<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/bcm/etherusb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/bcm/etherusb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Kernel proxy for usb ethernet device
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"
#include "../ip/ip.h"

#define	GET4(p)		((p)[3]&lt;&lt;24 | (p)[2]&lt;&lt;16 | (p)[1]&lt;&lt;8  | (p)[0])
#define	PUT4(p, v)	((p)[0] = (v), (p)[1] = (v)&gt;&gt;8, \
			 (p)[2] = (v)&gt;&gt;16, (p)[3] = (v)&gt;&gt;24)
#define	dprint	if(debug) print
#define ddump	if(0) dump

static int debug = 0;

enum {
	Bind	= 0,
	Unbind,

	SmscRxerror	= 0x8000,
	SmscTxfirst	= 0x2000,
	SmscTxlast	= 0x1000,
};

typedef struct Ctlr Ctlr;
typedef struct Udev Udev;

typedef int (Unpackfn)(Ether*, Block*);
typedef void (Transmitfn)(Ctlr*, Block*);

struct Ctlr {
	Ether*	edev;
	Udev*	udev;
	Chan*	inchan;
	Chan*	outchan;
	char*	buf;
	int	bufsize;
	int	maxpkt;
	uint	rxbuf;
	uint	rxpkt;
	uint	txbuf;
	uint	txpkt;
	QLock;
};

struct Udev {
	char	*name;
	Unpackfn *unpack;
	Transmitfn *transmit;
};
	
static Cmdtab cmds[] = {
	{ Bind,		"bind",		7, },
	{ Unbind,	"unbind",	0, },
};

static Unpackfn unpackcdc, unpackasix, unpacksmsc;
static Transmitfn transmitcdc, transmitasix, transmitsmsc;

static Udev udevtab[] = {
	{ "cdc",	unpackcdc,	transmitcdc, },
	{ "asix",	unpackasix,	transmitasix, },
	{ "smsc",	unpacksmsc,	transmitsmsc, },
	{ nil },
};

static void
dump(int c, Block *b)
{
	int s, i;

	s = splhi();
	print("%c%ld:", c, BLEN(b));
	for(i = 0; i &lt; 32; i++)
		print(" %2.2ux", b-&gt;rp[i]);
	print("\n");
	splx(s);
}

static int
unpack(Ether *edev, Block *b, int m)
{
	Block *nb;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	ddump('?', b);
	if(m == BLEN(b)){
		etheriq(edev, b, 1);
		ctlr-&gt;rxpkt++;
		return 1;
	}
	nb = iallocb(m);
	if(nb != nil){
		memmove(nb-&gt;wp, b-&gt;rp, m);
		nb-&gt;wp += m;
		etheriq(edev, nb, 1);
		ctlr-&gt;rxpkt++;
	}else
		edev-&gt;soverflows++;
	b-&gt;rp += m;
	return 0;
}

static int
unpackcdc(Ether *edev, Block *b)
{
	int m;

	m = BLEN(b);
	if(m &lt; 6)
		return -1;
	return unpack(edev, b, m);
}

static int
unpackasix(Ether *edev, Block *b)
{
	ulong hd;
	int m;
	uchar *wp;

	if(BLEN(b) &lt; 4)
		return -1;
	hd = GET4(b-&gt;rp);
	b-&gt;rp += 4;
	m = hd &amp; 0xFFFF;
	hd &gt;&gt;= 16;
	if(m != (~hd &amp; 0xFFFF))
		return -1;
	m = ROUND(m, 2);
	if(m &lt; 6 || m &gt; BLEN(b))
		return -1;
	if((wp = b-&gt;rp + m) != b-&gt;wp &amp;&amp; b-&gt;wp - wp &lt; 4)
		b-&gt;wp = wp;
	return unpack(edev, b, m);
}

static int
unpacksmsc(Ether *edev, Block *b)
{
	ulong hd;
	int m;
	
	ddump('@', b);
	if(BLEN(b) &lt; 4)
		return -1;
	hd = GET4(b-&gt;rp);
	b-&gt;rp += 4;
	m = hd &gt;&gt; 16;
	if(m &lt; 6 || m &gt; BLEN(b))
		return -1;
	if(BLEN(b) - m &lt; 4)
		b-&gt;wp = b-&gt;rp + m;
	if(hd &amp; SmscRxerror){
		edev-&gt;frames++;
		b-&gt;rp += m;
		if(BLEN(b) == 0){
			freeb(b);
			return 1;
		}
	}else if(unpack(edev, b, m) == 1)
		return 1;
	if((m &amp;= 3) != 0)
		b-&gt;rp += 4 - m;
	return 0;
}

static void
transmit(Ctlr *ctlr, Block *b)
{
	Chan *c;

	ddump('!', b);
	c = ctlr-&gt;outchan;
	devtab[c-&gt;type]-&gt;bwrite(c, b, 0);
}

static void
transmitcdc(Ctlr *ctlr, Block *b)
{
	transmit(ctlr, b);
}

static void
transmitasix(Ctlr *ctlr, Block *b)
{
	int n;

	n = BLEN(b) &amp; 0xFFFF;
	n |= ~n &lt;&lt; 16;
	padblock(b, 4);
	PUT4(b-&gt;rp, n);
	if(BLEN(b) % ctlr-&gt;maxpkt == 0){
		padblock(b, -4);
		PUT4(b-&gt;wp, 0xFFFF0000);
		b-&gt;wp += 4;
	}
	transmit(ctlr, b);
}

static void
transmitsmsc(Ctlr *ctlr, Block *b)
{
	int n;

	n = BLEN(b) &amp; 0x7FF;
	padblock(b, 8);
	PUT4(b-&gt;rp, n | SmscTxfirst | SmscTxlast);
	PUT4(b-&gt;rp+4, n);
	transmit(ctlr, b);
}

static void
etherusbproc(void *a)
{
	Ether *edev;
	Ctlr *ctlr;
	Chan *c;
	Block *b;

	edev = a;
	ctlr = edev-&gt;ctlr;
	c = ctlr-&gt;inchan;
	b = nil;
	if(waserror()){
		print("etherusbproc: error exit %s\n", up-&gt;errstr);
		pexit(up-&gt;errstr, 1);
		return;
	}
	for(;;){
		if(b == nil){
			b = devtab[c-&gt;type]-&gt;bread(c, ctlr-&gt;bufsize, 0);
			ctlr-&gt;rxbuf++;
		}
		switch(ctlr-&gt;udev-&gt;unpack(edev, b)){
		case -1:
			edev-&gt;buffs++;
			freeb(b);
			/* fall through */
		case 1:
			b = nil;
			break;
		}
	}
}

/*
 * bind type indev outdev mac bufsize maxpkt
 */
static void
bind(Ctlr *ctlr, Udev *udev, Cmdbuf *cb)
{
	Chan *inchan, *outchan;
	char *buf;
	uint bufsize, maxpkt;

	qlock(ctlr);
	inchan = outchan = nil;
	buf = nil;
	if(waserror()){
		free(buf);
		if(inchan)
			cclose(inchan);
		if(outchan)
			cclose(outchan);
		qunlock(ctlr);
		nexterror();
	}
	if(ctlr-&gt;buf != nil)
		cmderror(cb, "already bound to a device");
	maxpkt = strtol(cb-&gt;f[6], 0, 0);
	if(maxpkt &lt; 8 || maxpkt &gt; 512)
		cmderror(cb, "bad maxpkt");
	bufsize = strtol(cb-&gt;f[5], 0, 0);
	if(bufsize &lt; maxpkt || bufsize &gt; 32*1024)
		cmderror(cb, "bad bufsize");
	buf = smalloc(bufsize);
	inchan = namec(cb-&gt;f[2], Aopen, OREAD, 0);
	outchan = namec(cb-&gt;f[3], Aopen, OWRITE, 0);
	assert(inchan != nil &amp;&amp; outchan != nil);
	if(parsemac(ctlr-&gt;edev-&gt;ea, cb-&gt;f[4], Eaddrlen) != Eaddrlen)
		cmderror(cb, "bad etheraddr");
	memmove(ctlr-&gt;edev-&gt;addr, ctlr-&gt;edev-&gt;ea, Eaddrlen);
	print("\netherusb %s: %E\n", udev-&gt;name, ctlr-&gt;edev-&gt;addr);
	ctlr-&gt;buf = buf;
	ctlr-&gt;inchan = inchan;
	ctlr-&gt;outchan = outchan;
	ctlr-&gt;bufsize = bufsize;
	ctlr-&gt;maxpkt = maxpkt;
	ctlr-&gt;udev = udev;
	kproc("etherusb", etherusbproc, ctlr-&gt;edev);
	poperror();
	qunlock(ctlr);
}

static void
unbind(Ctlr *ctlr)
{
	qlock(ctlr);
	if(ctlr-&gt;buf != nil){
		free(ctlr-&gt;buf);
		ctlr-&gt;buf = nil;
		if(ctlr-&gt;inchan)
			cclose(ctlr-&gt;inchan);
		if(ctlr-&gt;outchan)
			cclose(ctlr-&gt;outchan);
		ctlr-&gt;inchan = ctlr-&gt;outchan = nil;
	}
	qunlock(ctlr);
}

static long
etherusbifstat(Ether* edev, void* a, long n, ulong offset)
{
	Ctlr *ctlr;
	char *p;
	int l;

	ctlr = edev-&gt;ctlr;
	p = malloc(READSTR);
	l = 0;

	l += snprint(p+l, READSTR-l, "rxbuf: %ud\n", ctlr-&gt;rxbuf);
	l += snprint(p+l, READSTR-l, "rxpkt: %ud\n", ctlr-&gt;rxpkt);
	l += snprint(p+l, READSTR-l, "txbuf: %ud\n", ctlr-&gt;txbuf);
	l += snprint(p+l, READSTR-l, "txpkt: %ud\n", ctlr-&gt;txpkt);
	USED(l);

	n = readstr(offset, a, n, p);
	free(p);
	return n;
}

static void
etherusbtransmit(Ether *edev)
{
	Ctlr *ctlr;
	Block *b;
	
	ctlr = edev-&gt;ctlr;
	while((b = qget(edev-&gt;oq)) != nil){
		ctlr-&gt;txpkt++;
		if(ctlr-&gt;buf == nil)
			freeb(b);
		else{
			ctlr-&gt;udev-&gt;transmit(ctlr, b);
			ctlr-&gt;txbuf++;
		}
	}
}

static long
etherusbctl(Ether* edev, void* buf, long n)
{
	Ctlr *ctlr;
	Cmdbuf *cb;
	Cmdtab *ct;
	Udev *udev;

	if((ctlr = edev-&gt;ctlr) == nil)
		error(Enonexist);

	cb = parsecmd(buf, n);
	if(waserror()){
		free(cb);
		nexterror();
	}
	ct = lookupcmd(cb, cmds, nelem(cmds));
	switch(ct-&gt;index){
	case Bind:
		for(udev = udevtab; udev-&gt;name; udev++)
			if(strcmp(cb-&gt;f[1], udev-&gt;name) == 0)
				break;
		if(udev-&gt;name == nil)
			cmderror(cb, "unknown etherusb type");
		bind(ctlr, udev, cb);
		break;
	case Unbind:
		unbind(ctlr);
		break;
	default:
		cmderror(cb, "unknown etherusb control message");
	}
	poperror();
	free(cb);
	return n;
}

static void
etherusbattach(Ether* edev)
{
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	ctlr-&gt;edev = edev;
}

static int
etherusbpnp(Ether* edev)
{
	Ctlr *ctlr;

	ctlr = malloc(sizeof(Ctlr));
	edev-&gt;ctlr = ctlr;
	edev-&gt;irq = -1;
	edev-&gt;mbps = 100;	/* TODO: get this from usbether */

	/*
	 * Linkage to the generic ethernet driver.
	 */
	edev-&gt;attach = etherusbattach;
	edev-&gt;transmit = etherusbtransmit;
	edev-&gt;interrupt = nil;
	edev-&gt;ifstat = etherusbifstat;
	edev-&gt;ctl = etherusbctl;

	edev-&gt;arg = edev;
	/* TODO: promiscuous, multicast (for ipv6), shutdown (for reboot) */
//	edev-&gt;promiscuous = etherusbpromiscuous;
//	edev-&gt;shutdown = etherusbshutdown;
//	edev-&gt;multicast = etherusbmulticast;

	return 0;
}

void
etherusblink(void)
{
	addethercard("usb", etherusbpnp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

