<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/bcm/mmu.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/bcm/mmu.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"

#include "arm.h"

#define L1X(va)		FEXT((va), 20, 12)
#define L2X(va)		FEXT((va), 12, 8)

enum {
	L1lo		= UZERO/MiB,		/* L1X(UZERO)? */
	L1hi		= (USTKTOP+MiB-1)/MiB,	/* L1X(USTKTOP+MiB-1)? */
};

void
mmuinit(void)
{
	PTE *l1, *l2;
	uintptr pa, va;

	l1 = (PTE*)PADDR(L1);
	l2 = (PTE*)PADDR(L2);

	/*
	 * map all of ram at KZERO
	 */
	va = KZERO;
	for(pa = PHYSDRAM; pa &lt; PHYSDRAM+DRAMSIZE; pa += MiB){
		l1[L1X(va)] = pa|Dom0|L1AP(Krw)|Section|Cached|Buffered;
		va += MiB;
	}

	/*
	 * identity map first MB of ram so mmu can be enabled
	 */
	l1[L1X(PHYSDRAM)] = PHYSDRAM|Dom0|L1AP(Krw)|Section|Cached|Buffered;

	/*
	 * map i/o registers 
	 */
	va = VIRTIO;
	for(pa = PHYSIO; pa &lt; PHYSIO+IOSIZE; pa += MiB){
		l1[L1X(va)] = pa|Dom0|L1AP(Krw)|Section;
		va += MiB;
	}

	/*
	 * double map exception vectors at top of virtual memory
	 */
	va = HVECTORS;
	l1[L1X(va)] = (uintptr)l2|Dom0|Coarse;
	l2[L2X(va)] = PHYSDRAM|L2AP(Krw)|Small;
}

void
mmuinit1(void)
{
	PTE *l1;

	l1 = (PTE*)L1;
	m-&gt;mmul1 = l1;

	/*
	 * undo identity map of first MB of ram
	 */
	l1[L1X(PHYSDRAM)] = 0;
	cachedwbse(&amp;l1[L1X(PHYSDRAM)], sizeof(PTE));
	mmuinvalidate();
}

static void
mmul2empty(Proc* proc, int clear)
{
	PTE *l1;
	Page **l2, *page;

	l1 = m-&gt;mmul1;
	l2 = &amp;proc-&gt;mmul2;
	for(page = *l2; page != nil; page = page-&gt;next){
		if(clear)
			memset(UINT2PTR(page-&gt;va), 0, BY2PG);
		l1[page-&gt;daddr] = Fault;
		l2 = &amp;page-&gt;next;
	}
	*l2 = proc-&gt;mmul2cache;
	proc-&gt;mmul2cache = proc-&gt;mmul2;
	proc-&gt;mmul2 = nil;
}

static void
mmul1empty(void)
{
#ifdef notdef
/* there's a bug in here */
	PTE *l1;

	/* clean out any user mappings still in l1 */
	if(m-&gt;mmul1lo &gt; L1lo){
		if(m-&gt;mmul1lo == 1)
			m-&gt;mmul1[L1lo] = Fault;
		else
			memset(&amp;m-&gt;mmul1[L1lo], 0, m-&gt;mmul1lo*sizeof(PTE));
		m-&gt;mmul1lo = L1lo;
	}
	if(m-&gt;mmul1hi &lt; L1hi){
		l1 = &amp;m-&gt;mmul1[m-&gt;mmul1hi];
		if((L1hi - m-&gt;mmul1hi) == 1)
			*l1 = Fault;
		else
			memset(l1, 0, (L1hi - m-&gt;mmul1hi)*sizeof(PTE));
		m-&gt;mmul1hi = L1hi;
	}
#else
	memset(&amp;m-&gt;mmul1[L1lo], 0, (L1hi - L1lo)*sizeof(PTE));
#endif /* notdef */
}

void
mmuswitch(Proc* proc)
{
	int x;
	PTE *l1;
	Page *page;

	/* do kprocs get here and if so, do they need to? */
	if(m-&gt;mmupid == proc-&gt;pid &amp;&amp; !proc-&gt;newtlb)
		return;
	m-&gt;mmupid = proc-&gt;pid;

	/* write back dirty and invalidate l1 caches */
	cacheuwbinv();

	if(proc-&gt;newtlb){
		mmul2empty(proc, 1);
		proc-&gt;newtlb = 0;
	}

	mmul1empty();

	/* move in new map */
	l1 = m-&gt;mmul1;
	for(page = proc-&gt;mmul2; page != nil; page = page-&gt;next){
		x = page-&gt;daddr;
		l1[x] = PPN(page-&gt;pa)|Dom0|Coarse;
		/* know here that L1lo &lt; x &lt; L1hi */
		if(x+1 - m-&gt;mmul1lo &lt; m-&gt;mmul1hi - x)
			m-&gt;mmul1lo = x+1;
		else
			m-&gt;mmul1hi = x;
	}

	/* make sure map is in memory */
	/* could be smarter about how much? */
	cachedwbse(&amp;l1[L1X(UZERO)], (L1hi - L1lo)*sizeof(PTE));

	/* lose any possible stale tlb entries */
	mmuinvalidate();
}

void
flushmmu(void)
{
	int s;

	s = splhi();
	up-&gt;newtlb = 1;
	mmuswitch(up);
	splx(s);
}

void
mmurelease(Proc* proc)
{
	Page *page, *next;

	/* write back dirty and invalidate l1 caches */
	cacheuwbinv();

	mmul2empty(proc, 0);
	for(page = proc-&gt;mmul2cache; page != nil; page = next){
		next = page-&gt;next;
		if(--page-&gt;ref)
			panic("mmurelease: page-&gt;ref %d", page-&gt;ref);
		pagechainhead(page);
	}
	if(proc-&gt;mmul2cache &amp;&amp; palloc.r.p)
		wakeup(&amp;palloc.r);
	proc-&gt;mmul2cache = nil;

	mmul1empty();

	/* make sure map is in memory */
	/* could be smarter about how much? */
	cachedwbse(&amp;m-&gt;mmul1[L1X(UZERO)], (L1hi - L1lo)*sizeof(PTE));

	/* lose any possible stale tlb entries */
	mmuinvalidate();
}

void
putmmu(uintptr va, uintptr pa, Page* page)
{
	int x;
	Page *pg;
	PTE *l1, *pte;

	x = L1X(va);
	l1 = &amp;m-&gt;mmul1[x];
	if(*l1 == Fault){
		/* wasteful - l2 pages only have 256 entries - fix */
		if(up-&gt;mmul2cache == nil){
			/* auxpg since we don't need much? memset if so */
			pg = newpage(1, 0, 0);
			pg-&gt;va = VA(kmap(pg));
		}
		else{
			pg = up-&gt;mmul2cache;
			up-&gt;mmul2cache = pg-&gt;next;
			memset(UINT2PTR(pg-&gt;va), 0, BY2PG);
		}
		pg-&gt;daddr = x;
		pg-&gt;next = up-&gt;mmul2;
		up-&gt;mmul2 = pg;

		/* force l2 page to memory */
		cachedwbse((void *)pg-&gt;va, BY2PG);

		*l1 = PPN(pg-&gt;pa)|Dom0|Coarse;
		cachedwbse(l1, sizeof *l1);

		if(x &gt;= m-&gt;mmul1lo &amp;&amp; x &lt; m-&gt;mmul1hi){
			if(x+1 - m-&gt;mmul1lo &lt; m-&gt;mmul1hi - x)
				m-&gt;mmul1lo = x+1;
			else
				m-&gt;mmul1hi = x;
		}
	}
	pte = UINT2PTR(KADDR(PPN(*l1)));

	/* protection bits are
	 *	PTERONLY|PTEVALID;
	 *	PTEWRITE|PTEVALID;
	 *	PTEWRITE|PTEUNCACHED|PTEVALID;
	 */
	x = Small;
	if(!(pa &amp; PTEUNCACHED))
		x |= Cached|Buffered;
	if(pa &amp; PTEWRITE)
		x |= L2AP(Urw);
	else
		x |= L2AP(Uro);
	pte[L2X(va)] = PPN(pa)|x;
	cachedwbse(&amp;pte[L2X(va)], sizeof pte[0]);

	/* clear out the current entry */
	mmuinvalidateaddr(PPN(va));

	/*  write back dirty entries - we need this because the pio() in
	 *  fault.c is writing via a different virt addr and won't clean
	 *  its changes out of the dcache.  Page coloring doesn't work
	 *  on this mmu because the virtual cache is set associative
	 *  rather than direct mapped.
	 */
	cachedwbinv();
	if(page-&gt;cachectl[0] == PG_TXTFLUSH){
		/* pio() sets PG_TXTFLUSH whenever a text pg has been written */
		cacheiinv();
		page-&gt;cachectl[0] = PG_NOFLUSH;
	}
	checkmmu(va, PPN(pa));
}

/*
 * Return the number of bytes that can be accessed via KADDR(pa).
 * If pa is not a valid argument to KADDR, return 0.
 */
uintptr
cankaddr(uintptr pa)
{
	if(pa &lt; PHYSDRAM + memsize)		/* assumes PHYSDRAM is 0 */
		return PHYSDRAM + memsize - pa;
	return 0;
}

uintptr
mmukmap(uintptr va, uintptr pa, usize size)
{
	int o;
	usize n;
	PTE *pte, *pte0;

	assert((va &amp; (MiB-1)) == 0);
	o = pa &amp; (MiB-1);
	pa -= o;
	size += o;
	pte = pte0 = &amp;m-&gt;mmul1[L1X(va)];
	for(n = 0; n &lt; size; n += MiB)
		if(*pte++ != Fault)
			return 0;
	pte = pte0;
	for(n = 0; n &lt; size; n += MiB){
		*pte++ = (pa+n)|Dom0|L1AP(Krw)|Section;
		mmuinvalidateaddr(va+n);
	}
	cachedwbse(pte0, pte - pte0);
	return va + o;
}


void
checkmmu(uintptr va, uintptr pa)
{
	USED(va);
	USED(pa);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

