<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/arp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/arp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ip.h"
#include "ipv6.h"

/*
 *  address resolution tables
 */

enum
{
	NHASH		= (1&lt;&lt;6),
	NCACHE		= 256,

	AOK		= 1,
	AWAIT		= 2,
};

char *arpstate[] =
{
	"UNUSED",
	"OK",
	"WAIT",
};

/*
 *  one per Fs
 */
struct Arp
{
	QLock;
	Fs	*f;
	Arpent	*hash[NHASH];
	Arpent	cache[NCACHE];
	Arpent	*rxmt;
	Proc	*rxmitp;	/* neib sol re-transmit proc */
	Rendez	rxmtq;
	Block 	*dropf, *dropl;
};

char *Ebadarp = "bad arp";

#define haship(s) ((s)[IPaddrlen-1]%NHASH)

extern int 	ReTransTimer = RETRANS_TIMER;

static void 	rxmitproc(void *v);

void
arpinit(Fs *f)
{
	f-&gt;arp = smalloc(sizeof(Arp));
	f-&gt;arp-&gt;f = f;
	f-&gt;arp-&gt;rxmt = nil;
	f-&gt;arp-&gt;dropf = f-&gt;arp-&gt;dropl = nil;
	kproc("rxmitproc", rxmitproc, f-&gt;arp);
}

/*
 *  create a new arp entry for an ip address.
 */
static Arpent*
newarp6(Arp *arp, uchar *ip, Ipifc *ifc, int addrxt)
{
	uint t;
	Block *next, *xp;
	Arpent *a, *e, *f, **l;
	Medium *m = ifc-&gt;m;
	int empty;

	/* find oldest entry */
	e = &amp;arp-&gt;cache[NCACHE];
	a = arp-&gt;cache;
	t = a-&gt;utime;
	for(f = a; f &lt; e; f++){
		if(f-&gt;utime &lt; t){
			t = f-&gt;utime;
			a = f;
		}
	}

	/* dump waiting packets */
	xp = a-&gt;hold;
	a-&gt;hold = nil;

	if(isv4(a-&gt;ip)){
		while(xp){
			next = xp-&gt;list;
			freeblist(xp);
			xp = next;
		}
	}
	else { /* queue icmp unreachable for rxmitproc later on, w/o arp lock */
		if(xp){
			if(arp-&gt;dropl == nil)
				arp-&gt;dropf = xp;
			else
				arp-&gt;dropl-&gt;list = xp;

			for(next = xp-&gt;list; next; next = next-&gt;list)
				xp = next;
			arp-&gt;dropl = xp;
			wakeup(&amp;arp-&gt;rxmtq);
		}
	}

	/* take out of current chain */
	l = &amp;arp-&gt;hash[haship(a-&gt;ip)];
	for(f = *l; f; f = f-&gt;hash){
		if(f == a){
			*l = a-&gt;hash;
			break;
		}
		l = &amp;f-&gt;hash;
	}

	/* insert into new chain */
	l = &amp;arp-&gt;hash[haship(ip)];
	a-&gt;hash = *l;
	*l = a;

	memmove(a-&gt;ip, ip, sizeof(a-&gt;ip));
	a-&gt;utime = NOW;
	a-&gt;ctime = 0;
	a-&gt;type = m;

	a-&gt;rtime = NOW + ReTransTimer;
	a-&gt;rxtsrem = MAX_MULTICAST_SOLICIT;
	a-&gt;ifc = ifc;
	a-&gt;ifcid = ifc-&gt;ifcid;

	/* put to the end of re-transmit chain; addrxt is 0 when isv4(a-&gt;ip) */
	if(!ipismulticast(a-&gt;ip) &amp;&amp; addrxt){
		l = &amp;arp-&gt;rxmt;
		empty = (*l==nil);

		for(f = *l; f; f = f-&gt;nextrxt){
			if(f == a){
				*l = a-&gt;nextrxt;
				break;
			}
			l = &amp;f-&gt;nextrxt;
		}
		for(f = *l; f; f = f-&gt;nextrxt){
			l = &amp;f-&gt;nextrxt;
		}
		*l = a;
		if(empty)
			wakeup(&amp;arp-&gt;rxmtq);
	}

	a-&gt;nextrxt = nil;

	return a;
}

/* called with arp qlocked */

void
cleanarpent(Arp *arp, Arpent *a)
{
	Arpent *f, **l;

	a-&gt;utime = 0;
	a-&gt;ctime = 0;
	a-&gt;type = 0;
	a-&gt;state = 0;

	/* take out of current chain */
	l = &amp;arp-&gt;hash[haship(a-&gt;ip)];
	for(f = *l; f; f = f-&gt;hash){
		if(f == a){
			*l = a-&gt;hash;
			break;
		}
		l = &amp;f-&gt;hash;
	}

	/* take out of re-transmit chain */
	l = &amp;arp-&gt;rxmt;
	for(f = *l; f; f = f-&gt;nextrxt){
		if(f == a){
			*l = a-&gt;nextrxt;
			break;
		}
		l = &amp;f-&gt;nextrxt;
	}
	a-&gt;nextrxt = nil;
	a-&gt;hash = nil;
	a-&gt;hold = nil;
	a-&gt;last = nil;
	a-&gt;ifc = nil;
}

/*
 *  fill in the media address if we have it.  Otherwise return an
 *  Arpent that represents the state of the address resolution FSM
 *  for ip.  Add the packet to be sent onto the list of packets
 *  waiting for ip-&gt;mac to be resolved.
 */
Arpent*
arpget(Arp *arp, Block *bp, int version, Ipifc *ifc, uchar *ip, uchar *mac)
{
	int hash;
	Arpent *a;
	Medium *type = ifc-&gt;m;
	uchar v6ip[IPaddrlen];

	if(version == V4){
		v4tov6(v6ip, ip);
		ip = v6ip;
	}

	qlock(arp);
	hash = haship(ip);
	for(a = arp-&gt;hash[hash]; a; a = a-&gt;hash){
		if(memcmp(ip, a-&gt;ip, sizeof(a-&gt;ip)) == 0)
		if(type == a-&gt;type)
			break;
	}

	if(a == nil){
		a = newarp6(arp, ip, ifc, (version != V4));
		a-&gt;state = AWAIT;
	}
	a-&gt;utime = NOW;
	if(a-&gt;state == AWAIT){
		if(bp != nil){
			if(a-&gt;hold)
				a-&gt;last-&gt;list = bp;
			else
				a-&gt;hold = bp;
			a-&gt;last = bp;
			bp-&gt;list = nil;
		}
		return a;		/* return with arp qlocked */
	}

	memmove(mac, a-&gt;mac, a-&gt;type-&gt;maclen);

	/* remove old entries */
	if(NOW - a-&gt;ctime &gt; 15*60*1000)
		cleanarpent(arp, a);

	qunlock(arp);
	return nil;
}

/*
 * called with arp locked
 */
void
arprelease(Arp *arp, Arpent*)
{
	qunlock(arp);
}

/*
 * Copy out the mac address from the Arpent.  Return the
 * block waiting to get sent to this mac address.
 *
 * called with arp locked
 */
Block*
arpresolve(Arp *arp, Arpent *a, Medium *type, uchar *mac)
{
	Block *bp;
	Arpent *f, **l;

	if(!isv4(a-&gt;ip)){
		l = &amp;arp-&gt;rxmt;
		for(f = *l; f; f = f-&gt;nextrxt){
			if(f == a){
				*l = a-&gt;nextrxt;
				break;
			}
			l = &amp;f-&gt;nextrxt;
		}
	}

	memmove(a-&gt;mac, mac, type-&gt;maclen);
	a-&gt;type = type;
	a-&gt;state = AOK;
	a-&gt;utime = NOW;
	bp = a-&gt;hold;
	a-&gt;hold = nil;
	qunlock(arp);

	return bp;
}

void
arpenter(Fs *fs, int version, uchar *ip, uchar *mac, int n, int refresh)
{
	Arp *arp;
	Route *r;
	Arpent *a, *f, **l;
	Ipifc *ifc;
	Medium *type;
	Block *bp, *next;
	uchar v6ip[IPaddrlen];

	arp = fs-&gt;arp;

	if(n != 6){
//		print("arp: len = %d\n", n);
		return;
	}

	switch(version){
	case V4:
		r = v4lookup(fs, ip, nil);
		v4tov6(v6ip, ip);
		ip = v6ip;
		break;
	case V6:
		r = v6lookup(fs, ip, nil);
		break;
	default:
		panic("arpenter: version %d", version);
		return;	/* to supress warnings */
	}

	if(r == nil){
//		print("arp: no route for entry\n");
		return;
	}

	ifc = r-&gt;ifc;
	type = ifc-&gt;m;

	qlock(arp);
	for(a = arp-&gt;hash[haship(ip)]; a; a = a-&gt;hash){
		if(a-&gt;type != type || (a-&gt;state != AWAIT &amp;&amp; a-&gt;state != AOK))
			continue;

		if(ipcmp(a-&gt;ip, ip) == 0){
			a-&gt;state = AOK;
			memmove(a-&gt;mac, mac, type-&gt;maclen);

			if(version == V6){
				/* take out of re-transmit chain */
				l = &amp;arp-&gt;rxmt;
				for(f = *l; f; f = f-&gt;nextrxt){
					if(f == a){
						*l = a-&gt;nextrxt;
						break;
					}
					l = &amp;f-&gt;nextrxt;
				}
			}

			a-&gt;ifc = ifc;
			a-&gt;ifcid = ifc-&gt;ifcid;
			bp = a-&gt;hold;
			a-&gt;hold = nil;
			if(version == V4)
				ip += IPv4off;
			a-&gt;utime = NOW;
			a-&gt;ctime = a-&gt;utime;
			qunlock(arp);

			while(bp){
				next = bp-&gt;list;
				if(ifc != nil){
					if(waserror()){
						runlock(ifc);
						nexterror();
					}
					rlock(ifc);
					if(ifc-&gt;m != nil)
						ifc-&gt;m-&gt;bwrite(ifc, bp, version, ip);
					else
						freeb(bp);
					runlock(ifc);
					poperror();
				} else
					freeb(bp);
				bp = next;
			}
			return;
		}
	}

	if(refresh == 0){
		a = newarp6(arp, ip, ifc, 0);
		a-&gt;state = AOK;
		a-&gt;type = type;
		a-&gt;ctime = NOW;
		memmove(a-&gt;mac, mac, type-&gt;maclen);
	}

	qunlock(arp);
}

int
arpwrite(Fs *fs, char *s, int len)
{
	int n;
	Route *r;
	Arp *arp;
	Block *bp;
	Arpent *a, *fl, **l;
	Medium *m;
	char *f[4], buf[256];
	uchar ip[IPaddrlen], mac[MAClen];

	arp = fs-&gt;arp;

	if(len == 0)
		error(Ebadarp);
	if(len &gt;= sizeof(buf))
		len = sizeof(buf)-1;
	strncpy(buf, s, len);
	buf[len] = 0;
	if(len &gt; 0 &amp;&amp; buf[len-1] == '\n')
		buf[len-1] = 0;

	n = getfields(buf, f, 4, 1, " ");
	if(strcmp(f[0], "flush") == 0){
		qlock(arp);
		for(a = arp-&gt;cache; a &lt; &amp;arp-&gt;cache[NCACHE]; a++){
			memset(a-&gt;ip, 0, sizeof(a-&gt;ip));
			memset(a-&gt;mac, 0, sizeof(a-&gt;mac));
			a-&gt;hash = nil;
			a-&gt;state = 0;
			a-&gt;utime = 0;
			while(a-&gt;hold != nil){
				bp = a-&gt;hold-&gt;list;
				freeblist(a-&gt;hold);
				a-&gt;hold = bp;
			}
		}
		memset(arp-&gt;hash, 0, sizeof(arp-&gt;hash));
		/* clear all pkts on these lists (rxmt, dropf/l) */
		arp-&gt;rxmt = nil;
		arp-&gt;dropf = nil;
		arp-&gt;dropl = nil;
		qunlock(arp);
	} else if(strcmp(f[0], "add") == 0){
		switch(n){
		default:
			error(Ebadarg);
		case 3:
			if (parseip(ip, f[1]) == -1)
				error(Ebadip);
			if(isv4(ip))
				r = v4lookup(fs, ip+IPv4off, nil);
			else
				r = v6lookup(fs, ip, nil);
			if(r == nil)
				error("Destination unreachable");
			m = r-&gt;ifc-&gt;m;
			n = parsemac(mac, f[2], m-&gt;maclen);
			break;
		case 4:
			m = ipfindmedium(f[1]);
			if(m == nil)
				error(Ebadarp);
			if (parseip(ip, f[2]) == -1)
				error(Ebadip);
			n = parsemac(mac, f[3], m-&gt;maclen);
			break;
		}

		if(m-&gt;ares == nil)
			error(Ebadarp);

		m-&gt;ares(fs, V6, ip, mac, n, 0);
	} else if(strcmp(f[0], "del") == 0){
		if(n != 2)
			error(Ebadarg);

		if (parseip(ip, f[1]) == -1)
			error(Ebadip);
		qlock(arp);

		l = &amp;arp-&gt;hash[haship(ip)];
		for(a = *l; a; a = a-&gt;hash){
			if(memcmp(ip, a-&gt;ip, sizeof(a-&gt;ip)) == 0){
				*l = a-&gt;hash;
				break;
			}
			l = &amp;a-&gt;hash;
		}

		if(a){
			/* take out of re-transmit chain */
			l = &amp;arp-&gt;rxmt;
			for(fl = *l; fl; fl = fl-&gt;nextrxt){
				if(fl == a){
					*l = a-&gt;nextrxt;
					break;
				}
				l = &amp;fl-&gt;nextrxt;
			}

			a-&gt;nextrxt = nil;
			a-&gt;hash = nil;
			a-&gt;hold = nil;
			a-&gt;last = nil;
			a-&gt;ifc = nil;
			memset(a-&gt;ip, 0, sizeof(a-&gt;ip));
			memset(a-&gt;mac, 0, sizeof(a-&gt;mac));
		}
		qunlock(arp);
	} else
		error(Ebadarp);

	return len;
}

enum
{
	Alinelen=	90,
};

char *aformat = "%-6.6s %-8.8s %-40.40I %-32.32s\n";

static void
convmac(char *p, char *ep, uchar *mac, int n)
{
	while(n-- &gt; 0)
		p = seprint(p, ep, "%2.2ux", *mac++);
}

int
arpread(Arp *arp, char *p, ulong offset, int len)
{
	Arpent *a;
	int n;
	char mac[2*MAClen+1];

	if(offset % Alinelen)
		return 0;

	offset = offset/Alinelen;
	len = len/Alinelen;

	n = 0;
	for(a = arp-&gt;cache; len &gt; 0 &amp;&amp; a &lt; &amp;arp-&gt;cache[NCACHE]; a++){
		if(a-&gt;state == 0)
			continue;
		if(offset &gt; 0){
			offset--;
			continue;
		}
		len--;
		qlock(arp);
		convmac(mac, &amp;mac[sizeof mac], a-&gt;mac, a-&gt;type-&gt;maclen);
		n += snprint(p+n, Alinelen+1, aformat, a-&gt;type-&gt;name,
			arpstate[a-&gt;state], a-&gt;ip, mac);	/* +1 for NUL */
		qunlock(arp);
	}

	return n;
}

extern int
rxmitsols(Arp *arp)
{
	uint sflag;
	Block *next, *xp;
	Arpent *a, *b, **l;
	Fs *f;
	uchar ipsrc[IPaddrlen];
	Ipifc *ifc = nil;
	long nrxt;

	qlock(arp);
	f = arp-&gt;f;

	a = arp-&gt;rxmt;
	if(a==nil){
		nrxt = 0;
		goto dodrops; 		/* return nrxt; */
	}
	nrxt = a-&gt;rtime - NOW;
	if(nrxt &gt; 3*ReTransTimer/4)
		goto dodrops; 		/* return nrxt; */

	for(; a; a = a-&gt;nextrxt){
		ifc = a-&gt;ifc;
		assert(ifc != nil);
		if((a-&gt;rxtsrem &lt;= 0) || !(canrlock(ifc)) || (a-&gt;ifcid != ifc-&gt;ifcid)){
			xp = a-&gt;hold;
			a-&gt;hold = nil;

			if(xp){
				if(arp-&gt;dropl == nil)
					arp-&gt;dropf = xp;
				else
					arp-&gt;dropl-&gt;list = xp;
			}

			cleanarpent(arp, a);
		}
		else
			break;
	}
	if(a == nil)
		goto dodrops;


	qunlock(arp);	/* for icmpns */
	if((sflag = ipv6anylocal(ifc, ipsrc)) != SRC_UNSPEC)
		icmpns(f, ipsrc, sflag, a-&gt;ip, TARG_MULTI, ifc-&gt;mac);

	runlock(ifc);
	qlock(arp);

	/* put to the end of re-transmit chain */
	l = &amp;arp-&gt;rxmt;
	for(b = *l; b; b = b-&gt;nextrxt){
		if(b == a){
			*l = a-&gt;nextrxt;
			break;
		}
		l = &amp;b-&gt;nextrxt;
	}
	for(b = *l; b; b = b-&gt;nextrxt){
		l = &amp;b-&gt;nextrxt;
	}
	*l = a;
	a-&gt;rxtsrem--;
	a-&gt;nextrxt = nil;
	a-&gt;rtime = NOW + ReTransTimer;

	a = arp-&gt;rxmt;
	if(a==nil)
		nrxt = 0;
	else
		nrxt = a-&gt;rtime - NOW;

dodrops:
	xp = arp-&gt;dropf;
	arp-&gt;dropf = nil;
	arp-&gt;dropl = nil;
	qunlock(arp);

	for(; xp; xp = next){
		next = xp-&gt;list;
		icmphostunr(f, ifc, xp, Icmp6_adr_unreach, 1);
	}

	return nrxt;

}

static int
rxready(void *v)
{
	Arp *arp = (Arp *) v;
	int x;

	x = ((arp-&gt;rxmt != nil) || (arp-&gt;dropf != nil));

	return x;
}

static void
rxmitproc(void *v)
{
	Arp *arp = v;
	long wakeupat;

	arp-&gt;rxmitp = up;
	//print("arp rxmitproc started\n");
	if(waserror()){
		arp-&gt;rxmitp = 0;
		pexit("hangup", 1);
	}
	for(;;){
		wakeupat = rxmitsols(arp);
		if(wakeupat == 0)
			sleep(&amp;arp-&gt;rxmtq, rxready, v);
		else if(wakeupat &gt; ReTransTimer/4)
			tsleep(&amp;arp-&gt;rxmtq, return0, 0, wakeupat);
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

