<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/devip.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/devip.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"../ip/ip.h"

enum
{
	Qtopdir=	1,		/* top level directory */
	Qtopbase,
	Qarp=		Qtopbase,
	Qbootp,
	Qndb,
	Qiproute,
	Qipselftab,
	Qlog,

	Qprotodir,			/* directory for a protocol */
	Qprotobase,
	Qclone=		Qprotobase,
	Qstats,

	Qconvdir,			/* directory for a conversation */
	Qconvbase,
	Qctl=		Qconvbase,
	Qdata,
	Qerr,
	Qlisten,
	Qlocal,
	Qremote,
	Qstatus,
	Qsnoop,

	Logtype=	5,
	Masktype=	(1&lt;&lt;Logtype)-1,
	Logconv=	12,
	Maskconv=	(1&lt;&lt;Logconv)-1,
	Shiftconv=	Logtype,
	Logproto=	8,
	Maskproto=	(1&lt;&lt;Logproto)-1,
	Shiftproto=	Logtype + Logconv,

	Nfs=		128,
};
#define TYPE(x) 	( ((ulong)(x).path) &amp; Masktype )
#define CONV(x) 	( (((ulong)(x).path) &gt;&gt; Shiftconv) &amp; Maskconv )
#define PROTO(x) 	( (((ulong)(x).path) &gt;&gt; Shiftproto) &amp; Maskproto )
#define QID(p, c, y) 	( ((p)&lt;&lt;(Shiftproto)) | ((c)&lt;&lt;Shiftconv) | (y) )

static char network[] = "network";

QLock	fslock;
Fs	*ipfs[Nfs];	/* attached fs's */
Queue	*qlog;

extern	void nullmediumlink(void);
extern	void pktmediumlink(void);
	long ndbwrite(Fs *f, char *a, ulong off, int n);

static int
ip3gen(Chan *c, int i, Dir *dp)
{
	Qid q;
	Conv *cv;
	char *p;

	cv = ipfs[c-&gt;dev]-&gt;p[PROTO(c-&gt;qid)]-&gt;conv[CONV(c-&gt;qid)];
	if(cv-&gt;owner == nil)
		kstrdup(&amp;cv-&gt;owner, eve);
	mkqid(&amp;q, QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), i), 0, QTFILE);

	switch(i) {
	default:
		return -1;
	case Qctl:
		devdir(c, q, "ctl", 0, cv-&gt;owner, cv-&gt;perm, dp);
		return 1;
	case Qdata:
		devdir(c, q, "data", qlen(cv-&gt;rq), cv-&gt;owner, cv-&gt;perm, dp);
		return 1;
	case Qerr:
		devdir(c, q, "err", qlen(cv-&gt;eq), cv-&gt;owner, cv-&gt;perm, dp);
		return 1;
	case Qlisten:
		devdir(c, q, "listen", 0, cv-&gt;owner, cv-&gt;perm, dp);
		return 1;
	case Qlocal:
		p = "local";
		break;
	case Qremote:
		p = "remote";
		break;
	case Qsnoop:
		if(strcmp(cv-&gt;p-&gt;name, "ipifc") != 0)
			return -1;
		devdir(c, q, "snoop", qlen(cv-&gt;sq), cv-&gt;owner, 0400, dp);
		return 1;
	case Qstatus:
		p = "status";
		break;
	}
	devdir(c, q, p, 0, cv-&gt;owner, 0444, dp);
	return 1;
}

static int
ip2gen(Chan *c, int i, Dir *dp)
{
	Qid q;

	switch(i) {
	case Qclone:
		mkqid(&amp;q, QID(PROTO(c-&gt;qid), 0, Qclone), 0, QTFILE);
		devdir(c, q, "clone", 0, network, 0666, dp);
		return 1;
	case Qstats:
		mkqid(&amp;q, QID(PROTO(c-&gt;qid), 0, Qstats), 0, QTFILE);
		devdir(c, q, "stats", 0, network, 0444, dp);
		return 1;
	}
	return -1;
}

static int
ip1gen(Chan *c, int i, Dir *dp)
{
	Qid q;
	char *p;
	int prot;
	int len = 0;
	Fs *f;
	extern ulong	kerndate;

	f = ipfs[c-&gt;dev];

	prot = 0666;
	mkqid(&amp;q, QID(0, 0, i), 0, QTFILE);
	switch(i) {
	default:
		return -1;
	case Qarp:
		p = "arp";
		prot = 0664;
		break;
	case Qbootp:
		p = "bootp";
		break;
	case Qndb:
		p = "ndb";
		len = strlen(f-&gt;ndb);
		q.vers = f-&gt;ndbvers;
		break;
	case Qiproute:
		p = "iproute";
		prot = 0664;
		break;
	case Qipselftab:
		p = "ipselftab";
		prot = 0444;
		break;
	case Qlog:
		p = "log";
		break;
	}
	devdir(c, q, p, len, network, prot, dp);
	if(i == Qndb &amp;&amp; f-&gt;ndbmtime &gt; kerndate)
		dp-&gt;mtime = f-&gt;ndbmtime;
	return 1;
}

static int
ipgen(Chan *c, char*, Dirtab*, int, int s, Dir *dp)
{
	Qid q;
	Conv *cv;
	Fs *f;

	f = ipfs[c-&gt;dev];

	switch(TYPE(c-&gt;qid)) {
	case Qtopdir:
		if(s == DEVDOTDOT){
			mkqid(&amp;q, QID(0, 0, Qtopdir), 0, QTDIR);
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "#I%lud", c-&gt;dev);
			devdir(c, q, up-&gt;genbuf, 0, network, 0555, dp);
			return 1;
		}
		if(s &lt; f-&gt;np) {
			if(f-&gt;p[s]-&gt;connect == nil)
				return 0;	/* protocol with no user interface */
			mkqid(&amp;q, QID(s, 0, Qprotodir), 0, QTDIR);
			devdir(c, q, f-&gt;p[s]-&gt;name, 0, network, 0555, dp);
			return 1;
		}
		s -= f-&gt;np;
		return ip1gen(c, s+Qtopbase, dp);
	case Qarp:
	case Qbootp:
	case Qndb:
	case Qlog:
	case Qiproute:
	case Qipselftab:
		return ip1gen(c, TYPE(c-&gt;qid), dp);
	case Qprotodir:
		if(s == DEVDOTDOT){
			mkqid(&amp;q, QID(0, 0, Qtopdir), 0, QTDIR);
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "#I%lud", c-&gt;dev);
			devdir(c, q, up-&gt;genbuf, 0, network, 0555, dp);
			return 1;
		}
		if(s &lt; f-&gt;p[PROTO(c-&gt;qid)]-&gt;ac) {
			cv = f-&gt;p[PROTO(c-&gt;qid)]-&gt;conv[s];
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "%d", s);
			mkqid(&amp;q, QID(PROTO(c-&gt;qid), s, Qconvdir), 0, QTDIR);
			devdir(c, q, up-&gt;genbuf, 0, cv-&gt;owner, 0555, dp);
			return 1;
		}
		s -= f-&gt;p[PROTO(c-&gt;qid)]-&gt;ac;
		return ip2gen(c, s+Qprotobase, dp);
	case Qclone:
	case Qstats:
		return ip2gen(c, TYPE(c-&gt;qid), dp);
	case Qconvdir:
		if(s == DEVDOTDOT){
			s = PROTO(c-&gt;qid);
			mkqid(&amp;q, QID(s, 0, Qprotodir), 0, QTDIR);
			devdir(c, q, f-&gt;p[s]-&gt;name, 0, network, 0555, dp);
			return 1;
		}
		return ip3gen(c, s+Qconvbase, dp);
	case Qctl:
	case Qdata:
	case Qerr:
	case Qlisten:
	case Qlocal:
	case Qremote:
	case Qstatus:
	case Qsnoop:
		return ip3gen(c, TYPE(c-&gt;qid), dp);
	}
	return -1;
}

static void
ipreset(void)
{
	nullmediumlink();
	pktmediumlink();

	fmtinstall('i', eipfmt);
	fmtinstall('I', eipfmt);
	fmtinstall('E', eipfmt);
	fmtinstall('V', eipfmt);
	fmtinstall('M', eipfmt);
}

static Fs*
ipgetfs(int dev)
{
	extern void (*ipprotoinit[])(Fs*);
	Fs *f;
	int i;

	if(dev &gt;= Nfs)
		return nil;

	qlock(&amp;fslock);
	if(ipfs[dev] == nil){
		f = smalloc(sizeof(Fs));
		ip_init(f);
		arpinit(f);
		netloginit(f);
		for(i = 0; ipprotoinit[i]; i++)
			ipprotoinit[i](f);
		f-&gt;dev = dev;
		ipfs[dev] = f;
	}
	qunlock(&amp;fslock);

	return ipfs[dev];
}

IPaux*
newipaux(char *owner, char *tag)
{
	IPaux *a;
	int n;

	a = smalloc(sizeof(*a));
	kstrdup(&amp;a-&gt;owner, owner);
	memset(a-&gt;tag, ' ', sizeof(a-&gt;tag));
	n = strlen(tag);
	if(n &gt; sizeof(a-&gt;tag))
		n = sizeof(a-&gt;tag);
	memmove(a-&gt;tag, tag, n);
	return a;
}

#define ATTACHER(c) (((IPaux*)((c)-&gt;aux))-&gt;owner)

static Chan*
ipattach(char* spec)
{
	Chan *c;
	int dev;

	dev = atoi(spec);
	if(dev &gt;= Nfs)
		error("bad specification");

	ipgetfs(dev);
	c = devattach('I', spec);
	mkqid(&amp;c-&gt;qid, QID(0, 0, Qtopdir), 0, QTDIR);
	c-&gt;dev = dev;

	c-&gt;aux = newipaux(commonuser(), "none");

	return c;
}

static Walkqid*
ipwalk(Chan* c, Chan *nc, char **name, int nname)
{
	IPaux *a = c-&gt;aux;
	Walkqid* w;

	w = devwalk(c, nc, name, nname, nil, 0, ipgen);
	if(w != nil &amp;&amp; w-&gt;clone != nil)
		w-&gt;clone-&gt;aux = newipaux(a-&gt;owner, a-&gt;tag);
	return w;
}


static int
ipstat(Chan* c, uchar* db, int n)
{
	return devstat(c, db, n, nil, 0, ipgen);
}

static int
incoming(void* arg)
{
	Conv *conv;

	conv = arg;
	return conv-&gt;incall != nil;
}

static int m2p[] = {
	[OREAD]		4,
	[OWRITE]	2,
	[ORDWR]		6
};

static Chan*
ipopen(Chan* c, int omode)
{
	Conv *cv, *nc;
	Proto *p;
	int perm;
	Fs *f;

	perm = m2p[omode&amp;3];

	f = ipfs[c-&gt;dev];

	switch(TYPE(c-&gt;qid)) {
	default:
		break;
	case Qndb:
		if(omode &amp; (OWRITE|OTRUNC) &amp;&amp; !iseve())
			error(Eperm);
		if((omode &amp; (OWRITE|OTRUNC)) == (OWRITE|OTRUNC))
			f-&gt;ndb[0] = 0;
		break;
	case Qlog:
		netlogopen(f);
		break;
	case Qiproute:
	case Qarp:
		if(omode != OREAD &amp;&amp; !iseve())
			error(Eperm);
		break;
	case Qtopdir:
	case Qprotodir:
	case Qconvdir:
	case Qstatus:
	case Qremote:
	case Qlocal:
	case Qstats:
	case Qbootp:
	case Qipselftab:
		if(omode != OREAD)
			error(Eperm);
		break;
	case Qsnoop:
		if(omode != OREAD)
			error(Eperm);
		p = f-&gt;p[PROTO(c-&gt;qid)];
		cv = p-&gt;conv[CONV(c-&gt;qid)];
		if(strcmp(ATTACHER(c), cv-&gt;owner) != 0 &amp;&amp; !iseve())
			error(Eperm);
		incref(&amp;cv-&gt;snoopers);
		break;
	case Qclone:
		p = f-&gt;p[PROTO(c-&gt;qid)];
		qlock(p);
		if(waserror()){
			qunlock(p);
			nexterror();
		}
		cv = Fsprotoclone(p, ATTACHER(c));
		qunlock(p);
		poperror();
		if(cv == nil) {
			error(Enodev);
			break;
		}
		mkqid(&amp;c-&gt;qid, QID(p-&gt;x, cv-&gt;x, Qctl), 0, QTFILE);
		break;
	case Qdata:
	case Qctl:
	case Qerr:
		p = f-&gt;p[PROTO(c-&gt;qid)];
		qlock(p);
		cv = p-&gt;conv[CONV(c-&gt;qid)];
		qlock(cv);
		if(waserror()) {
			qunlock(cv);
			qunlock(p);
			nexterror();
		}
		if((perm &amp; (cv-&gt;perm&gt;&gt;6)) != perm) {
			if(strcmp(ATTACHER(c), cv-&gt;owner) != 0)
				error(Eperm);
		 	if((perm &amp; cv-&gt;perm) != perm)
				error(Eperm);

		}
		cv-&gt;inuse++;
		if(cv-&gt;inuse == 1){
			kstrdup(&amp;cv-&gt;owner, ATTACHER(c));
			cv-&gt;perm = 0660;
		}
		qunlock(cv);
		qunlock(p);
		poperror();
		break;
	case Qlisten:
		cv = f-&gt;p[PROTO(c-&gt;qid)]-&gt;conv[CONV(c-&gt;qid)];
		if((perm &amp; (cv-&gt;perm&gt;&gt;6)) != perm) {
			if(strcmp(ATTACHER(c), cv-&gt;owner) != 0)
				error(Eperm);
		 	if((perm &amp; cv-&gt;perm) != perm)
				error(Eperm);

		}

		if(cv-&gt;state != Announced)
			error("not announced");

		if(waserror()){
			closeconv(cv);
			nexterror();
		}
		qlock(cv);
		cv-&gt;inuse++;
		qunlock(cv);

		nc = nil;
		while(nc == nil) {
			/* give up if we got a hangup */
			if(qisclosed(cv-&gt;rq))
				error("listen hungup");

			qlock(&amp;cv-&gt;listenq);
			if(waserror()) {
				qunlock(&amp;cv-&gt;listenq);
				nexterror();
			}

			/* wait for a connect */
			sleep(&amp;cv-&gt;listenr, incoming, cv);

			qlock(cv);
			nc = cv-&gt;incall;
			if(nc != nil){
				cv-&gt;incall = nc-&gt;next;
				mkqid(&amp;c-&gt;qid, QID(PROTO(c-&gt;qid), nc-&gt;x, Qctl), 0, QTFILE);
				kstrdup(&amp;cv-&gt;owner, ATTACHER(c));
			}
			qunlock(cv);

			qunlock(&amp;cv-&gt;listenq);
			poperror();
		}
		closeconv(cv);
		poperror();
		break;
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static void
ipcreate(Chan*, char*, int, ulong)
{
	error(Eperm);
}

static void
ipremove(Chan*)
{
	error(Eperm);
}

static int
ipwstat(Chan *c, uchar *dp, int n)
{
	Dir d;
	Conv *cv;
	Fs *f;
	Proto *p;

	f = ipfs[c-&gt;dev];
	switch(TYPE(c-&gt;qid)) {
	default:
		error(Eperm);
		break;
	case Qctl:
	case Qdata:
		break;
	}

	n = convM2D(dp, n, &amp;d, nil);
	if(n &gt; 0){
		p = f-&gt;p[PROTO(c-&gt;qid)];
		cv = p-&gt;conv[CONV(c-&gt;qid)];
		if(!iseve() &amp;&amp; strcmp(ATTACHER(c), cv-&gt;owner) != 0)
			error(Eperm);
		if(d.uid[0])
			kstrdup(&amp;cv-&gt;owner, d.uid);
		cv-&gt;perm = d.mode &amp; 0777;
	}
	return n;
}

void
closeconv(Conv *cv)
{
	Conv *nc;
	Ipmulti *mp;

	qlock(cv);

	if(--cv-&gt;inuse &gt; 0) {
		qunlock(cv);
		return;
	}

	/* close all incoming calls since no listen will ever happen */
	for(nc = cv-&gt;incall; nc; nc = cv-&gt;incall){
		cv-&gt;incall = nc-&gt;next;
		closeconv(nc);
	}
	cv-&gt;incall = nil;

	kstrdup(&amp;cv-&gt;owner, network);
	cv-&gt;perm = 0660;

	while((mp = cv-&gt;multi) != nil)
		ipifcremmulti(cv, mp-&gt;ma, mp-&gt;ia);

	cv-&gt;r = nil;
	cv-&gt;rgen = 0;
	cv-&gt;p-&gt;close(cv);
	cv-&gt;state = Idle;
	qunlock(cv);
}

static void
ipclose(Chan* c)
{
	Fs *f;

	f = ipfs[c-&gt;dev];
	switch(TYPE(c-&gt;qid)) {
	default:
		break;
	case Qlog:
		if(c-&gt;flag &amp; COPEN)
			netlogclose(f);
		break;
	case Qdata:
	case Qctl:
	case Qerr:
		if(c-&gt;flag &amp; COPEN)
			closeconv(f-&gt;p[PROTO(c-&gt;qid)]-&gt;conv[CONV(c-&gt;qid)]);
		break;
	case Qsnoop:
		if(c-&gt;flag &amp; COPEN)
			decref(&amp;f-&gt;p[PROTO(c-&gt;qid)]-&gt;conv[CONV(c-&gt;qid)]-&gt;snoopers);
		break;
	}
	free(((IPaux*)c-&gt;aux)-&gt;owner);
	free(c-&gt;aux);
}

enum
{
	Statelen=	32*1024,
};

static long
ipread(Chan *ch, void *a, long n, vlong off)
{
	Conv *c;
	Proto *x;
	char *buf, *p;
	long rv;
	Fs *f;
	ulong offset = off;

	f = ipfs[ch-&gt;dev];

	p = a;
	switch(TYPE(ch-&gt;qid)) {
	default:
		error(Eperm);
	case Qtopdir:
	case Qprotodir:
	case Qconvdir:
		return devdirread(ch, a, n, 0, 0, ipgen);
	case Qarp:
		return arpread(f-&gt;arp, a, offset, n);
 	case Qbootp:
 		return bootpread(a, offset, n);
 	case Qndb:
		return readstr(offset, a, n, f-&gt;ndb);
	case Qiproute:
		return routeread(f, a, offset, n);
	case Qipselftab:
		return ipselftabread(f, a, offset, n);
	case Qlog:
		return netlogread(f, a, offset, n);
	case Qctl:
		buf = smalloc(16);
		snprint(buf, 16, "%lud", CONV(ch-&gt;qid));
		rv = readstr(offset, p, n, buf);
		free(buf);
		return rv;
	case Qremote:
		buf = smalloc(Statelen);
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		if(x-&gt;remote == nil) {
			snprint(buf, Statelen, "%I!%d\n", c-&gt;raddr, c-&gt;rport);
		} else {
			(*x-&gt;remote)(c, buf, Statelen-2);
		}
		rv = readstr(offset, p, n, buf);
		free(buf);
		return rv;
	case Qlocal:
		buf = smalloc(Statelen);
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		if(x-&gt;local == nil) {
			snprint(buf, Statelen, "%I!%d\n", c-&gt;laddr, c-&gt;lport);
		} else {
			(*x-&gt;local)(c, buf, Statelen-2);
		}
		rv = readstr(offset, p, n, buf);
		free(buf);
		return rv;
	case Qstatus:
		buf = smalloc(Statelen);
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		(*x-&gt;state)(c, buf, Statelen-2);
		rv = readstr(offset, p, n, buf);
		free(buf);
		return rv;
	case Qdata:
		c = f-&gt;p[PROTO(ch-&gt;qid)]-&gt;conv[CONV(ch-&gt;qid)];
		return qread(c-&gt;rq, a, n);
	case Qerr:
		c = f-&gt;p[PROTO(ch-&gt;qid)]-&gt;conv[CONV(ch-&gt;qid)];
		return qread(c-&gt;eq, a, n);
	case Qsnoop:
		c = f-&gt;p[PROTO(ch-&gt;qid)]-&gt;conv[CONV(ch-&gt;qid)];
		return qread(c-&gt;sq, a, n);
	case Qstats:
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		if(x-&gt;stats == nil)
			error("stats not implemented");
		buf = smalloc(Statelen);
		(*x-&gt;stats)(x, buf, Statelen);
		rv = readstr(offset, p, n, buf);
		free(buf);
		return rv;
	}
}

static Block*
ipbread(Chan* ch, long n, ulong offset)
{
	Conv *c;
	Proto *x;
	Fs *f;

	switch(TYPE(ch-&gt;qid)){
	case Qdata:
		f = ipfs[ch-&gt;dev];
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		return qbread(c-&gt;rq, n);
	default:
		return devbread(ch, n, offset);
	}
}

/*
 *  set local address to be that of the ifc closest to remote address
 */
static void
setladdr(Conv* c)
{
	findlocalip(c-&gt;p-&gt;f, c-&gt;laddr, c-&gt;raddr);
}

/*
 *  set a local port making sure the quad of raddr,rport,laddr,lport is unique
 */
char*
setluniqueport(Conv* c, int lport)
{
	Proto *p;
	Conv *xp;
	int x;

	p = c-&gt;p;

	qlock(p);
	for(x = 0; x &lt; p-&gt;nc; x++){
		xp = p-&gt;conv[x];
		if(xp == nil)
			break;
		if(xp == c)
			continue;
		if((xp-&gt;state == Connected || xp-&gt;state == Announced)
		&amp;&amp; xp-&gt;lport == lport
		&amp;&amp; xp-&gt;rport == c-&gt;rport
		&amp;&amp; ipcmp(xp-&gt;raddr, c-&gt;raddr) == 0
		&amp;&amp; ipcmp(xp-&gt;laddr, c-&gt;laddr) == 0){
			qunlock(p);
			return "address in use";
		}
	}
	c-&gt;lport = lport;
	qunlock(p);
	return nil;
}

/*
 * is lport in use by anyone?
 */
static int
lportinuse(Proto *p, ushort lport)
{
	int x;

	for(x = 0; x &lt; p-&gt;nc &amp;&amp; p-&gt;conv[x]; x++)
		if(p-&gt;conv[x]-&gt;lport == lport)
			return 1;
	return 0;
}

/*
 *  pick a local port and set it
 */
char *
setlport(Conv* c)
{
	Proto *p;
	int i, port;

	p = c-&gt;p;
	qlock(p);
	if(c-&gt;restricted){
		/* Restricted ports cycle between 600 and 1024. */
		for(i=0; i&lt;1024-600; i++){
			if(p-&gt;nextrport &gt;= 1024 || p-&gt;nextrport &lt; 600)
				p-&gt;nextrport = 600;
			port = p-&gt;nextrport++;
			if(!lportinuse(p, port))
				goto chosen;
		}
	}else{
		/*
		 * Unrestricted ports are chosen randomly
		 * between 2^15 and 2^16.  There are at most
		 * 4*Nchan = 4096 ports in use at any given time,
		 * so even in the worst case, a random probe has a
		 * 1 - 4096/2^15 = 87% chance of success.
		 * If 64 successive probes fail, there is a bug somewhere
		 * (or a once in 10^58 event has happened, but that's
		 * less likely than a venti collision).
		 */
		for(i=0; i&lt;64; i++){
			port = (1&lt;&lt;15) + nrand(1&lt;&lt;15);
			if(!lportinuse(p, port))
				goto chosen;
		}
	}
	qunlock(p);
	/*
	 * debugging: let's see if we ever get this.
	 * if we do (and we're a cpu server), we might as well restart
	 * since we're now unable to service new connections.
	 */
	panic("setlport: out of ports");
	return "no ports available";

chosen:
	c-&gt;lport = port;
	qunlock(p);
	return nil;
}

/*
 *  set a local address and port from a string of the form
 *	[address!]port[!r]
 */
char*
setladdrport(Conv* c, char* str, int announcing)
{
	char *p;
	char *rv;
	ushort lport;
	uchar addr[IPaddrlen];

	/*
	 *  ignore restricted part if it exists.  it's
	 *  meaningless on local ports.
	 */
	p = strchr(str, '!');
	if(p != nil){
		*p++ = 0;
		if(strcmp(p, "r") == 0)
			p = nil;
	}

	c-&gt;lport = 0;
	if(p == nil){
		if(announcing)
			ipmove(c-&gt;laddr, IPnoaddr);
		else
			setladdr(c);
		p = str;
	} else {
		if(strcmp(str, "*") == 0)
			ipmove(c-&gt;laddr, IPnoaddr);
		else {
			if(parseip(addr, str) == -1)
				return Ebadip;
			if(ipforme(c-&gt;p-&gt;f, addr))
				ipmove(c-&gt;laddr, addr);
			else
				return "not a local IP address";
		}
	}

	/* one process can get all connections */
	if(announcing &amp;&amp; strcmp(p, "*") == 0){
		if(!iseve())
			error(Eperm);
		return setluniqueport(c, 0);
	}

	lport = atoi(p);
	if(lport &lt;= 0)
		rv = setlport(c);
	else
		rv = setluniqueport(c, lport);
	return rv;
}

static char*
setraddrport(Conv* c, char* str)
{
	char *p;

	p = strchr(str, '!');
	if(p == nil)
		return "malformed address";
	*p++ = 0;
	if (parseip(c-&gt;raddr, str) == -1)
		return Ebadip;
	c-&gt;rport = atoi(p);
	p = strchr(p, '!');
	if(p){
		if(strstr(p, "!r") != nil)
			c-&gt;restricted = 1;
	}
	return nil;
}

/*
 *  called by protocol connect routine to set addresses
 */
char*
Fsstdconnect(Conv *c, char *argv[], int argc)
{
	char *p;

	switch(argc) {
	default:
		return "bad args to connect";
	case 2:
		p = setraddrport(c, argv[1]);
		if(p != nil)
			return p;
		setladdr(c);
		p = setlport(c);
		if (p != nil)
			return p;
		break;
	case 3:
		p = setraddrport(c, argv[1]);
		if(p != nil)
			return p;
		p = setladdrport(c, argv[2], 0);
		if(p != nil)
			return p;
	}

	if( (memcmp(c-&gt;raddr, v4prefix, IPv4off) == 0 &amp;&amp;
		memcmp(c-&gt;laddr, v4prefix, IPv4off) == 0)
		|| ipcmp(c-&gt;raddr, IPnoaddr) == 0)
		c-&gt;ipversion = V4;
	else
		c-&gt;ipversion = V6;

	return nil;
}
/*
 *  initiate connection and sleep till its set up
 */
static int
connected(void* a)
{
	return ((Conv*)a)-&gt;state == Connected;
}
static void
connectctlmsg(Proto *x, Conv *c, Cmdbuf *cb)
{
	char *p;

	if(c-&gt;state != 0)
		error(Econinuse);
	c-&gt;state = Connecting;
	c-&gt;cerr[0] = '\0';
	if(x-&gt;connect == nil)
		error("connect not supported");
	p = x-&gt;connect(c, cb-&gt;f, cb-&gt;nf);
	if(p != nil)
		error(p);

	qunlock(c);
	if(waserror()){
		qlock(c);
		nexterror();
	}
	sleep(&amp;c-&gt;cr, connected, c);
	qlock(c);
	poperror();

	if(c-&gt;cerr[0] != '\0')
		error(c-&gt;cerr);
}

/*
 *  called by protocol announce routine to set addresses
 */
char*
Fsstdannounce(Conv* c, char* argv[], int argc)
{
	memset(c-&gt;raddr, 0, sizeof(c-&gt;raddr));
	c-&gt;rport = 0;
	switch(argc){
	default:
		break;
	case 2:
		return setladdrport(c, argv[1], 1);
	}
	return "bad args to announce";
}

/*
 *  initiate announcement and sleep till its set up
 */
static int
announced(void* a)
{
	return ((Conv*)a)-&gt;state == Announced;
}
static void
announcectlmsg(Proto *x, Conv *c, Cmdbuf *cb)
{
	char *p;

	if(c-&gt;state != 0)
		error(Econinuse);
	c-&gt;state = Announcing;
	c-&gt;cerr[0] = '\0';
	if(x-&gt;announce == nil)
		error("announce not supported");
	p = x-&gt;announce(c, cb-&gt;f, cb-&gt;nf);
	if(p != nil)
		error(p);

	qunlock(c);
	if(waserror()){
		qlock(c);
		nexterror();
	}
	sleep(&amp;c-&gt;cr, announced, c);
	qlock(c);
	poperror();

	if(c-&gt;cerr[0] != '\0')
		error(c-&gt;cerr);
}

/*
 *  called by protocol bind routine to set addresses
 */
char*
Fsstdbind(Conv* c, char* argv[], int argc)
{
	switch(argc){
	default:
		break;
	case 2:
		return setladdrport(c, argv[1], 0);
	}
	return "bad args to bind";
}

static void
bindctlmsg(Proto *x, Conv *c, Cmdbuf *cb)
{
	char *p;

	if(x-&gt;bind == nil)
		p = Fsstdbind(c, cb-&gt;f, cb-&gt;nf);
	else
		p = x-&gt;bind(c, cb-&gt;f, cb-&gt;nf);
	if(p != nil)
		error(p);
}

static void
tosctlmsg(Conv *c, Cmdbuf *cb)
{
	if(cb-&gt;nf &lt; 2)
		c-&gt;tos = 0;
	else
		c-&gt;tos = atoi(cb-&gt;f[1]);
}

static void
ttlctlmsg(Conv *c, Cmdbuf *cb)
{
	if(cb-&gt;nf &lt; 2)
		c-&gt;ttl = MAXTTL;
	else
		c-&gt;ttl = atoi(cb-&gt;f[1]);
}

static long
ipwrite(Chan* ch, void *v, long n, vlong off)
{
	Conv *c;
	Proto *x;
	char *p;
	Cmdbuf *cb;
	uchar ia[IPaddrlen], ma[IPaddrlen];
	Fs *f;
	char *a;
	ulong offset = off;

	a = v;
	f = ipfs[ch-&gt;dev];

	switch(TYPE(ch-&gt;qid)){
	default:
		error(Eperm);
	case Qdata:
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];

		if(c-&gt;wq == nil)
			error(Eperm);

		qwrite(c-&gt;wq, a, n);
		break;
	case Qarp:
		return arpwrite(f, a, n);
	case Qiproute:
		return routewrite(f, ch, a, n);
	case Qlog:
		netlogctl(f, a, n);
		return n;
	case Qndb:
		return ndbwrite(f, a, offset, n);
		break;
	case Qctl:
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		cb = parsecmd(a, n);

		qlock(c);
		if(waserror()) {
			qunlock(c);
			free(cb);
			nexterror();
		}
		if(cb-&gt;nf &lt; 1)
			error("short control request");
		if(strcmp(cb-&gt;f[0], "connect") == 0)
			connectctlmsg(x, c, cb);
		else if(strcmp(cb-&gt;f[0], "announce") == 0)
			announcectlmsg(x, c, cb);
		else if(strcmp(cb-&gt;f[0], "bind") == 0)
			bindctlmsg(x, c, cb);
		else if(strcmp(cb-&gt;f[0], "ttl") == 0)
			ttlctlmsg(c, cb);
		else if(strcmp(cb-&gt;f[0], "tos") == 0)
			tosctlmsg(c, cb);
		else if(strcmp(cb-&gt;f[0], "ignoreadvice") == 0)
			c-&gt;ignoreadvice = 1;
		else if(strcmp(cb-&gt;f[0], "addmulti") == 0){
			if(cb-&gt;nf &lt; 2)
				error("addmulti needs interface address");
			if(cb-&gt;nf == 2){
				if(!ipismulticast(c-&gt;raddr))
					error("addmulti for a non multicast address");
				if (parseip(ia, cb-&gt;f[1]) == -1)
					error(Ebadip);
				ipifcaddmulti(c, c-&gt;raddr, ia);
			} else {
				if (parseip(ia, cb-&gt;f[1]) == -1 ||
				    parseip(ma, cb-&gt;f[2]) == -1)
					error(Ebadip);
				if(!ipismulticast(ma))
					error("addmulti for a non multicast address");
				ipifcaddmulti(c, ma, ia);
			}
		} else if(strcmp(cb-&gt;f[0], "remmulti") == 0){
			if(cb-&gt;nf &lt; 2)
				error("remmulti needs interface address");
			if(!ipismulticast(c-&gt;raddr))
				error("remmulti for a non multicast address");
			if (parseip(ia, cb-&gt;f[1]) == -1)
				error(Ebadip);
			ipifcremmulti(c, c-&gt;raddr, ia);
		} else if(strcmp(cb-&gt;f[0], "maxfragsize") == 0){
			if(cb-&gt;nf &lt; 2)
				error("maxfragsize needs size");

			c-&gt;maxfragsize = (int)strtol(cb-&gt;f[1], nil, 0);

		} else if(x-&gt;ctl != nil) {
			p = x-&gt;ctl(c, cb-&gt;f, cb-&gt;nf);
			if(p != nil)
				error(p);
		} else
			error("unknown control request");
		qunlock(c);
		free(cb);
		poperror();
	}
	return n;
}

static long
ipbwrite(Chan* ch, Block* bp, ulong offset)
{
	Conv *c;
	Proto *x;
	Fs *f;
	int n;

	switch(TYPE(ch-&gt;qid)){
	case Qdata:
		f = ipfs[ch-&gt;dev];
		x = f-&gt;p[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];

		if(c-&gt;wq == nil)
			error(Eperm);

		if(bp-&gt;next)
			bp = concatblock(bp);
		n = BLEN(bp);
		qbwrite(c-&gt;wq, bp);
		return n;
	default:
		return devbwrite(ch, bp, offset);
	}
}

Dev ipdevtab = {
	'I',
	"ip",

	ipreset,
	devinit,
	devshutdown,
	ipattach,
	ipwalk,
	ipstat,
	ipopen,
	ipcreate,
	ipclose,
	ipread,
	ipbread,
	ipwrite,
	ipbwrite,
	ipremove,
	ipwstat,
};

int
Fsproto(Fs *f, Proto *p)
{
	if(f-&gt;np &gt;= Maxproto)
		return -1;

	p-&gt;f = f;

	if(p-&gt;ipproto &gt; 0){
		if(f-&gt;t2p[p-&gt;ipproto] != nil)
			return -1;
		f-&gt;t2p[p-&gt;ipproto] = p;
	}

	p-&gt;qid.type = QTDIR;
	p-&gt;qid.path = QID(f-&gt;np, 0, Qprotodir);
	p-&gt;conv = malloc(sizeof(Conv*)*(p-&gt;nc+1));
	if(p-&gt;conv == nil)
		panic("Fsproto");

	p-&gt;x = f-&gt;np;
	p-&gt;nextrport = 600;
	f-&gt;p[f-&gt;np++] = p;

	return 0;
}

/*
 *  return true if this protocol is
 *  built in
 */
int
Fsbuiltinproto(Fs* f, uchar proto)
{
	return f-&gt;t2p[proto] != nil;
}

/*
 *  called with protocol locked
 */
Conv*
Fsprotoclone(Proto *p, char *user)
{
	Conv *c, **pp, **ep;

retry:
	c = nil;
	ep = &amp;p-&gt;conv[p-&gt;nc];
	for(pp = p-&gt;conv; pp &lt; ep; pp++) {
		c = *pp;
		if(c == nil){
			c = malloc(sizeof(Conv));
			if(c == nil)
				error(Enomem);
			qlock(c);
			c-&gt;p = p;
			c-&gt;x = pp - p-&gt;conv;
			if(p-&gt;ptclsize != 0){
				c-&gt;ptcl = malloc(p-&gt;ptclsize);
				if(c-&gt;ptcl == nil) {
					free(c);
					error(Enomem);
				}
			}
			*pp = c;
			p-&gt;ac++;
			c-&gt;eq = qopen(1024, Qmsg, 0, 0);
			(*p-&gt;create)(c);
			break;
		}
		if(canqlock(c)){
			/*
			 *  make sure both processes and protocol
			 *  are done with this Conv
			 */
			if(c-&gt;inuse == 0 &amp;&amp; (p-&gt;inuse == nil || (*p-&gt;inuse)(c) == 0))
				break;

			qunlock(c);
		}
	}
	if(pp &gt;= ep) {
		if(p-&gt;gc)
			print("Fsprotoclone: garbage collecting Convs\n");
		if(p-&gt;gc != nil &amp;&amp; (*p-&gt;gc)(p))
			goto retry;
		/* debugging: do we ever get here? */
		if (cpuserver)
			panic("Fsprotoclone: all conversations in use");
		return nil;
	}

	c-&gt;inuse = 1;
	kstrdup(&amp;c-&gt;owner, user);
	c-&gt;perm = 0660;
	c-&gt;state = Idle;
	ipmove(c-&gt;laddr, IPnoaddr);
	ipmove(c-&gt;raddr, IPnoaddr);
	c-&gt;r = nil;
	c-&gt;rgen = 0;
	c-&gt;lport = 0;
	c-&gt;rport = 0;
	c-&gt;restricted = 0;
	c-&gt;maxfragsize = 0;
	c-&gt;ttl = MAXTTL;
	qreopen(c-&gt;rq);
	qreopen(c-&gt;wq);
	qreopen(c-&gt;eq);

	qunlock(c);
	return c;
}

int
Fsconnected(Conv* c, char* msg)
{
	if(msg != nil &amp;&amp; *msg != '\0')
		strncpy(c-&gt;cerr, msg, ERRMAX-1);

	switch(c-&gt;state){

	case Announcing:
		c-&gt;state = Announced;
		break;

	case Connecting:
		c-&gt;state = Connected;
		break;
	}

	wakeup(&amp;c-&gt;cr);
	return 0;
}

Proto*
Fsrcvpcol(Fs* f, uchar proto)
{
	if(f-&gt;ipmux)
		return f-&gt;ipmux;
	else
		return f-&gt;t2p[proto];
}

Proto*
Fsrcvpcolx(Fs *f, uchar proto)
{
	return f-&gt;t2p[proto];
}

/*
 *  called with protocol locked
 */
Conv*
Fsnewcall(Conv *c, uchar *raddr, ushort rport, uchar *laddr, ushort lport, uchar version)
{
	Conv *nc;
	Conv **l;
	int i;

	qlock(c);
	i = 0;
	for(l = &amp;c-&gt;incall; *l; l = &amp;(*l)-&gt;next)
		i++;
	if(i &gt;= Maxincall) {
		static int beenhere;

		qunlock(c);
		if (!beenhere) {
			beenhere = 1;
			print("Fsnewcall: incall queue full (%d) on port %d\n",
				i, c-&gt;lport);
		}
		return nil;
	}

	/* find a free conversation */
	nc = Fsprotoclone(c-&gt;p, network);
	if(nc == nil) {
		qunlock(c);
		return nil;
	}
	ipmove(nc-&gt;raddr, raddr);
	nc-&gt;rport = rport;
	ipmove(nc-&gt;laddr, laddr);
	nc-&gt;lport = lport;
	nc-&gt;next = nil;
	*l = nc;
	nc-&gt;state = Connected;
	nc-&gt;ipversion = version;

	qunlock(c);

	wakeup(&amp;c-&gt;listenr);

	return nc;
}

long
ndbwrite(Fs *f, char *a, ulong off, int n)
{
	if(off &gt; strlen(f-&gt;ndb))
		error(Eio);
	if(off+n &gt;= sizeof(f-&gt;ndb))
		error(Eio);
	memmove(f-&gt;ndb+off, a, n);
	f-&gt;ndb[off+n] = 0;
	f-&gt;ndbvers++;
	f-&gt;ndbmtime = seconds();
	return n;
}

ulong
scalednconv(void)
{
	if(cpuserver &amp;&amp; conf.npage*BY2PG &gt;= 128*MB)
		return Nchans*4;
	return Nchans;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

