<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/icmp6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/icmp6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Internet Control Message Protocol for IPv6
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "ip.h"
#include "ipv6.h"

enum
{
	InMsgs6,
	InErrors6,
	OutMsgs6,
	CsumErrs6,
	LenErrs6,
	HlenErrs6,
	HoplimErrs6,
	IcmpCodeErrs6,
	TargetErrs6,
	OptlenErrs6,
	AddrmxpErrs6,
	RouterAddrErrs6,

	Nstats6,
};

enum {
	ICMP_USEAD6	= 40,
};

enum {
	Oflag	= 1&lt;&lt;5,
	Sflag	= 1&lt;&lt;6,
	Rflag	= 1&lt;&lt;7,
};

enum {
	/* ICMPv6 types */
	EchoReply	= 0,
	UnreachableV6	= 1,
	PacketTooBigV6	= 2,
	TimeExceedV6	= 3,
	SrcQuench	= 4,
	ParamProblemV6	= 4,
	Redirect	= 5,
	EchoRequest	= 8,
	TimeExceed	= 11,
	InParmProblem	= 12,
	Timestamp	= 13,
	TimestampReply	= 14,
	InfoRequest	= 15,
	InfoReply	= 16,
	AddrMaskRequest = 17,
	AddrMaskReply   = 18,
	EchoRequestV6	= 128,
	EchoReplyV6	= 129,
	RouterSolicit	= 133,
	RouterAdvert	= 134,
	NbrSolicit	= 135,
	NbrAdvert	= 136,
	RedirectV6	= 137,

	Maxtype6	= 137,
};

/* on-the-wire packet formats */
typedef struct IPICMP IPICMP;
typedef struct Ndpkt Ndpkt;
typedef struct NdiscC NdiscC;

/* we do this to avoid possible struct padding  */
#define ICMPHDR \
	IPV6HDR; \
	uchar	type; \
	uchar	code; \
	uchar	cksum[2]; \
	uchar	icmpid[2]; \
	uchar	seq[2]

struct IPICMP {
	ICMPHDR;
	uchar	payload[];
};

#define IPICMPSZ offsetof(IPICMP, payload[0])

struct NdiscC {
	ICMPHDR;
	uchar	target[IPaddrlen];
	uchar	payload[];
};

#define NDISCSZ offsetof(NdiscC, payload[0])

struct Ndpkt {
	ICMPHDR;
	uchar	target[IPaddrlen];
	uchar	otype;
	uchar	olen;		/* length in units of 8 octets(incl type, code),
				 * 1 for IEEE 802 addresses */
	uchar	lnaddr[6];	/* link-layer address */
	uchar	payload[];
};

#define NDPKTSZ offsetof(Ndpkt, payload[0])

typedef struct Icmppriv6
{
	ulong	stats[Nstats6];

	/* message counts */
	ulong	in[Maxtype6+1];
	ulong	out[Maxtype6+1];
} Icmppriv6;

typedef struct Icmpcb6
{
	QLock;
	uchar	headers;
} Icmpcb6;

char *icmpnames6[Maxtype6+1] =
{
[EchoReply]		"EchoReply",
[UnreachableV6]		"UnreachableV6",
[PacketTooBigV6]	"PacketTooBigV6",
[TimeExceedV6]		"TimeExceedV6",
[SrcQuench]		"SrcQuench",
[Redirect]		"Redirect",
[EchoRequest]		"EchoRequest",
[TimeExceed]		"TimeExceed",
[InParmProblem]		"InParmProblem",
[Timestamp]		"Timestamp",
[TimestampReply]	"TimestampReply",
[InfoRequest]		"InfoRequest",
[InfoReply]		"InfoReply",
[AddrMaskRequest]	"AddrMaskRequest",
[AddrMaskReply]		"AddrMaskReply",
[EchoRequestV6]		"EchoRequestV6",
[EchoReplyV6]		"EchoReplyV6",
[RouterSolicit]		"RouterSolicit",
[RouterAdvert]		"RouterAdvert",
[NbrSolicit]		"NbrSolicit",
[NbrAdvert]		"NbrAdvert",
[RedirectV6]		"RedirectV6",
};

static char *statnames6[Nstats6] =
{
[InMsgs6]	"InMsgs",
[InErrors6]	"InErrors",
[OutMsgs6]	"OutMsgs",
[CsumErrs6]	"CsumErrs",
[LenErrs6]	"LenErrs",
[HlenErrs6]	"HlenErrs",
[HoplimErrs6]	"HoplimErrs",
[IcmpCodeErrs6]	"IcmpCodeErrs",
[TargetErrs6]	"TargetErrs",
[OptlenErrs6]	"OptlenErrs",
[AddrmxpErrs6]	"AddrmxpErrs",
[RouterAddrErrs6]	"RouterAddrErrs",
};

static char *unreachcode[] =
{
[Icmp6_no_route]	"no route to destination",
[Icmp6_ad_prohib]	"comm with destination administratively prohibited",
[Icmp6_out_src_scope]	"beyond scope of source address",
[Icmp6_adr_unreach]	"address unreachable",
[Icmp6_port_unreach]	"port unreachable",
[Icmp6_gress_src_fail]	"source address failed ingress/egress policy",
[Icmp6_rej_route]	"reject route to destination",
[Icmp6_unknown]		"icmp unreachable: unknown code",
};

static void icmpkick6(void *x, Block *bp);

static void
icmpcreate6(Conv *c)
{
	c-&gt;rq = qopen(64*1024, Qmsg, 0, c);
	c-&gt;wq = qbypass(icmpkick6, c);
}

static void
set_cksum(Block *bp)
{
	IPICMP *p = (IPICMP *)(bp-&gt;rp);

	hnputl(p-&gt;vcf, 0);  	/* borrow IP header as pseudoheader */
	hnputs(p-&gt;ploadlen, blocklen(bp) - IP6HDR);
	p-&gt;proto = 0;
	p-&gt;ttl = ICMPv6;	/* ttl gets set later */
	hnputs(p-&gt;cksum, 0);
	hnputs(p-&gt;cksum, ptclcsum(bp, 0, blocklen(bp)));
	p-&gt;proto = ICMPv6;
}

static Block *
newIPICMP(int packetlen)
{
	Block *nbp;

	nbp = allocb(packetlen);
	nbp-&gt;wp += packetlen;
	memset(nbp-&gt;rp, 0, packetlen);
	return nbp;
}

void
icmpadvise6(Proto *icmp, Block *bp, char *msg)
{
	ushort recid;
	Conv **c, *s;
	IPICMP *p;

	p = (IPICMP *)bp-&gt;rp;
	recid = nhgets(p-&gt;icmpid);

	for(c = icmp-&gt;conv; *c; c++) {
		s = *c;
		if(s-&gt;lport == recid &amp;&amp; ipcmp(s-&gt;raddr, p-&gt;dst) == 0){
			qhangup(s-&gt;rq, msg);
			qhangup(s-&gt;wq, msg);
			break;
		}
	}
	freeblist(bp);
}

static void
icmpkick6(void *x, Block *bp)
{
	uchar laddr[IPaddrlen], raddr[IPaddrlen];
	Conv *c = x;
	IPICMP *p;
	Icmppriv6 *ipriv = c-&gt;p-&gt;priv;
	Icmpcb6 *icb = (Icmpcb6*)c-&gt;ptcl;

	if(bp == nil)
		return;

	if(icb-&gt;headers==6) {
		/* get user specified addresses */
		bp = pullupblock(bp, ICMP_USEAD6);
		if(bp == nil)
			return;
		bp-&gt;rp += 8;
		ipmove(laddr, bp-&gt;rp);
		bp-&gt;rp += IPaddrlen;
		ipmove(raddr, bp-&gt;rp);
		bp-&gt;rp += IPaddrlen;
		bp = padblock(bp, IP6HDR);
	}

	if(blocklen(bp) &lt; IPICMPSZ){
		freeblist(bp);
		return;
	}
	p = (IPICMP *)(bp-&gt;rp);
	if(icb-&gt;headers == 6) {
		ipmove(p-&gt;dst, raddr);
		ipmove(p-&gt;src, laddr);
	} else {
		ipmove(p-&gt;dst, c-&gt;raddr);
		ipmove(p-&gt;src, c-&gt;laddr);
		hnputs(p-&gt;icmpid, c-&gt;lport);
	}

	set_cksum(bp);
	p-&gt;vcf[0] = 0x06 &lt;&lt; 4;
	if(p-&gt;type &lt;= Maxtype6)
		ipriv-&gt;out[p-&gt;type]++;
	ipoput6(c-&gt;p-&gt;f, bp, 0, c-&gt;ttl, c-&gt;tos, nil);
}

char*
icmpctl6(Conv *c, char **argv, int argc)
{
	Icmpcb6 *icb;

	icb = (Icmpcb6*) c-&gt;ptcl;
	if(argc==1 &amp;&amp; strcmp(argv[0], "headers")==0) {
		icb-&gt;headers = 6;
		return nil;
	}
	return "unknown control request";
}

static void
goticmpkt6(Proto *icmp, Block *bp, int muxkey)
{
	ushort recid;
	uchar *addr;
	Conv **c, *s;
	IPICMP *p = (IPICMP *)bp-&gt;rp;

	if(muxkey == 0) {
		recid = nhgets(p-&gt;icmpid);
		addr = p-&gt;src;
	} else {
		recid = muxkey;
		addr = p-&gt;dst;
	}

	for(c = icmp-&gt;conv; *c; c++){
		s = *c;
		if(s-&gt;lport == recid &amp;&amp; ipcmp(s-&gt;raddr, addr) == 0){
			bp = concatblock(bp);
			if(bp != nil)
				qpass(s-&gt;rq, bp);
			return;
		}
	}

	freeblist(bp);
}

static Block *
mkechoreply6(Block *bp, Ipifc *ifc)
{
	uchar addr[IPaddrlen];
	IPICMP *p = (IPICMP *)(bp-&gt;rp);

	ipmove(addr, p-&gt;src);
	if(!isv6mcast(p-&gt;dst))
		ipmove(p-&gt;src, p-&gt;dst);
	else if (!ipv6anylocal(ifc, p-&gt;src))
		return nil;
	ipmove(p-&gt;dst, addr);
	p-&gt;type = EchoReplyV6;
	set_cksum(bp);
	return bp;
}

/*
 * sends out an ICMPv6 neighbor solicitation
 * 	suni == SRC_UNSPEC or SRC_UNI,
 *	tuni == TARG_MULTI =&gt; multicast for address resolution,
 * 	and tuni == TARG_UNI =&gt; neighbor reachability.
 */
extern void
icmpns(Fs *f, uchar* src, int suni, uchar* targ, int tuni, uchar* mac)
{
	Block *nbp;
	Ndpkt *np;
	Proto *icmp = f-&gt;t2p[ICMPv6];
	Icmppriv6 *ipriv = icmp-&gt;priv;

	nbp = newIPICMP(NDPKTSZ);
	np = (Ndpkt*) nbp-&gt;rp;

	if(suni == SRC_UNSPEC)
		memmove(np-&gt;src, v6Unspecified, IPaddrlen);
	else
		memmove(np-&gt;src, src, IPaddrlen);

	if(tuni == TARG_UNI)
		memmove(np-&gt;dst, targ, IPaddrlen);
	else
		ipv62smcast(np-&gt;dst, targ);

	np-&gt;type = NbrSolicit;
	np-&gt;code = 0;
	memmove(np-&gt;target, targ, IPaddrlen);
	if(suni != SRC_UNSPEC) {
		np-&gt;otype = SRC_LLADDR;
		np-&gt;olen = 1;		/* 1+1+6 = 8 = 1 8-octet */
		memmove(np-&gt;lnaddr, mac, sizeof(np-&gt;lnaddr));
	} else
		nbp-&gt;wp -= NDPKTSZ - NDISCSZ;

	set_cksum(nbp);
	np = (Ndpkt*)nbp-&gt;rp;
	np-&gt;ttl = HOP_LIMIT;
	np-&gt;vcf[0] = 0x06 &lt;&lt; 4;
	ipriv-&gt;out[NbrSolicit]++;
	netlog(f, Logicmp, "sending neighbor solicitation %I\n", targ);
	ipoput6(f, nbp, 0, MAXTTL, DFLTTOS, nil);
}

/*
 * sends out an ICMPv6 neighbor advertisement. pktflags == RSO flags.
 */
extern void
icmpna(Fs *f, uchar* src, uchar* dst, uchar* targ, uchar* mac, uchar flags)
{
	Block *nbp;
	Ndpkt *np;
	Proto *icmp = f-&gt;t2p[ICMPv6];
	Icmppriv6 *ipriv = icmp-&gt;priv;

	nbp = newIPICMP(NDPKTSZ);
	np = (Ndpkt*)nbp-&gt;rp;

	memmove(np-&gt;src, src, IPaddrlen);
	memmove(np-&gt;dst, dst, IPaddrlen);

	np-&gt;type = NbrAdvert;
	np-&gt;code = 0;
	np-&gt;icmpid[0] = flags;
	memmove(np-&gt;target, targ, IPaddrlen);

	np-&gt;otype = TARGET_LLADDR;
	np-&gt;olen = 1;
	memmove(np-&gt;lnaddr, mac, sizeof(np-&gt;lnaddr));

	set_cksum(nbp);
	np = (Ndpkt*) nbp-&gt;rp;
	np-&gt;ttl = HOP_LIMIT;
	np-&gt;vcf[0] = 0x06 &lt;&lt; 4;
	ipriv-&gt;out[NbrAdvert]++;
	netlog(f, Logicmp, "sending neighbor advertisement %I\n", src);
	ipoput6(f, nbp, 0, MAXTTL, DFLTTOS, nil);
}

/* if free is true, freeblist(bp) before return. */
extern void
icmphostunr(Fs *f, Ipifc *ifc, Block *bp, int code, int free)
{
	int osz, sz;
	Block *nbp;
	IPICMP *np;
	Icmppriv6 *ipriv;
	Ip6hdr *p;
	Proto *icmp;

	osz = BLEN(bp);
	sz = MIN(IPICMPSZ + osz, v6MINTU);
	icmp = f-&gt;t2p[ICMPv6];
	ipriv = icmp-&gt;priv;
	p = (Ip6hdr *)bp-&gt;rp;
	if(isv6mcast(p-&gt;src))
		goto freebl;
	nbp = newIPICMP(sz);
	np = (IPICMP *)nbp-&gt;rp;

	rlock(ifc);
	if(!ipv6anylocal(ifc, np-&gt;src)){
		netlog(f, Logicmp, "icmphostunr fail -&gt; src %I dst %I\n",
			p-&gt;src, p-&gt;dst);
		runlock(ifc);
		freeblist(nbp);
		goto freebl;
	}

	netlog(f, Logicmp, "send icmphostunr -&gt; src %I dst %I\n", p-&gt;src, p-&gt;dst);
	memmove(np-&gt;dst, p-&gt;src, IPaddrlen);
	np-&gt;type = UnreachableV6;
	np-&gt;code = code;
	memmove(nbp-&gt;rp + IPICMPSZ, bp-&gt;rp, sz - IPICMPSZ);
	set_cksum(nbp);
	np-&gt;ttl = HOP_LIMIT;
	np-&gt;vcf[0] = 0x06 &lt;&lt; 4;
	ipriv-&gt;out[UnreachableV6]++;

	if(free)
		ipiput6(f, ifc, nbp);
	else
		ipoput6(f, nbp, 0, MAXTTL, DFLTTOS, nil);
	runlock(ifc);
freebl:
	if(free)
		freeblist(bp);
}

extern void
icmpttlexceeded6(Fs *f, Ipifc *ifc, Block *bp)
{
	int osz = BLEN(bp);
	int sz = MIN(IPICMPSZ + osz, v6MINTU);
	Block *nbp;
	IPICMP *np;
	Ip6hdr *p;
	Proto *icmp = f-&gt;t2p[ICMPv6];
	Icmppriv6 *ipriv = icmp-&gt;priv;

	p = (Ip6hdr *)bp-&gt;rp;
	if(isv6mcast(p-&gt;src))
		return;

	nbp = newIPICMP(sz);
	np = (IPICMP *) nbp-&gt;rp;
	if(ipv6anylocal(ifc, np-&gt;src))
		netlog(f, Logicmp, "send icmpttlexceeded6 -&gt; src %I dst %I\n",
			p-&gt;src, p-&gt;dst);
	else {
		netlog(f, Logicmp, "icmpttlexceeded6 fail -&gt; src %I dst %I\n",
			p-&gt;src, p-&gt;dst);
		return;
	}

	memmove(np-&gt;dst, p-&gt;src, IPaddrlen);
	np-&gt;type = TimeExceedV6;
	np-&gt;code = 0;
	memmove(nbp-&gt;rp + IPICMPSZ, bp-&gt;rp, sz - IPICMPSZ);
	set_cksum(nbp);
	np-&gt;ttl = HOP_LIMIT;
	np-&gt;vcf[0] = 0x06 &lt;&lt; 4;
	ipriv-&gt;out[TimeExceedV6]++;
	ipoput6(f, nbp, 0, MAXTTL, DFLTTOS, nil);
}

extern void
icmppkttoobig6(Fs *f, Ipifc *ifc, Block *bp)
{
	int osz = BLEN(bp);
	int sz = MIN(IPICMPSZ + osz, v6MINTU);
	Block *nbp;
	IPICMP *np;
	Ip6hdr *p;
	Proto *icmp = f-&gt;t2p[ICMPv6];
	Icmppriv6 *ipriv = icmp-&gt;priv;

	p = (Ip6hdr *)bp-&gt;rp;
	if(isv6mcast(p-&gt;src))
		return;

	nbp = newIPICMP(sz);
	np = (IPICMP *)nbp-&gt;rp;
	if(ipv6anylocal(ifc, np-&gt;src))
		netlog(f, Logicmp, "send icmppkttoobig6 -&gt; src %I dst %I\n",
			p-&gt;src, p-&gt;dst);
	else {
		netlog(f, Logicmp, "icmppkttoobig6 fail -&gt; src %I dst %I\n",
			p-&gt;src, p-&gt;dst);
		return;
	}

	memmove(np-&gt;dst, p-&gt;src, IPaddrlen);
	np-&gt;type = PacketTooBigV6;
	np-&gt;code = 0;
	hnputl(np-&gt;icmpid, ifc-&gt;maxtu - ifc-&gt;m-&gt;hsize);
	memmove(nbp-&gt;rp + IPICMPSZ, bp-&gt;rp, sz - IPICMPSZ);
	set_cksum(nbp);
	np-&gt;ttl = HOP_LIMIT;
	np-&gt;vcf[0] = 0x06 &lt;&lt; 4;
	ipriv-&gt;out[PacketTooBigV6]++;
	ipoput6(f, nbp, 0, MAXTTL, DFLTTOS, nil);
}

/*
 * RFC 2461, pages 39-40, pages 57-58.
 */
static int
valid(Proto *icmp, Ipifc *, Block *bp, Icmppriv6 *ipriv)
{
	int sz, osz, unsp, n, ttl, iplen, pktsz;
	uchar *packet;
	IPICMP *p;
	Ndpkt *np;

	n = blocklen(bp);
	if(n &lt; IPICMPSZ) {
		ipriv-&gt;stats[HlenErrs6]++;
		netlog(icmp-&gt;f, Logicmp, "icmp hlen %d\n", n);
		goto err;
	}

	packet = bp-&gt;rp;
	p = (IPICMP *)packet;
	pktsz = BLEN(bp);
	iplen = nhgets(p-&gt;ploadlen);
	if(iplen &gt; n - IP6HDR) {
		ipriv-&gt;stats[LenErrs6]++;
		netlog(icmp-&gt;f, Logicmp, "icmp length %d\n", iplen);
		goto err;
	}

	/* Rather than construct explicit pseudoheader, overwrite IPv6 header */
	if(p-&gt;proto != ICMPv6) {
		/* This code assumes no extension headers!!! */
		netlog(icmp-&gt;f, Logicmp, "icmp error: extension header\n");
		goto err;
	}
	memset(packet, 0, 4);
	ttl = p-&gt;ttl;
	p-&gt;ttl = p-&gt;proto;
	p-&gt;proto = 0;
	if(ptclcsum(bp, 0, iplen + IP6HDR)) {
		ipriv-&gt;stats[CsumErrs6]++;
		netlog(icmp-&gt;f, Logicmp, "icmp checksum error\n");
		goto err;
	}
	p-&gt;proto = p-&gt;ttl;
	p-&gt;ttl = ttl;

	/* additional tests for some pkt types */
	if (p-&gt;type != NbrSolicit   &amp;&amp; p-&gt;type != NbrAdvert &amp;&amp;
	    p-&gt;type != RouterAdvert &amp;&amp; p-&gt;type != RouterSolicit &amp;&amp;
	    p-&gt;type != RedirectV6)
		return 1;	/* TODO: unknown, presumed valid; why? */
	if(p-&gt;ttl != HOP_LIMIT) {
		ipriv-&gt;stats[HoplimErrs6]++;
		goto err;
	}
	if(p-&gt;code != 0) {
		ipriv-&gt;stats[IcmpCodeErrs6]++;
		goto err;
	}

	switch (p-&gt;type) {
	case NbrSolicit:
	case NbrAdvert:
		np = (Ndpkt*) p;
		if(isv6mcast(np-&gt;target)) {
			ipriv-&gt;stats[TargetErrs6]++;
			goto err;
		}
		if(optexsts(np) &amp;&amp; np-&gt;olen == 0) {
			ipriv-&gt;stats[OptlenErrs6]++;
			goto err;
		}
		if (p-&gt;type == NbrSolicit &amp;&amp; ipcmp(np-&gt;src, v6Unspecified) == 0)
			if(!issmcast(np-&gt;dst) || optexsts(np)) {
				ipriv-&gt;stats[AddrmxpErrs6]++;
				goto err;
			}
		if(p-&gt;type == NbrAdvert &amp;&amp; isv6mcast(np-&gt;dst) &amp;&amp;
		    nhgets(np-&gt;icmpid) &amp; Sflag){
			ipriv-&gt;stats[AddrmxpErrs6]++;
			goto err;
		}
		break;
	case RouterAdvert:
		if(pktsz - IP6HDR &lt; 16) {
			ipriv-&gt;stats[HlenErrs6]++;
			goto err;
		}
		if(!islinklocal(p-&gt;src)) {
			ipriv-&gt;stats[RouterAddrErrs6]++;
			goto err;
		}
		for (sz = IPICMPSZ + 8; sz+1 &lt; pktsz; sz += 8*osz) {
			osz = packet[sz+1];
			if(osz &lt;= 0) {
				ipriv-&gt;stats[OptlenErrs6]++;
				goto err;
			}
		}
		break;
	case RouterSolicit:
		if(pktsz - IP6HDR &lt; 8) {
			ipriv-&gt;stats[HlenErrs6]++;
			goto err;
		}
		unsp = (ipcmp(p-&gt;src, v6Unspecified) == 0);
		for (sz = IPICMPSZ + 8; sz+1 &lt; pktsz; sz += 8*osz) {
			osz = packet[sz+1];
			if(osz &lt;= 0 || (unsp &amp;&amp; packet[sz] == SRC_LLADDR)) {
				ipriv-&gt;stats[OptlenErrs6]++;
				goto err;
			}
		}
		break;
	case RedirectV6:
		/* TODO: fill in */
		break;
	default:
		goto err;
	}
	return 1;
err:
	ipriv-&gt;stats[InErrors6]++;
	return 0;
}

static int
targettype(Fs *f, Ipifc *ifc, uchar *target)
{
	Iplifc *lifc;
	int t;

	rlock(ifc);
	if(ipproxyifc(f, ifc, target)) {
		runlock(ifc);
		return Tuniproxy;
	}

	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next)
		if(ipcmp(lifc-&gt;local, target) == 0) {
			t = (lifc-&gt;tentative)? Tunitent: Tunirany;
			runlock(ifc);
			return t;
		}

	runlock(ifc);
	return 0;
}

/* bp needs to be freed with freeblist or passed on. */
static void
icmpiput6(Proto *icmp, Ipifc *ipifc, Block *bp)
{
	int type;
	char *msg, m2[128];
	uchar pktflags;
	uchar *packet, *src;
	uchar lsrc[IPaddrlen];
	Block *r;
	IPICMP *p;
	Icmppriv6 *ipriv;
	Iplifc *lifc;
	Ndpkt* np;
	Proto *pr;

	packet = bp-&gt;rp;
	p = (IPICMP *)packet;
	type = p-&gt;type;
	ipriv = icmp-&gt;priv;
	if(!valid(icmp, ipifc, bp, ipriv) || type &gt; Maxtype6)
		goto raise;

	ipriv-&gt;in[type]++;
	switch(type) {
	case EchoRequestV6:
		bp = concatblock(bp);
		r = mkechoreply6(bp, ipifc);
		if(r == nil)
			goto raise;
		ipriv-&gt;out[EchoReply]++;
		ipoput6(icmp-&gt;f, r, 0, MAXTTL, DFLTTOS, nil);
		break;
	case UnreachableV6:
		if(p-&gt;code &gt;= nelem(unreachcode))
			msg = unreachcode[Icmp6_unknown];
		else
			msg = unreachcode[p-&gt;code];

		bp-&gt;rp += IPICMPSZ;
		if(blocklen(bp) &lt; 8){
			ipriv-&gt;stats[LenErrs6]++;
			goto raise;
		}
		p = (IPICMP *)bp-&gt;rp;
		pr = Fsrcvpcolx(icmp-&gt;f, p-&gt;proto);
		if(pr != nil &amp;&amp; pr-&gt;advise != nil) {
			(*pr-&gt;advise)(pr, bp, msg);
			return;
		}

		bp-&gt;rp -= IPICMPSZ;
		goticmpkt6(icmp, bp, 0);
		break;
	case TimeExceedV6:
		if(p-&gt;code == 0){
			snprint(m2, sizeof m2, "ttl exceeded at %I", p-&gt;src);
			bp-&gt;rp += IPICMPSZ;
			if(blocklen(bp) &lt; 8){
				ipriv-&gt;stats[LenErrs6]++;
				goto raise;
			}
			p = (IPICMP *)bp-&gt;rp;
			pr = Fsrcvpcolx(icmp-&gt;f, p-&gt;proto);
			if(pr &amp;&amp; pr-&gt;advise) {
				(*pr-&gt;advise)(pr, bp, m2);
				return;
			}
			bp-&gt;rp -= IPICMPSZ;
		}
		goticmpkt6(icmp, bp, 0);
		break;
	case RouterAdvert:
	case RouterSolicit:
		/* using lsrc as a temp, munge hdr for goticmp6 */
		if (0) {
			memmove(lsrc, p-&gt;src, IPaddrlen);
			memmove(p-&gt;src, p-&gt;dst, IPaddrlen);
			memmove(p-&gt;dst, lsrc, IPaddrlen);
		}
		goticmpkt6(icmp, bp, type);
		break;
	case NbrSolicit:
		np = (Ndpkt*)p;			/* within bp */
		pktflags = 0;
		switch (targettype(icmp-&gt;f, ipifc, np-&gt;target)) {
		case Tunirany:
			pktflags |= Oflag;
			/* fall through */
		case Tuniproxy:
			if(ipcmp(np-&gt;src, v6Unspecified) != 0) {
				arpenter(icmp-&gt;f, V6, np-&gt;src, np-&gt;lnaddr,
					8*np-&gt;olen-2, 0);
				pktflags |= Sflag;
			}
			if(ipv6local(ipifc, lsrc)) {
				src = np-&gt;src;
				if(ipcmp(src, v6Unspecified) == 0)
					src = v6allnodesL;
				icmpna(icmp-&gt;f, lsrc, src, np-&gt;target,
					ipifc-&gt;mac, pktflags);
			}
			break;
		case Tunitent:
			/*
			 * not clear what needs to be done.  send up
			 * an icmp mesg saying `don't use this address'?
			 */
			break;
		}
		freeblist(bp);
		break;
	case NbrAdvert:
		/*
		 * if the target address matches one of the local interface
		 * addresses and the local interface address has tentative bit
		 * set, insert into ARP table. this is so the duplicate address
		 * detection part of ipconfig can discover duplication through
		 * the arp table.
		 */
		np = (Ndpkt*)p;			/* within bp */
		lifc = iplocalonifc(ipifc, np-&gt;target);
		arpenter(icmp-&gt;f, V6, np-&gt;target, np-&gt;lnaddr, 8*np-&gt;olen-2,
			lifc &amp;&amp; lifc-&gt;tentative);
		freeblist(bp);
		break;
	case PacketTooBigV6:
	default:
		goticmpkt6(icmp, bp, 0);
		break;
	}
	return;

raise:
	freeblist(bp);
}

int
icmpstats6(Proto *icmp6, char *buf, int len)
{
	Icmppriv6 *priv;
	char *p, *e;
	int i;

	priv = icmp6-&gt;priv;
	p = buf;
	e = p+len;
	for(i = 0; i &lt; Nstats6; i++)
		p = seprint(p, e, "%s: %lud\n", statnames6[i], priv-&gt;stats[i]);
	for(i = 0; i &lt;= Maxtype6; i++)
		if(icmpnames6[i])
			p = seprint(p, e, "%s: %lud %lud\n", icmpnames6[i],
				priv-&gt;in[i], priv-&gt;out[i]);
		else if (0)
			p = seprint(p, e, "%d: %lud %lud\n", i, priv-&gt;in[i],
				priv-&gt;out[i]);
	return p - buf;
}

/* import from icmp.c */
extern int	icmpstate(Conv *c, char *state, int n);
extern char*	icmpannounce(Conv *c, char **argv, int argc);
extern char*	icmpconnect(Conv *c, char **argv, int argc);
extern void	icmpclose(Conv *c);

void
icmp6init(Fs *fs)
{
	Proto *icmp6 = smalloc(sizeof(Proto));

	icmp6-&gt;priv = smalloc(sizeof(Icmppriv6));
	icmp6-&gt;name = "icmpv6";
	icmp6-&gt;connect = icmpconnect;
	icmp6-&gt;announce = icmpannounce;
	icmp6-&gt;state = icmpstate;
	icmp6-&gt;create = icmpcreate6;
	icmp6-&gt;close = icmpclose;
	icmp6-&gt;rcv = icmpiput6;
	icmp6-&gt;stats = icmpstats6;
	icmp6-&gt;ctl = icmpctl6;
	icmp6-&gt;advise = icmpadvise6;
	icmp6-&gt;gc = nil;
	icmp6-&gt;ipproto = ICMPv6;
	icmp6-&gt;nc = 16;
	icmp6-&gt;ptclsize = sizeof(Icmpcb6);

	Fsproto(fs, icmp6);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

