<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/ipifc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/ipifc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ip.h"
#include "ipv6.h"

#define DPRINT if(0)print

enum {
	Maxmedia	= 32,
	Nself		= Maxmedia*5,
	NHASH		= 1&lt;&lt;6,
	NCACHE		= 256,
	QMAX		= 192*1024-1,
	Maxv6repr	= (128/(4*4))*(4+1), /* limit of xxxx:xxxx:⋯ notation */
};

Medium *media[Maxmedia] = { 0 };

/*
 *  cache of local addresses (addresses we answer to)
 */
struct Ipself
{
	uchar	a[IPaddrlen];
	Ipself	*hnext;		/* next address in the hash table */
	Iplink	*link;		/* binding twixt Ipself and Ipifc */
	ulong	expire;
	uchar	type;		/* type of address */
	int	ref;
	Ipself	*next;		/* free list */
};

struct Ipselftab
{
	QLock;
	int	inited;
	int	acceptall;	/* true if an interface has the null address */
	Ipself	*hash[NHASH];	/* hash chains */
};

/*
 *  Multicast addresses are chained onto a Chan so that
 *  we can remove them when the Chan is closed.
 */
typedef struct Ipmcast Ipmcast;
struct Ipmcast
{
	Ipmcast	*next;
	uchar	ma[IPaddrlen];	/* multicast address */
	uchar	ia[IPaddrlen];	/* interface address */
};

/* quick hash for ip addresses */
#define hashipa(a) ( ( ((a)[IPaddrlen-2]&lt;&lt;8) | (a)[IPaddrlen-1] )%NHASH )

static char tifc[] = "ifc ";

static void	addselfcache(Fs *f, Ipifc *ifc, Iplifc *lifc, uchar *a, int type);
static void	remselfcache(Fs *f, Ipifc *ifc, Iplifc *lifc, uchar *a);
static char*	ipifcjoinmulti(Ipifc *ifc, char **argv, int argc);
static char*	ipifcleavemulti(Ipifc *ifc, char **argv, int argc);
static void	ipifcregisterproxy(Fs*, Ipifc*, uchar*);
static char*	ipifcremlifc(Ipifc*, Iplifc*);

/*
 *  link in a new medium
 */
void
addipmedium(Medium *med)
{
	int i;

	for(i = 0; i &lt; nelem(media)-1; i++)
		if(media[i] == nil){
			media[i] = med;
			break;
		}
}

/*
 *  find the medium with this name
 */
Medium*
ipfindmedium(char *name)
{
	Medium **mp;

	for(mp = media; *mp != nil; mp++)
		if(strcmp((*mp)-&gt;name, name) == 0)
			break;
	return *mp;
}

/*
 *  attach a device (or pkt driver) to the interface.
 *  called with c locked
 */
static char*
ipifcbind(Conv *c, char **argv, int argc)
{
	Ipifc *ifc;
	Medium *m;

	if(argc &lt; 2)
		return Ebadarg;

	ifc = (Ipifc*)c-&gt;ptcl;

	/* bind the device to the interface */
	m = ipfindmedium(argv[1]);
	if(m == nil)
		return "unknown interface type";

	wlock(ifc);
	if(ifc-&gt;m != nil){
		wunlock(ifc);
		return "interface already bound";
	}
	if(waserror()){
		wunlock(ifc);
		nexterror();
	}

	/* do medium specific binding */
	(*m-&gt;bind)(ifc, argc, argv);

	/* set the bound device name */
	if(argc &gt; 2)
		strncpy(ifc-&gt;dev, argv[2], sizeof(ifc-&gt;dev));
	else
		snprint(ifc-&gt;dev, sizeof ifc-&gt;dev, "%s%d", m-&gt;name, c-&gt;x);
	ifc-&gt;dev[sizeof(ifc-&gt;dev)-1] = 0;

	/* set up parameters */
	ifc-&gt;m = m;
	ifc-&gt;mintu = ifc-&gt;m-&gt;mintu;
	ifc-&gt;maxtu = ifc-&gt;m-&gt;maxtu;
	if(ifc-&gt;m-&gt;unbindonclose == 0)
		ifc-&gt;conv-&gt;inuse++;
	ifc-&gt;rp.mflag = 0;		/* default not managed */
	ifc-&gt;rp.oflag = 0;
	ifc-&gt;rp.maxraint = 600000;	/* millisecs */
	ifc-&gt;rp.minraint = 200000;
	ifc-&gt;rp.linkmtu = 0;		/* no mtu sent */
	ifc-&gt;rp.reachtime = 0;
	ifc-&gt;rp.rxmitra = 0;
	ifc-&gt;rp.ttl = MAXTTL;
	ifc-&gt;rp.routerlt = 3 * ifc-&gt;rp.maxraint;

	/* any ancillary structures (like routes) no longer pertain */
	ifc-&gt;ifcid++;

	/* reopen all the queues closed by a previous unbind */
	qreopen(c-&gt;rq);
	qreopen(c-&gt;eq);
	qreopen(c-&gt;sq);

	wunlock(ifc);
	poperror();

	return nil;
}

/*
 *  detach a device from an interface, close the interface
 *  called with ifc-&gt;conv closed
 */
static char*
ipifcunbind(Ipifc *ifc)
{
	char *err;

	if(waserror()){
		wunlock(ifc);
		nexterror();
	}
	wlock(ifc);

	/* dissociate routes */
	if(ifc-&gt;m != nil &amp;&amp; ifc-&gt;m-&gt;unbindonclose == 0)
		ifc-&gt;conv-&gt;inuse--;
	ifc-&gt;ifcid++;

	/* disassociate logical interfaces (before zeroing ifc-&gt;arg) */
	while(ifc-&gt;lifc){
		err = ipifcremlifc(ifc, ifc-&gt;lifc);
		/*
		 * note: err non-zero means lifc not found,
		 * which can't happen in this case.
		 */
		if(err)
			error(err);
	}

	/* disassociate device */
	if(ifc-&gt;m &amp;&amp; ifc-&gt;m-&gt;unbind)
		(*ifc-&gt;m-&gt;unbind)(ifc);
	memset(ifc-&gt;dev, 0, sizeof(ifc-&gt;dev));
	ifc-&gt;arg = nil;
	ifc-&gt;reassemble = 0;

	/* close queues to stop queuing of packets */
	qclose(ifc-&gt;conv-&gt;rq);
	qclose(ifc-&gt;conv-&gt;wq);
	qclose(ifc-&gt;conv-&gt;sq);

	ifc-&gt;m = nil;
	wunlock(ifc);
	poperror();
	return nil;
}

char sfixedformat[] = "device %s maxtu %d sendra %d recvra %d mflag %d oflag"
" %d maxraint %d minraint %d linkmtu %d reachtime %d rxmitra %d ttl %d routerlt"
" %d pktin %lud pktout %lud errin %lud errout %lud\n";

char slineformat[] = "	%-40I %-10M %-40I %-12lud %-12lud\n";

static int
ipifcstate(Conv *c, char *state, int n)
{
	Ipifc *ifc;
	Iplifc *lifc;
	int m;

	ifc = (Ipifc*)c-&gt;ptcl;
	m = snprint(state, n, sfixedformat,
		ifc-&gt;dev, ifc-&gt;maxtu, ifc-&gt;sendra6, ifc-&gt;recvra6,
		ifc-&gt;rp.mflag, ifc-&gt;rp.oflag, ifc-&gt;rp.maxraint,
		ifc-&gt;rp.minraint, ifc-&gt;rp.linkmtu, ifc-&gt;rp.reachtime,
		ifc-&gt;rp.rxmitra, ifc-&gt;rp.ttl, ifc-&gt;rp.routerlt,
		ifc-&gt;in, ifc-&gt;out, ifc-&gt;inerr, ifc-&gt;outerr);

	rlock(ifc);
	for(lifc = ifc-&gt;lifc; lifc &amp;&amp; n &gt; m; lifc = lifc-&gt;next)
		m += snprint(state+m, n - m, slineformat, lifc-&gt;local,
			lifc-&gt;mask, lifc-&gt;remote, lifc-&gt;validlt, lifc-&gt;preflt);
	if(ifc-&gt;lifc == nil)
		m += snprint(state+m, n - m, "\n");
	runlock(ifc);
	return m;
}

static int
ipifclocal(Conv *c, char *state, int n)
{
	Ipifc *ifc;
	Iplifc *lifc;
	Iplink *link;
	int m;

	ifc = (Ipifc*)c-&gt;ptcl;
	m = 0;

	rlock(ifc);
	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
		m += snprint(state+m, n - m, "%-40.40I -&gt;", lifc-&gt;local);
		for(link = lifc-&gt;link; link; link = link-&gt;lifclink)
			m += snprint(state+m, n - m, " %-40.40I", link-&gt;self-&gt;a);
		m += snprint(state+m, n - m, "\n");
	}
	runlock(ifc);
	return m;
}

static int
ipifcinuse(Conv *c)
{
	Ipifc *ifc;

	ifc = (Ipifc*)c-&gt;ptcl;
	return ifc-&gt;m != nil;
}

/*
 *  called when a process writes to an interface's 'data'
 */
static void
ipifckick(void *x)
{
	Conv *c = x;
	Block *bp;
	Ipifc *ifc;

	bp = qget(c-&gt;wq);
	if(bp == nil)
		return;

	ifc = (Ipifc*)c-&gt;ptcl;
	if(!canrlock(ifc)){
		freeb(bp);
		return;
	}
	if(waserror()){
		runlock(ifc);
		nexterror();
	}
	if(ifc-&gt;m == nil || ifc-&gt;m-&gt;pktin == nil)
		freeb(bp);
	else
		(*ifc-&gt;m-&gt;pktin)(c-&gt;p-&gt;f, ifc, bp);
	runlock(ifc);
	poperror();
}

/*
 *  called when a new ipifc structure is created
 */
static void
ipifccreate(Conv *c)
{
	Ipifc *ifc;

	c-&gt;rq = qopen(QMAX, 0, 0, 0);
	c-&gt;sq = qopen(QMAX, 0, 0, 0);
	c-&gt;wq = qopen(QMAX, Qkick, ipifckick, c);
	ifc = (Ipifc*)c-&gt;ptcl;
	ifc-&gt;conv = c;
	ifc-&gt;unbinding = 0;
	ifc-&gt;m = nil;
	ifc-&gt;reassemble = 0;
}

/*
 *  called after last close of ipifc data or ctl
 *  called with c locked, we must unlock
 */
static void
ipifcclose(Conv *c)
{
	Ipifc *ifc;
	Medium *m;

	ifc = (Ipifc*)c-&gt;ptcl;
	m = ifc-&gt;m;
	if(m &amp;&amp; m-&gt;unbindonclose)
		ipifcunbind(ifc);
}

/*
 *  change an interface's mtu
 */
char*
ipifcsetmtu(Ipifc *ifc, char **argv, int argc)
{
	int mtu;

	if(argc &lt; 2 || ifc-&gt;m == nil)
		return Ebadarg;
	mtu = strtoul(argv[1], 0, 0);
	if(mtu &lt; ifc-&gt;m-&gt;mintu || mtu &gt; ifc-&gt;m-&gt;maxtu)
		return Ebadarg;
	ifc-&gt;maxtu = mtu;
	return nil;
}

/*
 *  add an address to an interface.
 */
char*
ipifcadd(Ipifc *ifc, char **argv, int argc, int tentative, Iplifc *lifcp)
{
	int i, type, mtu, sendnbrdisc = 0;
	uchar ip[IPaddrlen], mask[IPaddrlen], rem[IPaddrlen];
	uchar bcast[IPaddrlen], net[IPaddrlen];
	Iplifc *lifc, **l;
	Fs *f;

	if(ifc-&gt;m == nil)
		return "ipifc not yet bound to device";

	f = ifc-&gt;conv-&gt;p-&gt;f;

	type = Rifc;
	memset(ip, 0, IPaddrlen);
	memset(mask, 0, IPaddrlen);
	memset(rem, 0, IPaddrlen);
	switch(argc){
	case 6:
		if(strcmp(argv[5], "proxy") == 0)
			type |= Rproxy;
		/* fall through */
	case 5:
		mtu = strtoul(argv[4], 0, 0);
		if(mtu &gt;= ifc-&gt;m-&gt;mintu &amp;&amp; mtu &lt;= ifc-&gt;m-&gt;maxtu)
			ifc-&gt;maxtu = mtu;
		/* fall through */
	case 4:
		if (parseip(ip, argv[1]) == -1 || parseip(rem, argv[3]) == -1)
			return Ebadip;
		parseipmask(mask, argv[2]);
		maskip(rem, mask, net);
		break;
	case 3:
		if (parseip(ip, argv[1]) == -1)
			return Ebadip;
		parseipmask(mask, argv[2]);
		maskip(ip, mask, rem);
		maskip(rem, mask, net);
		break;
	case 2:
		if (parseip(ip, argv[1]) == -1)
			return Ebadip;
		memmove(mask, defmask(ip), IPaddrlen);
		maskip(ip, mask, rem);
		maskip(rem, mask, net);
		break;
	default:
		return Ebadarg;
	}
	if(isv4(ip))
		tentative = 0;
	wlock(ifc);

	/* ignore if this is already a local address for this ifc */
	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next) {
		if(ipcmp(lifc-&gt;local, ip) == 0) {
			if(lifc-&gt;tentative != tentative)
				lifc-&gt;tentative = tentative;
			if(lifcp) {
				lifc-&gt;onlink = lifcp-&gt;onlink;
				lifc-&gt;autoflag = lifcp-&gt;autoflag;
				lifc-&gt;validlt = lifcp-&gt;validlt;
				lifc-&gt;preflt = lifcp-&gt;preflt;
				lifc-&gt;origint = lifcp-&gt;origint;
			}
			goto out;
		}
	}

	/* add the address to the list of logical ifc's for this ifc */
	lifc = smalloc(sizeof(Iplifc));
	ipmove(lifc-&gt;local, ip);
	ipmove(lifc-&gt;mask, mask);
	ipmove(lifc-&gt;remote, rem);
	ipmove(lifc-&gt;net, net);
	lifc-&gt;tentative = tentative;
	if(lifcp) {
		lifc-&gt;onlink = lifcp-&gt;onlink;
		lifc-&gt;autoflag = lifcp-&gt;autoflag;
		lifc-&gt;validlt = lifcp-&gt;validlt;
		lifc-&gt;preflt = lifcp-&gt;preflt;
		lifc-&gt;origint = lifcp-&gt;origint;
	} else {		/* default values */
		lifc-&gt;onlink = lifc-&gt;autoflag = 1;
		lifc-&gt;validlt = lifc-&gt;preflt = ~0L;
		lifc-&gt;origint = NOW / 1000;
	}
	lifc-&gt;next = nil;

	for(l = &amp;ifc-&gt;lifc; *l; l = &amp;(*l)-&gt;next)
		;
	*l = lifc;

	/* check for point-to-point interface */
	if(ipcmp(ip, v6loopback)) /* skip v6 loopback, it's a special address */
	if(ipcmp(mask, IPallbits) == 0)
		type |= Rptpt;

	/* add local routes */
	if(isv4(ip))
		v4addroute(f, tifc, rem+IPv4off, mask+IPv4off, rem+IPv4off, type);
	else
		v6addroute(f, tifc, rem, mask, rem, type);

	addselfcache(f, ifc, lifc, ip, Runi);

	if((type &amp; (Rproxy|Rptpt)) == (Rproxy|Rptpt)){
		ipifcregisterproxy(f, ifc, rem);
		goto out;
	}

	if(isv4(ip) || ipcmp(ip, IPnoaddr) == 0) {
		/* add subnet directed broadcast address to the self cache */
		for(i = 0; i &lt; IPaddrlen; i++)
			bcast[i] = (ip[i] &amp; mask[i]) | ~mask[i];
		addselfcache(f, ifc, lifc, bcast, Rbcast);

		/* add subnet directed network address to the self cache */
		for(i = 0; i &lt; IPaddrlen; i++)
			bcast[i] = (ip[i] &amp; mask[i]) &amp; mask[i];
		addselfcache(f, ifc, lifc, bcast, Rbcast);

		/* add network directed broadcast address to the self cache */
		memmove(mask, defmask(ip), IPaddrlen);
		for(i = 0; i &lt; IPaddrlen; i++)
			bcast[i] = (ip[i] &amp; mask[i]) | ~mask[i];
		addselfcache(f, ifc, lifc, bcast, Rbcast);

		/* add network directed network address to the self cache */
		memmove(mask, defmask(ip), IPaddrlen);
		for(i = 0; i &lt; IPaddrlen; i++)
			bcast[i] = (ip[i] &amp; mask[i]) &amp; mask[i];
		addselfcache(f, ifc, lifc, bcast, Rbcast);

		addselfcache(f, ifc, lifc, IPv4bcast, Rbcast);
	}
	else {
		if(ipcmp(ip, v6loopback) == 0) {
			/* add node-local mcast address */
			addselfcache(f, ifc, lifc, v6allnodesN, Rmulti);

			/* add route for all node multicast */
			v6addroute(f, tifc, v6allnodesN, v6allnodesNmask,
				v6allnodesN, Rmulti);
		}

		/* add all nodes multicast address */
		addselfcache(f, ifc, lifc, v6allnodesL, Rmulti);

		/* add route for all nodes multicast */
		v6addroute(f, tifc, v6allnodesL, v6allnodesLmask, v6allnodesL,
			Rmulti);

		/* add solicited-node multicast address */
		ipv62smcast(bcast, ip);
		addselfcache(f, ifc, lifc, bcast, Rmulti);

		sendnbrdisc = 1;
	}

	/* register the address on this network for address resolution */
	if(isv4(ip) &amp;&amp; ifc-&gt;m-&gt;areg != nil)
		(*ifc-&gt;m-&gt;areg)(ifc, ip);

out:
	wunlock(ifc);
	if(tentative &amp;&amp; sendnbrdisc)
		icmpns(f, 0, SRC_UNSPEC, ip, TARG_MULTI, ifc-&gt;mac);
	return nil;
}

/*
 *  remove a logical interface from an ifc
 *  always called with ifc wlock'd
 */
static char*
ipifcremlifc(Ipifc *ifc, Iplifc *lifc)
{
	Iplifc **l;
	Fs *f;

	f = ifc-&gt;conv-&gt;p-&gt;f;

	/*
	 *  find address on this interface and remove from chain.
	 *  for pt to pt we actually specify the remote address as the
	 *  addresss to remove.
	 */
	for(l = &amp;ifc-&gt;lifc; *l != nil &amp;&amp; *l != lifc; l = &amp;(*l)-&gt;next)
		;
	if(*l == nil)
		return "address not on this interface";
	*l = lifc-&gt;next;

	/* disassociate any addresses */
	while(lifc-&gt;link)
		remselfcache(f, ifc, lifc, lifc-&gt;link-&gt;self-&gt;a);

	/* remove the route for this logical interface */
	if(isv4(lifc-&gt;local))
		v4delroute(f, lifc-&gt;remote+IPv4off, lifc-&gt;mask+IPv4off, 1);
	else {
		v6delroute(f, lifc-&gt;remote, lifc-&gt;mask, 1);
		if(ipcmp(lifc-&gt;local, v6loopback) == 0)
			/* remove route for all node multicast */
			v6delroute(f, v6allnodesN, v6allnodesNmask, 1);
		else if(memcmp(lifc-&gt;local, v6linklocal, v6llpreflen) == 0)
			/* remove route for all link multicast */
			v6delroute(f, v6allnodesL, v6allnodesLmask, 1);
	}

	free(lifc);
	return nil;
}

/*
 *  remove an address from an interface.
 *  called with c-&gt;car locked
 */
char*
ipifcrem(Ipifc *ifc, char **argv, int argc)
{
	char *rv;
	uchar ip[IPaddrlen], mask[IPaddrlen], rem[IPaddrlen];
	Iplifc *lifc;

	if(argc &lt; 3)
		return Ebadarg;

	if (parseip(ip, argv[1]) == -1)
		return Ebadip;
	parseipmask(mask, argv[2]);
	if(argc &lt; 4)
		maskip(ip, mask, rem);
	else
		if (parseip(rem, argv[3]) == -1)
			return Ebadip;

	wlock(ifc);

	/*
	 *  find address on this interface and remove from chain.
	 *  for pt to pt we actually specify the remote address as the
	 *  addresss to remove.
	 */
	for(lifc = ifc-&gt;lifc; lifc != nil; lifc = lifc-&gt;next) {
		if (memcmp(ip, lifc-&gt;local, IPaddrlen) == 0
		&amp;&amp; memcmp(mask, lifc-&gt;mask, IPaddrlen) == 0
		&amp;&amp; memcmp(rem, lifc-&gt;remote, IPaddrlen) == 0)
			break;
	}

	rv = ipifcremlifc(ifc, lifc);
	wunlock(ifc);
	return rv;
}

/*
 * distribute routes to active interfaces like the
 * TRIP linecards
 */
void
ipifcaddroute(Fs *f, int vers, uchar *addr, uchar *mask, uchar *gate, int type)
{
	Medium *m;
	Conv **cp, **e;
	Ipifc *ifc;

	e = &amp;f-&gt;ipifc-&gt;conv[f-&gt;ipifc-&gt;nc];
	for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
		if(*cp != nil) {
			ifc = (Ipifc*)(*cp)-&gt;ptcl;
			m = ifc-&gt;m;
			if(m &amp;&amp; m-&gt;addroute)
				m-&gt;addroute(ifc, vers, addr, mask, gate, type);
		}
	}
}

void
ipifcremroute(Fs *f, int vers, uchar *addr, uchar *mask)
{
	Medium *m;
	Conv **cp, **e;
	Ipifc *ifc;

	e = &amp;f-&gt;ipifc-&gt;conv[f-&gt;ipifc-&gt;nc];
	for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
		if(*cp != nil) {
			ifc = (Ipifc*)(*cp)-&gt;ptcl;
			m = ifc-&gt;m;
			if(m &amp;&amp; m-&gt;remroute)
				m-&gt;remroute(ifc, vers, addr, mask);
		}
	}
}

/*
 *  associate an address with the interface.  This wipes out any previous
 *  addresses.  This is a macro that means, remove all the old interfaces
 *  and add a new one.
 */
static char*
ipifcconnect(Conv* c, char **argv, int argc)
{
	char *err;
	Ipifc *ifc;

	ifc = (Ipifc*)c-&gt;ptcl;

	if(ifc-&gt;m == nil)
		 return "ipifc not yet bound to device";

	if(waserror()){
		wunlock(ifc);
		nexterror();
	}
	wlock(ifc);
	while(ifc-&gt;lifc){
		err = ipifcremlifc(ifc, ifc-&gt;lifc);
		if(err)
			error(err);
	}
	wunlock(ifc);
	poperror();

	err = ipifcadd(ifc, argv, argc, 0, nil);
	if(err)
		return err;

	Fsconnected(c, nil);
	return nil;
}

char*
ipifcra6(Ipifc *ifc, char **argv, int argc)
{
	int i, argsleft, vmax = ifc-&gt;rp.maxraint, vmin = ifc-&gt;rp.minraint;

	argsleft = argc - 1;
	i = 1;

	if(argsleft % 2 != 0)
		return Ebadarg;

	while (argsleft &gt; 1) {
		if(strcmp(argv[i], "recvra") == 0)
			ifc-&gt;recvra6 = (atoi(argv[i+1]) != 0);
		else if(strcmp(argv[i], "sendra") == 0)
			ifc-&gt;sendra6 = (atoi(argv[i+1]) != 0);
		else if(strcmp(argv[i], "mflag") == 0)
			ifc-&gt;rp.mflag = (atoi(argv[i+1]) != 0);
		else if(strcmp(argv[i], "oflag") == 0)
			ifc-&gt;rp.oflag = (atoi(argv[i+1]) != 0);
		else if(strcmp(argv[i], "maxraint") == 0)
			ifc-&gt;rp.maxraint = atoi(argv[i+1]);
		else if(strcmp(argv[i], "minraint") == 0)
			ifc-&gt;rp.minraint = atoi(argv[i+1]);
		else if(strcmp(argv[i], "linkmtu") == 0)
			ifc-&gt;rp.linkmtu = atoi(argv[i+1]);
		else if(strcmp(argv[i], "reachtime") == 0)
			ifc-&gt;rp.reachtime = atoi(argv[i+1]);
		else if(strcmp(argv[i], "rxmitra") == 0)
			ifc-&gt;rp.rxmitra = atoi(argv[i+1]);
		else if(strcmp(argv[i], "ttl") == 0)
			ifc-&gt;rp.ttl = atoi(argv[i+1]);
		else if(strcmp(argv[i], "routerlt") == 0)
			ifc-&gt;rp.routerlt = atoi(argv[i+1]);
		else
			return Ebadarg;

		argsleft -= 2;
		i += 2;
	}

	/* consistency check */
	if(ifc-&gt;rp.maxraint &lt; ifc-&gt;rp.minraint) {
		ifc-&gt;rp.maxraint = vmax;
		ifc-&gt;rp.minraint = vmin;
		return Ebadarg;
	}
	return nil;
}

/*
 *  non-standard control messages.
 *  called with c-&gt;car locked.
 */
static char*
ipifcctl(Conv* c, char**argv, int argc)
{
	Ipifc *ifc;
	int i;

	ifc = (Ipifc*)c-&gt;ptcl;
	if(strcmp(argv[0], "add") == 0)
		return ipifcadd(ifc, argv, argc, 0, nil);
	else if(strcmp(argv[0], "try") == 0)
		return ipifcadd(ifc, argv, argc, 1, nil);
	else if(strcmp(argv[0], "remove") == 0)
		return ipifcrem(ifc, argv, argc);
	else if(strcmp(argv[0], "unbind") == 0)
		return ipifcunbind(ifc);
	else if(strcmp(argv[0], "joinmulti") == 0)
		return ipifcjoinmulti(ifc, argv, argc);
	else if(strcmp(argv[0], "leavemulti") == 0)
		return ipifcleavemulti(ifc, argv, argc);
	else if(strcmp(argv[0], "mtu") == 0)
		return ipifcsetmtu(ifc, argv, argc);
	else if(strcmp(argv[0], "reassemble") == 0){
		ifc-&gt;reassemble = 1;
		return nil;
	}
	else if(strcmp(argv[0], "iprouting") == 0){
		i = 1;
		if(argc &gt; 1)
			i = atoi(argv[1]);
		iprouting(c-&gt;p-&gt;f, i);
		return nil;
	}
	else if(strcmp(argv[0], "add6") == 0)
		return ipifcadd6(ifc, argv, argc);
	else if(strcmp(argv[0], "ra6") == 0)
		return ipifcra6(ifc, argv, argc);
	return "unsupported ctl";
}

int
ipifcstats(Proto *ipifc, char *buf, int len)
{
	return ipstats(ipifc-&gt;f, buf, len);
}

void
ipifcinit(Fs *f)
{
	Proto *ipifc;

	ipifc = smalloc(sizeof(Proto));
	ipifc-&gt;name = "ipifc";
	ipifc-&gt;connect = ipifcconnect;
	ipifc-&gt;announce = nil;
	ipifc-&gt;bind = ipifcbind;
	ipifc-&gt;state = ipifcstate;
	ipifc-&gt;create = ipifccreate;
	ipifc-&gt;close = ipifcclose;
	ipifc-&gt;rcv = nil;
	ipifc-&gt;ctl = ipifcctl;
	ipifc-&gt;advise = nil;
	ipifc-&gt;stats = ipifcstats;
	ipifc-&gt;inuse = ipifcinuse;
	ipifc-&gt;local = ipifclocal;
	ipifc-&gt;ipproto = -1;
	ipifc-&gt;nc = Maxmedia;
	ipifc-&gt;ptclsize = sizeof(Ipifc);

	f-&gt;ipifc = ipifc;	/* hack for ipifcremroute, findipifc, ... */
	f-&gt;self = smalloc(sizeof(Ipselftab));	/* hack for ipforme */

	Fsproto(f, ipifc);
}

/*
 *  add to self routing cache
 *	called with c-&gt;car locked
 */
static void
addselfcache(Fs *f, Ipifc *ifc, Iplifc *lifc, uchar *a, int type)
{
	Ipself *p;
	Iplink *lp;
	int h;

	qlock(f-&gt;self);

	/* see if the address already exists */
	h = hashipa(a);
	for(p = f-&gt;self-&gt;hash[h]; p; p = p-&gt;next)
		if(memcmp(a, p-&gt;a, IPaddrlen) == 0)
			break;

	/* allocate a local address and add to hash chain */
	if(p == nil){
		p = smalloc(sizeof(*p));
		ipmove(p-&gt;a, a);
		p-&gt;type = type;
		p-&gt;next = f-&gt;self-&gt;hash[h];
		f-&gt;self-&gt;hash[h] = p;

		/* if the null address, accept all packets */
		if(ipcmp(a, v4prefix) == 0 || ipcmp(a, IPnoaddr) == 0)
			f-&gt;self-&gt;acceptall = 1;
	}

	/* look for a link for this lifc */
	for(lp = p-&gt;link; lp; lp = lp-&gt;selflink)
		if(lp-&gt;lifc == lifc)
			break;

	/* allocate a lifc-to-local link and link to both */
	if(lp == nil){
		lp = smalloc(sizeof(*lp));
		lp-&gt;ref = 1;
		lp-&gt;lifc = lifc;
		lp-&gt;self = p;
		lp-&gt;selflink = p-&gt;link;
		p-&gt;link = lp;
		lp-&gt;lifclink = lifc-&gt;link;
		lifc-&gt;link = lp;

		/* add to routing table */
		if(isv4(a))
			v4addroute(f, tifc, a+IPv4off, IPallbits+IPv4off,
				a+IPv4off, type);
		else
			v6addroute(f, tifc, a, IPallbits, a, type);

		if((type &amp; Rmulti) &amp;&amp; ifc-&gt;m-&gt;addmulti != nil)
			(*ifc-&gt;m-&gt;addmulti)(ifc, a, lifc-&gt;local);
	} else
		lp-&gt;ref++;

	qunlock(f-&gt;self);
}

/*
 *  These structures are unlinked from their chains while
 *  other threads may be using them.  To avoid excessive locking,
 *  just put them aside for a while before freeing them.
 *	called with f-&gt;self locked
 */
static Iplink *freeiplink;
static Ipself *freeipself;

static void
iplinkfree(Iplink *p)
{
	Iplink **l, *np;
	ulong now = NOW;

	l = &amp;freeiplink;
	for(np = *l; np; np = *l){
		if(np-&gt;expire &gt; now){
			*l = np-&gt;next;
			free(np);
			continue;
		}
		l = &amp;np-&gt;next;
	}
	p-&gt;expire = now + 5000;	/* give other threads 5 secs to get out */
	p-&gt;next = nil;
	*l = p;
}

static void
ipselffree(Ipself *p)
{
	Ipself **l, *np;
	ulong now = NOW;

	l = &amp;freeipself;
	for(np = *l; np; np = *l){
		if(np-&gt;expire &gt; now){
			*l = np-&gt;next;
			free(np);
			continue;
		}
		l = &amp;np-&gt;next;
	}
	p-&gt;expire = now + 5000;	/* give other threads 5 secs to get out */
	p-&gt;next = nil;
	*l = p;
}

/*
 *  Decrement reference for this address on this link.
 *  Unlink from selftab if this is the last ref.
 *	called with c-&gt;car locked
 */
static void
remselfcache(Fs *f, Ipifc *ifc, Iplifc *lifc, uchar *a)
{
	Ipself *p, **l;
	Iplink *link, **l_self, **l_lifc;

	qlock(f-&gt;self);

	/* find the unique selftab entry */
	l = &amp;f-&gt;self-&gt;hash[hashipa(a)];
	for(p = *l; p; p = *l){
		if(ipcmp(p-&gt;a, a) == 0)
			break;
		l = &amp;p-&gt;next;
	}

	if(p == nil)
		goto out;

	/*
	 *  walk down links from an ifc looking for one
	 *  that matches the selftab entry
	 */
	l_lifc = &amp;lifc-&gt;link;
	for(link = *l_lifc; link; link = *l_lifc){
		if(link-&gt;self == p)
			break;
		l_lifc = &amp;link-&gt;lifclink;
	}

	if(link == nil)
		goto out;

	/*
	 *  walk down the links from the selftab looking for
	 *  the one we just found
	 */
	l_self = &amp;p-&gt;link;
	for(link = *l_self; link; link = *l_self){
		if(link == *l_lifc)
			break;
		l_self = &amp;link-&gt;selflink;
	}

	if(link == nil)
		panic("remselfcache");

	if(--(link-&gt;ref) != 0)
		goto out;

	if((p-&gt;type &amp; Rmulti) &amp;&amp; ifc-&gt;m-&gt;remmulti != nil)
		(*ifc-&gt;m-&gt;remmulti)(ifc, a, lifc-&gt;local);

	/* ref == 0, remove from both chains and free the link */
	*l_lifc = link-&gt;lifclink;
	*l_self = link-&gt;selflink;
	iplinkfree(link);

	if(p-&gt;link != nil)
		goto out;

	/* remove from routing table */
	if(isv4(a))
		v4delroute(f, a+IPv4off, IPallbits+IPv4off, 1);
	else
		v6delroute(f, a, IPallbits, 1);

	/* no more links, remove from hash and free */
	*l = p-&gt;next;
	ipselffree(p);

	/* if IPnoaddr, forget */
	if(ipcmp(a, v4prefix) == 0 || ipcmp(a, IPnoaddr) == 0)
		f-&gt;self-&gt;acceptall = 0;

out:
	qunlock(f-&gt;self);
}

static char *stformat = "%-44.44I %2.2d %4.4s\n";
enum
{
	Nstformat= 41,
};

long
ipselftabread(Fs *f, char *cp, ulong offset, int n)
{
	int i, m, nifc, off;
	Ipself *p;
	Iplink *link;
	char state[8];

	m = 0;
	off = offset;
	qlock(f-&gt;self);
	for(i = 0; i &lt; NHASH &amp;&amp; m &lt; n; i++){
		for(p = f-&gt;self-&gt;hash[i]; p != nil &amp;&amp; m &lt; n; p = p-&gt;next){
			nifc = 0;
			for(link = p-&gt;link; link; link = link-&gt;selflink)
				nifc++;
			routetype(p-&gt;type, state);
			m += snprint(cp + m, n - m, stformat, p-&gt;a, nifc, state);
			if(off &gt; 0){
				off -= m;
				m = 0;
			}
		}
	}
	qunlock(f-&gt;self);
	return m;
}

int
iptentative(Fs *f, uchar *addr)
{
 	Ipself *p;

	p = f-&gt;self-&gt;hash[hashipa(addr)];
	for(; p; p = p-&gt;next){
		if(ipcmp(addr, p-&gt;a) == 0)
			return p-&gt;link-&gt;lifc-&gt;tentative;
	}
	return 0;
}

/*
 *  returns
 *	0		- no match
 *	Runi
 *	Rbcast
 *	Rmcast
 */
int
ipforme(Fs *f, uchar *addr)
{
	Ipself *p;

	p = f-&gt;self-&gt;hash[hashipa(addr)];
	for(; p; p = p-&gt;next){
		if(ipcmp(addr, p-&gt;a) == 0)
			return p-&gt;type;
	}

	/* hack to say accept anything */
	if(f-&gt;self-&gt;acceptall)
		return Runi;
	return 0;
}

/*
 *  find the ifc on same net as the remote system.  If none,
 *  return nil.
 */
Ipifc*
findipifc(Fs *f, uchar *remote, int type)
{
	Ipifc *ifc, *x;
	Iplifc *lifc;
	Conv **cp, **e;
	uchar gnet[IPaddrlen], xmask[IPaddrlen];

	x = nil;
	memset(xmask, 0, IPaddrlen);

	/* find most specific match */
	e = &amp;f-&gt;ipifc-&gt;conv[f-&gt;ipifc-&gt;nc];
	for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
		if(*cp == 0)
			continue;
		ifc = (Ipifc*)(*cp)-&gt;ptcl;
		for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
			maskip(remote, lifc-&gt;mask, gnet);
			if(ipcmp(gnet, lifc-&gt;net) == 0){
				if(x == nil || ipcmp(lifc-&gt;mask, xmask) &gt; 0){
					x = ifc;
					ipmove(xmask, lifc-&gt;mask);
				}
			}
		}
	}
	if(x != nil)
		return x;

	/* for now for broadcast and multicast, just use first interface */
	if(type &amp; (Rbcast|Rmulti)){
		for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
			if(*cp == 0)
				continue;
			ifc = (Ipifc*)(*cp)-&gt;ptcl;
			if(ifc-&gt;lifc != nil)
				return ifc;
		}
	}
	return nil;
}

enum {
	unknownv6,		/* UGH */
//	multicastv6,
	unspecifiedv6,
	linklocalv6,
	globalv6,
};

int
v6addrtype(uchar *addr)
{
	if(isv4(addr) || ipcmp(addr, IPnoaddr) == 0)
		return unknownv6;
	else if(islinklocal(addr) ||
	    isv6mcast(addr) &amp;&amp; (addr[1] &amp; 0xF) &lt;= Link_local_scop)
		return linklocalv6;
	else
		return globalv6;
}

#define v6addrcurr(lifc) ((lifc)-&gt;preflt == ~0L || \
			(lifc)-&gt;origint + (lifc)-&gt;preflt &gt;= NOW/1000)

static void
findprimaryipv6(Fs *f, uchar *local)
{
	int atype, atypel;
	Conv **cp, **e;
	Ipifc *ifc;
	Iplifc *lifc;

	ipmove(local, v6Unspecified);
	atype = unspecifiedv6;

	/*
	 * find "best" (global &gt; link local &gt; unspecified)
	 * local address; address must be current.
	 */
	e = &amp;f-&gt;ipifc-&gt;conv[f-&gt;ipifc-&gt;nc];
	for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
		if(*cp == 0)
			continue;
		ifc = (Ipifc*)(*cp)-&gt;ptcl;
		for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
			atypel = v6addrtype(lifc-&gt;local);
			if(atypel &gt; atype &amp;&amp; v6addrcurr(lifc)) {
				ipmove(local, lifc-&gt;local);
				atype = atypel;
				if(atype == globalv6)
					return;
			}
		}
	}
}

/*
 *  returns first ip address configured
 */
static void
findprimaryipv4(Fs *f, uchar *local)
{
	Conv **cp, **e;
	Ipifc *ifc;
	Iplifc *lifc;

	/* find first ifc local address */
	e = &amp;f-&gt;ipifc-&gt;conv[f-&gt;ipifc-&gt;nc];
	for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
		if(*cp == 0)
			continue;
		ifc = (Ipifc*)(*cp)-&gt;ptcl;
		if((lifc = ifc-&gt;lifc) != nil){
			ipmove(local, lifc-&gt;local);
			return;
		}
	}
}

/*
 *  find the local address 'closest' to the remote system, copy it to
 *  local and return the ifc for that address
 */
void
findlocalip(Fs *f, uchar *local, uchar *remote)
{
	int version, atype = unspecifiedv6, atypel = unknownv6;
	int atyper, deprecated;
	uchar gate[IPaddrlen], gnet[IPaddrlen];
	Ipifc *ifc;
	Iplifc *lifc;
	Route *r;

	USED(atype);
	USED(atypel);
	qlock(f-&gt;ipifc);
	r = v6lookup(f, remote, nil);
 	version = (memcmp(remote, v4prefix, IPv4off) == 0)? V4: V6;

	if(r != nil){
		ifc = r-&gt;ifc;
		if(r-&gt;type &amp; Rv4)
			v4tov6(gate, r-&gt;v4.gate);
		else {
			ipmove(gate, r-&gt;v6.gate);
			ipmove(local, v6Unspecified);
		}

		switch(version) {
		case V4:
			/* find ifc address closest to the gateway to use */
			for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
				maskip(gate, lifc-&gt;mask, gnet);
				if(ipcmp(gnet, lifc-&gt;net) == 0){
					ipmove(local, lifc-&gt;local);
					goto out;
				}
			}
			break;
		case V6:
			/* find ifc address with scope matching the destination */
			atyper = v6addrtype(remote);
			deprecated = 0;
			for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
				atypel = v6addrtype(lifc-&gt;local);
				/* prefer appropriate scope */
				if(atypel &gt; atype &amp;&amp; atype &lt; atyper ||
				   atypel &lt; atype &amp;&amp; atype &gt; atyper){
					ipmove(local, lifc-&gt;local);
					deprecated = !v6addrcurr(lifc);
					atype = atypel;
				} else if(atypel == atype){
					/* avoid deprecated addresses */
					if(deprecated &amp;&amp; v6addrcurr(lifc)){
						ipmove(local, lifc-&gt;local);
						atype = atypel;
						deprecated = 0;
					}
				}
				if(atype == atyper &amp;&amp; !deprecated)
					goto out;
			}
			if(atype &gt;= atyper)
				goto out;
			break;
		default:
			panic("findlocalip: version %d", version);
		}
	}

	switch(version){
	case V4:
		findprimaryipv4(f, local);
		break;
	case V6:
		findprimaryipv6(f, local);
		break;
	default:
		panic("findlocalip2: version %d", version);
	}

out:
	qunlock(f-&gt;ipifc);
}

/*
 *  return first v4 address associated with an interface
 */
int
ipv4local(Ipifc *ifc, uchar *addr)
{
	Iplifc *lifc;

	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
		if(isv4(lifc-&gt;local)){
			memmove(addr, lifc-&gt;local+IPv4off, IPv4addrlen);
			return 1;
		}
	}
	return 0;
}

/*
 *  return first v6 address associated with an interface
 */
int
ipv6local(Ipifc *ifc, uchar *addr)
{
	Iplifc *lifc;

	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
		if(!isv4(lifc-&gt;local) &amp;&amp; !(lifc-&gt;tentative)){
			ipmove(addr, lifc-&gt;local);
			return 1;
		}
	}
	return 0;
}

int
ipv6anylocal(Ipifc *ifc, uchar *addr)
{
	Iplifc *lifc;

	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
		if(!isv4(lifc-&gt;local)){
			ipmove(addr, lifc-&gt;local);
			return SRC_UNI;
		}
	}
	return SRC_UNSPEC;
}

/*
 *  see if this address is bound to the interface
 */
Iplifc*
iplocalonifc(Ipifc *ifc, uchar *ip)
{
	Iplifc *lifc;

	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next)
		if(ipcmp(ip, lifc-&gt;local) == 0)
			return lifc;
	return nil;
}


/*
 *  See if we're proxying for this address on this interface
 */
int
ipproxyifc(Fs *f, Ipifc *ifc, uchar *ip)
{
	Route *r;
	uchar net[IPaddrlen];
	Iplifc *lifc;

	/* see if this is a direct connected pt to pt address */
	r = v6lookup(f, ip, nil);
	if(r == nil || (r-&gt;type &amp; (Rifc|Rproxy)) != (Rifc|Rproxy))
		return 0;

	/* see if this is on the right interface */
	for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
		maskip(ip, lifc-&gt;mask, net);
		if(ipcmp(net, lifc-&gt;remote) == 0)
			return 1;
	}
	return 0;
}

/*
 *  return multicast version if any
 */
int
ipismulticast(uchar *ip)
{
	if(isv4(ip)){
		if(ip[IPv4off] &gt;= 0xe0 &amp;&amp; ip[IPv4off] &lt; 0xf0)
			return V4;
	}
	else if(ip[0] == 0xff)
		return V6;
	return 0;
}
int
ipisbm(uchar *ip)
{
	if(isv4(ip)){
		if(ip[IPv4off] &gt;= 0xe0 &amp;&amp; ip[IPv4off] &lt; 0xf0)
			return V4;
		else if(ipcmp(ip, IPv4bcast) == 0)
			return V4;
	}
	else if(ip[0] == 0xff)
		return V6;
	return 0;
}


/*
 *  add a multicast address to an interface, called with c-&gt;car locked
 */
void
ipifcaddmulti(Conv *c, uchar *ma, uchar *ia)
{
	Ipifc *ifc;
	Iplifc *lifc;
	Conv **p;
	Ipmulti *multi, **l;
	Fs *f;

	f = c-&gt;p-&gt;f;

	for(l = &amp;c-&gt;multi; *l; l = &amp;(*l)-&gt;next)
		if(ipcmp(ma, (*l)-&gt;ma) == 0 &amp;&amp; ipcmp(ia, (*l)-&gt;ia) == 0)
			return;		/* it's already there */

	multi = *l = smalloc(sizeof(*multi));
	ipmove(multi-&gt;ma, ma);
	ipmove(multi-&gt;ia, ia);
	multi-&gt;next = nil;

	for(p = f-&gt;ipifc-&gt;conv; *p; p++){
		if((*p)-&gt;inuse == 0)
			continue;
		ifc = (Ipifc*)(*p)-&gt;ptcl;
		if(waserror()){
			wunlock(ifc);
			nexterror();
		}
		wlock(ifc);
		for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next)
			if(ipcmp(ia, lifc-&gt;local) == 0)
				addselfcache(f, ifc, lifc, ma, Rmulti);
		wunlock(ifc);
		poperror();
	}
}


/*
 *  remove a multicast address from an interface, called with c-&gt;car locked
 */
void
ipifcremmulti(Conv *c, uchar *ma, uchar *ia)
{
	Ipmulti *multi, **l;
	Iplifc *lifc;
	Conv **p;
	Ipifc *ifc;
	Fs *f;

	f = c-&gt;p-&gt;f;

	for(l = &amp;c-&gt;multi; *l; l = &amp;(*l)-&gt;next)
		if(ipcmp(ma, (*l)-&gt;ma) == 0 &amp;&amp; ipcmp(ia, (*l)-&gt;ia) == 0)
			break;

	multi = *l;
	if(multi == nil)
		return; 	/* we don't have it open */

	*l = multi-&gt;next;

	for(p = f-&gt;ipifc-&gt;conv; *p; p++){
		if((*p)-&gt;inuse == 0)
			continue;

		ifc = (Ipifc*)(*p)-&gt;ptcl;
		if(waserror()){
			wunlock(ifc);
			nexterror();
		}
		wlock(ifc);
		for(lifc = ifc-&gt;lifc; lifc; lifc = lifc-&gt;next)
			if(ipcmp(ia, lifc-&gt;local) == 0)
				remselfcache(f, ifc, lifc, ma);
		wunlock(ifc);
		poperror();
	}

	free(multi);
}

/*
 *  make lifc's join and leave multicast groups
 */
static char*
ipifcjoinmulti(Ipifc *ifc, char **argv, int argc)
{
	USED(ifc, argv, argc);
	return nil;
}

static char*
ipifcleavemulti(Ipifc *ifc, char **argv, int argc)
{
	USED(ifc, argv, argc);
	return nil;
}

static void
ipifcregisterproxy(Fs *f, Ipifc *ifc, uchar *ip)
{
	Conv **cp, **e;
	Ipifc *nifc;
	Iplifc *lifc;
	Medium *m;
	uchar net[IPaddrlen];

	/* register the address on any network that will proxy for us */
	e = &amp;f-&gt;ipifc-&gt;conv[f-&gt;ipifc-&gt;nc];

	if(!isv4(ip)) {				/* V6 */
		for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
			if(*cp == nil || (nifc = (Ipifc*)(*cp)-&gt;ptcl) == ifc)
				continue;
			rlock(nifc);
			m = nifc-&gt;m;
			if(m == nil || m-&gt;addmulti == nil) {
				runlock(nifc);
				continue;
			}
			for(lifc = nifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
				maskip(ip, lifc-&gt;mask, net);
				if(ipcmp(net, lifc-&gt;remote) == 0) {
					/* add solicited-node multicast addr */
					ipv62smcast(net, ip);
					addselfcache(f, nifc, lifc, net, Rmulti);
					arpenter(f, V6, ip, nifc-&gt;mac, 6, 0);
					// (*m-&gt;addmulti)(nifc, net, ip);
					break;
				}
			}
			runlock(nifc);
		}
	}
	else {					/* V4 */
		for(cp = f-&gt;ipifc-&gt;conv; cp &lt; e; cp++){
			if(*cp == nil || (nifc = (Ipifc*)(*cp)-&gt;ptcl) == ifc)
				continue;
			rlock(nifc);
			m = nifc-&gt;m;
			if(m == nil || m-&gt;areg == nil){
				runlock(nifc);
				continue;
			}
			for(lifc = nifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
				maskip(ip, lifc-&gt;mask, net);
				if(ipcmp(net, lifc-&gt;remote) == 0){
					(*m-&gt;areg)(nifc, ip);
					break;
				}
			}
			runlock(nifc);
		}
	}
}


/* added for new v6 mesg types */
static void
adddefroute6(Fs *f, uchar *gate, int force)
{
	Route *r;

	r = v6lookup(f, v6Unspecified, nil);
	/*
	 * route entries generated by all other means take precedence
	 * over router announcements.
	 */
	if (r &amp;&amp; !force &amp;&amp; strcmp(r-&gt;tag, "ra") != 0)
		return;

	v6delroute(f, v6Unspecified, v6Unspecified, 1);
	v6addroute(f, "ra", v6Unspecified, v6Unspecified, gate, 0);
}

enum {
	Ngates = 3,
};

char*
ipifcadd6(Ipifc *ifc, char**argv, int argc)
{
	int plen = 64;
	long origint = NOW / 1000, preflt = ~0L, validlt = ~0L;
	char addr[Maxv6repr], preflen[6];
	char *params[3];
	uchar autoflag = 1, onlink = 1;
	uchar prefix[IPaddrlen];
	Iplifc *lifc;

	switch(argc) {
	case 7:
		preflt = atoi(argv[6]);
		/* fall through */
	case 6:
		validlt = atoi(argv[5]);
		/* fall through */
	case 5:
		autoflag = atoi(argv[4]);
		/* fall through */
	case 4:
		onlink = atoi(argv[3]);
		/* fall through */
	case 3:
		plen = atoi(argv[2]);
		/* fall through */
	case 2:
		break;
	default:
		return Ebadarg;
	}

	if (parseip(prefix, argv[1]) != 6)
		return "bad ipv6 address";
	if (validlt &lt; preflt)
		return "valid ipv6 lifetime less than preferred lifetime";
	if (plen &lt; 0)
		return "negative ipv6 prefix length";
	/* i think that this length limit is bogus - geoff */
//	if (plen &gt; 64)
//		return "ipv6 prefix length greater than 64;
	if (islinklocal(prefix))
		return "ipv6 prefix is link-local";

	lifc = smalloc(sizeof(Iplifc));
	lifc-&gt;onlink = (onlink != 0);
	lifc-&gt;autoflag = (autoflag != 0);
	lifc-&gt;validlt = validlt;
	lifc-&gt;preflt = preflt;
	lifc-&gt;origint = origint;

	/* issue "add" ctl msg for v6 link-local addr and prefix len */
	if(!ifc-&gt;m-&gt;pref2addr)
		return "no pref2addr on interface";
	ifc-&gt;m-&gt;pref2addr(prefix, ifc-&gt;mac);	/* mac → v6 link-local addr */
	snprint(addr, sizeof addr, "%I", prefix);
	snprint(preflen, sizeof preflen, "/%d", plen);
	params[0] = "add";
	params[1] = addr;
	params[2] = preflen;

	return ipifcadd(ifc, params, 3, 0, lifc);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

