<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/ipmux.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/ipmux.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * IP packet filter
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ip.h"
#include "ipv6.h"

typedef struct Ipmuxrock  Ipmuxrock;
typedef struct Ipmux      Ipmux;

typedef struct Myip4hdr Myip4hdr;
struct Myip4hdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* ip-&gt;identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;		/* Time to live */
	uchar	proto;		/* Protocol */
	uchar	cksum[2];	/* Header checksum */
	uchar	src[4];		/* IP source */
	uchar	dst[4];		/* IP destination */

	uchar	data[1];	/* start of data */
};
Myip4hdr *ipoff = 0;

enum
{
	Tproto,
	Tdata,
	Tiph,
	Tdst,
	Tsrc,
	Tifc,

	Cother = 0,
	Cbyte,		/* single byte */
	Cmbyte,		/* single byte with mask */
	Cshort,		/* single short */
	Cmshort,	/* single short with mask */
	Clong,		/* single long */
	Cmlong,		/* single long with mask */
	Cifc,
	Cmifc,
};

char *ftname[] =
{
[Tproto]	"proto",
[Tdata]		"data",
[Tiph]	 	"iph",
[Tdst]		"dst",
[Tsrc]		"src",
[Tifc]		"ifc",
};

/*
 *  a node in the decision tree
 */
struct Ipmux
{
	Ipmux	*yes;
	Ipmux	*no;
	uchar	type;		/* type of field(Txxxx) */
	uchar	ctype;		/* tupe of comparison(Cxxxx) */
	uchar	len;		/* length in bytes of item to compare */
	uchar	n;		/* number of items val points to */
	short	off;		/* offset of comparison */
	short	eoff;		/* end offset of comparison */
	uchar	skiphdr;	/* should offset start after ipheader */
	uchar	*val;
	uchar	*mask;
	uchar	*e;		/* val+n*len*/

	int	ref;		/* so we can garbage collect */
	Conv	*conv;
};

/*
 *  someplace to hold per conversation data
 */
struct Ipmuxrock
{
	Ipmux	*chain;
};

static int	ipmuxsprint(Ipmux*, int, char*, int);
static void	ipmuxkick(void *x);

static char*
skipwhite(char *p)
{
	while(*p == ' ' || *p == '\t')
		p++;
	return p;
}

static char*
follows(char *p, char c)
{
	char *f;

	f = strchr(p, c);
	if(f == nil)
		return nil;
	*f++ = 0;
	f = skipwhite(f);
	if(*f == 0)
		return nil;
	return f;
}

static Ipmux*
parseop(char **pp)
{
	char *p = *pp;
	int type, off, end, len;
	Ipmux *f;

	p = skipwhite(p);
	if(strncmp(p, "dst", 3) == 0){
		type = Tdst;
		off = (ulong)(ipoff-&gt;dst);
		len = IPv4addrlen;
		p += 3;
	}
	else if(strncmp(p, "src", 3) == 0){
		type = Tsrc;
		off = (ulong)(ipoff-&gt;src);
		len = IPv4addrlen;
		p += 3;
	}
	else if(strncmp(p, "ifc", 3) == 0){
		type = Tifc;
		off = -IPv4addrlen;
		len = IPv4addrlen;
		p += 3;
	}
	else if(strncmp(p, "proto", 5) == 0){
		type = Tproto;
		off = (ulong)&amp;(ipoff-&gt;proto);
		len = 1;
		p += 5;
	}
	else if(strncmp(p, "data", 4) == 0 || strncmp(p, "iph", 3) == 0){
		if(strncmp(p, "data", 4) == 0) {
			type = Tdata;
			p += 4;
		}
		else {
			type = Tiph;
			p += 3;
		}
		p = skipwhite(p);
		if(*p != '[')
			return nil;
		p++;
		off = strtoul(p, &amp;p, 0);
		if(off &lt; 0 || off &gt; (64-IP4HDR))
			return nil;
		p = skipwhite(p);
		if(*p != ':')
			end = off;
		else {
			p++;
			p = skipwhite(p);
			end = strtoul(p, &amp;p, 0);
			if(end &lt; off)
				return nil;
			p = skipwhite(p);
		}
		if(*p != ']')
			return nil;
		p++;
		len = end - off + 1;
	}
	else
		return nil;

	f = smalloc(sizeof(*f));
	f-&gt;type = type;
	f-&gt;len = len;
	f-&gt;off = off;
	f-&gt;val = nil;
	f-&gt;mask = nil;
	f-&gt;n = 1;
	f-&gt;ref = 1;
	if(type == Tdata)
		f-&gt;skiphdr = 1;
	else
		f-&gt;skiphdr = 0;

	return f;
}

static int
htoi(char x)
{
	if(x &gt;= '0' &amp;&amp; x &lt;= '9')
		x -= '0';
	else if(x &gt;= 'a' &amp;&amp; x &lt;= 'f')
		x -= 'a' - 10;
	else if(x &gt;= 'A' &amp;&amp; x &lt;= 'F')
		x -= 'A' - 10;
	else
		x = 0;
	return x;
}

static int
hextoi(char *p)
{
	return (htoi(p[0])&lt;&lt;4) | htoi(p[1]);
}

static void
parseval(uchar *v, char *p, int len)
{
	while(*p &amp;&amp; len-- &gt; 0){
		*v++ = hextoi(p);
		p += 2;
	}
}

static Ipmux*
parsemux(char *p)
{
	int n, nomask;
	Ipmux *f;
	char *val;
	char *mask;
	char *vals[20];
	uchar *v;

	/* parse operand */
	f = parseop(&amp;p);
	if(f == nil)
		return nil;

	/* find value */
	val = follows(p, '=');
	if(val == nil)
		goto parseerror;

	/* parse mask */
	mask = follows(p, '&amp;');
	if(mask != nil){
		switch(f-&gt;type){
		case Tsrc:
		case Tdst:
		case Tifc:
			f-&gt;mask = smalloc(f-&gt;len);
			v4parseip(f-&gt;mask, mask);
			break;
		case Tdata:
		case Tiph:
			f-&gt;mask = smalloc(f-&gt;len);
			parseval(f-&gt;mask, mask, f-&gt;len);
			break;
		default:
			goto parseerror;
		}
		nomask = 0;
	} else {
		nomask = 1;
		f-&gt;mask = smalloc(f-&gt;len);
		memset(f-&gt;mask, 0xff, f-&gt;len);
	}

	/* parse vals */
	f-&gt;n = getfields(val, vals, sizeof(vals)/sizeof(char*), 1, "|");
	if(f-&gt;n == 0)
		goto parseerror;
	f-&gt;val = smalloc(f-&gt;n*f-&gt;len);
	v = f-&gt;val;
	for(n = 0; n &lt; f-&gt;n; n++){
		switch(f-&gt;type){
		case Tsrc:
		case Tdst:
		case Tifc:
			v4parseip(v, vals[n]);
			break;
		case Tproto:
		case Tdata:
		case Tiph:
			parseval(v, vals[n], f-&gt;len);
			break;
		}
		v += f-&gt;len;
	}

	f-&gt;eoff = f-&gt;off + f-&gt;len;
	f-&gt;e = f-&gt;val + f-&gt;n*f-&gt;len;
	f-&gt;ctype = Cother;
	if(f-&gt;n == 1){
		switch(f-&gt;len){
		case 1:
			f-&gt;ctype = nomask ? Cbyte : Cmbyte;
			break;
		case 2:
			f-&gt;ctype = nomask ? Cshort : Cmshort;
			break;
		case 4:
			if(f-&gt;type == Tifc)
				f-&gt;ctype = nomask ? Cifc : Cmifc;
			else
				f-&gt;ctype = nomask ? Clong : Cmlong;
			break;
		}
	}
	return f;

parseerror:
	if(f-&gt;mask)
		free(f-&gt;mask);
	if(f-&gt;val)
		free(f-&gt;val);
	free(f);
	return nil;
}

/*
 *  Compare relative ordering of two ipmuxs.  This doesn't compare the
 *  values, just the fields being looked at.
 *
 *  returns:	&lt;0 if a is a more specific match
 *		 0 if a and b are matching on the same fields
 *		&gt;0 if b is a more specific match
 */
static int
ipmuxcmp(Ipmux *a, Ipmux *b)
{
	int n;

	/* compare types, lesser ones are more important */
	n = a-&gt;type - b-&gt;type;
	if(n != 0)
		return n;

	/* compare offsets, call earlier ones more specific */
	n = (a-&gt;off+((int)a-&gt;skiphdr)*(ulong)ipoff-&gt;data) -
		(b-&gt;off+((int)b-&gt;skiphdr)*(ulong)ipoff-&gt;data);
	if(n != 0)
		return n;

	/* compare match lengths, longer ones are more specific */
	n = b-&gt;len - a-&gt;len;
	if(n != 0)
		return n;

	/*
	 *  if we get here we have two entries matching
	 *  the same bytes of the record.  Now check
	 *  the mask for equality.  Longer masks are
	 *  more specific.
	 */
	if(a-&gt;mask != nil &amp;&amp; b-&gt;mask == nil)
		return -1;
	if(a-&gt;mask == nil &amp;&amp; b-&gt;mask != nil)
		return 1;
	if(a-&gt;mask != nil &amp;&amp; b-&gt;mask != nil){
		n = memcmp(b-&gt;mask, a-&gt;mask, a-&gt;len);
		if(n != 0)
			return n;
	}
	return 0;
}

/*
 *  Compare the values of two ipmuxs.  We're assuming that ipmuxcmp
 *  returned 0 comparing them.
 */
static int
ipmuxvalcmp(Ipmux *a, Ipmux *b)
{
	int n;

	n = b-&gt;len*b-&gt;n - a-&gt;len*a-&gt;n;
	if(n != 0)
		return n;
	return memcmp(a-&gt;val, b-&gt;val, a-&gt;len*a-&gt;n);
}

/*
 *  add onto an existing ipmux chain in the canonical comparison
 *  order
 */
static void
ipmuxchain(Ipmux **l, Ipmux *f)
{
	for(; *l; l = &amp;(*l)-&gt;yes)
		if(ipmuxcmp(f, *l) &lt; 0)
			break;
	f-&gt;yes = *l;
	*l = f;
}

/*
 *  copy a tree
 */
static Ipmux*
ipmuxcopy(Ipmux *f)
{
	Ipmux *nf;

	if(f == nil)
		return nil;
	nf = smalloc(sizeof *nf);
	*nf = *f;
	nf-&gt;no = ipmuxcopy(f-&gt;no);
	nf-&gt;yes = ipmuxcopy(f-&gt;yes);
	nf-&gt;val = smalloc(f-&gt;n*f-&gt;len);
	nf-&gt;e = nf-&gt;val + f-&gt;len*f-&gt;n;
	memmove(nf-&gt;val, f-&gt;val, f-&gt;n*f-&gt;len);
	return nf;
}

static void
ipmuxfree(Ipmux *f)
{
	if(f-&gt;val != nil)
		free(f-&gt;val);
	free(f);
}

static void
ipmuxtreefree(Ipmux *f)
{
	if(f == nil)
		return;
	if(f-&gt;no != nil)
		ipmuxfree(f-&gt;no);
	if(f-&gt;yes != nil)
		ipmuxfree(f-&gt;yes);
	ipmuxfree(f);
}

/*
 *  merge two trees
 */
static Ipmux*
ipmuxmerge(Ipmux *a, Ipmux *b)
{
	int n;
	Ipmux *f;

	if(a == nil)
		return b;
	if(b == nil)
		return a;
	n = ipmuxcmp(a, b);
	if(n &lt; 0){
		f = ipmuxcopy(b);
		a-&gt;yes = ipmuxmerge(a-&gt;yes, b);
		a-&gt;no = ipmuxmerge(a-&gt;no, f);
		return a;
	}
	if(n &gt; 0){
		f = ipmuxcopy(a);
		b-&gt;yes = ipmuxmerge(b-&gt;yes, a);
		b-&gt;no = ipmuxmerge(b-&gt;no, f);
		return b;
	}
	if(ipmuxvalcmp(a, b) == 0){
		a-&gt;yes = ipmuxmerge(a-&gt;yes, b-&gt;yes);
		a-&gt;no = ipmuxmerge(a-&gt;no, b-&gt;no);
		a-&gt;ref++;
		ipmuxfree(b);
		return a;
	}
	a-&gt;no = ipmuxmerge(a-&gt;no, b);
	return a;
}

/*
 *  remove a chain from a demux tree.  This is like merging accept that
 *  we remove instead of insert.
 */
static int
ipmuxremove(Ipmux **l, Ipmux *f)
{
	int n, rv;
	Ipmux *ft;

	if(f == nil)
		return 0;		/* we've removed it all */
	if(*l == nil)
		return -1;

	ft = *l;
	n = ipmuxcmp(ft, f);
	if(n &lt; 0){
		/* *l is maching an earlier field, descend both paths */
		rv = ipmuxremove(&amp;ft-&gt;yes, f);
		rv += ipmuxremove(&amp;ft-&gt;no, f);
		return rv;
	}
	if(n &gt; 0){
		/* f represents an earlier field than *l, this should be impossible */
		return -1;
	}

	/* if we get here f and *l are comparing the same fields */
	if(ipmuxvalcmp(ft, f) != 0){
		/* different values mean mutually exclusive */
		return ipmuxremove(&amp;ft-&gt;no, f);
	}

	/* we found a match */
	if(--(ft-&gt;ref) == 0){
		/*
		 *  a dead node implies the whole yes side is also dead.
		 *  since our chain is constrained to be on that side,
		 *  we're done.
		 */
		ipmuxtreefree(ft-&gt;yes);
		*l = ft-&gt;no;
		ipmuxfree(ft);
		return 0;
	}

	/*
	 *  free the rest of the chain.  it is constrained to match the
	 *  yes side.
	 */
	return ipmuxremove(&amp;ft-&gt;yes, f-&gt;yes);
}

/*
 *  connection request is a semi separated list of filters
 *  e.g. proto=17;data[0:4]=11aa22bb;ifc=135.104.9.2&amp;255.255.255.0
 *
 *  there's no protection against overlapping specs.
 */
static char*
ipmuxconnect(Conv *c, char **argv, int argc)
{
	int i, n;
	char *field[10];
	Ipmux *mux, *chain;
	Ipmuxrock *r;
	Fs *f;

	f = c-&gt;p-&gt;f;

	if(argc != 2)
		return Ebadarg;

	n = getfields(argv[1], field, nelem(field), 1, ";");
	if(n &lt;= 0)
		return Ebadarg;

	chain = nil;
	mux = nil;
	for(i = 0; i &lt; n; i++){
		mux = parsemux(field[i]);
		if(mux == nil){
			ipmuxtreefree(chain);
			return Ebadarg;
		}
		ipmuxchain(&amp;chain, mux);
	}
	if(chain == nil)
		return Ebadarg;
	mux-&gt;conv = c;

	/* save a copy of the chain so we can later remove it */
	mux = ipmuxcopy(chain);
	r = (Ipmuxrock*)(c-&gt;ptcl);
	r-&gt;chain = chain;

	/* add the chain to the protocol demultiplexor tree */
	wlock(f);
	f-&gt;ipmux-&gt;priv = ipmuxmerge(f-&gt;ipmux-&gt;priv, mux);
	wunlock(f);

	Fsconnected(c, nil);
	return nil;
}

static int
ipmuxstate(Conv *c, char *state, int n)
{
	Ipmuxrock *r;

	r = (Ipmuxrock*)(c-&gt;ptcl);
	return ipmuxsprint(r-&gt;chain, 0, state, n);
}

static void
ipmuxcreate(Conv *c)
{
	Ipmuxrock *r;

	c-&gt;rq = qopen(64*1024, Qmsg, 0, c);
	c-&gt;wq = qopen(64*1024, Qkick, ipmuxkick, c);
	r = (Ipmuxrock*)(c-&gt;ptcl);
	r-&gt;chain = nil;
}

static char*
ipmuxannounce(Conv*, char**, int)
{
	return "ipmux does not support announce";
}

static void
ipmuxclose(Conv *c)
{
	Ipmuxrock *r;
	Fs *f = c-&gt;p-&gt;f;

	r = (Ipmuxrock*)(c-&gt;ptcl);

	qclose(c-&gt;rq);
	qclose(c-&gt;wq);
	qclose(c-&gt;eq);
	ipmove(c-&gt;laddr, IPnoaddr);
	ipmove(c-&gt;raddr, IPnoaddr);
	c-&gt;lport = 0;
	c-&gt;rport = 0;

	wlock(f);
	ipmuxremove(&amp;(c-&gt;p-&gt;priv), r-&gt;chain);
	wunlock(f);
	ipmuxtreefree(r-&gt;chain);
	r-&gt;chain = nil;
}

/*
 *  takes a fully formed ip packet and just passes it down
 *  the stack
 */
static void
ipmuxkick(void *x)
{
	Conv *c = x;
	Block *bp;

	bp = qget(c-&gt;wq);
	if(bp != nil) {
		Myip4hdr *ih4 = (Myip4hdr*)(bp-&gt;rp);

		if((ih4-&gt;vihl &amp; 0xF0) != IP_VER6)
			ipoput4(c-&gt;p-&gt;f, bp, 0, ih4-&gt;ttl, ih4-&gt;tos, nil);
		else
			ipoput6(c-&gt;p-&gt;f, bp, 0, ((Ip6hdr*)ih4)-&gt;ttl, 0, nil);
	}
}

static void
ipmuxiput(Proto *p, Ipifc *ifc, Block *bp)
{
	int len, hl;
	Fs *f = p-&gt;f;
	uchar *m, *h, *v, *e, *ve, *hp;
	Conv *c;
	Ipmux *mux;
	Myip4hdr *ip;
	Ip6hdr *ip6;

	ip = (Myip4hdr*)bp-&gt;rp;
	hl = (ip-&gt;vihl&amp;0x0F)&lt;&lt;2;

	if(p-&gt;priv == nil)
		goto nomatch;

	h = bp-&gt;rp;
	len = BLEN(bp);

	/* run the v4 filter */
	rlock(f);
	c = nil;
	mux = f-&gt;ipmux-&gt;priv;
	while(mux != nil){
		if(mux-&gt;eoff &gt; len){
			mux = mux-&gt;no;
			continue;
		}
		hp = h + mux-&gt;off + ((int)mux-&gt;skiphdr)*hl;
		switch(mux-&gt;ctype){
		case Cbyte:
			if(*mux-&gt;val == *hp)
				goto yes;
			break;
		case Cmbyte:
			if((*hp &amp; *mux-&gt;mask) == *mux-&gt;val)
				goto yes;
			break;
		case Cshort:
			if(*((ushort*)mux-&gt;val) == *(ushort*)hp)
				goto yes;
			break;
		case Cmshort:
			if((*(ushort*)hp &amp; (*((ushort*)mux-&gt;mask))) == *((ushort*)mux-&gt;val))
				goto yes;
			break;
		case Clong:
			if(*((ulong*)mux-&gt;val) == *(ulong*)hp)
				goto yes;
			break;
		case Cmlong:
			if((*(ulong*)hp &amp; (*((ulong*)mux-&gt;mask))) == *((ulong*)mux-&gt;val))
				goto yes;
			break;
		case Cifc:
			if(*((ulong*)mux-&gt;val) == *(ulong*)(ifc-&gt;lifc-&gt;local + IPv4off))
				goto yes;
			break;
		case Cmifc:
			if((*(ulong*)(ifc-&gt;lifc-&gt;local + IPv4off) &amp; (*((ulong*)mux-&gt;mask))) == *((ulong*)mux-&gt;val))
				goto yes;
			break;
		default:
			v = mux-&gt;val;
			for(e = mux-&gt;e; v &lt; e; v = ve){
				m = mux-&gt;mask;
				hp = h + mux-&gt;off;
				for(ve = v + mux-&gt;len; v &lt; ve; v++){
					if((*hp++ &amp; *m++) != *v)
						break;
				}
				if(v == ve)
					goto yes;
			}
		}
		mux = mux-&gt;no;
		continue;
yes:
		if(mux-&gt;conv != nil)
			c = mux-&gt;conv;
		mux = mux-&gt;yes;
	}
	runlock(f);

	if(c != nil){
		/* tack on interface address */
		bp = padblock(bp, IPaddrlen);
		ipmove(bp-&gt;rp, ifc-&gt;lifc-&gt;local);
		bp = concatblock(bp);
		if(bp != nil)
			if(qpass(c-&gt;rq, bp) &lt; 0)
				print("ipmuxiput: qpass failed\n");
		return;
	}

nomatch:
	/* doesn't match any filter, hand it to the specific protocol handler */
	ip = (Myip4hdr*)bp-&gt;rp;
	if((ip-&gt;vihl &amp; 0xF0) == IP_VER4) {
		p = f-&gt;t2p[ip-&gt;proto];
	} else {
		ip6 = (Ip6hdr*)bp-&gt;rp;
		p = f-&gt;t2p[ip6-&gt;proto];
	}
	if(p &amp;&amp; p-&gt;rcv)
		(*p-&gt;rcv)(p, ifc, bp);
	else
		freeblist(bp);
	return;
}

static int
ipmuxsprint(Ipmux *mux, int level, char *buf, int len)
{
	int i, j, n;
	uchar *v;

	n = 0;
	for(i = 0; i &lt; level; i++)
		n += snprint(buf+n, len-n, " ");
	if(mux == nil){
		n += snprint(buf+n, len-n, "\n");
		return n;
	}
	n += snprint(buf+n, len-n, "h[%d:%d]&amp;",
               mux-&gt;off+((int)mux-&gt;skiphdr)*((int)ipoff-&gt;data),
               mux-&gt;off+(((int)mux-&gt;skiphdr)*((int)ipoff-&gt;data))+mux-&gt;len-1);
	for(i = 0; i &lt; mux-&gt;len; i++)
		n += snprint(buf+n, len - n, "%2.2ux", mux-&gt;mask[i]);
	n += snprint(buf+n, len-n, "=");
	v = mux-&gt;val;
	for(j = 0; j &lt; mux-&gt;n; j++){
		for(i = 0; i &lt; mux-&gt;len; i++)
			n += snprint(buf+n, len - n, "%2.2ux", *v++);
		n += snprint(buf+n, len-n, "|");
	}
	n += snprint(buf+n, len-n, "\n");
	level++;
	n += ipmuxsprint(mux-&gt;no, level, buf+n, len-n);
	n += ipmuxsprint(mux-&gt;yes, level, buf+n, len-n);
	return n;
}

static int
ipmuxstats(Proto *p, char *buf, int len)
{
	int n;
	Fs *f = p-&gt;f;

	rlock(f);
	n = ipmuxsprint(p-&gt;priv, 0, buf, len);
	runlock(f);

	return n;
}

void
ipmuxinit(Fs *f)
{
	Proto *ipmux;

	ipmux = smalloc(sizeof(Proto));
	ipmux-&gt;priv = nil;
	ipmux-&gt;name = "ipmux";
	ipmux-&gt;connect = ipmuxconnect;
	ipmux-&gt;announce = ipmuxannounce;
	ipmux-&gt;state = ipmuxstate;
	ipmux-&gt;create = ipmuxcreate;
	ipmux-&gt;close = ipmuxclose;
	ipmux-&gt;rcv = ipmuxiput;
	ipmux-&gt;ctl = nil;
	ipmux-&gt;advise = nil;
	ipmux-&gt;stats = ipmuxstats;
	ipmux-&gt;ipproto = -1;
	ipmux-&gt;nc = 64;
	ipmux-&gt;ptclsize = sizeof(Ipmuxrock);

	f-&gt;ipmux = ipmux;			/* hack for Fsrcvpcol */

	Fsproto(f, ipmux);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

