<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/iproute.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/iproute.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"ip.h"

static void	walkadd(Fs*, Route**, Route*);
static void	addnode(Fs*, Route**, Route*);
static void	calcd(Route*);

/* these are used for all instances of IP */
static Route*	v4freelist;
static Route*	v6freelist;
static RWlock	routelock;
static ulong	v4routegeneration, v6routegeneration;

static void
freeroute(Route *r)
{
	Route **l;

	r-&gt;left = nil;
	r-&gt;right = nil;
	if(r-&gt;type &amp; Rv4)
		l = &amp;v4freelist;
	else
		l = &amp;v6freelist;
	r-&gt;mid = *l;
	*l = r;
}

static Route*
allocroute(int type)
{
	Route *r;
	int n;
	Route **l;

	if(type &amp; Rv4){
		n = sizeof(RouteTree) + sizeof(V4route);
		l = &amp;v4freelist;
	} else {
		n = sizeof(RouteTree) + sizeof(V6route);
		l = &amp;v6freelist;
	}

	r = *l;
	if(r != nil){
		*l = r-&gt;mid;
	} else {
		r = malloc(n);
		if(r == nil)
			panic("out of routing nodes");
	}
	memset(r, 0, n);
	r-&gt;type = type;
	r-&gt;ifc = nil;
	r-&gt;ref = 1;

	return r;
}

static void
addqueue(Route **q, Route *r)
{
	Route *l;

	if(r == nil)
		return;

	l = allocroute(r-&gt;type);
	l-&gt;mid = *q;
	*q = l;
	l-&gt;left = r;
}

/*
 *   compare 2 v6 addresses
 */
static int
lcmp(ulong *a, ulong *b)
{
	int i;

	for(i = 0; i &lt; IPllen; i++){
		if(a[i] &gt; b[i])
			return 1;
		if(a[i] &lt; b[i])
			return -1;
	}
	return 0;
}

/*
 *  compare 2 v4 or v6 ranges
 */
enum
{
	Rpreceeds,
	Rfollows,
	Requals,
	Rcontains,
	Rcontained,
};

static int
rangecompare(Route *a, Route *b)
{
	if(a-&gt;type &amp; Rv4){
		if(a-&gt;v4.endaddress &lt; b-&gt;v4.address)
			return Rpreceeds;

		if(a-&gt;v4.address &gt; b-&gt;v4.endaddress)
			return Rfollows;

		if(a-&gt;v4.address &lt;= b-&gt;v4.address
		&amp;&amp; a-&gt;v4.endaddress &gt;= b-&gt;v4.endaddress){
			if(a-&gt;v4.address == b-&gt;v4.address
			&amp;&amp; a-&gt;v4.endaddress == b-&gt;v4.endaddress)
				return Requals;
			return Rcontains;
		}
		return Rcontained;
	}

	if(lcmp(a-&gt;v6.endaddress, b-&gt;v6.address) &lt; 0)
		return Rpreceeds;

	if(lcmp(a-&gt;v6.address, b-&gt;v6.endaddress) &gt; 0)
		return Rfollows;

	if(lcmp(a-&gt;v6.address, b-&gt;v6.address) &lt;= 0
	&amp;&amp; lcmp(a-&gt;v6.endaddress, b-&gt;v6.endaddress) &gt;= 0){
		if(lcmp(a-&gt;v6.address, b-&gt;v6.address) == 0
		&amp;&amp; lcmp(a-&gt;v6.endaddress, b-&gt;v6.endaddress) == 0)
				return Requals;
		return Rcontains;
	}

	return Rcontained;
}

static void
copygate(Route *old, Route *new)
{
	if(new-&gt;type &amp; Rv4)
		memmove(old-&gt;v4.gate, new-&gt;v4.gate, IPv4addrlen);
	else
		memmove(old-&gt;v6.gate, new-&gt;v6.gate, IPaddrlen);
}

/*
 *  walk down a tree adding nodes back in
 */
static void
walkadd(Fs *f, Route **root, Route *p)
{
	Route *l, *r;

	l = p-&gt;left;
	r = p-&gt;right;
	p-&gt;left = 0;
	p-&gt;right = 0;
	addnode(f, root, p);
	if(l)
		walkadd(f, root, l);
	if(r)
		walkadd(f, root, r);
}

/*
 *  calculate depth
 */
static void
calcd(Route *p)
{
	Route *q;
	int d;

	if(p) {
		d = 0;
		q = p-&gt;left;
		if(q)
			d = q-&gt;depth;
		q = p-&gt;right;
		if(q &amp;&amp; q-&gt;depth &gt; d)
			d = q-&gt;depth;
		q = p-&gt;mid;
		if(q &amp;&amp; q-&gt;depth &gt; d)
			d = q-&gt;depth;
		p-&gt;depth = d+1;
	}
}

/*
 *  balance the tree at the current node
 */
static void
balancetree(Route **cur)
{
	Route *p, *l, *r;
	int dl, dr;

	/*
	 * if left and right are
	 * too out of balance,
	 * rotate tree node
	 */
	p = *cur;
	dl = 0; if(l = p-&gt;left) dl = l-&gt;depth;
	dr = 0; if(r = p-&gt;right) dr = r-&gt;depth;

	if(dl &gt; dr+1) {
		p-&gt;left = l-&gt;right;
		l-&gt;right = p;
		*cur = l;
		calcd(p);
		calcd(l);
	} else
	if(dr &gt; dl+1) {
		p-&gt;right = r-&gt;left;
		r-&gt;left = p;
		*cur = r;
		calcd(p);
		calcd(r);
	} else
		calcd(p);
}

/*
 *  add a new node to the tree
 */
static void
addnode(Fs *f, Route **cur, Route *new)
{
	Route *p;

	p = *cur;
	if(p == 0) {
		*cur = new;
		new-&gt;depth = 1;
		return;
	}

	switch(rangecompare(new, p)){
	case Rpreceeds:
		addnode(f, &amp;p-&gt;left, new);
		break;
	case Rfollows:
		addnode(f, &amp;p-&gt;right, new);
		break;
	case Rcontains:
		/*
		 *  if new node is superset
		 *  of tree node,
		 *  replace tree node and
		 *  queue tree node to be
		 *  merged into root.
		 */
		*cur = new;
		new-&gt;depth = 1;
		addqueue(&amp;f-&gt;queue, p);
		break;
	case Requals:
		/*
		 *  supercede the old entry if the old one isn't
		 *  a local interface.
		 */
		if((p-&gt;type &amp; Rifc) == 0){
			p-&gt;type = new-&gt;type;
			p-&gt;ifcid = -1;
			copygate(p, new);
		} else if(new-&gt;type &amp; Rifc)
			p-&gt;ref++;
		freeroute(new);
		break;
	case Rcontained:
		addnode(f, &amp;p-&gt;mid, new);
		break;
	}

	balancetree(cur);
}

#define	V4H(a)	((a&amp;0x07ffffff)&gt;&gt;(32-Lroot-5))

void
v4addroute(Fs *f, char *tag, uchar *a, uchar *mask, uchar *gate, int type)
{
	Route *p;
	ulong sa;
	ulong m;
	ulong ea;
	int h, eh;

	m = nhgetl(mask);
	sa = nhgetl(a) &amp; m;
	ea = sa | ~m;

	eh = V4H(ea);
	for(h=V4H(sa); h&lt;=eh; h++) {
		p = allocroute(Rv4 | type);
		p-&gt;v4.address = sa;
		p-&gt;v4.endaddress = ea;
		memmove(p-&gt;v4.gate, gate, sizeof(p-&gt;v4.gate));
		memmove(p-&gt;tag, tag, sizeof(p-&gt;tag));

		wlock(&amp;routelock);
		addnode(f, &amp;f-&gt;v4root[h], p);
		while(p = f-&gt;queue) {
			f-&gt;queue = p-&gt;mid;
			walkadd(f, &amp;f-&gt;v4root[h], p-&gt;left);
			freeroute(p);
		}
		wunlock(&amp;routelock);
	}
	v4routegeneration++;

	ipifcaddroute(f, Rv4, a, mask, gate, type);
}

#define	V6H(a)	(((a)[IPllen-1] &amp; 0x07ffffff)&gt;&gt;(32-Lroot-5))
#define ISDFLT(a, mask, tag) ((ipcmp((a),v6Unspecified)==0) &amp;&amp; (ipcmp((mask),v6Unspecified)==0) &amp;&amp; (strcmp((tag), "ra")!=0))

void
v6addroute(Fs *f, char *tag, uchar *a, uchar *mask, uchar *gate, int type)
{
	Route *p;
	ulong sa[IPllen], ea[IPllen];
	ulong x, y;
	int h, eh;

	/*
	if(ISDFLT(a, mask, tag))
		f-&gt;v6p-&gt;cdrouter = -1;
	*/


	for(h = 0; h &lt; IPllen; h++){
		x = nhgetl(a+4*h);
		y = nhgetl(mask+4*h);
		sa[h] = x &amp; y;
		ea[h] = x | ~y;
	}

	eh = V6H(ea);
	for(h = V6H(sa); h &lt;= eh; h++) {
		p = allocroute(type);
		memmove(p-&gt;v6.address, sa, IPaddrlen);
		memmove(p-&gt;v6.endaddress, ea, IPaddrlen);
		memmove(p-&gt;v6.gate, gate, IPaddrlen);
		memmove(p-&gt;tag, tag, sizeof(p-&gt;tag));

		wlock(&amp;routelock);
		addnode(f, &amp;f-&gt;v6root[h], p);
		while(p = f-&gt;queue) {
			f-&gt;queue = p-&gt;mid;
			walkadd(f, &amp;f-&gt;v6root[h], p-&gt;left);
			freeroute(p);
		}
		wunlock(&amp;routelock);
	}
	v6routegeneration++;

	ipifcaddroute(f, 0, a, mask, gate, type);
}

Route**
looknode(Route **cur, Route *r)
{
	Route *p;

	for(;;){
		p = *cur;
		if(p == 0)
			return 0;

		switch(rangecompare(r, p)){
		case Rcontains:
			return 0;
		case Rpreceeds:
			cur = &amp;p-&gt;left;
			break;
		case Rfollows:
			cur = &amp;p-&gt;right;
			break;
		case Rcontained:
			cur = &amp;p-&gt;mid;
			break;
		case Requals:
			return cur;
		}
	}
}

void
v4delroute(Fs *f, uchar *a, uchar *mask, int dolock)
{
	Route **r, *p;
	Route rt;
	int h, eh;
	ulong m;

	m = nhgetl(mask);
	rt.v4.address = nhgetl(a) &amp; m;
	rt.v4.endaddress = rt.v4.address | ~m;
	rt.type = Rv4;

	eh = V4H(rt.v4.endaddress);
	for(h=V4H(rt.v4.address); h&lt;=eh; h++) {
		if(dolock)
			wlock(&amp;routelock);
		r = looknode(&amp;f-&gt;v4root[h], &amp;rt);
		if(r) {
			p = *r;
			if(--(p-&gt;ref) == 0){
				*r = 0;
				addqueue(&amp;f-&gt;queue, p-&gt;left);
				addqueue(&amp;f-&gt;queue, p-&gt;mid);
				addqueue(&amp;f-&gt;queue, p-&gt;right);
				freeroute(p);
				while(p = f-&gt;queue) {
					f-&gt;queue = p-&gt;mid;
					walkadd(f, &amp;f-&gt;v4root[h], p-&gt;left);
					freeroute(p);
				}
			}
		}
		if(dolock)
			wunlock(&amp;routelock);
	}
	v4routegeneration++;

	ipifcremroute(f, Rv4, a, mask);
}

void
v6delroute(Fs *f, uchar *a, uchar *mask, int dolock)
{
	Route **r, *p;
	Route rt;
	int h, eh;
	ulong x, y;

	for(h = 0; h &lt; IPllen; h++){
		x = nhgetl(a+4*h);
		y = nhgetl(mask+4*h);
		rt.v6.address[h] = x &amp; y;
		rt.v6.endaddress[h] = x | ~y;
	}
	rt.type = 0;

	eh = V6H(rt.v6.endaddress);
	for(h=V6H(rt.v6.address); h&lt;=eh; h++) {
		if(dolock)
			wlock(&amp;routelock);
		r = looknode(&amp;f-&gt;v6root[h], &amp;rt);
		if(r) {
			p = *r;
			if(--(p-&gt;ref) == 0){
				*r = 0;
				addqueue(&amp;f-&gt;queue, p-&gt;left);
				addqueue(&amp;f-&gt;queue, p-&gt;mid);
				addqueue(&amp;f-&gt;queue, p-&gt;right);
				freeroute(p);
				while(p = f-&gt;queue) {
					f-&gt;queue = p-&gt;mid;
					walkadd(f, &amp;f-&gt;v6root[h], p-&gt;left);
					freeroute(p);
				}
			}
		}
		if(dolock)
			wunlock(&amp;routelock);
	}
	v6routegeneration++;

	ipifcremroute(f, 0, a, mask);
}

Route*
v4lookup(Fs *f, uchar *a, Conv *c)
{
	Route *p, *q;
	ulong la;
	uchar gate[IPaddrlen];
	Ipifc *ifc;

	if(c != nil &amp;&amp; c-&gt;r != nil &amp;&amp; c-&gt;r-&gt;ifc != nil &amp;&amp; c-&gt;rgen == v4routegeneration)
		return c-&gt;r;

	la = nhgetl(a);
	q = nil;
	for(p=f-&gt;v4root[V4H(la)]; p;)
		if(la &gt;= p-&gt;v4.address) {
			if(la &lt;= p-&gt;v4.endaddress) {
				q = p;
				p = p-&gt;mid;
			} else
				p = p-&gt;right;
		} else
			p = p-&gt;left;

	if(q &amp;&amp; (q-&gt;ifc == nil || q-&gt;ifcid != q-&gt;ifc-&gt;ifcid)){
		if(q-&gt;type &amp; Rifc) {
			hnputl(gate+IPv4off, q-&gt;v4.address);
			memmove(gate, v4prefix, IPv4off);
		} else
			v4tov6(gate, q-&gt;v4.gate);
		ifc = findipifc(f, gate, q-&gt;type);
		if(ifc == nil)
			return nil;
		q-&gt;ifc = ifc;
		q-&gt;ifcid = ifc-&gt;ifcid;
	}

	if(c != nil){
		c-&gt;r = q;
		c-&gt;rgen = v4routegeneration;
	}

	return q;
}

Route*
v6lookup(Fs *f, uchar *a, Conv *c)
{
	Route *p, *q;
	ulong la[IPllen];
	int h;
	ulong x, y;
	uchar gate[IPaddrlen];
	Ipifc *ifc;

	if(memcmp(a, v4prefix, IPv4off) == 0){
		q = v4lookup(f, a+IPv4off, c);
		if(q != nil)
			return q;
	}

	if(c != nil &amp;&amp; c-&gt;r != nil &amp;&amp; c-&gt;r-&gt;ifc != nil &amp;&amp; c-&gt;rgen == v6routegeneration)
		return c-&gt;r;

	for(h = 0; h &lt; IPllen; h++)
		la[h] = nhgetl(a+4*h);

	q = 0;
	for(p=f-&gt;v6root[V6H(la)]; p;){
		for(h = 0; h &lt; IPllen; h++){
			x = la[h];
			y = p-&gt;v6.address[h];
			if(x == y)
				continue;
			if(x &lt; y){
				p = p-&gt;left;
				goto next;
			}
			break;
		}
		for(h = 0; h &lt; IPllen; h++){
			x = la[h];
			y = p-&gt;v6.endaddress[h];
			if(x == y)
				continue;
			if(x &gt; y){
				p = p-&gt;right;
				goto next;
			}
			break;
		}
		q = p;
		p = p-&gt;mid;
next:		;
	}

	if(q &amp;&amp; (q-&gt;ifc == nil || q-&gt;ifcid != q-&gt;ifc-&gt;ifcid)){
		if(q-&gt;type &amp; Rifc) {
			for(h = 0; h &lt; IPllen; h++)
				hnputl(gate+4*h, q-&gt;v6.address[h]);
			ifc = findipifc(f, gate, q-&gt;type);
		} else
			ifc = findipifc(f, q-&gt;v6.gate, q-&gt;type);
		if(ifc == nil)
			return nil;
		q-&gt;ifc = ifc;
		q-&gt;ifcid = ifc-&gt;ifcid;
	}
	if(c != nil){
		c-&gt;r = q;
		c-&gt;rgen = v6routegeneration;
	}

	return q;
}

void
routetype(int type, char *p)
{
	memset(p, ' ', 4);
	p[4] = 0;
	if(type &amp; Rv4)
		*p++ = '4';
	else
		*p++ = '6';
	if(type &amp; Rifc)
		*p++ = 'i';
	if(type &amp; Runi)
		*p++ = 'u';
	else if(type &amp; Rbcast)
		*p++ = 'b';
	else if(type &amp; Rmulti)
		*p++ = 'm';
	if(type &amp; Rptpt)
		*p = 'p';
}

static char *rformat = "%-15I %-4M %-15I %4.4s %4.4s %3s\n";

void
convroute(Route *r, uchar *addr, uchar *mask, uchar *gate, char *t, int *nifc)
{
	int i;

	if(r-&gt;type &amp; Rv4){
		memmove(addr, v4prefix, IPv4off);
		hnputl(addr+IPv4off, r-&gt;v4.address);
		memset(mask, 0xff, IPv4off);
		hnputl(mask+IPv4off, ~(r-&gt;v4.endaddress ^ r-&gt;v4.address));
		memmove(gate, v4prefix, IPv4off);
		memmove(gate+IPv4off, r-&gt;v4.gate, IPv4addrlen);
	} else {
		for(i = 0; i &lt; IPllen; i++){
			hnputl(addr + 4*i, r-&gt;v6.address[i]);
			hnputl(mask + 4*i, ~(r-&gt;v6.endaddress[i] ^ r-&gt;v6.address[i]));
		}
		memmove(gate, r-&gt;v6.gate, IPaddrlen);
	}

	routetype(r-&gt;type, t);

	if(r-&gt;ifc)
		*nifc = r-&gt;ifc-&gt;conv-&gt;x;
	else
		*nifc = -1;
}

/*
 *  this code is not in rr to reduce stack size
 */
static void
sprintroute(Route *r, Routewalk *rw)
{
	int nifc, n;
	char t[5], *iname, ifbuf[5];
	uchar addr[IPaddrlen], mask[IPaddrlen], gate[IPaddrlen];
	char *p;

	convroute(r, addr, mask, gate, t, &amp;nifc);
	iname = "-";
	if(nifc != -1) {
		iname = ifbuf;
		snprint(ifbuf, sizeof ifbuf, "%d", nifc);
	}
	p = seprint(rw-&gt;p, rw-&gt;e, rformat, addr, mask, gate, t, r-&gt;tag, iname);
	if(rw-&gt;o &lt; 0){
		n = p - rw-&gt;p;
		if(n &gt; -rw-&gt;o){
			memmove(rw-&gt;p, rw-&gt;p-rw-&gt;o, n+rw-&gt;o);
			rw-&gt;p = p + rw-&gt;o;
		}
		rw-&gt;o += n;
	} else
		rw-&gt;p = p;
}

/*
 *  recurse descending tree, applying the function in Routewalk
 */
static int
rr(Route *r, Routewalk *rw)
{
	int h;

	if(rw-&gt;e &lt;= rw-&gt;p)
		return 0;
	if(r == nil)
		return 1;

	if(rr(r-&gt;left, rw) == 0)
		return 0;

	if(r-&gt;type &amp; Rv4)
		h = V4H(r-&gt;v4.address);
	else
		h = V6H(r-&gt;v6.address);

	if(h == rw-&gt;h)
		rw-&gt;walk(r, rw);

	if(rr(r-&gt;mid, rw) == 0)
		return 0;

	return rr(r-&gt;right, rw);
}

void
ipwalkroutes(Fs *f, Routewalk *rw)
{
	rlock(&amp;routelock);
	if(rw-&gt;e &gt; rw-&gt;p) {
		for(rw-&gt;h = 0; rw-&gt;h &lt; nelem(f-&gt;v4root); rw-&gt;h++)
			if(rr(f-&gt;v4root[rw-&gt;h], rw) == 0)
				break;
	}
	if(rw-&gt;e &gt; rw-&gt;p) {
		for(rw-&gt;h = 0; rw-&gt;h &lt; nelem(f-&gt;v6root); rw-&gt;h++)
			if(rr(f-&gt;v6root[rw-&gt;h], rw) == 0)
				break;
	}
	runlock(&amp;routelock);
}

long
routeread(Fs *f, char *p, ulong offset, int n)
{
	Routewalk rw;

	rw.p = p;
	rw.e = p+n;
	rw.o = -offset;
	rw.walk = sprintroute;

	ipwalkroutes(f, &amp;rw);

	return rw.p - p;
}

/*
 *  this code is not in routeflush to reduce stack size
 */
void
delroute(Fs *f, Route *r, int dolock)
{
	uchar addr[IPaddrlen];
	uchar mask[IPaddrlen];
	uchar gate[IPaddrlen];
	char t[5];
	int nifc;

	convroute(r, addr, mask, gate, t, &amp;nifc);
	if(r-&gt;type &amp; Rv4)
		v4delroute(f, addr+IPv4off, mask+IPv4off, dolock);
	else
		v6delroute(f, addr, mask, dolock);
}

/*
 *  recurse until one route is deleted
 *    returns 0 if nothing is deleted, 1 otherwise
 */
int
routeflush(Fs *f, Route *r, char *tag)
{
	if(r == nil)
		return 0;
	if(routeflush(f, r-&gt;mid, tag))
		return 1;
	if(routeflush(f, r-&gt;left, tag))
		return 1;
	if(routeflush(f, r-&gt;right, tag))
		return 1;
	if((r-&gt;type &amp; Rifc) == 0){
		if(tag == nil || strncmp(tag, r-&gt;tag, sizeof(r-&gt;tag)) == 0){
			delroute(f, r, 0);
			return 1;
		}
	}
	return 0;
}

Route *
iproute(Fs *fs, uchar *ip)
{
	if(isv4(ip))
		return v4lookup(fs, ip+IPv4off, nil);
	else
		return v6lookup(fs, ip, nil);
}

static void
printroute(Route *r)
{
	int nifc;
	char t[5], *iname, ifbuf[5];
	uchar addr[IPaddrlen], mask[IPaddrlen], gate[IPaddrlen];

	convroute(r, addr, mask, gate, t, &amp;nifc);
	iname = "-";
	if(nifc != -1) {
		iname = ifbuf;
		snprint(ifbuf, sizeof ifbuf, "%d", nifc);
	}
	print(rformat, addr, mask, gate, t, r-&gt;tag, iname);
}

long
routewrite(Fs *f, Chan *c, char *p, int n)
{
	int h, changed;
	char *tag;
	Cmdbuf *cb;
	uchar addr[IPaddrlen];
	uchar mask[IPaddrlen];
	uchar gate[IPaddrlen];
	IPaux *a, *na;
	Route *q;

	cb = parsecmd(p, n);
	if(waserror()){
		free(cb);
		nexterror();
	}

	if(strcmp(cb-&gt;f[0], "flush") == 0){
		tag = cb-&gt;f[1];
		for(h = 0; h &lt; nelem(f-&gt;v4root); h++)
			for(changed = 1; changed;){
				wlock(&amp;routelock);
				changed = routeflush(f, f-&gt;v4root[h], tag);
				wunlock(&amp;routelock);
			}
		for(h = 0; h &lt; nelem(f-&gt;v6root); h++)
			for(changed = 1; changed;){
				wlock(&amp;routelock);
				changed = routeflush(f, f-&gt;v6root[h], tag);
				wunlock(&amp;routelock);
			}
	} else if(strcmp(cb-&gt;f[0], "remove") == 0){
		if(cb-&gt;nf &lt; 3)
			error(Ebadarg);
		if (parseip(addr, cb-&gt;f[1]) == -1)
			error(Ebadip);
		parseipmask(mask, cb-&gt;f[2]);
		if(memcmp(addr, v4prefix, IPv4off) == 0)
			v4delroute(f, addr+IPv4off, mask+IPv4off, 1);
		else
			v6delroute(f, addr, mask, 1);
	} else if(strcmp(cb-&gt;f[0], "add") == 0){
		if(cb-&gt;nf &lt; 4)
			error(Ebadarg);
		if(parseip(addr, cb-&gt;f[1]) == -1 ||
		    parseip(gate, cb-&gt;f[3]) == -1)
			error(Ebadip);
		parseipmask(mask, cb-&gt;f[2]);
		tag = "none";
		if(c != nil){
			a = c-&gt;aux;
			tag = a-&gt;tag;
		}
		if(memcmp(addr, v4prefix, IPv4off) == 0)
			v4addroute(f, tag, addr+IPv4off, mask+IPv4off, gate+IPv4off, 0);
		else
			v6addroute(f, tag, addr, mask, gate, 0);
	} else if(strcmp(cb-&gt;f[0], "tag") == 0) {
		if(cb-&gt;nf &lt; 2)
			error(Ebadarg);

		a = c-&gt;aux;
		na = newipaux(a-&gt;owner, cb-&gt;f[1]);
		c-&gt;aux = na;
		free(a);
	} else if(strcmp(cb-&gt;f[0], "route") == 0) {
		if(cb-&gt;nf &lt; 2)
			error(Ebadarg);
		if (parseip(addr, cb-&gt;f[1]) == -1)
			error(Ebadip);

		q = iproute(f, addr);
		print("%I: ", addr);
		if(q == nil)
			print("no route\n");
		else
			printroute(q);
	}

	poperror();
	free(cb);
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

