<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/tcp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/tcp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"ip.h"

enum
{
	QMAX		= 64*1024-1,
	IP_TCPPROTO	= 6,

	TCP4_IPLEN	= 8,
	TCP4_PHDRSIZE	= 12,
	TCP4_HDRSIZE	= 20,
	TCP4_TCBPHDRSZ	= 40,
	TCP4_PKT	= TCP4_IPLEN+TCP4_PHDRSIZE,

	TCP6_IPLEN	= 0,
	TCP6_PHDRSIZE	= 40,
	TCP6_HDRSIZE	= 20,
	TCP6_TCBPHDRSZ	= 60,
	TCP6_PKT	= TCP6_IPLEN+TCP6_PHDRSIZE,

	TcptimerOFF	= 0,
	TcptimerON	= 1,
	TcptimerDONE	= 2,
	MAX_TIME 	= (1&lt;&lt;20),	/* Forever */
	TCP_ACK		= 50,		/* Timed ack sequence in ms */
	MAXBACKMS	= 9*60*1000,	/* longest backoff time (ms) before hangup */

	URG		= 0x20,		/* Data marked urgent */
	ACK		= 0x10,		/* Acknowledge is valid */
	PSH		= 0x08,		/* Whole data pipe is pushed */
	RST		= 0x04,		/* Reset connection */
	SYN		= 0x02,		/* Pkt. is synchronise */
	FIN		= 0x01,		/* Start close down */

	EOLOPT		= 0,
	NOOPOPT		= 1,
	MSSOPT		= 2,
	MSS_LENGTH	= 4,		/* Maximum segment size */
	WSOPT		= 3,
	WS_LENGTH	= 3,		/* Bits to scale window size by */
	MSL2		= 10,
	MSPTICK		= 50,		/* Milliseconds per timer tick */
	DEF_MSS		= 1460,		/* Default maximum segment */
	DEF_MSS6	= 1280,		/* Default maximum segment (min) for v6 */
	DEF_RTT		= 500,		/* Default round trip */
	DEF_KAT		= 120000,	/* Default time (ms) between keep alives */
	TCP_LISTEN	= 0,		/* Listen connection */
	TCP_CONNECT	= 1,		/* Outgoing connection */
	SYNACK_RXTIMER	= 250,		/* ms between SYNACK retransmits */

	TCPREXMTTHRESH	= 3,		/* dupack threshhold for rxt */

	FORCE		= 1,
	CLONE		= 2,
	RETRAN		= 4,
	ACTIVE		= 8,
	SYNACK		= 16,

	LOGAGAIN	= 3,
	LOGDGAIN	= 2,

	Closed		= 0,		/* Connection states */
	Listen,
	Syn_sent,
	Syn_received,
	Established,
	Finwait1,
	Finwait2,
	Close_wait,
	Closing,
	Last_ack,
	Time_wait,

	Maxlimbo	= 1000,		/* maximum procs waiting for response to SYN ACK */
	NLHT		= 256,		/* hash table size, must be a power of 2 */
	LHTMASK		= NLHT-1,

	/*
	 * window is 64kb * 2ⁿ
	 * these factors determine the ultimate bandwidth-delay product.
	 * 64kb * 2⁵ = 2mb, or 2× overkill for 100mbps * 70ms.
	 */
	Maxqscale	= 4,		/* maximum queuing scale */
	Defadvscale	= 4,		/* default advertisement */
};

/* Must correspond to the enumeration above */
char *tcpstates[] =
{
	"Closed", 	"Listen", 	"Syn_sent", "Syn_received",
	"Established", 	"Finwait1",	"Finwait2", "Close_wait",
	"Closing", 	"Last_ack", 	"Time_wait"
};

typedef struct Tcptimer Tcptimer;
struct Tcptimer
{
	Tcptimer	*next;
	Tcptimer	*prev;
	Tcptimer	*readynext;
	int	state;
	int	start;
	int	count;
	void	(*func)(void*);
	void	*arg;
};

/*
 *  v4 and v6 pseudo headers used for
 *  checksuming tcp
 */
typedef struct Tcp4hdr Tcp4hdr;
struct Tcp4hdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	Unused;
	uchar	proto;
	uchar	tcplen[2];
	uchar	tcpsrc[4];
	uchar	tcpdst[4];
	/* same as v6 from here on */
	uchar	tcpsport[2];
	uchar	tcpdport[2];
	uchar	tcpseq[4];
	uchar	tcpack[4];
	uchar	tcpflag[2];
	uchar	tcpwin[2];
	uchar	tcpcksum[2];
	uchar	tcpurg[2];
	/* Options segment */
	uchar	tcpopt[1];
};

typedef struct Tcp6hdr Tcp6hdr;
struct Tcp6hdr
{
	uchar	vcf[4];
	uchar	ploadlen[2];
	uchar	proto;
	uchar	ttl;
	uchar	tcpsrc[IPaddrlen];
	uchar	tcpdst[IPaddrlen];
	/* same as v4 from here on */
	uchar	tcpsport[2];
	uchar	tcpdport[2];
	uchar	tcpseq[4];
	uchar	tcpack[4];
	uchar	tcpflag[2];
	uchar	tcpwin[2];
	uchar	tcpcksum[2];
	uchar	tcpurg[2];
	/* Options segment */
	uchar	tcpopt[1];
};

/*
 *  this represents the control info
 *  for a single packet.  It is derived from
 *  a packet in ntohtcp{4,6}() and stuck into
 *  a packet in htontcp{4,6}().
 */
typedef struct Tcp Tcp;
struct	Tcp
{
	ushort	source;
	ushort	dest;
	ulong	seq;
	ulong	ack;
	uchar	flags;
	uchar	update;
	ushort	ws;	/* window scale option */
	ulong	wnd;	/* prescaled window*/
	ushort	urg;
	ushort	mss;	/* max segment size option (if not zero) */
	ushort	len;	/* size of data */
};

/*
 *  this header is malloc'd to thread together fragments
 *  waiting to be coalesced
 */
typedef struct Reseq Reseq;
struct Reseq
{
	Reseq	*next;
	Tcp	seg;
	Block	*bp;
	ushort	length;
};

/*
 *  the qlock in the Conv locks this structure
 */
typedef struct Tcpctl Tcpctl;
struct Tcpctl
{
	uchar	state;			/* Connection state */
	uchar	type;			/* Listening or active connection */
	uchar	code;			/* Icmp code */
	struct {
		ulong	una;		/* Unacked data pointer */
		ulong	nxt;		/* Next sequence expected */
		ulong	ptr;		/* Data pointer */
		ulong	wnd;		/* Tcp send window */
		ulong	urg;		/* Urgent data pointer */
		ulong	wl2;
		uint	scale;		/* how much to right shift window */
					/* in xmitted packets */
		/* to implement tahoe and reno TCP */
		ulong	dupacks;	/* number of duplicate acks rcvd */
		ulong	partialack;
		int	recovery;	/* loss recovery flag */
		int	retransmit;	/* retransmit 1 packet @ una flag */
		int	rto;
		ulong	rxt;		/* right window marker for recovery */
					/* "recover" rfc3782 */
	} snd;
	struct {
		ulong	nxt;		/* Receive pointer to next uchar slot */
		ulong	wnd;		/* Receive window incoming */
		ulong	wsnt;		/* Last wptr sent.  important to */
					/* track for large bdp */
		ulong	wptr;
		ulong	urg;		/* Urgent pointer */
		ulong	ackptr;		/* last acked sequence */
		int	blocked;
		uint	scale;		/* how much to left shift window in */
					/* rcv'd packets */
	} rcv;
	ulong	iss;			/* Initial sequence number */
	ulong	cwind;			/* Congestion window */
	ulong	abcbytes;		/* appropriate byte counting rfc 3465 */
	uint	scale;			/* desired snd.scale */
	ulong	ssthresh;		/* Slow start threshold */
	int	resent;			/* Bytes just resent */
	int	irs;			/* Initial received squence */
	ushort	mss;			/* Maximum segment size */
	int	rerecv;			/* Overlap of data rerecevived */
	ulong	window;			/* Our receive window (queue) */
	uint	qscale;			/* Log2 of our receive window (queue) */
	uchar	backoff;		/* Exponential backoff counter */
	int	backedoff;		/* ms we've backed off for rexmits */
	uchar	flags;			/* State flags */
	Reseq	*reseq;			/* Resequencing queue */
	int	nreseq;
	int	reseqlen;
	Tcptimer	timer;			/* Activity timer */
	Tcptimer	acktimer;		/* Acknowledge timer */
	Tcptimer	rtt_timer;		/* Round trip timer */
	Tcptimer	katimer;		/* keep alive timer */
	ulong	rttseq;			/* Round trip sequence */
	int	srtt;			/* Smoothed round trip */
	int	mdev;			/* Mean deviation of round trip */
	int	kacounter;		/* count down for keep alive */
	uint	sndsyntime;		/* time syn sent */
	ulong	time;			/* time Finwait2 or Syn_received was sent */
	ulong	timeuna;		/* snd.una when time was set */
	int	nochecksum;		/* non-zero means don't send checksums */
	int	flgcnt;			/* number of flags in the sequence (FIN,SEQ) */

	union {
		Tcp4hdr	tcp4hdr;
		Tcp6hdr	tcp6hdr;
	} protohdr;		/* prototype header */
};

/*
 *  New calls are put in limbo rather than having a conversation structure
 *  allocated.  Thus, a SYN attack results in lots of limbo'd calls but not
 *  any real Conv structures mucking things up.  Calls in limbo rexmit their
 *  SYN ACK every SYNACK_RXTIMER ms up to 4 times, i.e., they disappear after 1 second.
 *
 *  In particular they aren't on a listener's queue so that they don't figure
 *  in the input queue limit.
 *
 *  If 1/2 of a T3 was attacking SYN packets, we'ld have a permanent queue
 *  of 70000 limbo'd calls.  Not great for a linear list but doable.  Therefore
 *  there is no hashing of this list.
 */
typedef struct Limbo Limbo;
struct Limbo
{
	Limbo	*next;

	uchar	laddr[IPaddrlen];
	uchar	raddr[IPaddrlen];
	ushort	lport;
	ushort	rport;
	ulong	irs;		/* initial received sequence */
	ulong	iss;		/* initial sent sequence */
	ushort	mss;		/* mss from the other end */
	ushort	rcvscale;	/* how much to scale rcvd windows */
	ushort	sndscale;	/* how much to scale sent windows */
	ulong	lastsend;	/* last time we sent a synack */
	uchar	version;	/* v4 or v6 */
	uchar	rexmits;	/* number of retransmissions */
};

int	tcp_irtt = DEF_RTT;	/* Initial guess at round trip time */

enum {
	/* MIB stats */
	MaxConn,
	Mss,
	ActiveOpens,
	PassiveOpens,
	EstabResets,
	CurrEstab,
	InSegs,
	OutSegs,
	RetransSegs,
	RetransSegsSent,
	RetransTimeouts,
	InErrs,
	OutRsts,

	/* non-MIB stats */
	CsumErrs,
	HlenErrs,
	LenErrs,
	Resequenced,
	OutOfOrder,
	ReseqBytelim,
	ReseqPktlim,
	Delayack,
	Wopenack,

	Recovery,
	RecoveryDone,
	RecoveryRTO,
	RecoveryNoSeq,
	RecoveryCwind,
	RecoveryPA,

	Nstats
};

static char *statnames[Nstats] =
{
[MaxConn]	"MaxConn",
[Mss]		"MaxSegment",
[ActiveOpens]	"ActiveOpens",
[PassiveOpens]	"PassiveOpens",
[EstabResets]	"EstabResets",
[CurrEstab]	"CurrEstab",
[InSegs]	"InSegs",
[OutSegs]	"OutSegs",
[RetransSegs]	"RetransSegs",
[RetransSegsSent]	"RetransSegsSent",
[RetransTimeouts]	"RetransTimeouts",
[InErrs]	"InErrs",
[OutRsts]	"OutRsts",
[CsumErrs]	"CsumErrs",
[HlenErrs]	"HlenErrs",
[LenErrs]	"LenErrs",
[OutOfOrder]	"OutOfOrder",
[Resequenced]	"Resequenced",
[ReseqBytelim]	"ReseqBytelim",
[ReseqPktlim]	"ReseqPktlim",
[Delayack]	"Delayack",
[Wopenack]	"Wopenack",

[Recovery]	"Recovery",
[RecoveryDone]	"RecoveryDone",
[RecoveryRTO]	"RecoveryRTO",

[RecoveryNoSeq]	"RecoveryNoSeq",
[RecoveryCwind]	"RecoveryCwind",
[RecoveryPA]	"RecoveryPA",
};

typedef struct Tcppriv Tcppriv;
struct Tcppriv
{
	/* List of active timers */
	QLock 	tl;
	Tcptimer *timers;

	/* hash table for matching conversations */
	Ipht	ht;

	/* calls in limbo waiting for an ACK to our SYN ACK */
	int	nlimbo;
	Limbo	*lht[NLHT];

	/* for keeping track of tcpackproc */
	QLock	apl;
	int	ackprocstarted;

	uvlong	stats[Nstats];
};

/*
 *  Setting tcpporthogdefense to non-zero enables Dong Lin's
 *  solution to hijacked systems staking out port's as a form
 *  of DoS attack.
 *
 *  To avoid stateless Conv hogs, we pick a sequence number at random.  If
 *  that number gets acked by the other end, we shut down the connection.
 *  Look for tcpporthogdefense in the code.
 */
int tcpporthogdefense = 0;

static	int	addreseq(Fs*, Tcpctl*, Tcppriv*, Tcp*, Block*, ushort);
static	int	dumpreseq(Tcpctl*);
static	void	getreseq(Tcpctl*, Tcp*, Block**, ushort*);
static	void	limbo(Conv*, uchar*, uchar*, Tcp*, int);
static	void	limborexmit(Proto*);
static	void	localclose(Conv*, char*);
static	void	procsyn(Conv*, Tcp*);
static	void	tcpacktimer(void*);
static	void	tcpiput(Proto*, Ipifc*, Block*);
static	void	tcpkeepalive(void*);
static	void	tcpoutput(Conv*);
static	void	tcprcvwin(Conv*);
static	void	tcprxmit(Conv*);
static	void	tcpsetkacounter(Tcpctl*);
static	void	tcpsetscale(Conv*, Tcpctl*, ushort, ushort);
static	void	tcpsettimer(Tcpctl*);
static	void	tcpsndsyn(Conv*, Tcpctl*);
static	void	tcpstart(Conv*, int);
static	void	tcpsynackrtt(Conv*);
static	void	tcptimeout(void*);
static	int	tcptrim(Tcpctl*, Tcp*, Block**, ushort*);

static void
tcpsetstate(Conv *s, uchar newstate)
{
	Tcpctl *tcb;
	uchar oldstate;
	Tcppriv *tpriv;

	tpriv = s-&gt;p-&gt;priv;

	tcb = (Tcpctl*)s-&gt;ptcl;

	oldstate = tcb-&gt;state;
	if(oldstate == newstate)
		return;

	if(oldstate == Established)
		tpriv-&gt;stats[CurrEstab]--;
	if(newstate == Established)
		tpriv-&gt;stats[CurrEstab]++;

	switch(newstate) {
	case Closed:
		qclose(s-&gt;rq);
		qclose(s-&gt;wq);
		qclose(s-&gt;eq);
		break;

	case Close_wait:		/* Remote closes */
		qhangup(s-&gt;rq, nil);
		break;
	}

	tcb-&gt;state = newstate;

	if(oldstate == Syn_sent &amp;&amp; newstate != Closed)
		Fsconnected(s, nil);
}

static char*
tcpconnect(Conv *c, char **argv, int argc)
{
	char *e;
	Tcpctl *tcb;

	tcb = (Tcpctl*)(c-&gt;ptcl);
	if(tcb-&gt;state != Closed)
		return Econinuse;

	e = Fsstdconnect(c, argv, argc);
	if(e != nil)
		return e;
	tcpstart(c, TCP_CONNECT);

	return nil;
}

static int
tcpstate(Conv *c, char *state, int n)
{
	Tcpctl *s;

	s = (Tcpctl*)(c-&gt;ptcl);

	return snprint(state, n,
		"%s qin %d qout %d rq %d.%d srtt %d mdev %d sst %lud cwin %lud "
		"swin %lud&gt;&gt;%d rwin %lud&gt;&gt;%d qscale %d timer.start %d "
		"timer.count %d rerecv %d katimer.start %d katimer.count %d\n",
		tcpstates[s-&gt;state],
		c-&gt;rq ? qlen(c-&gt;rq) : 0,
		c-&gt;wq ? qlen(c-&gt;wq) : 0,
		s-&gt;nreseq, s-&gt;reseqlen,
		s-&gt;srtt, s-&gt;mdev, s-&gt;ssthresh,
		s-&gt;cwind, s-&gt;snd.wnd, s-&gt;rcv.scale, s-&gt;rcv.wnd, s-&gt;snd.scale,
		s-&gt;qscale,
		s-&gt;timer.start, s-&gt;timer.count, s-&gt;rerecv,
		s-&gt;katimer.start, s-&gt;katimer.count);
}

static int
tcpinuse(Conv *c)
{
	Tcpctl *s;

	s = (Tcpctl*)(c-&gt;ptcl);
	return s-&gt;state != Closed;
}

static char*
tcpannounce(Conv *c, char **argv, int argc)
{
	char *e;
	Tcpctl *tcb;

	tcb = (Tcpctl*)(c-&gt;ptcl);
	if(tcb-&gt;state != Closed)
		return Econinuse;

	e = Fsstdannounce(c, argv, argc);
	if(e != nil)
		return e;
	tcpstart(c, TCP_LISTEN);
	Fsconnected(c, nil);

	return nil;
}

/*
 *  tcpclose is always called with the q locked
 */
static void
tcpclose(Conv *c)
{
	Tcpctl *tcb;

	tcb = (Tcpctl*)c-&gt;ptcl;

	qhangup(c-&gt;rq, nil);
	qhangup(c-&gt;wq, nil);
	qhangup(c-&gt;eq, nil);
	qflush(c-&gt;rq);

	switch(tcb-&gt;state) {
	case Listen:
		/*
		 *  reset any incoming calls to this listener
		 */
		Fsconnected(c, "Hangup");

		localclose(c, nil);
		break;
	case Closed:
	case Syn_sent:
		localclose(c, nil);
		break;
	case Syn_received:
	case Established:
		tcb-&gt;flgcnt++;
		tcb-&gt;snd.nxt++;
		tcpsetstate(c, Finwait1);
		tcpoutput(c);
		break;
	case Close_wait:
		tcb-&gt;flgcnt++;
		tcb-&gt;snd.nxt++;
		tcpsetstate(c, Last_ack);
		tcpoutput(c);
		break;
	}
}

static void
tcpkick(void *x)
{
	Conv *s = x;
	Tcpctl *tcb;

	tcb = (Tcpctl*)s-&gt;ptcl;

	if(waserror()){
		qunlock(s);
		nexterror();
	}
	qlock(s);

	switch(tcb-&gt;state) {
	case Syn_sent:
	case Syn_received:
	case Established:
	case Close_wait:
		/*
		 * Push data
		 */
		tcpoutput(s);
		break;
	default:
		localclose(s, "Hangup");
		break;
	}

	qunlock(s);
	poperror();
}

static int seq_lt(ulong, ulong);

static void
tcprcvwin(Conv *s)				/* Call with tcb locked */
{
	int w;
	Tcpctl *tcb;

	tcb = (Tcpctl*)s-&gt;ptcl;
	w = tcb-&gt;window - qlen(s-&gt;rq);
	if(w &lt; 0)
		w = 0;
	/* RFC 1122 § 4.2.2.17 do not move right edge of window left */
	if(seq_lt(tcb-&gt;rcv.nxt + w, tcb-&gt;rcv.wptr))
		w = tcb-&gt;rcv.wptr - tcb-&gt;rcv.nxt;
	if(w != tcb-&gt;rcv.wnd)
	if(w&gt;&gt;tcb-&gt;rcv.scale == 0 || tcb-&gt;window &gt; 4*tcb-&gt;mss &amp;&amp; w &lt; tcb-&gt;mss/4){
		tcb-&gt;rcv.blocked = 1;
		netlog(s-&gt;p-&gt;f, Logtcp, "tcprcvwin: window %lud qlen %d ws %ud lport %d\n",
			tcb-&gt;window, qlen(s-&gt;rq), tcb-&gt;rcv.scale, s-&gt;lport);
	}
	tcb-&gt;rcv.wnd = w;
	tcb-&gt;rcv.wptr = tcb-&gt;rcv.nxt + w;
}

static void
tcpacktimer(void *v)
{
	Tcpctl *tcb;
	Conv *s;

	s = v;
	tcb = (Tcpctl*)s-&gt;ptcl;

	if(waserror()){
		qunlock(s);
		nexterror();
	}
	qlock(s);
	if(tcb-&gt;state != Closed){
		tcb-&gt;flags |= FORCE;
		tcpoutput(s);
	}
	qunlock(s);
	poperror();
}

static void
tcpcongestion(Tcpctl *tcb)
{
	ulong inflight;

	inflight = tcb-&gt;snd.nxt - tcb-&gt;snd.una;
	if(inflight &gt; tcb-&gt;cwind)
		inflight = tcb-&gt;cwind;
	tcb-&gt;ssthresh = inflight / 2;
	if(tcb-&gt;ssthresh &lt; 2*tcb-&gt;mss)
		tcb-&gt;ssthresh = 2*tcb-&gt;mss;
}

enum {
	L	= 2,	/* aggressive slow start; legal values ∈ (1.0, 2.0) */
};

static void
tcpabcincr(Tcpctl *tcb, uint acked)
{
	uint limit;

	tcb-&gt;abcbytes += acked;
	if(tcb-&gt;cwind &lt; tcb-&gt;ssthresh){
		/* slow start */
		if(tcb-&gt;snd.rto)
			limit = tcb-&gt;mss;
		else
			limit = L*tcb-&gt;mss;
		tcb-&gt;cwind += MIN(tcb-&gt;abcbytes, limit);
		tcb-&gt;abcbytes = 0;
	} else {
		tcb-&gt;snd.rto = 0;
		/* avoidance */
		if(tcb-&gt;abcbytes &gt;= tcb-&gt;cwind){
			tcb-&gt;abcbytes -= tcb-&gt;cwind;
			tcb-&gt;cwind += tcb-&gt;mss;
		}
	}
}

static void
tcpcreate(Conv *c)
{
	c-&gt;rq = qopen(QMAX, Qcoalesce, tcpacktimer, c);
	c-&gt;wq = qopen(QMAX, Qkick, tcpkick, c);
}

static void
timerstate(Tcppriv *priv, Tcptimer *t, int newstate)
{
	if(newstate != TcptimerON){
		if(t-&gt;state == TcptimerON){
			/* unchain */
			if(priv-&gt;timers == t){
				priv-&gt;timers = t-&gt;next;
				if(t-&gt;prev != nil)
					panic("timerstate1");
			}
			if(t-&gt;next)
				t-&gt;next-&gt;prev = t-&gt;prev;
			if(t-&gt;prev)
				t-&gt;prev-&gt;next = t-&gt;next;
			t-&gt;next = t-&gt;prev = nil;
		}
	} else {
		if(t-&gt;state != TcptimerON){
			/* chain */
			if(t-&gt;prev != nil || t-&gt;next != nil)
				panic("timerstate2");
			t-&gt;prev = nil;
			t-&gt;next = priv-&gt;timers;
			if(t-&gt;next)
				t-&gt;next-&gt;prev = t;
			priv-&gt;timers = t;
		}
	}
	t-&gt;state = newstate;
}

static void
tcpackproc(void *a)
{
	Tcptimer *t, *tp, *timeo;
	Proto *tcp;
	Tcppriv *priv;
	int loop;

	tcp = a;
	priv = tcp-&gt;priv;

	for(;;) {
		tsleep(&amp;up-&gt;sleep, return0, 0, MSPTICK);

		qlock(&amp;priv-&gt;tl);
		timeo = nil;
		loop = 0;
		for(t = priv-&gt;timers; t != nil; t = tp) {
			if(loop++ &gt; 10000)
				panic("tcpackproc1");
			tp = t-&gt;next;
 			if(t-&gt;state == TcptimerON) {
				t-&gt;count--;
				if(t-&gt;count == 0) {
					timerstate(priv, t, TcptimerDONE);
					t-&gt;readynext = timeo;
					timeo = t;
				}
			}
		}
		qunlock(&amp;priv-&gt;tl);

		loop = 0;
		for(t = timeo; t != nil; t = t-&gt;readynext) {
			if(loop++ &gt; 10000)
				panic("tcpackproc2");
			if(t-&gt;state == TcptimerDONE &amp;&amp; t-&gt;func != nil &amp;&amp; !waserror()){
				(*t-&gt;func)(t-&gt;arg);
				poperror();
			}
		}

		limborexmit(tcp);
	}
}

static void
tcpgo(Tcppriv *priv, Tcptimer *t)
{
	if(t == nil || t-&gt;start == 0)
		return;

	qlock(&amp;priv-&gt;tl);
	t-&gt;count = t-&gt;start;
	timerstate(priv, t, TcptimerON);
	qunlock(&amp;priv-&gt;tl);
}

static void
tcphalt(Tcppriv *priv, Tcptimer *t)
{
	if(t == nil)
		return;

	qlock(&amp;priv-&gt;tl);
	timerstate(priv, t, TcptimerOFF);
	qunlock(&amp;priv-&gt;tl);
}

static int
backoff(int n)
{
	return 1 &lt;&lt; n;
}

static void
localclose(Conv *s, char *reason)	/* called with tcb locked */
{
	Tcpctl *tcb;
	Tcppriv *tpriv;

	tpriv = s-&gt;p-&gt;priv;
	tcb = (Tcpctl*)s-&gt;ptcl;

	iphtrem(&amp;tpriv-&gt;ht, s);

	tcphalt(tpriv, &amp;tcb-&gt;timer);
	tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
	tcphalt(tpriv, &amp;tcb-&gt;acktimer);
	tcphalt(tpriv, &amp;tcb-&gt;katimer);

	/* Flush reassembly queue; nothing more can arrive */
	dumpreseq(tcb);

	if(tcb-&gt;state == Syn_sent)
		Fsconnected(s, reason);
	if(s-&gt;state == Announced)
		wakeup(&amp;s-&gt;listenr);

	qhangup(s-&gt;rq, reason);
	qhangup(s-&gt;wq, reason);

	tcpsetstate(s, Closed);
}

/* mtu (- TCP + IP hdr len) of 1st hop */
static int
tcpmtu(Proto *tcp, uchar *addr, int version, uint *scale)
{
	Ipifc *ifc;
	int mtu;

	ifc = findipifc(tcp-&gt;f, addr, 0);
	switch(version){
	default:
	case V4:
		mtu = DEF_MSS;
		if(ifc != nil)
			mtu = ifc-&gt;maxtu - ifc-&gt;m-&gt;hsize - (TCP4_PKT + TCP4_HDRSIZE);
		break;
	case V6:
		mtu = DEF_MSS6;
		if(ifc != nil)
			mtu = ifc-&gt;maxtu - ifc-&gt;m-&gt;hsize - (TCP6_PKT + TCP6_HDRSIZE);
		break;
	}
	/*
	 * set the ws.  it doesn't commit us to anything.
	 * ws is the ultimate limit to the bandwidth-delay product.
	 */
	*scale = Defadvscale;

	return mtu;
}

static void
inittcpctl(Conv *s, int mode)
{
	Tcpctl *tcb;
	Tcp4hdr* h4;
	Tcp6hdr* h6;
	Tcppriv *tpriv;
	int mss;

	tcb = (Tcpctl*)s-&gt;ptcl;

	memset(tcb, 0, sizeof(Tcpctl));

	tcb-&gt;ssthresh = QMAX;			/* reset by tcpsetscale() */
	tcb-&gt;srtt = tcp_irtt&lt;&lt;LOGAGAIN;
	tcb-&gt;mdev = 0;

	/* setup timers */
	tcb-&gt;timer.start = tcp_irtt / MSPTICK;
	tcb-&gt;timer.func = tcptimeout;
	tcb-&gt;timer.arg = s;
	tcb-&gt;rtt_timer.start = MAX_TIME;
	tcb-&gt;acktimer.start = TCP_ACK / MSPTICK;
	tcb-&gt;acktimer.func = tcpacktimer;
	tcb-&gt;acktimer.arg = s;
	tcb-&gt;katimer.start = DEF_KAT / MSPTICK;
	tcb-&gt;katimer.func = tcpkeepalive;
	tcb-&gt;katimer.arg = s;

	mss = DEF_MSS;

	/* create a prototype(pseudo) header */
	if(mode != TCP_LISTEN){
		if(ipcmp(s-&gt;laddr, IPnoaddr) == 0)
			findlocalip(s-&gt;p-&gt;f, s-&gt;laddr, s-&gt;raddr);

		switch(s-&gt;ipversion){
		case V4:
			h4 = &amp;tcb-&gt;protohdr.tcp4hdr;
			memset(h4, 0, sizeof(*h4));
			h4-&gt;proto = IP_TCPPROTO;
			hnputs(h4-&gt;tcpsport, s-&gt;lport);
			hnputs(h4-&gt;tcpdport, s-&gt;rport);
			v6tov4(h4-&gt;tcpsrc, s-&gt;laddr);
			v6tov4(h4-&gt;tcpdst, s-&gt;raddr);
			break;
		case V6:
			h6 = &amp;tcb-&gt;protohdr.tcp6hdr;
			memset(h6, 0, sizeof(*h6));
			h6-&gt;proto = IP_TCPPROTO;
			hnputs(h6-&gt;tcpsport, s-&gt;lport);
			hnputs(h6-&gt;tcpdport, s-&gt;rport);
			ipmove(h6-&gt;tcpsrc, s-&gt;laddr);
			ipmove(h6-&gt;tcpdst, s-&gt;raddr);
			mss = DEF_MSS6;
			break;
		default:
			panic("inittcpctl: version %d", s-&gt;ipversion);
		}
	}

	tcb-&gt;mss = tcb-&gt;cwind = mss;
	tcb-&gt;abcbytes = 0;
	tpriv = s-&gt;p-&gt;priv;
	tpriv-&gt;stats[Mss] = tcb-&gt;mss;

	/* default is no window scaling */
	tcpsetscale(s, tcb, 0, 0);
}

/*
 *  called with s qlocked
 */
static void
tcpstart(Conv *s, int mode)
{
	Tcpctl *tcb;
	Tcppriv *tpriv;
	char kpname[KNAMELEN];

	tpriv = s-&gt;p-&gt;priv;

	if(tpriv-&gt;ackprocstarted == 0){
		qlock(&amp;tpriv-&gt;apl);
		if(tpriv-&gt;ackprocstarted == 0){
			snprint(kpname, sizeof kpname, "#I%dtcpack", s-&gt;p-&gt;f-&gt;dev);
			kproc(kpname, tcpackproc, s-&gt;p);
			tpriv-&gt;ackprocstarted = 1;
		}
		qunlock(&amp;tpriv-&gt;apl);
	}

	tcb = (Tcpctl*)s-&gt;ptcl;

	inittcpctl(s, mode);

	iphtadd(&amp;tpriv-&gt;ht, s);
	switch(mode) {
	case TCP_LISTEN:
		tpriv-&gt;stats[PassiveOpens]++;
		tcb-&gt;flags |= CLONE;
		tcpsetstate(s, Listen);
		break;

	case TCP_CONNECT:
		tpriv-&gt;stats[ActiveOpens]++;
		tcb-&gt;flags |= ACTIVE;
		tcpsndsyn(s, tcb);
		tcpsetstate(s, Syn_sent);
		tcpoutput(s);
		break;
	}
}

static char*
tcpflag(char *buf, char *e, ushort flag)
{
	char *p;

	p = seprint(buf, e, "%d", flag&gt;&gt;10);	/* Head len */
	if(flag &amp; URG)
		p = seprint(p, e, " URG");
	if(flag &amp; ACK)
		p = seprint(p, e, " ACK");
	if(flag &amp; PSH)
		p = seprint(p, e, " PSH");
	if(flag &amp; RST)
		p = seprint(p, e, " RST");
	if(flag &amp; SYN)
		p = seprint(p, e, " SYN");
	if(flag &amp; FIN)
		p = seprint(p, e, " FIN");
	USED(p);
	return buf;
}

static Block*
htontcp6(Tcp *tcph, Block *data, Tcp6hdr *ph, Tcpctl *tcb)
{
	int dlen;
	Tcp6hdr *h;
	ushort csum;
	ushort hdrlen, optpad = 0;
	uchar *opt;

	hdrlen = TCP6_HDRSIZE;
	if(tcph-&gt;flags &amp; SYN){
		if(tcph-&gt;mss)
			hdrlen += MSS_LENGTH;
		if(tcph-&gt;ws)
			hdrlen += WS_LENGTH;
		optpad = hdrlen &amp; 3;
		if(optpad)
			optpad = 4 - optpad;
		hdrlen += optpad;
	}

	if(data) {
		dlen = blocklen(data);
		data = padblock(data, hdrlen + TCP6_PKT);
		if(data == nil)
			return nil;
	}
	else {
		dlen = 0;
		data = allocb(hdrlen + TCP6_PKT + 64);	/* the 64 pad is to meet mintu's */
		if(data == nil)
			return nil;
		data-&gt;wp += hdrlen + TCP6_PKT;
	}

	/* copy in pseudo ip header plus port numbers */
	h = (Tcp6hdr *)(data-&gt;rp);
	memmove(h, ph, TCP6_TCBPHDRSZ);

	/* compose pseudo tcp header, do cksum calculation */
	hnputl(h-&gt;vcf, hdrlen + dlen);
	h-&gt;ploadlen[0] = h-&gt;ploadlen[1] = h-&gt;proto = 0;
	h-&gt;ttl = ph-&gt;proto;

	/* copy in variable bits */
	hnputl(h-&gt;tcpseq, tcph-&gt;seq);
	hnputl(h-&gt;tcpack, tcph-&gt;ack);
	hnputs(h-&gt;tcpflag, (hdrlen&lt;&lt;10) | tcph-&gt;flags);
	hnputs(h-&gt;tcpwin, tcph-&gt;wnd&gt;&gt;(tcb != nil ? tcb-&gt;snd.scale : 0));
	hnputs(h-&gt;tcpurg, tcph-&gt;urg);

	if(tcph-&gt;flags &amp; SYN){
		opt = h-&gt;tcpopt;
		if(tcph-&gt;mss != 0){
			*opt++ = MSSOPT;
			*opt++ = MSS_LENGTH;
			hnputs(opt, tcph-&gt;mss);
			opt += 2;
		}
		if(tcph-&gt;ws != 0){
			*opt++ = WSOPT;
			*opt++ = WS_LENGTH;
			*opt++ = tcph-&gt;ws;
		}
		while(optpad-- &gt; 0)
			*opt++ = NOOPOPT;
	}

	if(tcb != nil &amp;&amp; tcb-&gt;nochecksum){
		h-&gt;tcpcksum[0] = h-&gt;tcpcksum[1] = 0;
	} else {
		csum = ptclcsum(data, TCP6_IPLEN, hdrlen+dlen+TCP6_PHDRSIZE);
		hnputs(h-&gt;tcpcksum, csum);
	}

	/* move from pseudo header back to normal ip header */
	memset(h-&gt;vcf, 0, 4);
	h-&gt;vcf[0] = IP_VER6;
	hnputs(h-&gt;ploadlen, hdrlen+dlen);
	h-&gt;proto = ph-&gt;proto;

	return data;
}

static Block*
htontcp4(Tcp *tcph, Block *data, Tcp4hdr *ph, Tcpctl *tcb)
{
	int dlen;
	Tcp4hdr *h;
	ushort csum;
	ushort hdrlen, optpad = 0;
	uchar *opt;

	hdrlen = TCP4_HDRSIZE;
	if(tcph-&gt;flags &amp; SYN){
		if(tcph-&gt;mss)
			hdrlen += MSS_LENGTH;
		if(1)
			hdrlen += WS_LENGTH;
		optpad = hdrlen &amp; 3;
		if(optpad)
			optpad = 4 - optpad;
		hdrlen += optpad;
	}

	if(data) {
		dlen = blocklen(data);
		data = padblock(data, hdrlen + TCP4_PKT);
		if(data == nil)
			return nil;
	}
	else {
		dlen = 0;
		data = allocb(hdrlen + TCP4_PKT + 64);	/* the 64 pad is to meet mintu's */
		if(data == nil)
			return nil;
		data-&gt;wp += hdrlen + TCP4_PKT;
	}

	/* copy in pseudo ip header plus port numbers */
	h = (Tcp4hdr *)(data-&gt;rp);
	memmove(h, ph, TCP4_TCBPHDRSZ);

	/* copy in variable bits */
	hnputs(h-&gt;tcplen, hdrlen + dlen);
	hnputl(h-&gt;tcpseq, tcph-&gt;seq);
	hnputl(h-&gt;tcpack, tcph-&gt;ack);
	hnputs(h-&gt;tcpflag, (hdrlen&lt;&lt;10) | tcph-&gt;flags);
	hnputs(h-&gt;tcpwin, tcph-&gt;wnd&gt;&gt;(tcb != nil ? tcb-&gt;snd.scale : 0));
	hnputs(h-&gt;tcpurg, tcph-&gt;urg);

	if(tcph-&gt;flags &amp; SYN){
		opt = h-&gt;tcpopt;
		if(tcph-&gt;mss != 0){
			*opt++ = MSSOPT;
			*opt++ = MSS_LENGTH;
			hnputs(opt, tcph-&gt;mss);
			opt += 2;
		}
		/* always offer.  rfc1323 §2.2 */
		if(1){
			*opt++ = WSOPT;
			*opt++ = WS_LENGTH;
			*opt++ = tcph-&gt;ws;
		}
		while(optpad-- &gt; 0)
			*opt++ = NOOPOPT;
	}

	if(tcb != nil &amp;&amp; tcb-&gt;nochecksum){
		h-&gt;tcpcksum[0] = h-&gt;tcpcksum[1] = 0;
	} else {
		csum = ptclcsum(data, TCP4_IPLEN, hdrlen+dlen+TCP4_PHDRSIZE);
		hnputs(h-&gt;tcpcksum, csum);
	}

	return data;
}

static int
ntohtcp6(Tcp *tcph, Block **bpp)
{
	Tcp6hdr *h;
	uchar *optr;
	ushort hdrlen;
	ushort optlen;
	int n;

	*bpp = pullupblock(*bpp, TCP6_PKT+TCP6_HDRSIZE);
	if(*bpp == nil)
		return -1;

	h = (Tcp6hdr *)((*bpp)-&gt;rp);
	tcph-&gt;source = nhgets(h-&gt;tcpsport);
	tcph-&gt;dest = nhgets(h-&gt;tcpdport);
	tcph-&gt;seq = nhgetl(h-&gt;tcpseq);
	tcph-&gt;ack = nhgetl(h-&gt;tcpack);
	hdrlen = (h-&gt;tcpflag[0]&gt;&gt;2) &amp; ~3;
	if(hdrlen &lt; TCP6_HDRSIZE) {
		freeblist(*bpp);
		return -1;
	}

	tcph-&gt;flags = h-&gt;tcpflag[1];
	tcph-&gt;wnd = nhgets(h-&gt;tcpwin);
	tcph-&gt;urg = nhgets(h-&gt;tcpurg);
	tcph-&gt;mss = 0;
	tcph-&gt;ws = 0;
	tcph-&gt;update = 0;
	tcph-&gt;len = nhgets(h-&gt;ploadlen) - hdrlen;

	*bpp = pullupblock(*bpp, hdrlen+TCP6_PKT);
	if(*bpp == nil)
		return -1;

	optr = h-&gt;tcpopt;
	n = hdrlen - TCP6_HDRSIZE;
	while(n &gt; 0 &amp;&amp; *optr != EOLOPT) {
		if(*optr == NOOPOPT) {
			n--;
			optr++;
			continue;
		}
		optlen = optr[1];
		if(optlen &lt; 2 || optlen &gt; n)
			break;
		switch(*optr) {
		case MSSOPT:
			if(optlen == MSS_LENGTH)
				tcph-&gt;mss = nhgets(optr+2);
			break;
		case WSOPT:
			if(optlen == WS_LENGTH &amp;&amp; *(optr+2) &lt;= 14)
				tcph-&gt;ws = *(optr+2);
			break;
		}
		n -= optlen;
		optr += optlen;
	}
	return hdrlen;
}

static int
ntohtcp4(Tcp *tcph, Block **bpp)
{
	Tcp4hdr *h;
	uchar *optr;
	ushort hdrlen;
	ushort optlen;
	int n;

	*bpp = pullupblock(*bpp, TCP4_PKT+TCP4_HDRSIZE);
	if(*bpp == nil)
		return -1;

	h = (Tcp4hdr *)((*bpp)-&gt;rp);
	tcph-&gt;source = nhgets(h-&gt;tcpsport);
	tcph-&gt;dest = nhgets(h-&gt;tcpdport);
	tcph-&gt;seq = nhgetl(h-&gt;tcpseq);
	tcph-&gt;ack = nhgetl(h-&gt;tcpack);

	hdrlen = (h-&gt;tcpflag[0]&gt;&gt;2) &amp; ~3;
	if(hdrlen &lt; TCP4_HDRSIZE) {
		freeblist(*bpp);
		return -1;
	}

	tcph-&gt;flags = h-&gt;tcpflag[1];
	tcph-&gt;wnd = nhgets(h-&gt;tcpwin);
	tcph-&gt;urg = nhgets(h-&gt;tcpurg);
	tcph-&gt;mss = 0;
	tcph-&gt;ws = 0;
	tcph-&gt;update = 0;
	tcph-&gt;len = nhgets(h-&gt;length) - (hdrlen + TCP4_PKT);

	*bpp = pullupblock(*bpp, hdrlen+TCP4_PKT);
	if(*bpp == nil)
		return -1;

	optr = h-&gt;tcpopt;
	n = hdrlen - TCP4_HDRSIZE;
	while(n &gt; 0 &amp;&amp; *optr != EOLOPT) {
		if(*optr == NOOPOPT) {
			n--;
			optr++;
			continue;
		}
		optlen = optr[1];
		if(optlen &lt; 2 || optlen &gt; n)
			break;
		switch(*optr) {
		case MSSOPT:
			if(optlen == MSS_LENGTH)
				tcph-&gt;mss = nhgets(optr+2);
			break;
		case WSOPT:
			if(optlen == WS_LENGTH &amp;&amp; *(optr+2) &lt;= 14)
				tcph-&gt;ws = *(optr+2);
			break;
		}
		n -= optlen;
		optr += optlen;
	}
	return hdrlen;
}

/*
 *  For outgoing calls, generate an initial sequence
 *  number and put a SYN on the send queue
 */
static void
tcpsndsyn(Conv *s, Tcpctl *tcb)
{
	Tcppriv *tpriv;

	tcb-&gt;iss = (nrand(1&lt;&lt;16)&lt;&lt;16)|nrand(1&lt;&lt;16);
	tcb-&gt;rttseq = tcb-&gt;iss;
	tcb-&gt;snd.wl2 = tcb-&gt;iss;
	tcb-&gt;snd.una = tcb-&gt;iss;
	tcb-&gt;snd.rxt = tcb-&gt;iss;
	tcb-&gt;snd.ptr = tcb-&gt;rttseq;
	tcb-&gt;snd.nxt = tcb-&gt;rttseq;
	tcb-&gt;flgcnt++;
	tcb-&gt;flags |= FORCE;
	tcb-&gt;sndsyntime = NOW;

	/* set desired mss and scale */
	tcb-&gt;mss = tcpmtu(s-&gt;p, s-&gt;laddr, s-&gt;ipversion, &amp;tcb-&gt;scale);
	tpriv = s-&gt;p-&gt;priv;
	tpriv-&gt;stats[Mss] = tcb-&gt;mss;
}

void
sndrst(Proto *tcp, uchar *source, uchar *dest, ushort length, Tcp *seg, uchar version, char *reason)
{
	Block *hbp;
	uchar rflags;
	Tcppriv *tpriv;
	Tcp4hdr ph4;
	Tcp6hdr ph6;

	netlog(tcp-&gt;f, Logtcp, "sndrst: %s\n", reason);

	tpriv = tcp-&gt;priv;

	if(seg-&gt;flags &amp; RST)
		return;

	/* make pseudo header */
	switch(version) {
	case V4:
		memset(&amp;ph4, 0, sizeof(ph4));
		ph4.vihl = IP_VER4;
		v6tov4(ph4.tcpsrc, dest);
		v6tov4(ph4.tcpdst, source);
		ph4.proto = IP_TCPPROTO;
		hnputs(ph4.tcplen, TCP4_HDRSIZE);
		hnputs(ph4.tcpsport, seg-&gt;dest);
		hnputs(ph4.tcpdport, seg-&gt;source);
		break;
	case V6:
		memset(&amp;ph6, 0, sizeof(ph6));
		ph6.vcf[0] = IP_VER6;
		ipmove(ph6.tcpsrc, dest);
		ipmove(ph6.tcpdst, source);
		ph6.proto = IP_TCPPROTO;
		hnputs(ph6.ploadlen, TCP6_HDRSIZE);
		hnputs(ph6.tcpsport, seg-&gt;dest);
		hnputs(ph6.tcpdport, seg-&gt;source);
		break;
	default:
		panic("sndrst: version %d", version);
	}

	tpriv-&gt;stats[OutRsts]++;
	rflags = RST;

	/* convince the other end that this reset is in band */
	if(seg-&gt;flags &amp; ACK) {
		seg-&gt;seq = seg-&gt;ack;
		seg-&gt;ack = 0;
	}
	else {
		rflags |= ACK;
		seg-&gt;ack = seg-&gt;seq;
		seg-&gt;seq = 0;
		if(seg-&gt;flags &amp; SYN)
			seg-&gt;ack++;
		seg-&gt;ack += length;
		if(seg-&gt;flags &amp; FIN)
			seg-&gt;ack++;
	}
	seg-&gt;flags = rflags;
	seg-&gt;wnd = 0;
	seg-&gt;urg = 0;
	seg-&gt;mss = 0;
	seg-&gt;ws = 0;
	switch(version) {
	case V4:
		hbp = htontcp4(seg, nil, &amp;ph4, nil);
		if(hbp == nil)
			return;
		ipoput4(tcp-&gt;f, hbp, 0, MAXTTL, DFLTTOS, nil);
		break;
	case V6:
		hbp = htontcp6(seg, nil, &amp;ph6, nil);
		if(hbp == nil)
			return;
		ipoput6(tcp-&gt;f, hbp, 0, MAXTTL, DFLTTOS, nil);
		break;
	default:
		panic("sndrst2: version %d", version);
	}
}

/*
 *  send a reset to the remote side and close the conversation
 *  called with s qlocked
 */
static char*
tcphangup(Conv *s)
{
	Tcp seg;
	Tcpctl *tcb;
	Block *hbp;

	tcb = (Tcpctl*)s-&gt;ptcl;
	if(waserror())
		return commonerror();
	if(ipcmp(s-&gt;raddr, IPnoaddr) != 0) {
		if(!waserror()){
			memset(&amp;seg, 0, sizeof seg);
			seg.flags = RST | ACK;
			seg.ack = tcb-&gt;rcv.nxt;
			tcb-&gt;rcv.ackptr = seg.ack;
			seg.seq = tcb-&gt;snd.ptr;
			seg.wnd = 0;
			seg.urg = 0;
			seg.mss = 0;
			seg.ws = 0;
			switch(s-&gt;ipversion) {
			case V4:
				tcb-&gt;protohdr.tcp4hdr.vihl = IP_VER4;
				hbp = htontcp4(&amp;seg, nil, &amp;tcb-&gt;protohdr.tcp4hdr, tcb);
				ipoput4(s-&gt;p-&gt;f, hbp, 0, s-&gt;ttl, s-&gt;tos, s);
				break;
			case V6:
				tcb-&gt;protohdr.tcp6hdr.vcf[0] = IP_VER6;
				hbp = htontcp6(&amp;seg, nil, &amp;tcb-&gt;protohdr.tcp6hdr, tcb);
				ipoput6(s-&gt;p-&gt;f, hbp, 0, s-&gt;ttl, s-&gt;tos, s);
				break;
			default:
				panic("tcphangup: version %d", s-&gt;ipversion);
			}
			poperror();
		}
	}
	localclose(s, nil);
	poperror();
	return nil;
}

/*
 *  (re)send a SYN ACK
 */
static int
sndsynack(Proto *tcp, Limbo *lp)
{
	Block *hbp;
	Tcp4hdr ph4;
	Tcp6hdr ph6;
	Tcp seg;
	uint scale;

	/* make pseudo header */
	switch(lp-&gt;version) {
	case V4:
		memset(&amp;ph4, 0, sizeof(ph4));
		ph4.vihl = IP_VER4;
		v6tov4(ph4.tcpsrc, lp-&gt;laddr);
		v6tov4(ph4.tcpdst, lp-&gt;raddr);
		ph4.proto = IP_TCPPROTO;
		hnputs(ph4.tcplen, TCP4_HDRSIZE);
		hnputs(ph4.tcpsport, lp-&gt;lport);
		hnputs(ph4.tcpdport, lp-&gt;rport);
		break;
	case V6:
		memset(&amp;ph6, 0, sizeof(ph6));
		ph6.vcf[0] = IP_VER6;
		ipmove(ph6.tcpsrc, lp-&gt;laddr);
		ipmove(ph6.tcpdst, lp-&gt;raddr);
		ph6.proto = IP_TCPPROTO;
		hnputs(ph6.ploadlen, TCP6_HDRSIZE);
		hnputs(ph6.tcpsport, lp-&gt;lport);
		hnputs(ph6.tcpdport, lp-&gt;rport);
		break;
	default:
		panic("sndrst: version %d", lp-&gt;version);
	}

	memset(&amp;seg, 0, sizeof seg);
	seg.seq = lp-&gt;iss;
	seg.ack = lp-&gt;irs+1;
	seg.flags = SYN|ACK;
	seg.urg = 0;
	seg.mss = tcpmtu(tcp, lp-&gt;laddr, lp-&gt;version, &amp;scale);
	seg.wnd = QMAX;

	/* if the other side set scale, we should too */
	if(lp-&gt;rcvscale){
		seg.ws = scale;
		lp-&gt;sndscale = scale;
	} else {
		seg.ws = 0;
		lp-&gt;sndscale = 0;
	}

	switch(lp-&gt;version) {
	case V4:
		hbp = htontcp4(&amp;seg, nil, &amp;ph4, nil);
		if(hbp == nil)
			return -1;
		ipoput4(tcp-&gt;f, hbp, 0, MAXTTL, DFLTTOS, nil);
		break;
	case V6:
		hbp = htontcp6(&amp;seg, nil, &amp;ph6, nil);
		if(hbp == nil)
			return -1;
		ipoput6(tcp-&gt;f, hbp, 0, MAXTTL, DFLTTOS, nil);
		break;
	default:
		panic("sndsnack: version %d", lp-&gt;version);
	}
	lp-&gt;lastsend = NOW;
	return 0;
}

#define hashipa(a, p) ( ( (a)[IPaddrlen-2] + (a)[IPaddrlen-1] + p )&amp;LHTMASK )

/*
 *  put a call into limbo and respond with a SYN ACK
 *
 *  called with proto locked
 */
static void
limbo(Conv *s, uchar *source, uchar *dest, Tcp *seg, int version)
{
	Limbo *lp, **l;
	Tcppriv *tpriv;
	int h;

	tpriv = s-&gt;p-&gt;priv;
	h = hashipa(source, seg-&gt;source);

	for(l = &amp;tpriv-&gt;lht[h]; *l != nil; l = &amp;lp-&gt;next){
		lp = *l;
		if(lp-&gt;lport != seg-&gt;dest || lp-&gt;rport != seg-&gt;source || lp-&gt;version != version)
			continue;
		if(ipcmp(lp-&gt;raddr, source) != 0)
			continue;
		if(ipcmp(lp-&gt;laddr, dest) != 0)
			continue;

		/* each new SYN restarts the retransmits */
		lp-&gt;irs = seg-&gt;seq;
		break;
	}
	lp = *l;
	if(lp == nil){
		if(tpriv-&gt;nlimbo &gt;= Maxlimbo &amp;&amp; tpriv-&gt;lht[h]){
			lp = tpriv-&gt;lht[h];
			tpriv-&gt;lht[h] = lp-&gt;next;
			lp-&gt;next = nil;
		} else {
			lp = malloc(sizeof(*lp));
			if(lp == nil)
				return;
			tpriv-&gt;nlimbo++;
		}
		*l = lp;
		lp-&gt;version = version;
		ipmove(lp-&gt;laddr, dest);
		ipmove(lp-&gt;raddr, source);
		lp-&gt;lport = seg-&gt;dest;
		lp-&gt;rport = seg-&gt;source;
		lp-&gt;mss = seg-&gt;mss;
		lp-&gt;rcvscale = seg-&gt;ws;
		lp-&gt;irs = seg-&gt;seq;
		lp-&gt;iss = (nrand(1&lt;&lt;16)&lt;&lt;16)|nrand(1&lt;&lt;16);
	}

	if(sndsynack(s-&gt;p, lp) &lt; 0){
		*l = lp-&gt;next;
		tpriv-&gt;nlimbo--;
		free(lp);
	}
}

/*
 *  resend SYN ACK's once every SYNACK_RXTIMER ms.
 */
static void
limborexmit(Proto *tcp)
{
	Tcppriv *tpriv;
	Limbo **l, *lp;
	int h;
	int seen;
	ulong now;

	tpriv = tcp-&gt;priv;

	if(!canqlock(tcp))
		return;
	seen = 0;
	now = NOW;
	for(h = 0; h &lt; NLHT &amp;&amp; seen &lt; tpriv-&gt;nlimbo; h++){
		for(l = &amp;tpriv-&gt;lht[h]; *l != nil &amp;&amp; seen &lt; tpriv-&gt;nlimbo; ){
			lp = *l;
			seen++;
			if(now - lp-&gt;lastsend &lt; (lp-&gt;rexmits+1)*SYNACK_RXTIMER)
				continue;

			/* time it out after 1 second */
			if(++(lp-&gt;rexmits) &gt; 5){
				tpriv-&gt;nlimbo--;
				*l = lp-&gt;next;
				free(lp);
				continue;
			}

			/* if we're being attacked, don't bother resending SYN ACK's */
			if(tpriv-&gt;nlimbo &gt; 100)
				continue;

			if(sndsynack(tcp, lp) &lt; 0){
				tpriv-&gt;nlimbo--;
				*l = lp-&gt;next;
				free(lp);
				continue;
			}

			l = &amp;lp-&gt;next;
		}
	}
	qunlock(tcp);
}

/*
 *  lookup call in limbo.  if found, throw it out.
 *
 *  called with proto locked
 */
static void
limborst(Conv *s, Tcp *segp, uchar *src, uchar *dst, uchar version)
{
	Limbo *lp, **l;
	int h;
	Tcppriv *tpriv;

	tpriv = s-&gt;p-&gt;priv;

	/* find a call in limbo */
	h = hashipa(src, segp-&gt;source);
	for(l = &amp;tpriv-&gt;lht[h]; *l != nil; l = &amp;lp-&gt;next){
		lp = *l;
		if(lp-&gt;lport != segp-&gt;dest || lp-&gt;rport != segp-&gt;source || lp-&gt;version != version)
			continue;
		if(ipcmp(lp-&gt;laddr, dst) != 0)
			continue;
		if(ipcmp(lp-&gt;raddr, src) != 0)
			continue;

		/* RST can only follow the SYN */
		if(segp-&gt;seq == lp-&gt;irs+1){
			tpriv-&gt;nlimbo--;
			*l = lp-&gt;next;
			free(lp);
		}
		break;
	}
}

static void
initialwindow(Tcpctl *tcb)
{
	/* RFC 3390 initial window */
	if(tcb-&gt;mss &lt; 1095)
		tcb-&gt;cwind = 4*tcb-&gt;mss;
	else if(tcb-&gt;mss &lt; 2190)
		tcb-&gt;cwind = 2*2190;
	else
		tcb-&gt;cwind = 2*tcb-&gt;mss;
}

/*
 *  come here when we finally get an ACK to our SYN-ACK.
 *  lookup call in limbo.  if found, create a new conversation
 *
 *  called with proto locked
 */
static Conv*
tcpincoming(Conv *s, Tcp *segp, uchar *src, uchar *dst, uchar version)
{
	Conv *new;
	Tcpctl *tcb;
	Tcppriv *tpriv;
	Tcp4hdr *h4;
	Tcp6hdr *h6;
	Limbo *lp, **l;
	int h;

	/* unless it's just an ack, it can't be someone coming out of limbo */
	if((segp-&gt;flags &amp; SYN) || (segp-&gt;flags &amp; ACK) == 0)
		return nil;

	tpriv = s-&gt;p-&gt;priv;

	/* find a call in limbo */
	h = hashipa(src, segp-&gt;source);
	for(l = &amp;tpriv-&gt;lht[h]; (lp = *l) != nil; l = &amp;lp-&gt;next){
		netlog(s-&gt;p-&gt;f, Logtcp, "tcpincoming s %I!%ud/%I!%ud d %I!%ud/%I!%ud v %d/%d\n",
			src, segp-&gt;source, lp-&gt;raddr, lp-&gt;rport,
			dst, segp-&gt;dest, lp-&gt;laddr, lp-&gt;lport,
			version, lp-&gt;version
 		);

		if(lp-&gt;lport != segp-&gt;dest || lp-&gt;rport != segp-&gt;source || lp-&gt;version != version)
			continue;
		if(ipcmp(lp-&gt;laddr, dst) != 0)
			continue;
		if(ipcmp(lp-&gt;raddr, src) != 0)
			continue;

		/* we're assuming no data with the initial SYN */
		if(segp-&gt;seq != lp-&gt;irs+1 || segp-&gt;ack != lp-&gt;iss+1){
			netlog(s-&gt;p-&gt;f, Logtcp, "tcpincoming s %lux/%lux a %lux %lux\n",
				segp-&gt;seq, lp-&gt;irs+1, segp-&gt;ack, lp-&gt;iss+1);
			lp = nil;
		} else {
			tpriv-&gt;nlimbo--;
			*l = lp-&gt;next;
		}
		break;
	}
	if(lp == nil)
		return nil;

	new = Fsnewcall(s, src, segp-&gt;source, dst, segp-&gt;dest, version);
	if(new == nil)
		return nil;

	memmove(new-&gt;ptcl, s-&gt;ptcl, sizeof(Tcpctl));
	tcb = (Tcpctl*)new-&gt;ptcl;
	tcb-&gt;flags &amp;= ~CLONE;
	tcb-&gt;timer.arg = new;
	tcb-&gt;timer.state = TcptimerOFF;
	tcb-&gt;acktimer.arg = new;
	tcb-&gt;acktimer.state = TcptimerOFF;
	tcb-&gt;katimer.arg = new;
	tcb-&gt;katimer.state = TcptimerOFF;
	tcb-&gt;rtt_timer.arg = new;
	tcb-&gt;rtt_timer.state = TcptimerOFF;

	tcb-&gt;irs = lp-&gt;irs;
	tcb-&gt;rcv.nxt = tcb-&gt;irs+1;
	tcb-&gt;rcv.wptr = tcb-&gt;rcv.nxt;
	tcb-&gt;rcv.wsnt = 0;
	tcb-&gt;rcv.urg = tcb-&gt;rcv.nxt;

	tcb-&gt;iss = lp-&gt;iss;
	tcb-&gt;rttseq = tcb-&gt;iss;
	tcb-&gt;snd.wl2 = tcb-&gt;iss;
	tcb-&gt;snd.una = tcb-&gt;iss+1;
	tcb-&gt;snd.ptr = tcb-&gt;iss+1;
	tcb-&gt;snd.nxt = tcb-&gt;iss+1;
	tcb-&gt;snd.rxt = tcb-&gt;iss+1;
	tcb-&gt;flgcnt = 0;
	tcb-&gt;flags |= SYNACK;

	/* our sending max segment size cannot be bigger than what he asked for */
	if(lp-&gt;mss != 0 &amp;&amp; lp-&gt;mss &lt; tcb-&gt;mss) {
		tcb-&gt;mss = lp-&gt;mss;
		tpriv-&gt;stats[Mss] = tcb-&gt;mss;
	}

	/* window scaling */
	tcpsetscale(new, tcb, lp-&gt;rcvscale, lp-&gt;sndscale);

	/* congestion window */
	tcb-&gt;snd.wnd = segp-&gt;wnd;
	initialwindow(tcb);

	/* set initial round trip time */
	tcb-&gt;sndsyntime = lp-&gt;lastsend+lp-&gt;rexmits*SYNACK_RXTIMER;
	tcpsynackrtt(new);

	free(lp);

	/* set up proto header */
	switch(version){
	case V4:
		h4 = &amp;tcb-&gt;protohdr.tcp4hdr;
		memset(h4, 0, sizeof(*h4));
		h4-&gt;proto = IP_TCPPROTO;
		hnputs(h4-&gt;tcpsport, new-&gt;lport);
		hnputs(h4-&gt;tcpdport, new-&gt;rport);
		v6tov4(h4-&gt;tcpsrc, dst);
		v6tov4(h4-&gt;tcpdst, src);
		break;
	case V6:
		h6 = &amp;tcb-&gt;protohdr.tcp6hdr;
		memset(h6, 0, sizeof(*h6));
		h6-&gt;proto = IP_TCPPROTO;
		hnputs(h6-&gt;tcpsport, new-&gt;lport);
		hnputs(h6-&gt;tcpdport, new-&gt;rport);
		ipmove(h6-&gt;tcpsrc, dst);
		ipmove(h6-&gt;tcpdst, src);
		break;
	default:
		panic("tcpincoming: version %d", new-&gt;ipversion);
	}

	tcpsetstate(new, Established);

	iphtadd(&amp;tpriv-&gt;ht, new);

	return new;
}

static int
seq_within(ulong x, ulong low, ulong high)
{
	if(low &lt;= high){
		if(low &lt;= x &amp;&amp; x &lt;= high)
			return 1;
	}
	else {
		if(x &gt;= low || x &lt;= high)
			return 1;
	}
	return 0;
}

static int
seq_lt(ulong x, ulong y)
{
	return (int)(x-y) &lt; 0;
}

static int
seq_le(ulong x, ulong y)
{
	return (int)(x-y) &lt;= 0;
}

static int
seq_gt(ulong x, ulong y)
{
	return (int)(x-y) &gt; 0;
}

static int
seq_ge(ulong x, ulong y)
{
	return (int)(x-y) &gt;= 0;
}

/*
 *  use the time between the first SYN and it's ack as the
 *  initial round trip time
 */
static void
tcpsynackrtt(Conv *s)
{
	Tcpctl *tcb;
	int delta;
	Tcppriv *tpriv;

	tcb = (Tcpctl*)s-&gt;ptcl;
	tpriv = s-&gt;p-&gt;priv;

	delta = NOW - tcb-&gt;sndsyntime;
	tcb-&gt;srtt = delta&lt;&lt;LOGAGAIN;
	tcb-&gt;mdev = delta&lt;&lt;LOGDGAIN;

	/* halt round trip timer */
	tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
}

static void
update(Conv *s, Tcp *seg)
{
	int rtt, delta;
	Tcpctl *tcb;
	ulong acked;
	Tcppriv *tpriv;

	if(seg-&gt;update)
		return;
	seg-&gt;update = 1;

	tpriv = s-&gt;p-&gt;priv;
	tcb = (Tcpctl*)s-&gt;ptcl;

	/* catch zero-window updates, update window &amp; recover */
	if(tcb-&gt;snd.wnd == 0 &amp;&amp; seg-&gt;wnd &gt; 0 &amp;&amp;
	    seq_lt(seg-&gt;ack, tcb-&gt;snd.ptr)){
		netlog(s-&gt;p-&gt;f, Logtcp, "tcp: zwu ack %lud una %lud ptr %lud win %lud\n",
			seg-&gt;ack,  tcb-&gt;snd.una, tcb-&gt;snd.ptr, seg-&gt;wnd);
		tcb-&gt;snd.wnd = seg-&gt;wnd;
		goto recovery;
	}

	/* newreno fast retransmit */
	if(seg-&gt;ack == tcb-&gt;snd.una &amp;&amp; tcb-&gt;snd.una != tcb-&gt;snd.nxt &amp;&amp;
	    ++tcb-&gt;snd.dupacks == 3){		/* was TCPREXMTTHRESH */
recovery:
		if(tcb-&gt;snd.recovery){
			tpriv-&gt;stats[RecoveryCwind]++;
			tcb-&gt;cwind += tcb-&gt;mss;
		}else if(seq_le(tcb-&gt;snd.rxt, seg-&gt;ack)){
			tpriv-&gt;stats[Recovery]++;
			tcb-&gt;abcbytes = 0;
			tcb-&gt;snd.recovery = 1;
			tcb-&gt;snd.partialack = 0;
			tcb-&gt;snd.rxt = tcb-&gt;snd.nxt;
			tcpcongestion(tcb);
			tcb-&gt;cwind = tcb-&gt;ssthresh + 3*tcb-&gt;mss;
			netlog(s-&gt;p-&gt;f, Logtcpwin, "recovery inflate %ld ss %ld @%lud\n",
				tcb-&gt;cwind, tcb-&gt;ssthresh, tcb-&gt;snd.rxt);
			tcprxmit(s);
		}else{
			tpriv-&gt;stats[RecoveryNoSeq]++;
			netlog(s-&gt;p-&gt;f, Logtcpwin, "!recov %lud not ≤ %lud %ld\n",
				tcb-&gt;snd.rxt, seg-&gt;ack, tcb-&gt;snd.rxt - seg-&gt;ack);
			/* don't enter fast retransmit, don't change ssthresh */
		}
	}else if(tcb-&gt;snd.recovery){
		tpriv-&gt;stats[RecoveryCwind]++;
		tcb-&gt;cwind += tcb-&gt;mss;
	}

	/*
	 *  update window
	 */
	if(seq_gt(seg-&gt;ack, tcb-&gt;snd.wl2)
	|| (tcb-&gt;snd.wl2 == seg-&gt;ack &amp;&amp; seg-&gt;wnd &gt; tcb-&gt;snd.wnd)){
		/* clear dupack if we advance wl2 */
		if(tcb-&gt;snd.wl2 != seg-&gt;ack)
			tcb-&gt;snd.dupacks = 0;
		tcb-&gt;snd.wnd = seg-&gt;wnd;
		tcb-&gt;snd.wl2 = seg-&gt;ack;
	}

	if(!seq_gt(seg-&gt;ack, tcb-&gt;snd.una)){
		/*
		 *  don't let us hangup if sending into a closed window and
		 *  we're still getting acks
		 */
		if((tcb-&gt;flags&amp;RETRAN) &amp;&amp; tcb-&gt;snd.wnd == 0)
			tcb-&gt;backedoff = MAXBACKMS/4;
		return;
	}

	/* Compute the new send window size */
	acked = seg-&gt;ack - tcb-&gt;snd.una;

	/* avoid slow start and timers for SYN acks */
	if((tcb-&gt;flags &amp; SYNACK) == 0) {
		tcb-&gt;flags |= SYNACK;
		acked--;
		tcb-&gt;flgcnt--;
		goto done;
	}

	/*
	 * congestion control
	 */
	if(tcb-&gt;snd.recovery){
		if(seq_ge(seg-&gt;ack, tcb-&gt;snd.rxt)){
			/* recovery finished; deflate window */
			tpriv-&gt;stats[RecoveryDone]++;
			tcb-&gt;snd.dupacks = 0;
			tcb-&gt;snd.recovery = 0;
			tcb-&gt;cwind = (tcb-&gt;snd.nxt - tcb-&gt;snd.una) + tcb-&gt;mss;
			if(tcb-&gt;ssthresh &lt; tcb-&gt;cwind)
				tcb-&gt;cwind = tcb-&gt;ssthresh;
			netlog(s-&gt;p-&gt;f, Logtcpwin, "recovery deflate %ld %ld\n",
				tcb-&gt;cwind, tcb-&gt;ssthresh);
		} else {
			/* partial ack; we lost more than one segment */
			tpriv-&gt;stats[RecoveryPA]++;
			if(tcb-&gt;cwind &gt; acked)
				tcb-&gt;cwind -= acked;
			else{
				netlog(s-&gt;p-&gt;f, Logtcpwin, "partial ack neg\n");
				tcb-&gt;cwind = tcb-&gt;mss;
			}
			netlog(s-&gt;p-&gt;f, Logtcpwin, "partial ack %ld left %ld cwind %ld\n",
				acked, tcb-&gt;snd.rxt - seg-&gt;ack, tcb-&gt;cwind);

			if(acked &gt;= tcb-&gt;mss)
				tcb-&gt;cwind += tcb-&gt;mss;
			tcb-&gt;snd.partialack++;
		}
	} else
		tcpabcincr(tcb, acked);

	/* Adjust the timers according to the round trip time */
	/* TODO: fix sloppy treatment of overflow cases here. */
	if(tcb-&gt;rtt_timer.state == TcptimerON &amp;&amp; seq_ge(seg-&gt;ack, tcb-&gt;rttseq)) {
		tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
		if((tcb-&gt;flags&amp;RETRAN) == 0) {
			tcb-&gt;backoff = 0;
			tcb-&gt;backedoff = 0;
			rtt = tcb-&gt;rtt_timer.start - tcb-&gt;rtt_timer.count;
			if(rtt == 0)
				rtt = 1; /* else all close sys's will rexmit in 0 time */
			rtt *= MSPTICK;
			if(tcb-&gt;srtt == 0) {
				tcb-&gt;srtt = rtt &lt;&lt; LOGAGAIN;
				tcb-&gt;mdev = rtt &lt;&lt; LOGDGAIN;
			} else {
				delta = rtt - (tcb-&gt;srtt&gt;&gt;LOGAGAIN);
				tcb-&gt;srtt += delta;
				if(tcb-&gt;srtt &lt;= 0)
					tcb-&gt;srtt = 1;

				delta = abs(delta) - (tcb-&gt;mdev&gt;&gt;LOGDGAIN);
				tcb-&gt;mdev += delta;
				if(tcb-&gt;mdev &lt;= 0)
					tcb-&gt;mdev = 1;
			}
			tcpsettimer(tcb);
		}
	}

done:
	if(qdiscard(s-&gt;wq, acked) &lt; acked)
		tcb-&gt;flgcnt--;
	tcb-&gt;snd.una = seg-&gt;ack;

	/* newreno fast recovery */
	if(tcb-&gt;snd.recovery)
		tcprxmit(s);

	if(seq_gt(seg-&gt;ack, tcb-&gt;snd.urg))
		tcb-&gt;snd.urg = seg-&gt;ack;

	if(tcb-&gt;snd.una != tcb-&gt;snd.nxt){
		/* `impatient' variant */
		if(!tcb-&gt;snd.recovery || tcb-&gt;snd.partialack == 1){
			tcb-&gt;time = NOW;
			tcb-&gt;timeuna = tcb-&gt;snd.una;
			tcpgo(tpriv, &amp;tcb-&gt;timer);
		}
	} else
		tcphalt(tpriv, &amp;tcb-&gt;timer);

	if(seq_lt(tcb-&gt;snd.ptr, tcb-&gt;snd.una))
		tcb-&gt;snd.ptr = tcb-&gt;snd.una;

	if(!tcb-&gt;snd.recovery)
		tcb-&gt;flags &amp;= ~RETRAN;
	tcb-&gt;backoff = 0;
	tcb-&gt;backedoff = 0;
}

static void
tcpiput(Proto *tcp, Ipifc*, Block *bp)
{
	Tcp seg;
	Tcp4hdr *h4;
	Tcp6hdr *h6;
	int hdrlen;
	Tcpctl *tcb;
	ushort length, csum;
	uchar source[IPaddrlen], dest[IPaddrlen];
	Conv *s;
	Fs *f;
	Tcppriv *tpriv;
	uchar version;

	f = tcp-&gt;f;
	tpriv = tcp-&gt;priv;

	tpriv-&gt;stats[InSegs]++;

	h4 = (Tcp4hdr*)(bp-&gt;rp);
	h6 = (Tcp6hdr*)(bp-&gt;rp);

	if((h4-&gt;vihl&amp;0xF0)==IP_VER4) {
		version = V4;
		length = nhgets(h4-&gt;length);
		v4tov6(dest, h4-&gt;tcpdst);
		v4tov6(source, h4-&gt;tcpsrc);

		h4-&gt;Unused = 0;
		hnputs(h4-&gt;tcplen, length-TCP4_PKT);
		if(!(bp-&gt;flag &amp; Btcpck) &amp;&amp; (h4-&gt;tcpcksum[0] || h4-&gt;tcpcksum[1]) &amp;&amp;
			ptclcsum(bp, TCP4_IPLEN, length-TCP4_IPLEN)) {
			tpriv-&gt;stats[CsumErrs]++;
			tpriv-&gt;stats[InErrs]++;
			netlog(f, Logtcp, "bad tcp proto cksum\n");
			freeblist(bp);
			return;
		}

		hdrlen = ntohtcp4(&amp;seg, &amp;bp);
		if(hdrlen &lt; 0){
			tpriv-&gt;stats[HlenErrs]++;
			tpriv-&gt;stats[InErrs]++;
			netlog(f, Logtcp, "bad tcp hdr len\n");
			return;
		}

		/* trim the packet to the size claimed by the datagram */
		length -= hdrlen+TCP4_PKT;
		bp = trimblock(bp, hdrlen+TCP4_PKT, length);
		if(bp == nil){
			tpriv-&gt;stats[LenErrs]++;
			tpriv-&gt;stats[InErrs]++;
			netlog(f, Logtcp, "tcp len &lt; 0 after trim\n");
			return;
		}
	}
	else {
		int ttl = h6-&gt;ttl;
		int proto = h6-&gt;proto;

		version = V6;
		length = nhgets(h6-&gt;ploadlen);
		ipmove(dest, h6-&gt;tcpdst);
		ipmove(source, h6-&gt;tcpsrc);

		h6-&gt;ploadlen[0] = h6-&gt;ploadlen[1] = h6-&gt;proto = 0;
		h6-&gt;ttl = proto;
		hnputl(h6-&gt;vcf, length);
		if((h6-&gt;tcpcksum[0] || h6-&gt;tcpcksum[1]) &amp;&amp;
		    (csum = ptclcsum(bp, TCP6_IPLEN, length+TCP6_PHDRSIZE)) != 0) {
			tpriv-&gt;stats[CsumErrs]++;
			tpriv-&gt;stats[InErrs]++;
			netlog(f, Logtcp,
			    "bad tcpv6 proto cksum: got %#ux, computed %#ux\n",
				h6-&gt;tcpcksum[0]&lt;&lt;8 | h6-&gt;tcpcksum[1], csum);
			freeblist(bp);
			return;
		}
		h6-&gt;ttl = ttl;
		h6-&gt;proto = proto;
		hnputs(h6-&gt;ploadlen, length);

		hdrlen = ntohtcp6(&amp;seg, &amp;bp);
		if(hdrlen &lt; 0){
			tpriv-&gt;stats[HlenErrs]++;
			tpriv-&gt;stats[InErrs]++;
			netlog(f, Logtcp, "bad tcpv6 hdr len\n");
			return;
		}

		/* trim the packet to the size claimed by the datagram */
		length -= hdrlen;
		bp = trimblock(bp, hdrlen+TCP6_PKT, length);
		if(bp == nil){
			tpriv-&gt;stats[LenErrs]++;
			tpriv-&gt;stats[InErrs]++;
			netlog(f, Logtcp, "tcpv6 len &lt; 0 after trim\n");
			return;
		}
	}

	/* lock protocol while searching for a conversation */
	qlock(tcp);

	/* Look for a matching conversation */
	s = iphtlook(&amp;tpriv-&gt;ht, source, seg.source, dest, seg.dest);
	if(s == nil){
		netlog(f, Logtcp, "iphtlook(src %I!%d, dst %I!%d) failed\n",
			source, seg.source, dest, seg.dest);
reset:
		qunlock(tcp);
		sndrst(tcp, source, dest, length, &amp;seg, version, "no conversation");
		freeblist(bp);
		return;
	}

	/* if it's a listener, look for the right flags and get a new conv */
	tcb = (Tcpctl*)s-&gt;ptcl;
	if(tcb-&gt;state == Listen){
		if(seg.flags &amp; RST){
			limborst(s, &amp;seg, source, dest, version);
			qunlock(tcp);
			freeblist(bp);
			return;
		}

		/* if this is a new SYN, put the call into limbo */
		if((seg.flags &amp; SYN) &amp;&amp; (seg.flags &amp; ACK) == 0){
			limbo(s, source, dest, &amp;seg, version);
			qunlock(tcp);
			freeblist(bp);
			return;
		}

		/*
		 *  if there's a matching call in limbo, tcpincoming will
		 *  return it in state Syn_received
		 */
		s = tcpincoming(s, &amp;seg, source, dest, version);
		if(s == nil)
			goto reset;
	}

	/* The rest of the input state machine is run with the control block
	 * locked and implements the state machine directly out of the RFC.
	 * Out-of-band data is ignored - it was always a bad idea.
	 */
	tcb = (Tcpctl*)s-&gt;ptcl;
	if(waserror()){
		qunlock(s);
		nexterror();
	}
	qlock(s);
	qunlock(tcp);

	/* fix up window */
	seg.wnd &lt;&lt;= tcb-&gt;rcv.scale;

	/* every input packet in puts off the keep alive time out */
	tcpsetkacounter(tcb);

	switch(tcb-&gt;state) {
	case Closed:
		sndrst(tcp, source, dest, length, &amp;seg, version, "sending to Closed");
		goto raise;
	case Syn_sent:
		if(seg.flags &amp; ACK) {
			if(!seq_within(seg.ack, tcb-&gt;iss+1, tcb-&gt;snd.nxt)) {
				sndrst(tcp, source, dest, length, &amp;seg, version,
					 "bad seq in Syn_sent");
				goto raise;
			}
		}
		if(seg.flags &amp; RST) {
			if(seg.flags &amp; ACK)
				localclose(s, Econrefused);
			goto raise;
		}

		if(seg.flags &amp; SYN) {
			procsyn(s, &amp;seg);
			if(seg.flags &amp; ACK){
				update(s, &amp;seg);
				tcpsynackrtt(s);
				tcpsetstate(s, Established);
				tcpsetscale(s, tcb, seg.ws, tcb-&gt;scale);
			}
			else {
				tcb-&gt;time = NOW;
				tcpsetstate(s, Syn_received);	/* DLP - shouldn't this be a reset? */
			}

			if(length != 0 || (seg.flags &amp; FIN))
				break;

			freeblist(bp);
			goto output;
		}
		else
			freeblist(bp);

		qunlock(s);
		poperror();
		return;
	case Syn_received:
		/* doesn't matter if it's the correct ack, we're just trying to set timing */
		if(seg.flags &amp; ACK)
			tcpsynackrtt(s);
		break;
	}

	/*
	 *  One DOS attack is to open connections to us and then forget about them,
	 *  thereby tying up a conv at no long term cost to the attacker.
	 *  This is an attempt to defeat these stateless DOS attacks.  See
	 *  corresponding code in tcpsendka().
	 */
	if(tcb-&gt;state != Syn_received &amp;&amp; (seg.flags &amp; RST) == 0){
		if(tcpporthogdefense
		&amp;&amp; seq_within(seg.ack, tcb-&gt;snd.una-(1&lt;&lt;31), tcb-&gt;snd.una-(1&lt;&lt;29))){
			print("stateless hog %I.%d-&gt;%I.%d f %ux %lux - %lux - %lux\n",
				source, seg.source, dest, seg.dest, seg.flags,
				tcb-&gt;snd.una-(1&lt;&lt;31), seg.ack, tcb-&gt;snd.una-(1&lt;&lt;29));
			localclose(s, "stateless hog");
		}
	}

	/* Cut the data to fit the receive window */
	tcprcvwin(s);
	if(tcptrim(tcb, &amp;seg, &amp;bp, &amp;length) == -1) {
		if(seg.seq+1 != tcb-&gt;rcv.nxt || length != 1)
		netlog(f, Logtcp, "tcp: trim: !inwind: seq %lud-%lud win "
			"%lud-%lud l %d from %I\n", seg.seq,
			seg.seq + length - 1, tcb-&gt;rcv.nxt,
			tcb-&gt;rcv.nxt + tcb-&gt;rcv.wnd-1, length, s-&gt;raddr);
		update(s, &amp;seg);
		if(qlen(s-&gt;wq)+tcb-&gt;flgcnt == 0 &amp;&amp; tcb-&gt;state == Closing) {
			tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
			tcphalt(tpriv, &amp;tcb-&gt;acktimer);
			tcphalt(tpriv, &amp;tcb-&gt;katimer);
			tcpsetstate(s, Time_wait);
			tcb-&gt;timer.start = MSL2*(1000 / MSPTICK);
			tcpgo(tpriv, &amp;tcb-&gt;timer);
		}
		if(!(seg.flags &amp; RST)) {
			tcb-&gt;flags |= FORCE;
			goto output;
		}
		qunlock(s);
		poperror();
		return;
	}

	/* Cannot accept so answer with a rst */
	if(length &amp;&amp; tcb-&gt;state == Closed) {
		sndrst(tcp, source, dest, length, &amp;seg, version, "sending to Closed");
		goto raise;
	}

	/* The segment is beyond the current receive pointer so
	 * queue the data in the resequence queue
	 */
	if(seg.seq != tcb-&gt;rcv.nxt)
	if(length != 0 || (seg.flags &amp; (SYN|FIN))) {
		update(s, &amp;seg);
		if(addreseq(f, tcb, tpriv, &amp;seg, bp, length) &lt; 0)
			print("reseq %I.%d -&gt; %I.%d\n", s-&gt;raddr, s-&gt;rport,
				s-&gt;laddr, s-&gt;lport);
		tcb-&gt;flags |= FORCE;	/* force duplicate ack; RFC 5681 §3.2 */
		goto output;
	}

	if(tcb-&gt;nreseq &gt; 0)
		tcb-&gt;flags |= FORCE; /* filled hole in seq. space; RFC 5681 §3.2 */

	/*
	 *  keep looping till we've processed this packet plus any
	 *  adjacent packets in the resequence queue
	 */
	for(;;) {
		if(seg.flags &amp; RST) {
			if(tcb-&gt;state == Established) {
				tpriv-&gt;stats[EstabResets]++;
				if(tcb-&gt;rcv.nxt != seg.seq)
					netlog(f, Logtcp, "out of order RST "
						"rcvd: %I.%d -&gt; %I.%d, rcv.nxt "
						"%lux seq %lux\n",
						s-&gt;raddr, s-&gt;rport, s-&gt;laddr,
						s-&gt;lport, tcb-&gt;rcv.nxt, seg.seq);
			}
			localclose(s, Econrefused);
			goto raise;
		}

		if((seg.flags&amp;ACK) == 0)
			goto raise;

		switch(tcb-&gt;state) {
		case Syn_received:
			if(!seq_within(seg.ack, tcb-&gt;snd.una+1, tcb-&gt;snd.nxt)){
				sndrst(tcp, source, dest, length, &amp;seg, version,
					"bad seq in Syn_received");
				goto raise;
			}
			update(s, &amp;seg);
			tcpsetstate(s, Established);
		case Established:
		case Close_wait:
			update(s, &amp;seg);
			break;
		case Finwait1:
			update(s, &amp;seg);
			if(qlen(s-&gt;wq)+tcb-&gt;flgcnt == 0){
				tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
				tcphalt(tpriv, &amp;tcb-&gt;acktimer);
				tcpsetkacounter(tcb);
				tcb-&gt;time = NOW;
				tcpsetstate(s, Finwait2);
				tcb-&gt;katimer.start = MSL2 * (1000 / MSPTICK);
				tcpgo(tpriv, &amp;tcb-&gt;katimer);
			}
			break;
		case Finwait2:
			update(s, &amp;seg);
			break;
		case Closing:
			update(s, &amp;seg);
			if(qlen(s-&gt;wq)+tcb-&gt;flgcnt == 0) {
				tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
				tcphalt(tpriv, &amp;tcb-&gt;acktimer);
				tcphalt(tpriv, &amp;tcb-&gt;katimer);
				tcpsetstate(s, Time_wait);
				tcb-&gt;timer.start = MSL2*(1000 / MSPTICK);
				tcpgo(tpriv, &amp;tcb-&gt;timer);
			}
			break;
		case Last_ack:
			update(s, &amp;seg);
			if(qlen(s-&gt;wq)+tcb-&gt;flgcnt == 0) {
				localclose(s, nil);
				goto raise;
			}
		case Time_wait:
			tcb-&gt;flags |= FORCE;
			if(tcb-&gt;timer.state != TcptimerON)
				tcpgo(tpriv, &amp;tcb-&gt;timer);
		}

		if((seg.flags&amp;URG) &amp;&amp; seg.urg) {
			if(seq_gt(seg.urg + seg.seq, tcb-&gt;rcv.urg)) {
				tcb-&gt;rcv.urg = seg.urg + seg.seq;
				pullblock(&amp;bp, seg.urg);
			}
		}
		else
		if(seq_gt(tcb-&gt;rcv.nxt, tcb-&gt;rcv.urg))
			tcb-&gt;rcv.urg = tcb-&gt;rcv.nxt;

		if(length == 0) {
			if(bp != nil)
				freeblist(bp);
		}
		else {
			switch(tcb-&gt;state){
			default:
				/* Ignore segment text */
				if(bp != nil)
					freeblist(bp);
				break;

			case Syn_received:
			case Established:
			case Finwait1:
				/* If we still have some data place on
				 * receive queue
				 */
				if(bp) {
					bp = packblock(bp);
					if(bp == nil)
						panic("tcp packblock");
					qpassnolim(s-&gt;rq, bp);
					bp = nil;
				}
				tcb-&gt;rcv.nxt += length;

				/*
				 *  turn on the acktimer if there's something
				 *  to ack
				 */
				if(tcb-&gt;acktimer.state != TcptimerON)
					tcpgo(tpriv, &amp;tcb-&gt;acktimer);

				break;
			case Finwait2:
				/* no process to read the data, send a reset */
				if(bp != nil)
					freeblist(bp);
				sndrst(tcp, source, dest, length, &amp;seg, version,
					"send to Finwait2");
				qunlock(s);
				poperror();
				return;
			}
		}

		if(seg.flags &amp; FIN) {
			tcb-&gt;flags |= FORCE;

			switch(tcb-&gt;state) {
			case Syn_received:
			case Established:
				tcb-&gt;rcv.nxt++;
				tcpsetstate(s, Close_wait);
				break;
			case Finwait1:
				tcb-&gt;rcv.nxt++;
				if(qlen(s-&gt;wq)+tcb-&gt;flgcnt == 0) {
					tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
					tcphalt(tpriv, &amp;tcb-&gt;acktimer);
					tcphalt(tpriv, &amp;tcb-&gt;katimer);
					tcpsetstate(s, Time_wait);
					tcb-&gt;timer.start = MSL2*(1000/MSPTICK);
					tcpgo(tpriv, &amp;tcb-&gt;timer);
				}
				else
					tcpsetstate(s, Closing);
				break;
			case Finwait2:
				tcb-&gt;rcv.nxt++;
				tcphalt(tpriv, &amp;tcb-&gt;rtt_timer);
				tcphalt(tpriv, &amp;tcb-&gt;acktimer);
				tcphalt(tpriv, &amp;tcb-&gt;katimer);
				tcpsetstate(s, Time_wait);
				tcb-&gt;timer.start = MSL2 * (1000/MSPTICK);
				tcpgo(tpriv, &amp;tcb-&gt;timer);
				break;
			case Close_wait:
			case Closing:
			case Last_ack:
				break;
			case Time_wait:
				tcpgo(tpriv, &amp;tcb-&gt;timer);
				break;
			}
		}

		/*
		 *  get next adjacent segment from the resequence queue.
		 *  dump/trim any overlapping segments
		 */
		for(;;) {
			if(tcb-&gt;reseq == nil)
				goto output;

			if(seq_ge(tcb-&gt;rcv.nxt, tcb-&gt;reseq-&gt;seg.seq) == 0)
				goto output;

			getreseq(tcb, &amp;seg, &amp;bp, &amp;length);

			tcprcvwin(s);
			if(tcptrim(tcb, &amp;seg, &amp;bp, &amp;length) == 0){
				tcb-&gt;flags |= FORCE;
				break;
			}
		}
	}
output:
	tcpoutput(s);
	qunlock(s);
	poperror();
	return;
raise:
	qunlock(s);
	poperror();
	freeblist(bp);
	tcpkick(s);
}

/*
 *  always enters and exits with the s locked.  We drop
 *  the lock to ipoput the packet so some care has to be
 *  taken by callers.
 */
static void
tcpoutput(Conv *s)
{
	Tcp seg;
	uint msgs;
	Tcpctl *tcb;
	Block *hbp, *bp;
	int sndcnt;
	ulong ssize, dsize, sent;
	Fs *f;
	Tcppriv *tpriv;
	uchar version;

	f = s-&gt;p-&gt;f;
	tpriv = s-&gt;p-&gt;priv;
	version = s-&gt;ipversion;

	tcb = (Tcpctl*)s-&gt;ptcl;

	/* force ack every 2*mss */
	if((tcb-&gt;flags &amp; FORCE) == 0 &amp;&amp;
	    tcb-&gt;rcv.nxt - tcb-&gt;rcv.ackptr &gt;= 2*tcb-&gt;mss){
		tpriv-&gt;stats[Delayack]++;
		tcb-&gt;flags |= FORCE;
	}

	/* force ack if window opening */
	if((tcb-&gt;flags &amp; FORCE) == 0){
		tcprcvwin(s);
		if((int)(tcb-&gt;rcv.wptr - tcb-&gt;rcv.wsnt) &gt;= 2*tcb-&gt;mss){
			tpriv-&gt;stats[Wopenack]++;
			tcb-&gt;flags |= FORCE;
		}
	}

	for(msgs = 0; msgs &lt; 100; msgs++) {
		switch(tcb-&gt;state) {
		case Listen:
		case Closed:
		case Finwait2:
			return;
		}

		/* Don't send anything else until our SYN has been acked */
		if(tcb-&gt;snd.ptr != tcb-&gt;iss &amp;&amp; (tcb-&gt;flags &amp; SYNACK) == 0)
			break;

		/* force an ack when a window has opened up */
		tcprcvwin(s);
		if(tcb-&gt;rcv.blocked &amp;&amp; tcb-&gt;rcv.wnd &gt; 0){
			tcb-&gt;rcv.blocked = 0;
			tcb-&gt;flags |= FORCE;
		}

		sndcnt = qlen(s-&gt;wq)+tcb-&gt;flgcnt;
		sent = tcb-&gt;snd.ptr - tcb-&gt;snd.una;
		ssize = sndcnt;
		if(tcb-&gt;snd.wnd == 0){
			/* zero window probe */
			if(sent &gt; 0 &amp;&amp; !(tcb-&gt;flags &amp; FORCE))
				break;	/* already probing, rto re-probes */
			if(ssize &lt; sent)
				ssize = 0;
			else{
				ssize -= sent;
				if(ssize &gt; 0)
					ssize = 1;
			}
		} else {
			/* calculate usable segment size */
			if(ssize &gt; tcb-&gt;cwind)
				ssize = tcb-&gt;cwind;
			if(ssize &gt; tcb-&gt;snd.wnd)
				ssize = tcb-&gt;snd.wnd;

			if(ssize &lt; sent)
				ssize = 0;
			else {
				ssize -= sent;
				if(ssize &gt; tcb-&gt;mss)
					ssize = tcb-&gt;mss;
			}
		}

		dsize = ssize;
		seg.urg = 0;

		if(!(tcb-&gt;flags &amp; FORCE))
			if(ssize == 0 ||
			    ssize &lt; tcb-&gt;mss &amp;&amp; tcb-&gt;snd.nxt == tcb-&gt;snd.ptr &amp;&amp;
			    sent &gt; TCPREXMTTHRESH * tcb-&gt;mss)
				break;

		tcb-&gt;flags &amp;= ~FORCE;

		/* By default we will generate an ack */
		tcphalt(tpriv, &amp;tcb-&gt;acktimer);
		seg.source = s-&gt;lport;
		seg.dest = s-&gt;rport;
		seg.flags = ACK;
		seg.mss = 0;
		seg.ws = 0;
		seg.update = 0;
		switch(tcb-&gt;state){
		case Syn_sent:
			seg.flags = 0;
			if(tcb-&gt;snd.ptr == tcb-&gt;iss){
				seg.flags |= SYN;
				dsize--;
				seg.mss = tcb-&gt;mss;
				seg.ws = tcb-&gt;scale;
			}
			break;
		case Syn_received:
			/*
			 *  don't send any data with a SYN/ACK packet
			 *  because Linux rejects the packet in its
			 *  attempt to solve the SYN attack problem
			 */
			if(tcb-&gt;snd.ptr == tcb-&gt;iss){
				seg.flags |= SYN;
				dsize = 0;
				ssize = 1;
				seg.mss = tcb-&gt;mss;
				seg.ws = tcb-&gt;scale;
			}
			break;
		}
		seg.seq = tcb-&gt;snd.ptr;
		seg.ack = tcb-&gt;rcv.nxt;
		seg.wnd = tcb-&gt;rcv.wnd;

		/* Pull out data to send */
		bp = nil;
		if(dsize != 0) {
			bp = qcopy(s-&gt;wq, dsize, sent);
			if(BLEN(bp) != dsize) {
				seg.flags |= FIN;
				dsize--;
			}
		}

		if(sent+dsize == sndcnt &amp;&amp; dsize)
			seg.flags |= PSH;

		tcb-&gt;snd.ptr += ssize;

		/* Pull up the send pointer so we can accept acks
		 * for this window
		 */
		if(seq_gt(tcb-&gt;snd.ptr,tcb-&gt;snd.nxt))
			tcb-&gt;snd.nxt = tcb-&gt;snd.ptr;

		/* Build header, link data and compute cksum */
		switch(version){
		case V4:
			tcb-&gt;protohdr.tcp4hdr.vihl = IP_VER4;
			hbp = htontcp4(&amp;seg, bp, &amp;tcb-&gt;protohdr.tcp4hdr, tcb);
			if(hbp == nil) {
				freeblist(bp);
				return;
			}
			break;
		case V6:
			tcb-&gt;protohdr.tcp6hdr.vcf[0] = IP_VER6;
			hbp = htontcp6(&amp;seg, bp, &amp;tcb-&gt;protohdr.tcp6hdr, tcb);
			if(hbp == nil) {
				freeblist(bp);
				return;
			}
			break;
		default:
			hbp = nil;	/* to suppress a warning */
			panic("tcpoutput: version %d", version);
		}

		/* Start the transmission timers if there is new data and we
		 * expect acknowledges
		 */
		if(ssize != 0){
			if(tcb-&gt;timer.state != TcptimerON){
				tcb-&gt;time = NOW;
				tcb-&gt;timeuna = tcb-&gt;snd.una;
				tcpgo(tpriv, &amp;tcb-&gt;timer);
			}

			/*  If round trip timer isn't running, start it.
			 *  measure the longest packet only in case the
			 *  transmission time dominates RTT
			 */
			if(tcb-&gt;snd.retransmit == 0)
			if(tcb-&gt;rtt_timer.state != TcptimerON)
			if(ssize == tcb-&gt;mss) {
				tcpgo(tpriv, &amp;tcb-&gt;rtt_timer);
				tcb-&gt;rttseq = tcb-&gt;snd.ptr;
			}
		}

		tpriv-&gt;stats[OutSegs]++;
		if(tcb-&gt;snd.retransmit)
			tpriv-&gt;stats[RetransSegsSent]++;
		tcb-&gt;rcv.ackptr = seg.ack;
		tcb-&gt;rcv.wsnt = tcb-&gt;rcv.wptr;

		/* put off the next keep alive */
		tcpgo(tpriv, &amp;tcb-&gt;katimer);

		switch(version){
		case V4:
			if(ipoput4(f, hbp, 0, s-&gt;ttl, s-&gt;tos, s) &lt; 0){
				/* a negative return means no route */
				localclose(s, "no route");
			}
			break;
		case V6:
			if(ipoput6(f, hbp, 0, s-&gt;ttl, s-&gt;tos, s) &lt; 0){
				/* a negative return means no route */
				localclose(s, "no route");
			}
			break;
		default:
			panic("tcpoutput2: version %d", version);
		}
		if((msgs%4) == 3){
			qunlock(s);
			qlock(s);
		}
	}
}

/*
 *  the BSD convention (hack?) for keep alives.  resend last uchar acked.
 */
static void
tcpsendka(Conv *s)
{
	Tcp seg;
	Tcpctl *tcb;
	Block *hbp,*dbp;

	tcb = (Tcpctl*)s-&gt;ptcl;

	dbp = nil;
	memset(&amp;seg, 0, sizeof seg);
	seg.urg = 0;
	seg.source = s-&gt;lport;
	seg.dest = s-&gt;rport;
	seg.flags = ACK|PSH;
	seg.mss = 0;
	seg.ws = 0;
	if(tcpporthogdefense)
		seg.seq = tcb-&gt;snd.una-(1&lt;&lt;30)-nrand(1&lt;&lt;20);
	else
		seg.seq = tcb-&gt;snd.una-1;
	seg.ack = tcb-&gt;rcv.nxt;
	tcb-&gt;rcv.ackptr = seg.ack;
	tcprcvwin(s);
	seg.wnd = tcb-&gt;rcv.wnd;
	if(tcb-&gt;state == Finwait2){
		seg.flags |= FIN;
	} else {
		dbp = allocb(1);
		dbp-&gt;wp++;
	}

	if(isv4(s-&gt;raddr)) {
		/* Build header, link data and compute cksum */
		tcb-&gt;protohdr.tcp4hdr.vihl = IP_VER4;
		hbp = htontcp4(&amp;seg, dbp, &amp;tcb-&gt;protohdr.tcp4hdr, tcb);
		if(hbp == nil) {
			freeblist(dbp);
			return;
		}
		ipoput4(s-&gt;p-&gt;f, hbp, 0, s-&gt;ttl, s-&gt;tos, s);
	}
	else {
		/* Build header, link data and compute cksum */
		tcb-&gt;protohdr.tcp6hdr.vcf[0] = IP_VER6;
		hbp = htontcp6(&amp;seg, dbp, &amp;tcb-&gt;protohdr.tcp6hdr, tcb);
		if(hbp == nil) {
			freeblist(dbp);
			return;
		}
		ipoput6(s-&gt;p-&gt;f, hbp, 0, s-&gt;ttl, s-&gt;tos, s);
	}
}

/*
 *  set connection to time out after 12 minutes
 */
static void
tcpsetkacounter(Tcpctl *tcb)
{
	tcb-&gt;kacounter = (12 * 60 * 1000) / (tcb-&gt;katimer.start*MSPTICK);
	if(tcb-&gt;kacounter &lt; 3)
		tcb-&gt;kacounter = 3;
}

/*
 *  if we've timed out, close the connection
 *  otherwise, send a keepalive and restart the timer
 */
static void
tcpkeepalive(void *v)
{
	Tcpctl *tcb;
	Conv *s;

	s = v;
	tcb = (Tcpctl*)s-&gt;ptcl;
	if(waserror()){
		qunlock(s);
		nexterror();
	}
	qlock(s);
	if(tcb-&gt;state != Closed){
		if(--(tcb-&gt;kacounter) &lt;= 0) {
			localclose(s, Etimedout);
		} else {
			tcpsendka(s);
			tcpgo(s-&gt;p-&gt;priv, &amp;tcb-&gt;katimer);
		}
	}
	qunlock(s);
	poperror();
}

/*
 *  start keepalive timer
 */
static char*
tcpstartka(Conv *s, char **f, int n)
{
	Tcpctl *tcb;
	int x;

	tcb = (Tcpctl*)s-&gt;ptcl;
	if(tcb-&gt;state != Established)
		return "connection must be in Establised state";
	if(n &gt; 1){
		x = atoi(f[1]);
		if(x &gt;= MSPTICK)
			tcb-&gt;katimer.start = x/MSPTICK;
	}
	tcpsetkacounter(tcb);
	tcpgo(s-&gt;p-&gt;priv, &amp;tcb-&gt;katimer);

	return nil;
}

/*
 *  turn checksums on/off
 */
static char*
tcpsetchecksum(Conv *s, char **f, int)
{
	Tcpctl *tcb;

	tcb = (Tcpctl*)s-&gt;ptcl;
	tcb-&gt;nochecksum = !atoi(f[1]);

	return nil;
}

/*
 *  retransmit (at most) one segment at snd.una.
 *  preserve cwind &amp; snd.ptr
 */
static void
tcprxmit(Conv *s)
{
	Tcpctl *tcb;
	Tcppriv *tpriv;
	ulong tcwind, tptr;

	tcb = (Tcpctl*)s-&gt;ptcl;
	tcb-&gt;flags |= RETRAN|FORCE;

	tptr = tcb-&gt;snd.ptr;
	tcwind = tcb-&gt;cwind;
	tcb-&gt;snd.ptr = tcb-&gt;snd.una;
	tcb-&gt;cwind = tcb-&gt;mss;
	tcb-&gt;snd.retransmit = 1;
	tcpoutput(s);
	tcb-&gt;snd.retransmit = 0;
	tcb-&gt;cwind = tcwind;
	tcb-&gt;snd.ptr = tptr;

	tpriv = s-&gt;p-&gt;priv;
	tpriv-&gt;stats[RetransSegs]++;
}

/*
 *  TODO: RFC 4138 F-RTO
 */
static void
tcptimeout(void *arg)
{
	Conv *s;
	Tcpctl *tcb;
	int maxback;
	Tcppriv *tpriv;

	s = (Conv*)arg;
	tpriv = s-&gt;p-&gt;priv;
	tcb = (Tcpctl*)s-&gt;ptcl;

	if(waserror()){
		qunlock(s);
		nexterror();
	}
	qlock(s);
	switch(tcb-&gt;state){
	default:
		tcb-&gt;backoff++;
		if(tcb-&gt;state == Syn_sent)
			maxback = MAXBACKMS/2;
		else
			maxback = MAXBACKMS;
		tcb-&gt;backedoff += tcb-&gt;timer.start * MSPTICK;
		if(tcb-&gt;backedoff &gt;= maxback) {
			localclose(s, Etimedout);
			break;
		}
		netlog(s-&gt;p-&gt;f, Logtcprxmt, "rxm %d/%d %ldms %lud rto %d %lud %s\n",
			tcb-&gt;srtt, tcb-&gt;mdev, NOW - tcb-&gt;time,
			tcb-&gt;snd.una - tcb-&gt;timeuna, tcb-&gt;snd.rto, tcb-&gt;snd.ptr,
			tcpstates[s-&gt;state]);
		tcpsettimer(tcb);
		if(tcb-&gt;snd.rto == 0)
			tcpcongestion(tcb);
		tcprxmit(s);
		tcb-&gt;snd.ptr = tcb-&gt;snd.una;
		tcb-&gt;cwind = tcb-&gt;mss;
		tcb-&gt;snd.rto = 1;
		tpriv-&gt;stats[RetransTimeouts]++;

		if(tcb-&gt;snd.recovery){
			tcb-&gt;snd.dupacks = 0;		/* reno rto */
			tcb-&gt;snd.recovery = 0;
			tpriv-&gt;stats[RecoveryRTO]++;
			tcb-&gt;snd.rxt = tcb-&gt;snd.nxt;
			netlog(s-&gt;p-&gt;f, Logtcpwin,
				"rto recovery rxt @%lud\n", tcb-&gt;snd.nxt);
		}

		tcb-&gt;abcbytes = 0;
		break;
	case Time_wait:
		localclose(s, nil);
		break;
	case Closed:
		break;
	}
	qunlock(s);
	poperror();
}

static int
inwindow(Tcpctl *tcb, int seq)
{
	return seq_within(seq, tcb-&gt;rcv.nxt, tcb-&gt;rcv.nxt+tcb-&gt;rcv.wnd-1);
}

/*
 *  set up state for a received SYN (or SYN ACK) packet
 */
static void
procsyn(Conv *s, Tcp *seg)
{
	Tcpctl *tcb;
	Tcppriv *tpriv;

	tcb = (Tcpctl*)s-&gt;ptcl;
	tcb-&gt;flags |= FORCE;

	tcb-&gt;rcv.nxt = seg-&gt;seq + 1;
	tcb-&gt;rcv.wptr = tcb-&gt;rcv.nxt;
	tcb-&gt;rcv.wsnt = 0;
	tcb-&gt;rcv.urg = tcb-&gt;rcv.nxt;
	tcb-&gt;irs = seg-&gt;seq;

	/* our sending max segment size cannot be bigger than what he asked for */
	if(seg-&gt;mss != 0 &amp;&amp; seg-&gt;mss &lt; tcb-&gt;mss) {
		tcb-&gt;mss = seg-&gt;mss;
		tpriv = s-&gt;p-&gt;priv;
		tpriv-&gt;stats[Mss] = tcb-&gt;mss;
	}

	tcb-&gt;snd.wnd = seg-&gt;wnd;
	initialwindow(tcb);
}

static int
dumpreseq(Tcpctl *tcb)
{
	Reseq *r, *next;

	for(r = tcb-&gt;reseq; r != nil; r = next){
		next = r-&gt;next;
		freeblist(r-&gt;bp);
		free(r);
	}
	tcb-&gt;reseq = nil;
	tcb-&gt;nreseq = 0;
	tcb-&gt;reseqlen = 0;
	return -1;
}

static void
logreseq(Fs *f, Reseq *r, ulong n)
{
	char *s;

	for(; r != nil; r = r-&gt;next){
		s = nil;
		if(r-&gt;next == nil &amp;&amp; r-&gt;seg.seq != n)
			s = "hole/end";
		else if(r-&gt;next == nil)
			s = "end";
		else if(r-&gt;seg.seq != n)
			s = "hole";
		if(s != nil)
			netlog(f, Logtcp, "%s %lud-%lud (%ld) %#ux\n", s,
				n, r-&gt;seg.seq, r-&gt;seg.seq - n, r-&gt;seg.flags);
		n = r-&gt;seg.seq + r-&gt;seg.len;
	}
}

static int
addreseq(Fs *f, Tcpctl *tcb, Tcppriv *tpriv, Tcp *seg, Block *bp, ushort length)
{
	Reseq *rp, **rr;
	int qmax;

	rp = malloc(sizeof *rp);
	if(rp == nil){
		freeblist(bp);		/* bp always consumed by addreseq */
		return 0;
	}

	rp-&gt;seg = *seg;
	rp-&gt;bp = bp;
	rp-&gt;length = length;

	tcb-&gt;reseqlen += length;
	tcb-&gt;nreseq++;

	/* Place on reassembly list sorting by starting seq number */
	for(rr = &amp;tcb-&gt;reseq; ; rr = &amp;(*rr)-&gt;next)
		if(*rr == nil || seq_lt(seg-&gt;seq, (*rr)-&gt;seg.seq)){
			rp-&gt;next = *rr;
			*rr = rp;
			tpriv-&gt;stats[Resequenced]++;
			if(rp-&gt;next != nil)
				tpriv-&gt;stats[OutOfOrder]++;
			break;
		}

	qmax = tcb-&gt;window;
	if(tcb-&gt;reseqlen &gt; qmax){
		netlog(f, Logtcp, "tcp: reseq: queue &gt; window: %d &gt; %d; %d packets\n",
			tcb-&gt;reseqlen, qmax, tcb-&gt;nreseq);
		logreseq(f, tcb-&gt;reseq, tcb-&gt;rcv.nxt);
		tpriv-&gt;stats[ReseqBytelim]++;
		return dumpreseq(tcb);
	}
	qmax = tcb-&gt;window / tcb-&gt;mss; /* ~190 for qscale=2, 390 for qscale=3 */
	if(tcb-&gt;nreseq &gt; qmax){
		netlog(f, Logtcp, "resequence queue &gt; packets: %d %d; %d bytes\n",
			tcb-&gt;nreseq, qmax, tcb-&gt;reseqlen);
		logreseq(f, tcb-&gt;reseq, tcb-&gt;rcv.nxt);
		tpriv-&gt;stats[ReseqPktlim]++;
		return dumpreseq(tcb);
	}
	return 0;
}

static void
getreseq(Tcpctl *tcb, Tcp *seg, Block **bp, ushort *length)
{
	Reseq *rp;

	rp = tcb-&gt;reseq;
	if(rp == nil)
		return;

	tcb-&gt;reseq = rp-&gt;next;

	*seg = rp-&gt;seg;
	*bp = rp-&gt;bp;
	*length = rp-&gt;length;

	tcb-&gt;nreseq--;
	tcb-&gt;reseqlen -= rp-&gt;length;

	free(rp);
}

static int
tcptrim(Tcpctl *tcb, Tcp *seg, Block **bp, ushort *length)
{
	ushort len;
	uchar accept;
	int dupcnt, excess;

	accept = 0;
	len = *length;
	if(seg-&gt;flags &amp; SYN)
		len++;
	if(seg-&gt;flags &amp; FIN)
		len++;

	if(tcb-&gt;rcv.wnd == 0) {
		if(len == 0 &amp;&amp; seg-&gt;seq == tcb-&gt;rcv.nxt)
			return 0;
	}
	else {
		/* Some part of the segment should be in the window */
		if(inwindow(tcb,seg-&gt;seq))
			accept++;
		else
		if(len != 0) {
			if(inwindow(tcb, seg-&gt;seq+len-1) ||
			seq_within(tcb-&gt;rcv.nxt, seg-&gt;seq,seg-&gt;seq+len-1))
				accept++;
		}
	}
	if(!accept) {
		freeblist(*bp);
		return -1;
	}
	dupcnt = tcb-&gt;rcv.nxt - seg-&gt;seq;
	if(dupcnt &gt; 0){
		tcb-&gt;rerecv += dupcnt;
		if(seg-&gt;flags &amp; SYN){
			seg-&gt;flags &amp;= ~SYN;
			seg-&gt;seq++;

			if(seg-&gt;urg &gt; 1)
				seg-&gt;urg--;
			else
				seg-&gt;flags &amp;= ~URG;
			dupcnt--;
		}
		if(dupcnt &gt; 0){
			pullblock(bp, (ushort)dupcnt);
			seg-&gt;seq += dupcnt;
			*length -= dupcnt;

			if(seg-&gt;urg &gt; dupcnt)
				seg-&gt;urg -= dupcnt;
			else {
				seg-&gt;flags &amp;= ~URG;
				seg-&gt;urg = 0;
			}
		}
	}
	excess = seg-&gt;seq + *length - (tcb-&gt;rcv.nxt + tcb-&gt;rcv.wnd);
	if(excess &gt; 0) {
		tcb-&gt;rerecv += excess;
		*length -= excess;
		*bp = trimblock(*bp, 0, *length);
		if(*bp == nil)
			panic("presotto is a boofhead");
		seg-&gt;flags &amp;= ~FIN;
	}
	return 0;
}

static void
tcpadvise(Proto *tcp, Block *bp, char *msg)
{
	Tcp4hdr *h4;
	Tcp6hdr *h6;
	Tcpctl *tcb;
	uchar source[IPaddrlen];
	uchar dest[IPaddrlen];
	ushort psource, pdest;
	Conv *s, **p;

	h4 = (Tcp4hdr*)(bp-&gt;rp);
	h6 = (Tcp6hdr*)(bp-&gt;rp);

	if((h4-&gt;vihl&amp;0xF0)==IP_VER4) {
		v4tov6(dest, h4-&gt;tcpdst);
		v4tov6(source, h4-&gt;tcpsrc);
		psource = nhgets(h4-&gt;tcpsport);
		pdest = nhgets(h4-&gt;tcpdport);
	}
	else {
		ipmove(dest, h6-&gt;tcpdst);
		ipmove(source, h6-&gt;tcpsrc);
		psource = nhgets(h6-&gt;tcpsport);
		pdest = nhgets(h6-&gt;tcpdport);
	}

	/* Look for a connection */
	qlock(tcp);
	for(p = tcp-&gt;conv; *p; p++) {
		s = *p;
		tcb = (Tcpctl*)s-&gt;ptcl;
		if(s-&gt;rport == pdest)
		if(s-&gt;lport == psource)
		if(tcb-&gt;state != Closed)
		if(ipcmp(s-&gt;raddr, dest) == 0)
		if(ipcmp(s-&gt;laddr, source) == 0){
			qlock(s);
			qunlock(tcp);
			switch(tcb-&gt;state){
			case Syn_sent:
				localclose(s, msg);
				break;
			}
			qunlock(s);
			freeblist(bp);
			return;
		}
	}
	qunlock(tcp);
	freeblist(bp);
}

static char*
tcpporthogdefensectl(char *val)
{
	if(strcmp(val, "on") == 0)
		tcpporthogdefense = 1;
	else if(strcmp(val, "off") == 0)
		tcpporthogdefense = 0;
	else
		return "unknown value for tcpporthogdefense";
	return nil;
}

/* called with c qlocked */
static char*
tcpctl(Conv* c, char** f, int n)
{
	if(n == 1 &amp;&amp; strcmp(f[0], "hangup") == 0)
		return tcphangup(c);
	if(n &gt;= 1 &amp;&amp; strcmp(f[0], "keepalive") == 0)
		return tcpstartka(c, f, n);
	if(n &gt;= 1 &amp;&amp; strcmp(f[0], "checksum") == 0)
		return tcpsetchecksum(c, f, n);
	if(n &gt;= 1 &amp;&amp; strcmp(f[0], "tcpporthogdefense") == 0)
		return tcpporthogdefensectl(f[1]);
	return "unknown control request";
}

static int
tcpstats(Proto *tcp, char *buf, int len)
{
	Tcppriv *priv;
	char *p, *e;
	int i;

	priv = tcp-&gt;priv;
	p = buf;
	e = p+len;
	for(i = 0; i &lt; Nstats; i++)
		p = seprint(p, e, "%s: %llud\n", statnames[i], priv-&gt;stats[i]);
	return p - buf;
}

/*
 *  garbage collect any stale conversations:
 *	- SYN received but no SYN-ACK after 5 seconds (could be the SYN attack)
 *	- Finwait2 after 5 minutes
 *
 *  this is called whenever we run out of channels.  Both checks are
 *  of questionable validity so we try to use them only when we're
 *  up against the wall.
 */
static int
tcpgc(Proto *tcp)
{
	Conv *c, **pp, **ep;
	int n;
	Tcpctl *tcb;


	n = 0;
	ep = &amp;tcp-&gt;conv[tcp-&gt;nc];
	for(pp = tcp-&gt;conv; pp &lt; ep; pp++) {
		c = *pp;
		if(c == nil)
			break;
		if(!canqlock(c))
			continue;
		tcb = (Tcpctl*)c-&gt;ptcl;
		switch(tcb-&gt;state){
		case Syn_received:
			if(NOW - tcb-&gt;time &gt; 5000){
				localclose(c, Etimedout);
				n++;
			}
			break;
		case Finwait2:
			if(NOW - tcb-&gt;time &gt; 5*60*1000){
				localclose(c, Etimedout);
				n++;
			}
			break;
		}
		qunlock(c);
	}
	return n;
}

static void
tcpsettimer(Tcpctl *tcb)
{
	int x;

	/* round trip dependency */
	x = backoff(tcb-&gt;backoff) *
		(tcb-&gt;mdev + (tcb-&gt;srtt&gt;&gt;LOGAGAIN) + MSPTICK) / MSPTICK;

	/* bounded twixt 0.3 and 64 seconds */
	if(x &lt; 300/MSPTICK)
		x = 300/MSPTICK;
	else if(x &gt; (64000/MSPTICK))
		x = 64000/MSPTICK;
	tcb-&gt;timer.start = x;
}

void
tcpinit(Fs *fs)
{
	Proto *tcp;
	Tcppriv *tpriv;

	tcp = smalloc(sizeof(Proto));
	tpriv = tcp-&gt;priv = smalloc(sizeof(Tcppriv));
	tcp-&gt;name = "tcp";
	tcp-&gt;connect = tcpconnect;
	tcp-&gt;announce = tcpannounce;
	tcp-&gt;ctl = tcpctl;
	tcp-&gt;state = tcpstate;
	tcp-&gt;create = tcpcreate;
	tcp-&gt;close = tcpclose;
	tcp-&gt;rcv = tcpiput;
	tcp-&gt;advise = tcpadvise;
	tcp-&gt;stats = tcpstats;
	tcp-&gt;inuse = tcpinuse;
	tcp-&gt;gc = tcpgc;
	tcp-&gt;ipproto = IP_TCPPROTO;
	tcp-&gt;nc = scalednconv();
	tcp-&gt;ptclsize = sizeof(Tcpctl);
	tpriv-&gt;stats[MaxConn] = tcp-&gt;nc;

	Fsproto(fs, tcp);
}

static void
tcpsetscale(Conv *s, Tcpctl *tcb, ushort rcvscale, ushort sndscale)
{
	/*
	 * guess at reasonable queue sizes.  there's no current way
	 * to know how many nic receive buffers we can safely tie up in the
	 * tcp stack, and we don't adjust our queues to maximize throughput
	 * and minimize bufferbloat.  n.b. the offer (rcvscale) needs to be
	 * respected, but we still control our own buffer commitment by
	 * keeping a seperate qscale.
	 */
	tcb-&gt;rcv.scale = rcvscale &amp; 0xff;
	tcb-&gt;snd.scale = sndscale &amp; 0xff;
	tcb-&gt;qscale = rcvscale &amp; 0xff;
	if(rcvscale &gt; Maxqscale)
		tcb-&gt;qscale = Maxqscale;

	if(rcvscale != tcb-&gt;rcv.scale)
		netlog(s-&gt;p-&gt;f, Logtcp, "tcpsetscale: window %lud "
			"qlen %d &gt;&gt; window %ud lport %d\n",
			tcb-&gt;window, qlen(s-&gt;rq), QMAX&lt;&lt;tcb-&gt;qscale, s-&gt;lport);
	tcb-&gt;window = QMAX &lt;&lt; tcb-&gt;qscale;
	tcb-&gt;ssthresh = tcb-&gt;window;

	/*
	 * it's important to set wq large enough to cover the full
	 * bandwidth-delay product.  it's possible to be in loss
	 * recovery with a big window, and we need to keep sending
	 * into the inflated window.  the difference can be huge
	 * for even modest (70ms) ping times.
	 */
	qsetlimit(s-&gt;rq, tcb-&gt;window);
	qsetlimit(s-&gt;wq, tcb-&gt;window);
	tcprcvwin(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

