<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/udp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/udp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"ip.h"
#include	"ipv6.h"


#define DPRINT if(0)print

enum
{
	UDP_UDPHDR_SZ	= 8,

	UDP4_PHDR_OFF = 8,
	UDP4_PHDR_SZ = 12,
	UDP4_IPHDR_SZ = 20,
	UDP6_IPHDR_SZ = 40,
	UDP6_PHDR_SZ = 40,
	UDP6_PHDR_OFF = 0,

	IP_UDPPROTO	= 17,
	UDP_USEAD7	= 52,

	Udprxms		= 200,
	Udptickms	= 100,
	Udpmaxxmit	= 10,
};

typedef struct Udp4hdr Udp4hdr;
struct Udp4hdr
{
	/* ip header */
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	Unused;
	uchar	udpproto;	/* Protocol */
	uchar	udpplen[2];	/* Header plus data length */
	uchar	udpsrc[IPv4addrlen];	/* Ip source */
	uchar	udpdst[IPv4addrlen];	/* Ip destination */

	/* udp header */
	uchar	udpsport[2];	/* Source port */
	uchar	udpdport[2];	/* Destination port */
	uchar	udplen[2];	/* data length */
	uchar	udpcksum[2];	/* Checksum */
};

typedef struct Udp6hdr Udp6hdr;
struct Udp6hdr {
	uchar viclfl[4];
	uchar len[2];
	uchar nextheader;
	uchar hoplimit;
	uchar udpsrc[IPaddrlen];
	uchar udpdst[IPaddrlen];

	/* udp header */
	uchar	udpsport[2];	/* Source port */
	uchar	udpdport[2];	/* Destination port */
	uchar	udplen[2];	/* data length */
	uchar	udpcksum[2];	/* Checksum */
};

/* MIB II counters */
typedef struct Udpstats Udpstats;
struct Udpstats
{
	uvlong	udpInDatagrams;
	ulong	udpNoPorts;
	ulong	udpInErrors;
	uvlong	udpOutDatagrams;
};

typedef struct Udppriv Udppriv;
struct Udppriv
{
	Ipht		ht;

	/* MIB counters */
	Udpstats	ustats;

	/* non-MIB stats */
	ulong		csumerr;		/* checksum errors */
	ulong		lenerr;			/* short packet */
};

void (*etherprofiler)(char *name, int qlen);
void udpkick(void *x, Block *bp);

/*
 *  protocol specific part of Conv
 */
typedef struct Udpcb Udpcb;
struct Udpcb
{
	QLock;
	uchar	headers;
};

static char*
udpconnect(Conv *c, char **argv, int argc)
{
	char *e;
	Udppriv *upriv;

	upriv = c-&gt;p-&gt;priv;
	e = Fsstdconnect(c, argv, argc);
	Fsconnected(c, e);
	if(e != nil)
		return e;

	iphtadd(&amp;upriv-&gt;ht, c);
	return nil;
}


static int
udpstate(Conv *c, char *state, int n)
{
	return snprint(state, n, "%s qin %d qout %d\n",
		c-&gt;inuse ? "Open" : "Closed",
		c-&gt;rq ? qlen(c-&gt;rq) : 0,
		c-&gt;wq ? qlen(c-&gt;wq) : 0
	);
}

static char*
udpannounce(Conv *c, char** argv, int argc)
{
	char *e;
	Udppriv *upriv;

	upriv = c-&gt;p-&gt;priv;
	e = Fsstdannounce(c, argv, argc);
	if(e != nil)
		return e;
	Fsconnected(c, nil);
	iphtadd(&amp;upriv-&gt;ht, c);

	return nil;
}

static void
udpcreate(Conv *c)
{
	c-&gt;rq = qopen(128*1024, Qmsg, 0, 0);
	c-&gt;wq = qbypass(udpkick, c);
}

static void
udpclose(Conv *c)
{
	Udpcb *ucb;
	Udppriv *upriv;

	upriv = c-&gt;p-&gt;priv;
	iphtrem(&amp;upriv-&gt;ht, c);

	c-&gt;state = 0;
	qclose(c-&gt;rq);
	qclose(c-&gt;wq);
	qclose(c-&gt;eq);
	ipmove(c-&gt;laddr, IPnoaddr);
	ipmove(c-&gt;raddr, IPnoaddr);
	c-&gt;lport = 0;
	c-&gt;rport = 0;

	ucb = (Udpcb*)c-&gt;ptcl;
	ucb-&gt;headers = 0;
}

void
udpkick(void *x, Block *bp)
{
	Conv *c = x;
	Udp4hdr *uh4;
	Udp6hdr *uh6;
	ushort rport;
	uchar laddr[IPaddrlen], raddr[IPaddrlen];
	Udpcb *ucb;
	int dlen, ptcllen;
	Udppriv *upriv;
	Fs *f;
	int version;
	Conv *rc;

	upriv = c-&gt;p-&gt;priv;
	f = c-&gt;p-&gt;f;

//	netlog(c-&gt;p-&gt;f, Logudp, "udp: kick\n");	/* frequent and uninteresting */
	if(bp == nil)
		return;

	ucb = (Udpcb*)c-&gt;ptcl;
	switch(ucb-&gt;headers) {
	case 7:
		/* get user specified addresses */
		bp = pullupblock(bp, UDP_USEAD7);
		if(bp == nil)
			return;
		ipmove(raddr, bp-&gt;rp);
		bp-&gt;rp += IPaddrlen;
		ipmove(laddr, bp-&gt;rp);
		bp-&gt;rp += IPaddrlen;
		/* pick interface closest to dest */
		if(ipforme(f, laddr) != Runi)
			findlocalip(f, laddr, raddr);
		bp-&gt;rp += IPaddrlen;		/* Ignore ifc address */
		rport = nhgets(bp-&gt;rp);
		bp-&gt;rp += 2+2;			/* Ignore local port */
		break;
	default:
		rport = 0;
		break;
	}

	if(ucb-&gt;headers) {
		if(memcmp(laddr, v4prefix, IPv4off) == 0
		|| ipcmp(laddr, IPnoaddr) == 0)
			version = 4;
		else
			version = 6;
	} else {
		if( (memcmp(c-&gt;raddr, v4prefix, IPv4off) == 0 &amp;&amp;
			memcmp(c-&gt;laddr, v4prefix, IPv4off) == 0)
			|| ipcmp(c-&gt;raddr, IPnoaddr) == 0)
			version = 4;
		else
			version = 6;
	}

	dlen = blocklen(bp);

	/* fill in pseudo header and compute checksum */
	switch(version){
	case V4:
		bp = padblock(bp, UDP4_IPHDR_SZ+UDP_UDPHDR_SZ);
		if(bp == nil)
			return;

		uh4 = (Udp4hdr *)(bp-&gt;rp);
		ptcllen = dlen + UDP_UDPHDR_SZ;
		uh4-&gt;Unused = 0;
		uh4-&gt;udpproto = IP_UDPPROTO;
		uh4-&gt;frag[0] = 0;
		uh4-&gt;frag[1] = 0;
		hnputs(uh4-&gt;udpplen, ptcllen);
		if(ucb-&gt;headers) {
			v6tov4(uh4-&gt;udpdst, raddr);
			hnputs(uh4-&gt;udpdport, rport);
			v6tov4(uh4-&gt;udpsrc, laddr);
			rc = nil;
		} else {
			v6tov4(uh4-&gt;udpdst, c-&gt;raddr);
			hnputs(uh4-&gt;udpdport, c-&gt;rport);
			if(ipcmp(c-&gt;laddr, IPnoaddr) == 0)
				findlocalip(f, c-&gt;laddr, c-&gt;raddr);
			v6tov4(uh4-&gt;udpsrc, c-&gt;laddr);
			rc = c;
		}
		hnputs(uh4-&gt;udpsport, c-&gt;lport);
		hnputs(uh4-&gt;udplen, ptcllen);
		uh4-&gt;udpcksum[0] = 0;
		uh4-&gt;udpcksum[1] = 0;
		hnputs(uh4-&gt;udpcksum,
		       ptclcsum(bp, UDP4_PHDR_OFF, dlen+UDP_UDPHDR_SZ+UDP4_PHDR_SZ));
		uh4-&gt;vihl = IP_VER4;
		ipoput4(f, bp, 0, c-&gt;ttl, c-&gt;tos, rc);
		break;

	case V6:
		bp = padblock(bp, UDP6_IPHDR_SZ+UDP_UDPHDR_SZ);
		if(bp == nil)
			return;

		/*
		 * using the v6 ip header to create pseudo header
		 * first then reset it to the normal ip header
		 */
		uh6 = (Udp6hdr *)(bp-&gt;rp);
		memset(uh6, 0, 8);
		ptcllen = dlen + UDP_UDPHDR_SZ;
		hnputl(uh6-&gt;viclfl, ptcllen);
		uh6-&gt;hoplimit = IP_UDPPROTO;
		if(ucb-&gt;headers) {
			ipmove(uh6-&gt;udpdst, raddr);
			hnputs(uh6-&gt;udpdport, rport);
			ipmove(uh6-&gt;udpsrc, laddr);
			rc = nil;
		} else {
			ipmove(uh6-&gt;udpdst, c-&gt;raddr);
			hnputs(uh6-&gt;udpdport, c-&gt;rport);
			if(ipcmp(c-&gt;laddr, IPnoaddr) == 0)
				findlocalip(f, c-&gt;laddr, c-&gt;raddr);
			ipmove(uh6-&gt;udpsrc, c-&gt;laddr);
			rc = c;
		}
		hnputs(uh6-&gt;udpsport, c-&gt;lport);
		hnputs(uh6-&gt;udplen, ptcllen);
		uh6-&gt;udpcksum[0] = 0;
		uh6-&gt;udpcksum[1] = 0;
		hnputs(uh6-&gt;udpcksum,
		       ptclcsum(bp, UDP6_PHDR_OFF, dlen+UDP_UDPHDR_SZ+UDP6_PHDR_SZ));
		memset(uh6, 0, 8);
		uh6-&gt;viclfl[0] = IP_VER6;
		hnputs(uh6-&gt;len, ptcllen);
		uh6-&gt;nextheader = IP_UDPPROTO;
		ipoput6(f, bp, 0, c-&gt;ttl, c-&gt;tos, rc);
		break;

	default:
		panic("udpkick: version %d", version);
	}
	upriv-&gt;ustats.udpOutDatagrams++;
}

void
udpiput(Proto *udp, Ipifc *ifc, Block *bp)
{
	int len;
	Udp4hdr *uh4;
	Udp6hdr *uh6;
	Conv *c;
	Udpcb *ucb;
	uchar raddr[IPaddrlen], laddr[IPaddrlen];
	ushort rport, lport;
	Udppriv *upriv;
	Fs *f;
	int version;
	int ottl, oviclfl, olen;
	uchar *p;

	upriv = udp-&gt;priv;
	f = udp-&gt;f;
	upriv-&gt;ustats.udpInDatagrams++;

	uh4 = (Udp4hdr*)(bp-&gt;rp);
	version = ((uh4-&gt;vihl&amp;0xF0)==IP_VER6) ? 6 : 4;

	/* Put back pseudo header for checksum
	 * (remember old values for icmpnoconv()) */
	switch(version) {
	case V4:
		ottl = uh4-&gt;Unused;
		uh4-&gt;Unused = 0;
		len = nhgets(uh4-&gt;udplen);
		olen = nhgets(uh4-&gt;udpplen);
		hnputs(uh4-&gt;udpplen, len);

		v4tov6(raddr, uh4-&gt;udpsrc);
		v4tov6(laddr, uh4-&gt;udpdst);
		lport = nhgets(uh4-&gt;udpdport);
		rport = nhgets(uh4-&gt;udpsport);

		if(nhgets(uh4-&gt;udpcksum)) {
			if(ptclcsum(bp, UDP4_PHDR_OFF, len+UDP4_PHDR_SZ)) {
				upriv-&gt;ustats.udpInErrors++;
				netlog(f, Logudp, "udp: checksum error %I\n", raddr);
				DPRINT("udp: checksum error %I\n", raddr);
				freeblist(bp);
				return;
			}
		}
		uh4-&gt;Unused = ottl;
		hnputs(uh4-&gt;udpplen, olen);
		break;
	case V6:
		uh6 = (Udp6hdr*)(bp-&gt;rp);
		len = nhgets(uh6-&gt;udplen);
		oviclfl = nhgetl(uh6-&gt;viclfl);
		olen = nhgets(uh6-&gt;len);
		ottl = uh6-&gt;hoplimit;
		ipmove(raddr, uh6-&gt;udpsrc);
		ipmove(laddr, uh6-&gt;udpdst);
		lport = nhgets(uh6-&gt;udpdport);
		rport = nhgets(uh6-&gt;udpsport);
		memset(uh6, 0, 8);
		hnputl(uh6-&gt;viclfl, len);
		uh6-&gt;hoplimit = IP_UDPPROTO;
		if(ptclcsum(bp, UDP6_PHDR_OFF, len+UDP6_PHDR_SZ)) {
			upriv-&gt;ustats.udpInErrors++;
			netlog(f, Logudp, "udp: checksum error %I\n", raddr);
			DPRINT("udp: checksum error %I\n", raddr);
			freeblist(bp);
			return;
		}
		hnputl(uh6-&gt;viclfl, oviclfl);
		hnputs(uh6-&gt;len, olen);
		uh6-&gt;nextheader = IP_UDPPROTO;
		uh6-&gt;hoplimit = ottl;
		break;
	default:
		panic("udpiput: version %d", version);
		return;	/* to avoid a warning */
	}

	qlock(udp);

	c = iphtlook(&amp;upriv-&gt;ht, raddr, rport, laddr, lport);
	if(c == nil){
		/* no conversation found */
		upriv-&gt;ustats.udpNoPorts++;
		qunlock(udp);
		netlog(f, Logudp, "udp: no conv %I!%d -&gt; %I!%d\n", raddr, rport,
		       laddr, lport);

		switch(version){
		case V4:
			icmpnoconv(f, bp);
			break;
		case V6:
			icmphostunr(f, ifc, bp, Icmp6_port_unreach, 0);
			break;
		default:
			panic("udpiput2: version %d", version);
		}

		freeblist(bp);
		return;
	}
	ucb = (Udpcb*)c-&gt;ptcl;

	if(c-&gt;state == Announced){
		if(ucb-&gt;headers == 0){
			/* create a new conversation */
			if(ipforme(f, laddr) != Runi) {
				switch(version){
				case V4:
					v4tov6(laddr, ifc-&gt;lifc-&gt;local);
					break;
				case V6:
					ipmove(laddr, ifc-&gt;lifc-&gt;local);
					break;
				default:
					panic("udpiput3: version %d", version);
				}
			}
			c = Fsnewcall(c, raddr, rport, laddr, lport, version);
			if(c == nil){
				qunlock(udp);
				freeblist(bp);
				return;
			}
			iphtadd(&amp;upriv-&gt;ht, c);
			ucb = (Udpcb*)c-&gt;ptcl;
		}
	}

	qlock(c);
	qunlock(udp);

	/*
	 * Trim the packet down to data size
	 */
	len -= UDP_UDPHDR_SZ;
	switch(version){
	case V4:
		bp = trimblock(bp, UDP4_IPHDR_SZ+UDP_UDPHDR_SZ, len);
		break;
	case V6:
		bp = trimblock(bp, UDP6_IPHDR_SZ+UDP_UDPHDR_SZ, len);
		break;
	default:
		bp = nil;
		panic("udpiput4: version %d", version);
	}
	if(bp == nil){
		qunlock(c);
		netlog(f, Logudp, "udp: len err %I.%d -&gt; %I.%d\n", raddr, rport,
		       laddr, lport);
		upriv-&gt;lenerr++;
		return;
	}

	netlog(f, Logudpmsg, "udp: %I.%d -&gt; %I.%d l %d\n", raddr, rport,
	       laddr, lport, len);

	switch(ucb-&gt;headers){
	case 7:
		/* pass the src address */
		bp = padblock(bp, UDP_USEAD7);
		p = bp-&gt;rp;
		ipmove(p, raddr); p += IPaddrlen;
		ipmove(p, laddr); p += IPaddrlen;
		ipmove(p, ifc-&gt;lifc-&gt;local); p += IPaddrlen;
		hnputs(p, rport); p += 2;
		hnputs(p, lport);
		break;
	}

	if(bp-&gt;next)
		bp = concatblock(bp);

	if(qfull(c-&gt;rq)){
		qunlock(c);
		netlog(f, Logudp, "udp: qfull %I.%d -&gt; %I.%d\n", raddr, rport,
		       laddr, lport);
		freeblist(bp);
		return;
	}

	qpass(c-&gt;rq, bp);
	qunlock(c);

}

char*
udpctl(Conv *c, char **f, int n)
{
	Udpcb *ucb;

	ucb = (Udpcb*)c-&gt;ptcl;
	if(n == 1){
		if(strcmp(f[0], "headers") == 0){
			ucb-&gt;headers = 7;	/* new headers format */
			return nil;
		}
	}
	return "unknown control request";
}

void
udpadvise(Proto *udp, Block *bp, char *msg)
{
	Udp4hdr *h4;
	Udp6hdr *h6;
	uchar source[IPaddrlen], dest[IPaddrlen];
	ushort psource, pdest;
	Conv *s, **p;
	int version;

	h4 = (Udp4hdr*)(bp-&gt;rp);
	version = ((h4-&gt;vihl&amp;0xF0)==IP_VER6) ? 6 : 4;

	switch(version) {
	case V4:
		v4tov6(dest, h4-&gt;udpdst);
		v4tov6(source, h4-&gt;udpsrc);
		psource = nhgets(h4-&gt;udpsport);
		pdest = nhgets(h4-&gt;udpdport);
		break;
	case V6:
		h6 = (Udp6hdr*)(bp-&gt;rp);
		ipmove(dest, h6-&gt;udpdst);
		ipmove(source, h6-&gt;udpsrc);
		psource = nhgets(h6-&gt;udpsport);
		pdest = nhgets(h6-&gt;udpdport);
		break;
	default:
		panic("udpadvise: version %d", version);
		return;  /* to avoid a warning */
	}

	/* Look for a connection */
	qlock(udp);
	for(p = udp-&gt;conv; *p; p++) {
		s = *p;
		if(s-&gt;rport == pdest)
		if(s-&gt;lport == psource)
		if(ipcmp(s-&gt;raddr, dest) == 0)
		if(ipcmp(s-&gt;laddr, source) == 0){
			if(s-&gt;ignoreadvice)
				break;
			qlock(s);
			qunlock(udp);
			qhangup(s-&gt;rq, msg);
			qhangup(s-&gt;wq, msg);
			qunlock(s);
			freeblist(bp);
			return;
		}
	}
	qunlock(udp);
	freeblist(bp);
}

int
udpstats(Proto *udp, char *buf, int len)
{
	Udppriv *upriv;

	upriv = udp-&gt;priv;
	return snprint(buf, len, "InDatagrams: %llud\nNoPorts: %lud\n"
		"InErrors: %lud\nOutDatagrams: %llud\n",
		upriv-&gt;ustats.udpInDatagrams,
		upriv-&gt;ustats.udpNoPorts,
		upriv-&gt;ustats.udpInErrors,
		upriv-&gt;ustats.udpOutDatagrams);
}

void
udpinit(Fs *fs)
{
	Proto *udp;

	udp = smalloc(sizeof(Proto));
	udp-&gt;priv = smalloc(sizeof(Udppriv));
	udp-&gt;name = "udp";
	udp-&gt;connect = udpconnect;
	udp-&gt;announce = udpannounce;
	udp-&gt;ctl = udpctl;
	udp-&gt;state = udpstate;
	udp-&gt;create = udpcreate;
	udp-&gt;close = udpclose;
	udp-&gt;rcv = udpiput;
	udp-&gt;advise = udpadvise;
	udp-&gt;stats = udpstats;
	udp-&gt;ipproto = IP_UDPPROTO;
	udp-&gt;nc = Nchans;
	udp-&gt;ptclsize = sizeof(Udpcb);

	Fsproto(fs, udp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

