<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/flashkw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/flashkw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * sheevaplug nand flash driver
 *
 * for now separate from (inferno's) os/port/flashnand.c because the flash
 * seems newer, and has different commands, but that is nand-chip specific,
 * not sheevaplug-specific.  they should be merged in future.
 *
 * the sheevaplug has a hynix 4gbit flash chip: hy27uf084g2m.
 * 2048 byte pages, with 64 spare bytes each; erase block size is 128k.
 *
 * it has a "glueless" interface, at 0xf9000000.  that's the address
 * of the data register.  the command and address registers are those
 * or'ed with 1 and 2 respectively.
 *
 * linux uses this layout for the nand flash (from address 0 onwards):
 *	1mb for u-boot
 *	4mb for kernel
 *	507mb for file system
 *
 * this is not so relevant here except for ecc.  the first two areas
 * (u-boot and kernel) are expected to have 4-bit ecc per 512 bytes
 * (but calculated from last byte to first), bad erase blocks skipped.
 * the file system area has 1-bit ecc per 256 bytes.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"

#include	"../port/flashif.h"
#include	"../port/nandecc.h"

enum {
	Debug		= 0,

	Nopage		= ~0ul,		/* cache is empty */

	/* vendors */
	Hynix		= 0xad,
	Samsung		= 0xec,

	/* chips */
	Hy27UF084G2M	= 0xdc,

	NandActCEBoot	= 1&lt;&lt;1,
};

typedef struct Nandreg Nandreg;
typedef struct Nandtab Nandtab;
typedef struct Cache Cache;

struct Nandreg {			/* hw registers */
	ulong	rdparms;
	ulong	wrparms;
	uchar	_pad0[0x70 - 0x20];
	ulong	ctl;
};

struct Nandtab {
	int	vid;
	int	did;
	vlong	size;
	char*	name;
};

struct Cache {
	Flash	*flif;
	ulong	pageno;
	ulong	pgsize;			/* r-&gt;pagesize */
	char	*page;			/* of pgsize bytes */
};

enum {
	/* commands */
	Readstatus	= 0x70,
	Readid		= 0x90,	/* needs 1 0-address write */
	Resetf		= 0xff,

	/*
	 * needs 5 address writes followed by Readstart,
	 * Readstartcache or Restartcopy.
	 */
	Read		= 0x00,
	Readstart	= 0x30,
	Readstartcache	= 0x31,
	Readstartcopy	= 0x35,
	/* after Readstartcache, to stop reading next pages */
	Readstopcache	= 0x34,

	/* needs 5 address writes, the data, and -start or -cache */
	Program		= 0x80,
	Programstart	= 0x10,
	Programcache	= 0x15,

	Copyback	= 0x85,	/* followed by Programstart */

	/* 3 address writes for block followed by Erasestart */
	Erase		= 0x60,
	Erasestart	= 0xd0,

	Randomread	= 0x85,
	Randomwrite	= 0x05,
	Randomwritestart= 0xe0,

	/* status bits */
	SFail		= 1&lt;&lt;0,
	SCachefail	= 1&lt;&lt;1,
	SIdle		= 1&lt;&lt;5,		/* doesn't seem to come on ever */
	SReady		= 1&lt;&lt;6,
	SNotprotected	= 1&lt;&lt;7,

	Srdymask	= SReady,	/* was SIdle|SReady */
};

Nandtab nandtab[] = {
	{Hynix,		Hy27UF084G2M,	512*MB,	"Hy27UF084G2M"},
	{Samsung,	0xdc,		512*MB,	"Samsung 2Gb"},
};

static Cache cache;

static void
nandcmd(Flash *f, uchar b)
{
	uchar *p = (uchar *)((ulong)f-&gt;addr|1);

	*p = b;
	coherence();
}

static void
nandaddr(Flash *f, uchar b)
{
	uchar *p = (uchar *)((ulong)f-&gt;addr|2);

	*p = b;
	coherence();
}

static uchar
nandread(Flash *f)
{
	return *(uchar *)f-&gt;addr;
}

static void
nandreadn(Flash *f, uchar *buf, long n)
{
	uchar *p = f-&gt;addr;

	while(n-- &gt; 0)
		*buf++ = *p;
}

static void
nandwrite(Flash *f, uchar b)
{
	*(uchar *)f-&gt;addr = b;
	coherence();
}

static void
nandwriten(Flash *f, uchar *buf, long n)
{
	uchar *p = f-&gt;addr;

	while(n-- &gt; 0)
		*p = *buf++;
	coherence();
}

static void
nandclaim(Flash*)
{
	Nandreg *nand = (Nandreg*)soc.nand;

	nand-&gt;ctl |= NandActCEBoot;
	coherence();
}

static void
nandunclaim(Flash*)
{
	Nandreg *nand = (Nandreg*)soc.nand;

	nand-&gt;ctl &amp;= ~NandActCEBoot;
	coherence();
}


Nandtab *
findflash(Flash *f, uintptr pa, uchar *id4p)
{
	int i;
	ulong sts;
	uchar maker, device, id3, id4;
	Nandtab *chip;

	mmuidmap(pa, 16);
	f-&gt;addr = (void *)pa;

	/* make sure controller is idle */
	nandclaim(f);
	nandcmd(f, Resetf);
	nandunclaim(f);

	nandclaim(f);
	nandcmd(f, Readstatus);
	sts = nandread(f);
	nandunclaim(f);
	for (i = 10; i &gt; 0 &amp;&amp; !(sts &amp; SReady); i--) {
		delay(50);
		nandclaim(f);
		nandcmd(f, Readstatus);
		sts = nandread(f);
		nandunclaim(f);
	}
	if(!(sts &amp; SReady)) {
		if (Debug)
			print("flashkw: ctlr %#p not ready\n", pa);
		return nil;
	}

	nandclaim(f);
	nandcmd(f, Readid);
	nandaddr(f, 0);
	maker = nandread(f);
	device = nandread(f);
	id3 = nandread(f);
	USED(id3);
	id4 = nandread(f);
	nandunclaim(f);
	if (id4p)
		*id4p = id4;

	for(i = 0; i &lt; nelem(nandtab); i++) {
		chip = &amp;nandtab[i];
		if(chip-&gt;vid == maker &amp;&amp; chip-&gt;did == device)
			return chip;
	}
	print("flashkw: unknown chip: vid %#ux did %#ux\n", maker, device);
	return nil;
}

int
flashat(Flash *f, uintptr pa)
{
	return findflash(f, pa, nil) != nil;
}

static int
idchip(Flash *f)
{
	uchar id4;
	Flashregion *r;
	Nandtab *chip;
	static int blocksizes[4] = { 64*1024, 128*1024, 256*1024, 0 };
	static int pagesizes[4] = { 1024, 2*1024, 0, 0 };
	static int spares[2] = { 8, 16 };		/* per 512 bytes */

	f-&gt;id = 0;
	f-&gt;devid = 0;
	f-&gt;width = 1;
	chip = findflash(f, (uintptr)f-&gt;addr, &amp;id4);
	if (chip == nil)
		return -1;
	f-&gt;id = chip-&gt;vid;
	f-&gt;devid = chip-&gt;did;
	f-&gt;size = chip-&gt;size;
	f-&gt;width = 1;
	f-&gt;nr = 1;

	r = &amp;f-&gt;regions[0];
	r-&gt;pagesize = pagesizes[id4 &amp; MASK(2)];
	r-&gt;erasesize = blocksizes[(id4 &gt;&gt; 4) &amp; MASK(2)];
	if (r-&gt;pagesize == 0 || r-&gt;erasesize == 0) {
		iprint("flashkw: bogus flash sizes\n");
		return -1;
	}
	r-&gt;n = f-&gt;size / r-&gt;erasesize;
	r-&gt;start = 0;
	r-&gt;end = f-&gt;size;
	assert(ispow2(r-&gt;pagesize));
	r-&gt;pageshift = log2(r-&gt;pagesize);
	assert(ispow2(r-&gt;erasesize));
	r-&gt;eraseshift = log2(r-&gt;erasesize);
	assert(r-&gt;eraseshift &gt;= r-&gt;pageshift);
	if (cache.page == nil) {
		cache.pgsize = r-&gt;pagesize;
		cache.page = smalloc(r-&gt;pagesize);
	}

	r-&gt;spares = r-&gt;pagesize / 512 * spares[(id4 &gt;&gt; 2) &amp; 1];
	print("#F0: kwnand: %s %,lud bytes pagesize %lud erasesize %,lud"
		" spares per page %lud\n", chip-&gt;name, f-&gt;size, r-&gt;pagesize,
		r-&gt;erasesize, r-&gt;spares);
	return 0;
}

static int
ctlrwait(Flash *f)
{
	int sts, cnt;

	nandclaim(f);
	for (;;) {
		nandcmd(f, Readstatus);
		for(cnt = 100; cnt &gt; 0 &amp;&amp; (nandread(f) &amp; Srdymask) != Srdymask;
		    cnt--)
			microdelay(50);
		nandcmd(f, Readstatus);
		sts = nandread(f);
		if((sts &amp; Srdymask) == Srdymask)
			break;
		print("flashkw: flash ctlr busy, sts %#ux: resetting\n", sts);
		nandcmd(f, Resetf);
	}
	nandunclaim(f);
	return 0;
}

static int
erasezone(Flash *f, Flashregion *r, ulong offset)
{
	int i;
	ulong page, block;
	uchar s;

	if (Debug) {
		print("flashkw: erasezone: offset %#lux, region nblocks %d,"
			" start %#lux, end %#lux\n", offset, r-&gt;n, r-&gt;start,
			r-&gt;end);
		print(" erasesize %lud, pagesize %lud\n",
			r-&gt;erasesize, r-&gt;pagesize);
	}
	assert(r-&gt;erasesize != 0);
	if(offset &amp; (r-&gt;erasesize - 1)) {
		print("flashkw: erase offset %lud not block aligned\n", offset);
		return -1;
	}
	page = offset &gt;&gt; r-&gt;pageshift;
	block = page &gt;&gt; (r-&gt;eraseshift - r-&gt;pageshift);
	if (Debug)
		print("flashkw: erase: block %#lux\n", block);

	/* make sure controller is idle */
	if(ctlrwait(f) &lt; 0) {
		print("flashkw: erase: flash busy\n");
		return -1;
	}

	/* start erasing */
	nandclaim(f);
	nandcmd(f, Erase);
	nandaddr(f, page&gt;&gt;0);
	nandaddr(f, page&gt;&gt;8);
	nandaddr(f, page&gt;&gt;16);
	nandcmd(f, Erasestart);

	/* invalidate cache on any erasure (slight overkill) */
	cache.pageno = Nopage;

	/* have to wait until flash is done.  typically ~2ms */
	delay(1);
	nandcmd(f, Readstatus);
	for(i = 0; i &lt; 100; i++) {
		s = nandread(f);
		if(s &amp; SReady) {
			nandunclaim(f);
			if(s &amp; SFail) {
				print("flashkw: erase: failed, block %#lux\n",
					block);
				return -1;
			}
			return 0;
		}
		microdelay(50);
	}
	print("flashkw: erase timeout, block %#lux\n", block);
	nandunclaim(f);
	return -1;
}

static void
flcachepage(Flash *f, ulong page, uchar *buf)
{
	Flashregion *r = &amp;f-&gt;regions[0];

	assert(cache.pgsize == r-&gt;pagesize);
	cache.flif = f;
	cache.pageno = page;
	/* permit i/o directly to or from the cache */
	if (buf != (uchar *)cache.page)
		memmove(cache.page, buf, cache.pgsize);
}

static int
write1page(Flash *f, ulong offset, void *buf)
{
	int i;
	ulong page, v;
	uchar s;
	uchar *eccp, *p;
	Flashregion *r = &amp;f-&gt;regions[0];
	static uchar *oob;

	if (oob == nil)
		oob = smalloc(r-&gt;spares);

	page = offset &gt;&gt; r-&gt;pageshift;
	if (Debug)
		print("flashkw: write nand offset %#lux page %#lux\n",
			offset, page);

	if(offset &amp; (r-&gt;pagesize - 1)) {
		print("flashkw: write offset %lud not page aligned\n", offset);
		return -1;
	}

	p = buf;
	memset(oob, 0xff, r-&gt;spares);
	assert(r-&gt;spares &gt;= 24);
	eccp = oob + r-&gt;spares - 24;
	for(i = 0; i &lt; r-&gt;pagesize / 256; i++) {
		v = nandecc(p);
		*eccp++ = v&gt;&gt;8;
		*eccp++ = v&gt;&gt;0;
		*eccp++ = v&gt;&gt;16;
		p += 256;
	}

	if(ctlrwait(f) &lt; 0) {
		print("flashkw: write: nand not ready &amp; idle\n");
		return -1;
	}

	/* write, only whole pages for now, no sub-pages */
	nandclaim(f);
	nandcmd(f, Program);
	nandaddr(f, 0);
	nandaddr(f, 0);
	nandaddr(f, page&gt;&gt;0);
	nandaddr(f, page&gt;&gt;8);
	nandaddr(f, page&gt;&gt;16);
	nandwriten(f, buf, r-&gt;pagesize);
	nandwriten(f, oob, r-&gt;spares);
	nandcmd(f, Programstart);

	microdelay(100);
	nandcmd(f, Readstatus);
	for(i = 0; i &lt; 100; i++) {
		s = nandread(f);
		if(s &amp; SReady) {
			nandunclaim(f);
			if(s &amp; SFail) {
				print("flashkw: write failed, page %#lux\n",
					page);
				return -1;
			}
			return 0;
		}
		microdelay(10);
	}

	nandunclaim(f);
	flcachepage(f, page, buf);
	print("flashkw: write timeout for page %#lux\n", page);
	return -1;
}

static int
read1page(Flash *f, ulong offset, void *buf)
{
	int i;
	ulong addr, page, w;
	uchar *eccp, *p;
	Flashregion *r = &amp;f-&gt;regions[0];
	static uchar *oob;

	if (oob == nil)
		oob = smalloc(r-&gt;spares);

	assert(r-&gt;pagesize != 0);
	addr = offset &amp; (r-&gt;pagesize - 1);
	page = offset &gt;&gt; r-&gt;pageshift;
	if(addr != 0) {
		print("flashkw: read1page: read addr %#lux:"
			" must read aligned page\n", addr);
		return -1;
	}

	/* satisfy request from cache if possible */
	if (f == cache.flif &amp;&amp; page == cache.pageno &amp;&amp;
	    r-&gt;pagesize == cache.pgsize) {
		memmove(buf, cache.page, r-&gt;pagesize);
		return 0;
	}

	if (Debug)
		print("flashkw: read offset %#lux addr %#lux page %#lux\n",
			offset, addr, page);

	nandclaim(f);
	nandcmd(f, Read);
	nandaddr(f, addr&gt;&gt;0);
	nandaddr(f, addr&gt;&gt;8);
	nandaddr(f, page&gt;&gt;0);
	nandaddr(f, page&gt;&gt;8);
	nandaddr(f, page&gt;&gt;16);
	nandcmd(f, Readstart);

	microdelay(50);

	nandreadn(f, buf, r-&gt;pagesize);
	nandreadn(f, oob, r-&gt;spares);

	nandunclaim(f);

	/* verify/correct data. last 8*3 bytes is ecc, per 256 bytes. */
	p = buf;
	assert(r-&gt;spares &gt;= 24);
	eccp = oob + r-&gt;spares - 24;
	for(i = 0; i &lt; r-&gt;pagesize / 256; i++) {
		w = eccp[0] &lt;&lt; 8 | eccp[1] &lt;&lt; 0 | eccp[2] &lt;&lt; 16;
		eccp += 3;
		switch(nandecccorrect(p, nandecc(p), &amp;w, 1)) {
		case NandEccErrorBad:
			print("(page %d)\n", i);
			return -1;
		case NandEccErrorOneBit:
		case NandEccErrorOneBitInEcc:
			print("(page %d)\n", i);
			/* fall through */
		case NandEccErrorGood:
			break;
		}
		p += 256;
	}

	flcachepage(f, page, buf);
	return 0;
}

/*
 * read a page at offset into cache, copy fragment from buf into it
 * at pagoff, and rewrite that page.
 */
static int
rewrite(Flash *f, ulong offset, ulong pagoff, void *buf, ulong size)
{
	if (read1page(f, offset, cache.page) &lt; 0)
		return -1;
	memmove(&amp;cache.page[pagoff], buf, size);
	return write1page(f, offset, cache.page);
}

/* there are no alignment constraints on offset, buf, nor n */
static int
write(Flash *f, ulong offset, void *buf, long n)
{
	uint un, frag, pagoff;
	ulong pgsize;
	uchar *p;
	Flashregion *r = &amp;f-&gt;regions[0];

	if(n &lt;= 0)
		panic("flashkw: write: non-positive count %ld", n);
	un = n;
	assert(r-&gt;pagesize != 0);
	pgsize = r-&gt;pagesize;

	/* if a partial first page exists, update the first page with it. */
	p = buf;
	pagoff = offset % pgsize;
	if (pagoff != 0) {
		frag = pgsize - pagoff;
		if (frag &gt; un)		/* might not extend to end of page */
			frag = un;
		if (rewrite(f, offset - pagoff, pagoff, p, frag) &lt; 0)
			return -1;
		offset += frag;
		p  += frag;
		un -= frag;
	}

	/* copy whole pages */
	while (un &gt;= pgsize) {
		if (write1page(f, offset, p) &lt; 0)
			return -1;
		offset += pgsize;
		p  += pgsize;
		un -= pgsize;
	}

	/* if a partial last page exists, update the last page with it. */
	if (un &gt; 0)
		return rewrite(f, offset, 0, p, un);
	return 0;
}

/* there are no alignment constraints on offset, buf, nor n */
static int
read(Flash *f, ulong offset, void *buf, long n)
{
	uint un, frag, pagoff;
	ulong pgsize;
	uchar *p;
	Flashregion *r = &amp;f-&gt;regions[0];

	if(n &lt;= 0)
		panic("flashkw: read: non-positive count %ld", n);
	un = n;
	assert(r-&gt;pagesize != 0);
	pgsize = r-&gt;pagesize;

	/* if partial 1st page, read it into cache &amp; copy fragment to buf */
	p = buf;
	pagoff = offset % pgsize;
	if (pagoff != 0) {
		frag = pgsize - pagoff;
		if (frag &gt; un)		/* might not extend to end of page */
			frag = un;
		if (read1page(f, offset - pagoff, cache.page) &lt; 0)
			return -1;
		offset += frag;
		memmove(p, &amp;cache.page[pagoff], frag);
		p  += frag;
		un -= frag;
	}

	/* copy whole pages */
	while (un &gt;= pgsize) {
		if (read1page(f, offset, p) &lt; 0)
			return -1;
		offset += pgsize;
		p  += pgsize;
		un -= pgsize;
	}

	/* if partial last page, read into cache &amp; copy initial fragment to buf */
	if (un &gt; 0) {
		if (read1page(f, offset, cache.page) &lt; 0)
			return -1;
		memmove(p, cache.page, un);
	}
	return 0;
}

static int
reset(Flash *f)
{
	if(f-&gt;data != nil)
		return 1;
	f-&gt;write = write;
 	f-&gt;read = read;
	f-&gt;eraseall = nil;
	f-&gt;erasezone = erasezone;
	f-&gt;suspend = nil;
	f-&gt;resume = nil;
	f-&gt;sort = "nand";
	cache.pageno = Nopage;
	return idchip(f);
}

void
flashkwlink(void)
{
	addflashcard("nand", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

