<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/fpiarm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/fpiarm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * this doesn't attempt to implement ARM floating-point properties
 * that aren't visible in the Inferno environment.
 * all arithmetic is done in double precision.
 * the FP trap status isn't updated.
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"

#include	"ureg.h"

#include	"arm.h"
#include	"../port/fpi.h"

/* undef this if correct kernel r13 isn't in Ureg;
 * check calculation in fpiarm below
 */


#define	REG(ur, x) (*(long*)(((char*)(ur))+roff[(x)]))
#define	FR(ufp, x) (*(Internal*)(ufp)-&gt;regs[(x)&amp;7])

typedef struct FP2 FP2;
typedef struct FP1 FP1;

struct FP2 {
	char*	name;
	void	(*f)(Internal, Internal, Internal*);
};

struct FP1 {
	char*	name;
	void	(*f)(Internal*, Internal*);
};

enum {
	N = 1&lt;&lt;31,
	Z = 1&lt;&lt;30,
	C = 1&lt;&lt;29,
	V = 1&lt;&lt;28,
	REGPC = 15,
};

enum {
	fpemudebug = 0,
};

#undef OFR
#define	OFR(X)	((ulong)&amp;((Ureg*)0)-&gt;X)

static	int	roff[] = {
	OFR(r0), OFR(r1), OFR(r2), OFR(r3),
	OFR(r4), OFR(r5), OFR(r6), OFR(r7),
	OFR(r8), OFR(r9), OFR(r10), OFR(r11),
	OFR(r12), OFR(r13), OFR(r14), OFR(pc),
};

static Internal fpconst[8] = {	/* indexed by op&amp;7 */
	/* s, e, l, h */
	{0, 0x1, 0x00000000, 0x00000000}, /* 0.0 */
	{0, 0x3FF, 0x00000000, 0x08000000},	/* 1.0 */
	{0, 0x400, 0x00000000, 0x08000000},	/* 2.0 */
	{0, 0x400, 0x00000000, 0x0C000000},	/* 3.0 */
	{0, 0x401, 0x00000000, 0x08000000},	/* 4.0 */
	{0, 0x401, 0x00000000, 0x0A000000},	/* 5.0 */
	{0, 0x3FE, 0x00000000, 0x08000000},	/* 0.5 */
	{0, 0x402, 0x00000000, 0x0A000000},	/* 10.0 */
};

/*
 * arm binary operations
 */

static void
fadd(Internal m, Internal n, Internal *d)
{
	(m.s == n.s? fpiadd: fpisub)(&amp;m, &amp;n, d);
}

static void
fsub(Internal m, Internal n, Internal *d)
{
	m.s ^= 1;
	(m.s == n.s? fpiadd: fpisub)(&amp;m, &amp;n, d);
}

static void
fsubr(Internal m, Internal n, Internal *d)
{
	n.s ^= 1;
	(n.s == m.s? fpiadd: fpisub)(&amp;n, &amp;m, d);
}

static void
fmul(Internal m, Internal n, Internal *d)
{
	fpimul(&amp;m, &amp;n, d);
}

static void
fdiv(Internal m, Internal n, Internal *d)
{
	fpidiv(&amp;m, &amp;n, d);
}

static void
fdivr(Internal m, Internal n, Internal *d)
{
	fpidiv(&amp;n, &amp;m, d);
}

/*
 * arm unary operations
 */

static void
fmov(Internal *m, Internal *d)
{
	*d = *m;
}

static void
fmovn(Internal *m, Internal *d)
{
	*d = *m;
	d-&gt;s ^= 1;
}

static void
fabsf(Internal *m, Internal *d)
{
	*d = *m;
	d-&gt;s = 0;
}

static void
frnd(Internal *m, Internal *d)
{
	short e;

	(m-&gt;s? fsub: fadd)(fpconst[6], *m, d);
	if(IsWeird(d))
		return;
	fpiround(d);
	e = (d-&gt;e - ExpBias) + 1;
	if(e &lt;= 0)
		SetZero(d);
	else if(e &gt; FractBits){
		if(e &lt; 2*FractBits)
			d-&gt;l &amp;= ~((1&lt;&lt;(2*FractBits - e))-1);
	}else{
		d-&gt;l = 0;
		if(e &lt; FractBits)
			d-&gt;h &amp;= ~((1&lt;&lt;(FractBits-e))-1);
	}
}

static	FP1	optab1[16] = {	/* Fd := OP Fm */
[0]	{"MOVF",	fmov},
[1]	{"NEGF",	fmovn},
[2]	{"ABSF",	fabsf},
[3]	{"RNDF",	frnd},
[4]	{"SQTF",	/*fsqt*/0},
/* LOG, LGN, EXP, SIN, COS, TAN, ASN, ACS, ATN all `deprecated' */
/* URD and NRM aren't implemented */
};

static	FP2	optab2[16] = {	/* Fd := Fn OP Fm */
[0]	{"ADDF",	fadd},
[1]	{"MULF",	fmul},
[2]	{"SUBF",	fsub},
[3]	{"RSUBF",	fsubr},
[4]	{"DIVF",	fdiv},
[5]	{"RDIVF",	fdivr},
/* POW, RPW deprecated */
[8]	{"REMF",	/*frem*/0},
[9]	{"FMF",	fmul},	/* fast multiply */
[10]	{"FDV",	fdiv},	/* fast divide */
[11]	{"FRD",	fdivr},	/* fast reverse divide */
/* POL deprecated */
};

static ulong
fcmp(Internal *n, Internal *m)
{
	int i;
	Internal rm, rn;

	if(IsWeird(m) || IsWeird(n)){
		/* BUG: should trap if not masked */
		return V|C;
	}
	rn = *n;
	rm = *m;
	fpiround(&amp;rn);
	fpiround(&amp;rm);
	i = fpicmp(&amp;rn, &amp;rm);
	if(i &gt; 0)
		return C;
	else if(i == 0)
		return C|Z;
	else
		return N;
}

static void
fld(void (*f)(Internal*, void*), int d, ulong ea, int n, FPsave *ufp)
{
	void *mem;

	mem = (void*)ea;
	(*f)(&amp;FR(ufp, d), mem);
	if(fpemudebug)
		print("MOV%c #%lux, F%d\n", n==8? 'D': 'F', ea, d);
}

static void
fst(void (*f)(void*, Internal*), ulong ea, int s, int n, FPsave *ufp)
{
	Internal tmp;
	void *mem;

	mem = (void*)ea;
	tmp = FR(ufp, s);
	if(fpemudebug)
		print("MOV%c	F%d,#%lux\n", n==8? 'D': 'F', s, ea);
	(*f)(mem, &amp;tmp);
}

static int
condok(int cc, int c)
{
	switch(c){
	case 0:	/* Z set */
		return cc&amp;Z;
	case 1:	/* Z clear */
		return (cc&amp;Z) == 0;
	case 2:	/* C set */
		return cc&amp;C;
	case 3:	/* C clear */
		return (cc&amp;C) == 0;
	case 4:	/* N set */
		return cc&amp;N;
	case 5:	/* N clear */
		return (cc&amp;N) == 0;
	case 6:	/* V set */
		return cc&amp;V;
	case 7:	/* V clear */
		return (cc&amp;V) == 0;
	case 8:	/* C set and Z clear */
		return cc&amp;C &amp;&amp; (cc&amp;Z) == 0;
	case 9:	/* C clear or Z set */
		return (cc&amp;C) == 0 || cc&amp;Z;
	case 10:	/* N set and V set, or N clear and V clear */
		return (~cc&amp;(N|V))==0 || (cc&amp;(N|V)) == 0;
	case 11:	/* N set and V clear, or N clear and V set */
		return (cc&amp;(N|V))==N || (cc&amp;(N|V))==V;
	case 12:	/* Z clear, and either N set and V set or N clear and V clear */
		return (cc&amp;Z) == 0 &amp;&amp; ((~cc&amp;(N|V))==0 || (cc&amp;(N|V))==0);
	case 13:	/* Z set, or N set and V clear or N clear and V set */
		return (cc&amp;Z) || (cc&amp;(N|V))==N || (cc&amp;(N|V))==V;
	case 14:	/* always */
		return 1;
	case 15:	/* never (reserved) */
		return 0;
	}
	return 0;	/* not reached */
}

static void
unimp(ulong pc, ulong op)
{
	char buf[60];

	snprint(buf, sizeof(buf), "sys: fp: pc=%lux unimp fp 0x%.8lux", pc, op);
	if(fpemudebug)
		print("FPE: %s\n", buf);
	error(buf);
	/* no return */
}

static void
fpemu(ulong pc, ulong op, Ureg *ur, FPsave *ufp)
{
	int rn, rd, tag, o;
	long off;
	ulong ea;
	Internal tmp, *fm, *fn;

	/* note: would update fault status here if we noted numeric exceptions */

	/*
	 * LDF, STF; 10.1.1
	 */
	if(((op&gt;&gt;25)&amp;7) == 6){
		if(op &amp; (1&lt;&lt;22))
			unimp(pc, op);	/* packed or extended */
		rn = (op&gt;&gt;16)&amp;0xF;
		off = (op&amp;0xFF)&lt;&lt;2;
		if((op &amp; (1&lt;&lt;23)) == 0)
			off = -off;
		ea = REG(ur, rn);
		if(rn == REGPC)
			ea += 8;
		if(op &amp; (1&lt;&lt;24))
			ea += off;
		rd = (op&gt;&gt;12)&amp;7;
		if(op &amp; (1&lt;&lt;20)){
			if(op &amp; (1&lt;&lt;15))
				fld(fpid2i, rd, ea, 8, ufp);
			else
				fld(fpis2i, rd, ea, 4, ufp);
		}else{
			if(op &amp; (1&lt;&lt;15))
				fst(fpii2d, ea, rd, 8, ufp);
			else
				fst(fpii2s, ea, rd, 4, ufp);
		}
		if((op &amp; (1&lt;&lt;24)) == 0)
			ea += off;
		if(op &amp; (1&lt;&lt;21))
			REG(ur, rn) = ea;
		return;
	}

	/*
	 * CPRT/transfer, 10.3
	 */
	if(op &amp; (1&lt;&lt;4)){
		rd = (op&gt;&gt;12) &amp; 0xF;

		/*
		 * compare, 10.3.1
		 */
		if(rd == 15 &amp;&amp; op &amp; (1&lt;&lt;20)){
			rn = (op&gt;&gt;16)&amp;7;
			fn = &amp;FR(ufp, rn);
			if(op &amp; (1&lt;&lt;3)){
				fm = &amp;fpconst[op&amp;7];
				if(fpemudebug)
					tag = 'C';
			}else{
				fm = &amp;FR(ufp, op&amp;7);
				if(fpemudebug)
					tag = 'F';
			}
			switch((op&gt;&gt;21)&amp;7){
			default:
				unimp(pc, op);
			case 4:	/* CMF: Fn :: Fm */
			case 6:	/* CMFE: Fn :: Fm (with exception) */
				ur-&gt;psr &amp;= ~(N|C|Z|V);
				ur-&gt;psr |= fcmp(fn, fm);
				break;
			case 5:	/* CNF: Fn :: -Fm */
			case 7:	/* CNFE: Fn :: -Fm (with exception) */
				tmp = *fm;
				tmp.s ^= 1;
				ur-&gt;psr &amp;= ~(N|C|Z|V);
				ur-&gt;psr |= fcmp(fn, &amp;tmp);
				break;
			}
			if(fpemudebug)
				print("CMPF	%c%d,F%ld =%#lux\n",
					tag, rn, op&amp;7, ur-&gt;psr&gt;&gt;28);
			return;
		}

		/*
		 * other transfer, 10.3
		 */
		switch((op&gt;&gt;20)&amp;0xF){
		default:
			unimp(pc, op);
		case 0:	/* FLT */
			rn = (op&gt;&gt;16) &amp; 7;
			fpiw2i(&amp;FR(ufp, rn), &amp;REG(ur, rd));
			if(fpemudebug)
				print("MOVW[FD]	R%d, F%d\n", rd, rn);
			break;
		case 1:	/* FIX */
			if(op &amp; (1&lt;&lt;3))
				unimp(pc, op);
			rn = op &amp; 7;
			tmp = FR(ufp, rn);
			fpii2w(&amp;REG(ur, rd), &amp;tmp);
			if(fpemudebug)
				print("MOV[FD]W	F%d, R%d =%ld\n", rn, rd, REG(ur, rd));
			break;
		case 2:	/* FPSR := Rd */
			ufp-&gt;status = REG(ur, rd);
			if(fpemudebug)
				print("MOVW	R%d, FPSR\n", rd);
			break;
		case 3:	/* Rd := FPSR */
			REG(ur, rd) = ufp-&gt;status;
			if(fpemudebug)
				print("MOVW	FPSR, R%d\n", rd);
			break;
		case 4:	/* FPCR := Rd */
			ufp-&gt;control = REG(ur, rd);
			if(fpemudebug)
				print("MOVW	R%d, FPCR\n", rd);
			break;
		case 5:	/* Rd := FPCR */
			REG(ur, rd) = ufp-&gt;control;
			if(fpemudebug)
				print("MOVW	FPCR, R%d\n", rd);
			break;
		}
		return;
	}

	/*
	 * arithmetic
	 */

	if(op &amp; (1&lt;&lt;3)){	/* constant */
		fm = &amp;fpconst[op&amp;7];
		if(fpemudebug)
			tag = 'C';
	}else{
		fm = &amp;FR(ufp, op&amp;7);
		if(fpemudebug)
			tag = 'F';
	}
	rd = (op&gt;&gt;12)&amp;7;
	o = (op&gt;&gt;20)&amp;0xF;
	if(op &amp; (1&lt;&lt;15)){	/* monadic */
		FP1 *fp;
		fp = &amp;optab1[o];
		if(fp-&gt;f == nil)
			unimp(pc, op);
		if(fpemudebug)
			print("%s	%c%ld,F%d\n", fp-&gt;name, tag, op&amp;7, rd);
		(*fp-&gt;f)(fm, &amp;FR(ufp, rd));
	} else {
		FP2 *fp;
		fp = &amp;optab2[o];
		if(fp-&gt;f == nil)
			unimp(pc, op);
		rn = (op&gt;&gt;16)&amp;7;
		if(fpemudebug)
			print("%s	%c%ld,F%d,F%d\n", fp-&gt;name, tag, op&amp;7, rn, rd);
		(*fp-&gt;f)(*fm, FR(ufp, rn), &amp;FR(ufp, rd));
	}
}

void
casemu(ulong pc, ulong op, Ureg *ur)
{
	ulong *rp, ro, rn, *rd;

	USED(pc);

	rp = (ulong*)ur;
	ro = rp[op&gt;&gt;16 &amp; 0x7];
	rn = rp[op&gt;&gt;0 &amp; 0x7];
	rd = rp + (op&gt;&gt;12 &amp; 0x7);
	rp = (ulong*)*rd;
	validaddr((ulong)rp, 4, 1);
	splhi();
	if(*rd = (*rp == ro))
		*rp = rn;
	spllo();
}

int ldrexvalid;

void
ldrex(ulong pc, ulong op, Ureg *ur)
{
	ulong *rp, *rd, *addr;

	USED(pc);

	rp = (ulong*)ur;
	rd = rp + (op&gt;&gt;16 &amp; 0x7);
	addr = (ulong*)*rd;
	validaddr((ulong)addr, 4, 0);
	ldrexvalid = 1;
	rp[op&gt;&gt;12 &amp; 0x7] = *addr;
	if(fpemudebug)
		print("ldrex, r%ld = [r%ld]@0x%8.8p = 0x%8.8lux",
			op&gt;&gt;12 &amp; 0x7, op&gt;&gt;16 &amp; 0x7, addr, rp[op&gt;&gt;12 &amp; 0x7]);
}

void
clrex(ulong, ulong, Ureg *)
{
	ldrexvalid = 0;
	if(fpemudebug)
		print("clrex");
}

void
strex(ulong pc, ulong op, Ureg *ur)
{
	ulong *rp, rn, *rd, *addr;

	USED(pc);

	rp = (ulong*)ur;
	rd = rp + (op&gt;&gt;16 &amp; 0x7);
	rn = rp[op&gt;&gt;0 &amp; 0x7];
	addr = (ulong*)*rd;
	validaddr((ulong)addr, 4, 1);
	splhi();
	if(ldrexvalid){
		if(fpemudebug)
			print("strex valid, [r%ld]@0x%8.8p = r%ld = 0x%8.8lux",
				op&gt;&gt;16 &amp; 0x7, addr, op&gt;&gt;0 &amp; 0x7, rn);
		*addr = rn;
		ldrexvalid = 0;
		rp[op&gt;&gt;12 &amp; 0x7] = 0;
	}else{
		if(fpemudebug)
			print("strex invalid, r%ld = 1", op&gt;&gt;16 &amp; 0x7);
		rp[op&gt;&gt;12 &amp; 0x7] = 1;
	}
	spllo();
}

struct {
	ulong	opc;
	ulong	mask;
	void	(*f)(ulong, ulong, Ureg*);
} specialopc[] = {
	{ 0x01900f9f, 0x0ff00fff, ldrex },
	{ 0x01800f90, 0x0ff00ff0, strex },
	{ 0xf57ff01f, 0xffffffff, clrex },
	{ 0x0ed00100, 0x0ef08100, casemu },
	{ 0x00000000, 0x00000000, nil }
};

/*
 * returns the number of FP instructions emulated
 */
int
fpiarm(Ureg *ur)
{
	ulong op, o;
	FPsave *ufp;
	int i, n;

	if(up == nil)
		panic("fpiarm not in a process");
	ufp = &amp;up-&gt;fpsave;
	/* because all the state is in the proc structure,
	 * it need not be saved/restored
	 */
	if(up-&gt;fpstate != FPactive){
//		assert(sizeof(Internal) == sizeof(ufp-&gt;regs[0]));
		up-&gt;fpstate = FPactive;
		ufp-&gt;control = 0;
		ufp-&gt;status = (0x01&lt;&lt;28)|(1&lt;&lt;12);	/* software emulation, alternative C flag */
		for(n = 0; n &lt; 8; n++)
			FR(ufp, n) = fpconst[0];
	}
	for(n=0; ;n++){
		validaddr(ur-&gt;pc, 4, 0);
		op = *(ulong*)(ur-&gt;pc);
		if(fpemudebug)
			print("%#lux: %#8.8lux ", ur-&gt;pc, op);
		o = (op&gt;&gt;24) &amp; 0xF;
		if(condok(ur-&gt;psr, op&gt;&gt;28)){
			for(i = 0; specialopc[i].f; i++)
				if((op &amp; specialopc[i].mask) == specialopc[i].opc)
					break;
			if(specialopc[i].f)
				specialopc[i].f(ur-&gt;pc, op, ur);
			else if((op &amp; 0xF00) != 0x100 || o != 0xE &amp;&amp; (o&amp;~1) != 0xC)
				break;
			else
				fpemu(ur-&gt;pc, op, ur, ufp);
		}else if((op &amp; 0xF00) != 0x100 || o != 0xE &amp;&amp; (o&amp;~1) != 0xC)
			break;
		ur-&gt;pc += 4;
	}
	if(fpemudebug) print("\n");
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

