<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/sdio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/sdio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * kirkwood SDIO / SDMem / MMC host interface
 */

#include "u.h"
#include "../port/lib.h"
#include "../port/error.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/sd.h"

#define TM(bits)	((bits)&lt;&lt;16)
#define	GETTM(bits)	(((bits)&gt;&gt;16)&amp;0xFFFF)
#define GETCMD(bits)	((bits)&amp;0xFFFF)

typedef struct Ctlr Ctlr;

enum {
	Clkfreq	= 100000000,	/* external clk frequency */
	Initfreq= 400000,	/* initialisation frequency for MMC */
	SDfreq	= 25000000,	/* standard SD frequency */
	PIOread	= 0,		/* use programmed i/o (not dma) for reading */
	PIOwrite= 0,		/* use programmed i/o (not dma) writing */
	Polldone= 0,		/* poll for Datadone status, don't use interrupt */
	Pollread= 1,		/* poll for reading blocks */
	Pollwrite= 1,		/* poll for writing blocks */

	MMCSelect= 7,		/* mmc/sd card select command */
	Setbuswidth= 6,		/* mmc/sd set bus width command */
};

enum {
	/* Controller registers */
	DmaLSB		= 0x0&gt;&gt;2,
	DmaMSB		= 0x4&gt;&gt;2,
	Blksize		= 0x8&gt;&gt;2,
	Blkcount	= 0xc&gt;&gt;2,
	ArgLSB		= 0x10&gt;&gt;2,
	ArgMSB		= 0x14&gt;&gt;2,
	Tm		= 0x18&gt;&gt;2,
	Cmd		= 0x1c&gt;&gt;2,
	Resp0		= 0x20&gt;&gt;2,
	Resp1		= 0x24&gt;&gt;2,
	Resp2		= 0x28&gt;&gt;2,
	Resp3		= 0x2c&gt;&gt;2,
	Resp4		= 0x30&gt;&gt;2,
	Resp5		= 0x34&gt;&gt;2,
	Resp6		= 0x38&gt;&gt;2,
	Resp7		= 0x3c&gt;&gt;2,
	Data		= 0x40&gt;&gt;2,
	Hoststat	= 0x48&gt;&gt;2,
	Hostctl		= 0x50&gt;&gt;2,
	Clockctl	= 0x58&gt;&gt;2,
	Softreset	= 0x5C&gt;&gt;2,
	Interrupt	= 0x60&gt;&gt;2,
	ErrIntr		= 0x64&gt;&gt;2,
	Irptmask	= 0x68&gt;&gt;2,
	ErrIrptmask	= 0x6C&gt;&gt;2,
	Irpten		= 0x70&gt;&gt;2,
	ErrIrpten	= 0x74&gt;&gt;2,
	Mbuslo		= 0x100&gt;&gt;2,
	Mbushi		= 0x104&gt;&gt;2,
	Win0ctl		= 0x108&gt;&gt;2,
	Win0base	= 0x10c&gt;&gt;2,
	Win1ctl		= 0x110&gt;&gt;2,
	Win1base	= 0x114&gt;&gt;2,
	Win2ctl		= 0x118&gt;&gt;2,
	Win2base	= 0x11c&gt;&gt;2,
	Win3ctl		= 0x120&gt;&gt;2,
	Win3base	= 0x124&gt;&gt;2,
	Clockdiv	= 0x128&gt;&gt;2,

	/* Hostctl */
	Timeouten	= 1&lt;&lt;15,
	Datatoshift	= 11,
	Datatomask	= 0x7800,
	Hispeed		= 1&lt;&lt;10,
	Dwidth4		= 1&lt;&lt;9,
	Dwidth1		= 0&lt;&lt;9,
	Bigendian	= 1&lt;&lt;3,
	LSBfirst	= 1&lt;&lt;4,
	Cardtypemask	= 3&lt;&lt;1,
	Cardtypemem	= 0&lt;&lt;1,
	Cardtypeio	= 1&lt;&lt;1,
	Cardtypeiomem	= 2&lt;&lt;1,
	Cardtypsdio	= 3&lt;&lt;1,
	Pushpullen	= 1&lt;&lt;0,

	/* Clockctl */
	Sdclken		= 1&lt;&lt;0,

	/* Softreset */
	Swreset		= 1&lt;&lt;8,

	/* Cmd */
	Indexshift	= 8,
	Isdata		= 1&lt;&lt;5,
	Ixchken		= 1&lt;&lt;4,
	Crcchken	= 3&lt;&lt;2,
	Respmask	= 3&lt;&lt;0,
	Respnone	= 0&lt;&lt;0,
	Resp136		= 1&lt;&lt;0,
	Resp48		= 2&lt;&lt;0,
	Resp48busy	= 3&lt;&lt;0,

	/* Tm */
	Hostdma		= 0&lt;&lt;6,
	Hostpio		= 1&lt;&lt;6,
	Stopclken	= 1&lt;&lt;5,
	Host2card	= 0&lt;&lt;4,
	Card2host	= 1&lt;&lt;4,
	Autocmd12	= 1&lt;&lt;2,
	Hwwrdata	= 1&lt;&lt;1,
	Swwrdata	= 1&lt;&lt;0,

	/* ErrIntr */
	Crcstaterr	= 1&lt;&lt;14,
	Crcstartbiterr	= 1&lt;&lt;13,
	Crcendbiterr	= 1&lt;&lt;12,
	Resptbiterr	= 1&lt;&lt;11,
	Xfersizeerr	= 1&lt;&lt;10,
	Cmdstarterr	= 1&lt;&lt;9,
	Acmderr		= 1&lt;&lt;8,
	Denderr		= 1&lt;&lt;6,
	Dcrcerr		= 1&lt;&lt;5,
	Dtoerr		= 1&lt;&lt;4,
	Cbaderr		= 1&lt;&lt;3,
	Cenderr		= 1&lt;&lt;2,
	Ccrcerr		= 1&lt;&lt;1,
	Ctoerr		= 1&lt;&lt;0,

	/* Interrupt */
	Err		= 1&lt;&lt;15,
	Write8ready	= 1&lt;&lt;11,
	Read8wready	= 1&lt;&lt;10,
	Cardintr	= 1&lt;&lt;8,
	Readrdy		= 1&lt;&lt;5,
	Writerdy	= 1&lt;&lt;4,
	Dmadone		= 1&lt;&lt;3,
	Blockgap	= 1&lt;&lt;2,
	Datadone	= 1&lt;&lt;1,
	Cmddone		= 1&lt;&lt;0,

	/* Hoststat */
	Fifoempty	= 1&lt;&lt;13,
	Fifofull	= 1&lt;&lt;12,
	Rxactive	= 1&lt;&lt;9,
	Txactive	= 1&lt;&lt;8,
	Cardbusy	= 1&lt;&lt;1,
	Cmdinhibit	= 1&lt;&lt;0,
};

int cmdinfo[64] = {
[0]	Ixchken,
[2]	Resp136,
[3]	Resp48 | Ixchken | Crcchken,
[6]	Resp48 | Ixchken | Crcchken,
[7]	Resp48busy | Ixchken | Crcchken,
[8]	Resp48 | Ixchken | Crcchken,
[9]	Resp136,
[12]	Resp48busy | Ixchken | Crcchken,
[13]	Resp48 | Ixchken | Crcchken,
[16]	Resp48,
[17]	Resp48 | Isdata | TM(Card2host) | Ixchken | Crcchken,
[18]	Resp48 | Isdata | TM(Card2host) | Ixchken | Crcchken,
[24]	Resp48 | Isdata | TM(Host2card | Hwwrdata) | Ixchken | Crcchken,
[25]	Resp48 | Isdata | TM(Host2card | Hwwrdata) | Ixchken | Crcchken,
[41]	Resp48,
[55]	Resp48 | Ixchken | Crcchken,
};

struct Ctlr {
	Rendez	r;
	int	datadone;
	int	fastclock;
};

static Ctlr ctlr;

static void sdiointerrupt(Ureg*, void*);

void
WR(int reg, u32int val)
{
	u32int *r;

	r = (u32int*)AddrSdio;
	val &amp;= 0xFFFF;
	if(0)iprint("WR %#4.4ux %#ux\n", reg&lt;&lt;2, val);
	r[reg] = val;
}

static uint
clkdiv(uint d)
{
	assert(d &lt; 1&lt;&lt;11);
	return d;
}

static int
datadone(void*)
{
	return ctlr.datadone;
}

static int
sdioinit(void)
{
	u32int *r;

	r = (u32int*)AddrSdio;
	WR(Softreset, Swreset);
	while(r[Softreset] &amp; Swreset)
		;
	delay(10);
	return 0;
}

static int
sdioinquiry(char *inquiry, int inqlen)
{
	return snprint(inquiry, inqlen, "SDIO Host Controller");
}

static void
sdioenable(void)
{
	u32int *r;

	r = (u32int*)AddrSdio;
	WR(Clockdiv, clkdiv(Clkfreq/Initfreq - 1));
	delay(10);
	WR(Clockctl, r[Clockctl] &amp; ~Sdclken);
	WR(Hostctl, Pushpullen|Bigendian|Cardtypemem);
	WR(Irpten, 0);
	WR(Interrupt, ~0);
	WR(ErrIntr, ~0);
	WR(Irptmask, ~0);
	WR(ErrIrptmask, ~Dtoerr);
	intrenable(Irqlo, IRQ0sdio, sdiointerrupt, &amp;ctlr, "sdio");
}

static int
awaitdone(u32int *r, int bits, int ticks)
{
	int i;
	ulong start;

	start = m-&gt;ticks;
	while(((i = r[Interrupt]) &amp; (bits|Err)) == 0)
		if(m-&gt;ticks - start &gt; ticks)
			break;
	return i;
}

static void
ckerr(u32int *r, int i, int len, char *op)
{
	int err;

	if(i &amp; Err){
		err = r[ErrIntr];
		iprint("sdioio: (%d) %s error intr %#ux err %#ux stat %#ux\n",
			len, op, i, err, r[Hoststat]);
		WR(ErrIntr, err);
		WR(Interrupt, i);
		error(Eio);
	}
}

static void
ckdmadone(u32int *r, int i, char *msg)
{
	if((i &amp; Dmadone) == 0){
		iprint("sdioio: %s intr %#ux stat %#ux\n", msg, i, r[Hoststat]);
		WR(Interrupt, i);
		error(Eio);
	}
}

static void
getresp(u32int *r, u32int *resp, int resptype)
{
	switch(resptype){
	case Resp136:
		resp[0] = r[Resp7]&lt;&lt;8  | r[Resp6]&lt;&lt;22;
		resp[1] = r[Resp6]&gt;&gt;10 | r[Resp5]&lt;&lt;6 | r[Resp4]&lt;&lt;22;
		resp[2] = r[Resp4]&gt;&gt;10 | r[Resp3]&lt;&lt;6 | r[Resp2]&lt;&lt;22;
		resp[3] = r[Resp2]&gt;&gt;10 | r[Resp1]&lt;&lt;6 | r[Resp0]&lt;&lt;22;
		break;
	case Resp48:
	case Resp48busy:
		resp[0] = r[Resp2] | r[Resp1]&lt;&lt;6 | r[Resp0]&lt;&lt;22;
		break;
	case Respnone:
		resp[0] = 0;
		break;
	}
}

static void
awaitresp48data(u32int *r, u32int cmd)
{
	int i;

	if(Polldone)
		i = awaitdone(r, Datadone, 3*HZ);
	else{
		WR(Irpten, Datadone|Err);
		tsleep(&amp;ctlr.r, datadone, 0, 3000);
		i = ctlr.datadone;
		ctlr.datadone = 0;
		WR(Irpten, 0);
	}
	if((i &amp; Datadone) == 0)
		iprint("sdioio: no Datadone after CMD%d\n", cmd);
	if(i &amp; Err)
		iprint("sdioio: CMD%d error interrupt %#ux %#ux\n",
			cmd, r[Interrupt], r[ErrIntr]);
	WR(Interrupt, i);
}

static void
finishcmd(u32int cmd, u32int arg)
{
	u32int *r;

	/*
	 * Once card is selected, use faster clock.
	 * If card bus width changes, change host bus width.
	 */
	r = (u32int*)AddrSdio;
	if(cmd == MMCSelect){
		delay(10);
		WR(Clockdiv, clkdiv(Clkfreq/SDfreq - 1));
		delay(10);
		ctlr.fastclock = 1;
	} else if(cmd == Setbuswidth)
		switch(arg){
		case 0:
			WR(Hostctl, r[Hostctl] &amp; ~Dwidth4);
			break;
		case 2:
			WR(Hostctl, r[Hostctl] | Dwidth4);
			break;
		}
}

static int
sdiocmd(u32int cmd, u32int arg, u32int *resp)
{
	int i, err;
	u32int c;
	u32int *r;

	assert(cmd &lt; nelem(cmdinfo) &amp;&amp; cmdinfo[cmd] != 0);
	i = GETTM(cmdinfo[cmd]);
	c = cmd&lt;&lt;Indexshift | GETCMD(cmdinfo[cmd]);
	if(c &amp; Isdata)
		if(i &amp; Card2host)
			i |= PIOread?  Hostpio: Hostdma;
		else
			i |= PIOwrite? Hostpio: Hostdma;
	WR(Tm, i);
	WR(ArgLSB, arg);
	WR(ArgMSB, arg&gt;&gt;16);
	WR(ErrIntr, ~0);
	WR(Cmd, c);

	r = (u32int*)AddrSdio;
	i = awaitdone(r, Cmddone, HZ);
	if((i &amp; (Cmddone|Err)) != Cmddone){
		if((err = r[ErrIntr]) != Ctoerr)
			iprint("sdio: cmd %#ux error intr %#ux %#ux stat %#ux\n",
				c, i, err, r[Hoststat]);
		WR(ErrIntr, err);
		WR(Interrupt, i);
		error(Eio);
	}
	WR(Interrupt, i &amp; ~Datadone);

	c &amp;= Respmask;
	getresp(r, resp, c);
	if(c == Resp48busy)
		awaitresp48data(r, cmd);

	finishcmd(cmd, arg);
	return 0;
}

static void
sdioiosetup(int write, void *buf, int bsize, int bcount)
{
	int len;
	uintptr pa;

	pa = PADDR(buf);
	if(write &amp;&amp; !PIOwrite){
		WR(DmaLSB, pa);
		WR(DmaMSB, pa&gt;&gt;16);
		len = bsize * bcount;
		cachedwbse(buf, len);
		l2cacheuwbse(buf, len);
	}else if(!write &amp;&amp; !PIOread){
		WR(DmaLSB, pa);
		WR(DmaMSB, pa&gt;&gt;16);
		len = bsize * bcount;
		cachedwbinvse(buf, len);
		l2cacheuwbinvse(buf, len);
	}
	WR(Blksize, bsize);
	WR(Blkcount, bcount);
}

static uchar *
getdatas(u32int *r, uchar *buf)
{
	ushort d;

	d = r[Data];
	*buf++ = d;
	*buf++ = d&gt;&gt;8;
	return buf;
}

static int
sdioread(uchar *buf, int *lenp)
{
	int i, now, len;
	u32int *r;

	r = (u32int*)AddrSdio;
	i = 0;
	len = *lenp;
	while(len &gt; 0){
		if(Pollread){
			now = m-&gt;ticks;
			i = awaitdone(r, Read8wready|Readrdy, 3*HZ);
			if(m-&gt;ticks - now &gt; 3*HZ){
				print("sdioio: (%d) no Readrdy intr %#ux stat %#ux\n",
					len, i, r[Hoststat]);
				error(Eio);
			}
		}else{
			i = r[Interrupt];
			if((i &amp; (Read8wready|Readrdy|Err)) == 0){
				WR(Irpten, (len &gt; 8*4? Read8wready:
					Readrdy) | Err);
				tsleep(&amp;ctlr.r, datadone, 0, 3000);
				WR(Irpten, 0);
				i = ctlr.datadone;
				ctlr.datadone = 0;
				if((i &amp; (Read8wready|Readrdy|Err)) == 0){
					print("sdioio: (%d) no Readrdy intr %#ux stat %#ux\n",
						len, i, r[Hoststat]);
					error(Eio);
				}
			}
		}

		if((i &amp; Read8wready) &amp;&amp; len &gt;= 8*2*2){
			for(i = 0; i &lt; 8*2; i++)
				buf = getdatas(r, buf);
			len -= 8*2*2;
		}else if(i &amp; Readrdy){
			buf = getdatas(r, buf);
			buf = getdatas(r, buf);
			len -= 2*2;
		} else
			ckerr(r, i, len, "read");
	}
	*lenp = len;
	return i;
}

static int
sdiowrite(uchar *buf, int *lenp)
{
	int i, now, len;
	u32int *r;

	r = (u32int*)AddrSdio;
	i = 0;
	len = *lenp;
	while(len &gt; 0){
		if(Pollwrite){
			now = m-&gt;ticks;
			i = awaitdone(r, Writerdy, 8*HZ);
			if(m-&gt;ticks - now &gt; 8*HZ){
				print("sdioio: (%d) no Writerdy intr %#ux stat %#ux\n",
					len, i, r[Hoststat]);
				error(Eio);
			}
		}else{
			i = r[Interrupt];
			if((i &amp; (Writerdy|Err)) == 0){
				WR(Irpten, Writerdy | Err);
				tsleep(&amp;ctlr.r, datadone, 0, 8000);
				WR(Irpten, 0);
				i = ctlr.datadone;
				ctlr.datadone = 0;
				if((i &amp; (Writerdy|Err)) == 0){
					print("sdioio: (%d) no Writerdy intr %#ux stat %#ux\n",
						len, i, r[Hoststat]);
					error(Eio);
				}
			}
		}
		if(i &amp; Writerdy){
			r[Data] = buf[0] | buf[1]&lt;&lt;8;
			r[Data] = buf[2] | buf[3]&lt;&lt;8;
			buf += 4;
			len -= 4;
		} else
			ckerr(r, i, len, "write");
	}
	*lenp = len;
	return i;
}

static void
sdioio(int write, uchar *buf, int len)
{
	int i;
	u32int *r;

	assert((len &amp; 3) == 0);
	r = (u32int*)AddrSdio;
	if(write &amp;&amp; PIOwrite)
		i = sdiowrite(buf, &amp;len);
	else if(!write &amp;&amp; PIOread)
		i = sdioread(buf, &amp;len);
	else{
		WR(Irpten, Dmadone|Err);
		tsleep(&amp;ctlr.r, datadone, 0, 3000);
		WR(Irpten, 0);
		i = ctlr.datadone;
		ctlr.datadone = 0;
		ckerr(r, i, len, "dma");
		ckdmadone(r, i, "no dma done");
		WR(Interrupt, Dmadone);
	}

	if(Polldone)
		i = awaitdone(r, Datadone, 3*HZ);
	else if((i &amp; Datadone) == 0){
		WR(Irpten, Datadone|Err);
		tsleep(&amp;ctlr.r, datadone, 0, 3000);
		i = ctlr.datadone;
		ctlr.datadone = 0;
		WR(Irpten, 0);
	}
	ckerr(r, i, len, "IO");
	ckdmadone(r, i, "IO timeout");
	if(i)
		WR(Interrupt, i);
}

static void
sdiointerrupt(Ureg*, void*)
{
	u32int *r;

	r = (u32int*)AddrSdio;
	ctlr.datadone = r[Interrupt];
	WR(Irpten, 0);
	wakeup(&amp;ctlr.r);
}

SDio sdio = {
	"sdio",
	sdioinit,
	sdioenable,
	sdioinquiry,
	sdiocmd,
	sdioiosetup,
	sdioio,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

