<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/mtx/devrtc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/mtx/devrtc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *	M48T59/559 Timekeeper
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"io.h"

enum{
	STB0 = 0x74,
	STB1 = 0x75,
	Data = 0x77,

	NVOFF=	0,
	NVLEN=	0x1ff0,		/* length in bytes of NV RAM */

	/*
	 *  register offsets into time of day clock
	 */
	NVflags=		0x1ff0,
	NVwatchdog=	0x1ff7,
	NVctl=		0x1ff8,
	NVsec,
	NVmin,
	NVhour,	
	NVday,		/* (1 = Sun) */
	NVmday,		/* (1-31) */
	NVmon,		/* (1-12) */
	NVyear,		/* (0-99) */

	/* NVctl */
	RTwrite = (1&lt;&lt;7),
	RTread = (1&lt;&lt;6),
	RTsign = (1&lt;&lt;5),
	RTcal = 0x1f,

	/* NVwatchdog */
	WDsteer = (1&lt;&lt;7),		/* 0 -&gt; intr, 1 -&gt; reset */
	WDmult = (1&lt;&lt;2),		/* 5 bits of multiplier */
	WDres0 = (0&lt;&lt;0),		/* 1/16 sec resolution */
	WDres1 = (1&lt;&lt;0),		/* 1/4 sec resolution */
	WDres2 = (2&lt;&lt;0),		/* 1 sec resolution */
	WDres3 = (3&lt;&lt;0),		/* 4 sec resolution */

	Qdir = 0,
	Qrtc,
	Qnvram,
};

/*
 *  broken down time
 */
typedef struct
{
	int	sec;
	int	min;
	int	hour;
	int	mday;
	int	mon;
	int	year;
} Rtc;

QLock	rtclock;		/* mutex on nvram operations */

static Dirtab rtcdir[]={
	".",		{Qdir, 0, QTDIR},	0,	DMDIR|0555,
	"rtc",		{Qrtc, 0},	0,	0644,
	"nvram",	{Qnvram, 0},	0,	0600,
};

static ulong	rtc2sec(Rtc*);
static void	sec2rtc(ulong, Rtc*);
static void	setrtc(Rtc*);
static void	nvcksum(void);
static void	nvput(int, uchar);
static uchar	nvget(int);

static Chan*
rtcattach(char *spec)
{
	return devattach('r', spec);
}

static Walkqid*
rtcwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, rtcdir, nelem(rtcdir), devgen);
}

static int	 
rtcstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, rtcdir, nelem(rtcdir), devgen);
}

static Chan*
rtcopen(Chan *c, int omode)
{
	omode = openmode(omode);
	switch((ulong)c-&gt;qid.path){
	case Qrtc:
		if(strcmp(up-&gt;user, eve)!=0 &amp;&amp; omode!=OREAD)
			error(Eperm);
		break;
	case Qnvram:
		if(strcmp(up-&gt;user, eve)!=0 || !cpuserver)
			error(Eperm);
	}
	return devopen(c, omode, rtcdir, nelem(rtcdir), devgen);
}

static void	 
rtcclose(Chan*)
{
}

static long	 
rtcread(Chan *c, void *buf, long n, vlong off)
{
	char *p;
	ulong t;
	int i;
	ulong offset = off;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, buf, n, rtcdir, nelem(rtcdir), devgen);

	switch((ulong)c-&gt;qid.path){
	case Qrtc:
		qlock(&amp;rtclock);
		t = rtctime();
		qunlock(&amp;rtclock);
		n = readnum(offset, buf, n, t, 12);
		return n;
	case Qnvram:
		offset += NVOFF;
		if(offset &gt; NVLEN)
			return 0;
		if(n &gt; NVLEN - offset)
			n = NVLEN - offset;
		p = buf;
		qlock(&amp;rtclock);
		for(i = 0; i &lt; n; i++)
			p[i] = nvget(i+offset);
		qunlock(&amp;rtclock);
		return n;
	}
	error(Egreg);
	return -1;		/* never reached */
}

static long	 
rtcwrite(Chan *c, void *buf, long n, vlong off)
{
	Rtc rtc;
	ulong secs;
	char *cp, *ep;
	int i;
	ulong offset = off;

	switch((ulong)c-&gt;qid.path){
	case Qrtc:
		if(offset!=0)
			error(Ebadarg);
		/*
		 *  read the time
		 */
		cp = ep = buf;
		ep += n;
		while(cp &lt; ep){
			if(*cp&gt;='0' &amp;&amp; *cp&lt;='9')
				break;
			cp++;
		}
		secs = strtoul(cp, 0, 0);
		/*
		 *  convert to bcd
		 */
		sec2rtc(secs, &amp;rtc);
		/*
		 * write it
		 */
		qlock(&amp;rtclock);
		setrtc(&amp;rtc);
		qunlock(&amp;rtclock);
		return n;
	case Qnvram:
		offset += NVOFF;
		if(offset &gt; NVLEN)
			return 0;
		if(n &gt; NVLEN - offset)
			n = NVLEN - offset;
		qlock(&amp;rtclock);
		for(i = 0; i &lt; n; i++)
			nvput(i+offset, ((uchar*)buf)[i]);
		nvcksum();
		qunlock(&amp;rtclock);
		return n;
	}
	error(Egreg);
	return -1;		/* never reached */
}

long
rtcbwrite(Chan *c, Block *bp, ulong offset)
{
	return devbwrite(c, bp, offset);
}

Dev rtcdevtab = {
	'r',
	"rtc",

	devreset,
	devinit,
	devshutdown,
	rtcattach,
	rtcwalk,
	rtcstat,
	rtcopen,
	devcreate,
	rtcclose,
	rtcread,
	devbread,
	rtcwrite,
	devbwrite,
	devremove,
	devwstat,
};

static void
nvput(int offset, uchar val)
{
	outb(STB0, offset);
	outb(STB1, offset&gt;&gt;8);
	outb(Data, val);
}

static uchar
nvget(int offset)
{
	outb(STB0, offset);
	outb(STB1, offset&gt;&gt;8);
	return inb(Data);
}

static void
nvcksum(void)
{
}

void
watchreset(void)
{
	splhi();
	nvput(NVwatchdog, WDsteer|(1*WDmult)|WDres0);
	for(;;);
}

static int
getbcd(int bcd)
{
	return (bcd&amp;0x0f) + 10 * (bcd&gt;&gt;4);
}

static int
putbcd(int val)
{
	return (val % 10) | (((val/10) % 10) &lt;&lt; 4);
}

long	 
rtctime(void)
{
	int ctl;
	Rtc rtc;

	/*
	 *  convert from BCD
	 */
	ctl = nvget(NVctl);
	ctl &amp;= RTsign|RTcal;
	nvput(NVctl, ctl|RTread);

	rtc.sec = getbcd(nvget(NVsec) &amp; 0x7f);
	rtc.min = getbcd(nvget(NVmin));
	rtc.hour = getbcd(nvget(NVhour));
	rtc.mday = getbcd(nvget(NVmday));
	rtc.mon = getbcd(nvget(NVmon));
	rtc.year = getbcd(nvget(NVyear));
	if(rtc.year &lt; 70)
		rtc.year += 2000;
	else
		rtc.year += 1900;

	nvput(NVctl, ctl);

	return rtc2sec(&amp;rtc);
}

static void
setrtc(Rtc *rtc)
{
	int ctl;

	ctl = nvget(NVctl);
	ctl &amp;= RTsign|RTcal;
	nvput(NVctl, ctl|RTwrite);

	nvput(NVsec, putbcd(rtc-&gt;sec));
	nvput(NVmin, putbcd(rtc-&gt;min));
	nvput(NVhour, putbcd(rtc-&gt;hour));
	nvput(NVmday, putbcd(rtc-&gt;mday));
	nvput(NVmon, putbcd(rtc-&gt;mon));
	nvput(NVyear, putbcd(rtc-&gt;year % 100));

	nvput(NVctl, ctl);
}

#define SEC2MIN 60L
#define SEC2HOUR (60L*SEC2MIN)
#define SEC2DAY (24L*SEC2HOUR)

/*
 *  days per month plus days/year
 */
static	int	dmsize[] =
{
	365, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};
static	int	ldmsize[] =
{
	366, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};

/*
 *  return the days/month for the given year
 */
static int *
yrsize(int y)
{

	if((y%4) == 0 &amp;&amp; ((y%100) != 0 || (y%400) == 0))
		return ldmsize;
	else
		return dmsize;
}

/*
 *  compute seconds since Jan 1 1970
 */
static ulong
rtc2sec(Rtc *rtc)
{
	ulong secs;
	int i;
	int *d2m;

	secs = 0;

	/*
	 *  seconds per year
	 */
	for(i = 1970; i &lt; rtc-&gt;year; i++){
		d2m = yrsize(i);
		secs += d2m[0] * SEC2DAY;
	}

	/*
	 *  seconds per month
	 */
	d2m = yrsize(rtc-&gt;year);
	for(i = 1; i &lt; rtc-&gt;mon; i++)
		secs += d2m[i] * SEC2DAY;

	secs += (rtc-&gt;mday-1) * SEC2DAY;
	secs += rtc-&gt;hour * SEC2HOUR;
	secs += rtc-&gt;min * SEC2MIN;
	secs += rtc-&gt;sec;

	return secs;
}

/*
 *  compute rtc from seconds since Jan 1 1970
 */
static void
sec2rtc(ulong secs, Rtc *rtc)
{
	int d;
	long hms, day;
	int *d2m;

	/*
	 * break initial number into days
	 */
	hms = secs % SEC2DAY;
	day = secs / SEC2DAY;
	if(hms &lt; 0) {
		hms += SEC2DAY;
		day -= 1;
	}

	/*
	 * generate hours:minutes:seconds
	 */
	rtc-&gt;sec = hms % 60;
	d = hms / 60;
	rtc-&gt;min = d % 60;
	d /= 60;
	rtc-&gt;hour = d;

	/*
	 * year number
	 */
	if(day &gt;= 0)
		for(d = 1970; day &gt;= *yrsize(d); d++)
			day -= *yrsize(d);
	else
		for (d = 1970; day &lt; 0; d--)
			day += *yrsize(d-1);
	rtc-&gt;year = d;

	/*
	 * generate month
	 */
	d2m = yrsize(rtc-&gt;year);
	for(d = 1; day &gt;= d2m[d]; d++)
		day -= d2m[d];
	rtc-&gt;mday = day + 1;
	rtc-&gt;mon = d;

	return;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

