<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/devdss.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/devdss.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * omap35 display subsystem (dss) device interface to screen.c.
 * implements #v/vgactl
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"
// #include "gamma.h"

enum {
	Qdir,
	Qdss,
};

extern OScreen oscreen;
extern Settings settings[];
extern Omap3fb *framebuf;

static QLock dsslck;
static Dirtab dsstab[] = {
	".",		{Qdir, 0, QTDIR},	0,	0555|DMDIR,
	"vgactl",	{Qdss, 0},		0,	0666,
};

static Chan*
screenattach(char *spec)
{
	return devattach('v', spec);
}

static Walkqid*
screenwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, dsstab, nelem(dsstab), devgen);
}

static int
screenstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, dsstab, nelem(dsstab), devgen);
}

static Chan*
screenopen(Chan *c, int omode)
{
	if ((ulong)c-&gt;qid.path == Qdss) {
		qlock(&amp;dsslck);
		oscreen.open = 1;
		c-&gt;mode = openmode(omode);
		c-&gt;flag |= COPEN;
		c-&gt;offset = 0;
	}
	return c;
}

static void
screenclose(Chan *c)
{
	if ((c-&gt;qid.type &amp; QTDIR) == 0 &amp;&amp; c-&gt;flag &amp; COPEN)
		if (c-&gt;qid.path == Qdss) {
			oscreen.open = 0;
			qunlock(&amp;dsslck);
		}
}

static ulong
getchans(char *p)
{
	if (strncmp("x24" , p, 3) == 0)
		return RGB24;		/* can't work yet, pixels are shorts */
	else if (strncmp("x16", p, 3) == 0)
		return RGB16;
	else
		return RGB16;
}

static long
settingswrite(OScreen *scr, char *p)
{
	if (strncmp("800x600", p, 7) == 0) {
		p += 7;
		scr-&gt;settings = &amp;settings[Res800x600];
	} else if (strncmp("1024x768", p, 8) == 0) {
		p += 8;
		scr-&gt;settings = &amp;settings[Res1024x768];
	} else if (strncmp("1280x1024", p, 9) == 0) {
		p += 9;
		scr-&gt;settings = &amp;settings[Res1280x1024];
	} else
		return -1;
	scr-&gt;settings-&gt;chan = getchans(p);
	return 1;
}

static long
screenread(Chan *c, void *a, long n, vlong off)
{
	int len, depth;
	char *p;
	Settings *set;

	switch ((ulong)c-&gt;qid.path) {
	case Qdir:
		return devdirread(c, a, n, dsstab, nelem(dsstab), devgen);
	case Qdss:
		set = oscreen.settings;
		p = malloc(READSTR);
		if(waserror()){
			free(p);
			nexterror();
		}
		if (set-&gt;chan == RGB16)
			depth = 16;
		else if (set-&gt;chan == RGB24)
			depth = 24;
		else
			depth = 0;
		len = snprint(p, READSTR, "size %dx%dx%d @ %d Hz\n"
			"addr %#p size %ud\n", set-&gt;wid, set-&gt;ht, depth,
			set-&gt;freq, framebuf, sizeof *framebuf);
		USED(len);
		n = readstr(off, a, n, p);
		poperror();
		free(p);
		return n;
	default:
		error(Egreg);
	}
	return 0;
}

static long
screenwrite(Chan *c, void *a, long n, vlong off)
{
	switch ((ulong)c-&gt;qid.path) {
	case Qdss:
		if(off)
			error(Ebadarg);
		n = settingswrite(&amp;oscreen, a);
		if (n &lt; 0)
			error(Ebadctl);
		screeninit();
		return n;
	default:
		error(Egreg);
	}
	return 0;
}

Dev dssdevtab = {
	L'v',
	"dss",

	devreset,
	devinit,
	devshutdown,		// TODO add a shutdown to stop dma to monitor
	screenattach,
	screenwalk,
	screenstat,
	screenopen,
	devcreate,
	screenclose,
	screenread,
	devbread,
	screenwrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

