<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/devusb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/devusb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB device driver framework.
 *
 * This is in charge of providing access to actual HCIs
 * and providing I/O to the various endpoints of devices.
 * A separate user program (usbd) is in charge of
 * enumerating the bus, setting up endpoints and
 * starting devices (also user programs).
 *
 * The interface provided is a violation of the standard:
 * you're welcome.
 *
 * The interface consists of a root directory with several files
 * plus a directory (epN.M) with two files per endpoint.
 * A device is represented by its first endpoint, which
 * is a control endpoint automatically allocated for each device.
 * Device control endpoints may be used to create new endpoints.
 * Devices corresponding to hubs may also allocate new devices,
 * perhaps also hubs. Initially, a hub device is allocated for
 * each controller present, to represent its root hub. Those can
 * never be removed.
 *
 * All endpoints refer to the first endpoint (epN.0) of the device,
 * which keeps per-device information, and also to the HCI used
 * to reach them. Although all endpoints cache that information.
 *
 * epN.M/data files permit I/O and are considered DMEXCL.
 * epN.M/ctl files provide status info and accept control requests.
 *
 * Endpoints may be given file names to be listed also at #u,
 * for those drivers that have nothing to do after configuring the
 * device and its endpoints.
 *
 * Drivers for different controllers are kept at usb[oue]hci.c
 * It's likely we could factor out much from controllers into
 * a generic controller driver, the problem is that details
 * regarding how to handle toggles, tokens, Tds, etc. will
 * get in the way. Thus, code is probably easier the way it is.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/usb.h"

typedef struct Hcitype Hcitype;

enum
{
	/* Qid numbers */
	Qdir = 0,		/* #u */
	Qusbdir,			/* #u/usb */
	Qctl,			/* #u/usb/ctl - control requests */

	Qep0dir,			/* #u/usb/ep0.0 - endpoint 0 dir */
	Qep0io,			/* #u/usb/ep0.0/data - endpoint 0 I/O */
	Qep0ctl,		/* #u/usb/ep0.0/ctl - endpoint 0 ctl. */
	Qep0dummy,		/* give 4 qids to each endpoint */

	Qepdir = 0,		/* (qid-qep0dir)&amp;3 is one of these */
	Qepio,			/* to identify which file for the endpoint */
	Qepctl,

	/* ... */

	/* Usb ctls. */
	CMdebug = 0,		/* debug on|off */
	CMdump,			/* dump (data structures for debug) */

	/* Ep. ctls */
	CMnew = 0,		/* new nb ctl|bulk|intr|iso r|w|rw (endpoint) */
	CMnewdev,		/* newdev full|low|high portnb (allocate new devices) */
	CMhub,			/* hub (set the device as a hub) */
	CMspeed,		/* speed full|low|high|no */
	CMmaxpkt,		/* maxpkt size */
	CMntds,			/* ntds nb (max nb. of tds per µframe) */
	CMclrhalt,		/* clrhalt (halt was cleared on endpoint) */
	CMpollival,		/* pollival interval (interrupt/iso) */
	CMhz,			/* hz n (samples/sec; iso) */
	CMsamplesz,		/* samplesz n (sample size; iso) */
	CMinfo,			/* info infostr (ke.ep info for humans) */
	CMdetach,		/* detach (abort I/O forever on this ep). */
	CMaddress,		/* address (address is assigned) */
	CMdebugep,		/* debug n (set/clear debug for this ep) */
	CMname,			/* name str (show up as #u/name as well) */
	CMtmout,		/* timeout n (activate timeouts for ep) */
	CMpreset,		/* reset the port */

	/* Hub feature selectors */
	Rportenable	= 1,
	Rportreset	= 4,

};

struct Hcitype
{
	char*	type;
	int	(*reset)(Hci*);
};

#define QID(q)	((int)(q).path)

static Cmdtab usbctls[] =
{
	{CMdebug,	"debug",	2},
	{CMdump,	"dump",		1},
};

static Cmdtab epctls[] =
{
	{CMnew,		"new",		4},
	{CMnewdev,	"newdev",	3},
	{CMhub,		"hub",		1},
	{CMspeed,	"speed",	2},
	{CMmaxpkt,	"maxpkt",	2},
	{CMntds,	"ntds",		2},
	{CMpollival,	"pollival",	2},
	{CMsamplesz,	"samplesz",	2},
	{CMhz,		"hz",		2},
	{CMinfo,	"info",		0},
	{CMdetach,	"detach",	1},
	{CMaddress,	"address",	1},
	{CMdebugep,	"debug",	2},
	{CMclrhalt,	"clrhalt",	1},
	{CMname,	"name",		2},
	{CMtmout,	"timeout",	2},
	{CMpreset,	"reset",	1},
};

static Dirtab usbdir[] =
{
	"ctl",		{Qctl},		0,	0666,
};

char *usbmodename[] =
{
	[OREAD]	"r",
	[OWRITE]	"w",
	[ORDWR]	"rw",
};

static char *ttname[] =
{
	[Tnone]	"none",
	[Tctl]	"control",
	[Tiso]	"iso",
	[Tintr]	"interrupt",
	[Tbulk]	"bulk",
};

static char *spname[] =
{
	[Fullspeed]	"full",
	[Lowspeed]	"low",
	[Highspeed]	"high",
	[Nospeed]	"no",
};

static int	debug;
static Hcitype	hcitypes[Nhcis];
static Hci*	hcis[Nhcis];
static QLock	epslck;		/* add, del, lookup endpoints */
static Ep*	eps[Neps];	/* all endpoints known */
static int	epmax;		/* 1 + last endpoint index used  */
static int	usbidgen;	/* device address generator */

/*
 * Is there something like this in a library? should it be?
 */
char*
seprintdata(char *s, char *se, uchar *d, int n)
{
	int i, l;

	s = seprint(s, se, " %#p[%d]: ", d, n);
	l = n;
	if(l &gt; 10)
		l = 10;
	for(i=0; i&lt;l; i++)
		s = seprint(s, se, " %2.2ux", d[i]);
	if(l &lt; n)
		s = seprint(s, se, "...");
	return s;
}

static int
name2speed(char *name)
{
	int i;

	for(i = 0; i &lt; nelem(spname); i++)
		if(strcmp(name, spname[i]) == 0)
			return i;
	return Nospeed;
}

static int
name2ttype(char *name)
{
	int i;

	for(i = 0; i &lt; nelem(ttname); i++)
		if(strcmp(name, ttname[i]) == 0)
			return i;
	/* may be a std. USB ep. type */
	i = strtol(name, nil, 0);
	switch(i+1){
	case Tctl:
	case Tiso:
	case Tbulk:
	case Tintr:
		return i+1;
	default:
		return Tnone;
	}
}

static int
name2mode(char *mode)
{
	int i;

	for(i = 0; i &lt; nelem(usbmodename); i++)
		if(strcmp(mode, usbmodename[i]) == 0)
			return i;
	return -1;
}

static int
qid2epidx(int q)
{
	q = (q-Qep0dir)/4;
	if(q &lt; 0 || q &gt;= epmax || eps[q] == nil)
		return -1;
	return q;
}

static int
isqtype(int q, int type)
{
	if(q &lt; Qep0dir)
		return 0;
	q -= Qep0dir;
	return (q &amp; 3) == type;
}

void
addhcitype(char* t, int (*r)(Hci*))
{
	static int ntype;

	if(ntype == Nhcis)
		panic("too many USB host interface types");
	hcitypes[ntype].type = t;
	hcitypes[ntype].reset = r;
	ntype++;
}

static char*
seprintep(char *s, char *se, Ep *ep, int all)
{
	static char* dsnames[] = { "config", "enabled", "detached", "reset" };
	Udev *d;
	int i;
	int di;

	d = ep-&gt;dev;

	qlock(ep);
	if(waserror()){
		qunlock(ep);
		nexterror();
	}
	di = ep-&gt;dev-&gt;nb;
	if(all)
		s = seprint(s, se, "dev %d ep %d ", di, ep-&gt;nb);
	s = seprint(s, se, "%s", dsnames[ep-&gt;dev-&gt;state]);
	s = seprint(s, se, " %s", ttname[ep-&gt;ttype]);
	assert(ep-&gt;mode == OREAD || ep-&gt;mode == OWRITE || ep-&gt;mode == ORDWR);
	s = seprint(s, se, " %s", usbmodename[ep-&gt;mode]);
	s = seprint(s, se, " speed %s", spname[d-&gt;speed]);
	s = seprint(s, se, " maxpkt %ld", ep-&gt;maxpkt);
	s = seprint(s, se, " pollival %ld", ep-&gt;pollival);
	s = seprint(s, se, " samplesz %ld", ep-&gt;samplesz);
	s = seprint(s, se, " hz %ld", ep-&gt;hz);
	s = seprint(s, se, " hub %d", ep-&gt;dev-&gt;hub);
	s = seprint(s, se, " port %d", ep-&gt;dev-&gt;port);
	if(ep-&gt;inuse)
		s = seprint(s, se, " busy");
	else
		s = seprint(s, se, " idle");
	if(all){
		s = seprint(s, se, " load %uld", ep-&gt;load);
		s = seprint(s, se, " ref %ld addr %#p", ep-&gt;ref, ep);
		s = seprint(s, se, " idx %d", ep-&gt;idx);
		if(ep-&gt;name != nil)
			s = seprint(s, se, " name '%s'", ep-&gt;name);
		if(ep-&gt;tmout != 0)
			s = seprint(s, se, " tmout");
		if(ep == ep-&gt;ep0){
			s = seprint(s, se, " ctlrno %#x", ep-&gt;hp-&gt;ctlrno);
			s = seprint(s, se, " eps:");
			for(i = 0; i &lt; nelem(d-&gt;eps); i++)
				if(d-&gt;eps[i] != nil)
					s = seprint(s, se, " ep%d.%d", di, i);
		}
	}
	if(ep-&gt;info != nil)
		s = seprint(s, se, "\n%s %s\n", ep-&gt;info, ep-&gt;hp-&gt;type);
	else
		s = seprint(s, se, "\n");
	qunlock(ep);
	poperror();
	return s;
}

static Ep*
epalloc(Hci *hp)
{
	Ep *ep;
	int i;

	ep = smalloc(sizeof(Ep));
	ep-&gt;ref = 1;
	qlock(&amp;epslck);
	for(i = 0; i &lt; Neps; i++)
		if(eps[i] == nil)
			break;
	if(i == Neps){
		qunlock(&amp;epslck);
		free(ep);
		print("usb: bug: too few endpoints.\n");
		return nil;
	}
	ep-&gt;idx = i;
	if(epmax &lt;= i)
		epmax = i+1;
	eps[i] = ep;
	ep-&gt;hp = hp;
	ep-&gt;maxpkt = 8;
	ep-&gt;ntds = 1;
	ep-&gt;samplesz = ep-&gt;pollival = ep-&gt;hz = 0; /* make them void */
	qunlock(&amp;epslck);
	return ep;
}

static Ep*
getep(int i)
{
	Ep *ep;

	if(i &lt; 0 || i &gt;= epmax || eps[i] == nil)
		return nil;
	qlock(&amp;epslck);
	ep = eps[i];
	if(ep != nil)
		incref(ep);
	qunlock(&amp;epslck);
	return ep;
}

static void
putep(Ep *ep)
{
	Udev *d;

	if(ep != nil &amp;&amp; decref(ep) == 0){
		d = ep-&gt;dev;
		deprint("usb: ep%d.%d %#p released\n", d-&gt;nb, ep-&gt;nb, ep);
		qlock(&amp;epslck);
		eps[ep-&gt;idx] = nil;
		if(ep-&gt;idx == epmax-1)
			epmax--;
		if(ep == ep-&gt;ep0 &amp;&amp; ep-&gt;dev != nil &amp;&amp; ep-&gt;dev-&gt;nb == usbidgen)
			usbidgen--;
		qunlock(&amp;epslck);
		if(d != nil){
			qlock(ep-&gt;ep0);
			d-&gt;eps[ep-&gt;nb] = nil;
			qunlock(ep-&gt;ep0);
		}
		if(ep-&gt;ep0 != ep){
			putep(ep-&gt;ep0);
			ep-&gt;ep0 = nil;
		}
		free(ep-&gt;info);
		free(ep-&gt;name);
		free(ep);
	}
}

static void
dumpeps(void)
{
	int i;
	static char buf[512];
	char *s;
	char *e;
	Ep *ep;

	print("usb dump eps: epmax %d Neps %d (ref=1+ for dump):\n", epmax, Neps);
	for(i = 0; i &lt; epmax; i++){
		s = buf;
		e = buf+sizeof(buf);
		ep = getep(i);
		if(ep != nil){
			if(waserror()){
				putep(ep);
				nexterror();
			}
			s = seprint(s, e, "ep%d.%d ", ep-&gt;dev-&gt;nb, ep-&gt;nb);
			seprintep(s, e, ep, 1);
			print("%s", buf);
			ep-&gt;hp-&gt;seprintep(buf, e, ep);
			print("%s", buf);
			poperror();
			putep(ep);
		}
	}
	print("usb dump hcis:\n");
	for(i = 0; i &lt; Nhcis; i++)
		if(hcis[i] != nil)
			hcis[i]-&gt;dump(hcis[i]);
}

static int
newusbid(Hci *)
{
	int id;

	qlock(&amp;epslck);
	id = ++usbidgen;
	if(id &gt;= 0x7F)
		print("#u: too many device addresses; reuse them more\n");
	qunlock(&amp;epslck);
	return id;
}

/*
 * Create endpoint 0 for a new device
 */
static Ep*
newdev(Hci *hp, int ishub, int isroot)
{
	Ep *ep;
	Udev *d;

	ep = epalloc(hp);
	d = ep-&gt;dev = smalloc(sizeof(Udev));
	d-&gt;nb = newusbid(hp);
	d-&gt;eps[0] = ep;
	ep-&gt;nb = 0;
	ep-&gt;toggle[0] = ep-&gt;toggle[1] = 0;
	d-&gt;ishub = ishub;
	d-&gt;isroot = isroot;
	if(hp-&gt;highspeed != 0)
		d-&gt;speed = Highspeed;
	else
		d-&gt;speed = Fullspeed;
	d-&gt;state = Dconfig;		/* address not yet set */
	ep-&gt;dev = d;
	ep-&gt;ep0 = ep;			/* no ref counted here */
	ep-&gt;ttype = Tctl;
	ep-&gt;tmout = Xfertmout;
	ep-&gt;mode = ORDWR;
	dprint("newdev %#p ep%d.%d %#p\n", d, d-&gt;nb, ep-&gt;nb, ep);
	return ep;
}

/*
 * Create a new endpoint for the device
 * accessed via the given endpoint 0.
 */
static Ep*
newdevep(Ep *ep, int i, int tt, int mode)
{
	Ep *nep;
	Udev *d;

	d = ep-&gt;dev;
	if(d-&gt;eps[i] != nil)
		error("endpoint already in use");
	nep = epalloc(ep-&gt;hp);
	incref(ep);
	d-&gt;eps[i] = nep;
	nep-&gt;nb = i;
	nep-&gt;toggle[0] = nep-&gt;toggle[1] = 0;
	nep-&gt;ep0 = ep;
	nep-&gt;dev = ep-&gt;dev;
	nep-&gt;mode = mode;
	nep-&gt;ttype = tt;
	nep-&gt;debug = ep-&gt;debug;
	/* set defaults */
	switch(tt){
	case Tctl:
		nep-&gt;tmout = Xfertmout;
		break;
	case Tintr:
		nep-&gt;pollival = 10;
		break;
	case Tiso:
		nep-&gt;tmout = Xfertmout;
		nep-&gt;pollival = 10;
		nep-&gt;samplesz = 4;
		nep-&gt;hz = 44100;
		break;
	}
	deprint("newdevep ep%d.%d %#p\n", d-&gt;nb, nep-&gt;nb, nep);
	return ep;
}

static int
epdataperm(int mode)
{

	switch(mode){
	case OREAD:
		return 0440|DMEXCL;
		break;
	case OWRITE:
		return 0220|DMEXCL;
		break;
	default:
		return 0660|DMEXCL;
	}
}

static int
usbgen(Chan *c, char *, Dirtab*, int, int s, Dir *dp)
{
	Qid q;
	Dirtab *dir;
	int perm;
	char *se;
	Ep *ep;
	int nb;
	int mode;

	if(0)ddprint("usbgen q %#x s %d...", QID(c-&gt;qid), s);
	if(s == DEVDOTDOT){
		if(QID(c-&gt;qid) &lt;= Qusbdir){
			mkqid(&amp;q, Qdir, 0, QTDIR);
			devdir(c, q, "#u", 0, eve, 0555, dp);
		}else{
			mkqid(&amp;q, Qusbdir, 0, QTDIR);
			devdir(c, q, "usb", 0, eve, 0555, dp);
		}
		if(0)ddprint("ok\n");
		return 1;
	}

	switch(QID(c-&gt;qid)){
	case Qdir:				/* list #u */
		if(s == 0){
			mkqid(&amp;q, Qusbdir, 0, QTDIR);
			devdir(c, q, "usb", 0, eve, 0555, dp);
			if(0)ddprint("ok\n");
			return 1;
		}
		s--;
		if(s &lt; 0 || s &gt;= epmax)
			goto Fail;
		ep = getep(s);
		if(ep == nil || ep-&gt;name == nil){
			if(ep != nil)
				putep(ep);
			if(0)ddprint("skip\n");
			return 0;
		}
		if(waserror()){
			putep(ep);
			nexterror();
		}
		mkqid(&amp;q, Qep0io+s*4, 0, QTFILE);
		devdir(c, q, ep-&gt;name, 0, eve, epdataperm(ep-&gt;mode), dp);
		putep(ep);
		poperror();
		if(0)ddprint("ok\n");
		return 1;

	case Qusbdir:				/* list #u/usb */
	Usbdir:
		if(s &lt; nelem(usbdir)){
			dir = &amp;usbdir[s];
			mkqid(&amp;q, dir-&gt;qid.path, 0, QTFILE);
			devdir(c, q, dir-&gt;name, dir-&gt;length, eve, dir-&gt;perm, dp);
			if(0)ddprint("ok\n");
			return 1;
		}
		s -= nelem(usbdir);
		if(s &lt; 0 || s &gt;= epmax)
			goto Fail;
		ep = getep(s);
		if(ep == nil){
			if(0)ddprint("skip\n");
			return 0;
		}
		if(waserror()){
			putep(ep);
			nexterror();
		}
		se = up-&gt;genbuf+sizeof(up-&gt;genbuf);
		seprint(up-&gt;genbuf, se, "ep%d.%d", ep-&gt;dev-&gt;nb, ep-&gt;nb);
		mkqid(&amp;q, Qep0dir+4*s, 0, QTDIR);
		putep(ep);
		poperror();
		devdir(c, q, up-&gt;genbuf, 0, eve, 0755, dp);
		if(0)ddprint("ok\n");
		return 1;

	case Qctl:
		s = 0;
		goto Usbdir;

	default:				/* list #u/usb/epN.M */
		nb = qid2epidx(QID(c-&gt;qid));
		ep = getep(nb);
		if(ep == nil)
			goto Fail;
		mode = ep-&gt;mode;
		putep(ep);
		if(isqtype(QID(c-&gt;qid), Qepdir)){
		Epdir:
			switch(s){
			case 0:
				mkqid(&amp;q, Qep0io+nb*4, 0, QTFILE);
				perm = epdataperm(mode);
				devdir(c, q, "data", 0, eve, perm, dp);
				break;
			case 1:
				mkqid(&amp;q, Qep0ctl+nb*4, 0, QTFILE);
				devdir(c, q, "ctl", 0, eve, 0664, dp);
				break;
			default:
				goto Fail;
			}
		}else if(isqtype(QID(c-&gt;qid), Qepctl)){
			s = 1;
			goto Epdir;
		}else{
			s = 0;
			goto Epdir;
		}
		if(0)ddprint("ok\n");
		return 1;
	}
Fail:
	if(0)ddprint("fail\n");
	return -1;
}

static Hci*
hciprobe(int cardno, int ctlrno)
{
	Hci *hp;
	char *type;
	char name[64];
	static int epnb = 1;	/* guess the endpoint nb. for the controller */

	ddprint("hciprobe %d %d\n", cardno, ctlrno);
	hp = smalloc(sizeof(Hci));
	hp-&gt;ctlrno = ctlrno;

	if(cardno &lt; 0)
		for(cardno = 0; cardno &lt; Nhcis; cardno++){
			if(hcitypes[cardno].type == nil)
				break;
			type = hp-&gt;type;
			if(type==nil || *type==0)
				type = "uhci";
			if(cistrcmp(hcitypes[cardno].type, type) == 0)
				break;
		}

	if(cardno &gt;= Nhcis || hcitypes[cardno].type == nil){
		free(hp);
		return nil;
	}
	dprint("%s...", hcitypes[cardno].type);
	if(hcitypes[cardno].reset(hp) &lt; 0){
		free(hp);
		return nil;
	}

	snprint(name, sizeof(name), "usb%s", hcitypes[cardno].type);
	intrenable(hp-&gt;irq, hp-&gt;interrupt, hp, UNKNOWN, name);

	print("#u/usb/ep%d.0: %s: port %#luX irq %d\n",
		epnb, hcitypes[cardno].type, hp-&gt;port, hp-&gt;irq);
	epnb++;

	return hp;
}

static void
usbreset(void)
{
	int cardno, ctlrno;
	Hci *hp;

	dprint("usbreset\n");

	for(ctlrno = 0; ctlrno &lt; Nhcis; ctlrno++)
		if((hp = hciprobe(-1, ctlrno)) != nil)
			hcis[ctlrno] = hp;
	cardno = ctlrno = 0;
	while(cardno &lt; Nhcis &amp;&amp; ctlrno &lt; Nhcis &amp;&amp; hcitypes[cardno].type != nil)
		if(hcis[ctlrno] != nil)
			ctlrno++;
		else{
			hp = hciprobe(cardno, ctlrno);
			if(hp == nil)
				cardno++;
			hcis[ctlrno++] = hp;
		}
	if(hcis[Nhcis-1] != nil)
		print("usbreset: bug: Nhcis too small\n");
}

static void
usbinit(void)
{
	Hci *hp;
	int ctlrno;
	Ep *d;
	char info[40];

	dprint("usbinit\n");
	for(ctlrno = 0; ctlrno &lt; Nhcis; ctlrno++){
		hp = hcis[ctlrno];
		if(hp != nil){
			if(hp-&gt;init != nil)
				hp-&gt;init(hp);
			d = newdev(hp, 1, 1);		/* new root hub */
			d-&gt;dev-&gt;state = Denabled;	/* although addr == 0 */
			d-&gt;maxpkt = 64;
			snprint(info, sizeof(info), "ports %d", hp-&gt;nports);
			kstrdup(&amp;d-&gt;info, info);
		}
	}
}

static Chan*
usbattach(char *spec)
{
	return devattach(L'u', spec);
}

static Walkqid*
usbwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, nil, 0, usbgen);
}

static int
usbstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, nil, 0, usbgen);
}

/*
 * µs for the given transfer, for bandwidth allocation.
 * This is a very rough worst case for what 5.11.3
 * of the usb 2.0 spec says.
 * Also, we are using maxpkt and not actual transfer sizes.
 * Only when we are sure we
 * are not exceeding b/w might we consider adjusting it.
 */
static ulong
usbload(int speed, int maxpkt)
{
	enum{ Hostns = 1000, Hubns = 333 };
	ulong l;
	ulong bs;

	l = 0;
	bs = 10UL * maxpkt;
	switch(speed){
	case Highspeed:
		l = 55*8*2 + 2 * (3 + bs) + Hostns;
		break;
	case Fullspeed:
		l = 9107 + 84 * (4 + bs) + Hostns;
		break;
	case Lowspeed:
		l = 64107 + 2 * Hubns + 667 * (3 + bs) + Hostns;
		break;
	default:
		print("usbload: bad speed %d\n", speed);
		/* let it run */
	}
	return l / 1000UL;	/* in µs */
}

static Chan*
usbopen(Chan *c, int omode)
{
	int q;
	Ep *ep;
	int mode;

	mode = openmode(omode);
	q = QID(c-&gt;qid);

	if(q &gt;= Qep0dir &amp;&amp; qid2epidx(q) &lt; 0)
		error(Eio);
	if(q &lt; Qep0dir || isqtype(q, Qepctl) || isqtype(q, Qepdir))
		return devopen(c, omode, nil, 0, usbgen);

	ep = getep(qid2epidx(q));
	if(ep == nil)
		error(Eio);
	deprint("usbopen q %#x fid %d omode %d\n", q, c-&gt;fid, mode);
	if(waserror()){
		putep(ep);
		nexterror();
	}
	qlock(ep);
	if(ep-&gt;inuse){
		qunlock(ep);
		error(Einuse);
	}
	ep-&gt;inuse = 1;
	qunlock(ep);
	if(waserror()){
		ep-&gt;inuse = 0;
		nexterror();
	}
	if(mode != OREAD &amp;&amp; ep-&gt;mode == OREAD)
		error(Eperm);
	if(mode != OWRITE &amp;&amp; ep-&gt;mode == OWRITE)
		error(Eperm);
	if(ep-&gt;ttype == Tnone)
		error(Enotconf);
	ep-&gt;clrhalt = 0;
	ep-&gt;rhrepl = -1;
	if(ep-&gt;load == 0)
		ep-&gt;load = usbload(ep-&gt;dev-&gt;speed, ep-&gt;maxpkt);
	ep-&gt;hp-&gt;epopen(ep);

	poperror();	/* ep-&gt;inuse */
	poperror();	/* don't putep(): ref kept for fid using the ep. */

	c-&gt;mode = mode;
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	c-&gt;aux = nil;	/* paranoia */
	return c;
}

static void
epclose(Ep *ep)
{
	qlock(ep);
	if(waserror()){
		qunlock(ep);
		nexterror();
	}
	if(ep-&gt;inuse){
		ep-&gt;hp-&gt;epclose(ep);
		ep-&gt;inuse = 0;
	}
	qunlock(ep);
	poperror();
}

static void
usbclose(Chan *c)
{
	int q;
	Ep *ep;

	q = QID(c-&gt;qid);
	if(q &lt; Qep0dir || isqtype(q, Qepctl) || isqtype(q, Qepdir))
		return;

	ep = getep(qid2epidx(q));
	if(ep == nil)
		return;
	deprint("usbclose q %#x fid %d ref %ld\n", q, c-&gt;fid, ep-&gt;ref);
	if(waserror()){
		putep(ep);
		nexterror();
	}
	if(c-&gt;flag &amp; COPEN){
		free(c-&gt;aux);
		c-&gt;aux = nil;
		epclose(ep);
		putep(ep);	/* release ref kept since usbopen */
		c-&gt;flag &amp;= ~COPEN;
	}
	poperror();
	putep(ep);
}

static long
ctlread(Chan *c, void *a, long n, vlong offset)
{
	int q;
	char *s;
	char *us;
	char *se;
	Ep *ep;
	int i;

	q = QID(c-&gt;qid);
	us = s = smalloc(READSTR);
	se = s + READSTR;
	if(waserror()){
		free(us);
		nexterror();
	}
	if(q == Qctl)
		for(i = 0; i &lt; epmax; i++){
			ep = getep(i);
			if(ep != nil){
				if(waserror()){
					putep(ep);
					nexterror();
				}
				s = seprint(s, se, "ep%d.%d ", ep-&gt;dev-&gt;nb, ep-&gt;nb);
				s = seprintep(s, se, ep, 0);
				poperror();
			}
			putep(ep);
		}
	else{
		ep = getep(qid2epidx(q));
		if(ep == nil)
			error(Eio);
		if(waserror()){
			putep(ep);
			nexterror();
		}
		if(c-&gt;aux != nil){
			/* After a new endpoint request we read
			 * the new endpoint name back.
			 */
			strecpy(s, se, c-&gt;aux);
			free(c-&gt;aux);
			c-&gt;aux = nil;
		}else
			seprintep(s, se, ep, 0);
		poperror();
		putep(ep);
	}
	n = readstr(offset, a, n, us);
	poperror();
	free(us);
	return n;
}

/*
 * Fake root hub emulation.
 */
static long
rhubread(Ep *ep, void *a, long n)
{
	char *b;

	if(ep-&gt;dev-&gt;isroot == 0 || ep-&gt;nb != 0 || n &lt; 2)
		return -1;
	if(ep-&gt;rhrepl &lt; 0)
		return -1;

	b = a;
	memset(b, 0, n);
	PUT2(b, ep-&gt;rhrepl);
	ep-&gt;rhrepl = -1;
	return n;
}

static long
rhubwrite(Ep *ep, void *a, long n)
{
	uchar *s;
	int cmd;
	int feature;
	int port;
	Hci *hp;

	if(ep-&gt;dev == nil || ep-&gt;dev-&gt;isroot == 0 || ep-&gt;nb != 0)
		return -1;
	if(n != Rsetuplen)
		error("root hub is a toy hub");
	ep-&gt;rhrepl = -1;
	s = a;
	if(s[Rtype] != (Rh2d|Rclass|Rother) &amp;&amp; s[Rtype] != (Rd2h|Rclass|Rother))
		error("root hub is a toy hub");
	hp = ep-&gt;hp;
	cmd = s[Rreq];
	feature = GET2(s+Rvalue);
	port = GET2(s+Rindex);
	if(port &lt; 1 || port &gt; hp-&gt;nports)
		error("bad hub port number");
	switch(feature){
	case Rportenable:
		ep-&gt;rhrepl = hp-&gt;portenable(hp, port, cmd == Rsetfeature);
		break;
	case Rportreset:
		ep-&gt;rhrepl = hp-&gt;portreset(hp, port, cmd == Rsetfeature);
		break;
	case Rgetstatus:
		ep-&gt;rhrepl = hp-&gt;portstatus(hp, port);
		break;
	default:
		ep-&gt;rhrepl = 0;
	}
	return n;
}

static long
usbread(Chan *c, void *a, long n, vlong offset)
{
	int q;
	Ep *ep;
	int nr;

	q = QID(c-&gt;qid);

	if(c-&gt;qid.type == QTDIR)
		return devdirread(c, a, n, nil, 0, usbgen);

	if(q == Qctl || isqtype(q, Qepctl))
		return ctlread(c, a, n, offset);

	ep = getep(qid2epidx(q));
	if(ep == nil)
		error(Eio);
	if(waserror()){
		putep(ep);
		nexterror();
	}
	if(ep-&gt;dev-&gt;state == Ddetach)
		error(Edetach);
	if(ep-&gt;mode == OWRITE || ep-&gt;inuse == 0)
		error(Ebadusefd);
	switch(ep-&gt;ttype){
	case Tnone:
		error("endpoint not configured");
	case Tctl:
		nr = rhubread(ep, a, n);
		if(nr &gt;= 0){
			n = nr;
			break;
		}
		/* else fall */
	default:
		ddeprint("\nusbread q %#x fid %d cnt %ld off %lld\n",q,c-&gt;fid,n,offset);
		n = ep-&gt;hp-&gt;epread(ep, a, n);
		break;
	}
	poperror();
	putep(ep);
	return n;
}

static long
pow2(int n)
{
	return 1 &lt;&lt; n;
}

static void
setmaxpkt(Ep *ep, char* s)
{
	long spp;	/* samples per packet */

	if(ep-&gt;dev-&gt;speed == Highspeed)
		spp = (ep-&gt;hz * ep-&gt;pollival * ep-&gt;ntds + 7999) / 8000;
	else
		spp = (ep-&gt;hz * ep-&gt;pollival + 999) / 1000;
	ep-&gt;maxpkt = spp * ep-&gt;samplesz;
	deprint("usb: %s: setmaxpkt: hz %ld poll %ld"
		" ntds %d %s speed -&gt; spp %ld maxpkt %ld\n", s,
		ep-&gt;hz, ep-&gt;pollival, ep-&gt;ntds, spname[ep-&gt;dev-&gt;speed],
		spp, ep-&gt;maxpkt);
	if(ep-&gt;maxpkt &gt; 1024){
		print("usb: %s: maxpkt %ld &gt; 1024. truncating\n", s, ep-&gt;maxpkt);
		ep-&gt;maxpkt = 1024;
	}
}

/*
 * Many endpoint ctls. simply update the portable representation
 * of the endpoint. The actual controller driver will look
 * at them to setup the endpoints as dictated.
 */
static long
epctl(Ep *ep, Chan *c, void *a, long n)
{
	int i, l, mode, nb, tt;
	char *b, *s;
	Cmdbuf *cb;
	Cmdtab *ct;
	Ep *nep;
	Udev *d;
	static char *Info = "info ";

	d = ep-&gt;dev;

	cb = parsecmd(a, n);
	if(waserror()){
		free(cb);
		nexterror();
	}
	ct = lookupcmd(cb, epctls, nelem(epctls));
	if(ct == nil)
		error(Ebadctl);
	i = ct-&gt;index;
	if(i == CMnew || i == CMspeed || i == CMhub || i == CMpreset)
		if(ep != ep-&gt;ep0)
			error("allowed only on a setup endpoint");
	if(i != CMclrhalt &amp;&amp; i != CMdetach &amp;&amp; i != CMdebugep &amp;&amp; i != CMname)
		if(ep != ep-&gt;ep0 &amp;&amp; ep-&gt;inuse != 0)
			error("must configure before using");
	switch(i){
	case CMnew:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		nb = strtol(cb-&gt;f[1], nil, 0);
		if(nb &lt; 0 || nb &gt;= Ndeveps)
			error("bad endpoint number");
		tt = name2ttype(cb-&gt;f[2]);
		if(tt == Tnone)
			error("unknown endpoint type");
		mode = name2mode(cb-&gt;f[3]);
		if(mode &lt; 0)
			error("unknown i/o mode");
		newdevep(ep, nb, tt, mode);
		break;
	case CMnewdev:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		if(ep != ep-&gt;ep0 || d-&gt;ishub == 0)
			error("not a hub setup endpoint");
		l = name2speed(cb-&gt;f[1]);
		if(l == Nospeed)
			error("speed must be full|low|high");
		nep = newdev(ep-&gt;hp, 0, 0);
		nep-&gt;dev-&gt;speed = l;
		if(nep-&gt;dev-&gt;speed  != Lowspeed)
			nep-&gt;maxpkt = 64;	/* assume full speed */
		nep-&gt;dev-&gt;hub = d-&gt;nb;
		nep-&gt;dev-&gt;port = atoi(cb-&gt;f[2]);
		/* next read request will read
		 * the name for the new endpoint
		 */
		l = sizeof(up-&gt;genbuf);
		snprint(up-&gt;genbuf, l, "ep%d.%d", nep-&gt;dev-&gt;nb, nep-&gt;nb);
		kstrdup(&amp;c-&gt;aux, up-&gt;genbuf);
		break;
	case CMhub:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		d-&gt;ishub = 1;
		break;
	case CMspeed:
		l = name2speed(cb-&gt;f[1]);
		deprint("usb epctl %s %d\n", cb-&gt;f[0], l);
		if(l == Nospeed)
			error("speed must be full|low|high");
		qlock(ep-&gt;ep0);
		d-&gt;speed = l;
		qunlock(ep-&gt;ep0);
		break;
	case CMmaxpkt:
		l = strtoul(cb-&gt;f[1], nil, 0);
		deprint("usb epctl %s %d\n", cb-&gt;f[0], l);
		if(l &lt; 1 || l &gt; 1024)
			error("maxpkt not in [1:1024]");
		qlock(ep);
		ep-&gt;maxpkt = l;
		qunlock(ep);
		break;
	case CMntds:
		l = strtoul(cb-&gt;f[1], nil, 0);
		deprint("usb epctl %s %d\n", cb-&gt;f[0], l);
		if(l &lt; 1 || l &gt; 3)
			error("ntds not in [1:3]");
		qlock(ep);
		ep-&gt;ntds = l;
		qunlock(ep);
		break;
	case CMpollival:
		if(ep-&gt;ttype != Tintr &amp;&amp; ep-&gt;ttype != Tiso)
			error("not an intr or iso endpoint");
		l = strtoul(cb-&gt;f[1], nil, 0);
		deprint("usb epctl %s %d\n", cb-&gt;f[0], l);
		if(ep-&gt;ttype == Tiso ||
		   (ep-&gt;ttype == Tintr &amp;&amp; ep-&gt;dev-&gt;speed == Highspeed)){
			if(l &lt; 1 || l &gt; 16)
				error("pollival power not in [1:16]");
			l = pow2(l-1);
		}else
			if(l &lt; 1 || l &gt; 255)
				error("pollival not in [1:255]");
		qlock(ep);
		ep-&gt;pollival = l;
		if(ep-&gt;ttype == Tiso)
			setmaxpkt(ep, "pollival");
		qunlock(ep);
		break;
	case CMsamplesz:
		if(ep-&gt;ttype != Tiso)
			error("not an iso endpoint");
		l = strtoul(cb-&gt;f[1], nil, 0);
		deprint("usb epctl %s %d\n", cb-&gt;f[0], l);
		if(l &lt;= 0 || l &gt; 8)
			error("samplesz not in [1:8]");
		qlock(ep);
		ep-&gt;samplesz = l;
		setmaxpkt(ep, "samplesz");
		qunlock(ep);
		break;
	case CMhz:
		if(ep-&gt;ttype != Tiso)
			error("not an iso endpoint");
		l = strtoul(cb-&gt;f[1], nil, 0);
		deprint("usb epctl %s %d\n", cb-&gt;f[0], l);
		if(l &lt;= 0 || l &gt; 100000)
			error("hz not in [1:100000]");
		qlock(ep);
		ep-&gt;hz = l;
		setmaxpkt(ep, "hz");
		qunlock(ep);
		break;
	case CMclrhalt:
		qlock(ep);
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		ep-&gt;clrhalt = 1;
		qunlock(ep);
		break;
	case CMinfo:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		l = strlen(Info);
		s = a;
		if(n &lt; l+2 || strncmp(Info, s, l) != 0)
			error(Ebadctl);
		if(n &gt; 1024)
			n = 1024;
		b = smalloc(n);
		memmove(b, s+l, n-l);
		b[n-l] = 0;
		if(b[n-l-1] == '\n')
			b[n-l-1] = 0;
		qlock(ep);
		free(ep-&gt;info);
		ep-&gt;info = b;
		qunlock(ep);
		break;
	case CMaddress:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		ep-&gt;dev-&gt;state = Denabled;
		break;
	case CMdetach:
		if(ep-&gt;dev-&gt;isroot != 0)
			error("can't detach a root hub");
		deprint("usb epctl %s ep%d.%d\n",
			cb-&gt;f[0], ep-&gt;dev-&gt;nb, ep-&gt;nb);
		ep-&gt;dev-&gt;state = Ddetach;
		/* Release file system ref. for its endpoints */
		for(i = 0; i &lt; nelem(ep-&gt;dev-&gt;eps); i++)
			putep(ep-&gt;dev-&gt;eps[i]);
		break;
	case CMdebugep:
		if(strcmp(cb-&gt;f[1], "on") == 0)
			ep-&gt;debug = 1;
		else if(strcmp(cb-&gt;f[1], "off") == 0)
			ep-&gt;debug = 0;
		else
			ep-&gt;debug = strtoul(cb-&gt;f[1], nil, 0);
		print("usb: ep%d.%d debug %d\n",
			ep-&gt;dev-&gt;nb, ep-&gt;nb, ep-&gt;debug);
		break;
	case CMname:
		deprint("usb epctl %s %s\n", cb-&gt;f[0], cb-&gt;f[1]);
		validname(cb-&gt;f[1], 0);
		kstrdup(&amp;ep-&gt;name, cb-&gt;f[1]);
		break;
	case CMtmout:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		if(ep-&gt;ttype == Tiso || ep-&gt;ttype == Tctl)
			error("ctl ignored for this endpoint type");
		ep-&gt;tmout = strtoul(cb-&gt;f[1], nil, 0);
		if(ep-&gt;tmout != 0 &amp;&amp; ep-&gt;tmout &lt; Xfertmout)
			ep-&gt;tmout = Xfertmout;
		break;
	case CMpreset:
		deprint("usb epctl %s\n", cb-&gt;f[0]);
		if(ep-&gt;ttype != Tctl)
			error("not a control endpoint");
		if(ep-&gt;dev-&gt;state != Denabled)
			error("forbidden on devices not enabled");
		ep-&gt;dev-&gt;state = Dreset;
		break;
	default:
		panic("usb: unknown epctl %d", ct-&gt;index);
	}
	free(cb);
	poperror();
	return n;
}

static long
usbctl(void *a, long n)
{
	Cmdtab *ct;
	Cmdbuf *cb;
	Ep *ep;
	int i;

	cb = parsecmd(a, n);
	if(waserror()){
		free(cb);
		nexterror();
	}
	ct = lookupcmd(cb, usbctls, nelem(usbctls));
	dprint("usb ctl %s\n", cb-&gt;f[0]);
	switch(ct-&gt;index){
	case CMdebug:
		if(strcmp(cb-&gt;f[1], "on") == 0)
			debug = 1;
		else if(strcmp(cb-&gt;f[1], "off") == 0)
			debug = 0;
		else
			debug = strtol(cb-&gt;f[1], nil, 0);
		print("usb: debug %d\n", debug);
		for(i = 0; i &lt; epmax; i++)
			if((ep = getep(i)) != nil){
				ep-&gt;hp-&gt;debug(ep-&gt;hp, debug);
				putep(ep);
			}
		break;
	case CMdump:
		dumpeps();
		break;
	}
	free(cb);
	poperror();
	return n;
}

static long
ctlwrite(Chan *c, void *a, long n)
{
	int q;
	Ep *ep;

	q = QID(c-&gt;qid);
	if(q == Qctl)
		return usbctl(a, n);

	ep = getep(qid2epidx(q));
	if(ep == nil)
		error(Eio);
	if(waserror()){
		putep(ep);
		nexterror();
	}
	if(ep-&gt;dev-&gt;state == Ddetach)
		error(Edetach);
	if(isqtype(q, Qepctl) &amp;&amp; c-&gt;aux != nil){
		/* Be sure we don't keep a cloned ep name */
		free(c-&gt;aux);
		c-&gt;aux = nil;
		error("read, not write, expected");
	}
	n = epctl(ep, c, a, n);
	putep(ep);
	poperror();
	return n;
}

static long
usbwrite(Chan *c, void *a, long n, vlong off)
{
	int nr, q;
	Ep *ep;

	if(c-&gt;qid.type == QTDIR)
		error(Eisdir);

	q = QID(c-&gt;qid);

	if(q == Qctl || isqtype(q, Qepctl))
		return ctlwrite(c, a, n);

	ep = getep(qid2epidx(q));
	if(ep == nil)
		error(Eio);
	if(waserror()){
		putep(ep);
		nexterror();
	}
	if(ep-&gt;dev-&gt;state == Ddetach)
		error(Edetach);
	if(ep-&gt;mode == OREAD || ep-&gt;inuse == 0)
		error(Ebadusefd);

	switch(ep-&gt;ttype){
	case Tnone:
		error("endpoint not configured");
	case Tctl:
		nr = rhubwrite(ep, a, n);
		if(nr &gt;= 0){
			n = nr;
			break;
		}
		/* else fall */
	default:
		ddeprint("\nusbwrite q %#x fid %d cnt %ld off %lld\n",q, c-&gt;fid, n, off);
		ep-&gt;hp-&gt;epwrite(ep, a, n);
	}
	putep(ep);
	poperror();
	return n;
}

void
usbshutdown(void)
{
	Hci *hp;
	int i;

	for(i = 0; i &lt; Nhcis; i++){
		hp = hcis[i];
		if(hp == nil)
			continue;
		if(hp-&gt;shutdown == nil)
			print("#u: no shutdown function for %s\n", hp-&gt;type);
		else
			hp-&gt;shutdown(hp);
	}
}

Dev usbdevtab = {
	L'u',
	"usb",

	usbreset,
	usbinit,
	usbshutdown,
	usbattach,
	usbwalk,
	usbstat,
	usbopen,
	devcreate,
	usbclose,
	usbread,
	devbread,
	usbwrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

