<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/ether9221.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/ether9221.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * SMSC 9221 Ethernet driver
 * specifically for the ISEE IGEPv2 board,
 * where it is assigned to Chip Select 5,
 * its registers are at 0x2c000000 (inherited from u-boot),
 * and irq is 34 from gpio pin 176, thus gpio module 6.
 *
 * it's slow due to the use of fifos instead of buffer rings.
 * the slow system dma just makes it worse.
 *
 * igepv2 u-boot uses pin 64 on gpio 3 as an output pin to reset the 9221.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"

/* currently using kprocs is a lot slower than not (87 s. to boot vs 60) */
#undef USE_KPROCS

enum {
	Vid9221	= 0x9221,
	Slop	= 4,			/* beyond ETHERMAXTU */
};

typedef struct Regs Regs;
struct Regs {
	/* fifo ports */
	ulong	rxdata;
	uchar	_pad0[0x20 - 4];
	ulong	txdata;
	uchar	_pad1[0x40 - 0x24];
	ulong	rxsts;
	ulong	rxstspeek;
	ulong	txsts;
	ulong	txstspeek;

	/* control &amp; status */
	ushort	rev;			/* chip revision */
	ushort	id;			/* chip id, 0x9221 */
	ulong	irqcfg;
	ulong	intsts;
	ulong	inten;
	ulong	_pad2;
	ulong	bytetest;
	ulong	fifoint;		/* fifo level interrupts */
	ulong	rxcfg;
	ulong	txcfg;
	ulong	hwcfg;
	ulong	rxdpctl;		/* rx data path control */
	ulong	rxfifoinf;
	ulong	txfifoinf;
	ulong	pmtctl;			/* power mgmt. control */
	ulong	gpiocfg;
	ulong	gptcfg;			/* timer */
	ulong	gptcnt;
	ulong	_pad3;
	ulong	wordswap;
	ulong	freerun; 		/* counters */
	ulong	rxdrop;

	/*
	 * mac registers are accessed indirectly via the mac csr registers.
	 * phy registers are doubly indirect, via the mac csr mii_acc &amp;
	 * mii_data mac csr registers.
	 */
	ulong	maccsrcmd;		/* mac csr synchronizer */
	ulong	maccsrdata;
	ulong	afccfg;			/* automatic flow control cfg. */
	ulong	eepcmd;			/* eeprom */
	ulong	eepdata;
	/* 0xb8 */
};

enum {
	Nstatistics	= 128,
};

enum {
	/* txcmda bits */
	Intcompl	= 1&lt;&lt;31,
	Bufendalign	= 3&lt;&lt;24,	/* mask */
	Datastoff	= 037&lt;&lt;16,	/* mask */
	Firstseg	= 1&lt;&lt;13,
	Lastseg		= 1&lt;&lt;12,
	Bufsize		= MASK(11),

	/* txcmdb bits */
	Pkttag		= MASK(16) &lt;&lt; 16,
	Txcksumen	= 1&lt;&lt;14,
	Addcrcdis	= 1&lt;&lt;13,
	Framepaddis	= 1&lt;&lt;12,
	Pktlen		= (1&lt;&lt;1) - 1,	/* mask */

	/* txcfg bits */
	Txsdump		= 1&lt;&lt;15,	/* flush tx status fifo */
	Txddump		= 1&lt;&lt;14,	/* flush tx data fifo */
	Txon		= 1&lt;&lt;1,
	Stoptx		= 1&lt;&lt;0,

	/* hwcfg bits */
	Mbo		= 1&lt;&lt;20,	/* must be one */
	Srstto		= 1&lt;&lt;1,		/* soft reset time-out */
	Srst		= 1&lt;&lt;0,

	/* rxcfg bits */
	Rxdmacntshift	= 16,		/* ulong count, 12 bits wide */
	Rxdmacntmask	= MASK(12) &lt;&lt; Rxdmacntshift,
	Rxdump		= 1&lt;&lt;15,	/* flush rx fifos */

	/* rxsts bits */
	Rxpktlenshift	= 16,		/* byte count */
	Rxpktlenmask	= MASK(14) &lt;&lt; Rxpktlenshift,
	Rxerr		= 1&lt;&lt;15,

	/* rxfifoinf bits */
	Rxstsusedshift	= 16,		/* ulong count */
	Rxstsusedmask	= MASK(8) &lt;&lt; Rxstsusedshift,
	Rxdatausedmask	= MASK(16),	/* byte count */

	/* txfifoinf bits */
	Txstsusedshift	= 16,		/* ulong count */
	Txstsusedmask	= MASK(8) &lt;&lt; Txstsusedshift,
	Txdatafreemask	= MASK(16),	/* byte count */

	/* pmtctl bits */
	Dready		= 1&lt;&lt;0,

	/* maccsrcmd bits */
	Csrbusy		= 1&lt;&lt;31,
	Csrread		= 1&lt;&lt;30,	/* not write */
	Csraddrshift	= 0,
	Csraddrmask	= MASK(8) - 1,

	/* mac registers' indices */
	Maccr		= 1,
	Macaddrh,
	Macaddrl,
	Machashh,
	Machashl,
	Macmiiacc,			/* for doubly-indirect phy access */
	Macmiidata,
	Macflow,
	Macvlan1,
	Macvlan2,
	Macwuff,
	Macwucsr,
	Maccoe,

	/* Maccr bits */
	Rxall		= 1&lt;&lt;31,
	Rcvown		= 1&lt;&lt;23,	/* don't receive own transmissions */
	Fdpx		= 1&lt;&lt;20,	/* full duplex */
	Mcpas		= 1&lt;&lt;19,	/* pass all multicast */
	Prms		= 1&lt;&lt;18,	/* promiscuous */
	Ho		= 1&lt;&lt;15,	/* hash-only filtering */
	Hpfilt		= 1&lt;&lt;13,	/* hash/perfect filtering */
	Padstr		= 1&lt;&lt;8,		/* strip padding &amp; fcs (crc) */
	Txen		= 1&lt;&lt;3,
	Rxen		= 1&lt;&lt;2,

	/* irqcfg bits */
	Irqdeasclr	= 1&lt;&lt;14,	/* deassertion intv'l clear */
	Irqdeassts	= 1&lt;&lt;13,	/* deassertion intv'l status */
	Irqint		= 1&lt;&lt;12,	/* intr being asserted? (ro) */
	Irqen		= 1&lt;&lt;8,
	Irqpol		= 1&lt;&lt;4,		/* irq output is active high */
	Irqpushpull	= 1&lt;&lt;0,		/* irq output is push/pull driver */

	/* intsts/inten bits */
	Swint		= 1&lt;&lt;31,	/* generate an interrupt */
	Txstop		= 1&lt;&lt;25,
	Rxstop		= 1&lt;&lt;24,
	Txioc		= 1&lt;&lt;21,
	Rxdma		= 1&lt;&lt;20,
	Gptimer		= 1&lt;&lt;19,
	Phy		= 1&lt;&lt;18,
	Rxe		= 1&lt;&lt;14,	/* errors */
	Txe		= 1&lt;&lt;13,
	Tdfo		= 1&lt;&lt;10,	/* tx data fifo overrun */
	Tdfa		= 1&lt;&lt;9,		/* tx data fifo available */
	Tsff		= 1&lt;&lt;8,		/* tx status fifo full */
	Tsfl		= 1&lt;&lt;7,		/* tx status fifo level */
	Rsff		= 1&lt;&lt;4,		/* rx status fifo full */
	Rsfl		= 1&lt;&lt;3,		/* rx status fifo level */

	/* eepcmd bits */
	Epcbusy		= 1&lt;&lt;31,
	Epccmdshift	= 28,		/* interesting one is Reload (7) */
	Epctimeout	= 1&lt;&lt;9,
	Epcmacloaded	= 1&lt;&lt;8,
	Epcaddrshift	= 0,
};

enum {
	Rxintrs		= Rsff | Rsfl | Rxe,
	Txintrs		= Tsff | Tsfl | Txe | Txioc,
};

/* wake-up frame filter */
struct Wakeup {
	ulong	bytemask[4];		/* index is filter # */
	uchar	filt0cmd;		/* filter 0 command */
	uchar	_pad0;
	uchar	filt1cmd;
	uchar	_pad1;
	uchar	filt2cmd;
	uchar	_pad2;
	uchar	filt3cmd;
	uchar	_pad3;
	uchar	offset[4];		/* index is filter # */
	ushort	crc16[4];		/* " */
};

typedef struct Ctlr Ctlr;
struct Ctlr {
	int	port;
	Ctlr*	next;
	Ether*	edev;
	Regs*	regs;
	int	active;
	int	started;
	int	inited;
	int	id;
	int	cls;
	ushort	eeprom[0x40];

	QLock	alock;			/* attach */
	int	nrb;			/* how many this Ctlr has in the pool */

	int*	nic;
	Lock	imlock;
	int	im;			/* interrupt mask */

//	Mii*	mii;
//	Rendez	lrendez;
	int	lim;

	int	link;

	QLock	slock;
	uint	statistics[Nstatistics];
	uint	lsleep;
	uint	lintr;
	uint	rsleep;
	uint	rintr;
	int	tsleep;
	uint	tintr;

	uchar	ra[Eaddrlen];		/* receive address */
	ulong	mta[128];		/* multicast table array */

	Rendez	rrendez;
	int	gotinput;
	int	rdcpydone;

	Rendez	trendez;
	int	gotoutput;
	int	wrcpydone;

	Lock	tlock;
};

#define csr32r(c, r)	(*((c)-&gt;nic+((r)/4)))
#define csr32w(c, r, v)	(*((c)-&gt;nic+((r)/4)) = (v))

static Ctlr *smcctlrhead, *smcctlrtail;

static char* statistics[Nstatistics] = { "dummy", };

static uchar mymac[] = { 0xb0, 0x0f, 0xba, 0xbe, 0x00, 0x00, };

static void etherclock(void);
static void smcreceive(Ether *edev);
static void smcinterrupt(Ureg*, void* arg);

static Ether *thisether;
static int attached;

static void
smconce(Ether *edev)
{
	static int beenhere;
	static Lock l;

	ilock(&amp;l);
	if (!beenhere &amp;&amp; edev != nil) {
		beenhere = 1;
		/* simulate interrupts if we don't know the irq */
		if (edev-&gt;irq &lt; 0) {		/* poll as backup */
			thisether = edev;
			addclock0link(etherclock, 1000/HZ);
			iprint(" polling");
		}
	}
	iunlock(&amp;l);
}

/*
 * indirect (mac) register access
 */

static void
macwait(Regs *regs)
{
	long bound;

	for (bound = 400*Mhz; regs-&gt;maccsrcmd &amp; Csrbusy &amp;&amp; bound &gt; 0; bound--)
		;
	if (bound &lt;= 0)
		iprint("smc: mac registers didn't come ready\n");
}

static ulong
macrd(Regs *regs, uchar index)
{
	macwait(regs);
	regs-&gt;maccsrcmd = Csrbusy | Csrread | index;
	coherence();		/* back-to-back write/read delay per §6.2.1 */
	macwait(regs);
	return regs-&gt;maccsrdata;
}

static void
macwr(Regs *regs, uchar index, ulong val)
{
	macwait(regs);
	regs-&gt;maccsrdata = val;
	regs-&gt;maccsrcmd = Csrbusy | index;	/* fire */
	macwait(regs);
}


static long
smcifstat(Ether* edev, void* a, long n, ulong offset)
{
	Ctlr *ctlr;
	char *p, *s;
	int i, l, r;

	ctlr = edev-&gt;ctlr;
	qlock(&amp;ctlr-&gt;slock);
	p = malloc(READSTR);
	l = 0;
	for(i = 0; i &lt; Nstatistics; i++){
		// read regs-&gt;rxdrop TODO
		r = 0;
		if((s = statistics[i]) == nil)
			continue;
		switch(i){
		default:
			ctlr-&gt;statistics[i] += r;
			if(ctlr-&gt;statistics[i] == 0)
				continue;
			l += snprint(p+l, READSTR-l, "%s: %ud %ud\n",
				s, ctlr-&gt;statistics[i], r);
			break;
		}
	}

	l += snprint(p+l, READSTR-l, "lintr: %ud %ud\n",
		ctlr-&gt;lintr, ctlr-&gt;lsleep);
	l += snprint(p+l, READSTR-l, "rintr: %ud %ud\n",
		ctlr-&gt;rintr, ctlr-&gt;rsleep);
	l += snprint(p+l, READSTR-l, "tintr: %ud %ud\n",
		ctlr-&gt;tintr, ctlr-&gt;tsleep);

	l += snprint(p+l, READSTR-l, "eeprom:");
	for(i = 0; i &lt; 0x40; i++){
		if(i &amp;&amp; ((i &amp; 0x07) == 0))
			l += snprint(p+l, READSTR-l, "\n       ");
		l += snprint(p+l, READSTR-l, " %4.4uX", ctlr-&gt;eeprom[i]);
	}
	l += snprint(p+l, READSTR-l, "\n");
	USED(l);

	n = readstr(offset, a, n, p);
	free(p);
	qunlock(&amp;ctlr-&gt;slock);

	return n;
}

static void
smcpromiscuous(void* arg, int on)
{
	int rctl;
	Ctlr *ctlr;
	Ether *edev;
	Regs *regs;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	regs = ctlr-&gt;regs;
	rctl = macrd(regs, Maccr);
	if(on)
		rctl |= Prms;
	else
		rctl &amp;= ~Prms;
	macwr(regs, Maccr, rctl);
}

static void
smcmulticast(void*, uchar*, int)
{
	/* nothing to do, we allow all multicast packets in */
}

static int
iswrcpydone(void *arg)
{
	return ((Ctlr *)arg)-&gt;wrcpydone;
}

static int
smctxstart(Ctlr *ctlr, uchar *ubuf, uint len)
{
	uint wds, ruplen;
	ulong *wdp, *txdp;
	Regs *regs;
	static ulong buf[ROUNDUP(ETHERMAXTU, sizeof(ulong)) / sizeof(ulong)];

	if (!ctlr-&gt;inited) {
		iprint("smctxstart: too soon to send\n");
		return -1;		/* toss it */
	}
	regs = ctlr-&gt;regs;

	/* is there room for a packet in the tx data fifo? */
	if (len &lt; ETHERMINTU)
		iprint("sending too-short (%d) pkt\n", len);
	else if (len &gt; ETHERMAXTU)
		iprint("sending jumbo (%d) pkt\n", len);

	ruplen = ROUNDUP(len, sizeof(ulong));
	coherence();	/* back-to-back read/read delay per §6.2.2 */
	if ((regs-&gt;txfifoinf &amp; Txdatafreemask) &lt; ruplen + 2*sizeof(ulong))
		return -1;	/* not enough room for data + command words */

	if ((uintptr)ubuf &amp; MASK(2)) {		/* ensure word alignment */
		memmove(buf, ubuf, len);
		ubuf = (uchar *)buf;
	}

	/* tx cmd a: length is bytes in this buffer */
	txdp = &amp;regs-&gt;txdata;
	*txdp = Intcompl | Firstseg | Lastseg | len;
	/* tx cmd b: length is bytes in this packet (could be multiple buf.s) */
	*txdp = len;

	/* shovel pkt into tx fifo, which triggers transmission due to Txon */
	wdp = (ulong *)ubuf;
	for (wds = ruplen / sizeof(ulong) + 1; --wds &gt; 0; )
		*txdp = *wdp++;

	regs-&gt;intsts = Txintrs;		/* dismiss intr */
	coherence();
	regs-&gt;inten |= Txintrs;
	coherence();		/* back-to-back write/read delay per §6.2.1 */
	return 0;
}

static void
smctransmit(Ether* edev)
{
	Block *bp;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	if (ctlr == nil)
		panic("smctransmit: nil ctlr");
	ilock(&amp;ctlr-&gt;tlock);
	/*
	 * Try to fill the chip's buffers back up, via the tx fifo.
	 */
	while ((bp = qget(edev-&gt;oq)) != nil)
		if (smctxstart(ctlr, bp-&gt;rp, BLEN(bp)) &lt; 0) {
			qputback(edev-&gt;oq, bp);	/* retry the block later */
			iprint("smctransmit: tx data fifo full\n");
			break;
		} else
			freeb(bp);
	iunlock(&amp;ctlr-&gt;tlock);
}

static void
smctransmitcall(Ether *edev)		/* called from devether.c */
{
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	ctlr-&gt;gotoutput = 1;
#ifdef USE_KPROCS
	wakeup(&amp;ctlr-&gt;trendez);
#else
	smctransmit(edev);
#endif
}

static int
smcrim(void* ctlr)
{
	return ((Ctlr*)ctlr)-&gt;gotinput;
}

static void
smcrproc(void* arg)
{
	Ctlr *ctlr;
	Ether *edev;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	for(;;){
		ctlr-&gt;rsleep++;
		sleep(&amp;ctlr-&gt;rrendez, smcrim, ctlr);

		/* process any newly-arrived packets and pass to etheriq */
		ctlr-&gt;gotinput = 0;
		smcreceive(edev);
	}
}

static int
smcgotout(void* ctlr)
{
	return ((Ctlr*)ctlr)-&gt;gotoutput;
}

static void
smctproc(void* arg)
{
	Ctlr *ctlr;
	Ether *edev;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	for(;;){
		ctlr-&gt;tsleep++;
		sleep(&amp;ctlr-&gt;trendez, smcgotout, ctlr);

		/* process any newly-arrived packets and pass to etheriq */
		ctlr-&gt;gotoutput = 0;
		smctransmit(edev);
	}
}

void	gpioirqclr(void);

static void
smcattach(Ether* edev)
{
#ifdef USE_KPROCS
	char name[KNAMELEN];
#endif
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	qlock(&amp;ctlr-&gt;alock);
	if(waserror()){
		qunlock(&amp;ctlr-&gt;alock);
		nexterror();
	}
	if (!ctlr-&gt;inited) {
		ctlr-&gt;inited = 1;
#ifdef USE_KPROCS
		snprint(name, KNAMELEN, "#l%drproc", edev-&gt;ctlrno);
		kproc(name, smcrproc, edev);

		snprint(name, KNAMELEN, "#l%dtproc", edev-&gt;ctlrno);
		kproc(name, smctproc, edev);
#endif

iprint("smcattach:");
#ifdef USE_KPROCS
iprint(" with kprocs");
#else
iprint(" no kprocs");
#endif
iprint(", no dma");
		/* can now accept real or simulated interrupts */

		smconce(edev);
		attached = 1;
iprint("\n");
	}
	qunlock(&amp;ctlr-&gt;alock);
	poperror();
}

static int
isrdcpydone(void *arg)
{
	return ((Ctlr *)arg)-&gt;rdcpydone;
}

static void
smcreceive(Ether *edev)
{
	uint wds, len, sts;
	ulong *wdp, *rxdp;
	Block *bp;
	Ctlr *ctlr;
	Regs *regs;

	ctlr = edev-&gt;ctlr;
	regs = ctlr-&gt;regs;
	coherence();		/* back-to-back read/read delay per §6.2.2 */
	/*
	 * is there a full packet in the rx data fifo?
	 */
	while (((regs-&gt;rxfifoinf &amp; Rxstsusedmask) &gt;&gt; Rxstsusedshift) != 0) {
		coherence();
		sts = regs-&gt;rxsts;		/* pop rx status */
		if(sts &amp; Rxerr)
			iprint("smcreceive: rx error\n");
		len = (sts &amp; Rxpktlenmask) &gt;&gt; Rxpktlenshift;
		if (len &gt; ETHERMAXTU + Slop)
			iprint("smcreceive: oversized rx pkt (%d)\n", len);
		else if (len &lt; ETHERMINTU)
			iprint("smcreceive: too-short (%d) pkt\n", len);
		wds = ROUNDUP(len, sizeof(ulong)) / sizeof(ulong);
		if (wds &gt; 0) {
			/* copy aligned words from rx fifo into a Block */
			bp = iallocb(len + sizeof(ulong) /* - 1 */);
			if (bp == nil)
				panic("smcreceive: nil Block*");

			/* bp-&gt;rp should be 32-byte aligned, more than we need */
			assert(((uintptr)bp-&gt;rp &amp; (sizeof(ulong) - 1)) == 0);
			wdp = (ulong *)bp-&gt;rp;
			rxdp = &amp;regs-&gt;rxdata;
			wds = ROUNDUP(len, sizeof(ulong)) / sizeof(ulong) + 1;
			while (--wds &gt; 0)
				*wdp++ = *rxdp;
			bp-&gt;wp = bp-&gt;rp + len;

			/* and push the Block upstream */
			if (ctlr-&gt;inited)
				etheriq(edev, bp, 1);
			else
				freeb(bp);

			regs-&gt;intsts = Rxintrs;		/* dismiss intr */
			coherence();
			regs-&gt;inten |= Rxintrs;
		}
		coherence();
	}
	regs-&gt;inten |= Rxintrs;
	coherence();
}

/*
 * disable the stsclr bits in inten and write them to intsts to ack and dismiss
 * the interrupt source.
 */
void
ackintr(Regs *regs, ulong stsclr)
{
	if (stsclr == 0)
		return;

	regs-&gt;inten &amp;= ~stsclr;
	coherence();

//	regs-&gt;intsts = stsclr;		/* acknowledge &amp; clear intr(s) */
//	coherence();
}

static void
smcinterrupt(Ureg*, void* arg)
{
	int junk;
	unsigned intsts, intr;
	Ctlr *ctlr;
	Ether *edev;
	Regs *regs;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;imlock);
	regs = ctlr-&gt;regs;

	gpioirqclr();

	coherence();		/* back-to-back read/read delay per §6.2.2 */
	intsts = regs-&gt;intsts;
	coherence();

	intsts &amp;= ~MASK(3);		/* ignore gpio bits */
	if (0 &amp;&amp; intsts == 0) {
		coherence();
		iprint("smc: interrupt without a cause; insts %#ux (vs inten %#lux)\n",
			intsts, regs-&gt;inten);
	}

	intr = intsts &amp; Rxintrs;
	if(intr) {
		/* disable interrupt sources; kproc/smcreceive will reenable */
		ackintr(regs, intr);

		ctlr-&gt;rintr++;
		ctlr-&gt;gotinput = 1;
#ifdef USE_KPROCS
		wakeup(&amp;ctlr-&gt;rrendez);
#else
		smcreceive(edev);
#endif
	}

	while(((regs-&gt;txfifoinf &amp; Txstsusedmask) &gt;&gt; Txstsusedshift) != 0) {
		/* probably indicates tx completion, just toss it */
		junk = regs-&gt;txsts;		/* pop tx sts */
		USED(junk);
		coherence();
	}

	intr = intsts &amp; Txintrs;
	if (ctlr-&gt;gotoutput || intr) {
		/* disable interrupt sources; kproc/smctransmit will reenable */
		ackintr(regs, intr);

		ctlr-&gt;tintr++;
		ctlr-&gt;gotoutput = 1;
#ifdef USE_KPROCS
		wakeup(&amp;ctlr-&gt;trendez);
#else
		smctransmit(edev);
#endif
	}

	iunlock(&amp;ctlr-&gt;imlock);
}

static void
etherclock(void)
{
	smcinterrupt(nil, thisether);
}

static int
smcmii(Ctlr *)
{
	return 0;
}

static int
smcdetach(Ctlr* ctlr)
{
	Regs *regs;

	if (ctlr == nil || ctlr-&gt;regs == nil)
		return -1;
	regs = ctlr-&gt;regs;
	/* verify that it's real by reading a few registers */
	switch (regs-&gt;id) {
	case Vid9221:
		break;
	default:
		print("smc: unknown chip id %#ux\n", regs-&gt;id);
		return -1;
	}
	regs-&gt;inten = 0;		/* no interrupts */
	regs-&gt;intsts = ~0;		/* clear any pending */
	regs-&gt;gptcfg = 0;
	coherence();
	regs-&gt;rxcfg = Rxdump;
	regs-&gt;txcfg = Txsdump | Txddump;
	regs-&gt;irqcfg &amp;= ~Irqen;
	coherence();
	return 0;
}

static void
smcshutdown(Ether* ether)
{
	smcdetach(ether-&gt;ctlr);
}

static void
powerwait(Regs *regs)
{
	long bound;

	regs-&gt;bytetest = 0;			/* bring power on */
	for (bound = 400*Mhz; !(regs-&gt;pmtctl &amp; Dready) &amp;&amp; bound &gt; 0; bound--)
		;
	if (bound &lt;= 0)
		iprint("smc: pmtctl didn't come ready\n");
}

static int
smcreset(Ctlr* ctlr)
{
	int r;
	Regs *regs;
	static char zea[Eaddrlen];

	regs = ctlr-&gt;regs;
	powerwait(regs);

	if(smcdetach(ctlr))
		return -1;

	/* verify that it's real by reading a few registers */
	switch (regs-&gt;id) {
	case Vid9221:
		break;
	default:
		print("smc: unknown chip id %#ux\n", regs-&gt;id);
		return -1;
	}
	if (regs-&gt;bytetest != 0x87654321) {
		print("smc: bytetest reg %#p (%#lux) != 0x87654321\n",
			&amp;regs-&gt;bytetest, regs-&gt;bytetest);
		return -1;
	}

#ifdef TODO			/* read MAC from EEPROM */
//	int ctrl, i, pause, swdpio, txcw;
	/*
	 * Snarf and set up the receive addresses.
	 * There are 16 addresses. The first should be the MAC address.
	 * The others are cleared and not marked valid (MS bit of Rah).
	 */
	for(i = Ea; i &lt; Eaddrlen/2; i++){
		ctlr-&gt;ra[2*i] = ctlr-&gt;eeprom[i];
		ctlr-&gt;ra[2*i+1] = ctlr-&gt;eeprom[i]&gt;&gt;8;
	}

	/*
	 * Clear the Multicast Table Array.
	 * It's a 4096 bit vector accessed as 128 32-bit registers.
	 */
	memset(ctlr-&gt;mta, 0, sizeof(ctlr-&gt;mta));
	for(i = 0; i &lt; 128; i++)
		csr32w(ctlr, Mta+i*4, 0);
#endif
	regs-&gt;hwcfg |= Mbo;

	/* don't overwrite existing ea */
//	if (memcmp(edev-&gt;ea, zea, Eaddrlen) == 0)
//		memmove(edev-&gt;ea, ctlr-&gt;ra, Eaddrlen);

	r = ctlr-&gt;ra[3]&lt;&lt;24 | ctlr-&gt;ra[2]&lt;&lt;16 | ctlr-&gt;ra[1]&lt;&lt;8 | ctlr-&gt;ra[0];
	macwr(regs, Macaddrl, r);
	macwr(regs, Macaddrh, ctlr-&gt;ra[5]&lt;&lt;8 | ctlr-&gt;ra[4]);

	/* turn on the controller */
	macwr(regs, Maccoe, 0);
	regs-&gt;inten = 0;		/* no interrupts yet */
	regs-&gt;intsts = ~0;		/* clear any pending */
	regs-&gt;gptcfg = 0;
	coherence();
	regs-&gt;rxcfg = Rxdump;
	regs-&gt;txcfg = Txsdump | Txddump | Txon;
	regs-&gt;fifoint = 72&lt;&lt;24;		/* default values */
	macwr(regs, Maccr, Rxall | Rcvown | Fdpx | Mcpas | Txen | Rxen);
	coherence();		/* back-to-back write/read delay per §6.2.1 */
	regs-&gt;irqcfg = 1&lt;&lt;24 | Irqen | Irqpushpull;  /* deas for 10µs (linux) */
	coherence();		/* back-to-back write/read delay per §6.2.1 */
	regs-&gt;inten = Rxintrs | Txintrs;
	coherence();

	if(smcmii(ctlr) &lt; 0)
		return -1;
	return 0;
}

static void
smcpci(void)
{
	Ctlr *ctlr;
	static int beenhere;

	if (beenhere)
		return;
	beenhere = 1;

	if (probeaddr(PHYSETHER) &lt; 0)
		return;
	ctlr = malloc(sizeof(Ctlr));
	ctlr-&gt;id = Vid9221&lt;&lt;16 | 0x0424;	/* smsc 9221 */
	ctlr-&gt;port = PHYSETHER;
	ctlr-&gt;nic = (int *)PHYSETHER;
	ctlr-&gt;regs = (Regs *)PHYSETHER;

	if(smcreset(ctlr)){
		free(ctlr);
		return;
	}
	if(smcctlrhead != nil)
		smcctlrtail-&gt;next = ctlr;
	else
		smcctlrhead = ctlr;
	smcctlrtail = ctlr;
}

static int
smcpnp(Ether* edev)
{
	Ctlr *ctlr;
	static char zea[Eaddrlen];

	if(smcctlrhead == nil)
		smcpci();

	/*
	 * Any adapter matches if no edev-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	for(ctlr = smcctlrhead; ctlr != nil; ctlr = ctlr-&gt;next){
		if(ctlr-&gt;active)
			continue;
		if(edev-&gt;port == 0 || edev-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}
	if(ctlr == nil)
		return -1;

	edev-&gt;ctlr = ctlr;
	ctlr-&gt;edev = edev;			/* point back to Ether* */
	edev-&gt;port = ctlr-&gt;port;
	edev-&gt;irq = 34;
// TODO: verify speed (100Mb/s) and duplicity (full-duplex)
	edev-&gt;mbps = 100;

	/* don't overwrite existing ea */
	if (memcmp(edev-&gt;ea, zea, Eaddrlen) == 0)
		memmove(edev-&gt;ea, ctlr-&gt;ra, Eaddrlen);

	/*
	 * Linkage to the generic ethernet driver.
	 */
	edev-&gt;attach = smcattach;
	edev-&gt;transmit = smctransmitcall;
	edev-&gt;interrupt = smcinterrupt;
	edev-&gt;ifstat = smcifstat;
/*	edev-&gt;ctl = smcctl;			/* no ctl msgs supported */

	edev-&gt;arg = edev;
	edev-&gt;promiscuous = smcpromiscuous;
	edev-&gt;multicast = smcmulticast;
	edev-&gt;shutdown = smcshutdown;
	return 0;
}

void
ether9221link(void)
{
	addethercard("9221", smcpnp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

