<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * omap3530 traps, exceptions, interrupts, system calls.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ureg.h"
#include "arm.h"

enum {
	Nirqs = 96,
	Nvec = 8,		/* # of vectors at start of lexception.s */
	Bi2long = BI2BY * sizeof(long),
};

extern int notify(Ureg*);

extern int ldrexvalid;

/* omap35x intc (aka mpu_intc) */
typedef struct Intrregs Intrregs;
struct Intrregs {
	/*
	 * the manual inserts "INTCPS_" before each register name;
	 * we'll just assume the prefix.
	 */
	uchar	_pad0[4*4];
	ulong	sysconfig;
	ulong	sysstatus;		/* ro */
	uchar	_pad1[0x40 - 0x18];
	ulong	sir_irq;		/* ro */
	ulong	sir_fiq;		/* ro */
	ulong	control;
	ulong	protection;
	ulong	idle;
	uchar	_pad2[0x60 - 0x54];
	ulong	irq_priority;
	ulong	fiq_priority;
	ulong	threshold;
	uchar	_pad3[0x80 - 0x6c];
	struct Bits {			/* bitmaps */
		ulong	itr;		/* ro: pending intrs (no mask) */
		ulong	mir;		/* interrupt mask: 1 means masked */
		ulong	mir_clear;	/* wo: 1 sets the bit */
		ulong	mir_set;	/* wo: 1 clears the bit */
		ulong	isr_set;	/* software interrupts */
		ulong	isr_clear;	/* wo */
		ulong	pending_irq;	/* ro */
		ulong	pending_fiq;	/* ro */
	} bits[3];			/* 3*32 = 96 (Nirqs) */
	ulong	ilr[Nirqs];
};

enum {
	/* sysconfig bits */
	Softreset	= 1&lt;&lt;1,

	/* sysstatus bits */
	Resetdone	= 1&lt;&lt;0,

	/* sir_irq/fiq bits */
	Activeirq	= MASK(7),

	/* control bits */
	Newirqagr	= 1&lt;&lt;0,

	/* protection bits */
	Protection	= 1&lt;&lt;0,

	/* irq/fiq_priority bits */
	Irqpriority	= MASK(6),

	/* threshold bits */
	Prioritythreshold = MASK(8),

	/* ilr bits */
	Priority	= MASK(8) - MASK(2),
};

typedef struct Vctl Vctl;
typedef struct Vctl {
	Vctl*	next;		/* handlers on this vector */
	char	*name;		/* of driver, xallocated */
	void	(*f)(Ureg*, void*);	/* handler to call */
	void*	a;		/* argument to call it with */
} Vctl;

static Lock vctllock;
static Vctl* vctl[Nirqs];

/*
 *   Layout at virtual address 0.
 */
typedef struct Vpage0 {
	void	(*vectors[Nvec])(void);
	u32int	vtable[Nvec];
} Vpage0;
static Vpage0 *vpage0;

uvlong ninterrupt;
uvlong ninterruptticks;
int irqtooearly = 1;

static volatile int probing, trapped;

static int
irqinuse(uint irq)
{
	Intrregs *ip = (Intrregs *)PHYSINTC;

	/*
	 * mir registers are odd: a 0 bit means intr unmasked (i.e.,
	 * we've unmasked it because it's in use).
	 */
	return (ip-&gt;bits[irq / Bi2long].mir &amp; (1 &lt;&lt; (irq % Bi2long))) == 0;
}

static void
intcmask(uint irq)
{
	Intrregs *ip = (Intrregs *)PHYSINTC;

	ip-&gt;bits[irq / Bi2long].mir_set = 1 &lt;&lt; (irq % Bi2long);
	coherence();
}

static void
intcunmask(uint irq)
{
	Intrregs *ip = (Intrregs *)PHYSINTC;

	ip-&gt;bits[irq / Bi2long].mir_clear = 1 &lt;&lt; (irq % Bi2long);
	coherence();
}

static void
intcmaskall(void)
{
	int i;
	Intrregs *ip = (Intrregs *)PHYSINTC;

	for (i = 0; i &lt; 3; i++)
		ip-&gt;bits[i].mir_set = ~0;
	coherence();
}

static void
intcunmaskall(void)
{
	int i;
	Intrregs *ip = (Intrregs *)PHYSINTC;

	for (i = 0; i &lt; 3; i++)
		ip-&gt;bits[i].mir_clear = ~0;
	coherence();
}

static void
intcinvertall(void)
{
	int i, s;
	ulong bits;
	Intrregs *ip = (Intrregs *)PHYSINTC;

	s = splhi();
	for (i = 0; i &lt; 3; i++) {
		bits = ip-&gt;bits[i].mir;
		ip-&gt;bits[i].mir_set = ~0;	/* mask all */
		coherence();
		/* clearing enables only those intrs. that were disabled */
		ip-&gt;bits[i].mir_clear = bits;
	}
	coherence();
	splx(s);
}

static void
intrsave(ulong buf[3])
{
	int i;
	Intrregs *ip = (Intrregs *)PHYSINTC;

	for (i = 0; i &lt; nelem(buf); i++)
		buf[i] = ip-&gt;bits[i].mir;
	coherence();
}

static void
intrrestore(ulong buf[3])
{
	int i, s;
	Intrregs *ip = (Intrregs *)PHYSINTC;

	s = splhi();
	for (i = 0; i &lt; nelem(buf); i++) {
		ip-&gt;bits[i].mir_clear = ~0;	/* unmask all */
		coherence();
		ip-&gt;bits[i].mir_set = buf[i];	/* mask previously disabled */
	}
	coherence();
	splx(s);
}

/*
 *  set up for exceptions
 */
void
trapinit(void)
{
	int i;
	Intrregs *ip = (Intrregs *)PHYSINTC;

	/* set up the exception vectors */
	vpage0 = (Vpage0*)HVECTORS;
	memmove(vpage0-&gt;vectors, vectors, sizeof(vpage0-&gt;vectors));
	memmove(vpage0-&gt;vtable, vtable, sizeof(vpage0-&gt;vtable));
	cacheuwbinv();
	l2cacheuwbinv();

	/* set up the stacks for the interrupt modes */
	setr13(PsrMfiq, m-&gt;sfiq);
	setr13(PsrMirq, m-&gt;sirq);
	setr13(PsrMabt, m-&gt;sabt);
	setr13(PsrMund, m-&gt;sund);
#ifdef HIGH_SECURITY
	setr13(PsrMmon, m-&gt;smon);
#endif
	setr13(PsrMsys, m-&gt;ssys);

	intcmaskall();
	ip-&gt;control = 0;
	ip-&gt;threshold = Prioritythreshold;	/* disable threshold */
	for (i = 0; i &lt; Nirqs; i++)
		ip-&gt;ilr[i] = 0&lt;&lt;2 | 0;	/* all intrs pri 0 &amp; to irq, not fiq */
	irqtooearly = 0;
	coherence();
}

void
intrsoff(void)
{
	Intrregs *ip = (Intrregs *)PHYSINTC;

	intcmaskall();
	ip-&gt;control = Newirqagr;	/* dismiss interrupt */
	coherence();
}

/*
 *  enable an irq interrupt
 */
int
irqenable(int irq, void (*f)(Ureg*, void*), void* a, char *name)
{
	Vctl *v;

	if(irq &gt;= nelem(vctl) || irq &lt; 0)
		panic("irqenable irq %d", irq);

	if (irqtooearly) {
		iprint("irqenable for %d %s called too early\n", irq, name);
		return -1;
	}
	if(irqinuse(irq))
		print("irqenable: %s: irq %d already in use, chaining\n",
			name, irq);
	v = malloc(sizeof(Vctl));
	if (v == nil)
		panic("irqenable: malloc Vctl");
	v-&gt;f = f;
	v-&gt;a = a;
	v-&gt;name = malloc(strlen(name)+1);
	if (v-&gt;name == nil)
		panic("irqenable: malloc name");
	strcpy(v-&gt;name, name);

	lock(&amp;vctllock);
	v-&gt;next = vctl[irq];
	vctl[irq] = v;

	intcunmask(irq);
	unlock(&amp;vctllock);
	return 0;
}

/*
 *  disable an irq interrupt
 */
int
irqdisable(int irq, void (*f)(Ureg*, void*), void* a, char *name)
{
	Vctl **vp, *v;

	if(irq &gt;= nelem(vctl) || irq &lt; 0)
		panic("irqdisable irq %d", irq);

	lock(&amp;vctllock);
	for(vp = &amp;vctl[irq]; v = *vp; vp = &amp;v-&gt;next)
		if (v-&gt;f == f &amp;&amp; v-&gt;a == a &amp;&amp; strcmp(v-&gt;name, name) == 0){
			print("irqdisable: remove %s\n", name);
			*vp = v-&gt;next;
			free(v);
			break;
		}

	if(v == nil)
		print("irqdisable: irq %d, name %s not enabled\n", irq, name);
	if(vctl[irq] == nil){
		print("irqdisable: clear icmr bit %d\n", irq);
		intcmask(irq);
	}
	unlock(&amp;vctllock);

	return 0;
}

/*
 *  called by trap to handle access faults
 */
static void
faultarm(Ureg *ureg, uintptr va, int user, int read)
{
	int n, insyscall;
	char buf[ERRMAX];

	if(up == nil) {
		dumpregs(ureg);
		panic("fault: nil up in faultarm, accessing %#p", va);
	}
	insyscall = up-&gt;insyscall;
	up-&gt;insyscall = 1;
	n = fault(va, read);
	if(n &lt; 0){
		if(!user){
			dumpregs(ureg);
			panic("fault: kernel accessing %#p", va);
		}
		/* don't dump registers; programs suicide all the time */
		snprint(buf, sizeof buf, "sys: trap: fault %s va=%#p",
			read? "read": "write", va);
		postnote(up, 1, buf, NDebug);
	}
	up-&gt;insyscall = insyscall;
}

/*
 *  called by trap to handle interrupts.
 *  returns true iff a clock interrupt, thus maybe reschedule.
 */
static int
irq(Ureg* ureg)
{
	int clockintr;
	uint irqno, handled, t, ticks = perfticks();
	Intrregs *ip = (Intrregs *)PHYSINTC;
	Vctl *v;
	static int nesting, lastirq = -1;

	handled = 0;
	irqno = ip-&gt;sir_irq &amp; Activeirq;

	if (irqno &gt;= 37 &amp;&amp; irqno &lt;= 47)		/* this is a clock intr? */
		m-&gt;inclockintr++;		/* yes, count nesting */
	lastirq = irqno;

	if (irqno &gt;= nelem(vctl)) {
		iprint("trap: irq %d &gt;= # vectors (%d)\n", irqno, nelem(vctl));
		ip-&gt;control = Newirqagr;	/* dismiss interrupt */
		return 0;
	}

	++nesting;
	for(v = vctl[irqno]; v != nil; v = v-&gt;next)
		if (v-&gt;f) {
			if (islo())
				panic("trap: pl0 before trap handler for %s",
					v-&gt;name);
			v-&gt;f(ureg, v-&gt;a);
			if (islo())
				panic("trap: %s lowered pl", v-&gt;name);
//			splhi();		/* in case v-&gt;f lowered pl */
			handled++;
		}
	if(!handled) {
		iprint("unexpected interrupt: irq %d", irqno);
		switch (irqno) {
		case 56:
		case 57:
			iprint(" (I⁲C)");
			break;
		case 83:
		case 86:
		case 94:
			iprint(" (MMC)");
			break;
		}

		if(irqno &lt; nelem(vctl)) {
			intcmask(irqno);
			iprint(", now masked");
		}
		iprint("\n");
	}
	t = perfticks();
	ninterrupt++;
	if(t &lt; ticks)
		ninterruptticks += ticks-t;
	else
		ninterruptticks += t-ticks;
	ip-&gt;control = Newirqagr;	/* dismiss interrupt */
	coherence();

	--nesting;
	clockintr = m-&gt;inclockintr == 1;
	if (irqno &gt;= 37 &amp;&amp; irqno &lt;= 47)
		m-&gt;inclockintr--;
	return clockintr;
}

/*
 *  returns 1 if the instruction writes memory, 0 otherwise
 */
int
writetomem(ulong inst)
{
	/* swap always write memory */
	if((inst &amp; 0x0FC00000) == 0x01000000)
		return 1;

	/* loads and stores are distinguished by bit 20 */
	if(inst &amp; (1&lt;&lt;20))
		return 0;

	return 1;
}

void	prgpmcerrs(void);

/*
 *  here on all exceptions other than syscall (SWI)
 */
void
trap(Ureg *ureg)
{
	int clockintr, user, x, rv, rem;
	ulong inst, fsr;
	uintptr va;
	char buf[ERRMAX];

	splhi();			/* paranoia */
	if(up != nil)
		rem = ((char*)ureg)-up-&gt;kstack;
	else
		rem = ((char*)ureg)-((char*)m+sizeof(Mach));
	if(rem &lt; 1024) {
		iprint("trap: %d stack bytes left, up %#p ureg %#p at pc %#lux\n",
			rem, up, ureg, ureg-&gt;pc);
		delay(1000);
		dumpstack();
		panic("trap: %d stack bytes left, up %#p ureg %#p at pc %#lux",
			rem, up, ureg, ureg-&gt;pc);
	}

	user = (ureg-&gt;psr &amp; PsrMask) == PsrMusr;
	if(user){
		up-&gt;dbgreg = ureg;
		cycles(&amp;up-&gt;kentry);
	}

	/*
	 * All interrupts/exceptions should be resumed at ureg-&gt;pc-4,
	 * except for Data Abort which resumes at ureg-&gt;pc-8.
	 */
	if(ureg-&gt;type == (PsrMabt+1))
		ureg-&gt;pc -= 8;
	else
		ureg-&gt;pc -= 4;

	clockintr = 0;		/* if set, may call sched() before return */
	switch(ureg-&gt;type){
	default:
		panic("unknown trap; type %#lux, psr mode %#lux", ureg-&gt;type,
			ureg-&gt;psr &amp; PsrMask);
		break;
	case PsrMirq:
		ldrexvalid = 0;
		clockintr = irq(ureg);
		m-&gt;intr++;
		break;
	case PsrMabt:			/* prefetch fault */
		ldrexvalid = 0;
		x = ifsrget();
		fsr = (x&gt;&gt;7) &amp; 0x8 | x &amp; 0x7;
		switch(fsr){
		case 0x02:		/* instruction debug event (BKPT) */
			if(user){
				snprint(buf, sizeof buf, "sys: breakpoint");
				postnote(up, 1, buf, NDebug);
			}else{
				iprint("kernel bkpt: pc %#lux inst %#ux\n",
					ureg-&gt;pc, *(u32int*)ureg-&gt;pc);
				panic("kernel bkpt");
			}
			break;
		default:
			faultarm(ureg, ureg-&gt;pc, user, 1);
			break;
		}
		break;
	case PsrMabt+1:			/* data fault */
		ldrexvalid = 0;
		va = farget();
		inst = *(ulong*)(ureg-&gt;pc);
		/* bits 12 and 10 have to be concatenated with status */
		x = fsrget();
		fsr = (x&gt;&gt;7) &amp; 0x20 | (x&gt;&gt;6) &amp; 0x10 | x &amp; 0xf;
		if (probing &amp;&amp; !user) {
			if (trapped++ &gt; 0)
				panic("trap: recursive probe %#lux", va);
			ureg-&gt;pc += 4;	/* continue at next instruction */
			break;
		}
		switch(fsr){
		default:
		case 0xa:		/* ? was under external abort */
			panic("unknown data fault, 6b fsr %#lux", fsr);
			break;
		case 0x0:
			panic("vector exception at %#lux", ureg-&gt;pc);
			break;
		case 0x1:		/* alignment fault */
		case 0x3:		/* access flag fault (section) */
			if(user){
				snprint(buf, sizeof buf,
					"sys: alignment: pc %#lux va %#p\n",
					ureg-&gt;pc, va);
				postnote(up, 1, buf, NDebug);
			} else
				panic("kernel alignment: pc %#lux va %#p", ureg-&gt;pc, va);
			break;
		case 0x2:
			panic("terminal exception at %#lux", ureg-&gt;pc);
			break;
		case 0x4:		/* icache maint fault */
		case 0x6:		/* access flag fault (page) */
		case 0x8:		/* precise external abort, non-xlat'n */
		case 0x28:
		case 0xc:		/* l1 translation, precise ext. abort */
		case 0x2c:
		case 0xe:		/* l2 translation, precise ext. abort */
		case 0x2e:
		case 0x16:		/* imprecise ext. abort, non-xlt'n */
		case 0x36:
			panic("external abort %#lux pc %#lux addr %#p",
				fsr, ureg-&gt;pc, va);
			break;
		case 0x1c:		/* l1 translation, precise parity err */
		case 0x1e:		/* l2 translation, precise parity err */
		case 0x18:		/* imprecise parity or ecc err */
			panic("translation parity error %#lux pc %#lux addr %#p",
				fsr, ureg-&gt;pc, va);
			break;
		case 0x5:		/* translation fault, no section entry */
		case 0x7:		/* translation fault, no page entry */
			faultarm(ureg, va, user, !writetomem(inst));
			break;
		case 0x9:
		case 0xb:
			/* domain fault, accessing something we shouldn't */
			if(user){
				snprint(buf, sizeof buf,
					"sys: access violation: pc %#lux va %#p\n",
					ureg-&gt;pc, va);
				postnote(up, 1, buf, NDebug);
			} else
				panic("kernel access violation: pc %#lux va %#p",
					ureg-&gt;pc, va);
			break;
		case 0xd:
		case 0xf:
			/* permission error, copy on write or real permission error */
			faultarm(ureg, va, user, !writetomem(inst));
			break;
		}
		break;
	case PsrMund:			/* undefined instruction */
		if(user){
			if(seg(up, ureg-&gt;pc, 0) != nil &amp;&amp;
			   *(u32int*)ureg-&gt;pc == 0xD1200070){
				snprint(buf, sizeof buf, "sys: breakpoint");
				postnote(up, 1, buf, NDebug);
			}else{
				/* look for floating point instructions to interpret */
				x = spllo();
				rv = fpiarm(ureg);
				splx(x);
				if(rv == 0){
					ldrexvalid = 0;
					snprint(buf, sizeof buf,
						"undefined instruction: pc %#lux\n",
						ureg-&gt;pc);
					postnote(up, 1, buf, NDebug);
				}
			}
		}else{
			if (ureg-&gt;pc &amp; 3) {
				iprint("rounding fault pc %#lux down to word\n",
					ureg-&gt;pc);
				ureg-&gt;pc &amp;= ~3;
			}
			iprint("undefined instruction: pc %#lux inst %#ux\n",
				ureg-&gt;pc, ((u32int*)ureg-&gt;pc)[-2]);
			panic("undefined instruction");
		}
		break;
	}
	splhi();

	/* delaysched set because we held a lock or because our quantum ended */
	if(up &amp;&amp; up-&gt;delaysched &amp;&amp; clockintr){
		ldrexvalid = 0;
		sched();		/* can cause more traps */
		splhi();
	}

	if(user){
		if(up-&gt;procctl || up-&gt;nnote)
			notify(ureg);
		kexit(ureg);
	}
}

/*
 * Fill in enough of Ureg to get a stack trace, and call a function.
 * Used by debugging interface rdb.
 */
void
callwithureg(void (*fn)(Ureg*))
{
	Ureg ureg;

	ureg.pc = getcallerpc(&amp;fn);
	ureg.sp = PTR2UINT(&amp;fn);
	fn(&amp;ureg);
}

static void
dumpstackwithureg(Ureg *ureg)
{
	int x;
	uintptr l, v, i, estack;
	char *s;

	dumpregs(ureg);
	if((s = getconf("*nodumpstack")) != nil &amp;&amp; strcmp(s, "0") != 0){
		iprint("dumpstack disabled\n");
		return;
	}
	iprint("dumpstack\n");

	x = 0;
	x += iprint("ktrace /kernel/path %#.8lux %#.8lux %#.8lux # pc, sp, link\n",
		ureg-&gt;pc, ureg-&gt;sp, ureg-&gt;r14);
	delay(20);
	i = 0;
	if(up
	&amp;&amp; (uintptr)&amp;l &gt;= (uintptr)up-&gt;kstack
	&amp;&amp; (uintptr)&amp;l &lt;= (uintptr)up-&gt;kstack+KSTACK)
		estack = (uintptr)up-&gt;kstack+KSTACK;
	else if((uintptr)&amp;l &gt;= (uintptr)m-&gt;stack
	&amp;&amp; (uintptr)&amp;l &lt;= (uintptr)m+MACHSIZE)
		estack = (uintptr)m+MACHSIZE;
	else
		return;
	x += iprint("estackx %p\n", estack);

	for(l = (uintptr)&amp;l; l &lt; estack; l += sizeof(uintptr)){
		v = *(uintptr*)l;
		if((KTZERO &lt; v &amp;&amp; v &lt; (uintptr)etext) || estack-l &lt; 32){
			x += iprint("%.8p ", v);
			delay(20);
			i++;
		}
		if(i == 8){
			i = 0;
			x += iprint("\n");
			delay(20);
		}
	}
	if(i)
		iprint("\n");
}

void
dumpstack(void)
{
	callwithureg(dumpstackwithureg);
}

/*
 * dump system control coprocessor registers
 */
static void
dumpscr(void)
{
	iprint("0:\t%#8.8ux id\n", cpidget());
	iprint("\t%8.8#ux ct\n", cpctget());
	iprint("1:\t%#8.8ux control\n", controlget());
	iprint("2:\t%#8.8ux ttb\n", ttbget());
	iprint("3:\t%#8.8ux dac\n", dacget());
	iprint("4:\t(reserved)\n");
	iprint("5:\t%#8.8ux fsr\n", fsrget());
	iprint("6:\t%#8.8ux far\n", farget());
	iprint("7:\twrite-only cache\n");
	iprint("8:\twrite-only tlb\n");
	iprint("13:\t%#8.8ux pid\n", pidget());
	delay(10);
}

/*
 * dump general registers
 */
static void
dumpgpr(Ureg* ureg)
{
	if(up != nil)
		iprint("cpu%d: registers for %s %lud\n",
			m-&gt;machno, up-&gt;text, up-&gt;pid);
	else
		iprint("cpu%d: registers for kernel\n", m-&gt;machno);

	delay(20);
	iprint("%#8.8lux\tr0\n", ureg-&gt;r0);
	iprint("%#8.8lux\tr1\n", ureg-&gt;r1);
	iprint("%#8.8lux\tr2\n", ureg-&gt;r2);
	delay(20);
	iprint("%#8.8lux\tr3\n", ureg-&gt;r3);
	iprint("%#8.8lux\tr4\n", ureg-&gt;r4);
	iprint("%#8.8lux\tr5\n", ureg-&gt;r5);
	delay(20);
	iprint("%#8.8lux\tr6\n", ureg-&gt;r6);
	iprint("%#8.8lux\tr7\n", ureg-&gt;r7);
	iprint("%#8.8lux\tr8\n", ureg-&gt;r8);
	delay(20);
	iprint("%#8.8lux\tr9 (up)\n", ureg-&gt;r9);
	iprint("%#8.8lux\tr10 (m)\n", ureg-&gt;r10);
	iprint("%#8.8lux\tr11 (loader temporary)\n", ureg-&gt;r11);
	iprint("%#8.8lux\tr12 (SB)\n", ureg-&gt;r12);
	delay(20);
	iprint("%#8.8lux\tr13 (sp)\n", ureg-&gt;r13);
	iprint("%#8.8lux\tr14 (link)\n", ureg-&gt;r14);
	iprint("%#8.8lux\tr15 (pc)\n", ureg-&gt;pc);
	delay(20);
	iprint("%10.10lud\ttype\n", ureg-&gt;type);
	iprint("%#8.8lux\tpsr\n", ureg-&gt;psr);
	delay(20);
}

void
dumpregs(Ureg* ureg)
{
	dumpgpr(ureg);
	dumpscr();
}

vlong
probeaddr(uintptr addr)
{
	vlong v;
	static Lock fltlck;

	ilock(&amp;fltlck);
	trapped = 0;
	probing = 1;
	coherence();

	v = *(ulong *)addr;	/* this may cause a fault */
	USED(probing);
	coherence();

	probing = 0;
	coherence();
	if (trapped)
		v = -1;
	iunlock(&amp;fltlck);
	return v;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

