<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/usbehciomap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/usbehciomap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * OMAP3-specific code for
 * USB Enhanced Host Controller Interface (EHCI) driver
 * High speed USB 2.0.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/usb.h"
#include	"../port/portusbehci.h"
#include	"usbehci.h"

static Ctlr* ctlrs[Nhcis];

static void
ehcireset(Ctlr *ctlr)
{
	Eopio *opio;
	int i;

	ilock(ctlr);
	dprint("ehci %#p reset\n", ctlr-&gt;capio);
	opio = ctlr-&gt;opio;

	/*
	 * Turn off legacy mode. Some controllers won't
	 * interrupt us as expected otherwise.
	 */
	ehcirun(ctlr, 0);

	/* clear high 32 bits of address signals if it's 64 bits capable.
	 * This is probably not needed but it does not hurt and others do it.
	 */
	if((ctlr-&gt;capio-&gt;capparms &amp; C64) != 0){
		dprint("ehci: 64 bits\n");
		opio-&gt;seg = 0;
	}

	if(ehcidebugcapio != ctlr-&gt;capio){
		opio-&gt;cmd |= Chcreset;	/* controller reset */
		coherence();
		for(i = 0; i &lt; 100; i++){
			if((opio-&gt;cmd &amp; Chcreset) == 0)
				break;
			delay(1);
		}
		if(i == 100)
			print("ehci %#p controller reset timed out\n", ctlr-&gt;capio);
	}

	/* requesting more interrupts per µframe may miss interrupts */
	opio-&gt;cmd &amp;= ~Citcmask;
	opio-&gt;cmd |= 1 &lt;&lt; Citcshift;		/* max of 1 intr. per 125 µs */
	coherence();
	switch(opio-&gt;cmd &amp; Cflsmask){
	case Cfls1024:
		ctlr-&gt;nframes = 1024;
		break;
	case Cfls512:
		ctlr-&gt;nframes = 512;
		break;
	case Cfls256:
		ctlr-&gt;nframes = 256;
		break;
	default:
		panic("ehci: unknown fls %ld", opio-&gt;cmd &amp; Cflsmask);
	}
	coherence();
	dprint("ehci: %d frames\n", ctlr-&gt;nframes);
	iunlock(ctlr);
}

static void
setdebug(Hci*, int d)
{
	ehcidebug = d;
}

static void
shutdown(Hci *hp)
{
	int i;
	Ctlr *ctlr;
	Eopio *opio;

	ctlr = hp-&gt;aux;
	ilock(ctlr);
	opio = ctlr-&gt;opio;
	opio-&gt;cmd |= Chcreset;		/* controller reset */
	coherence();
	for(i = 0; i &lt; 100; i++){
		if((opio-&gt;cmd &amp; Chcreset) == 0)
			break;
		delay(1);
	}
	if(i &gt;= 100)
		print("ehci %#p controller reset timed out\n", ctlr-&gt;capio);
	delay(100);
	ehcirun(ctlr, 0);
	opio-&gt;frbase = 0;
	coherence();
	iunlock(ctlr);
}

/*
 * omap3-specific ehci code
 */

enum {
	/* opio-&gt;insn[5] bits */
	Control		= 1&lt;&lt;31,  /* set to start access, cleared when done */
	Write		= 2&lt;&lt;22,
	Read		= 3&lt;&lt;22,
	Portsh		= 24,
	Regaddrsh	= 16,		/* 0x2f means use extended reg addr */
	Eregaddrsh	= 8,

	/* phy reg addresses */
	Funcctlreg	= 4,
	Ifcctlreg	= 7,

	Phystppullupoff	= 0x90,		/* on is 0x10 */

	Phyrstport2	= 147,		/* gpio # */

};

static void
wrulpi(Eopio *opio, int port, int reg, uchar data)
{
	opio-&gt;insn[5] = Control | port &lt;&lt; Portsh | Write | reg &lt;&lt; Regaddrsh |
		data;
	coherence();
	/*
	 * this seems contrary to the skimpy documentation in the manual
	 * but inverting the test hangs forever.
	 */
	while (!(opio-&gt;insn[5] &amp; Control))
		;
}

static int
reset(Hci *hp)
{
	Ctlr *ctlr;
	Ecapio *capio;
	Eopio *opio;
	Uhh *uhh;
	static int beenhere;

	if (beenhere)
		return -1;
	beenhere = 1;

	if(getconf("*nousbehci") != nil || probeaddr(PHYSEHCI) &lt; 0)
		return -1;

	ctlr = smalloc(sizeof(Ctlr));
	/*
	 * don't bother with vmap; i/o space is all mapped anyway,
	 * and a size less than 1MB will blow an assertion in mmukmap.
	 */
	ctlr-&gt;capio = capio = (Ecapio *)PHYSEHCI;
	ctlr-&gt;opio = opio = (Eopio*)((uintptr)capio + (capio-&gt;cap &amp; 0xff));

	hp-&gt;aux = ctlr;
	hp-&gt;port = (uintptr)ctlr-&gt;capio;
	hp-&gt;irq = 77;
	hp-&gt;nports = capio-&gt;parms &amp; Cnports;

	ddprint("echi: %s, ncc %lud npcc %lud\n",
		capio-&gt;parms &amp; 0x10000 ? "leds" : "no leds",
		(capio-&gt;parms &gt;&gt; 12) &amp; 0xf, (capio-&gt;parms &gt;&gt; 8) &amp; 0xf);
	ddprint("ehci: routing %s, %sport power ctl, %d ports\n",
		capio-&gt;parms &amp; 0x40 ? "explicit" : "automatic",
		capio-&gt;parms &amp; 0x10 ? "" : "no ", hp-&gt;nports);

	ehcireset(ctlr);
	ehcimeminit(ctlr);

	/* omap35-specific set up */
	/* bit 5 `must be set to 1 for proper behavior', spruf98d §23.2.6.7.17 */
	opio-&gt;insn[4] |= 1&lt;&lt;5;
	coherence();

	/* insn[5] is for both utmi and ulpi, depending on hostconfig mode */
	uhh = (Uhh *)PHYSUHH;
	if (uhh-&gt;hostconfig &amp; P1ulpi_bypass) {		/* utmi port 1 active */
		/* not doing this */
		iprint("usbehci: bypassing ulpi on port 1!\n");
		opio-&gt;insn[5] &amp;= ~(MASK(4) &lt;&lt; 13);
		opio-&gt;insn[5] |= 1 &lt;&lt; 13;		/* select port 1 */
		coherence();
	} else {					/* ulpi port 1 active */
		/* TODO may need to reset gpio port2 here */

		/* disable integrated stp pull-up resistor */
		wrulpi(opio, 1, Ifcctlreg, Phystppullupoff);

		/* force phy to `high-speed' */
		wrulpi(opio, 1, Funcctlreg, 0x40);
	}

	/*
	 * Linkage to the generic HCI driver.
	 */
	ehcilinkage(hp);
	hp-&gt;shutdown = shutdown;
	hp-&gt;debug = setdebug;

	intrenable(78, hp-&gt;interrupt, hp, UNKNOWN, "usbtll");
	intrenable(92, hp-&gt;interrupt, hp, UNKNOWN, "usb otg");
	intrenable(93, hp-&gt;interrupt, hp, UNKNOWN, "usb otg dma");
	return 0;
}

void
usbehcilink(void)
{
	addhcitype("ehci", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

