<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ahci.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ahci.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * advanced host controller interface (sata)
 * © 2007  coraid, inc
 */

/* ata errors */
enum {
	Emed	= 1&lt;&lt;0,		/* media error */
	Enm	= 1&lt;&lt;1,		/* no media */
	Eabrt	= 1&lt;&lt;2,		/* abort */
	Emcr	= 1&lt;&lt;3,		/* media change request */
	Eidnf	= 1&lt;&lt;4,		/* no user-accessible address */
	Emc	= 1&lt;&lt;5,		/* media change */
	Eunc	= 1&lt;&lt;6,		/* data error */
	Ewp	= 1&lt;&lt;6,		/* write protect */
	Eicrc	= 1&lt;&lt;7,		/* interface crc error */

	Efatal	= Eidnf|Eicrc,	/* must sw reset */
};

/* ata status */
enum {
	ASerr	= 1&lt;&lt;0,		/* error */
	ASdrq	= 1&lt;&lt;3,		/* request */
	ASdf	= 1&lt;&lt;5,		/* fault */
	ASdrdy	= 1&lt;&lt;6,		/* ready */
	ASbsy	= 1&lt;&lt;7,		/* busy */

	ASobs	= 1&lt;&lt;1|1&lt;&lt;2|1&lt;&lt;4,
};

/* pci configuration */
enum {
	Abar	= 5,
};

/*
 * ahci memory configuration
 *
 * 0000-0023	generic host control
 * 0024-009f	reserved
 * 00a0-00ff	vendor specific.
 * 0100-017f	port 0
 * ...
 * 1080-1100	port 31
 */

/* cap bits: supported features */
enum {
	Hs64a	= 1&lt;&lt;31,	/* 64-bit addressing */
	Hsncq	= 1&lt;&lt;30,	/* ncq */
	Hssntf	= 1&lt;&lt;29,	/* snotification reg. */
	Hsmps	= 1&lt;&lt;28,	/* mech pres switch */
	Hsss	= 1&lt;&lt;27,	/* staggered spinup */
	Hsalp	= 1&lt;&lt;26,	/* aggressive link pm */
	Hsal	= 1&lt;&lt;25,	/* activity led */
	Hsclo	= 1&lt;&lt;24,	/* command-list override */
	Hiss	= 1&lt;&lt;20,	/* for interface speed */
//	Hsnzo	= 1&lt;&lt;19,
	Hsam	= 1&lt;&lt;18,	/* ahci-mode only */
	Hspm	= 1&lt;&lt;17,	/* port multiplier */
//	Hfbss	= 1&lt;&lt;16,
	Hpmb	= 1&lt;&lt;15,	/* multiple-block pio */
	Hssc	= 1&lt;&lt;14,	/* slumber state */
	Hpsc	= 1&lt;&lt;13,	/* partial-slumber state */
	Hncs	= 1&lt;&lt;8,		/* n command slots */
	Hcccs	= 1&lt;&lt;7,		/* coal */
	Hems	= 1&lt;&lt;6,		/* enclosure mgmt. */
	Hsxs	= 1&lt;&lt;5,		/* external sata */
	Hnp	= 1&lt;&lt;0,		/* n ports */
};

/* ghc bits */
enum {
	Hae	= 1&lt;&lt;31,	/* enable ahci */
	Hie	= 1&lt;&lt;1,		/* " interrupts */
	Hhr	= 1&lt;&lt;0,		/* hba reset */
};

typedef struct {
	ulong	cap;
	ulong	ghc;
	ulong	isr;
	ulong	pi;		/* ports implemented */
	ulong	ver;
	ulong	ccc;		/* coaleasing control */
	ulong	cccports;
	ulong	emloc;
	ulong	emctl;
} Ahba;

enum {
	Acpds	= 1&lt;&lt;31,	/* cold port detect status */
	Atfes	= 1&lt;&lt;30,	/* task file error status */
	Ahbfs	= 1&lt;&lt;29,	/* hba fatal */
	Ahbds	= 1&lt;&lt;28,	/* hba error (parity error) */
	Aifs	= 1&lt;&lt;27,	/* interface fatal  §6.1.2 */
	Ainfs	= 1&lt;&lt;26,	/* interface error (recovered) */
	Aofs	= 1&lt;&lt;24,	/* too many bytes from disk */
	Aipms	= 1&lt;&lt;23,	/* incorrect prt mul status */
	Aprcs	= 1&lt;&lt;22,	/* PhyRdy change status Pxserr.diag.n */
	Adpms	= 1&lt;&lt;7,		/* mechanical presence status */
	Apcs 	= 1&lt;&lt;6,		/* port connect  diag.x */
	Adps 	= 1&lt;&lt;5,		/* descriptor processed */
	Aufs 	= 1&lt;&lt;4,		/* unknown fis diag.f */
	Asdbs	= 1&lt;&lt;3,		/* set device bits fis received w/ i bit set */
	Adss	= 1&lt;&lt;2,		/* dma setup */
	Apio	= 1&lt;&lt;1,		/* pio setup fis */
	Adhrs	= 1&lt;&lt;0,		/* device to host register fis */

	IEM	= Acpds|Atfes|Ahbds|Ahbfs|Ahbds|Aifs|Ainfs|Aprcs|Apcs|Adps|
			Aufs|Asdbs|Adss|Adhrs,
	Ifatal	= Atfes|Ahbfs|Ahbds|Aifs,
};

/* serror bits */
enum {
	SerrX	= 1&lt;&lt;26,	/* exchanged */
	SerrF	= 1&lt;&lt;25,	/* unknown fis */
	SerrT	= 1&lt;&lt;24,	/* transition error */
	SerrS	= 1&lt;&lt;23,	/* link sequence */
	SerrH	= 1&lt;&lt;22,	/* handshake */
	SerrC	= 1&lt;&lt;21,	/* crc */
	SerrD	= 1&lt;&lt;20,	/* not used by ahci */
	SerrB	= 1&lt;&lt;19,	/* 10-tp-8 decode */
	SerrW	= 1&lt;&lt;18,	/* comm wake */
	SerrI	= 1&lt;&lt;17,	/* phy internal */
	SerrN	= 1&lt;&lt;16,	/* phyrdy change */

	ErrE	= 1&lt;&lt;11,	/* internal */
	ErrP	= 1&lt;&lt;10,	/* ata protocol violation */
	ErrC	= 1&lt;&lt;9,		/* communication */
	ErrT	= 1&lt;&lt;8,		/* transient */
	ErrM	= 1&lt;&lt;1,		/* recoverd comm */
	ErrI	= 1&lt;&lt;0,		/* recovered data integrety */

	ErrAll	= ErrE|ErrP|ErrC|ErrT|ErrM|ErrI,
	SerrAll	= SerrX|SerrF|SerrT|SerrS|SerrH|SerrC|SerrD|SerrB|SerrW|
			SerrI|SerrN|ErrAll,
	SerrBad	= 0x7f&lt;&lt;19,
};

/* cmd register bits */
enum {
	Aicc	= 1&lt;&lt;28,	/* interface communcations control. 4 bits */
	Aasp	= 1&lt;&lt;27,	/* aggressive slumber &amp; partial sleep */
	Aalpe 	= 1&lt;&lt;26,	/* aggressive link pm enable */
	Adlae	= 1&lt;&lt;25,	/* drive led on atapi */
	Aatapi	= 1&lt;&lt;24,	/* device is atapi */
	Aesp	= 1&lt;&lt;21,	/* external sata port */
	Acpd	= 1&lt;&lt;20,	/* cold presence detect */
	Ampsp	= 1&lt;&lt;19,	/* mechanical pres. */
	Ahpcp	= 1&lt;&lt;18,	/* hot plug capable */
	Apma	= 1&lt;&lt;17,	/* pm attached */
	Acps	= 1&lt;&lt;16,	/* cold presence state */
	Acr	= 1&lt;&lt;15,	/* cmdlist running */
	Afr	= 1&lt;&lt;14,	/* fis running */
	Ampss	= 1&lt;&lt;13,	/* mechanical presence switch state */
	Accs	= 1&lt;&lt;8,		/* current command slot 12:08 */
	Afre	= 1&lt;&lt;4,		/* fis enable receive */
	Aclo	= 1&lt;&lt;3,		/* command list override */
	Apod	= 1&lt;&lt;2,		/* power on dev (requires cold-pres. detect) */
	Asud	= 1&lt;&lt;1,		/* spin-up device;  requires ss capability */
	Ast	= 1&lt;&lt;0,		/* start */

	Arun	= Ast|Acr|Afre|Afr,
};

/* ctl register bits */
enum {
	Aipm	= 1&lt;&lt;8,		/* interface power mgmt. 3=off */
	Aspd	= 1&lt;&lt;4,
	Adet	= 1&lt;&lt;0,		/* device detection */
};

#define	sstatus	scr0
#define	sctl	scr2
#define	serror	scr1
#define	sactive	scr3

typedef struct {
	ulong	list;		/* PxCLB must be 1kb aligned. */
	ulong	listhi;
	ulong	fis;		/* 256-byte aligned */
	ulong	fishi;
	ulong	isr;
	ulong	ie;		/* interrupt enable */
	ulong	cmd;
	ulong	res1;
	ulong	task;
	ulong	sig;
	ulong	scr0;
	ulong	scr2;
	ulong	scr1;
	ulong	scr3;
	ulong	ci;		/* command issue */
	ulong	ntf;
	uchar	res2[8];
	ulong	vendor;
} Aport;

enum {
	/*
	 * Aport sstatus bits (actually states):
	 * 11-8 interface power management
	 *  7-4 current interface speed (generation #)
	 *  3-0 device detection
	 */
	Intslumber	= 0x600,
	Intpartpwr	= 0x200,
	Intactive	= 0x100,
	Intpm		= 0xf00,

	Devphyoffline	= 4,
	Devphycomm	= 2,		/* phy communication established */
	Devpresent	= 1,
	Devdet		= Devpresent | Devphycomm | Devphyoffline,
};

/* in host's memory; not memory mapped */
typedef struct {
	uchar	*base;
	uchar	*d;
	uchar	*p;
	uchar	*r;
	uchar	*u;
	ulong	*devicebits;
} Afis;

enum {
	Lprdtl	= 1&lt;&lt;16,	/* physical region descriptor table len */
	Lpmp	= 1&lt;&lt;12,	/* port multiplier port */
	Lclear	= 1&lt;&lt;10,	/* clear busy on R_OK */
	Lbist	= 1&lt;&lt;9,
	Lreset	= 1&lt;&lt;8,
	Lpref	= 1&lt;&lt;7,		/* prefetchable */
	Lwrite	= 1&lt;&lt;6,
	Latapi	= 1&lt;&lt;5,
	Lcfl	= 1&lt;&lt;0,		/* command fis length in double words */
};

/* in hosts memory; memory mapped */
typedef struct {
	ulong	flags;
	ulong	len;
	ulong	ctab;
	ulong	ctabhi;
	uchar	reserved[16];
} Alist;

typedef struct {
	ulong	dba;
	ulong	dbahi;
	ulong	pad;
	ulong	count;
} Aprdt;

typedef struct {
	uchar	cfis[0x40];
	uchar	atapi[0x10];
	uchar	pad[0x30];
	Aprdt	prdt;
} Actab;

enum {
	Ferror	= 1,
	Fdone	= 2,
};

enum {
	Dllba 	= 1,
	Dsmart	= 1&lt;&lt;1,
	Dpower	= 1&lt;&lt;2,
	Dnop	= 1&lt;&lt;3,
	Datapi	= 1&lt;&lt;4,
	Datapi16= 1&lt;&lt;5,
};

typedef struct {
	QLock;
	Rendez;
	uchar	flag;
	uchar	feat;
	uchar	smart;
	Afis	fis;
	Alist	*list;
	Actab	*ctab;
} Aportm;

typedef struct {
	Aport	*p;
	Aportm	*pm;
} Aportc;
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

