<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/devlml.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/devlml.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Lml 22 driver
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"io.h"

#include	"devlml.h"

#define DBGREAD	0x01
#define DBGWRIT	0x02
#define DBGINTR	0x04
#define DBGINTS	0x08
#define DBGFS	0x10

int debug = DBGREAD|DBGWRIT|DBGFS;

enum{
	Qdir,
	Qctl0,
	Qjpg0,
	Qraw0,
	Qctl1,
	Qjpg1,
	Qraw1,
};

static Dirtab lmldir[] = {
	".",		{Qdir, 0, QTDIR},	0,	0555,
	"lml0ctl",	{Qctl0},		0,	0666,
	"lml0jpg",	{Qjpg0},		0,	0444,
	"lml0raw",	{Qraw0},		0,	0444,
	"lml1ctl",	{Qctl1},		0,	0666,
	"lml1jpg",	{Qjpg1},		0,	0444,
	"lml1raw",	{Qraw1},		0,	0444,
};

typedef struct LML LML;

struct LML {
	/* Hardware */
	Pcidev	*pcidev;
	ulong	pciBaseAddr;

	/* Allocated memory */
	CodeData *codedata;

	/* Software state */
	ulong	jpgframeno;
	int	frameNo;
	Rendez	sleepjpg;
	int	jpgopens;
} lmls[NLML];

int nlml;

static FrameHeader jpgheader = {
	MRK_SOI, MRK_APP3, (sizeof(FrameHeader)-4) &lt;&lt; 8,
	{ 'L', 'M', 'L', '\0'},
	-1, 0, 0,  0
};

#define writel(v, a) *(ulong *)(a) = (v)
#define readl(a) *(ulong*)(a)

static int
getbuffer(void *x)
{
	static last = NBUF-1;
	int l = last;
	LML *lml;

	lml = x;
	for(;;){
		last = (last+1) % NBUF;
		if(lml-&gt;codedata-&gt;statCom[last] &amp; STAT_BIT)
			return last + 1;
		if(last == l)
			return 0;
	}
}

static long
jpgread(LML *lml, void *va, long nbytes, vlong, int dosleep)
{
	int bufno;
	FrameHeader *jpgheader;

	/*
	 * reads should be of size 1 or sizeof(FrameHeader).
	 * Frameno is the number of the buffer containing the data.
	 */
	while((bufno = getbuffer(lml)) == 0 &amp;&amp; dosleep)
		sleep(&amp;lml-&gt;sleepjpg, getbuffer, lml);
	if(--bufno &lt; 0)
		return 0;

	jpgheader = (FrameHeader*)(lml-&gt;codedata-&gt;frag[bufno].hdr+2);
	if(nbytes == sizeof(FrameHeader)){
		memmove(va, jpgheader, sizeof(FrameHeader));
		return sizeof(FrameHeader);
	}
	if(nbytes == 1){
		*(char *)va = bufno;
		return 1;
	}
	return 0;
}

static void lmlintr(Ureg *, void *);

static void
prepbuf(LML *lml)
{
	int i;
	CodeData *cd;

	cd = lml-&gt;codedata;
	for(i = 0; i &lt; NBUF; i++){
		cd-&gt;statCom[i] = PADDR(&amp;(cd-&gt;fragdesc[i]));
		cd-&gt;fragdesc[i].addr = PADDR(cd-&gt;frag[i].fb);
		/* Length is in double words, in position 1..20 */
		cd-&gt;fragdesc[i].leng = FRAGSIZE &gt;&gt; 1 | FRAGM_FINAL_B;
		memmove(cd-&gt;frag[i].hdr+2, &amp;jpgheader, sizeof(FrameHeader)-2);
	}
}

static void
lmlreset(void)
{
	ulong regpa;
	char name[32];
	void *regva;
	LML *lml;
	Pcidev *pcidev;
	Physseg segbuf;

	pcidev = nil;

	for(nlml = 0; nlml &lt; NLML &amp;&amp; (pcidev = pcimatch(pcidev, VENDOR_ZORAN,
	    ZORAN_36067)); nlml++){
		lml = &amp;lmls[nlml];
		lml-&gt;pcidev = pcidev;
		lml-&gt;codedata = (CodeData*)(((ulong)xalloc(Codedatasize+ BY2PG)
			+ BY2PG-1) &amp; ~(BY2PG-1));
		if(lml-&gt;codedata == nil){
			print("devlml: xalloc(%ux, %ux, 0)\n", Codedatasize, BY2PG);
			return;
		}

		print("Installing Motion JPEG driver %s, irq %d\n",
			MJPG_VERSION, pcidev-&gt;intl);
		print("MJPG buffer at 0x%.8p, size 0x%.8ux\n", lml-&gt;codedata,
			Codedatasize);

		/* Get access to DMA memory buffer */
		lml-&gt;codedata-&gt;pamjpg = PADDR(lml-&gt;codedata-&gt;statCom);

		prepbuf(lml);

		print("zr36067 found at 0x%.8lux", pcidev-&gt;mem[0].bar &amp; ~0x0F);

		regpa = pcidev-&gt;mem[0].bar &amp; ~0x0F;
		regva = vmap(regpa, pcidev-&gt;mem[0].size);
		if(regva == 0){
			print("lml: failed to map registers\n");
			return;
		}
		lml-&gt;pciBaseAddr = (ulong)regva;
		print(", mapped at 0x%.8lux\n", lml-&gt;pciBaseAddr);

		memset(&amp;segbuf, 0, sizeof(segbuf));
		segbuf.attr = SG_PHYSICAL;
		sprint(name, "lml%d.mjpg", nlml);
		kstrdup(&amp;segbuf.name, name);
		segbuf.pa = PADDR(lml-&gt;codedata);
		segbuf.size = Codedatasize;
		if(addphysseg(&amp;segbuf) == -1){
			print("lml: physsegment: %s\n", name);
			return;
		}

		memset(&amp;segbuf, 0, sizeof(segbuf));
		segbuf.attr = SG_PHYSICAL;
		sprint(name, "lml%d.regs", nlml);
		kstrdup(&amp;segbuf.name, name);
		segbuf.pa = (ulong)regpa;
		segbuf.size = pcidev-&gt;mem[0].size;
		if(addphysseg(&amp;segbuf) == -1){
			print("lml: physsegment: %s\n", name);
			return;
		}

		/* set up interrupt handler */
		intrenable(pcidev-&gt;intl, lmlintr, lml, pcidev-&gt;tbdf, "lml");
	}
}

static Chan*
lmlattach(char *spec)
{
	if(debug&amp;DBGFS)
		print("lmlattach\n");
	return devattach(L'Λ', spec);
}

static Walkqid*
lmlwalk(Chan *c, Chan *nc, char **name, int nname)
{
	if(debug&amp;DBGFS)
		print("lmlwalk\n");
	return devwalk(c, nc, name, nname, lmldir, 3*nlml+1, devgen);
}

static int
lmlstat(Chan *c, uchar *db, int n)
{
	if(debug&amp;DBGFS)
		print("lmlstat\n");
	return devstat(c, db, n, lmldir, 3*nlml+1, devgen);
}

static Chan*
lmlopen(Chan *c, int omode)
{
	int i;
	LML *lml;

	if(debug&amp;DBGFS)
		print("lmlopen\n");
	if(omode != OREAD)
		error(Eperm);
	c-&gt;aux = 0;
	i = 0;
	switch((ulong)c-&gt;qid.path){
	case Qctl1:
		i++;
		/* fall through */
	case Qctl0:
		if(i &gt;= nlml)
			error(Eio);
		break;
	case Qjpg1:
	case Qraw1:
		i++;
		/* fall through */
	case Qjpg0:
	case Qraw0:
		/* allow one open */
		if(i &gt;= nlml)
			error(Eio);
		lml = lmls+i;
		if(lml-&gt;jpgopens)
			error(Einuse);
		lml-&gt;jpgopens = 1;
		lml-&gt;jpgframeno = 0;
		prepbuf(lml);
		break;
	}
	return devopen(c, omode, lmldir, 3*nlml+1, devgen);
}

static void
lmlclose(Chan *c)
{
	int i;

	if(debug&amp;DBGFS)
		print("lmlclose\n");
	i = 0;
	switch((ulong)c-&gt;qid.path){
	case Qjpg1:
	case Qraw1:
		i++;
		/* fall through */
	case Qjpg0:
	case Qraw0:
		lmls[i].jpgopens = 0;
		break;
	}
}

static long
lmlread(Chan *c, void *va, long n, vlong voff)
{
	int i, len;
	long off = voff;
	uchar *buf = va;
	LML *lml;
	static char lmlinfo[1024];

	i = 0;
	switch((ulong)c-&gt;qid.path){
	case Qdir:
		n = devdirread(c, (char *)buf, n, lmldir, 3*nlml+1, devgen);
		if(debug&amp;(DBGFS|DBGREAD))
			print("lmlread %ld\n", n);
		return n;
	case Qctl1:
		i++;
		/* fall through */
	case Qctl0:
		if(i &gt;= nlml)
			error(Eio);
		lml = lmls+i;
		len = snprint(lmlinfo, sizeof lmlinfo, "lml%djpg	lml%draw\nlml%d.regs	0x%lux	0x%ux\nlml%d.mjpg	0x%lux	0x%ux\n",
			i, i,
			i, lml-&gt;pcidev-&gt;mem[0].bar &amp; ~0x0F, lml-&gt;pcidev-&gt;mem[0].size,
			i, PADDR(lml-&gt;codedata), Codedatasize);
		if(voff &gt; len)
			return 0;
		if(n &gt; len - voff)
			n = len - voff;
		memmove(va, lmlinfo+voff, n);
		return n;
	case Qjpg1:
		i++;
		/* fall through */
	case Qjpg0:
		if(i &gt;= nlml)
			error(Eio);
		return jpgread(lmls+i, buf, n, off, 1);
	case Qraw1:
		i++;
		/* fall through */
	case Qraw0:
		if(i &gt;= nlml)
			error(Eio);
		return jpgread(lmls+i, buf, n, off, 0);
	}
	return -1;
}

static long
lmlwrite(Chan *, void *, long, vlong)
{
	error(Eperm);
	return 0;
}

Dev lmldevtab = {
	L'Λ',
	"video",

	lmlreset,
	devinit,
	devshutdown,
	lmlattach,
	lmlwalk,
	lmlstat,
	lmlopen,
	devcreate,
	lmlclose,
	lmlread,
	devbread,
	lmlwrite,
	devbwrite,
	devremove,
	devwstat,
};

static void
lmlintr(Ureg *, void *x)
{
	ulong fstart, fno, flags, statcom;
	FrameHeader *jpgheader;
	LML *lml;

	lml = x;
	flags = readl(lml-&gt;pciBaseAddr+INTR_STAT);
	/* Reset all interrupts from 067 */
	writel(0xff000000, lml-&gt;pciBaseAddr + INTR_STAT);

	if(flags &amp; INTR_JPEGREP){

		if(debug&amp;DBGINTR)
			print("MjpgDrv_intrHandler stat=0x%.8lux\n", flags);

		fstart = lml-&gt;jpgframeno &amp; 3;
		for(;;){
			lml-&gt;jpgframeno++;
			fno = lml-&gt;jpgframeno &amp; 3;
			if(lml-&gt;codedata-&gt;statCom[fno] &amp; STAT_BIT)
				break;
			if(fno == fstart){
				if(debug &amp; DBGINTR)
					print("Spurious lml jpg intr?\n");
				return;
			}
		}
		statcom = lml-&gt;codedata-&gt;statCom[fno];
		jpgheader = (FrameHeader *)(lml-&gt;codedata-&gt;frag[fno].hdr + 2);
		jpgheader-&gt;frameNo = lml-&gt;jpgframeno;
		jpgheader-&gt;ftime  = todget(nil);
		jpgheader-&gt;frameSize = (statcom &amp; 0x00ffffff) &gt;&gt; 1;
		jpgheader-&gt;frameSeqNo = statcom &gt;&gt; 24;
		wakeup(&amp;lml-&gt;sleepjpg);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

