<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ether8139.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ether8139.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Realtek 8139 (but not the 8129).
 * Error recovery for the various over/under -flow conditions
 * may need work.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"

enum {					/* registers */
	Idr0		= 0x0000,	/* MAC address */
	Mar0		= 0x0008,	/* Multicast address */
	Tsd0		= 0x0010,	/* Transmit Status Descriptor0 */
	Tsad0		= 0x0020,	/* Transmit Start Address Descriptor0 */
	Rbstart		= 0x0030,	/* Receive Buffer Start Address */
	Erbcr		= 0x0034,	/* Early Receive Byte Count */
	Ersr		= 0x0036,	/* Early Receive Status */
	Cr		= 0x0037,	/* Command Register */
	Capr		= 0x0038,	/* Current Address of Packet Read */
	Cbr		= 0x003A,	/* Current Buffer Address */
	Imr		= 0x003C,	/* Interrupt Mask */
	Isr		= 0x003E,	/* Interrupt Status */
	Tcr		= 0x0040,	/* Transmit Configuration */
	Rcr		= 0x0044,	/* Receive Configuration */
	Tctr		= 0x0048,	/* Timer Count */
	Mpc		= 0x004C,	/* Missed Packet Counter */
	Cr9346		= 0x0050,	/* 9346 Command Register */
	Config0		= 0x0051,	/* Configuration Register 0 */
	Config1		= 0x0052,	/* Configuration Register 1 */
	TimerInt	= 0x0054,	/* Timer Interrupt */
	Msr		= 0x0058,	/* Media Status */
	Config3		= 0x0059,	/* Configuration Register 3 */
	Config4		= 0x005A,	/* Configuration Register 4 */
	Mulint		= 0x005C,	/* Multiple Interrupt Select */
	RerID		= 0x005E,	/* PCI Revision ID */
	Tsad		= 0x0060,	/* Transmit Status of all Descriptors */

	Bmcr		= 0x0062,	/* Basic Mode Control */
	Bmsr		= 0x0064,	/* Basic Mode Status */
	Anar		= 0x0066,	/* Auto-Negotiation Advertisment */
	Anlpar		= 0x0068,	/* Auto-Negotiation Link Partner */
	Aner		= 0x006A,	/* Auto-Negotiation Expansion */
	Dis		= 0x006C,	/* Disconnect Counter */
	Fcsc		= 0x006E,	/* False Carrier Sense Counter */
	Nwaytr		= 0x0070,	/* N-way Test */
	Rec		= 0x0072,	/* RX_ER Counter */
	Cscr		= 0x0074,	/* CS Configuration */
	Phy1parm	= 0x0078,	/* PHY Parameter 1 */
	Twparm		= 0x007C,	/* Twister Parameter */
	Phy2parm	= 0x0080,	/* PHY Parameter 2 */
};

enum {					/* Cr */
	Bufe		= 0x01,		/* Rx Buffer Empty */
	Te		= 0x04,		/* Transmitter Enable */
	Re		= 0x08,		/* Receiver Enable */
	Rst		= 0x10,		/* Software Reset */
};

enum {					/* Imr/Isr */
	Rok		= 0x0001,	/* Receive OK */
	Rer		= 0x0002,	/* Receive Error */
	Tok		= 0x0004,	/* Transmit OK */
	Ter		= 0x0008,	/* Transmit Error */
	Rxovw		= 0x0010,	/* Receive Buffer Overflow */
	PunLc		= 0x0020,	/* Packet Underrun or Link Change */
	Fovw		= 0x0040,	/* Receive FIFO Overflow */
	Clc		= 0x2000,	/* Cable Length Change */
	Timerbit	= 0x4000,	/* Timer */
	Serr		= 0x8000,	/* System Error */
};

enum {					/* Tcr */
	Clrabt		= 0x00000001,	/* Clear Abort */
	TxrrSHIFT	= 4,		/* Transmit Retry Count */
	TxrrMASK	= 0x000000F0,
	MtxdmaSHIFT	= 8,		/* Max. DMA Burst Size */
	MtxdmaMASK	= 0x00000700,
	Mtxdma2048	= 0x00000700,
	Acrc		= 0x00010000,	/* Append CRC (not) */
	LbkSHIFT	= 17,		/* Loopback Test */
	LbkMASK		= 0x00060000,
	Rtl8139ArevG	= 0x00800000,	/* RTL8139A Rev. G ID */
	IfgSHIFT	= 24,		/* Interframe Gap */
	IfgMASK		= 0x03000000,
	HwveridSHIFT	= 26,		/* Hardware Version ID */
	HwveridMASK	= 0x7C000000,
};

enum {					/* Rcr */
	Aap		= 0x00000001,	/* Accept All Packets */
	Apm		= 0x00000002,	/* Accept Physical Match */
	Am		= 0x00000004,	/* Accept Multicast */
	Ab		= 0x00000008,	/* Accept Broadcast */
	Ar		= 0x00000010,	/* Accept Runt */
	Aer		= 0x00000020,	/* Accept Error */
	Sel9356		= 0x00000040,	/* 9356 EEPROM used */
	Wrap		= 0x00000080,	/* Rx Buffer Wrap Control */
	MrxdmaSHIFT	= 8,		/* Max. DMA Burst Size */
	MrxdmaMASK	= 0x00000700,
	Mrxdmaunlimited	= 0x00000700,
	RblenSHIFT	= 11,		/* Receive Buffer Length */
	RblenMASK	= 0x00001800,
	Rblen8K		= 0x00000000,	/* 8KB+16 */
	Rblen16K	= 0x00000800,	/* 16KB+16 */
	Rblen32K	= 0x00001000,	/* 32KB+16 */
	Rblen64K	= 0x00001800,	/* 64KB+16 */
	RxfthSHIFT	= 13,		/* Receive Buffer Length */
	RxfthMASK	= 0x0000E000,
	Rxfth256	= 0x00008000,
	Rxfthnone	= 0x0000E000,
	Rer8		= 0x00010000,	/* Accept Error Packets &gt; 8 bytes */
	MulERINT	= 0x00020000,	/* Multiple Early Interrupt Select */
	ErxthSHIFT	= 24,		/* Early Rx Threshold */
	ErxthMASK	= 0x0F000000,
	Erxthnone	= 0x00000000,
};

enum {					/* Received Packet Status */
	Rcok		= 0x0001,	/* Receive Completed OK */
	Fae		= 0x0002,	/* Frame Alignment Error */
	Crc		= 0x0004,	/* CRC Error */
	Long		= 0x0008,	/* Long Packet */
	Runt		= 0x0010,	/* Runt Packet Received */
	Ise		= 0x0020,	/* Invalid Symbol Error */
	Bar		= 0x2000,	/* Broadcast Address Received */
	Pam		= 0x4000,	/* Physical Address Matched */
	Mar		= 0x8000,	/* Multicast Address Received */
};

enum {					/* Media Status Register */
	Rxpf		= 0x01,		/* Pause Flag */
	Txpf		= 0x02,		/* Pause Flag */
	Linkb		= 0x04,		/* Inverse of Link Status */
	Speed10		= 0x08,		/* 10Mbps */
	Auxstatus	= 0x10,		/* Aux. Power Present Status */
	Rxfce		= 0x40,		/* Receive Flow Control Enable */
	Txfce		= 0x80,		/* Transmit Flow Control Enable */
};

typedef struct Td Td;
struct Td {			/* Soft Transmit Descriptor */
	int	tsd;
	int	tsad;
	uchar*	data;
	Block*	bp;
};

enum {					/* Tsd0 */
	SizeSHIFT	= 0,		/* Descriptor Size */
	SizeMASK	= 0x00001FFF,
	Own		= 0x00002000,
	Tun		= 0x00004000,	/* Transmit FIFO Underrun */
	Tcok		= 0x00008000,	/* Transmit COmpleted OK */
	EtxthSHIFT	= 16,		/* Early Tx Threshold */
	EtxthMASK	= 0x001F0000,
	NccSHIFT	= 24,		/* Number of Collisions Count */
	NccMASK		= 0x0F000000,
	Cdh		= 0x10000000,	/* CD Heartbeat */
	Owc		= 0x20000000,	/* Out of Window Collision */
	Tabt		= 0x40000000,	/* Transmit Abort */
	Crs		= 0x80000000,	/* Carrier Sense Lost */
};

enum {
	Rblen		= Rblen64K,	/* Receive Buffer Length */
	Ntd		= 4,		/* Number of Transmit Descriptors */
	Tdbsz		= ROUNDUP(sizeof(Etherpkt), 4),
};

typedef struct Ctlr Ctlr;
typedef struct Ctlr {
	int	port;
	Pcidev*	pcidev;
	Ctlr*	next;
	int	active;
	int	id;

	QLock	alock;			/* attach */
	Lock	ilock;			/* init */
	void*	alloc;			/* base of per-Ctlr allocated data */

	int	pcie;			/* flag: pci-express device? */

	uvlong	mchash;			/* multicast hash */

	int	rcr;			/* receive configuration register */
	uchar*	rbstart;		/* receive buffer */
	int	rblen;			/* receive buffer length */
	int	ierrs;			/* receive errors */

	Lock	tlock;			/* transmit */
	Td	td[Ntd];
	int	ntd;			/* descriptors active */
	int	tdh;			/* host index into td */
	int	tdi;			/* interface index into td */
	int	etxth;			/* early transmit threshold */
	int	taligned;		/* packet required no alignment */
	int	tunaligned;		/* packet required alignment */

	int	dis;			/* disconnect counter */
	int	fcsc;			/* false carrier sense counter */
	int	rec;			/* RX_ER counter */
	uint	mcast;
} Ctlr;

static Ctlr* ctlrhead;
static Ctlr* ctlrtail;

#define csr8r(c, r)	(inb((c)-&gt;port+(r)))
#define csr16r(c, r)	(ins((c)-&gt;port+(r)))
#define csr32r(c, r)	(inl((c)-&gt;port+(r)))
#define csr8w(c, r, b)	(outb((c)-&gt;port+(r), (int)(b)))
#define csr16w(c, r, w)	(outs((c)-&gt;port+(r), (ushort)(w)))
#define csr32w(c, r, l)	(outl((c)-&gt;port+(r), (ulong)(l)))

static void
rtl8139promiscuous(void* arg, int on)
{
	Ether *edev;
	Ctlr * ctlr;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;ilock);

	if(on)
		ctlr-&gt;rcr |= Aap;
	else
		ctlr-&gt;rcr &amp;= ~Aap;
	csr32w(ctlr, Rcr, ctlr-&gt;rcr);
	iunlock(&amp;ctlr-&gt;ilock);
}

enum {
	/* everyone else uses 0x04c11db7, but they both produce the same crc */
	Etherpolybe = 0x04c11db6,
	Bytemask = (1&lt;&lt;8) - 1,
};

static ulong
ethercrcbe(uchar *addr, long len)
{
	int i, j;
	ulong c, crc, carry;

	crc = ~0UL;
	for (i = 0; i &lt; len; i++) {
		c = addr[i];
		for (j = 0; j &lt; 8; j++) {
			carry = ((crc &amp; (1UL &lt;&lt; 31))? 1: 0) ^ (c &amp; 1);
			crc &lt;&lt;= 1;
			c &gt;&gt;= 1;
			if (carry)
				crc = (crc ^ Etherpolybe) | carry;
		}
	}
	return crc;
}

static ulong
swabl(ulong l)
{
	return l&gt;&gt;24 | (l&gt;&gt;8) &amp; (Bytemask&lt;&lt;8) |
		(l&lt;&lt;8) &amp; (Bytemask&lt;&lt;16) | l&lt;&lt;24;
}

static void
rtl8139multicast(void* ether, uchar *eaddr, int add)
{
	Ether *edev;
	Ctlr *ctlr;

	if (!add)
		return;	/* ok to keep receiving on old mcast addrs */

	edev = ether;
	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;ilock);

	ctlr-&gt;mchash |= 1ULL &lt;&lt; (ethercrcbe(eaddr, Eaddrlen) &gt;&gt; 26);

	ctlr-&gt;rcr |= Am;
	csr32w(ctlr, Rcr, ctlr-&gt;rcr);

	/* pci-e variants reverse the order of the hash byte registers */
	if (0 &amp;&amp; ctlr-&gt;pcie) {
		csr32w(ctlr, Mar0,   swabl(ctlr-&gt;mchash&gt;&gt;32));
		csr32w(ctlr, Mar0+4, swabl(ctlr-&gt;mchash));
	} else {
		csr32w(ctlr, Mar0,   ctlr-&gt;mchash);
		csr32w(ctlr, Mar0+4, ctlr-&gt;mchash&gt;&gt;32);
	}

	iunlock(&amp;ctlr-&gt;ilock);
}

static long
rtl8139ifstat(Ether* edev, void* a, long n, ulong offset)
{
	int l;
	char *p;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	l = snprint(p, READSTR, "rcr %#8.8ux\n", ctlr-&gt;rcr);
	l += snprint(p+l, READSTR-l, "multicast %ud\n", ctlr-&gt;mcast);
	l += snprint(p+l, READSTR-l, "ierrs %d\n", ctlr-&gt;ierrs);
	l += snprint(p+l, READSTR-l, "etxth %d\n", ctlr-&gt;etxth);
	l += snprint(p+l, READSTR-l, "taligned %d\n", ctlr-&gt;taligned);
	l += snprint(p+l, READSTR-l, "tunaligned %d\n", ctlr-&gt;tunaligned);
	ctlr-&gt;dis += csr16r(ctlr, Dis);
	l += snprint(p+l, READSTR-l, "dis %d\n", ctlr-&gt;dis);
	ctlr-&gt;fcsc += csr16r(ctlr, Fcsc);
	l += snprint(p+l, READSTR-l, "fcscnt %d\n", ctlr-&gt;fcsc);
	ctlr-&gt;rec += csr16r(ctlr, Rec);
	l += snprint(p+l, READSTR-l, "rec %d\n", ctlr-&gt;rec);

	l += snprint(p+l, READSTR-l, "Tcr %#8.8lux\n", csr32r(ctlr, Tcr));
	l += snprint(p+l, READSTR-l, "Config0 %#2.2ux\n", csr8r(ctlr, Config0));
	l += snprint(p+l, READSTR-l, "Config1 %#2.2ux\n", csr8r(ctlr, Config1));
	l += snprint(p+l, READSTR-l, "Msr %#2.2ux\n", csr8r(ctlr, Msr));
	l += snprint(p+l, READSTR-l, "Config3 %#2.2ux\n", csr8r(ctlr, Config3));
	l += snprint(p+l, READSTR-l, "Config4 %#2.2ux\n", csr8r(ctlr, Config4));

	l += snprint(p+l, READSTR-l, "Bmcr %#4.4ux\n", csr16r(ctlr, Bmcr));
	l += snprint(p+l, READSTR-l, "Bmsr %#4.4ux\n", csr16r(ctlr, Bmsr));
	l += snprint(p+l, READSTR-l, "Anar %#4.4ux\n", csr16r(ctlr, Anar));
	l += snprint(p+l, READSTR-l, "Anlpar %#4.4ux\n", csr16r(ctlr, Anlpar));
	l += snprint(p+l, READSTR-l, "Aner %#4.4ux\n", csr16r(ctlr, Aner));
	l += snprint(p+l, READSTR-l, "Nwaytr %#4.4ux\n", csr16r(ctlr, Nwaytr));
	snprint(p+l, READSTR-l, "Cscr %#4.4ux\n", csr16r(ctlr, Cscr));
	n = readstr(offset, a, n, p);
	free(p);

	return n;
}

static int
rtl8139reset(Ctlr* ctlr)
{
	int timeo;

	/* stop interrupts */
	csr16w(ctlr, Imr, 0);
	csr16w(ctlr, Isr, ~0);
	csr32w(ctlr, TimerInt, 0);

	/*
	 * Soft reset the controller.
	 */
	csr8w(ctlr, Cr, Rst);
	for(timeo = 0; timeo &lt; 1000; timeo++){
		if(!(csr8r(ctlr, Cr) &amp; Rst))
			return 0;
		delay(1);
	}

	return -1;
}

static void
rtl8139halt(Ctlr* ctlr)
{
	int i;

	csr8w(ctlr, Cr, 0);
	csr16w(ctlr, Imr, 0);
	csr16w(ctlr, Isr, ~0);
	csr32w(ctlr, TimerInt, 0);

	for(i = 0; i &lt; Ntd; i++){
		if(ctlr-&gt;td[i].bp == nil)
			continue;
		freeb(ctlr-&gt;td[i].bp);
		ctlr-&gt;td[i].bp = nil;
	}
}

static void
rtl8139shutdown(Ether *edev)
{
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;ilock);
	rtl8139halt(ctlr);
	rtl8139reset(ctlr);
	iunlock(&amp;ctlr-&gt;ilock);
}

static void
rtl8139init(Ether* edev)
{
	int i;
	ulong r;
	Ctlr *ctlr;
	uchar *alloc;

	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;ilock);

	rtl8139halt(ctlr);

	/*
	 * MAC Address.
	 */
	r = (edev-&gt;ea[3]&lt;&lt;24)|(edev-&gt;ea[2]&lt;&lt;16)|(edev-&gt;ea[1]&lt;&lt;8)|edev-&gt;ea[0];
	csr32w(ctlr, Idr0, r);
	r = (edev-&gt;ea[5]&lt;&lt;8)|edev-&gt;ea[4];
	csr32w(ctlr, Idr0+4, r);

	/*
	 * Receiver
	 */
	alloc = (uchar*)ROUNDUP((ulong)ctlr-&gt;alloc, 32);
	ctlr-&gt;rbstart = alloc;
	alloc += ctlr-&gt;rblen+16;
	memset(ctlr-&gt;rbstart, 0, ctlr-&gt;rblen+16);
	csr32w(ctlr, Rbstart, PCIWADDR(ctlr-&gt;rbstart));
	ctlr-&gt;rcr = Rxfth256|Rblen|Mrxdmaunlimited|Ab|Am|Apm;

	/*
	 * Transmitter.
	 */
	for(i = 0; i &lt; Ntd; i++){
		ctlr-&gt;td[i].tsd = Tsd0+i*4;
		ctlr-&gt;td[i].tsad = Tsad0+i*4;
		ctlr-&gt;td[i].data = alloc;
		alloc += Tdbsz;
		ctlr-&gt;td[i].bp = nil;
	}
	ctlr-&gt;ntd = ctlr-&gt;tdh = ctlr-&gt;tdi = 0;
	ctlr-&gt;etxth = 128/32;

	/*
	 * Enable receiver/transmitter.
	 * Need to enable before writing the Rcr or it won't take.
	 */
	csr8w(ctlr, Cr, Te|Re);
	csr32w(ctlr, Tcr, Mtxdma2048);
	csr32w(ctlr, Rcr, ctlr-&gt;rcr);
	csr32w(ctlr, Mar0,   0);
	csr32w(ctlr, Mar0+4, 0);
	ctlr-&gt;mchash = 0;

	/*
	 * Interrupts.
	 */
	csr32w(ctlr, TimerInt, 0);
	csr16w(ctlr, Imr, Serr|Timerbit|Fovw|PunLc|Rxovw|Ter|Tok|Rer|Rok);
	csr32w(ctlr, Mpc, 0);

	iunlock(&amp;ctlr-&gt;ilock);
}

static void
rtl8139attach(Ether* edev)
{
	Ctlr *ctlr;

	if(edev == nil) {
		print("rtl8139attach: nil edev\n");
		return;
	}
	ctlr = edev-&gt;ctlr;
	if(ctlr == nil) {
		print("rtl8139attach: nil ctlr for Ether %#p\n", edev);
		return;
	}
	qlock(&amp;ctlr-&gt;alock);
	if(ctlr-&gt;alloc == nil){
		ctlr-&gt;rblen = 1&lt;&lt;((Rblen&gt;&gt;RblenSHIFT)+13);
		ctlr-&gt;alloc = malloc(ctlr-&gt;rblen+16 + Ntd*Tdbsz + 32);
		if(ctlr-&gt;alloc == nil) {
			qunlock(&amp;ctlr-&gt;alock);
			error(Enomem);
		}
		rtl8139init(edev);
	}
	qunlock(&amp;ctlr-&gt;alock);
}

static void
rtl8139txstart(Ether* edev)
{
	Td *td;
	int size;
	Block *bp;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	while(ctlr-&gt;ntd &lt; Ntd){
		bp = qget(edev-&gt;oq);
		if(bp == nil)
			break;
		size = BLEN(bp);

		td = &amp;ctlr-&gt;td[ctlr-&gt;tdh];
		if(((int)bp-&gt;rp) &amp; 0x03){
			memmove(td-&gt;data, bp-&gt;rp, size);
			freeb(bp);
			csr32w(ctlr, td-&gt;tsad, PCIWADDR(td-&gt;data));
			ctlr-&gt;tunaligned++;
		}
		else{
			td-&gt;bp = bp;
			csr32w(ctlr, td-&gt;tsad, PCIWADDR(bp-&gt;rp));
			ctlr-&gt;taligned++;
		}
		csr32w(ctlr, td-&gt;tsd, (ctlr-&gt;etxth&lt;&lt;EtxthSHIFT)|size);

		ctlr-&gt;ntd++;
		ctlr-&gt;tdh = NEXT(ctlr-&gt;tdh, Ntd);
	}
}

static void
rtl8139transmit(Ether* edev)
{
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;tlock);
	rtl8139txstart(edev);
	iunlock(&amp;ctlr-&gt;tlock);
}

static void
rtl8139receive(Ether* edev)
{
	Block *bp;
	Ctlr *ctlr;
	ushort capr;
	uchar cr, *p;
	int l, length, status;

	ctlr = edev-&gt;ctlr;

	/*
	 * Capr is where the host is reading from,
	 * Cbr is where the NIC is currently writing.
	 */
	if(ctlr-&gt;rblen == 0)
		return;		/* not attached yet (shouldn't happen) */
	capr = (csr16r(ctlr, Capr)+16) % ctlr-&gt;rblen;
	while(!(csr8r(ctlr, Cr) &amp; Bufe)){
		p = ctlr-&gt;rbstart+capr;

		/*
		 * Apparently the packet length may be 0xFFF0 if
		 * the NIC is still copying the packet into memory.
		 */
		length = (*(p+3)&lt;&lt;8)|*(p+2);
		if(length == 0xFFF0)
			break;
		status = (*(p+1)&lt;&lt;8)|*p;

		if(!(status &amp; Rcok)){
			if(status &amp; (Ise|Fae))
				edev-&gt;frames++;
			if(status &amp; Crc)
				edev-&gt;crcs++;
			if(status &amp; (Runt|Long))
				edev-&gt;buffs++;

			/*
			 * Reset the receiver.
			 * Also may have to restore the multicast list
			 * here too if it ever gets used.
			 */
			cr = csr8r(ctlr, Cr);
			csr8w(ctlr, Cr, cr &amp; ~Re);
			csr32w(ctlr, Rbstart, PCIWADDR(ctlr-&gt;rbstart));
			csr8w(ctlr, Cr, cr);
			csr32w(ctlr, Rcr, ctlr-&gt;rcr);

			continue;
		}

		/*
		 * Receive Completed OK.
		 * Very simplistic; there are ways this could be done
		 * without copying, but the juice probably isn't worth
		 * the squeeze.
		 * The packet length includes a 4 byte CRC on the end.
		 */
		capr = (capr+4) % ctlr-&gt;rblen;
		p = ctlr-&gt;rbstart+capr;
		capr = (capr+length) % ctlr-&gt;rblen;
		if(status &amp; Mar)
			ctlr-&gt;mcast++;

		if((bp = iallocb(length)) != nil){
			if(p+length &gt;= ctlr-&gt;rbstart+ctlr-&gt;rblen){
				l = ctlr-&gt;rbstart+ctlr-&gt;rblen - p;
				memmove(bp-&gt;wp, p, l);
				bp-&gt;wp += l;
				length -= l;
				p = ctlr-&gt;rbstart;
			}
			if(length &gt; 0){
				memmove(bp-&gt;wp, p, length);
				bp-&gt;wp += length;
			}
			bp-&gt;wp -= 4;
			etheriq(edev, bp, 1);
		}

		capr = ROUNDUP(capr, 4);
		csr16w(ctlr, Capr, capr-16);
	}
}

static void
rtl8139interrupt(Ureg*, void* arg)
{
	Td *td;
	Ctlr *ctlr;
	Ether *edev;
	int isr, msr, tsd;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	if(ctlr == nil) {	/* not attached yet? (shouldn't happen) */
		print("rtl8139interrupt: interrupt for unattached Ether %#p\n",
			edev);
		return;
	}

	while((isr = csr16r(ctlr, Isr)) != 0){
		csr16w(ctlr, Isr, isr);
		if(ctlr-&gt;alloc == nil) {
			print("rtl8139interrupt: interrupt for unattached Ctlr "
				"%#p port %#p\n", ctlr, (void *)ctlr-&gt;port);
			return;	/* not attached yet (shouldn't happen) */
		}
		if(isr &amp; (Fovw|PunLc|Rxovw|Rer|Rok)){
			rtl8139receive(edev);
			if(!(isr &amp; Rok))
				ctlr-&gt;ierrs++;
			isr &amp;= ~(Fovw|Rxovw|Rer|Rok);
		}

		if(isr &amp; (Ter|Tok)){
			ilock(&amp;ctlr-&gt;tlock);
			while(ctlr-&gt;ntd){
				td = &amp;ctlr-&gt;td[ctlr-&gt;tdi];
				tsd = csr32r(ctlr, td-&gt;tsd);
				if(!(tsd &amp; (Tabt|Tun|Tcok)))
					break;

				if(!(tsd &amp; Tcok)){
					if(tsd &amp; Tun){
						if(ctlr-&gt;etxth &lt; ETHERMAXTU/32)
							ctlr-&gt;etxth++;
					}
					edev-&gt;oerrs++;
				}

				if(td-&gt;bp != nil){
					freeb(td-&gt;bp);
					td-&gt;bp = nil;
				}

				ctlr-&gt;ntd--;
				ctlr-&gt;tdi = NEXT(ctlr-&gt;tdi, Ntd);
			}
			rtl8139txstart(edev);
			iunlock(&amp;ctlr-&gt;tlock);
			isr &amp;= ~(Ter|Tok);
		}

		if(isr &amp; PunLc){
			/*
			 * Maybe the link changed - do we care very much?
			 */
			msr = csr8r(ctlr, Msr);
			if(!(msr &amp; Linkb)){
				if(!(msr &amp; Speed10) &amp;&amp; edev-&gt;mbps != 100){
					edev-&gt;mbps = 100;
					qsetlimit(edev-&gt;oq, 256*1024);
				}
				else if((msr &amp; Speed10) &amp;&amp; edev-&gt;mbps != 10){
					edev-&gt;mbps = 10;
					qsetlimit(edev-&gt;oq, 65*1024);
				}
			}
			isr &amp;= ~(Clc|PunLc);
		}

		/*
		 * Only Serr|Timerbit should be left by now.
		 * Should anything be done to tidy up? TimerInt isn't
		 * used so that can be cleared. A PCI bus error is indicated
		 * by Serr, that's pretty serious; is there anyhing to do
		 * other than try to reinitialise the chip?
		 */
		if((isr &amp; (Serr|Timerbit)) != 0){
			iprint("rtl8139interrupt: imr %#4.4ux isr %#4.4ux\n",
				csr16r(ctlr, Imr), isr);
			if(isr &amp; Timerbit)
				csr32w(ctlr, TimerInt, 0);
			if(isr &amp; Serr)
				rtl8139init(edev);
		}
	}
}

static Ctlr*
rtl8139match(Ether* edev, int id)
{
	Pcidev *p;
	Ctlr *ctlr;
	int i, port;

	/*
	 * Any adapter matches if no edev-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	for(ctlr = ctlrhead; ctlr != nil; ctlr = ctlr-&gt;next){
		if(ctlr-&gt;active)
			continue;
		p = ctlr-&gt;pcidev;
		if(((p-&gt;did&lt;&lt;16)|p-&gt;vid) != id)
			continue;
		port = p-&gt;mem[0].bar &amp; ~0x01;
		if(edev-&gt;port != 0 &amp;&amp; edev-&gt;port != port)
			continue;

		if(ioalloc(port, p-&gt;mem[0].size, 0, "rtl8139") &lt; 0){
			print("rtl8139: port %#ux in use\n", port);
			continue;
		}

		if(pcigetpms(p) &gt; 0){
			pcisetpms(p, 0);
	
			for(i = 0; i &lt; 6; i++)
				pcicfgw32(p, PciBAR0+i*4, p-&gt;mem[i].bar);
			pcicfgw8(p, PciINTL, p-&gt;intl);
			pcicfgw8(p, PciLTR, p-&gt;ltr);
			pcicfgw8(p, PciCLS, p-&gt;cls);
			pcicfgw16(p, PciPCR, p-&gt;pcr);
		}

		ctlr-&gt;port = port;
		if(rtl8139reset(ctlr)) {
			iofree(port);
			continue;
		}
		pcisetbme(p);

		ctlr-&gt;active = 1;
		return ctlr;
	}
	return nil;
}

static struct {
	char*	name;
	int	id;
} rtl8139pci[] = {
	{ "rtl8139",	(0x8139&lt;&lt;16)|0x10EC, },	/* generic */
	{ "smc1211",	(0x1211&lt;&lt;16)|0x1113, },	/* SMC EZ-Card */
	{ "dfe-538tx",	(0x1300&lt;&lt;16)|0x1186, }, /* D-Link DFE-538TX */
	{ "dfe-560txd",	(0x1340&lt;&lt;16)|0x1186, }, /* D-Link DFE-560TXD */
	{ nil },
};

static int
rtl8139pnp(Ether* edev)
{
	int i, id;
	Pcidev *p;
	Ctlr *ctlr;
	uchar ea[Eaddrlen];

	/*
	 * Make a list of all ethernet controllers
	 * if not already done.
	 */
	if(ctlrhead == nil){
		p = nil;
		while(p = pcimatch(p, 0, 0)){
			if(p-&gt;ccrb != 0x02 || p-&gt;ccru != 0)
				continue;
			ctlr = malloc(sizeof(Ctlr));
			if(ctlr == nil)
				error(Enomem);
			ctlr-&gt;pcidev = p;
			ctlr-&gt;id = (p-&gt;did&lt;&lt;16)|p-&gt;vid;

			if(ctlrhead != nil)
				ctlrtail-&gt;next = ctlr;
			else
				ctlrhead = ctlr;
			ctlrtail = ctlr;
		}
	}

	/*
	 * Is it an RTL8139 under a different name?
	 * Normally a search is made through all the found controllers
	 * for one which matches any of the known vid+did pairs.
	 * If a vid+did pair is specified a search is made for that
	 * specific controller only.
	 */
	id = 0;
	for(i = 0; i &lt; edev-&gt;nopt; i++){
		if(cistrncmp(edev-&gt;opt[i], "id=", 3) == 0)
			id = strtol(&amp;edev-&gt;opt[i][3], nil, 0);
	}

	ctlr = nil;
	if(id != 0)
		ctlr = rtl8139match(edev, id);
	else for(i = 0; rtl8139pci[i].name; i++){
		if((ctlr = rtl8139match(edev, rtl8139pci[i].id)) != nil)
			break;
	}
	if(ctlr == nil)
		return -1;

	edev-&gt;ctlr = ctlr;
	edev-&gt;port = ctlr-&gt;port;
	edev-&gt;irq = ctlr-&gt;pcidev-&gt;intl;
	edev-&gt;tbdf = ctlr-&gt;pcidev-&gt;tbdf;

	/*
	 * Check if the adapter's station address is to be overridden.
	 * If not, read it from the device and set in edev-&gt;ea.
	 */
	memset(ea, 0, Eaddrlen);
	if(memcmp(ea, edev-&gt;ea, Eaddrlen) == 0){
		i = csr32r(ctlr, Idr0);
		edev-&gt;ea[0] = i;
		edev-&gt;ea[1] = i&gt;&gt;8;
		edev-&gt;ea[2] = i&gt;&gt;16;
		edev-&gt;ea[3] = i&gt;&gt;24;
		i = csr32r(ctlr, Idr0+4);
		edev-&gt;ea[4] = i;
		edev-&gt;ea[5] = i&gt;&gt;8;
	}

	edev-&gt;arg = edev;
	edev-&gt;attach = rtl8139attach;
	edev-&gt;transmit = rtl8139transmit;
	edev-&gt;interrupt = rtl8139interrupt;
	edev-&gt;ifstat = rtl8139ifstat;

	edev-&gt;promiscuous = rtl8139promiscuous;
	edev-&gt;multicast = rtl8139multicast;
	edev-&gt;shutdown = rtl8139shutdown;

	/*
	 * This should be much more dynamic but will do for now.
	 */
	if((csr8r(ctlr, Msr) &amp; (Speed10|Linkb)) == 0)
		edev-&gt;mbps = 100;

	return 0;
}

void
ether8139link(void)
{
	addethercard("rtl8139", rtl8139pnp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

