<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ether83815.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ether83815.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * National Semiconductor DP83815
 *
 * Supports only internal PHY and has been tested on:
 *	Netgear FA311TX (using Netgear DS108 10/100 hub)
 *	SiS 900 within SiS 630
 * To do:
 *	check Ethernet address;
 *	test autonegotiation on 10 Mbit, and 100 Mbit full duplex;
 *	external PHY via MII (should be common code for MII);
 *	thresholds;
 *	ring sizing;
 *	physical link changes/disconnect;
 *	push initialisation back to attach.
 *
 * C H Forsyth, forsyth@vitanuova.com, 18th June 2001.
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"

#define DEBUG		0
#define debug		if(DEBUG)print

enum {
	Nrde		= 64,
	Ntde		= 64,
};

#define Rbsz		ROUNDUP(sizeof(Etherpkt)+4, 4)

typedef struct Des {
	ulong	next;
	int	cmdsts;
	ulong	addr;
	Block*	bp;
} Des;

enum {	/* cmdsts */
	Own	= 1&lt;&lt;31,	/* set by data producer to hand to consumer */
	More	= 1&lt;&lt;30,	/* more of packet in next descriptor */
	Intr	= 1&lt;&lt;29,	/* interrupt when device is done with it */
	Supcrc	= 1&lt;&lt;28,	/* suppress crc on transmit */
	Inccrc	= 1&lt;&lt;28,	/* crc included on receive (always) */
	Ok	= 1&lt;&lt;27,	/* packet ok */
	Size	= 0xFFF,	/* packet size in bytes */

	/* transmit */
	Txa	= 1&lt;&lt;26,	/* transmission aborted */
	Tfu	= 1&lt;&lt;25,	/* transmit fifo underrun */
	Crs	= 1&lt;&lt;24,	/* carrier sense lost */
	Td	= 1&lt;&lt;23,	/* transmission deferred */
	Ed	= 1&lt;&lt;22,	/* excessive deferral */
	Owc	= 1&lt;&lt;21,	/* out of window collision */
	Ec	= 1&lt;&lt;20,	/* excessive collisions */
	/* 19-16 collision count */

	/* receive */
	Rxa	= 1&lt;&lt;26,	/* receive aborted (same as Rxo) */
	Rxo	= 1&lt;&lt;25,	/* receive overrun */
	Dest	= 3&lt;&lt;23,	/* destination class */
	  Drej=	0&lt;&lt;23,		/* packet was rejected */
	  Duni=	1&lt;&lt;23,		/* unicast */
	  Dmulti=	2&lt;&lt;23,		/* multicast */
	  Dbroad=	3&lt;&lt;23,		/* broadcast */
	Long = 1&lt;&lt;22,		/* too long packet received */
	Runt =  1&lt;&lt;21,		/* packet less than 64 bytes */
	Ise =	1&lt;&lt;20,		/* invalid symbol */
	Crce =	1&lt;&lt;19,		/* invalid crc */
	Fae =	1&lt;&lt;18,		/* frame alignment error */
	Lbp =	1&lt;&lt;17,		/* loopback packet */
	Col =	1&lt;&lt;16,		/* collision during receive */
};

enum {				/* PCI vendor &amp; device IDs */
	Nat83815	= (0x0020&lt;&lt;16)|0x100B,
	SiS = 	0x1039,
	SiS900 =	(0x0900&lt;&lt;16)|SiS,
	SiS7016 =	(0x7016&lt;&lt;16)|SiS,

	SiS630bridge	= 0x0008,

	/* SiS 900 PCI revision codes */
	SiSrev630s =	0x81,
	SiSrev630e =	0x82,
	SiSrev630ea1 =	0x83,

	SiSeenodeaddr =	8,		/* short addr of SiS eeprom mac addr */
	SiS630eenodeaddr =	9,	/* likewise for the 630 */
	Nseenodeaddr =	6,		/* " for NS eeprom */
	Nat83815avng =	0x403,
	Nat83816avng =	0x505,		/* 83816 acts like submodel of 83815 */
					/* using reg. 0x58 to disambiguate. */
};

typedef struct Ctlr Ctlr;
typedef struct Ctlr {
	int	port;
	Pcidev*	pcidev;
	Ctlr*	next;
	int	active;
	int	id;			/* (pcidev-&gt;did&lt;&lt;16)|pcidev-&gt;vid */

	ushort	srom[0xB+1];
	uchar	sromea[Eaddrlen];	/* MAC address */

	uchar	fd;			/* option or auto negotiation */

	int	mbps;

	Lock	lock;

	Des*	rdr;			/* receive descriptor ring */
	int	nrdr;			/* size of rdr */
	int	rdrx;			/* index into rdr */

	Lock	tlock;
	Des*	tdr;			/* transmit descriptor ring */
	int	ntdr;			/* size of tdr */
	int	tdrh;			/* host index into tdr */
	int	tdri;			/* interface index into tdr */
	int	ntq;			/* descriptors active */
	int	ntqmax;

	ulong	rxa;			/* receive statistics */
	ulong	rxo;
	ulong	rlong;
	ulong	runt;
	ulong	ise;
	ulong	crce;
	ulong	fae;
	ulong	lbp;
	ulong	col;
	ulong	rxsovr;
	ulong	rxorn;

	ulong	txa;			/* transmit statistics */
	ulong	tfu;
	ulong	crs;
	ulong	td;
	ulong	ed;
	ulong	owc;
	ulong	ec;
	ulong	txurn;

	ulong	dperr;			/* system errors */
	ulong	rmabt;
	ulong	rtabt;
	ulong	sserr;
	ulong	rxsover;

	ulong	version;		/* silicon version; register 0x58h */
} Ctlr;

static Ctlr* ctlrhead;
static Ctlr* ctlrtail;

enum {
	/* registers (could memory map) */
	Rcr=	0x00,		/* command register */
	  Rst=		1&lt;&lt;8,
	  Rxr=		1&lt;&lt;5,	/* receiver reset */
	  Txr=		1&lt;&lt;4,	/* transmitter reset */
	  Rxd=		1&lt;&lt;3,	/* receiver disable */
	  Rxe=		1&lt;&lt;2,	/* receiver enable */
	  Txd=		1&lt;&lt;1,	/* transmitter disable */
	  Txe=		1&lt;&lt;0,	/* transmitter enable */
	Rcfg=	0x04,		/* configuration */
	  Lnksts=	1&lt;&lt;31,	/* link good */
	  Speed100=	1&lt;&lt;30,	/* 100 Mb/s link */
	  Fdup=		1&lt;&lt;29,	/* full duplex */
	  Pol=		1&lt;&lt;28,	/* polarity reversal (10baseT) */
	  Aneg_dn=	1&lt;&lt;27,	/* autonegotiation done */
	  Pint_acen=	1&lt;&lt;17,	/* PHY interrupt auto clear enable */
	  Pause_adv=	1&lt;&lt;16,	/* advertise pause during auto neg */
	  Paneg_ena=	1&lt;&lt;13,	/* auto negotiation enable */
	  Paneg_all=	7&lt;&lt;13,	/* auto negotiation enable 10/100 half &amp; full */
	  Ext_phy=	1&lt;&lt;12,	/* enable MII for external PHY */
	  Phy_rst=	1&lt;&lt;10,	/* reset internal PHY */
	  Phy_dis=	1&lt;&lt;9,	/* disable internal PHY (eg, low power) */
	  Req_alg=	1&lt;&lt;7,	/* PCI bus request: set means less aggressive */
	  Sb=		1&lt;&lt;6,	/* single slot back-off not random */
	  Pow=		1&lt;&lt;5,	/* out of window timer selection */
	  Exd=		1&lt;&lt;4,	/* disable excessive deferral timer */
	  Pesel=	1&lt;&lt;3,	/* parity error algorithm selection */
	  Brom_dis=	1&lt;&lt;2,	/* disable boot rom interface */
	  Bem=		1&lt;&lt;0,	/* big-endian mode */
	Rmear=	0x08,		/* eeprom access */
	  Mdc=		1&lt;&lt;6,	/* MII mangement check */
	  Mddir=	1&lt;&lt;5,	/* MII management direction */
	  Mdio=		1&lt;&lt;4,	/* MII mangement data */
	  Eesel=	1&lt;&lt;3,	/* EEPROM chip select */
	  Eeclk=	1&lt;&lt;2,	/* EEPROM clock */
	  Eedo=		1&lt;&lt;1,	/* EEPROM data out (from chip) */
	  Eedi=		1&lt;&lt;0,	/* EEPROM data in (to chip) */
	Rptscr=	0x0C,		/* pci test control */
	Risr=	0x10,		/* interrupt status */
	  Txrcmp=	1&lt;&lt;25,	/* transmit reset complete */
	  Rxrcmp=	1&lt;&lt;24,	/* receiver reset complete */
	  Dperr=	1&lt;&lt;23,	/* detected parity error */
	  Sserr=	1&lt;&lt;22,	/* signalled system error */
	  Rmabt=	1&lt;&lt;21,	/* received master abort */
	  Rtabt=	1&lt;&lt;20,	/* received target abort */
	  Rxsovr=	1&lt;&lt;16,	/* RX status FIFO overrun */
	  Hiberr=	1&lt;&lt;15,	/* high bits error set (OR of 25-16) */
	  Phy=		1&lt;&lt;14,	/* PHY interrupt */
	  Pme=		1&lt;&lt;13,	/* power management event (wake online) */
	  Swi=		1&lt;&lt;12,	/* software interrupt */
	  Mib=		1&lt;&lt;11,	/* MIB service */
	  Txurn=	1&lt;&lt;10,	/* TX underrun */
	  Txidle=	1&lt;&lt;9,	/* TX idle */
	  Txerr=	1&lt;&lt;8,	/* TX packet error */
	  Txdesc=	1&lt;&lt;7,	/* TX descriptor (with Intr bit done) */
	  Txok=		1&lt;&lt;6,	/* TX ok */
	  Rxorn=	1&lt;&lt;5,	/* RX overrun */
	  Rxidle=	1&lt;&lt;4,	/* RX idle */
	  Rxearly=	1&lt;&lt;3,	/* RX early threshold */
	  Rxerr=	1&lt;&lt;2,	/* RX packet error */
	  Rxdesc=	1&lt;&lt;1,	/* RX descriptor (with Intr bit done) */
	  Rxok=		1&lt;&lt;0,	/* RX ok */
	Rimr=	0x14,		/* interrupt mask */
	Rier=	0x18,		/* interrupt enable */
	  Ie=		1&lt;&lt;0,	/* interrupt enable */
	Rtxdp=	0x20,		/* transmit descriptor pointer */
	Rtxcfg=	0x24,		/* transmit configuration */
	  Csi=		1&lt;&lt;31,	/* carrier sense ignore (needed for full duplex) */
	  Hbi=		1&lt;&lt;30,	/* heartbeat ignore (needed for full duplex) */
	  Atp=		1&lt;&lt;28,	/* automatic padding of runt packets */
	  Mxdma=	7&lt;&lt;20,	/* maximum dma transfer field */
	  Mxdma32=	4&lt;&lt;20,	/* 4x32-bit words (32 bytes) */
	  Mxdma64=	5&lt;&lt;20,	/* 8x32-bit words (64 bytes) */
	  Flth=		0x3F&lt;&lt;8,/* Tx fill threshold, units of 32 bytes (must be &gt; Mxdma) */
	  Drth=		0x3F&lt;&lt;0,/* Tx drain threshold (units of 32 bytes) */
	  Flth128=	4&lt;&lt;8,	/* fill at 128 bytes */
	  Drth512=	16&lt;&lt;0,	/* drain at 512 bytes */
	Rrxdp=	0x30,		/* receive descriptor pointer */
	Rrxcfg=	0x34,		/* receive configuration */
	  Atx=		1&lt;&lt;28,	/* accept transmit packets (needed for full duplex) */
	  Rdrth=	0x1F&lt;&lt;1,/* Rx drain threshold (units of 32 bytes) */
	  Rdrth64=	2&lt;&lt;1,	/* drain at 64 bytes */
	Rccsr=	0x3C,		/* CLKRUN control/status */
	  Pmests=	1&lt;&lt;15,	/* PME status */
	Rwcsr=	0x40,		/* wake on lan control/status */
	Rpcr=	0x44,		/* pause control/status */
	Rrfcr=	0x48,		/* receive filter/match control */
	  Rfen=		1&lt;&lt;31,	/* receive filter enable */
	  Aab=		1&lt;&lt;30,	/* accept all broadcast */
	  Aam=		1&lt;&lt;29,	/* accept all multicast */
	  Aau=		1&lt;&lt;28,	/* accept all unicast */
	  Apm=		1&lt;&lt;27,	/* accept on perfect match */
	  Apat=		0xF&lt;&lt;23,/* accept on pattern match */
	  Aarp=		1&lt;&lt;22,	/* accept ARP */
	  Mhen=		1&lt;&lt;21,	/* multicast hash enable */
	  Uhen=		1&lt;&lt;20,	/* unicast hash enable */
	  Ulm=		1&lt;&lt;19,	/* U/L bit mask */
				/* bits 0-9 are rfaddr */
	Rrfdr=	0x4C,		/* receive filter/match data */
	Rbrar=	0x50,		/* boot rom address */
	Rbrdr=	0x54,		/* boot rom data */
	Rsrr=	0x58,		/* silicon revision */
	Rmibc=	0x5C,		/* MIB control */
				/* 60-78 MIB data */

	/* PHY registers */
	Rbmcr=	0x80,		/* basic mode configuration */
	  Reset=	1&lt;&lt;15,
	  Sel100=	1&lt;&lt;13,	/* select 100Mb/sec if no auto neg */
	  Anena=	1&lt;&lt;12,	/* auto negotiation enable */
	  Anrestart=	1&lt;&lt;9,	/* restart auto negotiation */
	  Selfdx=	1&lt;&lt;8,	/* select full duplex if no auto neg */
	Rbmsr=	0x84,		/* basic mode status */
	  Ancomp=	1&lt;&lt;5,	/* autonegotiation complete */
	Rphyidr1= 0x88,
	Rphyidr2= 0x8C,
	Ranar=	0x90,		/* autonegotiation advertisement */
	Ranlpar= 0x94,		/* autonegotiation link partner ability */
	Raner=	0x98,		/* autonegotiation expansion */
	Rannptr= 0x9C,		/* autonegotiation next page TX */
	Rphysts= 0xC0,		/* PHY status */
	Rmicr=	0xC4,		/* MII control */
	  Inten=	1&lt;&lt;1,	/* PHY interrupt enable */
	Rmisr=	0xC8,		/* MII status */
	Rfcscr=	0xD0,		/* false carrier sense counter */
	Rrecr=	0xD4,		/* receive error counter */
	Rpcsr=	0xD8,		/* 100Mb config/status */
	Rphycr=	0xE4,		/* PHY control */
	Rtbscr=	0xE8,		/* 10BaseT status/control */
};

/*
 * eeprom addresses
 * 	7 to 9 (16 bit words): mac address, shifted and reversed
 */

#define csr32r(c, r)	(inl((c)-&gt;port+(r)))
#define csr32w(c, r, l)	(outl((c)-&gt;port+(r), (ulong)(l)))
#define csr16r(c, r)	(ins((c)-&gt;port+(r)))
#define csr16w(c, r, l)	(outs((c)-&gt;port+(r), (ulong)(l)))

static void
dumpcregs(Ctlr *ctlr)
{
	int i;

	for(i=0; i&lt;=0x5C; i+=4)
		print("%2.2ux %8.8lux\n", i, csr32r(ctlr, i));
}

static void
promiscuous(void* arg, int on)
{
	Ctlr *ctlr;
	ulong w;

	ctlr = ((Ether*)arg)-&gt;ctlr;
	ilock(&amp;ctlr-&gt;lock);
	w = csr32r(ctlr, Rrfcr);
	if(on != ((w&amp;Aau)!=0)){
		csr32w(ctlr, Rrfcr, w &amp; ~Rfen);
		csr32w(ctlr, Rrfcr, Rfen | (w ^ Aau));
	}
	iunlock(&amp;ctlr-&gt;lock);
}

static void
attach(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(&amp;ctlr-&gt;lock);
	if(0)
		dumpcregs(ctlr);
	csr32w(ctlr, Rcr, Rxe);
	iunlock(&amp;ctlr-&gt;lock);
}

static long
ifstat(Ether* ether, void* a, long n, ulong offset)
{
	Ctlr *ctlr;
	char *buf, *p;
	int i, l, len;

	ctlr = ether-&gt;ctlr;

	ether-&gt;crcs = ctlr-&gt;crce;
	ether-&gt;frames = ctlr-&gt;runt+ctlr-&gt;ise+ctlr-&gt;rlong+ctlr-&gt;fae;
	ether-&gt;buffs = ctlr-&gt;rxorn+ctlr-&gt;tfu;
	ether-&gt;overflows = ctlr-&gt;rxsovr;

	if(n == 0)
		return 0;

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	l = snprint(p, READSTR, "Rxa: %lud\n", ctlr-&gt;rxa);
	l += snprint(p+l, READSTR-l, "Rxo: %lud\n", ctlr-&gt;rxo);
	l += snprint(p+l, READSTR-l, "Rlong: %lud\n", ctlr-&gt;rlong);
	l += snprint(p+l, READSTR-l, "Runt: %lud\n", ctlr-&gt;runt);
	l += snprint(p+l, READSTR-l, "Ise: %lud\n", ctlr-&gt;ise);
	l += snprint(p+l, READSTR-l, "Fae: %lud\n", ctlr-&gt;fae);
	l += snprint(p+l, READSTR-l, "Lbp: %lud\n", ctlr-&gt;lbp);
	l += snprint(p+l, READSTR-l, "Tfu: %lud\n", ctlr-&gt;tfu);
	l += snprint(p+l, READSTR-l, "Txa: %lud\n", ctlr-&gt;txa);
	l += snprint(p+l, READSTR-l, "CRC Error: %lud\n", ctlr-&gt;crce);
	l += snprint(p+l, READSTR-l, "Collision Seen: %lud\n", ctlr-&gt;col);
	l += snprint(p+l, READSTR-l, "Frame Too Long: %lud\n", ctlr-&gt;rlong);
	l += snprint(p+l, READSTR-l, "Runt Frame: %lud\n", ctlr-&gt;runt);
	l += snprint(p+l, READSTR-l, "Rx Underflow Error: %lud\n", ctlr-&gt;rxorn);
	l += snprint(p+l, READSTR-l, "Tx Underrun: %lud\n", ctlr-&gt;txurn);
	l += snprint(p+l, READSTR-l, "Excessive Collisions: %lud\n", ctlr-&gt;ec);
	l += snprint(p+l, READSTR-l, "Late Collision: %lud\n", ctlr-&gt;owc);
	l += snprint(p+l, READSTR-l, "Loss of Carrier: %lud\n", ctlr-&gt;crs);
	l += snprint(p+l, READSTR-l, "Parity: %lud\n", ctlr-&gt;dperr);
	l += snprint(p+l, READSTR-l, "Aborts: %lud\n", ctlr-&gt;rmabt+ctlr-&gt;rtabt);
	l += snprint(p+l, READSTR-l, "RX Status overrun: %lud\n", ctlr-&gt;rxsover);
	snprint(p+l, READSTR-l, "ntqmax: %d\n", ctlr-&gt;ntqmax);
	ctlr-&gt;ntqmax = 0;
	buf = a;
	len = readstr(offset, buf, n, p);
	if(offset &gt; l)
		offset -= l;
	else
		offset = 0;
	buf += len;
	n -= len;

	l = snprint(p, READSTR, "srom:");
	for(i = 0; i &lt; nelem(ctlr-&gt;srom); i++){
		if(i &amp;&amp; ((i &amp; 0x0F) == 0))
			l += snprint(p+l, READSTR-l, "\n     ");
		l += snprint(p+l, READSTR-l, " %4.4uX", ctlr-&gt;srom[i]);
	}

	snprint(p+l, READSTR-l, "\n");
	len += readstr(offset, buf, n, p);
	free(p);

	return len;
}

static void
txstart(Ether* ether)
{
	Ctlr *ctlr;
	Block *bp;
	Des *des;
	int started;

	ctlr = ether-&gt;ctlr;
	started = 0;
	while(ctlr-&gt;ntq &lt; ctlr-&gt;ntdr-1){
		bp = qget(ether-&gt;oq);
		if(bp == nil)
			break;
		des = &amp;ctlr-&gt;tdr[ctlr-&gt;tdrh];
		des-&gt;bp = bp;
		des-&gt;addr = PADDR(bp-&gt;rp);
		ctlr-&gt;ntq++;
		coherence();
		des-&gt;cmdsts = Own | BLEN(bp);
		ctlr-&gt;tdrh = NEXT(ctlr-&gt;tdrh, ctlr-&gt;ntdr);
		started = 1;
	}
	if(started){
		coherence();
		csr32w(ctlr, Rcr, Txe);	/* prompt */
	}

	if(ctlr-&gt;ntq &gt; ctlr-&gt;ntqmax)
		ctlr-&gt;ntqmax = ctlr-&gt;ntq;
}

static void
transmit(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(&amp;ctlr-&gt;tlock);
	txstart(ether);
	iunlock(&amp;ctlr-&gt;tlock);
}

static void
txrxcfg(Ctlr *ctlr, int txdrth)
{
	ulong rx, tx;

	rx = csr32r(ctlr, Rrxcfg);
	tx = csr32r(ctlr, Rtxcfg);
	if(ctlr-&gt;fd){
		rx |= Atx;
		tx |= Csi | Hbi;
	}else{
		rx &amp;= ~Atx;
		tx &amp;= ~(Csi | Hbi);
	}
	tx &amp;= ~(Mxdma|Drth|Flth);
	tx |= Mxdma64 | Flth128 | txdrth;
	csr32w(ctlr, Rtxcfg, tx);
	rx &amp;= ~(Mxdma|Rdrth);
	rx |= Mxdma64 | Rdrth64;
	csr32w(ctlr, Rrxcfg, rx);
}

static void
interrupt(Ureg*, void* arg)
{
	int len, status, cmdsts, n;
	Ctlr *ctlr;
	Ether *ether;
	Des *des;
	Block *bp;

	ether = arg;
	ctlr = ether-&gt;ctlr;

	while((status = csr32r(ctlr, Risr)) != 0){

		status &amp;= ~(Pme|Mib);

		if(status &amp; Hiberr){
			if(status &amp; Rxsovr)
				ctlr-&gt;rxsover++;
			if(status &amp; Sserr)
				ctlr-&gt;sserr++;
			if(status &amp; Dperr)
				ctlr-&gt;dperr++;
			if(status &amp; Rmabt)
				ctlr-&gt;rmabt++;
			if(status &amp; Rtabt)
				ctlr-&gt;rtabt++;
			status &amp;= ~(Hiberr|Txrcmp|Rxrcmp|Rxsovr|Dperr|Sserr|Rmabt|Rtabt);
		}

		/* update link state */
		if(status&amp;Phy){
			status &amp;= ~Phy;
			csr32r(ctlr, Rcfg);
			n = csr32r(ctlr, Rcfg);
//			iprint("83815 phy %x %x\n", n, n&amp;Lnksts);
			ether-&gt;link = (n&amp;Lnksts) != 0;
		}

		/*
		 * Received packets.
		 */
		if(status &amp; (Rxdesc|Rxok|Rxerr|Rxearly|Rxorn)){
			des = &amp;ctlr-&gt;rdr[ctlr-&gt;rdrx];
			while((cmdsts = des-&gt;cmdsts) &amp; Own){
				if((cmdsts&amp;Ok) == 0){
					if(cmdsts &amp; Rxa)
						ctlr-&gt;rxa++;
					if(cmdsts &amp; Rxo)
						ctlr-&gt;rxo++;
					if(cmdsts &amp; Long)
						ctlr-&gt;rlong++;
					if(cmdsts &amp; Runt)
						ctlr-&gt;runt++;
					if(cmdsts &amp; Ise)
						ctlr-&gt;ise++;
					if(cmdsts &amp; Crce)
						ctlr-&gt;crce++;
					if(cmdsts &amp; Fae)
						ctlr-&gt;fae++;
					if(cmdsts &amp; Lbp)
						ctlr-&gt;lbp++;
					if(cmdsts &amp; Col)
						ctlr-&gt;col++;
				}
				else if(bp = iallocb(Rbsz)){
					len = (cmdsts&amp;Size)-4;
					if(len &lt;= 0){
						debug("ns83815: packet len %d &lt;=0\n", len);
						freeb(des-&gt;bp);
					}else{
						des-&gt;bp-&gt;wp = des-&gt;bp-&gt;rp+len;
						etheriq(ether, des-&gt;bp, 1);
					}
					des-&gt;bp = bp;
					des-&gt;addr = PADDR(bp-&gt;rp);
					coherence();
				}else{
					debug("ns83815: interrupt: iallocb for input buffer failed\n");
					des-&gt;bp-&gt;next = 0;
				}

				des-&gt;cmdsts = Rbsz;
				coherence();

				ctlr-&gt;rdrx = NEXT(ctlr-&gt;rdrx, ctlr-&gt;nrdr);
				des = &amp;ctlr-&gt;rdr[ctlr-&gt;rdrx];
			}
			status &amp;= ~(Rxdesc|Rxok|Rxerr|Rxearly|Rxorn);
		}

		/*
		 * Check the transmit side:
		 *	check for Transmit Underflow and Adjust
		 *	the threshold upwards;
		 *	free any transmitted buffers and try to
		 *	top-up the ring.
		 */
		if(status &amp; Txurn){
			ctlr-&gt;txurn++;
			ilock(&amp;ctlr-&gt;lock);
			/* change threshold */
			iunlock(&amp;ctlr-&gt;lock);
			status &amp;= ~(Txurn);
		}

		ilock(&amp;ctlr-&gt;tlock);
		while(ctlr-&gt;ntq){
			des = &amp;ctlr-&gt;tdr[ctlr-&gt;tdri];
			cmdsts = des-&gt;cmdsts;
			if(cmdsts &amp; Own)
				break;

			if((cmdsts &amp; Ok) == 0){
				if(cmdsts &amp; Txa)
					ctlr-&gt;txa++;
				if(cmdsts &amp; Tfu)
					ctlr-&gt;tfu++;
				if(cmdsts &amp; Td)
					ctlr-&gt;td++;
				if(cmdsts &amp; Ed)
					ctlr-&gt;ed++;
				if(cmdsts &amp; Owc)
					ctlr-&gt;owc++;
				if(cmdsts &amp; Ec)
					ctlr-&gt;ec++;
				ether-&gt;oerrs++;
			}

			freeb(des-&gt;bp);
			des-&gt;bp = nil;
			des-&gt;cmdsts = 0;

			ctlr-&gt;ntq--;
			ctlr-&gt;tdri = NEXT(ctlr-&gt;tdri, ctlr-&gt;ntdr);
		}
		txstart(ether);
		iunlock(&amp;ctlr-&gt;tlock);

		status &amp;= ~(Txurn|Txidle|Txerr|Txdesc|Txok);

		/*
		 * Anything left not catered for?
		 */
		if(status)
			print("#l%d: status %8.8uX\n", ether-&gt;ctlrno, status);
	}
}

static void
ctlrinit(Ether* ether)
{
	Ctlr *ctlr;
	Des *des, *last;

	ctlr = ether-&gt;ctlr;

	/*
	 * Allocate suitable aligned descriptors
	 * for the transmit and receive rings;
	 * initialise the receive ring;
	 * initialise the transmit ring;
	 * unmask interrupts and start the transmit side.
	 */
	des = xspanalloc((ctlr-&gt;nrdr+ctlr-&gt;ntdr)*sizeof(Des), 32, 0);
	ctlr-&gt;tdr = des;
	ctlr-&gt;rdr = des+ctlr-&gt;ntdr;

	last = nil;
	for(des = ctlr-&gt;rdr; des &lt; &amp;ctlr-&gt;rdr[ctlr-&gt;nrdr]; des++){
		des-&gt;bp = iallocb(Rbsz);
		if(des-&gt;bp == nil)
			error(Enomem);
		des-&gt;cmdsts = Rbsz;
		des-&gt;addr = PADDR(des-&gt;bp-&gt;rp);
		if(last != nil)
			last-&gt;next = PADDR(des);
		last = des;
	}
	ctlr-&gt;rdr[ctlr-&gt;nrdr-1].next = PADDR(ctlr-&gt;rdr);
	ctlr-&gt;rdrx = 0;
	csr32w(ctlr, Rrxdp, PADDR(ctlr-&gt;rdr));

	last = nil;
	for(des = ctlr-&gt;tdr; des &lt; &amp;ctlr-&gt;tdr[ctlr-&gt;ntdr]; des++){
		des-&gt;cmdsts = 0;
		des-&gt;bp = nil;
		des-&gt;addr = ~0;
		if(last != nil)
			last-&gt;next = PADDR(des);
		last = des;
	}
	ctlr-&gt;tdr[ctlr-&gt;ntdr-1].next = PADDR(ctlr-&gt;tdr);
	ctlr-&gt;tdrh = 0;
	ctlr-&gt;tdri = 0;
	csr32w(ctlr, Rtxdp, PADDR(ctlr-&gt;tdr));

	txrxcfg(ctlr, Drth512);

	csr32w(ctlr, Rimr, Dperr|Sserr|Rmabt|Rtabt|Rxsovr|Hiberr|Txurn|Txerr|
		Txdesc|Txok|Rxorn|Rxerr|Rxdesc|Rxok);	/* Phy|Pme|Mib */
	csr32w(ctlr, Rmicr, Inten);	/* enable phy interrupts */
	csr32r(ctlr, Risr);		/* clear status */
	csr32w(ctlr, Rier, Ie);
}

static void
eeclk(Ctlr *ctlr, int clk)
{
	csr32w(ctlr, Rmear, Eesel | clk);
	microdelay(2);
}

static void
eeidle(Ctlr *ctlr)
{
	int i;

	eeclk(ctlr, 0);
	eeclk(ctlr, Eeclk);
	for(i=0; i&lt;25; i++){
		eeclk(ctlr, 0);
		eeclk(ctlr, Eeclk);
	}
	eeclk(ctlr, 0);
	csr32w(ctlr, Rmear, 0);
	microdelay(2);
}

static ushort
eegetw(Ctlr *ctlr, int a)
{
	int d, i, w;

	eeidle(ctlr);
	eeclk(ctlr, 0);
	eeclk(ctlr, Eeclk);
	d = 0x180 | a;
	for(i=0x400; i; i&gt;&gt;=1){
		if(d &amp; i)
			csr32w(ctlr, Rmear, Eesel|Eedi);
		else
			csr32w(ctlr, Rmear, Eesel);
		eeclk(ctlr, Eeclk);
		eeclk(ctlr, 0);
		microdelay(2);
	}
	w = 0;
	for(i=0x8000; i; i &gt;&gt;= 1){
		eeclk(ctlr, Eeclk);
		if(csr32r(ctlr, Rmear) &amp; Eedo)
			w |= i;
		microdelay(2);
		eeclk(ctlr, 0);
	}
	eeidle(ctlr);
	return w;
}

static int
resetctlr(Ctlr *ctlr)
{
	int i;

	/*
	 * Soft-reset the controller
	 */
	csr32w(ctlr, Rcr, Rst);
	for(i=0;; i++){
		if(i &gt; 100){
			print("ns83815: soft reset did not complete\n");
			return -1;
		}
		microdelay(250);
		if((csr32r(ctlr, Rcr) &amp; Rst) == 0)
			break;
		delay(1);
	}
	return 0;
}

static void
shutdown(Ether* ether)
{
	Ctlr *ctlr = ether-&gt;ctlr;

print("ether83815 shutting down\n");
	csr32w(ctlr, Rcr, Rxd|Txd);	/* disable transceiver */
	resetctlr(ctlr);
}

static int
softreset(Ctlr* ctlr, int resetphys)
{
	int i, w;

	/*
	 * Soft-reset the controller
	 */
	resetctlr(ctlr);
	csr32w(ctlr, Rccsr, Pmests);
	csr32w(ctlr, Rccsr, 0);
	csr32w(ctlr, Rcfg, csr32r(ctlr, Rcfg) | Pint_acen);
	ctlr-&gt;version = csr32r(ctlr, Rsrr);
	if(resetphys){
		/*
		 * Soft-reset the PHY
		 */
		csr32w(ctlr, Rbmcr, Reset);
		for(i=0;; i++){
			if(i &gt; 100){
				print("ns83815: PHY soft reset time out\n");
				return -1;
			}
			if((csr32r(ctlr, Rbmcr) &amp; Reset) == 0)
				break;
			delay(1);
		}
	}

	/*
	 * Initialisation values, in sequence (see 4.4 Recommended Registers Configuration)
	 */
	csr16w(ctlr, 0xCC, 0x0001);	/* PGSEL */
	csr16w(ctlr, 0xE4, 0x189C);	/* PMCCSR */
	csr16w(ctlr, 0xFC, 0x0000);	/* TSTDAT */
	csr16w(ctlr, 0xF4, 0x5040);	/* DSPCFG */
	csr16w(ctlr, 0xF8, 0x008C);	/* SDCFG */

	/*
	 * Auto negotiate
	 */
	csr16r(ctlr, Rbmsr);		/* clear latched bits */
	debug("anar: %4.4ux\n", csr16r(ctlr, Ranar));
	csr16w(ctlr, Rbmcr, Anena);
	if(csr16r(ctlr, Ranar) == 0 || (csr32r(ctlr, Rcfg) &amp; Aneg_dn) == 0){
		csr16w(ctlr, Rbmcr, Anena|Anrestart);
		for(i=0;; i++){
			if(i &gt; 3000){
				print("ns83815: auto neg timed out\n");
				return -1;
			}
			if((w = csr16r(ctlr, Rbmsr)) &amp; Ancomp)
				break;
			delay(1);
		}
		debug("%d ms\n", i);
		w &amp;= 0xFFFF;
		debug("bmsr: %4.4ux\n", w);
		USED(w);
	}
	debug("anar: %4.4ux\n", csr16r(ctlr, Ranar));
	debug("anlpar: %4.4ux\n", csr16r(ctlr, Ranlpar));
	debug("aner: %4.4ux\n", csr16r(ctlr, Raner));
	debug("physts: %4.4ux\n", csr16r(ctlr, Rphysts));
	debug("tbscr: %4.4ux\n", csr16r(ctlr, Rtbscr));
	return 0;
}

static int
media(Ether* ether)
{
	Ctlr* ctlr;
	ulong cfg;

	ctlr = ether-&gt;ctlr;
	cfg = csr32r(ctlr, Rcfg);
	ctlr-&gt;fd = (cfg &amp; Fdup) != 0;
	ether-&gt;link = (cfg&amp;Lnksts) != 0;
	return (cfg&amp;(Lnksts|Speed100)) == Lnksts? 10: 100;
}

static char* mediatable[9] = {
	"10BASE-T",				/* TP */
	"10BASE-2",				/* BNC */
	"10BASE-5",				/* AUI */
	"100BASE-TX",
	"10BASE-TFD",
	"100BASE-TXFD",
	"100BASE-T4",
	"100BASE-FX",
	"100BASE-FXFD",
};

static int
is630(ulong id, Pcidev *p)
{
	if(id == SiS900)
		switch (p-&gt;rid) {
		case SiSrev630s:
		case SiSrev630e:
	  	case SiSrev630ea1:
			return 1;
		}
	return 0;
}

enum {
	MagicReg = 0x48,
	MagicRegSz = 1,
	Magicrden = 0x40,	/* read enable, apparently */
	Paddr=		0x70,	/* address port */
	Pdata=		0x71,	/* data port */
};

/* rcmos() originally from LANL's SiS 900 driver's rcmos() */
static int
sisrdcmos(Ctlr *ctlr)
{
	int i;
	unsigned reg;
	ulong port;
	Pcidev *p;

	debug("ns83815: SiS 630 rev. %ux reading mac address from cmos\n", ctlr-&gt;pcidev-&gt;rid);
	p = pcimatch(nil, SiS, SiS630bridge);
	if(p == nil) {
		print("ns83815: no SiS 630 rev. %ux bridge for mac addr\n",
			ctlr-&gt;pcidev-&gt;rid);
		return 0;
	}
	port = p-&gt;mem[0].bar &amp; ~0x01;
	debug("ns83815: SiS 630 rev. %ux reading mac addr from cmos via bridge at port 0x%lux\n", ctlr-&gt;pcidev-&gt;rid, port);

	reg = pcicfgr8(p, MagicReg);
	pcicfgw8(p, MagicReg, reg|Magicrden);

	for (i = 0; i &lt; Eaddrlen; i++) {
		outb(port+Paddr, SiS630eenodeaddr + i);
		ctlr-&gt;sromea[i] = inb(port+Pdata);
	}

	pcicfgw8(p, MagicReg, reg &amp; ~Magicrden);
	return 1;
}

/*
 * If this is a SiS 630E chipset with an embedded SiS 900 controller,
 * we have to read the MAC address from the APC CMOS RAM. - sez freebsd.
 * However, CMOS *is* NVRAM normally.  See devrtc.c:440, memory.c:88.
 */
static void
sissrom(Ctlr *ctlr)
{
	union {
		uchar	eaddr[Eaddrlen];
		ushort	alignment;
	} ee;
	int i, off = SiSeenodeaddr, cnt = sizeof ee.eaddr / sizeof(short);
	ushort *shp = (ushort *)ee.eaddr;

	if(!is630(ctlr-&gt;id, ctlr-&gt;pcidev) || !sisrdcmos(ctlr)) {
		for (i = 0; i &lt; cnt; i++)
			*shp++ = eegetw(ctlr, off++);
		memmove(ctlr-&gt;sromea, ee.eaddr, sizeof ctlr-&gt;sromea);
	}
}

ushort
søkrisee(Ctlr *c, int n)
{
	int i;
	uint cmd;
	ushort r;

   	csr32w(c, Rmear, Eesel);

	cmd = 0x180|n;
	for(i = 10; i &gt;= 0; i--){
		n = 1&lt;&lt;3;
		if(cmd&amp;(1&lt;&lt;i))
			n |= 1;
		csr32w(c, Rmear, n);
		csr32r(c, Rmear);
		csr32w(c, Rmear, n|4);
		csr32r(c, Rmear);
	}

	csr32w(c, Rmear, 1&lt;&lt;3);
	csr32r(c, Rmear);

	r = 0;
	for(i = 0; i &lt; 16; i++){
		csr32w(c, Rmear, 1&lt;&lt;3 | 1&lt;&lt;2);
		csr32r(c, Rmear);
		if(csr32r(c, Rmear) &amp; 2)
			r |= 1&lt;&lt;i;
		csr32w(c, Rmear, 1&lt;&lt;3);
		csr32r(c, Rmear);
	}

	csr32w(c, Rmear, 1&lt;&lt;3);
	csr32w(c, Rmear, 0);

	return r;
}

static void
nsnormalea(Ctlr *ctlr)
{
	int i, j;

	/*
	 * the MAC address is reversed, straddling word boundaries
	 */
	j = Nseenodeaddr*16 + 15;
	for(i = 0; i &lt; 48; i++){
		ctlr-&gt;sromea[i&gt;&gt;3] |= ((ctlr-&gt;srom[j&gt;&gt;4] &gt;&gt; (15-(j&amp;0xF))) &amp; 1) &lt;&lt; (i&amp;7);
		j++;
	}
}

static void
ns403ea(Ctlr *ctlr)
{
	int i;
	ushort s, t;

	s = ctlr-&gt;srom[6];
	for(i = 0; i &lt; 3; i++){
		t = ctlr-&gt;srom[i+7];
		ctlr-&gt;sromea[i*2]   = t&lt;&lt;1 | s&gt;&gt;15;
		ctlr-&gt;sromea[i*2+1] = t&gt;&gt;7;
		s = t;
	}
}

static void
nssrom(Ctlr* ctlr)
{
	int i, ns403;
	ulong vers;
	ushort (*ee)(Ctlr*, int);

	vers = ctlr-&gt;version;
	ns403 = vers == Nat83815avng || vers == Nat83816avng;
	if(ns403){
		ee = søkrisee;
		print("soekris %lx\n", vers);
	}else
		ee = eegetw;

	for(i = 0; i &lt; nelem(ctlr-&gt;srom); i++)
		ctlr-&gt;srom[i] = ee(ctlr, i);

	if(ns403)
		ns403ea(ctlr);
	else
		nsnormalea(ctlr);
}

static void
srom(Ctlr* ctlr)
{
	memset(ctlr-&gt;sromea, 0, sizeof(ctlr-&gt;sromea));
	switch (ctlr-&gt;id) {
	case SiS900:
	case SiS7016:
		sissrom(ctlr);
		break;
	case Nat83815:
		nssrom(ctlr);
		break;
	default:
		print("ns83815: srom: unknown id 0x%ux\n", ctlr-&gt;id);
		break;
	}
}

static void
scanpci83815(void)
{
	Ctlr *ctlr;
	Pcidev *p;
	ulong id;

	p = nil;
	while(p = pcimatch(p, 0, 0)){
		if(p-&gt;ccrb != Pcibcnet || p-&gt;ccru != 0)
			continue;
		id = (p-&gt;did&lt;&lt;16)|p-&gt;vid;
		switch(id){
		default:
			continue;

		case Nat83815:
			break;
		case SiS900:
			break;
		}

		/*
		 * bar[0] is the I/O port register address and
		 * bar[1] is the memory-mapped register address.
		 */
		ctlr = malloc(sizeof(Ctlr));
		if(ctlr == nil)
			error(Enomem);
		ctlr-&gt;port = p-&gt;mem[0].bar &amp; ~0x01;
		ctlr-&gt;pcidev = p;
		ctlr-&gt;id = id;

		if(ioalloc(ctlr-&gt;port, p-&gt;mem[0].size, 0, "ns83815") &lt; 0){
			print("ns83815: port 0x%uX in use\n", ctlr-&gt;port);
			free(ctlr);
			continue;
		}

		if(softreset(ctlr, 0) == -1){
			free(ctlr);
			continue;
		}
		srom(ctlr);

		if(ctlrhead != nil)
			ctlrtail-&gt;next = ctlr;
		else
			ctlrhead = ctlr;
		ctlrtail = ctlr;
	}
}

/* multicast already on, don't need to do anything */
static void
multicast(void*, uchar*, int)
{
}

static int
reset(Ether* ether)
{
	Ctlr *ctlr;
	int i, x;
	ulong ctladdr;
	uchar ea[Eaddrlen];
	static int scandone;

	if(scandone == 0){
		scanpci83815();
		scandone = 1;
	}

	/*
	 * Any adapter matches if no ether-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	for(ctlr = ctlrhead; ctlr != nil; ctlr = ctlr-&gt;next){
		if(ctlr-&gt;active)
			continue;
		if(ether-&gt;port == 0 || ether-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}
	if(ctlr == nil)
		return -1;

	ether-&gt;ctlr = ctlr;
	ether-&gt;port = ctlr-&gt;port;
	ether-&gt;irq = ctlr-&gt;pcidev-&gt;intl;
	ether-&gt;tbdf = ctlr-&gt;pcidev-&gt;tbdf;

	/*
	 * Check if the adapter's station address is to be overridden.
	 * If not, read it from the EEPROM and set in ether-&gt;ea prior to
	 * loading the station address in the hardware.
	 */
	memset(ea, 0, Eaddrlen);
	if(memcmp(ea, ether-&gt;ea, Eaddrlen) == 0)
		memmove(ether-&gt;ea, ctlr-&gt;sromea, Eaddrlen);
	for(i=0; i&lt;Eaddrlen; i+=2){
		x = ether-&gt;ea[i] | (ether-&gt;ea[i+1]&lt;&lt;8);
		ctladdr = (ctlr-&gt;id == Nat83815? i: i&lt;&lt;15);
		csr32w(ctlr, Rrfcr, ctladdr);
		csr32w(ctlr, Rrfdr, x);
	}
	csr32w(ctlr, Rrfcr, Rfen|Apm|Aab|Aam);

	ether-&gt;mbps = media(ether);

	/*
	 * Look for a medium override in case there's no autonegotiation
	 * the autonegotiation fails.
	 */

	for(i = 0; i &lt; ether-&gt;nopt; i++){
		if(cistrcmp(ether-&gt;opt[i], "FD") == 0){
			ctlr-&gt;fd = 1;
			continue;
		}
		for(x = 0; x &lt; nelem(mediatable); x++){
			debug("compare &lt;%s&gt; &lt;%s&gt;\n", mediatable[x],
				ether-&gt;opt[i]);
			if(cistrcmp(mediatable[x], ether-&gt;opt[i]) == 0){
				if(x != 4 &amp;&amp; x &gt;= 3)
					ether-&gt;mbps = 100;
				else
					ether-&gt;mbps = 10;
				switch(x){
				default:
					ctlr-&gt;fd = 0;
					break;

				case 0x04:		/* 10BASE-TFD */
				case 0x05:		/* 100BASE-TXFD */
				case 0x08:		/* 100BASE-FXFD */
					ctlr-&gt;fd = 1;
					break;
				}
				break;
			}
		}
	}

	/*
	 * Initialise descriptor rings, ethernet address.
	 */
	ctlr-&gt;nrdr = Nrde;
	ctlr-&gt;ntdr = Ntde;
	pcisetbme(ctlr-&gt;pcidev);
	ctlrinit(ether);

	/*
	 * Linkage to the generic ethernet driver.
	 */
	ether-&gt;attach = attach;
	ether-&gt;transmit = transmit;
	ether-&gt;interrupt = interrupt;
	ether-&gt;ifstat = ifstat;

	ether-&gt;arg = ether;
	ether-&gt;promiscuous = promiscuous;
	ether-&gt;multicast = multicast;
	ether-&gt;shutdown = shutdown;
	return 0;
}

void
ether83815link(void)
{
	addethercard("83815",  reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

