<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/etherm10g.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/etherm10g.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * myricom 10g-pcie-8a 10 Gb ethernet driver
 * © 2007 erik quanstrom, coraid
 *
 * the card is big endian.
 * we use uvlong rather than uintptr to hold addresses so that
 * we don't get "warning: stupid shift" on 32-bit architectures.
 *
 * appears to have massively-bloated buffers.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "../pc/etherif.h"

#ifndef KiB
#define KiB		1024u			/* Kibi 0x0000000000000400 */
#define MiB		1048576u		/* Mebi 0x0000000000100000 */
#endif /* KiB */

#define	dprint(...)	if(debug) print(__VA_ARGS__)
#define	pcicapdbg(...)
#define malign(n)	mallocalign((n), 4*KiB, 0, 0)

#include "etherm10g2k.i"
#include "etherm10g4k.i"

static int 	debug		= 0;
static char	Etimeout[]	= "timeout";

enum {
	Epromsz	= 256,
	Maxslots= 1024,		/* rcv descriptors; wasteful: only 9 needed */
	Align	= 4096,
	Maxmtu	= 9000,		/* jumbos; bad idea */
	Noconf	= 0xffffffff,

	Fwoffset= 1*MiB,
	Cmdoff	= 0xf80000,	/* command port offset */
	Fwsubmt	= 0xfc0000,	/* firmware submission command port offset */
	Rdmaoff	= 0xfc01c0,	/* rdma command port offset */
};

enum {
	CZero,
	Creset,
	Cversion,

	CSintrqdma,	/* issue these before Cetherup */
	CSbigsz,	/* in bytes bigsize = 2^n */
	CSsmallsz,

	CGsendoff,
	CGsmallrxoff,
	CGbigrxoff,
	CGirqackoff,
	CGirqdeassoff,
	CGsendrgsz,
	CGrxrgsz,

	CSintrqsz,	/* 2^n */
	Cetherup,	/* above parameters + mtu/mac addr must be set first. */
	Cetherdn,

	CSmtu,		/* below may be issued live */
	CGcoaloff,	/* in µs */
	CSstatsrate,	/* in µs */
	CSstatsdma,

	Cpromisc,
	Cnopromisc,
	CSmac,

	Cenablefc,
	Cdisablefc,

	Cdmatest,	/* address in d[0-1], d[2]=length */

	Cenableallmc,
	Cdisableallmc,

	CSjoinmc,
	CSleavemc,
	Cleaveallmc,

	CSstatsdma2,	/* adds (unused) multicast stats */
};

typedef union {
	uint	i[2];
	uchar	c[8];
} Cmd;

typedef ulong Slot;
typedef struct {
	ushort	cksum;
	ushort	len;
} Slotparts;

enum {
	SFsmall	= 1,
	SFfirst	= 2,
	SFalign	= 4,
	SFnotso	= 16,
};

typedef struct {
	ulong	high;
	ulong	low;
	ushort	hdroff;
	ushort	len;
	uchar	pad;
	uchar	nrdma;
	uchar	chkoff;
	uchar	flags;
} Send;

typedef struct {
	QLock;
	Send	*lanai;		/* tx ring (cksum+len in lanai memory) */
	Send	*host;		/* tx ring (data in our memory) */
	Block	**bring;
//	uchar	*wcfifo;	/* what the heck is a w/c fifo? */
	int	size;		/* of buffers in the z8's memory */
	ulong	segsz;
	uint	n;		/* rxslots */
	uint	m;		/* mask; rxslots must be a power of two */
	uint	i;		/* number of segments (not frames) queued */
	uint	cnt;		/* number of segments sent by the card */

	ulong	npkt;
	vlong	nbytes;
} Tx;

typedef struct {
	Lock;
	Block	*head;
	uint	size;		/* buffer size of each block */
	uint	n;		/* n free buffers */
	uint	cnt;
} Bpool;

static Bpool	smpool 	= { .size = 128, };
static Bpool	bgpool	= { .size = Maxmtu, };

typedef struct {
	Bpool	*pool;		/* free buffers */
	ulong	*lanai;		/* rx ring; we have no permanent host shadow */
	Block	**host;		/* called "info" in myricom driver */
//	uchar	*wcfifo;	/* cmd submission fifo */
	uint	m;
	uint	n;		/* rxslots */
	uint	i;
	uint	cnt;		/* number of buffers allocated (lifetime) */
	uint	allocfail;
} Rx;

/* dma mapped.  unix network byte order. */
typedef struct {
	uchar	txcnt[4];
	uchar	linkstat[4];
	uchar	dlink[4];
	uchar	derror[4];
	uchar	drunt[4];
	uchar	doverrun[4];
	uchar	dnosm[4];
	uchar	dnobg[4];
	uchar	nrdma[4];
	uchar	txstopped;
	uchar	down;
	uchar	updated;
	uchar	valid;
} Stats;

enum {
	Detached,
	Attached,
	Runed,
};

typedef struct {
	Slot 	*entry;
	uvlong	busaddr;
	uint	m;
	uint	n;
	uint	i;
} Done;

typedef struct Ctlr Ctlr;
typedef struct Ctlr {
	QLock;
	int	state;
	int	kprocs;
	uvlong	port;
	Pcidev*	pcidev;
	Ctlr*	next;
	int	active;
	int	id;		/* do we need this? */

	uchar	ra[Eaddrlen];

	int	ramsz;
	uchar	*ram;

	ulong	*irqack;
	ulong	*irqdeass;
	ulong	*coal;

	char	eprom[Epromsz];
	ulong	serial;		/* unit serial number */

	QLock	cmdl;
	Cmd	*cmd;		/* address of command return */
	uvlong	cprt;		/* bus address of command */

	uvlong	boot;		/* boot address */

	Done	done;
	Tx	tx;
	Rx	sm;
	Rx	bg;
	Stats	*stats;
	uvlong	statsprt;

	Rendez	rxrendez;
	Rendez	txrendez;

	int	msi;
	ulong	linkstat;
	ulong	nrdma;
} Ctlr;

static Ctlr 	*ctlrs;

enum {
	PciCapPMG	 = 0x01,	/* power management */
	PciCapAGP	 = 0x02,
	PciCapVPD	 = 0x03,	/* vital product data */
	PciCapSID	 = 0x04,	/* slot id */
	PciCapMSI	 = 0x05,
	PciCapCHS	 = 0x06,	/* compact pci hot swap */
	PciCapPCIX	 = 0x07,
	PciCapHTC	 = 0x08,	/* hypertransport irq conf */
	PciCapVND	 = 0x09,	/* vendor specific information */
	PciCapHSW	 = 0x0C,	/* hot swap */
	PciCapPCIe	 = 0x10,
	PciCapMSIX	 = 0x11,
};

enum {
	PcieAERC = 1,
	PcieVC,
	PcieSNC,
	PciePBC,
};

enum {
	AercCCR	= 0x18,		/* control register */
};

enum {
	PcieCTL	= 8,
	PcieLCR	= 12,
	PcieMRD	= 0x7000,	/* maximum read size */
};

static int
pcicap(Pcidev *p, int cap)
{
	int i, c, off;

	pcicapdbg("pcicap: %x:%d\n", p-&gt;vid, p-&gt;did);
	off = 0x34;			/* 0x14 for cardbus */
	for(i = 48; i--; ){
		pcicapdbg("\t" "loop %x\n", off);
		off = pcicfgr8(p, off);
		pcicapdbg("\t" "pcicfgr8 %x\n", off);
		if(off &lt; 0x40)
			break;
		off &amp;= ~3;
		c = pcicfgr8(p, off);
		pcicapdbg("\t" "pcicfgr8 %x\n", c);
		if(c == 0xff)
			break;
		if(c == cap)
			return off;
		off++;
	}
	return 0;
}

/*
 * this function doesn't work because pcicgr32 doesn't have access
 * to the pcie extended configuration space.
 */
static int
pciecap(Pcidev *p, int cap)
{
	uint off, i;

	off = 0x100;
	while(((i = pcicfgr32(p, off)) &amp; 0xffff) != cap){
		off = i &gt;&gt; 20;
		print("m10g: pciecap offset = %ud",  off);
		if(off &lt; 0x100 || off &gt;= 4*KiB - 1)
			return 0;
	}
	print("m10g: pciecap found = %ud",  off);
	return off;
}

static int
setpcie(Pcidev *p)
{
	int off;

	/* set 4k writes */
	off = pcicap(p, PciCapPCIe);
	if(off &lt; 64)
		return -1;
	off += PcieCTL;
	pcicfgw16(p, off, (pcicfgr16(p, off) &amp; ~PcieMRD) | 5&lt;&lt;12);
	return 0;
}

static int
whichfw(Pcidev *p)
{
	char *s;
	int i, off, lanes, ecrc;
	ulong cap;

	/* check the number of configured lanes. */
	off = pcicap(p, PciCapPCIe);
	if(off &lt; 64)
		return -1;
	off += PcieLCR;
	cap = pcicfgr16(p, off);
	lanes = (cap&gt;&gt;4) &amp; 0x3f;

	/* check AERC register.  we need it on.  */
	off = pciecap(p, PcieAERC);
	print("; offset %d returned\n", off);
	cap = 0;
	if(off != 0){
		off += AercCCR;
		cap = pcicfgr32(p, off);
		print("m10g: %lud cap\n", cap);
	}
	ecrc = (cap&gt;&gt;4) &amp; 0xf;
	/* if we don't like the aerc, kick it here. */

	print("m10g: %d lanes; ecrc=%d; ", lanes, ecrc);
	if(s = getconf("myriforce")){
		i = atoi(s);
		if(i != 4*KiB || i != 2*KiB)
			i = 2*KiB;
		print("fw = %d [forced]\n", i);
		return i;
	}
	if(lanes &lt;= 4)
		print("fw = 4096 [lanes]\n");
	else if(ecrc &amp; 10)
		print("fw = 4096 [ecrc set]\n");
	else
		print("fw = 4096 [default]\n");
	return 4*KiB;
}

static int
parseeprom(Ctlr *c)
{
	int i, j, k, l, bits;
	char *s;

	dprint("m10g eprom:\n");
	s = c-&gt;eprom;
	bits = 3;
	for(i = 0; s[i] &amp;&amp; i &lt; Epromsz; i++){
		l = strlen(s+i);
		dprint("\t%s\n", s+i);
		if(strncmp(s+i, "MAC=", 4) == 0 &amp;&amp; l == 4+12+5){
			bits ^= 1;
			j = i + 4;
			for(k = 0; k &lt; 6; k++)
				c-&gt;ra[k] = strtoul(s+j+3*k, 0, 16);
		}else if(strncmp(s+i, "SN=", 3) == 0){
			bits ^= 2;
			c-&gt;serial = atoi(s+i+3);
		}
		i += l;
	}
	if(bits)
		return -1;
	return 0;
}

static ushort
pbit16(ushort i)
{
	ushort j;
	uchar *p;

	p = (uchar*)&amp;j;
	p[1] = i;
	p[0] = i&gt;&gt;8;
	return j;
}

static ushort
gbit16(uchar i[2])
{
	ushort j;

	j  = i[1];
	j |= i[0]&lt;&lt;8;
	return j;
}

static ulong
pbit32(ulong i)
{
	ulong j;
	uchar *p;

	p = (uchar*)&amp;j;
	p[3] = i;
	p[2] = i&gt;&gt;8;
	p[1] = i&gt;&gt;16;
	p[0] = i&gt;&gt;24;
	return j;
}

static ulong
gbit32(uchar i[4])
{
	ulong j;

	j  = i[3];
	j |= i[2]&lt;&lt;8;
	j |= i[1]&lt;&lt;16;
	j |= i[0]&lt;&lt;24;
	return j;
}

static void
prepcmd(ulong *cmd, int i)
{
	while(i-- &gt; 0)
		cmd[i] = pbit32(cmd[i]);
}

/*
 * the command looks like this (int 32bit integers)
 * cmd type
 * addr (low)
 * addr (high)
 * pad (used for dma testing)
 * response (high)
 * response (low)
 * 40 byte = 5 int pad.
 */

ulong
cmd(Ctlr *c, int type, uvlong data)
{
	ulong buf[16], i;
	Cmd *cmd;

	qlock(&amp;c-&gt;cmdl);
	cmd = c-&gt;cmd;
	cmd-&gt;i[1] = Noconf;
	memset(buf, 0, sizeof buf);
	buf[0] = type;
	buf[1] = data;
	buf[2] = data &gt;&gt; 32;
	buf[4] = c-&gt;cprt &gt;&gt; 32;
	buf[5] = c-&gt;cprt;
	prepcmd(buf, 6);
	coherence();
	memmove(c-&gt;ram + Cmdoff, buf, sizeof buf);

	if(waserror()){
		qunlock(&amp;c-&gt;cmdl);
		nexterror();
	}
	for(i = 0; i &lt; 15; i++){
		if(cmd-&gt;i[1] != Noconf){
			poperror();
			i = gbit32(cmd-&gt;c);
			qunlock(&amp;c-&gt;cmdl);
			if(cmd-&gt;i[1] != 0)
				dprint("[%lux]", i);
			return i;	/* normal return */
		}
		tsleep(&amp;up-&gt;sleep, return0, 0, 1);
	}
	iprint("m10g: cmd timeout [%ux %ux] cmd=%d\n",
		cmd-&gt;i[0], cmd-&gt;i[1], type);
	error(Etimeout);
	return ~0;			/* silence! */
}

ulong
maccmd(Ctlr *c, int type, uchar *m)
{
	ulong buf[16], i;
	Cmd *cmd;

	qlock(&amp;c-&gt;cmdl);
	cmd = c-&gt;cmd;
	cmd-&gt;i[1] = Noconf;
	memset(buf, 0, sizeof buf);
	buf[0] = type;
	buf[1] = m[0]&lt;&lt;24 | m[1]&lt;&lt;16 | m[2]&lt;&lt;8 | m[3];
	buf[2] = m[4]&lt;&lt; 8 | m[5];
	buf[4] = c-&gt;cprt &gt;&gt; 32;
	buf[5] = c-&gt;cprt;
	prepcmd(buf, 6);
	coherence();
	memmove(c-&gt;ram + Cmdoff, buf, sizeof buf);

	if(waserror()){
		qunlock(&amp;c-&gt;cmdl);
		nexterror();
	}
	for(i = 0; i &lt; 15; i++){
		if(cmd-&gt;i[1] != Noconf){
			poperror();
			i = gbit32(cmd-&gt;c);
			qunlock(&amp;c-&gt;cmdl);
			if(cmd-&gt;i[1] != 0)
				dprint("[%lux]", i);
			return i;	/* normal return */
		}
		tsleep(&amp;up-&gt;sleep, return0, 0, 1);
	}
	iprint("m10g: maccmd timeout [%ux %ux] cmd=%d\n",
		cmd-&gt;i[0], cmd-&gt;i[1], type);
	error(Etimeout);
	return ~0;			/* silence! */
}

/* remove this garbage after testing */
enum {
	DMAread	= 0x10000,
	DMAwrite= 0x1,
};

ulong
dmatestcmd(Ctlr *c, int type, uvlong addr, int len)
{
	ulong buf[16], i;

	memset(buf, 0, sizeof buf);
	memset(c-&gt;cmd, Noconf, sizeof *c-&gt;cmd);
	buf[0] = Cdmatest;
	buf[1] = addr;
	buf[2] = addr &gt;&gt; 32;
	buf[3] = len * type;
	buf[4] = c-&gt;cprt &gt;&gt; 32;
	buf[5] = c-&gt;cprt;
	prepcmd(buf, 6);
	coherence();
	memmove(c-&gt;ram + Cmdoff, buf, sizeof buf);

	for(i = 0; i &lt; 15; i++){
		if(c-&gt;cmd-&gt;i[1] != Noconf){
			i = gbit32(c-&gt;cmd-&gt;c);
			if(i == 0)
				error(Eio);
			return i;	/* normal return */
		}
		tsleep(&amp;up-&gt;sleep, return0, 0, 5);
	}
	error(Etimeout);
	return ~0;			/* silence! */
}

ulong
rdmacmd(Ctlr *c, int on)
{
	ulong buf[16], i;

	memset(buf, 0, sizeof buf);
	c-&gt;cmd-&gt;i[0] = 0;
	coherence();
	buf[0] = c-&gt;cprt &gt;&gt; 32;
	buf[1] = c-&gt;cprt;
	buf[2] = Noconf;
	buf[3] = c-&gt;cprt &gt;&gt; 32;
	buf[4] = c-&gt;cprt;
	buf[5] = on;
	prepcmd(buf, 6);
	memmove(c-&gt;ram + Rdmaoff, buf, sizeof buf);

	for(i = 0; i &lt; 20; i++){
		if(c-&gt;cmd-&gt;i[0] == Noconf)
			return gbit32(c-&gt;cmd-&gt;c);	/* normal return */
		tsleep(&amp;up-&gt;sleep, return0, 0, 1);
	}
	iprint("m10g: rdmacmd timeout\n");
	error(Etimeout);
	return ~0;			/* silence! */
}

static int
loadfw(Ctlr *c, int *align)
{
	ulong *f, *s, sz;
	int i;

	if((*align = whichfw(c-&gt;pcidev)) == 4*KiB){
		f = (ulong*)fw4k;
		sz = sizeof fw4k;
	}else{
		f = (ulong*)fw2k;
		sz = sizeof fw2k;
	}

	s = (ulong*)(c-&gt;ram + Fwoffset);
	for(i = 0; i &lt; sz / 4; i++)
		s[i] = f[i];
	return sz &amp; ~3;
}

static int
bootfw(Ctlr *c)
{
	int i, sz, align;
	ulong buf[16];
	Cmd* cmd;

	if((sz = loadfw(c, &amp;align)) == 0)
		return 0;
	dprint("bootfw %d bytes ... ", sz);
	cmd = c-&gt;cmd;

	memset(buf, 0, sizeof buf);
	c-&gt;cmd-&gt;i[0] = 0;
	coherence();
	buf[0] = c-&gt;cprt &gt;&gt; 32;	/* upper dma target address */
	buf[1] = c-&gt;cprt;	/* lower */
	buf[2] = Noconf;	/* writeback */
	buf[3] = Fwoffset + 8,
	buf[4] = sz - 8;
	buf[5] = 8;
	buf[6] = 0;
	prepcmd(buf, 7);
	coherence();
	memmove(c-&gt;ram + Fwsubmt, buf, sizeof buf);

	for(i = 0; i &lt; 20; i++){
		if(cmd-&gt;i[0] == Noconf)
			break;
		delay(1);
	}
	dprint("[%lux %lux]", gbit32(cmd-&gt;c), gbit32(cmd-&gt;c+4));
	if(i == 20){
		print("m10g: cannot load fw\n");
		return -1;
	}
	dprint("\n");
	c-&gt;tx.segsz = align;
	return 0;
}

static int
kickthebaby(Pcidev *p, Ctlr *c)
{
	/* don't kick the baby! */
	ulong code;

	pcicfgw8(p,  0x10 + c-&gt;boot, 0x3);
	pcicfgw32(p, 0x18 + c-&gt;boot, 0xfffffff0);
	code = pcicfgr32(p, 0x14 + c-&gt;boot);

	dprint("reboot status = %lux\n", code);
	if(code != 0xfffffff0)
		return -1;
	return 0;
}

typedef struct {
	uchar	len[4];
	uchar	type[4];
	char	version[128];
	uchar	globals[4];
	uchar	ramsz[4];
	uchar	specs[4];
	uchar	specssz[4];
} Fwhdr;

enum {
	Tmx	= 0x4d582020,
	Tpcie	= 0x70636965,
	Teth	= 0x45544820,
	Tmcp0	= 0x4d435030,
};

static char *
fwtype(ulong type)
{
	switch(type){
	case Tmx:
		return "mx";
	case Tpcie:
		return "PCIe";
	case Teth:
		return "eth";
	case Tmcp0:
		return "mcp0";
	}
	return "*GOK*";
}

static int
chkfw(Ctlr *c)
{
	ulong off, type;
	Fwhdr *h;

	off = gbit32(c-&gt;ram+0x3c);
	dprint("firmware %lux\n", off);
	if((off&amp;3) || off + sizeof *h &gt; c-&gt;ramsz){
		print("!m10g: bad firmware %lux\n", off);
		return -1;
	}
	h = (Fwhdr*)(c-&gt;ram + off);
	type = gbit32(h-&gt;type);
	dprint("\t" "type	%s\n", fwtype(type));
	dprint("\t" "vers	%s\n", h-&gt;version);
	dprint("\t" "ramsz	%lux\n", gbit32(h-&gt;ramsz));
	if(type != Teth){
		print("!m10g: bad card type %s\n", fwtype(type));
		return -1;
	}

	return bootfw(c) || rdmacmd(c, 0);
}

static int
reset(Ether *e, Ctlr *c)
{
	ulong i, sz;

	if(waserror()){
		print("m10g: reset error\n");
		nexterror();
		return -1;
	}

	chkfw(c);
	cmd(c, Creset, 0);

	cmd(c, CSintrqsz, c-&gt;done.n * sizeof *c-&gt;done.entry);
	cmd(c, CSintrqdma, c-&gt;done.busaddr);
	c-&gt;irqack =   (ulong*)(c-&gt;ram + cmd(c, CGirqackoff, 0));
	/* required only if we're not doing msi? */
	c-&gt;irqdeass = (ulong*)(c-&gt;ram + cmd(c, CGirqdeassoff, 0));
	/* this is the driver default, why fiddle with this? */
	c-&gt;coal = (ulong*)(c-&gt;ram + cmd(c, CGcoaloff, 0));
	*c-&gt;coal = pbit32(25);

	dprint("dma stats:\n");
	rdmacmd(c, 1);
	sz = c-&gt;tx.segsz;
	i = dmatestcmd(c, DMAread, c-&gt;done.busaddr, sz);
	print("m10g: read %lud MB/s;", ((i&gt;&gt;16)*sz*2) / (i&amp;0xffff));
	i = dmatestcmd(c, DMAwrite, c-&gt;done.busaddr, sz);
	print(" write %lud MB/s;", ((i&gt;&gt;16)*sz*2) / (i&amp;0xffff));
	i = dmatestcmd(c, DMAwrite|DMAread, c-&gt;done.busaddr, sz);
	print(" r/w %lud MB/s\n", ((i&gt;&gt;16)*sz*2*2) / (i&amp;0xffff));
	memset(c-&gt;done.entry, 0, c-&gt;done.n * sizeof *c-&gt;done.entry);

	maccmd(c, CSmac, c-&gt;ra);
//	cmd(c, Cnopromisc, 0);
	cmd(c, Cenablefc, 0);
	e-&gt;maxmtu = Maxmtu;
	cmd(c, CSmtu, e-&gt;maxmtu);
	dprint("CSmtu %d...\n", e-&gt;maxmtu);

	poperror();
	return 0;
}

static void
ctlrfree(Ctlr *c)
{
	/* free up all the Block*s, too */
	free(c-&gt;tx.host);
	free(c-&gt;sm.host);
	free(c-&gt;bg.host);
	free(c-&gt;cmd);
	free(c-&gt;done.entry);
	free(c-&gt;stats);
	free(c);
}

static int
setmem(Pcidev *p, Ctlr *c)
{
	ulong i;
	uvlong raddr;
	Done *d;
	void *mem;

	c-&gt;tx.segsz = 2048;
	c-&gt;ramsz = 2*MiB - (2*48*KiB + 32*KiB) - 0x100;
	if(c-&gt;ramsz &gt; p-&gt;mem[0].size)
		return -1;

	raddr = p-&gt;mem[0].bar &amp; ~0x0F;
	mem = vmap(raddr, p-&gt;mem[0].size);
	if(mem == nil){
		print("m10g: can't map %8.8lux\n", p-&gt;mem[0].bar);
		return -1;
	}
	dprint("%llux &lt;- vmap(mem[0].size = %ux)\n", raddr, p-&gt;mem[0].size);
	c-&gt;port = raddr;
	c-&gt;ram = mem;
	c-&gt;cmd = malign(sizeof *c-&gt;cmd);
	c-&gt;cprt = PCIWADDR(c-&gt;cmd);

	d = &amp;c-&gt;done;
	d-&gt;n = Maxslots;
	d-&gt;m = d-&gt;n - 1;
	i = d-&gt;n * sizeof *d-&gt;entry;
	d-&gt;entry = malign(i);
	memset(d-&gt;entry, 0, i);
	d-&gt;busaddr = PCIWADDR(d-&gt;entry);

	c-&gt;stats = malign(sizeof *c-&gt;stats);
	memset(c-&gt;stats, 0, sizeof *c-&gt;stats);
	c-&gt;statsprt = PCIWADDR(c-&gt;stats);

	memmove(c-&gt;eprom, c-&gt;ram + c-&gt;ramsz - Epromsz, Epromsz-2);
	return setpcie(p) || parseeprom(c);
}

static Rx*
whichrx(Ctlr *c, int sz)
{
	if(sz &lt;= smpool.size)
		return &amp;c-&gt;sm;
	return &amp;c-&gt;bg;
}

static Block*
balloc(Rx* rx)
{
	Block *bp;

	ilock(rx-&gt;pool);
	if((bp = rx-&gt;pool-&gt;head) != nil){
		rx-&gt;pool-&gt;head = bp-&gt;next;
		bp-&gt;next = nil;
		_xinc(&amp;bp-&gt;ref);	/* prevent bp from being freed */
		rx-&gt;pool-&gt;n--;
	}
	iunlock(rx-&gt;pool);
	return bp;
}

static void
rbfree(Block *b, Bpool *p)
{
	b-&gt;rp = b-&gt;wp = (uchar*)PGROUND((uintptr)b-&gt;base);
 	b-&gt;flag &amp;= ~(Bipck | Budpck | Btcpck | Bpktck);

	ilock(p);
	b-&gt;next = p-&gt;head;
	p-&gt;head = b;
	p-&gt;n++;
	p-&gt;cnt++;
	iunlock(p);
}

static void
smbfree(Block *b)
{
	rbfree(b, &amp;smpool);
}

static void
bgbfree(Block *b)
{
	rbfree(b, &amp;bgpool);
}

static void
replenish(Rx *rx)
{
	ulong buf[16], i, idx, e;
	Bpool *p;
	Block *b;

	p = rx-&gt;pool;
	if(p-&gt;n &lt; 8)
		return;
	memset(buf, 0, sizeof buf);
	e = (rx-&gt;i - rx-&gt;cnt) &amp; ~7;
	e += rx-&gt;n;
	while(p-&gt;n &gt;= 8 &amp;&amp; e){
		idx = rx-&gt;cnt &amp; rx-&gt;m;
		for(i = 0; i &lt; 8; i++){
			b = balloc(rx);
			buf[i*2]   = pbit32((uvlong)PCIWADDR(b-&gt;wp) &gt;&gt; 32);
			buf[i*2+1] = pbit32(PCIWADDR(b-&gt;wp));
			rx-&gt;host[idx+i] = b;
			assert(b);
		}
		memmove(rx-&gt;lanai + 2*idx, buf, sizeof buf);
		coherence();
		rx-&gt;cnt += 8;
		e -= 8;
	}
	if(e &amp;&amp; p-&gt;n &gt; 7+1)
		print("m10g: should panic? pool-&gt;n = %d\n", p-&gt;n);
}

/*
 * future:
 * if (c-&gt;mtrr &gt;= 0) {
 *	c-&gt;tx.wcfifo = c-&gt;ram+0x200000;
 *	c-&gt;sm.wcfifo = c-&gt;ram+0x300000;
 *	c-&gt;bg.wcfifo = c-&gt;ram+0x340000;
 * }
 */

static int
nextpow(int j)
{
	int i;

	for(i = 0; j &gt; (1 &lt;&lt; i); i++)
		;
	return 1 &lt;&lt; i;
}

static void*
emalign(int sz)
{
	void *v;

	v = malign(sz);
	if(v == nil)
		error(Enomem);
	memset(v, 0, sz);
	return v;
}

static void
open0(Ether *e, Ctlr *c)
{
	Block *b;
	int i, sz, entries;

	entries = cmd(c, CGsendrgsz, 0) / sizeof *c-&gt;tx.lanai;
	c-&gt;tx.lanai = (Send*)(c-&gt;ram + cmd(c, CGsendoff, 0));
	c-&gt;tx.host  = emalign(entries * sizeof *c-&gt;tx.host);
	c-&gt;tx.bring = emalign(entries * sizeof *c-&gt;tx.bring);
	c-&gt;tx.n = entries;
	c-&gt;tx.m = entries-1;

	entries = cmd(c, CGrxrgsz, 0)/8;
	c-&gt;sm.pool = &amp;smpool;
	cmd(c, CSsmallsz, c-&gt;sm.pool-&gt;size);
	c-&gt;sm.lanai = (ulong*)(c-&gt;ram + cmd(c, CGsmallrxoff, 0));
	c-&gt;sm.n = entries;
	c-&gt;sm.m = entries-1;
	c-&gt;sm.host = emalign(entries * sizeof *c-&gt;sm.host);

	c-&gt;bg.pool = &amp;bgpool;
	c-&gt;bg.pool-&gt;size = nextpow(2 + e-&gt;maxmtu);  /* 2-byte alignment pad */
	cmd(c, CSbigsz, c-&gt;bg.pool-&gt;size);
	c-&gt;bg.lanai = (ulong*)(c-&gt;ram + cmd(c, CGbigrxoff, 0));
	c-&gt;bg.n = entries;
	c-&gt;bg.m = entries-1;
	c-&gt;bg.host = emalign(entries * sizeof *c-&gt;bg.host);

	sz = c-&gt;sm.pool-&gt;size + BY2PG;
	for(i = 0; i &lt; c-&gt;sm.n; i++){
		if((b = allocb(sz)) == 0)
			break;
		b-&gt;free = smbfree;
		freeb(b);
	}
	sz = c-&gt;bg.pool-&gt;size + BY2PG;
	for(i = 0; i &lt; c-&gt;bg.n; i++){
		if((b = allocb(sz)) == 0)
			break;
		b-&gt;free = bgbfree;
		freeb(b);
	}

	cmd(c, CSstatsdma, c-&gt;statsprt);
	c-&gt;linkstat = ~0;
	c-&gt;nrdma = 15;

	cmd(c, Cetherup, 0);
}

static Block*
nextblock(Ctlr *c)
{
	uint i;
	ushort l, k;
	Block *b;
	Done *d;
	Rx *rx;
	Slot *s;
	Slotparts *sp;

	d = &amp;c-&gt;done;
	s = d-&gt;entry;
	i = d-&gt;i &amp; d-&gt;m;
	sp = (Slotparts *)(s + i);
	l = sp-&gt;len;
	if(l == 0)
		return 0;
	k = sp-&gt;cksum;
	s[i] = 0;
	d-&gt;i++;
	l = gbit16((uchar*)&amp;l);
//dprint("nextb: i=%d l=%d\n", d-&gt;i, l);
	rx = whichrx(c, l);
	if(rx-&gt;i &gt;= rx-&gt;cnt){
		iprint("m10g: overrun\n");
		return 0;
	}
	i = rx-&gt;i &amp; rx-&gt;m;
	b = rx-&gt;host[i];
	rx-&gt;host[i] = 0;
	if(b == 0){
		iprint("m10g: error rx to no block.  memory is hosed.\n");
		return 0;
	}
	rx-&gt;i++;

	b-&gt;flag |= Bipck|Btcpck|Budpck;
	b-&gt;checksum = k;
	b-&gt;rp += 2;
	b-&gt;wp += 2+l;
	b-&gt;lim = b-&gt;wp;			/* lie like a dog. */
	return b;
}

static int
rxcansleep(void *v)
{
	Ctlr *c;
	Slot *s;
	Slotparts *sp;
	Done *d;

	c = v;
	d = &amp;c-&gt;done;
	s = c-&gt;done.entry;
	sp = (Slotparts *)(s + (d-&gt;i &amp; d-&gt;m));
	if(sp-&gt;len != 0)
		return -1;
	c-&gt;irqack[0] = pbit32(3);
	return 0;
}

static void
m10rx(void *v)
{
	Ether *e;
	Ctlr *c;
	Block *b;

	e = v;
	c = e-&gt;ctlr;
	for(;;){
		replenish(&amp;c-&gt;sm);
		replenish(&amp;c-&gt;bg);
		sleep(&amp;c-&gt;rxrendez, rxcansleep, c);
		while(b = nextblock(c))
			etheriq(e, b, 1);
	}
}

static void
txcleanup(Tx *tx, ulong n)
{
	Block *b;
	uint j, l, m;

	if(tx-&gt;npkt == n)
		return;
	l = 0;
	m = tx-&gt;m;
	/*
	 * if tx-&gt;cnt == tx-&gt;i, yet tx-&gt;npkt == n-1, we just
	 * caught ourselves and myricom card updating.
	 */
	for(;; tx-&gt;cnt++){
		j = tx-&gt;cnt &amp; tx-&gt;m;
		if(b = tx-&gt;bring[j]){
			tx-&gt;bring[j] = 0;
			tx-&gt;nbytes += BLEN(b);
			freeb(b);
			if(++tx-&gt;npkt == n)
				return;
		}
		if(tx-&gt;cnt == tx-&gt;i)
			return;
		if(l++ == m){
			iprint("m10g: tx ovrun: %lud %lud\n", n, tx-&gt;npkt);
			return;
		}
	}
}

static int
txcansleep(void *v)
{
	Ctlr *c;

	c = v;
	if(c-&gt;tx.cnt != c-&gt;tx.i &amp;&amp; c-&gt;tx.npkt != gbit32(c-&gt;stats-&gt;txcnt))
		return -1;
	return 0;
}

static void
txproc(void *v)
{
	Ether *e;
	Ctlr *c;
	Tx *tx;

	e = v;
	c = e-&gt;ctlr;
	tx = &amp;c-&gt;tx;
	for(;;){
 		sleep(&amp;c-&gt;txrendez, txcansleep, c);
		txcleanup(tx, gbit32(c-&gt;stats-&gt;txcnt));
	}
}

static void
submittx(Tx *tx, int n)
{
	Send *l, *h;
	int i0, i, m;

	m = tx-&gt;m;
	i0 = tx-&gt;i &amp; m;
	l = tx-&gt;lanai;
	h = tx-&gt;host;
	for(i = n-1; i &gt;= 0; i--)
		memmove(l+(i + i0 &amp; m), h+(i + i0 &amp; m), sizeof *h);
	tx-&gt;i += n;
//	coherence();
}

static int
nsegments(Block *b, int segsz)
{
	uintptr bus, end, slen, len;
	int i;

	bus = PCIWADDR(b-&gt;rp);
	i = 0;
	for(len = BLEN(b); len; len -= slen){
		end = bus + segsz &amp; ~(segsz-1);
		slen = end - bus;
		if(slen &gt; len)
			slen = len;
		bus += slen;
		i++;
	}
	return i;
}

static void
m10gtransmit(Ether *e)
{
	ushort slen;
	ulong i, cnt, rdma, nseg, count, end, bus, len, segsz;
	uchar flags;
	Block *b;
	Ctlr *c;
	Send *s, *s0, *s0m8;
	Tx *tx;

	c = e-&gt;ctlr;
	tx = &amp;c-&gt;tx;
	segsz = tx-&gt;segsz;

	qlock(tx);
	count = 0;
	s = tx-&gt;host + (tx-&gt;i &amp; tx-&gt;m);
	cnt = tx-&gt;cnt;
	s0 =   tx-&gt;host + (cnt &amp; tx-&gt;m);
	s0m8 = tx-&gt;host + ((cnt - 8) &amp; tx-&gt;m);
	i = tx-&gt;i;
	for(; s &gt;= s0 || s &lt; s0m8; i += nseg){
		if((b = qget(e-&gt;oq)) == nil)
			break;
		flags = SFfirst|SFnotso;
		if((len = BLEN(b)) &lt; 1520)
			flags |= SFsmall;
		rdma = nseg = nsegments(b, segsz);
		bus = PCIWADDR(b-&gt;rp);
		for(; len; len -= slen){
			end = (bus + segsz) &amp; ~(segsz-1);
			slen = end - bus;
			if(slen &gt; len)
				slen = len;
			s-&gt;low = pbit32(bus);
			s-&gt;len = pbit16(slen);
			s-&gt;nrdma = rdma;
			s-&gt;flags = flags;

			bus += slen;
			if(++s ==  tx-&gt;host + tx-&gt;n)
				s = tx-&gt;host;
			count++;
			flags &amp;= ~SFfirst;
			rdma = 1;
		}
		tx-&gt;bring[(i + nseg - 1) &amp; tx-&gt;m] = b;
		if(1 || count &gt; 0){
			submittx(tx, count);
			count = 0;
			cnt = tx-&gt;cnt;
			s0 =   tx-&gt;host + (cnt &amp; tx-&gt;m);
			s0m8 = tx-&gt;host + ((cnt - 8) &amp; tx-&gt;m);
		}
	}
	qunlock(tx);
}

static void
checkstats(Ether *e, Ctlr *c, Stats *s)
{
	ulong i;

	if(s-&gt;updated == 0)
		return;

	i = gbit32(s-&gt;linkstat);
	if(c-&gt;linkstat != i){
		e-&gt;link = i;
		if(c-&gt;linkstat = i)
			dprint("m10g: link up\n");
		else
			dprint("m10g: link down\n");
	}
	i = gbit32(s-&gt;nrdma);
	if(i != c-&gt;nrdma){
		dprint("m10g: rdma timeout %ld\n", i);
		c-&gt;nrdma = i;
	}
}

static void
waitintx(Ctlr *c)
{
	int i;

	for(i = 0; i &lt; 1024*1024; i++){
		if(c-&gt;stats-&gt;valid == 0)
			break;
		coherence();
	}
}

static void
m10ginterrupt(Ureg *, void *v)
{
	Ether *e;
	Ctlr *c;

	e = v;
	c = e-&gt;ctlr;

	if(c-&gt;state != Runed || c-&gt;stats-&gt;valid == 0)	/* not ready for us? */
		return;

	if(c-&gt;stats-&gt;valid &amp; 1)
		wakeup(&amp;c-&gt;rxrendez);
	if(gbit32(c-&gt;stats-&gt;txcnt) != c-&gt;tx.npkt)
		wakeup(&amp;c-&gt;txrendez);
	if(c-&gt;msi == 0)
		*c-&gt;irqdeass = 0;
	else
		c-&gt;stats-&gt;valid = 0;
	waitintx(c);
	checkstats(e, c, c-&gt;stats);
	c-&gt;irqack[1] = pbit32(3);
}

static void
m10gattach(Ether *e)
{
	Ctlr *c;
	char name[12];

	dprint("m10gattach\n");

	qlock(e-&gt;ctlr);
	c = e-&gt;ctlr;
	if(c-&gt;state != Detached){
		qunlock(c);
		return;
	}
	if(waserror()){
		c-&gt;state = Detached;
		qunlock(c);
		nexterror();
	}
	reset(e, c);
	c-&gt;state = Attached;
	open0(e, c);
	if(c-&gt;kprocs == 0){
		c-&gt;kprocs++;
		snprint(name, sizeof name, "#l%drxproc", e-&gt;ctlrno);
		kproc(name, m10rx, e);
		snprint(name, sizeof name, "#l%dtxproc", e-&gt;ctlrno);
		kproc(name, txproc, e);
	}
	c-&gt;state = Runed;
	qunlock(c);
	poperror();
}

static int
m10gdetach(Ctlr *c)
{
	dprint("m10gdetach\n");
//	reset(e-&gt;ctlr);
	vunmap(c-&gt;ram, c-&gt;pcidev-&gt;mem[0].size);
	ctlrfree(c);		/* this is a bad idea: don't free c */
	return -1;
}

static int
lstcount(Block *b)
{
	int i;

	i = 0;
	for(; b; b = b-&gt;next)
		i++;
	return i;
}

static long
m10gifstat(Ether *e, void *v, long n, ulong off)
{
	char *p;
	Ctlr *c;
	Stats s;

	c = e-&gt;ctlr;
	p = malloc(READSTR+1);
	if(p == nil)
		error(Enomem);
	/* no point in locking this because this is done via dma. */
	memmove(&amp;s, c-&gt;stats, sizeof s);

	snprint(p, READSTR,
		"txcnt = %lud\n"  "linkstat = %lud\n" 	"dlink = %lud\n"
		"derror = %lud\n" "drunt = %lud\n" 	"doverrun = %lud\n"
		"dnosm = %lud\n"  "dnobg = %lud\n"	"nrdma = %lud\n"
		"txstopped = %ud\n" "down = %ud\n" 	"updated = %ud\n"
		"valid = %ud\n\n"
		"tx pkt = %lud\n"  "tx bytes = %lld\n"
		"tx cnt = %ud\n"  "tx n = %ud\n"	"tx i = %ud\n"
		"sm cnt = %ud\n"  "sm i = %ud\n"	"sm n = %ud\n"
		"sm lst = %ud\n"
		"bg cnt = %ud\n"  "bg i = %ud\n"	"bg n = %ud\n"
		"bg lst = %ud\n"
		"segsz = %lud\n"   "coal = %lud\n",
		gbit32(s.txcnt),  gbit32(s.linkstat),	gbit32(s.dlink),
		gbit32(s.derror), gbit32(s.drunt),	gbit32(s.doverrun),
		gbit32(s.dnosm),  gbit32(s.dnobg),	gbit32(s.nrdma),
		s.txstopped,  s.down, s.updated, s.valid,
		c-&gt;tx.npkt, c-&gt;tx.nbytes,
		c-&gt;tx.cnt, c-&gt;tx.n, c-&gt;tx.i,
		c-&gt;sm.cnt, c-&gt;sm.i, c-&gt;sm.pool-&gt;n, lstcount(c-&gt;sm.pool-&gt;head),
		c-&gt;bg.cnt, c-&gt;bg.i, c-&gt;bg.pool-&gt;n, lstcount(c-&gt;bg.pool-&gt;head),
		c-&gt;tx.segsz, gbit32((uchar*)c-&gt;coal));

	n = readstr(off, v, n, p);
	free(p);
	return n;
}

//static void
//summary(Ether *e)
//{
//	char *buf;
//	int n, i, j;
//
//	if(e == 0)
//		return;
//	buf = malloc(n=250);
//	if(buf == 0)
//		return;
//
//	snprint(buf, n, "oq\n");
//	qsummary(e-&gt;oq, buf+3, n-3-1);
//	iprint("%s", buf);
//
//	if(e-&gt;f) for(i = 0; e-&gt;f[i]; i++){
//		j = snprint(buf, n, "f%d %d\n", i, e-&gt;f[i]-&gt;type);
//		qsummary(e-&gt;f[i]-&gt;in, buf+j, n-j-1);
//		print("%s", buf);
//	}
//
//	free(buf);
//}

static void
rxring(Ctlr *c)
{
	Done *d;
	Slot *s;
	Slotparts *sp;
	int i;

	d = &amp;c-&gt;done;
	s = d-&gt;entry;
	for(i = 0; i &lt; d-&gt;n; i++) {
		sp = (Slotparts *)(s + i);
		if(sp-&gt;len)
			iprint("s[%d] = %d\n", i, sp-&gt;len);
	}
}

enum {
	CMdebug,
	CMcoal,
	CMwakeup,
	CMtxwakeup,
	CMqsummary,
	CMrxring,
};

static Cmdtab ctab[] = {
	CMdebug,	"debug",	2,
	CMcoal,		"coal",		2,
	CMwakeup,	"wakeup",	1,
	CMtxwakeup,	"txwakeup",	1,
//	CMqsummary,	"q",		1,
	CMrxring,	"rxring",	1,
};

static long
m10gctl(Ether *e, void *v, long n)
{
	int i;
	Cmdbuf *c;
	Cmdtab *t;

	dprint("m10gctl\n");
	if(e-&gt;ctlr == nil)
		error(Enonexist);

	c = parsecmd(v, n);
	if(waserror()){
		free(c);
		nexterror();
	}
	t = lookupcmd(c, ctab, nelem(ctab));
	switch(t-&gt;index){
	case CMdebug:
		debug = (strcmp(c-&gt;f[1], "on") == 0);
		break;
	case CMcoal:
		i = atoi(c-&gt;f[1]);
		if(i &lt; 0 || i &gt; 1000)
			error(Ebadarg);
		*((Ctlr*)e-&gt;ctlr)-&gt;coal = pbit32(i);
		break;
	case CMwakeup:
		wakeup(&amp;((Ctlr*)e-&gt;ctlr)-&gt;rxrendez); /* you're kidding, right? */
		break;
	case CMtxwakeup:
		wakeup(&amp;((Ctlr*)e-&gt;ctlr)-&gt;txrendez); /* you're kidding, right? */
		break;
//	case CMqsummary:
//		summary(e);
//		break;
	case CMrxring:
		rxring(e-&gt;ctlr);
		break;
	default:
		error(Ebadarg);
	}
	free(c);
	poperror();
	return n;
}

static void
m10gshutdown(Ether *e)
{
	dprint("m10gshutdown\n");
	m10gdetach(e-&gt;ctlr);
}

static void
m10gpromiscuous(void *v, int on)
{
	Ether *e;
	int i;

	dprint("m10gpromiscuous\n");
	e = v;
	if(on)
		i = Cpromisc;
	else
		i = Cnopromisc;
	cmd(e-&gt;ctlr, i, 0);
}

static int	mcctab[]  = { CSleavemc, CSjoinmc };
static char	*mcntab[] = { "leave", "join" };

static void
m10gmulticast(void *v, uchar *ea, int on)
{
	Ether *e;
	int i;

	dprint("m10gmulticast\n");
	e = v;
	if((i = maccmd(e-&gt;ctlr, mcctab[on], ea)) != 0)
		print("m10g: can't %s %E: %d\n", mcntab[on], ea, i);
}

static void
m10gpci(void)
{
	Pcidev *p;
	Ctlr *t, *c;

	t = 0;
	for(p = 0; p = pcimatch(p, Vmyricom, 0); ){
		switch(p-&gt;did){
		case 0x8:		/* 8a */
			break;
		case 0x9:		/* 8a with msi-x fw */
		case 0xa:		/* 8b */
		case 0xb:		/* 8b2 */
		case 0xc:		/* 2-8b2 */
			/* untested */
			break;
		default:
			print("etherm10g: unknown myricom did %#ux\n", p-&gt;did);
			continue;
		}
		c = malloc(sizeof *c);
		if(c == nil)
			break;
		c-&gt;pcidev = p;
		c-&gt;id = p-&gt;did&lt;&lt;16 | p-&gt;vid;
		c-&gt;boot = pcicap(p, PciCapVND);
//		kickthebaby(p, c);
		pcisetbme(p);
		if(setmem(p, c) == -1){
			print("m10g: setmem failed\n");
			free(c);
			/* cleanup */
			continue;
		}
		if(t)
			t-&gt;next = c;
		else
			ctlrs = c;
		t = c;
	}
}

static int
m10gpnp(Ether *e)
{
	Ctlr *c;

	if(ctlrs == nil)
		m10gpci();

	for(c = ctlrs; c != nil; c = c-&gt;next)
		if(c-&gt;active)
			continue;
		else if(e-&gt;port == 0 || e-&gt;port == c-&gt;port)
			break;
	if(c == nil)
		return -1;
	c-&gt;active = 1;

	e-&gt;ctlr = c;
	e-&gt;port = c-&gt;port;
	e-&gt;irq = c-&gt;pcidev-&gt;intl;
	e-&gt;tbdf = c-&gt;pcidev-&gt;tbdf;
	e-&gt;mbps = 10000;
	memmove(e-&gt;ea, c-&gt;ra, Eaddrlen);

	e-&gt;attach = m10gattach;
	e-&gt;detach = m10gshutdown;
	e-&gt;transmit = m10gtransmit;
	e-&gt;interrupt = m10ginterrupt;
	e-&gt;ifstat = m10gifstat;
	e-&gt;ctl = m10gctl;
	e-&gt;shutdown = m10gshutdown;

	e-&gt;arg = e;
	e-&gt;promiscuous = m10gpromiscuous;
	e-&gt;multicast = m10gmulticast;
	return 0;
}

void
etherm10glink(void)
{
	addethercard("m10g", m10gpnp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

