<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ethervgbe.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ethervgbe.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * VIA Velocity gigabit ethernet.
 * Register info has been stolen from FreeBSD driver.
 *
 * Has been tested on:
 *	- VIA8237 (ABIT AV8): 100Mpbs Full duplex only.
 *	  It works enough to run replica/pull, vncv, ...
 *
 * To do:
 *	- 64/48 bits
 *	- autonegotiation
 *	- thresholds
 *	- dynamic ring sizing ??
 *	- link status change
 *	- shutdown
 *	- promiscuous
 *	- report error
 *	- Rx/Tx Csum
 *	- Jumbo frames
 *
 * Philippe Anel, xigh@free.fr
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"
#include "ethermii.h"

#define DEBUG

enum
{
	DumpIntr	= (1&lt;&lt;0),
	DumpRx		= (1&lt;&lt;1),
	DumpTx		= (1&lt;&lt;2),
};

#define htole16(x) (x)
#define htole32(x) (x)
#define le32toh(x) (x)

enum
{
	Timeout		= 50000,
	RxCount		= 256,
	TxCount		= 256,
	RxSize		= 2048,

	EthAddr		= 0x00,

	/* Command registers. */
	Cr0S		= 0x08,			/* Global command 0 (Set) */
	Cr0C		= 0x0c,			/* Global command 0 (Clear) */
		Cr0_Start	= 0x01,		/* - start MAC */
		Cr0_Stop	= 0x02,		/* - stop MAC */
		Cr0_EnableRx	= 0x04,		/* - turn on Rx engine */
		Cr0_EnableTx	= 0x08,		/* - turn on Tx engine */

	Cr1S		= 0x09,			/* Global command 1 (Set) */
	Cr1C		= 0x0d,			/* Global command 1 (Clear) */
		Cr1_NoPool	= 0x08,		/* - disable Rx/Tx desc pool */
		Cr1_reset	= 0x80,		/* - software reset */

	Cr2S		= 0x0a,			/* Global command 2 (Set) */
		Cr2_XonEnable	= 0x80,		/* - 802.3x XON/XOFF flow control */

	Cr3S		= 0x0b,			/* Global command 3 (Set) */
	Cr3C		= 0x0f,			/* Global command 3 (Set) */
		Cr3_IntMask	= 0x02,		/* - Mask all interrupts */

	/* Eeprom registers. */
	Eecsr		= 0x93,			/* EEPROM control/status */
		Eecsr_Autold	= 0x20,		/* - trigger reload from EEPROM */

	/* Mii registers. */
	MiiStatus	= 0x6D,			/* MII port status */
		MiiStatus_idle	= 0x80,		/* - idle */

	MiiCmd		= 0x70,			/* MII command */
		MiiCmd_write	= 0x20,		/* - write */
		MiiCmd_read	= 0x40,		/* - read */
		MiiCmd_auto	= 0x80,		/* - enable autopolling */

	MiiAddr		= 0x71,			/* MII address */
	MiiData		= 0x72,			/* MII data */

	/* 64 bits related registers. */
	TxDescHi	= 0x18,
	DataBufHi	= 0x1d,

	/* Rx engine registers. */
	RxDescLo	= 0x38,			/* Rx descriptor base address (lo 32 bits) */
	RxCsrS		= 0x32,			/* Rx descriptor queue control/status (Set) */
	RxCsrC		= 0x36,			/* Rx descriptor queue control/status (Clear) */
		RxCsr_RunQueue	= 0x01,		/* 	- enable queue */
		RxCsr_Active	= 0x02,		/* - queue active indicator */
		RxCsr_Wakeup	= 0x04,		/* - wake up queue */
		RxCsr_Dead	= 0x08,		/* - queue dead indicator */
	RxNum		= 0x50,			/* Size of Rx desc ring */
	RxDscIdx	= 0x3c,			/* Current Rx descriptor index */
	RxResCnt	= 0x5e,			/* Rx descriptor residue count */
	RxHostErr	= 0x23,			/* Rx host error status */
	RxTimer		= 0x3e,			/* Rx queue timer pend */
	RxControl	= 0x06,			/* MAC Rx control */
		RxControl_BadFrame = 0x01,	/* - accept CRC error frames */
		RxControl_Runt = 0x02,		/* - accept runts */
		RxControl_MultiCast = 0x04,	/* - accept multicasts */
		RxControl_BroadCast = 0x08,	/* - accept broadcasts */
		RxControl_Promisc = 0x10,	/* - promisc mode */
		RxControl_Giant = 0x20,		/* - accept VLAN tagged frames */
		RxControl_UniCast = 0x40,	/* - use perfect filtering */
		RxControl_SymbolErr = 0x80,	/* - accept symbol err packet */
	RxConfig	= 0x7e,			/* MAC Rx config */
		RxConfig_VlanFilter = 0x01,	/* - filter VLAN ID mismatches */
		RxConfig_VlanOpt0 = (0&lt;&lt;1),	/* - TX: no tag insert, RX: all, no extr */
		RxConfig_VlanOpt1 = (1&lt;&lt;1),	/* - TX: no tag insert, RX: tagged pkts, no extr */
		RxConfig_VlanOpt2 = (2&lt;&lt;1),	/* - TX: tag insert, RX: all, extract tags */
		RxConfig_VlanOpt3 = (3&lt;&lt;1),	/* - TX: tag insert, RX: tagged pkts, with extr */
		RxConfig_FifoLowWat = 0x08,	/* - RX FIFO low watermark (7QW/15QW) */
		RxConfig_FifoTh128 = (0&lt;&lt;4),	/* - RX FIFO threshold 128 bytes */
		RxConfig_FifoTh512 = (1&lt;&lt;4),	/* - RX FIFO threshold 512 bytes */
		RxConfig_FifoTh1024 = (2&lt;&lt;4),	/* - RX FIFO threshold 1024 bytes */
		RxConfig_FifoThFwd = (3&lt;&lt;4),	/* - RX FIFO threshold ??? */
		RxConfig_ArbPrio = 0x80,	/* - arbitration priority */

	/* Tx engine registers. */
	TxDescLo	= 0x40,			/* Tx descriptor base address (lo 32 bits) */
	TxCsrS		= 0x30,			/* Tx descriptor queue control/status (Set) */
	TxCsrC		= 0x38,			/* Tx descriptor queue control/status (Clear) */
		TxCsr_RunQueue	= 0x01,		/* 	- enable queue */
		TxCsr_Active	= 0x02,		/* - queue active indicator */
		TxCsr_Wakeup	= 0x04,		/* - wake up queue */
		TxCsr_Dead	= 0x08,		/* - queue dead indicator */
	TxNum		= 0x52,			/* Size of Tx desc ring */
	TxDscIdx	= 0x54,			/* Current Tx descriptor index */
	TxHostErr	= 0x22,			/* Tx host error status */
	TxTimer		= 0x3f,			/* Tx queue timer pend */
	TxControl	= 0x07,			/* MAC Rx control */
		TxControl_LC_Off = (0&lt;&lt;0),	/* - loopback control off */
		TxControl_LC_Mac = (1&lt;&lt;0),	/* - loopback control MAC internal */
		TxControl_LC_Ext = (2&lt;&lt;0),	/* - loopback control external */
		TxControl_Coll16 = (0&lt;&lt;2),	/* - one set of 16 retries */
		TxControl_Coll32 = (1&lt;&lt;2),	/* - two sets of 16 retries */
		TxControl_Coll48 = (2&lt;&lt;2),	/* - three sets of 16 retries */
		TxControl_CollInf = (3&lt;&lt;2),	/* - retry forever */

	TxConfig	= 0x7f,			/* MAC Tx config */
		TxConfig_SnapOpt = 0x01,	/* - 1 == insert VLAN tag at 13th byte, */
										/*	  0 == insert VLAN tag after SNAP header (21st byte) */
		TxConfig_NonBlk	= 0x02,		/* - priority TX/non-blocking mode */
		TxConfig_Blk64	= (0&lt;&lt;3),	/* - non-blocking threshold 64 packets */
		TxConfig_Blk32	= (1&lt;&lt;3),	/* - non-blocking threshold 32 packets */
		TxConfig_Blk128	= (2&lt;&lt;3),	/* - non-blocking threshold 128 packets */
		TxConfig_Blk8	= (3&lt;&lt;3),	/* - non-blocking threshold 8 packets */
		TxConfig_ArbPrio	= 0x80,	/* - arbitration priority */

	/* Timer registers. */
	Timer0		= 0x74,			/* single-shot timer */
	Timer1		= 0x76,			/* periodic timer */

	/* Chip config registers. */
	ChipCfgA	= 0x78,			/* chip config A */
	ChipCfgB	= 0x79,			/* chip config B */
	ChipCfgC	= 0x7a,			/* chip config C */
	ChipCfgD	= 0x7b,			/* chip config D */

	/* DMA config registers. */
	DmaCfg0		= 0x7C,			/* DMA config 0 */
	DmaCfg1		= 0x7D,			/* DMA config 1 */

	/* Interrupt registers. */
	IntCtl		= 0x20,			/* Interrupt control */
	Imr		= 0x28,			/* Interrupt mask */
	Isr		= 0x24,			/* Interrupt status */
		Isr_RxHiPrio	= (1&lt;&lt;0),	/* - hi prio Rx int */
		Isr_TxHiPrio	= (1&lt;&lt;1),	/* - hi prio Tx int */
		Isr_RxComplete	= (1&lt;&lt;2),	/* - Rx queue completed */
		Isr_TxComplete	= (1&lt;&lt;3),	/* - One of Tx queues completed */

		Isr_TxComplete0	= (1&lt;&lt;4),	/* - Tx queue 0 completed */
		Isr_TxComplete1	= (1&lt;&lt;5),	/* - Tx queue 1 completed */
		Isr_TxComplete2	= (1&lt;&lt;6),	/* - Tx queue 2 completed */
		Isr_TxComplete3	= (1&lt;&lt;7),	/* - Tx queue 3 completed */

		Isr_Reserved8	= (1&lt;&lt;8),	/* - reserved */
		Isr_Reserver9	= (1&lt;&lt;9),	/* - reserved */
		Isr_RxCountOvflow = (1&lt;&lt;10),	/* - Rx packet count overflow */
		Isr_RxPause	= (1&lt;&lt;11),	/* - pause frame Rx */

		Isr_RxFifoOvflow = (1&lt;&lt;12),	/* - RX FIFO overflow */
		Isr_RxNoDesc	= (1&lt;&lt;13),	/* - ran out of Rx descriptors */
		Isr_RxNoDescWar	= (1&lt;&lt;14),	/* - running out of Rx descriptors */
		Isr_LinkStatus	= (1&lt;&lt;15),	/* - link status change */

		Isr_Timer0	= (1&lt;&lt;16),	/* - one shot timer expired */
		Isr_Timer1	= (1&lt;&lt;17),	/* - periodic timer expired */
		Isr_Power	= (1&lt;&lt;18),	/* - wake up power event */
		Isr_PhyIntr	= (1&lt;&lt;19),	/* - PHY interrupt */

		Isr_Stopped	= (1&lt;&lt;20),	/* - software shutdown complete */
		Isr_MibOvflow	= (1&lt;&lt;21),	/* - MIB counter overflow warning */
		Isr_SoftIntr	= (1&lt;&lt;22),	/* - software interrupt */
		Isr_HoldOffReload = (1&lt;&lt;23),	/* - reload hold timer */

		Isr_RxDmaStall	= (1&lt;&lt;24),	/* - Rx DMA stall */
		Isr_TxDmaStall	= (1&lt;&lt;25),	/* - Tx DMA stall */
		Isr_Reserved26	= (1&lt;&lt;26),	/* - reserved */
		Isr_Reserved27	= (1&lt;&lt;27),	/* - reserved */

		Isr_Source0	= (1&lt;&lt;28),	/* - interrupt source indication */
		Isr_Source1	= (1&lt;&lt;29),	/* - interrupt source indication */
		Isr_Source2	= (1&lt;&lt;30),	/* - interrupt source indication */
		Isr_Source3	= (1&lt;&lt;31),	/* - interrupt source indication */

	Isr_Mask = Isr_TxComplete0|Isr_RxComplete|Isr_Stopped|
			Isr_RxFifoOvflow|Isr_PhyIntr|Isr_LinkStatus|
			Isr_RxNoDesc|Isr_RxDmaStall|Isr_TxDmaStall
};

typedef struct Frag Frag;
struct Frag
{
	ulong	addr_lo;
	ushort	addr_hi;
	ushort	length;
};

typedef struct RxDesc RxDesc;
struct RxDesc
{
	ulong	status;
	ulong	control;
	Frag;
};

typedef struct TxDesc TxDesc;
struct TxDesc
{
	ulong	status;
	ulong	control;
	Frag	frags[7];
};

enum
{
	RxDesc_Status_VidMiss	= (1&lt;&lt;0),	/* VLAN tag filter miss */
	RxDesc_Status_CrcErr	= (1&lt;&lt;1),	/* bad CRC error */
	RxDesc_Status_FrAlErr	= (1&lt;&lt;3),	/* frame alignment error */
	RxDesc_Status_CsumErr	= (1&lt;&lt;3),	/* bad TCP/IP checksum */
	RxDesc_Status_RxLenErr	= (1&lt;&lt;4),	/* Rx length error */
	RxDesc_Status_SymErr	= (1&lt;&lt;5),	/* PCS symbol error */
	RxDesc_Status_SnTag	= (1&lt;&lt;6),	/* RX'ed tagged SNAP pkt */
	RxDesc_Status_DeTag	= (1&lt;&lt;7),	/* VLAN tag extracted */

	RxDesc_Status_OneFrag	= (0&lt;&lt;8),	/* only one fragment */
	RxDesc_Status_FirstFrag	= (1&lt;&lt;8),	/* first frag in frame */
	RxDesc_Status_LastFrag	= (2&lt;&lt;8),	/* last frag in frame */
	RxDesc_Status_MidFrag	= (3&lt;&lt;8),	/* intermediate frag */

	RxDesc_Status_Vtag	= (1&lt;&lt;10),	/* VLAN tag indicator */
	RxDesc_Status_UniCast	= (1&lt;&lt;11),	/* unicast frame */
	RxDesc_Status_BroadCast	= (1&lt;&lt;12),	/* broadcast frame */
	RxDesc_Status_MultiCast	= (1&lt;&lt;13),	/* multicast frame */
	RxDesc_Status_Perfect	= (1&lt;&lt;14),	/* perfect filter hit */
	RxDesc_Status_Goodframe	= (1&lt;&lt;15),	/* frame is good. */

	RxDesc_Status_SizShift	= 16,		/* received frame len shift */
	RxDesc_Status_SizMask	= 0x3FFF,	/* received frame len mask */

	RxDesc_Status_Shutdown	= (1&lt;&lt;30),	/* shutdown during RX */
	RxDesc_Status_Own	= (1&lt;&lt;31),	/* own bit */

	/* ... */
	TxDesc_Status_Own	= (1&lt;&lt;31),	/* own bit */

	/* ... */
	TxDesc_Control_Intr	= (1&lt;&lt;23),	/* Tx intr request */
	TxDesc_Control_Normal	= (3&lt;&lt;24),	/* normal frame */
};

typedef struct Stats Stats;
struct Stats
{
	ulong	rx;
	ulong	tx;
	ulong	txe;
	ulong	intr;
};

typedef struct Ctlr Ctlr;
struct Ctlr
{
	Ctlr*	link;
	Pcidev*	pdev;
	int	port;

	int	inited;
	Lock	init_lock;

	ulong	debugflags;
	ulong	debugcount;

	Mii*	mii;
	int	active;
	uchar	ea[6];

	RxDesc*	rx_ring;
	Block*	rx_blocks[RxCount];

	Lock	tx_lock;
	TxDesc*	tx_ring;
	Block*	tx_blocks[TxCount];
	ulong	tx_count;

	Stats	stats;
};

static Ctlr* vgbehead;
static Ctlr* vgbetail;

#define riob(c, r)	inb(c-&gt;port + r)
#define riow(c, r)	ins(c-&gt;port + r)
#define riol(c, r)	inl(c-&gt;port + r)
#define wiob(c, r, d)	outb(c-&gt;port + r, d)
#define wiow(c, r, d)	outs(c-&gt;port + r, d)
#define wiol(c, r, d)	outl(c-&gt;port + r, d)

#define siob(c, r, b)	wiob(c, r, riob(c, r) | b)
#define siow(c, r, b)	wiow(c, r, riob(c, r) | b)
#define siol(c, r, b)	wiol(c, r, riob(c, r) | b)
#define ciob(c, r, b)	wiob(c, r, riob(c, r) &amp; ~b)
#define ciow(c, r, b)	wiow(c, r, riob(c, r) &amp; ~b)
#define ciol(c, r, b)	wiol(c, r, riob(c, r) &amp; ~b)

static int
vgbemiiw(Mii* mii, int phy, int addr, int data)
{
	Ctlr* ctlr;
	int i;

	if(phy != 1)
		return -1;

	ctlr = mii-&gt;ctlr;

	wiob(ctlr, MiiAddr, addr);
	wiow(ctlr, MiiData, (ushort) data);
	wiob(ctlr, MiiCmd, MiiCmd_write);

	for(i = 0; i &lt; Timeout; i++)
		if((riob(ctlr, MiiCmd) &amp; MiiCmd_write) == 0)
			break;

	if(i &gt;= Timeout){
		print("vgbe: miiw timeout\n");
		return -1;
	}

	return 0;
}

static int
vgbemiir(Mii* mii, int phy, int addr)
{
	Ctlr* ctlr;
	int i;

	if(phy != 1)
		return -1;

	ctlr = mii-&gt;ctlr;

	wiob(ctlr, MiiAddr, addr);
	wiob(ctlr, MiiCmd, MiiCmd_read);

	for(i = 0; i &lt; Timeout; i++)
		if((riob(ctlr, MiiCmd) &amp; MiiCmd_read) == 0)
			break;

	if(i &gt;= Timeout){
		print("vgbe: miir timeout\n");
		return -1;
	}

	return riow(ctlr, MiiData);
}

static long
vgbeifstat(Ether* edev, void* a, long n, ulong offset)
{
	char* p;
	Ctlr* ctlr;
	int l;

	ctlr = edev-&gt;ctlr;

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	l = 0;
	l += snprint(p+l, READSTR-l, "tx: %uld\n", ctlr-&gt;stats.tx);
	l += snprint(p+l, READSTR-l, "tx [errs]: %uld\n", ctlr-&gt;stats.txe);
	l += snprint(p+l, READSTR-l, "rx: %uld\n", ctlr-&gt;stats.rx);
	l += snprint(p+l, READSTR-l, "intr: %uld\n", ctlr-&gt;stats.intr);
	snprint(p+l, READSTR-l, "\n");

	n = readstr(offset, a, n, p);
	free(p);

	return n;
}

static char* vgbeisr_info[] = {
	"hi prio Rx int",
	"hi prio Tx int",
	"Rx queue completed",
	"One of Tx queues completed",
	"Tx queue 0 completed",
	"Tx queue 1 completed",
	"Tx queue 2 completed",
	"Tx queue 3 completed",
	"reserved",
	"reserved",
	"Rx packet count overflow",
	"pause frame Rx'ed",
	"RX FIFO overflow",
	"ran out of Rx descriptors",
	"running out of Rx descriptors",
	"link status change",
	"one shot timer expired",
	"periodic timer expired",
	"wake up power event",
	"PHY interrupt",
	"software shutdown complete",
	"MIB counter overflow warning",
	"software interrupt",
	"reload hold timer",
	"Rx DMA stall",
	"Tx DMA stall",
	"reserved",
	"reserved",
	"interrupt source indication 0",
	"interrupt source indication 1",
	"interrupt source indication 2",
	"interrupt source indication 3",
};

static void
vgbedumpisr(ulong isr)
{
	int i;

	for(i = 0; i &lt; 32; i++){
		ulong mask;

		mask = 1&lt;&lt;i;
		if(isr &amp; mask)
			print("vgbe: irq:  - %02d : %c %s\n", i,
			 	Isr_Mask &amp; mask ? '*' : '-', vgbeisr_info[i]);
	}
}

static void
noop(Block *)
{
}

static int
vgbenewrx(Ctlr* ctlr, int i)
{
	Block* block;
	RxDesc* desc;

	/*
	 * allocate a receive Block.  we're maintaining
	 * a private pool of Blocks, so we don't want freeb
	 * to actually free them, thus we set block-&gt;free.
	 */
	block = allocb(RxSize);
	block-&gt;free = noop;

	/* Remember that block. */
	ctlr-&gt;rx_blocks[i] = block;

	/* Initialize Rx descriptor. (TODO: 48/64 bits support ?) */
	desc = &amp;ctlr-&gt;rx_ring[i];
	desc-&gt;status = htole32(RxDesc_Status_Own);
	desc-&gt;control = htole32(0);

	desc-&gt;addr_lo = htole32((ulong)PCIWADDR(block-&gt;rp));
	desc-&gt;addr_hi = htole16(0);
	desc-&gt;length = htole16(RxSize | 0x8000);

	return 0;
}

static void
vgberxeof(Ether* edev)
{
	Ctlr* ctlr;
	int i;
	Block* block;
	ulong length, status;
	RxDesc* desc;

	ctlr = edev-&gt;ctlr;

	if(ctlr-&gt;debugflags &amp; DumpRx)
		print("vgbe: rx_eof\n");

	for(i = 0; i &lt; RxCount; i++){
		/* Remember that block. */
		desc = &amp;ctlr-&gt;rx_ring[i];

		status = le32toh(desc-&gt;status);

		if(status &amp; RxDesc_Status_Own)
			continue;

		if(status &amp; RxDesc_Status_Goodframe){
			length = status &gt;&gt; RxDesc_Status_SizShift;
			length &amp;= RxDesc_Status_SizMask;

			if(ctlr-&gt;debugflags &amp; DumpRx)
				print("vgbe: Rx-desc[%03d] status=%#08ulx ctl=%#08ulx len=%uld bytes\n",
					i, status, desc-&gt;control, length);

			block = ctlr-&gt;rx_blocks[i];
			block-&gt;wp = block-&gt;rp + length;

			ctlr-&gt;stats.rx++;
			etheriq(edev, block, 1);
		}
		else
			print("vgbe: Rx-desc[%#02x] *BAD FRAME* status=%#08ulx ctl=%#08ulx\n",
				i, status, desc-&gt;control);

		/* reset packet ... */
		desc-&gt;status = htole32(RxDesc_Status_Own);
		desc-&gt;control = htole32(0);
	}

	if(ctlr-&gt;debugflags &amp; DumpRx)
		print("vgbe: rx_eof: done\n");

	wiow(ctlr, RxResCnt, RxCount);
	wiob(ctlr, RxCsrS, RxCsr_Wakeup);
}

static void
vgbetxeof(Ether* edev)
{
	Ctlr* ctlr;
	int i, count;
	Block* block;
	ulong status;

	ctlr = edev-&gt;ctlr;

	ilock(&amp;ctlr-&gt;tx_lock);

	if(ctlr-&gt;debugflags &amp; DumpTx)
		print("vgbe: tx_eof\n");

	for(count = 0, i = 0; i &lt; TxCount; i++){
		block = ctlr-&gt;tx_blocks[i];
		if(block == nil)
			continue;

		status = le32toh(ctlr-&gt;tx_ring[i].status);
		if(status &amp; TxDesc_Status_Own)
			continue;

		/* Todo add info if it failed */
		ctlr-&gt;stats.tx++;

		if(ctlr-&gt;debugflags &amp; DumpTx)
			print("vgbe: Block[%03d]:%#p has been sent\n", i, block);

		count++;
		ctlr-&gt;tx_blocks[i] = nil;
		freeb(block);

		if(ctlr-&gt;debugflags &amp; DumpTx)
			print("vgbe: Block[%03d]:%#p has been freed\n", i, block);
	}
	ctlr-&gt;tx_count -= count;

	if(ctlr-&gt;debugflags &amp; DumpTx)
		print("vgbe: tx_eof: done [count=%d]\n", count);

	iunlock(&amp;ctlr-&gt;tx_lock);

	if(ctlr-&gt;tx_count)
		wiob(ctlr, TxCsrS, TxCsr_Wakeup);
}

static void
vgbeinterrupt(Ureg *, void* arg)
{
	Ether* edev;
	Ctlr* ctlr;
	ulong status;

	edev = (Ether *) arg;
	if(edev == nil)
		return;

	ctlr = edev-&gt;ctlr;
	if(ctlr == nil)
		return;

	/* Mask interrupts. */
	wiol(ctlr, Imr, 0);

	status = riol(ctlr, Isr);
	if(status == 0xffff)
		goto end;

	/* acknowledge */
	if(status)
		wiol(ctlr, Isr, status);

	if((status &amp; Isr_Mask) == 0)
		goto end;

	ctlr-&gt;stats.intr++;

	if(ctlr-&gt;debugflags &amp; DumpIntr)
		if(ctlr-&gt;debugcount){
			print("vgbe: irq: status = %#08ulx\n", status);
			vgbedumpisr(status);
			ctlr-&gt;debugcount--;
		}

	if(status &amp; Isr_RxComplete)
		vgberxeof(edev);

	if(status &amp; Isr_TxComplete0)
		vgbetxeof(edev);

	if(status &amp; Isr_Stopped)
		print("vgbe: irq: software shutdown complete\n");

	if(status &amp; Isr_RxFifoOvflow)
		print("vgbe: irq: RX FIFO overflow\n");

	if(status &amp; Isr_PhyIntr)
		print("vgbe: irq: PHY interrupt\n");

	if(status &amp; Isr_LinkStatus)
		print("vgbe: irq: link status change\n");

	if(status &amp; Isr_RxNoDesc)
		print("vgbe: irq: ran out of Rx descriptors\n");

	if(status &amp; Isr_RxDmaStall){
		print("vgbe: irq: Rx DMA stall\n");
		wiol(ctlr, Cr3C, Cr3_IntMask);
		return;
	}

	if(status &amp; Isr_TxDmaStall){
		print("vgbe: irq: Tx DMA stall\n");
		wiol(ctlr, Cr3C, Cr3_IntMask);
		return;
	}

end:
	/* Unmask interrupts. */
	wiol(ctlr, Imr, ~0);
}

static void
vgbetransmit(Ether* edev)
{
	Block* block;
	Ctlr* ctlr;
	int i, index, start, count;
	TxDesc* desc;
	ulong status, length;

	ctlr = edev-&gt;ctlr;

	ilock(&amp;ctlr-&gt;tx_lock);

	start = riow(ctlr, TxDscIdx);

	if(ctlr-&gt;debugflags &amp; DumpTx)
		print("vgbe: transmit (start=%d)\n", start);

	/* find empty slot */
	for(count = 0, i = 0; i &lt; TxCount; i++){
		index = (i + start) % TxCount;

		if(ctlr-&gt;tx_blocks[index])
			continue;

		desc = &amp;ctlr-&gt;tx_ring[index];

		status = le32toh(desc-&gt;status);
		if(status &amp; TxDesc_Status_Own)
			continue;

		block = qget(edev-&gt;oq);
		if(block == nil)
			break;

		count++;

		length = BLEN(block);

		if(ctlr-&gt;debugflags &amp; DumpTx)
			print("vgbe: Tx-Desc[%03d] Block:%#p, addr=%#08ulx, len:%ld\n", index, block,
				PCIWADDR(block-&gt;rp), length);

		ctlr-&gt;tx_blocks[index] = block;

		/* Initialize Tx descriptor. */
		desc-&gt;status = htole32((length&lt;&lt;16)|TxDesc_Status_Own);
		desc-&gt;control = htole32(TxDesc_Control_Intr|TxDesc_Control_Normal|((1+1)&lt;&lt;28));

		desc-&gt;frags[0].addr_lo = htole32((ulong) PCIWADDR(block-&gt;rp));
		desc-&gt;frags[0].addr_hi = htole16(0);
		desc-&gt;frags[0].length = htole16(length);
	}
	ctlr-&gt;tx_count += count;

	if(ctlr-&gt;debugflags &amp; DumpTx)
		print("vgbe: transmit: done [count=%d]\n", count);

	iunlock(&amp;ctlr-&gt;tx_lock);

	if(ctlr-&gt;tx_count)
		wiob(ctlr, TxCsrS, TxCsr_Wakeup);

	if((ctlr-&gt;debugflags &amp; DumpTx) &amp;&amp; count == 0)
		print("vgbe: transmit: no Tx entry available\n");
}

static void
vgbeattach(Ether* edev)
{
	Ctlr* ctlr;
	RxDesc* rxdesc;
	TxDesc* txdesc;
	int i;

	ctlr = edev-&gt;ctlr;

	lock(&amp;ctlr-&gt;init_lock);
	if(ctlr-&gt;inited){
		unlock(&amp;ctlr-&gt;init_lock);
		return;
	}

//	print("vgbe: attach\n");

	/* Allocate Rx ring.  (TODO: Alignment ?) */
	rxdesc = mallocalign(RxCount* sizeof(RxDesc), 256, 0, 0);
	if(rxdesc == nil){
		print("vgbe: unable to alloc Rx ring\n");
		unlock(&amp;ctlr-&gt;init_lock);
		return;
	}
	ctlr-&gt;rx_ring = rxdesc;

	/* Allocate Rx blocks, initialize Rx ring. */
	for(i = 0; i &lt; RxCount; i++)
		vgbenewrx(ctlr, i);

	/* Init Rx MAC. */
	wiob(ctlr, RxControl,
		RxControl_MultiCast|RxControl_BroadCast|RxControl_UniCast);
	wiob(ctlr, RxConfig, RxConfig_VlanOpt0);

	/* Load Rx ring. */
	wiol(ctlr, RxDescLo, (ulong) PCIWADDR(rxdesc));
	wiow(ctlr, RxNum, RxCount - 1);
	wiow(ctlr, RxDscIdx, 0);
	wiow(ctlr, RxResCnt, RxCount);

	/* Allocate Tx ring. */
	txdesc = mallocalign(TxCount* sizeof(TxDesc), 256, 0, 0);
	if(txdesc == nil){
		print("vgbe: unable to alloc Tx ring\n");
		unlock(&amp;ctlr-&gt;init_lock);
		return;
	}
	ctlr-&gt;tx_ring = txdesc;

	/* Init DMAs */
	wiob(ctlr, DmaCfg0, 4);

	/* Init Tx MAC. */
	wiob(ctlr, TxControl, 0);
	wiob(ctlr, TxConfig, TxConfig_NonBlk|TxConfig_ArbPrio);

	/* Load Tx ring. */
	wiol(ctlr, TxDescLo, (ulong) PCIWADDR(txdesc));
	wiow(ctlr, TxNum, TxCount - 1);
	wiow(ctlr, TxDscIdx, 0);

	/* Enable Xon/Xoff */
	wiob(ctlr, Cr2S, 0xb|Cr2_XonEnable);

	/* Enable Rx queue */
	wiob(ctlr, RxCsrS, RxCsr_RunQueue);

	/* Enable Tx queue */
	wiob(ctlr, TxCsrS, TxCsr_RunQueue);

	/* Done */
	ctlr-&gt;inited = 1;
	unlock(&amp;ctlr-&gt;init_lock);

	/* Enable interrupts */
	wiol(ctlr, Isr, 0xffffffff);
	wiob(ctlr, Cr3S, Cr3_IntMask);

	/* Wake up Rx queue */
	wiob(ctlr, RxCsrS, RxCsr_Wakeup);
}

static void
vgbereset(Ctlr* ctlr)
{
//	MiiPhy* phy;
	int timeo, i;

//	print("vgbe: reset\n");

	/* Soft reset the controller. */
	wiob(ctlr, Cr1S, Cr1_reset);

	for(timeo = 0; timeo &lt; Timeout; timeo++)
		if((riob(ctlr, Cr1S) &amp; Cr1_reset) == 0)
			break;

	if(timeo &gt;= Timeout){
		print("vgbe: softreset timeout\n");
		return;
	}

	/* Reload eeprom. */
	siob(ctlr, Eecsr, Eecsr_Autold);

	for(timeo = 0; timeo &lt; Timeout; timeo++)
		if((riob(ctlr, Eecsr) &amp; Eecsr_Autold) == 0)
			break;

	if(timeo &gt;= Timeout){
		print("vgbe: eeprom reload timeout\n");
		return;
	}

	/* Load the MAC address. */
	for(i = 0; i &lt; Eaddrlen; i++)
		ctlr-&gt;ea[i] = riob(ctlr, EthAddr+i);

	/* Initialize interrupts. */
	wiol(ctlr, Isr, 0xffffffff);
	wiol(ctlr, Imr, 0xffffffff);

	/* Disable interrupts. */
	wiol(ctlr, Cr3C, Cr3_IntMask);

	/* 32 bits addresses only. (TODO: 64 bits ?) */
	wiol(ctlr, TxDescHi, 0);
	wiow(ctlr, DataBufHi, 0);

	/* Enable MAC (turning off Rx/Tx engines for the moment). */
	wiob(ctlr, Cr0C, Cr0_Stop|Cr0_EnableRx|Cr0_EnableTx);
	wiob(ctlr, Cr0S, Cr0_Start);

	/* Initialize Rx engine. */
	wiow(ctlr, RxCsrC, RxCsr_RunQueue);

	/* Initialize Tx engine. */
	wiow(ctlr, TxCsrC, TxCsr_RunQueue);

	/* Enable Rx/Tx engines. */
	wiob(ctlr, Cr0S, Cr0_EnableRx|Cr0_EnableTx);

	/* Initialize link management. */
	ctlr-&gt;mii = malloc(sizeof(Mii));
	if(ctlr-&gt;mii == nil){
		print("vgbe: unable to alloc Mii\n");
		return;
	}

	ctlr-&gt;mii-&gt;mir = vgbemiir;
	ctlr-&gt;mii-&gt;miw = vgbemiiw;
	ctlr-&gt;mii-&gt;ctlr = ctlr;

	if(mii(ctlr-&gt;mii, 1&lt;&lt;1) == 0){
		print("vgbe: no phy found\n");
		return;
	}

//	phy = ctlr-&gt;mii-&gt;curphy;
//	print("vgbe: phy:oui %#x\n", phy-&gt;oui);
}

static void
vgbepci(void)
{
	Pcidev* pdev;

//	print("vgbe: pci\n");

	pdev = nil;
	while(pdev = pcimatch(pdev, 0, 0)){
		Ctlr* ctlr;
		int port, size;

		if(pdev-&gt;ccrb != 0x02 || pdev-&gt;ccru != 0)
			continue;

		switch((pdev-&gt;did&lt;&lt;16) | pdev-&gt;vid){
		default:
			continue;

		case (0x3119&lt;&lt;16)|0x1106:	/* VIA Velocity (VT6122) */
			break;
		}

		if((pdev-&gt;pcr &amp; 1) == 0){
			print("vgbe: io not enabled [pcr=%#lux]\n", (ulong)pdev-&gt;pcr);
			continue;
		}

		pcisetbme(pdev);
		pcisetpms(pdev, 0);

		port = pdev-&gt;mem[0].bar;
		size = pdev-&gt;mem[0].size;

		if((port &amp; 1) == 0){
			print("vgbe: bar[0]=%#x is not io\n", port);
			continue;
		}

		if(port &gt; 0xff00){
			print("vgbe: invalid port %#ux\n", port);
			continue;
		}

		port &amp;= 0xfffe;

		if(size != 256){
			print("vgbe: invalid io size: %d\n", size);
			continue;
		}

		if(ioalloc(port, size, 0, "vge") &lt; 0){
			print("vgbe: port %#ux already in use\n", port);
			continue;
		}

		ctlr = malloc(sizeof(Ctlr));
		if(ctlr == nil){
			print("vgbe: unable to alloc Ctlr\n");
			iofree(port);
			continue;
		}

		ctlr-&gt;pdev = pdev;
		ctlr-&gt;port = port;
		ctlr-&gt;inited = 0;

		if(vgbehead != nil)
			vgbetail-&gt;link = ctlr;
		else
			vgbehead = ctlr;
		vgbetail = ctlr;
	}
}

static long
vgbectl(Ether* edev, void* buf, long n)
{
	Cmdbuf* cb;
	Ctlr* ctlr;
	ulong index;
	char* rptr;
	RxDesc* rd;
	TxDesc* td;
	uchar* p;

	ctlr = edev-&gt;ctlr;

	cb = parsecmd(buf, n);
	if(waserror()){
		free(cb);
		nexterror();
	}

	if(cistrcmp(cb-&gt;f[0], "reset") == 0){
		vgbereset(ctlr);
		wiob(ctlr, Cr3S, Cr3_IntMask);
		wiob(ctlr, RxCsrS, RxCsr_RunQueue);
		wiob(ctlr, RxCsrS, RxCsr_Wakeup);
	}
	else if(cistrcmp(cb-&gt;f[0], "dumpintr") == 0){
		if(cb-&gt;nf &lt; 2)
			error(Ecmdargs);

		if(cistrcmp(cb-&gt;f[1], "on") == 0){
			ctlr-&gt;debugflags |= DumpIntr;
			ctlr-&gt;debugcount = ~0;
		}
		else if(cistrcmp(cb-&gt;f[1], "off") == 0)
			ctlr-&gt;debugflags &amp;= ~DumpIntr;
		else{
			ulong count;
			char* rptr;

			count = strtoul(cb-&gt;f[1], &amp;rptr, 0);
			if(rptr == cb-&gt;f[1])
				error("invalid control request");

			ctlr-&gt;debugflags |= DumpIntr;
			ctlr-&gt;debugcount = count;

			print("vgbe: debugcount set to %uld\n", count);
		}
	}
	else if(cistrcmp(cb-&gt;f[0], "dumprx") == 0){
		if(cb-&gt;nf &lt; 2)
			error(Ecmdargs);

		if(cistrcmp(cb-&gt;f[1], "on") == 0)
			ctlr-&gt;debugflags |= DumpRx;
		else if(cistrcmp(cb-&gt;f[1], "off") == 0)
			ctlr-&gt;debugflags &amp;= ~DumpRx;
		else{
			index = strtoul(cb-&gt;f[1], &amp;rptr, 0);
			if((rptr == cb-&gt;f[1]) || (index &gt;= RxCount))
				error("invalid control request");

			rd = &amp;ctlr-&gt;rx_ring[index];
			print("vgbe: DumpRx[%03uld] status=%#08ulx ctl=%#08ulx len=%#04ux bytes\n",
				index, rd-&gt;status, rd-&gt;control, rd-&gt;length);
		}
	}
	else if(cistrcmp(cb-&gt;f[0], "dumptx") == 0){
		if(cb-&gt;nf &lt; 2)
			error(Ecmdargs);

		if(cistrcmp(cb-&gt;f[1], "on") == 0)
			ctlr-&gt;debugflags |= DumpTx;
		else if(cistrcmp(cb-&gt;f[1], "off") == 0)
			ctlr-&gt;debugflags &amp;= ~DumpTx;
		else{
			index = strtoul(cb-&gt;f[1], &amp;rptr, 0);
			if((rptr == cb-&gt;f[1]) || (index &gt;= TxCount))
				error("invalid control request");

			td = &amp;ctlr-&gt;tx_ring[index];
			print("vgbe: DumpTx[%03uld] status=%#08ulx ctl=%#08ulx len=%#04ux bytes",
				index, td-&gt;status, td-&gt;control, td-&gt;frags[0].length);

			p = (uchar*)td;
			for(index = 0; index &lt; sizeof(TxDesc); index++){
				if((index % 16) == 0)
					print("\nvgbe: ");
				else
					print(" ");
				print("%#02x", p[index]);
			}
		}
	}
	else if(cistrcmp(cb-&gt;f[0], "dumpall") == 0){
		if(cb-&gt;nf &lt; 2)
			error(Ecmdargs);

		if(cistrcmp(cb-&gt;f[1], "on") == 0){
			ctlr-&gt;debugflags = ~0;
			ctlr-&gt;debugcount = ~0;
		}
		else if(cistrcmp(cb-&gt;f[1], "off") == 0)
			ctlr-&gt;debugflags = 0;
		else error("invalid control request");
	}
	else
		error(Ebadctl);

	free(cb);
	poperror();

	return n;
}

static void
vgbepromiscuous(void* arg, int on)
{
	USED(arg, on);
}

/* multicast already on, don't need to do anything */
static void
vgbemulticast(void*, uchar*, int)
{
}

static void
vgbeshutdown(Ether* ether)
{
	vgbereset(ether-&gt;ctlr);
}

static int
vgbepnp(Ether* edev)
{
	Ctlr* ctlr;

//	print("vgbe: pnp\n");

	if(vgbehead == nil)
		vgbepci();

	for(ctlr = vgbehead; ctlr != nil; ctlr = ctlr-&gt;link){
		if(ctlr-&gt;active)
			continue;

		if(edev-&gt;port == 0 || edev-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}

	if(ctlr == nil)
		return -1;

	vgbereset(ctlr);

	edev-&gt;ctlr = ctlr;
	edev-&gt;port = ctlr-&gt;port;
	edev-&gt;irq = ctlr-&gt;pdev-&gt;intl;
	edev-&gt;tbdf = ctlr-&gt;pdev-&gt;tbdf;
	edev-&gt;mbps = 1000;
	memmove(edev-&gt;ea, ctlr-&gt;ea, Eaddrlen);
	edev-&gt;attach = vgbeattach;
	edev-&gt;transmit = vgbetransmit;
	edev-&gt;interrupt = vgbeinterrupt;
	edev-&gt;ifstat = vgbeifstat;
//	edev-&gt;promiscuous = vgbepromiscuous;
	edev-&gt;multicast = vgbemulticast;
	edev-&gt;shutdown = vgbeshutdown;
	edev-&gt;ctl = vgbectl;

	edev-&gt;arg = edev;
	return 0;
}

void
ethervgbelink(void)
{
	addethercard("vgbe", vgbepnp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

