<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/etherwavelan.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/etherwavelan.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Pci/pcmcia code for wavelan.c */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"
#include "etherif.h"

#include "wavelan.h"

static int
wavelanpcmciareset(Ether *ether)
{
	int i;
	char *p;
	Ctlr *ctlr;

	if((ctlr = malloc(sizeof(Ctlr))) == nil)
		return -1;

	ilock(ctlr);
	ctlr-&gt;ctlrno = ether-&gt;ctlrno;

	if (ether-&gt;port==0)
		ether-&gt;port=WDfltIOB;
	ctlr-&gt;iob = ether-&gt;port;

	if (ether-&gt;irq==0)
		ether-&gt;irq=WDfltIRQ;

	if (ioalloc(ether-&gt;port,WIOLen,0,"wavelan")&lt;0){
	//	print("#l%d: port 0x%lx in use\n",
	//			ether-&gt;ctlrno, ether-&gt;port);
		goto abort1;
	}

	/*
	 * If id= is specified, card must match.  Otherwise try generic.
	 */
	ctlr-&gt;slot = -1;
	for(i=0; i&lt;ether-&gt;nopt; i++){
		if(cistrncmp(ether-&gt;opt[i], "id=", 3) == 0){
			if((ctlr-&gt;slot = pcmspecial(&amp;ether-&gt;opt[i][3], ether)) &lt; 0)
				goto abort;
			break;
		}
	}
	if(ctlr-&gt;slot == -1){
		for (i=0; wavenames[i]; i++)
			if((ctlr-&gt;slot = pcmspecial(wavenames[i], ether))&gt;=0)
				break;
		if(!wavenames[i]){
			DEBUG("no wavelan found\n");
			goto abort;
		}
	}

	// DEBUG("#l%d: port=0x%lx irq=%ld\n",
	//		ether-&gt;ctlrno, ether-&gt;port, ether-&gt;irq);

	if(wavelanreset(ether, ctlr) &lt; 0){
	abort:
		iofree(ether-&gt;port);
	abort1:
		iunlock(ctlr);
		free(ctlr);
		ether-&gt;ctlr = nil;
		return -1;
	}

	for(i = 0; i &lt; ether-&gt;nopt; i++){
		if(p = strchr(ether-&gt;opt[i], '='))
			*p = ' ';
		w_option(ctlr, ether-&gt;opt[i], strlen(ether-&gt;opt[i]));
	}

	iunlock(ctlr);
	return 0;
}

static struct {
	int vid;
	int did;
} wavelanpci[] = {
	0x1260, 0x3873,	/* Intersil Prism2.5 */
	0x1737,	0x0019,	/* Linksys WPC-11 untested */
};

static Ctlr *ctlrhead, *ctlrtail;

static void
wavelanpciscan(void)
{
	int i;
	void *mem;
	Pcidev *p;
	Ctlr *ctlr;

	p = nil;
	while(p = pcimatch(p, 0, 0)){
		for(i=0; i&lt;nelem(wavelanpci); i++)
			if(p-&gt;vid == wavelanpci[i].vid &amp;&amp; p-&gt;did == wavelanpci[i].did)
				break;
		if(i==nelem(wavelanpci))
			continue;

		/*
		 * On the Prism, bar[0] is the memory-mapped register address (4KB),
		 */
		if(p-&gt;mem[0].size != 4096){
			print("wavelanpci: %.4ux %.4ux: unlikely mmio size\n", p-&gt;vid, p-&gt;did);
			continue;
		}

		ctlr = malloc(sizeof(Ctlr));
		if(ctlr == nil)
			error(Enomem);
		ctlr-&gt;pcidev = p;
		mem = vmap(p-&gt;mem[0].bar&amp;~0xF, p-&gt;mem[0].size);
		if(mem == nil){
			print("wavelanpci: %.4ux %.4ux: vmap 0x%.8lux %d failed\n", p-&gt;vid, p-&gt;did, p-&gt;mem[0].bar&amp;~0xF, p-&gt;mem[0].size);
			free(ctlr);
			continue;
		}
		ctlr-&gt;mmb = mem;
		if(ctlrhead != nil)
			ctlrtail-&gt;next = ctlr;
		else
			ctlrhead = ctlr;
		ctlrtail = ctlr;
		pcisetbme(p);
	}
}

static int
wavelanpcireset(Ether *ether)
{
	int i;
	char *p;
	Ctlr *ctlr;

	if(ctlrhead == nil)
		wavelanpciscan();

	/*
	 * Allow plan9.ini to set vid, did?
	 */
	for(ctlr=ctlrhead; ctlr!=nil; ctlr=ctlr-&gt;next)
		if(ctlr-&gt;active == 0)
			break;
	if(ctlr == nil)
		return -1;

	ctlr-&gt;active = 1;
	ilock(ctlr);
	ether-&gt;irq = ctlr-&gt;pcidev-&gt;intl;
	ether-&gt;tbdf = ctlr-&gt;pcidev-&gt;tbdf;

	/*
	 * Really hard reset.
	 */
	csr_outs(ctlr, WR_PciCor, 0x0080);
	delay(250);
	csr_outs(ctlr, WR_PciCor, 0x0000);
	delay(500);
	for(i=0; i&lt;2*10; i++){
		if(!(csr_ins(ctlr, WR_Cmd)&amp;WCmdBusy))
			break;
		delay(100);
	}
	if(i &gt;= 2*10)
		print("wavelan pci %.4ux %.4ux: reset timeout %.4ux\n",
			ctlr-&gt;pcidev-&gt;vid, ctlr-&gt;pcidev-&gt;did, csr_ins(ctlr, WR_Cmd));

	if(wavelanreset(ether, ctlr) &lt; 0){
		iunlock(ctlr);
		ether-&gt;ctlr = nil;
		return -1;
	}

	for(i = 0; i &lt; ether-&gt;nopt; i++){
		if(p = strchr(ether-&gt;opt[i], '='))
			*p = ' ';
		w_option(ctlr, ether-&gt;opt[i], strlen(ether-&gt;opt[i]));
	}
	iunlock(ctlr);
	return 0;
}
	
void
etherwavelanlink(void)
{
	addethercard("wavelan", wavelanpcmciareset);
	addethercard("wavelanpci", wavelanpcireset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

