<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"init.h"
#include	"pool.h"
#include	"reboot.h"
#include	"mp.h"
#include	&lt;tos.h&gt;

Mach *m;

/*
 * Where configuration info is left for the loaded programme.
 * This will turn into a structure as more is done by the boot loader
 * (e.g. why parse the .ini file twice?).
 * There are 3584 bytes available at CONFADDR.
 */
#define BOOTLINE	((char*)CONFADDR)
#define BOOTLINELEN	64
#define BOOTARGS	((char*)(CONFADDR+BOOTLINELEN))
#define	BOOTARGSLEN	(4096-0x200-BOOTLINELEN)
#define	MAXCONF		64

enum {
	/* space for syscall args, return PC, top-of-stack struct */
	Ustkheadroom	= sizeof(Sargs) + sizeof(uintptr) + sizeof(Tos),
};

char bootdisk[KNAMELEN];
Conf conf;
char *confname[MAXCONF];
char *confval[MAXCONF];
int nconf;
uchar *sp;	/* user stack of init proc */
int delaylink;
int idle_spin, idle_if_nproc;

static void
options(void)
{
	long i, n;
	char *cp, *line[MAXCONF], *p, *q;

	/*
	 *  parse configuration args from dos file plan9.ini
	 */
	cp = BOOTARGS;	/* where b.com leaves its config */
	cp[BOOTARGSLEN-1] = 0;

	/*
	 * Strip out '\r', change '\t' -&gt; ' '.
	 */
	p = cp;
	for(q = cp; *q; q++){
		if(*q == '\r')
			continue;
		if(*q == '\t')
			*q = ' ';
		*p++ = *q;
	}
	*p = 0;

	n = getfields(cp, line, MAXCONF, 1, "\n");
	for(i = 0; i &lt; n; i++){
		if(*line[i] == '#')
			continue;
		cp = strchr(line[i], '=');
		if(cp == nil)
			continue;
		*cp++ = '\0';
		confname[nconf] = line[i];
		confval[nconf] = cp;
		nconf++;
	}
}

extern void mmuinit0(void);
extern void (*i8237alloc)(void);

void
fpsavealloc(void)
{
	m-&gt;fpsavalign = mallocalign(sizeof(FPssestate), FPalign, 0, 0);
	if (m-&gt;fpsavalign == nil)
		panic("cpu%d: can't allocate fpsavalign", m-&gt;machno);
}

static int
isa20on(void)
{
	int r;
	ulong o;
	ulong *zp, *mb1p;

	zp = (ulong *)KZERO;
	mb1p = (ulong *)(KZERO|MB);
	o = *zp;

	*zp = 0x1234;
	*mb1p = 0x8765;
	coherence();
	wbinvd();
	r = *zp != *mb1p;

	*zp = o;
	return r;
}

void
main(void)
{
	cgapost(0);
	mach0init();
	options();
	ioinit();
	i8250console();
	quotefmtinstall();
	screeninit();

	print("\nPlan 9\n");

	trapinit0();
	mmuinit0();

	kbdinit();
	i8253init();
	cpuidentify();
	meminit();
	confinit();
	archinit();
	if(!isa20on())
		panic("bootstrap didn't leave a20 address line enabled");
	xinit();
	if(i8237alloc != nil)
		i8237alloc();
	trapinit();
	printinit();
	cpuidprint();
	mmuinit();
	fpsavealloc();
	if(arch-&gt;intrinit)	/* launches other processors on an mp */
		arch-&gt;intrinit();
	timersinit();
	mathinit();
	kbdenable();
	if(arch-&gt;clockenable)
		arch-&gt;clockenable();
	procinit0();
	initseg();
	if(delaylink){
		bootlinks();
		pcimatch(0, 0, 0);
	}else
		links();
	conf.monitor = 1;
	chandevreset();
	cgapost(0xcd);

	pageinit();
	i8253link();
	swapinit();
	userinit();
	active.thunderbirdsarego = 1;

	cgapost(0x99);
	schedinit();
}

void
mach0init(void)
{
	conf.nmach = 1;
	MACHP(0) = (Mach*)CPU0MACH;
	m-&gt;pdb = (ulong*)CPU0PDB;
	m-&gt;gdt = (Segdesc*)CPU0GDT;

	machinit();

	active.machs = 1;
	active.exiting = 0;
}

void
machinit(void)
{
	int machno;
	ulong *pdb;
	Segdesc *gdt;

	machno = m-&gt;machno;
	pdb = m-&gt;pdb;
	gdt = m-&gt;gdt;
	memset(m, 0, sizeof(Mach));
	m-&gt;machno = machno;
	m-&gt;pdb = pdb;
	m-&gt;gdt = gdt;
	m-&gt;perf.period = 1;

	/*
	 * For polled uart output at boot, need
	 * a default delay constant. 100000 should
	 * be enough for a while. Cpuidentify will
	 * calculate the real value later.
	 */
	m-&gt;loopconst = 100000;
}

void
init0(void)
{
	int i;
	char buf[2*KNAMELEN];

	up-&gt;nerrlab = 0;

	spllo();

	/*
	 * These are o.k. because rootinit is null.
	 * Then early kproc's will have a root and dot.
	 */
	up-&gt;slash = namec("#/", Atodir, 0, 0);
	pathclose(up-&gt;slash-&gt;path);
	up-&gt;slash-&gt;path = newpath("/");
	up-&gt;dot = cclone(up-&gt;slash);

	chandevinit();

	if(!waserror()){
		snprint(buf, sizeof(buf), "%s %s", arch-&gt;id, conffile);
		ksetenv("terminal", buf, 0);
		ksetenv("cputype", "386", 0);
		if(cpuserver)
			ksetenv("service", "cpu", 0);
		else
			ksetenv("service", "terminal", 0);
		for(i = 0; i &lt; nconf; i++){
			if(confname[i][0] != '*')
				ksetenv(confname[i], confval[i], 0);
			ksetenv(confname[i], confval[i], 1);
		}
		poperror();
	}
	kproc("alarm", alarmkproc, 0);
	cgapost(0x9);
	touser(sp);
}

void
userinit(void)
{
	void *v;
	Proc *p;
	Segment *s;
	Page *pg;

	p = newproc();
	p-&gt;pgrp = newpgrp();
	p-&gt;egrp = smalloc(sizeof(Egrp));
	p-&gt;egrp-&gt;ref = 1;
	p-&gt;fgrp = dupfgrp(nil);
	p-&gt;rgrp = newrgrp();
	p-&gt;procmode = 0640;

	kstrdup(&amp;eve, "");
	kstrdup(&amp;p-&gt;text, "*init*");
	kstrdup(&amp;p-&gt;user, eve);

	p-&gt;fpstate = FPinit;
	fpoff();

	/*
	 * Kernel Stack
	 *
	 * N.B. make sure there's enough space for syscall to check
	 *	for valid args and 
	 *	4 bytes for gotolabel's return PC
	 */
	p-&gt;sched.pc = (ulong)init0;
	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK-(sizeof(Sargs)+BY2WD);

	/*
	 * User Stack
	 *
	 * N.B. cannot call newpage() with clear=1, because pc kmap
	 * requires up != nil.  use tmpmap instead.
	 */
	s = newseg(SG_STACK, USTKTOP-USTKSIZE, USTKSIZE/BY2PG);
	p-&gt;seg[SSEG] = s;
	pg = newpage(0, 0, USTKTOP-BY2PG);
	v = tmpmap(pg);
	memset(v, 0, BY2PG);
	segpage(s, pg);
	bootargs(v);
	tmpunmap(v);

	/*
	 * Text
	 */
	s = newseg(SG_TEXT, UTZERO, 1);
	s-&gt;flushme++;
	p-&gt;seg[TSEG] = s;
	pg = newpage(0, 0, UTZERO);
	memset(pg-&gt;cachectl, PG_TXTFLUSH, sizeof(pg-&gt;cachectl));
	segpage(s, pg);
	v = tmpmap(pg);
	memset(v, 0, BY2PG);
	memmove(v, initcode, sizeof initcode);
	tmpunmap(v);

	ready(p);
}

uchar *
pusharg(char *p)
{
	int n;

	n = strlen(p)+1;
	sp -= n;
	memmove(sp, p, n);
	return sp;
}

void
bootargs(void *base)
{
 	int i, ac;
	uchar *av[32];
	uchar **lsp;
	char *cp = BOOTLINE;
	char buf[64];

	sp = (uchar*)base + BY2PG - Ustkheadroom;

	ac = 0;
	av[ac++] = pusharg("/386/9dos");

	/* when boot is changed to only use rc, this code can go away */
	cp[BOOTLINELEN-1] = 0;
	buf[0] = 0;
	if(strncmp(cp, "fd", 2) == 0){
		snprint(buf, sizeof buf, "local!#f/fd%lddisk",
			strtol(cp+2, 0, 0));
		av[ac++] = pusharg(buf);
	} else if(strncmp(cp, "sd", 2) == 0){
		snprint(buf, sizeof buf, "local!#S/sd%c%c/fs", *(cp+2), *(cp+3));
		av[ac++] = pusharg(buf);
	} else if(strncmp(cp, "ether", 5) == 0)
		av[ac++] = pusharg("-n");

	/* 4 byte word align stack */
	sp = (uchar*)((ulong)sp &amp; ~3);

	/* build argc, argv on stack */
	sp -= (ac+1)*sizeof(sp);
	lsp = (uchar**)sp;
	for(i = 0; i &lt; ac; i++)
		*lsp++ = av[i] + ((USTKTOP - BY2PG) - (ulong)base);
	*lsp = 0;
	sp += (USTKTOP - BY2PG) - (ulong)base - sizeof(ulong);
}

char*
getconf(char *name)
{
	int i;

	for(i = 0; i &lt; nconf; i++)
		if(cistrcmp(confname[i], name) == 0)
			return confval[i];
	return 0;
}

static void
writeconf(void)
{
	char *p, *q;
	int n;

	p = getconfenv();

	if(waserror()) {
		free(p);
		nexterror();
	}

	/* convert to name=value\n format */
	for(q=p; *q; q++) {
		q += strlen(q);
		*q = '=';
		q += strlen(q);
		*q = '\n';
	}
	n = q - p + 1;
	if(n &gt;= BOOTARGSLEN)
		error("kernel configuration too large");
	memset(BOOTLINE, 0, BOOTLINELEN);
	memmove(BOOTARGS, p, n);
	poperror();
	free(p);
}

void
confinit(void)
{
	char *p;
	int i, userpcnt;
	unsigned mb;
	ulong kpages, ksize;

	if(p = getconf("*kernelpercent"))
		userpcnt = 100 - strtol(p, 0, 0);
	else
		userpcnt = 0;

	conf.npage = 0;
	for(i=0; i&lt;nelem(conf.mem); i++)
		conf.npage += conf.mem[i].npage;

	conf.nproc = 100 + ((conf.npage*BY2PG)/MB)*5;
	if(cpuserver)
		conf.nproc *= 3;
	if(conf.nproc &gt; 2000)
		conf.nproc = 2000;
	conf.nimage = 200;
	conf.nswap = conf.nproc*80;
	conf.nswppo = 4096;

	if(cpuserver) {
		if(userpcnt &lt; 10)
			userpcnt = 70;
		kpages = conf.npage - (conf.npage*userpcnt)/100;

		/*
		 * Hack for the big boys. Only good while physmem &lt; 4GB.
		 * Give the kernel fixed max + enough to allocate the
		 * page pool.
		 * This is an overestimate as conf.upages &lt; conf.npages.
		 * The patch of nimage is a band-aid, scanning the whole
		 * page list in imagereclaim just takes too long.
		 */
		for (mb = 400; mb &gt;= 100; mb /= 2) {
			ksize = mb*MB + conf.npage*sizeof(Page);
			if(kpages &gt; ksize/BY2PG &amp;&amp; cankaddr(ksize)) {
				kpages = ksize/BY2PG + (conf.nproc*KSTACK)/BY2PG;
				conf.nimage = 2000;
				break;
			}
		}
	} else {
		if(userpcnt &lt; 10) {
			if(conf.npage*BY2PG &lt; 16*MB)
				userpcnt = 40;
			else
				userpcnt = 60;
		}
		kpages = conf.npage - (conf.npage*userpcnt)/100;

		/*
		 * Make sure terminals with low memory get at least
		 * 4MB on the first Image chunk allocation.
		 */
		if(conf.npage*BY2PG &lt; 16*MB)
			imagmem-&gt;minarena = 4*1024*1024;
	}

	/*
	 * can't go past the end of virtual memory
	 * (ulong)-KZERO is 2^32 - KZERO
	 */
	if(kpages &gt; ((ulong)-KZERO)/BY2PG)
		kpages = ((ulong)-KZERO)/BY2PG;

	conf.upages = conf.npage - kpages;
	conf.ialloc = (kpages/2)*BY2PG;

	/*
	 * Guess how much is taken by the large permanent
	 * datastructures. Mntcache and Mntrpc are not accounted for
	 * (probably ~300KB).
	 */
	kpages *= BY2PG;
	kpages -= conf.upages*sizeof(Page)
		+ conf.nproc*sizeof(Proc)
		+ conf.nimage*sizeof(Image)
		+ conf.nswap
		+ conf.nswppo*sizeof(Page);
	mainmem-&gt;maxsize = kpages;
	if(!cpuserver){
		/*
		 * give terminals lots of image memory, too; the dynamic
		 * allocation will balance the load properly, hopefully.
		 * be careful with 32-bit overflow.
		 */
		imagmem-&gt;maxsize = kpages;
	}
}

static char* mathmsg[] =
{
	nil,	/* handled below */
	"denormalized operand",
	"division by zero",
	"numeric overflow",
	"numeric underflow",
	"precision loss",
};

static void
mathstate(ulong *stsp, ulong *pcp, ulong *ctlp)
{
	ulong sts, fpc, ctl;
	FPsave *f = &amp;up-&gt;fpsave;

	if(fpsave == fpx87save){
		sts = f-&gt;status;
		fpc = f-&gt;pc;
		ctl = f-&gt;control;
	} else {
		sts = f-&gt;fsw;
		fpc = f-&gt;fpuip;
		ctl = f-&gt;fcw;
	}
	if(stsp)
		*stsp = sts;
	if(pcp)
		*pcp = fpc;
	if(ctlp)
		*ctlp = ctl;
}

static void
mathnote(void)
{
	int i;
	ulong status, pc;
	char *msg, note[ERRMAX];

	mathstate(&amp;status, &amp;pc, nil);

	/*
	 * Some attention should probably be paid here to the
	 * exception masks and error summary.
	 */
	msg = "unknown exception";
	for(i = 1; i &lt;= 5; i++){
		if(!((1&lt;&lt;i) &amp; status))
			continue;
		msg = mathmsg[i];
		break;
	}
	if(status &amp; 0x01){
		if(status &amp; 0x40){
			if(status &amp; 0x200)
				msg = "stack overflow";
			else
				msg = "stack underflow";
		}else
			msg = "invalid operation";
	}
	snprint(note, sizeof note, "sys: fp: %s fppc=%#lux status=%#lux",
		msg, pc, status);
	postnote(up, 1, note, NDebug);
}

/*
 * sse fp save and restore buffers have to be 16-byte (FPalign) aligned,
 * so we shuffle the data down as needed or make copies.
 */

void
fpssesave(FPsave *fps)
{
	FPsave *afps;

	fps-&gt;magic = 0x1234;
	afps = (FPsave *)ROUND(((uintptr)fps), FPalign);
	fpssesave0(afps);
	if (fps != afps)  /* not aligned? shuffle down from aligned buffer */
		memmove(fps, afps, sizeof(FPssestate));
	if (fps-&gt;magic != 0x1234)
		print("fpssesave: magic corrupted\n");
}

void
fpsserestore(FPsave *fps)
{
	FPsave *afps;

	fps-&gt;magic = 0x4321;
	afps = (FPsave *)ROUND(((uintptr)fps), FPalign);
	if (fps != afps) {
		afps = m-&gt;fpsavalign;
		memmove(afps, fps, sizeof(FPssestate));	/* make aligned copy */
	}
	fpsserestore0(afps);
	if (fps-&gt;magic != 0x4321)
		print("fpsserestore: magic corrupted\n");
}

/*
 *  math coprocessor error
 */
static void
matherror(Ureg *ur, void*)
{
	ulong status, pc;

	/*
	 *  a write cycle to port 0xF0 clears the interrupt latch attached
	 *  to the error# line from the 387
	 */
	if(!(m-&gt;cpuiddx &amp; Fpuonchip))
		outb(0xF0, 0xFF);

	/*
	 *  save floating point state to check out error
	 */
	fpenv(&amp;up-&gt;fpsave);	/* result ignored, but masks fp exceptions */
	fpsave(&amp;up-&gt;fpsave);		/* also turns fpu off */
	fpon();
	mathnote();

	if((ur-&gt;pc &amp; 0xf0000000) == KZERO){
		mathstate(&amp;status, &amp;pc, nil);
		panic("fp: status %#lux fppc=%#lux pc=%#lux", status, pc, ur-&gt;pc);
	}
}

/*
 *  math coprocessor emulation fault
 */
static void
mathemu(Ureg *ureg, void*)
{
	ulong status, control;

	if(up-&gt;fpstate &amp; FPillegal){
		/* someone did floating point in a note handler */
		postnote(up, 1, "sys: floating point in note handler", NDebug);
		return;
	}
	switch(up-&gt;fpstate){
	case FPinit:
		fpinit();
		up-&gt;fpstate = FPactive;
		break;
	case FPinactive:
		/*
		 * Before restoring the state, check for any pending
		 * exceptions, there's no way to restore the state without
		 * generating an unmasked exception.
		 * More attention should probably be paid here to the
		 * exception masks and error summary.
		 */
		mathstate(&amp;status, nil, &amp;control);
		if((status &amp; ~control) &amp; 0x07F){
			mathnote();
			break;
		}
		fprestore(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPactive;
		break;
	case FPactive:
		panic("math emu pid %ld %s pc %#lux",
			up-&gt;pid, up-&gt;text, ureg-&gt;pc);
		break;
	}
}

/*
 *  math coprocessor segment overrun
 */
static void
mathover(Ureg*, void*)
{
	pexit("math overrun", 0);
}

void
mathinit(void)
{
	trapenable(VectorCERR, matherror, 0, "matherror");
	if(X86FAMILY(m-&gt;cpuidax) == 3)
		intrenable(IrqIRQ13, matherror, 0, BUSUNKNOWN, "matherror");
	trapenable(VectorCNA, mathemu, 0, "mathemu");
	trapenable(VectorCSO, mathover, 0, "mathover");
}

/*
 *  set up floating point for a new process
 */
void
procsetup(Proc*p)
{
	p-&gt;fpstate = FPinit;
	fpoff();
}

void
procrestore(Proc *p)
{
	uvlong t;

	if(p-&gt;kp)
		return;
	cycles(&amp;t);
	p-&gt;pcycles -= t;
}

/*
 *  Save the mach dependent part of the process state.
 */
void
procsave(Proc *p)
{
	uvlong t;

	cycles(&amp;t);
	p-&gt;pcycles += t;
	if(p-&gt;fpstate == FPactive){
		if(p-&gt;state == Moribund)
			fpclear();
		else{
			/*
			 * Fpsave() stores without handling pending
			 * unmasked exeptions. Postnote() can't be called
			 * here as sleep() already has up-&gt;rlock, so
			 * the handling of pending exceptions is delayed
			 * until the process runs again and generates an
			 * emulation fault to activate the FPU.
			 */
			fpsave(&amp;p-&gt;fpsave);
		}
		p-&gt;fpstate = FPinactive;
	}

	/*
	 * While this processor is in the scheduler, the process could run
	 * on another processor and exit, returning the page tables to
	 * the free list where they could be reallocated and overwritten.
	 * When this processor eventually has to get an entry from the
	 * trashed page tables it will crash.
	 *
	 * If there's only one processor, this can't happen.
	 * You might think it would be a win not to do this in that case,
	 * especially on VMware, but it turns out not to matter.
	 */
	mmuflushtlb(PADDR(m-&gt;pdb));
}

static void
shutdown(int ispanic)
{
	int ms, once;

	lock(&amp;active);
	if(ispanic)
		active.ispanic = ispanic;
	else if(m-&gt;machno == 0 &amp;&amp; (active.machs &amp; (1&lt;&lt;m-&gt;machno)) == 0)
		active.ispanic = 0;
	once = active.machs &amp; (1&lt;&lt;m-&gt;machno);
	/*
	 * setting exiting will make hzclock() on each processor call exit(0),
	 * which calls shutdown(0) and arch-&gt;reset(), which on mp systems is
	 * mpshutdown, which idles non-bootstrap cpus and returns on bootstrap
	 * processors (to permit a reboot).  clearing our bit in machs avoids
	 * calling exit(0) from hzclock() on this processor.
	 */
	active.machs &amp;= ~(1&lt;&lt;m-&gt;machno);
	active.exiting = 1;
	unlock(&amp;active);

	if(once)
		iprint("cpu%d: exiting\n", m-&gt;machno);

	/* wait for any other processors to shutdown */
	spllo();
	for(ms = 5*1000; ms &gt; 0; ms -= TK2MS(2)){
		delay(TK2MS(2));
		if(active.machs == 0 &amp;&amp; consactive() == 0)
			break;
	}

	if(active.ispanic){
		if(!cpuserver)
			for(;;)
				halt();
		if(getconf("*debug"))
			delay(5*60*1000);
		else
			delay(10000);
	}else
		delay(1000);
}

void
reboot(void *entry, void *code, ulong size)
{
	void (*f)(ulong, ulong, ulong);
	ulong *pdb;

	writeconf();

	/*
	 * the boot processor is cpu0.  execute this function on it
	 * so that the new kernel has the same cpu0.  this only matters
	 * because the hardware has a notion of which processor was the
	 * boot processor and we look at it at start up.
	 */
	if (m-&gt;machno != 0) {
		procwired(up, 0);
		sched();
	}

	if(conf.nmach &gt; 1) {
		/*
		 * the other cpus could be holding locks that will never get
		 * released (e.g., in the print path) if we put them into
		 * reset now, so force them to shutdown gracefully first.
		 */
		lock(&amp;active);
		active.rebooting = 1;
		unlock(&amp;active);
		shutdown(0);
		if(arch-&gt;resetothers)
			arch-&gt;resetothers();
		delay(20);
	}

	/*
	 * should be the only processor running now
	 */
	active.machs = 0;
	if (m-&gt;machno != 0)
		print("on cpu%d (not 0)!\n", m-&gt;machno);

	print("shutting down...\n");
	delay(200);

	splhi();

	/* turn off buffered serial console */
	serialoq = nil;

	/* shutdown devices */
	chandevshutdown();
	arch-&gt;introff();

	/*
	 * Modify the machine page table to directly map the low 4MB of memory
	 * This allows the reboot code to turn off the page mapping
	 */
	pdb = m-&gt;pdb;
	pdb[PDX(0)] = pdb[PDX(KZERO)];
	mmuflushtlb(PADDR(pdb));

	/* setup reboot trampoline function */
	f = (void*)REBOOTADDR;
	memmove(f, rebootcode, sizeof(rebootcode));

	print("rebooting...\n");

	/* off we go - never to return */
	coherence();
	(*f)(PADDR(entry), PADDR(code), size);
}


void
exit(int ispanic)
{
	shutdown(ispanic);
	arch-&gt;reset();
}

int
isaconfig(char *class, int ctlrno, ISAConf *isa)
{
	char cc[32], *p;
	int i;

	snprint(cc, sizeof cc, "%s%d", class, ctlrno);
	p = getconf(cc);
	if(p == nil)
		return 0;

	isa-&gt;type = "";
	isa-&gt;nopt = tokenize(p, isa-&gt;opt, NISAOPT);
	for(i = 0; i &lt; isa-&gt;nopt; i++){
		p = isa-&gt;opt[i];
		if(cistrncmp(p, "type=", 5) == 0)
			isa-&gt;type = p + 5;
		else if(cistrncmp(p, "port=", 5) == 0)
			isa-&gt;port = strtoul(p+5, &amp;p, 0);
		else if(cistrncmp(p, "irq=", 4) == 0)
			isa-&gt;irq = strtoul(p+4, &amp;p, 0);
		else if(cistrncmp(p, "dma=", 4) == 0)
			isa-&gt;dma = strtoul(p+4, &amp;p, 0);
		else if(cistrncmp(p, "mem=", 4) == 0)
			isa-&gt;mem = strtoul(p+4, &amp;p, 0);
		else if(cistrncmp(p, "size=", 5) == 0)
			isa-&gt;size = strtoul(p+5, &amp;p, 0);
		else if(cistrncmp(p, "freq=", 5) == 0)
			isa-&gt;freq = strtoul(p+5, &amp;p, 0);
	}
	return 1;
}

int
cistrcmp(char *a, char *b)
{
	int ac, bc;

	for(;;){
		ac = *a++;
		bc = *b++;
	
		if(ac &gt;= 'A' &amp;&amp; ac &lt;= 'Z')
			ac = 'a' + (ac - 'A');
		if(bc &gt;= 'A' &amp;&amp; bc &lt;= 'Z')
			bc = 'a' + (bc - 'A');
		ac -= bc;
		if(ac)
			return ac;
		if(bc == 0)
			break;
	}
	return 0;
}

int
cistrncmp(char *a, char *b, int n)
{
	unsigned ac, bc;

	while(n &gt; 0){
		ac = *a++;
		bc = *b++;
		n--;

		if(ac &gt;= 'A' &amp;&amp; ac &lt;= 'Z')
			ac = 'a' + (ac - 'A');
		if(bc &gt;= 'A' &amp;&amp; bc &lt;= 'Z')
			bc = 'a' + (bc - 'A');

		ac -= bc;
		if(ac)
			return ac;
		if(bc == 0)
			break;
	}

	return 0;
}

/*
 *  put the processor in the halt state if we've no processes to run.
 *  an interrupt will get us going again.
 */
void
idlehands(void)
{
	/*
	 * we used to halt only on single-core setups. halting in an smp system 
	 * can result in a startup latency for processes that become ready.
	 * if idle_spin is zero, we care more about saving energy
	 * than reducing this latency.
	 *
	 * the performance loss with idle_spin == 0 seems to be slight
	 * and it reduces lock contention (thus system time and real time)
	 * on many-core systems with large values of NPROC.
	 */
	if(conf.nmach == 1 || idle_spin == 0 ||
	    idle_if_nproc &amp;&amp; conf.nmach &gt;= idle_if_nproc)
		halt();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

