<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/mp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/mp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"

#include "mp.h"
#include "apbootstrap.h"

#define dprint(...)	if(mpdebug) print(__VA_ARGS__); else USED(mpdebug)

/* from mpacpi.c */
Apic *bootapic;

int mpdebug;
void (*mpacpifunc)(void);

static PCMP* mppcmp;
static Bus* mpbus;
static Bus* mpbuslast;
static int mpisabus = -1;
static int mpeisabus = -1;
extern int i8259elcr;			/* mask of level-triggered interrupts */
/* static */ Apic mpapic[MaxAPICNO+1];
/* static */ int machno2apicno[MaxAPICNO+1];	/* inverse map: machno -&gt; APIC ID */
/* static */ Apic ioapic[MaxAPICNO+1];
static Ref mpvnoref;			/* unique vector assignment */
static int mpmachno = 1;
static Lock mpphysidlock;
static int mpphysid;

static char* buses[] = {
	"CBUSI ",
	"CBUSII",
	"EISA  ",
	"FUTURE",
	"INTERN",
	"ISA   ",
	"MBI   ",
	"MBII  ",
	"MCA   ",
	"MPI   ",
	"MPSA  ",
	"NUBUS ",
	"PCI   ",
	"PCMCIA",
	"TC    ",
	"VL    ",
	"VME   ",
	"XPRESS",
	0,
};

static Apic*
mkprocessor(PCMPprocessor* p)
{
	int apicno;
	Apic *apic;

	apicno = p-&gt;apicno;
	if(!(p-&gt;flags &amp; PcmpEN) || apicno &gt; MaxAPICNO)
		return 0;

	apic = &amp;mpapic[apicno];
	apic-&gt;type = PcmpPROCESSOR;
	apic-&gt;apicno = apicno;
	apic-&gt;flags = p-&gt;flags;
	apic-&gt;lintr[0] = ApicIMASK;
	apic-&gt;lintr[1] = ApicIMASK;

	if(p-&gt;flags &amp; PcmpBP){
		machno2apicno[0] = apicno;
		apic-&gt;machno = 0;
	}
	else{
		machno2apicno[mpmachno] = apicno;
		apic-&gt;machno = mpmachno;
		mpmachno++;
	}

	return apic;
}

static Bus*
mkbus(PCMPbus* p)
{
	Bus *bus;
	int i;

	for(i = 0; buses[i]; i++){
		if(strncmp(buses[i], p-&gt;string, sizeof(p-&gt;string)) == 0)
			break;
	}
	if(buses[i] == 0)
		return 0;

	bus = xalloc(sizeof(Bus));
	if(mpbus)
		mpbuslast-&gt;next = bus;
	else
		mpbus = bus;
	mpbuslast = bus;

	bus-&gt;type = i;
	bus-&gt;busno = p-&gt;busno;
	if(bus-&gt;type == BusEISA){
		bus-&gt;po = PcmpLOW;
		bus-&gt;el = PcmpLEVEL;
		if(mpeisabus != -1)
			print("mkbus: more than one EISA bus\n");
		mpeisabus = bus-&gt;busno;
	}
	else if(bus-&gt;type == BusPCI){
		bus-&gt;po = PcmpLOW;
		bus-&gt;el = PcmpLEVEL;
	}
	else if(bus-&gt;type == BusISA){
		bus-&gt;po = PcmpHIGH;
		bus-&gt;el = PcmpEDGE;
		if(mpisabus != -1)
			print("mkbus: more than one ISA bus\n");
		mpisabus = bus-&gt;busno;
	}
	else{
		bus-&gt;po = PcmpHIGH;
		bus-&gt;el = PcmpEDGE;
	}

	return bus;
}

static Bus*
mpgetbus(int busno)
{
	Bus *bus;

	for(bus = mpbus; bus; bus = bus-&gt;next){
		if(bus-&gt;busno == busno)
			return bus;
	}
	print("mpgetbus: can't find bus %d\n", busno);

	return 0;
}

static Apic*
mkioapic(PCMPioapic* p)
{
	void *va;
	int apicno;
	Apic *apic;

	apicno = p-&gt;apicno;
	if(!(p-&gt;flags &amp; PcmpEN) || apicno &gt; MaxAPICNO)
		return 0;

	/*
	 * Map the I/O APIC.
	 */
	if((va = vmap(p-&gt;addr, 1024)) == nil)
		return 0;

	apic = &amp;ioapic[apicno];
	apic-&gt;type = PcmpIOAPIC;
	apic-&gt;apicno = apicno;
	apic-&gt;addr = va;
	apic-&gt;paddr = p-&gt;addr;
	apic-&gt;flags = p-&gt;flags;

	return apic;
}

static Aintr*
mkiointr(PCMPintr* p)
{
	Bus *bus;
	Aintr *aintr;
	PCMPintr* pcmpintr;

	/*
	 * According to the MultiProcessor Specification, a destination
	 * I/O APIC of 0xFF means the signal is routed to all I/O APICs.
	 * It's unclear how that can possibly be correct so treat it as
	 * an error for now.
	 */
	if(p-&gt;apicno == 0xFF)
		return 0;
	if((bus = mpgetbus(p-&gt;busno)) == 0)
		return 0;

	aintr = xalloc(sizeof(Aintr));
	aintr-&gt;intr = p;

	if(0)
		dprint("mkiointr: type %d intr type %d flags %#o "
			"bus %d irq %d apicno %d intin %d\n",
			p-&gt;type, p-&gt;intr, p-&gt;flags,
			p-&gt;busno, p-&gt;irq, p-&gt;apicno, p-&gt;intin);
	/*
	 * Hack for Intel SR1520ML motherboard, which BIOS describes
	 * the i82575 dual ethernet controllers incorrectly.
	 */
	if(mppcmp &amp;&amp; memcmp(mppcmp-&gt;product, "INTEL   X38MLST     ", 20) == 0){
		if(p-&gt;busno == 1 &amp;&amp; p-&gt;intin == 16 &amp;&amp; p-&gt;irq == 1){
			pcmpintr = malloc(sizeof(PCMPintr));
			if(pcmpintr == nil)
				panic("mkiointr: no memory");
			memmove(pcmpintr, p, sizeof(PCMPintr));
			print("mkiointr: %20.20s bus %d intin %d irq %d\n",
				(char*)mppcmp-&gt;product,
				pcmpintr-&gt;busno, pcmpintr-&gt;intin,
				pcmpintr-&gt;irq);
			pcmpintr-&gt;intin = 17;
			aintr-&gt;intr = pcmpintr;
		}
	}
	if ((unsigned)p-&gt;apicno &gt;= nelem(mpapic))
		panic("mkiointr: apic %d out of range", p-&gt;apicno);
	aintr-&gt;apic = &amp;ioapic[p-&gt;apicno];
	aintr-&gt;next = bus-&gt;aintr;
	bus-&gt;aintr = aintr;

	return aintr;
}

static int
mpintrinit(Bus* bus, PCMPintr* intr, int vno, int /*irq*/)
{
	int el, po, v;

	/*
	 * Parse an I/O or Local APIC interrupt table entry and
	 * return the encoded vector.
	 */
	v = vno;

	po = intr-&gt;flags &amp; PcmpPOMASK;
	el = intr-&gt;flags &amp; PcmpELMASK;

	switch(intr-&gt;intr){

	default:				/* PcmpINT */
		v |= ApicFIXED;			/* no-op */
		break;

	case PcmpNMI:
		v |= ApicNMI;
		po = PcmpHIGH;
		el = PcmpEDGE;
		break;

	case PcmpSMI:
		v |= ApicSMI;
		break;

	case PcmpExtINT:
		v |= ApicExtINT;
		/*
		 * The AMI Goliath doesn't boot successfully with it's LINTR0
		 * entry which decodes to low+level. The PPro manual says ExtINT
		 * should be level, whereas the Pentium is edge. Setting the
		 * Goliath to edge+high seems to cure the problem. Other PPro
		 * MP tables (e.g. ASUS P/I-P65UP5 have a entry which decodes
		 * to edge+high, so who knows.
		 * Perhaps it would be best just to not set an ExtINT entry at
		 * all, it shouldn't be needed for SMP mode.
		 */
		po = PcmpHIGH;
		el = PcmpEDGE;
		break;
	}

	/*
	 */
	if(bus-&gt;type == BusEISA &amp;&amp; !po &amp;&amp; !el /*&amp;&amp; !(i8259elcr &amp; (1&lt;&lt;irq))*/){
		po = PcmpHIGH;
		el = PcmpEDGE;
	}
	if(!po)
		po = bus-&gt;po;
	if(po == PcmpLOW)
		v |= ApicLOW;
	else if(po != PcmpHIGH){
		print("mpintrinit: bad polarity 0x%uX\n", po);
		return ApicIMASK;
	}

	if(!el)
		el = bus-&gt;el;
	if(el == PcmpLEVEL)
		v |= ApicLEVEL;
	else if(el != PcmpEDGE){
		print("mpintrinit: bad trigger 0x%uX\n", el);
		return ApicIMASK;
	}

	return v;
}

static int
mklintr(PCMPintr* p)
{
	Apic *apic;
	Bus *bus;
	int intin, v;

	/*
	 * The offsets of vectors for LINT[01] are known to be
	 * 0 and 1 from the local APIC vector space at VectorLAPIC.
	 */
	if((bus = mpgetbus(p-&gt;busno)) == 0)
		return 0;
	intin = p-&gt;intin;

	/*
	 * Pentium Pros have problems if LINT[01] are set to ExtINT
	 * so just bag it, SMP mode shouldn't need ExtINT anyway.
	 */
	if(p-&gt;intr == PcmpExtINT || p-&gt;intr == PcmpNMI)
		v = ApicIMASK;
	else
		v = mpintrinit(bus, p, VectorLAPIC+intin, p-&gt;irq);

	if(p-&gt;apicno == 0xFF){
		for(apic = mpapic; apic &lt;= &amp;mpapic[MaxAPICNO]; apic++){
			if((apic-&gt;flags &amp; PcmpEN)
			&amp;&amp; apic-&gt;type == PcmpPROCESSOR)
				apic-&gt;lintr[intin] = v;
		}
	}
	else{
		if ((unsigned)p-&gt;apicno &gt;= nelem(mpapic))
			panic("mklintr: ioapic %d out of range", p-&gt;apicno);
		apic = &amp;mpapic[p-&gt;apicno];
		if((apic-&gt;flags &amp; PcmpEN) &amp;&amp; apic-&gt;type == PcmpPROCESSOR)
			apic-&gt;lintr[intin] = v;
	}

	return v;
}

static void
checkmtrr(void)
{
	int i, vcnt;
	Mach *mach0;

	/*
	 * If there are MTRR registers, snarf them for validation.
	 */
	if(!(m-&gt;cpuiddx &amp; Mtrr))
		return;

	rdmsr(0x0FE, &amp;m-&gt;mtrrcap);
	rdmsr(0x2FF, &amp;m-&gt;mtrrdef);
	if(m-&gt;mtrrcap &amp; 0x0100){
		rdmsr(0x250, &amp;m-&gt;mtrrfix[0]);
		rdmsr(0x258, &amp;m-&gt;mtrrfix[1]);
		rdmsr(0x259, &amp;m-&gt;mtrrfix[2]);
		for(i = 0; i &lt; 8; i++)
			rdmsr(0x268+i, &amp;m-&gt;mtrrfix[(i+3)]);
	}
	vcnt = m-&gt;mtrrcap &amp; 0x00FF;
	if(vcnt &gt; nelem(m-&gt;mtrrvar))
		vcnt = nelem(m-&gt;mtrrvar);
	for(i = 0; i &lt; vcnt; i++)
		rdmsr(0x200+i, &amp;m-&gt;mtrrvar[i]);

	/*
	 * If not the bootstrap processor, compare.
	 */
	if(m-&gt;machno == 0)
		return;

	mach0 = MACHP(0);
	if(mach0-&gt;mtrrcap != m-&gt;mtrrcap)
		print("mtrrcap%d: %lluX %lluX\n",
			m-&gt;machno, mach0-&gt;mtrrcap, m-&gt;mtrrcap);
	if(mach0-&gt;mtrrdef != m-&gt;mtrrdef)
		print("mtrrdef%d: %lluX %lluX\n",
			m-&gt;machno, mach0-&gt;mtrrdef, m-&gt;mtrrdef);
	for(i = 0; i &lt; 11; i++){
		if(mach0-&gt;mtrrfix[i] != m-&gt;mtrrfix[i])
			print("mtrrfix%d: i%d: %lluX %lluX\n",
				m-&gt;machno, i, mach0-&gt;mtrrfix[i], m-&gt;mtrrfix[i]);
	}
	for(i = 0; i &lt; vcnt; i++){
		if(mach0-&gt;mtrrvar[i] != m-&gt;mtrrvar[i])
			print("mtrrvar%d: i%d: %lluX %lluX\n",
				m-&gt;machno, i, mach0-&gt;mtrrvar[i], m-&gt;mtrrvar[i]);
	}
}

static void
squidboy(Apic* apic)
{
//	iprint("Hello Squidboy\n");

	machinit();
	fpsavealloc();
	mmuinit();

	cpuidentify();
	cpuidprint();
	checkmtrr();

	apic-&gt;online = 1;
	coherence();

	lapicinit(apic);
	lapiconline();
	syncclock();
	timersinit();

	fpoff();

	lock(&amp;active);
	active.machs |= 1&lt;&lt;m-&gt;machno;
	unlock(&amp;active);

	while(!active.thunderbirdsarego)
		microdelay(100);

	schedinit();
}

static void
mpstartap(Apic* apic)
{
	ulong *apbootp, *pdb, *pte;
	Mach *mach, *mach0;
	int i, machno;
	uchar *p;

	mach0 = MACHP(0);

	/*
	 * Initialise the AP page-tables and Mach structure. The page-tables
	 * are the same as for the bootstrap processor with the exception of
	 * the PTE for the Mach structure.
	 * Xspanalloc will panic if an allocation can't be made.
	 */
	p = xspanalloc(4*BY2PG, BY2PG, 0);
	pdb = (ulong*)p;
	memmove(pdb, mach0-&gt;pdb, BY2PG);
	p += BY2PG;

	if((pte = mmuwalk(pdb, MACHADDR, 1, 0)) == nil)
		return;
	memmove(p, KADDR(PPN(*pte)), BY2PG);
	*pte = PADDR(p)|PTEWRITE|PTEVALID;
	if(mach0-&gt;havepge)
		*pte |= PTEGLOBAL;
	p += BY2PG;

	mach = (Mach*)p;
	if((pte = mmuwalk(pdb, MACHADDR, 2, 0)) == nil)
		return;
	*pte = PADDR(mach)|PTEWRITE|PTEVALID;
	if(mach0-&gt;havepge)
		*pte |= PTEGLOBAL;
	p += BY2PG;

	machno = apic-&gt;machno;
	MACHP(machno) = mach;
	mach-&gt;machno = machno;
	mach-&gt;pdb = pdb;
	mach-&gt;gdt = (Segdesc*)p;	/* filled by mmuinit */

	/*
	 * Tell the AP where its kernel vector and pdb are.
	 * The offsets are known in the AP bootstrap code.
	 */
	apbootp = (ulong*)(APBOOTSTRAP+0x08);
	*apbootp++ = (ulong)squidboy;	/* assembler jumps here eventually */
	*apbootp++ = PADDR(pdb);
	*apbootp = (ulong)apic;

	/*
	 * Universal Startup Algorithm.
	 */
	p = KADDR(0x467);		/* warm-reset vector */
	*p++ = PADDR(APBOOTSTRAP);
	*p++ = PADDR(APBOOTSTRAP)&gt;&gt;8;
	i = (PADDR(APBOOTSTRAP) &amp; ~0xFFFF)/16;
	/* code assumes i==0 */
	if(i != 0)
		print("mp: bad APBOOTSTRAP\n");
	*p++ = i;
	*p = i&gt;&gt;8;

	coherence();

	nvramwrite(0x0F, 0x0A);	/* shutdown code: warm reset upon init ipi */
	lapicstartap(apic, PADDR(APBOOTSTRAP));
	for(i = 0; i &lt; 1000; i++){
		if(apic-&gt;online)
			break;
		delay(10);
	}
	nvramwrite(0x0F, 0x00);
}

static void
trympacpi(void)
{
	if (mpacpifunc != nil) {
		print("mpinit: scanning acpi madt for extra cpus\n");
		(*mpacpifunc)();
	}
}

void
mpinit(void)
{
	int ncpu, cpuson;
	char *cp;
	PCMP *pcmp;
	uchar *e, *p;
	Apic *apic, *bpapic;
	void *va;

	mpdebug = getconf("*debugmp") != nil;
	i8259init();
	syncclock();

	bpapic = nil;
	cpuson = 0;

	if(_mp_ == 0) {
		/*
		 * We can easily get processor info from ACPI, but
		 * interrupt routing, etc. would require interpreting AML.
		 */
		print("mpinit: no mp table found, assuming uniprocessor\n");
		archrevert();
		return;
	}
	pcmp = KADDR(_mp_-&gt;physaddr);

	/*
	 * Map the local APIC.
	 */
	if((va = vmap(pcmp-&gt;lapicbase, 1024)) == nil)
		return;
	mppcmp = pcmp;
	print("LAPIC: %#lux %#lux\n", pcmp-&gt;lapicbase, (ulong)va);

	/*
	 * Run through the table saving information needed for starting
	 * application processors and initialising any I/O APICs. The table
	 * is guaranteed to be in order such that only one pass is necessary.
	 */
	p = ((uchar*)pcmp)+sizeof(PCMP);
	e = ((uchar*)pcmp)+pcmp-&gt;length;
	while(p &lt; e) switch(*p){

	default:
		print("mpinit: unknown PCMP type 0x%uX (e-p 0x%luX)\n",
			*p, e-p);
		while(p &lt; e){
			print("%uX ", *p);
			p++;
		}
		break;

	case PcmpPROCESSOR:
		if(apic = mkprocessor((PCMPprocessor*)p)){
			/*
			 * Must take a note of bootstrap processor APIC
			 * now as it will be needed in order to start the
			 * application processors later and there's no
			 * guarantee that the bootstrap processor appears
			 * first in the table before the others.
			 */
			apic-&gt;addr = va;
			apic-&gt;paddr = pcmp-&gt;lapicbase;
			if(apic-&gt;flags &amp; PcmpBP)
				bpapic = apic;
			cpuson++;
		}
		p += sizeof(PCMPprocessor);
		continue;

	case PcmpBUS:
		mkbus((PCMPbus*)p);
		p += sizeof(PCMPbus);
		continue;

	case PcmpIOAPIC:
		if(apic = mkioapic((PCMPioapic*)p))
			ioapicinit(apic, ((PCMPioapic*)p)-&gt;apicno);
		p += sizeof(PCMPioapic);
		continue;

	case PcmpIOINTR:
		mkiointr((PCMPintr*)p);
		p += sizeof(PCMPintr);
		continue;

	case PcmpLINTR:
		mklintr((PCMPintr*)p);
		p += sizeof(PCMPintr);
		continue;
	}

	dprint("mpinit: mp table describes %d cpus\n", cpuson);

	/* For now, always scan ACPI's MADT for processors that MP missed. */
	trympacpi();

	if (bpapic == nil)
		bpapic = bootapic;

	/*
	 * No bootstrap processor, no need to go further.
	 */
	if(bpapic == 0)
		return;
	bpapic-&gt;online = 1;

	lapicinit(bpapic);

	/*
	 * These interrupts are local to the processor
	 * and do not appear in the I/O APIC so it is OK
	 * to set them now.
	 */
	intrenable(IrqTIMER, lapicclock, 0, BUSUNKNOWN, "clock");
	intrenable(IrqERROR, lapicerror, 0, BUSUNKNOWN, "lapicerror");
	intrenable(IrqSPURIOUS, lapicspurious, 0, BUSUNKNOWN, "lapicspurious");
	lapiconline();

	checkmtrr();

	/*
	 * Initialise the application processors.
	 */
	if(cp = getconf("*ncpu")){
		ncpu = strtol(cp, 0, 0);
		if(ncpu &lt; 1)
			ncpu = 1;
		else if(ncpu &gt; MAXMACH)
			ncpu = MAXMACH;
	}
	else
		ncpu = MAXMACH;
	memmove((void*)APBOOTSTRAP, apbootstrap, sizeof(apbootstrap));
	for(apic = mpapic; apic &lt;= &amp;mpapic[MaxAPICNO]; apic++){
		if(ncpu &lt;= 1)
			break;
		if((apic-&gt;flags &amp; (PcmpBP|PcmpEN)) == PcmpEN
		&amp;&amp; apic-&gt;type == PcmpPROCESSOR){
			mpstartap(apic);
			conf.nmach++;
			ncpu--;
		}
	}

	/*
	 *  we don't really know the number of processors till
	 *  here.
	 *
	 *  set conf.copymode here if nmach &gt; 1.
	 *  Should look for an ExtINT line and enable it.
	 */
	if(X86FAMILY(m-&gt;cpuidax) == 3 || conf.nmach &gt; 1)
		conf.copymode = 1;
}

static int
mpintrcpu(void)
{
	int i;

	/*
	 * The bulk of this code was written ~1995, when there was
	 * one architecture and one generation of hardware, the number
	 * of CPUs was up to 4(8) and the choices for interrupt routing
	 * were physical, or flat logical (optionally with lowest
	 * priority interrupt). Logical mode hasn't scaled well with
	 * the increasing number of packages/cores/threads, so the
	 * fall-back is to physical mode, which works across all processor
	 * generations, both AMD and Intel, using the APIC and xAPIC.
	 *
	 * Interrupt routing policy can be set here.
	 * Currently, just assign each interrupt to a different CPU on
	 * a round-robin basis. Some idea of the packages/cores/thread
	 * topology would be useful here, e.g. to not assign interrupts
	 * to more than one thread in a core, or to use a "noise" core.
	 * But, as usual, Intel make that an onerous task. 
	 */

	/*
	 * temporary workaround for many-core intel (non-amd) systems:
	 * always use cpu 0.  (TODO)
	 */
	if(strncmp(m-&gt;cpuidid, "AuthenticAMD", 12) != 0 &amp;&amp; conf.nmach &gt; 8)
		return 0;

	lock(&amp;mpphysidlock);
	for(;;){
		i = mpphysid++;
		if(mpphysid &gt;= MaxAPICNO+1)
			mpphysid = 0;
		if(mpapic[i].online)
			break;
	}
	unlock(&amp;mpphysidlock);

	return mpapic[i].apicno;
}

static int
mpintrenablex(Vctl* v, int tbdf)
{
	Bus *bus;
	Aintr *aintr;
	Apic *apic;
	Pcidev *pcidev;
	int bno, dno, hi, irq, lo, n, type, vno;
	char *typenm;

	/*
	 * Find the bus.
	 */
	type = BUSTYPE(tbdf);
	bno = BUSBNO(tbdf);
	dno = BUSDNO(tbdf);
	if(type == BusISA)
		bno = mpisabus;
	vno = -1;
	for(bus = mpbus; bus != nil; bus = bus-&gt;next){
		if(bus-&gt;type != type)
			continue;
		if(bus-&gt;busno == bno)
			break;
	}
	if(bus == nil){
		typenm = type &lt; 0 || type &gt;= nelem(buses)? "": buses[type];
		print("mpintrenablex: can't find bus type %d (%s) for irq %d "
			"%s busno %d\n", type, typenm, v-&gt;irq, v-&gt;name, bno);
		return -1;
	}

	/*
	 * For PCI devices the interrupt pin (INT[ABCD]) and device
	 * number are encoded into the entry irq field, so create something
	 * to match on. The interrupt pin used by the device has to be
	 * obtained from the PCI config space.
	 */
	if(bus-&gt;type == BusPCI){
		pcidev = pcimatchtbdf(tbdf);
		if(pcidev != nil &amp;&amp; (n = pcicfgr8(pcidev, PciINTP)) != 0)
			irq = (dno&lt;&lt;2)|(n-1);
		else
			irq = -1;
		//print("pcidev %#uX: irq %#uX v-&gt;irq %#uX\n", tbdf, irq, v-&gt;irq);
	}
	else
		irq = v-&gt;irq;

	/*
	 * Find a matching interrupt entry from the list of interrupts
	 * attached to this bus.
	 */
	for(aintr = bus-&gt;aintr; aintr; aintr = aintr-&gt;next){
		if(aintr-&gt;intr-&gt;irq != irq)
			continue;
		if (0) {
			PCMPintr* p = aintr-&gt;intr;

	   	 	print("mpintrenablex: bus %d intin %d irq %d\n",
				p-&gt;busno, p-&gt;intin, p-&gt;irq);
		}
		/*
		 * Check if already enabled. Multifunction devices may share
		 * INT[A-D]# so, if already enabled, check the polarity matches
		 * and the trigger is level.
		 *
		 * Should check the devices differ only in the function number,
		 * but that can wait for the planned enable/disable rewrite.
		 * The RDT read here is safe for now as currently interrupts
		 * are never disabled once enabled.
		 */
		apic = aintr-&gt;apic;
		ioapicrdtr(apic, aintr-&gt;intr-&gt;intin, 0, &amp;lo);
		if(!(lo &amp; ApicIMASK)){
			vno = lo &amp; 0xFF;
//print("%s vector %d (!imask)\n", v-&gt;name, vno);
			n = mpintrinit(bus, aintr-&gt;intr, vno, v-&gt;irq);
			n |= ApicPHYSICAL;		/* no-op */
			lo &amp;= ~(ApicRemoteIRR|ApicDELIVS);
			if(n != lo || !(n &amp; ApicLEVEL)){
				print("mpintrenable: multiple botch irq%d, tbdf %uX, lo %8.8uX, n %8.8uX\n",
					v-&gt;irq, tbdf, lo, n);
				return -1;
			}
			break;
		}

		/*
		 * With the APIC a unique vector can be assigned to each
		 * request to enable an interrupt. There are two reasons this
		 * is a good idea:
		 * 1) to prevent lost interrupts, no more than 2 interrupts
		 *    should be assigned per block of 16 vectors (there is an
		 *    in-service entry and a holding entry for each priority
		 *    level and there is one priority level per block of 16
		 *    interrupts).
		 * 2) each input pin on the IOAPIC will receive a different
		 *    vector regardless of whether the devices on that pin use
		 *    the same IRQ as devices on another pin.
		 */
		vno = VectorAPIC + (incref(&amp;mpvnoref)-1)*8;
//print("%s vector %d (imask)\n", v-&gt;name, vno);
		if(vno &gt; MaxVectorAPIC){
			print("mpintrenable: vno %d, irq %d, tbdf %uX\n",
				vno, v-&gt;irq, tbdf);
			return -1;
		}

		hi = mpintrcpu()&lt;&lt;24;
		lo = mpintrinit(bus, aintr-&gt;intr, vno, v-&gt;irq);
		//print("lo 0x%uX: busno %d intr %d vno %d irq %d elcr 0x%uX\n",
		//	lo, bus-&gt;busno, aintr-&gt;intr-&gt;irq, vno,
		//	v-&gt;irq, i8259elcr);
		if(lo &amp; ApicIMASK)
			return -1;
		lo |= ApicPHYSICAL;			/* no-op */

		if((apic-&gt;flags &amp; PcmpEN) &amp;&amp; apic-&gt;type == PcmpIOAPIC)
 			ioapicrdtw(apic, aintr-&gt;intr-&gt;intin, hi, lo);
		//else
		//	print("lo not enabled 0x%uX %d\n",
		//		apic-&gt;flags, apic-&gt;type);
		break;
	}
	if (aintr) {
		v-&gt;isr = lapicisr;
		v-&gt;eoi = lapiceoi;
	}
	return vno;
}

int
mpintrenable(Vctl* v)
{
	int irq, tbdf, vno;

	/*
	 * If the bus is known, try it.
	 * BUSUNKNOWN is given both by [E]ISA devices and by
	 * interrupts local to the processor (local APIC, coprocessor
	 * breakpoint and page-fault).
	 */
	tbdf = v-&gt;tbdf;
	if(tbdf != BUSUNKNOWN &amp;&amp; (vno = mpintrenablex(v, tbdf)) != -1)
		return vno;

	irq = v-&gt;irq;
	if(irq &gt;= IrqLINT0 &amp;&amp; irq &lt;= MaxIrqLAPIC){
		if(irq != IrqSPURIOUS)
			v-&gt;isr = lapiceoi;
		return VectorPIC+irq;
	}
	if(irq &lt; 0 || irq &gt; MaxIrqPIC){
		print("mpintrenable: irq %d out of range\n", irq);
		return -1;
	}

	/*
	 * Either didn't find it or have to try the default buses
	 * (ISA and EISA). This hack is due to either over-zealousness 
	 * or laziness on the part of some manufacturers.
	 *
	 * The MP configuration table on some older systems
	 * (e.g. ASUS PCI/E-P54NP4) has an entry for the EISA bus
	 * but none for ISA. It also has the interrupt type and
	 * polarity set to 'default for this bus' which wouldn't
	 * be compatible with ISA.
	 */
	if(mpeisabus != -1){
		vno = mpintrenablex(v, MKBUS(BusEISA, 0, 0, 0));
		if(vno != -1)
			return vno;
	}
	if(mpisabus != -1){
		vno = mpintrenablex(v, MKBUS(BusISA, 0, 0, 0));
		if(vno != -1)
			return vno;
	}
	print("mpintrenable: out of choices eisa %d isa %d tbdf %#ux irq %d\n",
		mpeisabus, mpisabus, v-&gt;tbdf, v-&gt;irq);
	return -1;
}

static Lock mpshutdownlock;

void
mpshutdown(void)
{
	/*
	 * To be done...
	 */
	if(!canlock(&amp;mpshutdownlock)){
		/*
		 * If this processor received the CTRL-ALT-DEL from
		 * the keyboard, acknowledge it. Send an INIT to self.
		 */
#ifdef FIXTHIS
		if(lapicisr(VectorKBD))
			lapiceoi(VectorKBD);
#endif /* FIX THIS */
		arch-&gt;introff();
		idle();
	}

	if(active.rebooting)
		return;
	print("apshutdown: active = %#8.8ux\n", active.machs);
	delay(1000);
	splhi();
	arch-&gt;resetothers();

	pcireset();
	i8042reset();

	/*
	 * Often the BIOS hangs during restart if a conventional 8042
	 * warm-boot sequence is tried. The following is Intel specific and
	 * seems to perform a cold-boot, but at least it comes back.
	 * And sometimes there is no keyboard...
	 *
	 * The reset register (0xcf9) is usually in one of the bridge
	 * chips. The actual location and sequence could be extracted from
	 * ACPI but why bother, this is the end of the line anyway.
	 */
	print("no kbd; trying bios warm boot...");
	*(ushort*)KADDR(0x472) = 0x1234;	/* BIOS warm-boot flag */
	outb(0xCF9, 0x02);
	outb(0xCF9, 0x06);

	print("can't reset\n");
	for(;;)
		idle();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

