<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/mpacpi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/mpacpi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * minimal acpi support for multiprocessors.
 *
 * avoids AML but that's only enough to discover
 * the processors, not the interrupt routing details.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "mp.h"
#include "mpacpi.h"

/* 8c says: out of fixed registers */
#define L64GET(p)	((uvlong)L32GET((p)+4) &lt;&lt; 32 | L32GET(p))

enum {
	/* apic types */
	Apiclproc,
	Apicio,
	Apicintrsrcoverride,
	Apicnmisrc,
	Apiclnmi,
	Apicladdroverride,
	Apicios,
	Apicls,
	Apicintrsrc,
	Apiclx2,
	Apiclx2nmi,

	PcmpUsed = 1ul&lt;&lt;31,		/* Apic-&gt;flags addition */

	Lapicbase = 0x1b,		/* msr */

	Lapicae	= 1&lt;&lt;11,		/* apic enable in Lapicbase */
};

#define dprint(...)	if(mpdebug) print(__VA_ARGS__); else USED(mpdebug)

/* from mp.c */
int	mpdebug;
int	mpmachno;
Apic	mpapic[MaxAPICNO+1];
int	machno2apicno[MaxAPICNO+1];	/* inverse map: machno -&gt; APIC ID */

Apic	*bootapic;

static int nprocid;

static uvlong
l64get(uchar *p)
{
	return L64GET(p);
}

int
apicset(Apic *apic, int type, int apicno, int f)
{
	if(apicno &gt; MaxAPICNO)
		return -1;
	apic-&gt;type = type;
	apic-&gt;apicno = apicno;
	apic-&gt;flags = f | PcmpEN | PcmpUsed;
	return 0;
}

int
mpnewproc(Apic *apic, int apicno, int f)
{
	if(apic-&gt;flags &amp; PcmpUsed) {
		print("mpnewproc: apic already enabled\n");
		return -1;
	}
	if (apicset(apic, PcmpPROCESSOR, apicno, f) &lt; 0)
		return -1;
	apic-&gt;lintr[1] = apic-&gt;lintr[0] = ApicIMASK;
	/* botch! just enumerate */
	if(apic-&gt;flags &amp; PcmpBP)
		apic-&gt;machno = 0;
	else
		apic-&gt;machno = ++mpmachno;
	machno2apicno[apic-&gt;machno] = apicno;
	return 0;
}

static int
mpacpiproc(uchar *p, ulong laddr)
{
	int id, f;
	ulong *vladdr;
	vlong base;
	char *already;
	Apic *apic;

	/* p bytes: type (0), len (8), cpuid, cpu_lapic id, flags[4] */
	id = p[3];
	/* cpu unusable flag or id out of range? */
	if((L32GET(p+4) &amp; 1) == 0 || id &gt; MaxAPICNO)
		return -1;

	vladdr = nil;
	already = "";
	f = 0;
	apic = &amp;mpapic[id];
	dprint("\tmpacpiproc: apic %#p\n", apic);
	apic-&gt;paddr = laddr;
	if (nprocid++ == 0) {
		f = PcmpBP;
		vladdr = vmap(apic-&gt;paddr, 1024);
		if(apic-&gt;addr == nil){
			print("proc apic %d: failed to map %#p\n", id,
				apic-&gt;paddr);
			already = "(fail)";
		}
		bootapic = apic;
	}
	apic-&gt;addr = vladdr;

	if(apic-&gt;flags &amp; PcmpUsed)
		already = "(on)";
	else
		mpnewproc(apic, id, f);

	if (0)
		dprint("\tapic proc %d/%d apicid %d flags%s%s %s\n", nprocid-1,
			apic-&gt;machno, id, f &amp; PcmpBP? " boot": "",
			f &amp; PcmpEN? " enabled": "", already);
	USED(already);

	rdmsr(Lapicbase, &amp;base);
	if (!(base &amp; Lapicae)) {
		dprint("mpacpiproc: enabling lapic\n");
		wrmsr(Lapicbase, base | Lapicae);
	}
	return 0;
}

static void
mpacpicpus(Madt *madt)
{
	int i, n;
	ulong laddr;
	uchar *p;

	laddr = L32GET(madt-&gt;addr);
	dprint("APIC mpacpicpus(%#p) lapic addr %#lux, flags %#ux\n",
		madt, laddr, L32GET(madt-&gt;flags));

	n = L32GET(&amp;madt-&gt;sdthdr[4]);
	p = madt-&gt;structures;
	dprint("\t%d structures at %#p\n",n, p);
	/* byte 0 is assumed to be type, 1 is assumed to be length */
	for(i = offsetof(Madt, structures[0]); i &lt; n; i += p[1], p += p[1])
		switch(p[0]){
		case Apiclproc:
			mpacpiproc(p, laddr);
			break;
		}
}

/* returns nil iff checksum is bad */
static void *
mpacpirsdchecksum(void* addr, int length)
{
	uchar *p, sum;

	sum = 0;
	for(p = addr; length-- &gt; 0; p++)
		sum += *p;
	return sum == 0? addr: nil;
}

/* call func for each acpi table found */
static void
mpacpiscan(void (*func)(uchar *))
{
	int asize, i, tbllen, sdtlen;
	uintptr dhpa, sdtpa;
	uchar *tbl, *sdt;
	Rsd *rsd;

	dprint("ACPI...");
	if((rsd = sigsearch("RSD PTR ")) == nil) {
		dprint("none\n");
		return;
	}

	dprint("rsd %#p physaddr %#ux length %ud %#llux rev %d oem %.6s\n",
		rsd, L32GET(rsd-&gt;raddr), L32GET(rsd-&gt;length),
		l64get(rsd-&gt;xaddr), rsd-&gt;revision, (char*)rsd-&gt;oemid);

	if(rsd-&gt;revision == 2){
		if(mpacpirsdchecksum(rsd, 36) == nil)
			return;
		asize = 8;
		sdtpa = l64get(rsd-&gt;xaddr);
	} else {
		if(mpacpirsdchecksum(rsd, 20) == nil)
			return;
		asize = 4;
		sdtpa = L32GET(rsd-&gt;raddr);
	}

	if((sdt = vmap(sdtpa, 8)) == nil)
		return;
	if((sdt[0] != 'R' &amp;&amp; sdt[0] != 'X') || memcmp(sdt+1, "SDT", 3) != 0){
		vunmap(sdt, 8);
		return;
	}
	sdtlen = L32GET(sdt + 4);
	vunmap(sdt, 8);

	if((sdt = vmap(sdtpa, sdtlen)) == nil)
		return;
	if(mpacpirsdchecksum(sdt, sdtlen) != nil)
		for(i = 36; i &lt; sdtlen; i += asize){
			if(asize == 8)
				dhpa = l64get(sdt+i);
			else
				dhpa = L32GET(sdt+i);
	
			if((tbl = vmap(dhpa, 8)) == nil)
				continue;
			tbllen = L32GET(tbl + 4);
			vunmap(tbl, 8);
	
			if((tbl = vmap(dhpa, tbllen)) == nil)
				continue;
			if(mpacpirsdchecksum(tbl, tbllen) != nil)
				(*func)(tbl);
			vunmap(tbl, tbllen);
		}
	vunmap(sdt, sdtlen);
}

static void
mpacpitbl(uchar *p)
{
	/* for now, just activate any idle cpus */
	if (memcmp(p, "APIC", 4) == 0)
		mpacpicpus((Madt *)p);
}

static void
mpacpi(void)
{
	mpdebug = getconf("*debugmp") != nil;
	mpacpiscan(mpacpitbl);
}

void	(*mpacpifunc)(void) = mpacpi;
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

