<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/piix4smbus.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/piix4smbus.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"

/*
 *	SMBus support for the PIIX4
 */
enum
{
	IntelVendID=	0x8086,
	Piix4PMID=	0x7113,		/* PIIX4 power management function */

	/* SMBus configuration registers (function 3) */
	SMBbase=	0x90, /* 4 byte base address (bit 0 == 1, bit 3:1 == 0) */
	SMBconfig=	0xd2,
	SMBintrselect=	(7&lt;&lt;1),
	SMIenable=	(0&lt;&lt;1),		/* interrupts sent to SMI# */
	IRQ9enable=	(4&lt;&lt;1),		/* interrupts sent to IRQ9 */
	SMBenable=	(1&lt;&lt;0),		/* 1 enables */

	/* SMBus IO space registers */
	Hoststatus=	0x0,	/* (writing 1 bits reset the interrupt bits) */
	Failed=		(1&lt;&lt;4),		/* transaction terminated by KILL */
	Bus_error=	(1&lt;&lt;3),		/* transaction collision */
	Dev_error=	(1&lt;&lt;2),		/* device error interrupt */
	Host_complete=	(1&lt;&lt;1),		/* host command completion interrupt */
	Host_busy=	(1&lt;&lt;0),		/*  */
	Slavestatus=	0x1,	/* (writing 1 bits reset) */
	Alert_sts=	(1&lt;&lt;5),		/* someone asserted SMBALERT# */
	Shdw2_sts=	(1&lt;&lt;4),		/* slave accessed shadow 2 port */
	Shdw1_sts=	(1&lt;&lt;3),		/* slave accessed shadow 1 port */
	Slv_sts=	(1&lt;&lt;2),		/* slave accessed shadow 1 port */
	Slv_bsy=	(1&lt;&lt;0),
	Hostcontrol=	0x2,
	Start=		(1&lt;&lt;6),		/* start execution */
	Cmd_prot=	(7&lt;&lt;2),		/* command protocol mask */
	Quick=		(0&lt;&lt;2),		/*  address only */
	Byte=		(1&lt;&lt;2),		/*  address + cmd */
	ByteData=	(2&lt;&lt;2),		/*  address + cmd + data */
	WordData=	(3&lt;&lt;2),		/*  address + cmd + data + data */
	Kill=		(1&lt;&lt;1),		/* abort in progress command */
	Ienable=	(1&lt;&lt;0),		/* enable completion interrupts */
	Hostcommand=	0x3,
	Hostaddress=	0x4,
	AddressMask=	(0x7f&lt;&lt;1),	/* target address */
	Read=		(1&lt;&lt;0),		/* 1 == read, 0 == write */
	Hostdata0=	0x5,
	Hostdata1=	0x6,
	Blockdata=	0x7,
	Slavecontrol=	0x8,
	Alert_en=	(1&lt;&lt;3),	/* enable inter on SMBALERT# */
	Shdw2_en=	(1&lt;&lt;2),	/* enable inter on external shadow 2 access */
	Shdw1_en=	(1&lt;&lt;1),	/* enable inter on external shadow 1 access */
	Slv_en=		(1&lt;&lt;0),	/* enable inter on access of host ctlr slave port */
	Shadowcommand=	0x9,
	Slaveevent=	0xa,
	Slavedata=	0xc,
};

static struct
{
	int	rw;
	int	cmd;
	int	len;
	int	proto;
} proto[] =
{
	[SMBquick]	{ 0,	0,	0,	Quick },
	[SMBsend]	{ 0,	1,	0,	Byte },
	[SMBbytewrite]	{ 0,	1,	1,	ByteData },
	[SMBwordwrite]	{ 0,	1,	2,	WordData },
	[SMBrecv]	{ Read,	0,	1, 	Byte },
	[SMBbyteread]	{ Read,	1,	1,	ByteData },
	[SMBwordread]	{ Read,	1,	2,	WordData },
};

static void
transact(SMBus *s, int type, int addr, int cmd, uchar *data)
{
	int tries, status;
	char err[256];

	if(type &lt; 0 || type &gt; nelem(proto))
		panic("piix4smbus: illegal transaction type %d", type);

	if(waserror()){
		qunlock(s);
		nexterror();
	}
	qlock(s);

	/* wait a while for the host interface to be available */
	for(tries = 0; tries &lt; 1000000; tries++){
		if((inb(s-&gt;base+Hoststatus) &amp; Host_busy) == 0)
			break;
		sched();
	}
	if(tries &gt;= 1000000){
		/* try aborting current transaction */
		outb(s-&gt;base+Hostcontrol, Kill);
		for(tries = 0; tries &lt; 1000000; tries++){
			if((inb(s-&gt;base+Hoststatus) &amp; Host_busy) == 0)
				break;
			sched();
		}
		if(tries &gt;= 1000000){
			snprint(err, sizeof(err), "SMBus jammed: %2.2ux", inb(s-&gt;base+Hoststatus));
			error(err);
		}
	}

	/* set up for transaction */
	outb(s-&gt;base+Hostaddress, (addr&lt;&lt;1)|proto[type].rw);
	if(proto[type].cmd)
		outb(s-&gt;base+Hostcommand, cmd);
	if(proto[type].rw != Read){
		switch(proto[type].len){
		case 2:
			outb(s-&gt;base+Hostdata1, data[1]);
			/* fall through */
		case 1:
			outb(s-&gt;base+Hostdata0, data[0]);
			break;
		}
	}


	/* reset the completion/error bits and start transaction */
	outb(s-&gt;base+Hoststatus, Failed|Bus_error|Dev_error|Host_complete);
	outb(s-&gt;base+Hostcontrol, Start|proto[type].proto);

	/* wait for completion */
	status = 0;
	for(tries = 0; tries &lt; 1000000; tries++){
		status = inb(s-&gt;base+Hoststatus);
		if(status &amp; (Failed|Bus_error|Dev_error|Host_complete))
			break;
		sched();
	}
	if((status &amp; Host_complete) == 0){
		snprint(err, sizeof(err), "SMBus request failed: %2.2ux", status);
		error(err);
	}

	/* get results */
	if(proto[type].rw == Read){
		switch(proto[type].len){
		case 2:
			data[1] = inb(s-&gt;base+Hostdata1);
			/* fall through */
		case 1:
			data[0] = inb(s-&gt;base+Hostdata0);
			break;
		}
	}
	qunlock(s);
	poperror();
}

static SMBus smbusproto =
{
	.transact = transact,
};

/*
 *  return 0 if this is a piix4 with an smbus interface
 */
SMBus*
piix4smbus(void)
{
	Pcidev *p;
	static SMBus *s;

	if(s != nil)
		return s;

	p = pcimatch(nil, IntelVendID, Piix4PMID);
	if(p == nil)
		return nil;

	s = smalloc(sizeof(*s));
	memmove(s, &amp;smbusproto, sizeof(*s));
	s-&gt;arg = p;

	/* disable the smbus */
	pcicfgw8(p, SMBconfig, IRQ9enable|0);

	/* see if bios gave us a viable port space */
	s-&gt;base = pcicfgr32(p, SMBbase) &amp; ~1;
print("SMB base from bios is 0x%lux\n", s-&gt;base);
	if(ioalloc(s-&gt;base, 0xd, 0, "piix4smbus") &lt; 0){
		s-&gt;base = ioalloc(-1, 0xd, 2, "piix4smbus");
		if(s-&gt;base &lt; 0){
			free(s);
			print("piix4smbus: can't allocate io port\n");
			return nil;
		}
print("SMB base ialloc is 0x%lux\n", s-&gt;base);
		pcicfgw32(p, SMBbase, s-&gt;base|1);
	}

	/* disable SMBus interrupts, abort any transaction in progress */
	outb(s-&gt;base+Hostcontrol, Kill);
	outb(s-&gt;base+Slavecontrol, 0);

	/* enable the smbus */
	pcicfgw8(p, SMBconfig, IRQ9enable|SMBenable);

	return s;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

