<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/sd53c8xx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/sd53c8xx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * NCR/Symbios/LSI Logic 53c8xx driver for Plan 9
 * Nigel Roles (nigel@9fs.org)
 *
 * 27/5/02	Fixed problems with transfers &gt;= 256 * 512
 *
 * 13/3/01	Fixed microcode to support targets &gt; 7
 *
 * 01/12/00	Removed previous comments. Fixed a small problem in
 *			mismatch recovery for targets with synchronous offsets of &gt;=16
 *			connected to &gt;=875s. Thanks, Jean.
 *
 * Known problems
 *
 * Read/write mismatch recovery may fail on 53c1010s. Really need to get a manual.
 */

#define MAXTARGET	16		/* can be 8 or 16 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"

#include "../port/sd.h"
extern SDifc sd53c8xxifc;

/**********************************/
/* Portable configuration macros  */
/**********************************/

//#define BOOTDEBUG
//#define ASYNC_ONLY
//#define	INTERNAL_SCLK
//#define ALWAYS_DO_WDTR
#define WMR_DEBUG

/**********************************/
/* CPU specific macros            */
/**********************************/

#define PRINTPREFIX "sd53c8xx: "

#ifdef BOOTDEBUG

#define KPRINT oprint
#define IPRINT intrprint
#define DEBUG(n) 1
#define IFLUSH() iflush()

#else

static int idebug = 1;
#define KPRINT	if(0) iprint
#define IPRINT	if(idebug) iprint
#define DEBUG(n)	(0)
#define IFLUSH()

#endif /* BOOTDEBUG */

/*******************************/
/* General                     */
/*******************************/

#ifndef DMASEG
#define DMASEG(x) PCIWADDR(x)
#define legetl(x) (*(ulong*)(x))
#define lesetl(x,v) (*(ulong*)(x) = (v))
#define swabl(a,b,c)
#else
#endif /*DMASEG */
#define DMASEG_TO_KADDR(x) KADDR((x)-PCIWINDOW)
#define KPTR(x) ((x) == 0 ? 0 : DMASEG_TO_KADDR(x))

#define MEGA 1000000L
#ifdef INTERNAL_SCLK
#define	SCLK (33 * MEGA)
#else
#define SCLK (40 * MEGA)
#endif /* INTERNAL_SCLK */
#define ULTRA_NOCLOCKDOUBLE_SCLK (80 * MEGA)

#define MAXSYNCSCSIRATE (5 * MEGA)
#define MAXFASTSYNCSCSIRATE (10 * MEGA)
#define MAXULTRASYNCSCSIRATE (20 * MEGA)
#define MAXULTRA2SYNCSCSIRATE (40 * MEGA)
#define MAXASYNCCORERATE (25 * MEGA)
#define MAXSYNCCORERATE (25 * MEGA)
#define MAXFASTSYNCCORERATE (50 * MEGA)
#define MAXULTRASYNCCORERATE (80 * MEGA)
#define MAXULTRA2SYNCCORERATE (160 * MEGA)


#define X_MSG	1
#define X_MSG_SDTR 1
#define X_MSG_WDTR 3

struct na_patch {
	unsigned lwoff;
	unsigned char type;
};

typedef struct Ncr {
	uchar scntl0;	/* 00 */
	uchar scntl1;
	uchar scntl2;
	uchar scntl3;

	uchar scid;	/* 04 */
	uchar sxfer;
	uchar sdid;
	uchar gpreg;

	uchar sfbr;	/* 08 */
	uchar socl;
	uchar ssid;
	uchar sbcl;

	uchar dstat;	/* 0c */
	uchar sstat0;
	uchar sstat1;
	uchar sstat2;

	uchar dsa[4];	/* 10 */

	uchar istat;	/* 14 */
	uchar istatpad[3];

	uchar ctest0;	/* 18 */
	uchar ctest1;
	uchar ctest2;
	uchar ctest3;

	uchar temp[4];	/* 1c */

	uchar dfifo;	/* 20 */
	uchar ctest4;
	uchar ctest5;
	uchar ctest6;

	uchar dbc[3];	/* 24 */
	uchar dcmd;	/* 27 */

	uchar dnad[4];	/* 28 */
	uchar dsp[4];	/* 2c */
	uchar dsps[4];	/* 30 */

	uchar scratcha[4];	/* 34 */

	uchar dmode;	/* 38 */
	uchar dien;
	uchar dwt;
	uchar dcntl;

	uchar adder[4];	/* 3c */

	uchar sien0;	/* 40 */
	uchar sien1;
	uchar sist0;
	uchar sist1;

	uchar slpar;	/* 44 */
	uchar slparpad0;
	uchar macntl;
	uchar gpcntl;

	uchar stime0;	/* 48 */
	uchar stime1;
	uchar respid;
	uchar respidpad0;

	uchar stest0;	/* 4c */
	uchar stest1;
	uchar stest2;
	uchar stest3;

	uchar sidl;	/* 50 */
	uchar sidlpad[3];

	uchar sodl;	/* 54 */
	uchar sodlpad[3];

	uchar sbdl;	/* 58 */
	uchar sbdlpad[3];

	uchar scratchb[4];	/* 5c */
} Ncr;

typedef struct Movedata {
	uchar dbc[4];
	uchar pa[4];
} Movedata;

typedef enum NegoState {
	NeitherDone, WideInit, WideResponse, WideDone,
	SyncInit, SyncResponse, BothDone
} NegoState;

typedef enum State {
	Allocated, Queued, Active, Done
} State;

typedef struct Dsa Dsa;
struct Dsa {
	uchar stateb;
	uchar result;
	uchar dmablks;
	uchar flag;	/* setbyte(state,3,...) */

	union {
		ulong dmancr;		/* For block transfer: NCR order (little-endian) */
		uchar dmaaddr[4];
	};

	uchar target;			/* Target */
	uchar pad0[3];

	uchar lun;			/* Logical Unit Number */
	uchar pad1[3];

	uchar scntl3;
	uchar sxfer;
	uchar pad2[2];

	uchar next[4];			/* chaining for SCRIPT (NCR byte order) */
	Dsa	*freechain;		/* chaining for freelist */
	Rendez;
	uchar scsi_id_buf[4];
	Movedata msg_out_buf;
	Movedata cmd_buf;
	Movedata data_buf;
	Movedata status_buf;
	uchar msg_out[10];		/* enough to include SDTR */
	uchar status;
	int p9status;
	uchar parityerror;
};

typedef enum Feature {
	BigFifo = 1,			/* 536 byte fifo */
	BurstOpCodeFetch = 2,		/* burst fetch opcodes */
	Prefetch = 4,			/* prefetch 8 longwords */
	LocalRAM = 8,			/* 4K longwords of local RAM */
	Differential = 16,		/* Differential support */
	Wide = 32,			/* Wide capable */
	Ultra = 64,			/* Ultra capable */
	ClockDouble = 128,		/* Has clock doubler */
	ClockQuad = 256,		/* Has clock quadrupler (same as Ultra2) */
	Ultra2 = 256,
} Feature;

typedef enum Burst {
	Burst2 = 0,
	Burst4 = 1,
	Burst8 = 2,
	Burst16 = 3,
	Burst32 = 4,
	Burst64 = 5,
	Burst128 = 6
} Burst;

typedef struct Variant {
	ushort did;
	uchar maxrid;			/* maximum allowed revision ID */
	char *name;
	Burst burst;			/* codings for max burst */
	uchar maxsyncoff;		/* max synchronous offset */
	uchar registers;		/* number of 32 bit registers */
	unsigned feature;
} Variant;

static unsigned char cf2[] = { 6, 2, 3, 4, 6, 8, 12, 16 };
#define NULTRA2SCF (sizeof(cf2)/sizeof(cf2[0]))
#define NULTRASCF (NULTRA2SCF - 2)
#define NSCF (NULTRASCF - 1)

typedef struct Controller {
	Lock;
	struct {
		uchar scntl3;
		uchar stest2;
	} bios;
	uchar synctab[NULTRA2SCF - 1][8];/* table of legal tpfs */
	NegoState s[MAXTARGET];
	uchar scntl3[MAXTARGET];
	uchar sxfer[MAXTARGET];
	uchar cap[MAXTARGET];		/* capabilities byte from Identify */
	ushort capvalid;		/* bit per target for validity of cap[] */
	ushort wide;			/* bit per target set if wide negotiated */
	ulong sclk;			/* clock speed of controller */
	uchar clockmult;		/* set by synctabinit */
	uchar ccf;			/* CCF bits */
	uchar tpf;			/* best tpf value for this controller */
	uchar feature;			/* requested features */
	int running;			/* is the script processor running? */
	int ssm;			/* single step mode */
	Ncr *n;				/* pointer to registers */
	Variant *v;			/* pointer to variant type */
	ulong *script;			/* where the real script is */
	ulong scriptpa;			/* where the real script is */
	Pcidev* pcidev;
	SDev*	sdev;

	struct {
		Lock;
		uchar head[4];		/* head of free list (NCR byte order) */
		Dsa	*freechain;
	} dsalist;

	QLock q[MAXTARGET];		/* queues for each target */
} Controller;

#define SYNCOFFMASK(c)		(((c)-&gt;v-&gt;maxsyncoff * 2) - 1)
#define SSIDMASK(c)		(((c)-&gt;v-&gt;feature &amp; Wide) ? 15 : 7)

/* ISTAT */
enum { Abrt = 0x80, Srst = 0x40, Sigp = 0x20, Sem = 0x10, Con = 0x08, Intf = 0x04, Sip = 0x02, Dip = 0x01 };

/* DSTAT */
enum { Dfe = 0x80, Mdpe = 0x40, Bf = 0x20, Abrted = 0x10, Ssi = 0x08, Sir = 0x04, Iid = 0x01 };

/* SSTAT */
enum { DataOut, DataIn, Cmd, Status, ReservedOut, ReservedIn, MessageOut, MessageIn };

static void setmovedata(Movedata*, ulong, ulong);
static void advancedata(Movedata*, long);
static int bios_set_differential(Controller *c);

static char *phase[] = {
	"data out", "data in", "command", "status",
	"reserved out", "reserved in", "message out", "message in"
};

#ifdef BOOTDEBUG
#define DEBUGSIZE 10240
char debugbuf[DEBUGSIZE];
char *debuglast;

static void
intrprint(char *format, ...)
{
	if (debuglast == 0)
		debuglast = debugbuf;
	debuglast = vseprint(debuglast, debugbuf + (DEBUGSIZE - 1), format, (&amp;format + 1));
}

static void
iflush()
{
	int s;
	char *endp;
	s = splhi();
	if (debuglast == 0)
		debuglast = debugbuf;
	if (debuglast == debugbuf) {
		splx(s);
		return;
	}
	endp = debuglast;
	splx(s);
	screenputs(debugbuf, endp - debugbuf);
	s = splhi();
	memmove(debugbuf, endp, debuglast - endp);
	debuglast -= endp - debugbuf;
	splx(s);
}

static void
oprint(char *format, ...)
{
	int s;

	iflush();
	s = splhi();
	if (debuglast == 0)
		debuglast = debugbuf;
	debuglast = vseprint(debuglast, debugbuf + (DEBUGSIZE - 1), format, (&amp;format + 1));
	splx(s);
	iflush();	
}
#endif

#include "sd53c8xx.i"

/*
 * We used to use a linked list of Dsas with nil as the terminator,
 * but occasionally the 896 card seems not to notice that the 0
 * is really a 0, and then it tries to reference the Dsa at address 0.
 * To address this, we use a sentinel dsa that links back to itself
 * and has state A_STATE_END.  If the card takes an iteration or
 * two to notice that the state says A_STATE_END, that's no big 
 * deal.  Clearly this isn't the right approach, but I'm just
 * stumped.  Even with this, we occasionally get prints about
 * "WSR set", usually with about the same frequency that the
 * card used to walk past 0. 
 */
static Dsa *dsaend;

static Dsa*
dsaallocnew(Controller *c)
{
	Dsa *d;
	
	/* c-&gt;dsalist must be ilocked */
	d = xalloc(sizeof *d);
	if (d == nil)
		panic("sd53c8xx dsaallocnew: no memory");
	lesetl(d-&gt;next, legetl(c-&gt;dsalist.head));
	lesetl(&amp;d-&gt;stateb, A_STATE_FREE);
	coherence();
	lesetl(c-&gt;dsalist.head, DMASEG(d));
	coherence();
	return d;
}

static Dsa *
dsaalloc(Controller *c, int target, int lun)
{
	Dsa *d;

	ilock(&amp;c-&gt;dsalist);
	if ((d = c-&gt;dsalist.freechain) != 0) {
		if (DEBUG(1))
			IPRINT(PRINTPREFIX "%d/%d: reused dsa %lux\n", target, lun, (ulong)d);
	} else {	
		d = dsaallocnew(c);
		if (DEBUG(1))
			IPRINT(PRINTPREFIX "%d/%d: allocated dsa %lux\n", target, lun, (ulong)d);
	}
	c-&gt;dsalist.freechain = d-&gt;freechain;
	lesetl(&amp;d-&gt;stateb, A_STATE_ALLOCATED);
	iunlock(&amp;c-&gt;dsalist);
	d-&gt;target = target;
	d-&gt;lun = lun;
	return d;
}

static void
dsafree(Controller *c, Dsa *d)
{
	ilock(&amp;c-&gt;dsalist);
	d-&gt;freechain = c-&gt;dsalist.freechain;
	c-&gt;dsalist.freechain = d;
	lesetl(&amp;d-&gt;stateb, A_STATE_FREE);
	iunlock(&amp;c-&gt;dsalist);
}

static void
dsadump(Controller *c)
{
	Dsa *d;
	u32int *a;
	
	iprint("dsa controller list: c=%p head=%.8lux\n", c, legetl(c-&gt;dsalist.head));
	for(d=KPTR(legetl(c-&gt;dsalist.head)); d != dsaend; d=KPTR(legetl(d-&gt;next))){
		if(d == (void*)-1){
			iprint("\t dsa %p\n", d);
			break;
		}
		a = (u32int*)d;
		iprint("\tdsa %p %.8ux %.8ux %.8ux %.8ux %.8ux %.8ux\n", a, a[0], a[1], a[2], a[3], a[4], a[5]);
	}

/*
	a = KPTR(c-&gt;scriptpa+E_dsa_addr);
	iprint("dsa_addr: %.8ux %.8ux %.8ux %.8ux %.8ux\n",
		a[0], a[1], a[2], a[3], a[4]);
	a = KPTR(c-&gt;scriptpa+E_issue_addr);
	iprint("issue_addr: %.8ux %.8ux %.8ux %.8ux %.8ux\n",
		a[0], a[1], a[2], a[3], a[4]);

	a = KPTR(c-&gt;scriptpa+E_issue_test_begin);
	e = KPTR(c-&gt;scriptpa+E_issue_test_end);
	iprint("issue_test code (at offset %.8ux):\n", E_issue_test_begin);
	
	i = 0;
	for(; a&lt;e; a++){
		iprint(" %.8ux", *a);
		if(++i%8 == 0)
			iprint("\n");
	}
	if(i%8)
		iprint("\n");
*/
}

static Dsa *
dsafind(Controller *c, uchar target, uchar lun, uchar state)
{
	Dsa *d;
	for (d = KPTR(legetl(c-&gt;dsalist.head)); d != dsaend; d = KPTR(legetl(d-&gt;next))) {
		if (d-&gt;target != 0xff &amp;&amp; d-&gt;target != target)
			continue;
		if (lun != 0xff &amp;&amp; d-&gt;lun != lun)
			continue;
		if (state != 0xff &amp;&amp; d-&gt;stateb != state)
			continue;
		break;
	}
	return d;
}

static void
dumpncrregs(Controller *c, int intr)
{
	int i;
	Ncr *n = c-&gt;n;
	int depth = c-&gt;v-&gt;registers / 4;

	if (intr) {
		IPRINT("sa = %.8lux\n", c-&gt;scriptpa);
	}
	else {
		KPRINT("sa = %.8lux\n", c-&gt;scriptpa);
	}
	for (i = 0; i &lt; depth; i++) {
		int j;
		for (j = 0; j &lt; 4; j++) {
			int k = j * depth + i;
			uchar *p;

			/* display little-endian to make 32-bit values readable */
			p = (uchar*)n+k*4;
			if (intr) {
				IPRINT(" %.2x%.2x%.2x%.2x %.2x %.2x", p[3], p[2], p[1], p[0], k * 4, (k * 4) + 0x80);
			}
			else {
				KPRINT(" %.2x%.2x%.2x%.2x %.2x %.2x", p[3], p[2], p[1], p[0], k * 4, (k * 4) + 0x80);
			}
			USED(p);
		}
		if (intr) {
			IPRINT("\n");
		}
		else {
			KPRINT("\n");
		}
	}
}	

static int
chooserate(Controller *c, int tpf, int *scfp, int *xferpp)
{
	/* find lowest entry &gt;= tpf */
	int besttpf = 1000;
	int bestscfi = 0;
	int bestxferp = 0;
	int scf, xferp;
	int maxscf;

	if (c-&gt;v-&gt;feature &amp; Ultra2)
		maxscf = NULTRA2SCF;
	else if (c-&gt;v-&gt;feature &amp; Ultra)
		maxscf = NULTRASCF;
	else
		maxscf = NSCF;

	/*
	 * search large clock factors first since this should
	 * result in more reliable transfers
	 */
	for (scf = maxscf; scf &gt;= 1; scf--) {
		for (xferp = 0; xferp &lt; 8; xferp++) {
			unsigned char v = c-&gt;synctab[scf - 1][xferp];
			if (v == 0)
				continue;
			if (v &gt;= tpf &amp;&amp; v &lt; besttpf) {
				besttpf = v;
				bestscfi = scf;
				bestxferp = xferp;
			}
		}
	}
	if (besttpf == 1000)
		return 0;
	if (scfp)
		*scfp = bestscfi;
	if (xferpp)
		*xferpp = bestxferp;
	return besttpf;
}

static void
synctabinit(Controller *c)
{
	int scf;
	unsigned long scsilimit;
	int xferp;
	unsigned long cr, sr;
	int tpf;
	int fast;
	int maxscf;

	if (c-&gt;v-&gt;feature &amp; Ultra2)
		maxscf = NULTRA2SCF;
	else if (c-&gt;v-&gt;feature &amp; Ultra)
		maxscf = NULTRASCF;
	else
		maxscf = NSCF;

	/*
	 * for chips with no clock doubler, but Ultra capable (e.g. 860, or interestingly the
	 * first spin of the 875), assume 80MHz
	 * otherwise use the internal (33 Mhz) or external (40MHz) default
	 */

	if ((c-&gt;v-&gt;feature &amp; Ultra) != 0 &amp;&amp; (c-&gt;v-&gt;feature &amp; (ClockDouble | ClockQuad)) == 0)
		c-&gt;sclk = ULTRA_NOCLOCKDOUBLE_SCLK;
	else
		c-&gt;sclk = SCLK;

	/*
	 * otherwise, if the chip is Ultra capable, but has a slow(ish) clock,
	 * invoke the doubler
	 */

	if (SCLK &lt;= 40000000) {
		if (c-&gt;v-&gt;feature &amp; ClockDouble) {
			c-&gt;sclk *= 2;
			c-&gt;clockmult = 1;
		}
		else if (c-&gt;v-&gt;feature &amp; ClockQuad) {
			c-&gt;sclk *= 4;
			c-&gt;clockmult = 1;
		}
		else
			c-&gt;clockmult = 0;
	}
	else
		c-&gt;clockmult = 0;

	/* derive CCF from sclk */
	/* woebetide anyone with SCLK &lt; 16.7 or &gt; 80MHz */
	if (c-&gt;sclk &lt;= 25 * MEGA)
		c-&gt;ccf = 1;
	else if (c-&gt;sclk &lt;= 3750000)
		c-&gt;ccf = 2;
	else if (c-&gt;sclk &lt;= 50 * MEGA)
		c-&gt;ccf = 3;
	else if (c-&gt;sclk &lt;= 75 * MEGA)
		c-&gt;ccf = 4;
	else if ((c-&gt;v-&gt;feature &amp; ClockDouble) &amp;&amp; c-&gt;sclk &lt;= 80 * MEGA)
		c-&gt;ccf = 5;
	else if ((c-&gt;v-&gt;feature &amp; ClockQuad) &amp;&amp; c-&gt;sclk &lt;= 120 * MEGA)
		c-&gt;ccf = 6;
	else if ((c-&gt;v-&gt;feature &amp; ClockQuad) &amp;&amp; c-&gt;sclk &lt;= 160 * MEGA)
		c-&gt;ccf = 7;

	for (scf = 1; scf &lt; maxscf; scf++) {
		/* check for legal core rate */
		/* round up so we run slower for safety */
	   	cr = (c-&gt;sclk * 2 + cf2[scf] - 1) / cf2[scf];
		if (cr &lt;= MAXSYNCCORERATE) {
			scsilimit = MAXSYNCSCSIRATE;
			fast = 0;
		}
		else if (cr &lt;= MAXFASTSYNCCORERATE) {
			scsilimit = MAXFASTSYNCSCSIRATE;
			fast = 1;
		}
		else if ((c-&gt;v-&gt;feature &amp; Ultra) &amp;&amp; cr &lt;= MAXULTRASYNCCORERATE) {
			scsilimit = MAXULTRASYNCSCSIRATE;
			fast = 2;
		}
		else if ((c-&gt;v-&gt;feature &amp; Ultra2) &amp;&amp; cr &lt;= MAXULTRA2SYNCCORERATE) {
			scsilimit = MAXULTRA2SYNCSCSIRATE;
			fast = 3;
		}
		else
			continue;
		for (xferp = 11; xferp &gt;= 4; xferp--) {
			int ok;
			int tp;
			/* calculate scsi rate - round up again */
			/* start from sclk for accuracy */
			int totaldivide = xferp * cf2[scf];
			sr = (c-&gt;sclk * 2 + totaldivide - 1) / totaldivide;
			if (sr &gt; scsilimit)
				break;
			/*
			 * now work out transfer period
			 * round down now so that period is pessimistic
			 */
			tp = (MEGA * 1000) / sr;
			/*
			 * bounds check it
			 */
			if (tp &lt; 25 || tp &gt; 255 * 4)
				continue;
			/*
			 * spot stupid special case for Ultra or Ultra2
			 * while working out factor
			 */
			if (tp == 25)
				tpf = 10;
			else if (tp == 50)
				tpf = 12;
			else if (tp &lt; 52)
				continue;
			else
				tpf = tp / 4;
			/*
			 * now check tpf looks sensible
			 * given core rate
			 */
			switch (fast) {
			case 0:
				/* scf must be ccf for SCSI 1 */
				ok = tpf &gt;= 50 &amp;&amp; scf == c-&gt;ccf;
				break;
			case 1:
				ok = tpf &gt;= 25 &amp;&amp; tpf &lt; 50;
				break;
			case 2:
				/*
				 * must use xferp of 4, or 5 at a pinch
				 * for an Ultra transfer
				 */
				ok = xferp &lt;= 5 &amp;&amp; tpf &gt;= 12 &amp;&amp; tpf &lt; 25;
				break;
			case 3:
				ok = xferp == 4 &amp;&amp; (tpf == 10 || tpf == 11);
				break;
			default:
				ok = 0;
			}
			if (!ok)
				continue;
			c-&gt;synctab[scf - 1][xferp - 4] = tpf;
		}
	}

#ifndef NO_ULTRA2
	if (c-&gt;v-&gt;feature &amp; Ultra2)
		tpf = 10;
	else
#endif
	if (c-&gt;v-&gt;feature &amp; Ultra)
		tpf = 12;
	else
		tpf = 25;
	for (; tpf &lt; 256; tpf++) {
		if (chooserate(c, tpf, &amp;scf, &amp;xferp) == tpf) {
			unsigned tp = tpf == 10 ? 25 : (tpf == 12 ? 50 : tpf * 4);
			unsigned long khz = (MEGA + tp - 1) / (tp);
			KPRINT(PRINTPREFIX "tpf=%d scf=%d.%.1d xferp=%d mhz=%ld.%.3ld\n",
			    tpf, cf2[scf] / 2, (cf2[scf] &amp; 1) ? 5 : 0,
			    xferp + 4, khz / 1000, khz % 1000);
			USED(khz);
			if (c-&gt;tpf == 0)
				c-&gt;tpf = tpf;	/* note lowest value for controller */
		}
	}
}

static void
synctodsa(Dsa *dsa, Controller *c)
{
/*
	KPRINT("synctodsa(dsa=%lux, target=%d, scntl3=%.2lx sxfer=%.2x)\n",
	    dsa, dsa-&gt;target, c-&gt;scntl3[dsa-&gt;target], c-&gt;sxfer[dsa-&gt;target]);
*/
	dsa-&gt;scntl3 = c-&gt;scntl3[dsa-&gt;target];
	dsa-&gt;sxfer = c-&gt;sxfer[dsa-&gt;target];
}

static void
setsync(Dsa *dsa, Controller *c, int target, uchar ultra, uchar scf, uchar xferp, uchar reqack)
{
	c-&gt;scntl3[target] =
	    (c-&gt;scntl3[target] &amp; 0x08) | (((scf &lt;&lt; 4) | c-&gt;ccf | (ultra &lt;&lt; 7)) &amp; ~0x08);
	c-&gt;sxfer[target] = (xferp &lt;&lt; 5) | reqack;
	c-&gt;s[target] = BothDone;
	if (dsa) {
		synctodsa(dsa, c);
		c-&gt;n-&gt;scntl3 = c-&gt;scntl3[target];
		c-&gt;n-&gt;sxfer = c-&gt;sxfer[target];
	}
}

static void
setasync(Dsa *dsa, Controller *c, int target)
{
	setsync(dsa, c, target, 0, c-&gt;ccf, 0, 0);
}

static void
setwide(Dsa *dsa, Controller *c, int target, uchar wide)
{
	c-&gt;scntl3[target] = wide ? (1 &lt;&lt; 3) : 0;
	setasync(dsa, c, target);
	c-&gt;s[target] = WideDone;
}

static int
buildsdtrmsg(uchar *buf, uchar tpf, uchar offset)
{
	*buf++ = X_MSG;
	*buf++ = 3;
	*buf++ = X_MSG_SDTR;
	*buf++ = tpf;
	*buf = offset;
	return 5;
}

static int
buildwdtrmsg(uchar *buf, uchar expo)
{
	*buf++ = X_MSG;
	*buf++ = 2;
	*buf++ = X_MSG_WDTR;
	*buf = expo;
	return 4;
}

static void
start(Controller *c, long entry)
{
	ulong p;

	if (c-&gt;running)
		panic(PRINTPREFIX "start called while running");
	c-&gt;running = 1;
	p = c-&gt;scriptpa + entry;
	lesetl(c-&gt;n-&gt;dsp, p);
	coherence();
	if (c-&gt;ssm)
		c-&gt;n-&gt;dcntl |= 0x4;		/* start DMA in SSI mode */
}

static void
ncrcontinue(Controller *c)
{
	if (c-&gt;running)
		panic(PRINTPREFIX "ncrcontinue called while running");
	/* set the start DMA bit to continue execution */
	c-&gt;running = 1;
	coherence();
	c-&gt;n-&gt;dcntl |= 0x4;
}

static void
softreset(Controller *c)
{
	Ncr *n = c-&gt;n;

	n-&gt;istat = Srst;		/* software reset */
	n-&gt;istat = 0;
	/* general initialisation */
	n-&gt;scid = (1 &lt;&lt; 6) | 7;		/* respond to reselect, ID 7 */
	n-&gt;respid = 1 &lt;&lt; 7;		/* response ID = 7 */

#ifdef INTERNAL_SCLK
	n-&gt;stest1 = 0x80;		/* disable external scsi clock */
#else
	n-&gt;stest1 = 0x00;
#endif

	n-&gt;stime0 = 0xdd;		/* about 0.5 second timeout on each device */
	n-&gt;scntl0 |= 0x8;		/* Enable parity checking */

	/* continued setup */
	n-&gt;sien0 = 0x8f;
	n-&gt;sien1 = 0x04;
	n-&gt;dien = 0x7d;
	n-&gt;stest3 = 0x80;		/* TolerANT enable */
	c-&gt;running = 0;

	if (c-&gt;v-&gt;feature &amp; BigFifo)
		n-&gt;ctest5 = (1 &lt;&lt; 5);
	n-&gt;dmode = c-&gt;v-&gt;burst &lt;&lt; 6;	/* set burst length bits */
	if (c-&gt;v-&gt;burst &amp; 4)
		n-&gt;ctest5 |= (1 &lt;&lt; 2);	/* including overflow into ctest5 bit 2 */
	if (c-&gt;v-&gt;feature &amp; Prefetch)
		n-&gt;dcntl |= (1 &lt;&lt; 5);	/* prefetch enable */
	else if (c-&gt;v-&gt;feature &amp; BurstOpCodeFetch)
		n-&gt;dmode |= (1 &lt;&lt; 1);	/* burst opcode fetch */
	if (c-&gt;v-&gt;feature &amp; Differential) {
		/* chip capable */
		if ((c-&gt;feature &amp; Differential) || bios_set_differential(c)) {
			/* user enabled, or some evidence bios set differential */
			if (n-&gt;sstat2 &amp; (1 &lt;&lt; 2))
				print(PRINTPREFIX "can't go differential; wrong cable\n");
			else {
				n-&gt;stest2 = (1 &lt;&lt; 5);
				print(PRINTPREFIX "differential mode set\n");
			}
		}
	}
	if (c-&gt;clockmult) {
		n-&gt;stest1 |= (1 &lt;&lt; 3);	/* power up doubler */
		delay(2);
		n-&gt;stest3 |= (1 &lt;&lt; 5);	/* stop clock */
		n-&gt;stest1 |= (1 &lt;&lt; 2);	/* enable doubler */
		n-&gt;stest3 &amp;= ~(1 &lt;&lt; 5);	/* start clock */
		/* pray */
	}
}

static void
msgsm(Dsa *dsa, Controller *c, int msg, int *cont, int *wakeme)
{
	uchar histpf, hisreqack;
	int tpf;
	int scf, xferp;
	int len;

	Ncr *n = c-&gt;n;

	switch (c-&gt;s[dsa-&gt;target]) {
	case SyncInit:
		switch (msg) {
		case A_SIR_MSG_SDTR:
			/* reply to my SDTR */
			histpf = n-&gt;scratcha[2];
			hisreqack = n-&gt;scratcha[3];
			KPRINT(PRINTPREFIX "%d: SDTN response %d %d\n",
			    dsa-&gt;target, histpf, hisreqack);

			if (hisreqack == 0)
				setasync(dsa, c, dsa-&gt;target);
			else {
				/* hisreqack should be &lt;= c-&gt;v-&gt;maxsyncoff */
				tpf = chooserate(c, histpf, &amp;scf, &amp;xferp);
				KPRINT(PRINTPREFIX "%d: SDTN: using %d %d\n",
				    dsa-&gt;target, tpf, hisreqack);
				setsync(dsa, c, dsa-&gt;target, tpf &lt; 25, scf, xferp, hisreqack);
			}
			*cont = -2;
			return;
		case A_SIR_EV_PHASE_SWITCH_AFTER_ID:
			/* target ignored ATN for message after IDENTIFY - not SCSI-II */
			KPRINT(PRINTPREFIX "%d: illegal phase switch after ID message - SCSI-1 device?\n", dsa-&gt;target);
			KPRINT(PRINTPREFIX "%d: SDTN: async\n", dsa-&gt;target);
			setasync(dsa, c, dsa-&gt;target);
			*cont = E_to_decisions;
			return;
		case A_SIR_MSG_REJECT:
			/* rejection of my SDTR */
			KPRINT(PRINTPREFIX "%d: SDTN: rejected SDTR\n", dsa-&gt;target);
		//async:
			KPRINT(PRINTPREFIX "%d: SDTN: async\n", dsa-&gt;target);
			setasync(dsa, c, dsa-&gt;target);
			*cont = -2;
			return;
		}
		break;
	case WideInit:
		switch (msg) {
		case A_SIR_MSG_WDTR:
			/* reply to my WDTR */
			KPRINT(PRINTPREFIX "%d: WDTN: response %d\n",
			    dsa-&gt;target, n-&gt;scratcha[2]);
			setwide(dsa, c, dsa-&gt;target, n-&gt;scratcha[2]);
			*cont = -2;
			return;
		case A_SIR_EV_PHASE_SWITCH_AFTER_ID:
			/* target ignored ATN for message after IDENTIFY - not SCSI-II */
			KPRINT(PRINTPREFIX "%d: illegal phase switch after ID message - SCSI-1 device?\n", dsa-&gt;target);
			setwide(dsa, c, dsa-&gt;target, 0);
			*cont = E_to_decisions;
			return;
		case A_SIR_MSG_REJECT:
			/* rejection of my SDTR */
			KPRINT(PRINTPREFIX "%d: WDTN: rejected WDTR\n", dsa-&gt;target);
			setwide(dsa, c, dsa-&gt;target, 0);
			*cont = -2;
			return;
		}
		break;

	case NeitherDone:
	case WideDone:
	case BothDone:
		switch (msg) {
		case A_SIR_MSG_WDTR: {
			uchar hiswide, mywide;
			hiswide = n-&gt;scratcha[2];
			mywide = (c-&gt;v-&gt;feature &amp; Wide) != 0;
			KPRINT(PRINTPREFIX "%d: WDTN: target init %d\n",
			    dsa-&gt;target, hiswide);
			if (hiswide &lt; mywide)
				mywide = hiswide;
			KPRINT(PRINTPREFIX "%d: WDTN: responding %d\n",
			    dsa-&gt;target, mywide);
			setwide(dsa, c, dsa-&gt;target, mywide);
			len = buildwdtrmsg(dsa-&gt;msg_out, mywide);
			setmovedata(&amp;dsa-&gt;msg_out_buf, DMASEG(dsa-&gt;msg_out), len);
			*cont = E_response;
			c-&gt;s[dsa-&gt;target] = WideResponse;
			return;
		}
		case A_SIR_MSG_SDTR:
#ifdef ASYNC_ONLY
			*cont = E_reject;
			return;
#else
			/* target decides to renegotiate */
			histpf = n-&gt;scratcha[2];
			hisreqack = n-&gt;scratcha[3];
			KPRINT(PRINTPREFIX "%d: SDTN: target init %d %d\n",
			    dsa-&gt;target, histpf, hisreqack);
			if (hisreqack == 0) {
				/* he wants asynchronous */
				setasync(dsa, c, dsa-&gt;target);
				tpf = 0;
			}
			else {
				/* he wants synchronous */
				tpf = chooserate(c, histpf, &amp;scf, &amp;xferp);
				if (hisreqack &gt; c-&gt;v-&gt;maxsyncoff)
					hisreqack = c-&gt;v-&gt;maxsyncoff;
				KPRINT(PRINTPREFIX "%d: using %d %d\n",
				    dsa-&gt;target, tpf, hisreqack);
				setsync(dsa, c, dsa-&gt;target, tpf &lt; 25, scf, xferp, hisreqack);
			}
			/* build my SDTR message */
			len = buildsdtrmsg(dsa-&gt;msg_out, tpf, hisreqack);
			setmovedata(&amp;dsa-&gt;msg_out_buf, DMASEG(dsa-&gt;msg_out), len);
			*cont = E_response;
			c-&gt;s[dsa-&gt;target] = SyncResponse;
			return;
#endif
		}
		break;
	case WideResponse:
		switch (msg) {
		case A_SIR_EV_RESPONSE_OK:
			c-&gt;s[dsa-&gt;target] = WideDone;
			KPRINT(PRINTPREFIX "%d: WDTN: response accepted\n", dsa-&gt;target);
			*cont = -2;
			return;
		case A_SIR_MSG_REJECT:
			setwide(dsa, c, dsa-&gt;target, 0);
			KPRINT(PRINTPREFIX "%d: WDTN: response REJECTed\n", dsa-&gt;target);
			*cont = -2;
			return;
		}
		break;
	case SyncResponse:
		switch (msg) {
		case A_SIR_EV_RESPONSE_OK:
			c-&gt;s[dsa-&gt;target] = BothDone;
			KPRINT(PRINTPREFIX "%d: SDTN: response accepted (%s)\n",
			    dsa-&gt;target, phase[n-&gt;sstat1 &amp; 7]);
			*cont = -2;
			return;	/* chf */
		case A_SIR_MSG_REJECT:
			setasync(dsa, c, dsa-&gt;target);
			KPRINT(PRINTPREFIX "%d: SDTN: response REJECTed\n", dsa-&gt;target);
			*cont = -2;
			return;
		}
		break;
	}
	KPRINT(PRINTPREFIX "%d: msgsm: state %d msg %d\n",
	    dsa-&gt;target, c-&gt;s[dsa-&gt;target], msg);
	*wakeme = 1;
	return;
}

static void
calcblockdma(Dsa *d, ulong base, ulong count)
{
	ulong blocks;
	if (DEBUG(3))
		blocks = 0;
	else {
		blocks = count / A_BSIZE;
		if (blocks &gt; 255)
			blocks = 255;
	}
	d-&gt;dmablks = blocks;
	d-&gt;dmaaddr[0] = base;
	d-&gt;dmaaddr[1] = base &gt;&gt; 8;
	d-&gt;dmaaddr[2] = base &gt;&gt; 16;
	d-&gt;dmaaddr[3] = base &gt;&gt; 24;
	setmovedata(&amp;d-&gt;data_buf, base + blocks * A_BSIZE, count - blocks * A_BSIZE);
	d-&gt;flag = legetl(d-&gt;data_buf.dbc) == 0;
}

static ulong
read_mismatch_recover(Controller *c, Ncr *n, Dsa *dsa)
{
	ulong dbc;
	uchar dfifo = n-&gt;dfifo;
	int inchip;

	dbc = (n-&gt;dbc[2]&lt;&lt;16)|(n-&gt;dbc[1]&lt;&lt;8)|n-&gt;dbc[0];
	if (n-&gt;ctest5 &amp; (1 &lt;&lt; 5))
		inchip = ((dfifo | ((n-&gt;ctest5 &amp; 3) &lt;&lt; 8)) - (dbc &amp; 0x3ff)) &amp; 0x3ff;
	else
		inchip = ((dfifo &amp; 0x7f) - (dbc &amp; 0x7f)) &amp; 0x7f;
	if (inchip) {
		IPRINT(PRINTPREFIX "%d/%d: read_mismatch_recover: DMA FIFO = %d\n",
		    dsa-&gt;target, dsa-&gt;lun, inchip);
	}
	if (n-&gt;sxfer &amp; SYNCOFFMASK(c)) {
		/* SCSI FIFO */
		uchar fifo = n-&gt;sstat1 &gt;&gt; 4;
		if (c-&gt;v-&gt;maxsyncoff &gt; 8)
			fifo |= (n-&gt;sstat2 &amp; (1 &lt;&lt; 4));
		if (fifo) {
			inchip += fifo;
			IPRINT(PRINTPREFIX "%d/%d: read_mismatch_recover: SCSI FIFO = %d\n",
			    dsa-&gt;target, dsa-&gt;lun, fifo);
		}
	}
	else {
		if (n-&gt;sstat0 &amp; (1 &lt;&lt; 7)) {
			inchip++;
			IPRINT(PRINTPREFIX "%d/%d: read_mismatch_recover: SIDL full\n",
			    dsa-&gt;target, dsa-&gt;lun);
		}
		if (n-&gt;sstat2 &amp; (1 &lt;&lt; 7)) {
			inchip++;
			IPRINT(PRINTPREFIX "%d/%d: read_mismatch_recover: SIDL msb full\n",
			    dsa-&gt;target, dsa-&gt;lun);
		}
	}
	USED(inchip);
	return dbc;
}

static ulong
write_mismatch_recover(Controller *c, Ncr *n, Dsa *dsa)
{
	ulong dbc;
	uchar dfifo = n-&gt;dfifo;
	int inchip;

	dbc = (n-&gt;dbc[2]&lt;&lt;16)|(n-&gt;dbc[1]&lt;&lt;8)|n-&gt;dbc[0];
	USED(dsa);
	if (n-&gt;ctest5 &amp; (1 &lt;&lt; 5))
		inchip = ((dfifo | ((n-&gt;ctest5 &amp; 3) &lt;&lt; 8)) - (dbc &amp; 0x3ff)) &amp; 0x3ff;
	else
		inchip = ((dfifo &amp; 0x7f) - (dbc &amp; 0x7f)) &amp; 0x7f;
#ifdef WMR_DEBUG
	if (inchip) {
		IPRINT(PRINTPREFIX "%d/%d: write_mismatch_recover: DMA FIFO = %d\n",
		    dsa-&gt;target, dsa-&gt;lun, inchip);
	}
#endif
	if (n-&gt;sstat0 &amp; (1 &lt;&lt; 5)) {
		inchip++;
#ifdef WMR_DEBUG
		IPRINT(PRINTPREFIX "%d/%d: write_mismatch_recover: SODL full\n", dsa-&gt;target, dsa-&gt;lun);
#endif
	}
	if (n-&gt;sstat2 &amp; (1 &lt;&lt; 5)) {
		inchip++;
#ifdef WMR_DEBUG
		IPRINT(PRINTPREFIX "%d/%d: write_mismatch_recover: SODL msb full\n", dsa-&gt;target, dsa-&gt;lun);
#endif
	}
	if (n-&gt;sxfer &amp; SYNCOFFMASK(c)) {
		/* synchronous SODR */
		if (n-&gt;sstat0 &amp; (1 &lt;&lt; 6)) {
			inchip++;
#ifdef WMR_DEBUG
			IPRINT(PRINTPREFIX "%d/%d: write_mismatch_recover: SODR full\n",
			    dsa-&gt;target, dsa-&gt;lun);
#endif
		}
		if (n-&gt;sstat2 &amp; (1 &lt;&lt; 6)) {
			inchip++;
#ifdef WMR_DEBUG
			IPRINT(PRINTPREFIX "%d/%d: write_mismatch_recover: SODR msb full\n",
			    dsa-&gt;target, dsa-&gt;lun);
#endif
		}
	}
	/* clear the dma fifo */
	n-&gt;ctest3 |= (1 &lt;&lt; 2);
	/* wait till done */
	while ((n-&gt;dstat &amp; Dfe) == 0)
		;
	return dbc + inchip;
}

static void
sd53c8xxinterrupt(Ureg *ur, void *a)
{
	uchar istat, dstat;
	ushort sist;
	int wakeme = 0;
	int cont = -1;
	Dsa *dsa;
	ulong dsapa;
	Controller *c = a;
	Ncr *n = c-&gt;n;

	USED(ur);
	if (DEBUG(1)) {
		IPRINT(PRINTPREFIX "int\n");
	}
	ilock(c);
	istat = n-&gt;istat;
	if (istat &amp; Intf) {
		Dsa *d;
		int wokesomething = 0;
		if (DEBUG(1)) {
			IPRINT(PRINTPREFIX "Intfly\n");
		}
		n-&gt;istat = Intf;
		/* search for structures in A_STATE_DONE */
		for (d = KPTR(legetl(c-&gt;dsalist.head)); d != dsaend; d = KPTR(legetl(d-&gt;next))) {
			if (d-&gt;stateb == A_STATE_DONE) {
				d-&gt;p9status = d-&gt;status;
				if (DEBUG(1)) {
					IPRINT(PRINTPREFIX "waking up dsa %lux\n", (ulong)d);
				}
				wakeup(d);
				wokesomething = 1;
			}
		}
		if (!wokesomething) {
			IPRINT(PRINTPREFIX "nothing to wake up\n");
		}
	}

	if ((istat &amp; (Sip | Dip)) == 0) {
		if (DEBUG(1)) {
			IPRINT(PRINTPREFIX "int end %x\n", istat);
		}
		iunlock(c);
		return;
	}

	sist = (n-&gt;sist1&lt;&lt;8)|n-&gt;sist0;	/* BUG? can two-byte read be inconsistent? */
	dstat = n-&gt;dstat;
	dsapa = legetl(n-&gt;dsa);

	/*
	 * Can't compute dsa until we know that dsapa is valid.
	 */
	if(dsapa &lt; -KZERO)
		dsa = (Dsa*)DMASEG_TO_KADDR(dsapa);
	else{
		dsa = nil;
		/*
		 * happens at startup on some cards but we 
		 * don't actually deref dsa because none of the
		 * flags we are about are set.
		 * still, print in case that changes and we're
		 * about to dereference nil.
		 */
		iprint("sd53c8xxinterrupt: dsa=%.8lux istat=%ux sist=%ux dstat=%ux\n", dsapa, istat, sist, dstat);
	}

	c-&gt;running = 0;
	if (istat &amp; Sip) {
		if (DEBUG(1)) {
			IPRINT("sist = %.4x\n", sist);
		}
		if (sist &amp; 0x80) {
			ulong addr;
			ulong sa;
			ulong dbc;
			ulong tbc;
			int dmablks;
			ulong dmaaddr;

			addr = legetl(n-&gt;dsp);
			sa = addr - c-&gt;scriptpa;
			if (DEBUG(1) || DEBUG(2)) {
				IPRINT(PRINTPREFIX "%d/%d: Phase Mismatch sa=%.8lux\n",
				    dsa-&gt;target, dsa-&gt;lun, sa);
			}
			/*
			 * now recover
			 */
			if (sa == E_data_in_mismatch) {
				/*
				 * though this is a failure in the residue, there may have been blocks
				 * as well. if so, dmablks will not have been zeroed, since the state
				 * was not saved by the microcode. 
				 */
				dbc = read_mismatch_recover(c, n, dsa);
				tbc = legetl(dsa-&gt;data_buf.dbc) - dbc;
				dsa-&gt;dmablks = 0;
				n-&gt;scratcha[2] = 0;
				advancedata(&amp;dsa-&gt;data_buf, tbc);
				if (DEBUG(1) || DEBUG(2)) {
					IPRINT(PRINTPREFIX "%d/%d: transferred = %ld residue = %ld\n",
					    dsa-&gt;target, dsa-&gt;lun, tbc, legetl(dsa-&gt;data_buf.dbc));
				}
				cont = E_data_mismatch_recover;
			}
			else if (sa == E_data_in_block_mismatch) {
				dbc = read_mismatch_recover(c, n, dsa);
				tbc = A_BSIZE - dbc;
				/* recover current state from registers */
				dmablks = n-&gt;scratcha[2];
				dmaaddr = legetl(n-&gt;scratchb);
				/* we have got to dmaaddr + tbc */
				/* we have dmablks * A_BSIZE - tbc + residue left to do */
				/* so remaining transfer is */
				IPRINT("in_block_mismatch: dmaaddr = 0x%lux tbc=%lud dmablks=%d\n",
				    dmaaddr, tbc, dmablks);
				calcblockdma(dsa, dmaaddr + tbc,
				    dmablks * A_BSIZE - tbc + legetl(dsa-&gt;data_buf.dbc));
				/* copy changes into scratch registers */
				IPRINT("recalc: dmablks %d dmaaddr 0x%lx pa 0x%lx dbc %ld\n",
				    dsa-&gt;dmablks, legetl(dsa-&gt;dmaaddr),
				    legetl(dsa-&gt;data_buf.pa), legetl(dsa-&gt;data_buf.dbc));
				n-&gt;scratcha[2] = dsa-&gt;dmablks;
				lesetl(n-&gt;scratchb, dsa-&gt;dmancr);
				cont = E_data_block_mismatch_recover;
			}
			else if (sa == E_data_out_mismatch) {
				dbc = write_mismatch_recover(c, n, dsa);
				tbc = legetl(dsa-&gt;data_buf.dbc) - dbc;
				dsa-&gt;dmablks = 0;
				n-&gt;scratcha[2] = 0;
				advancedata(&amp;dsa-&gt;data_buf, tbc);
				if (DEBUG(1) || DEBUG(2)) {
					IPRINT(PRINTPREFIX "%d/%d: transferred = %ld residue = %ld\n",
					    dsa-&gt;target, dsa-&gt;lun, tbc, legetl(dsa-&gt;data_buf.dbc));
				}
				cont = E_data_mismatch_recover;
			}
			else if (sa == E_data_out_block_mismatch) {
				dbc = write_mismatch_recover(c, n, dsa);
				tbc = legetl(dsa-&gt;data_buf.dbc) - dbc;
				/* recover current state from registers */
				dmablks = n-&gt;scratcha[2];
				dmaaddr = legetl(n-&gt;scratchb);
				/* we have got to dmaaddr + tbc */
				/* we have dmablks blocks - tbc + residue left to do */
				/* so remaining transfer is */
				IPRINT("out_block_mismatch: dmaaddr = %lux tbc=%lud dmablks=%d\n",
				    dmaaddr, tbc, dmablks);
				calcblockdma(dsa, dmaaddr + tbc,
				    dmablks * A_BSIZE - tbc + legetl(dsa-&gt;data_buf.dbc));
				/* copy changes into scratch registers */
				n-&gt;scratcha[2] = dsa-&gt;dmablks;
				lesetl(n-&gt;scratchb, dsa-&gt;dmancr);
				cont = E_data_block_mismatch_recover;
			}
			else if (sa == E_id_out_mismatch) {
				/*
				 * target switched phases while attention held during
				 * message out. The possibilities are:
				 * 1. It didn't like the last message. This is indicated
				 *    by the new phase being message_in. Use script to recover
				 *
				 * 2. It's not SCSI-II compliant. The new phase will be other
				 *    than message_in. We should also indicate that the device
				 *    is asynchronous, if it's the SDTR that got ignored
				 * 
				 * For now, if the phase switch is not to message_in, and
				 * and it happens after IDENTIFY and before SDTR, we
				 * notify the negotiation state machine.
				 */
				ulong lim = legetl(dsa-&gt;msg_out_buf.dbc);
				uchar p = n-&gt;sstat1 &amp; 7;
				dbc = write_mismatch_recover(c, n, dsa);
				tbc = lim - dbc;
				IPRINT(PRINTPREFIX "%d/%d: msg_out_mismatch: %lud/%lud sent, phase %s\n",
				    dsa-&gt;target, dsa-&gt;lun, tbc, lim, phase[p]);
				if (p != MessageIn &amp;&amp; tbc == 1) {
					msgsm(dsa, c, A_SIR_EV_PHASE_SWITCH_AFTER_ID, &amp;cont, &amp;wakeme);
				}
				else
					cont = E_id_out_mismatch_recover;
			}
			else if (sa == E_cmd_out_mismatch) {
				/*
				 * probably the command count is longer than the device wants ...
				 */
				ulong lim = legetl(dsa-&gt;cmd_buf.dbc);
				uchar p = n-&gt;sstat1 &amp; 7;
				dbc = write_mismatch_recover(c, n, dsa);
				tbc = lim - dbc;
				IPRINT(PRINTPREFIX "%d/%d: cmd_out_mismatch: %lud/%lud sent, phase %s\n",
				    dsa-&gt;target, dsa-&gt;lun, tbc, lim, phase[p]);
				USED(p, tbc);
				cont = E_to_decisions;
			}
			else {
				IPRINT(PRINTPREFIX "%d/%d: ma sa=%.8lux wanted=%s got=%s\n",
				    dsa-&gt;target, dsa-&gt;lun, sa,
				    phase[n-&gt;dcmd &amp; 7],
				    phase[n-&gt;sstat1 &amp; 7]);
				dumpncrregs(c, 1);
				dsa-&gt;p9status = SDeio;	/* chf */
				wakeme = 1;
			}
		}
		/*else*/ if (sist &amp; 0x400) {
			if (DEBUG(0)) {
				IPRINT(PRINTPREFIX "%d/%d Sto\n", dsa-&gt;target, dsa-&gt;lun);
			}
			dsa-&gt;p9status = SDtimeout;
			dsa-&gt;stateb = A_STATE_DONE;
			coherence();
			softreset(c);
			cont = E_issue_check;
			wakeme = 1;
		}
		if (sist &amp; 0x1) {
			IPRINT(PRINTPREFIX "%d/%d: parity error\n", dsa-&gt;target, dsa-&gt;lun);
			dsa-&gt;parityerror = 1;
		}
		if (sist &amp; 0x4) {
			IPRINT(PRINTPREFIX "%s%d lun %d: unexpected disconnect\n",
				c-&gt;sdev-&gt;name, dsa-&gt;target, dsa-&gt;lun);
			dumpncrregs(c, 1);
			//wakeme = 1;
			dsa-&gt;p9status = SDeio;
		}
	}
	if (istat &amp; Dip) {
		if (DEBUG(1)) {
			IPRINT("dstat = %.2x\n", dstat);
		}
		/*else*/ if (dstat &amp; Ssi) {
			ulong w = legetl(n-&gt;dsp) - c-&gt;scriptpa;
			IPRINT("[%lux]", w);
			USED(w);
			cont = -2;	/* restart */
		}
		if (dstat &amp; Sir) {
			switch (legetl(n-&gt;dsps)) {
			case A_SIR_MSG_IO_COMPLETE:
				dsa-&gt;p9status = dsa-&gt;status;
				wakeme = 1;
				break;
			case A_SIR_MSG_SDTR:
			case A_SIR_MSG_WDTR:
			case A_SIR_MSG_REJECT:
			case A_SIR_EV_RESPONSE_OK:
				msgsm(dsa, c, legetl(n-&gt;dsps), &amp;cont, &amp;wakeme);
				break;
			case A_SIR_MSG_IGNORE_WIDE_RESIDUE:
				/* back up one in the data transfer */
				IPRINT(PRINTPREFIX "%d/%d: ignore wide residue %d, WSR = %d\n",
				    dsa-&gt;target, dsa-&gt;lun, n-&gt;scratcha[1], n-&gt;scntl2 &amp; 1);
				if (dsa-&gt;flag == 2) {
					IPRINT(PRINTPREFIX "%d/%d: transfer over; residue ignored\n",
					    dsa-&gt;target, dsa-&gt;lun);
				}
				else {
					calcblockdma(dsa, legetl(dsa-&gt;dmaaddr) - 1,
					    dsa-&gt;dmablks * A_BSIZE + legetl(dsa-&gt;data_buf.dbc) + 1);
				}
				cont = -2;
				break;
			case A_SIR_ERROR_NOT_MSG_IN_AFTER_RESELECT:
				IPRINT(PRINTPREFIX "%d: not msg_in after reselect (%s)",
				    n-&gt;ssid &amp; SSIDMASK(c), phase[n-&gt;sstat1 &amp; 7]);
				dsa = dsafind(c, n-&gt;ssid &amp; SSIDMASK(c), -1, A_STATE_DISCONNECTED);
				dumpncrregs(c, 1);
				wakeme = 1;
				break;
			case A_SIR_NOTIFY_LOAD_STATE:
				IPRINT(PRINTPREFIX ": load_state dsa=%p\n", dsa);
				if (dsa == (void*)KZERO || dsa == (void*)-1) {
					dsadump(c);
					dumpncrregs(c, 1);
					panic("bad dsa in load_state");
				}
				cont = -2;
				break;
			case A_SIR_NOTIFY_MSG_IN:
				IPRINT(PRINTPREFIX "%d/%d: msg_in %d\n",
				    dsa-&gt;target, dsa-&gt;lun, n-&gt;sfbr);
				cont = -2;
				break;
			case A_SIR_NOTIFY_DISC:
				IPRINT(PRINTPREFIX "%d/%d: disconnect:", dsa-&gt;target, dsa-&gt;lun);
				goto dsadump;
			case A_SIR_NOTIFY_STATUS:
				IPRINT(PRINTPREFIX "%d/%d: status\n", dsa-&gt;target, dsa-&gt;lun);
				cont = -2;
				break;
			case A_SIR_NOTIFY_COMMAND:
				IPRINT(PRINTPREFIX "%d/%d: commands\n", dsa-&gt;target, dsa-&gt;lun);
				cont = -2;
				break;
			case A_SIR_NOTIFY_DATA_IN:
				IPRINT(PRINTPREFIX "%d/%d: data in a %lx b %lx\n",
				    dsa-&gt;target, dsa-&gt;lun, legetl(n-&gt;scratcha), legetl(n-&gt;scratchb));
				cont = -2;
				break;
			case A_SIR_NOTIFY_BLOCK_DATA_IN:
				IPRINT(PRINTPREFIX "%d/%d: block data in: a2 %x b %lx\n",
				    dsa-&gt;target, dsa-&gt;lun, n-&gt;scratcha[2], legetl(n-&gt;scratchb));
				cont = -2;
				break;
			case A_SIR_NOTIFY_DATA_OUT:
				IPRINT(PRINTPREFIX "%d/%d: data out\n", dsa-&gt;target, dsa-&gt;lun);
				cont = -2;
				break;
			case A_SIR_NOTIFY_DUMP:
				IPRINT(PRINTPREFIX "%d/%d: dump\n", dsa-&gt;target, dsa-&gt;lun);
				dumpncrregs(c, 1);
				cont = -2;
				break;
			case A_SIR_NOTIFY_DUMP2:
				IPRINT(PRINTPREFIX "%d/%d: dump2:", dsa-&gt;target, dsa-&gt;lun);
				IPRINT(" sa %lux", legetl(n-&gt;dsp) - c-&gt;scriptpa);
				IPRINT(" dsa %lux", legetl(n-&gt;dsa));
				IPRINT(" sfbr %ux", n-&gt;sfbr);
				IPRINT(" a %lux", legetl(n-&gt;scratcha));
				IPRINT(" b %lux", legetl(n-&gt;scratchb));
				IPRINT(" ssid %ux", n-&gt;ssid);
				IPRINT("\n");
				cont = -2;
				break;
			case A_SIR_NOTIFY_WAIT_RESELECT:
				IPRINT(PRINTPREFIX "wait reselect\n");
				cont = -2;
				break;
			case A_SIR_NOTIFY_RESELECT:
				IPRINT(PRINTPREFIX "reselect: ssid %.2x sfbr %.2x at %ld\n",
				    n-&gt;ssid, n-&gt;sfbr, TK2MS(m-&gt;ticks));
				cont = -2;
				break;
			case A_SIR_NOTIFY_ISSUE:
				IPRINT(PRINTPREFIX "%d/%d: issue dsa=%p end=%p:", dsa-&gt;target, dsa-&gt;lun, dsa, dsaend);
			dsadump:
				IPRINT(" tgt=%d", dsa-&gt;target);
				IPRINT(" time=%ld", TK2MS(m-&gt;ticks));
				IPRINT("\n");
				cont = -2;
				break;
			case A_SIR_NOTIFY_ISSUE_CHECK:
				IPRINT(PRINTPREFIX "issue check\n");
				cont = -2;
				break;
			case A_SIR_NOTIFY_SIGP:
				IPRINT(PRINTPREFIX "responded to SIGP\n");
				cont = -2;
				break;
			case A_SIR_NOTIFY_DUMP_NEXT_CODE: {
				ulong *dsp = c-&gt;script + (legetl(n-&gt;dsp)-c-&gt;scriptpa)/4;
				int x;
				IPRINT(PRINTPREFIX "code at %lux", dsp - c-&gt;script);
				for (x = 0; x &lt; 6; x++) {
					IPRINT(" %.8lux", dsp[x]);
				}
				IPRINT("\n");
				USED(dsp);
				cont = -2;
				break;
			}
			case A_SIR_NOTIFY_WSR:
				IPRINT(PRINTPREFIX "%d/%d: WSR set\n", dsa-&gt;target, dsa-&gt;lun);
				cont = -2;
				break;
			case A_SIR_NOTIFY_LOAD_SYNC:
				IPRINT(PRINTPREFIX "%d/%d: scntl=%.2x sxfer=%.2x\n",
				    dsa-&gt;target, dsa-&gt;lun, n-&gt;scntl3, n-&gt;sxfer);
				cont = -2;
				break;
			case A_SIR_NOTIFY_RESELECTED_ON_SELECT:
				if (DEBUG(2)) {
					IPRINT(PRINTPREFIX "%d/%d: reselected during select\n",
 					    dsa-&gt;target, dsa-&gt;lun);
				}
				cont = -2;
				break;
			case A_error_reselected:		/* dsa isn't valid here */
				iprint(PRINTPREFIX "reselection error\n");
				dumpncrregs(c, 1);
				for (dsa = KPTR(legetl(c-&gt;dsalist.head)); dsa != dsaend; dsa = KPTR(legetl(dsa-&gt;next))) {
					IPRINT(PRINTPREFIX "dsa target %d lun %d state %d\n", dsa-&gt;target, dsa-&gt;lun, dsa-&gt;stateb);
				}
				break;
			default:
				IPRINT(PRINTPREFIX "%d/%d: script error %ld\n",
					dsa-&gt;target, dsa-&gt;lun, legetl(n-&gt;dsps));
				dumpncrregs(c, 1);
				wakeme = 1;
			}
		}
		/*else*/ if (dstat &amp; Iid) {
			int i, target, lun;
			ulong addr, dbc, *v;
			
			addr = legetl(n-&gt;dsp);
			if(dsa){
				target = dsa-&gt;target;
				lun = dsa-&gt;lun;
			}else{
				target = -1;
				lun = -1;
			}
			dbc = (n-&gt;dbc[2]&lt;&lt;16)|(n-&gt;dbc[1]&lt;&lt;8)|n-&gt;dbc[0];

		//	if(dsa == nil)
				idebug++;
			IPRINT(PRINTPREFIX "%d/%d: Iid pa=%.8lux sa=%.8lux dbc=%lux\n",
			    target, lun,
			    addr, addr - c-&gt;scriptpa, dbc);
			addr = (ulong)c-&gt;script + addr - c-&gt;scriptpa;
			addr -= 64;
			addr &amp;= ~63;
			v = (ulong*)addr;
			for(i=0; i&lt;8; i++){
				IPRINT("%.8lux: %.8lux %.8lux %.8lux %.8lux\n", 
					addr, v[0], v[1], v[2], v[3]);
				addr += 4*4;
				v += 4;
			}
			USED(addr, dbc);
			if(dsa == nil){
				dsadump(c);
				dumpncrregs(c, 1);
				panic("bad dsa");
			}
			dsa-&gt;p9status = SDeio;
			wakeme = 1;
		}
		/*else*/ if (dstat &amp; Bf) {
			IPRINT(PRINTPREFIX "%d/%d: Bus Fault\n", dsa-&gt;target, dsa-&gt;lun);
			dumpncrregs(c, 1);
			dsa-&gt;p9status = SDeio;
			wakeme = 1;
		}
	}
	if (cont == -2)
		ncrcontinue(c);
	else if (cont &gt;= 0)
		start(c, cont);
	if (wakeme){
		if(dsa-&gt;p9status == SDnostatus)
			dsa-&gt;p9status = SDeio;
		wakeup(dsa);
	}
	iunlock(c);
	if (DEBUG(1)) {
		IPRINT(PRINTPREFIX "int end 1\n");
	}
}

static int
done(void *arg)
{
	return ((Dsa *)arg)-&gt;p9status != SDnostatus;
}

static void
setmovedata(Movedata *d, ulong pa, ulong bc)
{
	d-&gt;pa[0] = pa;
	d-&gt;pa[1] = pa&gt;&gt;8;
	d-&gt;pa[2] = pa&gt;&gt;16;
	d-&gt;pa[3] = pa&gt;&gt;24;
	d-&gt;dbc[0] = bc;
	d-&gt;dbc[1] = bc&gt;&gt;8;
	d-&gt;dbc[2] = bc&gt;&gt;16;
	d-&gt;dbc[3] = bc&gt;&gt;24;
}

static void
advancedata(Movedata *d, long v)
{
	lesetl(d-&gt;pa, legetl(d-&gt;pa) + v);
	lesetl(d-&gt;dbc, legetl(d-&gt;dbc) - v);
}

static void
dumpwritedata(uchar *data, int datalen)
{
	int i;
	uchar *bp;
	if (!DEBUG(0)){
		USED(data, datalen);
		return;
	}

	if (datalen) {
		KPRINT(PRINTPREFIX "write:");
		for (i = 0, bp = data; i &lt; 50 &amp;&amp; i &lt; datalen; i++, bp++) {
			KPRINT("%.2ux", *bp);
		}
		if (i &lt; datalen) {
			KPRINT("...");
		}
		KPRINT("\n");
	}
}

static void
dumpreaddata(uchar *data, int datalen)
{
	int i;
	uchar *bp;
	if (!DEBUG(0)){
		USED(data, datalen);
		return;
	}

	if (datalen) {
		KPRINT(PRINTPREFIX "read:");
		for (i = 0, bp = data; i &lt; 50 &amp;&amp; i &lt; datalen; i++, bp++) {
			KPRINT("%.2ux", *bp);
		}
		if (i &lt; datalen) {
			KPRINT("...");
		}
		KPRINT("\n");
	}
}

static void
busreset(Controller *c)
{
	int x, ntarget;

	/* bus reset */
	c-&gt;n-&gt;scntl1 |= (1 &lt;&lt; 3);
	delay(500);
	c-&gt;n-&gt;scntl1 &amp;= ~(1 &lt;&lt; 3);
	if(!(c-&gt;v-&gt;feature &amp; Wide))
		ntarget = 8;
	else
		ntarget = MAXTARGET;
	for (x = 0; x &lt; ntarget; x++) {
		setwide(0, c, x, 0);
#ifndef ASYNC_ONLY
		c-&gt;s[x] = NeitherDone;
#endif
	}
	c-&gt;capvalid = 0;
}

static void
reset(Controller *c)
{
	/* should wakeup all pending tasks */
	softreset(c);
	busreset(c);
}

static int
sd53c8xxrio(SDreq* r)
{
	Dsa *d;
	uchar *bp;
	Controller *c;
	uchar target_expo, my_expo;
	int bc, check, i, status, target;

	if((target = r-&gt;unit-&gt;subno) == 0x07)
		return r-&gt;status = SDtimeout;	/* assign */

	c = r-&gt;unit-&gt;dev-&gt;ctlr;

	check = 0;
	d = dsaalloc(c, target, r-&gt;lun);

	qlock(&amp;c-&gt;q[target]);			/* obtain access to target */
docheck:
	/* load the transfer control stuff */
	d-&gt;scsi_id_buf[0] = 0;
	d-&gt;scsi_id_buf[1] = c-&gt;sxfer[target];
	d-&gt;scsi_id_buf[2] = target;
	d-&gt;scsi_id_buf[3] = c-&gt;scntl3[target];
	synctodsa(d, c);

	bc = 0;

	d-&gt;msg_out[bc] = 0x80 | r-&gt;lun;

#ifndef NO_DISCONNECT
	d-&gt;msg_out[bc] |= (1 &lt;&lt; 6);
#endif
	bc++;

	/* work out what to do about negotiation */
	switch (c-&gt;s[target]) {
	default:
		KPRINT(PRINTPREFIX "%d: strange nego state %d\n", target, c-&gt;s[target]);
		c-&gt;s[target] = NeitherDone;
		/* fall through */
	case NeitherDone:
		if ((c-&gt;capvalid &amp; (1 &lt;&lt; target)) == 0)
			break;
		target_expo = (c-&gt;cap[target] &gt;&gt; 5) &amp; 3;
		my_expo = (c-&gt;v-&gt;feature &amp; Wide) != 0;
		if (target_expo &lt; my_expo)
			my_expo = target_expo;
#ifdef ALWAYS_DO_WDTR
		bc += buildwdtrmsg(d-&gt;msg_out + bc, my_expo);
		KPRINT(PRINTPREFIX "%d: WDTN: initiating expo %d\n", target, my_expo);
		c-&gt;s[target] = WideInit;
		break;
#else
		if (my_expo) {
			bc += buildwdtrmsg(d-&gt;msg_out + bc, (c-&gt;v-&gt;feature &amp; Wide) ? 1 : 0);
			KPRINT(PRINTPREFIX "%d: WDTN: initiating expo %d\n", target, my_expo);
			c-&gt;s[target] = WideInit;
			break;
		}
		KPRINT(PRINTPREFIX "%d: WDTN: narrow\n", target);
		/* fall through */
#endif
	case WideDone:
		if (c-&gt;cap[target] &amp; (1 &lt;&lt; 4)) {
			KPRINT(PRINTPREFIX "%d: SDTN: initiating %d %d\n", target, c-&gt;tpf, c-&gt;v-&gt;maxsyncoff);
			bc += buildsdtrmsg(d-&gt;msg_out + bc, c-&gt;tpf, c-&gt;v-&gt;maxsyncoff);
			c-&gt;s[target] = SyncInit;
			break;
		}
		KPRINT(PRINTPREFIX "%d: SDTN: async only\n", target);
		c-&gt;s[target] = BothDone;
		break;

	case BothDone:
		break;
	}

	setmovedata(&amp;d-&gt;msg_out_buf, DMASEG(d-&gt;msg_out), bc);
	setmovedata(&amp;d-&gt;cmd_buf, DMASEG(r-&gt;cmd), r-&gt;clen);
	calcblockdma(d, r-&gt;data ? DMASEG(r-&gt;data) : 0, r-&gt;dlen);

	if (DEBUG(0)) {
		KPRINT(PRINTPREFIX "%d/%d: exec: ", target, r-&gt;lun);
		for (bp = r-&gt;cmd; bp &lt; &amp;r-&gt;cmd[r-&gt;clen]; bp++) {
			KPRINT("%.2ux", *bp);
		}
		KPRINT("\n");
		if (!r-&gt;write) {
			KPRINT(PRINTPREFIX "%d/%d: exec: limit=(%d)%ld\n",
			  target, r-&gt;lun, d-&gt;dmablks, legetl(d-&gt;data_buf.dbc));
		}
		else
			dumpwritedata(r-&gt;data, r-&gt;dlen);
	}

	setmovedata(&amp;d-&gt;status_buf, DMASEG(&amp;d-&gt;status), 1);	

	d-&gt;p9status = SDnostatus;
	d-&gt;parityerror = 0;
	coherence();
	d-&gt;stateb = A_STATE_ISSUE;		/* start operation */
	coherence();

	ilock(c);
	if (c-&gt;ssm)
		c-&gt;n-&gt;dcntl |= 0x10;		/* single step */
	if (c-&gt;running) {
		c-&gt;n-&gt;istat = Sigp;
	}
	else {
		start(c, E_issue_check);
	}
	iunlock(c);

	while(waserror())
		;
	tsleep(d, done, d, 600 * 1000);
	poperror();

	if (!done(d)) {
		KPRINT(PRINTPREFIX "%d/%d: exec: Timed out\n", target, r-&gt;lun);
		dumpncrregs(c, 0);
		dsafree(c, d);
		reset(c);
		qunlock(&amp;c-&gt;q[target]);
		r-&gt;status = SDtimeout;
		return r-&gt;status = SDtimeout;	/* assign */
	}

	if((status = d-&gt;p9status) == SDeio)
		c-&gt;s[target] = NeitherDone;
	if (d-&gt;parityerror) {
		status = SDeio;
	}

	/*
	 * adjust datalen
	 */
	r-&gt;rlen = r-&gt;dlen;
	if (DEBUG(0)) {
		KPRINT(PRINTPREFIX "%d/%d: exec: before rlen adjust: dmablks %d flag %d dbc %lud\n",
		    target, r-&gt;lun, d-&gt;dmablks, d-&gt;flag, legetl(d-&gt;data_buf.dbc));
	}
	r-&gt;rlen = r-&gt;dlen;
	if (d-&gt;flag != 2) {
		r-&gt;rlen -= d-&gt;dmablks * A_BSIZE;
		r-&gt;rlen -= legetl(d-&gt;data_buf.dbc);
	}
	if(!r-&gt;write)
		dumpreaddata(r-&gt;data, r-&gt;rlen);
	if (DEBUG(0)) {
		KPRINT(PRINTPREFIX "%d/%d: exec: p9status=%d status %d rlen %ld\n",
		    target, r-&gt;lun, d-&gt;p9status, status, r-&gt;rlen);
	}
	/*
	 * spot the identify
	 */
	if ((c-&gt;capvalid &amp; (1 &lt;&lt; target)) == 0
	 &amp;&amp; (status == SDok || status == SDcheck)
	 &amp;&amp; r-&gt;cmd[0] == 0x12 &amp;&amp; r-&gt;dlen &gt;= 8) {
		c-&gt;capvalid |= 1 &lt;&lt; target;
		bp = r-&gt;data;
		c-&gt;cap[target] = bp[7];
		KPRINT(PRINTPREFIX "%d: capabilities %.2x\n", target, bp[7]);
	}
	if(!check &amp;&amp; status == SDcheck &amp;&amp; !(r-&gt;flags &amp; SDnosense)){
		check = 1;
		r-&gt;write = 0;
		memset(r-&gt;cmd, 0, sizeof(r-&gt;cmd));
		r-&gt;cmd[0] = 0x03;
		r-&gt;cmd[1] = r-&gt;lun&lt;&lt;5;
		r-&gt;cmd[4] = sizeof(r-&gt;sense)-1;
		r-&gt;clen = 6;
		r-&gt;data = r-&gt;sense;
		r-&gt;dlen = sizeof(r-&gt;sense)-1;
		/*
		 * Clear out the microcode state
		 * so the Dsa can be re-used.
		 */
		lesetl(&amp;d-&gt;stateb, A_STATE_ALLOCATED);
		coherence();
		goto docheck;
	}
	qunlock(&amp;c-&gt;q[target]);
	dsafree(c, d);

	if(status == SDok &amp;&amp; check){
		status = SDcheck;
		r-&gt;flags |= SDvalidsense;
	}
	if(DEBUG(0))
		KPRINT(PRINTPREFIX "%d: r flags %8.8uX status %d rlen %ld\n",
			target, r-&gt;flags, status, r-&gt;rlen);
	if(r-&gt;flags &amp; SDvalidsense){
		if(!DEBUG(0))
			KPRINT(PRINTPREFIX "%d: r flags %8.8uX status %d rlen %ld\n",
				target, r-&gt;flags, status, r-&gt;rlen);
		for(i = 0; i &lt; r-&gt;rlen; i++)
			KPRINT(" %2.2uX", r-&gt;sense[i]);
		KPRINT("\n");
	}
	return r-&gt;status = status;
}

static void
cribbios(Controller *c)
{
	c-&gt;bios.scntl3 = c-&gt;n-&gt;scntl3;
	c-&gt;bios.stest2 = c-&gt;n-&gt;stest2;
	print(PRINTPREFIX "%s: bios scntl3(%.2x) stest2(%.2x)\n",
		c-&gt;sdev-&gt;name, c-&gt;bios.scntl3, c-&gt;bios.stest2);
}

static int
bios_set_differential(Controller *c)
{
	/* Concept lifted from FreeBSD - thanks Gerard */
	/* basically, if clock conversion factors are set, then there is
 	 * evidence the bios had a go at the chip, and if so, it would
	 * have set the differential enable bit in stest2
	 */
	return (c-&gt;bios.scntl3 &amp; 7) != 0 &amp;&amp; (c-&gt;bios.stest2 &amp; 0x20) != 0;
}

#define NCR_VID 	0x1000
#define NCR_810_DID 	0x0001
#define NCR_820_DID	0x0002	/* don't know enough about this one to support it */
#define NCR_825_DID	0x0003
#define NCR_815_DID	0x0004
#define SYM_810AP_DID	0x0005
#define SYM_860_DID	0x0006
#define SYM_896_DID	0x000b
#define SYM_895_DID	0x000c
#define SYM_885_DID	0x000d	/* ditto */
#define SYM_875_DID	0x000f	/* ditto */
#define SYM_1010_DID	0x0020
#define SYM_1011_DID	0x0021
#define SYM_875J_DID	0x008f

static Variant variant[] = {
{ NCR_810_DID,   0x0f, "NCR53C810",	Burst16,   8, 24, 0 },
{ NCR_810_DID,   0x1f, "SYM53C810ALV",	Burst16,   8, 24, Prefetch },
{ NCR_810_DID,   0xff, "SYM53C810A",	Burst16,   8, 24, Prefetch },
{ SYM_810AP_DID, 0xff, "SYM53C810AP",	Burst16,   8, 24, Prefetch },
{ NCR_815_DID,   0xff, "NCR53C815",	Burst16,   8, 24, BurstOpCodeFetch },
{ NCR_825_DID,   0x0f, "NCR53C825",	Burst16,   8, 24, Wide|BurstOpCodeFetch|Differential },
{ NCR_825_DID,   0xff, "SYM53C825A",	Burst128, 16, 24, Prefetch|LocalRAM|BigFifo|Differential|Wide },
{ SYM_860_DID,   0x0f, "SYM53C860",	Burst16,   8, 24, Prefetch|Ultra },
{ SYM_860_DID,   0xff, "SYM53C860LV",	Burst16,   8, 24, Prefetch|Ultra },
{ SYM_875_DID,   0x01, "SYM53C875r1",	Burst128, 16, 24, Prefetch|LocalRAM|BigFifo|Differential|Wide|Ultra },
{ SYM_875_DID,   0xff, "SYM53C875",	Burst128, 16, 24, Prefetch|LocalRAM|BigFifo|Differential|Wide|Ultra|ClockDouble },
{ SYM_875J_DID,   0xff, "SYM53C875j",	Burst128, 16, 24, Prefetch|LocalRAM|BigFifo|Differential|Wide|Ultra|ClockDouble },
{ SYM_885_DID,   0xff, "SYM53C885",	Burst128, 16, 24, Prefetch|LocalRAM|BigFifo|Wide|Ultra|ClockDouble },
{ SYM_895_DID,   0xff, "SYM53C895",	Burst128, 16, 24, Prefetch|LocalRAM|BigFifo|Wide|Ultra|Ultra2 },
{ SYM_896_DID,   0xff, "SYM53C896",	Burst128, 16, 64, Prefetch|LocalRAM|BigFifo|Wide|Ultra|Ultra2 },
{ SYM_1010_DID,  0xff, "SYM53C1010",	Burst128, 16, 64, Prefetch|LocalRAM|BigFifo|Wide|Ultra|Ultra2 },
{ SYM_1011_DID,   0xff, "SYM53C1010",	Burst128, 16, 64, Prefetch|LocalRAM|BigFifo|Wide|Ultra|Ultra2 },
};

static int
xfunc(Controller *c, enum na_external x, unsigned long *v)
{
	switch (x) {
	default:
		print("xfunc: can't find external %d\n", x);
		return 0;
	case X_scsi_id_buf:
		*v = offsetof(Dsa, scsi_id_buf[0]);
		break;
	case X_msg_out_buf:
		*v = offsetof(Dsa, msg_out_buf);
		break;
	case X_cmd_buf:
		*v = offsetof(Dsa, cmd_buf);
		break;
	case X_data_buf:
		*v = offsetof(Dsa, data_buf);
		break;
	case X_status_buf:
		*v = offsetof(Dsa, status_buf);
		break;
	case X_dsa_head:
		*v = DMASEG(&amp;c-&gt;dsalist.head[0]);
		break;
	case X_ssid_mask:
		*v = SSIDMASK(c);
		break;
	}
	return 1;
}

static int
na_fixup(Controller *c, ulong pa_reg,
    struct na_patch *patch, int patches,
    int (*externval)(Controller*, int, ulong*))
{
	int p;
	int v;
	ulong *script, pa_script;
	unsigned long lw, lv;

	script = c-&gt;script;
	pa_script = c-&gt;scriptpa;
	for (p = 0; p &lt; patches; p++) {
		switch (patch[p].type) {
		case 1:
			/* script relative */
			script[patch[p].lwoff] += pa_script;
			break;
		case 2:
			/* register i/o relative */
			script[patch[p].lwoff] += pa_reg;
			break;
		case 3:
			/* data external */
			lw = script[patch[p].lwoff];
			v = (lw &gt;&gt; 8) &amp; 0xff;
			if (!(*externval)(c, v, &amp;lv))
				return 0;
			v = lv &amp; 0xff;
			script[patch[p].lwoff] = (lw &amp; 0xffff00ffL) | (v &lt;&lt; 8);
			break;
		case 4:
			/* 32 bit external */
			lw = script[patch[p].lwoff];
			if (!(*externval)(c, lw, &amp;lv))
				return 0;
			script[patch[p].lwoff] = lv;
			break;
		case 5:
			/* 24 bit external */
			lw = script[patch[p].lwoff];
			if (!(*externval)(c, lw &amp; 0xffffff, &amp;lv))
				return 0;
			script[patch[p].lwoff] = (lw &amp; 0xff000000L) | (lv &amp; 0xffffffL);
			break;
		}
	}
	return 1;
}

static SDev*
sd53c8xxpnp(void)
{
	char *cp;
	Pcidev *p;
	Variant *v;
	int ba, nctlr;
	void *scriptma;
	Controller *ctlr;
	SDev *sdev, *head, *tail;
	ulong regpa, *script, scriptpa;
	void *regva, *scriptva;

	if(cp = getconf("*maxsd53c8xx"))
		nctlr = strtoul(cp, 0, 0);
	else
		nctlr = 32;

	p = nil;
	head = tail = nil;
	while((p = pcimatch(p, NCR_VID, 0)) != nil &amp;&amp; nctlr &gt; 0){
		for(v = variant; v &lt; &amp;variant[nelem(variant)]; v++){
			if(p-&gt;did == v-&gt;did &amp;&amp; p-&gt;rid &lt;= v-&gt;maxrid)
				break;
		}
		if(v &gt;= &amp;variant[nelem(variant)]) {
			print("sd53c8xx: no match\n");
			continue;
		}
		print(PRINTPREFIX "%s rev. 0x%2.2x intr=%d command=%4.4uX\n",
			v-&gt;name, p-&gt;rid, p-&gt;intl, p-&gt;pcr);

		regpa = p-&gt;mem[1].bar;
		ba = 2;
		if(regpa &amp; 0x04){
			if(p-&gt;mem[2].bar)
				continue;
			ba++;
		}
		if(regpa == 0)
			print("regpa 0\n");
		regpa &amp;= ~0xF;
		regva = vmap(regpa, p-&gt;mem[1].size);
		if(regva == 0)
			continue;

		script = nil;
		scriptpa = 0;
		scriptva = nil;
		scriptma = nil;
		if((v-&gt;feature &amp; LocalRAM) &amp;&amp; sizeof(na_script) &lt;= 4096){
			scriptpa = p-&gt;mem[ba].bar;
			if((scriptpa &amp; 0x04) &amp;&amp; p-&gt;mem[ba+1].bar){
				vunmap(regva, p-&gt;mem[1].size);
				continue;
			}
			scriptpa &amp;= ~0x0F;
			scriptva = vmap(scriptpa, p-&gt;mem[ba].size);
			if(scriptva)
				script = scriptva;
		}
		if(scriptpa == 0){
			/*
			 * Either the map failed, or this chip does not have
			 * local RAM. It will need a copy of the microcode.
			 */
			scriptma = malloc(sizeof(na_script));
			if(scriptma == nil){
				vunmap(regva, p-&gt;mem[1].size);
				continue;
			}
			scriptpa = DMASEG(scriptma);
			script = scriptma;
		}

		ctlr = malloc(sizeof(Controller));
		sdev = malloc(sizeof(SDev));
		if(ctlr == nil || sdev == nil){
buggery:
			if(ctlr)
				free(ctlr);
			if(sdev)
				free(sdev);
			if(scriptma)
				free(scriptma);
			else if(scriptva)
				vunmap(scriptva, p-&gt;mem[ba].size);
			if(regva)
				vunmap(regva, p-&gt;mem[1].size);
			continue;
		}

		if(dsaend == nil)
			dsaend = xalloc(sizeof *dsaend);
		if(dsaend == nil)
			panic("sd53c8xxpnp: no memory");
		lesetl(&amp;dsaend-&gt;stateb, A_STATE_END);
	//	lesetl(dsaend-&gt;next, DMASEG(dsaend));
		coherence();
		lesetl(ctlr-&gt;dsalist.head, DMASEG(dsaend));
		coherence();
		ctlr-&gt;dsalist.freechain = 0;

		ctlr-&gt;n = regva;
		ctlr-&gt;v = v;
		ctlr-&gt;script = script;
		memmove(ctlr-&gt;script, na_script, sizeof(na_script));

		/*
		 * Because we don't yet have an abstraction for the
		 * addresses as seen from the controller side (and on
		 * the 386 it doesn't matter), the following two lines
		 * are different between the 386 and alpha copies of
		 * this driver.
		 */
		ctlr-&gt;scriptpa = scriptpa;
		if(!na_fixup(ctlr, regpa, na_patches, NA_PATCHES, xfunc)){
			print("script fixup failed\n");
			goto buggery;
		}
		swabl(ctlr-&gt;script, ctlr-&gt;script, sizeof(na_script));

		ctlr-&gt;pcidev = p;

		sdev-&gt;ifc = &amp;sd53c8xxifc;
		sdev-&gt;ctlr = ctlr;
		sdev-&gt;idno = '0';
		if(!(v-&gt;feature &amp; Wide))
			sdev-&gt;nunit = 8;
		else
			sdev-&gt;nunit = MAXTARGET;
		ctlr-&gt;sdev = sdev;
		
		if(head != nil)
			tail-&gt;next = sdev;
		else
			head = sdev;
		tail = sdev;

		nctlr--;
	}

	return head;
}

static int
sd53c8xxenable(SDev* sdev)
{
	Pcidev *pcidev;
	Controller *ctlr;
	char name[32];

	ctlr = sdev-&gt;ctlr;
	pcidev = ctlr-&gt;pcidev;

	pcisetbme(pcidev);

	ilock(ctlr);
	synctabinit(ctlr);
	cribbios(ctlr);
	reset(ctlr);
	snprint(name, sizeof(name), "%s (%s)", sdev-&gt;name, sdev-&gt;ifc-&gt;name);
	intrenable(pcidev-&gt;intl, sd53c8xxinterrupt, ctlr, pcidev-&gt;tbdf, name);
	iunlock(ctlr);

	return 1;
}

SDifc sd53c8xxifc = {
	"53c8xx",			/* name */

	sd53c8xxpnp,			/* pnp */
	nil,				/* legacy */
	sd53c8xxenable,			/* enable */
	nil,				/* disable */

	scsiverify,			/* verify */
	scsionline,			/* online */
	sd53c8xxrio,			/* rio */
	nil,				/* rctl */
	nil,				/* wctl */

	scsibio,			/* bio */
	nil,				/* probe */
	nil,				/* clear */
	nil,				/* rtopctl */
	nil,				/* wtopctl */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

