<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/usbuhci.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/usbuhci.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB Universal Host Controller Interface (sic) driver.
 *
 * BUGS:
 * - Too many delays and ilocks.
 * - bandwidth admission control must be done per-frame.
 * - interrupt endpoints should go on a tree like [oe]hci.
 * - must warn of power overruns.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/usb.h"

typedef struct Ctlio Ctlio;
typedef struct Ctlr Ctlr;
typedef struct Isoio Isoio;
typedef struct Qh Qh;
typedef struct Qhpool Qhpool;
typedef struct Qio Qio;
typedef struct Td Td;
typedef struct Tdpool Tdpool;

enum
{
	Resetdelay	= 100,		/* delay after a controller reset (ms) */
	Enabledelay	= 100,		/* waiting for a port to enable */
	Abortdelay	= 5,		/* delay after cancelling Tds (ms) */
	Incr		= 64,		/* for Td and Qh pools */

	Tdatomic	= 8,		/* max nb. of Tds per bulk I/O op. */

	/* Queue states (software) */
	Qidle		= 0,
	Qinstall,
	Qrun,
	Qdone,
	Qclose,
	Qfree,

	/*
	 * HW constants
	 */

	Nframes		= 1024,		/* 2ⁿ for xspanalloc; max 1024 */
	Align		= 16,		/* for data structures */

	/* Size of small buffer kept within Tds. (software) */
	/* Keep as a multiple of Align to maintain alignment of Tds in pool */
	Tdndata		= 1*Align,

	/* i/o space
	 * Some ports are short, some are long, some are byte.
	 * We use ins[bsl] and not vmap.
	 */
	Cmd		= 0,
		Crun		= 0x01,
		Chcreset	= 0x02,	/* host controller reset */
		Cgreset		= 0x04,	/* global reset */
		Cegsm		= 0x08,	/* enter global suspend */
		Cfgr		= 0x10,	/* forge global resume */
		Cdbg		= 0x20,	/* single step, debug */
		Cmaxp		= 0x80,	/* max packet */

	Status		= 2,
		Susbintr		= 0x01,	/* interrupt */
		Seintr		= 0x02, /* error interrupt */
		Sresume		= 0x04, /* resume detect */
		Shserr		= 0x08, /* host system error */
		Shcerr		= 0x10, /* host controller error */
		Shalted		= 0x20, /* controller halted */
		Sall		= 0x3F,

	Usbintr 		= 4,
		Itmout		= 0x01, /* timeout or crc */
		Iresume		= 0x02, /* resume interrupt enable */
		Ioc		= 0x04, /* interrupt on complete */
		Ishort		= 0x08, /* short packet interrupt */
		Iall		= 0x0F,
	Frnum		= 6,
	Flbaseadd 	= 8,
	SOFmod		= 0xC,		/* start of frame modifier register */

	Portsc0		= 0x10,
		PSpresent	= 0x0001,	/* device present */
		PSstatuschg	= 0x0002,	/* PSpresent changed */
		PSenable	= 0x0004,	/* device enabled */
		PSchange	= 0x0008,	/* PSenable changed */
		PSresume	= 0x0040,	/* resume detected */
		PSreserved1	= 0x0080,	/* always read as 1; reserved */
		PSslow		= 0x0100,	/* device has low speed */
		PSreset		= 0x0200,	/* port reset */
		PSsuspend	= 0x1000,	/* port suspended */

	/* Transfer descriptor link */
	Tdterm		= 0x1,		/* nil (terminate) */
	Tdlinkqh	= 0x2,			/* link refers to a QH */
	Tdvf		= 0x4,		/* run linked Tds first (depth-first)*/

	/* Transfer status bits */
	Tdbitstuff	= 0x00020000,	/* bit stuffing error */
	Tdcrcto		= 0x00040000,	/* crc or timeout error */
	Tdnak		= 0x00080000,	/* nak packet received */
	Tdbabble	= 0x00100000,	/* babble detected */
	Tddberr		= 0x00200000,	/* data buf. error */
	Tdstalled	= 0x00400000,	/* serious error to ep. */
	Tdactive		= 0x00800000,	/* enabled/in use by hw */
	/* Transfer control bits */
	Tdioc		= 0x01000000,	/* interrupt on complete */
	Tdiso		= 0x02000000,	/* isochronous select */
	Tdlow		= 0x04000000,	/* low speed device */
	Tderr1		= 0x08000000,	/* bit 0 of error counter */
	Tderr2		= 0x10000000,	/* bit 1 of error counter */
	Tdspd		= 0x20000000,	/* short packet detect */

	Tdlen		= 0x000003FF,	/* actual length field */

	Tdfatalerr	= Tdnak|Tdbabble|Tdstalled, /* hw retries others */
	Tderrors	= Tdfatalerr|Tdbitstuff|Tdcrcto|Tddberr,

	/* Transfer descriptor token bits */
	Tddata0		= 0,
	Tddata1		= 0x80000,	/* data toggle (1==DATA1) */
	Tdtokin		= 0x69,
	Tdtokout	= 0xE1,
	Tdtoksetup	= 0x2D,

	Tdmaxpkt	= 0x800,	/* max packet size */

	/* Queue head bits */
	QHterm		= 1&lt;&lt;0,		/* nil (terminate) */
	QHlinkqh		= 1&lt;&lt;1,		/* link refers to a QH */
	QHvf		= 1&lt;&lt;2,		/* vertical first (depth first) */
};

struct Ctlr
{
	Lock;			/* for ilock. qh lists and basic ctlr I/O */
	QLock	portlck;	/* for port resets/enable... */
	Pcidev*	pcidev;
	int	active;
	int	port;		/* I/O address */
	Qh*	qhs;		/* list of Qhs for this controller */
	Qh*	qh[Tmax];	/* Dummy Qhs to insert Qhs after */
	Isoio*	iso;		/* list of active iso I/O */
	ulong*	frames;		/* frame list (used by hw) */
	ulong	load;		/* max load for a single frame */
	ulong	isoload;		/* max iso load for a single frame */
	int	nintr;		/* number of interrupts attended */
	int	ntdintr;		/* number of intrs. with something to do */
	int	nqhintr;		/* number of intrs. for Qhs */
	int	nisointr;	/* number of intrs. for iso transfers */
};

struct Qio
{
	QLock;			/* for the entire I/O process */
	Rendez;			/* wait for completion */
	Qh*	qh;		/* Td list (field const after init) */
	int	usbid;		/* usb address for endpoint/device */
	int	toggle;		/* Tddata0/Tddata1 */
	int	tok;		/* Tdtoksetup, Tdtokin, Tdtokout */
	ulong	iotime;		/* time of last I/O */
	int	debug;		/* debug flag from the endpoint */
	char*	err;		/* error string */
};

struct Ctlio
{
	Qio;			/* a single Qio for each RPC */
	uchar*	data;		/* read from last ctl req. */
	int	ndata;		/* number of bytes read */
};

struct Isoio
{
	QLock;
	Rendez;			/* wait for space/completion/errors */
	int	usbid;		/* address used for device/endpoint */
	int	tok;		/* Tdtokin or Tdtokout */
	int	state;		/* Qrun -&gt; Qdone -&gt; Qrun... -&gt; Qclose */
	int	nframes;	/* Nframes/ep-&gt;pollival */
	uchar*	data;		/* iso data buffers if not embedded */
	int	td0frno;	/* frame number for first Td */
	Td*	tdu;		/* next td for user I/O in tdps */
	Td*	tdi;		/* next td processed by interrupt */
	char*	err;		/* error string */
	int	nerrs;		/* nb of consecutive I/O errors */
	long	nleft;		/* number of bytes left from last write */
	int	debug;		/* debug flag from the endpoint */
	Isoio*	next;		/* in list of active Isoios */
	Td*	tdps[Nframes];	/* pointer to Td used for i-th frame or nil */
};

struct Tdpool
{
	Lock;
	Td*	free;
	int	nalloc;
	int	ninuse;
	int	nfree;
};

struct Qhpool
{
	Lock;
	Qh*	free;
	int	nalloc;
	int	ninuse;
	int	nfree;
};

/*
 * HW data structures
 */

/*
 * Queue header (known by hw).
 * 16-byte aligned. first two words used by hw.
 * They are taken from the pool upon endpoint opening and
 * queued after the dummy queue header for the endpoint type
 * in the controller. Actual I/O happens as Tds are linked into it.
 * The driver does I/O in lock-step.
 * The user builds a list of Tds and links it into the Qh,
 * then the Qh goes from Qidle to Qrun and nobody touches it until
 * it becomes Qdone at interrupt time.
 * At that point the user collects the Tds and it goes Qidle.
 * A premature cancel may set the state to Qclose and abort I/O.
 * The Ctlr lock protects change of state for Qhs in use.
 */
struct Qh
{
	ulong	link;		/* link to next horiz. item (eg. Qh) */
	ulong	elink;		/* link to element (eg. Td; updated by hw) */

	ulong	state;		/* Qidle -&gt; Qinstall -&gt; Qrun -&gt; Qdone | Qclose */
	Qio*	io;		/* for this queue */

	Qh*	next;		/* in active or free list */
	Td*	tds;		/* Td list in this Qh (initially, elink) */
	char*	tag;		/* debug and align, mostly */
	ulong	align;
};

/*
 * Transfer descriptor.
 * 16-byte aligned. first two words used by hw. Next 4 by sw.
 * We keep an embedded buffer for small I/O transfers.
 * They are taken from the pool when buffers are needed for I/O
 * and linked at the Qh/Isoio for the endpoint and direction requiring it.
 * The block keeps actual data. They are protected from races by
 * the queue or the pool keeping it. The owner of the link to the Td
 * is free to use it and can be the only one using it.
 */
struct Td
{
	ulong	link;		/* Link to next Td or Qh */
	ulong	csw;		/* control and status word (updated by hw) */
	ulong	token;		/* endpt, device, pid */
	ulong	buffer;		/* buffer pointer */

	Td*	next;		/* in qh or Isoio or free list */
	ulong	ndata;		/* bytes available/used at data */
	uchar*	data;		/* pointer to actual data */
	void*	buff;		/* allocated data, for large transfers */

	uchar	sbuff[Tdndata];	/* embedded buffer, for small transfers */
};

#define INB(x)		inb(ctlr-&gt;port+(x))
#define	INS(x)		ins(ctlr-&gt;port+(x))
#define INL(x)		inl(ctlr-&gt;port+(x))
#define OUTB(x, v)	outb(ctlr-&gt;port+(x), (v))
#define	OUTS(x, v)	outs(ctlr-&gt;port+(x), (v))
#define OUTL(x, v)	outl(ctlr-&gt;port+(x), (v))
#define TRUNC(x, sz)	((x) &amp; ((sz)-1))
#define PTR(q)		((void*)KADDR((ulong)(q) &amp; ~ (0xF|PCIWINDOW)))
#define QPTR(q)		((Qh*)PTR(q))
#define TPTR(q)		((Td*)PTR(q))
#define PORT(p)		(Portsc0 + 2*(p))
#define diprint		if(debug || iso-&gt;debug)print
#define ddiprint		if(debug&gt;1 || iso-&gt;debug&gt;1)print
#define dqprint		if(debug || (qh-&gt;io &amp;&amp; qh-&gt;io-&gt;debug))print
#define ddqprint		if(debug&gt;1 || (qh-&gt;io &amp;&amp; qh-&gt;io-&gt;debug&gt;1))print

static Ctlr* ctlrs[Nhcis];

static Tdpool tdpool;
static Qhpool qhpool;
static int debug;

static char* qhsname[] = { "idle", "install", "run", "done", "close", "FREE" };

static void
uhcicmd(Ctlr *ctlr, int c)
{
	OUTS(Cmd, c);
}

static void
uhcirun(Ctlr *ctlr, int on)
{
	int i;

	ddprint("uhci %#ux setting run to %d\n", ctlr-&gt;port, on);

	if(on)
		uhcicmd(ctlr, INS(Cmd)|Crun);
	else
		uhcicmd(ctlr, INS(Cmd) &amp; ~Crun);
	for(i = 0; i &lt; 100; i++)
		if(on == 0 &amp;&amp; (INS(Status) &amp; Shalted) != 0)
			break;
		else if(on != 0 &amp;&amp; (INS(Status) &amp; Shalted) == 0)
			break;
		else
			delay(1);
	if(i == 100)
		dprint("uhci %#x run cmd timed out\n", ctlr-&gt;port);
	ddprint("uhci %#ux cmd %#ux sts %#ux\n",
		ctlr-&gt;port, INS(Cmd), INS(Status));
}

static int
tdlen(Td *td)
{
	return (td-&gt;csw+1) &amp; Tdlen;
}

static int
maxtdlen(Td *td)
{
	return ((td-&gt;token&gt;&gt;21)+1) &amp; (Tdmaxpkt-1);
}

static int
tdtok(Td *td)
{
	return td-&gt;token &amp; 0xFF;
}

static char*
seprinttd(char *s, char *se, Td *td)
{
	s = seprint(s, se, "%#p link %#ulx", td, td-&gt;link);
	if((td-&gt;link &amp; Tdvf) != 0)
		s = seprint(s, se, "V");
	if((td-&gt;link &amp; Tdterm) != 0)
		s = seprint(s, se, "T");
	if((td-&gt;link &amp; Tdlinkqh) != 0)
		s = seprint(s, se, "Q");
	s = seprint(s, se, " csw %#ulx ", td-&gt;csw);
	if(td-&gt;csw &amp; Tdactive)
		s = seprint(s, se, "a");
	if(td-&gt;csw &amp; Tdiso)
		s = seprint(s, se, "I");
	if(td-&gt;csw &amp; Tdioc)
		s = seprint(s, se, "i");
	if(td-&gt;csw &amp; Tdlow)
		s = seprint(s, se, "l");
	if((td-&gt;csw &amp; (Tderr1|Tderr2)) == 0)
		s = seprint(s, se, "z");
	if(td-&gt;csw &amp; Tderrors)
		s = seprint(s, se, " err %#ulx", td-&gt;csw &amp; Tderrors);
	if(td-&gt;csw &amp; Tdstalled)
		s = seprint(s, se, "s");
	if(td-&gt;csw &amp; Tddberr)
		s = seprint(s, se, "d");
	if(td-&gt;csw &amp; Tdbabble)
		s = seprint(s, se, "b");
	if(td-&gt;csw &amp; Tdnak)
		s = seprint(s, se, "n");
	if(td-&gt;csw &amp; Tdcrcto)
		s = seprint(s, se, "c");
	if(td-&gt;csw &amp; Tdbitstuff)
		s = seprint(s, se, "B");
	s = seprint(s, se, " stslen %d", tdlen(td));

	s = seprint(s, se, " token %#ulx", td-&gt;token);
	if(td-&gt;token == 0)		/* the BWS loopback Td, ignore rest */
		return s;
	s = seprint(s, se, " maxlen %d", maxtdlen(td));
	if(td-&gt;token &amp; Tddata1)
		s = seprint(s, se, " d1");
	else
		s = seprint(s, se, " d0");
	s = seprint(s, se, " id %#ulx:", (td-&gt;token&gt;&gt;15) &amp; Epmax);
	s = seprint(s, se, "%#ulx", (td-&gt;token&gt;&gt;8) &amp; Devmax);
	switch(tdtok(td)){
	case Tdtokin:
		s = seprint(s, se, " in");
		break;
	case Tdtokout:
		s = seprint(s, se, " out");
		break;
	case Tdtoksetup:
		s = seprint(s, se, " setup");
		break;
	default:
		s = seprint(s, se, " BADPID");
	}
	s = seprint(s, se, "\n\t  buffer %#ulx data %#p", td-&gt;buffer, td-&gt;data);
	s = seprint(s, se, " ndata %uld sbuff %#p buff %#p",
		td-&gt;ndata, td-&gt;sbuff, td-&gt;buff);
	if(td-&gt;ndata &gt; 0)
		s = seprintdata(s, se, td-&gt;data, td-&gt;ndata);
	return s;
}

static void
isodump(Isoio *iso, int all)
{
	char buf[256];
	Td *td;
	int i;

	print("iso %#p %s state %d nframes %d"
		" td0 %#p tdu %#p tdi %#p data %#p\n",
		iso, iso-&gt;tok == Tdtokin ? "in" : "out",
		iso-&gt;state, iso-&gt;nframes, iso-&gt;tdps[iso-&gt;td0frno],
		iso-&gt;tdu, iso-&gt;tdi, iso-&gt;data);
	if(iso-&gt;err != nil)
		print("\terr='%s'\n", iso-&gt;err);
	if(all == 0){
		seprinttd(buf, buf+sizeof(buf), iso-&gt;tdu);
		print("\ttdu %s\n", buf);
		seprinttd(buf, buf+sizeof(buf), iso-&gt;tdi);
		print("\ttdi %s\n", buf);
	}else{
		td = iso-&gt;tdps[iso-&gt;td0frno];
		for(i = 0; i &lt; iso-&gt;nframes; i++){
			seprinttd(buf, buf+sizeof(buf), td);
			if(td == iso-&gt;tdi)
				print("i-&gt;");
			if(td == iso-&gt;tdu)
				print("u-&gt;");
			print("\t%s\n", buf);
			td = td-&gt;next;
		}
	}
}

static int
sameptr(void *p, ulong l)
{
	if(l &amp; QHterm)
		return p == nil;
	return PTR(l) == p;
}

static void
dumptd(Td *td, char *pref)
{
	char buf[256];
	char *s;
	char *se;
	int i;

	i = 0;
	se = buf+sizeof(buf);
	for(; td != nil; td = td-&gt;next){
		s = seprinttd(buf, se, td);
		if(!sameptr(td-&gt;next, td-&gt;link))
			seprint(s, se, " next %#p != link %#ulx %#p",
				td-&gt;next, td-&gt;link, TPTR(td-&gt;link));
		print("%std %s\n", pref, buf);
		if(i++ &gt; 20){
			print("...more tds...\n");
			break;
		}
	}
}

static void
qhdump(Qh *qh, char *pref)
{
	char buf[256];
	char *s;
	char *se;
	ulong td;
	int i;

	s = buf;
	se = buf+sizeof(buf);
	s = seprint(s, se, "%sqh %s %#p state %s link %#ulx", pref,
		qh-&gt;tag, qh, qhsname[qh-&gt;state], qh-&gt;link);
	if(!sameptr(qh-&gt;tds, qh-&gt;elink))
		s = seprint(s, se, " [tds %#p != elink %#ulx %#p]",
			qh-&gt;tds, qh-&gt;elink, TPTR(qh-&gt;elink));
	if(!sameptr(qh-&gt;next, qh-&gt;link))
		s = seprint(s, se, " [next %#p != link %#ulx %#p]",
			qh-&gt;next, qh-&gt;link, QPTR(qh-&gt;link));
	if((qh-&gt;link &amp; Tdterm) != 0)
		s = seprint(s, se, "T");
	if((qh-&gt;link &amp; Tdlinkqh) != 0)
		s = seprint(s, se, "Q");
	s = seprint(s, se, " elink %#ulx", qh-&gt;elink);
	if((qh-&gt;elink &amp; Tdterm) != 0)
		s = seprint(s, se, "T");
	if((qh-&gt;elink &amp; Tdlinkqh) != 0)
		s = seprint(s, se, "Q");
	s = seprint(s, se, " io %#p", qh-&gt;io);
	if(qh-&gt;io != nil &amp;&amp; qh-&gt;io-&gt;err != nil)
		seprint(s, se, " err='%s'", qh-&gt;io-&gt;err);
	print("%s\n", buf);
	dumptd(qh-&gt;tds, "\t");
	if((qh-&gt;elink &amp; QHterm) == 0){
		print("\thw tds:");
		i = 0;
		for(td = qh-&gt;elink; (td &amp; Tdterm) == 0; td = TPTR(td)-&gt;link){
			print(" %#ulx", td);
			if(td == TPTR(td)-&gt;link)	/* BWS Td */
				break;
			if(i++ &gt; 40){
				print("...");
				break;
			}
		}
		print("\n");
	}
}

static void
xdump(Ctlr *ctlr, int doilock)
{
	Isoio *iso;
	Qh *qh;
	int i;

	if(doilock){
		if(ctlr == ctlrs[0]){
			lock(&amp;tdpool);
			print("tds: alloc %d = inuse %d + free %d\n",
				tdpool.nalloc, tdpool.ninuse, tdpool.nfree);
			unlock(&amp;tdpool);
			lock(&amp;qhpool);
			print("qhs: alloc %d = inuse %d + free %d\n",
				qhpool.nalloc, qhpool.ninuse, qhpool.nfree);
			unlock(&amp;qhpool);
		}
		ilock(ctlr);
	}
	print("uhci port %#x frames %#p nintr %d ntdintr %d",
		ctlr-&gt;port, ctlr-&gt;frames, ctlr-&gt;nintr, ctlr-&gt;ntdintr);
	print(" nqhintr %d nisointr %d\n", ctlr-&gt;nqhintr, ctlr-&gt;nisointr);
	print("cmd %#ux sts %#ux fl %#ulx ps1 %#ux ps2 %#ux frames[0] %#ulx\n",
		INS(Cmd), INS(Status),
		INL(Flbaseadd), INS(PORT(0)), INS(PORT(1)),
		ctlr-&gt;frames[0]);
	for(iso = ctlr-&gt;iso; iso != nil; iso = iso-&gt;next)
		isodump(iso, 1);
	i = 0;
	for(qh = ctlr-&gt;qhs; qh != nil; qh = qh-&gt;next){
		qhdump(qh, "");
		if(i++ &gt; 20){
			print("qhloop\n");
			break;
		}
	}
	print("\n");
	if(doilock)
		iunlock(ctlr);
}

static void
dump(Hci *hp)
{
	xdump(hp-&gt;aux, 1);
}

static Td*
tdalloc(void)
{
	int i;
	Td *td;
	Td *pool;

	lock(&amp;tdpool);
	if(tdpool.free == nil){
		ddprint("uhci: tdalloc %d Tds\n", Incr);
		pool = xspanalloc(Incr*sizeof(Td), Align, 0);
		if(pool == nil)
			panic("tdalloc");
		for(i=Incr; --i&gt;=0;){
			pool[i].next = tdpool.free;
			tdpool.free = &amp;pool[i];
		}
		tdpool.nalloc += Incr;
		tdpool.nfree += Incr;
	}
	td = tdpool.free;
	tdpool.free = td-&gt;next;
	tdpool.ninuse++;
	tdpool.nfree--;
	unlock(&amp;tdpool);

	memset(td, 0, sizeof(Td));
	td-&gt;link = Tdterm;
	assert(((ulong)td &amp; 0xF) == 0);
	return td;
}

static void
tdfree(Td *td)
{
	if(td == nil)
		return;
	free(td-&gt;buff);
	td-&gt;buff = nil;
	lock(&amp;tdpool);
	td-&gt;next = tdpool.free;
	tdpool.free = td;
	tdpool.ninuse--;
	tdpool.nfree++;
	unlock(&amp;tdpool);
}

static void
qhlinkqh(Qh* qh, Qh* next)
{
	if(next == nil)
		qh-&gt;link = QHterm;
	else{
		next-&gt;link = qh-&gt;link;
		next-&gt;next = qh-&gt;next;
		qh-&gt;link = PCIWADDR(next)|QHlinkqh;
	}
	qh-&gt;next = next;
}

static void
qhlinktd(Qh *qh, Td *td)
{
	qh-&gt;tds = td;
	if(td == nil)
		qh-&gt;elink = QHvf|QHterm;
	else
		qh-&gt;elink = PCIWADDR(td);
}

static void
tdlinktd(Td *td, Td *next)
{
	td-&gt;next = next;
	if(next == nil)
		td-&gt;link = Tdterm;
	else
		td-&gt;link = PCIWADDR(next)|Tdvf;
}

static Qh*
qhalloc(Ctlr *ctlr, Qh *prev, Qio *io, char *tag)
{
	int i;
	Qh *qh;
	Qh *pool;

	lock(&amp;qhpool);
	if(qhpool.free == nil){
		ddprint("uhci: qhalloc %d Qhs\n", Incr);
		pool = xspanalloc(Incr*sizeof(Qh), Align, 0);
		if(pool == nil)
			panic("qhalloc");
		for(i=Incr; --i&gt;=0;){
			pool[i].next = qhpool.free;
			qhpool.free = &amp;pool[i];
		}
		qhpool.nalloc += Incr;
		qhpool.nfree += Incr;
	}
	qh = qhpool.free;
	qhpool.free = qh-&gt;next;
	qh-&gt;next = nil;
	qh-&gt;link = QHterm;
	qhpool.ninuse++;
	qhpool.nfree--;
	unlock(&amp;qhpool);

	qh-&gt;tds = nil;
	qh-&gt;elink = QHterm;
	qh-&gt;state = Qidle;
	qh-&gt;io = io;
	qh-&gt;tag = nil;
	kstrdup(&amp;qh-&gt;tag, tag);

	if(prev != nil){
		coherence();
		ilock(ctlr);
		qhlinkqh(prev, qh);
		iunlock(ctlr);
	}

	assert(((ulong)qh &amp; 0xF) == 0);
	return qh;
}

static void
qhfree(Ctlr *ctlr, Qh *qh)
{
	Td *td;
	Td *ltd;
	Qh *q;

	if(qh == nil)
		return;

	ilock(ctlr);
	for(q = ctlr-&gt;qhs; q != nil; q = q-&gt;next)
		if(q-&gt;next == qh)
			break;
	if(q == nil)
		panic("qhfree: nil q");
	q-&gt;next = qh-&gt;next;
	q-&gt;link = qh-&gt;link;
	iunlock(ctlr);

	for(td = qh-&gt;tds; td != nil; td = ltd){
		ltd = td-&gt;next;
		tdfree(td);
	}
	lock(&amp;qhpool);
	qh-&gt;state = Qfree;	/* paranoia */
	qh-&gt;next = qhpool.free;
	qh-&gt;tag = nil;
	qh-&gt;io = nil;
	qhpool.free = qh;
	qhpool.ninuse--;
	qhpool.nfree++;
	unlock(&amp;qhpool);
	ddprint("qhfree: qh %#p\n", qh);
}

static char*
errmsg(int err)
{
	if(err == 0)
		return "ok";
	if(err &amp; Tdcrcto)
		return "crc/timeout error";
	if(err &amp; Tdbabble)
		return "babble detected";
	if(err &amp; Tddberr)
		return "db error";
	if(err &amp; Tdbitstuff)
		return "bit stuffing error";
	if(err &amp; Tdstalled)
		return Estalled;
	return Eio;
}

static int
isocanread(void *a)
{
	Isoio *iso;

	iso = a;
	return iso-&gt;state == Qclose ||
		(iso-&gt;state == Qrun &amp;&amp;
		iso-&gt;tok == Tdtokin &amp;&amp; iso-&gt;tdi != iso-&gt;tdu);
}

static int
isocanwrite(void *a)
{
	Isoio *iso;

	iso = a;
	return iso-&gt;state == Qclose ||
		(iso-&gt;state == Qrun &amp;&amp;
		iso-&gt;tok == Tdtokout &amp;&amp; iso-&gt;tdu-&gt;next != iso-&gt;tdi);
}

static void
tdisoinit(Isoio *iso, Td *td, long count)
{
	td-&gt;ndata = count;
	td-&gt;token = ((count-1)&lt;&lt;21)| ((iso-&gt;usbid &amp; 0x7FF)&lt;&lt;8) | iso-&gt;tok;
	td-&gt;csw = Tderr1|Tdiso|Tdactive|Tdioc;
}

/*
 * Process Iso i/o on interrupt. For writes update just error status.
 * For reads update tds to reflect data and also error status.
 * When tdi aproaches tdu, advance tdu; data may be lost.
 * (If nframes is &lt;&lt; Nframes tdu might be far away but this avoids
 * races regarding frno.)
 * If we suffer errors for more than half the frames we stall.
 */
static void
isointerrupt(Ctlr *ctlr, Isoio* iso)
{
	Td *tdi;
	int err;
	int i;
	int nframes;

	tdi = iso-&gt;tdi;
	if((tdi-&gt;csw &amp; Tdactive) != 0)		/* nothing new done */
		return;
	ctlr-&gt;nisointr++;
	ddiprint("isointr: iso %#p: tdi %#p tdu %#p\n", iso, tdi, iso-&gt;tdu);
	if(iso-&gt;state != Qrun &amp;&amp; iso-&gt;state != Qdone)
		panic("isointr: iso state");
	if(debug &gt; 1 || iso-&gt;debug &gt; 1)
		isodump(iso, 0);

	nframes = iso-&gt;nframes / 2;		/* limit how many we look */
	if(nframes &gt; 64)
		nframes = 64;

	for(i = 0; i &lt; nframes &amp;&amp; (tdi-&gt;csw &amp; Tdactive) == 0; i++){
		tdi-&gt;csw &amp;= ~Tdioc;
		err = tdi-&gt;csw &amp; Tderrors;
		if(err == 0)
			iso-&gt;nerrs = 0;
		else if(iso-&gt;nerrs++ &gt; iso-&gt;nframes/2)
			tdi-&gt;csw |= Tdstalled;
		if((tdi-&gt;csw &amp; Tdstalled) != 0){
			if(iso-&gt;err == nil){
				iso-&gt;err = errmsg(err);
				diprint("isointerrupt: tdi %#p error %#ux %s\n",
					tdi, err, iso-&gt;err);
				diprint("ctlr load %uld\n", ctlr-&gt;load);
			}
			tdi-&gt;ndata = 0;
		}else
			tdi-&gt;ndata = tdlen(tdi);

		if(tdi-&gt;next == iso-&gt;tdu || tdi-&gt;next-&gt;next == iso-&gt;tdu){
			memset(iso-&gt;tdu-&gt;data, 0, maxtdlen(iso-&gt;tdu));
			tdisoinit(iso, iso-&gt;tdu, maxtdlen(iso-&gt;tdu));
			iso-&gt;tdu = iso-&gt;tdu-&gt;next;
			iso-&gt;nleft = 0;
		}
		tdi = tdi-&gt;next;
	}
	ddiprint("isointr: %d frames processed\n", nframes);
	if(i == nframes)
		tdi-&gt;csw |= Tdioc;
	iso-&gt;tdi = tdi;
	if(isocanwrite(iso) || isocanread(iso)){
		diprint("wakeup iso %#p tdi %#p tdu %#p\n", iso,
			iso-&gt;tdi, iso-&gt;tdu);
		wakeup(iso);
	}

}

/*
 * Process a Qh upon interrupt. There's one per ongoing user I/O.
 * User process releases resources later, that is not done here.
 * We may find in this order one or more Tds:
 * - none/many non active and completed Tds
 * - none/one (usually(!) not active) and failed Td
 * - none/many active Tds.
 * Upon errors the entire transfer is aborted and error reported.
 * Otherwise, the transfer is complete only when all Tds are done or
 * when a read with less than maxpkt is found.
 * Use the software list and not qh-&gt;elink to avoid races.
 * We could use qh-&gt;elink to see if there's something new or not.
 */
static void
qhinterrupt(Ctlr *ctlr, Qh *qh)
{
	Td *td;
	int err;

	ctlr-&gt;nqhintr++;
	if(qh-&gt;state != Qrun)
		panic("qhinterrupt: qh state");
	if(qh-&gt;tds == nil)
		panic("qhinterrupt: no tds");
	if((qh-&gt;tds-&gt;csw &amp; Tdactive) == 0)
		ddqprint("qhinterrupt port %#ux qh %#p p0 %#x p1 %#x\n",
			ctlr-&gt;port, qh, INS(PORT(0)), INS(PORT(1)));
	for(td = qh-&gt;tds; td != nil; td = td-&gt;next){
		if(td-&gt;csw &amp; Tdactive)
			return;
		td-&gt;csw &amp;= ~Tdioc;
		if((td-&gt;csw &amp; Tdstalled) != 0){
			err = td-&gt;csw &amp; Tderrors;
			/* just stalled is end of xfer but not an error */
			if(err != Tdstalled &amp;&amp; qh-&gt;io-&gt;err == nil){
				qh-&gt;io-&gt;err = errmsg(td-&gt;csw &amp; Tderrors);
				dqprint("qhinterrupt: td %#p error %#ux %s\n",
					td, err, qh-&gt;io-&gt;err);
				dqprint("ctlr load %uld\n", ctlr-&gt;load);
			}
			break;
		}
		if((td-&gt;csw &amp; Tdnak) != 0){	/* retransmit; not serious */
			td-&gt;csw &amp;= ~Tdnak;
			if(td-&gt;next == nil)
				td-&gt;csw |= Tdioc;
		}
		td-&gt;ndata = tdlen(td);
		if(td-&gt;ndata &lt; maxtdlen(td)){	/* EOT */
			td = td-&gt;next;
			break;
		}
	}

	/*
	 * Done. Make void the Tds not used (errors or EOT) and wakeup epio.
	 */
	qh-&gt;elink = QHterm;
	for(; td != nil; td = td-&gt;next)
		td-&gt;ndata = 0;
	qh-&gt;state = Qdone;
	wakeup(qh-&gt;io);
}

static void
interrupt(Ureg*, void *a)
{
	Hci *hp;
	Ctlr *ctlr;
	int frptr;
	int frno;
	Qh *qh;
	Isoio *iso;
	int sts;
	int cmd;

	hp = a;
	ctlr = hp-&gt;aux;
	ilock(ctlr);
	ctlr-&gt;nintr++;
	sts = INS(Status);
	if((sts &amp; Sall) == 0){		/* not for us; sharing irq */
		iunlock(ctlr);
		return;
	}
	OUTS(Status, sts &amp; Sall);
	cmd = INS(Cmd);
	if(cmd &amp; Crun == 0){
		print("uhci %#ux: not running: uhci bug?\n", ctlr-&gt;port);
		/* BUG: should abort everything in this case */
	}
	if(debug &gt; 1){
		frptr = INL(Flbaseadd);
		frno = INL(Frnum);
		frno = TRUNC(frno, Nframes);
		print("cmd %#ux sts %#ux frptr %#ux frno %d\n",
			cmd, sts, frptr, frno);
	}
	ctlr-&gt;ntdintr++;
	/*
	 * Will we know in USB 3.0 who the interrupt was for?.
	 * Do they still teach indexing in CS?
	 * This is Intel's doing.
	 */
	for(iso = ctlr-&gt;iso; iso != nil; iso = iso-&gt;next)
		if(iso-&gt;state == Qrun || iso-&gt;state == Qdone)
			isointerrupt(ctlr, iso);
	for(qh = ctlr-&gt;qhs; qh != nil; qh = qh-&gt;next)
		if(qh-&gt;state == Qrun)
			qhinterrupt(ctlr, qh);
		else if(qh-&gt;state == Qclose)
			qhlinktd(qh, nil);
	iunlock(ctlr);
}

/*
 * iso-&gt;tdu is the next place to put data. When it gets full
 * it is activated and tdu advanced.
 */
static long
putsamples(Isoio *iso, uchar *b, long count)
{
	long tot;
	long n;

	for(tot = 0; isocanwrite(iso) &amp;&amp; tot &lt; count; tot += n){
		n = count-tot;
		if(n &gt; maxtdlen(iso-&gt;tdu) - iso-&gt;nleft)
			n = maxtdlen(iso-&gt;tdu) - iso-&gt;nleft;
		memmove(iso-&gt;tdu-&gt;data+iso-&gt;nleft, b+tot, n);
		iso-&gt;nleft += n;
		if(iso-&gt;nleft == maxtdlen(iso-&gt;tdu)){
			tdisoinit(iso, iso-&gt;tdu, iso-&gt;nleft);
			iso-&gt;nleft = 0;
			iso-&gt;tdu = iso-&gt;tdu-&gt;next;
		}
	}
	return tot;
}

/*
 * Queue data for writing and return error status from
 * last writes done, to maintain buffered data.
 */
static long
episowrite(Ep *ep, Isoio *iso, void *a, long count)
{
	Ctlr *ctlr;
	uchar *b;
	int tot;
	int nw;
	char *err;

	iso-&gt;debug = ep-&gt;debug;
	diprint("uhci: episowrite: %#p ep%d.%d\n", iso, ep-&gt;dev-&gt;nb, ep-&gt;nb);

	ctlr = ep-&gt;hp-&gt;aux;
	qlock(iso);
	if(waserror()){
		qunlock(iso);
		nexterror();
	}
	ilock(ctlr);
	if(iso-&gt;state == Qclose){
		iunlock(ctlr);
		error(iso-&gt;err ? iso-&gt;err : Eio);
	}
	iso-&gt;state = Qrun;
	b = a;
	for(tot = 0; tot &lt; count; tot += nw){
		while(isocanwrite(iso) == 0){
			iunlock(ctlr);
			diprint("uhci: episowrite: %#p sleep\n", iso);
			if(waserror()){
				if(iso-&gt;err == nil)
					iso-&gt;err = "I/O timed out";
				ilock(ctlr);
				break;
			}
			tsleep(iso, isocanwrite, iso, ep-&gt;tmout);
			poperror();
			ilock(ctlr);
		}
		err = iso-&gt;err;
		iso-&gt;err = nil;
		if(iso-&gt;state == Qclose || err != nil){
			iunlock(ctlr);
			error(err ? err : Eio);
		}
		if(iso-&gt;state != Qrun)
			panic("episowrite: iso not running");
		iunlock(ctlr);		/* We could page fault here */
		nw = putsamples(iso, b+tot, count-tot);
		ilock(ctlr);
	}
	if(iso-&gt;state != Qclose)
		iso-&gt;state = Qdone;
	iunlock(ctlr);
	err = iso-&gt;err;		/* in case it failed early */
	iso-&gt;err = nil;
	qunlock(iso);
	poperror();
	if(err != nil)
		error(err);
	diprint("uhci: episowrite: %#p %d bytes\n", iso, tot);
	return tot;
}

/*
 * Available data is kept at tdu and following tds, up to tdi (excluded).
 */
static long
episoread(Ep *ep, Isoio *iso, void *a, int count)
{
	Ctlr *ctlr;
	uchar *b;
	int nr;
	int tot;
	Td *tdu;

	iso-&gt;debug = ep-&gt;debug;
	diprint("uhci: episoread: %#p ep%d.%d\n", iso, ep-&gt;dev-&gt;nb, ep-&gt;nb);

	b = a;
	ctlr = ep-&gt;hp-&gt;aux;
	qlock(iso);
	if(waserror()){
		qunlock(iso);
		nexterror();
	}
	iso-&gt;err = nil;
	iso-&gt;nerrs = 0;
	ilock(ctlr);
	if(iso-&gt;state == Qclose){
		iunlock(ctlr);
		error(iso-&gt;err ? iso-&gt;err : Eio);
	}
	iso-&gt;state = Qrun;
	while(isocanread(iso) == 0){
		iunlock(ctlr);
		diprint("uhci: episoread: %#p sleep\n", iso);
		if(waserror()){
			if(iso-&gt;err == nil)
				iso-&gt;err = "I/O timed out";
			ilock(ctlr);
			break;
		}
		tsleep(iso, isocanread, iso, ep-&gt;tmout);
		poperror();
		ilock(ctlr);
	}
	if(iso-&gt;state == Qclose){
		iunlock(ctlr);
		error(iso-&gt;err ? iso-&gt;err : Eio);
	}
	iso-&gt;state = Qdone;
	assert(iso-&gt;tdu != iso-&gt;tdi);

	for(tot = 0; iso-&gt;tdi != iso-&gt;tdu &amp;&amp; tot &lt; count; tot += nr){
		tdu = iso-&gt;tdu;
		if(tdu-&gt;csw &amp; Tdactive){
			diprint("uhci: episoread: %#p tdu active\n", iso);
			break;
		}
		nr = tdu-&gt;ndata;
		if(tot + nr &gt; count)
			nr = count - tot;
		if(nr == 0)
			print("uhci: ep%d.%d: too many polls\n",
				ep-&gt;dev-&gt;nb, ep-&gt;nb);
		else{
			iunlock(ctlr);		/* We could page fault here */
			memmove(b+tot, tdu-&gt;data, nr);
			ilock(ctlr);
			if(nr &lt; tdu-&gt;ndata)
				memmove(tdu-&gt;data, tdu-&gt;data+nr, tdu-&gt;ndata - nr);
			tdu-&gt;ndata -= nr;
		}
		if(tdu-&gt;ndata == 0){
			tdisoinit(iso, tdu, ep-&gt;maxpkt);
			iso-&gt;tdu = tdu-&gt;next;
		}
	}
	iunlock(ctlr);
	qunlock(iso);
	poperror();
	diprint("uhci: episoread: %#p %d bytes err '%s'\n", iso, tot, iso-&gt;err);
	if(iso-&gt;err != nil)
		error(iso-&gt;err);
	return tot;
}

static int
nexttoggle(int tog)
{
	if(tog == Tddata0)
		return Tddata1;
	else
		return Tddata0;
}

static Td*
epgettd(Ep *ep, Qio *io, int flags, void *a, int count)
{
	Td *td;
	int tok;

	if(ep-&gt;maxpkt &lt; count)
		error("maxpkt too short");
	td = tdalloc();
	if(count &lt;= Tdndata)
		td-&gt;data = td-&gt;sbuff;
	else
		td-&gt;data = td-&gt;buff = smalloc(ep-&gt;maxpkt);
	td-&gt;buffer = PCIWADDR(td-&gt;data);
	td-&gt;ndata = count;
	if(a != nil &amp;&amp; count &gt; 0)
		memmove(td-&gt;data, a, count);
	td-&gt;csw = Tderr2|Tderr1|flags;
	if(ep-&gt;dev-&gt;speed == Lowspeed)
		td-&gt;csw |= Tdlow;
	tok = io-&gt;tok | io-&gt;toggle;
	io-&gt;toggle = nexttoggle(io-&gt;toggle);
	td-&gt;token = ((count-1)&lt;&lt;21) | ((io-&gt;usbid&amp;0x7FF)&lt;&lt;8) | tok;

	return td;
}

/*
 * Try to get them idle
 */
static void
aborttds(Qh *qh)
{
	Td *td;

	qh-&gt;state = Qdone;
	qh-&gt;elink = QHterm;
	for(td = qh-&gt;tds; td != nil; td = td-&gt;next){
		if(td-&gt;csw &amp; Tdactive)
			td-&gt;ndata = 0;
		td-&gt;csw &amp;= ~(Tdactive|Tdioc);
	}
}

static int
epiodone(void *a)
{
	Qh *qh;

	qh = a;
	return qh-&gt;state != Qrun;
}

static void
epiowait(Ctlr *ctlr, Qio *io, int tmout, ulong load)
{
	Qh *qh;
	int timedout;

	qh = io-&gt;qh;
	ddqprint("uhci io %#p sleep on qh %#p state %uld\n", io, qh, qh-&gt;state);
	timedout = 0;
	if(waserror()){
		dqprint("uhci io %#p qh %#p timed out\n", io, qh);
		timedout++;
	}else{
		if(tmout == 0)
			sleep(io, epiodone, qh);
		else
			tsleep(io, epiodone, qh, tmout);
		poperror();
	}
	ilock(ctlr);
	if(qh-&gt;state == Qrun)
		timedout = 1;
	else if(qh-&gt;state != Qdone &amp;&amp; qh-&gt;state != Qclose)
		panic("epio: queue not done and not closed");
	if(timedout){
		aborttds(io-&gt;qh);
		io-&gt;err = "request timed out";
		iunlock(ctlr);
		if(!waserror()){
			tsleep(&amp;up-&gt;sleep, return0, 0, Abortdelay);
			poperror();
		}
		ilock(ctlr);
	}
	if(qh-&gt;state != Qclose)
		qh-&gt;state = Qidle;
	qhlinktd(qh, nil);
	ctlr-&gt;load -= load;
	iunlock(ctlr);
}

/*
 * Non iso I/O.
 * To make it work for control transfers, the caller may
 * lock the Qio for the entire control transfer.
 */
static long
epio(Ep *ep, Qio *io, void *a, long count, int mustlock)
{
	Td *td, *ltd, *td0, *ntd;
	Ctlr *ctlr;
	Qh* qh;
	long n, tot;
	char buf[128];
	uchar *c;
	int saved, ntds, tmout;
	ulong load;
	char *err;

	qh = io-&gt;qh;
	ctlr = ep-&gt;hp-&gt;aux;
	io-&gt;debug = ep-&gt;debug;
	tmout = ep-&gt;tmout;
	ddeprint("epio: %s ep%d.%d io %#p count %ld load %uld\n",
		io-&gt;tok == Tdtokin ? "in" : "out",
		ep-&gt;dev-&gt;nb, ep-&gt;nb, io, count, ctlr-&gt;load);
	if((debug &gt; 1 || ep-&gt;debug &gt; 1) &amp;&amp; io-&gt;tok != Tdtokin){
		seprintdata(buf, buf+sizeof(buf), a, count);
		print("uchi epio: user data: %s\n", buf);
	}
	if(mustlock){
		qlock(io);
		if(waserror()){
			qunlock(io);
			nexterror();
		}
	}
	io-&gt;err = nil;
	ilock(ctlr);
	if(qh-&gt;state == Qclose){	/* Tds released by cancelio */
		iunlock(ctlr);
		error(io-&gt;err ? io-&gt;err : Eio);
	}
	if(qh-&gt;state != Qidle)
		panic("epio: qh not idle");
	qh-&gt;state = Qinstall;
	iunlock(ctlr);

	c = a;
	td0 = ltd = nil;
	load = tot = 0;
	do{
		n = ep-&gt;maxpkt;
		if(count-tot &lt; n)
			n = count-tot;
		if(c != nil &amp;&amp; io-&gt;tok != Tdtokin)
			td = epgettd(ep, io, Tdactive, c+tot, n);
		else
			td = epgettd(ep, io, Tdactive|Tdspd, nil, n);
		if(td0 == nil)
			td0 = td;
		else
			tdlinktd(ltd, td);
		ltd = td;
		tot += n;
		load += ep-&gt;load;
	}while(tot &lt; count);
	if(td0 == nil || ltd == nil)
		panic("epio: no td");

	ltd-&gt;csw |= Tdioc;	/* the last one interrupts */
	ddeprint("uhci: load %uld ctlr load %uld\n", load, ctlr-&gt;load);
	ilock(ctlr);
	if(qh-&gt;state != Qclose){
		io-&gt;iotime = TK2MS(MACHP(0)-&gt;ticks);
		qh-&gt;state = Qrun;
		coherence();
		qhlinktd(qh, td0);
		ctlr-&gt;load += load;
	}
	iunlock(ctlr);

	epiowait(ctlr, io, tmout, load);

	if(debug &gt; 1 || ep-&gt;debug &gt; 1)
		dumptd(td0, "epio: got tds: ");

	tot = 0;
	c = a;
	saved = 0;
	ntds = 0;
	for(td = td0; td != nil; td = ntd){
		ntds++;
		/*
		 * Use td tok, not io tok, because of setup packets.
		 * Also, if the Td was stalled or active (previous Td
		 * was a short packet), we must save the toggle as it is.
		 */
		if(td-&gt;csw &amp; (Tdstalled|Tdactive)){
			if(saved++ == 0)
				io-&gt;toggle = td-&gt;token &amp; Tddata1;
		}else{
			tot += td-&gt;ndata;
			if(c != nil &amp;&amp; tdtok(td) == Tdtokin &amp;&amp; td-&gt;ndata &gt; 0){
				memmove(c, td-&gt;data, td-&gt;ndata);
				c += td-&gt;ndata;
			}
		}
		ntd = td-&gt;next;
		tdfree(td);
	}
	err = io-&gt;err;
	if(mustlock){
		qunlock(io);
		poperror();
	}
	ddeprint("epio: io %#p: %d tds: return %ld err '%s'\n",
		io, ntds, tot, err);
	if(err != nil)
		error(err);
	if(tot &lt; 0)
		error(Eio);
	return tot;
}

/*
 * halt condition was cleared on the endpoint. update our toggles.
 */
static void
clrhalt(Ep *ep)
{
	Qio *io;

	ep-&gt;clrhalt = 0;
	switch(ep-&gt;ttype){
	case Tbulk:
	case Tintr:
		io = ep-&gt;aux;
		if(ep-&gt;mode != OREAD){
			qlock(&amp;io[OWRITE]);
			io[OWRITE].toggle = Tddata0;
			deprint("ep clrhalt for io %#p\n", io+OWRITE);
			qunlock(&amp;io[OWRITE]);
		}
		if(ep-&gt;mode != OWRITE){
			qlock(&amp;io[OREAD]);
			io[OREAD].toggle = Tddata0;
			deprint("ep clrhalt for io %#p\n", io+OREAD);
			qunlock(&amp;io[OREAD]);
		}
		break;
	}
}

static long
epread(Ep *ep, void *a, long count)
{
	Ctlio *cio;
	Qio *io;
	Isoio *iso;
	char buf[160];
	ulong delta;

	ddeprint("uhci: epread\n");
	if(ep-&gt;aux == nil)
		panic("epread: not open");

	switch(ep-&gt;ttype){
	case Tctl:
		cio = ep-&gt;aux;
		qlock(cio);
		if(waserror()){
			qunlock(cio);
			nexterror();
		}
		ddeprint("epread ctl ndata %d\n", cio-&gt;ndata);
		if(cio-&gt;ndata &lt; 0)
			error("request expected");
		else if(cio-&gt;ndata == 0){
			cio-&gt;ndata = -1;
			count = 0;
		}else{
			if(count &gt; cio-&gt;ndata)
				count = cio-&gt;ndata;
			if(count &gt; 0)
				memmove(a, cio-&gt;data, count);
			/* BUG for big transfers */
			free(cio-&gt;data);
			cio-&gt;data = nil;
			cio-&gt;ndata = 0;	/* signal EOF next time */
		}
		qunlock(cio);
		poperror();
		if(debug&gt;1 || ep-&gt;debug){
			seprintdata(buf, buf+sizeof(buf), a, count);
			print("epread: %s\n", buf);
		}
		return count;
	case Tbulk:
		io = ep-&gt;aux;
		if(ep-&gt;clrhalt)
			clrhalt(ep);
		return epio(ep, &amp;io[OREAD], a, count, 1);
	case Tintr:
		io = ep-&gt;aux;
		delta = TK2MS(MACHP(0)-&gt;ticks) - io[OREAD].iotime + 1;
		if(delta &lt; ep-&gt;pollival / 2)
			tsleep(&amp;up-&gt;sleep, return0, 0, ep-&gt;pollival/2 - delta);
		if(ep-&gt;clrhalt)
			clrhalt(ep);
		return epio(ep, &amp;io[OREAD], a, count, 1);
	case Tiso:
		iso = ep-&gt;aux;
		return episoread(ep, iso, a, count);
	default:
		panic("epread: bad ep ttype %d", ep-&gt;ttype);
	}
	return -1;
}

/*
 * Control transfers are one setup write (data0)
 * plus zero or more reads/writes (data1, data0, ...)
 * plus a final write/read with data1 to ack.
 * For both host to device and device to host we perform
 * the entire transfer when the user writes the request,
 * and keep any data read from the device for a later read.
 * We call epio three times instead of placing all Tds at
 * the same time because doing so leads to crc/tmout errors
 * for some devices.
 * Upon errors on the data phase we must still run the status
 * phase or the device may cease responding in the future.
 */
static long
epctlio(Ep *ep, Ctlio *cio, void *a, long count)
{
	uchar *c;
	long len;

	ddeprint("epctlio: cio %#p ep%d.%d count %ld\n",
		cio, ep-&gt;dev-&gt;nb, ep-&gt;nb, count);
	if(count &lt; Rsetuplen)
		error("short usb comand");
	qlock(cio);
	free(cio-&gt;data);
	cio-&gt;data = nil;
	cio-&gt;ndata = 0;
	if(waserror()){
		qunlock(cio);
		free(cio-&gt;data);
		cio-&gt;data = nil;
		cio-&gt;ndata = 0;
		nexterror();
	}

	/* set the address if unset and out of configuration state */
	if(ep-&gt;dev-&gt;state != Dconfig &amp;&amp; ep-&gt;dev-&gt;state != Dreset)
		if(cio-&gt;usbid == 0)
			cio-&gt;usbid = ((ep-&gt;nb&amp;Epmax)&lt;&lt;7)|(ep-&gt;dev-&gt;nb&amp;Devmax);
	c = a;
	cio-&gt;tok = Tdtoksetup;
	cio-&gt;toggle = Tddata0;
	if(epio(ep, cio, a, Rsetuplen, 0) &lt; Rsetuplen)
		error(Eio);
	a = c + Rsetuplen;
	count -= Rsetuplen;

	cio-&gt;toggle = Tddata1;
	if(c[Rtype] &amp; Rd2h){
		cio-&gt;tok = Tdtokin;
		len = GET2(c+Rcount);
		if(len &lt;= 0)
			error("bad length in d2h request");
		if(len &gt; Maxctllen)
			error("d2h data too large to fit in uhci");
		a = cio-&gt;data = smalloc(len+1);
	}else{
		cio-&gt;tok = Tdtokout;
		len = count;
	}
	if(len &gt; 0)
		if(waserror())
			len = -1;
		else{
			len = epio(ep, cio, a, len, 0);
			poperror();
		}
	if(c[Rtype] &amp; Rd2h){
		count = Rsetuplen;
		cio-&gt;ndata = len;
		cio-&gt;tok = Tdtokout;
	}else{
		if(len &lt; 0)
			count = -1;
		else
			count = Rsetuplen + len;
		cio-&gt;tok = Tdtokin;
	}
	cio-&gt;toggle = Tddata1;
	epio(ep, cio, nil, 0, 0);
	qunlock(cio);
	poperror();
	ddeprint("epctlio cio %#p return %ld\n", cio, count);
	return count;
}

static long
epwrite(Ep *ep, void *a, long count)
{
	Ctlio *cio;
	Isoio *iso;
	Qio *io;
	ulong delta;
	char *b;
	int tot;
	int nw;

	ddeprint("uhci: epwrite ep%d.%d\n", ep-&gt;dev-&gt;nb, ep-&gt;nb);
	if(ep-&gt;aux == nil)
		panic("uhci: epwrite: not open");
	switch(ep-&gt;ttype){
	case Tctl:
		cio = ep-&gt;aux;
		return epctlio(ep, cio, a, count);
	case Tbulk:
		io = ep-&gt;aux;
		if(ep-&gt;clrhalt)
			clrhalt(ep);
		/*
		 * Put at most Tdatomic Tds (512 bytes) at a time.
		 * Otherwise some devices produce babble errors.
		 */
		b = a;
		for(tot = 0; tot &lt; count ; tot += nw){
			nw = count - tot;
			if(nw &gt; Tdatomic * ep-&gt;maxpkt)
				nw = Tdatomic * ep-&gt;maxpkt;
			nw = epio(ep, &amp;io[OWRITE], b+tot, nw, 1);
		}
		return tot;
	case Tintr:
		io = ep-&gt;aux;
		delta = TK2MS(MACHP(0)-&gt;ticks) - io[OWRITE].iotime + 1;
		if(delta &lt; ep-&gt;pollival)
			tsleep(&amp;up-&gt;sleep, return0, 0, ep-&gt;pollival - delta);
		if(ep-&gt;clrhalt)
			clrhalt(ep);
		return epio(ep, &amp;io[OWRITE], a, count, 1);
	case Tiso:
		iso = ep-&gt;aux;
		return episowrite(ep, iso, a, count);
	default:
		panic("uhci: epwrite: bad ep ttype %d", ep-&gt;ttype);
	}
	return -1;
}

static void
isoopen(Ep *ep)
{
	Ctlr *ctlr;
	Isoio *iso;
	int frno;
	int i;
	Td* td;
	Td* ltd;
	int size;
	int left;

	if(ep-&gt;mode == ORDWR)
		error("iso i/o is half-duplex");
	ctlr = ep-&gt;hp-&gt;aux;
	iso = ep-&gt;aux;
	iso-&gt;debug = ep-&gt;debug;
	iso-&gt;next = nil;			/* paranoia */
	if(ep-&gt;mode == OREAD)
		iso-&gt;tok = Tdtokin;
	else
		iso-&gt;tok = Tdtokout;
	iso-&gt;usbid = ((ep-&gt;nb &amp; Epmax)&lt;&lt;7)|(ep-&gt;dev-&gt;nb &amp; Devmax);
	iso-&gt;state = Qidle;
	iso-&gt;nframes = Nframes/ep-&gt;pollival;
	if(iso-&gt;nframes &lt; 3)
		error("uhci isoopen bug");	/* we need at least 3 tds */

	ilock(ctlr);
	if(ctlr-&gt;load + ep-&gt;load &gt; 800)
		print("usb: uhci: bandwidth may be exceeded\n");
	ctlr-&gt;load += ep-&gt;load;
	ctlr-&gt;isoload += ep-&gt;load;
	dprint("uhci: load %uld isoload %uld\n", ctlr-&gt;load, ctlr-&gt;isoload);
	iunlock(ctlr);

	/*
	 * From here on this cannot raise errors
	 * unless we catch them and release here all memory allocated.
	 */
	if(ep-&gt;maxpkt &gt; Tdndata)
		iso-&gt;data = smalloc(iso-&gt;nframes*ep-&gt;maxpkt);
	ilock(ctlr);
	frno = INS(Frnum) + 10;			/* start 10ms ahead */
	frno = TRUNC(frno, Nframes);
	iunlock(ctlr);
	iso-&gt;td0frno = frno;
	ltd = nil;
	left = 0;
	for(i = 0; i &lt; iso-&gt;nframes; i++){
		td = iso-&gt;tdps[frno] = tdalloc();
		if(ep-&gt;mode == OREAD)
			size = ep-&gt;maxpkt;
		else{
			size = (ep-&gt;hz+left) * ep-&gt;pollival / 1000;
			size *= ep-&gt;samplesz;
			left = (ep-&gt;hz+left) * ep-&gt;pollival % 1000;
			if(size &gt; ep-&gt;maxpkt){
				print("uhci: ep%d.%d: size &gt; maxpkt\n",
					ep-&gt;dev-&gt;nb, ep-&gt;nb);
				print("size = %d max = %ld\n", size, ep-&gt;maxpkt);
				size = ep-&gt;maxpkt;
			}
		}
		if(size &gt; Tdndata)
			td-&gt;data = iso-&gt;data + i * ep-&gt;maxpkt;
		else
			td-&gt;data = td-&gt;sbuff;
		td-&gt;buffer = PCIWADDR(td-&gt;data);
		tdisoinit(iso, td, size);
		if(ltd != nil)
			ltd-&gt;next = td;
		ltd = td;
		frno = TRUNC(frno+ep-&gt;pollival, Nframes);
	}
	ltd-&gt;next = iso-&gt;tdps[iso-&gt;td0frno];
	iso-&gt;tdi = iso-&gt;tdps[iso-&gt;td0frno];
	iso-&gt;tdu = iso-&gt;tdi;	/* read: right now; write: 1s ahead */
	ilock(ctlr);
	frno = iso-&gt;td0frno;
	for(i = 0; i &lt; iso-&gt;nframes; i++){
		iso-&gt;tdps[frno]-&gt;link = ctlr-&gt;frames[frno];
		frno = TRUNC(frno+ep-&gt;pollival, Nframes);
	}
	coherence();
	frno = iso-&gt;td0frno;
	for(i = 0; i &lt; iso-&gt;nframes; i++){
		ctlr-&gt;frames[frno] = PCIWADDR(iso-&gt;tdps[frno]);
		frno = TRUNC(frno+ep-&gt;pollival, Nframes);
	}
	iso-&gt;next = ctlr-&gt;iso;
	ctlr-&gt;iso = iso;
	iso-&gt;state = Qdone;
	iunlock(ctlr);
	if(debug &gt; 1 || iso-&gt;debug &gt;1)
		isodump(iso, 0);
}

/*
 * Allocate the endpoint and set it up for I/O
 * in the controller. This must follow what's said
 * in Ep regarding configuration, including perhaps
 * the saved toggles (saved on a previous close of
 * the endpoint data file by epclose).
 */
static void
epopen(Ep *ep)
{
	Ctlr *ctlr;
	Qh *cqh;
	Qio *io;
	Ctlio *cio;
	int usbid;

	ctlr = ep-&gt;hp-&gt;aux;
	deprint("uhci: epopen ep%d.%d\n", ep-&gt;dev-&gt;nb, ep-&gt;nb);
	if(ep-&gt;aux != nil)
		panic("uhci: epopen called with open ep");
	if(waserror()){
		free(ep-&gt;aux);
		ep-&gt;aux = nil;
		nexterror();
	}
	if(ep-&gt;maxpkt &gt; Tdmaxpkt){
		print("uhci: maxkpkt too large: using %d\n", Tdmaxpkt);
		ep-&gt;maxpkt = Tdmaxpkt;
	}
	cqh = ctlr-&gt;qh[ep-&gt;ttype];
	switch(ep-&gt;ttype){
	case Tnone:
		error("endpoint not configured");
	case Tiso:
		ep-&gt;aux = smalloc(sizeof(Isoio));
		isoopen(ep);
		break;
	case Tctl:
		cio = ep-&gt;aux = smalloc(sizeof(Ctlio));
		cio-&gt;debug = ep-&gt;debug;
		cio-&gt;ndata = -1;
		cio-&gt;data = nil;
		if(ep-&gt;dev-&gt;isroot != 0 &amp;&amp; ep-&gt;nb == 0)	/* root hub */
			break;
		cio-&gt;qh = qhalloc(ctlr, cqh, cio, "epc");
		break;
	case Tbulk:
	case Tintr:
		io = ep-&gt;aux = smalloc(sizeof(Qio)*2);
		io[OREAD].debug = io[OWRITE].debug = ep-&gt;debug;
		usbid = ((ep-&gt;nb&amp;Epmax)&lt;&lt;7)|(ep-&gt;dev-&gt;nb &amp;Devmax);
		if(ep-&gt;mode != OREAD){
			if(ep-&gt;toggle[OWRITE] != 0)
				io[OWRITE].toggle = Tddata1;
			else
				io[OWRITE].toggle = Tddata0;
			io[OWRITE].tok = Tdtokout;
			io[OWRITE].qh = qhalloc(ctlr, cqh, io+OWRITE, "epw");
			io[OWRITE].usbid = usbid;
		}
		if(ep-&gt;mode != OWRITE){
			if(ep-&gt;toggle[OREAD] != 0)
				io[OREAD].toggle = Tddata1;
			else
				io[OREAD].toggle = Tddata0;
			io[OREAD].tok = Tdtokin;
			io[OREAD].qh = qhalloc(ctlr, cqh, io+OREAD, "epr");
			io[OREAD].usbid = usbid;
		}
		break;
	}
	if(debug&gt;1 || ep-&gt;debug)
		dump(ep-&gt;hp);
	deprint("uhci: epopen done\n");
	poperror();
}

static void
cancelio(Ctlr *ctlr, Qio *io)
{
	Qh *qh;

	ilock(ctlr);
	qh = io-&gt;qh;
	if(io == nil || io-&gt;qh == nil || io-&gt;qh-&gt;state == Qclose){
		iunlock(ctlr);
		return;
	}
	dqprint("uhci: cancelio for qh %#p state %s\n",
		qh, qhsname[qh-&gt;state]);
	aborttds(qh);
	qh-&gt;state = Qclose;
	iunlock(ctlr);
	if(!waserror()){
		tsleep(&amp;up-&gt;sleep, return0, 0, Abortdelay);
		poperror();
	}

	wakeup(io);
	qlock(io);
	/* wait for epio if running */
	qunlock(io);

	qhfree(ctlr, qh);
	io-&gt;qh = nil;
}

static void
cancelisoio(Ctlr *ctlr, Isoio *iso, int pollival, ulong load)
{
	Isoio **il;
	ulong *lp;
	int i;
	int frno;
	Td *td;

	ilock(ctlr);
	if(iso-&gt;state == Qclose){
		iunlock(ctlr);
		return;
	}
	if(iso-&gt;state != Qrun &amp;&amp; iso-&gt;state != Qdone)
		panic("bad iso state");
	iso-&gt;state = Qclose;
	if(ctlr-&gt;isoload &lt; load)
		panic("uhci: low isoload");
	ctlr-&gt;isoload -= load;
	ctlr-&gt;load -= load;
	for(il = &amp;ctlr-&gt;iso; *il != nil; il = &amp;(*il)-&gt;next)
		if(*il == iso)
			break;
	if(*il == nil)
		panic("isocancel: not found");
	*il = iso-&gt;next;
	frno = iso-&gt;td0frno;
	for(i = 0; i &lt; iso-&gt;nframes; i++){
		td = iso-&gt;tdps[frno];
		td-&gt;csw &amp;= ~(Tdioc|Tdactive);
		for(lp=&amp;ctlr-&gt;frames[frno]; !(*lp &amp; Tdterm);
					lp = &amp;TPTR(*lp)-&gt;link)
			if(TPTR(*lp) == td)
				break;
		if(*lp &amp; Tdterm)
			panic("cancelisoio: td not found");
		*lp = td-&gt;link;
		frno = TRUNC(frno+pollival, Nframes);
	}
	iunlock(ctlr);

	/*
	 * wakeup anyone waiting for I/O and
	 * wait to be sure no I/O is in progress in the controller.
	 * and then wait to be sure episo-io is no longer running.
	 */
	wakeup(iso);
	diprint("cancelisoio iso %#p waiting for I/O to cease\n", iso);
	tsleep(&amp;up-&gt;sleep, return0, 0, 5);
	qlock(iso);
	qunlock(iso);
	diprint("cancelisoio iso %#p releasing iso\n", iso);

	frno = iso-&gt;td0frno;
	for(i = 0; i &lt; iso-&gt;nframes; i++){
		tdfree(iso-&gt;tdps[frno]);
		iso-&gt;tdps[frno] = nil;
		frno = TRUNC(frno+pollival, Nframes);
	}
	free(iso-&gt;data);
	iso-&gt;data = nil;
}

static void
epclose(Ep *ep)
{
	Ctlr *ctlr;
	Ctlio *cio;
	Isoio *iso;
	Qio *io;

	ctlr = ep-&gt;hp-&gt;aux;
	deprint("uhci: epclose ep%d.%d\n", ep-&gt;dev-&gt;nb, ep-&gt;nb);

	if(ep-&gt;aux == nil)
		panic("uhci: epclose called with closed ep");
	switch(ep-&gt;ttype){
	case Tctl:
		cio = ep-&gt;aux;
		cancelio(ctlr, cio);
		free(cio-&gt;data);
		cio-&gt;data = nil;
		break;
	case Tbulk:
	case Tintr:
		io = ep-&gt;aux;
		ep-&gt;toggle[OREAD] = ep-&gt;toggle[OWRITE] = 0;
		if(ep-&gt;mode != OWRITE){
			cancelio(ctlr, &amp;io[OREAD]);
			if(io[OREAD].toggle == Tddata1)
				ep-&gt;toggle[OREAD] = 1;
		}
		if(ep-&gt;mode != OREAD){
			cancelio(ctlr, &amp;io[OWRITE]);
			if(io[OWRITE].toggle == Tddata1)
				ep-&gt;toggle[OWRITE] = 1;
		}
		break;
	case Tiso:
		iso = ep-&gt;aux;
		cancelisoio(ctlr, iso, ep-&gt;pollival, ep-&gt;load);
		break;
	default:
		panic("epclose: bad ttype %d", ep-&gt;ttype);
	}

	free(ep-&gt;aux);
	ep-&gt;aux = nil;

}

static char*
seprintep(char *s, char *e, Ep *ep)
{
	Ctlio *cio;
	Qio *io;
	Isoio *iso;
	Ctlr *ctlr;

	ctlr = ep-&gt;hp-&gt;aux;
	ilock(ctlr);
	if(ep-&gt;aux == nil){
		*s = 0;
		iunlock(ctlr);
		return s;
	}
	switch(ep-&gt;ttype){
	case Tctl:
		cio = ep-&gt;aux;
		s = seprint(s,e,"cio %#p qh %#p"
			" id %#x tog %#x tok %#x err %s\n",
			cio, cio-&gt;qh, cio-&gt;usbid, cio-&gt;toggle,
			cio-&gt;tok, cio-&gt;err);
		break;
	case Tbulk:
	case Tintr:
		io = ep-&gt;aux;
		if(ep-&gt;mode != OWRITE)
			s = seprint(s,e,"r: qh %#p id %#x tog %#x tok %#x err %s\n",
				io[OREAD].qh, io[OREAD].usbid, io[OREAD].toggle,
				io[OREAD].tok, io[OREAD].err);
		if(ep-&gt;mode != OREAD)
			s = seprint(s,e,"w: qh %#p id %#x tog %#x tok %#x err %s\n",
				io[OWRITE].qh, io[OWRITE].usbid, io[OWRITE].toggle,
				io[OWRITE].tok, io[OWRITE].err);
		break;
	case Tiso:
		iso = ep-&gt;aux;
		s = seprint(s,e,"iso %#p id %#x tok %#x tdu %#p tdi %#p err %s\n",
			iso, iso-&gt;usbid, iso-&gt;tok, iso-&gt;tdu, iso-&gt;tdi, iso-&gt;err);
		break;
	}
	iunlock(ctlr);
	return s;
}

static int
portenable(Hci *hp, int port, int on)
{
	int s;
	int ioport;
	Ctlr *ctlr;

	ctlr = hp-&gt;aux;
	dprint("uhci: %#x port %d enable=%d\n", ctlr-&gt;port, port, on);
	ioport = PORT(port-1);
	qlock(&amp;ctlr-&gt;portlck);
	if(waserror()){
		qunlock(&amp;ctlr-&gt;portlck);
		nexterror();
	}
	ilock(ctlr);
	s = INS(ioport);
	if(on)
		OUTS(ioport, s | PSenable);
	else
		OUTS(ioport, s &amp; ~PSenable);
	microdelay(64);
	iunlock(ctlr);
	tsleep(&amp;up-&gt;sleep, return0, 0, Enabledelay);
	dprint("uhci %#ux port %d enable=%d: sts %#x\n",
		ctlr-&gt;port, port, on, INS(ioport));
	qunlock(&amp;ctlr-&gt;portlck);
	poperror();
	return 0;
}

static int
portreset(Hci *hp, int port, int on)
{
	int i, p;
	Ctlr *ctlr;

	if(on == 0)
		return 0;
	ctlr = hp-&gt;aux;
	dprint("uhci: %#ux port %d reset\n", ctlr-&gt;port, port);
	p = PORT(port-1);
	ilock(ctlr);
	OUTS(p, PSreset);
	delay(50);
	OUTS(p, INS(p) &amp; ~PSreset);
	OUTS(p, INS(p) | PSenable);
	microdelay(64);
	for(i=0; i&lt;1000 &amp;&amp; (INS(p) &amp; PSenable) == 0; i++)
		;
	OUTS(p, (INS(p) &amp; ~PSreset)|PSenable);
	iunlock(ctlr);
	dprint("uhci %#ux after port %d reset: sts %#x\n",
		ctlr-&gt;port, port, INS(p));
	return 0;
}

static int
portstatus(Hci *hp, int port)
{
	int s;
	int r;
	int ioport;
	Ctlr *ctlr;

	ctlr = hp-&gt;aux;
	ioport = PORT(port-1);
	qlock(&amp;ctlr-&gt;portlck);
	if(waserror()){
		iunlock(ctlr);
		qunlock(&amp;ctlr-&gt;portlck);
		nexterror();
	}
	ilock(ctlr);
	s = INS(ioport);
	if(s &amp; (PSstatuschg | PSchange)){
		OUTS(ioport, s);
		ddprint("uhci %#ux port %d status %#x\n", ctlr-&gt;port, port, s);
	}
	iunlock(ctlr);
	qunlock(&amp;ctlr-&gt;portlck);
	poperror();

	/*
	 * We must return status bits as a
	 * get port status hub request would do.
	 */
	r = 0;
	if(s &amp; PSpresent)
		r |= HPpresent;
	if(s &amp; PSenable)
		r |= HPenable;
	if(s &amp; PSsuspend)
		r |= HPsuspend;
	if(s &amp; PSreset)
		r |= HPreset;
	if(s &amp; PSslow)
		r |= HPslow;
	if(s &amp; PSstatuschg)
		r |= HPstatuschg;
	if(s &amp; PSchange)
		r |= HPchange;
	return r;
}

static void
scanpci(void)
{
	static int already = 0;
	int io;
	int i;
	Ctlr *ctlr;
	Pcidev *p;

	if(already)
		return;
	already = 1;
	p = nil;
	while(p = pcimatch(p, 0, 0)){
		/*
		 * Find UHCI controllers (Programming Interface = 0).
		 */
		if(p-&gt;ccrb != Pcibcserial || p-&gt;ccru != Pciscusb)
			continue;
		switch(p-&gt;ccrp){
		case 0:
			io = p-&gt;mem[4].bar &amp; ~0x0F;
			break;
		default:
			continue;
		}
		if(io == 0){
			print("usbuhci: %#x %#x: failed to map registers\n",
				p-&gt;vid, p-&gt;did);
			continue;
		}
		if(ioalloc(io, p-&gt;mem[4].size, 0, "usbuhci") &lt; 0){
			print("usbuhci: port %#ux in use\n", io);
			continue;
		}
		if(p-&gt;intl == 0xFF || p-&gt;intl == 0){
			print("usbuhci: no irq assigned for port %#ux\n", io);
			continue;
		}

		dprint("uhci: %#x %#x: port %#ux size %#x irq %d\n",
			p-&gt;vid, p-&gt;did, io, p-&gt;mem[4].size, p-&gt;intl);

		ctlr = malloc(sizeof(Ctlr));
		if (ctlr == nil)
			panic("uhci: out of memory");
		ctlr-&gt;pcidev = p;
		ctlr-&gt;port = io;
		for(i = 0; i &lt; Nhcis; i++)
			if(ctlrs[i] == nil){
				ctlrs[i] = ctlr;
				break;
			}
		if(i == Nhcis)
			print("uhci: bug: no more controllers\n");
	}
}

static void
uhcimeminit(Ctlr *ctlr)
{
	Td* td;
	Qh *qh;
	int frsize;
	int i;

	ctlr-&gt;qhs = ctlr-&gt;qh[Tctl] = qhalloc(ctlr, nil, nil, "CTL");
	ctlr-&gt;qh[Tintr] = qhalloc(ctlr, ctlr-&gt;qh[Tctl], nil, "INT");
	ctlr-&gt;qh[Tbulk] = qhalloc(ctlr, ctlr-&gt;qh[Tintr], nil, "BLK");

	/* idle Td from dummy Qh at the end. looped back to itself */
	/* This is a workaround for PIIX4 errata 29773804.pdf */
	qh = qhalloc(ctlr, ctlr-&gt;qh[Tbulk], nil, "BWS");
	td = tdalloc();
	td-&gt;link = PCIWADDR(td);
	qhlinktd(qh, td);

	/* loop (hw only) from the last qh back to control xfers.
	 * this may be done only for some of them. Disable until ehci comes.
	 */
	if(0)
	qh-&gt;link = PCIWADDR(ctlr-&gt;qhs);

	frsize = Nframes*sizeof(ulong);
	ctlr-&gt;frames = xspanalloc(frsize, frsize, 0);
	if(ctlr-&gt;frames == nil)
		panic("uhci reset: no memory");

	ctlr-&gt;iso = nil;
	for(i = 0; i &lt; Nframes; i++)
		ctlr-&gt;frames[i] = PCIWADDR(ctlr-&gt;qhs)|QHlinkqh;
	OUTL(Flbaseadd, PCIWADDR(ctlr-&gt;frames));
	OUTS(Frnum, 0);
	dprint("uhci %#ux flb %#ulx frno %#ux\n", ctlr-&gt;port,
		INL(Flbaseadd), INS(Frnum));
}

static void
init(Hci *hp)
{
	Ctlr *ctlr;
	int sts;
	int i;

	ctlr = hp-&gt;aux;
	dprint("uhci %#ux init\n", ctlr-&gt;port);
	coherence();
	ilock(ctlr);
	OUTS(Usbintr, Itmout|Iresume|Ioc|Ishort);
	uhcirun(ctlr, 1);
	dprint("uhci: init: cmd %#ux sts %#ux sof %#ux",
		INS(Cmd), INS(Status), INS(SOFmod));
	dprint(" flb %#ulx frno %#ux psc0 %#ux psc1 %#ux",
		INL(Flbaseadd), INS(Frnum), INS(PORT(0)), INS(PORT(1)));
	/* guess other ports */
	for(i = 2; i &lt; 6; i++){
		sts = INS(PORT(i));
		if(sts != 0xFFFF &amp;&amp; (sts &amp; PSreserved1) == 1){
			dprint(" psc%d %#ux", i, sts);
			hp-&gt;nports++;
		}else
			break;
	}
	for(i = 0; i &lt; hp-&gt;nports; i++)
		OUTS(PORT(i), 0);
	iunlock(ctlr);
}

static void
uhcireset(Ctlr *ctlr)
{
	int i;
	int sof;

	ilock(ctlr);
	dprint("uhci %#ux reset\n", ctlr-&gt;port);

	/*
	 * Turn off legacy mode. Some controllers won't
	 * interrupt us as expected otherwise.
	 */
	uhcirun(ctlr, 0);
	pcicfgw16(ctlr-&gt;pcidev, 0xc0, 0x2000);

	OUTS(Usbintr, 0);
	sof = INB(SOFmod);
	uhcicmd(ctlr, Cgreset);			/* global reset */
	delay(Resetdelay);
	uhcicmd(ctlr, 0);			/* all halt */
	uhcicmd(ctlr, Chcreset);			/* controller reset */
	for(i = 0; i &lt; 100; i++){
		if((INS(Cmd) &amp; Chcreset) == 0)
			break;
		delay(1);
	}
	if(i == 100)
		print("uhci %#x controller reset timed out\n", ctlr-&gt;port);
	OUTB(SOFmod, sof);
	iunlock(ctlr);
}

static void
setdebug(Hci*, int d)
{
	debug = d;
}

static void
shutdown(Hci *hp)
{
	Ctlr *ctlr;

	ctlr = hp-&gt;aux;

	ilock(ctlr);
	uhcirun(ctlr, 0);
	delay(100);
	iunlock(ctlr);
}

static int
reset(Hci *hp)
{
	static Lock resetlck;
	int i;
	Ctlr *ctlr;
	Pcidev *p;

	if(getconf("*nousbuhci"))
		return -1;

	ilock(&amp;resetlck);
	scanpci();

	/*
	 * Any adapter matches if no hp-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	ctlr = nil;
	for(i = 0; i &lt; Nhcis &amp;&amp; ctlrs[i] != nil; i++){
		ctlr = ctlrs[i];
		if(ctlr-&gt;active == 0)
		if(hp-&gt;port == 0 || hp-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}
	iunlock(&amp;resetlck);
	if(ctlrs[i] == nil || i == Nhcis)
		return -1;

	p = ctlr-&gt;pcidev;
	hp-&gt;aux = ctlr;
	hp-&gt;port = ctlr-&gt;port;
	hp-&gt;irq = p-&gt;intl;
	hp-&gt;tbdf = p-&gt;tbdf;
	hp-&gt;nports = 2;			/* default */

	uhcireset(ctlr);
	uhcimeminit(ctlr);

	/*
	 * Linkage to the generic HCI driver.
	 */
	hp-&gt;init = init;
	hp-&gt;dump = dump;
	hp-&gt;interrupt = interrupt;
	hp-&gt;epopen = epopen;
	hp-&gt;epclose = epclose;
	hp-&gt;epread = epread;
	hp-&gt;epwrite = epwrite;
	hp-&gt;seprintep = seprintep;
	hp-&gt;portenable = portenable;
	hp-&gt;portreset = portreset;
	hp-&gt;portstatus = portstatus;
	hp-&gt;shutdown = shutdown;
	hp-&gt;debug = setdebug;
	hp-&gt;type = "uhci";
	return 0;
}

void
usbuhcilink(void)
{
	addhcitype("uhci", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

