<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vga3dfx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vga3dfx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

typedef struct Cursor3dfx Cursor3dfx;
struct Cursor3dfx {
	int	vidProcCfg;
	int	hwCurPatAddr;
	int	hwCurLoc;
	int	hwCurC0;
	int	hwCurC1;
};

enum {
	dramInit0	= 0x18,
	dramInit1	= 0x1C,

	hwCur		= 0x5C,
};

static void
tdfxenable(VGAscr* scr)
{
	Pcidev *p;
	int i, *mmio;

	if(scr-&gt;mmio)
		return;
	if(p = pcimatch(nil, 0x121A, 0)){
		switch(p-&gt;did){
		case 0x0003:		/* Banshee */
		case 0x0005:		/* Avenger (a.k.a. Voodoo3) */
			break;
		default:
			return;
		}
	}
	else
		return;
	
	scr-&gt;mmio = vmap(p-&gt;mem[0].bar&amp;~0x0F, p-&gt;mem[0].size);
	if(scr-&gt;mmio == nil)
		return;
	scr-&gt;pci = p;
	
	addvgaseg("3dfxmmio", p-&gt;mem[0].bar&amp;~0x0F, p-&gt;mem[0].size);
	vgalinearpci(scr);
	if(scr-&gt;apsize)
		addvgaseg("3dfxscreen", scr-&gt;paddr, scr-&gt;apsize);

	/*
	 * Find a place for the cursor data in display memory.
	 * If SDRAM then there's 16MB memory else it's SGRAM
	 * and can count it based on the power-on straps -
	 * chip size can be 8Mb or 16Mb, and there can be 4 or
	 * 8 of them.
	 * Use the last 1KB of the framebuffer.
	 */
	mmio = (void*)((uchar*)scr-&gt;mmio+dramInit0);
	if(*(mmio+1) &amp; 0x40000000)
		i = 16*1024*1024;
	else{
		if(*mmio &amp; 0x08000000)
			i = 16*1024*1024/8;
		else
			i = 8*1024*1024/8;
		if(*mmio &amp; 0x04000000)
			i *= 8;
		else
			i *= 4;
	}
	scr-&gt;storage = i - 1024;
}

static void
tdfxcurdisable(VGAscr* scr)
{
	Cursor3dfx *cursor3dfx;

	if(scr-&gt;mmio == 0)
		return;
	cursor3dfx = (void*)((uchar*)scr-&gt;mmio+hwCur);
	cursor3dfx-&gt;vidProcCfg &amp;= ~0x08000000;
}

static void
tdfxcurload(VGAscr* scr, Cursor* curs)
{
	int y;
	uchar *p;
	Cursor3dfx *cursor3dfx;

	if(scr-&gt;mmio == 0)
		return;
	cursor3dfx = (void*)((uchar*)scr-&gt;mmio+hwCur);

	/*
	 * Disable the cursor then load the new image in
	 * the top-left of the 64x64 array.
	 * The cursor data is stored in memory as 128-bit
	 * words consisting of plane 0 in the least significant 64-bits
	 * and plane 1 in the most significant.
	 * The X11 cursor truth table is:
	 *	p0 p1	colour
	 *	 0  0	transparent
	 *	 0  1	transparent
	 *	 1  0	hwCurC0
	 *	 1  1	hwCurC1
	 * Unused portions of the image have been initialised to be
	 * transparent.
	 */
	cursor3dfx-&gt;vidProcCfg &amp;= ~0x08000000;
	p = (uchar*)scr-&gt;vaddr + scr-&gt;storage;
	for(y = 0; y &lt; 16; y++){
		*p++ = curs-&gt;clr[2*y]|curs-&gt;set[2*y];
		*p++ = curs-&gt;clr[2*y+1]|curs-&gt;set[2*y+1];
		p += 6;
		*p++ = curs-&gt;set[2*y];
		*p++ = curs-&gt;set[2*y+1];
		p += 6;
	}

	/*
	 * Save the cursor hotpoint and enable the cursor.
	 * The 0,0 cursor point is bottom-right.
	 */
	scr-&gt;offset.x = 63+curs-&gt;offset.x;
	scr-&gt;offset.y = 63+curs-&gt;offset.y;
	cursor3dfx-&gt;vidProcCfg |= 0x08000000;
}

static int
tdfxcurmove(VGAscr* scr, Point p)
{
	Cursor3dfx *cursor3dfx;

	if(scr-&gt;mmio == 0)
		return 1;
	cursor3dfx = (void*)((uchar*)scr-&gt;mmio+hwCur);

	cursor3dfx-&gt;hwCurLoc = ((p.y+scr-&gt;offset.y)&lt;&lt;16)|(p.x+scr-&gt;offset.x);

	return 0;
}

static void
tdfxcurenable(VGAscr* scr)
{
	Cursor3dfx *cursor3dfx;

	tdfxenable(scr);
	if(scr-&gt;mmio == 0)
		return;
	cursor3dfx = (void*)((uchar*)scr-&gt;mmio+hwCur);

	/*
	 * Cursor colours.
	 */
	cursor3dfx-&gt;hwCurC0 = 0xFFFFFFFF;
	cursor3dfx-&gt;hwCurC1 = 0x00000000;

	/*
	 * Initialise the 64x64 cursor to be transparent (X11 mode).
	 */
	cursor3dfx-&gt;hwCurPatAddr = scr-&gt;storage;
	memset((uchar*)scr-&gt;vaddr + scr-&gt;storage, 0, 64*16);

	/*
	 * Load, locate and enable the 64x64 cursor in X11 mode.
	 */
	tdfxcurload(scr, &amp;arrow);
	tdfxcurmove(scr, ZP);
	cursor3dfx-&gt;vidProcCfg |= 0x08000002;
}

VGAdev vga3dfxdev = {
	"3dfx",

	tdfxenable,
	nil,
	nil,
	nil,
};

VGAcur vga3dfxcur = {
	"3dfxhwgc",

	tdfxcurenable,
	tdfxcurdisable,
	tdfxcurload,
	tdfxcurmove,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

