<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vgaclgd542x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vgaclgd542x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

static int
clgd542xpageset(VGAscr*, int page)
{
	uchar gr09;
	int opage;
	
	if(vgaxi(Seqx, 0x07) &amp; 0xF0)
		page = 0;
	gr09 = vgaxi(Grx, 0x09);
	if(vgaxi(Grx, 0x0B) &amp; 0x20){
		vgaxo(Grx, 0x09, page&lt;&lt;2);
		opage = gr09&gt;&gt;2;
	}
	else{
		vgaxo(Grx, 0x09, page&lt;&lt;4);
		opage = gr09&gt;&gt;4;
	}

	return opage;
}

static void
clgd542xpage(VGAscr* scr, int page)
{
	lock(&amp;scr-&gt;devlock);
	clgd542xpageset(scr, page);
	unlock(&amp;scr-&gt;devlock);
}

static void
clgd542xlinear(VGAscr* scr, int, int)
{
	vgalinearpciid(scr, 0x1013, 0);
}

static void
clgd542xdisable(VGAscr*)
{
	uchar sr12;

	sr12 = vgaxi(Seqx, 0x12);
	vgaxo(Seqx, 0x12, sr12 &amp; ~0x01);
}

static void
clgd542xenable(VGAscr* scr)
{
	uchar sr12;
	int mem, x;
 
	/*
	 * Disable the cursor.
	 */
	sr12 = vgaxi(Seqx, 0x12);
	vgaxo(Seqx, 0x12, sr12 &amp; ~0x01);

	/*
	 * Cursor colours.
	 * Can't call setcolor here as cursor is already locked.
	 */
	vgaxo(Seqx, 0x12, sr12|0x02);
	vgao(PaddrW, 0x00);
	vgao(Pdata, Pwhite);
	vgao(Pdata, Pwhite);
	vgao(Pdata, Pwhite);
	vgao(PaddrW, 0x0F);
	vgao(Pdata, Pblack);
	vgao(Pdata, Pblack);
	vgao(Pdata, Pblack);
	vgaxo(Seqx, 0x12, sr12);

	mem = 0;
	switch(vgaxi(Crtx, 0x27) &amp; ~0x03){

	case 0x88:				/* CL-GD5420 */
	case 0x8C:				/* CL-GD5422 */
	case 0x94:				/* CL-GD5424 */
	case 0x80:				/* CL-GD5425 */
	case 0x90:				/* CL-GD5426 */
	case 0x98:				/* CL-GD5427 */
	case 0x9C:				/* CL-GD5429 */
		/*
		 * The BIOS leaves the memory size in Seq0A, bits 4 and 3.
		 * See Technical Reference Manual Appendix E1, Section 1.3.2.
		 *
		 * The storage area for the 64x64 cursors is the last 16Kb of
		 * display memory.
		 */
		mem = (vgaxi(Seqx, 0x0A)&gt;&gt;3) &amp; 0x03;
		break;

	case 0xA0:				/* CL-GD5430 */
	case 0xA8:				/* CL-GD5434 */
	case 0xAC:				/* CL-GD5436 */
	case 0xB8:				/* CL-GD5446 */
	case 0x30:				/* CL-GD7543 */
		/*
		 * Attempt to intuit the memory size from the DRAM control
		 * register. Minimum is 512KB.
		 * If DRAM bank switching is on then there's double.
		 */
		x = vgaxi(Seqx, 0x0F);
		mem = (x&gt;&gt;3) &amp; 0x03;
		if(x &amp; 0x80)
			mem++;
		break;

	case 0xBC:				/* CL-GD5480 */
		mem = 2;			/* 1024 = 256&lt;&lt;2 */
		x = vgaxi(Seqx, 0x0F);
		if((x &amp; 0x18) == 0x18){
			mem &lt;&lt;= 1;		/* 2048 = 256&lt;&lt;3 */
			if(x &amp; 0x80)
				mem &lt;&lt;= 2;	/* 2048 = 256&lt;&lt;4 */
		}
		if(vgaxi(Seqx, 0x17) &amp; 0x80)
			mem &lt;&lt;= 1;
		break;

	default:				/* uh, ah dunno */
		break;
	}
	scr-&gt;storage = ((256&lt;&lt;mem)-16)*1024;

	/*
	 * Set the current cursor to index 0
	 * and turn the 64x64 cursor on.
	 */
	vgaxo(Seqx, 0x13, 0);
	vgaxo(Seqx, 0x12, sr12|0x05);
}

static void
clgd542xinitcursor(VGAscr* scr, int xo, int yo, int index)
{
	uchar *p, seq07;
	uint p0, p1;
	int opage, x, y;

	/*
	 * Is linear addressing turned on? This will determine
	 * how we access the cursor storage.
	 */
	seq07 = vgaxi(Seqx, 0x07);
	opage = 0;
	p = scr-&gt;vaddr;
	if(!(seq07 &amp; 0xF0)){
		lock(&amp;scr-&gt;devlock);
		opage = clgd542xpageset(scr, scr-&gt;storage&gt;&gt;16);
		p += (scr-&gt;storage &amp; 0xFFFF);
	}
	else
		p += scr-&gt;storage;
	p += index*1024;

	for(y = yo; y &lt; 16; y++){
		p0 = scr-&gt;set[2*y];
		p1 = scr-&gt;set[2*y+1];
		if(xo){
			p0 = (p0&lt;&lt;xo)|(p1&gt;&gt;(8-xo));
			p1 &lt;&lt;= xo;
		}
		*p++ = p0;
		*p++ = p1;

		for(x = 16; x &lt; 64; x += 8)
			*p++ = 0x00;

		p0 = scr-&gt;clr[2*y]|scr-&gt;set[2*y];
		p1 = scr-&gt;clr[2*y+1]|scr-&gt;set[2*y+1];
		if(xo){
			p0 = (p0&lt;&lt;xo)|(p1&gt;&gt;(8-xo));
			p1 &lt;&lt;= xo;
		}
		*p++ = p0;
		*p++ = p1;

		for(x = 16; x &lt; 64; x += 8)
			*p++ = 0x00;
	}
	while(y &lt; 64+yo){
		for(x = 0; x &lt; 64; x += 8){
			*p++ = 0x00;
			*p++ = 0x00;
		}
		y++;
	}

	if(!(seq07 &amp; 0xF0)){
		clgd542xpageset(scr, opage);
		unlock(&amp;scr-&gt;devlock);
	}
}

static void
clgd542xload(VGAscr* scr, Cursor* curs)
{
	uchar sr12;

	/*
	 * Disable the cursor.
	 */
	sr12 = vgaxi(Seqx, 0x12);
	vgaxo(Seqx, 0x12, sr12 &amp; ~0x01);

	memmove(&amp;scr-&gt;Cursor, curs, sizeof(Cursor));
	clgd542xinitcursor(scr, 0, 0, 0);

	/*
	 * Enable the cursor.
	 */
	vgaxo(Seqx, 0x13, 0);
	vgaxo(Seqx, 0x12, sr12|0x05);
}

static int
clgd542xmove(VGAscr* scr, Point p)
{
	int index, x, xo, y, yo;

	index = 0;
	if((x = p.x+scr-&gt;offset.x) &lt; 0){
		xo = -x;
		x = 0;
	}
	else
		xo = 0;
	if((y = p.y+scr-&gt;offset.y) &lt; 0){
		yo = -y;
		y = 0;
	}
	else
		yo = 0;

	if(xo || yo){
		clgd542xinitcursor(scr, xo, yo, 1);
		index = 1;
	}
	vgaxo(Seqx, 0x13, index&lt;&lt;2);
	
	vgaxo(Seqx, 0x10|((x &amp; 0x07)&lt;&lt;5), (x&gt;&gt;3) &amp; 0xFF);
	vgaxo(Seqx, 0x11|((y &amp; 0x07)&lt;&lt;5), (y&gt;&gt;3) &amp; 0xFF);

	return 0;
}

VGAdev vgaclgd542xdev = {
	"clgd542x",

	0,
	0,
	clgd542xpage,
	clgd542xlinear,
};

VGAcur vgaclgd542xcur = {
	"clgd542xhwgc",

	clgd542xenable,
	clgd542xdisable,
	clgd542xload,
	clgd542xmove,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

