<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vgaet4000.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vgaet4000.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

static void
setet4000page(int page)
{
	uchar p;

	p = page &amp; 0x0F;
	p |= p&lt;&lt;4;
	outb(0x3CD, p);

	p = (page &amp; 0x30);
	p |= p&gt;&gt;4;
	outb(0x3CB, p);
}

static void
et4000page(VGAscr *scr, int page)
{
	lock(&amp;scr-&gt;devlock);
	setet4000page(page);
	unlock(&amp;scr-&gt;devlock);
}

static void
et4000disable(VGAscr*)
{
	uchar imaF7;

	outb(0x217A, 0xF7);
	imaF7 = inb(0x217B) &amp; ~0x80;
	outb(0x217B, imaF7);
}

static void
et4000enable(VGAscr *scr)
{
	uchar imaF7;

	et4000disable(scr);

	/*
	 * Configure CRTCB for Sprite, 64x64,
	 * CRTC pixel overlay.
	 */
	outb(0x217A, 0xEF);
	outb(0x217B, 0x02);

	/*
	 * Cursor goes in the top left corner
	 * of the Sprite area, so the horizontal and
	 * vertical presets are 0.
	 */
	outb(0x217A, 0xE2);
	outb(0x217B, 0x00);
	outb(0x217A, 0xE3);
	outb(0x217B, 0x00);

	outb(0x217A, 0xE6);
	outb(0x217B, 0x00);
	outb(0x217A, 0xE7);
	outb(0x217B, 0x00);

	/*
	 * Find a place for the cursor data in display memory.
	 * Must be on a "doubleword" boundary, but put it on a
	 * 1024-byte boundary so that there's no danger of it
	 * crossing a page.
	 */
	scr-&gt;storage = (scr-&gt;gscreen-&gt;width*BY2WD*scr-&gt;gscreen-&gt;r.max.y+1023)/1024;
	scr-&gt;storage *= 1024/4;
	outb(0x217A, 0xE8);
	outb(0x217B, scr-&gt;storage &amp; 0xFF);
	outb(0x217A, 0xE9);
	outb(0x217B, (scr-&gt;storage&gt;&gt;8) &amp; 0xFF);
	outb(0x217A, 0xEA);
	outb(0x217B, (scr-&gt;storage&gt;&gt;16) &amp; 0x0F);
	scr-&gt;storage *= 4;

	/*
	 * Row offset in "quadwords". Must be 2 for Sprite.
	 * Bag the pixel-panning.
	 * Colour depth, must be 2 for Sprite.
	 */
	outb(0x217A, 0xEB);
	outb(0x217B, 0x02);
	outb(0x217A, 0xEC);
	outb(0x217B, 0x00);

	outb(0x217A, 0xED);
	outb(0x217B, 0x00);

	outb(0x217A, 0xEE);
//	if(vgascreen.ldepth == 3)
		outb(0x217B, 0x01);
//	else
//		outb(0x217B, 0x00);

	/*
	 * Enable the CRTCB/Sprite.
	 */
	outb(0x217A, 0xF7);
	imaF7 = inb(0x217B);
	outb(0x217B, 0x80|imaF7);
}

static void
et4000load(VGAscr *scr, Cursor *c)
{
	uchar p0, p1, *mem;
	int i, x, y;
	ushort p;
	uchar clr[2*16], set[2*16];

	/*
	 * Lock the display memory so we can update the
	 * cursor bitmap if necessary.
	 */
	lock(&amp;scr-&gt;devlock);

	/*
	 * Disable the cursor.
	 * Set the display page (do we need to restore
	 * the current contents when done?) and the
	 * pointer to the two planes. What if this crosses
	 * into a new page?
	 */
	et4000disable(scr);

	setet4000page(scr-&gt;storage&gt;&gt;16);
	mem = (uchar*)scr-&gt;vaddr + (scr-&gt;storage &amp; 0xFFFF);

	/*
	 * Initialise the 64x64 cursor RAM array. There are 2 planes,
	 * p0 and p1. Data is written 4 pixels per byte, with p1 the
	 * MS bit of each pixel.
	 * The cursor mode gives the following truth table:
	 *	p1 p0	colour
	 *	 0  0	Sprite Colour 0 (defined as 0x00)
	 *	 0  1	Sprite Colour 1 (defined as 0xFF)
	 *	 1  0	Transparent (allow CRTC pixel pass through)
	 *	 1  1	Invert (allow CRTC pixel invert through)
	 * Put the cursor into the top-left of the 64x64 array.
	 *
	 * This is almost certainly wrong, since it has not
	 * been updated for the 3rd edition color values.
	 */
	memmove(clr, c-&gt;clr, sizeof(clr));
//	pixreverse(clr, sizeof(clr), 0);
	memmove(set, c-&gt;set, sizeof(set));
//	pixreverse(set, sizeof(set), 0);
	for(y = 0; y &lt; 64; y++){
		for(x = 0; x &lt; 64/8; x++){
			if(x &lt; 16/8 &amp;&amp; y &lt; 16){
				p0 = clr[x+y*2];
				p1 = set[x+y*2];

				p = 0x0000;
				for(i = 0; i &lt; 8; i++){
					if(p1 &amp; (1&lt;&lt;(7-i))){
						/* nothing to do */
					}
					else if(p0 &amp; (1&lt;&lt;(7-i)))
						p |= 0x01&lt;&lt;(2*i);
					else
						p |= 0x02&lt;&lt;(2*i);
				}
				*mem++ = p &amp; 0xFF;
				*mem++ = (p&gt;&gt;8) &amp; 0xFF;
			}
			else {
				*mem++ = 0xAA;
				*mem++ = 0xAA;
			}
		}
	}

	/*
	 * enable the cursor.
	 */
	outb(0x217A, 0xF7);
	p = inb(0x217B)|0x80;
	outb(0x217B, p);

	unlock(&amp;scr-&gt;devlock);
}

static int
et4000move(VGAscr *scr, Point p)
{
	int x, xo, y, yo;

	if(canlock(&amp;scr-&gt;devlock) == 0)
		return 1;

	/*
	 * Mustn't position the cursor offscreen even partially,
	 * or it disappears. Therefore, if x or y is -ve, adjust the
	 * cursor presets instead.
	 */
	if((x = p.x+scr-&gt;offset.x) &lt; 0){
		xo = -x;
		x = 0;
	}
	else
		xo = 0;
	if((y = p.y+scr-&gt;offset.y) &lt; 0){
		yo = -y;
		y = 0;
	}
	else
		yo = 0;

	/*
	 * The cursor image is jerky if we don't do this.
	 * The cursor information is probably fetched from
	 * display memory during the horizontal blank active
	 * time and it doesn't like it if the coordinates
	 * are changed underneath.
	 */
	while((vgai(Status1) &amp; 0x08) == 0)
		;

	outb(0x217A, 0xE2);
	outb(0x217B, xo);

	outb(0x217A, 0xE6);
	outb(0x217B, yo);

	outb(0x217A, 0xE1);
	outb(0x217B, (x&gt;&gt;8) &amp; 0xFF);
	outb(0x217A, 0xE0);
	outb(0x217B, x &amp; 0xFF);
	outb(0x217A, 0xE5);
	outb(0x217B, (y&gt;&gt;8) &amp; 0xFF);
	outb(0x217A, 0xE4);
	outb(0x217B, y &amp; 0xFF);

	unlock(&amp;scr-&gt;devlock);
	return 0;
}

VGAcur vgaet4000cur = {
	"et4000hwgc",

	et4000enable,
	et4000disable,
	et4000load,
	et4000move,
};

VGAdev vgaet4000dev = {
	"et4000",

	0,
	0,
	et4000page,
	0
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

