<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vgaradeon.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vgaradeon.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ATI Radeon [789]XXX vga driver
 * see /sys/src/cmd/aux/vga/radeon.c
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

#include "/sys/src/cmd/aux/vga/radeon.h"	/* ugh */

/* #define HW_ACCEL */

enum {
	Kilo	= 1024,
	Meg	= Kilo * Kilo,
};

static Pcidev*
radeonpci(void)
{
	static Pcidev *p = nil;
	struct pciids *ids;

	while ((p = pcimatch(p, ATI_PCIVID, 0)) != nil)
		for (ids = radeon_pciids; ids-&gt;did; ids++)
			if (ids-&gt;did == p-&gt;did)
				return p;
	return nil;
}

/* mmio access */

static void
OUTREG8(ulong mmio, ulong offset, uchar val)
{
	((uchar*)KADDR((mmio + offset)))[0] = val;
}

static void
OUTREG(ulong mmio, ulong offset, ulong val)
{
	((ulong*)KADDR((mmio + offset)))[0] = val;
}

static ulong
INREG(ulong mmio, ulong offset)
{
	return ((ulong*)KADDR((mmio + offset)))[0];
}

static void
OUTREGP(ulong mmio, ulong offset, ulong val, ulong mask)
{
	OUTREG(mmio, offset, (INREG(mmio, offset) &amp; mask) | val);
}

static void
OUTPLL(ulong mmio, ulong offset, ulong val)
{
	OUTREG8(mmio, CLOCK_CNTL_INDEX, (offset &amp; 0x3f) | PLL_WR_EN);
	OUTREG(mmio, CLOCK_CNTL_DATA, val);
}

static ulong
INPLL(ulong mmio, ulong offset)
{
	OUTREG8(mmio, CLOCK_CNTL_INDEX, offset &amp; 0x3f);
	return INREG(mmio, CLOCK_CNTL_DATA);
}

static void
OUTPLLP(ulong mmio, ulong offset, ulong val, ulong mask)
{
	OUTPLL(mmio, offset, (INPLL(mmio, offset) &amp; mask) | val);
}

static void
radeonlinear(VGAscr *, int, int)
{
}

static void
radeonenable(VGAscr *scr)
{
	Pcidev *p;

	if (scr-&gt;mmio)
		return;
	p = radeonpci();
	if (p == nil)
		return;
	scr-&gt;id = p-&gt;did;
	scr-&gt;pci = p;

	scr-&gt;mmio = vmap(p-&gt;mem[2].bar &amp; ~0x0f, p-&gt;mem[2].size);
	if(scr-&gt;mmio == 0)
		return;
	addvgaseg("radeonmmio", p-&gt;mem[2].bar &amp; ~0x0f, p-&gt;mem[2].size);

	vgalinearpci(scr);
	if(scr-&gt;apsize)
		addvgaseg("radeonscreen", scr-&gt;paddr, scr-&gt;apsize);
}

static void
radeoncurload(VGAscr *scr, Cursor *curs)
{
	int x, y;
	ulong *p;

	if(scr-&gt;mmio == nil)
		return;

	p = (ulong*)KADDR(scr-&gt;storage);

	for(y = 0; y &lt; 64; y++){
		int cv, sv;

		if (y &lt; 16) {
			cv = curs-&gt;clr[2*y] &lt;&lt; 8 | curs-&gt;clr[2*y+1];
			sv = curs-&gt;set[2*y] &lt;&lt; 8 | curs-&gt;set[2*y+1];
		} else
			cv = sv = 0;

		for(x = 0; x &lt; 64; x++){
			ulong col = 0;
			int c, s;

			if (x &lt; 16) {
				c = (cv &gt;&gt; (15 - x)) &amp; 1;
				s = (sv &gt;&gt; (15 - x)) &amp; 1;
			} else
				c = s = 0;

			switch(c | s&lt;&lt;1) {
			case 0:
				col = 0;
				break;
			case 1:
				col = ~0ul;		/* white */
				break;
			case 2:
			case 3:
				col = 0xff000000;	/* black */
				break;
			}

			*p++ = col;
		}
	}

	scr-&gt;offset.x = curs-&gt;offset.x;
	scr-&gt;offset.y = curs-&gt;offset.y;
}

static int
radeoncurmove(VGAscr *scr, Point p)
{
	int x, y, ox, oy;
	static ulong storage = 0;

	if(scr-&gt;mmio == nil)
		return 1;

	if (storage == 0)
		storage = scr-&gt;apsize - 1*Meg;

	x = p.x + scr-&gt;offset.x;
	y = p.y + scr-&gt;offset.y;
	ox = oy = 0;

	if (x &lt; 0) {
		ox = -x - 1;
		x = 0;
	}
	if (y &lt; 0) {
		oy = -y - 1;
		y = 0;
	}

	OUTREG((ulong)scr-&gt;mmio, CUR_OFFSET, storage + oy * 256);
	OUTREG((ulong)scr-&gt;mmio, CUR_HORZ_VERT_OFF,
		(ox &amp; 0x7fff) &lt;&lt; 16 | (oy &amp; 0x7fff));
	OUTREG((ulong)scr-&gt;mmio, CUR_HORZ_VERT_POSN,
		(x &amp; 0x7fff) &lt;&lt; 16 | (y &amp; 0x7fff));
	return 0;
}

static void
radeoncurdisable(VGAscr *scr)
{
	if(scr-&gt;mmio == nil)
		return;
	OUTREGP((ulong)scr-&gt;mmio, CRTC_GEN_CNTL, 0, ~CRTC_CUR_EN);
}

static void
radeoncurenable(VGAscr *scr)
{
	ulong storage;

	if(scr-&gt;mmio == 0)
		return;

	radeoncurdisable(scr);
	storage = scr-&gt;apsize - 1*Meg;
	scr-&gt;storage = (ulong)KADDR(scr-&gt;paddr + storage);
	radeoncurload(scr, &amp;arrow);
	radeoncurmove(scr, ZP);

	OUTREGP((ulong)scr-&gt;mmio, CRTC_GEN_CNTL, CRTC_CUR_EN | 2&lt;&lt;20,
		~(CRTC_CUR_EN | 3&lt;&lt;20));
}

/* hw blank */

static void
radeonblank(VGAscr* scr, int blank)
{
	ulong mask;
	char *cp;

	if (scr-&gt;mmio == 0)
		return;

//	iprint("radeon: hwblank(%d)\n", blank);

	mask = CRTC_DISPLAY_DIS | CRTC_HSYNC_DIS | CRTC_VSYNC_DIS;
	if (blank == 0) {
		OUTREGP((ulong)scr-&gt;mmio, CRTC_EXT_CNTL, 0, ~mask);
		return;
	}

	cp = getconf("*dpms");
	if (cp) {
		if (strcmp(cp, "standby") == 0)
			OUTREGP((ulong)scr-&gt;mmio, CRTC_EXT_CNTL,
				CRTC_DISPLAY_DIS | CRTC_HSYNC_DIS, ~mask);
		else if (strcmp(cp, "suspend") == 0)
			OUTREGP((ulong)scr-&gt;mmio, CRTC_EXT_CNTL,
				CRTC_DISPLAY_DIS | CRTC_VSYNC_DIS, ~mask);
		else if (strcmp(cp, "off") == 0)
			OUTREGP((ulong)scr-&gt;mmio, CRTC_EXT_CNTL, mask, ~mask);
		return;
	}

	OUTREGP((ulong)scr-&gt;mmio, CRTC_EXT_CNTL, mask, ~mask);
}

/* hw acceleration */

static void
radeonwaitfifo(VGAscr *scr, int entries)
{
	int i;

	for (i = 0; i &lt; 2000000; i++)
		if (INREG((ulong)scr-&gt;mmio, RBBM_STATUS) &amp; RBBM_FIFOCNT_MASK &gt;=
		    entries)
			return;
	iprint("radeon: fifo timeout\n");
}

static void
radeonwaitidle(VGAscr *scr)
{
	radeonwaitfifo(scr, 64);

	for (; ; ) {
		int i;

		for (i = 0; i &lt; 2000000; i++)
			if (!(INREG((ulong)scr-&gt;mmio, RBBM_STATUS) &amp; RBBM_ACTIVE))
				return;

		iprint("radeon: idle timed out: %uld entries, stat=0x%.8ulx\n",
			INREG((ulong)scr-&gt;mmio, RBBM_STATUS) &amp; RBBM_FIFOCNT_MASK,
			INREG((ulong)scr-&gt;mmio, RBBM_STATUS));
	}
}

static ulong dp_gui_master_cntl = 0;

static int
radeonfill(VGAscr *scr, Rectangle r, ulong color)
{
	if (scr-&gt;mmio == nil)
		return 0;

	radeonwaitfifo(scr, 6);
	OUTREG((ulong)scr-&gt;mmio, DP_GUI_MASTER_CNTL,
		dp_gui_master_cntl | GMC_BRUSH_SOLID_COLOR |
		GMC_SRC_DATATYPE_COLOR | ROP3_P);
	OUTREG((ulong)scr-&gt;mmio, DP_BRUSH_FRGD_CLR, color);
	OUTREG((ulong)scr-&gt;mmio, DP_WRITE_MASK, ~0ul);
	OUTREG((ulong)scr-&gt;mmio, DP_CNTL,
		DST_X_LEFT_TO_RIGHT | DST_Y_TOP_TO_BOTTOM);
	OUTREG((ulong)scr-&gt;mmio, DST_Y_X, r.min.y &lt;&lt; 16 | r.min.x);
	OUTREG((ulong)scr-&gt;mmio, DST_WIDTH_HEIGHT, Dx(r) &lt;&lt; 16 | Dy(r));

	radeonwaitidle(scr);
	return 1;
}

static int
radeonscroll(VGAscr*scr, Rectangle dst, Rectangle src)
{
	int xs, ys, xd, yd, w, h;
	ulong dp_cntl = 0x20;

	if (scr-&gt;mmio == nil)
		return 0;

	// iprint("radeon: hwscroll(dst:%R, src:%R)\n", dst, src);

	xd = dst.min.x;
	yd = dst.min.y;
	xs = src.min.x;
	ys = src.min.y;
	w = Dx(dst);
	h = Dy(dst);

	if (ys &lt; yd) {
		ys += h - 1;
		yd += h - 1;
	} else
		dp_cntl |= DST_Y_TOP_TO_BOTTOM;

	if (xs &lt; xd) {
		xs += w - 1;
		xd += w - 1;
	} else
		dp_cntl |= DST_X_LEFT_TO_RIGHT;

	radeonwaitfifo(scr, 6);
	OUTREG((ulong)scr-&gt;mmio, DP_GUI_MASTER_CNTL, dp_gui_master_cntl |
		GMC_BRUSH_NONE | GMC_SRC_DATATYPE_COLOR | DP_SRC_SOURCE_MEMORY |
		ROP3_S);
	OUTREG((ulong)scr-&gt;mmio, DP_WRITE_MASK, ~0ul);
	OUTREG((ulong)scr-&gt;mmio, DP_CNTL, dp_cntl);
	OUTREG((ulong)scr-&gt;mmio, SRC_Y_X, ys &lt;&lt; 16 | xs);
	OUTREG((ulong)scr-&gt;mmio, DST_Y_X, yd &lt;&lt; 16 | xd);
	OUTREG((ulong)scr-&gt;mmio, DST_WIDTH_HEIGHT, w &lt;&lt; 16 | h);

	radeonwaitidle(scr);

	// iprint("radeon: hwscroll(xs=%d ys=%d xd=%d yd=%d w=%d h=%d)\n",
	//	xs, ys, xd, yd, w, h);
	return 1;
}

static void
radeondrawinit(VGAscr*scr)
{
	ulong bpp, dtype, i, pitch, clock_cntl_index, mclk_cntl, rbbm_soft_reset;

	if (scr-&gt;mmio == 0)
		return;

	switch (scr-&gt;gscreen-&gt;depth) {
	case 6:
	case 8:
		dtype = 2;
		bpp = 1;
		break;
	case 15:
		dtype = 3;
		bpp = 2;
		break;
	case 16:
		dtype = 4;
		bpp = 2;
		break;
	case 32:
		dtype = 6;
		bpp = 4;
		break;
	default:
		return;
	}

	/* disable 3D */
	OUTREG((ulong)scr-&gt;mmio, RB3D_CNTL, 0);

	/* flush engine */
	OUTREGP((ulong)scr-&gt;mmio, RB2D_DSTCACHE_CTLSTAT,
		RB2D_DC_FLUSH_ALL, ~RB2D_DC_FLUSH_ALL);
	for (i = 0; i &lt; 2000000; i++)
		if (!(INREG((ulong)scr-&gt;mmio, RB2D_DSTCACHE_CTLSTAT) &amp;
		    RB2D_DC_BUSY))
			break;

	/* reset 2D engine */
	clock_cntl_index = INREG((ulong)scr-&gt;mmio, CLOCK_CNTL_INDEX);

	mclk_cntl = INPLL((ulong)scr-&gt;mmio, MCLK_CNTL);
	OUTPLL((ulong)scr-&gt;mmio, MCLK_CNTL, mclk_cntl | FORCEON_MCLKA |
		FORCEON_MCLKB | FORCEON_YCLKA | FORCEON_YCLKB | FORCEON_MC |
		FORCEON_AIC);
	rbbm_soft_reset = INREG((ulong)scr-&gt;mmio, RBBM_SOFT_RESET);

	OUTREG((ulong)scr-&gt;mmio, RBBM_SOFT_RESET, rbbm_soft_reset |
		SOFT_RESET_CP | SOFT_RESET_HI | SOFT_RESET_SE | SOFT_RESET_RE |
		SOFT_RESET_PP | SOFT_RESET_E2 | SOFT_RESET_RB);
	INREG((ulong)scr-&gt;mmio, RBBM_SOFT_RESET);
	OUTREG((ulong)scr-&gt;mmio, RBBM_SOFT_RESET, rbbm_soft_reset &amp;
		~(SOFT_RESET_CP | SOFT_RESET_HI | SOFT_RESET_SE | SOFT_RESET_RE |
		SOFT_RESET_PP | SOFT_RESET_E2 | SOFT_RESET_RB));
	INREG((ulong)scr-&gt;mmio, RBBM_SOFT_RESET);

	OUTPLL((ulong)scr-&gt;mmio, MCLK_CNTL, mclk_cntl);
	OUTREG((ulong)scr-&gt;mmio, CLOCK_CNTL_INDEX, clock_cntl_index);

	/* init 2D engine */
	radeonwaitfifo(scr, 1);
	OUTREG((ulong)scr-&gt;mmio, RB2D_DSTCACHE_MODE, 0);

	pitch = Dx(scr-&gt;gscreen-&gt;r) * bpp;
	radeonwaitfifo(scr, 4);
	OUTREG((ulong)scr-&gt;mmio, DEFAULT_PITCH, pitch);
	OUTREG((ulong)scr-&gt;mmio, DST_PITCH, pitch);
	OUTREG((ulong)scr-&gt;mmio, SRC_PITCH, pitch);
	OUTREG((ulong)scr-&gt;mmio, DST_PITCH_OFFSET_C, 0);

	radeonwaitfifo(scr, 3);
	OUTREG((ulong)scr-&gt;mmio, DEFAULT_OFFSET, 0);
	OUTREG((ulong)scr-&gt;mmio, DST_OFFSET, 0);
	OUTREG((ulong)scr-&gt;mmio, SRC_OFFSET, 0);

	radeonwaitfifo(scr, 1);
	OUTREGP((ulong)scr-&gt;mmio, DP_DATATYPE, 0, ~HOST_BIG_ENDIAN_EN);

	radeonwaitfifo(scr, 1);
	OUTREG((ulong)scr-&gt;mmio, DEFAULT_SC_BOTTOM_RIGHT,
		DEFAULT_SC_RIGHT_MAX | DEFAULT_SC_BOTTOM_MAX);

	dp_gui_master_cntl = dtype &lt;&lt; GMC_DST_DATATYPE_SHIFT |
		GMC_SRC_PITCH_OFFSET_CNTL | GMC_DST_PITCH_OFFSET_CNTL |
		GMC_CLR_CMP_CNTL_DIS;
	radeonwaitfifo(scr, 1);
	OUTREG((ulong)scr-&gt;mmio, DP_GUI_MASTER_CNTL,
	    dp_gui_master_cntl | GMC_BRUSH_SOLID_COLOR | GMC_SRC_DATATYPE_COLOR);

	radeonwaitfifo(scr, 7);
	OUTREG((ulong)scr-&gt;mmio, DST_LINE_START,    0);
	OUTREG((ulong)scr-&gt;mmio, DST_LINE_END,      0);
	OUTREG((ulong)scr-&gt;mmio, DP_BRUSH_FRGD_CLR, ~0ul);
	OUTREG((ulong)scr-&gt;mmio, DP_BRUSH_BKGD_CLR, 0);
	OUTREG((ulong)scr-&gt;mmio, DP_SRC_FRGD_CLR,   ~0ul);
	OUTREG((ulong)scr-&gt;mmio, DP_SRC_BKGD_CLR,   0);
	OUTREG((ulong)scr-&gt;mmio, DP_WRITE_MASK,     ~0ul);

	radeonwaitidle(scr);

	scr-&gt;fill = radeonfill;
	scr-&gt;scroll = radeonscroll;
	hwaccel = 1;

	scr-&gt;blank = radeonblank;
	hwblank = 1;
}

/* hw overlay */

static void
radeonovlctl(VGAscr *scr, Chan *c, void *data, int len)
{
	USED(scr, c, data, len);
}

static int
radeonovlwrite(VGAscr *scr, void *data, int len, vlong opt)
{
	USED(scr, data, len, opt);
	return -1;
}

static void
radeonflush(VGAscr *scr, Rectangle r)
{
	USED(scr, r);
}

/* Export */

VGAdev vgaradeondev = {
	"radeon",

	radeonenable,
	0, 				/* disable */
	0, 				/* page */
	radeonlinear,

	radeondrawinit,
#ifdef HW_ACCEL
	radeonfill,

	radeonovlctl,
	radeonovlwrite,
	radeonflush,
#endif
};
VGAcur vgaradeoncur = {
	"radeonhwgc",
	radeoncurenable,
	radeoncurdisable,
	radeoncurload,
	radeoncurmove,
	0				/* doespanning */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

