<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/dir.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/dir.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * directory reading
 * from /sys/src/libc/9sys/dirread.c
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"ureg.h"

enum
{
	DIRSIZE	= STATFIXLEN + 16 * 4		/* enough for encoded stat buf + some reasonable strings */
};

Dir*
dirchstat(Chan *chan)
{
	Dir *d;
	uchar *buf;
	int n, nd, i;

	nd = DIRSIZE;
	for(i=0; i&lt;2; i++){	/* should work by the second try */
		d = malloc(sizeof(Dir) + BIT16SZ + nd);
		if(d == nil)
			return nil;
		buf = (uchar*)&amp;d[1];
		n = devtab[chan-&gt;type]-&gt;stat(chan, buf, BIT16SZ + nd);
		if(n &lt; BIT16SZ){
			free(d);
			return nil;
		}
		nd = GBIT16((uchar*)buf);	/* upper bound on size of Dir + strings */
		if(nd &lt;= n){
			convM2D(buf, n, d, (char*)&amp;d[1]);
			return d;
		}
		/* else sizeof(Dir)+BIT16SZ+nd is plenty */
		free(d);
	}
	return nil;
}

long
dirpackage(uchar *buf, long ts, Dir **d)
{
	char *s;
	long ss, i, n, nn, m;

	*d = nil;
	if(ts &lt;= 0)
		return 0;

	/*
	 * first find number of all stats, check they look like stats, &amp; size all associated strings
	 */
	ss = 0;
	n = 0;
	for(i = 0; i &lt; ts; i += m){
		m = BIT16SZ + GBIT16(&amp;buf[i]);
		if(statcheck(&amp;buf[i], m) &lt; 0)
			break;
		ss += m;
		n++;
	}

	if(i != ts)
		return -1;

	*d = malloc(n * sizeof(Dir) + ss);
	if(*d == nil)
		return -1;

	/*
	 * then convert all buffers
	 */
	s = (char*)*d + n * sizeof(Dir);
	nn = 0;
	for(i = 0; i &lt; ts; i += m){
		m = BIT16SZ + GBIT16((uchar*)&amp;buf[i]);
		if(nn &gt;= n || convM2D(&amp;buf[i], m, *d + nn, s) != m){
			free(*d);
			*d = nil;
			return -1;
		}
		nn++;
		s += m;
	}

	return nn;
}

/*
 * directory reading, from sysfile.c
 */

long
unionread(Chan *c, void *va, long n)
{
	int i;
	long nr;
	Mhead *m;
	Mount *mount;

	qlock(&amp;c-&gt;umqlock);
	m = c-&gt;umh;
	rlock(&amp;m-&gt;lock);
	mount = m-&gt;mount;
	/* bring mount in sync with c-&gt;uri and c-&gt;umc */
	for(i = 0; mount != nil &amp;&amp; i &lt; c-&gt;uri; i++)
		mount = mount-&gt;next;

	nr = 0;
	while(mount != nil){
		/* Error causes component of union to be skipped */
		if(mount-&gt;to &amp;&amp; !waserror()){
			if(c-&gt;umc == nil){
				c-&gt;umc = cclone(mount-&gt;to);
				c-&gt;umc = devtab[c-&gt;umc-&gt;type]-&gt;open(c-&gt;umc, OREAD);
			}
	
			nr = devtab[c-&gt;umc-&gt;type]-&gt;read(c-&gt;umc, va, n, c-&gt;umc-&gt;offset);
			c-&gt;umc-&gt;offset += nr;
			poperror();
		}
		if(nr &gt; 0)
			break;

		/* Advance to next element */
		c-&gt;uri++;
		if(c-&gt;umc){
			cclose(c-&gt;umc);
			c-&gt;umc = nil;
		}
		mount = mount-&gt;next;
	}
	runlock(&amp;m-&gt;lock);
	qunlock(&amp;c-&gt;umqlock);
	return nr;
}

void
unionrewind(Chan *c)
{
	qlock(&amp;c-&gt;umqlock);
	c-&gt;uri = 0;
	if(c-&gt;umc){
		cclose(c-&gt;umc);
		c-&gt;umc = nil;
	}
	qunlock(&amp;c-&gt;umqlock);
}

static int
dirfixed(uchar *p, uchar *e, Dir *d)
{
	int len;

	len = GBIT16(p)+BIT16SZ;
	if(p + len &gt; e)
		return -1;

	p += BIT16SZ;	/* ignore size */
	d-&gt;type = devno(GBIT16(p), 1);
	p += BIT16SZ;
	d-&gt;dev = GBIT32(p);
	p += BIT32SZ;
	d-&gt;qid.type = GBIT8(p);
	p += BIT8SZ;
	d-&gt;qid.vers = GBIT32(p);
	p += BIT32SZ;
	d-&gt;qid.path = GBIT64(p);
	p += BIT64SZ;
	d-&gt;mode = GBIT32(p);
	p += BIT32SZ;
	d-&gt;atime = GBIT32(p);
	p += BIT32SZ;
	d-&gt;mtime = GBIT32(p);
	p += BIT32SZ;
	d-&gt;length = GBIT64(p);

	return len;
}

static char*
dirname(uchar *p, int *n)
{
	p += BIT16SZ+BIT16SZ+BIT32SZ+BIT8SZ+BIT32SZ+BIT64SZ
		+ BIT32SZ+BIT32SZ+BIT32SZ+BIT64SZ;
	*n = GBIT16(p);
	return (char*)p+BIT16SZ;
}

static long
dirsetname(char *name, int len, uchar *p, long n, long maxn)
{
	char *oname;
	int olen;
	long nn;

	if(n == BIT16SZ)
		return BIT16SZ;

	oname = dirname(p, &amp;olen);

	nn = n+len-olen;
	PBIT16(p, nn-BIT16SZ);
	if(nn &gt; maxn)
		return BIT16SZ;

	if(len != olen)
		memmove(oname+len, oname+olen, p+n-(uchar*)(oname+olen));
	PBIT16((uchar*)(oname-2), len);
	memmove(oname, name, len);
	return nn;
}

/*
 * Mountfix might have caused the fixed results of the directory read
 * to overflow the buffer.  Catch the overflow in c-&gt;dirrock.
 */
static void
mountrock(Chan *c, uchar *p, uchar **pe)
{
	uchar *e, *r;
	int len, n;

	e = *pe;

	/* find last directory entry */
	for(;;){
		len = BIT16SZ+GBIT16(p);
		if(p+len &gt;= e)
			break;
		p += len;
	}

	/* save it away */
	qlock(&amp;c-&gt;rockqlock);
	if(c-&gt;nrock+len &gt; c-&gt;mrock){
		n = ROUND(c-&gt;nrock+len, 1024);
		r = smalloc(n);
		memmove(r, c-&gt;dirrock, c-&gt;nrock);
		free(c-&gt;dirrock);
		c-&gt;dirrock = r;
		c-&gt;mrock = n;
	}
	memmove(c-&gt;dirrock+c-&gt;nrock, p, len);
	c-&gt;nrock += len;
	qunlock(&amp;c-&gt;rockqlock);

	/* drop it */
	*pe = p;
}

/*
 * Satisfy a directory read with the results saved in c-&gt;dirrock.
 */
int
mountrockread(Chan *c, uchar *op, long n, long *nn)
{
	long dirlen;
	uchar *rp, *erp, *ep, *p;

	/* common case */
	if(c-&gt;nrock == 0)
		return 0;

	/* copy out what we can */
	qlock(&amp;c-&gt;rockqlock);
	rp = c-&gt;dirrock;
	erp = rp+c-&gt;nrock;
	p = op;
	ep = p+n;
	while(rp+BIT16SZ &lt;= erp){
		dirlen = BIT16SZ+GBIT16(rp);
		if(p+dirlen &gt; ep)
			break;
		memmove(p, rp, dirlen);
		p += dirlen;
		rp += dirlen;
	}

	if(p == op){
		qunlock(&amp;c-&gt;rockqlock);
		return 0;
	}

	/* shift the rest */
	if(rp != erp)
		memmove(c-&gt;dirrock, rp, erp-rp);
	c-&gt;nrock = erp - rp;

	*nn = p - op;
	qunlock(&amp;c-&gt;rockqlock);
	return 1;
}

void
mountrewind(Chan *c)
{
	c-&gt;nrock = 0;
}

/*
 * Rewrite the results of a directory read to reflect current 
 * name space bindings and mounts.  Specifically, replace
 * directory entries for bind and mount points with the results
 * of statting what is mounted there.  Except leave the old names.
 */
long
mountfix(Chan *c, uchar *op, long n, long maxn)
{
	char *name;
	int nbuf, nname;
	Chan *nc;
	Mhead *mh;
	Mount *m;
	uchar *p;
	int dirlen, rest;
	long l;
	uchar *buf, *e;
	Dir d;

	p = op;
	buf = nil;
	nbuf = 0;
	for(e=&amp;p[n]; p+BIT16SZ&lt;e; p+=dirlen){
		dirlen = dirfixed(p, e, &amp;d);
		if(dirlen &lt; 0)
			break;
		nc = nil;
		mh = nil;
		if(findmount(&amp;nc, &amp;mh, d.type, d.dev, d.qid)){
			/*
			 * If it's a union directory and the original is
			 * in the union, don't rewrite anything.
			 */
			for(m=mh-&gt;mount; m; m=m-&gt;next)
				if(eqchantdqid(m-&gt;to, d.type, d.dev, d.qid, 1))
					goto Norewrite;

			name = dirname(p, &amp;nname);
			/*
			 * Do the stat but fix the name.  If it fails, leave old entry.
			 * BUG: If it fails because there isn't room for the entry,
			 * what can we do?  Nothing, really.  Might as well skip it.
			 */
			if(buf == nil){
				buf = smalloc(4096);
				nbuf = 4096;
			}
			if(waserror())
				goto Norewrite;
			l = devtab[nc-&gt;type]-&gt;stat(nc, buf, nbuf);
			l = dirsetname(name, nname, buf, l, nbuf);
			if(l == BIT16SZ)
				error("dirsetname");
			poperror();

			/*
			 * Shift data in buffer to accomodate new entry,
			 * possibly overflowing into rock.
			 */
			rest = e - (p+dirlen);
			if(l &gt; dirlen){
				while(p+l+rest &gt; op+maxn){
					mountrock(c, p, &amp;e);
					if(e == p){
						dirlen = 0;
						goto Norewrite;
					}
					rest = e - (p+dirlen);
				}
			}
			if(l != dirlen){
				memmove(p+l, p+dirlen, rest);
				dirlen = l;
				e = p+dirlen+rest;
			}

			/*
			 * Rewrite directory entry.
			 */
			memmove(p, buf, l);

		    Norewrite:
			cclose(nc);
			putmhead(mh);
		}
	}
	if(buf)
		free(buf);

	if(p != e)
		error("oops in rockfix");

	return e-op;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

