<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/dosboot.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/dosboot.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"pool.h"
#include	"../port/error.h"
#include	"../port/netif.h"
#include	"dosfs.h"

enum {
	Dosfilemax = 8,
	Dosextmax = 3,
};

/*
 *  predeclared
 */
static void	bootdump(Dosboot*);
static void	setname(Dosfile*, char*);

/*
 *  debugging
 */
#define chatty	0
#define chat	if(chatty)print

/*
 *  block io buffers
 */
enum
{
	Nbio=	16,
};
typedef struct	Clustbuf	Clustbuf;
struct Clustbuf
{
	int	age;
	long	sector;
	uchar	*iobuf;
	Dos	*dos;
	int	size;
};
Clustbuf	bio[Nbio];

/*
 *  get an io block from an io buffer
 */
Clustbuf*
getclust(Dos *dos, long sector)
{
	Bootfs *fs;
	Clustbuf *p, *oldest;
	int size;

	chat("getclust @ %ld\n", sector);

	/*
	 *  if we have it, just return it
	 */
	for(p = bio; p &lt; &amp;bio[Nbio]; p++){
		if(sector == p-&gt;sector &amp;&amp; dos == p-&gt;dos){
			p-&gt;age = m-&gt;ticks;
			chat("getclust %ld in cache\n", sector);
			return p;
		}
	}

	/*
	 *  otherwise, reuse the oldest entry
	 */
	oldest = bio;
	for(p = &amp;bio[1]; p &lt; &amp;bio[Nbio]; p++){
		if(p-&gt;age &lt;= oldest-&gt;age)
			oldest = p;
	}
	p = oldest;

	/*
	 *  make sure the buffer is big enough
	 */
	size = dos-&gt;clustsize*dos-&gt;sectsize;
	if(p-&gt;iobuf==0 || p-&gt;size &lt; size)
		p-&gt;iobuf = smalloc(size);
	p-&gt;size = size;

	/*
	 *  read in the cluster
	 */
	fs = (Bootfs*)dos;		/* assume dos is embedded at start of an Bootfs */
	chat("getclust addr %llud %p %s\n", ((sector+dos-&gt;start)*(vlong)dos-&gt;sectsize),
		fs, fs-&gt;disk);
	fs-&gt;devch-&gt;offset = (sector+dos-&gt;start) * (vlong)dos-&gt;sectsize;
	if(myreadn(fs-&gt;devch, p-&gt;iobuf, size) != size){
		chat("can't read block\n");
		return 0;
	}
	USED(fs);
	p-&gt;age = m-&gt;ticks;
	p-&gt;dos = dos;
	p-&gt;sector = sector;
	chat("getclust %ld read\n", sector);
	return p;
}

/*
 *  walk the fat one level ( n is a current cluster number ).
 *  return the new cluster number or -1 if no more.
 */
static long
fatwalk(Dos *dos, int n)
{
	ulong k, sect;
	Clustbuf *p;
	int o;

	chat("fatwalk %d\n", n);

	if(n &lt; 2 || n &gt;= dos-&gt;fatclusters)
		return -1;

	switch(dos-&gt;fatbits){
	case 12:
		k = (3*n)/2; break;
	case 16:
		k = 2*n; break;
	case 32:
		k = 4*n; break;
	default:
		return -1;
	}
	if(k &gt;= dos-&gt;fatsize*dos-&gt;sectsize)
		panic("getfat");

	if (dos-&gt;sectsize == 0 || dos-&gt;clustsize == 0)
		panic("fatwalk: zero sector or cluster size");
	sect = (k/(dos-&gt;sectsize*dos-&gt;clustsize))*dos-&gt;clustsize + dos-&gt;fataddr;
	o = k%(dos-&gt;sectsize*dos-&gt;clustsize);
	p = getclust(dos, sect);
	k = p-&gt;iobuf[o++];
	if(o &gt;= dos-&gt;sectsize*dos-&gt;clustsize){
		p = getclust(dos, sect+dos-&gt;clustsize);
		o = 0;
	}
	k |= p-&gt;iobuf[o++]&lt;&lt;8;
	if(dos-&gt;fatbits == 12){
		if(n&amp;1)
			k &gt;&gt;= 4;
		else
			k &amp;= 0xfff;
		if(k &gt;= 0xff8)
			k = -1;
	}
	else if (dos-&gt;fatbits == 32){
		if(o &gt;= dos-&gt;sectsize*dos-&gt;clustsize){
			p = getclust(dos, sect+dos-&gt;clustsize);
			o = 0;
		}
		k |= p-&gt;iobuf[o++]&lt;&lt;16;
		k |= p-&gt;iobuf[o]&lt;&lt;24;
		if (k &gt;= 0xfffffff8)
			k = -1;
	}
	else
		k = k &lt; 0xfff8 ? k : -1;
	chat("fatwalk %d -&gt; %lud\n", n, k);
	return k;
}

/*
 *  map a file's logical cluster address to a physical sector address
 */
static long
fileaddr(Dosfile *fp, long ltarget)
{
	Dos *dos = fp-&gt;dos;
	long l;
	long p;

	chat("fileaddr %8.8s %ld\n", fp-&gt;name, ltarget);
	/*
	 *  root directory is contiguous and easy (unless FAT32)
	 */
	if(fp-&gt;pstart == 0 &amp;&amp; dos-&gt;rootsize != 0) {
		if(ltarget*dos-&gt;sectsize*dos-&gt;clustsize &gt;= dos-&gt;rootsize*sizeof(Dosdir))
			return -1;
		l = dos-&gt;rootaddr + ltarget*dos-&gt;clustsize;
		chat("fileaddr %ld -&gt; %ld\n", ltarget, l);
		return l;
	}

	/*
	 *  anything else requires a walk through the fat
	 */
	if(ltarget &gt;= fp-&gt;lcurrent &amp;&amp; fp-&gt;pcurrent){
		/* start at the currrent point */
		l = fp-&gt;lcurrent;
		p = fp-&gt;pcurrent;
	} else {
		/* go back to the beginning */
		l = 0;
		p = fp-&gt;pstart;
	}
	while(l != ltarget){
		/* walk the fat */
		p = fatwalk(dos, p);
		if(p &lt; 0)
			return -1;
		l++;
	}
	fp-&gt;lcurrent = l;
	fp-&gt;pcurrent = p;

	/*
	 *  clusters start at 2 instead of 0 (why? - presotto)
	 */
	l =  dos-&gt;dataaddr + (p-2)*dos-&gt;clustsize;
	chat("fileaddr %ld -&gt; %ld\n", ltarget, l);
	return l;
}

/*
 *  read from a dos file
 */
long
dosread(Dosfile *fp, void *a, long n)
{
	long addr;
	long rv;
	int i;
	int off;
	Clustbuf *p;
	uchar *from, *to;

	if((fp-&gt;attr &amp; DOSDIR) == 0){
		if(fp-&gt;offset &gt;= fp-&gt;length)
			return 0;
		if(fp-&gt;offset+n &gt; fp-&gt;length)
			n = fp-&gt;length - fp-&gt;offset;
	}

	to = a;
	for(rv = 0; rv &lt; n; rv+=i){
		/*
		 *  read the cluster
		 */
		addr = fileaddr(fp, fp-&gt;offset/fp-&gt;dos-&gt;clustbytes);
		if(addr &lt; 0)
			return -1;
		p = getclust(fp-&gt;dos, addr);
		if(p == 0)
			return -1;

		/*
		 *  copy the bytes we need
		 */
		off = fp-&gt;offset % fp-&gt;dos-&gt;clustbytes;
		from = &amp;p-&gt;iobuf[off];
		i = n - rv;
		if(i &gt; fp-&gt;dos-&gt;clustbytes - off)
			i = fp-&gt;dos-&gt;clustbytes - off;
		memmove(to, from, i);
		to += i;
		fp-&gt;offset += i;
	}

	return rv;
}

/*
 *  walk a directory returns
 * 	-1 if something went wrong
 *	 0 if not found
 *	 1 if found
 */
int
doswalk(File *f, char *name)
{
	Dosdir d;
	long n;
	Dosfile *file;

	chat("doswalk %s\n", name);

	file = &amp;f-&gt;dos;

	if((file-&gt;attr &amp; DOSDIR) == 0){
		chat("walking non-directory!\n");
		return -1;
	}

	setname(file, name);

	file-&gt;offset = 0;	/* start at the beginning */
	while((n = dosread(file, &amp;d, sizeof(d))) == sizeof(d)){
		chat("comparing to %8.8s.%3.3s\n", (char*)d.name, (char*)d.ext);
		if(memcmp(file-&gt;name, d.name, sizeof(d.name)) != 0)
			continue;
		if(memcmp(file-&gt;ext, d.ext, sizeof(d.ext)) != 0)
			continue;
		if(d.attr &amp; DOSVLABEL){
			chat("%8.8s.%3.3s is a LABEL\n", (char*)d.name, (char*)d.ext);
			continue;
		}
		file-&gt;attr = d.attr;
		file-&gt;pstart = GSHORT(d.start);
		if (file-&gt;dos-&gt;fatbits == 32)
			file-&gt;pstart |= GSHORT(d.highstart) &lt;&lt; 16;
		file-&gt;length = GLONG(d.length);
		file-&gt;pcurrent = 0;
		file-&gt;lcurrent = 0;
		file-&gt;offset = 0;
		return 1;
	}
	return n &gt;= 0 ? 0 : -1;
}

void
lowercase(char *s)
{
	for (; *s != '\0'; s++)
		if (*s &gt;= 'A' &amp;&amp; *s &lt;= 'Z')
			*s -= 'A' - 'a';
}

void
trim(char *s, int len)
{
	while(len &gt; 0 &amp;&amp; s[len-1] == ' ')
		s[--len] = '\0';
}

/*
 *  read a directory and return the file names in a malloced
 *	array whose address is stored through nmarray.
 * 	-1 if something went wrong
 *	else number of dir. entries
 */
int
dosdirread(File *f, char ***nmarray)
{
	int entries;
	long i;
	char buf[Dosfilemax+1+Dosextmax+1];
	char **nms;
	Dosdir d;
	Dosfile *file;

	chat("dosdirread\n");
	file = &amp;f-&gt;dos;
	if((file-&gt;attr &amp; DOSDIR) == 0){
		chat("walking non-directory!\n");
		return -1;
	}

	/* allocate the array of char*s */
	file-&gt;offset = 0;		/* start at the beginning */
	for(entries = 0; dosread(file, &amp;d, sizeof d) == sizeof d; entries++)
		;
	nms = smalloc(sizeof(char *) * (entries + 1));

	/* populate the array */
	file-&gt;offset = 0;		/* rewind */
	for(i = 0; i &lt; entries &amp;&amp; dosread(file, &amp;d, sizeof d) == sizeof d; ){
		trim((char *)d.name, Dosfilemax);
		trim((char *)d.ext, Dosextmax);
		if (d.name[0] == '\0')
			continue;
		if (d.ext[0] == '\0')
			kstrdup(&amp;nms[i], (char *)d.name);
		else {
			snprint(buf, sizeof buf, "%.*s.%.*s",
				Dosfilemax, (char *)d.name,
				Dosextmax, (char *)d.ext);
			kstrdup(&amp;nms[i], buf);
		}
		lowercase(nms[i++]);
	}
	*nmarray = nms;
	return 0;
}

/*
 *  instructions that boot blocks can start with
 */
#define	JMPSHORT	0xeb
#define JMPNEAR		0xe9

/*
 *  read in a segment
 */
long
dosreadseg(File *f, void *va, long len)
{
	char *a;
	long n, sofar;
	Dosfile *fp;

	fp = &amp;f-&gt;dos;
	a = va;
	for(sofar = 0; sofar &lt; len; sofar += n){
		n = 8*1024;
		if(len - sofar &lt; n)
			n = len - sofar;
		n = dosread(fp, a + sofar, n);
		if(n &lt;= 0)
			break;
		print(".");
	}
	return sofar;
}

int
dosinit(Bootfs *fs, char *disk)
{
	Clustbuf *p;
	Dosboot *b;
	int i;
	Dos *dos;
	Dosfile *root;

chat("dosinit0 %p %s\n", fs, fs-&gt;disk);

	fs-&gt;disk = disk;
	fs-&gt;devch = namecopen(disk, OREAD);
	if (fs-&gt;devch == nil) {
		print("dosinit: can't open %s\n", disk);
		return -1;
	}

	dos = &amp;fs-&gt;dos;
	/* defaults till we know better */
	dos-&gt;sectsize = 512;
	dos-&gt;clustsize = 1;

	/* get first sector */
	p = getclust(dos, 0);
	if(p == 0){
		chat("can't read boot block\n");
		return -1;
	}

chat("dosinit0a\n");

	p-&gt;dos = 0;				/* don't cache this block */
	b = (Dosboot *)p-&gt;iobuf;
	if(b-&gt;magic[0] != JMPNEAR &amp;&amp; (b-&gt;magic[0] != JMPSHORT || b-&gt;magic[2] != 0x90)){
		chat("no dos file system %x %x %x %x\n",
			b-&gt;magic[0], b-&gt;magic[1], b-&gt;magic[2], b-&gt;magic[3]);
		return -1;
	}

	if(chatty)
		bootdump(b);

	if(b-&gt;clustsize == 0) {
unreasonable:
		if(chatty){
			print("unreasonable FAT BPB: ");
			for(i=0; i&lt;3+8+2+1; i++)
				print(" %.2ux", p-&gt;iobuf[i]);
			print("\n");
		}
		return -1;
	}

chat("dosinit1\n");

	/*
	 * Determine the systems' wondrous properties.
	 * There are heuristics here, but there's no real way
	 * of knowing if this is a reasonable FAT.
	 */
	dos-&gt;fatbits = 0;
	dos-&gt;sectsize = GSHORT(b-&gt;sectsize);
	if(dos-&gt;sectsize &amp; 0xFF)
		goto unreasonable;
	dos-&gt;clustsize = b-&gt;clustsize;
	dos-&gt;clustbytes = dos-&gt;sectsize*dos-&gt;clustsize;
	dos-&gt;nresrv = GSHORT(b-&gt;nresrv);
	dos-&gt;nfats = b-&gt;nfats;
	dos-&gt;fatsize = GSHORT(b-&gt;fatsize);
	dos-&gt;rootsize = GSHORT(b-&gt;rootsize);
	dos-&gt;volsize = GSHORT(b-&gt;volsize);
	if(dos-&gt;volsize == 0)
		dos-&gt;volsize = GLONG(b-&gt;bigvolsize);
	dos-&gt;mediadesc = b-&gt;mediadesc;
	if(dos-&gt;fatsize == 0) {
		chat("fat32\n");
		dos-&gt;rootsize = 0;
		dos-&gt;fatsize = GLONG(b-&gt;bigfatsize);
		dos-&gt;fatbits = 32;
	}
	dos-&gt;fataddr = dos-&gt;nresrv;
	if (dos-&gt;rootsize == 0) {
		dos-&gt;rootaddr = 0;
		dos-&gt;rootclust = GLONG(b-&gt;rootdirstartclust);
		dos-&gt;dataaddr = dos-&gt;fataddr + dos-&gt;nfats*dos-&gt;fatsize;
	} else {
		dos-&gt;rootaddr = dos-&gt;fataddr + dos-&gt;nfats*dos-&gt;fatsize;
		i = dos-&gt;rootsize*sizeof(Dosdir) + dos-&gt;sectsize - 1;
		i = i/dos-&gt;sectsize;
		dos-&gt;dataaddr = dos-&gt;rootaddr + i;
	}
	dos-&gt;fatclusters = 2+(dos-&gt;volsize - dos-&gt;dataaddr)/dos-&gt;clustsize;
	if(dos-&gt;fatbits != 32) {
		if(dos-&gt;fatclusters &lt; 4087)
			dos-&gt;fatbits = 12;
		else
			dos-&gt;fatbits = 16;
	}
	dos-&gt;freeptr = 2;

	if(dos-&gt;clustbytes &lt; 512 || dos-&gt;clustbytes &gt; 64*1024)
		goto unreasonable;

chat("dosinit2\n");

	/*
	 *  set up the root
	 */

	fs-&gt;root.fs = fs;
	root = &amp;fs-&gt;root.dos;
	root-&gt;dos = dos;
	root-&gt;pstart = dos-&gt;rootsize == 0 ? dos-&gt;rootclust : 0;
	root-&gt;pcurrent = root-&gt;lcurrent = 0;
	root-&gt;offset = 0;
	root-&gt;attr = DOSDIR;
	root-&gt;length = dos-&gt;rootsize*sizeof(Dosdir);

chat("dosinit3\n");

	fs-&gt;read = dosreadseg;
	fs-&gt;walk = doswalk;
	return 0;
}

static void
bootdump(Dosboot *b)
{
	if(chatty == 0)
		return;
	print("magic: 0x%2.2x 0x%2.2x 0x%2.2x ",
		b-&gt;magic[0], b-&gt;magic[1], b-&gt;magic[2]);
	print("version: \"%8.8s\"\n", (char*)b-&gt;version);
	print("sectsize: %d ", GSHORT(b-&gt;sectsize));
	print("allocsize: %d ", b-&gt;clustsize);
	print("nresrv: %d ", GSHORT(b-&gt;nresrv));
	print("nfats: %d\n", b-&gt;nfats);
	print("rootsize: %d ", GSHORT(b-&gt;rootsize));
	print("volsize: %d ", GSHORT(b-&gt;volsize));
	print("mediadesc: 0x%2.2x\n", b-&gt;mediadesc);
	print("fatsize: %d ", GSHORT(b-&gt;fatsize));
	print("trksize: %d ", GSHORT(b-&gt;trksize));
	print("nheads: %d ", GSHORT(b-&gt;nheads));
	print("nhidden: %d ", GLONG(b-&gt;nhidden));
	print("bigvolsize: %d\n", GLONG(b-&gt;bigvolsize));
/*
	print("driveno: %d\n", b-&gt;driveno);
	print("reserved0: 0x%2.2x\n", b-&gt;reserved0);
	print("bootsig: 0x%2.2x\n", b-&gt;bootsig);
	print("volid: 0x%8.8x\n", GLONG(b-&gt;volid));
	print("label: \"%11.11s\"\n", b-&gt;label);
*/
}


/*
 *  set up a dos file name
 */
static void
setname(Dosfile *fp, char *from)
{
	char *to;

	to = fp-&gt;name;
	for(; *from &amp;&amp; to-fp-&gt;name &lt; 8; from++, to++){
		if(*from == '.'){
			from++;
			break;
		}
		if(*from &gt;= 'a' &amp;&amp; *from &lt;= 'z')
			*to = *from + 'A' - 'a';
		else
			*to = *from;
	}
	while(to - fp-&gt;name &lt; 8)
		*to++ = ' ';
	
	/* from might be 12345678.123: don't save the '.' in ext */
	if(*from == '.')
		from++;

	to = fp-&gt;ext;
	for(; *from &amp;&amp; to-fp-&gt;ext &lt; 3; from++, to++){
		if(*from &gt;= 'a' &amp;&amp; *from &lt;= 'z')
			*to = *from + 'A' - 'a';
		else
			*to = *from;
	}
	while(to-fp-&gt;ext &lt; 3)
		*to++ = ' ';

	chat("name is %8.8s.%3.3s\n", fp-&gt;name, fp-&gt;ext);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

