<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/memory.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/memory.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Size memory and create the kernel page-tables on the fly while doing so.
 * Called from main(), this code should only be run by the bootstrap processor.
 *
 * MemMin is what the bootstrap code in l.s has already mapped;
 * MemMax is the limit of physical memory to scan.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"

#define MEMDEBUG	0

enum {
	MemUPA		= 0,		/* unbacked physical address */
	MemRAM		= 1,		/* physical memory */
	MemUMB		= 2,		/* upper memory block (&lt;16MB) */
	MemReserved	= 3,
	NMemType	= 4,

	KB		= 1024,
};

typedef struct Map Map;
struct Map {
	ulong	size;
	ulong	addr;
};

typedef struct RMap RMap;
struct RMap {
	char*	name;
	Map*	map;
	Map*	mapend;

	Lock;
};

/* 
 * Memory allocation tracking.
 */
static Map mapupa[16];
static RMap rmapupa = {
	"unallocated unbacked physical addresses",
	mapupa,
	&amp;mapupa[nelem(mapupa)-1],
};

static Map mapram[16];
static RMap rmapram = {
	"physical memory",
	mapram,
	&amp;mapram[nelem(mapram)-1],
};

static Map mapumb[64];
static RMap rmapumb = {
	"upper memory block",
	mapumb,
	&amp;mapumb[nelem(mapumb)-1],
};

static Map mapumbrw[16];
static RMap rmapumbrw = {
	"UMB device memory",
	mapumbrw,
	&amp;mapumbrw[nelem(mapumbrw)-1],
};

static void map(ulong base, ulong len, int type);

void
mapprint(RMap *rmap)
{
	Map *mp;

	print("%s\n", rmap-&gt;name);	
	for(mp = rmap-&gt;map; mp-&gt;size; mp++)
		print("\t%8.8luX %8.8luX (%lud)\n", mp-&gt;addr, mp-&gt;addr+mp-&gt;size, mp-&gt;size);
}


void
memdebug(void)
{
	ulong maxpa, maxpa1, maxpa2;

	maxpa = (nvramread(0x18)&lt;&lt;8)|nvramread(0x17);
	maxpa1 = (nvramread(0x31)&lt;&lt;8)|nvramread(0x30);
	maxpa2 = (nvramread(0x16)&lt;&lt;8)|nvramread(0x15);
	print("maxpa = %luX -&gt; %luX, maxpa1 = %luX maxpa2 = %luX\n",
		maxpa, MB+maxpa*KB, maxpa1, maxpa2);

	mapprint(&amp;rmapram);
	mapprint(&amp;rmapumb);
	mapprint(&amp;rmapumbrw);
	mapprint(&amp;rmapupa);
}

void
mapfree(RMap* rmap, ulong addr, ulong size)
{
	Map *mp;
	ulong t;

	if(size &lt;= 0)
		return;

	lock(rmap);
	for(mp = rmap-&gt;map; mp-&gt;addr &lt;= addr &amp;&amp; mp-&gt;size; mp++)
		;

	if(mp &gt; rmap-&gt;map &amp;&amp; (mp-1)-&gt;addr+(mp-1)-&gt;size == addr){
		(mp-1)-&gt;size += size;
		if(addr+size == mp-&gt;addr){
			(mp-1)-&gt;size += mp-&gt;size;
			while(mp-&gt;size){
				mp++;
				(mp-1)-&gt;addr = mp-&gt;addr;
				(mp-1)-&gt;size = mp-&gt;size;
			}
		}
	}
	else{
		if(addr+size == mp-&gt;addr &amp;&amp; mp-&gt;size){
			mp-&gt;addr -= size;
			mp-&gt;size += size;
		}
		else do{
			if(mp &gt;= rmap-&gt;mapend){
				print("mapfree: %s: losing %#luX, %ld\n",
					rmap-&gt;name, addr, size);
				break;
			}
			t = mp-&gt;addr;
			mp-&gt;addr = addr;
			addr = t;
			t = mp-&gt;size;
			mp-&gt;size = size;
			mp++;
		}while(size = t);
	}
	unlock(rmap);
}

ulong
mapalloc(RMap* rmap, ulong addr, int size, int align)
{
	Map *mp;
	ulong maddr, oaddr;

	lock(rmap);
	for(mp = rmap-&gt;map; mp-&gt;size; mp++){
		maddr = mp-&gt;addr;

		if(addr){
			/*
			 * A specific address range has been given:
			 *   if the current map entry is greater then
			 *   the address is not in the map;
			 *   if the current map entry does not overlap
			 *   the beginning of the requested range then
			 *   continue on to the next map entry;
			 *   if the current map entry does not entirely
			 *   contain the requested range then the range
			 *   is not in the map.
			 */
			if(maddr &gt; addr)
				break;
			if(mp-&gt;size &lt; addr - maddr)	/* maddr+mp-&gt;size &lt; addr, but no overflow */
				continue;
			if(addr - maddr &gt; mp-&gt;size - size)	/* addr+size &gt; maddr+mp-&gt;size, but no overflow */
				break;
			maddr = addr;
		}

		if(align &gt; 0)
			maddr = ((maddr+align-1)/align)*align;
		if(mp-&gt;addr+mp-&gt;size-maddr &lt; size)
			continue;

		oaddr = mp-&gt;addr;
		mp-&gt;addr = maddr+size;
		mp-&gt;size -= maddr-oaddr+size;
		if(mp-&gt;size == 0){
			do{
				mp++;
				(mp-1)-&gt;addr = mp-&gt;addr;
			}while((mp-1)-&gt;size = mp-&gt;size);
		}

		unlock(rmap);
		if(oaddr != maddr)
			mapfree(rmap, oaddr, maddr-oaddr);

		return maddr;
	}
	unlock(rmap);

	return 0;
}

/*
 * Allocate from the ram map directly to make page tables.
 * Called by mmuwalk during e820scan.
 */
void*
rampage(void)
{
	ulong m;

	m = mapalloc(&amp;rmapram, 0, BY2PG, BY2PG);
	if(m == 0)
		return nil;
	return KADDR(m);
}

static void
umbexclude(void)
{
	int size;
	ulong addr;
	char *op, *p, *rptr;

	if((p = getconf("umbexclude")) == nil)
		return;

	while(p &amp;&amp; *p != '\0' &amp;&amp; *p != '\n'){
		op = p;
		addr = strtoul(p, &amp;rptr, 0);
		if(rptr == nil || rptr == p || *rptr != '-'){
			print("umbexclude: invalid argument &lt;%s&gt;\n", op);
			break;
		}
		p = rptr+1;

		size = strtoul(p, &amp;rptr, 0) - addr + 1;
		if(size &lt;= 0){
			print("umbexclude: bad range &lt;%s&gt;\n", op);
			break;
		}
		if(rptr != nil &amp;&amp; *rptr == ',')
			*rptr++ = '\0';
		p = rptr;

		mapalloc(&amp;rmapumb, addr, size, 0);
	}
}

static void
umbscan(void)
{
	uchar o[2], *p;

	/*
	 * Scan the Upper Memory Blocks (0xA0000-&gt;0xF0000) for pieces
	 * which aren't used; they can be used later for devices which
	 * want to allocate some virtual address space.
	 * Check for two things:
	 * 1) device BIOS ROM. This should start with a two-byte header
	 *    of 0x55 0xAA, followed by a byte giving the size of the ROM
	 *    in 512-byte chunks. These ROM's must start on a 2KB boundary.
	 * 2) device memory. This is read-write.
	 * There are some assumptions: there's VGA memory at 0xA0000 and
	 * the VGA BIOS ROM is at 0xC0000. Also, if there's no ROM signature
	 * at 0xE0000 then the whole 64KB up to 0xF0000 is theoretically up
	 * for grabs; check anyway.
	 */
	p = KADDR(0xD0000);
	while(p &lt; (uchar*)KADDR(0xE0000)){
		/*
		 * Check for the ROM signature, skip if valid.
		 */
		if(p[0] == 0x55 &amp;&amp; p[1] == 0xAA){
			p += p[2]*512;
			continue;
		}

		/*
		 * Is it writeable? If yes, then stick it in
		 * the UMB device memory map. A floating bus will
		 * return 0xff, so add that to the map of the
		 * UMB space available for allocation.
		 * If it is neither of those, ignore it.
		 */
		o[0] = p[0];
		p[0] = 0xCC;
		o[1] = p[2*KB-1];
		p[2*KB-1] = 0xCC;
		if(p[0] == 0xCC &amp;&amp; p[2*KB-1] == 0xCC){
			p[0] = o[0];
			p[2*KB-1] = o[1];
			mapfree(&amp;rmapumbrw, PADDR(p), 2*KB);
		}
		else if(p[0] == 0xFF &amp;&amp; p[1] == 0xFF)
			mapfree(&amp;rmapumb, PADDR(p), 2*KB);
		p += 2*KB;
	}

	p = KADDR(0xE0000);
	if(p[0] != 0x55 || p[1] != 0xAA){
		p[0] = 0xCC;
		p[64*KB-1] = 0xCC;
		if(p[0] != 0xCC &amp;&amp; p[64*KB-1] != 0xCC)
			mapfree(&amp;rmapumb, PADDR(p), 64*KB);
	}

	umbexclude();
}

enum {
	Pteflags = (1&lt;&lt;12) - 1,
};

void
dumppdb(ulong *pdb)
{
	ulong *pp;

	pdb = (ulong *)((uintptr)pdb &amp; ~Pteflags);
	iprint("pdb at phys %#8.8p:\n", PADDR(pdb));
	for (pp = pdb; pp &lt; pdb + 1024; pp++)
		if (*pp)
			iprint("pdb[%3ld]: %#8.8lux\n", pp - pdb, *pp);
}

void
dumppte(ulong *pdb, int sub, int first)
{
	ulong *pp, *pte;

	pte = KADDR(pdb[sub]);
	pte = (ulong *)((uintptr)pte &amp; ~Pteflags);
	if (PADDR(pte) == 0) {
		iprint("pdb[%d] unmapped\n", sub);
		return;
	}
	iprint("pdb[%d] pte at phys %#8.8p:\n", sub, PADDR(pte));
	for (pp = pte; pp &lt; pte + first; pp++)
		if (*pp)
			iprint("pte[%3ld]: %#8.8lux\n", pp - pte, *pp);
	iprint("...\n");
}

uintptr
mapping(uintptr va)
{
	ulong *pte;

	pte = KADDR(m-&gt;pdb[PDX(va)] &amp; ~Pteflags);
	return pte[PTX(va)] &amp; ~Pteflags;
}

/*
 * adjust the maps and make the mmu mappings match the maps
 */
static void
lowraminit(void)
{
	/*
	 * low memory is in use by bootstrap kernels and ROMs.
	 * MemReserved is untouchable, so use MemRAM.
	 * address zero is special to mapalloc, and thus to map, so avoid it.
	 * we can thus load the new kernel directly at 1MB and up.
	 */
//	map(BY2PG, MB - BY2PG, MemRAM)	/* executing this map call is fatal */
	mapalloc(&amp;rmapram, BY2PG, Mallocbase - BY2PG, 0);

	/*
	 * declare all RAM above Mallocbase to be free.
	 */
	map(Mallocbase, MemMax - Mallocbase, MemRAM);

	/* declare rest of physical address space above RAM to be available */
	map(MemMax, KZERO-MemMax, MemUPA);

	/* force the new mappings to take effect */
	mmuflushtlb(PADDR(m-&gt;pdb));
}

/*
 * add region at physical base of len bytes to map for `type', and
 * set up page tables to map virtual KZERO|base to physical base.
 */
static void
map(ulong base, ulong len, int type)
{
	ulong n, flags, maxkpa;
	
//	iprint("map %.8lux %.8lux %d (", base, base+len, type);
	/*
	 * Split any call crossing MemMin to make below simpler.
	 */
	if(base &lt; MemMin &amp;&amp; len &gt; MemMin-base){
		n = MemMin - base;
		map(base, n, type);
		map(MemMin, len-n, type);
		return;
	}
	
	switch(type){
	case MemRAM:
		mapfree(&amp;rmapram, base, len);
		flags = PTEWRITE|PTEVALID;
		break;
	case MemUMB:
		mapfree(&amp;rmapumb, base, len);
		flags = PTEWRITE|PTEUNCACHED|PTEVALID;
		break;
	case MemUPA:
		mapfree(&amp;rmapupa, base, len);
		flags = 0;
		break;
	default:
	case MemReserved:
		flags = 0;
		break;
	}

	/*
	 * Only map from KZERO to 2^32.
	 */
	if(flags){
		maxkpa = -KZERO;
		if(base &gt;= maxkpa)
			return;
		if(len &gt; maxkpa-base)
			len = maxkpa - base;
		pdbmap(m-&gt;pdb, base|flags, base+KZERO, len);
	}
}

void
meminit(void)
{
	int i, kzsub;
	Map *mp;
	Confmem *cm;
	ulong pa, *pte;
	ulong lost, physpte;

	/* no need to size memory, we don't need much. */
	pte = m-&gt;pdb + BY2PG/BY2WD;		/* see l*.s */

	/* populate pdb with double-mapping of low memory */
	kzsub = ((uintptr)KZERO &gt;&gt; (2*PGSHIFT - 4)) / sizeof(ulong);
	physpte = (uintptr)PADDR(pte);
	for (i = 0; i &lt; LOWPTEPAGES; i++)
		m-&gt;pdb[kzsub + i] = m-&gt;pdb[i] =
			PTEVALID | PTEKERNEL | PTEWRITE | (physpte + i * BY2PG);

	/*
	 * Set special attributes for memory between 640KB and 1MB:
	 *   VGA memory is writethrough;
	 *   BIOS ROM's/UMB's are uncached;
	 * then scan for useful memory.
	 */
	for(pa = 0xA0000; pa &lt; 0xC0000; pa += BY2PG){
		pte = mmuwalk(m-&gt;pdb, (ulong)KADDR(pa), 2, 0);
		*pte |= PTEWT;
	}
	for(pa = 0xC0000; pa &lt; 0x100000; pa += BY2PG){
		pte = mmuwalk(m-&gt;pdb, (ulong)KADDR(pa), 2, 0);
		*pte |= PTEUNCACHED;
	}
	mmuflushtlb(PADDR(m-&gt;pdb));

	umbscan();
	lowraminit();

	/*
	 * Set the conf entries describing banks of allocatable memory.
	 */
	for(i=0; i&lt;nelem(mapram) &amp;&amp; i&lt;nelem(conf.mem); i++){
		mp = &amp;rmapram.map[i];
		cm = &amp;conf.mem[i];
		cm-&gt;base = mp-&gt;addr;
		cm-&gt;npage = mp-&gt;size/BY2PG;
		if (i == 0 &amp;&amp; cm-&gt;npage == 0)
			panic("meminit: no memory in conf.mem");
	}
	lost = 0;
	for(; i&lt;nelem(mapram); i++)
		lost += rmapram.map[i].size;
	if(lost)
		print("meminit - lost %lud bytes\n", lost);

	if(MEMDEBUG)
		memdebug();
}

/*
 * Allocate memory from the upper memory blocks.
 */
ulong
umbmalloc(ulong addr, int size, int align)
{
	ulong a;

	if(a = mapalloc(&amp;rmapumb, addr, size, align))
		return (ulong)KADDR(a);

	return 0;
}

void
umbfree(ulong addr, int size)
{
	mapfree(&amp;rmapumb, PADDR(addr), size);
}

ulong
umbrwmalloc(ulong addr, int size, int align)
{
	ulong a;
	uchar o[2], *p;

	if(a = mapalloc(&amp;rmapumbrw, addr, size, align))
		return(ulong)KADDR(a);

	/*
	 * Perhaps the memory wasn't visible before
	 * the interface is initialised, so try again.
	 */
	if((a = umbmalloc(addr, size, align)) == 0)
		return 0;
	p = (uchar*)a;
	o[0] = p[0];
	p[0] = 0xCC;
	o[1] = p[size-1];
	p[size-1] = 0xCC;
	if(p[0] == 0xCC &amp;&amp; p[size-1] == 0xCC){
		p[0] = o[0];
		p[size-1] = o[1];
		return a;
	}
	umbfree(a, size);

	return 0;
}

void
umbrwfree(ulong addr, int size)
{
	mapfree(&amp;rmapumbrw, PADDR(addr), size);
}

/*
 * Give out otherwise-unused physical address space
 * for use in configuring devices.  Note that unlike upamalloc
 * before it, upaalloc does not map the physical address
 * into virtual memory.  Call vmap to do that.
 */
ulong
upaalloc(int size, int align)
{
	ulong a;

	a = mapalloc(&amp;rmapupa, 0, size, align);
	if(a == 0){
		print("out of physical address space allocating %d\n", size);
		mapprint(&amp;rmapupa);
	}
	return a;
}

void
upafree(ulong pa, int size)
{
	mapfree(&amp;rmapupa, pa, size);
}

void
upareserve(ulong pa, int size)
{
	ulong a;
	
	a = mapalloc(&amp;rmapupa, pa, size, 0);
	if(a != pa){
		/*
		 * This can happen when we're using the E820
		 * map, which might have already reserved some
		 * of the regions claimed by the pci devices.
		 */
	//	print("upareserve: cannot reserve pa=%#.8lux size=%d\n", pa, size);
		if(a != 0)
			mapfree(&amp;rmapupa, a, size);
	}
}

void
memorysummary(void)
{
	memdebug();
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

