<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/parts.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/parts.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * read disk partition tables, intended for early use on systems
 * that don't use (the new) 9load.  borrowed from old 9load.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"pool.h"
#include	"../port/error.h"
#include	"../port/netif.h"
#include	"dosfs.h"
#include	"../port/sd.h"
#include	"iso9660.h"

#define gettokens(l, a, an, del)	getfields(l, a, an, 1, del)

enum {
	Trace	= 0,
	Parttrace = 0,
	Debugboot = 0,

	Maxsec	= 2048,
	Normsec	= 512,			/* mag disks */

	/* from devsd.c */
	PartLOG		= 8,
	NPart		= (1&lt;&lt;PartLOG),
};

typedef struct PSDunit PSDunit;
struct PSDunit {
	SDunit;
	Chan	*ctlc;
	Chan	*data;
};

static uchar *mbrbuf, *partbuf;
static char buf[128], buf2[128];

static void
psdaddpart(PSDunit* unit, char* name, uvlong start, uvlong end)
{
	int len, nw;

	sdaddpart(unit, name, start, end);

	/* update devsd's in-memory partition table. */
	len = snprint(buf, sizeof buf, "part %s %lld %lld\n", name, start, end);
	nw = devtab[unit-&gt;ctlc-&gt;type]-&gt;write(unit-&gt;ctlc, buf, len,
		unit-&gt;ctlc-&gt;offset);
	if (nw != len)
		print("can't update devsd's partition table\n");
	if (Debugboot)
		print("part %s %lld %lld\n", name, start, end);
}

static long
psdread(PSDunit *unit, SDpart *pp, void* va, long len, vlong off)
{
	long l, secsize;
	uvlong bno, nb;

	/*
	 * Check the request is within partition bounds.
	 */
	secsize = unit-&gt;secsize;
	if (secsize == 0)
		panic("psdread: %s: zero sector size", unit-&gt;name);
	bno = off/secsize + pp-&gt;start;
	nb = (off+len+secsize-1)/secsize + pp-&gt;start - bno;
	if(bno+nb &gt; pp-&gt;end)
		nb = pp-&gt;end - bno;
	if(bno &gt;= pp-&gt;end || nb == 0)
		return 0;

	unit-&gt;data-&gt;offset = bno * secsize;
	l = myreadn(unit-&gt;data, va, len);
	if (l &lt; 0)
		return 0;
	return l;
}

static int
sdreadblk(PSDunit *unit, SDpart *part, void *a, vlong off, int mbr)
{
	uchar *b;

	assert(a);			/* sdreadblk */
	if(psdread(unit, part, a, unit-&gt;secsize, off) != unit-&gt;secsize){
		if(Trace)
			print("%s: read %lud at %lld failed\n", unit-&gt;name,
				unit-&gt;secsize, (vlong)part-&gt;start*unit-&gt;secsize+off);
		return -1;
	}
	b = a;
	if(mbr &amp;&amp; (b[0x1FE] != 0x55 || b[0x1FF] != 0xAA)){
		if(Trace)
			print("%s: bad magic %.2ux %.2ux at %lld\n",
				unit-&gt;name, b[0x1FE], b[0x1FF],
				(vlong)part-&gt;start*unit-&gt;secsize+off);
		return -1;
	}
	return 0;
}

/*
 *  read partition table.  The partition table is just ascii strings.
 */
#define MAGIC "plan9 partitions"
static void
oldp9part(PSDunit *unit)
{
	SDpart *pp;
	char *field[3], *line[NPart+1];
	ulong n;
	uvlong start, end;
	int i;
	static SDpart fakepart;

	/*
	 * We prefer partition tables on the second to last sector,
	 * but some old disks use the last sector instead.
	 */

	pp = &amp;fakepart;
	kstrdup(&amp;pp-&gt;name, "partition");
	pp-&gt;start = unit-&gt;sectors - 2;
	pp-&gt;end = unit-&gt;sectors - 1;

	if(Debugboot)
		print("oldp9part %s\n", unit-&gt;name);
	if(sdreadblk(unit, pp, partbuf, 0, 0) &lt; 0)
		return;

	if(strncmp((char*)partbuf, MAGIC, sizeof(MAGIC)-1) != 0) {
		/* not found on 2nd last sector; look on last sector */
		pp-&gt;start++;
		pp-&gt;end++;
		if(sdreadblk(unit, pp, partbuf, 0, 0) &lt; 0)
			return;
		if(strncmp((char*)partbuf, MAGIC, sizeof(MAGIC)-1) != 0)
			return;
		print("%s: using old plan9 partition table on last sector\n", unit-&gt;name);
	}else
		print("%s: using old plan9 partition table on 2nd-to-last sector\n", unit-&gt;name);

	/* we found a partition table, so add a partition partition */
	psdaddpart(unit, pp-&gt;name, pp-&gt;start, pp-&gt;end);

	/*
	 * parse partition table
	 */
	partbuf[unit-&gt;secsize-1] = '\0';
	n = gettokens((char*)partbuf, line, NPart+1, "\n");
	if(n &amp;&amp; strncmp(line[0], MAGIC, sizeof(MAGIC)-1) == 0)
		for(i = 1; i &lt; n; i++){
			if(gettokens(line[i], field, 3, " ") != 3)
				break;
			start = strtoull(field[1], 0, 0);
			end = strtoull(field[2], 0, 0);
			if(start &gt;= end || end &gt; unit-&gt;sectors)
				break;
			psdaddpart(unit, field[0], start, end);
		}
}

static SDpart*
sdfindpart(PSDunit *unit, char *name)
{
	int i;

	if(Parttrace)
		print("findpart %d %s %s: ", unit-&gt;npart, unit-&gt;name, name);
	for(i=0; i&lt;unit-&gt;npart; i++) {
		if(Parttrace)
			print("%s...", unit-&gt;part[i].name);
		if(strcmp(unit-&gt;part[i].name, name) == 0){
			if(Parttrace)
				print("\n");
			return &amp;unit-&gt;part[i];
		}
	}
	if(Parttrace)
		print("not found\n");
	return nil;
}

/*
 * look for a plan 9 partition table on drive `unit' in the second
 * sector (sector 1) of partition `name'.
 * if found, add the partitions defined in the table.
 */
static void
p9part(PSDunit *unit, char *name)
{
	SDpart *p;
	char *field[4], *line[NPart+1];
	uvlong start, end;
	int i, n;

	if(Debugboot)
		print("p9part %s %s\n", unit-&gt;name, name);
	p = sdfindpart(unit, name);
	if(p == nil)
		return;

	if(sdreadblk(unit, p, partbuf, unit-&gt;secsize, 0) &lt; 0)
		return;
	partbuf[unit-&gt;secsize-1] = '\0';

	if(strncmp((char*)partbuf, "part ", 5) != 0)
		return;

	n = gettokens((char*)partbuf, line, NPart+1, "\n");
	if(n == 0)
		return;
	for(i = 0; i &lt; n; i++){
		if(strncmp(line[i], "part ", 5) != 0)
			break;
		if(gettokens(line[i], field, 4, " ") != 4)
			break;
		start = strtoull(field[2], 0, 0);
		end   = strtoull(field[3], 0, 0);
		if(start &gt;= end || end &gt; unit-&gt;sectors)
			break;
		psdaddpart(unit, field[1], p-&gt;start+start, p-&gt;start+end);
	}
}

static int
isdos(int t)
{
	return t==FAT12 || t==FAT16 || t==FATHUGE || t==FAT32 || t==FAT32X;
}

static int
isextend(int t)
{
	return t==EXTEND || t==EXTHUGE || t==LEXTEND;
}

/*
 * Fetch the first dos and all plan9 partitions out of the MBR partition table.
 * We return -1 if we did not find a plan9 partition.
 */
static int
mbrpart(PSDunit *unit)
{
	Dospart *dp;
	uvlong taboffset, start, end;
	uvlong firstxpart, nxtxpart;
	int havedos, i, nplan9;
	char name[10];

	taboffset = 0;
	dp = (Dospart*)&amp;mbrbuf[0x1BE];
	{
		/* get the MBR (allowing for DMDDO) */
		if(sdreadblk(unit, &amp;unit-&gt;part[0], mbrbuf,
		    (vlong)taboffset * unit-&gt;secsize, 1) &lt; 0)
			return -1;
		for(i=0; i&lt;4; i++)
			if(dp[i].type == DMDDO) {
				if(Trace)
					print("DMDDO partition found\n");
				taboffset = 63;
				if(sdreadblk(unit, &amp;unit-&gt;part[0], mbrbuf,
				    (vlong)taboffset * unit-&gt;secsize, 1) &lt; 0)
					return -1;
				i = -1;	/* start over */
			}
	}

	/*
	 * Read the partitions, first from the MBR and then
	 * from successive extended partition tables.
	 */
	nplan9 = 0;
	havedos = 0;
	firstxpart = 0;
	for(;;) {
		if(sdreadblk(unit, &amp;unit-&gt;part[0], mbrbuf,
		    (vlong)taboffset * unit-&gt;secsize, 1) &lt; 0)
			return -1;
		if(Trace) {
			if(firstxpart)
				print("%s ext %llud ", unit-&gt;name, taboffset);
			else
				print("%s mbr ", unit-&gt;name);
		}
		nxtxpart = 0;
		for(i=0; i&lt;4; i++) {
			if(Trace)
				print("dp %d...", dp[i].type);
			start = taboffset+GLONG(dp[i].start);
			end = start+GLONG(dp[i].len);

			if(dp[i].type == PLAN9) {
				if(nplan9 == 0)
					strncpy(name, "plan9", sizeof name);
				else
					snprint(name, sizeof name, "plan9.%d",
						nplan9);
				psdaddpart(unit, name, start, end);
				p9part(unit, name);
				nplan9++;
			}

			/*
			 * We used to take the active partition (and then the first
			 * when none are active).  We have to take the first here,
			 * so that the partition we call ``dos'' agrees with the
			 * partition disk/fdisk calls ``dos''.
			 */
			if(havedos==0 &amp;&amp; isdos(dp[i].type)){
				havedos = 1;
				psdaddpart(unit, "dos", start, end);
			}

			/* nxtxpart is relative to firstxpart (or 0), not taboffset */
			if(isextend(dp[i].type)){
				nxtxpart = start-taboffset+firstxpart;
				if(Trace)
					print("link %llud...", nxtxpart);
			}
		}
		if(Trace)
			print("\n");

		if(!nxtxpart)
			break;
		if(!firstxpart)
			firstxpart = nxtxpart;
		taboffset = nxtxpart;
	}
	return nplan9 ? 0 : -1;
}

/*
 * To facilitate booting from CDs, we create a partition for
 * the FAT filesystem image embedded in a bootable CD.
 */
static int
part9660(PSDunit *unit)
{
	ulong a, n, i, j;
	uchar drecsz;
	uchar *p;
	uchar buf[Maxsec];
	Drec *rootdrec, *drec;
	Voldesc *v;
	static char stdid[] = "CD001\x01";

	if(unit-&gt;secsize == 0)
		unit-&gt;secsize = Cdsec;
	if(unit-&gt;secsize != Cdsec)
		return -1;

	if(psdread(unit, &amp;unit-&gt;part[0], buf, Cdsec, VOLDESC*Cdsec) &lt; 0)
		return -1;
	if(buf[0] != PrimaryIso ||
	    memcmp((char*)buf+1, stdid, sizeof stdid - 1) != 0)
		return -1;

	v = (Voldesc *)buf;
	rootdrec = (Drec *)v-&gt;z.desc.rootdir;
	assert(rootdrec);
	p = rootdrec-&gt;addr;
	a = p[0] | (p[1]&lt;&lt;8) | (p[2]&lt;&lt;16) | (p[3]&lt;&lt;24);
	p = rootdrec-&gt;size;
	n = p[0] | (p[1]&lt;&lt;8) | (p[2]&lt;&lt;16) | (p[3]&lt;&lt;24);
//	print("part9660: read %uld %uld\n", n, a);	/* debugging */

	if(n &lt; Cdsec){
		print("warning: bad boot file size %ld in iso directory", n);
		n = Cdsec;
	}

	drec = nil;
	for(j = 0; j*Cdsec &lt; n; j++){
		if(psdread(unit, &amp;unit-&gt;part[0], buf, Cdsec, (a + j)*Cdsec) &lt; 0)
			return -1;
		for(i = 0; i + j*Cdsec &lt;= n &amp;&amp; i &lt; Cdsec; i += drecsz){
			drec = (Drec *)&amp;buf[i];
			drecsz = drec-&gt;reclen;
			if(drecsz == 0 || drecsz + i &gt; Cdsec)
				break;
			if(cistrncmp("bootdisk.img", (char *)drec-&gt;name, 12) == 0)
				goto Found;
		}
	}
Found:
	if(j*Cdsec &gt;= n || drec == nil)
		return -1;

	p = drec-&gt;addr;
	a = p[0] | (p[1]&lt;&lt;8) | (p[2]&lt;&lt;16) | (p[3]&lt;&lt;24);
	p = drec-&gt;size;
	n = p[0] | (p[1]&lt;&lt;8) | (p[2]&lt;&lt;16) | (p[3]&lt;&lt;24);

	print("found partition %s!9fat; %lud+%lud\n", unit-&gt;name, a, n);
	n /= Cdsec;
	psdaddpart(unit, "9fat", a, a+n);
	return 0;
}

enum {
	NEW = 1&lt;&lt;0,
	OLD = 1&lt;&lt;1
};

/*
 * read unit-&gt;data to look for partition tables.
 * if found, stash partitions in environment and write them to ctl too.
 */
static void
partition(PSDunit *unit)
{
	int type;
	char *p;

	if(unit-&gt;part == 0)
		return;

	if(part9660(unit) == 0)
		return;

	p = getconf("partition");
	if(p != nil &amp;&amp; strncmp(p, "new", 3) == 0)
		type = NEW;
	else if(p != nil &amp;&amp; strncmp(p, "old", 3) == 0)
		type = OLD;
	else
		type = NEW|OLD;

	if(mbrbuf == nil) {
		mbrbuf = malloc(Maxsec);
		partbuf = malloc(Maxsec);
		if(mbrbuf==nil || partbuf==nil) {
			free(mbrbuf);
			free(partbuf);
			partbuf = mbrbuf = nil;
			return;
		}
	}

	/*
	 * there might be no mbr (e.g. on a very large device), so look for
	 * a bare plan 9 partition table if mbrpart fails.
	 */
	if((type &amp; NEW) &amp;&amp; mbrpart(unit) &gt;= 0){
		/* nothing to do */
	}
	else if (type &amp; NEW)
		p9part(unit, "data");
	else if(type &amp; OLD)
		oldp9part(unit);
}

static void
rdgeom(PSDunit *unit)
{
	int n, f, lines;
	char *buf, *p;
	char *line[64], *fld[5];
	char ctl[64];
	static char geom[] = "geometry";

	buf = smalloc(Maxfile + 1);
	strncpy(ctl, unit-&gt;name, sizeof ctl);
	p = strrchr(ctl, '/');
	if (p)
		strcpy(p, "/ctl");		/* was "/data" */
	n = readfile(ctl, buf, Maxfile);
	if (n &lt; 0) {
		print("rdgeom: can't read %s\n", ctl);
		free(buf);
		return;
	}
	buf[n] = 0;

	lines = getfields(buf, line, nelem(line), 0, "\r\n");
	for (f = 0; f &lt; lines; f++)
		if (tokenize(line[f], fld, nelem(fld)) &gt;= 3 &amp;&amp;
		    strcmp(fld[0], geom) == 0)
			break;
	if(f &lt; lines){
		unit-&gt;sectors = strtoull(fld[1], nil, 0);
		unit-&gt;secsize = strtoull(fld[2], nil, 0);
	}
	if (f &gt;= lines || unit-&gt;sectors == 0){
		/* no geometry line, so fake it */
		unit-&gt;secsize = Cdsec;
		unit-&gt;sectors = ~0ull / unit-&gt;secsize;
	}
	if(unit-&gt;secsize == 0)
		print("rdgeom: %s: zero sector size read from ctl file\n",
			unit-&gt;name);
	free(buf);
	unit-&gt;ctlc-&gt;offset = 0;
}

static void
setpartitions(char *name, Chan *ctl, Chan *data)
{
	PSDunit sdunit;
	PSDunit *unit;
	SDpart *part0;

	unit = &amp;sdunit;
	memset(unit, 0, sizeof *unit);
	unit-&gt;ctlc = ctl;
	unit-&gt;data = data;

	unit-&gt;secsize = Normsec;	/* default: won't work for CDs */
	unit-&gt;sectors = ~0ull / unit-&gt;secsize;
	kstrdup(&amp;unit-&gt;name, name);
	rdgeom(unit);
	unit-&gt;part = mallocz(sizeof(SDpart) * SDnpart, 1);
	unit-&gt;npart = SDnpart;

	part0 = &amp;unit-&gt;part[0];
	part0-&gt;end = unit-&gt;sectors - 1;
	kstrdup(&amp;part0-&gt;name, "data");
	part0-&gt;valid = 1;

	mbrbuf = malloc(Maxsec);
	partbuf = malloc(Maxsec);
	partition(unit);
	free(unit-&gt;part);
	unit-&gt;part = nil;
}

/*
 * read disk partition tables so that readnvram via factotum
 * can see them.
 */
int
readparts(char *disk)
{
	Chan *ctl, *data;

	snprint(buf, sizeof buf, "%s/ctl", disk);
	ctl  = namecopen(buf, ORDWR);
	snprint(buf2, sizeof buf2, "%s/data", disk);
	data = namecopen(buf2, OREAD);
	if (ctl != nil &amp;&amp; data != nil)
		setpartitions(buf2, ctl, data);
	cclose(ctl);
	cclose(data);
	return 0;
}

/*
 * Leave partitions around for devsd in next kernel to pick up.
 * (Needed by boot process; more extensive
 * partitioning is done by termrc or cpurc).
 */
void
sdaddconf(SDunit *unit)
{
	int i;
	SDpart *pp;

	/*
	 * If there were no partitions (just data and partition), don't bother.
	 */
	if(unit-&gt;npart &lt;= 1 || (unit-&gt;npart == 2 &amp;&amp;
	    strcmp(unit-&gt;part[1].name, "partition") == 0))
		return;

	addconf("%spart=", unit-&gt;name);
	/* skip 0, which is "data" */
	for(i = 1, pp = &amp;unit-&gt;part[i]; i &lt; unit-&gt;npart; i++, pp++)
		if (pp-&gt;valid)
			addconf("%s%s %lld %lld", i==1 ? "" : "/", pp-&gt;name,
				pp-&gt;start, pp-&gt;end);
	addconf("\n");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

