<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/sdbios.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/sdbios.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * read-only sd driver for BIOS devices with partitions.
 * will probably only work with bootstrap kernels, as the normal kernel
 * deals directly with the clock and disk controllers, which seems
 * to confuse many BIOSes.
 *
 * devbios must be initialised first and no disks may be accessed
 * via non-BIOS means.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"pool.h"
#include	"../port/error.h"
#include	"../port/netif.h"
#include	"../port/sd.h"
#include	"dosfs.h"
#include	&lt;disk.h&gt;

long	biosread0(Bootfs *, void *, long);
vlong	biosseek(Bootfs *fs, vlong off);

extern SDifc sdbiosifc;
extern int biosndevs;

uchar *
putbeul(ulong ul, uchar *p)
{
	*p++ = ul &gt;&gt; 24;
	*p++ = ul &gt;&gt; 16;
	*p++ = ul &gt;&gt; 8;
	*p++ = ul;
	return p;
}

uchar *
putbeuvl(uvlong uvl, uchar *p)
{
	*p++ = uvl &gt;&gt; 56;
	*p++ = uvl &gt;&gt; 48;
	*p++ = uvl &gt;&gt; 40;
	*p++ = uvl &gt;&gt; 32;
	*p++ = uvl &gt;&gt; 24;
	*p++ = uvl &gt;&gt; 16;
	*p++ = uvl &gt;&gt; 8;
	*p++ = uvl;
	return p;
}

int
biosverify(SDunit* )
{
	if (!biosinited)
		return 0;
	return 1;
}

int
biosonline(SDunit* unit)
{
	uint subno = unit-&gt;subno;

	if (!biosinited)
		panic("sdbios: biosonline: sdbios not inited");
	if (unit == nil)
		return 0;
	unit-&gt;secsize = biossectsz(subno);
	if (unit-&gt;secsize &lt;= 0) {
		print("sdbios: biosonline: implausible sector size on medium\n");
		return 0;
	}
	unit-&gt;sectors = biossize(subno);
	if (unit-&gt;sectors &lt;= 0) {
		unit-&gt;sectors = 0;
		print("sdbios: biosonline: no sectors on medium\n");
		return 0;
	}
	return 1;
}

static int
biosrio(SDreq* r)
{
	int nb;
	long got;
	vlong off;
	uchar *p;
	Bootfs fs;			/* just for fs-&gt;dev, which is zero */
	SDunit *unit;

	if (!biosinited)
		return SDeio;
	unit = r-&gt;unit;
	/*
	 * Most SCSI commands can be passed unchanged except for
	 * the padding on the end. The few which require munging
	 * are not used internally. Mode select/sense(6) could be
	 * converted to the 10-byte form but it's not worth the
	 * effort. Read/write(6) are easy.
	 */
	r-&gt;rlen = 0;
	r-&gt;status = SDok;
	switch(r-&gt;cmd[0]){
	case ScmdRead:
	case ScmdExtread:
		if (r-&gt;cmd[0] == ScmdRead)
			panic("biosrio: ScmdRead read op");
		off = r-&gt;cmd[2]&lt;&lt;24 | r-&gt;cmd[3]&lt;&lt;16 | r-&gt;cmd[4]&lt;&lt;8 | r-&gt;cmd[5];
		nb =  r-&gt;cmd[7]&lt;&lt;8  | r-&gt;cmd[8];	/* often 4 */
		USED(nb);		/* is nb*unit-&gt;secsize == r-&gt;dlen? */
		memset(&amp;fs, 0, sizeof fs);
		biosseek(&amp;fs, off * unit-&gt;secsize);
		got = biosread0(&amp;fs, r-&gt;data, r-&gt;dlen);
		if (got &lt; 0)
			r-&gt;status = SDeio;
		else
			r-&gt;rlen = got;
		break;
	case ScmdWrite:
	case ScmdExtwrite:
		r-&gt;status = SDeio;	/* boot programs don't write */
		break;

		/*
		 * Read capacity returns the LBA of the last sector.
		 */
	case ScmdRcapacity:
		p = putbeul(r-&gt;unit-&gt;sectors - 1, r-&gt;data);
		r-&gt;data = putbeul(r-&gt;unit-&gt;secsize, p);
		return SDok;
	case ScmdRcapacity16:
		p = putbeuvl(r-&gt;unit-&gt;sectors - 1, r-&gt;data);
		r-&gt;data = putbeul(r-&gt;unit-&gt;secsize, p);
		return SDok;
	/* ignore others */
	}
	return r-&gt;status;
}

/* this is called between biosreset and biosinit */
static SDev*
biospnp(void)
{
	SDev *sdev;

	if (!biosinited)
		panic("sdbios: biospnp: bios devbios not yet inited");
	if((sdev = malloc(sizeof(SDev))) != nil) {
		sdev-&gt;ifc = &amp;sdbiosifc;
		sdev-&gt;idno = 'B';
		sdev-&gt;nunit = biosndevs;
		iprint("sdbios: biospnp: %d unit(s) at sd%C0\n",
			sdev-&gt;nunit, sdev-&gt;idno);
	}
	return sdev;
}

SDifc sdbiosifc = {
	"bios",				/* name */

	biospnp,			/* pnp */
	nil,				/* legacy */
	nil,				/* enable */
	nil,				/* disable */

	biosverify,			/* verify */
	biosonline,			/* online */
	biosrio,			/* rio */
	nil,				/* rctl */
	nil,				/* wctl */

	scsibio,			/* bio */
	nil,				/* probe */
	nil,				/* clear */
	nil,				/* rtopctl */
	nil,				/* wtopctl */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

