<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/debugalloc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/debugalloc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"pool.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

#define left	u.s.bhl
#define right	u.s.bhr
#define fwd	u.s.bhf
#define prev	u.s.bhv
#define parent	u.s.bhp

typedef struct Bhdr	Bhdr;

struct Bhdr {
	ulong	magic;
	ulong	size;
};
enum {
	NOT_MAGIC = 0xdeadfa11,
};

struct Pool
{
	char*	name;
	ulong	maxsize;
	int	quanta;
	int	chunk;
	ulong	cursize;
	ulong	arenasize;
	ulong	hw;
	Lock	l;
	Bhdr*	root;
	Bhdr*	chain;
	int	nalloc;
	int	nfree;
	int	nbrk;
	int	lastfree;
	void	(*move)(void*, void*);
};

struct
{
	int	n;
	Pool	pool[MAXPOOL];
	Lock	l;
} table = {
	2,
	{
		{ "Main",	 4*1024*1024, 31,  128*1024 },
		{ "Image",	 16*1024*1024, 31, 2*1024*1024 },
	}
};

Pool*	mainmem = &amp;table.pool[0];
Pool*	imagmem = &amp;table.pool[1];

int	poolcompact(Pool*);

Bhdr*
poolchain(Pool *p)
{
	return p-&gt;chain;
}

void
pooldel(Pool *p, Bhdr *t)
{
	Bhdr *s, *f, *rp, *q;

	if(t-&gt;parent == nil &amp;&amp; p-&gt;root != t) {
		t-&gt;prev-&gt;fwd = t-&gt;fwd;
		t-&gt;fwd-&gt;prev = t-&gt;prev;
		return;
	}

	if(t-&gt;fwd != t) {
		f = t-&gt;fwd;
		s = t-&gt;parent;
		f-&gt;parent = s;
		if(s == nil)
			p-&gt;root = f;
		else {
			if(s-&gt;left == t)
				s-&gt;left = f;
			else
				s-&gt;right = f;
		}

		rp = t-&gt;left;
		f-&gt;left = rp;
		if(rp != nil)
			rp-&gt;parent = f;
		rp = t-&gt;right;
		f-&gt;right = rp;
		if(rp != nil)
			rp-&gt;parent = f;

		t-&gt;prev-&gt;fwd = t-&gt;fwd;
		t-&gt;fwd-&gt;prev = t-&gt;prev;
		return;
	}

	if(t-&gt;left == nil)
		rp = t-&gt;right;
	else {
		if(t-&gt;right == nil)
			rp = t-&gt;left;
		else {
			f = t;
			rp = t-&gt;right;
			s = rp-&gt;left;
			while(s != nil) {
				f = rp;
				rp = s;
				s = rp-&gt;left;
			}
			if(f != t) {
				s = rp-&gt;right;
				f-&gt;left = s;
				if(s != nil)
					s-&gt;parent = f;
				s = t-&gt;right;
				rp-&gt;right = s;
				if(s != nil)
					s-&gt;parent = rp;
			}
			s = t-&gt;left;
			rp-&gt;left = s;
			s-&gt;parent = rp;
		}
	}
	q = t-&gt;parent;
	if(q == nil)
		p-&gt;root = rp;
	else {
		if(t == q-&gt;left)
			q-&gt;left = rp;
		else
			q-&gt;right = rp;
	}
	if(rp != nil)
		rp-&gt;parent = q;
}

void
pooladd(Pool *p, Bhdr *q)
{
	int size;
	Bhdr *tp, *t;

	q-&gt;magic = MAGIC_F;

	q-&gt;left = nil;
	q-&gt;right = nil;
	q-&gt;parent = nil;
	q-&gt;fwd = q;
	q-&gt;prev = q;

	t = p-&gt;root;
	if(t == nil) {
		p-&gt;root = q;
		return;
	}

	size = q-&gt;size;

	tp = nil;
	while(t != nil) {
		if(size == t-&gt;size) {
			q-&gt;fwd = t-&gt;fwd;
			q-&gt;fwd-&gt;prev = q;
			q-&gt;prev = t;
			t-&gt;fwd = q;
			return;
		}
		tp = t;
		if(size &lt; t-&gt;size)
			t = t-&gt;left;
		else
			t = t-&gt;right;
	}

	q-&gt;parent = tp;
	if(size &lt; tp-&gt;size)
		tp-&gt;left = q;
	else
		tp-&gt;right = q;
}

void*
poolalloc(Pool *p, int size)
{
	Bhdr *q, *t;
	int alloc, ldr, ns, frag;

	if(size &lt; 0 || size &gt;= 1024*1024*1024)	/* for sanity and to avoid overflow */
		return nil;
	size = (size + BHDRSIZE + p-&gt;quanta) &amp; ~(p-&gt;quanta);

	ilock(&amp;p-&gt;l);
	p-&gt;nalloc++;

	t = p-&gt;root;
	q = nil;
	while(t) {
		if(t-&gt;size == size) {
			pooldel(p, t);
			t-&gt;magic = MAGIC_A;
			p-&gt;cursize += t-&gt;size;
			if(p-&gt;cursize &gt; p-&gt;hw)
				p-&gt;hw = p-&gt;cursize;
			iunlock(&amp;p-&gt;l);
			return B2D(t);
		}
		if(size &lt; t-&gt;size) {
			q = t;
			t = t-&gt;left;
		}
		else
			t = t-&gt;right;
	}
	if(q != nil) {
		pooldel(p, q);
		q-&gt;magic = MAGIC_A;
		frag = q-&gt;size - size;
		if(frag &lt; (size&gt;&gt;2)) {
			p-&gt;cursize += q-&gt;size;
			if(p-&gt;cursize &gt; p-&gt;hw)
				p-&gt;hw = p-&gt;cursize;
			iunlock(&amp;p-&gt;l);
			return B2D(q);
		}
		/* Split */
		ns = q-&gt;size - size;
		q-&gt;size = size;
		B2T(q)-&gt;hdr = q;
		t = B2NB(q);
		t-&gt;size = ns;
		B2T(t)-&gt;hdr = t;
		pooladd(p, t);
		p-&gt;cursize += q-&gt;size;
		if(p-&gt;cursize &gt; p-&gt;hw)
			p-&gt;hw = p-&gt;cursize;
		iunlock(&amp;p-&gt;l);
		return B2D(q);
	}

	ns = p-&gt;chunk;
	if(size &gt; ns)
		ns = size;
	ldr = p-&gt;quanta+1;

	alloc = ns+ldr+sizeof(t-&gt;magic);
	p-&gt;arenasize += alloc;
	if(p-&gt;arenasize &gt; p-&gt;maxsize) {
		p-&gt;arenasize -= alloc;

		if(poolcompact(p)) {
			iunlock(&amp;p-&gt;l);
			return poolalloc(p, size);
		}

		iunlock(&amp;p-&gt;l);
		print("%s arena too large: size %d cursize %lud arenasize %lud maxsize %lud\n",
			 p-&gt;name, size, p-&gt;cursize, p-&gt;arenasize, p-&gt;maxsize);
		return nil;
	}

	p-&gt;nbrk++;
	t = xalloc(alloc);
	if(t == nil) {
		iunlock(&amp;p-&gt;l);
		return nil;
	}

	t-&gt;magic = MAGIC_E;		/* Make a leader */
	t-&gt;size = ldr;
	t-&gt;csize = ns+ldr;
	t-&gt;clink = p-&gt;chain;
	p-&gt;chain = t;
	B2T(t)-&gt;hdr = t;
	t = B2NB(t);

	t-&gt;magic = MAGIC_A;		/* Make the block we are going to return */
	t-&gt;size = size;
	B2T(t)-&gt;hdr = t;
	q = t;

	ns -= size;			/* Free the rest */
	if(ns &gt; 0) {
		q = B2NB(t);
		q-&gt;size = ns;
		B2T(q)-&gt;hdr = q;
		pooladd(p, q);
	}
	B2NB(q)-&gt;magic = MAGIC_E;	/* Mark the end of the chunk */

	p-&gt;cursize += t-&gt;size;
	if(p-&gt;cursize &gt; p-&gt;hw)
		p-&gt;hw = p-&gt;cursize;
	iunlock(&amp;p-&gt;l);
	return B2D(t);
}

void
poolfree(Pool *p, void *v)
{
	Bhdr *b, *c;

	D2B(b, v);

	ilock(&amp;p-&gt;l);
	p-&gt;nfree++;
	p-&gt;cursize -= b-&gt;size;

	c = B2NB(b);
	if(c-&gt;magic == MAGIC_F) {	/* Join forward */
		pooldel(p, c);
		c-&gt;magic = 0;
		b-&gt;size += c-&gt;size;
		B2T(b)-&gt;hdr = b;
	}

	c = B2PT(b)-&gt;hdr;
	if(c-&gt;magic == MAGIC_F) {	/* Join backward */
		pooldel(p, c);
		b-&gt;magic = 0;
		c-&gt;size += b-&gt;size;
		b = c;
		B2T(b)-&gt;hdr = b;
	}

	pooladd(p, b);
	iunlock(&amp;p-&gt;l);
}

int
poolread(char *va, int count, ulong offset)
{
	Pool *p;
	int n, i, signed_off;

	n = 0;
	signed_off = offset;
	for(i = 0; i &lt; table.n; i++) {
		p = &amp;table.pool[i];
		n += snprint(va+n, count-n, "%11lud %11lud %11lud %11d %11d %11d %s\n",
			p-&gt;cursize,
			p-&gt;maxsize,
			p-&gt;hw,
			p-&gt;nalloc,
			p-&gt;nfree,
			p-&gt;nbrk,
			p-&gt;name);

		if(signed_off &gt; 0) {
			signed_off -= n;
			if(signed_off &lt; 0) {
				memmove(va, va+n+signed_off, -signed_off);
				n = -signed_off;
			}
			else
				n = 0;
		}

	}
	return n;
}

Lock pcxlock;
struct {
	ulong	n;
	ulong	pc;
} pcx[1024];

static void
remember(ulong pc, void *v)
{
	Bhdr *b;
	int i;

	if(v == nil)
		return;

	D2B(b, v);
	if((b-&gt;size&gt;&gt;5) != 2)
		return;

	ilock(&amp;pcxlock);
	B2T(b)-&gt;pad = 0;
	for(i = 0; i &lt; 1024; i++)
		if(pcx[i].pc == pc || pcx[i].pc == 0){
			pcx[i].pc = pc;
			pcx[i].n++;
			B2T(b)-&gt;pad = i;
			break;
		}
	iunlock(&amp;pcxlock);
}

static void
forget(void *v)
{
	Bhdr *b;

	if(v == nil)
		return;

	D2B(b, v);
	if((b-&gt;size&gt;&gt;5) != 2)
		return;

	ilock(&amp;pcxlock);
	pcx[B2T(b)-&gt;pad].n--;
	iunlock(&amp;pcxlock);
}

void*
malloc(ulong size)
{
	void *v;

	v = poolalloc(mainmem, size);
remember(getcallerpc(&amp;size), v);
	if(v != nil)
		memset(v, 0, size);
	return v;
}

void*
smalloc(ulong size)
{
	void *v;

	for(;;) {
		v = poolalloc(mainmem, size);
remember(getcallerpc(&amp;size), v);
		if(v != nil)
			break;
		tsleep(&amp;up-&gt;sleep, return0, 0, 100);
	}
	memset(v, 0, size);
	return v;
}

void*
mallocz(ulong size, int clr)
{
	void *v;

	v = poolalloc(mainmem, size);
remember(getcallerpc(&amp;size), v);
	if(clr &amp;&amp; v != nil)
		memset(v, 0, size);
	return v;
}

void
free(void *v)
{
	Bhdr *b;

	if(v != nil) {
forget(v);
		D2B(b, v);
		poolfree(mainmem, v);
	}
}

void*
realloc(void *v, ulong size)
{
	Bhdr *b;
	void *nv;
	int osize;

	if(v == nil)
		return malloc(size);

	D2B(b, v);

	osize = b-&gt;size - BHDRSIZE;
	if(osize &gt;= size)
		return v;

	nv = poolalloc(mainmem, size);
remember(getcallerpc(&amp;v), nv);
	if(nv != nil) {
		memmove(nv, v, osize);
		free(v);
	}
	return nv;
}

int
msize(void *v)
{
	Bhdr *b;

	D2B(b, v);
	return b-&gt;size - BHDRSIZE;
}

void*
calloc(ulong n, ulong szelem)
{
	return malloc(n*szelem);
}

/*
void
pooldump(Bhdr *b, int d, int c)
{
	Bhdr *t;

	if(b == nil)
		return;

	print("%.8lux %.8lux %.8lux %c %4d %d (f %.8lux p %.8lux)\n",
		b, b-&gt;left, b-&gt;right, c, d, b-&gt;size, b-&gt;fwd, b-&gt;prev);
	d++;
	for(t = b-&gt;fwd; t != b; t = t-&gt;fwd)
		print("\t%.8lux %.8lux %.8lux\n", t, t-&gt;prev, t-&gt;fwd);
	pooldump(b-&gt;left, d, 'l');
	pooldump(b-&gt;right, d, 'r');
}


void
poolshow(void)
{
	int i;

	for(i = 0; i &lt; table.n; i++) {
		print("Arena: %s root=%.8lux\n", table.pool[i].name, table.pool[i].root);
		pooldump(table.pool[i].root, 0, 'R');
	}
}
*/

void
poolsummary(void)
{
	int i;

	for(i = 0; i &lt; table.n; i++)
		print("Arena: %s cursize=%lud; maxsize=%lud\n",
			table.pool[i].name,
			table.pool[i].cursize,
			table.pool[i].maxsize);
}

/*
void
pooldump(Pool *p)
{
	Bhdr *b, *base, *limit, *ptr;

	b = p-&gt;chain;
	if(b == nil)
		return;
	base = b;
	ptr = b;
	limit = B2LIMIT(b);

	while(base != nil) {
		print("\tbase #%.8lux ptr #%.8lux", base, ptr);
		if(ptr-&gt;magic == MAGIC_A)
			print("\tA%.5d\n", ptr-&gt;size);
		else if(ptr-&gt;magic == MAGIC_E)
			print("\tE\tL#%.8lux\tS#%.8lux\n", ptr-&gt;clink, ptr-&gt;csize);
		else
			print("\tF%.5d\tL#%.8lux\tR#%.8lux\tF#%.8lux\tP#%.8lux\tT#%.8lux\n",
				ptr-&gt;size, ptr-&gt;left, ptr-&gt;right, ptr-&gt;fwd, ptr-&gt;prev, ptr-&gt;parent);
		ptr = B2NB(ptr);
		if(ptr &gt;= limit) {
			print("link to #%.8lux\n", base-&gt;clink);
			base = base-&gt;clink;
			if(base == nil)
				break;
			ptr = base;
			limit = B2LIMIT(base);
		}
	}
	return;
}
*/

void
poolsetcompact(Pool *p, void (*move)(void*, void*))
{
	p-&gt;move = move;
}

void
poolsetparam(char *name, ulong maxsize, int quanta, int chunk)
{
	Pool *p;
	int i;

	for(i=0; i&lt;table.n; i++){
		p = &amp;table.pool[i];
		if(strcmp(name, p-&gt;name) == 0){
			if(maxsize)
				p-&gt;maxsize = maxsize;
			if(quanta)
				p-&gt;quanta = quanta;
			if(chunk)
				p-&gt;chunk = chunk;
			return;
		}
	}
}

int
poolcompact(Pool *pool)
{
	Bhdr *base, *limit, *ptr, *end, *next;
	int compacted, recov, nb;

	if(pool-&gt;move == nil || pool-&gt;lastfree == pool-&gt;nfree)
		return 0;

	pool-&gt;lastfree = pool-&gt;nfree;

	base = pool-&gt;chain;
	ptr = B2NB(base);	/* First Block in arena has clink */
	limit = B2LIMIT(base);
	compacted = 0;

	pool-&gt;root = nil;
	end = ptr;
	recov = 0;
	while(base != nil) {
		next = B2NB(ptr);
		if(ptr-&gt;magic == MAGIC_A) {
			if(ptr != end) {
				memmove(end, ptr, ptr-&gt;size);
				pool-&gt;move(B2D(ptr), B2D(end));
				recov = (uchar*)ptr - (uchar*)end;
				compacted = 1;
			}
			end = B2NB(end);
		}
		if(next &gt;= limit) {
			nb = (uchar*)limit - (uchar*)end;
			//print("recovered %d bytes\n", recov);
			//print("%d bytes at end\n", nb);
			USED(recov);
			if(nb &gt; 0){
				if(nb &lt; pool-&gt;quanta+1)
					panic("poolcompact: leftover too small\n");
				end-&gt;size = nb;
				pooladd(pool, end);
			}
			base = base-&gt;clink;
			if(base == nil)
				break;
			ptr = B2NB(base);
			end = ptr;	/* could do better by copying between chains */
			limit = B2LIMIT(base);
			recov = 0;
		} else
			ptr = next;
	}

	return compacted;
}

int
recur(Bhdr *t)
{
	if(t == 0)
		return 1;
	if((uintptr)t &lt; KZERO || (uintptr)t - KZERO &gt; 0x10000000)
		return 0;
	return recur(t-&gt;right) &amp;&amp; recur(t-&gt;left);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

