<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devaoe.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devaoe.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *	© 2005-2010 coraid
 *	ATA-over-Ethernet (AoE) storage initiator
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"
#include "../port/netif.h"
#include "etherif.h"
#include "../ip/ip.h"
#include "../port/aoe.h"

#pragma	varargck argpos	eventlog	1

#define dprint(...)	if(debug) eventlog(__VA_ARGS__); else USED(debug);
#define uprint(...)	snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, __VA_ARGS__);

enum {
	Maxunits	= 0xff,
	Maxframes	= 128,
	Ndevlink	= 6,
	Nea		= 6,
	Nnetlink	= 6,
};

#define TYPE(q)		((ulong)(q).path &amp; 0xf)
#define UNIT(q)		(((ulong)(q).path&gt;&gt;4) &amp; 0xff)
#define L(q)		(((ulong)(q).path&gt;&gt;12) &amp; 0xf)
#define QID(u, t) 	((u)&lt;&lt;4 | (t))
#define Q3(l, u, t)	((l)&lt;&lt;8 | QID(u, t))
#define UP(d)		((d)-&gt;flag &amp; Dup)
/*
 * would like this to depend on the chan (srb).
 * not possible in the current structure.
 */
#define Nofail(d, s)	((d)-&gt;flag &amp; Dnofail)

#define	MS2TK(t)	((t)/MS2HZ)

enum {
	Qzero,
	Qtopdir		= 1,
	Qtopbase,
	Qtopctl		= Qtopbase,
	Qtoplog,
	Qtopend,

	Qunitdir,
	Qunitbase,
	Qctl		= Qunitbase,
	Qdata,
	Qconfig,
	Qident,

	Qdevlinkdir,
	Qdevlinkbase,
	Qdevlink	= Qdevlinkbase,
	Qdevlinkend,

	Qtopfiles	= Qtopend-Qtopbase,
	Qdevlinkfiles	= Qdevlinkend-Qdevlinkbase,

	Eventlen 	= 256,
	Nevents 	= 64,			/* must be power of 2 */

	Fread		= 0,
	Fwrite,
	Tfree		= -1,
	Tmgmt,

	/*
	 * round trip bounds, timeouts, in ticks.
	 * timeouts should be long enough that rebooting
	 * the coraid (which usually takes under two minutes)
	 * doesn't trigger a timeout.
	 */
	Rtmax		= MS2TK(320),
	Rtmin		= MS2TK(20),
	Maxreqticks	= 4*60*HZ,		/* was 45*HZ */

	Dbcnt		= 1024,

	Crd		= 0x20,
	Crdext		= 0x24,
	Cwr		= 0x30,
	Cwrext		= 0x34,
	Cid		= 0xec,
};

enum {
	Read,
	Write,
};

/*
 * unified set of flags
 * a Netlink + Aoedev most both be jumbo capable
 * to send jumbograms to that interface.
 */
enum {
	/* sync with ahci.h */
	Dllba 	= 1&lt;&lt;0,
	Dsmart	= 1&lt;&lt;1,
	Dpower	= 1&lt;&lt;2,
	Dnop	= 1&lt;&lt;3,
	Datapi	= 1&lt;&lt;4,
	Datapi16= 1&lt;&lt;5,

	/* aoe specific */
	Dup	= 1&lt;&lt;6,
	Djumbo	= 1&lt;&lt;7,
	Dnofail	= 1&lt;&lt;8,
};

static char *flagname[] = {
	"llba",
	"smart",
	"power",
	"nop",
	"atapi",
	"atapi16",

	"up",
	"jumbo",
	"nofail",
};

typedef struct {
	ushort	flag;
	uint	lostjumbo;
	int	datamtu;

	Chan	*cc;
	Chan	*dc;
	Chan	*mtu;		/* open early to prevent bind issues. */
	char	path[Maxpath];
	uchar	ea[Eaddrlen];
} Netlink;

typedef struct {
	Netlink	*nl;
	int	nea;
	ulong	eaidx;
	uchar	eatab[Nea][Eaddrlen];
	ulong	npkt;
	ulong	resent;
	ushort	flag;

	ulong	rttavg;
	ulong	mintimer;
} Devlink;

typedef struct Srb Srb;
struct Srb {
	Rendez;
	Srb	*next;
	int	shared;	/* Srb shared with kproc (don't free) */
	ulong	ticksent;
	ulong	len;
	vlong	sector;
	short	write;
	short	nout;
	char	*error;
	void	*dp;
	void	*data;
};

typedef struct {
	int	tag;
	ulong	bcnt;
	ulong	dlen;
	vlong	lba;
	ulong	ticksent;
	int	nhdr;
	uchar	hdr[ETHERMINTU];
	void	*dp;
	Devlink	*dl;
	Netlink	*nl;
	int	eaidx;
	Srb	*srb;
} Frame;

typedef struct Aoedev Aoedev;
struct Aoedev {
	QLock;
	Aoedev	*next;

	ulong	vers;

	int	ndl;
	ulong	dlidx;
	Devlink	*dl;
	Devlink	dltab[Ndevlink];

	ushort	fwver;
	ushort	flag;
	int	nopen;
	int	major;
	int	minor;
	int	unit;
	int	lasttag;
	int	nframes;
	Frame	*frames;
	vlong	bsize;
	vlong	realbsize;

	uint	maxbcnt;
	ushort	nout;
	ushort	maxout;
	ulong	lastwadj;
	Srb	*head;
	Srb	*tail;
	Srb	*inprocess;

	/* magic numbers 'R' us */
	char	serial[20+1];
	char	firmware[8+1];
	char	model[40+1];
	int	nconfig;
	uchar	config[1024];
	uchar	ident[512];
};

#pragma	varargck type	"æ"	Aoedev*

static struct {
	Lock;
	QLock;
	Rendez;
	char	buf[Eventlen*Nevents];
	char	*rp;
	char	*wp;
} events;

static struct {
	RWlock;
	int	nd;
	Aoedev	*d;
} devs;

static struct {
	Lock;
	int	reader[Nnetlink];	/* reader is running. */
	Rendez	rendez[Nnetlink];	/* confirm exit. */
	Netlink	nl[Nnetlink];
} netlinks;

extern Dev 	aoedevtab;
static Ref 	units;
static Ref	drivevers;
static int	debug;
static int	autodiscover	= 1;
static int	rediscover;

static Srb*
srballoc(ulong sz)
{
	Srb *srb;

	srb = malloc(sizeof *srb+sz);
	if(srb == nil)
		error(Enomem);
	srb-&gt;dp = srb-&gt;data = srb+1;
	srb-&gt;ticksent = MACHP(0)-&gt;ticks;
	srb-&gt;shared = 0;
	return srb;
}

static Srb*
srbkalloc(void *db, ulong)
{
	Srb *srb;

	srb = malloc(sizeof *srb);
	if(srb == nil)
		error(Enomem);
	srb-&gt;dp = srb-&gt;data = db;
	srb-&gt;ticksent = MACHP(0)-&gt;ticks;
	srb-&gt;shared = 0;
	return srb;
}

static void
srbfree(Srb *srb)
{
	while(srb-&gt;shared)
		sched();
	free(srb);
}

static void
srberror(Srb *srb, char *s)
{
	srb-&gt;error = s;
	srb-&gt;nout--;
	if(srb-&gt;nout == 0)
		wakeup(srb);
}

static void
frameerror(Aoedev *d, Frame *f, char *s)
{
	Srb *srb;

	srb = f-&gt;srb;
	if(f-&gt;tag == Tfree || !srb)
		return;
	f-&gt;srb = nil;
	f-&gt;tag = Tfree;		/* don't get fooled by way-slow responses */
	srberror(srb, s);
	d-&gt;nout--;
}

static char*
unitname(Aoedev *d)
{
	uprint("%d.%d", d-&gt;major, d-&gt;minor);
	return up-&gt;genbuf;
}

static int
eventlogready(void*)
{
	return *events.rp;
}

static long
eventlogread(void *a, long n)
{
	int len;
	char *p, *buf;

	buf = smalloc(Eventlen);
	qlock(&amp;events);
	lock(&amp;events);
	p = events.rp;
	len = *p;
	if(len == 0){
		n = 0;
		unlock(&amp;events);
	} else {
		if(n &gt; len)
			n = len;
		/* can't move directly into pageable space with events lock held */
		memmove(buf, p+1, n);
		*p = 0;
		events.rp = p += Eventlen;
		if(p &gt;= events.buf + sizeof events.buf)
			events.rp = events.buf;
		unlock(&amp;events);

		/* the concern here is page faults in memmove below */
		if(waserror()){
			free(buf);
			qunlock(&amp;events);
			nexterror();
		}
		memmove(a, buf, n);
		poperror();
	}
	free(buf);
	qunlock(&amp;events);
	return n;
}

static int
eventlog(char *fmt, ...)
{
	int dragrp, n;
	char *p;
	va_list arg;

	lock(&amp;events);
	p = events.wp;
	dragrp = *p++;
	va_start(arg, fmt);
	n = vsnprint(p, Eventlen-1, fmt, arg);
	*--p = n;
	p = events.wp += Eventlen;
	if(p &gt;= events.buf + sizeof events.buf)
		p = events.wp = events.buf;
	if(dragrp)
		events.rp = p;
	unlock(&amp;events);
	wakeup(&amp;events);
	return n;
}

static int
eventcount(void)
{
	int n;

	lock(&amp;events);
	if(*events.rp == 0)
		n = 0;
	else
		n = (events.wp - events.rp) &amp; (Nevents - 1);
	unlock(&amp;events);
	return n/Eventlen;
}

static int
tsince(int tag)
{
	int n;

	n = MACHP(0)-&gt;ticks &amp; 0xffff;
	n -= tag &amp; 0xffff;
	if(n &lt; 0)
		n += 1&lt;&lt;16;
	return n;
}

static int
newtag(Aoedev *d)
{
	int t;

	do {
		t = ++d-&gt;lasttag &lt;&lt; 16;
		t |= MACHP(0)-&gt;ticks &amp; 0xffff;
	} while (t == Tfree || t == Tmgmt);
	return t;
}

static void
downdev(Aoedev *d, char *err)
{
	Frame *f, *e;

	d-&gt;flag &amp;= ~Dup;
	f = d-&gt;frames;
	e = f + d-&gt;nframes;
	for(; f &lt; e; f-&gt;tag = Tfree, f-&gt;srb = nil, f++)
		frameerror(d, f, Eaoedown);
	d-&gt;inprocess = nil;
	eventlog("%æ: removed; %s\n", d, err);
}

static Block*
allocfb(Frame *f)
{
	int len;
	Block *b;

	len = f-&gt;nhdr + f-&gt;dlen;
	if(len &lt; ETHERMINTU)
		len = ETHERMINTU;
	b = allocb(len);
	memmove(b-&gt;wp, f-&gt;hdr, f-&gt;nhdr);
	if(f-&gt;dlen)
		memmove(b-&gt;wp + f-&gt;nhdr, f-&gt;dp, f-&gt;dlen);
	b-&gt;wp += len;
	return b;
}

static void
putlba(Aoeata *a, vlong lba)
{
	uchar *c;

	c = a-&gt;lba;
	c[0] = lba;
	c[1] = lba &gt;&gt; 8;
	c[2] = lba &gt;&gt; 16;
	c[3] = lba &gt;&gt; 24;
	c[4] = lba &gt;&gt; 32;
	c[5] = lba &gt;&gt; 40;
}

static Devlink*
pickdevlink(Aoedev *d)
{
	ulong i, n;
	Devlink *l;

	for(i = 0; i &lt; d-&gt;ndl; i++){
		n = d-&gt;dlidx++ % d-&gt;ndl;
		l = d-&gt;dl + n;
		if(l &amp;&amp; l-&gt;flag &amp; Dup)
			return l;
	}
	return 0;
}

static int
pickea(Devlink *l)
{
	if(l == 0)
		return -1;
	if(l-&gt;nea == 0)
		return -1;
	return l-&gt;eaidx++ % l-&gt;nea;
}

static int
hset(Aoedev *d, Frame *f, Aoehdr *h, int cmd)
{
	int i;
	Devlink *l;

	if(f-&gt;srb &amp;&amp; MACHP(0)-&gt;ticks - f-&gt;srb-&gt;ticksent &gt; Maxreqticks){
		eventlog("%æ: srb timeout\n", d);
		if(cmd == ACata &amp;&amp; f-&gt;srb &amp;&amp; Nofail(d, s))
			f-&gt;srb-&gt;ticksent = MACHP(0)-&gt;ticks;
		else
			frameerror(d, f, Etimedout);
		return -1;
	}
	l = pickdevlink(d);
	i = pickea(l);
	if(i == -1){
		if(cmd != ACata || f-&gt;srb == nil || !Nofail(d, s))
			downdev(d, "resend fails; no netlink/ea");
		return -1;
	}
	memmove(h-&gt;dst, l-&gt;eatab[i], Eaddrlen);
	memmove(h-&gt;src, l-&gt;nl-&gt;ea, sizeof h-&gt;src);
	hnputs(h-&gt;type, Aoetype);
	h-&gt;verflag = Aoever &lt;&lt; 4;
	h-&gt;error = 0;
	hnputs(h-&gt;major, d-&gt;major);
	h-&gt;minor = d-&gt;minor;
	h-&gt;cmd = cmd;

	hnputl(h-&gt;tag, f-&gt;tag = newtag(d));
	f-&gt;dl = l;
	f-&gt;nl = l-&gt;nl;
	f-&gt;eaidx = i;
	f-&gt;ticksent = MACHP(0)-&gt;ticks;

	return f-&gt;tag;
}

static int
resend(Aoedev *d, Frame *f)
{
	ulong n;
	Aoeata *a;

	a = (Aoeata*)f-&gt;hdr;
	if(hset(d, f, a, a-&gt;cmd) == -1)
		return -1;
	n = f-&gt;bcnt;
	if(n &gt; d-&gt;maxbcnt){
		n = d-&gt;maxbcnt;		/* mtu mismatch (jumbo fail?) */
		if(f-&gt;dlen &gt; n)
			f-&gt;dlen = n;
	}
	a-&gt;scnt = n / Aoesectsz;
	f-&gt;dl-&gt;resent++;
	f-&gt;dl-&gt;npkt++;
	if(waserror())
		return -1;
	devtab[f-&gt;nl-&gt;dc-&gt;type]-&gt;bwrite(f-&gt;nl-&gt;dc, allocfb(f), 0);
	poperror();
	return 0;
}

static void
discover(int major, int minor)
{
	Aoehdr *h;
	Block *b;
	Netlink *nl, *e;

	nl = netlinks.nl;
	e = nl + nelem(netlinks.nl);
	for(; nl &lt; e; nl++){
		if(nl-&gt;cc == nil)
			continue;
		b = allocb(ETHERMINTU);
		if(waserror()){
			freeb(b);
			nexterror();
		}
		b-&gt;wp = b-&gt;rp + ETHERMINTU;
		memset(b-&gt;rp, 0, ETHERMINTU);
		h = (Aoehdr*)b-&gt;rp;
		memset(h-&gt;dst, 0xff, sizeof h-&gt;dst);
		memmove(h-&gt;src, nl-&gt;ea, sizeof h-&gt;src);
		hnputs(h-&gt;type, Aoetype);
		h-&gt;verflag = Aoever &lt;&lt; 4;
		hnputs(h-&gt;major, major);
		h-&gt;minor = minor;
		h-&gt;cmd = ACconfig;
		poperror();
		/* send b down the queue */
		devtab[nl-&gt;dc-&gt;type]-&gt;bwrite(nl-&gt;dc, b, 0);
	}
}

/*
 * Check all frames on device and resend any frames that have been
 * outstanding for 200% of the device round trip time average.
 */
static void
aoesweepproc(void*)
{
	ulong i, tx, timeout, nbc;
	vlong starttick;
	enum { Nms = 100, Nbcms = 30*1000, };		/* magic */
	uchar *ea;
	Aoeata *a;
	Aoedev *d;
	Devlink *l;
	Frame *f, *e;

	nbc = Nbcms/Nms;
loop:
	if(nbc-- == 0){
		if(rediscover &amp;&amp; !waserror()){
			discover(0xffff, 0xff);
			poperror();
		}
		nbc = Nbcms/Nms;
	}
	starttick = MACHP(0)-&gt;ticks;
	rlock(&amp;devs);
	for(d = devs.d; d; d = d-&gt;next){
		if(!canqlock(d))
			continue;
		if(!UP(d)){
			qunlock(d);
			continue;
		}
		tx = 0;
		f = d-&gt;frames;
		e = f + d-&gt;nframes;
		for (; f &lt; e; f++){
			if(f-&gt;tag == Tfree)
				continue;
			l = f-&gt;dl;
			timeout = l-&gt;rttavg &lt;&lt; 1;
			i = tsince(f-&gt;tag);
			if(i &lt; timeout)
				continue;
			if(d-&gt;nout == d-&gt;maxout){
				if(d-&gt;maxout &gt; 1)
					d-&gt;maxout--;
				d-&gt;lastwadj = MACHP(0)-&gt;ticks;
			}
			a = (Aoeata*)f-&gt;hdr;
			if(a-&gt;scnt &gt; Dbcnt / Aoesectsz &amp;&amp;
			   ++f-&gt;nl-&gt;lostjumbo &gt; (d-&gt;nframes &lt;&lt; 1)){
				ea = f-&gt;dl-&gt;eatab[f-&gt;eaidx];
				eventlog("%æ: jumbo failure on %s:%E; lba%lld\n",
					d, f-&gt;nl-&gt;path, ea, f-&gt;lba);
				d-&gt;maxbcnt = Dbcnt;
				d-&gt;flag &amp;= ~Djumbo;
			}
			resend(d, f);
			if(tx++ == 0){
				if((l-&gt;rttavg &lt;&lt;= 1) &gt; Rtmax)
					l-&gt;rttavg = Rtmax;
				eventlog("%æ: rtt %ldms\n", d, TK2MS(l-&gt;rttavg));
			}
		}
		if(d-&gt;nout == d-&gt;maxout &amp;&amp; d-&gt;maxout &lt; d-&gt;nframes &amp;&amp;
		   TK2MS(MACHP(0)-&gt;ticks - d-&gt;lastwadj) &gt; 10*1000){ /* more magic */
			d-&gt;maxout++;
			d-&gt;lastwadj = MACHP(0)-&gt;ticks;
		}
		qunlock(d);
	}
	runlock(&amp;devs);
	i = Nms - TK2MS(MACHP(0)-&gt;ticks - starttick);
	if(i &gt; 0)
		tsleep(&amp;up-&gt;sleep, return0, 0, i);
	goto loop;
}

static int
fmtæ(Fmt *f)
{
	char buf[16];
	Aoedev *d;

	d = va_arg(f-&gt;args, Aoedev*);
	snprint(buf, sizeof buf, "aoe%d.%d", d-&gt;major, d-&gt;minor);
	return fmtstrcpy(f, buf);
}

static void netbind(char *path);

static void
aoecfg(void)
{
	int n, i;
	char *p, *f[32], buf[24];

	if((p = getconf("aoeif")) == nil || (n = tokenize(p, f, nelem(f))) &lt; 1)
		return;
	/* goo! */
	for(i = 0; i &lt; n; i++){
		p = f[i];
		if(strncmp(p, "ether", 5) == 0)
			snprint(buf, sizeof buf, "#l%c/ether%c", p[5], p[5]);
		else if(strncmp(p, "#l", 2) == 0)
			snprint(buf, sizeof buf, "#l%c/ether%c", p[2], p[2]);
		else
			continue;
		if(!waserror()){
			netbind(buf);
			poperror();
		}
	}
}

static void
aoeinit(void)
{
	static int init;
	static QLock l;

	if(!canqlock(&amp;l))
		return;
	if(init == 0){
		fmtinstall(L'æ', fmtæ);
		events.rp = events.wp = events.buf;
		kproc("aoesweep", aoesweepproc, nil);
		aoecfg();
		init = 1;
	}
	qunlock(&amp;l);
}

static Chan*
aoeattach(char *spec)
{
	Chan *c;

	if(*spec)
		error(Enonexist);
	aoeinit();
	c = devattach(L'æ', spec);
	mkqid(&amp;c-&gt;qid, Qzero, 0, QTDIR);
	return c;
}

static Aoedev*
unit2dev(ulong unit)
{
	int i;
	Aoedev *d;

	rlock(&amp;devs);
	i = 0;
	for(d = devs.d; d; d = d-&gt;next)
		if(i++ == unit){
			runlock(&amp;devs);
			return d;
		}
	runlock(&amp;devs);
	uprint("unit lookup failure: %lux pc %#p", unit, getcallerpc(&amp;unit));
	error(up-&gt;genbuf);
	return nil;
}

static int
unitgen(Chan *c, ulong type, Dir *dp)
{
	int perm, t;
	ulong vers;
	vlong size;
	char *p;
	Aoedev *d;
	Qid q;

	d = unit2dev(UNIT(c-&gt;qid));
	perm = 0644;
	size = 0;
	vers = d-&gt;vers;
	t = QTFILE;

	switch(type){
	default:
		return -1;
	case Qctl:
		p = "ctl";
		break;
	case Qdata:
		p = "data";
		perm = 0640;
		if(UP(d))
			size = d-&gt;bsize;
		break;
	case Qconfig:
		p = "config";
		if(UP(d))
			size = d-&gt;nconfig;
		break;
	case Qident:
		p = "ident";
		if(UP(d))
			size = sizeof d-&gt;ident;
		break;
	case Qdevlinkdir:
		p = "devlink";
		t = QTDIR;
		perm = 0555;
		break;
	}
	mkqid(&amp;q, QID(UNIT(c-&gt;qid), type), vers, t);
	devdir(c, q, p, size, eve, perm, dp);
	return 1;
}

static int
topgen(Chan *c, ulong type, Dir *d)
{
	int perm;
	vlong size;
	char *p;
	Qid q;

	perm = 0444;
	size = 0;
	switch(type){
	default:
		return -1;
	case Qtopctl:
		p = "ctl";
		perm = 0644;
		break;
	case Qtoplog:
		p = "log";
		size = eventcount();
		break;
	}
	mkqid(&amp;q, type, 0, QTFILE);
	devdir(c, q, p, size, eve, perm, d);
	return 1;
}

static int
aoegen(Chan *c, char *, Dirtab *, int, int s, Dir *dp)
{
	int i;
	Aoedev *d;
	Qid q;

	if(c-&gt;qid.path == 0){
		switch(s){
		case DEVDOTDOT:
			q.path = 0;
			q.type = QTDIR;
			devdir(c, q, "#æ", 0, eve, 0555, dp);
			break;
		case 0:
			q.path = Qtopdir;
			q.type = QTDIR;
			devdir(c, q, "aoe", 0, eve, 0555, dp);
			break;
		default:
			return -1;
		}
		return 1;
	}

	switch(TYPE(c-&gt;qid)){
	default:
		return -1;
	case Qtopdir:
		if(s == DEVDOTDOT){
			mkqid(&amp;q, Qzero, 0, QTDIR);
			devdir(c, q, "aoe", 0, eve, 0555, dp);
			return 1;
		}
		if(s &lt; Qtopfiles)
			return topgen(c, Qtopbase + s, dp);
		s -= Qtopfiles;
		if(s &gt;= units.ref)
			return -1;
		mkqid(&amp;q, QID(s, Qunitdir), 0, QTDIR);
		d = unit2dev(s);
		assert(d != nil);
		devdir(c, q, unitname(d), 0, eve, 0555, dp);
		return 1;
	case Qtopctl:
	case Qtoplog:
		return topgen(c, TYPE(c-&gt;qid), dp);
	case Qunitdir:
		if(s == DEVDOTDOT){
			mkqid(&amp;q, QID(0, Qtopdir), 0, QTDIR);
			uprint("%uld", UNIT(c-&gt;qid));
			devdir(c, q, up-&gt;genbuf, 0, eve, 0555, dp);
			return 1;
		}
		return unitgen(c, Qunitbase+s, dp);
	case Qctl:
	case Qdata:
	case Qconfig:
	case Qident:
		return unitgen(c, TYPE(c-&gt;qid), dp);
	case Qdevlinkdir:
		i = UNIT(c-&gt;qid);
		if(s == DEVDOTDOT){
			mkqid(&amp;q, QID(i, Qunitdir), 0, QTDIR);
			devdir(c, q, "devlink", 0, eve, 0555, dp);
			return 1;
		}
		if(i &gt;= units.ref)
			return -1;
		d = unit2dev(i);
		if(s &gt;= d-&gt;ndl)
			return -1;
		uprint("%d", s);
		mkqid(&amp;q, Q3(s, i, Qdevlink), 0, QTFILE);
		devdir(c, q, up-&gt;genbuf, 0, eve, 0755, dp);
		return 1;
	case Qdevlink:
		uprint("%d", s);
		mkqid(&amp;q, Q3(s, UNIT(c-&gt;qid), Qdevlink), 0, QTFILE);
		devdir(c, q, up-&gt;genbuf, 0, eve, 0755, dp);
		return 1;
	}
}

static Walkqid*
aoewalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, nil, 0, aoegen);
}

static int
aoestat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, nil, 0, aoegen);
}

static Chan*
aoeopen(Chan *c, int omode)
{
	Aoedev *d;

	if(TYPE(c-&gt;qid) != Qdata)
		return devopen(c, omode, 0, 0, aoegen);

	d = unit2dev(UNIT(c-&gt;qid));
	qlock(d);
	if(waserror()){
		qunlock(d);
		nexterror();
	}
	if(!UP(d))
		error(Eaoedown);
	c = devopen(c, omode, 0, 0, aoegen);
	d-&gt;nopen++;
	poperror();
	qunlock(d);
	return c;
}

static void
aoeclose(Chan *c)
{
	Aoedev *d;

	if(TYPE(c-&gt;qid) != Qdata || (c-&gt;flag&amp;COPEN) == 0)
		return;

	d = unit2dev(UNIT(c-&gt;qid));
	qlock(d);
	if(--d-&gt;nopen == 0 &amp;&amp; !waserror()){
		discover(d-&gt;major, d-&gt;minor);
		poperror();
	}
	qunlock(d);
}

static void
atarw(Aoedev *d, Frame *f)
{
	ulong bcnt;
	char extbit, writebit;
	Aoeata *ah;
	Srb *srb;

	extbit = 0x4;
	writebit = 0x10;

	srb = d-&gt;inprocess;
	bcnt = d-&gt;maxbcnt;
	if(bcnt &gt; srb-&gt;len)
		bcnt = srb-&gt;len;
	f-&gt;nhdr = AOEATASZ;
	memset(f-&gt;hdr, 0, f-&gt;nhdr);
	ah = (Aoeata*)f-&gt;hdr;
	if(hset(d, f, ah, ACata) == -1) {
		d-&gt;inprocess = nil;
		return;
	}
	f-&gt;dp = srb-&gt;dp;
	f-&gt;bcnt = bcnt;
	f-&gt;lba = srb-&gt;sector;
	f-&gt;srb = srb;

	ah-&gt;scnt = bcnt / Aoesectsz;
	putlba(ah, f-&gt;lba);
	if(d-&gt;flag &amp; Dllba)
		ah-&gt;aflag |= AAFext;
	else {
		extbit = 0;
		ah-&gt;lba[3] &amp;= 0x0f;
		ah-&gt;lba[3] |= 0xe0;	/* LBA bit+obsolete 0xa0 */
	}
	if(srb-&gt;write){
		ah-&gt;aflag |= AAFwrite;
		f-&gt;dlen = bcnt;
	}else{
		writebit = 0;
		f-&gt;dlen = 0;
	}
	ah-&gt;cmdstat = 0x20 | writebit | extbit;

	/* mark tracking fields and load out */
	srb-&gt;nout++;
	srb-&gt;dp = (uchar*)srb-&gt;dp + bcnt;
	srb-&gt;len -= bcnt;
	srb-&gt;sector += bcnt / Aoesectsz;
	if(srb-&gt;len == 0)
		d-&gt;inprocess = nil;
	d-&gt;nout++;
	f-&gt;dl-&gt;npkt++;
	if(waserror()){
		f-&gt;tag = Tfree;
		d-&gt;inprocess = nil;
		nexterror();
	}
	devtab[f-&gt;nl-&gt;dc-&gt;type]-&gt;bwrite(f-&gt;nl-&gt;dc, allocfb(f), 0);
	poperror();
}

static char*
aoeerror(Aoehdr *h)
{
	int n;
	static char *errs[] = {
		"aoe protocol error: unknown",
		"aoe protocol error: bad command code",
		"aoe protocol error: bad argument param",
		"aoe protocol error: device unavailable",
		"aoe protocol error: config string present",
		"aoe protocol error: unsupported version",
		"aoe protocol error: target is reserved",
	};

	if((h-&gt;verflag &amp; AFerr) == 0)
		return 0;
	n = h-&gt;error;
	if(n &gt; nelem(errs))
		n = 0;
	return errs[n];
}

static void
rtupdate(Devlink *l, int rtt)
{
	int n;

	n = rtt;
	if(rtt &lt; 0){
		n = -rtt;
		if(n &lt; Rtmin)
			n = Rtmin;
		else if(n &gt; Rtmax)
			n = Rtmax;
		l-&gt;mintimer += (n - l-&gt;mintimer) &gt;&gt; 1;
	} else if(n &lt; l-&gt;mintimer)
		n = l-&gt;mintimer;
	else if(n &gt; Rtmax)
		n = Rtmax;

	/* g == .25; cf. Congestion Avoidance and Control, Jacobson&amp;Karels; 1988 */
	n -= l-&gt;rttavg;
	l-&gt;rttavg += n &gt;&gt; 2;
}

static int
srbready(void *v)
{
	Srb *s;

	s = v;
	return s-&gt;error || (s-&gt;nout == 0 &amp;&amp; s-&gt;len == 0);
}

static Frame*
getframe(Aoedev *d, int tag)
{
	Frame *f, *e;

	f = d-&gt;frames;
	e = f + d-&gt;nframes;
	for(; f &lt; e; f++)
		if(f-&gt;tag == tag)
			return f;
	return nil;
}

static Frame*
freeframe(Aoedev *d)
{
	if(d-&gt;nout &lt; d-&gt;maxout)
		return getframe(d, Tfree);
	return nil;
}

static void
work(Aoedev *d)
{
	Frame *f;

	while ((f = freeframe(d)) != nil) {
		if(d-&gt;inprocess == nil){
			if(d-&gt;head == nil)
				return;
			d-&gt;inprocess = d-&gt;head;
			d-&gt;head = d-&gt;head-&gt;next;
			if(d-&gt;head == nil)
				d-&gt;tail = nil;
		}
		atarw(d, f);
	}
}

static void
strategy(Aoedev *d, Srb *srb)
{
	qlock(d);
	if(waserror()){
		qunlock(d);
		nexterror();
	}
	srb-&gt;next = nil;
	if(d-&gt;tail)
		d-&gt;tail-&gt;next = srb;
	d-&gt;tail = srb;
	if(d-&gt;head == nil)
		d-&gt;head = srb;
	srb-&gt;shared = 1;
	work(d);
	poperror();
	qunlock(d);

	while(waserror())
		;
	sleep(srb, srbready, srb);
	poperror();
}

#define iskaddr(a)	((uintptr)(a) &gt; KZERO)

static long
rw(Aoedev *d, int write, uchar *db, long len, uvlong off)
{
	long n, nlen, copy;
	enum { Srbsz = 1&lt;&lt;19, };	/* magic allocation */
	Srb *srb;

	if((off|len) &amp; (Aoesectsz-1))
		error("offset and length must be sector multiple.\n");
	if(off &gt; d-&gt;bsize || len == 0)
		return 0;
	if(off + len &gt; d-&gt;bsize)
		len = d-&gt;bsize - off;
	copy = 0;
	if(iskaddr(db)){
		srb = srbkalloc(db, len);
		copy = 1;
	}else
		srb = srballoc(Srbsz &lt;= len? Srbsz: len);
	if(waserror()){
		srbfree(srb);
		nexterror();
	}
	nlen = len;
	srb-&gt;write = write;
	do {
		if(!UP(d))
			error(Eio);
		srb-&gt;sector = off / Aoesectsz;
		srb-&gt;dp = srb-&gt;data;
		n = nlen;
		if(n &gt; Srbsz)
			n = Srbsz;
		srb-&gt;len = n;
		if(write &amp;&amp; !copy)
			memmove(srb-&gt;data, db, n);
		strategy(d, srb);
		if(srb-&gt;error)
			error(srb-&gt;error);
		if(!write &amp;&amp; !copy)
			memmove(db, srb-&gt;data, n);
		nlen -= n;
		db += n;
		off += n;
	} while (nlen &gt; 0);
	poperror();
	srbfree(srb);
	return len;
}

static long
readmem(ulong off, void *dst, long n, void *src, long size)
{
	if(off &gt;= size)
		return 0;
	if(off + n &gt; size)
		n = size - off;
	memmove(dst, (uchar*)src + off, n);
	return n;
}

static char *
pflag(char *s, char *e, uchar f)
{
	uchar i;

	for(i = 0; i &lt; 8; i++)
		if(f &amp; (1 &lt;&lt; i))
			s = seprint(s, e, "%s ", flagname[i]? flagname[i]: "oops");
	return seprint(s, e, "\n");
}

static int
pstat(Aoedev *d, char *db, int len, int off)
{
	int i;
	char *state, *s, *p, *e;

	s = p = malloc(READSTR);
	if(s == nil)
		error(Enomem);
	e = p + READSTR;

	state = "down";
	if(UP(d))
		state = "up";

	p = seprint(p, e,
		"state: %s\n"	"nopen: %d\n"	"nout: %d\n"
		"nmaxout: %d\n"	"nframes: %d\n"	"maxbcnt: %d\n"
		"fw: %.4ux\n"
		"model: %s\n"	"serial: %s\n"	"firmware: %s\n",
		state,		d-&gt;nopen,	d-&gt;nout,
		d-&gt;maxout, 	d-&gt;nframes,	d-&gt;maxbcnt,
		d-&gt;fwver,
		d-&gt;model, 	d-&gt;serial, 	d-&gt;firmware);
	p = seprint(p, e, "flag: ");
	p = pflag(p, e, d-&gt;flag);

	if(p - s &lt; len)
		len = p - s;
	i = readstr(off, db, len, s);
	free(s);
	return i;
}

static long
unitread(Chan *c, void *db, long len, vlong off)
{
	Aoedev *d;

	d = unit2dev(UNIT(c-&gt;qid));
	if(d-&gt;vers != c-&gt;qid.vers)
		error(Echange);
	switch(TYPE(c-&gt;qid)){
	default:
		error(Ebadarg);
	case Qctl:
		return pstat(d, db, len, off);
	case Qdata:
		return rw(d, Read, db, len, off);
	case Qconfig:
		if (!UP(d))
			error(Eaoedown);
		return readmem(off, db, len, d-&gt;config, d-&gt;nconfig);
	case Qident:
		if (!UP(d))
			error(Eaoedown);
		return readmem(off, db, len, d-&gt;ident, sizeof d-&gt;ident);
	}
}

static int
devlinkread(Chan *c, void *db, int len, int off)
{
	int i;
	char *s, *p, *e;
	Aoedev *d;
	Devlink *l;

	d = unit2dev(UNIT(c-&gt;qid));
	i = L(c-&gt;qid);
	if(i &gt;= d-&gt;ndl)
		return 0;
	l = d-&gt;dl + i;

	s = p = malloc(READSTR);
	if(s == nil)
		error(Enomem);
	e = s + READSTR;

	p = seprint(p, e, "addr: ");
	for(i = 0; i &lt; l-&gt;nea; i++)
		p = seprint(p, e, "%E ", l-&gt;eatab[i]);
	p = seprint(p, e, "\n");
	p = seprint(p, e, "npkt: %uld\n", l-&gt;npkt);
	p = seprint(p, e, "resent: %uld\n", l-&gt;resent);
	p = seprint(p, e, "flag: "); p = pflag(p, e, l-&gt;flag);
	p = seprint(p, e, "rttavg: %uld\n", TK2MS(l-&gt;rttavg));
	p = seprint(p, e, "mintimer: %uld\n", TK2MS(l-&gt;mintimer));

	p = seprint(p, e, "nl path: %s\n", l-&gt;nl-&gt;path);
	p = seprint(p, e, "nl ea: %E\n", l-&gt;nl-&gt;ea);
	p = seprint(p, e, "nl flag: "); p = pflag(p, e, l-&gt;flag);
	p = seprint(p, e, "nl lostjumbo: %d\n", l-&gt;nl-&gt;lostjumbo);
	p = seprint(p, e, "nl datamtu: %d\n", l-&gt;nl-&gt;datamtu);

	if(p - s &lt; len)
		len = p - s;
	i = readstr(off, db, len, s);
	free(s);
	return i;
}

static long
topctlread(Chan *, void *db, int len, int off)
{
	int i;
	char *s, *p, *e;
	Netlink *n;

	s = p = malloc(READSTR);
	if(s == nil)
		error(Enomem);
	e = s + READSTR;

	p = seprint(p, e, "debug: %d\n", debug);
	p = seprint(p, e, "autodiscover: %d\n", autodiscover);
	p = seprint(p, e, "rediscover: %d\n", rediscover);

	for(i = 0; i &lt; Nnetlink; i++){
		n = netlinks.nl+i;
		if(n-&gt;cc == 0)
			continue;
		p = seprint(p, e, "if%d path: %s\n", i, n-&gt;path);
		p = seprint(p, e, "if%d ea: %E\n", i, n-&gt;ea);
		p = seprint(p, e, "if%d flag: ", i); p = pflag(p, e, n-&gt;flag);
		p = seprint(p, e, "if%d lostjumbo: %d\n", i, n-&gt;lostjumbo);
		p = seprint(p, e, "if%d datamtu: %d\n", i, n-&gt;datamtu);
	}

	if(p - s &lt; len)
		len = p - s;
	i = readstr(off, db, len, s);
	free(s);
	return i;
}

static long
aoeread(Chan *c, void *db, long n, vlong off)
{
	switch(TYPE(c-&gt;qid)){
	default:
		error(Eperm);
	case Qzero:
	case Qtopdir:
	case Qunitdir:
	case Qdevlinkdir:
		return devdirread(c, db, n, 0, 0, aoegen);
	case Qtopctl:
		return topctlread(c, db, n, off);
	case Qtoplog:
		return eventlogread(db, n);
	case Qctl:
	case Qdata:
	case Qconfig:
	case Qident:
		return unitread(c, db, n, off);
	case Qdevlink:
		return devlinkread(c, db, n, off);
	}
}

static long
configwrite(Aoedev *d, void *db, long len)
{
	char *s;
	Aoeqc *ch;
	Frame *f;
	Srb *srb;

	if(!UP(d))
		error(Eaoedown);
	if(len &gt; ETHERMAXTU - AOEQCSZ)
		error(Etoobig);
	srb = srballoc(len);
	s = malloc(len);
	if(s == nil)
		error(Enomem);
	memmove(s, db, len);

	if(waserror()){
		srbfree(srb);
		free(s);
		nexterror();
	}
	for (;;) {
		qlock(d);
		if(waserror()){
			qunlock(d);
			nexterror();
		}
		f = freeframe(d);
		if(f != nil)
			break;
		poperror();
		qunlock(d);

		if(waserror())
			nexterror();
		tsleep(&amp;up-&gt;sleep, return0, 0, 100);
		poperror();
	}
	f-&gt;nhdr = AOEQCSZ;
	memset(f-&gt;hdr, 0, f-&gt;nhdr);
	ch = (Aoeqc*)f-&gt;hdr;
	if(hset(d, f, ch, ACconfig) == -1) {
		/*
		 * these refer to qlock &amp; waserror in the above for loop.
		 * there's still the first waserror outstanding.
		 */
		poperror();
		qunlock(d);
		return 0;
	}
	srb-&gt;shared = 1;
	f-&gt;srb = srb;
	f-&gt;dp = s;
	ch-&gt;verccmd = AQCfset;
	hnputs(ch-&gt;cslen, len);
	d-&gt;nout++;
	srb-&gt;nout++;
	f-&gt;dl-&gt;npkt++;
	f-&gt;dlen = len;
	/* these too */
	poperror();
	qunlock(d);

	devtab[f-&gt;nl-&gt;dc-&gt;type]-&gt;bwrite(f-&gt;nl-&gt;dc, allocfb(f), 0);
	sleep(srb, srbready, srb);
	if(srb-&gt;error)
		error(srb-&gt;error);

	qlock(d);
	if(waserror()){
		qunlock(d);
		nexterror();
	}
	memmove(d-&gt;config, s, len);
	d-&gt;nconfig = len;
	poperror();
	qunlock(d);

	poperror();			/* pop first waserror */

	srbfree(srb);
	memmove(db, s, len);
	free(s);
	return len;
}

static int getmtu(Chan*);

static int
devmaxdata(Aoedev *d)		/* return aoe mtu (excluding headers) */
{
	int i, nmtu, mtu;
	Devlink *l;
	Netlink *n;

	mtu = 100000;
	for(i = 0; i &lt; d-&gt;ndl; i++){
		l = d-&gt;dl + i;
		n = l-&gt;nl;
		if((l-&gt;flag &amp; Dup) == 0 || (n-&gt;flag &amp; Dup) == 0)
			continue;
		nmtu = getmtu(n-&gt;mtu);
		if(mtu &gt; nmtu)
			mtu = nmtu;
	}
	if(mtu == 100000)
		mtu = ETHERMAXTU;		/* normal ethernet mtu */
	mtu -= AOEATASZ;
	mtu -= (uint)mtu % Aoesectsz;
	if(mtu &lt; 2*Aoesectsz)			/* sanity */
		mtu = 2*Aoesectsz;
	return mtu;
}

static int
toggle(char *s, int f, int bit)
{
	if(s == nil)
		f ^= bit;
	else if(strcmp(s, "on") == 0)
		f |= bit;
	else
		f &amp;= ~bit;
	return f;
}

static void ataident(Aoedev*);

static long
unitctlwrite(Aoedev *d, void *db, long n)
{
	uint maxbcnt, mtu;
	uvlong bsize;
	enum {
		Failio,
		Ident,
		Jumbo,
		Maxbno,
		Mtu,
		Nofailf,
		Setsize,
	};
	Cmdbuf *cb;
	Cmdtab *ct;
	static Cmdtab cmds[] = {
		{Failio, 	"failio", 	1 },
		{Ident, 	"identify", 	1 },
		{Jumbo, 	"jumbo", 	0 },
		{Maxbno,	"maxbno",	0 },
		{Mtu,		"mtu",		0 },
		{Nofailf,	"nofail",	0 },
		{Setsize, 	"setsize", 	0 },
	};

	cb = parsecmd(db, n);
	qlock(d);
	if(waserror()){
		qunlock(d);
		free(cb);
		nexterror();
	}
	ct = lookupcmd(cb, cmds, nelem(cmds));
	switch(ct-&gt;index){
	case Failio:
		downdev(d, "i/o failure");
		break;
	case Ident:
		ataident(d);
		break;
	case Jumbo:
		d-&gt;flag = toggle(cb-&gt;f[1], d-&gt;flag, Djumbo);
		break;
	case Maxbno:
	case Mtu:
		maxbcnt = devmaxdata(d);
		if(cb-&gt;nf &gt; 2)
			error(Ecmdargs);
		if(cb-&gt;nf == 2){
			mtu = strtoul(cb-&gt;f[1], 0, 0);
			if(ct-&gt;index == Maxbno)
				mtu *= Aoesectsz;
			else{
				mtu -= AOEATASZ;
				mtu &amp;= ~(Aoesectsz-1);
			}
			if(mtu == 0 || mtu &gt; maxbcnt)
				cmderror(cb, "mtu out of legal range");
			maxbcnt = mtu;
		}
		d-&gt;maxbcnt = maxbcnt;
		break;
	case Nofailf:
		d-&gt;flag = toggle(cb-&gt;f[1], d-&gt;flag, Dnofail);
		break;
	case Setsize:
		bsize = d-&gt;realbsize;
		if(cb-&gt;nf &gt; 2)
			error(Ecmdargs);
		if(cb-&gt;nf == 2){
			bsize = strtoull(cb-&gt;f[1], 0, 0);
			if(bsize % Aoesectsz)
				cmderror(cb, "disk size must be sector aligned");
		}
		d-&gt;bsize = bsize;
		break;
	default:
		cmderror(cb, "unknown aoe control message");
	}
	poperror();
	qunlock(d);
	free(cb);
	return n;
}

static long
unitwrite(Chan *c, void *db, long n, vlong off)
{
	long rv;
	char *buf;
	Aoedev *d;

	d = unit2dev(UNIT(c-&gt;qid));
	switch(TYPE(c-&gt;qid)){
	default:
		error(Ebadarg);
	case Qctl:
		return unitctlwrite(d, db, n);
	case Qident:
		error(Eperm);
	case Qdata:
		return rw(d, Write, db, n, off);
	case Qconfig:
		if(off + n &gt; sizeof d-&gt;config)
			error(Etoobig);
		buf = malloc(sizeof d-&gt;config);
		if(buf == nil)
			error(Enomem);
		if(waserror()){
			free(buf);
			nexterror();
		}
		memmove(buf, d-&gt;config, d-&gt;nconfig);
		memmove(buf + off, db, n);
		rv = configwrite(d, buf, n + off);
		poperror();
		free(buf);
		return rv;
	}
}

static Netlink*
addnet(char *path, Chan *cc, Chan *dc, Chan *mtu, uchar *ea)
{
	Netlink *nl, *e;

	lock(&amp;netlinks);
	if(waserror()){
		unlock(&amp;netlinks);
		nexterror();
	}
	nl = netlinks.nl;
	e = nl + nelem(netlinks.nl);
	for(; nl &lt; e &amp;&amp; nl-&gt;cc; nl++)
		continue;
	if (nl &gt;= e)
		error("out of netlink structures");
	nl-&gt;cc = cc;
	nl-&gt;dc = dc;
	nl-&gt;mtu = mtu;
	strncpy(nl-&gt;path, path, sizeof nl-&gt;path);
	memmove(nl-&gt;ea, ea, sizeof nl-&gt;ea);
	poperror();
	nl-&gt;flag |= Dup;
	unlock(&amp;netlinks);
	return nl;
}

static int
newunit(void)
{
	int x;

	lock(&amp;units);
	if(units.ref == Maxunits)
		x = -1;
	else
		x = units.ref++;
	unlock(&amp;units);
	return x;
}

static int
dropunit(void)
{
	int x;

	lock(&amp;units);
	x = --units.ref;
	unlock(&amp;units);
	return x;
}

/*
 * always allocate max frames.  maxout may change.
 */
static Aoedev*
newdev(long major, long minor, int n)
{
	Aoedev *d;
	Frame *f, *e;

	d = mallocz(sizeof *d, 1);
	f = mallocz(sizeof *f * Maxframes, 1);
	if (!d || !f) {
		free(d);
		free(f);
		error("aoe device allocation failure");
	}
	d-&gt;nframes = n;
	d-&gt;frames = f;
	for (e = f + n; f &lt; e; f++)
		f-&gt;tag = Tfree;
	d-&gt;maxout = n;
	d-&gt;major = major;
	d-&gt;minor = minor;
	d-&gt;maxbcnt = Dbcnt;
	d-&gt;flag = Djumbo;
	d-&gt;unit = newunit();		/* bzzt.  inaccurate if units removed */
	if(d-&gt;unit == -1){
		free(d-&gt;frames);
		free(d);
		error("too many units");
	}
	d-&gt;dl = d-&gt;dltab;
	return d;
}

static Aoedev*
mm2dev(int major, int minor)
{
	Aoedev *d;

	rlock(&amp;devs);
	for(d = devs.d; d; d = d-&gt;next)
		if(d-&gt;major == major &amp;&amp; d-&gt;minor == minor){
			runlock(&amp;devs);
			return d;
		}
	runlock(&amp;devs);
	eventlog("mm2dev: %d.%d not found\n", major, minor);
	return nil;
}

/* Find the device in our list.  If not known, add it */
static Aoedev*
getdev(long major, long minor, int n)
{
	Aoedev *d;

	if(major == 0xffff || minor == 0xff)
		return 0;
	wlock(&amp;devs);
	if(waserror()){
		wunlock(&amp;devs);
		nexterror();
	}
	for(d = devs.d; d; d = d-&gt;next)
		if(d-&gt;major == major &amp;&amp; d-&gt;minor == minor)
			break;
	if (d == nil) {
		d = newdev(major, minor, n);
		d-&gt;next = devs.d;
		devs.d = d;
	}
	poperror();
	wunlock(&amp;devs);
	return d;
}

static ushort
gbit16(void *a)
{
	uchar *i;

	i = a;
	return i[1] &lt;&lt; 8 | i[0];
}

static ulong
gbit32(void *a)
{
	ulong j;
	uchar *i;

	i = a;
	j  = i[3] &lt;&lt; 24;
	j |= i[2] &lt;&lt; 16;
	j |= i[1] &lt;&lt; 8;
	j |= i[0];
	return j;
}

static uvlong
gbit64(void *a)
{
	uchar *i;

	i = a;
	return (uvlong)gbit32(i+4) &lt;&lt; 32 | gbit32(a);
}

static void
ataident(Aoedev *d)
{
	Aoeata *a;
	Block *b;
	Frame *f;

	f = freeframe(d);
	if(f == nil)
		return;
	f-&gt;nhdr = AOEATASZ;
	memset(f-&gt;hdr, 0, f-&gt;nhdr);
	a = (Aoeata*)f-&gt;hdr;
	if(hset(d, f, a, ACata) == -1)
		return;
	a-&gt;cmdstat = Cid;	/* ata 6, page 110 */
	a-&gt;scnt = 1;
	a-&gt;lba[3] = 0xa0;
	d-&gt;nout++;
	f-&gt;dl-&gt;npkt++;
	f-&gt;bcnt = 512;
	f-&gt;dlen = 0;
	b = allocfb(f);
	devtab[f-&gt;nl-&gt;dc-&gt;type]-&gt;bwrite(f-&gt;nl-&gt;dc, b, 0);
}

static int
getmtu(Chan *mtuch)
{
	int n, mtu;
	char buf[36];

	mtu = ETHERMAXTU;
	if(mtuch == nil || waserror())
		return mtu;
	n = devtab[mtuch-&gt;type]-&gt;read(mtuch, buf, sizeof buf - 1, 0);
	if(n &gt; 12){
		buf[n] = 0;
		mtu = strtoul(buf + 12, 0, 0);
	}
	poperror();
	return mtu;
}

static int
newdlea(Devlink *l, uchar *ea)
{
	int i;
	uchar *t;

	for(i = 0; i &lt; Nea; i++){
		t = l-&gt;eatab[i];
		if(i == l-&gt;nea){
			memmove(t, ea, Eaddrlen);
			return l-&gt;nea++;
		}
		if(memcmp(t, ea, Eaddrlen) == 0)
			return i;
	}
	return -1;
}

static Devlink*
newdevlink(Aoedev *d, Netlink *n, Aoeqc *c)
{
	int i;
	Devlink *l;

	for(i = 0; i &lt; Ndevlink; i++){
		l = d-&gt;dl + i;
		if(i == d-&gt;ndl){
			d-&gt;ndl++;
			newdlea(l, c-&gt;src);
			l-&gt;nl = n;
			l-&gt;flag |= Dup;
			l-&gt;mintimer = Rtmin;
			l-&gt;rttavg = Rtmax;
			return l;
		}
		if(l-&gt;nl == n) {
			newdlea(l, c-&gt;src);
			l-&gt;flag |= Dup;
			return l;
		}
	}
	eventlog("%æ: out of links: %s:%E to %E\n", d, n-&gt;path, n-&gt;ea, c-&gt;src);
	return 0;
}

static void
errrsp(Block *b, char *s)
{
	int n;
	Aoedev *d;
	Aoehdr *h;
	Frame *f;

	h = (Aoehdr*)b-&gt;rp;
	n = nhgetl(h-&gt;tag);
	if(n == Tmgmt || n == Tfree)
		return;
	d = mm2dev(nhgets(h-&gt;major), h-&gt;minor);
	if(d == 0)
		return;
	if(f = getframe(d, n))
		frameerror(d, f, s);
}

static void
qcfgrsp(Block *b, Netlink *nl)
{
	int major, cmd, cslen, blen;
	unsigned n;
	Aoedev *d;
	Aoeqc *ch;
	Devlink *l;
	Frame *f;

	ch = (Aoeqc*)b-&gt;rp;
	major = nhgets(ch-&gt;major);
	n = nhgetl(ch-&gt;tag);
	if(n != Tmgmt){
		d = mm2dev(major, ch-&gt;minor);
		if(d == nil)
			return;
		qlock(d);
		f = getframe(d, n);
		if(f == nil){
			qunlock(d);
			eventlog("%æ: unknown response tag %ux\n", d, n);
			return;
		}
		cslen = nhgets(ch-&gt;cslen);
		blen = BLEN(b) - AOEQCSZ;
		if(cslen &lt; blen &amp;&amp; BLEN(b) &gt; 60)
			eventlog("%æ: cfgrsp: tag %.8ux oversized %d %d\n",
				d, n, cslen, blen);
		if(cslen &gt; blen){
			eventlog("%æ: cfgrsp: tag %.8ux runt %d %d\n",
				d, n, cslen, blen);
			cslen = blen;
		}
		memmove(f-&gt;dp, ch + 1, cslen);
		f-&gt;srb-&gt;nout--;
		wakeup(f-&gt;srb);
		f-&gt;srb-&gt;shared = 0;
		d-&gt;nout--;
		f-&gt;srb = nil;
		f-&gt;tag = Tfree;
		qunlock(d);
		return;
	}

	cmd = ch-&gt;verccmd &amp; 0xf;
	if(cmd != 0){
		eventlog("aoe%d.%d: cfgrsp: bad command %d\n", major, ch-&gt;minor, cmd);
		return;
	}
	n = nhgets(ch-&gt;bufcnt);
	if(n &gt; Maxframes)
		n = Maxframes;

	if(waserror()){
		eventlog("getdev: %d.%d ignored: %s\n", major, ch-&gt;minor, up-&gt;errstr);
		return;
	}
	d = getdev(major, ch-&gt;minor, n);
	poperror();
	if(d == 0)
		return;

	qlock(d);
	*up-&gt;errstr = 0;
	if(waserror()){
		qunlock(d);
		eventlog("%æ: %s\n", d, up-&gt;errstr);
		nexterror();
	}

	l = newdevlink(d, nl, ch);		/* add this interface. */

	d-&gt;fwver = nhgets(ch-&gt;fwver);
	n = nhgets(ch-&gt;cslen);
	if(n &gt; sizeof d-&gt;config)
		n = sizeof d-&gt;config;
	d-&gt;nconfig = n;
	memmove(d-&gt;config, ch + 1, n);
	if(l != 0 &amp;&amp; d-&gt;flag &amp; Djumbo){
		n = getmtu(nl-&gt;mtu) - AOEATASZ;
		n /= Aoesectsz;
		if(n &gt; ch-&gt;scnt)
			n = ch-&gt;scnt;
		n = n? n * Aoesectsz: Dbcnt;
		if(n != d-&gt;maxbcnt){
			eventlog("%æ: setting %d byte data frames on %s:%E\n",
				d, n, nl-&gt;path, nl-&gt;ea);
			d-&gt;maxbcnt = n;
		}
	}
	if(d-&gt;nopen == 0)
		ataident(d);
	poperror();
	qunlock(d);
}

void
aoeidmove(char *p, ushort *u, unsigned n)
{
	int i;
	char *op, *e, *s;

	op = p;
	/*
	 * the ushort `*u' is sometimes not aligned on a short boundary,
	 * so dereferencing u[i] causes an alignment exception on
	 * some machines.
	 */
	s = (char *)u;
	for(i = 0; i &lt; n; i += 2){
		*p++ = s[i + 1];
		*p++ = s[i];
	}
	*p = 0;
	while(p &gt; op &amp;&amp; *--p == ' ')
		*p = 0;
	e = p;
	p = op;
	while(*p == ' ')
		p++;
	memmove(op, p, n - (e - p));
}

static vlong
aoeidentify(Aoedev *d, ushort *id)
{
	int i;
	vlong s;

	d-&gt;flag &amp;= ~(Dllba|Dpower|Dsmart|Dnop|Dup);

	i = gbit16(id+83) | gbit16(id+86);
	if(i &amp; (1&lt;&lt;10)){
		d-&gt;flag |= Dllba;
		s = gbit64(id+100);
	}else
		s = gbit32(id+60);

	i = gbit16(id+83);
	if((i&gt;&gt;14) == 1) {
		if(i &amp; (1&lt;&lt;3))
			d-&gt;flag  |= Dpower;
		i = gbit16(id+82);
		if(i &amp; 1)
			d-&gt;flag  |= Dsmart;
		if(i &amp; (1&lt;&lt;14))
			d-&gt;flag  |= Dnop;
	}
//	eventlog("%æ up\n", d);
	d-&gt;flag |= Dup;
	memmove(d-&gt;ident, id, sizeof d-&gt;ident);
	return s;
}

static void
newvers(Aoedev *d)
{
	lock(&amp;drivevers);
	d-&gt;vers = drivevers.ref++;
	unlock(&amp;drivevers);
}

static int
identify(Aoedev *d, ushort *id)
{
	vlong osectors, s;
	uchar oserial[21];

	s = aoeidentify(d, id);
	if(s == -1)
		return -1;
	osectors = d-&gt;realbsize;
	memmove(oserial, d-&gt;serial, sizeof d-&gt;serial);

	aoeidmove(d-&gt;serial, id+10, 20);
	aoeidmove(d-&gt;firmware, id+23, 8);
	aoeidmove(d-&gt;model, id+27, 40);

	s *= Aoesectsz;
	if((osectors == 0 || osectors != s) &amp;&amp;
	    memcmp(oserial, d-&gt;serial, sizeof oserial) != 0){
		d-&gt;bsize = s;
		d-&gt;realbsize = s;
//		d-&gt;mediachange = 1;
		newvers(d);
	}
	return 0;
}

static void
atarsp(Block *b)
{
	unsigned n;
	short major;
	Aoeata *ahin, *ahout;
	Aoedev *d;
	Frame *f;
	Srb *srb;

	ahin = (Aoeata*)b-&gt;rp;
	major = nhgets(ahin-&gt;major);
	d = mm2dev(major, ahin-&gt;minor);
	if(d == nil)
		return;
	qlock(d);
	if(waserror()){
		qunlock(d);
		nexterror();
	}
	n = nhgetl(ahin-&gt;tag);
	f = getframe(d, n);
	if(f == nil){
		dprint("%æ: unexpected response; tag %ux\n", d, n);
		goto bail;
	}
	rtupdate(f-&gt;dl, tsince(f-&gt;tag));
	ahout = (Aoeata*)f-&gt;hdr;
	srb = f-&gt;srb;

	if(ahin-&gt;cmdstat &amp; 0xa9){
		eventlog("%æ: ata error cmd %.2ux stat %.2ux\n",
			d, ahout-&gt;cmdstat, ahin-&gt;cmdstat);
		if(srb)
			srb-&gt;error = Eio;
	} else {
		n = ahout-&gt;scnt * Aoesectsz;
		switch(ahout-&gt;cmdstat){
		case Crd:
		case Crdext:
			if(BLEN(b) - AOEATASZ &lt; n){
				eventlog("%æ: runt read blen %ld expect %d\n",
					d, BLEN(b), n);
				goto bail;
			}
			memmove(f-&gt;dp, (uchar *)ahin + AOEATASZ, n);
		case Cwr:
		case Cwrext:
			if(n &gt; Dbcnt)
				f-&gt;nl-&gt;lostjumbo = 0;
			if(f-&gt;bcnt -= n){
				f-&gt;lba += n / Aoesectsz;
				f-&gt;dp = (uchar*)f-&gt;dp + n;
				resend(d, f);
				goto bail;
			}
			break;
		case Cid:
			if(BLEN(b) - AOEATASZ &lt; 512){
				eventlog("%æ: runt identify blen %ld expect %d\n",
					d, BLEN(b), n);
				goto bail;
			}
			identify(d, (ushort*)((uchar *)ahin + AOEATASZ));
			break;
		default:
			eventlog("%æ: unknown ata command %.2ux \n",
				d, ahout-&gt;cmdstat);
		}
	}

	if(srb &amp;&amp; --srb-&gt;nout == 0 &amp;&amp; srb-&gt;len == 0){
		wakeup(srb);
		srb-&gt;shared = 0;
	}
	f-&gt;srb = nil;
	f-&gt;tag = Tfree;
	d-&gt;nout--;

	work(d);
bail:
	poperror();
	qunlock(d);
}

static void
netrdaoeproc(void *v)
{
	int idx;
	char name[Maxpath+1], *s;
	Aoehdr *h;
	Block *b;
	Netlink *nl;

	nl = (Netlink*)v;
	idx = nl - netlinks.nl;
	netlinks.reader[idx] = 1;
	kstrcpy(name, nl-&gt;path, Maxpath);

	if(waserror()){
		eventlog("netrdaoe exiting: %s\n", up-&gt;errstr);
		netlinks.reader[idx] = 0;
		wakeup(netlinks.rendez + idx);
		pexit(up-&gt;errstr, 1);
	}
	if(autodiscover)
		discover(0xffff, 0xff);
	for (;;) {
		if(!(nl-&gt;flag &amp; Dup)) {
			uprint("%s: netlink is down", name);
			error(up-&gt;genbuf);
		}
		if (nl-&gt;dc == nil)
			panic("netrdaoe: nl-&gt;dc == nil");
		b = devtab[nl-&gt;dc-&gt;type]-&gt;bread(nl-&gt;dc, 1&lt;&lt;16, 0);
		if(b == nil) {
			uprint("%s: nil read from network", name);
			error(up-&gt;genbuf);
		}
		h = (Aoehdr*)b-&gt;rp;
		if(h-&gt;verflag &amp; AFrsp)
			if(s = aoeerror(h)){
				eventlog("%s: %s\n", nl-&gt;path, up-&gt;errstr);
				errrsp(b, s);
			}else
				switch(h-&gt;cmd){
				case ACata:
					atarsp(b);
					break;
				case ACconfig:
					qcfgrsp(b, nl);
					break;
				default:
					if((h-&gt;cmd &amp; 0xf0) == 0){
						eventlog("%s: unknown cmd %d\n",
							nl-&gt;path, h-&gt;cmd);
						errrsp(b, "unknown command");
					}
					break;
				}
		freeb(b);
	}
}

static void
getaddr(char *path, uchar *ea)
{
	int n;
	char buf[2*Eaddrlen+1];
	Chan *c;

	uprint("%s/addr", path);
	c = namec(up-&gt;genbuf, Aopen, OREAD, 0);
	if(waserror()) {
		cclose(c);
		nexterror();
	}
	if (c == nil)
		panic("æ: getaddr: c == nil");
	n = devtab[c-&gt;type]-&gt;read(c, buf, sizeof buf-1, 0);
	poperror();
	cclose(c);
	buf[n] = 0;
	if(parseether(ea, buf) &lt; 0)
		error("parseether failure");
}

static void
netbind(char *path)
{
	char addr[Maxpath];
	uchar ea[2*Eaddrlen+1];
	Chan *dc, *cc, *mtu;
	Netlink *nl;

	snprint(addr, sizeof addr, "%s!%#x", path, Aoetype);
	dc = chandial(addr, nil, nil, &amp;cc);
	snprint(addr, sizeof addr, "%s/mtu", path);
	if(waserror())
		mtu = nil;
	else {
		mtu = namec(addr, Aopen, OREAD, 0);
		poperror();
	}

	if(waserror()){
		cclose(dc);
		cclose(cc);
		if(mtu)
			cclose(mtu);
		nexterror();
	}
	if(dc == nil  || cc == nil)
		error(Enonexist);
	getaddr(path, ea);
	nl = addnet(path, cc, dc, mtu, ea);
	snprint(addr, sizeof addr, "netrdaoe@%s", path);
	kproc(addr, netrdaoeproc, nl);
	poperror();
}

static int
unbound(void *v)
{
	return *(int*)v != 0;
}

static void
netunbind(char *path)
{
	int i, idx;
	Aoedev *d, *p, *next;
	Chan *dc, *cc;
	Devlink *l;
	Frame *f;
	Netlink *n, *e;

	n = netlinks.nl;
	e = n + nelem(netlinks.nl);

	lock(&amp;netlinks);
	for(; n &lt; e; n++)
		if(n-&gt;dc &amp;&amp; strcmp(n-&gt;path, path) == 0)
			break;
	unlock(&amp;netlinks);
	if (n &gt;= e)
		error("device not bound");

	/*
	 * hunt down devices using this interface; disable
	 * this also terminates the reader.
	 */
	idx = n - netlinks.nl;
	wlock(&amp;devs);
	for(d = devs.d; d; d = d-&gt;next){
		qlock(d);
		for(i = 0; i &lt; d-&gt;ndl; i++){
			l = d-&gt;dl + i;
			if(l-&gt;nl == n)
				l-&gt;flag &amp;= ~Dup;
		}
		qunlock(d);
	}
	n-&gt;flag &amp;= ~Dup;
	wunlock(&amp;devs);

	/* confirm reader is down. */
	while(waserror())
		;
	sleep(netlinks.rendez + idx, unbound, netlinks.reader + idx);
	poperror();

	/* reschedule packets. */
	wlock(&amp;devs);
	for(d = devs.d; d; d = d-&gt;next){
		qlock(d);
		for(i = 0; i &lt; d-&gt;nframes; i++){
			f = d-&gt;frames + i;
			if(f-&gt;tag != Tfree &amp;&amp; f-&gt;nl == n)
				resend(d, f);
		}
		qunlock(d);
	}
	wunlock(&amp;devs);

	/* squeeze devlink pool.  (we assert nobody is using them now) */
	wlock(&amp;devs);
	for(d = devs.d; d; d = d-&gt;next){
		qlock(d);
		for(i = 0; i &lt; d-&gt;ndl; i++){
			l = d-&gt;dl + i;
			if(l-&gt;nl == n)
				memmove(l, l + 1, sizeof *l * (--d-&gt;ndl - i));
		}
		qunlock(d);
	}
	wunlock(&amp;devs);

	/* close device link. */
	lock(&amp;netlinks);
	dc = n-&gt;dc;
	cc = n-&gt;cc;
	if(n-&gt;mtu)
		cclose(n-&gt;mtu);
	memset(n, 0, sizeof *n);
	unlock(&amp;netlinks);

	cclose(dc);
	cclose(cc);

	/* squeeze orphan devices */
	wlock(&amp;devs);
	for(p = d = devs.d; d; d = next){
		next = d-&gt;next;
		if(d-&gt;ndl &gt; 0) {
			p = d;
			continue;
		}
		qlock(d);
		downdev(d, "orphan");
		qunlock(d);
		if(p != devs.d)
			p-&gt;next = next;
		else{
			devs.d = next;
			p = devs.d;
		}
		free(d-&gt;frames);
		free(d);
		dropunit();
	}
	wunlock(&amp;devs);
}

static void
removeaoedev(Aoedev *d)
{
	int i;
	Aoedev *p;

	wlock(&amp;devs);
	p = 0;
	if(d != devs.d)
		for(p = devs.d; p; p = p-&gt;next)
			if(p-&gt;next == d)
				break;
	qlock(d);
	d-&gt;flag &amp;= ~Dup;

	/*
	 * Changing the version number is, strictly speaking, correct,
 	 * but doing so means that deleting a LUN that is not in use
	 * invalidates all other LUNs too.  If your file server has
	 * venti arenas or fossil file systems on 1.0, and you delete 1.1,
	 * since you no longer need it, 1.0 will become inaccessible to your
	 * file server, which will eventually panic.  Note that newdev()
	 * does not change the version number.
	 */
	// newvers(d);

	d-&gt;ndl = 0;
	qunlock(d);
	for(i = 0; i &lt; d-&gt;nframes; i++)
		frameerror(d, d-&gt;frames+i, Eaoedown);

	if(p)
		p-&gt;next = d-&gt;next;
	else
		devs.d = d-&gt;next;
	free(d-&gt;frames);
	free(d);
	dropunit();
	wunlock(&amp;devs);
}

static void
removedev(char *name)
{
	Aoedev *d, *p;

	wlock(&amp;devs);
	for(p = d = devs.d; d; p = d, d = d-&gt;next)
		if(strcmp(name, unitname(d)) == 0) {
			wunlock(&amp;devs);
			removeaoedev(p);
			return;
		}
	wunlock(&amp;devs);
	error("device not bound");
}

static void
discoverstr(char *f)
{
	ushort shelf, slot;
	ulong sh;
	char *s;

	if(f == 0){
		discover(0xffff, 0xff);
		return;
	}

	shelf = sh = strtol(f, &amp;s, 0);
	if(s == f || sh &gt; 0xffff)
		error("bad shelf");
	f = s;
	if(*f++ == '.'){
		slot = strtol(f, &amp;s, 0);
		if(s == f || slot &gt; 0xff)
			error("bad shelf");
	}else
		slot = 0xff;
	discover(shelf, slot);
}


static void
aoeremove(Chan *c)
{
	switch(TYPE(c-&gt;qid)){
	default:
		error(Eperm);
	case Qunitdir:
		removeaoedev(unit2dev(UNIT(c-&gt;qid)));
		break;
	}
}

static long
topctlwrite(void *db, long n)
{
	enum {
		Autodiscover,
		Bind,
		Debug,
		Discover,
		Rediscover,
		Remove,
		Unbind,
	};
	char *f;
	Cmdbuf *cb;
	Cmdtab *ct;
	static Cmdtab cmds[] = {
		{ Autodiscover,	"autodiscover",	0	},
		{ Bind, 	"bind", 	2	},
		{ Debug, 	"debug", 	0	},
		{ Discover, 	"discover", 	0	},
		{ Rediscover,	"rediscover",	0	},
		{ Remove,	"remove",	2	},
		{ Unbind,	"unbind",	2	},
	};

	cb = parsecmd(db, n);
	if(waserror()){
		free(cb);
		nexterror();
	}
	ct = lookupcmd(cb, cmds, nelem(cmds));
	f = cb-&gt;f[1];
	switch(ct-&gt;index){
	case Autodiscover:
		autodiscover = toggle(f, autodiscover, 1);
		break;
	case Bind:
		netbind(f);
		break;
	case Debug:
		debug = toggle(f, debug, 1);
		break;
	case Discover:
		discoverstr(f);
		break;
	case Rediscover:
		rediscover = toggle(f, rediscover, 1);
		break;
	case Remove:
		removedev(f);
		break;
	case Unbind:
		netunbind(f);
		break;
	default:
		cmderror(cb, "unknown aoe control message");
	}
	poperror();
	free(cb);
	return n;
}

static long
aoewrite(Chan *c, void *db, long n, vlong off)
{
	switch(TYPE(c-&gt;qid)){
	default:
	case Qzero:
	case Qtopdir:
	case Qunitdir:
	case Qtoplog:
		error(Eperm);
	case Qtopctl:
		return topctlwrite(db, n);
	case Qctl:
	case Qdata:
	case Qconfig:
	case Qident:
		return unitwrite(c, db, n, off);
	}
}

Dev aoedevtab = {
	L'æ',
	"aoe",

	devreset,
	devinit,
	devshutdown,
	aoeattach,
	aoewalk,
	aoestat,
	aoeopen,
	devcreate,
	aoeclose,
	aoeread,
	devbread,
	aoewrite,
	devbwrite,
	aoeremove,
	devwstat,
	devpower,
	devconfig,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

