<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devbridge.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devbridge.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * IPv4 Ethernet bridge
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../ip/ip.h"
#include "../port/netif.h"
#include "../port/error.h"

typedef struct Bridge 	Bridge;
typedef struct Port 	Port;
typedef struct Centry	Centry;
typedef struct Iphdr	Iphdr;
typedef struct Tcphdr	Tcphdr;

enum
{
	Qtopdir=	1,		/* top level directory */

	Qbridgedir,			/* bridge* directory */
	Qbctl,
	Qstats,
	Qcache,
	Qlog,

	Qportdir,			/* directory for a protocol */
	Qpctl,
	Qlocal,
	Qstatus,

	MaxQ,

	Maxbridge=	4,
	Maxport=	128,		// power of 2
	CacheHash=	257,		// prime
	CacheLook=	5,		// how many cache entries to examine
	CacheSize=	(CacheHash+CacheLook-1),
	CacheTimeout=	5*60,		// timeout for cache entry in seconds

	TcpMssMax = 1300,		// max desirable Tcp MSS value
	TunnelMtu = 1400,
};

static Dirtab bridgedirtab[]={
	"ctl",		{Qbctl},	0,	0666,
	"stats",	{Qstats},	0,	0444,
	"cache",	{Qcache},	0,	0444,
	"log",		{Qlog},		0,	0666,
};

static Dirtab portdirtab[]={
	"ctl",		{Qpctl},	0,	0666,
	"local",	{Qlocal},	0,	0444,
	"status",	{Qstatus},	0,	0444,
};

enum {
	Logcache=	(1&lt;&lt;0),
	Logmcast=	(1&lt;&lt;1),
};

// types of interfaces
enum
{
	Tether,
	Ttun,
};

static Logflag logflags[] =
{
	{ "cache",	Logcache, },
	{ "multicast",	Logmcast, },
	{ nil,		0, },
};

static Dirtab	*dirtab[MaxQ];

#define TYPE(x) 	(((ulong)(x).path) &amp; 0xff)
#define PORT(x) 	((((ulong)(x).path) &gt;&gt; 8)&amp;(Maxport-1))
#define QID(x, y) 	(((x)&lt;&lt;8) | (y))

struct Centry
{
	uchar	d[Eaddrlen];
	int	port;
	long	expire;		// entry expires this many seconds after bootime
	long	src;
	long	dst;
};

struct Bridge
{
	QLock;
	int	nport;
	Port	*port[Maxport];
	Centry	cache[CacheSize];
	ulong	hit;
	ulong	miss;
	ulong	copy;
	long	delay0;		// constant microsecond delay per packet
	long	delayn;		// microsecond delay per byte
	int	tcpmss;		// modify tcpmss value

	Log;
};

struct Port
{
	int	id;
	Bridge	*bridge;
	int	ref;
	int	closed;

	Chan	*data[2];	// channel to data

	Proc	*readp;		// read proc
	
	// the following uniquely identifies the port
	int	type;
	char	name[KNAMELEN];
	
	// owner hash - avoids bind/unbind races
	ulong	ownhash;

	// various stats
	int	in;		// number of packets read
	int	inmulti;	// multicast or broadcast
	int	inunknown;	// unknown address
	int	out;		// number of packets read
	int	outmulti;	// multicast or broadcast
	int	outunknown;	// unknown address
	int	outfrag;	// fragmented the packet
	int	nentry;		// number of cache entries for this port
};

enum {
	IP_TCPPROTO	= 6,
	EOLOPT		= 0,
	NOOPOPT		= 1,
	MSSOPT		= 2,
	MSS_LENGTH	= 4,		/* Mean segment size */
	SYN		= 0x02,		/* Pkt. is synchronise */
	IPHDR		= 20,		/* sizeof(Iphdr) */
};

struct Iphdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* ip-&gt;identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;		/* Time to live */
	uchar	proto;		/* Protocol */
	uchar	cksum[2];	/* Header checksum */
	uchar	src[4];		/* IP source */
	uchar	dst[4];		/* IP destination */
};

struct Tcphdr
{
	uchar	sport[2];
	uchar	dport[2];
	uchar	seq[4];
	uchar	ack[4];
	uchar	flag[2];
	uchar	win[2];
	uchar	cksum[2];
	uchar	urg[2];
};

static Bridge bridgetab[Maxbridge];

static int m2p[] = {
	[OREAD]		4,
	[OWRITE]	2,
	[ORDWR]		6
};

static int	bridgegen(Chan *c, char*, Dirtab*, int, int s, Dir *dp);
static void	portbind(Bridge *b, int argc, char *argv[]);
static void	portunbind(Bridge *b, int argc, char *argv[]);
static void	etherread(void *a);
static char	*cachedump(Bridge *b);
static void	portfree(Port *port);
static void	cacheflushport(Bridge *b, int port);
static void	etherwrite(Port *port, Block *bp);

static void
bridgeinit(void)
{
	int i;
	Dirtab *dt;

	// setup dirtab with non directory entries
	for(i=0; i&lt;nelem(bridgedirtab); i++) {
		dt = bridgedirtab + i;
		dirtab[TYPE(dt-&gt;qid)] = dt;
	}
	for(i=0; i&lt;nelem(portdirtab); i++) {
		dt = portdirtab + i;
		dirtab[TYPE(dt-&gt;qid)] = dt;
	}
}

static Chan*
bridgeattach(char* spec)
{
	Chan *c;
	int dev;

	dev = atoi(spec);
	if(dev&lt;0 || dev &gt;= Maxbridge)
		error("bad specification");

	c = devattach('B', spec);
	mkqid(&amp;c-&gt;qid, QID(0, Qtopdir), 0, QTDIR);
	c-&gt;dev = dev;
	return c;
}

static Walkqid*
bridgewalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, (Dirtab*)0, 0, bridgegen);
}

static int
bridgestat(Chan* c, uchar* db, int n)
{
	return devstat(c, db, n, (Dirtab *)0, 0L, bridgegen);
}

static Chan*
bridgeopen(Chan* c, int omode)
{
	int perm;
	Bridge *b;

	omode &amp;= 3;
	perm = m2p[omode];
	USED(perm);

	b = bridgetab + c-&gt;dev;
	USED(b);

	switch(TYPE(c-&gt;qid)) {
	default:
		break;
	case Qlog:
		logopen(b);
		break;
	case Qcache:
		c-&gt;aux = cachedump(b);
		break;
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static void
bridgeclose(Chan* c)
{
	Bridge *b  = bridgetab + c-&gt;dev;

	switch(TYPE(c-&gt;qid)) {
	case Qcache:
		if(c-&gt;flag &amp; COPEN)
			free(c-&gt;aux);
		break;
	case Qlog:
		if(c-&gt;flag &amp; COPEN)
			logclose(b);
		break;
	}
}

static long
bridgeread(Chan *c, void *a, long n, vlong off)
{
	char buf[256];
	Bridge *b = bridgetab + c-&gt;dev;
	Port *port;
	int i, ingood, outgood;

	USED(off);
	switch(TYPE(c-&gt;qid)) {
	default:
		error(Eperm);
	case Qtopdir:
	case Qbridgedir:
	case Qportdir:
		return devdirread(c, a, n, 0, 0, bridgegen);
	case Qlog:
		return logread(b, a, off, n);
	case Qstatus:
		qlock(b);
		port = b-&gt;port[PORT(c-&gt;qid)];
		if(port == 0)
			strcpy(buf, "unbound\n");
		else {
			i = 0;
			switch(port-&gt;type) {
			default:
				panic("bridgeread: unknown port type: %d",
					port-&gt;type);
			case Tether:
				i += snprint(buf+i, sizeof(buf)-i, "ether %s: ", port-&gt;name);
				break;
			case Ttun:
				i += snprint(buf+i, sizeof(buf)-i, "tunnel %s: ", port-&gt;name);
				break;
			}
			ingood = port-&gt;in - port-&gt;inmulti - port-&gt;inunknown;
			outgood = port-&gt;out - port-&gt;outmulti - port-&gt;outunknown;
			i += snprint(buf+i, sizeof(buf)-i,
				"in=%d(%d:%d:%d) out=%d(%d:%d:%d:%d)\n",
				port-&gt;in, ingood, port-&gt;inmulti, port-&gt;inunknown,
				port-&gt;out, outgood, port-&gt;outmulti,
				port-&gt;outunknown, port-&gt;outfrag);
			USED(i);
		}
		n = readstr(off, a, n, buf);
		qunlock(b);
		return n;
	case Qbctl:
		snprint(buf, sizeof(buf), "%s tcpmss\ndelay %ld %ld\n",
			b-&gt;tcpmss ? "set" : "clear", b-&gt;delay0, b-&gt;delayn);
		n = readstr(off, a, n, buf);
		return n;
	case Qcache:
		n = readstr(off, a, n, c-&gt;aux);
		return n;
	case Qstats:
		snprint(buf, sizeof(buf), "hit=%uld miss=%uld copy=%uld\n",
			b-&gt;hit, b-&gt;miss, b-&gt;copy);
		n = readstr(off, a, n, buf);
		return n;
	}
}

static void
bridgeoption(Bridge *b, char *option, int value)
{
	if(strcmp(option, "tcpmss") == 0)
		b-&gt;tcpmss = value;
	else
		error("unknown bridge option");
}


static long
bridgewrite(Chan *c, void *a, long n, vlong off)
{
	Bridge *b = bridgetab + c-&gt;dev;
	Cmdbuf *cb;
	char *arg0, *p;
	
	USED(off);
	switch(TYPE(c-&gt;qid)) {
	default:
		error(Eperm);
	case Qbctl:
		cb = parsecmd(a, n);
		qlock(b);
		if(waserror()) {
			qunlock(b);
			free(cb);
			nexterror();
		}
		if(cb-&gt;nf == 0)
			error("short write");
		arg0 = cb-&gt;f[0];
		if(strcmp(arg0, "bind") == 0) {
			portbind(b, cb-&gt;nf-1, cb-&gt;f+1);
		} else if(strcmp(arg0, "unbind") == 0) {
			portunbind(b, cb-&gt;nf-1, cb-&gt;f+1);
		} else if(strcmp(arg0, "cacheflush") == 0) {
			log(b, Logcache, "cache flush\n");
			memset(b-&gt;cache, 0, CacheSize*sizeof(Centry));
		} else if(strcmp(arg0, "set") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: set option");
			bridgeoption(b, cb-&gt;f[1], 1);
		} else if(strcmp(arg0, "clear") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: clear option");
			bridgeoption(b, cb-&gt;f[1], 0);
		} else if(strcmp(arg0, "delay") == 0) {
			if(cb-&gt;nf != 3)
				error("usage: delay delay0 delayn");
			b-&gt;delay0 = strtol(cb-&gt;f[1], nil, 10);
			b-&gt;delayn = strtol(cb-&gt;f[2], nil, 10);
		} else
			error("unknown control request");
		poperror();
		qunlock(b);
		free(cb);
		return n;
	case Qlog:
		cb = parsecmd(a, n);
		p = logctl(b, cb-&gt;nf, cb-&gt;f, logflags);
		free(cb);
		if(p != nil)
			error(p);
		return n;
	}
}

static int
bridgegen(Chan *c, char *, Dirtab*, int, int s, Dir *dp)
{
	Bridge *b = bridgetab + c-&gt;dev;
	int type = TYPE(c-&gt;qid);
	Dirtab *dt;
	Qid qid;

	if(s  == DEVDOTDOT){
		switch(TYPE(c-&gt;qid)){
		case Qtopdir:
		case Qbridgedir:
			snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "#B%ld", c-&gt;dev);
			mkqid(&amp;qid, Qtopdir, 0, QTDIR);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		case Qportdir:
			snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "bridge%ld", c-&gt;dev);
			mkqid(&amp;qid, Qbridgedir, 0, QTDIR);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		default:
			panic("bridgewalk %llux", c-&gt;qid.path);
		}
		return 1;
	}

	switch(type) {
	default:
		/* non-directory entries end up here */
		if(c-&gt;qid.type &amp; QTDIR)
			panic("bridgegen: unexpected directory");	
		if(s != 0)
			return -1;
		dt = dirtab[TYPE(c-&gt;qid)];
		if(dt == nil)
			panic("bridgegen: unknown type: %lud", TYPE(c-&gt;qid));
		devdir(c, c-&gt;qid, dt-&gt;name, dt-&gt;length, eve, dt-&gt;perm, dp);
		return 1;
	case Qtopdir:
		if(s != 0)
			return -1;
		snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "bridge%ld", c-&gt;dev);
		mkqid(&amp;qid, QID(0, Qbridgedir), 0, QTDIR);
		devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
		return 1;
	case Qbridgedir:
		if(s&lt;nelem(bridgedirtab)) {
			dt = bridgedirtab+s;
			devdir(c, dt-&gt;qid, dt-&gt;name, dt-&gt;length, eve, dt-&gt;perm, dp);
			return 1;
		}
		s -= nelem(bridgedirtab);
		if(s &gt;= b-&gt;nport)
			return -1;
		mkqid(&amp;qid, QID(s, Qportdir), 0, QTDIR);
		snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "%d", s);
		devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
		return 1;
	case Qportdir:
		if(s&gt;=nelem(portdirtab))
			return -1;
		dt = portdirtab+s;
		mkqid(&amp;qid, QID(PORT(c-&gt;qid),TYPE(dt-&gt;qid)), 0, QTFILE);
		devdir(c, qid, dt-&gt;name, dt-&gt;length, eve, dt-&gt;perm, dp);
		return 1;
	}
}

// parse mac address; also in netif.c
static int
parseaddr(uchar *to, char *from, int alen)
{
	char nip[4];
	char *p;
	int i;

	p = from;
	for(i = 0; i &lt; alen; i++){
		if(*p == 0)
			return -1;
		nip[0] = *p++;
		if(*p == 0)
			return -1;
		nip[1] = *p++;
		nip[2] = 0;
		to[i] = strtoul(nip, 0, 16);
		if(*p == ':')
			p++;
	}
	return 0;
}

// assumes b is locked
static void
portbind(Bridge *b, int argc, char *argv[])
{
	Port *port;
	Chan *ctl;
	int type = 0, i, n;
	ulong ownhash;
	char *dev, *dev2 = nil, *p;
	char buf[100], name[KNAMELEN], path[8*KNAMELEN];
	static char usage[] = "usage: bind ether|tunnel name ownhash dev [dev2]";

	memset(name, 0, KNAMELEN);
	if(argc &lt; 4)
		error(usage);
	if(strcmp(argv[0], "ether") == 0) {
		if(argc != 4)
			error(usage);
		type = Tether;
		strncpy(name, argv[1], KNAMELEN);
		name[KNAMELEN-1] = 0;
//		parseaddr(addr, argv[1], Eaddrlen);
	} else if(strcmp(argv[0], "tunnel") == 0) {
		if(argc != 5)
			error(usage);
		type = Ttun;
		strncpy(name, argv[1], KNAMELEN);
		name[KNAMELEN-1] = 0;
//		parseip(addr, argv[1]);
		dev2 = argv[4];
	} else
		error(usage);
	ownhash = atoi(argv[2]);
	dev = argv[3];
	for(i=0; i&lt;b-&gt;nport; i++) {
		port = b-&gt;port[i];
		if(port != nil &amp;&amp; port-&gt;type == type &amp;&amp;
		    memcmp(port-&gt;name, name, KNAMELEN) == 0)
			error("port in use");
	}
	for(i=0; i&lt;Maxport; i++)
		if(b-&gt;port[i] == nil)
			break;
	if(i == Maxport)
		error("no more ports");
	port = smalloc(sizeof(Port));
	port-&gt;ref = 1;
	port-&gt;id = i;
	port-&gt;ownhash = ownhash;

	if(waserror()) {
		portfree(port);
		nexterror();
	}
	port-&gt;type = type;
	memmove(port-&gt;name, name, KNAMELEN);
	switch(port-&gt;type) {
	default:
		panic("portbind: unknown port type: %d", type);
	case Tether:
		snprint(path, sizeof(path), "%s/clone", dev);
		ctl = namec(path, Aopen, ORDWR, 0);
		if(waserror()) {
			cclose(ctl);
			nexterror();
		}
		// check addr?

		// get directory name
		n = devtab[ctl-&gt;type]-&gt;read(ctl, buf, sizeof(buf), 0);
		buf[n] = 0;
		for(p = buf; *p == ' '; p++)
			;
		snprint(path, sizeof(path), "%s/%lud/data", dev, strtoul(p, 0, 0));

		// setup connection to be promiscuous
		snprint(buf, sizeof(buf), "connect -1");
		devtab[ctl-&gt;type]-&gt;write(ctl, buf, strlen(buf), 0);
		snprint(buf, sizeof(buf), "promiscuous");
		devtab[ctl-&gt;type]-&gt;write(ctl, buf, strlen(buf), 0);
		snprint(buf, sizeof(buf), "bridge");
		devtab[ctl-&gt;type]-&gt;write(ctl, buf, strlen(buf), 0);

		// open data port
		port-&gt;data[0] = namec(path, Aopen, ORDWR, 0);
		// dup it
		incref(port-&gt;data[0]);
		port-&gt;data[1] = port-&gt;data[0];

		poperror();
		cclose(ctl);		

		break;
	case Ttun:
		port-&gt;data[0] = namec(dev, Aopen, OREAD, 0);
		port-&gt;data[1] = namec(dev2, Aopen, OWRITE, 0);
		break;
	}

	poperror();

	/* committed to binding port */
	b-&gt;port[port-&gt;id] = port;
	port-&gt;bridge = b;
	if(b-&gt;nport &lt;= port-&gt;id)
		b-&gt;nport = port-&gt;id+1;

	// assumes kproc always succeeds
	kproc("etherread", etherread, port);	// poperror must be next
	port-&gt;ref++;
}

// assumes b is locked
static void
portunbind(Bridge *b, int argc, char *argv[])
{
	int type = 0, i;
	char name[KNAMELEN];
	ulong ownhash;
	Port *port = nil;
	static char usage[] = "usage: unbind ether|tunnel addr [ownhash]";

	memset(name, 0, KNAMELEN);
	if(argc &lt; 2 || argc &gt; 3)
		error(usage);
	if(strcmp(argv[0], "ether") == 0) {
		type = Tether;
		strncpy(name, argv[1], KNAMELEN);
		name[KNAMELEN-1] = 0;
//		parseaddr(addr, argv[1], Eaddrlen);
	} else if(strcmp(argv[0], "tunnel") == 0) {
		type = Ttun;
		strncpy(name, argv[1], KNAMELEN);
		name[KNAMELEN-1] = 0;
//		parseip(addr, argv[1]);
	} else
		error(usage);
	if(argc == 3)
		ownhash = atoi(argv[2]);
	else
		ownhash = 0;
	for(i=0; i&lt;b-&gt;nport; i++) {
		port = b-&gt;port[i];
		if(port != nil &amp;&amp; port-&gt;type == type &amp;&amp;
		    memcmp(port-&gt;name, name, KNAMELEN) == 0)
			break;
	}
	if(i == b-&gt;nport)
		error("port not found");
	if(ownhash != 0 &amp;&amp; port-&gt;ownhash != 0 &amp;&amp; ownhash != port-&gt;ownhash)
		error("bad owner hash");

	port-&gt;closed = 1;
	b-&gt;port[i] = nil;	// port is now unbound
	cacheflushport(b, i);

	// try and stop reader
	if(port-&gt;readp)
		postnote(port-&gt;readp, 1, "unbind", 0);
	portfree(port);
}

// assumes b is locked
static Centry *
cachelookup(Bridge *b, uchar d[Eaddrlen])
{
	int i;
	uint h;
	Centry *p;
	long sec;

	// dont cache multicast or broadcast
	if(d[0] &amp; 1)
		return 0;

	h = 0;
	for(i=0; i&lt;Eaddrlen; i++) {
		h *= 7;
		h += d[i];
	}
	h %= CacheHash;
	p = b-&gt;cache + h;
	sec = TK2SEC(m-&gt;ticks);
	for(i=0; i&lt;CacheLook; i++,p++) {
		if(memcmp(d, p-&gt;d, Eaddrlen) == 0) {
			p-&gt;dst++;
			if(sec &gt;= p-&gt;expire) {
				log(b, Logcache, "expired cache entry: %E %d\n",
					d, p-&gt;port);
				return nil;
			}
			p-&gt;expire = sec + CacheTimeout;
			return p;
		}
	}
	log(b, Logcache, "cache miss: %E\n", d);
	return nil;
}

// assumes b is locked
static void
cacheupdate(Bridge *b, uchar d[Eaddrlen], int port)
{
	int i;
	uint h;
	Centry *p, *pp;
	long sec;

	// dont cache multicast or broadcast
	if(d[0] &amp; 1) {
		log(b, Logcache, "bad source address: %E\n", d);
		return;
	}
	
	h = 0;
	for(i=0; i&lt;Eaddrlen; i++) {
		h *= 7;
		h += d[i];
	}
	h %= CacheHash;
	p = b-&gt;cache + h;
	pp = p;
	sec = p-&gt;expire;

	// look for oldest entry
	for(i=0; i&lt;CacheLook; i++,p++) {
		if(memcmp(p-&gt;d, d, Eaddrlen) == 0) {
			p-&gt;expire = TK2SEC(m-&gt;ticks) + CacheTimeout;
			if(p-&gt;port != port) {
				log(b, Logcache, "NIC changed port %d-&gt;%d: %E\n",
					p-&gt;port, port, d);
				p-&gt;port = port;
			}
			p-&gt;src++;
			return;
		}
		if(p-&gt;expire &lt; sec) {
			sec = p-&gt;expire;
			pp = p;
		}
	}
	if(pp-&gt;expire != 0)
		log(b, Logcache, "bumping from cache: %E %d\n", pp-&gt;d, pp-&gt;port);
	pp-&gt;expire = TK2SEC(m-&gt;ticks) + CacheTimeout;
	memmove(pp-&gt;d, d, Eaddrlen);
	pp-&gt;port = port;
	pp-&gt;src = 1;
	pp-&gt;dst = 0;
	log(b, Logcache, "adding to cache: %E %d\n", pp-&gt;d, pp-&gt;port);
}

// assumes b is locked
static void
cacheflushport(Bridge *b, int port)
{
	Centry *ce;
	int i;

	ce = b-&gt;cache;
	for(i=0; i&lt;CacheSize; i++,ce++) {
		if(ce-&gt;port != port)
			continue;
		memset(ce, 0, sizeof(Centry));
	}
}

static char *
cachedump(Bridge *b)
{
	int i, n;
	long sec, off;
	char *buf, *p, *ep;
	Centry *ce;
	char c;

	qlock(b);
	if(waserror()) {
		qunlock(b);
		nexterror();
	}
	sec = TK2SEC(m-&gt;ticks);
	n = 0;
	for(i=0; i&lt;CacheSize; i++)
		if(b-&gt;cache[i].expire != 0)
			n++;
	
	n *= 51;	// change if print format is changed
	n += 10;	// some slop at the end
	buf = malloc(n);
	if(buf == nil)
		error(Enomem);
	p = buf;
	ep = buf + n;
	ce = b-&gt;cache;
	off = seconds() - sec;
	for(i=0; i&lt;CacheSize; i++,ce++) {
		if(ce-&gt;expire == 0)
			continue;	
		c = (sec &lt; ce-&gt;expire)?'v':'e';
		p += snprint(p, ep-p, "%E %2d %10ld %10ld %10ld %c\n", ce-&gt;d,
			ce-&gt;port, ce-&gt;src, ce-&gt;dst, ce-&gt;expire+off, c);
	}
	*p = 0;
	poperror();
	qunlock(b);

	return buf;
}



// assumes b is locked
static void
ethermultiwrite(Bridge *b, Block *bp, Port *port)
{
	Port *oport;
	Block *bp2;
	Etherpkt *ep;
	int i, mcast;

	if(waserror()) {
		if(bp)
			freeb(bp);
		nexterror();
	}
	
	ep = (Etherpkt*)bp-&gt;rp;
	mcast = ep-&gt;d[0] &amp; 1;		/* multicast bit of ethernet address */

	oport = nil;
	for(i=0; i&lt;b-&gt;nport; i++) {
		if(i == port-&gt;id || b-&gt;port[i] == nil)
			continue;
		/*
		 * we need to forward multicast packets for ipv6,
		 * so always do it.
		 */
		if(mcast)
			b-&gt;port[i]-&gt;outmulti++;
		else
			b-&gt;port[i]-&gt;outunknown++;

		// delay one so that the last write does not copy
		if(oport != nil) {
			b-&gt;copy++;
			bp2 = copyblock(bp, blocklen(bp));
			if(!waserror()) {
				etherwrite(oport, bp2);
				poperror();
			}
		}
		oport = b-&gt;port[i];
	}

	// last write free block
	if(oport) {
		bp2 = bp; bp = nil; USED(bp);
		if(!waserror()) {
			etherwrite(oport, bp2);
			poperror();
		}
	} else
		freeb(bp);

	poperror();
}

static void
tcpmsshack(Etherpkt *epkt, int n)
{
	int hl, optlen;
	Iphdr *iphdr;
	Tcphdr *tcphdr;
	ulong mss, cksum;
	uchar *optr;

	/* ignore non-ipv4 packets */
	if(nhgets(epkt-&gt;type) != ETIP4)
		return;
	iphdr = (Iphdr*)(epkt-&gt;data);
	n -= ETHERHDRSIZE;
	if(n &lt; IPHDR)
		return;

	/* ignore bad packets */
	if(iphdr-&gt;vihl != (IP_VER4|IP_HLEN4)) {
		hl = (iphdr-&gt;vihl&amp;0xF)&lt;&lt;2;
		if((iphdr-&gt;vihl&amp;0xF0) != IP_VER4 || hl &lt; (IP_HLEN4&lt;&lt;2))
			return;
	} else
		hl = IP_HLEN4&lt;&lt;2;

	/* ignore non-tcp packets */
	if(iphdr-&gt;proto != IP_TCPPROTO)
		return;
	n -= hl;
	if(n &lt; sizeof(Tcphdr))
		return;
	tcphdr = (Tcphdr*)((uchar*)(iphdr) + hl);
	// MSS can only appear in SYN packet
	if(!(tcphdr-&gt;flag[1] &amp; SYN))
		return;
	hl = (tcphdr-&gt;flag[0] &amp; 0xf0)&gt;&gt;2;
	if(n &lt; hl)
		return;

	// check for MSS option
	optr = (uchar*)tcphdr + sizeof(Tcphdr);
	n = hl - sizeof(Tcphdr);
	for(;;) {
		if(n &lt;= 0 || *optr == EOLOPT)
			return;
		if(*optr == NOOPOPT) {
			n--;
			optr++;
			continue;
		}
		optlen = optr[1];
		if(optlen &lt; 2 || optlen &gt; n)
			return;
		if(*optr == MSSOPT &amp;&amp; optlen == MSS_LENGTH)
			break;
		n -= optlen;
		optr += optlen;
	}

	mss = nhgets(optr+2);
	if(mss &lt;= TcpMssMax)
		return;
	// fit checksum
	cksum = nhgets(tcphdr-&gt;cksum);
	if(optr-(uchar*)tcphdr &amp; 1) {
print("tcpmsshack: odd alignment!\n");
		// odd alignments are a pain
		cksum += nhgets(optr+1);
		cksum -= (optr[1]&lt;&lt;8)|(TcpMssMax&gt;&gt;8);
		cksum += (cksum&gt;&gt;16);
		cksum &amp;= 0xffff;
		cksum += nhgets(optr+3);
		cksum -= ((TcpMssMax&amp;0xff)&lt;&lt;8)|optr[4];
		cksum += (cksum&gt;&gt;16);
	} else {
		cksum += mss;
		cksum -= TcpMssMax;
		cksum += (cksum&gt;&gt;16);
	}
	hnputs(tcphdr-&gt;cksum, cksum);
	hnputs(optr+2, TcpMssMax);
}

/*
 *  process to read from the ethernet
 */
static void
etherread(void *a)
{
	Port *port = a;
	Bridge *b = port-&gt;bridge;
	Block *bp, *bp2;
	Etherpkt *ep;
	Centry *ce;
	long md;
	
	qlock(b);
	port-&gt;readp = up;	/* hide identity under a rock for unbind */

	while(!port-&gt;closed){
		// release lock to read - error means it is time to quit
		qunlock(b);
		if(waserror()) {
			print("etherread read error: %s\n", up-&gt;errstr);
			qlock(b);
			break;
		}
		if(0)
			print("devbridge: etherread: reading\n");
		bp = devtab[port-&gt;data[0]-&gt;type]-&gt;bread(port-&gt;data[0],
			ETHERMAXTU, 0);
		if(0)
			print("devbridge: etherread: blocklen = %d\n",
				blocklen(bp));
		poperror();
		qlock(b);
		if(bp == nil || port-&gt;closed)
			break;
		if(waserror()) {
//			print("etherread bridge error\n");
			if(bp)
				freeb(bp);
			continue;
		}
		if(blocklen(bp) &lt; ETHERMINTU)
			error("short packet");
		port-&gt;in++;

		ep = (Etherpkt*)bp-&gt;rp;
		cacheupdate(b, ep-&gt;s, port-&gt;id);
		if(b-&gt;tcpmss)
			tcpmsshack(ep, BLEN(bp));

		/*
		 * delay packets to simulate a slow link
		 */
		if(b-&gt;delay0 || b-&gt;delayn){
			md = b-&gt;delay0 + b-&gt;delayn * BLEN(bp);
			if(md &gt; 0)
				microdelay(md);
		}

		if(ep-&gt;d[0] &amp; 1) {
			log(b, Logmcast, "multicast: port=%d src=%E dst=%E type=%#.4ux\n",
				port-&gt;id, ep-&gt;s, ep-&gt;d, ep-&gt;type[0]&lt;&lt;8|ep-&gt;type[1]);
			port-&gt;inmulti++;
			bp2 = bp; bp = nil;
			ethermultiwrite(b, bp2, port);
		} else {
			ce = cachelookup(b, ep-&gt;d);
			if(ce == nil) {
				b-&gt;miss++;
				port-&gt;inunknown++;
				bp2 = bp; bp = nil;
				ethermultiwrite(b, bp2, port);
			}else if(ce-&gt;port != port-&gt;id){
				b-&gt;hit++;
				bp2 = bp; bp = nil;
				etherwrite(b-&gt;port[ce-&gt;port], bp2);
			}
		}

		poperror();
		if(bp)
			freeb(bp);
	}
//	print("etherread: trying to exit\n");
	port-&gt;readp = nil;
	portfree(port);
	qunlock(b);
	pexit("hangup", 1);
}

static int
fragment(Etherpkt *epkt, int n)
{
	Iphdr *iphdr;

	if(n &lt;= TunnelMtu)
		return 0;

	/* ignore non-ipv4 packets */
	if(nhgets(epkt-&gt;type) != ETIP4)
		return 0;
	iphdr = (Iphdr*)(epkt-&gt;data);
	n -= ETHERHDRSIZE;
	/*
	 * ignore: IP runt packets, bad packets (I don't handle IP
	 * options for the moment), packets with don't-fragment set,
	 * and short blocks.
	 */
	if(n &lt; IPHDR || iphdr-&gt;vihl != (IP_VER4|IP_HLEN4) ||
	    iphdr-&gt;frag[0] &amp; (IP_DF&gt;&gt;8) || nhgets(iphdr-&gt;length) &gt; n)
		return 0;

	return 1;
}


static void
etherwrite(Port *port, Block *bp)
{
	Iphdr *eh, *feh;
	Etherpkt *epkt;
	int n, lid, len, seglen, chunk, dlen, blklen, offset, mf;
	Block *xp, *nb;
	ushort fragoff, frag;

	port-&gt;out++;
	epkt = (Etherpkt*)bp-&gt;rp;
	n = blocklen(bp);
	if(port-&gt;type != Ttun || !fragment(epkt, n)) {
		devtab[port-&gt;data[1]-&gt;type]-&gt;bwrite(port-&gt;data[1], bp, 0);
		return;
	}
	port-&gt;outfrag++;
	if(waserror()){
		freeblist(bp);	
		nexterror();
	}

	seglen = (TunnelMtu - ETHERHDRSIZE - IPHDR) &amp; ~7;
	eh = (Iphdr*)(epkt-&gt;data);
	len = nhgets(eh-&gt;length);
	frag = nhgets(eh-&gt;frag);
	mf = frag &amp; IP_MF;
	frag &lt;&lt;= 3;
	dlen = len - IPHDR;
	xp = bp;
	lid = nhgets(eh-&gt;id);
	offset = ETHERHDRSIZE+IPHDR;
	while(xp != nil &amp;&amp; offset &amp;&amp; offset &gt;= BLEN(xp)) {
		offset -= BLEN(xp);
		xp = xp-&gt;next;
	}
	xp-&gt;rp += offset;
	
	if(0)
		print("seglen=%d, dlen=%d, mf=%x, frag=%d\n",
			seglen, dlen, mf, frag);
	for(fragoff = 0; fragoff &lt; dlen; fragoff += seglen) {
		nb = allocb(ETHERHDRSIZE+IPHDR+seglen);
		
		feh = (Iphdr*)(nb-&gt;wp+ETHERHDRSIZE);

		memmove(nb-&gt;wp, epkt, ETHERHDRSIZE+IPHDR);
		nb-&gt;wp += ETHERHDRSIZE+IPHDR;

		if((fragoff + seglen) &gt;= dlen) {
			seglen = dlen - fragoff;
			hnputs(feh-&gt;frag, (frag+fragoff)&gt;&gt;3 | mf);
		}
		else	
			hnputs(feh-&gt;frag, (frag+fragoff&gt;&gt;3) | IP_MF);

		hnputs(feh-&gt;length, seglen + IPHDR);
		hnputs(feh-&gt;id, lid);

		/* Copy up the data area */
		chunk = seglen;
		while(chunk) {
			blklen = chunk;
			if(BLEN(xp) &lt; chunk)
				blklen = BLEN(xp);
			memmove(nb-&gt;wp, xp-&gt;rp, blklen);
			nb-&gt;wp += blklen;
			xp-&gt;rp += blklen;
			chunk -= blklen;
			if(xp-&gt;rp == xp-&gt;wp)
				xp = xp-&gt;next;
		} 

		feh-&gt;cksum[0] = 0;
		feh-&gt;cksum[1] = 0;
		hnputs(feh-&gt;cksum, ipcsum(&amp;feh-&gt;vihl));
	
		/* don't generate small packets */
		if(BLEN(nb) &lt; ETHERMINTU)
			nb-&gt;wp = nb-&gt;rp + ETHERMINTU;
		devtab[port-&gt;data[1]-&gt;type]-&gt;bwrite(port-&gt;data[1], nb, 0);
	}
	poperror();
	freeblist(bp);	
}

// hold b lock
static void
portfree(Port *port)
{
	port-&gt;ref--;
	if(port-&gt;ref &lt; 0)
		panic("portfree: bad ref");
	if(port-&gt;ref &gt; 0)
		return;

	if(port-&gt;data[0])
		cclose(port-&gt;data[0]);
	if(port-&gt;data[1])
		cclose(port-&gt;data[1]);
	memset(port, 0, sizeof(Port));
	free(port);
}

Dev bridgedevtab = {
	'B',
	"bridge",

	devreset,
	bridgeinit,
	devshutdown,
	bridgeattach,
	bridgewalk,
	bridgestat,
	bridgeopen,
	devcreate,
	bridgeclose,
	bridgeread,
	devbread,
	bridgewrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

