<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devflash.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devflash.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * flash memory
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include "../port/flashif.h"

typedef struct Flashtype Flashtype;
struct Flashtype {
	char*	name;
	int	(*reset)(Flash*);
	Flashtype* next;
};

enum {
	Nbanks = 2,
};

static struct
{
	Flash*	card[Nbanks];	/* actual card type, reset for access */
	Flashtype* types;	/* possible card types */
}flash;

enum{
	Qtopdir,
	Qflashdir,
	Qdata,
	Qctl,
};

#define	TYPE(q)	((ulong)(q) &amp; 0xFF)
#define	PART(q)	((ulong)(q)&gt;&gt;8)
#define	QID(p,t)	(((p)&lt;&lt;8) | (t))

static	Flashregion*	flashregion(Flash*, ulong);
static	char*	flashnewpart(Flash*, char*, ulong, ulong);
static	ulong	flashaddr(Flash*, Flashpart*, char*);
static	void	protect(Flash*, ulong);
static	void	eraseflash(Flash*, Flashregion*, ulong);
static	long	readflash(Flash*, void*, long, int);
static	long	writeflash(Flash*, long, void*,int);

static char Eprotect[] = "flash region protected";

static int
flash2gen(Chan *c, ulong p, Dir *dp)
{
	Flashpart *fp;
	Flash *f;
	Qid q;
	int mode;

	f = flash.card[c-&gt;dev];
	fp = &amp;f-&gt;part[PART(p)];
	if(fp-&gt;name == nil)
		return 0;
	mkqid(&amp;q, p, 0, QTFILE);
	switch(TYPE(p)){
	case Qdata:
		mode = 0660;
		if(f-&gt;write == nil)
			mode = 0440;
		devdir(c, q, fp-&gt;name, fp-&gt;end-fp-&gt;start, eve, mode, dp);
		return 1;
	case Qctl:
		snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "%sctl", fp-&gt;name);
		/* no harm in letting everybody read the ctl files */
		devdir(c, q, up-&gt;genbuf, 0, eve, 0664, dp);
		return 1;
	default:
		return -1;
	}
}

static int
flashgen(Chan *c, char*, Dirtab*, int, int s, Dir *dp)
{
	Qid q;
	char *n;

	if(s == DEVDOTDOT){
		mkqid(&amp;q, QID(0, Qtopdir), 0, QTDIR);
		n = "#F";
		if(c-&gt;dev != 0){
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "#F%ld", c-&gt;dev);
			n = up-&gt;genbuf;
		}
		devdir(c, q, n, 0, eve, 0555, dp);
		return 1;
	}
	switch(TYPE(c-&gt;qid.path)){
	case Qtopdir:
		if(s != 0)
			break;
		mkqid(&amp;q, QID(0, Qflashdir), 0, QTDIR);
		n = "flash";
		if(c-&gt;dev != 0){
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "flash%ld",
				c-&gt;dev);
			n = up-&gt;genbuf;
		}
		devdir(c, q, n, 0, eve, 0555, dp);
		return 1;
	case Qflashdir:
		if(s &gt;= 2*nelem(flash.card[c-&gt;dev]-&gt;part))
			return -1;
		return flash2gen(c, QID(s&gt;&gt;1, s&amp;1?Qctl:Qdata), dp);
	case Qctl:
	case Qdata:
		return flash2gen(c, (ulong)c-&gt;qid.path, dp);
	}
	return -1;
}
		
static void
flashreset(void)
{
	Flash *f;
	Flashtype *t;
	char *e;
	int bank;

	for(bank = 0; bank &lt; Nbanks; bank++){
		f = malloc(sizeof(*f));
		if(f == nil){
			print("#F%d: can't allocate Flash data\n", bank);
			return;
		}
		f-&gt;cmask = ~(ulong)0;
		if(archflashreset(bank, f) &lt; 0 || f-&gt;type == nil ||
		    f-&gt;addr == nil){
			free(f);
			return;
		}
		for(t = flash.types; t != nil; t = t-&gt;next)
			if(strcmp(f-&gt;type, t-&gt;name) == 0)
				break;
		if(t == nil){
			iprint("#F%d: no flash driver for type %s (addr %p)\n",
				bank, f-&gt;type, f-&gt;addr);
			free(f);
			return;
		}
		f-&gt;reset = t-&gt;reset;
		f-&gt;protect = 1;
		if(f-&gt;reset(f) == 0){
			flash.card[bank] = f;
			iprint("#F%d: %s addr %#p len %lud width %d interleave %d\n",
//				bank, f-&gt;type, PADDR(f-&gt;addr), f-&gt;size,
				bank, f-&gt;type, f-&gt;addr, f-&gt;size,
				f-&gt;width, f-&gt;interleave);
			e = flashnewpart(f, "flash", 0, f-&gt;size);
			if(e != nil)
				panic("#F%d: couldn't init table: %s", bank, e);
		}else
			iprint("#F%d: %#p: reset failed (%s)\n",
				bank, f-&gt;addr, f-&gt;type);
	}
}

static Chan*
flashattach(char *spec)
{
	Flash *f;
	int bank;
	Chan *c;

	bank = strtol(spec, nil, 0);
	if(bank &lt; 0 || bank &gt;= Nbanks ||
	   (f = flash.card[bank]) == nil ||
	   f-&gt;attach != nil &amp;&amp; f-&gt;attach(f) &lt; 0)
		error(Enodev);
	c = devattach('F', spec);
	c-&gt;dev = bank;
	return c;
}

static Walkqid*
flashwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, nil, 0, flashgen);
}

static int
flashstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, nil, 0, flashgen);
}

static Chan*
flashopen(Chan *c, int omode)
{
	omode = openmode(omode);
	switch(TYPE(c-&gt;qid.path)){
	case Qdata:
	case Qctl:
		if(flash.card[c-&gt;dev] == nil)
			error(Enodev);
		break;
	}
	return devopen(c, omode, nil, 0, flashgen);
}

static void	 
flashclose(Chan*)
{
}

static long	 
flashread(Chan *c, void *buf, long n, vlong offset)
{
	Flash *f;
	Flashpart *fp;
	Flashregion *r;
	int i;
	ulong start, end;
	char *s, *o;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, buf, n, nil, 0, flashgen);

	f = flash.card[c-&gt;dev];
	fp = &amp;f-&gt;part[PART(c-&gt;qid.path)];
	if(fp-&gt;name == nil)
		error(Egreg);
	switch(TYPE(c-&gt;qid.path)){
	case Qdata:
		offset += fp-&gt;start;
		if(offset &gt;= fp-&gt;end)
			return 0;
		if(offset+n &gt; fp-&gt;end)
			n = fp-&gt;end - offset;
		n = readflash(f, buf, offset, n);
		if(n &lt; 0)
			error(Eio);
		return n;
	case Qctl:
		s = malloc(READSTR);
		if(s == nil)
			error(Enomem);
		if(waserror()){
			free(s);
			nexterror();
		}
		o = seprint(s, s+READSTR, "%#2.2ux %#4.4ux %d %q\n",
			f-&gt;id, f-&gt;devid, f-&gt;width, f-&gt;sort!=nil? f-&gt;sort: "nor");
		for(i=0; i&lt;f-&gt;nr; i++){
			r = &amp;f-&gt;regions[i];
			if(r-&gt;start &lt; fp-&gt;end &amp;&amp; fp-&gt;start &lt; r-&gt;end){
				start = r-&gt;start;
				if(fp-&gt;start &gt; start)
					start = fp-&gt;start;
				end = r-&gt;end;
				if(fp-&gt;end &lt; end)
					end = fp-&gt;end;
				o = seprint(o, s+READSTR, "%#8.8lux %#8.8lux %#8.8lux",
					start, end, r-&gt;erasesize);
				if(r-&gt;pagesize)
					o = seprint(o, s+READSTR, " %#8.8lux",
						r-&gt;pagesize);
				o = seprint(o, s+READSTR, "\n");
			}
		}
		n = readstr(offset, buf, n, s);
		poperror();
		free(s);
		return n;
	}
	error(Egreg);
	return 0;		/* not reached */
}

enum {
	CMerase,
	CMadd,
	CMremove,
	CMsync,
	CMprotectboot,
};

static Cmdtab flashcmds[] = {
	{CMerase,	"erase",	2},
	{CMadd,		"add",		0},
	{CMremove,	"remove",	2},
	{CMsync,	"sync",		0},
	{CMprotectboot,	"protectboot",	0},
};

static long	 
flashwrite(Chan *c, void *buf, long n, vlong offset)
{
	Cmdbuf *cb;
	Cmdtab *ct;
	ulong addr, start, end;
	char *e;
	Flashpart *fp;
	Flashregion *r;
	Flash *f;

	f = flash.card[c-&gt;dev];
	fp = &amp;f-&gt;part[PART(c-&gt;qid.path)];
	if(fp-&gt;name == nil)
		error(Egreg);
	switch(TYPE(c-&gt;qid.path)){
	case Qdata:
		if(f-&gt;write == nil)
			error(Eperm);
		offset += fp-&gt;start;
		if(offset &gt;= fp-&gt;end)
			return 0;
		if(offset+n &gt; fp-&gt;end)
			n = fp-&gt;end - offset;
		n = writeflash(f, offset, buf, n);
		if(n &lt; 0)
			error(Eio);
		return n;
	case Qctl:
		cb = parsecmd(buf, n);
		if(waserror()){
			free(cb);
			nexterror();
		}
		ct = lookupcmd(cb, flashcmds, nelem(flashcmds));
		switch(ct-&gt;index){
		case CMerase:
			if(strcmp(cb-&gt;f[1], "all") != 0){
				addr = flashaddr(f, fp, cb-&gt;f[1]);
				r = flashregion(f, addr);
				if(r == nil)
					error("nonexistent flash region");
				if(addr%r-&gt;erasesize != 0)
					error("invalid erase block address");
				eraseflash(f, r, addr);
			}else if(fp-&gt;start == 0 &amp;&amp; fp-&gt;end == f-&gt;size &amp;&amp;
			    f-&gt;eraseall != nil){
				eraseflash(f, nil, 0);
			}else{
				for(addr = fp-&gt;start; addr &lt; fp-&gt;end;
				    addr += r-&gt;erasesize){
					r = flashregion(f, addr);
					if(r == nil)
						error("nonexistent flash region");
					if(addr%r-&gt;erasesize != 0)
						error("invalid erase block address");
					eraseflash(f, r, addr);
				}
			}
			break;
		case CMadd:
			if(cb-&gt;nf &lt; 3)
				error(Ebadarg);
			start = flashaddr(f, fp, cb-&gt;f[2]);
			if(cb-&gt;nf &gt; 3 &amp;&amp; strcmp(cb-&gt;f[3], "end") != 0)
				end = flashaddr(f, fp, cb-&gt;f[3]);
			else
				end = fp-&gt;end;
			if(start &gt; end || start &gt;= fp-&gt;end || end &gt; fp-&gt;end)
				error(Ebadarg);
			e = flashnewpart(f, cb-&gt;f[1], start, end);
			if(e != nil)
				error(e);
			break;
		case CMremove:
			/* TO DO */
			break;
		case CMprotectboot:
			if(cb-&gt;nf &gt; 1 &amp;&amp; strcmp(cb-&gt;f[1], "off") == 0)
				f-&gt;protect = 0;
			else
				f-&gt;protect = 1;
			break;
		case CMsync:
			/* TO DO? */
			break;
		default:
			error(Ebadarg);
		}
		poperror();
		free(cb);
		return n;
	}
	error(Egreg);
	return 0;		/* not reached */
}

static char*
flashnewpart(Flash *f, char *name, ulong start, ulong end)
{
	Flashpart *fp, *empty;
	int i;

	empty = nil;
	for(i = 0; i &lt; nelem(f-&gt;part); i++){
		fp = &amp;f-&gt;part[i];
		if(fp-&gt;name == nil){
			if(empty == nil)
				empty = fp;
		}else if(strcmp(fp-&gt;name, name) == 0)
			return Eexist;
	}
	if((fp = empty) == nil)
		return "partition table full";
//	fp-&gt;name = nil;
	kstrdup(&amp;fp-&gt;name, name);
	if(fp-&gt;name == nil)
		return Enomem;
	fp-&gt;start = start;
	fp-&gt;end = end;
	return nil;
}

static ulong
flashaddr(Flash *f, Flashpart *fp, char *s)
{
	Flashregion *r;
	ulong addr;

	addr = strtoul(s, &amp;s, 0);
	if(*s)
		error(Ebadarg);
	if(fp-&gt;name == nil)
		error("partition removed");
	addr += fp-&gt;start;
	r = flashregion(f, addr);
	if(r != nil &amp;&amp; addr%r-&gt;erasesize != 0)
		error("invalid erase unit address");
	if(addr &lt; fp-&gt;start || addr &gt; fp-&gt;end || addr &gt; f-&gt;size)
		error(Ebadarg);
	return addr;
}

static Flashregion*
flashregion(Flash *f, ulong a)
{
	int i;
	Flashregion *r;

	for(i=0; i&lt;f-&gt;nr; i++){
		r = &amp;f-&gt;regions[i];
		if(r-&gt;start &lt;= a &amp;&amp; a &lt; r-&gt;end)
			return r;
	}
	return nil;
}

Dev flashdevtab = {
	'F',
	"flash",

	flashreset,
	devinit,
	devshutdown,
	flashattach,
	flashwalk,
	flashstat,
	flashopen,
	devcreate,
	flashclose,
	flashread,
	devbread,
	flashwrite,
	devbwrite,
	devremove,
	devwstat,
};

/*
 * called by flash card types named in link section (eg, flashamd.c)
 */
void
addflashcard(char *name, int (*reset)(Flash*))
{
	Flashtype *f, **l;

	f = (Flashtype*)malloc(sizeof(*f));
	if(f == nil)
		error(Enomem);
	f-&gt;name = name;
	f-&gt;reset = reset;
	f-&gt;next = nil;
	for(l = &amp;flash.types; *l != nil; l = &amp;(*l)-&gt;next)
		;
	*l = f;
}

static long
readflash(Flash *f, void *buf, long offset, int n)
{
	int r, width, wmask;
	uchar tmp[16];
	uchar *p;
	ulong o;

	if(offset &lt; 0 || offset+n &gt; f-&gt;size)
		error(Ebadarg);
	qlock(f);
	if(waserror()){
		qunlock(f);
		nexterror();
	}
	if(f-&gt;read != nil){
		width = f-&gt;width;
		wmask = width-1;
		p = buf;
		if(offset &amp; wmask) {
			o = offset &amp; ~wmask;
			if(f-&gt;read(f, o, (ulong*)tmp, width) &lt; 0)
				error(Eio);
			memmove(tmp, (uchar*)f-&gt;addr + o, width);
			for(; n &gt; 0 &amp;&amp; offset &amp; wmask; n--)
				*p++ = tmp[offset++ &amp; wmask];
		}
		r = n &amp; wmask;
		n &amp;= ~wmask;
		if(n){
			if(f-&gt;read(f, offset, (ulong*)p, n) &lt; 0)
				error(Eio);
			offset += n;
			p += n;
		}
		if(r){
			if(f-&gt;read(f, offset, (ulong*)tmp, width))
				error(Eio);
			memmove(p, tmp, r);
		}
	}else
		/* assumes hardware supports byte access */
		memmove(buf, (uchar*)f-&gt;addr+offset, n);
	poperror();
	qunlock(f);
	return n;
}

static long
writeflash(Flash *f, long offset, void *buf, int n)
{
	uchar tmp[16];
	uchar *p;
	ulong o;
	int r, width, wmask;
	Flashregion *rg;

	if(f-&gt;write == nil || offset &lt; 0 || offset+n &gt; f-&gt;size)
		error(Ebadarg);
	rg = flashregion(f, offset);
	if(f-&gt;protect &amp;&amp; rg != nil &amp;&amp; rg-&gt;start == 0 &amp;&amp; offset &lt; rg-&gt;erasesize)
		error(Eprotect);
	width = f-&gt;width;
	wmask = width-1;
	qlock(f);
	archflashwp(f, 0);
	if(waserror()){
		archflashwp(f, 1);
		qunlock(f);
		nexterror();
	}
	p = buf;
	if(offset&amp;wmask){
		o = offset &amp; ~wmask;
		if(f-&gt;read != nil){
			if(f-&gt;read(f, o, tmp, width) &lt; 0)
				error(Eio);
		}else
			memmove(tmp, (uchar*)f-&gt;addr+o, width);
		for(; n &gt; 0 &amp;&amp; offset&amp;wmask; n--)
			tmp[offset++&amp;wmask] = *p++;
		if(f-&gt;write(f, o, tmp, width) &lt; 0)
			error(Eio);
	}
	r = n&amp;wmask;
	n &amp;= ~wmask;
	if(n){
		if(f-&gt;write(f, offset, p, n) &lt; 0)
			error(Eio);
		offset += n;
		p += n;
	}
	if(r){
		if(f-&gt;read != nil){
			if(f-&gt;read(f, offset, tmp, width) &lt; 0)
				error(Eio);
		}else
			memmove(tmp, (uchar*)f-&gt;addr+offset, width);
		memmove(tmp, p, r);
		if(f-&gt;write(f, offset, tmp, width) &lt; 0)
			error(Eio);
	}
	poperror();
	archflashwp(f, 1);
	qunlock(f);
	return n;
}

static void
eraseflash(Flash *f, Flashregion *r, ulong addr)
{
	int rv;

	if(f-&gt;protect &amp;&amp; r != nil &amp;&amp; r-&gt;start == 0 &amp;&amp; addr &lt; r-&gt;erasesize)
		error(Eprotect);
	qlock(f);
	archflashwp(f, 0);
	if(waserror()){
		archflashwp(f, 1);
		qunlock(f);
		nexterror();
	}
	if(r == nil){
		if(f-&gt;eraseall != nil)
			rv = f-&gt;eraseall(f);
		else
			rv = -1;
	}else
		rv = f-&gt;erasezone(f, r, addr);
	if(rv &lt; 0)
		error(Eio);
	poperror();
	archflashwp(f, 1);
	qunlock(f);
}

/*
 * flash access taking width and interleave into account
 */
int
flashget(Flash *f, ulong a)
{
	switch(f-&gt;width){
	default:
		return ((uchar*)f-&gt;addr)[a&lt;&lt;f-&gt;bshift];
	case 2:
		return ((ushort*)f-&gt;addr)[a];
	case 4:
		return ((ulong*)f-&gt;addr)[a];
	}
}

void
flashput(Flash *f, ulong a, int v)
{
	switch(f-&gt;width){
	default:
		((uchar*)f-&gt;addr)[a&lt;&lt;f-&gt;bshift] = v;
		break;
	case 2:
		((ushort*)f-&gt;addr)[a] = v;
		break;
	case 4:
		((ulong*)f-&gt;addr)[a] = v;
		break;
	}
	coherence();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

