<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devloopback.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devloopback.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

typedef struct Link	Link;
typedef struct Loop	Loop;

struct Link
{
	Lock;

	int	ref;

	long	packets;	/* total number of packets sent */
	long	bytes;		/* total number of bytes sent */
	int	indrop;		/* enable dropping on iq overflow */
	long	soverflows;	/* packets dropped because iq overflowed */
	long	droprate;	/* drop 1/droprate packets in tq */
	long	drops;		/* packets deliberately dropped */

	vlong	delay0ns;	/* nanosec of delay in the link */
	long	delaynns;	/* nanosec of delay per byte */

	Block	*tq;		/* transmission queue */
	Block	*tqtail;
	vlong	tout;		/* time the last packet in tq is really out */
	vlong	tin;		/* time the head packet in tq enters the remote side  */

	long	limit;		/* queue buffering limit */
	Queue	*oq;		/* output queue from other side &amp; packets in the link */
	Queue	*iq;

	Timer	ci;		/* time to move packets from  next packet from oq */
};

struct Loop
{
	QLock;
	int	ref;
	int	minmtu;		/* smallest block transmittable */
	Loop	*next;
	ulong	path;
	Link	link[2];
};

static struct
{
	Lock;
	ulong	path;
} loopbackalloc;

enum
{
	Qtopdir=	1,		/* top level directory */

	Qloopdir,			/* loopback* directory */

	Qportdir,			/* directory each end of the loop */
	Qctl,
	Qstatus,
	Qstats,
	Qdata,

	MaxQ,

	Nloopbacks	= 5,

	Statelen	= 23*1024,	/* status buffer size */

	Tmsize		= 8,
	Delayn 		= 10000,	/* default delays in ns */
	Delay0 		= 2500000,

	Loopqlim	= 32*1024,	/* default size of queues */
};

static Dirtab loopportdir[] =
{
	"ctl",		{Qctl},		0,			0222,
	"status",	{Qstatus},	0,			0444,
	"stats",	{Qstats},	0,			0444,
	"data",		{Qdata},	0,			0666,
};
static Dirtab loopdirs[MaxQ];

static Loop	loopbacks[Nloopbacks];

#define TYPE(x) 	(((ulong)(x))&amp;0xff)
#define ID(x) 		(((ulong)(x))&gt;&gt;8)
#define QID(x,y) 	((((ulong)(x))&lt;&lt;8)|((ulong)(y)))

static void	looper(Loop *lb);
static long	loopoput(Loop *lb, Link *link, Block *bp);
static void	ptime(uchar *p, vlong t);
static vlong	gtime(uchar *p);
static void	closelink(Link *link, int dofree);
static void	pushlink(Link *link, vlong now);
static void	freelb(Loop *lb);
static void	linkintr(Ureg*, Timer *ci);

static void
loopbackinit(void)
{
	int i;

	for(i = 0; i &lt; Nloopbacks; i++)
		loopbacks[i].path = i;

	/* invert directory tables for non-directory entries */
	for(i=0; i&lt;nelem(loopportdir); i++)
		loopdirs[loopportdir[i].qid.path] = loopportdir[i];
}

static Chan*
loopbackattach(char *spec)
{
	Loop *volatile lb;
	Queue *q;
	Chan *c;
	int chan;
	int dev;

	dev = 0;
	if(spec != nil){
		dev = atoi(spec);
		if(dev &gt;= Nloopbacks)
			error(Ebadspec);
	}

	c = devattach('X', spec);
	lb = &amp;loopbacks[dev];

	qlock(lb);
	if(waserror()){
		lb-&gt;ref--;
		qunlock(lb);
		nexterror();
	}

	lb-&gt;ref++;
	if(lb-&gt;ref == 1){
		for(chan = 0; chan &lt; 2; chan++){
			lb-&gt;link[chan].ci.mode = Trelative;
			lb-&gt;link[chan].ci.a = &amp;lb-&gt;link[chan];
			lb-&gt;link[chan].ci.f = linkintr;
			lb-&gt;link[chan].limit = Loopqlim;
			q = qopen(lb-&gt;link[chan].limit, 0, 0, 0);
			lb-&gt;link[chan].iq = q;
			if(q == nil){
				freelb(lb);
				exhausted("memory");
			}
			q = qopen(lb-&gt;link[chan].limit, 0, 0, 0);
			lb-&gt;link[chan].oq = q;
			if(q == nil){
				freelb(lb);
				exhausted("memory");
			}
			lb-&gt;link[chan].indrop = 1;

			lb-&gt;link[chan].delaynns = Delayn;
			lb-&gt;link[chan].delay0ns = Delay0;
		}
	}
	poperror();
	qunlock(lb);

	mkqid(&amp;c-&gt;qid, QID(0, Qtopdir), 0, QTDIR);
	c-&gt;aux = lb;
	c-&gt;dev = dev;
	return c;
}

static int
loopbackgen(Chan *c, char*, Dirtab*, int, int i, Dir *dp)
{
	Dirtab *tab;
	int len, type;
	Qid qid;

	type = TYPE(c-&gt;qid.path);
	if(i == DEVDOTDOT){
		switch(type){
		case Qtopdir:
		case Qloopdir:
			snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "#X%ld", c-&gt;dev);
			mkqid(&amp;qid, QID(0, Qtopdir), 0, QTDIR);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		case Qportdir:
			snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "loopback%ld", c-&gt;dev);
			mkqid(&amp;qid, QID(0, Qloopdir), 0, QTDIR);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		default:
			panic("loopbackgen %llux", c-&gt;qid.path);
		}
		return 1;
	}

	switch(type){
	case Qtopdir:
		if(i != 0)
			return -1;
		snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "loopback%ld", c-&gt;dev);
		mkqid(&amp;qid, QID(0, Qloopdir), 0, QTDIR);
		devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
		return 1;
	case Qloopdir:
		if(i &gt;= 2)
			return -1;
		snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "%d", i);
		mkqid(&amp;qid, QID(i, QID(0, Qportdir)), 0, QTDIR);
		devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
		return 1;
	case Qportdir:
		if(i &gt;= nelem(loopportdir))
			return -1;
		tab = &amp;loopportdir[i];
		mkqid(&amp;qid, QID(ID(c-&gt;qid.path), tab-&gt;qid.path), 0, QTFILE);
		devdir(c, qid, tab-&gt;name, tab-&gt;length, eve, tab-&gt;perm, dp);
		return 1;
	default:
		/* non directory entries end up here; must be in lowest level */
		if(c-&gt;qid.type &amp; QTDIR)
			panic("loopbackgen: unexpected directory");	
		if(i != 0)
			return -1;
		tab = &amp;loopdirs[type];
		if(tab == nil)
			panic("loopbackgen: unknown type: %d", type);
		len = tab-&gt;length;
		devdir(c, c-&gt;qid, tab-&gt;name, len, eve, tab-&gt;perm, dp);
		return 1;
	}
}


static Walkqid*
loopbackwalk(Chan *c, Chan *nc, char **name, int nname)
{
	Walkqid *wq;
	Loop *lb;

	wq = devwalk(c, nc, name, nname, nil, 0, loopbackgen);
	if(wq != nil &amp;&amp; wq-&gt;clone != nil &amp;&amp; wq-&gt;clone != c){
		lb = c-&gt;aux;
		qlock(lb);
		lb-&gt;ref++;
		if((c-&gt;flag &amp; COPEN) &amp;&amp; TYPE(c-&gt;qid.path) == Qdata)
			lb-&gt;link[ID(c-&gt;qid.path)].ref++;
		qunlock(lb);
	}
	return wq;
}

static int
loopbackstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, nil, 0, loopbackgen);
}

/*
 *  if the stream doesn't exist, create it
 */
static Chan*
loopbackopen(Chan *c, int omode)
{
	Loop *lb;

	if(c-&gt;qid.type &amp; QTDIR){
		if(omode != OREAD)
			error(Ebadarg);
		c-&gt;mode = omode;
		c-&gt;flag |= COPEN;
		c-&gt;offset = 0;
		return c;
	}

	lb = c-&gt;aux;
	qlock(lb);
	if(TYPE(c-&gt;qid.path) == Qdata){
		if(lb-&gt;link[ID(c-&gt;qid.path)].ref){
			qunlock(lb);
			error(Einuse);
		}
		lb-&gt;link[ID(c-&gt;qid.path)].ref++;
	}
	qunlock(lb);

	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	c-&gt;iounit = qiomaxatomic;
	return c;
}

static void
loopbackclose(Chan *c)
{
	Loop *lb;
	int ref, chan;

	lb = c-&gt;aux;

	qlock(lb);

	/*
	 * closing either side hangs up the stream
	 */
	if((c-&gt;flag &amp; COPEN) &amp;&amp; TYPE(c-&gt;qid.path) == Qdata){
		chan = ID(c-&gt;qid.path);
		if(--lb-&gt;link[chan].ref == 0){
			qhangup(lb-&gt;link[chan ^ 1].oq, nil);
			looper(lb);
		}
	}


	/*
	 *  if both sides are closed, they are reusable
	 */
	if(lb-&gt;link[0].ref == 0 &amp;&amp; lb-&gt;link[1].ref == 0){
		for(chan = 0; chan &lt; 2; chan++){
			closelink(&amp;lb-&gt;link[chan], 0);
			qreopen(lb-&gt;link[chan].iq);
			qreopen(lb-&gt;link[chan].oq);
			qsetlimit(lb-&gt;link[chan].oq, lb-&gt;link[chan].limit);
			qsetlimit(lb-&gt;link[chan].iq, lb-&gt;link[chan].limit);
		}
	}
	ref = --lb-&gt;ref;
	if(ref == 0)
		freelb(lb);
	qunlock(lb);
}

static void
freelb(Loop *lb)
{
	int chan;

	for(chan = 0; chan &lt; 2; chan++)
		closelink(&amp;lb-&gt;link[chan], 1);
}

/*
 * called with the Loop qlocked,
 * so only pushlink can mess with the queues
 */
static void
closelink(Link *link, int dofree)
{
	Queue *iq, *oq;
	Block *bp;

	ilock(link);
	iq = link-&gt;iq;
	oq = link-&gt;oq;
	bp = link-&gt;tq;
	link-&gt;tq = nil;
	link-&gt;tqtail = nil;
	link-&gt;tout = 0;
	link-&gt;tin = 0;
	timerdel(&amp;link-&gt;ci);
	iunlock(link);
	if(iq != nil){
		qclose(iq);
		if(dofree){
			ilock(link);
			free(iq);
			link-&gt;iq = nil;
			iunlock(link);
		}
	}
	if(oq != nil){
		qclose(oq);
		if(dofree){
			ilock(link);
			free(oq);
			link-&gt;oq = nil;
			iunlock(link);
		}
	}
	freeblist(bp);
}

static long
loopbackread(Chan *c, void *va, long n, vlong offset)
{
	Loop *lb;
	Link *link;
	char *buf;
	long rv;

	lb = c-&gt;aux;
	switch(TYPE(c-&gt;qid.path)){
	default:
		error(Eperm);
		return -1;	/* not reached */
	case Qtopdir:
	case Qloopdir:
	case Qportdir:
		return devdirread(c, va, n, nil, 0, loopbackgen);
	case Qdata:
		return qread(lb-&gt;link[ID(c-&gt;qid.path)].iq, va, n);
	case Qstatus:
		link = &amp;lb-&gt;link[ID(c-&gt;qid.path)];
		buf = smalloc(Statelen);
		rv = snprint(buf, Statelen, "delay %lld %ld\n", link-&gt;delay0ns, link-&gt;delaynns);
		rv += snprint(buf+rv, Statelen-rv, "limit %ld\n", link-&gt;limit);
		rv += snprint(buf+rv, Statelen-rv, "indrop %d\n", link-&gt;indrop);
		snprint(buf+rv, Statelen-rv, "droprate %ld\n", link-&gt;droprate);
		rv = readstr(offset, va, n, buf);
		free(buf);
		break;
	case Qstats:
		link = &amp;lb-&gt;link[ID(c-&gt;qid.path)];
		buf = smalloc(Statelen);
		rv = snprint(buf, Statelen, "packets: %ld\n", link-&gt;packets);
		rv += snprint(buf+rv, Statelen-rv, "bytes: %ld\n", link-&gt;bytes);
		rv += snprint(buf+rv, Statelen-rv, "dropped: %ld\n", link-&gt;drops);
		snprint(buf+rv, Statelen-rv, "soft overflows: %ld\n", link-&gt;soverflows);
		rv = readstr(offset, va, n, buf);
		free(buf);
		break;
	}
	return rv;
}

static Block*
loopbackbread(Chan *c, long n, ulong offset)
{
	Loop *lb;

	lb = c-&gt;aux;
	if(TYPE(c-&gt;qid.path) == Qdata)
		return qbread(lb-&gt;link[ID(c-&gt;qid.path)].iq, n);

	return devbread(c, n, offset);
}

static long
loopbackbwrite(Chan *c, Block *bp, ulong off)
{
	Loop *lb;

	lb = c-&gt;aux;
	if(TYPE(c-&gt;qid.path) == Qdata)
		return loopoput(lb, &amp;lb-&gt;link[ID(c-&gt;qid.path) ^ 1], bp);
	return devbwrite(c, bp, off);
}

static long
loopbackwrite(Chan *c, void *va, long n, vlong off)
{
	Loop *lb;
	Link *link;
	Cmdbuf *volatile cb;
	Block *volatile bp;
	vlong d0, d0ns;
	long dn, dnns;

	switch(TYPE(c-&gt;qid.path)){
	case Qdata:
		bp = allocb(n);
		if(waserror()){
			freeb(bp);
			nexterror();
		}
		memmove(bp-&gt;wp, va, n);
		poperror();
		bp-&gt;wp += n;
		return loopbackbwrite(c, bp, off);
	case Qctl:
		lb = c-&gt;aux;
		link = &amp;lb-&gt;link[ID(c-&gt;qid.path)];
		cb = parsecmd(va, n);
		if(waserror()){
			free(cb);
			nexterror();
		}
		if(cb-&gt;nf &lt; 1)
			error("short control request");
		if(strcmp(cb-&gt;f[0], "delay") == 0){
			if(cb-&gt;nf != 3)
				error("usage: delay latency bytedelay");
			d0ns = strtoll(cb-&gt;f[1], nil, 10);
			dnns = strtol(cb-&gt;f[2], nil, 10);

			/*
			 * it takes about 20000 cycles on a pentium ii
			 * to run pushlink; perhaps this should be accounted.
			 */

			ilock(link);
			link-&gt;delay0ns = d0ns;
			link-&gt;delaynns = dnns;
			iunlock(link);
		}else if(strcmp(cb-&gt;f[0], "indrop") == 0){
			if(cb-&gt;nf != 2)
				error("usage: indrop [01]");
			ilock(link);
			link-&gt;indrop = strtol(cb-&gt;f[1], nil, 0) != 0;
			iunlock(link);
		}else if(strcmp(cb-&gt;f[0], "droprate") == 0){
			if(cb-&gt;nf != 2)
				error("usage: droprate ofn");
			ilock(link);
			link-&gt;droprate = strtol(cb-&gt;f[1], nil, 0);
			iunlock(link);
		}else if(strcmp(cb-&gt;f[0], "limit") == 0){
			if(cb-&gt;nf != 2)
				error("usage: limit maxqsize");
			ilock(link);
			link-&gt;limit = strtol(cb-&gt;f[1], nil, 0);
			qsetlimit(link-&gt;oq, link-&gt;limit);
			qsetlimit(link-&gt;iq, link-&gt;limit);
			iunlock(link);
		}else if(strcmp(cb-&gt;f[0], "reset") == 0){
			if(cb-&gt;nf != 1)
				error("usage: reset");
			ilock(link);
			link-&gt;packets = 0;
			link-&gt;bytes = 0;
			link-&gt;indrop = 0;
			link-&gt;soverflows = 0;
			link-&gt;drops = 0;
			iunlock(link);
		}else
			error("unknown control request");
		poperror();
		free(cb);
		break;
	default:
		error(Eperm);
	}

	return n;
}

static long
loopoput(Loop *lb, Link *link, Block *volatile bp)
{
	long n;

	n = BLEN(bp);

	/* make it a single block with space for the loopback timing header */
	if(waserror()){
		freeb(bp);
		nexterror();
	}
	bp = padblock(bp, Tmsize);
	if(bp-&gt;next)
		bp = concatblock(bp);
	if(BLEN(bp) &lt; lb-&gt;minmtu)
		bp = adjustblock(bp, lb-&gt;minmtu);
	poperror();
	ptime(bp-&gt;rp, todget(nil));

	link-&gt;packets++;
	link-&gt;bytes += n;

	qbwrite(link-&gt;oq, bp);

	looper(lb);
	return n;
}

static void
looper(Loop *lb)
{
	vlong t;
	int chan;

	t = todget(nil);
	for(chan = 0; chan &lt; 2; chan++)
		pushlink(&amp;lb-&gt;link[chan], t);
}

static void
linkintr(Ureg*, Timer *ci)
{
	Link *link;

	link = ci-&gt;a;
	pushlink(link, ci-&gt;ns);
}

/*
 * move blocks between queues if they are ready.
 * schedule an interrupt for the next interesting time.
 *
 * must be called with the link ilocked.
 */
static void
pushlink(Link *link, vlong now)
{
	Block *bp;
	vlong tout, tin;

	/*
	 * put another block in the link queue
	 */
	ilock(link);
	if(link-&gt;iq == nil || link-&gt;oq == nil){
		iunlock(link);
		return;

	}
	timerdel(&amp;link-&gt;ci);

	/*
	 * put more blocks into the xmit queue
	 * use the time the last packet was supposed to go out
	 * as the start time for the next packet, rather than
	 * the current time.  this more closely models a network
	 * device which can queue multiple output packets.
	 */
	tout = link-&gt;tout;
	if(!tout)
		tout = now;
	while(tout &lt;= now){
		bp = qget(link-&gt;oq);
		if(bp == nil){
			tout = 0;
			break;
		}

		/*
		 * can't send the packet before it gets queued
		 */
		tin = gtime(bp-&gt;rp);
		if(tin &gt; tout)
			tout = tin;
		tout = tout + (BLEN(bp) - Tmsize) * link-&gt;delayn;

		/*
		 * drop packets
		 */
		if(link-&gt;droprate &amp;&amp; nrand(link-&gt;droprate) == 0)
			link-&gt;drops++;
		else{
			ptime(bp-&gt;rp, tout + link-&gt;delay0ns);
			if(link-&gt;tq == nil)
				link-&gt;tq = bp;
			else
				link-&gt;tqtail-&gt;next = bp;
			link-&gt;tqtail = bp;
		}
	}

	/*
	 * record the next time a packet can be sent,
	 * but don't schedule an interrupt if none is waiting
	 */
	link-&gt;tout = tout;
	if(!qcanread(link-&gt;oq))
		tout = 0;

	/*
	 * put more blocks into the receive queue
	 */
	tin = 0;
	while(bp = link-&gt;tq){
		tin = gtime(bp-&gt;rp);
		if(tin &gt; now)
			break;
		bp-&gt;rp += Tmsize;
		link-&gt;tq = bp-&gt;next;
		bp-&gt;next = nil;
		if(!link-&gt;indrop)
			qpassnolim(link-&gt;iq, bp);
		else if(qpass(link-&gt;iq, bp) &lt; 0)
			link-&gt;soverflows++;
		tin = 0;
	}
	if(bp == nil &amp;&amp; qisclosed(link-&gt;oq) &amp;&amp; !qcanread(link-&gt;oq) &amp;&amp; !qisclosed(link-&gt;iq))
		qhangup(link-&gt;iq, nil);
	link-&gt;tin = tin;
	if(!tin || tin &gt; tout &amp;&amp; tout)
		tin = tout;

	link-&gt;ci.ns = tin - now;
	if(tin){
		if(tin &lt; now)
			panic("loopback unfinished business");
		timeradd(&amp;link-&gt;ci);
	}
	iunlock(link);
}

static void
ptime(uchar *p, vlong t)
{
	ulong tt;

	tt = t &gt;&gt; 32;
	p[0] = tt &gt;&gt; 24;
	p[1] = tt &gt;&gt; 16;
	p[2] = tt &gt;&gt; 8;
	p[3] = tt;
	tt = t;
	p[4] = tt &gt;&gt; 24;
	p[5] = tt &gt;&gt; 16;
	p[6] = tt &gt;&gt; 8;
	p[7] = tt;
}

static vlong
gtime(uchar *p)
{
	ulong t1, t2;

	t1 = (p[0] &lt;&lt; 24) | (p[1] &lt;&lt; 16) | (p[2] &lt;&lt; 8) | p[3];
	t2 = (p[4] &lt;&lt; 24) | (p[5] &lt;&lt; 16) | (p[6] &lt;&lt; 8) | p[7];
	return ((vlong)t1 &lt;&lt; 32) | t2;
}

Dev loopbackdevtab = {
	'X',
	"loopback",

	devreset,
	loopbackinit,
	devshutdown,
	loopbackattach,
	loopbackwalk,
	loopbackstat,
	loopbackopen,
	devcreate,
	loopbackclose,
	loopbackread,
	loopbackbread,
	loopbackwrite,
	loopbackbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

