<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devpipe.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devpipe.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"netif.h"

typedef struct Pipe	Pipe;
struct Pipe
{
	QLock;
	Pipe	*next;
	int	ref;
	ulong	path;
	long	perm;
	Queue	*q[2];
	int	qref[2];
};

struct
{
	Lock;
	ulong	path;
} pipealloc;

enum
{
	Qdir,
	Qdata0,
	Qdata1,
};

Dirtab pipedir[] =
{
	".",		{Qdir,0,QTDIR},	0,		DMDIR|0500,
	"data",		{Qdata0},	0,		0600,
	"data1",	{Qdata1},	0,		0600,
};
#define NPIPEDIR 3

static void
pipeinit(void)
{
	if(conf.pipeqsize == 0){
		if(conf.nmach &gt; 1)
			conf.pipeqsize = 256*1024;
		else
			conf.pipeqsize = 32*1024;
	}
}

/*
 *  create a pipe, no streams are created until an open
 */
static Chan*
pipeattach(char *spec)
{
	Pipe *p;
	Chan *c;

	c = devattach('|', spec);
	p = malloc(sizeof(Pipe));
	if(p == 0)
		exhausted("memory");
	p-&gt;ref = 1;

	p-&gt;q[0] = qopen(conf.pipeqsize, 0, 0, 0);
	if(p-&gt;q[0] == 0){
		free(p);
		exhausted("memory");
	}
	p-&gt;q[1] = qopen(conf.pipeqsize, 0, 0, 0);
	if(p-&gt;q[1] == 0){
		free(p-&gt;q[0]);
		free(p);
		exhausted("memory");
	}

	lock(&amp;pipealloc);
	p-&gt;path = ++pipealloc.path;
	unlock(&amp;pipealloc);
	p-&gt;perm = pipedir[Qdata0].perm;

	mkqid(&amp;c-&gt;qid, NETQID(2*p-&gt;path, Qdir), 0, QTDIR);
	c-&gt;aux = p;
	c-&gt;dev = 0;
	return c;
}

static int
pipegen(Chan *c, char*, Dirtab *tab, int ntab, int i, Dir *dp)
{
	Qid q;
	int len;
	Pipe *p;

	if(i == DEVDOTDOT){
		devdir(c, c-&gt;qid, "#|", 0, eve, DMDIR|0555, dp);
		return 1;
	}
	i++;	/* skip . */
	if(tab==0 || i&gt;=ntab)
		return -1;

	tab += i;
	p = c-&gt;aux;
	switch((ulong)tab-&gt;qid.path){
	case Qdata0:
		len = qlen(p-&gt;q[0]);
		break;
	case Qdata1:
		len = qlen(p-&gt;q[1]);
		break;
	default:
		len = tab-&gt;length;
		break;
	}
	mkqid(&amp;q, NETQID(NETID(c-&gt;qid.path), tab-&gt;qid.path), 0, QTFILE);
	devdir(c, q, tab-&gt;name, len, eve, p-&gt;perm, dp);
	return 1;
}


static Walkqid*
pipewalk(Chan *c, Chan *nc, char **name, int nname)
{
	Walkqid *wq;
	Pipe *p;

	wq = devwalk(c, nc, name, nname, pipedir, NPIPEDIR, pipegen);
	if(wq != nil &amp;&amp; wq-&gt;clone != nil &amp;&amp; wq-&gt;clone != c){
		p = c-&gt;aux;
		qlock(p);
		p-&gt;ref++;
		if(c-&gt;flag &amp; COPEN){
			print("channel open in pipewalk\n");
			switch(NETTYPE(c-&gt;qid.path)){
			case Qdata0:
				p-&gt;qref[0]++;
				break;
			case Qdata1:
				p-&gt;qref[1]++;
				break;
			}
		}
		qunlock(p);
	}
	return wq;
}

static int
pipestat(Chan *c, uchar *db, int n)
{
	Pipe *p;
	Dir dir;

	p = c-&gt;aux;

	switch(NETTYPE(c-&gt;qid.path)){
	case Qdir:
		devdir(c, c-&gt;qid, ".", 0, eve, DMDIR|0555, &amp;dir);
		break;
	case Qdata0:
		devdir(c, c-&gt;qid, "data", qlen(p-&gt;q[0]), eve, p-&gt;perm, &amp;dir);
		break;
	case Qdata1:
		devdir(c, c-&gt;qid, "data1", qlen(p-&gt;q[1]), eve, p-&gt;perm, &amp;dir);
		break;
	default:
		panic("pipestat");
	}
	n = convD2M(&amp;dir, db, n);
	if(n &lt; BIT16SZ)
		error(Eshortstat);
	return n;
}

static int
pipewstat(Chan* c, uchar* db, int n)
{
	int m;
	Dir *dir;
	Pipe *p;

	p = c-&gt;aux;
	if(strcmp(up-&gt;user, eve) != 0)
		error(Eperm);
	if(NETTYPE(c-&gt;qid.path) == Qdir)
		error(Eisdir);

	dir = smalloc(sizeof(Dir)+n);
	if(waserror()){
		free(dir);
		nexterror();
	}
	m = convM2D(db, n, &amp;dir[0], (char*)&amp;dir[1]);
	if(m == 0)
		error(Eshortstat);
	if(!emptystr(dir[0].uid))
		error("can't change owner");
	if(dir[0].mode != ~0UL)
		p-&gt;perm = dir[0].mode;
	poperror();
	free(dir);
	return m;
}

/*
 *  if the stream doesn't exist, create it
 */
static Chan*
pipeopen(Chan *c, int omode)
{
	Pipe *p;

	if(c-&gt;qid.type &amp; QTDIR){
		if(omode != OREAD)
			error(Ebadarg);
		c-&gt;mode = omode;
		c-&gt;flag |= COPEN;
		c-&gt;offset = 0;
		return c;
	}

	p = c-&gt;aux;
	qlock(p);
	switch(NETTYPE(c-&gt;qid.path)){
	case Qdata0:
		p-&gt;qref[0]++;
		break;
	case Qdata1:
		p-&gt;qref[1]++;
		break;
	}
	qunlock(p);

	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	c-&gt;iounit = qiomaxatomic;
	return c;
}

static void
pipeclose(Chan *c)
{
	Pipe *p;

	p = c-&gt;aux;
	qlock(p);

	if(c-&gt;flag &amp; COPEN){
		/*
		 *  closing either side hangs up the stream
		 */
		switch(NETTYPE(c-&gt;qid.path)){
		case Qdata0:
			p-&gt;qref[0]--;
			if(p-&gt;qref[0] == 0){
				qhangup(p-&gt;q[1], 0);
				qclose(p-&gt;q[0]);
			}
			break;
		case Qdata1:
			p-&gt;qref[1]--;
			if(p-&gt;qref[1] == 0){
				qhangup(p-&gt;q[0], 0);
				qclose(p-&gt;q[1]);
			}
			break;
		}
	}


	/*
	 *  if both sides are closed, they are reusable
	 */
	if(p-&gt;qref[0] == 0 &amp;&amp; p-&gt;qref[1] == 0){
		qreopen(p-&gt;q[0]);
		qreopen(p-&gt;q[1]);
	}

	/*
	 *  free the structure on last close
	 */
	p-&gt;ref--;
	if(p-&gt;ref == 0){
		qunlock(p);
		free(p-&gt;q[0]);
		free(p-&gt;q[1]);
		free(p);
	} else
		qunlock(p);
}

static long
piperead(Chan *c, void *va, long n, vlong)
{
	Pipe *p;

	p = c-&gt;aux;

	switch(NETTYPE(c-&gt;qid.path)){
	case Qdir:
		return devdirread(c, va, n, pipedir, NPIPEDIR, pipegen);
	case Qdata0:
		return qread(p-&gt;q[0], va, n);
	case Qdata1:
		return qread(p-&gt;q[1], va, n);
	default:
		panic("piperead");
	}
	return -1;	/* not reached */
}

static Block*
pipebread(Chan *c, long n, ulong offset)
{
	Pipe *p;

	p = c-&gt;aux;

	switch(NETTYPE(c-&gt;qid.path)){
	case Qdata0:
		return qbread(p-&gt;q[0], n);
	case Qdata1:
		return qbread(p-&gt;q[1], n);
	}

	return devbread(c, n, offset);
}

/*
 *  a write to a closed pipe causes a note to be sent to
 *  the process.
 */
static long
pipewrite(Chan *c, void *va, long n, vlong)
{
	Pipe *p;

	if(!islo())
		print("pipewrite hi %#p\n", getcallerpc(&amp;c));
	if(waserror()) {
		/* avoid notes when pipe is a mounted queue */
		if((c-&gt;flag &amp; CMSG) == 0)
			postnote(up, 1, "sys: write on closed pipe", NUser);
		nexterror();
	}

	p = c-&gt;aux;

	switch(NETTYPE(c-&gt;qid.path)){
	case Qdata0:
		n = qwrite(p-&gt;q[1], va, n);
		break;

	case Qdata1:
		n = qwrite(p-&gt;q[0], va, n);
		break;

	default:
		panic("pipewrite");
	}

	poperror();
	return n;
}

static long
pipebwrite(Chan *c, Block *bp, ulong)
{
	long n;
	Pipe *p;

	if(waserror()) {
		/* avoid notes when pipe is a mounted queue */
		if((c-&gt;flag &amp; CMSG) == 0)
			postnote(up, 1, "sys: write on closed pipe", NUser);
		nexterror();
	}

	p = c-&gt;aux;
	switch(NETTYPE(c-&gt;qid.path)){
	case Qdata0:
		n = qbwrite(p-&gt;q[1], bp);
		break;

	case Qdata1:
		n = qbwrite(p-&gt;q[0], bp);
		break;

	default:
		n = 0;
		panic("pipebwrite");
	}

	poperror();
	return n;
}

Dev pipedevtab = {
	'|',
	"pipe",

	devreset,
	pipeinit,
	devshutdown,
	pipeattach,
	pipewalk,
	pipestat,
	pipeopen,
	devcreate,
	pipeclose,
	piperead,
	pipebread,
	pipewrite,
	pipebwrite,
	devremove,
	pipewstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

