<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devsdp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devsdp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/netif.h"
#include "../port/error.h"

#include	&lt;libsec.h&gt;
#include "../port/thwack.h"

/*
 * sdp - secure datagram protocol
 */

typedef struct Sdp Sdp;
typedef struct Conv Conv;
typedef struct OneWay OneWay;
typedef struct Stats Stats;
typedef struct AckPkt AckPkt;
typedef struct Algorithm Algorithm;
typedef struct CipherRc4 CipherRc4;

enum
{
	Qtopdir=	1,		/* top level directory */

	Qsdpdir,			/* sdp directory */
	Qclone,
	Qlog,

	Qconvdir,			/* directory per conversation */
	Qctl,
	Qdata,				/* unreliable packet channel */
	Qcontrol,			/* reliable control channel */
	Qstatus,
	Qstats,
	Qrstats,

	MaxQ,

	Maxconv= 256,		// power of 2
	Nfs= 4,			// number of file systems
	MaxRetries=	12,
	KeepAlive = 300,	// keep alive in seconds - should probably be about 60 but is higher to avoid linksys bug
	SecretLength= 32,	// a secret per direction
	SeqMax = (1&lt;&lt;24),
	SeqWindow = 32,
	NCompStats = 8,
};

#define TYPE(x) 	(((ulong)(x).path) &amp; 0xff)
#define CONV(x) 	((((ulong)(x).path) &gt;&gt; 8)&amp;(Maxconv-1))
#define QID(x, y) 	(((x)&lt;&lt;8) | (y))

struct Stats
{
	ulong	outPackets;
	ulong	outDataPackets;
	ulong	outDataBytes;
	ulong	outCompDataBytes;
	ulong	outCompBytes;
	ulong	outCompStats[NCompStats];
	ulong	inPackets;
	ulong	inDataPackets;
	ulong	inDataBytes;
	ulong	inCompDataBytes;
	ulong	inMissing;
	ulong	inDup;
	ulong	inReorder;
	ulong	inBadComp;
	ulong	inBadAuth;
	ulong	inBadSeq;
	ulong	inBadOther;
};

struct OneWay
{
	Rendez	statsready;

	ulong	seqwrap;	// number of wraps of the sequence number
	ulong	seq;
	ulong	window;

	uchar	secret[SecretLength];

	QLock	controllk;
	Rendez	controlready;
	Block	*controlpkt;		// control channel
	ulong	controlseq;

	void	*cipherstate;	// state cipher
	int		cipherivlen;	// initial vector length
	int		cipherblklen;	// block length
	int		(*cipher)(OneWay*, uchar *buf, int len);

	void	*authstate;		// auth state
	int		authlen;		// auth data length in bytes
	int		(*auth)(OneWay*, uchar *buf, int len);

	void	*compstate;
	int		(*comp)(Conv*, int subtype, ulong seq, Block **);
};

// conv states
enum {
	CFree,
	CInit,
	CDial,
	CAccept,
	COpen,
	CLocalClose,
	CRemoteClose,
	CClosed,
};

struct Conv {
	QLock;
	Sdp	*sdp;
	int	id;

	int ref;	// holds conv up

	int state;

	int dataopen;	// ref count of opens on Qdata
	int controlopen;	// ref count of opens on Qcontrol
	int reader;		// reader proc has been started

	Stats	lstats;
	Stats	rstats;
	
	ulong	lastrecv;	// time last packet was received 
	ulong	timeout;
	int		retries;

	// the following pair uniquely define conversation on this port
	ulong dialid;
	ulong acceptid;

	QLock readlk;		// protects readproc
	Proc *readproc;

	Chan *chan;		// packet channel
	char *channame;

	char owner[KNAMELEN];		/* protections */
	int	perm;

	Algorithm *auth;
	Algorithm *cipher;
	Algorithm *comp;

	int drop;

	OneWay	in;
	OneWay	out;
};

struct Sdp {
	QLock;
	Log;
	int	nconv;
	Conv *conv[Maxconv];
	int ackproc;
};

enum {
	TConnect,
	TControl,
	TData,
	TCompData,
};

enum {
	ControlMesg,
	ControlAck,
};

enum {
	ThwackU,
	ThwackC,
};

enum {
	ConOpenRequest,
	ConOpenAck,
	ConOpenAckAck,
	ConClose,
	ConCloseAck,
	ConReset,
};

struct AckPkt
{
	uchar	cseq[4];
	uchar	outPackets[4];
	uchar	outDataPackets[4];
	uchar	outDataBytes[4];
	uchar	outCompDataBytes[4];
	uchar	outCompStats[4*NCompStats];
	uchar	inPackets[4];
	uchar	inDataPackets[4];
	uchar	inDataBytes[4];
	uchar	inCompDataBytes[4];
	uchar	inMissing[4];
	uchar	inDup[4];
	uchar	inReorder[4];
	uchar	inBadComp[4];
	uchar	inBadAuth[4];
	uchar	inBadSeq[4];
	uchar	inBadOther[4];
};

struct Algorithm
{
	char 	*name;
	int		keylen;		// in bytes
	void	(*init)(Conv*);
};

enum {
	RC4forward	= 10*1024*1024,	// maximum skip forward
	RC4back = 100*1024,		// maximum look back
};

struct CipherRc4
{
	ulong cseq;	// current byte sequence number
	RC4state current;

	int ovalid;	// old is valid
	ulong lgseq; // last good sequence
	ulong oseq;	// old byte sequence number
	RC4state old;
};

static Dirtab sdpdirtab[]={
	"log",		{Qlog},		0,	0666,
	"clone",	{Qclone},		0,	0666,
};

static Dirtab convdirtab[]={
	"ctl",		{Qctl},	0,	0666,
	"data",		{Qdata},	0,	0666,
	"control",	{Qcontrol},	0,	0666,
	"status",	{Qstatus},	0,	0444,
	"stats",	{Qstats},	0,	0444,
	"rstats",	{Qrstats},	0,	0444,
};

static int m2p[] = {
	[OREAD]		4,
	[OWRITE]	2,
	[ORDWR]		6
};

enum {
	Logcompress=	(1&lt;&lt;0),
	Logauth=	(1&lt;&lt;1),
	Loghmac=	(1&lt;&lt;2),
};

static Logflag logflags[] =
{
	{ "compress",	Logcompress, },
	{ "auth",	Logauth, },
	{ "hmac",	Loghmac, },
	{ nil,		0, },
};

static Dirtab	*dirtab[MaxQ];
static Sdp sdptab[Nfs];
static char *convstatename[] = {
	[CFree]		"Free",
	[CInit]		"Init",
	[CDial]		"Dial",
	[CAccept]	"Accept",
	[COpen]		"Open",
	[CLocalClose] "LocalClose",
	[CRemoteClose] "RemoteClose",
	[CClosed]	"Closed",
};

static int sdpgen(Chan *c, char*, Dirtab*, int, int s, Dir *dp);
static Conv *sdpclone(Sdp *sdp);
static void sdpackproc(void *a);
static void onewaycleanup(OneWay *ow);
static int readready(void *a);
static int controlread();
static void convsetstate(Conv *c, int state);
static Block *readcontrol(Conv *c, int n);
static void writecontrol(Conv *c, void *p, int n, int wait);
static Block *readdata(Conv *c, int n);
static long writedata(Conv *c, Block *b);
static void convderef(Conv *c);
static Block *conviput(Conv *c, Block *b, int control);
static void conviconnect(Conv *c, int op, Block *b);
static void convicontrol(Conv *c, int op, Block *b);
static Block *convicomp(Conv *c, int op, ulong, Block *b);
static void convoput(Conv *c, int type, int subtype, Block *b);
static void convoconnect(Conv *c, int op, ulong dialid, ulong acceptid);
static void convopenchan(Conv *c, char *path);
static void convstats(Conv *c, int local, char *buf, int n);
static void convreader(void *a);

static void setalg(Conv *c, char *name, Algorithm *tab, Algorithm **);
static void setsecret(OneWay *cc, char *secret);

static void nullcipherinit(Conv*c);
static void descipherinit(Conv*c);
static void rc4cipherinit(Conv*c);
static void nullauthinit(Conv*c);
static void shaauthinit(Conv*c);
static void md5authinit(Conv*c);
static void nullcompinit(Conv*c);
static void thwackcompinit(Conv*c);

static Algorithm cipheralg[] =
{
	"null",			0,	nullcipherinit,
	"des_56_cbc",	7,	descipherinit,
	"rc4_128",		16,	rc4cipherinit,
	"rc4_256",		32,	rc4cipherinit,
	nil,			0,	nil,
};

static Algorithm authalg[] =
{
	"null",			0,	nullauthinit,
	"hmac_sha1_96",	16,	shaauthinit,
	"hmac_md5_96",	16,	md5authinit,
	nil,			0,	nil,
};

static Algorithm compalg[] =
{
	"null",			0,	nullcompinit,
	"thwack",		0,	thwackcompinit,
	nil,			0,	nil,
};


static void
sdpinit(void)
{
	int i;
	Dirtab *dt;
	
	// setup dirtab with non directory entries
	for(i=0; i&lt;nelem(sdpdirtab); i++) {
		dt = sdpdirtab + i;
		dirtab[TYPE(dt-&gt;qid)] = dt;
	}

	for(i=0; i&lt;nelem(convdirtab); i++) {
		dt = convdirtab + i;
		dirtab[TYPE(dt-&gt;qid)] = dt;
	}

}

static Chan*
sdpattach(char* spec)
{
	Chan *c;
	int dev;
	char buf[100];
	Sdp *sdp;
	int start;

	dev = atoi(spec);
	if(dev&lt;0 || dev &gt;= Nfs)
		error("bad specification");

	c = devattach('E', spec);
	c-&gt;qid = (Qid){QID(0, Qtopdir), 0, QTDIR};
	c-&gt;dev = dev;

	sdp = sdptab + dev;
	qlock(sdp);
	start = sdp-&gt;ackproc == 0;
	sdp-&gt;ackproc = 1;
	qunlock(sdp);

	if(start) {
		snprint(buf, sizeof(buf), "sdpackproc%d", dev);
		kproc(buf, sdpackproc, sdp);
	}
	
	return c;
}

static Walkqid*
sdpwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, sdpgen);
}

static int
sdpstat(Chan* c, uchar* db, int n)
{
	return devstat(c, db, n, nil, 0, sdpgen);
}

static Chan*
sdpopen(Chan* ch, int omode)
{
	int perm;
	Sdp *sdp;
	Conv *c;

	omode &amp;= 3;
	perm = m2p[omode];
	USED(perm);

	sdp = sdptab + ch-&gt;dev;

	switch(TYPE(ch-&gt;qid)) {
	default:
		break;
	case Qtopdir:
	case Qsdpdir:
	case Qconvdir:
		if(omode != OREAD)
			error(Eperm);
		break;
	case Qlog:
		logopen(sdp);
		break;
	case Qclone:
		c = sdpclone(sdp);
		if(c == nil)
			error(Enodev);
		ch-&gt;qid.path = QID(c-&gt;id, Qctl);
		break;
	case Qdata:
	case Qctl:
	case Qstatus:
	case Qcontrol:
	case Qstats:
	case Qrstats:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		qlock(c);
		if(waserror()) {
			qunlock(c);
			nexterror();
		}
		if((perm &amp; (c-&gt;perm&gt;&gt;6)) != perm)
		if(strcmp(up-&gt;user, c-&gt;owner) != 0 || (perm &amp; c-&gt;perm) != perm)
				error(Eperm);

		c-&gt;ref++;
		if(TYPE(ch-&gt;qid) == Qdata) {
			c-&gt;dataopen++;
			// kill reader if Qdata is opened for the first time
			if(c-&gt;dataopen == 1)
			if(c-&gt;readproc != nil)
				postnote(c-&gt;readproc, 1, "interrupt", 0);
		} else if(TYPE(ch-&gt;qid) == Qcontrol) {	
			c-&gt;controlopen++;
		}
		qunlock(c);
		poperror();
		break;
	}
	ch-&gt;mode = openmode(omode);
	ch-&gt;flag |= COPEN;
	ch-&gt;offset = 0;
	return ch;
}

static void
sdpclose(Chan* ch)
{
	Sdp *sdp  = sdptab + ch-&gt;dev;
	Conv *c;

	if(!(ch-&gt;flag &amp; COPEN))
		return;
	switch(TYPE(ch-&gt;qid)) {
	case Qlog:
		logclose(sdp);
		break;
	case Qctl:
	case Qstatus:
	case Qstats:
	case Qrstats:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		qlock(c);
		convderef(c);
		qunlock(c);
		break;

	case Qdata:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		qlock(c);
		c-&gt;dataopen--;
		convderef(c);
		if(c-&gt;dataopen == 0)
		if(c-&gt;reader == 0)
		if(c-&gt;chan != nil)
		if(!waserror()) {
			kproc("convreader", convreader, c);
			c-&gt;reader = 1;
			c-&gt;ref++;
			poperror();
		}
		qunlock(c);
		break;

	case Qcontrol:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		qlock(c);
		c-&gt;controlopen--;
		convderef(c);
		if(c-&gt;controlopen == 0 &amp;&amp; c-&gt;ref != 0) {
			switch(c-&gt;state) {
			default:
				convsetstate(c, CClosed);
				break;
			case CAccept:
			case COpen:
				convsetstate(c, CLocalClose);
				break;
			}
		}
		qunlock(c);
		break;
	}
}

static long
sdpread(Chan *ch, void *a, long n, vlong off)
{
	char buf[256];
	char *s;
	Sdp *sdp = sdptab + ch-&gt;dev;
	Conv *c;
	Block *b;
	int rv;

	USED(off);
	switch(TYPE(ch-&gt;qid)) {
	default:
		error(Eperm);
	case Qtopdir:
	case Qsdpdir:
	case Qconvdir:
		return devdirread(ch, a, n, 0, 0, sdpgen);
	case Qlog:
		return logread(sdp, a, off, n);
	case Qstatus:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		qlock(c);
		n = readstr(off, a, n, convstatename[c-&gt;state]);
		qunlock(c);
		return n;
	case Qctl:
		snprint(buf, sizeof buf, "%lud", CONV(ch-&gt;qid));
		return readstr(off, a, n, buf);
	case Qcontrol:
		b = readcontrol(sdp-&gt;conv[CONV(ch-&gt;qid)], n);
		if(b == nil)
			return 0;
		if(BLEN(b) &lt; n)
			n = BLEN(b);
		memmove(a, b-&gt;rp, n);
		freeb(b);
		return n;
	case Qdata:
		b = readdata(sdp-&gt;conv[CONV(ch-&gt;qid)], n);
		if(b == nil)
			return 0;
		if(BLEN(b) &lt; n)
			n = BLEN(b);
		memmove(a, b-&gt;rp, n);
		freeb(b);
		return n;
	case Qstats:
	case Qrstats:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		s = smalloc(1000);
		convstats(c, TYPE(ch-&gt;qid) == Qstats, s, 1000);
		rv = readstr(off, a, n, s);
		free(s);
		return rv;
	}
}

static Block*
sdpbread(Chan* ch, long n, ulong offset)
{
	Sdp *sdp = sdptab + ch-&gt;dev;

	if(TYPE(ch-&gt;qid) != Qdata)
		return devbread(ch, n, offset);
	return readdata(sdp-&gt;conv[CONV(ch-&gt;qid)], n);
}


static long
sdpwrite(Chan *ch, void *a, long n, vlong off)
{
	Sdp *sdp = sdptab + ch-&gt;dev;
	Cmdbuf *cb;
	char *arg0;
	char *p;
	Conv *c;
	Block *b;
	
	USED(off);
	switch(TYPE(ch-&gt;qid)) {
	default:
		error(Eperm);
	case Qctl:
		c = sdp-&gt;conv[CONV(ch-&gt;qid)];
		cb = parsecmd(a, n);
		qlock(c);
		if(waserror()) {
			qunlock(c);
			free(cb);
			nexterror();
		}
		if(cb-&gt;nf == 0)
			error("short write");
		arg0 = cb-&gt;f[0];
		if(strcmp(arg0, "accept") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: accept file");
			convopenchan(c, cb-&gt;f[1]);
		} else if(strcmp(arg0, "dial") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: dial file");
			convopenchan(c, cb-&gt;f[1]);
			convsetstate(c, CDial);
		} else if(strcmp(arg0, "drop") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: drop permil");
			c-&gt;drop = atoi(cb-&gt;f[1]);
		} else if(strcmp(arg0, "cipher") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: cipher alg");
			setalg(c, cb-&gt;f[1], cipheralg, &amp;c-&gt;cipher);
		} else if(strcmp(arg0, "auth") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: auth alg");
			setalg(c, cb-&gt;f[1], authalg, &amp;c-&gt;auth);
		} else if(strcmp(arg0, "comp") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: comp alg");
			setalg(c, cb-&gt;f[1], compalg, &amp;c-&gt;comp);
		} else if(strcmp(arg0, "insecret") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: insecret secret");
			setsecret(&amp;c-&gt;in, cb-&gt;f[1]);
			if(c-&gt;cipher)
				c-&gt;cipher-&gt;init(c);
			if(c-&gt;auth)
				c-&gt;auth-&gt;init(c);
		} else if(strcmp(arg0, "outsecret") == 0) {
			if(cb-&gt;nf != 2)
				error("usage: outsecret secret");
			setsecret(&amp;c-&gt;out, cb-&gt;f[1]);
			if(c-&gt;cipher)
				c-&gt;cipher-&gt;init(c);
			if(c-&gt;auth)
				c-&gt;auth-&gt;init(c);
		} else
			error("unknown control request");
		poperror();
		qunlock(c);
		free(cb);
		return n;
	case Qlog:
		cb = parsecmd(a, n);
		p = logctl(sdp, cb-&gt;nf, cb-&gt;f, logflags);
		free(cb);
		if(p != nil)
			error(p);
		return n;
	case Qcontrol:
		writecontrol(sdp-&gt;conv[CONV(ch-&gt;qid)], a, n, 0);
		return n;
	case Qdata:
		b = allocb(n);
		memmove(b-&gt;wp, a, n);
		b-&gt;wp += n;
		return writedata(sdp-&gt;conv[CONV(ch-&gt;qid)], b);
	}
}

long
sdpbwrite(Chan *ch, Block *bp, ulong offset)
{
	Sdp *sdp = sdptab + ch-&gt;dev;

	if(TYPE(ch-&gt;qid) != Qdata)
		return devbwrite(ch, bp, offset);
	return writedata(sdp-&gt;conv[CONV(ch-&gt;qid)], bp);
}

static int
sdpgen(Chan *c, char*, Dirtab*, int, int s, Dir *dp)
{
	Sdp *sdp = sdptab + c-&gt;dev;
	int type = TYPE(c-&gt;qid);
	Dirtab *dt;
	Qid qid;

	if(s == DEVDOTDOT){
		switch(TYPE(c-&gt;qid)){
		case Qtopdir:
		case Qsdpdir:
			snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "#E%ld", c-&gt;dev);
			mkqid(&amp;qid, Qtopdir, 0, QTDIR);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		case Qconvdir:
			snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "%d", s);
			mkqid(&amp;qid, Qsdpdir, 0, QTDIR);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		default:
			panic("sdpwalk %llux", c-&gt;qid.path);
		}
		return 1;
	}

	switch(type) {
	default:
		// non directory entries end up here
		if(c-&gt;qid.type &amp; QTDIR)
			panic("sdpgen: unexpected directory");	
		if(s != 0)
			return -1;
		dt = dirtab[TYPE(c-&gt;qid)];
		if(dt == nil)
			panic("sdpgen: unknown type: %lud", TYPE(c-&gt;qid));
		devdir(c, c-&gt;qid, dt-&gt;name, dt-&gt;length, eve, dt-&gt;perm, dp);
		return 1;
	case Qtopdir:
		if(s != 0)
			return -1;
		mkqid(&amp;qid, QID(0, Qsdpdir), 0, QTDIR);
		devdir(c, qid, "sdp", 0, eve, 0555, dp);
		return 1;
	case Qsdpdir:
		if(s&lt;nelem(sdpdirtab)) {
			dt = sdpdirtab+s;
			devdir(c, dt-&gt;qid, dt-&gt;name, dt-&gt;length, eve, dt-&gt;perm, dp);
			return 1;
		}
		s -= nelem(sdpdirtab);
		if(s &gt;= sdp-&gt;nconv)
			return -1;
		mkqid(&amp;qid, QID(s, Qconvdir), 0, QTDIR);
		snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "%d", s);
		devdir(c, qid, up-&gt;genbuf, 0, eve, 0555, dp);
		return 1;
	case Qconvdir:
		if(s&gt;=nelem(convdirtab))
			return -1;
		dt = convdirtab+s;
		mkqid(&amp;qid, QID(CONV(c-&gt;qid),TYPE(dt-&gt;qid)), 0, QTFILE);
		devdir(c, qid, dt-&gt;name, dt-&gt;length, eve, dt-&gt;perm, dp);
		return 1;
	}
}

static Conv*
sdpclone(Sdp *sdp)
{
	Conv *c, **pp, **ep;

	c = nil;
	ep = sdp-&gt;conv + nelem(sdp-&gt;conv);
	qlock(sdp);
	if(waserror()) {
		qunlock(sdp);
		nexterror();
	}
	for(pp = sdp-&gt;conv; pp &lt; ep; pp++) {
		c = *pp;
		if(c == nil){
			c = malloc(sizeof(Conv));
			if(c == nil)
				error(Enomem);
			memset(c, 0, sizeof(Conv));
			qlock(c);
			c-&gt;sdp = sdp;
			c-&gt;id = pp - sdp-&gt;conv;
			*pp = c;
			sdp-&gt;nconv++;
			break;
		}
		if(c-&gt;ref == 0 &amp;&amp; canqlock(c)){
			if(c-&gt;ref == 0)
				break;
			qunlock(c);
		}
	}
	poperror();
	qunlock(sdp);

	if(pp &gt;= ep)
		return nil;

	assert(c-&gt;state == CFree);
	// set ref to 2 - 1 ref for open - 1 ref for channel state
	c-&gt;ref = 2;
	c-&gt;state = CInit;
	c-&gt;in.window = ~0;
	strncpy(c-&gt;owner, up-&gt;user, sizeof(c-&gt;owner));
	c-&gt;perm = 0660;
	qunlock(c);

	return c;
}

// assume c is locked
static void
convretryinit(Conv *c)
{
	c-&gt;retries = 0;
	// +2 to avoid rounding effects.
	c-&gt;timeout = TK2SEC(m-&gt;ticks) + 2;
}

// assume c is locked
static int
convretry(Conv *c, int reset)
{
	c-&gt;retries++;
	if(c-&gt;retries &gt; MaxRetries) {
		if(reset)
			convoconnect(c, ConReset, c-&gt;dialid, c-&gt;acceptid);
		convsetstate(c, CClosed);
		return 0;
	}
	c-&gt;timeout = TK2SEC(m-&gt;ticks) + (c-&gt;retries+1);
	return 1;
}

// assumes c is locked
static void
convtimer(Conv *c, ulong sec)
{
	Block *b;

	if(c-&gt;timeout &gt; sec)
		return;

	switch(c-&gt;state) {
	case CInit:
		break;
	case CDial:
		if(convretry(c, 1))
			convoconnect(c, ConOpenRequest, c-&gt;dialid, 0);
		break;
	case CAccept:
		if(convretry(c, 1))
			convoconnect(c, ConOpenAck, c-&gt;dialid, c-&gt;acceptid);
		break;
	case COpen:
		b = c-&gt;out.controlpkt;
		if(b != nil) {
			if(convretry(c, 1))
				convoput(c, TControl, ControlMesg, copyblock(b, blocklen(b)));
			break;
		}

		c-&gt;timeout = c-&gt;lastrecv + KeepAlive;
		if(c-&gt;timeout &gt; sec)
			break;
		// keepalive - randomly spaced between KeepAlive and 2*KeepAlive
		if(c-&gt;timeout + KeepAlive &gt; sec &amp;&amp; nrand(c-&gt;lastrecv + 2*KeepAlive - sec) &gt; 0)
			break;
		// can not use writecontrol
		b = allocb(4);
		c-&gt;out.controlseq++;
		hnputl(b-&gt;wp, c-&gt;out.controlseq);
		b-&gt;wp += 4;
		c-&gt;out.controlpkt = b;
		convretryinit(c);
		if(!waserror()) {
			convoput(c, TControl, ControlMesg, copyblock(b, blocklen(b)));
			poperror();
		}
		break;
	case CLocalClose:
		if(convretry(c, 0))
			convoconnect(c, ConClose, c-&gt;dialid, c-&gt;acceptid);
		break;
	case CRemoteClose:
	case CClosed:
		break;
	}
}


static void
sdpackproc(void *a)
{
	Sdp *sdp = a;
	ulong sec;
	int i;
	Conv *c;

	for(;;) {
		tsleep(&amp;up-&gt;sleep, return0, 0, 1000);
		sec = TK2SEC(m-&gt;ticks);
		qlock(sdp);
		for(i=0; i&lt;sdp-&gt;nconv; i++) {
			c = sdp-&gt;conv[i];
			if(c-&gt;ref == 0)
				continue;
			qunlock(sdp);
			qlock(c);
			if(c-&gt;ref &gt; 0 &amp;&amp; !waserror()) {
				convtimer(c, sec);
				poperror();
			}
			qunlock(c);
			qlock(sdp);
		}
		qunlock(sdp);
	}
}

Dev sdpdevtab = {
	'E',
	"sdp",

	devreset,
	sdpinit,
	devshutdown,
	sdpattach,
	sdpwalk,
	sdpstat,
	sdpopen,
	devcreate,
	sdpclose,
	sdpread,
	devbread,
	sdpwrite,
	devbwrite,
	devremove,
	devwstat,
};

// assume hold lock on c
static void
convsetstate(Conv *c, int state)
{

if(0)print("convsetstate %d: %s -&gt; %s\n", c-&gt;id, convstatename[c-&gt;state], convstatename[state]);

	switch(state) {
	default:
		panic("setstate: bad state: %d", state);
	case CDial:
		assert(c-&gt;state == CInit);
		c-&gt;dialid = (rand()&lt;&lt;16) + rand();
		convretryinit(c);
		convoconnect(c, ConOpenRequest, c-&gt;dialid, 0);
		break;
	case CAccept:
		assert(c-&gt;state == CInit);
		c-&gt;acceptid = (rand()&lt;&lt;16) + rand();
		convretryinit(c);
		convoconnect(c, ConOpenAck, c-&gt;dialid, c-&gt;acceptid);
		break;
	case COpen:
		assert(c-&gt;state == CDial || c-&gt;state == CAccept);
		c-&gt;lastrecv = TK2SEC(m-&gt;ticks);
		if(c-&gt;state == CDial) {
			convretryinit(c);
			convoconnect(c, ConOpenAckAck, c-&gt;dialid, c-&gt;acceptid);
			hnputl(c-&gt;in.secret, c-&gt;acceptid);
			hnputl(c-&gt;in.secret+4, c-&gt;dialid);
			hnputl(c-&gt;out.secret, c-&gt;dialid);
			hnputl(c-&gt;out.secret+4, c-&gt;acceptid);
		} else {
			hnputl(c-&gt;in.secret, c-&gt;dialid);
			hnputl(c-&gt;in.secret+4, c-&gt;acceptid);
			hnputl(c-&gt;out.secret, c-&gt;acceptid);
			hnputl(c-&gt;out.secret+4, c-&gt;dialid);
		}
		setalg(c, "hmac_md5_96", authalg, &amp;c-&gt;auth);
		break;
	case CLocalClose:
		assert(c-&gt;state == CAccept || c-&gt;state == COpen);
		convretryinit(c);
		convoconnect(c, ConClose, c-&gt;dialid, c-&gt;acceptid);
		break;
	case CRemoteClose:
		wakeup(&amp;c-&gt;in.controlready);
		wakeup(&amp;c-&gt;out.controlready);
		break;
	case CClosed:
		wakeup(&amp;c-&gt;in.controlready);
		wakeup(&amp;c-&gt;out.controlready);
		if(c-&gt;readproc)
			postnote(c-&gt;readproc, 1, "interrupt", 0);
		if(c-&gt;state != CClosed)
			convderef(c);
		break;
	}
	c-&gt;state = state;
}


//assumes c is locked
static void
convderef(Conv *c)
{
	c-&gt;ref--;
	if(c-&gt;ref &gt; 0) {
		return;
	}
	assert(c-&gt;ref == 0);
	assert(c-&gt;dataopen == 0);
	assert(c-&gt;controlopen == 0);
if(0)print("convderef: %d: ref == 0!\n", c-&gt;id);
	c-&gt;state = CFree;
	if(c-&gt;chan) {	
		cclose(c-&gt;chan);
		c-&gt;chan = nil;
	}
	if(c-&gt;channame) {
		free(c-&gt;channame);
		c-&gt;channame = nil;
	}
	c-&gt;cipher = nil;
	c-&gt;auth = nil;
	c-&gt;comp = nil;
	strcpy(c-&gt;owner, "network");
	c-&gt;perm = 0660;
	c-&gt;dialid = 0;
	c-&gt;acceptid = 0;
	c-&gt;timeout = 0;
	c-&gt;retries = 0;
	c-&gt;drop = 0;
	onewaycleanup(&amp;c-&gt;in);
	onewaycleanup(&amp;c-&gt;out);
	memset(&amp;c-&gt;lstats, 0, sizeof(Stats));
	memset(&amp;c-&gt;rstats, 0, sizeof(Stats));
}

static void
onewaycleanup(OneWay *ow)
{
	if(ow-&gt;controlpkt)
		freeb(ow-&gt;controlpkt);
	if(ow-&gt;authstate)
		free(ow-&gt;authstate);
	if(ow-&gt;cipherstate)
		free(ow-&gt;cipherstate);
	if(ow-&gt;compstate)
		free(ow-&gt;compstate);
	memset(ow, 0, sizeof(OneWay));
}


// assumes conv is locked
static void
convopenchan(Conv *c, char *path)
{
	if(c-&gt;state != CInit || c-&gt;chan != nil)
		error("already connected");
	c-&gt;chan = namec(path, Aopen, ORDWR, 0);
	c-&gt;channame = smalloc(strlen(path)+1);
	strcpy(c-&gt;channame, path);
	if(waserror()) {
		cclose(c-&gt;chan);
		c-&gt;chan = nil;
		free(c-&gt;channame);
		c-&gt;channame = nil;
		nexterror();
	}
	kproc("convreader", convreader, c);

	assert(c-&gt;reader == 0 &amp;&amp; c-&gt;ref &gt; 0);
	// after kproc in case it fails
	c-&gt;reader = 1;
	c-&gt;ref++;

	poperror();
}

static void
convstats(Conv *c, int local, char *buf, int n)
{
	Stats *stats;
	char *p, *ep;
	int i;

	if(local) {
		stats = &amp;c-&gt;lstats;
	} else {
		if(!waserror()) {
			writecontrol(c, 0, 0, 1);
			poperror();
		}
		stats = &amp;c-&gt;rstats;
	}

	qlock(c);
	p = buf;
	ep = buf + n;
	p += snprint(p, ep-p, "outPackets: %lud\n", stats-&gt;outPackets);
	p += snprint(p, ep-p, "outDataPackets: %lud\n", stats-&gt;outDataPackets);
	p += snprint(p, ep-p, "outDataBytes: %lud\n", stats-&gt;outDataBytes);
	p += snprint(p, ep-p, "outCompDataBytes: %lud\n", stats-&gt;outCompDataBytes);
	for(i=0; i&lt;NCompStats; i++) {
		if(stats-&gt;outCompStats[i] == 0)
			continue;
		p += snprint(p, ep-p, "outCompStats[%d]: %lud\n", i, stats-&gt;outCompStats[i]);
	}
	p += snprint(p, ep-p, "inPackets: %lud\n", stats-&gt;inPackets);
	p += snprint(p, ep-p, "inDataPackets: %lud\n", stats-&gt;inDataPackets);
	p += snprint(p, ep-p, "inDataBytes: %lud\n", stats-&gt;inDataBytes);
	p += snprint(p, ep-p, "inCompDataBytes: %lud\n", stats-&gt;inCompDataBytes);
	p += snprint(p, ep-p, "inMissing: %lud\n", stats-&gt;inMissing);
	p += snprint(p, ep-p, "inDup: %lud\n", stats-&gt;inDup);
	p += snprint(p, ep-p, "inReorder: %lud\n", stats-&gt;inReorder);
	p += snprint(p, ep-p, "inBadComp: %lud\n", stats-&gt;inBadComp);
	p += snprint(p, ep-p, "inBadAuth: %lud\n", stats-&gt;inBadAuth);
	p += snprint(p, ep-p, "inBadSeq: %lud\n", stats-&gt;inBadSeq);
	p += snprint(p, ep-p, "inBadOther: %lud\n", stats-&gt;inBadOther);
	USED(p);
	qunlock(c);
}

// c is locked
static void
convack(Conv *c)
{
	Block *b;
	AckPkt *ack;
	Stats *s;
	int i;

	b = allocb(sizeof(AckPkt));
	ack = (AckPkt*)b-&gt;wp;
	b-&gt;wp += sizeof(AckPkt);
	s = &amp;c-&gt;lstats;
	hnputl(ack-&gt;cseq, c-&gt;in.controlseq);
	hnputl(ack-&gt;outPackets, s-&gt;outPackets);
	hnputl(ack-&gt;outDataPackets, s-&gt;outDataPackets);
	hnputl(ack-&gt;outDataBytes, s-&gt;outDataBytes);
	hnputl(ack-&gt;outCompDataBytes, s-&gt;outCompDataBytes);
	for(i=0; i&lt;NCompStats; i++)
		hnputl(ack-&gt;outCompStats+i*4, s-&gt;outCompStats[i]);
	hnputl(ack-&gt;inPackets, s-&gt;inPackets);
	hnputl(ack-&gt;inDataPackets, s-&gt;inDataPackets);
	hnputl(ack-&gt;inDataBytes, s-&gt;inDataBytes);
	hnputl(ack-&gt;inCompDataBytes, s-&gt;inCompDataBytes);
	hnputl(ack-&gt;inMissing, s-&gt;inMissing);
	hnputl(ack-&gt;inDup, s-&gt;inDup);
	hnputl(ack-&gt;inReorder, s-&gt;inReorder);
	hnputl(ack-&gt;inBadComp, s-&gt;inBadComp);
	hnputl(ack-&gt;inBadAuth, s-&gt;inBadAuth);
	hnputl(ack-&gt;inBadSeq, s-&gt;inBadSeq);
	hnputl(ack-&gt;inBadOther, s-&gt;inBadOther);
	convoput(c, TControl, ControlAck, b);
}


// assume we hold lock for c
static Block *
conviput(Conv *c, Block *b, int control)
{
	int type, subtype;
	ulong seq, seqwrap;
	long seqdiff;
	int pad;

	c-&gt;lstats.inPackets++;

	if(BLEN(b) &lt; 4) {
		c-&gt;lstats.inBadOther++;
		freeb(b);
		return nil;
	}
	
	type = b-&gt;rp[0] &gt;&gt; 4;
	subtype = b-&gt;rp[0] &amp; 0xf;
	b-&gt;rp += 1;
	if(type == TConnect) {
		conviconnect(c, subtype, b);
		return nil;
	}

	switch(c-&gt;state) {
	case CInit:
	case CDial:
		c-&gt;lstats.inBadOther++;
		convoconnect(c, ConReset, c-&gt;dialid, c-&gt;acceptid);
		convsetstate(c, CClosed);
		break;
	case CAccept:
	case CRemoteClose:
	case CLocalClose:
		c-&gt;lstats.inBadOther++;
		freeb(b);
		return nil;
	}

	seq = (b-&gt;rp[0]&lt;&lt;16) + (b-&gt;rp[1]&lt;&lt;8) + b-&gt;rp[2];
	b-&gt;rp += 3;

	seqwrap = c-&gt;in.seqwrap;
	seqdiff = seq - c-&gt;in.seq;
	if(seqdiff &lt; -(SeqMax*3/4)) {
		seqwrap++;
		seqdiff += SeqMax;
	} else if(seqdiff &gt; SeqMax*3/4) {
		seqwrap--;
		seqdiff -= SeqMax;
	}

	if(seqdiff &lt;= 0) {
		if(seqdiff &lt;= -SeqWindow) {
if(0)print("old sequence number: %ld (%ld %ld)\n", seq, c-&gt;in.seqwrap, seqdiff);
			c-&gt;lstats.inBadSeq++;
			freeb(b);
			return nil;
		}

		if(c-&gt;in.window &amp; (1&lt;&lt;-seqdiff)) {
if(0)print("dup sequence number: %ld (%ld %ld)\n", seq, c-&gt;in.seqwrap, seqdiff);
			c-&gt;lstats.inDup++;
			freeb(b);
			return nil;
		}

		c-&gt;lstats.inReorder++;
	}

	// ok the sequence number looks ok
if(0) print("coniput seq=%ulx\n", seq);
	if(c-&gt;in.auth != 0) {
		if(!(*c-&gt;in.auth)(&amp;c-&gt;in, b-&gt;rp-4, BLEN(b)+4)) {
if(0)print("bad auth %ld\n", BLEN(b)+4);
			c-&gt;lstats.inBadAuth++;
			freeb(b);
			return nil;
		}
		b-&gt;wp -= c-&gt;in.authlen;
	}

	if(c-&gt;in.cipher != 0) {
		if(!(*c-&gt;in.cipher)(&amp;c-&gt;in, b-&gt;rp, BLEN(b))) {
if(0)print("bad cipher\n");
			c-&gt;lstats.inBadOther++;
			freeb(b);
			return nil;
		}
		b-&gt;rp += c-&gt;in.cipherivlen;
		if(c-&gt;in.cipherblklen &gt; 1) {
			pad = b-&gt;wp[-1];
			if(pad &gt; BLEN(b)) {
if(0)print("pad too big\n");
				c-&gt;lstats.inBadOther++;
				freeb(b);
				return nil;
			}
			b-&gt;wp -= pad;
		}
	}

	// ok the packet is good
	if(seqdiff &gt; 0) {
		while(seqdiff &gt; 0 &amp;&amp; c-&gt;in.window != 0) {
			if((c-&gt;in.window &amp; (1&lt;&lt;(SeqWindow-1))) == 0) {
				c-&gt;lstats.inMissing++;
			}
			c-&gt;in.window &lt;&lt;= 1;
			seqdiff--;
		}
		if(seqdiff &gt; 0) {
			c-&gt;lstats.inMissing += seqdiff;
			seqdiff = 0;
		}
		c-&gt;in.seq = seq;
		c-&gt;in.seqwrap = seqwrap;
	}
	c-&gt;in.window |= 1&lt;&lt;-seqdiff;
	c-&gt;lastrecv = TK2SEC(m-&gt;ticks);

	switch(type) {
	case TControl:
		convicontrol(c, subtype, b);
		return nil;
	case TData:
		c-&gt;lstats.inDataPackets++;
		c-&gt;lstats.inDataBytes += BLEN(b);
		if(control)
			break;
		return b;
	case TCompData:
		c-&gt;lstats.inDataPackets++;
		c-&gt;lstats.inCompDataBytes += BLEN(b);
		b = convicomp(c, subtype, seq, b);
		if(b == nil) {
			c-&gt;lstats.inBadComp++;
			return nil;
		}
		c-&gt;lstats.inDataBytes += BLEN(b);
		if(control)
			break;
		return b;
	}
if(0)print("dropping packet id=%d: type=%d n=%ld control=%d\n", c-&gt;id, type, BLEN(b), control);
	c-&gt;lstats.inBadOther++;
	freeb(b);
	return nil;
}

// assume hold conv lock
static void
conviconnect(Conv *c, int subtype, Block *b)
{
	ulong dialid;
	ulong acceptid;

	if(BLEN(b) != 8) {
		freeb(b);
		return;
	}
	dialid = nhgetl(b-&gt;rp);
	acceptid = nhgetl(b-&gt;rp + 4);
	freeb(b);

if(0)print("sdp: conviconnect: %s: %d %uld %uld\n", convstatename[c-&gt;state], subtype, dialid, acceptid);

	if(subtype == ConReset) {
		convsetstate(c, CClosed);
		return;
	}

	switch(c-&gt;state) {
	default:
		panic("unknown state: %d", c-&gt;state);
	case CInit:
		break;
	case CDial:
		if(dialid != c-&gt;dialid)
			goto Reset;
		break;
	case CAccept:
	case COpen:
	case CLocalClose:
	case CRemoteClose:
		if(dialid != c-&gt;dialid
		|| subtype != ConOpenRequest &amp;&amp; acceptid != c-&gt;acceptid)
			goto Reset;
		break;
	case CClosed:
		goto Reset;
	}

	switch(subtype) {
	case ConOpenRequest:
		switch(c-&gt;state) {
		case CInit:
			c-&gt;dialid = dialid;
			convsetstate(c, CAccept);
			return;
		case CAccept:
		case COpen:
			// duplicate ConOpenRequest that we ignore
			return;
		}
		break;
	case ConOpenAck:
		switch(c-&gt;state) {
		case CDial:
			c-&gt;acceptid = acceptid;
			convsetstate(c, COpen);
			return;
		case COpen:
			// duplicate that we have to ack
			convoconnect(c, ConOpenAckAck, acceptid, dialid);
			return;
		}
		break;
	case ConOpenAckAck:
		switch(c-&gt;state) {
		case CAccept:
			convsetstate(c, COpen);
			return;
		case COpen:
		case CLocalClose:
		case CRemoteClose:
			// duplicate that we ignore
			return;
		}
		break;
	case ConClose:
		switch(c-&gt;state) {
		case COpen:
			convoconnect(c, ConCloseAck, dialid, acceptid);
			convsetstate(c, CRemoteClose);
			return;
		case CRemoteClose:
			// duplicate ConClose
			convoconnect(c, ConCloseAck, dialid, acceptid);
			return;
		}
		break;
	case ConCloseAck:
		switch(c-&gt;state) {
		case CLocalClose:
			convsetstate(c, CClosed);
			return;
		}
		break;
	}
Reset:
	// invalid connection message - reset to sender
if(1)print("sdp: invalid conviconnect - sending reset\n");
	convoconnect(c, ConReset, dialid, acceptid);
	convsetstate(c, CClosed);
}

static void
convicontrol(Conv *c, int subtype, Block *b)
{
	ulong cseq;
	AckPkt *ack;
	int i;

	if(BLEN(b) &lt; 4)
		return;
	cseq = nhgetl(b-&gt;rp);
	
	switch(subtype){
	case ControlMesg:
		if(cseq == c-&gt;in.controlseq) {
if(0)print("duplicate control packet: %ulx\n", cseq);
			// duplicate control packet
			freeb(b);
			if(c-&gt;in.controlpkt == nil)
				convack(c);
			return;
		}

		if(cseq != c-&gt;in.controlseq+1)
			return;
		c-&gt;in.controlseq = cseq;
		b-&gt;rp += 4;
		if(BLEN(b) == 0) {
			// just a ping
			freeb(b);
			convack(c);
		} else {
			c-&gt;in.controlpkt = b;
if(0) print("recv %ld size=%ld\n", cseq, BLEN(b));
			wakeup(&amp;c-&gt;in.controlready);
		}
		return;
	case ControlAck:
		if(cseq != c-&gt;out.controlseq)
			return;
		if(BLEN(b) &lt; sizeof(AckPkt))
			return;
		ack = (AckPkt*)(b-&gt;rp);
		c-&gt;rstats.outPackets = nhgetl(ack-&gt;outPackets);
		c-&gt;rstats.outDataPackets = nhgetl(ack-&gt;outDataPackets);
		c-&gt;rstats.outDataBytes = nhgetl(ack-&gt;outDataBytes);
		c-&gt;rstats.outCompDataBytes = nhgetl(ack-&gt;outCompDataBytes);
		for(i=0; i&lt;NCompStats; i++)
			c-&gt;rstats.outCompStats[i] = nhgetl(ack-&gt;outCompStats + 4*i);
		c-&gt;rstats.inPackets = nhgetl(ack-&gt;inPackets);
		c-&gt;rstats.inDataPackets = nhgetl(ack-&gt;inDataPackets);
		c-&gt;rstats.inDataBytes = nhgetl(ack-&gt;inDataBytes);
		c-&gt;rstats.inCompDataBytes = nhgetl(ack-&gt;inCompDataBytes);
		c-&gt;rstats.inMissing = nhgetl(ack-&gt;inMissing);
		c-&gt;rstats.inDup = nhgetl(ack-&gt;inDup);
		c-&gt;rstats.inReorder = nhgetl(ack-&gt;inReorder);
		c-&gt;rstats.inBadComp = nhgetl(ack-&gt;inBadComp);
		c-&gt;rstats.inBadAuth = nhgetl(ack-&gt;inBadAuth);
		c-&gt;rstats.inBadSeq = nhgetl(ack-&gt;inBadSeq);
		c-&gt;rstats.inBadOther = nhgetl(ack-&gt;inBadOther);
		freeb(b);
		freeb(c-&gt;out.controlpkt);
		c-&gt;out.controlpkt = nil;
		c-&gt;timeout = c-&gt;lastrecv + KeepAlive;
		wakeup(&amp;c-&gt;out.controlready);
		return;
	}
}

static Block*
convicomp(Conv *c, int subtype, ulong seq, Block *b)
{
	if(c-&gt;in.comp == nil) {
		freeb(b);
		return nil;
	}
	if(!(*c-&gt;in.comp)(c, subtype, seq, &amp;b))
		return nil;
	return b;
}

// c is locked
static void
convwriteblock(Conv *c, Block *b)
{
	// simulated errors
	if(c-&gt;drop &amp;&amp; nrand(c-&gt;drop) == 0)
		return;

	if(waserror()) {
		convsetstate(c, CClosed);
		nexterror();
	}
	devtab[c-&gt;chan-&gt;type]-&gt;bwrite(c-&gt;chan, b, 0);
	poperror();
}


// assume hold conv lock
static void
convoput(Conv *c, int type, int subtype, Block *b)
{
	int pad;
	
	c-&gt;lstats.outPackets++;
	/* Make room for sdp trailer */
	if(c-&gt;out.cipherblklen &gt; 1)
		pad = c-&gt;out.cipherblklen - (BLEN(b) + c-&gt;out.cipherivlen) % c-&gt;out.cipherblklen;
	else
		pad = 0;

	b = padblock(b, -(pad+c-&gt;out.authlen));

	if(pad) {
		memset(b-&gt;wp, 0, pad-1);
		b-&gt;wp[pad-1] = pad;
		b-&gt;wp += pad;
	}

	/* Make space to fit sdp header */
	b = padblock(b, 4 + c-&gt;out.cipherivlen);
	b-&gt;rp[0] = (type &lt;&lt; 4) | subtype;
	c-&gt;out.seq++;
	if(c-&gt;out.seq == (1&lt;&lt;24)) {
		c-&gt;out.seq = 0;
		c-&gt;out.seqwrap++;
	}
	b-&gt;rp[1] = c-&gt;out.seq&gt;&gt;16;
	b-&gt;rp[2] = c-&gt;out.seq&gt;&gt;8;
	b-&gt;rp[3] = c-&gt;out.seq;
	
	if(c-&gt;out.cipher)
		(*c-&gt;out.cipher)(&amp;c-&gt;out, b-&gt;rp+4, BLEN(b)-4);

	// auth
	if(c-&gt;out.auth) {
		b-&gt;wp += c-&gt;out.authlen;
		(*c-&gt;out.auth)(&amp;c-&gt;out, b-&gt;rp, BLEN(b));
	}
	
	convwriteblock(c, b);
}

// assume hold conv lock
static void
convoconnect(Conv *c, int op, ulong dialid, ulong acceptid)
{
	Block *b;

	c-&gt;lstats.outPackets++;
	assert(c-&gt;chan != nil);
	b = allocb(9);
	b-&gt;wp[0] = (TConnect &lt;&lt; 4) | op;
	hnputl(b-&gt;wp+1, dialid);
	hnputl(b-&gt;wp+5, acceptid);
	b-&gt;wp += 9;

	if(!waserror()) {
		convwriteblock(c, b);
		poperror();
	}
}

static Block *
convreadblock(Conv *c, int n)
{
	Block *b;
	Chan *ch;

	qlock(&amp;c-&gt;readlk);
	if(waserror()) {
		c-&gt;readproc = nil;
		qunlock(&amp;c-&gt;readlk);
		nexterror();
	}
	qlock(c);
	if(c-&gt;state == CClosed) {
		qunlock(c);
		error("closed");
	}
	c-&gt;readproc = up;
	ch = c-&gt;chan;
	assert(c-&gt;ref &gt; 0);
	qunlock(c);

	b = devtab[ch-&gt;type]-&gt;bread(ch, n, 0);
	c-&gt;readproc = nil;
	poperror();
	qunlock(&amp;c-&gt;readlk);

	return b;
}

static int
readready(void *a)
{
	Conv *c = a;

	return c-&gt;in.controlpkt != nil || (c-&gt;state == CClosed) || (c-&gt;state == CRemoteClose);
}

static Block *
readcontrol(Conv *c, int n)
{
	Block *b;

	USED(n);

	qlock(&amp;c-&gt;in.controllk);
	if(waserror()) {
		qunlock(&amp;c-&gt;in.controllk);
		nexterror();
	}
	qlock(c);	// this lock is not held during the sleep below

	for(;;) {
		if(c-&gt;chan == nil || c-&gt;state == CClosed) {
			qunlock(c);
if(0)print("readcontrol: return error - state = %s\n", convstatename[c-&gt;state]);
			error("conversation closed");
		}

		if(c-&gt;in.controlpkt != nil)
			break;

		if(c-&gt;state == CRemoteClose) {
			qunlock(c);
if(0)print("readcontrol: return nil - state = %s\n", convstatename[c-&gt;state]);
			poperror();
			return nil;
		}
		qunlock(c);
		sleep(&amp;c-&gt;in.controlready, readready, c);
		qlock(c);
	}

	convack(c);

	b = c-&gt;in.controlpkt;
	c-&gt;in.controlpkt = nil;
	qunlock(c);
	poperror();
	qunlock(&amp;c-&gt;in.controllk);
	return b;
}


static int
writeready(void *a)
{
	Conv *c = a;

	return c-&gt;out.controlpkt == nil || (c-&gt;state == CClosed) || (c-&gt;state == CRemoteClose);
}

// c is locked
static void
writewait(Conv *c)
{
	for(;;) {
		if(c-&gt;state == CFree || c-&gt;state == CInit ||
		   c-&gt;state == CClosed || c-&gt;state == CRemoteClose)
			error("conversation closed");

		if(c-&gt;state == COpen &amp;&amp; c-&gt;out.controlpkt == nil)
			break;

		qunlock(c);
		if(waserror()) {
			qlock(c);
			nexterror();
		}
		sleep(&amp;c-&gt;out.controlready, writeready, c);
		poperror();
		qlock(c);
	}
}

static void
writecontrol(Conv *c, void *p, int n, int wait)
{
	Block *b;

	qlock(&amp;c-&gt;out.controllk);
	qlock(c);
	if(waserror()) {
		qunlock(c);
		qunlock(&amp;c-&gt;out.controllk);
		nexterror();
	}
	writewait(c);
	b = allocb(4+n);
	c-&gt;out.controlseq++;
	hnputl(b-&gt;wp, c-&gt;out.controlseq);
	memmove(b-&gt;wp+4, p, n);
	b-&gt;wp += 4+n;
	c-&gt;out.controlpkt = b;
	convretryinit(c);
	convoput(c, TControl, ControlMesg, copyblock(b, blocklen(b)));
	if(wait)
		writewait(c);
	poperror();
	qunlock(c);
	qunlock(&amp;c-&gt;out.controllk);
}

static Block *
readdata(Conv *c, int n)
{
	Block *b;
	int nn;

	for(;;) {

		// some slack for tunneling overhead
		nn = n + 100;

		// make sure size is big enough for control messages
		if(nn &lt; 1000)
			nn = 1000;
		b = convreadblock(c, nn);
		if(b == nil)
			return nil;
		qlock(c);
		if(waserror()) {
			qunlock(c);
			return nil;
		}
		b = conviput(c, b, 0);
		poperror();
		qunlock(c);
		if(b != nil) {
			if(BLEN(b) &gt; n)
				b-&gt;wp = b-&gt;rp + n;
			return b;
		}
	}
}

static long
writedata(Conv *c, Block *b)
{
	int n;
	ulong seq;
	int subtype;

	qlock(c);
	if(waserror()) {
		qunlock(c);
		nexterror();
	}

	if(c-&gt;state != COpen) {
		freeb(b);
		error("conversation not open");
	}

	n = BLEN(b);
	c-&gt;lstats.outDataPackets++;
	c-&gt;lstats.outDataBytes += n;

	if(c-&gt;out.comp != nil) {
		// must generate same value as convoput
		seq = (c-&gt;out.seq + 1) &amp; (SeqMax-1);

		subtype = (*c-&gt;out.comp)(c, 0, seq, &amp;b);
		c-&gt;lstats.outCompDataBytes += BLEN(b);
		convoput(c, TCompData, subtype, b);
	} else
		convoput(c, TData, 0, b);

	poperror();
	qunlock(c);
	return n;
}

static void
convreader(void *a)
{
	Conv *c = a;
	Block *b;

	qlock(c);
	assert(c-&gt;reader == 1);
	while(c-&gt;dataopen == 0 &amp;&amp; c-&gt;state != CClosed) {
		qunlock(c);
		b = nil;
		if(!waserror()) {
			b = convreadblock(c, 2000);
			poperror();
		}
		qlock(c);
		if(b == nil) {
			if(strcmp(up-&gt;errstr, Eintr) != 0) {
				convsetstate(c, CClosed);
				break;
			}
		} else if(!waserror()) {
			conviput(c, b, 1);
			poperror();
		}
	}
	c-&gt;reader = 0;
	convderef(c);
	qunlock(c);
	pexit("hangup", 1);
}


/* ciphers, authenticators, and compressors  */

static void
setalg(Conv *c, char *name, Algorithm *alg, Algorithm **p)
{
	for(; alg-&gt;name; alg++)
		if(strcmp(name, alg-&gt;name) == 0)
			break;
	if(alg-&gt;name == nil)
		error("unknown algorithm");

	*p = alg;
	alg-&gt;init(c);
}

static void
setsecret(OneWay *ow, char *secret)
{
	char *p;
	int i, c;
	
	i = 0;
	memset(ow-&gt;secret, 0, sizeof(ow-&gt;secret));
	for(p=secret; *p; p++) {
		if(i &gt;= sizeof(ow-&gt;secret)*2)
			break;
		c = *p;
		if(c &gt;= '0' &amp;&amp; c &lt;= '9')
			c -= '0';
		else if(c &gt;= 'a' &amp;&amp; c &lt;= 'f')
			c -= 'a'-10;
		else if(c &gt;= 'A' &amp;&amp; c &lt;= 'F')
			c -= 'A'-10;
		else
			error("bad character in secret");
		if((i&amp;1) == 0)
			c &lt;&lt;= 4;
		ow-&gt;secret[i&gt;&gt;1] |= c;
		i++;
	}
}

static void
setkey(uchar *key, int n, OneWay *ow, char *prefix)
{
	uchar ibuf[SHA1dlen], obuf[MD5dlen], salt[10];
	int i, round = 0;

	while(n &gt; 0){
		for(i=0; i&lt;round+1; i++)
			salt[i] = 'A'+round;
		sha1((uchar*)prefix, strlen(prefix), ibuf, sha1(salt, round+1, nil, nil));
		md5(ibuf, SHA1dlen, obuf, md5(ow-&gt;secret, sizeof(ow-&gt;secret), nil, nil));
		i = (n&lt;MD5dlen) ? n : MD5dlen;
		memmove(key, obuf, i);
		key += i;
		n -= i;
		if(++round &gt; sizeof salt)
			panic("setkey: you ask too much");
	}
}

static void
cipherfree(Conv *c)
{
	if(c-&gt;in.cipherstate) {
		free(c-&gt;in.cipherstate);
		c-&gt;in.cipherstate = nil;
	}
	if(c-&gt;out.cipherstate) {
		free(c-&gt;out.cipherstate);
		c-&gt;out.cipherstate = nil;
	}
	c-&gt;in.cipher = nil;
	c-&gt;in.cipherblklen = 0;
	c-&gt;out.cipherblklen = 0;
	c-&gt;in.cipherivlen = 0;
	c-&gt;out.cipherivlen = 0;
}

static void
authfree(Conv *c)
{
	if(c-&gt;in.authstate) {
		free(c-&gt;in.authstate);
		c-&gt;in.authstate = nil;
	}
	if(c-&gt;out.authstate) {
		free(c-&gt;out.authstate);
		c-&gt;out.authstate = nil;
	}
	c-&gt;in.auth = nil;
	c-&gt;in.authlen = 0;
	c-&gt;out.authlen = 0;
}

static void
compfree(Conv *c)
{
	if(c-&gt;in.compstate) {
		free(c-&gt;in.compstate);
		c-&gt;in.compstate = nil;
	}
	if(c-&gt;out.compstate) {
		free(c-&gt;out.compstate);
		c-&gt;out.compstate = nil;
	}
	c-&gt;in.comp = nil;
}

static void
nullcipherinit(Conv *c)
{
	cipherfree(c);
}

static int
desencrypt(OneWay *ow, uchar *p, int n)
{
	uchar *pp, *ip, *eip, *ep;
	DESstate *ds = ow-&gt;cipherstate;

	if(n &lt; 8 || (n &amp; 0x7 != 0))
		return 0;
	ep = p + n;
	memmove(p, ds-&gt;ivec, 8);
	for(p += 8; p &lt; ep; p += 8){
		pp = p;
		ip = ds-&gt;ivec;
		for(eip = ip+8; ip &lt; eip; )
			*pp++ ^= *ip++;
		block_cipher(ds-&gt;expanded, p, 0);
		memmove(ds-&gt;ivec, p, 8);
	}
	return 1;
}

static int
desdecrypt(OneWay *ow, uchar *p, int n)
{
	uchar tmp[8];
	uchar *tp, *ip, *eip, *ep;
	DESstate *ds = ow-&gt;cipherstate;

	if(n &lt; 8 || (n &amp; 0x7 != 0))
		return 0;
	ep = p + n;
	memmove(ds-&gt;ivec, p, 8);
	p += 8;
	while(p &lt; ep){
		memmove(tmp, p, 8);
		block_cipher(ds-&gt;expanded, p, 1);
		tp = tmp;
		ip = ds-&gt;ivec;
		for(eip = ip+8; ip &lt; eip; ){
			*p++ ^= *ip;
			*ip++ = *tp++;
		}
	}
	return 1;
}

static void
descipherinit(Conv *c)
{
	uchar key[8];
	uchar ivec[8];
	int i;
	int n = c-&gt;cipher-&gt;keylen;

	cipherfree(c);
	
	if(n &gt; sizeof(key))
		n = sizeof(key);

	/* in */
	memset(key, 0, sizeof(key));
	setkey(key, n, &amp;c-&gt;in, "cipher");
	memset(ivec, 0, sizeof(ivec));
	c-&gt;in.cipherblklen = 8;
	c-&gt;in.cipherivlen = 8;
	c-&gt;in.cipher = desdecrypt;
	c-&gt;in.cipherstate = smalloc(sizeof(DESstate));
	setupDESstate(c-&gt;in.cipherstate, key, ivec);
	
	/* out */
	memset(key, 0, sizeof(key));
	setkey(key, n, &amp;c-&gt;out, "cipher");
	for(i=0; i&lt;8; i++)
		ivec[i] = nrand(256);
	c-&gt;out.cipherblklen = 8;
	c-&gt;out.cipherivlen = 8;
	c-&gt;out.cipher = desencrypt;
	c-&gt;out.cipherstate = smalloc(sizeof(DESstate));
	setupDESstate(c-&gt;out.cipherstate, key, ivec);
}

static int
rc4encrypt(OneWay *ow, uchar *p, int n)
{
	CipherRc4 *cr = ow-&gt;cipherstate;

	if(n &lt; 4)
		return 0;

	hnputl(p, cr-&gt;cseq);
	p += 4;
	n -= 4;
	rc4(&amp;cr-&gt;current, p, n);
	cr-&gt;cseq += n;
	return 1;
}

static int
rc4decrypt(OneWay *ow, uchar *p, int n)
{
	CipherRc4 *cr = ow-&gt;cipherstate;
	RC4state tmpstate;
	ulong seq;
	long d, dd;

	if(n &lt; 4)
		return 0;

	seq = nhgetl(p);
	p += 4;
	n -= 4;
	d = seq-cr-&gt;cseq;
	if(d == 0) {
		rc4(&amp;cr-&gt;current, p, n);
		cr-&gt;cseq += n;
		if(cr-&gt;ovalid) {
			dd = cr-&gt;cseq - cr-&gt;lgseq;
			if(dd &gt; RC4back)
				cr-&gt;ovalid = 0;
		}
	} else if(d &gt; 0) {
//print("missing packet: %uld %ld\n", seq, d);
		// this link is hosed 
		if(d &gt; RC4forward)
			return 0;
		cr-&gt;lgseq = seq;
		if(!cr-&gt;ovalid) {
			cr-&gt;ovalid = 1;
			cr-&gt;oseq = cr-&gt;cseq;
			memmove(&amp;cr-&gt;old, &amp;cr-&gt;current, sizeof(RC4state));
		}
		rc4skip(&amp;cr-&gt;current, d);
		rc4(&amp;cr-&gt;current, p, n);
		cr-&gt;cseq = seq+n;
	} else {
//print("reordered packet: %uld %ld\n", seq, d);
		dd = seq - cr-&gt;oseq;
		if(!cr-&gt;ovalid || -d &gt; RC4back || dd &lt; 0)
			return 0;
		memmove(&amp;tmpstate, &amp;cr-&gt;old, sizeof(RC4state));
		rc4skip(&amp;tmpstate, dd);
		rc4(&amp;tmpstate, p, n);
		return 1;
	}

	// move old state up
	if(cr-&gt;ovalid) {
		dd = cr-&gt;cseq - RC4back - cr-&gt;oseq;
		if(dd &gt; 0) {
			rc4skip(&amp;cr-&gt;old, dd);
			cr-&gt;oseq += dd;
		}
	}

	return 1;
}

static void
rc4cipherinit(Conv *c)
{
	uchar key[32];
	CipherRc4 *cr;
	int n;

	cipherfree(c);

	n = c-&gt;cipher-&gt;keylen;
	if(n &gt; sizeof(key))
		n = sizeof(key);

	/* in */
	memset(key, 0, sizeof(key));
	setkey(key, n, &amp;c-&gt;in, "cipher");
	c-&gt;in.cipherblklen = 1;
	c-&gt;in.cipherivlen = 4;
	c-&gt;in.cipher = rc4decrypt;
	cr = smalloc(sizeof(CipherRc4));
	memset(cr, 0, sizeof(*cr));
	setupRC4state(&amp;cr-&gt;current, key, n);
	c-&gt;in.cipherstate = cr;

	/* out */
	memset(key, 0, sizeof(key));
	setkey(key, n, &amp;c-&gt;out, "cipher");
	c-&gt;out.cipherblklen = 1;
	c-&gt;out.cipherivlen = 4;
	c-&gt;out.cipher = rc4encrypt;
	cr = smalloc(sizeof(CipherRc4));
	memset(cr, 0, sizeof(*cr));
	setupRC4state(&amp;cr-&gt;current, key, n);
	c-&gt;out.cipherstate = cr;
}

static void
nullauthinit(Conv *c)
{
	authfree(c);
}

static void
shaauthinit(Conv *c)
{
	authfree(c);
}

static void
seanq_hmac_md5(uchar hash[MD5dlen], ulong wrap, uchar *t, long tlen, uchar *key, long klen)
{
	uchar ipad[65], opad[65], wbuf[4];
	int i;
	DigestState *digest;
	uchar innerhash[MD5dlen];

	for(i=0; i&lt;64; i++){
		ipad[i] = 0x36;
		opad[i] = 0x5c;
	}
	ipad[64] = opad[64] = 0;
	for(i=0; i&lt;klen; i++){
		ipad[i] ^= key[i];
		opad[i] ^= key[i];
	}
	hnputl(wbuf, wrap);
	digest = md5(ipad, 64, nil, nil);
	digest = md5(wbuf, sizeof(wbuf), nil, digest);
	md5(t, tlen, innerhash, digest);
	digest = md5(opad, 64, nil, nil);
	md5(innerhash, MD5dlen, hash, digest);
}

static int
md5auth(OneWay *ow, uchar *t, int tlen)
{
	uchar hash[MD5dlen];
	int r;

	if(tlen &lt; ow-&gt;authlen)
		return 0;
	tlen -= ow-&gt;authlen;

	memset(hash, 0, MD5dlen);
	seanq_hmac_md5(hash, ow-&gt;seqwrap, t, tlen, (uchar*)ow-&gt;authstate, 16);
	r = memcmp(t+tlen, hash, ow-&gt;authlen) == 0;
	memmove(t+tlen, hash, ow-&gt;authlen);
	return r;
}

static void
md5authinit(Conv *c)
{
	int keylen;

	authfree(c);

	keylen = c-&gt;auth-&gt;keylen;
	if(keylen &gt; 16)
		keylen = 16;

	/* in */
	c-&gt;in.authstate = smalloc(16);
	memset(c-&gt;in.authstate, 0, 16);
	setkey(c-&gt;in.authstate, keylen, &amp;c-&gt;in, "auth");
	c-&gt;in.authlen = 12;
	c-&gt;in.auth = md5auth;
	
	/* out */
	c-&gt;out.authstate = smalloc(16);
	memset(c-&gt;out.authstate, 0, 16);
	setkey(c-&gt;out.authstate, keylen, &amp;c-&gt;out, "auth");
	c-&gt;out.authlen = 12;
	c-&gt;out.auth = md5auth;
}

static void
nullcompinit(Conv *c)
{
	compfree(c);
}

static int
thwackcomp(Conv *c, int, ulong seq, Block **bp)
{
	Block *b, *bb;
	int nn;
	ulong ackseq;
	uchar mask;

	// add ack info
	b = padblock(*bp, 4);

	ackseq = unthwackstate(c-&gt;in.compstate, &amp;mask);
	b-&gt;rp[0] = mask;
	b-&gt;rp[1] = ackseq&gt;&gt;16;
	b-&gt;rp[2] = ackseq&gt;&gt;8;
	b-&gt;rp[3] = ackseq;

	bb = allocb(BLEN(b));
	nn = thwack(c-&gt;out.compstate, bb-&gt;wp, b-&gt;rp, BLEN(b), seq, c-&gt;lstats.outCompStats);
	if(nn &lt; 0) {
		freeb(bb);
		*bp = b;
		return ThwackU;
	} else {
		bb-&gt;wp += nn;
		freeb(b);
		*bp = bb;
		return ThwackC;
	}
}

static int
thwackuncomp(Conv *c, int subtype, ulong seq, Block **bp)
{
	Block *b, *bb;
	ulong mask;
	ulong mseq;
	int n;

	switch(subtype) {
	default:
		return 0;
	case ThwackU:
		b = *bp;
		mask = b-&gt;rp[0];
		mseq = (b-&gt;rp[1]&lt;&lt;16) | (b-&gt;rp[2]&lt;&lt;8) | b-&gt;rp[3];
		b-&gt;rp += 4;
		thwackack(c-&gt;out.compstate, mseq, mask);
		return 1;
	case ThwackC:
		bb = *bp;
		b = allocb(ThwMaxBlock);
		n = unthwack(c-&gt;in.compstate, b-&gt;wp, ThwMaxBlock, bb-&gt;rp, BLEN(bb), seq);
		freeb(bb);
		*bp = nil;
		if(n &lt; 0) {
if(0)print("unthwack failed: %d\n", n);
			freeb(b);
			return 0;
		}
		b-&gt;wp += n;
		mask = b-&gt;rp[0];
		mseq = (b-&gt;rp[1]&lt;&lt;16) | (b-&gt;rp[2]&lt;&lt;8) | b-&gt;rp[3];
		thwackack(c-&gt;out.compstate, mseq, mask);
		b-&gt;rp += 4;
		*bp = b;
		return 1;
	}
}

static void
thwackcompinit(Conv *c)
{
	compfree(c);

	c-&gt;in.compstate = malloc(sizeof(Unthwack));
	if(c-&gt;in.compstate == nil)
		error(Enomem);
	unthwackinit(c-&gt;in.compstate);
	c-&gt;out.compstate = malloc(sizeof(Thwack));
	if(c-&gt;out.compstate == nil)
		error(Enomem);
	thwackinit(c-&gt;out.compstate);
	c-&gt;in.comp = thwackuncomp;
	c-&gt;out.comp = thwackcomp;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

