<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devsrv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devsrv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"


typedef struct Srv Srv;
struct Srv
{
	char	*name;
	char	*owner;
	ulong	perm;
	Chan	*chan;
	Srv	*link;
	ulong	path;
};

static QLock	srvlk;
static Srv	*srv;
static int	qidpath;

static int
srvgen(Chan *c, char*, Dirtab*, int, int s, Dir *dp)
{
	Srv *sp;
	Qid q;

	if(s == DEVDOTDOT){
		devdir(c, c-&gt;qid, "#s", 0, eve, 0555, dp);
		return 1;
	}

	qlock(&amp;srvlk);
	for(sp = srv; sp &amp;&amp; s; sp = sp-&gt;link)
		s--;

	if(sp == 0) {
		qunlock(&amp;srvlk);
		return -1;
	}

	mkqid(&amp;q, sp-&gt;path, 0, QTFILE);
	/* make sure name string continues to exist after we release lock */
	kstrcpy(up-&gt;genbuf, sp-&gt;name, sizeof up-&gt;genbuf);
	devdir(c, q, up-&gt;genbuf, 0, sp-&gt;owner, sp-&gt;perm, dp);
	qunlock(&amp;srvlk);
	return 1;
}

static void
srvinit(void)
{
	qidpath = 1;
}

static Chan*
srvattach(char *spec)
{
	return devattach('s', spec);
}

static Walkqid*
srvwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, srvgen);
}

static Srv*
srvlookup(char *name, ulong qidpath)
{
	Srv *sp;
	for(sp = srv; sp; sp = sp-&gt;link)
		if(sp-&gt;path == qidpath || (name &amp;&amp; strcmp(sp-&gt;name, name) == 0))
			return sp;
	return nil;
}

static int
srvstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, 0, 0, srvgen);
}

char*
srvname(Chan *c)
{
	int size;
	Srv *sp;
	char *s;

	for(sp = srv; sp; sp = sp-&gt;link)
		if(sp-&gt;chan == c){
			size = 3+strlen(sp-&gt;name)+1;
			s = smalloc(size);
			snprint(s, size, "#s/%s", sp-&gt;name);
			return s;
		}
	return nil;
}

static Chan*
srvopen(Chan *c, int omode)
{
	Srv *sp;

	if(c-&gt;qid.type == QTDIR){
		if(omode &amp; ORCLOSE)
			error(Eperm);
		if(omode != OREAD)
			error(Eisdir);
		c-&gt;mode = omode;
		c-&gt;flag |= COPEN;
		c-&gt;offset = 0;
		return c;
	}
	qlock(&amp;srvlk);
	if(waserror()){
		qunlock(&amp;srvlk);
		nexterror();
	}

	sp = srvlookup(nil, c-&gt;qid.path);
	if(sp == 0 || sp-&gt;chan == 0)
		error(Eshutdown);

	if(omode&amp;OTRUNC)
		error("srv file already exists");
	if(openmode(omode)!=sp-&gt;chan-&gt;mode &amp;&amp; sp-&gt;chan-&gt;mode!=ORDWR)
		error(Eperm);
	devpermcheck(sp-&gt;owner, sp-&gt;perm, omode);

	cclose(c);
	incref(sp-&gt;chan);
	qunlock(&amp;srvlk);
	poperror();
	return sp-&gt;chan;
}

static void
srvcreate(Chan *c, char *name, int omode, ulong perm)
{
	char *sname;
	Srv *sp;

	if(openmode(omode) != OWRITE)
		error(Eperm);

	if(omode &amp; OCEXEC)	/* can't happen */
		panic("someone broke namec");

	sp = smalloc(sizeof *sp);
	sname = smalloc(strlen(name)+1);

	qlock(&amp;srvlk);
	if(waserror()){
		free(sp);
		free(sname);
		qunlock(&amp;srvlk);
		nexterror();
	}
	if(sp == nil || sname == nil)
		error(Enomem);
	if(srvlookup(name, -1))
		error(Eexist);

	sp-&gt;path = qidpath++;
	sp-&gt;link = srv;
	strcpy(sname, name);
	sp-&gt;name = sname;
	c-&gt;qid.type = QTFILE;
	c-&gt;qid.path = sp-&gt;path;
	srv = sp;
	qunlock(&amp;srvlk);
	poperror();

	kstrdup(&amp;sp-&gt;owner, up-&gt;user);
	sp-&gt;perm = perm&amp;0777;

	c-&gt;flag |= COPEN;
	c-&gt;mode = OWRITE;
}

static void
srvremove(Chan *c)
{
	Srv *sp, **l;

	if(c-&gt;qid.type == QTDIR)
		error(Eperm);

	qlock(&amp;srvlk);
	if(waserror()){
		qunlock(&amp;srvlk);
		nexterror();
	}
	l = &amp;srv;
	for(sp = *l; sp; sp = sp-&gt;link) {
		if(sp-&gt;path == c-&gt;qid.path)
			break;

		l = &amp;sp-&gt;link;
	}
	if(sp == 0)
		error(Enonexist);

	/*
	 * Only eve can remove system services.
	 * No one can remove #s/boot.
	 */
	if(strcmp(sp-&gt;owner, eve) == 0 &amp;&amp; !iseve())
		error(Eperm);
	if(strcmp(sp-&gt;name, "boot") == 0)
		error(Eperm);

	/*
	 * No removing personal services.
	 */
	if((sp-&gt;perm&amp;7) != 7 &amp;&amp; strcmp(sp-&gt;owner, up-&gt;user) &amp;&amp; !iseve())
		error(Eperm);

	*l = sp-&gt;link;
	qunlock(&amp;srvlk);
	poperror();

	if(sp-&gt;chan)
		cclose(sp-&gt;chan);
	free(sp-&gt;owner);
	free(sp-&gt;name);
	free(sp);
}

static int
srvwstat(Chan *c, uchar *dp, int n)
{
	char *strs;
	Dir d;
	Srv *sp;

	if(c-&gt;qid.type &amp; QTDIR)
		error(Eperm);

	strs = nil;
	qlock(&amp;srvlk);
	if(waserror()){
		qunlock(&amp;srvlk);
		free(strs);
		nexterror();
	}

	sp = srvlookup(nil, c-&gt;qid.path);
	if(sp == 0)
		error(Enonexist);

	if(strcmp(sp-&gt;owner, up-&gt;user) != 0 &amp;&amp; !iseve())
		error(Eperm);

	strs = smalloc(n);
	n = convM2D(dp, n, &amp;d, strs);
	if(n == 0)
		error(Eshortstat);
	if(d.mode != ~0UL)
		sp-&gt;perm = d.mode &amp; 0777;
	if(d.uid &amp;&amp; *d.uid)
		kstrdup(&amp;sp-&gt;owner, d.uid);
	if(d.name &amp;&amp; *d.name &amp;&amp; strcmp(sp-&gt;name, d.name) != 0) {
		if(strchr(d.name, '/') != nil)
			error(Ebadchar);
		kstrdup(&amp;sp-&gt;name, d.name);
	}
	qunlock(&amp;srvlk);
	free(strs);
	poperror();
	return n;
}

static void
srvclose(Chan *c)
{
	/*
	 * in theory we need to override any changes in removability
	 * since open, but since all that's checked is the owner,
	 * which is immutable, all is well.
	 */
	if(c-&gt;flag &amp; CRCLOSE){
		if(waserror())
			return;
		srvremove(c);
		poperror();
	}
}

static long
srvread(Chan *c, void *va, long n, vlong)
{
	isdir(c);
	return devdirread(c, va, n, 0, 0, srvgen);
}

static long
srvwrite(Chan *c, void *va, long n, vlong)
{
	Srv *sp;
	Chan *c1;
	int fd;
	char buf[32];

	if(n &gt;= sizeof buf)
		error(Egreg);
	memmove(buf, va, n);	/* so we can NUL-terminate */
	buf[n] = 0;
	fd = strtoul(buf, 0, 0);

	c1 = fdtochan(fd, -1, 0, 1);	/* error check and inc ref */

	qlock(&amp;srvlk);
	if(waserror()) {
		qunlock(&amp;srvlk);
		cclose(c1);
		nexterror();
	}
	if(c1-&gt;flag &amp; (CCEXEC|CRCLOSE))
		error("posted fd has remove-on-close or close-on-exec");
	if(c1-&gt;qid.type &amp; QTAUTH)
		error("cannot post auth file in srv");
	sp = srvlookup(nil, c-&gt;qid.path);
	if(sp == 0)
		error(Enonexist);

	if(sp-&gt;chan)
		error(Ebadusefd);

	sp-&gt;chan = c1;
	qunlock(&amp;srvlk);
	poperror();
	return n;
}

Dev srvdevtab = {
	's',
	"srv",

	devreset,
	srvinit,	
	devshutdown,
	srvattach,
	srvwalk,
	srvstat,
	srvopen,
	srvcreate,
	srvclose,
	srvread,
	devbread,
	srvwrite,
	devbwrite,
	srvremove,
	srvwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

