<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/edf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/edf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* EDF scheduling */
#include	&lt;u.h&gt;
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"../port/edf.h"
#include	&lt;trace.h&gt;

/* debugging */
enum {
	Dontprint = 1,
};

#define DPRINT	if(Dontprint){}else print

static long	now;	/* Low order 32 bits of time in µs */
extern ulong	delayedscheds;
extern Schedq	runq[Nrq];
extern int	nrdy;
extern ulong	runvec;

/* Statistics stuff */
ulong		nilcount;
ulong		scheds;
ulong		edfnrun;
int		misseddeadlines;

/* Edfschedlock protects modification of admission params */
int		edfinited;
QLock		edfschedlock;
static Lock	thelock;

enum{
	Dl,	/* Invariant for schedulability test: Dl &lt; Rl */
	Rl,
};

static char *testschedulability(Proc*);
static Proc *qschedulability;

enum {
	Onemicrosecond =	1,
	Onemillisecond =	1000,
	Onesecond =		1000000,
	OneRound = 		Onemillisecond/2,
};

static int
timeconv(Fmt *f)
{
	char buf[128], *sign;
	vlong t;

	buf[0] = 0;
	switch(f-&gt;r) {
	case 'U':
		t = va_arg(f-&gt;args, uvlong);
		break;
	case 't':			/* vlong in nanoseconds */
		t = va_arg(f-&gt;args, long);
		break;
	default:
		return fmtstrcpy(f, "(timeconv)");
	}
	if (t &lt; 0) {
		sign = "-";
		t = -t;
	}
	else
		sign = "";
	if (t &gt; Onesecond){
		t += OneRound;
		snprint(buf, sizeof buf, "%s%d.%.3ds", sign,
			(int)(t / Onesecond),
			(int)(t % Onesecond)/Onemillisecond);
	}else if (t &gt; Onemillisecond)
		snprint(buf, sizeof buf, "%s%d.%.3dms", sign,
			(int)(t / Onemillisecond), (int)(t % Onemillisecond));
	else
		snprint(buf, sizeof buf, "%s%dµs", sign, (int)t);
	return fmtstrcpy(f, buf);
}

long edfcycles;

Edf*
edflock(Proc *p)
{
	Edf *e;

	if (p-&gt;edf == nil)
		return nil;
	ilock(&amp;thelock);
	if((e = p-&gt;edf) &amp;&amp; (e-&gt;flags &amp; Admitted)){
		thelock.pc = getcallerpc(&amp;p);
#ifdef EDFCYCLES
		edfcycles -= lcycles();
#endif
		now = µs();
		return e;
	}
	iunlock(&amp;thelock);
	return nil;
}

void
edfunlock(void)
{

#ifdef EDFCYCLES
	edfcycles += lcycles();
#endif
	edfnrun++;
	iunlock(&amp;thelock);
}

void
edfinit(Proc*p)
{
	if(!edfinited){
		fmtinstall('t', timeconv);
		edfinited++;
	}
	now = µs();
	DPRINT("%lud edfinit %lud[%s]\n", now, p-&gt;pid, statename[p-&gt;state]);
	p-&gt;edf = malloc(sizeof(Edf));
	if(p-&gt;edf == nil)
		error(Enomem);
	return;
}

static void
deadlineintr(Ureg*, Timer *t)
{
	/* Proc reached deadline */
	extern int panicking;
	Proc *p;
	void (*pt)(Proc*, int, vlong);

	if(panicking || active.exiting)
		return;

	p = t-&gt;ta;
	now = µs();
	DPRINT("%lud deadlineintr %lud[%s]\n", now, p-&gt;pid, statename[p-&gt;state]);
	/* If we're interrupting something other than the proc pointed to by t-&gt;a,
	 * we've already achieved recheduling, so we need not do anything
	 * Otherwise, we must cause a reschedule, but if we call sched()
	 * here directly, the timer interrupt routine will not finish its business
	 * Instead, we cause the resched to happen when the interrupted proc
	 * returns to user space
	 */
	if(p == up){
		if(up-&gt;trace &amp;&amp; (pt = proctrace))
			pt(up, SInts, 0);
		up-&gt;delaysched++;
 		delayedscheds++;
	}
}

static void
release(Proc *p)
{
	/* Called with edflock held */
	Edf *e;
	void (*pt)(Proc*, int, vlong);
	long n;
	vlong nowns;

	e = p-&gt;edf;
	e-&gt;flags &amp;= ~Yield;
	if(e-&gt;d - now &lt; 0){
		e-&gt;periods++;
		e-&gt;r = now;
		if((e-&gt;flags &amp; Sporadic) == 0){
			/*
			 * Non sporadic processes stay true to their period;
			 * calculate next release time.
			 * Second test limits duration of while loop.
			 */
			if((n = now - e-&gt;t) &gt; 0){
				if(n &lt; e-&gt;T)
					e-&gt;t += e-&gt;T;
				else
					e-&gt;t = now + e-&gt;T - (n % e-&gt;T);
			}
		}else{
			/* Sporadic processes may not be released earlier than
			 * one period after this release
			 */
			e-&gt;t = e-&gt;r + e-&gt;T;
		}
		e-&gt;d = e-&gt;r + e-&gt;D;
		e-&gt;S = e-&gt;C;
		DPRINT("%lud release %lud[%s], r=%lud, d=%lud, t=%lud, S=%lud\n",
			now, p-&gt;pid, statename[p-&gt;state], e-&gt;r, e-&gt;d, e-&gt;t, e-&gt;S);
		if(pt = proctrace){
			nowns = todget(nil);
			pt(p, SRelease, nowns);
			pt(p, SDeadline, nowns + 1000LL*e-&gt;D);
		}
	}else{
		DPRINT("%lud release %lud[%s], too late t=%lud, called from %#p\n",
			now, p-&gt;pid, statename[p-&gt;state], e-&gt;t, getcallerpc(&amp;p));
	}
}

static void
releaseintr(Ureg*, Timer *t)
{
	Proc *p;
	extern int panicking;
	Schedq *rq;

	if(panicking || active.exiting)
		return;

	p = t-&gt;ta;
	if((edflock(p)) == nil)
		return;
	DPRINT("%lud releaseintr %lud[%s]\n", now, p-&gt;pid, statename[p-&gt;state]);
	switch(p-&gt;state){
	default:
		edfunlock();
		return;
	case Ready:
		/* remove proc from current runq */
		rq = &amp;runq[p-&gt;priority];
		if(dequeueproc(rq, p) != p){
			DPRINT("releaseintr: can't find proc or lock race\n");
			release(p);	/* It'll start best effort */
			edfunlock();
			return;
		}
		p-&gt;state = Waitrelease;
		/* fall through */
	case Waitrelease:
		release(p);
		edfunlock();
		if(p-&gt;state == Wakeme){
			iprint("releaseintr: wakeme\n");
		}
		ready(p);
		if(up){
			up-&gt;delaysched++;
			delayedscheds++;
		}
		return;
	case Running:
		release(p);
		edfrun(p, 1);
		break;
	case Wakeme:
		release(p);
		edfunlock();
		if(p-&gt;trend)
			wakeup(p-&gt;trend);
		p-&gt;trend = nil;
		if(up){
			up-&gt;delaysched++;
			delayedscheds++;
		}
		return;
	}
	edfunlock();
}

void
edfrecord(Proc *p)
{
	long used;
	Edf *e;
	void (*pt)(Proc*, int, vlong);

	if((e = edflock(p)) == nil)
		return;
	used = now - e-&gt;s;
	if(e-&gt;d - now &lt;= 0)
		e-&gt;edfused += used;
	else
		e-&gt;extraused += used;
	if(e-&gt;S &gt; 0){
		if(e-&gt;S &lt;= used){
			if(pt = proctrace)
				pt(p, SSlice, 0);
			DPRINT("%lud edfrecord slice used up\n", now);
			e-&gt;d = now;
			e-&gt;S = 0;
		}else
			e-&gt;S -= used;
	}
	e-&gt;s = now;
	edfunlock();
}

void
edfrun(Proc *p, int edfpri)
{
	Edf *e;
	void (*pt)(Proc*, int, vlong);
	long tns;

	e = p-&gt;edf;
	/* Called with edflock held */
	if(edfpri){
		tns = e-&gt;d - now;
		if(tns &lt;= 0 || e-&gt;S == 0){
			/* Deadline reached or resources exhausted,
			 * deschedule forthwith
			 */
			p-&gt;delaysched++;
 			delayedscheds++;
			e-&gt;s = now;
			return;
		}
		if(e-&gt;S &lt; tns)
			tns = e-&gt;S;
		if(tns &lt; 20)
			tns = 20;
		e-&gt;tns = 1000LL * tns;	/* µs to ns */
		if(e-&gt;tt == nil || e-&gt;tf != deadlineintr){
			DPRINT("%lud edfrun, deadline=%lud\n", now, tns);
		}else{
			DPRINT("v");
		}
		if(p-&gt;trace &amp;&amp; (pt = proctrace))
			pt(p, SInte, todget(nil) + e-&gt;tns);
		e-&gt;tmode = Trelative;
		e-&gt;tf = deadlineintr;
		e-&gt;ta = p;
		timeradd(e);
	}else{
		DPRINT("&lt;");
	}
	e-&gt;s = now;
}

char *
edfadmit(Proc *p)
{
	char *err;
	Edf *e;
	int i;
	Proc *r;
	void (*pt)(Proc*, int, vlong);
	long tns;

	e = p-&gt;edf;
	if (e-&gt;flags &amp; Admitted)
		return "task state";	/* should never happen */

	/* simple sanity checks */
	if (e-&gt;T == 0)
		return "T not set";
	if (e-&gt;C == 0)
		return "C not set";
	if (e-&gt;D &gt; e-&gt;T)
		return "D &gt; T";
	if (e-&gt;D == 0)	/* if D is not set, set it to T */
		e-&gt;D = e-&gt;T;
	if (e-&gt;C &gt; e-&gt;D)
		return "C &gt; D";

	qlock(&amp;edfschedlock);
	if (err = testschedulability(p)){
		qunlock(&amp;edfschedlock);
		return err;
	}
	e-&gt;flags |= Admitted;

	edflock(p);

	if(p-&gt;trace &amp;&amp; (pt = proctrace))
		pt(p, SAdmit, 0);

	/* Look for another proc with the same period to synchronize to */
	SET(r);
	for(i=0; i&lt;conf.nproc; i++) {
		r = proctab(i);
		if(r-&gt;state == Dead || r == p)
			continue;
		if (r-&gt;edf == nil || (r-&gt;edf-&gt;flags &amp; Admitted) == 0)
			continue;
		if (r-&gt;edf-&gt;T == e-&gt;T)
				break;
	}
	if (i == conf.nproc){
		/* Can't synchronize to another proc, release now */
		e-&gt;t = now;
		e-&gt;d = 0;
		release(p);
		if (p == up){
			DPRINT("%lud edfadmit self %lud[%s], release now: r=%lud d=%lud t=%lud\n",
				now, p-&gt;pid, statename[p-&gt;state], e-&gt;r, e-&gt;d, e-&gt;t);
			/* We're already running */
			edfrun(p, 1);
		}else{
			/* We're releasing another proc */
			DPRINT("%lud edfadmit other %lud[%s], release now: r=%lud d=%lud t=%lud\n",
				now, p-&gt;pid, statename[p-&gt;state], e-&gt;r, e-&gt;d, e-&gt;t);
			p-&gt;ta = p;
			edfunlock();
			qunlock(&amp;edfschedlock);
			releaseintr(nil, p);
			return nil;
		}
	}else{
		/* Release in synch to something else */
		e-&gt;t = r-&gt;edf-&gt;t;
		if (p == up){
			DPRINT("%lud edfadmit self %lud[%s], release at %lud\n",
				now, p-&gt;pid, statename[p-&gt;state], e-&gt;t);
			edfunlock();
			qunlock(&amp;edfschedlock);
			return nil;
		}else{
			DPRINT("%lud edfadmit other %lud[%s], release at %lud\n",
				now, p-&gt;pid, statename[p-&gt;state], e-&gt;t);
			if(e-&gt;tt == nil){
				e-&gt;tf = releaseintr;
				e-&gt;ta = p;
				tns = e-&gt;t - now;
				if(tns &lt; 20)
					tns = 20;
				e-&gt;tns = 1000LL * tns;
				e-&gt;tmode = Trelative;
				timeradd(e);
			}
		}
	}
	edfunlock();
	qunlock(&amp;edfschedlock);
	return nil;
}

void
edfstop(Proc *p)
{
	Edf *e;
	void (*pt)(Proc*, int, vlong);

	if(e = edflock(p)){
		DPRINT("%lud edfstop %lud[%s]\n", now, p-&gt;pid, statename[p-&gt;state]);
		if(p-&gt;trace &amp;&amp; (pt = proctrace))
			pt(p, SExpel, 0);
		e-&gt;flags &amp;= ~Admitted;
		if(e-&gt;tt)
			timerdel(e);
		edfunlock();
	}
}

static int
yfn(void *)
{
	now = µs();
	return up-&gt;trend == nil || now - up-&gt;edf-&gt;r &gt;= 0;
}

void
edfyield(void)
{
	/* sleep until next release */
	Edf *e;
	void (*pt)(Proc*, int, vlong);
	long n;

	if((e = edflock(up)) == nil)
		return;
	if(up-&gt;trace &amp;&amp; (pt = proctrace))
		pt(up, SYield, 0);
	if((n = now - e-&gt;t) &gt; 0){
		if(n &lt; e-&gt;T)
			e-&gt;t += e-&gt;T;
		else
			e-&gt;t = now + e-&gt;T - (n % e-&gt;T);
	}
	e-&gt;r = e-&gt;t;
	e-&gt;flags |= Yield;
	e-&gt;d = now;
	if (up-&gt;tt == nil){
		n = e-&gt;t - now;
		if(n &lt; 20)
			n = 20;
		up-&gt;tns = 1000LL * n;
		up-&gt;tf = releaseintr;
		up-&gt;tmode = Trelative;
		up-&gt;ta = up;
		up-&gt;trend = &amp;up-&gt;sleep;
		timeradd(up);
	}else if(up-&gt;tf != releaseintr)
		print("edfyield: surprise! %#p\n", up-&gt;tf);
	edfunlock();
	sleep(&amp;up-&gt;sleep, yfn, nil);
}

int
edfready(Proc *p)
{
	Edf *e;
	Schedq *rq;
	Proc *l, *pp;
	void (*pt)(Proc*, int, vlong);
	long n;

	if((e = edflock(p)) == nil)
		return 0;

	if(p-&gt;state == Wakeme &amp;&amp; p-&gt;r){
		iprint("edfready: wakeme\n");
	}
	if(e-&gt;d - now &lt;= 0){
		/* past deadline, arrange for next release */
		if((e-&gt;flags &amp; Sporadic) == 0){
			/*
			 * Non sporadic processes stay true to their period;
			 * calculate next release time.
			 */
			if((n = now - e-&gt;t) &gt; 0){
				if(n &lt; e-&gt;T)
					e-&gt;t += e-&gt;T;
				else
					e-&gt;t = now + e-&gt;T - (n % e-&gt;T);
			}
		}
		if(now - e-&gt;t &lt; 0){
			/* Next release is in the future, schedule it */
			if(e-&gt;tt == nil || e-&gt;tf != releaseintr){
				n = e-&gt;t - now;
				if(n &lt; 20)
					n = 20;
				e-&gt;tns = 1000LL * n;
				e-&gt;tmode = Trelative;
				e-&gt;tf = releaseintr;
				e-&gt;ta = p;
				timeradd(e);
				DPRINT("%lud edfready %lud[%s], release=%lud\n",
					now, p-&gt;pid, statename[p-&gt;state], e-&gt;t);
			}
			if(p-&gt;state == Running &amp;&amp; (e-&gt;flags &amp; (Yield|Yieldonblock)) == 0 &amp;&amp; (e-&gt;flags &amp; Extratime)){
				/* If we were running, we've overrun our CPU allocation
				 * or missed the deadline, continue running best-effort at low priority
				 * Otherwise we were blocked.  If we don't yield on block, we continue
				 * best effort
				 */
				DPRINT("&gt;");
				p-&gt;basepri = PriExtra;
				p-&gt;fixedpri = 1;
				edfunlock();
				return 0;	/* Stick on runq[PriExtra] */
			}
			DPRINT("%lud edfready %lud[%s] wait release at %lud\n",
				now, p-&gt;pid, statename[p-&gt;state], e-&gt;t);
			p-&gt;state = Waitrelease;
			edfunlock();
			return 1;	/* Make runnable later */
		}
		DPRINT("%lud edfready %lud %s release now\n", now, p-&gt;pid, statename[p-&gt;state]);
		/* release now */
		release(p);
	}
	edfunlock();
	DPRINT("^");
	rq = &amp;runq[PriEdf];
	/* insert in queue in earliest deadline order */
	lock(runq);
	l = nil;
	for(pp = rq-&gt;head; pp; pp = pp-&gt;rnext){
		if(pp-&gt;edf-&gt;d &gt; e-&gt;d)
			break;
		l = pp;
	}
	p-&gt;rnext = pp;
	if (l == nil)
		rq-&gt;head = p;
	else
		l-&gt;rnext = p;
	if(pp == nil)
		rq-&gt;tail = p;
	rq-&gt;n++;
	nrdy++;
	runvec |= 1 &lt;&lt; PriEdf;
	p-&gt;priority = PriEdf;
	p-&gt;readytime = m-&gt;ticks;
	p-&gt;state = Ready;
	unlock(runq);
	if(p-&gt;trace &amp;&amp; (pt = proctrace))
		pt(p, SReady, 0);
	return 1;
}


static void
testenq(Proc *p)
{
	Proc *xp, **xpp;
	Edf *e;

	e = p-&gt;edf;
	e-&gt;testnext = nil;
	if (qschedulability == nil) {
		qschedulability = p;
		return;
	}
	SET(xp);
	for (xpp = &amp;qschedulability; *xpp; xpp = &amp;xp-&gt;edf-&gt;testnext) {
		xp = *xpp;
		if (e-&gt;testtime - xp-&gt;edf-&gt;testtime &lt; 0
		|| (e-&gt;testtime == xp-&gt;edf-&gt;testtime &amp;&amp; e-&gt;testtype &lt; xp-&gt;edf-&gt;testtype)){
			e-&gt;testnext = xp;
			*xpp = p;
			return;
		}
	}
	assert(xp-&gt;edf-&gt;testnext == nil);
	xp-&gt;edf-&gt;testnext = p;
}

static char *
testschedulability(Proc *theproc)
{
	Proc *p;
	long H, G, Cb, ticks;
	int steps, i;

	/* initialize */
	DPRINT("schedulability test %lud\n", theproc-&gt;pid);
	qschedulability = nil;
	for(i=0; i&lt;conf.nproc; i++) {
		p = proctab(i);
		if(p-&gt;state == Dead)
			continue;
		if ((p-&gt;edf == nil || (p-&gt;edf-&gt;flags &amp; Admitted) == 0) &amp;&amp; p != theproc)
			continue;
		p-&gt;edf-&gt;testtype = Rl;
		p-&gt;edf-&gt;testtime = 0;
		DPRINT("\tInit: edfenqueue %lud\n", p-&gt;pid);
		testenq(p);
	}
	H=0;
	G=0;
	for(steps = 0; steps &lt; Maxsteps; steps++){
		p = qschedulability;
		qschedulability = p-&gt;edf-&gt;testnext;
		ticks = p-&gt;edf-&gt;testtime;
		switch (p-&gt;edf-&gt;testtype){
		case Dl:
			H += p-&gt;edf-&gt;C;
			Cb = 0;
			DPRINT("\tStep %3d, Ticks %lud, pid %lud, deadline, H += %lud → %lud, Cb = %lud\n",
				steps, ticks, p-&gt;pid, p-&gt;edf-&gt;C, H, Cb);
			if (H+Cb&gt;ticks){
				DPRINT("not schedulable\n");
				return "not schedulable";
			}
			p-&gt;edf-&gt;testtime += p-&gt;edf-&gt;T - p-&gt;edf-&gt;D;
			p-&gt;edf-&gt;testtype = Rl;
			testenq(p);
			break;
		case Rl:
			DPRINT("\tStep %3d, Ticks %lud, pid %lud, release, G  %lud, C%lud\n",
				steps, ticks, p-&gt;pid, p-&gt;edf-&gt;C, G);
			if(ticks &amp;&amp; G &lt;= ticks){
				DPRINT("schedulable\n");
				return nil;
			}
			G += p-&gt;edf-&gt;C;
			p-&gt;edf-&gt;testtime += p-&gt;edf-&gt;D;
			p-&gt;edf-&gt;testtype = Dl;
			testenq(p);
			break;
		default:
			assert(0);
		}
	}
	DPRINT("probably not schedulable\n");
	return "probably not schedulable";
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

