<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/fault.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/fault.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

int
fault(ulong addr, int read)
{
	Segment *s;
	char *sps;

	if(up == nil)
		panic("fault: nil up");
	if(up-&gt;nlocks.ref)
		print("fault: addr %#p: nlocks %ld\n", addr, up-&gt;nlocks.ref);

	sps = up-&gt;psstate;
	up-&gt;psstate = "Fault";
	spllo();

	m-&gt;pfault++;
	for(;;) {
		s = seg(up, addr, 1);		/* leaves s-&gt;lk qlocked if seg != nil */
		if(s == 0) {
			up-&gt;psstate = sps;
			return -1;
		}

		if(!read &amp;&amp; (s-&gt;type&amp;SG_RONLY)) {
			qunlock(&amp;s-&gt;lk);
			up-&gt;psstate = sps;
			return -1;
		}

		if(fixfault(s, addr, read, 1) == 0)	/* qunlocks s-&gt;lk */
			break;
	}

	up-&gt;psstate = sps;
	return 0;
}

static void
faulterror(char *s, Chan *c, int freemem)
{
	char buf[ERRMAX];

	if(c &amp;&amp; c-&gt;path){
		snprint(buf, sizeof buf, "%s accessing %s: %s", s, c-&gt;path-&gt;s, up-&gt;errstr);
		s = buf;
	}
	if(up-&gt;nerrlab) {
		postnote(up, 1, s, NDebug);
		error(s);
	}
	pexit(s, freemem);
}

void	(*checkaddr)(ulong, Segment *, Page *);
ulong	addr2check;

int
fixfault(Segment *s, ulong addr, int read, int doputmmu)
{
	int type;
	int ref;
	Pte **p, *etp;
	ulong mmuphys=0, soff;
	Page **pg, *lkp, *new;
	Page *(*fn)(Segment*, ulong);

	addr &amp;= ~(BY2PG-1);
	soff = addr-s-&gt;base;
	p = &amp;s-&gt;map[soff/PTEMAPMEM];
	if(*p == 0)
		*p = ptealloc();

	etp = *p;
	pg = &amp;etp-&gt;pages[(soff&amp;(PTEMAPMEM-1))/BY2PG];
	type = s-&gt;type&amp;SG_TYPE;

	if(pg &lt; etp-&gt;first)
		etp-&gt;first = pg;
	if(pg &gt; etp-&gt;last)
		etp-&gt;last = pg;

	switch(type) {
	default:
		panic("fault");
		break;

	case SG_TEXT: 			/* Demand load */
		if(pagedout(*pg))
			pio(s, addr, soff, pg);

		mmuphys = PPN((*pg)-&gt;pa) | PTERONLY|PTEVALID;
		(*pg)-&gt;modref = PG_REF;
		break;

	case SG_BSS:
	case SG_SHARED:			/* Zero fill on demand */
	case SG_STACK:
		if(*pg == 0) {
			new = newpage(1, &amp;s, addr);
			if(s == 0)
				return -1;

			*pg = new;
		}
		goto common;

	case SG_DATA:
	common:			/* Demand load/pagein/copy on write */
		if(pagedout(*pg))
			pio(s, addr, soff, pg);

		/*
		 *  It's only possible to copy on write if
		 *  we're the only user of the segment.
		 */
		if(read &amp;&amp; conf.copymode == 0 &amp;&amp; s-&gt;ref == 1) {
			mmuphys = PPN((*pg)-&gt;pa)|PTERONLY|PTEVALID;
			(*pg)-&gt;modref |= PG_REF;
			break;
		}

		lkp = *pg;
		lock(lkp);

		if(lkp-&gt;image == &amp;swapimage)
			ref = lkp-&gt;ref + swapcount(lkp-&gt;daddr);
		else
			ref = lkp-&gt;ref;
		if(ref == 1 &amp;&amp; lkp-&gt;image){
			/* save a copy of the original for the image cache */
			duppage(lkp);
			ref = lkp-&gt;ref;
		}
		unlock(lkp);
		if(ref &gt; 1){
			new = newpage(0, &amp;s, addr);
			if(s == 0)
				return -1;
			*pg = new;
			copypage(lkp, *pg);
			putpage(lkp);
		}
		mmuphys = PPN((*pg)-&gt;pa) | PTEWRITE | PTEVALID;
		(*pg)-&gt;modref = PG_MOD|PG_REF;
		break;

	case SG_PHYSICAL:
		if(*pg == 0) {
			fn = s-&gt;pseg-&gt;pgalloc;
			if(fn)
				*pg = (*fn)(s, addr);
			else {
				new = smalloc(sizeof(Page));
				new-&gt;va = addr;
				new-&gt;pa = s-&gt;pseg-&gt;pa+(addr-s-&gt;base);
				new-&gt;ref = 1;
				*pg = new;
			}
		}

		if (checkaddr &amp;&amp; addr == addr2check)
			(*checkaddr)(addr, s, *pg);
		mmuphys = PPN((*pg)-&gt;pa) |PTEWRITE|PTEUNCACHED|PTEVALID;
		(*pg)-&gt;modref = PG_MOD|PG_REF;
		break;
	}
	qunlock(&amp;s-&gt;lk);

	if(doputmmu)
		putmmu(addr, mmuphys, *pg);

	return 0;
}

void
pio(Segment *s, ulong addr, ulong soff, Page **p)
{
	Page *new;
	KMap *k;
	Chan *c;
	int n, ask;
	char *kaddr;
	ulong daddr;
	Page *loadrec;

retry:
	loadrec = *p;
	if(loadrec == 0) {	/* from a text/data image */
		daddr = s-&gt;fstart+soff;
		new = lookpage(s-&gt;image, daddr);
		if(new != nil) {
			*p = new;
			return;
		}

		c = s-&gt;image-&gt;c;
		ask = s-&gt;flen-soff;
		if(ask &gt; BY2PG)
			ask = BY2PG;
	}
	else {			/* from a swap image */
		daddr = swapaddr(loadrec);
		new = lookpage(&amp;swapimage, daddr);
		if(new != nil) {
			putswap(loadrec);
			*p = new;
			return;
		}

		c = swapimage.c;
		ask = BY2PG;
	}
	qunlock(&amp;s-&gt;lk);

	new = newpage(0, 0, addr);
	k = kmap(new);
	kaddr = (char*)VA(k);

	while(waserror()) {
		if(strcmp(up-&gt;errstr, Eintr) == 0)
			continue;
		kunmap(k);
		putpage(new);
		faulterror(Eioload, c, 0);
	}

	n = devtab[c-&gt;type]-&gt;read(c, kaddr, ask, daddr);
	if(n != ask)
		faulterror(Eioload, c, 0);
	if(ask &lt; BY2PG)
		memset(kaddr+ask, 0, BY2PG-ask);

	poperror();
	kunmap(k);
	qlock(&amp;s-&gt;lk);
	if(loadrec == 0) {	/* This is demand load */
		/*
		 *  race, another proc may have gotten here first while
		 *  s-&gt;lk was unlocked
		 */
		if(*p == 0) { 
			new-&gt;daddr = daddr;
			cachepage(new, s-&gt;image);
			*p = new;
		}
		else
			putpage(new);
	}
	else {			/* This is paged out */
		/*
		 *  race, another proc may have gotten here first
		 *  (and the pager may have run on that page) while
		 *  s-&gt;lk was unlocked
		 */
		if(*p != loadrec){
			if(!pagedout(*p)){
				/* another process did it for me */
				putpage(new);
				goto done;
			} else {
				/* another process and the pager got in */
				putpage(new);
				goto retry;
			}
		}

		new-&gt;daddr = daddr;
		cachepage(new, &amp;swapimage);
		*p = new;
		putswap(loadrec);
	}

done:
	if(s-&gt;flushme)
		memset((*p)-&gt;cachectl, PG_TXTFLUSH, sizeof((*p)-&gt;cachectl));
}

/*
 * Called only in a system call
 */
int
okaddr(ulong addr, ulong len, int write)
{
	Segment *s;

	if((long)len &gt;= 0) {
		for(;;) {
			s = seg(up, addr, 0);
			if(s == 0 || (write &amp;&amp; (s-&gt;type&amp;SG_RONLY)))
				break;

			if(addr+len &gt; s-&gt;top) {
				len -= s-&gt;top - addr;
				addr = s-&gt;top;
				continue;
			}
			return 1;
		}
	}
	pprint("suicide: invalid address %#lux/%lud in sys call pc=%#lux\n", addr, len, userpc());
	return 0;
}

void
validaddr(ulong addr, ulong len, int write)
{
	if(!okaddr(addr, len, write)){
		postnote(up, 1, "sys: bad address in syscall", NDebug);
		error(Ebadarg);
	}
}

/*
 * &amp;s[0] is known to be a valid address.
 */
void*
vmemchr(void *s, int c, int n)
{
	int m;
	ulong a;
	void *t;

	a = (ulong)s;
	while(PGROUND(a) != PGROUND(a+n-1)){
		/* spans pages; handle this page */
		m = BY2PG - (a &amp; (BY2PG-1));
		t = memchr((void*)a, c, m);
		if(t)
			return t;
		a += m;
		n -= m;
		if(a &lt; KZERO)
			validaddr(a, 1, 0);
	}

	/* fits in one page */
	return memchr((void*)a, c, n);
}

Segment*
seg(Proc *p, ulong addr, int dolock)
{
	Segment **s, **et, *n;

	et = &amp;p-&gt;seg[NSEG];
	for(s = p-&gt;seg; s &lt; et; s++) {
		n = *s;
		if(n == 0)
			continue;
		if(addr &gt;= n-&gt;base &amp;&amp; addr &lt; n-&gt;top) {
			if(dolock == 0)
				return n;

			qlock(&amp;n-&gt;lk);
			if(addr &gt;= n-&gt;base &amp;&amp; addr &lt; n-&gt;top)
				return n;
			qunlock(&amp;n-&gt;lk);
		}
	}

	return 0;
}

extern void checkmmu(ulong, ulong);
void
checkpages(void)
{
	int checked;
	ulong addr, off;
	Pte *p;
	Page *pg;
	Segment **sp, **ep, *s;
	
	if(up == nil)
		return;

	checked = 0;
	for(sp=up-&gt;seg, ep=&amp;up-&gt;seg[NSEG]; sp&lt;ep; sp++){
		s = *sp;
		if(s == nil)
			continue;
		qlock(&amp;s-&gt;lk);
		for(addr=s-&gt;base; addr&lt;s-&gt;top; addr+=BY2PG){
			off = addr - s-&gt;base;
			p = s-&gt;map[off/PTEMAPMEM];
			if(p == 0)
				continue;
			pg = p-&gt;pages[(off&amp;(PTEMAPMEM-1))/BY2PG];
			if(pg == 0 || pagedout(pg))
				continue;
			checkmmu(addr, pg-&gt;pa);
			checked++;
		}
		qunlock(&amp;s-&gt;lk);
	}
	print("%ld %s: checked %d page table entries\n", up-&gt;pid, up-&gt;text, checked);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

