<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/log.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/log.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

static char Ebadlogctl[] = "unknown log ctl message";

void
logopen(Log *alog)
{
	lock(alog);
	if(waserror()){
		unlock(alog);
		nexterror();
	}
	if(alog-&gt;opens == 0){
		if(alog-&gt;nlog == 0)
			alog-&gt;nlog = 4*1024;
		if(alog-&gt;minread == 0)
			alog-&gt;minread = 1;
		if(alog-&gt;buf == nil &amp;&amp; (alog-&gt;buf = malloc(alog-&gt;nlog)) == nil)
			error(Enomem);
		alog-&gt;rptr = alog-&gt;buf;
		alog-&gt;end = alog-&gt;buf + alog-&gt;nlog;
		alog-&gt;len = 0;
	}
	alog-&gt;opens++;
	unlock(alog);
	poperror();
}

void
logclose(Log *alog)
{
	lock(alog);
	alog-&gt;opens--;
	if(alog-&gt;opens == 0){
		free(alog-&gt;buf);
		alog-&gt;buf = nil;
	}
	unlock(alog);
}

static int
logready(void *a)
{
	Log *alog = a;

	return alog-&gt;len &gt;= alog-&gt;minread;
}

long
logread(Log *alog, void *a, ulong, long n)
{
	int i, d;
	char *p, *rptr;

	qlock(&amp;alog-&gt;readq);
	if(waserror()){
		qunlock(&amp;alog-&gt;readq);
		nexterror();
	}

	for(;;){
		lock(alog);
		if(alog-&gt;len &gt;= alog-&gt;minread || alog-&gt;len &gt;= n){
			if(n &gt; alog-&gt;len)
				n = alog-&gt;len;
			d = 0;
			rptr = alog-&gt;rptr;
			alog-&gt;rptr += n;
			if(alog-&gt;rptr &gt;= alog-&gt;end){
				d = alog-&gt;rptr - alog-&gt;end;
				alog-&gt;rptr = alog-&gt;buf + d;
			}
			alog-&gt;len -= n;
			unlock(alog);

			i = n-d;
			p = a;
			memmove(p, rptr, i);
			memmove(p+i, alog-&gt;buf, d);
			break;
		}
		else
			unlock(alog);

		sleep(&amp;alog-&gt;readr, logready, alog);
	}

	qunlock(&amp;alog-&gt;readq);
	poperror();

	return n;
}

char*
logctl(Log *alog, int argc, char *argv[], Logflag *flags)
{
	int i, set;
	Logflag *fp;

	if(argc &lt; 2)
		return Ebadlogctl;

	if(strcmp("set", argv[0]) == 0)
		set = 1;
	else if(strcmp("clear", argv[0]) == 0)
		set = 0;
	else
		return Ebadlogctl;

	for(i = 1; i &lt; argc; i++){
		for(fp = flags; fp-&gt;name; fp++)
			if(strcmp(fp-&gt;name, argv[i]) == 0)
				break;
		if(fp-&gt;name == nil)
			continue;
		if(set)
			alog-&gt;logmask |= fp-&gt;mask;
		else
			alog-&gt;logmask &amp;= ~fp-&gt;mask;
	}

	return nil;
}

void
logn(Log *alog, int mask, void *buf, int n)
{
	char *fp, *t;
	int dowake, i;

	if(!(alog-&gt;logmask &amp; mask))
		return;

	if(alog-&gt;opens == 0)
		return;

	if(n &gt; alog-&gt;nlog)
		return;

	lock(alog);
	i = alog-&gt;len + n - alog-&gt;nlog;
	if(i &gt; 0){
		alog-&gt;len -= i;
		alog-&gt;rptr += i;
		if(alog-&gt;rptr &gt;= alog-&gt;end)
			alog-&gt;rptr = alog-&gt;buf + (alog-&gt;rptr - alog-&gt;end);
	}
	t = alog-&gt;rptr + alog-&gt;len;
	fp = buf;
	alog-&gt;len += n;
	while(n-- &gt; 0){
		if(t &gt;= alog-&gt;end)
			t = alog-&gt;buf + (t - alog-&gt;end);
		*t++ = *fp++;
	}
	dowake = alog-&gt;len &gt;= alog-&gt;minread;
	unlock(alog);

	if(dowake)
		wakeup(&amp;alog-&gt;readr);
}

void
log(Log *alog, int mask, char *fmt, ...)
{
	int n;
	va_list arg;
	char buf[128];

	if(!(alog-&gt;logmask &amp; mask))
		return;

	if(alog-&gt;opens == 0)
		return;

	va_start(arg, fmt);
	n = vseprint(buf, buf+sizeof(buf), fmt, arg) - buf;
	va_end(arg);

	logn(alog, mask, buf, n);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

