<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/netif.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/netif.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"../port/netif.h"

static int netown(Netfile*, char*, int);
static int openfile(Netif*, int);
static char* matchtoken(char*, char*);
static char* netmulti(Netif*, Netfile*, uchar*, int);
static int parseaddr(uchar*, char*, int);

/*
 *  set up a new network interface
 */
void
netifinit(Netif *nif, char *name, int nfile, ulong limit)
{
	strncpy(nif-&gt;name, name, KNAMELEN-1);
	nif-&gt;name[KNAMELEN-1] = 0;
	nif-&gt;nfile = nfile;
	nif-&gt;f = xalloc(nfile*sizeof(Netfile*));
	if (nif-&gt;f == nil)
		panic("netifinit: no memory");
	memset(nif-&gt;f, 0, nfile*sizeof(Netfile*));
	nif-&gt;limit = limit;
}

/*
 *  generate a 3 level directory
 */
static int
netifgen(Chan *c, char*, Dirtab *vp, int, int i, Dir *dp)
{
	Qid q;
	Netif *nif = (Netif*)vp;
	Netfile *f;
	int t;
	int perm;
	char *o;

	q.type = QTFILE;
	q.vers = 0;

	/* top level directory contains the name of the network */
	if(c-&gt;qid.path == 0){
		switch(i){
		case DEVDOTDOT:
			q.path = 0;
			q.type = QTDIR;
			devdir(c, q, ".", 0, eve, 0555, dp);
			break;
		case 0:
			q.path = N2ndqid;
			q.type = QTDIR;
			strcpy(up-&gt;genbuf, nif-&gt;name);
			devdir(c, q, up-&gt;genbuf, 0, eve, 0555, dp);
			break;
		default:
			return -1;
		}
		return 1;
	}

	/* second level contains clone plus all the conversations */
	t = NETTYPE(c-&gt;qid.path);
	if(t == N2ndqid || t == Ncloneqid || t == Naddrqid){
		switch(i) {
		case DEVDOTDOT:
			q.type = QTDIR;
			q.path = 0;
			devdir(c, q, ".", 0, eve, DMDIR|0555, dp);
			break;
		case 0:
			q.path = Ncloneqid;
			devdir(c, q, "clone", 0, eve, 0666, dp);
			break;
		case 1:
			q.path = Naddrqid;
			devdir(c, q, "addr", 0, eve, 0666, dp);
			break;
		case 2:
			q.path = Nstatqid;
			devdir(c, q, "stats", 0, eve, 0444, dp);
			break;
		case 3:
			q.path = Nifstatqid;
			devdir(c, q, "ifstats", 0, eve, 0444, dp);
			break;
		default:
			i -= 4;
			if(i &gt;= nif-&gt;nfile)
				return -1;
			if(nif-&gt;f[i] == 0)
				return 0;
			q.type = QTDIR;
			q.path = NETQID(i, N3rdqid);
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "%d", i);
			devdir(c, q, up-&gt;genbuf, 0, eve, DMDIR|0555, dp);
			break;
		}
		return 1;
	}

	/* third level */
	f = nif-&gt;f[NETID(c-&gt;qid.path)];
	if(f == 0)
		return 0;
	if(*f-&gt;owner){
		o = f-&gt;owner;
		perm = f-&gt;mode;
	} else {
		o = eve;
		perm = 0666;
	}
	switch(i){
	case DEVDOTDOT:
		q.type = QTDIR;
		q.path = N2ndqid;
		strcpy(up-&gt;genbuf, nif-&gt;name);
		devdir(c, q, up-&gt;genbuf, 0, eve, DMDIR|0555, dp);
		break;
	case 0:
		q.path = NETQID(NETID(c-&gt;qid.path), Ndataqid);
		devdir(c, q, "data", 0, o, perm, dp);
		break;
	case 1:
		q.path = NETQID(NETID(c-&gt;qid.path), Nctlqid);
		devdir(c, q, "ctl", 0, o, perm, dp);
		break;
	case 2:
		q.path = NETQID(NETID(c-&gt;qid.path), Nstatqid);
		devdir(c, q, "stats", 0, eve, 0444, dp);
		break;
	case 3:
		q.path = NETQID(NETID(c-&gt;qid.path), Ntypeqid);
		devdir(c, q, "type", 0, eve, 0444, dp);
		break;
	case 4:
		q.path = NETQID(NETID(c-&gt;qid.path), Nifstatqid);
		devdir(c, q, "ifstats", 0, eve, 0444, dp);
		break;
	default:
		return -1;
	}
	return 1;
}

Walkqid*
netifwalk(Netif *nif, Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, (Dirtab *)nif, 0, netifgen);
}

Chan*
netifopen(Netif *nif, Chan *c, int omode)
{
	int id;
	Netfile *f;

	id = 0;
	if(c-&gt;qid.type &amp; QTDIR){
		if(omode != OREAD)
			error(Eperm);
	} else {
		switch(NETTYPE(c-&gt;qid.path)){
		case Ndataqid:
		case Nctlqid:
			id = NETID(c-&gt;qid.path);
			openfile(nif, id);
			break;
		case Ncloneqid:
			id = openfile(nif, -1);
			c-&gt;qid.path = NETQID(id, Nctlqid);
			break;
		default:
			if(omode != OREAD)
				error(Ebadarg);
		}
		switch(NETTYPE(c-&gt;qid.path)){
		case Ndataqid:
		case Nctlqid:
			f = nif-&gt;f[id];
			if(netown(f, up-&gt;user, omode&amp;7) &lt; 0)
				error(Eperm);
			break;
		}
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	c-&gt;iounit = qiomaxatomic;
	return c;
}

long
netifread(Netif *nif, Chan *c, void *a, long n, ulong offset)
{
	int i, j;
	Netfile *f;
	char *p;

	if(c-&gt;qid.type&amp;QTDIR)
		return devdirread(c, a, n, (Dirtab*)nif, 0, netifgen);

	switch(NETTYPE(c-&gt;qid.path)){
	case Ndataqid:
		f = nif-&gt;f[NETID(c-&gt;qid.path)];
		return qread(f-&gt;in, a, n);
	case Nctlqid:
		return readnum(offset, a, n, NETID(c-&gt;qid.path), NUMSIZE);
	case Nstatqid:
		p = malloc(READSTR);
		if(p == nil)
			error(Enomem);
		j = snprint(p, READSTR, "in: %llud\n", nif-&gt;inpackets);
		j += snprint(p+j, READSTR-j, "link: %d\n", nif-&gt;link);
		j += snprint(p+j, READSTR-j, "out: %llud\n", nif-&gt;outpackets);
		j += snprint(p+j, READSTR-j, "crc errs: %d\n", nif-&gt;crcs);
		j += snprint(p+j, READSTR-j, "overflows: %d\n", nif-&gt;overflows);
		j += snprint(p+j, READSTR-j, "soft overflows: %d\n", nif-&gt;soverflows);
		j += snprint(p+j, READSTR-j, "framing errs: %d\n", nif-&gt;frames);
		j += snprint(p+j, READSTR-j, "buffer errs: %d\n", nif-&gt;buffs);
		j += snprint(p+j, READSTR-j, "output errs: %d\n", nif-&gt;oerrs);
		j += snprint(p+j, READSTR-j, "prom: %d\n", nif-&gt;prom);
		j += snprint(p+j, READSTR-j, "mbps: %d\n", nif-&gt;mbps);
		j += snprint(p+j, READSTR-j, "addr: ");
		for(i = 0; i &lt; nif-&gt;alen; i++)
			j += snprint(p+j, READSTR-j, "%2.2ux", nif-&gt;addr[i]);
		snprint(p+j, READSTR-j, "\n");
		n = readstr(offset, a, n, p);
		free(p);
		return n;
	case Naddrqid:
		p = malloc(READSTR);
		if(p == nil)
			error(Enomem);
		j = 0;
		for(i = 0; i &lt; nif-&gt;alen; i++)
			j += snprint(p+j, READSTR-j, "%2.2ux", nif-&gt;addr[i]);
		n = readstr(offset, a, n, p);
		free(p);
		return n;
	case Ntypeqid:
		f = nif-&gt;f[NETID(c-&gt;qid.path)];
		return readnum(offset, a, n, f-&gt;type, NUMSIZE);
	case Nifstatqid:
		return 0;
	}
	error(Ebadarg);
	return -1;	/* not reached */
}

Block*
netifbread(Netif *nif, Chan *c, long n, ulong offset)
{
	if((c-&gt;qid.type &amp; QTDIR) || NETTYPE(c-&gt;qid.path) != Ndataqid)
		return devbread(c, n, offset);

	return qbread(nif-&gt;f[NETID(c-&gt;qid.path)]-&gt;in, n);
}

/*
 *  make sure this type isn't already in use on this device
 */
static int
typeinuse(Netif *nif, int type)
{
	Netfile *f, **fp, **efp;

	if(type &lt;= 0)
		return 0;

	efp = &amp;nif-&gt;f[nif-&gt;nfile];
	for(fp = nif-&gt;f; fp &lt; efp; fp++){
		f = *fp;
		if(f == 0)
			continue;
		if(f-&gt;type == type)
			return 1;
	}
	return 0;
}

/*
 *  the devxxx.c that calls us handles writing data, it knows best
 */
long
netifwrite(Netif *nif, Chan *c, void *a, long n)
{
	Netfile *f;
	int type;
	char *p, buf[64];
	uchar binaddr[Nmaxaddr];

	if(NETTYPE(c-&gt;qid.path) != Nctlqid)
		error(Eperm);

	if(n &gt;= sizeof(buf))
		n = sizeof(buf)-1;
	memmove(buf, a, n);
	buf[n] = 0;

	if(waserror()){
		qunlock(nif);
		nexterror();
	}

	qlock(nif);
	f = nif-&gt;f[NETID(c-&gt;qid.path)];
	if((p = matchtoken(buf, "connect")) != 0){
		type = atoi(p);
		if(typeinuse(nif, type))
			error(Einuse);
		f-&gt;type = type;
		if(f-&gt;type &lt; 0)
			nif-&gt;all++;
	} else if(matchtoken(buf, "promiscuous")){
		if(f-&gt;prom == 0){
			if(nif-&gt;prom == 0 &amp;&amp; nif-&gt;promiscuous != nil)
				nif-&gt;promiscuous(nif-&gt;arg, 1);
			f-&gt;prom = 1;
			nif-&gt;prom++;
		}
	} else if((p = matchtoken(buf, "scanbs")) != 0){
		/* scan for base stations */
		if(f-&gt;scan == 0){
			type = atoi(p);
			if(type &lt; 5)
				type = 5;
			if(nif-&gt;scanbs != nil)
				nif-&gt;scanbs(nif-&gt;arg, type);
			f-&gt;scan = type;
			nif-&gt;scan++;
		}
	} else if(matchtoken(buf, "bridge")){
		f-&gt;bridge = 1;
	} else if(matchtoken(buf, "headersonly")){
		f-&gt;headersonly = 1;
	} else if((p = matchtoken(buf, "addmulti")) != 0){
		if(parseaddr(binaddr, p, nif-&gt;alen) &lt; 0)
			error("bad address");
		p = netmulti(nif, f, binaddr, 1);
		if(p)
			error(p);
	} else if((p = matchtoken(buf, "remmulti")) != 0){
		if(parseaddr(binaddr, p, nif-&gt;alen) &lt; 0)
			error("bad address");
		p = netmulti(nif, f, binaddr, 0);
		if(p)
			error(p);
	} else
		n = -1;
	qunlock(nif);
	poperror();
	return n;
}

int
netifwstat(Netif *nif, Chan *c, uchar *db, int n)
{
	Dir *dir;
	Netfile *f;
	int m;

	f = nif-&gt;f[NETID(c-&gt;qid.path)];
	if(f == 0)
		error(Enonexist);

	if(netown(f, up-&gt;user, OWRITE) &lt; 0)
		error(Eperm);

	dir = smalloc(sizeof(Dir)+n);
	m = convM2D(db, n, &amp;dir[0], (char*)&amp;dir[1]);
	if(m == 0){
		free(dir);
		error(Eshortstat);
	}
	if(!emptystr(dir[0].uid))
		strncpy(f-&gt;owner, dir[0].uid, KNAMELEN);
	if(dir[0].mode != ~0UL)
		f-&gt;mode = dir[0].mode;
	free(dir);
	return m;
}

int
netifstat(Netif *nif, Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, (Dirtab *)nif, 0, netifgen);
}

void
netifclose(Netif *nif, Chan *c)
{
	Netfile *f;
	int t;
	Netaddr *ap;

	if((c-&gt;flag &amp; COPEN) == 0)
		return;

	t = NETTYPE(c-&gt;qid.path);
	if(t != Ndataqid &amp;&amp; t != Nctlqid)
		return;

	f = nif-&gt;f[NETID(c-&gt;qid.path)];
	qlock(f);
	if(--(f-&gt;inuse) == 0){
		if(f-&gt;prom){
			qlock(nif);
			if(--(nif-&gt;prom) == 0 &amp;&amp; nif-&gt;promiscuous != nil)
				nif-&gt;promiscuous(nif-&gt;arg, 0);
			qunlock(nif);
			f-&gt;prom = 0;
		}
		if(f-&gt;scan){
			qlock(nif);
			if(--(nif-&gt;scan) == 0 &amp;&amp; nif-&gt;scanbs != nil)
				nif-&gt;scanbs(nif-&gt;arg, 0);
			qunlock(nif);
			f-&gt;prom = 0;
			f-&gt;scan = 0;
		}
		if(f-&gt;nmaddr){
			qlock(nif);
			t = 0;
			for(ap = nif-&gt;maddr; ap; ap = ap-&gt;next){
				if(f-&gt;maddr[t/8] &amp; (1&lt;&lt;(t%8)))
					netmulti(nif, f, ap-&gt;addr, 0);
			}
			qunlock(nif);
			f-&gt;nmaddr = 0;
		}
		if(f-&gt;type &lt; 0){
			qlock(nif);
			--(nif-&gt;all);
			qunlock(nif);
		}
		f-&gt;owner[0] = 0;
		f-&gt;type = 0;
		f-&gt;bridge = 0;
		f-&gt;headersonly = 0;
		qclose(f-&gt;in);
	}
	qunlock(f);
}

Lock netlock;

static int
netown(Netfile *p, char *o, int omode)
{
	static int access[] = { 0400, 0200, 0600, 0100 };
	int mode;
	int t;

	lock(&amp;netlock);
	if(*p-&gt;owner){
		if(strncmp(o, p-&gt;owner, KNAMELEN) == 0)	/* User */
			mode = p-&gt;mode;
		else if(strncmp(o, eve, KNAMELEN) == 0)	/* Bootes is group */
			mode = p-&gt;mode&lt;&lt;3;
		else
			mode = p-&gt;mode&lt;&lt;6;		/* Other */

		t = access[omode&amp;3];
		if((t &amp; mode) == t){
			unlock(&amp;netlock);
			return 0;
		} else {
			unlock(&amp;netlock);
			return -1;
		}
	}
	strncpy(p-&gt;owner, o, KNAMELEN);
	p-&gt;mode = 0660;
	unlock(&amp;netlock);
	return 0;
}

/*
 *  Increment the reference count of a network device.
 *  If id &lt; 0, return an unused ether device.
 */
static int
openfile(Netif *nif, int id)
{
	Netfile *f, **fp, **efp;

	if(id &gt;= 0){
		f = nif-&gt;f[id];
		if(f == 0)
			error(Enodev);
		qlock(f);
		qreopen(f-&gt;in);
		f-&gt;inuse++;
		qunlock(f);
		return id;
	}

	qlock(nif);
	if(waserror()){
		qunlock(nif);
		nexterror();
	}
	efp = &amp;nif-&gt;f[nif-&gt;nfile];
	for(fp = nif-&gt;f; fp &lt; efp; fp++){
		f = *fp;
		if(f == 0){
			f = malloc(sizeof(Netfile));
			if(f == 0)
				exhausted("memory");
			f-&gt;in = qopen(nif-&gt;limit, Qmsg, 0, 0);
			if(f-&gt;in == nil){
				free(f);
				exhausted("memory");
			}
			*fp = f;
			qlock(f);
		} else {
			qlock(f);
			if(f-&gt;inuse){
				qunlock(f);
				continue;
			}
		}
		f-&gt;inuse = 1;
		qreopen(f-&gt;in);
		netown(f, up-&gt;user, 0);
		qunlock(f);
		qunlock(nif);
		poperror();
		return fp - nif-&gt;f;
	}
	error(Enodev);
	return -1;	/* not reached */
}

/*
 *  look for a token starting a string,
 *  return a pointer to first non-space char after it
 */
static char*
matchtoken(char *p, char *token)
{
	int n;

	n = strlen(token);
	if(strncmp(p, token, n))
		return 0;
	p += n;
	if(*p == 0)
		return p;
	if(*p != ' ' &amp;&amp; *p != '\t' &amp;&amp; *p != '\n')
		return 0;
	while(*p == ' ' || *p == '\t' || *p == '\n')
		p++;
	return p;
}

void
hnputv(void *p, uvlong v)
{
	uchar *a;

	a = p;
	hnputl(a, v&gt;&gt;32);
	hnputl(a+4, v);
}

void
hnputl(void *p, uint v)
{
	uchar *a;

	a = p;
	a[0] = v&gt;&gt;24;
	a[1] = v&gt;&gt;16;
	a[2] = v&gt;&gt;8;
	a[3] = v;
}

void
hnputs(void *p, ushort v)
{
	uchar *a;

	a = p;
	a[0] = v&gt;&gt;8;
	a[1] = v;
}

uvlong
nhgetv(void *p)
{
	uchar *a;

	a = p;
	return ((vlong)nhgetl(a) &lt;&lt; 32) | nhgetl(a+4);
}

uint
nhgetl(void *p)
{
	uchar *a;

	a = p;
	return (a[0]&lt;&lt;24)|(a[1]&lt;&lt;16)|(a[2]&lt;&lt;8)|(a[3]&lt;&lt;0);
}

ushort
nhgets(void *p)
{
	uchar *a;

	a = p;
	return (a[0]&lt;&lt;8)|(a[1]&lt;&lt;0);
}

static ulong
hash(uchar *a, int len)
{
	ulong sum = 0;

	while(len-- &gt; 0)
		sum = (sum &lt;&lt; 1) + *a++;
	return sum%Nmhash;
}

int
activemulti(Netif *nif, uchar *addr, int alen)
{
	Netaddr *hp;

	for(hp = nif-&gt;mhash[hash(addr, alen)]; hp; hp = hp-&gt;hnext)
		if(memcmp(addr, hp-&gt;addr, alen) == 0){
			if(hp-&gt;ref)
				return 1;
			else
				break;
		}
	return 0;
}

static int
parseaddr(uchar *to, char *from, int alen)
{
	char nip[4];
	char *p;
	int i;

	p = from;
	for(i = 0; i &lt; alen; i++){
		if(*p == 0)
			return -1;
		nip[0] = *p++;
		if(*p == 0)
			return -1;
		nip[1] = *p++;
		nip[2] = 0;
		to[i] = strtoul(nip, 0, 16);
		if(*p == ':')
			p++;
	}
	return 0;
}

/*
 *  keep track of multicast addresses
 */
static char*
netmulti(Netif *nif, Netfile *f, uchar *addr, int add)
{
	Netaddr **l, *ap;
	int i;
	ulong h;

	if(nif-&gt;multicast == nil)
		return "interface does not support multicast";

	l = &amp;nif-&gt;maddr;
	i = 0;
	for(ap = *l; ap; ap = *l){
		if(memcmp(addr, ap-&gt;addr, nif-&gt;alen) == 0)
			break;
		i++;
		l = &amp;ap-&gt;next;
	}

	if(add){
		if(ap == 0){
			*l = ap = smalloc(sizeof(*ap));
			memmove(ap-&gt;addr, addr, nif-&gt;alen);
			ap-&gt;next = 0;
			ap-&gt;ref = 1;
			h = hash(addr, nif-&gt;alen);
			ap-&gt;hnext = nif-&gt;mhash[h];
			nif-&gt;mhash[h] = ap;
		} else {
			ap-&gt;ref++;
		}
		if(ap-&gt;ref == 1){
			nif-&gt;nmaddr++;
			nif-&gt;multicast(nif-&gt;arg, addr, 1);
		}
		if(i &lt; 8*sizeof(f-&gt;maddr)){
			if((f-&gt;maddr[i/8] &amp; (1&lt;&lt;(i%8))) == 0)
				f-&gt;nmaddr++;
			f-&gt;maddr[i/8] |= 1&lt;&lt;(i%8);
		}
	} else {
		if(ap == 0 || ap-&gt;ref == 0)
			return 0;
		ap-&gt;ref--;
		if(ap-&gt;ref == 0){
			nif-&gt;nmaddr--;
			nif-&gt;multicast(nif-&gt;arg, addr, 0);
		}
		if(i &lt; 8*sizeof(f-&gt;maddr)){
			if((f-&gt;maddr[i/8] &amp; (1&lt;&lt;(i%8))) != 0)
				f-&gt;nmaddr--;
			f-&gt;maddr[i/8] &amp;= ~(1&lt;&lt;(i%8));
		}
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

