<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/page.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/page.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#define	pghash(daddr)	palloc.hash[(daddr&gt;&gt;PGSHIFT)&amp;(PGHSIZE-1)]

struct	Palloc palloc;

void
pageinit(void)
{
	int color, i, j;
	Page *p;
	Pallocmem *pm;
	ulong m, np, k, vkb, pkb;

	np = 0;
	for(i=0; i&lt;nelem(palloc.mem); i++){
		pm = &amp;palloc.mem[i];
		np += pm-&gt;npage;
	}
	palloc.pages = xalloc(np*sizeof(Page));
	if(palloc.pages == 0)
		panic("pageinit");

	color = 0;
	palloc.head = palloc.pages;
	p = palloc.head;
	for(i=0; i&lt;nelem(palloc.mem); i++){
		pm = &amp;palloc.mem[i];
		for(j=0; j&lt;pm-&gt;npage; j++){
			p-&gt;prev = p-1;
			p-&gt;next = p+1;
			p-&gt;pa = pm-&gt;base+j*BY2PG;
			p-&gt;color = color;
			palloc.freecount++;
			color = (color+1)%NCOLOR;
			p++;
		}
	}
	palloc.tail = p - 1;
	palloc.head-&gt;prev = 0;
	palloc.tail-&gt;next = 0;

	palloc.user = p - palloc.pages;
	pkb = palloc.user*BY2PG/1024;
	vkb = pkb + (conf.nswap*BY2PG)/1024;

	/* Paging numbers */
	swapalloc.highwater = (palloc.user*5)/100;
	swapalloc.headroom = swapalloc.highwater + (swapalloc.highwater/4);

	m = 0;
	for(i=0; i&lt;nelem(conf.mem); i++)
		if(conf.mem[i].npage)
			m += conf.mem[i].npage*BY2PG;
	k = PGROUND(end - (char*)KTZERO);
	print("%ldM memory: ", (m+k+1024*1024-1)/(1024*1024));
	print("%ldM kernel data, ", (m+k-pkb*1024+1024*1024-1)/(1024*1024));
	print("%ldM user, ", pkb/1024);
	print("%ldM swap\n", vkb/1024);
}

static void
pageunchain(Page *p)
{
	if(canlock(&amp;palloc))
		panic("pageunchain (palloc %p)", &amp;palloc);
	if(p-&gt;prev)
		p-&gt;prev-&gt;next = p-&gt;next;
	else
		palloc.head = p-&gt;next;
	if(p-&gt;next)
		p-&gt;next-&gt;prev = p-&gt;prev;
	else
		palloc.tail = p-&gt;prev;
	p-&gt;prev = p-&gt;next = nil;
	palloc.freecount--;
}

void
pagechaintail(Page *p)
{
	if(canlock(&amp;palloc))
		panic("pagechaintail");
	if(palloc.tail) {
		p-&gt;prev = palloc.tail;
		palloc.tail-&gt;next = p;
	}
	else {
		palloc.head = p;
		p-&gt;prev = 0;
	}
	palloc.tail = p;
	p-&gt;next = 0;
	palloc.freecount++;
}

void
pagechainhead(Page *p)
{
	if(canlock(&amp;palloc))
		panic("pagechainhead");
	if(palloc.head) {
		p-&gt;next = palloc.head;
		palloc.head-&gt;prev = p;
	}
	else {
		palloc.tail = p;
		p-&gt;next = 0;
	}
	palloc.head = p;
	p-&gt;prev = 0;
	palloc.freecount++;
}

Page*
newpage(int clear, Segment **s, ulong va)
{
	Page *p;
	KMap *k;
	uchar ct;
	int i, hw, dontalloc, color;

	lock(&amp;palloc);
	color = getpgcolor(va);
	hw = swapalloc.highwater;
	for(;;) {
		if(palloc.freecount &gt; hw)
			break;
		if(up-&gt;kp &amp;&amp; palloc.freecount &gt; 0)
			break;

		unlock(&amp;palloc);
		dontalloc = 0;
		if(s &amp;&amp; *s) {
			qunlock(&amp;((*s)-&gt;lk));
			*s = 0;
			dontalloc = 1;
		}
		qlock(&amp;palloc.pwait);	/* Hold memory requesters here */

		while(waserror())	/* Ignore interrupts */
			;

		kickpager();
		tsleep(&amp;palloc.r, ispages, 0, 1000);

		poperror();

		qunlock(&amp;palloc.pwait);

		/*
		 * If called from fault and we lost the segment from
		 * underneath don't waste time allocating and freeing
		 * a page. Fault will call newpage again when it has
		 * reacquired the segment locks
		 */
		if(dontalloc)
			return 0;

		lock(&amp;palloc);
	}

	/* First try for our colour */
	for(p = palloc.head; p; p = p-&gt;next)
		if(p-&gt;color == color)
			break;

	ct = PG_NOFLUSH;
	if(p == 0) {
		p = palloc.head;
		p-&gt;color = color;
		ct = PG_NEWCOL;
	}

	pageunchain(p);

	lock(p);
	if(p-&gt;ref != 0)
		panic("newpage: p-&gt;ref %d != 0", p-&gt;ref);

	uncachepage(p);
	p-&gt;ref++;
	p-&gt;va = va;
	p-&gt;modref = 0;
	for(i = 0; i &lt; MAXMACH; i++)
		p-&gt;cachectl[i] = ct;
	unlock(p);
	unlock(&amp;palloc);

	if(clear) {
		k = kmap(p);
		memset((void*)VA(k), 0, BY2PG);
		kunmap(k);
	}

	return p;
}

int
ispages(void*)
{
	return palloc.freecount &gt;= swapalloc.highwater;
}

void
putpage(Page *p)
{
	if(onswap(p)) {
		putswap(p);
		return;
	}

	lock(&amp;palloc);
	lock(p);

	if(p-&gt;ref == 0)
		panic("putpage");

	if(--p-&gt;ref &gt; 0) {
		unlock(p);
		unlock(&amp;palloc);
		return;
	}

	if(p-&gt;image &amp;&amp; p-&gt;image != &amp;swapimage)
		pagechaintail(p);
	else 
		pagechainhead(p);

	if(palloc.r.p != 0)
		wakeup(&amp;palloc.r);

	unlock(p);
	unlock(&amp;palloc);
}

Page*
auxpage(void)
{
	Page *p;

	lock(&amp;palloc);
	p = palloc.head;
	if(palloc.freecount &lt; swapalloc.highwater) {
		unlock(&amp;palloc);
		return 0;
	}
	pageunchain(p);

	lock(p);
	if(p-&gt;ref != 0)
		panic("auxpage");
	p-&gt;ref++;
	uncachepage(p);
	unlock(p);
	unlock(&amp;palloc);

	return p;
}

static int dupretries = 15000;

int
duppage(Page *p)				/* Always call with p locked */
{
	Page *np;
	int color;
	int retries;

	retries = 0;
retry:

	if(retries++ &gt; dupretries){
		print("duppage %d, up %p\n", retries, up);
		dupretries += 100;
		if(dupretries &gt; 100000)
			panic("duppage\n");
		uncachepage(p);
		return 1;
	}
		

	/* don't dup pages with no image */
	if(p-&gt;ref == 0 || p-&gt;image == nil || p-&gt;image-&gt;notext)
		return 0;

	/*
	 *  normal lock ordering is to call
	 *  lock(&amp;palloc) before lock(p).
	 *  To avoid deadlock, we have to drop
	 *  our locks and try again.
	 */
	if(!canlock(&amp;palloc)){
		unlock(p);
		if(up)
			sched();
		lock(p);
		goto retry;
	}

	/* No freelist cache when memory is very low */
	if(palloc.freecount &lt; swapalloc.highwater) {
		unlock(&amp;palloc);
		uncachepage(p);
		return 1;
	}

	color = getpgcolor(p-&gt;va);
	for(np = palloc.head; np; np = np-&gt;next)
		if(np-&gt;color == color)
			break;

	/* No page of the correct color */
	if(np == 0) {
		unlock(&amp;palloc);
		uncachepage(p);
		return 1;
	}

	pageunchain(np);
	pagechaintail(np);
/*
* XXX - here's a bug? - np is on the freelist but it's not really free.
* when we unlock palloc someone else can come in, decide to
* use np, and then try to lock it.  they succeed after we've 
* run copypage and cachepage and unlock(np).  then what?
* they call pageunchain before locking(np), so it's removed
* from the freelist, but still in the cache because of
* cachepage below.  if someone else looks in the cache
* before they remove it, the page will have a nonzero ref
* once they finally lock(np).
*/
	lock(np);
	unlock(&amp;palloc);

	/* Cache the new version */
	uncachepage(np);
	np-&gt;va = p-&gt;va;
	np-&gt;daddr = p-&gt;daddr;
	copypage(p, np);
	cachepage(np, p-&gt;image);
	unlock(np);
	uncachepage(p);

	return 0;
}

void
copypage(Page *f, Page *t)
{
	KMap *ks, *kd;

	ks = kmap(f);
	kd = kmap(t);
	memmove((void*)VA(kd), (void*)VA(ks), BY2PG);
	kunmap(ks);
	kunmap(kd);
}

void
uncachepage(Page *p)			/* Always called with a locked page */
{
	Page **l, *f;

	if(p-&gt;image == 0)
		return;

	lock(&amp;palloc.hashlock);
	l = &amp;pghash(p-&gt;daddr);
	for(f = *l; f; f = f-&gt;hash) {
		if(f == p) {
			*l = p-&gt;hash;
			break;
		}
		l = &amp;f-&gt;hash;
	}
	unlock(&amp;palloc.hashlock);
	putimage(p-&gt;image);
	p-&gt;image = 0;
	p-&gt;daddr = 0;
}

void
cachepage(Page *p, Image *i)
{
	Page **l;

	/* If this ever happens it should be fixed by calling
	 * uncachepage instead of panic. I think there is a race
	 * with pio in which this can happen. Calling uncachepage is
	 * correct - I just wanted to see if we got here.
	 */
	if(p-&gt;image)
		panic("cachepage");

	incref(i);
	lock(&amp;palloc.hashlock);
	p-&gt;image = i;
	l = &amp;pghash(p-&gt;daddr);
	p-&gt;hash = *l;
	*l = p;
	unlock(&amp;palloc.hashlock);
}

void
cachedel(Image *i, ulong daddr)
{
	Page *f, **l;

	lock(&amp;palloc.hashlock);
	l = &amp;pghash(daddr);
	for(f = *l; f; f = f-&gt;hash) {
		if(f-&gt;image == i &amp;&amp; f-&gt;daddr == daddr) {
			lock(f);
			if(f-&gt;image == i &amp;&amp; f-&gt;daddr == daddr){
				*l = f-&gt;hash;
				putimage(f-&gt;image);
				f-&gt;image = 0;
				f-&gt;daddr = 0;
			}
			unlock(f);
			break;
		}
		l = &amp;f-&gt;hash;
	}
	unlock(&amp;palloc.hashlock);
}

Page *
lookpage(Image *i, ulong daddr)
{
	Page *f;

	lock(&amp;palloc.hashlock);
	for(f = pghash(daddr); f; f = f-&gt;hash) {
		if(f-&gt;image == i &amp;&amp; f-&gt;daddr == daddr) {
			unlock(&amp;palloc.hashlock);

			lock(&amp;palloc);
			lock(f);
			if(f-&gt;image != i || f-&gt;daddr != daddr) {
				unlock(f);
				unlock(&amp;palloc);
				return 0;
			}
			if(++f-&gt;ref == 1)
				pageunchain(f);
			unlock(&amp;palloc);
			unlock(f);

			return f;
		}
	}
	unlock(&amp;palloc.hashlock);

	return 0;
}

Pte*
ptecpy(Pte *old)
{
	Pte *new;
	Page **src, **dst;

	new = ptealloc();
	dst = &amp;new-&gt;pages[old-&gt;first-old-&gt;pages];
	new-&gt;first = dst;
	for(src = old-&gt;first; src &lt;= old-&gt;last; src++, dst++)
		if(*src) {
			if(onswap(*src))
				dupswap(*src);
			else {
				lock(*src);
				(*src)-&gt;ref++;
				unlock(*src);
			}
			new-&gt;last = dst;
			*dst = *src;
		}

	return new;
}

Pte*
ptealloc(void)
{
	Pte *new;

	new = smalloc(sizeof(Pte));
	new-&gt;first = &amp;new-&gt;pages[PTEPERTAB];
	new-&gt;last = new-&gt;pages;
	return new;
}

void
freepte(Segment *s, Pte *p)
{
	int ref;
	void (*fn)(Page*);
	Page *pt, **pg, **ptop;

	switch(s-&gt;type&amp;SG_TYPE) {
	case SG_PHYSICAL:
		fn = s-&gt;pseg-&gt;pgfree;
		ptop = &amp;p-&gt;pages[PTEPERTAB];
		if(fn) {
			for(pg = p-&gt;pages; pg &lt; ptop; pg++) {
				if(*pg == 0)
					continue;
				(*fn)(*pg);
				*pg = 0;
			}
			break;
		}
		for(pg = p-&gt;pages; pg &lt; ptop; pg++) {
			pt = *pg;
			if(pt == 0)
				continue;
			lock(pt);
			ref = --pt-&gt;ref;
			unlock(pt);
			if(ref == 0)
				free(pt);
		}
		break;
	default:
		for(pg = p-&gt;first; pg &lt;= p-&gt;last; pg++)
			if(*pg) {
				putpage(*pg);
				*pg = 0;
			}
	}
	free(p);
}

ulong
pagenumber(Page *p)
{
	return p-palloc.pages;
}

void
checkpagerefs(void)
{
	int s;
	ulong i, np, nwrong;
	ulong *ref;
	
	np = palloc.user;
	ref = malloc(np*sizeof ref[0]);
	if(ref == nil){
		print("checkpagerefs: out of memory\n");
		return;
	}
	
	/*
	 * This may not be exact if there are other processes
	 * holding refs to pages on their stacks.  The hope is
	 * that if you run it on a quiescent system it will still
	 * be useful.
	 */
	s = splhi();
	lock(&amp;palloc);
	countpagerefs(ref, 0);
	portcountpagerefs(ref, 0);
	nwrong = 0;
	for(i=0; i&lt;np; i++){
		if(palloc.pages[i].ref != ref[i]){
			iprint("page %#.8lux ref %d actual %lud\n", 
				palloc.pages[i].pa, palloc.pages[i].ref, ref[i]);
			ref[i] = 1;
			nwrong++;
		}else
			ref[i] = 0;
	}
	countpagerefs(ref, 1);
	portcountpagerefs(ref, 1);
	iprint("%lud mistakes found\n", nwrong);
	unlock(&amp;palloc);
	splx(s);
}

void
portcountpagerefs(ulong *ref, int print)
{
	ulong i, j, k, ns, n;
	Page **pg, *entry;
	Proc *p;
	Pte *pte;
	Segment *s;

	/*
	 * Pages in segments.  s-&gt;mark avoids double-counting.
	 */
	n = 0;
	ns = 0;
	for(i=0; i&lt;conf.nproc; i++){
		p = proctab(i);
		for(j=0; j&lt;NSEG; j++){
			s = p-&gt;seg[j];
			if(s)
				s-&gt;mark = 0;
		}
	}
	for(i=0; i&lt;conf.nproc; i++){
		p = proctab(i);
		for(j=0; j&lt;NSEG; j++){
			s = p-&gt;seg[j];
			if(s == nil || s-&gt;mark++)
				continue;
			ns++;
			for(k=0; k&lt;s-&gt;mapsize; k++){
				pte = s-&gt;map[k];
				if(pte == nil)
					continue;
				for(pg = pte-&gt;first; pg &lt;= pte-&gt;last; pg++){
					entry = *pg;
					if(pagedout(entry))
						continue;
					if(print){
						if(ref[pagenumber(entry)])
							iprint("page %#.8lux in segment %#p\n", entry-&gt;pa, s);
						continue;
					}
					if(ref[pagenumber(entry)]++ == 0)
						n++;
				}
			}
		}
	}
	if(!print){
		iprint("%lud pages in %lud segments\n", n, ns);
		for(i=0; i&lt;conf.nproc; i++){
			p = proctab(i);
			for(j=0; j&lt;NSEG; j++){
				s = p-&gt;seg[j];
				if(s == nil)
					continue;
				if(s-&gt;ref != s-&gt;mark){
					iprint("segment %#p (used by proc %lud pid %lud) has bad ref count %lud actual %lud\n",
						s, i, p-&gt;pid, s-&gt;ref, s-&gt;mark);
				}
			}
		}
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

