<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/pgrp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/pgrp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

enum {
	Whinesecs = 10,		/* frequency of out-of-resources printing */
};

static Ref pgrpid;
static Ref mountid;

void
pgrpnote(ulong noteid, char *a, long n, int flag)
{
	Proc *p, *ep;
	char buf[ERRMAX];

	if(n &gt;= ERRMAX-1)
		error(Etoobig);

	memmove(buf, a, n);
	buf[n] = 0;
	p = proctab(0);
	ep = p+conf.nproc;
	for(; p &lt; ep; p++) {
		if(p-&gt;state == Dead)
			continue;
		if(up != p &amp;&amp; p-&gt;noteid == noteid &amp;&amp; p-&gt;kp == 0) {
			qlock(&amp;p-&gt;debug);
			if(p-&gt;pid == 0 || p-&gt;noteid != noteid){
				qunlock(&amp;p-&gt;debug);
				continue;
			}
			if(!waserror()) {
				postnote(p, 0, buf, flag);
				poperror();
			}
			qunlock(&amp;p-&gt;debug);
		}
	}
}

Pgrp*
newpgrp(void)
{
	Pgrp *p;

	p = smalloc(sizeof(Pgrp));
	p-&gt;ref = 1;
	p-&gt;pgrpid = incref(&amp;pgrpid);
	return p;
}

Rgrp*
newrgrp(void)
{
	Rgrp *r;

	r = smalloc(sizeof(Rgrp));
	r-&gt;ref = 1;
	return r;
}

void
closergrp(Rgrp *r)
{
	if(decref(r) == 0)
		free(r);
}

void
closepgrp(Pgrp *p)
{
	Mhead **h, **e, *f, *next;

	if(decref(p) != 0)
		return;

	qlock(&amp;p-&gt;debug);
	wlock(&amp;p-&gt;ns);
	p-&gt;pgrpid = -1;

	e = &amp;p-&gt;mnthash[MNTHASH];
	for(h = p-&gt;mnthash; h &lt; e; h++) {
		for(f = *h; f; f = next) {
			wlock(&amp;f-&gt;lock);
			cclose(f-&gt;from);
			mountfree(f-&gt;mount);
			f-&gt;mount = nil;
			next = f-&gt;hash;
			wunlock(&amp;f-&gt;lock);
			putmhead(f);
		}
	}
	wunlock(&amp;p-&gt;ns);
	qunlock(&amp;p-&gt;debug);
	free(p);
}

void
pgrpinsert(Mount **order, Mount *m)
{
	Mount *f;

	m-&gt;order = 0;
	if(*order == 0) {
		*order = m;
		return;
	}
	for(f = *order; f; f = f-&gt;order) {
		if(m-&gt;mountid &lt; f-&gt;mountid) {
			m-&gt;order = f;
			*order = m;
			return;
		}
		order = &amp;f-&gt;order;
	}
	*order = m;
}

/*
 * pgrpcpy MUST preserve the mountid allocation order of the parent group
 */
void
pgrpcpy(Pgrp *to, Pgrp *from)
{
	int i;
	Mount *n, *m, **link, *order;
	Mhead *f, **tom, **l, *mh;

	wlock(&amp;from-&gt;ns);
	order = 0;
	tom = to-&gt;mnthash;
	for(i = 0; i &lt; MNTHASH; i++) {
		l = tom++;
		for(f = from-&gt;mnthash[i]; f; f = f-&gt;hash) {
			rlock(&amp;f-&gt;lock);
			mh = newmhead(f-&gt;from);
			*l = mh;
			l = &amp;mh-&gt;hash;
			link = &amp;mh-&gt;mount;
			for(m = f-&gt;mount; m; m = m-&gt;next) {
				n = newmount(mh, m-&gt;to, m-&gt;mflag, m-&gt;spec);
				m-&gt;copy = n;
				pgrpinsert(&amp;order, m);
				*link = n;
				link = &amp;n-&gt;next;
			}
			runlock(&amp;f-&gt;lock);
		}
	}
	/*
	 * Allocate mount ids in the same sequence as the parent group
	 */
	lock(&amp;mountid);
	for(m = order; m; m = m-&gt;order)
		m-&gt;copy-&gt;mountid = mountid.ref++;
	unlock(&amp;mountid);
	wunlock(&amp;from-&gt;ns);
}

Fgrp*
dupfgrp(Fgrp *f)
{
	Fgrp *new;
	Chan *c;
	int i;

	new = smalloc(sizeof(Fgrp));
	if(f == nil){
		new-&gt;fd = smalloc(DELTAFD*sizeof(Chan*));
		new-&gt;nfd = DELTAFD;
		new-&gt;ref = 1;
		return new;
	}

	lock(f);
	/* Make new fd list shorter if possible, preserving quantization */
	new-&gt;nfd = f-&gt;maxfd+1;
	i = new-&gt;nfd%DELTAFD;
	if(i != 0)
		new-&gt;nfd += DELTAFD - i;
	new-&gt;fd = malloc(new-&gt;nfd*sizeof(Chan*));
	if(new-&gt;fd == nil){
		unlock(f);
		free(new);
		error("no memory for fgrp");
	}
	new-&gt;ref = 1;

	new-&gt;maxfd = f-&gt;maxfd;
	for(i = 0; i &lt;= f-&gt;maxfd; i++) {
		if(c = f-&gt;fd[i]){
			incref(c);
			new-&gt;fd[i] = c;
		}
	}
	unlock(f);

	return new;
}

void
closefgrp(Fgrp *f)
{
	int i;
	Chan *c;

	if(f == 0)
		return;

	if(decref(f) != 0)
		return;

	/*
	 * If we get into trouble, forceclosefgrp
	 * will bail us out.
	 */
	up-&gt;closingfgrp = f;
	for(i = 0; i &lt;= f-&gt;maxfd; i++)
		if(c = f-&gt;fd[i]){
			f-&gt;fd[i] = nil;
			cclose(c);
		}
	up-&gt;closingfgrp = nil;

	free(f-&gt;fd);
	free(f);
}

/*
 * Called from sleep because up is in the middle
 * of closefgrp and just got a kill ctl message.
 * This usually means that up has wedged because
 * of some kind of deadly embrace with mntclose
 * trying to talk to itself.  To break free, hand the
 * unclosed channels to the close queue.  Once they
 * are finished, the blocked cclose that we've 
 * interrupted will finish by itself.
 */
void
forceclosefgrp(void)
{
	int i;
	Chan *c;
	Fgrp *f;

	if(up-&gt;procctl != Proc_exitme || up-&gt;closingfgrp == nil){
		print("bad forceclosefgrp call");
		return;
	}

	f = up-&gt;closingfgrp;
	for(i = 0; i &lt;= f-&gt;maxfd; i++)
		if(c = f-&gt;fd[i]){
			f-&gt;fd[i] = nil;
			ccloseq(c);
		}
}


Mount*
newmount(Mhead *mh, Chan *to, int flag, char *spec)
{
	Mount *m;

	m = smalloc(sizeof(Mount));
	m-&gt;to = to;
	m-&gt;head = mh;
	incref(to);
	m-&gt;mountid = incref(&amp;mountid);
	m-&gt;mflag = flag;
	if(spec != 0)
		kstrdup(&amp;m-&gt;spec, spec);

	return m;
}

void
mountfree(Mount *m)
{
	Mount *f;

	while(m) {
		f = m-&gt;next;
		cclose(m-&gt;to);
		m-&gt;mountid = 0;
		free(m-&gt;spec);
		free(m);
		m = f;
	}
}

void
resrcwait(char *reason)
{
	ulong now;
	char *p;
	static ulong lastwhine;

	if(up == 0)
		panic("resrcwait");

	p = up-&gt;psstate;
	if(reason) {
		up-&gt;psstate = reason;
		now = seconds();
		/* don't tie up the console with complaints */
		if(now - lastwhine &gt; Whinesecs) {
			lastwhine = now;
			print("%s\n", reason);
		}
	}

	tsleep(&amp;up-&gt;sleep, return0, 0, 300);
	up-&gt;psstate = p;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

