<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/segment.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/segment.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

static void	imagereclaim(void);
static void	imagechanreclaim(void);

#include "io.h"

/*
 * Attachable segment types
 */
static Physseg physseg[10] = {
	{ SG_SHARED,	"shared",	0,	SEGMAXSIZE,	0, 	0 },
	{ SG_BSS,	"memory",	0,	SEGMAXSIZE,	0,	0 },
	{ 0,		0,		0,	0,		0,	0 },
};

static Lock physseglock;

#define NFREECHAN	64
#define IHASHSIZE	64
#define ihash(s)	imagealloc.hash[s%IHASHSIZE]
static struct Imagealloc
{
	Lock;
	Image	*free;
	Image	*hash[IHASHSIZE];
	QLock	ireclaim;	/* mutex on reclaiming free images */

	Chan	**freechan;	/* free image channels */
	int	nfreechan;	/* number of free channels */
	int	szfreechan;	/* size of freechan array */
	QLock	fcreclaim;	/* mutex on reclaiming free channels */
}imagealloc;

Segment* (*_globalsegattach)(Proc*, char*);

void
initseg(void)
{
	Image *i, *ie;

	imagealloc.free = xalloc(conf.nimage*sizeof(Image));
	if (imagealloc.free == nil)
		panic("initseg: no memory");
	ie = &amp;imagealloc.free[conf.nimage-1];
	for(i = imagealloc.free; i &lt; ie; i++)
		i-&gt;next = i+1;
	i-&gt;next = 0;
	imagealloc.freechan = malloc(NFREECHAN * sizeof(Chan*));
	imagealloc.szfreechan = NFREECHAN;
}

Segment *
newseg(int type, ulong base, ulong size)
{
	Segment *s;
	int mapsize;

	if(size &gt; (SEGMAPSIZE*PTEPERTAB))
		error(Enovmem);

	s = smalloc(sizeof(Segment));
	s-&gt;ref = 1;
	s-&gt;type = type;
	s-&gt;base = base;
	s-&gt;top = base+(size*BY2PG);
	s-&gt;size = size;
	s-&gt;sema.prev = &amp;s-&gt;sema;
	s-&gt;sema.next = &amp;s-&gt;sema;

	mapsize = ROUND(size, PTEPERTAB)/PTEPERTAB;
	if(mapsize &gt; nelem(s-&gt;ssegmap)){
		mapsize *= 2;
		if(mapsize &gt; (SEGMAPSIZE*PTEPERTAB))
			mapsize = (SEGMAPSIZE*PTEPERTAB);
		s-&gt;map = smalloc(mapsize*sizeof(Pte*));
		s-&gt;mapsize = mapsize;
	}
	else{
		s-&gt;map = s-&gt;ssegmap;
		s-&gt;mapsize = nelem(s-&gt;ssegmap);
	}

	return s;
}

void
putseg(Segment *s)
{
	Pte **pp, **emap;
	Image *i;

	if(s == 0)
		return;

	i = s-&gt;image;
	if(i != 0) {
		lock(i);
		lock(s);
		if(i-&gt;s == s &amp;&amp; s-&gt;ref == 1)
			i-&gt;s = 0;
		unlock(i);
	}
	else
		lock(s);

	s-&gt;ref--;
	if(s-&gt;ref != 0) {
		unlock(s);
		return;
	}
	unlock(s);

	qlock(&amp;s-&gt;lk);
	if(i)
		putimage(i);

	emap = &amp;s-&gt;map[s-&gt;mapsize];
	for(pp = s-&gt;map; pp &lt; emap; pp++)
		if(*pp)
			freepte(s, *pp);

	qunlock(&amp;s-&gt;lk);
	if(s-&gt;map != s-&gt;ssegmap)
		free(s-&gt;map);
	if(s-&gt;profile != 0)
		free(s-&gt;profile);
	free(s);
}

void
relocateseg(Segment *s, ulong offset)
{
	Page **pg, *x;
	Pte *pte, **p, **endpte;

	endpte = &amp;s-&gt;map[s-&gt;mapsize];
	for(p = s-&gt;map; p &lt; endpte; p++) {
		if(*p == 0)
			continue;
		pte = *p;
		for(pg = pte-&gt;first; pg &lt;= pte-&gt;last; pg++) {
			if(x = *pg)
				x-&gt;va += offset;
		}
	}
}

Segment*
dupseg(Segment **seg, int segno, int share)
{
	int i, size;
	Pte *pte;
	Segment *n, *s;

	SET(n);
	s = seg[segno];

	qlock(&amp;s-&gt;lk);
	if(waserror()){
		qunlock(&amp;s-&gt;lk);
		nexterror();
	}
	switch(s-&gt;type&amp;SG_TYPE) {
	case SG_TEXT:		/* New segment shares pte set */
	case SG_SHARED:
	case SG_PHYSICAL:
		goto sameseg;

	case SG_STACK:
		n = newseg(s-&gt;type, s-&gt;base, s-&gt;size);
		break;

	case SG_BSS:		/* Just copy on write */
		if(share)
			goto sameseg;
		n = newseg(s-&gt;type, s-&gt;base, s-&gt;size);
		break;

	case SG_DATA:		/* Copy on write plus demand load info */
		if(segno == TSEG){
			poperror();
			qunlock(&amp;s-&gt;lk);
			return data2txt(s);
		}

		if(share)
			goto sameseg;
		n = newseg(s-&gt;type, s-&gt;base, s-&gt;size);

		incref(s-&gt;image);
		n-&gt;image = s-&gt;image;
		n-&gt;fstart = s-&gt;fstart;
		n-&gt;flen = s-&gt;flen;
		break;
	}
	size = s-&gt;mapsize;
	for(i = 0; i &lt; size; i++)
		if(pte = s-&gt;map[i])
			n-&gt;map[i] = ptecpy(pte);

	n-&gt;flushme = s-&gt;flushme;
	if(s-&gt;ref &gt; 1)
		procflushseg(s);
	poperror();
	qunlock(&amp;s-&gt;lk);
	return n;

sameseg:
	incref(s);
	poperror();
	qunlock(&amp;s-&gt;lk);
	return s;
}

void
segpage(Segment *s, Page *p)
{
	Pte **pte;
	ulong off;
	Page **pg;

	if(p-&gt;va &lt; s-&gt;base || p-&gt;va &gt;= s-&gt;top)
		panic("segpage");

	off = p-&gt;va - s-&gt;base;
	pte = &amp;s-&gt;map[off/PTEMAPMEM];
	if(*pte == 0)
		*pte = ptealloc();

	pg = &amp;(*pte)-&gt;pages[(off&amp;(PTEMAPMEM-1))/BY2PG];
	*pg = p;
	if(pg &lt; (*pte)-&gt;first)
		(*pte)-&gt;first = pg;
	if(pg &gt; (*pte)-&gt;last)
		(*pte)-&gt;last = pg;
}

Image*
attachimage(int type, Chan *c, ulong base, ulong len)
{
	Image *i, **l;

	/* reclaim any free channels from reclaimed segments */
	if(imagealloc.nfreechan)
		imagechanreclaim();

	lock(&amp;imagealloc);

	/*
	 * Search the image cache for remains of the text from a previous
	 * or currently running incarnation
	 */
	for(i = ihash(c-&gt;qid.path); i; i = i-&gt;hash) {
		if(c-&gt;qid.path == i-&gt;qid.path) {
			lock(i);
			if(eqqid(c-&gt;qid, i-&gt;qid) &amp;&amp;
			   eqqid(c-&gt;mqid, i-&gt;mqid) &amp;&amp;
			   c-&gt;mchan == i-&gt;mchan &amp;&amp;
			   c-&gt;type == i-&gt;type) {
				goto found;
			}
			unlock(i);
		}
	}

	/*
	 * imagereclaim dumps pages from the free list which are cached by image
	 * structures. This should free some image structures.
	 */
	while(!(i = imagealloc.free)) {
		unlock(&amp;imagealloc);
		imagereclaim();
		sched();
		lock(&amp;imagealloc);
	}

	imagealloc.free = i-&gt;next;

	lock(i);
	incref(c);
	i-&gt;c = c;
	i-&gt;type = c-&gt;type;
	i-&gt;qid = c-&gt;qid;
	i-&gt;mqid = c-&gt;mqid;
	i-&gt;mchan = c-&gt;mchan;
	l = &amp;ihash(c-&gt;qid.path);
	i-&gt;hash = *l;
	*l = i;
found:
	unlock(&amp;imagealloc);

	if(i-&gt;s == 0) {
		/* Disaster after commit in exec */
		if(waserror()) {
			unlock(i);
			pexit(Enovmem, 1);
		}
		i-&gt;s = newseg(type, base, len);
		i-&gt;s-&gt;image = i;
		i-&gt;ref++;
		poperror();
	}
	else
		incref(i-&gt;s);

	return i;
}

static struct {
	int	calls;			/* times imagereclaim was called */
	int	loops;			/* times the main loop was run */
	uvlong	ticks;			/* total time in the main loop */
	uvlong	maxt;			/* longest time in main loop */
} irstats;

static void
imagereclaim(void)
{
	int n;
	Page *p;
	uvlong ticks;

	irstats.calls++;
	/* Somebody is already cleaning the page cache */
	if(!canqlock(&amp;imagealloc.ireclaim))
		return;

	lock(&amp;palloc);
	ticks = fastticks(nil);
	n = 0;
	/*
	 * All the pages with images backing them are at the
	 * end of the list (see putpage) so start there and work
	 * backward.
	 */
	for(p = palloc.tail; p &amp;&amp; p-&gt;image &amp;&amp; n&lt;1000; p = p-&gt;prev) {
		if(p-&gt;ref == 0 &amp;&amp; canlock(p)) {
			if(p-&gt;ref == 0) {
				n++;
				uncachepage(p);
			}
			unlock(p);
		}
	}
	ticks = fastticks(nil) - ticks;
	unlock(&amp;palloc);
	irstats.loops++;
	irstats.ticks += ticks;
	if(ticks &gt; irstats.maxt)
		irstats.maxt = ticks;
	//print("T%llud+", ticks);
	qunlock(&amp;imagealloc.ireclaim);
}

/*
 *  since close can block, this has to be called outside of
 *  spin locks.
 */
static void
imagechanreclaim(void)
{
	Chan *c;

	/* Somebody is already cleaning the image chans */
	if(!canqlock(&amp;imagealloc.fcreclaim))
		return;

	/*
	 * We don't have to recheck that nfreechan &gt; 0 after we
	 * acquire the lock, because we're the only ones who decrement 
	 * it (the other lock contender increments it), and there's only
	 * one of us thanks to the qlock above.
	 */
	while(imagealloc.nfreechan &gt; 0){
		lock(&amp;imagealloc);
		imagealloc.nfreechan--;
		c = imagealloc.freechan[imagealloc.nfreechan];
		unlock(&amp;imagealloc);
		cclose(c);
	}

	qunlock(&amp;imagealloc.fcreclaim);
}

void
putimage(Image *i)
{
	Chan *c, **cp;
	Image *f, **l;

	if(i-&gt;notext)
		return;

	lock(i);
	if(--i-&gt;ref == 0) {
		l = &amp;ihash(i-&gt;qid.path);
		mkqid(&amp;i-&gt;qid, ~0, ~0, QTFILE);
		unlock(i);
		c = i-&gt;c;

		lock(&amp;imagealloc);
		for(f = *l; f; f = f-&gt;hash) {
			if(f == i) {
				*l = i-&gt;hash;
				break;
			}
			l = &amp;f-&gt;hash;
		}

		i-&gt;next = imagealloc.free;
		imagealloc.free = i;

		/* defer freeing channel till we're out of spin lock's */
		if(imagealloc.nfreechan == imagealloc.szfreechan){
			imagealloc.szfreechan += NFREECHAN;
			cp = malloc(imagealloc.szfreechan*sizeof(Chan*));
			if(cp == nil)
				panic("putimage");
			memmove(cp, imagealloc.freechan, imagealloc.nfreechan*sizeof(Chan*));
			free(imagealloc.freechan);
			imagealloc.freechan = cp;
		}
		imagealloc.freechan[imagealloc.nfreechan++] = c;
		unlock(&amp;imagealloc);

		return;
	}
	unlock(i);
}

long
ibrk(ulong addr, int seg)
{
	Segment *s, *ns;
	ulong newtop, newsize;
	int i, mapsize;
	Pte **map;

	s = up-&gt;seg[seg];
	if(s == 0)
		error(Ebadarg);

	if(addr == 0)
		return s-&gt;base;

	qlock(&amp;s-&gt;lk);

	/* We may start with the bss overlapping the data */
	if(addr &lt; s-&gt;base) {
		if(seg != BSEG || up-&gt;seg[DSEG] == 0 || addr &lt; up-&gt;seg[DSEG]-&gt;base) {
			qunlock(&amp;s-&gt;lk);
			error(Enovmem);
		}
		addr = s-&gt;base;
	}

	newtop = PGROUND(addr);
	newsize = (newtop-s-&gt;base)/BY2PG;
	if(newtop &lt; s-&gt;top) {
		/*
		 * do not shrink a segment shared with other procs, as the
		 * to-be-freed address space may have been passed to the kernel
		 * already by another proc and is past the validaddr stage.
		 */
		if(s-&gt;ref &gt; 1){
			qunlock(&amp;s-&gt;lk);
			error(Einuse);
		}
		mfreeseg(s, newtop, (s-&gt;top-newtop)/BY2PG);
		s-&gt;top = newtop;
		s-&gt;size = newsize;
		qunlock(&amp;s-&gt;lk);
		flushmmu();
		return 0;
	}

	for(i = 0; i &lt; NSEG; i++) {
		ns = up-&gt;seg[i];
		if(ns == 0 || ns == s)
			continue;
		if(newtop &gt;= ns-&gt;base &amp;&amp; newtop &lt; ns-&gt;top) {
			qunlock(&amp;s-&gt;lk);
			error(Esoverlap);
		}
	}

	if(newsize &gt; (SEGMAPSIZE*PTEPERTAB)) {
		qunlock(&amp;s-&gt;lk);
		error(Enovmem);
	}
	mapsize = ROUND(newsize, PTEPERTAB)/PTEPERTAB;
	if(mapsize &gt; s-&gt;mapsize){
		map = smalloc(mapsize*sizeof(Pte*));
		memmove(map, s-&gt;map, s-&gt;mapsize*sizeof(Pte*));
		if(s-&gt;map != s-&gt;ssegmap)
			free(s-&gt;map);
		s-&gt;map = map;
		s-&gt;mapsize = mapsize;
	}

	s-&gt;top = newtop;
	s-&gt;size = newsize;
	qunlock(&amp;s-&gt;lk);
	return 0;
}

/*
 *  called with s-&gt;lk locked
 */
void
mfreeseg(Segment *s, ulong start, int pages)
{
	int i, j, size;
	ulong soff;
	Page *pg;
	Page *list;

	soff = start-s-&gt;base;
	j = (soff&amp;(PTEMAPMEM-1))/BY2PG;

	size = s-&gt;mapsize;
	list = nil;
	for(i = soff/PTEMAPMEM; i &lt; size; i++) {
		if(pages &lt;= 0)
			break;
		if(s-&gt;map[i] == 0) {
			pages -= PTEPERTAB-j;
			j = 0;
			continue;
		}
		while(j &lt; PTEPERTAB) {
			pg = s-&gt;map[i]-&gt;pages[j];
			/*
			 * We want to zero s-&gt;map[i]-&gt;page[j] and putpage(pg),
			 * but we have to make sure other processors flush the
			 * entry from their TLBs before the page is freed.
			 * We construct a list of the pages to be freed, zero
			 * the entries, then (below) call procflushseg, and call
			 * putpage on the whole list.
			 *
			 * Swapped-out pages don't appear in TLBs, so it's okay
			 * to putswap those pages before procflushseg.
			 */
			if(pg){
				if(onswap(pg))
					putswap(pg);
				else{
					pg-&gt;next = list;
					list = pg;
				}
				s-&gt;map[i]-&gt;pages[j] = 0;
			}
			if(--pages == 0)
				goto out;
			j++;
		}
		j = 0;
	}
out:
	/* flush this seg in all other processes */
	if(s-&gt;ref &gt; 1)
		procflushseg(s);

	/* free the pages */
	for(pg = list; pg != nil; pg = list){
		list = list-&gt;next;
		putpage(pg);
	}
}

Segment*
isoverlap(Proc *p, ulong va, int len)
{
	int i;
	Segment *ns;
	ulong newtop;

	newtop = va+len;
	for(i = 0; i &lt; NSEG; i++) {
		ns = p-&gt;seg[i];
		if(ns == 0)
			continue;
		if((newtop &gt; ns-&gt;base &amp;&amp; newtop &lt;= ns-&gt;top) ||
		   (va &gt;= ns-&gt;base &amp;&amp; va &lt; ns-&gt;top))
			return ns;
	}
	return nil;
}

int
addphysseg(Physseg* new)
{
	Physseg *ps;

	/*
	 * Check not already entered and there is room
	 * for a new entry and the terminating null entry.
	 */
	lock(&amp;physseglock);
	for(ps = physseg; ps-&gt;name; ps++){
		if(strcmp(ps-&gt;name, new-&gt;name) == 0){
			unlock(&amp;physseglock);
			return -1;
		}
	}
	if(ps-physseg &gt;= nelem(physseg)-2){
		unlock(&amp;physseglock);
		return -1;
	}

	*ps = *new;
	unlock(&amp;physseglock);

	return 0;
}

int
isphysseg(char *name)
{
	Physseg *ps;
	int rv = 0;

	lock(&amp;physseglock);
	for(ps = physseg; ps-&gt;name; ps++){
		if(strcmp(ps-&gt;name, name) == 0){
			rv = 1;
			break;
		}
	}
	unlock(&amp;physseglock);
	return rv;
}

ulong
segattach(Proc *p, ulong attr, char *name, ulong va, ulong len)
{
	int sno;
	Segment *s, *os;
	Physseg *ps;

	if(va != 0 &amp;&amp; va &gt;= USTKTOP)
		error(Ebadarg);

	validaddr((ulong)name, 1, 0);
	vmemchr(name, 0, ~0);

	for(sno = 0; sno &lt; NSEG; sno++)
		if(p-&gt;seg[sno] == nil &amp;&amp; sno != ESEG)
			break;

	if(sno == NSEG)
		error(Enovmem);

	/*
	 *  first look for a global segment with the
	 *  same name
	 */
	if(_globalsegattach != nil){
		s = (*_globalsegattach)(p, name);
		if(s != nil){
			p-&gt;seg[sno] = s;
			return s-&gt;base;
		}
	}

	len = PGROUND(len);
	if(len == 0)
		error(Ebadarg);

	/*
	 * Find a hole in the address space.
	 * Starting at the lowest possible stack address - len,
	 * check for an overlapping segment, and repeat at the
	 * base of that segment - len until either a hole is found
	 * or the address space is exhausted.  Ensure that we don't
	 * map the zero page.
	 */
	if(va == 0) {
		for (os = p-&gt;seg[SSEG]; os != nil; os = isoverlap(p, va, len)) {
			va = os-&gt;base;
			if(len &gt;= va)
				error(Enovmem);
			va -= len;
		}
		va &amp;= ~(BY2PG-1);
	} else {
		va &amp;= ~(BY2PG-1);
		if(va == 0 || va &gt;= USTKTOP)
			error(Ebadarg);
	}

	if(isoverlap(p, va, len) != nil)
		error(Esoverlap);

	for(ps = physseg; ps-&gt;name; ps++)
		if(strcmp(name, ps-&gt;name) == 0)
			goto found;

	error(Ebadarg);
found:
	if(len &gt; ps-&gt;size)
		error(Enovmem);

	attr &amp;= ~SG_TYPE;		/* Turn off what is not allowed */
	attr |= ps-&gt;attr;		/* Copy in defaults */

	s = newseg(attr, va, len/BY2PG);
	s-&gt;pseg = ps;
	p-&gt;seg[sno] = s;

	return va;
}

void
pteflush(Pte *pte, int s, int e)
{
	int i;
	Page *p;

	for(i = s; i &lt; e; i++) {
		p = pte-&gt;pages[i];
		if(pagedout(p) == 0)
			memset(p-&gt;cachectl, PG_TXTFLUSH, sizeof(p-&gt;cachectl));
	}
}

long
syssegflush(ulong *arg)
{
	Segment *s;
	ulong addr, l;
	Pte *pte;
	int chunk, ps, pe, len;

	addr = arg[0];
	len = arg[1];

	while(len &gt; 0) {
		s = seg(up, addr, 1);
		if(s == 0)
			error(Ebadarg);

		s-&gt;flushme = 1;
	more:
		l = len;
		if(addr+l &gt; s-&gt;top)
			l = s-&gt;top - addr;

		ps = addr-s-&gt;base;
		pte = s-&gt;map[ps/PTEMAPMEM];
		ps &amp;= PTEMAPMEM-1;
		pe = PTEMAPMEM;
		if(pe-ps &gt; l){
			pe = ps + l;
			pe = (pe+BY2PG-1)&amp;~(BY2PG-1);
		}
		if(pe == ps) {
			qunlock(&amp;s-&gt;lk);
			error(Ebadarg);
		}

		if(pte)
			pteflush(pte, ps/BY2PG, pe/BY2PG);

		chunk = pe-ps;
		len -= chunk;
		addr += chunk;

		if(len &gt; 0 &amp;&amp; addr &lt; s-&gt;top)
			goto more;

		qunlock(&amp;s-&gt;lk);
	}
	flushmmu();
	return 0;
}

void
segclock(ulong pc)
{
	Segment *s;

	s = up-&gt;seg[TSEG];
	if(s == 0 || s-&gt;profile == 0)
		return;

	s-&gt;profile[0] += TK2MS(1);
	if(pc &gt;= s-&gt;base &amp;&amp; pc &lt; s-&gt;top) {
		pc -= s-&gt;base;
		s-&gt;profile[pc&gt;&gt;LRESPROF] += TK2MS(1);
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

