<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/sysproc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/sysproc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"tos.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"../port/edf.h"

#include	&lt;a.out.h&gt;

int	shargs(char*, int, char**);

extern void checkpages(void);
extern void checkpagerefs(void);

long
sysr1(ulong*)
{
	checkpagerefs();
	return 0;
}

long
sysrfork(ulong *arg)
{
	Proc *p;
	int n, i;
	Fgrp *ofg;
	Pgrp *opg;
	Rgrp *org;
	Egrp *oeg;
	ulong pid, flag;
	Mach *wm;

	flag = arg[0];
	/* Check flags before we commit */
	if((flag &amp; (RFFDG|RFCFDG)) == (RFFDG|RFCFDG))
		error(Ebadarg);
	if((flag &amp; (RFNAMEG|RFCNAMEG)) == (RFNAMEG|RFCNAMEG))
		error(Ebadarg);
	if((flag &amp; (RFENVG|RFCENVG)) == (RFENVG|RFCENVG))
		error(Ebadarg);

	if((flag&amp;RFPROC) == 0) {
		if(flag &amp; (RFMEM|RFNOWAIT))
			error(Ebadarg);
		if(flag &amp; (RFFDG|RFCFDG)) {
			ofg = up-&gt;fgrp;
			if(flag &amp; RFFDG)
				up-&gt;fgrp = dupfgrp(ofg);
			else
				up-&gt;fgrp = dupfgrp(nil);
			closefgrp(ofg);
		}
		if(flag &amp; (RFNAMEG|RFCNAMEG)) {
			opg = up-&gt;pgrp;
			up-&gt;pgrp = newpgrp();
			if(flag &amp; RFNAMEG)
				pgrpcpy(up-&gt;pgrp, opg);
			/* inherit noattach */
			up-&gt;pgrp-&gt;noattach = opg-&gt;noattach;
			closepgrp(opg);
		}
		if(flag &amp; RFNOMNT)
			up-&gt;pgrp-&gt;noattach = 1;
		if(flag &amp; RFREND) {
			org = up-&gt;rgrp;
			up-&gt;rgrp = newrgrp();
			closergrp(org);
		}
		if(flag &amp; (RFENVG|RFCENVG)) {
			oeg = up-&gt;egrp;
			up-&gt;egrp = smalloc(sizeof(Egrp));
			up-&gt;egrp-&gt;ref = 1;
			if(flag &amp; RFENVG)
				envcpy(up-&gt;egrp, oeg);
			closeegrp(oeg);
		}
		if(flag &amp; RFNOTEG)
			up-&gt;noteid = incref(&amp;noteidalloc);
		return 0;
	}

	p = newproc();

	p-&gt;fpsave = up-&gt;fpsave;
	p-&gt;scallnr = up-&gt;scallnr;
	p-&gt;s = up-&gt;s;
	p-&gt;nerrlab = 0;
	p-&gt;slash = up-&gt;slash;
	p-&gt;dot = up-&gt;dot;
	incref(p-&gt;dot);

	memmove(p-&gt;note, up-&gt;note, sizeof(p-&gt;note));
	p-&gt;privatemem = up-&gt;privatemem;
	p-&gt;noswap = up-&gt;noswap;
	p-&gt;nnote = up-&gt;nnote;
	p-&gt;notified = 0;
	p-&gt;lastnote = up-&gt;lastnote;
	p-&gt;notify = up-&gt;notify;
	p-&gt;ureg = up-&gt;ureg;
	p-&gt;dbgreg = 0;

	/* Make a new set of memory segments */
	n = flag &amp; RFMEM;
	qlock(&amp;p-&gt;seglock);
	if(waserror()){
		qunlock(&amp;p-&gt;seglock);
		nexterror();
	}
	for(i = 0; i &lt; NSEG; i++)
		if(up-&gt;seg[i])
			p-&gt;seg[i] = dupseg(up-&gt;seg, i, n);
	qunlock(&amp;p-&gt;seglock);
	poperror();

	/* File descriptors */
	if(flag &amp; (RFFDG|RFCFDG)) {
		if(flag &amp; RFFDG)
			p-&gt;fgrp = dupfgrp(up-&gt;fgrp);
		else
			p-&gt;fgrp = dupfgrp(nil);
	}
	else {
		p-&gt;fgrp = up-&gt;fgrp;
		incref(p-&gt;fgrp);
	}

	/* Process groups */
	if(flag &amp; (RFNAMEG|RFCNAMEG)) {
		p-&gt;pgrp = newpgrp();
		if(flag &amp; RFNAMEG)
			pgrpcpy(p-&gt;pgrp, up-&gt;pgrp);
		/* inherit noattach */
		p-&gt;pgrp-&gt;noattach = up-&gt;pgrp-&gt;noattach;
	}
	else {
		p-&gt;pgrp = up-&gt;pgrp;
		incref(p-&gt;pgrp);
	}
	if(flag &amp; RFNOMNT)
		p-&gt;pgrp-&gt;noattach = 1;

	if(flag &amp; RFREND)
		p-&gt;rgrp = newrgrp();
	else {
		incref(up-&gt;rgrp);
		p-&gt;rgrp = up-&gt;rgrp;
	}

	/* Environment group */
	if(flag &amp; (RFENVG|RFCENVG)) {
		p-&gt;egrp = smalloc(sizeof(Egrp));
		p-&gt;egrp-&gt;ref = 1;
		if(flag &amp; RFENVG)
			envcpy(p-&gt;egrp, up-&gt;egrp);
	}
	else {
		p-&gt;egrp = up-&gt;egrp;
		incref(p-&gt;egrp);
	}
	p-&gt;hang = up-&gt;hang;
	p-&gt;procmode = up-&gt;procmode;

	/* Craft a return frame which will cause the child to pop out of
	 * the scheduler in user mode with the return register zero
	 */
	forkchild(p, up-&gt;dbgreg);

	p-&gt;parent = up;
	p-&gt;parentpid = up-&gt;pid;
	if(flag&amp;RFNOWAIT)
		p-&gt;parentpid = 0;
	else {
		lock(&amp;up-&gt;exl);
		up-&gt;nchild++;
		unlock(&amp;up-&gt;exl);
	}
	if((flag&amp;RFNOTEG) == 0)
		p-&gt;noteid = up-&gt;noteid;

	/* don't penalize the child, it hasn't done FP in a note handler. */
	p-&gt;fpstate = up-&gt;fpstate &amp; ~FPillegal;
	pid = p-&gt;pid;
	memset(p-&gt;time, 0, sizeof(p-&gt;time));
	p-&gt;time[TReal] = MACHP(0)-&gt;ticks;

	kstrdup(&amp;p-&gt;text, up-&gt;text);
	kstrdup(&amp;p-&gt;user, up-&gt;user);
	/*
	 *  since the bss/data segments are now shareable,
	 *  any mmu info about this process is now stale
	 *  (i.e. has bad properties) and has to be discarded.
	 */
	flushmmu();
	p-&gt;basepri = up-&gt;basepri;
	p-&gt;priority = up-&gt;basepri;
	p-&gt;fixedpri = up-&gt;fixedpri;
	p-&gt;mp = up-&gt;mp;
	wm = up-&gt;wired;
	if(wm)
		procwired(p, wm-&gt;machno);
	ready(p);
	sched();
	return pid;
}

ulong
l2be(long l)
{
	uchar *cp;

	cp = (uchar*)&amp;l;
	return (cp[0]&lt;&lt;24) | (cp[1]&lt;&lt;16) | (cp[2]&lt;&lt;8) | cp[3];
}

long
sysexec(ulong *arg)
{
	Segment *s, *ts;
	ulong t, d, b;
	int i;
	Chan *tc;
	char **argv, **argp;
	char *a, *charp, *args, *file, *file0;
	char *progarg[sizeof(Exec)/2+1], *elem, progelem[64];
	ulong ssize, spage, nargs, nbytes, n, bssend;
	int indir;
	Exec exec;
	char line[sizeof(Exec)];
	Fgrp *f;
	Image *img;
	ulong magic, text, entry, data, bss;
	Tos *tos;

	indir = 0;
	elem = nil;
	validaddr(arg[0], 1, 0);
	file0 = validnamedup((char*)arg[0], 1);
	if(waserror()){
		free(file0);
		free(elem);
		nexterror();
	}
	file = file0;
	for(;;){
		tc = namec(file, Aopen, OEXEC, 0);
		if(waserror()){
			cclose(tc);
			nexterror();
		}
		if(!indir)
			kstrdup(&amp;elem, up-&gt;genbuf);

		n = devtab[tc-&gt;type]-&gt;read(tc, &amp;exec, sizeof(Exec), 0);
		if(n &lt; 2)
			error(Ebadexec);
		magic = l2be(exec.magic);
		text = l2be(exec.text);
		entry = l2be(exec.entry);
		if(n==sizeof(Exec) &amp;&amp; (magic == AOUT_MAGIC)){
			if(text &gt;= USTKTOP-UTZERO
			|| entry &lt; UTZERO+sizeof(Exec)
			|| entry &gt;= UTZERO+sizeof(Exec)+text)
				error(Ebadexec);
			break; /* for binary */
		}

		/*
		 * Process #! /bin/sh args ...
		 */
		memmove(line, &amp;exec, sizeof(Exec));
		if(indir || line[0]!='#' || line[1]!='!')
			error(Ebadexec);
		n = shargs(line, n, progarg);
		if(n == 0)
			error(Ebadexec);
		indir = 1;
		/*
		 * First arg becomes complete file name
		 */
		progarg[n++] = file;
		progarg[n] = 0;
		validaddr(arg[1], BY2WD, 1);
		arg[1] += BY2WD;
		file = progarg[0];
		if(strlen(elem) &gt;= sizeof progelem)
			error(Ebadexec);
		strcpy(progelem, elem);
		progarg[0] = progelem;
		poperror();
		cclose(tc);
	}

	data = l2be(exec.data);
	bss = l2be(exec.bss);
	t = UTROUND(UTZERO+sizeof(Exec)+text);
	d = (t + data + (BY2PG-1)) &amp; ~(BY2PG-1);
	bssend = t + data + bss;
	b = (bssend + (BY2PG-1)) &amp; ~(BY2PG-1);
	if(t &gt;= KZERO || d &gt;= KZERO || b &gt;= KZERO)
		error(Ebadexec);

	/*
	 * Args: pass 1: count
	 */
	nbytes = sizeof(Tos);		/* hole for profiling clock at top of stack (and more) */
	nargs = 0;
	if(indir){
		argp = progarg;
		while(*argp){
			a = *argp++;
			nbytes += strlen(a) + 1;
			nargs++;
		}
	}
	validalign(arg[1], sizeof(char**));
	argp = (char**)arg[1];
	validaddr((ulong)argp, BY2WD, 0);
	while(*argp){
		a = *argp++;
		if(((ulong)argp&amp;(BY2PG-1)) &lt; BY2WD)
			validaddr((ulong)argp, BY2WD, 0);
		validaddr((ulong)a, 1, 0);
		nbytes += ((char*)vmemchr(a, 0, 0x7FFFFFFF) - a) + 1;
		nargs++;
	}
	ssize = BY2WD*(nargs+1) + ((nbytes+(BY2WD-1)) &amp; ~(BY2WD-1));

	/*
	 * 8-byte align SP for those (e.g. sparc) that need it.
	 * execregs() will subtract another 4 bytes for argc.
	 */
	if((ssize+4) &amp; 7)
		ssize += 4;
	spage = (ssize+(BY2PG-1)) &gt;&gt; PGSHIFT;

	/*
	 * Build the stack segment, putting it in kernel virtual for the moment
	 */
	if(spage &gt; TSTKSIZ)
		error(Enovmem);

	qlock(&amp;up-&gt;seglock);
	if(waserror()){
		qunlock(&amp;up-&gt;seglock);
		nexterror();
	}
	up-&gt;seg[ESEG] = newseg(SG_STACK, TSTKTOP-USTKSIZE, USTKSIZE/BY2PG);

	/*
	 * Args: pass 2: assemble; the pages will be faulted in
	 */
	tos = (Tos*)(TSTKTOP - sizeof(Tos));
	tos-&gt;cyclefreq = m-&gt;cyclefreq;
	cycles((uvlong*)&amp;tos-&gt;pcycles);
	tos-&gt;pcycles = -tos-&gt;pcycles;
	tos-&gt;kcycles = tos-&gt;pcycles;
	tos-&gt;clock = 0;
	argv = (char**)(TSTKTOP - ssize);
	charp = (char*)(TSTKTOP - nbytes);
	args = charp;
	if(indir)
		argp = progarg;
	else
		argp = (char**)arg[1];

	for(i=0; i&lt;nargs; i++){
		if(indir &amp;&amp; *argp==0) {
			indir = 0;
			argp = (char**)arg[1];
		}
		*argv++ = charp + (USTKTOP-TSTKTOP);
		n = strlen(*argp) + 1;
		memmove(charp, *argp++, n);
		charp += n;
	}
	free(file0);

	free(up-&gt;text);
	up-&gt;text = elem;
	elem = nil;	/* so waserror() won't free elem */
	USED(elem);

	/* copy args; easiest from new process's stack */
	n = charp - args;
	if(n &gt; 128)	/* don't waste too much space on huge arg lists */
		n = 128;
	a = up-&gt;args;
	up-&gt;args = nil;
	free(a);
	up-&gt;args = smalloc(n);
	memmove(up-&gt;args, args, n);
	if(n&gt;0 &amp;&amp; up-&gt;args[n-1]!='\0'){
		/* make sure last arg is NUL-terminated */
		/* put NUL at UTF-8 character boundary */
		for(i=n-1; i&gt;0; --i)
			if(fullrune(up-&gt;args+i, n-i))
				break;
		up-&gt;args[i] = 0;
		n = i+1;
	}
	up-&gt;nargs = n;

	/*
	 * Committed.
	 * Free old memory.
	 * Special segments are maintained across exec
	 */
	for(i = SSEG; i &lt;= BSEG; i++) {
		putseg(up-&gt;seg[i]);
		/* prevent a second free if we have an error */
		up-&gt;seg[i] = 0;
	}
	for(i = BSEG+1; i &lt; NSEG; i++) {
		s = up-&gt;seg[i];
		if(s != 0 &amp;&amp; (s-&gt;type&amp;SG_CEXEC)) {
			putseg(s);
			up-&gt;seg[i] = 0;
		}
	}

	/*
	 * Close on exec
	 */
	f = up-&gt;fgrp;
	for(i=0; i&lt;=f-&gt;maxfd; i++)
		fdclose(i, CCEXEC);

	/* Text.  Shared. Attaches to cache image if possible */
	/* attachimage returns a locked cache image */
	img = attachimage(SG_TEXT|SG_RONLY, tc, UTZERO, (t-UTZERO)&gt;&gt;PGSHIFT);
	ts = img-&gt;s;
	up-&gt;seg[TSEG] = ts;
	ts-&gt;flushme = 1;
	ts-&gt;fstart = 0;
	ts-&gt;flen = sizeof(Exec)+text;
	unlock(img);

	/* Data. Shared. */
	s = newseg(SG_DATA, t, (d-t)&gt;&gt;PGSHIFT);
	up-&gt;seg[DSEG] = s;

	/* Attached by hand */
	incref(img);
	s-&gt;image = img;
	s-&gt;fstart = ts-&gt;fstart+ts-&gt;flen;
	s-&gt;flen = data;

	/* BSS. Zero fill on demand */
	up-&gt;seg[BSEG] = newseg(SG_BSS, d, (b-d)&gt;&gt;PGSHIFT);

	/*
	 * Move the stack
	 */
	s = up-&gt;seg[ESEG];
	up-&gt;seg[ESEG] = 0;
	up-&gt;seg[SSEG] = s;
	qunlock(&amp;up-&gt;seglock);
	poperror();	/* seglock */
	poperror();	/* elem */
	s-&gt;base = USTKTOP-USTKSIZE;
	s-&gt;top = USTKTOP;
	relocateseg(s, USTKTOP-TSTKTOP);

	/*
	 *  '/' processes are higher priority (hack to make /ip more responsive).
	 */
	if(devtab[tc-&gt;type]-&gt;dc == L'/')
		up-&gt;basepri = PriRoot;
	up-&gt;priority = up-&gt;basepri;
	poperror();
	cclose(tc);

	/*
	 *  At this point, the mmu contains info about the old address
	 *  space and needs to be flushed
	 */
	flushmmu();
	qlock(&amp;up-&gt;debug);
	up-&gt;nnote = 0;
	up-&gt;notify = 0;
	up-&gt;notified = 0;
	up-&gt;privatemem = 0;
	procsetup(up);
	qunlock(&amp;up-&gt;debug);
	if(up-&gt;hang)
		up-&gt;procctl = Proc_stopme;

	return execregs(entry, ssize, nargs);
}

int
shargs(char *s, int n, char **ap)
{
	int i;

	s += 2;
	n -= 2;		/* skip #! */
	for(i=0; s[i]!='\n'; i++)
		if(i == n-1)
			return 0;
	s[i] = 0;
	*ap = 0;
	i = 0;
	for(;;) {
		while(*s==' ' || *s=='\t')
			s++;
		if(*s == 0)
			break;
		i++;
		*ap++ = s;
		*ap = 0;
		while(*s &amp;&amp; *s!=' ' &amp;&amp; *s!='\t')
			s++;
		if(*s == 0)
			break;
		else
			*s++ = 0;
	}
	return i;
}

int
return0(void*)
{
	return 0;
}

long
syssleep(ulong *arg)
{

	int n;

	n = arg[0];
	if(n &lt;= 0) {
		if (up-&gt;edf &amp;&amp; (up-&gt;edf-&gt;flags &amp; Admitted))
			edfyield();
		else
			yield();
		return 0;
	}
	if(n &lt; TK2MS(1))
		n = TK2MS(1);
	tsleep(&amp;up-&gt;sleep, return0, 0, n);
	return 0;
}

long
sysalarm(ulong *arg)
{
	return procalarm(arg[0]);
}

long
sysexits(ulong *arg)
{
	char *status;
	char *inval = "invalid exit string";
	char buf[ERRMAX];

	status = (char*)arg[0];
	if(status){
		if(waserror())
			status = inval;
		else{
			validaddr((ulong)status, 1, 0);
			if(vmemchr(status, 0, ERRMAX) == 0){
				memmove(buf, status, ERRMAX);
				buf[ERRMAX-1] = 0;
				status = buf;
			}
			poperror();
		}

	}
	pexit(status, 1);
	return 0;		/* not reached */
}

long
sys_wait(ulong *arg)
{
	int pid;
	Waitmsg w;
	OWaitmsg *ow;

	if(arg[0] == 0)
		return pwait(nil);

	validaddr(arg[0], sizeof(OWaitmsg), 1);
	validalign(arg[0], BY2WD);			/* who cares? */
	pid = pwait(&amp;w);
	if(pid &gt;= 0){
		ow = (OWaitmsg*)arg[0];
		readnum(0, ow-&gt;pid, NUMSIZE, w.pid, NUMSIZE);
		readnum(0, ow-&gt;time+TUser*NUMSIZE, NUMSIZE, w.time[TUser], NUMSIZE);
		readnum(0, ow-&gt;time+TSys*NUMSIZE, NUMSIZE, w.time[TSys], NUMSIZE);
		readnum(0, ow-&gt;time+TReal*NUMSIZE, NUMSIZE, w.time[TReal], NUMSIZE);
		strncpy(ow-&gt;msg, w.msg, sizeof(ow-&gt;msg));
		ow-&gt;msg[sizeof(ow-&gt;msg)-1] = '\0';
	}
	return pid;
}

long
sysawait(ulong *arg)
{
	int i;
	int pid;
	Waitmsg w;
	ulong n;

	n = arg[1];
	validaddr(arg[0], n, 1);
	pid = pwait(&amp;w);
	if(pid &lt; 0)
		return -1;
	i = snprint((char*)arg[0], n, "%d %lud %lud %lud %q",
		w.pid,
		w.time[TUser], w.time[TSys], w.time[TReal],
		w.msg);

	return i;
}

void
werrstr(char *fmt, ...)
{
	va_list va;

	if(up == nil)
		return;

	va_start(va, fmt);
	vseprint(up-&gt;syserrstr, up-&gt;syserrstr+ERRMAX, fmt, va);
	va_end(va);
}

static long
generrstr(char *buf, uint nbuf)
{
	char tmp[ERRMAX];

	if(nbuf == 0)
		error(Ebadarg);
	validaddr((ulong)buf, nbuf, 1);
	if(nbuf &gt; sizeof tmp)
		nbuf = sizeof tmp;
	memmove(tmp, buf, nbuf);

	/* make sure it's NUL-terminated */
	tmp[nbuf-1] = '\0';
	memmove(buf, up-&gt;syserrstr, nbuf);
	buf[nbuf-1] = '\0';
	memmove(up-&gt;syserrstr, tmp, nbuf);
	return 0;
}

long
syserrstr(ulong *arg)
{
	return generrstr((char*)arg[0], arg[1]);
}

/* compatibility for old binaries */
long
sys_errstr(ulong *arg)
{
	return generrstr((char*)arg[0], 64);
}

long
sysnotify(ulong *arg)
{
	if(arg[0] != 0)
		validaddr(arg[0], sizeof(ulong), 0);
	up-&gt;notify = (int(*)(void*, char*))(arg[0]);
	return 0;
}

long
sysnoted(ulong *arg)
{
	if(arg[0]!=NRSTR &amp;&amp; !up-&gt;notified)
		error(Egreg);
	return 0;
}

long
syssegbrk(ulong *arg)
{
	int i;
	ulong addr;
	Segment *s;

	addr = arg[0];
	for(i = 0; i &lt; NSEG; i++) {
		s = up-&gt;seg[i];
		if(s == 0 || addr &lt; s-&gt;base || addr &gt;= s-&gt;top)
			continue;
		switch(s-&gt;type&amp;SG_TYPE) {
		case SG_TEXT:
		case SG_DATA:
		case SG_STACK:
			error(Ebadarg);
		default:
			return ibrk(arg[1], i);
		}
	}

	error(Ebadarg);
	return 0;		/* not reached */
}

long
syssegattach(ulong *arg)
{
	return segattach(up, arg[0], (char*)arg[1], arg[2], arg[3]);
}

long
syssegdetach(ulong *arg)
{
	int i;
	ulong addr;
	Segment *s;

	qlock(&amp;up-&gt;seglock);
	if(waserror()){
		qunlock(&amp;up-&gt;seglock);
		nexterror();
	}

	s = 0;
	addr = arg[0];
	for(i = 0; i &lt; NSEG; i++)
		if(s = up-&gt;seg[i]) {
			qlock(&amp;s-&gt;lk);
			if((addr &gt;= s-&gt;base &amp;&amp; addr &lt; s-&gt;top) ||
			   (s-&gt;top == s-&gt;base &amp;&amp; addr == s-&gt;base))
				goto found;
			qunlock(&amp;s-&gt;lk);
		}

	error(Ebadarg);

found:
	/*
	 * Check we are not detaching the initial stack segment.
	 */
	if(s == up-&gt;seg[SSEG]){
		qunlock(&amp;s-&gt;lk);
		error(Ebadarg);
	}
	up-&gt;seg[i] = 0;
	qunlock(&amp;s-&gt;lk);
	putseg(s);
	qunlock(&amp;up-&gt;seglock);
	poperror();

	/* Ensure we flush any entries from the lost segment */
	flushmmu();
	return 0;
}

long
syssegfree(ulong *arg)
{
	Segment *s;
	ulong from, to;

	from = arg[0];
	s = seg(up, from, 1);
	if(s == nil)
		error(Ebadarg);
	to = (from + arg[1]) &amp; ~(BY2PG-1);
	from = PGROUND(from);

	if(to &gt; s-&gt;top) {
		qunlock(&amp;s-&gt;lk);
		error(Ebadarg);
	}

	mfreeseg(s, from, (to - from) / BY2PG);
	qunlock(&amp;s-&gt;lk);
	flushmmu();

	return 0;
}

/* For binary compatibility */
long
sysbrk_(ulong *arg)
{
	return ibrk(arg[0], BSEG);
}

long
sysrendezvous(ulong *arg)
{
	uintptr tag, val;
	Proc *p, **l;

	tag = arg[0];
	l = &amp;REND(up-&gt;rgrp, tag);
	up-&gt;rendval = ~(uintptr)0;

	lock(up-&gt;rgrp);
	for(p = *l; p; p = p-&gt;rendhash) {
		if(p-&gt;rendtag == tag) {
			*l = p-&gt;rendhash;
			val = p-&gt;rendval;
			p-&gt;rendval = arg[1];

			while(p-&gt;mach != 0)
				;
			ready(p);
			unlock(up-&gt;rgrp);
			return val;
		}
		l = &amp;p-&gt;rendhash;
	}

	/* Going to sleep here */
	up-&gt;rendtag = tag;
	up-&gt;rendval = arg[1];
	up-&gt;rendhash = *l;
	*l = up;
	up-&gt;state = Rendezvous;
	unlock(up-&gt;rgrp);

	sched();

	return up-&gt;rendval;
}

/*
 * The implementation of semaphores is complicated by needing
 * to avoid rescheduling in syssemrelease, so that it is safe
 * to call from real-time processes.  This means syssemrelease
 * cannot acquire any qlocks, only spin locks.
 * 
 * Semacquire and semrelease must both manipulate the semaphore
 * wait list.  Lock-free linked lists only exist in theory, not
 * in practice, so the wait list is protected by a spin lock.
 * 
 * The semaphore value *addr is stored in user memory, so it
 * cannot be read or written while holding spin locks.
 * 
 * Thus, we can access the list only when holding the lock, and
 * we can access the semaphore only when not holding the lock.
 * This makes things interesting.  Note that sleep's condition function
 * is called while holding two locks - r and up-&gt;rlock - so it cannot
 * access the semaphore value either.
 * 
 * An acquirer announces its intention to try for the semaphore
 * by putting a Sema structure onto the wait list and then
 * setting Sema.waiting.  After one last check of semaphore,
 * the acquirer sleeps until Sema.waiting==0.  A releaser of n
 * must wake up n acquirers who have Sema.waiting set.  It does
 * this by clearing Sema.waiting and then calling wakeup.
 * 
 * There are three interesting races here.  
 
 * The first is that in this particular sleep/wakeup usage, a single
 * wakeup can rouse a process from two consecutive sleeps!  
 * The ordering is:
 * 
 * 	(a) set Sema.waiting = 1
 * 	(a) call sleep
 * 	(b) set Sema.waiting = 0
 * 	(a) check Sema.waiting inside sleep, return w/o sleeping
 * 	(a) try for semaphore, fail
 * 	(a) set Sema.waiting = 1
 * 	(a) call sleep
 * 	(b) call wakeup(a)
 * 	(a) wake up again
 * 
 * This is okay - semacquire will just go around the loop
 * again.  It does mean that at the top of the for(;;) loop in
 * semacquire, phore.waiting might already be set to 1.
 * 
 * The second is that a releaser might wake an acquirer who is
 * interrupted before he can acquire the lock.  Since
 * release(n) issues only n wakeup calls -- only n can be used
 * anyway -- if the interrupted process is not going to use his
 * wakeup call he must pass it on to another acquirer.
 * 
 * The third race is similar to the second but more subtle.  An
 * acquirer sets waiting=1 and then does a final canacquire()
 * before going to sleep.  The opposite order would result in
 * missing wakeups that happen between canacquire and
 * waiting=1.  (In fact, the whole point of Sema.waiting is to
 * avoid missing wakeups between canacquire() and sleep().) But
 * there can be spurious wakeups between a successful
 * canacquire() and the following semdequeue().  This wakeup is
 * not useful to the acquirer, since he has already acquired
 * the semaphore.  Like in the previous case, though, the
 * acquirer must pass the wakeup call along.
 * 
 * This is all rather subtle.  The code below has been verified
 * with the spin model /sys/src/9/port/semaphore.p.  The
 * original code anticipated the second race but not the first
 * or third, which were caught only with spin.  The first race
 * is mentioned in /sys/doc/sleep.ps, but I'd forgotten about it.
 * It was lucky that my abstract model of sleep/wakeup still managed
 * to preserve that behavior.
 *
 * I remain slightly concerned about memory coherence
 * outside of locks.  The spin model does not take 
 * queued processor writes into account so we have to
 * think hard.  The only variables accessed outside locks
 * are the semaphore value itself and the boolean flag
 * Sema.waiting.  The value is only accessed with cmpswap,
 * whose job description includes doing the right thing as
 * far as memory coherence across processors.  That leaves
 * Sema.waiting.  To handle it, we call coherence() before each
 * read and after each write.		- rsc
 */

/* Add semaphore p with addr a to list in seg. */
static void
semqueue(Segment *s, long *a, Sema *p)
{
	memset(p, 0, sizeof *p);
	p-&gt;addr = a;
	lock(&amp;s-&gt;sema);	/* uses s-&gt;sema.Rendez.Lock, but no one else is */
	p-&gt;next = &amp;s-&gt;sema;
	p-&gt;prev = s-&gt;sema.prev;
	p-&gt;next-&gt;prev = p;
	p-&gt;prev-&gt;next = p;
	unlock(&amp;s-&gt;sema);
}

/* Remove semaphore p from list in seg. */
static void
semdequeue(Segment *s, Sema *p)
{
	lock(&amp;s-&gt;sema);
	p-&gt;next-&gt;prev = p-&gt;prev;
	p-&gt;prev-&gt;next = p-&gt;next;
	unlock(&amp;s-&gt;sema);
}

/* Wake up n waiters with addr a on list in seg. */
static void
semwakeup(Segment *s, long *a, long n)
{
	Sema *p;
	
	lock(&amp;s-&gt;sema);
	for(p=s-&gt;sema.next; p!=&amp;s-&gt;sema &amp;&amp; n&gt;0; p=p-&gt;next){
		if(p-&gt;addr == a &amp;&amp; p-&gt;waiting){
			p-&gt;waiting = 0;
			coherence();
			wakeup(p);
			n--;
		}
	}
	unlock(&amp;s-&gt;sema);
}

/* Add delta to semaphore and wake up waiters as appropriate. */
static long
semrelease(Segment *s, long *addr, long delta)
{
	long value;

	do
		value = *addr;
	while(!cmpswap(addr, value, value+delta));
	semwakeup(s, addr, delta);
	return value+delta;
}

/* Try to acquire semaphore using compare-and-swap */
static int
canacquire(long *addr)
{
	long value;
	
	while((value=*addr) &gt; 0)
		if(cmpswap(addr, value, value-1))
			return 1;
	return 0;
}		

/* Should we wake up? */
static int
semawoke(void *p)
{
	coherence();
	return !((Sema*)p)-&gt;waiting;
}

/* Acquire semaphore (subtract 1). */
static int
semacquire(Segment *s, long *addr, int block)
{
	int acquired;
	Sema phore;

	if(canacquire(addr))
		return 1;
	if(!block)
		return 0;

	acquired = 0;
	semqueue(s, addr, &amp;phore);
	for(;;){
		phore.waiting = 1;
		coherence();
		if(canacquire(addr)){
			acquired = 1;
			break;
		}
		if(waserror())
			break;
		sleep(&amp;phore, semawoke, &amp;phore);
		poperror();
	}
	semdequeue(s, &amp;phore);
	coherence();	/* not strictly necessary due to lock in semdequeue */
	if(!phore.waiting)
		semwakeup(s, addr, 1);
	if(!acquired)
		nexterror();
	return 1;
}

/* Acquire semaphore or time-out */
static int
tsemacquire(Segment *s, long *addr, ulong ms)
{
	int acquired, timedout;
	ulong t, elms;
	Sema phore;

	if(canacquire(addr))
		return 1;
	if(ms == 0)
		return 0;
	acquired = timedout = 0;
	semqueue(s, addr, &amp;phore);
	for(;;){
		phore.waiting = 1;
		coherence();
		if(canacquire(addr)){
			acquired = 1;
			break;
		}
		if(waserror())
			break;
		t = m-&gt;ticks;
		tsleep(&amp;phore, semawoke, &amp;phore, ms);
		elms = TK2MS(m-&gt;ticks - t);
		poperror();
		if(elms &gt;= ms){
			timedout = 1;
			break;
		}
		ms -= elms;
	}
	semdequeue(s, &amp;phore);
	coherence();	/* not strictly necessary due to lock in semdequeue */
	if(!phore.waiting)
		semwakeup(s, addr, 1);
	if(timedout)
		return 0;
	if(!acquired)
		nexterror();
	return 1;
}

long
syssemacquire(ulong *arg)
{
	int block;
	long *addr;
	Segment *s;

	validaddr(arg[0], sizeof(long), 1);
	validalign(arg[0], sizeof(long));
	addr = (long*)arg[0];
	block = arg[1];
	
	if((s = seg(up, (ulong)addr, 0)) == nil)
		error(Ebadarg);
	if(*addr &lt; 0)
		error(Ebadarg);
	return semacquire(s, addr, block);
}

long
systsemacquire(ulong *arg)
{
	long *addr;
	ulong ms;
	Segment *s;

	validaddr(arg[0], sizeof(long), 1);
	validalign(arg[0], sizeof(long));
	addr = (long*)arg[0];
	ms = arg[1];

	if((s = seg(up, (ulong)addr, 0)) == nil)
		error(Ebadarg);
	if(*addr &lt; 0)
		error(Ebadarg);
	return tsemacquire(s, addr, ms);
}

long
syssemrelease(ulong *arg)
{
	long *addr, delta;
	Segment *s;

	validaddr(arg[0], sizeof(long), 1);
	validalign(arg[0], sizeof(long));
	addr = (long*)arg[0];
	delta = arg[1];

	if((s = seg(up, (ulong)addr, 0)) == nil)
		error(Ebadarg);
	/* delta == 0 is a no-op, not a release */
	if(delta &lt; 0 || *addr &lt; 0)
		error(Ebadarg);
	return semrelease(s, addr, delta);
}

long
sysnsec(ulong *arg)
{
	validaddr(arg[0], sizeof(vlong), 1);
	validalign(arg[0], sizeof(vlong));

	*(vlong*)arg[0] = todget(nil);

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

