<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/etherfcc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/etherfcc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * FCCn ethernet
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "imm.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"
#include "../ppc/ethermii.h"

#define DBG 1

enum {
	Nrdre		= 128,			/* receive descriptor ring entries */
	Ntdre		= 128,			/* transmit descriptor ring entries */

	Rbsize		= ETHERMAXTU+4,		/* ring buffer size (+4 for CRC) */
	Bufsize		= Rbsize+CACHELINESZ,	/* extra room for alignment */
};

enum {

	/* ether-specific Rx BD bits */
	RxMiss=		SBIT(7),
	RxeLG=		SBIT(10),
	RxeNO=		SBIT(11),
	RxeSH=		SBIT(12),
	RxeCR=		SBIT(13),
	RxeOV=		SBIT(14),
	RxeCL=		SBIT(15),
	RxError=	(RxeLG|RxeNO|RxeSH|RxeCR|RxeOV|RxeCL),	/* various error flags */

	/* ether-specific Tx BD bits */
	TxPad=		SBIT(1),	/* pad short frames */
	TxTC=		SBIT(5),	/* transmit CRC */
	TxeDEF=		SBIT(6),
	TxeHB=		SBIT(7),
	TxeLC=		SBIT(8),
	TxeRL=		SBIT(9),
	TxeUN=		SBIT(14),
	TxeCSL=		SBIT(15),

	/* psmr */
	CRCE=		BIT(24),	/* Ethernet CRC */
	FCE=		BIT(10),	/* flow control */
	PRO=		BIT(9),		/* promiscuous mode */
	FDE=		BIT(5),		/* full duplex ethernet */
	LPB=		BIT(3),		/* local protect bit */

	/* gfmr */
	ENET=		0xc,		/* ethernet mode */
	ENT=		BIT(27),
	ENR=		BIT(26),
	TCI=		BIT(2),

	/* FCC function code register */
	GBL=		0x20,
	BO=		0x18,
	EB=		0x10,		/* Motorola byte order */
	TC2=		0x04,
	DTB=		0x02,
	BDB=		0x01,

	/* FCC Event/Mask bits */
	GRA=		SBIT(8),
	RXC=		SBIT(9),
	TXC=		SBIT(10),
	TXE=		SBIT(11),
	RXF=		SBIT(12),
	BSY=		SBIT(13),
	TXB=		SBIT(14),
	RXB=		SBIT(15),
};

enum {		/* Mcr */
	MDIread	=	0x60020000,	/* read opcode */
	MDIwrite =	0x50020000,	/* write opcode */
};

typedef struct Etherparam Etherparam;
struct Etherparam {
/*0x00*/	FCCparam;
/*0x3c*/	ulong	stat_buf;
/*0x40*/	ulong	cam_ptr;
/*0x44*/	ulong	cmask;
/*0x48*/	ulong	cpres;
/*0x4c*/	ulong	crcec;
/*0x50*/	ulong	alec;
/*0x54*/	ulong	disfc;
/*0x58*/	ushort	retlim;
/*0x5a*/	ushort	retcnt;
/*0x5c*/	ushort	p_per;
/*0x5e*/	ushort	boff_cnt;
/*0x60*/	ulong	gaddr[2];
/*0x68*/	ushort	tfcstat;
/*0x6a*/	ushort	tfclen;
/*0x6c*/	ulong	tfcptr;
/*0x70*/	ushort	mflr;
/*0x72*/	ushort	paddr[3];
/*0x78*/	ushort	ibd_cnt;
/*0x7a*/	ushort	ibd_start;
/*0x7c*/	ushort	ibd_end;
/*0x7e*/	ushort	tx_len;
/*0x80*/	uchar	ibd_base[32];
/*0xa0*/	ulong	iaddr[2];
/*0xa8*/	ushort	minflr;
/*0xaa*/	ushort	taddr[3];
/*0xb0*/	ushort	padptr;
/*0xb2*/	ushort	Rsvdb2;
/*0xb4*/	ushort	cf_range;
/*0xb6*/	ushort	max_b;
/*0xb8*/	ushort	maxd1;
/*0xba*/	ushort	maxd2;
/*0xbc*/	ushort	maxd;
/*0xbe*/	ushort	dma_cnt;
/*0xc0*/	ulong	octc;
/*0xc4*/	ulong	colc;
/*0xc8*/	ulong	broc;
/*0xcc*/	ulong	mulc;
/*0xd0*/	ulong	uspc;
/*0xd4*/	ulong	frgc;
/*0xd8*/	ulong	ospc;
/*0xdc*/	ulong	jbrc;
/*0xe0*/	ulong	p64c;
/*0xe4*/	ulong	p65c;
/*0xe8*/	ulong	p128c;
/*0xec*/	ulong	p256c;
/*0xf0*/	ulong	p512c;
/*0xf4*/	ulong	p1024c;
/*0xf8*/	ulong	cam_buf;
/*0xfc*/	ulong	Rsvdfc;
/*0x100*/
};

typedef struct Ctlr Ctlr;
struct Ctlr {
	Lock;
	int	fccid;
	int	port;
	ulong	pmdio;
	ulong	pmdck;
	int	init;
	int	active;
	int	duplex;		/* 1 == full */
	FCC*	fcc;

	Ring;
	Block*	rcvbufs[Nrdre];
	Mii*	mii;
	Timer;

	ulong	interrupts;	/* statistics */
	ulong	deferred;
	ulong	heartbeat;
	ulong	latecoll;
	ulong	retrylim;
	ulong	underrun;
	ulong	overrun;
	ulong	carrierlost;
	ulong	retrycount;
};

static	int	fccirq[] = {0x20, 0x21, 0x22};
static	int	fccid[] = {FCC1ID, FCC2ID, FCC3ID};

#ifdef DBG
ulong fccrhisto[16];
ulong fccthisto[16];
ulong fccrthisto[16];
ulong fcctrhisto[16];
ulong ehisto[0x80];
#endif

static int fccmiimir(Mii*, int, int);
static int fccmiimiw(Mii*, int, int, int);
static void fccltimer(Ureg*, Timer*);

static void
attach(Ether *ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	ctlr-&gt;active = 1;
	ctlr-&gt;fcc-&gt;gfmr |= ENR|ENT;
	iunlock(ctlr);
	ctlr-&gt;tmode = Tperiodic;
	ctlr-&gt;tf = fccltimer;
	ctlr-&gt;ta = ether;
	ctlr-&gt;tns = 5000000000LL;	/* 5 seconds */
	timeradd(ctlr);
}

static void
closed(Ether *ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	ctlr-&gt;active = 0;
	ctlr-&gt;fcc-&gt;gfmr &amp;= ~(ENR|ENT);
	iunlock(ctlr);
	print("Ether closed\n");
}

static void
promiscuous(void* arg, int on)
{
	Ether *ether;
	Ctlr *ctlr;

	ether = (Ether*)arg;
	ctlr = ether-&gt;ctlr;

	ilock(ctlr);
	if(on || ether-&gt;nmaddr)
		ctlr-&gt;fcc-&gt;fpsmr |= PRO;
	else
		ctlr-&gt;fcc-&gt;fpsmr &amp;= ~PRO;
	iunlock(ctlr);
}

static void
multicast(void* arg, uchar *addr, int on)
{
	Ether *ether;
	Ctlr *ctlr;

	USED(addr, on);	/* if on, could SetGroupAddress; if !on, it's hard */

	ether = (Ether*)arg;
	ctlr = ether-&gt;ctlr;

	ilock(ctlr);
	if(ether-&gt;prom || ether-&gt;nmaddr)
		ctlr-&gt;fcc-&gt;fpsmr |= PRO;
	else
		ctlr-&gt;fcc-&gt;fpsmr &amp;= ~PRO;
	iunlock(ctlr);
}

static void
txstart(Ether *ether)
{
	int len;
	Ctlr *ctlr;
	Block *b;
	BD *dre;

	ctlr = ether-&gt;ctlr;
	if(ctlr-&gt;init)
		return;
	while(ctlr-&gt;ntq &lt; Ntdre-1){
		b = qget(ether-&gt;oq);
		if(b == 0)
			break;

		dre = &amp;ctlr-&gt;tdr[ctlr-&gt;tdrh];
		dczap(dre, sizeof(BD));
		if(dre-&gt;status &amp; BDReady)
			panic("ether: txstart");

		/*
		 * Give ownership of the descriptor to the chip, increment the
		 * software ring descriptor pointer and tell the chip to poll.
		 */
		len = BLEN(b);
		if(ctlr-&gt;txb[ctlr-&gt;tdrh] != nil)
			panic("fcc/ether: txstart");
		ctlr-&gt;txb[ctlr-&gt;tdrh] = b;
		if((ulong)b-&gt;rp&amp;1)
			panic("fcc/ether: txstart align");	/* TO DO: ensure alignment */
		dre-&gt;addr = PADDR(b-&gt;rp);
		dre-&gt;length = len;
		dcflush(b-&gt;rp, len);
		dcflush(dre, sizeof(BD));
		dre-&gt;status = (dre-&gt;status &amp; BDWrap) | BDReady|TxPad|BDInt|BDLast|TxTC;
		dcflush(dre, sizeof(BD));
/*		ctlr-&gt;fcc-&gt;ftodr = 1&lt;&lt;15;	/* transmit now; Don't do this according to errata */
		ctlr-&gt;ntq++;
		ctlr-&gt;tdrh = NEXT(ctlr-&gt;tdrh, Ntdre);
	}
}

static void
transmit(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	txstart(ether);
	iunlock(ctlr);
}

static void
interrupt(Ureg*, void *arg)
{
	int len, status, rcvd, xmtd, restart;
	ushort events;
	Ctlr *ctlr;
	BD *dre;
	Block *b, *nb;
	Ether *ether = arg;

	ctlr = ether-&gt;ctlr;
	if(!ctlr-&gt;active)
		return;	/* not ours */

	/*
	 * Acknowledge all interrupts and whine about those that shouldn't
	 * happen.
	 */
	events = ctlr-&gt;fcc-&gt;fcce;
	ctlr-&gt;fcc-&gt;fcce = events;		/* clear events */

#ifdef DBG
	ehisto[events &amp; 0x7f]++;
#endif

	ctlr-&gt;interrupts++;

	if(events &amp; BSY)
		ctlr-&gt;overrun++;
	if(events &amp; TXE)
		ether-&gt;oerrs++;

#ifdef DBG
	rcvd = xmtd = 0;
#endif
	/*
	 * Receiver interrupt: run round the descriptor ring logging
	 * errors and passing valid receive data up to the higher levels
	 * until we encounter a descriptor still owned by the chip.
	 */
	if(events &amp; RXF){
		dre = &amp;ctlr-&gt;rdr[ctlr-&gt;rdrx];
		dczap(dre, sizeof(BD));
		while(((status = dre-&gt;status) &amp; BDEmpty) == 0){
			rcvd++;
			if(status &amp; RxError || (status &amp; (BDFirst|BDLast)) != (BDFirst|BDLast)){
				if(status &amp; (RxeLG|RxeSH))
					ether-&gt;buffs++;
				if(status &amp; RxeNO)
					ether-&gt;frames++;
				if(status &amp; RxeCR)
					ether-&gt;crcs++;
				if(status &amp; RxeOV)
					ether-&gt;overflows++;
				print("eth rx: %ux\n", status);
			}else{
				/*
				 * We have a packet. Read it in.
				 */
				len = dre-&gt;length-4;
				b = ctlr-&gt;rcvbufs[ctlr-&gt;rdrx];
				assert(dre-&gt;addr == PADDR(b-&gt;rp));
				dczap(b-&gt;rp, len);
				if(nb = iallocb(Bufsize)){
					b-&gt;wp += len;
					etheriq(ether, b, 1);
					b = nb;
					b-&gt;rp = (uchar*)(((ulong)b-&gt;rp + CACHELINESZ-1) &amp; ~(CACHELINESZ-1));
					b-&gt;wp = b-&gt;rp;
					ctlr-&gt;rcvbufs[ctlr-&gt;rdrx] = b;
					ctlr-&gt;rdr[ctlr-&gt;rdrx].addr = PADDR(b-&gt;wp);
				}else
					ether-&gt;soverflows++;
			}

			/*
			 * Finished with this descriptor, reinitialise it,
			 * give it back to the chip, then on to the next...
			 */
			dre-&gt;length = 0;
			dre-&gt;status = (status &amp; BDWrap) | BDEmpty | BDInt;
			dcflush(dre, sizeof(BD));

			ctlr-&gt;rdrx = NEXT(ctlr-&gt;rdrx, Nrdre);
			dre = &amp;ctlr-&gt;rdr[ctlr-&gt;rdrx];
			dczap(dre, sizeof(BD));
		}
	}

	/*
	 * Transmitter interrupt: handle anything queued for a free descriptor.
	 */
	if(events &amp; (TXB|TXE)){
		ilock(ctlr);
		restart = 0;
		while(ctlr-&gt;ntq){
			dre = &amp;ctlr-&gt;tdr[ctlr-&gt;tdri];
			dczap(dre, sizeof(BD));
			status = dre-&gt;status;
			if(status &amp; BDReady)
				break;
			if(status &amp; TxeDEF)
				ctlr-&gt;deferred++;
			if(status &amp; TxeHB)
				ctlr-&gt;heartbeat++;
			if(status &amp; TxeLC)
				ctlr-&gt;latecoll++;
			if(status &amp; TxeRL)
				ctlr-&gt;retrylim++;
			if(status &amp; TxeUN)
				ctlr-&gt;underrun++;
			if(status &amp; TxeCSL)
				ctlr-&gt;carrierlost++;
			if(status &amp; (TxeLC|TxeRL|TxeUN))
				restart = 1;
			ctlr-&gt;retrycount += (status&gt;&gt;2)&amp;0xF;
			b = ctlr-&gt;txb[ctlr-&gt;tdri];
			if(b == nil)
				panic("fcce/interrupt: bufp");
			ctlr-&gt;txb[ctlr-&gt;tdri] = nil;
			freeb(b);
			ctlr-&gt;ntq--;
			ctlr-&gt;tdri = NEXT(ctlr-&gt;tdri, Ntdre);
			xmtd++;
		}

		if(restart){
			ctlr-&gt;fcc-&gt;gfmr &amp;= ~ENT;
			delay(10);
			ctlr-&gt;fcc-&gt;gfmr |= ENT;
			cpmop(RestartTx, ctlr-&gt;fccid, 0xc);
		}
		txstart(ether);
		iunlock(ctlr);
	}
#ifdef DBG
	if(rcvd &gt;= nelem(fccrhisto))
		rcvd = nelem(fccrhisto) - 1;
	if(xmtd &gt;= nelem(fccthisto))
		xmtd = nelem(fccthisto) - 1;
	if(rcvd)
		fcctrhisto[xmtd]++;
	else
		fccthisto[xmtd]++;
	if(xmtd)
		fccrthisto[rcvd]++;
	else
		fccrhisto[rcvd]++;
#endif
}

static long
ifstat(Ether* ether, void* a, long n, ulong offset)
{
	char *p;
	int len, i, r;
	Ctlr *ctlr;
	MiiPhy *phy;

	if(n == 0)
		return 0;

	ctlr = ether-&gt;ctlr;

	p = malloc(READSTR);
	len = snprint(p, READSTR, "interrupts: %lud\n", ctlr-&gt;interrupts);
	len += snprint(p+len, READSTR-len, "carrierlost: %lud\n", ctlr-&gt;carrierlost);
	len += snprint(p+len, READSTR-len, "heartbeat: %lud\n", ctlr-&gt;heartbeat);
	len += snprint(p+len, READSTR-len, "retrylimit: %lud\n", ctlr-&gt;retrylim);
	len += snprint(p+len, READSTR-len, "retrycount: %lud\n", ctlr-&gt;retrycount);
	len += snprint(p+len, READSTR-len, "latecollisions: %lud\n", ctlr-&gt;latecoll);
	len += snprint(p+len, READSTR-len, "rxoverruns: %lud\n", ctlr-&gt;overrun);
	len += snprint(p+len, READSTR-len, "txunderruns: %lud\n", ctlr-&gt;underrun);
	len += snprint(p+len, READSTR-len, "framesdeferred: %lud\n", ctlr-&gt;deferred);
	miistatus(ctlr-&gt;mii);
	phy = ctlr-&gt;mii-&gt;curphy;
	len += snprint(p+len, READSTR-len, "phy: link=%d, tfc=%d, rfc=%d, speed=%d, fd=%d\n",
		phy-&gt;link, phy-&gt;tfc, phy-&gt;rfc, phy-&gt;speed, phy-&gt;fd);

#ifdef DBG
	if(ctlr-&gt;mii != nil &amp;&amp; ctlr-&gt;mii-&gt;curphy != nil){
		len += snprint(p+len, READSTR, "phy:   ");
		for(i = 0; i &lt; NMiiPhyr; i++){
			if(i &amp;&amp; ((i &amp; 0x07) == 0))
				len += snprint(p+len, READSTR-len, "\n       ");
			r = miimir(ctlr-&gt;mii, i);
			len += snprint(p+len, READSTR-len, " %4.4uX", r);
		}
		snprint(p+len, READSTR-len, "\n");
	}
#endif
	snprint(p+len, READSTR-len, "\n");

	n = readstr(offset, a, n, p);
	free(p);

	return n;
}

IMM* imm;

/*
 * This follows the MPC8260 user guide: section28.9's initialisation sequence.
 */
static int
fccsetup(Ctlr *ctlr, FCC *fcc, uchar *ea)
{
	int i;
	Etherparam *p;
	MiiPhy *phy;

	/* Turn Ethernet off */
	fcc-&gt;gfmr &amp;= ~(ENR | ENT);

	ioplock();
	switch(ctlr-&gt;port) {
	default:
		iopunlock();
		return -1;
	case 0:
		/* Step 1 (Section 28.9), write the parallel ports */
		ctlr-&gt;pmdio = 0x01000000;
		ctlr-&gt;pmdck = 0x08000000;
		imm-&gt;port[0].pdir &amp;= ~A1dir0;
		imm-&gt;port[0].pdir |= A1dir1;
		imm-&gt;port[0].psor &amp;= ~A1psor0;
		imm-&gt;port[0].psor |= A1psor1;
		imm-&gt;port[0].ppar |= (A1dir0 | A1dir1);
		/* Step 2, Port C clocks */
		imm-&gt;port[2].psor &amp;= ~0x00000c00;
		imm-&gt;port[2].pdir &amp;= ~0x00000c00;
		imm-&gt;port[2].ppar |= 0x00000c00;
		imm-&gt;port[3].pdat |= (ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		imm-&gt;port[3].podr |= ctlr-&gt;pmdio;
		imm-&gt;port[3].pdir |= (ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		imm-&gt;port[3].ppar &amp;= ~(ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		eieio();
		/* Step 3, Serial Interface clock routing */
		imm-&gt;cmxfcr &amp;= ~0xff000000;	/* Clock mask */
		imm-&gt;cmxfcr |= 0x37000000;	/* Clock route */
		break;

	case 1:
		/* Step 1 (Section 28.9), write the parallel ports */
		ctlr-&gt;pmdio = 0x00400000;
		ctlr-&gt;pmdck = 0x00200000;
		imm-&gt;port[1].pdir &amp;= ~B2dir0;
		imm-&gt;port[1].pdir |= B2dir1;
		imm-&gt;port[1].psor &amp;= ~B2psor0;
		imm-&gt;port[1].psor |= B2psor1;
		imm-&gt;port[1].ppar |= (B2dir0 | B2dir1);
		/* Step 2, Port C clocks */
		imm-&gt;port[2].psor &amp;= ~0x00003000;
		imm-&gt;port[2].pdir &amp;= ~0x00003000;
		imm-&gt;port[2].ppar |= 0x00003000;

		imm-&gt;port[2].pdat |= (ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		imm-&gt;port[2].podr |= ctlr-&gt;pmdio;
		imm-&gt;port[2].pdir |= (ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		imm-&gt;port[2].ppar &amp;= ~(ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		eieio();
		/* Step 3, Serial Interface clock routing */
		imm-&gt;cmxfcr &amp;= ~0x00ff0000;
		imm-&gt;cmxfcr |= 0x00250000;
		break;

	case 2:
		/* Step 1 (Section 28.9), write the parallel ports */
		imm-&gt;port[1].pdir &amp;= ~B3dir0;
		imm-&gt;port[1].pdir |= B3dir1;
		imm-&gt;port[1].psor &amp;= ~B3psor0;
		imm-&gt;port[1].psor |= B3psor1;
		imm-&gt;port[1].ppar |= (B3dir0 | B3dir1);
		/* Step 2, Port C clocks */
		imm-&gt;port[2].psor &amp;= ~0x0000c000;
		imm-&gt;port[2].pdir &amp;= ~0x0000c000;
		imm-&gt;port[2].ppar |= 0x0000c000;
		imm-&gt;port[3].pdat |= (ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		imm-&gt;port[3].podr |= ctlr-&gt;pmdio;
		imm-&gt;port[3].pdir |= (ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		imm-&gt;port[3].ppar &amp;= ~(ctlr-&gt;pmdio | ctlr-&gt;pmdck);
		eieio();
		/* Step 3, Serial Interface clock routing */
		imm-&gt;cmxfcr &amp;= ~0x0000ff00;
		imm-&gt;cmxfcr |= 0x00003700;
		break;
	}
	iopunlock();

	p = (Etherparam*)(m-&gt;immr-&gt;prmfcc + ctlr-&gt;port);
	memset(p, 0, sizeof(Etherparam));

	/* Step 4 */
	fcc-&gt;gfmr |= ENET;

	/* Step 5 */
	fcc-&gt;fpsmr = CRCE | FDE | LPB;	/* full duplex operation */
	ctlr-&gt;duplex = ~0;

	/* Step 6 */
	fcc-&gt;fdsr = 0xd555;

	/* Step 7, initialize parameter ram */
	p-&gt;rbase = PADDR(ctlr-&gt;rdr);
	p-&gt;tbase = PADDR(ctlr-&gt;tdr);
	p-&gt;rstate = (GBL | EB) &lt;&lt; 24;
	p-&gt;tstate = (GBL | EB) &lt;&lt; 24;

	p-&gt;cmask = 0xdebb20e3;
	p-&gt;cpres = 0xffffffff;

	p-&gt;retlim = 15;	/* retry limit */

	p-&gt;mrblr = (Rbsize+0x1f)&amp;~0x1f;		/* multiple of 32 */
	p-&gt;mflr = Rbsize;
	p-&gt;minflr = ETHERMINTU;
	p-&gt;maxd1 = (Rbsize+7) &amp; ~7;
	p-&gt;maxd2 = (Rbsize+7) &amp; ~7;

	for(i=0; i&lt;Eaddrlen; i+=2)
		p-&gt;paddr[2-i/2] = (ea[i+1]&lt;&lt;8)|ea[i];

	/* Step 7, initialize parameter ram, configuration-dependent values */
	p-&gt;riptr = m-&gt;immr-&gt;fccextra[ctlr-&gt;port].ri - (uchar*)IMMR;
	p-&gt;tiptr = m-&gt;immr-&gt;fccextra[ctlr-&gt;port].ti - (uchar*)IMMR;
	p-&gt;padptr = m-&gt;immr-&gt;fccextra[ctlr-&gt;port].pad - (uchar*)IMMR;
	memset(m-&gt;immr-&gt;fccextra[ctlr-&gt;port].pad, 0x88, 0x20);

	/* Step 8, clear out events */
	fcc-&gt;fcce = ~0;

	/* Step 9, Interrupt enable */
	fcc-&gt;fccm = TXE | RXF | TXB;

	/* Step 10, Configure interrupt priority (not done here) */
	/* Step 11, Clear out current events */
	/* Step 12, Enable interrupts to the CP interrupt controller */

	/* Step 13, Issue the Init Tx and Rx command, specifying 0xc for ethernet*/
	cpmop(InitRxTx, fccid[ctlr-&gt;port], 0xc);

	/* Step 14, Link management */
	if((ctlr-&gt;mii = malloc(sizeof(Mii))) == nil)
		return -1;
	ctlr-&gt;mii-&gt;mir = fccmiimir;
	ctlr-&gt;mii-&gt;miw = fccmiimiw;
	ctlr-&gt;mii-&gt;ctlr = ctlr;

	if(mii(ctlr-&gt;mii, ~0) == 0 || (phy = ctlr-&gt;mii-&gt;curphy) == nil){
		free(ctlr-&gt;mii);
		ctlr-&gt;mii = nil;
		return -1;
	}
	miiane(ctlr-&gt;mii, ~0, ~0, ~0);
#ifdef DBG
	print("oui=%X, phyno=%d, ", phy-&gt;oui, phy-&gt;phyno);
	print("anar=%ux, ", phy-&gt;anar);
	print("fc=%ux, ", phy-&gt;fc);
	print("mscr=%ux, ", phy-&gt;mscr);

	print("link=%ux, ", phy-&gt;link);
	print("speed=%ux, ", phy-&gt;speed);
	print("fd=%ux, ", phy-&gt;fd);
	print("rfc=%ux, ", phy-&gt;rfc);
	print("tfc=%ux\n", phy-&gt;tfc);
#endif
	/* Step 15, Enable ethernet: done at attach time */
	return 0;
}

static int
reset(Ether* ether)
{
	uchar ea[Eaddrlen];
	Ctlr *ctlr;
	FCC *fcc;
	Block *b;
	int i;

	if(m-&gt;cpuhz &lt; 24000000){
		print("%s ether: system speed must be &gt;= 24MHz for ether use\n", ether-&gt;type);
		return -1;
	}

	if(ether-&gt;port &gt; 3){
		print("%s ether: no FCC port %ld\n", ether-&gt;type, ether-&gt;port);
		return -1;
	}
	ether-&gt;irq = fccirq[ether-&gt;port];
	ether-&gt;tbdf = BusPPC;
	fcc = imm-&gt;fcc + ether-&gt;port;

	ctlr = malloc(sizeof(*ctlr));
	ether-&gt;ctlr = ctlr;
	memset(ctlr, 0, sizeof(*ctlr));
	ctlr-&gt;fcc = fcc;
	ctlr-&gt;port = ether-&gt;port;
	ctlr-&gt;fccid = fccid[ether-&gt;port];

	/* Ioringinit will allocate the buffer descriptors in normal memory
	 * and NOT in Dual-Ported Ram, as prescribed by the MPC8260
	 * PowerQUICC II manual (Section 28.6).  When they are allocated
	 * in DPram and the Dcache is enabled, the processor will hang
	 */
	if(ioringinit(ctlr, Nrdre, Ntdre, 0) &lt; 0)
		panic("etherfcc init");
	for(i = 0; i &lt; Nrdre; i++){
		b = iallocb(Bufsize);
		b-&gt;rp = (uchar*)(((ulong)b-&gt;rp + CACHELINESZ-1) &amp; ~(CACHELINESZ-1));
		b-&gt;wp = b-&gt;rp;
		ctlr-&gt;rcvbufs[i] = b;
		ctlr-&gt;rdr[i].addr = PADDR(b-&gt;wp);
	}

	fccsetup(ctlr, fcc, ether-&gt;ea);

	ether-&gt;mbps = 100;	/* TO DO: could be 10mbps */
	ether-&gt;attach = attach;
	ether-&gt;transmit = transmit;
	ether-&gt;interrupt = interrupt;
	ether-&gt;ifstat = ifstat;

	ether-&gt;arg = ether;
	ether-&gt;promiscuous = promiscuous;
	ether-&gt;multicast = multicast;

	/*
	 * Until we know where to find it, insist that the plan9.ini
	 * entry holds the Ethernet address.
	 */
	memset(ea, 0, Eaddrlen);
	if(memcmp(ea, ether-&gt;ea, Eaddrlen) == 0){
		print("no ether address");
		return -1;
	}

	return 0;
}

void
etherfcclink(void)
{
	addethercard("fcc", reset);
}

static void
nanodelay(void)
{
	static int count;
	int i;

	for(i = 0; i &lt; 500; i++)
		count++;
	return;
}

static
void miiwriteloop(Ctlr *ctlr, Port *port, int cnt, ulong cmd)
{
	int i;

	for(i = 0; i &lt; cnt; i++){
		port-&gt;pdat &amp;= ~ctlr-&gt;pmdck;
		if(cmd &amp; BIT(i))
			port-&gt;pdat |= ctlr-&gt;pmdio;
		else
			port-&gt;pdat &amp;= ~ctlr-&gt;pmdio;
		nanodelay();
		port-&gt;pdat |= ctlr-&gt;pmdck;
		nanodelay();
	}
}

static int
fccmiimiw(Mii *mii, int pa, int ra, int data)
{
	int x;
	Port *port;
	ulong cmd;
	Ctlr *ctlr;

	/*
	 * MII Management Interface Write.
	 */

	ctlr = mii-&gt;ctlr;
	port = imm-&gt;port + 3;
	cmd = MDIwrite | (pa&lt;&lt;(5+2+16))| (ra&lt;&lt;(2+16)) | (data &amp; 0xffff);

	x = splhi();

	port-&gt;pdir |= (ctlr-&gt;pmdio|ctlr-&gt;pmdck);
	nanodelay();

	miiwriteloop(ctlr, port, 32, ~0);
	miiwriteloop(ctlr, port, 32, cmd);

	port-&gt;pdir |= (ctlr-&gt;pmdio|ctlr-&gt;pmdck);
	nanodelay();

	miiwriteloop(ctlr, port, 32, ~0);

	splx(x);
	return 1;
}

static int
fccmiimir(Mii *mii, int pa, int ra)
{
	int data, i, x;
	Port *port;
	ulong cmd;
	Ctlr *ctlr;

	ctlr = mii-&gt;ctlr;
	port = imm-&gt;port + 3;

	cmd = MDIread | pa&lt;&lt;(5+2+16) | ra&lt;&lt;(2+16);

	x = splhi();
	port-&gt;pdir |= (ctlr-&gt;pmdio|ctlr-&gt;pmdck);
	nanodelay();

	miiwriteloop(ctlr, port, 32, ~0);

	/* Clock out the first 14 MS bits of the command */
	miiwriteloop(ctlr, port, 14, cmd);

	/* Turn-around */
	port-&gt;pdat &amp;= ~ctlr-&gt;pmdck;
	port-&gt;pdir &amp;= ~ctlr-&gt;pmdio;
	nanodelay();

	/* For read, clock in 18 bits, use 16 */
	data = 0;
	for(i=0; i&lt;18; i++){
		data &lt;&lt;= 1;
		if(port-&gt;pdat &amp; ctlr-&gt;pmdio)
			data |= 1;
		port-&gt;pdat |= ctlr-&gt;pmdck;
		nanodelay();
		port-&gt;pdat &amp;= ~ctlr-&gt;pmdck;
		nanodelay();
	}
	port-&gt;pdir |= (ctlr-&gt;pmdio|ctlr-&gt;pmdck);
	nanodelay();
	miiwriteloop(ctlr, port, 32, ~0);
	splx(x);
	return data &amp; 0xffff;
}

static void
fccltimer(Ureg*, Timer *t)
{
	Ether *ether;
	Ctlr *ctlr;
	MiiPhy *phy;
	ulong gfmr;

	ether = t-&gt;ta;
	ctlr = ether-&gt;ctlr;
	if(ctlr-&gt;mii == nil || ctlr-&gt;mii-&gt;curphy == nil)
		return;
	phy = ctlr-&gt;mii-&gt;curphy;
	if(miistatus(ctlr-&gt;mii) &lt; 0){
		print("miistatus failed\n");
		return;
	}
	if(phy-&gt;link == 0){
		print("link lost\n");
		return;
	}
	ether-&gt;mbps = phy-&gt;speed;

	if(phy-&gt;fd != ctlr-&gt;duplex)
		print("set duplex\n");
	ilock(ctlr);
	gfmr = ctlr-&gt;fcc-&gt;gfmr;
	if(phy-&gt;fd != ctlr-&gt;duplex){
		ctlr-&gt;fcc-&gt;gfmr &amp;= ~(ENR|ENT);
		if(phy-&gt;fd)
			ctlr-&gt;fcc-&gt;fpsmr |= FDE | LPB;		/* full duplex operation */
		else
			ctlr-&gt;fcc-&gt;fpsmr &amp;= ~(FDE | LPB);	/* half duplex operation */
		ctlr-&gt;duplex = phy-&gt;fd;
	}
	ctlr-&gt;fcc-&gt;gfmr = gfmr;
	iunlock(ctlr);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

