<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/saturntimer.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/saturntimer.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "msaturn.h"

enum {
	Timer_ctrl = Saturn + 0x0106,
	Timer0_load = Saturn + 0x0200,
	Timer0_cnt = Saturn + 0x0204,
	Timer1_load = Saturn + 0x0300,
	Timer1_cnt = Saturn + 0x0304,
	
	T0_event = RBIT(13, ushort),
	T0_ie = RBIT(14, ushort),
	T0_cen = RBIT(15, ushort),
	T1_event = RBIT(5, ushort),
	T1_ie = RBIT(6, ushort),
	T1_cen = RBIT(7, ushort),
};

static ulong ticks;
static Lock tlock;
static ushort timer_ctl;

ulong multiplier;

ulong
µs(void)
{
	uvlong x;

	if(multiplier == 0){
		multiplier = (uvlong)(1000000LL &lt;&lt; 16) / m-&gt;cyclefreq;
		print("µs: multiplier %ld, cyclefreq %lld, shifter %d\n", multiplier, m-&gt;cyclefreq, 16);
	}
	cycles(&amp;x);
	return (x*multiplier) &gt;&gt; 16;
}

void
saturntimerintr(Ureg *u, void*)
{
	ushort ctl = *(ushort*)Timer_ctrl, v = 0;

	if(ctl&amp;T1_event){
		v = T1_event;
		ticks++;
	}
		
	*(ushort*)Timer_ctrl = timer_ctl|T0_event|v;
	intack();
	timerintr(u, 0);
}

void
timerinit(void)
{
	*(ushort*)Timer_ctrl = 0;
	*(ulong*)Timer0_load = m-&gt;bushz  / HZ;
	*(ulong*)Timer0_cnt = m-&gt;bushz / HZ;
	*(ulong*)Timer1_load = m-&gt;bushz;
	*(ulong*)Timer1_cnt = m-&gt;bushz;

	intrenable(Vectimer0, saturntimerintr, nil, "timer");

	timer_ctl = T0_cen|T0_ie|T1_cen;
	*(ushort*)Timer_ctrl = timer_ctl;
}

uvlong
fastticks(uvlong *hz)
{
	assert(*(ushort*)Timer_ctrl&amp;T1_cen);
	if(*(ushort*)Timer_ctrl&amp;T1_event){
		*(ushort*)Timer_ctrl = timer_ctl|T1_event;
		ticks++;
	}
		
	if (hz)
		*hz = m-&gt;bushz;

	return (uvlong)ticks*m-&gt;bushz+(uvlong)(m-&gt;bushz-*(ulong*)Timer1_cnt);
}

void
timerset(Tval next)
{
	ulong offset;
	uvlong now;

	ilock(&amp;tlock);
	*(ushort*)Timer_ctrl = T1_cen;

	now = fastticks(nil);
	offset = next - now;
	if((long)offset &lt; 10000)
		offset = 10000;
	else if(offset &gt; m-&gt;bushz)
		offset = m-&gt;bushz;

	*(ulong*)Timer0_cnt = offset;
	*(ushort*)Timer_ctrl = timer_ctl;
	assert(*(ushort*)Timer_ctrl &amp; T1_cen);
	iunlock(&amp;tlock);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

