<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/uartsaturn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/uartsaturn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "msaturn.h"

enum{
	UartAoffs = Saturn + 0x0a00,
	UartBoffs = Saturn + 0x0b00,
	Nuart = 2,

	Baudfreq = 14745600 / 16,
	Lcr_div = RBIT(1, uchar),
	Lcr_peven = RBIT(3, uchar),
	Lcr_pen = RBIT(4, uchar),
	Lcr_stop = RBIT(5, uchar),
	Lcr_wrdlenmask = RBIT(6, uchar) | RBIT(7, uchar),
	Lcr_wrdlenshift = 0,
	Lsr_tbre = RBIT(2, uchar),	
	Fcr_txreset = RBIT(5, uchar),
	Fcr_rxreset = RBIT(6, uchar),
	Iir_txempty = RBIT(5, uchar),
	Iir_rxfull = RBIT(6, uchar),
	Iir_rxerr = RBIT(7, uchar),
	Ier_rxerr = RBIT(5, uchar),
	Ier_txempty = RBIT(6, uchar),
	Ier_rxfull = RBIT(7, uchar),
	Lsr_rxavail = RBIT(7, uchar),
	Txsize = 16,
	Rxsize = 16,
};

typedef struct Saturnuart Saturnuart;
struct Saturnuart {
	uchar	rxb;
#define txb	rxb
#define dll	rxb
	uchar	ier;			// Interrupt enable, divisor latch
#define dlm	ier
	uchar	iir;			// Interrupt identification, fifo control
#define fcr	iir	
	uchar	lcr;			// Line control register
	uchar	f1;		
	uchar	lsr;			// Line status register
	ushort	f2;
};

typedef struct UartData UartData;
struct UartData {
	int			suno;	/* saturn uart number: 0 or 1 */
	Saturnuart	*su;
	char			*rxbuf;
	char			*txbuf;
	int			initialized;
	int			enabled;
} uartdata[Nuart];

extern PhysUart saturnphysuart;

Uart suart[Nuart] = {
	{
		.name = "SaturnUart1",
		.baud = 19200,
		.bits = 8,
		.stop = 1,
		.parity = 'n',
		.phys = &amp;saturnphysuart,
		.special = 0,
	},
	{
		.name = "SaturnUart2",
		.baud = 115200,
		.bits = 8,
		.stop = 1,
		.parity = 'n',
		.phys = &amp;saturnphysuart,
		.special = 0,
	},
};

static void suinterrupt(Ureg*, void*);

static Uart*
supnp(void)
{
	int i;

	for (i = 0; i &lt; nelem(suart)-1; i++)
		suart[i].next = &amp;suart[i + 1];
	suart[nelem(suart)-1].next=nil;
	return suart;
}

static void
suinit(Uart*uart)
{
	UartData *ud;
	Saturnuart *su;

	ud = uart-&gt;regs;
	su = ud-&gt;su;
	su-&gt;fcr=Fcr_txreset|Fcr_rxreset;
	ud-&gt;initialized=1;
}

static void
suenable(Uart*uart, int ie)
{
	Saturnuart *su;
	UartData *ud;
	int nr;

	nr = uart - suart;
	if (nr &lt; 0 || nr &gt; Nuart)
		panic("No uart %d", nr);
	ud = uartdata + nr;
	ud-&gt;suno = nr;
	su=ud-&gt;su = (Saturnuart*)((nr == 0)? UartAoffs: UartBoffs);
	uart-&gt;regs = ud;

	if(ud-&gt;initialized==0)
		suinit(uart);

	if(!ud-&gt;enabled &amp;&amp; ie){
		intrenable(Vecuart0+nr , suinterrupt, uart, uart-&gt;name);
		su-&gt;ier=Ier_txempty|Ier_rxfull;
		ud-&gt;enabled=1;
	}
}


static long
sustatus(Uart* uart, void* buf, long n, long offset)
{
	Saturnuart *su;
	char p[128];

	su = ((UartData*)uart-&gt;regs)-&gt;su;
	snprint(p, sizeof p, "b%d c%d e%d l%d m0 p%c s%d i1\n"
		"dev(%d) type(%d) framing(%d) overruns(%d)\n",

		uart-&gt;baud,
		uart-&gt;hup_dcd, 
		uart-&gt;hup_dsr,
		Txsize,
		(su-&gt;lcr &amp; Lcr_pen)? ((su-&gt;lcr &amp; Lcr_peven) ? 'e': 'o'): 'n',
		(su-&gt;lcr &amp; Lcr_stop)? 2: 1,

		uart-&gt;dev,
		uart-&gt;type,
		uart-&gt;ferr,
		uart-&gt;oerr);
	n = readstr(offset, buf, n, p);
	free(p);

	return n;
}

static void
sufifo(Uart*, int)
{}

static void
sudtr(Uart*, int)
{}

static void
surts(Uart*, int)
{}

static void
sumodemctl(Uart*, int)
{}

static int
suparity(Uart*uart, int parity)
{
	int lcr;
	Saturnuart *su;

	su = ((UartData*)uart-&gt;regs)-&gt;su;

	lcr = su-&gt;lcr &amp; ~(Lcr_pen|Lcr_peven);

	switch(parity){
	case 'e':
		lcr |= (Lcr_pen|Lcr_peven);
		break;
	case 'o':
		lcr |= Lcr_pen;
		break;
	case 'n':
	default:
		break;
	}

	su-&gt;lcr = lcr;
	uart-&gt;parity = parity;

	return 0;
}

static int
sustop(Uart* uart, int stop)
{
	int lcr;
	Saturnuart *su;

	su = ((UartData*)uart-&gt;regs)-&gt;su;
	lcr = su-&gt;lcr &amp; ~Lcr_stop;

	switch(stop){
	case 1:
		break;
	case 2:
		lcr |= Lcr_stop;
		break;
	default:
		return -1;
	}

	/* Set new value and reenable if device was previously enabled */
	su-&gt;lcr = lcr;
	uart-&gt;stop = stop;

	return 0;
}

static int
subits(Uart*uart, int n)
{	
	Saturnuart *su;
	uchar lcr;

	su = ((UartData*)uart-&gt;regs)-&gt;su;
	if(n&lt;5||n&gt;8)
		return -1;

	lcr = su-&gt;lcr &amp; ~Lcr_wrdlenmask;
	lcr |= (n-5) &lt;&lt; Lcr_wrdlenshift;
	su-&gt;lcr = lcr;
	return 0;
}

static int
subaud(Uart* uart, int baud)
{
	ushort v;
	Saturnuart *su;

	if (uart-&gt;enabled){
		su = ((UartData*)uart-&gt;regs)-&gt;su;
	
		if(baud &lt;= 0)
			return -1;

		v = Baudfreq / baud;
		su-&gt;lcr |= Lcr_div;
		su-&gt;dll = v;
		su-&gt;dlm = v &gt;&gt; 8;
		su-&gt;lcr &amp;= ~Lcr_div;
	}
	uart-&gt;baud = baud;

	return 0;
}

static void
subreak(Uart*, int)
{}

static void
sukick(Uart *uart)
{
	Saturnuart *su;
	int i;

	if(uart-&gt;blocked)
		return;

	su = ((UartData*)uart-&gt;regs)-&gt;su;
	if((su-&gt;iir &amp; Iir_txempty) == 0)
		return;

	for(i = 0; i &lt; Txsize; i++){
		if(uart-&gt;op &gt;= uart-&gt;oe &amp;&amp; uartstageoutput(uart) == 0)
			break;
		su-&gt;txb = *(uart-&gt;op++);
		su-&gt;ier |= Ier_txempty;
		break;
	}
}

static void
suputc(Uart *uart, int c)
{
	Saturnuart *su;

	su = ((UartData*)uart-&gt;regs)-&gt;su;
	while((su-&gt;lsr&amp;Lsr_tbre) == 0)
		;

	su-&gt;txb=c;
	while((su-&gt;lsr&amp;Lsr_tbre) == 0)
			;
}

static int
getchars(Uart *uart, uchar *cbuf)
{
	int nc;
	UartData *ud;
	Saturnuart *su;

	ud = uart-&gt;regs;
	su = ud-&gt;su;

	while((su-&gt;lsr&amp;Lsr_rxavail) == 0)
		;

	*cbuf++ = su-&gt;rxb;
	nc = 1;
	while(su-&gt;lsr&amp;Lsr_rxavail){
		*cbuf++ = su-&gt;rxb;
		nc++;
	}
	return nc;
}

static int
sugetc(Uart *uart)
{
	static uchar buf[128], *p;
	static int cnt;
	char	c;

	if (cnt &lt;= 0) {
		cnt = getchars(uart, buf);
		p = buf;
	}
	c = *p++;
	cnt--;
	return c;
}

static void
suinterrupt(Ureg*, void*u)
{
	Saturnuart *su;
	Uart *uart;
	uchar iir;

	uart = u;
	if (uart == nil)
		panic("uart is nil");
	su = ((UartData*)uart-&gt;regs)-&gt;su;
	iir = su-&gt;iir;
	if(iir&amp;Iir_rxfull)
		while(su-&gt;lsr&amp;Lsr_rxavail)
			uartrecv(uart, su-&gt;rxb);
	if(iir &amp; Iir_txempty){
		su-&gt;ier&amp;=~Ier_txempty;
		uartkick(uart);
	}
	if (iir &amp; Iir_rxerr)
		uart-&gt;oerr++;
	intack();
}

static void
sudisable(Uart* uart)
{
	Saturnuart *su;

	su = ((UartData*)uart-&gt;regs)-&gt;su;
	su-&gt;ier&amp;=~(Ier_txempty|Ier_rxfull);
}

PhysUart saturnphysuart = {
	.name		= "su",
	.pnp			= supnp,
	.enable		= suenable,
	.disable		= sudisable,
	.kick			= sukick,
	.dobreak		= subreak,
	.baud		= subaud,
	.bits			= subits,
	.stop			= sustop,
	.parity		= suparity,
	.modemctl	= sumodemctl,
	.rts			= surts,
	.dtr			= sudtr,
	.status		= sustatus,
	.fifo			= sufifo,
	.getc			= sugetc,
	.putc			= suputc,
};

void
console(void)
{
	Uart *uart;
	int n;
	char *cmd, *p;

	if((p = getconf("console")) == nil)
		return;
	n = strtoul(p, &amp;cmd, 0);
	if(p == cmd)
		return;
	if(n &lt; 0 || n &gt;= nelem(suart))
		return;

	uart = suart + n;

/*	uartctl(uart, "b115200 l8 pn s1"); */
	if(*cmd != '\0')
		uartctl(uart, cmd);
	(*uart-&gt;phys-&gt;enable)(uart, 0);

	consuart = uart;
	uart-&gt;console = 1;
} 

Saturnuart*uart = (Saturnuart*)UartAoffs;

void
dbgputc(int c)
{
	while((uart-&gt;lsr&amp;Lsr_tbre) == 0)
		;

	uart-&gt;txb=c;
	while((uart-&gt;lsr&amp;Lsr_tbre) == 0)
			;
}

void
dbgputs(char*s)
{
	while(*s)
		dbgputc(*s++);
}

void
dbgputx(ulong x)
{
	int i;
	char c;

	for(i=0; i &lt; sizeof(ulong) * 2; i++){
		c = ((x &gt;&gt; (28 - i * 4))) &amp; 0xf;
		if(c &gt;= 0 &amp;&amp; c &lt;= 9)
			c += '0';
		else
			c += 'a' - 10;

		while((uart-&gt;lsr&amp;Lsr_tbre) == 0)
			;

		uart-&gt;txb=c;
	}
	while((uart-&gt;lsr&amp;Lsr_tbre) == 0)
			;

	uart-&gt;txb='\n';
	while((uart-&gt;lsr&amp;Lsr_tbre) == 0)
			;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

