<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/rb/devether.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/rb/devether.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Atheros 71xx ethernets for rb450g.
 *
 * all 5 PHYs are accessible only through first ether's register space.
 *
 * TODO:
 *	promiscuous mode.
 *	make ether1 work: probably needs mii/phy initialisation,
 *	maybe needs 8316 switch code too (which requires mdio, phy, etc. glop).
 * to maybe do some day:
 *	dig mac addresses out &amp; config phy/mii via spi or other grot and swill
 *	(instead of editing rb config file).
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/netif.h"
#include	"etherif.h"
#include	"ethermii.h"
#include	&lt;pool.h&gt;

enum {
	Ntd	= 64,
	Nrd	= 256,
	Nrb	= 1024,

	Bufalign= 4,
	Rbsz	= ETHERMAXTU + 4,	/* 4 for CRC */
};

extern uchar arge0mac[Eaddrlen];	/* see rb config file */
extern uchar arge1mac[Eaddrlen];

typedef struct Arge Arge;
typedef struct Ctlr Ctlr;
typedef struct Desc Desc;
typedef struct Etherif Etherif;

/*
 *  device registers
 */
struct Arge {
	ulong	cfg1;
	ulong	cfg2;
	ulong	ifg;
	ulong	hduplex;
	ulong	maxframelen;
	uchar	_pad0[0x20 - 0x14];

	ulong	miicfg;
	ulong	miicmd;
	ulong	miiaddr;
	ulong	miictl;
	ulong	miists;
	ulong	miiindic;

	ulong	ifctl;
	ulong	_pad1;
	ulong	staaddr1;
	ulong	staaddr2;

	ulong	fifocfg[3];
	ulong	fifotxthresh;
	ulong	fiforxfiltmatch;
	ulong	fiforxfiltmask;
	ulong	fiforam[7];
	uchar	_pad2[0x180 - 0x7c];

	/* dma */
	ulong	txctl;
	ulong	txdesc;
	ulong	txsts;
	ulong	rxctl;
	ulong	rxdesc;
	ulong	rxsts;
	ulong	dmaintr;
	ulong	dmaintrsts;
};

enum {
	Cfg1softrst		= 1 &lt;&lt; 31,
	Cfg1simulrst		= 1 &lt;&lt; 30,
	Cfg1macrxblkrst		= 1 &lt;&lt; 19,
	Cfg1mactxblkrst		= 1 &lt;&lt; 18,
	Cfg1rxfuncrst		= 1 &lt;&lt; 17,
	Cfg1txfuncrst		= 1 &lt;&lt; 16,
	Cfg1loopback		= 1 &lt;&lt;  8,
	Cfg1rxflowctl		= 1 &lt;&lt;  5,
	Cfg1txflowctl		= 1 &lt;&lt;  4,
	Cfg1syncrx		= 1 &lt;&lt;  3,
	Cfg1rxen		= 1 &lt;&lt;  2,
	Cfg1synctx		= 1 &lt;&lt;  1,
	Cfg1txen		= 1 &lt;&lt;  0,

	Cfg2preamblelenmask	= 0xf,
	Cfg2preamblelenshift	= 12,
	Cfg2ifmode1000		= 2 &lt;&lt; 8,
	Cfg2ifmode10_100	= 1 &lt;&lt; 8,
	Cfg2ifmodeshift		= 8,
	Cfg2ifmodemask		= 3,
	Cfg2hugeframe		= 1 &lt;&lt; 5,
	Cfg2lenfield		= 1 &lt;&lt; 4,
	Cfg2enpadcrc		= 1 &lt;&lt; 2,
	Cfg2encrc		= 1 &lt;&lt; 1,
	Cfg2fdx			= 1 &lt;&lt; 0,

	Miicfgrst		= 1 &lt;&lt; 31,
	Miicfgscanautoinc	= 1 &lt;&lt;  5,
	Miicfgpreamblesup	= 1 &lt;&lt;  4,
	Miicfgclkselmask	= 0x7,
	Miicfgclkdiv4		= 0,
	Miicfgclkdiv6		= 2,
	Miicfgclkdiv8		= 3,
	Miicfgclkdiv10		= 4,
	Miicfgclkdiv14		= 5,
	Miicfgclkdiv20		= 6,
	Miicfgclkdiv28		= 7,

	Miicmdscancycle		= 1 &lt;&lt; 1,
	Miicmdread		= 1,
	Miicmdwrite		= 0,

	Miiphyaddrshift		= 8,
	Miiphyaddrmask		= 0xff,
	Miiregmask		= 0x1f,

	Miictlmask		= 0xffff,

	Miistsmask		= 0xffff,

	Miiindicinvalid		= 1 &lt;&lt; 2,
	Miiindicscanning	= 1 &lt;&lt; 1,
	Miiindicbusy		= 1 &lt;&lt; 0,

	Ifctlspeed		= 1 &lt;&lt; 16,

	Fifocfg0txfabric	= 1 &lt;&lt; 4,
	Fifocfg0txsys		= 1 &lt;&lt; 3,
	Fifocfg0rxfabric	= 1 &lt;&lt; 2,
	Fifocfg0rxsys		= 1 &lt;&lt; 1,
	Fifocfg0watermark	= 1 &lt;&lt; 0,
	Fifocfg0all		= MASK(5),
	Fifocfg0enshift		= 8,

	/*
	 * these flags applicable both to filter mask and to filter match.
	 * `Ff' is for `fifo filter'.
	 */
	Ffunicast		= 1 &lt;&lt; 17,
	Fftruncframe		= 1 &lt;&lt; 16,
	Ffvlantag		= 1 &lt;&lt; 15,
	Ffunsupopcode		= 1 &lt;&lt; 14,
	Ffpauseframe		= 1 &lt;&lt; 13,
	Ffctlframe		= 1 &lt;&lt; 12,
	Fflongevent		= 1 &lt;&lt; 11,
	Ffdribblenibble		= 1 &lt;&lt; 10,
	Ffbcast			= 1 &lt;&lt;  9,
	Ffmcast			= 1 &lt;&lt;  8,
	Ffok			= 1 &lt;&lt;  7,
	Ffoorange		= 1 &lt;&lt;  6,
	Fflenmsmtch		= 1 &lt;&lt;  5,
	Ffcrcerr		= 1 &lt;&lt;  4,
	Ffcodeerr		= 1 &lt;&lt;  3,
	Fffalsecarrier		= 1 &lt;&lt;  2,
	Ffrxdvevent		= 1 &lt;&lt;  1,
	Ffdropevent		= 1 &lt;&lt;  0,
	/*
	 * exclude unicast and truncated frames from matching.
	 */
	Ffmatchdflt = Ffvlantag | Ffunsupopcode | Ffpauseframe | Ffctlframe |
		Fflongevent | Ffdribblenibble | Ffbcast | Ffmcast | Ffok |
		Ffoorange | Fflenmsmtch | Ffcrcerr | Ffcodeerr |
		Fffalsecarrier | Ffrxdvevent | Ffdropevent,

	/* `Frm' is for `fifo receive mask'. */
	Frmbytemode		= 1 &lt;&lt; 19,
	Frmnoshortframe		= 1 &lt;&lt; 18,
	Frmbit17		= 1 &lt;&lt; 17,
	Frmbit16		= 1 &lt;&lt; 16,
	Frmtruncframe		= 1 &lt;&lt; 15,
	Frmlongevent		= 1 &lt;&lt; 14,
	Frmvlantag		= 1 &lt;&lt; 13,
	Frmunsupopcode		= 1 &lt;&lt; 12,
	Frmpauseframe		= 1 &lt;&lt; 11,
	Frmctlframe		= 1 &lt;&lt; 10,
	Frmdribblenibble	= 1 &lt;&lt;  9,
	Frmbcast		= 1 &lt;&lt;  8,
	Frmmcast		= 1 &lt;&lt;  7,
	Frmok			= 1 &lt;&lt;  6,
	Frmoorange		= 1 &lt;&lt;  5,
	Frmlenmsmtch		= 1 &lt;&lt;  4,
	Frmcodeerr		= 1 &lt;&lt;  3,
	Frmfalsecarrier		= 1 &lt;&lt;  2,
	Frmrxdvevent		= 1 &lt;&lt;  1,
	Frmdropevent		= 1 &lt;&lt;  0,
	/*
	 *  len. mismatch, unsupp. opcode and short frame bits excluded
	 */
	Ffmaskdflt = Frmnoshortframe | Frmbit17 | Frmbit16 | Frmtruncframe |
		Frmlongevent | Frmvlantag | Frmpauseframe | Frmctlframe |
		Frmdribblenibble | Frmbcast | Frmmcast | Frmok | Frmoorange |
		Frmcodeerr | Frmfalsecarrier | Frmrxdvevent | Frmdropevent,

	Dmatxctlen	= 1 &lt;&lt; 0,

	/* dma tx status */
	Txpcountmask	= 0xff,
	Txpcountshift	= 16,
	Txbuserr	= 1 &lt;&lt; 3,
	Txunderrun	= 1 &lt;&lt; 1,
	Txpktsent	= 1 &lt;&lt; 0,

	Dmarxctlen	= 1 &lt;&lt; 0,

	/* dma rx status */
	Rxpcountmask	= 0xff,
	Rxpcountshift	= 16,
	Rxbuserr	= 1 &lt;&lt; 3,
	Rxovflo		= 1 &lt;&lt; 2,
	Rxpktrcvd	= 1 &lt;&lt; 0,

	/* dmaintr &amp; dmaintrsts bits */
	Dmarxbuserr	= 1 &lt;&lt; 7,
	Dmarxovflo	= 1 &lt;&lt; 6,
	Dmarxpktrcvd	= 1 &lt;&lt; 4,
	Dmatxbuserr	= 1 &lt;&lt; 3,
	Dmatxunderrun	= 1 &lt;&lt; 1,
	Dmatxpktsent	= 1 &lt;&lt; 0,
	/* we don't really need most tx interrupts */
	Dmaall		= Dmarxbuserr | Dmarxovflo | Dmarxpktrcvd | Dmatxbuserr,

	Spictlremapdisable	= 1 &lt;&lt; 6,
	Spictlclkdividermask	= MASK(6),

	Spiioctlcs2		= 1 &lt;&lt; 18,
	Spiioctlcs1		= 1 &lt;&lt; 17,
	Spiioctlcs0		= 1 &lt;&lt; 16,
	Spiioctlcsmask		= 7 &lt;&lt; 16,
	Spiioctlclk		= 1 &lt;&lt; 8,
	Spiioctldo		= 1,
};

struct Spi {			/* at 0x1f000000 */
	ulong	fs;
	ulong	ctl;
	ulong	ioctl;
	ulong	rds;
};

/* hw descriptors of buffer rings (rx and tx), need to be uncached */
struct Desc {
	ulong	addr;		/* of packet buffer */
	ulong	ctl;
	Desc	*next;
	ulong	_pad;
};

enum {
	Descempty	= 1 &lt;&lt; 31,
	Descmore	= 1 &lt;&lt; 24,
	Descszmask	= MASK(12),
};
#define DMASIZE(len)	((len) &amp; Descszmask)

struct Ctlr {
	Arge	*regs;
	Ether*	edev;			/* backward pointer */

	Lock;				/* attach */
	int	init;
	int	attached;

	Mii*	mii;
	Rendez	lrendez;
	int	lim;
	int	link;
	int	phymask;

	/* receiver */
	Rendez	rrendez;
	uint	rintr;			/* count */
	int	pktstoread;		/* flag */
	int	discard;
	/* rx descriptors */
	Desc*	rdba;			/* base address */
	Block**	rd;
	uint	rdh;			/* head */
	uint	rdt;			/* tail */
	uint	nrdfree;		/* rd's awaiting pkts (sort of) */

	/* transmitter */
	Rendez	trendez;
	uint	tintr;			/* count */
	int	pktstosend;		/* flag */
	int	ntq;
	/* tx descriptors */
	Desc*	tdba;			/* base address */
	Block**	td;
	uint	tdh;			/* head */
	uint	tdt;			/* tail */
};

struct Etherif {
	uintptr	regs;
	int	irq;
	uchar	*mac;
	int	phymask;
};

static Etherif etherifs[] = {
	{ 0x1a000000, ILenet0, arge0mac, 1&lt;&lt;4 },
	{ 0x19000000, ILenet1, arge1mac, MASK(4) },
};

static Ether *etherxx[MaxEther];
static Lock athrblock;		/* free receive Blocks */
static Block* athrbpool;	/* receive Blocks for all ath controllers */

static void	athrbfree(Block* bp);

/*
 * ar8316 ether switch
 */

enum {
	Swrgmii	= 0,
	Swgmii	= 1,
	Swphy4cpu = 0, /* flag: port 4 connected to CPU (not internal switch) */
};

typedef struct Switch Switch;
struct Switch {
	int	page;
	int	scdev;
};

enum {
	/* atheros-specific mii registers */
	Miiathdbgaddr	= 0x1d,
	Miiathdbgdata	= 0x1e,

	Swregmask	= 0,
		Swmaskrevmask	= 0x00ff,
		Swmaskvermask	= 0xff00,
		Swmaskvershift	= 8,
		Swmasksoftreset	= 1 &lt;&lt; 31,

	Swregmode	= 8,
		Swdir615uboot	= 0x8d1003e0,
		/* from ubiquiti rspro */
		Swrgmiiport4iso	= 0x81461bea,
		Swrgmiiport4sw	= 0x01261be2,
		/* avm fritz!box 7390 */
		Swgmiiavm	= 0x010e5b71,

		Swmac0gmiien	= 1 &lt;&lt;  0,
		Swmac0rgmiien	= 1 &lt;&lt;  1,
		Swphy4gmiien	= 1 &lt;&lt;  2,
		Swphy4rgmiien	= 1 &lt;&lt;  3,
		Swmac0macmode	= 1 &lt;&lt;  4,
		Swrgmiirxclkdelayen= 1 &lt;&lt;  6,
		Swrgmiitxclkdelayen= 1 &lt;&lt;  7,
		Swmac5macmode	= 1 &lt;&lt; 14,
		Swmac5phymode	= 1 &lt;&lt; 15,
		Swtxdelays0	= 1 &lt;&lt; 21,
		Swtxdelays1	= 1 &lt;&lt; 22,
		Swrxdelays0	= 1 &lt;&lt; 23,
		Swledopenen	= 1 &lt;&lt; 24,
		Swspien		= 1 &lt;&lt; 25,
		Swrxdelays1	= 1 &lt;&lt; 26,
		Swpoweronsel	= 1 &lt;&lt; 31,

	Swregfloodmask	= 0x2c,
		Swfloodmaskbcast2cpu= 1 &lt;&lt; 26,

	Swregglobal	= 0x30,
		Swglobalmtumask	= 0x7fff,
};

#ifdef NOTYET
void *
devicegetparent(int)
{
	static int glop;

	return &amp;glop;
}

static void
arswsplitsetpage(int dev, ulong addr, ushort *phy, ushort *reg)
{
	static Switch ar8316;
	Switch *sc = &amp;ar8316;
	ushort page;

	page = ((addr) &gt;&gt; 9) &amp; 0xffff;
	*phy = (((addr) &gt;&gt; 6) &amp; 0x7) | 0x10;
	*reg = ((addr) &gt;&gt; 1) &amp; 0x1f;
	MDIOWRREG(devicegetparent(dev), 0x18, 0, page);
	sc-&gt;page = page;
}

/*
 * Read half a register.  Some of the registers define control bits, and
 * the sequence of half-word accesses matters.  The register addresses
 * are word-even (mod 4).
 */
static int
arswrdreg16(int dev, int addr)
{
	ushort phy, reg;

	arswsplitsetpage(dev, addr, &amp;phy, &amp;reg);
	return MDIORDREG(devicegetparent(dev), phy, reg);
}

void
arswwritedbg(int dev, int phy, ushort dbgaddr, ushort dbgdata)
{
	MDIOWRREG(devicegetparent(dev), phy, Miiathdbgaddr, dbgaddr);
	MDIOWRREG(devicegetparent(dev), phy, Miiathdbgdata, dbgdata);
}

/*
 * Write half a register
 */
static inline int
arswwrreg16(int dev, int addr, int data)
{
	ushort phy, reg;

	arswsplitsetpage(dev, addr, &amp;phy, &amp;reg);
	return MDIOWRREG(devicegetparent(dev), phy, reg, data);
}

/* arsw??reglsb routines operate on lower 16 bits; *msb on upper ones */

int
arswrdreg(int dev, int addr)
{
	return arswrdreglsb(dev, addr) | arswrdregmsb(dev, addr);
}

int
arswwrreg(int dev, int addr, int value)
{
	arswwrreglsb(dev, addr, value);		/* XXX check this write too? */
	return arswwrregmsb(dev, addr, value);
}

int
arswmodifyreg(int dev, int addr, int mask, int set)
{
	return arswwrreg(dev, addr, (arswrdreg(dev, addr) &amp; ~mask) | set);
}

/*
 * initialise the switch
 */
static int
ar8316init(Switch *sc)
{
	if (Swrgmii &amp;&amp; Swphy4cpu) {
		arswwrreg(sc-&gt;scdev, Swregmode, Swrgmiiport4iso);
		iprint("ar8316: MAC port == RGMII, port 4 = dedicated PHY\n");
	} else if (Swrgmii) {
		arswwrreg(sc-&gt;scdev, Swregmode, Swrgmiiport4sw);
		iprint("ar8316: MAC port == RGMII, port 4 = switch port\n");
	} else if (Swgmii) {
		arswwrreg(sc-&gt;scdev, Swregmode, Swgmiiavm);
		iprint("ar8316: MAC port == GMII\n");
	} else {
		iprint("ar8316: unknown switch PHY config\n");
		return -1;
	}

	delay(1);			/* wait for things to settle */

	if (Swrgmii &amp;&amp; Swphy4cpu) {
		iprint("ar8316: port 4 RGMII hack\n");

		/* work around for phy4 rgmii mode */
		arswwritedbg(sc-&gt;scdev, 4, 0x12, 0x480c);
		arswwritedbg(sc-&gt;scdev, 4, 0x0, 0x824e);	/* rx delay */
		arswwritedbg(sc-&gt;scdev, 4, 0x5, 0x3d47);	/* tx delay */
		delay(1);		/* again to let things settle */
	}
	arswwrreg(sc-&gt;scdev, 0x38, 0xc000050e);	/* mystery */

	/*
	 * Flood address table misses to all ports, and enable forwarding of
	 * broadcasts to the cpu port.
	 */
	arswwrreg(sc-&gt;scdev, Swregfloodmask, Swfloodmaskbcast2cpu | 0x003f003f);
	arswmodifyreg(sc-&gt;scdev, Swregglobal, Swglobalmtumask, ETHERMAXTU+8+2);
	return 0;
}
#endif			/* NOTYET */

static long
ifstat(Ether* edev, void* a, long n, ulong offset)
{
	int l, i, r;
	char *p;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	l = 0;
	l += snprint(p+l, READSTR-l, "tintr: %ud\n", ctlr-&gt;tintr);
	l += snprint(p+l, READSTR-l, "rintr: %ud\n", ctlr-&gt;rintr);
	l += snprint(p+l, READSTR-l, "discarded: %ud\n", ctlr-&gt;discard);

	if(ctlr-&gt;mii != nil &amp;&amp; ctlr-&gt;mii-&gt;curphy != nil){
		l += snprint(p+l, READSTR-l, "phy:   ");
		for(i = 0; i &lt; NMiiPhyr; i++){
			if(i &amp;&amp; ((i &amp; 0x07) == 0))
				l += snprint(p+l, READSTR-l, "\n       ");
			r = miimir(ctlr-&gt;mii, i);
			l += snprint(p+l, READSTR-l, " %4.4uX", r);
		}
		snprint(p+l, READSTR-l, "\n");
	}
	n = readstr(offset, a, n, p);
	free(p);

	return n;
}

static void
etherrtrace(Netfile* f, Etherpkt* pkt, int len)
{
	int i, n;
	Block *bp;

	if(qwindow(f-&gt;in) &lt;= 0)
		return;
	if(len &gt; 58)
		n = 58;
	else
		n = len;
	bp = iallocb(64);
	if(bp == nil)
		return;
	memmove(bp-&gt;wp, pkt-&gt;d, n);
	i = TK2MS(MACHP(0)-&gt;ticks);
	bp-&gt;wp[58] = len&gt;&gt;8;
	bp-&gt;wp[59] = len;
	bp-&gt;wp[60] = i&gt;&gt;24;
	bp-&gt;wp[61] = i&gt;&gt;16;
	bp-&gt;wp[62] = i&gt;&gt;8;
	bp-&gt;wp[63] = i;
	bp-&gt;wp += 64;
	qpass(f-&gt;in, bp);
}

Block*
etheriq(Ether* ether, Block* bp, int fromwire)
{
	Etherpkt *pkt;
	ushort type;
	int len, multi, tome, fromme;
	Netfile **ep, *f, **fp, *fx;
	Block *xbp;
	Ctlr *ctlr;

	ether-&gt;inpackets++;
	ctlr = ether-&gt;ctlr;

	pkt = (Etherpkt*)bp-&gt;rp;
	len = BLEN(bp);
	type = (pkt-&gt;type[0]&lt;&lt;8)|pkt-&gt;type[1];
	fx = 0;
	ep = &amp;ether-&gt;f[Ntypes];

	multi = pkt-&gt;d[0] &amp; 1;
	/* check for valid multicast addresses */
	if(multi &amp;&amp; memcmp(pkt-&gt;d, ether-&gt;bcast, sizeof(pkt-&gt;d)) != 0 &amp;&amp;
	    ether-&gt;prom == 0)
		if(!activemulti(ether, pkt-&gt;d, sizeof(pkt-&gt;d))){
			if(fromwire){
				ctlr-&gt;discard++;
				freeb(bp);
				bp = 0;
			}
			return bp;
		}

	/* is it for me? */
	tome   = memcmp(pkt-&gt;d, ether-&gt;ea, sizeof(pkt-&gt;d)) == 0;
	fromme = memcmp(pkt-&gt;s, ether-&gt;ea, sizeof(pkt-&gt;s)) == 0;

	/*
	 * Multiplex the packet to all the connections which want it.
	 * If the packet is not to be used subsequently (fromwire != 0),
	 * attempt to simply pass it into one of the connections, thereby
	 * saving a copy of the data (usual case hopefully).
	 */
	for(fp = ether-&gt;f; fp &lt; ep; fp++)
		if((f = *fp) != nil &amp;&amp; (f-&gt;type == type || f-&gt;type &lt; 0))
		if(tome || multi || f-&gt;prom)
			/* Don't want to hear bridged packets */
			if(f-&gt;bridge &amp;&amp; !fromwire &amp;&amp; !fromme)
				continue;
			else if(f-&gt;headersonly)
				etherrtrace(f, pkt, len);
			else if(fromwire &amp;&amp; fx == 0)
				fx = f;
			else if(xbp = iallocb(len)){
				memmove(xbp-&gt;wp, pkt, len);
				xbp-&gt;wp += len;
				if(qpass(f-&gt;in, xbp) &lt; 0){
					iprint("soverflow for f-&gt;in\n");
					ether-&gt;soverflows++;
				}
			}else{
				iprint("soverflow iallocb\n");
				ether-&gt;soverflows++;
			}
	if(fx){
		if(qpass(fx-&gt;in, bp) &lt; 0){
			iprint("soverflow for fx-&gt;in\n");
			ether-&gt;soverflows++;
		}
		return 0;
	}
	if(fromwire){
		ctlr-&gt;discard++;
		freeb(bp);
		return 0;
	}
	return bp;
}

static void
athhwreset(Ether *ether)
{
	Ctlr *ctlr;
	Arge *arge;

	ctlr = ether-&gt;ctlr;
	if (ctlr == nil)
		return;
	arge = ctlr-&gt;regs;
	if (arge == nil)
		return;

	arge-&gt;dmaintr = 0;

	arge-&gt;rxctl = 0;
	arge-&gt;txctl = 0;
	coherence();

	/*
	 * give tx &amp; rx time to stop, otherwise clearing desc registers
	 * too early will cause random memory corruption.
	 */
	delay(1);

	arge-&gt;rxdesc = 0;
	arge-&gt;txdesc = 0;
	coherence();

	/* clear all interrupts */
	while (arge-&gt;rxsts &amp; Rxpktrcvd)
		arge-&gt;rxsts = Rxpktrcvd;
	while (arge-&gt;txsts &amp; Txpktsent)
		arge-&gt;txsts = Txpktsent;

	/* and errors */
	arge-&gt;rxsts = Rxbuserr | Rxovflo;
	arge-&gt;txsts = Txbuserr | Txunderrun;
}

static void
txreclaim(Ctlr *ctlr)
{
	uint tdh;
	Arge *arge;
	Block *bp;

	arge = ctlr-&gt;regs;
	tdh = ctlr-&gt;tdh;
	while (tdh != ctlr-&gt;tdt &amp;&amp; ctlr-&gt;tdba[tdh].ctl &amp; Descempty){
		arge-&gt;txsts = Txpktsent;

		bp = ctlr-&gt;td[tdh];
		ctlr-&gt;td[tdh] = nil;
		if (bp)
			freeb(bp);

		ctlr-&gt;tdba[tdh].addr = 0;
		ctlr-&gt;ntq--;
		tdh = NEXT(tdh, Ntd);
	}
	ctlr-&gt;tdh = tdh;
}

static Block*
athrballoc(void)
{
	Block *bp;

	ilock(&amp;athrblock);
	if((bp = athrbpool) != nil){
		athrbpool = bp-&gt;next;
		bp-&gt;next = nil;
		_xinc(&amp;bp-&gt;ref);	/* prevent bp from being freed */
	}
	iunlock(&amp;athrblock);
	return bp;
}

static void
athrbfree(Block* bp)
{
	bp-&gt;wp = bp-&gt;rp = bp-&gt;lim - ROUND(Rbsz, BLOCKALIGN);
	bp-&gt;flag &amp;= ~(Bipck | Budpck | Btcpck | Bpktck);

	ilock(&amp;athrblock);
	bp-&gt;next = athrbpool;
	athrbpool = bp;
	iunlock(&amp;athrblock);
}

static void
rxnewbuf(Ctlr *ctlr, int i)
{
	Block *bp;
	Desc *rd;

	if (ctlr-&gt;rd[i] != nil)
		return;
	ctlr-&gt;rd[i] = bp = athrballoc();
	if(bp == nil)
		panic("#l%d: can't allocate receive buffer",
			ctlr-&gt;edev-&gt;ctlrno);
	dcflush(bp-&gt;rp, Rbsz);		/* writeback &amp; invalidate */

	rd = &amp;ctlr-&gt;rdba[i];
	rd-&gt;addr = PADDR(bp-&gt;rp);
	rd-&gt;ctl = Descempty | DMASIZE(Rbsz);
	ctlr-&gt;nrdfree++;
}

static void
rxreclaim(Ctlr *ctlr)
{
	uint rdt;

	rdt = ctlr-&gt;rdt;
	while (rdt != ctlr-&gt;rdh &amp;&amp; !(ctlr-&gt;rdba[rdt].ctl &amp; Descempty)){
		rxnewbuf(ctlr, rdt);
		rdt = NEXT(rdt, Nrd);
	}
	ctlr-&gt;rdt = rdt;
}

static void
etherintr(void *arg)
{
	int sts;
	Arge *arge;
	Ctlr *ctlr;
	Ether *ether;

	ether = arg;
	ctlr = ether-&gt;ctlr;
	arge = ctlr-&gt;regs;
	ilock(ctlr);
	sts = arge-&gt;dmaintrsts;
	if (sts &amp; Dmarxpktrcvd) {
		arge-&gt;dmaintr &amp;= ~Dmarxpktrcvd;
		ctlr-&gt;pktstoread = 1;
		wakeup(&amp;ctlr-&gt;rrendez);
		ctlr-&gt;rintr++;
		sts &amp;= ~Dmarxpktrcvd;
	}
	if (sts &amp; (Dmatxpktsent | Dmatxunderrun)) {
		arge-&gt;dmaintr &amp;= ~(Dmatxpktsent | Dmatxunderrun);
		ctlr-&gt;pktstosend = 1;
		wakeup(&amp;ctlr-&gt;trendez);
		ctlr-&gt;tintr++;
		sts &amp;= ~(Dmatxpktsent | Dmatxunderrun);
	}
	iunlock(ctlr);
	if (sts)
		iprint("#l%d: sts %#ux\n", ether-&gt;ctlrno, sts);
}

static int
pktstoread(void* v)
{
	Ctlr *ctlr = v;

	return ctlr-&gt;pktstoread || !(ctlr-&gt;rdba[ctlr-&gt;rdh].ctl &amp; Descempty);
}

static void
rproc(void* arg)
{
	uint rdh, sz;
	Arge *arge;
	Block *bp;
	Ctlr *ctlr;
	Desc *rd;
	Ether *edev;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	arge = ctlr-&gt;regs;
	for(;;){
		/* wait for next interrupt */
		ilock(ctlr);
		arge-&gt;dmaintr |= Dmarxpktrcvd;
		iunlock(ctlr);

		sleep(&amp;ctlr-&gt;rrendez, pktstoread, ctlr);
		ctlr-&gt;pktstoread = 0;

		rxreclaim(ctlr);
		rdh = ctlr-&gt;rdh;
		for (rd = &amp;ctlr-&gt;rdba[rdh]; !(rd-&gt;ctl &amp; Descempty);
		     rd = &amp;ctlr-&gt;rdba[rdh]){
			bp = ctlr-&gt;rd[rdh];
			assert(bp != nil);
			ctlr-&gt;rd[rdh] = nil;

			/* omit final 4 bytes (crc), pass pkt upstream */
			sz = DMASIZE(rd-&gt;ctl) - 4;
			assert(sz &gt; 0 &amp;&amp; sz &lt;= Rbsz);
			bp-&gt;wp = bp-&gt;rp + sz;
			bp = etheriq(edev, bp, 1);
			assert(bp == nil);		/* Block was consumed */

			arge-&gt;rxsts = Rxpktrcvd;

			ctlr-&gt;nrdfree--;
			rdh = NEXT(rdh, Nrd);
			if(ctlr-&gt;nrdfree &lt; Nrd/2) {
				/* rxreclaim reads ctlr-&gt;rdh */
				ctlr-&gt;rdh = rdh;
				rxreclaim(edev-&gt;ctlr);
			}
		}
		ctlr-&gt;rdh = rdh;
	}
}

static int
pktstosend(void* v)
{
	Ether *edev = v;
	Ctlr *ctlr = edev-&gt;ctlr;

	return ctlr-&gt;pktstosend || ctlr-&gt;ntq &gt; 0 || qlen(edev-&gt;oq) &gt; 0;
}

static void
tproc(void* arg)
{
	uint tdt, added;
	Arge *arge;
	Block *bp;
	Ctlr *ctlr;
	Desc *td;
	Ether *edev;

	edev = arg;
	ctlr = edev-&gt;ctlr;
	arge = ctlr-&gt;regs;
	for(;;){
		/* wait for next free buffer and output queue block */
		sleep(&amp;ctlr-&gt;trendez, pktstosend, edev);
		ctlr-&gt;pktstosend = 0;

		txreclaim(ctlr);

		/* copy as much of my output q as possible into output ring */
		added = 0;
		tdt = ctlr-&gt;tdt;
		while(ctlr-&gt;ntq &lt; Ntd - 1){
			td = &amp;ctlr-&gt;tdba[tdt];
			if (!(td-&gt;ctl &amp; Descempty))
				break;
			bp = qget(edev-&gt;oq);
			if(bp == nil)
				break;

			/* make sure the whole packet is in ram */
			dcflush(bp-&gt;rp, BLEN(bp));

			/*
			 * Give ownership of the descriptor to the chip,
			 * increment the software ring descriptor pointer.
			 */
			ctlr-&gt;td[tdt] = bp;
			td-&gt;addr = PADDR(bp-&gt;rp);
			td-&gt;ctl = DMASIZE(BLEN(bp));
			coherence();

			added++;
			ctlr-&gt;ntq++;
			tdt = NEXT(tdt, Ntd);
		}
		ctlr-&gt;tdt = tdt;
		/*
		 * Underrun turns off TX.  Clear underrun indication.
		 * If there's anything left in the ring, reactivate the tx.
		 */
		if (arge-&gt;dmaintrsts &amp; Dmatxunderrun)
			arge-&gt;txsts = Txunderrun;
		if(1 || added)
			arge-&gt;txctl = Dmatxctlen;	/* kick xmiter */
		ilock(ctlr);
		if(ctlr-&gt;ntq &gt;= Ntd/2)			/* tx ring half-full? */
			arge-&gt;dmaintr |= Dmatxpktsent;
		else if (ctlr-&gt;ntq &gt; 0)
			arge-&gt;dmaintr |= Dmatxunderrun;
		iunlock(ctlr);
		txreclaim(ctlr);
	}
}

/*
 *  turn promiscuous mode on/off
 */
static void
promiscuous(void *ve, int on)
{
	USED(ve, on);
}

static void
multicast(void *ve, uchar*, int on)
{
	USED(ve, on);
}

static void
linkdescs(Desc *base, int ndesc)
{
	int i;

	for(i = 0; i &lt; ndesc - 1; i++)
		base[i].next = (Desc *)PADDR(&amp;base[i+1]);
	base[ndesc - 1].next = (Desc *)PADDR(&amp;base[0]);
}

/*
 * Initialise the receive and transmit buffer rings.
 *
 * This routine is protected by ctlr-&gt;init.
 */
static void
ringinit(Ctlr* ctlr)
{
	int i;
	void *v;

	if(ctlr-&gt;rdba == 0){
		v = xspanalloc(Nrd * sizeof(Desc), CACHELINESZ, 0);
		assert(v);
		ctlr-&gt;rdba = (Desc *)KSEG1ADDR(v);
		ctlr-&gt;rd = xspanalloc(Nrd * sizeof(Block *), 0, 0);
		assert(ctlr-&gt;rd != nil);
		linkdescs(ctlr-&gt;rdba, Nrd);
		for(i = 0; i &lt; Nrd; i++)
			rxnewbuf(ctlr, i);
	}
	ctlr-&gt;rdt = ctlr-&gt;rdh = 0;

	if(ctlr-&gt;tdba == 0) {
		v = xspanalloc(Ntd * sizeof(Desc), CACHELINESZ, 0);
		assert(v);
		ctlr-&gt;tdba = (Desc *)KSEG1ADDR(v);
		ctlr-&gt;td = xspanalloc(Ntd * sizeof(Block *), 0, 0);
		assert(ctlr-&gt;td != nil);
	}
	memset(ctlr-&gt;td, 0, Ntd * sizeof(Block *));

	linkdescs(ctlr-&gt;tdba, Ntd);
	for(i = 0; i &lt; Ntd; i++)
		ctlr-&gt;tdba[i].ctl = Descempty;

	ctlr-&gt;tdh = ctlr-&gt;tdt = 0;
}

static void
cfgmediaduplex(Ether *ether)
{
	Arge *arge, *arge0;
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	arge = ctlr-&gt;regs;
	arge-&gt;cfg2 = (arge-&gt;cfg2 &amp; ~Cfg2ifmode10_100) | Cfg2ifmode1000 | Cfg2fdx;
	arge-&gt;ifctl &amp;= ~Ifctlspeed;
	arge-&gt;fiforxfiltmask |= Frmbytemode;
	arge-&gt;fifotxthresh = 0x008001ff;	/* undocumented magic */

	if (ether-&gt;ctlrno &gt; 0) {
		/* set PLL registers: copy from arge0 */
		arge0 = (Arge *)(KSEG1 | etherifs[0].regs);
		USED(arge0);
	}
}

static void
athmii(Ether *ether, int phymask)
{
	USED(ether, phymask);
}

static void
athcfg(Ether *ether, int phymask)
{
	uchar *eaddr;
	Arge *arge;
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	arge = ctlr-&gt;regs;
	if(ether-&gt;ctlrno &gt; 0){
		if(0){
			/* doing this seems to disable both ethers */
			arge-&gt;cfg1 |= Cfg1softrst;		/* stop */
			delay(20);
			*Reset |= Rstge1mac;
			delay(100);
		}
		*Reset &amp;= ~Rstge1mac;
		delay(200);
	}

	/* configure */
	arge-&gt;cfg1 = Cfg1syncrx | Cfg1rxen | Cfg1synctx | Cfg1txen;
	arge-&gt;cfg2 |= Cfg2enpadcrc | Cfg2lenfield | Cfg2encrc;
	arge-&gt;maxframelen = Rbsz;

	if(ether-&gt;ctlrno &gt; 0){
		arge-&gt;miicfg = Miicfgrst;
		delay(100);
		arge-&gt;miicfg = Miicfgclkdiv28;
		delay(100);
	}

	/*
	 * Set all Ethernet address registers to the same initial values
	 * set all four addresses to 66-88-aa-cc-dd-ee
	 */
	eaddr = ether-&gt;ea;
	arge-&gt;staaddr1 = eaddr[2]&lt;&lt;24 | eaddr[3]&lt;&lt;16 | eaddr[4]&lt;&lt;8  | eaddr[5];
	arge-&gt;staaddr2 = eaddr[0]&lt;&lt; 8 | eaddr[1];

	arge-&gt;fifocfg[0] = Fifocfg0all &lt;&lt; Fifocfg0enshift; /* undocumented magic */
	arge-&gt;fifocfg[1] = 0x0fff0000;	/* undocumented magic */
	arge-&gt;fifocfg[2] = 0x00001fff;	/* undocumented magic */

	arge-&gt;fiforxfiltmatch = Ffmatchdflt;
	arge-&gt;fiforxfiltmask  = Ffmaskdflt;

	/* phy goo */
	athmii(ether, phymask);
	if (ether-&gt;ctlrno &gt; 0)
		cfgmediaduplex(ether);
}

static int
athattach(Ether *ether)
{
	int i;
	char name[32];
	Arge *arge;
	Block *bp;
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	if (ctlr-&gt;attached)
		return -1;
	ilock(ctlr);
	ctlr-&gt;init = 1;
	for(i = 0; i &lt; Nrb; i++){
		if((bp = allocb(Rbsz + Bufalign)) == nil)
			error(Enomem);
		bp-&gt;free = athrbfree;
		freeb(bp);
	}
	ringinit(ctlr);
	ctlr-&gt;init = 0;
	iunlock(ctlr);

	athcfg(ether, ctlr-&gt;phymask);

	/* start */
	arge = ctlr-&gt;regs;
	arge-&gt;txdesc = PADDR(ctlr-&gt;tdba);
	arge-&gt;rxdesc = PADDR(ctlr-&gt;rdba);
	coherence();
	arge-&gt;rxctl = Dmarxctlen;

	snprint(name, KNAMELEN, "#l%drproc", ether-&gt;ctlrno);
	kproc(name, rproc, ether);

	snprint(name, KNAMELEN, "#l%dtproc", ether-&gt;ctlrno);
	kproc(name, tproc, ether);

	ilock(ctlr);
	arge-&gt;dmaintr |= Dmaall;
	iunlock(ctlr);

	ctlr-&gt;attached = 1;
	return 0;
}

/*
 * strategy: RouterBOOT has initialised arge0, try to leave it alone.
 * copy arge0 registers to arge1, with a few exceptions.
 */
static int
athreset(Ether *ether)
{
	Arge *arge;
	Ctlr *ctlr;
	Etherif *ep;

	if (ether-&gt;ctlrno &lt; 0 || ether-&gt;ctlrno &gt;= MaxEther)
		return -1;
	if (ether-&gt;ctlr == nil) {
		/*
		 * Allocate a controller structure and start to initialise it.
		 */
		ether-&gt;ctlr = ctlr = malloc(sizeof(Ctlr));
		if (ctlr == nil)
			return -1;
		ctlr-&gt;edev = ether;
		ep = etherifs + ether-&gt;ctlrno;
		ctlr-&gt;regs = arge = (Arge *)(KSEG1 | ep-&gt;regs);
		ctlr-&gt;phymask = ep-&gt;phymask;

		ether-&gt;port = (uint)arge;
		ether-&gt;irq = ep-&gt;irq;
		memmove(ether-&gt;ea, ep-&gt;mac, Eaddrlen);
		ether-&gt;ifstat = ifstat;
		ether-&gt;promiscuous = promiscuous;
		ether-&gt;multicast = multicast;
		ether-&gt;arg = ether;
	}
	athhwreset(ether);
	return 0;
}

static Ether*
etherprobe(int ctlrno)
{
	int i, lg;
	ulong mb, bsz;
	Ether *ether;
	char buf[128], name[32];

	ether = malloc(sizeof(Ether));
	if(ether == nil)
		error(Enomem);
	memset(ether, 0, sizeof(Ether));
	ether-&gt;ctlrno = ctlrno;
	ether-&gt;tbdf = BUSUNKNOWN;
	ether-&gt;mbps = 1000;
	ether-&gt;minmtu = ETHERMINTU;
	ether-&gt;maxmtu = ETHERMAXTU;
	ether-&gt;mtu = ETHERMAXTU;

	if(ctlrno &gt;= MaxEther || athreset(ether) &lt; 0){
		free(ether);
		return nil;
	}

	snprint(name, sizeof(name), "ether%d", ctlrno);

	/*
	 * If ether-&gt;irq is &lt;0, it is a hack to indicate no interrupt
	 * used by ethersink.
	 * apparently has to be done here and cannot be deferred until attach.
	 */
	if(ether-&gt;irq &gt;= 0)
		intrenable(ether-&gt;irq, etherintr, ether);

	i = sprint(buf, "#l%d: atheros71xx: ", ctlrno);
	if(ether-&gt;mbps &gt;= 1000)
		i += sprint(buf+i, "%dGbps", ether-&gt;mbps/1000);
	else
		i += sprint(buf+i, "%dMbps", ether-&gt;mbps);
	i += sprint(buf+i, " port %#luX irq %d", PADDR(ether-&gt;port), ether-&gt;irq);
	i += sprint(buf+i, ": %2.2ux%2.2ux%2.2ux%2.2ux%2.2ux%2.2ux",
		ether-&gt;ea[0], ether-&gt;ea[1], ether-&gt;ea[2],
		ether-&gt;ea[3], ether-&gt;ea[4], ether-&gt;ea[5]);
	sprint(buf+i, "\n");
	print(buf);

	/*
	 * input queues are allocated by ../port/netif.c:/^openfile.
	 * the size will be the last argument to netifinit() below.
	 *
	 * output queues should be small, to minimise `bufferbloat',
	 * which confuses tcp's feedback loop.  at 1Gb/s, it only takes
	 * ~15µs to transmit a full-sized non-jumbo packet.
	 */

	/* compute log10(ether-&gt;mbps) into lg */
	for(lg = 0, mb = ether-&gt;mbps; mb &gt;= 10; lg++)
		mb /= 10;
	if (lg &gt; 13)			/* sanity cap; 2**(13+16) = 2²⁹ */
		lg = 13;

	/* allocate larger input queues for higher-speed interfaces */
	bsz = 1UL &lt;&lt; (lg + 16);		/* 2ⁱ⁶ = 64K, bsz = 2ⁿ × 64K */
	while (bsz &gt; mainmem-&gt;maxsize / 8 &amp;&amp; bsz &gt; 128*1024)	/* sanity */
		bsz /= 2;
	netifinit(ether, name, Ntypes, bsz);

	if(ether-&gt;oq == nil)
		ether-&gt;oq = qopen(1 &lt;&lt; (lg + 13), Qmsg, 0, 0);
	if(ether-&gt;oq == nil)
		panic("etherreset %s: can't allocate output queue", name);

	ether-&gt;alen = Eaddrlen;
	memmove(ether-&gt;addr, ether-&gt;ea, Eaddrlen);
	memset(ether-&gt;bcast, 0xFF, Eaddrlen);
	return ether;
}

static void
etherreset(void)
{
	int ctlrno;

	for(ctlrno = 0; ctlrno &lt; MaxEther; ctlrno++)
		etherxx[ctlrno] = etherprobe(ctlrno);
}

static void
ethershutdown(void)
{
	Ether *ether;
	int i;

	for(i = 0; i &lt; MaxEther; i++){
		ether = etherxx[i];
		if(ether)
			athhwreset(ether);
	}
}

static Chan *
etherattach(char* spec)
{
	ulong ctlrno;
	char *p;
	Chan *chan;

	ctlrno = 0;
	if(spec &amp;&amp; *spec){
		ctlrno = strtoul(spec, &amp;p, 0);
		if((ctlrno == 0 &amp;&amp; p == spec) || *p || (ctlrno &gt;= MaxEther))
			error(Ebadarg);
	}
	if(etherxx[ctlrno] == 0)
		error(Enodev);

	chan = devattach('l', spec);
	if(waserror()){
		chanfree(chan);
		nexterror();
	}
	chan-&gt;dev = ctlrno;
	athattach(etherxx[ctlrno]);
	poperror();
	return chan;
}

static Walkqid*
etherwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return netifwalk(etherxx[c-&gt;dev], c, nc, name, nname);
}

static Chan*
etheropen(Chan *c, int omode)
{
	return netifopen(etherxx[c-&gt;dev], c, omode);
}

static void
ethercreate(Chan*, char*, int, ulong)
{
}

static void
etherclose(Chan *c)
{
	netifclose(etherxx[c-&gt;dev], c);
}

static long
etherread(Chan *chan, void *buf, long n, vlong off)
{
	Ether *ether;
	ulong offset = off;

	ether = etherxx[chan-&gt;dev];
	if((chan-&gt;qid.type &amp; QTDIR) == 0 &amp;&amp; ether-&gt;ifstat){
		/*
		 * With some controllers it is necessary to reach
		 * into the chip to extract statistics.
		 */
		if(NETTYPE(chan-&gt;qid.path) == Nifstatqid)
			return ether-&gt;ifstat(ether, buf, n, offset);
		else if(NETTYPE(chan-&gt;qid.path) == Nstatqid)
			ether-&gt;ifstat(ether, buf, 0, offset);
	}

	return netifread(ether, chan, buf, n, offset);
}

static Block*
etherbread(Chan *c, long n, ulong offset)
{
	return netifbread(etherxx[c-&gt;dev], c, n, offset);
}

/* kick the transmitter to drain the output ring */
static void
athtransmit(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	ctlr-&gt;pktstosend = 1;
	wakeup(&amp;ctlr-&gt;trendez);
	iunlock(ctlr);
}

static long (*athctl)(Ether *, char *, int) = nil;

static int
etheroq(Ether* ether, Block* bp)
{
	int len, loopback, s;
	Etherpkt *pkt;

	ether-&gt;outpackets++;

	/*
	 * Check if the packet has to be placed back onto the input queue,
	 * i.e. if it's a loopback or broadcast packet or the interface is
	 * in promiscuous mode.
	 * If it's a loopback packet indicate to etheriq that the data isn't
	 * needed and return, etheriq will pass-on or free the block.
	 * To enable bridging to work, only packets that were originated
	 * by this interface are fed back.
	 */
	pkt = (Etherpkt*)bp-&gt;rp;
	len = BLEN(bp);
	loopback = memcmp(pkt-&gt;d, ether-&gt;ea, sizeof(pkt-&gt;d)) == 0;
	if(loopback || memcmp(pkt-&gt;d, ether-&gt;bcast, sizeof(pkt-&gt;d)) == 0 || ether-&gt;prom){
		s = splhi();
		etheriq(ether, bp, 0);
		splx(s);
	}

	if(!loopback){
		if(qfull(ether-&gt;oq))
			print("etheroq: WARNING: ether-&gt;oq full!\n");
		qbwrite(ether-&gt;oq, bp);
		athtransmit(ether);
	} else
		freeb(bp);

	return len;
}

static long
etherwrite(Chan* chan, void* buf, long n, vlong)
{
	Ether *ether;
	Block *bp;
	int nn, onoff;
	Cmdbuf *cb;

	ether = etherxx[chan-&gt;dev];
	if(NETTYPE(chan-&gt;qid.path) != Ndataqid) {
		nn = netifwrite(ether, chan, buf, n);
		if(nn &gt;= 0)
			return nn;
		cb = parsecmd(buf, n);
		if(cb-&gt;f[0] &amp;&amp; strcmp(cb-&gt;f[0], "nonblocking") == 0){
			if(cb-&gt;nf &lt;= 1)
				onoff = 1;
			else
				onoff = atoi(cb-&gt;f[1]);
			qnoblock(ether-&gt;oq, onoff);
			free(cb);
			return n;
		}
		free(cb);
		if(athctl != nil)
			return athctl(ether, buf, n);
		error(Ebadctl);
	}

	assert(ether-&gt;ctlr != nil);
	if(n &gt; ether-&gt;mtu)
		error(Etoobig);
	if(n &lt; ether-&gt;minmtu)
		error(Etoosmall);

	bp = allocb(n);
	if(waserror()){
		freeb(bp);
		nexterror();
	}
	memmove(bp-&gt;rp, buf, n);
	memmove(bp-&gt;rp+Eaddrlen, ether-&gt;ea, Eaddrlen);
	poperror();
	bp-&gt;wp += n;

	return etheroq(ether, bp);
}

static long
etherbwrite(Chan *c, Block *bp, ulong offset)
{
	return devbwrite(c, bp, offset);
}

static int
etherstat(Chan *c, uchar *dp, int n)
{
	return netifstat(etherxx[c-&gt;dev], c, dp, n);
}

static int
etherwstat(Chan *c, uchar *dp, int n)
{
	return netifwstat(etherxx[c-&gt;dev], c, dp, n);
}

Dev etherdevtab = {
	'l',
	"ether",

	etherreset,
	devinit,
	ethershutdown,
	etherattach,
	etherwalk,
	etherstat,
	etheropen,
	ethercreate,
	etherclose,
	etherread,
	etherbread,
	etherwrite,
	etherbwrite,
	devremove,
	etherwstat,
	devpower,
	devconfig,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

