<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/rb/mmu.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/rb/mmu.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"ureg.h"

/*
 *  tlb entry 0 is used only by mmuswitch() to set the current tlb pid.
 *
 *  It is apparently assumed that user tlb entries are not
 *  overwritten during start-up, so ...
 *  During system start-up (before up first becomes non-nil),
 *  Kmap entries start at tlb index 1 and work their way up until
 *  kmapinval() removes them.  They then restart at 1.  As long as there
 *  are few kmap entries they will not pass tlbroff (the WIRED tlb entry
 *  limit) and interfere with user tlb entries.
 *  Once start-up is over, we combine the kernel and user tlb pools into one,
 *  in the hope of making better use of the tlb on systems with small ones.
 *
 *  All invalidations of the tlb are via indexed entries.  The virtual
 *  address used is always 'KZERO | (x&lt;&lt;(PGSHIFT+1) | currentpid' where
 *  'x' is the index into the tlb.  This ensures that the current pid doesn't
 *  change and that no two invalidated entries have matching virtual
 *  addresses just in case SGI/MIPS ever makes a chip that cares (as
 *  they keep threatening).  These entries should never be used in
 *  lookups since accesses to KZERO addresses don't go through the tlb
 *  (actually only true of KSEG0 and KSEG1; KSEG2 and KSEG3 do go
 *  through the tlb).
 */

#define TLBINVAL(x, pid) puttlbx(x, KZERO|((x)&lt;&lt;(PGSHIFT+1))|(pid), 0, 0, PGSZ)

enum {
	Debugswitch	= 0,
	Debughash	= 0,
};

static ulong ktime[8];		/* only for first 8 cpus */

void
tlbinit(void)
{
	int i;

	for(i=0; i&lt;NTLB; i++)
		TLBINVAL(i, 0);
}

Lock	kmaplock;
KMap	kpte[KPTESIZE];
KMap*	kmapfree;

static int minfree = KPTESIZE;
static int lastfree;
static int tlbroff = TLBROFF;

static void
nfree(void)
{
	int i;
	KMap *k;

	i = 0;
	for(k=kmapfree; k; k=k-&gt;next)
		i++;
	if(i&lt;minfree){
		iprint("%d free\n", i);
		minfree = i;
	}
	lastfree = i;
}

void
kmapinit(void)
{
	KMap *k, *klast;

	lock(&amp;kmaplock);
	kmapfree = kpte;
	klast = &amp;kpte[KPTESIZE-1];
	for(k=kpte; k&lt;klast; k++)
		k-&gt;next = k+1;
	k-&gt;next = 0;
	unlock(&amp;kmaplock);

	m-&gt;ktlbnext = TLBOFF;
}

void
kmapdump(void)
{
	int i;

	for(i=0; i&lt;KPTESIZE; i++)
		iprint("%d: %lud pc=%#lux\n", i, kpte[i].ref, kpte[i].pc);
}

static int
putktlb(KMap *k)
{
	int x;
	ulong virt;
	ulong tlbent[3];

	virt = k-&gt;virt &amp; ~BY2PG | TLBPID(tlbvirt());
	x = gettlbp(virt, tlbent);
	if (!m-&gt;paststartup)
		if (up) {			/* startup just ended? */
			tlbroff = 1;
			setwired(tlbroff);	/* share all-but-one entries */
			m-&gt;paststartup = 1;
		} else if (x &lt; 0) {		/* no such entry? use next */
			x = m-&gt;ktlbnext++;
			if(m-&gt;ktlbnext &gt;= tlbroff)
				m-&gt;ktlbnext = TLBOFF;
		}
	if (x &lt; 0)		/* no entry for va? overwrite random one */
		x = puttlb(virt, k-&gt;phys0, k-&gt;phys1);
	else
		puttlbx(x, virt, k-&gt;phys0, k-&gt;phys1, PGSZ);
	m-&gt;ktlbx[x] = 1;
	return x;
}

/*
 *  Arrange that the KMap'd virtual address will hit the same
 *  primary cache line as pg-&gt;va by making bits 14...12 of the
 *  tag the same as virtual address.  These bits are the index
 *  into the primary cache and are checked whenever accessing
 *  the secondary cache through the primary.  Violation causes
 *  a VCE trap.
 */
KMap *
kmap(Page *pg)
{
	int s, printed = 0;
	ulong pte, virt;
	KMap *k;

	s = splhi();
	lock(&amp;kmaplock);

	if(kmapfree == 0) {
retry:
		unlock(&amp;kmaplock);
		kmapinval();		/* try and free some */
		lock(&amp;kmaplock);
		if(kmapfree == 0){
			unlock(&amp;kmaplock);
			splx(s);
			if(printed++ == 0){
			/* using iprint here we get mixed up with other prints */
				print("%d KMAP RETRY %#lux ktime %ld %ld %ld %ld %ld %ld %ld %ld\n",
					m-&gt;machno, getcallerpc(&amp;pg),
					ktime[0], ktime[1], ktime[2], ktime[3],
					ktime[4], ktime[5], ktime[6], ktime[7]);
				delay(200);
			}
			splhi();
			lock(&amp;kmaplock);
			goto retry;
		}
	}

	k = kmapfree;
	kmapfree = k-&gt;next;

	k-&gt;pg = pg;
	/*
	 * One for the allocation,
	 * One for kactive
	 */
	k-&gt;pc = getcallerpc(&amp;pg);
	k-&gt;ref = 2;
	k-&gt;konmach[m-&gt;machno] = m-&gt;kactive;
	m-&gt;kactive = k;

	virt = pg-&gt;va;
	/* bits 14..12 form the secondary-cache virtual index */
	virt &amp;= PIDX;
	virt |= KMAPADDR | ((k-kpte)&lt;&lt;KMAPSHIFT);

	k-&gt;virt = virt;
	pte = PPN(pg-&gt;pa)|PTECACHABILITY|PTEGLOBL|PTEWRITE|PTEVALID;
	if(virt &amp; BY2PG) {
		k-&gt;phys0 = PTEGLOBL | PTECACHABILITY;
		k-&gt;phys1 = pte;
	}
	else {
		k-&gt;phys0 = pte;
		k-&gt;phys1 = PTEGLOBL | PTECACHABILITY;
	}

	putktlb(k);
	unlock(&amp;kmaplock);

	splx(s);
	return k;
}

void
kunmap(KMap *k)
{
	int s;

	s = splhi();
	if(decref(k) == 0) {
		k-&gt;virt = 0;
		k-&gt;phys0 = 0;
		k-&gt;phys1 = 0;
		k-&gt;pg = 0;

		lock(&amp;kmaplock);
		k-&gt;next = kmapfree;
		kmapfree = k;
//nfree();
		unlock(&amp;kmaplock);
	}
	splx(s);
}

void
kfault(Ureg *ur)			/* called from trap() */
{
	ulong index, addr;
	KMap *k, *f;

	addr = ur-&gt;badvaddr;
	index = (addr &amp; ~KSEGM) &gt;&gt; KMAPSHIFT;
	if(index &gt;= KPTESIZE)
		panic("kmapfault: %#lux", addr);

	k = &amp;kpte[index];
	if(k-&gt;virt == 0)
		panic("kmapfault: unmapped %#lux", addr);

	for(f = m-&gt;kactive; f; f = f-&gt;konmach[m-&gt;machno])
		if(f == k)
			break;
	if(f == 0) {
		incref(k);
		k-&gt;konmach[m-&gt;machno] = m-&gt;kactive;
		m-&gt;kactive = k;
	}
	putktlb(k);
}

void
kmapinval(void)
{
	int mno, i, curpid;
	KMap *k, *next;
	uchar *ktlbx;

	if(m-&gt;machno &lt; nelem(ktime))
		ktime[m-&gt;machno] = MACHP(0)-&gt;ticks;
	if(m-&gt;kactive == 0)
		return;

	curpid = PTEPID(TLBPID(tlbvirt()));
	ktlbx = m-&gt;ktlbx;
	for(i = 0; i &lt; NTLB; i++, ktlbx++){
		if(*ktlbx == 0)
			continue;
		TLBINVAL(i, curpid);
		*ktlbx = 0;
	}

	mno = m-&gt;machno;
	for(k = m-&gt;kactive; k; k = next) {
		next = k-&gt;konmach[mno];
		kunmap(k);
	}

	m-&gt;kactive = 0;
	m-&gt;ktlbnext = TLBOFF;
}

struct
{
	ulong	va;
	ulong	pl;
	ulong	ph;
} wired[NWTLB+1];		/* +1 to avoid zero size if NWTLB==0 */
// = {
//	PCIMEM,
//	 (PCIMEM&gt;&gt;6) | PTEUNCACHED|PTEGLOBL|PTEWRITE|PTEVALID,
//	((PCIMEM&gt;&gt;6) | PTEUNCACHED|PTEGLOBL|PTEWRITE|PTEVALID)+(1&lt;&lt;(PGSHIFT-6)),
//};

/*
 * allocate a virtual address corresponding to physical addr and map them.
 * run on cpu 0.
 */
ulong
wiredpte(vlong addr)
{
	int i;
	ulong va;

	for(i = 0; i &lt; NWTLB; i++)
		if(wired[i].va == 0)
			break;
	if(i &gt;= NWTLB)
		panic("wiredpte: not enough wired TLB entries");

	va = WIREDADDR + i*256*MB;
	wired[i].va = va;
	wired[i].pl = (addr &gt;&gt; 6) | PTEUNCACHED|PTEGLOBL|PTEWRITE|PTEVALID;
	wired[i].ph = wired[i].pl + (1&lt;&lt;(PGSHIFT-6));

	puttlbx(i+WTLBOFF, va, wired[i].pl, wired[i].ph, PGSZ256M);
	return va;
}

void
machwire(void)
{
	int i;

	if(m-&gt;machno == 0)
		return;
	for(i = 0; i &lt; NWTLB; i++)
		if(wired[i].va)
			puttlbx(i+WTLBOFF, wired[i].va, wired[i].pl,
				wired[i].ph, PGSZ256M);
}

void
mmuswitch(Proc *p)
{
	int tp;
	static char lasttext[32];

	if(Debugswitch &amp;&amp; !p-&gt;kp){
		if(strncmp(lasttext, p-&gt;text, sizeof lasttext) != 0)
			iprint("[%s]", p-&gt;text);
		strncpy(lasttext, p-&gt;text, sizeof lasttext);
	}

	if(p-&gt;newtlb) {
		memset(p-&gt;pidonmach, 0, sizeof p-&gt;pidonmach);
		p-&gt;newtlb = 0;
	}
	tp = p-&gt;pidonmach[m-&gt;machno];
	if(tp == 0)
		tp = newtlbpid(p);
	puttlbx(0, KZERO|PTEPID(tp), 0, 0, PGSZ);
}

void
mmurelease(Proc *p)
{
	memset(p-&gt;pidonmach, 0, sizeof p-&gt;pidonmach);
}

/*
 * Process must be splhi
 */
int
newtlbpid(Proc *p)
{
	int i, s;
	Proc **h;

	i = m-&gt;lastpid;
	h = m-&gt;pidproc;
	for(s = 0; s &lt; NTLBPID; s++) {
		i++;
		if(i &gt;= NTLBPID)
			i = 1;
		if(h[i] == 0)
			break;
	}

	if(h[i])
		purgetlb(i);
	if(h[i] != 0)
		panic("newtlb");

	m-&gt;pidproc[i] = p;
	p-&gt;pidonmach[m-&gt;machno] = i;
	m-&gt;lastpid = i;

	return i;
}

void
putmmu(ulong tlbvirt, ulong tlbphys, Page *pg)
{
	short tp;
	char *ctl;
	Softtlb *entry;
	int s;

	s = splhi();
	tp = up-&gt;pidonmach[m-&gt;machno];
	if(tp == 0)
		tp = newtlbpid(up);

	tlbvirt |= PTEPID(tp);
	if((tlbphys &amp; PTEALGMASK) != PTEUNCACHED) {
		tlbphys &amp;= ~PTEALGMASK;
		tlbphys |= PTECACHABILITY;
	}

	entry = putstlb(tlbvirt, tlbphys);
	puttlb(entry-&gt;virt, entry-&gt;phys0, entry-&gt;phys1);

	ctl = &amp;pg-&gt;cachectl[m-&gt;machno];
	switch(*ctl) {
	case PG_TXTFLUSH:
		icflush((void*)pg-&gt;va, BY2PG);
		*ctl = PG_NOFLUSH;
		break;
	case PG_DATFLUSH:
		dcflush((void*)pg-&gt;va, BY2PG);
		*ctl = PG_NOFLUSH;
		break;
	case PG_NEWCOL:
		cleancache();		/* Too expensive */
		*ctl = PG_NOFLUSH;
		break;
	}
	splx(s);
}

void
purgetlb(int pid)
{
	int i, mno;
	Proc *sp, **pidproc;
	Softtlb *entry, *etab;

	m-&gt;tlbpurge++;

	/*
	 * find all pid entries that are no longer used by processes
	 */
	mno = m-&gt;machno;
	pidproc = m-&gt;pidproc;
	for(i=1; i&lt;NTLBPID; i++) {
		sp = pidproc[i];
		if(sp &amp;&amp; sp-&gt;pidonmach[mno] != i)
			pidproc[i] = 0;
	}

	/*
	 * shoot down the one we want
	 */
	sp = pidproc[pid];
	if(sp != 0)
		sp-&gt;pidonmach[mno] = 0;
	pidproc[pid] = 0;

	/*
	 * clean out all dead pids from the stlb;
	 */
	entry = m-&gt;stb;
	for(etab = &amp;entry[STLBSIZE]; entry &lt; etab; entry++)
		if(pidproc[TLBPID(entry-&gt;virt)] == 0)
			entry-&gt;virt = 0;

	/*
	 * clean up the hardware
	 */
	for(i=tlbroff; i&lt;NTLB; i++)
		if(pidproc[TLBPID(gettlbvirt(i))] == 0)
			TLBINVAL(i, pid);
}

void
flushmmu(void)
{
	int s;

	s = splhi();
	up-&gt;newtlb = 1;
	mmuswitch(up);
	splx(s);
}

/* tlbvirt also has TLBPID() in its low byte as the asid */
Softtlb*
putstlb(ulong tlbvirt, ulong tlbphys)
{
	int odd;
	Softtlb *entry;

	/* identical calculation in l.s/utlbmiss */
	entry = &amp;m-&gt;stb[stlbhash(tlbvirt)];
	odd = tlbvirt &amp; BY2PG;		/* even/odd bit */
	tlbvirt &amp;= ~BY2PG;		/* zero even/odd bit */
	if(entry-&gt;virt != tlbvirt) {	/* not my entry? overwrite it */
		if(entry-&gt;virt != 0) {
			m-&gt;hashcoll++;
			if (Debughash)
				iprint("putstlb: hash collision: %#lx old virt "
					"%#lux new virt %#lux page %#lux\n",
					entry - m-&gt;stb, entry-&gt;virt, tlbvirt,
					tlbvirt &gt;&gt; (PGSHIFT+1));
		}
		entry-&gt;virt = tlbvirt;
		entry-&gt;phys0 = 0;
		entry-&gt;phys1 = 0;
	}

	if(odd)
		entry-&gt;phys1 = tlbphys;
	else
		entry-&gt;phys0 = tlbphys;

	if(entry-&gt;phys0 == 0 &amp;&amp; entry-&gt;phys1 == 0)
		entry-&gt;virt = 0;

	return entry;
}

void
checkmmu(ulong, ulong)
{
}

void
countpagerefs(ulong*, int)
{
}

/*
 * Return the number of bytes that can be accessed via KADDR(pa).
 * If pa is not a valid argument to KADDR, return 0.
 */
ulong
cankaddr(ulong pa)
{
	if(pa &gt;= KZERO || pa &gt;= MEMSIZE)
		return 0;
	return MEMSIZE - pa;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

