<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/teg2/archtegra.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/teg2/archtegra.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * nvidia tegra 2 architecture-specific stuff
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"
#include "arm.h"

#include "../port/netif.h"
#include "etherif.h"
#include "../port/flashif.h"
#include "../port/usb.h"
#include "../port/portusbehci.h"
#include "usbehci.h"

enum {
	/* hardware limits imposed by register contents or layouts */
	Maxcpus		= 4,
	Maxflowcpus	= 2,

	Debug	= 0,
};

typedef struct Clkrst Clkrst;
typedef struct Diag Diag;
typedef struct Flow Flow;
typedef struct Scu Scu;
typedef struct Power Power;

struct Clkrst {
	ulong	rstsrc;
	ulong	rstdevl;
	ulong	rstdevh;
	ulong	rstdevu;

	ulong	clkoutl;
	ulong	clkouth;
	ulong	clkoutu;

	uchar	_pad0[0x24-0x1c];
	ulong	supcclkdiv;		/* super cclk divider */
	ulong	_pad1;
	ulong	supsclkdiv;		/* super sclk divider */

	uchar	_pad4[0x4c-0x30];
	ulong	clkcpu;

	uchar	_pad1[0xe0-0x50];
	ulong	pllxbase;		/* pllx controls CPU clock speed */
	ulong	pllxmisc;
	ulong	pllebase;		/* plle is dedicated to pcie */
	ulong	pllemisc;

	uchar	_pad2[0x340-0xf0];
	ulong	cpuset;
	ulong	cpuclr;
};

enum {
	/* rstsrc bits */
	Wdcpurst =	1&lt;&lt;0,
	Wdcoprst =	1&lt;&lt;1,
	Wdsysrst =	1&lt;&lt;2,
	Wdsel =		1&lt;&lt;4,		/* tmr1 or tmr2? */
	Wdena =		1&lt;&lt;5,

	/* devl bits */
	Sysreset =	1&lt;&lt;2,

	/* clkcpu bits */
	Cpu1stop =	1&lt;&lt;9,
	Cpu0stop =	1&lt;&lt;8,

	/* cpu* bits */
	Cpu1dbgreset =	1&lt;&lt;13,
	Cpu0dbgreset =	1&lt;&lt;12,
	Cpu1wdreset =	1&lt;&lt;9,
	Cpu0wdreset =	1&lt;&lt;8,
	Cpu1dereset =	1&lt;&lt;5,
	Cpu0dereset =	1&lt;&lt;4,
	Cpu1reset =	1&lt;&lt;1,
	Cpu0reset =	1&lt;&lt;0,
};

struct Power {
	ulong	ctl;			/* mainly for rtc clock signals */
	ulong	secregdis;
	ulong	swrst;

	ulong	wakevmask;
	ulong	waklvl;
	ulong	waksts;
	ulong	swwaksts;

	ulong	dpdpadsovr;		/* deep power down pads override */
	ulong	dpdsample;
	ulong	dpden;

	ulong	gatetimroff;
	ulong	gatetimron;
	ulong	toggle;
	ulong	unclamp;
	ulong	gatests;		/* ro */

	ulong	goodtmr;
	ulong	blinktmr;

	ulong	noiopwr;
	ulong	detect;
	ulong	detlatch;

	ulong	scratch[24];
	ulong	secscratch[6];

	ulong	cpupwrgoodtmr;
	ulong	cpupwrofftmr;

	ulong	pgmask[2];

	ulong	autowaklvl;
	ulong	autowaklvlmask;
	ulong	wakdelay;

	ulong	detval;
	ulong	ddr;
	ulong	usbdebdel;	/* usb de-bounce delay */
	ulong	usbao;
	ulong	cryptoop;
	ulong	pllpwb0ovr;
	ulong	scratch24[42-24+1];
	ulong	boundoutmirr[3];
	ulong	sys33ven;
	ulong	boundoutmirracc;
	ulong	gate;
};

enum {
	/* toggle bits */
	Start	= 1&lt;&lt;8,
	/* partition ids */
	Partpcie= 3,
	Partl2	= 4,
};

struct Scu {
	ulong	ctl;
	ulong	cfg;			/* ro */
	ulong	cpupwrsts;
	ulong	inval;

	uchar	_pad0[0x40-0x10];
	ulong	filtstart;
	ulong	filtend;

	uchar	_pad1[0x50-0x48];
	ulong	accctl;			/* initially 0 */
	ulong	nsaccctl;
};

enum {
	/* ctl bits */
	Scuenable =	1&lt;&lt;0,
	Filter =	1&lt;&lt;1,
	Scuparity =	1&lt;&lt;2,
	Specfill =	1&lt;&lt;3,		/* only for PL310 */
	Allport0 =	1&lt;&lt;4,
	Standby =	1&lt;&lt;5,
	Icstandby =	1&lt;&lt;6,
};

struct Flow {
	ulong	haltcpu0;
	ulong	haltcop;
	ulong	cpu0;
	ulong	cop;
	ulong	xrq;
	ulong	haltcpu1;
	ulong	cpu1;
};

enum {
	/* haltcpu* bits */
	Stop =	2&lt;&lt;29,

	/* cpu* bits */
	Event =			1&lt;&lt;14,	/* w1c */
	Waitwfebitsshift =	4,
	Waitwfebitsmask =	MASK(2),
	Eventenable =		1&lt;&lt;1,
	Cpuenable =		1&lt;&lt;0,
};

struct Diag {
	Cacheline c0;
	Lock;
	long	cnt;
	long	sync;
	Cacheline c1;
};

extern ulong testmem;

/*
 * number of cpus available.  contrast with conf.nmach, which is number
 * of running cpus.
 */
int navailcpus;
Isolated l1ptstable;

Soc soc = {
	.clkrst	= 0x60006000,		/* clock &amp; reset signals */
	.power	= 0x7000e400,
	.exceptvec = PHYSEVP,		/* undocumented magic */
	.sema	= 0x60001000,
	.l2cache= PHYSL2BAG,		/* pl310 bag on the side */
	.flow	= 0x60007000,

	/* 4 non-gic controllers */
//	.intr	= { 0x60004000, 0x60004100, 0x60004200, 0x60004300, },

	/* private memory region */
	.scu	= 0x50040000,
	/* we got this address from the `cortex-a series programmer's guide'. */
	.intr	= 0x50040100,		/* per-cpu interface */
	.glbtmr	= 0x50040200,
	.loctmr	= 0x50040600,
	.intrdist=0x50041000,

	.uart	= { 0x70006000, 0x70006040,
		    0x70006200, 0x70006300, 0x70006400, },

	.rtc	= 0x7000e000,
	.tmr	= { 0x60005000, 0x60005008, 0x60005050, 0x60005058, },
	.µs	= 0x60005010,

	.pci	= 0x80000000,
	.ether	= 0xa0024000,

	.nand	= 0x70008000,
	.nor	= 0x70009000,		/* also VIRTNOR */

	.ehci	= P2VAHB(0xc5000000),	/* 1st of 3 */
	.ide	= P2VAHB(0xc3000000),

	.gpio	= { 0x6000d000, 0x6000d080, 0x6000d100, 0x6000d180,
			    0x6000d200, 0x6000d280, 0x6000d300, },
	.spi	= { 0x7000d400, 0x7000d600, 0x7000d800, 0x7000da00, },
 	.twsi	= 0x7000c000,
	.mmc	= { P2VAHB(0xc8000000), P2VAHB(0xc8000200),
		    P2VAHB(0xc8000400), P2VAHB(0xc8000600), },
};

static volatile Diag diag;
static int missed;

void
dumpcpuclks(void)		/* run CPU at full speed */
{
	Clkrst *clk = (Clkrst *)soc.clkrst;

	iprint("pllx base %#lux misc %#lux\n", clk-&gt;pllxbase, clk-&gt;pllxmisc);
	iprint("plle base %#lux misc %#lux\n", clk-&gt;pllebase, clk-&gt;pllemisc);
	iprint("super cclk divider %#lux\n", clk-&gt;supcclkdiv);
	iprint("super sclk divider %#lux\n", clk-&gt;supsclkdiv);
}

static char *
devidstr(ulong)
{
	return "ARM Cortex-A9";
}

void
archtegralink(void)
{
}

/* convert AddrDevid register to a string in buf and return buf */
char *
cputype2name(char *buf, int size)
{
	ulong r;

	r = cpidget();			/* main id register */
	assert((r &gt;&gt; 24) == 'A');
	seprint(buf, buf + size, "Cortex-A9 r%ldp%ld",
		(r &gt;&gt; 20) &amp; MASK(4), r &amp; MASK(4));
	return buf;
}

static void
errata(void)
{
	ulong reg, r, p;

	/* apply cortex-a9 errata workarounds */
	r = cpidget();			/* main id register */
	assert((r &gt;&gt; 24) == 'A');
	p = r &amp; MASK(4);		/* minor revision */
	r &gt;&gt;= 20;
	r &amp;= MASK(4);			/* major revision */

	/* this is an undocumented `diagnostic register' that linux knows */
	reg = cprdsc(0, CpDTLB, 0, 1);
	if (r &lt; 2 || r == 2 &amp;&amp; p &lt;= 2)
		reg |= 1&lt;&lt;4;			/* 742230 */
	if (r == 2 &amp;&amp; p &lt;= 2)
		reg |= 1&lt;&lt;6 | 1&lt;&lt;12 | 1&lt;&lt;22;	/* 743622, 2×742231 */
	if (r &lt; 3)
		reg |= 1&lt;&lt;11;			/* 751472 */
	cpwrsc(0, CpDTLB, 0, 1, reg);
}

void
archconfinit(void)
{
	char *p;
	ulong hz;

	assert(m != nil);
	m-&gt;cpuhz = 1000 * Mhz;			/* trimslice speed */
	p = getconf("*cpumhz");
	if (p) {
		hz = atoi(p) * Mhz;
		if (hz &gt;= 100*Mhz &amp;&amp; hz &lt;= 3600UL*Mhz)
			m-&gt;cpuhz = hz;
	}
	m-&gt;delayloop = m-&gt;cpuhz/2000;		/* initial estimate */
	errata();
}

int
archether(unsigned ctlrno, Ether *ether)
{
	switch(ctlrno) {
	case 0:
		ether-&gt;type = "rtl8169";		/* pci-e ether */
		ether-&gt;ctlrno = ctlrno;
		ether-&gt;irq = Pcieirq;			/* non-msi pci-e intr */
		ether-&gt;nopt = 0;
		ether-&gt;mbps = 1000;
		return 1;
	}
	return -1;
}

void
dumpscustate(void)
{
	Scu *scu = (Scu *)soc.scu;

	print("cpu%d scu: accctl %#lux\n", m-&gt;machno, scu-&gt;accctl);
	print("cpu%d scu: smp cpu bit map %#lo for %ld cpus; ", m-&gt;machno,
		(scu-&gt;cfg &gt;&gt; 4) &amp; MASK(4), (scu-&gt;cfg &amp; MASK(2)) + 1);
	print("cpus' power %#lux\n", scu-&gt;cpupwrsts);
}

void
scuon(void)
{
	Scu *scu = (Scu *)soc.scu;

	if (scu-&gt;ctl &amp; Scuenable)
		return;
	scu-&gt;inval = MASK(16);
	coherence();
	scu-&gt;ctl = Scuparity | Scuenable | Specfill;
	coherence();
}

int
getncpus(void)
{
	int n;
	char *p;
	Scu *scu;

	if (navailcpus == 0) {
		scu = (Scu *)soc.scu;
		navailcpus = (scu-&gt;cfg &amp; MASK(2)) + 1;
		if (navailcpus &gt; MAXMACH)
			navailcpus = MAXMACH;

		p = getconf("*ncpu");
		if (p &amp;&amp; *p) {
			n = atoi(p);
			if (n &gt; 0 &amp;&amp; n &lt; navailcpus)
				navailcpus = n;
		}
	}
	return navailcpus;
}

void
cpuidprint(void)
{
	char name[64];

	cputype2name(name, sizeof name);
	delay(50);				/* let uart catch up */
	iprint("cpu%d: %lldMHz ARM %s %s-endian\n",
		m-&gt;machno, m-&gt;cpuhz / Mhz, name,
		getpsr() &amp; PsrBigend? "big": "little");
}

static void
clockson(void)
{
	Clkrst *clk = (Clkrst *)soc.clkrst;

	/* enable all by clearing resets */
	clk-&gt;rstdevl = clk-&gt;rstdevh = clk-&gt;rstdevu = 0;
	coherence();
	clk-&gt;clkoutl = clk-&gt;clkouth = clk-&gt;clkoutu = ~0; /* enable all clocks */
	coherence();

	clk-&gt;rstsrc = Wdcpurst | Wdcoprst | Wdsysrst | Wdena;
	coherence();
}

/* we could be shutting down ourself (if cpu == m-&gt;machno), so take care. */
void
stopcpu(uint cpu)
{
	Flow *flow = (Flow *)soc.flow;
	Clkrst *clk = (Clkrst *)soc.clkrst;

	if (cpu == 0) {
		iprint("stopcpu: may not stop cpu0\n");
		return;
	}

	machoff(cpu);
	lock(&amp;active);
	active.stopped |= 1 &lt;&lt; cpu;
	unlock(&amp;active);
	l1cache-&gt;wb();

	/* shut down arm7 avp coproc so it can't cause mischief. */
	/* could try watchdog without stopping avp. */
	flow-&gt;haltcop = Stop;
	coherence();
	flow-&gt;cop = 0;					/* no Cpuenable */
	coherence();
	delay(10);

	assert(cpu &lt; Maxflowcpus);
	*(cpu == 0? &amp;flow-&gt;haltcpu0: &amp;flow-&gt;haltcpu1) = Stop;
	coherence();
	*(cpu == 0? &amp;flow-&gt;cpu0: &amp;flow-&gt;cpu1) = 0;	/* no Cpuenable */
	coherence();
	delay(10);

	/* cold reset */
	assert(cpu &lt; Maxcpus);
	clk-&gt;cpuset = (Cpu0reset | Cpu0dbgreset | Cpu0dereset) &lt;&lt; cpu;
	coherence();
	delay(1);

	l1cache-&gt;wb();
}

static void
synccpus(volatile long *cntp, int n)
{
	ainc(cntp);
	while (*cntp &lt; n)
		;
	/* all cpus should now be here */
}

static void
pass1(int pass, volatile Diag *dp)
{
	int i;

	if(m-&gt;machno == 0)
		iprint(" %d", pass);
	for (i = 1000*1000; --i &gt; 0; ) {
		ainc(&amp;dp-&gt;cnt);
		adec(&amp;dp-&gt;cnt);
	}

	synccpus(&amp;dp-&gt;sync, navailcpus);
	/* all cpus are now here */

	ilock(dp);
	if(dp-&gt;cnt != 0)
		panic("cpu%d: diag: failed w count %ld", m-&gt;machno, dp-&gt;cnt);
	iunlock(dp);

	synccpus(&amp;dp-&gt;sync, 2 * navailcpus);
	/* all cpus are now here */
	adec(&amp;dp-&gt;sync);
	adec(&amp;dp-&gt;sync);
}

/*
 * try to confirm coherence of l1 caches.
 * assume that all available cpus will be started.
 */
void
l1diag(void)
{
	int pass;
	volatile Diag *dp;

	if (!Debug)
		return;

	l1cache-&gt;wb();

	/*
	 * synchronise and print
	 */
	dp = &amp;diag;
	ilock(dp);
	if (m-&gt;machno == 0)
		iprint("l1: waiting for %d cpus... ", navailcpus);
	iunlock(dp);

	synccpus(&amp;dp-&gt;sync, navailcpus);

	ilock(dp);
	if (m-&gt;machno == 0)
		iprint("cache coherency pass");
	iunlock(dp);

	synccpus(&amp;dp-&gt;sync, 2 * navailcpus);
	adec(&amp;dp-&gt;sync);
	adec(&amp;dp-&gt;sync);

	/*
	 * cpus contend
	 */
	for (pass = 0; pass &lt; 3; pass++)
		pass1(pass, dp);

	/*
	 * synchronise and check sanity
	 */
	synccpus(&amp;dp-&gt;sync, navailcpus);

	if(dp-&gt;sync &lt; navailcpus || dp-&gt;sync &gt;= 2 * navailcpus)
		panic("cpu%d: diag: failed w dp-&gt;sync %ld", m-&gt;machno,
			dp-&gt;sync);
	if(dp-&gt;cnt != 0)
		panic("cpu%d: diag: failed w dp-&gt;cnt %ld", m-&gt;machno,
			dp-&gt;cnt);

	ilock(dp);
	iprint(" cpu%d ok", m-&gt;machno);
	iunlock(dp);

	synccpus(&amp;dp-&gt;sync, 2 * navailcpus);
	adec(&amp;dp-&gt;sync);
	adec(&amp;dp-&gt;sync);
	l1cache-&gt;wb();

	/*
	 * all done, print
	 */
	ilock(dp);
	if (m-&gt;machno == 0)
		iprint("\n");
	iunlock(dp);
}

static void
unfreeze(uint cpu)
{
	Clkrst *clk = (Clkrst *)soc.clkrst;
	Flow *flow = (Flow *)soc.flow;

	assert(cpu &lt; Maxcpus);

	clk-&gt;clkcpu &amp;= ~(Cpu0stop &lt;&lt; cpu);
	coherence();
	/* out of reset */
	clk-&gt;cpuclr = (Cpu0reset | Cpu0wdreset | Cpu0dbgreset | Cpu0dereset) &lt;&lt;
		cpu;
	coherence();

	assert(cpu &lt; Maxflowcpus);
	*(cpu == 0? &amp;flow-&gt;cpu0: &amp;flow-&gt;cpu1) = 0;
	coherence();
	*(cpu == 0? &amp;flow-&gt;haltcpu0: &amp;flow-&gt;haltcpu1) = 0; /* normal operat'n */
	coherence();
}

/*
 * this is all a bit magic.  the soc.exceptvec register is effectively
 * undocumented.  we had to look at linux and experiment, alas.  this is the
 * sort of thing that should be standardised as part of the cortex mpcore spec.
 * even intel document their equivalent procedure.
 */
int
startcpu(uint cpu)
{
	int i, r;
	ulong oldvec, rstaddr;
	ulong *evp = (ulong *)soc.exceptvec;	/* magic */

	r = 0;
	if (getncpus() &lt; 2 || cpu == m-&gt;machno ||
	    cpu &gt;= MAXMACH || cpu &gt;= navailcpus)
		return -1;

	oldvec = *evp;
	l1cache-&gt;wb();			/* start next cpu w same view of ram */
	*evp = rstaddr = PADDR(_vrst);	/* will start cpu executing at _vrst */
	coherence();
	l1cache-&gt;wb();
	unfreeze(cpu);

	for (i = 2000; i &gt; 0 &amp;&amp; *evp == rstaddr; i--)
		delay(1);
	if (i &lt;= 0 || *evp != cpu) {
		iprint("cpu%d: didn't start!\n", cpu);
		stopcpu(cpu);		/* make sure it's stopped */
		r = -1;
	}
	*evp = oldvec;
	return r;
}

static void
cksecure(void)
{
	ulong db;
	extern ulong getdebug(void);

	if (getscr() &amp; 1)
		panic("cpu%d: running non-secure", m-&gt;machno);
	db = getdebug();
	if (db)
		iprint("cpu%d: debug enable reg %#lux\n", m-&gt;machno, db);
}

ulong
smpon(void)
{
	ulong aux;

	/* cortex-a9 model-specific configuration */
	aux = getauxctl();
	putauxctl(aux | CpACsmp | CpACmaintbcast);
	return aux;
}

void
cortexa9cachecfg(void)
{
	/* cortex-a9 model-specific configuration */
	putauxctl(getauxctl() | CpACparity | CpAClwr0line | CpACl2pref);
}

/*
 * called on a cpu other than 0 from cpureset in l.s,
 * from _vrst in lexception.s.
 * mmu and l1 (and system-wide l2) caches and coherency (smpon) are on,
 * but interrupts are disabled.
 * our mmu is using an exact copy of cpu0's l1 page table
 * as it was after userinit ran.
 */
void
cpustart(void)
{
	int ms;
	ulong *evp;
	Power *pwr;

	up = nil;
	if (active.machs &amp; (1&lt;&lt;m-&gt;machno)) {
		serialputc('?');
		serialputc('r');
		panic("cpu%d: resetting after start", m-&gt;machno);
	}
	assert(m-&gt;machno != 0);

	errata();
	cortexa9cachecfg();
	memdiag(&amp;testmem);

	machinit();			/* bumps nmach, adds bit to machs */
	machoff(m-&gt;machno);		/* not ready to go yet */

	/* clock signals and scu are system-wide and already on */
	clockshutdown();		/* kill any watch-dog timer */

	trapinit();
	clockinit();			/* sets loop delay */
	timersinit();
	cpuidprint();

	/*
	 * notify cpu0 that we're up so it can proceed to l1diag.
	 */
	evp = (ulong *)soc.exceptvec;	/* magic */
	*evp = m-&gt;machno;
	coherence();

	l1diag();		/* contend with other cpus to verify sanity */

	/*
	 * pwr-&gt;noiopwr == 0
	 * pwr-&gt;detect == 0x1ff (default, all disabled)
	 */
	pwr = (Power *)soc.power;
	assert(pwr-&gt;gatests == MASK(7)); /* everything has power */

	/*
	 * 8169 has to initialise before we get past this, thus cpu0
	 * has to schedule processes first.
	 */
	if (Debug)
		iprint("cpu%d: waiting for 8169\n", m-&gt;machno);
	for (ms = 0; !l1ptstable.word &amp;&amp; ms &lt; 5000; ms += 10) {
		delay(10);
		cachedinvse(&amp;l1ptstable.word, sizeof l1ptstable.word);
	}
	if (!l1ptstable.word)
		iprint("cpu%d: 8169 unreasonably slow; proceeding\n", m-&gt;machno);
	/* now safe to copy cpu0's l1 pt in mmuinit */

	mmuinit();			/* update our l1 pt from cpu0's */
	fpon();
	machon(m-&gt;machno);		/* now ready to go and be scheduled */

	if (Debug)
		iprint("cpu%d: scheding\n", m-&gt;machno);
	schedinit();
	panic("cpu%d: schedinit returned", m-&gt;machno);
}

/* mainly used to break out of wfi */
void
sgintr(Ureg *ureg, void *)
{
	iprint("cpu%d: got sgi\n", m-&gt;machno);
	/* try to prod cpu1 into life when it gets stuck */
	if (m-&gt;machno != 0)
		clockprod(ureg);
}

void
archreset(void)
{
	static int beenhere;

	if (beenhere)
		return;
	beenhere = 1;

	/* conservative temporary values until archconfinit runs */
	m-&gt;cpuhz = 1000 * Mhz;			/* trimslice speed */
	m-&gt;delayloop = m-&gt;cpuhz/2000;		/* initial estimate */

	prcachecfg();

	clockson();
	/* all partitions were powered up by u-boot, so needn't do anything */
	archconfinit();
//	resetusb();
	fpon();

	if (irqtooearly)
		panic("archreset: too early for irqenable");
	irqenable(Cpu0irq, sgintr, nil, "cpu0");
	irqenable(Cpu1irq, sgintr, nil, "cpu1");
	/* ... */
}

void
archreboot(void)
{
	Clkrst *clk = (Clkrst *)soc.clkrst;

	assert(m-&gt;machno == 0);
	iprint("archreboot: reset!\n");
	delay(20);

	clk-&gt;rstdevl |= Sysreset;
	coherence();
	delay(500);

	/* shouldn't get here */
	splhi();
	iprint("awaiting reset");
	for(;;) {
		delay(1000);
		print(".");
	}
}

void
kbdinit(void)
{
}

static void
missing(ulong addr, char *name)
{
	static int firstmiss = 1;

	if (addr == 0) {
		iprint("address zero for %s\n", name);
		return;
	}
	if (probeaddr(addr) &gt;= 0)
		return;
	missed++;
	if (firstmiss) {
		iprint("missing:");
		firstmiss = 0;
	} else
		iprint(",\n\t");
	iprint(" %s at %#lux", name, addr);
}

/* verify that all the necessary device registers are accessible */
void
chkmissing(void)
{
	delay(10);
	missing(KZERO, "dram");
	missing(soc.intr, "intr ctlr");
	missing(soc.intrdist, "intr distrib");
	missing(soc.tmr[0], "tegra timer1");
	missing(soc.uart[0], "console uart");
	missing(soc.pci, "pcie");
	missing(soc.ether, "ether8169");
	missing(soc.µs, "µs counter");
	if (missed)
		iprint("\n");
	delay(10);
}

void
archflashwp(Flash*, int)
{
}

/*
 * for ../port/devflash.c:/^flashreset
 * retrieve flash type, virtual base and length and return 0;
 * return -1 on error (no flash)
 */
int
archflashreset(int bank, Flash *f)
{
	if(bank != 0)
		return -1;
panic("archflashreset: rewrite for nor &amp; nand flash on ts");
	/*
	 * this is set up for the igepv2 board.
	 */
	f-&gt;type = "onenand";
	f-&gt;addr = (void*)VIRTNOR;		/* mapped here by archreset */
	f-&gt;size = 0;				/* done by probe */
	f-&gt;width = 1;
	f-&gt;interleave = 0;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

