<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/teg2/caches-v7.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/teg2/caches-v7.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * caches defined by arm v7 architecture
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"
#include "arm.h"

static char *
l1iptype(uint type)
{
	static char *types[] = {
		"reserved",
		"asid-tagged VIVT",
		"VIPT",
		"PIPT",
	};

	if (type &gt;= nelem(types) || types[type] == nil)
		return "GOK";
	return types[type];
}

static char *catype[] = {
	"none,",
	"i,",
	"d,",
	"split i&amp;d,",
	"unified,",
	"gok,",
	"gok,",
	"gok,",
};

void
cacheinfo(int level, Memcache *cp, int ext, int type)
{
	ulong setsways;

	memset(cp, 0, sizeof *cp);
	if (type == Nocache)
		return;
	cp-&gt;level = level;
	cp-&gt;type = type;
	cp-&gt;external = ext;
	if (level == 2) {			/* external PL310 */
		allcache-&gt;info(cp);
		setsways = cp-&gt;setsways;
	} else {
		/* select internal cache level */
		cpwrsc(CpIDcssel, CpID, CpIDid, 0, (level - 1) &lt;&lt; 1);

		setsways = cprdsc(CpIDcsize, CpID, CpIDid, 0);
		cp-&gt;l1ip = cpctget();
		cp-&gt;nways = ((setsways &gt;&gt; 3)  &amp; MASK(10)) + 1;
		cp-&gt;nsets = ((setsways &gt;&gt; 13) &amp; MASK(15)) + 1;
		cp-&gt;log2linelen = (setsways &amp; MASK(2)) + 2 + 2;
	}
	cp-&gt;linelen = 1 &lt;&lt; cp-&gt;log2linelen;
	cp-&gt;setsways = setsways;
	cp-&gt;setsh = cp-&gt;log2linelen;
	cp-&gt;waysh = 32 - log2(cp-&gt;nways);
}

void
allcacheinfo(Memcache *mc)
{
	int n;
	ulong lvl;

	lvl = cprdsc(CpIDcsize, CpID, CpIDidct, CpIDclvlid);
	n = 1;
	for (lvl &amp;= MASK(21); lvl; lvl &gt;&gt;= 3)
		cacheinfo(n, &amp;mc[n], Intcache, lvl &amp; MASK(3));
//	cacheinfo(2, &amp;mc[2], Extcache, Unified);		/* PL310 */
}

void
prcachecfg(void)
{
	int cache;
	Memcache *mc;

	for (cache = 1; cache &lt; 8 &amp;&amp; cachel[cache].type; cache++) {
		mc = &amp;cachel[cache];
		iprint("l%d: %s %-10s %2d ways %4d sets %d bytes/line; can W[",
			mc-&gt;level, mc-&gt;external? "ext": "int", catype[mc-&gt;type],
			mc-&gt;nways, mc-&gt;nsets, mc-&gt;linelen);
		if (mc-&gt;linelen != CACHELINESZ)
			iprint(" *should* be %d", CACHELINESZ);
		if (mc-&gt;setsways &amp; Cawt)
			iprint("T");
		if (mc-&gt;setsways &amp; Cawb)
			iprint("B");
		if (mc-&gt;setsways &amp; Cawa)
			iprint("A");
		iprint("]");
		if (cache == 1)
			iprint("; l1-i %s", l1iptype((mc-&gt;l1ip &gt;&gt; 14) &amp; MASK(2)));
		iprint("\n");
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

