<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/teg2/caches.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/teg2/caches.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * operations on all memory data or unified caches, a no-op cache,
 * and an l1-only cache ops cache.
 * i-caches are not handled here.
 *
 * there are only three cache operations that we care about:
 * force cache contents to memory (before dma out or shutdown),
 * ignore cache contents in favour of memory (initialisation, after dma in),
 * both (update page tables and force cpu to read new contents).
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

static Cacheimpl allcaches, nullcaches, l1caches;

void
cachesinfo(Memcache *cp)
{
	memset(cp, 0, sizeof *cp);
	cp-&gt;setsways = Cara | Cawa | Cawt | Cawb;
	cp-&gt;l1ip = 3&lt;&lt;14;				/* PIPT */
	cp-&gt;log2linelen = log2(CACHELINESZ);
}

void
allcacheson(void)
{
	l2pl310init();
	allcache = &amp;allcaches;
	nocache = &amp;nullcaches;
	l1cache = &amp;l1caches;
}

void
cachesoff(void)
{
	l2cache-&gt;off();
}

void
cachesinvse(void *va, int bytes)
{
	int s;

	s = splhi();
	l2cache-&gt;invse(va, bytes);
	cachedinvse(va, bytes);
	splx(s);
}

void
cacheswbse(void *va, int bytes)
{
	int s;

	s = splhi();
	cachedwbse(va, bytes);
	l2cache-&gt;wbse(va, bytes);
	splx(s);
}

void
cacheswbinvse(void *va, int bytes)
{
	int s;

	s = splhi();
	cachedwbse(va, bytes);
	l2cache-&gt;wbinvse(va, bytes);
	cachedwbinvse(va, bytes);
	splx(s);
}


void
cachesinv(void)
{
	int s;

	s = splhi();
	l2cache-&gt;inv();
	cachedinv();
	splx(s);
}

void
cacheswb(void)
{
	int s;

	s = splhi();
	cachedwb();
	l2cache-&gt;wb();
	splx(s);
}

void
cacheswbinv(void)
{
	int s;

	s = splhi();
	cachedwb();
	l2cache-&gt;wbinv();
	cachedwbinv();
	splx(s);
}

static Cacheimpl allcaches = {
	.info	= cachesinfo,
	.on	= allcacheson,
	.off	= cachesoff,

	.inv	= cachesinv,
	.wb	= cacheswb,
	.wbinv	= cacheswbinv,

	.invse	= cachesinvse,
	.wbse	= cacheswbse,
	.wbinvse= cacheswbinvse,
};


/*
 * null cache ops
 */

void
nullinfo(Memcache *cp)
{
	memset(cp, 0, sizeof *cp);
	cp-&gt;log2linelen = 2;
}

void
nullon(void)
{
	nocache = &amp;nullcaches;
}

void
nullop(void)
{
}

void
nullse(void *, int)
{
}

static Cacheimpl nullcaches = {
	.info	= nullinfo,
	.on	= nullon,
	.off	= nullop,

	.inv	= nullop,
	.wb	= nullop,
	.wbinv	= nullop,

	.invse	= nullse,
	.wbse	= nullse,
	.wbinvse= nullse,
};

/*
 * l1-only ops
 */

void
l1cachesinfo(Memcache *)
{
}

void
l1cacheson(void)
{
	l1cache = &amp;l1caches;
}

static Cacheimpl l1caches = {
	.info	= l1cachesinfo,
	.on	= l1cacheson,
	.off	= nullop,

	.inv	= cachedinv,
	.wb	= cachedwb,
	.wbinv	= cachedwbinv,

	.invse	= cachedinvse,
	.wbse	= cachedwbse,
	.wbinvse= cachedwbinvse,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

