<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/teg2/coproc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/teg2/coproc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * arm co-processors
 * mainly to cope with arm hard-wiring register numbers into instructions.
 *
 * CP15 (system control) is the one that gets used the most in practice.
 * these routines must be callable from KZERO space or the 0 segment.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"

#include "arm.h"

enum {
	/* alternates:	0xe12fff1e	BX (R14); last e is R14 */
	/*		0xe28ef000	B 0(R14); second e is R14 (ken) */
	Retinst	= 0xe1a0f00e,		/* MOV R14, R15 */

	Opmask	= MASK(3),
	Regmask	= MASK(4),
};

typedef ulong (*Pufv)(void);
typedef void  (*Pvfu)(ulong);

static void
setupcpop(ulong instr[2], ulong opcode, int cp, int op1, int crn, int crm,
	int op2)
{
	ulong instrsz[2];

	op1 &amp;= Opmask;
	op2 &amp;= Opmask;
	crn &amp;= Regmask;
	crm &amp;= Regmask;
	cp  &amp;= Regmask;
	instr[0] = opcode | op1 &lt;&lt; 21 | crn &lt;&lt; 16 | cp &lt;&lt; 8 | op2 &lt;&lt; 5 | crm;
	instr[1] = Retinst;

	cachedwbse(instr, sizeof instrsz);
	cacheiinv();
}

ulong
cprd(int cp, int op1, int crn, int crm, int op2)
{
	int s, r;
	volatile ulong instr[2];
	Pufv fp;

	s = splhi();
	/*
	 * MRC.  return value will be in R0, which is convenient.
	 * Rt will be R0.
	 */
	setupcpop(instr, 0xee100010, cp, op1, crn, crm, op2);
	fp = (Pufv)instr;
	r = fp();
	splx(s);
	return r;
}

void
cpwr(int cp, int op1, int crn, int crm, int op2, ulong val)
{
	int s;
	volatile ulong instr[2];
	Pvfu fp;

	s = splhi();
	setupcpop(instr, 0xee000010, cp, op1, crn, crm, op2); /* MCR, Rt is R0 */
	fp = (Pvfu)instr;
	fp(val);
	coherence();
	splx(s);
}

ulong
cprdsc(int op1, int crn, int crm, int op2)
{
	return cprd(CpSC, op1, crn, crm, op2);
}

void
cpwrsc(int op1, int crn, int crm, int op2, ulong val)
{
	cpwr(CpSC, op1, crn, crm, op2, val);
}

/* floating point */

/* fp coproc control */
static void
setupfpctlop(ulong instr[2], int opcode, int fpctlreg)
{
	ulong instrsz[2];

	fpctlreg &amp;= Nfpctlregs - 1;
	instr[0] = opcode | fpctlreg &lt;&lt; 16 | 0 &lt;&lt; 12 | CpFP &lt;&lt; 8;
	instr[1] = Retinst;

	cachedwbse(instr, sizeof instrsz);
	cacheiinv();
}

ulong
fprd(int fpreg)
{
	int s, r;
	volatile ulong instr[2];
	Pufv fp;

	if (!m-&gt;fpon) {
		dumpstack();
		panic("fprd: cpu%d fpu off", m-&gt;machno);
	}
	s = splhi();
	/*
	 * VMRS.  return value will be in R0, which is convenient.
	 * Rt will be R0.
	 */
	setupfpctlop(instr, 0xeef00010, fpreg);
	fp = (Pufv)instr;
	r = fp();
	splx(s);
	return r;
}

void
fpwr(int fpreg, ulong val)
{
	int s;
	volatile ulong instr[2];
	Pvfu fp;

	/* fpu might be off and this VMSR might enable it */
	s = splhi();
	setupfpctlop(instr, 0xeee00010, fpreg);		/* VMSR, Rt is R0 */
	fp = (Pvfu)instr;
	fp(val);
	coherence();
	splx(s);
}

/* fp register access; don't bother with single precision */
static void
setupfpop(ulong instr[2], int opcode, int fpreg)
{
	ulong instrsz[2];

	instr[0] = opcode | 0 &lt;&lt; 16 | (fpreg &amp; (16 - 1)) &lt;&lt; 12;
	if (fpreg &gt;= 16)
		instr[0] |= 1 &lt;&lt; 22;		/* high bit of dfp reg # */
	instr[1] = Retinst;

	cachedwbse(instr, sizeof instrsz);
	cacheiinv();
}

ulong
fpsavereg(int fpreg, uvlong *fpp)
{
	int s, r;
	volatile ulong instr[2];
	ulong (*fp)(uvlong *);

	if (!m-&gt;fpon)
		panic("fpsavereg: cpu%d fpu off", m-&gt;machno);
	s = splhi();
	/*
	 * VSTR.  pointer will be in R0, which is convenient.
	 * Rt will be R0.
	 */
	setupfpop(instr, 0xed000000 | CpDFP &lt;&lt; 8, fpreg);
	fp = (ulong (*)(uvlong *))instr;
	r = fp(fpp);
	splx(s);
	coherence();
	return r;			/* not too meaningful */
}

void
fprestreg(int fpreg, uvlong val)
{
	int s;
	volatile ulong instr[2];
	void (*fp)(uvlong *);

	if (!m-&gt;fpon)
		panic("fprestreg: cpu%d fpu off", m-&gt;machno);
	s = splhi();
	setupfpop(instr, 0xed100000 | CpDFP &lt;&lt; 8, fpreg); /* VLDR, Rt is R0 */
	fp = (void (*)(uvlong *))instr;
	fp(&amp;val);
	coherence();
	splx(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

