<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/teg2/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/teg2/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * arm mpcore generic interrupt controller (gic) v1
 * traps, exceptions, interrupts, system calls.
 *
 * there are two pieces: the interrupt distributor and the cpu interface.
 *
 * memset or memmove on any of the distributor registers generates an
 * exception like this one:
 *	panic: external abort 0x28 pc 0xc048bf68 addr 0x50041800
 *
 * we use l1 and l2 cache ops to force vectors to be visible everywhere.
 *
 * apparently irqs 0—15 (SGIs) are always enabled.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ureg.h"
#include "arm.h"

#define ISSGI(irq)	((uint)(irq) &lt; Nsgi)

enum {
	Debug = 0,

	Nvec = 8,		/* # of vectors at start of lexception.s */
	Bi2long = BI2BY * sizeof(long),
	Nirqs = 1024,
	Nsgi =	16,		/* software-generated (inter-processor) intrs */
	Nppi =	32,		/* sgis + other private peripheral intrs */
};

typedef struct Intrcpuregs Intrcpuregs;
typedef struct Intrdistregs Intrdistregs;

/*
 * almost this entire register set is buggered.
 * the distributor is supposed to be per-system, not per-cpu,
 * yet some registers are banked per-cpu, as marked.
 */
struct Intrdistregs {			/* distributor */
	ulong	ctl;
	ulong	ctlrtype;
	ulong	distid;
	uchar	_pad0[0x80 - 0xc];

	/* botch: *[0] are banked per-cpu from here */
	/* bit maps */
	ulong	grp[32];		/* in group 1 (non-secure) */
	ulong	setena[32];		/* forward to cpu interfaces */
	ulong	clrena[32];
	ulong	setpend[32];
	ulong	clrpend[32];
	ulong	setact[32];		/* active? */
	ulong	clract[32];
	/* botch: *[0] are banked per-cpu until here */

	uchar	pri[1020];	/* botch: pri[0] — pri[7] are banked per-cpu */
	ulong	_rsrvd1;
	/* botch: targ[0] through targ[7] are banked per-cpu and RO */
	uchar	targ[1020];	/* byte bit maps: cpu targets indexed by intr */
	ulong	_rsrvd2;
	/* botch: cfg[1] is banked per-cpu */
	ulong	cfg[64];		/* bit pairs: edge? 1-N? */
	ulong	_pad1[64];
	ulong	nsac[64];		/* bit pairs (v2 only) */

	/* software-generated intrs (a.k.a. sgi) */
	ulong	swgen;			/* intr targets */
	uchar	_pad2[0xf10 - 0xf04];
	uchar	clrsgipend[16];		/* bit map (v2 only) */
	uchar	setsgipend[16];		/* bit map (v2 only) */
};

enum {
	/* ctl bits */
	Forw2cpuif =	1,

	/* ctlrtype bits */
	Cpunoshft =	5,
	Cpunomask =	MASK(3),
	Intrlines =	MASK(5),

	/* cfg bits */
	Level =		0&lt;&lt;1,
	Edge =		1&lt;&lt;1,		/* edge-, not level-sensitive */
	Toall =		0&lt;&lt;0,
	To1 =		1&lt;&lt;0,		/* vs. to all */

	/* swgen bits */
	Totargets =	0,
	Tonotme =	1&lt;&lt;24,
	Tome =		2&lt;&lt;24,
};

/* each cpu sees its own registers at the same base address (soc.intr) */
struct Intrcpuregs {
	ulong	ctl;
	ulong	primask;

	ulong	binpt;			/* group pri vs subpri split */
	ulong	ack;
	ulong	end;
	ulong	runpri;
	ulong	hipripend;

	/* aliased regs (secure, for group 1) */
	ulong	alibinpt;
	ulong	aliack;			/* (v2 only) */
	ulong	aliend;			/* (v2 only) */
	ulong	alihipripend;		/* (v2 only) */

	uchar	_pad0[0xd0 - 0x2c];
	ulong	actpri[4];		/* (v2 only) */
	ulong	nsactpri[4];		/* (v2 only) */

	uchar	_pad0[0xfc - 0xf0];
	ulong	ifid;			/* ro */

	uchar	_pad0[0x1000 - 0x100];
	ulong	deact;			/* wo (v2 only) */
};

enum {
	/* ctl bits */
	Enable =	1,
	Eoinodeact =	1&lt;&lt;9,		/* (v2 only) */

	/* (ali) ack/end/hipriend/deact bits */
	Intrmask =	MASK(10),
	Cpuidshift =	10,
	Cpuidmask =	MASK(3),

	/* ifid bits */
	Archversshift =	16,
	Archversmask =	MASK(4),
};

typedef struct Vctl Vctl;
typedef struct Vctl {
	Vctl*	next;		/* handlers on this vector */
	char	*name;		/* of driver, xallocated */
	void	(*f)(Ureg*, void*);	/* handler to call */
	void*	a;		/* argument to call it with */
} Vctl;

static Lock vctllock;
static Vctl* vctl[Nirqs];

/*
 *   Layout at virtual address 0.
 */
typedef struct Vpage0 {
	void	(*vectors[Nvec])(void);
	u32int	vtable[Nvec];
} Vpage0;

enum
{
	Ntimevec = 20		/* number of time buckets for each intr */
};
ulong intrtimes[Nirqs][Ntimevec];

uvlong ninterrupt;
uvlong ninterruptticks;
int irqtooearly = 1;

static ulong shadena[32];	/* copy of enable bits, saved by intcmaskall */
static Lock distlock, nintrlock;

extern int notify(Ureg*);

static void dumpstackwithureg(Ureg *ureg);

void
printrs(int base, ulong word)
{
	int bit;

	for (bit = 0; word; bit++, word &gt;&gt;= 1)
		if (word &amp; 1)
			iprint(" %d", base + bit);
}

void
dumpintrs(char *what, ulong *bits)
{
	int i, first, some;
	ulong word;
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	first = 1;
	some = 0;
	USED(idp);
	for (i = 0; i &lt; nelem(idp-&gt;setpend); i++) {
		word = bits[i];
		if (word) {
			if (first) {
				first = 0;
				iprint("%s", what);
			}
			some = 1;
			printrs(i * Bi2long, word);
		}
	}
	if (!some)
		iprint("%s none", what);
	iprint("\n");
}

void
dumpintrpend(void)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	iprint("\ncpu%d gic regs:\n", m-&gt;machno);
	dumpintrs("group 1", idp-&gt;grp);
	dumpintrs("enabled", idp-&gt;setena);
	dumpintrs("pending", idp-&gt;setpend);
	dumpintrs("active ", idp-&gt;setact);
}

/*
 *  keep histogram of interrupt service times
 */
void
intrtime(Mach*, int vno)
{
	ulong diff;
	ulong x;

	x = perfticks();
	diff = x - m-&gt;perf.intrts;
	m-&gt;perf.intrts = x;

	m-&gt;perf.inintr += diff;
	if(up == nil &amp;&amp; m-&gt;perf.inidle &gt; diff)
		m-&gt;perf.inidle -= diff;

	if (m-&gt;cpumhz == 0)
		return;			/* don't divide by zero */
	diff /= m-&gt;cpumhz*100;		/* quantum = 100µsec */
	if(diff &gt;= Ntimevec)
		diff = Ntimevec-1;
	if ((uint)vno &gt;= Nirqs)
		vno = Nirqs-1;
	intrtimes[vno][diff]++;
}

static ulong
intack(Intrcpuregs *icp)
{
	return icp-&gt;ack &amp; Intrmask;
}

static void
intdismiss(Intrcpuregs *icp, ulong ack)
{
	icp-&gt;end = ack;
	coherence();
}

static int
irqinuse(uint irq)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	return idp-&gt;setena[irq / Bi2long] &amp; (1 &lt;&lt; (irq % Bi2long));
}

void
intcunmask(uint irq)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	ilock(&amp;distlock);
	idp-&gt;setena[irq / Bi2long] = 1 &lt;&lt; (irq % Bi2long);
	iunlock(&amp;distlock);
}

void
intcmask(uint irq)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	ilock(&amp;distlock);
	idp-&gt;clrena[irq / Bi2long] = 1 &lt;&lt; (irq % Bi2long);
	iunlock(&amp;distlock);
}

static void
intcmaskall(Intrdistregs *idp)		/* mask all intrs for all cpus */
{
	int i;

	for (i = 0; i &lt; nelem(idp-&gt;setena); i++)
		shadena[i] = idp-&gt;setena[i];
	for (i = 0; i &lt; nelem(idp-&gt;clrena); i++)
		idp-&gt;clrena[i] = ~0;
	coherence();
}

static void
intcunmaskall(Intrdistregs *idp)	/* unused */
{
	int i;

	for (i = 0; i &lt; nelem(idp-&gt;setena); i++)
		idp-&gt;setena[i] = shadena[i];
	coherence();
}

static ulong
permintrs(Intrdistregs *idp, int base, int r)
{
	ulong perms;

	idp-&gt;clrena[r] = ~0;		/* disable all */
	coherence();
	perms = idp-&gt;clrena[r];
	if (perms) {
		iprint("perm intrs:");
		printrs(base, perms);
		iprint("\n");
	}
	return perms;
}

static void
intrcfg(Intrdistregs *idp)
{
	int i, cpumask;
	ulong pat;

	/* set up all interrupts as level-sensitive, to one cpu (0) */
	pat = 0;
	for (i = 0; i &lt; Bi2long; i += 2)
		pat |= (Level | To1) &lt;&lt; i;

	if (m-&gt;machno == 0) {			/* system-wide &amp; cpu0 cfg */
		for (i = 0; i &lt; nelem(idp-&gt;grp); i++)
			idp-&gt;grp[i] = 0;		/* secure */
		for (i = 0; i &lt; nelem(idp-&gt;pri); i++)
			idp-&gt;pri[i] = 0;		/* highest priority */
		/* set up all interrupts as level-sensitive, to one cpu (0) */
		for (i = 0; i &lt; nelem(idp-&gt;cfg); i++)
			idp-&gt;cfg[i] = pat;
		/* first Nppi are read-only for SGIs and PPIs */
		cpumask = 1&lt;&lt;0;				/* just cpu 0 */
		navailcpus = getncpus();
		for (i = Nppi; i &lt; sizeof idp-&gt;targ; i++)
			idp-&gt;targ[i] = cpumask;
		coherence();

		intcmaskall(idp);
		for (i = 0; i &lt; nelem(idp-&gt;clrena); i++) {
			// permintrs(idp, i * Bi2long, i);
			idp-&gt;clrpend[i] = idp-&gt;clract[i] = idp-&gt;clrena[i] = ~0;
		}
	} else {				/* per-cpu config */
		idp-&gt;grp[0] = 0;		/* secure */
		for (i = 0; i &lt; 8; i++)
			idp-&gt;pri[i] = 0;	/* highest priority */
		/* idp-&gt;targ[0 through Nppi-1] are supposed to be read-only */
		for (i = 0; i &lt; Nppi; i++)
			idp-&gt;targ[i] = 1&lt;&lt;m-&gt;machno;
		idp-&gt;cfg[1] = pat;
		coherence();

		// permintrs(idp, i * Bi2long, i);
		idp-&gt;clrpend[0] = idp-&gt;clract[0] = idp-&gt;clrena[0] = ~0;
		/* on cpu1, irq Extpmuirq (118) is always pending here */
	}
	coherence();
}

void
intrto(int cpu, int irq)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	/* first Nppi are read-only for SGIs and the like */
	ilock(&amp;distlock);
	idp-&gt;targ[irq] = 1 &lt;&lt; cpu;
	iunlock(&amp;distlock);
}

void
intrsto(int cpu)			/* unused */
{
	int i;
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	/* first Nppi are read-only for SGIs and the like */
	for (i = Nppi; i &lt; sizeof idp-&gt;targ; i++)
		intrto(cpu, i);
	USED(idp);
}

void
intrcpu(int cpu)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	ilock(&amp;distlock);
	idp-&gt;swgen = Totargets | 1 &lt;&lt; (cpu + 16) | m-&gt;machno;
	iunlock(&amp;distlock);
}

/*
 *  set up for exceptions
 */
void
trapinit(void)
{
	int s;
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;
	Intrcpuregs *icp = (Intrcpuregs *)soc.intr;
	Vpage0 *vpage0;
	enum { Vecsize = sizeof vpage0-&gt;vectors + sizeof vpage0-&gt;vtable, };

	/*
	 * set up the exception vectors, high and low.
	 *
	 * we can't use cache ops on HVECTORS address, since they
	 * work on virtual addresses, and only those that have a
	 * physical address == PADDR(virtual).
	 */
	if (m-&gt;machno == 0) {
		vpage0 = (Vpage0*)HVECTORS;
		memmove(vpage0-&gt;vectors, vectors, sizeof(vpage0-&gt;vectors));
		memmove(vpage0-&gt;vtable, vtable, sizeof(vpage0-&gt;vtable));

		vpage0 = (Vpage0*)KADDR(0);
		memmove(vpage0-&gt;vectors, vectors, sizeof(vpage0-&gt;vectors));
		memmove(vpage0-&gt;vtable, vtable, sizeof(vpage0-&gt;vtable));

		allcache-&gt;wbse(vpage0, Vecsize);
		cacheiinv();
	}

	/*
	 * set up the stack pointers for the exception modes for this cpu.
	 * they point to small `save areas' in Mach, not actual stacks.
	 */
	s = splhi();			/* make these modes ignore intrs too */
	setr13(PsrMfiq, m-&gt;sfiq);
	setr13(PsrMirq, m-&gt;sirq);
	setr13(PsrMmon, m-&gt;smon);
	setr13(PsrMabt, m-&gt;sabt);
	setr13(PsrMund, m-&gt;sund);
	setr13(PsrMsys, m-&gt;ssys);
	splx(s);

	assert((idp-&gt;distid &amp; MASK(12)) == 0x43b);	/* made by arm */
	assert((icp-&gt;ifid   &amp; MASK(12)) == 0x43b);	/* made by arm */

	ilock(&amp;distlock);
	idp-&gt;ctl = 0;
	icp-&gt;ctl = 0;
	coherence();

	intrcfg(idp);			/* some per-cpu cfg here */

	icp-&gt;ctl = Enable;
	icp-&gt;primask = (uchar)~0;	/* let all priorities through */
	coherence();

	idp-&gt;ctl = Forw2cpuif;
	iunlock(&amp;distlock);
}

void
intrsoff(void)
{
	ilock(&amp;distlock);
	intcmaskall((Intrdistregs *)soc.intrdist);
	iunlock(&amp;distlock);
}

void
intrcpushutdown(void)
{
	Intrcpuregs *icp = (Intrcpuregs *)soc.intr;

	icp-&gt;ctl = 0;
	icp-&gt;primask = 0;	/* let no priorities through */
	coherence();
}

/* called from cpu0 after other cpus are shutdown */
void
intrshutdown(void)
{
	Intrdistregs *idp = (Intrdistregs *)soc.intrdist;

	intrsoff();
	idp-&gt;ctl = 0;
	intrcpushutdown();
}

/*
 *  enable an irq interrupt
 *  note that the same private interrupt may be enabled on multiple cpus
 */
int
irqenable(uint irq, void (*f)(Ureg*, void*), void* a, char *name)
{
	Vctl *v;

	if(irq &gt;= nelem(vctl))
		panic("irqenable irq %d", irq);

	if (irqtooearly) {
		iprint("irqenable for %d %s called too early\n", irq, name);
		return -1;
	}
	/*
	 * if in use, could be a private interrupt on a secondary cpu,
	 * so don't add anything to the vector chain.  irqs should
	 * otherwise be one-to-one with devices.
	 */
	if(!ISSGI(irq) &amp;&amp; irqinuse(irq)) {
		lock(&amp;vctllock);
		if (vctl[irq] == nil) {
			dumpintrpend();
			panic("non-sgi irq %d in use yet no Vctl allocated", irq);
		}
		unlock(&amp;vctllock);
	}
	/* could be 1st use of this irq or could be an sgi (always in use) */
	else if (vctl[irq] == nil) {
		v = malloc(sizeof(Vctl));
		if (v == nil)
			panic("irqenable: malloc Vctl");
		v-&gt;f = f;
		v-&gt;a = a;
		v-&gt;name = malloc(strlen(name)+1);
		if (v-&gt;name == nil)
			panic("irqenable: malloc name");
		strcpy(v-&gt;name, name);

		lock(&amp;vctllock);
		if (vctl[irq] != nil) {
			/* allocation race: someone else did it first */
			free(v-&gt;name);
			free(v);
		} else {
			v-&gt;next = vctl[irq];
			vctl[irq] = v;
		}
		unlock(&amp;vctllock);
	}
	intcunmask(irq);
	return 0;
}

/*
 *  disable an irq interrupt
 */
int
irqdisable(uint irq, void (*f)(Ureg*, void*), void* a, char *name)
{
	Vctl **vp, *v;

	if(irq &gt;= nelem(vctl))
		panic("irqdisable irq %d", irq);

	lock(&amp;vctllock);
	for(vp = &amp;vctl[irq]; v = *vp; vp = &amp;v-&gt;next)
		if (v-&gt;f == f &amp;&amp; v-&gt;a == a &amp;&amp; strcmp(v-&gt;name, name) == 0){
			if(Debug)
				print("irqdisable: remove %s\n", name);
			*vp = v-&gt;next;
			free(v-&gt;name);
			free(v);
			break;
		}

	if(v == nil)
		print("irqdisable: irq %d, name %s not enabled\n", irq, name);
	if(vctl[irq] == nil){
		if(Debug)
			print("irqdisable: clear icmr bit %d\n", irq);
		intcmask(irq);
	}
	unlock(&amp;vctllock);

	return 0;
}

/*
 *  called by trap to handle access faults
 */
static void
faultarm(Ureg *ureg, uintptr va, int user, int read)
{
	int n, insyscall;

	if(up == nil) {
		dumpstackwithureg(ureg);
		panic("faultarm: cpu%d: nil up, %sing %#p at %#p",
			m-&gt;machno, (read? "read": "writ"), va, ureg-&gt;pc);
	}
	insyscall = up-&gt;insyscall;
	up-&gt;insyscall = 1;

	n = fault(va, read);		/* goes spllo */
	splhi();
	if(n &lt; 0){
		char buf[ERRMAX];

		if(!user){
			dumpstackwithureg(ureg);
			panic("fault: cpu%d: kernel %sing %#p at %#p",
				m-&gt;machno, read? "read": "writ", va, ureg-&gt;pc);
		}
		/* don't dump registers; programs suicide all the time */
		snprint(buf, sizeof buf, "sys: trap: fault %s va=%#p",
			read? "read": "write", va);
		postnote(up, 1, buf, NDebug);
	}
	up-&gt;insyscall = insyscall;
}

/*
 *  called by trap to handle interrupts.
 *  returns true iff a clock interrupt, thus maybe reschedule.
 */
static int
irq(Ureg* ureg)
{
	int clockintr, ack;
	uint irqno, handled, t, ticks;
	Intrcpuregs *icp = (Intrcpuregs *)soc.intr;
	Vctl *v;

	ticks = perfticks();
	handled = 0;
	ack = intack(icp);
	irqno = ack &amp; Intrmask;

	if (irqno &gt;= nelem(vctl)) {
		iprint("trap: irq %d &gt;= # vectors (%d)\n", irqno, nelem(vctl));
		intdismiss(icp, ack);
		return 0;
	}

	if (irqno == Loctmrirq)			/* this is a clock intr? */
		m-&gt;inclockintr++;		/* yes, count nesting */
	if(m-&gt;machno &amp;&amp; m-&gt;inclockintr &gt; 1) {
		iprint("cpu%d: nested clock intrs\n", m-&gt;machno);
		m-&gt;inclockintr--;
		intdismiss(icp, ack);
		return 0;
	}

	for(v = vctl[irqno]; v != nil; v = v-&gt;next)
		if (v-&gt;f) {
			if (islo())
				panic("trap: pl0 before trap handler for %s",
					v-&gt;name);
			v-&gt;f(ureg, v-&gt;a);
			if (islo())
				panic("trap: %s lowered pl", v-&gt;name);
//			splhi();		/* in case v-&gt;f lowered pl */
			handled++;
		}
	if(!handled)
		if (irqno &gt;= 1022)
			iprint("cpu%d: ignoring spurious interrupt\n", m-&gt;machno);
		else {
			intcmask(irqno);
			iprint("cpu%d: unexpected interrupt %d, now masked\n",
				m-&gt;machno, irqno);
		}
	t = perfticks();
	if (0) {			/* left over from another port? */
		ilock(&amp;nintrlock);
		ninterrupt++;
		if(t &lt; ticks)
			ninterruptticks += ticks-t;
		else
			ninterruptticks += t-ticks;
		iunlock(&amp;nintrlock);
	}
	USED(t, ticks);
	clockintr = m-&gt;inclockintr == 1;
	if (irqno == Loctmrirq)
		m-&gt;inclockintr--;

	intdismiss(icp, ack);
	intrtime(m, irqno);
	return clockintr;
}

/*
 *  returns 1 if the instruction writes memory, 0 otherwise
 */
int
writetomem(ulong inst)
{
	/* swap always write memory */
	if((inst &amp; 0x0FC00000) == 0x01000000)
		return 1;

	/* loads and stores are distinguished by bit 20 */
	if(inst &amp; (1&lt;&lt;20))
		return 0;

	return 1;
}

static void
datafault(Ureg *ureg, int user)
{
	int x;
	ulong inst, fsr;
	uintptr va;

	va = farget();

	if (m-&gt;probing &amp;&amp; !user) {
		if (m-&gt;trapped++ &gt; 0) {
			dumpstackwithureg(ureg);
			panic("trap: recursive probe %#lux", va);
		}
		ureg-&gt;pc += 4;	/* continue after faulting instr'n */
		return;
	}

	inst = *(ulong*)(ureg-&gt;pc);
	/* bits 12 and 10 have to be concatenated with status */
	x = fsrget();
	fsr = (x&gt;&gt;7) &amp; 0x20 | (x&gt;&gt;6) &amp; 0x10 | x &amp; 0xf;
	switch(fsr){
	default:
	case 0xa:		/* ? was under external abort */
		panic("unknown data fault, 6b fsr %#lux", fsr);
		break;
	case 0x0:
		panic("vector exception at %#lux", ureg-&gt;pc);
		break;
	case 0x1:		/* alignment fault */
	case 0x3:		/* access flag fault (section) */
		if(user){
			char buf[ERRMAX];

			snprint(buf, sizeof buf,
				"sys: alignment: pc %#lux va %#p\n",
				ureg-&gt;pc, va);
			postnote(up, 1, buf, NDebug);
		} else {
			dumpstackwithureg(ureg);
			panic("kernel alignment: pc %#lux va %#p", ureg-&gt;pc, va);
		}
		break;
	case 0x2:
		panic("terminal exception at %#lux", ureg-&gt;pc);
		break;
	case 0x4:		/* icache maint fault */
	case 0x6:		/* access flag fault (page) */
	case 0x8:		/* precise external abort, non-xlat'n */
	case 0x28:
	case 0x16:		/* imprecise ext. abort, non-xlt'n */
	case 0x36:
		panic("external non-translation abort %#lux pc %#lux addr %#p",
			fsr, ureg-&gt;pc, va);
		break;
	case 0xc:		/* l1 translation, precise ext. abort */
	case 0x2c:
	case 0xe:		/* l2 translation, precise ext. abort */
	case 0x2e:
		panic("external translation abort %#lux pc %#lux addr %#p",
			fsr, ureg-&gt;pc, va);
		break;
	case 0x1c:		/* l1 translation, precise parity err */
	case 0x1e:		/* l2 translation, precise parity err */
	case 0x18:		/* imprecise parity or ecc err */
		panic("translation parity error %#lux pc %#lux addr %#p",
			fsr, ureg-&gt;pc, va);
		break;
	case 0x5:		/* translation fault, no section entry */
	case 0x7:		/* translation fault, no page entry */
		faultarm(ureg, va, user, !writetomem(inst));
		break;
	case 0x9:
	case 0xb:
		/* domain fault, accessing something we shouldn't */
		if(user){
			char buf[ERRMAX];

			snprint(buf, sizeof buf,
				"sys: access violation: pc %#lux va %#p\n",
				ureg-&gt;pc, va);
			postnote(up, 1, buf, NDebug);
		} else
			panic("kernel access violation: pc %#lux va %#p",
				ureg-&gt;pc, va);
		break;
	case 0xd:
	case 0xf:
		/* permission error, copy on write or real permission error */
		faultarm(ureg, va, user, !writetomem(inst));
		break;
	}
}

/*
 *  here on all exceptions other than syscall (SWI) and reset
 */
void
trap(Ureg *ureg)
{
	int clockintr, user, rem;
	uintptr va, ifar, ifsr;

	splhi();			/* paranoia */
	if(up != nil)
		rem = ((char*)ureg)-up-&gt;kstack;
	else
		rem = ((char*)ureg)-((char*)m+sizeof(Mach));
	if(rem &lt; 1024) {
		iprint("trap: %d stack bytes left, up %#p ureg %#p m %#p cpu%d at pc %#lux\n",
			rem, up, ureg, m, m-&gt;machno, ureg-&gt;pc);
		dumpstackwithureg(ureg);
		panic("trap: %d stack bytes left, up %#p ureg %#p at pc %#lux",
			rem, up, ureg, ureg-&gt;pc);
	}

	m-&gt;perf.intrts = perfticks();
	user = (ureg-&gt;psr &amp; PsrMask) == PsrMusr;
	if(user){
		up-&gt;dbgreg = ureg;
		cycles(&amp;up-&gt;kentry);
	}

	/*
	 * All interrupts/exceptions should be resumed at ureg-&gt;pc-4,
	 * except for Data Abort which resumes at ureg-&gt;pc-8.
	 */
	if(ureg-&gt;type == (PsrMabt+1))
		ureg-&gt;pc -= 8;
	else
		ureg-&gt;pc -= 4;

	clockintr = 0;		/* if set, may call sched() before return */
	switch(ureg-&gt;type){
	default:
		panic("unknown trap; type %#lux, psr mode %#lux", ureg-&gt;type,
			ureg-&gt;psr &amp; PsrMask);
		break;
	case PsrMirq:
		m-&gt;intr++;
		clockintr = irq(ureg);
		if(0 &amp;&amp; up &amp;&amp; !clockintr)
			preempted();	/* this causes spurious suicides */
		break;
	case PsrMabt:			/* prefetch (instruction) fault */
		va = ureg-&gt;pc;
		ifsr = cprdsc(0, CpFSR, 0, CpIFSR);
		ifsr = (ifsr&gt;&gt;7) &amp; 0x8 | ifsr &amp; 0x7;
		switch(ifsr){
		case 0x02:		/* instruction debug event (BKPT) */
			if(user)
				postnote(up, 1, "sys: breakpoint", NDebug);
			else{
				iprint("kernel bkpt: pc %#lux inst %#ux\n",
					va, *(u32int*)va);
				panic("kernel bkpt");
			}
			break;
		default:
			ifar = cprdsc(0, CpFAR, 0, CpIFAR);
			if (va != ifar)
				iprint("trap: cpu%d: i-fault va %#p != ifar %#p\n",
					m-&gt;machno, va, ifar);
			faultarm(ureg, va, user, 1);
			break;
		}
		break;
	case PsrMabt+1:			/* data fault */
		datafault(ureg, user);
		break;
	case PsrMund:			/* undefined instruction */
		if(!user) {
			if (ureg-&gt;pc &amp; 3) {
				iprint("rounding fault pc %#lux down to word\n",
					ureg-&gt;pc);
				ureg-&gt;pc &amp;= ~3;
			}
			if (Debug)
				iprint("mathemu: cpu%d fpon %d instr %#8.8lux at %#p\n",
					m-&gt;machno, m-&gt;fpon, *(ulong *)ureg-&gt;pc,
				ureg-&gt;pc);
			dumpstackwithureg(ureg);
			panic("cpu%d: undefined instruction: pc %#lux inst %#ux",
				m-&gt;machno, ureg-&gt;pc, ((u32int*)ureg-&gt;pc)[0]);
		} else if(seg(up, ureg-&gt;pc, 0) != nil &amp;&amp;
		   *(u32int*)ureg-&gt;pc == 0xD1200070)
			postnote(up, 1, "sys: breakpoint", NDebug);
		else if(fpuemu(ureg) == 0){	/* didn't find any FP instrs? */
			char buf[ERRMAX];

			snprint(buf, sizeof buf,
				"undefined instruction: pc %#lux instr %#8.8lux\n",
				ureg-&gt;pc, *(ulong *)ureg-&gt;pc);
			postnote(up, 1, buf, NDebug);
		}
		break;
	}
	splhi();

	/* delaysched set because we held a lock or because our quantum ended */
	if(up &amp;&amp; up-&gt;delaysched &amp;&amp; clockintr){
		sched();		/* can cause more traps */
		splhi();
	}

	if(user){
		if(up-&gt;procctl || up-&gt;nnote)
			notify(ureg);
		kexit(ureg);
	}
}

/*
 * Fill in enough of Ureg to get a stack trace, and call a function.
 * Used by debugging interface rdb.
 */
void
callwithureg(void (*fn)(Ureg*))
{
	Ureg ureg;

	memset(&amp;ureg, 0, sizeof ureg);
	ureg.pc = getcallerpc(&amp;fn);
	ureg.sp = PTR2UINT(&amp;fn);
	fn(&amp;ureg);
}

static void
dumpstackwithureg(Ureg *ureg)
{
	int x;
	uintptr l, v, i, estack;
	char *s;

	dumpregs(ureg);
	if((s = getconf("*nodumpstack")) != nil &amp;&amp; strcmp(s, "0") != 0){
		iprint("dumpstack disabled\n");
		return;
	}
	delay(1000);
	iprint("dumpstack\n");

	x = 0;
	x += iprint("ktrace /kernel/path %#.8lux %#.8lux %#.8lux # pc, sp, link\n",
		ureg-&gt;pc, ureg-&gt;sp, ureg-&gt;r14);
	delay(20);
	i = 0;
	if(up
	&amp;&amp; (uintptr)&amp;l &gt;= (uintptr)up-&gt;kstack
	&amp;&amp; (uintptr)&amp;l &lt;= (uintptr)up-&gt;kstack+KSTACK)
		estack = (uintptr)up-&gt;kstack+KSTACK;
	else if((uintptr)&amp;l &gt;= (uintptr)m-&gt;stack
	&amp;&amp; (uintptr)&amp;l &lt;= (uintptr)m+MACHSIZE)
		estack = (uintptr)m+MACHSIZE;
	else
		return;
	x += iprint("estackx %p\n", estack);

	for(l = (uintptr)&amp;l; l &lt; estack; l += sizeof(uintptr)){
		v = *(uintptr*)l;
		if((KTZERO &lt; v &amp;&amp; v &lt; (uintptr)etext) || estack-l &lt; 32){
			x += iprint("%.8p ", v);
			delay(20);
			i++;
		}
		if(i == 8){
			i = 0;
			x += iprint("\n");
			delay(20);
		}
	}
	if(i)
		iprint("\n");
	delay(3000);
}

void
dumpstack(void)
{
	callwithureg(dumpstackwithureg);
}

/*
 * dump system control coprocessor registers
 */
static void
dumpscr(void)
{
	iprint("0:\t%#8.8ux id\n", cpidget());
	iprint("\t%8.8#ux ct\n", cpctget());
	iprint("1:\t%#8.8ux control\n", controlget());
	iprint("2:\t%#8.8ux ttb\n", ttbget());
	iprint("3:\t%#8.8ux dac\n", dacget());
	iprint("4:\t(reserved)\n");
	iprint("5:\t%#8.8ux fsr\n", fsrget());
	iprint("6:\t%#8.8ux far\n", farget());
	iprint("7:\twrite-only cache\n");
	iprint("8:\twrite-only tlb\n");
	iprint("13:\t%#8.8ux pid\n", pidget());
	delay(10);
}

/*
 * dump general registers
 */
static void
dumpgpr(Ureg* ureg)
{
	if(up != nil)
		iprint("cpu%d: registers for %s %lud\n",
			m-&gt;machno, up-&gt;text, up-&gt;pid);
	else
		iprint("cpu%d: registers for kernel\n", m-&gt;machno);

	delay(20);
	iprint("%#8.8lux\tr0\n", ureg-&gt;r0);
	iprint("%#8.8lux\tr1\n", ureg-&gt;r1);
	iprint("%#8.8lux\tr2\n", ureg-&gt;r2);
	delay(20);
	iprint("%#8.8lux\tr3\n", ureg-&gt;r3);
	iprint("%#8.8lux\tr4\n", ureg-&gt;r4);
	iprint("%#8.8lux\tr5\n", ureg-&gt;r5);
	delay(20);
	iprint("%#8.8lux\tr6\n", ureg-&gt;r6);
	iprint("%#8.8lux\tr7\n", ureg-&gt;r7);
	iprint("%#8.8lux\tr8\n", ureg-&gt;r8);
	delay(20);
	iprint("%#8.8lux\tr9 (up)\n", ureg-&gt;r9);
	iprint("%#8.8lux\tr10 (m)\n", ureg-&gt;r10);
	iprint("%#8.8lux\tr11 (loader temporary)\n", ureg-&gt;r11);
	iprint("%#8.8lux\tr12 (SB)\n", ureg-&gt;r12);
	delay(20);
	iprint("%#8.8lux\tr13 (sp)\n", ureg-&gt;r13);
	iprint("%#8.8lux\tr14 (link)\n", ureg-&gt;r14);
	iprint("%#8.8lux\tr15 (pc)\n", ureg-&gt;pc);
	delay(20);
	iprint("%10.10lud\ttype\n", ureg-&gt;type);
	iprint("%#8.8lux\tpsr\n", ureg-&gt;psr);
	delay(500);
}

void
dumpregs(Ureg* ureg)
{
	dumpgpr(ureg);
	dumpscr();
}

vlong
probeaddr(uintptr addr)
{
	vlong v;

	ilock(&amp;m-&gt;probelock);
	m-&gt;trapped = 0;
	m-&gt;probing = 1;
	coherence();

	v = *(ulong *)addr;	/* this may cause a fault */
	coherence();

	m-&gt;probing = 0;
	if (m-&gt;trapped)
		v = -1;
	iunlock(&amp;m-&gt;probelock);
	return v;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

