<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/teg2/vfp3.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/teg2/vfp3.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * VFPv2 or VFPv3 floating point unit
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "ureg.h"
#include "arm.h"

/* subarchitecture code in m-&gt;havefp */
enum {
	VFPv2	= 2,
	VFPv3	= 3,
};

/* fp control regs.  most are read-only */
enum {
	Fpsid =	0,
	Fpscr =	1,			/* rw */
	Mvfr1 =	6,
	Mvfr0 =	7,
	Fpexc =	8,			/* rw */
	Fpinst= 9,			/* optional, for exceptions */
	Fpinst2=10,
};
enum {
	/* Fpexc bits */
	Fpex =		1u &lt;&lt; 31,
	Fpenabled =	1 &lt;&lt; 30,
	Fpdex =		1 &lt;&lt; 29,	/* defined synch exception */
//	Fp2v =		1 &lt;&lt; 28,	/* Fpinst2 reg is valid */
//	Fpvv =		1 &lt;&lt; 27,	/* if Fpdex, vecitr is valid */
//	Fptfv = 	1 &lt;&lt; 26,	/* trapped fault is valid */
//	Fpvecitr =	MASK(3) &lt;&lt; 8,
	/* FSR bits appear here */
	Fpmbc =		Fpdex,		/* bits exception handler must clear */

	/* Fpscr bits; see u.h for more */
	Stride =	MASK(2) &lt;&lt; 20,
	Len =		MASK(3) &lt;&lt; 16,
	Dn=		1 &lt;&lt; 25,
	Fz=		1 &lt;&lt; 24,
	/* trap exception enables (not allowed in vfp3) */
	FPIDNRM =	1 &lt;&lt; 15,	/* input denormal */
	Alltraps = FPIDNRM | FPINEX | FPUNFL | FPOVFL | FPZDIV | FPINVAL,
	/* pending exceptions */
	FPAIDNRM =	1 &lt;&lt; 7,		/* input denormal */
	Allexc = FPAIDNRM | FPAINEX | FPAUNFL | FPAOVFL | FPAZDIV | FPAINVAL,
	/* condition codes */
	Allcc =		MASK(4) &lt;&lt; 28,
};
enum {
	/* CpCPaccess bits */
	Cpaccnosimd =	1u &lt;&lt; 31,
	Cpaccd16 =	1 &lt;&lt; 30,
};

static char *
subarch(int impl, uint sa)
{
	static char *armarchs[] = {
		"VFPv1 (unsupported)",
		"VFPv2",
		"VFPv3+ with common VFP subarch v2",
		"VFPv3+ with null subarch",
		"VFPv3+ with common VFP subarch v3",
	};

	if (impl != 'A' || sa &gt;= nelem(armarchs))
		return "GOK";
	else
		return armarchs[sa];
}

static char *
implement(uchar impl)
{
	if (impl == 'A')
		return "arm";
	else
		return "unknown";
}

static int
havefp(void)
{
	int gotfp;
	ulong acc, sid;

	if (m-&gt;havefpvalid)
		return m-&gt;havefp;

	m-&gt;havefp = 0;
	gotfp = 1 &lt;&lt; CpFP | 1 &lt;&lt; CpDFP;
	cpwrsc(0, CpCONTROL, 0, CpCPaccess, MASK(28));
	acc = cprdsc(0, CpCONTROL, 0, CpCPaccess);
	if ((acc &amp; (MASK(2) &lt;&lt; (2*CpFP))) == 0) {
		gotfp &amp;= ~(1 &lt;&lt; CpFP);
		print("fpon: no single FP coprocessor\n");
	}
	if ((acc &amp; (MASK(2) &lt;&lt; (2*CpDFP))) == 0) {
		gotfp &amp;= ~(1 &lt;&lt; CpDFP);
		print("fpon: no double FP coprocessor\n");
	}
	if (!gotfp) {
		print("fpon: no FP coprocessors\n");
		m-&gt;havefpvalid = 1;
		return 0;
	}
	m-&gt;fpon = 1;			/* don't panic */
	sid = fprd(Fpsid);
	m-&gt;fpon = 0;
	switch((sid &gt;&gt; 16) &amp; MASK(7)){
	case 0:				/* VFPv1 */
		break;
	case 1:				/* VFPv2 */
		m-&gt;havefp = VFPv2;
		m-&gt;fpnregs = 16;
		break;
	default:			/* VFPv3 or later */
		m-&gt;havefp = VFPv3;
		m-&gt;fpnregs = (acc &amp; Cpaccd16) ? 16 : 32;
		break;
	}
	if (m-&gt;machno == 0)
		print("fp: %d registers, %s simd\n", m-&gt;fpnregs,
			(acc &amp; Cpaccnosimd? " no": ""));
	m-&gt;havefpvalid = 1;
	return 1;
}

/*
 * these can be called to turn the fpu on or off for user procs,
 * not just at system start up or shutdown.
 */

void
fpoff(void)
{
	if (m-&gt;fpon) {
		fpwr(Fpexc, 0);
		m-&gt;fpon = 0;
	}
}

void
fpononly(void)
{
	if (!m-&gt;fpon &amp;&amp; havefp()) {
		/* enable fp.  must be first operation on the FPUs. */
		fpwr(Fpexc, Fpenabled);
		m-&gt;fpon = 1;
	}
}

static void
fpcfg(void)
{
	int impl;
	ulong sid;
	static int printed;

	/* clear pending exceptions; no traps in vfp3; all v7 ops are scalar */
	m-&gt;fpscr = Dn | Fz | FPRNR | (FPINVAL | FPZDIV | FPOVFL) &amp; ~Alltraps;
	fpwr(Fpscr, m-&gt;fpscr);
	m-&gt;fpconfiged = 1;

	if (printed)
		return;
	sid = fprd(Fpsid);
	impl = sid &gt;&gt; 24;
	print("fp: %s arch %s; rev %ld\n", implement(impl),
		subarch(impl, (sid &gt;&gt; 16) &amp; MASK(7)), sid &amp; MASK(4));
	printed = 1;
}

void
fpinit(void)
{
	if (havefp()) {
		fpononly();
		fpcfg();
	}
}

void
fpon(void)
{
	if (havefp()) {
	 	fpononly();
		if (m-&gt;fpconfiged)
			fpwr(Fpscr, (fprd(Fpscr) &amp; Allcc) | m-&gt;fpscr);
		else
			fpcfg();	/* 1st time on this fpu; configure it */
	}
}

void
fpclear(void)
{
//	ulong scr;

	fpon();
//	scr = fprd(Fpscr);
//	m-&gt;fpscr = scr &amp; ~Allexc;
//	fpwr(Fpscr, m-&gt;fpscr);

	fpwr(Fpexc, fprd(Fpexc) &amp; ~Fpmbc);
}


/*
 * Called when a note is about to be delivered to a
 * user process, usually at the end of a system call.
 * Note handlers are not allowed to use the FPU so
 * the state is marked (after saving if necessary) and
 * checked in the Device Not Available handler.
 */
void
fpunotify(Ureg*)
{
	if(up-&gt;fpstate == FPactive){
		fpsave(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPinactive;
	}
	up-&gt;fpstate |= FPillegal;
}

/*
 * Called from sysnoted() via the machine-dependent
 * noted() routine.
 * Clear the flag set above in fpunotify().
 */
void
fpunoted(void)
{
	up-&gt;fpstate &amp;= ~FPillegal;
}

/*
 * Called early in the non-interruptible path of
 * sysrfork() via the machine-dependent syscall() routine.
 * Save the state so that it can be easily copied
 * to the child process later.
 */
void
fpusysrfork(Ureg*)
{
	if(up-&gt;fpstate == FPactive){
		fpsave(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPinactive;
	}
}

/*
 * Called later in sysrfork() via the machine-dependent
 * sysrforkchild() routine.
 * Copy the parent FPU state to the child.
 */
void
fpusysrforkchild(Proc *p, Ureg *, Proc *up)
{
	/* don't penalize the child, it hasn't done FP in a note handler. */
	p-&gt;fpstate = up-&gt;fpstate &amp; ~FPillegal;
}

/* should only be called if p-&gt;fpstate == FPactive */
void
fpsave(FPsave *fps)
{
	int n;

	fpon();
	fps-&gt;control = fps-&gt;status = fprd(Fpscr);
	assert(m-&gt;fpnregs);
	for (n = 0; n &lt; m-&gt;fpnregs; n++)
		fpsavereg(n, (uvlong *)fps-&gt;regs[n]);
	fpoff();
}

static void
fprestore(Proc *p)
{
	int n;

	fpon();
	fpwr(Fpscr, p-&gt;fpsave.control);
	m-&gt;fpscr = fprd(Fpscr) &amp; ~Allcc;
	assert(m-&gt;fpnregs);
	for (n = 0; n &lt; m-&gt;fpnregs; n++)
		fprestreg(n, *(uvlong *)p-&gt;fpsave.regs[n]);
}

/*
 * Called from sched() and sleep() via the machine-dependent
 * procsave() routine.
 * About to go in to the scheduler.
 * If the process wasn't using the FPU
 * there's nothing to do.
 */
void
fpuprocsave(Proc *p)
{
	if(p-&gt;fpstate == FPactive){
		if(p-&gt;state == Moribund)
			fpclear();
		else{
			/*
			 * Fpsave() stores without handling pending
			 * unmasked exeptions. Postnote() can't be called
			 * here as sleep() already has up-&gt;rlock, so
			 * the handling of pending exceptions is delayed
			 * until the process runs again and generates an
			 * emulation fault to activate the FPU.
			 */
			fpsave(&amp;p-&gt;fpsave);
		}
		p-&gt;fpstate = FPinactive;
	}
}

/*
 * The process has been rescheduled and is about to run.
 * Nothing to do here right now. If the process tries to use
 * the FPU again it will cause a Device Not Available
 * exception and the state will then be restored.
 */
void
fpuprocrestore(Proc *)
{
}

/*
 * Disable the FPU.
 * Called from sysexec() via sysprocsetup() to
 * set the FPU for the new process.
 */
void
fpusysprocsetup(Proc *p)
{
	p-&gt;fpstate = FPinit;
	fpoff();
}

static void
mathnote(void)
{
	ulong status;
	char *msg, note[ERRMAX];

	status = up-&gt;fpsave.status;

	/*
	 * Some attention should probably be paid here to the
	 * exception masks and error summary.
	 */
	if (status &amp; FPAINEX)
		msg = "inexact";
	else if (status &amp; FPAOVFL)
		msg = "overflow";
	else if (status &amp; FPAUNFL)
		msg = "underflow";
	else if (status &amp; FPAZDIV)
		msg = "divide by zero";
	else if (status &amp; FPAINVAL)
		msg = "bad operation";
	else
		msg = "spurious";
	snprint(note, sizeof note, "sys: fp: %s fppc=%#p status=%#lux",
		msg, up-&gt;fpsave.pc, status);
	postnote(up, 1, note, NDebug);
}

static void
mathemu(Ureg *)
{
	switch(up-&gt;fpstate){
	case FPemu:
		error("illegal instruction: VFP opcode in emulated mode");
	case FPinit:
		fpinit();
		up-&gt;fpstate = FPactive;
		break;
	case FPinactive:
		/*
		 * Before restoring the state, check for any pending
		 * exceptions.  There's no way to restore the state without
		 * generating an unmasked exception.
		 * More attention should probably be paid here to the
		 * exception masks and error summary.
		 */
		if(up-&gt;fpsave.status &amp; (FPAINEX|FPAUNFL|FPAOVFL|FPAZDIV|FPAINVAL)){
			mathnote();
			break;
		}
		fprestore(up);
		up-&gt;fpstate = FPactive;
		break;
	case FPactive:
		error("illegal instruction: bad vfp fpu opcode");
		break;
	}
	fpclear();
}

void
fpstuck(uintptr pc)
{
	if (m-&gt;fppc == pc &amp;&amp; m-&gt;fppid == up-&gt;pid) {
		m-&gt;fpcnt++;
		if (m-&gt;fpcnt &gt; 4)
			panic("fpuemu: cpu%d stuck at pid %ld %s pc %#p "
				"instr %#8.8lux", m-&gt;machno, up-&gt;pid, up-&gt;text,
				pc, *(ulong *)pc);
	} else {
		m-&gt;fppid = up-&gt;pid;
		m-&gt;fppc = pc;
		m-&gt;fpcnt = 0;
	}
}

enum {
	N = 1&lt;&lt;31,
	Z = 1&lt;&lt;30,
	C = 1&lt;&lt;29,
	V = 1&lt;&lt;28,
	REGPC = 15,
};

static int
condok(int cc, int c)
{
	switch(c){
	case 0:	/* Z set */
		return cc&amp;Z;
	case 1:	/* Z clear */
		return (cc&amp;Z) == 0;
	case 2:	/* C set */
		return cc&amp;C;
	case 3:	/* C clear */
		return (cc&amp;C) == 0;
	case 4:	/* N set */
		return cc&amp;N;
	case 5:	/* N clear */
		return (cc&amp;N) == 0;
	case 6:	/* V set */
		return cc&amp;V;
	case 7:	/* V clear */
		return (cc&amp;V) == 0;
	case 8:	/* C set and Z clear */
		return cc&amp;C &amp;&amp; (cc&amp;Z) == 0;
	case 9:	/* C clear or Z set */
		return (cc&amp;C) == 0 || cc&amp;Z;
	case 10:	/* N set and V set, or N clear and V clear */
		return (~cc&amp;(N|V))==0 || (cc&amp;(N|V)) == 0;
	case 11:	/* N set and V clear, or N clear and V set */
		return (cc&amp;(N|V))==N || (cc&amp;(N|V))==V;
	case 12:	/* Z clear, and either N set and V set or N clear and V clear */
		return (cc&amp;Z) == 0 &amp;&amp; ((~cc&amp;(N|V))==0 || (cc&amp;(N|V))==0);
	case 13:	/* Z set, or N set and V clear or N clear and V set */
		return (cc&amp;Z) || (cc&amp;(N|V))==N || (cc&amp;(N|V))==V;
	case 14:	/* always */
		return 1;
	case 15:	/* never (reserved) */
		return 0;
	}
	return 0;	/* not reached */
}

/* only called to deal with user-mode instruction faults */
int
fpuemu(Ureg* ureg)
{
	int s, nfp, cop, op;
	uintptr pc;

	if(waserror()){
		postnote(up, 1, up-&gt;errstr, NDebug);
		return 1;
	}

	if(up-&gt;fpstate &amp; FPillegal)
		error("floating point in note handler");

	nfp = 0;
	pc = ureg-&gt;pc;
	validaddr(pc, 4, 0);
	if(!condok(ureg-&gt;psr, *(ulong*)pc &gt;&gt; 28))
		iprint("fpuemu: conditional instr shouldn't have got here\n");
	op  = (*(ulong *)pc &gt;&gt; 24) &amp; MASK(4);
	cop = (*(ulong *)pc &gt;&gt;  8) &amp; MASK(4);
	if(m-&gt;fpon)
		fpstuck(pc);		/* debugging; could move down 1 line */
	if (ISFPAOP(cop, op)) {		/* old arm 7500 fpa opcode? */
//		iprint("fpuemu: fpa instr %#8.8lux at %#p\n", *(ulong *)pc, pc);
//		error("illegal instruction: old arm 7500 fpa opcode");
		s = spllo();
		if(waserror()){
			splx(s);
			nexterror();
		}
		nfp = fpiarm(ureg);	/* advances pc past emulated instr(s) */
		if (nfp &gt; 1)		/* could adjust this threshold */
			m-&gt;fppc = m-&gt;fpcnt = 0;
		splx(s);
		poperror();
	} else if (ISVFPOP(cop, op)) {	/* if vfp, fpu must be off */
		mathemu(ureg);		/* enable fpu &amp; retry */
		nfp = 1;
	}

	poperror();
	return nfp;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

