<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/9src/stty.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/9src/stty.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;tty.h&gt;

typedef struct Mode Mode;
struct Mode
{
	char*	name;
	int	bit;
};

Mode ou[] =
{
	"opost",	OPOST,
	"olcuc",	OLCUC,
	"onlcr",	ONLCR,
	"ocrnl",	OCRNL,
	"onocr",	ONOCR,
	"onlret",	ONLRET,
	"ofill",	OFILL,
	"ofdel",	OFDEL,
	0
};

Mode in[] =
{
	"brkint",	BRKINT,
	"icrnl",	ICRNL,
	"ignbrk",	IGNBRK,
	"igncr",	IGNCR,
	"ignpar",	IGNPAR,
	"inlcr",	INLCR,
	"inpck",	INPCK,
	"istrip",	ISTRIP,
	"ixoff",	IXOFF,
	"ixon",		IXON,
	"parmrk",	PARMRK,
	0
};

Mode lo[] =
{
	"echo",		ECHO,
	"echoe",	ECHOE,
	"echok", 	ECHOK,
	"echonl",	ECHONL,
	"icanon",	ICANON,
	"iexten",	IEXTEN,
	"isig",		ISIG,
	"noflsh",	NOFLSH,
	"tostop",	TOSTOP,
	0
};

Mode cc[] =
{
	"eof",		VEOF,
	"eol",		VEOL,
	"erase",	VERASE,
	"intr",		VINTR,
	"kill",		VKILL,
	"min",		VMIN,
	"quit",		VQUIT,
	"susp",		VSUSP,
	"time",		VTIME,
	"start",	VSTART,
	"stop",		VSTOP,
	0,
};

int	getmode(int, Termios*);
int	setmode(int, Termios*);

char*
ctlchar(char c)
{
	static char buf[10];

	if(c == 0x7f)
		return "DEL";
	if(c == 0)
		return "NUL";
	if(c &lt; 32) {
		buf[0] = '^';
		buf[1] = '@'+c;
		buf[2] = '\0';
		return buf;
	}	
	buf[0] = c;
	buf[1] = '\0';
	return buf;
}

void
showmode(Termios *t)
{
	int i;

	for(i = 0; cc[i].name; i++) {
		switch(cc[i].bit) {
		case VMIN:
		case VTIME:
			if(t-&gt;cc[i] != 0)
				print("%s %d ", cc[i].name, t-&gt;cc[i]);
			break;
		default:
			print("%s %s ", cc[i].name, ctlchar(t-&gt;cc[i]));
			break;
		}
	}
	print("\n");

	for(i = 0; ou[i].name; i++)
		if(ou[i].bit &amp; t-&gt;oflag)
			print("%s ", ou[i].name);

	for(i = 0; in[i].name; i++)
		if(in[i].bit &amp; t-&gt;iflag)
			print("%s ", in[i].name);

	print("\n");
	for(i = 0; lo[i].name; i++)
		if(lo[i].bit &amp; t-&gt;lflag)
			print("%s ", lo[i].name);
	print("\n");
}

int
setreset(char *mode, int *bits, Mode *t)
{
	int i, clr;

	clr = 0;
	if(mode[0] == '-') {
		mode++;
		clr = 1;
	}
	for(i = 0; t[i].name; i++) {
		if(strcmp(mode, t[i].name) == 0) {
			if(clr)
				*bits &amp;= ~t[i].bit;
			else
				*bits |= t[i].bit;

			return 1;
		}
	}
	return 0;
}

int
ccname(char *name)
{
	int i;

	for(i = 0; cc[i].name; i++)
		if(strcmp(cc[i].name, name) == 0)
			return i;

	return -1;
}

void
main(int argc, char **argv)
{
	Termios t;
	int i, stdin, wmo, cc;

	/* Try and get a seek pointer */
	stdin = open("/fd/0", ORDWR);
	if(stdin &lt; 0)
		stdin = 0;

	if(getmode(stdin, &amp;t) &lt; 0) {
		fprint(2, "stty: tiocget %r\n");
		exits("1");
	}

	if(argc &lt; 2) {
		fprint(2, "usage: stty [-a|-g] modes...\n");
		exits("1");
	}
	wmo = 0;
	for(i = 1; i &lt; argc; i++) {
		if(strcmp(argv[i], "-a") == 0) {
			showmode(&amp;t);
			continue;
		}
		if(setreset(argv[i], &amp;t.iflag, in)) {
			wmo++;
			continue;
		}
		if(setreset(argv[i], &amp;t.lflag, lo)) {
			wmo++;
			continue;
		}
		if(setreset(argv[i], &amp;t.oflag, ou)) {
			wmo++;
			continue;
		}
		cc = ccname(argv[i]);
		if(cc != -1 &amp;&amp; i+1 &lt; argc) {
			wmo++;
			t.cc[cc] = argv[++i][0];
			continue;
		}
		fprint(2, "stty: bad option/mode %s\n", argv[i]);
		exits("1");
	}

	if(wmo) {
		if(setmode(stdin, &amp;t) &lt; 0) {
			fprint(2, "stty: cant set mode %r\n");
			exits("1");
		}
	}

	exits(0);
}

int
setmode(int fd, Termios *t)
{
	int n, i;
	char buf[256];

	n = sprint(buf, "IOW %4.4ux %4.4ux %4.4ux %4.4ux ",
		t-&gt;iflag, t-&gt;oflag, t-&gt;cflag, t-&gt;lflag);
	for(i = 0; i &lt; NCCS; i++)
		n += sprint(buf+n, "%2.2ux ", t-&gt;cc[i]);

	if(seek(fd, -2, 0) != -2)
		return -1;

	n = write(fd, buf, n);
	if(n &lt; 0)
		return -1;
	return 0;
}

/*
 * Format is: IOR iiii oooo cccc llll xx xx xx xx ...
 */
int
getmode(int fd, Termios *t)
{
	int n;
	char buf[256];

	if(seek(fd, -2, 0) != -2)
		return -1;

	n = read(fd, buf, 57);
	if(n &lt; 0)
		return -1;

	t-&gt;iflag = strtoul(buf+4, 0, 16);
	t-&gt;oflag = strtoul(buf+9, 0, 16);
	t-&gt;cflag = strtoul(buf+14, 0, 16);
	t-&gt;lflag = strtoul(buf+19, 0, 16);

	for(n = 0; n &lt; NCCS; n++)
		t-&gt;cc[n] = strtoul(buf+24+(n*3), 0, 16);

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

