<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/9src/tar.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/9src/tar.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Attempt at emulation of Unix tar by calling Plan 9 tar.
 * 
 * The differences from Plan 9 tar are:
 *	In the absence of an "f" flag, the file /dev/tape is used.
 *	An "f" flag with argument "-" causes use of stdin/stdout
 *		by passing no "f" flag (nor argument) to Plan 9 tar.
 *	By default, the "T" flag is passed to Plan 9 tar.
 *		The "m" flag to this tar inhibits this behavior.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;

void
usage(void)
{
	fprint(2, "usage: ape/tar [crtx][vfm] [args...] [file...]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i, j, verb, vflag, fflag, Tflag, nargc;
	char *p, *file, **nargv, *cpu, flagbuf[10], execbuf[128];
	Waitmsg *w;

	argv++, argc--;
	if(argc &lt; 1)
		usage();

	p = argv[0];
	argv++, argc--;

	if(*p == '-')
		p++;

	if(strchr("crtx", *p) == nil)
		usage();
	verb = *p++;

	/* unix defaults */
	fflag = 1;
	file = "/dev/tape";
	Tflag = 1;
	vflag = 0;

	for(; *p; p++) {
		switch(*p) {
		default:
			usage();
		case 'v':
			vflag = 1;
			break;
		case 'f':
			if(argc &lt;= 0)
				usage();

			fflag = 1;
			file = argv[0];
			argv++, argc--;
			if(strcmp(file, "-") == 0) {
				/*
				 * plan9 doesn't know about "-" meaning stdin/stdout,
				 * but it's the default,
				 * so rewrite to not use f flag at all.
				 */
				file = nil;
				fflag = 0;
			}
			break;
		case 'm':
			Tflag = 0;
			break;
		case 'p':		/* pretend nothing's wrong */
			break;
		}
	}

	nargc = 1 + 1 + fflag + argc + 1;
	nargv = malloc(sizeof(char*) * nargc);
	if(nargv == nil) {
		fprint(2, "ape/tar: out of memory\n");
		exits("memory");
	}

	cpu = getenv("cputype");
	if(cpu == nil) {
		fprint(2, "ape/tar: need cputype environment variable set\n");
		exits("cputype");
	}
	snprint(execbuf, sizeof execbuf, "/%s/bin/tar", cpu);

	nargv[0] = "tar";
	sprint(flagbuf, "%c%s%s%s", verb, vflag ? "v" : "", Tflag ? "T" : "", fflag ? "f" : "");
	nargv[1] = flagbuf;

	i = 2;
	if(fflag)
		nargv[i++] = file;

	for(j=0; j&lt;argc; j++, i++)
		nargv[i] = argv[j];

	nargv[i++] = nil;
	assert(i == nargc);

	switch(fork()){
	case -1:
		fprint(2, "ape/tar: fork failed: %r\n");
		exits("fork");
	case 0:
		exec(execbuf, nargv);
		fprint(2, "exec %s fails: %r\n", execbuf);
		_exits("exec");
	default:
		w = wait();
		if(w == nil)
			exits("wait failed");
		if(w-&gt;msg[0] == '\0')
			exits(nil);
		else
			exits(w-&gt;msg);
	}
	assert(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

