<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/make/doname.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/make/doname.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "defs.h"

static int docom1(char *, int, int, int, int);
static void expand(depblkp);

/*  BASIC PROCEDURE.  RECURSIVE.  */

/*
p-&gt;done = 0   don't know what to do yet
p-&gt;done = 1   file in process of being updated
p-&gt;done = 2   file already exists in current state
p-&gt;done = 3   file make failed
*/

int
doname(nameblkp p, int reclevel, time_t *tval, int nowait)
{
int errstat;
int okdel1;
int didwork;
int len;
time_t td, td1, tdep, ptime, ptime1;
depblkp q;
depblkp qtemp, suffp, suffp1;
nameblkp p1, p2;
struct shblock *implcom, *explcom;
lineblkp lp;
lineblkp lp1, lp2;
char sourcename[100], prefix[100], temp[100], concsuff[20];
char *stem;
char *pnamep, *p1namep;
chainp allchain, qchain;
char qbuf[QBUFMAX], tgsbuf[QBUFMAX];
wildp wp;
int nproc1;
char *lastslash, *s;

if(p == 0)
	{
	*tval = 0;
	return 0;
	}

if(dbgflag)
	{
	printf("doname(%s,%d)\n",p-&gt;namep,reclevel);
	fflush(stdout);
	}

if(p-&gt;done &gt; 0)
	{
	*tval = p-&gt;modtime;
	return (p-&gt;done == 3);
	}

errstat = 0;
tdep = 0;
implcom = 0;
explcom = 0;
ptime = exists(p-&gt;namep);
ptime1 = 0;
didwork = NO;
p-&gt;done = 1;	/* avoid infinite loops */
nproc1 = nproc;	/* current depth of process stack */

qchain = NULL;
allchain = NULL;

/* define values of Bradford's $$@ and $$/ macros */
for(s = lastslash = p-&gt;namep; *s; ++s)
	if(*s == '/')
		lastslash = s;
setvar("$@", p-&gt;namep, YES);
setvar("$/", lastslash, YES);


/* expand any names that have embedded metacharacters */

for(lp = p-&gt;linep ; lp ; lp = lp-&gt;nxtlineblock)
	for(q = lp-&gt;depp ; q ; q=qtemp )
		{
		qtemp = q-&gt;nxtdepblock;
		expand(q);
		}

/* make sure all dependents are up to date */

for(lp = p-&gt;linep ; lp ; lp = lp-&gt;nxtlineblock)
	{
	td = 0;
	for(q = lp-&gt;depp ; q ; q = q-&gt;nxtdepblock)
		if(q-&gt;depname)
			{
			errstat += doname(q-&gt;depname, reclevel+1, &amp;td1, q-&gt;nowait);
			if(dbgflag)
				printf("TIME(%s)=%ld\n",q-&gt;depname-&gt;namep, td1);
			if(td1 &gt; td)
				td = td1;
			if(ptime &lt; td1)
				qchain = appendq(qchain, q-&gt;depname-&gt;namep);
			allchain = appendq(allchain, q-&gt;depname-&gt;namep);
			}
	if(p-&gt;septype == SOMEDEPS)
		{
		if(lp-&gt;shp)
		     if( ptime&lt;td || (ptime==0 &amp;&amp; td==0) || lp-&gt;depp==0)
			{
			okdel1 = okdel;
			okdel = NO;
			set3var("@", p-&gt;namep);
			setvar("?", mkqlist(qchain,qbuf), YES);
			setvar("^", mkqlist(allchain,tgsbuf), YES);
			qchain = NULL;
			if( !questflag )
				errstat += docom(lp-&gt;shp, nowait, nproc1);
			set3var("@", CHNULL);
			okdel = okdel1;
			ptime1 = prestime();
			didwork = YES;
			}
		}

	else	{
		if(lp-&gt;shp != 0)
			{
			if(explcom)
				fprintf(stderr, "Too many command lines for `%s'\n",
					p-&gt;namep);
			else	explcom = lp-&gt;shp;
			}

		if(td &gt; tdep) tdep = td;
		}
	}



/* Look for implicit dependents, using suffix rules */

for(lp = sufflist ; lp ; lp = lp-&gt;nxtlineblock)
    for(suffp = lp-&gt;depp ; suffp ; suffp = suffp-&gt;nxtdepblock)
	{
	pnamep = suffp-&gt;depname-&gt;namep;
	if(suffix(p-&gt;namep , pnamep , prefix))
		{
		(void)srchdir(concat(prefix,"*",temp), NO, (depblkp) NULL);
		for(lp1 = sufflist ; lp1 ; lp1 = lp1-&gt;nxtlineblock)
		    for(suffp1=lp1-&gt;depp; suffp1 ; suffp1 = suffp1-&gt;nxtdepblock)
			{
			p1namep = suffp1-&gt;depname-&gt;namep;
			if( (p1=srchname(concat(p1namep, pnamep ,concsuff))) &amp;&amp;
			    (p2=srchname(concat(prefix, p1namep ,sourcename))) )
				{
				errstat += doname(p2, reclevel+1, &amp;td, NO);
				if(ptime &lt; td)
					qchain = appendq(qchain, p2-&gt;namep);
if(dbgflag) printf("TIME(%s)=%ld\n", p2-&gt;namep, td);
				if(td &gt; tdep) tdep = td;
				set3var("*", prefix);
				set3var("&lt;", copys(sourcename));
				for(lp2=p1-&gt;linep ; lp2 ; lp2 = lp2-&gt;nxtlineblock)
					if(implcom = lp2-&gt;shp) break;
				goto endloop;
				}
			}
		}
	}

/* Look for implicit dependents, using pattern matching rules */

len = strlen(p-&gt;namep);
for(wp = firstwild ; wp ; wp = wp-&gt;next)
	if(stem = wildmatch(wp, p-&gt;namep, len) )
		{
		lp = wp-&gt;linep;
		for(q = lp-&gt;depp; q; q = q-&gt;nxtdepblock)
			{
			if(dbgflag&gt;1 &amp;&amp; q-&gt;depname)
				fprintf(stderr,"check dep of %s on %s\n", p-&gt;namep,
					wildsub(q-&gt;depname-&gt;namep,stem));
			if(q-&gt;depname &amp;&amp;
				! chkname(wildsub(q-&gt;depname-&gt;namep,stem)))
					break;
			}

		if(q)	/* some name not found, go to next line */
			continue;

		for(q = lp-&gt;depp; q; q = q-&gt;nxtdepblock)
			{
			nameblkp tamep;
			if(q-&gt;depname == NULL)
				continue;
			tamep = srchname( wildsub(q-&gt;depname-&gt;namep,stem));
/*TEMP fprintf(stderr,"check dep %s on %s =&gt;%s\n",p-&gt;namep,q-&gt;depname-&gt;namep,tamep-&gt;namep);*/
/*TEMP*/if(dbgflag) printf("%s depends on %s. stem=%s\n", p-&gt;namep,tamep-&gt;namep, stem);
			errstat += doname(tamep, reclevel+1, &amp;td, q-&gt;nowait);
			if(ptime &lt; td)
				qchain = appendq(qchain, tamep-&gt;namep);
			allchain = appendq(allchain, tamep-&gt;namep);
			if(dbgflag) printf("TIME(%s)=%ld\n", tamep-&gt;namep, td);
			if(td &gt; tdep)
				tdep = td;
			set3var("&lt;", copys(tamep-&gt;namep) );
			}
		set3var("*", stem);
		setvar("%", stem, YES);
		implcom = lp-&gt;shp;
		goto endloop;
		}

endloop:


if(errstat==0 &amp;&amp; (ptime&lt;tdep || (ptime==0 &amp;&amp; tdep==0) ) )
	{
	ptime = (tdep&gt;0 ? tdep : prestime() );
	set3var("@", p-&gt;namep);
	setvar("?", mkqlist(qchain,qbuf), YES);
	setvar("^", mkqlist(allchain,tgsbuf), YES);
	if(explcom)
		errstat += docom(explcom, nowait, nproc1);
	else if(implcom)
		errstat += docom(implcom, nowait, nproc1);
	else if(p-&gt;septype == 0)
		if(p1=srchname(".DEFAULT"))
			{
			set3var("&lt;", p-&gt;namep);
			for(lp2 = p1-&gt;linep ; lp2 ; lp2 = lp2-&gt;nxtlineblock)
				if(implcom = lp2-&gt;shp)
					{
					errstat += docom(implcom, nowait,nproc1);
					break;
					}
			}
		else if(keepgoing)
			{
			printf("Don't know how to make %s\n", p-&gt;namep);
			++errstat;
			}
		else
			fatal1(" Don't know how to make %s", p-&gt;namep);

	set3var("@", CHNULL);
	if(noexflag || nowait || (ptime = exists(p-&gt;namep)) == 0 )
		ptime = prestime();
	}

else if(errstat!=0 &amp;&amp; reclevel==0)
	printf("`%s' not remade because of errors\n", p-&gt;namep);

else if(!questflag &amp;&amp; reclevel==0  &amp;&amp;  didwork==NO)
	printf("`%s' is up to date.\n", p-&gt;namep);

if(questflag &amp;&amp; reclevel==0)
	exit(ndocoms&gt;0 ? -1 : 0);

p-&gt;done = (errstat ? 3 : 2);
if(ptime1 &gt; ptime)
	ptime = ptime1;
p-&gt;modtime = ptime;
*tval = ptime;
return errstat;
}

docom(struct shblock *q, int nowait, int nproc1)
{
char *s;
int ign, nopr, doit;
char string[OUTMAX];

++ndocoms;
if(questflag)
	return NO;

if(touchflag)
	{
	s = varptr("@")-&gt;varval;
	if(!silflag)
		printf("touch(%s)\n", s);
	if(!noexflag)
		touch(YES, s);
	return NO;
	}

if(nproc1 &lt; nproc)
	waitstack(nproc1);

for( ; q ; q = q-&gt;nxtshblock )
	{
	subst(q-&gt;shbp, string, &amp;string[sizeof string - 1]);
	ign = ignerr;
	nopr = NO;
	doit = NO;
	for(s = string ; ; ++s)
		{
		switch(*s)
			{
			case '-':
				ign = YES;
				continue;
			case '@':
				nopr = YES;
				continue;
			case '+':
				doit = YES;
				continue;
			default:
				break;
			}
		break;
		}

	if( docom1(s, ign, nopr, doit||!noexflag, nowait&amp;&amp;!q-&gt;nxtshblock) &amp;&amp; !ign)
		return YES;
	}
return NO;
}


static int
docom1(char *comstring, int nohalt, int noprint, int doit, int nowait)
{
int status;
char *prefix;

if(comstring[0] == '\0')
	return 0;

if(!silflag &amp;&amp; (!noprint || !doit) )
	prefix = doit ? prompt : "" ;
else
	prefix = CHNULL;

if(dynmacro(comstring) || !doit)
	{
	if(prefix)
		{
		fputs(prefix, stdout);
		puts(comstring);	/* with a newline */
		fflush(stdout);
		}
	return 0;
	}

status = dosys(comstring, nohalt, nowait, prefix);
baddirs();	/* directories may have changed */
return status;
}


/*
   If there are any Shell meta characters in the name,
   expand into a list, after searching directory
*/

static void
expand(depblkp q)
{
char *s;
char *s1;
depblkp p;

s1 = q-&gt;depname-&gt;namep;
for(s=s1 ; ;) switch(*s++)
	{
	case '\0':
		return;

	case '*':
	case '?':
	case '[':
		if( p = srchdir(s1 , YES, q-&gt;nxtdepblock) )
			{
			q-&gt;nxtdepblock = p;
			q-&gt;depname = 0;
			}
		return;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

