<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/make/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/make/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
# include "defs.h"
/*
command make to update programs.
Posix Flags:
	'e'  use environment macros after rather than before makefiles
	'f'  the next argument is the name of the description file;
	     "makefile" is the default
	'i'  ignore error codes from the shell
	'k'  continue to update other targets that don't depend
	     on target if error occurs making a target
	'n'  don't issue, just print, commands
	'p'  print out a version of the input graph
	'q'  don't do anything, but check if object is up to date;
	     returns exit code 0 if up to date, 1 if not
	'r'  clear the builtin suffix list and don't use built-in rules
	's'  silent mode--don't print out commands
	'S'  stop after any command fails (default; opposite of -k)
	't'  touch (update time of) files but don't issue command

Nonposix Flags:
	'd'  print out debugging comments
	'N'  use % patterns instead of old suffix rules
	'Pn' set process limit to n
	'z'  always use shell, never issue commands directly

*/

nameblkp mainname	= NULL;
nameblkp firstname	= NULL;
lineblkp sufflist	= NULL;
struct varblock *firstvar	= NULL;
struct pattern *firstpat	= NULL;
struct dirhd *firstod		= NULL;
wildp firstwild			= NULL;
wildp lastwild			= NULL;
nameblkp *hashtab;
int nhashed;
int hashsize;
int hashthresh;

int proclimit	= PROCLIMIT;
int nproc	= 0;
int proclive	= 0;
struct process procstack[MAXPROC];

int sigivalue	= 0;
int sigqvalue	= 0;

int dbgflag	= NO;
int prtrflag	= NO;
int silflag	= NO;
int noexflag	= NO;
int keepgoing	= NO;
int noruleflag	= NO;
int touchflag	= NO;
int questflag	= NO;
int oldflag	= YES;
int ndocoms	= NO;
int ignerr	= NO;    /* default is to stop on error */
int forceshell	= NO;
int okdel	= YES;
int envlast	= NO;
int inarglist	= NO;
char **envpp	= NULL;

extern char *dfltmacro[];
extern char *dfltpat[];
extern char *dfltsuff[];
extern char **environ;
char **linesptr;

char *prompt	= "";
int nopdir	= 0;
char funny[128];

static void	loadenv(void);
static int	isprecious(char *);
static int	rddescf(char *);
static void	rdarray(char **);
static void	printdesc(int);

void
main(int argc, char **argv)
{
nameblkp p;
int i, j;
int descset, nfargs;
int nowait = NO;
time_t tjunk;
char c, *s, *mkflagp;
static char makeflags[30] = "-";
static char onechar[2] = "X";

descset = 0;
mkflagp = makeflags+1;

funny['\0'] = (META | TERMINAL);
for(s = "=|^();&amp;&lt;&gt;*?[]:$`'\"\\\n" ; *s ; ++s)
	funny[*s] |= META;
for(s = "\n\t :;&amp;&gt;|" ; *s ; ++s)
	funny[*s] |= TERMINAL;


newhash(HASHSIZE);

inarglist = YES;
for(i=1; i&lt;argc; ++i)
	if(argv[i]!=0 &amp;&amp; argv[i][0]!='-' &amp;&amp; eqsign(argv[i]))
		argv[i] = 0;

setvar("$", "$", NO);
inarglist = NO;

for(i=1; i&lt;argc; ++i)
    if(argv[i]!=0 &amp;&amp; argv[i][0]=='-')
	{
	for(j=1 ; (c=argv[i][j])!='\0' ; ++j)  switch(c)
		{
		case 'd':
			++dbgflag;
			*mkflagp++ = 'd';
			break;

		case 'e':
			envlast = YES;
			*mkflagp++ = 'e';
			break;

		case 'f':
			if(i &gt;= argc-1)
			  fatal("No description argument after -f flag");
			if( ! rddescf(argv[i+1]) )
				fatal1("Cannot open %s", argv[i+1]);
			argv[i+1] = 0;
			++descset;
			break;

		case 'i':
			ignerr = YES;
			*mkflagp++ = 'i';
			break;

		case 'k':
			keepgoing = YES;
			*mkflagp++ = 'k';
			break;

		case 'n':
			noexflag = YES;
			*mkflagp++ = 'n';
			break;

		case 'N':
			oldflag = NO;
			*mkflagp++ = 'N';
			break;
	
		case 'p':
			prtrflag = YES;
			break;

		case 'P':
			if(isdigit(argv[i][j+1]))
				{
				proclimit = argv[i][++j] - '0';
				if(proclimit &lt; 1)
					proclimit = 1;
				}
			else
				fatal("illegal proclimit parameter");
			*mkflagp++ = 'P';
			*mkflagp++ = argv[i][j];
			break;

		case 'q':
			questflag = YES;
			*mkflagp++ = 'q';
			break;

		case 'r':
			noruleflag = YES;
			*mkflagp++ = 'r';
			break;

		case 's':
			silflag = YES;
			*mkflagp++ = 's';
			break;

		case 'S':
			keepgoing = NO;
			*mkflagp++ = 'S';
			break;

		case 't':
			touchflag = YES;
			*mkflagp++ = 't';
			break;

		case 'z':
			forceshell = YES;
			*mkflagp++ = 'z';
			break;

		default:
			onechar[0] = c;	/* to make lint happy */
			fatal1("Unknown flag argument %s", onechar);
		}

	argv[i] = NULL;
	}

if(mkflagp &gt; makeflags+1)
	setvar("MAKEFLAGS", makeflags, NO);

if( !descset )
if(	!rddescf("makefile") &amp;&amp;
	!rddescf("Makefile") &amp;&amp;
	(exists(s = "s.makefile") || exists(s = "s.Makefile")) )
		{
		char junk[20];
		concat("get ", s, junk);
		(void) dosys(junk, NO, NO, junk);
		rddescf(s+2);
		unlink(s+2);
		}


if(envlast)
	loadenv();
if(!noruleflag &amp;&amp; !oldflag)
	rdarray(dfltpat);

if(prtrflag) printdesc(NO);

if( srchname(".IGNORE") )
	ignerr = YES;
if( srchname(".SILENT") )
	silflag = YES;
if( srchname(".OLDFLAG") )
	oldflag = YES;
if( p=srchname(".SUFFIXES") )
	sufflist = p-&gt;linep;
if( !sufflist &amp;&amp; !firstwild)
	fprintf(stderr,"No suffix or %% pattern list.\n");
/*
if(sufflist &amp;&amp; !oldflag)
	fprintf(stderr, "Suffix lists are old-fashioned. Use %% patterns\n);
*/

	sigivalue = (int) signal(SIGINT, SIG_IGN);
	sigqvalue = (int) signal(SIGQUIT, SIG_IGN);
	enbint(intrupt);

nfargs = 0;

for(i=1; i&lt;argc; ++i)
	if(s = argv[i])
		{
		if((p=srchname(s)) == NULL)
			p = makename(s);
		++nfargs;
		if(i+1&lt;argc &amp;&amp; argv[i+1] != 0 &amp;&amp; equal(argv[i+1], "&amp;") )
			{
			++i;
			nowait = YES;
			}
		else
			nowait = NO;
		doname(p, 0, &amp;tjunk, nowait);
		if(dbgflag) printdesc(YES);
		}

/*
If no file arguments have been encountered, make the first
name encountered that doesn't start with a dot
*/

if(nfargs == 0)
	if(mainname == 0)
		fatal("No arguments or description file");
	else	{
		doname(mainname, 0, &amp;tjunk, NO);
		if(dbgflag) printdesc(YES);
		}

if(!nowait)
	waitstack(0);
exit(0);
}


void
intrupt(int sig)
{
char *p;

if(okdel &amp;&amp; !noexflag &amp;&amp; !touchflag &amp;&amp;
	(p = varptr("@")-&gt;varval) &amp;&amp; exists(p)&gt;0 &amp;&amp; !isprecious(p) )
		{
		fprintf(stderr, "\n***  %s removed.", p);
		remove(p);
		}

fprintf(stderr, "\n");
exit(2);
}



static int
isprecious(char *p)
{
lineblkp lp;
depblkp dp;
nameblkp np;

if(np = srchname(".PRECIOUS"))
	for(lp = np-&gt;linep ; lp ; lp = lp-&gt;nxtlineblock)
		for(dp = lp-&gt;depp ; dp ; dp = dp-&gt;nxtdepblock)
			if(equal(p, dp-&gt;depname-&gt;namep))
				return YES;

return NO;
}


void
enbint(void (*k)(int))
{
if(sigivalue == 0)
	signal(SIGINT,k);
if(sigqvalue == 0)
	signal(SIGQUIT,k);
}

static int
rddescf(char *descfile)
{
static int firstrd = YES;

/* read and parse description */

if(firstrd)
	{
	firstrd = NO;
	if( !noruleflag )
		{
		rdarray(dfltmacro);
		if(oldflag)
			rdarray(dfltsuff);
		}
	if(!envlast)
		loadenv();

	}

return  parse(descfile);
}

static void
rdarray(char **s)
{
linesptr = s;
parse(CHNULL);
}

static void
loadenv(void)
{
for(envpp = environ ; *envpp ; ++envpp)
	eqsign(*envpp);
envpp = NULL;
}

static void
printdesc(int prntflag)
{
nameblkp p;
depblkp dp;
struct varblock *vp;
struct dirhd *od;
struct shblock *sp;
lineblkp lp;

if(prntflag)
	{
	printf("Open directories:\n");
	for (od = firstod; od; od = od-&gt;nxtdirhd)
		printf("\t%s\n", od-&gt;dirn);
	}

if(firstvar != 0) printf("Macros:\n");
for(vp = firstvar; vp ; vp = vp-&gt;nxtvarblock)
	printf("\t%s = %s\n" , vp-&gt;varname , vp-&gt;varval ? vp-&gt;varval : "(null)");

for(p = firstname; p; p = p-&gt;nxtnameblock)
	{
	printf("\n\n%s",p-&gt;namep);
	if(p-&gt;linep != 0) printf(":");
	if(prntflag) printf("  done=%d",p-&gt;done);
	if(p==mainname) printf("  (MAIN NAME)");
	for(lp = p-&gt;linep ; lp ; lp = lp-&gt;nxtlineblock)
		{
		if( dp = lp-&gt;depp )
			{
			printf("\n depends on:");
			for(; dp ; dp = dp-&gt;nxtdepblock)
				if(dp-&gt;depname != 0)
					printf(" %s ", dp-&gt;depname-&gt;namep);
			}
	
		if(sp = lp-&gt;shp)
			{
			printf("\n commands:\n");
			for( ; sp ; sp = sp-&gt;nxtshblock)
				printf("\t%s\n", sp-&gt;shbp);
			}
		}
	}
printf("\n");
fflush(stdout);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

