<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pax/link.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pax/link.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* $Source: /u/mark/src/pax/RCS/link.c,v $
 *
 * $Revision: 1.2 $
 *
 * link.c - functions for handling multiple file links 
 *
 * DESCRIPTION
 *
 *	These function manage the link chains which are used to keep track
 *	of outstanding links during archive reading and writing.
 *
 * AUTHOR
 *
 *	Mark H. Colburn, NAPS International (mark@jhereg.mn.org)
 *
 * Sponsored by The USENIX Association for public distribution. 
 *
 * Copyright (c) 1989 Mark H. Colburn.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice is duplicated in all such 
 * forms and that any documentation, advertising materials, and other 
 * materials related to such distribution and use acknowledge that the 
 * software was developed * by Mark H. Colburn and sponsored by The 
 * USENIX Association. 
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Log:	link.c,v $
 * Revision 1.2  89/02/12  10:04:38  mark
 * 1.2 release fixes
 * 
 * Revision 1.1  88/12/23  18:02:12  mark
 * Initial revision
 * 
 */

#ifndef lint
static char *ident = "$Id: link.c,v 1.2 89/02/12 10:04:38 mark Exp $";
static char *copyright = "Copyright (c) 1989 Mark H. Colburn.\nAll rights reserved.\n";
#endif /* ! lint */


/* Headers */

#include "pax.h"


/* Defines */

/*
 * Address link information base. 
 */
#define	LINKHASH(ino)	(linkbase + (ino) % NEL(linkbase))

/*
 * Number of array elements. 
 */
#define	NEL(a)		(sizeof(a) / sizeof(*(a)))



/* Internal Identifiers */

static Link    *linkbase[256];	/* Unresolved link information */


/* linkfrom - find a file to link from 
 *
 * DESCRIPTION
 *
 *	Linkfrom searches the link chain to see if there is a file in the
 *	link chain which has the same inode number as the file specified
 *	by the stat block pointed at by asb.  If a file is found, the
 *	name is returned to the caller, otherwise a NULL is returned.
 *
 * PARAMETERS
 *
 *	char    *name   - name of the file which we are attempting
 *                        to find a link for
 *	Stat	*asb	- stat structure of file to find a link to
 *
 * RETURNS
 *
 * 	Returns a pointer to a link structure, or NULL if unsuccessful. 
 *
 */

#ifdef __STDC__

Link *linkfrom(char *name, Stat *asb)

#else
    
Link *linkfrom(name, asb)
char           *name;
Stat           *asb;

#endif
{
    Link           *linkp;
    Link           *linknext;
    Path           *path;
    Path           *pathnext;
    Link          **abase;

    for (linkp = *(abase = LINKHASH(asb-&gt;sb_ino)); linkp; linkp = linknext) {
	if (linkp-&gt;l_nlink == 0) {
	    if (linkp-&gt;l_name) {
		free((char *) linkp-&gt;l_name);
	    }
	    if (linknext = linkp-&gt;l_forw) {
		linknext-&gt;l_back = linkp-&gt;l_back;
	    }
	    if (linkp-&gt;l_back) {
		linkp-&gt;l_back-&gt;l_forw = linkp-&gt;l_forw;
	    }
	    free((char *) linkp);
	    *abase = (Link *)NULL;
	} else if (linkp-&gt;l_ino == asb-&gt;sb_ino &amp;&amp; linkp-&gt;l_dev == asb-&gt;sb_dev) {
	    /* 
	     * check to see if a file with the name "name" exists in the 
	     * chain of files which we have for this particular link
	     */
	    for (path = linkp-&gt;l_path; path; path = pathnext) {
		if (strcmp(path-&gt;p_name, name) == 0) {
		    --linkp-&gt;l_nlink;
		    if (path-&gt;p_name) {
			free(path-&gt;p_name);
		    }
		    if (pathnext = path-&gt;p_forw) {
			pathnext-&gt;p_back = path-&gt;p_back;
		    }
		    if (path-&gt;p_back) {
			path-&gt;p_back-&gt;p_forw = pathnext;
		    }
		    if (linkp-&gt;l_path == path) {
			linkp-&gt;l_path = pathnext;
		    }
		    free(path);
		    return (linkp);
		}
		pathnext = path-&gt;p_forw;
	    }
	    return((Link *)NULL);
	} else {
	    linknext = linkp-&gt;l_forw;
	}
    }
    return ((Link *)NULL);
}



/* islink - determine whether a given file really a link
 *
 * DESCRIPTION
 *
 *	Islink searches the link chain to see if there is a file in the
 *	link chain which has the same inode number as the file specified
 *	by the stat block pointed at by asb.  If a file is found, a
 *	non-zero value is returned to the caller, otherwise a 0 is
 *	returned.
 *
 * PARAMETERS
 *
 *	char    *name   - name of file to check to see if it is link.
 *	Stat	*asb	- stat structure of file to find a link to
 *
 * RETURNS
 *
 * 	Returns a pointer to a link structure, or NULL if unsuccessful. 
 *
 */

#ifdef __STDC__

Link *islink(char *name, Stat *asb)

#else
    
Link *islink(name, asb)
char           *name;
Stat           *asb;

#endif
{
    Link           *linkp;
    Link           *linknext;

    for (linkp = *(LINKHASH(asb-&gt;sb_ino)); linkp; linkp = linknext) {
	if (linkp-&gt;l_ino == asb-&gt;sb_ino &amp;&amp; linkp-&gt;l_dev == asb-&gt;sb_dev) {
	    if (strcmp(name, linkp-&gt;l_name) == 0) {
		return ((Link *)NULL);
	    } 
	    return (linkp);
	} else {
	    linknext = linkp-&gt;l_forw;
	}
    }
    return ((Link *)NULL);
}


/* linkto  - remember a file with outstanding links 
 *
 * DESCRIPTION
 *
 *	Linkto adds the specified file to the link chain.  Any subsequent
 *	calls to linkfrom which have the same inode will match the file
 *	just entered.  If not enough space is available to make the link
 *	then the item is not added to the link chain, and a NULL is
 *	returned to the calling function.
 *
 * PARAMETERS
 *
 *	char	*name	- name of file to remember
 *	Stat	*asb	- pointer to stat structure of file to remember
 *
 * RETURNS
 *
 * 	Returns a pointer to the associated link structure, or NULL when 
 *	linking is not possible. 
 *
 */

#ifdef __STDC__

Link *linkto(char *name, Stat *asb)

#else
    
Link *linkto(name, asb)
char           *name;
Stat           *asb;

#endif
{
    Link           *linkp;
    Link           *linknext;
    Path           *path;
    Link          **abase;

    for (linkp = *(LINKHASH(asb-&gt;sb_ino)); linkp; linkp = linknext) {
	if (linkp-&gt;l_ino == asb-&gt;sb_ino &amp;&amp; linkp-&gt;l_dev == asb-&gt;sb_dev) {
	    if ((path = (Path *) mem_get(sizeof(Path))) == (Path *)NULL || 
		(path-&gt;p_name = mem_str(name)) == (char *)NULL) {
		return((Link *)NULL);
	    }
	    if (path-&gt;p_forw = linkp-&gt;l_path) {
		if (linkp-&gt;l_path-&gt;p_forw) {
		    linkp-&gt;l_path-&gt;p_forw-&gt;p_back = path;
		}
	    } else {
		linkp-&gt;l_path = path;
	    }
	    path-&gt;p_back = (Path *)NULL;
	    return(linkp);
	} else {
	    linknext = linkp-&gt;l_forw;
	}
    }
    /*
     * This is a brand new link, for which there is no other information
     */

    if ((asb-&gt;sb_mode &amp; S_IFMT) == S_IFDIR
	|| (linkp = (Link *) mem_get(sizeof(Link))) == (Link *)NULL
	|| (linkp-&gt;l_name = mem_str(name)) == (char *)NULL) {
	return ((Link *)NULL);
    }
    linkp-&gt;l_dev = asb-&gt;sb_dev;
    linkp-&gt;l_ino = asb-&gt;sb_ino;
    linkp-&gt;l_nlink = asb-&gt;sb_nlink - 1;
    linkp-&gt;l_size = asb-&gt;sb_size;
    linkp-&gt;l_path = (Path *)NULL;
    if (linkp-&gt;l_forw = *(abase = LINKHASH(asb-&gt;sb_ino))) {
	linkp-&gt;l_forw-&gt;l_back = linkp;
    } else {
	*abase = linkp;
    }
    linkp-&gt;l_back = (Link *)NULL;
    return (linkp);
}


/* linkleft - complain about files with unseen links 
 *
 * DESCRIPTION
 *
 *	Linksleft scans through the link chain to see if there were any
 *	files which have outstanding links that were not processed by the
 *	archive.  For each file in the link chain for which there was not
 *	a file,  and error message is printed.
 */

#ifdef __STDC__

void linkleft(void)

#else
    
void linkleft()

#endif
{
    Link           *lp;
    Link          **base;

    for (base = linkbase; base &lt; linkbase + NEL(linkbase); ++base) {
	for (lp = *base; lp; lp = lp-&gt;l_forw) {
	    if (lp-&gt;l_nlink) {
		warn(lp-&gt;l_path-&gt;p_name, "Unseen link(s)");
	    }
	}
    }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

