<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * signal handling
 */

/* Kludge to avoid bogus re-declaration of sigtraps[] error on AIX 3.2.5 */
#define FROM_TRAP_C
#include "sh.h"

/* Table is indexed by signal number
 *
 * The script siglist.sh generates siglist.out, which is a sorted, complete
 * list of signals
 */
Trap sigtraps[SIGNALS+1] = {
	{ SIGEXIT_, "EXIT", "Signal 0" },
	{ 1 , "HUP", "Hangup" },
	{ 2 , "INT", "Interrupt" },
	{ 3 , "QUIT", "Quit" },
	{ 4 , "ILL", "Illegal instruction" },
	{ 5 , "ABRT", "Abort" },
	{ 6 , "FPE", "Floating point exception" },
	{ 7 , "KILL", "Killed" },
	{ 8 , "SEGV", "Memory fault" },
	{ 9 , "PIPE", "Broken pipe" },
	{ 10 , "ALRM", "Alarm clock" },
	{ 11 , "TERM", "Terminated" },
	{ 12 , "USR1", "User defined signal 1" },
	{ 13 , "USR2", "User defined signal 2" },
	{ 14 , "BUS", "Bus error" },
	{ 15 , "CHLD", "Child exited" },
	{ 16 , "CONT", "Continued" },
	{ 17 , "STOP", "Stopped (signal)" },
	{ 18 , "TSTP", "Stopped" },
	{ 19 , "TTIN", "Stopped (tty input)" },
	{ 20 , "TTOU", "Stopped (tty output)" },
	{ SIGERR_,  "ERR",  "Error handler" },
    };

static struct sigaction Sigact_ign, Sigact_trap;

void
inittraps()
{
#ifdef HAVE_SYS_SIGLIST
# ifndef SYS_SIGLIST_DECLARED
	extern char	*sys_siglist[];
# endif
	int	i;

	/* Use system description, if available, for unknown signals... */
	for (i = 0; i &lt; NSIG; i++)
		if (!sigtraps[i].name &amp;&amp; sys_siglist[i] &amp;&amp; sys_siglist[i][0])
			sigtraps[i].mess = sys_siglist[i];
#endif	/* HAVE_SYS_SIGLIST */

	sigemptyset(&amp;Sigact_ign.sa_mask);
	Sigact_ign.sa_flags = KSH_SA_FLAGS;
	Sigact_ign.sa_handler = SIG_IGN;
	Sigact_trap = Sigact_ign;
	Sigact_trap.sa_handler = trapsig;

	sigtraps[SIGINT].flags |= TF_DFL_INTR | TF_TTY_INTR;
	sigtraps[SIGQUIT].flags |= TF_DFL_INTR | TF_TTY_INTR;
	sigtraps[SIGTERM].flags |= TF_DFL_INTR;/* not fatal for interactive */
	sigtraps[SIGHUP].flags |= TF_FATAL;
	sigtraps[SIGCHLD].flags |= TF_SHELL_USES;

	/* these are always caught so we can clean up any temproary files. */
	setsig(&amp;sigtraps[SIGINT], trapsig, SS_RESTORE_ORIG);
	setsig(&amp;sigtraps[SIGQUIT], trapsig, SS_RESTORE_ORIG);
	setsig(&amp;sigtraps[SIGTERM], trapsig, SS_RESTORE_ORIG);
	setsig(&amp;sigtraps[SIGHUP], trapsig, SS_RESTORE_ORIG);
}

#ifdef KSH
static RETSIGTYPE alarm_catcher ARGS((int sig));

void
alarm_init()
{
	sigtraps[SIGALRM].flags |= TF_SHELL_USES;
	setsig(&amp;sigtraps[SIGALRM], alarm_catcher,
		SS_RESTORE_ORIG|SS_FORCE|SS_SHTRAP);
}

static RETSIGTYPE
alarm_catcher(sig)
	int sig;
{
	if (ksh_tmout_state == TMOUT_READING) {
		int left = alarm(0);

		if (left == 0) {
			ksh_tmout_state = TMOUT_LEAVING;
			intrsig = 1;
		} else
			alarm(left);
	}
	return RETSIGVAL;
}
#endif /* KSH */

Trap *
gettrap(name, igncase)
	const char *name;
	int igncase;
{
	int i;
	register Trap *p;

	if (digit(*name)) {
		int n;

		if (getn(name, &amp;n) &amp;&amp; 0 &lt;= n &amp;&amp; n &lt; SIGNALS)
			return &amp;sigtraps[n];
		return NULL;
	}
	if (strncasecmp(name, "sig", 3) == 0)
		name += 3;
	for (p = sigtraps, i = SIGNALS+1; --i &gt;= 0; p++)
		if (p-&gt;name &amp;&amp; (igncase ? strcasecmp(p-&gt;name, name) == 0
					: strcmp(p-&gt;name, name) == 0))
			return p;
	return NULL;
}

/*
 * trap signal handler
 */
RETSIGTYPE
trapsig(i)
	int i;
{
	Trap *p = &amp;sigtraps[i];

	trap = p-&gt;set = 1;
	if (p-&gt;flags &amp; TF_DFL_INTR)
		intrsig = 1;
	if ((p-&gt;flags &amp; TF_FATAL) &amp;&amp; !p-&gt;trap) {
		fatal_trap = 1;
		intrsig = 1;
	}
	if (p-&gt;shtrap)
		(*p-&gt;shtrap)(i);
#ifdef V7_SIGNALS
	if (sigtraps[i].cursig == trapsig) /* this for SIGCHLD,SIGALRM */
		sigaction(i, &amp;Sigact_trap, (struct sigaction *) 0);
#endif /* V7_SIGNALS */
	return RETSIGVAL;
}

/* called when we want to allow the user to ^C out of something - won't
 * work if user has trapped SIGINT.
 */
void
intrcheck()
{
	if (intrsig)
		runtraps(TF_DFL_INTR|TF_FATAL);
}

/* called after EINTR to check if a signal with normally causes process
 * termination has been received.
 */
int
fatal_trap_check()
{
	int i;
	Trap *p;

	/* todo: should check if signal is fatal, not the TF_DFL_INTR flag */
	for (p = sigtraps, i = SIGNALS+1; --i &gt;= 0; p++)
		if (p-&gt;set &amp;&amp; (p-&gt;flags &amp; (TF_DFL_INTR|TF_FATAL)))
			/* return value is used as an exit code */
			return 128 + p-&gt;signal;
	return 0;
}

/* Returns the signal number of any pending traps: ie, a signal which has
 * occured for which a trap has been set or for which the TF_DFL_INTR flag
 * is set.
 */
int
trap_pending()
{
	int i;
	Trap *p;

	for (p = sigtraps, i = SIGNALS+1; --i &gt;= 0; p++)
		if (p-&gt;set &amp;&amp; ((p-&gt;trap &amp;&amp; p-&gt;trap[0])
			       || ((p-&gt;flags &amp; (TF_DFL_INTR|TF_FATAL))
				   &amp;&amp; !p-&gt;trap)))
			return p-&gt;signal;
	return 0;
}

/*
 * run any pending traps.  If intr is set, only run traps that
 * can interrupt commands.
 */
void
runtraps(flag)
	int flag;
{
	int i;
	register Trap *p;

#ifdef KSH
	if (ksh_tmout_state == TMOUT_LEAVING) {
		ksh_tmout_state = TMOUT_EXECUTING;
		warningf(FALSE, "timed out waiting for input");
		unwind(LEXIT);
	} else
		/* XXX: this means the alarm will have no effect if a trap
		 * is caught after the alarm() was started...not good.
		 */
		ksh_tmout_state = TMOUT_EXECUTING;
#endif /* KSH */
	if (!flag)
		trap = 0;
	if (flag &amp; TF_DFL_INTR)
		intrsig = 0;
	if (flag &amp; TF_FATAL)
		fatal_trap = 0;
	for (p = sigtraps, i = SIGNALS+1; --i &gt;= 0; p++)
		if (p-&gt;set &amp;&amp; (!flag
			       || ((p-&gt;flags &amp; flag) &amp;&amp; p-&gt;trap == (char *) 0)))
			runtrap(p);
}

void
runtrap(p)
	Trap *p;
{
	int	i = p-&gt;signal;
	char	*trapstr = p-&gt;trap;
	int	oexstat;
	int	UNINITIALIZED(old_changed);

	p-&gt;set = 0;
	if (trapstr == (char *) 0) { /* SIG_DFL */
		if (p-&gt;flags &amp; TF_FATAL) {
			/* eg, SIGHUP */
			exstat = 128 + i;
			unwind(LLEAVE);
		}
		if (p-&gt;flags &amp; TF_DFL_INTR) {
			/* eg, SIGINT, SIGQUIT, SIGTERM, etc. */
			exstat = 128 + i;
			unwind(LINTR);
		}
		return;
	}
	if (trapstr[0] == '\0') /* SIG_IGN */
		return;
	if (i == SIGEXIT_ || i == SIGERR_) {	/* avoid recursion on these */
		old_changed = p-&gt;flags &amp; TF_CHANGED;
		p-&gt;flags &amp;= ~TF_CHANGED;
		p-&gt;trap = (char *) 0;
	}
	oexstat = exstat;
	/* Note: trapstr is fully parsed before anything is executed, thus
	 * no problem with afree(p-&gt;trap) in settrap() while still in use.
	 */
	command(trapstr);
	exstat = oexstat;
	if (i == SIGEXIT_ || i == SIGERR_) {
		if (p-&gt;flags &amp; TF_CHANGED)
			/* don't clear TF_CHANGED */
			afree(trapstr, APERM);
		else
			p-&gt;trap = trapstr;
		p-&gt;flags |= old_changed;
	}
}
 
/* clear pending traps and reset user's trap handlers; used after fork(2) */
void
cleartraps()
{
	int i;
	Trap *p;

	trap = 0;
	intrsig = 0;
	fatal_trap = 0;
	for (i = SIGNALS+1, p = sigtraps; --i &gt;= 0; p++) {
		p-&gt;set = 0;
		if ((p-&gt;flags &amp; TF_USER_SET) &amp;&amp; (p-&gt;trap &amp;&amp; p-&gt;trap[0]))
			settrap(p, (char *) 0);
	}
}

/* restore signals just before an exec(2) */
void
restoresigs()
{
	int i;
	Trap *p;

	for (i = SIGNALS+1, p = sigtraps; --i &gt;= 0; p++)
		if (p-&gt;flags &amp; (TF_EXEC_IGN|TF_EXEC_DFL))
			setsig(p, (p-&gt;flags &amp; TF_EXEC_IGN) ? SIG_IGN : SIG_DFL,
				SS_RESTORE_CURR|SS_FORCE);
}

void
settrap(p, s)
	Trap *p;
	char *s;
{
	handler_t f;

	if (p-&gt;trap)
		afree(p-&gt;trap, APERM);
	p-&gt;trap = str_save(s, APERM); /* handles s == 0 */
	p-&gt;flags |= TF_CHANGED;
	f = !s ? SIG_DFL : s[0] ? trapsig : SIG_IGN;

	p-&gt;flags |= TF_USER_SET;
	if ((p-&gt;flags &amp; (TF_DFL_INTR|TF_FATAL)) &amp;&amp; f == SIG_DFL)
		f = trapsig;
	else if (p-&gt;flags &amp; TF_SHELL_USES) {
		if (!(p-&gt;flags &amp; TF_ORIG_IGN) || Flag(FTALKING)) {
			/* do what user wants at exec time */
			p-&gt;flags &amp;= ~(TF_EXEC_IGN|TF_EXEC_DFL);
			if (f == SIG_IGN)
				p-&gt;flags |= TF_EXEC_IGN;
			else
				p-&gt;flags |= TF_EXEC_DFL;
		}
		/* assumes handler already set to what shell wants it
		 * (normally trapsig, but could be j_sigchld() or SIG_IGN)
		 */
		return;
	}

	/* todo: should we let user know signal is ignored? how? */
	setsig(p, f, SS_RESTORE_CURR|SS_USER);
}

/* Called by c_print() when writing to a co-process to ensure SIGPIPE won't
 * kill shell (unless user catches it and exits)
 */
int
block_pipe()
{
	int restore_dfl = 0;
	Trap *p = &amp;sigtraps[SIGPIPE];

	if (!(p-&gt;flags &amp; (TF_ORIG_IGN|TF_ORIG_DFL))) {
		setsig(p, SIG_IGN, SS_RESTORE_CURR);
		if (p-&gt;flags &amp; TF_ORIG_DFL)
			restore_dfl = 1;
	} else if (p-&gt;cursig == SIG_DFL) {
		setsig(p, SIG_IGN, SS_RESTORE_CURR);
		restore_dfl = 1; /* restore to SIG_DFL */
	}
	return restore_dfl;
}

/* Called by c_print() to undo whatever block_pipe() did */
void
restore_pipe(restore_dfl)
	int restore_dfl;
{
	if (restore_dfl)
		setsig(&amp;sigtraps[SIGPIPE], SIG_DFL, SS_RESTORE_CURR);
}

/* Set action for a signal.  Action may not be set if original
 * action was SIG_IGN, depending on the value of flags and
 * FTALKING.
 */
int
setsig(p, f, flags)
	Trap *p;
	handler_t f;
	int flags;
{
	struct sigaction sigact;

	if (p-&gt;signal == SIGEXIT_ || p-&gt;signal == SIGERR_)
		return 1;

	/* First time setting this signal?  If so, get and note the current
	 * setting.
	 */
	if (!(p-&gt;flags &amp; (TF_ORIG_IGN|TF_ORIG_DFL))) {
		sigaction(p-&gt;signal, &amp;Sigact_ign, &amp;sigact);
		p-&gt;flags |= sigact.sa_handler == SIG_IGN ?
					TF_ORIG_IGN : TF_ORIG_DFL;
		p-&gt;cursig = SIG_IGN;
	}

	/* Generally, an ignored signal stays ignored, except if
	 *	- the user of an interactive shell wants to change it
	 *	- the shell wants for force a change
	 */
	if ((p-&gt;flags &amp; TF_ORIG_IGN) &amp;&amp; !(flags &amp; SS_FORCE)
	    &amp;&amp; (!(flags &amp; SS_USER) || !Flag(FTALKING)))
		return 0;

	setexecsig(p, flags &amp; SS_RESTORE_MASK);

	/* This is here 'cause there should be a way of clearing shtraps, but
	 * don't know if this is a sane way of doing it.  At the moment,
	 * all users of shtrap are lifetime users (SIGCHLD, SIGALRM, SIGWINCH).
	 */
	if (!(flags &amp; SS_USER))
		p-&gt;shtrap = (handler_t) 0;
	if (flags &amp; SS_SHTRAP) {
		p-&gt;shtrap = f;
		f = trapsig;
	}

	if (p-&gt;cursig != f) {
		p-&gt;cursig = f;
		sigemptyset(&amp;sigact.sa_mask);
		sigact.sa_flags = KSH_SA_FLAGS;
		sigact.sa_handler = f;
		sigaction(p-&gt;signal, &amp;sigact, (struct sigaction *) 0);
	}

	return 1;
}

/* control what signal is set to before an exec() */
void
setexecsig(p, restore)
	Trap *p;
	int restore;
{
	/* XXX debugging */
	if (!(p-&gt;flags &amp; (TF_ORIG_IGN|TF_ORIG_DFL)))
		internal_errorf(1, "setexecsig: unset signal %d(%s)",
			p-&gt;signal, p-&gt;name);

	/* restore original value for exec'd kids */
	p-&gt;flags &amp;= ~(TF_EXEC_IGN|TF_EXEC_DFL);
	switch (restore &amp; SS_RESTORE_MASK) {
	  case SS_RESTORE_CURR: /* leave things as they currently are */
		break;
	  case SS_RESTORE_ORIG:
		p-&gt;flags |= p-&gt;flags &amp; TF_ORIG_IGN ? TF_EXEC_IGN : TF_EXEC_DFL;
		break;
	  case SS_RESTORE_DFL:
		p-&gt;flags |= TF_EXEC_DFL;
		break;
	  case SS_RESTORE_IGN:
		p-&gt;flags |= TF_EXEC_IGN;
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

