<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/var.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/var.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sh.h"
#include "ksh_time.h"
#include "ksh_limval.h"
#include "ksh_stat.h"
#include &lt;ctype.h&gt;

/*
 * Variables
 *
 * WARNING: unreadable code, needs a rewrite
 *
 * if (flag&amp;INTEGER), val.i contains integer value, and type contains base.
 * otherwise, (val.s + type) contains string value.
 * if (flag&amp;EXPORT), val.s contains "name=value" for E-Z exporting.
 */
static	struct tbl vtemp;
static	struct table specials;
static char	*formatstr	ARGS((struct tbl *vp, const char *s));
static void	export		ARGS((struct tbl *vp, const char *val));
static int	special		ARGS((const char *name));
static void	unspecial	ARGS((const char *name));
static void	getspec		ARGS((struct tbl *vp));
static void	setspec		ARGS((struct tbl *vp));
static void	unsetspec	ARGS((struct tbl *vp));
static struct tbl *arraysearch  ARGS((struct tbl *, int));

/*
 * create a new block for function calls and simple commands
 * assume caller has allocated and set up e-&gt;loc
 */
void
newblock()
{
	register struct block *l;
	static char *const empty[] = {null};

	l = (struct block *) alloc(sizeof(struct block), ATEMP);
	l-&gt;flags = 0;
	ainit(&amp;l-&gt;area); /* todo: could use e-&gt;area (l-&gt;area =&gt; l-&gt;areap) */
	if (!e-&gt;loc) {
		l-&gt;argc = 0;
		l-&gt;argv = (char **) empty;
	} else {
		l-&gt;argc = e-&gt;loc-&gt;argc;
		l-&gt;argv = e-&gt;loc-&gt;argv;
	}
	l-&gt;exit = l-&gt;error = NULL;
	tinit(&amp;l-&gt;vars, &amp;l-&gt;area, 0);
	tinit(&amp;l-&gt;funs, &amp;l-&gt;area, 0);
	l-&gt;next = e-&gt;loc;
	e-&gt;loc = l;
}

/*
 * pop a block handling special variables
 */
void
popblock()
{
	register struct block *l = e-&gt;loc;
	register struct tbl *vp, **vpp = l-&gt;vars.tbls, *vq;
	register int i;

	e-&gt;loc = l-&gt;next;	/* pop block */
	for (i = l-&gt;vars.size; --i &gt;= 0; )
		if ((vp = *vpp++) != NULL &amp;&amp; (vp-&gt;flag&amp;SPECIAL))
			if ((vq = global(vp-&gt;name))-&gt;flag &amp; ISSET)
				setspec(vq);
			else
				unsetspec(vq);
	if (l-&gt;flags &amp; BF_DOGETOPTS)
		user_opt = l-&gt;getopts_state;
	afreeall(&amp;l-&gt;area);
	afree(l, ATEMP);
}

/* called by main() to initialize variable data structures */
void
initvar()
{
	static const struct {
		const char *name;
		int v;
	} names[] = {
			{ "COLUMNS",		V_COLUMNS },
			{ "IFS",		V_IFS },
			{ "OPTIND",		V_OPTIND },
			{ "PATH",		V_PATH },
			{ "POSIXLY_CORRECT",	V_POSIXLY_CORRECT },
			{ "TMPDIR",		V_TMPDIR },
#ifdef HISTORY
			{ "HISTFILE",		V_HISTFILE },
			{ "HISTSIZE",		V_HISTSIZE },
#endif /* HISTORY */
#ifdef EDIT
			{ "EDITOR",		V_EDITOR },
			{ "VISUAL",		V_VISUAL },
#endif /* EDIT */
#ifdef KSH
			{ "MAIL",		V_MAIL },
			{ "MAILCHECK",		V_MAILCHECK },
			{ "MAILPATH",		V_MAILPATH },
			{ "RANDOM",		V_RANDOM },
			{ "SECONDS",		V_SECONDS },
			{ "TMOUT",		V_TMOUT },
#endif /* KSH */
			{ "LINENO",		V_LINENO },
			{ (char *) 0,	0 }
		};
	int i;
	struct tbl *tp;

	tinit(&amp;specials, APERM, 32); /* must be 2^n (currently 17 specials) */
	for (i = 0; names[i].name; i++) {
		tp = tenter(&amp;specials, names[i].name, hash(names[i].name));
		tp-&gt;flag = DEFINED|ISSET;
		tp-&gt;type = names[i].v;
	}
}

/* Used to calculate an array index for global()/local().  Sets *arrayp to
 * non-zero if this is an array, sets *valp to the array index, returns
 * the basename of the array.
 */
const char *
array_index_calc(const char *n, bool_t *arrayp, int *valp)
{
	const char *p;
	int len;

	*arrayp = FALSE;
	p = skip_varname(n, FALSE);
	if (p != n &amp;&amp; *p == '[' &amp;&amp; (len = array_ref_len(p))) {
		char *sub, *tmp;
		long rval;

		/* Calculate the value of the subscript */
		*arrayp = TRUE;
		tmp = str_nsave(p+1, len-2, ATEMP);
		sub = substitute(tmp, 0);
		afree(tmp, ATEMP);
		n = str_nsave(n, p - n, ATEMP);
		evaluate(sub, &amp;rval, KSH_UNWIND_ERROR);
		if (rval &lt; 0 || rval &gt; ARRAYMAX)
			errorf("%s: subscript out of range", n);
		*valp = rval;
		afree(sub, ATEMP);
	}
	return n;
}

/*
 * Search for variable, if not found create globally.
 */
struct tbl *
global(n)
	register const char *n;
{
	register struct block *l = e-&gt;loc;
	register struct tbl *vp;
	register int c;
	unsigned h; 
	bool_t	 array;
	int	 val;

	/* Check to see if this is an array */
	n = array_index_calc(n, &amp;array, &amp;val);
	h = hash(n);
	c = n[0];
	if (!letter(c)) {
		if (array)
			errorf("bad substitution");
		vp = &amp;vtemp;
		vp-&gt;flag = DEFINED;
		vp-&gt;type = 0;
		vp-&gt;areap = ATEMP;
		*vp-&gt;name = c;
		if (digit(c)) {
			for (c = 0; digit(*n); n++)
				c = c*10 + *n-'0';
			if (c &lt;= l-&gt;argc)
				/* setstr can't fail here */
				setstr(vp, l-&gt;argv[c], KSH_RETURN_ERROR);
			vp-&gt;flag |= RDONLY;
			return vp;
		}
		vp-&gt;flag |= RDONLY;
		if (n[1] != '\0')
			return vp;
		vp-&gt;flag |= ISSET|INTEGER;
		switch (c) {
		  case '$':
			vp-&gt;val.i = kshpid;
			break;
		  case '!':
			/* If no job, expand to nothing */
			if ((vp-&gt;val.i = j_async()) == 0)
				vp-&gt;flag &amp;= ~(ISSET|INTEGER);
			break;
		  case '?':
			vp-&gt;val.i = exstat;
			break;
		  case '#':
			vp-&gt;val.i = l-&gt;argc;
			break;
		  case '-':
			vp-&gt;flag &amp;= ~INTEGER;
			vp-&gt;val.s = getoptions();
			break;
		  default:
			vp-&gt;flag &amp;= ~(ISSET|INTEGER);
		}
		return vp;
	}
	for (l = e-&gt;loc; ; l = l-&gt;next) {
		vp = tsearch(&amp;l-&gt;vars, n, h);
		if (vp != NULL)
			if (array)
				return arraysearch(vp, val);
			else
				return vp;
		if (l-&gt;next == NULL)
			break;
	}
	vp = tenter(&amp;l-&gt;vars, n, h);
	if (array)
		vp = arraysearch(vp, val);
	vp-&gt;flag |= DEFINED;
	if (special(n))
		vp-&gt;flag |= SPECIAL;
	return vp;
}

/*
 * Search for local variable, if not found create locally.
 */
struct tbl *
local(n, copy)
	register const char *n;
	bool_t copy;
{
	register struct block *l = e-&gt;loc;
	register struct tbl *vp;
	unsigned h;
	bool_t	 array;
	int	 val;

	/* Check to see if this is an array */
	n = array_index_calc(n, &amp;array, &amp;val);
	h = hash(n);
	if (!letter(*n)) {
		vp = &amp;vtemp;
		vp-&gt;flag = DEFINED|RDONLY;
		vp-&gt;type = 0;
		vp-&gt;areap = ATEMP;
		return vp;
	}
	vp = tenter(&amp;l-&gt;vars, n, h);
	if (copy &amp;&amp; !(vp-&gt;flag &amp; DEFINED)) {
		struct block *ll = l;
		struct tbl *vq = (struct tbl *) 0;

		while ((ll = ll-&gt;next) &amp;&amp; !(vq = tsearch(&amp;ll-&gt;vars, n, h)))
			;
		if (vq) {
			vp-&gt;flag |= vq-&gt;flag &amp; (EXPORT|INTEGER|RDONLY
						|LJUST|RJUST|ZEROFIL
						|LCASEV|UCASEV_AL|INT_U|INT_L);
			if (vq-&gt;flag &amp; INTEGER)
				vp-&gt;type = vq-&gt;type;
			vp-&gt;u2.field = vq-&gt;u2.field;
		}
	}
	if (array)
		vp = arraysearch(vp, val);
	vp-&gt;flag |= DEFINED;
	if (special(n))
		vp-&gt;flag |= SPECIAL;
	return vp;
}

/* get variable string value */
char *
str_val(vp)
	register struct tbl *vp;
{
	char *s;

	if ((vp-&gt;flag&amp;SPECIAL))
		getspec(vp);
	if (!(vp-&gt;flag&amp;ISSET))
		s = null;		/* special to dollar() */
	else if (!(vp-&gt;flag&amp;INTEGER))	/* string source */
		s = vp-&gt;val.s + vp-&gt;type;
	else {				/* integer source */
		/* worst case number length is when base=2, so use BITS(long) */
			     /* minus base #     number    null */
		static char strbuf[1 + 2 + 1 + BITS(long) + 1];
		const char *digits = (vp-&gt;flag &amp; UCASEV_AL) ?
				  "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
				: "0123456789abcdefghijklmnopqrstuvwxyz";
		register unsigned long n;
		register int base;

		s = strbuf + sizeof(strbuf);
		if (vp-&gt;flag &amp; INT_U)
			n = (unsigned long) vp-&gt;val.i;
		else
			n = (vp-&gt;val.i &lt; 0) ? -vp-&gt;val.i : vp-&gt;val.i;
		base = (vp-&gt;type == 0) ? 10 : vp-&gt;type;

		*--s = '\0';
		do {
			*--s = digits[n % base];
			n /= base;
		} while (n != 0);
		if (base != 10) {
			*--s = '#';
			*--s = digits[base % 10];
			if (base &gt;= 10)
				*--s = digits[base / 10];
		}
		if (!(vp-&gt;flag &amp; INT_U) &amp;&amp; vp-&gt;val.i &lt; 0)
			*--s = '-';
		if (vp-&gt;flag &amp; (RJUST|LJUST)) /* case already dealt with */
			s = formatstr(vp, s);
	}
	return s;
}

/* get variable integer value, with error checking */
long
intval(vp)
	register struct tbl *vp;
{
	long num;
	int base;

	base = getint(vp, &amp;num);
	if (base == -1)
		/* XXX check calls - is error here ok by POSIX? */
		errorf("%s: bad number", str_val(vp));
	return num;
}

/* set variable to string value */
int
setstr(vq, s, error_ok)
	register struct tbl *vq;
	const char *s;
	int error_ok;
{
	if (vq-&gt;flag &amp; RDONLY) {
		warningf(TRUE, "%s: is read only", vq-&gt;name);
		if (!error_ok)
			errorf(null);
		return 0;
	}
	if (!(vq-&gt;flag&amp;INTEGER)) { /* string dest */
		if ((vq-&gt;flag&amp;ALLOC)) {
			/* debugging */
			if (s &gt;= vq-&gt;val.s
			    &amp;&amp; s &lt;= vq-&gt;val.s + strlen(vq-&gt;val.s))
				internal_errorf(TRUE,
				    "setstr: %s=%s: assigning to self",
				    vq-&gt;name, s);
			afree((void*)vq-&gt;val.s, vq-&gt;areap);
		}
		vq-&gt;flag &amp;= ~(ISSET|ALLOC);
		vq-&gt;type = 0;
		if (s &amp;&amp; (vq-&gt;flag &amp; (UCASEV_AL|LCASEV|LJUST|RJUST)))
			s = formatstr(vq, s);
		if ((vq-&gt;flag&amp;EXPORT))
			export(vq, s);
		else {
			vq-&gt;val.s = str_save(s, vq-&gt;areap);
			if (vq-&gt;val.s)		/* &lt;sjg&gt; don't lie */
				vq-&gt;flag |= ALLOC;
		}
	} else			/* integer dest */
		if (!v_evaluate(vq, s, error_ok))
			return 0;
	vq-&gt;flag |= ISSET;
	if ((vq-&gt;flag&amp;SPECIAL))
		setspec(vq);
	return 1;
}

/* set variable to integer */
void
setint(vq, n)
	register struct tbl *vq;
	long n;
{
	if (!(vq-&gt;flag&amp;INTEGER)) {
		register struct tbl *vp = &amp;vtemp;
		vp-&gt;flag = (ISSET|INTEGER);
		vp-&gt;type = 0;
		vp-&gt;areap = ATEMP;
		vp-&gt;val.i = n;
		/* setstr can't fail here */
		setstr(vq, str_val(vp), KSH_RETURN_ERROR);
	} else
		vq-&gt;val.i = n;
	vq-&gt;flag |= ISSET;
	if ((vq-&gt;flag&amp;SPECIAL))
		setspec(vq);
}

int
getint(vp, nump)
	struct tbl *vp;
	long *nump;
{
	register char *s;
	register int c;
	int base, neg;
	int have_base = 0;
	long num;
	
	if (vp-&gt;flag&amp;SPECIAL)
		getspec(vp);
	/* XXX is it possible for ISSET to be set and val.s to be 0? */
	if (!(vp-&gt;flag&amp;ISSET) || (!(vp-&gt;flag&amp;INTEGER) &amp;&amp; vp-&gt;val.s == NULL))
		return -1;
	if (vp-&gt;flag&amp;INTEGER) {
		*nump = vp-&gt;val.i;
		return vp-&gt;type;
	}
	s = vp-&gt;val.s + vp-&gt;type;
	if (s == NULL)	/* redundent given initial test */
		s = null;
	base = 10;
	num = 0;
	neg = 0;
	for (c = *s++; c ; c = *s++) {
		if (c == '-') {
			neg++;
		} else if (c == '#') {
			base = (int) num;
			if (have_base || base &lt; 2 || base &gt; 36)
				return -1;
			num = 0;
			have_base = 1;
		} else if (letnum(c)) {
			if (isdigit(c))
				c -= '0';
			else if (islower(c))
				c -= 'a' - 10; /* todo: assumes ascii */
			else if (isupper(c))
				c -= 'A' - 10; /* todo: assumes ascii */
			else
				c = -1; /* _: force error */
			if (c &lt; 0 || c &gt;= base)
				return -1;
			num = num * base + c;
		} else
			return -1;
	}
	if (neg)
		num = -num;
	*nump = num;
	return base;
}

/* convert variable vq to integer variable, setting its value from vp
 * (vq and vp may be the same)
 */
struct tbl *
setint_v(vq, vp)
	register struct tbl *vq, *vp;
{
	int base;
	long num;
	
	if ((base = getint(vp, &amp;num)) == -1)
		return NULL;
	if (!(vq-&gt;flag &amp; INTEGER) &amp;&amp; (vq-&gt;flag &amp; ALLOC)) {
		vq-&gt;flag &amp;= ~ALLOC;
		afree(vq-&gt;val.s, vq-&gt;areap);
	}
	vq-&gt;val.i = num;
	if (vq-&gt;type == 0) /* default base */
		vq-&gt;type = base;
	vq-&gt;flag |= ISSET|INTEGER;
	if (vq-&gt;flag&amp;SPECIAL)
		setspec(vq);
	return vq;
}

static char *
formatstr(vp, s)
	struct tbl *vp;
	const char *s;
{
	int olen, nlen;
	char *p, *q;

	olen = strlen(s);

	if (vp-&gt;flag &amp; (RJUST|LJUST)) {
		if (!vp-&gt;u2.field)	/* default field width */
			vp-&gt;u2.field = olen;
		nlen = vp-&gt;u2.field;
	} else
		nlen = olen;

	p = (char *) alloc(nlen + 1, ATEMP);
	if (vp-&gt;flag &amp; (RJUST|LJUST)) {
		int slen;

		if (vp-&gt;flag &amp; RJUST) {
			const char *q = s + olen;
			/* strip trailing spaces (at&amp;t ksh uses q[-1] == ' ') */
			while (q &gt; s &amp;&amp; isspace(q[-1]))
				--q;
			slen = q - s;
			if (slen &gt; vp-&gt;u2.field) {
				s += slen - vp-&gt;u2.field;
				slen = vp-&gt;u2.field;
			}
			shf_snprintf(p, nlen + 1,
				((vp-&gt;flag &amp; ZEROFIL) &amp;&amp; digit(*s)) ?
					  "%0*s%.*s" : "%*s%.*s",
				vp-&gt;u2.field - slen, null, slen, s);
		} else {
			/* strip leading spaces/zeros */
			while (isspace(*s))
				s++;
			if (vp-&gt;flag &amp; ZEROFIL)
				while (*s == '0')
					s++;
			shf_snprintf(p, nlen + 1, "%-*.*s",
				vp-&gt;u2.field, vp-&gt;u2.field, s);
		}
	} else
		memcpy(p, s, olen + 1);

	if (vp-&gt;flag &amp; UCASEV_AL) {
		for (q = p; *q; q++)
			if (islower(*q))
				*q = toupper(*q);
	} else if (vp-&gt;flag &amp; LCASEV) {
		for (q = p; *q; q++)
			if (isupper(*q))
				*q = tolower(*q);
	}

	return p;
}

/*
 * make vp-&gt;val.s be "name=value" for quick exporting.
 */
static void
export(vp, val)
	register struct tbl *vp;
	const char *val;
{
	register char *xp;
	char *op = (vp-&gt;flag&amp;ALLOC) ? vp-&gt;val.s : NULL;
	int namelen = strlen(vp-&gt;name);
	int vallen = strlen(val) + 1;

	vp-&gt;flag |= ALLOC;
	xp = (char*)alloc(namelen + 1 + vallen, vp-&gt;areap);
	memcpy(vp-&gt;val.s = xp, vp-&gt;name, namelen);
	xp += namelen;
	*xp++ = '=';
	vp-&gt;type = xp - vp-&gt;val.s; /* offset to value */
	memcpy(xp, val, vallen);
	if (op != NULL)
		afree((void*)op, vp-&gt;areap);
}

/*
 * lookup variable (according to (set&amp;LOCAL)),
 * set its attributes (INTEGER, RDONLY, EXPORT, TRACE, LJUST, RJUST, ZEROFIL,
 * LCASEV, UCASEV_AL), and optionally set its value if an assignment.
 */
struct tbl *
typeset(var, set, clr, field, base)
	register const char *var;
	Tflag clr, set;
	int field, base;
{
	register struct tbl *vp;
	struct tbl *vpbase, *t;
	char *tvar;
	const char *val;

	/* check for valid variable name, search for value */
	val = skip_varname(var, FALSE);
	if (val == var)
		return NULL;
	if (*val == '[') {
		int len;
		
		len = array_ref_len(val);
		if (len == 0)
			return NULL;
		/* IMPORT is only used when the shell starts up and is
		 * setting up its environment.  Allow only simple array
		 * references at this time since parameter/command substitution
		 * is preformed on the [expression], which would be a major
		 * security hole.
		 */
		if (set &amp; IMPORT) {
			int i;
			for (i = 1; i &lt; len - 1; i++)
				if (!digit(val[i]))
					return NULL;
		}
		val += len;
	}
	if (*val == '=')
		tvar = str_nsave(var, val++ - var, ATEMP);
	else {
		/* Importing from original envirnment: must have an = */
		if (set &amp; IMPORT)
			return NULL;
		tvar = (char *) var;
		val = NULL;
	}

	/* Prevent typeset from creating a local PATH/ENV/SHELL */
	if (Flag(FRESTRICTED) &amp;&amp; (strcmp(tvar, "PATH") == 0
				  || strcmp(tvar, "ENV") == 0
				  || strcmp(tvar, "SHELL") == 0))
		errorf("%s: restricted", tvar);

	vp = (set&amp;LOCAL) ? local(tvar, (set &amp; LOCAL_COPY) ? TRUE : FALSE)
		: global(tvar);
	set &amp;= ~(LOCAL|LOCAL_COPY);

	vpbase = (vp-&gt;flag &amp; ARRAY) ? global(arrayname(var)) : vp;

	/* only allow export flag to be set.  at&amp;t ksh allows any attribute to
	 * be changed, which means it can be truncated or modified
	 * (-L/-R/-Z/-i).
	 */
	if ((vpbase-&gt;flag&amp;RDONLY)
	    &amp;&amp; (val || clr || (set &amp; ~EXPORT)))
		/* XXX check calls - is error here ok by POSIX? */
		errorf("%s: is read only", tvar);
	if (val)
		afree(tvar, ATEMP);

	/* most calls are with set/clr == 0 */
	if (set | clr) {
		int ok = 1;
		/* XXX if x[0] isn't set, there will be problems: need to have
		 * one copy of attributes for arrays...
		 */
		for (t = vpbase; t; t = t-&gt;u.array) {
			int fake_assign;
			char UNINITIALIZED(*s);
			char UNINITIALIZED(*free_me);

			fake_assign = (t-&gt;flag &amp; ISSET) &amp;&amp; (!val || t != vp)
				      &amp;&amp; ((set &amp; (UCASEV_AL|LCASEV|LJUST|RJUST|ZEROFIL))
					  || ((t-&gt;flag &amp; INTEGER) &amp;&amp; (clr &amp; INTEGER))
					  || (!(t-&gt;flag &amp; INTEGER) &amp;&amp; (set &amp; INTEGER)));
			if (fake_assign) {
				if (t-&gt;flag &amp; INTEGER) {
					s = str_val(t);
					free_me = (char *) 0;
				} else {
					s = t-&gt;val.s + t-&gt;type;
					free_me = (t-&gt;flag &amp; ALLOC) ? t-&gt;val.s
								  : (char *) 0;
				}
				t-&gt;flag &amp;= ~ALLOC;
			}
			if (!(t-&gt;flag &amp; INTEGER) &amp;&amp; (set &amp; INTEGER)) {
				t-&gt;type = 0;
				t-&gt;flag &amp;= ~ALLOC;
			}
			t-&gt;flag = (t-&gt;flag | set) &amp; ~clr;
			/* Don't change base if assignment is to be done,
			 * in case assignment fails.
			 */
			if ((set &amp; INTEGER) &amp;&amp; base &gt; 0 &amp;&amp; (!val || t != vp))
				t-&gt;type = base;
			if (set &amp; (LJUST|RJUST|ZEROFIL))
				t-&gt;u2.field = field;
			if (fake_assign) {
				if (!setstr(t, s, KSH_RETURN_ERROR)) {
					/* Somewhat arbitrary action here:
					 * zap contents of varibale, but keep
					 * the flag settings.
					 */
					ok = 0;
					if (t-&gt;flag &amp; INTEGER)
						t-&gt;flag &amp;= ~ISSET;
					else {
						if (t-&gt;flag &amp; ALLOC)
							afree((void*) t-&gt;val.s,
							      t-&gt;areap);
						t-&gt;flag &amp;= ~(ISSET|ALLOC);
						t-&gt;type = 0;
					}
				}
				if (free_me)
					afree((void *) free_me, t-&gt;areap);
			}
		}
		if (!ok)
		    errorf(null);
	}

	if (val != NULL) {
		if (vp-&gt;flag&amp;INTEGER) {
			/* do not zero base before assignment */
			setstr(vp, val, KSH_UNWIND_ERROR);
			/* Done after assignment to override default */
			if (base &gt; 0)
				vp-&gt;type = base;
		} else
			/* setstr can't fail (readonly check already done) */
			setstr(vp, val, KSH_RETURN_ERROR);
	}

	/* only x[0] is ever exported, so use vpbase */
	if ((vpbase-&gt;flag&amp;EXPORT) &amp;&amp; !(vpbase-&gt;flag&amp;INTEGER)
	    &amp;&amp; vpbase-&gt;type == 0)
		export(vpbase, (vpbase-&gt;flag&amp;ISSET) ? vpbase-&gt;val.s : null);

	return vp;
}

/* Unset a variable.  array_ref is set if there was an array reference in
 * the name lookup (eg, x[2]).
 */
void
unset(vp, array_ref)
	register struct tbl *vp;
	int array_ref;
{
	if (vp-&gt;flag &amp; ALLOC)
		afree((void*)vp-&gt;val.s, vp-&gt;areap);
	if ((vp-&gt;flag &amp; ARRAY) &amp;&amp; !array_ref) {
		struct tbl *a, *tmp;

		/* Free up entire array */
		for (a = vp-&gt;u.array; a; ) {
			tmp = a;
			a = a-&gt;u.array;
			if (tmp-&gt;flag &amp; ALLOC)
				afree((void *) tmp-&gt;val.s, tmp-&gt;areap);
			afree(tmp, tmp-&gt;areap);
		}
		vp-&gt;u.array = (struct tbl *) 0;
	}
	/* If foo[0] is being unset, the remainder of the array is kept... */
	vp-&gt;flag &amp;= SPECIAL | (array_ref ? ARRAY|DEFINED : 0);
	if (vp-&gt;flag &amp; SPECIAL)
		unsetspec(vp);	/* responsible for `unspecial'ing var */
}

/* return a pointer to the first char past a legal variable name (returns the
 * argument if there is no legal name, returns * a pointer to the terminating
 * null if whole string is legal).
 */
char *
skip_varname(s, aok)
	const char *s;
	int aok;
{
	int alen;

	if (s &amp;&amp; letter(*s)) {
		while (*++s &amp;&amp; letnum(*s))
			;
		if (aok &amp;&amp; *s == '[' &amp;&amp; (alen = array_ref_len(s)))
			s += alen;
	}
	return (char *) s;
}

/* Return a pointer to the first character past any legal variable name.  */
char *
skip_wdvarname(s, aok)
	const char *s;
	int aok;	/* skip array de-reference? */
{
	if (s[0] == CHAR &amp;&amp; letter(s[1])) {
		do
			s += 2;
		while (s[0] == CHAR &amp;&amp; letnum(s[1]));
		if (aok &amp;&amp; s[0] == CHAR &amp;&amp; s[1] == '[') {
			/* skip possible array de-reference */
			const char *p = s;
			char c;
			int depth = 0;

			while (1) {
				if (p[0] != CHAR)
					break;
				c = p[1];
				p += 2;
				if (c == '[')
					depth++;
				else if (c == ']' &amp;&amp; --depth == 0) {
					s = p;
					break;
				}
			}
		}
	}
	return (char *) s;
}

/* Check if coded string s is a variable name */
int
is_wdvarname(s, aok)
	const char *s;
	int aok;
{
	char *p = skip_wdvarname(s, aok);

	return p != s &amp;&amp; p[0] == EOS;
}

/* Check if coded string s is a variable assignment */
int
is_wdvarassign(s)
	const char *s;
{
	char *p = skip_wdvarname(s, TRUE);

	return p != s &amp;&amp; p[0] == CHAR &amp;&amp; p[1] == '=';
}

/*
 * Make the exported environment from the exported names in the dictionary.
 */
char **
makenv()
{
	struct block *l = e-&gt;loc;
	XPtrV env;
	register struct tbl *vp, **vpp;
	register int i;

	XPinit(env, 64);
	for (l = e-&gt;loc; l != NULL; l = l-&gt;next)
		for (vpp = l-&gt;vars.tbls, i = l-&gt;vars.size; --i &gt;= 0; )
			if ((vp = *vpp++) != NULL
			    &amp;&amp; (vp-&gt;flag&amp;(ISSET|EXPORT)) == (ISSET|EXPORT)) {
				register struct block *l2;
				register struct tbl *vp2;
				unsigned h = hash(vp-&gt;name);

				/* unexport any redefined instances */
				for (l2 = l-&gt;next; l2 != NULL; l2 = l2-&gt;next) {
					vp2 = tsearch(&amp;l2-&gt;vars, vp-&gt;name, h);
					if (vp2 != NULL)
						vp2-&gt;flag &amp;= ~EXPORT;
				}
				if ((vp-&gt;flag&amp;INTEGER)) {
					/* integer to string */
					char *val;
					val = str_val(vp);
					vp-&gt;flag &amp;= ~(INTEGER|RDONLY);
					/* setstr can't fail here */
					setstr(vp, val, KSH_RETURN_ERROR);
				}
				XPput(env, vp-&gt;val.s);
			}
	XPput(env, NULL);
	return (char **) XPclose(env);
}

/*
 * Called after a fork in parent to bump the random number generator.
 * Done to ensure children will not get the same random number sequence
 * if the parent doesn't use $RANDOM.
 */
void
change_random()
{
    rand();
}

/*
 * handle special variables with side effects - PATH, SECONDS.
 */

/* Test if name is a special parameter */
static int
special(name)
	register const char * name;
{
	register struct tbl *tp;

	tp = tsearch(&amp;specials, name, hash(name));
	return tp &amp;&amp; (tp-&gt;flag &amp; ISSET) ? tp-&gt;type : V_NONE;
}

/* Make a variable non-special */
static void
unspecial(name)
	register const char * name;
{
	register struct tbl *tp;

	tp = tsearch(&amp;specials, name, hash(name));
	if (tp)
		tdelete(tp);
}

#ifdef KSH
static	time_t	seconds;		/* time SECONDS last set */
#endif /* KSH */
static	int	user_lineno;		/* what user set $LINENO to */

static void
getspec(vp)
	register struct tbl *vp;
{
	switch (special(vp-&gt;name)) {
#ifdef KSH
	  case V_SECONDS:
		vp-&gt;flag &amp;= ~SPECIAL;
		/* On start up the value of SECONDS is used before seconds
		 * has been set - don't do anything in this case
		 * (see initcoms[] in main.c).
		 */
		if (vp-&gt;flag &amp; ISSET)
			setint(vp, (long) (time((time_t *)0) - seconds));
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_RANDOM:
		vp-&gt;flag &amp;= ~SPECIAL;
		setint(vp, (long) (rand() &amp; 0x7fff));
		vp-&gt;flag |= SPECIAL;
		break;
#endif /* KSH */
#ifdef HISTORY
	  case V_HISTSIZE:
		vp-&gt;flag &amp;= ~SPECIAL;
		setint(vp, (long) histsize);
		vp-&gt;flag |= SPECIAL;
		break;
#endif /* HISTORY */
	  case V_OPTIND:
		vp-&gt;flag &amp;= ~SPECIAL;
		setint(vp, (long) user_opt.uoptind);
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_LINENO:
		vp-&gt;flag &amp;= ~SPECIAL;
		setint(vp, (long) current_lineno + user_lineno);
		vp-&gt;flag |= SPECIAL;
		break;
	}
}

static void
setspec(vp)
	register struct tbl *vp;
{
	char *s;

	switch (special(vp-&gt;name)) {
	  case V_PATH:
		if (path)
			afree(path, APERM);
		path = str_save(str_val(vp), APERM);
		flushcom(1);	/* clear tracked aliases */
		break;
	  case V_IFS:
		setctypes(s = str_val(vp), C_IFS);
		ifs0 = *s;
		break;
	  case V_OPTIND:
		vp-&gt;flag &amp;= ~SPECIAL;
		getopts_reset((int) intval(vp));
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_POSIXLY_CORRECT:
		change_flag(FPOSIX, OF_SPECIAL, 1);
		break;
	  case V_TMPDIR:
		if (tmpdir) {
			afree(tmpdir, APERM);
			tmpdir = (char *) 0;
		}
		/* Use tmpdir iff it is an absolute path, is writable and
		 * searchable and is a directory...
		 */
		{
			struct stat statb;
			s = str_val(vp);
			if (ISABSPATH(s) &amp;&amp; eaccess(s, W_OK|X_OK) == 0
			    &amp;&amp; stat(s, &amp;statb) == 0 &amp;&amp; S_ISDIR(statb.st_mode))
				tmpdir = str_save(s, APERM);
		}
		break;
#ifdef HISTORY
	  case V_HISTSIZE:
		vp-&gt;flag &amp;= ~SPECIAL;
		sethistsize((int) intval(vp));
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_HISTFILE:
		sethistfile(str_val(vp));
		break;
#endif /* HISTORY */
#ifdef EDIT
	  case V_VISUAL:
		set_editmode(str_val(vp));
		break;
	  case V_EDITOR:
		if (!(global("VISUAL")-&gt;flag &amp; ISSET))
			set_editmode(str_val(vp));
		break;
	  case V_COLUMNS:
		if ((x_cols = intval(vp)) &lt;= MIN_COLS)
			x_cols = MIN_COLS;
		break;
#endif /* EDIT */
#ifdef KSH
	  case V_MAIL:
		mbset(str_val(vp));
		break;
	  case V_MAILPATH:
		mpset(str_val(vp));
		break;
	  case V_MAILCHECK:
		vp-&gt;flag &amp;= ~SPECIAL;
		mcset(intval(vp));
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_RANDOM:
		vp-&gt;flag &amp;= ~SPECIAL;
		srand((unsigned int)intval(vp));
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_SECONDS:
		vp-&gt;flag &amp;= ~SPECIAL;
		seconds = time((time_t*) 0) - intval(vp);
		vp-&gt;flag |= SPECIAL;
		break;
	  case V_TMOUT:
		/* at&amp;t ksh seems to do this (only listen if integer) */
		if (vp-&gt;flag &amp; INTEGER)
			ksh_tmout = vp-&gt;val.i &gt;= 0 ? vp-&gt;val.i : 0;
		break;
#endif /* KSH */
	  case V_LINENO:
		vp-&gt;flag &amp;= ~SPECIAL;
		/* The -1 is because line numbering starts at 1. */
		user_lineno = (unsigned int) intval(vp) - current_lineno - 1;
		vp-&gt;flag |= SPECIAL;
		break;
	}
}

static void
unsetspec(vp)
	register struct tbl *vp;
{
	switch (special(vp-&gt;name)) {
	  case V_PATH:
		if (path)
			afree(path, APERM);
		path = str_save(def_path, APERM);
		flushcom(1);	/* clear tracked aliases */
		break;
	  case V_IFS:
		setctypes(" \t\n", C_IFS);
		ifs0 = ' ';
		break;
	  case V_TMPDIR:
		/* should not become unspecial */
		if (tmpdir) {
			afree(tmpdir, APERM);
			tmpdir = (char *) 0;
		}
		break;
#ifdef KSH
	  case V_MAIL:
		mbset((char *) 0);
		break;
	  case V_MAILPATH:
		mpset((char *) 0);
		break;
#endif /* KSH */

	  case V_LINENO:
#ifdef KSH
	  case V_MAILCHECK:	/* at&amp;t ksh leaves previous value in place */
	  case V_RANDOM:
	  case V_SECONDS:
	  case V_TMOUT:		/* at&amp;t ksh leaves previous value in place */
#endif /* KSH */
		unspecial(vp-&gt;name);
		break;

	  /* at&amp;t ksh man page says OPTIND, OPTARG and _ lose special meaning,
	   * but OPTARG does not (still set by getopts) and _ is also still
	   * set in various places.
	   * Don't know what at&amp;t does for:
	   *		MAIL, MAILPATH, HISTSIZE, HISTFILE,
	   * Unsetting these in at&amp;t ksh does not loose the `specialness':
	   *    no effect: IFS, COLUMNS, PATH, TMPDIR,
	   *		VISUAL, EDITOR,
	   * pdkshisms: no effect:
	   *		POSIXLY_CORRECT (use set +o posix instead)
	   */
	}
}

/*
 * Search for (and possibly create) a table entry starting with
 * vp, indexed by val.
 */
static struct tbl *
arraysearch(vp, val)
	struct tbl *vp;
	int val;
{
	struct tbl *prev, *curr, *new;

	vp-&gt;flag |= ARRAY|DEFINED;

	/* The table entry is always [0] */
	if (val == 0) {
		vp-&gt;index = 0;
		return vp;
	}
	prev = vp;
	curr = vp-&gt;u.array;
	while (curr &amp;&amp; curr-&gt;index &lt; val) {
		prev = curr;
		curr = curr-&gt;u.array;
	}
	if (curr &amp;&amp; curr-&gt;index == val) {
		if (curr-&gt;flag&amp;ISSET)
			return curr;
		else
			new = curr;
	} else
		new = (struct tbl *)alloc(sizeof(struct tbl)+strlen(vp-&gt;name)+1, vp-&gt;areap);
	strcpy(new-&gt;name, vp-&gt;name);
	new-&gt;flag = vp-&gt;flag &amp; ~(ALLOC|DEFINED|ISSET|SPECIAL);
	new-&gt;type = vp-&gt;type;
	new-&gt;areap = vp-&gt;areap;
	new-&gt;u2.field = vp-&gt;u2.field;
	new-&gt;index = val;
	if (curr != new) {		/* not reusing old array entry */
		prev-&gt;u.array = new;
		new-&gt;u.array = curr;
	}
	return new;
}

/* Return the length of an array reference (eg, [1+2]) - cp is assumed
 * to point to the open bracket.  Returns 0 if there is no matching closing
 * bracket.
 */
int
array_ref_len(cp)
	const char *cp;
{
	const char *s = cp;
	int c;
	int depth = 0;

	while ((c = *s++) &amp;&amp; (c != ']' || --depth))
		if (c == '[')
			depth++;
	if (!c)
		return 0;
	return s - cp;
}

/*
 * Make a copy of the base of an array name
 */
char *
arrayname(str)
	const char *str;
{
	const char *p;

	if ((p = strchr(str, '[')) == 0)
		/* Shouldn't happen, but why worry? */
		return (char *) str;

	return str_nsave(str, p - str, ATEMP);
}

/* Set (or overwrite, if !reset) the array variable var to the values in vals.
 */
void
set_array(var, reset, vals)
	const char *var;
	int reset;
	char **vals;
{
	struct tbl *vp, *vq;
	int i;

	/* to get local array, use "typeset foo; set -A foo" */
	vp = global(var);

	/* Note: at&amp;t ksh allows set -A but not set +A of a read-only var */
	if ((vp-&gt;flag&amp;RDONLY))
		errorf("%s: is read only", var);
	/* This code is quite non-optimal */
	if (reset &gt; 0)
		/* trash existing values and attributes */
		unset(vp, 0);
	/* todo: would be nice for assignment to completely succeed or
	 * completely fail.  Only really effects integer arrays:
	 * evaluation of some of vals[] may fail...
	 */
	for (i = 0; vals[i]; i++) {
		vq = arraysearch(vp, i);
		/* would be nice to deal with errors here... (see above) */
		setstr(vq, vals[i], KSH_RETURN_ERROR);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

