<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/gen/mbwc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/gen/mbwc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdlib.h&gt;
#include &lt;limits.h&gt;

/*
 * Use the FSS-UTF transformation proposed by posix.
 *	We define 7 byte types:
 *	T0	0xxxxxxx	7 free bits
 *	Tx	10xxxxxx	6 free bits
 *	T1	110xxxxx	5 free bits
 *	T2	1110xxxx	4 free bits
 *	T3	11110xxx	3 free bits
 *	T4	111110xx	2 free bits
 *	T5	1111110x	1 free bit
 *
 *	Encoding is as follows.
 *	From hex	Thru hex	Sequence		Bits
 *	00000000	0000007F	T0				7
 *	00000080	000007FF	T1 Tx			11
 *	00000800	0000FFFF	T2 Tx Tx			16
 *	00010000	001FFFFF	T3 Tx Tx Tx		21
 *	00200000	03FFFFFF	T4 Tx Tx Tx Tx		26
 *	04000000	7FFFFFFF	T5 Tx Tx  Tx Tx Tx	31
 */
int
mbtowc(wchar_t *pwc, const char *s, size_t n);

int
mblen(const char *s, size_t n)
{
	return mbtowc(0, s, n);
}

enum {
	C0MSK = 0x7F,
	C1MSK = 0x7FF,
	T1 = 0xC0,
	T2 = 0xE0,
	NT1BITS = 11,
	NSHFT = 5,
	NCSHFT = NSHFT + 1,
	WCHARMSK = (1&lt;&lt; (8*MB_LEN_MAX - 1)) - 1,
};

int
mbtowc(wchar_t *pwc, const char *s, size_t n)
{
	unsigned long long c[MB_LEN_MAX];
	unsigned long long l, m, wm, b;
	int i;

	if(!s)
		return 0;

	if(n &lt; 1)
		goto bad;

	c[0] = s[0] &amp; 0xff;		/* first one is special */
	if((c[0] &amp; 0x80) == 0x00) {
		if(pwc)
			*pwc = c[0];
		if(c[0] == 0)
			return 0;
		return 1;
	}

	m = T2;
	b = m^0x20;
	l = c[0];
	wm = C1MSK;
	for(i = 1; i &lt; MB_LEN_MAX + 1; i++){
		if(n &lt; i+1)
			goto bad;
		c[i] = (s[i] ^ 0x80) &amp; 0xff;
		l = (l &lt;&lt; NCSHFT) | c[i];
		if((c[i] &amp; 0xC0) != 0x00)
			goto bad;
		if((c[0] &amp; m) == b) {
			if(pwc)
				*pwc = l &amp; wm;
			return i + 1;
		}
		b = m;
		m = (m &gt;&gt; 1) | 0x80;
		wm = (wm &lt;&lt; NSHFT) | wm;
	}

	/*
	 * bad decoding
	 */
bad:
	return -1;

}

int
wctomb(char *s, wchar_t wchar)
{
	unsigned long long c, maxc, m;
	int i, j;

	if(!s)
		return 0;

	maxc = 0x80;
	c = wchar &amp; WCHARMSK;
	if(c &lt; maxc) {
		s[0] = c;
		return 1;
	}

	m = T1;
	for(i = 2; i &lt; MB_LEN_MAX + 1; i++){
		maxc &lt;&lt;= 4;
		if(c &lt; maxc || i == MB_LEN_MAX){
			s[0] = m | (c &gt;&gt; ((i - 1) * NCSHFT));
			for(j = i - 1; j &gt;= 1; j--){
				s[i - j] = 0x80|((c&gt;&gt;(6 * (j - 1)))&amp;0x3f);
			}
			return i;
		}
		m = (m &gt;&gt; 1) | 0x80;
	}
	return MB_LEN_MAX;
}

size_t
mbstowcs(wchar_t *pwcs, const char *s, size_t n)
{
	int i, d, c;

	for(i=0; i &lt; n; i++) {
		c = *s &amp; 0xff;
		if(c &lt; 0x80) {
			*pwcs = c;
			if(c == 0)
				break;
			s++;
		} else {
			d = mbtowc(pwcs, s, MB_LEN_MAX);
			if(d &lt;= 0)
				return (size_t)((d&lt;0) ? -1 : i);
			s += d;
		}
		pwcs++;
	}
	return i;
}

size_t
wcstombs(char *s, const wchar_t *pwcs, size_t n)
{
	int i, d;
	long c;
	char *p, *pe;
	char buf[MB_LEN_MAX];

	p = s;
	pe = p+n-MB_LEN_MAX;
	while(p &lt; pe) {
		c = *pwcs++;
		if(c &lt; 0x80)
			*p++ = c;
		else
			p += wctomb(p, c);
		if(c == 0)
			return p-s;
	}
	while(p &lt; pe+MB_LEN_MAX) {
		c = *pwcs++;
		d = wctomb(buf, c);
		if(p+d &lt;= pe+MB_LEN_MAX) {
			*p++ = buf[0];		/* first one is special */
			for(i = 2; i &lt; MB_LEN_MAX + 1; i++){
				if(d &lt;= i -1)
					break;
				*p++ = buf[i];
			}
		}
		if(c == 0)
			break;
	}
	return p-s;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

