<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/_buf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/_buf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#define  _BSDTIME_EXTENSION
#define _LOCK_EXTENSION
#include "lib.h"
#include &lt;stdlib.h&gt;
#include &lt;errno.h&gt;
#include &lt;unistd.h&gt;
#include &lt;signal.h&gt;
#include &lt;string.h&gt;
#include &lt;stdio.h&gt;
#include &lt;lock.h&gt;
#include &lt;sys/time.h&gt;
#include &lt;sys/select.h&gt;
#include &lt;unistd.h&gt;
#include "sys9.h"

typedef struct Muxseg {
	Lock	lock;			/* for mutual exclusion access to buffer variables */
	int	curfds;			/* number of fds currently buffered */
	int	selwait;		/* true if selecting process is waiting */
	int	waittime;		/* time for timer process to wait */
	fd_set	rwant;			/* fd's that select wants to read */
	fd_set	ewant;			/* fd's that select wants to know eof info on */
	Muxbuf	bufs[INITBUFS];		/* can grow, via segbrk() */
} Muxseg;

#define MUXADDR ((void*)0x6000000)
static Muxseg *mux = 0;			/* shared memory segment */

/* _muxsid and _killmuxsid are known in libbsd's listen.c */
int _muxsid = -1;			/* group id of copy processes */
static int _mainpid = -1;
static int timerpid = -1;		/* pid of a timer process */

void _killmuxsid(void);
static void _copyproc(int, Muxbuf*);
static void _timerproc(void);
static void _resettimer(void);

static int copynotehandler(void *, char *);

/* assume FD_SETSIZE is 96 */
#define FD_ANYSET(p)	((p)-&gt;fds_bits[0] || (p)-&gt;fds_bits[1] || (p)-&gt;fds_bits[2])

/*
 * Start making fd read-buffered: make the shared segment, if necessary,
 * allocate a slot (index into mux-&gt;bufs), and fork a child to read the fd
 * and write into the slot-indexed buffer.
 * Return -1 if we can't do it.
 */
int
_startbuf(int fd)
{
	long i, slot;
	int pid;
	Fdinfo *f;
	Muxbuf *b;

	if(mux == 0){
		_RFORK(RFREND);
		mux = (Muxseg*)_SEGATTACH(0, "shared", MUXADDR, sizeof(Muxseg));
		if((long)mux == -1){
			_syserrno();
			return -1;
		}
		/* segattach has returned zeroed memory */
		atexit(_killmuxsid);
	}

	if(fd == -1)
		return 0;

	lock(&amp;mux-&gt;lock);
	slot = mux-&gt;curfds++;
	if(mux-&gt;curfds &gt; INITBUFS) {
		if(_SEGBRK(mux, mux-&gt;bufs+mux-&gt;curfds) &lt; 0){
			_syserrno();
			unlock(&amp;mux-&gt;lock);
			return -1;
		}
	}

	f = &amp;_fdinfo[fd];
	b = &amp;mux-&gt;bufs[slot];
	b-&gt;n = 0;
	b-&gt;putnext = b-&gt;data;
	b-&gt;getnext = b-&gt;data;
	b-&gt;eof = 0;
	b-&gt;fd = fd;
	if(_mainpid == -1)
		_mainpid = getpid();
	if((pid = _RFORK(RFFDG|RFPROC|RFNOWAIT)) == 0){
		/* copy process ... */
		if(_muxsid == -1) {
			_RFORK(RFNOTEG);
			_muxsid = getpgrp();
		} else
			setpgid(getpid(), _muxsid);
		_NOTIFY(copynotehandler);
		for(i=0; i&lt;OPEN_MAX; i++)
			if(i!=fd &amp;&amp; (_fdinfo[i].flags&amp;FD_ISOPEN))
				_CLOSE(i);
		_RENDEZVOUS(0, _muxsid);
		_copyproc(fd, b);
	}

	/* parent process continues ... */
	b-&gt;copypid = pid;
	f-&gt;buf = b;
	f-&gt;flags |= FD_BUFFERED;
	unlock(&amp;mux-&gt;lock);
	_muxsid = _RENDEZVOUS(0, 0);
	/* leave fd open in parent so system doesn't reuse it */
	return 0;
}

/*
 * The given buffered fd is being closed.
 * Set the fd field in the shared buffer to -1 to tell copyproc
 * to exit, and kill the copyproc.
 */
void
_closebuf(int fd)
{
	Muxbuf *b;

	b = _fdinfo[fd].buf;
	if(!b)
		return;
	lock(&amp;mux-&gt;lock);
	b-&gt;fd = -1;
	unlock(&amp;mux-&gt;lock);
	kill(b-&gt;copypid, SIGKILL);
}

/* child copy procs execute this until eof */
static void
_copyproc(int fd, Muxbuf *b)
{
	unsigned char *e;
	int n;
	int nzeros;

	e = &amp;b-&gt;data[PERFDMAX];
	for(;;) {
		/* make sure there's room */
		lock(&amp;mux-&gt;lock);
		if(e - b-&gt;putnext &lt; READMAX) {
			if(b-&gt;getnext == b-&gt;putnext) {
				b-&gt;getnext = b-&gt;putnext = b-&gt;data;
				unlock(&amp;mux-&gt;lock);
			} else {
				/* sleep until there's room */
				b-&gt;roomwait = 1;
				unlock(&amp;mux-&gt;lock);
				_RENDEZVOUS((unsigned long)&amp;b-&gt;roomwait, 0);
			}
		} else
			unlock(&amp;mux-&gt;lock);
		/*
		 * A Zero-length _READ might mean a zero-length write
		 * happened, or it might mean eof; try several times to
		 * disambiguate (posix read() discards 0-length messages)
		 */
		nzeros = 0;
		do {
			n = _READ(fd, b-&gt;putnext, READMAX);
			if(b-&gt;fd == -1) {
				_exit(0);		/* we've been closed */
			}
		} while(n == 0 &amp;&amp; ++nzeros &lt; 3);
		lock(&amp;mux-&gt;lock);
		if(n &lt;= 0) {
			b-&gt;eof = 1;
			if(mux-&gt;selwait &amp;&amp; FD_ISSET(fd, &amp;mux-&gt;ewant)) {
				mux-&gt;selwait = 0;
				unlock(&amp;mux-&gt;lock);
				_RENDEZVOUS((unsigned long)&amp;mux-&gt;selwait, fd);
			} else if(b-&gt;datawait) {
				b-&gt;datawait = 0;
				unlock(&amp;mux-&gt;lock);
				_RENDEZVOUS((unsigned long)&amp;b-&gt;datawait, 0);
			} else if(mux-&gt;selwait &amp;&amp; FD_ISSET(fd, &amp;mux-&gt;rwant)) {
				mux-&gt;selwait = 0;
				unlock(&amp;mux-&gt;lock);
				_RENDEZVOUS((unsigned long)&amp;mux-&gt;selwait, fd);
			} else
				unlock(&amp;mux-&gt;lock);
			_exit(0);
		} else {
			b-&gt;putnext += n;
			b-&gt;n += n;
			if(b-&gt;n &gt; 0) {
				/* parent process cannot be both in datawait and selwait */
				if(b-&gt;datawait) {
					b-&gt;datawait = 0;
					unlock(&amp;mux-&gt;lock);
					/* wake up _bufreading process */
					_RENDEZVOUS((unsigned long)&amp;b-&gt;datawait, 0);
				} else if(mux-&gt;selwait &amp;&amp; FD_ISSET(fd, &amp;mux-&gt;rwant)) {
					mux-&gt;selwait = 0;
					unlock(&amp;mux-&gt;lock);
					/* wake up selecting process */
					_RENDEZVOUS((unsigned long)&amp;mux-&gt;selwait, fd);
				} else
					unlock(&amp;mux-&gt;lock);
			} else
				unlock(&amp;mux-&gt;lock);
		}
	}
}

/* like read(), for a buffered fd; extra arg noblock says don't wait for data if true */
int
_readbuf(int fd, void *addr, int nwant, int noblock)
{
	Muxbuf *b;
	int ngot;

	b = _fdinfo[fd].buf;
	if(b-&gt;eof &amp;&amp; b-&gt;n == 0) {
goteof:
		return 0;
	}
	if(b-&gt;n == 0 &amp;&amp; noblock) {
		errno = EAGAIN;
		return -1;
	}
	/* make sure there's data */
	lock(&amp;mux-&gt;lock);
	ngot = b-&gt;putnext - b-&gt;getnext;
	if(ngot == 0) {
		/* maybe EOF just happened */
		if(b-&gt;eof) {
			unlock(&amp;mux-&gt;lock);
			goto goteof;
		}
		/* sleep until there's data */
		b-&gt;datawait = 1;
		unlock(&amp;mux-&gt;lock);
		_RENDEZVOUS((unsigned long)&amp;b-&gt;datawait, 0);
		lock(&amp;mux-&gt;lock);
		ngot = b-&gt;putnext - b-&gt;getnext;
	}
	if(ngot == 0) {
		unlock(&amp;mux-&gt;lock);
		goto goteof;
	}
	if(ngot &gt; nwant)
		ngot = nwant;
	memcpy(addr, b-&gt;getnext, ngot);
	b-&gt;getnext += ngot;
	b-&gt;n -= ngot;
	if(b-&gt;getnext == b-&gt;putnext &amp;&amp; b-&gt;roomwait) {
		b-&gt;getnext = b-&gt;putnext = b-&gt;data;
		b-&gt;roomwait = 0;
		unlock(&amp;mux-&gt;lock);
		/* wake up copy process */
		_RENDEZVOUS((unsigned long)&amp;b-&gt;roomwait, 0);
	} else
		unlock(&amp;mux-&gt;lock);
	return ngot;
}

int
select(int nfds, fd_set *rfds, fd_set *wfds, fd_set *efds, struct timeval *timeout)
{
	int n, i, t, slots, fd, err;
	Fdinfo *f;
	Muxbuf *b;

	if(timeout)
		t = timeout-&gt;tv_sec*1000 + (timeout-&gt;tv_usec+999)/1000;
	else
		t = -1;
	if(!((rfds &amp;&amp; FD_ANYSET(rfds)) || (wfds &amp;&amp; FD_ANYSET(wfds))
			|| (efds &amp;&amp; FD_ANYSET(efds)))) {
		/* no requested fds */
		if(t &gt; 0)
			_SLEEP(t);
		return 0;
	}

	_startbuf(-1);

	/* make sure all requested rfds and efds are buffered */
	if(nfds &gt;= OPEN_MAX)
		nfds = OPEN_MAX;
	for(i = 0; i &lt; nfds; i++)
		if((rfds &amp;&amp; FD_ISSET(i, rfds)) || (efds &amp;&amp; FD_ISSET(i, efds))){
			f = &amp;_fdinfo[i];
			if(!(f-&gt;flags&amp;FD_BUFFERED))
				if(_startbuf(i) != 0)
					return -1;
		}

	/* check wfds;  for now, we'll say they are all ready */
	n = 0;
	if(wfds &amp;&amp; FD_ANYSET(wfds)){
		for(i = 0; i&lt;nfds; i++)
			if(FD_ISSET(i, wfds)) {
				n++;
			}
	}

	lock(&amp;mux-&gt;lock);

	slots = mux-&gt;curfds;
	FD_ZERO(&amp;mux-&gt;rwant);
	FD_ZERO(&amp;mux-&gt;ewant);

	for(i = 0; i&lt;slots; i++) {
		b = &amp;mux-&gt;bufs[i];
		fd = b-&gt;fd;
		if(fd == -1)
			continue;
		err = 0;
		if(efds &amp;&amp; FD_ISSET(fd, efds)) {
			if(b-&gt;eof &amp;&amp; b-&gt;n == 0){
				err = 1;
				n++;
			}else{
				FD_CLR(fd, efds);
				FD_SET(fd, &amp;mux-&gt;ewant);
			}
		}
		if(rfds &amp;&amp; FD_ISSET(fd, rfds)) {
			if(!err &amp;&amp; (b-&gt;n &gt; 0 || b-&gt;eof))
				n++;
			else{
				FD_CLR(fd, rfds);
				FD_SET(fd, &amp;mux-&gt;rwant);
			}
		}
	}
	if(n || !(FD_ANYSET(&amp;mux-&gt;rwant) || FD_ANYSET(&amp;mux-&gt;ewant)) || t == 0) {
		FD_ZERO(&amp;mux-&gt;rwant);
		FD_ZERO(&amp;mux-&gt;ewant);
		unlock(&amp;mux-&gt;lock);
		return n;
	}

	if(timeout) {
		mux-&gt;waittime = t;
		if(timerpid == -1)
			_timerproc();
		else
			_resettimer();
	}
	mux-&gt;selwait = 1;
	unlock(&amp;mux-&gt;lock);
	fd = _RENDEZVOUS((unsigned long)&amp;mux-&gt;selwait, 0);
	if(fd &gt;= 0) {
		b = _fdinfo[fd].buf;
		if(FD_ISSET(fd, &amp;mux-&gt;rwant)) {
			FD_SET(fd, rfds);
			n = 1;
		} else if(FD_ISSET(fd, &amp;mux-&gt;ewant) &amp;&amp; b-&gt;eof &amp;&amp; b-&gt;n == 0) {
			FD_SET(fd, efds);
			n = 1;
		}
	}
	FD_ZERO(&amp;mux-&gt;rwant);
	FD_ZERO(&amp;mux-&gt;ewant);
	return n;
}

static int timerreset;
static int timerpid;

static void
alarmed(int)
{
	timerreset = 1;
}

/* a little over an hour */
#define LONGWAIT 4000001

static void
_killtimerproc(void)
{
	if(timerpid &gt; 0)
		kill(timerpid, SIGKILL);
}

static void
_timerproc(void)
{
	int i;

	if((timerpid = _RFORK(RFFDG|RFPROC|RFNOWAIT)) == 0){
		/* timer process */
		setpgid(getpid(), _muxsid);
		signal(SIGALRM, alarmed);
		for(i=0; i&lt;OPEN_MAX; i++)
				_CLOSE(i);
		_RENDEZVOUS(1, 0);
		for(;;) {
			_SLEEP(mux-&gt;waittime);
			if(timerreset) {
				timerreset = 0;
			} else {
				lock(&amp;mux-&gt;lock);
				if(mux-&gt;selwait &amp;&amp; mux-&gt;waittime != LONGWAIT) {
					mux-&gt;selwait = 0;
					mux-&gt;waittime = LONGWAIT;
					unlock(&amp;mux-&gt;lock);
					_RENDEZVOUS((unsigned long)&amp;mux-&gt;selwait, -2);
				} else {
					mux-&gt;waittime = LONGWAIT;
					unlock(&amp;mux-&gt;lock);
				}
			}
		}
	}
	atexit(_killtimerproc);
	/* parent process continues */
	_RENDEZVOUS(1, 0);
}

static void
_resettimer(void)
{
	kill(timerpid, SIGALRM);
}

void
_killmuxsid(void)
{
	if(_muxsid != -1 &amp;&amp; (_mainpid == getpid() || _mainpid == -1))
		kill(-_muxsid,SIGTERM);
}

/* call this on fork(), because reading a BUFFERED fd won't work in child */
void
_detachbuf(void)
{
	int i;
	Fdinfo *f;

	if(mux == 0)
		return;
	_SEGDETACH(mux);
	for(i = 0; i &lt; OPEN_MAX; i++){
		f = &amp;_fdinfo[i];
		if(f-&gt;flags&amp;FD_BUFFERED)
			f-&gt;flags = (f-&gt;flags&amp;~FD_BUFFERED) | FD_BUFFEREDX;
				/* mark 'poisoned' */
	}
	mux = 0;
	_muxsid = -1;
	_mainpid = -1;
	timerpid = -1;
}

static int
copynotehandler(void *, char *)
{
	if(_finishing)
		_finish(0, 0);
	_NOTED(1);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

