<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/_fdinfo.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/_fdinfo.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#define  _BSDTIME_EXTENSION
#include "lib.h"
#include &lt;sys/stat.h&gt;
#include &lt;stdlib.h&gt;
#include "sys9.h"
#include &lt;string.h&gt;

extern int errno;
Fdinfo _fdinfo[OPEN_MAX];

/*
   called from _envsetup, either with the value of the environment
   variable _fdinfo (from s to se-1), or with s==0 if there was no _fdinfo
*/
static void
defaultfdinit(void)
{
	int i;
	Fdinfo *fi;

	for(i = 0; i &lt;= 2; i++) {
		fi = &amp;_fdinfo[i];
		fi-&gt;flags = FD_ISOPEN;
		fi-&gt;oflags = (i == 0)? O_RDONLY : O_WRONLY;
		if(_isatty(i))
			fi-&gt;flags |= FD_ISTTY;
	}
}

static int
readprocfdinit(void)
{
	/* construct info from /proc/$pid/fd */
	char buf[8192];
	Fdinfo *fi;
	int fd, pfd, pid, n, tot, m;
	char *s, *nexts;

	memset(buf, 0, sizeof buf);
	pfd = _OPEN("#c/pid", 0);
	if(pfd &lt; 0)
		return -1;
	if(_PREAD(pfd, buf, 100, 0) &lt; 0){
		_CLOSE(pfd);
		return -1;
	}
	_CLOSE(pfd);
	pid = strtoul(buf, 0, 10);
	strcpy(buf, "#p/");
	_ultoa(buf+3, pid);
	strcat(buf, "/fd");
	pfd = _OPEN(buf, 0);
	if(pfd &lt; 0)
		return -1;
	memset(buf, 0, sizeof buf);
	tot = 0;
	for(;;){
		n = _PREAD(pfd, buf+tot, sizeof buf-tot, tot);
		if(n &lt;= 0)
			break;
		tot += n;
	}
	_CLOSE(pfd);
	if(n &lt; 0)
		return -1;
	buf[sizeof buf-1] = '\0';
	s = strchr(buf, '\n');	/* skip current directory */
	if(s == 0)
		return -1;
	s++;
	m = 0;
	for(; s &amp;&amp; *s; s=nexts){
		nexts = strchr(s, '\n');
		if(nexts)
			*nexts++ = '\0';
		errno = 0;
		fd = strtoul(s, &amp;s, 10);
		if(errno != 0)
			return -1;
		if(fd &gt;= OPEN_MAX)
			continue;
		if(fd == pfd)
			continue;
		fi = &amp;_fdinfo[fd];
		fi-&gt;flags = FD_ISOPEN;
		while(*s == ' ' || *s == '\t')
			s++;
		if(*s == 'r'){
			m |= 1;
			s++;
		}
		if(*s == 'w'){
			m |= 2;
		}
		if(m==1)
			fi-&gt;oflags = O_RDONLY;
		else if(m==2)
			fi-&gt;oflags = O_WRONLY;
		else
			fi-&gt;oflags = O_RDWR;
		if(strlen(s) &gt;= 9 &amp;&amp; strcmp(s+strlen(s)-9, "/dev/cons") == 0)
			fi-&gt;flags |= FD_ISTTY;
	}
	return 0;
}

static void
sfdinit(int usedproc, char *s, char *se)
{
	Fdinfo *fi;
	unsigned long fd, fl, ofl;
	char *e;

	while(s &lt; se){
		fd = strtoul(s, &amp;e, 10);
		if(s == e)
			break;
		s = e;
		fl = strtoul(s, &amp;e, 10);
		if(s == e)
			break;
		s = e;
		ofl = strtoul(s, &amp;e, 10);
		if(s == e)
			break;
		s = e;
		if(fd &lt; OPEN_MAX){
			fi = &amp;_fdinfo[fd];
			if(usedproc &amp;&amp; !(fi-&gt;flags&amp;FD_ISOPEN))
				continue;	/* should probably ignore all of $_fdinit */
			fi-&gt;flags = fl;
			fi-&gt;oflags = ofl;
			if(_isatty(fd))
				fi-&gt;flags |= FD_ISTTY;
		}
	}

}

void
_fdinit(char *s, char *se)
{
	int i, usedproc;
	Fdinfo *fi;
	struct stat sbuf;

	usedproc = 0;
	if(readprocfdinit() == 0)
		usedproc = 1;
else
_WRITE(2, "FAILED\n", 7);
	if(s)
		sfdinit(usedproc, s, se);
	if(!s &amp;&amp; !usedproc)
		defaultfdinit();

	for(i = 0; i &lt; OPEN_MAX; i++) {
		fi = &amp;_fdinfo[i];
		if(fi-&gt;flags&amp;FD_ISOPEN){
			if(fstat(i, &amp;sbuf) &gt;= 0) {
				fi-&gt;uid = sbuf.st_uid;
				fi-&gt;gid = sbuf.st_gid;
			}
		}
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

