<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/profile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/profile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;stdio.h&gt;
#include	&lt;stdlib.h&gt;
#include	&lt;string.h&gt;
#include	&lt;unistd.h&gt;
#include	&lt;errno.h&gt;
#include	&lt;sys/types.h&gt;
#include	&lt;fcntl.h&gt;
#include	"sys9.h"

enum {
	Profoff,			/* No profiling */
	Profuser,			/* Measure user time only (default) */
	Profkernel,			/* Measure user + kernel time */
	Proftime,			/* Measure total time */
	Profsample,			/* Use clock interrupt to sample (default when there is no cycle counter) */
}; /* what */

typedef long long vlong;
typedef unsigned long ulong;
typedef unsigned long long uvlong;

#include	"/sys/include/tos.h"

extern	void*	sbrk(ulong);
extern	long	_callpc(void**);
extern	long	_savearg(void);
extern	void	_cycles(uvlong*);	/* 64-bit value of the cycle counter if there is one, 0 if there isn't */

static ulong	khz;
static ulong	perr;
static int	havecycles;

typedef	struct	Plink	Plink;
struct	Plink
{
	Plink	*old;
	Plink	*down;
	Plink	*link;
	long	pc;
	long	count;
	vlong	time;
};

#pragma profile off

ulong
_profin(void)
{
	void *dummy;
	long pc;
	Plink *pp, *p;
	ulong arg;
	vlong t;

	arg = _savearg();
	pc = _callpc(&amp;dummy);
	pp = _tos-&gt;prof.pp;
	if(pp == 0 || (_tos-&gt;prof.pid &amp;&amp; _tos-&gt;pid != _tos-&gt;prof.pid))
		return arg;

	for(p=pp-&gt;down; p; p=p-&gt;link)
		if(p-&gt;pc == pc)
			goto out;
	p = _tos-&gt;prof.next + 1;
	if(p &gt;= _tos-&gt;prof.last){
		_tos-&gt;prof.pp = 0;
		perr++;
		return arg;
	}
	_tos-&gt;prof.next = p;
	p-&gt;link = pp-&gt;down;
	pp-&gt;down = p;
	p-&gt;pc = pc;
	p-&gt;old = pp;
	p-&gt;down = 0;
	p-&gt;count = 0;
	p-&gt;time = 0LL;

out:
	_tos-&gt;prof.pp = p;
	p-&gt;count++;
	switch(_tos-&gt;prof.what){
	case Profkernel:
		p-&gt;time = p-&gt;time - _tos-&gt;pcycles;
		goto proftime;
	case Profuser:
		/* Add kernel cycles on proc entry */
		p-&gt;time = p-&gt;time + _tos-&gt;kcycles;
		/* fall through */
	case Proftime:	
	proftime:		/* Subtract cycle counter on proc entry */
		_cycles((uvlong*)&amp;t);
		p-&gt;time = p-&gt;time - t;
		break;
	case Profsample:
		p-&gt;time = p-&gt;time - _tos-&gt;clock;
		break;
	}
	return arg;		/* disgusting linkage */
}

ulong
_profout(void)
{
	Plink *p;
	ulong arg;
	vlong t;

	arg = _savearg();
	p = _tos-&gt;prof.pp;
	if (p == NULL || (_tos-&gt;prof.pid != 0 &amp;&amp; _tos-&gt;pid != _tos-&gt;prof.pid))
		return arg;	/* Not our process */
	switch(_tos-&gt;prof.what){
	case Profkernel:		/* Add proc cycles on proc entry */
		p-&gt;time = p-&gt;time + _tos-&gt;pcycles;
		goto proftime;
	case Profuser:			/* Subtract kernel cycles on proc entry */
		p-&gt;time = p-&gt;time - _tos-&gt;kcycles;
		/* fall through */
	case Proftime:	
	proftime:				/* Add cycle counter on proc entry */
		_cycles((uvlong*)&amp;t);
		p-&gt;time = p-&gt;time + t;
		break;
	case Profsample:
		p-&gt;time = p-&gt;time + _tos-&gt;clock;
		break;
	}
	_tos-&gt;prof.pp = p-&gt;old;
	return arg;
}

/* stdio may not be ready for us yet */
static void
err(char *fmt, ...)
{
	int fd;
	va_list arg;
	char buf[128];

	if((fd = open("/dev/cons", OWRITE)) == -1)
		return;
	va_start(arg, fmt);
	/*
	 * C99 now requires *snprintf to return the number of characters
	 * that *would* have been emitted, had there been room for them,
	 * or a negative value on an `encoding error'.  Arrgh!
	 */
	vsnprintf(buf, sizeof buf, fmt, arg);
	va_end(arg);
	write(fd, buf, strlen(buf));
	close(fd);
}

void
_profdump(void)
{
	int f;
	long n;
	Plink *p;
	char *vp;
	char filename[64];

	if (_tos-&gt;prof.what == 0)
		return;	/* No profiling */
	if (_tos-&gt;prof.pid != 0 &amp;&amp; _tos-&gt;pid != _tos-&gt;prof.pid)
		return;	/* Not our process */
	if(perr)
		err("%lud Prof errors\n", perr);
	_tos-&gt;prof.pp = NULL;
	if (_tos-&gt;prof.pid)
		snprintf(filename, sizeof filename - 1, "prof.%ld", _tos-&gt;prof.pid);
	else
		snprintf(filename, sizeof filename - 1, "prof.out");
	f = creat(filename, 0666);
	if(f &lt; 0) {
		err("%s: cannot create - %s\n", filename, strerror(errno));
		return;
	}
	_tos-&gt;prof.pid = ~0;	/* make sure data gets dumped once */
	switch(_tos-&gt;prof.what){
	case Profkernel:
		_cycles((uvlong*)&amp;_tos-&gt;prof.first-&gt;time);
		_tos-&gt;prof.first-&gt;time = _tos-&gt;prof.first-&gt;time + _tos-&gt;pcycles;
		break;
	case Profuser:
		_cycles((uvlong*)&amp;_tos-&gt;prof.first-&gt;time);
		_tos-&gt;prof.first-&gt;time = _tos-&gt;prof.first-&gt;time - _tos-&gt;kcycles;
		break;
	case Proftime:
		_cycles((uvlong*)&amp;_tos-&gt;prof.first-&gt;time);
		break;
	case Profsample:
		_tos-&gt;prof.first-&gt;time = _tos-&gt;clock;
		break;
	}
	vp = (char*)_tos-&gt;prof.first;

	for(p = _tos-&gt;prof.first; p &lt;= _tos-&gt;prof.next; p++) {

		/*
		 * short down
		 */
		n = 0xffff;
		if(p-&gt;down)
			n = p-&gt;down - _tos-&gt;prof.first;
		vp[0] = n&gt;&gt;8;
		vp[1] = n;

		/*
		 * short right
		 */
		n = 0xffff;
		if(p-&gt;link)
			n = p-&gt;link - _tos-&gt;prof.first;
		vp[2] = n&gt;&gt;8;
		vp[3] = n;
		vp += 4;

		/*
		 * long pc
		 */
		n = p-&gt;pc;
		vp[0] = n&gt;&gt;24;
		vp[1] = n&gt;&gt;16;
		vp[2] = n&gt;&gt;8;
		vp[3] = n;
		vp += 4;

		/*
		 * long count
		 */
		n = p-&gt;count;
		vp[0] = n&gt;&gt;24;
		vp[1] = n&gt;&gt;16;
		vp[2] = n&gt;&gt;8;
		vp[3] = n;
		vp += 4;

		/*
		 * vlong time
		 */
		if (havecycles){
			n = (vlong)(p-&gt;time / (vlong)khz);
		}else
			n = p-&gt;time;

		vp[0] = n&gt;&gt;24;
		vp[1] = n&gt;&gt;16;
		vp[2] = n&gt;&gt;8;
		vp[3] = n;
		vp += 4;
	}
	write(f, (char*)_tos-&gt;prof.first, vp - (char*)_tos-&gt;prof.first);
	close(f);

}

void
_profinit(int entries, int what)
{
	if (_tos-&gt;prof.what == 0)
		return;	/* Profiling not linked in */
	_tos-&gt;prof.pp = NULL;
	_tos-&gt;prof.first = calloc(entries*sizeof(Plink),1);
	_tos-&gt;prof.last = _tos-&gt;prof.first + entries;
	_tos-&gt;prof.next = _tos-&gt;prof.first;
	_tos-&gt;prof.pid = _tos-&gt;pid;
	_tos-&gt;prof.what = what;
	_tos-&gt;clock = 1;
}

void
_profmain(void)
{
	char ename[50];
	int n, f;

	n = 2000;
	if (_tos-&gt;cyclefreq != 0LL){
		khz = _tos-&gt;cyclefreq / 1000;	/* Report times in milliseconds */
		havecycles = 1;
	}
	f = open("/env/profsize", OREAD);
	if(f &gt;= 0) {
		memset(ename, 0, sizeof(ename));
		read(f, ename, sizeof(ename)-1);
		close(f);
		n = atol(ename);
	}
	_tos-&gt;prof.what = Profuser;
	f = open("/env/proftype", OREAD);
	if(f &gt;= 0) {
		memset(ename, 0, sizeof(ename));
		read(f, ename, sizeof(ename)-1);
		close(f);
		if (strcmp(ename, "user") == 0)
			_tos-&gt;prof.what = Profuser;
		else if (strcmp(ename, "kernel") == 0)
			_tos-&gt;prof.what = Profkernel;
		else if (strcmp(ename, "elapsed") == 0 || strcmp(ename, "time") == 0)
			_tos-&gt;prof.what = Proftime;
		else if (strcmp(ename, "sample") == 0)
			_tos-&gt;prof.what = Profsample;
	}
	_tos-&gt;prof.first = sbrk(n*sizeof(Plink));
	_tos-&gt;prof.last = sbrk(0);
	_tos-&gt;prof.next = _tos-&gt;prof.first;
	_tos-&gt;prof.pp = NULL;
	_tos-&gt;prof.pid = _tos-&gt;pid;
	atexit(_profdump);
	_tos-&gt;clock = 1;
}

void prof(void (*fn)(void*), void *arg, int entries, int what)
{
	_profinit(entries, what);
	_tos-&gt;prof.pp = _tos-&gt;prof.next;
	fn(arg);
	_profdump();
}

#pragma profile on

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

