<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/wait.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/wait.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "lib.h"
#include &lt;stdlib.h&gt;
#include &lt;sys/wait.h&gt;
#include &lt;sys/time.h&gt;
#include &lt;sys/resource.h&gt;
#include &lt;sys/stat.h&gt;
#include &lt;unistd.h&gt;
#include &lt;string.h&gt;
#include &lt;errno.h&gt;
#include &lt;stdio.h&gt;
#include "sys9.h"
#include "dir.h"

/*
 * status not yet collected for processes that have exited
 */
typedef struct Waited Waited;
struct Waited {
	Waitmsg*	msg;
	Waited*	next;
};
static Waited *wd;

static Waitmsg *
lookpid(int pid)
{
	Waited **wl, *w;
	Waitmsg *msg;

	for(wl = &amp;wd; (w = *wl) != nil; wl = &amp;w-&gt;next)
		if(pid &lt;= 0 || w-&gt;msg-&gt;pid == pid){
			msg = w-&gt;msg;
			*wl = w-&gt;next;
			free(w);
			return msg;
		}
	return 0;
}

static void
addpid(Waitmsg *msg)
{
	Waited *w;

	w = malloc(sizeof(*w));
	if(w == nil){
		/* lost it; what can we do? */
		free(msg);
		return;
	}
	w-&gt;msg = msg;
	w-&gt;next = wd;
	wd = w;
}

static int
waitstatus(Waitmsg *w)
{
	int r, t;
	char *bp, *ep;

	r = 0;
	t = 0;
	if(w-&gt;msg[0]){
		/* message is 'prog pid:string' */
		bp = w-&gt;msg;
		while(*bp){
			if(*bp++ == ':')
				break;
		}
		if(*bp == 0)
			bp = w-&gt;msg;
		r = strtol(bp, &amp;ep, 10);
		if(*ep == 0){
			if(r &lt; 0 || r &gt;= 256)
				r = 1;
		}else{
			t = _stringsig(bp);
			if(t == 0)
				r = 1;
		}
	}
	return (r&lt;&lt;8) | t;
}

static void
waitresource(struct rusage *ru, Waitmsg *w)
{
	memset(ru, 0, sizeof(*ru));
	ru-&gt;ru_utime.tv_sec = w-&gt;time[0]/1000;
	ru-&gt;ru_utime.tv_usec = (w-&gt;time[0]%1000)*1000;
	ru-&gt;ru_stime.tv_sec = w-&gt;time[1]/1000;
	ru-&gt;ru_stime.tv_usec = (w-&gt;time[1]%1000)*1000;
}

pid_t
wait(int *status)
{
	return wait4(-1, status, 0, nil);
}

pid_t
waitpid(pid_t wpid, int *status, int options)
{
	return wait4(wpid, status, options, nil);
}

pid_t
wait3(int *status, int options, struct rusage *res)
{
	return wait4(-1, status, options, res);
}

pid_t
wait4(pid_t wpid, int *status, int options, struct rusage *res)
{
	char pname[50];
	Dir *d;
	Waitmsg *w;

	w = lookpid(wpid);
	if(w == nil){
		if(options &amp; WNOHANG){
			snprintf(pname, sizeof(pname), "/proc/%d/wait", getpid());
			d = _dirstat(pname);
			if(d != nil &amp;&amp; d-&gt;length == 0){
				free(d);
				return 0;
			}
			free(d);
		}
		for(;;){
			w = _WAIT();
			if(w == nil){
				_syserrno();
				return -1;
			}
			if(wpid &lt;= 0 || w-&gt;pid == wpid)
				break;
			addpid(w);
		}
	}
	if(res != nil)
		waitresource(res, w);
	if(status != nil)
		*status = waitstatus(w);
	wpid = w-&gt;pid;
	free(w);
	return wpid;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

