<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/posix/tzset.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/posix/tzset.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdlib.h&gt;
#include &lt;sys/types.h&gt;
#include &lt;fcntl.h&gt;
#include &lt;time.h&gt;
#include &lt;ctype.h&gt;
#include &lt;string.h&gt;
#include &lt;unistd.h&gt;

#define TZFILE	"/etc/TZ"

static char TZ[128];
static char std[32] = "GMT0";
static char dst[32];
char *tzname[2] = {
	std, dst
};
time_t tzoffset, tzdstoffset;
int tzdst = 0;

static int
offset(char *env, time_t *off)
{
	int n, sign;
	size_t len, retlen;

	retlen = 0;
	sign = 1;
	/*
	 * strictly, no sign is allowed in the 'time' part of the
	 * dst start/stop rules, but who cares?
	 */
	if (*env == '-' || *env == '+') {
		if (*env++ == '-')
			sign = -1;
		retlen++;
	}
	if ((len = strspn(env, ":0123456789")) == 0)
		return 0;
	retlen += len;
	for (*off = 0; len &amp;&amp; isdigit(*env); len--)		/* hours */
		*off = *off*10 + (*env++ - '0')*60*60;
	if (len) {
		if (*env++ != ':')
			return 0;
		len--;
	}
	for (n = 0; len &amp;&amp; isdigit(*env); len--)		/* minutes */
		n = n*10 + (*env++ - '0')*60;
	*off += n;
	if (len) {
		if (*env++ != ':')
			return 0;
		len--;
	}
	for (n = 0; len &amp;&amp; isdigit(*env); len--)		/* seconds */
		n = n*10 + (*env++ - '0');
	*off = (*off + n)*sign;
	return retlen;
}

/*
 * TZ=stdoffset[dst[offset][,start[/time],end[/time]]]
 */
void
tzset(void)
{
	char *env, *p, envbuf[128];
	int fd, i;
	size_t len, retlen;
	time_t off;

	/*
	 * get the TZ environment variable and check for validity.
	 * the implementation-defined manner for dealing with the
	 * leading ':' format is to reject it.
	 * if it's ok, stash a copy away for quick comparison next time.
	 */
	if ((env = getenv("TZ")) == 0) {
		if ((fd = open(TZFILE, O_RDONLY)) == -1)
			return;
		if (read(fd, envbuf, sizeof(envbuf)-1) == -1) {
			close(fd);
			return;
		}
		close(fd);
		for (i = 0; i &lt; sizeof(envbuf); i++) {
			if (envbuf[i] != '\n')
				continue;
			envbuf[i] = '\0';
			break;
		}
		env = envbuf;
	}
	if (strcmp(env, TZ) == 0)
		return;
	if (*env == 0 || *env == ':')
		return;
	strncpy(TZ, env, sizeof(TZ)-1);
	TZ[sizeof(TZ)-1] = 0;
	/*
	 * get the 'std' string.
	 * before committing, check there is a valid offset.
	 */
	if ((len = strcspn(env, ":0123456789,-+")) == 0)
		return;
	if ((retlen = offset(env+len, &amp;off)) == 0)
		return;
	for (p = std, i = len+retlen; i; i--)
		*p++ = *env++;
	*p = 0;
	tzoffset = -off;
	/*
	 * get the 'dst' string (if any).
	 */
	if (*env == 0 || (len = strcspn(env, ":0123456789,-+")) == 0)
		return;
	for (p = dst; len; len--)
		*p++ = *env++;
	*p = 0;
	/*
	 * optional dst offset.
	 * default is one hour.
	 */
	tzdst = 1;
	if (retlen = offset(env+len, &amp;off)) {
		tzdstoffset = -off;
		env += retlen;
	}
	else
		tzdstoffset = tzoffset + 60*60;
	/*
	 * optional rule(s) for start/end of dst.
	 */
	if (*env == 0 || *env != ',' || *(env+1) == 0)
		return;
	env++;
	/*
	 * we could go on...
	 * but why bother?
	 */
	USED(env);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

