<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/utf/rune.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/utf/rune.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * The authors of this software are Rob Pike and Ken Thompson.
 *              Copyright (c) 2002 by Lucent Technologies.
 * Permission to use, copy, modify, and distribute this software for any
 * purpose without fee is hereby granted, provided that this entire notice
 * is included in all copies of any software which is or includes a copy
 * or modification of this software and in all copies of the supporting
 * documentation for such software.
 * THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTY.  IN PARTICULAR, NEITHER THE AUTHORS NOR LUCENT TECHNOLOGIES MAKE ANY
 * REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
 * OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
 */
#include &lt;stdarg.h&gt;
#include &lt;string.h&gt;
#include "utf.h"
#include "utfdef.h"

enum
{
	Bit1	= 7,
	Bitx	= 6,
	Bit2	= 5,
	Bit3	= 4,
	Bit4	= 3,
	Bit5	= 2,

	T1	= ((1&lt;&lt;(Bit1+1))-1) ^ 0xFF,	/* 0000 0000 */
	Tx	= ((1&lt;&lt;(Bitx+1))-1) ^ 0xFF,	/* 1000 0000 */
	T2	= ((1&lt;&lt;(Bit2+1))-1) ^ 0xFF,	/* 1100 0000 */
	T3	= ((1&lt;&lt;(Bit3+1))-1) ^ 0xFF,	/* 1110 0000 */
	T4	= ((1&lt;&lt;(Bit4+1))-1) ^ 0xFF,	/* 1111 0000 */
	T5	= ((1&lt;&lt;(Bit5+1))-1) ^ 0xFF,	/* 1111 1000 */

	Rune1	= (1&lt;&lt;(Bit1+0*Bitx))-1,		/* 0000 0000 0000 0000 0111 1111 */
	Rune2	= (1&lt;&lt;(Bit2+1*Bitx))-1,		/* 0000 0000 0000 0111 1111 1111 */
	Rune3	= (1&lt;&lt;(Bit3+2*Bitx))-1,		/* 0000 0000 1111 1111 1111 1111 */
	Rune4	= (1&lt;&lt;(Bit4+3*Bitx))-1,		/* 0001 1111 1111 1111 1111 1111 */

	Maskx	= (1&lt;&lt;Bitx)-1,			/* 0011 1111 */
	Testx	= Maskx ^ 0xFF,			/* 1100 0000 */

	SurrogateMin	= 0xD800,
	SurrogateMax	= 0xDFFF,

	Bad	= Runeerror,
};

int
chartorune(Rune *rune, char *str)
{
	int c, c1, c2, c3;
	long l;

	/*
	 * one character sequence
	 *	00000-0007F =&gt; T1
	 */
	c = *(uchar*)str;
	if(c &lt; Tx) {
		*rune = c;
		return 1;
	}

	/*
	 * two character sequence
	 *	00080-007FF =&gt; T2 Tx
	 */
	c1 = *(uchar*)(str+1) ^ Tx;
	if(c1 &amp; Testx)
		goto bad;
	if(c &lt; T3) {
		if(c &lt; T2)
			goto bad;
		l = ((c &lt;&lt; Bitx) | c1) &amp; Rune2;
		if(l &lt;= Rune1)
			goto bad;
		*rune = l;
		return 2;
	}

	/*
	 * three character sequence
	 *	00800-0FFFF =&gt; T3 Tx Tx
	 */
	c2 = *(uchar*)(str+2) ^ Tx;

	if(c2 &amp; Testx)
		goto bad;
	if(c &lt; T4) {
		l = ((((c &lt;&lt; Bitx) | c1) &lt;&lt; Bitx) | c2) &amp; Rune3;
		if(l &lt;= Rune2)
			goto bad;
		if (SurrogateMin &lt;= l &amp;&amp; l &lt;= SurrogateMax)
			goto bad;
		*rune = l;
		return 3;
	}

	/*
	 * four character sequence
	 *	10000-10FFFF =&gt; T4 Tx Tx Tx
	 */
	if(UTFmax &gt;= 4) {
		c3 = *(uchar*)(str+3) ^ Tx;
		if(c3 &amp; Testx)
			goto bad;
		if(c &lt; T5) {
			l = ((((((c &lt;&lt; Bitx) | c1) &lt;&lt; Bitx) | c2) &lt;&lt; Bitx) | c3) &amp; Rune4;
			if(l &lt;= Rune3)
				goto bad;
			if(l &gt; Runemax)
				goto bad;
			*rune = l;
			return 4;
		}
	}

	/*
	 * bad decoding
	 */
bad:
	*rune = Bad;
	return 1;
}

int
runetochar(char *str, Rune *rune)
{
	long c;

	/*
	 * one character sequence
	 *	00000-0007F =&gt; 00-7F
	 */
	c = *rune;
	if(c &lt;= Rune1) {
		str[0] = c;
		return 1;
	}

	/*
	 * two character sequence
	 *	0080-07FF =&gt; T2 Tx
	 */
	if(c &lt;= Rune2) {
		str[0] = T2 | (c &gt;&gt; 1*Bitx);
		str[1] = Tx | (c &amp; Maskx);
		return 2;
	}
	/*
	 * If the Rune is out of range or a surrogate half, convert it to the error rune.
	 * Do this test here because the error rune encodes to three bytes.
	 * Doing it earlier would duplicate work, since an out of range
	 * Rune wouldn't have fit in one or two bytes.
	 */
	if (c &gt; Runemax)
		c = Runeerror;
	if (SurrogateMin &lt;= c &amp;&amp; c &lt;= SurrogateMax)
		c = Runeerror;

	/*
	 * three character sequence
	 *	0800-FFFF =&gt; T3 Tx Tx
	 */
	if (c &lt;= Rune3) {
		str[0] = T3 |  (c &gt;&gt; 2*Bitx);
		str[1] = Tx | ((c &gt;&gt; 1*Bitx) &amp; Maskx);
		str[2] = Tx |  (c &amp; Maskx);
		return 3;
	}

	/*
	 * four character sequence (21-bit value)
	 *     10000-1FFFFF =&gt; T4 Tx Tx Tx
	 */
	str[0] = T4 | (c &gt;&gt; 3*Bitx);
	str[1] = Tx | ((c &gt;&gt; 2*Bitx) &amp; Maskx);
	str[2] = Tx | ((c &gt;&gt; 1*Bitx) &amp; Maskx);
	str[3] = Tx | (c &amp; Maskx);
	return 4;
}

int
runelen(long c)
{
	Rune rune;
	char str[10];

	rune = c;
	return runetochar(str, &amp;rune);
}

int
runenlen(Rune *r, int nrune)
{
	int nb, c;

	nb = 0;
	while(nrune--) {
		c = *r++;
		if(c &lt;= Rune1)
			nb++;
		else if(c &lt;= Rune2)
			nb += 2;
		else if(c &lt;= Rune3)
 			nb += 3;
		else
			nb += 4;
	}
	return nb;
}

int
fullrune(char *str, int n)
{
	int c;
	if(n &lt;= 0)
		return 0;
	c = *(uchar*)str;
	if(c &lt; Tx)
		return 1;
	if(c &lt; T3)
		return n &gt;= 2;
	if(c &lt; T4)
		return n &gt;= 3;
	return n &gt;= 4;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

