<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>/n/sources/plan9/sys/src/boot/pc/ether8169.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size=10pt"><a href="/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/boot/pc/ether8169.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright &copy; 2006 Lucent Technologies.<br />
Distributed under the
<a href="/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Realtek RTL8110S/8169S.
 * Mostly there. There are some magic register values used
 * which are not described in any datasheet or driver but seem
 * to be necessary.
 * Why is the Fovf descriptor bit set for every received packet?
 * Occasionally the hardware indicates an input TCP checksum error
 * although the higher-level software seems to check the packet OK?
 * No tuning has been done. Only tested on an RTL8110S, there
 * are slight differences between the chips in the series so some
 * tweaks may be needed.
 */
#include "u.h"
#include "lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"

typedef struct QLock { int r; } QLock;
#define qlock(i)	while(0)
#define qunlock(i)	while(0)
#define iallocb		allocb
#define iprint		print

#include "etherif.h"
#include "ethermii.h"

enum {					/* registers */
	Idr0		= 0x00,		/* MAC address */
	Mar0		= 0x08,		/* Multicast address */
	Dtccr		= 0x10,		/* Dump Tally Counter Command */
	Tnpds		= 0x20,		/* Transmit Normal Priority Descriptors */
	Thpds		= 0x28,		/* Transmit High Priority Descriptors */
	Flash		= 0x30,		/* Flash Memory Read/Write */
	Erbcr		= 0x34,		/* Early Receive Byte Count */
	Ersr		= 0x36,		/* Early Receive Status */
	Cr		= 0x37,		/* Command Register */
	Tppoll		= 0x38,		/* Transmit Priority Polling */
	Imr		= 0x3C,		/* Interrupt Mask */
	Isr		= 0x3E,		/* Interrupt Status */
	Tcr		= 0x40,		/* Transmit Configuration */
	Rcr		= 0x44,		/* Receive Configuration */
	Tctr		= 0x48,		/* Timer Count */
	Mpc		= 0x4C,		/* Missed Packet Counter */
	Cr9346		= 0x50,		/* 9346 Command Register */
	Config0		= 0x51,		/* Configuration Register 0 */
	Config1		= 0x52,		/* Configuration Register 1 */
	Config2		= 0x53,		/* Configuration Register 2 */
	Config3		= 0x54,		/* Configuration Register 3 */
	Config4		= 0x55,		/* Configuration Register 4 */
	Config5		= 0x56,		/* Configuration Register 5 */
	Timerint	= 0x58,		/* Timer Interrupt */
	Mulint		= 0x5C,		/* Multiple Interrupt Select */
	Phyar		= 0x60,		/* PHY Access */
	Tbicsr0		= 0x64,		/* TBI Control and Status */
	Tbianar		= 0x68,		/* TBI Auto-Negotiation Advertisment */
	Tbilpar		= 0x6A,		/* TBI Auto-Negotiation Link Partner */
	Phystatus	= 0x6C,		/* PHY Status */

	Rms		= 0xDA,		/* Receive Packet Maximum Size */
	Cplusc		= 0xE0,		/* C+ Command */
	Rdsar		= 0xE4,		/* Receive Descriptor Start Address */
	Mtps		= 0xEC,		/* Max. Transmit Packet Size */
};

enum {					/* Dtccr */
	Cmd		= 0x00000008,	/* Command */
};

enum {					/* Cr */
	Te		= 0x04,		/* Transmitter Enable */
	Re		= 0x08,		/* Receiver Enable */
	Rst		= 0x10,		/* Software Reset */
};

enum {					/* Tppoll */
	Fswint		= 0x01,		/* Forced Software Interrupt */
	Npq		= 0x40,		/* Normal Priority Queue polling */
	Hpq		= 0x80,		/* High Priority Queue polling */
};

enum {					/* Imr/Isr */
	Rok		= 0x0001,	/* Receive OK */
	Rer		= 0x0002,	/* Receive Error */
	Tok		= 0x0004,	/* Transmit OK */
	Ter		= 0x0008,	/* Transmit Error */
	Rdu		= 0x0010,	/* Receive Descriptor Unavailable */
	Punlc		= 0x0020,	/* Packet Underrun or Link Change */
	Fovw		= 0x0040,	/* Receive FIFO Overflow */
	Tdu		= 0x0080,	/* Transmit Descriptor Unavailable */
	Swint		= 0x0100,	/* Software Interrupt */
	Timeout		= 0x4000,	/* Timer */
	Serr		= 0x8000,	/* System Error */
};

enum {					/* Tcr */
	MtxdmaSHIFT	= 8,		/* Max. DMA Burst Size */
	MtxdmaMASK	= 0x00000700,
	Mtxdmaunlimited	= 0x00000700,
	Acrc		= 0x00010000,	/* Append CRC (not) */
	Lbk0		= 0x00020000,	/* Loopback Test 0 */
	Lbk1		= 0x00040000,	/* Loopback Test 1 */
	Ifg2		= 0x00080000,	/* Interframe Gap 2 */
	HwveridSHIFT	= 23,		/* Hardware Version ID */
	HwveridMASK	= 0x7C800000,
	Macv01		= 0x00000000,	/* RTL8169 */
	Macv02		= 0x00800000,	/* RTL8169S/8110S */
	Macv03		= 0x04000000,	/* RTL8169S/8110S */
	Macv04		= 0x10000000,	/* RTL8169SB/8110SB */
	Macv05		= 0x18000000,	/* RTL8169SC/8110SC */
	Macv11		= 0x30000000,	/* RTL8168B/8111B */
	Macv12		= 0x38000000,	/* RTL8169B/8111B */
	Macv13		= 0x34000000,	/* RTL8101E */
	Macv14		= 0x30800000,	/* RTL8100E */
	Macv15		= 0x38800000,	/* RTL8100E */
	Ifg0		= 0x01000000,	/* Interframe Gap 0 */
	Ifg1		= 0x02000000,	/* Interframe Gap 1 */
};

enum {					/* Rcr */
	Aap		= 0x00000001,	/* Accept All Packets */
	Apm		= 0x00000002,	/* Accept Physical Match */
	Am		= 0x00000004,	/* Accept Multicast */
	Ab		= 0x00000008,	/* Accept Broadcast */
	Ar		= 0x00000010,	/* Accept Runt */
	Aer		= 0x00000020,	/* Accept Error */
	Sel9356		= 0x00000040,	/* 9356 EEPROM used */
	MrxdmaSHIFT	= 8,		/* Max. DMA Burst Size */
	MrxdmaMASK	= 0x00000700,
	Mrxdmaunlimited	= 0x00000700,
	RxfthSHIFT	= 13,		/* Receive Buffer Length */
	RxfthMASK	= 0x0000E000,
	Rxfth256	= 0x00008000,
	Rxfthnone	= 0x0000E000,
	Rer8		= 0x00010000,	/* Accept Error Packets &gt; 8 bytes */
	MulERINT	= 0x01000000,	/* Multiple Early Interrupt Select */
};

enum {					/* Cr9346 */
	Eedo		= 0x01,		/* */
	Eedi		= 0x02,		/* */
	Eesk		= 0x04,		/* */
	Eecs		= 0x08,		/* */
	Eem0		= 0x40,		/* Operating Mode */
	Eem1		= 0x80,
};

enum {					/* Phyar */
	DataMASK	= 0x0000FFFF,	/* 16-bit GMII/MII Register Data */
	DataSHIFT	= 0,
	RegaddrMASK	= 0x001F0000,	/* 5-bit GMII/MII Register Address */
	RegaddrSHIFT	= 16,
	Flag		= 0x80000000,	/* */
};

enum {					/* Phystatus */
	Fd		= 0x01,		/* Full Duplex */
	Linksts		= 0x02,		/* Link Status */
	Speed10		= 0x04,		/* */
	Speed100	= 0x08,		/* */
	Speed1000	= 0x10,		/* */
	Rxflow		= 0x20,		/* */
	Txflow		= 0x40,		/* */
	Entbi		= 0x80,		/* */
};

enum {					/* Cplusc */
	Mulrw		= 0x0008,	/* PCI Multiple R/W Enable */
	Dac		= 0x0010,	/* PCI Dual Address Cycle Enable */
	Rxchksum	= 0x0020,	/* Receive Checksum Offload Enable */
	Rxvlan		= 0x0040,	/* Receive VLAN De-tagging Enable */
	Endian		= 0x0200,	/* Endian Mode */
};

typedef struct D D;			/* Transmit/Receive Descriptor */
struct D {
	u32int	control;
	u32int	vlan;
	u32int	addrlo;
	u32int	addrhi;
};

enum {					/* Transmit Descriptor control */
	TxflMASK	= 0x0000FFFF,	/* Transmit Frame Length */
	TxflSHIFT	= 0,
	Tcps		= 0x00010000,	/* TCP Checksum Offload */
	Udpcs		= 0x00020000,	/* UDP Checksum Offload */
	Ipcs		= 0x00040000,	/* IP Checksum Offload */
	Lgsen		= 0x08000000,	/* Large Send */
};

enum {					/* Receive Descriptor control */
	RxflMASK	= 0x00003FFF,	/* Receive Frame Length */
	RxflSHIFT	= 0,
	Tcpf		= 0x00004000,	/* TCP Checksum Failure */
	Udpf		= 0x00008000,	/* UDP Checksum Failure */
	Ipf		= 0x00010000,	/* IP Checksum Failure */
	Pid0		= 0x00020000,	/* Protocol ID0 */
	Pid1		= 0x00040000,	/* Protocol ID1 */
	Crce		= 0x00080000,	/* CRC Error */
	Runt		= 0x00100000,	/* Runt Packet */
	Res		= 0x00200000,	/* Receive Error Summary */
	Rwt		= 0x00400000,	/* Receive Watchdog Timer Expired */
	Fovf		= 0x00800000,	/* FIFO Overflow */
	Bovf		= 0x01000000,	/* Buffer Overflow */
	Bar		= 0x02000000,	/* Broadcast Address Received */
	Pam		= 0x04000000,	/* Physical Address Matched */
	Mar		= 0x08000000,	/* Multicast Address Received */
};

enum {					/* General Descriptor control */
	Ls		= 0x10000000,	/* Last Segment Descriptor */
	Fs		= 0x20000000,	/* First Segment Descriptor */
	Eor		= 0x40000000,	/* End of Descriptor Ring */
	Own		= 0x80000000,	/* Ownership */
};

/*
 */
enum {					/* Ring sizes  (&lt;= 1024) */
	Ntd		= 8,		/* Transmit Ring */
	Nrd		= 32,		/* Receive Ring */

	Mps		= ROUNDUP(ETHERMAXTU+4, 128),
};

typedef struct Dtcc Dtcc;
struct Dtcc {
	u64int	txok;
	u64int	rxok;
	u64int	txer;
	u32int	rxer;
	u16int	misspkt;
	u16int	fae;
	u32int	tx1col;
	u32int	txmcol;
	u64int	rxokph;
	u64int	rxokbrd;
	u32int	rxokmu;
	u16int	txabt;
	u16int	txundrn;
};

enum {						/* Variants */
	Rtl8100e	= (0x8136&lt;&lt;16)|0x10EC,	/* RTL810[01]E ? */
	Rtl8169c		= (0x0116&lt;&lt;16)|0x16EC,	/* RTL8169C+ (USR997902) */
	Rtl8169sc	= (0x8167&lt;&lt;16)|0x10EC,	/* RTL8169SC */
	Rtl8168b	= (0x8168&lt;&lt;16)|0x10EC,	/* RTL8168B */
	Rtl8169		= (0x8169&lt;&lt;16)|0x10EC,	/* RTL8169 */
};

typedef struct Ctlr Ctlr;
typedef struct Ctlr {
	int	port;
	Pcidev*	pcidev;
	Ctlr*	next;
	int	active;

	void*	nic;

	QLock	alock;			/* attach */
	Lock	ilock;			/* init */
	int	init;			/*  */

	int	pciv;			/*  */
	int	macv;			/* MAC version */
	int	phyv;			/* PHY version */

	Mii*	mii;

	Lock	tlock;			/* transmit */
	D*	td;			/* descriptor ring */
	Block**	tb;			/* transmit buffers */
	int	ntd;

	int	tdh;			/* head - producer index (host) */
	int	tdt;			/* tail - consumer index (NIC) */
	int	ntdfree;
	int	ntq;

	int	mtps;			/* Max. Transmit Packet Size */

	Lock	rlock;			/* receive */
	D*	rd;			/* descriptor ring */
	void**	rb;			/* receive buffers */
	int	nrd;

	int	rdh;			/* head - producer index (NIC) */
	int	rdt;			/* tail - consumer index (host) */
	int	nrdfree;

	int	rcr;			/* receive configuration register */

	QLock	slock;			/* statistics */
	Dtcc*	dtcc;
	uint	txdu;
	uint	tcpf;
	uint	udpf;
	uint	ipf;
	uint	fovf;
	uint	ierrs;
	uint	rer;
	uint	rdu;
	uint	punlc;
	uint	fovw;
} Ctlr;

static Ctlr* rtl8169ctlrhead;
static Ctlr* rtl8169ctlrtail;

#define csr8r(c, r)	(inb((c)-&gt;port+(r)))
#define csr16r(c, r)	(ins((c)-&gt;port+(r)))
#define csr32r(c, r)	(inl((c)-&gt;port+(r)))
#define csr8w(c, r, b)	(outb((c)-&gt;port+(r), (int)(b)))
#define csr16w(c, r, w)	(outs((c)-&gt;port+(r), (ushort)(w)))
#define csr32w(c, r, l)	(outl((c)-&gt;port+(r), (ulong)(l)))

static int
rtl8169miimir(Mii* mii, int pa, int ra)
{
	uint r;
	int timeo;
	Ctlr *ctlr;

	if(pa != 1)
		return -1;
	ctlr = mii-&gt;ctlr;

	r = (ra&lt;&lt;16) &amp; RegaddrMASK;
	csr32w(ctlr, Phyar, r);
	delay(1);
	for(timeo = 0; timeo &lt; 2000; timeo++){
		if((r = csr32r(ctlr, Phyar)) &amp; Flag)
			break;
		microdelay(100);
	}
	if(!(r &amp; Flag))
		return -1;

	return (r &amp; DataMASK)&gt;&gt;DataSHIFT;
}

static int
rtl8169miimiw(Mii* mii, int pa, int ra, int data)
{
	uint r;
	int timeo;
	Ctlr *ctlr;

	if(pa != 1)
		return -1;
	ctlr = mii-&gt;ctlr;

	r = Flag|((ra&lt;&lt;16) &amp; RegaddrMASK)|((data&lt;&lt;DataSHIFT) &amp; DataMASK);
	csr32w(ctlr, Phyar, r);
	delay(1);
	for(timeo = 0; timeo &lt; 2000; timeo++){
		if(!((r = csr32r(ctlr, Phyar)) &amp; Flag))
			break;
		microdelay(100);
	}
	if(r &amp; Flag)
		return -1;

	return 0;
}

static int
rtl8169mii(Ctlr* ctlr)
{
	MiiPhy *phy;

	/*
	 * Link management.
	 */
	if((ctlr-&gt;mii = malloc(sizeof(Mii))) == nil)
		return -1;
	ctlr-&gt;mii-&gt;mir = rtl8169miimir;
	ctlr-&gt;mii-&gt;miw = rtl8169miimiw;
	ctlr-&gt;mii-&gt;ctlr = ctlr;

	/*
	 * Get rev number out of Phyidr2 so can config properly.
	 * There's probably more special stuff for Macv0[234] needed here.
	 */
	ctlr-&gt;phyv = rtl8169miimir(ctlr-&gt;mii, 1, Phyidr2) &amp; 0x0F;
	if(ctlr-&gt;macv == Macv02){
		csr8w(ctlr, 0x82, 1);				/* magic */
		rtl8169miimiw(ctlr-&gt;mii, 1, 0x0B, 0x0000);	/* magic */
	}

	if(mii(ctlr-&gt;mii, (1&lt;&lt;1)) == 0 || (phy = ctlr-&gt;mii-&gt;curphy) == nil){
		free(ctlr-&gt;mii);
		ctlr-&gt;mii = nil;
		return -1;
	}
	print("oui %#ux phyno %d, macv = %#8.8ux phyv = %#4.4ux\n",
		phy-&gt;oui, phy-&gt;phyno, ctlr-&gt;macv, ctlr-&gt;phyv);

	miiane(ctlr-&gt;mii, ~0, ~0, ~0);

	return 0;
}

static void
rtl8169halt(Ctlr* ctlr)
{
	csr8w(ctlr, Cr, 0);
	csr16w(ctlr, Imr, 0);
	csr16w(ctlr, Isr, ~0);
}

static int
rtl8169reset(Ctlr* ctlr)
{
	u32int r;
	int timeo;

	/*
	 * Soft reset the controller.
	 */
	csr8w(ctlr, Cr, Rst);
	for(r = timeo = 0; timeo &lt; 1000; timeo++){
		r = csr8r(ctlr, Cr);
		if(!(r &amp; Rst))
			break;
		delay(1);
	}
	rtl8169halt(ctlr);

	if(r &amp; Rst)
		return -1;
	return 0;
}

static void
rtl8169detach(Ether* edev)
{
	rtl8169reset(edev-&gt;ctlr);
}

static void
rtl8169replenish(Ctlr* ctlr)
{
	D *d;
	int rdt;
	void *bp;

	rdt = ctlr-&gt;rdt;
	while(NEXT(rdt, ctlr-&gt;nrd) != ctlr-&gt;rdh){
		d = &amp;ctlr-&gt;rd[rdt];
		if(ctlr-&gt;rb[rdt] == nil){
			/*
			 * simple allocation for now
			 */
			bp = mallocalign(Mps, 8, 0, 0);
			ctlr-&gt;rb[rdt] = bp;
			d-&gt;addrlo = PCIWADDR(bp);
			d-&gt;addrhi = 0;
		}
		coherence();
		d-&gt;control |= Own|Mps;
		rdt = NEXT(rdt, ctlr-&gt;nrd);
		ctlr-&gt;nrdfree++;
	}
	ctlr-&gt;rdt = rdt;
}

static int
rtl8169init(Ether* edev)
{
	u32int r;
	Ctlr *ctlr;
	u8int cplusc;

	ctlr = edev-&gt;ctlr;
	ilock(&amp;ctlr-&gt;ilock);

	rtl8169halt(ctlr);

	/*
	 * MAC Address.
	 * Must put chip into config register write enable mode.
	 */
	csr8w(ctlr, Cr9346, Eem1|Eem0);
	r = (edev-&gt;ea[3]&lt;&lt;24)|(edev-&gt;ea[2]&lt;&lt;16)|(edev-&gt;ea[1]&lt;&lt;8)|edev-&gt;ea[0];
	csr32w(ctlr, Idr0, r);
	r = (edev-&gt;ea[5]&lt;&lt;8)|edev-&gt;ea[4];
	csr32w(ctlr, Idr0+4, r);

	/*
	 * Transmitter.
	 */
	memset(ctlr-&gt;td, 0, sizeof(D)*ctlr-&gt;ntd);
	ctlr-&gt;tdh = ctlr-&gt;tdt = 0;
	ctlr-&gt;td[ctlr-&gt;ntd-1].control = Eor;

	/*
	 * Receiver.
	 * Need to do something here about the multicast filter.
	 */
	memset(ctlr-&gt;rd, 0, sizeof(D)*ctlr-&gt;nrd);
	ctlr-&gt;rdh = ctlr-&gt;rdt = 0;
	ctlr-&gt;rd[ctlr-&gt;nrd-1].control = Eor;
	rtl8169replenish(ctlr);
	ctlr-&gt;rcr = Rxfthnone|Mrxdmaunlimited|Ab|Apm;

	/*
	 * Mtps is in units of 128 except for the RTL8169
	 * where is is 32. If using jumbo frames should be
	 * set to 0x3F.
	 * Setting Mulrw in Cplusc disables the Tx/Rx DMA burst
	 * settings in Tcr/Rcr; the (1&lt;&lt;14) is magic.
	 */
	ctlr-&gt;mtps = HOWMANY(Mps, 128);
	cplusc = csr16r(ctlr, Cplusc) &amp; ~(1&lt;&lt;14);
	cplusc |= Rxchksum|Mulrw;
	switch(ctlr-&gt;macv){
	default:
		return -1;
	case Macv01:
		ctlr-&gt;mtps = HOWMANY(Mps, 32);
		break;
	case Macv02:
	case Macv03:
		cplusc |= (1&lt;&lt;14);			/* magic */
		break;
	case Macv05:
		/*
		 * This is interpreted from clearly bogus code
		 * in the manufacturer-supplied driver, it could
		 * be wrong. Untested.
		 */
		r = csr8r(ctlr, Config2) &amp; 0x07;
		if(r == 0x01)				/* 66MHz PCI */
			csr32w(ctlr, 0x7C, 0x0007FFFF);	/* magic */
		else
			csr32w(ctlr, 0x7C, 0x0007FF00);	/* magic */
		pciclrmwi(ctlr-&gt;pcidev);
		break;
	case Macv13:
		/*
		 * This is interpreted from clearly bogus code
		 * in the manufacturer-supplied driver, it could
		 * be wrong. Untested.
		 */
		pcicfgw8(ctlr-&gt;pcidev, 0x68, 0x00);	/* magic */
		pcicfgw8(ctlr-&gt;pcidev, 0x69, 0x08);	/* magic */
		break;
	case Macv04:
	case Macv11:
	case Macv12:
	case Macv14:
	case Macv15:
		break;
	}

	/*
	 * Enable receiver/transmitter.
	 * Need to do this first or some of the settings below
	 * won't take.
	 */
	switch(ctlr-&gt;pciv){
	default:
		csr8w(ctlr, Cr, Te|Re);
		csr32w(ctlr, Tcr, Ifg1|Ifg0|Mtxdmaunlimited);
		csr32w(ctlr, Rcr, ctlr-&gt;rcr);
	case Rtl8169sc:
	case Rtl8168b:
		break;
	}

	/*
	 * Interrupts.
	 * Disable Tdu|Tok for now, the transmit routine will tidy.
	 * Tdu means the NIC ran out of descriptors to send, so it
	 * doesn't really need to ever be on.
	 */
	csr32w(ctlr, Timerint, 0);
	csr16w(ctlr, Imr, Serr|Timeout|Fovw|Punlc|Rdu|Ter|Rer|Rok);

	/*
	 * Clear missed-packet counter;
	 * initial early transmit threshold value;
	 * set the descriptor ring base addresses;
	 * set the maximum receive packet size;
	 * no early-receive interrupts.
	 */
	csr32w(ctlr, Mpc, 0);
	csr8w(ctlr, Mtps, ctlr-&gt;mtps);
	csr32w(ctlr, Tnpds+4, 0);
	csr32w(ctlr, Tnpds, PCIWADDR(ctlr-&gt;td));
	csr32w(ctlr, Rdsar+4, 0);
	csr32w(ctlr, Rdsar, PCIWADDR(ctlr-&gt;rd));
	csr16w(ctlr, Rms, Mps);
	r = csr16r(ctlr, Mulint) &amp; 0xF000;
	csr16w(ctlr, Mulint, r);
	csr16w(ctlr, Cplusc, cplusc);

	/*
	 * Set configuration.
	 */
	switch(ctlr-&gt;pciv){
	default:
		break;
	case Rtl8169sc:
		csr16w(ctlr, 0xE2, 0);			/* magic */
		csr8w(ctlr, Cr, Te|Re);
		csr32w(ctlr, Tcr, Ifg1|Ifg0|Mtxdmaunlimited);
		csr32w(ctlr, Rcr, ctlr-&gt;rcr);
		break;
	case Rtl8168b:
	case Rtl8169c:
		csr16w(ctlr, 0xE2, 0);			/* magic */
		csr16w(ctlr, Cplusc, 0x2000);		/* magic */
		csr8w(ctlr, Cr, Te|Re);
		csr32w(ctlr, Tcr, Ifg1|Ifg0|Mtxdmaunlimited);
		csr32w(ctlr, Rcr, ctlr-&gt;rcr);
		csr16w(ctlr, Rms, 0x0800);
		csr8w(ctlr, Mtps, 0x3F);
		break;
	}

	csr8w(ctlr, Cr9346, 0);

	iunlock(&amp;ctlr-&gt;ilock);

//	rtl8169mii(ctlr);

	return 0;
}

static void
rtl8169attach(Ether* edev)
{
	int timeo;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	qlock(&amp;ctlr-&gt;alock);
	if(ctlr-&gt;init == 0){
		/*
		 * Handle allocation/init errors here.
		 */
		ctlr-&gt;td = xspanalloc(sizeof(D)*Ntd, 256, 0);
		ctlr-&gt;tb = malloc(Ntd*sizeof(Block*));
		ctlr-&gt;ntd = Ntd;
		ctlr-&gt;rd = xspanalloc(sizeof(D)*Nrd, 256, 0);
		ctlr-&gt;rb = malloc(Nrd*sizeof(Block*));
		ctlr-&gt;nrd = Nrd;
		ctlr-&gt;dtcc = xspanalloc(sizeof(Dtcc), 64, 0);
		if (ctlr-&gt;td == nil || ctlr-&gt;tb == nil ||
		    ctlr-&gt;rd == nil || ctlr-&gt;rb == nil || ctlr-&gt;dtcc == nil)
			print("rtl8169attach: out of memory\n");
		rtl8169init(edev);
		ctlr-&gt;init = 1;
	}
	qunlock(&amp;ctlr-&gt;alock);

	for(timeo = 0; timeo &lt; 3500; timeo++){
		if(miistatus(ctlr-&gt;mii) == 0)
			break;
		delay(10);
	}
}

static void
rtl8169transmit(Ether* edev)
{
	D *d;
	Block *bp;
	Ctlr *ctlr;
	int control, x;
	RingBuf *tb;

	ctlr = edev-&gt;ctlr;

	ilock(&amp;ctlr-&gt;tlock);
	for(x = ctlr-&gt;tdh; ctlr-&gt;ntq &gt; 0; x = NEXT(x, ctlr-&gt;ntd)){
		d = &amp;ctlr-&gt;td[x];
		if((control = d-&gt;control) &amp; Own)
			break;

		/*
		 * Check errors and log here.
		 */
		USED(control);

		/*
		 * Free it up.
		 * Need to clean the descriptor here? Not really.
		 * Simple freeb for now (no chain and freeblist).
		 * Use ntq count for now.
		 */
		freeb(ctlr-&gt;tb[x]);
		ctlr-&gt;tb[x] = nil;
		d-&gt;control &amp;= Eor;

		ctlr-&gt;ntq--;
	}
	ctlr-&gt;tdh = x;

	x = ctlr-&gt;tdt;
	while(ctlr-&gt;ntq &lt; (ctlr-&gt;ntd-1)){
		tb = &amp;edev-&gt;tb[edev-&gt;ti];
		if(tb-&gt;owner != Interface)
			break;

		bp = allocb(tb-&gt;len);
		memmove(bp-&gt;wp, tb-&gt;pkt, tb-&gt;len);
		memmove(bp-&gt;wp+Eaddrlen, edev-&gt;ea, Eaddrlen);
		bp-&gt;wp += tb-&gt;len;

		tb-&gt;owner = Host;
		edev-&gt;ti = NEXT(edev-&gt;ti, edev-&gt;ntb);

		d = &amp;ctlr-&gt;td[x];
		d-&gt;addrlo = PCIWADDR(bp-&gt;rp);
		d-&gt;addrhi = 0;
		ctlr-&gt;tb[x] = bp;
		coherence();
		d-&gt;control |= Own|Fs|Ls|((BLEN(bp)&lt;&lt;TxflSHIFT) &amp; TxflMASK);

		x = NEXT(x, ctlr-&gt;ntd);
		ctlr-&gt;ntq++;
	}
	if(x != ctlr-&gt;tdt){
		ctlr-&gt;tdt = x;
		csr8w(ctlr, Tppoll, Npq);
	}
	else if(ctlr-&gt;ntq &gt;= (ctlr-&gt;ntd-1))
		ctlr-&gt;txdu++;

	iunlock(&amp;ctlr-&gt;tlock);
}

static void
rtl8169receive(Ether* edev)
{
	D *d;
	int len, rdh;
	Ctlr *ctlr;
	u32int control;
	RingBuf *ring;

	ctlr = edev-&gt;ctlr;

	rdh = ctlr-&gt;rdh;
	for(;;){
		d = &amp;ctlr-&gt;rd[rdh];
		if(d-&gt;control &amp; Own)
			break;

		control = d-&gt;control;
		if((control &amp; (Fs|Ls|Res)) == (Fs|Ls)){
			len = ((control &amp; RxflMASK)&gt;&gt;RxflSHIFT) - 4;

			ring = &amp;edev-&gt;rb[edev-&gt;ri];
			if(ring-&gt;owner == Interface){
				ring-&gt;owner = Host;
				ring-&gt;len = len;
				memmove(ring-&gt;pkt, ctlr-&gt;rb[rdh], len);
				edev-&gt;ri = NEXT(edev-&gt;ri, edev-&gt;nrb);
			}
		}
		else{
			/*
			 * Error stuff here.
			print("control %#8.8ux\n", control);
			 */
		}
		d-&gt;control &amp;= Eor;
		ctlr-&gt;nrdfree--;
		if (!ctlr-&gt;init)
			print("rtl8169receive: ctlr not initialised\n");
		if (ctlr-&gt;nrd == 0)
			print("rtl8169receive: zero ctlr-&gt;nrd\n");
		rdh = NEXT(rdh, ctlr-&gt;nrd);
	}
	ctlr-&gt;rdh = rdh;
	
	if(ctlr-&gt;nrdfree &lt; ctlr-&gt;nrd/2)
		rtl8169replenish(ctlr);
}

static void
rtl8169interrupt(Ureg*, void* arg)
{
	Ctlr *ctlr;
	Ether *edev;
	u32int isr;

	edev = arg;
	ctlr = edev-&gt;ctlr;

	while((isr = csr16r(ctlr, Isr)) != 0 &amp;&amp; isr != 0xFFFF){
		csr16w(ctlr, Isr, isr);
		if(isr &amp; (Fovw|Punlc|Rdu|Rer|Rok)){
			rtl8169receive(edev);
			if(!(isr &amp; (Punlc|Rok)))
				ctlr-&gt;ierrs++;
			if(isr &amp; Rer)
				ctlr-&gt;rer++;
			if(isr &amp; Rdu)
				ctlr-&gt;rdu++;
			if(isr &amp; Punlc)
				ctlr-&gt;punlc++;
			if(isr &amp; Fovw)
				ctlr-&gt;fovw++;
			isr &amp;= ~(Fovw|Rdu|Rer|Rok);
		}

		if(isr &amp; (Tdu|Ter|Tok)){
			rtl8169transmit(edev);
			isr &amp;= ~(Tdu|Ter|Tok);
		}

		if(isr &amp; Punlc){
//			rtl8169link(edev);
			isr &amp;= ~Punlc;
		}

		/*
		 * Some of the reserved bits get set sometimes...
		 */
		if(isr &amp; (Serr|Timeout|Tdu|Fovw|Punlc|Rdu|Ter|Tok|Rer|Rok))
			panic("rtl8169interrupt: imr %#4.4ux isr %#4.4ux",
				csr16r(ctlr, Imr), isr);
	}
}

static void
rtl8169pci(void)
{
	Pcidev *p;
	Ctlr *ctlr;
	int i, port;
	u32int bar;

	p = nil;
	while(p = pcimatch(p, 0, 0)){
		if(p-&gt;ccrb != 0x02 || p-&gt;ccru != 0)
			continue;

		switch(i = ((p-&gt;did&lt;&lt;16)|p-&gt;vid)){
		default:
			continue;
		case Rtl8100e:			/* RTL810[01]E ? */
		case Rtl8169c:			/* RTL8169C */
		case Rtl8169sc:			/* RTL8169SC */
		case Rtl8168b:			/* RTL8168B */
		case Rtl8169:			/* RTL8169 */
			break;
		case (0xC107&lt;&lt;16)|0x1259:	/* Corega CG-LAPCIGT */
			i = Rtl8169;
			break;
		}

		bar = p-&gt;mem[0].bar;
		port = bar &amp; ~0x01;
		if(ioalloc(port, p-&gt;mem[0].size, 0, "rtl8169") &lt; 0){
			print("rtl8169: port %#ux in use\n", port);
			continue;
		}
		ctlr = malloc(sizeof(Ctlr));
		ctlr-&gt;port = port;
		ctlr-&gt;pcidev = p;
		ctlr-&gt;pciv = i;

		if(pcigetpms(p) &gt; 0){
			pcisetpms(p, 0);
	
			for(i = 0; i &lt; 6; i++)
				pcicfgw32(p, PciBAR0+i*4, p-&gt;mem[i].bar);
			pcicfgw8(p, PciINTL, p-&gt;intl);
			pcicfgw8(p, PciLTR, p-&gt;ltr);
			pcicfgw8(p, PciCLS, p-&gt;cls);
			pcicfgw16(p, PciPCR, p-&gt;pcr);
		}

		if(rtl8169reset(ctlr)){
			iofree(port);
			free(ctlr);
			continue;
		}

		/*
		 * Extract the chip hardware version,
		 * needed to configure each properly.
		 */
		ctlr-&gt;macv = csr32r(ctlr, Tcr) &amp; HwveridMASK;

		rtl8169mii(ctlr);

		pcisetbme(p);

		if(rtl8169ctlrhead != nil)
			rtl8169ctlrtail-&gt;next = ctlr;
		else
			rtl8169ctlrhead = ctlr;
		rtl8169ctlrtail = ctlr;
	}
}

int
rtl8169pnp(Ether* edev)
{
	u32int r;
	Ctlr *ctlr;

	if(rtl8169ctlrhead == nil)
		rtl8169pci();

	/*
	 * Any adapter matches if no edev-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	for(ctlr = rtl8169ctlrhead; ctlr != nil; ctlr = ctlr-&gt;next){
		if(ctlr-&gt;active)
			continue;
		if(edev-&gt;port == 0 || edev-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}
	if(ctlr == nil)
		return -1;

	edev-&gt;ctlr = ctlr;
	edev-&gt;port = ctlr-&gt;port;
	edev-&gt;irq = ctlr-&gt;pcidev-&gt;intl;
	edev-&gt;tbdf = ctlr-&gt;pcidev-&gt;tbdf;
//	edev-&gt;mbps = 100;

	/*
	 * Pull the MAC address out of the chip.
	 */
	r = csr32r(ctlr, Idr0);
	edev-&gt;ea[0] = r;
	edev-&gt;ea[1] = r&gt;&gt;8;
	edev-&gt;ea[2] = r&gt;&gt;16;
	edev-&gt;ea[3] = r&gt;&gt;24;
	r = csr32r(ctlr, Idr0+4);
	edev-&gt;ea[4] = r;
	edev-&gt;ea[5] = r&gt;&gt;8;

	/*
	 * Linkage to the generic ethernet driver.
	 */
	edev-&gt;attach = rtl8169attach;
	edev-&gt;transmit = rtl8169transmit;
	edev-&gt;interrupt = rtl8169interrupt;
	edev-&gt;detach = rtl8169detach;
//	edev-&gt;ifstat = rtl8169ifstat;
//	edev-&gt;ctl = nil;
//
//	edev-&gt;arg = edev;
//	edev-&gt;promiscuous = rtl8169promiscuous;
//	edev-&gt;multicast = rtl8169multicast;

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size=10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size=10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size=10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size=10pt">&copy; 2006 Lucent Technologies.</span>
<span style="font-size=10pt">All Rights Reserved.</span>
<br />
<span style="font-size=10pt">Comments to</span>
<span style="font-size=10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

