<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/5i/5i.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/5i/5i.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#include "arm.h"

#include &lt;tos.h&gt;

char*	file = "5.out";
int	datasize;
ulong	textbase;
Biobuf	bp, bi;
Fhdr	fhdr;

void
main(int argc, char **argv)
{

	argc--;
	argv++;

	bioout = &amp;bp;
	bin = &amp;bi;
	Binit(bioout, 1, OWRITE);
	Binit(bin, 0, OREAD);

	tlb.on = 1;
	tlb.tlbsize = 24;

	if(argc)
		file = argv[0];
	argc--;
	argv++;

	text = open(file, OREAD);
	if(text &lt; 0)
		fatal(1, "open text '%s'", file);

	Bprint(bioout, "5i\n");
	inithdr(text);
	initstk(argc, argv);

	cmd();
}

void
initmap()
{
	ulong t, d, b, bssend;
	Segment *s;

	t = (fhdr.txtaddr+fhdr.txtsz+(BY2PG-1)) &amp; ~(BY2PG-1);
	d = (t + fhdr.datsz + (BY2PG-1)) &amp; ~(BY2PG-1);
	bssend = t + fhdr.datsz + fhdr.bsssz;
	b = (bssend + (BY2PG-1)) &amp; ~(BY2PG-1);

	s = &amp;memory.seg[Text];
	s-&gt;type = Text;
	s-&gt;base = fhdr.txtaddr - fhdr.hdrsz;
	s-&gt;end = t;
	s-&gt;fileoff = fhdr.txtoff - fhdr.hdrsz;
	s-&gt;fileend = s-&gt;fileoff + fhdr.txtsz;
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	iprof = emalloc(((s-&gt;end-s-&gt;base)/PROFGRAN)*sizeof(long));
	textbase = s-&gt;base;

	s = &amp;memory.seg[Data];
	s-&gt;type = Data;
	s-&gt;base = t;
	s-&gt;end = t+(d-t);
	s-&gt;fileoff = fhdr.datoff;
	s-&gt;fileend = s-&gt;fileoff + fhdr.datsz;
	datasize = fhdr.datsz;
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	s = &amp;memory.seg[Bss];
	s-&gt;type = Bss;
	s-&gt;base = d;
	s-&gt;end = d+(b-d);
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	s = &amp;memory.seg[Stack];
	s-&gt;type = Stack;
	s-&gt;base = STACKTOP-STACKSIZE;
	s-&gt;end = STACKTOP;
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	reg.r[REGPC] = fhdr.entry;
}

void
inithdr(int fd)
{
	Symbol s;

	extern Machdata armmach;

	seek(fd, 0, 0);
	if (!crackhdr(fd, &amp;fhdr))
		fatal(0, "read text header");

	if(fhdr.type != FARM )
		fatal(0, "bad magic number: %d %d", fhdr.type, FARM);

	if (syminit(fd, &amp;fhdr) &lt; 0)
		fatal(0, "%r\n");

	symmap = loadmap(symmap, fd, &amp;fhdr);
	if (mach-&gt;sbreg &amp;&amp; lookup(0, mach-&gt;sbreg, &amp;s))
		mach-&gt;sb = s.value;
	machdata = &amp;armmach;
}

void
reset(void)
{
	int i, l, m;
	Segment *s;
	Breakpoint *b;

	memset(&amp;reg, 0, sizeof(Registers));

	for(i = 0; i &gt; Nseg; i++) {
		s = &amp;memory.seg[i];
		l = ((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*);
		for(m = 0; m &lt; l; m++)
			if(s-&gt;table[m])
				free(s-&gt;table[m]);
		free(s-&gt;table);
	}
	free(iprof);
	memset(&amp;memory, 0, sizeof(memory));

	for(b = bplist; b; b = b-&gt;next)
		b-&gt;done = b-&gt;count;
}

void
initstk(int argc, char *argv[])
{
	ulong size;
	ulong sp, ap, tos;
	int i;
	char *p;

	initmap();
	tos = STACKTOP - sizeof(Tos)*2;	/* we'll assume twice the host's is big enough */
	sp = tos;
	for (i = 0; i &lt; sizeof(Tos)*2; i++)
		putmem_b(tos + i, 0);

	/*
	 * pid is second word from end of tos and needs to be set for nsec().
	 * we know arm is a 32-bit cpu, so we'll assume knowledge of the Tos
	 * struct for now, and use our pid.
	 */
	putmem_w(tos + 4*4 + 2*sizeof(ulong) + 3*sizeof(uvlong), getpid());

	/* Build exec stack */
	size = strlen(file)+1+BY2WD+BY2WD+BY2WD;	
	for(i = 0; i &lt; argc; i++)
		size += strlen(argv[i])+BY2WD+1;

	sp -= size;
	sp &amp;= ~7;
	reg.r[0] = tos;
	reg.r[13] = sp;
	reg.r[1] = STACKTOP-4;	/* Plan 9 profiling clock (why &amp; why in R1?) */

	/* Push argc */
	putmem_w(sp, argc+1);
	sp += BY2WD;

	/* Compute sizeof(argv) and push argv[0] */
	ap = sp+((argc+1)*BY2WD)+BY2WD;
	putmem_w(sp, ap);
	sp += BY2WD;
	
	/* Build argv[0] string into stack */
	for(p = file; *p; p++)
		putmem_b(ap++, *p);

	putmem_b(ap++, '\0');

	/* Loop through pushing the arguments */
	for(i = 0; i &lt; argc; i++) {
		putmem_w(sp, ap);
		sp += BY2WD;
		for(p = argv[i]; *p; p++)
			putmem_b(ap++, *p);
		putmem_b(ap++, '\0');
	}
	/* Null terminate argv */
	putmem_w(sp, 0);

}

void
fatal(int syserr, char *fmt, ...)
{
	char buf[ERRMAX], *s;
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	s = "5i: %s\n";
	if(syserr)
		s = "5i: %s: %r\n";
	fprint(2, s, buf);
	exits(buf);
}

void
itrace(char *fmt, ...)
{
	char buf[128];
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	Bprint(bioout, "%8lux %.8lux %2d %s\n", reg.ar, reg.ir, reg.class, buf);	
}

void
dumpreg(void)
{
	int i;

	Bprint(bioout, "PC  #%-8lux SP  #%-8lux \n",
				reg.r[REGPC], reg.r[REGSP]);

	for(i = 0; i &lt; 16; i++) {
		if((i%4) == 0 &amp;&amp; i != 0)
			Bprint(bioout, "\n");
		Bprint(bioout, "R%-2d #%-8lux ", i, reg.r[i]);
	}
	Bprint(bioout, "\n");
}

void
dumpfreg(void)
{
}

void
dumpdreg(void)
{
}

void *
emalloc(ulong size)
{
	void *a;

	a = malloc(size);
	if(a == 0)
		fatal(0, "no memory");

	memset(a, 0, size);
	return a;
}

void *
erealloc(void *a, ulong oldsize, ulong size)
{
	void *n;

	n = malloc(size);
	if(n == 0)
		fatal(0, "no memory");
	memset(n, 0, size);
	if(size &gt; oldsize)
		size = oldsize;
	memmove(n, a, size);
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

