<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/5l/asm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/5l/asm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

long	OFFSET;

static Prog *PP;

long
entryvalue(void)
{
	char *a;
	Sym *s;

	a = INITENTRY;
	if(*a &gt;= '0' &amp;&amp; *a &lt;= '9')
		return atolwhex(a);
	s = lookup(a, 0);
	if(s-&gt;type == 0)
		return INITTEXT;
	switch(s-&gt;type) {
	case STEXT:
	case SLEAF:
		break;
	case SDATA:
		if(dlm)
			return s-&gt;value+INITDAT;
	default:
		diag("entry not text: %s", s-&gt;name);
	}
	return s-&gt;value;
}

void
asmb(void)
{
	Prog *p;
	long t, etext;
	Optab *o;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f asm\n", cputime());
	Bflush(&amp;bso);
	OFFSET = HEADR;
	seek(cout, OFFSET, 0);
	pc = INITTEXT;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT) {
			curtext = p;
			autosize = p-&gt;to.offset + 4;
		}
		if(p-&gt;pc != pc) {
			diag("phase error %lux sb %lux",
				p-&gt;pc, pc);
			if(!debug['a'])
				prasm(curp);
			pc = p-&gt;pc;
		}
		curp = p;
		o = oplook(p);	/* could probably avoid this call */
		asmout(p, o);
		pc += o-&gt;size;
	}

	if(debug['a'])
		Bprint(&amp;bso, "\n");
	Bflush(&amp;bso);
	cflush();

	/* output strings in text segment */
	etext = INITTEXT + textsize;
	for(t = pc; t &lt; etext; t += sizeof(buf)-100) {
		if(etext-t &gt; sizeof(buf)-100)
			datblk(t, sizeof(buf)-100, 1);
		else
			datblk(t, etext-t, 1);
	}

	curtext = P;
	switch(HEADTYPE) {
	case 0:
	case 1:
	case 2:
	case 5:
	case 7:
		OFFSET = HEADR+textsize;
		seek(cout, OFFSET, 0);
		break;
	case 3:
	case 6:	/* no header, padded segments */
		OFFSET = rnd(HEADR+textsize, 4096);
		seek(cout, OFFSET, 0);
		break;
	}
	if(dlm){
		char buf[8];

		write(cout, buf, INITDAT-textsize);
		textsize = INITDAT;
	}
	for(t = 0; t &lt; datsize; t += sizeof(buf)-100) {
		if(datsize-t &gt; sizeof(buf)-100)
			datblk(t, sizeof(buf)-100, 0);
		else
			datblk(t, datsize-t, 0);
	}

	symsize = 0;
	lcsize = 0;
	if(!debug['s']) {
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f sym\n", cputime());
		Bflush(&amp;bso);
		switch(HEADTYPE) {
		case 0:
		case 1:
		case 4:
		case 5:
			debug['s'] = 1;
			break;
		case 2:
			OFFSET = HEADR+textsize+datsize;
			seek(cout, OFFSET, 0);
			break;
		case 3:
		case 6:	/* no header, padded segments */
			OFFSET += rnd(datsize, 4096);
			seek(cout, OFFSET, 0);
			break;
		case 7:
			break;
		}
		if(!debug['s'])
			asmsym();
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f pc\n", cputime());
		Bflush(&amp;bso);
		if(!debug['s'])
			asmlc();
		if(dlm)
			asmdyn();
		cflush();
	}
	else if(dlm){
		seek(cout, HEADR+textsize+datsize, 0);
		asmdyn();
		cflush();
	}

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f header\n", cputime());
	Bflush(&amp;bso);
	OFFSET = 0;
	seek(cout, OFFSET, 0);
	switch(HEADTYPE) {
	case 0:	/* no header */
	case 6:	/* no header, padded segments */
		break;
	case 1:	/* aif for risc os */
		lputl(0xe1a00000);		/* NOP - decompress code */
		lputl(0xe1a00000);		/* NOP - relocation code */
		lputl(0xeb000000 + 12);		/* BL - zero init code */
		lputl(0xeb000000 +
			(entryvalue()
			 - INITTEXT
			 + HEADR
			 - 12
			 - 8) / 4);		/* BL - entry code */

		lputl(0xef000011);		/* SWI - exit code */
		lputl(textsize+HEADR);		/* text size */
		lputl(datsize);			/* data size */
		lputl(0);			/* sym size */

		lputl(bsssize);			/* bss size */
		lputl(0);			/* sym type */
		lputl(INITTEXT-HEADR);		/* text addr */
		lputl(0);			/* workspace - ignored */

		lputl(32);			/* addr mode / data addr flag */
		lputl(0);			/* data addr */
		for(t=0; t&lt;2; t++)
			lputl(0);		/* reserved */

		for(t=0; t&lt;15; t++)
			lputl(0xe1a00000);	/* NOP - zero init code */
		lputl(0xe1a0f00e);		/* B (R14) - zero init return */
		break;
	case 2:	/* plan 9 */
		if(dlm)
			lput(0x80000000|0x647);	/* magic */
		else
			lput(0x647);			/* magic */
		lput(textsize);			/* sizes */
		lput(datsize);
		lput(bsssize);
		lput(symsize);			/* nsyms */
		lput(entryvalue());		/* va of entry */
		lput(0L);
		lput(lcsize);
		break;
	case 3:	/* boot for NetBSD */
		lput((143&lt;&lt;16)|0413);		/* magic */
		lputl(rnd(HEADR+textsize, 4096));
		lputl(rnd(datsize, 4096));
		lputl(bsssize);
		lputl(symsize);			/* nsyms */
		lputl(entryvalue());		/* va of entry */
		lputl(0L);
		lputl(0L);
		break;
	case 4: /* boot for IXP1200 */
		break;
	case 5: /* boot for ipaq */
		lputl(0xe3300000);		/* nop */
		lputl(0xe3300000);		/* nop */
		lputl(0xe3300000);		/* nop */
		lputl(0xe3300000);		/* nop */
		break;
	case 7:	/* elf */
		debug['S'] = 1;			/* symbol table */
		elf32(ARM, ELFDATA2LSB, 0, nil);
		break;
	}
	cflush();
}

void
strnput(char *s, int n)
{
	for(; *s; s++){
		cput(*s);
		n--;
	}
	for(; n &gt; 0; n--)
		cput(0);
}

void
cput(int c)
{
	cbp[0] = c;
	cbp++;
	cbc--;
	if(cbc &lt;= 0)
		cflush();
}

void
wput(long l)
{

	cbp[0] = l&gt;&gt;8;
	cbp[1] = l;
	cbp += 2;
	cbc -= 2;
	if(cbc &lt;= 0)
		cflush();
}

void
wputl(long l)
{

	cbp[0] = l;
	cbp[1] = l&gt;&gt;8;
	cbp += 2;
	cbc -= 2;
	if(cbc &lt;= 0)
		cflush();
}

void
lput(long l)
{

	cbp[0] = l&gt;&gt;24;
	cbp[1] = l&gt;&gt;16;
	cbp[2] = l&gt;&gt;8;
	cbp[3] = l;
	cbp += 4;
	cbc -= 4;
	if(cbc &lt;= 0)
		cflush();
}

void
lputl(long l)
{

	cbp[3] = l&gt;&gt;24;
	cbp[2] = l&gt;&gt;16;
	cbp[1] = l&gt;&gt;8;
	cbp[0] = l;
	cbp += 4;
	cbc -= 4;
	if(cbc &lt;= 0)
		cflush();
}

void
llput(vlong v)
{
	lput(v&gt;&gt;32);
	lput(v);
}

void
llputl(vlong v)
{
	lputl(v);
	lputl(v&gt;&gt;32);
}

void
cflush(void)
{
	int n;

	n = sizeof(buf.cbuf) - cbc;
	if(n)
		write(cout, buf.cbuf, n);
	cbp = buf.cbuf;
	cbc = sizeof(buf.cbuf);
}

void
nopstat(char *f, Count *c)
{
	if(c-&gt;outof)
	Bprint(&amp;bso, "%s delay %ld/%ld (%.2f)\n", f,
		c-&gt;outof - c-&gt;count, c-&gt;outof,
		(double)(c-&gt;outof - c-&gt;count)/c-&gt;outof);
}

void
asmsym(void)
{
	Prog *p;
	Auto *a;
	Sym *s;
	int h;

	s = lookup("etext", 0);
	if(s-&gt;type == STEXT)
		putsymb(s-&gt;name, 'T', s-&gt;value, s-&gt;version);

	for(h=0; h&lt;NHASH; h++)
		for(s=hash[h]; s!=S; s=s-&gt;link)
			switch(s-&gt;type) {
			case SCONST:
				putsymb(s-&gt;name, 'D', s-&gt;value, s-&gt;version);
				continue;

			case SDATA:
				putsymb(s-&gt;name, 'D', s-&gt;value+INITDAT, s-&gt;version);
				continue;

			case SBSS:
				putsymb(s-&gt;name, 'B', s-&gt;value+INITDAT, s-&gt;version);
				continue;

			case SSTRING:
				putsymb(s-&gt;name, 'T', s-&gt;value, s-&gt;version);
				continue;

			case SFILE:
				putsymb(s-&gt;name, 'f', s-&gt;value, s-&gt;version);
				continue;
			}

	for(p=textp; p!=P; p=p-&gt;cond) {
		s = p-&gt;from.sym;
		if(s-&gt;type != STEXT &amp;&amp; s-&gt;type != SLEAF)
			continue;

		/* filenames first */
		for(a=p-&gt;to.autom; a; a=a-&gt;link)
			if(a-&gt;type == D_FILE)
				putsymb(a-&gt;asym-&gt;name, 'z', a-&gt;aoffset, 0);
			else
			if(a-&gt;type == D_FILE1)
				putsymb(a-&gt;asym-&gt;name, 'Z', a-&gt;aoffset, 0);

		if(s-&gt;type == STEXT)
			putsymb(s-&gt;name, 'T', s-&gt;value, s-&gt;version);
		else
			putsymb(s-&gt;name, 'L', s-&gt;value, s-&gt;version);

		/* frame, auto and param after */
		putsymb(".frame", 'm', p-&gt;to.offset+4, 0);
		for(a=p-&gt;to.autom; a; a=a-&gt;link)
			if(a-&gt;type == D_AUTO)
				putsymb(a-&gt;asym-&gt;name, 'a', -a-&gt;aoffset, 0);
			else
			if(a-&gt;type == D_PARAM)
				putsymb(a-&gt;asym-&gt;name, 'p', a-&gt;aoffset, 0);
	}
	if(debug['v'] || debug['n'])
		Bprint(&amp;bso, "symsize = %lud\n", symsize);
	Bflush(&amp;bso);
}

void
putsymb(char *s, int t, long v, int ver)
{
	int i, f;

	if(t == 'f')
		s++;
	lput(v);
	if(ver)
		t += 'a' - 'A';
	cput(t+0x80);			/* 0x80 is variable length */

	if(t == 'Z' || t == 'z') {
		cput(s[0]);
		for(i=1; s[i] != 0 || s[i+1] != 0; i += 2) {
			cput(s[i]);
			cput(s[i+1]);
		}
		cput(0);
		cput(0);
		i++;
	}
	else {
		for(i=0; s[i]; i++)
			cput(s[i]);
		cput(0);
	}
	symsize += 4 + 1 + i + 1;

	if(debug['n']) {
		if(t == 'z' || t == 'Z') {
			Bprint(&amp;bso, "%c %.8lux ", t, v);
			for(i=1; s[i] != 0 || s[i+1] != 0; i+=2) {
				f = ((s[i]&amp;0xff) &lt;&lt; 8) | (s[i+1]&amp;0xff);
				Bprint(&amp;bso, "/%x", f);
			}
			Bprint(&amp;bso, "\n");
			return;
		}
		if(ver)
			Bprint(&amp;bso, "%c %.8lux %s&lt;%d&gt;\n", t, v, s, ver);
		else
			Bprint(&amp;bso, "%c %.8lux %s\n", t, v, s);
	}
}

#define	MINLC	4
void
asmlc(void)
{
	long oldpc, oldlc;
	Prog *p;
	long v, s;

	oldpc = INITTEXT;
	oldlc = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;line == oldlc || p-&gt;as == ATEXT || p-&gt;as == ANOP) {
			if(p-&gt;as == ATEXT)
				curtext = p;
			if(debug['V'])
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			continue;
		}
		if(debug['V'])
			Bprint(&amp;bso, "\t\t%6ld", lcsize);
		v = (p-&gt;pc - oldpc) / MINLC;
		while(v) {
			s = 127;
			if(v &lt; 127)
				s = v;
			cput(s+128);	/* 129-255 +pc */
			if(debug['V'])
				Bprint(&amp;bso, " pc+%ld*%d(%ld)", s, MINLC, s+128);
			v -= s;
			lcsize++;
		}
		s = p-&gt;line - oldlc;
		oldlc = p-&gt;line;
		oldpc = p-&gt;pc + MINLC;
		if(s &gt; 64 || s &lt; -64) {
			cput(0);	/* 0 vv +lc */
			cput(s&gt;&gt;24);
			cput(s&gt;&gt;16);
			cput(s&gt;&gt;8);
			cput(s);
			if(debug['V']) {
				if(s &gt; 0)
					Bprint(&amp;bso, " lc+%ld(%d,%ld)\n",
						s, 0, s);
				else
					Bprint(&amp;bso, " lc%ld(%d,%ld)\n",
						s, 0, s);
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			}
			lcsize += 5;
			continue;
		}
		if(s &gt; 0) {
			cput(0+s);	/* 1-64 +lc */
			if(debug['V']) {
				Bprint(&amp;bso, " lc+%ld(%ld)\n", s, 0+s);
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			}
		} else {
			cput(64-s);	/* 65-128 -lc */
			if(debug['V']) {
				Bprint(&amp;bso, " lc%ld(%ld)\n", s, 64-s);
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			}
		}
		lcsize++;
	}
	while(lcsize &amp; 1) {
		s = 129;
		cput(s);
		lcsize++;
	}
	if(debug['v'] || debug['V'])
		Bprint(&amp;bso, "lcsize = %ld\n", lcsize);
	Bflush(&amp;bso);
}

void
datblk(long s, long n, int str)
{
	Sym *v;
	Prog *p;
	char *cast;
	long a, l, fl, j, d;
	int i, c;

	memset(buf.dbuf, 0, n+100);
	for(p = datap; p != P; p = p-&gt;link) {
		if(str != (p-&gt;from.sym-&gt;type == SSTRING))
			continue;
		curp = p;
		a = p-&gt;from.sym-&gt;value + p-&gt;from.offset;
		l = a - s;
		c = p-&gt;reg;
		i = 0;
		if(l &lt; 0) {
			if(l+c &lt;= 0)
				continue;
			while(l &lt; 0) {
				l++;
				i++;
			}
		}
		if(l &gt;= n)
			continue;
		if(p-&gt;as != AINIT &amp;&amp; p-&gt;as != ADYNT) {
			for(j=l+(c-i)-1; j&gt;=l; j--)
				if(buf.dbuf[j]) {
					print("%P\n", p);
					diag("multiple initialization");
					break;
				}
		}
		switch(p-&gt;to.type) {
		default:
			diag("unknown mode in initialization%P", p);
			break;

		case D_FCONST:
			switch(c) {
			default:
			case 4:
				fl = ieeedtof(p-&gt;to.ieee);
				cast = (char*)&amp;fl;
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[fnuxi4[i]];
					l++;
				}
				break;
			case 8:
				cast = (char*)p-&gt;to.ieee;
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[fnuxi8[i]];
					l++;
				}
				break;
			}
			break;

		case D_SCONST:
			for(; i&lt;c; i++) {
				buf.dbuf[l] = p-&gt;to.sval[i];
				l++;
			}
			break;

		case D_CONST:
			d = p-&gt;to.offset;
			v = p-&gt;to.sym;
			if(v) {
				switch(v-&gt;type) {
				case SUNDEF:
					ckoff(v, d);
				case STEXT:
				case SLEAF:
				case SSTRING:
					d += p-&gt;to.sym-&gt;value;
					break;
				case SDATA:
				case SBSS:
					d += p-&gt;to.sym-&gt;value + INITDAT;
				}
				if(dlm)
					dynreloc(v, a+INITDAT, 1);
			}
			cast = (char*)&amp;d;
			switch(c) {
			default:
				diag("bad nuxi %d %d%P", c, i, curp);
				break;
			case 1:
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi1[i]];
					l++;
				}
				break;
			case 2:
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi2[i]];
					l++;
				}
				break;
			case 4:
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi4[i]];
					l++;
				}
				break;
			}
			break;
		}
	}
	write(cout, buf.dbuf, n);
}

void
asmout(Prog *p, Optab *o)
{
	long o1, o2, o3, o4, o5, o6, v;
	int r, rf, rt, rt2;
	Sym *s;

PP = p;
	o1 = 0;
	o2 = 0;
	o3 = 0;
	o4 = 0;
	o5 = 0;
	o6 = 0;
	switch(o-&gt;type) {
	default:
		diag("unknown asm %d", o-&gt;type);
		prasm(p);
		break;

	case 0:		/* pseudo ops */
		break;

	case 1:		/* op R,[R],R */
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		rt = p-&gt;to.reg;
		r = p-&gt;reg;
		if(p-&gt;to.type == D_NONE)
			rt = 0;
		if(p-&gt;as == AMOVW || p-&gt;as == AMVN)
			r = 0;
		else if(r == NREG)
			r = rt;
		o1 |= rf | (r&lt;&lt;16) | (rt&lt;&lt;12);
		break;

	case 2:		/* movbu $I,[R],R */
		aclass(&amp;p-&gt;from);
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		o1 |= immrot(instoffset);
		rt = p-&gt;to.reg;
		r = p-&gt;reg;
		if(p-&gt;to.type == D_NONE)
			rt = 0;
		if(p-&gt;as == AMOVW || p-&gt;as == AMVN)
			r = 0;
		else if(r == NREG)
			r = rt;
		o1 |= (r&lt;&lt;16) | (rt&lt;&lt;12);
		break;

	case 3:		/* add R&lt;&lt;[IR],[R],R */
	mov:
		aclass(&amp;p-&gt;from);
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		o1 |= p-&gt;from.offset;
		rt = p-&gt;to.reg;
		r = p-&gt;reg;
		if(p-&gt;to.type == D_NONE)
			rt = 0;
		if(p-&gt;as == AMOVW || p-&gt;as == AMVN)
			r = 0;
		else if(r == NREG)
			r = rt;
		o1 |= (r&lt;&lt;16) | (rt&lt;&lt;12);
		break;

	case 4:		/* add $I,[R],R */
		aclass(&amp;p-&gt;from);
		o1 = oprrr(AADD, p-&gt;scond);
		o1 |= immrot(instoffset);
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 |= r &lt;&lt; 16;
		o1 |= p-&gt;to.reg &lt;&lt; 12;
		break;

	case 5:		/* bra s */
		v = -8;
		if(p-&gt;cond == UP) {
			s = p-&gt;to.sym;
			if(s-&gt;type != SUNDEF)
				diag("bad branch sym type");
			v = (ulong)s-&gt;value &gt;&gt; (Roffset-2);
			dynreloc(s, p-&gt;pc, 0);
		}
		else if(p-&gt;cond != P)
			v = (p-&gt;cond-&gt;pc - pc) - 8;
		o1 = opbra(p-&gt;as, p-&gt;scond);
		o1 |= (v &gt;&gt; 2) &amp; 0xffffff;
		break;

	case 6:		/* b ,O(R) -&gt; add $O,R,PC */
		aclass(&amp;p-&gt;to);
		o1 = oprrr(AADD, p-&gt;scond);
		o1 |= immrot(instoffset);
		o1 |= p-&gt;to.reg &lt;&lt; 16;
		o1 |= REGPC &lt;&lt; 12;
		break;

	case 7:		/* bl ,O(R) -&gt; mov PC,link; add $O,R,PC */
		aclass(&amp;p-&gt;to);
		o1 = oprrr(AADD, p-&gt;scond);
		o1 |= immrot(0);
		o1 |= REGPC &lt;&lt; 16;
		o1 |= REGLINK &lt;&lt; 12;

		o2 = oprrr(AADD, p-&gt;scond);
		o2 |= immrot(instoffset);
		o2 |= p-&gt;to.reg &lt;&lt; 16;
		o2 |= REGPC &lt;&lt; 12;
		break;

	case 8:		/* sll $c,[R],R -&gt; mov (R&lt;&lt;$c),R */
		aclass(&amp;p-&gt;from);
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		r = p-&gt;reg;
		if(r == NREG)
			r = p-&gt;to.reg;
		o1 |= r;
		o1 |= (instoffset&amp;31) &lt;&lt; 7;
		o1 |= p-&gt;to.reg &lt;&lt; 12;
		break;

	case 9:		/* sll R,[R],R -&gt; mov (R&lt;&lt;R),R */
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		r = p-&gt;reg;
		if(r == NREG)
			r = p-&gt;to.reg;
		o1 |= r;
		o1 |= (p-&gt;from.reg &lt;&lt; 8) | (1&lt;&lt;4);
		o1 |= p-&gt;to.reg &lt;&lt; 12;
		break;

	case 10:	/* swi [$con] */
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		if(p-&gt;to.type != D_NONE) {
			aclass(&amp;p-&gt;to);
			o1 |= instoffset &amp; 0xffffff;
		}
		break;

	case 11:	/* word */
		switch(aclass(&amp;p-&gt;to)) {
		case C_LCON:
			if(!dlm)
				break;
			if(p-&gt;to.name != D_EXTERN &amp;&amp; p-&gt;to.name != D_STATIC)
				break;
		case C_ADDR:
			if(p-&gt;to.sym-&gt;type == SUNDEF)
				ckoff(p-&gt;to.sym, p-&gt;to.offset);
			dynreloc(p-&gt;to.sym, p-&gt;pc, 1);
		}
		o1 = instoffset;
		break;

	case 12:	/* movw $lcon, reg */
		o1 = omvl(p, &amp;p-&gt;from, p-&gt;to.reg);
		break;

	case 13:	/* op $lcon, [R], R */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;
		o2 = oprrr(p-&gt;as, p-&gt;scond);
		o2 |= REGTMP;
		r = p-&gt;reg;
		if(p-&gt;as == AMOVW || p-&gt;as == AMVN)
			r = 0;
		else if(r == NREG)
			r = p-&gt;to.reg;
		o2 |= r &lt;&lt; 16;
		if(p-&gt;to.type != D_NONE)
			o2 |= p-&gt;to.reg &lt;&lt; 12;
		break;

	case 14:	/* movb/movbu/movh/movhu R,R */
		o1 = oprrr(ASLL, p-&gt;scond);

		if(p-&gt;as == AMOVBU || p-&gt;as == AMOVHU)
			o2 = oprrr(ASRL, p-&gt;scond);
		else
			o2 = oprrr(ASRA, p-&gt;scond);

		r = p-&gt;to.reg;
		o1 |= (p-&gt;from.reg)|(r&lt;&lt;12);
		o2 |= (r)|(r&lt;&lt;12);
		if(p-&gt;as == AMOVB || p-&gt;as == AMOVBU) {
			o1 |= (24&lt;&lt;7);
			o2 |= (24&lt;&lt;7);
		} else {
			o1 |= (16&lt;&lt;7);
			o2 |= (16&lt;&lt;7);
		}
		break;

	case 15:	/* mul r,[r,]r */
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		rt = p-&gt;to.reg;
		r = p-&gt;reg;
		if(r == NREG)
			r = rt;
		if(rt == r) {
			r = rf;
			rf = rt;
		}
		if(0)
		if(rt == r || rf == REGPC || r == REGPC || rt == REGPC) {
			diag("bad registers in MUL");
			prasm(p);
		}
		o1 |= (rf&lt;&lt;8) | r | (rt&lt;&lt;16);
		break;


	case 16:	/* div r,[r,]r */
		o1 = 0xf &lt;&lt; 28;
		o2 = 0;
		break;

	case 17:
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		rt = p-&gt;to.reg;
		rt2 = p-&gt;to.offset;
		r = p-&gt;reg;
		o1 |= (rf&lt;&lt;8) | r | (rt&lt;&lt;16) | (rt2&lt;&lt;12);
		break;

	case 20:	/* mov/movb/movbu R,O(R) */
		aclass(&amp;p-&gt;to);
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = osr(p-&gt;as, p-&gt;from.reg, instoffset, r, p-&gt;scond);
		break;

	case 21:	/* mov/movbu O(R),R -&gt; lr */
		aclass(&amp;p-&gt;from);
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = olr(instoffset, r, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as != AMOVW)
			o1 |= 1&lt;&lt;22;
		break;

	case 22:	/* movb/movh/movhu O(R),R -&gt; lr,shl,shr */
		aclass(&amp;p-&gt;from);
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = olr(instoffset, r, p-&gt;to.reg, p-&gt;scond);

		o2 = oprrr(ASLL, p-&gt;scond);
		o3 = oprrr(ASRA, p-&gt;scond);
		r = p-&gt;to.reg;
		if(p-&gt;as == AMOVB) {
			o2 |= (24&lt;&lt;7)|(r)|(r&lt;&lt;12);
			o3 |= (24&lt;&lt;7)|(r)|(r&lt;&lt;12);
		} else {
			o2 |= (16&lt;&lt;7)|(r)|(r&lt;&lt;12);
			if(p-&gt;as == AMOVHU)
				o3 = oprrr(ASRL, p-&gt;scond);
			o3 |= (16&lt;&lt;7)|(r)|(r&lt;&lt;12);
		}
		break;

	case 23:	/* movh/movhu R,O(R) -&gt; sb,sb */
		aclass(&amp;p-&gt;to);
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = osr(AMOVH, p-&gt;from.reg, instoffset, r, p-&gt;scond);

		o2 = oprrr(ASRL, p-&gt;scond);
		o2 |= (8&lt;&lt;7)|(p-&gt;from.reg)|(REGTMP&lt;&lt;12);

		o3 = osr(AMOVH, REGTMP, instoffset+1, r, p-&gt;scond);
		break;

	case 30:	/* mov/movb/movbu R,L(R) */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = osrr(p-&gt;from.reg, REGTMP,r, p-&gt;scond);
		if(p-&gt;as != AMOVW)
			o2 |= 1&lt;&lt;22;
		break;

	case 31:	/* mov/movbu L(R),R -&gt; lr[b] */
	case 32:	/* movh/movb L(R),R -&gt; lr[b] */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = olrr(REGTMP,r, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as == AMOVBU || p-&gt;as == AMOVB)
			o2 |= 1&lt;&lt;22;
		if(o-&gt;type == 31)
			break;

		o3 = oprrr(ASLL, p-&gt;scond);

		if(p-&gt;as == AMOVBU || p-&gt;as == AMOVHU)
			o4 = oprrr(ASRL, p-&gt;scond);
		else
			o4 = oprrr(ASRA, p-&gt;scond);

		r = p-&gt;to.reg;
		o3 |= (r)|(r&lt;&lt;12);
		o4 |= (r)|(r&lt;&lt;12);
		if(p-&gt;as == AMOVB || p-&gt;as == AMOVBU) {
			o3 |= (24&lt;&lt;7);
			o4 |= (24&lt;&lt;7);
		} else {
			o3 |= (16&lt;&lt;7);
			o4 |= (16&lt;&lt;7);
		}
		break;

	case 33:	/* movh/movhu R,L(R) -&gt; sb, sb */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = osrr(p-&gt;from.reg, REGTMP, r, p-&gt;scond);
		o2 |= (1&lt;&lt;22) ;

		o3 = oprrr(ASRL, p-&gt;scond);
		o3 |= (8&lt;&lt;7)|(p-&gt;from.reg)|(p-&gt;from.reg&lt;&lt;12);
		o3 |= (1&lt;&lt;6);	/* ROR 8 */

		o4 = oprrr(AADD, p-&gt;scond);
		o4 |= (REGTMP &lt;&lt; 12) | (REGTMP &lt;&lt; 16);
		o4 |= immrot(1);

		o5 = osrr(p-&gt;from.reg, REGTMP,r,p-&gt;scond);
		o5 |= (1&lt;&lt;22);

		o6 = oprrr(ASRL, p-&gt;scond);
		o6 |= (24&lt;&lt;7)|(p-&gt;from.reg)|(p-&gt;from.reg&lt;&lt;12);
		o6 |= (1&lt;&lt;6);	/* ROL 8 */

		break;
		
	case 34:	/* mov $lacon,R */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;

		o2 = oprrr(AADD, p-&gt;scond);
		o2 |= REGTMP;
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 |= r &lt;&lt; 16;
		if(p-&gt;to.type != D_NONE)
			o2 |= p-&gt;to.reg &lt;&lt; 12;
		break;

	case 35:	/* mov PSR,R */
		o1 = (2&lt;&lt;23) | (0xf&lt;&lt;16) | (0&lt;&lt;0);
		o1 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28;
		o1 |= (p-&gt;from.reg &amp; 1) &lt;&lt; 22;
		o1 |= p-&gt;to.reg &lt;&lt; 12;
		break;

	case 36:	/* mov R,PSR */
		o1 = (2&lt;&lt;23) | (0x29f&lt;&lt;12) | (0&lt;&lt;4);
		if(p-&gt;scond &amp; C_FBIT)
			o1 ^= 0x010 &lt;&lt; 12;
		o1 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28;
		o1 |= (p-&gt;to.reg &amp; 1) &lt;&lt; 22;
		o1 |= p-&gt;from.reg &lt;&lt; 0;
		break;

	case 37:	/* mov $con,PSR */
		aclass(&amp;p-&gt;from);
		o1 = (2&lt;&lt;23) | (0x29f&lt;&lt;12) | (0&lt;&lt;4);
		if(p-&gt;scond &amp; C_FBIT)
			o1 ^= 0x010 &lt;&lt; 12;
		o1 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28;
		o1 |= immrot(instoffset);
		o1 |= (p-&gt;to.reg &amp; 1) &lt;&lt; 22;
		o1 |= p-&gt;from.reg &lt;&lt; 0;
		break;

	case 38:	/* movm $con,oreg -&gt; stm */
		o1 = (0x4 &lt;&lt; 25);
		o1 |= p-&gt;from.offset &amp; 0xffff;
		o1 |= p-&gt;to.reg &lt;&lt; 16;
		aclass(&amp;p-&gt;to);
		goto movm;

	case 39:	/* movm oreg,$con -&gt; ldm */
		o1 = (0x4 &lt;&lt; 25) | (1 &lt;&lt; 20);
		o1 |= p-&gt;to.offset &amp; 0xffff;
		o1 |= p-&gt;from.reg &lt;&lt; 16;
		aclass(&amp;p-&gt;from);
	movm:
		if(instoffset != 0)
			diag("offset must be zero in MOVM");
		o1 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28;
		if(p-&gt;scond &amp; C_PBIT)
			o1 |= 1 &lt;&lt; 24;
		if(p-&gt;scond &amp; C_UBIT)
			o1 |= 1 &lt;&lt; 23;
		if(p-&gt;scond &amp; C_SBIT)
			o1 |= 1 &lt;&lt; 22;
		if(p-&gt;scond &amp; C_WBIT)
			o1 |= 1 &lt;&lt; 21;
		break;

	case 40:	/* swp oreg,reg,reg */
		aclass(&amp;p-&gt;from);
		if(instoffset != 0)
			diag("offset must be zero in SWP");
		o1 = (0x2&lt;&lt;23) | (0x9&lt;&lt;4);
		if(p-&gt;as != ASWPW)
			o1 |= 1 &lt;&lt; 22;
		o1 |= p-&gt;from.reg &lt;&lt; 16;
		o1 |= p-&gt;reg &lt;&lt; 0;
		o1 |= p-&gt;to.reg &lt;&lt; 12;
		o1 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28;
		break;

	case 41:	/* rfe -&gt; movm.s.w.u 0(r13),[r15] */
		o1 = 0xe8fd8000;
		break;

	case 50:	/* floating point store */
		v = regoff(&amp;p-&gt;to);
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = ofsr(p-&gt;as, p-&gt;from.reg, v, r, p-&gt;scond, p);
		break;

	case 51:	/* floating point load */
		v = regoff(&amp;p-&gt;from);
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = ofsr(p-&gt;as, p-&gt;to.reg, v, r, p-&gt;scond, p) | (1&lt;&lt;20);
		break;

	case 52:	/* floating point store, long offset UGLY */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = oprrr(AADD, p-&gt;scond) | (REGTMP &lt;&lt; 12) | (REGTMP &lt;&lt; 16) | r;
		o3 = ofsr(p-&gt;as, p-&gt;from.reg, 0, REGTMP, p-&gt;scond, p);
		break;

	case 53:	/* floating point load, long offset UGLY */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = oprrr(AADD, p-&gt;scond) | (REGTMP &lt;&lt; 12) | (REGTMP &lt;&lt; 16) | r;
		o3 = ofsr(p-&gt;as, p-&gt;to.reg, 0, REGTMP, p-&gt;scond, p) | (1&lt;&lt;20);
		break;

	case 54:	/* floating point arith */
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		if(p-&gt;from.type == D_FCONST) {
			rf = chipfloat(p-&gt;from.ieee);
			if(rf &lt; 0){
				diag("invalid floating-point immediate\n%P", p);
				rf = 0;
			}
			rf |= (1&lt;&lt;3);
		} else
			rf = p-&gt;from.reg;
		rt = p-&gt;to.reg;
		r = p-&gt;reg;
		if(p-&gt;to.type == D_NONE)
			rt = 0;	/* CMP[FD] */
		else if(o1 &amp; (1&lt;&lt;15))
			r = 0;	/* monadic */
		else if(r == NREG)
			r = rt;
		o1 |= rf | (r&lt;&lt;16) | (rt&lt;&lt;12);
		break;

	case 55:	/* floating point fix and float */
		o1 = oprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		rt = p-&gt;to.reg;
		if(p-&gt;to.type == D_NONE){
			rt = 0;
			diag("to.type==D_NONE (asm/fp)");
		}
		if(p-&gt;from.type == D_REG)
			o1 |= (rf&lt;&lt;12) | (rt&lt;&lt;16);
		else
			o1 |= rf | (rt&lt;&lt;12);
		break;

	/* old arm 7500 fp using coproc 1 (1&lt;&lt;8) */
	case 56:	/* move to FP[CS]R */
		o1 = ((p-&gt;scond &amp; C_SCOND) &lt;&lt; 28) | (0xe &lt;&lt; 24) | (1&lt;&lt;8) | (1&lt;&lt;4);
		o1 |= ((p-&gt;to.reg+1)&lt;&lt;21) | (p-&gt;from.reg &lt;&lt; 12);
		break;

	case 57:	/* move from FP[CS]R */
		o1 = ((p-&gt;scond &amp; C_SCOND) &lt;&lt; 28) | (0xe &lt;&lt; 24) | (1&lt;&lt;8) | (1&lt;&lt;4);
		o1 |= ((p-&gt;from.reg+1)&lt;&lt;21) | (p-&gt;to.reg&lt;&lt;12) | (1&lt;&lt;20);
		break;
	case 58:	/* movbu R,R */
		o1 = oprrr(AAND, p-&gt;scond);
		o1 |= immrot(0xff);
		rt = p-&gt;to.reg;
		r = p-&gt;from.reg;
		if(p-&gt;to.type == D_NONE)
			rt = 0;
		if(r == NREG)
			r = rt;
		o1 |= (r&lt;&lt;16) | (rt&lt;&lt;12);
		break;

	case 59:	/* movw/bu R&lt;&lt;I(R),R -&gt; ldr indexed */
		if(p-&gt;from.reg == NREG) {
			if(p-&gt;as != AMOVW)
				diag("byte MOV from shifter operand");
			goto mov;
		}
		if(p-&gt;from.offset&amp;(1&lt;&lt;4))
			diag("bad shift in LDR");
		o1 = olrr(p-&gt;from.offset, p-&gt;from.reg, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as == AMOVBU)
			o1 |= 1&lt;&lt;22;
		break;

	case 60:	/* movb R(R),R -&gt; ldrsb indexed */
		if(p-&gt;from.reg == NREG) {
			diag("byte MOV from shifter operand");
			goto mov;
		}
		if(p-&gt;from.offset&amp;(~0xf))
			diag("bad shift in LDRSB");
		o1 = olhrr(p-&gt;from.offset, p-&gt;from.reg, p-&gt;to.reg, p-&gt;scond);
		o1 ^= (1&lt;&lt;5)|(1&lt;&lt;6);
		break;

	case 61:	/* movw/b/bu R,R&lt;&lt;[IR](R) -&gt; str indexed */
		if(p-&gt;to.reg == NREG)
			diag("MOV to shifter operand");
		o1 = osrr(p-&gt;from.reg, p-&gt;to.offset, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as == AMOVB || p-&gt;as == AMOVBU)
			o1 |= 1&lt;&lt;22;
		break;

	case 62:	/* case R -&gt; movw	R&lt;&lt;2(PC),PC */
		o1 = olrr(p-&gt;from.reg, REGPC, REGPC, p-&gt;scond);
		o1 |= 2&lt;&lt;7;
		break;

	case 63:	/* bcase */
		if(p-&gt;cond != P) {
			o1 = p-&gt;cond-&gt;pc;
			if(dlm)
				dynreloc(S, p-&gt;pc, 1);
		}
		break;

	/* reloc ops */
	case 64:	/* mov/movb/movbu R,addr */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		o2 = osr(p-&gt;as, p-&gt;from.reg, 0, REGTMP, p-&gt;scond);
		break;

	case 65:	/* mov/movbu addr,R */
	case 66:	/* movh/movhu/movb addr,R */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;
		o2 = olr(0, REGTMP, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as == AMOVBU || p-&gt;as == AMOVB)
			o2 |= 1&lt;&lt;22;
		if(o-&gt;type == 65)
			break;

		o3 = oprrr(ASLL, p-&gt;scond);

		if(p-&gt;as == AMOVBU || p-&gt;as == AMOVHU)
			o4 = oprrr(ASRL, p-&gt;scond);
		else
			o4 = oprrr(ASRA, p-&gt;scond);

		r = p-&gt;to.reg;
		o3 |= (r)|(r&lt;&lt;12);
		o4 |= (r)|(r&lt;&lt;12);
		if(p-&gt;as == AMOVB || p-&gt;as == AMOVBU) {
			o3 |= (24&lt;&lt;7);
			o4 |= (24&lt;&lt;7);
		} else {
			o3 |= (16&lt;&lt;7);
			o4 |= (16&lt;&lt;7);
		}
		break;

	case 67:	/* movh/movhu R,addr -&gt; sb, sb */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		o2 = osr(p-&gt;as, p-&gt;from.reg, 0, REGTMP, p-&gt;scond);

		o3 = oprrr(ASRL, p-&gt;scond);
		o3 |= (8&lt;&lt;7)|(p-&gt;from.reg)|(p-&gt;from.reg&lt;&lt;12);
		o3 |= (1&lt;&lt;6);	/* ROR 8 */

		o4 = oprrr(AADD, p-&gt;scond);
		o4 |= (REGTMP &lt;&lt; 12) | (REGTMP &lt;&lt; 16);
		o4 |= immrot(1);

		o5 = osr(p-&gt;as, p-&gt;from.reg, 0, REGTMP, p-&gt;scond);

		o6 = oprrr(ASRL, p-&gt;scond);
		o6 |= (24&lt;&lt;7)|(p-&gt;from.reg)|(p-&gt;from.reg&lt;&lt;12);
		o6 |= (1&lt;&lt;6);	/* ROL 8 */
		break;

	case 68:	/* floating point store -&gt; ADDR */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		o2 = ofsr(p-&gt;as, p-&gt;from.reg, 0, REGTMP, p-&gt;scond, p);
		break;

	case 69:	/* floating point load &lt;- ADDR */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;
		o2 = ofsr(p-&gt;as, p-&gt;to.reg, 0, REGTMP, p-&gt;scond, p) | (1&lt;&lt;20);
		break;

	/* ArmV4 ops: */
	case 70:	/* movh/movhu R,O(R) -&gt; strh */
		aclass(&amp;p-&gt;to);
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = oshr(p-&gt;from.reg, instoffset, r, p-&gt;scond);
		break;	
	case 71:	/* movb/movh/movhu O(R),R -&gt; ldrsb/ldrsh/ldrh */
		aclass(&amp;p-&gt;from);
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o1 = olhr(instoffset, r, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as == AMOVB)
			o1 ^= (1&lt;&lt;5)|(1&lt;&lt;6);
		else if(p-&gt;as == AMOVH)
			o1 ^= (1&lt;&lt;6);
		break;
	case 72:	/* movh/movhu R,L(R) -&gt; strh */
		o1 = omvl(p, &amp;p-&gt;to, REGTMP);
		if(!o1)
			break;
		r = p-&gt;to.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = oshrr(p-&gt;from.reg, REGTMP,r, p-&gt;scond);
		break;	
	case 73:	/* movb/movh/movhu L(R),R -&gt; ldrsb/ldrsh/ldrh */
		o1 = omvl(p, &amp;p-&gt;from, REGTMP);
		if(!o1)
			break;
		r = p-&gt;from.reg;
		if(r == NREG)
			r = o-&gt;param;
		o2 = olhrr(REGTMP, r, p-&gt;to.reg, p-&gt;scond);
		if(p-&gt;as == AMOVB)
			o2 ^= (1&lt;&lt;5)|(1&lt;&lt;6);
		else if(p-&gt;as == AMOVH)
			o2 ^= (1&lt;&lt;6);
		break;

	/* VFP ops: */
	case 74:	/* vfp floating point arith */
		o1 = opvfprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		if(p-&gt;from.type == D_FCONST) {
			diag("invalid floating-point immediate\n%P", p);
			rf = 0;
		}
		rt = p-&gt;to.reg;
		r = p-&gt;reg;
		if(r == NREG)
			r = rt;
		o1 |= rt&lt;&lt;12;
		if(((o1&gt;&gt;20)&amp;0xf) == 0xb)
			o1 |= rf&lt;&lt;0;
		else
			o1 |= r&lt;&lt;16 | rf&lt;&lt;0;
		break;
	case 75:	/* vfp floating point compare */
		o1 = opvfprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		if(p-&gt;from.type == D_FCONST) {
			if(p-&gt;from.ieee-&gt;h != 0 || p-&gt;from.ieee-&gt;l != 0)
				diag("invalid floating-point immediate\n%P", p);
			o1 |= 1&lt;&lt;16;
			rf = 0;
		}
		rt = p-&gt;reg;
		o1 |= rt&lt;&lt;12 | rf&lt;&lt;0;
		o2 = 0x0ef1fa10;	/* MRS APSR_nzcv, FPSCR */
		o2 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28;
		break;
	case 76:	/* vfp floating point fix and float */
		o1 = opvfprrr(p-&gt;as, p-&gt;scond);
		rf = p-&gt;from.reg;
		rt = p-&gt;to.reg;
		if(p-&gt;from.type == D_REG) {
			o2 = o1 | rt&lt;&lt;12 | rt&lt;&lt;0;
			o1 = 0x0e000a10;	/* VMOV F,R */
			o1 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28 | rt&lt;&lt;16 | rf&lt;&lt;12;
		} else {
			o1 |= FREGTMP&lt;&lt;12 | rf&lt;&lt;0;
			o2 = 0x0e100a10;	/* VMOV R,F */
			o2 |= (p-&gt;scond &amp; C_SCOND) &lt;&lt; 28 | FREGTMP&lt;&lt;16 | rt&lt;&lt;12;
		}
		break;
	}

	if(debug['a'] &gt; 1)
		Bprint(&amp;bso, "%2d ", o-&gt;type);

	v = p-&gt;pc;
	switch(o-&gt;size) {
	default:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux:\t\t%P\n", v, p);
		break;
	case 4:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux: %.8lux\t%P\n", v, o1, p);
		lputl(o1);
		break;
	case 8:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux: %.8lux %.8lux%P\n", v, o1, o2, p);
		lputl(o1);
		lputl(o2);
		break;
	case 12:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux: %.8lux %.8lux %.8lux%P\n", v, o1, o2, o3, p);
		lputl(o1);
		lputl(o2);
		lputl(o3);
		break;
	case 16:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux: %.8lux %.8lux %.8lux %.8lux%P\n",
				v, o1, o2, o3, o4, p);
		lputl(o1);
		lputl(o2);
		lputl(o3);
		lputl(o4);
		break;
	case 20:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux: %.8lux %.8lux %.8lux %.8lux %.8lux%P\n",
				v, o1, o2, o3, o4, o5, p);
		lputl(o1);
		lputl(o2);
		lputl(o3);
		lputl(o4);
		lputl(o5);
		break;
	case 24:
		if(debug['a'])
			Bprint(&amp;bso, " %.8lux: %.8lux %.8lux %.8lux %.8lux %.8lux %.8lux%P\n",
				v, o1, o2, o3, o4, o5, o6, p);
		lputl(o1);
		lputl(o2);
		lputl(o3);
		lputl(o4);
		lputl(o5);
		lputl(o6);
		break;
	}
}

long
oprrr(int a, int sc)
{
	long o;

	o = (sc &amp; C_SCOND) &lt;&lt; 28;
	if(sc &amp; C_SBIT)
		o |= 1 &lt;&lt; 20;
	if(sc &amp; (C_PBIT|C_WBIT))
		diag(".P/.W on dp instruction");
	switch(a) {
	case AMULU:
	case AMUL:	return o | (0x0&lt;&lt;21) | (0x9&lt;&lt;4);
	case AMULA:	return o | (0x1&lt;&lt;21) | (0x9&lt;&lt;4);
	case AMULLU:	return o | (0x4&lt;&lt;21) | (0x9&lt;&lt;4);
	case AMULL:	return o | (0x6&lt;&lt;21) | (0x9&lt;&lt;4);
	case AMULALU:	return o | (0x5&lt;&lt;21) | (0x9&lt;&lt;4);
	case AMULAL:	return o | (0x7&lt;&lt;21) | (0x9&lt;&lt;4);
	case AAND:	return o | (0x0&lt;&lt;21);
	case AEOR:	return o | (0x1&lt;&lt;21);
	case ASUB:	return o | (0x2&lt;&lt;21);
	case ARSB:	return o | (0x3&lt;&lt;21);
	case AADD:	return o | (0x4&lt;&lt;21);
	case AADC:	return o | (0x5&lt;&lt;21);
	case ASBC:	return o | (0x6&lt;&lt;21);
	case ARSC:	return o | (0x7&lt;&lt;21);
	case ATST:	return o | (0x8&lt;&lt;21) | (1&lt;&lt;20);
	case ATEQ:	return o | (0x9&lt;&lt;21) | (1&lt;&lt;20);
	case ACMP:	return o | (0xa&lt;&lt;21) | (1&lt;&lt;20);
	case ACMN:	return o | (0xb&lt;&lt;21) | (1&lt;&lt;20);
	case AORR:	return o | (0xc&lt;&lt;21);
	case AMOVW:	return o | (0xd&lt;&lt;21);
	case ABIC:	return o | (0xe&lt;&lt;21);
	case AMVN:	return o | (0xf&lt;&lt;21);
	case ASLL:	return o | (0xd&lt;&lt;21) | (0&lt;&lt;5);
	case ASRL:	return o | (0xd&lt;&lt;21) | (1&lt;&lt;5);
	case ASRA:	return o | (0xd&lt;&lt;21) | (2&lt;&lt;5);
	case ASWI:	return o | (0xf&lt;&lt;24);

	/* old arm 7500 fp using coproc 1 (1&lt;&lt;8) */
	case AADDD:	return o | (0xe&lt;&lt;24) | (0x0&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;7);
	case AADDF:	return o | (0xe&lt;&lt;24) | (0x0&lt;&lt;20) | (1&lt;&lt;8);
	case AMULD:	return o | (0xe&lt;&lt;24) | (0x1&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;7);
	case AMULF:	return o | (0xe&lt;&lt;24) | (0x1&lt;&lt;20) | (1&lt;&lt;8);
	case ASUBD:	return o | (0xe&lt;&lt;24) | (0x2&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;7);
	case ASUBF:	return o | (0xe&lt;&lt;24) | (0x2&lt;&lt;20) | (1&lt;&lt;8);
	case ADIVD:	return o | (0xe&lt;&lt;24) | (0x4&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;7);
	case ADIVF:	return o | (0xe&lt;&lt;24) | (0x4&lt;&lt;20) | (1&lt;&lt;8);
	case ACMPD:
	case ACMPF:	return o | (0xe&lt;&lt;24) | (0x9&lt;&lt;20) | (0xF&lt;&lt;12) | (1&lt;&lt;8) | (1&lt;&lt;4);	/* arguably, ACMPF should expand to RNDF, CMPD */

	case AMOVF:
	case AMOVDF:	return o | (0xe&lt;&lt;24) | (0x0&lt;&lt;20) | (1&lt;&lt;15) | (1&lt;&lt;8);
	case AMOVD:
	case AMOVFD:	return o | (0xe&lt;&lt;24) | (0x0&lt;&lt;20) | (1&lt;&lt;15) | (1&lt;&lt;8) | (1&lt;&lt;7);

	case AMOVWF:	return o | (0xe&lt;&lt;24) | (0&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;4);
	case AMOVWD:	return o | (0xe&lt;&lt;24) | (0&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;4) | (1&lt;&lt;7);
	case AMOVFW:	return o | (0xe&lt;&lt;24) | (1&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;4);
	case AMOVDW:	return o | (0xe&lt;&lt;24) | (1&lt;&lt;20) | (1&lt;&lt;8) | (1&lt;&lt;4) | (1&lt;&lt;7);
	}
	diag("bad rrr %d", a);
	prasm(curp);
	return 0;
}

long
opvfprrr(int a, int sc)
{
	long o;

	o = (sc &amp; C_SCOND) &lt;&lt; 28;
	if(sc &amp; (C_SBIT|C_PBIT|C_WBIT))
		diag(".S/.P/.W on vfp instruction");
	o |= 0xe&lt;&lt;24;
	switch(a) {
	case AMOVWD:	return o | 0xb&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x8&lt;&lt;16 | 1&lt;&lt;7;
	case AMOVWF:	return o | 0xa&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x8&lt;&lt;16 | 1&lt;&lt;7;
	case AMOVDW:	return o | 0xb&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0xD&lt;&lt;16 | 1&lt;&lt;7;
	case AMOVFW:	return o | 0xa&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0xD&lt;&lt;16 | 1&lt;&lt;7;
	case AMOVFD:	return o | 0xa&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x7&lt;&lt;16 | 1&lt;&lt;7;
	case AMOVDF:	return o | 0xb&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x7&lt;&lt;16 | 1&lt;&lt;7;
	case AMOVF:	return o | 0xa&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x0&lt;&lt;16 | 0&lt;&lt;7;
	case AMOVD:	return o | 0xb&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x0&lt;&lt;16 | 0&lt;&lt;7;
	case ACMPF:	return o | 0xa&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x4&lt;&lt;16 | 0&lt;&lt;7;
	case ACMPD:	return o | 0xb&lt;&lt;8 | 0xb&lt;&lt;20 | 1&lt;&lt;6 | 0x4&lt;&lt;16 | 0&lt;&lt;7;
	case AADDF:	return o | 0xa&lt;&lt;8 | 0x3&lt;&lt;20;
	case AADDD:	return o | 0xb&lt;&lt;8 | 0x3&lt;&lt;20;
	case ASUBF:	return o | 0xa&lt;&lt;8 | 0x3&lt;&lt;20 | 1&lt;&lt;6;
	case ASUBD:	return o | 0xb&lt;&lt;8 | 0x3&lt;&lt;20 | 1&lt;&lt;6;
	case AMULF:	return o | 0xa&lt;&lt;8 | 0x2&lt;&lt;20;
	case AMULD:	return o | 0xb&lt;&lt;8 | 0x2&lt;&lt;20;
	case ADIVF:	return o | 0xa&lt;&lt;8 | 0x8&lt;&lt;20;
	case ADIVD:	return o | 0xb&lt;&lt;8 | 0x8&lt;&lt;20;
	}
	diag("bad vfp rrr %d", a);
	prasm(curp);
	return 0;
}

long
opbra(int a, int sc)
{

	if(sc &amp; (C_SBIT|C_PBIT|C_WBIT))
		diag(".S/.P/.W on bra instruction");
	sc &amp;= C_SCOND;
	if(a == ABL)
		return (sc&lt;&lt;28)|(0x5&lt;&lt;25)|(0x1&lt;&lt;24);
	if(sc != 0xe)
		diag(".COND on bcond instruction");
	switch(a) {
	case ABEQ:	return (0x0&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABNE:	return (0x1&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABCS:	return (0x2&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABHS:	return (0x2&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABCC:	return (0x3&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABLO:	return (0x3&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABMI:	return (0x4&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABPL:	return (0x5&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABVS:	return (0x6&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABVC:	return (0x7&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABHI:	return (0x8&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABLS:	return (0x9&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABGE:	return (0xa&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABLT:	return (0xb&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABGT:	return (0xc&lt;&lt;28)|(0x5&lt;&lt;25);
	case ABLE:	return (0xd&lt;&lt;28)|(0x5&lt;&lt;25);
	case AB:	return (0xe&lt;&lt;28)|(0x5&lt;&lt;25);
	}
	diag("bad bra %A", a);
	prasm(curp);
	return 0;
}

long
olr(long v, int b, int r, int sc)
{
	long o;

	if(sc &amp; C_SBIT)
		diag(".S on LDR/STR instruction");
	o = (sc &amp; C_SCOND) &lt;&lt; 28;
	if(!(sc &amp; C_PBIT))
		o |= 1 &lt;&lt; 24;
	if(!(sc &amp; C_UBIT))
		o |= 1 &lt;&lt; 23;
	if(sc &amp; C_WBIT)
		o |= 1 &lt;&lt; 21;
	o |= (0x1&lt;&lt;26) | (1&lt;&lt;20);
	if(v &lt; 0) {
		v = -v;
		o ^= 1 &lt;&lt; 23;
	}
	if(v &gt;= (1&lt;&lt;12))
		diag("literal span too large: %ld (R%d)\n%P", v, b, PP);
	o |= v;
	o |= b &lt;&lt; 16;
	o |= r &lt;&lt; 12;
	return o;
}

long
olhr(long v, int b, int r, int sc)
{
	long o;

	if(sc &amp; C_SBIT)
		diag(".S on LDRH/STRH instruction");
	o = (sc &amp; C_SCOND) &lt;&lt; 28;
	if(!(sc &amp; C_PBIT))
		o |= 1 &lt;&lt; 24;
	if(sc &amp; C_WBIT)
		o |= 1 &lt;&lt; 21;
	o |= (1&lt;&lt;23) | (1&lt;&lt;20)|(0xb&lt;&lt;4);
	if(v &lt; 0) {
		v = -v;
		o ^= 1 &lt;&lt; 23;
	}
	if(v &gt;= (1&lt;&lt;8))
		diag("literal span too large: %ld (R%d)\n%P", v, b, PP);
	o |= (v&amp;0xf)|((v&gt;&gt;4)&lt;&lt;8)|(1&lt;&lt;22);
	o |= b &lt;&lt; 16;
	o |= r &lt;&lt; 12;
	return o;
}

long
osr(int a, int r, long v, int b, int sc)
{
	long o;

	o = olr(v, b, r, sc) ^ (1&lt;&lt;20);
	if(a != AMOVW)
		o |= 1&lt;&lt;22;
	return o;
}

long
oshr(int r, long v, int b, int sc)
{
	long o;

	o = olhr(v, b, r, sc) ^ (1&lt;&lt;20);
	return o;
}
	

long
osrr(int r, int i, int b, int sc)
{

	return olr(i, b, r, sc) ^ ((1&lt;&lt;25) | (1&lt;&lt;20));
}

long
oshrr(int r, int i, int b, int sc)
{
	return olhr(i, b, r, sc) ^ ((1&lt;&lt;22) | (1&lt;&lt;20));
}

long
olrr(int i, int b, int r, int sc)
{

	return olr(i, b, r, sc) ^ (1&lt;&lt;25);
}

long
olhrr(int i, int b, int r, int sc)
{
	return olhr(i, b, r, sc) ^ (1&lt;&lt;22);
}

long
ovfpmem(int a, int r, long v, int b, int sc, Prog *p)
{
	long o;

	if(sc &amp; (C_SBIT|C_PBIT|C_WBIT))
		diag(".S/.P/.W on VLDR/VSTR instruction");
	o = (sc &amp; C_SCOND) &lt;&lt; 28;
	o |= 0xd&lt;&lt;24 | (1&lt;&lt;23);
	if(v &lt; 0) {
		v = -v;
		o ^= 1 &lt;&lt; 23;
	}
	if(v &amp; 3)
		diag("odd offset for floating point op: %ld\n%P", v, p);
	else if(v &gt;= (1&lt;&lt;10))
		diag("literal span too large: %ld\n%P", v, p);
	o |= (v&gt;&gt;2) &amp; 0xFF;
	o |= b &lt;&lt; 16;
	o |= r &lt;&lt; 12;
	switch(a) {
	default:
		diag("bad fst %A", a);
	case AMOVD:
		o |= 0xb&lt;&lt;8;
		break;
	case AMOVF:
		o |= 0xa&lt;&lt;8;
		break;
	}
	return o;
}

long
ofsr(int a, int r, long v, int b, int sc, Prog *p)
{
	long o;

	if(vfp)
		return ovfpmem(a, r, v, b, sc, p);
	if(sc &amp; C_SBIT)
		diag(".S on FLDR/FSTR instruction");
	o = (sc &amp; C_SCOND) &lt;&lt; 28;
	if(!(sc &amp; C_PBIT))
		o |= 1 &lt;&lt; 24;
	if(sc &amp; C_WBIT)
		o |= 1 &lt;&lt; 21;
	o |= (6&lt;&lt;25) | (1&lt;&lt;24) | (1&lt;&lt;23);
	if(v &lt; 0) {
		v = -v;
		o ^= 1 &lt;&lt; 23;
	}
	if(v &amp; 3)
		diag("odd offset for floating point op: %ld\n%P", v, p);
	else if(v &gt;= (1&lt;&lt;10))
		diag("literal span too large: %ld\n%P", v, p);
	o |= (v&gt;&gt;2) &amp; 0xFF;
	o |= b &lt;&lt; 16;
	o |= r &lt;&lt; 12;
	o |= 1 &lt;&lt; 8;

	switch(a) {
	default:
		diag("bad fst %A", a);
	case AMOVD:
		o |= 1&lt;&lt;15;
	case AMOVF:
		break;
	}
	return o;
}

long
omvl(Prog *p, Adr *a, int dr)
{	
	long v, o1;
	if(!p-&gt;cond) {
		aclass(a);
		v = immrot(~instoffset);
		if(v == 0) {
			diag("missing literal");
			prasm(p);
			return 0;
		}
		o1 = oprrr(AMVN, p-&gt;scond&amp;C_SCOND);
		o1 |= v;
		o1 |= dr &lt;&lt; 12;
	} else {
		v = p-&gt;cond-&gt;pc - p-&gt;pc - 8;
		o1 = olr(v, REGPC, dr, p-&gt;scond&amp;C_SCOND);
	}
	return o1;
}

static Ieee chipfloats[] = {
	{0x00000000, 0x00000000}, /* 0 */
	{0x00000000, 0x3ff00000}, /* 1 */
	{0x00000000, 0x40000000}, /* 2 */
	{0x00000000, 0x40080000}, /* 3 */
	{0x00000000, 0x40100000}, /* 4 */
	{0x00000000, 0x40140000}, /* 5 */
	{0x00000000, 0x3fe00000}, /* .5 */
	{0x00000000, 0x40240000}, /* 10 */
};

int
chipfloat(Ieee *e)
{
	Ieee *p;
	int n;

	if(vfp)
		return -1;
	for(n = sizeof(chipfloats)/sizeof(chipfloats[0]); --n &gt;= 0;){
		p = &amp;chipfloats[n];
		if(p-&gt;l == e-&gt;l &amp;&amp; p-&gt;h == e-&gt;h)
			return n;
	}
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

