<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/5l/pass.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/5l/pass.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

void
dodata(void)
{
	int i, t;
	Sym *s;
	Prog *p;
	long orig, v;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f dodata\n", cputime());
	Bflush(&amp;bso);
	for(p = datap; p != P; p = p-&gt;link) {
		s = p-&gt;from.sym;
		if(p-&gt;as == ADYNT || p-&gt;as == AINIT)
			s-&gt;value = dtype;
		if(s-&gt;type == SBSS)
			s-&gt;type = SDATA;
		if(s-&gt;type != SDATA)
			diag("initialize non-data (%d): %s\n%P",
				s-&gt;type, s-&gt;name, p);
		v = p-&gt;from.offset + p-&gt;reg;
		if(v &gt; s-&gt;value)
			diag("initialize bounds (%ld): %s\n%P",
				s-&gt;value, s-&gt;name, p);
	}

	if(debug['t']) {
		/*
		 * pull out string constants
		 */
		for(p = datap; p != P; p = p-&gt;link) {
			s = p-&gt;from.sym;
			if(p-&gt;to.type == D_SCONST)
				s-&gt;type = SSTRING;
		}
	}

	/*
	 * pass 1
	 *	assign 'small' variables to data segment
	 *	(rational is that data segment is more easily
	 *	 addressed through offset on R12)
	 */
	orig = 0;
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		t = s-&gt;type;
		if(t != SDATA &amp;&amp; t != SBSS)
			continue;
		v = s-&gt;value;
		if(v == 0) {
			diag("%s: no size", s-&gt;name);
			v = 1;
		}
		while(v &amp; 3)
			v++;
		s-&gt;value = v;
		if(v &gt; MINSIZ)
			continue;
		s-&gt;value = orig;
		orig += v;
		s-&gt;type = SDATA1;
	}

	/*
	 * pass 2
	 *	assign large 'data' variables to data segment
	 */
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		t = s-&gt;type;
		if(t != SDATA) {
			if(t == SDATA1)
				s-&gt;type = SDATA;
			continue;
		}
		v = s-&gt;value;
		s-&gt;value = orig;
		orig += v;
	}

	while(orig &amp; 7)
		orig++;
	datsize = orig;

	/*
	 * pass 3
	 *	everything else to bss segment
	 */
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		if(s-&gt;type != SBSS)
			continue;
		v = s-&gt;value;
		s-&gt;value = orig;
		orig += v;
	}
	while(orig &amp; 7)
		orig++;
	bsssize = orig-datsize;

	xdefine("setR12", SDATA, 0L+BIG);
	xdefine("bdata", SDATA, 0L);
	xdefine("edata", SDATA, datsize);
	xdefine("end", SBSS, datsize+bsssize);
	xdefine("etext", STEXT, 0L);
}

void
undef(void)
{
	int i;
	Sym *s;

	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link)
		if(s-&gt;type == SXREF)
			diag("%s: not defined", s-&gt;name);
}

Prog*
brchain(Prog *p)
{
	int i;

	for(i=0; i&lt;20; i++) {
		if(p == P || p-&gt;as != AB)
			return p;
		p = p-&gt;cond;
	}
	return P;
}

int
relinv(int a)
{
	switch(a) {
	case ABEQ:	return ABNE;
	case ABNE:	return ABEQ;
	case ABCS:	return ABCC;
	case ABHS:	return ABLO;
	case ABCC:	return ABCS;
	case ABLO:	return ABHS;
	case ABMI:	return ABPL;
	case ABPL:	return ABMI;
	case ABVS:	return ABVC;
	case ABVC:	return ABVS;
	case ABHI:	return ABLS;
	case ABLS:	return ABHI;
	case ABGE:	return ABLT;
	case ABLT:	return ABGE;
	case ABGT:	return ABLE;
	case ABLE:	return ABGT;
	}
	diag("unknown relation: %s", anames[a]);
	return a;
}

void
follow(void)
{
	if(debug['v'])
		Bprint(&amp;bso, "%5.2f follow\n", cputime());
	Bflush(&amp;bso);

	firstp = prg();
	lastp = firstp;
	xfol(textp);

	firstp = firstp-&gt;link;
	lastp-&gt;link = P;
}

void
xfol(Prog *p)
{
	Prog *q, *r;
	int a, i;

loop:
	if(p == P)
		return;
	a = p-&gt;as;
	if(a == ATEXT)
		curtext = p;
	if(a == AB) {
		q = p-&gt;cond;
		if(q != P) {
			p-&gt;mark |= FOLL;
			p = q;
			if(!(p-&gt;mark &amp; FOLL))
				goto loop;
		}
	}
	if(p-&gt;mark &amp; FOLL) {
		for(i=0,q=p; i&lt;4; i++,q=q-&gt;link) {
			if(q == lastp)
				break;
			a = q-&gt;as;
			if(a == ANOP) {
				i--;
				continue;
			}
			if(a == AB || (a == ARET &amp;&amp; q-&gt;scond == 14) || a == ARFE)
				goto copy;
			if(!q-&gt;cond || (q-&gt;cond-&gt;mark&amp;FOLL))
				continue;
			if(a != ABEQ &amp;&amp; a != ABNE)
				continue;
		copy:
			for(;;) {
				r = prg();
				*r = *p;
				if(!(r-&gt;mark&amp;FOLL))
					print("cant happen 1\n");
				r-&gt;mark |= FOLL;
				if(p != q) {
					p = p-&gt;link;
					lastp-&gt;link = r;
					lastp = r;
					continue;
				}
				lastp-&gt;link = r;
				lastp = r;
				if(a == AB || (a == ARET &amp;&amp; q-&gt;scond == 14) || a == ARFE)
					return;
				r-&gt;as = ABNE;
				if(a == ABNE)
					r-&gt;as = ABEQ;
				r-&gt;cond = p-&gt;link;
				r-&gt;link = p-&gt;cond;
				if(!(r-&gt;link-&gt;mark&amp;FOLL))
					xfol(r-&gt;link);
				if(!(r-&gt;cond-&gt;mark&amp;FOLL))
					print("cant happen 2\n");
				return;
			}
		}
		a = AB;
		q = prg();
		q-&gt;as = a;
		q-&gt;line = p-&gt;line;
		q-&gt;to.type = D_BRANCH;
		q-&gt;to.offset = p-&gt;pc;
		q-&gt;cond = p;
		p = q;
	}
	p-&gt;mark |= FOLL;
	lastp-&gt;link = p;
	lastp = p;
	if(a == AB || (a == ARET &amp;&amp; p-&gt;scond == 14) || a == ARFE){
		return;
	}
	if(p-&gt;cond != P)
	if(a != ABL &amp;&amp; p-&gt;link != P) {
		q = brchain(p-&gt;link);
		if(a != ATEXT &amp;&amp; a != ABCASE)
		if(q != P &amp;&amp; (q-&gt;mark&amp;FOLL)) {
			p-&gt;as = relinv(a);
			p-&gt;link = p-&gt;cond;
			p-&gt;cond = q;
		}
		xfol(p-&gt;link);
		q = brchain(p-&gt;cond);
		if(q == P)
			q = p-&gt;cond;
		if(q-&gt;mark&amp;FOLL) {
			p-&gt;cond = q;
			return;
		}
		p = q;
		goto loop;
	}
	p = p-&gt;link;
	goto loop;
}

void
patch(void)
{
	long c, vexit;
	Prog *p, *q;
	Sym *s;
	int a;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f patch\n", cputime());
	Bflush(&amp;bso);
	mkfwd();
	s = lookup("exit", 0);
	vexit = s-&gt;value;
	for(p = firstp; p != P; p = p-&gt;link) {
		a = p-&gt;as;
		if(a == ATEXT)
			curtext = p;
		if((a == ABL || a == AB || a == ARET) &amp;&amp;
		   p-&gt;to.type != D_BRANCH &amp;&amp; p-&gt;to.sym != S) {
			s = p-&gt;to.sym;
			switch(s-&gt;type) {
			default:
				diag("undefined: %s\n%P", s-&gt;name, p);
				s-&gt;type = STEXT;
				s-&gt;value = vexit;
				break;
			case STEXT:
				p-&gt;to.offset = s-&gt;value;
				p-&gt;to.type = D_BRANCH;
				break;
			case SUNDEF:
				if(p-&gt;as != ABL)
					diag("help: SUNDEF in AB || ARET");
				p-&gt;to.offset = 0;
				p-&gt;to.type = D_BRANCH;
				p-&gt;cond = UP;
				break;
			}
		}
		if(p-&gt;to.type != D_BRANCH || p-&gt;cond == UP)
			continue;
		c = p-&gt;to.offset;
		for(q = firstp; q != P;) {
			if(q-&gt;forwd != P)
			if(c &gt;= q-&gt;forwd-&gt;pc) {
				q = q-&gt;forwd;
				continue;
			}
			if(c == q-&gt;pc)
				break;
			q = q-&gt;link;
		}
		if(q == P) {
			diag("branch out of range %ld\n%P", c, p);
			p-&gt;to.type = D_NONE;
		}
		p-&gt;cond = q;
	}

	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		if(p-&gt;cond != P &amp;&amp; p-&gt;cond != UP) {
			p-&gt;cond = brloop(p-&gt;cond);
			if(p-&gt;cond != P)
			if(p-&gt;to.type == D_BRANCH)
				p-&gt;to.offset = p-&gt;cond-&gt;pc;
		}
	}
}

#define	LOG	5
void
mkfwd(void)
{
	Prog *p;
	long dwn[LOG], cnt[LOG], i;
	Prog *lst[LOG];

	for(i=0; i&lt;LOG; i++) {
		if(i == 0)
			cnt[i] = 1; else
			cnt[i] = LOG * cnt[i-1];
		dwn[i] = 1;
		lst[i] = P;
	}
	i = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		i--;
		if(i &lt; 0)
			i = LOG-1;
		p-&gt;forwd = P;
		dwn[i]--;
		if(dwn[i] &lt;= 0) {
			dwn[i] = cnt[i];
			if(lst[i] != P)
				lst[i]-&gt;forwd = p;
			lst[i] = p;
		}
	}
}

Prog*
brloop(Prog *p)
{
	Prog *q;
	int c;

	for(c=0; p!=P;) {
		if(p-&gt;as != AB)
			return p;
		q = p-&gt;cond;
		if(q &lt;= p) {
			c++;
			if(q == p || c &gt; 5000)
				break;
		}
		p = q;
	}
	return P;
}

long
atolwhex(char *s)
{
	long n;
	int f;

	n = 0;
	f = 0;
	while(*s == ' ' || *s == '\t')
		s++;
	if(*s == '-' || *s == '+') {
		if(*s++ == '-')
			f = 1;
		while(*s == ' ' || *s == '\t')
			s++;
	}
	if(s[0]=='0' &amp;&amp; s[1]){
		if(s[1]=='x' || s[1]=='X'){
			s += 2;
			for(;;){
				if(*s &gt;= '0' &amp;&amp; *s &lt;= '9')
					n = n*16 + *s++ - '0';
				else if(*s &gt;= 'a' &amp;&amp; *s &lt;= 'f')
					n = n*16 + *s++ - 'a' + 10;
				else if(*s &gt;= 'A' &amp;&amp; *s &lt;= 'F')
					n = n*16 + *s++ - 'A' + 10;
				else
					break;
			}
		} else
			while(*s &gt;= '0' &amp;&amp; *s &lt;= '7')
				n = n*8 + *s++ - '0';
	} else
		while(*s &gt;= '0' &amp;&amp; *s &lt;= '9')
			n = n*10 + *s++ - '0';
	if(f)
		n = -n;
	return n;
}

long
rnd(long v, long r)
{
	long c;

	if(r &lt;= 0)
		return v;
	v += r - 1;
	c = v % r;
	if(c &lt; 0)
		c += r;
	v -= c;
	return v;
}

void
import(void)
{
	int i;
	Sym *s;

	for(i = 0; i &lt; NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link)
			if(s-&gt;sig != 0 &amp;&amp; s-&gt;type == SXREF &amp;&amp; (nimports == 0 || s-&gt;subtype == SIMPORT)){
				undefsym(s);
				Bprint(&amp;bso, "IMPORT: %s sig=%lux v=%ld\n", s-&gt;name, s-&gt;sig, s-&gt;value);
			}
}

void
ckoff(Sym *s, long v)
{
	if(v &lt; 0 || v &gt;= 1&lt;&lt;Roffset)
		diag("relocation offset %ld for %s out of range", v, s-&gt;name);
}

static Prog*
newdata(Sym *s, int o, int w, int t)
{
	Prog *p;

	p = prg();
	p-&gt;link = datap;
	datap = p;
	p-&gt;as = ADATA;
	p-&gt;reg = w;
	p-&gt;from.type = D_OREG;
	p-&gt;from.name = t;
	p-&gt;from.sym = s;
	p-&gt;from.offset = o;
	p-&gt;to.type = D_CONST;
	p-&gt;to.name = D_NONE;
	return p;
}

void
export(void)
{
	int i, j, n, off, nb, sv, ne;
	Sym *s, *et, *str, **esyms;
	Prog *p;
	char buf[NSNAME], *t;

	n = 0;
	for(i = 0; i &lt; NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link)
			if(s-&gt;sig != 0 &amp;&amp; s-&gt;type != SXREF &amp;&amp; s-&gt;type != SUNDEF &amp;&amp; (nexports == 0 || s-&gt;subtype == SEXPORT))
				n++;
	esyms = malloc(n*sizeof(Sym*));
	ne = n;
	n = 0;
	for(i = 0; i &lt; NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link)
			if(s-&gt;sig != 0 &amp;&amp; s-&gt;type != SXREF &amp;&amp; s-&gt;type != SUNDEF &amp;&amp; (nexports == 0 || s-&gt;subtype == SEXPORT))
				esyms[n++] = s;
	for(i = 0; i &lt; ne-1; i++)
		for(j = i+1; j &lt; ne; j++)
			if(strcmp(esyms[i]-&gt;name, esyms[j]-&gt;name) &gt; 0){
				s = esyms[i];
				esyms[i] = esyms[j];
				esyms[j] = s;
			}

	nb = 0;
	off = 0;
	et = lookup(EXPTAB, 0);
	if(et-&gt;type != 0 &amp;&amp; et-&gt;type != SXREF)
		diag("%s already defined", EXPTAB);
	et-&gt;type = SDATA;
	str = lookup(".string", 0);
	if(str-&gt;type == 0)
		str-&gt;type = SDATA;
	sv = str-&gt;value;
	for(i = 0; i &lt; ne; i++){
		s = esyms[i];
		Bprint(&amp;bso, "EXPORT: %s sig=%lux t=%d\n", s-&gt;name, s-&gt;sig, s-&gt;type);

		/* signature */
		p = newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
		p-&gt;to.offset = s-&gt;sig;

		/* address */
		p = newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
		p-&gt;to.name = D_EXTERN;
		p-&gt;to.sym = s;

		/* string */
		t = s-&gt;name;
		n = strlen(t)+1;
		for(;;){
			buf[nb++] = *t;
			sv++;
			if(nb &gt;= NSNAME){
				p = newdata(str, sv-NSNAME, NSNAME, D_STATIC);
				p-&gt;to.type = D_SCONST;
				p-&gt;to.sval = malloc(NSNAME);
				memmove(p-&gt;to.sval, buf, NSNAME);
				nb = 0;
			}
			if(*t++ == 0)
				break;
		}

		/* name */
		p = newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
		p-&gt;to.name = D_STATIC;
		p-&gt;to.sym = str;
		p-&gt;to.offset = sv-n;
	}

	if(nb &gt; 0){
		p = newdata(str, sv-nb, nb, D_STATIC);
		p-&gt;to.type = D_SCONST;
		p-&gt;to.sval = malloc(NSNAME);
		memmove(p-&gt;to.sval, buf, nb);
	}

	for(i = 0; i &lt; 3; i++){
		newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
	}
	et-&gt;value = off;
	if(sv == 0)
		sv = 1;
	str-&gt;value = sv;
	exports = ne;
	free(esyms);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

