<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9660srv/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9660srv/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "dat.h"
#include "fns.h"

enum
{
	Maxfdata	= 8192,
	Maxiosize	= IOHDRSZ+Maxfdata,
};

void io(int);
void rversion(void);
void	rattach(void);
void	rauth(void);
void	rclunk(void);
void	rcreate(void);
void	rflush(void);
void	ropen(void);
void	rread(void);
void	rremove(void);
void	rsession(void);
void	rstat(void);
void	rwalk(void);
void	rwrite(void);
void	rwstat(void);

static int	openflags(int);
static void	rmservice(void);
static void	usage(void);

#define Reqsize (sizeof(Fcall)+Maxfdata)

Fcall *req;
Fcall *rep;

uchar mdata[Maxiosize];
char fdata[Maxfdata];
uchar statbuf[STATMAX];
int errno;

static char	srvfile[64];

extern Xfsub	*xsublist[];
extern int	nclust;

jmp_buf	err_lab[16];
int	nerr_lab;
char	err_msg[ERRMAX];

int	chatty;
int	nojoliet;
int	noplan9;
int norock;

void	(*fcalls[])(void) = {
	[Tversion]	rversion,
	[Tflush]	rflush,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

void
main(int argc, char **argv)
{
	int srvfd, pipefd[2], stdio;
	Xfsub **xs;

	stdio = 0;
	ARGBEGIN {
	case '9':
		noplan9 = 1;
		break;
	case 'c':
		nclust = atoi(EARGF(usage()));
		if (nclust &lt;= 0)
			sysfatal("nclust %d non-positive", nclust);
		break;
	case 'f':
		deffile = EARGF(usage());
		break;
	case 'r':
		norock = 1;
		break;
	case 's':
		stdio = 1;
		break;
	case 'v':
		chatty = 1;
		break;
	case 'J':
		nojoliet = 1;
		break;
	default:
		usage();
	} ARGEND

	switch(argc) {
	case 0:
		break;
	case 1:
		srvname = argv[0];
		break;
	default:
		usage();
	}

	iobuf_init();
	for(xs=xsublist; *xs; xs++)
		(*(*xs)-&gt;reset)();

	if(stdio) {
		pipefd[0] = 0;
		pipefd[1] = 1;
	} else {
		close(0);
		close(1);
		open("/dev/null", OREAD);
		open("/dev/null", OWRITE);
		if(pipe(pipefd) &lt; 0)
			panic(1, "pipe");
		sprint(srvfile, "/srv/%s", srvname);
		srvfd = create(srvfile, OWRITE|ORCLOSE, 0600);
		if(srvfd &lt; 0)
			panic(1, srvfile);
		fprint(srvfd, "%d", pipefd[0]);
		close(pipefd[0]);
		fprint(2, "%s %d: serving %s\n", argv0, getpid(), srvfile);
	}
	srvfd = pipefd[1];

	switch(rfork(RFNOWAIT|RFNOTEG|RFFDG|RFPROC)){
	case -1:
		panic(1, "fork");
	default:
		_exits(0);
	case 0:
		break;
	}

	io(srvfd);
	exits(0);
}

void
io(int srvfd)
{
	int n, pid;
	Fcall xreq, xrep;

	req = &amp;xreq;
	rep = &amp;xrep;
	pid = getpid();
	fmtinstall('F', fcallfmt);

	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads.
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error.
		 */
		n = read9pmsg(srvfd, mdata, sizeof mdata);
		if(n &lt; 0)
			break;
		if(n == 0)
			continue;
		if(convM2S(mdata, n, req) == 0)
			continue;

		if(chatty)
			fprint(2, "9660srv %d:&lt;-%F\n", pid, req);

		errno = 0;
		if(!waserror()){
			err_msg[0] = 0;
			if(req-&gt;type &gt;= nelem(fcalls) || !fcalls[req-&gt;type])
				error("bad fcall type");
			(*fcalls[req-&gt;type])();
			poperror();
		}

		if(err_msg[0]){
			rep-&gt;type = Rerror;
			rep-&gt;ename = err_msg;
		}else{
			rep-&gt;type = req-&gt;type + 1;
			rep-&gt;fid = req-&gt;fid;
		}
		rep-&gt;tag = req-&gt;tag;

		if(chatty)
			fprint(2, "9660srv %d:-&gt;%F\n", pid, rep);
		n = convS2M(rep, mdata, sizeof mdata);
		if(n == 0)
			panic(1, "convS2M error on write");
		if(write(srvfd, mdata, n) != n)
			panic(1, "mount write");
		if(nerr_lab != 0)
			panic(0, "err stack %d: %lux %lux %lux %lux %lux %lux", nerr_lab,
			err_lab[0][JMPBUFPC], err_lab[1][JMPBUFPC],
			err_lab[2][JMPBUFPC], err_lab[3][JMPBUFPC],
			err_lab[4][JMPBUFPC], err_lab[5][JMPBUFPC]);
	}
	chat("server shut down");
}

static void
usage(void)
{
	fprint(2, "usage: %s [-v] [-9Jr] [-s] [-f devicefile] [srvname]\n", argv0);
	exits("usage");
}

void
error(char *p)
{
	strecpy(err_msg, err_msg+sizeof err_msg, p);
	nexterror();
}

void
nexterror(void)
{
	longjmp(err_lab[--nerr_lab], 1);
}

void*
ealloc(long n)
{
	void *p;

	p = malloc(n);
	if(p == 0)
		error("no memory");
	return p;
}

void
setnames(Dir *d, char *n)
{
	d-&gt;name = n;
	d-&gt;uid = n+Maxname;
	d-&gt;gid = n+Maxname*2;
	d-&gt;muid = n+Maxname*3;

	d-&gt;name[0] = '\0';
	d-&gt;uid[0] = '\0';
	d-&gt;gid[0] = '\0';
	d-&gt;muid[0] = '\0';
}

void
rversion(void)
{
	if(req-&gt;msize &gt; Maxiosize)
		rep-&gt;msize = Maxiosize;
	else
		rep-&gt;msize = req-&gt;msize;
	rep-&gt;version = "9P2000";
}

void
rauth(void)
{
	error("9660srv: authentication not required");
}

void
rflush(void)
{
}

void
rattach(void)
{
	Xfs *xf;
	Xfile *root;
	Xfsub **xs;

	chat("attach(fid=%d,uname=\"%s\",aname=\"%s\")...",
		req-&gt;fid, req-&gt;uname, req-&gt;aname);

	if(waserror()){
		xfile(req-&gt;fid, Clunk);
		nexterror();
	}
	root = xfile(req-&gt;fid, Clean);
	root-&gt;qid = (Qid){0, 0, QTDIR};
	root-&gt;xf = xf = ealloc(sizeof(Xfs));
	memset(xf, 0, sizeof(Xfs));
	xf-&gt;ref = 1;
	xf-&gt;d = getxdata(req-&gt;aname);

	for(xs=xsublist; *xs; xs++)
		if((*(*xs)-&gt;attach)(root) &gt;= 0){
			poperror();
			xf-&gt;s = *xs;
			xf-&gt;rootqid = root-&gt;qid;
			rep-&gt;qid = root-&gt;qid;
			return;
		}
	error("unknown format");
}

Xfile*
doclone(Xfile *of, int newfid)
{
	Xfile *nf, *next;

	nf = xfile(newfid, Clean);
	if(waserror()){
		xfile(newfid, Clunk);
		nexterror();
	}
	next = nf-&gt;next;
	*nf = *of;
	nf-&gt;next = next;
	nf-&gt;fid = newfid;
	refxfs(nf-&gt;xf, 1);
	if(nf-&gt;len){
		nf-&gt;ptr = ealloc(nf-&gt;len);
		memmove(nf-&gt;ptr, of-&gt;ptr, nf-&gt;len);
	}else
		nf-&gt;ptr = of-&gt;ptr;
	(*of-&gt;xf-&gt;s-&gt;clone)(of, nf);
	poperror();
	return nf;
}

void
rwalk(void)
{
	Xfile *f, *nf;
	Isofile *oldptr;
	int oldlen;
	Qid oldqid;

	rep-&gt;nwqid = 0;
	nf = nil;
	f = xfile(req-&gt;fid, Asis);
	if(req-&gt;fid != req-&gt;newfid)
		f = nf = doclone(f, req-&gt;newfid);

	/* save old state in case of error */
	oldqid = f-&gt;qid;
	oldlen = f-&gt;len;
	oldptr = f-&gt;ptr;
	if(oldlen){
		oldptr = ealloc(oldlen);
		memmove(oldptr, f-&gt;ptr, oldlen);
	}

	if(waserror()){
		/*
		 * if nf != nil, nf == f, which is derived from req-&gt;newfid,
		 * so we can't clunk req-&gt;newfid with xfile, which would put
		 * f back on the free list, until we're done with f below.
		 */
		if(rep-&gt;nwqid == req-&gt;nwname){
			if(oldlen)
				free(oldptr);
		}else{
			/* restore previous state */
			f-&gt;qid = oldqid;
			if(f-&gt;len)
				free(f-&gt;ptr);
			f-&gt;ptr = oldptr;
			f-&gt;len = oldlen;
		}
		if(nf != nil)
			xfile(req-&gt;newfid, Clunk);
		if(rep-&gt;nwqid==req-&gt;nwname || rep-&gt;nwqid &gt; 0){
			err_msg[0] = '\0';
			return;
		}
		nexterror();
	}

	for(rep-&gt;nwqid=0; rep-&gt;nwqid &lt; req-&gt;nwname &amp;&amp; rep-&gt;nwqid &lt; MAXWELEM; rep-&gt;nwqid++){
		chat("\twalking %s\n", req-&gt;wname[rep-&gt;nwqid]);
		if(!(f-&gt;qid.type &amp; QTDIR)){
			chat("\tnot dir: type=%#x\n", f-&gt;qid.type);
			error("walk in non-directory");
		}

		if(strcmp(req-&gt;wname[rep-&gt;nwqid], "..")==0){
			if(f-&gt;qid.path != f-&gt;xf-&gt;rootqid.path)
				(*f-&gt;xf-&gt;s-&gt;walkup)(f);
		}else
			(*f-&gt;xf-&gt;s-&gt;walk)(f, req-&gt;wname[rep-&gt;nwqid]);
		rep-&gt;wqid[rep-&gt;nwqid] = f-&gt;qid;
	}
	poperror();
	if(oldlen)
		free(oldptr);
}

void
ropen(void)
{
	Xfile *f;

	f = xfile(req-&gt;fid, Asis);
	if(f-&gt;flags&amp;Omodes)
		error("open on open file");
	if(req-&gt;mode&amp;ORCLOSE)
		error("no removes");
	(*f-&gt;xf-&gt;s-&gt;open)(f, req-&gt;mode);
	f-&gt;flags = openflags(req-&gt;mode);
	rep-&gt;qid = f-&gt;qid;
	rep-&gt;iounit = 0;
}

void
rcreate(void)
{
	error("no creates");
/*
	Xfile *f;

	if(strcmp(req-&gt;name, ".") == 0 || strcmp(req-&gt;name, "..") == 0)
		error("create . or ..");
	f = xfile(req-&gt;fid, Asis);
	if(f-&gt;flags&amp;Omodes)
		error("create on open file");
	if(!(f-&gt;qid.path&amp;CHDIR))
		error("create in non-directory");
	(*f-&gt;xf-&gt;s-&gt;create)(f, req-&gt;name, req-&gt;perm, req-&gt;mode);
	chat("f-&gt;qid=0x%8.8lux...", f-&gt;qid.path);
	f-&gt;flags = openflags(req-&gt;mode);
	rep-&gt;qid = f-&gt;qid;
*/
}

void
rread(void)
{
	Xfile *f;

	f=xfile(req-&gt;fid, Asis);
	if (!(f-&gt;flags&amp;Oread))
		error("file not opened for reading");
	if(f-&gt;qid.type &amp; QTDIR)
		rep-&gt;count = (*f-&gt;xf-&gt;s-&gt;readdir)(f, (uchar*)fdata, req-&gt;offset, req-&gt;count);
	else
		rep-&gt;count = (*f-&gt;xf-&gt;s-&gt;read)(f, fdata, req-&gt;offset, req-&gt;count);
	rep-&gt;data = fdata;
}

void
rwrite(void)
{
	Xfile *f;

	f=xfile(req-&gt;fid, Asis);
	if(!(f-&gt;flags&amp;Owrite))
		error("file not opened for writing");
	rep-&gt;count = (*f-&gt;xf-&gt;s-&gt;write)(f, req-&gt;data, req-&gt;offset, req-&gt;count);
}

void
rclunk(void)
{
	Xfile *f;

	if(!waserror()){
		f = xfile(req-&gt;fid, Asis);
		(*f-&gt;xf-&gt;s-&gt;clunk)(f);
		poperror();
	}
	xfile(req-&gt;fid, Clunk);
}

void
rremove(void)
{
	error("no removes");
}

void
rstat(void)
{
	Xfile *f;
	Dir dir;

	chat("stat(fid=%d)...", req-&gt;fid);
	f=xfile(req-&gt;fid, Asis);
	setnames(&amp;dir, fdata);
	(*f-&gt;xf-&gt;s-&gt;stat)(f, &amp;dir);
	if(chatty)
		showdir(2, &amp;dir);
	rep-&gt;nstat = convD2M(&amp;dir, statbuf, sizeof statbuf);
	rep-&gt;stat = statbuf;
}

void
rwstat(void)
{
	error("no wstat");
}

static int
openflags(int mode)
{
	int flags = 0;

	switch(mode &amp; ~(OTRUNC|OCEXEC|ORCLOSE)){
	case OREAD:
	case OEXEC:
		flags = Oread; break;
	case OWRITE:
		flags = Owrite; break;
	case ORDWR:
		flags = Oread|Owrite; break;
	}
	if(mode &amp; ORCLOSE)
		flags |= Orclose;
	return flags;
}

void
showdir(int fd, Dir *s)
{
	char a_time[32], m_time[32];
	char *p;

	strcpy(a_time, ctime(s-&gt;atime));
	if(p=strchr(a_time, '\n'))	/* assign = */
		*p = 0;
	strcpy(m_time, ctime(s-&gt;mtime));
	if(p=strchr(m_time, '\n'))	/* assign = */
		*p = 0;
	fprint(fd, "name=\"%s\" qid=(0x%llux,%lud) type=%d dev=%d \
mode=0x%8.8lux=0%luo atime=%s mtime=%s length=%lld uid=\"%s\" gid=\"%s\"...",
		s-&gt;name, s-&gt;qid.path, s-&gt;qid.vers, s-&gt;type, s-&gt;dev,
		s-&gt;mode, s-&gt;mode,
		a_time, m_time, s-&gt;length, s-&gt;uid, s-&gt;gid);
}

#define	SIZE	1024

void
chat(char *fmt, ...)
{
	va_list arg;

	if(chatty){
		va_start(arg, fmt);
		vfprint(2, fmt, arg);
		va_end(arg);
	}
}

void
panic(int rflag, char *fmt, ...)
{
	va_list arg;
	char buf[SIZE]; int n;

	n = sprint(buf, "%s %d: ", argv0, getpid());
	va_start(arg, fmt);
	vseprint(buf+n, buf+SIZE, fmt, arg);
	va_end(arg);
	fprint(2, (rflag ? "%s: %r\n" : "%s\n"), buf);
	if(chatty){
		fprint(2, "abort\n");
		abort();
	}
	exits("panic");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

