<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/mport.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/mport.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

typedef struct Rpcconn	Rpcconn;

struct Rpcconn
{
	int	data;
	int	ctl;
	Rpccall	cmd;
	Rpccall	reply;
	uchar	rpcbuf[8192];
	uchar	argbuf[8192];
};

void	putauth(char*, Auth*);
int	rpccall(Rpcconn*, int);

int	rpcdebug;

Rpcconn	r;
char *	mach;

void
main(int argc, char **argv)
{
	char addr[64], dir[64], name[128];
	char buf[33], *p;
	uchar *dataptr, *argptr;
	int i, fd, n, remport;

	ARGBEGIN{
	case 'm':
		mach = ARGF();
		break;
	case 'D':
		++rpcdebug;
		break;
	}ARGEND
	if(argc != 1)
		exits("usage");

	snprint(addr, sizeof addr, "udp!%s!111", argv[0]);
	r.data = dial(addr, 0, dir, &amp;r.ctl);
	if(r.data &lt; 0){
		fprint(2, "dial %s: %r\n", addr);
		exits("dial");
	}
	if(rpcdebug)
		fprint(2, "dial %s: dir=%s\n", addr, dir);
	if(fprint(r.ctl, "headers") &lt; 0){
		fprint(2, "can't set header mode: %r\n");
		exits("headers");
	}
	sprint(name, "%s/remote", dir);
	fd = open(name, OREAD);
	if(fd &lt; 0){
		fprint(2, "can't open %s: %r\n", name);
		exits("remote");
	}
	n = read(fd, buf, sizeof buf-1);
	if(n &lt; 0){
		fprint(2, "can't read %s: %r\n", name);
		exits("remote");
	}
	close(fd);
	buf[n] = 0;
	p = buf;
	r.cmd.host = 0;
	for(i=0; i&lt;4; i++, p++)
		r.cmd.host = (r.cmd.host&lt;&lt;8)|strtol(p, &amp;p, 10);
	r.cmd.port = strtol(p, 0, 10);
	fprint(2, "host=%ld.%ld.%ld.%ld, port=%lud\n",
		(r.cmd.host&gt;&gt;24)&amp;0xff, (r.cmd.host&gt;&gt;16)&amp;0xff,
		(r.cmd.host&gt;&gt;8)&amp;0xff, r.cmd.host&amp;0xff, r.cmd.port);
	fprint(r.ctl, "disconnect");

	r.cmd.xid = time(0);
	r.cmd.mtype = CALL;
	r.cmd.rpcvers = 2;
	r.cmd.args = r.argbuf;
	if(mach)
		putauth(mach, &amp;r.cmd.cred);

	r.cmd.prog = 100000;	/* portmapper */
	r.cmd.vers = 2;		/* vers */
	r.cmd.proc = 3;		/* getport */
	dataptr = r.cmd.args;

	PLONG(100005);		/* mount */
	PLONG(1);		/* vers */
	PLONG(IPPROTO_UDP);
	PLONG(0);

	i = rpccall(&amp;r, dataptr-(uchar*)r.cmd.args);
	if(i != 4)
		exits("trouble");
	argptr = r.reply.results;
	remport = GLONG();
	fprint(2, "remote port = %d\n", remport);

	r.cmd.port = remport;
	r.cmd.prog = 100005;	/* mount */
	r.cmd.vers = 1;		/* vers */
	r.cmd.proc = 0;		/* null */
	dataptr = r.cmd.args;

	i = rpccall(&amp;r, dataptr-(uchar*)r.cmd.args);
	if(i != 0)
		exits("trouble");
	fprint(2, "OK ping mount\n");

	r.cmd.prog = 100005;	/* mount */
	r.cmd.vers = 1;		/* vers */
	r.cmd.proc = 5;		/* export */
	dataptr = r.cmd.args;

	i = rpccall(&amp;r, dataptr-(uchar*)r.cmd.args);
	fprint(2, "export: %d bytes returned\n", i);
	argptr = r.reply.results;
	while (GLONG() != 0) {
		n = GLONG();
		p = GPTR(n);
		print("%.*s\n", utfnlen(p, n), p);
		while (GLONG() != 0) {
			n = GLONG();
			p = GPTR(n);
			print("\t%.*s\n", utfnlen(p, n), p);
		}
	}

	exits(0);
}

void
putauth(char *mach, Auth *a)
{
	uchar *dataptr;
	long stamp = time(0);
	int n = strlen(mach);

	dataptr = realloc(a-&gt;data, 2*4+ROUNDUP(n)+4*4);
	a-&gt;data = dataptr;
	a-&gt;flavor = AUTH_UNIX;
	PLONG(stamp);
	PLONG(n);
	PPTR(mach, n);
	PLONG(0);
	PLONG(1);
	PLONG(1);
	PLONG(0);
	a-&gt;count = dataptr - (uchar*)a-&gt;data;
}

int
rpccall(Rpcconn *r, int narg)
{
	int n;

	r-&gt;cmd.xid++;
	n = rpcS2M(&amp;r-&gt;cmd, narg, r-&gt;rpcbuf);
	if(rpcdebug)
		rpcprint(2, &amp;r-&gt;cmd);
	if(write(r-&gt;data, r-&gt;rpcbuf, n) &lt; 0){
		fprint(2, "rpc write: %r\n");
		exits("rpc");
	}
	n = read(r-&gt;data, r-&gt;rpcbuf, sizeof r-&gt;rpcbuf);
	if(n &lt; 0){
		fprint(2, "rpc read: %r\n");
		exits("rpc");
	}
	if(rpcM2S(r-&gt;rpcbuf, &amp;r-&gt;reply, n) != 0){
		fprint(2, "rpc reply format error\n");
		exits("rpc");
	}
	if(rpcdebug)
		rpcprint(2, &amp;r-&gt;reply);
	if(r-&gt;reply.mtype != REPLY || r-&gt;reply.stat != MSG_ACCEPTED ||
	   r-&gt;reply.astat != SUCCESS){
		fprint(2, "rpc mtype, stat, astat = %ld, %ld, %ld\n",
			r-&gt;reply.mtype, r-&gt;reply.stat, r-&gt;reply.astat);
		exits("rpc");
	}
	return n - (((uchar *)r-&gt;reply.results) - r-&gt;rpcbuf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

