<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/nfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/nfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

extern uchar buf[];

Xfid *
rpc2xfid(Rpccall *cmd, Dir *dp)
{
	char *argptr = cmd-&gt;args;
	Xfile *xp;
	Xfid *xf;
	Session *s;
	char *service;
	Authunix au;
	Qid qid;
	char client[256], *user;
	Unixidmap *m;
	int i;
	uvlong x1, x2;

	chat("rpc2xfid %.8lux %.8lux %p %p\n", *((ulong*)argptr), *((ulong*)argptr+1), buf, argptr);
	if(argptr[0] == 0 &amp;&amp; argptr[1] == 0){	/* root */
		chat("root...");
		xp = xfroot(&amp;argptr[2], 0);
		s = xp ? xp-&gt;s : 0;
	}else{
		ulong ul;
		chat("noroot %.8lux...", *((ulong*)argptr));
		if((ul=GLONG()) != starttime){
			chat("bad tag %lux %lux...", ul, starttime);
			return 0;
		}
		s = (Session *)GLONG();
		x1 = GLONG();
		x2 = GLONG();
		qid.path = x1 | (x2&lt;&lt;32);
		qid.vers = 0;
		qid.type = GBYTE();
		xp = xfile(&amp;qid, s, 0);
	}
	if(xp == 0){
		chat("no xfile...");
		return 0;
	}
	if(auth2unix(&amp;cmd-&gt;cred, &amp;au) != 0){
		chat("auth flavor=%ld, count=%ld\n",
			cmd-&gt;cred.flavor, cmd-&gt;cred.count);
		for(i=0; i&lt;cmd-&gt;cred.count; i++)
			chat(" %.2ux", ((uchar *)cmd-&gt;cred.data)[i]);
		chat("...");
		return 0;
	}else{
/*		chat("auth: %d %.*s u=%d g=%d",
 *			au.stamp, utfnlen(au.mach.s, au.mach.n), au.mach.s, au.uid, au.gid);
 *		for(i=0; i&lt;au.gidlen; i++)
 *			chat(", %d", au.gids[i]);
 *		chat("...");
 */
		char *p = memchr(au.mach.s, '.', au.mach.n);
		chat("%ld@%.*s...", au.uid, utfnlen(au.mach.s, (p ? p-au.mach.s : au.mach.n)), au.mach.s);
	}
	if(au.mach.n &gt;= sizeof client){
		chat("client name too long...");
		return 0;
	}
	memcpy(client, au.mach.s, au.mach.n);
	client[au.mach.n] = 0;
	service = xp-&gt;parent-&gt;s-&gt;service;
	cmd-&gt;up = m = pair2idmap(service, cmd-&gt;host);
	if(m == 0){
		chat("no map for pair (%s,%s)...", service, client);
		/*chat("getdom %d.%d.%d.%d", cmd-&gt;host&amp;0xFF, (cmd-&gt;host&gt;&gt;8)&amp;0xFF,
			(cmd-&gt;host&gt;&gt;16)&amp;0xFF, (cmd-&gt;host&gt;&gt;24)&amp;0xFF);/**/
		/*if(getdom(cmd-&gt;host, client, sizeof(client))&lt;0)
			return 0;/**/
		return 0;
	}
	/*chat("map=(%s,%s)...", m-&gt;server, m-&gt;client);/**/
	cmd-&gt;user = user = id2name(&amp;m-&gt;u.ids, au.uid);
	if(user == 0){
		chat("no user for id %ld...", au.uid);
		return 0;
	}
	chat("user=%s...", user);/**/
	xf = 0;
	if(s == xp-&gt;parent-&gt;s){
		if(!s-&gt;noauth)
			xf = setuser(xp, user);
		if(xf == 0)
			xf = setuser(xp, "none");
		if(xf == 0)
			chat("can't set user none...");
	}else
		xf = xp-&gt;users;
	if(xf)
		chat("uid=%s...", xf-&gt;uid);
	if(xf &amp;&amp; dp &amp;&amp; xfstat(xf, dp) &lt; 0){
		chat("can't stat %s...", xp-&gt;name);
		return 0;
	}
	return xf;
}

Xfid *
setuser(Xfile *xp, char *user)
{
	Xfid *xf, *xpf;
	Session *s;

	xf = xfid(user, xp, 1);
	if(xf-&gt;urfid)
		return xf;
	if(xp-&gt;parent==xp || !(xpf = setuser(xp-&gt;parent, user))) /* assign = */
		return xfid(user, xp, -1);
	s = xp-&gt;s;
	xf-&gt;urfid = newfid(s);
	xf-&gt;urfid-&gt;owner = &amp;xf-&gt;urfid;
	setfid(s, xpf-&gt;urfid);
	s-&gt;f.newfid = xf-&gt;urfid - s-&gt;fids;
	s-&gt;f.nwname = 1;
	s-&gt;f.wname[0] = xp-&gt;name;
	if(xmesg(s, Twalk) || s-&gt;f.nwqid != 1)
		return xfid(user, xp, -1);
	return xf;
}

int
xfstat(Xfid *xf, Dir *dp)
{
	Xfile *xp;
	Session *s;
	char buf[128];

	xp = xf-&gt;xp;
	s = xp-&gt;s;
	if(s != xp-&gt;parent-&gt;s){
		seprint(buf, buf+sizeof buf, "#%s", xf-&gt;uid);
		dp-&gt;name = strstore(buf);
		dp-&gt;uid = xf-&gt;uid;
		dp-&gt;gid = xf-&gt;uid;
		dp-&gt;muid = xf-&gt;uid;
		dp-&gt;qid.path = (uvlong)xf-&gt;uid;
		dp-&gt;qid.type = QTFILE;
		dp-&gt;qid.vers = 0;
		dp-&gt;mode = 0666;
		dp-&gt;atime = time(0);
		dp-&gt;mtime = dp-&gt;atime;
		dp-&gt;length = NETCHLEN;
		dp-&gt;type = 0;
		dp-&gt;type = 0;
		return 0;
	}
	setfid(s, xf-&gt;urfid);
	if(xmesg(s, Tstat) == 0){
		convM2D(s-&gt;f.stat, s-&gt;f.nstat, dp, (char*)s-&gt;statbuf);
		if(xp-&gt;qid.path == dp-&gt;qid.path){
			xp-&gt;name = strstore(dp-&gt;name);
			return 0;
		}
		/* not reached ? */
		chat("xp-&gt;qid.path=0x%.16llux, dp-&gt;qid.path=0x%.16llux name=%s...",
			xp-&gt;qid.path, dp-&gt;qid.path, dp-&gt;name);
	}
	if(xp != xp-&gt;parent)
		xpclear(xp);
	else
		clog("can't stat root: %s",
			s-&gt;f.type == Rerror ? s-&gt;f.ename : "??");
	return -1;
}

int
xfwstat(Xfid *xf, Dir *dp)
{
	Xfile *xp;
	Session *s;

	xp = xf-&gt;xp;
	s = xp-&gt;s;

	/*
	 * xf-&gt;urfid can be zero because some DOS NFS clients
	 * try to do wstat on the #user authentication files on close.
	 */
	if(s == 0 || xf-&gt;urfid == 0)
		return -1;
	setfid(s, xf-&gt;urfid);
	s-&gt;f.stat = s-&gt;statbuf;
	convD2M(dp, s-&gt;f.stat, Maxstatdata);
	if(xmesg(s, Twstat))
		return -1;
	xp-&gt;name = strstore(dp-&gt;name);
	return 0;
}

int
xfopen(Xfid *xf, int flag)
{
	static int modes[] = {
		[Oread] OREAD, [Owrite] OWRITE, [Oread|Owrite] ORDWR,
	};
	Xfile *xp;
	Session *s;
	Fid *opfid;
	int omode;

	if(xf-&gt;opfid &amp;&amp; (xf-&gt;mode &amp; flag &amp; Open) == flag)
		return 0;
	omode = modes[(xf-&gt;mode|flag) &amp; Open];
	if(flag &amp; Trunc)
		omode |= OTRUNC;
	xp = xf-&gt;xp;
	chat("open(\"%s\", %d)...", xp-&gt;name, omode);
	s = xp-&gt;s;
	opfid = newfid(s);
	setfid(s, xf-&gt;urfid);
	s-&gt;f.newfid = opfid - s-&gt;fids;
	s-&gt;f.nwname = 0;
	if(xmesg(s, Twalk)){
		putfid(s, opfid);
		return -1;
	}
	setfid(s, opfid);
	s-&gt;f.mode = omode;
	if(xmesg(s, Topen)){
		clunkfid(s, opfid);
		return -1;
	}
	if(xf-&gt;opfid)
		clunkfid(s, xf-&gt;opfid);
	xf-&gt;mode |= flag &amp; Open;
	xf-&gt;opfid = opfid;
	opfid-&gt;owner = &amp;xf-&gt;opfid;
	xf-&gt;offset = 0;
	return 0;
}

void
xfclose(Xfid *xf)
{
	Xfile *xp;

	if(xf-&gt;mode &amp; Open){
		xp = xf-&gt;xp;
		chat("close(\"%s\")...", xp-&gt;name);
		if(xf-&gt;opfid)
			clunkfid(xp-&gt;s, xf-&gt;opfid);
		xf-&gt;mode &amp;= ~Open;
		xf-&gt;opfid = 0;
	}
}

void
xfclear(Xfid *xf)
{
	Xfile *xp = xf-&gt;xp;

	if(xf-&gt;opfid){
		clunkfid(xp-&gt;s, xf-&gt;opfid);
		xf-&gt;opfid = 0;
	}
	if(xf-&gt;urfid){
		clunkfid(xp-&gt;s, xf-&gt;urfid);
		xf-&gt;urfid = 0;
	}
	xfid(xf-&gt;uid, xp, -1);
}

Xfid *
xfwalkcr(int type, Xfid *xf, String *elem, long perm)
{
	Session *s;
	Xfile *xp, *newxp;
	Xfid *newxf;
	Fid *nfid;

	chat("xf%s(\"%s\")...", type==Tcreate ? "create" : "walk", elem-&gt;s);
	xp = xf-&gt;xp;
	s = xp-&gt;s;
	nfid = newfid(s);
	setfid(s, xf-&gt;urfid);
	s-&gt;f.newfid = nfid - s-&gt;fids;
	if(type == Tcreate){
		s-&gt;f.nwname = 0;
		if(xmesg(s, Twalk)){
			putfid(s, nfid);
			return 0;
		}
		s-&gt;f.fid = nfid - s-&gt;fids;
	}
	if(type == Tcreate){
		s-&gt;f.name = elem-&gt;s;
		s-&gt;f.perm = perm;
		s-&gt;f.mode = (perm&amp;DMDIR) ? OREAD : ORDWR;
		if(xmesg(s, type)){
			clunkfid(s, nfid);
			return 0;
		}
	}else{	/* Twalk */
		s-&gt;f.nwname = 1;
		s-&gt;f.wname[0] = elem-&gt;s;
		if(xmesg(s, type) || s-&gt;f.nwqid!=1){
			putfid(s, nfid);
			return 0;
		}
		s-&gt;f.qid = s-&gt;f.wqid[0];	/* only one element */
	}
	chat("fid=%d,qid=0x%llux,%ld,%.2ux...", s-&gt;f.fid, s-&gt;f.qid.path, s-&gt;f.qid.vers, s-&gt;f.qid.type);
	newxp = xfile(&amp;s-&gt;f.qid, s, 1);
	if(newxp-&gt;parent == 0){
		chat("new xfile...");
		newxp-&gt;parent = xp;
		newxp-&gt;sib = xp-&gt;child;
		xp-&gt;child = newxp;
	}
	newxf = xfid(xf-&gt;uid, newxp, 1);
	if(type == Tcreate){
		newxf-&gt;mode = (perm&amp;DMDIR) ? Oread : (Oread|Owrite);
		newxf-&gt;opfid = nfid;
		nfid-&gt;owner = &amp;newxf-&gt;opfid;
		nfid = newfid(s);
		setfid(s, xf-&gt;urfid);
		s-&gt;f.newfid = nfid - s-&gt;fids;
		s-&gt;f.nwname = 1;
		s-&gt;f.wname[0] = elem-&gt;s;
		if(xmesg(s, Twalk) || s-&gt;f.nwqid!=1){
			putfid(s, nfid);
			xpclear(newxp);
			return 0;
		}
		newxf-&gt;urfid = nfid;
		nfid-&gt;owner = &amp;newxf-&gt;urfid;
	}else if(newxf-&gt;urfid){
		chat("old xfid %ld...", newxf-&gt;urfid-s-&gt;fids);
		clunkfid(s, nfid);
	}else{
		newxf-&gt;urfid = nfid;
		nfid-&gt;owner = &amp;newxf-&gt;urfid;
	}
	newxp-&gt;name = strstore(elem-&gt;s);
	return newxf;
}

void
xpclear(Xfile *xp)
{
	Session *s;
	Xfid *xf;
	Xfile *xnp;

	s = xp-&gt;s;
	while(xf = xp-&gt;users)	/* assign = */
		xfclear(xf);
	while(xnp = xp-&gt;child){	/* assign = */
		xp-&gt;child = xnp-&gt;sib;
		xnp-&gt;parent = 0;
		xpclear(xnp);
		xfile(&amp;xnp-&gt;qid, s, -1);
	}
	if(xnp = xp-&gt;parent){	/* assign = */
		if(xnp-&gt;child == xp)
			xnp-&gt;child = xp-&gt;sib;
		else{
			xnp = xnp-&gt;child;
			while(xnp-&gt;sib != xp)
				xnp = xnp-&gt;sib;
			xnp-&gt;sib = xp-&gt;sib;
		}
		xfile(&amp;xp-&gt;qid, s, -1);
	}
}

int
xp2fhandle(Xfile *xp, Fhandle fh)
{
	uchar *dataptr = fh;
	ulong x;
	int n;

	memset(fh, 0, FHSIZE);
	if(xp == xp-&gt;parent){	/* root */
		dataptr[0] = 0;
		dataptr[1] = 0;
		n = strlen(xp-&gt;s-&gt;service);
		if(n &gt; FHSIZE-3)
			n = FHSIZE-3;
		memmove(&amp;dataptr[2], xp-&gt;s-&gt;service, n);
		dataptr[2+n] = 0;
	}else{
		PLONG(starttime);
		PLONG((u32int)(uintptr)xp-&gt;s);
		x = xp-&gt;qid.path;
		PLONG(x);
		x = xp-&gt;qid.path&gt;&gt;32;
		PLONG(x);
		PBYTE(xp-&gt;qid.type);
		USED(dataptr);
	}
	return FHSIZE;
}

int
dir2fattr(Unixidmap *up, Dir *dp, void *mp)
{
	uchar *dataptr = mp;
	long length;
	int r;

	r = dp-&gt;mode &amp; 0777;
	if (dp-&gt;mode &amp; DMDIR)
		length = 1024;
	else
		length = dp-&gt;length;
	if((dp-&gt;mode &amp; DMDIR) &amp;&amp; dp-&gt;type == '/' &amp;&amp; dp-&gt;dev == 0)
		r |= 0555;
	if(dp-&gt;mode &amp; DMDIR){
		PLONG(NFDIR);	/* type */
		r |= S_IFDIR;
		PLONG(r);	/* mode */
		PLONG(3);	/* nlink */
	}else{
		PLONG(NFREG);	/* type */
		r |= S_IFREG;
		PLONG(r);	/* mode */
		PLONG(1);	/* nlink */
	}
	r = name2id(&amp;up-&gt;u.ids, dp-&gt;uid);
	if(r &lt; 0){
		r = name2id(&amp;up-&gt;u.ids, "daemon");
		if(r &lt; 0)
			r = 1;
	}
	PLONG(r);		/* uid */
	r = name2id(&amp;up-&gt;g.ids, dp-&gt;gid);
	if(r &lt; 0){
		r = name2id(&amp;up-&gt;g.ids, "user");
		if(r &lt; 0)
			r = 1;
	}
	PLONG(r);		/* gid */
	PLONG(length);		/* size */
	PLONG(2048);		/* blocksize */
	PLONG(0);		/* rdev */
	r = (length+2047)/2048;
	PLONG(r);		/* blocks */
	r = (dp-&gt;type&lt;&lt;16) | dp-&gt;dev;
	PLONG(r);		/* fsid */
	PLONG(dp-&gt;qid.path);	/* fileid */
	PLONG(dp-&gt;atime);	/* atime */
	PLONG(0);
	PLONG(dp-&gt;mtime);	/* mtime */
	PLONG(0);
	PLONG(dp-&gt;mtime);	/* ctime */
	PLONG(0);
	return dataptr - (uchar *)mp;
}

int
convM2sattr(void *mp, Sattr *sp)
{
	uchar *argptr = mp;

	sp-&gt;mode = GLONG();
	sp-&gt;uid = GLONG();
	sp-&gt;gid = GLONG();
	sp-&gt;size = GLONG();
	sp-&gt;atime = GLONG();
	sp-&gt;ausec = GLONG();
	sp-&gt;mtime = GLONG();
	sp-&gt;musec = GLONG();
	return argptr - (uchar *)mp;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

