<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/nfsmount.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/nfsmount.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

/*
 *	Cf. /lib/rfc/rfc1094
 */

static int	mntnull(int, Rpccall*, Rpccall*);
static int	mntmnt(int, Rpccall*, Rpccall*);
static int	mntdump(int, Rpccall*, Rpccall*);
static int	mntumnt(int, Rpccall*, Rpccall*);
static int	mntumntall(int, Rpccall*, Rpccall*);
static int	mntexport(int, Rpccall*, Rpccall*);

Procmap mntproc[] = {
	0, mntnull,
	1, mntmnt,
	2, mntdump,
	3, mntumnt,
	4, mntumntall,
	5, mntexport,
	0, 0
};

long		starttime;
static int	noauth;
char *		config;
Session *	head;
Session *	tail;
int staletime = 10*60;

void
mnttimer(long now)
{
	Session *s;

	for(s=head; s; s=s-&gt;next)
		fidtimer(s, now);
}

static void
usage(void)
{
	sysfatal("usage: %s %s [-ns] [-a dialstring] [-c uidmap] [-f srvfile] "
		"[-T staletime]", argv0, commonopts);
}

void
mntinit(int argc, char **argv)
{
	int tries;

	config = "config";
	starttime = time(0);
	clog("nfs mount server init, starttime = %lud\n", starttime);
	tries = 0;
	ARGBEGIN{
	case 'a':
		++tries;
		srvinit(-1, 0, EARGF(usage()));
		break;
	case 'c':
		config = EARGF(usage());
		break;
	case 'f':
		++tries;
		srvinit(-1, EARGF(usage()), 0);
		break;
	case 'n':
		++noauth;
		break;
	case 's':
		++tries;
		srvinit(1, 0, 0);
		break;
	case 'T':
		staletime = atoi(EARGF(usage()));
		break;
	default:
		if(argopt(ARGC()) &lt; 0)
			sysfatal("usage: %s %s [-ns] [-a dialstring] "
				"[-c uidmap] [-f srvfile] [-T staletime]",
				argv0, commonopts);
		break;
	}ARGEND
noauth=1;	/* ZZZ */
	if(tries == 0 &amp;&amp; head == 0)
		srvinit(-1, 0, "tcp!fs");
	if(head == 0)
		panic("can't initialize services");
	readunixidmaps(config);
}

void
srvinit(int fd, char *file, char *addr)
{
	char fdservice[16], *naddr;
	Session *s;
	Xfile *xp;
	Xfid *xf;
	Fid *f;

	s = calloc(1, sizeof(Session));
	s-&gt;spec = "";
	s-&gt;fd = -1;
	if(fd &gt;= 0){
		s-&gt;fd = fd;
		sprint(fdservice, "/fd/%d", s-&gt;fd);
		s-&gt;service = strstore(fdservice);
		chat("fd = %d\n", s-&gt;fd);
	}else if(file){
		chat("file = \"%s\"\n", file);
		s-&gt;service = file;
		s-&gt;fd = open(file, ORDWR);
		if(s-&gt;fd &lt; 0){
			clog("can't open %s: %r\n", file);
			goto error;
		}
	}else if(addr){
		chat("addr = \"%s\"\n", addr);
		naddr = netmkaddr(addr, 0, "9fs");
		s-&gt;service = addr;
		s-&gt;fd = dial(naddr, 0, 0, 0);
		if(s-&gt;fd &lt; 0){
			clog("can't dial %s: %r\n", naddr);
			goto error;
		}
	}

	chat("version...");
	s-&gt;tag = NOTAG-1;
	s-&gt;f.msize = Maxfdata+IOHDRSZ;
	s-&gt;f.version = "9P2000";
	xmesg(s, Tversion);
	messagesize = IOHDRSZ+s-&gt;f.msize;
	chat("version spec %s size %d\n", s-&gt;f.version, s-&gt;f.msize);

	s-&gt;tag = 0;

	chat("authenticate...");
	if(authhostowner(s) &lt; 0){
		clog("auth failed %r\n");
		goto error;
	}

	chat("attach as none...");
	f = newfid(s);
	s-&gt;f.fid = f - s-&gt;fids;
	s-&gt;f.afid = ~0x0UL;
	s-&gt;f.uname = "none";
	s-&gt;f.aname = s-&gt;spec;
	if(xmesg(s, Tattach)){
		clog("attach failed\n");
		goto error;
	}

	xp = xfile(&amp;s-&gt;f.qid, s, 1);
	s-&gt;root = xp;
	xp-&gt;parent = xp;
	xp-&gt;name = "/";
	xf = xfid("none", xp, 1);
	xf-&gt;urfid = f;
	clog("service=%s uid=%s fid=%ld\n",
		s-&gt;service, xf-&gt;uid, xf-&gt;urfid - s-&gt;fids);
	if(tail)
		tail-&gt;next = s;
	else
		head = s;
	tail = s;
	return;

error:
	if(s-&gt;fd &gt;= 0)
		close(s-&gt;fd);
	free(s);
}

static int
mntnull(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, cmd, reply);
	chat("mntnull\n");
	return 0;
}

static char*
Str2str(String s, char *buf, int nbuf)
{
	int i;
	i = s.n;
	if(i &gt;= nbuf)
		i = nbuf-1;
	memmove(buf, s.s, i);
	buf[i] = 0;
	return buf;
}

static int
mntmnt(int n, Rpccall *cmd, Rpccall *reply)
{
	int i;
	char dom[64];
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	Authunix au;
	Xfile *xp;
	String root;

	chat("mntmnt...\n");
	if(n &lt; 8)
		return garbage(reply, "n too small");
	argptr += string2S(argptr, &amp;root);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	clog("host=%I, port=%ld, root=\"%.*s\"...",
		cmd-&gt;host, cmd-&gt;port, utfnlen(root.s, root.n), root.s);
	if(auth2unix(&amp;cmd-&gt;cred, &amp;au) != 0){
		chat("auth flavor=%ld, count=%ld\n",
			cmd-&gt;cred.flavor, cmd-&gt;cred.count);
		for(i=0; i&lt;cmd-&gt;cred.count; i++)
			chat(" %.2ux", ((uchar *)cmd-&gt;cred.data)[i]);
		chat("\n");
		clog("auth: bad credentials");
		return error(reply, 1);
	}
	clog("auth: %ld %.*s u=%ld g=%ld",
		au.stamp, utfnlen(au.mach.s, au.mach.n), au.mach.s, au.uid, au.gid);
	for(i=0; i&lt;au.gidlen; i++)
		chat(", %ld", au.gids[i]);
	chat("...");
	if(getdom(cmd-&gt;host, dom, sizeof(dom))&lt;0){
		clog("auth: unknown ip address");
		return error(reply, 1);
	}
	chat("dom=%s...", dom);
	xp = xfroot(root.s, root.n);
	if(xp == 0){
		chat("xp=0...");
		clog("mntmnt: no fs");
		return error(reply, 3);
	}

	PLONG(0);
	dataptr += xp2fhandle(xp, dataptr);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
mntdump(int n, Rpccall *cmd, Rpccall *reply)
{
	if(n != 0)
		return garbage(reply, "mntdump");
	USED(cmd);
	chat("mntdump...");
	return error(reply, FALSE);
}

static int
mntumnt(int n, Rpccall *cmd, Rpccall *reply)
{
	if(n &lt;= 0)
		return garbage(reply, "mntumnt");
	USED(cmd);
	chat("mntumnt\n");
	return 0;
}

static int
mntumntall(int n, Rpccall *cmd, Rpccall *reply)
{
	if(n != 0)
		return garbage(reply, "mntumntall");
	USED(cmd);
	chat("mntumntall\n");
	return 0;
}

static int
mntexport(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *dataptr = reply-&gt;results;
	Authunix au;
	int i;

	chat("mntexport...");
	if(n != 0)
		return garbage(reply, "mntexport");
	if(auth2unix(&amp;cmd-&gt;cred, &amp;au) != 0){
		chat("auth flavor=%ld, count=%ld\n",
			cmd-&gt;cred.flavor, cmd-&gt;cred.count);
		for(i=0; i&lt;cmd-&gt;cred.count; i++)
			chat(" %.2ux", ((uchar *)cmd-&gt;cred.data)[i]);
		chat("...");
		au.mach.n = 0;
	}else
		chat("%ld@%.*s...", au.uid, utfnlen(au.mach.s, au.mach.n), au.mach.s);
	PLONG(TRUE);
	PLONG(1);
	PPTR("/", 1);
	if(au.mach.n &gt; 0){
		PLONG(TRUE);
		PLONG(au.mach.n);
		PPTR(au.mach.s, au.mach.n);
	}
	PLONG(FALSE);
	PLONG(FALSE);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

Xfile *
xfroot(char *name, int n)
{
	Session *s;
	char *p;

	if(n &lt;= 0)
		n = strlen(name);
	chat("xfroot: %.*s...", utfnlen(name, n), name);
	if(n == 1 &amp;&amp; name[0] == '/')
		return head-&gt;root;
	for(s=head; s; s=s-&gt;next){
		if(strncmp(name, s-&gt;service, n) == 0)
			return s-&gt;root;
		p = strrchr(s-&gt;service, '!');	/* for -a tcp!foo */
		if(p &amp;&amp; strncmp(name, p+1, n) == 0)
			return s-&gt;root;
		p = strrchr(s-&gt;service, '/');	/* for -f /srv/foo */
		if(p &amp;&amp; strncmp(name, p+1, n) == 0)
			return s-&gt;root;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

