<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/nfsserver.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/nfsserver.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

/*
 *	Cf. /lib/rfc/rfc1094
 */

static int	nfsnull(int, Rpccall*, Rpccall*);
static int	nfsgetattr(int, Rpccall*, Rpccall*);
static int	nfssetattr(int, Rpccall*, Rpccall*);
static int	nfsroot(int, Rpccall*, Rpccall*);
static int	nfslookup(int, Rpccall*, Rpccall*);
static int	nfsreadlink(int, Rpccall*, Rpccall*);
static int	nfsread(int, Rpccall*, Rpccall*);
static int	nfswritecache(int, Rpccall*, Rpccall*);
static int	nfswrite(int, Rpccall*, Rpccall*);
static int	nfscreate(int, Rpccall*, Rpccall*);
static int	nfsremove(int, Rpccall*, Rpccall*);
static int	nfsrename(int, Rpccall*, Rpccall*);
static int	nfslink(int, Rpccall*, Rpccall*);
static int	nfssymlink(int, Rpccall*, Rpccall*);
static int	nfsmkdir(int, Rpccall*, Rpccall*);
static int	nfsrmdir(int, Rpccall*, Rpccall*);
static int	nfsreaddir(int, Rpccall*, Rpccall*);
static int	nfsstatfs(int, Rpccall*, Rpccall*);

Procmap nfsproc[] = {
	0, nfsnull,	/* void */
	1, nfsgetattr,	/* Fhandle */
	2, nfssetattr,	/* Fhandle, Sattr */
	3, nfsroot,	/* void */
	4, nfslookup,	/* Fhandle, String */
	5, nfsreadlink,	/* Fhandle */
	6, nfsread,	/* Fhandle, long, long, long */
	7, nfswritecache,/* void */
	8, nfswrite,	/* Fhandle, long, long, long, String */
	9, nfscreate,	/* Fhandle, String, Sattr */
	10, nfsremove,	/* Fhandle, String */
	11, nfsrename,	/* Fhandle, String, Fhandle, String */
	12, nfslink,	/* Fhandle, Fhandle, String */
	13, nfssymlink,	/* Fhandle, String, String, Sattr */
	14, nfsmkdir,	/* Fhandle, String, Sattr */
	15, nfsrmdir,	/* Fhandle, String */
	16, nfsreaddir,	/* Fhandle, long, long */
	17, nfsstatfs,	/* Fhandle */
	0, 0
};

void	nfsinit(int, char**);
extern void	mntinit(int, char**);
extern Procmap	mntproc[];

Progmap progmap[] = {
	100005, 1, mntinit, mntproc,
	100003, 2, nfsinit, nfsproc,
	0, 0, 0,
};

int	myport = 2049;
long	nfstime;
int	conftime;

void
main(int argc, char *argv[])
{
	server(argc, argv, myport, progmap);
}

static void
doalarm(void)
{
	nfstime = time(0);
	mnttimer(nfstime);
	if(conftime+5*60 &lt; nfstime){
		conftime = nfstime;
		readunixidmaps(config);
	}
}

void
nfsinit(int argc, char **argv)
{
	/*
	 * mntinit will have already parsed our options.
	 */
	USED(argc, argv);
	clog("nfs file server init\n");
	rpcalarm = doalarm;
	nfstime = time(0);
}

static int
nfsnull(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, reply);
	chat("nfsnull...");
	showauth(&amp;cmd-&gt;cred);
	chat("OK\n");
	return 0;
}

static int
nfsgetattr(int n, Rpccall *cmd, Rpccall *reply)
{
	Xfid *xf;
	Dir dir;
	uchar *dataptr = reply-&gt;results;

	chat("getattr...");
	if(n != FHSIZE)
		return garbage(reply, "bad count");
	xf = rpc2xfid(cmd, &amp;dir);
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	chat("%s...", xf-&gt;xp-&gt;name);
	PLONG(NFS_OK);
	dataptr += dir2fattr(cmd-&gt;up, &amp;dir, dataptr);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfssetattr(int n, Rpccall *cmd, Rpccall *reply)
{
	Xfid *xf;
	Dir dir, nd;
	Sattr sattr;
	int r;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;

	chat("setattr...");
	if(n &lt;= FHSIZE)
		return garbage(reply, "count too small");
	xf = rpc2xfid(cmd, &amp;dir);
	argptr += FHSIZE;
	argptr += convM2sattr(argptr, &amp;sattr);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	chat("mode=0%lo,u=%ld,g=%ld,size=%ld,atime=%ld,mtime=%ld...",
		sattr.mode, sattr.uid, sattr.gid, sattr.size,
		sattr.atime, sattr.mtime);
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	if(sattr.uid != NOATTR || sattr.gid != NOATTR)
		return error(reply, NFSERR_PERM);
	if(sattr.size == 0){
		if(xf-&gt;xp-&gt;s != xf-&gt;xp-&gt;parent-&gt;s){
			if(xfauthremove(xf, cmd-&gt;user) &lt; 0)
				return error(reply, NFSERR_PERM);
		}else if(dir.length &amp;&amp; xfopen(xf, Trunc|Oread|Owrite) &lt; 0)
			return error(reply, NFSERR_PERM);
	}else if(sattr.size != NOATTR)
		return error(reply, NFSERR_PERM);
	r = 0;
	nulldir(&amp;nd);
	if(sattr.mode != NOATTR)
		++r, nd.mode = (dir.mode &amp; ~0777) | (sattr.mode &amp; 0777);
	if(sattr.atime != NOATTR)
		++r, nd.atime = sattr.atime;
	if(sattr.mtime != NOATTR)
		++r, nd.mtime = sattr.mtime;
	chat("sattr.mode=%luo dir.mode=%luo nd.mode=%luo...", sattr.mode, dir.mode, nd.mode);
	if(r){
		r = xfwstat(xf, &amp;nd);
		if(r &lt; 0)
			return error(reply, NFSERR_PERM);
	}
	if(xfstat(xf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_STALE);
	PLONG(NFS_OK);
	dataptr += dir2fattr(cmd-&gt;up, &amp;dir, dataptr);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfsroot(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, reply);
	chat("nfsroot...");
	showauth(&amp;cmd-&gt;cred);
	chat("OK\n");
	return 0;
}

static int
nfslookup(int n, Rpccall *cmd, Rpccall *reply)
{
	Xfile *xp;
	Xfid *xf, *newxf;
	String elem;
	Dir dir;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;

	chat("lookup...");
	if(n &lt;= FHSIZE)
		return garbage(reply, "count too small");
	xf = rpc2xfid(cmd, 0);
	argptr += FHSIZE;
	argptr += string2S(argptr, &amp;elem);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	xp = xf-&gt;xp;
	if(!(xp-&gt;qid.type &amp; QTDIR))
		return error(reply, NFSERR_NOTDIR);
	chat("%s -&gt; \"%.*s\"...", xp-&gt;name, utfnlen(elem.s, elem.n), elem.s);
	if(xp-&gt;s-&gt;noauth == 0 &amp;&amp; xp-&gt;parent == xp &amp;&amp; elem.s[0] == '#')
		newxf = xfauth(xp, &amp;elem);
	else
		newxf = xfwalkcr(Twalk, xf, &amp;elem, 0);
	if(newxf == 0)
		return error(reply, NFSERR_NOENT);
	if(xfstat(newxf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_IO);
	PLONG(NFS_OK);
	dataptr += xp2fhandle(newxf-&gt;xp, dataptr);
	dataptr += dir2fattr(cmd-&gt;up, &amp;dir, dataptr);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfsreadlink(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, reply);
	chat("readlink...");
	showauth(&amp;cmd-&gt;cred);
	return error(reply, NFSERR_NOENT);
}

static int
nfsread(int n, Rpccall *cmd, Rpccall *reply)
{
	Session *s;
	Xfid *xf;
	Dir dir;
	int offset, count;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	uchar *readptr = dataptr + 4 + 17*4 + 4;

	chat("read...");
	if(n != FHSIZE+12)
		return garbage(reply, "bad count");
	xf = rpc2xfid(cmd, 0);
	argptr += FHSIZE;
	offset = GLONG();
	count = GLONG();
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	chat("%s %d %d...", xf-&gt;xp-&gt;name, offset, count);
	if(xf-&gt;xp-&gt;s != xf-&gt;xp-&gt;parent-&gt;s){
		count = xfauthread(xf, offset, readptr, count);
	}else{
		if(xfopen(xf, Oread) &lt; 0)
			return error(reply, NFSERR_PERM);
		if(count &gt; 8192)
			count = 8192;
		s = xf-&gt;xp-&gt;s;
		setfid(s, xf-&gt;opfid);
		xf-&gt;opfid-&gt;tstale = nfstime + 60;
		s-&gt;f.offset = offset;
		s-&gt;f.count = count;
		if(xmesg(s, Tread) &lt; 0)
			return error(reply, NFSERR_IO);
		count = s-&gt;f.count;
		memmove(readptr, s-&gt;f.data, count);
	}
	if(xfstat(xf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_IO);
	PLONG(NFS_OK);
	dataptr += dir2fattr(cmd-&gt;up, &amp;dir, dataptr);
	PLONG(count);
	dataptr += ROUNDUP(count);
	chat("%d OK\n", count);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfswritecache(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, reply);
	chat("writecache...");
	showauth(&amp;cmd-&gt;cred);
	chat("OK\n");
	return 0;
}

static int
nfswrite(int n, Rpccall *cmd, Rpccall *reply)
{
	Session *s;
	Xfid *xf;
	Dir dir;
	int offset, count;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;

	chat("write...");
	if(n &lt; FHSIZE+16)
		return garbage(reply, "count too small");
	xf = rpc2xfid(cmd, 0);
	argptr += FHSIZE + 4;
	offset = GLONG();
	argptr += 4;
	count = GLONG();
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	chat("%s %d %d...", xf-&gt;xp-&gt;name, offset, count);
	if(xf-&gt;xp-&gt;s != xf-&gt;xp-&gt;parent-&gt;s){
		if(xfauthwrite(xf, offset, argptr, count) &lt; 0)
			return error(reply, NFSERR_IO);
	}else{
		if(xfopen(xf, Owrite) &lt; 0)
			return error(reply, NFSERR_PERM);
		s = xf-&gt;xp-&gt;s;
		setfid(s, xf-&gt;opfid);
		xf-&gt;opfid-&gt;tstale = nfstime + 60;
		s-&gt;f.offset = offset;
		s-&gt;f.count = count;
		s-&gt;f.data = (char *)argptr;
		if(xmesg(s, Twrite) &lt; 0)
			return error(reply, NFSERR_IO);
	}
	if(xfstat(xf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_IO);
	PLONG(NFS_OK);
	dataptr += dir2fattr(cmd-&gt;up, &amp;dir, dataptr);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
creat(int n, Rpccall *cmd, Rpccall *reply, int chdir)
{
	Xfid *xf, *newxf;
	Xfile *xp;
	String elem;
	Dir dir; Sattr sattr;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	int trunced;

	if(n &lt;= FHSIZE)
		return garbage(reply, "count too small");
	xf = rpc2xfid(cmd, 0);
	argptr += FHSIZE;
	argptr += string2S(argptr, &amp;elem);
	argptr += convM2sattr(argptr, &amp;sattr);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	xp = xf-&gt;xp;
	if(!(xp-&gt;qid.type &amp; QTDIR))
		return error(reply, NFSERR_NOTDIR);
	chat("%s/%.*s...", xp-&gt;name, utfnlen(elem.s, elem.n), elem.s);
	trunced = 0;
	if(xp-&gt;parent == xp &amp;&amp; elem.s[0] == '#'){
		newxf = xfauth(xp, &amp;elem);
		if(newxf == 0)
			return error(reply, NFSERR_PERM);
		if(xfauthremove(newxf, cmd-&gt;user) &lt; 0)
			return error(reply, NFSERR_PERM);
		trunced = 1;
	}else
		newxf = xfwalkcr(Twalk, xf, &amp;elem, 0);
	if(newxf == 0){
		newxf = xfwalkcr(Tcreate, xf, &amp;elem, chdir|(sattr.mode&amp;0777));
		if(newxf)
			trunced = 1;
		else
			newxf = xfwalkcr(Twalk, xf, &amp;elem, 0);
	}
	if(newxf == 0)
		return error(reply, NFSERR_PERM);
	if(!trunced &amp;&amp; chdir)
		return error(reply, NFSERR_EXIST);
	if(!trunced &amp;&amp; xfopen(newxf, Trunc|Oread|Owrite) &lt; 0)
		return error(reply, NFSERR_PERM);
	if(xfstat(newxf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_IO);

	PLONG(NFS_OK);
	dataptr += xp2fhandle(newxf-&gt;xp, dataptr);
	dataptr += dir2fattr(cmd-&gt;up, &amp;dir, dataptr);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfscreate(int n, Rpccall *cmd, Rpccall *reply)
{
	chat("create...");
	return creat(n, cmd, reply, 0);
}

static int
remov(int n, Rpccall *cmd, Rpccall *reply)
{
	Session *s;
	Xfile *xp;
	Xfid *xf, *newxf;
	String elem;
	Fid *nfid;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;

	if(n &lt;= FHSIZE)
		return garbage(reply, "count too small");
	xf = rpc2xfid(cmd, 0);
	argptr += FHSIZE;
	argptr += string2S(argptr, &amp;elem);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	xp = xf-&gt;xp;
	if(!(xp-&gt;qid.type &amp; QTDIR))
		return error(reply, NFSERR_NOTDIR);
	chat("%s/%.*s...", xp-&gt;name, utfnlen(elem.s, elem.n), elem.s);
	if(xp-&gt;s-&gt;noauth == 0 &amp;&amp; xp-&gt;parent == xp &amp;&amp; elem.s[0] == '#')
		return error(reply, NFSERR_PERM);
	newxf = xfwalkcr(Twalk, xf, &amp;elem, 0);
	if(newxf == 0)
		return error(reply, NFSERR_NOENT);
	s = xp-&gt;s;
	nfid = newfid(s);
	setfid(s, newxf-&gt;urfid);
	s-&gt;f.newfid = nfid - s-&gt;fids;
	s-&gt;f.nwname = 0;
	if(xmesg(s, Twalk) &lt; 0){
		putfid(s, nfid);
		return error(reply, NFSERR_IO);
	}
	s-&gt;f.fid = nfid - s-&gt;fids;
	if(xmesg(s, Tremove) &lt; 0){
		putfid(s, nfid);
		return error(reply, NFSERR_PERM);
	}
	putfid(s, nfid);
	xpclear(newxf-&gt;xp);
	PLONG(NFS_OK);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfsremove(int n, Rpccall *cmd, Rpccall *reply)
{
	chat("remove...");
	return remov(n, cmd, reply);
}

static int
nfsrename(int n, Rpccall *cmd, Rpccall *reply)
{
	Xfid *xf, *newxf;
	Xfile *xp;
	uchar *fromdir, *todir;
	String fromelem, toelem;
	Dir dir;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;

	chat("rename...");
	if(n &lt;= FHSIZE)
		return garbage(reply, "count too small");
	xf = rpc2xfid(cmd, 0);
	fromdir = argptr;
	argptr += FHSIZE;
	argptr += string2S(argptr, &amp;fromelem);
	todir = argptr;
	argptr += FHSIZE;
	argptr += string2S(argptr, &amp;toelem);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	xp = xf-&gt;xp;
	if(!(xp-&gt;qid.type &amp; QTDIR))
		return error(reply, NFSERR_NOTDIR);
	if(memcmp(fromdir, todir, FHSIZE) != 0)
		return error(reply, NFSERR_NXIO);
	newxf = xfwalkcr(Twalk, xf, &amp;fromelem, 0);
	if(newxf == 0)
		return error(reply, NFSERR_NOENT);
	if(xfstat(newxf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_IO);

	if(xp-&gt;parent == xp &amp;&amp; toelem.s[0] == '#')
		return error(reply, NFSERR_PERM);
	nulldir(&amp;dir);
	dir.name = toelem.s;
	if(xfwstat(newxf, &amp;dir) &lt; 0)
		return error(reply, NFSERR_PERM);
	PLONG(NFS_OK);
	chat("OK\n");
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfslink(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, reply);
	chat("link...");
	showauth(&amp;cmd-&gt;cred);
	return error(reply, NFSERR_NOENT);
}

static int
nfssymlink(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, reply);
	chat("symlink...");
	showauth(&amp;cmd-&gt;cred);
	return error(reply, NFSERR_NOENT);
}

static int
nfsmkdir(int n, Rpccall *cmd, Rpccall *reply)
{
	chat("mkdir...");
	return creat(n, cmd, reply, DMDIR);
}

static int
nfsrmdir(int n, Rpccall *cmd, Rpccall *reply)
{
	chat("rmdir...");
	return remov(n, cmd, reply);
}

static int
nfsreaddir(int n, Rpccall *cmd, Rpccall *reply)
{
	Session *s;
	Xfid *xf;
	Dir dir;
	char *rdata;
	int k, offset, count, sfcount, entries, dsize;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;

	chat("readdir...");
	if(n != FHSIZE+8)
		return garbage(reply, "bad count");
	xf = rpc2xfid(cmd, 0);
	argptr += FHSIZE;
	offset = GLONG();
	count = GLONG();
	if(xf == 0)
		return error(reply, NFSERR_STALE);
	chat("%s (%ld) %d %d...", xf-&gt;xp-&gt;name, xf-&gt;offset, offset, count);
	s = xf-&gt;xp-&gt;s;
	if((xf-&gt;mode &amp; Open) &amp;&amp; xf-&gt;offset &gt; offset)
		xfclose(xf);
	if(xfopen(xf, Oread) &lt; 0)
		return error(reply, NFSERR_PERM);
	while(xf-&gt;offset &lt; offset){	/* if we reopened, xf-&gt;offset will be zero */
		sfcount = offset - xf-&gt;offset;
		if(sfcount &gt; messagesize-IOHDRSZ)
			sfcount = messagesize-IOHDRSZ;
		setfid(s, xf-&gt;opfid);
		s-&gt;f.offset = xf-&gt;offset;
		s-&gt;f.count = sfcount;
		if(xmesg(s, Tread) &lt; 0){
			xfclose(xf);
			return error(reply, NFSERR_IO);
		}
		if(s-&gt;f.count &lt;= BIT16SZ)
			break;
		xf-&gt;offset += s-&gt;f.count;
	}
	if(count &gt; messagesize-IOHDRSZ)
		count = messagesize-IOHDRSZ;
	PLONG(NFS_OK);
	entries = 0;
	while(count &gt; 16){	/* at least 16 bytes required; we don't know size of name */
chat("top of loop\n");
		setfid(s, xf-&gt;opfid);
		s-&gt;f.offset = xf-&gt;offset;
		s-&gt;f.count = count;	/* as good a guess as any */
		if(xmesg(s, Tread) &lt; 0){
			xfclose(xf);
			return error(reply, NFSERR_IO);
		}
		sfcount = s-&gt;f.count;
		if(sfcount &lt;= BIT16SZ)
			break;
		xf-&gt;offset += sfcount;
chat("count %d data 0x%p\n", s-&gt;f.count, s-&gt;f.data);
		rdata = s-&gt;f.data;
		/* now have a buffer of Plan 9 directories; unpack into NFS thingies */
		while(sfcount &gt;= 0){
			dsize = convM2D((uchar*)rdata, sfcount, &amp;dir, (char*)s-&gt;statbuf);
			if(dsize &lt;= BIT16SZ){
				count = 0;	/* force break from outer loop */
				break;
			}
			offset += dsize;
			k = strlen(dir.name);
			if(count &lt; 16+ROUNDUP(k)){
				count = 0;	/* force break from outer loop */
				break;
			}
			PLONG(TRUE);
			PLONG(dir.qid.path);
			PLONG(k);
			PPTR(dir.name, k);
			PLONG(offset);
			count -= 16+ROUNDUP(k);
			rdata += dsize;
			sfcount -= dsize;
		}
	}
	PLONG(FALSE);
	if(s-&gt;f.count &lt;= 0){
		xfclose(xf);
		chat("eof...");
		PLONG(TRUE);
	}else
		PLONG(FALSE);
	chat("%d OK\n", entries);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
nfsstatfs(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *dataptr = reply-&gt;results;
	enum {
		Xfersize = 2048,
		Maxlong = (long)((1ULL&lt;&lt;31) - 1),
		Maxfreeblks = Maxlong / Xfersize,
	};

	chat("statfs...");
	showauth(&amp;cmd-&gt;cred);
	if(n != FHSIZE)
		return garbage(reply, "bad count");
	PLONG(NFS_OK);
	PLONG(4096);		/* tsize (fs block size) */
	PLONG(Xfersize);	/* bsize (optimal transfer size) */
	PLONG(Maxfreeblks);	/* blocks in fs */
	PLONG(Maxfreeblks);	/* bfree to root*/
	PLONG(Maxfreeblks);	/* bavail (free to mortals) */
	chat("OK\n");
	/*conftime = 0;
	readunixidmaps(config);*/
	return dataptr - (uchar *)reply-&gt;results;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

