<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/pcnfsd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/pcnfsd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

static void	pcinit(int, char**);
static int	pcnull(int, Rpccall*, Rpccall*);
static int	pcinfo(int, Rpccall*, Rpccall*);
static int	pcauth(int, Rpccall*, Rpccall*);
static int	pc1auth(int, Rpccall*, Rpccall*);
static int	pcfacilities[15];
static char	no_comment[] = "Trust me.";
static char	pc_vers[] = "@(#)pcnfsd_v2.c	1.6 - rpc.pcnfsd V2.0 (c) 1994 P9, GmbH";
static char	pc_home[] = "merrimack:/";

static Procmap pcproc[] = {	/* pcnfsd v2 */
	0, pcnull,
	1, pcinfo,
	13, pcauth,
	0, 0
};

static Procmap pc1proc[] = { 	/* pc-nfsd v1 */
	0, pcnull,
	1, pc1auth,
	0, 0
};

int	myport = 1111;

Progmap progmap[] = {
	150001, 2, pcinit, pcproc,
	150001, 1, 0, pc1proc,
	0, 0, 0,
};

void
main(int argc, char *argv[])
{
	server(argc, argv, myport, progmap);
}

static void
pcinit(int argc, char **argv)
{
	Procmap *p;
	int i;
	char *config = "config";

	ARGBEGIN{
	case 'c':
		config = ARGF();
		break;
	default:
		if(argopt(ARGC()) &lt; 0)
			sysfatal("usage: %s %s [-c config]", argv0, commonopts);
		break;
	}ARGEND;
	clog("pc init\n");

	for(i=0; i&lt;nelem(pcfacilities); i++)
		pcfacilities[i] = -1;
	for(p=pcproc; p-&gt;procp; p++)
		pcfacilities[p-&gt;procno] = 100;
	readunixidmaps(config);
}

static int
pcnull(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, cmd, reply);
	return 0;
}

static void
scramble(String *x)
{
	int i;

	for(i=0; i&lt;x-&gt;n; i++)
		x-&gt;s[i] = (x-&gt;s[i] ^ 0x5b) &amp; 0x7f;
}

static int
pcinfo(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	String vers, cm;
	int i;

	chat("host=%I, port=%ld: pcinfo...",
		cmd-&gt;host, cmd-&gt;port);
	if(n &lt;= 16)
		return garbage(reply, "count too small");
	argptr += string2S(argptr, &amp;vers);
	argptr += string2S(argptr, &amp;cm);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	chat("\"%.*s\",\"%.*s\"\n", utfnlen(vers.s, vers.n), vers.s, utfnlen(cm.s, cm.n), cm.s);
	PLONG(sizeof(pc_vers)-1);
	PPTR(pc_vers, sizeof(pc_vers)-1);
	PLONG(sizeof(no_comment)-1);
	PPTR(no_comment, sizeof(no_comment)-1);
	PLONG(nelem(pcfacilities));
	for(i=0; i&lt;nelem(pcfacilities); i++)
		PLONG(pcfacilities[i]);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
pc1auth(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	String id, pw;
	Unixidmap *m;
	int uid;

	chat("host=%I, port=%ld: pcauth...",
		cmd-&gt;host, cmd-&gt;port);
	if(n &lt;= 8)
		return garbage(reply, "count too small");
	argptr += string2S(argptr, &amp;id);
	argptr += string2S(argptr, &amp;pw);
	if(argptr != &amp;((uchar*)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	scramble(&amp;id);
	scramble(&amp;pw);
	m = pair2idmap("pcnfsd", cmd-&gt;host);
	uid = -1;
	if(m)
		uid = name2id(&amp;m-&gt;u.ids, id.s);
	if(uid &lt; 0)
		uid = 1;
	chat("\"%.*s\",\"%.*s\" uid=%d\n", utfnlen(id.s, id.n), id.s, utfnlen(pw.s, pw.n), pw.s, uid);
	PLONG(0);	/* status */
	PLONG(uid);	/* uid */
	PLONG(uid);	/* gid */
	return dataptr - (uchar*)reply-&gt;results;
}

static int
pcauth(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	String sys, id, pw, cm;
	Unixidmap *m;
	int uid;

	chat("host=%I, port=%ld: pcauth...",
		cmd-&gt;host, cmd-&gt;port);
	if(n &lt;= 16)
		return garbage(reply, "count too small");
	argptr += string2S(argptr, &amp;sys);
	argptr += string2S(argptr, &amp;id);
	argptr += string2S(argptr, &amp;pw);
	argptr += string2S(argptr, &amp;cm);
	if(argptr != &amp;((uchar *)cmd-&gt;args)[n])
		return garbage(reply, "bad count");
	scramble(&amp;id);
	scramble(&amp;pw);

	m = pair2idmap("pcnfsd", cmd-&gt;host);
	uid = -1;
	if(m)
		uid = name2id(&amp;m-&gt;u.ids, id.s);
	if(uid &lt; 0)
		uid = 1;
	chat("\"%.*s\",\"%.*s\",\"%.*s\",\"%.*s\"\n", utfnlen(sys.s, sys.n), sys.s,
		utfnlen(id.s, id.n), id.s, utfnlen(pw.s, pw.n), pw.s, utfnlen(cm.s, cm.n), cm.s);
	PLONG(0);	/* status - OK */
	PLONG(uid);
	PLONG(uid);	/* gid */
	PLONG(0);	/* ngids */
	PLONG(sizeof(pc_home)-1);
	PPTR(pc_home, sizeof(pc_home)-1);
	PLONG(0);	/* umask */
	PLONG(sizeof(no_comment)-1);
	PPTR(no_comment, sizeof(no_comment)-1);
	return dataptr - (uchar *)reply-&gt;results;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

