<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/portmapper.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/portmapper.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * sunrpc portmapper
 */
#include "all.h"

typedef struct Portmap	Portmap;
struct Portmap
{
	int	prog;
	int	vers;
	int	protocol;
	int	port;
};

Portmap map[] = {
	100003, 2, IPPROTO_UDP, 2049,	/* nfs v2 */
//	100003, 3, IPPROTO_UDP, 2049,	/* nfs v3 */
	100005, 1, IPPROTO_UDP, 2049,	/* mount */
	150001, 2, IPPROTO_UDP, 1111,	/* pcnfsd v2 */
	150001, 1, IPPROTO_UDP, 1111,	/* pcnfsd v1 */
	0, 0, 0, 0,
};

static void	pmapinit(int, char**);
static int	pmapnull(int, Rpccall*, Rpccall*);
static int	pmapset(int, Rpccall*, Rpccall*);
static int	pmapunset(int, Rpccall*, Rpccall*);
static int	pmapgetport(int, Rpccall*, Rpccall*);
static int	pmapdump(int, Rpccall*, Rpccall*);
static int	pmapcallit(int, Rpccall*, Rpccall*);

static Procmap pmapproc[] = {
	0, pmapnull,
	1, pmapset,
	2, pmapunset,
	3, pmapgetport,
	4, pmapdump,
	5, pmapcallit,
	0, 0
};

int	myport = 111;

Progmap progmap[] = {
	100000, 2, pmapinit, pmapproc,
	0, 0, 0,
};

void
main(int argc, char *argv[])
{
	server(argc, argv, myport, progmap);
}

static
void
pmapinit(int argc, char **argv)
{
	ARGBEGIN{
	default:
		if(argopt(ARGC()) &lt; 0)
			sysfatal("usage: %s %s", argv0, commonopts);
		break;
	}ARGEND;
	clog("portmapper init\n");
}

static int
pmapnull(int n, Rpccall *cmd, Rpccall *reply)
{
	USED(n, cmd, reply);
	return 0;
}

static int
pmapset(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *dataptr = reply-&gt;results;

	if(n != 16)
		return garbage(reply, "bad count");
	USED(cmd);
	PLONG(FALSE);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
pmapunset(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *dataptr = reply-&gt;results;

	if(n != 16)
		return garbage(reply, "bad count");
	USED(cmd);
	PLONG(TRUE);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
pmapgetport(int n, Rpccall *cmd, Rpccall *reply)
{
	int prog, vers, prot;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	Portmap *mp;

	clog("get port\n");

	if(n != 16)
		return garbage(reply, "bad count");
	prog = GLONG();
	vers = GLONG();
	prot = GLONG();
	chat("host=%I, port=%ld: ", cmd-&gt;host, cmd-&gt;port);
	chat("getport: %d, %d, %d...", prog, vers, prot);
	for(mp=map; mp-&gt;prog&gt;0; mp++)
		if(prog == mp-&gt;prog &amp;&amp; vers == mp-&gt;vers &amp;&amp;
		   prot == mp-&gt;protocol)
			break;
	chat("%d\n", mp-&gt;port);
	PLONG(mp-&gt;port);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
pmapdump(int n, Rpccall *cmd, Rpccall *reply)
{
	uchar *dataptr = reply-&gt;results;
	Portmap *mp;

	if(n != 0)
		return garbage(reply, "bad count");
	USED(cmd);
	for(mp=map; mp-&gt;prog&gt;0; mp++){
		PLONG(1);
		PLONG(mp-&gt;prog);
		PLONG(mp-&gt;vers);
		PLONG(mp-&gt;protocol);
		PLONG(mp-&gt;port);
	}
	PLONG(0);
	return dataptr - (uchar *)reply-&gt;results;
}

static int
pmapcallit(int n, Rpccall *cmd, Rpccall *reply)
{
	int prog, vers, proc;
	uchar *argptr = cmd-&gt;args;
	uchar *dataptr = reply-&gt;results;
	Portmap *mp;

	if(n &lt; 12)
		return garbage(reply, "bad count");
	prog = GLONG();
	vers = GLONG();
	proc = GLONG();
	chat("host=%I, port=%ld: ", cmd-&gt;host, cmd-&gt;port);
	chat("callit: %d, %d, %d...", prog, vers, proc);
	for(mp=map; mp-&gt;prog&gt;0; mp++)
		if(prog == mp-&gt;prog &amp;&amp; vers == mp-&gt;vers &amp;&amp;
		   proc == 0)
			break;
	if(mp-&gt;port == 0){
		chat("ignored\n");
		return -1;
	}
	chat("%d\n", mp-&gt;port);
	PLONG(mp-&gt;port);
	PLONG(0);
	return dataptr - (uchar *)reply-&gt;results;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

