<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/exec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/exec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include "dat.h"
#include "fns.h"

void	del(Text *, Text *, int, int, Rune *, int);
void	delcol(Text *, Text *, int, int, Rune *, int);
void	cut(Text *, Text *, int, int, Rune *, int);
void	exit(Text *, Text *, int, int, Rune *, int);
void	get(Text *, Text *, int, int, Rune *, int);
void	go(Text *,Text *,  int, int, Rune *, int);
void	google(Text *,Text *,  int, int, Rune *, int);
void	new(Text*, Text *, int, int, Rune *, int);
void	newcol(Text*, Text *, int, int, Rune *, int);
void	paste(Text *, Text *, int, int, Rune *, int);
void	sort(Text *, Text *, int, int, Rune *, int);
void	stop(Text *, Text *, int, int, Rune *, int);
void	debug(Text *, Text *, int, int, Rune *, int);

typedef struct Exectab Exectab;
struct Exectab
{
	Rune	*name;
	void	(*fn)(Text *, Text *, int, int, Rune *, int);
	int		flag1;
	int		flag2;
};

Exectab exectab[] = {
	{ L"Back",		go,		FALSE,	XXX		},
	{ L"Cut",		cut,		TRUE,	TRUE	},
	{ L"Debug",	debug,	XXX,		XXX		},
	{ L"Del",		del,		XXX,		XXX		},
	{ L"Delcol",	delcol,	FALSE,	TRUE	},
	{ L"Exit",		exit,		XXX,		XXX		},
	{ L"Get",		get,		XXX,		XXX		},
	{ L"Google",	google,	XXX,		XXX		},
	{ L"New",		new,		XXX,		XXX		},
	{ L"Newcol",	newcol,	XXX,		XXX		},
	{ L"Next",		go,		TRUE,	XXX		},
	{ L"Paste",		paste,	TRUE,	XXX		},
	{ L"Snarf",		cut,		TRUE,	FALSE	},
	{ L"Stop",		stop,		XXX,		XXX		},
	{ L"Sort",		sort,		XXX,		XXX		},
	{ nil, 			nil,		0,		0		},
};

static
Exectab*
lookup(Rune *r, int n)
{
	Exectab *e;
	int nr;

	r = skipbl(r, n, &amp;n);
	if(n == 0)
		return nil;
	findbl(r, n, &amp;nr);
	nr = n-nr;
	for(e=exectab; e-&gt;name; e++)
		if(runeeq(r, nr, e-&gt;name, runestrlen(e-&gt;name)) == TRUE)
			return e;
	return nil;
}

int
isexecc(int c)
{
	if(isalnum(c))
		return 1;
	return c=='&lt;' || c=='|' || c=='&gt;';
}

void
execute(Text *t, uint aq0, uint aq1, Text *)
{
	uint q0, q1;
	Rune *r, *s;
	Exectab *e;
	int c, n;

	q0 = aq0;
	q1 = aq1;
	if(q1 == q0){	/* expand to find word (actually file name) */
		/* if in selection, choose selection */
		if(t-&gt;q1&gt;t-&gt;q0 &amp;&amp; t-&gt;q0&lt;=q0 &amp;&amp; q0&lt;=t-&gt;q1){
			q0 = t-&gt;q0;
			q1 = t-&gt;q1;
		}else{
			while(q1&lt;t-&gt;rs.nr &amp;&amp; isexecc(c=t-&gt;rs.r[q1]) &amp;&amp; c!=':')
				q1++;
			while(q0&gt;0 &amp;&amp; isexecc(c=t-&gt;rs.r[q0-1]) &amp;&amp; c!=':')
				q0--;
			if(q1 == q0)
				return;
		}
	}
	r = runemalloc(q1-q0);
	runemove(r, t-&gt;rs.r+q0, q1-q0);
	e = lookup(r, q1-q0);
	if(e){
		s = skipbl(r, q1-q0, &amp;n);
		s = findbl(s, n, &amp;n);
		s = skipbl(s, n, &amp;n);
		(*e-&gt;fn)(t, seltext, e-&gt;flag1, e-&gt;flag2, s, n);
	}
	free(r);
}

void
newcol(Text *et, Text *, int, int, Rune *, int)
{
	Column *c;

	c = rowadd(et-&gt;row, nil, -1);
	if(c)
		winsettag(coladd(c, nil, nil, -1));
}

void
delcol(Text *t, Text *, int, int, Rune *, int)
{
	Column *c;

	c = t-&gt;col;
	if(c==nil || colclean(c)==0)
		return;

	rowclose(c-&gt;row, c, TRUE);
}

void
del(Text *et, Text *, int flag1, int, Rune *, int)
{
	if(et-&gt;w==nil)
		return;

	if(flag1 || winclean(et-&gt;w, FALSE))
		colclose(et-&gt;col, et-&gt;w, TRUE);
}

void
sort(Text *et, Text *, int, int, Rune *, int)
{
	if(et-&gt;col)
		colsort(et-&gt;col);
}

void
exit(Text *, Text *, int, int, Rune *, int)
{
	sendul(cexit, 0);
	threadexits(nil);
}

void
debug(Text *, Text *, int, int, Rune *, int)
{
	Column *c;
	int i, j;

	for(j=0; j&lt;row.ncol; j++){
		c = row.col[j];
		for(i=0; i&lt;c-&gt;nw; i++){
			fprint(2, "Col: %d; Win: %d\n", j, i);
			windebug(c-&gt;w[i]);
		}
	}
}

void
stop(Text *t, Text *, int, int, Rune *, int)
{
	if(t==nil || t-&gt;w==nil)
		return;

	pageabort(&amp;t-&gt;w-&gt;page);
}

void
get(Text *t, Text *, int, int, Rune *, int)
{
	Window *w;
	int dohist;

	if(t==nil || t-&gt;w==nil)
		return;
	w = t-&gt;w;
	if(w-&gt;url.rs.nr == 0)
		return;

	dohist = FALSE;
	if(w-&gt;page.url==nil || runestreq(w-&gt;page.url-&gt;act, w-&gt;url.rs)==FALSE)
		dohist = TRUE;

	pageget(&amp;w-&gt;page, &amp;w-&gt;url.rs, nil, HGet, dohist);
}

void
go(Text *et, Text *t, int isnext, int, Rune *, int)
{
	if(et!=nil &amp;&amp; et-&gt;w!=nil)
		t = et;
	if(t==nil || t-&gt;w==nil)
		return;

	wingohist(t-&gt;w, isnext);
}

void
cut(Text *, Text *t, int dosnarf, int docut, Rune *, int)
{
	Runestr rs;
	uint u;

	if(selpage){
		if(dosnarf &amp;&amp; !docut &amp;&amp; !eqpt(selpage-&gt;top, selpage-&gt;bot))
			pagesnarf(selpage);
		return;
	}
	if(t==nil){
		/* can only happen if seltext == nil */
		return;
	}
	if(t-&gt;q0 &gt; t-&gt;q1){
		u = t-&gt;q0;
		t-&gt;q0 = t-&gt;q1;
		t-&gt;q1 =u;
	}

	if(t-&gt;q0 == t-&gt;q1)
		return;

	if(dosnarf){
		rs.nr = t-&gt;q1-t-&gt;q0;
		rs.r = runemalloc(rs.nr);
		runemove(rs.r, t-&gt;rs.r+t-&gt;q0, rs.nr);
		putsnarf(&amp;rs);
		closerunestr(&amp;rs);
	}
	if(docut){
		textdelete(t, t-&gt;q0, t-&gt;q1);
		textsetselect(t, t-&gt;q0, t-&gt;q0);
		if(t-&gt;w)
			textscrdraw(t);
	}else if(dosnarf)	/* Snarf command */
		argtext = t;
}

void
paste(Text *, Text *t, int selectall, int, Rune *, int)
{
	Runestr rs;
	uint q1;

	if(t == nil)
		return;

	getsnarf(&amp;rs);
	if(rs.nr == 0)
		return;

	cut(t, t, FALSE, TRUE, nil, 0);
	textinsert(t, t-&gt;q0, rs.r, rs.nr);
	q1 = t-&gt;q0+rs.nr;
	if(selectall)
		textsetselect(t, t-&gt;q0, q1);
	else
		textsetselect(t, q1, q1);
	if(t-&gt;w)
		textscrdraw(t);

	closerunestr(&amp;rs);
}

typedef	struct	Expand Expand;

struct Expand
{
	uint	q0;
	uint	q1;
	Rune	*name;
	int	nname;
	int	jump;
	union{
		Text	*at;
		Rune	*ar;
	};
	int	(*agetc)(void*, uint);
	int	a0;
	int	a1;
};

int
expand(Text *t, uint q0, uint q1, Expand *e)
{
	memset(e, 0, sizeof *e);

	/* if in selection, choose selection */
	e-&gt;jump = TRUE;
	if(q1==q0 &amp;&amp; t-&gt;q1&gt;t-&gt;q0 &amp;&amp; t-&gt;q0&lt;=q0 &amp;&amp; q0&lt;=t-&gt;q1){
		q0 = t-&gt;q0;
		q1 = t-&gt;q1;
		if(t-&gt;what == Tag)
			e-&gt;jump = FALSE;
	}
	if(q0 == q1){
		while(q1&lt;t-&gt;rs.nr &amp;&amp; isalnum(t-&gt;rs.r[q1]))
			q1++;
		while(q0&gt;0 &amp;&amp; isalnum(t-&gt;rs.r[q0-1]))
			q0--;
	}
	e-&gt;q0 = q0;
	e-&gt;q1 = q1;
	return q1 &gt; q0;
}

void
look3(Text *t, uint q0, uint q1)
{
	Expand e;
	Text *ct;
	Runestr rs;
	char buf[32];
	Rune *r, c;
	uint p;
	int n;

	ct = seltext;
	if(ct == nil)
		ct = seltext = t;
	if(expand(t, q0, q1, &amp;e) == FALSE)
		return;
	if(plumbsendfd &gt;= 0){
		/* send whitespace-delimited word to plumber */
		buf[0] = '\0';
		if(q1 == q0){
			if(t-&gt;q1&gt;t-&gt;q0 &amp;&amp; t-&gt;q0&lt;=q0 &amp;&amp; q0&lt;=t-&gt;q1){
				q0 = t-&gt;q0;
				q1 = t-&gt;q1;
			}else{
				p = q0;
				while(q0&gt;0 &amp;&amp; (c=t-&gt;rs.r[q0-1])!=L' ' &amp;&amp; c!=L'\t' &amp;&amp; c!=L'\n')
					q0--;
				while(q1&lt;t-&gt;rs.nr &amp;&amp; (c=t-&gt;rs.r[q1])!=L' ' &amp;&amp; c!=L'\t' &amp;&amp; c!=L'\n')
					q1++;
				if(q1 == q0)
					return;
				sprint(buf, "click=%d", p-q0);
			}
		}
		rs.r = runemalloc(q1-q0);
		runemove(rs.r, t-&gt;rs.r+q0, q1-q0);
		rs.nr = q1-q0;
		if(plumbrunestr(&amp;rs, buf) &gt;= 0){
			closerunestr(&amp;rs);
			return;
		}
		/* plumber failed to match; fall through */
	}
	if(t == ct)
		textsetselect(ct, e.q1, e.q1);
	n = e.q1 - e.q0;
	r = runemalloc(n);
	runemove(r, t-&gt;rs.r+e.q0, n);
	if(search(ct, r, n) &amp;&amp; e.jump)
		moveto(mousectl, addpt(frptofchar(ct, ct-&gt;p0), Pt(4, ct-&gt;font-&gt;height-4)));

	free(r);
}

int
search(Text *ct, Rune *r, uint n)
{
	uint q, nb, maxn;
	int around;
	Rune *s, *b, *c;

	if(n==0 || n&gt;ct-&gt;rs.nr || 2*n&gt;RBUFSIZE)
		return FALSE;

	maxn = max(n*2, RBUFSIZE);
	s = runemalloc(RBUFSIZE);
	b = s;
	nb = 0;
	b[nb] = 0;
	around = 0;
	q = ct-&gt;q1;
	for(;;){
		if(q &gt;= ct-&gt;rs.nr){
			q = 0;
			around = 1;
			nb = 0;
			b[nb] = 0;
		}
		if(nb &gt; 0){
			c = runestrchr(b, r[0]);
			if(c == nil){
				q += nb;
				nb = 0;
				b[nb] = 0;
				if(around &amp;&amp; q&gt;=ct-&gt;q1)
					break;
				continue;
			}
			q += (c-b);
			nb -= (c-b);
			b = c;
		}
		/* reload if buffer covers neither string nor rest of file */
		if(nb&lt;n &amp;&amp; nb!=ct-&gt;rs.nr-q){
			nb = ct-&gt;rs.nr-q;
			if(nb &gt;= maxn)
				nb = maxn-1;
			runemove(s, ct-&gt;rs.r+q, nb);
			b = s;
			b[nb] = '\0';
		}
		/* this runeeq is fishy but the null at b[nb] makes it safe */
		if(runeeq(b, n, r, n) == TRUE){
			if(ct-&gt;w)
				textshow(ct, q, q+n, 1);
			else{
				ct-&gt;q0 = q;
				ct-&gt;q1 = q+n;
			}
			seltext = ct;
			free(s);
			return TRUE;
		}
		if(around &amp;&amp; q&gt;=ct-&gt;q1)
			break;
		--nb;
		b++;
		q++;
	}
	free(s);
	return FALSE;
}

Window*
lookpage(Rune *s, int n)
{
	int i, j;
	Window *w;
	Column *c;
	Page *p;

	/* avoid terminal slash on directories */
	if(n&gt;1 &amp;&amp; s[n-1] == '/')
		--n;
	for(j=0; j&lt;row.ncol; j++){
		c = row.col[j];
		for(i=0; i&lt;c-&gt;nw; i++){
			w = c-&gt;w[i];
			p = &amp;w-&gt;page;
			if(p-&gt;url &amp;&amp; runeeq(p-&gt;url-&gt;src.r, p-&gt;url-&gt;src.nr, s, n))
				if(w-&gt;col != nil)
					return w;
		}
	}
	return nil;
}

Window *
openpage(Page *p, Runestr *rs)
{
	Window *w;

	if(!validurl(rs-&gt;r))
		return nil;

	w = lookpage(rs-&gt;r, rs-&gt;nr);
	if(w){
		p = &amp;w-&gt;page;
		if(!p-&gt;col-&gt;safe &amp;&amp; Dy(p-&gt;r)==0) /* window is obscured by full-column window */
			colgrow(p-&gt;col, p-&gt;col-&gt;w[0], 1);
	}else{
		w = makenewwindow(p);
		winsettag(w);
		pageget(&amp;w-&gt;page, rs, nil, HGet, TRUE);
	}
	return w;
}

void
plumblook(Plumbmsg *m)
{
	Runestr rs;

	if(m-&gt;ndata &gt;= BUFSIZE){
		fprint(2, "insanely long file name (%d bytes) in plumb message (%.32s...)\n", m-&gt;ndata, m-&gt;data);
		return;
	}
	if(m-&gt;data[0] == '\0')
		return;

	bytetorunestr(m-&gt;data, &amp;rs);
	openpage(nil, &amp;rs);
	closerunestr(&amp;rs);
}

void
new(Text *et, Text *, int, int, Rune *, int)
{
	if(et-&gt;col != nil)
		winsettag(coladd(et-&gt;col, nil, nil, -1));
}

void
google(Text *, Text *, int, int, Rune *arg, int narg)
{
	Runestr rs;
	Rune *s;

	s = ucvt(arg);
	rs.r = runesmprint("http://www.google.com/search?hl=en&amp;ie=UTF-8&amp;q=%.*S", narg, s);
	rs.nr = runestrlen(rs.r);
	openpage(nil, &amp;rs);
	free(s);
	closerunestr(&amp;rs);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

