<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/page.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/page.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include "dat.h"
#include "fns.h"

static void pageload1(Page *, Url *, int);

static
void
addchild(Page *p, Page *c)
{
	Page *t;

	c-&gt;parent = p;
	c-&gt;w = p-&gt;w;
	c-&gt;b = p-&gt;b;
	c-&gt;col = p-&gt;col;
	c-&gt;row = p-&gt;row;
	if(p-&gt;child == nil)
		p-&gt;child = c;
	else{
		for(t=p-&gt;child; t-&gt;next!=nil; t=t-&gt;next)
			;
		t-&gt;next = c;
	}
}

static
void
loadchilds(Page *p, Kidinfo *k)
{
	Runestr rs;
	Kidinfo *t;
	Page *c;

	addrefresh(p, "loading frames...");
	p-&gt;kidinfo = k;
	for(t=k-&gt;kidinfos; t!=nil; t=t-&gt;next){
		c = emalloc(sizeof(Page));
		addchild(p, c);
		if(t-&gt;isframeset){
			c-&gt;url = urldup(p-&gt;url);
			loadchilds(c, t);
		}else{
			c-&gt;kidinfo = t;
			/* this check shouldn't be necessary, but... */
			if(t-&gt;src){
				rs.r = urlcombine(p-&gt;url-&gt;act.r, t-&gt;src);
				rs.nr = runestrlen(rs.r);
				pageload1(c, urlalloc(&amp;rs, nil, HGet), FALSE);
				closerunestr(&amp;rs);
			}
		}
	}
}

static struct {
	char *mime;
	char *filter;
}filtertab[] = {
	"image/gif",	"gif -t9",
	"image/jpeg",	"jpg -t9",
	"image/jpg",	"jpg -t9",
	"image/pjpeg",	"jpg -t9",
	"image/png",	"png -t9",
	"image/ppm",	"ppm -t9",
	nil,	nil,
};

char *
getfilter(Rune *r, int x, int y)
{
	char buf[128];
	int i;

	snprint(buf, sizeof(buf), "%S", r);
	for(i=0; filtertab[i].mime!=nil; i++)
		if(cistrncmp(buf, filtertab[i].mime, strlen(filtertab[i].mime)) == 0)
			break;

	if(filtertab[i].filter == nil)
		return nil;

	if(x==0 &amp;&amp; y==0)
		return smprint("%s", filtertab[i].filter);
	if(x!=0 &amp;&amp; y!=0)
		return smprint("%s | resample -x %d -y %d", filtertab[i].filter, x, y);
	if(x != 0)
		return smprint("%s | resample -x %d", filtertab[i].filter, x);
	/* y != 0 */
	return smprint("%s | resample -y %d", filtertab[i].filter, y);
}

static Cimage *cimages = nil;
static QLock cimagelock;

static
void
freecimage(Cimage *ci)
{
	Cimage *ci1;

	qlock(&amp;cimagelock);
	if(decref(ci) == 0){
		if(ci-&gt;i)
			freeimage(ci-&gt;i);
		else if(ci-&gt;mi)
			freememimage(ci-&gt;mi);
		urlfree(ci-&gt;url);
		ci1 = cimages;
		if(ci1 == ci)
			cimages = ci-&gt;next;
		else{
			while(ci1){
				if(ci1-&gt;next == ci){
					ci1-&gt;next = ci-&gt;next;
					break;
				}
				ci1 = ci1-&gt;next;
			}
		}
		free(ci);
	}
	qunlock(&amp;cimagelock);
}

static
void
closeimages(Page *p)
{
	int i;

	for(i=0; i&lt;p-&gt;ncimage; i++)
		freecimage(p-&gt;cimage[i]);
	free(p-&gt;cimage);
	p-&gt;cimage =nil;
	p-&gt;ncimage = 0;
}

static
Cimage *
loadimg(Rune *src, int x , int y)
{
	Channel *sync;
	Cimage *ci;
	Runestr rs;
	Exec *e;
	char *filter;
	int fd, p[2], q[2];

	ci = emalloc(sizeof(Cimage));
	rs. r = src;
	rs.nr = runestrlen(rs.r);
	ci-&gt;url = urlalloc(&amp;rs, nil, HGet);
	fd = urlopen(ci-&gt;url);
	if(fd &lt; 0){
    Err1:
		return ci;
	}
	filter = getfilter(ci-&gt;url-&gt;ctype.r, x, y);
	if(filter == nil){
		werrstr("%S unsupported: %S", ci-&gt;url-&gt;ctype.r, ci-&gt;url-&gt;act.r);
    Err2:
		close(fd);
		goto Err1;
	}

	if(pipe(p)&lt;0 || pipe(q)&lt;0)
		error("can't create pipe");
	close(p[0]);
	p[0] = fd;
	sync = chancreate(sizeof(ulong), 0);
	if(sync == nil)
		error("can't create channel");
	e = emalloc(sizeof(Exec));
	e-&gt;p[0] = p[0];
	e-&gt;p[1] = p[1];
	e-&gt;q[0] = q[0];
	e-&gt;q[1] = q[1];
	e-&gt;cmd = filter;
	e-&gt;sync = sync;
	proccreate(execproc, e, STACK);
	recvul(sync);
	chanfree(sync);
	close(p[0]);
	close(p[1]);
	close(q[1]);

	ci-&gt;mi = readmemimage(q[0]);
	close(q[0]);
	if(ci-&gt;mi == nil){
		werrstr("can't read image");
		goto Err2;
	}
	free(filter);
	return ci;
}

static
Cimage *
findimg(Rune *s)
{
	Cimage *ci;

	qlock(&amp;cimagelock);
	for(ci=cimages; ci!=nil; ci=ci-&gt;next)
		if(runestrcmp(ci-&gt;url-&gt;src.r, s) == 0)
			break;

	qunlock(&amp;cimagelock);
	return ci;
}

void
loadimages(Page *p)
{
	Cimage *ci;
	Iimage *i;
	Rune *src;

	addrefresh(p, "loading images...");
	reverseimages(&amp;p-&gt;doc-&gt;images);
	for(i=p-&gt;doc-&gt;images; i!=nil; i=i-&gt;nextimage){
		if(p-&gt;aborting)
			break;
		src = urlcombine(getbase(p), i-&gt;imsrc);
		ci = findimg(src);
		if(ci == nil){
			ci = loadimg(src, i-&gt;imwidth, i-&gt;imheight);
			qlock(&amp;cimagelock);
			ci-&gt;next = cimages;
			cimages = ci;
			qunlock(&amp;cimagelock);
		}
		free(src);
		incref(ci);
		i-&gt;aux = ci;
		p-&gt;cimage = erealloc(p-&gt;cimage, ++p-&gt;ncimage*sizeof(Cimage *));
		p-&gt;cimage[p-&gt;ncimage-1] = ci;
		p-&gt;changed = TRUE;
		addrefresh(p, "");
	}
}

static char *mimetab[] = {
	"text/html",
	"application/xhtml",
	nil,
};

static
void
pageloadproc(void *v)
{
	Page *p;
	char buf[BUFSIZE], *s;
	long n, l;
	int fd, i, ctype;

	threadsetname("pageloadproc");
	rfork(RFFDG);

	p = v;
	addrefresh(p, "opening: %S...", p-&gt;url-&gt;src.r);
	fd = urlopen(p-&gt;url);
	if(fd &lt; 0){
		addrefresh(p, "%S: %r", p-&gt;url-&gt;src.r);
    Err:
		p-&gt;loading = FALSE;
		return;
	}
	if(runestrlen(p-&gt;url-&gt;ctype.r) == 0) /* assume .html when headers don't say anyting */
		goto Html;

	snprint(buf, sizeof(buf), "%S", p-&gt;url-&gt;ctype.r);
	for(i=0; mimetab[i]!=nil; i++)
		if(cistrncmp(buf, mimetab[i], strlen(mimetab[i])) == 0)
			break;

	if(mimetab[i]){
    Html:
		ctype = TextHtml;
	}else if(cistrncmp(buf, "text/", 5) == 0)
		ctype = TextPlain;
	else{
		close(fd);
		addrefresh(p, "%S: unsupported mime type: '%S'", p-&gt;url-&gt;act.r, p-&gt;url-&gt;ctype.r);
		goto Err;
	}
	addrefresh(p, "loading: %S...", p-&gt;url-&gt;src.r);
	s = nil;
	l = 0;
	while((n=read(fd, buf, sizeof(buf))) &gt; 0){
		if(p-&gt;aborting){
			if(s){
				free(s);
				s = nil;
			}
			break;
		}
		s = erealloc(s, l+n+1);
		memmove(s+l, buf, n);
		l += n;
		s[l] = '\0';
	}
	close(fd);
	n = l;
	if(s){
		s = convert(p-&gt;url-&gt;ctype, s, &amp;n);
		p-&gt;items = parsehtml((uchar *)s, n, p-&gt;url-&gt;act.r, ctype, UTF_8, &amp;p-&gt;doc);
		free(s);
		fixtext(p);
		if(ctype==TextHtml &amp;&amp; p-&gt;aborting==FALSE){
			p-&gt;changed = TRUE;
			addrefresh(p, "");
			if(p-&gt;doc-&gt;doctitle){
				p-&gt;title.r = erunestrdup(p-&gt;doc-&gt;doctitle);
				p-&gt;title.nr = runestrlen(p-&gt;title.r);
			}
			p-&gt;loading = XXX;
			if(p-&gt;doc-&gt;kidinfo)
				loadchilds(p, p-&gt;doc-&gt;kidinfo);
			else if(p-&gt;doc-&gt;images)
				loadimages(p);
		}
	}
	p-&gt;changed = TRUE;
	p-&gt;loading = FALSE;
	addrefresh(p, "");
}

static
void
pageload1(Page *p, Url *u, int dohist)
{
	pageclose(p);
	p-&gt;loading = TRUE;
	p-&gt;url = u;
	if(dohist)
		winaddhist(p-&gt;w, p-&gt;url);
	proccreate(pageloadproc, p, STACK);
}

void
pageload(Page *p, Url *u, int dohist)
{
	if(p-&gt;parent == nil)
		textset(&amp;p-&gt;w-&gt;url, u-&gt;src.r, u-&gt;src.nr);
	draw(p-&gt;b, p-&gt;all, display-&gt;white, nil, ZP);
	pageload1(p, u, dohist);
}

void
pageget(Page *p, Runestr *src, Runestr *post,  int m, int dohist)
{
	pageload(p, urlalloc(src, post, m), dohist);
}

void
pageclose(Page *p)
{
	Page *c, *nc;

	if(p == selpage)
		selpage = nil;
	pageabort(p);
	closeimages(p);
	urlfree(p-&gt;url);
	p-&gt;url = nil;
	if(p-&gt;doc){
		freedocinfo(p-&gt;doc);
		p-&gt;doc = nil;
	}
	layfree(p-&gt;lay);
	p-&gt;lay = nil;
	freeitems(p-&gt;items);
	p-&gt;items = nil;
	for(c=p-&gt;child; c!=nil; c=nc){
		nc = c-&gt;next;
		pageclose(c);
		free(c);
	}
	p-&gt;child = nil;
	closerunestr(&amp;p-&gt;title);
	closerunestr(&amp;p-&gt;refresh.rs);
	p-&gt;refresh.t = 0;
	p-&gt;pos = ZP;
	p-&gt;top = ZP;
	p-&gt;bot = ZP;
	p-&gt;loading = p-&gt;aborting = FALSE;
}

int
pageabort(Page *p)
{
	Page *c;

	for(c=p-&gt;child; c!=nil; c=c-&gt;next)
		pageabort(c);

	p-&gt;aborting = TRUE;
	while(p-&gt;loading)
		sleep(100);

	p-&gt;aborting = FALSE;
	return TRUE;
}


static Image *tmp;

void
tmpresize(void)
{
	if(tmp)
		freeimage(tmp);

	tmp = eallocimage(display, Rect(0,0,Dx(screen-&gt;r),Dy(screen-&gt;r)), screen-&gt;chan, 0, -1);
}

static
void
renderchilds(Page *p)
{
	Rectangle r;
	Kidinfo *k;
	Page *c;
	int i, j, x, y, *w, *h;

	draw(p-&gt;b, p-&gt;all, display-&gt;white, nil, ZP);
	r = p-&gt;all;
	y = r.min.y;
	c = p-&gt;child;
	k = p-&gt;kidinfo;
	frdims(k-&gt;rows, k-&gt;nrows, Dy(r), &amp;h);
	frdims(k-&gt;cols, k-&gt;ncols, Dx(r), &amp;w);
	for(i=0; i&lt;k-&gt;nrows; i++){
		x = r.min.x;
		for(j=0; j&lt;k-&gt;ncols; j++){
			if(c-&gt;aborting)
				return;
			c-&gt;b = p-&gt;b;
			c-&gt;all = Rect(x,y,x+w[j],y+h[i]);
			c-&gt;w = p-&gt;w;
			pagerender(c);
			c = c-&gt;next;
			x += w[j];
		}
		y += h[i];
	}
	free(w);
	free(h);
}

static
void
pagerender1(Page *p)
{
	Rectangle r;

	r = p-&gt;all;
	p-&gt;hscrollr = r;
	p-&gt;hscrollr.min.y = r.max.y-Scrollsize;
	p-&gt;vscrollr = r;
	p-&gt;vscrollr.max.x = r.min.x+Scrollsize;
	r.max.y -= Scrollsize;
	r.min.x += Scrollsize;
	p-&gt;r = r;
	p-&gt;vscrollr.max.y = r.max.y;
	p-&gt;hscrollr.min.x = r.min.x;
	laypage(p);
	pageredraw(p);
}

void
pagerender(Page *p)
{
	if(p-&gt;child &amp;&amp; p-&gt;loading==FALSE)
		renderchilds(p);
	else if(p-&gt;doc)
		pagerender1(p);
}

void
pageredraw(Page *p)
{
	Rectangle r;

	r = p-&gt;lay-&gt;r;
	if(Dx(r)==0 || Dy(r)==0){
		draw(p-&gt;b, p-&gt;r, display-&gt;white, nil, ZP);
		return;
	}
	if(tmp == nil)
		tmpresize();

	p-&gt;selecting = FALSE;
	draw(tmp, tmp-&gt;r, getbg(p), nil, ZP);
	laydraw(p, tmp, p-&gt;lay);
	draw(p-&gt;b, p-&gt;r, tmp, nil, tmp-&gt;r.min);
	r = p-&gt;vscrollr;
	r.min.y = r.max.y;
	r.max.y += Scrollsize;
	draw(p-&gt;b, r, tagcols[HIGH], nil, ZP);
	draw(p-&gt;b, insetrect(r, 1), tagcols[BACK], nil, ZP);
	pagescrldraw(p);
}

static
void
pageselect1(Page *p)	/* when called, button 1 is down */
{
	Point mp, npos, opos;
	int b, scrled, x, y;

	b = mouse-&gt;buttons;
	mp = mousectl-&gt;xy;
	opos = getpt(p, mp);
	do{
		x = y = 0;
		if(mp.x &lt; p-&gt;r.min.x)
			x -= p-&gt;r.min.x-mp.x;
		else if(mp.x &gt; p-&gt;r.max.x)
			x += mp.x-p-&gt;r.max.x;
		if(mp.y &lt; p-&gt;r.min.y)
			y -= (p-&gt;r.min.y-mp.y)*Panspeed;
		else if(mp.y &gt; p-&gt;r.max.y)
			y += (mp.y-p-&gt;r.max.y)*Panspeed;

		scrled = pagescrollxy(p, x, y);
		npos = getpt(p, mp);
		if(opos.y &lt;  npos.y){
			p-&gt;top = opos;
			p-&gt;bot = npos;
		}else{
			p-&gt;top = npos;
			p-&gt;bot = opos;
		}
		pageredraw(p);
		if(scrled == TRUE)
			scrsleep(100);
		else
			readmouse(mousectl);

		mp = mousectl-&gt;xy;
	}while(mousectl-&gt;buttons == b);
}

static Rune left1[] =  { L'{', L'[', L'(', L'&lt;', L'«', 0 };
static Rune right1[] = { L'}', L']', L')', L'&gt;', L'»', 0 };
static Rune left2[] =  { L'\'', L'"', L'`', 0 };

static
Rune *left[] = {
	left1,
	left2,
	nil
};
static
Rune *right[] = {
	right1,
	left2,
	nil
};

void
pagedoubleclick(Page *p)
{
	Point xy;
	Line *l;
	Box *b;

	xy = getpt(p, mouse-&gt;xy);
	l = linewhich(p-&gt;lay, xy);
	if(l==nil || l-&gt;hastext==FALSE)
		return;

	if(xy.x&lt;l-&gt;boxes-&gt;r.min.x &amp;&amp; hasbrk(l-&gt;state)){	/* beginning of line? */
		p-&gt;top = l-&gt;boxes-&gt;r.min;
		if(l-&gt;next &amp;&amp; !hasbrk(l-&gt;next-&gt;state)){
			for(l=l-&gt;next; l-&gt;next!=nil; l=l-&gt;next)
				if(hasbrk(l-&gt;next-&gt;state))
					break;
		}
		p-&gt;bot = l-&gt;lastbox-&gt;r.max;;
	}else if(xy.x&gt;l-&gt;lastbox-&gt;r.max.x &amp;&amp; hasbrk(l-&gt;next-&gt;state)){	/* end of line? */
		p-&gt;bot = l-&gt;lastbox-&gt;r.max;
		if(!hasbrk(l-&gt;state) &amp;&amp; l-&gt;prev!=nil){
			for(l=l-&gt;prev; l-&gt;prev!=nil; l=l-&gt;prev)
				if(hasbrk(l-&gt;state))
					break;
		}
		p-&gt;top = l-&gt;boxes-&gt;r.min;
	}else{
		b = pttobox(l, xy);
		if(b!=nil &amp;&amp; b-&gt;i-&gt;tag==Itexttag){
			p-&gt;top = b-&gt;r.min;
			p-&gt;bot = b-&gt;r.max;
		}
	}
	p-&gt;top.y += 2;
	p-&gt;bot.y -= 2;
	pageredraw(p);
}

static uint clickmsec;

void
pageselect(Page *p)
{
	int b, x, y;


	selpage = p;
	/*
	 * To have double-clicking and chording, we double-click
	 * immediately if it might make sense.
	 */
	b = mouse-&gt;buttons;
	if(mouse-&gt;msec-clickmsec&lt;500){
		pagedoubleclick(p);
		x = mouse-&gt;xy.x;
		y = mouse-&gt;xy.y;
		/* stay here until something interesting happens */
		do
			readmouse(mousectl);
		while(mouse-&gt;buttons==b &amp;&amp; abs(mouse-&gt;xy.x-x)&lt;3 &amp;&amp; abs(mouse-&gt;xy.y-y)&lt;3);
		mouse-&gt;xy.x = x;	/* in case we're calling pageselect1 */
		mouse-&gt;xy.y = y;
	}
	if(mousectl-&gt;buttons == b)
		pageselect1(p);

	if(eqpt(p-&gt;top, p-&gt;bot)){
		if(mouse-&gt;msec-clickmsec&lt;500)
			pagedoubleclick(p);
		else
			clickmsec = mouse-&gt;msec;
	}
	while(mouse-&gt;buttons){
		mouse-&gt;msec = 0;
		b = mouse-&gt;buttons;
		if(b &amp; 2)	/* snarf only */
			cut(nil, nil, TRUE, FALSE, nil, 0);
		while(mouse-&gt;buttons == b)
			readmouse(mousectl);
	}
}

Page *
pagewhich(Page *p, Point xy)
{
	Page *c;

	if(p-&gt;child == nil)
		return p;

	for(c=p-&gt;child; c!=nil; c=c-&gt;next)
		if(ptinrect(xy, c-&gt;all))
			return pagewhich(c, xy);

	return nil;
}

void
pagemouse(Page *p, Point xy, int but)
{
	Box *b;

	p = pagewhich(p, xy);
	if(p == nil)
		return;

	if(pagerefresh(p))
		return;

	if(p-&gt;lay == nil)
		return;

	if(ptinrect(xy, p-&gt;vscrollr)){
		pagescroll(p, but, FALSE);
		return;
	}
	if(ptinrect(xy, p-&gt;hscrollr)){
		pagescroll(p, but, TRUE);
		return;
	}
	xy = getpt(p, xy);
	b = boxwhich(p-&gt;lay, xy);
	if(b &amp;&amp; b-&gt;mouse)
		b-&gt;mouse(b, p, but);
	else if(but == 1)
		pageselect(p);
}

void
pagetype(Page *p, Rune r, Point xy)
{
	Box *b;
	int x, y;

	p = pagewhich(p, xy);
	if(p == nil)
		return;

	if(pagerefresh(p))
		return;

	if(p-&gt;lay == nil)
		return;

	/* text field? */
	xy = getpt(p, xy);
	b = boxwhich(p-&gt;lay, xy);
	if(b &amp;&amp; b-&gt;key){
		b-&gt;key(b, p, r);
		return;
	}
	/* ^H: same as 'Back' */
	if(r == 0x08){
		wingohist(p-&gt;w, FALSE);
		return;
	}

	x = 0;
	y = 0;
	switch(r){
	case Kleft:
		x -= Dx(p-&gt;r)/2;
		break;
	case Kright:
		x += Dx(p-&gt;r)/2;
		break;
	case Kdown:
	case Kscrollonedown:
		y += Dy(p-&gt;r)/2;
		break;
	case Kpgdown:
		y += Dy(p-&gt;r);
		break;
	case Kup:
	case Kscrolloneup:
		y -= Dy(p-&gt;r)/2;
		break;
	case Kpgup:
		y -= Dy(p-&gt;r);
		break;
	case Khome:
		y -= Dy(p-&gt;lay-&gt;r);	/* force p-&gt;pos.y = 0 */
		break;
	case Kend:
		y = Dy(p-&gt;lay-&gt;r) - Dy(p-&gt;r);
		break;
	default:
		return;
	}
	if(pagescrollxy(p, x, y))
		pageredraw(p);
}

void
pagesnarf(Page *p)
{
	Runestr rs;

	memset(&amp;rs, 0, sizeof(Runestr));
	laysnarf(p, p-&gt;lay, &amp;rs);
	putsnarf(&amp;rs);
	closerunestr(&amp;rs);
}

void
pagesetrefresh(Page *p)
{
	Runestr rs;
	Rune *s, *q, *t;
	char *v;
	int n;

	if(!p-&gt;doc || !p-&gt;doc-&gt;refresh)
		return;

	s = p-&gt;doc-&gt;refresh;
	q = runestrchr(s, L'=');
	if(q == nil)
		return;
	q++;
	if(!q)
		return;
	n = runestrlen(q);
	if(*q == L'''){
		q++;
		n -= 2;
	}
	if(n &lt;= 0)
		return;
	t = runesmprint("%.*S", n, q);
	rs.r = urlcombine(getbase(p), t);
	rs.nr = runestrlen(rs.r);
	copyrunestr(&amp;p-&gt;refresh.rs, &amp;rs);
	closerunestr(&amp;rs);
	free(t);

	/* now the time */
	q = runestrchr(s, L';');
	if(q){
		v = smprint("%.*S", (int)(q-s),  s);
		p-&gt;refresh.t = atoi(v);
		free(v);
	}else
		p-&gt;refresh.t = 1;

	p-&gt;refresh.t += time(0);
}

int
pagerefresh(Page *p)
{
	int t;

	if(!p-&gt;refresh.t)
		return 0;

	t = p-&gt;refresh.t - time(0);
	if(t &gt; 0)
		return 0;

	pageget(p, &amp;p-&gt;refresh.rs, nil, HGet, FALSE);
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

