<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/scrl.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/scrl.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include "dat.h"
#include "fns.h"

static Image *vscrtmp;
static Image *hscrtmp;

void
scrlresize(void)
{
	freeimage(vscrtmp);
	freeimage(hscrtmp);
	vscrtmp = eallocimage(display, Rect(0, 0, 32, screen-&gt;r.max.y), screen-&gt;chan, 0, DNofill);
	hscrtmp = eallocimage(display, Rect(0, 0, screen-&gt;r.max.x, 32), screen-&gt;chan, 0, DNofill);
}

static
Rectangle
scrpos(Rectangle r, uint p0, uint p1, uint tot)
{
	Rectangle q;
	int h;

	q = r;
	h = q.max.y-q.min.y;
	if(tot == 0)
		return q;
	if(tot &gt; 1024*1024){
		tot&gt;&gt;=10;
		p0&gt;&gt;=10;
		p1&gt;&gt;=10;
	}
	if(p0 &gt; 0)
		q.min.y += h*p0/tot;
	if(p1 &lt; tot)
		q.max.y -= h*(tot-p1)/tot;
	if(q.max.y &lt; q.min.y+2){
		if(q.min.y+2 &lt;= r.max.y)
			q.max.y = q.min.y+2;
		else
			q.min.y = q.max.y-2;
	}
	return q;
}

void
textscrdraw(Text *t)
{
	Rectangle r, r1, r2;
	Image *b;

	if(vscrtmp == nil)
		scrlresize();
	r = t-&gt;scrollr;
	b = vscrtmp;
	r1 = r;
	r1.min.x = 0;
	r1.max.x = Dx(r);
	r2 = scrpos(r1, t-&gt;org, t-&gt;org+t-&gt;nchars, t-&gt;rs.nr);
	if(!eqrect(r2, t-&gt;lastsr)){
		t-&gt;lastsr = r2;
		draw(b, r1, t-&gt;cols[BORD], nil, ZP);
		draw(b, r2, t-&gt;cols[BACK], nil, ZP);
		r2.min.x = r2.max.x-1;
		draw(b, r2, t-&gt;cols[BORD], nil, ZP);
		draw(t-&gt;b, r, b, nil, Pt(0, r1.min.y));
/*flushimage(display, 1);/*BUG?*/
	}
}

void
scrsleep(uint dt)
{
	Timer	*timer;
	static Alt alts[3];

	timer = timerstart(dt);
	alts[0].c = timer-&gt;c;
	alts[0].v = nil;
	alts[0].op = CHANRCV;
	alts[1].c = mousectl-&gt;c;
	alts[1].v = &amp;mousectl-&gt;Mouse;
	alts[1].op = CHANRCV;
	alts[2].op = CHANEND;
	for(;;)
		switch(alt(alts)){
		case 0:
			timerstop(timer);
			return;
		case 1:
			timercancel(timer);
			return;
		}
}

void
textscroll(Text *t, int but)
{
	uint p0, oldp0;
	Rectangle s;
	int x, y, my, h, first;

	s = insetrect(t-&gt;scrollr, 1);
	h = s.max.y-s.min.y;
	x = (s.min.x+s.max.x)/2;
	oldp0 = ~0;
	first = TRUE;
	do{
		flushimage(display, 1);
		my = mouse-&gt;xy.y;
		if(my &lt; s.min.y)
			my = s.min.y;
		if(my &gt;= s.max.y)
			my = s.max.y;
		if(!eqpt(mouse-&gt;xy, Pt(x, my))){
			moveto(mousectl, Pt(x, my));
			readmouse(mousectl);		/* absorb event generated by moveto() */
		}
		if(but == 2){
			y = my;
			p0 = (vlong)t-&gt;rs.nr*(y-s.min.y)/h;
			if(p0 &gt;= t-&gt;q1)
				p0 = textbacknl(t, p0, 2);
			if(oldp0 != p0)
				textsetorigin(t, p0, FALSE);
			oldp0 = p0;
			readmouse(mousectl);
			continue;
		}
		if(but == 1)
			p0 = textbacknl(t, t-&gt;org, (my-s.min.y)/t-&gt;font-&gt;height);
		else
			p0 = t-&gt;org+frcharofpt(t, Pt(s.max.x, my));
		if(oldp0 != p0)
			textsetorigin(t, p0, TRUE);
		oldp0 = p0;
		/* debounce */
		if(first){
			flushimage(display, 1);
			sleep(200);
			nbrecv(mousectl-&gt;c, &amp;mousectl-&gt;Mouse);
			first = FALSE;
		}
		scrsleep(80);
	}while(mouse-&gt;buttons &amp; (1&lt;&lt;(but-1)));
	while(mouse-&gt;buttons)
		readmouse(mousectl);
}

enum
{
	Scrbord = 1,
};

void
pagescrldraw(Page *p)
{
	Rectangle r1;
	int t, d, l, h;

	if(vscrtmp == nil)
		scrlresize();

	r1 = Rect(0,0,Dx(p-&gt;hscrollr), Dy(p-&gt;hscrollr));
	d = Dx(r1);
	t = Dx(p-&gt;lay-&gt;r);
	l = muldiv(p-&gt;pos.x, d, t);
	h = muldiv(p-&gt;pos.x+d, d, t);
	draw(hscrtmp, r1, tagcols[HIGH], nil, ZP);
	r1.max.x = r1.min.x+h;
	r1.min.x += l;
	r1.min.y += Scrbord;
	r1.max.y -= Scrbord;
	draw(hscrtmp, r1, tagcols[BACK], nil, ZP);

	r1 = Rect(0,0,Dx(p-&gt;vscrollr), Dy(p-&gt;vscrollr));
	d = Dy(r1);
	t = Dy(p-&gt;lay-&gt;r);
	l = muldiv(p-&gt;pos.y, d, t);
	h = muldiv(p-&gt;pos.y+d, d, t);
	draw(vscrtmp, r1, tagcols[HIGH], nil, ZP);
	r1.max.y = r1.min.y+h;
	r1.min.y += l;
	r1.max.x -= Scrbord;
	r1.min.x += Scrbord;
	draw(vscrtmp, r1, tagcols[BACK], nil, ZP);

	draw(screen, p-&gt;vscrollr, vscrtmp, nil, vscrtmp-&gt;r.min);
	draw(screen, p-&gt;hscrollr, hscrtmp, nil, hscrtmp-&gt;r.min);
}

void
pagescroll(Page *p, int but, int horizontal)
{
	uint oldp0, p0;
	Rectangle s;
	Point mxy;
	int i, m, om, first, d, size;
	int smin, smax, ss, *pos;

	if(horizontal){
		s = insetrect(p-&gt;hscrollr, 1);
		ss = s.max.x - s.min.x;
		i = (s.min.y+s.max.y)/2;
		d = Dx(p-&gt;r);
		size = Dx(p-&gt;lay-&gt;r);
		p0 = p-&gt;pos.x;
		pos = &amp;p-&gt;pos.x;
		smin =  s.min.x;
		smax = s.max.x;
		om = mouse-&gt;xy.x;
	}else{
		s = insetrect(p-&gt;vscrollr, 1);
		ss = s.max.y-s.min.y;
		i = (s.min.x+s.max.x)/2;
		d = Dy(p-&gt;r);
		size = Dy(p-&gt;lay-&gt;r);
		p0 = p-&gt;pos.y;
		pos = &amp;p-&gt;pos.y;
		smin =  s.min.y;
		smax = s.max.y;
		om = mouse-&gt;xy.y;
	}
	oldp0 = ~0;
	first = TRUE;
	do{
		flushimage(display, 1);
		if(horizontal)
			m = mouse-&gt;xy.x;
		else
			m = mouse-&gt;xy.y;

		if(m &gt; om)
			m += (m-om)*Panspeed;
		else if(m &lt; om)
			m -= (om-m)*Panspeed;

		if(m &lt; smin)
			m = smin;
		if(m &gt; smax)
			m = smax;

		om = m;
		if(horizontal)
			mxy = Pt(m, i);
		else
			mxy = Pt(i, m);
		if(!eqpt(mouse-&gt;xy, mxy)){
			moveto(mousectl, mxy);
			readmouse(mousectl);	/* absorb event generated by moveto() */
		}
		if(but == 2){
			p0 = muldiv(m-smin, size, ss);
			p0 = max(p0, 0);
			p0 = min(p0,size-d);
			if(oldp0 != p0){
				*pos = p0;
				pageredraw(p);
			}
			oldp0 = p0;
			readmouse(mousectl);
			continue;
		}
		if(but == 1)
			p0 -= (d/2);
		else
			p0 += d/2;
		p0 = min(p0, size-d);
		p0 = max(p0, 0);
		if(oldp0 != p0){
			*pos = p0;
			pageredraw(p);
		}
		oldp0 = p0;
		/* debounce */
		if(first){
			flushimage(display, 1);
			sleep(200);
			nbrecv(mousectl-&gt;c, &amp;mousectl-&gt;Mouse);
			first = FALSE;
		}
		scrsleep(80);
	}while(mouse-&gt;buttons &amp; (1&lt;&lt;(but-1)));
	while(mouse-&gt;buttons)
		readmouse(mousectl);
}

int
pagescrollxy(Page *p, int x, int y)
{
	int scrled;

	scrled = FALSE;
	if(x != 0){
		p-&gt;pos.x += x;
		p-&gt;pos.x = max(p-&gt;pos.x, 0);
		p-&gt;pos.x = min(p-&gt;pos.x, Dx(p-&gt;lay-&gt;r)-Dx(p-&gt;r));
		scrled =TRUE;
	}
	if(y != 0){
		p-&gt;pos.y += y;
		p-&gt;pos.y = max(p-&gt;pos.y, 0);
		p-&gt;pos.y = min(p-&gt;pos.y, Dy(p-&gt;lay-&gt;r)-Dy(p-&gt;r));
		scrled =TRUE;
	}
	return scrled;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

