<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/builtin.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/builtin.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#include &lt;regexp.h&gt;
#define Extern extern
#include "acid.h"
#include "y.tab.h"

void	cvtatof(Node*, Node*);
void	cvtatoi(Node*, Node*);
void	cvtitoa(Node*, Node*);
void	bprint(Node*, Node*);
void	funcbound(Node*, Node*);
void	printto(Node*, Node*);
void	getfile(Node*, Node*);
void	fmt(Node*, Node*);
void	pcfile(Node*, Node*);
void	pcline(Node*, Node*);
void	setproc(Node*, Node*);
void	strace(Node*, Node*);
void	follow(Node*, Node*);
void	reason(Node*, Node*);
void	newproc(Node*, Node*);
void	startstop(Node*, Node*);
void	match(Node*, Node*);
void	status(Node*, Node*);
void	kill(Node*,Node*);
void	waitstop(Node*, Node*);
void	stop(Node*, Node*);
void	start(Node*, Node*);
void	filepc(Node*, Node*);
void	doerror(Node*, Node*);
void	rc(Node*, Node*);
void	doaccess(Node*, Node*);
void	map(Node*, Node*);
void	readfile(Node*, Node*);
void	interpret(Node*, Node*);
void	include(Node*, Node*);
void	regexp(Node*, Node*);
void	dosysr1(Node*, Node*);
void	fmtof(Node*, Node*) ;
void	dofmtsize(Node*, Node*) ;

typedef struct Btab Btab;
struct Btab
{
	char	*name;
	void	(*fn)(Node*, Node*);
} tab[] =
{
	"atof",		cvtatof,
	"atoi",		cvtatoi,
	"error",	doerror,
	"file",		getfile,
	"readfile",	readfile,
	"access",	doaccess,
	"filepc",	filepc,
	"fnbound",	funcbound,
	"fmt",		fmt,
	"follow",	follow,
	"itoa",		cvtitoa,
	"kill",		kill,
	"match",	match,
	"newproc",	newproc,
	"pcfile",	pcfile,
	"pcline",	pcline,
	"print",	bprint,
	"printto",	printto,
	"rc",		rc,
	"reason",	reason,
	"setproc",	setproc,
	"start",	start,
	"startstop",	startstop,
	"status",	status,
	"stop",		stop,
	"strace",	strace,
	"sysr1",	dosysr1,
	"waitstop",	waitstop,
	"map",		map,
	"interpret",	interpret,
	"include",	include,
	"regexp",	regexp,
	"fmtof",	fmtof,
	"fmtsize",	dofmtsize,
	0
};

char vfmt[] = "aBbcCdDfFgGiIoOqQrRsSuUVWxXYZ38";

void
mkprint(Lsym *s)
{
	prnt = malloc(sizeof(Node));
	memset(prnt, 0, sizeof(Node));
	prnt-&gt;op = OCALL;
	prnt-&gt;left = malloc(sizeof(Node));
	memset(prnt-&gt;left, 0, sizeof(Node));
	prnt-&gt;left-&gt;sym = s;
}

void
installbuiltin(void)
{
	Btab *b;
	Lsym *s;

	b = tab;
	while(b-&gt;name) {
		s = look(b-&gt;name);
		if(s == 0)
			s = enter(b-&gt;name, Tid);

		s-&gt;builtin = b-&gt;fn;
		if(b-&gt;fn == bprint)
			mkprint(s);
		b++;
	}
}

void
dosysr1(Node *r, Node*)
{
	extern int sysr1(void);
	
	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;fmt = 'D';
	r-&gt;ival = sysr1();
}

void
match(Node *r, Node *args)
{
	int i;
	List *f;
	Node *av[Maxarg];
	Node resi, resl;

	na = 0;
	flatten(av, args);
	if(na != 2)
		error("match(obj, list): arg count");

	expr(av[1], &amp;resl);
	if(resl.type != TLIST)
		error("match(obj, list): need list");
	expr(av[0], &amp;resi);

	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;fmt = 'D';
	r-&gt;ival = -1;

	i = 0;
	for(f = resl.l; f; f = f-&gt;next) {
		if(resi.type == f-&gt;type) {
			switch(resi.type) {
			case TINT:
				if(resi.ival == f-&gt;ival) {
					r-&gt;ival = i;
					return;
				}
				break;
			case TFLOAT:
				if(resi.fval == f-&gt;fval) {
					r-&gt;ival = i;
					return;
				}
				break;
			case TSTRING:
				if(scmp(resi.string, f-&gt;string)) {
					r-&gt;ival = i;
					return;
				}
				break;
			case TLIST:
				error("match(obj, list): not defined for list");
			}
		}
		i++;
	}
}

void
newproc(Node *r, Node *args)
{
	int i;
	Node res;
	char *p, *e;
	char *argv[Maxarg], buf[Strsize];

	i = 1;
	argv[0] = aout;

	if(args) {
		expr(args, &amp;res);
		if(res.type != TSTRING)
			error("newproc(): arg not string");
		if(res.string-&gt;len &gt;= sizeof(buf))
			error("newproc(): too many arguments");
		memmove(buf, res.string-&gt;string, res.string-&gt;len);
		buf[res.string-&gt;len] = '\0';
		p = buf;
		e = buf+res.string-&gt;len;
		for(;;) {
			while(p &lt; e &amp;&amp; (*p == '\t' || *p == ' '))
				*p++ = '\0';
			if(p &gt;= e)
				break;
			argv[i++] = p;
			if(i &gt;= Maxarg)
				error("newproc: too many arguments");
			while(p &lt; e &amp;&amp; *p != '\t' &amp;&amp; *p != ' ')
				p++;
		}
	}
	argv[i] = 0;
	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;fmt = 'D';
	r-&gt;ival = nproc(argv);
}

void
startstop(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("startstop(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("startstop(pid): arg type");

	msg(res.ival, "startstop");
	notes(res.ival);
	dostop(res.ival);
}

void
waitstop(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("waitstop(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("waitstop(pid): arg type");

	Bflush(bout);
	msg(res.ival, "waitstop");
	notes(res.ival);
	dostop(res.ival);
}

void
start(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("start(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("start(pid): arg type");

	msg(res.ival, "start");
}

void
stop(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("stop(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("stop(pid): arg type");

	Bflush(bout);
	msg(res.ival, "stop");
	notes(res.ival);
	dostop(res.ival);
}

void
kill(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("kill(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("kill(pid): arg type");

	msg(res.ival, "kill");
	deinstall(res.ival);
}

void
status(Node *r, Node *args)
{
	Node res;
	char *p;

	USED(r);
	if(args == 0)
		error("status(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("status(pid): arg type");

	p = getstatus(res.ival);
	r-&gt;string = strnode(p);
	r-&gt;op = OCONST;
	r-&gt;fmt = 's';
	r-&gt;type = TSTRING;
}

void
reason(Node *r, Node *args)
{
	Node res;

	if(args == 0)
		error("reason(cause): no cause");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("reason(cause): arg type");

	r-&gt;op = OCONST;
	r-&gt;type = TSTRING;
	r-&gt;fmt = 's';
	r-&gt;string = strnode((*machdata-&gt;excep)(cormap, rget));
}

void
follow(Node *r, Node *args)
{
	int n, i;
	Node res;
	uvlong f[10];
	List **tail, *l;

	if(args == 0)
		error("follow(addr): no addr");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("follow(addr): arg type");

	n = (*machdata-&gt;foll)(cormap, res.ival, rget, f);
	if (n &lt; 0)
		error("follow(addr): %r");
	tail = &amp;r-&gt;l;
	for(i = 0; i &lt; n; i++) {
		l = al(TINT);
		l-&gt;ival = f[i];
		l-&gt;fmt = 'X';
		*tail = l;
		tail = &amp;l-&gt;next;
	}
}

void
funcbound(Node *r, Node *args)
{
	int n;
	Node res;
	uvlong bounds[2];
	List *l;

	if(args == 0)
		error("fnbound(addr): no addr");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("fnbound(addr): arg type");

	n = fnbound(res.ival, bounds);
	if (n != 0) {
		r-&gt;l = al(TINT);
		l = r-&gt;l;
		l-&gt;ival = bounds[0];
		l-&gt;fmt = 'X';
		l-&gt;next = al(TINT);
		l = l-&gt;next;
		l-&gt;ival = bounds[1];
		l-&gt;fmt = 'X';
	}
}

void
setproc(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("setproc(pid): no pid");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("setproc(pid): arg type");

	sproc(res.ival);
}

void
filepc(Node *r, Node *args)
{
	Node res;
	char *p, c;

	if(args == 0)
		error("filepc(filename:line): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("filepc(filename:line): arg type");

	p = strchr(res.string-&gt;string, ':');
	if(p == 0)
		error("filepc(filename:line): bad arg format");

	c = *p;
	*p++ = '\0';
	r-&gt;ival = file2pc(res.string-&gt;string, strtol(p, 0, 0));
	p[-1] = c;
	if(r-&gt;ival == ~0)
		error("filepc(filename:line): can't find address");

	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;fmt = 'V';
}

void
interpret(Node *r, Node *args)
{
	Node res;
	int isave;

	if(args == 0)
		error("interpret(string): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("interpret(string): arg type");

	pushstr(&amp;res);

	isave = interactive;
	interactive = 0;
	r-&gt;ival = yyparse();
	interactive = isave;
	popio();
	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;fmt = 'D';
}

void
include(Node *r, Node *args)
{
	Node res;
	int isave;

	if(args == 0)
		error("include(string): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("include(string): arg type");

	pushfile(res.string-&gt;string);

	isave = interactive;
	interactive = 0;
	r-&gt;ival = yyparse();
	interactive = isave;
	popio();
	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;fmt = 'D';
}

void
rc(Node *r, Node *args)
{
	Node res;
	int pid;
	char *p, *q, *argv[4];
	Waitmsg *w;

	USED(r);
	if(args == 0)
		error("error(string): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("error(string): arg type");

	argv[0] = "/bin/rc";
	argv[1] = "-c";
	argv[2] = res.string-&gt;string;
	argv[3] = 0;

	pid = fork();
	switch(pid) {
	case -1:
		error("fork %r");
	case 0:
		exec("/bin/rc", argv);
		exits(0);
	default:
		w = waitfor(pid);
		break;
	}
	p = w-&gt;msg;
	q = strrchr(p, ':');
	if (q)
		p = q+1;

	r-&gt;op = OCONST;
	r-&gt;type = TSTRING;
	r-&gt;string = strnode(p);
	free(w);
	r-&gt;fmt = 's';
}

void
doerror(Node *r, Node *args)
{
	Node res;

	USED(r);
	if(args == 0)
		error("error(string): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("error(string): arg type");

	error(res.string-&gt;string);
}

void
doaccess(Node *r, Node *args)
{
	Node res;

	if(args == 0)
		error("access(filename): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("access(filename): arg type");

	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;ival = 0;		
	if(access(res.string-&gt;string, 4) == 0)
		r-&gt;ival = 1;
}

void
readfile(Node *r, Node *args)
{
	Node res;
	int n, fd;
	char *buf;
	Dir *db;

	if(args == 0)
		error("readfile(filename): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("readfile(filename): arg type");

	fd = open(res.string-&gt;string, OREAD);
	if(fd &lt; 0)
		return;

	db = dirfstat(fd);
	if(db == nil || db-&gt;length == 0)
		n = 8192;
	else
		n = db-&gt;length;
	free(db);

	buf = malloc(n);
	n = read(fd, buf, n);

	if(n &gt; 0) {
		r-&gt;op = OCONST;
		r-&gt;type = TSTRING;
		r-&gt;string = strnodlen(buf, n);
		r-&gt;fmt = 's';
	}
	free(buf);
	close(fd);
}

void
getfile(Node *r, Node *args)
{
	int n;
	char *p;
	Node res;
	String *s;
	Biobuf *bp;
	List **l, *new;

	if(args == 0)
		error("file(filename): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("file(filename): arg type");

	r-&gt;op = OCONST;
	r-&gt;type = TLIST;
	r-&gt;l = 0;

	p = res.string-&gt;string;
	bp = Bopen(p, OREAD);
	if(bp == 0)
		return;

	l = &amp;r-&gt;l;
	for(;;) {
		p = Brdline(bp, '\n');
		n = Blinelen(bp);
		if(p == 0) {
			if(n == 0)
				break;
			s = strnodlen(0, n);
			Bread(bp, s-&gt;string, n);
		}
		else
			s = strnodlen(p, n-1);

		new = al(TSTRING);
		new-&gt;string = s;
		new-&gt;fmt = 's';
		*l = new;
		l = &amp;new-&gt;next;
	}
	Bterm(bp);
}

void
cvtatof(Node *r, Node *args)
{
	Node res;

	if(args == 0)
		error("atof(string): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("atof(string): arg type");

	r-&gt;op = OCONST;
	r-&gt;type = TFLOAT;
	r-&gt;fval = atof(res.string-&gt;string);
	r-&gt;fmt = 'f';
}

void
cvtatoi(Node *r, Node *args)
{
	Node res;

	if(args == 0)
		error("atoi(string): arg count");
	expr(args, &amp;res);
	if(res.type != TSTRING)
		error("atoi(string): arg type");

	r-&gt;op = OCONST;
	r-&gt;type = TINT;
	r-&gt;ival = strtoull(res.string-&gt;string, 0, 0);
	r-&gt;fmt = 'V';
}

static char *fmtflags = "-0123456789. #,u";
static char *fmtverbs = "bdox";

static int
acidfmt(char *fmt, char *buf, int blen)
{
	char *r, *w, *e;
	
	w = buf;
	e = buf+blen;
	for(r=fmt; *r; r++){
		if(w &gt;= e)
			return -1;
		if(*r != '%'){
			*w++ = *r;
			continue;
		}
		if(*r == '%'){
			*w++ = *r++;
			if(*r == '%'){
				if(w &gt;= e)
					return -1;
				*w++ = *r;
				continue;
			}
			while(*r &amp;&amp; strchr(fmtflags, *r)){
				if(w &gt;= e)
					return -1;
				*w++ = *r++;
			}
			if(*r == 0 || strchr(fmtverbs, *r) == nil)
				return -1;
			if(w+3 &gt; e)
				return -1;
			*w++ = 'l';
			*w++ = 'l';
			*w++ = *r;
		}
	}
	if(w &gt;= e)
		return -1;
	*w = 0;

	return 0;
}

void
cvtitoa(Node *r, Node *args)
{
	Node res;
	Node *av[Maxarg];
	vlong ival;
	char buf[128], fmt[32];

	if(args == 0)
err:
		error("itoa(number [, fmt]): arg count");
	na = 0;
	flatten(av, args);
	if(na == 0 || na &gt; 2)
		goto err;
	expr(av[0], &amp;res);
	if(res.type != TINT)
		error("itoa(number [, fmt]): arg type");
	ival = res.ival;
	strncpy(fmt, "%lld", sizeof(fmt));
	if(na == 2){
		expr(av[1], &amp;res);
		if(res.type != TSTRING)
			error("itoa(number [, fmt]): fmt type");
		if(acidfmt(res.string-&gt;string, fmt, sizeof(buf)))
			error("itoa(number [, fmt]): malformed fmt");
	}

	snprint(buf, sizeof(buf), fmt, ival);
	r-&gt;op = OCONST;
	r-&gt;type = TSTRING;
	r-&gt;string = strnode(buf);
	r-&gt;fmt = 's';
}

List*
mapent(Map *m)
{
	int i;
	List *l, *n, **t, *h;

	h = 0;
	t = &amp;h;
	for(i = 0; i &lt; m-&gt;nsegs; i++) {
		if(m-&gt;seg[i].inuse == 0)
			continue;
		l = al(TSTRING);
		n = al(TLIST);
		n-&gt;l = l;
		*t = n;
		t = &amp;n-&gt;next;
		l-&gt;string = strnode(m-&gt;seg[i].name);
		l-&gt;fmt = 's';
		l-&gt;next = al(TINT);
		l = l-&gt;next;
		l-&gt;ival = m-&gt;seg[i].b;
		l-&gt;fmt = 'W';
		l-&gt;next = al(TINT);
		l = l-&gt;next;
		l-&gt;ival = m-&gt;seg[i].e;
		l-&gt;fmt = 'W';
		l-&gt;next = al(TINT);
		l = l-&gt;next;
		l-&gt;ival = m-&gt;seg[i].f;
		l-&gt;fmt = 'W';
	}
	return h;
}

void
map(Node *r, Node *args)
{
	int i;
	Map *m;
	List *l;
	char *ent;
	Node *av[Maxarg], res;

	na = 0;
	flatten(av, args);

	if(na != 0) {
		expr(av[0], &amp;res);
		if(res.type != TLIST)
			error("map(list): map needs a list");
		if(listlen(res.l) != 4)
			error("map(list): list must have 4 entries");

		l = res.l;
		if(l-&gt;type != TSTRING)
			error("map name must be a string");
		ent = l-&gt;string-&gt;string;
		m = symmap;
		i = findseg(m, ent);
		if(i &lt; 0) {
			m = cormap;
			i = findseg(m, ent);
		}
		if(i &lt; 0)
			error("%s is not a map entry", ent);	
		l = l-&gt;next;
		if(l-&gt;type != TINT)
			error("map entry not int");
		m-&gt;seg[i].b = l-&gt;ival;
		if (strcmp(ent, "text") == 0)
			textseg(l-&gt;ival, &amp;fhdr);
		l = l-&gt;next;
		if(l-&gt;type != TINT)
			error("map entry not int");
		m-&gt;seg[i].e = l-&gt;ival;
		l = l-&gt;next;
		if(l-&gt;type != TINT)
			error("map entry not int");
		m-&gt;seg[i].f = l-&gt;ival;
	}

	r-&gt;type = TLIST;
	r-&gt;l = 0;
	if(symmap)
		r-&gt;l = mapent(symmap);
	if(cormap) {
		if(r-&gt;l == 0)
			r-&gt;l = mapent(cormap);
		else {
			for(l = r-&gt;l; l-&gt;next; l = l-&gt;next)
				;
			l-&gt;next = mapent(cormap);
		}
	}
}

void 
flatten(Node **av, Node *n)
{
	if(n == 0)
		return;

	switch(n-&gt;op) {
	case OLIST:
		flatten(av, n-&gt;left);
		flatten(av, n-&gt;right);
		break;
	default:
		av[na++] = n;
		if(na &gt;= Maxarg)
			error("too many function arguments");
		break;
	}
}

void
strace(Node *r, Node *args)
{
	Node *av[Maxarg], *n, res;
	uvlong pc, sp;

	na = 0;
	flatten(av, args);
	if(na != 3)
		error("strace(pc, sp, link): arg count");

	n = av[0];
	expr(n, &amp;res);
	if(res.type != TINT)
		error("strace(pc, sp, link): pc bad type");
	pc = res.ival;

	n = av[1];
	expr(n, &amp;res);
	if(res.type != TINT)
		error("strace(pc, sp, link): sp bad type");
	sp = res.ival;

	n = av[2];
	expr(n, &amp;res);
	if(res.type != TINT)
		error("strace(pc, sp, link): link bad type");

	tracelist = 0;
	if ((*machdata-&gt;ctrace)(cormap, pc, sp, res.ival, trlist) &lt;= 0)
		error("no stack frame: %r");
	r-&gt;type = TLIST;
	r-&gt;l = tracelist;
}

void
regerror(char *msg)
{
	error(msg);
}

void
regexp(Node *r, Node *args)
{
	Node res;
	Reprog *rp;
	Node *av[Maxarg];

	na = 0;
	flatten(av, args);
	if(na != 2)
		error("regexp(pattern, string): arg count");
	expr(av[0], &amp;res);
	if(res.type != TSTRING)
		error("regexp(pattern, string): pattern must be string");
	rp = regcomp(res.string-&gt;string);
	if(rp == 0)
		return;

	expr(av[1], &amp;res);
	if(res.type != TSTRING)
		error("regexp(pattern, string): bad string");

	r-&gt;fmt = 'D';
	r-&gt;type = TINT;
	r-&gt;ival = regexec(rp, res.string-&gt;string, 0, 0);
	free(rp);
}

void
fmt(Node *r, Node *args)
{
	Node res;
	Node *av[Maxarg];

	na = 0;
	flatten(av, args);
	if(na != 2)
		error("fmt(obj, fmt): arg count");
	expr(av[1], &amp;res);
	if(res.type != TINT || strchr(vfmt, res.ival) == 0)
		error("fmt(obj, fmt): bad format '%c'", (char)res.ival);
	expr(av[0], r);
	r-&gt;fmt = res.ival;
}

void
patom(char type, Store *res)
{
	int i;
	char buf[512];
	extern char *typenames[];

	switch(res-&gt;fmt) {
	case 'c':
		Bprint(bout, "%c", (int)res-&gt;ival);
		break;
	case 'C':
		if(res-&gt;ival &lt; ' ' || res-&gt;ival &gt;= 0x7f)
			Bprint(bout, "%3d", (int)res-&gt;ival&amp;0xff);
		else
			Bprint(bout, "%3c", (int)res-&gt;ival);
		break;
	case 'r':
		Bprint(bout, "%C", (int)res-&gt;ival);
		break;
	case 'B':
		memset(buf, '0', 34);
		buf[1] = 'b';
		for(i = 0; i &lt; 32; i++) {
			if(res-&gt;ival &amp; (1&lt;&lt;i))
				buf[33-i] = '1';
		}
		buf[35] = '\0';
		Bprint(bout, "%s", buf);
		break;
	case 'b':
		Bprint(bout, "%.2x", (int)res-&gt;ival&amp;0xff);
		break;
	case 'X':
		Bprint(bout, "%.8lux", (ulong)res-&gt;ival);
		break;
	case 'x':
		Bprint(bout, "%.4lux", (ulong)res-&gt;ival&amp;0xffff);
		break;
	case 'D':
		Bprint(bout, "%d", (int)res-&gt;ival);
		break;
	case 'd':
		Bprint(bout, "%d", (ushort)res-&gt;ival);
		break;
	case 'u':
		Bprint(bout, "%d", (int)res-&gt;ival&amp;0xffff);
		break;
	case 'U':
		Bprint(bout, "%lud", (ulong)res-&gt;ival);
		break;
	case 'Z':
		Bprint(bout, "%llud", res-&gt;ival);
		break;
	case 'V':
		Bprint(bout, "%lld", res-&gt;ival);
		break;
	case 'W':
		Bprint(bout, "%.8llux", res-&gt;ival);
		break;
	case 'Y':
		Bprint(bout, "%.16llux", res-&gt;ival);
		break;
	case 'o':
		Bprint(bout, "0%.11uo", (int)res-&gt;ival&amp;0xffff);
		break;
	case 'O':
		Bprint(bout, "0%.6uo", (int)res-&gt;ival);
		break;
	case 'q':
		Bprint(bout, "0%.11o", (short)(res-&gt;ival&amp;0xffff));
		break;
	case 'Q':
		Bprint(bout, "0%.6o", (int)res-&gt;ival);
		break;
	case 'f':
	case 'F':
	case '3':
	case '8':
		if(type != TFLOAT)
			Bprint(bout, "*%c&lt;%s&gt;*", res-&gt;fmt, typenames[type]);
		else
			Bprint(bout, "%g", res-&gt;fval);
		break;
	case 's':
	case 'g':
	case 'G':
		if(type != TSTRING)
			Bprint(bout, "*%c&lt;%s&gt;*", res-&gt;fmt, typenames[type]);
		else
			Bwrite(bout, res-&gt;string-&gt;string, res-&gt;string-&gt;len);
		break;
	case 'R':
		if(type != TSTRING)
			Bprint(bout, "*%c&lt;%s&gt;*", res-&gt;fmt, typenames[type]);
		else
			Bprint(bout, "%S", (Rune*)res-&gt;string-&gt;string);
		break;
	case 'a':
	case 'A':
		symoff(buf, sizeof(buf), res-&gt;ival, CANY);
		Bprint(bout, "%s", buf);
		break;
	case 'I':
	case 'i':
		if(type != TINT)
			Bprint(bout, "*%c&lt;%s&gt;*", res-&gt;fmt, typenames[type]);
		else {
			if (symmap == nil || (*machdata-&gt;das)(symmap, res-&gt;ival, res-&gt;fmt, buf, sizeof(buf)) &lt; 0)
				Bprint(bout, "no instruction");
			else
				Bprint(bout, "%s", buf);
		}
		break;
	}
}

void
blprint(List *l)
{
	Bprint(bout, "{");
	while(l) {
		switch(l-&gt;type) {
		default:
			patom(l-&gt;type, &amp;l-&gt;Store);
			break;
		case TSTRING:
			Bputc(bout, '"');
			patom(l-&gt;type, &amp;l-&gt;Store);
			Bputc(bout, '"');
			break;
		case TLIST:
			blprint(l-&gt;l);
			break;
		case TCODE:
			pcode(l-&gt;cc, 0);
			break;
		}
		l = l-&gt;next;
		if(l)
			Bprint(bout, ", ");
	}
	Bprint(bout, "}");
}

int
comx(Node res)
{
	Lsym *sl;
	Node *n, xx;

	if(res.fmt != 'a' &amp;&amp; res.fmt != 'A')
		return 0;

	if(res.comt == 0 || res.comt-&gt;base == 0)
		return 0;

	sl = res.comt-&gt;base;
	if(sl-&gt;proc) {
		res.left = ZN;
		res.right = ZN;
		n = an(ONAME, ZN, ZN);
		n-&gt;sym = sl;
		n = an(OCALL, n, &amp;res);
			n-&gt;left-&gt;sym = sl;
		expr(n, &amp;xx);
		return 1;
	}
	print("(%s)", sl-&gt;name);
	return 0;
}

void
bprint(Node *r, Node *args)
{
	int i, nas;
	Node res, *av[Maxarg];

	USED(r);
	na = 0;
	flatten(av, args);
	nas = na;
	for(i = 0; i &lt; nas; i++) {
		expr(av[i], &amp;res);
		switch(res.type) {
		default:
			if(comx(res))
				break;
			patom(res.type, &amp;res.Store);
			break;
		case TCODE:
			pcode(res.cc, 0);
			break;
		case TLIST:
			blprint(res.l);
			break;
		}
	}
	if(ret == 0)
		Bputc(bout, '\n');
}

void
printto(Node *r, Node *args)
{
	int fd;
	Biobuf *b;
	int i, nas;
	Node res, *av[Maxarg];

	USED(r);
	na = 0;
	flatten(av, args);
	nas = na;

	expr(av[0], &amp;res);
	if(res.type != TSTRING)
		error("printto(string, ...): need string");

	fd = create(res.string-&gt;string, OWRITE, 0666);
	if(fd &lt; 0)
		fd = open(res.string-&gt;string, OWRITE);
	if(fd &lt; 0)
		error("printto: open %s: %r", res.string-&gt;string);

	b = gmalloc(sizeof(Biobuf));
	Binit(b, fd, OWRITE);

	Bflush(bout);
	io[iop++] = bout;
	bout = b;

	for(i = 1; i &lt; nas; i++) {
		expr(av[i], &amp;res);
		switch(res.type) {
		default:
			if(comx(res))
				break;
			patom(res.type, &amp;res.Store);
			break;
		case TLIST:
			blprint(res.l);
			break;
		}
	}
	if(ret == 0)
		Bputc(bout, '\n');

	Bterm(b);
	close(fd);
	free(b);
	bout = io[--iop];
}

void
pcfile(Node *r, Node *args)
{
	Node res;
	char *p, buf[128];

	if(args == 0)
		error("pcfile(addr): arg count");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("pcfile(addr): arg type");

	r-&gt;type = TSTRING;
	r-&gt;fmt = 's';
	if(fileline(buf, sizeof(buf), res.ival) == 0) {
		r-&gt;string = strnode("?file?");
		return;
	}
	p = strrchr(buf, ':');
	if(p == 0)
		error("pcfile(addr): funny file %s", buf);
	*p = '\0';
	r-&gt;string = strnode(buf);	
}

void
pcline(Node *r, Node *args)
{
	Node res;
	char *p, buf[128];

	if(args == 0)
		error("pcline(addr): arg count");
	expr(args, &amp;res);
	if(res.type != TINT)
		error("pcline(addr): arg type");

	r-&gt;type = TINT;
	r-&gt;fmt = 'D';
	if(fileline(buf, sizeof(buf), res.ival) == 0) {
		r-&gt;ival = 0;
		return;
	}

	p = strrchr(buf, ':');
	if(p == 0)
		error("pcline(addr): funny file %s", buf);
	r-&gt;ival = strtol(p+1, 0, 0);	
}

void fmtof(Node *r, Node *args)
{
	Node *av[Maxarg];
	Node res;

	na = 0;
	flatten(av, args);
	if(na &lt; 1)
		error("fmtof(obj): no argument");
	if(na &gt; 1)
		error("fmtof(obj): too many arguments") ;
	expr(av[0], &amp;res);

	r-&gt;op = OCONST;
	r-&gt;type = TINT ;
	r-&gt;ival = res.fmt ;
	r-&gt;fmt = 'c';
}

void dofmtsize(Node *r, Node *args)
{
	Node *av[Maxarg];
	Node res;
	Store * s ;
	Value v ;

	na = 0;
	flatten(av, args);
	if(na &lt; 1)
		error("fmtsize(obj): no argument");
	if(na &gt; 1)
		error("fmtsize(obj): too many arguments") ;
	expr(av[0], &amp;res);

	v.type = res.type ;
	s = &amp;v.Store ;
	*s = res ;

	r-&gt;op = OCONST;
	r-&gt;type = TINT ;
	r-&gt;ival = fmtsize(&amp;v) ;
	r-&gt;fmt = 'D';
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

