<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/exec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/exec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "acid.h"

void
error(char *fmt, ...)
{
	int i;
	char buf[2048];
	va_list arg;

	/* Unstack io channels */
	if(iop != 0) {
		for(i = 1; i &lt; iop; i++)
			Bterm(io[i]);
		bout = io[0];
		iop = 0;
	}

	ret = 0;
	gotint = 0;
	Bflush(bout);
	if(silent)
		silent = 0;
	else {
		va_start(arg, fmt);
		vseprint(buf, buf+sizeof(buf), fmt, arg);
		va_end(arg);
		fprint(2, "%L: (error) %s\n", buf);
	}
	while(popio())
		;
	interactive = 1;
	longjmp(err, 1);
}

void
unwind(void)
{
	int i;
	Lsym *s;
	Value *v;

	for(i = 0; i &lt; Hashsize; i++) {
		for(s = hash[i]; s; s = s-&gt;hash) {
			while(s-&gt;v-&gt;pop) {
				v = s-&gt;v-&gt;pop;
				free(s-&gt;v);
				s-&gt;v = v;
			}
		}
	}
}

void
execute(Node *n)
{
	Value *v;
	Lsym *sl;
	Node *l, *r;
	vlong i, s, e;
	Node res, xx;
	static int stmnt;

	gc();
	if(gotint)
		error("interrupted");

	if(n == 0)
		return;

	if(stmnt++ &gt; 5000) {
		Bflush(bout);
		stmnt = 0;
	}

	l = n-&gt;left;
	r = n-&gt;right;

	switch(n-&gt;op) {
	default:
		expr(n, &amp;res);
		if(ret || (res.type == TLIST &amp;&amp; res.l == 0 &amp;&amp; n-&gt;op != OADD))
			break;
		prnt-&gt;right = &amp;res;
		expr(prnt, &amp;xx);
		break;
	case OASGN:
	case OCALL:
		expr(n, &amp;res);
		break;
	case OCOMPLEX:
		decl(n);
		break;
	case OLOCAL:
		for(n = n-&gt;left; n; n = n-&gt;left) {
			if(ret == 0)
				error("local not in function");
			sl = n-&gt;sym;
			if(sl-&gt;v-&gt;ret == ret)
				error("%s declared twice", sl-&gt;name);
			v = gmalloc(sizeof(Value));
			v-&gt;ret = ret;
			v-&gt;pop = sl-&gt;v;
			sl-&gt;v = v;
			v-&gt;scope = 0;
			*(ret-&gt;tail) = sl;
			ret-&gt;tail = &amp;v-&gt;scope;
			v-&gt;set = 0;
		}
		break;
	case ORET:
		if(ret == 0)
			error("return not in function");
		expr(n-&gt;left, ret-&gt;val);
		longjmp(ret-&gt;rlab, 1);
	case OLIST:
		execute(n-&gt;left);
		execute(n-&gt;right);
		break;
	case OIF:
		expr(l, &amp;res);
		if(r &amp;&amp; r-&gt;op == OELSE) {
			if(bool(&amp;res))
				execute(r-&gt;left);
			else
				execute(r-&gt;right);
		}
		else if(bool(&amp;res))
			execute(r);
		break;
	case OWHILE:
		for(;;) {
			expr(l, &amp;res);
			if(!bool(&amp;res))
				break;
			execute(r);
		}
		break;
	case ODO:
		expr(l-&gt;left, &amp;res);
		if(res.type != TINT)
			error("loop must have integer start");
		s = res.ival;
		expr(l-&gt;right, &amp;res);
		if(res.type != TINT)
			error("loop must have integer end");
		e = res.ival;
		for(i = s; i &lt;= e; i++)
			execute(r);
		break;
	}
}

int
bool(Node *n)
{
	int true = 0;

	if(n-&gt;op != OCONST)
		fatal("bool: not const");

	switch(n-&gt;type) {
	case TINT:
		if(n-&gt;ival != 0)
			true = 1;
		break;
	case TFLOAT:
		if(n-&gt;fval != 0.0)
			true = 1;
		break;
	case TSTRING:
		if(n-&gt;string-&gt;len)
			true = 1;
		break;
	case TLIST:
		if(n-&gt;l)
			true = 1;
		break;
	}
	return true;
}

void
convflt(Node *r, char *flt)
{
	char c;

	c = flt[0];
	if(('a' &lt;= c &amp;&amp; c &lt;= 'z') || ('A' &lt;= c &amp;&amp; c &lt;= 'Z')) {
		r-&gt;type = TSTRING;
		r-&gt;fmt = 's';
		r-&gt;string = strnode(flt);
	}
	else {
		r-&gt;type = TFLOAT;
		r-&gt;fval = atof(flt);
	}
}

void
indir(Map *m, uvlong addr, char fmt, Node *r)
{
	int i;
	ulong lval;
	uvlong uvval;
	int ret;
	uchar cval;
	ushort sval;
	char buf[512], reg[12];

	r-&gt;op = OCONST;
	r-&gt;fmt = fmt;
	switch(fmt) {
	default:
		error("bad pointer format '%c' for *", fmt);
	case 'c':
	case 'C':
	case 'b':
		r-&gt;type = TINT;
		ret = get1(m, addr, &amp;cval, 1);
		if (ret &lt; 0)
			error("indir: %r");
		r-&gt;ival = cval;
		break;
	case 'x':
	case 'd':
	case 'u':
	case 'o':
	case 'q':
	case 'r':
		r-&gt;type = TINT;
		ret = get2(m, addr, &amp;sval);
		if (ret &lt; 0)
			error("indir: %r");
		r-&gt;ival = sval;
		break;
	case 'a':
	case 'A':
	case 'W':
		r-&gt;type = TINT;
		ret = geta(m, addr, &amp;uvval);
		if (ret &lt; 0)
			error("indir: %r");
		r-&gt;ival = uvval;
		break;
	case 'B':
	case 'X':
	case 'D':
	case 'U':
	case 'O':
	case 'Q':
		r-&gt;type = TINT;
		ret = get4(m, addr, &amp;lval);
		if (ret &lt; 0)
			error("indir: %r");
		r-&gt;ival = lval;
		break;
	case 'V':
	case 'Y':
	case 'Z':
		r-&gt;type = TINT;
		ret = get8(m, addr, &amp;uvval);
		if (ret &lt; 0)
			error("indir: %r");
		r-&gt;ival = uvval;
		break;
	case 's':
		r-&gt;type = TSTRING;
		for(i = 0; i &lt; sizeof(buf)-1; i++) {
			ret = get1(m, addr, (uchar*)&amp;buf[i], 1);
			if (ret &lt; 0)
				error("indir: %r");
			addr++;
			if(buf[i] == '\0')
				break;
		}
		buf[i] = 0;
		if(i == 0)
			strcpy(buf, "(null)");
		r-&gt;string = strnode(buf);
		break;
	case 'R':
		r-&gt;type = TSTRING;
		for(i = 0; i &lt; sizeof(buf)-2; i += 2) {
			ret = get1(m, addr, (uchar*)&amp;buf[i], 2);
			if (ret &lt; 0)
				error("indir: %r");
			addr += 2;
			if(buf[i] == 0 &amp;&amp; buf[i+1] == 0)
				break;
		}
		buf[i++] = 0;
		buf[i] = 0;
		r-&gt;string = runenode((Rune*)buf);
		break;
	case 'i':
	case 'I':
		if ((*machdata-&gt;das)(m, addr, fmt, buf, sizeof(buf)) &lt; 0)
			error("indir: %r");
		r-&gt;type = TSTRING;
		r-&gt;fmt = 's';
		r-&gt;string = strnode(buf);
		break;
	case 'f':
		ret = get1(m, addr, (uchar*)buf, mach-&gt;szfloat);
		if (ret &lt; 0)
			error("indir: %r");
		machdata-&gt;sftos(buf, sizeof(buf), (void*) buf);
		convflt(r, buf);
		break;
	case 'g':
		ret = get1(m, addr, (uchar*)buf, mach-&gt;szfloat);
		if (ret &lt; 0)
			error("indir: %r");
		machdata-&gt;sftos(buf, sizeof(buf), (void*) buf);
		r-&gt;type = TSTRING;
		r-&gt;string = strnode(buf);
		break;
	case 'F':
		ret = get1(m, addr, (uchar*)buf, mach-&gt;szdouble);
		if (ret &lt; 0)
			error("indir: %r");
		machdata-&gt;dftos(buf, sizeof(buf), (void*) buf);
		convflt(r, buf);
		break;
	case '3':	/* little endian ieee 80 with hole in bytes 8&amp;9 */
		ret = get1(m, addr, (uchar*)reg, 10);
		if (ret &lt; 0)
			error("indir: %r");
		memmove(reg+10, reg+8, 2);	/* open hole */
		memset(reg+8, 0, 2);		/* fill it */
		leieee80ftos(buf, sizeof(buf), reg);
		convflt(r, buf);
		break;
	case '8':	/* big-endian ieee 80 */
		ret = get1(m, addr, (uchar*)reg, 10);
		if (ret &lt; 0)
			error("indir: %r");
		beieee80ftos(buf, sizeof(buf), reg);
		convflt(r, buf);
		break;
	case 'G':
		ret = get1(m, addr, (uchar*)buf, mach-&gt;szdouble);
		if (ret &lt; 0)
			error("indir: %r");
		machdata-&gt;dftos(buf, sizeof(buf), (void*) buf);
		r-&gt;type = TSTRING;
		r-&gt;string = strnode(buf);
		break;
	}
}

void
windir(Map *m, Node *addr, Node *rval, Node *r)
{
	uchar cval;
	ushort sval;
	long lval;
	Node res, aes;
	int ret;

	if(m == 0)
		error("no map for */@=");

	expr(rval, &amp;res);
	expr(addr, &amp;aes);

	if(aes.type != TINT)
		error("bad type lhs of @/*");

	if(m != cormap &amp;&amp; wtflag == 0)
		error("not in write mode");

	r-&gt;type = res.type;
	r-&gt;fmt = res.fmt;
	r-&gt;Store = res.Store;

	switch(res.fmt) {
	default:
		error("bad pointer format '%c' for */@=", res.fmt);
	case 'c':
	case 'C':
	case 'b':
		cval = res.ival;
		ret = put1(m, aes.ival, &amp;cval, 1);
		break;
	case 'r':
	case 'x':
	case 'd':
	case 'u':
	case 'o':
		sval = res.ival;
		ret = put2(m, aes.ival, sval);
		r-&gt;ival = sval;
		break;
	case 'a':
	case 'A':
	case 'W':
		ret = puta(m, aes.ival, res.ival);
		break;
	case 'B':
	case 'X':
	case 'D':
	case 'U':
	case 'O':
		lval = res.ival;
		ret = put4(m, aes.ival, lval);
		break;
	case 'V':
	case 'Y':
	case 'Z':
		ret = put8(m, aes.ival, res.ival);
		break;
	case 's':
	case 'R':
		ret = put1(m, aes.ival, (uchar*)res.string-&gt;string, res.string-&gt;len);
		break;
	}
	if (ret &lt; 0)
		error("windir: %r");
}

void
call(char *fn, Node *parameters, Node *local, Node *body, Node *retexp)
{
	int np, i;
	Rplace rlab;
	Node *n, res;
	Value *v, *f;
	Lsym *s, *next;
	Node *avp[Maxarg], *ava[Maxarg];

	rlab.local = 0;

	na = 0;
	flatten(avp, parameters);
	np = na;
	na = 0;
	flatten(ava, local);
	if(np != na) {
		if(np &lt; na)
			error("%s: too few arguments", fn);
		error("%s: too many arguments", fn);
	}

	rlab.tail = &amp;rlab.local;

	ret = &amp;rlab;
	for(i = 0; i &lt; np; i++) {
		n = ava[i];
		switch(n-&gt;op) {
		default:
			error("%s: %d formal not a name", fn, i);
		case ONAME:
			expr(avp[i], &amp;res);
			s = n-&gt;sym;
			break;
		case OINDM:
			res.cc = avp[i];
			res.type = TCODE;
			res.comt = 0;
			if(n-&gt;left-&gt;op != ONAME)
				error("%s: %d formal not a name", fn, i);
			s = n-&gt;left-&gt;sym;
			break;
		}
		if(s-&gt;v-&gt;ret == ret)
			error("%s already declared at this scope", s-&gt;name);

		v = gmalloc(sizeof(Value));
		v-&gt;ret = ret;
		v-&gt;pop = s-&gt;v;
		s-&gt;v = v;
		v-&gt;scope = 0;
		*(rlab.tail) = s;
		rlab.tail = &amp;v-&gt;scope;

		v-&gt;Store = res.Store;
		v-&gt;type = res.type;
		v-&gt;set = 1;
	}

	ret-&gt;val = retexp;
	if(setjmp(rlab.rlab) == 0)
		execute(body);

	for(s = rlab.local; s; s = next) {
		f = s-&gt;v;
		next = f-&gt;scope;
		s-&gt;v = f-&gt;pop;
		free(f);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

