<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/list.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/list.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "acid.h"

static List **tail;

List*
construct(Node *l)
{
	List *lh, **save;

	save = tail;
	lh = 0;
	tail = &amp;lh;
	build(l);
	tail = save;

	return lh;
}

int
listlen(List *l)
{
	int len;

	len = 0;
	while(l) {
		len++;
		l = l-&gt;next;
	}
	return len;
}

void
build(Node *n)
{
	List *l;
	Node res;

	if(n == 0)
		return;

	switch(n-&gt;op) {
	case OLIST:
		build(n-&gt;left);
		build(n-&gt;right);
		return;
	default:
		expr(n, &amp;res);
		l = al(res.type);
		l-&gt;Store = res.Store;
		*tail = l;
		tail = &amp;l-&gt;next;	
	}
}

List*
addlist(List *l, List *r)
{
	List *f;

	if(l == 0)
		return r;

	for(f = l; f-&gt;next; f = f-&gt;next)
		;
	f-&gt;next = r;

	return l;
}

void
append(Node *r, Node *list, Node *val)
{
	List *l, *f;

	l = al(val-&gt;type);
	l-&gt;Store = val-&gt;Store;
	l-&gt;next = 0;

	r-&gt;op = OCONST;
	r-&gt;type = TLIST;

	if(list-&gt;l == 0) {
		list-&gt;l = l;
		r-&gt;l = l;
		return;
	}
	for(f = list-&gt;l; f-&gt;next; f = f-&gt;next)
		;
	f-&gt;next = l;
	r-&gt;l = list-&gt;l;
}

int
listcmp(List *l, List *r)
{
	if(l == r)
		return 1;

	while(l) {
		if(r == 0)
			return 0;
		if(l-&gt;type != r-&gt;type)
			return 0;
		switch(l-&gt;type) {
		case TINT:
			if(l-&gt;ival != r-&gt;ival)
				return 0;
			break;
		case TFLOAT:
			if(l-&gt;fval != r-&gt;fval)
				return 0;
			break;
		case TSTRING:
			if(scmp(l-&gt;string, r-&gt;string) == 0)
				return 0;
			break;
		case TLIST:
			if(listcmp(l-&gt;l, r-&gt;l) == 0)
				return 0;
			break;
		}
		l = l-&gt;next;
		r = r-&gt;next;
	}
	if(l != r)
		return 0;
	return 1;
}

void
nthelem(List *l, int n, Node *res)
{
	if(n &lt; 0)
		error("negative index in []");

	while(l &amp;&amp; n--)
		l = l-&gt;next;

	res-&gt;op = OCONST;
	if(l == 0) {
		res-&gt;type = TLIST;
		res-&gt;l = 0;
		return;
	}
	res-&gt;type = l-&gt;type;
	res-&gt;Store = l-&gt;Store;
}

void
delete(List *l, int n, Node *res)
{
	List **tl;

	if(n &lt; 0)
		error("negative index in delete");

	res-&gt;op = OCONST;
	res-&gt;type = TLIST;
	res-&gt;l = l;

	for(tl = &amp;res-&gt;l; l &amp;&amp; n--; l = l-&gt;next)
		tl = &amp;l-&gt;next;

	if(l == 0)
		error("element beyond end of list");
	*tl = l-&gt;next;
}

List*
listvar(char *s, vlong v)
{
	List *l, *tl;

	tl = al(TLIST);

	l = al(TSTRING);
	tl-&gt;l = l;
	l-&gt;fmt = 's';
	l-&gt;string = strnode(s);
	l-&gt;next = al(TINT);
	l = l-&gt;next;
	l-&gt;fmt = 'X';
	l-&gt;ival = v;

	return tl;
}

static List*
listlocals(Map *map, Symbol *fn, uvlong fp)
{
	int i;
	uvlong val;
	Symbol s;
	List **tail, *l2;

	l2 = 0;
	tail = &amp;l2;
	s = *fn;

	for(i = 0; localsym(&amp;s, i); i++) {
		if(s.class != CAUTO)
			continue;
		if(s.name[0] == '.')
			continue;

		if(geta(map, fp-s.value, &amp;val) &gt; 0) {
			*tail = listvar(s.name, val);
			tail = &amp;(*tail)-&gt;next;
		}
	}
	return l2;
}

static List*
listparams(Map *map, Symbol *fn, uvlong fp)
{
	int i;
	Symbol s;
	uvlong v;
	List **tail, *l2;

	l2 = 0;
	tail = &amp;l2;
	fp += mach-&gt;szaddr;			/* skip saved pc */
	s = *fn;
	for(i = 0; localsym(&amp;s, i); i++) {
		if (s.class != CPARAM)
			continue;

		if(geta(map, fp+s.value, &amp;v) &gt; 0) {
			*tail = listvar(s.name, v);
			tail = &amp;(*tail)-&gt;next;
		}
	}
	return l2;
}

void
trlist(Map *map, uvlong pc, uvlong sp, Symbol *sym)
{
	List *q, *l;

	static List **tail;

	if (tracelist == 0) {		/* first time */
		tracelist = al(TLIST);
		tail = &amp;tracelist;
	}

	q = al(TLIST);
	*tail = q;
	tail = &amp;q-&gt;next;

	l = al(TINT);			/* Function address */
	q-&gt;l = l;
	l-&gt;ival = sym-&gt;value;
	l-&gt;fmt = 'X';

	l-&gt;next = al(TINT);		/* called from address */
	l = l-&gt;next;
	l-&gt;ival = pc;
	l-&gt;fmt = 'Y';

	l-&gt;next = al(TLIST);		/* make list of params */
	l = l-&gt;next;
	l-&gt;l = listparams(map, sym, sp);

	l-&gt;next = al(TLIST);		/* make list of locals */
	l = l-&gt;next;
	l-&gt;l = listlocals(map, sym, sp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

