<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#define Extern
#include "acid.h"
#include "y.tab.h"

extern int _ifmt(Fmt*);

static Biobuf	bioout;
static char	prog[128];
static char*	lm[16];
static int	nlm;
static char*	mtype;

static	int attachfiles(char*, int);
int	xfmt(Fmt*);
int	isnumeric(char*);
void	die(void);
void	loadmoduleobjtype(void);

void
usage(void)
{
	fprint(2, "usage: acid [-kqw] [-l library] [-m machine] [pid] [file]\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	Lsym *l;
	Node *n;
	char *s;
	int pid, i;

	argv0 = argv[0];
	pid = 0;
	aout = "8.out";
	quiet = 1;

	mtype = 0;
	ARGBEGIN{
	case 'm':
		mtype = ARGF();
		break;
	case 'w':
		wtflag = 1;
		break;
	case 'l':
		s = ARGF();
		if(s == 0)
			usage();
		lm[nlm++] = s;
		break;
	case 'k':
		kernel++;
		break;
	case 'q':
		quiet = 0;
		break;
	case 'r':
		pid = 1;
		remote++;
		kernel++;
		break;
	default:
		usage();
	}ARGEND

	if(argc &gt; 0) {
		if(remote)
			aout = argv[0];
		else
		if(isnumeric(argv[0])) {
			pid = strtol(argv[0], 0, 0);
			snprint(prog, sizeof(prog), "/proc/%d/text", pid);
			aout = prog;
			if(argc &gt; 1)
				aout = argv[1];
			else if(kernel)
				aout = system();
		}
		else {
			if(kernel) {
				fprint(2, "acid: -k requires a pid\n");
				usage();
			}
			aout = argv[0];
		}
	} else
	if(remote)
		aout = "/mips/9ch";

	fmtinstall('x', xfmt);
	fmtinstall('L', Lfmt);
	Binit(&amp;bioout, 1, OWRITE);
	bout = &amp;bioout;

	kinit();
	initialising = 1;
	pushfile(0);
	loadvars();
	installbuiltin();

	if(mtype &amp;&amp; machbyname(mtype) == 0)
		print("unknown machine %s", mtype);

	if (attachfiles(aout, pid) &lt; 0)
		varreg();		/* use default register set on error */

	loadmodule("/sys/lib/acid/port");
	loadmoduleobjtype();

	for(i = 0; i &lt; nlm; i++) {
		if(access(lm[i], AREAD) &gt;= 0)
			loadmodule(lm[i]);
		else {
			s = smprint("/sys/lib/acid/%s", lm[i]);
			loadmodule(s);
			free(s);
		}
	}

	userinit();
	varsym();

	l = look("acidmap");
	if(l &amp;&amp; l-&gt;proc) {
		n = an(ONAME, ZN, ZN);
		n-&gt;sym = l;
		n = an(OCALL, n, ZN);
		execute(n);
	}

	interactive = 1;
	initialising = 0;
	line = 1;

	notify(catcher);

	for(;;) {
		if(setjmp(err)) {
			Binit(&amp;bioout, 1, OWRITE);
			unwind();
		}
		stacked = 0;

		Bprint(bout, "acid: ");

		if(yyparse() != 1)
			die();
		restartio();

		unwind();
	}
	/* not reached */
}

static int
attachfiles(char *aout, int pid)
{
	interactive = 0;
	if(setjmp(err))
		return -1;

	if(aout) {				/* executable given */
		if(wtflag)
			text = open(aout, ORDWR);
		else
			text = open(aout, OREAD);

		if(text &lt; 0)
			error("%s: can't open %s: %r\n", argv0, aout);
		readtext(aout);
	}
	if(pid)					/* pid given */
		sproc(pid);
	return 0;
}

void
die(void)
{
	Lsym *s;
	List *f;

	Bprint(bout, "\n");

	s = look("proclist");
	if(s &amp;&amp; s-&gt;v-&gt;type == TLIST) {
		for(f = s-&gt;v-&gt;l; f; f = f-&gt;next)
			Bprint(bout, "echo kill &gt; /proc/%d/ctl\n", (int)f-&gt;ival);
	}
	exits(0);
}

void
loadmoduleobjtype(void)
{
	char *buf;

	buf = smprint("/sys/lib/acid/%s", mach-&gt;name);
	loadmodule(buf);
	free(buf);
}

void
userinit(void)
{
	Lsym *l;
	Node *n;
	char *buf, *p;

	p = getenv("home");
	if(p != 0) {
		buf = smprint("%s/lib/acid", p);
		silent = 1;
		loadmodule(buf);
		free(buf);
	}

	interactive = 0;
	if(setjmp(err)) {
		unwind();
		return;
	}
	l = look("acidinit");
	if(l &amp;&amp; l-&gt;proc) {
		n = an(ONAME, ZN, ZN);
		n-&gt;sym = l;
		n = an(OCALL, n, ZN);
		execute(n);
	}
}

void
loadmodule(char *s)
{
	interactive = 0;
	if(setjmp(err)) {
		unwind();
		return;
	}
	pushfile(s);
	silent = 0;
	yyparse();
	popio();
	return;
}

void
readtext(char *s)
{
	Dir *d;
	Lsym *l;
	Value *v;
	uvlong length;
	Symbol sym;
	extern Machdata mipsmach;

	if(mtype != 0){
		symmap = newmap(0, 1);
		if(symmap == 0)
			print("%s: (error) loadmap: cannot make symbol map\n", argv0);
		length = 1&lt;&lt;24;
		d = dirfstat(text);
		if(d != nil){
			length = d-&gt;length;
			free(d);
		}
		setmap(symmap, text, 0, length, 0, "binary");
		return;
	}

	machdata = &amp;mipsmach;

	if(!crackhdr(text, &amp;fhdr)) {
		print("can't decode file header\n");
		return;
	}

	symmap = loadmap(0, text, &amp;fhdr);
	if(symmap == 0)
		print("%s: (error) loadmap: cannot make symbol map\n", argv0);

	if(syminit(text, &amp;fhdr) &lt; 0) {
		print("%s: (error) syminit: %r\n", argv0);
		return;
	}
	print("%s:%s\n", s, fhdr.name);

	if(mach-&gt;sbreg &amp;&amp; lookup(0, mach-&gt;sbreg, &amp;sym)) {
		mach-&gt;sb = sym.value;
		l = enter("SB", Tid);
		l-&gt;v-&gt;fmt = 'X';
		l-&gt;v-&gt;ival = mach-&gt;sb;
		l-&gt;v-&gt;type = TINT;
		l-&gt;v-&gt;set = 1;
	}

	l = mkvar("objtype");
	v = l-&gt;v;
	v-&gt;fmt = 's';
	v-&gt;set = 1;
	v-&gt;string = strnode(mach-&gt;name);
	v-&gt;type = TSTRING;

	l = mkvar("textfile");
	v = l-&gt;v;
	v-&gt;fmt = 's';
	v-&gt;set = 1;
	v-&gt;string = strnode(s);
	v-&gt;type = TSTRING;

	machbytype(fhdr.type);
	varreg();
}

Node*
an(int op, Node *l, Node *r)
{
	Node *n;

	n = gmalloc(sizeof(Node));
	memset(n, 0, sizeof(Node));
	n-&gt;gclink = gcl;
	gcl = n;
	n-&gt;op = op;
	n-&gt;left = l;
	n-&gt;right = r;
	return n;
}

List*
al(int t)
{
	List *l;

	l = gmalloc(sizeof(List));
	memset(l, 0, sizeof(List));
	l-&gt;type = t;
	l-&gt;gclink = gcl;
	gcl = l;
	return l;
}

Node*
con(vlong v)
{
	Node *n;

	n = an(OCONST, ZN, ZN);
	n-&gt;ival = v;
	n-&gt;fmt = 'W';
	n-&gt;type = TINT;
	return n;
}

void
fatal(char *fmt, ...)
{
	char buf[128];
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	fprint(2, "%s: %L (fatal problem) %s\n", argv0, buf);
	exits(buf);
}

void
yyerror(char *fmt, ...)
{
	char buf[128];
	va_list arg;

	if(strcmp(fmt, "syntax error") == 0) {
		yyerror("syntax error, near symbol '%s'", symbol);
		return;
	}
	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	print("%L: %s\n", buf);
}

void
marktree(Node *n)
{

	if(n == 0)
		return;

	marktree(n-&gt;left);
	marktree(n-&gt;right);

	n-&gt;gcmark = 1;
	if(n-&gt;op != OCONST)
		return;

	switch(n-&gt;type) {
	case TSTRING:
		n-&gt;string-&gt;gcmark = 1;
		break;
	case TLIST:
		marklist(n-&gt;l);
		break;
	case TCODE:
		marktree(n-&gt;cc);
		break;
	}
}

void
marklist(List *l)
{
	while(l) {
		l-&gt;gcmark = 1;
		switch(l-&gt;type) {
		case TSTRING:
			l-&gt;string-&gt;gcmark = 1;
			break;
		case TLIST:
			marklist(l-&gt;l);
			break;
		case TCODE:
			marktree(l-&gt;cc);
			break;
		}
		l = l-&gt;next;
	}
}

void
gc(void)
{
	int i;
	Lsym *f;
	Value *v;
	Gc *m, **p, *next;

	if(dogc &lt; Mempergc)
		return;
	dogc = 0;

	/* Mark */
	for(m = gcl; m; m = m-&gt;gclink)
		m-&gt;gcmark = 0;

	/* Scan */
	for(i = 0; i &lt; Hashsize; i++) {
		for(f = hash[i]; f; f = f-&gt;hash) {
			marktree(f-&gt;proc);
			if(f-&gt;lexval != Tid)
				continue;
			for(v = f-&gt;v; v; v = v-&gt;pop) {
				switch(v-&gt;type) {
				case TSTRING:
					v-&gt;string-&gt;gcmark = 1;
					break;
				case TLIST:
					marklist(v-&gt;l);
					break;
				case TCODE:
					marktree(v-&gt;cc);
					break;
				}
			}
		}
	}

	/* Free */
	p = &amp;gcl;
	for(m = gcl; m; m = next) {
		next = m-&gt;gclink;
		if(m-&gt;gcmark == 0) {
			*p = next;
			free(m);	/* Sleazy reliance on my malloc */
		}
		else
			p = &amp;m-&gt;gclink;
	}
}

void*
gmalloc(long l)
{
	void *p;

	dogc += l;
	p = malloc(l);
	if(p == 0)
		fatal("out of memory");
	return p;
}

void
checkqid(int f1, int pid)
{
	int fd;
	Dir *d1, *d2;
	char buf[128];

	if(kernel)
		return;

	d1 = dirfstat(f1);
	if(d1 == nil){
		print("checkqid: (qid not checked) dirfstat: %r\n");
		return;
	}

	snprint(buf, sizeof(buf), "/proc/%d/text", pid);
	fd = open(buf, OREAD);
	if(fd &lt; 0 || (d2 = dirfstat(fd)) == nil){
		print("checkqid: (qid not checked) dirstat %s: %r\n", buf);
		free(d1);
		if(fd &gt;= 0)
			close(fd);
		return;
	}

	close(fd);

	if(d1-&gt;qid.path != d2-&gt;qid.path || d1-&gt;qid.vers != d2-&gt;qid.vers || d1-&gt;qid.type != d2-&gt;qid.type){
		print("path %llux %llux vers %lud %lud type %d %d\n",
			d1-&gt;qid.path, d2-&gt;qid.path, d1-&gt;qid.vers, d2-&gt;qid.vers, d1-&gt;qid.type, d2-&gt;qid.type);
		print("warning: image does not match text for pid %d\n", pid);
	}
	free(d1);
	free(d2);
}

void
catcher(void *junk, char *s)
{
	USED(junk);

	if(strstr(s, "interrupt")) {
		gotint = 1;
		noted(NCONT);
	}
	noted(NDFLT);
}

char*
system(void)
{
	char *cpu, *p, *q;
	static char *kernel;

	cpu = getenv("cputype");
	if(cpu == 0) {
		cpu = "mips";
		print("$cputype not set; assuming %s\n", cpu);
	}
	p = getenv("terminal");
	if(p == 0 || (p=strchr(p, ' ')) == 0 || p[1] == ' ' || p[1] == 0) {
		p = "ch";
		print("missing or bad $terminal; assuming %s\n", p);
	}
	else{
		p++;
		q = strchr(p, ' ');
		if(q)
			*q = 0;
	}

	if(kernel != nil)
		free(kernel);
	kernel = smprint("/%s/9%s", cpu, p);

	return kernel;
}

int
isnumeric(char *s)
{
	while(*s) {
		if(*s &lt; '0' || *s &gt; '9')
			return 0;
		s++;
	}
	return 1;
}

int
xfmt(Fmt *f)
{
	f-&gt;flags ^= FmtSharp;
	return _ifmt(f);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

