<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/proc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/proc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "acid.h"
#include "y.tab.h"

static void install(int);

void
nocore(void)
{
	int i;

	if(cormap == 0)
		return;

	for (i = 0; i &lt; cormap-&gt;nsegs; i++)
		if (cormap-&gt;seg[i].inuse &amp;&amp; cormap-&gt;seg[i].fd &gt;= 0)
			close(cormap-&gt;seg[i].fd);
	free(cormap);
	cormap = 0;
}

void
sproc(int pid)
{
	Lsym *s;
	char buf[64];
	int i, fcor;

	if(symmap == 0)
		error("no map");

	snprint(buf, sizeof(buf), "/proc/%d/mem", pid);
	fcor = open(buf, ORDWR);
	if(fcor &lt; 0)
		error("setproc: open %s: %r", buf);

	checkqid(symmap-&gt;seg[0].fd, pid);

	s = look("pid");
	s-&gt;v-&gt;ival = pid;

	nocore();
	cormap = attachproc(pid, kernel, fcor, &amp;fhdr);
	if (cormap == 0)
		error("setproc: can't make coremap: %r");
	i = findseg(cormap, "text");
	if (i &gt; 0)
		cormap-&gt;seg[i].name = "*text";
	i = findseg(cormap, "data");
	if (i &gt; 0)
		cormap-&gt;seg[i].name = "*data";
	install(pid);
}

int
nproc(char **argv)
{
	char buf[128];
	int pid, i, fd;

	pid = fork();
	switch(pid) {
	case -1:
		error("new: fork %r");
	case 0:
		rfork(RFNAMEG|RFNOTEG);

		snprint(buf, sizeof(buf), "/proc/%d/ctl", getpid());
		fd = open(buf, ORDWR);
		if(fd &lt; 0)
			fatal("new: open %s: %r", buf);
		write(fd, "hang", 4);
		close(fd);

		close(0);
		close(1);
		close(2);
		for(i = 3; i &lt; NFD; i++)
			close(i);

		open("/dev/cons", OREAD);
		open("/dev/cons", OWRITE);
		open("/dev/cons", OWRITE);
		exec(argv[0], argv);
		fatal("new: exec %s: %r");
	default:
		install(pid);
		msg(pid, "waitstop");
		notes(pid);
		sproc(pid);
		dostop(pid);
		break;
	}

	return pid;
}

void
notes(int pid)
{
	Lsym *s;
	Value *v;
	int i, fd;
	char buf[128];
	List *l, **tail;

	s = look("notes");
	if(s == 0)
		return;
	v = s-&gt;v;

	snprint(buf, sizeof(buf), "/proc/%d/note", pid);
	fd = open(buf, OREAD);
	if(fd &lt; 0)
		error("pid=%d: open note: %r", pid);

	v-&gt;set = 1;
	v-&gt;type = TLIST;
	v-&gt;l = 0;
	tail = &amp;v-&gt;l;
	for(;;) {
		i = read(fd, buf, sizeof(buf));
		if(i &lt;= 0)
			break;
		buf[i] = '\0';
		l = al(TSTRING);
		l-&gt;string = strnode(buf);
		l-&gt;fmt = 's';
		*tail = l;
		tail = &amp;l-&gt;next;
	}
	close(fd);
}

void
dostop(int pid)
{
	Lsym *s;
	Node *np, *p;

	s = look("stopped");
	if(s &amp;&amp; s-&gt;proc) {
		np = an(ONAME, ZN, ZN);
		np-&gt;sym = s;
		np-&gt;fmt = 'D';
		np-&gt;type = TINT;
		p = con(pid);
		p-&gt;fmt = 'D';
		np = an(OCALL, np, p);
		execute(np);
	}
}

static void
install(int pid)
{
	Lsym *s;
	List *l;
	char buf[128];
	int i, fd, new, p;

	new = -1;
	for(i = 0; i &lt; Maxproc; i++) {
		p = ptab[i].pid;
		if(p == pid)
			return;
		if(p == 0 &amp;&amp; new == -1)
			new = i;
	}
	if(new == -1)
		error("no free process slots");

	snprint(buf, sizeof(buf), "/proc/%d/ctl", pid);
	fd = open(buf, OWRITE);
	if(fd &lt; 0)
		error("pid=%d: open ctl: %r", pid);
	ptab[new].pid = pid;
	ptab[new].ctl = fd;

	s = look("proclist");
	l = al(TINT);
	l-&gt;fmt = 'D';
	l-&gt;ival = pid;
	l-&gt;next = s-&gt;v-&gt;l;
	s-&gt;v-&gt;l = l;
	s-&gt;v-&gt;set = 1;
}

void
deinstall(int pid)
{
	int i;
	Lsym *s;
	List *f, **d;

	for(i = 0; i &lt; Maxproc; i++) {
		if(ptab[i].pid == pid) {
			close(ptab[i].ctl);
			ptab[i].pid = 0;
			s = look("proclist");
			d = &amp;s-&gt;v-&gt;l;
			for(f = *d; f; f = f-&gt;next) {
				if(f-&gt;ival == pid) {
					*d = f-&gt;next;
					break;
				}
			}
			s = look("pid");
			if(s-&gt;v-&gt;ival == pid)
				s-&gt;v-&gt;ival = 0;
			return;
		}
	}
}

void
msg(int pid, char *msg)
{
	int i;
	int l;
	char err[ERRMAX];

	for(i = 0; i &lt; Maxproc; i++) {
		if(ptab[i].pid == pid) {
			l = strlen(msg);
			if(write(ptab[i].ctl, msg, l) != l) {
				errstr(err, sizeof err);
				if(strcmp(err, "process exited") == 0)
					deinstall(pid);
				error("msg: pid=%d %s: %s", pid, msg, err);
			}
			return;
		}
	}
	error("msg: pid=%d: not found for %s", pid, msg);
}

char *
getstatus(int pid)
{
	int fd, n;
	char *argv[16], buf[64];
	static char status[128];

	snprint(buf, sizeof(buf), "/proc/%d/status", pid);
	fd = open(buf, OREAD);
	if(fd &lt; 0)
		error("open %s: %r", buf);

	n = read(fd, status, sizeof(status)-1);
	close(fd);
	if(n &lt;= 0)
		error("read %s: %r", buf);
	status[n] = '\0';

	if(tokenize(status, argv, nelem(argv)-1) &lt; 3)
		error("tokenize %s: %r", buf);

	return argv[2];
}

Waitmsg*
waitfor(int pid)
{
	Waitmsg *w;

	for(;;) {
		if((w = wait()) == nil)
			error("wait %r");
		if(w-&gt;pid == pid)
			return w;
		free(w);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

