<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/exec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/exec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "fns.h"

Buffer	snarfbuf;

/*
 * These functions get called as:
 *
 *	fn(et, t, argt, flag1, flag1, flag2, s, n);
 *
 * Where the arguments are:
 *
 *	et: the Text* in which the executing event (click) occurred
 *	t: the Text* containing the current selection (Edit, Cut, Snarf, Paste)
 *	argt: the Text* containing the argument for a 2-1 click.
 *	e-&gt;flag1: from Exectab entry
 * 	e-&gt;flag2: from Exectab entry
 *	s: the command line remainder (e.g., "x" if executing "Dump x")
 *	n: length of s  (s is *not* NUL-terminated)
 */

void	del(Text*, Text*, Text*, int, int, Rune*, int);
void	delcol(Text*, Text*, Text*, int, int, Rune*, int);
void	dump(Text*, Text*, Text*, int, int, Rune*, int);
void	edit(Text*, Text*, Text*, int, int, Rune*, int);
void	exit(Text*, Text*, Text*, int, int, Rune*, int);
void	fontx(Text*, Text*, Text*, int, int, Rune*, int);
void	get(Text*, Text*, Text*, int, int, Rune*, int);
void	id(Text*, Text*, Text*, int, int, Rune*, int);
void	incl(Text*, Text*, Text*, int, int, Rune*, int);
void	indent(Text*, Text*, Text*, int, int, Rune*, int);
void	kill(Text*, Text*, Text*, int, int, Rune*, int);
void	local(Text*, Text*, Text*, int, int, Rune*, int);
void	look(Text*, Text*, Text*, int, int, Rune*, int);
void	newcol(Text*, Text*, Text*, int, int, Rune*, int);
void	paste(Text*, Text*, Text*, int, int, Rune*, int);
void	put(Text*, Text*, Text*, int, int, Rune*, int);
void	putall(Text*, Text*, Text*, int, int, Rune*, int);
void	sendx(Text*, Text*, Text*, int, int, Rune*, int);
void	sort(Text*, Text*, Text*, int, int, Rune*, int);
void	tab(Text*, Text*, Text*, int, int, Rune*, int);
void	zeroxx(Text*, Text*, Text*, int, int, Rune*, int);

typedef struct Exectab Exectab;
struct Exectab
{
	Rune	*name;
	void	(*fn)(Text*, Text*, Text*, int, int, Rune*, int);
	int		mark;
	int		flag1;
	int		flag2;
};

Exectab exectab[] = {
	{ L"Cut",		cut,		TRUE,	TRUE,	TRUE	},
	{ L"Del",		del,		FALSE,	FALSE,	XXX		},
	{ L"Delcol",	delcol,	FALSE,	XXX,		XXX		},
	{ L"Delete",	del,		FALSE,	TRUE,	XXX		},
	{ L"Dump",	dump,	FALSE,	TRUE,	XXX		},
	{ L"Edit",		edit,		FALSE,	XXX,		XXX		},
	{ L"Exit",		exit,		FALSE,	XXX,		XXX		},
	{ L"Font",		fontx,	FALSE,	XXX,		XXX		},
	{ L"Get",		get,		FALSE,	TRUE,	XXX		},
	{ L"ID",		id,		FALSE,	XXX,		XXX		},
	{ L"Incl",		incl,		FALSE,	XXX,		XXX		},
	{ L"Indent",	indent,	FALSE,	XXX,		XXX		},
	{ L"Kill",		kill,		FALSE,	XXX,		XXX		},
	{ L"Load",		dump,	FALSE,	FALSE,	XXX		},
	{ L"Local",		local,	FALSE,	XXX,		XXX		},
	{ L"Look",		look,		FALSE,	XXX,		XXX		},
	{ L"New",		new,		FALSE,	XXX,		XXX		},
	{ L"Newcol",	newcol,	FALSE,	XXX,		XXX		},
	{ L"Paste",		paste,	TRUE,	TRUE,	XXX		},
	{ L"Put",		put,		FALSE,	XXX,		XXX		},
	{ L"Putall",		putall,	FALSE,	XXX,		XXX		},
	{ L"Redo",		undo,	FALSE,	FALSE,	XXX		},
	{ L"Send",		sendx,	TRUE,	XXX,		XXX		},
	{ L"Snarf",		cut,		FALSE,	TRUE,	FALSE	},
	{ L"Sort",		sort,		FALSE,	XXX,		XXX		},
	{ L"Tab",		tab,		FALSE,	XXX,		XXX		},
	{ L"Undo",		undo,	FALSE,	TRUE,	XXX		},
	{ L"Zerox",	zeroxx,	FALSE,	XXX,		XXX		},
	{ nil, 			nil,		0,		0,		0		},
};

Exectab*
lookup(Rune *r, int n)
{
	Exectab *e;
	int nr;

	r = skipbl(r, n, &amp;n);
	if(n == 0)
		return nil;
	findbl(r, n, &amp;nr);
	nr = n-nr;
	for(e=exectab; e-&gt;name; e++)
		if(runeeq(r, nr, e-&gt;name, runestrlen(e-&gt;name)) == TRUE)
			return e;
	return nil;
}

int
isexecc(int c)
{
	if(isfilec(c))
		return 1;
	return c=='&lt;' || c=='|' || c=='&gt;';
}

void
execute(Text *t, uint aq0, uint aq1, int external, Text *argt)
{
	uint q0, q1;
	Rune *r, *s;
	char *b, *a, *aa;
	Exectab *e;
	int c, n, f;
	Runestr dir;

	q0 = aq0;
	q1 = aq1;
	if(q1 == q0){	/* expand to find word (actually file name) */
		/* if in selection, choose selection */
		if(t-&gt;q1&gt;t-&gt;q0 &amp;&amp; t-&gt;q0&lt;=q0 &amp;&amp; q0&lt;=t-&gt;q1){
			q0 = t-&gt;q0;
			q1 = t-&gt;q1;
		}else{
			while(q1&lt;t-&gt;file-&gt;nc &amp;&amp; isexecc(c=textreadc(t, q1)) &amp;&amp; c!=':')
				q1++;
			while(q0&gt;0 &amp;&amp; isexecc(c=textreadc(t, q0-1)) &amp;&amp; c!=':')
				q0--;
			if(q1 == q0)
				return;
		}
	}
	r = runemalloc(q1-q0);
	bufread(t-&gt;file, q0, r, q1-q0);
	e = lookup(r, q1-q0);
	if(!external &amp;&amp; t-&gt;w!=nil &amp;&amp; t-&gt;w-&gt;nopen[QWevent]&gt;0){
		f = 0;
		if(e)
			f |= 1;
		if(q0!=aq0 || q1!=aq1){
			bufread(t-&gt;file, aq0, r, aq1-aq0);
			f |= 2;
		}
		aa = getbytearg(argt, TRUE, TRUE, &amp;a);
		if(a){	
			if(strlen(a) &gt; EVENTSIZE){	/* too big; too bad */
				free(aa);
				free(a);
				warning(nil, "`argument string too long\n");
				return;
			}
			f |= 8;
		}
		c = 'x';
		if(t-&gt;what == Body)
			c = 'X';
		n = aq1-aq0;
		if(n &lt;= EVENTSIZE)
			winevent(t-&gt;w, "%c%d %d %d %d %.*S\n", c, aq0, aq1, f, n, n, r);
		else
			winevent(t-&gt;w, "%c%d %d %d 0 \n", c, aq0, aq1, f, n);
		if(q0!=aq0 || q1!=aq1){
			n = q1-q0;
			bufread(t-&gt;file, q0, r, n);
			if(n &lt;= EVENTSIZE)
				winevent(t-&gt;w, "%c%d %d 0 %d %.*S\n", c, q0, q1, n, n, r);
			else
				winevent(t-&gt;w, "%c%d %d 0 0 \n", c, q0, q1, n);
		}
		if(a){
			winevent(t-&gt;w, "%c0 0 0 %d %s\n", c, utflen(a), a);
			if(aa)
				winevent(t-&gt;w, "%c0 0 0 %d %s\n", c, utflen(aa), aa);
			else
				winevent(t-&gt;w, "%c0 0 0 0 \n", c);
		}
		free(r);
		free(aa);
		free(a);
		return;
	}
	if(e){
		if(e-&gt;mark &amp;&amp; seltext!=nil)
		if(seltext-&gt;what == Body){
			seq++;
			filemark(seltext-&gt;w-&gt;body.file);
		}
		s = skipbl(r, q1-q0, &amp;n);
		s = findbl(s, n, &amp;n);
		s = skipbl(s, n, &amp;n);
		(*e-&gt;fn)(t, seltext, argt, e-&gt;flag1, e-&gt;flag2, s, n);
		free(r);
		return;
	}

	b = runetobyte(r, q1-q0);
	free(r);
	dir = dirname(t, nil, 0);
	if(dir.nr==1 &amp;&amp; dir.r[0]=='.'){	/* sigh */
		free(dir.r);
		dir.r = nil;
		dir.nr = 0;
	}
	aa = getbytearg(argt, TRUE, TRUE, &amp;a);
	if(t-&gt;w)
		incref(t-&gt;w);
	run(t-&gt;w, b, dir.r, dir.nr, TRUE, aa, a, FALSE);
}

char*
printarg(Text *argt, uint q0, uint q1)
{
	char *buf;

	if(argt-&gt;what!=Body || argt-&gt;file-&gt;name==nil)
		return nil;
	buf = emalloc(argt-&gt;file-&gt;nname+32);
	if(q0 == q1)
		sprint(buf, "%.*S:#%d", argt-&gt;file-&gt;nname, argt-&gt;file-&gt;name, q0);
	else
		sprint(buf, "%.*S:#%d,#%d", argt-&gt;file-&gt;nname, argt-&gt;file-&gt;name, q0, q1);
	return buf;
}

char*
getarg(Text *argt, int doaddr, int dofile, Rune **rp, int *nrp)
{
	int n;
	Expand e;
	char *a;

	*rp = nil;
	*nrp = 0;
	if(argt == nil)
		return nil;
	a = nil;
	textcommit(argt, TRUE);
	if(expand(argt, argt-&gt;q0, argt-&gt;q1, &amp;e)){
		free(e.bname);
		if(e.nname &amp;&amp; dofile){
			e.name = runerealloc(e.name, e.nname+1);
			if(doaddr)
				a = printarg(argt, e.q0, e.q1);
			*rp = e.name;
			*nrp = e.nname;
			return a;
		}
		free(e.name);
	}else{
		e.q0 = argt-&gt;q0;
		e.q1 = argt-&gt;q1;
	}
	n = e.q1 - e.q0;
	*rp = runemalloc(n+1);
	bufread(argt-&gt;file, e.q0, *rp, n);
	if(doaddr)
		a = printarg(argt, e.q0, e.q1);
	*nrp = n;
	return a;
}

char*
getbytearg(Text *argt, int doaddr, int dofile, char **bp)
{
	Rune *r;
	int n;
	char *aa;

	*bp = nil;
	aa = getarg(argt, doaddr, dofile, &amp;r, &amp;n);
	if(r == nil)
		return nil;
	*bp = runetobyte(r, n);
	free(r);
	return aa;
}

void
newcol(Text *et, Text*, Text*, int, int, Rune*, int)
{
	Column *c;

	c = rowadd(et-&gt;row, nil, -1);
	if(c)
		winsettag(coladd(c, nil, nil, -1));
}

void
delcol(Text *et, Text*, Text*, int, int, Rune*, int)
{
	int i;
	Column *c;
	Window *w;

	c = et-&gt;col;
	if(c==nil || colclean(c)==0)
		return;
	for(i=0; i&lt;c-&gt;nw; i++){
		w = c-&gt;w[i];
		if(w-&gt;nopen[QWevent]+w-&gt;nopen[QWaddr]+w-&gt;nopen[QWdata]+w-&gt;nopen[QWxdata] &gt; 0){
			warning(nil, "can't delete column; %.*S is running an external command\n", w-&gt;body.file-&gt;nname, w-&gt;body.file-&gt;name);
			return;
		}
	}
	rowclose(et-&gt;col-&gt;row, et-&gt;col, TRUE);
}

void
del(Text *et, Text*, Text *argt, int flag1, int, Rune *arg, int narg)
{
	Window *w;
	char *name, *p;
	Plumbmsg *pm;

	if(et-&gt;col==nil || et-&gt;w == nil)
		return;
	if(flag1 || et-&gt;w-&gt;body.file-&gt;ntext&gt;1 || winclean(et-&gt;w, FALSE)){
		w = et-&gt;w;
		name = getname(&amp;w-&gt;body, argt, arg, narg, TRUE);
		if(name &amp;&amp; plumbsendfd &gt;= 0){
			pm = emalloc(sizeof(Plumbmsg));
			pm-&gt;src = estrdup("acme");
			pm-&gt;dst = estrdup("close");
			pm-&gt;wdir = estrdup(name);
			if(p = strrchr(pm-&gt;wdir, '/'))
				*p = '\0';
			pm-&gt;type = estrdup("text");
			pm-&gt;attr = nil;
			pm-&gt;data = estrdup(name);
			pm-&gt;ndata = strlen(pm-&gt;data);
			if(pm-&gt;ndata &lt; messagesize-1024)
				plumbsend(plumbsendfd, pm);
			else
				plumbfree(pm);
		}
		colclose(et-&gt;col, et-&gt;w, TRUE);
	}
}

void
sort(Text *et, Text*, Text*, int, int, Rune*, int)
{
	if(et-&gt;col)
		colsort(et-&gt;col);
}

uint
seqof(Window *w, int isundo)
{
	/* if it's undo, see who changed with us */
	if(isundo)
		return w-&gt;body.file-&gt;seq;
	/* if it's redo, see who we'll be sync'ed up with */
	return fileredoseq(w-&gt;body.file);
}

void
undo(Text *et, Text*, Text*, int flag1, int, Rune*, int)
{
	int i, j;
	Column *c;
	Window *w;
	uint seq;

	if(et==nil || et-&gt;w== nil)
		return;
	seq = seqof(et-&gt;w, flag1);
	if(seq == 0){
		/* nothing to undo */
		return;
	}
	/*
	 * Undo the executing window first. Its display will update. other windows
	 * in the same file will not call show() and jump to a different location in the file.
	 * Simultaneous changes to other files will be chaotic, however.
	 */
	winundo(et-&gt;w, flag1);
	for(i=0; i&lt;row.ncol; i++){
		c = row.col[i];
		for(j=0; j&lt;c-&gt;nw; j++){
			w = c-&gt;w[j];
			if(w == et-&gt;w)
				continue;
			if(seqof(w, flag1) == seq)
				winundo(w, flag1);
		}
	}
}

char*
getname(Text *t, Text *argt, Rune *arg, int narg, int isput)
{
	char *s;
	Rune *r;
	int i, n, promote;
	Runestr dir;

	getarg(argt, FALSE, TRUE, &amp;r, &amp;n);
	promote = FALSE;
	if(r == nil)
		promote = TRUE;
	else if(isput){
		/* if are doing a Put, want to synthesize name even for non-existent file */
		/* best guess is that file name doesn't contain a slash */
		promote = TRUE;
		for(i=0; i&lt;n; i++)
			if(r[i] == '/'){
				promote = FALSE;
				break;
			}
		if(promote){
			t = argt;
			arg = r;
			narg = n;
		}
	}
	if(promote){
		n = narg;
		if(n &lt;= 0){
			s = runetobyte(t-&gt;file-&gt;name, t-&gt;file-&gt;nname);
			return s;
		}
		/* prefix with directory name if necessary */
		dir.r = nil;
		dir.nr = 0;
		if(n&gt;0 &amp;&amp; arg[0]!='/'){
			dir = dirname(t, nil, 0);
			if(dir.nr==1 &amp;&amp; dir.r[0]=='.'){	/* sigh */
				free(dir.r);
				dir.r = nil;
				dir.nr = 0;
			}
		}
		if(dir.r){
			r = runemalloc(dir.nr+n+1);
			runemove(r, dir.r, dir.nr);
			free(dir.r);
			if(dir.nr&gt;0 &amp;&amp; r[dir.nr]!='/' &amp;&amp; n&gt;0 &amp;&amp; arg[0]!='/')
				r[dir.nr++] = '/';
			runemove(r+dir.nr, arg, n);
			n += dir.nr;
		}else{
			r = runemalloc(n+1);
			runemove(r, arg, n);
		}
	}
	s = runetobyte(r, n);
	free(r);
	if(strlen(s) == 0){
		free(s);
		s = nil;
	}
	return s;
}

void
zeroxx(Text *et, Text *t, Text*, int, int, Rune*, int)
{
	Window *nw;
	int c, locked;

	locked = FALSE;
	if(t!=nil &amp;&amp; t-&gt;w!=nil &amp;&amp; t-&gt;w!=et-&gt;w){
		locked = TRUE;
		c = 'M';
		if(et-&gt;w)
			c = et-&gt;w-&gt;owner;
		winlock(t-&gt;w, c);
	}
	if(t == nil)
		t = et;
	if(t==nil || t-&gt;w==nil)
		return;
	t = &amp;t-&gt;w-&gt;body;
	if(t-&gt;w-&gt;isdir)
		warning(nil, "%.*S is a directory; Zerox illegal\n", t-&gt;file-&gt;nname, t-&gt;file-&gt;name);
	else{
		nw = coladd(t-&gt;w-&gt;col, nil, t-&gt;w, -1);
		/* ugly: fix locks so w-&gt;unlock works */
		winlock1(nw, t-&gt;w-&gt;owner);
	}
	if(locked)
		winunlock(t-&gt;w);
}

void
get(Text *et, Text *t, Text *argt, int flag1, int, Rune *arg, int narg)
{
	char *name;
	Rune *r;
	int i, n, dirty, samename, isdir;
	Window *w;
	Text *u;
	Dir *d;

	if(flag1)
		if(et==nil || et-&gt;w==nil)
			return;
	if(!et-&gt;w-&gt;isdir &amp;&amp; (et-&gt;w-&gt;body.file-&gt;nc&gt;0 &amp;&amp; !winclean(et-&gt;w, TRUE)))
		return;
	w = et-&gt;w;
	t = &amp;w-&gt;body;
	name = getname(t, argt, arg, narg, FALSE);
	if(name == nil){
		warning(nil, "no file name\n");
		return;
	}
	if(t-&gt;file-&gt;ntext&gt;1){
		d = dirstat(name);
		isdir = (d!=nil &amp;&amp; (d-&gt;qid.type &amp; QTDIR));
		free(d);
		if(isdir){
			warning(nil, "%s is a directory; can't read with multiple windows on it\n", name);
			return;
		}
	}
	r = bytetorune(name, &amp;n);
	for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
		u = t-&gt;file-&gt;text[i];
		/* second and subsequent calls with zero an already empty buffer, but OK */
		textreset(u);
		windirfree(u-&gt;w);
	}
	samename = runeeq(r, n, t-&gt;file-&gt;name, t-&gt;file-&gt;nname);
	textload(t, 0, name, samename);
	if(samename){
		t-&gt;file-&gt;mod = FALSE;
		dirty = FALSE;
	}else{
		t-&gt;file-&gt;mod = TRUE;
		dirty = TRUE;
	}
	for(i=0; i&lt;t-&gt;file-&gt;ntext; i++)
		t-&gt;file-&gt;text[i]-&gt;w-&gt;dirty = dirty;
	free(name);
	free(r);
	winsettag(w);
	t-&gt;file-&gt;unread = FALSE;
	for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
		u = t-&gt;file-&gt;text[i];
		textsetselect(&amp;u-&gt;w-&gt;tag, u-&gt;w-&gt;tag.file-&gt;nc, u-&gt;w-&gt;tag.file-&gt;nc);
		textscrdraw(u);
	}
}

void
putfile(File *f, int q0, int q1, Rune *namer, int nname)
{
	uint n, m;
	Rune *r;
	char *s, *name, *p;
	int i, fd, q;
	Dir *d, *d1;
	Window *w;
	Plumbmsg *pm;
	int isapp;

	w = f-&gt;curtext-&gt;w;
	name = runetobyte(namer, nname);
	d = dirstat(name);
	if(d!=nil &amp;&amp; runeeq(namer, nname, f-&gt;name, f-&gt;nname)){
		/* f-&gt;mtime+1 because when talking over NFS it's often off by a second */
		if(f-&gt;dev!=d-&gt;dev || f-&gt;qidpath!=d-&gt;qid.path || f-&gt;mtime+1&lt;d-&gt;mtime){
			f-&gt;dev = d-&gt;dev;
			f-&gt;qidpath = d-&gt;qid.path;
			f-&gt;mtime = d-&gt;mtime;
			if(f-&gt;unread)
				warning(nil, "%s not written; file already exists\n", name);
			else
				warning(nil, "%s modified%s%s since last read\n", name, d-&gt;muid[0]?" by ":"", d-&gt;muid);
			goto Rescue1;
		}
	}
	fd = create(name, OWRITE, 0666);
	if(fd &lt; 0){
		warning(nil, "can't create file %s: %r\n", name);
		goto Rescue1;
	}
	r = fbufalloc();
	s = fbufalloc();
	free(d);
	d = dirfstat(fd);
	isapp = (d!=nil &amp;&amp; d-&gt;length&gt;0 &amp;&amp; (d-&gt;qid.type&amp;QTAPPEND));
	if(isapp){
		warning(nil, "%s not written; file is append only\n", name);
		goto Rescue2;
	}

	for(q=q0; q&lt;q1; q+=n){
		n = q1 - q;
		if(n &gt; BUFSIZE/UTFmax)
			n = BUFSIZE/UTFmax;
		bufread(f, q, r, n);
		m = snprint(s, BUFSIZE+1, "%.*S", n, r);
		if(write(fd, s, m) != m){
			warning(nil, "can't write file %s: %r\n", name);
			goto Rescue2;
		}
	}
	if(runeeq(namer, nname, f-&gt;name, f-&gt;nname)){
		if(q0!=0 || q1!=f-&gt;nc){
			f-&gt;mod = TRUE;
			w-&gt;dirty = TRUE;
			f-&gt;unread = TRUE;
		}else{
			d1 = dirfstat(fd);
			if(d1 != nil){
				free(d);
				d = d1;
			}
			f-&gt;qidpath = d-&gt;qid.path;
			f-&gt;dev = d-&gt;dev;
			f-&gt;mtime = d-&gt;mtime;
			f-&gt;mod = FALSE;
			w-&gt;dirty = FALSE;
			f-&gt;unread = FALSE;
		}
		for(i=0; i&lt;f-&gt;ntext; i++){
			f-&gt;text[i]-&gt;w-&gt;putseq = f-&gt;seq;
			f-&gt;text[i]-&gt;w-&gt;dirty = w-&gt;dirty;
		}
	}
	if(plumbsendfd &gt;= 0){
		pm = emalloc(sizeof(Plumbmsg));
		pm-&gt;src = estrdup("acme");
		pm-&gt;dst = estrdup("put");
		pm-&gt;wdir = estrdup(name);
		if(p = strrchr(pm-&gt;wdir, '/'))
			*p = '\0';
		pm-&gt;type = estrdup("text");
		pm-&gt;attr = nil;
		pm-&gt;data = estrdup(name);
		pm-&gt;ndata = strlen(pm-&gt;data);
		if(pm-&gt;ndata &lt; messagesize-1024)
			plumbsend(plumbsendfd, pm);
		else
			plumbfree(pm);
	}
	fbuffree(s);
	fbuffree(r);
	free(d);
	free(namer);
	free(name);
	close(fd);
	winsettag(w);
	return;

    Rescue2:
	fbuffree(s);
	fbuffree(r);
	close(fd);
	/* fall through */

    Rescue1:
	free(d);
	free(namer);
	free(name);
}

void
put(Text *et, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	int nname;
	Rune  *namer;
	Window *w;
	File *f;
	char *name;

	if(et==nil || et-&gt;w==nil || et-&gt;w-&gt;isdir)
		return;
	w = et-&gt;w;
	f = w-&gt;body.file;
	name = getname(&amp;w-&gt;body, argt, arg, narg, TRUE);
	if(name == nil){
		warning(nil, "no file name\n");
		return;
	}
	namer = bytetorune(name, &amp;nname);
	putfile(f, 0, f-&gt;nc, namer, nname);
	free(name);
}

void
dump(Text *, Text *, Text *argt, int isdump, int, Rune *arg, int narg)
{
	char *name;

	if(narg)
		name = runetobyte(arg, narg);
	else
		getbytearg(argt, FALSE, TRUE, &amp;name);
	if(isdump)
		rowdump(&amp;row, name);
	else
		rowload(&amp;row, name, FALSE);
	free(name);
}

void
cut(Text *et, Text *t, Text*, int dosnarf, int docut, Rune*, int)
{
	uint q0, q1, n, locked, c;
	Rune *r;

	/*
	 * if not executing a mouse chord (et != t) and snarfing (dosnarf)
	 * and executed Cut or Snarf in window tag (et-&gt;w != nil),
	 * then use the window body selection or the tag selection
	 * or do nothing at all.
	 */
	if(et!=t &amp;&amp; dosnarf &amp;&amp; et-&gt;w!=nil){
		if(et-&gt;w-&gt;body.q1&gt;et-&gt;w-&gt;body.q0){
			t = &amp;et-&gt;w-&gt;body;
			if(docut)
				filemark(t-&gt;file);	/* seq has been incremented by execute */
		}else if(et-&gt;w-&gt;tag.q1&gt;et-&gt;w-&gt;tag.q0)
			t = &amp;et-&gt;w-&gt;tag;
		else
			t = nil;
	}
	if(t == nil)	/* no selection */
		return;

	locked = FALSE;
	if(t-&gt;w!=nil &amp;&amp; et-&gt;w!=t-&gt;w){
		locked = TRUE;
		c = 'M';
		if(et-&gt;w)
			c = et-&gt;w-&gt;owner;
		winlock(t-&gt;w, c);
	}
	if(t-&gt;q0 == t-&gt;q1){
		if(locked)
			winunlock(t-&gt;w);
		return;
	}
	if(dosnarf){
		q0 = t-&gt;q0;
		q1 = t-&gt;q1;
		bufdelete(&amp;snarfbuf, 0, snarfbuf.nc);
		r = fbufalloc();
		while(q0 &lt; q1){
			n = q1 - q0;
			if(n &gt; RBUFSIZE)
				n = RBUFSIZE;
			bufread(t-&gt;file, q0, r, n);
			bufinsert(&amp;snarfbuf, snarfbuf.nc, r, n);
			q0 += n;
		}
		fbuffree(r);
		putsnarf();
	}
	if(docut){
		textdelete(t, t-&gt;q0, t-&gt;q1, TRUE);
		textsetselect(t, t-&gt;q0, t-&gt;q0);
		if(t-&gt;w){
			textscrdraw(t);
			winsettag(t-&gt;w);
		}
	}else if(dosnarf)	/* Snarf command */
		argtext = t;
	if(locked)
		winunlock(t-&gt;w);
}

void
paste(Text *et, Text *t, Text*, int selectall, int tobody, Rune*, int)
{
	int c;
	uint q, q0, q1, n;
	Rune *r;

	/* if(tobody), use body of executing window  (Paste or Send command) */
	if(tobody &amp;&amp; et!=nil &amp;&amp; et-&gt;w!=nil){
		t = &amp;et-&gt;w-&gt;body;
		filemark(t-&gt;file);	/* seq has been incremented by execute */
	}
	if(t == nil)
		return;

	getsnarf();
	if(t==nil || snarfbuf.nc==0)
		return;
	if(t-&gt;w!=nil &amp;&amp; et-&gt;w!=t-&gt;w){
		c = 'M';
		if(et-&gt;w)
			c = et-&gt;w-&gt;owner;
		winlock(t-&gt;w, c);
	}
	cut(t, t, nil, FALSE, TRUE, nil, 0);
	q = 0;
	q0 = t-&gt;q0;
	q1 = t-&gt;q0+snarfbuf.nc;
	r = fbufalloc();
	while(q0 &lt; q1){
		n = q1 - q0;
		if(n &gt; RBUFSIZE)
			n = RBUFSIZE;
		if(r == nil)
			r = runemalloc(n);
		bufread(&amp;snarfbuf, q, r, n);
		textinsert(t, q0, r, n, TRUE);
		q += n;
		q0 += n;
	}
	fbuffree(r);
	if(selectall)
		textsetselect(t, t-&gt;q0, q1);
	else
		textsetselect(t, q1, q1);
	if(t-&gt;w){
		textscrdraw(t);
		winsettag(t-&gt;w);
	}
	if(t-&gt;w!=nil &amp;&amp; et-&gt;w!=t-&gt;w)
		winunlock(t-&gt;w);
}

void
look(Text *et, Text *t, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *r;
	int n;

	if(et &amp;&amp; et-&gt;w){
		t = &amp;et-&gt;w-&gt;body;
		if(narg &gt; 0){
			search(t, arg, narg);
			return;
		}
		getarg(argt, FALSE, FALSE, &amp;r, &amp;n);
		if(r == nil){
			n = t-&gt;q1-t-&gt;q0;
			r = runemalloc(n);
			bufread(t-&gt;file, t-&gt;q0, r, n);
		}
		search(t, r, n);
		free(r);
	}
}

void
sendx(Text *et, Text *t, Text*, int, int, Rune*, int)
{
	if(et-&gt;w==nil)
		return;
	t = &amp;et-&gt;w-&gt;body;
	if(t-&gt;q0 != t-&gt;q1)
		cut(t, t, nil, TRUE, FALSE, nil, 0);
	textsetselect(t, t-&gt;file-&gt;nc, t-&gt;file-&gt;nc);
	paste(t, t, nil, TRUE, TRUE, nil, 0);
	if(textreadc(t, t-&gt;file-&gt;nc-1) != '\n'){
		textinsert(t, t-&gt;file-&gt;nc, L"\n", 1, TRUE);
		textsetselect(t, t-&gt;file-&gt;nc, t-&gt;file-&gt;nc);
	}
}

void
edit(Text *et, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *r;
	int len;

	if(et == nil)
		return;
	getarg(argt, FALSE, TRUE, &amp;r, &amp;len);
	seq++;
	if(r != nil){
		editcmd(et, r, len);
		free(r);
	}else
		editcmd(et, arg, narg);
}

void
exit(Text*, Text*, Text*, int, int, Rune*, int)
{
	if(rowclean(&amp;row)){
		sendul(cexit, 0);
		threadexits(nil);
	}
}

void
putall(Text*, Text*, Text*, int, int, Rune*, int)
{
	int i, j, e;
	Window *w;
	Column *c;
	char *a;

	for(i=0; i&lt;row.ncol; i++){
		c = row.col[i];
		for(j=0; j&lt;c-&gt;nw; j++){
			w = c-&gt;w[j];
			if(w-&gt;isscratch || w-&gt;isdir || w-&gt;body.file-&gt;nname==0)
				continue;
			if(w-&gt;nopen[QWevent] &gt; 0)
				continue;
			a = runetobyte(w-&gt;body.file-&gt;name, w-&gt;body.file-&gt;nname);
			e = access(a, 0);
			if(w-&gt;body.file-&gt;mod || w-&gt;body.ncache)
				if(e &lt; 0)
					warning(nil, "no auto-Put of %s: %r\n", a);
				else{
					wincommit(w, &amp;w-&gt;body);
					put(&amp;w-&gt;body, nil, nil, XXX, XXX, nil, 0);
				}
			free(a);
		}
	}
}


void
id(Text *et, Text*, Text*, int, int, Rune*, int)
{
	if(et &amp;&amp; et-&gt;w)
		warning(nil, "/mnt/acme/%d/\n", et-&gt;w-&gt;id);
}

void
local(Text *et, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	char *a, *aa;
	Runestr dir;

	aa = getbytearg(argt, TRUE, TRUE, &amp;a);

	dir = dirname(et, nil, 0);
	if(dir.nr==1 &amp;&amp; dir.r[0]=='.'){	/* sigh */
		free(dir.r);
		dir.r = nil;
		dir.nr = 0;
	}
	run(nil, runetobyte(arg, narg), dir.r, dir.nr, FALSE, aa, a, FALSE);
}

void
kill(Text*, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *a, *cmd, *r;
	int na;

	getarg(argt, FALSE, FALSE, &amp;r, &amp;na);
	if(r)
		kill(nil, nil, nil, 0, 0, r, na);
	/* loop condition: *arg is not a blank */
	for(;;){
		a = findbl(arg, narg, &amp;na);
		if(a == arg)
			break;
		cmd = runemalloc(narg-na+1);
		runemove(cmd, arg, narg-na);
		sendp(ckill, cmd);
		arg = skipbl(a, na, &amp;narg);
	}
}

void
fontx(Text *et, Text *t, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *a, *r, *flag, *file;
	int na, nf;
	char *aa;
	Reffont *newfont;
	Dirlist *dp;
	int i, fix;

	if(et==nil || et-&gt;w==nil)
		return;
	t = &amp;et-&gt;w-&gt;body;
	flag = nil;
	file = nil;
	/* loop condition: *arg is not a blank */
	nf = 0;
	for(;;){
		a = findbl(arg, narg, &amp;na);
		if(a == arg)
			break;
		r = runemalloc(narg-na+1);
		runemove(r, arg, narg-na);
		if(runeeq(r, narg-na, L"fix", 3) || runeeq(r, narg-na, L"var", 3)){
			free(flag);
			flag = r;
		}else{
			free(file);
			file = r;
			nf = narg-na;
		}
		arg = skipbl(a, na, &amp;narg);
	}
	getarg(argt, FALSE, TRUE, &amp;r, &amp;na);
	if(r)
		if(runeeq(r, na, L"fix", 3) || runeeq(r, na, L"var", 3)){
			free(flag);
			flag = r;
		}else{
			free(file);
			file = r;
			nf = na;
		}
	fix = 1;
	if(flag)
		fix = runeeq(flag, runestrlen(flag), L"fix", 3);
	else if(file == nil){
		newfont = rfget(FALSE, FALSE, FALSE, nil);
		if(newfont)
			fix = strcmp(newfont-&gt;f-&gt;name, t-&gt;font-&gt;name)==0;
	}
	if(file){
		aa = runetobyte(file, nf);
		newfont = rfget(fix, flag!=nil, FALSE, aa);
		free(aa);
	}else
		newfont = rfget(fix, FALSE, FALSE, nil);
	if(newfont){
		draw(screen, t-&gt;w-&gt;r, textcols[BACK], nil, ZP);
		rfclose(t-&gt;reffont);
		t-&gt;reffont = newfont;
		t-&gt;font = newfont-&gt;f;
		frinittick(t);
		if(t-&gt;w-&gt;isdir){
			t-&gt;all.min.x++;	/* force recolumnation; disgusting! */
			for(i=0; i&lt;t-&gt;w-&gt;ndl; i++){
				dp = t-&gt;w-&gt;dlp[i];
				aa = runetobyte(dp-&gt;r, dp-&gt;nr);
				dp-&gt;wid = stringwidth(newfont-&gt;f, aa);
				free(aa);
			}
		}
		/* avoid shrinking of window due to quantization */
		colgrow(t-&gt;w-&gt;col, t-&gt;w, -1);
	}
	free(file);
	free(flag);
}

void
incl(Text *et, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *a, *r;
	Window *w;
	int na, n, len;

	if(et==nil || et-&gt;w==nil)
		return;
	w = et-&gt;w;
	n = 0;
	getarg(argt, FALSE, TRUE, &amp;r, &amp;len);
	if(r){
		n++;
		winaddincl(w, r, len);
	}
	/* loop condition: *arg is not a blank */
	for(;;){
		a = findbl(arg, narg, &amp;na);
		if(a == arg)
			break;
		r = runemalloc(narg-na+1);
		runemove(r, arg, narg-na);
		n++;
		winaddincl(w, r, narg-na);
		arg = skipbl(a, na, &amp;narg);
	}
	if(n==0 &amp;&amp; w-&gt;nincl){
		for(n=w-&gt;nincl; --n&gt;=0; )
			warning(nil, "%S ", w-&gt;incl[n]);
		warning(nil, "\n");
	}
}

enum {
	IGlobal = -2,
	IError = -1,
	Ion = 0,
	Ioff = 1,
};

static int
indentval(Rune *s, int n)
{
	if(n &lt; 2)
		return IError;
	if(runestrncmp(s, L"ON", n) == 0){
		globalautoindent = TRUE;
		warning(nil, "Indent ON\n");
		return IGlobal;
	}
	if(runestrncmp(s, L"OFF", n) == 0){
		globalautoindent = FALSE;
		warning(nil, "Indent OFF\n");
		return IGlobal;
	}
	return runestrncmp(s, L"on", n) == 0;
}

static void
fixindent(Window *w, void*)
{
	w-&gt;autoindent = globalautoindent;
}

void
indent(Text *et, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *a, *r;
	Window *w;
	int na, len, autoindent;

	w = nil;
	if(et!=nil &amp;&amp; et-&gt;w!=nil)
		w = et-&gt;w;
	autoindent = IError;
	getarg(argt, FALSE, TRUE, &amp;r, &amp;len);
	if(r!=nil &amp;&amp; len&gt;0)
		autoindent = indentval(r, len);
	else{
		a = findbl(arg, narg, &amp;na);
		if(a != arg)
			autoindent = indentval(arg, narg-na);
	}
	if(autoindent == IGlobal)
		allwindows(fixindent, nil);
	else if(w != nil &amp;&amp; autoindent &gt;= 0)
		w-&gt;autoindent = autoindent;
}

void
tab(Text *et, Text*, Text *argt, int, int, Rune *arg, int narg)
{
	Rune *a, *r;
	Window *w;
	int na, len, tab;
	char *p;

	if(et==nil || et-&gt;w==nil)
		return;
	w = et-&gt;w;
	getarg(argt, FALSE, TRUE, &amp;r, &amp;len);
	tab = 0;
	if(r!=nil &amp;&amp; len&gt;0){
		p = runetobyte(r, len);
		if('0'&lt;=p[0] &amp;&amp; p[0]&lt;='9')
			tab = atoi(p);
		free(p);
	}else{
		a = findbl(arg, narg, &amp;na);
		if(a != arg){
			p = runetobyte(arg, narg-na);
			if('0'&lt;=p[0] &amp;&amp; p[0]&lt;='9')
				tab = atoi(p);
			free(p);
		}
	}
	if(tab &gt; 0){
		if(w-&gt;body.tabstop != tab){
			w-&gt;body.tabstop = tab;
			winresize(w, w-&gt;r, 1);
		}
	}else
		warning(nil, "%.*S: Tab %d\n", w-&gt;body.file-&gt;nname, w-&gt;body.file-&gt;name, w-&gt;body.tabstop);
}

void
runproc(void *argvp)
{
	/* args: */
		Window *win;
		char *s;
		Rune *rdir;
		int ndir;
		int newns;
		char *argaddr;
		char *arg;
		Command *c;
		Channel *cpid;
		int iseditcmd;
	/* end of args */
	char *e, *t, *name, *filename, *dir, **av, *news;
	Rune r, **incl;
	int ac, w, inarg, i, n, fd, nincl, winid;
	int pipechar;
	char buf[512];
	static void *parg[2];
	void **argv;

	argv = argvp;
	win = argv[0];
	s = argv[1];
	rdir = argv[2];
	ndir = (uintptr)argv[3];
	newns = (uintptr)argv[4];
	argaddr = argv[5];
	arg = argv[6];
	c = argv[7];
	cpid = argv[8];
	iseditcmd = (uintptr)argv[9];
	free(argv);

	t = s;
	while(*t==' ' || *t=='\n' || *t=='\t')
		t++;
	for(e=t; *e; e++)
		if(*e==' ' || *e=='\n' || *e=='\t' )
			break;
	name = emalloc((e-t)+2);
	memmove(name, t, e-t);
	name[e-t] = 0;
	e = utfrrune(name, '/');
	if(e)
		memmove(name, e+1, strlen(e+1)+1);	/* strcpy but overlaps */
	strcat(name, " ");	/* add blank here for ease in waittask */
	c-&gt;name = bytetorune(name, &amp;c-&gt;nname);
	free(name);
	pipechar = 0;
	if(*t=='&lt;' || *t=='|' || *t=='&gt;')
		pipechar = *t++;
	c-&gt;iseditcmd = iseditcmd;
	c-&gt;text = s;
	if(rdir != nil){
		dir = runetobyte(rdir, ndir);
		chdir(dir);	/* ignore error: probably app. window */
		free(dir);
	}
	if(newns){
		nincl = 0;
		incl = nil;
		if(win){
			filename = smprint("%.*S", win-&gt;body.file-&gt;nname, win-&gt;body.file-&gt;name);
			nincl = win-&gt;nincl;
			if(nincl &gt; 0){
				incl = emalloc(nincl*sizeof(Rune*));
				for(i=0; i&lt;nincl; i++){
					n = runestrlen(win-&gt;incl[i]);
					incl[i] = runemalloc(n+1);
					runemove(incl[i], win-&gt;incl[i], n);
				}
			}
			winid = win-&gt;id;
		}else{
			filename = nil;
			winid = 0;
			if(activewin)
				winid = activewin-&gt;id;
		}
		rfork(RFNAMEG|RFENVG|RFFDG|RFNOTEG);
		sprint(buf, "%d", winid);
		putenv("winid", buf);

		if(filename){
			putenv("%", filename);
			free(filename);
		}
		c-&gt;md = fsysmount(rdir, ndir, incl, nincl);
		if(c-&gt;md == nil){
			fprint(2, "child: can't mount /dev/cons: %r\n");
			threadexits("mount");
		}
		close(0);
		if(winid&gt;0 &amp;&amp; (pipechar=='|' || pipechar=='&gt;')){
			sprint(buf, "/mnt/acme/%d/rdsel", winid);
			open(buf, OREAD);
		}else
			open("/dev/null", OREAD);
		close(1);
		if((winid&gt;0 || iseditcmd) &amp;&amp; (pipechar=='|' || pipechar=='&lt;')){
			if(iseditcmd){
				if(winid &gt; 0)
					sprint(buf, "/mnt/acme/%d/editout", winid);
				else
					sprint(buf, "/mnt/acme/editout");
			}else
				sprint(buf, "/mnt/acme/%d/wrsel", winid);
			open(buf, OWRITE);
			close(2);
			open("/dev/cons", OWRITE);
		}else{
			open("/dev/cons", OWRITE);
			dup(1, 2);
		}
	}else{
		rfork(RFFDG|RFNOTEG);
		fsysclose();
		close(0);
		open("/dev/null", OREAD);
		close(1);
		open(acmeerrorfile, OWRITE);
		dup(1, 2);
	}

	if(win)
		winclose(win);

	if(argaddr)
		putenv("acmeaddr", argaddr);
	if(strlen(t) &gt; sizeof buf-10)	/* may need to print into stack */
		goto Hard;
	inarg = FALSE;
	for(e=t; *e; e+=w){
		w = chartorune(&amp;r, e);
		if(r==' ' || r=='\t')
			continue;
		if(r &lt; ' ')
			goto Hard;
		if(utfrune("#;&amp;|^$=`'{}()&lt;&gt;[]*?^~`", r))
			goto Hard;
		inarg = TRUE;
	}
	if(!inarg)
		goto Fail;

	ac = 0;
	av = nil;
	inarg = FALSE;
	for(e=t; *e; e+=w){
		w = chartorune(&amp;r, e);
		if(r==' ' || r=='\t'){
			inarg = FALSE;
			*e = 0;
			continue;
		}
		if(!inarg){
			inarg = TRUE;
			av = realloc(av, (ac+1)*sizeof(char**));
			av[ac++] = e;
		}
	}
	av = realloc(av, (ac+2)*sizeof(char**));
	av[ac++] = arg;
	av[ac] = nil;
	c-&gt;av = av;
	procexec(cpid, av[0], av);
	e = av[0];
	if(e[0]=='/' || (e[0]=='.' &amp;&amp; e[1]=='/'))
		goto Fail;
	if(cputype){
		sprint(buf, "%s/%s", cputype, av[0]);
		procexec(cpid, buf, av);
	}
	sprint(buf, "/bin/%s", av[0]);
	procexec(cpid, buf, av);
	goto Fail;

Hard:

	/*
	 * ugly: set path = (. $cputype /bin)
	 * should honor $path if unusual.
	 */
	if(cputype){
		n = 0;
		memmove(buf+n, ".", 2);
		n += 2;
		i = strlen(cputype)+1;
		memmove(buf+n, cputype, i);
		n += i;
		memmove(buf+n, "/bin", 5);
		n += 5;
		fd = create("/env/path", OWRITE, 0666);
		write(fd, buf, n);
		close(fd);
	}

	if(arg){
		news = emalloc(strlen(t) + 1 + 1 + strlen(arg) + 1 + 1);
		if(news){
			sprint(news, "%s '%s'", t, arg);	/* BUG: what if quote in arg? */
			free(s);
			t = news;
			c-&gt;text = news;
		}
	}
	procexecl(cpid, "/bin/rc", "rc", "-c", t, nil);

   Fail:
	/* procexec hasn't happened, so send a zero */
	sendul(cpid, 0);
	threadexits(nil);
}

void
runwaittask(void *v)
{
	Command *c;
	Channel *cpid;
	void **a;

	threadsetname("runwaittask");
	a = v;
	c = a[0];
	cpid = a[1];
	free(a);
	do
		c-&gt;pid = recvul(cpid);
	while(c-&gt;pid == ~0);
	free(c-&gt;av);
	if(c-&gt;pid != 0)	/* successful exec */
		sendp(ccommand, c);
	else{
		if(c-&gt;iseditcmd)
			sendul(cedit, 0);
		free(c-&gt;name);
		free(c-&gt;text);
		free(c);
	}
	chanfree(cpid);
}

void
run(Window *win, char *s, Rune *rdir, int ndir, int newns, char *argaddr, char *xarg, int iseditcmd)
{
	void **arg;
	Command *c;
	Channel *cpid;

	if(s == nil)
		return;

	arg = emalloc(10*sizeof(void*));
	c = emalloc(sizeof *c);
	cpid = chancreate(sizeof(ulong), 0);
	arg[0] = win;
	arg[1] = s;
	arg[2] = rdir;
	arg[3] = (void*)ndir;
	arg[4] = (void*)newns;
	arg[5] = argaddr;
	arg[6] = xarg;
	arg[7] = c;
	arg[8] = cpid;
	arg[9] = (void*)iseditcmd;
	proccreate(runproc, arg, STACK);
	/* mustn't block here because must be ready to answer mount() call in run() */
	arg = emalloc(2*sizeof(void*));
	arg[0] = c;
	arg[1] = cpid;
	threadcreate(runwaittask, arg, STACK);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

