<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/file.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/file.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "fns.h"

/*
 * Structure of Undo list:
 * 	The Undo structure follows any associated data, so the list
 *	can be read backwards: read the structure, then read whatever
 *	data is associated (insert string, file name) and precedes it.
 *	The structure includes the previous value of the modify bit
 *	and a sequence number; successive Undo structures with the
 *	same sequence number represent simultaneous changes.
 */

typedef struct Undo Undo;
struct Undo
{
	short	type;		/* Delete, Insert, Filename */
	short	mod;	/* modify bit */
	uint		seq;		/* sequence number */
	uint		p0;		/* location of change (unused in f) */
	uint		n;		/* # runes in string or file name */
};

enum
{
	Undosize = sizeof(Undo)/sizeof(Rune),
};

File*
fileaddtext(File *f, Text *t)
{
	if(f == nil){
		f = emalloc(sizeof(File));
		f-&gt;unread = TRUE;
	}
	f-&gt;text = realloc(f-&gt;text, (f-&gt;ntext+1)*sizeof(Text*));
	f-&gt;text[f-&gt;ntext++] = t;
	f-&gt;curtext = t;
	return f;
}

void
filedeltext(File *f, Text *t)
{
	int i;

	for(i=0; i&lt;f-&gt;ntext; i++)
		if(f-&gt;text[i] == t)
			goto Found;
	error("can't find text in filedeltext");

    Found:
	f-&gt;ntext--;
	if(f-&gt;ntext == 0){
		fileclose(f);
		return;
	}
	memmove(f-&gt;text+i, f-&gt;text+i+1, (f-&gt;ntext-i)*sizeof(Text*));
	if(f-&gt;curtext == t)
		f-&gt;curtext = f-&gt;text[0];
}

void
fileinsert(File *f, uint p0, Rune *s, uint ns)
{
	if(p0 &gt; f-&gt;nc)
		error("internal error: fileinsert");
	if(f-&gt;seq &gt; 0)
		fileuninsert(f, &amp;f-&gt;delta, p0, ns);
	bufinsert(f, p0, s, ns);
	if(ns)
		f-&gt;mod = TRUE;
}

void
fileuninsert(File *f, Buffer *delta, uint p0, uint ns)
{
	Undo u;

	/* undo an insertion by deleting */
	u.type = Delete;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = p0;
	u.n = ns;
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

void
filedelete(File *f, uint p0, uint p1)
{
	if(!(p0&lt;=p1 &amp;&amp; p0&lt;=f-&gt;nc &amp;&amp; p1&lt;=f-&gt;nc))
		error("internal error: filedelete");
	if(f-&gt;seq &gt; 0)
		fileundelete(f, &amp;f-&gt;delta, p0, p1);
	bufdelete(f, p0, p1);
	if(p1 &gt; p0)
		f-&gt;mod = TRUE;
}

void
fileundelete(File *f, Buffer *delta, uint p0, uint p1)
{
	Undo u;
	Rune *buf;
	uint i, n;

	/* undo a deletion by inserting */
	u.type = Insert;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = p0;
	u.n = p1-p0;
	buf = fbufalloc();
	for(i=p0; i&lt;p1; i+=n){
		n = p1 - i;
		if(n &gt; RBUFSIZE)
			n = RBUFSIZE;
		bufread(f, i, buf, n);
		bufinsert(delta, delta-&gt;nc, buf, n);
	}
	fbuffree(buf);
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);

}

void
filesetname(File *f, Rune *name, int n)
{
	if(f-&gt;seq &gt; 0)
		fileunsetname(f, &amp;f-&gt;delta);
	free(f-&gt;name);
	f-&gt;name = runemalloc(n);
	runemove(f-&gt;name, name, n);
	f-&gt;nname = n;
	f-&gt;unread = TRUE;
}

void
fileunsetname(File *f, Buffer *delta)
{
	Undo u;

	/* undo a file name change by restoring old name */
	u.type = Filename;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = 0;	/* unused */
	u.n = f-&gt;nname;
	if(f-&gt;nname)
		bufinsert(delta, delta-&gt;nc, f-&gt;name, f-&gt;nname);
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

uint
fileload(File *f, uint p0, int fd, int *nulls)
{
	if(f-&gt;seq &gt; 0)
		error("undo in file.load unimplemented");
	return bufload(f, p0, fd, nulls);
}

/* return sequence number of pending redo */
uint
fileredoseq(File *f)
{
	Undo u;
	Buffer *delta;

	delta = &amp;f-&gt;epsilon;
	if(delta-&gt;nc == 0)
		return 0;
	bufread(delta, delta-&gt;nc-Undosize, (Rune*)&amp;u, Undosize);
	return u.seq;
}

void
fileundo(File *f, int isundo, uint *q0p, uint *q1p)
{
	Undo u;
	Rune *buf;
	uint i, j, n, up;
	uint stop;
	Buffer *delta, *epsilon;

	if(isundo){
		/* undo; reverse delta onto epsilon, seq decreases */
		delta = &amp;f-&gt;delta;
		epsilon = &amp;f-&gt;epsilon;
		stop = f-&gt;seq;
	}else{
		/* redo; reverse epsilon onto delta, seq increases */
		delta = &amp;f-&gt;epsilon;
		epsilon = &amp;f-&gt;delta;
		stop = 0;	/* don't know yet */
	}

	buf = fbufalloc();
	while(delta-&gt;nc &gt; 0){
		up = delta-&gt;nc-Undosize;
		bufread(delta, up, (Rune*)&amp;u, Undosize);
		if(isundo){
			if(u.seq &lt; stop){
				f-&gt;seq = u.seq;
				goto Return;
			}
		}else{
			if(stop == 0)
				stop = u.seq;
			if(u.seq &gt; stop)
				goto Return;
		}
		switch(u.type){
		default:
			fprint(2, "undo: 0x%ux\n", u.type);
			abort();
			break;

		case Delete:
			f-&gt;seq = u.seq;
			fileundelete(f, epsilon, u.p0, u.p0+u.n);
			f-&gt;mod = u.mod;
			bufdelete(f, u.p0, u.p0+u.n);
			for(j=0; j&lt;f-&gt;ntext; j++)
				textdelete(f-&gt;text[j], u.p0, u.p0+u.n, FALSE);
			*q0p = u.p0;
			*q1p = u.p0;
			break;

		case Insert:
			f-&gt;seq = u.seq;
			fileuninsert(f, epsilon, u.p0, u.n);
			f-&gt;mod = u.mod;
			up -= u.n;
			for(i=0; i&lt;u.n; i+=n){
				n = u.n - i;
				if(n &gt; RBUFSIZE)
					n = RBUFSIZE;
				bufread(delta, up+i, buf, n);
				bufinsert(f, u.p0+i, buf, n);
				for(j=0; j&lt;f-&gt;ntext; j++)
					textinsert(f-&gt;text[j], u.p0+i, buf, n, FALSE);
			}
			*q0p = u.p0;
			*q1p = u.p0+u.n;
			break;

		case Filename:
			f-&gt;seq = u.seq;
			fileunsetname(f, epsilon);
			f-&gt;mod = u.mod;
			up -= u.n;
			free(f-&gt;name);
			if(u.n == 0)
				f-&gt;name = nil;
			else
				f-&gt;name = runemalloc(u.n);
			bufread(delta, up, f-&gt;name, u.n);
			f-&gt;nname = u.n;
			break;
		}
		bufdelete(delta, up, delta-&gt;nc);
	}
	if(isundo)
		f-&gt;seq = 0;
    Return:
	fbuffree(buf);
}

void
filereset(File *f)
{
	bufreset(&amp;f-&gt;delta);
	bufreset(&amp;f-&gt;epsilon);
	f-&gt;seq = 0;
}

void
fileclose(File *f)
{
	free(f-&gt;name);
	f-&gt;nname = 0;
	f-&gt;name = nil;
	free(f-&gt;text);
	f-&gt;ntext = 0;
	f-&gt;text = nil;
	bufclose(f);
	bufclose(&amp;f-&gt;delta);
	bufclose(&amp;f-&gt;epsilon);
	elogclose(f);
	free(f);
}

void
filemark(File *f)
{
	if(f-&gt;epsilon.nc)
		bufdelete(&amp;f-&gt;epsilon, 0, f-&gt;epsilon.nc);
	f-&gt;seq = seq;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

