<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/xfid.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/xfid.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "fns.h"

enum
{
	Ctlsize	= 5*12
};

char	Edel[]		= "deleted window";
char	Ebadctl[]		= "ill-formed control message";
char	Ebadaddr[]	= "bad address syntax";
char	Eaddr[]		= "address out of range";
char	Einuse[]		= "already in use";
char	Ebadevent[]	= "bad event syntax";
extern char Eperm[];

static
void
clampaddr(Window *w)
{
	if(w-&gt;addr.q0 &lt; 0)
		w-&gt;addr.q0 = 0;
	if(w-&gt;addr.q1 &lt; 0)
		w-&gt;addr.q1 = 0;
	if(w-&gt;addr.q0 &gt; w-&gt;body.file-&gt;nc)
		w-&gt;addr.q0 = w-&gt;body.file-&gt;nc;
	if(w-&gt;addr.q1 &gt; w-&gt;body.file-&gt;nc)
		w-&gt;addr.q1 = w-&gt;body.file-&gt;nc;
}

void
xfidctl(void *arg)
{
	Xfid *x;
	void (*f)(Xfid*);

	threadsetname("xfidctlthread");
	x = arg;
	for(;;){
		f = recvp(x-&gt;c);
		(*f)(x);
		flushimage(display, 1);
		sendp(cxfidfree, x);
	}
}

void
xfidflush(Xfid *x)
{
	Fcall fc;
	int i, j;
	Window *w;
	Column *c;
	Xfid *wx;

	/* search windows for matching tag */
	qlock(&amp;row);
	for(j=0; j&lt;row.ncol; j++){
		c = row.col[j];
		for(i=0; i&lt;c-&gt;nw; i++){
			w = c-&gt;w[i];
			winlock(w, 'E');
			wx = w-&gt;eventx;
			if(wx!=nil &amp;&amp; wx-&gt;tag==x-&gt;oldtag){
				w-&gt;eventx = nil;
				wx-&gt;flushed = TRUE;
				sendp(wx-&gt;c, nil);
				winunlock(w);
				goto out;
			}
			winunlock(w);
		}
	}
out:
	qunlock(&amp;row);
	respond(x, &amp;fc, nil);
}

void
xfidopen(Xfid *x)
{
	Fcall fc;
	Window *w;
	Text *t;
	char *s;
	Rune *r;
	int m, n, q, q0, q1;

	w = x-&gt;f-&gt;w;
	t = &amp;w-&gt;body;
	if(w){
		winlock(w, 'E');
		q = FILE(x-&gt;f-&gt;qid);
		switch(q){
		case QWaddr:
			if(w-&gt;nopen[q]++ == 0){
				w-&gt;addr = (Range){0,0};
				w-&gt;limit = (Range){-1,-1};
			}
			break;
		case QWdata:
		case QWxdata:
			w-&gt;nopen[q]++;
			break;
		case QWevent:
			if(w-&gt;nopen[q]++ == 0){
				if(!w-&gt;isdir &amp;&amp; w-&gt;col!=nil){
					w-&gt;filemenu = FALSE;
					winsettag(w);
				}
			}
			break;
		case QWrdsel:
			/*
			 * Use a temporary file.
			 * A pipe would be the obvious, but we can't afford the
			 * broken pipe notification.  Using the code to read QWbody
			 * is n², which should probably also be fixed.  Even then,
			 * though, we'd need to squirrel away the data in case it's
			 * modified during the operation, e.g. by |sort
			 */
			if(w-&gt;rdselfd &gt; 0){
				winunlock(w);
				respond(x, &amp;fc, Einuse);
				return;
			}
			w-&gt;rdselfd = tempfile();
			if(w-&gt;rdselfd &lt; 0){
				winunlock(w);
				respond(x, &amp;fc, "can't create temp file");
				return;
			}
			w-&gt;nopen[q]++;
			q0 = t-&gt;q0;
			q1 = t-&gt;q1;
			r = fbufalloc();
			s = fbufalloc();
			while(q0 &lt; q1){
				n = q1 - q0;
				if(n &gt; BUFSIZE/UTFmax)
					n = BUFSIZE/UTFmax;
				bufread(t-&gt;file, q0, r, n);
				m = snprint(s, BUFSIZE+1, "%.*S", n, r);
				if(write(w-&gt;rdselfd, s, m) != m){
					warning(nil, "can't write temp file for pipe command %r\n");
					break;
				}
				q0 += n;
			}
			fbuffree(s);
			fbuffree(r);
			break;
		case QWwrsel:
			w-&gt;nopen[q]++;
			seq++;
			filemark(t-&gt;file);
			cut(t, t, nil, FALSE, TRUE, nil, 0);
			w-&gt;wrselrange = (Range){t-&gt;q1, t-&gt;q1};
			w-&gt;nomark = TRUE;
			break;
		case QWeditout:
			if(editing == FALSE){
				winunlock(w);
				respond(x, &amp;fc, Eperm);
				return;
			}
			w-&gt;wrselrange = (Range){t-&gt;q1, t-&gt;q1};
			break;
		}
		winunlock(w);
	}
	fc.qid = x-&gt;f-&gt;qid;
	fc.iounit = messagesize-IOHDRSZ;
	x-&gt;f-&gt;open = TRUE;
	respond(x, &amp;fc, nil);
}

void
xfidclose(Xfid *x)
{
	Fcall fc;
	Window *w;
	int q;
	Text *t;

	w = x-&gt;f-&gt;w;
	x-&gt;f-&gt;busy = FALSE;
	if(x-&gt;f-&gt;open == FALSE){
		if(w != nil)
			winclose(w);
		respond(x, &amp;fc, nil);
		return;
	}

	x-&gt;f-&gt;open = FALSE;
	if(w){
		winlock(w, 'E');
		q = FILE(x-&gt;f-&gt;qid);
		switch(q){
		case QWctl:
			if(w-&gt;ctlfid!=~0 &amp;&amp; w-&gt;ctlfid==x-&gt;f-&gt;fid){
				w-&gt;ctlfid = ~0;
				qunlock(&amp;w-&gt;ctllock);
			}
			break;
		case QWdata:
		case QWxdata:
			w-&gt;nomark = FALSE;
			/* fall through */
		case QWaddr:
		case QWevent:	/* BUG: do we need to shut down Xfid? */
			if(--w-&gt;nopen[q] == 0){
				if(q == QWdata || q == QWxdata)
					w-&gt;nomark = FALSE;
				if(q==QWevent &amp;&amp; !w-&gt;isdir &amp;&amp; w-&gt;col!=nil){
					w-&gt;filemenu = TRUE;
					winsettag(w);
				}
				if(q == QWevent){
					free(w-&gt;dumpstr);
					free(w-&gt;dumpdir);
					w-&gt;dumpstr = nil;
					w-&gt;dumpdir = nil;
				}
			}
			break;
		case QWrdsel:
			close(w-&gt;rdselfd);
			w-&gt;rdselfd = 0;
			break;
		case QWwrsel:
			w-&gt;nomark = FALSE;
			t = &amp;w-&gt;body;
			/* before: only did this if !w-&gt;noscroll, but that didn't seem right in practice */
			textshow(t, min(w-&gt;wrselrange.q0, t-&gt;file-&gt;nc),
				min(w-&gt;wrselrange.q1, t-&gt;file-&gt;nc), 1);
			textscrdraw(t);
			break;
		}
		winunlock(w);
		winclose(w);
	}
	respond(x, &amp;fc, nil);
}

void
xfidread(Xfid *x)
{
	Fcall fc;
	int n, q;
	uint off;
	char *b;
	char buf[256];
	Window *w;

	q = FILE(x-&gt;f-&gt;qid);
	w = x-&gt;f-&gt;w;
	if(w == nil){
		fc.count = 0;
		switch(q){
		case Qcons:
		case Qlabel:
			break;
		case Qindex:
			xfidindexread(x);
			return;
		default:
			warning(nil, "unknown qid %d\n", q);
			break;
		}
		respond(x, &amp;fc, nil);
		return;
	}
	winlock(w, 'F');
	if(w-&gt;col == nil){
		winunlock(w);
		respond(x, &amp;fc, Edel);
		return;
	}
	off = x-&gt;offset;
	switch(q){
	case QWaddr:
		textcommit(&amp;w-&gt;body, TRUE);
		clampaddr(w);
		sprint(buf, "%11d %11d ", w-&gt;addr.q0, w-&gt;addr.q1);
		goto Readbuf;

	case QWbody:
		xfidutfread(x, &amp;w-&gt;body, w-&gt;body.file-&gt;nc, QWbody);
		break;

	case QWctl:
		b = winctlprint(w, buf, 1);
		goto Readb;

	Readbuf:
		b = buf;
	Readb:
		n = strlen(b);
		if(off &gt; n)
			off = n;
		if(off+x-&gt;count &gt; n)
			x-&gt;count = n-off;
		fc.count = x-&gt;count;
		fc.data = b+off;
		respond(x, &amp;fc, nil);
		if(b != buf)
			free(b);
		break;

	case QWevent:
		xfideventread(x, w);
		break;

	case QWdata:
		/* BUG: what should happen if q1 &gt; q0? */
		if(w-&gt;addr.q0 &gt; w-&gt;body.file-&gt;nc){
			respond(x, &amp;fc, Eaddr);
			break;
		}
		w-&gt;addr.q0 += xfidruneread(x, &amp;w-&gt;body, w-&gt;addr.q0, w-&gt;body.file-&gt;nc);
		w-&gt;addr.q1 = w-&gt;addr.q0;
		break;

	case QWxdata:
		/* BUG: what should happen if q1 &gt; q0? */
		if(w-&gt;addr.q0 &gt; w-&gt;body.file-&gt;nc){
			respond(x, &amp;fc, Eaddr);
			break;
		}
		w-&gt;addr.q0 += xfidruneread(x, &amp;w-&gt;body, w-&gt;addr.q0, w-&gt;addr.q1);
		break;

	case QWtag:
		xfidutfread(x, &amp;w-&gt;tag, w-&gt;tag.file-&gt;nc, QWtag);
		break;

	case QWrdsel:
		seek(w-&gt;rdselfd, off, 0);
		n = x-&gt;count;
		if(n &gt; BUFSIZE)
			n = BUFSIZE;
		b = fbufalloc();
		n = read(w-&gt;rdselfd, b, n);
		if(n &lt; 0){
			respond(x, &amp;fc, "I/O error in temp file");
			break;
		}
		fc.count = n;
		fc.data = b;
		respond(x, &amp;fc, nil);
		fbuffree(b);
		break;

	default:
		sprint(buf, "unknown qid %d in read", q);
		respond(x, &amp;fc, nil);
	}
	winunlock(w);
}

static Rune*
fullrunewrite(Xfid *x, int *inr)
{
	int q, cnt, c, nb, nr;
	Rune *r;

	q = x-&gt;f-&gt;nrpart;
	cnt = x-&gt;count;
	if(q &gt; 0){
		memmove(x-&gt;data+q, x-&gt;data, cnt);	/* there's room; see fsysproc */
		memmove(x-&gt;data, x-&gt;f-&gt;rpart, q);
		cnt += q;
		x-&gt;f-&gt;nrpart = 0;
	}
	r = runemalloc(cnt);
	cvttorunes(x-&gt;data, cnt-UTFmax, r, &amp;nb, &amp;nr, nil);
	/* approach end of buffer */
	while(fullrune(x-&gt;data+nb, cnt-nb)){
		c = nb;
		nb += chartorune(&amp;r[nr], x-&gt;data+c);
		if(r[nr])
			nr++;
	}
	if(nb &lt; cnt){
		memmove(x-&gt;f-&gt;rpart, x-&gt;data+nb, cnt-nb);
		x-&gt;f-&gt;nrpart = cnt-nb;
	}
	*inr = nr;
	return r;
}

void
xfidwrite(Xfid *x)
{
	Fcall fc;
	int c, qid, nb, nr, eval;
	char buf[64], *err;
	Window *w;
	Rune *r;
	Range a;
	Text *t;
	uint q0, tq0, tq1;

	qid = FILE(x-&gt;f-&gt;qid);
	w = x-&gt;f-&gt;w;
	if(w){
		c = 'F';
		if(qid==QWtag || qid==QWbody)
			c = 'E';
		winlock(w, c);
		if(w-&gt;col == nil){
			winunlock(w);
			respond(x, &amp;fc, Edel);
			return;
		}
	}
	x-&gt;data[x-&gt;count] = 0;
	switch(qid){
	case Qcons:
		w = errorwin(x-&gt;f-&gt;mntdir, 'X');
		t=&amp;w-&gt;body;
		goto BodyTag;

	case Qlabel:
		fc.count = x-&gt;count;
		respond(x, &amp;fc, nil);
		break;

	case QWaddr:
		x-&gt;data[x-&gt;count] = 0;
		r = bytetorune(x-&gt;data, &amp;nr);
		t = &amp;w-&gt;body;
		wincommit(w, t);
		eval = TRUE;
		a = address(x-&gt;f-&gt;mntdir, t, w-&gt;limit, w-&gt;addr, r, 0, nr, rgetc, &amp;eval, (uint*)&amp;nb);
		free(r);
		if(nb &lt; nr){
			respond(x, &amp;fc, Ebadaddr);
			break;
		}
		if(!eval){
			respond(x, &amp;fc, Eaddr);
			break;
		}
		w-&gt;addr = a;
		fc.count = x-&gt;count;
		respond(x, &amp;fc, nil);
		break;

	case Qeditout:
	case QWeditout:
		r = fullrunewrite(x, &amp;nr);
		if(w)
			err = edittext(w, w-&gt;wrselrange.q1, r, nr);
		else
			err = edittext(nil, 0, r, nr);
		free(r);
		if(err != nil){
			respond(x, &amp;fc, err);
			break;
		}
		fc.count = x-&gt;count;
		respond(x, &amp;fc, nil);
		break;

	case QWerrors:
		w = errorwinforwin(w);
		t = &amp;w-&gt;body;
		goto BodyTag;

	case QWbody:
	case QWwrsel:
		t = &amp;w-&gt;body;
		goto BodyTag;

	case QWctl:
		xfidctlwrite(x, w);
		break;

	case QWdata:
		a = w-&gt;addr;
		t = &amp;w-&gt;body;
		wincommit(w, t);
		if(a.q0&gt;t-&gt;file-&gt;nc || a.q1&gt;t-&gt;file-&gt;nc){
			respond(x, &amp;fc, Eaddr);
			break;
		}
		r = runemalloc(x-&gt;count);
		cvttorunes(x-&gt;data, x-&gt;count, r, &amp;nb, &amp;nr, nil);
		if(w-&gt;nomark == FALSE){
			seq++;
			filemark(t-&gt;file);
		}
		q0 = a.q0;
		if(a.q1 &gt; q0){
			textdelete(t, q0, a.q1, TRUE);
			w-&gt;addr.q1 = q0;
		}
		tq0 = t-&gt;q0;
		tq1 = t-&gt;q1;
		textinsert(t, q0, r, nr, TRUE);
		if(tq0 &gt;= q0)
			tq0 += nr;
		if(tq1 &gt;= q0)
			tq1 += nr;
		textsetselect(t, tq0, tq1);
		if(!t-&gt;w-&gt;noscroll)
			textshow(t, q0, q0+nr, 0);
		textscrdraw(t);
		winsettag(w);
		free(r);
		w-&gt;addr.q0 += nr;
		w-&gt;addr.q1 = w-&gt;addr.q0;
		fc.count = x-&gt;count;
		respond(x, &amp;fc, nil);
		break;

	case QWevent:
		xfideventwrite(x, w);
		break;

	case QWtag:
		t = &amp;w-&gt;tag;
		goto BodyTag;

	BodyTag:
		r = fullrunewrite(x, &amp;nr);
		if(nr &gt; 0){
			wincommit(w, t);
			if(qid == QWwrsel){
				q0 = w-&gt;wrselrange.q1;
				if(q0 &gt; t-&gt;file-&gt;nc)
					q0 = t-&gt;file-&gt;nc;
			}else
				q0 = t-&gt;file-&gt;nc;
			if(qid == QWtag)
				textinsert(t, q0, r, nr, TRUE);
			else{
				if(w-&gt;nomark == FALSE){
					seq++;
					filemark(t-&gt;file);
				}
				q0 = textbsinsert(t, q0, r, nr, TRUE, &amp;nr);
				textsetselect(t, t-&gt;q0, t-&gt;q1);	/* insert could leave it somewhere else */
				if(qid!=QWwrsel &amp;&amp; !t-&gt;w-&gt;noscroll)
					textshow(t, q0+nr, q0+nr, 1);
				textscrdraw(t);
			}
			winsettag(w);
			if(qid == QWwrsel)
				w-&gt;wrselrange.q1 += nr;
			free(r);
		}
		fc.count = x-&gt;count;
		respond(x, &amp;fc, nil);
		break;

	default:
		sprint(buf, "unknown qid %d in write", qid);
		respond(x, &amp;fc, buf);
		break;
	}
	if(w)
		winunlock(w);
}

void
xfidctlwrite(Xfid *x, Window *w)
{
	Fcall fc;
	int i, m, n, nb, nr, nulls;
	Rune *r;
	char *err, *p, *pp, *q, *e;
	int isfbuf, scrdraw, settag;
	Text *t;

	err = nil;
	e = x-&gt;data+x-&gt;count;
	scrdraw = FALSE;
	settag = FALSE;
	isfbuf = TRUE;
	if(x-&gt;count &lt; RBUFSIZE)
		r = fbufalloc();
	else{
		isfbuf = FALSE;
		r = emalloc(x-&gt;count*UTFmax+1);
	}
	x-&gt;data[x-&gt;count] = 0;
	textcommit(&amp;w-&gt;tag, TRUE);
	for(n=0; n&lt;x-&gt;count; n+=m){
		p = x-&gt;data+n;
		if(strncmp(p, "lock", 4) == 0){	/* make window exclusive use */
			qlock(&amp;w-&gt;ctllock);
			w-&gt;ctlfid = x-&gt;f-&gt;fid;
			m = 4;
		}else
		if(strncmp(p, "unlock", 6) == 0){	/* release exclusive use */
			w-&gt;ctlfid = ~0;
			qunlock(&amp;w-&gt;ctllock);
			m = 6;
		}else
		if(strncmp(p, "clean", 5) == 0){	/* mark window 'clean', seq=0 */
			t = &amp;w-&gt;body;
			t-&gt;eq0 = ~0;
			filereset(t-&gt;file);
			t-&gt;file-&gt;mod = FALSE;
			w-&gt;dirty = FALSE;
			settag = TRUE;
			m = 5;
		}else
		if(strncmp(p, "dirty", 5) == 0){	/* mark window 'dirty' */
			t = &amp;w-&gt;body;
			/* doesn't change sequence number, so "Put" won't appear.  it shouldn't. */
			t-&gt;file-&gt;mod = TRUE;
			w-&gt;dirty = TRUE;
			settag = TRUE;
			m = 5;
		}else
		if(strncmp(p, "show", 4) == 0){	/* show dot */
			t = &amp;w-&gt;body;
			textshow(t, t-&gt;q0, t-&gt;q1, 1);
			m = 4;
		}else
		if(strncmp(p, "name ", 5) == 0){	/* set file name */
			pp = p+5;
			m = 5;
			q = memchr(pp, '\n', e-pp);
			if(q==nil || q==pp){
				err = Ebadctl;
				break;
			}
			*q = 0;
			nulls = FALSE;
			cvttorunes(pp, q-pp, r, &amp;nb, &amp;nr, &amp;nulls);
			if(nulls){
				err = "nulls in file name";
				break;
			}
			for(i=0; i&lt;nr; i++)
				if(r[i] &lt;= ' '){
					err = "bad character in file name";
					goto out;
				}
out:
			seq++;
			filemark(w-&gt;body.file);
			winsetname(w, r, nr);
			m += (q+1) - pp;
		}else
		if(strncmp(p, "dump ", 5) == 0){	/* set dump string */
			pp = p+5;
			m = 5;
			q = memchr(pp, '\n', e-pp);
			if(q==nil || q==pp){
				err = Ebadctl;
				break;
			}
			*q = 0;
			nulls = FALSE;
			cvttorunes(pp, q-pp, r, &amp;nb, &amp;nr, &amp;nulls);
			if(nulls){
				err = "nulls in dump string";
				break;
			}
			w-&gt;dumpstr = runetobyte(r, nr);
			m += (q+1) - pp;
		}else
		if(strncmp(p, "dumpdir ", 8) == 0){	/* set dump directory */
			pp = p+8;
			m = 8;
			q = memchr(pp, '\n', e-pp);
			if(q==nil || q==pp){
				err = Ebadctl;
				break;
			}
			*q = 0;
			nulls = FALSE;
			cvttorunes(pp, q-pp, r, &amp;nb, &amp;nr, &amp;nulls);
			if(nulls){
				err = "nulls in dump directory string";
				break;
			}
			w-&gt;dumpdir = runetobyte(r, nr);
			m += (q+1) - pp;
		}else
		if(strncmp(p, "delete", 6) == 0){	/* delete for sure */
			colclose(w-&gt;col, w, TRUE);
			m = 6;
		}else
		if(strncmp(p, "del", 3) == 0){	/* delete, but check dirty */
			if(!winclean(w, TRUE)){
				err = "file dirty";
				break;
			}
			colclose(w-&gt;col, w, TRUE);
			m = 3;
		}else
		if(strncmp(p, "get", 3) == 0){	/* get file */
			get(&amp;w-&gt;body, nil, nil, FALSE, XXX, nil, 0);
			m = 3;
		}else
		if(strncmp(p, "put", 3) == 0){	/* put file */
			put(&amp;w-&gt;body, nil, nil, XXX, XXX, nil, 0);
			m = 3;
		}else
		if(strncmp(p, "dot=addr", 8) == 0){	/* set dot */
			textcommit(&amp;w-&gt;body, TRUE);
			clampaddr(w);
			w-&gt;body.q0 = w-&gt;addr.q0;
			w-&gt;body.q1 = w-&gt;addr.q1;
			textsetselect(&amp;w-&gt;body, w-&gt;body.q0, w-&gt;body.q1);
			settag = TRUE;
			m = 8;
		}else
		if(strncmp(p, "addr=dot", 8) == 0){	/* set addr */
			w-&gt;addr.q0 = w-&gt;body.q0;
			w-&gt;addr.q1 = w-&gt;body.q1;
			m = 8;
		}else
		if(strncmp(p, "limit=addr", 10) == 0){	/* set limit */
			textcommit(&amp;w-&gt;body, TRUE);
			clampaddr(w);
			w-&gt;limit.q0 = w-&gt;addr.q0;
			w-&gt;limit.q1 = w-&gt;addr.q1;
			m = 10;
		}else
		if(strncmp(p, "nomark", 6) == 0){	/* turn off automatic marking */
			w-&gt;nomark = TRUE;
			m = 6;
		}else
		if(strncmp(p, "mark", 4) == 0){	/* mark file */
			seq++;
			filemark(w-&gt;body.file);
			settag = TRUE;
			m = 4;
		}else
		if(strncmp(p, "nomenu", 6) == 0){	/* turn off automatic menu */
			w-&gt;filemenu = FALSE;
			m = 6;
		}else
		if(strncmp(p, "menu", 4) == 0){	/* enable automatic menu */
			w-&gt;filemenu = TRUE;
			m = 4;
		}else
		if(strncmp(p, "noscroll", 8) == 0){	/* turn off automatic scrolling */
			w-&gt;noscroll = TRUE;
			m = 8;
		}else
		if(strncmp(p, "cleartag", 8) == 0){	/* wipe tag right of bar */
			wincleartag(w);
			settag = TRUE;
			m = 8;
		}else
		if(strncmp(p, "scroll", 6) == 0){	/* turn on automatic scrolling (writes to body only) */
			w-&gt;noscroll = FALSE;
			m = 6;
		}else{
			err = Ebadctl;
			break;
		}
		while(p[m] == '\n')
			m++;
	}

	if(isfbuf)
		fbuffree(r);
	else
		free(r);
	if(err)
		n = 0;
	fc.count = n;
	respond(x, &amp;fc, err);
	if(settag)
		winsettag(w);
	if(scrdraw)
		textscrdraw(&amp;w-&gt;body);
}

void
xfideventwrite(Xfid *x, Window *w)
{
	Fcall fc;
	int m, n;
	Rune *r;
	char *err, *p, *q;
	int isfbuf;
	Text *t;
	int c;
	uint q0, q1;

	err = nil;
	isfbuf = TRUE;
	if(x-&gt;count &lt; RBUFSIZE)
		r = fbufalloc();
	else{
		isfbuf = FALSE;
		r = emalloc(x-&gt;count*UTFmax+1);
	}
	for(n=0; n&lt;x-&gt;count; n+=m){
		p = x-&gt;data+n;
		w-&gt;owner = *p++;	/* disgusting */
		c = *p++;
		while(*p == ' ')
			p++;
		q0 = strtoul(p, &amp;q, 10);
		if(q == p)
			goto Rescue;
		p = q;
		while(*p == ' ')
			p++;
		q1 = strtoul(p, &amp;q, 10);
		if(q == p)
			goto Rescue;
		p = q;
		while(*p == ' ')
			p++;
		if(*p++ != '\n')
			goto Rescue;
		m = p-(x-&gt;data+n);
		if('a'&lt;=c &amp;&amp; c&lt;='z')
			t = &amp;w-&gt;tag;
		else if('A'&lt;=c &amp;&amp; c&lt;='Z')
			t = &amp;w-&gt;body;
		else
			goto Rescue;
		if(q0&gt;t-&gt;file-&gt;nc || q1&gt;t-&gt;file-&gt;nc || q0&gt;q1)
			goto Rescue;

		qlock(&amp;row);	/* just like mousethread */
		switch(c){
		case 'x':
		case 'X':
			execute(t, q0, q1, TRUE, nil);
			break;
		case 'l':
		case 'L':
			look3(t, q0, q1, TRUE);
			break;
		default:
			qunlock(&amp;row);
			goto Rescue;
		}
		qunlock(&amp;row);

	}

    Out:
	if(isfbuf)
		fbuffree(r);
	else
		free(r);
	if(err)
		n = 0;
	fc.count = n;
	respond(x, &amp;fc, err);
	return;

    Rescue:
	err = Ebadevent;
	goto Out;
}

void
xfidutfread(Xfid *x, Text *t, uint q1, int qid)
{
	Fcall fc;
	Window *w;
	Rune *r;
	char *b, *b1;
	uint q, off, boff;
	int m, n, nr, nb;

	w = t-&gt;w;
	wincommit(w, t);
	off = x-&gt;offset;
	r = fbufalloc();
	b = fbufalloc();
	b1 = fbufalloc();
	n = 0;
	if(qid==w-&gt;utflastqid &amp;&amp; off&gt;=w-&gt;utflastboff &amp;&amp; w-&gt;utflastq&lt;=q1){
		boff = w-&gt;utflastboff;
		q = w-&gt;utflastq;
	}else{
		/* BUG: stupid code: scan from beginning */
		boff = 0;
		q = 0;
	}
	w-&gt;utflastqid = qid;
	while(q&lt;q1 &amp;&amp; n&lt;x-&gt;count){
		/*
		 * Updating here avoids partial rune problem: we're always on a
		 * char boundary. The cost is we will usually do one more read
		 * than we really need, but that's better than being n^2.
		 */
		w-&gt;utflastboff = boff;
		w-&gt;utflastq = q;
		nr = q1-q;
		if(nr &gt; BUFSIZE/UTFmax)
			nr = BUFSIZE/UTFmax;
		bufread(t-&gt;file, q, r, nr);
		nb = snprint(b, BUFSIZE+1, "%.*S", nr, r);
		if(boff &gt;= off){
			m = nb;
			if(boff+m &gt; off+x-&gt;count)
				m = off+x-&gt;count - boff;
			memmove(b1+n, b, m);
			n += m;
		}else if(boff+nb &gt; off){
			if(n != 0)
				error("bad count in utfrune");
			m = nb - (off-boff);
			if(m &gt; x-&gt;count)
				m = x-&gt;count;
			memmove(b1, b+(off-boff), m);
			n += m;
		}
		boff += nb;
		q += nr;
	}
	fbuffree(r);
	fbuffree(b);
	fc.count = n;
	fc.data = b1;
	respond(x, &amp;fc, nil);
	fbuffree(b1);
}

int
xfidruneread(Xfid *x, Text *t, uint q0, uint q1)
{
	Fcall fc;
	Window *w;
	Rune *r, junk;
	char *b, *b1;
	uint q, boff;
	int i, rw, m, n, nr, nb;

	w = t-&gt;w;
	wincommit(w, t);
	r = fbufalloc();
	b = fbufalloc();
	b1 = fbufalloc();
	n = 0;
	q = q0;
	boff = 0;
	while(q&lt;q1 &amp;&amp; n&lt;x-&gt;count){
		nr = q1-q;
		if(nr &gt; BUFSIZE/UTFmax)
			nr = BUFSIZE/UTFmax;
		bufread(t-&gt;file, q, r, nr);
		nb = snprint(b, BUFSIZE+1, "%.*S", nr, r);
		m = nb;
		if(boff+m &gt; x-&gt;count){
			i = x-&gt;count - boff;
			/* copy whole runes only */
			m = 0;
			nr = 0;
			while(m &lt; i){
				rw = chartorune(&amp;junk, b+m);
				if(m+rw &gt; i)
					break;
				m += rw;
				nr++;
			}
			if(m == 0)
				break;
		}
		memmove(b1+n, b, m);
		n += m;
		boff += nb;
		q += nr;
	}
	fbuffree(r);
	fbuffree(b);
	fc.count = n;
	fc.data = b1;
	respond(x, &amp;fc, nil);
	fbuffree(b1);
	return q-q0;
}

void
xfideventread(Xfid *x, Window *w)
{
	Fcall fc;
	char *b;
	int i, n;

	i = 0;
	x-&gt;flushed = FALSE;
	while(w-&gt;nevents == 0){
		if(i){
			if(!x-&gt;flushed)
				respond(x, &amp;fc, "window shut down");
			return;
		}
		w-&gt;eventx = x;
		winunlock(w);
		recvp(x-&gt;c);
		winlock(w, 'F');
		i++;
	}

	n = w-&gt;nevents;
	if(n &gt; x-&gt;count)
		n = x-&gt;count;
	fc.count = n;
	fc.data = w-&gt;events;
	respond(x, &amp;fc, nil);
	b = w-&gt;events;
	w-&gt;events = estrdup(w-&gt;events+n);
	free(b);
	w-&gt;nevents -= n;
}

void
xfidindexread(Xfid *x)
{
	Fcall fc;
	int i, j, m, n, nmax, isbuf, cnt, off;
	Window *w;
	char *b;
	Rune *r;
	Column *c;

	qlock(&amp;row);
	nmax = 0;
	for(j=0; j&lt;row.ncol; j++){
		c = row.col[j];
		for(i=0; i&lt;c-&gt;nw; i++){
			w = c-&gt;w[i];
			nmax += Ctlsize + w-&gt;tag.file-&gt;nc*UTFmax + 1;
		}
	}
	nmax++;
	isbuf = (nmax&lt;=RBUFSIZE);
	if(isbuf)
		b = (char*)x-&gt;buf;
	else
		b = emalloc(nmax);
	r = fbufalloc();
	n = 0;
	for(j=0; j&lt;row.ncol; j++){
		c = row.col[j];
		for(i=0; i&lt;c-&gt;nw; i++){
			w = c-&gt;w[i];
			/* only show the currently active window of a set */
			if(w-&gt;body.file-&gt;curtext != &amp;w-&gt;body)
				continue;
			winctlprint(w, b+n, 0);
			n += Ctlsize;
			m = min(RBUFSIZE, w-&gt;tag.file-&gt;nc);
			bufread(w-&gt;tag.file, 0, r, m);
			m = n + snprint(b+n, nmax-n-1, "%.*S", m, r);
			while(n&lt;m &amp;&amp; b[n]!='\n')
				n++;
			b[n++] = '\n';
		}
	}
	qunlock(&amp;row);
	off = x-&gt;offset;
	cnt = x-&gt;count;
	if(off &gt; n)
		off = n;
	if(off+cnt &gt; n)
		cnt = n-off;
	fc.count = cnt;
	memmove(r, b+off, cnt);
	fc.data = (char*)r;
	if(!isbuf)
		free(b);
	respond(x, &amp;fc, nil);
	fbuffree(r);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

