<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/client.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/client.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

static char *hmsg = "headers";
int chatty = 1;

void
warning(char *fmt, ...)
{
	char err[128];
	va_list arg;

	va_start(arg, fmt);
	vseprint(err, err+sizeof(err), fmt, arg);
	va_end(arg);
	syslog(1, "netbios-ns", err);
	if (chatty)
		print("%s\n", err);
}

static int
udpannounce(void)
{
	int data, ctl;
	char dir[64];
	char datafile[64+6];

	/* get a udp port */
	ctl = announce("udp!*!netbios-ns", dir);
	if(ctl &lt; 0){
		warning("can't announce on netbios-ns udp port");
		return -1;
	}
	snprint(datafile, sizeof(datafile), "%s/data", dir);

	/* turn on header style interface */
	if(write(ctl, hmsg, strlen(hmsg)) , 0)
		abort(); /* hmsg */;
	data = open(datafile, ORDWR);
	if(data &lt; 0){
		close(ctl);
		warning("can't announce on dns udp port");
		return -1;
	}

	close(ctl);
	return data;
}

#define BROADCAST 1


void
listen137(void *)
{	
	for (;;) {
		uchar msg[Udphdrsize + 576];
		int len = read(fd137, msg, sizeof(msg));
		if (len &lt; 0)
			break;
		if (len &gt;= Udphdrsize) {
			NbnsMessage *s;
			Udphdr *uh;
			uchar *p;

			uh = (Udphdr*)msg;
			p = msg + Udphdrsize;
			len -= Udphdrsize;
			s = nbnsconvM2S(p, len);
			if (s) {
				print("%I:%d -&gt; %I:%d\n", uh-&gt;raddr, nhgets(uh-&gt;rport), uh-&gt;laddr, nhgets(uh-&gt;lport));
				nbnsdumpmessage(s);
				if (s-&gt;response) {
					NbnsTransaction *t;
					qlock(&amp;transactionlist);
					for (t = transactionlist.head; t; t = t-&gt;next)
						if (t-&gt;id == s-&gt;id)
							break;
					if (t) {
						sendp(t-&gt;c, s);
					}
					else
						nbnsmessagefree(&amp;s);
					qunlock(&amp;transactionlist);
				}
				else
					nbnsmessagefree(&amp;s);
			}
		}
	}
}

void
usage(void)
{
	fprint(2, "usage: %s [-u ipaddr] name\n", argv0);
	exits("usage");
}

void
threadmain(int argc, char **argv)
{
	int broadcast = 1, i, listen137thread, rv;
	char *ip;
	uchar ipaddr[IPaddrlen], serveripaddr[IPaddrlen];
	NbName nbname;

	ARGBEGIN {
	case 'u':
		broadcast = 0;
		ip = EARGF(usage());
		if (parseip(serveripaddr, ip) == -1)
			sysfatal("bad ip address %s", ip);
		break;
	default:
		usage();
	} ARGEND;

	if (argc == 0)
		usage();

	nbmknamefromstring(nbname, argv[0]);

	ipifc = readipifc("/net", nil, 0);
	if (ipifc == nil || ipifc-&gt;lifc == nil)
		sysfatal("no network interface");
	fmtinstall('I', eipfmt);
	ipmove(bcastaddr, ipifc-&gt;lifc-&gt;ip);
	for (i = 0; i &lt; IPaddrlen; i++)
		bcastaddr[i] |= ~ipifc-&gt;lifc-&gt;mask[i];
	print("broadcasting to %I\n", bcastaddr);
//	setnetmtpt("/net");
	fd137 = udpannounce();
	listen137thread = proccreate(listen137, nil, 16384);
	rv = nbnsaddname(broadcast ? nil : serveripaddr, nbname, 3000, ipifc-&gt;lifc-&gt;ip);
	if (rv != 0)
		print("error code %d\n", rv);
	else
		print("%I\n", ipaddr);
	nbnsalarmend();
	threadint(listen137thread);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

