<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/dump.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/dump.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

static char *
opname(int opcode)
{
	switch (opcode) {
	case NbnsOpQuery: return "query";
	case NbnsOpRegistration: return "registration";
	case NbnsOpRelease: return "release";
	case NbnsOpWack: return "wack";
	case NbnsOpRefresh: return "refresh";
	default:
		return "???";
	}
}

void
nbnsdumpname(NbName name)
{
	int x;
	for (x = 0; x &lt; NbNameLen - 1; x++) {
		if (name[x] == ' ')
			break;
		print("%c", tolower(name[x]));
	}
	print("\\x%.2ux", name[NbNameLen - 1]);
}

void
nbnsdumpmessagequestion(NbnsMessageQuestion *q)
{
	print("question: ");
	nbnsdumpname(q-&gt;name);
	switch (q-&gt;type) {
	case NbnsQuestionTypeNb: print(" NB");	break;
	case NbnsQuestionTypeNbStat: print(" NBSTAT"); break;
	default: print(" ???");
	}
	switch (q-&gt;class) {
	case NbnsQuestionClassIn: print(" IN"); break;
	default: print(" ???");
	}
	print("\n");
}

void
nbnsdumpmessageresource(NbnsMessageResource *r, char *name)
{
	print("%s: ", name);
	nbnsdumpname(r-&gt;name);
	switch (r-&gt;type) {
	case NbnsResourceTypeA: print(" A");	break;
	case NbnsResourceTypeNs: print(" NS");	break;
	case NbnsResourceTypeNull: print(" NULL");	break;
	case NbnsResourceTypeNb: print(" NB");	break;
	case NbnsResourceTypeNbStat: print(" NBSTAT"); break;
	default: print(" ???");
	}
	switch (r-&gt;class) {
	case NbnsResourceClassIn: print(" IN"); break;
	default: print(" ???");
	}
	print(" ttl: %lud", r-&gt;ttl);
	if (r-&gt;rdlength) {
		int i;
		print(" rdata: ");
		for (i = 0; i &lt; r-&gt;rdlength; i++)
			print("%.2ux", r-&gt;rdata[i]);
	}
	print("\n");
}

void
nbnsdumpmessage(NbnsMessage *s)
{
	NbnsMessageQuestion *q;
	NbnsMessageResource *r;
	print("0x%.4ux %s %s (%d)",
		s-&gt;id, opname(s-&gt;opcode), s-&gt;response ? "response" : "request", s-&gt;opcode);
	if (s-&gt;broadcast)
		print(" B");
	if (s-&gt;recursionavailable)
		print(" RA");
	if (s-&gt;recursiondesired)
		print(" RD");
	if (s-&gt;truncation)
		print(" TC");
	if (s-&gt;authoritativeanswer)
		print(" AA");
	if (s-&gt;response)
		print(" rcode %d", s-&gt;rcode);
	print("\n");
	for (q = s-&gt;q; q; q = q-&gt;next)
		nbnsdumpmessagequestion(q);
	for (r = s-&gt;an; r; r = r-&gt;next)
		nbnsdumpmessageresource(r, "answer");
	for (r = s-&gt;ns; r; r = r-&gt;next)
		nbnsdumpmessageresource(r, "ns");
	for (r = s-&gt;ar; r; r = r-&gt;next)
		nbnsdumpmessageresource(r, "additional");
}

void
nbdumpdata(void *ap, long n)
{
	uchar *p = ap;
	long i;
	i = 0;
	while (i &lt; n) {
		int l = n - i &lt; 16 ? n - i : 16;
		int b;
		print("0x%.4lux  ", i);
		for (b = 0; b &lt; l; b += 2) {
			print(" %.2ux", p[i + b]);
			if (b &lt; l - 1)
				print("%.2ux", p[i + b + 1]);
			else
				print("  ");
		}
		while (b &lt; 16) {
			print("     ");
			b++;
		}
		print("        ");
		for (b = 0; b &lt; l; b++)
			if (p[i + b] &gt;= ' ' &amp;&amp; p[i + b] &lt;= '~')
				print("%c", p[i + b]);
			else
				print(".");
		print("\n");
		i += l;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

