<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/nbdgram.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/nbdgram.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

static struct {
	int thread;
	QLock;
	int fd;
} udp = { -1 };

typedef struct Listen Listen;

struct Listen {
	NbName to;
	int (*deliver)(void *magic, NbDgram *s);
	void *magic;
	Listen *next;
};

static struct {
	QLock;
	Listen *head;
} listens;

static void
udplistener(void *)
{
//print("udplistener - starting\n");
	for (;;) {
		uchar msg[Udphdrsize + 576];
		int len = read(udp.fd, msg, sizeof(msg));
		if (len &lt; 0)
			break;
		if (len &gt;= nbudphdrsize) {
			NbDgram s;
//			Udphdr *uh;
			uchar *p;
			int n;

//			uh = (Udphdr*)msg;
			p = msg + nbudphdrsize;
			len -= nbudphdrsize;
			n = nbdgramconvM2S(&amp;s, p, p + len);
			if (n) {
				switch (s.type) {
				case NbDgramError:
					print("nbdgramlisten: error: ip %I port %d code 0x%.2ux\n", s.srcip, s.srcport, s.error.code);
					break;
				case NbDgramDirectUnique:
				case NbDgramDirectGroup:
				case NbDgramBroadcast: {
					int delivered = 0;
					Listen **lp, *l;
					if ((s.flags &amp; NbDgramMore) || s.datagram.offset != 0)
						break;
					if (!nbnameisany(s.datagram.dstname)
						&amp;&amp; !nbnametablefind(s.datagram.dstname, 0)) {
/* - only do this if a broadcast node, and can tell when packets are broadcast...
						s.flags &amp;= 3;
						ipmove(s.srcip, nbglobals.myipaddr);
						s.srcport = NbDgramPort;
						s.type = NbDgramError;	
						s.error.code = NbDgramErrorDestinationNameNotPresent;
						nbdgramsendto(uh-&gt;raddr, nhgets(uh-&gt;rport), &amp;s);
*/
						break;
					}
					qlock(&amp;listens);
					for (lp = &amp;listens.head; (l = *lp) != nil;) {
						if (nbnameisany(l-&gt;to) || nbnameequal(l-&gt;to, s.datagram.dstname)) {
							switch ((*l-&gt;deliver)(l-&gt;magic, &amp;s)) {
							case 0:
								delivered = 1;
								/* fall through */
							case -1:
								*lp = l-&gt;next;
								free(l);
								continue;
							default:
								delivered = 1;
								break;
							}
						}
						lp = &amp;l-&gt;next;
					}
					qunlock(&amp;listens);
					USED(delivered);
				}
				default:
					;
				}
			}
		}
	}
print("udplistener - exiting\n");
	qlock(&amp;udp);
	udp.thread = -1;
	qunlock(&amp;udp);
}

static char *
startlistener(void)
{
	qlock(&amp;udp);
	if (udp.thread &lt; 0) {
		char *e;
		e = nbudpannounce(NbDgramPort, &amp;udp.fd);
		if (e) {
			qunlock(&amp;udp);
			return e;
		}
		udp.thread = proccreate(udplistener, nil, 16384);
	}
	qunlock(&amp;udp);
	return nil;
}

char *
nbdgramlisten(NbName to, int (*deliver)(void *magic, NbDgram *s), void *magic)
{
	Listen *l;
	char *e;
	nbnametablefind(to, 1);
	e = startlistener();
	if (e)
		return e;
	l = nbemalloc(sizeof(Listen));
	nbnamecpy(l-&gt;to, to);
	l-&gt;deliver = deliver;
	l-&gt;magic = magic;
	qlock(&amp;listens);
	l-&gt;next = listens.head;
	listens.head = l;
	qunlock(&amp;listens);
	return 0;
}

int
nbdgramsendto(uchar *ipaddr, ushort port, NbDgram *s)
{
	Udphdr *u;
	uchar msg[NbDgramMaxPacket + Udphdrsize];
	int l;
	int rv;
	char *e;

	e = startlistener();
	if (e != nil)
		return 0;

	l = nbdgramconvS2M(msg + nbudphdrsize, msg + sizeof(msg), s);
	if (l == 0) {
		print("conv failed\n");
		return 0;
	}
	u = (Udphdr *)msg;
	ipmove(u-&gt;laddr, nbglobals.myipaddr);
	hnputs(u-&gt;lport, NbDgramPort);
	ipmove(u-&gt;raddr, ipaddr);
	hnputs(u-&gt;rport, port);
//nbdumpdata(msg, l + nbudphdrsize);
//print("transmitting\n");
	rv = write(udp.fd, msg, l + nbudphdrsize);
//print("rv %d l %d hdrsize %d error %r\n", rv, l, nbudphdrsize);
	return rv == l + nbudphdrsize;
}

static struct {
	Lock;
	ushort id;
} id;

static ushort
nextdgramid(void)
{
	ushort v;
	lock(&amp;id);
	v = id.id++;
	unlock(&amp;id);
	return v;
}

int
nbdgramsend(NbDgramSendParameters *p, uchar *data, long datalen)
{
	NbDgram s;
	uchar dstip[IPaddrlen];
	s.type = p-&gt;type;
	switch (p-&gt;type) {
	case NbDgramBroadcast:
	case NbDgramDirectGroup:
		ipmove(dstip, nbglobals.bcastaddr);
		break;
	case NbDgramDirectUnique:
		if (!nbnameresolve(p-&gt;to, dstip)) {
			werrstr("nbdgramsend: name resolution failed");
			return 0;
		}
		break;
	default:
		werrstr("nbdgramsend: illegal datagram type");
		return 0;
	}
	s.flags = NbDgramFirst;
	s.id = nextdgramid();
	ipmove(s.srcip, nbglobals.myipaddr);
	s.srcport = NbDgramPort;
	s.datagram.offset = 0;
	s.datagram.data = data;
	s.datagram.length = datalen;
	nbnamecpy(s.datagram.dstname, p-&gt;to);
	nbnamecpy(s.datagram.srcname, nbglobals.myname);
	return nbdgramsendto(dstip, NbDgramPort, &amp;s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

