<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/nbss.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/nbss.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

static struct {
	int thread;
	QLock;
	char adir[NETPATHLEN];
	int acfd;
	char ldir[NETPATHLEN];
	int lcfd;
} tcp = { -1 };

typedef struct Session Session;

enum { NeedSessionRequest, Connected, Dead };

struct Session {
	NbSession;
	int thread;
	Session *next;
	int state;
	NBSSWRITEFN *write;
};

static struct {
	QLock;
	Session *head;
} sessions;

typedef struct Listen Listen;

struct Listen {
	NbName to;
	NbName from;
	int (*accept)(void *magic, NbSession *s, NBSSWRITEFN **writep);
	void *magic;
	Listen *next;
};

static struct {
	QLock;
	Listen *head;
} listens;

static void
deletesession(Session *s)
{
	Session **sp;
	close(s-&gt;fd);
	qlock(&amp;sessions);
	for (sp = &amp;sessions.head; *sp &amp;&amp; *sp != s; sp = &amp;(*sp)-&gt;next)
		;
	if (*sp)
		*sp = s-&gt;next;
	qunlock(&amp;sessions);
	free(s);
}

static void
tcpreader(void *a)
{
	Session *s = a;
	uchar *buf;
	int buflen = 0x1ffff + 4;
	buf = nbemalloc(buflen);
	for (;;) {
		int n;
		uchar flags;
		ushort length;

		n = readn(s-&gt;fd, buf, 4);
		if (n != 4) {
		die:
			free(buf);
			if (s-&gt;state == Connected)
				(*s-&gt;write)(s, nil, -1);
			deletesession(s);
			return;
		}
		flags = buf[1];
		length = nhgets(buf + 2) | ((flags &amp; 1) &lt;&lt; 16);
		n = readn(s-&gt;fd, buf + 4, length);
		if (n != length)
			goto die;
		if (flags &amp; 0xfe) {
			print("nbss: invalid flags field 0x%.2ux\n", flags);
			goto die;
		}
		switch (buf[0]) {
		case 0: /* session message */
			if (s-&gt;state != Connected &amp;&amp; s-&gt;state != Dead) {
				print("nbss: unexpected session message\n");
				goto die;
			}
			if (s-&gt;state == Connected) {
				if ((*s-&gt;write)(s, buf + 4, length) != 0) {
					s-&gt;state = Dead;
					goto die;
				}
			}
			break;
		case 0x81: /* session request */ {
			uchar *p, *ep;
			Listen *l;
			int k;
			int called_found;
			uchar error_code;

			if (s-&gt;state == Connected) {
				print("nbss: unexpected session request\n");
				goto die;
			}
			p = buf + 4;
			ep = p + length;
			k = nbnamedecode(p, p, ep, s-&gt;to);
			if (k == 0) {
				print("nbss: malformed called name in session request\n");
				goto die;
			}
			p += k;
			k = nbnamedecode(p, p, ep, s-&gt;from);
			if (k == 0) {
				print("nbss: malformed calling name in session request\n");
				goto die;
			}
/*
			p += k;
			if (p != ep) {
				print("nbss: extra data at end of session request\n");
				goto die;
			}
*/
			called_found = 0;
//print("nbss: called %B calling %B\n", s-&gt;to, s-&gt;from);
			qlock(&amp;listens);
			for (l = listens.head; l; l = l-&gt;next)
				if (nbnameequal(l-&gt;to, s-&gt;to)) {
					called_found = 1;
					if (nbnameequal(l-&gt;from, s-&gt;from))
						break;
				}
			if (l == nil) {
				qunlock(&amp;listens);
				error_code  = called_found ? 0x81 : 0x80;
			replydie:
				buf[0] = 0x83;
				buf[1] = 0;
				hnputs(buf + 2, 1);
				buf[4] = error_code;
				write(s-&gt;fd, buf, 5);
				goto die;
			}
			if (!(*l-&gt;accept)(l-&gt;magic, s, &amp;s-&gt;write)) {
				qunlock(&amp;listens);
				error_code = 0x83;
				goto replydie;
			}
			buf[0] = 0x82;
			buf[1] = 0;
			hnputs(buf + 2, 0);
			if (write(s-&gt;fd, buf, 4) != 4) {
				qunlock(&amp;listens);
				goto die;
			}
			s-&gt;state = Connected;
			qunlock(&amp;listens);
			break;
		}
		case 0x85: /* keep awake */
			break;
		default:
			print("nbss: opcode 0x%.2ux unexpected\n", buf[0]);
			goto die;
		}
	}
}

static NbSession *
createsession(int fd)
{
	Session *s;
	s = nbemalloc(sizeof(Session));
	s-&gt;fd = fd;
	s-&gt;state = NeedSessionRequest;
	qlock(&amp;sessions);
	s-&gt;thread = procrfork(tcpreader, s, 32768, RFNAMEG);
	if (s-&gt;thread &lt; 0) {
		qunlock(&amp;sessions);
		free(s);
		return nil;
	}
	s-&gt;next = sessions.head;
	sessions.head = s;
	qunlock(&amp;sessions);
	return s;
}

static void
tcplistener(void *)
{
	for (;;) {
		int dfd;
		char ldir[NETPATHLEN];
		int lcfd;
//print("tcplistener: listening\n");
		lcfd = listen(tcp.adir, ldir);
//print("tcplistener: contact\n");
		if (lcfd &lt; 0) {
		die:
			qlock(&amp;tcp);
			close(tcp.acfd);
			tcp.thread = -1;
			qunlock(&amp;tcp);
			return;
		}
		dfd = accept(lcfd, ldir);
		close(lcfd);
		if (dfd &lt; 0)
			goto die;
		if (createsession(dfd) == nil)
			close(dfd);
	}
}

int
nbsslisten(NbName to, NbName from,int (*accept)(void *magic, NbSession *s, NBSSWRITEFN **writep), void *magic)
{
	Listen *l;
	qlock(&amp;tcp);
	if (tcp.thread &lt; 0) {
		fmtinstall('B', nbnamefmt);
		tcp.acfd = announce("tcp!*!netbios", tcp.adir);
		if (tcp.acfd &lt; 0) {
			print("nbsslisten: can't announce: %r\n");
			qunlock(&amp;tcp);
			return -1;
		}
		tcp.thread = proccreate(tcplistener, nil, 16384);
	}
	qunlock(&amp;tcp);
	l = nbemalloc(sizeof(Listen));
	nbnamecpy(l-&gt;to, to);
	nbnamecpy(l-&gt;from, from);
	l-&gt;accept = accept;
	l-&gt;magic = magic;
	qlock(&amp;listens);
	l-&gt;next = listens.head;
	listens.head = l;
	qunlock(&amp;listens);
	return 0;
}

void
nbssfree(NbSession *s)
{	
	deletesession((Session *)s);
}

int
nbssgatherwrite(NbSession *s, NbScatterGather *a)
{
	uchar hdr[4];
	NbScatterGather *ap;
	long l = 0;
	for (ap = a; ap-&gt;p; ap++)
		l += ap-&gt;l;
//print("nbssgatherwrite %ld bytes\n", l);
	hnputl(hdr, l);
//nbdumpdata(hdr, sizeof(hdr));
	if (write(s-&gt;fd, hdr, sizeof(hdr)) != sizeof(hdr))
		return -1;
	for (ap = a; ap-&gt;p; ap++) {
//nbdumpdata(ap-&gt;p, ap-&gt;l);
		if (write(s-&gt;fd, ap-&gt;p, ap-&gt;l) != ap-&gt;l)
			return -1;
	}
	return 0;
}

NbSession *
nbssconnect(NbName to, NbName from)
{
	Session *s;
	uchar ipaddr[IPaddrlen];
	char dialaddress[100];
	char dir[NETPATHLEN];
	uchar msg[576];
	int fd;
	long o;
	uchar flags;
	long length;

	if (!nbnameresolve(to, ipaddr))
		return nil;
	fmtinstall('I', eipfmt);
	snprint(dialaddress, sizeof(dialaddress), "tcp!%I!netbios", ipaddr);
	fd = dial(dialaddress, nil, dir, nil);
	if (fd &lt; 0)
		return nil;
	msg[0] = 0x81;
	msg[1] = 0;
	o = 4;
	o += nbnameencode(msg + o, msg + sizeof(msg) - o, to);
	o += nbnameencode(msg + o, msg + sizeof(msg) - o, from);
	hnputs(msg + 2, o - 4);
	if (write(fd, msg, o) != o) {
		close(fd);
		return nil;
	}
	if (readn(fd, msg, 4) != 4) {
		close(fd);
		return nil;
	}
	flags = msg[1];
	length = nhgets(msg + 2) | ((flags &amp; 1) &lt;&lt; 16);
	switch (msg[0]) {
	default:
		close(fd);
		werrstr("unexpected session message code 0x%.2ux", msg[0]);
		return nil;
	case 0x82:
		if (length != 0) {
			close(fd);
			werrstr("length not 0 in positive session response");
			return nil;
		}
		break;
	case 0x83:
		if (length != 1) {
			close(fd);
			werrstr("length not 1 in negative session response");
			return nil;
		}
		if (readn(fd, msg + 4, 1) != 1) {
			close(fd);
			return nil;
		}
		close(fd);
		werrstr("negative session response 0x%.2ux", msg[4]);
		return nil;
	}
	s = nbemalloc(sizeof(Session));
	s-&gt;fd = fd;
	s-&gt;state = Connected;
	qlock(&amp;sessions);
	s-&gt;next = sessions.head;
	sessions.head = s;
	qunlock(&amp;sessions);
	return s;
}

long
nbssscatterread(NbSession *nbs, NbScatterGather *a)
{
	uchar hdr[4];
	uchar flags;
	long length, total;
	NbScatterGather *ap;
	Session *s = (Session *)nbs;

	long l = 0;
	for (ap = a; ap-&gt;p; ap++)
		l += ap-&gt;l;
//print("nbssscatterread %ld bytes\n", l);
again:
	if (readn(s-&gt;fd, hdr, 4) != 4) {
	dead:
		s-&gt;state = Dead;
		return -1;
	}
	flags = hdr[1];
	length = nhgets(hdr + 2) | ((flags &amp; 1) &lt;&lt; 16);
//print("%.2ux: %d\n", hdr[0], length);
	switch (hdr[0]) {
	case 0x85:
		if (length != 0) {
			werrstr("length in keepalive not 0");
			goto dead;
		}
		goto again;
	case 0x00:
		break;
	default:
		werrstr("unexpected session message code 0x%.2ux", hdr[0]);
		goto dead;
	}
	if (length &gt; l) {
		werrstr("message too big (%ld)", length);
		goto dead;
	}
	total = length;
	for (ap = a; length &amp;&amp; ap-&gt;p; ap++) {
		long thistime;
		long n;
		thistime = length;
		if (thistime &gt; ap-&gt;l)
			thistime = ap-&gt;l;
//print("reading %d\n", length);
		n = readn(s-&gt;fd, ap-&gt;p, thistime);
		if (n != thistime)
			goto dead;
		length -= thistime;
	}
	return total;
}

int
nbsswrite(NbSession *s, void *buf, long maxlen)
{
	NbScatterGather a[2];
	a[0].l = maxlen;
	a[0].p = buf;
	a[1].p = nil;
	return nbssgatherwrite(s, a);
}

long
nbssread(NbSession *s, void *buf, long maxlen)
{
	NbScatterGather a[2];
	a[0].l = maxlen;
	a[0].p = buf;
	a[1].p = nil;
	return nbssscatterread(s, a);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

