<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbcommon.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbcommon.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

int
smbsendunicode(SmbPeerInfo *i)
{
	return smbglobals.unicode &amp;&amp; (i == nil || (i-&gt;capabilities &amp; CAP_UNICODE) != 0);
}

int
smbcheckwordcount(char *name, SmbHeader *h, ushort wordcount)
{
	if (h-&gt;wordcount != wordcount) {
		smblogprint(-1, "smb%s: word count not %ud\n", name, wordcount);
		return 0;
	}
	return 1;
}

int
smbcheckwordandbytecount(char *name, SmbHeader *h, ushort wordcount, uchar **bdatap, uchar **edatap)
{
	ushort bytecount;
	uchar *bdata;
	if (h-&gt;wordcount != wordcount) {
		smblogprint(-1, "smb%s: word count not %ud\n", name, wordcount);
		return 0;
	}
	bdata = *bdatap;
	if (bdata + 2 &gt; *edatap) {
		smblogprint(-1, "smb%s: not enough data for byte count\n", name);
		return 0;
	}
	bytecount = smbnhgets(bdata); bdata += 2;
	if (bdata + bytecount &gt; *edatap) {
		smblogprint(-1, "smb%s: not enough data for bytes\n", name);
		return 0;
	}
	*edatap = bdata + bytecount;
	*bdatap = bdata;
	return 1;
}

SmbProcessResult
smbchaincommand(SmbSession *s, SmbHeader *h, ulong andxoffsetfixup, uchar cmd, ushort offset, SmbBuffer *b)
{
	SmbOpTableEntry *ote;
	uchar *pdata;
	ushort bytecount;

	h-&gt;command = cmd;
	ote = smboptable + cmd;
	if (ote-&gt;process == nil) {
		smblogprint(-1, "smbchaincommand: %s (0x%.2ux) not implemented\n", ote-&gt;name, cmd);
		return SmbProcessResultUnimp;
	}
	if (!smbresponsealignl2(s, 2)
		|| !smbresponseoffsetputs(s, andxoffsetfixup, smbresponseoffset(s))
		|| !smbbufferpopreadlimit(b))
		return SmbProcessResultMisc;
	if (!smbbufferreadskipto(b, offset)) {
		smblogprint(-1, "smbchaincommand: illegal offset\n");
		return SmbProcessResultFormat;
	}
	if (!smbbuffergetb(b, &amp;h-&gt;wordcount)) {
		smblogprint(-1, "smbchaincommand: not enough space for wordcount\n");
		return SmbProcessResultFormat;
	}
	pdata = smbbufferreadpointer(b);
	if (!smbbuffergetbytes(b, nil, h-&gt;wordcount * 2)) {
		smblogprint(-1, "smbchaincommand: not enough space for parameters\n");
		return SmbProcessResultFormat;
	}
	if (!smbbuffergets(b, &amp;bytecount)) {
		smblogprint(-1, "smbchaincommand: not enough space for bytecount\n");
		return SmbProcessResultFormat;
	}
	if (!smbbufferpushreadlimit(b, smbbufferreadoffset(b) + bytecount)) {
		smblogprint(-1, "smbchaincommand: not enough space for bytes\n");
		return SmbProcessResultFormat;
	}
smblogprint(cmd, "chaining to %s\n", ote-&gt;name);
	return (*ote-&gt;process)(s, h, pdata, b);
}

int
smbbuffergetheader(SmbBuffer *b, SmbHeader *h, uchar **parametersp, ushort *bytecountp)
{
	SmbOpTableEntry *ote;
	SmbRawHeader *rh;
	rh = (SmbRawHeader *)smbbufferreadpointer(b);
	if (!smbbuffergetbytes(b, nil, (long)offsetof(SmbRawHeader, parameterwords[0]))) {
		smblogprint(-1, "smbgetheader: short packet\n");
		return 0;
	}
	if (rh-&gt;protocol[0] != 0xff || memcmp(rh-&gt;protocol + 1, "SMB", 3) != 0) {
		smblogprint(-1, "smbgetheader: invalid protocol\n");
		return 0;
	}
	h-&gt;command = rh-&gt;command;
	ote = smboptable + h-&gt;command;
	if (ote-&gt;name == nil) {
		smblogprint(-1, "smbgetheader: illegal opcode 0x%.2ux\n", h-&gt;command);
		return 0;
	}
	h-&gt;errclass = rh-&gt;status[0];
	h-&gt;error = smbnhgets(rh-&gt;status + 2);
	h-&gt;flags = rh-&gt;flags;
	h-&gt;flags2 = smbnhgets(rh-&gt;flags2);
	if (h-&gt;flags &amp; ~(SmbHeaderFlagCaseless | SMB_FLAGS_SERVER_TO_REDIR | SmbHeaderFlagReserved | SmbHeaderFlagServerIgnore))
		smblogprint(-1, "smbgetheader: warning: unexpected flags 0x%.2ux\n", h-&gt;flags);
	h-&gt;wordcount = rh-&gt;wordcount;
	if (parametersp)
		*parametersp = smbbufferreadpointer(b);
	if (!smbbuffergetbytes(b, nil, h-&gt;wordcount * 2)) {
		smblogprint(-1, "smbgetheader: not enough data for parameter words\n");
		return 0;
	}
	h-&gt;tid = smbnhgets(rh-&gt;tid);
	h-&gt;pid = smbnhgets(rh-&gt;pid);
	h-&gt;uid = smbnhgets(rh-&gt;uid);
	h-&gt;mid = smbnhgets(rh-&gt;mid);
	if (!smbbuffergets(b, bytecountp))
		*bytecountp = 0;
	if (!smbbufferpushreadlimit(b, smbbufferreadoffset(b) + *bytecountp))
		return 0;

smblogprint(h-&gt;command, "%s %s: tid 0x%.4ux pid 0x%.4ux uid 0x%.4ux mid 0x%.4ux\n", ote-&gt;name,
	(h-&gt;flags &amp; SMB_FLAGS_SERVER_TO_REDIR) ? "response" : "request", h-&gt;tid, h-&gt;pid, h-&gt;uid, h-&gt;mid);
	return 1;
}

int
smbcheckheaderdirection(SmbHeader *h, int response, char **errmsgp)
{
	if (((h-&gt;flags &amp; SMB_FLAGS_SERVER_TO_REDIR) == 0) == response) {
		smbstringprint(errmsgp, "unexpected %s", response ? "request" : "response");
		return 0;
	}
	return 1;
}

int
smbcheckheader(SmbHeader *h, uchar command, int response, char **errmsgp)
{
	if (response &amp;&amp; h-&gt;command != command) {
		smbstringprint(errmsgp, "sent %.2uc request, got %.2ux response", command, h-&gt;command);
		return 0;
	}
	if (!smbcheckheaderdirection(h, response, errmsgp))
		return 0;
	return 1;
}

int
smbbuffergetandcheckheader(SmbBuffer *b, SmbHeader *h, uchar command, int response, uchar **pdatap, ushort *bytecountp, char **errmsgp)
{
	if (!smbbuffergetheader(b, h, pdatap, bytecountp)) {
		smbstringprint(errmsgp, "smbbuffergetandcheckheader: not enough data for header");
		return 0;
	}
	return smbcheckheader(h, command, response, errmsgp);
}

int
smbsuccess(SmbHeader *h, char **errmsgp)
{
	if (h-&gt;errclass != SUCCESS) {
		smbstringprint(errmsgp, "%s returned error %d/%d", smboptable[h-&gt;command].name, h-&gt;errclass, h-&gt;error);
		return 0;
	}
	return 1;
}

#define BASE_FLAGS (0)

int
smbbufferputheader(SmbBuffer *b, SmbHeader *h, SmbPeerInfo *p)
{
	SmbRawHeader *rh;
	if (offsetof(SmbRawHeader, parameterwords[0]) &gt; smbbufferwritespace(b))
		return 0;
	if (smbbufferwriteoffset(b) == 0) {
		rh = (SmbRawHeader *)smbbufferwritepointer(b);
		rh-&gt;protocol[0] = 0xff;
		memcpy(rh-&gt;protocol + 1, "SMB", 3);
		rh-&gt;flags = SMB_FLAGS_SERVER_TO_REDIR | SmbHeaderFlagCaseless;
		rh-&gt;command = h-&gt;command;
		smbhnputs(rh-&gt;flags2, BASE_FLAGS | (smbsendunicode(p) ? SMB_FLAGS2_UNICODE : 0));
		memset(rh-&gt;extra, 0, sizeof(rh-&gt;extra));
		if (!smbbufferputbytes(b, nil, offsetof(SmbRawHeader, parameterwords[0])))
			return 0;
		rh-&gt;wordcount = h-&gt;wordcount;
	}
	else {
		rh = (SmbRawHeader *)smbbufferreadpointer(b);
		smbbufferputb(b, h-&gt;wordcount);
	}
	rh-&gt;status[0] = h-&gt;errclass;
	rh-&gt;status[1] = 0;
	smbhnputs(rh-&gt;status + 2, h-&gt;error);
	smbhnputs(rh-&gt;tid, h-&gt;tid);
	smbhnputs(rh-&gt;pid, h-&gt;pid);
	smbhnputs(rh-&gt;uid, h-&gt;uid);
	smbhnputs(rh-&gt;mid, h-&gt;mid);
	return 1;
}

int
smbbufferputerror(SmbBuffer *s, SmbHeader *h, SmbPeerInfo *p, uchar errclass, ushort error)
{
	h-&gt;errclass = errclass;
	h-&gt;error = error;
	return smbbufferputheader(s, h, p);
}

int
smbbufferputandxheader(SmbBuffer *b, SmbHeader *h, SmbPeerInfo *p, uchar andxcommand, ulong *andxoffsetfixupp)
{
	if (!smbbufferputheader(b, h, p)
		|| !smbbufferputb(b, andxcommand)
		|| !smbbufferputb(b, 0))
		return 0;
	*andxoffsetfixupp = smbbufferwriteoffset(b);
	return smbbufferputbytes(b, nil, 2);
}

void
smbseterror(SmbSession *s, uchar errclass, ushort error)
{
	s-&gt;errclass = errclass;
	s-&gt;error = error;
}

SmbProcessResult
smbbufferputack(SmbBuffer *b, SmbHeader *h, SmbPeerInfo *p)
{
	h-&gt;wordcount = 0;
	return smbbufferputheader(b, h, p) &amp;&amp; smbbufferputs(b, 0) ? SmbProcessResultReply : SmbProcessResultMisc;
}

ushort
smbplan9mode2dosattr(ulong mode)
{
	if (mode &amp; DMDIR)
		return SMB_ATTR_DIRECTORY;
	return SMB_ATTR_NORMAL;
}

ulong
smbdosattr2plan9mode(ushort attr)
{
	ulong mode = 0444;
	if ((attr &amp; SMB_ATTR_READ_ONLY) == 0)
		mode |= 0222;
	if (attr &amp; SMB_ATTR_DIRECTORY) {
		mode |= DMDIR | 0711;
		mode &amp;= DMDIR | 0755;
	}
	else
		mode &amp;= 0744;
	return mode;
}

ulong
smbdosattr2plan9wstatmode(ulong oldmode, ushort attr)
{
	ulong mode;
	if (oldmode &amp; DMDIR)
		attr |= SMB_ATTR_DIRECTORY;
	else
		attr &amp;= ~SMB_ATTR_DIRECTORY;
	mode = smbdosattr2plan9mode(attr);
	if (oldmode &amp; 0444)
		mode = (mode &amp; ~0444) | (mode &amp; 0444);
	if ((attr &amp; SMB_ATTR_READ_ONLY) == 0)
		mode |= oldmode &amp; 0222;
	if (mode == oldmode)
		mode = 0xffffffff;
	return mode;
}

ulong
smbplan9length2size32(vlong length)
{
	if (length &gt; 0xffffffff)
		return 0xffffffff;
	return length;
}

vlong
smbl2roundupvlong(vlong v, int l2)
{
	uvlong mask;
	mask = (1 &lt;&lt; l2) - 1;
	return (v + mask) &amp; ~mask;
}

SmbSlut smbsharemodeslut[] = {
	{ "compatibility", SMB_OPEN_MODE_SHARE_COMPATIBILITY },
	{ "exclusive", SMB_OPEN_MODE_SHARE_EXCLUSIVE },
	{ "denywrite", SMB_OPEN_MODE_SHARE_DENY_WRITE },
	{ "denyread", SMB_OPEN_MODE_SHARE_DENY_READOREXEC },
	{ "denynone", SMB_OPEN_MODE_SHARE_DENY_NONE },
	{ 0 }
};

SmbSlut smbopenmodeslut[] = {
	{ "oread", OREAD },
	{ "owrite", OWRITE },
	{ "ordwr", ORDWR },
	{ "oexec", OEXEC },
	{ 0 }
};

int
smbslut(SmbSlut *s, char *pat)
{
	while (s-&gt;name) {
		if (cistrcmp(s-&gt;name, pat) == 0)
			return s-&gt;val;
		s++;
	}
	return -1;
}

char *
smbrevslut(SmbSlut *s, int val)
{
	while (s-&gt;name) {
		if (s-&gt;val == val)
			return s-&gt;name;
		s++;
	}
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

