<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbcomquery.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbcomquery.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

SmbProcessResult
smbcomqueryinformation(SmbSession *s, SmbHeader *h, uchar *, SmbBuffer *b)
{
	SmbTree *t;
	uchar fmt;
	char *path;
	Dir *d;
	char *fullpath;

	if (!smbcheckwordcount("comqueryinformation", h, 0)
		|| !smbbuffergetb(b, &amp;fmt)
		|| fmt != 4
		|| !smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path))
		return SmbProcessResultFormat;
	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		free(path);
		smbseterror(s, ERRSRV, ERRinvtid);
		return SmbProcessResultError;
	}
	smblogprint(h-&gt;command, "smbcomqueryinformation: %s\n", path);
	fullpath = nil;
	smbstringprint(&amp;fullpath, "%s%s", t-&gt;serv-&gt;path, path);
	d = dirstat(fullpath);
	free(fullpath);
	free(path);
	if (d == nil) {
		smbseterror(s, ERRDOS, ERRbadpath);
		return SmbProcessResultError;
	}
	h-&gt;wordcount = 10;
	if (!smbbufferputheader(s-&gt;response, h, &amp;s-&gt;peerinfo)
		|| !smbbufferputs(s-&gt;response, smbplan9mode2dosattr(d-&gt;mode))
		|| !smbbufferputl(s-&gt;response, smbplan9time2utime(d-&gt;mtime, s-&gt;tzoff))
		|| !smbbufferputl(s-&gt;response, smbplan9length2size32(d-&gt;length))
		|| !smbbufferfill(s-&gt;response, 0, 10)
		|| !smbbufferputs(s-&gt;response, 0)) {
		free(d);
		return SmbProcessResultMisc;
	}
	free(d);
	return SmbProcessResultReply;
}

SmbProcessResult
smbcomqueryinformation2(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *)
{
	SmbTree *t;
	Dir *d;
	ushort fid;
	ushort mtime, mdate;
	ushort atime, adate;
	SmbFile *f;

	if (!smbcheckwordcount("comqueryinformation2", h, 1))
		return SmbProcessResultFormat;
	fid = smbnhgets(pdata);
	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		return SmbProcessResultError;
	}
	f = smbidmapfind(s-&gt;fidmap, fid);
	if (f == nil) {
		smbseterror(s, ERRDOS, ERRbadfid);
		return SmbProcessResultError;
	}
	d = dirfstat(f-&gt;fd);
	if (d == nil) {
		smbseterror(s, ERRDOS, ERRbadpath);
		return SmbProcessResultError;
	}
	h-&gt;wordcount = 11;
	smbplan9time2datetime(d-&gt;atime, s-&gt;tzoff, &amp;adate, &amp;atime);
	smbplan9time2datetime(d-&gt;mtime, s-&gt;tzoff, &amp;mdate, &amp;mtime);
	if (!smbbufferputheader(s-&gt;response, h, &amp;s-&gt;peerinfo)
		|| !smbbufferputs(s-&gt;response, mdate)
		|| !smbbufferputs(s-&gt;response, mtime)
		|| !smbbufferputs(s-&gt;response, adate)
		|| !smbbufferputs(s-&gt;response, atime)
		|| !smbbufferputs(s-&gt;response, mdate)
		|| !smbbufferputs(s-&gt;response, mtime)
		|| !smbbufferputl(s-&gt;response, smbplan9length2size32(d-&gt;length))
		|| !smbbufferputl(s-&gt;response,
			smbplan9length2size32(smbl2roundupvlong(d-&gt;length, smbglobals.l2allocationsize)))
		|| !smbbufferputs(s-&gt;response, smbplan9mode2dosattr(d-&gt;mode))
		|| !smbbufferputs(s-&gt;response, 0)) {
		free(d);
		return SmbProcessResultMisc;
	}
	free(d);
	return SmbProcessResultReply;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

