<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbcomtransaction.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbcomtransaction.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

static int
sendresponse(void *magic, SmbBuffer *, char **errmsgp)
{
	int rv;
	SmbSession *s = magic;
	rv = smbresponsesend(s);
	if (rv &lt; 0) {
		smbstringprint(errmsgp, "sendresponse failed");
		return 0;
	}
	return 1;
}

SmbTransactionMethod smbtransactionmethod = {
	.encoderesponse = smbtransactionencoderesponse,
	.sendresponse = sendresponse,
};

SmbTransactionMethod smbtransactionmethod2 = {
	.encoderesponse = smbtransactionencoderesponse2,
	.sendresponse = sendresponse,
};

int
smbcomtransaction(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	int rv;
	char *errmsg;
	SmbProcessResult pr = SmbProcessResultDie;
	errmsg = nil;
	rv = smbtransactiondecodeprimary(&amp;s-&gt;transaction, h, pdata, b, &amp;errmsg);
	if (rv &lt; 0) {
		pr = SmbProcessResultFormat;
		goto done;
	}
	if (rv == 0) {
		h-&gt;wordcount = 0;
		if (smbbufferputack(s-&gt;response, h, &amp;s-&gt;peerinfo)) {
			pr = SmbProcessResultReply;
			s-&gt;nextcommand = SMB_COM_TRANSACTION_SECONDARY;
		}
		goto done;
	}
	smblogprint(h-&gt;command, "smbcomtransaction: %s scount %ud tpcount %lud tdcount %lud maxscount %lud maxpcount %lud maxdcount %lud\n",
		s-&gt;transaction.in.name, s-&gt;transaction.in.scount, s-&gt;transaction.in.tpcount, s-&gt;transaction.in.tdcount,
		s-&gt;transaction.in.maxscount, s-&gt;transaction.in.maxpcount, s-&gt;transaction.in.maxdcount);
	smbbufferfree(&amp;s-&gt;transaction.out.parameters);
	smbbufferfree(&amp;s-&gt;transaction.out.data);
	s-&gt;transaction.out.parameters = smbbuffernew(s-&gt;transaction.in.maxpcount);
	s-&gt;transaction.out.data = smbbuffernew(s-&gt;transaction.in.maxdcount);
	if (strcmp(s-&gt;transaction.in.name, smbglobals.pipelanman) == 0)
		pr = smbrap2(s);
	else {
		smbseterror(s, ERRDOS, ERRbadpath);
		pr = SmbProcessResultError;
		goto done;
	}
	if (pr == SmbProcessResultReply) {
		char *errmsg;
		errmsg = nil;
		rv = smbtransactionrespond(&amp;s-&gt;transaction, h, &amp;s-&gt;peerinfo, s-&gt;response, &amp;smbtransactionmethod, s, &amp;errmsg);
		if (!rv) {
			smblogprint(h-&gt;command, "smbcomtransaction: failed: %s\n", errmsg);
			pr = SmbProcessResultMisc;
		}
		else
			pr = SmbProcessResultOk;
	}
done:
	free(errmsg);
	return pr;
}

int
smbcomtransaction2(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	int rv;
	char *errmsg;
	SmbProcessResult pr = SmbProcessResultDie;
	ushort op;

	errmsg = nil;
	rv = smbtransactiondecodeprimary2(&amp;s-&gt;transaction, h, pdata, b, &amp;errmsg);
	if (rv &lt; 0) {
	fmtfail:
		pr = SmbProcessResultFormat;
		goto done;
	}
	if (rv == 0) {
		h-&gt;wordcount = 0;
		if (smbbufferputack(s-&gt;response, h, &amp;s-&gt;peerinfo)) {
			pr = SmbProcessResultReply;
			s-&gt;nextcommand = SMB_COM_TRANSACTION2_SECONDARY;
		}
		goto done;
	}
	smblogprint(h-&gt;command, "smbcomtransaction2: scount %ud tpcount %lud tdcount %lud maxscount %lud maxpcount %lud maxdcount %lud\n",
		s-&gt;transaction.in.scount, s-&gt;transaction.in.tpcount, s-&gt;transaction.in.tdcount,
		s-&gt;transaction.in.maxscount, s-&gt;transaction.in.maxpcount, s-&gt;transaction.in.maxdcount);
	smbbufferfree(&amp;s-&gt;transaction.out.parameters);
	smbbufferfree(&amp;s-&gt;transaction.out.data);
	s-&gt;transaction.out.parameters = smbbuffernew(s-&gt;transaction.in.maxpcount);
	s-&gt;transaction.out.data = smbbuffernew(s-&gt;transaction.in.maxdcount);
	if (s-&gt;transaction.in.scount != 1)
		goto fmtfail;
	op = s-&gt;transaction.in.setup[0];
	if (op &gt;= smbtrans2optablesize || smbtrans2optable[op].name == nil) {
		smblogprint(-1, "smbcomtransaction2: function %d unknown\n", op);
		pr = SmbProcessResultUnimp;
		goto done;
	}
	if (smbtrans2optable[op].process == nil) {
		smblogprint(-1, "smbcomtransaction2: %s unimplemented\n", smbtrans2optable[op].name);
		pr = SmbProcessResultUnimp;
		goto done;
	}
	pr = (*smbtrans2optable[op].process)(s, h);
	if (pr == SmbProcessResultReply) {
		char *errmsg;
		errmsg = nil;
		rv = smbtransactionrespond(&amp;s-&gt;transaction, h, &amp;s-&gt;peerinfo, s-&gt;response, &amp;smbtransactionmethod2, s, &amp;errmsg);
		if (!rv) {
			smblogprint(h-&gt;command, "smbcomtransaction2: failed: %s\n", errmsg);
			pr = SmbProcessResultMisc;
		}
		else
			pr = SmbProcessResultOk;
	}
done:
	free(errmsg);
	return pr;
}



<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

