<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smblisten.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smblisten.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

static struct {
	int thread;
	QLock;
	char adir[NETPATHLEN];
	int acfd;
	char ldir[NETPATHLEN];
	int lcfd;
	SMBCIFSACCEPTFN *accept;
} tcp = { -1 };

typedef struct Session Session;

enum { Connected, Dead };

struct Session {
	SmbCifsSession;
	int thread;
	Session *next;
	int state;
	SMBCIFSWRITEFN *write;
};

static struct {
	QLock;
	Session *head;
} sessions;

typedef struct Listen Listen;

static void
deletesession(Session *s)
{
	Session **sp;
	close(s-&gt;fd);
	qlock(&amp;sessions);
	for (sp = &amp;sessions.head; *sp &amp;&amp; *sp != s; sp = &amp;(*sp)-&gt;next)
		;
	if (*sp)
		*sp = s-&gt;next;
	qunlock(&amp;sessions);
	free(s);
}

static void
tcpreader(void *a)
{
	Session *s = a;
	uchar *buf;
	int buflen = smbglobals.maxreceive + 4;
	buf = nbemalloc(buflen);
	for (;;) {
		int n;
		uchar flags;
		ushort length;

		n = readn(s-&gt;fd, buf, 4);
		if (n != 4) {
		die:
			free(buf);
			if (s-&gt;state == Connected)
				(*s-&gt;write)(s, nil, -1);
			deletesession(s);
			return;
		}
		flags = buf[1];
		length = nhgets(buf + 2) | ((flags &amp; 1) &lt;&lt; 16);
		if (length &gt; buflen - 4) {
			print("nbss: too much data (%ud)\n", length);
			goto die;
		}
		n = readn(s-&gt;fd, buf + 4, length);
		if (n != length)
			goto die;
		if (s-&gt;state == Connected) {
			if ((*s-&gt;write)(s, buf + 4, length) != 0) {
				s-&gt;state = Dead;
				goto die;
			}
		}
	}
}

static Session *
createsession(int fd)
{
	Session *s;
	s = smbemalloc(sizeof(Session));
	s-&gt;fd = fd;
	s-&gt;state = Connected;
	qlock(&amp;sessions);
	if (!(*tcp.accept)(s, &amp;s-&gt;write)) {
		qunlock(&amp;sessions);
		free(s);
		return nil;
	}
	s-&gt;thread = procrfork(tcpreader, s, 32768, RFNAMEG);
	if (s-&gt;thread &lt; 0) {
		qunlock(&amp;sessions);
		(*s-&gt;write)(s, nil, -1);
		free(s);
		return nil;
	}
	s-&gt;next = sessions.head;
	sessions.head = s;
	qunlock(&amp;sessions);
	return s;
}

static void
tcplistener(void *)
{
	for (;;) {
		int dfd;
		char ldir[NETPATHLEN];
		int lcfd;
//print("cifstcplistener: listening\n");
		lcfd = listen(tcp.adir, ldir);
//print("cifstcplistener: contact\n");
		if (lcfd &lt; 0) {
		die:
			qlock(&amp;tcp);
			close(tcp.acfd);
			tcp.thread = -1;
			qunlock(&amp;tcp);
			return;
		}
		dfd = accept(lcfd, ldir);
		close(lcfd);
		if (dfd &lt; 0)
			goto die;
		if (createsession(dfd) == nil)
			close(dfd);
	}
}

int
smblistencifs(SMBCIFSACCEPTFN *accept)
{
	qlock(&amp;tcp);
	if (tcp.thread &lt; 0) {
		tcp.acfd = announce("tcp!*!cifs", tcp.adir);
		if (tcp.acfd &lt; 0) {
			print("smblistentcp: can't announce: %r\n");
			qunlock(&amp;tcp);
			return -1;
		}
		tcp.thread = proccreate(tcplistener, nil, 16384);
	}
	tcp.accept = accept;
	qunlock(&amp;tcp);
	return 0;
}
	<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

