<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbsharedfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbsharedfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

typedef struct SmbSharedFileEntry SmbSharedFileEntry;
struct SmbSharedFileEntry {
	SmbSharedFile;
	Ref;
	SmbSharedFileEntry *next;
};

static struct {
	QLock;
	SmbSharedFileEntry *list;
} sharedfiletable;

typedef struct SmbLockListEntry SmbLockListEntry;

struct SmbLockListEntry {
	SmbLock;
	SmbLockListEntry *next;
};

struct SmbLockList {
	SmbLockListEntry *head;
};

static int
lockconflict(SmbLock *l1, SmbLock *l2)
{
	return l1-&gt;base &lt; l2-&gt;limit &amp;&amp; l2-&gt;base &lt; l1-&gt;limit;
}

static int
lockorder(SmbLock *l1, SmbLock *l2)
{
	if (l1-&gt;base &lt; l2-&gt;base)
		return -1;
	if (l1-&gt;base &gt; l2-&gt;base)
		return 1;
	if (l1-&gt;limit &gt; l2-&gt;limit)
		return -1;
	if (l1-&gt;limit &lt; l2-&gt;limit)
		return 1;
	return 0;
}

static void
locklistfree(SmbLockList **llp)
{
	SmbLockList *ll = *llp;
	if (ll) {
		while (ll-&gt;head) {
			SmbLockListEntry *next = ll-&gt;head-&gt;next;
			free(ll-&gt;head);
			ll-&gt;head = next;
		}
		free(ll);
		*llp = nil;
	}
}

int
smbsharedfilelock(SmbSharedFile *sf, SmbSession *s, ushort pid, vlong base, vlong limit)
{
	SmbLockListEntry smblock;
	SmbLockListEntry *l, *nl, **lp;
	smblock.s = s;
	smblock.pid = pid;
	smblock.base = base;
	smblock.limit = limit;
	if (sf-&gt;locklist) {
		for (l = sf-&gt;locklist-&gt;head; l; l = l-&gt;next)
			if (lockconflict(l, &amp;smblock)) {
				smblogprintif(smbglobals.log.locks, "smbsharedfilelock: lock [%lld, %lld) failed because conflicts with [%lld, %lld)\n",
					base, limit, l-&gt;base, l-&gt;limit);
				return 0;
			}
	}
	if (sf-&gt;locklist == nil)
		sf-&gt;locklist = smbemallocz(sizeof(SmbLockList), 1);
	for (lp = &amp;sf-&gt;locklist-&gt;head; (l = *lp) != nil; lp = &amp;l-&gt;next)
		if (lockorder(&amp;smblock, l) &lt;= 0)
			break;
	smblogprintif(smbglobals.log.locks, "smbsharedfilelock: lock [%lld, %lld) succeeded\n", base, limit);
	nl = smbemalloc(sizeof(*nl));
	*nl = smblock;
	nl-&gt;next = *lp;
	*lp = nl;
//{
//	smblogprintif(smbglobals.log.locks,"smbsharedfilelock: list\n");
//	for (l = sf-&gt;locklist-&gt;head; l; l = l-&gt;next)
//		smblogprintif(smbglobals.log.locks, "smbsharedfilelock: [%lld, %lld)\n", l-&gt;base, l-&gt;limit);
//}
	return 1;
}

int
smbsharedfileunlock(SmbSharedFile *sf, SmbSession *s, ushort pid, vlong base, vlong limit)
{
	SmbLockListEntry smblock;
	SmbLockListEntry *l, **lp;
	smblock.s = s;
	smblock.pid = pid;
	smblock.base = base;
	smblock.limit = limit;
	if (sf-&gt;locklist == nil)
		goto failed;
	for (lp = &amp;sf-&gt;locklist-&gt;head; (l = *lp) != nil; lp = &amp;l-&gt;next) {
		if (l-&gt;s != s || l-&gt;pid != pid)
			continue;
		switch (lockorder(&amp;smblock, l)) {
		case 0:
			*lp = l-&gt;next;
			free(l);
			smblogprintif(smbglobals.log.locks, "smbsharedfilelock: unlock [%lld, %lld) succeeded\n", base, limit);
			return 1;
		case -1:
			goto failed;
		}
	}
failed:
	smblogprintif(smbglobals.log.locks, "smbsharedfilelock: unlock [%lld, %lld) failed\n", base, limit);
	return 0;
}

static int
p9denied(int p9mode, int share)
{
//smblogprint(-1, "p9denied(%d, %d)\n", p9mode, share);
	if (share == SMB_OPEN_MODE_SHARE_EXCLUSIVE)
		return 1;
	switch (p9mode &amp; 3) {
	case OREAD:
	case OEXEC:
		if (share == SMB_OPEN_MODE_SHARE_DENY_READOREXEC)
			return 1;
		break;
	case OWRITE:
		if (share == SMB_OPEN_MODE_SHARE_DENY_WRITE)
			return 1;
		break;
	case ORDWR:
		if (share != SMB_OPEN_MODE_SHARE_DENY_NONE)
			return 1;
		break;
	}
	return 0;
}

static void
sharesplit(int share, int *denyread, int *denywrite)
{
	switch (share) {
	case SMB_OPEN_MODE_SHARE_EXCLUSIVE:
		*denyread = 1;
		*denywrite = 1;
		break;
	case SMB_OPEN_MODE_SHARE_DENY_READOREXEC:
		*denyread = 1;
		*denywrite = 0;
		break;
	case SMB_OPEN_MODE_SHARE_DENY_WRITE:
		*denywrite = 0;
		*denywrite = 1;
		break;
	default:
		*denyread = 0;
		*denywrite = 0;
	}
}

static int
sharemake(int denyread, int denywrite)
{
	if (denyread)
		if (denywrite)
			return SMB_OPEN_MODE_SHARE_EXCLUSIVE;
		else
			return SMB_OPEN_MODE_SHARE_DENY_READOREXEC;
	else if (denywrite)
		return SMB_OPEN_MODE_SHARE_DENY_WRITE;
	else
		return SMB_OPEN_MODE_SHARE_DENY_NONE;
}

static ushort
sharesubtract(int share1, int share2)
{
	int dr1, dw1;
	int dr2, dw2;
	sharesplit(share1, &amp;dr1, &amp;dw1);
	sharesplit(share2, &amp;dr2, &amp;dw2);
	if (dw2)
		dw1 = 0;
	if (dr2)
		dr1 = 0;
	return sharemake(dr1, dw1);
}

static int
shareadd(int share1, int share2)
{
	int dr1, dw1;
	int dr2, dw2;
	sharesplit(share1, &amp;dr1, &amp;dw1);
	sharesplit(share2, &amp;dr2, &amp;dw2);
	if (dw2)
		dw1 = 1;
	if (dr2)
		dr1 = 1;
	return sharemake(dr1, dw1);
}

SmbSharedFile *
smbsharedfileget(Dir *d, int p9mode, int *sharep)
{
	SmbSharedFileEntry *sfe;
	qlock(&amp;sharedfiletable);
	for (sfe = sharedfiletable.list; sfe; sfe = sfe-&gt;next) {
		if (sfe-&gt;type == d-&gt;type &amp;&amp; sfe-&gt;dev == d-&gt;dev &amp;&amp; sfe-&gt;path == d-&gt;qid.path) {
			if (p9denied(p9mode, sfe-&gt;share)) {
				qunlock(&amp;sharedfiletable);
				return nil;
			}
			*sharep = sharesubtract(*sharep, sfe-&gt;share);
			sfe-&gt;share = shareadd(sfe-&gt;share, *sharep);
			sfe-&gt;ref++;
			goto done;
		}
	}
	sfe = smbemallocz(sizeof(SmbSharedFileEntry), 1);
	sfe-&gt;type = d-&gt;type;
	sfe-&gt;dev = d-&gt;dev;
	sfe-&gt;path = d-&gt;qid.path;
//	sfe-&gt;name = smbestrdup(name);
	sfe-&gt;ref = 1;
	sfe-&gt;share = *sharep;
	sfe-&gt;next = sharedfiletable.list;
	sharedfiletable.list = sfe;
done:
	smblogprintif(smbglobals.log.sharedfiles, "smbsharedfileget: ref %d share %d\n",
		sfe-&gt;ref, sfe-&gt;share);
	qunlock(&amp;sharedfiletable);
	return sfe;
}

void
smbsharedfileput(SmbFile *f, SmbSharedFile *sf, int share)
{
	SmbSharedFileEntry *sfe, **sfep;
	qlock(&amp;sharedfiletable);
	for (sfep = &amp;sharedfiletable.list; (sfe = *sfep) != nil; sfep = &amp;sfe-&gt;next) {
		if (sfe == sf) {
			sfe-&gt;ref--;
			if (sfe-&gt;ref == 0) {
				*sfep = sfe-&gt;next;
				if (sfe-&gt;deleteonclose &amp;&amp; f)
					smbremovefile(f-&gt;t, nil, f-&gt;name);
				smblogprintif(smbglobals.log.sharedfiles, "smbsharedfileput: removed\n");
				locklistfree(&amp;sfe-&gt;locklist);
				free(sfe);
			}
			else {
				sfe-&gt;share = sharesubtract(sfe-&gt;share, share);
				smblogprintif(smbglobals.log.sharedfiles,
					"smbsharedfileput: ref %d share %d\n", sfe-&gt;ref, sfe-&gt;share);
			}
			break;
		}
	}
	qunlock(&amp;sharedfiletable);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

