<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbtrans2find.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbtrans2find.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"
#include &lt;pool.h&gt;

void
smbsearchfree(SmbSearch **searchp)
{
	SmbSearch *search = *searchp;
	if (search) {
		smbdircachefree(&amp;search-&gt;dc);
		free(search-&gt;rep);
		free(search);
		*searchp = nil;
	}
}

void
smbsearchclose(SmbSession *s, SmbSearch *search)
{
	if (search) {
		smblogprintif(smbglobals.log.sids, "smbsearchclose: tid 0x%.4ux sid 0x%.4ux\n", search-&gt;t-&gt;id, search-&gt;id);
		smbidmapremove(s-&gt;sidmap, search);
		smbsearchfree(&amp;search);
	}
}

void
smbsearchclosebyid(SmbSession *s, ushort sid)
{
	smbsearchclose(s,  smbidmapfind(s-&gt;sidmap, sid));
}

SmbSearch *
smbsearchnew(SmbSession *s, SmbDirCache *dc, Reprog *r, SmbTree *t)
{
	SmbSearch *search;
	if (s-&gt;sidmap == nil)
		s-&gt;sidmap = smbidmapnew();
	search = smbemalloc(sizeof(SmbSearch));
	smbidmapadd(s-&gt;sidmap, search);
	search-&gt;dc = dc;
	search-&gt;rep = r;
	search-&gt;t = t;
	smblogprintif(smbglobals.log.sids, "smbsearchnew: 0x%.4ux\n", search-&gt;id);
	return search;
}

static int
standardflatten(SmbSession *s, SmbBuffer *b, Dir *d, ulong *nameoffsetp)
{
	ushort mdate, mtime;
	ushort adate, atime;
	ushort fnlfixupoffset;

	smbplan9time2datetime(d-&gt;mtime, s-&gt;tzoff, &amp;mdate, &amp;mtime);
	smbplan9time2datetime(d-&gt;atime, s-&gt;tzoff, &amp;adate, &amp;atime);
	if (!smbbufferputs(b, mdate)
		|| !smbbufferputs(b, mtime)
		|| !smbbufferputs(b, adate)
		|| !smbbufferputs(b, atime)
		|| !smbbufferputs(b, mdate)
		|| !smbbufferputs(b, mtime)
		|| !smbbufferputl(b, d-&gt;length)
		|| !smbbufferputl(b, 512)			// ha
		|| !smbbufferputs(b, (d-&gt;qid.type &amp; QTDIR) ? 0x10 : 0))
		return 0;
	fnlfixupoffset = smbbufferwriteoffset(b);
	if (!smbbufferputs(b, 0))
		return 0;
	*nameoffsetp = smbbufferwriteoffset(b);
	if (!smbbufferputstring(b, &amp;s-&gt;peerinfo, 0, d-&gt;name))
		return 0;
	return smbbufferfixuprelatives(b, fnlfixupoffset);
}

static int
findbothflatten(SmbBuffer *b, SmbPeerInfo *p, Dir *d, ulong resumekey, ulong *nameoffsetp)
{
	vlong mtime, atime;
	ulong fixup;

	fixup = smbbufferwriteoffset(b);
	mtime = smbplan9time2time(d-&gt;mtime);
	atime = smbplan9time2time(d-&gt;atime);
poolcheck(mainmem);
	if (!smbbufferputl(b, 0)
		|| !smbbufferputl(b, resumekey)
		|| !smbbufferputv(b, mtime)
		|| !smbbufferputv(b, atime)
		|| !smbbufferputv(b, mtime)
		|| !smbbufferputv(b, mtime)
		|| !smbbufferputv(b, d-&gt;length)
		|| !smbbufferputv(b, smbl2roundupvlong(d-&gt;length, smbglobals.l2allocationsize))			// ha
		|| !smbbufferputl(b, (d-&gt;qid.type &amp; QTDIR) ? 0x10 : 0x80)
		|| !smbbufferputl(b, smbstringlen(p, d-&gt;name))
		|| !smbbufferputl(b, 0)
		|| !smbbufferputb(b, 0)
		|| !smbbufferputb(b, 0)
		|| !smbbufferfill(b, 0, 24))
		return 0;
poolcheck(mainmem);
	*nameoffsetp = smbbufferwriteoffset(b);
	if (!smbbufferputstring(b, p, 0, d-&gt;name) || !smbbufferalignl2(b, 2))
		return 0;
poolcheck(mainmem);
	return smbbufferfixuprelativeinclusivel(b, fixup);
}

static void
populate(SmbSession *s, SmbDirCache *dc, Reprog *r, ushort informationlevel, ushort flags, ushort scount,
	ushort *ep, ulong *nameoffsetp)
{
	ushort e;
	ulong nameoffset;
	e = 0;
	nameoffset = 0;
	while (dc-&gt;i &lt; dc-&gt;n &amp;&amp; e &lt; scount) {
		ulong backup;
		int rv;
		
		if (!smbmatch(dc-&gt;buf[dc-&gt;i].name, r)) {
			dc-&gt;i++;
			continue;
		}
		rv = 0;
		backup = smbbufferwriteoffset(s-&gt;transaction.out.data);
		switch (informationlevel) {
		case SMB_INFO_STANDARD:
			if (flags &amp; SMB_FIND_RETURN_RESUME_KEYS) {
				if (!smbbufferputl(s-&gt;transaction.out.data, dc-&gt;i)) {
					rv = 0;
					break;
				}
			}
			rv = standardflatten(s, s-&gt;transaction.out.data, dc-&gt;buf + dc-&gt;i, &amp;nameoffset);
			break;
		case SMB_FIND_FILE_BOTH_DIRECTORY_INFO:
			rv = findbothflatten(s-&gt;transaction.out.data, &amp;s-&gt;peerinfo, dc-&gt;buf + dc-&gt;i, dc-&gt;i, &amp;nameoffset);
			break;
		}
		if (rv == 0) {
			smbbufferwritebackup(s-&gt;transaction.out.data, backup);
			break;
		}
		dc-&gt;i++;
		e++;
	}
	*ep = e;
	*nameoffsetp = nameoffset;
}

SmbProcessResult
smbtrans2findfirst2(SmbSession *s, SmbHeader *h)
{
	SmbBuffer *b;
	char *pattern = nil;
	char *dir = nil;
	char *name = nil;
	ushort searchattributes, searchcount, flags, informationlevel;
	ulong searchstoragetype;
	SmbDirCache *dc = nil;
	ushort e;
	ulong nameoffset;
	ushort eos;
	SmbSearch *search;
	SmbProcessResult pr;
	Reprog *r = nil;
	SmbTree *t;
	int debug;

	debug = smboptable[h-&gt;command].debug
		|| smbtrans2optable[SMB_TRANS2_FIND_FIRST2].debug
		|| smbglobals.log.find;
poolcheck(mainmem);
	b = smbbufferinit(s-&gt;transaction.in.parameters, s-&gt;transaction.in.parameters, s-&gt;transaction.in.tpcount);
	if (!smbbuffergets(b, &amp;searchattributes)
		|| !smbbuffergets(b, &amp;searchcount)
		|| !smbbuffergets(b, &amp;flags)
		|| !smbbuffergets(b, &amp;informationlevel)
		|| !smbbuffergetl(b, &amp;searchstoragetype)
		|| !smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;pattern)) {
		pr = SmbProcessResultFormat;
		goto done;
	}
	smbloglock();
	smblogprintif(debug, "searchattributes: 0x%.4ux\n", searchattributes);
	smblogprintif(debug, "searchcount: 0x%.4ux\n", searchcount);
	smblogprintif(debug, "flags: 0x%.4ux\n", flags);
	smblogprintif(debug, "informationlevel: 0x%.4ux\n", informationlevel);
	smblogprintif(debug, "searchstoragetype: 0x%.8lux\n", searchstoragetype);
	smblogprintif(debug, "pattern: %s\n", pattern);
	smblogunlock();
	smbpathsplit(pattern, &amp;dir, &amp;name);
	if (informationlevel != SMB_INFO_STANDARD &amp;&amp; informationlevel != SMB_FIND_FILE_BOTH_DIRECTORY_INFO) {
		smblogprint(-1, "smbtrans2findfirst2: infolevel 0x%.4ux not implemented\n", informationlevel);
		smbseterror(s, ERRDOS, ERRunknownlevel);
		pr = SmbProcessResultError;
		goto done;
	}

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}

	dc = smbmkdircache(t, dir);
	if (dc == nil) {
		smbseterror(s, ERRDOS, ERRnoaccess);
		pr = SmbProcessResultError;
		goto done;
	}
poolcheck(mainmem);
	r = smbmkrep(name);
	populate(s, dc, r, informationlevel, flags, searchcount, &amp;e, &amp;nameoffset);
poolcheck(mainmem);
	eos = dc-&gt;i &gt;= dc-&gt;n;
	if ((flags &amp; SMB_FIND_CLOSE) != 0 || ((flags &amp; SMB_FIND_CLOSE_EOS) != 0 &amp;&amp; eos))
		smbdircachefree(&amp;dc);
poolcheck(mainmem);
	if (dc) {
		/* create a search handle */
		search = smbsearchnew(s, dc, r, t);
		r = nil;
		dc = nil;
	}
	else
		search = nil;
	smbbufferputs(s-&gt;transaction.out.parameters, search ? search-&gt;id : 0);
	smbbufferputs(s-&gt;transaction.out.parameters, e);
	smbbufferputs(s-&gt;transaction.out.parameters, eos);
	smbbufferputs(s-&gt;transaction.out.parameters, 0);
	smbbufferputs(s-&gt;transaction.out.parameters, nameoffset);
	pr = SmbProcessResultReply;
done:
	smbbufferfree(&amp;b);
	free(pattern);
	free(dir);
	free(name);
	smbdircachefree(&amp;dc);
	free(r);
	return pr;
}

SmbProcessResult
smbtrans2findnext2(SmbSession *s, SmbHeader *h)
{
	SmbBuffer *b;
	int debug;
	ushort sid, scount, infolevel;
	ulong resumekey;
	ushort flags;
	char *filename = nil;
	SmbProcessResult pr;
	ushort e;
	ulong nameoffset;
	ushort eos;
	SmbTree *t;
	SmbSearch *search;

	debug = smboptable[h-&gt;command].debug
		|| smbtrans2optable[SMB_TRANS2_FIND_NEXT2].debug
		|| smbglobals.log.find;
	b = smbbufferinit(s-&gt;transaction.in.parameters, s-&gt;transaction.in.parameters, s-&gt;transaction.in.tpcount);
	if (!smbbuffergets(b, &amp;sid)
		|| !smbbuffergets(b, &amp;scount)
		|| !smbbuffergets(b, &amp;infolevel)
		|| !smbbuffergetl(b, &amp;resumekey)
		|| !smbbuffergets(b, &amp;flags)
		|| !smbbuffergetstring(b, h, 0, &amp;filename)) {
		pr = SmbProcessResultFormat;
		goto done;
	}
	smblogprintif(debug,
		"smbtrans2findnext2: sid %d scount %d infolevel 0x%.4ux resumekey %lud flags 0x%.4ux filename %s\n",
		sid, scount, infolevel, resumekey, flags, filename);

	if (infolevel != SMB_INFO_STANDARD &amp;&amp; infolevel != SMB_FIND_FILE_BOTH_DIRECTORY_INFO) {
		smblogprint(-1, "smbtrans2findnext2: infolevel 0x%.4ux not implemented\n", infolevel);
		smbseterror(s, ERRDOS, ERRunknownlevel);
		pr = SmbProcessResultError;
		goto done;
	}

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}

	search = smbidmapfind(s-&gt;sidmap, sid);
	if (search == nil) {
		smbseterror(s, ERRDOS, ERRnofiles);
		pr = SmbProcessResultError;
		goto done;
	}

	if (search-&gt;t != t) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}

	if ((flags &amp; (1 &lt;&lt; 3)) == 0) {
		long i;
		if (filename == nil) {
			smbseterror(s, ERRDOS, ERRnofiles);
			pr = SmbProcessResultError;
			goto done;
		}
		for (i = 0; i &lt; search-&gt;dc-&gt;n; i++)
			if (strcmp(search-&gt;dc-&gt;buf[i].name, filename) == 0) {
				search-&gt;dc-&gt;i = i + 1;
				break;
			}
	}

	populate(s, search-&gt;dc, search-&gt;rep, infolevel, flags, scount, &amp;e, &amp;nameoffset);
	
	eos = search-&gt;dc-&gt;i &gt;= search-&gt;dc-&gt;n;
	if ((flags &amp; SMB_FIND_CLOSE) != 0 || ((flags &amp; SMB_FIND_CLOSE_EOS) != 0 &amp;&amp; eos))
		smbsearchclose(s, search);
	smbbufferputs(s-&gt;transaction.out.parameters, e);
	smbbufferputs(s-&gt;transaction.out.parameters, eos);
	smbbufferputs(s-&gt;transaction.out.parameters, 0);
	smbbufferputs(s-&gt;transaction.out.parameters, nameoffset);
	pr = SmbProcessResultReply;
done:
	smbbufferfree(&amp;b);
	free(filename);
	return pr;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

