<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/testnbdgram.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/testnbdgram.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

static int
deliver(void *, NbDgram *s)
{
	SmbHeader h;
	uchar *pdata;
	ushort bytecount;
	SmbBuffer *b;
	char *errmsg;
	SmbTransaction transaction;
	int rv;
//	int x;
	char *comment, *servername;
	unsigned char opcode, updatecount, versionminor, versionmajor;
	ulong periodicity, signature, type;

	errmsg = nil;
	comment = nil;
	servername = nil;
//	nbdumpdata(s-&gt;datagram.data, s-&gt;datagram.length);
	b = smbbufferinit(s-&gt;datagram.data, s-&gt;datagram.data, s-&gt;datagram.length);
	if (!smbbuffergetandcheckheader(b, &amp;h, SMB_COM_TRANSACTION, 0, &amp;pdata, &amp;bytecount, &amp;errmsg)) {
		print("ignored: %s\n", errmsg);
		goto done;
	}
	memset(&amp;transaction, 0, sizeof(transaction));
	rv = smbtransactiondecodeprimary(&amp;transaction, &amp;h, pdata, b, &amp;errmsg);
	if (rv &lt; 0) {
		print("transaction decode fail: %s\n", errmsg);
		goto done;
	}
	if (rv == 0) {
		print("transaction too big\n");
		goto done;
	}
/*
	print("name: %s\n", transaction.in.name);
	print("setup:");
	for (x = 0; x &lt; transaction.in.scount; x++)
		print(" 0x%.4ux", transaction.in.setup[x]);
	print("\n");
	print("parameters:\n");
	nbdumpdata(transaction.in.parameters, transaction.in.tpcount);
	print("data:\n");
	nbdumpdata(transaction.in.data, transaction.in.tdcount);
*/
	if (strcmp(transaction.in.name, "\\MAILSLOT\\BROWSE") != 0) {
		print("not a supported mailslot\n");
		goto done;
	}
	
	if (!smbbuffergetb(b, &amp;opcode)) {
		print("not enough data for opcode\n");
		goto done;
	}

	if (opcode != 1) {
		print("not a supported mailslot opcode %d\n", opcode);
		goto done;
	}
	
	if (!smbbuffergetb(b, &amp;updatecount)
		|| !smbbuffergetl(b, &amp;periodicity)
		|| !smbbuffergetstrn(b, 16, &amp;servername)
		|| !smbbuffergetb(b, &amp;versionmajor)
		|| !smbbuffergetb(b, &amp;versionminor)
		|| !smbbuffergetl(b, &amp;type)
		|| !smbbuffergetl(b, &amp;signature)
		|| !smbbuffergetstr(b, &amp;comment)) {
		print("mailslot parse failed\n");
		goto done;
	}
/*
 * not advisable to check this! Netgear printservers send 0x55aa
	if ((signature &amp; 0xffff0000) != 0xaa550000) {
		print("wrong signature\n");
		goto done;
	}
*/
	print("%s: period %ludms version %d.%d type 0x%.8lux browserversion %d.%d comment %s\n",
		servername, periodicity, versionmajor, versionminor, type, (signature &gt;&gt; 8) &amp; 0xff, signature &amp; 0xff, comment);
done:
	free(errmsg);
	free(comment);
	free(servername);
	smbtransactionfree(&amp;transaction);
	smbbufferfree(&amp;b);
	return 1;
}

void
threadmain(int, char **)
{
	char *e;
	NbDgramSendParameters p;
	nbinit();
	smbglobalsguess(1);
	nbmknamefromstringandtype(p.to, smbglobals.primarydomain, 0x1d);
	e = nbdgramlisten(p.to, deliver, nil);
	if (e) {
		print("listen failed: %s\n", e);
		threadexitsall("net");
	}
	p.type = NbDgramDirectUnique;
	for (;;) {
		if (!smbbrowsesendhostannouncement(smbglobals.serverinfo.name, 3 * 60 * 1000,
			SV_TYPE_SERVER,
			"Testing testing", &amp;e)) {
			print("hostannounce failed: %s\n", e);
		}
		sleep(60 * 1000);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

