<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/astro/dist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/astro/dist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "astro.h"

double
dist(Obj1 *p, Obj1 *q)
{
	double a;

	a = sin(p-&gt;decl2)*sin(q-&gt;decl2) +
		cos(p-&gt;decl2)*cos(q-&gt;decl2)*cos(p-&gt;ra-q-&gt;ra);
	a = fabs(atan2(pyth(a), a)) / radsec;
	return a;
}

int
rline(int f)
{
	char *p;
	int c;
	static char buf[1024];
	static int bc, bn, bf;

	if(bf != f) {
		bf = f;
		bn = 0;
	}
	p = line;
	do {
		if(bn &lt;= 0) {
			bn = read(bf, buf, sizeof(buf));
			if(bn &lt;= 0)
				return 1;
			bc = 0;
		}
		c = buf[bc];
		bn--; bc++;
		*p++ = c;
	} while(c != '\n');
	return 0;
}

double
sunel(double t)
{
	int i;

	i = floor(t);
	if(i &lt; 0 || i &gt; NPTS+1)
		return -90;
	t = osun.point[i].el +
		(t-i)*(osun.point[i+1].el - osun.point[i].el);
	return t;
}

double
rise(Obj2 *op, double el)
{
	Obj2 *p;
	int i;
	double e1, e2;

	e2 = 0;
	p = op;
	for(i=0; i&lt;=NPTS; i++) {
		e1 = e2;
		e2 = p-&gt;point[i].el;
		if(i &gt;= 1 &amp;&amp; e1 &lt;= el &amp;&amp; e2 &gt; el)
			goto found;
	}
	return -1;

found:
	return i - 1 + (el-e1)/(e2-e1);
}

double
set(Obj2 *op, double el)
{
	Obj2 *p;
	int i;
	double e1, e2;

	e2 = 0;
	p = op;
	for(i=0; i&lt;=NPTS; i++) {
		e1 = e2;
		e2 = p-&gt;point[i].el;
		if(i &gt;= 1 &amp;&amp; e1 &gt; el &amp;&amp; e2 &lt;= el)
			goto found;
	}
	return -1;

found:
	return i - 1 + (el-e1)/(e2-e1);
}

double
solstice(int n)
{
	int i;
	double d1, d2, d3;

	d3 = (n*pi)/2 - pi;
	if(n == 0)
		d3 += pi;
	d2 = 0.;
	for(i=0; i&lt;=NPTS; i++) {
		d1 = d2;
		d2 = osun.point[i].ra;
		if(n == 0) {
			d2 -= pi;
			if(d2 &lt; -pi)
				d2 += pipi;
		}
		if(i &gt;= 1 &amp;&amp; d3 &gt;= d1 &amp;&amp; d3 &lt; d2)
			goto found;
	}
	return -1;

found:
	return i - (d3-d2)/(d1-d2);
}

double
betcross(double b)
{
	int i;
	double d1, d2;

	d2 = 0;
	for(i=0; i&lt;=NPTS; i++) {
		d1 = d2;
		d2 = osun.point[i].mag;
		if(i &gt;= 1 &amp;&amp; b &gt;= d1 &amp;&amp; b &lt; d2)
			goto found;
	}
	return -1;

found:
	return i - (b-d2)/(d1-d2);
}

double
melong(Obj2 *op)
{
	Obj2 *p;
	int i;
	double d1, d2, d3;

	d2 = 0;
	d3 = 0;
	p = op;
	for(i=0; i&lt;=NPTS; i++) {
		d1 = d2;
		d2 = d3;
		d3 = dist(&amp;p-&gt;point[i], &amp;osun.point[i]);
		if(i &gt;= 2 &amp;&amp; d2 &gt;= d1 &amp;&amp; d2 &gt;= d3)
			goto found;
	}
	return -1;

found:
	return i - 2;
}

#define	NEVENT	100
Event	events[NEVENT];
Event*	eventp = 0;

void
event(char *format, char *arg1, char *arg2, double tim, int flag)
{
	Event *p;

	if(flag &amp; DARK)
		if(sunel(tim) &gt; -12)
			return;
	if(flag &amp; LIGHT)
		if(sunel(tim) &lt; 0)
			return;
	if(eventp == 0)
		eventp = events;
	p = eventp;
	if(p &gt;= events+NEVENT) {
		fprint(2, "too many events\n");
		return;
	}
	eventp++;
	p-&gt;format = format;
	p-&gt;arg1 = arg1;
	p-&gt;arg2 = arg2;
	p-&gt;tim = tim;
	p-&gt;flag = flag;
}

void
evflush(void)
{
	Event *p;

	if(eventp == 0)
		return;
	qsort(events, eventp-events, sizeof *p, evcomp);
	for(p = events; p&lt;eventp; p++) {
		if((p-&gt;flag&amp;SIGNIF) &amp;&amp; flags['s'])
			print("ding ding ding ");
		print(p-&gt;format, p-&gt;arg1, p-&gt;arg2);
		if(p-&gt;flag &amp; PTIME)
			ptime(day + p-&gt;tim*deld);
		print("\n");
	}
	eventp = 0;
}

int
evcomp(void *a1, void *a2)
{
	double t1, t2;
	Event *p1, *p2;

	p1 = a1;
	p2 = a2;
	t1 = p1-&gt;tim;
	t2 = p2-&gt;tim;
	if(p1-&gt;flag &amp; SIGNIF)
		t1 -= 1000.;
	if(p2-&gt;flag &amp; SIGNIF)
		t2 -= 1000.;
	if(t1 &gt; t2)
		return 1;
	if(t2 &gt; t1)
		return -1;
	return 0;
}

double
pyth(double x)
{

	x *= x;
	if(x &gt; 1)
		x = 1;
	return sqrt(1-x);
}

char*
skip(int n)
{
	int i;
	char *cp;

	cp = line;
	for(i=0; i&lt;n; i++) {
		while(*cp == ' ' || *cp == '\t')
			cp++;
		while(*cp != '\n' &amp;&amp; *cp != ' ' &amp;&amp; *cp != '\t')
			cp++;
	}
	while(*cp == ' ' || *cp == '\t')
		cp++;
	return cp;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

