<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/astro/search.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/astro/search.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "astro.h"

char*	solstr[] =
{
	"Fall equinox",
	"Winter solstice",
	"Spring equinox",
	"Summer solstice",
};

struct
{
	double	beta;
	int	rta;
	int	dec;
	char	*betstr;
} bettab[] =
{
	-1.3572, 231,	50,	"Quadrantid",
	 0.7620, 336,	0,	"Eta aquarid",
	 1.5497, 260,	-20,	"Ophiuchid",
	 2.1324, 315,	-15,	"Capricornid",
	 2.1991, 339,	-17,	"Delta aquarid",
	 2.2158, 340,	-30,	"Pisces australid",
	 2.4331, 46,	58,	"Perseid",
	-2.6578, 95,	15,	"Orionid",
	-1.8678, 15,	-55,	"Phoenicid",
	-1.7260, 113,	32,	"Geminid",
	0
};

void
search(void)
{
	Obj2 *p, *q;
	int i, j;
	double t;

	for(i=0; objlst[i]; i++) {
		p = objlst[i];
		if(p == &amp;oshad)
			continue;
		t = rise(p, -.833);
		if(t &gt;= 0.)
			event("%s rises at ", p-&gt;name, "", t,
				i==0? PTIME: PTIME|DARK);
		t = set(p, -.833);
		if(t &gt;= 0.)
			event("%s sets at ", p-&gt;name, "", t,
				i==0? PTIME: PTIME|DARK);
		if(p == &amp;osun) {
			for(j=0; j&lt;4; j++) {
				t = solstice(j);
				if(t &gt;= 0)
					event("%s at ", solstr[j], "", t,
						SIGNIF|PTIME);
			}
			for(j=0; bettab[j].beta!=0; j++) {
				t = betcross(bettab[j].beta);
				if(t &gt;= 0)
					event("%s  meeteeor shouwer",
					bettab[j].betstr, "", t, SIGNIF);
			}
			t = rise(p, -18);
			if(t &gt;= 0)
				event("Twilight starts at ", "", "", t, PTIME);
			t = set(p, -18);
			if(t &gt;= 0)
				event("Twilight ends at ", "", "", t, PTIME);
		}
		if(p == &amp;omoon)
		for(j=0; j&lt;NPTS; j++) {
			if(p-&gt;point[j].mag &gt; .75 &amp;&amp; p-&gt;point[j+1].mag &lt; .25)
				event("New moon", "", "", 0, 0);
			if(p-&gt;point[j].mag &lt;= .25 &amp;&amp; p-&gt;point[j+1].mag &gt; .25)
				event("First quarter moon", "", "", 0, 0);
			if(p-&gt;point[j].mag &lt;= .50 &amp;&amp; p-&gt;point[j+1].mag &gt; .50)
				event("Full moon", "", "", 0, 0);
			if(p-&gt;point[j].mag &lt;= .75 &amp;&amp; p-&gt;point[j+1].mag &gt; .75)
				event("Last quarter moon", "", "", 0, 0);
		}
		if(p == &amp;omerc || p == &amp;ovenus) {
			t = melong(p);
			if(t &gt;= 0) {
				t = rise(p, 0) - rise(&amp;osun, 0);
				if(t &lt; 0)
					t += NPTS;
				if(t &gt; NPTS)
					t -= NPTS;
				if(t &gt; NPTS/2)
				event("Morning elongation of %s", p-&gt;name,
					"", 0, SIGNIF);
				else
				event("Evening elongation of %s", p-&gt;name,
					"", 0, SIGNIF);
			}
		}
		for(j=i; objlst[j]; j++) {
			if(i == j)
				continue;
			q = objlst[j];
			if(p == &amp;omoon || q == &amp;omoon) {
				occult(p, q, 0);
				if(occ.t3 &lt; 0)
					continue;
				if(p == &amp;osun || q == &amp;oshad) {
					if(occ.t1 &gt;= 0)
					event("Partial eclipse of %s begins at ", p-&gt;name, "",
						occ.t1, SIGNIF|PTIME);
					if(occ.t2 &gt;= 0)
					event("Total eclipse of %s begins at ", p-&gt;name, "",
						occ.t2, SIGNIF|PTIME);
					if(occ.t4 &gt;= 0)
					event("Total eclipse of %s ends at ", p-&gt;name, "",
						occ.t4, SIGNIF|PTIME);
					if(occ.t5 &gt;= 0)
					event("Partial eclipse of %s ends at ", p-&gt;name, "",
						occ.t5, SIGNIF|PTIME);
				} else {
					if(occ.t1 &gt;= 0)
					event("Occultation of %s begins at ", q-&gt;name, "",
						occ.t1, SIGNIF|PTIME);
					if(occ.t5 &gt;= 0)
					event("Occultation of %s ends at ", q-&gt;name, "",
						occ.t5, SIGNIF|PTIME);
				}
				continue;
			}
			if(p == &amp;osun) {
				if(q != &amp;omerc &amp;&amp; q != &amp;ovenus)
					continue;
				occult(p, q, -1);
				if(occ.t3 &gt;= 0.) {
					if(occ.t1 &gt;= 0)
					event("Transit of %s begins at ", q-&gt;name, "",
						occ.t1, SIGNIF|LIGHT|PTIME);
					if(occ.t5 &gt;= 0)
					event("Transit of %s ends at ", q-&gt;name, "",
						occ.t5, SIGNIF|LIGHT|PTIME);
				}
				continue;
			}
			t = dist(&amp;p-&gt;point[0], &amp;q-&gt;point[0]);
			if(t &gt; 5000)
				continue;
			event("%s is in the house of %s",
				p-&gt;name, q-&gt;name, 0, 0);
		}
	}
	if(flags['o'])
		stars();
	if(flags['a'])
		satels();
	evflush();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

