<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/apop.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/apop.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * APOP, CRAM - MD5 challenge/response authentication
 *
 * The client does not authenticate the server, hence no CAI
 *
 * Client protocol:
 *	write challenge: randomstring@domain
 *	read response: 2*MD5dlen hex digits
 *
 * Server protocol:
 *	read challenge: randomstring@domain
 *	write user: user
 *	write response: 2*MD5dlen hex digits
 */

#include "dat.h"

struct State
{
	int asfd;
	int astype;
	Key *key;
	Ticket	t;
	Ticketreq	tr;
	char chal[128];
	char	resp[64];
	char *user;
};

enum
{
	CNeedChal,
	CHaveResp,

	SHaveChal,
	SNeedUser,
	SNeedResp,

	Maxphase,
};

static char *phasenames[Maxphase] = {
[CNeedChal]	"CNeedChal",
[CHaveResp]	"CHaveResp",

[SHaveChal]	"SHaveChal",
[SNeedUser]	"SNeedUser",
[SNeedResp]	"SNeedResp",
};

static int dochal(State*);
static int doreply(State*, char*, char*);

static int
apopinit(Proto *p, Fsstate *fss)
{
	int iscli, ret;
	State *s;

	if((iscli = isclient(_strfindattr(fss-&gt;attr, "role"))) &lt; 0)
		return failure(fss, nil);

	s = emalloc(sizeof *s);
	fss-&gt;phasename = phasenames;
	fss-&gt;maxphase = Maxphase;
	s-&gt;asfd = -1;
	if(p == &amp;apop)
		s-&gt;astype = AuthApop;
	else if(p == &amp;cram)
		s-&gt;astype = AuthCram;
	else
		abort();

	if(iscli)
		fss-&gt;phase = CNeedChal;
	else{
		if((ret = findp9authkey(&amp;s-&gt;key, fss)) != RpcOk){
			free(s);
			return ret;
		}
		if(dochal(s) &lt; 0){
			free(s);
			return failure(fss, nil);
		}
		fss-&gt;phase = SHaveChal;
	}
	fss-&gt;ps = s;
	return RpcOk;
}

static int
apopwrite(Fsstate *fss, void *va, uint n)
{
	char *a, *v;
	int i, ret;
	uchar digest[MD5dlen];
	DigestState *ds;
	Key *k;
	State *s;
	Keyinfo ki;

	s = fss-&gt;ps;
	a = va;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "write");

	case CNeedChal:
		ret = findkey(&amp;k, mkkeyinfo(&amp;ki, fss, nil), "%s", fss-&gt;proto-&gt;keyprompt);
		if(ret != RpcOk)
			return ret;
		v = _strfindattr(k-&gt;privattr, "!password");
		if(v == nil)
			return failure(fss, "key has no password");
		setattrs(fss-&gt;attr, k-&gt;attr);
		switch(s-&gt;astype){
		default:
			abort();
		case AuthCram:
			hmac_md5((uchar*)a, n, (uchar*)v, strlen(v),
				digest, nil);
			snprint(s-&gt;resp, sizeof s-&gt;resp, "%.*H", MD5dlen, digest);
			break;
		case AuthApop:
			ds = md5((uchar*)a, n, nil, nil);
			md5((uchar*)v, strlen(v), digest, ds);
			for(i=0; i&lt;MD5dlen; i++)
				sprint(&amp;s-&gt;resp[2*i], "%2.2x", digest[i]);
			break;
		}
		closekey(k);
		fss-&gt;phase = CHaveResp;
		return RpcOk;
	
	case SNeedUser:
		if((v = _strfindattr(fss-&gt;attr, "user")) &amp;&amp; strcmp(v, a) != 0)
			return failure(fss, "bad user");
		fss-&gt;attr = setattr(fss-&gt;attr, "user=%q", a);
		s-&gt;user = estrdup(a);
		fss-&gt;phase = SNeedResp;
		return RpcOk;

	case SNeedResp:
		if(n != 2*MD5dlen)
			return failure(fss, "response not MD5 digest");
		if(doreply(s, s-&gt;user, a) &lt; 0){
			fss-&gt;phase = SNeedUser;
			return failure(fss, nil);
		}
		fss-&gt;haveai = 1;
		fss-&gt;ai.cuid = s-&gt;t.cuid;
		fss-&gt;ai.suid = s-&gt;t.suid;
		fss-&gt;ai.nsecret = 0;
		fss-&gt;ai.secret = nil;
		fss-&gt;phase = Established;
		return RpcOk;
	}
}

static int
apopread(Fsstate *fss, void *va, uint *n)
{
	State *s;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "read");

	case CHaveResp:
		if(*n &gt; strlen(s-&gt;resp))
			*n = strlen(s-&gt;resp);
		memmove(va, s-&gt;resp, *n);
		fss-&gt;phase = Established;
		fss-&gt;haveai = 0;
		return RpcOk;

	case SHaveChal:
		if(*n &gt; strlen(s-&gt;chal))
			*n = strlen(s-&gt;chal);
		memmove(va, s-&gt;chal, *n);
		fss-&gt;phase = SNeedUser;
		return RpcOk;
	}
}

static void
apopclose(Fsstate *fss)
{
	State *s;

	s = fss-&gt;ps;
	if(s-&gt;asfd &gt;= 0){
		close(s-&gt;asfd);
		s-&gt;asfd = -1;
	}
	if(s-&gt;key != nil){
		closekey(s-&gt;key);
		s-&gt;key = nil;
	}
	if(s-&gt;user != nil){
		free(s-&gt;user);
		s-&gt;user = nil;
	}
	free(s);
}

static int
dochal(State *s)
{
	char *dom, *user, trbuf[TICKREQLEN];

	s-&gt;asfd = -1;

	/* send request to authentication server and get challenge */
	/* send request to authentication server and get challenge */
	if((dom = _strfindattr(s-&gt;key-&gt;attr, "dom")) == nil
	|| (user = _strfindattr(s-&gt;key-&gt;attr, "user")) == nil){
		werrstr("apop/dochal cannot happen");
		goto err;
	}

	s-&gt;asfd = _authdial(nil, dom);

	/* could generate our own challenge on error here */
	if(s-&gt;asfd &lt; 0)
		goto err;

	memset(&amp;s-&gt;tr, 0, sizeof(s-&gt;tr));
	s-&gt;tr.type = s-&gt;astype;
	safecpy(s-&gt;tr.authdom, dom, sizeof s-&gt;tr.authdom);
	safecpy(s-&gt;tr.hostid, user, sizeof(s-&gt;tr.hostid));
	convTR2M(&amp;s-&gt;tr, trbuf);

	if(write(s-&gt;asfd, trbuf, TICKREQLEN) != TICKREQLEN)
		goto err;
	if(_asrdresp(s-&gt;asfd, s-&gt;chal, sizeof s-&gt;chal) &lt;= 5)
		goto err;
	return 0;

err:
	if(s-&gt;asfd &gt;= 0)
		close(s-&gt;asfd);
	s-&gt;asfd = -1;
	return -1;
}

static int
doreply(State *s, char *user, char *response)
{
	char ticket[TICKETLEN+AUTHENTLEN];
	char trbuf[TICKREQLEN];
	int n;
	Authenticator a;

	memrandom(s-&gt;tr.chal, CHALLEN);
	safecpy(s-&gt;tr.uid, user, sizeof(s-&gt;tr.uid));
	convTR2M(&amp;s-&gt;tr, trbuf);
	if((n=write(s-&gt;asfd, trbuf, TICKREQLEN)) != TICKREQLEN){
		if(n &gt;= 0)
			werrstr("short write to auth server");
		goto err;
	}
	/* send response to auth server */
	if(strlen(response) != MD5dlen*2){
		werrstr("response not MD5 digest");
		goto err;
	}
	if((n=write(s-&gt;asfd, response, MD5dlen*2)) != MD5dlen*2){
		if(n &gt;= 0)
			werrstr("short write to auth server");
		goto err;
	}
	if(_asrdresp(s-&gt;asfd, ticket, TICKETLEN+AUTHENTLEN) &lt; 0){
		/* leave connection open so we can try again */
		return -1;
	}
	close(s-&gt;asfd);
	s-&gt;asfd = -1;

	convM2T(ticket, &amp;s-&gt;t, (char*)s-&gt;key-&gt;priv);
	if(s-&gt;t.num != AuthTs
	|| memcmp(s-&gt;t.chal, s-&gt;tr.chal, sizeof(s-&gt;t.chal)) != 0){
		if(s-&gt;key-&gt;successes == 0)
			disablekey(s-&gt;key);
		werrstr(Easproto);
		goto err;
	}
	s-&gt;key-&gt;successes++;
	convM2A(ticket+TICKETLEN, &amp;a, s-&gt;t.key);
	if(a.num != AuthAc
	|| memcmp(a.chal, s-&gt;tr.chal, sizeof(a.chal)) != 0
	|| a.id != 0){
		werrstr(Easproto);
		goto err;
	}

	return 0;
err:
	if(s-&gt;asfd &gt;= 0)
		close(s-&gt;asfd);
	s-&gt;asfd = -1;
	return -1;
}

Proto apop = {
.name=	"apop",
.init=		apopinit,
.write=	apopwrite,
.read=	apopread,
.close=	apopclose,
.addkey=	replacekey,
.keyprompt=	"!password?"
};

Proto cram = {
.name=	"cram",
.init=		apopinit,
.write=	apopwrite,
.read=	apopread,
.close=	apopclose,
.addkey=	replacekey,
.keyprompt=	"!password?"
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

