<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/fgui.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/fgui.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "dat.h"
#include &lt;draw.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

int ctldeletequits = 1;

typedef struct RequestType RequestType;
typedef struct Request Request;
typedef struct Memory Memory;

struct RequestType
{
	char		*file;			/* file to read requests from */
	void		(*f)(Request*);		/* request handler */
	void		(*r)(Controlset*);	/* resize handler */
	int		fd;			/* fd = open(file, ORDWR) */
	Channel		*rc;			/* channel requests are multiplexed to */
	Controlset	*cs;
};

struct Request
{
	RequestType	*rt;
	Attr		*a;
	Attr		*tag;
};

struct Memory
{
	Memory	*next;
	Attr	*a;
	Attr	*val;
};
Memory *mem;

static void	readreq(void*);
static void	hide(void);
static void	unhide(void);
static void	openkmr(void);
static void	closekmr(void);
static Memory*	searchmem(Attr*);
static void	addmem(Attr*, Attr*);

static void	confirm(Request*);
static void	resizeconfirm(Controlset*);
static void	needkey(Request*);
static void	resizeneedkey(Controlset*);

Control *b_remember;
Control *b_accept;
Control *b_refuse;

RequestType rt[] = 
{
	{ "/mnt/factotum/confirm",	confirm,	resizeconfirm, },
	{ "/mnt/factotum/needkey",	needkey,	resizeneedkey, },
	{ 0 },
};

enum
{
	ButtonDim=	15,
};

void
threadmain(int argc, char *argv[])
{
	Request r;
	Channel *rc;
	RequestType *p;
	Font *invis;

	ARGBEGIN{
	}ARGEND;

	if(newwindow("-hide") &lt; 0)
		sysfatal("newwindow: %r");

	fmtinstall('A', _attrfmt);

	/* create the proc's that read */
	rc = chancreate(sizeof(Request), 0);
	for(p = rt;  p-&gt;file != 0; p++){
		p-&gt;fd = -1;
		p-&gt;rc = rc;
		proccreate(readreq, p, 16*1024);
	}

	/* gui initialization */
	if(initdraw(0, 0, "auth/fgui") &lt; 0)
		sysfatal("initdraw failed: %r");
	initcontrols();
	hide();

	/* get an invisible font for passwords */
	invis = openfont(display, "/lib/font/bit/lucm/passwd.9.font");
	if (invis == nil)
		sysfatal("fgui: %s: %r", "/lib/font/bit/lucm/passwd.9.font");
	namectlfont(invis, "invisible");

	/* serialize all requests */
	for(;;){
		if(recv(rc, &amp;r) &lt; 0)
			break;
		(*r.rt-&gt;f)(&amp;r);
		_freeattr(r.a);
		_freeattr(r.tag);
	}

	threadexitsall(nil);
}

/*
 *  read requests and pass them to the main loop
 */
enum
{
	Requestlen=4096,
};
static void
readreq(void *a)
{
	RequestType *rt = a;
	char *buf, *p;
	int n;
	Request r;
	Attr **l;

	rt-&gt;fd = open(rt-&gt;file, ORDWR);
	if(rt-&gt;fd &lt; 0)
		sysfatal("opening %s: %r", rt-&gt;file);
	rt-&gt;cs = nil;

	buf = malloc(Requestlen);
	if(buf == nil)
		sysfatal("allocating read buffer: %r");
	r.rt = rt;

	for(;;){
		n = read(rt-&gt;fd, buf, Requestlen-1);
		if(n &lt; 0)
			break;
		buf[n] = 0;

		/* skip verb, parse attributes, and remove tag */
		p = strchr(buf, ' ');
		if(p != nil)
			p++;
		else
			p = buf;
		r.a = _parseattr(p);

		/* separate out the tag */
		r.tag = nil;
		for(l = &amp;r.a; *l != nil; l = &amp;(*l)-&gt;next)
			if(strcmp((*l)-&gt;name, "tag") == 0){
				r.tag = *l;
				*l = r.tag-&gt;next;
				r.tag-&gt;next = nil;
				break;
			}

		/* if no tag, forget it */
		if(r.tag == nil){
			_freeattr(r.a);
			continue;
		}

		send(rt-&gt;rc, &amp;r);
	}
}
#ifdef asdf
static void
readreq(void *a)
{
	RequestType *rt = a;
	char *buf, *p;
	int n;
	Request r;

	rt-&gt;fd = -1;
	rt-&gt;cs = nil;

	buf = malloc(Requestlen);
	if(buf == nil)
		sysfatal("allocating read buffer: %r");
	r.rt = rt;

	for(;;){
		strcpy(buf, "adfasdf=afdasdf asdfasdf=asdfasdf");
		r.a = _parseattr(buf);
		send(rt-&gt;rc, &amp;r);
		sleep(5000);
	}
}
#endif asdf

/*
 *  open/close the keyboard, mouse and resize channels
 */
static Channel *kbdc;
static Channel *mousec;
static Channel *resizec;
static Keyboardctl *kctl;
static Mousectl *mctl;

static void
openkmr(void)
{
	/* get channels for subsequent newcontrolset calls  */
	kctl = initkeyboard(nil);
	if(kctl == nil)
		sysfatal("can't initialize keyboard: %r");
	kbdc = kctl-&gt;c;
	mctl = initmouse(nil, screen);
	if(mctl == nil)
		sysfatal("can't initialize mouse: %r");
	mousec = mctl-&gt;c;
	resizec = mctl-&gt;resizec;
}
static void
closekmr(void)
{
	Mouse m;

	while(nbrecv(kbdc, &amp;m) &gt; 0)
		;
	closekeyboard(kctl);
	while(nbrecv(mousec, &amp;m) &gt; 0)
		;
	closemouse(mctl);
}


/*
 *  called when the window is resized
 */
void
resizecontrolset(Controlset *cs)
{
	RequestType *p;

	for(p = rt;  p-&gt;file != 0; p++){
		if(p-&gt;cs == cs){
			(*p-&gt;r)(cs);
			break;
		}
	}
}

/*
 *  hide window when not in use
 */
static void
unhide(void)
{
	int wctl;

	wctl = open("/dev/wctl", OWRITE);
	if(wctl &lt; 0)
		return;
	fprint(wctl, "unhide");
	close(wctl);
}
static void
hide(void)
{
	int wctl;
	int tries;

	wctl = open("/dev/wctl", OWRITE);
	if(wctl &lt; 0)
		return;
	for(tries = 0; tries &lt; 10; tries++){
		if(fprint(wctl, "hide") &gt;= 0)
			break;
		sleep(100);
	}
	close(wctl);
}

/*
 *  set up the controls for the confirmation window
 */
static Channel*
setupconfirm(Request *r)
{
	Controlset *cs;
	Channel *c;
	Attr *a;

	/* create a new control set for the confirmation */
	openkmr();
	cs = newcontrolset(screen, kbdc, mousec, resizec);

	createtext(cs, "msg");
	chanprint(cs-&gt;ctl, "msg image paleyellow");
	chanprint(cs-&gt;ctl, "msg border 1");
	chanprint(cs-&gt;ctl, "msg add 'The following key is being used:'");
	for(a = r-&gt;a; a != nil; a = a-&gt;next)
		chanprint(cs-&gt;ctl, "msg add '    %s = %s'", a-&gt;name,
				a-&gt;val);

	namectlimage(display-&gt;white, "i_white");
	namectlimage(display-&gt;black, "i_black");

	b_remember = createbutton(cs, "b_remember");
	chanprint(cs-&gt;ctl, "b_remember border 1");
	chanprint(cs-&gt;ctl, "b_remember mask i_white");
	chanprint(cs-&gt;ctl, "b_remember image i_white");
	chanprint(cs-&gt;ctl, "b_remember light i_black");

	createtext(cs, "t_remember");
	chanprint(cs-&gt;ctl, "t_remember image white");
	chanprint(cs-&gt;ctl, "t_remember bordercolor white");
	chanprint(cs-&gt;ctl, "t_remember add 'Remember this answer for future confirmations'");

	b_accept = createtextbutton(cs, "b_accept");
	chanprint(cs-&gt;ctl, "b_accept border 1");
	chanprint(cs-&gt;ctl, "b_accept align center");
	chanprint(cs-&gt;ctl, "b_accept text Accept");
	chanprint(cs-&gt;ctl, "b_accept image i_white");
	chanprint(cs-&gt;ctl, "b_accept light i_black");

	b_refuse = createtextbutton(cs, "b_refuse");
	chanprint(cs-&gt;ctl, "b_refuse border 1");
	chanprint(cs-&gt;ctl, "b_refuse align center");
	chanprint(cs-&gt;ctl, "b_refuse text Refuse");
	chanprint(cs-&gt;ctl, "b_refuse image i_white");
	chanprint(cs-&gt;ctl, "b_refuse light i_black");

	c = chancreate(sizeof(char*), 0);
	controlwire(b_remember, "event", c);
	controlwire(b_accept, "event", c);
	controlwire(b_refuse, "event", c);

	/* make the controls interactive */
	activate(b_remember);
	activate(b_accept);
	activate(b_refuse);
	r-&gt;rt-&gt;cs = cs;
	unhide();
	resizecontrolset(cs);

	return c;
}

/*
 *  resize the controls for the confirmation window
 */
static void
resizeconfirm(Controlset *cs)
{
	Rectangle r, mr, nr, ntr, ar, rr;
	int fontwidth;

	fontwidth = font-&gt;height;

	/* get usable window rectangle */
	if(getwindow(display, Refnone) &lt; 0)
		ctlerror("resize failed: %r");
	r = insetrect(screen-&gt;r, 10);

	/* message box fills everything not needed for buttons */
	mr = r;
	mr.max.y = mr.min.y + font-&gt;height*((Dy(mr)-3*ButtonDim-font-&gt;height-4)/font-&gt;height);

	/* remember button */
	nr.min = Pt(mr.min.x, mr.max.y+ButtonDim);
	nr.max = Pt(mr.max.x, r.max.y);
	if(Dx(nr) &gt; ButtonDim)
		nr.max.x = nr.min.x+ButtonDim;
	if(Dy(nr) &gt; ButtonDim)
		nr.max.y = nr.min.y+ButtonDim;
	ntr.min = Pt(nr.max.x+ButtonDim, nr.min.y);
	ntr.max = Pt(r.max.x, nr.min.y+font-&gt;height);

	/* accept/refuse buttons */
	ar.min = Pt(r.min.x+Dx(r)/2-ButtonDim-6*fontwidth, nr.max.y+ButtonDim);
	ar.max = Pt(ar.min.x+6*fontwidth, ar.min.y+font-&gt;height+4);
	rr.min = Pt(r.min.x+Dx(r)/2+ButtonDim, nr.max.y+ButtonDim);
	rr.max = Pt(rr.min.x+6*fontwidth, rr.min.y+font-&gt;height+4);

	/* make the controls visible */
	chanprint(cs-&gt;ctl, "msg rect %R\nmsg show", mr);
	chanprint(cs-&gt;ctl, "b_remember rect %R\nb_remember show", nr);
	chanprint(cs-&gt;ctl, "t_remember rect %R\nt_remember show", ntr);
	chanprint(cs-&gt;ctl, "b_accept rect %R\nb_accept show", ar);
	chanprint(cs-&gt;ctl, "b_refuse rect %R\nb_refuse show", rr);
}

/*
 *  free the controls for the confirmation window
 */
static void
teardownconfirm(Request *r)
{
	Controlset *cs;

	cs = r-&gt;rt-&gt;cs;
	r-&gt;rt-&gt;cs = nil;
	hide();
	closecontrolset(cs);
	closekmr();
}

/*
 *  get user confirmation of a key
 */
static void
confirm(Request *r)
{
	Channel *c;
	char *s;
	int n;
	char *args[3];
	int remember;
	Attr *val;
	Memory *m;

	/* if it's something that the user wanted us not to ask again about */
	m = searchmem(r-&gt;a);
	if(m != nil){
		fprint(r-&gt;rt-&gt;fd, "%A %A", r-&gt;tag, m-&gt;val);
		return;
	}

	/* set up the controls */
	c = setupconfirm(r);

	/* wait for user to reply */
	remember = 0;
	for(;;){
		s = recvp(c);
		n = tokenize(s, args, nelem(args));
		if(n==3 &amp;&amp; strcmp(args[1], "value")==0){
			if(strcmp(args[0], "b_remember:") == 0){
				remember = atoi(args[2]);
			}
			if(strcmp(args[0], "b_accept:") == 0){
				val = _mkattr(AttrNameval, "answer", "yes", nil);
				free(s);
				break;
			}
			if(strcmp(args[0], "b_refuse:") == 0){
				val = _mkattr(AttrNameval, "answer", "no", nil);
				free(s);
				break;
			}
		}
		free(s);
	}
	teardownconfirm(r);
	fprint(r-&gt;rt-&gt;fd, "%A %A", r-&gt;tag, val);
	if(remember)
		addmem(_copyattr(r-&gt;a), val);
	else
		_freeattr(val);
}

/*
 *  confirmations that are remembered
 */
static int
match(Attr *a, Attr *b)
{
	Attr *x;

	for(; a != nil; a = a-&gt;next){
		x = _findattr(b, a-&gt;name);
		if(x == nil || strcmp(a-&gt;val, x-&gt;val) != 0)
			return 0;
	}
	return 1;
}
static Memory*
searchmem(Attr *a)
{
	Memory *m;

	for(m = mem; m != nil; m = m-&gt;next){
		if(match(a, m-&gt;a))
			break;
	}
	return m;
}
static void
addmem(Attr *a, Attr *val)
{
	Memory *m;

	m = malloc(sizeof *m);
	if(m == nil)
		return;
	m-&gt;a = a;
	m-&gt;val = val;
	m-&gt;next = mem;
	mem = m;
}

/* controls for needkey */
Control *msg;
Control *b_done;
enum {
	Pprivate=	1&lt;&lt;0,
	Pneed=		1&lt;&lt;1,
};
typedef struct Entry Entry;
struct Entry {
	Control *name;
	Control *val;
	Control *eq;
	Attr *a;
};
static Entry *entry;
static int entries;

/*
 *  set up the controls for the confirmation window
 */
static Channel*
setupneedkey(Request *r)
{
	Controlset *cs;
	Channel *c;
	Attr *a;
	Attr **l;
	char cn[10];
	int i;

	/* create a new control set for the confirmation */
	openkmr();
	cs = newcontrolset(screen, kbdc, mousec, resizec);

	/* count attributes and allocate entry controls */
	entries = 0;
	for(l = &amp;r-&gt;a; *l; l = &amp;(*l)-&gt;next)
		entries++;
	if(entries == 0){
		closecontrolset(cs);
		closekmr();
		return nil;
	}
	*l = a = mallocz(sizeof *a, 1);
	a-&gt;type = AttrQuery;
	entries++;
	l = &amp;(*l)-&gt;next;
	*l = a = mallocz(sizeof *a, 1);
	a-&gt;type = AttrQuery;
	entries++;
	entry = malloc(entries*sizeof(Entry));
	if(entry == nil){
		closecontrolset(cs);
		closekmr();
		return nil;
	}

	namectlimage(display-&gt;white, "i_white");
	namectlimage(display-&gt;black, "i_black");

	/* create controls */
	msg = createtext(cs, "msg");
	chanprint(cs-&gt;ctl, "msg image white");
	chanprint(cs-&gt;ctl, "msg bordercolor white");
	chanprint(cs-&gt;ctl, "msg add 'You need the following key.  Fill in the blanks'");
	chanprint(cs-&gt;ctl, "msg add 'and click on the DONE button.'");

	for(i = 0, a = r-&gt;a; a != nil; i++, a = a-&gt;next){
		entry[i].a = a;
		snprint(cn, sizeof cn, "name_%d", i);
		if(entry[i].a-&gt;name == nil){
			entry[i].name = createentry(cs, cn);
			chanprint(cs-&gt;ctl, "%s image yellow", cn);
			chanprint(cs-&gt;ctl, "%s border 1", cn);
		} else {
			entry[i].name = createtext(cs, cn);
			chanprint(cs-&gt;ctl, "%s image white", cn);
			chanprint(cs-&gt;ctl, "%s bordercolor white", cn);
			chanprint(cs-&gt;ctl, "%s add '%s'", cn, a-&gt;name);
		}

		snprint(cn, sizeof cn, "val_%d", i);
		if(a-&gt;type == AttrQuery){
			entry[i].val = createentry(cs, cn);
			chanprint(cs-&gt;ctl, "%s image yellow", cn);
			chanprint(cs-&gt;ctl, "%s border 1", cn);
			if(a-&gt;name != nil){
				if(strcmp(a-&gt;name, "user") == 0)
					chanprint(cs-&gt;ctl, "%s value %q", cn, getuser());
				if(*a-&gt;name == '!')
					chanprint(cs-&gt;ctl, "%s font invisible", cn);
			}
		} else {
			entry[i].val = createtext(cs, cn);
			chanprint(cs-&gt;ctl, "%s image white", cn);
			chanprint(cs-&gt;ctl, "%s add %q", cn, a-&gt;val);
		}

		snprint(cn, sizeof cn, "eq_%d", i);
		entry[i].eq = createtext(cs, cn);
		chanprint(cs-&gt;ctl, "%s image white", cn);
		chanprint(cs-&gt;ctl, "%s add ' = '", cn);
	}

	b_done = createtextbutton(cs, "b_done");
	chanprint(cs-&gt;ctl, "b_done border 1");
	chanprint(cs-&gt;ctl, "b_done align center");
	chanprint(cs-&gt;ctl, "b_done text DONE");
	chanprint(cs-&gt;ctl, "b_done image green");
	chanprint(cs-&gt;ctl, "b_done light green");

	/* wire controls for input */
	c = chancreate(sizeof(char*), 0);
	controlwire(b_done, "event", c);
	for(i = 0; i &lt; entries; i++)
		if(entry[i].a-&gt;type == AttrQuery)
			controlwire(entry[i].val, "event", c);

	/* make the controls interactive */
	activate(msg);
	activate(b_done);
	for(i = 0; i &lt; entries; i++){
		if(entry[i].a-&gt;type != AttrQuery)
			continue;
		if(entry[i].a-&gt;name == nil)
			activate(entry[i].name);
		activate(entry[i].val);
	}

	/* change the display */
	r-&gt;rt-&gt;cs = cs;
	unhide();
	resizecontrolset(cs);

	return c;
}

/*
 *  resize the controls for the confirmation window
 */
static void
resizeneedkey(Controlset *cs)
{
	Rectangle r, mr;
	int mid, i, n, lasty;

	/* get usable window rectangle */
	if(getwindow(display, Refnone) &lt; 0)
		ctlerror("resize failed: %r");
	r = insetrect(screen-&gt;r, 10);

	/* find largest name */
	mid = 0;
	for(i = 0; i &lt; entries; i++){
		if(entry[i].a-&gt;name == nil)
			continue;
		n = strlen(entry[i].a-&gt;name);
		if(n &gt; mid)
			mid = n;
	}
	mid = (mid+2) * font-&gt;height;

	/* top line is the message */
	mr = r;
	mr.max.y = mr.min.y + 2*font-&gt;height + 2;
	chanprint(cs-&gt;ctl, "msg rect %R\nmsg show", mr);

	/* one line per attribute */
	mr.min.x += 2*font-&gt;height;
	lasty = mr.max.y;
	for(i = 0; i &lt; entries; i++){
		r.min.x = mr.min.x;
		r.min.y = lasty+2;
		r.max.x = r.min.x + mid - 3*stringwidth(font, "=");
		r.max.y = r.min.y + font-&gt;height;
		chanprint(cs-&gt;ctl, "name_%d rect %R\nname_%d show", i, r, i);

		r.min.x = r.max.x;
		r.max.x = r.min.x + 3*stringwidth(font, "=");
		chanprint(cs-&gt;ctl, "eq_%d rect %R\neq_%d show", i, r, i);

		r.min.x = r.max.x;
		r.max.x = mr.max.x;
		if(Dx(r) &gt; 32*font-&gt;height)
			r.max.x = r.min.x + 32*font-&gt;height;
		chanprint(cs-&gt;ctl, "val_%d rect %R\nval_%d show", i, r, i);
		lasty = r.max.y;
	}

	/* done button */
	mr.min.x -= 2*font-&gt;height;
	r.min.x = mr.min.x + mid - 3*font-&gt;height;
	r.min.y = lasty+10;
	r.max.x = r.min.x + 6*font-&gt;height;
	r.max.y = r.min.y + font-&gt;height + 2;
	chanprint(cs-&gt;ctl, "b_done rect %R\nb_done show", r);
}

/*
 *  free the controls for the confirmation window
 */
static void
teardownneedkey(Request *r)
{
	Controlset *cs;

	cs = r-&gt;rt-&gt;cs;
	r-&gt;rt-&gt;cs = nil;
	hide();
	closecontrolset(cs);
	closekmr();

	if(entry != nil)
		free(entry);
	entry = nil;
}

static void
needkey(Request *r)
{
	Channel *c;
	char *nam, *val;
	int i, n;
	int fd;
	char *args[3];

	/* set up the controls */
	c = setupneedkey(r);
	if(c == nil)
		goto out;

	/* wait for user to reply */
	for(;;){
		val = recvp(c);
		n = tokenize(val, args, nelem(args));
		if(n==3 &amp;&amp; strcmp(args[1], "value")==0){	/* user hit 'enter' */
			free(val);
			break;
		}
		free(val);
	}

	/* get entry values */
	for(i = 0; i &lt; entries; i++){
		if(entry[i].a-&gt;type != AttrQuery)
			continue;

		chanprint(r-&gt;rt-&gt;cs-&gt;ctl, "val_%d data", i);
		val = recvp(entry[i].val-&gt;data);
		if(entry[i].a-&gt;name == nil){
			chanprint(r-&gt;rt-&gt;cs-&gt;ctl, "name_%d data", i);
			nam = recvp(entry[i].name-&gt;data);
			if(nam == nil || *nam == 0){
				free(val);
				continue;
			}
			entry[i].a-&gt;val = estrdup(val);
			free(val);
			entry[i].a-&gt;name = estrdup(nam);
			free(nam);
		} else {
			if(val != nil){
				entry[i].a-&gt;val = estrdup(val);
				free(val);
			}
		}
		entry[i].a-&gt;type = AttrNameval;
	}

	/* enter the new key !!!!need to do something in case of error!!!! */
	fd = open("/mnt/factotum/ctl", OWRITE);
	fprint(fd, "key %A", r-&gt;a);
	close(fd);

	teardownneedkey(r);
out:
	fprint(r-&gt;rt-&gt;fd, "%A", r-&gt;tag);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

