<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "dat.h"

int		askforkeys = 1;
char		*authaddr;
int		debug;
int		doprivate = 1;
int		gflag;
char		*owner;
int		kflag;
char		*mtpt = "/mnt";
Keyring	*ring;
char		*service;
int		sflag;
int		uflag;

extern Srv		fs;
static void		notifyf(void*, char*);
static void		private(void);

char	Easproto[]		= "auth server protocol botch";
char Ebadarg[]		= "invalid argument";
char Ebadkey[]		= "bad key";
char Enegotiation[]	= "negotiation failed, no common protocols or keys";
char Etoolarge[]	= "rpc too large";

Proto*
prototab[] =
{
	&amp;apop,
	&amp;chap,
	&amp;cram,
	&amp;httpdigest,
	&amp;mschap,
	&amp;p9any,
	&amp;p9cr,
	&amp;p9sk1,
	&amp;p9sk2,
	&amp;pass,
/*	&amp;srs, */
	&amp;rsa,
	&amp;vnc,
	&amp;wep,
	nil,
};

void
usage(void)
{
	fprint(2, "usage: %s [-DSdknpu] [-a authaddr] [-m mtpt] [-s service]\n",
		argv0);
	fprint(2, "or    %s -g 'params'\n", argv0);
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i, trysecstore;
	char err[ERRMAX], *s;
	Dir d;
	Proto *p;
	char *secstorepw;

	trysecstore = 1;
	secstorepw = nil;

	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'S':		/* server: read nvram, no prompting for keys */
		askforkeys = 0;
		trysecstore = 0;
		sflag = 1;
		break;
	case 'a':
		authaddr = EARGF(usage());
		break;
	case 'd':
		debug = 1;
		doprivate = 0;
		break;
	case 'g':		/* get: prompt for key for name and domain */
		gflag = 1;
		break;
	case 'k':		/* reinitialize nvram */
		kflag = 1;
		break;
	case 'm':		/* set default mount point */
		mtpt = EARGF(usage());
		break;
	case 'n':
		trysecstore = 0;
		break;
	case 'p':
		doprivate = 0;
		break;
	case 's':		/* set service name */
		service = EARGF(usage());
		break;
	case 'u':		/* user: set hostowner */
		uflag = 1;
		break;
	default:
		usage();
	}ARGEND

	if(argc != 0 &amp;&amp; !gflag)
		usage();
	if(doprivate)
		private();

	initcap();

	quotefmtinstall();
	fmtinstall('A', _attrfmt);
	fmtinstall('N', attrnamefmt);
	fmtinstall('H', encodefmt);

	ring = emalloc(sizeof(*ring));
	notify(notifyf);

	if(gflag){
		if(argc != 1)
			usage();
		askuser(argv[0]);
		exits(nil);
	}

	for(i=0; prototab[i]; i++){
		p = prototab[i];
		if(p-&gt;name == nil)
			sysfatal("protocol %d has no name", i);
		if(p-&gt;init == nil)
			sysfatal("protocol %s has no init", p-&gt;name);
		if(p-&gt;write == nil)
			sysfatal("protocol %s has no write", p-&gt;name);
		if(p-&gt;read == nil)
			sysfatal("protocol %s has no read", p-&gt;name);
		if(p-&gt;close == nil)
			sysfatal("protocol %s has no close", p-&gt;name);
		if(p-&gt;keyprompt == nil)
			p-&gt;keyprompt = "";
	}

	if(sflag){
		s = getnvramkey(kflag ? NVwrite : NVwriteonerr, &amp;secstorepw);
		if(s == nil)
			fprint(2, "factotum warning: cannot read nvram: %r\n");
		else if(ctlwrite(s, 0) &lt; 0)
			fprint(2, "factotum warning: cannot add nvram key: %r\n");
		if(secstorepw != nil)
			trysecstore = 1;
		if (s != nil) {
			memset(s, 0, strlen(s));
			free(s);
		}
	} else if(uflag)
		promptforhostowner();
	owner = getuser();

	if(trysecstore){
		if(havesecstore() == 1){
			while(secstorefetch(secstorepw) &lt; 0){
				rerrstr(err, sizeof err);
				if(strcmp(err, "cancel") == 0)
					break;
				fprint(2, "factotum: secstorefetch: %r\n");
				fprint(2, "Enter an empty password to quit.\n");
				free(secstorepw);
				secstorepw = nil; /* just try nvram pw once */
			}
		}else{
/*
			rerrstr(err, sizeof err);
			if(*err)
				fprint(2, "factotum: havesecstore: %r\n");
*/
		}
	}

	postmountsrv(&amp;fs, service, mtpt, MBEFORE);
	if(service){
		nulldir(&amp;d);
		d.mode = 0666;
		s = emalloc(10+strlen(service));
		strcpy(s, "/srv/");
		strcat(s, service);
		if(dirwstat(s, &amp;d) &lt; 0)
			fprint(2, "factotum warning: cannot chmod 666 %s: %r\n", s);
		free(s);
	}
	exits(nil);
}

char *pmsg = "Warning! %s can't protect itself from debugging: %r\n";
char *smsg = "Warning! %s can't turn off swapping: %r\n";

/* don't allow other processes to debug us and steal keys */
static void
private(void)
{
	int fd;
	char buf[64];

	snprint(buf, sizeof(buf), "#p/%d/ctl", getpid());
	fd = open(buf, OWRITE);
	if(fd &lt; 0){
		fprint(2, pmsg, argv0);
		return;
	}
	if(fprint(fd, "private") &lt; 0)
		fprint(2, pmsg, argv0);
	if(fprint(fd, "noswap") &lt; 0)
		fprint(2, smsg, argv0);
	close(fd);
}

static void
notifyf(void*, char *s)
{
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

enum
{
	Qroot,
	Qfactotum,
	Qrpc,
	Qkeylist,
	Qprotolist,
	Qconfirm,
	Qlog,
	Qctl,
	Qneedkey,
};

Qid
mkqid(int type, int path)
{
	Qid q;

	q.type = type;
	q.path = path;
	q.vers = 0;
	return q;
}

static void
fsattach(Req *r)
{
	r-&gt;fid-&gt;qid = mkqid(QTDIR, Qroot);
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

static struct {
	char *name;
	int qidpath;
	ulong perm;
} dirtab[] = {
	"confirm",	Qconfirm,	0600|DMEXCL,		/* we know this is slot #0 below */
	"needkey", Qneedkey,	0600|DMEXCL,		/* we know this is slot #1 below */
	"ctl",		Qctl,			0644,
	"rpc",	Qrpc,		0666,
	"proto",	Qprotolist,	0444,
	"log",	Qlog,		0400|DMEXCL,
};
static int inuse[nelem(dirtab)];
int *confirminuse = &amp;inuse[0];
int *needkeyinuse = &amp;inuse[1];

static void
fillstat(Dir *dir, char *name, int type, int path, ulong perm)
{
	dir-&gt;name = estrdup(name);
	dir-&gt;uid = estrdup(owner);
	dir-&gt;gid = estrdup(owner);
	dir-&gt;mode = perm;
	dir-&gt;length = 0;
	dir-&gt;qid = mkqid(type, path);
	dir-&gt;atime = time(0);
	dir-&gt;mtime = time(0);
	dir-&gt;muid = estrdup("");
}

static int
rootdirgen(int n, Dir *dir, void*)
{
	if(n &gt; 0)
		return -1;
	fillstat(dir, "factotum", QTDIR, Qfactotum, DMDIR|0555);
	return 0;
}

static int
fsdirgen(int n, Dir *dir, void*)
{
	if(n &gt;= nelem(dirtab))
		return -1;
	fillstat(dir, dirtab[n].name, 0, dirtab[n].qidpath, dirtab[n].perm);
	return 0;
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	int i;

	switch((ulong)fid-&gt;qid.path){
	default:
		return "cannot happen";
	case Qroot:
		if(strcmp(name, "factotum") == 0){
			*qid = mkqid(QTDIR, Qfactotum);
			fid-&gt;qid = *qid;
			return nil;
		}
		if(strcmp(name, "..") == 0){
			*qid = fid-&gt;qid;
			return nil;
		}
		return "not found";
	case Qfactotum:
		for(i=0; i&lt;nelem(dirtab); i++)
			if(strcmp(name, dirtab[i].name) == 0){
				*qid = mkqid(0, dirtab[i].qidpath);
				fid-&gt;qid = *qid;
				return nil;
			}
		if(strcmp(name, "..") == 0){
			*qid = mkqid(QTDIR, Qroot);
			fid-&gt;qid = *qid;
			return nil;
		}
		return "not found";
	}
}

static void
fsstat(Req *r)
{
	int i;
	ulong path;

	path = r-&gt;fid-&gt;qid.path;
	if(path == Qroot){
		fillstat(&amp;r-&gt;d, "/", QTDIR, Qroot, 0555|DMDIR);
		respond(r, nil);
		return;
	}
	if(path == Qfactotum){
		fillstat(&amp;r-&gt;d, "factotum", QTDIR, Qfactotum, 0555|DMDIR);
		respond(r, nil);
		return;
	}
	for(i=0; i&lt;nelem(dirtab); i++)
		if(dirtab[i].qidpath == path){
			fillstat(&amp;r-&gt;d, dirtab[i].name, 0, dirtab[i].qidpath, dirtab[i].perm);
			respond(r, nil);
			return;
		}
	respond(r, "file not found");	
}

static void
fsopen(Req *r)
{
	int i, *p, perm;
	static int need[4] = {4, 2, 6, 1};
	int n;
	Fsstate *fss;

	p = nil;
	for(i=0; i&lt;nelem(dirtab); i++)
		if(dirtab[i].qidpath == r-&gt;fid-&gt;qid.path)
			break;
	if(i &lt; nelem(dirtab)){
		if(dirtab[i].perm &amp; DMEXCL)
			p = &amp;inuse[i];
		if(strcmp(r-&gt;fid-&gt;uid, owner) == 0)
			perm = dirtab[i].perm&gt;&gt;6;
		else
			perm = dirtab[i].perm;
	}else
		perm = 5;

	n = need[r-&gt;ifcall.mode&amp;3];
	if((r-&gt;ifcall.mode&amp;~(3|OTRUNC)) || ((perm&amp;n) != n)){
		respond(r, "permission denied");
		return;
	}
	if(p){
		if(*p){
			respond(r, "file in use");
			return;
		}
		(*p)++;
	}

	r-&gt;fid-&gt;aux = fss = emalloc(sizeof(Fsstate));
	fss-&gt;phase = Notstarted;
	fss-&gt;sysuser = r-&gt;fid-&gt;uid;
	fss-&gt;attr = nil;
	strcpy(fss-&gt;err, "factotum/fs.c no error");
	respond(r, nil);
}

static void
fsdestroyfid(Fid *fid)
{
	int i;
	Fsstate *fss;

	if(fid-&gt;omode != -1){
		for(i=0; i&lt;nelem(dirtab); i++)
			if(dirtab[i].qidpath == fid-&gt;qid.path)
				if(dirtab[i].perm&amp;DMEXCL)
					inuse[i] = 0;
	}

	fss = fid-&gt;aux;
	if(fss == nil)
		return;
	if(fss-&gt;ps)
		(*fss-&gt;proto-&gt;close)(fss);
	_freeattr(fss-&gt;attr);
	free(fss);
}

static int
readlist(int off, int (*gen)(int, char*, uint, Fsstate*), Req *r, Fsstate *fss)
{
	char *a, *ea;
	int n;

	a = r-&gt;ofcall.data;
	ea = a+r-&gt;ifcall.count;
	for(;;){
		n = (*gen)(off, a, ea-a, fss);
		if(n == 0){
			r-&gt;ofcall.count = a - (char*)r-&gt;ofcall.data;
			return off;
		}
		a += n;
		off++;
	}
}

enum { Nearend = 2, };			/* at least room for \n and NUL */

/* result in `a', of `n' bytes maximum */
static int
keylist(int i, char *a, uint n, Fsstate *fss)
{
	int wb;
	Keyinfo ki;
	Key *k;
	static char zero[Nearend];

	k = nil;
	mkkeyinfo(&amp;ki, fss, nil);
	ki.attr = nil;
	ki.skip = i;
	ki.usedisabled = 1;
	if(findkey(&amp;k, &amp;ki, "") != RpcOk)
		return 0;

	memset(a + n - Nearend, 0, Nearend);
	wb = snprint(a, n, "key %A %N\n", k-&gt;attr, k-&gt;privattr);
	closekey(k);
	if (wb &gt;= n - 1 &amp;&amp; a[n - 2] != '\n' &amp;&amp; a[n - 2] != '\0') {
		/* line won't fit in `a', so just truncate */
		strcpy(a + n - 2, "\n");
		return 0;
	}
	return wb;
}

static int
protolist(int i, char *a, uint n, Fsstate *fss)
{
	USED(fss);

	if(i &gt;= nelem(prototab)-1)
		return 0;
	if(strlen(prototab[i]-&gt;name)+1 &gt; n)
		return 0;
	n = strlen(prototab[i]-&gt;name)+1;
	memmove(a, prototab[i]-&gt;name, n-1);
	a[n-1] = '\n';
	return n;
}

static void
fsread(Req *r)
{
	Fsstate *s;

	s = r-&gt;fid-&gt;aux;
	switch((ulong)r-&gt;fid-&gt;qid.path){
	default:
		respond(r, "bug in fsread");
		break;
	case Qroot:
		dirread9p(r, rootdirgen, nil);
		respond(r, nil);
		break;
	case Qfactotum:
		dirread9p(r, fsdirgen, nil);
		respond(r, nil);
		break;
	case Qrpc:
		rpcread(r);
		break;
	case Qneedkey:
		needkeyread(r);
		break;
	case Qconfirm:
		confirmread(r);
		break;
	case Qlog:
		logread(r);
		break;
	case Qctl:
		s-&gt;listoff = readlist(s-&gt;listoff, keylist, r, s);
		respond(r, nil);
		break;
	case Qprotolist:
		s-&gt;listoff = readlist(s-&gt;listoff, protolist, r, s);
		respond(r, nil);
		break;
	}
}

static void
fswrite(Req *r)
{
	int ret;
	char err[ERRMAX], *s;

	switch((ulong)r-&gt;fid-&gt;qid.path){
	default:
		respond(r, "bug in fswrite");
		break;
	case Qrpc:
		rpcwrite(r);
		break;
	case Qneedkey:
	case Qconfirm:
	case Qctl:
		s = emalloc(r-&gt;ifcall.count+1);
		memmove(s, r-&gt;ifcall.data, r-&gt;ifcall.count);
		s[r-&gt;ifcall.count] = '\0';
		switch((ulong)r-&gt;fid-&gt;qid.path){
		default:
			abort();
		case Qneedkey:
			ret = needkeywrite(s);
			break;
		case Qconfirm:
			ret = confirmwrite(s);
			break;
		case Qctl:
			ret = ctlwrite(s, 0);
			break;
		}
		free(s);
		if(ret &lt; 0){
			rerrstr(err, sizeof err);
			respond(r, err);
		}else{
			r-&gt;ofcall.count = r-&gt;ifcall.count;
			respond(r, nil);
		}
		break;
	}
}

static void
fsflush(Req *r)
{
	confirmflush(r-&gt;oldreq);
	needkeyflush(r-&gt;oldreq);
	logflush(r-&gt;oldreq);
	respond(r, nil);
}

Srv fs = {
.attach=	fsattach,
.walk1=	fswalk1,
.open=	fsopen,
.read=	fsread,
.write=	fswrite,
.stat=	fsstat,
.flush=	fsflush,
.destroyfid=	fsdestroyfid,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

