<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/p9any.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/p9any.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * p9any - protocol negotiator.
 *
 * Protocol:
 *	Server-&gt;Client: list of proto@domain, tokenize separated, nul terminated
 *	Client-&gt;Server: proto domain, tokenize separated (not proto@domain), nul terminated
 *
 * Server protocol:
 * 	read list of protocols.
 *	write null-terminated 
 */

#include "dat.h"

static Proto *negotiable[] = {
	&amp;p9sk1,
};

struct State
{
	Fsstate subfss;
	State *substate;	/* be very careful; this is not one of our States */
	Proto *subproto;
	int keyasked;
	String *subdom;
	int version;
};

enum
{
	CNeedProtos,
	CHaveProto,
	CNeedOK,
	CRelay,

	SHaveProtos,
	SNeedProto,
	SHaveOK,
	SRelay,

	Maxphase,
};

static char *phasenames[Maxphase] =
{
[CNeedProtos]	"CNeedProtos",
[CHaveProto]	"CHaveProto",
[CNeedOK]	"CNeedOK",
[CRelay]	"CRelay",
[SHaveProtos]	"SHaveProtos",
[SNeedProto]	"SNeedProto",
[SHaveOK]	"SHaveOK",
[SRelay]	"SRelay",
};

static int
p9anyinit(Proto*, Fsstate *fss)
{
	int iscli;
	State *s;

	if((iscli = isclient(_strfindattr(fss-&gt;attr, "role"))) &lt; 0)
		return failure(fss, nil);

	s = emalloc(sizeof *s);
	fss = fss;
	fss-&gt;phasename = phasenames;
	fss-&gt;maxphase = Maxphase;
	if(iscli)
		fss-&gt;phase = CNeedProtos;
	else
		fss-&gt;phase = SHaveProtos;
	s-&gt;version = 1;
	fss-&gt;ps = s;
	return RpcOk;
}

static void
p9anyclose(Fsstate *fss)
{
	State *s;

	s = fss-&gt;ps;
	if(s-&gt;subproto &amp;&amp; s-&gt;subfss.ps &amp;&amp; s-&gt;subproto-&gt;close)
		(*s-&gt;subproto-&gt;close)(&amp;s-&gt;subfss);
	s-&gt;subproto = nil;
	s-&gt;substate = nil;
	s_free(s-&gt;subdom);
	s-&gt;subdom = nil;
	s-&gt;keyasked = 0;
	memset(&amp;s-&gt;subfss, 0, sizeof s-&gt;subfss);
	free(s);
}

static void
setupfss(Fsstate *fss, State *s, Key *k)
{
	fss-&gt;attr = setattr(fss-&gt;attr, "proto=%q", s-&gt;subproto-&gt;name);
	fss-&gt;attr = setattr(fss-&gt;attr, "dom=%q", _strfindattr(k-&gt;attr, "dom"));
	s-&gt;subfss.attr = fss-&gt;attr;
	s-&gt;subfss.phase = Notstarted;
	s-&gt;subfss.sysuser = fss-&gt;sysuser;
	s-&gt;subfss.seqnum = fss-&gt;seqnum;
	s-&gt;subfss.conf = fss-&gt;conf;
	s-&gt;subfss.nconf = fss-&gt;nconf;
}

static int
passret(Fsstate *fss, State *s, int ret)
{
	switch(ret){
	default:
		return ret;
	case RpcFailure:
		if(s-&gt;subfss.phase == Broken)
			fss-&gt;phase = Broken;
		memmove(fss-&gt;err, s-&gt;subfss.err, sizeof fss-&gt;err);
		return ret;
	case RpcNeedkey:
		memmove(fss-&gt;keyinfo, s-&gt;subfss.keyinfo, sizeof fss-&gt;keyinfo);
		return ret;
	case RpcOk:
		if(s-&gt;subfss.haveai){
			fss-&gt;haveai = 1;
			fss-&gt;ai = s-&gt;subfss.ai;
			s-&gt;subfss.haveai = 0;
		}
		if(s-&gt;subfss.phase == Established)
			fss-&gt;phase = Established;
		return ret;
	case RpcToosmall:
		fss-&gt;rpc.nwant = s-&gt;subfss.rpc.nwant;
		return ret;
	case RpcConfirm:
		fss-&gt;conf = s-&gt;subfss.conf;
		fss-&gt;nconf = s-&gt;subfss.nconf;
		return ret;
	}
}

static int
p9anyread(Fsstate *fss, void *a, uint *n)
{
	int i, m, ophase, ret;
	Attr *anew;
	Key *k;
	Keyinfo ki;
	String *negstr;
	State *s;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "read");

	case SHaveProtos:
		m = 0;
		negstr = s_new();
		mkkeyinfo(&amp;ki, fss, nil);
		ki.attr = nil;
		ki.noconf = 1;
		ki.user = nil;
		for(i=0; i&lt;nelem(negotiable); i++){
			anew = setattr(_copyattr(fss-&gt;attr), "proto=%q dom?", negotiable[i]-&gt;name);
			ki.attr = anew;
			for(ki.skip=0; findkey(&amp;k, &amp;ki, nil)==RpcOk; ki.skip++){
				if(m++)
					s_append(negstr, " ");
				s_append(negstr, negotiable[i]-&gt;name);
				s_append(negstr, "@");
				s_append(negstr, _strfindattr(k-&gt;attr, "dom"));
				closekey(k);
			}
			_freeattr(anew);
		}
		if(m == 0){
			s_free(negstr);
			return failure(fss, Enegotiation);
		}
		i = s_len(negstr)+1;
		if(*n &lt; i){
			s_free(negstr);
			return toosmall(fss, i);
		}
		*n = i;
		memmove(a, s_to_c(negstr), i+1);
		fss-&gt;phase = SNeedProto;
		s_free(negstr);
		return RpcOk;

	case CHaveProto:
		i = strlen(s-&gt;subproto-&gt;name)+1+s_len(s-&gt;subdom)+1;
		if(*n &lt; i)
			return toosmall(fss, i);
		*n = i;
		strcpy(a, s-&gt;subproto-&gt;name);
		strcat(a, " ");
		strcat(a, s_to_c(s-&gt;subdom));
		if(s-&gt;version == 1)
			fss-&gt;phase = CRelay;
		else
			fss-&gt;phase = CNeedOK;
		return RpcOk;

	case SHaveOK:
		i = 3;
		if(*n &lt; i)
			return toosmall(fss, i);
		*n = i;
		strcpy(a, "OK");
		fss-&gt;phase = SRelay;
		return RpcOk;

	case CRelay:
	case SRelay:
		ophase = s-&gt;subfss.phase;
		ret = (*s-&gt;subproto-&gt;read)(&amp;s-&gt;subfss, a, n);
		rpcrdwrlog(&amp;s-&gt;subfss, "read", *n, ophase, ret);
		return passret(fss, s, ret);
	}
}

static char*
getdom(char *p)
{
	p = strchr(p, '@');
	if(p == nil)
		return "";
	return p+1;
}

static Proto*
findneg(char *name)
{
	int i, len;
	char *p;

	if(p = strchr(name, '@'))
		len = p-name;
	else
		len = strlen(name);

	for(i=0; i&lt;nelem(negotiable); i++)
		if(strncmp(negotiable[i]-&gt;name, name, len) == 0 &amp;&amp; negotiable[i]-&gt;name[len] == 0)
			return negotiable[i];
	return nil;
}

static int
p9anywrite(Fsstate *fss, void *va, uint n)
{
	char *a, *dom, *user, *token[20];
	int asking, i, m, ophase, ret;
	Attr *anew, *anewsf, *attr;
	Key *k;
	Keyinfo ki;
	Proto *p;
	State *s;

	s = fss-&gt;ps;
	a = va;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "write");

	case CNeedProtos:
		if(n==0 || a[n-1] != '\0')
			return toosmall(fss, 2048);
		a = estrdup(a);
		m = tokenize(a, token, nelem(token));
		if(m &gt; 0 &amp;&amp; strncmp(token[0], "v.", 2) == 0){
			s-&gt;version = atoi(token[0]+2);
			if(s-&gt;version != 2){
				free(a);
				return failure(fss, "unknown version of p9any");
			}
		}
	
		/*
		 * look for a key
		 */
		anew = _delattr(_delattr(_copyattr(fss-&gt;attr), "proto"), "role");
		anewsf = _delattr(_copyattr(anew), "user");
		user = _strfindattr(anew, "user");
		k = nil;
		p = nil;
		dom = nil;
		for(i=(s-&gt;version==1?0:1); i&lt;m; i++){
			p = findneg(token[i]);
			if(p == nil)
				continue;
			dom = getdom(token[i]);
			ret = RpcFailure;
			mkkeyinfo(&amp;ki, fss, nil);
			if(user==nil || strcmp(user, fss-&gt;sysuser)==0){
				ki.attr = anewsf;
				ki.user = nil;
				ret = findkey(&amp;k, &amp;ki, "proto=%q dom=%q role=speakfor %s",
						p-&gt;name, dom, p-&gt;keyprompt);
			}
			if(ret == RpcFailure){
				ki.attr = anew;
				ki.user = fss-&gt;sysuser;
				ret = findkey(&amp;k, &amp;ki,
					"proto=%q dom=%q role=client %s",
					p-&gt;name, dom, p-&gt;keyprompt);
			}
			if(ret == RpcConfirm){
				free(a);
				return ret;
			}
			if(ret == RpcOk)
				break;
		}
		_freeattr(anewsf);

		/*
		 * no acceptable key, go through the proto@domains one at a time.
		 */
		asking = 0;
		if(k == nil){
			while(!asking &amp;&amp; s-&gt;keyasked &lt; m){
				p = findneg(token[s-&gt;keyasked]);
				if(p == nil){
					s-&gt;keyasked++;
					continue;
				}
				dom = getdom(token[s-&gt;keyasked]);
				mkkeyinfo(&amp;ki, fss, nil);
				ki.attr = anew;
				ret = findkey(&amp;k, &amp;ki,
					"proto=%q dom=%q role=client %s",
					p-&gt;name, dom, p-&gt;keyprompt);
				s-&gt;keyasked++;
				if(ret == RpcNeedkey){
					asking = 1;
					break;
				}
			}
		}
		if(k == nil){
			free(a);
			_freeattr(anew);
			if(asking)
				return RpcNeedkey;
			else if(s-&gt;keyasked)
				return failure(fss, nil);
			else
				return failure(fss, Enegotiation);
		}
		s-&gt;subdom = s_copy(dom);
		s-&gt;subproto = p;
		free(a);
		_freeattr(anew);
		setupfss(fss, s, k);
		closekey(k);
		ret = (*s-&gt;subproto-&gt;init)(p, &amp;s-&gt;subfss);
		rpcstartlog(s-&gt;subfss.attr, &amp;s-&gt;subfss, ret);
		if(ret == RpcOk)
			fss-&gt;phase = CHaveProto;
		return passret(fss, s, ret);

	case SNeedProto:
		if(n==0 || a[n-1] != '\0')
			return toosmall(fss, n+1);
		a = estrdup(a);
		m = tokenize(a, token, nelem(token));
		if(m != 2){
			free(a);
			return failure(fss, Ebadarg);
		}
		p = findneg(token[0]);
		if(p == nil){
			free(a);
			return failure(fss, Enegotiation);
		}
		attr = _delattr(_copyattr(fss-&gt;attr), "proto");
		mkkeyinfo(&amp;ki, fss, nil);
		ki.attr = attr;
		ki.user = nil;
		ret = findkey(&amp;k, &amp;ki, "proto=%q dom=%q role=server", token[0], token[1]);
		free(a);
		_freeattr(attr);
		if(ret == RpcConfirm)
			return ret;
		if(ret != RpcOk)
			return failure(fss, Enegotiation);
		s-&gt;subproto = p;
		setupfss(fss, s, k);
		closekey(k);
		ret = (*s-&gt;subproto-&gt;init)(p, &amp;s-&gt;subfss);
		if(ret == RpcOk){
			if(s-&gt;version == 1)
				fss-&gt;phase = SRelay;
			else
				fss-&gt;phase = SHaveOK;
		}
		return passret(fss, s, ret);

	case CNeedOK:
		if(n &lt; 3)
			return toosmall(fss, 3);
		if(strcmp("OK", a) != 0)
			return failure(fss, "server gave up");
		fss-&gt;phase = CRelay;
		return RpcOk;

	case CRelay:
	case SRelay:
		ophase = s-&gt;subfss.phase;
		ret = (*s-&gt;subproto-&gt;write)(&amp;s-&gt;subfss, va, n);
		rpcrdwrlog(&amp;s-&gt;subfss, "write", n, ophase, ret);
		return passret(fss, s, ret);
	}
}

Proto p9any = 
{
.name=	"p9any",
.init=		p9anyinit,
.write=	p9anywrite,
.read=	p9anyread,
.close=	p9anyclose,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

