<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/p9cr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/p9cr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * p9cr, vnc - textual challenge/response authentication
 *
 * Client protocol:	[currently unimplemented]
 *	write challenge
 *	read response
 *
 * Server protocol:
 *	write user
 *	read challenge
 * 	write response
 */

#include "dat.h"

enum
{
	Maxchal=	64,
};

typedef struct State State;
struct State
{
	Key	*key;
	int	astype;
	int	asfd;
	Ticket	t;
	Ticketreq tr;
	char	chal[Maxchal];
	int	challen;
	char	resp[Maxchal];
	int	resplen;
};

enum
{
	CNeedChal,
	CHaveResp,

	SHaveChal,
	SNeedResp,

	Maxphase,
};

static char *phasenames[Maxphase] =
{
[CNeedChal]	"CNeedChal",
[CHaveResp]	"CHaveResp",

[SHaveChal]	"SHaveChal",
[SNeedResp]	"SNeedResp",
};

static void
p9crclose(Fsstate *fss)
{
	State *s;

	s = fss-&gt;ps;
	if(s-&gt;asfd &gt;= 0){
		close(s-&gt;asfd);
		s-&gt;asfd = -1;
	}
	free(s);
}

static int getchal(State*, Fsstate*);

static int
p9crinit(Proto *p, Fsstate *fss)
{
	int iscli, ret;
	char *user;
	State *s;
	Attr *attr;
	Keyinfo ki;

	if((iscli = isclient(_strfindattr(fss-&gt;attr, "role"))) &lt; 0)
		return failure(fss, nil);
	
	s = emalloc(sizeof(*s));
	s-&gt;asfd = -1;
	if(p == &amp;p9cr){
		s-&gt;astype = AuthChal;
		s-&gt;challen = NETCHLEN;
	}else if(p == &amp;vnc){
		s-&gt;astype = AuthVNC;
		s-&gt;challen = Maxchal;
	}else
		abort();

	if(iscli){
		fss-&gt;phase = CNeedChal;
		if(p == &amp;p9cr)
			attr = setattr(_copyattr(fss-&gt;attr), "proto=p9sk1");
		else
			attr = nil;
		ret = findkey(&amp;s-&gt;key, mkkeyinfo(&amp;ki, fss, attr),
			"role=client %s", p-&gt;keyprompt);
		_freeattr(attr);
		if(ret != RpcOk){
			free(s);
			return ret;
		}
		fss-&gt;ps = s;
	}else{
		if((ret = findp9authkey(&amp;s-&gt;key, fss)) != RpcOk){
			free(s);
			return ret;
		}
		if((user = _strfindattr(fss-&gt;attr, "user")) == nil){
			free(s);
			return failure(fss, "no user name specified in start msg");
		}
		if(strlen(user) &gt;= sizeof s-&gt;tr.uid){
			free(s);
			return failure(fss, "user name too long");
		}
		fss-&gt;ps = s;
		strcpy(s-&gt;tr.uid, user);
		ret = getchal(s, fss);
		if(ret != RpcOk){
			p9crclose(fss);	/* frees s */
			fss-&gt;ps = nil;
		}
	}
	fss-&gt;phasename = phasenames;
	fss-&gt;maxphase = Maxphase;
	return ret;
}

static int
p9crread(Fsstate *fss, void *va, uint *n)
{
	int m;
	State *s;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "read");

	case CHaveResp:
		if(s-&gt;resplen &lt; *n)
			*n = s-&gt;resplen;
		memmove(va, s-&gt;resp, *n);
		fss-&gt;phase = Established;
		return RpcOk;

	case SHaveChal:
		if(s-&gt;astype == AuthChal)
			m = strlen(s-&gt;chal);	/* ascii string */
		else
			m = s-&gt;challen;		/* fixed length binary */
		if(m &gt; *n)
			return toosmall(fss, m);
		*n = m;
		memmove(va, s-&gt;chal, m);
		fss-&gt;phase = SNeedResp;
		return RpcOk;
	}
}

static int
p9response(Fsstate *fss, State *s)
{
	char key[DESKEYLEN];
	uchar buf[8];
	ulong chal;
	char *pw;

	pw = _strfindattr(s-&gt;key-&gt;privattr, "!password");
	if(pw == nil)
		return failure(fss, "vncresponse cannot happen");
	passtokey(key, pw);
	memset(buf, 0, 8);
	snprint((char*)buf, sizeof buf, "%d", atoi(s-&gt;chal));
	if(encrypt(key, buf, 8) &lt; 0)
		return failure(fss, "can't encrypt response");
	chal = (buf[0]&lt;&lt;24)+(buf[1]&lt;&lt;16)+(buf[2]&lt;&lt;8)+buf[3];
	s-&gt;resplen = snprint(s-&gt;resp, sizeof s-&gt;resp, "%.8lux", chal);
	return RpcOk;
}

static uchar tab[256];

/* VNC reverses the bits of each byte before using as a des key */
static void
mktab(void)
{
	int i, j, k;
	static int once;

	if(once)
		return;
	once = 1;

	for(i=0; i&lt;256; i++) {
		j=i;
		tab[i] = 0;
		for(k=0; k&lt;8; k++) {
			tab[i] = (tab[i]&lt;&lt;1) | (j&amp;1);
			j &gt;&gt;= 1;
		}
	}
}

static int
vncaddkey(Key *k, int before)
{
	uchar *p;
	char *s;

	k-&gt;priv = emalloc(8+1);
	if(s = _strfindattr(k-&gt;privattr, "!password")){
		mktab();
		memset(k-&gt;priv, 0, 8+1);
		strncpy((char*)k-&gt;priv, s, 8);
		for(p=k-&gt;priv; *p; p++)
			*p = tab[*p];
	}else{
		werrstr("no key data");
		return -1;
	}
	return replacekey(k, before);
}

static void
vncclosekey(Key *k)
{
	free(k-&gt;priv);
}

static int
vncresponse(Fsstate*, State *s)
{
	DESstate des;

	memmove(s-&gt;resp, s-&gt;chal, sizeof s-&gt;chal);
	setupDESstate(&amp;des, s-&gt;key-&gt;priv, nil);
	desECBencrypt((uchar*)s-&gt;resp, s-&gt;challen, &amp;des);
	s-&gt;resplen = s-&gt;challen;
	return RpcOk;
}

static int
p9crwrite(Fsstate *fss, void *va, uint n)
{
	char tbuf[TICKETLEN+AUTHENTLEN];
	State *s;
	char *data = va;
	Authenticator a;
	char resp[Maxchal];
	int ret;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "write");

	case CNeedChal:
		if(n &gt;= sizeof(s-&gt;chal))
			return failure(fss, Ebadarg);
		memset(s-&gt;chal, 0, sizeof s-&gt;chal);
		memmove(s-&gt;chal, data, n);
		s-&gt;challen = n;

		if(s-&gt;astype == AuthChal)
			ret = p9response(fss, s);
		else
			ret = vncresponse(fss, s);
		if(ret != RpcOk)
			return ret;
		fss-&gt;phase = CHaveResp;
		return RpcOk;

	case SNeedResp:
		/* send response to auth server and get ticket */
		if(n &gt; sizeof(resp))
			return failure(fss, Ebadarg);
		memset(resp, 0, sizeof resp);
		memmove(resp, data, n);
		if(write(s-&gt;asfd, resp, s-&gt;challen) != s-&gt;challen)
			return failure(fss, Easproto);

		/* get ticket plus authenticator from auth server */
		if(_asrdresp(s-&gt;asfd, tbuf, TICKETLEN+AUTHENTLEN) &lt; 0)
			return failure(fss, nil);

		/* check ticket */
		convM2T(tbuf, &amp;s-&gt;t, s-&gt;key-&gt;priv);
		if(s-&gt;t.num != AuthTs
		|| memcmp(s-&gt;t.chal, s-&gt;tr.chal, sizeof(s-&gt;t.chal)) != 0){
			if (s-&gt;key-&gt;successes == 0)
				disablekey(s-&gt;key);
			return failure(fss, Easproto);
		}
		s-&gt;key-&gt;successes++;
		convM2A(tbuf+TICKETLEN, &amp;a, s-&gt;t.key);
		if(a.num != AuthAc
		|| memcmp(a.chal, s-&gt;tr.chal, sizeof(a.chal)) != 0
		|| a.id != 0)
			return failure(fss, Easproto);

		fss-&gt;haveai = 1;
		fss-&gt;ai.cuid = s-&gt;t.cuid;
		fss-&gt;ai.suid = s-&gt;t.suid;
		fss-&gt;ai.nsecret = 0;
		fss-&gt;ai.secret = nil;
		fss-&gt;phase = Established;
		return RpcOk;
	}
}

static int
getchal(State *s, Fsstate *fss)
{
	char trbuf[TICKREQLEN];
	int n;

	safecpy(s-&gt;tr.hostid, _strfindattr(s-&gt;key-&gt;attr, "user"), sizeof(s-&gt;tr.hostid));
	safecpy(s-&gt;tr.authdom, _strfindattr(s-&gt;key-&gt;attr, "dom"), sizeof(s-&gt;tr.authdom));
	s-&gt;tr.type = s-&gt;astype;
	convTR2M(&amp;s-&gt;tr, trbuf);

	/* get challenge from auth server */
	s-&gt;asfd = _authdial(nil, _strfindattr(s-&gt;key-&gt;attr, "dom"));
	if(s-&gt;asfd &lt; 0)
		return failure(fss, Easproto);
	if(write(s-&gt;asfd, trbuf, TICKREQLEN) != TICKREQLEN)
		return failure(fss, Easproto);
	n = _asrdresp(s-&gt;asfd, s-&gt;chal, s-&gt;challen);
	if(n &lt;= 0){
		if(n == 0)
			werrstr("_asrdresp short read");
		return failure(fss, nil);
	}
	s-&gt;challen = n;
	fss-&gt;phase = SHaveChal;
	return RpcOk;
}

Proto p9cr =
{
.name=		"p9cr",
.init=		p9crinit,
.write=		p9crwrite,
.read=		p9crread,
.close=		p9crclose,
.keyprompt=	"user? !password?",
};

Proto vnc =
{
.name=		"vnc",
.init=		p9crinit,
.write=		p9crwrite,
.read=		p9crread,
.close=		p9crclose,
.keyprompt=	"!password?",
.addkey=	vncaddkey,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

