<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/p9sk1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/p9sk1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * p9sk1, p9sk2 - Plan 9 secret (private) key authentication.
 * p9sk2 is an incomplete flawed variant of p9sk1.
 *
 * Client protocol:
 *	write challenge[challen]	(p9sk1 only)
 *	read tickreq[tickreqlen]
 *	write ticket[ticketlen]
 *	read authenticator[authentlen]
 *
 * Server protocol:
 * 	read challenge[challen]	(p9sk1 only)
 *	write tickreq[tickreqlen]
 *	read ticket[ticketlen]
 *	write authenticator[authentlen]
 */

#include "dat.h"

struct State
{
	int vers;
	Key *key;
	Ticket t;
	Ticketreq tr;
	char cchal[CHALLEN];
	char tbuf[TICKETLEN+AUTHENTLEN];
	char authkey[DESKEYLEN];
	uchar *secret;
	int speakfor;
};

enum
{
	/* client phases */
	CHaveChal,
	CNeedTreq,
	CHaveTicket,
	CNeedAuth,

	/* server phases */
	SNeedChal,
	SHaveTreq,
	SNeedTicket,
	SHaveAuth,

	Maxphase,
};

static char *phasenames[Maxphase] =
{
[CHaveChal]		"CHaveChal",
[CNeedTreq]		"CNeedTreq",
[CHaveTicket]		"CHaveTicket",
[CNeedAuth]		"CNeedAuth",

[SNeedChal]		"SNeedChal",
[SHaveTreq]		"SHaveTreq",
[SNeedTicket]		"SNeedTicket",
[SHaveAuth]		"SHaveAuth",
};

static int gettickets(State*, char*, char*);

static int
p9skinit(Proto *p, Fsstate *fss)
{
	State *s;
	int iscli, ret;
	Key *k;
	Keyinfo ki;
	Attr *attr;

	if((iscli = isclient(_strfindattr(fss-&gt;attr, "role"))) &lt; 0)
		return failure(fss, nil);

	s = emalloc(sizeof *s);
	fss = fss;
	fss-&gt;phasename = phasenames;
	fss-&gt;maxphase = Maxphase;
	if(p == &amp;p9sk1)
		s-&gt;vers = 1;
	else if(p == &amp;p9sk2)
		s-&gt;vers = 2;
	else
		abort();
	if(iscli){
		switch(s-&gt;vers){
		case 1:
			fss-&gt;phase = CHaveChal;
			memrandom(s-&gt;cchal, CHALLEN);
			break;
		case 2:
			fss-&gt;phase = CNeedTreq;
			break;
		}
	}else{
		s-&gt;tr.type = AuthTreq;
		attr = setattr(_copyattr(fss-&gt;attr), "proto=p9sk1");
		mkkeyinfo(&amp;ki, fss, attr);
		ki.user = nil;
		ret = findkey(&amp;k, &amp;ki, "user? dom?");
		_freeattr(attr);
		if(ret != RpcOk){
			free(s);
			return ret;
		}
		safecpy(s-&gt;tr.authid, _strfindattr(k-&gt;attr, "user"), sizeof(s-&gt;tr.authid));
		safecpy(s-&gt;tr.authdom, _strfindattr(k-&gt;attr, "dom"), sizeof(s-&gt;tr.authdom));
		s-&gt;key = k;
		memrandom(s-&gt;tr.chal, sizeof s-&gt;tr.chal);
		switch(s-&gt;vers){
		case 1:
			fss-&gt;phase = SNeedChal;
			break;
		case 2:
			fss-&gt;phase = SHaveTreq;
			memmove(s-&gt;cchal, s-&gt;tr.chal, CHALLEN);
			break;
		}
	}
	fss-&gt;ps = s;
	return RpcOk;
}

static int
p9skread(Fsstate *fss, void *a, uint *n)
{
	int m;
	State *s;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "read");

	case CHaveChal:
		m = CHALLEN;
		if(*n &lt; m)
			return toosmall(fss, m);
		*n = m;
		memmove(a, s-&gt;cchal, m);
		fss-&gt;phase = CNeedTreq;
		return RpcOk;

	case SHaveTreq:
		m = TICKREQLEN;
		if(*n &lt; m)
			return toosmall(fss, m);
		*n = m;
		convTR2M(&amp;s-&gt;tr, a);
		fss-&gt;phase = SNeedTicket;
		return RpcOk;

	case CHaveTicket:
		m = TICKETLEN+AUTHENTLEN;
		if(*n &lt; m)
			return toosmall(fss, m);
		*n = m;
		memmove(a, s-&gt;tbuf, m);
		fss-&gt;phase = CNeedAuth;
		return RpcOk;

	case SHaveAuth:
		m = AUTHENTLEN;
		if(*n &lt; m)
			return toosmall(fss, m);
		*n = m;
		memmove(a, s-&gt;tbuf+TICKETLEN, m);
		fss-&gt;ai.cuid = s-&gt;t.cuid;
		fss-&gt;ai.suid = s-&gt;t.suid;
		s-&gt;secret = emalloc(8);
		des56to64((uchar*)s-&gt;t.key, s-&gt;secret);
		fss-&gt;ai.secret = s-&gt;secret;
		fss-&gt;ai.nsecret = 8;
		fss-&gt;haveai = 1;
		fss-&gt;phase = Established;
		return RpcOk;
	}
}

static int
p9skwrite(Fsstate *fss, void *a, uint n)
{
	int m, ret, sret;
	char tbuf[2*TICKETLEN], trbuf[TICKREQLEN], *user;
	Attr *attr;
	Authenticator auth;
	State *s;
	Key *srvkey;
	Keyinfo ki;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "write");

	case SNeedChal:
		m = CHALLEN;
		if(n &lt; m)
			return toosmall(fss, m);
		memmove(s-&gt;cchal, a, m);
		fss-&gt;phase = SHaveTreq;
		return RpcOk;

	case CNeedTreq:
		m = TICKREQLEN;
		if(n &lt; m)
			return toosmall(fss, m);

		/* remember server's chal */
		convM2TR(a, &amp;s-&gt;tr);
		if(s-&gt;vers == 2)
			memmove(s-&gt;cchal, s-&gt;tr.chal, CHALLEN);

		if(s-&gt;key != nil)
			closekey(s-&gt;key);

		attr = _delattr(_delattr(_copyattr(fss-&gt;attr), "role"), "user");
		attr = setattr(attr, "proto=p9sk1");
		user = _strfindattr(fss-&gt;attr, "user");
		/*
		 * If our client is the user who started factotum (client==owner), then
		 * he can use whatever keys we have to speak as whoever he pleases.
		 * If, on the other hand, we're speaking on behalf of someone else,
		 * we will only vouch for their name on the local system.
		 *
		 * We do the sysuser findkey second so that if we return RpcNeedkey,
		 * the correct key information gets asked for.
		 */
		srvkey = nil;
		s-&gt;speakfor = 0;
		sret = RpcFailure;
		if(user==nil || strcmp(user, fss-&gt;sysuser) == 0){
			mkkeyinfo(&amp;ki, fss, attr);
			ki.user = nil;
			sret = findkey(&amp;srvkey, &amp;ki,
				"role=speakfor dom=%q user?", s-&gt;tr.authdom);
		}
		if(user != nil)
			attr = setattr(attr, "user=%q", user);
		mkkeyinfo(&amp;ki, fss, attr);
		ret = findkey(&amp;s-&gt;key, &amp;ki,
			"role=client dom=%q %s", s-&gt;tr.authdom, p9sk1.keyprompt);
		if(ret == RpcOk)
			closekey(srvkey);
		else if(sret == RpcOk){
			s-&gt;key = srvkey;
			s-&gt;speakfor = 1;
		}else if(ret == RpcConfirm || sret == RpcConfirm){
			_freeattr(attr);
			return RpcConfirm;
		}else{
			_freeattr(attr);
			return ret;
		}

		/* fill in the rest of the request */
		s-&gt;tr.type = AuthTreq;
		safecpy(s-&gt;tr.hostid, _strfindattr(s-&gt;key-&gt;attr, "user"), sizeof s-&gt;tr.hostid);
		if(s-&gt;speakfor)
			safecpy(s-&gt;tr.uid, fss-&gt;sysuser, sizeof s-&gt;tr.uid);
		else
			safecpy(s-&gt;tr.uid, s-&gt;tr.hostid, sizeof s-&gt;tr.uid);

		convTR2M(&amp;s-&gt;tr, trbuf);

		/* get tickets, from auth server or invent if we can */
		if(gettickets(s, trbuf, tbuf) &lt; 0){
			_freeattr(attr);
			return failure(fss, nil);
		}

		convM2T(tbuf, &amp;s-&gt;t, (char*)s-&gt;key-&gt;priv);
		if(s-&gt;t.num != AuthTc){
			if(s-&gt;key-&gt;successes == 0 &amp;&amp; !s-&gt;speakfor)
				disablekey(s-&gt;key);
			if(askforkeys &amp;&amp; !s-&gt;speakfor){
				snprint(fss-&gt;keyinfo, sizeof fss-&gt;keyinfo,
					"%A %s", attr, p9sk1.keyprompt);
				_freeattr(attr);
				return RpcNeedkey;
			}else{
				_freeattr(attr);
				return failure(fss, Ebadkey);
			}
		}
		s-&gt;key-&gt;successes++;
		_freeattr(attr);
		memmove(s-&gt;tbuf, tbuf+TICKETLEN, TICKETLEN);

		auth.num = AuthAc;
		memmove(auth.chal, s-&gt;tr.chal, CHALLEN);
		auth.id = 0;
		convA2M(&amp;auth, s-&gt;tbuf+TICKETLEN, s-&gt;t.key);
		fss-&gt;phase = CHaveTicket;
		return RpcOk;

	case SNeedTicket:
		m = TICKETLEN+AUTHENTLEN;
		if(n &lt; m)
			return toosmall(fss, m);
		convM2T(a, &amp;s-&gt;t, (char*)s-&gt;key-&gt;priv);
		if(s-&gt;t.num != AuthTs
		|| memcmp(s-&gt;t.chal, s-&gt;tr.chal, CHALLEN) != 0)
			return failure(fss, Easproto);
		convM2A((char*)a+TICKETLEN, &amp;auth, s-&gt;t.key);
		if(auth.num != AuthAc
		|| memcmp(auth.chal, s-&gt;tr.chal, CHALLEN) != 0
		|| auth.id != 0)
			return failure(fss, Easproto);
		auth.num = AuthAs;
		memmove(auth.chal, s-&gt;cchal, CHALLEN);
		auth.id = 0;
		convA2M(&amp;auth, s-&gt;tbuf+TICKETLEN, s-&gt;t.key);
		fss-&gt;phase = SHaveAuth;
		return RpcOk;

	case CNeedAuth:
		m = AUTHENTLEN;
		if(n &lt; m)
			return toosmall(fss, m);
		convM2A(a, &amp;auth, s-&gt;t.key);
		if(auth.num != AuthAs
		|| memcmp(auth.chal, s-&gt;cchal, CHALLEN) != 0
		|| auth.id != 0)
			return failure(fss, Easproto);
		fss-&gt;ai.cuid = s-&gt;t.cuid;
		fss-&gt;ai.suid = s-&gt;t.suid;
		s-&gt;secret = emalloc(8);
		des56to64((uchar*)s-&gt;t.key, s-&gt;secret);
		fss-&gt;ai.secret = s-&gt;secret;
		fss-&gt;ai.nsecret = 8;
		fss-&gt;haveai = 1;
		fss-&gt;phase = Established;
		return RpcOk;
	}
}

static void
p9skclose(Fsstate *fss)
{
	State *s;

	s = fss-&gt;ps;
	if(s-&gt;secret != nil){
		free(s-&gt;secret);
		s-&gt;secret = nil;
	}
	if(s-&gt;key != nil){
		closekey(s-&gt;key);
		s-&gt;key = nil;
	}
	free(s);
}

static int
unhex(char c)
{
	if('0' &lt;= c &amp;&amp; c &lt;= '9')
		return c-'0';
	if('a' &lt;= c &amp;&amp; c &lt;= 'f')
		return c-'a'+10;
	if('A' &lt;= c &amp;&amp; c &lt;= 'F')
		return c-'A'+10;
	abort();
	return -1;
}

static int
hexparse(char *hex, uchar *dat, int ndat)
{
	int i;

	if(strlen(hex) != 2*ndat)
		return -1;
	if(hex[strspn(hex, "0123456789abcdefABCDEF")] != '\0')
		return -1;
	for(i=0; i&lt;ndat; i++)
		dat[i] = (unhex(hex[2*i])&lt;&lt;4)|unhex(hex[2*i+1]);
	return 0;
}

static int
p9skaddkey(Key *k, int before)
{
	char *s;

	k-&gt;priv = emalloc(DESKEYLEN);
	if(s = _strfindattr(k-&gt;privattr, "!hex")){
		if(hexparse(s, k-&gt;priv, 7) &lt; 0){
			free(k-&gt;priv);
			k-&gt;priv = nil;
			werrstr("malformed key data");
			return -1;
		}
	}else if(s = _strfindattr(k-&gt;privattr, "!password")){
		passtokey((char*)k-&gt;priv, s);
	}else{
		werrstr("no key data");
		free(k-&gt;priv);
		k-&gt;priv = nil;
		return -1;
	}
	return replacekey(k, before);
}

static void
p9skclosekey(Key *k)
{
	free(k-&gt;priv);
}

static int
getastickets(State *s, char *trbuf, char *tbuf)
{
	int asfd, rv;
	char *dom;

	if((dom = _strfindattr(s-&gt;key-&gt;attr, "dom")) == nil){
		werrstr("auth key has no domain");
		return -1;
	}
	asfd = _authdial(nil, dom);
	if(asfd &lt; 0)
		return -1;
	rv = _asgetticket(asfd, trbuf, tbuf);
	close(asfd);
	return rv;
}

static int
mkserverticket(State *s, char *tbuf)
{
	Ticketreq *tr = &amp;s-&gt;tr;
	Ticket t;

	if(strcmp(tr-&gt;authid, tr-&gt;hostid) != 0)
		return -1;
/* this keeps creating accounts on martha from working.  -- presotto
	if(strcmp(tr-&gt;uid, "none") == 0)
		return -1;
*/
	memset(&amp;t, 0, sizeof(t));
	memmove(t.chal, tr-&gt;chal, CHALLEN);
	strcpy(t.cuid, tr-&gt;uid);
	strcpy(t.suid, tr-&gt;uid);
	memrandom(t.key, DESKEYLEN);
	t.num = AuthTc;
	convT2M(&amp;t, tbuf, s-&gt;key-&gt;priv);
	t.num = AuthTs;
	convT2M(&amp;t, tbuf+TICKETLEN, s-&gt;key-&gt;priv);
	return 0;
}

static int
gettickets(State *s, char *trbuf, char *tbuf)
{
/*
	if(mktickets(s, trbuf, tbuf) &gt;= 0)
		return 0;
*/
	if(getastickets(s, trbuf, tbuf) &gt;= 0)
		return 0;
	return mkserverticket(s, tbuf);
}

Proto p9sk1 = {
.name=	"p9sk1",
.init=		p9skinit,
.write=	p9skwrite,
.read=	p9skread,
.close=	p9skclose,
.addkey=	p9skaddkey,
.closekey=	p9skclosekey,
.keyprompt=	"user? !password?"
};

Proto p9sk2 = {
.name=	"p9sk2",
.init=		p9skinit,
.write=	p9skwrite,
.read=	p9skread,
.close=	p9skclose,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

