<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/rsa.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/rsa.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * RSA authentication.
 *
 * Old ssh client protocol:
 *	read public key
 *		if you don't like it, read another, repeat
 *	write challenge
 *	read response
 *
 * all numbers are hexadecimal biginits parsable with strtomp.
 *
 * Sign (PKCS #1 using hash=sha1 or hash=md5)
 *	write hash(msg)
 *	read signature(hash(msg))
 *
 * Verify:
 *	write hash(msg)
 *	write signature(hash(msg))
 *	read ok or fail
 */

#include "dat.h"

enum {
	CHavePub,
	CHaveResp,
	VNeedHash,
	VNeedSig,
	VHaveResp,
	SNeedHash,
	SHaveResp,
	Maxphase,
};

static char *phasenames[] = {
[CHavePub]	"CHavePub",
[CHaveResp]	"CHaveResp",
[VNeedHash]	"VNeedHash",
[VNeedSig]	"VNeedSig",
[VHaveResp]	"VHaveResp",
[SNeedHash]	"SNeedHash",
[SHaveResp]	"SHaveResp",
};

struct State
{
	RSApriv *priv;
	mpint *resp;
	int off;
	Key *key;
	mpint *digest;
	int sigresp;
};

static mpint* mkdigest(RSApub *key, char *hashalg, uchar *hash, uint dlen);

static RSApriv*
readrsapriv(Key *k)
{
	char *a;
	RSApriv *priv;

	priv = rsaprivalloc();

	if((a=_strfindattr(k-&gt;attr, "ek"))==nil || (priv-&gt;pub.ek=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if((a=_strfindattr(k-&gt;attr, "n"))==nil || (priv-&gt;pub.n=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if(k-&gt;privattr == nil)		/* only public half */
		return priv;
	if((a=_strfindattr(k-&gt;privattr, "!p"))==nil || (priv-&gt;p=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if((a=_strfindattr(k-&gt;privattr, "!q"))==nil || (priv-&gt;q=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if((a=_strfindattr(k-&gt;privattr, "!kp"))==nil || (priv-&gt;kp=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if((a=_strfindattr(k-&gt;privattr, "!kq"))==nil || (priv-&gt;kq=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if((a=_strfindattr(k-&gt;privattr, "!c2"))==nil || (priv-&gt;c2=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	if((a=_strfindattr(k-&gt;privattr, "!dk"))==nil || (priv-&gt;dk=strtomp(a, nil, 16, nil))==nil)
		goto Error;
	return priv;

Error:
	rsaprivfree(priv);
	return nil;
}

static int
rsainit(Proto*, Fsstate *fss)
{
	Keyinfo ki;
	State *s;
	char *role;

	if((role = _strfindattr(fss-&gt;attr, "role")) == nil)
		return failure(fss, "rsa role not specified");
	if(strcmp(role, "client") == 0)
		fss-&gt;phase = CHavePub;
	else if(strcmp(role, "sign") == 0)
		fss-&gt;phase = SNeedHash;
	else if(strcmp(role, "verify") == 0)
		fss-&gt;phase = VNeedHash;
	else
		return failure(fss, "rsa role %s unimplemented", role);

	s = emalloc(sizeof *s);
	fss-&gt;phasename = phasenames;
	fss-&gt;maxphase = Maxphase;
	fss-&gt;ps = s;

	switch(fss-&gt;phase){
	case SNeedHash:
	case VNeedHash:
		mkkeyinfo(&amp;ki, fss, nil);
		if(findkey(&amp;s-&gt;key, &amp;ki, nil) != RpcOk)
			return failure(fss, nil);
		/* signing needs private key */
		if(fss-&gt;phase == SNeedHash &amp;&amp; s-&gt;key-&gt;privattr == nil)
			return failure(fss,
				"missing private half of key -- cannot sign");
	}
	return RpcOk;
}

static int
rsaread(Fsstate *fss, void *va, uint *n)
{
	RSApriv *priv;
	State *s;
	mpint *m;
	Keyinfo ki;
	int len, r;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "read");
	case CHavePub:
		if(s-&gt;key){
			closekey(s-&gt;key);
			s-&gt;key = nil;
		}
		mkkeyinfo(&amp;ki, fss, nil);
		ki.skip = s-&gt;off;
		ki.noconf = 1;
		if(findkey(&amp;s-&gt;key, &amp;ki, nil) != RpcOk)
			return failure(fss, nil);
		s-&gt;off++;
		priv = s-&gt;key-&gt;priv;
		*n = snprint(va, *n, "%B", priv-&gt;pub.n);
		return RpcOk;
	case CHaveResp:
		*n = snprint(va, *n, "%B", s-&gt;resp);
		fss-&gt;phase = Established;
		return RpcOk;
	case SHaveResp:
		priv = s-&gt;key-&gt;priv;
		len = (mpsignif(priv-&gt;pub.n)+7)/8;
		if(len &gt; *n)
			return failure(fss, "signature buffer too short");
		m = rsadecrypt(priv, s-&gt;digest, nil);
		r = mptobe(m, (uchar*)va, len, nil);
		if(r &lt; len){
			memmove((uchar*)va+len-r, va, r);
			memset(va, 0, len-r);
		}
		*n = len;
		mpfree(m);
		fss-&gt;phase = Established;
		return RpcOk;
	case VHaveResp:
		*n = snprint(va, *n, "%s", s-&gt;sigresp == 0? "ok":
			"signature does not verify");
		fss-&gt;phase = Established;
		return RpcOk;
	}
}

static int
rsawrite(Fsstate *fss, void *va, uint n)
{
	RSApriv *priv;
	mpint *m, *mm;
	State *s;
	char *hash;
	int dlen;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "write");
	case CHavePub:
		if(s-&gt;key == nil)
			return failure(fss, "no current key");
		switch(canusekey(fss, s-&gt;key)){
		case -1:
			return RpcConfirm;
		case 0:
			return failure(fss, "confirmation denied");
		case 1:
			break;
		}
		m = strtomp(va, nil, 16, nil);
		if(m == nil)
			return failure(fss, "invalid challenge value");
		m = rsadecrypt(s-&gt;key-&gt;priv, m, m);
		s-&gt;resp = m;
		fss-&gt;phase = CHaveResp;
		return RpcOk;
	case SNeedHash:
	case VNeedHash:
		/* get hash type from key */
		hash = _strfindattr(s-&gt;key-&gt;attr, "hash");
		if(hash == nil)
			hash = "sha1";
		if(strcmp(hash, "sha1") == 0)
			dlen = SHA1dlen;
		else if(strcmp(hash, "md5") == 0)
			dlen = MD5dlen;
		else
			return failure(fss, "unknown hash function %s", hash);
		if(n != dlen)
			return failure(fss, "hash length %d should be %d",
				n, dlen);
		priv = s-&gt;key-&gt;priv;
		s-&gt;digest = mkdigest(&amp;priv-&gt;pub, hash, (uchar *)va, n);
		if(s-&gt;digest == nil)
			return failure(fss, nil);
		if(fss-&gt;phase == VNeedHash)
			fss-&gt;phase = VNeedSig;
		else
			fss-&gt;phase = SHaveResp;
		return RpcOk;
	case VNeedSig:
		priv = s-&gt;key-&gt;priv;
		m = betomp((uchar*)va, n, nil);
		mm = rsaencrypt(&amp;priv-&gt;pub, m, nil);
		s-&gt;sigresp = mpcmp(s-&gt;digest, mm);
		mpfree(m);
		mpfree(mm);
		fss-&gt;phase = VHaveResp;
		return RpcOk;
	}
}

static void
rsaclose(Fsstate *fss)
{
	State *s;

	s = fss-&gt;ps;
	if(s-&gt;key)
		closekey(s-&gt;key);
	if(s-&gt;resp)
		mpfree(s-&gt;resp);
	if(s-&gt;digest)
		mpfree(s-&gt;digest);
	free(s);
}

static int
rsaaddkey(Key *k, int before)
{
	fmtinstall('B', mpfmt);

	if((k-&gt;priv = readrsapriv(k)) == nil){
		werrstr("malformed key data");
		return -1;
	}
	return replacekey(k, before);
}

static void
rsaclosekey(Key *k)
{
	rsaprivfree(k-&gt;priv);
}

Proto rsa = {
.name=	"rsa",
.init=		rsainit,
.write=	rsawrite,
.read=	rsaread,
.close=	rsaclose,
.addkey=	rsaaddkey,
.closekey=	rsaclosekey,
};

/*
 * Simple ASN.1 encodings.
 * Lengths &lt; 128 are encoded as 1-bytes constants,
 * making our life easy.
 */

/*
 * Hash OIDs
 *
 * SHA1 = 1.3.14.3.2.26
 * MDx = 1.2.840.113549.2.x
 */
#define O0(a,b)	((a)*40+(b))
#define O2(x)	\
	(((x)&gt;&gt; 7)&amp;0x7F)|0x80, \
	((x)&amp;0x7F)
#define O3(x)	\
	(((x)&gt;&gt;14)&amp;0x7F)|0x80, \
	(((x)&gt;&gt; 7)&amp;0x7F)|0x80, \
	((x)&amp;0x7F)
uchar oidsha1[] = { O0(1, 3), 14, 3, 2, 26 };
uchar oidmd2[] = { O0(1, 2), O2(840), O3(113549), 2, 2 };
uchar oidmd5[] = { O0(1, 2), O2(840), O3(113549), 2, 5 };

/*
 *	DigestInfo ::= SEQUENCE {
 *		digestAlgorithm AlgorithmIdentifier,
 *		digest OCTET STRING
 *	}
 *
 * except that OpenSSL seems to sign
 *
 *	DigestInfo ::= SEQUENCE {
 *		SEQUENCE{ digestAlgorithm AlgorithmIdentifier, NULL }
 *		digest OCTET STRING
 *	}
 *
 * instead.  Sigh.
 */
static int
mkasn1(uchar *asn1, char *alg, uchar *d, uint dlen)
{
	uchar *obj, *p;
	uint olen;

	if(strcmp(alg, "sha1") == 0){
		obj = oidsha1;
		olen = sizeof(oidsha1);
	}else if(strcmp(alg, "md5") == 0){
		obj = oidmd5;
		olen = sizeof(oidmd5);
	}else{
		sysfatal("bad alg in mkasn1");
		return -1;
	}

	p = asn1;
	*p++ = 0x30;		/* sequence */
	p++;

	*p++ = 0x30;		/* another sequence */
	p++;

	*p++ = 0x06;		/* object id */
	*p++ = olen;
	memmove(p, obj, olen);
	p += olen;

	*p++ = 0x05;		/* null */
	*p++ = 0;

	asn1[3] = p - (asn1+4);	/* end of inner sequence */

	*p++ = 0x04;		/* octet string */
	*p++ = dlen;
	memmove(p, d, dlen);
	p += dlen;

	asn1[1] = p - (asn1+2);	/* end of outer sequence */
	return p - asn1;
}

static mpint*
mkdigest(RSApub *key, char *hashalg, uchar *hash, uint dlen)
{
	mpint *m;
	uchar asn1[512], *buf;
	int len, n, pad;

	/*
	 * Create ASN.1
	 */
	n = mkasn1(asn1, hashalg, hash, dlen);

	/*
	 * PKCS#1 padding
	 */
	len = (mpsignif(key-&gt;n)+7)/8 - 1;
	if(len &lt; n+2){
		werrstr("rsa key too short");
		return nil;
	}
	pad = len - (n+2);
	buf = emalloc(len);
	buf[0] = 0x01;
	memset(buf+1, 0xFF, pad);
	buf[1+pad] = 0x00;
	memmove(buf+1+pad+1, asn1, n);
	m = betomp(buf, len, nil);
	free(buf);
	return m;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

