<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/keyfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/keyfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * keyfs
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;authsrv.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;
#include "authcmdlib.h"

#pragma	varargck	type	"W"	char*

char authkey[8];

typedef struct Fid	Fid;
typedef struct User	User;

enum {
	Qroot,
	Quser,
	Qkey,
	Qsecret,
	Qlog,
	Qstatus,
	Qexpire,
	Qwarnings,
	Qmax,

	Nuser	= 512,
	MAXBAD	= 10,	/* max # of bad attempts before disabling the account */
	/* file must be randomly addressible, so names have fixed length */
	Namelen	= ANAMELEN,
};

enum {
	Sok,
	Sdisabled,
	Smax,
};

struct Fid {
	int	fid;
	ulong	qtype;
	User	*user;
	int	busy;
	Fid	*next;
};

struct User {
	char	*name;
	char	key[DESKEYLEN];
	char	secret[SECRETLEN];
	ulong	expire;			/* 0 == never */
	uchar	status;
	ulong	bad;		/* # of consecutive bad authentication attempts */
	int	ref;
	char	removed;
	uchar	warnings;
	long	purgatory;		/* time purgatory ends */
	ulong	uniq;
	User	*link;
};

char	*qinfo[Qmax] = {
	[Qroot]		"keys",
	[Quser]		".",
	[Qkey]		"key",
	[Qsecret]	"secret",
	[Qlog]		"log",
	[Qexpire]	"expire",
	[Qstatus]	"status",
	[Qwarnings]	"warnings",
};

char	*status[Smax] = {
	[Sok]		"ok",
	[Sdisabled]	"disabled",
};

Fid	*fids;
User	*users[Nuser];
char	*userkeys;
int	nuser;
ulong	uniq = 1;
Fcall	rhdr,
	thdr;
int	usepass;
char	*warnarg;
uchar	mdata[8192 + IOHDRSZ];
int	messagesize = sizeof mdata;

int	readusers(void);
ulong	hash(char*);
Fid	*findfid(int);
User	*finduser(char*);
User	*installuser(char*);
int	removeuser(User*);
void	insertuser(User*);
void	writeusers(void);
void	io(int, int);
void	*emalloc(ulong);
Qid	mkqid(User*, ulong);
int	dostat(User*, ulong, void*, int);
int	newkeys(void);
void	warning(void);
int	weirdfmt(Fmt *f);

char	*Auth(Fid*), *Attach(Fid*), *Version(Fid*),
	*Flush(Fid*), *Walk(Fid*),
	*Open(Fid*), *Create(Fid*),
	*Read(Fid *), *Write(Fid*), *Clunk(Fid*),
	*Remove(Fid *), *Stat(Fid*), *Wstat(Fid*);
char 	*(*fcalls[])(Fid*) = {
	[Tattach]	Attach,
	[Tauth]	Auth,
	[Tclunk]	Clunk,
	[Tcreate]	Create,
	[Tflush]	Flush,
	[Topen]		Open,
	[Tread]		Read,
	[Tremove]	Remove,
	[Tstat]		Stat,
	[Tversion]	Version,
	[Twalk]		Walk,
	[Twrite]	Write,
	[Twstat]	Wstat,
};

static void
usage(void)
{
	fprint(2, "usage: %s [-p] [-m mtpt] [-w warn] [keyfile]\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	char *mntpt;
	int p[2];

	fmtinstall('W', weirdfmt);
	mntpt = "/mnt/keys";
	ARGBEGIN{
	case 'm':
		mntpt = EARGF(usage());
		break;
	case 'p':
		usepass = 1;
		break;
	case 'w':
		warnarg = EARGF(usage());
		break;
	default:
		usage();
		break;
	}ARGEND
	argv0 = "keyfs";

	userkeys = "/adm/keys";
	if(argc &gt; 1)
		usage();
	if(argc == 1)
		userkeys = argv[0];

	if(pipe(p) &lt; 0)
		error("can't make pipe: %r");

	if(usepass) {
		getpass(authkey, nil, 0, 0);
	} else {
		if(!getauthkey(authkey))
			print("keyfs: warning: can't read NVRAM\n");
	}

	switch(rfork(RFPROC|RFNAMEG|RFNOTEG|RFNOWAIT|RFENVG|RFFDG)){
	case 0:
		close(p[0]);
		io(p[1], p[1]);
		exits(0);
	case -1:
		error("fork");
	default:
		close(p[1]);
		if(mount(p[0], -1, mntpt, MREPL|MCREATE, "") &lt; 0)
			error("can't mount: %r");
		exits(0);
	}
}

char *
Flush(Fid *f)
{
	USED(f);
	return 0;
}

char *
Auth(Fid *)
{
	return "keyfs: authentication not required";
}

char *
Attach(Fid *f)
{
	if(f-&gt;busy)
		Clunk(f);
	f-&gt;user = 0;
	f-&gt;qtype = Qroot;
	f-&gt;busy = 1;
	thdr.qid = mkqid(f-&gt;user, f-&gt;qtype);
	return 0;
}

char*
Version(Fid*)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			Clunk(f);
	if(rhdr.msize &gt; sizeof mdata)
		thdr.msize = sizeof mdata;
	else
		thdr.msize = rhdr.msize;
	messagesize = thdr.msize;
	if(strncmp(rhdr.version, "9P2000", 6) != 0)
		return "bad 9P version";
	thdr.version = "9P2000";
	return 0;
}

char *
Walk(Fid *f)
{
	char *name, *err;
	int i, j, max;
	Fid *nf;
	ulong qtype;
	User *user;

	if(!f-&gt;busy)
		return "walk of unused fid";
	nf = nil;
	qtype = f-&gt;qtype;
	user = f-&gt;user;
	if(rhdr.fid != rhdr.newfid){
		nf = findfid(rhdr.newfid);
		if(nf-&gt;busy)
			return "fid in use";
		f = nf;	/* walk f */
	}

	err = nil;
	i = 0;
	if(rhdr.nwname &gt; 0){
		for(; i&lt;rhdr.nwname; i++){
			if(i &gt;= MAXWELEM){
				err = "too many path name elements";
				break;
			}
			name = rhdr.wname[i];
			switch(qtype){
			case Qroot:
				if(strcmp(name, "..") == 0)
					goto Accept;
				user = finduser(name);
				if(!user)
					goto Out;
				qtype = Quser;

			Accept:
				thdr.wqid[i] = mkqid(user, qtype);
				break;

			case Quser:
				if(strcmp(name, "..") == 0) {
					qtype = Qroot;
					user = 0;
					goto Accept;
				}
				max = Qmax;
				for(j = Quser + 1; j &lt; Qmax; j++)
					if(strcmp(name, qinfo[j]) == 0){
						qtype = j;
						break;
					}
				if(j &lt; max)
					goto Accept;
				goto Out;

			default:
				err = "file is not a directory";
				goto Out;
			}
		}
	    Out:
		if(i &lt; rhdr.nwname &amp;&amp; err == nil)
			err = "file not found";
	}

	if(err != nil){
		return err;
	}

	/* if we cloned and then completed the walk, update new fid */
	if(rhdr.fid != rhdr.newfid &amp;&amp; i == rhdr.nwname){
		nf-&gt;busy = 1;
		nf-&gt;qtype = qtype;
		if(nf-&gt;user = user)
			nf-&gt;user-&gt;ref++;
	}else if(nf == nil &amp;&amp; rhdr.nwname &gt; 0){	/* walk without clone (rare) */
		Clunk(f);
		f-&gt;busy = 1;
		f-&gt;qtype = qtype;
		if(f-&gt;user = user)
			f-&gt;user-&gt;ref++;
	}

	thdr.nwqid = i;
	return 0;
}

char *
Clunk(Fid *f)
{
	f-&gt;busy = 0;
	if(f-&gt;user &amp;&amp; --f-&gt;user-&gt;ref == 0 &amp;&amp; f-&gt;user-&gt;removed) {
		free(f-&gt;user-&gt;name);
		free(f-&gt;user);
	}
	f-&gt;user = 0;
	return 0;
}

char *
Open(Fid *f)
{
	int mode;

	if(!f-&gt;busy)
		return "open of unused fid";
	mode = rhdr.mode;
	if(f-&gt;qtype == Quser &amp;&amp; (mode &amp; (OWRITE|OTRUNC)))
		return "user already exists";
	thdr.qid = mkqid(f-&gt;user, f-&gt;qtype);
	thdr.iounit = messagesize - IOHDRSZ;
	return 0;
}

char *
Create(Fid *f)
{
	char *name;
	long perm;

	if(!f-&gt;busy)
		return "create of unused fid";
	name = rhdr.name;
	if(f-&gt;user){
		return "permission denied";
	}else{
		perm = rhdr.perm;
		if(!(perm &amp; DMDIR))
			return "permission denied";
		if(strcmp(name, "") == 0)
			return "empty file name";
		if(strlen(name) &gt;= Namelen)
			return "file name too long";
		if(finduser(name))
			return "user already exists";
		f-&gt;user = installuser(name);
		f-&gt;user-&gt;ref++;
		f-&gt;qtype = Quser;
	}
	thdr.qid = mkqid(f-&gt;user, f-&gt;qtype);
	thdr.iounit = messagesize - IOHDRSZ;
	writeusers();
	return 0;
}

char *
Read(Fid *f)
{
	User *u;
	char *data;
	ulong off, n, m;
	int i, j, max;

	if(!f-&gt;busy)
		return "read of unused fid";
	n = rhdr.count;
	off = rhdr.offset;
	thdr.count = 0;
	data = thdr.data;
	switch(f-&gt;qtype){
	case Qroot:
		j = 0;
		for(i = 0; i &lt; Nuser; i++)
			for(u = users[i]; u; j += m, u = u-&gt;link){
				m = dostat(u, Quser, data, n);
				if(m &lt;= BIT16SZ)
					break;
				if(j &lt; off)
					continue;
				data += m;
				n -= m;
			}
		thdr.count = data - thdr.data;
		return 0;
	case Quser:
		max = Qmax;
		max -= Quser + 1;
		j = 0;
		for(i = 0; i &lt; max; j += m, i++){
			m = dostat(f-&gt;user, i + Quser + 1, data, n);
			if(m &lt;= BIT16SZ)
				break;
			if(j &lt; off)
				continue;
			data += m;
			n -= m;
		}
		thdr.count = data - thdr.data;
		return 0;
	case Qkey:
		if(f-&gt;user-&gt;status != Sok)
			return "user disabled";
		if(f-&gt;user-&gt;purgatory &gt; time(0))
			return "user in purgatory";
		if(f-&gt;user-&gt;expire != 0 &amp;&amp; f-&gt;user-&gt;expire &lt; time(0))
			return "user expired";
		if(off != 0)
			return 0;
		if(n &gt; DESKEYLEN)
			n = DESKEYLEN;
		memmove(thdr.data, f-&gt;user-&gt;key, n);
		thdr.count = n;
		return 0;
	case Qsecret:
		if(f-&gt;user-&gt;status != Sok)
			return "user disabled";
		if(f-&gt;user-&gt;purgatory &gt; time(0))
			return "user in purgatory";
		if(f-&gt;user-&gt;expire != 0 &amp;&amp; f-&gt;user-&gt;expire &lt; time(0))
			return "user expired";
		if(off != 0)
			return 0;
		if(n &gt; strlen(f-&gt;user-&gt;secret))
			n = strlen(f-&gt;user-&gt;secret);
		memmove(thdr.data, f-&gt;user-&gt;secret, n);
		thdr.count = n;
		return 0;
	case Qstatus:
		if(off != 0){
			thdr.count = 0;
			return 0;
		}
		if(f-&gt;user-&gt;status == Sok &amp;&amp; f-&gt;user-&gt;expire &amp;&amp; f-&gt;user-&gt;expire &lt; time(0))
			sprint(thdr.data, "expired\n");
		else
			sprint(thdr.data, "%s\n", status[f-&gt;user-&gt;status]);
		thdr.count = strlen(thdr.data);
		return 0;
	case Qexpire:
		if(off != 0){
			thdr.count = 0;
			return 0;
		}
		if(!f-&gt;user-&gt;expire)
			strcpy(data, "never\n");
		else
			sprint(data, "%lud\n", f-&gt;user-&gt;expire);
		if(n &gt; strlen(data))
			n = strlen(data);
		thdr.count = n;
		return 0;
	case Qlog:
		if(off != 0){
			thdr.count = 0;
			return 0;
		}
		sprint(data, "%lud\n", f-&gt;user-&gt;bad);
		if(n &gt; strlen(data))
			n = strlen(data);
		thdr.count = n;
		return 0;
	case Qwarnings:
		if(off != 0){
			thdr.count = 0;
			return 0;
		}
		sprint(data, "%ud\n", f-&gt;user-&gt;warnings);
		if(n &gt; strlen(data))
			n = strlen(data);
		thdr.count = n;
		return 0;
	default:
		return "permission denied: unknown qid";
	}
}

char *
Write(Fid *f)
{
	char *data, *p;
	ulong n, expire;
	int i;

	if(!f-&gt;busy)
		return "permission denied";
	n = rhdr.count;
	data = rhdr.data;
	switch(f-&gt;qtype){
	case Qkey:
		if(n != DESKEYLEN)
			return "garbled write data";
		memmove(f-&gt;user-&gt;key, data, DESKEYLEN);
		thdr.count = DESKEYLEN;
		break;
	case Qsecret:
		if(n &gt;= SECRETLEN)
			return "garbled write data";
		memmove(f-&gt;user-&gt;secret, data, n);
		f-&gt;user-&gt;secret[n] = 0;
		thdr.count = n;
		break;
	case Qstatus:
		data[n] = '\0';
		if(p = strchr(data, '\n'))
			*p = '\0';
		for(i = 0; i &lt; Smax; i++)
			if(strcmp(data, status[i]) == 0){
				f-&gt;user-&gt;status = i;
				break;
			}
		if(i == Smax)
			return "unknown status";
		f-&gt;user-&gt;bad = 0;
		thdr.count = n;
		break;
	case Qexpire:
		data[n] = '\0';
		if(p = strchr(data, '\n'))
			*p = '\0';
		else
			p = &amp;data[n];
		if(strcmp(data, "never") == 0)
			expire = 0;
		else{
			expire = strtoul(data, &amp;data, 10);
			if(data != p)
				return "bad expiration date";
		}
		f-&gt;user-&gt;expire = expire;
		f-&gt;user-&gt;warnings = 0;
		thdr.count = n;
		break;
	case Qlog:
		data[n] = '\0';
		if(strcmp(data, "good") == 0)
			f-&gt;user-&gt;bad = 0;
		else
			f-&gt;user-&gt;bad++;
		if(f-&gt;user-&gt;bad &amp;&amp; ((f-&gt;user-&gt;bad)%MAXBAD) == 0)
			f-&gt;user-&gt;purgatory = time(0) + f-&gt;user-&gt;bad;
		return 0;
	case Qwarnings:
		data[n] = '\0';
		f-&gt;user-&gt;warnings = strtoul(data, 0, 10);
		thdr.count = n;
		break;
	case Qroot:
	case Quser:
	default:
		return "permission denied";
	}
	writeusers();
	return 0;
}

char *
Remove(Fid *f)
{
	if(!f-&gt;busy)
		return "permission denied";
	if(f-&gt;qtype == Qwarnings)
		f-&gt;user-&gt;warnings = 0;
	else if(f-&gt;qtype == Quser)
		removeuser(f-&gt;user);
	else {
		Clunk(f);
		return "permission denied";
	}
	Clunk(f);
	writeusers();
	return 0;
}

char *
Stat(Fid *f)
{
	static uchar statbuf[1024];

	if(!f-&gt;busy)
		return "stat on unattached fid";
	thdr.nstat = dostat(f-&gt;user, f-&gt;qtype, statbuf, sizeof statbuf);
	if(thdr.nstat &lt;= BIT16SZ)
		return "stat buffer too small";
	thdr.stat = statbuf;
	return 0;
}

char *
Wstat(Fid *f)
{
	Dir d;
	int n;
	char buf[1024];

	if(!f-&gt;busy || f-&gt;qtype != Quser)
		return "permission denied";
	if(rhdr.nstat &gt; sizeof buf)
		return "wstat buffer too big";
	if(convM2D(rhdr.stat, rhdr.nstat, &amp;d, buf) == 0)
		return "bad stat buffer";
	n = strlen(d.name);
	if(n == 0 || n &gt;= Namelen)
		return "bad user name";
	if(finduser(d.name))
		return "user already exists";
	if(!removeuser(f-&gt;user))
		return "user previously removed";
	free(f-&gt;user-&gt;name);
	f-&gt;user-&gt;name = strdup(d.name);
	if(f-&gt;user-&gt;name == nil)
		error("wstat: malloc failed: %r");
	insertuser(f-&gt;user);
	writeusers();
	return 0;
}

Qid
mkqid(User *u, ulong qtype)
{
	Qid q;

	q.vers = 0;
	q.path = qtype;
	if(u)
		q.path |= u-&gt;uniq * 0x100;
	if(qtype == Quser || qtype == Qroot)
		q.type = QTDIR;
	else
		q.type = QTFILE;
	return q;
}

int
dostat(User *user, ulong qtype, void *p, int n)
{
	Dir d;

	if(qtype == Quser)
		d.name = user-&gt;name;
	else
		d.name = qinfo[qtype];
	d.uid = d.gid = d.muid = "auth";
	d.qid = mkqid(user, qtype);
	if(d.qid.type &amp; QTDIR)
		d.mode = 0777|DMDIR;
	else
		d.mode = 0666;
	d.atime = d.mtime = time(0);
	d.length = 0;
	return convD2M(&amp;d, p, n);
}

int
passline(Biobuf *b, void *vbuf)
{
	char *buf = vbuf;

	if(Bread(b, buf, KEYDBLEN) != KEYDBLEN)
		return 0;
	decrypt(authkey, buf, KEYDBLEN);
	buf[Namelen-1] = '\0';
	return 1;
}

void
randombytes(uchar *p, int len)
{
	int i, fd;

	fd = open("/dev/random", OREAD);
	if(fd &lt; 0){
		fprint(2, "keyfs: can't open /dev/random, using rand()\n");
		srand(time(0));
		for(i = 0; i &lt; len; i++)
			p[i] = rand();
		return;
	}
	read(fd, p, len);
	close(fd);
}

void
oldCBCencrypt(char *key7, uchar *p, int len)
{
	uchar ivec[8];
	uchar key[8];
	DESstate s;

	memset(ivec, 0, 8);
	des56to64((uchar*)key7, key);
	setupDESstate(&amp;s, key, ivec);
	desCBCencrypt((uchar*)p, len, &amp;s);
}

void
oldCBCdecrypt(char *key7, uchar *p, int len)
{
	uchar ivec[8];
	uchar key[8];
	DESstate s;

	memset(ivec, 0, 8);
	des56to64((uchar*)key7, key);
	setupDESstate(&amp;s, key, ivec);
	desCBCdecrypt((uchar*)p, len, &amp;s);

}

void
writeusers(void)
{
	int fd, i, nu;
	User *u;
	uchar *p, *buf;
	ulong expire;

	/* count users */
	nu = 0;
	for(i = 0; i &lt; Nuser; i++)
		for(u = users[i]; u; u = u-&gt;link)
			nu++;

	/* pack into buffer */
	buf = malloc(KEYDBOFF + nu*KEYDBLEN);
	if(buf == 0){
		fprint(2, "keyfs: can't write keys file, out of memory\n");
		return;
	}
	p = buf;
	randombytes(p, KEYDBOFF);
	p += KEYDBOFF;
	for(i = 0; i &lt; Nuser; i++)
		for(u = users[i]; u; u = u-&gt;link){
			strncpy((char*)p, u-&gt;name, Namelen);
			p += Namelen;
			memmove(p, u-&gt;key, DESKEYLEN);
			p += DESKEYLEN;
			*p++ = u-&gt;status;
			*p++ = u-&gt;warnings;
			expire = u-&gt;expire;
			*p++ = expire;
			*p++ = expire &gt;&gt; 8;
			*p++ = expire &gt;&gt; 16;
			*p++ = expire &gt;&gt; 24;
			memmove(p, u-&gt;secret, SECRETLEN);
			p += SECRETLEN;
		}

	/* encrypt */
	oldCBCencrypt(authkey, buf, p - buf);

	/* write file */
	fd = create(userkeys, OWRITE, 0660);
	if(fd &lt; 0){
		free(buf);
		fprint(2, "keyfs: can't write keys file\n");
		return;
	}
	if(write(fd, buf, p - buf) != (p - buf))
		fprint(2, "keyfs: can't write keys file\n");

	free(buf);
	close(fd);
}

int
weirdfmt(Fmt *f)
{
	char *s, *p, *ep, buf[ANAMELEN*4 + 1];
	int i, n;
	Rune r;

	s = va_arg(f-&gt;args, char*);
	p = buf;
	ep = buf + sizeof buf;
	for(i = 0; i &lt; ANAMELEN; i += n){
		n = chartorune(&amp;r, s + i);
		if(r == Runeerror)
			p = seprint(p, ep, "[%.2x]", buf[i]);
		else if(isascii(r) &amp;&amp; iscntrl(r))
			p = seprint(p, ep, "[%.2x]", r);
		else if(r == ' ' || r == '/')
			p = seprint(p, ep, "[%c]", r);
		else
			p = seprint(p, ep, "%C", r);
	}
	return fmtstrcpy(f, buf);
}

int
userok(char *user, int nu)
{
	int i, n, rv;
	Rune r;
	char buf[ANAMELEN+1];

	memset(buf, 0, sizeof buf);
	memmove(buf, user, ANAMELEN);

	if(buf[ANAMELEN-1] != 0){
		fprint(2, "keyfs: %d: no termination: %W\n", nu, buf);
		return -1;
	}

	rv = 0;
	for(i = 0; buf[i]; i += n){
		n = chartorune(&amp;r, buf+i);
		if(r == Runeerror){
//			fprint(2, "keyfs: name %W bad rune byte %d\n", buf, i);
			rv = -1;
		} else if(isascii(r) &amp;&amp; iscntrl(r) || r == ' ' || r == '/'){
//			fprint(2, "keyfs: name %W bad char %C\n", buf, r);
			rv = -1;
		}
	}

	if(i == 0){
		fprint(2, "keyfs: %d: nil name\n", nu);
		return -1;
	}
	if(rv == -1)
		fprint(2, "keyfs: %d: bad syntax: %W\n", nu, buf);
	return rv;
}

int
readusers(void)
{
	int fd, i, n, nu;
	uchar *p, *buf, *ep;
	User *u;
	Dir *d;

	/* read file into an array */
	fd = open(userkeys, OREAD);
	if(fd &lt; 0)
		return 0;
	d = dirfstat(fd);
	if(d == nil){
		close(fd);
		return 0;
	}
	buf = malloc(d-&gt;length);
	if(buf == 0){
		close(fd);
		free(d);
		return 0;
	}
	n = readn(fd, buf, d-&gt;length);
	close(fd);
	free(d);
	if(n != d-&gt;length){
		free(buf);
		return 0;
	}

	/* decrypt */
	n -= n % KEYDBLEN;
	oldCBCdecrypt(authkey, buf, n);

	/* unpack */
	nu = 0;
	for(i = KEYDBOFF; i &lt; n; i += KEYDBLEN){
		ep = buf + i;
		if(userok((char*)ep, i/KEYDBLEN) &lt; 0)
			continue;
		u = finduser((char*)ep);
		if(u == 0)
			u = installuser((char*)ep);
		memmove(u-&gt;key, ep + Namelen, DESKEYLEN);
		p = ep + Namelen + DESKEYLEN;
		u-&gt;status = *p++;
		u-&gt;warnings = *p++;
		if(u-&gt;status &gt;= Smax)
			fprint(2, "keyfs: warning: bad status in key file\n");
		u-&gt;expire = p[0] + (p[1]&lt;&lt;8) + (p[2]&lt;&lt;16) + (p[3]&lt;&lt;24);
		p += 4;
		memmove(u-&gt;secret, p, SECRETLEN);
		u-&gt;secret[SECRETLEN-1] = 0;
		nu++;
	}
	free(buf);

	print("%d keys read\n", nu);
	return 1;
}

User *
installuser(char *name)
{
	User *u;
	int h;

	h = hash(name);
	u = emalloc(sizeof *u);
	u-&gt;name = strdup(name);
	if(u-&gt;name == nil)
		error("malloc failed: %r");
	u-&gt;removed = 0;
	u-&gt;ref = 0;
	u-&gt;purgatory = 0;
	u-&gt;expire = 0;
	u-&gt;status = Sok;
	u-&gt;bad = 0;
	u-&gt;warnings = 0;
	u-&gt;uniq = uniq++;
	u-&gt;link = users[h];
	users[h] = u;
	return u;
}

User *
finduser(char *name)
{
	User *u;

	for(u = users[hash(name)]; u; u = u-&gt;link)
		if(strcmp(name, u-&gt;name) == 0)
			return u;
	return 0;
}

int
removeuser(User *user)
{
	User *u, **last;
	char *name;

	user-&gt;removed = 1;
	name = user-&gt;name;
	last = &amp;users[hash(name)];
	for(u = *last; u; u = *last){
		if(strcmp(name, u-&gt;name) == 0){
			*last = u-&gt;link;
			return 1;
		}
		last = &amp;u-&gt;link;
	}
	return 0;
}

void
insertuser(User *user)
{
	int h;

	user-&gt;removed = 0;
	h = hash(user-&gt;name);
	user-&gt;link = users[h];
	users[h] = user;
}

ulong
hash(char *s)
{
	ulong h;

	h = 0;
	while(*s)
		h = (h &lt;&lt; 1) ^ *s++;
	return h % Nuser;
}

Fid *
findfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;busy = 0;
	f-&gt;user = 0;
	f-&gt;next = fids;
	fids = f;
	return f;
}

void
io(int in, int out)
{
	char *err;
	int n;
	long now, lastwarning;

	/* after restart, let the system settle for 5 mins before warning */
	lastwarning = time(0) - 24*60*60 + 5*60;

	for(;;){
		n = read9pmsg(in, mdata, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0)
			error("mount read %d", n);
		if(convM2S(mdata, n, &amp;rhdr) == 0)
			continue;

		if(newkeys())
			readusers();

		thdr.data = (char*)mdata + IOHDRSZ;
		thdr.fid = rhdr.fid;
		if(!fcalls[rhdr.type])
			err = "fcall request";
		else
			err = (*fcalls[rhdr.type])(findfid(rhdr.fid));
		thdr.tag = rhdr.tag;
		thdr.type = rhdr.type+1;
		if(err){
			thdr.type = Rerror;
			thdr.ename = err;
		}
		n = convS2M(&amp;thdr, mdata, messagesize);
		if(write(out, mdata, n) != n)
			error("mount write");

		now = time(0);
		if(warnarg &amp;&amp; (now - lastwarning &gt; 24*60*60)){
			syslog(0, "auth", "keyfs starting warnings: %lux %lux",
				now, lastwarning);
			warning();
			lastwarning = now;
		}
	}
}

int
newkeys(void)
{
	Dir *d;
	static long ftime;

	d = dirstat(userkeys);
	if(d == nil)
		return 0;
	if(d-&gt;mtime &gt; ftime){
		ftime = d-&gt;mtime;
		free(d);
		return 1;
	}
	free(d);
	return 0;
}

void *
emalloc(ulong n)
{
	void *p;

	if(p = malloc(n))
		return p;
	error("out of memory");
	return 0;		/* not reached */
}

void
warning(void)
{
	int i;
	char buf[64];

	snprint(buf, sizeof buf, "-%s", warnarg);
	switch(rfork(RFPROC|RFNAMEG|RFNOTEG|RFNOWAIT|RFENVG|RFFDG)){
	case 0:
		i = open("/sys/log/auth", OWRITE);
		if(i &gt;= 0){
			dup(i, 2);
			seek(2, 0, 2);
			close(i);
		}
		execl("/bin/auth/warning", "warning", warnarg, nil);
		error("can't exec warning");
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

