<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/secstore/SConn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/secstore/SConn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;
#include "SConn.h"

extern int verbose;

typedef struct ConnState {
	uchar secret[SHA1dlen];
	ulong seqno;
	RC4state rc4;
} ConnState;

typedef struct SS{
	int fd;		// file descriptor for read/write of encrypted data
	int alg;	// if nonzero, "alg sha rc4_128"
	ConnState in, out;
} SS;

static int
SC_secret(SConn *conn, uchar *sigma, int direction)
{
	SS *ss = (SS*)(conn-&gt;chan);
	int nsigma = conn-&gt;secretlen;

	if(direction != 0){
		hmac_sha1(sigma, nsigma, (uchar*)"one", 3, ss-&gt;out.secret, nil);
		hmac_sha1(sigma, nsigma, (uchar*)"two", 3, ss-&gt;in.secret, nil);
	}else{
		hmac_sha1(sigma, nsigma, (uchar*)"two", 3, ss-&gt;out.secret, nil);
		hmac_sha1(sigma, nsigma, (uchar*)"one", 3, ss-&gt;in.secret, nil);
	}
	setupRC4state(&amp;ss-&gt;in.rc4, ss-&gt;in.secret, 16); // restrict to 128 bits
	setupRC4state(&amp;ss-&gt;out.rc4, ss-&gt;out.secret, 16);
	ss-&gt;alg = 1;
	return 0;
}

static void
hash(uchar secret[SHA1dlen], uchar *data, int len, int seqno, uchar d[SHA1dlen])
{
	DigestState sha;
	uchar seq[4];

	seq[0] = seqno&gt;&gt;24;
	seq[1] = seqno&gt;&gt;16;
	seq[2] = seqno&gt;&gt;8;
	seq[3] = seqno;
	memset(&amp;sha, 0, sizeof sha);
	sha1(secret, SHA1dlen, nil, &amp;sha);
	sha1(data, len, nil, &amp;sha);
	sha1(seq, 4, d, &amp;sha);
}

static int
verify(uchar secret[SHA1dlen], uchar *data, int len, int seqno, uchar d[SHA1dlen])
{
	DigestState sha;
	uchar seq[4];
	uchar digest[SHA1dlen];

	seq[0] = seqno&gt;&gt;24;
	seq[1] = seqno&gt;&gt;16;
	seq[2] = seqno&gt;&gt;8;
	seq[3] = seqno;
	memset(&amp;sha, 0, sizeof sha);
	sha1(secret, SHA1dlen, nil, &amp;sha);
	sha1(data, len, nil, &amp;sha);
	sha1(seq, 4, digest, &amp;sha);
	return memcmp(d, digest, SHA1dlen);
}

static int
SC_read(SConn *conn, uchar *buf, int n)
{
	SS *ss = (SS*)(conn-&gt;chan);
	uchar count[2], digest[SHA1dlen];
	int len, nr;

	if(read(ss-&gt;fd, count, 2) != 2 || (count[0]&amp;0x80) == 0){
		snprint((char*)buf,n,"!SC_read invalid count");
		return -1;
	}
	len = (count[0]&amp;0x7f)&lt;&lt;8 | count[1];	// SSL-style count; no pad
	if(ss-&gt;alg){
		len -= SHA1dlen;
		if(len &lt;= 0 || readn(ss-&gt;fd, digest, SHA1dlen) != SHA1dlen){
			snprint((char*)buf,n,"!SC_read missing sha1");
			return -1;
		}
		if(len &gt; n || readn(ss-&gt;fd, buf, len) != len){
			snprint((char*)buf,n,"!SC_read missing data");
			return -1;
		}
		rc4(&amp;ss-&gt;in.rc4, digest, SHA1dlen);
		rc4(&amp;ss-&gt;in.rc4, buf, len);
		if(verify(ss-&gt;in.secret, buf, len, ss-&gt;in.seqno, digest) != 0){
			snprint((char*)buf,n,"!SC_read integrity check failed");
			return -1;
		}
	}else{
		if(len &lt;= 0 || len &gt; n){
			snprint((char*)buf,n,"!SC_read implausible record length");
			return -1;
		}
		if( (nr = readn(ss-&gt;fd, buf, len)) != len){
			snprint((char*)buf,n,"!SC_read expected %d bytes, but got %d", len, nr);
			return -1;
		}
	}
	ss-&gt;in.seqno++;
	return len;
}

static int
SC_write(SConn *conn, uchar *buf, int n)
{
	SS *ss = (SS*)(conn-&gt;chan);
	uchar count[2], digest[SHA1dlen], enc[Maxmsg+1];
	int len;

	if(n &lt;= 0 || n &gt; Maxmsg+1){
		werrstr("!SC_write invalid n %d", n);
		return -1;
	}
	len = n;
	if(ss-&gt;alg)
		len += SHA1dlen;
	count[0] = 0x80 | len&gt;&gt;8;
	count[1] = len;
	if(write(ss-&gt;fd, count, 2) != 2){
		werrstr("!SC_write invalid count");
		return -1;
	}
	if(ss-&gt;alg){
		hash(ss-&gt;out.secret, buf, n, ss-&gt;out.seqno, digest);
		rc4(&amp;ss-&gt;out.rc4, digest, SHA1dlen);
		memcpy(enc, buf, n);
		rc4(&amp;ss-&gt;out.rc4, enc, n);
		if(write(ss-&gt;fd, digest, SHA1dlen) != SHA1dlen ||
				write(ss-&gt;fd, enc, n) != n){
			werrstr("!SC_write error on send");
			return -1;
		}
	}else{
		if(write(ss-&gt;fd, buf, n) != n){
			werrstr("!SC_write error on send");
			return -1;
		}
	}
	ss-&gt;out.seqno++;
	return n;
}

static void
SC_free(SConn *conn)
{
	SS *ss = (SS*)(conn-&gt;chan);

	close(ss-&gt;fd);
	free(ss);
	free(conn);
}

SConn*
newSConn(int fd)
{
	SS *ss;
	SConn *conn;

	if(fd &lt; 0)
		return nil;
	ss = (SS*)emalloc(sizeof(*ss));
	conn = (SConn*)emalloc(sizeof(*conn));
	ss-&gt;fd  = fd;
	ss-&gt;alg = 0;
	conn-&gt;chan = (void*)ss;
	conn-&gt;secretlen = SHA1dlen;
	conn-&gt;free = SC_free;
	conn-&gt;secret = SC_secret;
	conn-&gt;read = SC_read;
	conn-&gt;write = SC_write;
	return conn;
}

void
writerr(SConn *conn, char *s)
{
	char buf[Maxmsg];

	snprint(buf, Maxmsg, "!%s", s);
	conn-&gt;write(conn, (uchar*)buf, strlen(buf));
}

int
readstr(SConn *conn, char *s)
{
	int n;

	n = conn-&gt;read(conn, (uchar*)s, Maxmsg);
	if(n &gt;= 0){
		s[n] = 0;
		if(s[0] == '!'){
			memmove(s, s+1, n);
			n = -1;
		}
	}else{
		strcpy(s, "connection read error");
	}
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

