<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/secstore/password.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/secstore/password.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* password.c */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;
#include "SConn.h"
#include "secstore.h"

static Biobuf*
openPW(char *id, int mode)
{
	int nfn = strlen(SECSTORE_DIR)+strlen(id)+20;
	char *fn;
	Biobuf *b;

	if(validatefile(id) == nil || strcmp(id,".") == 0)
		return nil;
	fn = emalloc(nfn);
	snprint(fn, nfn, "%s/who/%s", SECSTORE_DIR, id);
	b = Bopen(fn, mode);
	free(fn);
	return b;
}

static ulong
mtimePW(char *id)
{
	ulong mt;
	char *fn;
	Dir *d;

	fn = smprint("%s/who/%s", SECSTORE_DIR, id);
	d = dirstat(fn);
	mt = (d? d-&gt;mtime: 0);
	free(d);
	free(fn);
	return mt;
}

PW *
getPW(char *id, int dead_or_alive)
{
	ulong now = time(0);
	char *f1, *f2, *oid;		/* fields 1, 2 = attribute, value */
	Biobuf *bin;
	PW *pw;

	oid = id;
	if((bin = openPW(id, OREAD)) == 0){
		id = "FICTITIOUS";
		if((bin = openPW(id, OREAD)) == 0){
			werrstr("accounts %s and FICTITIOUS do not exist", oid);
			return nil;
		}
	}
	pw = emalloc(sizeof *pw);
	pw-&gt;id = estrdup(id);
	pw-&gt;status |= Enabled;
	while( (f1 = Brdline(bin, '\n')) != 0){
		f1[Blinelen(bin)-1] = 0;
		for(f2 = f1; *f2 &amp;&amp; *f2 != ' ' &amp;&amp; *f2 != '\t'; f2++)
			;
		if(*f2)
			for(*f2++ = 0; *f2 &amp;&amp; (*f2==' ' || *f2=='\t'); f2++)
				;
		if(strcmp(f1, "exp") == 0)
			pw-&gt;expire = strtoul(f2, 0, 10);
		else if(strcmp(f1, "DISABLED") == 0)
			pw-&gt;status &amp;= ~Enabled;
		else if(strcmp(f1, "STA") == 0)
			pw-&gt;status |= STA;
		else if(strcmp(f1, "failed") == 0)
			pw-&gt;failed = strtoul(f2, 0, 10);
		else if(strcmp(f1, "other") == 0)
			pw-&gt;other = estrdup(f2);
		else if(strcmp(f1, "PAK-Hi") == 0)
			pw-&gt;Hi = strtomp(f2, nil, 64, nil);
	}
	Bterm(bin);
	if(pw-&gt;Hi == nil){
		werrstr("corrupted account file for %s", pw-&gt;id);
		freePW(pw);
		return nil;
	}
	if(dead_or_alive)
		return pw;  /* return for editing, whether valid now or not */
	if(pw-&gt;expire != 0 &amp;&amp; pw-&gt;expire &lt;= now){
		/* %.28s excludes ctime's newline */
		werrstr("account %s expired at %.28s", pw-&gt;id,
			ctime(pw-&gt;expire));
		freePW(pw);
		return nil;
	}
	if((pw-&gt;status &amp; Enabled) == 0){
		werrstr("account %s disabled", pw-&gt;id);
		freePW(pw);
		return nil;
	}
	if(pw-&gt;failed &lt; 10)
		return pw;	/* success */
	if(now &lt; mtimePW(id)+300){
		werrstr("too many failures; try again in five minutes");
		freePW(pw);
		return nil;
	}
	pw-&gt;failed = 0;
	putPW(pw);	/* reset failed-login-counter after five minutes */
	return pw;
}

int
putPW(PW *pw)
{
	Biobuf *bout;
	char *hexHi;

	if((bout = openPW(pw-&gt;id, OWRITE|OTRUNC)) ==0){
		werrstr("can't open PW file for %s", pw-&gt;id);
		return -1;
	}
	Bprint(bout, "exp	%lud\n", pw-&gt;expire);
	if(!(pw-&gt;status &amp; Enabled))
		Bprint(bout, "DISABLED\n");
	if(pw-&gt;status &amp; STA)
		Bprint(bout, "STA\n");
	if(pw-&gt;failed)
		Bprint(bout, "failed\t%d\n", pw-&gt;failed);
	if(pw-&gt;other)
		Bprint(bout,"other\t%s\n", pw-&gt;other);
	hexHi = mptoa(pw-&gt;Hi, 64, nil, 0);
	Bprint(bout, "PAK-Hi\t%s\n", hexHi);
	free(hexHi);
	return 0;
}

void
freePW(PW *pw)
{
	if(pw == nil)
		return;
	free(pw-&gt;id);
	free(pw-&gt;other);
	mpfree(pw-&gt;Hi);
	free(pw);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

