<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/8prefix.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/8prefix.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Pre-resolve references inside an object file.
 * Mark such functions static so that linking with
 * other object files can't get at them.
 * Also rename "main".
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "/sys/src/cmd/8c/8.out.h"

typedef struct Sym Sym;
struct Sym
{
	char *name;
	char *newname;
	short type;
	short version;
	Sym *link;
};

typedef struct Obj Obj;
struct Obj
{
	int fd;
	int version;
	uchar *bp;
	uchar *ep;
	char *name;
};

enum
{
	NHASH = 10007
};

Sym *hash[NHASH];
int nsymbol;
int renamemain = 1;
Sym *xsym[256];
int version = 1;
Obj **obj;
int nobj;
Biobuf bout;
char *prefix;
int verbose;

void *emalloc(ulong);
Sym *lookup(char*, int);
Obj *openobj(char*);
void walkobj(Obj*, void (*fn)(int, Sym*, uchar*, int));
void walkobjs(void (*fn)(int, Sym*, uchar*, int));
void dump(int, Sym*, uchar*, int);
void nop(int, Sym*, uchar*, int);
void owrite(int, Sym*, uchar*, int);
int zaddr(uchar*, Sym**);
void renamesyms(int, Sym*, uchar*, int);

void
usage(void)
{
	fprint(2, "usage: 8prelink [-mv] prefix file.8...\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i;
	Obj *o;

	ARGBEGIN{
	case 'm':
		renamemain = 0;
		break;
	case 'v':
		verbose = 1;
		break;
	default:
		usage();
	}ARGEND
	
	if(argc &lt; 2)
		usage();
	
	prefix = argv[0];
	argv++;
	argc--;

	nobj = argc;
	obj = emalloc(nobj*sizeof obj[0]);
	for(i=0; i&lt;argc; i++)
		obj[i] = openobj(argv[i]);

	walkobjs(nop);	/* initialize symbol table */
	if(verbose)
		walkobjs(dump);
	walkobjs(renamesyms);
	
	for(i=0; i&lt;nobj; i++){
		o = obj[i];
		seek(o-&gt;fd, 0, 0);
		Binit(&amp;bout, o-&gt;fd, OWRITE);
		walkobj(o, owrite);
		Bflush(&amp;bout);
	}
	exits(0);
}

void
renamesyms(int op, Sym *sym, uchar*, int)
{
	if(sym &amp;&amp; sym-&gt;version==0 &amp;&amp; !sym-&gt;newname)
	switch(op){
	case AGLOBL:
	case AINIT:
	case ADATA:
	case ATEXT:
		if(!renamemain &amp;&amp; strcmp(sym-&gt;name, "main") == 0)
			break;
		sym-&gt;newname = smprint("%s%s", prefix, sym-&gt;name);
		break;
	}	
}

void
dump(int op, Sym *sym, uchar*, int)
{
	if(sym &amp;&amp; sym-&gt;version==0)
	switch(op){
	case AGLOBL:
	case AINIT:
	case ADATA:
	case ATEXT:
		print("%s\n", sym-&gt;name);
		break;
	}	
}

void
nop(int, Sym*, uchar*, int)
{
}

void
owrite(int op, Sym *sym, uchar *p, int l)
{
	switch(op){
	case ASIGNAME:
		Bwrite(&amp;bout, p, 4);
		p += 4;
		l -= 4;
	case ANAME:
		if(sym-&gt;newname){
			Bwrite(&amp;bout, p, 4);
			Bwrite(&amp;bout, sym-&gt;newname, strlen(sym-&gt;newname)+1);
			break;
		}
	default:
		Bwrite(&amp;bout, p, l);
		break;
	}
}

int
zaddr(uchar *p, Sym **symp)
{
	int c, t;
	
	t = p[0];
	c = 1;
	if(t &amp; T_INDEX)
		c += 2;
	if(t &amp; T_OFFSET)
		c += 4;
	if(t &amp; T_SYM){
		if(symp)
			*symp = xsym[p[c]];
		c++;
	}
	if(t &amp; T_FCONST)
		c += 8;
	else if(t &amp; T_SCONST)
		c += NSNAME;
	if(t &amp; T_TYPE)
		c++;
	return c;
}

void*
emalloc(ulong n)
{
	void *v;
	
	v = mallocz(n, 1);
	if(v == nil)
		sysfatal("out of memory");
	return v;
}

Sym*
lookup(char *symb, int v)
{
	Sym *s;
	char *p;
	long h;
	int l, c;

	h = v;
	for(p=symb; c = *p; p++)
		h = h+h+h + c;
	l = (p - symb) + 1;
	if(h &lt; 0)
		h = ~h;
	h %= NHASH;
	for(s = hash[h]; s != nil; s = s-&gt;link)
		if(s-&gt;version == v)
		if(memcmp(s-&gt;name, symb, l) == 0)
			return s;

	s = emalloc(sizeof *s);
	s-&gt;name = emalloc(l + 1);
	memmove(s-&gt;name, symb, l);

	s-&gt;link = hash[h];
	s-&gt;type = 0;
	s-&gt;version = v;
	hash[h] = s;
	nsymbol++;
	return s;
}

Obj*
openobj(char *name)
{
	Dir *d;
	Obj *obj;
	
	obj = emalloc(sizeof *obj);
	obj-&gt;name = name;
	obj-&gt;version = version++;
	if((obj-&gt;fd = open(name, ORDWR)) &lt; 0)
		sysfatal("open %s: %r", name);
	if((d = dirfstat(obj-&gt;fd)) == nil)
		sysfatal("dirfstat: %r");
	obj-&gt;bp = emalloc(d-&gt;length);
	if(readn(obj-&gt;fd, obj-&gt;bp, d-&gt;length) != d-&gt;length)
		sysfatal("read %s: %r", name);
	obj-&gt;ep = obj-&gt;bp+d-&gt;length;
	return obj;
}

void
walkobjs(void (*fn)(int, Sym*, uchar*, int))
{
	int i;
	
	for(i=0; i&lt;nobj; i++)
		walkobj(obj[i], fn);
}

void
walkobj(Obj *obj, void (*fn)(int, Sym*, uchar*, int))
{
	int op, type;
	Sym *sym;
	uchar *p, *p0;

	for(p=obj-&gt;bp; p+4&lt;=obj-&gt;ep; ){
		op = p[0] | (p[1]&lt;&lt;8);
		if(op &lt;= AXXX || op &gt;= ALAST)
			sysfatal("%s: opcode out of range - probably not a .8 file", obj-&gt;name);
		p0 = p;
		switch(op){
		case ASIGNAME:
			p += 4;	/* sign */
		case ANAME:
			type = p[2];
			sym = lookup((char*)p+4, type==D_STATIC ? obj-&gt;version : 0);
			xsym[p[3]] = sym;
			p += 4+strlen(sym-&gt;name)+1;
			fn(op, sym, p0, p-p0);
			break;
		
		default:
			p += 6;
			p += zaddr(p, &amp;sym);
			p += zaddr(p, nil);
			fn(op, sym, p0, p-p0);
			break;
		}
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

