<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/acidleak.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/acidleak.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

void*
emalloc(ulong sz)
{
	void *v;

	v = malloc(sz);
	if(v == nil)
		sysfatal("malloc %lud fails", sz);
	memset(v, 0, sz);
	return v;
}

void*
erealloc(void *v, ulong sz)
{
	v = realloc(v, sz);
	if(v == nil)
		sysfatal("realloc %lud fails", sz);
	return v;
}

char*
estrdup(char* s)
{
	char *r;

	r = strdup(s);
	if(r == nil)
		sysfatal("strdup fails");
	return r;
}

typedef struct Block Block;
typedef struct Data Data;
struct Block {
	ulong addr;
	ulong size;
	ulong w0;
	ulong w1;
	char *s0;
	char *s1;
	int mark;
	int free;
	Data *d;
};

struct Data {
	ulong addr;
	ulong val;
	uchar type;
	Block *b;
};

Block *block;
uint nblock;
uint ablock;

Data *data;
Data *edata;
uint ndata;
uint adata;

int
addrcmp(void *va, void *vb)
{
	ulong *a, *b;

	a = va;
	b = vb;
	if(*a &lt; *b)
		return -1;
	if(*a &gt; *b)
		return 1;
	return 0;
}

Block*
findblock(ulong addr)
{
	int lo, hi, m;

	lo = 0;
	hi = nblock;

	while(lo &lt; hi) {
		m = (lo+hi)/2;
		if(block[m].addr &lt; addr)
			lo = m+1;
		else if(addr &lt; block[m].addr)
			hi = m;
		else
			return &amp;block[m];
	}
	return nil;
}

Data*
finddata(ulong addr)
{
	int lo, hi, m;

	lo = 0;
	hi = ndata;

	while(lo &lt; hi) {
		m = (lo+hi)/2;
		if(data[m].addr &lt; addr)
			lo = m+1;
		else if(addr &lt; data[m].addr)
			hi = m;
		else
			return &amp;data[m];
	}
	if(0 &lt;= lo &amp;&amp; lo &lt; ndata)
		return &amp;data[lo];
	return nil;
}

int nmark;

int
markblock(ulong from, ulong fromval, Block *b)
{
	Data *d;
	ulong top;
	Block *nb;

USED(from, fromval);
//print("trace 0x%.8lux from 0x%.8lux (%d)\n", b-&gt;addr, from, b-&gt;mark);
	if(b-&gt;free){
	//	fprint(2, "possible dangling pointer *0x%.8lux = 0x%.8lux\n", from, fromval);
		return 0;
	}
	if(b-&gt;mark)
		return 0;
	b-&gt;mark = 1;
	nmark++;

	if(d = finddata(b-&gt;addr)) {
		assert(d-&gt;addr &gt;= b-&gt;addr);
		b-&gt;d = d;
		top = b-&gt;addr+b-&gt;size;
		for(; d &lt; edata &amp;&amp; d-&gt;addr &lt; top; d++) {
			assert(d-&gt;b == 0);
			d-&gt;b = b;
			if((nb = findblock(d-&gt;val-8)) || (nb = findblock(d-&gt;val-8-8)))
				markblock(d-&gt;addr, d-&gt;val, nb);
		}
		return 1;
	}
	return 0;
}

enum {
	AllocColor = 2,	// dark blue: completely allocated region
	HdrColor = 54,		// bright blue: region with header
	LeakColor = 205,	// dark red: region with leak
	LeakHdrColor = 240,	// bright red: region with leaked header
	FreeColor = 252,	// bright yellow: completely free region
	NoColor = 255,		// padding, white
};

int
rXr(int as, int ae, int bs, int be)
{
	return bs &lt; ae &amp;&amp; as &lt; be;
}

void
main(int argc, char **argv)
{
	Biobuf bio;
	char *p, *f[10];
	int bitmap, c, nf, resolution, n8, n16, hdr, nhdr, nlhdr, nleak, x, y, nb;
	ulong allocstart, allocend, len, u;
	Data *d, *ed;
	Block *b, *eb;

	bitmap = 0;
	resolution = 8;
	x = 512;
	ARGBEGIN{
	case 'b':
		bitmap=1;
		break;
	case 'r':
		resolution = atoi(EARGF(sysfatal("usage")));
		break;
	case 'x':
		x = atoi(EARGF(sysfatal("usage")));
		break;
	}ARGEND

	n8 = n16 = 0;
	allocstart = allocend = 0;
	Binit(&amp;bio, 0, OREAD);
	while(p=Brdline(&amp;bio, '\n')) {
		p[Blinelen(&amp;bio)-1] = '\0';
		nf = tokenize(p, f, nelem(f));
		if(nf &gt;= 4 &amp;&amp; strcmp(f[0], "data") == 0) {
			if(ndata &gt;= adata){
				if(adata == 0)
					adata = 4096;
				else
					adata += adata / 4;  /* increase 25% */
				data = erealloc(data, adata * sizeof(Data));
			}
			data[ndata].addr = strtoul(f[1], nil, 0);
			data[ndata].val = strtoul(f[2], nil, 0);
			data[ndata].type = f[3][0];
			data[ndata].b = 0;
			ndata++;
		}
		if(nf &gt;= 5 &amp;&amp;
		    (strcmp(f[0], "block") == 0 || strcmp(f[0], "free") == 0)) {
			if(nblock &gt;= ablock){
				if(ablock == 0)
					ablock = 4096;
				else
					ablock += ablock / 4; /* increase 25% */
				block = erealloc(block, ablock * sizeof(Block));
			}
			block[nblock].addr = strtoul(f[1], nil, 0);
			block[nblock].size = strtoul(f[2], nil, 0);
			block[nblock].w0 = strtoul(f[3], nil, 0);
			block[nblock].w1 = strtoul(f[4], nil, 0);
			if (nf &gt;= 7) {
				block[nblock].s0 = estrdup(f[5]);
				block[nblock].s1 = estrdup(f[6]);
			} else {
				block[nblock].s0 = "";
				block[nblock].s1 = "";
			}
			block[nblock].mark = 0;
			block[nblock].d = 0;
			block[nblock].free = strcmp(f[0], "free") == 0;
			nblock++;
		}
		if(nf &gt;= 4 &amp;&amp; strcmp(f[0], "range") == 0 &amp;&amp; strcmp(f[1], "alloc") == 0) {
			allocstart = strtoul(f[2], 0, 0)&amp;~15;
			allocend = strtoul(f[3], 0, 0);
		}
	}

	qsort(block, nblock, sizeof(Block), addrcmp);
	qsort(data, ndata, sizeof(Data), addrcmp);

	ed = edata = data+ndata;
	for(d=data; d&lt;ed; d++) {
		if(d-&gt;type == 'a')
			continue;
		if(b = findblock(d-&gt;val-8))		// pool header 2 words
			n8 += markblock(d-&gt;addr, d-&gt;val, b);
		else if(b = findblock(d-&gt;val-8-8))	// sometimes malloc header 2 words
			n16 += markblock(d-&gt;addr, d-&gt;val, b);
		else
			{}//print("noblock %.8lux\n", d-&gt;val);
	}

	Binit(&amp;bio, 1, OWRITE);
	if(bitmap){
		if(n8 &gt; n16)		// guess size of header
			hdr = 8;
		else
			hdr = 16;

		for(d=data; d&lt;ed; d++)
			if(d-&gt;type=='a')
				break;
		if(d==ed)
			sysfatal("no allocated data region");

		len = (allocend-allocstart+resolution-1)/resolution;
		y = (len+x-1)/x;
		Bprint(&amp;bio, "%11s %11d %11d %11d %11d ", "m8", 0, 0, x, y);

//fprint(2, "alloc %lux %lux x %d y %d res %d\n", allocstart, allocend, x, y, resolution);

		b = block;
		eb = block+nblock;
		for(u = allocstart; u&lt;allocend; u+=resolution){
//fprint(2, "u %lux %lux baddr %lux\n", u, u+resolution, b-&gt;addr);
			while(b-&gt;addr+b-&gt;size &lt;= u &amp;&amp; b &lt; eb)
//{
//fprint(2, "\tskip %lux %lux\n", b-&gt;addr, b-&gt;addr+b-&gt;size);
				b++;
//}
			nhdr = 0;
			nleak = 0;
			nb = 0;
			nlhdr = 0;
			if(block &lt; b &amp;&amp; u &lt; (b-1)-&gt;addr+(b-1)-&gt;size)
				b--;

			for(; b-&gt;addr &lt; u+resolution &amp;&amp; b &lt; eb; b++){
//fprint(2, "\tblock %lux %lux %d\n", b-&gt;addr, b-&gt;addr+b-&gt;size, b-&gt;mark);
				if(rXr(b-&gt;addr, b-&gt;addr+hdr, u, u+resolution)
				|| rXr(b-&gt;addr+b-&gt;size-8, b-&gt;addr+b-&gt;size, u, u+resolution)){
					if(b-&gt;mark == 0 &amp;&amp; !b-&gt;free)
						nlhdr++;
					else
						nhdr++;
				}
				if(b-&gt;mark == 0 &amp;&amp; !b-&gt;free)
					nleak++;
				nb++;
			}
			if(nhdr)
				c = HdrColor;
			else if(nlhdr)
				c = LeakHdrColor;
			else if(nleak)
				c = LeakColor;
			else if(nb)
				c = AllocColor;
			else
				c = FreeColor;
//fprint(2, "\t%d\n", c);
			Bputc(&amp;bio, c);
		}
		allocend = allocstart+x*y*resolution;
		for(; u &lt; allocend; u+=resolution)
			Bputc(&amp;bio, NoColor);
	}else{
		eb = block+nblock;
		for(b=block; b&lt;eb; b++)
			if(b-&gt;mark == 0 &amp;&amp; !b-&gt;free)
				Bprint(&amp;bio, "block 0x%.8lux 0x%.8lux 0x%.8lux 0x%.8lux %s %s\n", b-&gt;addr, b-&gt;size, b-&gt;w0, b-&gt;w1, b-&gt;s0, b-&gt;s1);
	}
	Bterm(&amp;bio);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

