<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/asc85enc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/asc85enc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * asc85enc.c
 * Copyright (C) 2000-2003 A.J. van Os; Released under GPL
 *
 * Description:
 * Functions to for ASCII 85 encoding
 *
 *====================================================================
 * This part of the software is based on:
 * asc85ec.c - ASCII85 and Hex encoding for PostScript Level 2 and PDF
 * Copyright (C) 1994-99 Thomas Merz (tm@muc.de)
 *====================================================================
 * The credit should go to him, but all the bugs are mine.
 */

#include &lt;stdio.h&gt;
#include "antiword.h"

static const ULONG	aulPower85[5] = {
	1UL, 85UL, 85UL * 85, 85UL * 85 * 85, 85UL * 85 * 85 * 85,
};
static int	iOutBytes = 0;	/* Number of characters in an output line */
static char	cCharPrev = '\0';

/*
 * Two percent characters at the start of a line will cause trouble
 * with some post-processing software. In order to avoid this, we
 * simply insert a line break if we encounter two percent characters
 * at the start of the line. Of course, this rather simplistic
 * algorithm may lead to a large line count in pathological cases,
 * but the chance for hitting such a case is very small, and even
 * so it's only a cosmetic flaw and not a functional restriction.
 */

/*
 * vOutputByte - output one byte
 */
static void
vOutputByte(ULONG ulChar, FILE *pOutFile)
{
	if (iOutBytes == 1 &amp;&amp; cCharPrev == '%' &amp;&amp; ulChar == (ULONG)'%') {
		if (putc('\n', pOutFile) != EOF) {
			iOutBytes = 0;
		}
	}
	if (putc((int)ulChar, pOutFile) == EOF) {
		return;
	}
	iOutBytes++;
	if (iOutBytes &gt; 63) {
		if (putc('\n', pOutFile) != EOF) {
			iOutBytes = 0;
		}
	}
	cCharPrev = (char)ulChar;
} /* end of vOutputByte */

/*
 * vASCII85EncodeByte - ASCII 85 encode a byte
 */
void
vASCII85EncodeByte(FILE *pOutFile, int iByte)
{
	static ULONG	ulBuffer[4] = { 0, 0, 0, 0 };
	static int	iInBuffer = 0;
	ULONG	ulValue, ulTmp;
	int	iIndex;

	fail(pOutFile == NULL);
	fail(iInBuffer &lt; 0);
	fail(iInBuffer &gt; 3);

	if (iByte == EOF) {
		/* End Of File, time to clean up */
		if (iInBuffer &gt; 0 &amp;&amp; iInBuffer &lt; 4) {
			/* Encode the remaining bytes */
			ulValue = 0;
			for (iIndex = iInBuffer - 1; iIndex &gt;= 0; iIndex--) {
				ulValue |=
					ulBuffer[iIndex] &lt;&lt; (8 * (3 - iIndex));
			}
			for (iIndex = 4; iIndex &gt;= 4 - iInBuffer; iIndex--) {
				ulTmp = ulValue / aulPower85[iIndex];
				vOutputByte(ulTmp + '!', pOutFile);
				ulValue -= ulTmp * aulPower85[iIndex];
			}
		}
		/* Add the End Of Data marker */
		(void)putc('~', pOutFile);
		(void)putc('&gt;', pOutFile);
		(void)putc('\n', pOutFile);
		/* Reset the control variables */
		iInBuffer = 0;
		iOutBytes = 0;
		cCharPrev = '\0';
		return;
	}

	ulBuffer[iInBuffer] = (ULONG)iByte &amp; 0xff;
	iInBuffer++;

	if (iInBuffer &gt;= 4) {
		ulValue = (ulBuffer[0] &lt;&lt; 24) | (ulBuffer[1] &lt;&lt; 16) |
			(ulBuffer[2] &lt;&lt; 8) | ulBuffer[3];
		if (ulValue == 0) {
			vOutputByte((ULONG)'z', pOutFile); /* Shortcut for 0 */
		} else {
			for (iIndex = 4; iIndex &gt;= 0; iIndex--) {
				ulTmp = ulValue / aulPower85[iIndex];
				vOutputByte(ulTmp + '!', pOutFile);
				ulValue -= ulTmp * aulPower85[iIndex];
			}
		}
		/* Reset the buffer */
		iInBuffer = 0;
	}
} /* end of vASCII85EncodeByte */

/*
 * vASCII85EncodeArray - ASCII 85 encode a byte array
 */
void
vASCII85EncodeArray(FILE *pInFile, FILE *pOutFile, size_t tLength)
{
	size_t	tCount;
	int	iByte;

	fail(pInFile == NULL);
	fail(pOutFile == NULL);

	DBG_DEC(tLength);

	for (tCount = 0; tCount &lt; tLength; tCount++) {
		iByte = iNextByte(pInFile);
		if (iByte == EOF) {
			break;
		}
		vASCII85EncodeByte(pOutFile, iByte);
	}
} /* end of vASCII85EncodeArray */

/*
 * vASCII85EncodeFile - ASCII 85 encode part of a file
 */
void
vASCII85EncodeFile(FILE *pInFile, FILE *pOutFile, size_t tLength)
{
	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(tLength == 0);

	vASCII85EncodeArray(pInFile, pOutFile, tLength);
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vASCII85EncodeFile */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

