<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/blocklist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/blocklist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * blocklist.c
 * Copyright (C) 1998-2005 A.J. van Os; Released under GNU GPL
 *
 * Description:
 * Build, read and destroy the lists of Word "text" blocks
 */

#include &lt;stdlib.h&gt;
#include "antiword.h"


/*
 * Private structure to hide the way the information
 * is stored from the rest of the program
 */
typedef struct list_mem_tag {
	text_block_type		tInfo;
	struct list_mem_tag	*pNext;
} list_mem_type;

typedef struct readinfo_tag {
	list_mem_type		*pBlockCurrent;
	ULONG			ulBlockOffset;
	size_t			tByteNext;
	UCHAR			aucBlock[BIG_BLOCK_SIZE];
} readinfo_type;

/* Variables to describe the start of the block lists */
static list_mem_type	*pTextAnchor = NULL;
static list_mem_type	*pFootnoteAnchor = NULL;
static list_mem_type	*pHdrFtrAnchor = NULL;
static list_mem_type	*pMacroAnchor = NULL;
static list_mem_type	*pAnnotationAnchor = NULL;
static list_mem_type	*pEndnoteAnchor = NULL;
static list_mem_type	*pTextBoxAnchor = NULL;
static list_mem_type	*pHdrTextBoxAnchor = NULL;
/* Variable needed to build the block list */
static list_mem_type	*pBlockLast = NULL;
/* Variable needed to read the block lists */
static readinfo_type	tOthers = { NULL, 0, 0, };
static readinfo_type	tHdrFtr = { NULL, 0, 0, };
static readinfo_type	tFootnote = { NULL, 0, 0, };


/*
 * pFreeOneList - free a text block list
 *
 * Will always return NULL
 */
static list_mem_type *
pFreeOneList(list_mem_type *pAnchor)
{
	list_mem_type	*pCurr, *pNext;

	pCurr = pAnchor;
	while (pCurr != NULL) {
		pNext = pCurr-&gt;pNext;
		pCurr = xfree(pCurr);
		pCurr = pNext;
	}
	return NULL;
} /* end of pFreeOneList */

/*
 * vDestroyTextBlockList - destroy the text block lists
 */
void
vDestroyTextBlockList(void)
{
	DBG_MSG("vDestroyTextBlockList");

	/* Free the lists one by one */
	pTextAnchor = pFreeOneList(pTextAnchor);
	pFootnoteAnchor = pFreeOneList(pFootnoteAnchor);
	pHdrFtrAnchor = pFreeOneList(pHdrFtrAnchor);
	pMacroAnchor = pFreeOneList(pMacroAnchor);
	pAnnotationAnchor = pFreeOneList(pAnnotationAnchor);
	pEndnoteAnchor = pFreeOneList(pEndnoteAnchor);
	pTextBoxAnchor = pFreeOneList(pTextBoxAnchor);
	pHdrTextBoxAnchor = pFreeOneList(pHdrTextBoxAnchor);
	/* Reset all the controle variables */
	pBlockLast = NULL;
	tOthers.pBlockCurrent = NULL;
	tHdrFtr.pBlockCurrent = NULL;
	tFootnote.pBlockCurrent = NULL;
} /* end of vDestroyTextBlockList */

/*
 * bAdd2TextBlockList - add an element to the text block list
 *
 * returns: TRUE when successful, otherwise FALSE
 */
BOOL
bAdd2TextBlockList(const text_block_type *pTextBlock)
{
	list_mem_type	*pListMember;

	fail(pTextBlock == NULL);
	fail(pTextBlock-&gt;ulFileOffset == FC_INVALID);
	fail(pTextBlock-&gt;ulCharPos == CP_INVALID);
	fail(pTextBlock-&gt;ulLength == 0);
	fail(pTextBlock-&gt;bUsesUnicode &amp;&amp; odd(pTextBlock-&gt;ulLength));

	NO_DBG_MSG("bAdd2TextBlockList");
	NO_DBG_HEX(pTextBlock-&gt;ulFileOffset);
	NO_DBG_HEX(pTextBlock-&gt;ulCharPos);
	NO_DBG_HEX(pTextBlock-&gt;ulLength);
	NO_DBG_DEC(pTextBlock-&gt;bUsesUnicode);
	NO_DBG_DEC(pTextBlock-&gt;usPropMod);

	if (pTextBlock-&gt;ulFileOffset == FC_INVALID ||
	    pTextBlock-&gt;ulCharPos == CP_INVALID ||
	    pTextBlock-&gt;ulLength == 0 ||
	    (pTextBlock-&gt;bUsesUnicode &amp;&amp; odd(pTextBlock-&gt;ulLength))) {
		werr(0, "Software (textblock) error");
		return FALSE;
	}
	/*
	 * Check for continuous blocks of the same character size and
	 * the same properties modifier
	 */
	if (pBlockLast != NULL &amp;&amp;
	    pBlockLast-&gt;tInfo.ulFileOffset +
	     pBlockLast-&gt;tInfo.ulLength == pTextBlock-&gt;ulFileOffset &amp;&amp;
	    pBlockLast-&gt;tInfo.ulCharPos +
	     pBlockLast-&gt;tInfo.ulLength == pTextBlock-&gt;ulCharPos &amp;&amp;
	    pBlockLast-&gt;tInfo.bUsesUnicode == pTextBlock-&gt;bUsesUnicode &amp;&amp;
	    pBlockLast-&gt;tInfo.usPropMod == pTextBlock-&gt;usPropMod) {
		/* These are continous blocks */
		pBlockLast-&gt;tInfo.ulLength += pTextBlock-&gt;ulLength;
		return TRUE;
	}
	/* Make a new block */
	pListMember = xmalloc(sizeof(list_mem_type));
	/* Add the block to the list */
	pListMember-&gt;tInfo = *pTextBlock;
	pListMember-&gt;pNext = NULL;
	if (pTextAnchor == NULL) {
		pTextAnchor = pListMember;
	} else {
		fail(pBlockLast == NULL);
		pBlockLast-&gt;pNext = pListMember;
	}
	pBlockLast = pListMember;
	return TRUE;
} /* end of bAdd2TextBlockList */

/*
 * vSpitList - Split the list in two
 */
static void
vSpitList(list_mem_type **ppAnchorCurr, list_mem_type **ppAnchorNext,
	ULONG ulListLen)
{
	list_mem_type	*pCurr;
	long		lCharsToGo, lBytesTooFar;

	fail(ppAnchorCurr == NULL);
	fail(ppAnchorNext == NULL);
	fail(ulListLen &gt; (ULONG)LONG_MAX);

	pCurr = NULL;
	lCharsToGo = (long)ulListLen;
	lBytesTooFar = -1;
	if (ulListLen != 0) {
		DBG_DEC(ulListLen);
		for (pCurr = *ppAnchorCurr;
		     pCurr != NULL;
		     pCurr = pCurr-&gt;pNext) {
			NO_DBG_DEC(pCurr-&gt;tInfo.ulLength);
			fail(pCurr-&gt;tInfo.ulLength == 0);
			fail(pCurr-&gt;tInfo.ulLength &gt; (ULONG)LONG_MAX);
			if (pCurr-&gt;tInfo.bUsesUnicode) {
				fail(odd(pCurr-&gt;tInfo.ulLength));
				lCharsToGo -= (long)(pCurr-&gt;tInfo.ulLength / 2);
				if (lCharsToGo &lt; 0) {
					lBytesTooFar = -2 * lCharsToGo;
				}
			} else {
				lCharsToGo -= (long)pCurr-&gt;tInfo.ulLength;
				if (lCharsToGo &lt; 0) {
					lBytesTooFar = -lCharsToGo;
				}
			}
			if (lCharsToGo &lt;= 0) {
				break;
			}
		}
	}
/* Split the list */
	if (ulListLen == 0) {
		/* Current blocklist is empty */
		*ppAnchorNext = *ppAnchorCurr;
		*ppAnchorCurr = NULL;
	} else if (pCurr == NULL) {
		/* No blocks for the next list */
		*ppAnchorNext = NULL;
	} else if (lCharsToGo == 0) {
		/* Move the integral number of blocks to the next list */
		*ppAnchorNext = pCurr-&gt;pNext;
		pCurr-&gt;pNext = NULL;
	} else {
		/* Split the part current block list, part next block list */
		DBG_DEC(lBytesTooFar);
		fail(lBytesTooFar &lt;= 0);
		*ppAnchorNext = xmalloc(sizeof(list_mem_type));
		DBG_HEX(pCurr-&gt;tInfo.ulFileOffset);
		(*ppAnchorNext)-&gt;tInfo.ulFileOffset =
				pCurr-&gt;tInfo.ulFileOffset +
				pCurr-&gt;tInfo.ulLength -
				lBytesTooFar;
		DBG_HEX((*ppAnchorNext)-&gt;tInfo.ulFileOffset);
		DBG_HEX(pCurr-&gt;tInfo.ulCharPos);
		(*ppAnchorNext)-&gt;tInfo.ulCharPos =
				pCurr-&gt;tInfo.ulCharPos +
				pCurr-&gt;tInfo.ulLength -
				lBytesTooFar;
		DBG_HEX((*ppAnchorNext)-&gt;tInfo.ulCharPos);
		(*ppAnchorNext)-&gt;tInfo.ulLength = (ULONG)lBytesTooFar;
		pCurr-&gt;tInfo.ulLength -= (ULONG)lBytesTooFar;
		(*ppAnchorNext)-&gt;tInfo.bUsesUnicode = pCurr-&gt;tInfo.bUsesUnicode;
		(*ppAnchorNext)-&gt;tInfo.usPropMod = pCurr-&gt;tInfo.usPropMod;
		/* Move the integral number of blocks to the next list */
		(*ppAnchorNext)-&gt;pNext = pCurr-&gt;pNext;
		pCurr-&gt;pNext = NULL;
	}
} /* end of vSpitList */

#if defined(DEBUG) || defined(__riscos)
/*
 * ulComputeListLength - compute the length of a list
 *
 * returns the list length in characters
 */
static ULONG
ulComputeListLength(const list_mem_type *pAnchor)
{
	const list_mem_type	*pCurr;
	ULONG		ulTotal;

	ulTotal = 0;
	for (pCurr = pAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		fail(pCurr-&gt;tInfo.ulLength == 0);
		if (pCurr-&gt;tInfo.bUsesUnicode) {
			fail(odd(pCurr-&gt;tInfo.ulLength));
			ulTotal += pCurr-&gt;tInfo.ulLength / 2;
		} else {
			ulTotal += pCurr-&gt;tInfo.ulLength;
		}
	}
	return ulTotal;
} /* end of ulComputeListLength */
#endif /* DEBUG || __riscos */

#if defined(DEBUG)
/*
 * vCheckList - check the number of bytes in a block list
 */
static void
vCheckList(const list_mem_type *pAnchor, ULONG ulListLen, char *szMsg)
{
	ULONG		ulTotal;

	ulTotal = ulComputeListLength(pAnchor);
	DBG_DEC(ulTotal);
	if (ulTotal != ulListLen) {
		DBG_DEC(ulListLen);
		werr(1, szMsg);
	}
} /* end of vCheckList */
#endif /* DEBUG */

/*
 * bIsEmptyBox - check to see if the given text box is empty
 */
static BOOL
bIsEmptyBox(FILE *pFile, const list_mem_type *pAnchor)
{
	const list_mem_type	*pCurr;
	size_t	tIndex, tSize;
	UCHAR	*aucBuffer;
	char	cChar;

	fail(pFile == NULL);

	if (pAnchor == NULL) {
		return TRUE;
	}

	aucBuffer = NULL;
	for (pCurr = pAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		fail(pCurr-&gt;tInfo.ulLength == 0);
		tSize = (size_t)pCurr-&gt;tInfo.ulLength;
#if defined(__dos) &amp;&amp; !defined(__DJGPP__)
		if (pCurr-&gt;tInfo.ulLength &gt; 0xffffUL) {
			tSize = 0xffff;
		}
#endif /* __dos &amp;&amp; !__DJGPP__ */
		fail(aucBuffer != NULL);
		aucBuffer = xmalloc(tSize);
		if (!bReadBytes(aucBuffer, tSize,
				pCurr-&gt;tInfo.ulFileOffset, pFile)) {
			aucBuffer = xfree(aucBuffer);
			return FALSE;
		}
		for (tIndex = 0; tIndex &lt; tSize; tIndex++) {
			cChar = (char)aucBuffer[tIndex];
			switch (cChar) {
			case '\0': case '\r': case '\n':
			case '\f': case '\t': case '\v':
			case ' ':
				break;
			default:
				aucBuffer = xfree(aucBuffer);
				return FALSE;
			}
		}
		aucBuffer = xfree(aucBuffer);
	}
	fail(aucBuffer != NULL);
	return TRUE;
} /* end of bIsEmptyBox */

/*
 * vSplitBlockList - split the block list in the various parts
 *
 * Split the blocklist in a Text block list, a Footnote block list, a
 * HeaderFooter block list, a Macro block list, an Annotation block list,
 * an Endnote block list, a TextBox list and a HeaderTextBox list.
 *
 * NOTE:
 * The various ul*Len input parameters are given in characters, but the
 * length of the blocks are in bytes.
 */
void
vSplitBlockList(FILE *pFile, ULONG ulTextLen, ULONG ulFootnoteLen,
	ULONG ulHdrFtrLen, ULONG ulMacroLen, ULONG ulAnnotationLen,
	ULONG ulEndnoteLen, ULONG ulTextBoxLen, ULONG ulHdrTextBoxLen,
	BOOL bMustExtend)
{
	list_mem_type	*apAnchors[8];
	list_mem_type	*pGarbageAnchor, *pCurr;
	size_t		tIndex;

	DBG_MSG("vSplitBlockList");

	pGarbageAnchor = NULL;

	DBG_MSG_C(ulTextLen != 0, "Text block list");
	vSpitList(&amp;pTextAnchor, &amp;pFootnoteAnchor, ulTextLen);
	DBG_MSG_C(ulFootnoteLen != 0, "Footnote block list");
	vSpitList(&amp;pFootnoteAnchor, &amp;pHdrFtrAnchor, ulFootnoteLen);
	DBG_MSG_C(ulHdrFtrLen != 0, "Header/Footer block list");
	vSpitList(&amp;pHdrFtrAnchor, &amp;pMacroAnchor, ulHdrFtrLen);
	DBG_MSG_C(ulMacroLen != 0, "Macro block list");
	vSpitList(&amp;pMacroAnchor, &amp;pAnnotationAnchor, ulMacroLen);
	DBG_MSG_C(ulAnnotationLen != 0, "Annotation block list");
	vSpitList(&amp;pAnnotationAnchor, &amp;pEndnoteAnchor, ulAnnotationLen);
	DBG_MSG_C(ulEndnoteLen != 0, "Endnote block list");
	vSpitList(&amp;pEndnoteAnchor, &amp;pTextBoxAnchor, ulEndnoteLen);
	DBG_MSG_C(ulTextBoxLen != 0, "Textbox block list");
	vSpitList(&amp;pTextBoxAnchor, &amp;pHdrTextBoxAnchor, ulTextBoxLen);
	DBG_MSG_C(ulHdrTextBoxLen != 0, "HeaderTextbox block list");
	vSpitList(&amp;pHdrTextBoxAnchor, &amp;pGarbageAnchor, ulHdrTextBoxLen);

	/* Free the garbage block list, this should not be needed */
	DBG_DEC_C(pGarbageAnchor != NULL, pGarbageAnchor-&gt;tInfo.ulLength);
	pGarbageAnchor = pFreeOneList(pGarbageAnchor);

#if defined(DEBUG)
	vCheckList(pTextAnchor, ulTextLen, "Software error (Text)");
	vCheckList(pFootnoteAnchor, ulFootnoteLen, "Software error (Footnote)");
	vCheckList(pHdrFtrAnchor, ulHdrFtrLen, "Software error (Hdr/Ftr)");
	vCheckList(pMacroAnchor, ulMacroLen, "Software error (Macro)");
	vCheckList(pAnnotationAnchor, ulAnnotationLen,
						"Software error (Annotation)");
	vCheckList(pEndnoteAnchor, ulEndnoteLen, "Software error (Endnote)");
	vCheckList(pTextBoxAnchor, ulTextBoxLen, "Software error (TextBox)");
	vCheckList(pHdrTextBoxAnchor, ulHdrTextBoxLen,
						"Software error (HdrTextBox)");
#endif /* DEBUG */

	/* Remove the list if the text box is empty */
	if (bIsEmptyBox(pFile, pTextBoxAnchor)) {
		pTextBoxAnchor = pFreeOneList(pTextBoxAnchor);
	}
	if (bIsEmptyBox(pFile, pHdrTextBoxAnchor)) {
		pHdrTextBoxAnchor = pFreeOneList(pHdrTextBoxAnchor);
	}

	if (!bMustExtend) {
		return;
	}
	/*
	 * All blocks (except the last one) must have a length that
	 * is a multiple of the Big Block Size
	 */

	apAnchors[0] = pTextAnchor;
	apAnchors[1] = pFootnoteAnchor;
	apAnchors[2] = pHdrFtrAnchor;
	apAnchors[3] = pMacroAnchor;
	apAnchors[4] = pAnnotationAnchor;
	apAnchors[5] = pEndnoteAnchor;
	apAnchors[6] = pTextBoxAnchor;
	apAnchors[7] = pHdrTextBoxAnchor;

	for (tIndex = 0; tIndex &lt; elementsof(apAnchors); tIndex++) {
		for (pCurr = apAnchors[tIndex];
		     pCurr != NULL;
		     pCurr = pCurr-&gt;pNext) {
			if (pCurr-&gt;pNext != NULL &amp;&amp;
			    pCurr-&gt;tInfo.ulLength % BIG_BLOCK_SIZE != 0) {
				DBG_DEC(tIndex);
				DBG_HEX(pCurr-&gt;tInfo.ulFileOffset);
				DBG_HEX(pCurr-&gt;tInfo.ulCharPos);
				DBG_DEC(pCurr-&gt;tInfo.ulLength);
				pCurr-&gt;tInfo.ulLength /= BIG_BLOCK_SIZE;
				pCurr-&gt;tInfo.ulLength++;
				pCurr-&gt;tInfo.ulLength *= BIG_BLOCK_SIZE;
				DBG_DEC(pCurr-&gt;tInfo.ulLength);
			}
		}
	}
} /* end of vSplitBlockList */

#if defined(__riscos)
/*
 * ulGetDocumentLength - get the total character length of the printable lists
 *
 * returns: The total number of characters
 */
ULONG
ulGetDocumentLength(void)
{
	long		ulTotal;

	DBG_MSG("ulGetDocumentLength");

	ulTotal = ulComputeListLength(pTextAnchor);
	ulTotal += ulComputeListLength(pFootnoteAnchor);
	ulTotal += ulComputeListLength(pEndnoteAnchor);
	ulTotal += ulComputeListLength(pTextBoxAnchor);
	ulTotal += ulComputeListLength(pHdrTextBoxAnchor);
	DBG_DEC(ulTotal);
	return ulTotal;
} /* end of ulGetDocumentLength */
#endif /* __riscos */

#if 0
/*
 * bExistsHdrFtr - are there headers and/or footers?
 */
BOOL
bExistsHdrFtr(void)
{
	return pHdrFtrAnchor != NULL &amp;&amp;
		pHdrFtrAnchor-&gt;tInfo.ulLength != 0;
} /* end of bExistsHdrFtr */
#endif

/*
 * bExistsTextBox - is there a text box?
 */
BOOL
bExistsTextBox(void)
{
	return pTextBoxAnchor != NULL &amp;&amp;
		pTextBoxAnchor-&gt;tInfo.ulLength != 0;
} /* end of bExistsTextBox */

/*
 * bExistsHdrTextBox - is there a header text box?
 */
BOOL
bExistsHdrTextBox(void)
{
	return pHdrTextBoxAnchor != NULL &amp;&amp;
		pHdrTextBoxAnchor-&gt;tInfo.ulLength != 0;
} /* end of bExistsHdrTextBox */

/*
 * usGetNextByte - get the next byte from the specified block list
 */
static USHORT
usGetNextByte(FILE *pFile, readinfo_type *pInfoCurrent, list_mem_type *pAnchor,
	ULONG *pulFileOffset, ULONG *pulCharPos, USHORT *pusPropMod)
{
	ULONG	ulReadOff;
	size_t	tReadLen;

	fail(pInfoCurrent == NULL);

	if (pInfoCurrent-&gt;pBlockCurrent == NULL ||
	    pInfoCurrent-&gt;tByteNext &gt;= sizeof(pInfoCurrent-&gt;aucBlock) ||
	    pInfoCurrent-&gt;ulBlockOffset + pInfoCurrent-&gt;tByteNext &gt;=
				pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.ulLength) {
		if (pInfoCurrent-&gt;pBlockCurrent == NULL) {
			/* First block, first part */
			pInfoCurrent-&gt;pBlockCurrent = pAnchor;
			pInfoCurrent-&gt;ulBlockOffset = 0;
		} else if (pInfoCurrent-&gt;ulBlockOffset +
				sizeof(pInfoCurrent-&gt;aucBlock) &lt;
				pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.ulLength) {
			/* Same block, next part */
			pInfoCurrent-&gt;ulBlockOffset +=
					sizeof(pInfoCurrent-&gt;aucBlock);
		} else {
			/* Next block, first part */
			pInfoCurrent-&gt;pBlockCurrent =
					pInfoCurrent-&gt;pBlockCurrent-&gt;pNext;
			pInfoCurrent-&gt;ulBlockOffset = 0;
		}
		if (pInfoCurrent-&gt;pBlockCurrent == NULL) {
			/* Past the last part of the last block */
			return (USHORT)EOF;
		}
		tReadLen = (size_t)
			(pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.ulLength -
			 pInfoCurrent-&gt;ulBlockOffset);
		if (tReadLen &gt; sizeof(pInfoCurrent-&gt;aucBlock)) {
			tReadLen = sizeof(pInfoCurrent-&gt;aucBlock);
		}
		ulReadOff = pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.ulFileOffset +
				pInfoCurrent-&gt;ulBlockOffset;
		if (!bReadBytes(pInfoCurrent-&gt;aucBlock,
						tReadLen, ulReadOff, pFile)) {
			/* Don't read from this list any longer */
			pInfoCurrent-&gt;pBlockCurrent = NULL;
			return (USHORT)EOF;
		}
		pInfoCurrent-&gt;tByteNext = 0;
	}
	if (pulFileOffset != NULL) {
		*pulFileOffset =
			pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.ulFileOffset +
			pInfoCurrent-&gt;ulBlockOffset +
			pInfoCurrent-&gt;tByteNext;
	}
	if (pulCharPos != NULL) {
		*pulCharPos =
			pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.ulCharPos +
			pInfoCurrent-&gt;ulBlockOffset +
			pInfoCurrent-&gt;tByteNext;
	}
	if (pusPropMod != NULL) {
		*pusPropMod = pInfoCurrent-&gt;pBlockCurrent-&gt;tInfo.usPropMod;
	}
	return (USHORT)pInfoCurrent-&gt;aucBlock[pInfoCurrent-&gt;tByteNext++];
} /* end of usGetNextByte */


/*
 * usGetNextChar - get the next character from the specified block list
 */
static USHORT
usGetNextChar(FILE *pFile, list_id_enum eListID,
	ULONG *pulFileOffset, ULONG *pulCharPos, USHORT *pusPropMod)
{
	readinfo_type	*pReadinfo;
	list_mem_type	*pAnchor;
	USHORT	usLSB, usMSB;

	switch (eListID) {
	case text_list:
		pReadinfo = &amp;tOthers;
		pAnchor = pTextAnchor;
		break;
	case footnote_list:
		pReadinfo = &amp;tFootnote;
		pAnchor = pFootnoteAnchor;
		break;
	case hdrftr_list:
		pReadinfo = &amp;tHdrFtr;
		pAnchor = pHdrFtrAnchor;
		break;
	case endnote_list:
		pReadinfo = &amp;tOthers;
		pAnchor = pEndnoteAnchor;
		break;
	case textbox_list:
		pReadinfo = &amp;tOthers;
		pAnchor = pTextBoxAnchor;
		break;
	case hdrtextbox_list:
		pReadinfo = &amp;tOthers;
		pAnchor = pHdrTextBoxAnchor;
		break;
	default:
		DBG_DEC(eListID);
		return (USHORT)EOF;
	}

	usLSB = usGetNextByte(pFile, pReadinfo, pAnchor,
				pulFileOffset, pulCharPos, pusPropMod);
	if (usLSB == (USHORT)EOF) {
		return (USHORT)EOF;
	}
	fail(pReadinfo-&gt;pBlockCurrent == NULL);

	if (pReadinfo-&gt;pBlockCurrent-&gt;tInfo.bUsesUnicode) {
		usMSB = usGetNextByte(pFile,
				pReadinfo, pAnchor, NULL, NULL, NULL);
	} else {
		usMSB = 0x00;
	}
	if (usMSB == (USHORT)EOF) {
		DBG_MSG("usGetNextChar: Unexpected EOF");
		DBG_HEX_C(pulFileOffset != NULL, *pulFileOffset);
		DBG_HEX_C(pulCharPos != NULL, *pulCharPos);
		return (USHORT)EOF;
	}
	return (usMSB &lt;&lt; 8) | usLSB;
} /* end of usGetNextChar */

/*
 * usNextChar - get the next character from the given block list
 */
USHORT
usNextChar(FILE *pFile, list_id_enum eListID,
	ULONG *pulFileOffset, ULONG *pulCharPos, USHORT *pusPropMod)
{
	USHORT	usRetVal;

	fail(pFile == NULL);

	usRetVal = usGetNextChar(pFile, eListID,
				pulFileOffset, pulCharPos, pusPropMod);
	if (usRetVal == (USHORT)EOF) {
		if (pulFileOffset != NULL) {
			*pulFileOffset = FC_INVALID;
		}
		if (pulCharPos != NULL) {
			*pulCharPos = CP_INVALID;
		}
		if (pusPropMod != NULL) {
			*pusPropMod = IGNORE_PROPMOD;
		}
	}
	return usRetVal;
} /* end of usNextChar */

/*
 * usToHdrFtrPosition - Go to a character position in header/foorter list
 *
 * Returns the character found on the specified character position
 */
USHORT
usToHdrFtrPosition(FILE *pFile, ULONG ulCharPos)
{
	ULONG	ulCharPosCurr;
	USHORT	usChar;

	tHdrFtr.pBlockCurrent = NULL;	/* To reset the header/footer list */
	do {
		usChar = usNextChar(pFile,
				hdrftr_list, NULL, &amp;ulCharPosCurr, NULL);
	} while (usChar != (USHORT)EOF &amp;&amp; ulCharPosCurr != ulCharPos);
	return usChar;
} /* end of usToHdrFtrPosition */

/*
 * usToFootnotePosition - Go to a character position in footnote list
 *
 * Returns the character found on the specified character position
 */
USHORT
usToFootnotePosition(FILE *pFile, ULONG ulCharPos)
{
	ULONG	ulCharPosCurr;
	USHORT	usChar;

	tFootnote.pBlockCurrent = NULL;	/* To reset the footnote list */
	do {
		usChar = usNextChar(pFile,
				footnote_list, NULL, &amp;ulCharPosCurr, NULL);
	} while (usChar != (USHORT)EOF &amp;&amp; ulCharPosCurr != ulCharPos);
	return usChar;
} /* end of usToFootnotePosition */

/*
 * Convert a character position to an offset in the file.
 * Logical to physical offset.
 *
 * Returns:	FC_INVALID: in case of error
 *		otherwise: the computed file offset
 */
ULONG
ulCharPos2FileOffsetX(ULONG ulCharPos, list_id_enum *peListID)
{
	static list_id_enum	eListIDs[8] = {
		text_list,	footnote_list,		hdrftr_list,
		macro_list,	annotation_list,	endnote_list,
		textbox_list,	hdrtextbox_list,
	};
	list_mem_type	*apAnchors[8];
	list_mem_type	*pCurr;
	list_id_enum	eListGuess;
	ULONG		ulBestGuess;
	size_t		tIndex;

	fail(peListID == NULL);

	if (ulCharPos == CP_INVALID) {
		*peListID = no_list;
		return FC_INVALID;
	}

	apAnchors[0] = pTextAnchor;
	apAnchors[1] = pFootnoteAnchor;
	apAnchors[2] = pHdrFtrAnchor;
	apAnchors[3] = pMacroAnchor;
	apAnchors[4] = pAnnotationAnchor;
	apAnchors[5] = pEndnoteAnchor;
	apAnchors[6] = pTextBoxAnchor;
	apAnchors[7] = pHdrTextBoxAnchor;

	eListGuess = no_list;	  /* Best guess is no list */
	ulBestGuess = FC_INVALID; /* Best guess is "file offset not found" */

	for (tIndex = 0; tIndex &lt; elementsof(apAnchors); tIndex++) {
		for (pCurr = apAnchors[tIndex];
		     pCurr != NULL;
		     pCurr = pCurr-&gt;pNext) {
			if (ulCharPos == pCurr-&gt;tInfo.ulCharPos +
			     pCurr-&gt;tInfo.ulLength &amp;&amp;
			    pCurr-&gt;pNext != NULL) {
				/*
				 * The character position is one beyond this
				 * block, so we guess it's the first byte of
				 * the next block (if there is a next block)
				 */
				eListGuess= eListIDs[tIndex];
				ulBestGuess = pCurr-&gt;pNext-&gt;tInfo.ulFileOffset;
			}

			if (ulCharPos &lt; pCurr-&gt;tInfo.ulCharPos ||
			    ulCharPos &gt;= pCurr-&gt;tInfo.ulCharPos +
			     pCurr-&gt;tInfo.ulLength) {
				/* Character position is not in this block */
				continue;
			}

			/* The character position is in the current block */
			*peListID = eListIDs[tIndex];
			return pCurr-&gt;tInfo.ulFileOffset +
				ulCharPos - pCurr-&gt;tInfo.ulCharPos;
		}
	}
	/* Passed beyond the end of the last list */
	NO_DBG_HEX(ulCharPos);
	NO_DBG_HEX(ulBestGuess);
	*peListID = eListGuess;
	return ulBestGuess;
} /* end of ulCharPos2FileOffsetX */

/*
 * Convert a character position to an offset in the file.
 * Logical to physical offset.
 *
 * Returns:	FC_INVALID: in case of error
 *		otherwise: the computed file offset
 */
ULONG
ulCharPos2FileOffset(ULONG ulCharPos)
{
	list_id_enum	eListID;

	return ulCharPos2FileOffsetX(ulCharPos, &amp;eListID);
} /* end of ulCharPos2FileOffset */

/*
 * Convert an offset in the header/footer list to a character position.
 *
 * Returns:	CP_INVALID: in case of error
 *		otherwise: the computed character position
 */
ULONG
ulHdrFtrOffset2CharPos(ULONG ulHdrFtrOffset)
{
	list_mem_type	*pCurr;
	ULONG		ulOffset;

	ulOffset = ulHdrFtrOffset;
	for (pCurr = pHdrFtrAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		if (ulOffset &gt;= pCurr-&gt;tInfo.ulLength) {
			/* The offset is not in this block */
			ulOffset -= pCurr-&gt;tInfo.ulLength;
			continue;
		}
		return pCurr-&gt;tInfo.ulCharPos + ulOffset;
	}
	return CP_INVALID;
} /* end of ulHdrFtrOffset2CharPos */

/*
 * Get the sequence number beloning to the given file offset
 *
 * Returns the sequence number
 */
ULONG
ulGetSeqNumber(ULONG ulFileOffset)
{
	list_mem_type	*pCurr;
	ULONG		ulSeq;

	if (ulFileOffset == FC_INVALID) {
		return FC_INVALID;
	}

	ulSeq = 0;
	for (pCurr = pTextAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		if (ulFileOffset &gt;= pCurr-&gt;tInfo.ulFileOffset &amp;&amp;
		    ulFileOffset &lt; pCurr-&gt;tInfo.ulFileOffset +
		     pCurr-&gt;tInfo.ulLength) {
			/* The file offset is within the current textblock */
			return ulSeq + ulFileOffset - pCurr-&gt;tInfo.ulFileOffset;
		}
		ulSeq += pCurr-&gt;tInfo.ulLength;
	}
	return FC_INVALID;
} /* end of ulGetSeqNumber */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

