<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/properties.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/properties.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * properties.c
 * Copyright (C) 1998-2005 A.J. van Os; Released under GNU GPL
 *
 * Description:
 * Read the properties information from a MS Word file
 */

#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include "antiword.h"


/*
 * Build the lists with Property Information
 */
void
vGetPropertyInfo(FILE *pFile, const pps_info_type *pPPS,
	const ULONG *aulBBD, size_t tBBDLen,
	const ULONG *aulSBD, size_t tSBDLen,
	const UCHAR *aucHeader, int iWordVersion)
{
	options_type	tOptions;

	TRACE_MSG("vGetPropertyInfo");

	fail(pFile == NULL);
	fail(pPPS == NULL &amp;&amp; iWordVersion &gt;= 6);
	fail(aulBBD == NULL &amp;&amp; tBBDLen != 0);
	fail(aulSBD == NULL &amp;&amp; tSBDLen != 0);
	fail(aucHeader == NULL);

	/* Get the options */
	vGetOptions(&amp;tOptions);

	/* Get the property information per Word version */
	switch (iWordVersion) {
	case 0:
		vGet0DopInfo(pFile, aucHeader);
		vGet0SepInfo(pFile, aucHeader);
		vGet0PapInfo(pFile, aucHeader);
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_xml ||
		    tOptions.eConversionType == conversion_fmt_text ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet0ChrInfo(pFile, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vCreate0FontTable();
		}
		vSet0SummaryInfo(pFile, aucHeader);
		break;
	case 1:
	case 2:
		vGet2Stylesheet(pFile, iWordVersion, aucHeader);
		vGet2DopInfo(pFile, aucHeader);
		vGet2SepInfo(pFile, aucHeader);
		vGet2PapInfo(pFile, aucHeader);
		if (tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet2HdrFtrInfo(pFile, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_xml ||
		    tOptions.eConversionType == conversion_fmt_text ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet2ChrInfo(pFile, iWordVersion, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vCreate2FontTable(pFile, iWordVersion, aucHeader);
		}
		vSet2SummaryInfo(pFile, iWordVersion, aucHeader);
		break;
	case 4:
	case 5:
		break;
	case 6:
	case 7:
		vGet6Stylesheet(pFile, pPPS-&gt;tWordDocument.ulSB,
			aulBBD, tBBDLen, aucHeader);
		vGet6DopInfo(pFile, pPPS-&gt;tWordDocument.ulSB,
			aulBBD, tBBDLen, aucHeader);
		vGet6SepInfo(pFile, pPPS-&gt;tWordDocument.ulSB,
			aulBBD, tBBDLen, aucHeader);
		vGet6PapInfo(pFile, pPPS-&gt;tWordDocument.ulSB,
			aulBBD, tBBDLen, aucHeader);
		if (tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet6HdrFtrInfo(pFile, pPPS-&gt;tWordDocument.ulSB,
				aulBBD, tBBDLen, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_xml ||
		    tOptions.eConversionType == conversion_fmt_text ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet6ChrInfo(pFile, pPPS-&gt;tWordDocument.ulSB,
				aulBBD, tBBDLen, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vCreate6FontTable(pFile, pPPS-&gt;tWordDocument.ulSB,
				aulBBD, tBBDLen, aucHeader);
		}
		vSet6SummaryInfo(pFile, pPPS,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		break;
	case 8:
		vGet8LstInfo(pFile, pPPS,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		vGet8Stylesheet(pFile, pPPS,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		vGet8DopInfo(pFile, &amp;pPPS-&gt;tTable,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		vGet8SepInfo(pFile, pPPS,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		vGet8PapInfo(pFile, pPPS,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		if (tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet8HdrFtrInfo(pFile, &amp;pPPS-&gt;tTable,
				aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_xml ||
		    tOptions.eConversionType == conversion_fmt_text ||
		    tOptions.eConversionType == conversion_pdf) {
			vGet8ChrInfo(pFile, pPPS,
				aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		}
		if (tOptions.eConversionType == conversion_draw ||
		    tOptions.eConversionType == conversion_ps ||
		    tOptions.eConversionType == conversion_pdf) {
			vCreate8FontTable(pFile, pPPS,
				aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		}
		vSet8SummaryInfo(pFile, pPPS,
			aulBBD, tBBDLen, aulSBD, tSBDLen, aucHeader);
		break;
	default:
		DBG_DEC(iWordVersion);
		DBG_FIXME();
		werr(0, "Sorry, no property information");
		break;
	}

	/* Temporarily: Correct the font table */
	vCorrectFontTable(tOptions.eConversionType, tOptions.eEncoding);
} /* end of vGetPropertyInfo */

/*
 * ePropMod2RowInfo - Turn the Property Modifier into row information
 *
 * Returns: the row information
 */
row_info_enum
ePropMod2RowInfo(USHORT usPropMod, int iWordVersion)
{
	row_block_type	tRow;
	const UCHAR	*aucPropMod;
	int	iLen;

	TRACE_MSG("ePropMod2RowInfo");

	aucPropMod = aucReadPropModListItem(usPropMod);
	if (aucPropMod == NULL) {
		return found_nothing;
	}
	iLen = (int)usGetWord(0, aucPropMod);

	switch (iWordVersion) {
	case 0:
		return found_nothing;
	case 1:
	case 2:
		return eGet2RowInfo(0, aucPropMod + 2, iLen, &amp;tRow);
	case 4:
	case 5:
		return found_nothing;
	case 6:
	case 7:
		return eGet6RowInfo(0, aucPropMod + 2, iLen, &amp;tRow);
	case 8:
		return eGet8RowInfo(0, aucPropMod + 2, iLen, &amp;tRow);
	default:
		DBG_DEC(iWordVersion);
		DBG_FIXME();
		return found_nothing;
	}
} /* end of ePropMod2RowInfo */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

