<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/saveas.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/saveas.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * saveas.c
 * Copyright (C) 1998-2001 A.J. van Os; Released under GPL
 *
 * Description:
 * Functions to save the results as a textfile or a drawfile
 */

#include &lt;stdio.h&gt;
#include &lt;string.h&gt;
#include "DeskLib:Menu.h"
#include "DeskLib:Save.h"
#include "DeskLib:Template.h"
#include "DeskLib:Window.h"
#include "drawfile.h"
#include "antiword.h"

/* The window handle of the save window */
static window_handle	tSaveWindow = 0;

/* Xfer_send box fields */
#define DRAG_SPRITE	3
#define OK_BUTTON	0
#define CANCEL_BUTTON	(-1)
#define FILENAME_ICON	2


/*
 * saveas - a wrapper around Save_InitSaveWindowhandler
 */
static void
saveas(int iFileType, char *szOutfile, size_t tEstSize,
	save_filesaver save_function, void *pvReference)
{
	TRACE_MSG("saveas");

	if (tSaveWindow == 0) {
		tSaveWindow = Window_Create("xfer_send", template_TITLEMIN);
	}
	Icon_SetText(tSaveWindow, FILENAME_ICON, szOutfile);
	Window_Show(tSaveWindow, open_UNDERPOINTER);
	(void)Save_InitSaveWindowHandler(tSaveWindow, FALSE, TRUE, TRUE,
		DRAG_SPRITE, OK_BUTTON, CANCEL_BUTTON, FILENAME_ICON,
		save_function, NULL, NULL, tEstSize, iFileType, pvReference);
} /* end of saveas */

static BOOL
bWrite2File(void *pvBytes, size_t tSize, FILE *pFile, const char *szFilename)
{
	if (fwrite(pvBytes, sizeof(char), tSize, pFile) != tSize) {
		werr(0, "I can't write to '%s'", szFilename);
		return FALSE;
	}
	return TRUE;
} /* end of bWrite2File */

/*
 * bText2File - Save the generated draw file to a Text file
 */
static BOOL
bText2File(char *szFilename, void *pvHandle)
{
	FILE	*pFile;
	diagram_type	*pDiag;
	drawfile_object	*pObj;
	drawfile_text	*pText;
	const char	*pcTmp;
	int	iToGo, iX, iYtopPrev, iHeight, iLines;
	BOOL	bFirst, bIndent, bSuccess;

	TRACE_MSG("bText2File");

	fail(szFilename == NULL || szFilename[0] == '\0');
	fail(pvHandle == NULL);

	DBG_MSG(szFilename);

	pDiag = (diagram_type *)pvHandle;
	pFile = fopen(szFilename, "w");
	if (pFile == NULL) {
		werr(0, "I can't open '%s' for writing", szFilename);
		return FALSE;
	}
	bFirst = TRUE;
	iYtopPrev = 0;
	iHeight = (int)lWord2DrawUnits20(DEFAULT_FONT_SIZE);
	bSuccess = TRUE;
	fail(pDiag-&gt;tInfo.length &lt; offsetof(drawfile_diagram, objects));
	iToGo = pDiag-&gt;tInfo.length - offsetof(drawfile_diagram, objects);
	DBG_DEC(iToGo);
	pcTmp = (const char *)pDiag-&gt;tInfo.data +
				offsetof(drawfile_diagram, objects);
	while (iToGo &gt; 0 &amp;&amp; bSuccess) {
		pObj = (drawfile_object *)pcTmp;
		switch (pObj-&gt;type) {
		case drawfile_TYPE_TEXT:
			pText = &amp;pObj-&gt;data.text;
			/* Compute the number of lines */
			iLines = (iYtopPrev - pText-&gt;bbox.max.y +
					iHeight / 2) / iHeight;
			DBG_DEC_C(iLines &lt; 0, iYtopPrev);
			DBG_DEC_C(iLines &lt; 0, pText-&gt;bbox.max.y);
			fail(iLines &lt; 0);
			bIndent = iLines &gt; 0 || bFirst;
			bFirst = FALSE;
			/* Print the newlines */
			while (iLines &gt; 0 &amp;&amp; bSuccess) {
				bSuccess = bWrite2File("\n",
					1, pFile, szFilename);
				iLines--;
			}
			/* Print the indentation */
			if (bIndent &amp;&amp; bSuccess) {
				for (iX = Drawfile_ScreenToDraw(8);
				     iX &lt;= pText-&gt;bbox.min.x &amp;&amp; bSuccess;
				     iX += Drawfile_ScreenToDraw(16)) {
					bSuccess = bWrite2File(" ",
						1, pFile, szFilename);
				}
			}
			if (!bSuccess) {
				break;
			}
			/* Print the text object */
			bSuccess = bWrite2File(pText-&gt;text,
				strlen(pText-&gt;text), pFile, szFilename);
			/* Setup for the next object */
			iYtopPrev = pText-&gt;bbox.max.y;
			iHeight = pText-&gt;bbox.max.y - pText-&gt;bbox.min.y;
			break;
		case drawfile_TYPE_FONT_TABLE:
		case drawfile_TYPE_PATH:
		case drawfile_TYPE_SPRITE:
		case drawfile_TYPE_JPEG:
			/* These are not relevant in a textfile */
			break;
		default:
			DBG_DEC(pObj-&gt;type);
			bSuccess = FALSE;
			break;
		}
		pcTmp += pObj-&gt;size;
		iToGo -= pObj-&gt;size;
	}
	DBG_DEC_C(iToGo != 0, iToGo);
	if (bSuccess) {
		bSuccess = bWrite2File("\n", 1, pFile, szFilename);
	}
	(void)fclose(pFile);
	if (bSuccess) {
		vSetFiletype(szFilename, FILETYPE_TEXT);
	} else {
		(void)remove(szFilename);
		werr(0, "Unable to save textfile '%s'", szFilename);
	}
	return bSuccess;
} /* end of bText2File */

/*
 * bSaveTextfile - save the diagram as a text file
 */
BOOL
bSaveTextfile(event_pollblock *pEvent, void *pvReference)
{
	diagram_type	*pDiag;
	size_t	tRecLen, tNbrRecs, tEstSize;

	TRACE_MSG("bSaveTextfile");

	fail(pEvent == NULL);
	fail(pvReference == NULL);

	pDiag = (diagram_type *)pvReference;

	switch (pEvent-&gt;type) {
	case event_SEND:	/* From a menu */
		fail(pEvent-&gt;data.message.header.action != message_MENUWARN);
		if (menu_currentopen != pDiag-&gt;pSaveMenu ||
		    pEvent-&gt;data.message.data.menuwarn.selection[0] !=
							SAVEMENU_SAVETEXT) {
			return FALSE;
		}
		break;
	case event_KEY:		/* From a key short cut */
		if (pEvent-&gt;data.key.caret.window != pDiag-&gt;tMainWindow) {
			return FALSE;
		}
		break;
	default:
		DBG_DEC(pEvent-&gt;type);
		return FALSE;
	}

	tRecLen = sizeof(drawfile_text) + DEFAULT_SCREEN_WIDTH * 2 / 3;
	tNbrRecs = pDiag-&gt;tInfo.length / tRecLen + 1;
	tEstSize = tNbrRecs * DEFAULT_SCREEN_WIDTH * 2 / 3;
	DBG_DEC(tEstSize);

	saveas(FILETYPE_TEXT, "WordText", tEstSize, bText2File, pDiag);
	return TRUE;
} /* end of bSaveTextfile */

/*
 * bDraw2File - Save the generated draw file to a Draw file
 *
 * Remark: This is not a simple copy action. The origin of the
 * coordinates (0,0) must move from the top-left corner to the
 * bottom-left corner.
 */
static BOOL
bDraw2File(char *szFilename, void *pvHandle)
{
	FILE		*pFile;
	diagram_type	*pDiagram;
	wimp_box	*pBbox;
	drawfile_object	*pObj;
	drawfile_text	*pText;
	drawfile_path	*pPath;
	drawfile_sprite	*pSprite;
	drawfile_jpeg	*pJpeg;
	int	*piPath;
	char	*pcTmp;
	int	iYadd, iToGo, iSize;
	BOOL	bSuccess;

	TRACE_MSG("bDraw2File");

	fail(szFilename == NULL || szFilename[0] == '\0');
	fail(pvHandle == NULL);

	NO_DBG_MSG(szFilename);

	pDiagram = (diagram_type *)pvHandle;
	pFile = fopen(szFilename, "wb");
	if (pFile == NULL) {
		werr(0, "I can't open '%s' for writing", szFilename);
		return FALSE;
	}
	iToGo = pDiagram-&gt;tInfo.length;
	DBG_DEC(iToGo);
	pcTmp = pDiagram-&gt;tInfo.data;
	bSuccess = bWrite2File(pcTmp,
			offsetof(drawfile_diagram, bbox), pFile, szFilename);
	if (bSuccess) {
	  	pcTmp += offsetof(drawfile_diagram, bbox);
		iToGo -= offsetof(drawfile_diagram, bbox);
		pBbox = (wimp_box *)pcTmp;
		iYadd = -pBbox-&gt;min.y;
		pBbox-&gt;min.y += iYadd;
		pBbox-&gt;max.y += iYadd;
		bSuccess = bWrite2File(pcTmp,
				sizeof(*pBbox), pFile, szFilename);
		iToGo -= sizeof(*pBbox);
		DBG_DEC(iToGo);
		pcTmp += sizeof(*pBbox);
	} else {
		iYadd = 0;
	}
	while (iToGo &gt; 0 &amp;&amp; bSuccess) {
		pObj = (drawfile_object *)pcTmp;
		iSize = pObj-&gt;size;
		switch (pObj-&gt;type) {
		case drawfile_TYPE_FONT_TABLE:
			bSuccess = bWrite2File(pcTmp,
					iSize, pFile, szFilename);
			pcTmp += iSize;
			iToGo -= iSize;
			break;
		case drawfile_TYPE_TEXT:
			pText = &amp;pObj-&gt;data.text;
			/* First correct the coordinates */
			pText-&gt;bbox.min.y += iYadd;
			pText-&gt;bbox.max.y += iYadd;
			pText-&gt;base.y += iYadd;
			/* Now write the information to file */
			bSuccess = bWrite2File(pcTmp,
					iSize, pFile, szFilename);
			pcTmp += pObj-&gt;size;
			iToGo -= pObj-&gt;size;
			break;
		case drawfile_TYPE_PATH:
			pPath = &amp;pObj-&gt;data.path;
			/* First correct the coordinates */
			pPath-&gt;bbox.min.y += iYadd;
			pPath-&gt;bbox.max.y += iYadd;
			/* Now write the information to file */
			bSuccess = bWrite2File(pPath,
				sizeof(*pPath), pFile, szFilename);
			pcTmp += sizeof(*pPath);
			iSize = pObj-&gt;size - sizeof(*pPath);
			fail(iSize &lt; 14 * sizeof(int));
			/* Second correct the path coordinates */
			piPath = xmalloc(iSize);
			memcpy(piPath, pcTmp, iSize);
			piPath[ 2] += iYadd;
			piPath[ 5] += iYadd;
			piPath[ 8] += iYadd;
			piPath[11] += iYadd;
			if (bSuccess) {
				bSuccess = bWrite2File(piPath,
					iSize, pFile, szFilename);
				pcTmp += iSize;
			}
			piPath = xfree(piPath);
			iToGo -= pObj-&gt;size;
			break;
		case drawfile_TYPE_SPRITE:
			pSprite = &amp;pObj-&gt;data.sprite;
			/* First correct the coordinates */
			pSprite-&gt;bbox.min.y += iYadd;
			pSprite-&gt;bbox.max.y += iYadd;
			/* Now write the information to file */
			bSuccess = bWrite2File(pcTmp,
					iSize, pFile, szFilename);
			pcTmp += pObj-&gt;size;
			iToGo -= pObj-&gt;size;
			break;
		case drawfile_TYPE_JPEG:
			pJpeg = &amp;pObj-&gt;data.jpeg;
			/* First correct the coordinates */
			pJpeg-&gt;bbox.min.y += iYadd;
			pJpeg-&gt;bbox.max.y += iYadd;
			pJpeg-&gt;trfm.entries[2][1] += iYadd;
			/* Now write the information to file */
			bSuccess = bWrite2File(pcTmp,
					iSize, pFile, szFilename);
			pcTmp += pObj-&gt;size;
			iToGo -= pObj-&gt;size;
			break;
		default:
			DBG_DEC(pObj-&gt;type);
			bSuccess = FALSE;
			break;
		}
	}
	DBG_DEC_C(iToGo != 0, iToGo);
	(void)fclose(pFile);
	if (bSuccess) {
		vSetFiletype(szFilename, FILETYPE_DRAW);
	} else {
		(void)remove(szFilename);
		werr(0, "Unable to save drawfile '%s'", szFilename);
	}
	return bSuccess;
} /* end of bDraw2File */

/*
 * bSaveDrawfile - save the diagram as a draw file
 */
BOOL
bSaveDrawfile(event_pollblock *pEvent, void *pvReference)
{
	diagram_type	*pDiag;
	size_t		tEstSize;

	TRACE_MSG("bSaveDrawfile");

	fail(pEvent == NULL);
	fail(pvReference == NULL);

	pDiag = (diagram_type *)pvReference;

	switch (pEvent-&gt;type) {
	case event_SEND:	/* From a menu */
		fail(pEvent-&gt;data.message.header.action != message_MENUWARN);
		if (menu_currentopen != pDiag-&gt;pSaveMenu ||
		    pEvent-&gt;data.message.data.menuwarn.selection[0] !=
							SAVEMENU_SAVEDRAW) {
			return FALSE;
		}
		break;
	case event_KEY:		/* From a key short cut */
		if (pEvent-&gt;data.key.caret.window != pDiag-&gt;tMainWindow) {
			return FALSE;
		}
		break;
	default:
		DBG_DEC(pEvent-&gt;type);
		return FALSE;
	}

	tEstSize = pDiag-&gt;tInfo.length;
	DBG_DEC(tEstSize);

	saveas(FILETYPE_DRAW, "WordDraw", tEstSize, bDraw2File, pDiag);
	return TRUE;
} /* end of bSaveDrawfile */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

