<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/startup.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/startup.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * startup.c
 * Copyright (C) 1998-2001 A.J. van Os; Released under GPL
 *
 * Description:
 * Try to force a single startup of !Antiword
 */

#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;ctype.h&gt;
#include "DeskLib:Error.h"
#include "DeskLib:Event.h"
#include "DeskLib:SWI.h"
#include "antiword.h"


#if !defined(TaskManager_EnumerateTasks)
#define TaskManager_EnumerateTasks	0x042681
#endif /* TaskManager_EnumerateTasks */

/*
 * bIsMatch - decide whether the two strings match
 *
 * like strcmp, but this one ignores case
 */
static BOOL
bIsMatch(const char *szStr1, const char *szStr2)
{
	const char	*pcTmp1, *pcTmp2;

	for (pcTmp1 = szStr1, pcTmp2 = szStr2;
	     *pcTmp1 != '\0';
	     pcTmp1++, pcTmp2++) {
		if (toupper(*pcTmp1) != toupper(*pcTmp2)) {
			return FALSE;
		}
	}
	return *pcTmp2 == '\0';
} /* end of bIsMatch */

/*
 * tGetTaskHandle - get the task handle of the given task
 *
 * returns the task handle when found, otherwise 0
 */
static task_handle
tGetTaskHandle(const char *szTaskname)
{
	const char	*pcTmp;
	int	iReg0, iIndex;
	int	aiBuffer[4];
	char	szTmp[21];

	iReg0 = 0;
	do {
		/* Get info on the next task */
		Error_CheckFatal(SWI(3, 1, TaskManager_EnumerateTasks | XOS_Bit,
			iReg0, aiBuffer, sizeof(aiBuffer), &amp;iReg0));
		/* Copy the (control character terminated) task name */
		for (iIndex = 0, pcTmp = (const char *)aiBuffer[1];
		     iIndex &lt; elementsof(szTmp);
		     iIndex++, pcTmp++) {
			if (iscntrl(*pcTmp)) {
				szTmp[iIndex] = '\0';
				break;
			}
			szTmp[iIndex] = *pcTmp;
		}
		szTmp[elementsof(szTmp) - 1] = '\0';
		if (bIsMatch(szTmp, szTaskname)) {
			/* Task found */
			return (task_handle)aiBuffer[0];
		}
	} while (iReg0 &gt;= 0);

	/* Task not found */
	return 0;
} /* end of tGetTaskHandle */

int
main(int argc, char **argv)
{
	message_block	tMsg;
	task_handle	tTaskHandle;
	size_t	tArgLen;
	int	aiMessages[] = {0};
	char	szCommand[512];

	Event_Initialise3("StartUp", 310, aiMessages);

	if (argc &gt; 1) {
		tArgLen = strlen(argv[1]);
	} else {
		tArgLen = 0;
	}
	if (tArgLen &gt;= sizeof(tMsg.data.dataload.filename)) {
		werr(1, "Input filename too long");
		return EXIT_FAILURE;
	}

	tTaskHandle = tGetTaskHandle("antiword");

	if (tTaskHandle == 0) {
		/* Antiword is not active */
		strcpy(szCommand, "chain:&lt;Antiword$Dir&gt;.!Antiword");
		if (argc &gt; 1) {
			strcat(szCommand, " ");
			strcat(szCommand, argv[1]);
		}
#if defined(DEBUG)
		strcat(szCommand, " ");
		strcat(szCommand, "2&gt;&lt;Antiword$Dir&gt;.Debug");
#endif /* DEBUG */
		system(szCommand);
		/* If we reach here something has gone wrong */
		return EXIT_FAILURE;
	}

	/* Antiword is active */
	if (argc &gt; 1) {
		/*
		 * Send the argument to Antiword by imitating a
		 * drag-and-drop to Antiword's iconbar icon
		 */
		memset(&amp;tMsg, 0, sizeof(tMsg));
		tMsg.header.size = ROUND4(offsetof(message_block, data) +
					offsetof(message_dataload, filename) +
					1 + tArgLen);
		tMsg.header.yourref = 0;
		tMsg.header.action = message_DATALOAD;
		tMsg.data.dataload.window = window_ICONBAR;
		tMsg.data.dataload.icon = -1;
		tMsg.data.dataload.size = 0;
		tMsg.data.dataload.filetype = FILETYPE_MSWORD;
		strcpy(tMsg.data.dataload.filename, argv[1]);
		Error_CheckFatal(Wimp_SendMessage(event_SEND,
						&amp;tMsg, tTaskHandle, 0));
		return EXIT_SUCCESS;
	} else {
		/* Give an error message and return */
		werr(1, "Antiword is already running");
		return EXIT_FAILURE;
	}
} /* end of main */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

