<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/apm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/apm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;/386/include/ureg.h&gt;
typedef struct Ureg Ureg;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

enum {
	/* power mgmt event codes */
	NotifyStandbyRequest		= 0x0001,
	NotifySuspendRequest		= 0x0002,
	NotifyNormalResume 		= 0x0003,
	NotifyCriticalResume		= 0x0004,
	NotifyBatteryLow			= 0x0005,
	NotifyPowerStatusChange	= 0x0006,
	NotifyUpdateTime			= 0x0007,
	NotifyCriticalSuspend		= 0x0008,
	NotifyUserStandbyRequest	= 0x0009,
	NotifyUserSuspendRequest	= 0x000A,
	NotifyStandbyResume		= 0x000B,
	NotifyCapabilitiesChange		= 0x000C,

	/* power device ids: add device number or All */
	DevBios					= 0x0000,
	DevAll					= 0x0001,
	DevDisplay				= 0x0100,
	DevStorage				= 0x0200,
	DevLpt					= 0x0300,
	DevEia					= 0x0400,
	DevNetwork				= 0x0500,
	DevPCMCIA				= 0x0600,
	DevBattery				= 0x8000,
		All					= 0x00FF,
	DevMask					= 0xFF00,

	/* power states */
	PowerEnabled				= 0x0000,
	PowerStandby				= 0x0001,
	PowerSuspend				= 0x0002,
	PowerOff					= 0x0003,

	/* apm commands */
	CmdInstallationCheck		= 0x5300,
	CmdRealModeConnect		= 0x5301,
	CmdProtMode16Connect		= 0x5302,
	CmdProtMode32Connect		= 0x5303,
	CmdDisconnect			= 0x5304,
	CmdCpuIdle				= 0x5305,
	CmdCpuBusy				= 0x5306,
	CmdSetPowerState			= 0x5307,
	CmdSetPowerMgmt	= 0x5308,
	  DisablePowerMgmt	= 0x0000,		/* CX */
	  EnablePowerMgmt	= 0x0001,
	CmdRestoreDefaults			= 0x5309,
	CmdGetPowerStatus			= 0x530A,
	CmdGetPMEvent			= 0x530B,
	CmdGetPowerState			= 0x530C,
	CmdGetPowerMgmt			= 0x530D,
	CmdDriverVersion			= 0x530E,

	/* like CmdDisconnect but doesn't lose the interface */
	CmdGagePowerMgmt	= 0x530F,
	  DisengagePowerMgmt	= 0x0000,	/* CX */
	  EngagePowerManagemenet	= 0x0001,

	CmdGetCapabilities			= 0x5310,
	  CapStandby				= 0x0001,
	  CapSuspend				= 0x0002,
	  CapTimerResumeStandby	= 0x0004,
	  CapTimerResumeSuspend	= 0x0008,
	  CapRingResumeStandby		= 0x0010,
	  CapRingResumeSuspend	= 0x0020,
	  CapPcmciaResumeStandby	= 0x0040,
	  CapPcmciaResumeSuspend	= 0x0080,
	  CapSlowCpu				= 0x0100,
	CmdResumeTimer			= 0x5311,
	  DisableResumeTimer		= 0x00,		/* CL */
	  GetResumeTimer			= 0x01,
	  SetResumeTimer			= 0x02,
	CmdResumeOnRing			= 0x5312,
	  DisableResumeOnRing		= 0x0000,		/* CX */
	  EnableResumeOnRing		= 0x0001,
	  GetResumeOnRing			= 0x0002,
	CmdTimerRequests			= 0x5313,
	  DisableTimerRequests		= 0x0000,		/* CX */
	  EnableTimerRequests		= 0x0001,
	  GetTimerRequests			= 0x0002,
};

static char* eventstr[] = {
[NotifyStandbyRequest]	"system standby request",
[NotifySuspendRequest]	"system suspend request",
[NotifyNormalResume]	"normal resume",
[NotifyCriticalResume]	"critical resume",
[NotifyBatteryLow]		"battery low",
[NotifyPowerStatusChange]	"power status change",
[NotifyUpdateTime]		"update time",
[NotifyCriticalSuspend]	"critical suspend",
[NotifyUserStandbyRequest]	"user standby request",
[NotifyUserSuspendRequest]	"user suspend request",
[NotifyCapabilitiesChange]	"capabilities change",
};

static char*
apmevent(int e)
{
	static char buf[32];

	if(0 &lt;= e &amp;&amp; e &lt; nelem(eventstr) &amp;&amp; eventstr[e])
		return eventstr[e];
	
	sprint(buf, "event 0x%ux", (uint)e);
	return buf;
}

static char *error[256] = {
[0x01]	"power mgmt disabled",
[0x02]	"real mode connection already established",
[0x03]	"interface not connected",
[0x05]	"16-bit protected mode connection already established",
[0x06]	"16-bit protected mode interface not supported",
[0x07]	"32-bit protected mode interface already established",
[0x08]	"32-bit protected mode interface not supported",
[0x09]	"unrecognized device id",
[0x0A]	"parameter value out of range",
[0x0B]	"interface not engaged",
[0x0C]	"function not supported",
[0x0D]	"resume timer disabled",
[0x60]	"unable to enter requested state",
[0x80]	"no power mgmt events pending",
[0x86]	"apm not present",
};

static char*
apmerror(int id)
{
	char *e;
	static char buf[64];

	if(e = error[id&amp;0xFF])
		return e;

	sprint(buf, "unknown error %x", id);
	return buf;
}

QLock apmlock;
int apmdebug;

static int
_apmcall(int fd, Ureg *u)
{
if(apmdebug) fprint(2, "call ax 0x%lux bx 0x%lux cx 0x%lux\n",
	u-&gt;ax&amp;0xFFFF, u-&gt;bx&amp;0xFFFF, u-&gt;cx&amp;0xFFFF);

	seek(fd, 0, 0);
	if(write(fd, u, sizeof *u) != sizeof *u)
		return -1;

	seek(fd, 0, 0);
	if(read(fd, u, sizeof *u) != sizeof *u)
		return -1;

if(apmdebug) fprint(2, "flags 0x%lux ax 0x%lux bx 0x%lux cx 0x%lux\n",
	u-&gt;flags&amp;0xFFFF, u-&gt;ax&amp;0xFFFF, u-&gt;bx&amp;0xFFFF, u-&gt;cx&amp;0xFFFF);

	if(u-&gt;flags &amp; 1) {	/* carry flag */
		werrstr("%s", apmerror(u-&gt;ax&gt;&gt;8));
		return -1;
	}
	return 0;
}

static int
apmcall(int fd, Ureg *u)
{
	int r;

	qlock(&amp;apmlock);
	r = _apmcall(fd, u);
	qunlock(&amp;apmlock);
	return r;
}

typedef struct Apm Apm;
typedef struct Battery Battery;

struct Battery {
	int status;
	int percent;
	int time;
};

enum {
	Mbattery = 4,
};
struct Apm {
	int fd;

	int verhi;
	int verlo;

	int acstatus;
	int nbattery;

	int capabilities;

	Battery battery[Mbattery];
};
enum {
	AcUnknown = 0,		/* Apm.acstatus */
	AcOffline,
	AcOnline,
	AcBackup,

	BatteryUnknown = 0,	/* Battery.status */
	BatteryHigh,
	BatteryLow,
	BatteryCritical,
	BatteryCharging,
};

static char*
acstatusstr[] = {
[AcUnknown]	"unknown",
[AcOffline]	"offline",
[AcOnline]	"online",
[AcBackup]	"backup",
};

static char*
batterystatusstr[] = {
[BatteryUnknown] "unknown",
[BatteryHigh]	"high",
[BatteryLow]	"low",
[BatteryCritical]	"critical",
[BatteryCharging]	"charging",
};

static char*
powerstatestr[] = {
[PowerOff]	"off",
[PowerSuspend]	"suspend",
[PowerStandby]	"standby",
[PowerEnabled]	"on",
};

static char*
xstatus(char **str, int nstr, int x)
{
	if(0 &lt;= x &amp;&amp; x &lt; nstr &amp;&amp; str[x])
		return str[x];
	return "unknown";
}

static char*
batterystatus(int b)
{
	return xstatus(batterystatusstr, nelem(batterystatusstr), b);
}

static char*
powerstate(int s)
{
	return xstatus(powerstatestr, nelem(powerstatestr), s);
}

static char*
acstatus(int a)
{
	return xstatus(acstatusstr, nelem(acstatusstr), a);
}
	  
static int
apmversion(Apm *apm)
{
	Ureg u;

	u.ax = CmdDriverVersion;
	u.bx = 0x0000;
	u.cx = 0x0102;
	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	apm-&gt;verhi = u.cx&gt;&gt;8;
	apm-&gt;verlo = u.cx &amp; 0xFF;

	return u.cx;
}

static int
apmcpuidle(Apm *apm)
{
	Ureg u;

	u.ax = CmdCpuIdle;
	return apmcall(apm-&gt;fd, &amp;u);
}

static int
apmcpubusy(Apm *apm)
{
	Ureg u;

	u.ax = CmdCpuBusy;
	return apmcall(apm-&gt;fd, &amp;u);
}

static int
apmsetpowerstate(Apm *apm, int dev, int state)
{
	Ureg u;

	u.ax = CmdSetPowerState;
	u.bx = dev;
	u.cx = state;
	return apmcall(apm-&gt;fd, &amp;u);
}

static int
apmsetpowermgmt(Apm *apm, int dev, int state)
{
	Ureg u;

	u.ax = CmdSetPowerMgmt;
	u.bx = dev;
	u.cx = state;
	return apmcall(apm-&gt;fd, &amp;u);
}

static int
apmrestoredefaults(Apm *apm, int dev)
{
	Ureg u;

	u.ax = CmdRestoreDefaults;
	u.bx = dev;
	return apmcall(apm-&gt;fd, &amp;u);
}

static int
apmgetpowerstatus(Apm *apm, int dev)
{
	Battery *b;
	Ureg u;

	if(dev == DevAll)
		b = &amp;apm-&gt;battery[0];
	else if((dev &amp; DevMask) == DevBattery) {
		if(dev - DevBattery &lt; nelem(apm-&gt;battery))
			b = &amp;apm-&gt;battery[dev - DevBattery];
		else
			b = nil;
	} else {
		werrstr("bad device number");
		return -1;
	}

	u.ax = CmdGetPowerStatus;
	u.bx = dev;

	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	if((dev &amp; DevMask) == DevBattery)
		apm-&gt;nbattery = u.si;

	switch(u.bx&gt;&gt;8) {
	case 0x00:
		apm-&gt;acstatus = AcOffline;
		break;
	case 0x01:
		apm-&gt;acstatus = AcOnline;
		break;
	case 0x02:
		apm-&gt;acstatus = AcBackup;
		break;
	default:
		apm-&gt;acstatus = AcUnknown;
		break;
	}

	if(b != nil) {
		switch(u.bx&amp;0xFF) {
		case 0x00:
			b-&gt;status = BatteryHigh;
			break;
		case 0x01:
			b-&gt;status = BatteryLow;
			break;
		case 0x02:
			b-&gt;status = BatteryCritical;
			break;
		case 0x03:
			b-&gt;status = BatteryCharging;
			break;
		default:
			b-&gt;status = BatteryUnknown;
			break;
		}

		if((u.cx &amp; 0xFF) == 0xFF)
			b-&gt;percent = -1;
		else
			b-&gt;percent = u.cx &amp; 0xFF;

		if((u.dx&amp;0xFFFF) == 0xFFFF)
			b-&gt;time = -1;
		else if(u.dx &amp; 0x8000)
			b-&gt;time = 60*(u.dx &amp; 0x7FFF);
		else
			b-&gt;time = u.dx &amp; 0x7FFF;
	}

	return 0;
}

static int
apmgetevent(Apm *apm)
{
	Ureg u;

	u.ax = CmdGetPMEvent;
	u.bx = 0;
	u.cx = 0;

	//when u.bx == NotifyNormalResume or NotifyCriticalResume,
	//u.cx &amp; 1 indicates PCMCIA socket was on while suspended,
	//u.cx &amp; 1 == 0 indicates was off.

	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	return u.bx;
}

static int
apmgetpowerstate(Apm *apm, int dev)
{
	Ureg u;

	u.ax = CmdGetPowerState;
	u.bx = dev;
	u.cx = 0;

	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	return u.cx;
}

static int
apmgetpowermgmt(Apm *apm, int dev)
{
	Ureg u;

	u.ax = CmdGetPowerMgmt;
	u.bx = dev;

	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	return u.cx;
}

static int
apmgetcapabilities(Apm *apm)
{
	Ureg u;

	u.ax = CmdGetCapabilities;
	u.bx = DevBios;

	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	apm-&gt;nbattery = u.bx &amp; 0xFF;
	apm-&gt;capabilities &amp;= ~0xFFFF;
	apm-&gt;capabilities |= u.cx;
	return 0;
}

static int
apminstallationcheck(Apm *apm)
{
	Ureg u;

	u.ax = CmdInstallationCheck;
	u.bx = DevBios;
	if(apmcall(apm-&gt;fd, &amp;u) &lt; 0)
		return -1;

	if(u.cx &amp; 0x0004)
		apm-&gt;capabilities |= CapSlowCpu;
	else
		apm-&gt;capabilities &amp;= ~CapSlowCpu;
	return 0;
}

void
apmsetdisplaystate(Apm *apm, int s)
{
	apmsetpowerstate(apm, DevDisplay, s);
}

void
apmblank(Apm *apm)
{
	apmsetdisplaystate(apm, PowerStandby);
}

void
apmunblank(Apm *apm)
{
	apmsetdisplaystate(apm, PowerEnabled);
}

void
apmsuspend(Apm *apm)
{
	apmsetpowerstate(apm, DevAll, PowerSuspend);
}

Apm apm;

void
powerprint(void)
{
	print("%s", ctime(time(0)));
	if(apmgetpowerstatus(&amp;apm, DevAll) == 0) {
		print("%d batteries\n", apm.nbattery);
		print("battery 0: status %s percent %d time %d:%.2d\n",
			batterystatus(apm.battery[0].status), apm.battery[0].percent,
			apm.battery[0].time/60, apm.battery[0].time%60);
	}
}

void*
erealloc(void *v, ulong n)
{
	v = realloc(v, n);
	if(v == nil)
		sysfatal("out of memory reallocating %lud", n);
	setmalloctag(v, getcallerpc(&amp;v));
	return v;
}

void*
emalloc(ulong n)
{
	void *v;

	v = malloc(n);
	if(v == nil)
		sysfatal("out of memory allocating %lud", n);
	memset(v, 0, n);
	setmalloctag(v, getcallerpc(&amp;n));
	return v;
}

char*
estrdup(char *s)
{
	int l;
	char *t;

	if (s == nil)
		return nil;
	l = strlen(s)+1;
	t = emalloc(l);
	memcpy(t, s, l);
	setmalloctag(t, getcallerpc(&amp;s));
	return t;
}

char*
estrdupn(char *s, int n)
{
	int l;
	char *t;

	l = strlen(s);
	if(l &gt; n)
		l = n;
	t = emalloc(l+1);
	memmove(t, s, l);
	t[l] = '\0';
	setmalloctag(t, getcallerpc(&amp;s));
	return t;
}

enum {
	Qroot = 0,
	Qevent,
	Qbattery,
	Qctl,
};

static void rootread(Req*);
static void eventread(Req*);
static void ctlread(Req*);
static void ctlwrite(Req*);
static void batteryread(Req*);

typedef struct Dfile Dfile;
struct Dfile {
	Qid qid;
	char *name;
	ulong mode;
	void (*read)(Req*);
	void (*write)(Req*);
};

Dfile dfile[] = {
	{ {Qroot,0,QTDIR},		"/",		DMDIR|0555,	rootread,		nil, },
	{ {Qevent},		"event",	0444,		eventread,	nil, },
	{ {Qbattery},	"battery",	0444,		batteryread,	nil, },
	{ {Qctl},		"ctl",		0666,		ctlread,		ctlwrite, },
};

static int
fillstat(uvlong path, Dir *d, int doalloc)
{
	int i;

	for(i=0; i&lt;nelem(dfile); i++)
		if(path==dfile[i].qid.path)
			break;
	if(i==nelem(dfile))
		return -1;

	memset(d, 0, sizeof *d);
	d-&gt;uid = doalloc ? estrdup("apm") : "apm";
	d-&gt;gid = doalloc ? estrdup("apm") : "apm";
	d-&gt;length = 0;
	d-&gt;name = doalloc ? estrdup(dfile[i].name) : dfile[i].name;
	d-&gt;mode = dfile[i].mode;
	d-&gt;atime = d-&gt;mtime = time(0);
	d-&gt;qid = dfile[i].qid;
	return 0;
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	int i;

	if(strcmp(name, "..")==0){
		*qid = dfile[0].qid;
		fid-&gt;qid = *qid;
		return nil;
	}

	for(i=1; i&lt;nelem(dfile); i++){	/* i=1: 0 is root dir */
		if(strcmp(dfile[i].name, name)==0){
			*qid = dfile[i].qid;
			fid-&gt;qid = *qid;
			return nil;
		}
	}
	return "file does not exist";
}

static void
fsopen(Req *r)
{
	switch((ulong)r-&gt;fid-&gt;qid.path){
	case Qroot:
		r-&gt;fid-&gt;aux = (void*)0;
		respond(r, nil);
		return;

	case Qevent:
	case Qbattery:
		if(r-&gt;ifcall.mode == OREAD){
			respond(r, nil);
			return;
		}
		break;

	case Qctl:
		if((r-&gt;ifcall.mode&amp;~(OTRUNC|OREAD|OWRITE|ORDWR)) == 0){
			respond(r, nil);
			return;
		}
		break;
	}
	respond(r, "permission denied");
	return;
}

static void
fsstat(Req *r)
{
	fillstat(r-&gt;fid-&gt;qid.path, &amp;r-&gt;d, 1);
	respond(r, nil);
}

static void
fsread(Req *r)
{
	dfile[r-&gt;fid-&gt;qid.path].read(r);
}

static void
fswrite(Req *r)
{
	dfile[r-&gt;fid-&gt;qid.path].write(r);
}

static void
rootread(Req *r)
{
	int n;
	uvlong offset;
	char *p, *ep;
	Dir d;

	if(r-&gt;ifcall.offset == 0)
		offset = 0;
	else
		offset = (uvlong)r-&gt;fid-&gt;aux;

	p = r-&gt;ofcall.data;
	ep = r-&gt;ofcall.data+r-&gt;ifcall.count;

	if(offset == 0)		/* skip root */
		offset = 1;
	for(; p+2 &lt; ep; p+=n){
		if(fillstat(offset, &amp;d, 0) &lt; 0)
			break;
		n = convD2M(&amp;d, (uchar*)p, ep-p);
		if(n &lt;= BIT16SZ)
			break;
		offset++;
	}
	r-&gt;fid-&gt;aux = (void*)offset;
	r-&gt;ofcall.count = p - r-&gt;ofcall.data;
	respond(r, nil);
}

static void
batteryread(Req *r)
{
	char buf[Mbattery*80], *ep, *p;
	int i;

	apmgetpowerstatus(&amp;apm, DevAll);

	p = buf;
	ep = buf+sizeof buf;
	*p = '\0';	/* could be no batteries */
	for(i=0; i&lt;apm.nbattery &amp;&amp; i&lt;Mbattery; i++)
		p += snprint(p, ep-p, "%s %d %d\n",
			batterystatus(apm.battery[i].status),
			apm.battery[i].percent, apm.battery[i].time);
	
	readstr(r, buf);
	respond(r, nil);
}

int
iscmd(char *p, char *cmd)
{
	int l;

	l = strlen(cmd);
	return strncmp(p, cmd, l)==0 &amp;&amp; p[l]=='\0' || p[l]==' ' || p[l]=='\t';
}

char*
skip(char *p, char *cmd)
{
	p += strlen(cmd);
	while(*p==' ' || *p=='\t')
		p++;
	return p;
}

static void
respondx(Req *r, int c)
{
	char err[ERRMAX];

	if(c == 0)
		respond(r, nil);
	else{
		rerrstr(err, sizeof err);
		respond(r, err);
	}
}

/*
 * we don't do suspend because it messes up the
 * cycle counter as well as the pcmcia ethernet cards.
 */
static void
ctlwrite(Req *r)
{
	char buf[80], *p, *q;
	int dev;
	long count;

	count = r-&gt;ifcall.count;
	if(count &gt; sizeof(buf)-1)
		count = sizeof(buf)-1;
	memmove(buf, r-&gt;ifcall.data, count);
	buf[count] = '\0';

	if(count &amp;&amp; buf[count-1] == '\n'){
		--count;
		buf[count] = '\0';
	}

	q = buf;
	p = strchr(q, ' ');
	if(p==nil)
		p = q+strlen(q);
	else
		*p++ = '\0';

	if(strcmp(q, "")==0 || strcmp(q, "system")==0)
		dev = DevAll;
	else if(strcmp(q, "display")==0)
		dev = DevDisplay;
	else if(strcmp(q, "storage")==0)
		dev = DevStorage;
	else if(strcmp(q, "lpt")==0)
		dev = DevLpt;
	else if(strcmp(q, "eia")==0)
		dev = DevEia;
	else if(strcmp(q, "network")==0)
		dev = DevNetwork;
	else if(strcmp(q, "pcmcia")==0)
		dev = DevPCMCIA;
	else{
		respond(r, "unknown device");
		return;
	}

	if(strcmp(p, "enable")==0)
		respondx(r, apmsetpowermgmt(&amp;apm, dev, EnablePowerMgmt));
	else if(strcmp(p, "disable")==0)
		respondx(r, apmsetpowermgmt(&amp;apm, dev, DisablePowerMgmt));
	else if(strcmp(p, "standby")==0)
		respondx(r, apmsetpowerstate(&amp;apm, dev, PowerStandby));
	else if(strcmp(p, "on")==0)
		respondx(r, apmsetpowerstate(&amp;apm, dev, PowerEnabled));
/*
	else if(strcmp(p, "off")==0)
		respondx(r, apmsetpowerstate(&amp;apm, dev, PowerOff));
*/
	else if(strcmp(p, "suspend")==0)
		respondx(r, apmsetpowerstate(&amp;apm, dev, PowerSuspend));
	else
		respond(r, "unknown verb");
}

static int
statusline(char *buf, int nbuf, char *name, int dev)
{
	int s;
	char *state;

	state = "unknown";
	if((s = apmgetpowerstate(&amp;apm, dev)) &gt;= 0)
		state = powerstate(s);
	return snprint(buf, nbuf, "%s %s\n", name, state);
}

static void
ctlread(Req *r)
{
	char buf[256+7*50], *ep, *p;

	p = buf;
	ep = buf+sizeof buf;

	p += snprint(p, ep-p, "ac %s\n", acstatus(apm.acstatus));
	p += snprint(p, ep-p, "capabilities");
	if(apm.capabilities &amp; CapStandby) 
		p += snprint(p, ep-p, " standby");
	if(apm.capabilities &amp; CapSuspend) 
		p += snprint(p, ep-p, " suspend");
	if(apm.capabilities &amp; CapSlowCpu)
		p += snprint(p, ep-p, " slowcpu");
	p += snprint(p, ep-p, "\n");

	p += statusline(p, ep-p, "system", DevAll);
	p += statusline(p, ep-p, "display", DevDisplay);
	p += statusline(p, ep-p, "storage", DevStorage);
	p += statusline(p, ep-p, "lpt", DevLpt);
	p += statusline(p, ep-p, "eia", DevEia|All);
	p += statusline(p, ep-p, "network", DevNetwork|All);
	p += statusline(p, ep-p, "pcmcia", DevPCMCIA|All);
	USED(p);

	readstr(r, buf);
	respond(r, nil);
}

enum {
	STACK = 16384,
};

Channel *creq;
Channel *cflush;
Channel *cevent;
Req *rlist, **tailp;
int rp, wp;
int nopoll;
char eventq[32][80];

static void
flushthread(void*)
{
	Req *r, *or, **rq;

	threadsetname("flushthread");
	while(r = recvp(cflush)){
		or = r-&gt;oldreq;
		for(rq=&amp;rlist; *rq; rq=&amp;(*rq)-&gt;aux){
			if(*rq == or){
				*rq = or-&gt;aux;
				if(tailp==&amp;or-&gt;aux)
					tailp = rq;
				respond(or, "interrupted");
				break;
			}
		}
		respond(r, nil);
	}
}

static void
answerany(void)
{
	char *buf;
	int l, m;
	Req *r;

	if(rlist==nil || rp==wp)
		return;

	while(rlist &amp;&amp; rp != wp){
		r = rlist;
		rlist = r-&gt;aux;
		if(rlist==nil)
			tailp = &amp;rlist;

		l = 0;
		buf = r-&gt;ofcall.data;
		m = r-&gt;ifcall.count;
		while(rp != wp){
			if(l+strlen(eventq[rp]) &lt;= m){
				strcpy(buf+l, eventq[rp]);
				l += strlen(buf+l);
			}else if(l==0){
				strncpy(buf, eventq[rp], m-1);
				buf[m-1] = '\0';
				l += m;
			}else
				break;
			rp++;
			if(rp == nelem(eventq))
				rp = 0;
		}
		r-&gt;ofcall.count = l;
		respond(r, nil);
	}
}

static void
eventwatch(void*)
{
	int e, s;

	threadsetname("eventwatch");
	for(;;){
		s = 0;
		while((e = apmgetevent(&amp;apm)) &gt;= 0){
			sendul(cevent, e);
			s = 1;
		}
		if(s)
			sendul(cevent, -1);
		if(sleep(750) &lt; 0)
			break;
	}
}

static void
eventthread(void*)
{
	int e;

	threadsetname("eventthread");
	for(;;){
		while((e = recvul(cevent)) &gt;= 0){
			snprint(eventq[wp], sizeof(eventq[wp])-1, "%s", apmevent(e));
			strcat(eventq[wp], "\n");
			wp++;
			if(wp==nelem(eventq))
				wp = 0;
			if(wp+1==rp || (wp+1==nelem(eventq) &amp;&amp; rp==0))
				break;
		}
		answerany();
	}
}

static void
eventproc(void*)
{
	Req *r;

	threadsetname("eventproc");

	creq = chancreate(sizeof(Req*), 0);
	cevent = chancreate(sizeof(ulong), 0);
	cflush = chancreate(sizeof(Req*), 0);

	tailp = &amp;rlist;
	if(!nopoll)
		proccreate(eventwatch, nil, STACK);
	threadcreate(eventthread, nil, STACK);
	threadcreate(flushthread, nil, STACK);

	while(r = recvp(creq)){
		*tailp = r;
		r-&gt;aux = nil;
		tailp = &amp;r-&gt;aux;
		answerany();
	}
}

static void
fsflush(Req *r)
{
	sendp(cflush, r);
}

static void
eventread(Req *r)
{
	sendp(creq, r);
}

static void
fsattach(Req *r)
{
	char *spec;
	static int first = 1;

	spec = r-&gt;ifcall.aname;

	if(first){
		first = 0;
		proccreate(eventproc, nil, STACK);
	}

	if(spec &amp;&amp; spec[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;fid-&gt;qid = dfile[0].qid;
	r-&gt;ofcall.qid = dfile[0].qid;
	respond(r, nil);
}

Srv fs = {
.attach=	fsattach,
.walk1=	fswalk1,
.open=	fsopen,
.read=	fsread,
.write=	fswrite,
.stat=	fsstat,
.flush=	fsflush,
};

void
usage(void)
{
	fprint(2, "usage: aux/apm [-ADPi] [-d /dev/apm] [-m /mnt/apm] [-s service]\n");
	exits("usage");
}

void
threadmain(int argc, char **argv)
{
	char *dev, *mtpt, *srv;

	dev = nil;
	mtpt = "/mnt/apm";
	srv = nil;
	ARGBEGIN{
	case 'A':
		apmdebug = 1;
		break;
	case 'D':
		chatty9p = 1;
		break;
	case 'P':
		nopoll = 1;
		break;
	case 'd':
		dev = EARGF(usage());
		break;
	case 'i':
		fs.nopipe++;
		fs.infd = 0;
		fs.outfd = 1;
		mtpt = nil;
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	case 's':
		srv = EARGF(usage());
		break;
	}ARGEND

	if(dev == nil){
		if((apm.fd = open("/dev/apm", ORDWR)) &lt; 0
		&amp;&amp; (apm.fd = open("#P/apm", ORDWR)) &lt; 0){
			fprint(2, "open %s: %r\n", dev);
			threadexitsall("open");
		}
	} else if((apm.fd = open(dev, ORDWR)) &lt; 0){
		fprint(2, "open %s: %r\n", dev);
		threadexitsall("open");
	}

	if(apmversion(&amp;apm) &lt; 0){
		fprint(2, "cannot get apm version: %r\n");
		threadexitsall("apmversion");
	}

	if(apm.verhi &lt; 1 || (apm.verhi==1 &amp;&amp; apm.verlo &lt; 2)){
		fprint(2, "apm version %d.%d not supported\n", apm.verhi, apm.verlo);
		threadexitsall("apmversion");
	}

	if(apmgetcapabilities(&amp;apm) &lt; 0)
		fprint(2, "warning: cannot read apm capabilities: %r\n");

	apminstallationcheck(&amp;apm);
	apmcpuidle(&amp;apm);

	rfork(RFNOTEG);
	threadpostmountsrv(&amp;fs, srv, mtpt, MREPL);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

