<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/conswdir.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/conswdir.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Process in-band messages about window title changes.
 * The messages are of the form:
 *
 *	\033];xxx\007
 *
 * where xxx is the new directory.  This format was chosen
 * because it changes the label on xterm windows.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;

struct {
	char *file;
	char name[512];
} keep[] = {
	{ "/dev/label" },
	{ "/dev/wdir" }
};

char *prog = "/bin/rwd";

void
usage(void)
{
	fprint(2, "usage: conswdir [/bin/rwd]\n");
	exits("usage");
}

void
save(void)
{
	int i, fd;
	for(i = 0; i &lt; nelem(keep); i++){
		*keep[i].name = 0;
		if((fd = open(keep[i].file, OREAD)) != -1){
			read(fd, keep[i].name, sizeof(keep[i].name));
			close(fd);
		}
	}
}

void
rest(void)
{
	int i, fd;
	for(i = 0; i &lt; nelem(keep); i++)
		if((fd = open(keep[i].file, OWRITE)) != -1){
			write(fd, keep[i].name, strlen(keep[i].name));
			close(fd);
		}

}

void
setpath(char *s)
{
	switch(rfork(RFPROC|RFFDG|RFNOWAIT)){
	case 0:
		execl(prog, prog, s, nil);
		_exits(nil);
	}
}

enum
{
	None,
	Esc,
	Brack,
	Semi,
	Bell,
};

int
process(char *buf, int n, int *pn)
{
	char *p;
	char path[4096];
	int start, state;

	start = 0;
	state = None;
	for(p=buf; p&lt;buf+n; p++){
		switch(state){
		case None:
			if(*p == '\033'){
				start = p-buf;
				state++;
			}
			break;
		case Esc:
			if(*p == ']')
				state++;
			else
				state = None;
			break;
		case Brack:
			if(*p == ';')
				state++;
			else
				state = None;
			break;
		case Semi:
			if(*p == '\007')
				state++;
			else if((uchar)*p &lt; 040)
				state = None;
			break;
		}
		if(state == Bell){
			memmove(path, buf+start+3, p - (buf+start+3));
			path[p-(buf+start+3)] = 0;
			p++;
			memmove(buf+start, p, n-(p-buf));
			n -= p-(buf+start);
			p = buf+start;
			p--;
			start = 0;
			state = None;
			setpath(path);
		}
	}
	/* give up if we go too long without seeing the close */
	*pn = n;
	if(state == None || p-(buf+start) &gt;= 2048)
		return (p - buf);
	else
		return start;
}

static void
catchint(void*, char *msg)
{
	if(strstr(msg, "interrupt"))
		noted(NCONT);
	else if(strstr(msg, "kill"))
		noted(NDFLT);
	else
		noted(NCONT);
}

void
main(int argc, char **argv)
{
	char buf[4096];
	int n, m;

	notify(catchint);

	ARGBEGIN{
	default:
		usage();
	}ARGEND

	if(argc &gt; 1)
		usage();
	if(argc == 1)
		prog = argv[0];

	save();
	n = 0;
	for(;;){
		m = read(0, buf+n, sizeof buf-n);
		if(m &lt; 0){
			rerrstr(buf, sizeof buf);
			if(strstr(buf, "interrupt"))
				continue;
			break;
		}
		n += m;
		m = process(buf, n, &amp;n);
		if(m &gt; 0){
			write(1, buf, m);
			memmove(buf, buf+m, n-m);
			n -= m;
		}
	}
	rest();
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

