<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/disksim.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/disksim.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

typedef struct Part Part;
typedef struct Trip Trip;
typedef struct Dbl Dbl;
typedef struct Ind Ind;

/*
 * with 8192-byte blocks and 4-byte pointers,
 * double-indirect gets us 34 GB. 
 * triple-indirect gets us 70,368 GB.
 */

enum
{
	LOGBLKSZ = 13,
	BLKSZ = 1&lt;&lt;LOGBLKSZ,	/* 8192 */
	LOGNPTR = LOGBLKSZ-2,	/* assume sizeof(void*) == 4 */
	NPTR = 1&lt;&lt;LOGNPTR,
};
static uchar zero[BLKSZ];

struct Trip
{
	Dbl *dbl[NPTR];	
};

struct Dbl
{
	Ind *ind[NPTR];
};

struct Ind
{
	uchar *blk[NPTR];
};

Trip trip;

struct Part
{
	int inuse;
	int vers;
	ulong mode;
	char *name;
	vlong offset;	/* in sectors */
	vlong length;	/* in sectors */
};

enum
{
	Qroot = 0,
	Qdir,
	Qctl,
	Qpart,
};

Part tab[64];
int fd = -1;
char *sdname = "sdXX";
ulong ctlmode = 0666;
char *inquiry = "aux/disksim hard drive";
vlong nsect, sectsize, c, h, s;
ulong time0;
int rdonly;

char*
ctlstring(void)
{
	int i;
	Fmt fmt;

	fmtstrinit(&amp;fmt);
	fmtprint(&amp;fmt, "inquiry %s\n", inquiry);
	fmtprint(&amp;fmt, "geometry %lld %lld %lld %lld %lld\n", nsect, sectsize, c, h, s);
	for(i=0; i&lt;nelem(tab); i++)
		if(tab[i].inuse)
			fmtprint(&amp;fmt, "part %s %lld %lld\n", tab[i].name, tab[i].offset, tab[i].length);
	return fmtstrflush(&amp;fmt);
}

int
addpart(char *name, vlong start, vlong end)
{
	int i;

	if(start &lt; 0 || start &gt; end || end &gt; nsect){
		werrstr("bad partition boundaries");
		return -1;
	}

	for(i=0; i&lt;nelem(tab); i++)
		if(tab[i].inuse == 0)
			break;
	if(i == nelem(tab)){
		werrstr("no free partition slots");
		return -1;	
	}

	free(tab[i].name);
	tab[i].inuse = 1;
	tab[i].name = estrdup9p(name);
	tab[i].offset = start;
	tab[i].length = end - start;
	tab[i].mode = ctlmode;
	tab[i].vers++;

	return 0;
}

int
delpart(char *s)
{
	int i;

	for(i=0; i&lt;nelem(tab); i++)
		if(tab[i].inuse &amp;&amp; strcmp(tab[i].name, s) == 0)
			break;
	if(i==nelem(tab)){
		werrstr("partition not found");
		return -1;
	}

	tab[i].inuse = 0;
	free(tab[i].name);
	tab[i].name = 0;
	return 0;
}

void
ctlwrite(Req *r)
{
	int i;
	Cmdbuf *cb;
	vlong start, end;

	r-&gt;ofcall.count = r-&gt;ifcall.count;
	cb = parsecmd(r-&gt;ifcall.data, r-&gt;ifcall.count);
	if(cb-&gt;nf &lt; 1){
		respond(r, "empty control message");
		free(cb);
		return;
	}

	if(strcmp(cb-&gt;f[0], "part") == 0){
		if(cb-&gt;nf != 4){
			respondcmderror(r, cb, "part takes 3 args");
			free(cb);
			return;
		}
		start = strtoll(cb-&gt;f[2], 0, 0);
		end = strtoll(cb-&gt;f[3], 0, 0);
		if(addpart(cb-&gt;f[1], start, end) &lt; 0){
			respondcmderror(r, cb, "%r");
			free(cb);
			return;
		}
	}
	else if(strcmp(cb-&gt;f[0], "delpart") == 0){
		if(cb-&gt;nf != 2){
			respondcmderror(r, cb, "delpart takes 1 arg");
			free(cb);
			return;
		}
		if(delpart(cb-&gt;f[1]) &lt; 0){
			respondcmderror(r, cb, "%r");
			free(cb);
			return;
		}
	}
	else if(strcmp(cb-&gt;f[0], "inquiry") == 0){
		if(cb-&gt;nf != 2){
			respondcmderror(r, cb, "inquiry takes 1 arg");
			free(cb);
			return;
		}
		free(inquiry);
		inquiry = estrdup9p(cb-&gt;f[1]);
	}
	else if(strcmp(cb-&gt;f[0], "geometry") == 0){
		if(cb-&gt;nf != 6){
			respondcmderror(r, cb, "geometry takes 5 args");
			free(cb);
			return;
		}
		nsect = strtoll(cb-&gt;f[1], 0, 0);
		sectsize = strtoll(cb-&gt;f[2], 0, 0);
		c = strtoll(cb-&gt;f[3], 0, 0);
		h = strtoll(cb-&gt;f[4], 0, 0);
		s = strtoll(cb-&gt;f[5], 0, 0);
		if(tab[0].inuse &amp;&amp; strcmp(tab[0].name, "data") == 0 &amp;&amp; tab[0].vers == 0){
			tab[0].offset = 0;
			tab[0].length = nsect;
		}
		for(i=0; i&lt;nelem(tab); i++){
			if(tab[i].inuse &amp;&amp; tab[i].offset+tab[i].length &gt; nsect){
				tab[i].inuse = 0;
				free(tab[i].name);
				tab[i].name = 0;
			}
		}
	}
	else{
		respondcmderror(r, cb, "unknown control message");
		free(cb);
		return;
	}

	free(cb);
	respond(r, nil);
}
	
void*
allocblk(vlong addr)
{
	uchar *op;
	static uchar *p;
	static ulong n;

	if(n == 0){
		p = malloc(4*1024*1024);
		if(p == 0)
			sysfatal("out of memory");
		n = 4*1024*1024;
	}
	op = p;
	p += BLKSZ;
	n -= BLKSZ;
	memset(op, 0, BLKSZ);
	if(fd != -1 &amp;&amp; addr != -1)
		pread(fd, op, BLKSZ, addr);
	return op;
}

uchar*
getblock(vlong addr, int alloc)
{
 	Dbl *p2;
	Ind *p1;
	uchar *p0;
	uint i0, i1, i2;
	vlong oaddr;

	if(fd &gt;= 0)
		alloc = 1;

	addr &gt;&gt;= LOGBLKSZ;
	oaddr = addr&lt;&lt;LOGBLKSZ;
	i0 = addr &amp; (NPTR-1);
	addr &gt;&gt;= LOGNPTR;
	i1 = addr &amp; (NPTR-1);
	addr &gt;&gt;= LOGNPTR;
	i2 = addr &amp; (NPTR-1);
	addr &gt;&gt;= LOGNPTR;
	assert(addr == 0);

	if((p2 = trip.dbl[i2]) == 0){
		if(!alloc)
			return zero;
		trip.dbl[i2] = p2 = allocblk(-1);
	}

	if((p1 = p2-&gt;ind[i1]) == 0){
		if(!alloc)
			return zero;
		p2-&gt;ind[i1] = p1 = allocblk(-1);
	}

	if((p0 = p1-&gt;blk[i0]) == 0){
		if(!alloc)
			return zero;
		p1-&gt;blk[i0] = p0 = allocblk(oaddr);
	}
	return p0;
}

void
dirty(vlong addr, uchar *buf)
{
	vlong oaddr;

	if(fd == -1 || rdonly)
		return;
	oaddr = addr&amp;~((vlong)BLKSZ-1);
	if(pwrite(fd, buf, BLKSZ, oaddr) != BLKSZ)
		sysfatal("write: %r");
}
	
int
rootgen(int off, Dir *d, void*)
{
	memset(d, 0, sizeof *d);
	d-&gt;atime = time0;
	d-&gt;mtime = time0;
	if(off == 0){
		d-&gt;name = estrdup9p(sdname);
		d-&gt;mode = DMDIR|0777;
		d-&gt;qid.path = Qdir;
		d-&gt;qid.type = QTDIR;
		d-&gt;uid = estrdup9p("disksim");
		d-&gt;gid = estrdup9p("disksim");
		d-&gt;muid = estrdup9p("");
		return 0;
	}
	return -1;
}	
		
int
dirgen(int off, Dir *d, void*)
{
	int n, j;

	memset(d, 0, sizeof *d);
	d-&gt;atime = time0;
	d-&gt;mtime = time0;
	if(off == 0){
		d-&gt;name = estrdup9p("ctl");
		d-&gt;mode = ctlmode;
		d-&gt;qid.path = Qctl;
		goto Have;
	}

	off--;
	n = 0;
	for(j=0; j&lt;nelem(tab); j++){
		if(tab[j].inuse==0)
			continue;
		if(n == off){
			d-&gt;name = estrdup9p(tab[j].name);
			d-&gt;length = tab[j].length*sectsize;
			d-&gt;mode = tab[j].mode;
			d-&gt;qid.path = Qpart+j;
			d-&gt;qid.vers = tab[j].vers;
			goto Have;
		}
		n++;
	}
	return -1;

Have:
	d-&gt;uid = estrdup9p("disksim");
	d-&gt;gid = estrdup9p("disksim");
	d-&gt;muid = estrdup9p("");
	return 0;
}

void*
evommem(void *a, void *b, ulong n)
{
	return memmove(b, a, n);
}

int
isnonzero(void *v, ulong n)
{
	uchar *a, *ea;
	
	a = v;
	ea = a+n;
	for(; a&lt;ea; a++)
		if(*a)
			return 1;
	return 0;
}

int
rdwrpart(Req *r)
{
	int q, nonzero;
	Part *p;
	vlong offset;
	long count, tot, n, o;
	uchar *blk, *dat;
	void *(*move)(void*, void*, ulong);

	q = r-&gt;fid-&gt;qid.path-Qpart;
	if(q &lt; 0 || q &gt; nelem(tab) || !tab[q].inuse || tab[q].vers != r-&gt;fid-&gt;qid.vers){
		respond(r, "unknown partition");
		return -1;
	}

	p = &amp;tab[q];
	offset = r-&gt;ifcall.offset;
	count = r-&gt;ifcall.count;
	if(offset &lt; 0){
		respond(r, "negative offset");
		return -1;
	}
	if(count &lt; 0){
		respond(r, "negative count");
		return -1;
	}
	if(offset &gt; p-&gt;length*sectsize){
		respond(r, "offset past end of partition");
		return -1;
	}
	if(offset+count &gt; p-&gt;length*sectsize)
		count = p-&gt;length*sectsize - offset;
	offset += p-&gt;offset*sectsize;

	if(r-&gt;ifcall.type == Tread)
		move = memmove;
	else
		move = evommem;

	tot = 0;
	nonzero = 1;
	if(r-&gt;ifcall.type == Tread)
		dat = (uchar*)r-&gt;ofcall.data;
	else{
		dat = (uchar*)r-&gt;ifcall.data;
		nonzero = isnonzero(dat, r-&gt;ifcall.count);
	}
	o = offset &amp; (BLKSZ-1);

	/* left fringe block */
	if(o &amp;&amp; count){
		blk = getblock(offset, r-&gt;ifcall.type==Twrite &amp;&amp; nonzero);
		n = BLKSZ - o;
		if(n &gt; count)
			n = count;
		if(r-&gt;ifcall.type != Twrite || blk != zero)
			(*move)(dat, blk+o, n);
		if(r-&gt;ifcall.type == Twrite)
			dirty(offset, blk);
		tot += n;
	}
	/* full and right fringe blocks */
	while(tot &lt; count){
		blk = getblock(offset+tot, r-&gt;ifcall.type==Twrite &amp;&amp; nonzero);
		n = BLKSZ;
		if(n &gt; count-tot)
			n = count-tot;
		if(r-&gt;ifcall.type != Twrite || blk != zero)
			(*move)(dat+tot, blk, n);
		if(r-&gt;ifcall.type == Twrite)
			dirty(offset+tot, blk);
		tot += n;
	}
	r-&gt;ofcall.count = tot;
	respond(r, nil);
	return 0;
}

void
fsread(Req *r)
{
	char *s;

	switch((int)r-&gt;fid-&gt;qid.path){
	case Qroot:
		dirread9p(r, rootgen, nil);
		respond(r, nil);
		break;

	case Qdir:
		dirread9p(r, dirgen, nil);
		respond(r, nil);
		break;

	case Qctl:
		s = ctlstring();
		readstr(r, s);
		free(s);
		respond(r, nil);
		break;

	default:
		rdwrpart(r);
		break;
	}
}

void
fswrite(Req *r)
{
	switch((int)r-&gt;fid-&gt;qid.path){
	case Qroot:
	case Qdir:
		respond(r, "write to a directory?");
		break;

	case Qctl:
		ctlwrite(r);
		break;

	default:
		rdwrpart(r);
		break;
	}
}

void
fsopen(Req *r)
{
	if(r-&gt;ifcall.mode&amp;ORCLOSE)
		respond(r, "cannot open ORCLOSE");

	switch((int)r-&gt;fid-&gt;qid.path){
	case Qroot:
	case Qdir:
		if(r-&gt;ifcall.mode != OREAD){
			respond(r, "bad mode for directory open");
			return;
		}
	}

	respond(r, nil);
}

void
fsstat(Req *r)
{
	int q;
	Dir *d;
	Part *p;

	d = &amp;r-&gt;d;
	memset(d, 0, sizeof *d);
	d-&gt;qid = r-&gt;fid-&gt;qid;
	d-&gt;atime = d-&gt;mtime = time0;
	q = r-&gt;fid-&gt;qid.path;
	switch(q){
	case Qroot:
		d-&gt;name = estrdup9p("/");
		d-&gt;mode = DMDIR|0777;
		break;

	case Qdir:
		d-&gt;name = estrdup9p(sdname);
		d-&gt;mode = DMDIR|0777;
		break;

	default:
		q -= Qpart;
		if(q &lt; 0 || q &gt; nelem(tab) || tab[q].inuse==0 || r-&gt;fid-&gt;qid.vers != tab[q].vers){
			respond(r, "partition no longer exists");
			return;
		}
		p = &amp;tab[q];
		d-&gt;name = estrdup9p(p-&gt;name);
		d-&gt;length = p-&gt;length * sectsize;
		d-&gt;mode = p-&gt;mode;
		break;
	}
		
	d-&gt;uid = estrdup9p("disksim");
	d-&gt;gid = estrdup9p("disksim");
	d-&gt;muid = estrdup9p("");
	respond(r, nil);
}

void
fsattach(Req *r)
{
	char *spec;

	spec = r-&gt;ifcall.aname;
	if(spec &amp;&amp; spec[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;ofcall.qid = (Qid){Qroot, 0, QTDIR};
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	respond(r, nil);
}

char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	int i;
	switch((int)fid-&gt;qid.path){
	case Qroot:
		if(strcmp(name, sdname) == 0){
			fid-&gt;qid.path = Qdir;
			fid-&gt;qid.type = QTDIR;
			*qid = fid-&gt;qid;
			return nil;
		}
		break;
	case Qdir:
		if(strcmp(name, "ctl") == 0){
			fid-&gt;qid.path = Qctl;
			fid-&gt;qid.vers = 0;
			fid-&gt;qid.type = 0;
			*qid = fid-&gt;qid;
			return nil;
		}
		for(i=0; i&lt;nelem(tab); i++){
			if(tab[i].inuse &amp;&amp; strcmp(tab[i].name, name) == 0){
				fid-&gt;qid.path = i+Qpart;
				fid-&gt;qid.vers = tab[i].vers;
				fid-&gt;qid.type = 0;
				*qid = fid-&gt;qid;
				return nil;
			}
		}
		break;
	}
	return "file not found";
}

Srv fs = {
	.attach=	fsattach,
	.open=	fsopen,
	.read=	fsread,
	.write=	fswrite,
	.stat=	fsstat,
	.walk1=	fswalk1,
};

char *mtpt = "/dev";
char *srvname;

void
usage(void)
{
	fprint(2, "usage: aux/disksim [-D] [-f file] [-s srvname] [-m mtpt] [sdXX]\n");
	fprint(2, "\tdefault mtpt is /dev\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	char *file;

	file = nil;
	quotefmtinstall();
	time0 = time(0);
	if(NPTR != BLKSZ/sizeof(void*))
		sysfatal("unexpected pointer size");

	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'f':
		file = EARGF(usage());
		break;
	case 'r':
		rdonly = 1;
		break;
	case 's':
		srvname = EARGF(usage());
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(argc &gt; 1)
		usage();
	if(argc == 1)
		sdname = argv[0];

	if(file){
		if((fd = open(file, rdonly ? OREAD : ORDWR)) &lt; 0)
			sysfatal("open %s: %r", file);
	}

	inquiry = estrdup9p(inquiry);
	tab[0].name = estrdup9p("data");
	tab[0].inuse = 1;
	tab[0].mode = 0666;

	postmountsrv(&amp;fs, srvname, mtpt, MBEFORE);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

