<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/flashfs/conv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/flashfs/conv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "flashfs.h"

int
convJ2M(Jrec *j, uchar *buff)
{
	int m, n;

	switch(j-&gt;type) {
	case FT_create:
		if(j-&gt;mode &amp; (1 &lt;&lt; 8)) {
			if(j-&gt;mode &amp; DMDIR)
				j-&gt;type = FT_DCREATE1;
			else
				j-&gt;type = FT_FCREATE1;
		}
		else {
			if(j-&gt;mode &amp; DMDIR)
				j-&gt;type = FT_DCREATE0;
			else
				j-&gt;type = FT_FCREATE0;
		}
	case FT_FCREATE0:
	case FT_FCREATE1:
	case FT_DCREATE0:
	case FT_DCREATE1:
		n = putc3(&amp;buff[0], j-&gt;fnum);
		goto create;
	case FT_chmod:
		if(j-&gt;mode &amp; (1 &lt;&lt; 8))
			j-&gt;type = FT_CHMOD1;
		else
			j-&gt;type = FT_CHMOD0;
	case FT_CHMOD0:
	case FT_CHMOD1:
		n = putc3(&amp;buff[0], j-&gt;fnum);
		buff[n++] = j-&gt;mode;
		return n + putc3(&amp;buff[n], j-&gt;mnum);
	case FT_REMOVE:
		return putc3(&amp;buff[0], j-&gt;fnum);
	case FT_WRITE:
		n = putc3(&amp;buff[0], j-&gt;fnum);
		n += putc3(&amp;buff[n], j-&gt;mtime);
		n += putc3(&amp;buff[n], j-&gt;offset);
		return n + putc3(&amp;buff[n], j-&gt;size - 1);
	case FT_AWRITE:
		n = putc3(&amp;buff[0], j-&gt;fnum);
		n += putc3(&amp;buff[n], j-&gt;offset);
		return n + putc3(&amp;buff[n], j-&gt;size - 1);
	case FT_trunc:
		if(j-&gt;mode &amp; (1 &lt;&lt; 8))
			j-&gt;type = FT_TRUNC1;
		else
			j-&gt;type = FT_TRUNC0;
	case FT_TRUNC0:
	case FT_TRUNC1:
		n = putc3(&amp;buff[0], j-&gt;fnum);
		n += putc3(&amp;buff[n], j-&gt;tnum);
		goto create;
	case FT_SUMMARY:
	case FT_SUMBEG:
		return putc3(&amp;buff[0], j-&gt;seq);
	case FT_SUMEND:
		return 0;
	create:
		buff[n++] = j-&gt;mode;
		n += putc3(&amp;buff[n], j-&gt;mtime);
		n += putc3(&amp;buff[n], j-&gt;parent);
		m = strlen(j-&gt;name);
		memmove(&amp;buff[n], j-&gt;name, m);
		n += m;
		buff[n++] = '\0';
		return n;
	}
	return -1;
}

int
convM2J(Jrec *j, uchar *buff)
{
	int m, n;

	j-&gt;type = buff[0];

	switch(j-&gt;type) {
	case FT_FCREATE0:
	case FT_FCREATE1:
	case FT_DCREATE0:
	case FT_DCREATE1:
		n = 1 + getc3(&amp;buff[1], &amp;j-&gt;fnum);
		j-&gt;mode = buff[n++];
		switch(j-&gt;type) {
		case FT_FCREATE0:
			break;
		case FT_FCREATE1:
			j-&gt;mode |= 1 &lt;&lt; 8;
			break;
		case FT_DCREATE0:
			j-&gt;mode |= DMDIR;
			break;
		case FT_DCREATE1:
			j-&gt;mode |= DMDIR | (1 &lt;&lt; 8);
			break;
		}
		j-&gt;type = FT_create;
		goto create;
	case FT_CHMOD0:
	case FT_CHMOD1:
		n = 1 + getc3(&amp;buff[1], &amp;j-&gt;fnum);
		j-&gt;mode = buff[n++];
		switch(j-&gt;type) {
		case FT_CHMOD0:
			break;
		case FT_CHMOD1:
			j-&gt;mode |= 1 &lt;&lt; 8;
			break;
		}
		j-&gt;type = FT_chmod;
		return n + getc3(&amp;buff[n], &amp;j-&gt;mnum);
	case FT_REMOVE:
		return 1 + getc3(&amp;buff[1], &amp;j-&gt;fnum);
	case FT_WRITE:
		n = 1 + getc3(&amp;buff[1], &amp;j-&gt;fnum);
		n += getc3(&amp;buff[n], &amp;j-&gt;mtime);
		n += getc3(&amp;buff[n], &amp;j-&gt;offset);
		n += getc3(&amp;buff[n], &amp;j-&gt;size);
		j-&gt;size++;
		return n;
	case FT_AWRITE:
		n = 1 + getc3(&amp;buff[1], &amp;j-&gt;fnum);
		n += getc3(&amp;buff[n], &amp;j-&gt;offset);
		n += getc3(&amp;buff[n], &amp;j-&gt;size);
		j-&gt;size++;
		return n;
	case FT_TRUNC0:
	case FT_TRUNC1:
		n = 1 + getc3(&amp;buff[1], &amp;j-&gt;fnum);
		n += getc3(&amp;buff[n], &amp;j-&gt;tnum);
		j-&gt;mode = buff[n++];
		switch(j-&gt;type) {
		case FT_TRUNC0:
			break;
		case FT_TRUNC1:
			j-&gt;mode |= 1 &lt;&lt; 8;
			break;
		}
		j-&gt;type = FT_trunc;
		goto create;
	case FT_SUMMARY:
	case FT_SUMBEG:
		return 1 + getc3(&amp;buff[1], &amp;j-&gt;seq);
	case FT_SUMEND:
		return 1;
	create:
		n += getc3(&amp;buff[n], &amp;j-&gt;mtime);
		n += getc3(&amp;buff[n], &amp;j-&gt;parent);
		memmove(j-&gt;name, &amp;buff[n], MAXNSIZE+1);
		j-&gt;name[MAXNSIZE+1] = '\0';
		m = strlen(j-&gt;name);
		if(m &gt; MAXNSIZE)
			return -1;
		return n + m + 1;
	}
	return -1;
}

int
Jconv(Fmt *fp)
{
	Jrec *j;

	j = va_arg(fp-&gt;args, Jrec *);
	switch(j-&gt;type) {
	case FT_create:
	case FT_FCREATE0:
	case FT_FCREATE1:
	case FT_DCREATE0:
	case FT_DCREATE1:
		return fmtprint(fp, "create f %ld p %ld t %lud m %ulo %s",
			j-&gt;fnum, j-&gt;parent, j-&gt;mtime, j-&gt;mode, j-&gt;name);
	case FT_chmod:
	case FT_CHMOD0:
	case FT_CHMOD1:
		return fmtprint(fp, "chmod f %ld m %ulo #%ld",
			j-&gt;fnum, j-&gt;mode, j-&gt;mnum);
	case FT_REMOVE:
		return fmtprint(fp, "remove f %ld", j-&gt;fnum);
	case FT_WRITE:
		return fmtprint(fp, "write f %ld z %ld o %ld t %uld",
			j-&gt;fnum, j-&gt;size, j-&gt;offset, j-&gt;mtime);
	case FT_AWRITE:
		return fmtprint(fp, "awrite f %ld z %ld o %ld",
			j-&gt;fnum, j-&gt;size, j-&gt;offset);
	case FT_trunc:
	case FT_TRUNC0:
	case FT_TRUNC1:
		return fmtprint(fp, "trunc f %ld o %ld p %ld t %ld m %ulo %s",
			j-&gt;fnum, j-&gt;tnum, j-&gt;parent, j-&gt;mtime, j-&gt;mode, j-&gt;name);
	case FT_SUMMARY:
		return fmtprint(fp, "summary %ld",
			j-&gt;seq);
	case FT_SUMBEG:
		return fmtprint(fp, "sumbeg %ld",
			j-&gt;seq);
	case FT_SUMEND:
		return fmtprint(fp, "end");
	default:
		return fmtprint(fp, "?type %d", j-&gt;type);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

