<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/flashfs/dreq.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/flashfs/dreq.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "flashfs.h"

static	Srv	flashsrv;

typedef struct	State	State;

struct State
{
	Entry	*e;
	Dirr	*r;
};

#define	writeable(e)	((e)-&gt;mode &amp; 0222)

static State *
state(Entry *e)
{
	State *s;

	s = emalloc9p(sizeof(State));
	s-&gt;e = e;
	s-&gt;r = nil;
	return s;
}

static void
destroy(Fid *f)
{
	State *s;

	s = f-&gt;aux;
	if(s-&gt;e)
		edestroy(s-&gt;e);
	if(s-&gt;r)
		edirclose(s-&gt;r);
	free(s);
}

static void
trace(Req *)
{
	edump();
}

/** T_ **/

static void
flattach(Req *r)
{
	root-&gt;ref++;
	r-&gt;ofcall.qid = eqid(root);
	r-&gt;fid-&gt;aux = state(root);
	respond(r, nil);
}

static void
flopen(Req *r)
{
	int m, p;
	Entry *e;
	State *s;

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	m = e-&gt;mode;
	m = (m | (m &gt;&gt; 3) | (m &gt;&gt; 6)) &amp; 7;
	switch(r-&gt;ifcall.mode &amp; 3) {
	case OREAD:
		p = AREAD;
		break;
	case OWRITE:
		p = AWRITE;
		break;
	case ORDWR:
		p = AREAD|AWRITE;
		break;
	case OEXEC:
		p = AEXEC;
		break;
	default:
		p = 0;
		break;
	}

	if((p &amp; m) != p) {
		respond(r, Eperm);
		return;
	}

	if(readonly &amp;&amp; (p &amp; AWRITE) != 0) {
		respond(r, Erofs);
		return;
	}

	r-&gt;ofcall.qid = eqid(e);
	if(r-&gt;ofcall.qid.type &amp; QTDIR)
		s-&gt;r = ediropen(s-&gt;e);
	else if(r-&gt;ifcall.mode &amp; OTRUNC)
		etrunc(e, 0, time(0));

	respond(r, nil);
}

static void
flcreate(Req *r)
{
	State *s;
	char *err;
	Entry *e, *f;

	if(readonly) {
		respond(r, Erofs);
		return;
	}

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	if(!writeable(e)) {
		respond(r, Eperm);
		return;
	}

	f = ecreate(e, r-&gt;ifcall.name, 0, r-&gt;ifcall.perm, time(0), &amp;err);
	if(f == nil) {
		respond(r, err);
		return;
	}

	s-&gt;e = f;
	r-&gt;ofcall.qid = eqid(f);
	respond(r, nil);
}

static void
flread(Req *r)
{
	Entry *e;
	State *s;

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;

	if(e-&gt;mode &amp; DMDIR)
		r-&gt;ofcall.count = edirread(s-&gt;r, r-&gt;ofcall.data, r-&gt;ifcall.count);
	else
		r-&gt;ofcall.count = 0;

	respond(r, nil);
}

static void
flwrite(Req *r)
{
	if(r-&gt;ifcall.offset + r-&gt;ifcall.count &gt;= MAXFSIZE) {
		respond(r, "file too big");
		return;
	}

	r-&gt;ofcall.count = r-&gt;ifcall.count;
	respond(r, nil);
}

static void
flremove(Req *r)
{
	State *s;
	Entry *e;

	if(readonly) {
		respond(r, Erofs);
		return;
	}

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	if(writeable(e-&gt;parent))
		respond(r, eremove(e));
	else
		respond(r, Eperm);
}

static void
flstat(Req *r)
{
	State *s;

	s = r-&gt;fid-&gt;aux;
	estat(s-&gt;e, &amp;r-&gt;d, 1);
	respond(r, nil);
}

static void
flwstat(Req *r)
{
	int m;
	State *s;
	Entry *e;

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	m = r-&gt;d.mode &amp; 0777;
	if(m != (e-&gt;mode &amp; 0777))
		echmod(e, m, 0);
	respond(r, nil);
}

static void
flwalk(Req *r)
{
	int i;
	State *s;
	char *err;
	Entry *e, *f;

	if(readonly) {
		respond(r, Erofs);
		return;
	}

	if(r-&gt;ifcall.fid != r-&gt;ifcall.newfid)
		r-&gt;newfid-&gt;aux = state(nil);

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	f = e;
	e-&gt;ref++;
	err = nil;
	for(i = 0; i &lt; r-&gt;ifcall.nwname; i++) {
		f = ewalk(e, r-&gt;ifcall.wname[i], &amp;err);
		if(f) {
			r-&gt;ofcall.wqid[i] = eqid(f);
			e = f;
		}
		else {
			e-&gt;ref--;
			break;
		}
	}
	r-&gt;ofcall.nwqid = i;

	if(f) {
		if(r-&gt;ifcall.fid != r-&gt;ifcall.newfid) {
			s = r-&gt;newfid-&gt;aux;
			s-&gt;e = f;
			r-&gt;newfid-&gt;qid = eqid(f);
		}
		else {
			s = r-&gt;fid-&gt;aux;
			s-&gt;e-&gt;ref--;
			s-&gt;e = f;
			r-&gt;fid-&gt;qid = eqid(f);
		}
	}
	respond(r, err);
}

void
serve(char *mount)
{
	flashsrv.attach = flattach;
	flashsrv.open = flopen;
	flashsrv.create = flcreate;
	flashsrv.read = flread;
	flashsrv.write = flwrite;
	flashsrv.remove = flremove;
	flashsrv.stat = flstat;
	flashsrv.wstat = flwstat;
	flashsrv.walk = flwalk;

	flashsrv.destroyfid = destroy;
	flashsrv.destroyreq = trace;
	einit();
	postmountsrv(&amp;flashsrv, "brzr", mount, MREPL|MCREATE);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

