<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/portmap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/portmap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright © 2003 Russ Cox, MIT; see /sys/src/libsunrpc/COPYING */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;sunrpc.h&gt;

int chatty;
SunClient *client;

void
usage(void)
{
	fprint(2, "usage: portmap address [cmd]\n"
		"cmd is one of:\n"
		"\tnull\n"
		"\tset prog vers proto port\n"
		"\tunset prog vers proto port\n"
		"\tgetport prog vers proto\n"
		"\tdump (default)\n");
	threadexitsall("usage");
}

void
portCall(SunCall *c, PortCallType type)
{
	c-&gt;rpc.prog = PortProgram;
	c-&gt;rpc.vers = PortVersion;
	c-&gt;rpc.proc = type&gt;&gt;1;
	c-&gt;rpc.iscall = !(type&amp;1);
	c-&gt;type = type;
}

void
tnull(char **argv)
{
	PortTNull tx;
	PortRNull rx;

	USED(argv);

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTNull);

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRNull);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");
}

void
tset(char **argv)
{
	PortTSet tx;
	PortRSet rx;

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTSet);
	tx.map.prog = strtol(argv[0], 0, 0);
	tx.map.vers = strtol(argv[1], 0, 0);
	tx.map.prot = strtol(argv[2], 0, 0);
	tx.map.port = strtol(argv[3], 0, 0);

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRSet);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	if(rx.b == 0)
		print("rejected\n");
}

void
tunset(char **argv)
{
	PortTUnset tx;
	PortRUnset rx;

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTUnset);
	tx.map.prog = strtol(argv[0], 0, 0);
	tx.map.vers = strtol(argv[1], 0, 0);
	tx.map.prot = strtol(argv[2], 0, 0);
	tx.map.port = strtol(argv[3], 0, 0);

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRUnset);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	if(rx.b == 0)
		print("rejected\n");
}

void
tgetport(char **argv)
{
	PortTGetport tx;
	PortRGetport rx;

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTGetport);
	tx.map.prog = strtol(argv[0], 0, 0);
	tx.map.vers = strtol(argv[1], 0, 0);
	tx.map.prot = strtol(argv[2], 0, 0);

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRGetport);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	print("%d\n", rx.port);
}

void
tdump(char **argv)
{
	int i;
	uchar *p;
	PortTDump tx;
	PortRDump rx;
	PortMap *m;

	USED(argv);

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTDump);

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRDump);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, &amp;p) &lt; 0)
		sysfatal("rpc: %r");

	for(i=0, m=rx.map; i&lt;rx.nmap; i++, m++)
		print("%ud %ud %ud %ud\n", (uint)m-&gt;prog, (uint)m-&gt;vers, (uint)m-&gt;prot, (uint)m-&gt;port);

	free(p);
}

static struct {
	char *cmd;
	int narg;
	void (*fn)(char**);
} tab[] = {
	"null",	0,	tnull,
	"set",	4,	tset,
	"unset",	4,	tunset,
	"getport",	3,	tgetport,
	"dump",	0,	tdump,
};

void
threadmain(int argc, char **argv)
{
	char *dflt[] = { "dump", };
	char *addr, *cmd;
	int i;

	ARGBEGIN{
	case 'R':
		chatty++;
		break;
	}ARGEND

	if(argc &lt; 1)
		usage();

	fmtinstall('B', sunRpcFmt);
	fmtinstall('C', sunCallFmt);
	fmtinstall('H', encodefmt);
	sunFmtInstall(&amp;portProg);

	addr = netmkaddr(argv[0], "udp", "portmap");
	if((client = sunDial(addr)) == nil)
		sysfatal("dial %s: %r", addr);

	client-&gt;chatty = chatty;
	sunClientProg(client, &amp;portProg);

	argv++;
	argc--;

	if(argc == 0){
		argc = 1;
		argv = dflt;
	}
	cmd = argv[0];
	argv++;
	argc--;

	for(i=0; i&lt;nelem(tab); i++){
		if(strcmp(tab[i].cmd, cmd) == 0){
			if(tab[i].narg != argc)
				usage();
			(*tab[i].fn)(argv);
			threadexitsall(nil);
		}
	}
	usage();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

