<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/searchfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/searchfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;

/*
 * caveat:
 * this stuff is only meant to work for ascii databases
 */

typedef struct Fid Fid;
typedef struct Fs Fs;
typedef struct Quick Quick;
typedef struct Match Match;
typedef struct Search Search;

enum
{
	OPERM	= 0x3,		/* mask of all permission types in open mode */
	Nfidhash	= 32,

	/*
	 * qids
	 */
	Qroot	= 1,
	Qsearch	= 2,
	Qstats	= 3,
};

/*
 * boyer-moore quick string matching
 */
struct Quick
{
	char	*pat;
	char	*up;		/* match string for upper case of pat */
	int	len;		/* of pat (and up) -1; used for fast search */
	uchar 	jump[256];	/* jump index table */
	int	miss;		/* amount to jump if we falsely match the last char */
};
extern void	quickmk(Quick*, char*, int);
extern void	quickfree(Quick*);
extern char*	quicksearch(Quick*, char*, char*);

/*
 * exact matching of a search string
 */
struct Match
{
	Match	*next;
	char	*pat;				/* null-terminated search string */
	char	*up;				/* upper case of pat */
	int	len;				/* length of both pat and up */
	int	(*op)(Match*, char*, char*);		/* method for this partiticular search */
};

struct Search
{
	Quick		quick;		/* quick match */
	Match		*match;		/* exact matches */
	int		skip;		/* number of matches to skip */
};

extern char*	searchsearch(Search*, char*, char*, int*);
extern Search*	searchparse(char*, char*);
extern void	searchfree(Search*);

struct Fid
{
	Lock;
	Fid	*next;
	Fid	**last;
	uint	fid;
	int	ref;		/* number of fcalls using the fid */
	int	attached;		/* fid has beed attached or cloned and not clunked */

	int	open;
	Qid	qid;
	Search	*search;		/* search patterns */
	char	*where;		/* current location in the database */
	int	n;		/* number of bytes left in found item */
};

int			dostat(int, uchar*, int);
void*			emalloc(uint);
void			fatal(char*, ...);
Match*			mkmatch(Match*, int(*)(Match*, char*, char*), char*);
Match*			mkstrmatch(Match*, char*);
char*		nextsearch(char*, char*, char**, char**);
int			strlook(Match*, char*, char*);
char*			strndup(char*, int);
int			tolower(int);
int			toupper(int);
char*			urlunesc(char*, char*);
void			usage(void);

struct Fs
{
	Lock;			/* for fids */

	Fid	*hash[Nfidhash];
	uchar	statbuf[1024];	/* plenty big enough */
};
extern	void	fsrun(Fs*, int);
extern	Fid*	getfid(Fs*, uint);
extern	Fid*	mkfid(Fs*, uint);
extern	void	putfid(Fs*, Fid*);
extern	char*	fsversion(Fs*, Fcall*);
extern	char*	fsauth(Fs*, Fcall*);
extern	char*	fsattach(Fs*, Fcall*);
extern	char*	fswalk(Fs*, Fcall*);
extern	char*	fsopen(Fs*, Fcall*);
extern	char*	fscreate(Fs*, Fcall*);
extern	char*	fsread(Fs*, Fcall*);
extern	char*	fswrite(Fs*, Fcall*);
extern	char*	fsclunk(Fs*, Fcall*);
extern	char*	fsremove(Fs*, Fcall*);
extern	char*	fsstat(Fs*, Fcall*);
extern	char*	fswstat(Fs*, Fcall*);

char	*(*fcalls[])(Fs*, Fcall*) =
{
	[Tversion]		fsversion,
	[Tattach]	fsattach,
	[Tauth]	fsauth,
	[Twalk]		fswalk,
	[Topen]		fsopen,
	[Tcreate]	fscreate,
	[Tread]		fsread,
	[Twrite]	fswrite,
	[Tclunk]	fsclunk,
	[Tremove]	fsremove,
	[Tstat]		fsstat,
	[Twstat]	fswstat
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enotexist[] =	"file does not exist";
char	Eisopen[] = 	"file already open for I/O";
char	Einuse[] =	"fid is already in use";
char	Enofid[] = 	"no such fid";
char	Enotopen[] =	"file is not open";
char	Ebadsearch[] =	"bad search string";

Fs	fs;
char	*database;
char	*edatabase;
int	messagesize = 8192+IOHDRSZ;
void
main(int argc, char **argv)
{
	Dir *d;
	char buf[12], *mnt, *srv;
	int fd, p[2], n;

	mnt = "/tmp";
	srv = nil;
	ARGBEGIN{
		case 's':
			srv = ARGF();
			mnt = nil;
			break;
		case 'm':
			mnt = ARGF();
			break;
	}ARGEND

	fmtinstall('F', fcallfmt);

	if(argc != 1)
		usage();
	d = nil;
	fd = open(argv[0], OREAD);
	if(fd &lt; 0 || (d=dirfstat(fd)) == nil)
		fatal("can't open %s: %r", argv[0]);
	n = d-&gt;length;
	free(d);
	if(n == 0)
		fatal("zero length database %s", argv[0]);
	database = emalloc(n);
	if(read(fd, database, n) != n)
		fatal("can't read %s: %r", argv[0]);
	close(fd);
	edatabase = database + n;

	if(pipe(p) &lt; 0)
		fatal("pipe failed");

	switch(rfork(RFPROC|RFMEM|RFNOTEG|RFNAMEG)){
	case 0:
		fsrun(&amp;fs, p[0]);
		exits(nil);
	case -1:	
		fatal("fork failed");
	}

	if(mnt == nil){
		if(srv == nil)
			usage();
		fd = create(srv, OWRITE, 0666);
		if(fd &lt; 0){
			remove(srv);
			fd = create(srv, OWRITE, 0666);
			if(fd &lt; 0){
				close(p[1]);
				fatal("create of %s failed", srv);
			}
		}
		sprint(buf, "%d", p[1]);
		if(write(fd, buf, strlen(buf)) &lt; 0){
			close(p[1]);
			fatal("writing %s", srv);
		}
		close(p[1]);
		exits(nil);
	}

	if(mount(p[1], -1, mnt, MREPL, "") &lt; 0){
		close(p[1]);
		fatal("mount failed");
	}
	close(p[1]);
	exits(nil);
}

/*
 * execute the search
 * do a quick match,
 * isolate the line in which the occured,
 * and try all of the exact matches
 */
char*
searchsearch(Search *search, char *where, char *end, int *np)
{
	Match *m;
	char *s, *e;

	*np = 0;
	if(search == nil || where == nil)
		return nil;
	for(;;){
		s = quicksearch(&amp;search-&gt;quick, where, end);
		if(s == nil)
			return nil;
		e = memchr(s, '\n', end - s);
		if(e == nil)
			e = end;
		else
			e++;
		while(s &gt; where &amp;&amp; s[-1] != '\n')
			s--;
		for(m = search-&gt;match; m != nil; m = m-&gt;next){
			if((*m-&gt;op)(m, s, e) == 0)
				break;
		}

		if(m == nil){
			if(search-&gt;skip &gt; 0)
				search-&gt;skip--;
			else{
				*np = e - s;
				return s;
			}
		}

		where = e;
	}
}

/*
 * parse a search string of the form
 * tag=val&amp;tag1=val1...
 */
Search*
searchparse(char *search, char *esearch)
{
	Search *s;
	Match *m, *next, **last;
	char *tag, *val, *p;
	int ok;

	s = emalloc(sizeof *s);
	s-&gt;match = nil;

	/*
	 * acording to the http spec,
	 * repeated search queries are ingored.
	 * the last search given is performed on the original object
	 */
	while((p = memchr(s, '?', esearch - search)) != nil){
		search = p + 1;
	}
	while(search &lt; esearch){
		search = nextsearch(search, esearch, &amp;tag, &amp;val);
		if(tag == nil)
			continue;

		ok = 0;
		if(strcmp(tag, "skip") == 0){
			s-&gt;skip = strtoul(val, &amp;p, 10);
			if(*p == 0)
				ok = 1;
		}else if(strcmp(tag, "search") == 0){
			s-&gt;match = mkstrmatch(s-&gt;match, val);
			ok = 1;
		}
		free(tag);
		free(val);
		if(!ok){
			searchfree(s);
			return nil;
		}
	}

	if(s-&gt;match == nil){
		free(s);
		return nil;
	}

	/*
	 * order the matches by probability of occurance
	 * first cut is just by length
	 */
	for(ok = 0; !ok; ){
		ok = 1;
		last = &amp;s-&gt;match;
		for(m = *last; m &amp;&amp; m-&gt;next; m = *last){
			if(m-&gt;next-&gt;len &gt; m-&gt;len){
				next = m-&gt;next;
				m-&gt;next = next-&gt;next;
				next-&gt;next = m;
				*last = next;
				ok = 0;
			}
			last = &amp;m-&gt;next;
		}
	}

	/*
	 * convert the best search into a fast lookup
	 */
	m = s-&gt;match;
	s-&gt;match = m-&gt;next;
	quickmk(&amp;s-&gt;quick, m-&gt;pat, 1);
	free(m-&gt;pat);
	free(m-&gt;up);
	free(m);
	return s;
}

void
searchfree(Search *s)
{
	Match *m, *next;

	if(s == nil)
		return;
	for(m = s-&gt;match; m; m = next){
		next = m-&gt;next;
		free(m-&gt;pat);
		free(m-&gt;up);
		free(m);
	}
	quickfree(&amp;s-&gt;quick);
	free(s);
}

char*
nextsearch(char *search, char *esearch, char **tagp, char **valp)
{
	char *tag, *val;

	*tagp = nil;
	*valp = nil;
	for(tag = search; search &lt; esearch &amp;&amp; *search != '='; search++)
		;
	if(search == esearch)
		return search;
	tag = urlunesc(tag, search);
	search++;
	for(val = search; search &lt; esearch &amp;&amp; *search != '&amp;'; search++)
		;
	val = urlunesc(val, search);
	if(search != esearch)
		search++;
	*tagp = tag;
	*valp = val;
	return search;
}

Match*
mkstrmatch(Match *m, char *pat)
{
	char *s;

	for(s = pat; *s; s++){
		if(*s == ' ' || *s == '\t' || *s == '\n' || *s == '\r'){
			*s = 0;
			m = mkmatch(m, strlook, pat);
			pat = s + 1;
		}else
			*s = tolower(*s);
	}
	return mkmatch(m, strlook, pat);
}

Match*
mkmatch(Match *next, int (*op)(Match*, char*, char*), char *pat)
{
	Match *m;
	char *p;
	int n;

	n = strlen(pat);
	if(n == 0)
		return next;
	m = emalloc(sizeof *m);
	m-&gt;op = op;
	m-&gt;len = n;
	m-&gt;pat = strdup(pat);
	m-&gt;up = strdup(pat);
	for(p = m-&gt;up; *p; p++)
		*p = toupper(*p);
	for(p = m-&gt;pat; *p; p++)
		*p = tolower(*p);
	m-&gt;next = next;
	return m;
}

int
strlook(Match *m, char *str, char *e)
{
	char *pat, *up, *s;
	int c, pc, fc, fuc, n;

	n = m-&gt;len;
	fc = m-&gt;pat[0];
	fuc = m-&gt;up[0];
	for(; str + n &lt;= e; str++){
		c = *str;
		if(c != fc &amp;&amp; c != fuc)
			continue;
		s = str + 1;
		up = m-&gt;up + 1;
		for(pat = m-&gt;pat + 1; pc = *pat; pat++){
			c = *s;
			if(c != pc &amp;&amp; c != *up)
				break;
			up++;
			s++;
		}
		if(pc == 0)
			return 1;
	}
	return 0;
}

/*
 * boyer-moore style pattern matching
 * implements an exact match for ascii
 * however, if mulitbyte upper-case and lower-case
 * characters differ in length or in more than one byte,
 * it only implements an approximate match
 */
void
quickmk(Quick *q, char *spat, int ignorecase)
{
	char *pat, *up;
	uchar *j;	
	int ep, ea, cp, ca, i, c, n;

	/*
	 * allocate the machine
	 */
	n = strlen(spat);
	if(n == 0){
		q-&gt;pat = nil;
		q-&gt;up = nil;
		q-&gt;len = -1;
		return;
	}
	pat = emalloc(2* n + 2);
	q-&gt;pat = pat;
	up = pat;
	if(ignorecase)
		up = pat + n + 1;
	q-&gt;up = up;
	while(c = *spat++){
		if(ignorecase){
			*up++ = toupper(c);
			c = tolower(c);
		}
		*pat++ = c;
	}
	pat = q-&gt;pat;
	up = q-&gt;up;
	pat[n] = up[n] = '\0';

	/*
	 * make the skipping table
	 */
	if(n &gt; 255)
		n = 255;
	j = q-&gt;jump;
	memset(j, n, 256);
	n--;
	q-&gt;len = n;
	for(i = 0; i &lt;= n; i++){
		j[(uchar)pat[i]] = n - i;
		j[(uchar)up[i]] = n - i;
	}
	
	/*
	 * find the minimum safe amount to skip
	 * if we match the last char but not the whole pat
	 */
	ep = pat[n];
	ea = up[n];
	for(i = n - 1; i &gt;= 0; i--){
		cp = pat[i];
		ca = up[i];
		if(cp == ep || cp == ea || ca == ep || ca == ea)
			break;
	}
	q-&gt;miss = n - i;
}

void
quickfree(Quick *q)
{
	if(q-&gt;pat != nil)
		free(q-&gt;pat);
	q-&gt;pat = nil;
}

char *
quicksearch(Quick *q, char *s, char *e)
{
	char *pat, *up, *m, *ee;
	uchar *j;
	int len, n, c, mc;

	len = q-&gt;len;
	if(len &lt; 0)
		return s;
	j = q-&gt;jump;
	pat = q-&gt;pat;
	up = q-&gt;up;
	s += len;
	ee = e - (len * 4 + 4);
	while(s &lt; e){
		/*
		 * look for a match on the last char
		 */
		while(s &lt; ee &amp;&amp; (n = j[(uchar)*s])){
			s += n;
			s += j[(uchar)*s];
			s += j[(uchar)*s];
			s += j[(uchar)*s];
		}
		if(s &gt;= e)
			return nil;
		while(n = j[(uchar)*s]){
			s += n;
			if(s &gt;= e)
				return nil;
		}

		/*
		 * does the string match?
		 */
		m = s - len;
		for(n = 0; c = pat[n]; n++){
			mc = *m++;
			if(c != mc &amp;&amp; mc != up[n])
				break;
		}
		if(!c)
			return s - len;
		s += q-&gt;miss;
	}
	return nil;
}

void
fsrun(Fs *fs, int fd)
{
	Fcall rpc;
	char *err;
	uchar *buf;
	int n;

	buf = emalloc(messagesize);
	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		n = read9pmsg(fd, buf, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0)
			fatal("mount read");

		rpc.data = (char*)buf + IOHDRSZ;
		if(convM2S(buf, n, &amp;rpc) == 0)
			continue;
		// fprint(2, "recv: %F\n", &amp;rpc);


		/*
		 * flushes are way too hard.
		 * a reply to the original message seems to work
		 */
		if(rpc.type == Tflush)
			continue;
		else if(rpc.type &gt;= Tmax || !fcalls[rpc.type])
			err = "bad fcall type";
		else
			err = (*fcalls[rpc.type])(fs, &amp;rpc);
		if(err){
			rpc.type = Rerror;
			rpc.ename = err;
		}else
			rpc.type++;
		n = convS2M(&amp;rpc, buf, messagesize);
		// fprint(2, "send: %F\n", &amp;rpc);
		if(write(fd, buf, n) != n)
			fatal("mount write");
	}
}

Fid*
mkfid(Fs *fs, uint fid)
{
	Fid *f;
	int h;

	h = fid % Nfidhash;
	for(f = fs-&gt;hash[h]; f; f = f-&gt;next){
		if(f-&gt;fid == fid)
			return nil;
	}

	f = emalloc(sizeof *f);
	f-&gt;next = fs-&gt;hash[h];
	if(f-&gt;next != nil)
		f-&gt;next-&gt;last = &amp;f-&gt;next;
	f-&gt;last = &amp;fs-&gt;hash[h];
	fs-&gt;hash[h] = f;

	f-&gt;fid = fid;
	f-&gt;ref = 1;
	f-&gt;attached = 1;
	f-&gt;open = 0;
	return f;
}

Fid*
getfid(Fs *fs, uint fid)
{
	Fid *f;
	int h;

	h = fid % Nfidhash;
	for(f = fs-&gt;hash[h]; f; f = f-&gt;next){
		if(f-&gt;fid == fid){
			if(f-&gt;attached == 0)
				break;
			f-&gt;ref++;
			return f;
		}
	}
	return nil;
}

void
putfid(Fs *, Fid *f)
{
	f-&gt;ref--;
	if(f-&gt;ref == 0 &amp;&amp; f-&gt;attached == 0){
		*f-&gt;last = f-&gt;next;
		if(f-&gt;next != nil)
			f-&gt;next-&gt;last = f-&gt;last;
		if(f-&gt;search != nil)
			searchfree(f-&gt;search);
		free(f);
	}
}

char*
fsversion(Fs *, Fcall *rpc)
{
	if(rpc-&gt;msize &lt; 256)
		return "version: message size too small";
	if(rpc-&gt;msize &gt; messagesize)
		rpc-&gt;msize = messagesize;
	messagesize = rpc-&gt;msize;
	if(strncmp(rpc-&gt;version, "9P2000", 6) != 0)
		return "unrecognized 9P version";
	rpc-&gt;version = "9P2000";
	return nil;
}

char*
fsauth(Fs *, Fcall *)
{
	return "searchfs: authentication not required";
}

char*
fsattach(Fs *fs, Fcall *rpc)
{
	Fid *f;

	f = mkfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Einuse;
	f-&gt;open = 0;
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.path = Qroot;
	f-&gt;qid.vers = 0;
	rpc-&gt;qid = f-&gt;qid;
	putfid(fs, f);
	return nil;
}

char*
fswalk(Fs *fs, Fcall *rpc)
{
	Fid *f, *nf;
	int nqid, nwname, type;
	char *err, *name;
	ulong path;

	f = getfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	nf = nil;
	if(rpc-&gt;fid != rpc-&gt;newfid){
		nf = mkfid(fs, rpc-&gt;newfid);
		if(nf == nil){
			putfid(fs, f);
			return Einuse;
		}
		nf-&gt;qid = f-&gt;qid;
		putfid(fs, f);
		f = nf;	/* walk f */
	}

	err = nil;
	path = f-&gt;qid.path;
	nwname = rpc-&gt;nwname;
	for(nqid=0; nqid&lt;nwname; nqid++){
		if(path != Qroot){
			err = Enotdir;
			break;
		}
		name = rpc-&gt;wname[nqid];
		if(strcmp(name, "search") == 0){
			type = QTFILE;
			path = Qsearch;
		}else if(strcmp(name, "stats") == 0){
			type = QTFILE;
			path = Qstats;
		}else if(strcmp(name, ".") == 0 || strcmp(name, "..") == 0){
			type = QTDIR;
			path = path;
		}else{
			err = Enotexist;
			break;
		}
		rpc-&gt;wqid[nqid] = (Qid){path, 0, type};
	}

	if(nwname &gt; 0){
		if(nf != nil &amp;&amp; nqid &lt; nwname)
			nf-&gt;attached = 0;
		if(nqid == nwname)
			f-&gt;qid = rpc-&gt;wqid[nqid-1];
	}

	putfid(fs, f);
	rpc-&gt;nwqid = nqid;
	f-&gt;open = 0;
	return err;
}

char *
fsopen(Fs *fs, Fcall *rpc)
{
	Fid *f;
	int mode;

	f = getfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(f-&gt;open){
		putfid(fs, f);
		return Eisopen;
	}
	mode = rpc-&gt;mode &amp; OPERM;
	if(mode == OEXEC
	|| f-&gt;qid.path == Qroot &amp;&amp; (mode == OWRITE || mode == ORDWR)){
		putfid(fs, f);
		return Eperm;
	}
	f-&gt;open = 1;
	f-&gt;where = nil;
	f-&gt;n = 0;
	f-&gt;search = nil;
	rpc-&gt;qid = f-&gt;qid;
	rpc-&gt;iounit = messagesize-IOHDRSZ;
	putfid(fs, f);
	return nil;
}

char *
fscreate(Fs *, Fcall *)
{
	return Eperm;
}

char*
fsread(Fs *fs, Fcall *rpc)
{
	Fid *f;
	int n, off, count, len;

	f = getfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(!f-&gt;open){
		putfid(fs, f);
		return Enotopen;
	}
	count = rpc-&gt;count;
	off = rpc-&gt;offset;
	rpc-&gt;count = 0;
	if(f-&gt;qid.path == Qroot){
		if(off &gt; 0)
			rpc-&gt;count = 0;
		else
			rpc-&gt;count = dostat(Qsearch, (uchar*)rpc-&gt;data, count);
		putfid(fs, f);
		if(off == 0 &amp;&amp; rpc-&gt;count &lt;= BIT16SZ)
			return "directory read count too small";
		return nil;
	}
	if(f-&gt;qid.path == Qstats){
		len = 0;
	}else{
		for(len = 0; len &lt; count; len += n){
			if(f-&gt;where == nil || f-&gt;search == nil)
				break;
			if(f-&gt;n == 0)
				f-&gt;where = searchsearch(f-&gt;search, f-&gt;where, edatabase, &amp;f-&gt;n);
			n = f-&gt;n;
			if(n != 0){
				if(n &gt; count-len)
					n = count-len;
				memmove(rpc-&gt;data+len, f-&gt;where, n);
				f-&gt;where += n;
				f-&gt;n -= n;
			}
		}
	}
	putfid(fs, f);
	rpc-&gt;count = len;
	return nil;
}

char*
fswrite(Fs *fs, Fcall *rpc)
{
	Fid *f;

	f = getfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(!f-&gt;open || f-&gt;qid.path != Qsearch){
		putfid(fs, f);
		return Enotopen;
	}

	if(f-&gt;search != nil)
		searchfree(f-&gt;search);
	f-&gt;search = searchparse(rpc-&gt;data, rpc-&gt;data + rpc-&gt;count);
	if(f-&gt;search == nil){
		putfid(fs, f);
		return Ebadsearch;
	}
	f-&gt;where = database;
	f-&gt;n = 0;
	putfid(fs, f);
	return nil;
}

char *
fsclunk(Fs *fs, Fcall *rpc)
{
	Fid *f;

	f = getfid(fs, rpc-&gt;fid);
	if(f != nil){
		f-&gt;attached = 0;
		putfid(fs, f);
	}
	return nil;
}

char *
fsremove(Fs *, Fcall *)
{
	return Eperm;
}

char *
fsstat(Fs *fs, Fcall *rpc)
{
	Fid *f;

	f = getfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	rpc-&gt;stat = fs-&gt;statbuf;
	rpc-&gt;nstat = dostat(f-&gt;qid.path, rpc-&gt;stat, sizeof fs-&gt;statbuf);
	putfid(fs, f);
	if(rpc-&gt;nstat &lt;= BIT16SZ)
		return "stat count too small";
	return nil;
}

char *
fswstat(Fs *, Fcall *)
{
	return Eperm;
}

int
dostat(int path, uchar *buf, int nbuf)
{
	Dir d;

	switch(path){
	case Qroot:
		d.name = ".";
		d.mode = DMDIR|0555;
		d.qid.type = QTDIR;
		break;
	case Qsearch:
		d.name = "search";
		d.mode = 0666;
		d.qid.type = QTFILE;
		break;
	case Qstats:
		d.name = "stats";
		d.mode = 0666;
		d.qid.type = QTFILE;
		break;
	}
	d.qid.path = path;
	d.qid.vers = 0;
	d.length = 0;
	d.uid = d.gid = d.muid = "none";
	d.atime = d.mtime = time(nil);
	return convD2M(&amp;d, buf, nbuf);
}

char *
urlunesc(char *s, char *e)
{
	char *t, *v;
	int c, n;

	v = emalloc((e - s) + 1);
	for(t = v; s &lt; e; s++){
		c = *s;
		if(c == '%'){
			if(s + 2 &gt;= e)
				break;
			n = s[1];
			if(n &gt;= '0' &amp;&amp; n &lt;= '9')
				n = n - '0';
			else if(n &gt;= 'A' &amp;&amp; n &lt;= 'F')
				n = n - 'A' + 10;
			else if(n &gt;= 'a' &amp;&amp; n &lt;= 'f')
				n = n - 'a' + 10;
			else
				break;
			c = n;
			n = s[2];
			if(n &gt;= '0' &amp;&amp; n &lt;= '9')
				n = n - '0';
			else if(n &gt;= 'A' &amp;&amp; n &lt;= 'F')
				n = n - 'A' + 10;
			else if(n &gt;= 'a' &amp;&amp; n &lt;= 'f')
				n = n - 'a' + 10;
			else
				break;
			s += 2;
			c = c * 16 + n;
		}
		*t++ = c;
	}
	*t = 0;
	return v;
}

int
toupper(int c)
{
	if(c &gt;= 'a' &amp;&amp; c &lt;= 'z')
		c += 'A' - 'a';
	return c;
}

int
tolower(int c)
{
	if(c &gt;= 'A' &amp;&amp; c &lt;= 'Z')
		c += 'a' - 'A';
	return c;
}

void
fatal(char *fmt, ...)
{
	va_list arg;
	char buf[1024];

	write(2, "searchfs: ", 8);
	va_start(arg, fmt);
	vseprint(buf, buf+1024, fmt, arg);
	va_end(arg);
	write(2, buf, strlen(buf));
	write(2, "\n", 1);
	exits(fmt);
}

void *
emalloc(uint n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		fatal("out of memory");
	memset(p, 0, n);
	return p;
}

void
usage(void)
{
	fprint(2, "usage: searchfs [-m mountpoint] [-s srvfile] database\n");
	exits("usage");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

