<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/stub.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/stub.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

uint time0;

enum
{
	Qroot = 0,
	Qkid,
};

char *kidname;
uint kidmode;

void
fsattach(Req *r)
{
	char *spec;

	spec = r-&gt;ifcall.aname;
	if(spec &amp;&amp; spec[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;ofcall.qid = (Qid){Qroot, 0, QTDIR};
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	respond(r, nil);
}

char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	switch((int)fid-&gt;qid.path){
	default:
		return "path not found";
	case Qroot:
		if(strcmp(name, "..") == 0)
			break;
		if(strcmp(name, kidname) == 0){
			fid-&gt;qid = (Qid){Qkid, 0, kidmode&gt;&gt;24};
			break;
		}
		return "path not found";
	case Qkid:
		if(strcmp(name, "..") == 0){
			fid-&gt;qid = (Qid){Qroot, 0, QTDIR};
			break;
		}
		return "path not found";
	}
	*qid = fid-&gt;qid;
	return nil;
}

void
fsstat(Req *r)
{
	int q;
	Dir *d;

	d = &amp;r-&gt;d;
	memset(d, 0, sizeof *d);
	q = r-&gt;fid-&gt;qid.path;
	d-&gt;qid = r-&gt;fid-&gt;qid;
	switch(q){
	case Qroot:
		d-&gt;name = estrdup9p("/");
		d-&gt;mode = DMDIR|0777;
		break;

	case Qkid:
		d-&gt;name = estrdup9p(kidname);
		d-&gt;mode = kidmode;
		break;
	}

	d-&gt;atime = d-&gt;mtime = time0;
	d-&gt;uid = estrdup9p("stub");
	d-&gt;gid = estrdup9p("stub");
	d-&gt;muid = estrdup9p("");
	respond(r, nil);
}

int
dirgen(int off, Dir *d, void*)
{
	if(off != 0)
		return -1;

	memset(d, 0, sizeof *d);
	d-&gt;atime = d-&gt;mtime = time0;
	d-&gt;name = estrdup9p(kidname);
	d-&gt;mode = kidmode;
	d-&gt;qid = (Qid){Qkid, 0, kidmode&gt;&gt;24};
	d-&gt;qid.type = d-&gt;mode&gt;&gt;24;
	d-&gt;uid = estrdup9p("stub");
	d-&gt;gid = estrdup9p("stub");
	d-&gt;muid = estrdup9p("");
	return 0;
}

void
fsread(Req *r)
{
	int q;

	q = r-&gt;fid-&gt;qid.path;
	switch(q){
	default:
		respond(r, "bug");
		return;

	case Qroot:
		dirread9p(r, dirgen, nil);
		respond(r, nil);
		return;
	}
}

void
fswrite(Req *r)
{
	respond(r, "no writing");
}

void
fsopen(Req *r)
{
	if(r-&gt;fid-&gt;qid.path != Qroot){
		respond(r, "permission denied");
		return;
	}

	if(r-&gt;ifcall.mode != OREAD)
		respond(r, "permission denied");
	else
		respond(r, nil);
}

Srv fs = {
	.attach=	fsattach,
	.open=	fsopen,
	.read=	fsread,
	.write=	fswrite,
	.stat=	fsstat,
	.walk1=	fswalk1,
};

void
usage(void)
{
	fprint(2, "usage: aux/stub [-Dd] path/name\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	char *p, *mtpt;

	quotefmtinstall();

	time0 = time(0);
	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'd':
		kidmode = DMDIR;
		break;
	default:
		usage();
	}ARGEND

	if(argc != 1)
		usage();

	if((p = strrchr(argv[0], '/')) == 0){
		mtpt = ".";
		kidname = argv[0];
	}else if(p == argv[0]){
		mtpt = "/";
		kidname = argv[0]+1;
	}else{
		mtpt = argv[0];
		*p++ = '\0';
		kidname = p;
	}
	/* don't leave standard descriptors open to confuse mk */
	close(0);
	close(1);
	close(2);
	postmountsrv(&amp;fs, nil, mtpt, MBEFORE);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

