<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/ark2000pv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/ark2000pv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * ARK Logic ARK2000PV GUI accelerator.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;

	/*
	 * Unlock access to the extended I/O registers.
	 */
	vgaxo(Seqx, 0x1D, 0x01);

	for(i = 0x10; i &lt; 0x2E; i++)
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);
	for(i = 0x40; i &lt; 0x47; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);
	vga-&gt;crt[0x50] = vgaxi(Crtx, 0x50);

	/*
	 * A hidey-hole for the coprocessor status register.
	 */
	vga-&gt;crt[0xFF] = inportb(0x3CB);

	/*
	 * Memory size.
	 */
	switch((vga-&gt;sequencer[0x10]&gt;&gt;6) &amp; 0x03){

	case 0x00:
		vga-&gt;vma = vga-&gt;vmz = 1*1024*1024;
		break;

	case 0x01:
		vga-&gt;vma = vga-&gt;vmz = 2*1024*1024;
		break;

	case 0x02:
		vga-&gt;vma = vga-&gt;vmz = 4*1024*1024;
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Hpclk2x8|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	ulong x;

	mode = vga-&gt;mode;

	vga-&gt;crt[0x46] = 0x00;
	if(ctlr-&gt;flag &amp; Upclk2x8){
		vga-&gt;crt[0x00] = ((mode-&gt;ht/2)&gt;&gt;3)-5;
		vga-&gt;crt[0x01] = ((mode-&gt;x/2)&gt;&gt;3)-1;
		vga-&gt;crt[0x02] = ((mode-&gt;shb/2)&gt;&gt;3)-1;
	
		x = (mode-&gt;ehb/2)&gt;&gt;3;
		vga-&gt;crt[0x03] = 0x80|(x &amp; 0x1F);
		vga-&gt;crt[0x04] = (mode-&gt;shs/2)&gt;&gt;3;
		vga-&gt;crt[0x05] = ((mode-&gt;ehs/2)&gt;&gt;3) &amp; 0x1F;
		if(x &amp; 0x20)
			vga-&gt;crt[0x05] |= 0x80;
		vga-&gt;crt[0x13] = mode-&gt;x/8;

		vga-&gt;crt[0x46] |= 0x04;
	}

	/*
	 * Overflow bits.
	 */
	vga-&gt;crt[0x40] = 0x00;
	if(vga-&gt;crt[0x18] &amp; 0x400)
		vga-&gt;crt[0x40] |= 0x08;
	if(vga-&gt;crt[0x10] &amp; 0x400)
		vga-&gt;crt[0x40] |= 0x10;
	if(vga-&gt;crt[0x15] &amp; 0x400)
		vga-&gt;crt[0x40] |= 0x20;
	if(vga-&gt;crt[0x12] &amp; 0x400)
		vga-&gt;crt[0x40] |= 0x40;
	if(vga-&gt;crt[0x06] &amp; 0x400)
		vga-&gt;crt[0x40] |= 0x80;

	vga-&gt;crt[0x41] = 0x00;
	if(vga-&gt;crt[0x13] &amp; 0x100)
		vga-&gt;crt[0x41] |= 0x08;
	if(vga-&gt;crt[0x04] &amp; 0x100)
		vga-&gt;crt[0x41] |= 0x10;
	if(vga-&gt;crt[0x02] &amp; 0x100)
		vga-&gt;crt[0x41] |= 0x20;
	if(vga-&gt;crt[0x01] &amp; 0x100)
		vga-&gt;crt[0x41] |= 0x40;
	if(vga-&gt;crt[0x00] &amp; 0x100)
		vga-&gt;crt[0x41] |= 0x80;

	/*
	 * Interlace.
	 */
	vga-&gt;crt[0x42] = 0x00;
	vga-&gt;crt[0x44] = 0x00;
	if(mode-&gt;interlace){
		vga-&gt;crt[0x42] = vga-&gt;crt[0]/2;
		vga-&gt;crt[0x44] |= 0x04;
	}
	vga-&gt;crt[0x45] = 0x00;

	/*
	 * Memory configuration:
	 * enable linear|coprocessor|VESA modes;
	 * set aperture to 64Kb, 0xA0000;
	 * set aperture index 0.
	 * Bugs: 1024x768x1 doesn't work (aperture not set correctly?);
	 *	 hwgc doesn't work in 1-bit modes (hardware?).
	 */
	vga-&gt;sequencer[0x10] &amp;= ~0x3F;
	vga-&gt;sequencer[0x11] &amp;= ~0x0F;
	switch(mode-&gt;z){

	case 1:
		vga-&gt;sequencer[0x10] |= 0x03;
		vga-&gt;sequencer[0x11] |= 0x01;
		cflag = 1;
		break;

	case 8:
		vga-&gt;sequencer[0x10] |= 0x0F;
		vga-&gt;sequencer[0x11] |= 0x06;
		if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear) &amp;&amp; vga-&gt;vmz)
			ctlr-&gt;flag |= Ulinear;
		break;

	default:
		error("depth %d not supported\n", mode-&gt;z);
	}
	vga-&gt;sequencer[0x12] &amp;= ~0x03;
	vga-&gt;sequencer[0x13] = 0x0A;
	vga-&gt;sequencer[0x14] = 0x00;
	vga-&gt;sequencer[0x15] = 0x00;
	vga-&gt;sequencer[0x16] = 0x00;

	/*
	 * Frame Buffer Pitch and FIFO control.
	 * Set the FIFO to 32 deep and refill trigger when
	 * 6 slots empty.
	 */
	vga-&gt;sequencer[0x17] = 0x00;
	vga-&gt;sequencer[0x18] = 0x13;
	if(mode-&gt;x &lt;= 640)
		vga-&gt;sequencer[0x17] = 0x00;
	else if(mode-&gt;x &lt;= 800)
		vga-&gt;sequencer[0x17] |= 0x01;
	else if(mode-&gt;x &lt;= 1024)
		vga-&gt;sequencer[0x17] |= 0x02;
	else if(mode-&gt;x &lt;= 1280)
		vga-&gt;sequencer[0x17] |= 0x04;
	else if(mode-&gt;x &lt;= 1600)
		vga-&gt;sequencer[0x17] |= 0x05;
	else if(mode-&gt;x &lt;= 2048)
		vga-&gt;sequencer[0x17] |= 0x06;

	/*
	 * Clock select.
	 */
	vga-&gt;misc &amp;= ~0x0C;
	vga-&gt;misc |= (vga-&gt;i[0] &amp; 0x03)&lt;&lt;2;
	vga-&gt;sequencer[0x11] &amp;= ~0xC0;
	vga-&gt;sequencer[0x11] |= (vga-&gt;i[0] &amp; 0x0C)&lt;&lt;4;

	vga-&gt;attribute[0x11] = 0x00;	/* color map entry for black */

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ulong l;

	/*
	 * Ensure there are no glitches when selecting a new
	 * clock frequency.
	 * The sequencer toggle seems to matter on the Hercules
	 * Stingray 64/Video at 1280x1024x8. Without it the screen
	 * is fuzzy; a second load clears it up and there's no
	 * difference between the two register sets. A mystery.
	 */
	vgao(MiscW, vga-&gt;misc &amp; ~0x0C);
	vgaxo(Seqx, 0x11, vga-&gt;sequencer[0x11]);
	vgao(MiscW, vga-&gt;misc);
	if(vga-&gt;ramdac &amp;&amp; strncmp(vga-&gt;ramdac-&gt;name, "w30c516", 7) == 0){
		sequencer(vga, 1);
		sleep(500);
		sequencer(vga, 0);
	}

	if(ctlr-&gt;flag &amp; Ulinear){
		vga-&gt;sequencer[0x10] |= 0x10;
		if(vga-&gt;vmz &lt;= 1024*1024)
			vga-&gt;sequencer[0x12] |= 0x01;
		else if(vga-&gt;vmz &lt;= 2*1024*1024)
			vga-&gt;sequencer[0x12] |= 0x02;
		else
			vga-&gt;sequencer[0x12] |= 0x03;
		l = vga-&gt;vmb&gt;&gt;16;
		vga-&gt;sequencer[0x13] = l &amp; 0xFF;
		vga-&gt;sequencer[0x14] = (l&gt;&gt;8) &amp; 0xFF;
	}

	vgaxo(Seqx, 0x10, vga-&gt;sequencer[0x10]);
	vgaxo(Seqx, 0x12, vga-&gt;sequencer[0x12]);
	vgaxo(Seqx, 0x13, vga-&gt;sequencer[0x13]);
	vgaxo(Seqx, 0x14, vga-&gt;sequencer[0x14]);
	vgaxo(Seqx, 0x15, vga-&gt;sequencer[0x15]);
	vgaxo(Seqx, 0x16, vga-&gt;sequencer[0x16]);
	vgaxo(Seqx, 0x17, vga-&gt;sequencer[0x17]);
	vgaxo(Seqx, 0x18, vga-&gt;sequencer[0x18]);

	vgaxo(Crtx, 0x40, vga-&gt;crt[0x40]);
	vgaxo(Crtx, 0x41, vga-&gt;crt[0x41]);
	vgaxo(Crtx, 0x42, vga-&gt;crt[0x42]);
	vgaxo(Crtx, 0x44, vga-&gt;crt[0x44]);
	vgaxo(Crtx, 0x45, vga-&gt;crt[0x45]);
	vgaxo(Crtx, 0x46, vga-&gt;crt[0x46]);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;

	printitem(ctlr-&gt;name, "Seq10");
	for(i = 0x10; i &lt; 0x2E; i++)
		printreg(vga-&gt;sequencer[i]);
	printitem(ctlr-&gt;name, "Crt40");
	for(i = 0x40; i &lt; 0x47; i++)
		printreg(vga-&gt;crt[i]);
	printitem(ctlr-&gt;name, "Crt50");
	printreg(vga-&gt;crt[0x50]);
	printitem(ctlr-&gt;name, "Cop status");
	printreg(vga-&gt;crt[0xFF]);
}

Ctlr ark2000pv = {
	"ark2000pv",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr ark2000pvhwgc = {
	"ark2000pvhwgc",		/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

