<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/clgd546x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/clgd546x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Laguna Visual Media Accelerators Family CL-GD546x.
 */
typedef struct {
	Pcidev*	pci;
	uchar*	mmio;
	int	mem;

	int	format;			/* graphics and video format */
	int	threshold;		/* display threshold */
	int	tilectrl;		/* tiling control */
	int	vsc;			/* vendor specific control */
	int	control;		/* control */
	int	tilectrl2D3D;		/* tiling control 2D3D */
} Laguna;

enum {
	Format		= 0xC0,		/* graphics and video format */

	Threshold	= 0xEA,		/* Display Threshold */

	TileCtrl	= 0x2C4,

	Vsc		= 0x3FC,	/* Vendor Specific Control (32-bits) */

	Control		= 0x402,	/* 2D Control */
	TileCtrl2D3D	= 0x407,	/* (8-bits) */
};

static int
mmio8r(Laguna* laguna, int offset)
{
	return *(laguna-&gt;mmio+offset) &amp; 0xFF;
}

static void
mmio8w(Laguna* laguna, int offset, int data)
{
	*(laguna-&gt;mmio+offset) = data;
}

static int
mmio16r(Laguna* laguna, int offset)
{
	return *((ushort*)(laguna-&gt;mmio+offset)) &amp; 0xFFFF;
}

static void
mmio16w(Laguna* laguna, int offset, int data)
{
	*((ushort*)(laguna-&gt;mmio+offset)) = data;
}

static int
mmio32r(Laguna* laguna, int offset)
{
	return *((ulong*)(laguna-&gt;mmio+offset));
}

static void
mmio32w(Laguna* laguna, int offset, int data)
{
	*((ulong*)(laguna-&gt;mmio+offset)) = data;
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int f, i;
	uchar *mmio;
	Pcidev *p;
	Laguna *laguna;

	/*
	 * Save all the registers, even though we'll only
	 * change a handful.
	 */
	for(i = 0x06; i &lt; 0x20; i++)
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);

	for(i = 0x09; i &lt; 0x0C; i++)
		vga-&gt;graphics[i] = vgaxi(Grx, i);

	for(i = 0x19; i &lt; 0x20; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);

	if(vga-&gt;private == nil){
		vga-&gt;private = alloc(sizeof(Laguna));
		if((p = pcimatch(0, 0x1013, 0)) == nil)
			error("%s: not found\n", ctlr-&gt;name);
		switch(p-&gt;did){
		case 0xD0:			/* CL-GD5462 */
			vga-&gt;f[1] = 170000000;
			break;
		case 0xD4:			/* CL-GD5464 */
		case 0xD6:			/* CL-GD5465 */
			vga-&gt;f[1] = 230000000;
			break;
		default:
			error("%s: not found\n", ctlr-&gt;name);
		}

		if((f = open("#v/vgactl", OWRITE)) &lt; 0)
			error("%s: can't open vgactl\n", ctlr-&gt;name);
		if(write(f, "type clgd546x", 13) != 13)
			error("%s: can't set type\n", ctlr-&gt;name);
		close(f);
	
		mmio = segattach(0, "clgd546xmmio", 0, p-&gt;mem[1].size);
		if(mmio == (void*)-1)
			error("%s: can't attach mmio segment\n", ctlr-&gt;name);
		laguna = vga-&gt;private;
		laguna-&gt;pci = p;
		laguna-&gt;mmio = mmio;
	}
	laguna = vga-&gt;private;

	laguna-&gt;mem = (vga-&gt;sequencer[0x14] &amp; 0x07)+1;

	laguna-&gt;format = mmio16r(laguna, Format);
	laguna-&gt;threshold = mmio16r(laguna, Threshold);
	laguna-&gt;tilectrl = mmio16r(laguna, TileCtrl);
	laguna-&gt;vsc = mmio32r(laguna, Vsc);
	laguna-&gt;control = mmio16r(laguna, Control);
	laguna-&gt;tilectrl2D3D = mmio8r(laguna, TileCtrl2D3D);

	vga-&gt;vma = vga-&gt;vmz = laguna-&gt;pci-&gt;mem[0].size;
	ctlr-&gt;flag |= Hlinear;

	ctlr-&gt;flag |= Fsnarf;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	ushort x;
	int format, interleave, fetches, nointerleave, notile, pagesize, tiles;
	Laguna *laguna;

	nointerleave = 1;
	notile = 1;
	pagesize = 0;

	mode = vga-&gt;mode;

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &gt; vga-&gt;f[1])
		error("%s: invalid pclk - %lud\n", ctlr-&gt;name, vga-&gt;f[0]);

	if(mode-&gt;z &gt; 8)
		error("%s: depth %d not supported\n", ctlr-&gt;name, mode-&gt;z);

	/*
	 * VCLK3
	 */
	clgd54xxclock(vga, ctlr);
	vga-&gt;misc |= 0x0C;
	vga-&gt;sequencer[0x1E] = vga-&gt;n[0];
	vga-&gt;sequencer[0x0E] = (vga-&gt;d[0]&lt;&lt;1)|vga-&gt;p[0];

	vga-&gt;sequencer[0x07] = 0x00;
	if(mode-&gt;z == 8)
		vga-&gt;sequencer[0x07] |= 0x01;

	vga-&gt;crt[0x14] = 0;
	vga-&gt;crt[0x17] = 0xC3;

	/*
	 * Overflow bits.
	 */
	vga-&gt;crt[0x1A] = 0x00;
	x = mode-&gt;ehb&gt;&gt;3;
	if(x &amp; 0x40)
		vga-&gt;crt[0x1A] |= 0x10;
	if(x &amp; 0x80)
		vga-&gt;crt[0x1A] |= 0x20;
	if(vga-&gt;crt[0x16] &amp; 0x100)
		vga-&gt;crt[0x1A] |= 0x40;
	if(vga-&gt;crt[0x16] &amp; 0x200)
		vga-&gt;crt[0x1A] |= 0x80;
	vga-&gt;crt[0x1B] = 0x22;
	if(vga-&gt;crt[0x13] &amp; 0x100)
		vga-&gt;crt[0x1B] |= 0x10;
	vga-&gt;crt[0x1D] = 0x00;
	if(vga-&gt;crt[0x13] &amp; 0x200)
		vga-&gt;crt[0x1D] |= 0x01;
	vga-&gt;crt[0x1E] = 0x00;
	if(vga-&gt;crt[0x10] &amp; 0x400)
		vga-&gt;crt[0x1E] |= 0x01;
	if(vga-&gt;crt[0x15] &amp; 0x400)
		vga-&gt;crt[0x1E] |= 0x02;
	if(vga-&gt;crt[0x12] &amp; 0x400)
		vga-&gt;crt[0x1E] |= 0x04;
	if(vga-&gt;crt[0x06] &amp; 0x400)
		vga-&gt;crt[0x1E] |= 0x08;
	if(vga-&gt;crt[0x04] &amp; 0x100)
		vga-&gt;crt[0x1E] |= 0x10;
	if(vga-&gt;crt[0x02] &amp; 0x100)
		vga-&gt;crt[0x1E] |= 0x20;
	if(vga-&gt;crt[0x01] &amp; 0x100)
		vga-&gt;crt[0x1E] |= 0x40;
	if(vga-&gt;crt[0x00] &amp; 0x100)
		vga-&gt;crt[0x1E] |= 0x80;

	vga-&gt;graphics[0x0B] = 0x00;
	if(vga-&gt;vmz &gt; 1024*1024)
		vga-&gt;graphics[0x0B] |= 0x20;

	if(mode-&gt;interlace == 'v'){
		vga-&gt;crt[0x19] = vga-&gt;crt[0x00]/2;
		vga-&gt;crt[0x1A] |= 0x01;
	}

	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
		ctlr-&gt;flag |= Ulinear;

	laguna = vga-&gt;private;

	/*
	 * Ignore wide tiles for now, this simplifies things.
	 */
	if(mode-&gt;x &lt;= 640)
		tiles = 5;
	else if(mode-&gt;x &lt;= 1024)
		tiles = 8;
	else if(mode-&gt;x &lt;= 1280)
		tiles = 10;
	else if(mode-&gt;x &lt;= 1664)
		tiles = 13;
	else if(mode-&gt;x &lt;= 2048)
		tiles = 16;
	else if(mode-&gt;x &lt;= 2560)
		tiles = 20;
	else if(mode-&gt;x &lt;= 3228)
		tiles = 26;
	else
		tiles = 32;
	fetches = tiles;		/* -1? */

	if(nointerleave)
		interleave = 0;
	else switch(laguna-&gt;mem){
	default:
		interleave = 0;
		break;
	case 2:
		interleave = 1;
		break;
	case 4:
	case 8:
		interleave = 2;
		break;
	}

	if(mode-&gt;z == 8)
		format = 0;
	else if(mode-&gt;z == 16)
		format = (1&lt;&lt;12)|(2&lt;&lt;9);
	else if(mode-&gt;z == 24)
		format = (2&lt;&lt;12)|(2&lt;&lt;9);
	else
		format = (2&lt;&lt;12)|(2&lt;&lt;9);

	//if(ctlr-&gt;flag &amp; Ulinear)
	//	laguna-&gt;vsc |= 0x10000000;
	//else
		laguna-&gt;vsc &amp;= ~0x10000000;
	laguna-&gt;format = format;
	laguna-&gt;threshold = (interleave&lt;&lt;14)|(fetches&lt;&lt;8)|0x14;
	laguna-&gt;tilectrl &amp;= 0x3F;
	laguna-&gt;tilectrl |= (interleave&lt;&lt;14)|(tiles&lt;&lt;8);
	if(!notile)
		laguna-&gt;tilectrl |= 0x80;
	if(pagesize == 1)
		laguna-&gt;tilectrl |= 0x10;
	laguna-&gt;tilectrl2D3D = (interleave&lt;&lt;6)|tiles;
	laguna-&gt;control = 0;
	if(notile)
		laguna-&gt;control |= 0x1000;
	if(pagesize == 1)
		laguna-&gt;control |= 0x0200;
}

static void
load(Vga* vga, Ctlr*)
{
	Laguna *laguna;

	vgaxo(Seqx, 0x0E, vga-&gt;sequencer[0x0E]);
	vgaxo(Seqx, 0x1E, vga-&gt;sequencer[0x1E]);
	vgaxo(Seqx, 0x07, vga-&gt;sequencer[0x07]);

	if(vga-&gt;mode-&gt;interlace == 'v')
		vgaxo(Crtx, 0x19, vga-&gt;crt[0x19]);
	vgaxo(Crtx, 0x1A, vga-&gt;crt[0x1A]);
	vgaxo(Crtx, 0x1B, vga-&gt;crt[0x1B]);
	vgaxo(Crtx, 0x1D, vga-&gt;crt[0x1D]);
	vgaxo(Crtx, 0x1E, vga-&gt;crt[0x1E]);

	vgaxo(Grx, 0x0B, vga-&gt;graphics[0x0B]);

	laguna = vga-&gt;private;
	mmio16w(laguna, Format, laguna-&gt;format);
	mmio32w(laguna, Vsc, laguna-&gt;vsc);
	mmio16w(laguna, Threshold, laguna-&gt;threshold);
	mmio16w(laguna, TileCtrl, laguna-&gt;tilectrl);
	mmio8w(laguna, TileCtrl2D3D, laguna-&gt;tilectrl2D3D);
	mmio16w(laguna, Control, laguna-&gt;control);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char *name;
	Laguna *laguna;

	name = ctlr-&gt;name;

	printitem(name, "Seq06");
	for(i = 0x06; i &lt; 0x20; i++)
		printreg(vga-&gt;sequencer[i]);

	printitem(name, "Crt19");
	for(i = 0x19; i &lt; 0x20; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Gr09");
	for(i = 0x09; i &lt; 0x0C; i++)
		printreg(vga-&gt;graphics[i]);

	laguna = vga-&gt;private;
	Bprint(&amp;stdout, "\n");
	Bprint(&amp;stdout, "%s mem\t\t%d\n", ctlr-&gt;name, laguna-&gt;mem*1024*1024);
	Bprint(&amp;stdout, "%s Format\t\t%uX\n", ctlr-&gt;name, laguna-&gt;format);
	Bprint(&amp;stdout, "%s Threshold\t\t\t%uX\n",
		ctlr-&gt;name, laguna-&gt;threshold);
	Bprint(&amp;stdout, "%s TileCtrl\t\t\t%uX\n", ctlr-&gt;name, laguna-&gt;tilectrl);
	Bprint(&amp;stdout, "%s Vsc\t\t%uX\n", ctlr-&gt;name, laguna-&gt;vsc);
	Bprint(&amp;stdout, "%s Control\t\t%uX\n", ctlr-&gt;name, laguna-&gt;control);
	Bprint(&amp;stdout, "%s TileCtrlC2D3D\t\t%uX\n",
		ctlr-&gt;name, laguna-&gt;tilectrl2D3D);
}

Ctlr clgd546x = {
	"clgd546x",			/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr clgd546xhwgc = {
	"clgd546xhwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

