<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/ct65540.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/ct65540.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

enum
{
	X=	0x3D6,	/* index reg */
	D=	0x3D7,	/* data reg */
};

static int misc[] = {	0x0,  0x1,  0x2,  0x3,  0x4,  0x5,  0x6,  0xE, 0x28, 0x29,
			0x70, 0x72, 0x73, 0x7D, 0x7F, -1};
static int map[] = {	0x7,  0x8,  0xB,  0xC,  0x10, 0x11, -1};
static int flags[] = {	0xF,  0x2B, 0x44, 0x45, -1};
static int compat[] = {	0x14, 0x15, 0x1F, 0x7E, -1};
static int clock[] = {	0x30, 0x31, 0x32, 0x33, -1};
static int mm[] = {	0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, -1};
static int alt[] = {	0x0D, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E,
			0x24, 0x25, 0x26, 0x64, 0x65, 0x66, 0x67, -1};
static int flat[] = {	0x2C, 0x2D, 0x2E, 0x2F, 0x4F, 0x50, 0x51, 0x52, 0x53, 0x54,
			0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E,
			0x5F, 0x60, 0x61, 0x62, 0x63, 0x68, 0x6C, 0x6E, 0x6F, -1};

typedef struct Group Group;
struct Group {
	char *name;
	int *x;
};
static Group group[] = 
{
	{ "misc", misc, },
	{ "map", map, },
	{ "compatability", compat, },
	{ "clock", clock, },
	{ "multimedia", mm, },
	{ "alternate", alt, },
	{ "flat-panel", flat, },
	{ 0 },
};

static uchar greg[256];

static uchar
ctxi(uchar index)
{
	outportb(X, index);
	return inportb(D);
}

static void
ctxo(uchar index, uchar data)
{
	outportb(X, index);
	outportb(D, data);
}

/*
 * ct65540.
 */
static void
snarf(Vga*, Ctlr* ctlr)
{
	Group *g;
	int *xp;

	ctlr-&gt;flag |= Fsnarf;

	for(g = group; g-&gt;name; g++)
		for(xp = g-&gt;x; *xp &gt;= 0; xp++)
			greg[*xp] = ctxi(*xp);
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Foptions;
}

/*
 *  brute force and ignorance
 */
static int
setclock(Vga* vga)
{
	ulong fvco, t;
	ulong m, n;
	ulong bestm, bestn, diff, bestdiff, lastdiff;
	ulong p;

	if(vga-&gt;mode-&gt;frequency &gt; 220000000)
		return -1;

	vga-&gt;misc &amp;= ~(3&lt;&lt;2);
	vga-&gt;feature &amp;= ~3;
	greg[0x33] &amp;= ~0x20;		/* set VCLK not MCLK */
	greg[0x33] &amp;= ~0x80;		/* clk0 &amp; clk1 are 25.175 &amp; 28.322 MHz */

	vga-&gt;misc |= (2&lt;&lt;2);
	vga-&gt;feature |= 2;

	fvco = vga-&gt;mode-&gt;frequency;
	if(fvco == 0)
		return -1;
	p = 0;
	while(fvco &lt; 100000000){
		fvco *= 2;
		p++;
	}

	m = (1&lt;&lt;31)/(4*RefFreq);
	if(m &gt; 127)
		m = 127;
	bestdiff = 1&lt;&lt;31;
	bestm = 3;
	bestn = 3;
	for(; m &gt; 2; m--){
		lastdiff = 1&lt;&lt;31;
		for(n = 3; n &lt; 128; n++){
			t = (RefFreq*4*m)/n;
			diff = abs(fvco-t);
			if(diff &lt; bestdiff){
				bestdiff = diff;
				bestm = m;
				bestn = n;
			} else {
				if(diff &gt; lastdiff)
					break;
			}
			lastdiff = diff;
		}
	}

	greg[0x31] = bestm - 2;
	greg[0x32] = bestn - 2;
	greg[0x30] = (p&lt;&lt;1) | 1;
	return 0;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	int x;

	greg[0x15] = 0;			/* allow writes to all registers */

	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	if(vga-&gt;mode-&gt;z == 8){
		if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
			ctlr-&gt;flag |= Ulinear;
		vga-&gt;vmz = 1024*1024;
		vga-&gt;vmb = 1024*1024;
	
		/* linear mapping - extension regs*/
		greg[0x04] = (1&lt;&lt;2);	/* enable CRTC bits 16 &amp; 17, 32 bit mode */
		greg[0x0b] = 0x15;	/* linear addressing, &gt; 256k, sequential addr */
		greg[0x28] = 0x90;	/* non-interlaced, 256 colors */

		/* normal regs */
		vga-&gt;sequencer[0x04] = 0x0A;	/* sequential memory access */
		vga-&gt;graphics[0x05] = 0x00;	/* sequential access, shift out 8 bits at */
						/* a time */
		vga-&gt;attribute[0x10] &amp;= ~(1&lt;&lt;6); /* 1 dot clock per pixel */
		vga-&gt;crt[0x14] = 0x00;
		vga-&gt;crt[0x17] = 0xe3;		/* always byte mode */
	} else {
		/* mapped to 0xa0000 - extension regs*/
		greg[0x04] = (1&lt;&lt;2);	/* enable CRTC bits 16 &amp; 17, 32 bit mode */
		greg[0x0b] = 0x01;	/* 0xA0000 - 0xAFFFF, planar addressing */
		greg[0x28] = 0x80;	/* non-interlaced, 16 colors */
	}

	/* the extension registers have even more overflow bits */
	x = 0;
	if(vga-&gt;mode-&gt;vt &amp; (1&lt;&lt;10))
		x |= (1&lt;&lt;0);
	if(vga-&gt;mode-&gt;vrs &amp; (1&lt;&lt;10))
		x |= (1&lt;&lt;2);
	greg[0x16] = x;
	x = 0;
	if(vga-&gt;mode-&gt;ht &amp; (1&lt;&lt;(8+3)))
		x |= (1&lt;&lt;0);
	if(vga-&gt;mode-&gt;shb &amp; (1&lt;&lt;(8+3)))
		x |= (1&lt;&lt;4);
	if(vga-&gt;mode-&gt;ehb &amp; (1&lt;&lt;(6+3)))
		x |= (1&lt;&lt;5);
	greg[0x17] = x;

	if(vga-&gt;mode-&gt;y &gt; 480)
		vga-&gt;misc &amp;= 0x3F;

	setclock(vga);

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	Group *g;
	int *xp;

	/* must be first */
	ctxo(0x15, greg[0x15]);	/* write protect */
	ctxo(0x33, greg[0x33]);	/* select clock */

	if(ctlr-&gt;flag &amp; Ulinear){
		greg[0x8] = vga-&gt;vmb&gt;&gt;20;
		ctxo(0x08, greg[0x08]);
	}

	/* only write what changed */
	for(g = group; g-&gt;name; g++)
		for(xp = g-&gt;x; *xp &gt;= 0; xp++)
			ctxo(*xp, greg[*xp]);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga*, Ctlr* ctlr)
{
	Group *g;
	int *xp;
	char *name;
	int lastx;
	char item[32];

	name = ctlr-&gt;name;

	for(g = group; g-&gt;name; g++){
		lastx = -2;
		for(xp = g-&gt;x; *xp &gt;= 0; xp++){
			if(*xp != lastx+1){
				sprint(item, "%s %2.2ux:", g-&gt;name, *xp);
				printitem(name, item);
			}
			lastx = *xp;
			printreg(greg[*xp]);
		}
	}
}

Ctlr ct65540 = {
	"ct65540",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr ct65545 = {
	"ct65545",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr ct65545hwgc = {
	"ct65545hwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

