<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/et4000.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/et4000.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Tseng Labs Inc. ET4000 Video Controller.
 */
enum {
	Crtcbx		= 0x217A,	/* Secondary CRT controller */

	Sprite		= 0xE0,
	NSprite		= 0x10,

	Ima		= 0xF0,
	NIma		= 0x08,
};

static void
setkey(void)
{
	outportb(0x3BF, 0x03);
	outportb(0x3D8, 0xA0);
	outportb(0x3CD, 0x00);
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;

	setkey();

	vga-&gt;sequencer[0x06] = vgaxi(Seqx, 0x06);
	vga-&gt;sequencer[0x07] = vgaxi(Seqx, 0x07);

	for(i = 0x30; i &lt; 0x38; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);
	vga-&gt;crt[0x3F] = vgaxi(Crtx, 0x3F);

	vga-&gt;attribute[0x16] = vgaxi(Attrx, 0x16);
	vga-&gt;attribute[0x17] = vgaxi(Attrx, 0x17);

	/*
	 * Memory size.
	 */
	switch(vga-&gt;crt[0x37] &amp; 0x03){

	case 1:
		vga-&gt;vmz = 256*1024;
		break;

	case 2:
		vga-&gt;vmz = 512*1024;
		break;

	case 3:
		vga-&gt;vmz = 1024*1024;
		break;
	}
	if(strncmp(ctlr-&gt;name, "et4000-w32", 10) == 0){
		if(vga-&gt;crt[0x32] &amp; 0x80)
			vga-&gt;vmz *= 2;
	}
	else if(vga-&gt;crt[0x37] &amp; 0x80)
		vga-&gt;vmz *= 2;

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga* vga, Ctlr* ctlr)
{
	/*
	 * The ET4000 does not need to have the vertical
	 * timing values divided by 2 for interlace mode.
	 */
	if(vga-&gt;mode-&gt;interlace == 'v')
		vga-&gt;mode-&gt;interlace = 'V';

	if(strncmp(ctlr-&gt;name, "et4000-w32", 10) == 0)
		ctlr-&gt;flag |= Hpclk2x8;
	
	ctlr-&gt;flag |= Hclkdiv|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	ulong x;

	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	if(ctlr-&gt;flag &amp; Upclk2x8){
		mode = vga-&gt;mode;
		vga-&gt;crt[0x00] = ((mode-&gt;ht/2)&gt;&gt;3)-5;
		vga-&gt;crt[0x01] = ((mode-&gt;x/2)&gt;&gt;3)-1;
		vga-&gt;crt[0x02] = ((mode-&gt;shb/2)&gt;&gt;3)-1;
	
		x = (mode-&gt;ehb/2)&gt;&gt;3;
		vga-&gt;crt[0x03] = 0x80|(x &amp; 0x1F);
		vga-&gt;crt[0x04] = (mode-&gt;shs/2)&gt;&gt;3;
		vga-&gt;crt[0x05] = ((mode-&gt;ehs/2)&gt;&gt;3) &amp; 0x1F;
		if(x &amp; 0x20)
			vga-&gt;crt[0x05] |= 0x80;
	}
	/*
	 * Itth a mythtawee.
	 */
	if(vga-&gt;crt[0x14] &amp; 0x20)
		vga-&gt;crt[0x17] |= 0x08;
	vga-&gt;crt[0x17] &amp;= ~0x20;

	vga-&gt;crt[0x30] = 0x00;
	vga-&gt;crt[0x33] = 0x00;

	/*
	 * Overflow High.
	 */
	vga-&gt;crt[0x35] = 0x00;
	if(vga-&gt;crt[0x15] &amp; 0x400)
		vga-&gt;crt[0x35] |= 0x01;
	if(vga-&gt;crt[0x06] &amp; 0x400)
		vga-&gt;crt[0x35] |= 0x02;
	if(vga-&gt;crt[0x12] &amp; 0x400)
		vga-&gt;crt[0x35] |= 0x04;
	if(vga-&gt;crt[0x10] &amp; 0x400)
		vga-&gt;crt[0x35] |= 0x08;
	if(vga-&gt;crt[0x18] &amp; 0x400)
		vga-&gt;crt[0x35] |= 0x10;
	if(vga-&gt;mode-&gt;interlace == 'V')
		vga-&gt;crt[0x35] |= 0x80;

	/*
	 * Horizontal Overflow.
	 */
	vga-&gt;crt[0x3F] = 0x00;
	if(vga-&gt;crt[0x00] &amp; 0x100)
		vga-&gt;crt[0x3F] |= 0x01;
	if(vga-&gt;crt[0x02] &amp; 0x100)
		vga-&gt;crt[0x3F] |= 0x04;
	if(vga-&gt;crt[0x04] &amp; 0x100)
		vga-&gt;crt[0x3F] |= 0x10;
	if(vga-&gt;crt[0x13] &amp; 0x100)
		vga-&gt;crt[0x3F] |= 0x80;

	/*
	 * Turn off MMU buffers, linear map
	 * and memory-mapped registers.
	 */
	vga-&gt;crt[0x36] &amp;= ~0x38;

	if(strncmp(ctlr-&gt;name, "et4000-w32", 10) == 0)
		vga-&gt;crt[0x37] |= 0x80;

	vga-&gt;sequencer[0x06] = 0x00;

	/*
	 * Clock select.
	 */
	if(vga-&gt;f[0] &gt; 86000000)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);
	vga-&gt;misc &amp;= ~0x0C;
	vga-&gt;misc |= (vga-&gt;i[0] &amp; 0x03)&lt;&lt;2;
	if(vga-&gt;i[0] &amp; 0x04)
		vga-&gt;crt[0x34] |= 0x02;
	else
		vga-&gt;crt[0x34] &amp;= ~0x02;
	vga-&gt;crt[0x31] &amp;= ~0xC0;
	vga-&gt;crt[0x31] |= (vga-&gt;i[0] &amp; 0x18)&lt;&lt;3;

	vga-&gt;sequencer[0x07] &amp;= ~0x41;
	if(vga-&gt;d[0] == 4)
		vga-&gt;sequencer[0x07] |= 0x01;
	else if(vga-&gt;d[0] == 2)
		vga-&gt;sequencer[0x07] |= 0x40;

	vga-&gt;attribute[0x10] &amp;= ~0x40;
	vga-&gt;attribute[0x11] = Pblack;
	vga-&gt;attribute[0x16] = 0x80;

	if(ctlr-&gt;flag &amp; Upclk2x8)
		vga-&gt;attribute[0x16] |= 0x20;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	vgaxo(Crtx, 0x30, vga-&gt;crt[0x30]);
	vgaxo(Crtx, 0x31, vga-&gt;crt[0x31]);
	vgaxo(Crtx, 0x33, vga-&gt;crt[0x33]);
	vgaxo(Crtx, 0x34, vga-&gt;crt[0x34]);
	vgaxo(Crtx, 0x35, vga-&gt;crt[0x35]);
	vgaxo(Crtx, 0x36, vga-&gt;crt[0x36]);
	vgaxo(Crtx, 0x37, vga-&gt;crt[0x37]);
	vgaxo(Crtx, 0x3F, vga-&gt;crt[0x3F]);

	vgaxo(Seqx, 0x06, vga-&gt;sequencer[0x06]);
	vgaxo(Seqx, 0x07, vga-&gt;sequencer[0x07]);

	vgaxo(Attrx, 0x16, vga-&gt;attribute[0x16]);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char *name;
	ushort shb, vrs, x;

	name = ctlr-&gt;name;

	printitem(name, "Seq06");
	printreg(vga-&gt;sequencer[0x06]);
	printreg(vga-&gt;sequencer[0x07]);

	printitem(name, "Crt30");
	for(i = 0x30; i &lt; 0x38; i++)
		printreg(vga-&gt;crt[i]);
	printitem(name, "Crt3F");
	printreg(vga-&gt;crt[0x3F]);

	printitem(name, "Attr16");
	printreg(vga-&gt;attribute[0x16]);
	printreg(vga-&gt;attribute[0x17]);

	if(strncmp(name, "et4000-w32", 10) == 0){
		printitem(name, "SpriteE0");
		for(i = Sprite; i &lt; Sprite+NSprite; i++){
			outportb(Crtcbx, i);
			printreg(inportb(Crtcbx+1));
		}
		printitem(name, "ImaF0");
		for(i = Ima; i &lt; Ima+NIma; i++){
			outportb(Crtcbx, i);
			printreg(inportb(Crtcbx+1));
		}
	}

	/*
	 * Try to disassemble the snarfed values into
	 * understandable numbers.
	 * Only do this if we weren't called after Finit.
	 */
	if(ctlr-&gt;flag &amp; Finit)
		return;

	x = (vga-&gt;crt[0x01]+1)&lt;&lt;3;
	printitem(name, "hde");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	shb = ((((vga-&gt;crt[0x3F] &amp; 0x04)&lt;&lt;6)|vga-&gt;crt[0x02])+1)&lt;&lt;3;
	printitem(name, "shb");
	printreg(shb);
	Bprint(&amp;stdout, "%6ud", shb);

	x = (((vga-&gt;crt[0x05] &amp; 0x80)&gt;&gt;2)|(vga-&gt;crt[0x03] &amp; 0x1F))&lt;&lt;3;
	printitem(name, "ehb");
	printreg(x);
	for(i = 0; x &lt; shb; i++)
		x |= 0x200&lt;&lt;i;
	Bprint(&amp;stdout, "%6ud", x);

	x = ((((vga-&gt;crt[0x3F] &amp; 0x01)&lt;&lt;8)|vga-&gt;crt[0x00])+5)&lt;&lt;3;
	printitem(name, "ht");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	x = vga-&gt;crt[0x12];
	if(vga-&gt;crt[0x07] &amp; 0x02)
		x |= 0x100;
	if(vga-&gt;crt[0x07] &amp; 0x40)
		x |= 0x200;
	if(vga-&gt;crt[0x35] &amp; 0x04)
		x |= 0x400;
	x += 1;
	printitem(name, "vde");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	vrs = vga-&gt;crt[0x10];
	if(vga-&gt;crt[0x07] &amp; 0x04)
		vrs |= 0x100;
	if(vga-&gt;crt[0x07] &amp; 0x80)
		vrs |= 0x200;
	if(vga-&gt;crt[0x35] &amp; 0x08)
		vrs |= 0x400;
	printitem(name, "vrs");
	printreg(vrs);
	Bprint(&amp;stdout, "%6ud", vrs);

	x = (vrs &amp; ~0x0F)|(vga-&gt;crt[0x11] &amp; 0x0F);
	printitem(name, "vre");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	x = vga-&gt;crt[0x06];
	if(vga-&gt;crt[0x07] &amp; 0x01)
		x |= 0x100;
	if(vga-&gt;crt[0x07] &amp; 0x20)
		x |= 0x200;
	if(vga-&gt;crt[0x35] &amp; 0x02)
		x |= 0x400;
	x += 2;
	printitem(name, "vt");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	printitem(name, "d i");
	if(vga-&gt;sequencer[0x07] &amp; 0x01)
		x = 4;
	else if(vga-&gt;sequencer[0x07] &amp; 0x40)
		x = 2;
	else
		x = 0;
	Bprint(&amp;stdout, "%9ud", x);
	x = (vga-&gt;misc &amp; 0x0C)&gt;&gt;2;
	if(vga-&gt;crt[0x34] &amp; 0x02)
		x |= 0x04;
	x |= (vga-&gt;crt[0x31] &amp; 0xC0)&gt;&gt;3;
	Bprint(&amp;stdout, "%8ud\n", x);
}

Ctlr et4000 = {
	"et4000",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

