<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/hiqvideo.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/hiqvideo.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Chips and Technologies HiQVideo.
 * Extensions in the 69000 over the 65550 are not fully taken into account.
 * Depths other than 8 are too slow.
 */
enum {
	Frx		= 0x3D0,	/* Flat Panel Extensions Index */
	Mrx		= 0x3D2,	/* Multimedia Extensions Index */
	Xrx		= 0x3D6,	/* Configuration Extensions Index */
};

typedef struct {
	Pcidev* pci;

	uchar	fr[256];
	uchar	mr[256];
	uchar	xr[256];
} HiQVideo;

static uchar
hiqvideoxi(long port, uchar index)
{
	uchar data;

	outportb(port, index);
	data = inportb(port+1);

	return data;
}

static void
hiqvideoxo(long port, uchar index, uchar data)
{
	outportb(port, index);
	outportb(port+1, data);
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	Pcidev *p;
	HiQVideo *hqv;

	if(vga-&gt;private == nil){
		vga-&gt;private = alloc(sizeof(HiQVideo));
		hqv = vga-&gt;private;
		if((p = pcimatch(nil, 0x102C, 0)) == nil)
			error("%s: not found\n", ctlr-&gt;name);
		switch(p-&gt;did){
		case 0x00C0:		/* 69000 HiQVideo */
			vga-&gt;f[1] = 135000000;
			vga-&gt;vmz = 2048*1024;
			break;
		case 0x00E0:		/* 65550 HiQV32 */
		case 0x00E4:		/* 65554 HiQV32 */
		case 0x00E5:		/* 65555 HiQV32 */
			vga-&gt;f[1] = 90000000;
			vga-&gt;vmz = 2048*1024;
			break;
		default:
			error("%s: DID %4.4uX unsupported\n",
				ctlr-&gt;name, p-&gt;did);
		}
		hqv-&gt;pci = p;
	}
	hqv = vga-&gt;private;

	for(i = 0; i &lt; 0x50; i++)
		hqv-&gt;fr[i] = hiqvideoxi(Frx, i);
	for(i = 0; i &lt; 0x60; i++)
		hqv-&gt;mr[i] = hiqvideoxi(Mrx, i);
	for(i = 0x30; i &lt; 0x80; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);
	for(i = 0; i &lt; 0x100; i++)
		hqv-&gt;xr[i] = hiqvideoxi(Xrx, i);

	switch(hqv-&gt;pci-&gt;did){
	case 0x00C0:			/* 69000 HiQVideo */
		vga-&gt;f[1] = 135000000;
		vga-&gt;vmz = 2048*1024;
		break;
	case 0x00E0:			/* 65550 HiQV32 */
	case 0x00E4:			/* 65554 HiQV32 */
	case 0x00E5:			/* 65555 HiQV32 */
		/*
		 * Check VCC to determine max clock.
		 * 5V allows a higher rate.
		 */
		if(hqv-&gt;fr[0x0A] &amp; 0x02)
			vga-&gt;f[1] = 110000000;
		else
			vga-&gt;f[1] = 80000000;
		switch((hqv-&gt;xr[0x43]&gt;&gt;1) &amp; 0x03){
		case 0:
			vga-&gt;vmz = 1*1024*1024;
			break;
		case 1:
			vga-&gt;vmz = 2*1024*1024;
			break;
		default:
			vga-&gt;vmz = 16*1024*1024;
			break;
		}
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Foptions;
}

static void
clock(Vga* vga, Ctlr* ctlr)
{
	double f, fmin, fvco, m;
	ulong n, nmin, nmax, pd, rd;

	/*
	 * Constraints:
	 *  1.	1MHz &lt;= Fref &lt;= 60MHz
	 *  2.	150KHz &lt;= Fref/(RD*N) &lt;= 2MHz
	 *  3.	48MHz &lt; Fvco &lt;= 220MHz
	 *  4.	3 &lt;= M &lt;= 1023
	 *  5.	3 &lt;= N &lt;= 1023
	 */
	f = vga-&gt;f[0];

	/*
	 * Although pd = 0 is valid, things seems more stable
	 * starting at 1.
	 */
	for(pd = 1; pd &lt; 6; pd++){
		f = vga-&gt;f[0]*(1&lt;&lt;pd);
		if(f &gt; 48000000 &amp;&amp; f &lt;= 220000000)
			break;
	}
	if(pd &gt;= 6)
		error("%s: dclk %lud out of range\n", ctlr-&gt;name, vga-&gt;f[0]);
	vga-&gt;p[0] = pd;

	/*
	 * The reference divisor has only two possible values, 1 and 4.
	 */
	fmin = f;
	for(rd = 1; rd &lt;= 4; rd += 3){
		/*
		 * Find the range for n (constraint 2).
		 */
		for(nmin = 3; nmin &lt;= 1023; nmin++){
			if(RefFreq/(rd*nmin) &lt;= 2000000)
				break;
		}
		for(nmax = 1023; nmax &gt;= 3; nmax--){
			if(RefFreq/(rd*nmax) &gt;= 150000)
				break;
		}

		/*
		 * Now find the closest match for M and N.
		 */
		for(n = nmin; n &lt; nmax; n++){
			for(m = 3; m &lt;= vga-&gt;m[1]; m++){
				fvco = (RefFreq*4*m)/(rd*n);
				if(fvco &lt; 48000000 || fvco &gt; 220000000)
					continue;
				fvco -= f;
				if(fvco &lt; 0)
					fvco = -fvco;
				if(fvco &lt; fmin){
					fmin = fvco;
					vga-&gt;m[0] = m;
					vga-&gt;n[0] = n;
					vga-&gt;p[0] = pd;
					vga-&gt;r[0] = rd;
				}
			}
		}
	}

}

static void
init(Vga* vga, Ctlr* ctlr)
{
	HiQVideo *hqv;

	hqv = vga-&gt;private;

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	vga-&gt;misc &amp;= ~0x0C;
	hqv-&gt;fr[0x03] &amp;= ~0x0C;

	switch(vga-&gt;mode-&gt;z){
	case 8:
	case 16:
	case 32:
		break;
	default:
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);
	}

	/*
	 * FR[0x01] == 1 for CRT, 2 for LCD.
	 * Don't programme the clock if it's an LCD.
	 */
	if((hqv-&gt;fr[0x01] &amp; 0x03) == 0x02){
		vga-&gt;misc |= 0x08;
		hqv-&gt;fr[0x03] |= 0x08;
	}
	else{
		/*
		 * Clock bits. If the desired video clock is
		 * one of the two standard VGA clocks it can just be
		 * set using bits &lt;3:2&gt; of vga-&gt;misc or Fr03,
		 * otherwise the DCLK PLL needs to be programmed.
		 */
		if(vga-&gt;f[0] == VgaFreq0){
			/* nothing to do */;
		}
		else if(vga-&gt;f[0] == VgaFreq1){
			vga-&gt;misc |= 0x04;
			hqv-&gt;fr[0x03] |= 0x04;
		}
		else{
			if(vga-&gt;f[0] &gt; vga-&gt;f[1])
				error("%s: invalid dclk - %lud\n",
					ctlr-&gt;name, vga-&gt;f[0]);
	
			if((hqv-&gt;fr[0x01] &amp; 0x03) != 0x02){
				vga-&gt;m[1] = 1023;
				clock(vga, ctlr);
				hqv-&gt;xr[0xC8] = (vga-&gt;m[0]-2) &amp; 0xFF;
				hqv-&gt;xr[0xCA] = ((vga-&gt;m[0]-2) &amp; 0x300)&gt;&gt;8;
				hqv-&gt;xr[0xC9] = (vga-&gt;n[0]-2) &amp; 0xFF;
				hqv-&gt;xr[0xCA] |= ((vga-&gt;n[0]-2) &amp; 0x300)&gt;&gt;4;
				hqv-&gt;xr[0xCB] = (vga-&gt;p[0]&lt;&lt;4)|(vga-&gt;r[0] == 1);
			}
			vga-&gt;misc |= 0x08;
			hqv-&gt;fr[0x03] |= 0x08;
		}
	}

	if(vga-&gt;mode-&gt;y &gt;= 480)
		vga-&gt;misc &amp;= ~0xC0;

	/*
	 * 10 bits should be enough, but set the extended mode anyway.
	 */
	hqv-&gt;xr[0x09] |= 0x01;
	vga-&gt;crt[0x30] = ((vga-&gt;mode-&gt;vt-2)&gt;&gt;8) &amp; 0x0F;
	vga-&gt;crt[0x31] = ((vga-&gt;mode-&gt;y-1)&gt;&gt;8) &amp; 0x0F;
	vga-&gt;crt[0x32] = (vga-&gt;mode-&gt;vrs&gt;&gt;8) &amp; 0x0F;
	vga-&gt;crt[0x33] = (vga-&gt;mode-&gt;vrs&gt;&gt;8) &amp; 0x0F;
	vga-&gt;crt[0x38] = (((vga-&gt;mode-&gt;ht&gt;&gt;3)-5)&gt;&gt;8) &amp; 0x01;
	vga-&gt;crt[0x3C] = (vga-&gt;mode-&gt;ehb&gt;&gt;3) &amp; 0xC0;
	vga-&gt;crt[0x41] = (vga-&gt;crt[0x13]&gt;&gt;8) &amp; 0x0F;
	vga-&gt;crt[0x40] = 0x80;

	hqv-&gt;xr[0x40] |= 0x03;
	hqv-&gt;xr[0x80] |= 0x10;
	hqv-&gt;xr[0x81] &amp;= ~0x0F;
	switch(vga-&gt;mode-&gt;z){
	case 8:
		hqv-&gt;xr[0x81] |= 0x12;
		break;
	case 16:
		hqv-&gt;xr[0x81] |= 0x15;
		break;
	case 32:
		hqv-&gt;xr[0x81] |= 0x16;
		break;
	}

	hqv-&gt;xr[0x0A] = 0x01;
	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
		ctlr-&gt;flag |= Ulinear;

	vga-&gt;attribute[0x11] = 0;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	HiQVideo *hqv;

	hqv = vga-&gt;private;

	hiqvideoxo(Xrx, 0x0E, 0x00);
	while((vgai(Status1) &amp; 0x08) == 0x08)
		;
	while((vgai(Status1) &amp; 0x08) == 0)
		;
	vgaxo(Seqx, 0x07, 0x00);

	/*
	 * Set the clock if necessary.
	 */
	if((vga-&gt;misc &amp; 0x0C) == 0x08 &amp;&amp; (hqv-&gt;fr[0x01] &amp; 0x03) != 0x02){
		vgao(MiscW, vga-&gt;misc &amp; ~0x0C);
		hiqvideoxo(Frx, 0x03, hqv-&gt;fr[0x03] &amp; ~0x0C);

		hiqvideoxo(Xrx, 0xC8, hqv-&gt;xr[0xC8]);
		hiqvideoxo(Xrx, 0xC9, hqv-&gt;xr[0xC9]);
		hiqvideoxo(Xrx, 0xCA, hqv-&gt;xr[0xCA]);
		hiqvideoxo(Xrx, 0xCB, hqv-&gt;xr[0xCB]);
	}
	hiqvideoxo(Frx, 0x03, hqv-&gt;fr[0x03]);
	vgao(MiscW, vga-&gt;misc);

	hiqvideoxo(Xrx, 0x09, hqv-&gt;xr[0x09]);
	vgaxo(Crtx, 0x30, vga-&gt;crt[0x30]);
	vgaxo(Crtx, 0x31, vga-&gt;crt[0x31]);
	vgaxo(Crtx, 0x32, vga-&gt;crt[0x32]);
	vgaxo(Crtx, 0x33, vga-&gt;crt[0x33]);
	vgaxo(Crtx, 0x38, vga-&gt;crt[0x38]);
	vgaxo(Crtx, 0x3C, vga-&gt;crt[0x3C]);
	vgaxo(Crtx, 0x41, vga-&gt;crt[0x41]);
	vgaxo(Crtx, 0x40, vga-&gt;crt[0x40]);

	hiqvideoxo(Xrx, 0x40, hqv-&gt;xr[0x40]);
	hiqvideoxo(Xrx, 0x80, hqv-&gt;xr[0x80]);
	hiqvideoxo(Xrx, 0x81, hqv-&gt;xr[0x81]);
	if(ctlr-&gt;flag &amp; Ulinear){
		hqv-&gt;xr[0x05] = vga-&gt;vmb&gt;&gt;16;
		hqv-&gt;xr[0x06] = vga-&gt;vmb&gt;&gt;24;
		hiqvideoxo(Xrx, 0x05, hqv-&gt;xr[0x05]);
		hiqvideoxo(Xrx, 0x06, hqv-&gt;xr[0x06]);
		hqv-&gt;xr[0x0A] = 0x02;
	}
	hiqvideoxo(Xrx, 0x0A, hqv-&gt;xr[0x0A]);

	ctlr-&gt;flag |= Fload;
}

static ulong
dumpmclk(uchar data[4])
{
	double f, m, n;
	int pds, rds;

	m = data[0] &amp; 0x7F;
	n = data[1] &amp; 0x7F;
	pds = 1&lt;&lt;((data[2] &amp; 0x70)&gt;&gt;4);
	if(data[2] &amp; 0x01)
		rds = 1;
	else
		rds = 4;
	f = (RefFreq*4*(m+2))/(rds*(n+2));
	f /= pds;

	return f;
}

static ulong
dumpvclk(uchar data[4])
{
	double f, m, n;
	int pds, rds;

	m = ((data[2] &amp; 0x03)&lt;&lt;8)|data[0];
	n = (((data[2] &amp; 0x30)&gt;&gt;4)&lt;&lt;8)|data[1];
	pds = 1&lt;&lt;((data[3] &amp; 0x70)&gt;&gt;4);
	if(data[3] &amp; 0x01)
		rds = 1;
	else
		rds = 4;
	f = (RefFreq*4*(m+2))/(rds*(n+2));
	f /= pds;

	return f;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char *name;
	HiQVideo *hqv;

	name = ctlr-&gt;name;
	hqv = vga-&gt;private;

	printitem(name, "Fr00");
	for(i = 0; i &lt; 0x50; i++)
		printreg(hqv-&gt;fr[i]);
	printitem(name, "Mr00");
	for(i = 0; i &lt; 0x60; i++)
		printreg(hqv-&gt;mr[i]);
	printitem(name, "Crt30");
	for(i = 0x30; i &lt; 0x80; i++)
		printreg(vga-&gt;crt[i]);
	printitem(name, "Xr00");
	for(i = 0; i &lt; 0x100; i++)
		printreg(hqv-&gt;xr[i]);

	printitem(ctlr-&gt;name, "CLK0");
	for(i = 0; i &lt; 4; i++)
		printreg(hqv-&gt;xr[0xC0+i]);
	Bprint(&amp;stdout, "%23ld", dumpvclk(&amp;hqv-&gt;xr[0xC0]));
	printitem(ctlr-&gt;name, "CLK1");
	for(i = 0; i &lt; 4; i++)
		printreg(hqv-&gt;xr[0xC4+i]);
	Bprint(&amp;stdout, "%23ld", dumpvclk(&amp;hqv-&gt;xr[0xC4]));
	printitem(ctlr-&gt;name, "CLK2");
	for(i = 0; i &lt; 4; i++)
		printreg(hqv-&gt;xr[0xC8+i]);
	Bprint(&amp;stdout, "%23ld", dumpvclk(&amp;hqv-&gt;xr[0xC8]));
	printitem(ctlr-&gt;name, "MCLK");
	for(i = 0; i &lt; 4; i++)
		printreg(hqv-&gt;xr[0xCC+i]);
	Bprint(&amp;stdout, "%23ld", dumpmclk(&amp;hqv-&gt;xr[0xCC]));

	printitem(ctlr-&gt;name, "m n pd rd");
	Bprint(&amp;stdout, "%9ld %8ld       - %8ld %8ld\n",
		vga-&gt;m[0], vga-&gt;n[0], vga-&gt;p[0], vga-&gt;r[0]);
}

Ctlr hiqvideo = {
	"hiqvideo",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr hiqvideohwgc = {
	"hiqvideohwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

