<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/ibm8514.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/ibm8514.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * IBM 8514/A Graphics Coprocessor.
 */
enum {
	Subsys		= 0x42E8,	/* Subsystem Status (R), Control (W) */
	Advfunc		= 0x4AE8,	/* Advanced Function Control */
	CurY		= 0x82E8,	/* Current Y Position */
	CurX		= 0x86E8,	/* Current X Position */
	DestyAxstp	= 0x8AE8,	/* Destination Y Position/Axial Step Constant */
	DestxDiastp	= 0x8EE8,	/* Destination X Position/Diagonal Step Constant */
	ErrTerm		= 0x92E8,	/* Error Term */
	MajAxisPcnt	= 0x96E8,	/* Major Axis Pixel Count */
	GPstat		= 0x9AE8,	/* Graphics Processor Status (R) */
	Cmd		= 0x9AE8,	/* Drawing Command (W) */
	ShortStroke	= 0x9EE8,	/* Short Stroke Vector (W) */
	BkgdColor	= 0xA2E8,	/* Background Colour */
	FrgdColor	= 0xA6E8,	/* Foreground Colour */
	WrtMask		= 0xAAE8,	/* Bitplane Write Mask */
	RdMask		= 0xAEE8,	/* Bitplane Read Mask */
	ColorCmp	= 0xB2E8,	/* Colour Compare */
	BkgdMix		= 0xB6E8,	/* Background Mix */
	FrgdMix		= 0xBAE8,	/* Foreground Mix */
	Multifunc	= 0xBEE8,	/* Multifunction Control */
	PixTrans	= 0xE2E8,	/* Pixel Data Transfer */
};

enum {					/* Multifunc Index */
	MinAxisPcnt	= 0x0000,	/* Minor Axis Pixel Count */
	ScissorsT	= 0x1000,	/* Top Scissors */
	ScissorsL	= 0x2000,	/* Left Scissors */
	ScissorsB	= 0x3000,	/* Bottom Scissors */
	ScissorsR	= 0x4000,	/* Right Scissors */
	MemCntl		= 0x5000,	/* Memory Control */
	PixCntl		= 0xA000,	/* Pixel Control */
	MultMisc	= 0xE000,	/* Miscellaneous Multifunction Control (S3) */
	ReadSel		= 0xF000,	/* Read Register Select (S3) */
};

static void
load(Vga* vga, Ctlr*)
{
	outportw(Pixmask, 0x00);
	outportw(Subsys, 0x8000|0x1000);
	outportw(Subsys, 0x4000|0x1000);
	outportw(Pixmask, 0xFF);

	outportw(FrgdMix, 0x47);
	outportw(BkgdMix, 0x07);

	outportw(Multifunc, ScissorsT|0x000);
	outportw(Multifunc, ScissorsL|0x000);
	outportw(Multifunc, ScissorsB|(vga-&gt;vmz/vga-&gt;mode-&gt;x-1));
	outportw(Multifunc, ScissorsR|(vga-&gt;mode-&gt;x-1));

	outportw(WrtMask, 0xFFFF);
	outportw(Multifunc, PixCntl|0x0000);
}

static void
dump(Vga*, Ctlr* ctlr)
{
	printitem(ctlr-&gt;name, "Advfunc");
	Bprint(&amp;stdout, "%9.4uX\n", inportw(Advfunc));
	printitem(ctlr-&gt;name, "Subsys");
	Bprint(&amp;stdout, "%9.4uX\n", inportw(Subsys));
}

Ctlr ibm8514 = {
	"ibm8514",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

