<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/ics534x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/ics534x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * ICS534x GENDAC.
 * For now assumed to be hooked to either a Tseng Labs ET4000-W32p
 * (Hercules Dynamite Power, the Hercules generates RS2 using CLK3)
 * or an ARK2000pv (Diamond Stealth64 Graphics 2001).
 */
static uchar
setrs2(Vga* vga, Ctlr* ctlr)
{
	uchar rs2;

	rs2 = 0;
	if(strncmp(vga-&gt;ctlr-&gt;name, "et4000-w32", 10) == 0){
		rs2 = vgaxi(Crtx, 0x31);
		vgaxo(Crtx, 0x31, 0x40|rs2);
	}
	else if(strncmp(vga-&gt;ctlr-&gt;name, "ark2000pv", 9) == 0){
		rs2 = vgaxi(Seqx, 0x1C);
		vgaxo(Seqx, 0x1C, 0x80|rs2);
	}
	else
		error("%s: not configured for %s\n", vga-&gt;ctlr-&gt;name, ctlr-&gt;name);

	return rs2;
}

static void
restorers2(Vga* vga, uchar rs2)
{
	if(strncmp(vga-&gt;ctlr-&gt;name, "et4000-w32", 10) == 0)
		vgaxo(Crtx, 0x31, rs2);
	else if(strncmp(vga-&gt;ctlr-&gt;name, "ark2000pv", 9) == 0)
		vgaxo(Seqx, 0x1C, rs2);
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hpclk2x8|Foptions;
}

static void
clock(Vga* vga, Ctlr* ctlr)
{
	ulong f, m, n, r;
	double fmin, fmax, t, tok;

	/*
	 * The PLL frequency is defined by:
	 *		    (M+2)
	 *	 Fout = ------------ x Fref
	 *	        (N+2) x 2**R
	 * where M, N and R have the following contraints:
	 * 1)	     2MHz &lt; Fref &lt; 32MHz
	 * 2)		    Fref
	 *         600KHz &lt; ----- &lt;= 8Mhz
	 *	            (N+2)
	 * 3)		(M+2) x Fref
	 *     60MHz &lt;= ------------ &lt;= 270MHz
	 *		    (N+2)
	 * 4) Fout &lt; 135MHz
	 * 5) 1 &lt;= M &lt;= 127, 1 &lt;= N &lt;= 31, 0 &lt;= R &lt;= 3
	 *
	 * First determine R by finding the highest value
	 * for which
	 *	      2**R x Fout &lt;= 270Mhz
	 * The datasheet says that if the multiplexed 16-bit
	 * pseudo-colour mode is used then N2 (vga-&gt;r) must
	 * be 2.
	 */
	if(ctlr-&gt;flag &amp; Upclk2x8)
		vga-&gt;r[0] = 2;
	else{
		vga-&gt;r[0] = 4;
		for(r = 0; r &lt;= 3; r++){
			f = vga-&gt;f[0]*(1&lt;&lt;r);
			if(60000000 &lt; f &amp;&amp; f &lt;= 270000000)
				vga-&gt;r[0] = r;
		}
		if(vga-&gt;r[0] &gt; 3)
			error("%s: pclk %lud out of range\n",
				ctlr-&gt;name, vga-&gt;f[0]);
	}

	/*
	 * Now find the closest match for M and N.
	 * Lower values of M and N give better noise rejection.
	 */
	fmin = vga-&gt;f[0]*0.995;
	fmax = vga-&gt;f[0]*1.005;
	tok = 0.0;
	for(n = 31; n &gt;= 1; n--){
		t = RefFreq/(n+2);
		if(600000 &gt;= t || t &gt; 8000000)
			continue;

		t = vga-&gt;f[0]*(n+2)*(1&lt;&lt;vga-&gt;r[0]);
		t /= RefFreq;
		m = (t+0.5) - 2;
		if(m &gt; 127)
			continue;

		t = (m+2)*RefFreq;
		t /= (n+2)*(1&lt;&lt;vga-&gt;r[0]);

		if(fmin &lt;= t &amp;&amp; t &lt; fmax){
			vga-&gt;m[0] = m;
			vga-&gt;n[0] = n;
			tok = t;
		}
	}

	if(tok == 0.0)
		error("%s: pclk %lud out of range\n", ctlr-&gt;name, vga-&gt;f[0]);
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong pclk;
	char *p;

	/*
	 * Part comes in -135, -110 and -80MHz speed-grades.
	 */
	pclk = 80000000;
	if(p = strrchr(ctlr-&gt;name, '-'))
		pclk = strtoul(p+1, 0, 0) * 1000000;

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 * Check it's within range.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &gt; pclk)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);

	/*
	 * Determine whether to use 2x8-bit mode or not.
	 * If yes and the clock has already been initialised,
	 * initialise it again.
	 */
	if(vga-&gt;ctlr &amp;&amp; (vga-&gt;ctlr-&gt;flag &amp; Hpclk2x8) &amp;&amp; vga-&gt;mode-&gt;z == 8 &amp;&amp; vga-&gt;f[0] &gt;= pclk/2){
		vga-&gt;f[0] /= 2;
		resyncinit(vga, ctlr, Upclk2x8, 0);
	}

	/*
	 * Clock bits. If the desired video clock is
	 * one of the two standard VGA clocks it can just be
	 * set using bits &lt;3:2&gt; of vga-&gt;misc, otherwise we
	 * need to programme the DCLK PLL.
	 */
	vga-&gt;misc &amp;= ~0x0C;
	if(vga-&gt;f[0] == VgaFreq0)
		vga-&gt;i[0] = 0;
	else if(vga-&gt;f[0] == VgaFreq1){
		vga-&gt;misc |= 0x04;
		vga-&gt;i[0] = 1;
	}
	else{
		/*
		 * Initialise the PLL parameters.
		 * Use CLK0 f7 internal clock (there are only 3
		 * clock-select bits).
		 */
		clock(vga, ctlr);
		vga-&gt;i[0] = 0x07;
	}

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	uchar rs2, mode, pll;

	rs2 = setrs2(vga, ctlr);

	/*
	 * Put the chip into snooze mode,
	 * colour mode 0.
	 */
	mode = 0x00;
	outportb(Pixmask, 0x01);

	if(ctlr-&gt;flag &amp; Upclk2x8)
		mode = 0x10;

	/*
	 * If necessary, set the PLL parameters for CLK0 f7
	 * and make sure the PLL control register selects the
	 * correct clock. Preserve the memory clock setting.
	 */
	outportb(PaddrR, 0x0E);
	pll = inportb(Pdata) &amp; 0x10;
	if(vga-&gt;i[0] == 0x07){
		outportb(PaddrW, vga-&gt;i[0]);
		outportb(Pdata, vga-&gt;m[0]);
		outportb(Pdata, (vga-&gt;r[0]&lt;&lt;5)|vga-&gt;n[0]);
		pll |= 0x27;
	}
	outportb(PaddrW, 0x0E);
	outportb(Pdata, pll);
	outportb(Pixmask, mode);

	restorers2(vga, rs2);
	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	uchar rs2, m, n;
	char buf[32];
	ulong f;

	rs2 = setrs2(vga, ctlr);

	printitem(ctlr-&gt;name, "command");
	printreg(inportb(Pixmask));

	outportb(PaddrR, 0x00);
	for(i = 0; i &lt; 0x0E; i++){
		sprint(buf, "f%X m n", i);
		printitem(ctlr-&gt;name, buf);
		m = inportb(Pdata);
		printreg(m);
		n = inportb(Pdata);
		printreg(n);

		f = 14318180*(m+2);
		f /= (n &amp; 0x1F)+2;
		f /= 1&lt;&lt;((n&gt;&gt;5) &amp; 0x03);
		Bprint(&amp;stdout, "%12lud", f);
	}
	printitem(ctlr-&gt;name, "control");
	printreg(inportb(Pdata));

	restorers2(vga, rs2);
}

Ctlr ics534x = {
	"ics534x",			/* name */
	0,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

