<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/mach64.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/mach64.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * ATI Mach64. Some hope. Kind of like a Mach32.
 * No support for accelerator so can only do up to 1024x768.
 *
 * All ATI Extended Registers are addressed using the modified index
 *	index = (0x02&lt;&lt;6)|(index &amp; 0x3F);
 * so registers 0x00-&gt;0x3F map to 0x80-&gt;0xBF, but we will only ever
 * look at a few in the range 0xA0-&gt;0xBF. In this way we can stash
 * them in the vga-&gt;crt[] array.
 */
enum {
	Configcntl	= 0x6AEC,	/* Configuration control */
	Configstat	= 0x72EC,	/* Configuration status */
	Memcntl		= 0x52EC,	/* Memory control */
	Scratch1	= 0x46EC,	/* Scratch Register (BIOS info) */
};

typedef struct {
	ulong	configcntl;
	ulong	configstat;
	ulong	memcntl;
	ulong	scratch1;
} Mach64;

/*
 * There are a number of possible clock generator chips for these
 * boards. We can divide any frequency by 2 (bit&lt;6&gt; of b8).
 */
typedef struct {
	ulong	frequency;
	uchar	be;			/* &lt;4&gt; - bit&lt;3&gt; of frequency index */
	uchar	b9;			/* &lt;1&gt; - bit&lt;2&gt; of frequency index */
	uchar	genmo;			/* &lt;3:2&gt; - bits &lt;1:0&gt; of frequency index */
} Pclk;

enum {
	Npclkx		= 16,		/* number of clock entries per table */
};

/*
 * ATI18811-0
 */
static Pclk ati188110[Npclkx] = {
	{  42950000, 0x00, 0x00, 0x00 },
	{  48770000, 0x00, 0x00, 0x04 },
	{  92400000, 0x00, 0x00, 0x08 },
	{  36000000, 0x00, 0x00, 0x0C },
	{  50350000, 0x00, 0x02, 0x00 },
	{  56640000, 0x00, 0x02, 0x04 },
	{ 	  0, 0x00, 0x02, 0x08 },
	{  44900000, 0x00, 0x02, 0x0C },
	{  30240000, 0x10, 0x00, 0x00 },
	{  32000000, 0x10, 0x00, 0x04 },
	{ 110000000, 0x10, 0x00, 0x08 },
	{  80000000, 0x10, 0x00, 0x0C },
	{  39910000, 0x10, 0x02, 0x00 },
	{  44900000, 0x10, 0x02, 0x04 },
	{  75000000, 0x10, 0x02, 0x08 },
	{  65000000, 0x10, 0x02, 0x0C },
};

/*
 * ATI18811-1, ATI18811-2
 * PCLK_TABLE = 0 in Mach64 speak.
 */
static Pclk ati188111[Npclkx] = {
	{ 100000000, 0x00, 0x00, 0x00 },
	{ 126000000, 0x00, 0x00, 0x04 },
	{  92400000, 0x00, 0x00, 0x08 },
	{  36000000, 0x00, 0x00, 0x0C },
	{  50350000, 0x00, 0x02, 0x00 },
	{  56640000, 0x00, 0x02, 0x04 },
	{ 	  0, 0x00, 0x02, 0x08 },
	{  44900000, 0x00, 0x02, 0x0C },
	{ 135000000, 0x10, 0x00, 0x00 },
	{  32000000, 0x10, 0x00, 0x04 },
	{ 110000000, 0x10, 0x00, 0x08 },
	{  80000000, 0x10, 0x00, 0x0C },
	{  39910000, 0x10, 0x02, 0x00 },
	{  44900000, 0x10, 0x02, 0x04 },
	{  75000000, 0x10, 0x02, 0x08 },
	{  65000000, 0x10, 0x02, 0x0C },
};

/*
 * ATI18818
 * The first four entries are programmable and the default
 * settings are either those below or those below divided by 2
 * (PCLK_TABLE = 1 and PCLK_TABLE = 2 respectively in Mach64
 * speak).
 */
static Pclk ati18818[Npclkx] = {
	{  50350000, 0x00, 0x00, 0x00 },
	{  56640000, 0x00, 0x00, 0x04 },
	{  63000000, 0x00, 0x00, 0x08 },
	{  72000000, 0x00, 0x00, 0x0C },
	{  40000000, 0x00, 0x02, 0x00 },
	{  44900000, 0x00, 0x02, 0x04 },
	{  49500000, 0x00, 0x02, 0x08 },
	{  50000000, 0x00, 0x02, 0x0C },
	{ 	  0, 0x10, 0x00, 0x00 },
	{ 110000000, 0x10, 0x00, 0x04 },
	{ 126000000, 0x10, 0x00, 0x08 },
	{ 135000000, 0x10, 0x00, 0x0C },
	{ 	  0, 0x10, 0x02, 0x00 },
	{  80000000, 0x10, 0x02, 0x04 },
	{  75000000, 0x10, 0x02, 0x08 },
	{  65000000, 0x10, 0x02, 0x0C },
};

static Pclk *pclkp;			/* which clock chip we are using */
static ulong atix;			/* index to extended regsiters */

static uchar
atixi(uchar index)
{
	outportb(atix, index);
	return inportb(atix+1);
}

static void
atixo(uchar index, uchar data)
{
	outportw(atix, (data&lt;&lt;8)|index);
}

static void
atixinit(Vga* vga, Ctlr*)
{
	uchar b;

	/*
	 * Set the I/O address and offset for the ATI
	 * extended registers to something we know about.
	 */
	if(atix == 0){
		outportw(Grx, (0xCE&lt;&lt;8)|0x50);
		outportw(Grx, (0x81&lt;&lt;8)|0x51);
		atix = 0x1CE;
	}

	/*
	 * Unlock the ATI Extended Registers.
	 * We leave them unlocked from now on.
	 * Why does this chip have so many
	 * lock bits?
	 */
	if((b = atixi(0xB8)) &amp; 0x3F)
		atixo(0xB8, b &amp; 0xC0);
	b = atixi(0xAB);
	atixo(0xAB, b &amp; ~0x18);
	atixo(0xB4, 0x00);
	b = atixi(0xB9);
	atixo(0xB9, b &amp; ~0x80);
	b = atixi(0xBE);
	atixo(0xBE, b|0x09);

	if(vga-&gt;private == 0)
		vga-&gt;private = alloc(sizeof(Mach64));
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	Mach64 *mach64;

	atixinit(vga, ctlr);
	for(i = 0xA0; i &lt; 0xC0; i++)
		vga-&gt;crt[i] = atixi(i);

	mach64 = vga-&gt;private;
	mach64-&gt;configcntl = inportl(Configcntl);
	mach64-&gt;configstat = inportl(Configstat);
	mach64-&gt;memcntl = inportl(Memcntl);
	mach64-&gt;scratch1 = inportl(Scratch1);

	/*
	 * Memory size.
	 */
	switch(mach64-&gt;memcntl &amp; 0x07){

	case 0:
		vga-&gt;vmz = 512*1024;
		break;

	case 1:
		vga-&gt;vmz = 1024*1024;
		break;

	case 2:
		vga-&gt;vmz = 2*1024*1024;
		break;

	case 3:
		vga-&gt;vmz = 4*1024*1024;
		break;

	case 4:
		vga-&gt;vmz = 6*1024*1024;
		break;

	case 5:
		vga-&gt;vmz = 8*1024*1024;
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	int f, divisor, index;

	mode = vga-&gt;mode;

	/*
	 * Must somehow determine which clock chip to use here.
	 * For now, punt and assume ATI18818.
	 */
	pclkp = ati18818;
	if(pclkp == 0)
		error("%s: can't determine clock chip\n", ctlr-&gt;name);

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;

	/*
	 * Find a clock frequency close to what we want.
	 * 'Close' is within 1MHz.
	 */
	for(divisor = 0, index = 0; index &lt; Npclkx; index++, divisor = 0){
		divisor = 1;
		f = pclkp[index].frequency/divisor;
		if(f &lt; vga-&gt;f[0]+1000000 &amp;&amp; f &gt;= vga-&gt;f[0]-1000000)
			break;

		divisor = 2;
		f /= divisor;
		if(f &lt; vga-&gt;f[0]+1000000 &amp;&amp; f &gt;= vga-&gt;f[0]-1000000)
			break;
	}
	if(divisor == 0)
		error("%s: no suitable clock for %lud\n",
			ctlr-&gt;name, vga-&gt;f[0]);

	vga-&gt;d[0] = divisor;
	vga-&gt;i[0] = index;

	vga-&gt;crt[0xB0] &amp;= 0xDA;
	vga-&gt;crt[0xB1] &amp;= 0x87;
	vga-&gt;crt[0xB5] &amp;= 0x7E;
	vga-&gt;crt[0xB6] &amp;= 0xE2;
	vga-&gt;crt[0xB3] &amp;= 0xAF;
	vga-&gt;crt[0xA6] &amp;= 0xFE;
	vga-&gt;crt[0xA7] &amp;= 0xF4;

	/*
	 * 256-colour linear addressing.
	 */
	if(mode-&gt;z == 8){
		vga-&gt;graphics[0x05] = 0x00;
		vga-&gt;attribute[0x10] &amp;= ~0x40;
		vga-&gt;crt[0x13] = (mode-&gt;x/8)/2;
		vga-&gt;crt[0x14] = 0x00;
		vga-&gt;crt[0x17] = 0xE3;

		vga-&gt;crt[0xB0] |= 0x20;
		vga-&gt;crt[0xB6] |= 0x04;
	}
	vga-&gt;attribute[0x11] = 0x00;
	vga-&gt;crt[0xB6] |= 0x01;
	vga-&gt;crt[0xBE] &amp;= ~0x04;

	/*
	 * Do the clock index bits.
	 */
	vga-&gt;crt[0xB8] &amp;= 0x3F;
	vga-&gt;crt[0xB9] &amp;= 0xFD;
	vga-&gt;crt[0xBE] &amp;= 0xE5;

	if(vga-&gt;d[0] == 2)
		vga-&gt;crt[0xB8] |= 0x40;
	vga-&gt;crt[0xB9] |= pclkp[vga-&gt;i[0]].b9;
	vga-&gt;crt[0xBE] |= pclkp[vga-&gt;i[0]].be;
	vga-&gt;misc |= pclkp[vga-&gt;i[0]].genmo;

	if(vga-&gt;mode-&gt;interlace == 'v')
		vga-&gt;crt[0xBE] |= 0x02;

	/*
	 * Turn off 128Kb CPU address bit so
	 * we only have a 64Kb aperture at 0xA0000.
	 */
	vga-&gt;crt[0xBD] &amp;= ~0x04;

	ctlr-&gt;type = mach32.name;

	/*
	 * The Mach64 can only address 1Mb in VGA mode
	 */
	vga-&gt;vmz = 1*1024*1024;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	/*
	 * We should probably do something here to make sure we that we
	 * have access to all the video memory through the 64Kb VGA aperture
	 * by disabling and linear aperture and memory boundary and then
	 * enabling the VGA controller.
	 * But for now, let's just assume it's ok, the Mach64 documentation
	 * is just as clear as the Mach32 documentation.
	 */
	atixo(0xB0, vga-&gt;crt[0xB0]);
	atixo(0xB1, vga-&gt;crt[0xB1]);
	atixo(0xB5, vga-&gt;crt[0xB5]);
	atixo(0xB6, vga-&gt;crt[0xB6]);
	atixo(0xB3, vga-&gt;crt[0xB3]);
	atixo(0xA6, vga-&gt;crt[0xA6]);
	atixo(0xA7, vga-&gt;crt[0xA7]);
	atixo(0xB8, vga-&gt;crt[0xB8]);
	atixo(0xB9, vga-&gt;crt[0xB9]);
	atixo(0xBE, vga-&gt;crt[0xBE]);
	vgao(MiscW, vga-&gt;misc);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	Mach64 *mach64;

	printitem(ctlr-&gt;name, "ATIX");
	for(i = 0xA0; i &lt; 0xC0; i++)
		printreg(vga-&gt;crt[i]);

	if((mach64 = vga-&gt;private) == 0)
		return;

	printitem(ctlr-&gt;name, "CONFIGCNTL");
	Bprint(&amp;stdout, "%.8lux\n", mach64-&gt;configcntl);
	printitem(ctlr-&gt;name, "CONFIGSTAT");
	Bprint(&amp;stdout, "%.8lux\n", mach64-&gt;configstat);
	printitem(ctlr-&gt;name, "MEMCNTL");
	Bprint(&amp;stdout, "%.8lux\n", mach64-&gt;memcntl);
	printitem(ctlr-&gt;name, "SCRATCH1");
	Bprint(&amp;stdout, "%.8lux\n", mach64-&gt;scratch1);
}

Ctlr mach64 = {
	"mach64",			/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

