<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/mach64xx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/mach64xx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * ATI Mach64 family.
 */
enum {
	HTotalDisp,
	HSyncStrtWid,
	VTotalDisp,
	VSyncStrtWid,
	VlineCrntVline,
	OffPitch,
	IntCntl,
	CrtcGenCntl,

	OvrClr,
	OvrWidLR,
	OvrWidTB,

	CurClr0,
	CurClr1,
	CurOffset,
	CurHVposn,
	CurHVoff,

	ScratchReg0,
	ScratchReg1,	/* Scratch Register (BIOS info) */
	ClockCntl,
	BusCntl,
	MemCntl,
	ExtMemCntl,
	MemVgaWpSel,
	MemVgaRpSel,
	DacRegs,
	DacCntl,
	GenTestCntl,
	ConfigCntl,	/* Configuration control */
	ConfigChipId,
	ConfigStat0,	/* Configuration status 0 */
	ConfigStat1,	/* Configuration status 1 */
	ConfigStat2,
	DspConfig,	/* Rage */
	DspOnOff,	/* Rage */

	DpBkgdClr,
	DpChainMsk,
	DpFrgdClr,
	DpMix,
	DpPixWidth,
	DpSrc,
	DpWriteMsk,

	LcdIndex,
	LcdData,

	Nreg,

	TvIndex = 0x1D,
	TvData = 0x27,

	LCD_ConfigPanel = 0,
	LCD_GenCtrl,
	LCD_DstnCntl,
	LCD_HfbPitchAddr,
	LCD_HorzStretch,
	LCD_VertStretch,
	LCD_ExtVertStretch,
	LCD_LtGio,
	LCD_PowerMngmnt,
	LCD_ZvgPio,
	Nlcd,
};

static char* iorname[Nreg] = {
	"HTotalDisp",
	"HSyncStrtWid",
	"VTotalDisp",
	"VSyncStrtWid",
	"VlineCrntVline",
	"OffPitch",
	"IntCntl",
	"CrtcGenCntl",

	"OvrClr",
	"OvrWidLR",
	"OvrWidTB",

	"CurClr0",
	"CurClr1",
	"CurOffset",
	"CurHVposn",
	"CurHVoff",

	"ScratchReg0",
	"ScratchReg1",
	"ClockCntl",
	"BusCntl",
	"MemCntl",
	"ExtMemCntl",
	"MemVgaWpSel",
	"MemVgaRpSel",
	"DacRegs",
	"DacCntl",
	"GenTestCntl",
	"ConfigCntl",
	"ConfigChipId",
	"ConfigStat0",
	"ConfigStat1",
	"ConfigStat2",
	"DspConfig",
	"DspOnOff",

	"DpBkgdClr",
	"DpChainMsk",
	"DpFrgdClr",
	"DpMix",
	"DpPixWidth",
	"DpSrc",
	"DpWriteMsk",

	"LcdIndex",
	"LcdData",	
};

static char* lcdname[Nlcd] = {
	"LCD ConfigPanel",
	"LCD GenCntl",
	"LCD DstnCntl",
	"LCD HfbPitchAddr",
	"LCD HorzStretch",
	"LCD VertStretch",
	"LCD ExtVertStretch",
	"LCD LtGio",
	"LCD PowerMngmnt",
	"LCD ZvgPio"
};

/*
 * Crummy hack: all io register offsets
 * here get IOREG or'ed in, so that we can
 * tell the difference between an uninitialized
 * array entry and HTotalDisp.
 */
enum {
	IOREG = 0x10000,
};
static ushort ioregs[Nreg] = {
 [HTotalDisp]		IOREG|0x0000,
 [HSyncStrtWid]	IOREG|0x0100,
 [VTotalDisp]		IOREG|0x0200,
 [VSyncStrtWid]		IOREG|0x0300,
 [VlineCrntVline]	IOREG|0x0400,
 [OffPitch]			IOREG|0x0500,
 [IntCntl]			IOREG|0x0600,
 [CrtcGenCntl]		IOREG|0x0700,
 [OvrClr]			IOREG|0x0800,
 [OvrWidLR]		IOREG|0x0900,
 [OvrWidTB]		IOREG|0x0A00,
 [CurClr0]			IOREG|0x0B00,
 [CurClr1]			IOREG|0x0C00,
 [CurOffset]		IOREG|0x0D00,
 [CurHVposn]		IOREG|0x0E00,
 [CurHVoff]		IOREG|0x0F00,
 [ScratchReg0]		IOREG|0x1000,
 [ScratchReg1]		IOREG|0x1100,
 [ClockCntl]		IOREG|0x1200,
 [BusCntl]			IOREG|0x1300,
 [MemCntl]		IOREG|0x1400,
 [MemVgaWpSel]	IOREG|0x1500,
 [MemVgaRpSel]	IOREG|0x1600,
 [DacRegs]		IOREG|0x1700,
 [DacCntl]			IOREG|0x1800,
 [GenTestCntl]		IOREG|0x1900,
 [ConfigCntl]		IOREG|0x1A00,
 [ConfigChipId]		IOREG|0x1B00,
 [ConfigStat0]		IOREG|0x1C00,
 [ConfigStat1]		IOREG|0x1D00,
/* [GpIo]				IOREG|0x1E00, */
/* [HTotalDisp]			IOREG|0x1F00, 	duplicate, says XFree86 */
};

static ushort pciregs[Nreg] = {
  [HTotalDisp]		0x00,
  [HSyncStrtWid]	0x01,
  [VTotalDisp]		0x02,
  [VSyncStrtWid]        0x03,
  [VlineCrntVline]      0x04,
  [OffPitch]		0x05,
  [IntCntl]		0x06,
  [CrtcGenCntl]		0x07,
  [DspConfig]		0x08,
  [DspOnOff]		0x09,
  [OvrClr]		0x10,
  [OvrWidLR]		0x11,
  [OvrWidTB]		0x12,
  [CurClr0]		0x18,
  [CurClr1]		0x19,
  [CurOffset]		0x1A,
  [CurHVposn]		0x1B,
  [CurHVoff]		0x1C,
  [ScratchReg0]		0x20,
  [ScratchReg1]		0x21,
  [ClockCntl]		0x24,
  [BusCntl]		0x28,
  [LcdIndex]		0x29,
  [LcdData]		0x2A,
  [ExtMemCntl]		0x2B,
  [MemCntl]		0x2C,
  [MemVgaWpSel]		0x2D,
  [MemVgaRpSel]		0x2E,
  [DacRegs]		0x30,
  [DacCntl]		0x31,
  [GenTestCntl]		0x34,
  [ConfigCntl]		0x37,
  [ConfigChipId]	0x38,
  [ConfigStat0]		0x39,
  [ConfigStat1]		0x25,	/* rsc: was 0x3A, but that's not what the LT manual says */
  [ConfigStat2]		0x26,
  [DpBkgdClr]		0xB0,
  [DpChainMsk]		0xB3,
  [DpFrgdClr]		0xB1,
  [DpMix]		0xB5,
  [DpPixWidth]		0xB4,
  [DpSrc]		0xB6,
  [DpWriteMsk]		0xB2,
};

enum {
	PLLm		= 0x02,
	PLLp		= 0x06,
	PLLn0		= 0x07,
	PLLn1		= 0x08,
	PLLn2		= 0x09,
	PLLn3		= 0x0A,
	PLLx            = 0x0B,         /* external divisor (Rage) */

	Npll		= 32,
	Ntv		= 1,		/* actually 256, but not used */
};

typedef struct Mach64xx	Mach64xx;
struct Mach64xx {
	ulong	io;
	Pcidev*	pci;
	int	bigmem;
	int	lcdon;
	int	lcdpanelid;

	ulong	reg[Nreg];
	ulong	lcd[Nlcd];
	ulong	tv[Ntv];
	uchar	pll[Npll];

	ulong	(*ior32)(Mach64xx*, int);
	void	(*iow32)(Mach64xx*, int, ulong);
};

static ulong
portior32(Mach64xx* mp, int r)
{
	if((ioregs[r] &amp; IOREG) == 0)
		return ~0;

	return inportl(((ioregs[r] &amp; ~IOREG)&lt;&lt;2)+mp-&gt;io);
}

static void
portiow32(Mach64xx* mp, int r, ulong l)
{
	if((ioregs[r] &amp; IOREG) == 0)
		return;

	outportl(((ioregs[r] &amp; ~IOREG)&lt;&lt;2)+mp-&gt;io, l);
}

static ulong
pciior32(Mach64xx* mp, int r)
{
	return inportl((pciregs[r]&lt;&lt;2)+mp-&gt;io);
}

static void
pciiow32(Mach64xx* mp, int r, ulong l)
{
	outportl((pciregs[r]&lt;&lt;2)+mp-&gt;io, l);
}

static uchar
pllr(Mach64xx* mp, int r)
{
	int io;

	if(mp-&gt;ior32 == portior32)
		io = ((ioregs[ClockCntl]&amp;~IOREG)&lt;&lt;2)+mp-&gt;io;
	else
		io = (pciregs[ClockCntl]&lt;&lt;2)+mp-&gt;io;

	outportb(io+1, r&lt;&lt;2);
	return inportb(io+2);
}

static void
pllw(Mach64xx* mp, int r, uchar b)
{
	int io;

	if(mp-&gt;ior32 == portior32)
		io = ((ioregs[ClockCntl]&amp;~IOREG)&lt;&lt;2)+mp-&gt;io;
	else
		io = (pciregs[ClockCntl]&lt;&lt;2)+mp-&gt;io;

	outportb(io+1, (r&lt;&lt;2)|0x02);
	outportb(io+2, b);
}

static ulong
lcdr32(Mach64xx *mp, ulong r)
{
	ulong or;

	or = mp-&gt;ior32(mp, LcdIndex);
	mp-&gt;iow32(mp, LcdIndex, (or&amp;~0x0F) | (r&amp;0x0F));
	return mp-&gt;ior32(mp, LcdData);
}

static void
lcdw32(Mach64xx *mp, ulong r, ulong v)
{
	ulong or;

	or = mp-&gt;ior32(mp, LcdIndex);
	mp-&gt;iow32(mp, LcdIndex, (or&amp;~0x0F) | (r&amp;0x0F));
	mp-&gt;iow32(mp, LcdData, v);
}

static ulong
tvr32(Mach64xx *mp, ulong r)
{
	outportb(mp-&gt;io+(TvIndex&lt;&lt;2), r&amp;0x0F);
	return inportl(mp-&gt;io+(TvData&lt;&lt;2));
}

static void
tvw32(Mach64xx *mp, ulong r, ulong v)
{
	outportb(mp-&gt;io+(TvIndex&lt;&lt;2), r&amp;0x0F);
	outportl(mp-&gt;io+(TvData&lt;&lt;2), v);
}

static int smallmem[] = {
	   512*1024,	  1024*1024,	 2*1024*1024,	 4*1024*1024,
	6*1024*1024,	8*1024*1024,	12*1024*1024,	16*1024*1024,
};

static int bigmem[] = {
	    512*1024,	  2*512*1024,	  3*512*1024,	  4*512*1024,
	  5*512*1024,	  6*512*1024,	  7*512*1024,	  8*512*1024,
	 5*1024*1024,	 6*1024*1024,	 7*1024*1024,	 8*1024*1024,
	10*1024*1024,	12*1024*1024,	14*1024*1024,	16*1024*1024,
};

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	Mach64xx *mp;
	int i;
	ulong v;

	if(vga-&gt;private == nil){
		vga-&gt;private = alloc(sizeof(Mach64xx));
		mp = vga-&gt;private;
		mp-&gt;io = 0x2EC;
		mp-&gt;ior32 = portior32;
		mp-&gt;iow32 = portiow32;
		mp-&gt;pci = pcimatch(0, 0x1002, 0);
		if (mp-&gt;pci) {
			if(v = mp-&gt;pci-&gt;mem[1].bar &amp; ~0x3) {
				mp-&gt;io = v;
				mp-&gt;ior32 = pciior32;
				mp-&gt;iow32 = pciiow32;
			}
		}
	}

	mp = vga-&gt;private;
	for(i = 0; i &lt; Nreg; i++)
		mp-&gt;reg[i] = mp-&gt;ior32(mp, i);

	for(i = 0; i &lt; Npll; i++)
		mp-&gt;pll[i] = pllr(mp, i);

	switch(mp-&gt;reg[ConfigChipId] &amp; 0xFFFF){
	default:
		mp-&gt;lcdpanelid = 0;
		break;
	case ('L'&lt;&lt;8)|'B':		/* 4C42: Rage LTPro AGP */
	case ('L'&lt;&lt;8)|'I':		/* 4C49: Rage 3D LTPro */
	case ('L'&lt;&lt;8)|'M':		/* 4C4D: Rage Mobility */
	case ('L'&lt;&lt;8)|'P':		/* 4C50: Rage 3D LTPro */
		for(i = 0; i &lt; Nlcd; i++)
			mp-&gt;lcd[i] = lcdr32(mp, i);
		if(mp-&gt;lcd[LCD_GenCtrl] &amp; 0x02)
			mp-&gt;lcdon = 1;
		mp-&gt;lcdpanelid = ((mp-&gt;reg[ConfigStat2]&gt;&gt;14) &amp; 0x1F);
		break;
	}

	/*
	 * Check which memory size map we are using.
	 */
	mp-&gt;bigmem = 0;
	switch(mp-&gt;reg[ConfigChipId] &amp; 0xFFFF){
		case ('G'&lt;&lt;8)|'B':	/* 4742: 264GT PRO */
		case ('G'&lt;&lt;8)|'D':	/* 4744: 264GT PRO */
		case ('G'&lt;&lt;8)|'I':	/* 4749: 264GT PRO */
		case ('G'&lt;&lt;8)|'M':	/* 474D: Rage XL */
		case ('G'&lt;&lt;8)|'P':	/* 4750: 264GT PRO */
		case ('G'&lt;&lt;8)|'Q':	/* 4751: 264GT PRO */
		case ('G'&lt;&lt;8)|'R':	/* 4752: */
		case ('G'&lt;&lt;8)|'U':	/* 4755: 264GT DVD */
		case ('G'&lt;&lt;8)|'V':	/* 4756: Rage2C */
		case ('G'&lt;&lt;8)|'Z':	/* 475A: Rage2C */
		case ('V'&lt;&lt;8)|'U':	/* 5655: 264VT3 */
		case ('V'&lt;&lt;8)|'V':	/* 5656: 264VT4 */
		case ('L'&lt;&lt;8)|'B':	/* 4C42: Rage LTPro AGP */
		case ('L'&lt;&lt;8)|'I':	/* 4C49: Rage 3D LTPro */
		case ('L'&lt;&lt;8)|'M':	/* 4C4D: Rage Mobility */
		case ('L'&lt;&lt;8)|'P':	/* 4C50: Rage 3D LTPro */
			mp-&gt;bigmem = 1;
			break;
		case ('G'&lt;&lt;8)|'T':	/* 4754: 264GT[B] */
		case ('V'&lt;&lt;8)|'T':	/* 5654: 264VT/GT/VTB */
			/*
			 * Only the VTB and GTB use the new memory encoding,
			 * and they are identified by a nonzero ChipVersion,
			 * apparently.
			 */
			if((mp-&gt;reg[ConfigChipId] &gt;&gt; 24) &amp; 0x7)
				mp-&gt;bigmem = 1;
			break;
	}

	/*
	 * Memory size and aperture. It's recommended
	 * to use an 8Mb aperture on a 16Mb boundary.
	 */
	if(mp-&gt;bigmem)
		vga-&gt;vmz = bigmem[mp-&gt;reg[MemCntl] &amp; 0x0F];
	else
		vga-&gt;vmz = smallmem[mp-&gt;reg[MemCntl] &amp; 0x07];
	vga-&gt;vma = 16*1024*1024;

	switch(mp-&gt;reg[ConfigCntl]&amp;0x3){
	case 0:
		vga-&gt;apz = 16*1024*1024;	/* empirical -rsc */
		break;
	case 1:
		vga-&gt;apz = 4*1024*1024;
		break;
	case 2:
		vga-&gt;apz = 8*1024*1024;
		break;
	case 3:
		vga-&gt;apz = 2*1024*1024;	/* empirical: mach64GX -rsc */
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Foptions;
}

static void
clock(Vga* vga, Ctlr* ctlr)
{
	int clk, m, n, p;
	double f, q;
	Mach64xx *mp;

	mp = vga-&gt;private;

	/*
	 * Don't compute clock timings for LCD panels.
	 * Just use what's already there.  We can't just use
	 * the frequency in the vgadb for this because 
	 * the frequency being programmed into the PLLs
	 * is not the frequency being used to compute the DSP
	 * settings.  The DSP-relevant frequency is the one
	 * we keep in /lib/vgadb.
	 */
	if(mp-&gt;lcdon){
		clk = mp-&gt;reg[ClockCntl] &amp; 0x03;
		n = mp-&gt;pll[7+clk];
		p = (mp-&gt;pll[6]&gt;&gt;(clk*2)) &amp; 0x03;
		p |= (mp-&gt;pll[11]&gt;&gt;(2+clk)) &amp; 0x04;
		switch(p){
		case 0:
		case 1:
		case 2:
		case 3:
			p = 1&lt;&lt;p;
			break;
		case 4+0:
			p = 3;
			break;
		case 4+2:
			p = 6;
			break;
		case 4+3:
			p = 12;
			break;

		default:
		case 4+1:
			p = -1;
			break;
		}
		m = mp-&gt;pll[PLLm];
		f = (2.0*RefFreq*n)/(m*p) + 0.5;

		vga-&gt;m[0] = m;
		vga-&gt;p[0] = p;
		vga-&gt;n[0] = n;
		vga-&gt;f[0] = f;
		return;
	}

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	f = vga-&gt;f[0];

	/*
	 * To generate a specific output frequency, the reference (m),
	 * feedback (n), and post dividers (p) must be loaded with the
	 * appropriate divide-down ratios. In the following r is the
	 * XTALIN frequency (usually RefFreq) and t is the target frequency
	 * (vga-&gt;f).
	 *
	 * Use the maximum reference divider left by the BIOS for now,
	 * otherwise MCLK might be a concern. It can be calculated as
	 * follows:
	 * 			    Upper Limit of PLL Lock Range
	 *	Minimum PLLREFCLK = -----------------------------
	 *				      (2*255)
	 *
	 *				       XTALIN
	 *			m = Floor[-----------------]
	 *				  Minimum PLLREFCLK
	 *
	 * For an upper limit of 135MHz and XTALIN of 14.318MHz m
	 * would be 54.
	 */
	m = mp-&gt;pll[PLLm];
	vga-&gt;m[0] = m;

	/*
	 * The post divider may be 1, 2, 4 or 8 and is determined by
	 * calculating
	 *		 t*m
	 *	    q = -----
	 *		(2*r)
	 * and using the result to look-up p.
	 */
	q = (f*m)/(2*RefFreq);
	if(ctlr-&gt;flag&amp;Uenhanced){
	  if(q &gt; 255 || q &lt; 10.6666666667)
		error("%s: vclk %lud out of range\n", ctlr-&gt;name, vga-&gt;f[0]);
	  if(q &gt; 127.5)
		p = 1;
	  else if(q &gt; 85)
		p = 2;
	  else if(q &gt; 63.75)
		p = 3;
	  else if(q &gt; 42.5)
		p = 4;
	  else if(q &gt; 31.875)
		p = 6;
	  else if(q &gt; 21.25)
		p = 8;
	  else
		p = 12;
	}else{
	  if(q &gt; 255 || q &lt; 16)
		error("%s: vclk %lud out of range\n", ctlr-&gt;name, vga-&gt;f[0]);
	  if(q &gt;= 127.5)
		p = 1;
	  else if(q &gt;= 63.5)
		p = 2;
	  else if(q &gt;= 31.5)
		p = 4;
	  else
		p = 8;
	}
	vga-&gt;p[0] = p;

	/*
	 * The feedback divider should be kept in the range 0x80 to 0xFF
	 * and is found from
	 *	n = q*p
	 * rounded to the nearest whole number.
	 */
	vga-&gt;n[0] = (q*p)+0.5;
}

typedef struct Meminfo	Meminfo;
struct Meminfo {
	int latency;
	int latch;
	int trp;		/* filled in from card */
	int trcd;		/* filled in from card */
	int tcrd;		/* filled in from card */
	int tras;		/* filled in from card */
};

enum {
	Mdram,
	Medo,	
	Msdram,
	Mwram,
};

/*
 * The manuals and documentation are silent on which settings
 * to use for Mwdram, or how to tell which to use.
 */
static Meminfo meminfo[] = {
[Mdram]		{ 1, 0 },
[Medo]		{ 1, 2 },
[Msdram]	{ 3, 1 },
[Mwram]		{ 1, 3 },	/* non TYPE_A */
};

static ushort looplatencytab[2][2] = {
	{ 8, 6 },		/* DRAM: ≤1M, &gt; 1M */
	{ 9, 8 },		/* SDRAM: ≤1M, &gt; 1M */
};

static ushort cyclesperqwordtab[2][2] = {
	{ 3, 2 },		/* DRAM: ≤1M, &gt; 1M */
	{ 2, 1 },		/* SDRAM: ≤1M, &gt; 1M */
};

static int memtype[] = {
	-1,			/* disable memory access */
	Mdram,			/* basic DRAM */
	Medo,			/* EDO */
	Medo,			/* hyper page DRAM or EDO */
	Msdram,			/* SDRAM */
	Msdram,			/* SGRAM */
	Mwram,
	Mwram
};

/*
 * Calculate various memory parameters so that the card
 * fetches the right bytes at the right time.  I don't claim to
 * understand the actual calculations very well.
 *
 * This is remarkably useful on laptops, since knowledge of
 * x lets us find the frequency that the screen is really running
 * at, which is not necessarily in the VCLKs.
 */
static void
setdsp(Vga* vga, Ctlr*)
{
	Mach64xx *mp;
	Meminfo *mem;
	ushort table, memclk, memtyp;
	int i, prec, xprec, fprec;
	ulong t;
	double pw, x, fifosz, fifoon, fifooff;
	ushort dspon, dspoff;
	int afifosz, lat, ncycle, pfc, rcc;

	mp = vga-&gt;private;

	/*
	 * Get video ram configuration from BIOS and chip
	 */
	table = *(ushort*)readbios(sizeof table, 0xc0048);
	trace("rom table offset %uX\n", table);
	table = *(ushort*)readbios(sizeof table, 0xc0000+table+16);
	trace("freq table offset %uX\n", table);
	memclk = *(ushort*)readbios(sizeof memclk, 0xc0000+table+18);
	trace("memclk %ud\n", memclk);
	memtyp = memtype[mp-&gt;reg[ConfigStat0]&amp;07];
	mem = &amp;meminfo[memtyp];

	/*
	 * First we need to calculate x, the number of 
	 * XCLKs that one QWORD occupies in the display FIFO.
	 *
	 * For some reason, x gets stretched out if LCD stretching
	 * is turned on. 
	 */

	x = ((double)memclk*640000.0) /
		((double)vga-&gt;mode-&gt;frequency * (double)vga-&gt;mode-&gt;z);
	if(mp-&gt;lcd[LCD_HorzStretch] &amp; (1&lt;&lt;31))
		x *= 4096.0 / (double)(mp-&gt;lcd[LCD_HorzStretch] &amp; 0xFFFF);

	trace("memclk %d... x %f...", memclk, x);
	/*
	 * We have 14 bits to specify x in.  Decide where to
	 * put the decimal (err, binary) point by counting how
	 * many significant bits are in the integer portion of x.
	 */
	t = x;
	for(i=31; i&gt;=0; i--)
		if(t &amp; (1&lt;&lt;i))
			break;
	xprec = i+1;
	trace("t %lud... xprec %d...", t, xprec);

	/*
	 * The maximum FIFO size is the number of XCLKs per QWORD
	 * multiplied by 32, for some reason.  We have 11 bits to
	 * specify fifosz.
	 */
	fifosz = x * 32.0;
	trace("fifosz %f...", fifosz);
	t = fifosz;
	for(i=31; i&gt;=0; i--)
		if(t &amp; (1&lt;&lt;i))
			break;
	fprec = i+1;
	trace("fprec %d...", fprec);

	/*
	 * Precision is specified as 3 less than the number of bits
	 * in the integer part of x, and 5 less than the number of bits
	 * in the integer part of fifosz.
	 *
	 * It is bounded by zero and seven.
	 */
	prec = (xprec-3 &gt; fprec-5) ? xprec-3 : fprec-5;
	if(prec &lt; 0)
		prec = 0;
	if(prec &gt; 7)
		prec = 7;

	xprec = prec+3;
	fprec = prec+5;
	trace("prec %d...", prec);

	/*
	 * Actual fifo size
	 */
	afifosz = (1&lt;&lt;fprec) / x;
	if(afifosz &gt; 32)
		afifosz = 32;

	fifooff = ceil(x*(afifosz-1));

	/*
	 * I am suspicious of this table, lifted from ATI docs,
	 * because it doesn't agree with the Windows drivers.
	 * We always get 0x0A for lat+2 while Windows uses 0x08.
	 */
	lat = looplatencytab[memtyp &gt; 1][vga-&gt;vmz &gt; 1*1024*1024];
	trace("afifosz %d...fifooff %f...", afifosz, fifooff);

	/*
	 * Page fault clock
	 */
	t = mp-&gt;reg[MemCntl];
	mem-&gt;trp = (t&gt;&gt;8)&amp;3;	/* RAS precharge time */
	mem-&gt;trcd = (t&gt;&gt;10)&amp;3;	/* RAS to CAS delay */
	mem-&gt;tcrd = (t&gt;&gt;12)&amp;1;	/* CAS to RAS delay */
	mem-&gt;tras = (t&gt;&gt;16)&amp;7;	/* RAS low minimum pulse width */
	pfc = mem-&gt;trp + 1 + mem-&gt;trcd + 1 + mem-&gt;tcrd;
	trace("pfc %d...", pfc);

	/*
	 * Maximum random access cycle clock.
	 */
	ncycle = cyclesperqwordtab[memtyp &gt; 1][vga-&gt;vmz &gt; 1*1024*1024];
	rcc = mem-&gt;trp + 1 + mem-&gt;tras + 1;
	if(rcc &lt; pfc+ncycle)
		rcc = pfc+ncycle;
	trace("rcc %d...", rcc);

	fifoon = (rcc &gt; floor(x)) ? rcc : floor(x);
	fifoon += (3.0 * rcc) - 1 + pfc + ncycle;
	trace("fifoon %f...\n", fifoon);
	/*
	 * Now finally put the bits together.
	 * x is stored in a 14 bit field with xprec bits of integer.
	 */
	pw = x * (1&lt;&lt;(14-xprec));
	mp-&gt;reg[DspConfig] = (ulong)pw | (((lat+2)&amp;0xF)&lt;&lt;16) | ((prec&amp;7)&lt;&lt;20);

	/*
	 * These are stored in an 11 bit field with fprec bits of integer.
	 */
	dspon  = (ushort)fifoon &lt;&lt; (11-fprec);
	dspoff = (ushort)fifooff &lt;&lt; (11-fprec);
	mp-&gt;reg[DspOnOff] = ((dspon&amp;0x7ff) &lt;&lt; 16) | (dspoff&amp;0x7ff);
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	Mach64xx *mp;
	int p, x, y;

	mode = vga-&gt;mode;
	if((mode-&gt;x &gt; 640 || mode-&gt;y &gt; 480) &amp;&amp; mode-&gt;z == 1)
		error("%s: no support for 1-bit mode other than 640x480x1\n",
			ctlr-&gt;name);

	mp = vga-&gt;private;
	if(mode-&gt;z &gt; 8 &amp;&amp; mp-&gt;pci == nil)
		error("%s: no support for &gt;8-bit color without PCI\n",
			ctlr-&gt;name);

	/*
	 * Check for Rage chip
	 */
	switch (mp-&gt;reg[ConfigChipId]&amp;0xffff) {
		case ('G'&lt;&lt;8)|'B':	/* 4742: 264GT PRO */
		case ('G'&lt;&lt;8)|'D':	/* 4744: 264GT PRO */
		case ('G'&lt;&lt;8)|'I':	/* 4749: 264GT PRO */
		case ('G'&lt;&lt;8)|'M':	/* 474D: Rage XL */
		case ('G'&lt;&lt;8)|'P':	/* 4750: 264GT PRO */
		case ('G'&lt;&lt;8)|'Q':	/* 4751: 264GT PRO */
		case ('G'&lt;&lt;8)|'R':	/* 4752: */
		case ('G'&lt;&lt;8)|'U':	/* 4755: 264GT DVD */
		case ('G'&lt;&lt;8)|'V':	/* 4756: Rage2C */
		case ('G'&lt;&lt;8)|'Z':	/* 475A: Rage2C */
		case ('V'&lt;&lt;8)|'U':	/* 5655: 264VT3 */
		case ('V'&lt;&lt;8)|'V':	/* 5656: 264VT4 */
		case ('G'&lt;&lt;8)|'T':	/* 4754: 264GT[B] */
		case ('V'&lt;&lt;8)|'T':	/* 5654: 264VT/GT/VTB */
		case ('L'&lt;&lt;8)|'B':	/* 4C42: Rage LTPro AGP */
		case ('L'&lt;&lt;8)|'I':	/* 4C49: 264LT PRO */
		case ('L'&lt;&lt;8)|'M':	/* 4C4D: Rage Mobility */
		case ('L'&lt;&lt;8)|'P':	/* 4C50: 264LT PRO */
			ctlr-&gt;flag |= Uenhanced;
			break;
	}

	/*
	 * Always use VCLK2.
	 */
	clock(vga, ctlr);
	mp-&gt;pll[PLLn2] = vga-&gt;n[0];
	mp-&gt;pll[PLLp] &amp;= ~(0x03&lt;&lt;(2*2));
	switch(vga-&gt;p[0]){
	case 1:
	case 3:
		p = 0;
		break;

	case 2:
		p = 1;
		break;

	case 4:
	case 6:
		p = 2;
		break;

	case 8:
	case 12:
		p = 3;
		break;

	default:
		p = 3;
		break;
	}
	mp-&gt;pll[PLLp] |= p&lt;&lt;(2*2);
	if ((1&lt;&lt;p) != vga-&gt;p[0])
		mp-&gt;pll[PLLx] |= 1&lt;&lt;(4+2);
	else
		mp-&gt;pll[PLLx] &amp;= ~(1&lt;&lt;(4+2));
	mp-&gt;reg[ClockCntl] = 2;

	mp-&gt;reg[ConfigCntl] = 0;

	mp-&gt;reg[CrtcGenCntl] = 0x02000000|(mp-&gt;reg[CrtcGenCntl] &amp; ~0x01400700);
	switch(mode-&gt;z){
	default:
	case 1:
		mp-&gt;reg[CrtcGenCntl] |= 0x00000100;
		mp-&gt;reg[DpPixWidth] = 0x00000000;
		break;
	case 8:
		mp-&gt;reg[CrtcGenCntl] |= 0x01000200;
		mp-&gt;reg[DpPixWidth] = 0x00020202;
		break;
	case 15:
		mp-&gt;reg[CrtcGenCntl] |= 0x01000300;
		mp-&gt;reg[DpPixWidth] = 0x00030303;
		break;
	case 16:
		mp-&gt;reg[CrtcGenCntl] |= 0x01000400;
		mp-&gt;reg[DpPixWidth] = 0x00040404;
		break;
	case 24:
		mp-&gt;reg[CrtcGenCntl] |= 0x01000500;
		mp-&gt;reg[DpPixWidth] = 0x00050505;
		break;
	case 32:
		mp-&gt;reg[CrtcGenCntl] |= 0x01000600;
		mp-&gt;reg[DpPixWidth] = 0x00060606;
		break;
	}

	mp-&gt;reg[HTotalDisp] = (((mode-&gt;x&gt;&gt;3)-1)&lt;&lt;16)|((mode-&gt;ht&gt;&gt;3)-1);
	mp-&gt;reg[HSyncStrtWid] = (((mode-&gt;ehs - mode-&gt;shs)&gt;&gt;3)&lt;&lt;16)
				|((mode-&gt;shs&gt;&gt;3)-1);
	if(mode-&gt;hsync == '-')
		mp-&gt;reg[HSyncStrtWid] |= 0x00200000;
	mp-&gt;reg[VTotalDisp] = ((mode-&gt;y-1)&lt;&lt;16)|(mode-&gt;vt-1);
	mp-&gt;reg[VSyncStrtWid] = ((mode-&gt;vre - mode-&gt;vrs)&lt;&lt;16)|(mode-&gt;vrs-1);
	if(mode-&gt;vsync == '-')
		mp-&gt;reg[VSyncStrtWid] |= 0x00200000;
	mp-&gt;reg[IntCntl] = 0;

	/*
	 * This used to set it to (mode-&gt;x/(8*2))&lt;&lt;22 for depths &lt; 8,
	 * but from the manual that seems wrong to me.  -rsc
	 */
	mp-&gt;reg[OffPitch] = (vga-&gt;virtx/8)&lt;&lt;22;

	mp-&gt;reg[OvrClr] = Pblack;

	if(vga-&gt;linear &amp;&amp; mode-&gt;z != 1)
		ctlr-&gt;flag |= Ulinear;

	/*
	 * Heuristic fiddling on LT PRO.
	 * Do this before setdsp so the stretching is right.
	 */
	if(mp-&gt;lcdon){
		/* use non-shadowed registers */
		mp-&gt;lcd[LCD_GenCtrl] &amp;= ~0x00000404;
		mp-&gt;lcd[LCD_ConfigPanel] |= 0x00004000;

		mp-&gt;lcd[LCD_VertStretch] = 0;
		y = ((mp-&gt;lcd[LCD_ExtVertStretch]&gt;&gt;11) &amp; 0x7FF)+1;
		if(mode-&gt;y &lt; y){
			x = (mode-&gt;y*1024)/y;
			mp-&gt;lcd[LCD_VertStretch] = 0xC0000000|x;
		}
		mp-&gt;lcd[LCD_ExtVertStretch] &amp;= ~0x00400400;

		/*
		 * The x value doesn't seem to be available on all
		 * chips so intuit it from the y value which seems to
		 * be reliable.
		 */
		mp-&gt;lcd[LCD_HorzStretch] &amp;= ~0xC00000FF;
		x = (mp-&gt;lcd[LCD_HorzStretch]&gt;&gt;20) &amp; 0xFF;
		if(x == 0){
			switch(y){
			default:
				break;
			case 480:
				x = 640;
				break;
			case 600:
				x = 800;
				break;
			case 768:
				x = 1024;
				break;
			case 1024:
				x = 1280;
				break;
			}
		}
		else
			x = (x+1)*8;
		if(mode-&gt;x &lt; x){
			x = (mode-&gt;x*4096)/x;
			mp-&gt;lcd[LCD_HorzStretch] |= 0xC0000000|x;
		}
	}

	if(ctlr-&gt;flag&amp;Uenhanced)
		setdsp(vga, ctlr);

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	Mach64xx *mp;
	int i;

	mp = vga-&gt;private;

	/*
	 * Unlock the CRTC and LCD registers.
	 */
	mp-&gt;iow32(mp, CrtcGenCntl, mp-&gt;ior32(mp, CrtcGenCntl)&amp;~0x00400000);
	if(mp-&gt;lcdon)
		lcdw32(mp, LCD_GenCtrl, mp-&gt;lcd[LCD_GenCtrl]|0x80000000);

	/*
	 * Always use an aperture on a 16Mb boundary.
	 */
	if(ctlr-&gt;flag &amp; Ulinear)
		mp-&gt;reg[ConfigCntl] = ((vga-&gt;vmb/(4*1024*1024))&lt;&lt;4)|0x02;

	mp-&gt;iow32(mp, ConfigCntl, mp-&gt;reg[ConfigCntl]);

	mp-&gt;iow32(mp, GenTestCntl, 0);
	mp-&gt;iow32(mp, GenTestCntl, 0x100);

	if((ctlr-&gt;flag&amp;Uenhanced) == 0)
	  mp-&gt;iow32(mp, MemCntl, mp-&gt;reg[MemCntl] &amp; ~0x70000);
	mp-&gt;iow32(mp, BusCntl, mp-&gt;reg[BusCntl]);
	mp-&gt;iow32(mp, HTotalDisp, mp-&gt;reg[HTotalDisp]);
	mp-&gt;iow32(mp, HSyncStrtWid, mp-&gt;reg[HSyncStrtWid]);
	mp-&gt;iow32(mp, VTotalDisp, mp-&gt;reg[VTotalDisp]);
	mp-&gt;iow32(mp, VSyncStrtWid, mp-&gt;reg[VSyncStrtWid]);
	mp-&gt;iow32(mp, IntCntl, mp-&gt;reg[IntCntl]);
	mp-&gt;iow32(mp, OffPitch, mp-&gt;reg[OffPitch]);
	if(mp-&gt;lcdon){
		for(i=0; i&lt;Nlcd; i++)
			lcdw32(mp, i, mp-&gt;lcd[i]);
	}

	mp-&gt;iow32(mp, GenTestCntl, mp-&gt;reg[GenTestCntl]);
	mp-&gt;iow32(mp, ConfigCntl, mp-&gt;reg[ConfigCntl]);
	mp-&gt;iow32(mp, CrtcGenCntl, mp-&gt;reg[CrtcGenCntl]);
	mp-&gt;iow32(mp, OvrClr, mp-&gt;reg[OvrClr]);
	mp-&gt;iow32(mp, OvrWidLR, mp-&gt;reg[OvrWidLR]);
	mp-&gt;iow32(mp, OvrWidTB, mp-&gt;reg[OvrWidTB]);
	if(ctlr-&gt;flag&amp;Uenhanced){
	  mp-&gt;iow32(mp, DacRegs, mp-&gt;reg[DacRegs]);
	  mp-&gt;iow32(mp, DacCntl, mp-&gt;reg[DacCntl]);
	  mp-&gt;iow32(mp, CrtcGenCntl, mp-&gt;reg[CrtcGenCntl]&amp;~0x02000000);
	  mp-&gt;iow32(mp, DspOnOff, mp-&gt;reg[DspOnOff]);
	  mp-&gt;iow32(mp, DspConfig, mp-&gt;reg[DspConfig]);
	  mp-&gt;iow32(mp, CrtcGenCntl, mp-&gt;reg[CrtcGenCntl]);
	  pllw(mp, PLLx, mp-&gt;pll[PLLx]);
	}
	pllw(mp, PLLn2, mp-&gt;pll[PLLn2]);
	pllw(mp, PLLp, mp-&gt;pll[PLLp]);
	pllw(mp, PLLn3, mp-&gt;pll[PLLn3]);

	mp-&gt;iow32(mp, ClockCntl, mp-&gt;reg[ClockCntl]);
	mp-&gt;iow32(mp, ClockCntl, 0x40|mp-&gt;reg[ClockCntl]);

	mp-&gt;iow32(mp, DpPixWidth, mp-&gt;reg[DpPixWidth]);

	if(vga-&gt;mode-&gt;z &gt; 8){
		int sh, i;
		/*
		 * We need to initialize the palette, since the DACs use it
		 * in true color modes.  First see if the card supports an
		 * 8-bit DAC.
		 */
		mp-&gt;iow32(mp, DacCntl, mp-&gt;reg[DacCntl] | 0x100);
		if(mp-&gt;ior32(mp, DacCntl)&amp;0x100){
			/* card appears to support it */
			vgactlw("palettedepth", "8");
			mp-&gt;reg[DacCntl] |= 0x100;
		}

		if(mp-&gt;reg[DacCntl] &amp; 0x100)
			sh = 0;	/* 8-bit DAC */
		else
			sh = 2;	/* 6-bit DAC */

		for(i=0; i&lt;256; i++)
			setpalette(i, i&gt;&gt;sh, i&gt;&gt;sh, i&gt;&gt;sh);
	}

	ctlr-&gt;flag |= Fload;
}

static void
pixelclock(Vga* vga, Ctlr* ctlr)
{
	Mach64xx *mp;
	ushort table, s;
	int memclk, ref_freq, ref_divider, min_freq, max_freq;
	int feedback, nmult, pd, post, value;
	int clock;

	/*
	 * Find the pixel clock from the BIOS and current
	 * settings. Lifted from the ATI-supplied example code.
	 * The clocks stored in the BIOS table are in kHz/10.
	 *
	 * This is the clock LCDs use in vgadb to set the DSP
	 * values.
	 */
	mp = vga-&gt;private;

	/*
	 * GetPLLInfo()
	 */
	table = *(ushort*)readbios(sizeof table, 0xc0048);
	trace("rom table offset %uX\n", table);
	table = *(ushort*)readbios(sizeof table, 0xc0000+table+16);
	trace("freq table offset %uX\n", table);
	s = *(ushort*)readbios(sizeof s, 0xc0000+table+18);
	memclk = s*10000;
	trace("memclk %ud\n", memclk);
	s = *(ushort*)readbios(sizeof s, 0xc0000+table+8);
	ref_freq = s*10000;
	trace("ref_freq %ud\n", ref_freq);
	s = *(ushort*)readbios(sizeof s, 0xc0000+table+10);
	ref_divider = s;
	trace("ref_divider %ud\n", ref_divider);
	s = *(ushort*)readbios(sizeof s, 0xc0000+table+2);
	min_freq = s*10000;
	trace("min_freq %ud\n", min_freq);
	s = *(ushort*)readbios(sizeof s, 0xc0000+table+4);
	max_freq = s*10000;
	trace("max_freq %ud\n", max_freq);

	/*
	 * GetDivider()
	 */
	pd = mp-&gt;pll[PLLp] &amp; 0x03;
	value = (mp-&gt;pll[PLLx] &amp; 0x10)&gt;&gt;2;
	trace("pd %uX value %uX (|%d)\n", pd, value, value|pd);
	value |= pd;
	post = 0;
	switch(value){
	case 0:
		post = 1;
		break;
	case 1:
		post = 2;
		break;
	case 2:
		post = 4;
		break;
	case 3:
		post = 8;
		break;
	case 4:
		post = 3;
		break;
	case 5:
		post = 0;
		break;
	case 6:
		post = 6;
		break;
	case 7:
		post = 12;
		break;
	}
	trace("post = %d\n", post);

	feedback = mp-&gt;pll[PLLn0];
	if(mp-&gt;pll[PLLx] &amp; 0x08)
		nmult = 4;
	else
		nmult = 2;

	clock = (ref_freq/10000)*nmult*feedback;
	clock /= ref_divider*post;
	clock *= 10000;

	Bprint(&amp;stdout, "%s pixel clock = %ud\n", ctlr-&gt;name, clock);
}

static void dumpmach64bios(Mach64xx*);

static void
dump(Vga* vga, Ctlr* ctlr)
{
	Mach64xx *mp;
	int i, m, n, p;
	double f;
	static int first = 1;

	if((mp = vga-&gt;private) == 0)
		return;

	Bprint(&amp;stdout, "%s pci %p io %lux %s\n", ctlr-&gt;name,
		mp-&gt;pci, mp-&gt;io, mp-&gt;ior32 == pciior32 ? "pciregs" : "ioregs");
	if(mp-&gt;pci)
		Bprint(&amp;stdout, "%s ccru %ux\n", ctlr-&gt;name, mp-&gt;pci-&gt;ccru);
	for(i = 0; i &lt; Nreg; i++)
		Bprint(&amp;stdout, "%s %-*s%.8luX\n",
			ctlr-&gt;name, 20, iorname[i], mp-&gt;reg[i]);

	printitem(ctlr-&gt;name, "PLL");
	for(i = 0; i &lt; Npll; i++)
		printreg(mp-&gt;pll[i]);
	Bprint(&amp;stdout, "\n");

	switch(mp-&gt;reg[ConfigChipId] &amp; 0xFFFF){
	default:
		break;
	case ('L'&lt;&lt;8)|'B':		/* 4C42: Rage LTPro AGP */
	case ('L'&lt;&lt;8)|'I':		/* 4C49: Rage 3D LTPro */
	case ('L'&lt;&lt;8)|'M':		/* 4C4D: Rage Mobility */
	case ('L'&lt;&lt;8)|'P':		/* 4C50: Rage 3D LTPro */
		for(i = 0; i &lt; Nlcd; i++)
			Bprint(&amp;stdout, "%s %-*s%.8luX\n",
				ctlr-&gt;name, 20, lcdname[i], mp-&gt;lcd[i]);
		break;
	}

	/*
	 *     (2*r*n)
	 * f = -------
	 *	(m*p)
	 */
	m = mp-&gt;pll[2];
	for(i = 0; i &lt; 4; i++){
		n = mp-&gt;pll[7+i];
		p = (mp-&gt;pll[6]&gt;&gt;(i*2)) &amp; 0x03;
		p |= (mp-&gt;pll[11]&gt;&gt;(2+i)) &amp; 0x04;
		switch(p){
		case 0:
		case 1:
		case 2:
		case 3:
			p = 1&lt;&lt;p;
			break;
		case 4+0:
			p = 3;
			break;
		case 4+2:
			p = 6;
			break;
		case 4+3:
			p = 12;
			break;

		default:
		case 4+1:
			p = -1;
			break;
		}
		if(m*p == 0)
			Bprint(&amp;stdout, "unknown VCLK%d\n", i);
		else {
			f = (2.0*RefFreq*n)/(m*p) + 0.5;
			Bprint(&amp;stdout, "%s VCLK%d\t%ud\n", ctlr-&gt;name, i, (int)f);
		}
	}

	pixelclock(vga, ctlr);

	if(first) {
		first = 0;
		dumpmach64bios(mp);
	}
}

enum {
	ClockFixed=0,
	ClockIcs2595,
	ClockStg1703,
	ClockCh8398,
	ClockInternal,
	ClockAtt20c408,
	ClockIbmrgb514
};

/*
 * mostly derived from the xfree86 probe routines.
 */
static void 
dumpmach64bios(Mach64xx *mp)
{
	int i, romtable, clocktable, freqtable, lcdtable, lcdpanel;
	uchar bios[0x10000];

	memmove(bios, readbios(sizeof bios, 0xC0000), sizeof bios);

	/* find magic string */
	for(i=0; i&lt;1024; i++)
		if(strncmp((char*)bios+i, " 761295520", 10) == 0)
			break;

	if(i==1024) {
		Bprint(&amp;stdout, "no ATI bios found\n");
		return;
	}

	/* this is horribly endian dependent.  sorry. */
	romtable = *(ushort*)(bios+0x48);
	if(romtable+0x12 &gt; sizeof(bios)) {
		Bprint(&amp;stdout, "couldn't find ATI rom table\n");
		return;
	}

	clocktable = *(ushort*)(bios+romtable+0x10);
	if(clocktable+0x0C &gt; sizeof(bios)) {
		Bprint(&amp;stdout, "couldn't find ATI clock table\n");
		return;
	}

	freqtable = *(ushort*)(bios+clocktable-2);
	if(freqtable+0x20 &gt; sizeof(bios)) {
		Bprint(&amp;stdout, "couldn't find ATI frequency table\n");
		return;
	}

	Bprint(&amp;stdout, "ATI BIOS rom 0x%x freq 0x%x clock 0x%x\n", romtable, freqtable, clocktable);
	Bprint(&amp;stdout, "clocks:");
	for(i=0; i&lt;16; i++)
		Bprint(&amp;stdout, " %d", *(ushort*)(bios+freqtable+2*i));
	Bprint(&amp;stdout, "\n");

	Bprint(&amp;stdout, "programmable clock: %d\n", bios[clocktable]);
	Bprint(&amp;stdout, "clock to program: %d\n", bios[clocktable+6]);

	if(*(ushort*)(bios+clocktable+8) != 1430) {
		Bprint(&amp;stdout, "reference numerator: %d\n", *(ushort*)(bios+clocktable+8)*10);
		Bprint(&amp;stdout, "reference denominator: 1\n");
	} else {
		Bprint(&amp;stdout, "default reference numerator: 157500\n");
		Bprint(&amp;stdout, "default reference denominator: 11\n");
	}

	switch(bios[clocktable]) {
	case ClockIcs2595:
		Bprint(&amp;stdout, "ics2595\n");
		Bprint(&amp;stdout, "reference divider: %d\n", *(ushort*)(bios+clocktable+0x0A));
		break;
	case ClockStg1703:
		Bprint(&amp;stdout, "stg1703\n");
		break;
	case ClockCh8398:
		Bprint(&amp;stdout, "ch8398\n");
		break;
	case ClockInternal:
		Bprint(&amp;stdout, "internal clock\n");
		Bprint(&amp;stdout, "reference divider in plls\n");
		break;
	case ClockAtt20c408:
		Bprint(&amp;stdout, "att 20c408\n");
		break;
	case ClockIbmrgb514:
		Bprint(&amp;stdout, "ibm rgb514\n");
		Bprint(&amp;stdout, "clock to program = 7\n");
		break;
	default:
		Bprint(&amp;stdout, "unknown clock\n");
		break;
	}

	USED(mp);
	if(1 || mp-&gt;lcdpanelid) {
		lcdtable = *(ushort*)(bios+0x78);
		if(lcdtable+5 &gt; sizeof bios || lcdtable+bios[lcdtable+5] &gt; sizeof bios) {
			Bprint(&amp;stdout, "can't find lcd bios table\n");
			goto NoLcd;
		}

		lcdpanel = *(ushort*)(bios+lcdtable+0x0A);
		if(lcdpanel+0x1D &gt; sizeof bios /*|| bios[lcdpanel] != mp-&gt;lcdpanelid*/) {
			Bprint(&amp;stdout, "can't find lcd bios table0\n");
			goto NoLcd;
		}

		Bprint(&amp;stdout, "panelid %d x %d y %d\n", bios[lcdpanel], *(ushort*)(bios+lcdpanel+0x19), *(ushort*)(bios+lcdpanel+0x1B));
	}
NoLcd:;
}

Ctlr mach64xx = {
	"mach64xx",			/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr mach64xxhwgc = {
	"mach64xxhwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};


<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

