<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/mga4xx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/mga4xx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Philippe Anel &lt;philippe.anel@noos.fr&gt; 
	- 2001-08-12 : First release.
	- 2001-08-15 : Added G450, with source code "adapted from" from Xfree86 4.1.0
	- 2001-08-23 : Added 'palettedepth 8' and a few 'ultradebug' ...
	- 2001-08-24 : Removed a possible lock in initialization.
	- 2001-08-30 : Hey ! The 32 bits mode is PALETIZED (Gamma Control I presume) !
				  And it seems plan9 assume the frame buffer is organized in
				  Big Endian format ! (+ Fix for the palette init. )
	- 2001-09-06 : Added Full 2D Accel ! (see drivers in /sys/src/9/pc)
	- 2001-10-01 : Rid Fix.
	- 2006-04-01 : Add MGA550 support.
	- 2006-08-07 : Add support for 16 and 24bits modes.
				HW accel now works for the G200 cards too (see kernel).
				by Leonardo Valencia &lt;leoval@anixcorp.com&gt;

     Greets and Acknowledgements go to :
     	- Sylvain Chipaux &lt;a.k.a. asle&gt;.
	- Nigel Roles.
	- Jean Mehat (the man who introduced me into the world of plan9).
	- Nicolas Stojanovic.
		... and for those who wrote plan9 of course ... :)
*/	

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

static int	 ultradebug = 0;

/*
 * Matrox G4xx 3D graphics accelerators
 */
enum {
	Kilo			= 1024,
	Meg			= 1024*1024,
	
	MATROX			= 0x102B,	/* pci chip manufacturer */
	MGA550			= 0x2527, /* pci chip device ids */
	MGA4XX			= 0x0525,
	MGA200			= 0x0521,

	/* Pci configuration space mapping */
	PCfgMgaFBAA		= 0x10,		/* Frame buffer Aperture Address */
	PCfgMgaCAA		= 0x14,		/* Control Aperture Address base */
	PCfgMgaIAA		= 0x18,		/* ILOAD Aperture base Address */
	PCfgMgaOption1		= 0x40,		/* Option Register 1 */
	PCfgMgaOption2		= 0x50,		/* Option Register 2 */
	PCfgMgaOption3		= 0x54,		/* Option Register 3 */
	PCfgMgaDevCtrl		= 0x04,		/* Device Control */

	/* control aperture offsets */
	DMAWIN			= 0x0000,	/* 7KByte Pseudo-DMA Window */

	STATUS0			= 0x1FC2,	/* Input Status 0 */
	STATUS1			= 0x1FDA,	/* Input Status 1 */
	
	SEQIDX			= 0x1FC4,	/* Sequencer Index */
	SEQDATA			= 0x1FC5,	/* Sequencer Data */

	MISC_W			= 0x1FC2,	/* Misc. WO */
	MISC_R			= 0x1FCC,	/* Misc. RO */

	GCTLIDX			= 0x1FCE,	/* Graphic Controler Index */
	GCTLDATA		= 0x1FCF,	/* Graphic Controler Data */

	CRTCIDX			= 0x1FD4,	/* CRTC Index */
	CRTCDATA		= 0x1FD5,	/* CRTC Data */

	CRTCEXTIDX		= 0x1FDE,	/* CRTC Extension Index */
	CRTCEXTDATA		= 0x1FDF,	/* CRTC Extension Data */
	
	RAMDACIDX		= 0x3C00,	/* RAMDAC registers Index */
	RAMDACDATA		= 0x3C0A,	/* RAMDAC Indexed Data */
	RAMDACPALDATA		= 0x3C01,

	ATTRIDX			= 0x1FC0,	/* Attribute Index */
	ATTRDATA		= 0x1FC1,	/* Attribute Data */

	CACHEFLUSH		= 0x1FFF,

	C2_CTL			= 0X3C10,
	MGA_STATUS		= 0X1E14,
	Z_DEPTH_ORG		= 0X1C0C,
	
 	/* ... */
	Seq_ClockingMode =	0x01,
		Dotmode =		(1&lt;&lt;0),
		Shftldrt =		(1&lt;&lt;2),
		Dotclkrt =		(1&lt;&lt;3),
		Shiftfour =		(1&lt;&lt;4),
		Scroff =		(1&lt;&lt;5),

	CrtcExt_Horizontcount =	0x01,
		Htotal =		(1&lt;&lt;0),
		Hblkstr =		(1&lt;&lt;1),
		Hsyncstr =		(1&lt;&lt;2),
		Hrsten =		(1&lt;&lt;3),
		Hsyncoff =		(1&lt;&lt;4),
		Vsyncoff =		(1&lt;&lt;5),
		Hblkend =		(1&lt;&lt;6),
		Vrsten =		(1&lt;&lt;7),

	CrtcExt_Miscellaneous =	0x03,
		Mgamode =		(1&lt;&lt;7),

	Dac_Xpixclkctrl =	0x1a,
		Pixclksl = 		(3&lt;&lt;0),
		Pixclkdis =		(1&lt;&lt;2),
		Pixpllpdn =		(1&lt;&lt;3),

	Dac_Xpixpllstat =	0x4f,
		Pixlock = 		(1&lt;&lt;6),
	
	Dac_Xpixpllan =		0x45,
	Dac_Xpixpllbn =		0x49,
	Dac_Xpixpllcn  =	0x4d,

	Dac_Xpixpllam =		0x44, 
	Dac_Xpixpllbm =		0x48,
	Dac_Xpixpllcm =		0x4c,

	Dac_Xpixpllap =		0x46,
	Dac_Xpixpllbp =		0x4a,
	Dac_Xpixpllcp =		0x4e,

	Dac_Xmulctrl =		0x19,
		ColorDepth =		(7&lt;&lt;0),
			_8bitsPerPixel = 		0,
			_15bitsPerPixel =		1,
			_16bitsPerPixel =		2,
			_24bitsPerPixel =		3,
			_32bitsPerPixelWithOv = 	4,
			_32bitsPerPixel	=		7,

	Dac_Xpanelmode =	0x1f,

	Dac_Xmiscctrl =		0x1e,
		Dacpdn =		(1&lt;&lt;0),
		Mfcsel =		(3&lt;&lt;1),
		Vga8dac =		(1&lt;&lt;3),
		Ramcs =			(1&lt;&lt;4),
		Vdoutsel =		(7&lt;&lt;5),

	Dac_Xcurctrl =		0x06,
		CursorDis = 		0,
		Cursor3Color = 		1,
		CursorXGA = 		2,
		CursorX11 = 		3,
		Cursor16Color = 	4,

	Dac_Xzoomctrl =		0x38,

	Misc_loaddsel =			(1&lt;&lt;0),
	Misc_rammapen =			(1&lt;&lt;1),
	Misc_clksel =			(3&lt;&lt;2),
	Misc_videodis =			(1&lt;&lt;4),
	Misc_hpgoddev = 		(1&lt;&lt;5),
	Misc_hsyncpol =			(1&lt;&lt;6),
	Misc_vsyncpol =			(1&lt;&lt;7),

	MNP_TABLE_SIZE =	64,

	TRUE = 	(1 == 1),
	FALSE = (1 == 0),
};

typedef struct {
	Pcidev*	pci;
	int	devid;
	int	revid;
	
	uchar*	mmio;
	uchar*	mmfb;
	int	fbsize;
	ulong	iload;

	uchar	syspll_m;
	uchar	syspll_n;
	uchar	syspll_p;
	uchar	syspll_s;

	uchar	pixpll_m;
	uchar	pixpll_n;
	uchar	pixpll_p;
	uchar	pixpll_s;

	ulong	option1;
	ulong	option2;
	ulong	option3;

	ulong	Fneeded;

	/* From plan9.ini ... later */
	uchar	sdram;
	uchar	colorkey;
	uchar	maskkey;
	ulong	maxpclk;

	uchar	graphics[9];	
	uchar	attribute[0x14];	
	uchar	sequencer[5];
	uchar	crtc[0x19];
	uchar	crtcext[9];

	ulong	htotal;
	ulong	hdispend;
	ulong	hblkstr;
	ulong	hblkend;
	ulong	hsyncstr;
	ulong	hsyncend;
	ulong	vtotal;
	ulong	vdispend;
	ulong	vblkstr;
	ulong	vblkend;
	ulong	vsyncstr;
	ulong	vsyncend;
	ulong	linecomp;
	ulong	hsyncsel;
	ulong	startadd;
	ulong	offset;
	ulong	maxscan;
	ulong 	curloc;
	ulong	prowscan;
	ulong	currowstr;
	ulong	currowend;
	ulong	curoff;
	ulong	undrow;
	ulong	curskew;
	ulong	conv2t4;
	ulong	interlace;
	ulong	hsyncdel;
	ulong	hdispskew;
	ulong	bytepan;
	ulong	dotclkrt;
	ulong	dword;
	ulong	wbmode;
	ulong	addwrap;
	ulong	selrowscan;
	ulong	cms;
	ulong	csynccen;
	ulong	hrsten;
	ulong	vrsten;
	ulong	vinten;
	ulong	vintclr;
	ulong	hsyncoff;
	ulong	vsyncoff;
	ulong	crtcrstN;
	ulong	mgamode;
	ulong	scale;
	ulong	hiprilvl;
	ulong	maxhipri;
	ulong	c2hiprilvl;
	ulong	c2maxhipri;
	ulong	misc;
	ulong	crtcprotect;
	ulong	winsize;
	ulong	winfreq;
	
	ulong	mgaapsize;
} Mga;

static void
mgawrite32(Mga* mga, int index, ulong val)
{
	((ulong*)mga-&gt;mmio)[index] = val;
}

static ulong
mgaread32(Mga* mga, int index)
{
	return ((ulong*)mga-&gt;mmio)[index];
}

static void
mgawrite8(Mga* mga, int index, uchar val)
{
	mga-&gt;mmio[index] = val;
}

static uchar
mgaread8(Mga* mga, int index)
{
	return mga-&gt;mmio[index];
}

static uchar
seqget(Mga* mga, int index)
{
	mgawrite8(mga, SEQIDX, index);
	return mgaread8(mga, SEQDATA);
}

static uchar
seqset(Mga* mga, int index, uchar set, uchar clr)
{
	uchar	tmp;

	mgawrite8(mga, SEQIDX, index);
	tmp = mgaread8(mga, SEQDATA);
	mgawrite8(mga, SEQIDX, index);
	mgawrite8(mga, SEQDATA, (tmp &amp; ~clr) | set);
	return tmp;
}

static uchar
crtcget(Mga* mga, int index)
{
	mgawrite8(mga, CRTCIDX, index);
	return mgaread8(mga, CRTCDATA);
}

static uchar
crtcset(Mga* mga, int index, uchar set, uchar clr)
{
	uchar	tmp;

	mgawrite8(mga, CRTCIDX, index);
	tmp = mgaread8(mga, CRTCDATA);
	mgawrite8(mga, CRTCIDX, index);
	mgawrite8(mga, CRTCDATA, (tmp &amp; ~clr) | set);
	return tmp;
}

static uchar
crtcextget(Mga* mga, int index)
{
	mgawrite8(mga, CRTCEXTIDX, index);
	return mgaread8(mga, CRTCEXTDATA);
}

static uchar
crtcextset(Mga* mga, int index, uchar set, uchar clr)
{
	uchar	tmp;

	mgawrite8(mga, CRTCEXTIDX, index);
	tmp = mgaread8(mga, CRTCEXTDATA);
	mgawrite8(mga, CRTCEXTIDX, index);
	mgawrite8(mga, CRTCEXTDATA, (tmp &amp; ~clr) | set);
	return tmp;
}

static uchar
dacget(Mga* mga, int index)
{
	mgawrite8(mga, RAMDACIDX, index);
	return mgaread8(mga, RAMDACDATA);
}

static uchar
dacset(Mga* mga, int index, uchar set, uchar clr)
{
	uchar	tmp;

	mgawrite8(mga, RAMDACIDX, index);
	tmp = mgaread8(mga, RAMDACDATA);
	mgawrite8(mga, RAMDACIDX, index);
	mgawrite8(mga, RAMDACDATA, (tmp &amp; ~clr) | set);
	return	tmp;
}

static uchar
gctlget(Mga* mga, int index)
{
	mgawrite8(mga, GCTLIDX, index);
	return mgaread8(mga, GCTLDATA);
}

static uchar
gctlset(Mga* mga, int index, uchar set, uchar clr)
{
	uchar	tmp;

	mgawrite8(mga, GCTLIDX, index);
	tmp = mgaread8(mga, GCTLDATA);
	mgawrite8(mga, GCTLIDX, index);
	mgawrite8(mga, GCTLDATA, (tmp &amp; ~clr) | set);
	return	tmp;
}

static uchar
attrget(Mga* mga, int index)
{
	mgawrite8(mga, ATTRIDX, index);
	return mgaread8(mga, ATTRDATA);
}

static uchar
attrset(Mga* mga, int index, uchar set, uchar clr)
{
	uchar	tmp;

	mgawrite8(mga, ATTRIDX, index);
	tmp = mgaread8(mga, ATTRDATA);
	mgawrite8(mga, ATTRIDX, index);
	mgawrite8(mga, ATTRDATA, (tmp &amp; ~clr) | set);
	return	tmp;
}

static uchar
miscget(Mga* mga)
{
	return mgaread8(mga, MISC_R);
}

static uchar
miscset(Mga* mga, uchar set, uchar clr)
{
	uchar	tmp;

	tmp = mgaread8(mga, MISC_R);
	mgawrite8(mga, MISC_W, (tmp &amp; ~clr) | set);
	return	tmp;
}

/* ************************************************************ */

static void
dump_all_regs(Mga* mga)
{
	int	i;

	for (i = 0; i &lt; 25; i++)
		trace("crtc[%d] = 0x%x\n", i, crtcget(mga, i));
	for (i = 0; i &lt; 9; i++)
		trace("crtcext[%d] = 0x%x\n", i, crtcextget(mga, i));
	for (i = 0; i &lt; 5; i++)
		trace("seq[%d] = 0x%x\n", i, seqget(mga, i));
	for (i = 0; i &lt; 9; i++)
		trace("gctl[%d] = 0x%x\n", i, gctlget(mga, i));
	trace("misc = 0x%x\n", mgaread8(mga, MISC_R));
	for (i = 0; i &lt; 0x87; i++)
		trace("dac[%d] = 0x%x\n", i, dacget(mga, i));
}

/* ************************************************************ */

static void
dump(Vga* vga, Ctlr* ctlr)
{
	dump_all_regs(vga-&gt;private);
	ctlr-&gt;flag |= Fdump;
}

static void
setpalettedepth(int depth)
{
	int	fd;
	char *cmd = strdup("palettedepth X");

	if ((depth != 8) &amp;&amp; (depth != 6) &amp;&amp; (depth != 16))
		error("mga: invalid palette depth %d\n", depth);

	fd = open("#v/vgactl", OWRITE);
	if(fd &lt; 0)
		error("mga: can't open vgactl\n");

	cmd[13] = '0' + depth;
	if(write(fd, cmd, 14) != 14)
		error("mga: can't set palette depth to %d\n", depth);

	close(fd);
}

static void
mapmga4xx(Vga* vga, Ctlr* ctlr)
{
	int 	f;
	uchar* 	m;
	Mga *	mga;

	if(vga-&gt;private == nil)
		error("%s: g4xxio: no *mga4xx\n", ctlr-&gt;name);
	mga = vga-&gt;private;

	f = open("#v/vgactl", OWRITE);
	if(f &lt; 0)
		error("%s: can't open vgactl\n", ctlr-&gt;name);

	if(write(f, "type mga4xx", 11) != 11)
		error("%s: can't set mga type\n", ctlr-&gt;name);
	
	m = segattach(0, "mga4xxmmio", 0, 16*Kilo);
	if(m == (void*)-1)
		error("%s: can't attach mga4xxmmio segment\n", ctlr-&gt;name);
	mga-&gt;mmio = m;
	trace("%s: mmio at %#p\n", ctlr-&gt;name, mga-&gt;mmio);

	m = segattach(0, "mga4xxscreen", 0, 32*Meg);
	if(m == (void*)-1) {
		mga-&gt;mgaapsize = 8*Meg;
		m = segattach(0, "mga4xxscreen", 0, 8*Meg);
		if(m == (void*)-1)
			error("%s: can't attach mga4xxscreen segment\n", ctlr-&gt;name);
	} else {
		mga-&gt;mgaapsize = 32*Meg;
	}
	mga-&gt;mmfb = m;
	trace("%s: frame buffer at %#p\n", ctlr-&gt;name, mga-&gt;mmfb);

	close(f);
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int 	i, k, n;
	uchar *	p;
	uchar	x[16];
	Pcidev *	pci;
	Mga *	mga;
	uchar	crtcext3;
	uchar	rid;

	trace("%s-&gt;snarf\n", ctlr-&gt;name);
	if(vga-&gt;private == nil) {
		pci = pcimatch(nil, MATROX, MGA4XX);
		if(pci == nil)
			pci = pcimatch(nil, MATROX, MGA550);
		if(pci == nil)
			pci = pcimatch(nil, MATROX, MGA200);
		if(pci == nil)
			error("%s: cannot find matrox adapter\n", ctlr-&gt;name);

		rid = pcicfgr8(pci, PciRID); // PciRID = 0x08

		trace("%s: G%d%d0 rev %d\n", ctlr-&gt;name, 
			2*(pci-&gt;did==MGA200)
			+4*(pci-&gt;did==MGA4XX)
			+5*(pci-&gt;did==MGA550),
			rid&amp;0x80 ? 5 : 0,
			rid&amp;~0x80);
		i = pcicfgr32(pci, PCfgMgaDevCtrl);
		if ((i &amp; 2) != 2)
			error("%s: Memory Space not enabled ... Aborting ...\n", ctlr-&gt;name);	

		vga-&gt;private = alloc(sizeof(Mga));
		mga = (Mga*)vga-&gt;private;
		mga-&gt;devid = 	pci-&gt;did;
		mga-&gt;revid =	rid;	
		mga-&gt;pci = 	pci;

		mapmga4xx(vga, ctlr);
	}
	else {
		mga = (Mga*)vga-&gt;private;
	}

	/* Find out how much memory is here, some multiple of 2Meg */

	/* First Set MGA Mode ... */
	crtcext3 = crtcextset(mga, 3, 0x80, 0x00);

	p = mga-&gt;mmfb;
	n = (mga-&gt;mgaapsize / Meg) / 2;
	for (i = 0; i &lt; n; i++) {
		k = (2*i+1)*Meg;
		p[k] = 0;
		p[k] = i+1;
		*(mga-&gt;mmio + CACHEFLUSH) = 0;
		x[i] = p[k];
		trace("x[%d]=%d\n", i, x[i]);
	}
	for(i = 1; i &lt; n; i++)
		if(x[i] != i+1)
			break;
	vga-&gt;vmz = mga-&gt;fbsize = 2*i*Meg;
	trace("probe found %d megabytes\n", 2*i);

	crtcextset(mga, 3, crtcext3, 0xff);

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga* vga, Ctlr* ctlr)
{
	if(vga-&gt;virtx &amp; 127)
		vga-&gt;virtx = (vga-&gt;virtx+127)&amp;~127;
	ctlr-&gt;flag |= Foptions;
}

/* ************************************************************ */

static void 
G450ApplyPFactor(Mga*, uchar ucP, ulong *pulFIn)
{
	if(!(ucP &amp; 0x40))
	{
		*pulFIn = *pulFIn / (2L &lt;&lt; (ucP &amp; 3));
	}
}


static void 
G450RemovePFactor(Mga*, uchar ucP, ulong *pulFIn)
{
	if(!(ucP &amp; 0x40))
	{
		*pulFIn = *pulFIn * (2L &lt;&lt; (ucP &amp; 3));
	}
}

static void 
G450CalculVCO(Mga*, ulong ulMNP, ulong *pulF)
{
	uchar ucM, ucN;

	ucM = (uchar)((ulMNP &gt;&gt; 16) &amp; 0xff);
	ucN = (uchar)((ulMNP &gt;&gt;  8) &amp; 0xff);

	*pulF = (27000 * (2 * (ucN + 2)) + ((ucM + 1) &gt;&gt; 1)) / (ucM + 1);
	trace("G450CalculVCO: ulMNP %lx, pulF %ld\n", ulMNP, *pulF);
}


static void 
G450CalculDeltaFreq(Mga*, ulong ulF1, ulong ulF2, ulong *pulDelta)
{
	if(ulF2 &lt; ulF1)
	{
		*pulDelta = ((ulF1 - ulF2) * 1000) / ulF1;
	}
	else
	{
		*pulDelta = ((ulF2 - ulF1) * 1000) / ulF1;
	}
	trace("G450CalculDeltaFreq: ulF1 %ld, ulF2 %ld, pulDelta %ld\n", ulF1, ulF2, *pulDelta);
}

static void 
G450FindNextPLLParam(Mga* mga, ulong ulFout, ulong *pulPLLMNP)
{
	uchar ucM, ucN, ucP, ucS;
	ulong ulVCO, ulVCOMin;

	ucM = (uchar)((*pulPLLMNP &gt;&gt; 16) &amp; 0xff);
	/* ucN = (uchar)((*pulPLLMNP &gt;&gt;  8) &amp; 0xff); */
	ucP = (uchar)(*pulPLLMNP &amp;  0x43);

	ulVCOMin = 256000;

	if(ulVCOMin &gt;= (255L * 8000))
	{
		ulVCOMin = 230000;
	}

	if((ucM == 9) &amp;&amp; (ucP &amp; 0x40))
	{
		*pulPLLMNP = 0xffffffff;
	} else if (ucM == 9)
	{
		if(ucP)
		{
			ucP--;
		}
		else
		{
			ucP = 0x40;
		}
		ucM = 0;
	}
	else
	{
		ucM++;
	}

	ulVCO = ulFout;

	G450RemovePFactor(mga, ucP, &amp;ulVCO);

	if(ulVCO &lt; ulVCOMin)
	{
		*pulPLLMNP = 0xffffffff;
	}

	if(*pulPLLMNP != 0xffffffff)
	{
		ucN = (uchar)(((ulVCO * (ucM+1) + 27000)/(27000 * 2)) - 2);

		ucS = 5;
		if(ulVCO &lt; 1300000) ucS = 4;
		if(ulVCO &lt; 1100000) ucS = 3;
		if(ulVCO &lt;  900000) ucS = 2;
		if(ulVCO &lt;  700000) ucS = 1;
		if(ulVCO &lt;  550000) ucS = 0;

		ucP |= (uchar)(ucS &lt;&lt; 3);

		*pulPLLMNP &amp;= 0xff000000;
		*pulPLLMNP |= (ulong)ucM &lt;&lt; 16;
		*pulPLLMNP |= (ulong)ucN &lt;&lt; 8;
		*pulPLLMNP |= (ulong)ucP;
	}
}

static void 
G450FindFirstPLLParam(Mga* mga, ulong ulFout, ulong *pulPLLMNP)
{
	uchar ucP;
	ulong ulVCO;
	ulong ulVCOMax;

	/* Default value */
	ulVCOMax = 1300000;

	if(ulFout &gt; (ulVCOMax/2))
	{
		ucP = 0x40;
		ulVCO = ulFout;
	}
	else
	{
		ucP = 3;
		ulVCO = ulFout;
		G450RemovePFactor(mga, ucP, &amp;ulVCO);
		while(ucP &amp;&amp; (ulVCO &gt; ulVCOMax))
		{
			ucP--;
			ulVCO = ulFout;
			G450RemovePFactor(mga, ucP, &amp;ulVCO);
		}
	}

	if(ulVCO &gt; ulVCOMax)
	{
		*pulPLLMNP = 0xffffffff;
	}
	else
	{
		/* Pixel clock: 1 */
		*pulPLLMNP = (1 &lt;&lt; 24) + 0xff0000 + ucP;
		G450FindNextPLLParam(mga, ulFout, pulPLLMNP);
	}
}


static void 
G450WriteMNP(Mga* mga, ulong ulMNP)
{
	if (0) trace("G450WriteMNP : 0x%lx\n", ulMNP);
	dacset(mga, Dac_Xpixpllcm, (uchar)(ulMNP &gt;&gt; 16), 0xff);
	dacset(mga, Dac_Xpixpllcn, (uchar)(ulMNP &gt;&gt;  8), 0xff);   
	dacset(mga, Dac_Xpixpllcp, (uchar)ulMNP, 0xff);   
}


static void 
G450CompareMNP(Mga* mga, ulong ulFout, ulong ulMNP1,
			    ulong ulMNP2, long *pulResult)
{
	ulong ulFreq, ulDelta1, ulDelta2;

	G450CalculVCO(mga, ulMNP1, &amp;ulFreq);
	G450ApplyPFactor(mga, (uchar) ulMNP1, &amp;ulFreq);
	G450CalculDeltaFreq(mga, ulFout, ulFreq, &amp;ulDelta1);

	G450CalculVCO(mga, ulMNP2, &amp;ulFreq);
	G450ApplyPFactor(mga, (uchar) ulMNP2, &amp;ulFreq);
	G450CalculDeltaFreq(mga, ulFout, ulFreq, &amp;ulDelta2);

	if(ulDelta1 &lt; ulDelta2)
	{
		*pulResult = -1;
	}
	else if(ulDelta1 &gt; ulDelta2)
	{
		*pulResult = 1;
	}
	else
	{
		*pulResult = 0;
	}

	if((ulDelta1 &lt;= 5) &amp;&amp; (ulDelta2 &lt;= 5))
	{
		if((ulMNP1 &amp; 0xff0000) &lt; (ulMNP2 &amp; 0xff0000))
		{
			*pulResult = -1;
		}
		else if((ulMNP1 &amp; 0xff0000) &gt; (ulMNP2 &amp; 0xff0000))
		{
			*pulResult = 1;
		}
	}
}


static void 
G450IsPllLocked(Mga* mga, int *lpbLocked)
{
	ulong ulFallBackCounter, ulLockCount, ulCount;
	uchar  ucPLLStatus;

	/* Pixel PLL */
	mgawrite8(mga, 0x3c00, 0x4f);    
	ulFallBackCounter = 0;

	do 
	{
		ucPLLStatus = mgaread8(mga, 0x3c0a);
		if (0) trace("ucPLLStatus[1] : 0x%x\n", ucPLLStatus);
		ulFallBackCounter++;
	} while(!(ucPLLStatus &amp; 0x40) &amp;&amp; (ulFallBackCounter &lt; 1000));

	ulLockCount = 0;
	if(ulFallBackCounter &lt; 1000)
	{
		for(ulCount = 0; ulCount &lt; 100; ulCount++)
		{
			ucPLLStatus = mgaread8(mga, 0x3c0a);
			if (0) trace("ucPLLStatus[2] : 0x%x\n", ucPLLStatus);
			if(ucPLLStatus &amp; 0x40)
			{
				ulLockCount++;
			}
		}
	}

	*lpbLocked = ulLockCount &gt;= 90;
}

static void 
G450SetPLLFreq(Mga* mga, long f_out) 
{
	int bFoundValidPLL;
	int bLocked;
	ulong ulMaxIndex;
	ulong ulMNP;
	ulong ulMNPTable[MNP_TABLE_SIZE];
	ulong ulIndex;
	ulong ulTryMNP;
	long lCompareResult;

	trace("f_out : %ld\n", f_out);

	G450FindFirstPLLParam(mga, f_out, &amp;ulMNP);
	ulMNPTable[0] = ulMNP;
	G450FindNextPLLParam(mga, f_out, &amp;ulMNP);
	ulMaxIndex = 1;
	while(ulMNP != 0xffffffff)
	{
		int ulIndex;
		int bSkipValue;

		bSkipValue = FALSE;
		if(ulMaxIndex == MNP_TABLE_SIZE)
		{
			G450CompareMNP(mga, f_out, ulMNP, ulMNPTable[MNP_TABLE_SIZE - 1],
				       &amp;lCompareResult);

			if(lCompareResult &gt; 0)
			{
				bSkipValue = TRUE;
			}
			else
			{
				ulMaxIndex--;
			}
		}

		if(!bSkipValue)
		{
			for(ulIndex = ulMaxIndex; !bSkipValue &amp;&amp; (ulIndex &gt; 0); ulIndex--)
			{
				G450CompareMNP(mga, f_out, ulMNP, ulMNPTable[ulIndex - 1],
					       &amp;lCompareResult);

				if(lCompareResult &lt; 0)
				{
					ulMNPTable[ulIndex] = ulMNPTable[ulIndex - 1];
				}
				else
				{
					break;
				}
			}
			ulMNPTable[ulIndex] = ulMNP;
			ulMaxIndex++;
		}

		G450FindNextPLLParam(mga, f_out, &amp;ulMNP);
	}

	bFoundValidPLL = FALSE;
	ulMNP = 0;

	for(ulIndex = 0; !bFoundValidPLL &amp;&amp; (ulIndex &lt; ulMaxIndex); ulIndex++)
	{
		ulTryMNP = ulMNPTable[ulIndex];

		{
			bLocked = TRUE;
			if((ulMNPTable[ulIndex] &amp; 0xff00) &lt; 0x300 ||
			   (ulMNPTable[ulIndex] &amp; 0xff00) &gt; 0x7a00)
			{
				bLocked = FALSE;
			}

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP - 0x300);
				G450IsPllLocked(mga, &amp;bLocked);
			}     

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP + 0x300);
				G450IsPllLocked(mga, &amp;bLocked);
			}     

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP - 0x200);
				G450IsPllLocked(mga, &amp;bLocked);
			}     

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP + 0x200);
				G450IsPllLocked(mga, &amp;bLocked);
			}     

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP - 0x100);
				G450IsPllLocked(mga, &amp;bLocked);
			}     

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP + 0x100);
				G450IsPllLocked(mga, &amp;bLocked);
			}     

			if(bLocked)
			{
				G450WriteMNP(mga, ulTryMNP);
				G450IsPllLocked(mga, &amp;bLocked);
			}     
			else if(!ulMNP)
			{
				G450WriteMNP(mga, ulTryMNP);
				G450IsPllLocked(mga, &amp;bLocked);
				if(bLocked)
				{
					ulMNP = ulMNPTable[ulIndex]; 
				}
				bLocked = FALSE;
			}

			if(bLocked)
			{
				bFoundValidPLL = TRUE;
			}
		}
	}

	if(!bFoundValidPLL)
	{
		if(ulMNP)
		{
			G450WriteMNP(mga, ulMNP);
		}
		else
		{
			G450WriteMNP(mga, ulMNPTable[0]);
		}
	}
}


/* ************************************************************ */

/*
	calcclock - Calculate the PLL settings (m, n, p, s).
*/
static double
g400_calcclock(Mga* mga, long Fneeded)
{
	double	Fpll;
	double	Fvco;
	double 	Fref;
	int		pixpll_m_min;
	int		pixpll_m_max;
	int		pixpll_n_min;
	int		pixpll_n_max;
	int		pixpll_p_max;
	double 	Ferr, Fcalc;
	int		m, n, p;
	
	if (mga-&gt;devid == MGA4XX || mga-&gt;devid == MGA550) {
		/* These values are taken from Matrox G400 Specification - p 4-91 */
		Fref     		= 27000000.0;
		pixpll_n_min 	= 7;
		pixpll_n_max 	= 127;
		pixpll_m_min	= 1;
		pixpll_m_max	= 31;
		pixpll_p_max 	= 7;
	} else { 				/* MGA200 */
		/* These values are taken from Matrox G200 Specification - p 4-77 */
		//Fref     		= 14318180.0;
		Fref     		= 27050500.0;
		pixpll_n_min 	= 7;
		pixpll_n_max 	= 127;
		pixpll_m_min	= 1;
		pixpll_m_max	= 6;
		pixpll_p_max 	= 7;
	}

	Fvco = ( double ) Fneeded;
	for (p = 0;  p &lt;= pixpll_p_max &amp;&amp; Fvco &lt; mga-&gt;maxpclk; p = p * 2 + 1, Fvco *= 2.0)
		;
	mga-&gt;pixpll_p = p;

	Ferr = Fneeded;
	for ( m = pixpll_m_min ; m &lt;= pixpll_m_max ; m++ )
		for ( n = pixpll_n_min; n &lt;= pixpll_n_max; n++ )
		{ 
			Fcalc = Fref * (n + 1) / (m + 1) ;

			/*
			 * Pick the closest frequency.
			 */
			if ( labs(Fcalc - Fvco) &lt; Ferr ) {
				Ferr = abs(Fcalc - Fvco);
				mga-&gt;pixpll_m = m;
				mga-&gt;pixpll_n = n;
			}
		}
	
	Fvco = Fref * (mga-&gt;pixpll_n + 1) / (mga-&gt;pixpll_m + 1);

	if (mga-&gt;devid == MGA4XX || mga-&gt;devid == MGA550) {
		if ( (50000000.0 &lt;= Fvco) &amp;&amp; (Fvco &lt; 110000000.0) )
			mga-&gt;pixpll_p |= 0;	
		if ( (110000000.0 &lt;= Fvco) &amp;&amp; (Fvco &lt; 170000000.0) )
			mga-&gt;pixpll_p |= (1&lt;&lt;3);	
		if ( (170000000.0 &lt;= Fvco) &amp;&amp; (Fvco &lt; 240000000.0) )
			mga-&gt;pixpll_p |= (2&lt;&lt;3);	
		if ( (300000000.0 &lt;= Fvco) )
			mga-&gt;pixpll_p |= (3&lt;&lt;3);	
	} else {
		if ( (50000000.0 &lt;= Fvco) &amp;&amp; (Fvco &lt; 100000000.0) )
			mga-&gt;pixpll_p |= 0;	
		if ( (100000000.0 &lt;= Fvco) &amp;&amp; (Fvco &lt; 140000000.0) )
			mga-&gt;pixpll_p |= (1&lt;&lt;3);	
		if ( (140000000.0 &lt;= Fvco) &amp;&amp; (Fvco &lt; 180000000.0) )
			mga-&gt;pixpll_p |= (2&lt;&lt;3);	
		if ( (250000000.0 &lt;= Fvco) )
			mga-&gt;pixpll_p |= (3&lt;&lt;3);	
	}
	
	Fpll = Fvco / (p + 1);

	return Fpll;
}

/* ************************************************************ */

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode*	mode;
	Mga*	mga;
	double	Fpll;
	Ctlr*	c;
	int	i;
	ulong	t;
	int     bppShift;

	mga = vga-&gt;private;
	mode = vga-&gt;mode;

	trace("mga mmio at %#p\n", mga-&gt;mmio);

	ctlr-&gt;flag |= Ulinear;

	/*
	 * Set the right bppShift based on depth
	 */

	switch(mode-&gt;z) {
	case 8: 
		bppShift = 0;
		break;
	case 16:
		bppShift = 1;
		break;
	case 24:
		bppShift = 0;
		break;
	case 32:
		bppShift = 2;
		break;
	default:
		bppShift = 0;
		error("depth %d not supported !\n", mode-&gt;z);
	}

	if (mode-&gt;interlace)
		error("interlaced mode not supported !\n");

	trace("%s: Initializing mode %dx%dx%d on %s\n", ctlr-&gt;name, mode-&gt;x, mode-&gt;y, mode-&gt;z, mode-&gt;type);
	trace("%s: Suggested Dot Clock : %d\n", 	ctlr-&gt;name, mode-&gt;frequency);
	trace("%s: Horizontal Total = %d\n", 		ctlr-&gt;name, mode-&gt;ht);
	trace("%s: Start Horizontal Blank = %d\n", ctlr-&gt;name, mode-&gt;shb);
	trace("%s: End Horizontal Blank = %d\n", 	ctlr-&gt;name, mode-&gt;ehb);
	trace("%s: Vertical Total = %d\n", 		ctlr-&gt;name, mode-&gt;vt);
	trace("%s: Vertical Retrace Start = %d\n", 	ctlr-&gt;name, mode-&gt;vrs);
	trace("%s: Vertical Retrace End = %d\n", 	ctlr-&gt;name, mode-&gt;vre);
	trace("%s: Start Horizontal Sync = %d\n", 	ctlr-&gt;name, mode-&gt;shs);
	trace("%s: End Horizontal Sync = %d\n", 	ctlr-&gt;name, mode-&gt;ehs);
	trace("%s: HSync = %c\n", 			ctlr-&gt;name, mode-&gt;hsync);
	trace("%s: VSync = %c\n", 				ctlr-&gt;name, mode-&gt;vsync);
	trace("%s: Interlace = %d\n", 			ctlr-&gt;name, mode-&gt;interlace);

	/* TODO : G400 Max : 360000000 */
	if (mga-&gt;devid == MGA4XX || mga-&gt;devid == MGA550)
		mga-&gt;maxpclk	= 300000000;
	else
		mga-&gt;maxpclk	= 250000000;

	if (mode-&gt;frequency &lt; 50000)
		error("mga: Too little Frequency %d : Minimum supported by PLL is %d\n", 
			mode-&gt;frequency, 50000);

	if (mode-&gt;frequency &gt; mga-&gt;maxpclk)
		error("mga: Too big Frequency %d : Maximum supported by PLL is %ld\n",
			mode-&gt;frequency, mga-&gt;maxpclk);
	
	trace("mga: revision ID is %x\n", mga-&gt;revid);
	if ((mga-&gt;devid == MGA200) || ((mga-&gt;devid == MGA4XX) &amp;&amp; (mga-&gt;revid &amp; 0x80) == 0x00)) {
		/* Is it G200/G400 or G450 ? */
		Fpll = g400_calcclock(mga, mode-&gt;frequency);
		trace("Fpll set to %f\n", Fpll);
		trace("pixclks : n = %d m = %d p = %d\n", mga-&gt;pixpll_n, mga-&gt;pixpll_m, mga-&gt;pixpll_p &amp; 0x7);
	} else
		mga-&gt;Fneeded = mode-&gt;frequency;

	trace("PCI Option1 = 0x%x\n", pcicfgr32(mga-&gt;pci, PCfgMgaOption1));
	trace("PCI Option2 = 0x%x\n", pcicfgr32(mga-&gt;pci, PCfgMgaOption2));
	trace("PCI Option3 = 0x%x\n", pcicfgr32(mga-&gt;pci, PCfgMgaOption3));

	mga-&gt;htotal =			(mode-&gt;ht &gt;&gt; 3) - 5;
	mga-&gt;hdispend =		(mode-&gt;x &gt;&gt; 3) - 1;
	mga-&gt;hblkstr =		mga-&gt;hdispend; 		/* (mode-&gt;shb &gt;&gt; 3); */
	mga-&gt;hblkend =		mga-&gt;htotal + 4;		/* (mode-&gt;ehb &gt;&gt; 3); */
	mga-&gt;hsyncstr =		(mode-&gt;shs &gt;&gt; 3) - 1;	// Was (mode-&gt;shs &gt;&gt; 3);
	mga-&gt;hsyncend =		(mode-&gt;ehs &gt;&gt; 3) - 1;	// Was (mode-&gt;ehs &gt;&gt; 3);
	mga-&gt;hsyncdel = 		0;
	mga-&gt;vtotal =			mode-&gt;vt - 2;
	mga-&gt;vdispend = 		mode-&gt;y - 1;
	mga-&gt;vblkstr = 		mode-&gt;y - 1;
	mga-&gt;vblkend = 		mode-&gt;vt - 1;
	mga-&gt;vsyncstr = 		mode-&gt;vrs;
	mga-&gt;vsyncend = 		mode-&gt;vre;
	mga-&gt;linecomp =		mode-&gt;y;
	mga-&gt;hsyncsel = 		0;					/* Do not double lines ... */
	mga-&gt;startadd =		0;
	mga-&gt;offset =		(mode-&gt;z==24) ? (vga-&gt;virtx * 3) &gt;&gt; (4 - bppShift) : vga-&gt;virtx &gt;&gt; (4-bppShift);
	/* No Zoom */
	mga-&gt;maxscan = 		0;
	/* Not used in Power Graphic mode */
	mga-&gt;curloc =			0;
	mga-&gt;prowscan = 		0;
	mga-&gt;currowstr = 		0;
	mga-&gt;currowend = 		0;
	mga-&gt;curoff = 		1;
	mga-&gt;undrow = 		0;
	mga-&gt;curskew = 		0;
	mga-&gt;conv2t4 = 		0;
	mga-&gt;interlace =		0;
	mga-&gt;hdispskew =		0;
	mga-&gt;bytepan = 		0;
	mga-&gt;dotclkrt = 		0;
	mga-&gt;dword =			0;
	mga-&gt;wbmode =		1;
	mga-&gt;addwrap = 		0;	/* Not Used ! */
	mga-&gt;selrowscan =		1;
	mga-&gt;cms =			1;
	mga-&gt;csynccen =		0; 	/* Disable composite sync */

	/* VIDRST Pin */
	mga-&gt;hrsten =			0; 	// Was 1;
	mga-&gt;vrsten =			0; 	// Was 1;

	/* vertical interrupt control ... disabled */
	mga-&gt;vinten = 		1;
	mga-&gt;vintclr = 		0;

	/* Let [hv]sync run freely */
	mga-&gt;hsyncoff =		0;
	mga-&gt;vsyncoff =		0;

	mga-&gt;crtcrstN =		1;

	mga-&gt;mgamode = 		1;
	mga-&gt;scale   =		(mode-&gt;z == 24) ? ((1 &lt;&lt; bppShift)*3)-1 : (1 &lt;&lt; bppShift)-1;
	
	mga-&gt;crtcprotect =      1;
	mga-&gt;winsize = 		0;
	mga-&gt;winfreq = 		0;

	if ((mga-&gt;htotal == 0)
	    || (mga-&gt;hblkend &lt;= (mga-&gt;hblkstr + 1))
	    || ((mga-&gt;htotal - mga-&gt;hdispend) == 0)
	    || ((mga-&gt;htotal - mga-&gt;bytepan + 2) &lt;= mga-&gt;hdispend)
	    || (mga-&gt;hsyncstr &lt;= (mga-&gt;hdispend + 2))
	    || (mga-&gt;vtotal == 0))
	{
		error("Invalid Power Graphic Mode :\n"
		      "mga-&gt;htotal = %ld\n"
		      "mga-&gt;hdispend = %ld\n"
		      "mga-&gt;hblkstr = %ld\n"
		      "mga-&gt;hblkend = %ld\n"
		      "mga-&gt;hsyncstr = %ld\n"
		      "mga-&gt;hsyncend = %ld\n"
		      "mga-&gt;hsyncdel = %ld\n"
		      "mga-&gt;vtotal = %ld\n"
		      "mga-&gt;vdispend = %ld\n"
		      "mga-&gt;vblkstr = %ld\n"
		      "mga-&gt;vblkend = %ld\n"
		      "mga-&gt;vsyncstr = %ld\n"
		      "mga-&gt;vsyncend = %ld\n"
		      "mga-&gt;linecomp = %ld\n",
		      mga-&gt;htotal,
		      mga-&gt;hdispend,
		      mga-&gt;hblkstr,
		      mga-&gt;hblkend,
		      mga-&gt;hsyncstr,
		      mga-&gt;hsyncend,
		      mga-&gt;hsyncdel,
		      mga-&gt;vtotal,
		      mga-&gt;vdispend,
		      mga-&gt;vblkstr,
		      mga-&gt;vblkend,
		      mga-&gt;vsyncstr,
		      mga-&gt;vsyncend,
		      mga-&gt;linecomp
		      );
	}

	mga-&gt;hiprilvl = 0;
	mga-&gt;maxhipri = 0;
	mga-&gt;c2hiprilvl = 0;
	mga-&gt;c2maxhipri = 0;

	mga-&gt;misc = ((mode-&gt;hsync != '-')?0:(1&lt;&lt;6)) | ((mode-&gt;vsync != '-')?0:(1&lt;&lt;7));

	trace("mga-&gt;htotal = %ld\n"
		      "mga-&gt;hdispend = %ld\n"
		      "mga-&gt;hblkstr = %ld\n"
		      "mga-&gt;hblkend = %ld\n"
		      "mga-&gt;hsyncstr = %ld\n"
		      "mga-&gt;hsyncend = %ld\n"
		      "mga-&gt;hsyncdel = %ld\n"
		      "mga-&gt;vtotal = %ld\n"
		      "mga-&gt;vdispend = %ld\n"
		      "mga-&gt;vblkstr = %ld\n"
		      "mga-&gt;vblkend = %ld\n"
		      "mga-&gt;vsyncstr = %ld\n"
		      "mga-&gt;vsyncend = %ld\n"
		      "mga-&gt;linecomp = %ld\n",
		      mga-&gt;htotal,
		      mga-&gt;hdispend,
		      mga-&gt;hblkstr,
		      mga-&gt;hblkend,
		      mga-&gt;hsyncstr,
		      mga-&gt;hsyncend,
		      mga-&gt;hsyncdel,
		      mga-&gt;vtotal,
		      mga-&gt;vdispend,
		      mga-&gt;vblkstr,
		      mga-&gt;vblkend,
		      mga-&gt;vsyncstr,
		      mga-&gt;vsyncend,
		      mga-&gt;linecomp
		      );	

	mga-&gt;crtc[0x00] = 0xff &amp; mga-&gt;htotal;

	mga-&gt;crtc[0x01] = 0xff &amp; mga-&gt;hdispend;

	mga-&gt;crtc[0x02] = 0xff &amp; mga-&gt;hblkstr;

	mga-&gt;crtc[0x03] = (0x1f &amp; mga-&gt;hblkend) 
		| ((0x03 &amp; mga-&gt;hdispskew) &lt;&lt; 5)
		| 0x80	/* cf 3-304 */
		;

	mga-&gt;crtc[0x04] = 0xff &amp; mga-&gt;hsyncstr;

	mga-&gt;crtc[0x05] = (0x1f &amp; mga-&gt;hsyncend) 
		| ((0x03 &amp; mga-&gt;hsyncdel) &lt;&lt; 5) 
		| ((0x01 &amp; (mga-&gt;hblkend &gt;&gt; 5)) &lt;&lt; 7)
		;

	mga-&gt;crtc[0x06] = 0xff &amp; mga-&gt;vtotal;

	t = ((0x01 &amp; (mga-&gt;vtotal &gt;&gt; 8)) &lt;&lt; 0)
	  | ((0x01 &amp; (mga-&gt;vdispend &gt;&gt; 8)) &lt;&lt; 1)
	  | ((0x01 &amp; (mga-&gt;vsyncstr &gt;&gt; 8)) &lt;&lt; 2)
	  | ((0x01 &amp; (mga-&gt;vblkstr &gt;&gt; 8)) &lt;&lt; 3)
	  | ((0x01 &amp; (mga-&gt;linecomp &gt;&gt; 8)) &lt;&lt; 4)
	  | ((0x01 &amp; (mga-&gt;vtotal &gt;&gt; 9)) &lt;&lt; 5)
	  | ((0x01 &amp; (mga-&gt;vdispend &gt;&gt; 9)) &lt;&lt; 6)
	  | ((0x01 &amp; (mga-&gt;vsyncstr &gt;&gt; 9)) &lt;&lt; 7)
	  ;
	mga-&gt;crtc[0x07] = 0xff &amp; t;

	mga-&gt;crtc[0x08] = (0x1f &amp; mga-&gt;prowscan) 
		| ((0x03 &amp; mga-&gt;bytepan) &lt;&lt; 5)
		;

	mga-&gt;crtc[0x09] = (0x1f &amp; mga-&gt;maxscan) 
		| ((0x01 &amp; (mga-&gt;vblkstr &gt;&gt; 9)) &lt;&lt; 5)
		| ((0x01 &amp; (mga-&gt;linecomp &gt;&gt; 9)) &lt;&lt; 6)
		| ((0x01 &amp; mga-&gt;conv2t4) &lt;&lt; 7)
		;

	mga-&gt;crtc[0x0a] = (0x1f &amp; mga-&gt;currowstr)
		| ((0x01 &amp; mga-&gt;curoff) &lt;&lt; 5)
		;

	mga-&gt;crtc[0x0b] = (0x1f &amp; mga-&gt;currowend)
		| ((0x03 &amp; mga-&gt;curskew) &lt;&lt; 5)
		;

	mga-&gt;crtc[0x0c] = 0xff &amp; (mga-&gt;startadd &gt;&gt; 8);

	mga-&gt;crtc[0x0d] = 0xff &amp; mga-&gt;startadd;

	mga-&gt;crtc[0x0e] = 0xff &amp; (mga-&gt;curloc &gt;&gt; 8);

	mga-&gt;crtc[0x0f] = 0xff &amp; mga-&gt;curloc;

	mga-&gt;crtc[0x10] = 0xff &amp; mga-&gt;vsyncstr;

	mga-&gt;crtc[0x11] = (0x0f &amp; mga-&gt;vsyncend)
		| ((0x01 &amp; mga-&gt;vintclr) &lt;&lt; 4)
		| ((0x01 &amp; mga-&gt;vinten) &lt;&lt; 5)
		| ((0x01 &amp; mga-&gt;crtcprotect) &lt;&lt; 7)
		;

	mga-&gt;crtc[0x12] = 0xff &amp; mga-&gt;vdispend;

	mga-&gt;crtc[0x13] = 0xff &amp; mga-&gt;offset;

	mga-&gt;crtc[0x14] = 0x1f &amp; mga-&gt;undrow;	/* vga only */

	mga-&gt;crtc[0x15] = 0xff &amp; mga-&gt;vblkstr;

	mga-&gt;crtc[0x16] = 0xff &amp; mga-&gt;vblkend;

	mga-&gt;crtc[0x17] = ((0x01 &amp; mga-&gt;cms) &lt;&lt; 0)
		| ((0x01 &amp; mga-&gt;selrowscan) &lt;&lt; 1)
		| ((0x01 &amp; mga-&gt;hsyncsel) &lt;&lt; 2)
		| ((0x01 &amp; mga-&gt;addwrap) &lt;&lt; 5)
		| ((0x01 &amp; mga-&gt;wbmode) &lt;&lt; 6)
		| ((0x01 &amp; mga-&gt;crtcrstN) &lt;&lt; 7)
		;

	mga-&gt;crtc[0x18] = 0xff &amp; mga-&gt;linecomp;
	
	mga-&gt;crtcext[0] = (0x0f &amp; (mga-&gt;startadd &gt;&gt; 16))
		| ((0x03 &amp; (mga-&gt;offset &gt;&gt; 8)) &lt;&lt; 4)
		| ((0x01 &amp; (mga-&gt;startadd &gt;&gt; 20)) &lt;&lt; 6)
		| ((0x01 &amp; mga-&gt;interlace) &lt;&lt; 7)
		;

	mga-&gt;crtcext[1] = ((0x01 &amp; (mga-&gt;htotal &gt;&gt; 8)) &lt;&lt; 0)
		| ((0x01 &amp; (mga-&gt;hblkstr &gt;&gt; 8)) &lt;&lt; 1)
		| ((0x01 &amp; (mga-&gt;hsyncstr &gt;&gt; 8)) &lt;&lt; 2)
		| ((0x01 &amp; mga-&gt;hrsten) &lt;&lt; 3)
		| ((0x01 &amp; mga-&gt;hsyncoff) &lt;&lt; 4)
		| ((0x01 &amp; mga-&gt;vsyncoff) &lt;&lt; 5)
		| ((0x01 &amp; (mga-&gt;hblkend &gt;&gt; 6)) &lt;&lt; 6)
		| ((0x01 &amp; mga-&gt;vrsten) &lt;&lt; 7)
		;

	mga-&gt;crtcext[2] = ((0x03 &amp; (mga-&gt;vtotal &gt;&gt; 10)) &lt;&lt; 0)
		| ((0x01 &amp; (mga-&gt;vdispend &gt;&gt; 10)) &lt;&lt; 2)
		| ((0x03 &amp; (mga-&gt;vblkstr &gt;&gt; 10)) &lt;&lt; 3)
		| ((0x03 &amp; (mga-&gt;vsyncstr &gt;&gt; 10)) &lt;&lt; 5)
		| ((0x01 &amp; (mga-&gt;linecomp &gt;&gt; 10)) &lt;&lt; 7)
		;

	mga-&gt;crtcext[3] = ((0x07 &amp; mga-&gt;scale) &lt;&lt; 0)
		| ((0x01 &amp; mga-&gt;csynccen) &lt;&lt; 6)
		| ((0x01 &amp; mga-&gt;mgamode) &lt;&lt; 7)
		;

	mga-&gt;crtcext[4] = 0;	/* memory page ... not used in Power Graphic Mode */

	mga-&gt;crtcext[5] = 0;	/* Not used in non-interlaced mode */

	mga-&gt;crtcext[6] = ((0x07 &amp; mga-&gt;hiprilvl) &lt;&lt; 0)
		| ((0x07 &amp; mga-&gt;maxhipri) &lt;&lt; 4)
		;

	mga-&gt;crtcext[7] = ((0x07 &amp; mga-&gt;winsize) &lt;&lt; 1)
		| ((0x07 &amp; mga-&gt;winfreq) &lt;&lt; 5)
		;

	mga-&gt;crtcext[8] = (0x01 &amp; (mga-&gt;startadd &gt;&gt; 21)) &lt;&lt; 0;

	/* Initialize Sequencer */
	mga-&gt;sequencer[0] = 0;
	mga-&gt;sequencer[1] = 0;
	mga-&gt;sequencer[2] = 0x03;
	mga-&gt;sequencer[3] = 0;
	mga-&gt;sequencer[4] = 0x02;

	/* Graphic Control registers are ignored when not using 0xA0000 aperture */	
	for (i = 0; i &lt; 9; i++)
		mga-&gt;graphics[i] = 0;	

	/* The Attribute Controler is not available in Power Graphics mode */
	for (i = 0; i &lt; 0x15; i++)
		mga-&gt;attribute[i] = i;	

	/* disable vga load (want to do fields in different order) */
	for(c = vga-&gt;link; c; c = c-&gt;link)
		if (strncmp(c-&gt;name, "vga", 3) == 0)
			c-&gt;load = nil;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	Mga*	mga;
	int	i;
	uchar*	p;
	Mode*	mode;
	uchar	cursor;

	mga = vga-&gt;private;
	mode = vga-&gt;mode;

	trace("mga: Loading ...\n");
	dump_all_regs(mga);

	if (mode-&gt;z == 8)
		setpalettedepth(mode-&gt;z);

	trace("mga mmio at %#p\n", mga-&gt;mmio);
	trace("mga: loading vga registers ...\n" );
	if (ultradebug) Bflush(&amp;stdout);

	/* Initialize Sequencer registers */
	for(i = 0; i &lt; 5; i++)
		seqset(mga, i, mga-&gt;sequencer[i], 0xff);

	/* Initialize Attribute register */
	for(i = 0; i &lt; 0x15; i++)
		attrset(mga, i, mga-&gt;attribute[i], 0xff);

	/* Initialize Graphic Control registers */
	for(i = 0; i &lt; 9; i++)
		gctlset(mga, i, mga-&gt;graphics[i], 0xff);

	/* Wait VSYNC */
	while (mgaread8(mga, STATUS1) &amp; 0x08);
	while (! (mgaread8(mga, STATUS1) &amp; ~0x08));

	/* Turn off the video. */
	seqset(mga, Seq_ClockingMode, Scroff, 0);

	/* Crtc2 Off */
	mgawrite32(mga, C2_CTL, 0);

	/* Disable Cursor */
	cursor = dacset(mga, Dac_Xcurctrl, CursorDis, 0xff);

	/* Pixel Pll UP and set Pixel clock source to Pixel Clock PLL */
	dacset(mga, Dac_Xpixclkctrl, 0x01 | 0x08, 0x0f);

	trace("mga: waiting for the clock source becomes stable ...\n");
	while ((dacget(mga, Dac_Xpixpllstat) &amp; Pixlock) != Pixlock)
		;
	trace("mga: pixpll locked !\n");
	if (ultradebug) Bflush(&amp;stdout);

	/* Enable LUT, Disable MAFC */
	dacset(mga, Dac_Xmiscctrl, Ramcs | Mfcsel, Vdoutsel);

	/* Disable Dac */
	dacset(mga, Dac_Xmiscctrl, 0, Dacpdn);

	/* Initialize Panel Mode */
	dacset(mga, Dac_Xpanelmode, 0, 0xff);

	/* Disable the PIXCLK and set Pixel clock source to Pixel Clock PLL */
	dacset(mga, Dac_Xpixclkctrl, Pixclkdis | 0x01, 0x3);

	/* Disable mapping of the memory */ 
	miscset(mga, 0, Misc_rammapen);

	/* Enable 8 bit palette */
	dacset(mga, Dac_Xmiscctrl, Vga8dac, 0);

	/* Select MGA Pixel Clock */
	miscset(mga, Misc_clksel, 0);

	/* Initialize Z Buffer ... (useful?) */
	mgawrite32(mga, Z_DEPTH_ORG, 0);

	/* Wait */
	for (i = 0; i &lt; 50; i++)
		mgaread32(mga, MGA_STATUS);

	if ((mga-&gt;devid == MGA200) || ((mga-&gt;devid == MGA4XX) &amp;&amp; (mga-&gt;revid &amp; 0x80) == 0x00)) { 
		dacset(mga, Dac_Xpixpllcm, mga-&gt;pixpll_m, 0xff);
		dacset(mga, Dac_Xpixpllcn, mga-&gt;pixpll_n, 0xff);
		dacset(mga, Dac_Xpixpllcp, mga-&gt;pixpll_p, 0xff);

		/* Wait until new clock becomes stable */
		trace("mga: waiting for the clock source becomes stable ...\n");
		while ((dacget(mga, Dac_Xpixpllstat) &amp; Pixlock) != Pixlock)
			;
		trace("mga: pixpll locked !\n");
	} else {
	/* MGA450 and MGA550 */
		/* Wait until new clock becomes stable */
		trace("mga450: waiting for the clock source becomes stable ...\n");
		while ((dacget(mga, Dac_Xpixpllstat) &amp; Pixlock) != Pixlock)
			;
		trace("mga: pixpll locked !\n");

		G450SetPLLFreq(mga, (long) mga-&gt;Fneeded / 1000);
	}

	/* Enable Pixel Clock Oscillation */
	dacset(mga, Dac_Xpixclkctrl, 0, Pixclkdis);
	if (ultradebug) Bflush(&amp;stdout);

	/* Enable Dac */
	dacset(mga, Dac_Xmiscctrl, Dacpdn, 0);

	/* Set Video Mode */
	switch (mode-&gt;z) {
	case 8:
		dacset(mga, Dac_Xmulctrl, _8bitsPerPixel, ColorDepth);	
		break;
	case 16:
		dacset(mga, Dac_Xmulctrl, _16bitsPerPixel, ColorDepth);	
		break;
	case 24:
		dacset(mga, Dac_Xmulctrl, _24bitsPerPixel, ColorDepth);	
		break;
	case 32:
		dacset(mga, Dac_Xmulctrl, _32bitsPerPixel, ColorDepth);
		break;
	default: 
		error("Unsupported depth %d\n", mode-&gt;z);
	}

	/* Wait */
	for (i = 0; i &lt; 50; i++)
		mgaread32(mga, MGA_STATUS);

	/* Wait until new clock becomes stable */
	trace("mga: waiting for the clock source becomes stable ...\n");
	if (ultradebug) Bflush(&amp;stdout);
	while ((dacget(mga, Dac_Xpixpllstat) &amp; Pixlock) != Pixlock)
		;
	trace("mga: pixpll locked !\n");
	if (ultradebug) Bflush(&amp;stdout);

	/* Initialize CRTC registers and remove irq */
	crtcset(mga, 0x11, (1&lt;&lt;4), (1&lt;&lt;5)|0x80);
	for (i = 0; i &lt; 25; i++)
		crtcset(mga, i, mga-&gt;crtc[i], 0xff);

	trace("mga: crtc loaded !\n");
	if (ultradebug) Bflush(&amp;stdout);

	/* Initialize CRTC Extension registers */
	for (i = 0; i &lt; 9; i++)
		crtcextset(mga, i, mga-&gt;crtcext[i], 0xff);

	trace("mga: ext loaded !\n");
	if (ultradebug) Bflush(&amp;stdout);

	/* Disable Zoom */
	dacset(mga, Dac_Xzoomctrl, 0, 0xff);

	trace("mga: XzoomCtrl Loaded !\n");
	if (ultradebug) Bflush(&amp;stdout);

	/* Enable mga mode again ... Just in case :) */
	crtcextset(mga, CrtcExt_Miscellaneous, Mgamode, 0);

	trace("mga: crtcext MgaMode loaded !\n");
	if (ultradebug) Bflush(&amp;stdout);

	if (mode-&gt;z == 32 || mode-&gt;z == 24 ) {
		/* Initialize Big Endian Mode ! */
		mgawrite32(mga, 0x1e54, 0x02 &lt;&lt; 16);
	}


	/* Set final misc ... enable mapping ... */
	miscset(mga, mga-&gt;misc | Misc_rammapen, 0);

	trace("mga: mapping enabled !\n");
	if (ultradebug) Bflush(&amp;stdout);

	/* Enable Screen */
	seqset(mga, 1, 0, 0xff);

	trace("screen enabled ...\n");

	if (0) {
		p = mga-&gt;mmfb;
		for (i = 0; i &lt; mga-&gt;fbsize; i++)
			*p++ = (0xff &amp; i);
	}

	trace("mga: Loaded !\n" );
	dump_all_regs(mga);
	if (ultradebug) Bflush(&amp;stdout);

	trace("mga: Loaded [bis]!\n" );

	/*
	 * TODO: In 16bpp mode, what is the correct palette ?
	 *       in the meantime lets use the default one,
	 *       which has a weird color combination.
	 */

	if (mode-&gt;z != 8 &amp;&amp; mode -&gt;z != 16) {
		/* Initialize Palette */
		mgawrite8(mga, RAMDACIDX, 0);
		for (i = 0; i &lt; 0x100; i++) {
			mgawrite8(mga, RAMDACPALDATA, i);
			mgawrite8(mga, RAMDACPALDATA, i);
			mgawrite8(mga, RAMDACPALDATA, i);
		}
	}

	trace("mga: Palette initialised !\n");

	/* Enable Cursor */
	dacset(mga, Dac_Xcurctrl, cursor, 0xff);

	ctlr-&gt;flag |= Fload;
	if (ultradebug) Bflush(&amp;stdout);
}

Ctlr mga4xx = {
	"mga4xx",			/* name */
	snarf,				/* snarf */
	options,				/* options */
	init,					/* init */
	load,					/* load */
	dump,				/* dump */
};

Ctlr mga4xxhwgc = {
	"mga4xxhwgc",		/* name */
	0,					/* snarf */
	0,					/* options */
	0,					/* init */
	0,					/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

