<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/neomagic.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/neomagic.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

typedef struct {
	Pcidev*	pci;

	int	x;
	int	y;
} Neomagic;

enum {
	ExtCrtx = 0x19,
	MaxCRT=0x85,
	MaxGR=0xc7,
};

enum {
	GeneralLockReg = 0x0A,
	ExtCRTDispAddr = 0x0E,
	ExtCRTOffset = 0x0F,
	SysIfaceCntl1 = 0x10,
	SysIfaceCntl2 = 0x11,
	SingleAddrPage = 0x15,		/* not changed? */
	DualAddrPage = 0x16,		/* not changed? */
	PanelDispCntlReg1 = 0x20,
	PanelDispCntlReg2 = 0x25,
	PanelDispCntlReg3 = 0x30,
	PanelVertCenterReg1 = 0x28,
	PanelVertCenterReg2 = 0x29,
	PanelVertCenterReg3 = 0x2A,
	PanelVertCenterReg4 = 0x32,	/* not 2070 */
	PanelHorizCenterReg1 = 0x33,
	PanelHorizCenterReg2 = 0x34,
	PanelHorizCenterReg3 = 0x35,
	PanelHorizCenterReg4 = 0x36,	/* 2160, 2200, 2360 */
	PanelVertCenterReg5 = 0x37,	/* 2200, 2360 */
	PanelHorizCenterReg5 = 0x38,	/* 2200, 2360 */

	ExtColorModeSelect = 0x90,

	VerticalExt = 0x70,		/* 2200; iobase+4 */
};

static int crts[] = {
	0x1D, 0x1F, 0x21, 0x23, 0x25, 0x2F,
	/* also 40-59, 60-69, 70-MaxCRT */
	-1
};

/*
 * Neomagic driver (fake)
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	Pcidev *p;
	Neomagic *nm;

	generic.snarf(vga, ctlr);

	outportw(Grx, 0x2609);	/* unlock neo registers */
	outportw(Grx, 0x0015);	/* reset bank */

	for(i=0; crts[i] &gt;= 0; i++)
		vga-&gt;crt[crts[i]] = vgaxi(Crtx, crts[i]);
	for(i=0x40; i &lt;= MaxCRT; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);

	for(i=0x08; i&lt;=0x3F; i++)
		vga-&gt;graphics[i] = vgaxi(Grx, i);
	for(i=0x70; i&lt;=MaxGR; i++)
		vga-&gt;graphics[i] = vgaxi(Grx, i);

	if(vga-&gt;private == nil){
		vga-&gt;private = alloc(sizeof(Neomagic));
		nm = vga-&gt;private;
		if((p = pcimatch(0, 0x10C8, 0)) == nil)
			error("%s: not found\n", ctlr-&gt;name);
		switch(p-&gt;did){
		case 0x0003:			/* MagicGraph 128 ZV */
			vga-&gt;f[1] = 80000000;
			vga-&gt;vmz = 2048*1024;
			vga-&gt;apz = 4*1024*1024;
			break;
		case 0x0083:			/* MagicGraph 128 ZV+ */
			vga-&gt;f[1] = 80000000;
			vga-&gt;vmz = 2048*1024;
			vga-&gt;apz = 4*1024*1024;
			break;
		case 0x0004:			/* MagicGraph 128 XD */
			vga-&gt;f[1] = 90000000;
			vga-&gt;vmz = 2048*1024;
			vga-&gt;apz = 16*1024*1024;
			break;
		case 0x0005:			/* MagicMedia 256 AV */
			vga-&gt;f[1] = 110000000;
			vga-&gt;vmz = 2560*1024;
			vga-&gt;apz = 16*1024*1024;
			break;
		case 0x0006:			/* MagicMedia 256 ZX */
			vga-&gt;f[1] = 110000000;
			vga-&gt;vmz = 4096*1024;
			vga-&gt;apz = 16*1024*1024;
			break;
		case 0x0016:			/* MagicMedia 256 XL+ */
			vga-&gt;f[1] = 110000000;
			/* Vaio VESA BIOS says 6080, but then hwgc doesn't work */
			vga-&gt;vmz = 4096*1024;
			vga-&gt;apz = 32*1024*1024;
			break;
		case 0x0001:			/* MagicGraph 128 */
		case 0x0002:			/* MagicGraph 128 V */
		default:
			error("%s: DID %4.4uX unsupported\n",
				ctlr-&gt;name, p-&gt;did);
		}
		nm-&gt;pci = p;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Ulinear|Hlinear|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Neomagic *nm;
	int i, h, v, t;

	generic.init(vga, ctlr);

	nm = vga-&gt;private;
	switch((vga-&gt;graphics[0x20]&gt;&gt;3)&amp;3){
	case 0:
		nm-&gt;x = 640;
		nm-&gt;y = 480;
		break;
	case 1:
		nm-&gt;x = 800;
		nm-&gt;y = 600;
		break;
	case 2:
		nm-&gt;x = 1024;
		nm-&gt;y = 768;
	case 3:
		nm-&gt;x = 1280;
		nm-&gt;y = 1024;
		break;
	}

	vga-&gt;crt[0x0C] = 0;	/* vga starting address (offset) */
	vga-&gt;crt[0x0D] = 0;
	vga-&gt;graphics[GeneralLockReg] = 0x01;	/* (internal or simultaneous) */
	vga-&gt;attribute[0x10] &amp;= ~0x40;	/* 2x4 mode not right for neomagic */

	t = 2;		/* LCD only (0x01 for external) */
	switch(vga-&gt;mode-&gt;x){
	case 1280:
		t |= 0x60;
		break;
	case 1024:
		t |= 0x40;
		break;
	case 800:
		t |= 0x20;
		break;
	}
	if(0 &amp;&amp; (nm-&gt;pci-&gt;did == 0x0005) || (nm-&gt;pci-&gt;did == 0x0006)){
		vga-&gt;graphics[PanelDispCntlReg1] &amp;= 0x98;
		vga-&gt;graphics[PanelDispCntlReg1] |= (t &amp; ~0x98);
	}
	else{
		vga-&gt;graphics[PanelDispCntlReg1] &amp;= 0xDC;	/* save bits 7:6, 4:2 */
		vga-&gt;graphics[PanelDispCntlReg1] |= (t &amp; ~0xDC);
	}

	vga-&gt;graphics[PanelDispCntlReg2] &amp;= 0x38;
	vga-&gt;graphics[PanelDispCntlReg3] &amp;= 0xEF;
	vga-&gt;graphics[PanelVertCenterReg1] = 0x00;
	vga-&gt;graphics[PanelVertCenterReg2] = 0x00;
	vga-&gt;graphics[PanelVertCenterReg3] = 0x00;
	vga-&gt;graphics[PanelVertCenterReg4] = 0x00;
	vga-&gt;graphics[PanelVertCenterReg5] = 0x00;
	vga-&gt;graphics[PanelHorizCenterReg1] = 0x00;
	vga-&gt;graphics[PanelHorizCenterReg2] = 0x00;
	vga-&gt;graphics[PanelHorizCenterReg3] = 0x00;
	vga-&gt;graphics[PanelHorizCenterReg4] = 0x00;
	vga-&gt;graphics[PanelHorizCenterReg5] = 0x00;
	if(vga-&gt;mode-&gt;x &lt; nm-&gt;x){
		vga-&gt;graphics[PanelDispCntlReg2] |= 0x01;
		vga-&gt;graphics[PanelDispCntlReg3] |= 0x10;
		h = ((nm-&gt;x - vga-&gt;mode-&gt;x) &gt;&gt; 4) - 1;
		v = ((nm-&gt;y - vga-&gt;mode-&gt;y) &gt;&gt; 1) - 2;
		switch(vga-&gt;mode-&gt;x){
		case 640:
			vga-&gt;graphics[PanelHorizCenterReg1] = h;
			vga-&gt;graphics[PanelVertCenterReg3] = v;
			break;
		case 800:
			vga-&gt;graphics[PanelHorizCenterReg2] = h;
			vga-&gt;graphics[PanelVertCenterReg4] = v;
			break;
		case 1024:
			vga-&gt;graphics[PanelHorizCenterReg5] = h;
			vga-&gt;graphics[PanelVertCenterReg5] = v;
			break;
		}
	}

	vga-&gt;graphics[ExtCRTDispAddr] = 0x10;
	vga-&gt;graphics[SysIfaceCntl1] &amp;= 0x0F;
	vga-&gt;graphics[SysIfaceCntl1] |= 0x30;
	vga-&gt;graphics[SysIfaceCntl2] = 0x40;	/* make sure MMIO is enabled */
	vga-&gt;graphics[SingleAddrPage] = 0x00;
	vga-&gt;graphics[DualAddrPage] = 0x00;
	vga-&gt;graphics[ExtCRTOffset] = 0x00;
	t = vga-&gt;graphics[ExtColorModeSelect] &amp; 0x70;	/* colour mode extension */
	if(vga-&gt;mode-&gt;z == 8){
		t |= 0x11;
		vga-&gt;crt[0x13] = vga-&gt;mode-&gt;x/8;
		vga-&gt;graphics[ExtCRTOffset] = vga-&gt;mode-&gt;x&gt;&gt;11;
		vga-&gt;graphics[0x05] = 0x00;	/* linear addressing? */
		vga-&gt;crt[0x14] = 0x40;	/* double word mode but don't count by 4 */
	}
	else if(vga-&gt;mode-&gt;z == 16){
		t |= 0x13;
		vga-&gt;crt[0x13] = vga-&gt;mode-&gt;x/4;
		vga-&gt;graphics[0x05] = 0x00;	/* linear addressing? */
		vga-&gt;crt[0x14] = 0x40;	/* double word mode but don't count by 4 */
		vga-&gt;graphics[ExtCRTOffset] = vga-&gt;mode-&gt;x&gt;&gt;10;
		for(i = 0; i &lt; Pcolours; i++){
			vga-&gt;palette[i][Red] = i&lt;&lt;1;
			vga-&gt;palette[i][Green] = i;
			vga-&gt;palette[i][Blue] = i&lt;&lt;1;
		}
	}
	else if(vga-&gt;mode-&gt;z == 24){
		t |= 0x14;
		vga-&gt;crt[0x13] = (vga-&gt;mode-&gt;x*3)/8;
//		vga-&gt;graphics[0x05] = 0x00;	/* linear addressing? */
		vga-&gt;crt[0x14] = 0x40;	/* double word mode but don't count by 4 */
		vga-&gt;graphics[ExtCRTOffset] = (vga-&gt;mode-&gt;x*3)&gt;&gt;11;
		for(i = 0; i &lt; Pcolours; i++){
			vga-&gt;palette[i][Red] = i;
			vga-&gt;palette[i][Green] = i;
			vga-&gt;palette[i][Blue] = i;
		}
	}
	else
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);
	vga-&gt;graphics[ExtColorModeSelect] = t;

	vga-&gt;misc |= 0x0C;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	vgaxo(Grx, GeneralLockReg, vga-&gt;graphics[GeneralLockReg]);
	vgaxo(Grx, ExtColorModeSelect, vga-&gt;graphics[ExtColorModeSelect]);
	vgaxo(Grx, PanelDispCntlReg2, vga-&gt;graphics[PanelDispCntlReg2] &amp; 0x39);
	sleep(200);

	generic.load(vga, ctlr);

	vgaxo(Grx, ExtCRTDispAddr, vga-&gt;graphics[ExtCRTDispAddr]);
	vgaxo(Grx, ExtCRTOffset, vga-&gt;graphics[ExtCRTOffset] &amp; 0x39);
	vgaxo(Grx, SysIfaceCntl1, vga-&gt;graphics[SysIfaceCntl1]);
	if(ctlr-&gt;flag &amp; Ulinear)
		vga-&gt;graphics[SysIfaceCntl2] |= 0x80;
	vgaxo(Grx, SysIfaceCntl2, vga-&gt;graphics[SysIfaceCntl2]);
	vgaxo(Grx, SingleAddrPage, vga-&gt;graphics[SingleAddrPage]);
	vgaxo(Grx, DualAddrPage, vga-&gt;graphics[DualAddrPage]);
	vgaxo(Grx, PanelDispCntlReg1, vga-&gt;graphics[PanelDispCntlReg1]);
	vgaxo(Grx, PanelDispCntlReg2, vga-&gt;graphics[PanelDispCntlReg2]);
	vgaxo(Grx, PanelDispCntlReg3, vga-&gt;graphics[PanelDispCntlReg3]);
	vgaxo(Grx, PanelVertCenterReg1, vga-&gt;graphics[PanelVertCenterReg1]);
	vgaxo(Grx, PanelVertCenterReg2, vga-&gt;graphics[PanelVertCenterReg2]);
	vgaxo(Grx, PanelVertCenterReg3, vga-&gt;graphics[PanelVertCenterReg3]);
	vgaxo(Grx, PanelVertCenterReg4, vga-&gt;graphics[PanelVertCenterReg4]);
	vgaxo(Grx, PanelHorizCenterReg1, vga-&gt;graphics[PanelHorizCenterReg1]);
	vgaxo(Grx, PanelHorizCenterReg2, vga-&gt;graphics[PanelHorizCenterReg2]);
	vgaxo(Grx, PanelHorizCenterReg3, vga-&gt;graphics[PanelHorizCenterReg3]);
	vgaxo(Grx, PanelHorizCenterReg4, vga-&gt;graphics[PanelHorizCenterReg4]);
	vgaxo(Grx, PanelVertCenterReg5, vga-&gt;graphics[PanelVertCenterReg5]);
	vgaxo(Grx, PanelHorizCenterReg5, vga-&gt;graphics[PanelHorizCenterReg5]);

	if(vga-&gt;mode-&gt;z != 8)
		palette.load(vga, ctlr);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char buf[100];

	generic.dump(vga, ctlr);

	for(i = 0; crts[i] &gt;= 0; i++){
		sprint(buf, "Crt%2.2uX", crts[i]);
		printitem(ctlr-&gt;name, buf);
		printreg(vga-&gt;crt[crts[i]]);
	}
	printitem(ctlr-&gt;name, "Crt40");
	for(i=0x40; i&lt;=0x59; i++)
		printreg(vga-&gt;crt[i]);
	printitem(ctlr-&gt;name, "Crt60");
	for(i=0x60; i&lt;=0x69; i++)
		printreg(vga-&gt;crt[i]);
	printitem(ctlr-&gt;name, "Crt70");
	for (i = 0x70; i &lt;= MaxCRT; i++)
		printreg(vga-&gt;crt[i]);

	printitem(ctlr-&gt;name, "Gr08");
	for(i=0x08; i&lt;=0x3F; i++)
		printreg(vga-&gt;graphics[i]);
	printitem(ctlr-&gt;name, "Gr70");
	for(i=0x70; i&lt;=MaxGR; i++)
		printreg(vga-&gt;graphics[i]);
}

Ctlr neomagic = {
	"neomagic",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr neomagichwgc = {
	"neomagichwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

