<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/palette.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/palette.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

static ulong
xnto32(uchar x, int n)
{
	int s;
	ulong y;

	x &amp;= (1&lt;&lt;n)-1;
	y = 0;
	for(s = 32 - n; s &gt; 0; s -= n)
		y |= x&lt;&lt;s;
	if(s &lt; 0)
		y |= x&gt;&gt;(-s);
	return y;
}

static void
setcolour(uchar p[3], ulong r, ulong g, ulong b)
{
	p[Red] = r&gt;&gt;(32-6);
	p[Green] = g&gt;&gt;(32-6);
	p[Blue] = b&gt;&gt;(32-6);
}

/*
 * Vga colour palette.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;

	vga-&gt;pixmask = vgai(Pixmask);
	vga-&gt;pstatus = vgai(Pstatus);
	vgao(PaddrR, 0x00);
	for(i = 0; i &lt; Pcolours; i++){
		vga-&gt;palette[i][Red] = vgai(Pdata);
		vga-&gt;palette[i][Green] = vgai(Pdata);
		vga-&gt;palette[i][Blue] = vgai(Pdata);
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	int i;
	uchar *p;
	ulong x;

	memset(vga-&gt;palette, 0, sizeof(vga-&gt;palette));
	vga-&gt;pixmask = 0xFF;
	if(vga-&gt;mode-&gt;z == 8){
		for(i = 0; i &lt; Pcolours; i++){
			p = vga-&gt;palette[i^0xFF];
			setcolour(p, xnto32(i&gt;&gt;5, 3), xnto32(i&gt;&gt;2, 3), xnto32(i, 2));
		}
		p =  vga-&gt;palette[0x55^0xFF];
		setcolour(p, xnto32(0x15, 6), xnto32(0x15, 6), xnto32(0x15, 6));
		p =  vga-&gt;palette[0xAA^0xFF];
		setcolour(p, xnto32(0x2A, 6), xnto32(0x2A, 6), xnto32(0x2A, 6));
		p =  vga-&gt;palette[0xFF^0xFF];
		setcolour(p, xnto32(0x3F, 6), xnto32(0x3F, 6), xnto32(0x3F, 6));
	}
	else for(i = 0; i &lt; 16; i++){
		x = xnto32((i*63)/15, 6);
		setcolour(vga-&gt;palette[i^0xFF], x, x, x);
	}

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	int i;

	vgao(Pixmask, vga-&gt;pixmask);
	vgao(PaddrW, 0x00);
	for(i = 0; i &lt; Pcolours; i++){
		vgao(Pdata, vga-&gt;palette[i][Red]);
		vgao(Pdata, vga-&gt;palette[i][Green]);
		vgao(Pdata, vga-&gt;palette[i][Blue]);
	}

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;

	printitem(ctlr-&gt;name, "palette");
	for(i = 0; i &lt; Pcolours; i++){
		if(i &amp;&amp; (i%6) == 0)
			Bprint(&amp;stdout, "\n%-20s", "");
		Bprint(&amp;stdout, " %2.2X/%2.2X/%2.2X", vga-&gt;palette[i][Red],
			vga-&gt;palette[i][Green], vga-&gt;palette[i][Blue]);
	}
	Bprint(&amp;stdout, "\n");
}

Ctlr palette = {
	"palette",			/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

