<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/radeon.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/radeon.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"
#include "radeon.h"

static int	debug = 0;

#define DBGPRINT	if (debug) print

enum {
	Kilo	 = 1024,
	Mega	 = Kilo *Kilo,
};

enum {
	DISPLAY_CRT,
	DISPLAY_FP,
	DISPLAY_LCD,
};

typedef struct Radeon Radeon;
struct Radeon {
	uintptr	mmio;
	Pcidev	*pci;
	uchar	*bios;

	ulong	fbsize;
	int	display_type;

	ulong	ovr_clr;
	ulong	ovr_wid_top_bottom;
	ulong	ovr_wid_left_right;
	ulong	ov0_scale_cntl;
	ulong	subpic_cntl;
	ulong	viph_control;
	ulong	i2c_cntl_1;
	ulong	rbbm_soft_reset;
	ulong	cap0_trig_cntl;
	ulong	cap1_trig_cntl;
	ulong	gen_int_cntl;
	ulong	bus_cntl;

	ulong	crtc_gen_cntl;
	ulong	crtc_ext_cntl;
	ulong	dac_cntl;

	ulong	crtc_h_total_disp;
	ulong	crtc_h_sync_strt_wid;
	ulong	crtc_v_total_disp;
	ulong	crtc_v_sync_strt_wid;

	ulong	crtc_pitch;

	ulong	crtc_offset;
	ulong	crtc_offset_cntl;

	ulong	htotal_cntl;

	ulong	surface_cntl;

	int	r300_workaround;

	/* inited from rom */
	ushort	reference_freq;
	ushort	reference_div;
	ushort	xclk;
	ulong	max_pll_freq;
	ulong	min_pll_freq;

	ulong	pll_output_freq;
	ulong	feedback_div;
	ulong	dot_clock_freq;

	ulong	post_div;
	ulong	ppll_ref_div;
	ulong	ppll_div_3;
};

/* from io.c */
extern char *readbios(long len, long offset);

static void radeon300_workaround(Radeon*radeon);

static void
OUTREG8(Radeon*radeon, ulong offset, uchar val)
{
	((uchar *)(radeon-&gt;mmio + offset))[0] = val;
}

static void
OUTREG(Radeon*radeon, ulong offset, ulong val)
{
	((ulong *)(radeon-&gt;mmio + offset))[0] = val;
}

static ulong
INREG(Radeon*radeon, ulong offset)
{
	return ((ulong *)(radeon-&gt;mmio + offset))[0];
}

static void
OUTREGP(Radeon*radeon, ulong offset, ulong val, ulong mask)
{
	OUTREG(radeon, offset, (INREG(radeon, offset) &amp; mask) | val);
}

static void
OUTPLL(Radeon*radeon, ulong offset, ulong val)
{
	OUTREG8(radeon, CLOCK_CNTL_INDEX,
		(offset &amp; 0x3f) | PLL_WR_EN);
	OUTREG(radeon, CLOCK_CNTL_DATA, val);
}

static ulong
INPLL(Radeon*radeon, ulong offset)
{
	ulong data;

	OUTREG8(radeon, CLOCK_CNTL_INDEX, offset &amp; 0x3f);
	data = INREG(radeon, CLOCK_CNTL_DATA);
	if (radeon-&gt;r300_workaround)
		radeon300_workaround(radeon);
	return data;
}

static void
OUTPLLP(Radeon*radeon, ulong offset, ulong val, ulong mask)
{
	OUTPLL(radeon, offset, (INPLL(radeon, offset) &amp; mask) | val);
}

static void
radeon300_workaround(Radeon*radeon)
{
	ulong save, tmp;

	save = INREG(radeon, CLOCK_CNTL_INDEX);
	tmp = save &amp; ~(0x3f | PLL_WR_EN);
	OUTREG(radeon, CLOCK_CNTL_INDEX, tmp);
	tmp = INREG(radeon, CLOCK_CNTL_DATA);
	OUTREG(radeon, CLOCK_CNTL_INDEX, save);
	USED(tmp);
}

static void
radeon_getbiosparams(Radeon*radeon)
{
	ulong addr;
	ushort offset, pib;
	uchar *bios;

	radeon-&gt;bios = nil;
	addr = 0xC0000;
	bios = (uchar *)readbios(0x10000, addr);
	if (bios[0] != 0x55 || bios[1] != 0xAA) {
		addr = 0xE0000;
		bios = (uchar *)readbios(0x10000, addr);
		if (bios[0] != 0x55 || bios[1] != 0xAA) {
			print("radeon: bios not found\n");
			return;
		}
	}

	radeon-&gt;bios = bios;
	offset = BIOS16(radeon, BIOS_START);

	pib = BIOS16(radeon, offset + 0x30);

	radeon-&gt;reference_freq	 = BIOS16(radeon, pib + 0x0e);
	radeon-&gt;reference_div	 = BIOS16(radeon, pib + 0x10);
	radeon-&gt;min_pll_freq	 = BIOS32(radeon, pib + 0x12);
	radeon-&gt;max_pll_freq	 = BIOS32(radeon, pib + 0x16);
	radeon-&gt;xclk		 = BIOS16(radeon, pib + 0x08);

	DBGPRINT("radeon: bios=0x%08ulx offset=0x%ux\n", addr, offset);
	DBGPRINT("radeon: pll_info_block: 0x%ux\n", pib);
	DBGPRINT("radeon: reference_freq: %ud\n", radeon-&gt;reference_freq);
	DBGPRINT("radeon: reference_div:  %ud\n", radeon-&gt;reference_div);
	DBGPRINT("radeon: min_pll_freq:   %uld\n", radeon-&gt;min_pll_freq);
	DBGPRINT("radeon: max_pll_freq:   %uld\n", radeon-&gt;max_pll_freq);
	DBGPRINT("radeon: xclk:           %ud\n", radeon-&gt;xclk);
}

static Pcidev *
radeonpci(int *isr300)
{
	static Pcidev * p = nil;
	struct pciids *ids;

	DBGPRINT("radeon: ATI Technologies Inc. Radeon [789]xxx drivers (v0.1)\n");
	while ((p = pcimatch(p, ATI_PCIVID, 0)) != nil)
		for (ids = radeon_pciids; ids-&gt;did; ids++)
			if (ids-&gt;did == p-&gt;did) {
				DBGPRINT("radeon: Found %s\n", ids-&gt;name);
				DBGPRINT("radeon: did:%04ux rid:%02ux\n",
					p-&gt;did, p-&gt;rid);
				if (isr300)
					*isr300 = ids-&gt;type == ATI_R300;
				return p;
			}
	DBGPRINT("radeon: not found!\n");
	return nil;
}

static void
vga_disable(Vga*vga)
{
	Ctlr *c;

	for (c = vga-&gt;link; c; c = c-&gt;link)
		if (strncmp(c-&gt;name, "vga", 3) == 0)
			c-&gt;load = nil;
}

static void
snarf(Vga *vga, Ctlr *ctlr)
{
	int isr300;
	ulong tmp;
	uintptr mmio;
	Pcidev *p;
	Radeon *radeon;

	if (vga-&gt;private == nil) {
		vga_disable(vga);

		vga-&gt;private = alloc(sizeof(Radeon));
		radeon = vga-&gt;private;

		p = radeonpci(&amp;isr300);
		if (p == nil)
			error("%s: not found\n", ctlr-&gt;name);

		vgactlw("type", ctlr-&gt;name);

		mmio = (uintptr)segattach(0, "radeonmmio", (void *)0,
			p-&gt;mem[2].size);
		if (mmio == ~0)
			error("%s: can't attach mmio segment\n", ctlr-&gt;name);

		DBGPRINT("radeon: mmio address: %08#p [size=%#x]\n",
			(void *)mmio, p-&gt;mem[2].size);

		radeon-&gt;pci = p;
		radeon-&gt;r300_workaround = isr300;
		radeon-&gt;mmio = mmio;
	}

	radeon = vga-&gt;private;
	radeon-&gt;fbsize = INREG(radeon, CONFIG_MEMSIZE);
	vga-&gt;vmz = radeon-&gt;fbsize;
	DBGPRINT("radeon: frame buffer size=%uld [%uldMB]\n",
		radeon-&gt;fbsize, radeon-&gt;fbsize / Mega);

	tmp = INREG(radeon, FP_GEN_CNTL);
	if (tmp &amp; FP_EN_TMDS)
		radeon-&gt;display_type = DISPLAY_FP;
	else
		radeon-&gt;display_type = DISPLAY_CRT;

	DBGPRINT("radeon: display type: %s\n",
		radeon-&gt;display_type == DISPLAY_CRT? "CRT": "FLAT PANEL");

	if (radeon-&gt;display_type != DISPLAY_CRT)
		error("unsupported NON CRT Display\n");

	radeon_getbiosparams(radeon);
	radeon-&gt;bus_cntl = INREG(radeon, BUS_CNTL);
	DBGPRINT("radeon: PPLL_CNTL=0x%08ulx\n", INPLL(radeon, PPLL_CNTL));
	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr*ctlr)
{
	ctlr-&gt;flag |= Hlinear | Foptions;
}

static int
radeondiv(int n, int d)
{
	return (n + d/2) / d;
}

static void
radeon_init_common_registers(Radeon*radeon)
{
	radeon-&gt;ovr_clr		= 0;
	radeon-&gt;ovr_wid_left_right	= 0;
	radeon-&gt;ovr_wid_top_bottom	= 0;
	radeon-&gt;ov0_scale_cntl	= 0;
	radeon-&gt;subpic_cntl	= 0;
	radeon-&gt;viph_control	= 0;
	radeon-&gt;i2c_cntl_1	= 0;
	radeon-&gt;rbbm_soft_reset	= 0;
	radeon-&gt;cap0_trig_cntl	= 0;
	radeon-&gt;cap1_trig_cntl	= 0;
	if (radeon-&gt;bus_cntl &amp; BUS_READ_BURST)
		radeon-&gt;bus_cntl |= BUS_RD_DISCARD_EN;
}

static void
radeon_init_crtc_registers(Radeon*radeon, Mode*mode)
{
	int format, dac6bit, hsync_wid, vsync_wid, hsync_start, hsync_fudge;
	int bpp;
	static int hsync_fudge_default[] = {
		0x00, 0x12, 0x09, 0x09, 0x06, 0x05,
	};

	format = 0;
	bpp = 0;
	dac6bit = 0;
	switch (mode-&gt;z) {
	case 6:
		format = 2;
		dac6bit = 1;
		bpp =  8;
		break;
	case 8:
		format = 2;
		dac6bit = 0;
		bpp =  8;
		break;
	case 15:
		format = 3;
		dac6bit = 0;
		bpp = 16;
		break;
	case 16:
		format = 4;
		dac6bit = 0;
		bpp = 16;
		break;
	case 24:
		format = 5;
		dac6bit = 0;
		bpp = 24;
		break;
	case 32:
		format = 6;
		dac6bit = 0;
		bpp = 32;
		break;
	default:
		error("radeon: unsupported mode depth %d\n", mode-&gt;z);
	}
	hsync_fudge = hsync_fudge_default[format-1];

	DBGPRINT("mode-&gt;z = %d (format = %d, bpp = %d, dac6bit = %s)\n",
		mode-&gt;z, format, bpp, dac6bit? "true": "false");

	radeon-&gt;crtc_gen_cntl = CRTC_EN | CRTC_EXT_DISP_EN | format &lt;&lt; 8 |
		(mode-&gt;interlace? CRTC_INTERLACE_EN: 0);
	radeon-&gt;crtc_ext_cntl = VGA_ATI_LINEAR | XCRT_CNT_EN | CRTC_CRT_ON;
	radeon-&gt;dac_cntl = DAC_MASK_ALL | DAC_VGA_ADR_EN |
		(dac6bit? 0: DAC_8BIT_EN);

	radeon-&gt;crtc_h_total_disp = ((mode-&gt;ht/8 - 1) &amp; 0x3ff) |
		((mode-&gt;x/8 - 1) &amp; 0x1ff) &lt;&lt; 16;

	hsync_wid = (mode-&gt;ehb - mode-&gt;shb) / 8;
	if (hsync_wid == 0)
		hsync_wid = 1;

	hsync_start = mode-&gt;shb - 8 + hsync_fudge;

	DBGPRINT("hsync_start=%d hsync_wid=%d hsync_fudge=%d\n",
		hsync_start, hsync_wid, hsync_fudge);

	radeon-&gt;crtc_h_sync_strt_wid = ((hsync_start &amp; 0x1fff) |
		(hsync_wid &amp; 0x3f) &lt;&lt; 16 | (mode-&gt;hsync? CRTC_H_SYNC_POL: 0));
	radeon-&gt;crtc_v_total_disp = ((mode-&gt;vt - 1) &amp; 0xffff) |
		(mode-&gt;y - 1) &lt;&lt; 16;

	vsync_wid = mode-&gt;vre - mode-&gt;vrs;
	if (!vsync_wid)
		vsync_wid = 1;

	radeon-&gt;crtc_v_sync_strt_wid = (((mode-&gt;vrs - 1) &amp; 0xfff) |
		(vsync_wid &amp; 0x1f) &lt;&lt; 16 | (mode-&gt;vsync? CRTC_V_SYNC_POL: 0));
	radeon-&gt;crtc_offset = 0;
	radeon-&gt;crtc_offset_cntl = INREG(radeon, CRTC_OFFSET_CNTL);
	radeon-&gt;crtc_pitch = (mode-&gt;x * bpp + bpp * 8 - 1) / (bpp * 8);
	radeon-&gt;crtc_pitch |= radeon-&gt;crtc_pitch &lt;&lt; 16;
}

struct divider {
	int	divider;
	int	bitvalue;
};

static void
radeon_init_pll_registers(Radeon*radeon, ulong freq)
{
	struct divider *post_div;
	static struct divider post_divs[] = {
		{ 1, 0 },
		{ 2, 1 },
		{ 4, 2 },
		{ 8, 3 },
		{ 3, 4 },
		{ 16, 5 },
		{ 6, 6 },
		{ 12, 7 },
		{ 0, 0 }
	};

	DBGPRINT("radeon: initpll: freq=%uld\n", freq);

	if (freq &gt; radeon-&gt;max_pll_freq)
		freq = radeon-&gt;max_pll_freq;
	if (freq * 12 &lt; radeon-&gt;min_pll_freq)
		freq = radeon-&gt;min_pll_freq / 12;

	for (post_div = &amp;post_divs[0]; post_div-&gt;divider; ++post_div) {
		radeon-&gt;pll_output_freq = post_div-&gt;divider * freq;
		if (radeon-&gt;pll_output_freq &gt;= radeon-&gt;min_pll_freq &amp;&amp;
		    radeon-&gt;pll_output_freq &lt;= radeon-&gt;max_pll_freq)
			break;
	}

	radeon-&gt;dot_clock_freq = freq;
	radeon-&gt;feedback_div = radeondiv(radeon-&gt;reference_div *
		radeon-&gt;pll_output_freq, radeon-&gt;reference_freq);
	radeon-&gt;post_div = post_div-&gt;divider;

	DBGPRINT("dc=%uld, of=%uld, fd=%uld, pd=%uld\n", radeon-&gt;dot_clock_freq,
		radeon-&gt;pll_output_freq, radeon-&gt;feedback_div, radeon-&gt;post_div);

	radeon-&gt;ppll_ref_div = radeon-&gt;reference_div;
	radeon-&gt;ppll_div_3 = radeon-&gt;feedback_div | post_div-&gt;bitvalue &lt;&lt; 16;
	radeon-&gt;htotal_cntl = 0;
	radeon-&gt;surface_cntl = 0;
}

static void
init(Vga*vga, Ctlr*ctlr)
{
	Radeon *radeon;
	Mode *mode;

	radeon	 = vga-&gt;private;
	mode	 = vga-&gt;mode;

	DBGPRINT("radeon: monitor type = '%s'\n", mode-&gt;type);
	DBGPRINT("radeon: size = '%s'\n", mode-&gt;size);
	DBGPRINT("radeon: chan = '%s'\n", mode-&gt;chan);
	DBGPRINT("radeon: freq=%d deffreq=%d x=%d y=%d z=%d\n",
		mode-&gt;frequency, mode-&gt;deffrequency, mode-&gt;x, mode-&gt;y, mode-&gt;z);
	DBGPRINT("radeon: ht=%d shb=%d ehb=%d shs=%d ehs=%d hsync='%c'\n",
		mode-&gt;ht, mode-&gt;shb, mode-&gt;ehb, mode-&gt;shs, mode-&gt;ehs,
		mode-&gt;hsync? mode-&gt;hsync: ' ');
	DBGPRINT("radeon: vt=%d vrs=%d vre=%d vsync='%c'\n",
		mode-&gt;vt, mode-&gt;vrs, mode-&gt;vre, mode-&gt;vsync? mode-&gt;vsync: ' ');

	radeon_init_common_registers(radeon);
	radeon_init_crtc_registers(radeon, mode);
	radeon_init_pll_registers(radeon, mode-&gt;frequency / 10000);
	ctlr-&gt;flag |= Finit | Ulinear;
}

static void
radeon_blank(Radeon*radeon)
{
	OUTREGP(radeon, CRTC_EXT_CNTL,
		  CRTC_DISPLAY_DIS | CRTC_VSYNC_DIS | CRTC_HSYNC_DIS,
		~(CRTC_DISPLAY_DIS | CRTC_VSYNC_DIS | CRTC_HSYNC_DIS));
}

static void
radeon_unblank(Radeon*radeon)
{
	OUTREGP(radeon, CRTC_EXT_CNTL, CRTC_CRT_ON,
		~(CRTC_DISPLAY_DIS | CRTC_VSYNC_DIS | CRTC_HSYNC_DIS));
}

static void
radeon_load_common_registers(Radeon*radeon)
{
	OUTREG(radeon, OVR_CLR, 		radeon-&gt;ovr_clr);
	OUTREG(radeon, OVR_WID_LEFT_RIGHT, 	radeon-&gt;ovr_wid_left_right);
	OUTREG(radeon, OVR_WID_TOP_BOTTOM, 	radeon-&gt;ovr_wid_top_bottom);
	OUTREG(radeon, OV0_SCALE_CNTL, 		radeon-&gt;ov0_scale_cntl);
	OUTREG(radeon, SUBPIC_CNTL, 		radeon-&gt;subpic_cntl);
	OUTREG(radeon, VIPH_CONTROL, 		radeon-&gt;viph_control);
	OUTREG(radeon, I2C_CNTL_1, 		radeon-&gt;i2c_cntl_1);
	OUTREG(radeon, GEN_INT_CNTL, 		radeon-&gt;gen_int_cntl);
	OUTREG(radeon, CAP0_TRIG_CNTL, 		radeon-&gt;cap0_trig_cntl);
	OUTREG(radeon, CAP1_TRIG_CNTL, 		radeon-&gt;cap1_trig_cntl);
	OUTREG(radeon, BUS_CNTL, 		radeon-&gt;bus_cntl);
	OUTREG(radeon, SURFACE_CNTL, 		radeon-&gt;surface_cntl);
}

static void
radeon_load_crtc_registers(Radeon*radeon)
{
	OUTREG(radeon, CRTC_GEN_CNTL, radeon-&gt;crtc_gen_cntl);
	OUTREGP(radeon, CRTC_EXT_CNTL, radeon-&gt;crtc_ext_cntl,
		CRTC_VSYNC_DIS | CRTC_HSYNC_DIS | CRTC_DISPLAY_DIS);
	OUTREGP(radeon, DAC_CNTL, radeon-&gt;dac_cntl,
		DAC_RANGE_CNTL | DAC_BLANKING);
	OUTREG(radeon, CRTC_H_TOTAL_DISP, 	radeon-&gt;crtc_h_total_disp);
	OUTREG(radeon, CRTC_H_SYNC_STRT_WID, 	radeon-&gt;crtc_h_sync_strt_wid);
	OUTREG(radeon, CRTC_V_TOTAL_DISP, 	radeon-&gt;crtc_v_total_disp);
	OUTREG(radeon, CRTC_V_SYNC_STRT_WID, 	radeon-&gt;crtc_v_sync_strt_wid);
	OUTREG(radeon, CRTC_OFFSET, 		radeon-&gt;crtc_offset);
	OUTREG(radeon, CRTC_OFFSET_CNTL, 	radeon-&gt;crtc_offset_cntl);
	OUTREG(radeon, CRTC_PITCH, 		radeon-&gt;crtc_pitch);
}

static void
radeon_pllwaitupd(Radeon*radeon)
{
	int i;

	for (i = 0; i &lt; 10000; i++)
		if (!(INPLL(radeon, PPLL_REF_DIV) &amp; PPLL_ATOMIC_UPDATE_R))
			break;
}

static void
radeon_pllwriteupd(Radeon*radeon)
{
	while (INPLL(radeon, PPLL_REF_DIV) &amp; PPLL_ATOMIC_UPDATE_R)
		;
	OUTPLLP(radeon, PPLL_REF_DIV, PPLL_ATOMIC_UPDATE_W, ~PPLL_ATOMIC_UPDATE_W);
}

static void
radeon_load_pll_registers(Radeon*radeon)
{
	OUTPLLP(radeon, VCLK_ECP_CNTL,
		VCLK_SRC_SEL_CPUCLK, ~VCLK_SRC_SEL_MASK);
	OUTPLLP(radeon, PPLL_CNTL,
	      PPLL_RESET | PPLL_ATOMIC_UPDATE_EN | PPLL_VGA_ATOMIC_UPDATE_EN,
	    ~(PPLL_RESET | PPLL_ATOMIC_UPDATE_EN | PPLL_VGA_ATOMIC_UPDATE_EN));
	OUTREGP(radeon, CLOCK_CNTL_INDEX, PLL_DIV_SEL, ~PLL_DIV_SEL);
	if (radeon-&gt;r300_workaround) {
		DBGPRINT("r300_workaround\n");
		if (radeon-&gt;ppll_ref_div &amp; R300_PPLL_REF_DIV_ACC_MASK)
			/*
			 * When restoring console mode, use saved PPLL_REF_DIV
			 * setting.
			 */
			OUTPLLP(radeon, PPLL_REF_DIV, radeon-&gt;ppll_ref_div, 0);
		else
			/* R300 uses ref_div_acc field as real ref divider */
			OUTPLLP(radeon, PPLL_REF_DIV,
			    radeon-&gt;ppll_ref_div &lt;&lt; R300_PPLL_REF_DIV_ACC_SHIFT,
				~R300_PPLL_REF_DIV_ACC_MASK);
	} else
		OUTPLLP(radeon, PPLL_REF_DIV, radeon-&gt;ppll_ref_div,
			~PPLL_REF_DIV_MASK);

	OUTPLLP(radeon, PPLL_DIV_3, radeon-&gt;ppll_div_3, ~PPLL_FB3_DIV_MASK);
	OUTPLLP(radeon, PPLL_DIV_3, radeon-&gt;ppll_div_3, ~PPLL_POST3_DIV_MASK);

	radeon_pllwriteupd(radeon);
	radeon_pllwaitupd(radeon);

	OUTPLL(radeon, HTOTAL_CNTL, radeon-&gt;htotal_cntl);
	OUTPLLP(radeon, PPLL_CNTL, 0,
		~(PPLL_RESET | PPLL_SLEEP | PPLL_ATOMIC_UPDATE_EN |
		  PPLL_VGA_ATOMIC_UPDATE_EN));

	if (debug) {
		Bprint(&amp;stdout, "Wrote: 0x%08ulx 0x%08ulx 0x%08ulx (0x%08ulx)\n",
			radeon-&gt;ppll_ref_div, radeon-&gt;ppll_div_3,
			radeon-&gt;htotal_cntl, INPLL(radeon, PPLL_CNTL));
		Bprint(&amp;stdout, "Wrote: rd=%uld, fd=%uld, pd=%uld\n",
			radeon-&gt;ppll_ref_div &amp; PPLL_REF_DIV_MASK,
			radeon-&gt;ppll_div_3 &amp; PPLL_FB3_DIV_MASK,
			(radeon-&gt;ppll_div_3 &amp; PPLL_POST3_DIV_MASK) &gt;&gt; 16);
	}

	/* Let the clock to lock */
	sleep(5);

	OUTPLLP(radeon, VCLK_ECP_CNTL, VCLK_SRC_SEL_PPLLCLK, ~VCLK_SRC_SEL_MASK);
}

static void
load(Vga*vga, Ctlr*ctlr)
{
	Radeon *radeon;

	radeon = (Radeon *) vga-&gt;private;
	radeon_blank(radeon);
	radeon_load_common_registers(radeon);
	radeon_load_crtc_registers(radeon);
	radeon_load_pll_registers(radeon);
	radeon_unblank(radeon);

	/* init palette [gamma] */
	if (vga-&gt;mode-&gt;z &gt; 8) {
		int i;

		OUTREG(radeon, PALETTE_INDEX, 0);
		for (i = 0; i &lt; 256; i++)
			OUTREG(radeon, PALETTE_DATA, i &lt;&lt; 16 | i &lt;&lt; 8 | i);
	}

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga*vga, Ctlr*ctlr)
{
	Radeon *radeon;

	USED(ctlr);
	radeon = (Radeon *)vga-&gt;private;
	USED(radeon);
}

Ctlr radeon = {
	"radeon",
	snarf,
	options,
	init,
	load,
	dump,
};
Ctlr radeonhwgc = {
	"radeonhwgc",
	0, 					/* snarf */
	0, 					/* options */
	0, 					/* init */
	0, 					/* load */
	0, 					/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

