<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/rgb524.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/rgb524.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * IBM RGB524.
 * 170/220MHz High Performance Palette DAC.
 *
 * Assumes hooked up to an S3 Vision96[48].
 */
enum {
	IndexLo		= 0x00,
	IndexHi		= 0x01,
	Data		= 0x02,
	IndexCtl	= 0x03,
};

enum {						/* index registers */
	MiscClock	= 0x02,
	PixelFormat	= 0x0A,
	PLLControl1	= 0x10,
	PLLControl2	= 0x11,
	PLLReference	= 0x14,
	Frequency0	= 0x20,
	MiscControl1	= 0x70,
	MiscControl2	= 0x71,
};

static uchar
setrs2(void)
{
	uchar rs2;

	rs2 = vgaxi(Crtx, 0x55);
	vgaxo(Crtx, 0x55, (rs2 &amp; 0xFC)|0x01);

	return rs2;
}

static uchar
rgb524xi(int index)
{
	outportb(dacxreg[IndexLo], index &amp; 0xFF);
	outportb(dacxreg[IndexHi], (index&gt;&gt;8) &amp; 0xFF);

	return inportb(dacxreg[Data]);
}

static void
rgb524xo(int index, uchar data)
{
	outportb(dacxreg[IndexLo], index &amp; 0xFF);
	outportb(dacxreg[IndexHi], (index&gt;&gt;8) &amp; 0xFF);

	outportb(dacxreg[Data], data);
}

static void
restorers2(uchar rs2)
{
	vgaxo(Crtx, 0x55, rs2);
}

static void
clock(Vga* vga, Ctlr* ctlr)
{
	if(vga-&gt;f[0] &gt;= 16250000 &amp;&amp; vga-&gt;f[0] &lt;= 32000000){
		vga-&gt;f[0] = (vga-&gt;f[0]/250000)*250000;
		vga-&gt;d[0] = (4*vga-&gt;f[0])/1000000 - 65;
	}
	else if(vga-&gt;f[0] &gt;= 32500000 &amp;&amp; vga-&gt;f[0] &lt;= 64000000){
		vga-&gt;f[0] = (vga-&gt;f[0]/500000)*500000;
		vga-&gt;d[0] = 0x40|((2*vga-&gt;f[0])/1000000 - 65);
	}
	else if(vga-&gt;f[0] &gt;= 65000000 &amp;&amp; vga-&gt;f[0] &lt;= 128000000){
		vga-&gt;f[0] = (vga-&gt;f[0]/1000000)*1000000;
		vga-&gt;d[0] = 0x80|(vga-&gt;f[0]/1000000 - 65);
	}
	else if(vga-&gt;f[0] &gt;= 130000000 &amp;&amp; vga-&gt;f[0] &lt;= 220000000){
		vga-&gt;f[0] = (vga-&gt;f[0]/2000000)*2000000;
		vga-&gt;d[0] = 0xC0|((vga-&gt;f[0]/2)/1000000 - 65);
	}
	else
		error("%s: pclk %lud out of range\n",
			ctlr-&gt;name, vga-&gt;f[0]);
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong pclk;
	char *p;

	/*
	 * Part comes in -170 and -220MHz speed-grades.
	 */
	pclk = 170000000;
	if(p = strrchr(ctlr-&gt;name, '-'))
		pclk = strtoul(p+1, 0, 0) * 1000000;

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 * Check it's within range.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &gt; pclk)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);

	/*
	 * Determine whether to use clock-doubler or not.
	 */
	if((ctlr-&gt;flag &amp; Uclk2) == 0 &amp;&amp; vga-&gt;mode-&gt;z == 8)
		resyncinit(vga, ctlr, Uclk2, 0);

	/*
	 * Clock bits. If the desired video clock is
	 * one of the two standard VGA clocks it can just be
	 * set using bits &lt;3:2&gt; of vga-&gt;misc, otherwise we
	 * need to programme the PLL.
	 */
	vga-&gt;misc &amp;= ~0x0C;
	if(vga-&gt;mode-&gt;z == 8 || (vga-&gt;f[0] != VgaFreq0 &amp;&amp; vga-&gt;f[0] != VgaFreq1)){
		/*
		 * Initialise the PLL parameters.
		 * Use internal FS3 fixed-reference divider.
		 */
		clock(vga, ctlr);
		vga-&gt;i[0] = 0x03;
	}
	else if(vga-&gt;f[0] == VgaFreq0)
		vga-&gt;i[0] = 0;
	else if(vga-&gt;f[0] == VgaFreq1){
		vga-&gt;misc |= 0x04;
		vga-&gt;i[0] = 1;
	}

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	uchar mc2, rs2, x;
	char *val;
	int f;

	rs2 = setrs2();

	/*
	 * Set VgaFreq[01].
	 */
	rgb524xo(PLLControl1, 0x00);
	rgb524xo(Frequency0, 0x24);
	rgb524xo(Frequency0+1, 0x30);

	if(val = dbattr(vga-&gt;attr, "rgb524refclk")){
		f = strtol(val, 0, 0);
		if(f &gt; 1000000)
			f /= 1000000;
		rgb524xo(PLLReference, f/2);
	}
		
	/*
	 * Enable pixel programming and clock divide
	 * factor.
	 */
	x = rgb524xi(MiscClock) &amp; ~0x0E;
	x |= 0x01;
	if(ctlr-&gt;flag &amp; Uclk2)
		x |= 0x02;
	rgb524xo(MiscClock, x);

	if(vga-&gt;mode-&gt;z == 1)
		rgb524xo(PixelFormat, 0x02);
	else if(vga-&gt;mode-&gt;z == 8)
		rgb524xo(PixelFormat, 0x03);

	x = rgb524xi(MiscControl1) &amp; ~0x41;
	x |= 0x01;
	rgb524xo(MiscControl1, x);

	mc2 = rgb524xi(MiscControl2) &amp; ~0x41;
	vga-&gt;crt[0x22] &amp;= ~0x08;
	if(vga-&gt;i[0] == 3){
		rgb524xo(Frequency0+3, vga-&gt;d[0]);
		rgb524xo(PLLControl1, 0x02);
		rgb524xo(PLLControl2, vga-&gt;i[0]);
		mc2 |= 0x41;
		vga-&gt;crt[0x22] |= 0x08;
	}
	rgb524xo(MiscControl2, mc2);
	vgaxo(Crtx, 0x22, vga-&gt;crt[0x22]);

	restorers2(rs2);
	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga*, Ctlr* ctlr)
{
	uchar rs2, r, x[256];
	char buf[32];
	int df, i, maxf, vcodc, vf;

	rs2 = setrs2();
	printitem(ctlr-&gt;name, "index00");
	for(i = 0x00; i &lt; 0x0F; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index10");
	for(i = 0x10; i &lt; 0x17; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index20");
	for(i = 0x20; i &lt; 0x30; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index30");
	for(i = 0x30; i &lt; 0x37; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index40");
	for(i = 0x40; i &lt; 0x49; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index60");
	for(i = 0x60; i &lt; 0x63; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index70");
	for(i = 0x70; i &lt; 0x73; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index8E");
	for(i = 0x8E; i &lt; 0x92; i++){
		x[i] = rgb524xi(i);
		printreg(x[i]);
	}
	restorers2(rs2);

	/*
	 * x[0x10]	pixel clock frequency selection
	 *		0, 2 for direct programming
	 * x[0x20-0x2F]	pixel frequency 0-15
	 */
	printitem(ctlr-&gt;name, "refclk");
	Bprint(&amp;stdout, "%12ud\n", x[PLLReference]*2*1000000);
	if((i = (x[0x10] &amp; 0x07)) == 0x00 || i == 0x02){
		/*
		 * Direct programming, external frequency select.
		 * F[0-4] are probably tied directly to the 2 clock-select
		 * bits in the VGA Misc register.
		 */
		if(i == 0)
			maxf = 4;
		else
			maxf = 16;
		for(i = 0; i &lt; maxf; i++){
			if((r = x[0x20+i]) == 0)
				continue;
			sprint(buf, "direct F%X", i);
			printitem(ctlr-&gt;name, buf);
			df = (r&gt;&gt;6) &amp; 0x03;
			vcodc = r &amp; 0x3F;

			vf = 0;
			switch(df){
			case 0:
				vf = (vcodc+65)/4;
				break;

			case 1:
				vf = (vcodc+65)/2;
				break;

			case 2:
				vf = (vcodc+65);
				break;

			case 3:
				vf = (vcodc+65)*2;
				break;
			}
			Bprint(&amp;stdout, "%12ud\n", vf);
		}
	}
}

Ctlr rgb524 = {
	"rgb524",			/* name */
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

