<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/rgb524mn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/rgb524mn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * IBM RGB52x and compatibles.
 * High Performance Palette DAC.
 */
uchar (*rgb524mnxi)(Vga*, int);
void (*rgb524mnxo)(Vga*, int, uchar);

enum {						/* index registers */
	MiscClock	= 0x02,
	SyncControl	= 0x03,
	HSyncControl	= 0x04,
	PowerMgmnt	= 0x05,
	PaletteControl	= 0x07,
	SYSCLKControl	= 0x08,
	PixelFormat	= 0x0A,
	Pixel8Control	= 0x0B,
	Pixel16Control	= 0x0C,
	Pixel32Control	= 0x0E,
	PLLControl1	= 0x10,
	PLLControl2	= 0x11,
	SYSCLKN		= 0x15,
	SYSCLKM		= 0x16,
	M0		= 0x20,
	N0		= 0x21,
	MiscControl1	= 0x70,
	MiscControl2	= 0x71,
};

static void
clock(Vga* vga, Ctlr*, ulong fref, ulong maxpclk)
{
	int d, mind;
	ulong df, f, m, n, vrf;

	mind = vga-&gt;f[0]+1;
	for(df = 0; df &lt; 4; df++){
		for(m = 2; m &lt; 64; m++){
			for(n = 2; n &lt; 32; n++){
				f = (fref*(m+65))/n;
				switch(df){
				case 0:
					vrf = fref/(n*2);
					if(vrf &gt; maxpclk/4 || vrf &lt; 1000000)
						continue;
					f /= 8;
					break;
				case 1:
					vrf = fref/(n*2);
					if(vrf &gt; maxpclk/2 || vrf &lt; 1000000)
						continue;
					f /= 4;
					break;
				case 2:
					vrf = fref/(n*2);
					if(vrf &gt; maxpclk || vrf &lt; 1000000)
						continue;
					f /= 2;
					break;
				case 3:
					vrf = fref/n;
					if(vrf &gt; maxpclk || vrf &lt; 1000000)
						continue;
					break;
				}
				if(f &gt; maxpclk)
					continue;

				d = vga-&gt;f[0] - f;
				if(d &lt; 0)
					d = -d;
				if(d &lt;= mind){
					vga-&gt;m[0] = m;
					vga-&gt;n[0] = n;
					vga-&gt;d[0] = df;
					mind = d;
				}
			}
		}
	}
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong fref, maxpclk;
	char *p, *val;

	/*
	 * Part comes in at least a -170MHz speed-grade.
	 */
	maxpclk = 170000000;
	if(p = strrchr(ctlr-&gt;name, '-'))
		maxpclk = strtoul(p+1, 0, 0) * 1000000;

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 * Check it's within range.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &gt; maxpclk)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);
	if(val = dbattr(vga-&gt;attr, "rgb524mnrefclk"))
		fref = strtol(val, 0, 0);
	else
		fref = RefFreq;

	/*
	 * Initialise the PLL parameters.
	 * Use m/n pair 2.
	 */
	clock(vga, ctlr, fref, maxpclk);
	vga-&gt;i[0] = 2;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	char *val;
	int hsyncdelay, x;

	if(rgb524mnxi == nil &amp;&amp; rgb524mnxo == nil)
		error("%s-&gt;load: no access routines\n", ctlr-&gt;name);
		
	/*
	 * Set the m/n values for the desired frequency and
	 * set pixel control to use compatibility mode with
	 * internal frequency select using the specified set
	 * of m/n registers.
	 */
	rgb524mnxo(vga, M0+vga-&gt;i[0]*2, vga-&gt;d[0]&lt;&lt;6|vga-&gt;m[0]);
	rgb524mnxo(vga, N0+vga-&gt;i[0]*2, vga-&gt;n[0]);
	rgb524mnxo(vga, PLLControl2, vga-&gt;i[0]);
	rgb524mnxo(vga, PLLControl1, 0x03);

	/*
	 * Enable pixel programming in MiscClock;
	 * nothing to do in MiscControl1;
	 * set internal PLL clock and !vga in MiscControl2;
	 */
	x = rgb524mnxi(vga, MiscClock) &amp; ~0x01;
	x |= 0x01;
	rgb524mnxo(vga, MiscClock, x);

	x = rgb524mnxi(vga, MiscControl2) &amp; ~0x41;
	x |= 0x41;
	rgb524mnxo(vga, MiscControl2, x);

	/*
	 * Syncs.
	 */
	x = 0;
	if(vga-&gt;mode-&gt;hsync == '+')
		x |= 0x10;
	if(vga-&gt;mode-&gt;vsync == '+')
		x |= 0x20;
	rgb524mnxo(vga, SyncControl, x);
	if(val = dbattr(vga-&gt;mode-&gt;attr, "hsyncdelay"))
		hsyncdelay = strtol(val, 0, 0);
	else switch(vga-&gt;mode-&gt;z){
	default:
	case 8:
		hsyncdelay = 1;
		break;
	case 15:
	case 16:
		hsyncdelay = 5;
		break;
	case 32:
		hsyncdelay = 7;
		break;
	}
	rgb524mnxo(vga, HSyncControl, hsyncdelay);

rgb524mnxo(vga, SYSCLKM, 0x50);
rgb524mnxo(vga, SYSCLKN, 0x08);
sleep(50);
//rgb524mnxo(vga, SYSCLKM, 0x6F);
//rgb524mnxo(vga, SYSCLKN, 0x0F);
//sleep(500);

	/*
	 * Set the palette for the desired format.
	 * ****NEEDS WORK FOR OTHER THAN 8-BITS****
	 */
	rgb524mnxo(vga, PaletteControl, 0x00);
	switch(vga-&gt;mode-&gt;z){
	case 8:
		rgb524mnxo(vga, PixelFormat, 0x03);
		rgb524mnxo(vga, Pixel8Control, 0x00);
		break;
	case 15:
		rgb524mnxo(vga, PixelFormat, 0x04);
		rgb524mnxo(vga, Pixel16Control, 0xC4);
	case 16:
		rgb524mnxo(vga, PixelFormat, 0x04);
		rgb524mnxo(vga, Pixel16Control, 0xC6);
		break;
	case 32:
		rgb524mnxo(vga, PixelFormat, 0x06);
		rgb524mnxo(vga, Pixel32Control, 0x03);
		break;
	}
}

static void
dumpclock(Vga*, Ctlr* ctlr, ulong fref, ulong m, ulong n, char* name)
{
	ulong df, f;

	df = (m&gt;&gt;6) &amp; 0x03;
	m &amp;= 0x3F;
	n &amp;= 0x1F;
	if(m == 0 || n == 0)
		return;
	f = (fref*(m+65))/n;
	switch(df){
	case 0:
		f /= 8;
		break;
	case 1:
		f /= 4;
		break;
	case 2:
		f /= 2;
		break;
	case 3:
		break;
	}
	printitem(ctlr-&gt;name, name);
	Bprint(&amp;stdout, "%12lud\n", f);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char *val;
	uchar x[256];
	ulong fref, fs;

	if(rgb524mnxi == nil &amp;&amp; rgb524mnxo == nil)
		error("%s-&gt;dump: no access routines\n", ctlr-&gt;name);

	printitem(ctlr-&gt;name, "index00");
	for(i = 0x00; i &lt; 0x0F; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index10");
	for(i = 0x10; i &lt; 0x18; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index20");
	for(i = 0x20; i &lt; 0x30; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index30");
	for(i = 0x30; i &lt; 0x39; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index40");
	for(i = 0x40; i &lt; 0x49; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index60");
	for(i = 0x60; i &lt; 0x63; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index70");
	for(i = 0x70; i &lt; 0x73; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}
	printitem(ctlr-&gt;name, "index8E");
	for(i = 0x8E; i &lt; 0x92; i++){
		x[i] = rgb524mnxi(vga, i);
		printreg(x[i]);
	}

	if(val = dbattr(vga-&gt;attr, "rgb524mnrefclk"))
		fref = strtol(val, 0, 0);
	else
		fref = RefFreq;
	if(!(x[SYSCLKControl] &amp; 0x04))
		dumpclock(vga, ctlr, fref, x[0x16], x[0x15], "sysclk");
	fs = x[PLLControl1] &amp; 0x07;
	if(fs == 0x01 || fs == 0x03){
		if(fs == 0x01)
			i = ((vga-&gt;misc&gt;&gt;2) &amp; 0x03)*2;
		else
			i = x[PLLControl2] &amp; 0x07;
		dumpclock(vga, ctlr, fref, x[M0+i*2], x[N0+i*2], "pllclk");
	}
}

Ctlr rgb524mn = {
	"rgb524mn",			/* name */
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

