<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/s3928.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/s3928.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * S3 86C928 GUI Accelerator.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	s3generic.snarf(vga, ctlr);
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Henhanced|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	ulong x;

	/*
	 * s3generic.init() will perform the same test.
	 * We need to do it here too so that the Crt registers
	 * will be correct when s3generic.init() calculates
	 * the overflow bits.
	 */
	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	mode = vga-&gt;mode;
	if((ctlr-&gt;flag &amp; Henhanced) &amp;&amp; mode-&gt;x &gt;= 1024 &amp;&amp; mode-&gt;z == 8){
		resyncinit(vga, ctlr, Uenhanced, 0);
		vga-&gt;crt[0x00] = ((mode-&gt;ht/4)&gt;&gt;3)-5;
		vga-&gt;crt[0x01] = ((mode-&gt;x/4)&gt;&gt;3)-1;
		vga-&gt;crt[0x02] = ((mode-&gt;shb/4)&gt;&gt;3)-1;
	
		x = (mode-&gt;ehb/4)&gt;&gt;3;
		vga-&gt;crt[0x03] = 0x80|(x &amp; 0x1F);
		vga-&gt;crt[0x04] = (mode-&gt;shs/4)&gt;&gt;3;
		vga-&gt;crt[0x05] = ((mode-&gt;ehs/4)&gt;&gt;3) &amp; 0x1F;
		if(x &amp; 0x20)
			vga-&gt;crt[0x05] |= 0x80;

		vga-&gt;crt[0x13] = mode-&gt;x/8;
		if(mode-&gt;z == 1)
			vga-&gt;crt[0x13] /= 8;
	}
	s3generic.init(vga, ctlr);
	vga-&gt;crt[0x3B] = (vga-&gt;crt[0]+vga-&gt;crt[4]+1)/2;

	/*
	 * Set up write-posting and read-ahead-cache.
	 */
	vga-&gt;crt[0x54] = 0xA7;
	if(ctlr-&gt;flag &amp; Uenhanced){
		vga-&gt;crt[0x58] |= 0x04;
		vga-&gt;crt[0x40] |= 0x08;
	}
	else{
		vga-&gt;crt[0x58] &amp;= ~0x04;
		vga-&gt;crt[0x40] &amp;= ~0x08;
	}

	/*
	 * Set up parallel VRAM and the external
	 * SID enable on the 86C928
	 */
	vga-&gt;crt[0x53] &amp;= ~0x20;			/* parallel VRAM */
	vga-&gt;crt[0x55] &amp;= ~0x48;			/* external SID */
	vga-&gt;crt[0x65] &amp;= ~0x60;			/* 2 86C928 E-step chip bugs */
	if(ctlr-&gt;flag &amp; Uenhanced){
		if(vga-&gt;ramdac-&gt;flag &amp; Hpvram)
			vga-&gt;crt[0x53] |= 0x20;
		if(vga-&gt;ramdac-&gt;flag &amp; Hextsid)
			vga-&gt;crt[0x55] |= 0x48;
		vga-&gt;crt[0x65] |= 0x60;
	}
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ushort advfunc;

	(*s3generic.load)(vga, ctlr);
	vgaxo(Crtx, 0x65, vga-&gt;crt[0x65]);

	advfunc = 0x0000;
	if(ctlr-&gt;flag &amp; Uenhanced){
		if(vga-&gt;mode-&gt;x == 1024 || vga-&gt;mode-&gt;x == 800)
			advfunc = 0x0057;
		else
			advfunc = 0x0053;
	}
	outportw(0x4AE8, advfunc);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	(*s3generic.dump)(vga, ctlr);
}

Ctlr s3928 = {
	"s3928",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

