<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/s3generic.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/s3generic.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Generic S3 GUI Accelerator.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;

	trace("%s-&gt;snarf-&gt;s3generic\n", ctlr-&gt;name);

	/*
	 * Unlock extended registers.
	 * 0xA5 ensures Crt36 and Crt37 are also unlocked
	 * (0xA0 unlocks everything else).
	 */
	vgaxo(Crtx, 0x38, 0x48);
	vgaxo(Crtx, 0x39, 0xA5);

	/*
	 * Not all registers exist on all chips.
	 * Crt3[EF] don't exist on any.
	 */
	for(i = 0x30; i &lt; 0x70; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);

	/*
	 * Memory size.
	 */
	switch((vga-&gt;crt[0x36]&gt;&gt;5) &amp; 0x07){

	case 0x00:
		vga-&gt;vmz = 4*1024*1024;
		break;

	case 0x02:
		vga-&gt;vmz = 3*1024*1024;
		break;

	case 0x04:
		vga-&gt;vmz = 2*1024*1024;
		break;

	case 0x06:
		vga-&gt;vmz = 1*1024*1024;
		break;

	case 0x07:
		vga-&gt;vmz = 512*1024;
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	ulong x;

	trace("%s-&gt;init-&gt;s3generic\n", ctlr-&gt;name);
	mode = vga-&gt;mode;

	/*
	 * Is enhanced mode is necessary?
	 */
	if((ctlr-&gt;flag &amp; (Uenhanced|Henhanced)) == Henhanced){
		if(mode-&gt;z &gt;= 8)
			resyncinit(vga, ctlr, Uenhanced, 0);
		else
			resyncinit(vga, ctlr, 0, Uenhanced|Henhanced);
	}
	if((ctlr-&gt;flag &amp; Uenhanced) == 0 &amp;&amp; mode-&gt;x &gt; 1024)
		error("%s: no support for 1-bit mode &gt; 1024x768x1\n", ctlr-&gt;name);

	vga-&gt;crt[0x31] = 0x85;
	vga-&gt;crt[0x6A] &amp;= 0xC0;
	vga-&gt;crt[0x32] &amp;= ~0x40;

	vga-&gt;crt[0x31] |= 0x08;
	vga-&gt;crt[0x32] |= 0x40;

	vga-&gt;crt[0x33] |= 0x20;
	if(mode-&gt;z &gt;= 8)
		vga-&gt;crt[0x3A] |= 0x10;
	else
		vga-&gt;crt[0x3A] &amp;= ~0x10;

	vga-&gt;crt[0x34] = 0x10;
	vga-&gt;crt[0x35] = 0x00;
	if(mode-&gt;interlace){
		vga-&gt;crt[0x3C] = vga-&gt;crt[0]/2;
		vga-&gt;crt[0x42] |= 0x20;
	}
	else{
		vga-&gt;crt[0x3C] = 0x00;
		vga-&gt;crt[0x42] &amp;= ~0x20;
	}

	vga-&gt;crt[0x40] = (vga-&gt;crt[0x40] &amp; 0xF2);
	vga-&gt;crt[0x43] = 0x00;
	vga-&gt;crt[0x45] = 0x00;

	vga-&gt;crt[0x50] &amp;= 0x3E;
	if(mode-&gt;x &lt;= 640)
		x = 0x40;
	else if(mode-&gt;x &lt;= 800)
		x = 0x80;
	else if(mode-&gt;x &lt;= 1024)
		x = 0x00;
	else if(mode-&gt;x &lt;= 1152)
		x = 0x01;
	else if(mode-&gt;x &lt;= 1280)
		x = 0xC0;
	else
		x = 0x81;
	vga-&gt;crt[0x50] |= x;

	vga-&gt;crt[0x51] = (vga-&gt;crt[0x51] &amp; 0xC3)|((vga-&gt;crt[0x13]&gt;&gt;4) &amp; 0x30);
	vga-&gt;crt[0x53] &amp;= ~0x10;

	/*
	 * Set up linear aperture. For the moment it's 64K at 0xA0000.
	 * The real base address will be assigned before load is called.
	 */
	vga-&gt;crt[0x58] = 0x88;
	if(ctlr-&gt;flag &amp; Uenhanced){
		vga-&gt;crt[0x58] |= 0x10;
		if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
			ctlr-&gt;flag |= Ulinear;
		if(vga-&gt;vmz &lt;= 1024*1024)
			vga-&gt;vma = 1024*1024;
		else if(vga-&gt;vmz &lt;= 2*1024*1024)
			vga-&gt;vma = 2*1024*1024;
		else
			vga-&gt;vma = 8*1024*1024;
	}
	vga-&gt;crt[0x59] = 0x00;
	vga-&gt;crt[0x5A] = 0x0A;

	vga-&gt;crt[0x5D] &amp;= 0x80;
	if(vga-&gt;crt[0x00] &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x01;
	if(vga-&gt;crt[0x01] &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x02;
	if(vga-&gt;crt[0x02] &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x04;
	if(vga-&gt;crt[0x04] &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x10;
	if(vga-&gt;crt[0x3B] &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x40;

	vga-&gt;crt[0x5E] = 0x40;
	if(vga-&gt;crt[0x06] &amp; 0x400)
		vga-&gt;crt[0x5E] |= 0x01;
	if(vga-&gt;crt[0x12] &amp; 0x400)
		vga-&gt;crt[0x5E] |= 0x02;
	if(vga-&gt;crt[0x15] &amp; 0x400)
		vga-&gt;crt[0x5E] |= 0x04;
	if(vga-&gt;crt[0x10] &amp; 0x400)
		vga-&gt;crt[0x5E] |= 0x10;

	ctlr-&gt;type = s3generic.name;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ulong l;

	trace("%s-&gt;load-&gt;s3generic\n", ctlr-&gt;name);

	vgaxo(Crtx, 0x31, vga-&gt;crt[0x31]);
	vgaxo(Crtx, 0x32, vga-&gt;crt[0x32]);
	vgaxo(Crtx, 0x33, vga-&gt;crt[0x33]);
	vgaxo(Crtx, 0x34, vga-&gt;crt[0x34]);
	vgaxo(Crtx, 0x35, vga-&gt;crt[0x35]);
	vgaxo(Crtx, 0x3A, vga-&gt;crt[0x3A]);
	vgaxo(Crtx, 0x3B, vga-&gt;crt[0x3B]);
	vgaxo(Crtx, 0x3C, vga-&gt;crt[0x3C]);

	vgaxo(Crtx, 0x40, vga-&gt;crt[0x40]|0x01);
	vgaxo(Crtx, 0x42, vga-&gt;crt[0x42]);
	vgaxo(Crtx, 0x43, vga-&gt;crt[0x43]);
	vgaxo(Crtx, 0x45, vga-&gt;crt[0x45]);

	vgaxo(Crtx, 0x50, vga-&gt;crt[0x50]);
	vgaxo(Crtx, 0x51, vga-&gt;crt[0x51]);
	vgaxo(Crtx, 0x53, vga-&gt;crt[0x53]);
	vgaxo(Crtx, 0x54, vga-&gt;crt[0x54]);
	vgaxo(Crtx, 0x55, vga-&gt;crt[0x55]);

	if(ctlr-&gt;flag &amp; Ulinear){
		l = vga-&gt;vmb&gt;&gt;16;
		vga-&gt;crt[0x59] = (l&gt;&gt;8) &amp; 0xFF;
		vga-&gt;crt[0x5A] = l &amp; 0xFF;
		if(vga-&gt;vmz &lt;= 1024*1024)
			vga-&gt;crt[0x58] |= 0x01;
		else if(vga-&gt;vmz &lt;= 2*1024*1024)
			vga-&gt;crt[0x58] |= 0x02;
		else
			vga-&gt;crt[0x58] |= 0x03;
	}
	vgaxo(Crtx, 0x59, vga-&gt;crt[0x59]);
	vgaxo(Crtx, 0x5A, vga-&gt;crt[0x5A]);
	vgaxo(Crtx, 0x58, vga-&gt;crt[0x58]);

	vgaxo(Crtx, 0x5D, vga-&gt;crt[0x5D]);
	vgaxo(Crtx, 0x5E, vga-&gt;crt[0x5E]);

	vgaxo(Crtx, 0x6A, vga-&gt;crt[0x6A]);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i, id, interlace, mul, div;
	char *name;
	ushort shb, vrs, x;

	name = ctlr-&gt;name;

	printitem(name, "Crt30");
	for(i = 0x30; i &lt; 0x3E; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Crt40");
	for(i = 0x40; i &lt; 0x50; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Crt50");
	for(i = 0x50; i &lt; 0x60; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Crt60");
	for(i = 0x60; i &lt; 0x70; i++)
		printreg(vga-&gt;crt[i]);

	/*
	 * Try to disassemble the snarfed values into
	 * understandable numbers.
	 * Only do this if we weren't called after Finit.
	 */
	if(ctlr-&gt;flag &amp; Finit)
		return;


	/*
	 * If hde &lt;= 400, assume this is a 928 or Vision964
	 * and the horizontal values have been divided by 4.
	 *
	 * if ViRGE/[DG]X and 15 or 16bpp, horizontal values have
	 * been multiplied by 2.
	 */
	mul = 1;
	div = 1;

	if(strcmp(name, "virge") == 0){
		id = (vga-&gt;crt[0x2D]&lt;&lt;8)|vga-&gt;crt[0x2E];
		/* S3 ViRGE/[DG]X */
		if(id==0x8A01 &amp;&amp; ((vga-&gt;crt[0x67] &amp; 0x30) || (vga-&gt;crt[0x67] &amp; 0x50))){
			mul = 1;
			div = 2;
		}
	}

	x = vga-&gt;crt[0x01];
	if(vga-&gt;crt[0x5D] &amp; 0x02)
		x |= 0x100;
	x = (x+1)&lt;&lt;3;

	if(x &lt;= 400){
		mul = 4;
		div = 1;
	}

	x = (x * mul) / div;
	printitem(name, "hde");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	shb = vga-&gt;crt[0x02];
	if(vga-&gt;crt[0x5D] &amp; 0x04)
		shb |= 0x100;
	shb = (shb+1)&lt;&lt;3;
	shb = (shb * mul) / div;
	printitem(name, "shb");
	printreg(shb);
	Bprint(&amp;stdout, "%6ud", shb);

	x = vga-&gt;crt[0x03] &amp; 0x1F;
	if(vga-&gt;crt[0x05] &amp; 0x80)
		x |= 0x20;
	x = (x * mul) / div;
	x = shb|x;					/* ???? */
	if(vga-&gt;crt[0x5D] &amp; 0x08)
		x += 64;
	printitem(name, "ehb");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	x = vga-&gt;crt[0x00];
	if(vga-&gt;crt[0x5D] &amp; 0x01)
		x |= 0x100;
	x = (x+5)&lt;&lt;3;
	x = (x * mul) / div;
	printitem(name, "ht");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	interlace = vga-&gt;crt[0x42] &amp; 0x20;
	x = vga-&gt;crt[0x12];
	if(vga-&gt;crt[0x07] &amp; 0x02)
		x |= 0x100;
	if(vga-&gt;crt[0x07] &amp; 0x40)
		x |= 0x200;
	if(vga-&gt;crt[0x5E] &amp; 0x02)
		x |= 0x400;
	x += 1;
	if(interlace)
		x *= 2;
	printitem(name, "vde");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	vrs = vga-&gt;crt[0x10];
	if(vga-&gt;crt[0x07] &amp; 0x04)
		vrs |= 0x100;
	if(vga-&gt;crt[0x07] &amp; 0x80)
		vrs |= 0x200;
	if(vga-&gt;crt[0x5E] &amp; 0x10)
		vrs |= 0x400;
	if(interlace)
		vrs *= 2;
	printitem(name, "vrs");
	printreg(vrs);
	Bprint(&amp;stdout, "%6ud", vrs);

	if(interlace)
		vrs /= 2;
	x = (vrs &amp; ~0x0F)|(vga-&gt;crt[0x11] &amp; 0x0F);
	if(interlace)
		x *= 2;
	printitem(name, "vre");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);

	x = vga-&gt;crt[0x06];
	if(vga-&gt;crt[0x07] &amp; 0x01)
		x |= 0x100;
	if(vga-&gt;crt[0x07] &amp; 0x20)
		x |= 0x200;
	if(vga-&gt;crt[0x5E] &amp; 0x01)
		x |= 0x400;
	x += 2;
	if(interlace)
		x *= 2;
	printitem(name, "vt");
	printreg(x);
	Bprint(&amp;stdout, "%6ud", x);
}

Ctlr s3generic = {
	"s3",				/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

