<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/trio64.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/trio64.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * S3 Trio64.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;

	/*
	 * The Trio has some extra sequencer registers which
	 * need to be unlocked for access.
	 */
	vgaxo(Seqx, 0x08, 0x06);
	for(i = 0x08; i &lt; 0x19; i++)
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);
	vga-&gt;crt[0x2D] = vgaxi(Crtx, 0x2D);
	vga-&gt;crt[0x2E] = vgaxi(Crtx, 0x2E);
	vga-&gt;crt[0x2F] = vgaxi(Crtx, 0x2F);

	s3generic.snarf(vga, ctlr);
	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Hpclk2x8|Henhanced|Foptions;
}

void
trio64clock(Vga* vga, Ctlr* ctlr)
{
	int d;
	ulong f, fmax, fmin, n, m, r;
	double trouble;

	/*
	 * The max value of R, M, N, and the speed rating of the part vary
	 * between parts and are passed to this routine in r[1] and f[1].
	 *			R	    F
	 *	Trio64		3	135000000
	 *	ViRGE		3	135000000
	 *	ViRGE/[DG]X	4	170000000
	 *	ViRGE/GX2	4	170000000
	 *	ViRGE/VX	4	220000000
	 */

	/*
	 * The PLL frequency is defined by the following equation:
	 *		   (M+2)
	 *	Fout = ------------- x Fref
	 *		(N+2) x 2**R
	 * where M, N and R have the following contraints:
	 * 1)		   (M+2) x Fref
	 *    vga-&gt;f[1] &lt;= ------------ &lt;= vga-&gt;f[1]*2
	 *		       (N+2)
	 * 2) 1 &lt;= M &lt;= vga-&gt;m[1] (usually 127)
	 * 3) 1 &lt;= N &lt;= vga-&gt;n[1] (usually 31)
	 * 4) 0 &lt;= R &lt;= vga-&gt;r[1]
	 *
	 * First determine R:
	 *	vga-&gt;f[1] &lt; 2**R x Fout &lt;= vga-&gt;f[1]*2
	 */
	for(r = 0; r &lt;= vga-&gt;r[1]; r++){
		f = vga-&gt;f[0]*(1&lt;&lt;r);
		if(vga-&gt;f[1] &lt; f &amp;&amp; f &lt;= vga-&gt;f[1]*2)
			vga-&gt;r[0] = r;
	}
	if(vga-&gt;r[0] &gt; vga-&gt;r[1])
		error("%s: pclk %lud out of range\n", ctlr-&gt;name, vga-&gt;f[0]);

	/*
	 * Now find the closest match for M and N.
	 */
	vga-&gt;d[0] = vga-&gt;f[0]+1;
	for(n = 1; n &lt;= vga-&gt;n[1]; n++){
		trouble = vga-&gt;f[0]*(n+2)*(1&lt;&lt;vga-&gt;r[0]);
		trouble /= RefFreq;
		m = (trouble+0.5) - 2;
		if(m &gt; vga-&gt;m[1])
			continue;

		trouble = (m+2)*RefFreq;
		trouble /= (n+2)*(1&lt;&lt;vga-&gt;r[0]);
		f = trouble+0.5;

		d = vga-&gt;f[0] - f;
		if(d &lt; 0)
			d = -d;
		if(d &lt;= vga-&gt;d[0]){
			vga-&gt;m[0] = m;
			vga-&gt;n[0] = n;
			vga-&gt;d[0] = d;
		}
	}

	trouble = vga-&gt;f[0]*1.005;
	fmax = trouble;
	trouble = vga-&gt;f[0]*0.995;
	fmin = trouble;
	trouble = (vga-&gt;m[0]+2)*RefFreq;
	trouble /= (vga-&gt;n[0]+2)*(1&lt;&lt;vga-&gt;r[0]);
	f = trouble+0.5;
	if(fmin &gt;= f || f &gt;= fmax)
		error("%s: pclk %lud out of range\n", ctlr-&gt;name, vga-&gt;f[0]);
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong pclk, x;

	s3generic.init(vga, ctlr);

	/*
	 * Clock bits. If the desired video clock is
	 * one of the two standard VGA clocks it can just be
	 * set using bits &lt;3:2&gt; of vga-&gt;misc, otherwise we
	 * need to programme the DCLK PLL.
	 */
	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	vga-&gt;misc &amp;= ~0x0C;
	if(vga-&gt;f[0] == VgaFreq0){
		/* nothing to do */;
	}
	else if(vga-&gt;f[0] == VgaFreq1)
		vga-&gt;misc |= 0x04;
	else{
		/*
		 * Part comes in -135MHz speed grade. In 8-bit mode
		 * the maximum DCLK is 80MHz. In 2x8-bit mode the maximum
		 * DCLK is 135MHz using the internal clock doubler.
		 */
		if((ctlr-&gt;flag &amp; Hpclk2x8) &amp;&amp; vga-&gt;mode-&gt;z == 8){
			pclk = 135000000;
			if(vga-&gt;f[0] &gt; 80000000)
				ctlr-&gt;flag |= Upclk2x8;
		}
		else
			pclk = 80000000;
		if(vga-&gt;f[0] &gt; pclk)
			error("%s: invalid pclk - %lud\n",
				ctlr-&gt;name, vga-&gt;f[0]);

		vga-&gt;f[1] = 135000000;
		vga-&gt;r[1] = 3;
		vga-&gt;n[1] = 31;
		vga-&gt;m[1] = 127;
		trio64clock(vga, ctlr);
		vga-&gt;sequencer[0x12] = (vga-&gt;r[0]&lt;&lt;5)|vga-&gt;n[0];
		vga-&gt;sequencer[0x13] = vga-&gt;m[0];
		vga-&gt;misc |= 0x0C;
	}

	/*
	 * Internal clock generator.
	 */
	vga-&gt;sequencer[0x15] &amp;= ~0x31;
	vga-&gt;sequencer[0x15] |= 0x02;
	vga-&gt;sequencer[0x18] &amp;= ~0x80;
	vga-&gt;crt[0x67] &amp;= ~0xF2;
	if(ctlr-&gt;flag &amp; Upclk2x8){
		vga-&gt;sequencer[0x15] |= 0x10;
		vga-&gt;sequencer[0x18] |= 0x80;
		/*
		 * There's a little strip of the border
		 * appears on the left in resolutions
		 * 1280 and above if the 0x02 bit isn't
		 * set (when it appears on the right...).
		 */
		vga-&gt;crt[0x67] |= 0x10;
	}

	/*
	 * VLB address latch delay.
	 */
	if((vga-&gt;crt[0x36] &amp; 0x03) == 0x01)
		vga-&gt;crt[0x58] &amp;= ~0x08;

	/*
	 * Start display FIFO fetch.
	 */
	x = vga-&gt;crt[0]-5;
	vga-&gt;crt[0x3B] = x;
	if(x &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x40;

	/*
	 * Display memory access control.
	 * Calculation of the M-parameter (Crt54) is
	 * memory-system and dot-clock dependent, the
	 * values below are guesses from dumping
	 * registers.
	 */
	vga-&gt;crt[0x60] = 0xFF;
	if(vga-&gt;mode-&gt;x &lt;= 800)
		vga-&gt;crt[0x54] = 0xE8;
	else if(vga-&gt;mode-&gt;x &lt;= 1024)
		vga-&gt;crt[0x54] = 0xA8;
	else
		vga-&gt;crt[0x54] = 0x00/*0x48*/;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ushort advfunc;

	s3generic.load(vga, ctlr);
	vgaxo(Crtx, 0x60, vga-&gt;crt[0x60]);
	vgaxo(Crtx, 0x67, vga-&gt;crt[0x67]);

	/*
	 * Load the PLL registers if necessary.
	 * Not sure if the variable-delay method of setting the
	 * PLL will work without a write here to vga-&gt;misc,
	 * so use the immediate-load method by toggling bit 5
	 * of Seq15 if necessary.
	 */
	vgaxo(Seqx, 0x12, vga-&gt;sequencer[0x12]);
	vgaxo(Seqx, 0x13, vga-&gt;sequencer[0x13]);
	if((vga-&gt;misc &amp; 0x0C) == 0x0C)
		vgaxo(Seqx, 0x15, vga-&gt;sequencer[0x15]|0x20);
	vgaxo(Seqx, 0x15, vga-&gt;sequencer[0x15]);
	vgaxo(Seqx, 0x18, vga-&gt;sequencer[0x18]);

	advfunc = 0x0000;
	if(ctlr-&gt;flag &amp; Uenhanced)
		advfunc = 0x0001;
	outportw(0x4AE8, advfunc);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	ulong dclk, m, n, r;

	s3generic.dump(vga, ctlr);

	printitem(ctlr-&gt;name, "Seq08");
	for(i = 0x08; i &lt; 0x19; i++)
		printreg(vga-&gt;sequencer[i]);

	printitem(ctlr-&gt;name, "Crt2D");
	printreg(vga-&gt;crt[0x2D]);
	printreg(vga-&gt;crt[0x2E]);
	printreg(vga-&gt;crt[0x2F]);

	n = vga-&gt;sequencer[0x12] &amp; 0x1F;
	r = (vga-&gt;sequencer[0x12]&gt;&gt;5) &amp; 0x03;
	m = vga-&gt;sequencer[0x13] &amp; 0x7F;
	dclk = (m+2)*RefFreq;
	dclk /= (n+2)*(1&lt;&lt;r);
	printitem(ctlr-&gt;name, "dclk m n r");
	Bprint(&amp;stdout, "%9ld %8ld       - %8ld %8ld\n", dclk, m, n, r);
}

Ctlr trio64 = {
	"trio64",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

