<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/tvp3025.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/tvp3025.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Tvp3025 Viewpoint Video Interface Pallette.
 * Assumes hooked up to an S3 Vision964.
 * The #9GXE64pro uses bit 5 of Crt5C as RS4,
 * giving access to the Bt485 emulation mode registers.
 */
static void
options(Vga* vga, Ctlr* ctlr)
{
	tvp3020.options(vga, ctlr);
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	/*
	 * Although the Tvp3025 has a higher default
	 * speed-grade (135MHz), just use the 3020 code.
	 */
	tvp3020.init(vga, ctlr);
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	uchar crt5c, x;

	crt5c = vgaxi(Crtx, 0x5C) &amp; ~0x20;
	vgaxo(Crtx, 0x5C, crt5c);
	x = tvp3020xi(0x06) &amp; ~0x80;
	tvp3020xo(0x06, x);
	tvp3020xo(0x0E, 0x00);

	(tvp3020.load)(vga, ctlr);
	if(ctlr-&gt;flag &amp; Uenhanced)
		tvp3020xo(0x29, 0x01);

	ctlr-&gt;flag |= Fload;
}

static ulong
dumpclock(ulong d, ulong n, ulong p)
{
	ulong f;

	f = RefFreq*((n+2)*8);
	f /= (d+2);
	f &gt;&gt;= p;

	return f;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	uchar crt5c;
	int i;
	ulong clock[4];

	crt5c = vgaxi(Crtx, 0x5C);
	vgaxo(Crtx, 0x5C, crt5c &amp; ~0x20);
	tvp3020.dump(vga, ctlr);

	printitem(ctlr-&gt;name, "PCLK");
	for(i = 0; i &lt; 4; i++){
		tvp3020xo(0x2C, (i&lt;&lt;4)|(i&lt;&lt;2)|i);
		printreg(clock[i] = tvp3020xi(0x2D));
	}
	Bprint(&amp;stdout, "%23ld\n", dumpclock(clock[0], clock[1], clock[2] &amp; 0x07));

	printitem(ctlr-&gt;name, "MCLK");
	for(i = 0; i &lt; 4; i++){
		tvp3020xo(0x2C, (i&lt;&lt;4)|(i&lt;&lt;2)|i);
		printreg(clock[i] = tvp3020xi(0x2E));
	}
	Bprint(&amp;stdout, "%23ld\n", dumpclock(clock[0], clock[1], clock[2] &amp; 0x07));

	printitem(ctlr-&gt;name, "RCLK");
	for(i = 0; i &lt; 4; i++){
		tvp3020xo(0x2C, (i&lt;&lt;4)|(i&lt;&lt;2)|i);
		printreg(clock[i] = tvp3020xi(0x2F));
	}
	Bprint(&amp;stdout, "%23ld\n", dumpclock(clock[0], clock[1], clock[2] &amp; 0x07));

	vgaxo(Crtx, 0x5C, crt5c);
}

Ctlr tvp3025 = {
	"tvp3025",			/* name */
	0,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

