<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/vesa.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/vesa.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;/386/include/ureg.h&gt;
typedef struct Ureg Ureg;

#include "pci.h"
#include "vga.h"

typedef struct Vbe Vbe;
typedef struct Vmode Vmode;
typedef struct Modelist Modelist;
typedef struct Edid Edid;

enum
{
	MemSize = 1024*1024,
	PageSize = 4096,
	RealModeBuf = 0x9000,
};

struct Vbe
{
	int	rmfd;	/* /dev/realmode */
	int	memfd;	/* /dev/realmem */
	uchar	*mem;	/* copy of memory; 1MB */
	uchar	*isvalid;	/* 1byte per 4kB in mem */
	uchar	*buf;
	uchar	*modebuf;
};

struct Vmode
{
	char	name[32];
	char	chan[32];
	int	id;
	int	attr;	/* flags */
	int	bpl;
	int	dx, dy;
	int	depth;
	char	*model;
	int	r, g, b, x;
	int	ro, go, bo, xo;
	int	directcolor;	/* flags */
	ulong	paddr;
};

struct Edid {
	char		mfr[4];		/* manufacturer */
	char		serialstr[16];	/* serial number as string (in extended data) */
	char		name[16];		/* monitor name as string (in extended data) */
	ushort	product;		/* product code, 0 = unused */
	ulong	serial;		/* serial number, 0 = unused */
	uchar	version;		/* major version number */
	uchar	revision;		/* minor version number */
	uchar	mfrweek;		/* week of manufacture, 0 = unused */
	int		mfryear;		/* year of manufacture, 0 = unused */
	uchar 	dxcm;		/* horizontal image size in cm. */
	uchar	dycm;		/* vertical image size in cm. */
	int		gamma;		/* gamma*100 */
	int		rrmin;		/* minimum vertical refresh rate */
	int		rrmax;		/* maximum vertical refresh rate */
	int		hrmin;		/* minimum horizontal refresh rate */
	int		hrmax;		/* maximum horizontal refresh rate */
	ulong	pclkmax;		/* maximum pixel clock */
	int		flags;

	Modelist	*modelist;		/* list of supported modes */
};

struct Modelist
{
	Mode;
	Modelist *next;
};

enum {
	Fdigital = 1&lt;&lt;0,		/* is a digital display */
	Fdpmsstandby = 1&lt;&lt;1,	/* supports DPMS standby mode */
	Fdpmssuspend = 1&lt;&lt;2,	/* supports DPMS suspend mode */
	Fdpmsactiveoff = 1&lt;&lt;3,	/* supports DPMS active off mode */
	Fmonochrome = 1&lt;&lt;4,	/* is a monochrome display */
	Fgtf = 1&lt;&lt;5,		/* supports VESA GTF: see /public/doc/vesa/gtf10.pdf */
};

#define WORD(p) ((p)[0] | ((p)[1]&lt;&lt;8))
#define LONG(p) ((p)[0] | ((p)[1]&lt;&lt;8) | ((p)[2]&lt;&lt;16) | ((p)[3]&lt;&lt;24))
#define PWORD(p, v) (p)[0] = (v); (p)[1] = (v)&gt;&gt;8
#define PLONG(p, v) (p)[0] = (v); (p)[1] = (v)&gt;&gt;8; (p)[2] = (v)&gt;&gt;16; (p)[3] = (v)&gt;&gt;24

static Vbe *vbe;
static Edid edid;

Vbe *mkvbe(void);
int vbecheck(Vbe*);
uchar *vbemodes(Vbe*);
int vbemodeinfo(Vbe*, int, Vmode*);
int vbegetmode(Vbe*);
int vbesetmode(Vbe*, int);
void vbeprintinfo(Vbe*);
void vbeprintmodeinfo(Vbe*, int, char*);
int vbesnarf(Vbe*, Vga*);
void vesaddc(void);
int vbeddcedid(Vbe *vbe, Edid *e);
void printedid(Edid*);

int
dbvesa(Vga* vga)
{
	vbe = mkvbe();
	if(vbe == nil){
		fprint(2, "mkvbe: %r\n");
		return 0;
	}
	if(vbecheck(vbe) &lt; 0){
		fprint(2, "dbvesa: %r\n");
		return 0;
	}
	vga-&gt;link = alloc(sizeof(Ctlr));
	*vga-&gt;link = vesa;
	vga-&gt;vesa = vga-&gt;link;
	vga-&gt;ctlr = vga-&gt;link;

	vga-&gt;link-&gt;link = alloc(sizeof(Ctlr));
	*vga-&gt;link-&gt;link = softhwgc;
	vga-&gt;hwgc = vga-&gt;link-&gt;link;

	return 1;
}

Mode*
dbvesamode(char *mode)
{
	int i;
	uchar *p, *ep;
	Vmode vm;
	Mode *m;
	
	if(vbe == nil)
		return nil;

	p = vbemodes(vbe);
	if(p == nil)
		return nil;
	for(ep=p+1024; (p[0]!=0xFF || p[1]!=0xFF) &amp;&amp; p&lt;ep; p+=2){
		if(vbemodeinfo(vbe, WORD(p), &amp;vm) &lt; 0)
			continue;
		if(strcmp(vm.name, mode) == 0)
			goto havemode;
	}
	if(1){
		fprint(2, "warning: scanning for unoffered vesa modes\n");
		for(i=0x100; i&lt;0x200; i++){
			if(vbemodeinfo(vbe, i, &amp;vm) &lt; 0)
				continue;
			if(strcmp(vm.name, mode) == 0)
				goto havemode;
		}
	}
	werrstr("no such vesa mode");
	return nil;

havemode:
	m = alloc(sizeof(Mode));
	strcpy(m-&gt;type, "vesa");
	strcpy(m-&gt;size, vm.name);
	strcpy(m-&gt;chan, vm.chan);
	m-&gt;frequency = 100;
	m-&gt;x = vm.dx;
	m-&gt;y = vm.dy;
	m-&gt;z = vm.depth;
	m-&gt;ht = m-&gt;x;
	m-&gt;shb = m-&gt;x;
	m-&gt;ehb = m-&gt;x;
	m-&gt;shs = m-&gt;x;
	m-&gt;ehs = m-&gt;x;
	m-&gt;vt = m-&gt;y;
	m-&gt;vrs = m-&gt;y;
	m-&gt;vre = m-&gt;y;

	m-&gt;attr = alloc(sizeof(Attr));
	m-&gt;attr-&gt;attr = "id";
	m-&gt;attr-&gt;val = alloc(32);
	sprint(m-&gt;attr-&gt;val, "0x%x", vm.id);
	return m;
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	if(!vbe)
		vbe = mkvbe();
	if(vbe)
		vga-&gt;vesa = ctlr;
	vbesnarf(vbe, vga);
	vga-&gt;linear = 1;
	ctlr-&gt;flag |= Hlinear|Ulinear;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	if(vbe == nil)
		error("no vesa bios\n");
	if(vbesetmode(vbe, atoi(dbattr(vga-&gt;mode-&gt;attr, "id"))) &lt; 0){
		ctlr-&gt;flag |= Ferror;
		fprint(2, "vbesetmode: %r\n");
	}
}

static void
dump(Vga*, Ctlr*)
{
	int i;
	char did[0x200];
	uchar *p, *ep;

	if(!vbe){
		Bprint(&amp;stdout, "no vesa bios\n");
		return;
	}

	memset(did, 0, sizeof did);
	vbeprintinfo(vbe);
	p = vbemodes(vbe);
	if(p){
		for(ep=p+1024; (p[0]!=0xFF || p[1]!=0xFF) &amp;&amp; p&lt;ep; p+=2){
			vbeprintmodeinfo(vbe, WORD(p), "");
			if(WORD(p) &lt; nelem(did))
				did[WORD(p)] = 1;
		}
	}
	for(i=0x100; i&lt;0x1FF; i++)
		if(!did[i])
			vbeprintmodeinfo(vbe, i, " (unoffered)");
				
	
	if(vbeddcedid(vbe, &amp;edid) &lt; 0)
		fprint(2, "warning: reading edid: %r\n");
	else
		printedid(&amp;edid);
}

Ctlr vesa = {
	"vesa",			/* name */
	snarf,				/* snarf */
	0,			/* options */
	0,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr softhwgc = {
	"soft",
};

/*
 * VESA bios extension
 */

typedef struct Flag Flag;
struct Flag {
	int bit;
	char *desc;
};

static Flag capabilityflag[] = {
	0x01, "8-bit-dac",
	0x02, "not-vga",
	0x04, "ramdac-needs-blank",
	0x08, "stereoscopic",
	0x10, "stereo-evc",
	0
};

static Flag modeattributesflags[] = {
	1&lt;&lt;0, "supported",
	1&lt;&lt;2, "tty",
	1&lt;&lt;3, "color",
	1&lt;&lt;4, "graphics",
	1&lt;&lt;5, "not-vga",
	1&lt;&lt;6, "no-windowed-vga",
	1&lt;&lt;7, "linear",
	1&lt;&lt;8, "double-scan",
	1&lt;&lt;9, "interlace",
	1&lt;&lt;10, "triple-buffer",
	1&lt;&lt;11, "stereoscopic",
	1&lt;&lt;12, "dual-start-addr",
	0
};

static Flag winattributesflags[] = {
	1&lt;&lt;0, "relocatable",
	1&lt;&lt;1, "readable",
	1&lt;&lt;2, "writeable",
	0
};

static Flag directcolorflags[] = {
	1&lt;&lt;0, "programmable-color-ramp",
	1&lt;&lt;1, "x-usable",
	0
};

static char *modelstr[] = {
	"text", "cga", "hercules", "planar", "packed", "non-chain4", "direct", "YUV"
};

static void
printflags(Flag *f, int b)
{
	int i;

	for(i=0; f[i].bit; i++)
		if(f[i].bit &amp; b)
			Bprint(&amp;stdout, " %s", f[i].desc);
	Bprint(&amp;stdout, "\n");
}

Vbe*
mkvbe(void)
{
	Vbe *vbe;

	vbe = alloc(sizeof(Vbe));
	if((vbe-&gt;rmfd = open("/dev/realmode", ORDWR)) &lt; 0)
		return nil;
	if((vbe-&gt;memfd = open("/dev/realmodemem", ORDWR)) &lt; 0)
		return nil;
	vbe-&gt;mem = alloc(MemSize);
	vbe-&gt;isvalid = alloc(MemSize/PageSize);
	vbe-&gt;buf = alloc(PageSize);
	vbe-&gt;modebuf = alloc(PageSize);
	return vbe;
}

static void
loadpage(Vbe *vbe, int p)
{
	if(p &gt;= MemSize/PageSize || vbe-&gt;isvalid[p])
		return;
	if(pread(vbe-&gt;memfd, vbe-&gt;mem+p*PageSize, PageSize, p*PageSize) != PageSize)
		error("read /dev/realmodemem: %r\n");
	vbe-&gt;isvalid[p] = 1;
}

static void*
unfarptr(Vbe *vbe, uchar *p)
{
	int seg, off;

	seg = WORD(p+2);
	off = WORD(p);
	if(seg==0 &amp;&amp; off==0)
		return nil;
	off += seg&lt;&lt;4;
	if(off &gt;= MemSize)
		return nil;
	loadpage(vbe, off/PageSize);
	loadpage(vbe, off/PageSize+1);	/* just in case */
	return vbe-&gt;mem+off;
}

uchar*
vbesetup(Vbe *vbe, Ureg *u, int ax)
{
	memset(vbe-&gt;buf, 0, PageSize);
	memset(u, 0, sizeof *u);
	u-&gt;ax = ax;
	u-&gt;es = (RealModeBuf&gt;&gt;4)&amp;0xF000;
	u-&gt;di = RealModeBuf&amp;0xFFFF;
	return vbe-&gt;buf;
}

int
vbecall(Vbe *vbe, Ureg *u)
{
	u-&gt;trap = 0x10;
	if(pwrite(vbe-&gt;memfd, vbe-&gt;buf, PageSize, RealModeBuf) != PageSize)
		error("write /dev/realmodemem: %r\n");
	if(pwrite(vbe-&gt;rmfd, u, sizeof *u, 0) != sizeof *u)
		error("write /dev/realmode: %r\n");
	if(pread(vbe-&gt;rmfd, u, sizeof *u, 0) != sizeof *u)
		error("read /dev/realmode: %r\n");
	if(pread(vbe-&gt;memfd, vbe-&gt;buf, PageSize, RealModeBuf) != PageSize)
		error("read /dev/realmodemem: %r\n");
	if((u-&gt;ax&amp;0xFFFF) != 0x004F){
		werrstr("VBE error %#.4lux", u-&gt;ax&amp;0xFFFF);
		return -1;
	}
	memset(vbe-&gt;isvalid, 0, MemSize/PageSize);
	return 0;
}

int
vbecheck(Vbe *vbe)
{
	uchar *p;
	Ureg u;

	p = vbesetup(vbe, &amp;u, 0x4F00);
	strcpy((char*)p, "VBE2");
	if(vbecall(vbe, &amp;u) &lt; 0)
		return -1;
	if(memcmp(p, "VESA", 4) != 0 || p[5] &lt; 2){
		werrstr("invalid vesa signature %.4H %.4H\n", p, p+4);
		return -1;
	}
	return 0;
}

int
vbesnarf(Vbe *vbe, Vga *vga)
{
	uchar *p;
	Ureg u;

	p = vbesetup(vbe, &amp;u, 0x4F00);
	strcpy((char*)p, "VBE2");
	if(vbecall(vbe, &amp;u) &lt; 0)
		return -1;
	if(memcmp(p, "VESA", 4) != 0 || p[5] &lt; 2)
		return -1;
	vga-&gt;apz = WORD(p+18)*0x10000UL;
	return 0;
}

void
vbeprintinfo(Vbe *vbe)
{
	uchar *p;
	Ureg u;

	p = vbesetup(vbe, &amp;u, 0x4F00);
	strcpy((char*)p, "VBE2");
	if(vbecall(vbe, &amp;u) &lt; 0)
		return;

	printitem("vesa", "sig");
	Bprint(&amp;stdout, "%.4s %d.%d\n", (char*)p, p[5], p[4]);
	if(p[5] &lt; 2)
		return;

	printitem("vesa", "oem");
	Bprint(&amp;stdout, "%s %d.%d\n", unfarptr(vbe, p+6), p[21], p[20]);
	printitem("vesa", "vendor");
	Bprint(&amp;stdout, "%s\n", unfarptr(vbe, p+22));
	printitem("vesa", "product");
	Bprint(&amp;stdout, "%s\n", unfarptr(vbe, p+26));
	printitem("vesa", "rev");
	Bprint(&amp;stdout, "%s\n", unfarptr(vbe, p+30));

	printitem("vesa", "cap");
	printflags(capabilityflag, p[10]);

	printitem("vesa", "mem");
	Bprint(&amp;stdout, "%lud\n", WORD(p+18)*0x10000UL);
}

uchar*
vbemodes(Vbe *vbe)
{
	uchar *p;
	Ureg u;

	p = vbesetup(vbe, &amp;u, 0x4F00);
	strcpy((char*)p, "VBE2");
	if(vbecall(vbe, &amp;u) &lt; 0)
		return nil;
	memmove(vbe-&gt;modebuf, unfarptr(vbe, p+14), 1024);
	return vbe-&gt;modebuf;
}

int
vbemodeinfo(Vbe *vbe, int id, Vmode *m)
{
	int o;
	ulong d, c, x;
	uchar *p;
	char tmp[sizeof m-&gt;chan];
	Ureg u;

	p = vbesetup(vbe, &amp;u, 0x4F01);
	u.cx = id;
	if(vbecall(vbe, &amp;u) &lt; 0)
		return -1;

	m-&gt;id = id;
	m-&gt;attr = WORD(p);
	m-&gt;bpl = WORD(p+16);
	m-&gt;dx = WORD(p+18);
	m-&gt;dy = WORD(p+20);
	m-&gt;depth = p[25];
	m-&gt;model = p[27] &lt; nelem(modelstr) ? modelstr[p[27]] : "unknown";
	m-&gt;r = p[31];
	m-&gt;g = p[33];
	m-&gt;b = p[35];
	m-&gt;x = p[37];
	m-&gt;ro = p[32];
	m-&gt;go = p[34];
	m-&gt;bo = p[36];
	m-&gt;xo = p[38];
	m-&gt;directcolor = p[39];
	m-&gt;paddr = LONG(p+40);
	snprint(m-&gt;name, sizeof m-&gt;name, "%dx%dx%d",
		m-&gt;dx, m-&gt;dy, m-&gt;depth);
	if(m-&gt;depth &lt;= 8) {
		snprint(m-&gt;chan, sizeof m-&gt;chan, "m%d", m-&gt;depth);
		return 0;
	}

	m-&gt;xo = m-&gt;x = 0;
	d = 1 &lt;&lt; (m-&gt;depth - 1);
	d |= d - 1;
	c  = ((1&lt;&lt;m-&gt;r)-1) &lt;&lt; m-&gt;ro;
	c |= ((1&lt;&lt;m-&gt;g)-1) &lt;&lt; m-&gt;go;
	c |= ((1&lt;&lt;m-&gt;b)-1) &lt;&lt; m-&gt;bo;
	x = d ^ c;
	if(x != 0){
		for(; (x &amp; 1) == 0; x &gt;&gt;= 1)
			m-&gt;xo++;
		for(; x &amp; 1; x &gt;&gt;= 1)
			m-&gt;x++;
	}

	m-&gt;chan[0] = o = 0;
	while(o &lt; m-&gt;depth){
		if(m-&gt;r &amp;&amp; m-&gt;ro == o){
			snprint(tmp, sizeof tmp, "r%d%s", m-&gt;r, m-&gt;chan);
			o += m-&gt;r;
		}else if(m-&gt;g &amp;&amp; m-&gt;go == o){
			snprint(tmp, sizeof tmp, "g%d%s", m-&gt;g, m-&gt;chan);
			o += m-&gt;g;
		}else if(m-&gt;b &amp;&amp; m-&gt;bo == o){
			snprint(tmp, sizeof tmp, "b%d%s", m-&gt;b, m-&gt;chan);
			o += m-&gt;b;
		}else if(m-&gt;x &amp;&amp; m-&gt;xo == o){
			snprint(tmp, sizeof tmp, "x%d%s", m-&gt;x, m-&gt;chan);
			o += m-&gt;x;
		}else
			break;
		strncpy(m-&gt;chan, tmp, sizeof m-&gt;chan);
	}
	return 0;
}

void
vbeprintmodeinfo(Vbe *vbe, int id, char *suffix)
{
	Vmode m;

	if(vbemodeinfo(vbe, id, &amp;m) &lt; 0){
	//	Bprint(&amp;stdout, "vesa: cannot get mode 0x%ux: %r\n", id);
		return;
	}
	printitem("vesa", "mode");
	Bprint(&amp;stdout, "0x%ux %s %s %s%s\n",
		m.id, m.name, m.chan, m.model, suffix);
}

int
vbegetmode(Vbe *vbe)
{
	Ureg u;

	vbesetup(vbe, &amp;u, 0x4F03);
	if(vbecall(vbe, &amp;u) &lt; 0)
		return 0;
	return u.bx;
}

int
vbesetmode(Vbe *vbe, int id)
{
	uchar *p;
	Ureg u;

	p = vbesetup(vbe, &amp;u, 0x4F02);
	if(id != 3)
		id |= 3&lt;&lt;14;	/* graphics: use linear, do not clear */
	u.bx = id;
	USED(p);
	/*
	 * can set mode specifics (ht hss hse vt vss vse 0 clockhz refreshhz):
	 *
		u.bx |= 1&lt;&lt;11;
		n = atoi(argv[2]); PWORD(p, n); p+=2;
		n = atoi(argv[3]); PWORD(p, n); p+=2;
		n = atoi(argv[4]); PWORD(p, n); p+=2;
		n = atoi(argv[5]); PWORD(p, n); p+=2;
		n = atoi(argv[6]); PWORD(p, n); p+=2;
		n = atoi(argv[7]); PWORD(p, n); p+=2;
		*p++ = atoi(argv[8]);
		n = atoi(argv[9]); PLONG(p, n); p += 4;
		n = atoi(argv[10]); PWORD(p, n); p += 2;
		if(p != vbe.buf+19){
			fprint(2, "prog error\n");
			return;
		}
	 *
	 */
	return vbecall(vbe, &amp;u);
}

void
vesatextmode(void)
{
	if(vbe == nil){
		vbe = mkvbe();
		if(!vbe)
			error("mkvbe: %r\n");
	}
	if(vbecheck(vbe) &lt; 0)
		error("vbecheck: %r\n");
	if(vbesetmode(vbe, 3) &lt; 0)
		error("vbesetmode: %r\n");
}

static Flag edidflags[] = {
	Fdigital, "digital",
	Fdpmsstandby, "standby",
	Fdpmssuspend, "suspend",
	Fdpmsactiveoff, "activeoff",
	Fmonochrome, "monochrome",
	Fgtf, "gtf",
	0
};

int parseedid128(Edid *e, void *v);

int
vbeddcedid(Vbe *vbe, Edid *e)
{
	uchar *p;
	Ureg u;
	
	p = vbesetup(vbe, &amp;u, 0x4F15);
	u.bx = 0x0001;
	if(vbecall(vbe, &amp;u) &lt; 0)
		return -1;
	if(parseedid128(e, p) &lt; 0){
		werrstr("parseedid128: %r");
		return -1;
	}
	return 0;
}
	
void
printedid(Edid *e)
{
	Modelist *l;
	
	printitem("edid", "mfr");
	Bprint(&amp;stdout, "%s\n", e-&gt;mfr);
	printitem("edid", "serialstr");
	Bprint(&amp;stdout, "%s\n", e-&gt;serialstr);
	printitem("edid", "name");
	Bprint(&amp;stdout, "%s\n", e-&gt;name);
	printitem("edid", "product");
	Bprint(&amp;stdout, "%d\n", e-&gt;product);
	printitem("edid", "serial");
	Bprint(&amp;stdout, "%lud\n", e-&gt;serial);
	printitem("edid", "version");
	Bprint(&amp;stdout, "%d.%d\n", e-&gt;version, e-&gt;revision);
	printitem("edid", "mfrdate");
	Bprint(&amp;stdout, "%d.%d\n", e-&gt;mfryear, e-&gt;mfrweek);
	printitem("edid", "size (cm)");
	Bprint(&amp;stdout, "%dx%d\n", e-&gt;dxcm, e-&gt;dycm);
	printitem("edid", "gamma");
	Bprint(&amp;stdout, "%.2f\n", e-&gt;gamma/100.);
	printitem("edid", "vert (Hz)");
	Bprint(&amp;stdout, "%d-%d\n", e-&gt;rrmin, e-&gt;rrmax);
	printitem("edid", "horz (Hz)");
	Bprint(&amp;stdout, "%d-%d\n", e-&gt;hrmin, e-&gt;hrmax);
	printitem("edid", "pclkmax");
	Bprint(&amp;stdout, "%lud\n", e-&gt;pclkmax);
	printitem("edid", "flags");
	printflags(edidflags, e-&gt;flags);
	
	for(l=e-&gt;modelist; l; l=l-&gt;next){
		printitem("edid", l-&gt;name);
		Bprint(&amp;stdout, "\n\t\tclock=%g\n\t\tshb=%d ehb=%d ht=%d\n\t\tvrs=%d vre=%d vt=%d\n\t\thsync=%c vsync=%c %s\n",
			l-&gt;frequency/1.e6, l-&gt;shb, l-&gt;ehb, l-&gt;ht, l-&gt;vrs, l-&gt;vre, l-&gt;vt, l-&gt;hsync?l-&gt;hsync:'?', l-&gt;vsync?l-&gt;vsync:'?', l-&gt;interlace?"interlace=v" : "");
	}
}

Modelist*
addmode(Modelist *l, Mode m)
{
	int rr;
	Modelist **lp;

//m.z = 8; // BUG
	rr = (m.frequency+m.ht*m.vt/2)/(m.ht*m.vt);
	snprint(m.name, sizeof m.name, "%dx%dx%d@%dHz", m.x, m.y, m.z, rr);

	if(m.shs == 0)
		m.shs = m.shb;
	if(m.ehs == 0)
		m.ehs = m.ehb;
	if(m.vbs == 0)
		m.vbs = m.vrs;
	if(m.vbe == 0)
		m.vbe = m.vbs+1;

	for(lp=&amp;l; *lp; lp=&amp;(*lp)-&gt;next){
		if(strcmp((*lp)-&gt;name, m.name) == 0){
			(*lp)-&gt;Mode = m;
			return l;
		}
	}

	*lp = alloc(sizeof(**lp));
	(*lp)-&gt;Mode = m;
	return l;
}

/*
 * Parse VESA EDID information.  Based on the VESA
 * Extended Display Identification Data standard, Version 3,
 * November 13, 1997.  See /public/doc/vesa/edidv3.pdf.
 *
 * This only handles 128-byte EDID blocks.  Until I find
 * a monitor that produces 256-byte blocks, I'm not going
 * to try to decode them.
 */

/*
 * Established timings block.  There is a bitmap
 * that says whether each mode is supported.  Most
 * of these have VESA definitions.  Those that don't are marked
 * as such, and we ignore them (the lookup fails).
 */
static char *estabtime[] = {
	"720x400@70Hz",	/* non-VESA: IBM, VGA */
	"720x400@88Hz",	/* non-VESA: IBM, XGA2 */
	"640x480@60Hz",
	"640x480@67Hz",	/* non-VESA: Apple, Mac II */
	"640x480@72Hz",
	"640x480@75Hz",
	"800x600@56Hz",
	"800x600@60Hz",

	"800x600@72Hz",
	"800x600@75Hz",
	"832x624@75Hz",	/* non-VESA: Apple, Mac II */
	"1024x768i@87Hz",	/* non-VESA: IBM */
	"1024x768@60Hz",
	"1024x768@70Hz",
	"1024x768@75Hz",
	"1280x1024@75Hz",

	"1152x870@75Hz",	/* non-VESA: Apple, Mac II */
};

/*
 * Decode the EDID detailed timing block.  See pp. 20-21 of the standard.
 */
static int
decodedtb(Mode *m, uchar *p)
{
	int ha, hb, hso, hspw, rr, va, vb, vso, vspw;
	/* int dxmm, dymm, hbord, vbord; */

	memset(m, 0, sizeof *m);

	m-&gt;frequency = ((p[1]&lt;&lt;8) | p[0]) * 10000;

	ha = ((p[4] &amp; 0xF0)&lt;&lt;4) | p[2];		/* horizontal active */
	hb = ((p[4] &amp; 0x0F)&lt;&lt;8) | p[3];		/* horizontal blanking */
	va = ((p[7] &amp; 0xF0)&lt;&lt;4) | p[5];		/* vertical active */
	vb = ((p[7] &amp; 0x0F)&lt;&lt;8) | p[6];		/* vertical blanking */
	hso = ((p[11] &amp; 0xC0)&lt;&lt;2) | p[8];	/* horizontal sync offset */
	hspw = ((p[11] &amp; 0x30)&lt;&lt;4) | p[9];	/* horizontal sync pulse width */
	vso = ((p[11] &amp; 0x0C)&lt;&lt;2) | ((p[10] &amp; 0xF0)&gt;&gt;4);	/* vertical sync offset */
	vspw = ((p[11] &amp; 0x03)&lt;&lt;4) | (p[10] &amp; 0x0F);		/* vertical sync pulse width */

	/* dxmm = (p[14] &amp; 0xF0)&lt;&lt;4) | p[12]; 	/* horizontal image size (mm) */
	/* dymm = (p[14] &amp; 0x0F)&lt;&lt;8) | p[13];	/* vertical image size (mm) */
	/* hbord = p[15];		/* horizontal border (pixels) */
	/* vbord = p[16];		/* vertical border (pixels) */

	m-&gt;x = ha;
	m-&gt;y = va;

	m-&gt;ht = ha+hb;
	m-&gt;shs = ha;
	m-&gt;shb = ha+hso;
	m-&gt;ehb = ha+hso+hspw;
	m-&gt;ehs = ha+hb;

	m-&gt;vt = va+vb;
	m-&gt;vbs = va;	
	m-&gt;vrs = va+vso;
	m-&gt;vre = va+vso+vspw;
	m-&gt;vbe = va+vb;

	if(p[17] &amp; 0x80)	/* interlaced */
		m-&gt;interlace = 'v';

	if(p[17] &amp; 0x60)	/* some form of stereo monitor mode; no support */
		return -1;

	/*
	 * Sync signal description.  I have no idea how to properly handle the 
	 * first three cases, which I think are aimed at things other than
	 * canonical SVGA monitors.
	 */
	switch((p[17] &amp; 0x18)&gt;&gt;3) {
	case 0:	/* analog composite sync signal*/
	case 1:	/* bipolar analog composite sync signal */
		/* p[17] &amp; 0x04 means serration: hsync during vsync */
		/* p[17] &amp; 0x02 means sync pulse appears on RGB not just G */
		break;

	case 2:	/* digital composite sync signal */
		/* p[17] &amp; 0x04 means serration: hsync during vsync */
		/* p[17] &amp; 0x02 means hsync positive outside vsync */
		break;

	case 3:	/* digital separate sync signal; the norm */
		m-&gt;vsync = (p[17] &amp; 0x04) ? '+' : '-';
		m-&gt;hsync = (p[17] &amp; 0x02) ? '+' : '-';
		break;
	}
	/* p[17] &amp; 0x01 is another stereo bit, only referenced if p[17] &amp; 0x60 != 0 */

	rr = (m-&gt;frequency+m-&gt;ht*m-&gt;vt/2) / (m-&gt;ht*m-&gt;vt);

	snprint(m-&gt;name, sizeof m-&gt;name, "%dx%d@%dHz", m-&gt;x, m-&gt;y, rr);

	return 0;
}

extern Mode *vesamodes[];

int
vesalookup(Mode *m, char *name)
{
	Mode **p;

	for(p=vesamodes; *p; p++)
		if(strcmp((*p)-&gt;name, name) == 0) {
			*m = **p;
			return 0;
		}

	return -1;
}

static int
decodesti(Mode *m, uchar *p)
{
	int x, y, rr;
	char str[20];

	x = (p[0]+31)*8;
	switch((p[1]&gt;&gt;6) &amp; 3){
	default:
	case 0:
		y = x;
		break;
	case 1:
		y = (x*4)/3;
		break;
	case 2:
		y = (x*5)/4;
		break;
	case 3:
		y = (x*16)/9;
		break;
	}
	rr = (p[1] &amp; 0x1F) + 60;

	sprint(str, "%dx%d@%dHz", x, y, rr);
	return vesalookup(m, str);
}

int
parseedid128(Edid *e, void *v)
{
	static uchar magic[8] = { 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00 };
	uchar *p, *q, sum;
	int dpms, estab, i, m, vid;
	Mode mode;

	memset(e, 0, sizeof *e);

	p = (uchar*)v;
	if(memcmp(p, magic, 8) != 0) {
		werrstr("bad edid header");
		return -1;
	}

	sum = 0;
	for(i=0; i&lt;128; i++) 
		sum += p[i];
	if(sum != 0) {
		werrstr("bad edid checksum");
		return -1;
	}
	p += 8;

	assert(p == (uchar*)v+8);	/* assertion offsets from pp. 12-13 of the standard */
	/*
	 * Manufacturer name is three 5-bit ascii letters, packed
	 * into a big endian [sic] short in big endian order.  The high bit is unused.
	 */
	i = (p[0]&lt;&lt;8) | p[1];
	p += 2;
	e-&gt;mfr[0] = 'A'-1 + ((i&gt;&gt;10) &amp; 0x1F);
	e-&gt;mfr[1] = 'A'-1 + ((i&gt;&gt;5) &amp; 0x1F);
	e-&gt;mfr[2] = 'A'-1 + (i &amp; 0x1F);
	e-&gt;mfr[3] = '\0';

	/*
	 * Product code is a little endian short.
	 */
	e-&gt;product = (p[1]&lt;&lt;8) | p[0];
	p += 2;

	/*
	 * Serial number is a little endian long, 0x01010101 = unused.
	 */
	e-&gt;serial = (p[3]&lt;&lt;24) | (p[2]&lt;&lt;16) | (p[1]&lt;&lt;8) | p[0];
	p += 4;
	if(e-&gt;serial == 0x01010101)
		e-&gt;serial = 0;

	e-&gt;mfrweek = *p++;
	e-&gt;mfryear = 1990 + *p++;

	assert(p == (uchar*)v+8+10);
	/*
	 * Structure version is next two bytes: major.minor.
	 */
	e-&gt;version = *p++;
	e-&gt;revision = *p++;

	assert(p == (uchar*)v+8+10+2);
	/*
	 * Basic display parameters / features.
	 */
	/*
	 * Video input definition byte: 0x80 tells whether it is
	 * an analog or digital screen; we ignore the other bits.
	 * See p. 15 of the standard.
	 */
	vid = *p++;
	if(vid &amp; 0x80)
		e-&gt;flags |= Fdigital;

	e-&gt;dxcm = *p++;
	e-&gt;dycm = *p++;
	e-&gt;gamma = 100 + *p++;
	dpms = *p++;
	if(dpms &amp; 0x80)
		e-&gt;flags |= Fdpmsstandby;
	if(dpms &amp; 0x40)
		e-&gt;flags |= Fdpmssuspend;
	if(dpms &amp; 0x20)
		e-&gt;flags |= Fdpmsactiveoff;
	if((dpms &amp; 0x18) == 0x00)
		e-&gt;flags |= Fmonochrome;
	if(dpms &amp; 0x01)
		e-&gt;flags |= Fgtf;

	assert(p == (uchar*)v+8+10+2+5);
	/*
	 * Color characteristics currently ignored.
	 */
	p += 10;

	assert(p == (uchar*)v+8+10+2+5+10);
	/*
	 * Established timings: a bitmask of 19 preset timings.
	 */
	estab = (p[0]&lt;&lt;16) | (p[1]&lt;&lt;8) | p[2];
	p += 3;
	
	for(i=0, m=1&lt;&lt;23; i&lt;nelem(estabtime); i++, m&gt;&gt;=1)
		if(estab &amp; m)
			if(vesalookup(&amp;mode, estabtime[i]) == 0)
				e-&gt;modelist = addmode(e-&gt;modelist,  mode);

	assert(p == (uchar*)v+8+10+2+5+10+3);
	/*
	 * Standard Timing Identifications: eight 2-byte selectors
	 * of more standard timings.
	 */
	for(i=0; i&lt;8; i++, p+=2)
		if(decodesti(&amp;mode, p+2*i) == 0)
			e-&gt;modelist = addmode(e-&gt;modelist, mode);

	assert(p == (uchar*)v+8+10+2+5+10+3+16);
	/*
	 * Detailed Timings
	 */
fprint(2, "dt\n");
	for(i=0; i&lt;4; i++, p+=18) {
fprint(2, "%.8H\n", p);
		if(p[0] || p[1]) {	/* detailed timing block: p[0] or p[1] != 0 */
			if(decodedtb(&amp;mode, p) == 0)
				e-&gt;modelist = addmode(e-&gt;modelist, mode);
		} else if(p[2]==0) {	/* monitor descriptor block */
			switch(p[3]) {
			case 0xFF:	/* monitor serial number (13-byte ascii, 0A terminated) */
				if(q = memchr(p+5, 0x0A, 13))
					*q = '\0';
				memset(e-&gt;serialstr, 0, sizeof(e-&gt;serialstr));
				strncpy(e-&gt;serialstr, (char*)p+5, 13);
				break;
			case 0xFE:	/* ascii string (13-byte ascii, 0A terminated) */
				break;
			case 0xFD:	/* monitor range limits */
				print("fd %.18H\n", p);
				e-&gt;rrmin = p[5];
				e-&gt;rrmax = p[6];
				e-&gt;hrmin = p[7]*1000;
				e-&gt;hrmax = p[8]*1000;
				if(p[9] != 0xFF)
					e-&gt;pclkmax = p[9]*10*1000000;
				break;
			case 0xFC:	/* monitor name (13-byte ascii, 0A terminated) */
				if(q = memchr(p+5, 0x0A, 13))
					*q = '\0';
				memset(e-&gt;name, 0, sizeof(e-&gt;name));
				strncpy(e-&gt;name, (char*)p+5, 13);
				break;
			case 0xFB:	/* extra color point data */
				break;
			case 0xFA:	/* extra standard timing identifications */
				for(i=0; i&lt;6; i++)
					if(decodesti(&amp;mode, p+5+2*i) == 0)
						e-&gt;modelist = addmode(e-&gt;modelist, mode);
				break;
			}
		}
	}

	assert(p == (uchar*)v+8+10+2+5+10+3+16+72);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

