<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/virge.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/virge.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * S3 Trio/ViRGE/Savage4
 * Requires work.
 */

/* on some cards, savage4mem[1] == 8, but i don't know how to tell. -rsc */
static uchar savage4mem[] = { 2, 4, 8, 12, 16, 32, 0, 32};
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i, id;
	char *p;

	/*
	 * The Trio/ViRGE variants have some extra sequencer registers
	 * which need to be unlocked for access.
	 */
	vgaxo(Seqx, 0x08, 0x06);
	s3generic.snarf(vga, ctlr);

	for(i = 0x08; i &lt; 0x4F; i++)
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);
	vga-&gt;crt[0x2D] = vgaxi(Crtx, 0x2D);
	vga-&gt;crt[0x2E] = vgaxi(Crtx, 0x2E);
	vga-&gt;crt[0x2F] = vgaxi(Crtx, 0x2F);
	for(i = 0x70; i &lt; 0x99; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);

	id = (vga-&gt;crt[0x2D]&lt;&lt;8)|vga-&gt;crt[0x2E];
	switch(id){

	default:
		trace("Unknown ViRGE/Trio64+ - 0x%4.4uX\n",
			(vga-&gt;crt[0x2D]&lt;&lt;8)|vga-&gt;crt[0x2E]);
		/*FALLTHROUGH*/

	case 0x8810:				/* Microsoft Virtual PC 2004 */
	case 0x8811:				/* Trio64+ */
		vga-&gt;r[1] = 3;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 31;
		vga-&gt;f[1] = 135000000;
		trace("Trio64+\n");
		break;

	case 0x8812:				/* Aurora64V+ */
		vga-&gt;r[1] = 3;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 63;
		vga-&gt;f[1] = 135000000;
		trace("Aurora64V+\n");
		break;

	case 0x8901:				/* Trio64V2 */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 31;
		vga-&gt;f[1] = 170000000;
		trace("Trio64V2\n");
		break;

	case 0x5631:				/* ViRGE */
		vga-&gt;r[1] = 3;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 31;
		vga-&gt;f[1] = 135000000;
		vga-&gt;apz = 64*1024*1024;
		trace("ViRGE\n");
		break;

	case 0x8A01:				/* ViRGE/[DG]X */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 31;
		vga-&gt;f[1] = 170000000;
		trace("ViRGE/[DG]X\n");
		break;

	case 0x8A10:				/* ViRGE/GX2 */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 31;
		vga-&gt;f[1] = 170000000;
		vga-&gt;apz = 64*1024*1024;
		trace("ViRGE/GX2\n");
		/*
		 * Memory encoding on the ViRGE/GX2 is different.
		 */
		switch((vga-&gt;crt[0x36]&gt;&gt;6) &amp; 0x03){

		case 0x01:
			vga-&gt;vmz = 4*1024*1024;
			break;

		case 0x03:
			vga-&gt;vmz = 2*1024*1024;
			break;
		}
		break;

	case 0x883D:				/* ViRGE/VX */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 31;
		vga-&gt;f[1] = 220000000;
		vga-&gt;apz = 64*1024*1024;
		trace("ViRGE/VX\n");
		/*
		 * Memory encoding on the ViRGE/VX is different.
		 */
		vga-&gt;vmz = (2*(((vga-&gt;crt[0x36]&gt;&gt;5) &amp; 0x03)+1)) * 1*1024*1024;
		break;

	case 0x8C10:				/* Savage MX/MV */
	case 0x8C12:				/* Savage4/IX-MV */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 127;
		vga-&gt;f[1] = 135000000;		/* without clock-doubling */
		for(i = 0x50; i &lt; 0x70; i++)
			vga-&gt;sequencer[i] = vgaxi(Seqx, i);
		vga-&gt;apz = 128*1024*1024;
		vga-&gt;vmz = savage4mem[vga-&gt;crt[0x36]&gt;&gt;5] * 1024 * 1024;
		trace("Savage4/IX-MV\n");
		break;

	case 0x8C2E:				/* SuperSavage/IXC16 */
		/*
		 * This is all guessed, from the Savage4/IX,
		 * inspection of the card (apz), and web pages
		 * talking about the chip (f[1]).  It seems to
		 * work on the IBM Thinkpad T23.
		 *
		 * XXX only 1024x768 works, not 1400x1050.
		 */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 127;
		vga-&gt;n[1] = 127;
		vga-&gt;f[1] = 135000000;		/* 300000000 after doubling? */
		for(i = 0x50; i &lt; 0x70; i++)
			vga-&gt;sequencer[i] = vgaxi(Seqx, i);
		vga-&gt;apz = 64*1024*1024;
		vga-&gt;vmz = savage4mem[vga-&gt;crt[0x36]&gt;&gt;5] * 1024 * 1024;
		trace("SuperSavage/IXC16\n");
		break;

	case 0x8A22:				/* Savage4 */
	case 0x8A25:				/* ProSavage PN133 */
	case 0x8A26:				/* ProSavage KN133 */
	case 0x8D04:				/* ProSavage DDR, K.Okamoto */
		vga-&gt;r[1] = 4;
		vga-&gt;m[1] = 511;
		vga-&gt;n[1] = 127;
		vga-&gt;f[1] = 300000000;	

		vga-&gt;apz = 128*1024*1024;
		vga-&gt;vmz = savage4mem[vga-&gt;crt[0x36]&gt;&gt;5] * 1024 * 1024;
		trace("Savage4\n");
		break;
	}

	/*
	 * Work out the part speed-grade from name. Name can have,
	 * e.g. '-135' on the end for 135MHz part.
	 */
	if(p = strrchr(ctlr-&gt;name, '-'))
		vga-&gt;f[1] = strtoul(p+1, 0, 0) * 1000000;

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga *vga, Ctlr* ctlr)
{
	int id;

	id = (vga-&gt;crt[0x2D]&lt;&lt;8)|(vga-&gt;crt[0x2E]);
	switch(id){
	case 0x8C2E:				/* SuperSavage/IXC16 */
	case 0x8C10:				/* Savage MX/MV */
	case 0x8C12:				/* Savage4/IX-MV */
	case 0x8A22:				/* Savage4 */
	case 0x8A25:				/* ProSavage PN133 */
	case 0x8A26:				/* ProSavage KN133 */
	case 0x8D04:				/* ProSavabe DDR, K.Okamoto */
		/*
		 * Round up so stride is multiple of 16.
		 */
		if(vga-&gt;virtx%16)
			vga-&gt;virtx = (vga-&gt;virtx+15)&amp;~15;
		break;
	}

	ctlr-&gt;flag |= Hlinear|Hpclk2x8|Henhanced|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	char *p, *val;
	Mode *mode;
	ulong pclk, x;
	int id, noclockset, width;

	id = (vga-&gt;crt[0x2D]&lt;&lt;8)|vga-&gt;crt[0x2E];
	mode = vga-&gt;mode;

	/*
	 * double 16bpp horizontal timings on ViRGE/[DG]X
	 * leaves overflow bit-fiddling to s3generic.init
	 */
	if((id == 0x8A01) &amp;&amp; ((mode-&gt;z+7)/8 == 2)){
		resyncinit(vga, ctlr, Uenhanced, 0);
		vga-&gt;crt[0x00] = ((mode-&gt;ht * 2) &gt;&gt; 3) - 5;
		vga-&gt;crt[0x01] = ((mode-&gt;x * 2) &gt;&gt; 3) - 1;
		vga-&gt;crt[0x02] = ((mode-&gt;shb * 2) &gt;&gt; 3) - 1;
		x = (mode-&gt;ehb * 2) &gt;&gt; 3;
		vga-&gt;crt[0x03] = 0x80 | (x &amp; 0x1F);
		vga-&gt;crt[0x04] = (mode-&gt;shs * 2) &gt;&gt; 3;
		vga-&gt;crt[0x05] = ((mode-&gt;ehs * 2) &gt;&gt; 3) &amp; 0x1F;
		if(x &amp; 0x20)
			vga-&gt;crt[0x05] |= 0x80;
	}
	s3generic.init(vga, ctlr);

	/*
	 * Work out the part speed-grade from name. Name can have,
	 * e.g. '-135' on the end for 135MHz part.
	 */
	noclockset = 0;
	if(p = strrchr(ctlr-&gt;name, '-'))
		vga-&gt;f[1] = strtoul(p+1, 0, 0) * 1000000;
	pclk = vga-&gt;f[1];

	if(vga-&gt;mode-&gt;z &gt; 8)
		width = vga-&gt;virtx*(vga-&gt;mode-&gt;z/8);
	else
		width = vga-&gt;virtx*(8/vga-&gt;mode-&gt;z);
	
	switch(id){

	case 0x8810:				/* Microsoft Virtual PC 2004 */
	case 0x8811:				/* Trio64+ */
		/*
		 * Part comes in -135MHz speed grade. In 8-bit mode
		 * the maximum DCLK is 80MHz. In 2x8-bit mode the maximum
		 * DCLK is 135MHz using the internal clock doubler.
		 */
		if((ctlr-&gt;flag &amp; Hpclk2x8) &amp;&amp; vga-&gt;mode-&gt;z == 8){
			if(vga-&gt;f[0] &gt; 80000000)
				ctlr-&gt;flag |= Upclk2x8;
		}
		else
			pclk = 80000000;

		vga-&gt;crt[0x67] &amp;= ~0xF2;
		if(ctlr-&gt;flag &amp; Upclk2x8){
			vga-&gt;sequencer[0x15] |= 0x10;
			vga-&gt;sequencer[0x18] |= 0x80;
			/*
			 * There's a little strip of the border
			 * appears on the left in resolutions
			 * 1280 and above if the 0x02 bit isn't
			 * set (when it appears on the right...).
			 */
			vga-&gt;crt[0x67] |= 0x10;
		}
	
		/*
		 * VLB address latch delay.
		 */
		if((vga-&gt;crt[0x36] &amp; 0x03) == 0x01)
			vga-&gt;crt[0x58] &amp;= ~0x08;

		/*
		 * Display memory access control.
		 */
		vga-&gt;crt[0x60] = 0xFF;

		if(vga-&gt;mode-&gt;z &gt; 8)
			error("trio64: depth %d not supported\n", vga-&gt;mode-&gt;z);
		break;

	case 0x8901:				/* Trio64V2 */
		vga-&gt;crt[0x90] = 0;
		vga-&gt;crt[0x91] = 0;
		break;
	case 0x8A10:				/* ViRGE/GX2 */
		vga-&gt;crt[0x90] = 0;
	
		vga-&gt;crt[0x31] |= 0x08;

		vga-&gt;crt[0x13] = (width&gt;&gt;3) &amp; 0xFF;
		vga-&gt;crt[0x51] &amp;= ~0x30;
		vga-&gt;crt[0x51] |= (width&gt;&gt;7) &amp; 0x30;

		/*
		 * Increase primary FIFO threshold
	 	 * to reduce flicker and tearing.
		 */
		vga-&gt;crt[0x85] = 0x0F;

		/*FALLTHROUGH*/
	case 0x5631:				/* ViRGE */
	case 0x8A01:				/* ViRGE/[DG]X */
		if(id == 0x8A01){
			x = mode-&gt;x * ((mode-&gt;z + 7) / 8);
			x = (x + 7) / 8;
			vga-&gt;crt[0x91] = x &amp; 0xFF;
			vga-&gt;crt[0x90] = (x &gt;&gt; 8) | 0x80;
		}
	case 0x883D:				/* ViRGE/VX */
		vga-&gt;crt[0x60] &amp;= 0x0F;
		/*FALLTHROUGH*/
	case 0x8812:				/* Aurora64V+ */
		if(id == 0x8812)		/* Aurora64V+ */
			noclockset = 1;
		vga-&gt;crt[0x65] = 0;
		vga-&gt;crt[0x66] = 0x89;
		vga-&gt;crt[0x67] = 0;

		if(id == 0x883D){		/* ViRGE/VX */
			/*
			 * Put the VRAM in 1-cycle EDO mode.  
			 * If it is not put in this mode, hardware acceleration
			 * will leave little turds on the screen when hwfill is used.
			 */
			vga-&gt;crt[0x36] &amp;= ~0x0C;

			if(vga-&gt;mode-&gt;x &gt; 800 &amp;&amp; vga-&gt;mode-&gt;z == 8)
				vga-&gt;crt[0x67] = 0x10;
			else
				vga-&gt;crt[0x67] = 0;

	 		/*
			 * Adjustments to the generic settings:
			 *	heuristic fiddling.
			 *
			 * We used to set crt[0x66] to 0x89, but setting it
			 * to 0x90 seems to allow us (and more importantly the card)
			 * to access more than 2MB of memory.
			 */
			vga-&gt;crt[0x66] = 0x90;
			vga-&gt;crt[0x58] &amp;= ~0x88;
			vga-&gt;crt[0x58] |= 0x40;
			if(vga-&gt;mode-&gt;x &gt; 640 &amp;&amp; vga-&gt;mode-&gt;z &gt;= 8)
				vga-&gt;crt[0x63] |= 0x01;
			else
				vga-&gt;crt[0x63] &amp;= ~0x01;
		}

		/*
		 * The high nibble is the mode; or'ing in 0x02 turns
		 * on support for gamma correction via the DACs, but I
		 * haven't figured out how to turn on the 8-bit DACs,
		 * so gamma correction stays off.
		 */
		switch(vga-&gt;mode-&gt;z){
		case 1:
		case 2:
		case 4:
		case 8:
		default:
			vga-&gt;crt[0x67] |= 0x00;
			break;
		case 15:
			vga-&gt;crt[0x67] |= 0x30;
			break;
		case 16:
			vga-&gt;crt[0x67] |= 0x50;
			break;
		case 24:
			if(id == 0x8A10)	/* GX2 has to be different */
				vga-&gt;crt[0x67] |= 0x70;
			else
				vga-&gt;crt[0x67] |= 0xD0;
			break;
		case 32:
			/*
			 * The ViRGE and ViRGE/VX manuals make no mention of
			 * 32-bit mode (which the GX/2 calls 24-bit unpacked mode).
			 */
			if(id != 0x8A10)
				error("32-bit mode only supported on the GX/2\n");
			vga-&gt;crt[0x67] |= 0xD0;
			break;
		}

		/*
		 * Set new MMIO method
		 */
		vga-&gt;crt[0x53] &amp;= ~0x18;
		vga-&gt;crt[0x53] |= 0x08;

		break;

	case 0x8C2E:				/* SuperSavage/IXC16 (let's try this -rsc) */
	case 0x8C10:				/* Savage MX/MV */
	case 0x8C12:				/* Savage4/IX-MV */
		/*
		 * Experience shows the -1 (according to the manual)
		 * is incorrect.
		 */
		x = width/8 /*-1*/;
		vga-&gt;crt[0x91] = x;
		vga-&gt;crt[0x90] &amp;= ~0x07;
		vga-&gt;crt[0x90] |= (x&gt;&gt;8) &amp; 0x07;

	case 0x8D04:				/* ProSavage DDR, K.Okamoto */
		x = mode-&gt;x * ((mode-&gt;z + 7) / 8);
		x = (x + 7) / 8;
		vga-&gt;crt[0x91] = x &amp; 0xFF;
		vga-&gt;crt[0x90] = (x &gt;&gt; 8) | 0x80;

		/*FALLTHROUGH*/

	case 0x8A22:				/* Savage4 */
	case 0x8A25:				/* ProSavage PN133 */
	case 0x8A26:				/* ProSavage KN133 */
		/*
		 * The Savage 4 is frustratingly similar to the
		 * ViRGE/GX2, but has enough slight differences
		 * to warrant special treatment.  Blog.
		 */
		vga-&gt;crt[0x66] = 0x89;
		vga-&gt;crt[0x67] = 0;
		vga-&gt;crt[0x85] = 0x02;
		vga-&gt;crt[0x31] |= 0x08;

		vga-&gt;crt[0x13] = (width&gt;&gt;3) &amp; 0xFF;
		vga-&gt;crt[0x51] &amp;= ~0x30;
		vga-&gt;crt[0x51] |= (width&gt;&gt;7) &amp; 0x30;

		/* pull screen width from GBD for graphics engine. */
		vga-&gt;crt[0x50] = 0xC1;	/* set color mode */

		/*
		 * The high nibble is the mode; or'ing in 0x02 turns
		 * on support for gamma correction via the DACs, but I
		 * haven't figured out how to turn on the 8-bit DACs,
		 * so gamma correction stays off.
		 */
		switch(vga-&gt;mode-&gt;z){
		default:
			error("%d-bit mode not supported on savage 4\n", vga-&gt;mode-&gt;z);
		case 8:
			vga-&gt;crt[0x67] |= 0x00;
			vga-&gt;crt[0x50] |= 0&lt;&lt;4;
			break;
		case 15:
			vga-&gt;crt[0x67] |= 0x20;
			vga-&gt;crt[0x50] |= 1&lt;&lt;4;
			break;
		case 16:
			vga-&gt;crt[0x67] |= 0x40;
			vga-&gt;crt[0x50] |= 1&lt;&lt;4;
			/*
			 * Manual says this should be accompanied by setting
			 * the clock-doubled modes but this seems to be the
			 * right answer.
			 * Should check if using doubled modes tidies any of
			 * this up.
			 */
			if(id == 0x8C12 || id == 0x8C2E || id == 0x8C10)
				vga-&gt;crt[0x67] |= 0x10;
			break;
		case 32:
			vga-&gt;crt[0x67] |= 0xD0;
			vga-&gt;crt[0x50] |= 3&lt;&lt;4;
			break;
		}
		break;
	}

	/*
	 * Clock bits. If the desired video clock is
	 * one of the two standard VGA clocks it can just be
	 * set using bits &lt;3:2&gt; of vga-&gt;misc, otherwise we
	 * need to programme the DCLK PLL.
	 */
	if(val = dbattr(vga-&gt;mode-&gt;attr, "noclockset")){
		 if((noclockset = strtol(val, &amp;p, 0)) == 0 &amp;&amp; p == val)
			error("%s: invalid 'noclockset' attr\n", ctlr-&gt;name);
	}
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	vga-&gt;misc &amp;= ~0x0C;
	if(vga-&gt;f[0] == VgaFreq0){
		/* nothing to do */;
	}
	else if(vga-&gt;f[0] == VgaFreq1)
		vga-&gt;misc |= 0x04;
	else if(noclockset){
		/*
		 * Don't touch the clock on the Aurora64V+
		 * and optionally on some others.
		 */
		vga-&gt;misc |= 0x0C;
	}
	else{
		if(vga-&gt;f[0] &gt; pclk)
			error("%s: invalid pclk - %lud\n",
				ctlr-&gt;name, vga-&gt;f[0]);

		trio64clock(vga, ctlr);
		switch(id){

		case 0x8A10:			/* ViRGE/GX2 */
			vga-&gt;sequencer[0x12] = (vga-&gt;r[0]&lt;&lt;6)|vga-&gt;n[0];
			if(vga-&gt;r[0] &amp; 0x04)
				vga-&gt;sequencer[0x29] |= 0x01;
			else
				vga-&gt;sequencer[0x29] &amp;= ~0x01;
			break;

		case 0x8C2E:			/* SuperSavage/IXC16 (let's try this -rsc) */
		case 0x8C10:			/* Savage MX/MV */
		case 0x8C12:			/* Savage4/IX-MV */
		case 0x8A22:			/* Savage4 */
		case 0x8A25:			/* ProSavage PN133 */
		case 0x8A26:			/* ProSavage KN133 */
		case 0x8D04:			/* ProSavage DDR, K.Okamoto */
			vga-&gt;sequencer[0x12] = (vga-&gt;r[0]&lt;&lt;6)|(vga-&gt;n[0] &amp; 0x3F);
			vga-&gt;sequencer[0x39] &amp;= ~0x01;
			vga-&gt;sequencer[0x29] &amp;= ~0x1C;
			if(vga-&gt;r[0] &amp; 0x04)
				vga-&gt;sequencer[0x29] |= (1&lt;&lt;2);
			if(vga-&gt;m[0] &amp; 0x100)
				vga-&gt;sequencer[0x29] |= (1&lt;&lt;3);
			if(vga-&gt;n[0] &amp; 0x40)
				vga-&gt;sequencer[0x29] |= (1&lt;&lt;4);
			break;

		default:
			vga-&gt;sequencer[0x12] = (vga-&gt;r[0]&lt;&lt;5)|vga-&gt;n[0];
			break;
		}
		vga-&gt;sequencer[0x13] = vga-&gt;m[0];
		vga-&gt;misc |= 0x0C;
	}

	/*
	 * Internal clock generator.
	 */
	vga-&gt;sequencer[0x15] &amp;= ~0x31;
	vga-&gt;sequencer[0x15] |= 0x02;
	vga-&gt;sequencer[0x18] &amp;= ~0x80;

	/*
	 * Start display FIFO fetch.
	 */
	x = (vga-&gt;crt[0]+vga-&gt;crt[4]+1)/2;
	vga-&gt;crt[0x3B] = x;
	if(x &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x40;

	/*
	 * Display memory access control.
	 * Calculation of the M-parameter (Crt54) is
	 * memory-system and dot-clock dependent, the
	 * values below are guesses from dumping
	 * registers.
	 * The Savage4 does not document 0x54,
	 * but we leave this anyway.
	 */
	if(vga-&gt;mode-&gt;x &lt;= 800)
		vga-&gt;crt[0x54] = 0xE8;
	else if(vga-&gt;mode-&gt;x &lt;= 1024 &amp;&amp; id != 0x8C12 &amp;&amp; id != 0x8C2E)
		vga-&gt;crt[0x54] = 0xA8;
	else
		vga-&gt;crt[0x54] = 0x00/*0x48*/;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	int id;
	ushort advfunc;

	s3generic.load(vga, ctlr);

	/*
	 * Load the PLL registers if necessary.
	 * Not sure if the variable-delay method of setting the
	 * PLL will work without a write here to vga-&gt;misc,
	 * so use the immediate-load method by toggling bit 5
	 * of Seq15 if necessary.
	 */
	vgaxo(Seqx, 0x12, vga-&gt;sequencer[0x12]);
	vgaxo(Seqx, 0x13, vga-&gt;sequencer[0x13]);
	id = (vga-&gt;crt[0x2D]&lt;&lt;8)|vga-&gt;crt[0x2E];
	switch(id){
	case 0x883D:				/* ViRGE/VX*/
		vgaxo(Crtx, 0x36, vga-&gt;crt[0x36]);
		break;
	case 0x8A10:				/* ViRGE/GX2 */
		vgaxo(Seqx, 0x29, vga-&gt;sequencer[0x29]);
		break;
	case 0x8C2E:				/* SuperSavage/IXC16 (let's try this -rsc) */
	case 0x8C12:				/* Savage4/IX-MV */
		vgaxo(Crtx, 0x90, vga-&gt;crt[0x90]);
		vgaxo(Crtx, 0x91, vga-&gt;crt[0x91]);
		/*FALLTHROUGH*/
	case 0x8A22:				/* Savage4 */
	case 0x8A25:				/* ProSavage PN133 */
	case 0x8A26:				/* ProSavage KN133 */
	case 0x8D04:				/* ProSavage DDR, K.Okamoto */
		vgaxo(Seqx, 0x29, vga-&gt;sequencer[0x29]);
		vgaxo(Seqx, 0x39, vga-&gt;sequencer[0x39]);
		break;
	}
	if((vga-&gt;misc &amp; 0x0C) == 0x0C)
		vgaxo(Seqx, 0x15, vga-&gt;sequencer[0x15]|0x20);
	vgaxo(Seqx, 0x15, vga-&gt;sequencer[0x15]);
	vgaxo(Seqx, 0x18, vga-&gt;sequencer[0x18]);

	vgaxo(Crtx, 0x60, vga-&gt;crt[0x60]);
	vgaxo(Crtx, 0x63, vga-&gt;crt[0x63]);
	vgaxo(Crtx, 0x65, vga-&gt;crt[0x65]);
	vgaxo(Crtx, 0x66, vga-&gt;crt[0x66]);
	vgaxo(Crtx, 0x67, vga-&gt;crt[0x67]);

	switch(id){

	case 0x8810:				/* Microsoft Virtual PC 2004 */
	case 0x8811:				/* Trio64+ */
		advfunc = 0x0000;
		if(ctlr-&gt;flag &amp; Uenhanced)
			advfunc = 0x0001;
		outportw(0x4AE8, advfunc);
		break;
	case 0x8901:				/* Trio64V2 */
	case 0x8A01:				/* ViRGE/[DG]X */
		vgaxo(Crtx, 0x90, vga-&gt;crt[0x90]);
		vgaxo(Crtx, 0x91, vga-&gt;crt[0x91]);
		break;
	case 0x8A10:				/* ViRGE/GX2 */
		vgaxo(Crtx, 0x90, vga-&gt;crt[0x90]);
		vgaxo(Crtx, 0x31, vga-&gt;crt[0x31]);
		vgaxo(Crtx, 0x13, vga-&gt;crt[0x13]);
		vgaxo(Crtx, 0x51, vga-&gt;crt[0x51]);
		vgaxo(Crtx, 0x85, vga-&gt;crt[0x85]);
		break;
	case 0x8D04:				/* ProSavage DDR, K.Okamoto */
		vgaxo(Crtx, 0x90, vga-&gt;crt[0x90]);		//K.Okamoto
		vgaxo(Crtx, 0x91, vga-&gt;crt[0x91]);		//K.Okamoto
	case 0x8C2E:				/* SuperSavage/IXC16 (let's try this -rsc) */
	case 0x8C12:				/* Savage4/IX-MV */
	case 0x8A22:				/* Savage4 */
	case 0x8A25:				/* ProSavage PN133 */
	case 0x8A26:				/* ProSavage KN133 */
		vgaxo(Crtx, 0x31, vga-&gt;crt[0x31]);
		vgaxo(Crtx, 0x13, vga-&gt;crt[0x13]);
		vgaxo(Crtx, 0x51, vga-&gt;crt[0x51]);
		vgaxo(Crtx, 0x85, vga-&gt;crt[0x85]);
		vgaxo(Crtx, 0x50, vga-&gt;crt[0x50]);
		break;
	}
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i, id;
	ulong dclk, m, n, r;

	s3generic.dump(vga, ctlr);
	printitem(ctlr-&gt;name, "Crt70");
	for(i = 0x70; i &lt; 0x99; i++)
		printreg(vga-&gt;crt[i]);

	printitem(ctlr-&gt;name, "Seq08");
	for(i = 0x08; i &lt; 0x10; i++)
		printreg(vga-&gt;sequencer[i]);
	printitem(ctlr-&gt;name, "Seq10");
	for(i = 0x10; i &lt; 0x50; i++)
		printreg(vga-&gt;sequencer[i]);
	id = (vga-&gt;crt[0x2D]&lt;&lt;8)|vga-&gt;crt[0x2E];
	switch(id){
	default:
		break;

	case 0x8812:				/* Aurora64V+ */
	case 0x8C2E:				/* SuperSavage/IXC16 (let's try this -rsc) */
	case 0x8C12:				/* Savage4/IX-MV */
		printitem(ctlr-&gt;name, "Seq50");
		for(i = 0x50; i &lt; 0x70; i++)
			printreg(vga-&gt;sequencer[i]);
		break;
	}

	printitem(ctlr-&gt;name, "Crt2D");
	printreg(vga-&gt;crt[0x2D]);
	printreg(vga-&gt;crt[0x2E]);
	printreg(vga-&gt;crt[0x2F]);

	m = vga-&gt;sequencer[0x13] &amp; vga-&gt;m[1];
	n = vga-&gt;sequencer[0x12] &amp; vga-&gt;n[1];
	r = (vga-&gt;sequencer[0x12]&gt;&gt;5) &amp; 0x03;

	switch(id){
	case 0x8812:				/* Aurora64V+ */
		r = (vga-&gt;sequencer[0x12]&gt;&gt;6) &amp; 0x03;
		break;
	case 0x8A01:				/* ViRGE/[DG]X */
		r = (vga-&gt;sequencer[0x12]&gt;&gt;5) &amp; 0x07;
		break;
	case 0x8A10:				/* ViRGE/GX2 */
		r = (vga-&gt;sequencer[0x12]&gt;&gt;6) &amp; 0x03;
		r |= (vga-&gt;sequencer[0x29] &amp; 0x01)&lt;&lt;2;
		break;
	case 0x8C2E:				/* SuperSavage/IXC16 (let's try this -rsc) */
	case 0x8C12:				/* Savage4/IX-MV */
	case 0x8A22:				/* Savage4 */
	case 0x8A25:				/* ProSavage PN133 */
	case 0x8A26:				/* ProSavage KN133 */
	case 0x8D04:				/* Prosavage DDR, K.Okamoto */
		m = vga-&gt;sequencer[0x13] &amp; 0xFF;
		if(vga-&gt;sequencer[0x29] &amp; (1&lt;&lt;3))
			m |= 0x100;
		if(vga-&gt;sequencer[0x29] &amp; (1&lt;&lt;4))
			n |= 0x40;
		r = (vga-&gt;sequencer[0x12]&gt;&gt;6) &amp; 0x03;
		r |= (vga-&gt;sequencer[0x29] &amp; (1&lt;&lt;2));
		break;
	}

	dclk = (m+2)*RefFreq;
	dclk /= (n+2)*(1&lt;&lt;r);
	printitem(ctlr-&gt;name, "dclk m n r");
	Bprint(&amp;stdout, "%9ld %8ld       - %8ld %8ld\n", dclk, m, n, r);

	m = vga-&gt;sequencer[0x11] &amp; 0x7F;
	n = vga-&gt;sequencer[0x10] &amp; 0x1F;
	r = (vga-&gt;sequencer[0x10]&gt;&gt;5) &amp; 0x03;	/* might be GX/2 specific */
	dclk = (m+2)*RefFreq;
	dclk /= (n+2)*(1&lt;&lt;r);
	printitem(ctlr-&gt;name, "mclk m n r");
	Bprint(&amp;stdout, "%9ld %8ld       - %8ld %8ld\n", dclk, m, n, r);
}

Ctlr virge = {
	"virge",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

