<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/w30c516.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/w30c516.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * IC Works W30C516 ZOOMDAC.
 * DSP-based Multimedia RAMDAC.
 */
enum {
	Cr0		= 0x00,		/* Control register 0 */
	Mid		= 0x01,		/* Manufacturer's identification register */
	Did		= 0x02,		/* Device identification register */
	Cr1		= 0x03,		/* Control register 1 */

	Reserve1	= 0x04,		/* Reserved (16-bit) */
	Reserve2	= 0x06,		/* Reserved (16-bit) */
	Reserve3	= 0x08,		/* Reserved (16-bit) */
	Reserve4	= 0x0A,		/* Reserved (16-bit) */

	IstartX		= 0x0C,		/* Image Start X (16-bit) */
	IstartY		= 0x0E,		/* Image Start Y (16-bit) */
	IendX		= 0x10,		/* Image End X (16-bit) */
	IendY		= 0x12,		/* Image End Y (16-bit) */

	RatioX		= 0x14,		/* Ratio X (16-bit) */
	RatioY		= 0x16,		/* Ratio Y (16-bit) */
	OffsetX		= 0x18,		/* Offset X (16-bit) */
	OffsetY		= 0x1A,		/* Offset Y (16-bit) */

	TestR		= 0x1C,		/* Red signature analysis register */
	TestG		= 0x1D,		/* Green signature analysis register */
	TestB		= 0x1E,		/* Blue signature analysis register */

	Nir		= 0x1F,		/* number of indirect registers */
};

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hpclk2x8|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong grade, pclk;
	char *p;

	/*
	 * Part comes in -170, -135 and -110MHz speed-grades.
	 * In 8-bit mode the max. PCLK is 135MHz for the -170 part
	 * and the speed-grade for the others. In 2x8-bit mode, the max.
	 * PCLK is the speed-grade, using the 2x doubler.
	 * Work out the part speed-grade from name. Name can have,
	 * e.g. '-135' on the end  for 135MHz part.
	 */
	grade = 110000000;
	if(p = strrchr(ctlr-&gt;name, '-'))
		grade = strtoul(p+1, 0, 0) * 1000000;

	if(grade == 170000000)
		pclk = 135000000;
	else
		pclk = grade;

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 * Check it's within range.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;

	/*
	 * Determine whether to use 2x8-bit mode or not.
	 * If yes and the clock has already been initialised,
	 * initialise it again. There is no real frequency
	 * restriction, it's really just a lower limit on what's
	 * available in some clock generator chips.
	 */
	if(vga-&gt;ctlr &amp;&amp; (vga-&gt;ctlr-&gt;flag &amp; Hpclk2x8) &amp;&amp; vga-&gt;mode-&gt;z == 8 &amp;&amp; vga-&gt;f[0] &gt;= 60000000){
		vga-&gt;f[0] /= 2;
		resyncinit(vga, ctlr, Upclk2x8, 0);
	}
	if(vga-&gt;f[0] &gt; pclk)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	uchar mode, x;

	/*
	 * Put the chip to sleep.
	 */
	attdaco(Cr0, 0x08);

	mode = 0x00;
	if(ctlr-&gt;flag &amp; Upclk2x8)
		mode = 0x20;

	/*
	 * Set the mode in the RAMDAC, setting 6/8-bit colour
	 * as appropriate and waking the chip back up.
	 */
	if(vga-&gt;mode-&gt;z == 8 &amp;&amp; 0)
		mode |= 0x02;
	x = attdaci(Cr1) &amp; 0x80;
	attdaco(Cr1, x);
	attdaco(Cr0, mode);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga*, Ctlr* ctlr)
{
	int i;

	printitem(ctlr-&gt;name, "");
	for(i = 0; i &lt; Nir; i++)
		printreg(attdaci(i));
}

Ctlr w30c516 = {
	"w30c516",			/* name */
	0,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

