<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/awk/tran.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/awk/tran.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/****************************************************************
Copyright (C) Lucent Technologies 1997
All Rights Reserved

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that the copyright notice and this
permission notice and warranty disclaimer appear in supporting
documentation, and that the name Lucent Technologies or any of
its entities not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.

LUCENT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
IN NO EVENT SHALL LUCENT OR ANY OF ITS ENTITIES BE LIABLE FOR ANY
SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
THIS SOFTWARE.
****************************************************************/

#define	DEBUG
#include &lt;stdio.h&gt;
#include &lt;math.h&gt;
#include &lt;ctype.h&gt;
#include &lt;string.h&gt;
#include &lt;stdlib.h&gt;
#include "awk.h"
#include "y.tab.h"

#define	FULLTAB	2	/* rehash when table gets this x full */
#define	GROWTAB 4	/* grow table by this factor */

Array	*symtab;	/* main symbol table */

char	**FS;		/* initial field sep */
char	**RS;		/* initial record sep */
char	**OFS;		/* output field sep */
char	**ORS;		/* output record sep */
char	**OFMT;		/* output format for numbers */
char	**CONVFMT;	/* format for conversions in getsval */
Awkfloat *NF;		/* number of fields in current record */
Awkfloat *NR;		/* number of current record */
Awkfloat *FNR;		/* number of current record in current file */
char	**FILENAME;	/* current filename argument */
Awkfloat *ARGC;		/* number of arguments from command line */
char	**SUBSEP;	/* subscript separator for a[i,j,k]; default \034 */
Awkfloat *RSTART;	/* start of re matched with ~; origin 1 (!) */
Awkfloat *RLENGTH;	/* length of same */

Cell	*nrloc;		/* NR */
Cell	*nfloc;		/* NF */
Cell	*fnrloc;	/* FNR */
Array	*ARGVtab;	/* symbol table containing ARGV[...] */
Array	*ENVtab;	/* symbol table containing ENVIRON[...] */
Cell	*rstartloc;	/* RSTART */
Cell	*rlengthloc;	/* RLENGTH */
Cell	*symtabloc;	/* SYMTAB */

Cell	*nullloc;	/* a guaranteed empty cell */
Node	*nullnode;	/* zero&amp;null, converted into a node for comparisons */
Cell	*literal0;

extern Cell **fldtab;

void syminit(void)	/* initialize symbol table with builtin vars */
{
	literal0 = setsymtab("0", "0", 0.0, NUM|STR|CON|DONTFREE, symtab);
	/* this is used for if(x)... tests: */
	nullloc = setsymtab("$zero&amp;null", "", 0.0, NUM|STR|CON|DONTFREE, symtab);
	nullnode = celltonode(nullloc, CCON);

	FS = &amp;setsymtab("FS", " ", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	RS = &amp;setsymtab("RS", "\n", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	OFS = &amp;setsymtab("OFS", " ", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	ORS = &amp;setsymtab("ORS", "\n", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	OFMT = &amp;setsymtab("OFMT", "%.6g", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	CONVFMT = &amp;setsymtab("CONVFMT", "%.6g", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	FILENAME = &amp;setsymtab("FILENAME", "", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	nfloc = setsymtab("NF", "", 0.0, NUM, symtab);
	NF = &amp;nfloc-&gt;fval;
	nrloc = setsymtab("NR", "", 0.0, NUM, symtab);
	NR = &amp;nrloc-&gt;fval;
	fnrloc = setsymtab("FNR", "", 0.0, NUM, symtab);
	FNR = &amp;fnrloc-&gt;fval;
	SUBSEP = &amp;setsymtab("SUBSEP", "\034", 0.0, STR|DONTFREE, symtab)-&gt;sval;
	rstartloc = setsymtab("RSTART", "", 0.0, NUM, symtab);
	RSTART = &amp;rstartloc-&gt;fval;
	rlengthloc = setsymtab("RLENGTH", "", 0.0, NUM, symtab);
	RLENGTH = &amp;rlengthloc-&gt;fval;
	symtabloc = setsymtab("SYMTAB", "", 0.0, ARR, symtab);
	symtabloc-&gt;sval = (char *) symtab;
}

void arginit(int ac, char **av)	/* set up ARGV and ARGC */
{
	Cell *cp;
	int i;
	char temp[50];

	ARGC = &amp;setsymtab("ARGC", "", (Awkfloat) ac, NUM, symtab)-&gt;fval;
	cp = setsymtab("ARGV", "", 0.0, ARR, symtab);
	ARGVtab = makesymtab(NSYMTAB);	/* could be (int) ARGC as well */
	cp-&gt;sval = (char *) ARGVtab;
	for (i = 0; i &lt; ac; i++) {
		sprintf(temp, "%d", i);
		if (is_number(*av))
			setsymtab(temp, *av, atof(*av), STR|NUM, ARGVtab);
		else
			setsymtab(temp, *av, 0.0, STR, ARGVtab);
		av++;
	}
}

void envinit(char **envp)	/* set up ENVIRON variable */
{
	Cell *cp;
	char *p;

	cp = setsymtab("ENVIRON", "", 0.0, ARR, symtab);
	ENVtab = makesymtab(NSYMTAB);
	cp-&gt;sval = (char *) ENVtab;
	for ( ; *envp; envp++) {
		if ((p = strchr(*envp, '=')) == NULL)
			continue;
		*p++ = 0;	/* split into two strings at = */
		if (is_number(p))
			setsymtab(*envp, p, atof(p), STR|NUM, ENVtab);
		else
			setsymtab(*envp, p, 0.0, STR, ENVtab);
		p[-1] = '=';	/* restore in case env is passed down to a shell */
	}
}

Array *makesymtab(int n)	/* make a new symbol table */
{
	Array *ap;
	Cell **tp;

	ap = (Array *) malloc(sizeof(Array));
	tp = (Cell **) calloc(n, sizeof(Cell *));
	if (ap == NULL || tp == NULL)
		FATAL("out of space in makesymtab");
	ap-&gt;nelem = 0;
	ap-&gt;size = n;
	ap-&gt;tab = tp;
	return(ap);
}

void freesymtab(Cell *ap)	/* free a symbol table */
{
	Cell *cp, *temp;
	Array *tp;
	int i;

	if (!isarr(ap))
		return;
	tp = (Array *) ap-&gt;sval;
	if (tp == NULL)
		return;
	for (i = 0; i &lt; tp-&gt;size; i++) {
		for (cp = tp-&gt;tab[i]; cp != NULL; cp = temp) {
			xfree(cp-&gt;nval);
			if (freeable(cp))
				xfree(cp-&gt;sval);
			temp = cp-&gt;cnext;	/* avoids freeing then using */
			free(cp); 
		}
		tp-&gt;tab[i] = 0;
	}
	free(tp-&gt;tab);
	free(tp);
}

void freeelem(Cell *ap, char *s)	/* free elem s from ap (i.e., ap["s"] */
{
	Array *tp;
	Cell *p, *prev = NULL;
	int h;
	
	tp = (Array *) ap-&gt;sval;
	h = hash(s, tp-&gt;size);
	for (p = tp-&gt;tab[h]; p != NULL; prev = p, p = p-&gt;cnext)
		if (strcmp(s, p-&gt;nval) == 0) {
			if (prev == NULL)	/* 1st one */
				tp-&gt;tab[h] = p-&gt;cnext;
			else			/* middle somewhere */
				prev-&gt;cnext = p-&gt;cnext;
			if (freeable(p))
				xfree(p-&gt;sval);
			free(p-&gt;nval);
			free(p);
			tp-&gt;nelem--;
			return;
		}
}

Cell *setsymtab(char *n, char *s, Awkfloat f, unsigned t, Array *tp)
{
	int h;
	Cell *p;

	if (n != NULL &amp;&amp; (p = lookup(n, tp)) != NULL) {
		   dprintf( ("setsymtab found %p: n=%s s=\"%s\" f=%g t=%o\n",
			p, p-&gt;nval, p-&gt;sval, p-&gt;fval, p-&gt;tval) );
		return(p);
	}
	p = (Cell *) malloc(sizeof(Cell));
	if (p == NULL)
		FATAL("out of space for symbol table at %s", n);
	p-&gt;nval = tostring(n);
	p-&gt;sval = s ? tostring(s) : tostring("");
	p-&gt;fval = f;
	p-&gt;tval = t;
	p-&gt;csub = CUNK;
	p-&gt;ctype = OCELL;
	tp-&gt;nelem++;
	if (tp-&gt;nelem &gt; FULLTAB * tp-&gt;size)
		rehash(tp);
	h = hash(n, tp-&gt;size);
	p-&gt;cnext = tp-&gt;tab[h];
	tp-&gt;tab[h] = p;
	   dprintf( ("setsymtab set %p: n=%s s=\"%s\" f=%g t=%o\n",
		p, p-&gt;nval, p-&gt;sval, p-&gt;fval, p-&gt;tval) );
	return(p);
}

int hash(char *s, int n)	/* form hash value for string s */
{
	unsigned hashval;

	for (hashval = 0; *s != '\0'; s++)
		hashval = (*s + 31 * hashval);
	return hashval % n;
}

void rehash(Array *tp)	/* rehash items in small table into big one */
{
	int i, nh, nsz;
	Cell *cp, *op, **np;

	nsz = GROWTAB * tp-&gt;size;
	np = (Cell **) calloc(nsz, sizeof(Cell *));
	if (np == NULL)		/* can't do it, but can keep running. */
		return;		/* someone else will run out later. */
	for (i = 0; i &lt; tp-&gt;size; i++) {
		for (cp = tp-&gt;tab[i]; cp; cp = op) {
			op = cp-&gt;cnext;
			nh = hash(cp-&gt;nval, nsz);
			cp-&gt;cnext = np[nh];
			np[nh] = cp;
		}
	}
	free(tp-&gt;tab);
	tp-&gt;tab = np;
	tp-&gt;size = nsz;
}

Cell *lookup(char *s, Array *tp)	/* look for s in tp */
{
	Cell *p;
	int h;

	h = hash(s, tp-&gt;size);
	for (p = tp-&gt;tab[h]; p != NULL; p = p-&gt;cnext)
		if (strcmp(s, p-&gt;nval) == 0)
			return(p);	/* found it */
	return(NULL);			/* not found */
}

Awkfloat setfval(Cell *vp, Awkfloat f)	/* set float val of a Cell */
{
	int fldno;

	if ((vp-&gt;tval &amp; (NUM | STR)) == 0) 
		funnyvar(vp, "assign to");
	if (isfld(vp)) {
		donerec = 0;	/* mark $0 invalid */
		fldno = atoi(vp-&gt;nval);
		if (fldno &gt; *NF)
			newfld(fldno);
		   dprintf( ("setting field %d to %g\n", fldno, f) );
	} else if (isrec(vp)) {
		donefld = 0;	/* mark $1... invalid */
		donerec = 1;
	}
	if (freeable(vp))
		xfree(vp-&gt;sval); /* free any previous string */
	vp-&gt;tval &amp;= ~STR;	/* mark string invalid */
	vp-&gt;tval |= NUM;	/* mark number ok */
	   dprintf( ("setfval %p: %s = %g, t=%o\n", vp, vp-&gt;nval, f, vp-&gt;tval) );
	return vp-&gt;fval = f;
}

void funnyvar(Cell *vp, char *rw)
{
	if (isarr(vp))
		FATAL("can't %s %s; it's an array name.", rw, vp-&gt;nval);
	if (vp-&gt;tval &amp; FCN)
		FATAL("can't %s %s; it's a function.", rw, vp-&gt;nval);
	WARNING("funny variable %p: n=%s s=\"%s\" f=%g t=%o",
		vp, vp-&gt;nval, vp-&gt;sval, vp-&gt;fval, vp-&gt;tval);
}

char *setsval(Cell *vp, char *s)	/* set string val of a Cell */
{
	char *t;
	int fldno;

	   dprintf( ("starting setsval %p: %s = \"%s\", t=%o\n", vp, vp-&gt;nval, s, vp-&gt;tval) );
	if ((vp-&gt;tval &amp; (NUM | STR)) == 0)
		funnyvar(vp, "assign to");
	if (isfld(vp)) {
		donerec = 0;	/* mark $0 invalid */
		fldno = atoi(vp-&gt;nval);
		if (fldno &gt; *NF)
			newfld(fldno);
		   dprintf( ("setting field %d to %s (%p)\n", fldno, s, s) );
	} else if (isrec(vp)) {
		donefld = 0;	/* mark $1... invalid */
		donerec = 1;
	}
	t = tostring(s);	/* in case it's self-assign */
	vp-&gt;tval &amp;= ~NUM;
	vp-&gt;tval |= STR;
	if (freeable(vp))
		xfree(vp-&gt;sval);
	vp-&gt;tval &amp;= ~DONTFREE;
	   dprintf( ("setsval %p: %s = \"%s (%p)\", t=%o\n", vp, vp-&gt;nval, t,t, vp-&gt;tval) );
	return(vp-&gt;sval = t);
}

Awkfloat getfval(Cell *vp)	/* get float val of a Cell */
{
	if ((vp-&gt;tval &amp; (NUM | STR)) == 0)
		funnyvar(vp, "read value of");
	if (isfld(vp) &amp;&amp; donefld == 0)
		fldbld();
	else if (isrec(vp) &amp;&amp; donerec == 0)
		recbld();
	if (!isnum(vp)) {	/* not a number */
		vp-&gt;fval = atof(vp-&gt;sval);	/* best guess */
		if (is_number(vp-&gt;sval) &amp;&amp; !(vp-&gt;tval&amp;CON))
			vp-&gt;tval |= NUM;	/* make NUM only sparingly */
	}
	   dprintf( ("getfval %p: %s = %g, t=%o\n", vp, vp-&gt;nval, vp-&gt;fval, vp-&gt;tval) );
	return(vp-&gt;fval);
}

char *getsval(Cell *vp)	/* get string val of a Cell */
{
	char s[100];	/* BUG: unchecked */
	double dtemp;

	if ((vp-&gt;tval &amp; (NUM | STR)) == 0)
		funnyvar(vp, "read value of");
	if (isfld(vp) &amp;&amp; donefld == 0)
		fldbld();
	else if (isrec(vp) &amp;&amp; donerec == 0)
		recbld();
	if (isstr(vp) == 0) {
		if (freeable(vp))
			xfree(vp-&gt;sval);
		if (modf(vp-&gt;fval, &amp;dtemp) == 0)	/* it's integral */
			sprintf(s, "%.30g", vp-&gt;fval);
		else
			sprintf(s, *CONVFMT, vp-&gt;fval);
		vp-&gt;sval = tostring(s);
		vp-&gt;tval &amp;= ~DONTFREE;
		vp-&gt;tval |= STR;
	}
	   dprintf( ("getsval %p: %s = \"%s (%p)\", t=%o\n", vp, vp-&gt;nval, vp-&gt;sval, vp-&gt;sval, vp-&gt;tval) );
	return(vp-&gt;sval);
}

char *tostring(char *s)	/* make a copy of string s */
{
	char *p;

	p = (char *) malloc(strlen(s)+1);
	if (p == NULL)
		FATAL("out of space in tostring on %s", s);
	strcpy(p, s);
	return(p);
}

char *qstring(char *s, int delim)	/* collect string up to next delim */
{
	char *os = s;
	int c, n;
	char *buf, *bp;

	if ((buf = (char *) malloc(strlen(s)+3)) == NULL)
		FATAL( "out of space in qstring(%s)", s);
	for (bp = buf; (c = *s) != delim; s++) {
		if (c == '\n')
			SYNTAX( "newline in string %.20s...", os );
		else if (c != '\\')
			*bp++ = c;
		else {	/* \something */
			c = *++s;
			if (c == 0) {	/* \ at end */
				*bp++ = '\\';
				break;	/* for loop */
			}	
			switch (c) {
			case '\\':	*bp++ = '\\'; break;
			case 'n':	*bp++ = '\n'; break;
			case 't':	*bp++ = '\t'; break;
			case 'b':	*bp++ = '\b'; break;
			case 'f':	*bp++ = '\f'; break;
			case 'r':	*bp++ = '\r'; break;
			default:
				if (!isdigit(c)) {
					*bp++ = c;
					break;
				}
				n = c - '0';
				if (isdigit(s[1])) {
					n = 8 * n + *++s - '0';
					if (isdigit(s[1]))
						n = 8 * n + *++s - '0';
				}
				*bp++ = n;
				break;
			}
		}
	}
	*bp++ = 0;
	return buf;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

