<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/bzip2/lib/bzcompress.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/bzip2/lib/bzcompress.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * THIS FILE IS NOT IDENTICAL TO THE ORIGINAL
 * FROM THE BZIP2 DISTRIBUTION.
 *
 * It has been modified, mainly to break the library
 * into smaller pieces.
 *
 * Russ Cox
 * rsc@plan9.bell-labs.com
 * July 2000
 */

/*-------------------------------------------------------------*/
/*--- Library top-level functions.                          ---*/
/*---                                               bzlib.c ---*/
/*-------------------------------------------------------------*/

/*--
  This file is a part of bzip2 and/or libbzip2, a program and
  library for lossless, block-sorting data compression.

  Copyright (C) 1996-2000 Julian R Seward.  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

  2. The origin of this software must not be misrepresented; you must 
     not claim that you wrote the original software.  If you use this 
     software in a product, an acknowledgment in the product 
     documentation would be appreciated but is not required.

  3. Altered source versions must be plainly marked as such, and must
     not be misrepresented as being the original software.

  4. The name of the author may not be used to endorse or promote 
     products derived from this software without specific prior written 
     permission.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  Julian Seward, Cambridge, UK.
  jseward@acm.org
  bzip2/libbzip2 version 1.0 of 21 March 2000

  This program is based on (at least) the work of:
     Mike Burrows
     David Wheeler
     Peter Fenwick
     Alistair Moffat
     Radford Neal
     Ian H. Witten
     Robert Sedgewick
     Jon L. Bentley

  For more information on these sources, see the manual.
--*/

/*--
   CHANGES
   ~~~~~~~
   0.9.0 -- original version.

   0.9.0a/b -- no changes in this file.

   0.9.0c
      * made zero-length BZ_FLUSH work correctly in bzCompress().
      * fixed bzWrite/bzRead to ignore zero-length requests.
      * fixed bzread to correctly handle read requests after EOF.
      * wrong parameter order in call to bzDecompressInit in
        bzBuffToBuffDecompress.  Fixed.
--*/

#include "os.h"
#include "bzlib.h"
#include "bzlib_private.h"

/*---------------------------------------------------*/
/*--- Compression stuff                           ---*/
/*---------------------------------------------------*/

/*---------------------------------------------------*/
static
void prepare_new_block ( EState* s )
{
   Int32 i;
   s-&gt;nblock = 0;
   s-&gt;numZ = 0;
   s-&gt;state_out_pos = 0;
   BZ_INITIALISE_CRC ( s-&gt;blockCRC );
   for (i = 0; i &lt; 256; i++) s-&gt;inUse[i] = False;
   s-&gt;blockNo++;
}


/*---------------------------------------------------*/
static
void init_RL ( EState* s )
{
   s-&gt;state_in_ch  = 256;
   s-&gt;state_in_len = 0;
}


static
Bool isempty_RL ( EState* s )
{
   if (s-&gt;state_in_ch &lt; 256 &amp;&amp; s-&gt;state_in_len &gt; 0)
      return False; else
      return True;
}


/*---------------------------------------------------*/
int BZ_API(BZ2_bzCompressInit) 
                    ( bz_stream* strm, 
                     int        blockSize100k,
                     int        verbosity,
                     int        workFactor )
{
   Int32   n;
   EState* s;

   if (!bz_config_ok()) return BZ_CONFIG_ERROR;

   if (strm == NULL || 
       blockSize100k &lt; 1 || blockSize100k &gt; 9 ||
       workFactor &lt; 0 || workFactor &gt; 250)
     return BZ_PARAM_ERROR;

   if (workFactor == 0) workFactor = 30;
   if (strm-&gt;bzalloc == NULL) strm-&gt;bzalloc = default_bzalloc;
   if (strm-&gt;bzfree == NULL) strm-&gt;bzfree = default_bzfree;

   s = BZALLOC( sizeof(EState) );
   if (s == NULL) return BZ_MEM_ERROR;
   s-&gt;strm = strm;

   s-&gt;arr1 = NULL;
   s-&gt;arr2 = NULL;
   s-&gt;ftab = NULL;

   n       = 100000 * blockSize100k;
   s-&gt;arr1 = BZALLOC( n                  * sizeof(UInt32) );
   s-&gt;arr2 = BZALLOC( (n+BZ_N_OVERSHOOT) * sizeof(UInt32) );
   s-&gt;ftab = BZALLOC( 65537              * sizeof(UInt32) );

   if (s-&gt;arr1 == NULL || s-&gt;arr2 == NULL || s-&gt;ftab == NULL) {
      if (s-&gt;arr1 != NULL) BZFREE(s-&gt;arr1);
      if (s-&gt;arr2 != NULL) BZFREE(s-&gt;arr2);
      if (s-&gt;ftab != NULL) BZFREE(s-&gt;ftab);
      if (s       != NULL) BZFREE(s);
      return BZ_MEM_ERROR;
   }

   s-&gt;blockNo           = 0;
   s-&gt;state             = BZ_S_INPUT;
   s-&gt;mode              = BZ_M_RUNNING;
   s-&gt;combinedCRC       = 0;
   s-&gt;blockSize100k     = blockSize100k;
   s-&gt;nblockMAX         = 100000 * blockSize100k - 19;
   s-&gt;verbosity         = verbosity;
   s-&gt;workFactor        = workFactor;

   s-&gt;block             = (UChar*)s-&gt;arr2;
   s-&gt;mtfv              = (UInt16*)s-&gt;arr1;
   s-&gt;zbits             = NULL;
   s-&gt;ptr               = (UInt32*)s-&gt;arr1;

   strm-&gt;state          = s;
   strm-&gt;total_in_lo32  = 0;
   strm-&gt;total_in_hi32  = 0;
   strm-&gt;total_out_lo32 = 0;
   strm-&gt;total_out_hi32 = 0;
   init_RL ( s );
   prepare_new_block ( s );
   return BZ_OK;
}


/*---------------------------------------------------*/
static
void add_pair_to_block ( EState* s )
{
   Int32 i;
   UChar ch = (UChar)(s-&gt;state_in_ch);
   for (i = 0; i &lt; s-&gt;state_in_len; i++) {
      BZ_UPDATE_CRC( s-&gt;blockCRC, ch );
   }
   s-&gt;inUse[s-&gt;state_in_ch] = True;
   switch (s-&gt;state_in_len) {
      case 1:
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         break;
      case 2:
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         break;
      case 3:
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         break;
      default:
         s-&gt;inUse[s-&gt;state_in_len-4] = True;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = (UChar)ch; s-&gt;nblock++;
         s-&gt;block[s-&gt;nblock] = ((UChar)(s-&gt;state_in_len-4));
         s-&gt;nblock++;
         break;
   }
}


/*---------------------------------------------------*/
static
void flush_RL ( EState* s )
{
   if (s-&gt;state_in_ch &lt; 256) add_pair_to_block ( s );
   init_RL ( s );
}


/*---------------------------------------------------*/
#define ADD_CHAR_TO_BLOCK(zs,zchh0)               \
{                                                 \
   UInt32 zchh = (UInt32)(zchh0);                 \
   /*-- fast track the common case --*/           \
   if (zchh != zs-&gt;state_in_ch &amp;&amp;                 \
       zs-&gt;state_in_len == 1) {                   \
      UChar ch = (UChar)(zs-&gt;state_in_ch);        \
      BZ_UPDATE_CRC( zs-&gt;blockCRC, ch );          \
      zs-&gt;inUse[zs-&gt;state_in_ch] = True;          \
      zs-&gt;block[zs-&gt;nblock] = (UChar)ch;          \
      zs-&gt;nblock++;                               \
      zs-&gt;state_in_ch = zchh;                     \
   }                                              \
   else                                           \
   /*-- general, uncommon cases --*/              \
   if (zchh != zs-&gt;state_in_ch ||                 \
      zs-&gt;state_in_len == 255) {                  \
      if (zs-&gt;state_in_ch &lt; 256)                  \
         add_pair_to_block ( zs );                \
      zs-&gt;state_in_ch = zchh;                     \
      zs-&gt;state_in_len = 1;                       \
   } else {                                       \
      zs-&gt;state_in_len++;                         \
   }                                              \
}


/*---------------------------------------------------*/
static
Bool copy_input_until_stop ( EState* s )
{
   Bool progress_in = False;

   if (s-&gt;mode == BZ_M_RUNNING) {

      /*-- fast track the common case --*/
      while (True) {
         /*-- block full? --*/
         if (s-&gt;nblock &gt;= s-&gt;nblockMAX) break;
         /*-- no input? --*/
         if (s-&gt;strm-&gt;avail_in == 0) break;
         progress_in = True;
         ADD_CHAR_TO_BLOCK ( s, (UInt32)(*((UChar*)(s-&gt;strm-&gt;next_in))) ); 
         s-&gt;strm-&gt;next_in++;
         s-&gt;strm-&gt;avail_in--;
         s-&gt;strm-&gt;total_in_lo32++;
         if (s-&gt;strm-&gt;total_in_lo32 == 0) s-&gt;strm-&gt;total_in_hi32++;
      }

   } else {

      /*-- general, uncommon case --*/
      while (True) {
         /*-- block full? --*/
         if (s-&gt;nblock &gt;= s-&gt;nblockMAX) break;
         /*-- no input? --*/
         if (s-&gt;strm-&gt;avail_in == 0) break;
         /*-- flush/finish end? --*/
         if (s-&gt;avail_in_expect == 0) break;
         progress_in = True;
         ADD_CHAR_TO_BLOCK ( s, (UInt32)(*((UChar*)(s-&gt;strm-&gt;next_in))) ); 
         s-&gt;strm-&gt;next_in++;
         s-&gt;strm-&gt;avail_in--;
         s-&gt;strm-&gt;total_in_lo32++;
         if (s-&gt;strm-&gt;total_in_lo32 == 0) s-&gt;strm-&gt;total_in_hi32++;
         s-&gt;avail_in_expect--;
      }
   }
   return progress_in;
}


/*---------------------------------------------------*/
static
Bool copy_output_until_stop ( EState* s )
{
   Bool progress_out = False;

   while (True) {

      /*-- no output space? --*/
      if (s-&gt;strm-&gt;avail_out == 0) break;

      /*-- block done? --*/
      if (s-&gt;state_out_pos &gt;= s-&gt;numZ) break;

      progress_out = True;
      *(s-&gt;strm-&gt;next_out) = s-&gt;zbits[s-&gt;state_out_pos];
      s-&gt;state_out_pos++;
      s-&gt;strm-&gt;avail_out--;
      s-&gt;strm-&gt;next_out++;
      s-&gt;strm-&gt;total_out_lo32++;
      if (s-&gt;strm-&gt;total_out_lo32 == 0) s-&gt;strm-&gt;total_out_hi32++;
   }

   return progress_out;
}


/*---------------------------------------------------*/
static
Bool handle_compress ( bz_stream* strm )
{
   Bool progress_in  = False;
   Bool progress_out = False;
   EState* s = strm-&gt;state;
   
   while (True) {

      if (s-&gt;state == BZ_S_OUTPUT) {
         progress_out |= copy_output_until_stop ( s );
         if (s-&gt;state_out_pos &lt; s-&gt;numZ) break;
         if (s-&gt;mode == BZ_M_FINISHING &amp;&amp; 
             s-&gt;avail_in_expect == 0 &amp;&amp;
             isempty_RL(s)) break;
         prepare_new_block ( s );
         s-&gt;state = BZ_S_INPUT;
         if (s-&gt;mode == BZ_M_FLUSHING &amp;&amp; 
             s-&gt;avail_in_expect == 0 &amp;&amp;
             isempty_RL(s)) break;
      }

      if (s-&gt;state == BZ_S_INPUT) {
         progress_in |= copy_input_until_stop ( s );
         if (s-&gt;mode != BZ_M_RUNNING &amp;&amp; s-&gt;avail_in_expect == 0) {
            flush_RL ( s );
            BZ2_compressBlock ( s, (Bool)(s-&gt;mode == BZ_M_FINISHING) );
            s-&gt;state = BZ_S_OUTPUT;
         }
         else
         if (s-&gt;nblock &gt;= s-&gt;nblockMAX) {
            BZ2_compressBlock ( s, False );
            s-&gt;state = BZ_S_OUTPUT;
         }
         else
         if (s-&gt;strm-&gt;avail_in == 0) {
            break;
         }
      }

   }

   return progress_in || progress_out;
}

/*---------------------------------------------------*/
int BZ_API(BZ2_bzCompress) ( bz_stream *strm, int action )
{
   Bool progress;
   EState* s;
   if (strm == NULL) return BZ_PARAM_ERROR;
   s = strm-&gt;state;
   if (s == NULL) return BZ_PARAM_ERROR;
   if (s-&gt;strm != strm) return BZ_PARAM_ERROR;

   preswitch:
   switch (s-&gt;mode) {

      case BZ_M_IDLE:
         return BZ_SEQUENCE_ERROR;

      case BZ_M_RUNNING:
         if (action == BZ_RUN) {
            progress = handle_compress ( strm );
            return progress ? BZ_RUN_OK : BZ_PARAM_ERROR;
         } 
         else
	 if (action == BZ_FLUSH) {
            s-&gt;avail_in_expect = strm-&gt;avail_in;
            s-&gt;mode = BZ_M_FLUSHING;
            goto preswitch;
         }
         else
         if (action == BZ_FINISH) {
            s-&gt;avail_in_expect = strm-&gt;avail_in;
            s-&gt;mode = BZ_M_FINISHING;
            goto preswitch;
         }
         else 
            return BZ_PARAM_ERROR;

      case BZ_M_FLUSHING:
         if (action != BZ_FLUSH) return BZ_SEQUENCE_ERROR;
         if (s-&gt;avail_in_expect != s-&gt;strm-&gt;avail_in) 
            return BZ_SEQUENCE_ERROR;
         progress = handle_compress ( strm );
         if (!progress) return BZ_SEQUENCE_ERROR;	//rsc added
         if (s-&gt;avail_in_expect &gt; 0 || !isempty_RL(s) ||
             s-&gt;state_out_pos &lt; s-&gt;numZ) return BZ_FLUSH_OK;
         s-&gt;mode = BZ_M_RUNNING;
         return BZ_RUN_OK;

      case BZ_M_FINISHING:
         if (action != BZ_FINISH) return BZ_SEQUENCE_ERROR;
         if (s-&gt;avail_in_expect != s-&gt;strm-&gt;avail_in) 
            return BZ_SEQUENCE_ERROR;
         progress = handle_compress ( strm );
         if (!progress) return BZ_SEQUENCE_ERROR;
         if (s-&gt;avail_in_expect &gt; 0 || !isempty_RL(s) ||
             s-&gt;state_out_pos &lt; s-&gt;numZ) return BZ_FINISH_OK;
         s-&gt;mode = BZ_M_IDLE;
         return BZ_STREAM_END;
   }
   return BZ_OK; /*--not reached--*/
}


/*---------------------------------------------------*/
int BZ_API(BZ2_bzCompressEnd)  ( bz_stream *strm )
{
   EState* s;
   if (strm == NULL) return BZ_PARAM_ERROR;
   s = strm-&gt;state;
   if (s == NULL) return BZ_PARAM_ERROR;
   if (s-&gt;strm != strm) return BZ_PARAM_ERROR;

   if (s-&gt;arr1 != NULL) BZFREE(s-&gt;arr1);
   if (s-&gt;arr2 != NULL) BZFREE(s-&gt;arr2);
   if (s-&gt;ftab != NULL) BZFREE(s-&gt;ftab);
   BZFREE(strm-&gt;state);

   strm-&gt;state = NULL;   

   return BZ_OK;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

