<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/bzip2/lib/bzdecompress.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/bzip2/lib/bzdecompress.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * THIS FILE IS NOT IDENTICAL TO THE ORIGINAL
 * FROM THE BZIP2 DISTRIBUTION.
 *
 * It has been modified, mainly to break the library
 * into smaller pieces.
 *
 * Russ Cox
 * rsc@plan9.bell-labs.com
 * July 2000
 */

/*-------------------------------------------------------------*/
/*--- Library top-level functions.                          ---*/
/*---                                               bzlib.c ---*/
/*-------------------------------------------------------------*/

/*--
  This file is a part of bzip2 and/or libbzip2, a program and
  library for lossless, block-sorting data compression.

  Copyright (C) 1996-2000 Julian R Seward.  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

  2. The origin of this software must not be misrepresented; you must 
     not claim that you wrote the original software.  If you use this 
     software in a product, an acknowledgment in the product 
     documentation would be appreciated but is not required.

  3. Altered source versions must be plainly marked as such, and must
     not be misrepresented as being the original software.

  4. The name of the author may not be used to endorse or promote 
     products derived from this software without specific prior written 
     permission.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  Julian Seward, Cambridge, UK.
  jseward@acm.org
  bzip2/libbzip2 version 1.0 of 21 March 2000

  This program is based on (at least) the work of:
     Mike Burrows
     David Wheeler
     Peter Fenwick
     Alistair Moffat
     Radford Neal
     Ian H. Witten
     Robert Sedgewick
     Jon L. Bentley

  For more information on these sources, see the manual.
--*/

/*--
   CHANGES
   ~~~~~~~
   0.9.0 -- original version.

   0.9.0a/b -- no changes in this file.

   0.9.0c
      * made zero-length BZ_FLUSH work correctly in bzCompress().
      * fixed bzWrite/bzRead to ignore zero-length requests.
      * fixed bzread to correctly handle read requests after EOF.
      * wrong parameter order in call to bzDecompressInit in
        bzBuffToBuffDecompress.  Fixed.
--*/

#include "os.h"
#include "bzlib.h"
#include "bzlib_private.h"

/*---------------------------------------------------*/
/*--- Decompression stuff                         ---*/
/*---------------------------------------------------*/

/*---------------------------------------------------*/
int BZ_API(BZ2_bzDecompressInit) 
                     ( bz_stream* strm, 
                       int        verbosity,
                       int        small )
{
   DState* s;

   if (!bz_config_ok()) return BZ_CONFIG_ERROR;

   if (strm == NULL) return BZ_PARAM_ERROR;
   if (small != 0 &amp;&amp; small != 1) return BZ_PARAM_ERROR;
   if (verbosity &lt; 0 || verbosity &gt; 4) return BZ_PARAM_ERROR;

   if (strm-&gt;bzalloc == NULL) strm-&gt;bzalloc = default_bzalloc;
   if (strm-&gt;bzfree == NULL) strm-&gt;bzfree = default_bzfree;

   s = BZALLOC( sizeof(DState) );
   if (s == NULL) return BZ_MEM_ERROR;
   s-&gt;strm                  = strm;
   strm-&gt;state              = s;
   s-&gt;state                 = BZ_X_MAGIC_1;
   s-&gt;bsLive                = 0;
   s-&gt;bsBuff                = 0;
   s-&gt;calculatedCombinedCRC = 0;
   strm-&gt;total_in_lo32      = 0;
   strm-&gt;total_in_hi32      = 0;
   strm-&gt;total_out_lo32     = 0;
   strm-&gt;total_out_hi32     = 0;
   s-&gt;smallDecompress       = (Bool)small;
   s-&gt;ll4                   = NULL;
   s-&gt;ll16                  = NULL;
   s-&gt;tt                    = NULL;
   s-&gt;currBlockNo           = 0;
   s-&gt;verbosity             = verbosity;

   return BZ_OK;
}


/*---------------------------------------------------*/
static
void unRLE_obuf_to_output_FAST ( DState* s )
{
   UChar k1;

   if (s-&gt;blockRandomised) {

      while (True) {
         /* try to finish existing run */
         while (True) {
            if (s-&gt;strm-&gt;avail_out == 0) return;
            if (s-&gt;state_out_len == 0) break;
            *( (UChar*)(s-&gt;strm-&gt;next_out) ) = s-&gt;state_out_ch;
            BZ_UPDATE_CRC ( s-&gt;calculatedBlockCRC, s-&gt;state_out_ch );
            s-&gt;state_out_len--;
            s-&gt;strm-&gt;next_out++;
            s-&gt;strm-&gt;avail_out--;
            s-&gt;strm-&gt;total_out_lo32++;
            if (s-&gt;strm-&gt;total_out_lo32 == 0) s-&gt;strm-&gt;total_out_hi32++;
         }
   
         /* can a new run be started? */
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) return;
               
   
         s-&gt;state_out_len = 1;
         s-&gt;state_out_ch = s-&gt;k0;
         BZ_GET_FAST(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         s-&gt;state_out_len = 2;
         BZ_GET_FAST(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         s-&gt;state_out_len = 3;
         BZ_GET_FAST(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         BZ_GET_FAST(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         s-&gt;state_out_len = ((Int32)k1) + 4;
         BZ_GET_FAST(s-&gt;k0); BZ_RAND_UPD_MASK; 
         s-&gt;k0 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
      }

   } else {

      /* restore */
      UInt32        c_calculatedBlockCRC = s-&gt;calculatedBlockCRC;
      UChar         c_state_out_ch       = s-&gt;state_out_ch;
      Int32         c_state_out_len      = s-&gt;state_out_len;
      Int32         c_nblock_used        = s-&gt;nblock_used;
      Int32         c_k0                 = s-&gt;k0;
      UInt32*       c_tt                 = s-&gt;tt;
      UInt32        c_tPos               = s-&gt;tPos;
      char*         cs_next_out          = s-&gt;strm-&gt;next_out;
      unsigned int  cs_avail_out         = s-&gt;strm-&gt;avail_out;
      /* end restore */

      UInt32       avail_out_INIT = cs_avail_out;
      Int32        s_save_nblockPP = s-&gt;save_nblock+1;
      unsigned int total_out_lo32_old;

      while (True) {

         /* try to finish existing run */
         if (c_state_out_len &gt; 0) {
            while (True) {
               if (cs_avail_out == 0) goto return_notr;
               if (c_state_out_len == 1) break;
               *( (UChar*)(cs_next_out) ) = c_state_out_ch;
               BZ_UPDATE_CRC ( c_calculatedBlockCRC, c_state_out_ch );
               c_state_out_len--;
               cs_next_out++;
               cs_avail_out--;
            }
            s_state_out_len_eq_one:
            {
               if (cs_avail_out == 0) { 
                  c_state_out_len = 1; goto return_notr;
               };
               *( (UChar*)(cs_next_out) ) = c_state_out_ch;
               BZ_UPDATE_CRC ( c_calculatedBlockCRC, c_state_out_ch );
               cs_next_out++;
               cs_avail_out--;
            }
         }   
         /* can a new run be started? */
         if (c_nblock_used == s_save_nblockPP) {
            c_state_out_len = 0; goto return_notr;
         };   
         c_state_out_ch = c_k0;
         BZ_GET_FAST_C(k1); c_nblock_used++;
         if (k1 != c_k0) { 
            c_k0 = k1; goto s_state_out_len_eq_one; 
         };
         if (c_nblock_used == s_save_nblockPP) 
            goto s_state_out_len_eq_one;
   
         c_state_out_len = 2;
         BZ_GET_FAST_C(k1); c_nblock_used++;
         if (c_nblock_used == s_save_nblockPP) continue;
         if (k1 != c_k0) { c_k0 = k1; continue; };
   
         c_state_out_len = 3;
         BZ_GET_FAST_C(k1); c_nblock_used++;
         if (c_nblock_used == s_save_nblockPP) continue;
         if (k1 != c_k0) { c_k0 = k1; continue; };
   
         BZ_GET_FAST_C(k1); c_nblock_used++;
         c_state_out_len = ((Int32)k1) + 4;
         BZ_GET_FAST_C(c_k0); c_nblock_used++;
      }

      return_notr:
      total_out_lo32_old = s-&gt;strm-&gt;total_out_lo32;
      s-&gt;strm-&gt;total_out_lo32 += (avail_out_INIT - cs_avail_out);
      if (s-&gt;strm-&gt;total_out_lo32 &lt; total_out_lo32_old)
         s-&gt;strm-&gt;total_out_hi32++;

      /* save */
      s-&gt;calculatedBlockCRC = c_calculatedBlockCRC;
      s-&gt;state_out_ch       = c_state_out_ch;
      s-&gt;state_out_len      = c_state_out_len;
      s-&gt;nblock_used        = c_nblock_used;
      s-&gt;k0                 = c_k0;
      s-&gt;tt                 = c_tt;
      s-&gt;tPos               = c_tPos;
      s-&gt;strm-&gt;next_out     = cs_next_out;
      s-&gt;strm-&gt;avail_out    = cs_avail_out;
      /* end save */
   }
}



/*---------------------------------------------------*/
__inline__ Int32 BZ2_indexIntoF ( Int32 indx, Int32 *cftab )
{
   Int32 nb, na, mid;
   nb = 0;
   na = 256;
   do {
      mid = (nb + na) &gt;&gt; 1;
      if (indx &gt;= cftab[mid]) nb = mid; else na = mid;
   }
   while (na - nb != 1);
   return nb;
}


/*---------------------------------------------------*/
static
void unRLE_obuf_to_output_SMALL ( DState* s )
{
   UChar k1;

   if (s-&gt;blockRandomised) {

      while (True) {
         /* try to finish existing run */
         while (True) {
            if (s-&gt;strm-&gt;avail_out == 0) return;
            if (s-&gt;state_out_len == 0) break;
            *( (UChar*)(s-&gt;strm-&gt;next_out) ) = s-&gt;state_out_ch;
            BZ_UPDATE_CRC ( s-&gt;calculatedBlockCRC, s-&gt;state_out_ch );
            s-&gt;state_out_len--;
            s-&gt;strm-&gt;next_out++;
            s-&gt;strm-&gt;avail_out--;
            s-&gt;strm-&gt;total_out_lo32++;
            if (s-&gt;strm-&gt;total_out_lo32 == 0) s-&gt;strm-&gt;total_out_hi32++;
         }
   
         /* can a new run be started? */
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) return;
               
   
         s-&gt;state_out_len = 1;
         s-&gt;state_out_ch = s-&gt;k0;
         BZ_GET_SMALL(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         s-&gt;state_out_len = 2;
         BZ_GET_SMALL(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         s-&gt;state_out_len = 3;
         BZ_GET_SMALL(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         BZ_GET_SMALL(k1); BZ_RAND_UPD_MASK; 
         k1 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
         s-&gt;state_out_len = ((Int32)k1) + 4;
         BZ_GET_SMALL(s-&gt;k0); BZ_RAND_UPD_MASK; 
         s-&gt;k0 ^= BZ_RAND_MASK; s-&gt;nblock_used++;
      }

   } else {

      while (True) {
         /* try to finish existing run */
         while (True) {
            if (s-&gt;strm-&gt;avail_out == 0) return;
            if (s-&gt;state_out_len == 0) break;
            *( (UChar*)(s-&gt;strm-&gt;next_out) ) = s-&gt;state_out_ch;
            BZ_UPDATE_CRC ( s-&gt;calculatedBlockCRC, s-&gt;state_out_ch );
            s-&gt;state_out_len--;
            s-&gt;strm-&gt;next_out++;
            s-&gt;strm-&gt;avail_out--;
            s-&gt;strm-&gt;total_out_lo32++;
            if (s-&gt;strm-&gt;total_out_lo32 == 0) s-&gt;strm-&gt;total_out_hi32++;
         }
   
         /* can a new run be started? */
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) return;
   
         s-&gt;state_out_len = 1;
         s-&gt;state_out_ch = s-&gt;k0;
         BZ_GET_SMALL(k1); s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         s-&gt;state_out_len = 2;
         BZ_GET_SMALL(k1); s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         s-&gt;state_out_len = 3;
         BZ_GET_SMALL(k1); s-&gt;nblock_used++;
         if (s-&gt;nblock_used == s-&gt;save_nblock+1) continue;
         if (k1 != s-&gt;k0) { s-&gt;k0 = k1; continue; };
   
         BZ_GET_SMALL(k1); s-&gt;nblock_used++;
         s-&gt;state_out_len = ((Int32)k1) + 4;
         BZ_GET_SMALL(s-&gt;k0); s-&gt;nblock_used++;
      }

   }
}


/*---------------------------------------------------*/
int BZ_API(BZ2_bzDecompress) ( bz_stream *strm )
{
   DState* s;
   if (strm == NULL) return BZ_PARAM_ERROR;
   s = strm-&gt;state;
   if (s == NULL) return BZ_PARAM_ERROR;
   if (s-&gt;strm != strm) return BZ_PARAM_ERROR;

   while (True) {
      if (s-&gt;state == BZ_X_IDLE) return BZ_SEQUENCE_ERROR;
      if (s-&gt;state == BZ_X_OUTPUT) {
         if (s-&gt;smallDecompress)
            unRLE_obuf_to_output_SMALL ( s ); else
            unRLE_obuf_to_output_FAST  ( s );
         if (s-&gt;nblock_used == s-&gt;save_nblock+1 &amp;&amp; s-&gt;state_out_len == 0) {
            BZ_FINALISE_CRC ( s-&gt;calculatedBlockCRC );
            if (s-&gt;verbosity &gt;= 3) 
               VPrintf2 ( " {0x%x, 0x%x}", s-&gt;storedBlockCRC, 
                          s-&gt;calculatedBlockCRC );
            if (s-&gt;verbosity &gt;= 2) VPrintf0 ( "]" );
            if (s-&gt;calculatedBlockCRC != s-&gt;storedBlockCRC)
               return BZ_DATA_ERROR;
            s-&gt;calculatedCombinedCRC 
               = (s-&gt;calculatedCombinedCRC &lt;&lt; 1) | 
                    (s-&gt;calculatedCombinedCRC &gt;&gt; 31);
            s-&gt;calculatedCombinedCRC ^= s-&gt;calculatedBlockCRC;
            s-&gt;state = BZ_X_BLKHDR_1;
         } else {
            return BZ_OK;
         }
      }
      if (s-&gt;state &gt;= BZ_X_MAGIC_1) {
         Int32 r = BZ2_decompress ( s );
         if (r == BZ_STREAM_END) {
            if (s-&gt;verbosity &gt;= 3)
               VPrintf2 ( "\n    combined CRCs: stored = 0x%x, computed = 0x%x", 
                          s-&gt;storedCombinedCRC, s-&gt;calculatedCombinedCRC );
            if (s-&gt;calculatedCombinedCRC != s-&gt;storedCombinedCRC)
               return BZ_DATA_ERROR;
            return r;
         }
         if (s-&gt;state != BZ_X_OUTPUT) return r;
      }
   }
}


/*---------------------------------------------------*/
int BZ_API(BZ2_bzDecompressEnd)  ( bz_stream *strm )
{
   DState* s;
   if (strm == NULL) return BZ_PARAM_ERROR;
   s = strm-&gt;state;
   if (s == NULL) return BZ_PARAM_ERROR;
   if (s-&gt;strm != strm) return BZ_PARAM_ERROR;

   if (s-&gt;tt   != NULL) BZFREE(s-&gt;tt);
   if (s-&gt;ll16 != NULL) BZFREE(s-&gt;ll16);
   if (s-&gt;ll4  != NULL) BZFREE(s-&gt;ll4);

   BZFREE(strm-&gt;state);
   strm-&gt;state = NULL;

   return BZ_OK;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

