<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cal.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cal.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

char	dayw[] =
{
	" S  M Tu  W Th  F  S"
};
char	*smon[] =
{
	"January", "February", "March", "April",
	"May", "June", "July", "August",
	"September", "October", "November", "December",
};
char	mon[] =
{
	0,
	31, 29, 31, 30,
	31, 30, 31, 31,
	30, 31, 30, 31,
};
char	string[432];
Biobuf	bout;

void	main(int argc, char *argv[]);
int	number(char *str);
void	pstr(char *str, int n);
void	cal(int m, int y, char *p, int w);
int	jan1(int yr);
int	curmo(void);
int	curyr(void);

void
main(int argc, char *argv[])
{
	int y, i, j, m;

	if(argc &gt; 3) {
		fprint(2, "usage: cal [month] [year]\n");
		exits("usage");
	}
	Binit(&amp;bout, 1, OWRITE);

/*
 * no arg, print current month
 */
	if(argc == 1) {
		m = curmo();
		y = curyr();
		goto xshort;
	}

/*
 * one arg
 *	if looks like a month, print month
 *	else print year
 */
	if(argc == 2) {
		y = number(argv[1]);
		if(y &lt; 0)
			y = -y;
		if(y &gt;= 1 &amp;&amp; y &lt;= 12) {
			m = y;
			y = curyr();
			goto xshort;
		}
		goto xlong;
	}

/*
 * two arg, month and year
 */
	m = number(argv[1]);
	if(m &lt; 0)
		m = -m;
	y = number(argv[2]);
	goto xshort;

/*
 *	print out just month
 */
xshort:
	if(m &lt; 1 || m &gt; 12)
		goto badarg;
	if(y &lt; 1 || y &gt; 9999)
		goto badarg;
	Bprint(&amp;bout, "   %s %ud\n", smon[m-1], y);
	Bprint(&amp;bout, "%s\n", dayw);
	cal(m, y, string, 24);
	for(i=0; i&lt;6*24; i+=24)
		pstr(string+i, 24);
	exits(0);

/*
 *	print out complete year
 */
xlong:
	y = number(argv[1]);
	if(y&lt;1 || y&gt;9999)
		goto badarg;
	Bprint(&amp;bout, "\n\n\n");
	Bprint(&amp;bout, "                                %ud\n", y);
	Bprint(&amp;bout, "\n");
	for(i=0; i&lt;12; i+=3) {
		for(j=0; j&lt;6*72; j++)
			string[j] = '\0';
		Bprint(&amp;bout, "         %.3s", smon[i]);
		Bprint(&amp;bout, "                    %.3s", smon[i+1]);
		Bprint(&amp;bout, "                    %.3s\n", smon[i+2]);
		Bprint(&amp;bout, "%s   %s   %s\n", dayw, dayw, dayw);
		cal(i+1, y, string, 72);
		cal(i+2, y, string+23, 72);
		cal(i+3, y, string+46, 72);
		for(j=0; j&lt;6*72; j+=72)
			pstr(string+j, 72);
	}
	Bprint(&amp;bout, "\n\n\n");
	exits(0);

badarg:
	Bprint(&amp;bout, "cal: bad argument\n");
}

struct
{
	char*	word;
	int	val;
} dict[] =
{
	"jan",		1,
	"january",	1,
	"feb",		2,
	"february",	2,
	"mar",		3,
	"march",	3,
	"apr",		4,
	"april",	4,
	"may",		5,
	"jun",		6,
	"june",		6,
	"jul",		7,
	"july",		7,
	"aug",		8,
	"august",	8,
	"sep",		9,
	"sept",		9,
	"september",	9,
	"oct",		10,
	"october",	10,
	"nov",		11,
	"november",	11,
	"dec",		12,
	"december",	12,
	0
};

/*
 * convert to a number.
 * if its a dictionary word,
 * return negative  number
 */
int
number(char *str)
{
	int n, c;
	char *s;

	for(n=0; s=dict[n].word; n++)
		if(strcmp(s, str) == 0)
			return -dict[n].val;
	n = 0;
	s = str;
	while(c = *s++) {
		if(c&lt;'0' || c&gt;'9')
			return 0;
		n = n*10 + c-'0';
	}
	return n;
}

void
pstr(char *str, int n)
{
	int i;
	char *s;

	s = str;
	i = n;
	while(i--)
		if(*s++ == '\0')
			s[-1] = ' ';
	i = n+1;
	while(i--)
		if(*--s != ' ')
			break;
	s[1] = '\0';
	Bprint(&amp;bout, "%s\n", str);
}

void
cal(int m, int y, char *p, int w)
{
	int d, i;
	char *s;

	s = p;
	d = jan1(y);
	mon[2] = 29;
	mon[9] = 30;

	switch((jan1(y+1)+7-d)%7) {

	/*
	 *	non-leap year
	 */
	case 1:
		mon[2] = 28;
		break;

	/*
	 *	1752
	 */
	default:
		mon[9] = 19;
		break;

	/*
	 *	leap year
	 */
	case 2:
		;
	}
	for(i=1; i&lt;m; i++)
		d += mon[i];
	d %= 7;
	s += 3*d;
	for(i=1; i&lt;=mon[m]; i++) {
		if(i==3 &amp;&amp; mon[m]==19) {
			i += 11;
			mon[m] += 11;
		}
		if(i &gt; 9)
			*s = i/10+'0';
		s++;
		*s++ = i%10+'0';
		s++;
		if(++d == 7) {
			d = 0;
			s = p+w;
			p = s;
		}
	}
}

/*
 *	return day of the week
 *	of jan 1 of given year
 */
int
jan1(int yr)
{
	int y, d;

/*
 *	normal gregorian calendar
 *	one extra day per four years
 */

	y = yr;
	d = 4+y+(y+3)/4;

/*
 *	julian calendar
 *	regular gregorian
 *	less three days per 400
 */

	if(y &gt; 1800) {
		d -= (y-1701)/100;
		d += (y-1601)/400;
	}

/*
 *	great calendar changeover instant
 */

	if(y &gt; 1752)
		d += 3;

	return d%7;
}

/*
 * system dependent
 * get current month and year
 */
int
curmo(void)
{
	Tm *tm;

	tm = localtime(time(0));
	return tm-&gt;mon+1;
}

int
curyr(void)
{
	Tm *tm;

	tm = localtime(time(0));
	return tm-&gt;year+1900;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

