<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cc/pickle.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cc/pickle.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "cc.h"

static char *kwd[] =
{
	"$adt", "$aggr", "$append", "$complex", "$defn",
	"$delete", "$do", "$else", "$eval", "$head", "$if",
	"$local", "$loop", "$return", "$tail", "$then",
	"$union", "$whatis", "$while",
};
static char picklestr[] = "\tpickle(s, un, ";

static char*
pmap(char *s)
{
	int i, bot, top, new;

	bot = 0;
	top = bot + nelem(kwd) - 1;
	while(bot &lt;= top){
		new = bot + (top - bot)/2;
		i = strcmp(kwd[new]+1, s);
		if(i == 0)
			return kwd[new];

		if(i &lt; 0)
			bot = new + 1;
		else
			top = new - 1;
	}
	return s;
}

Sym*
picklesue(Type *t)
{
	int h;
	Sym *s;

	if(t != T)
	for(h=0; h&lt;nelem(hash); h++)
		for(s = hash[h]; s != S; s = s-&gt;link)
			if(s-&gt;suetag &amp;&amp; s-&gt;suetag-&gt;link == t)
				return s;
	return 0;
}

Sym*
picklefun(Type *t)
{
	int h;
	Sym *s;

	for(h=0; h&lt;nelem(hash); h++)
		for(s = hash[h]; s != S; s = s-&gt;link)
			if(s-&gt;type == t)
				return s;
	return 0;
}

char	picklechar[NTYPE];
Init	picklecinit[] =
{
	TCHAR,		'C',	0,
	TUCHAR,		'b',	0,
	TSHORT,		'd',	0,
	TUSHORT,		'u',	0,
	TLONG,		'D',	0,
	TULONG,		'U',	0,
	TVLONG,		'V',	0,
	TUVLONG,	'W',	0,
	TFLOAT,		'f',	0,
	TDOUBLE,		'F',	0,
	TARRAY,		'a',	0,
	TIND,		'X',	0,
	-1,		0,	0,
};

static void
pickleinit(void)
{
	Init *p;

	for(p=picklecinit; p-&gt;code &gt;= 0; p++)
		picklechar[p-&gt;code] = p-&gt;value;

	picklechar[TINT] = picklechar[TLONG];
	picklechar[TUINT] = picklechar[TULONG];
	if(types[TINT]-&gt;width != types[TLONG]-&gt;width) {
		picklechar[TINT] = picklechar[TSHORT];
		picklechar[TUINT] = picklechar[TUSHORT];
		if(types[TINT]-&gt;width != types[TSHORT]-&gt;width)
			warn(Z, "picklemember int not long or short");
	}
	
}

void
picklemember(Type *t, long off)
{
	Sym *s, *s1;
	static int picklecharinit = 0;

	if(picklecharinit == 0) {
		pickleinit();
		picklecharinit = 1;
	}
	s = t-&gt;sym;
	switch(t-&gt;etype) {
	default:
		Bprint(&amp;outbuf, "	T%d\n", t-&gt;etype);
		break;

	case TIND:
		if(s == S)
			Bprint(&amp;outbuf,
				"%s\"p\", (char*)addr+%ld+_i*%ld);\n",
				picklestr, t-&gt;offset+off, t-&gt;width);
		else
			Bprint(&amp;outbuf,
				"%s\"p\", &amp;addr-&gt;%s);\n",
				picklestr, pmap(s-&gt;name));
		break;

	case TINT:
	case TUINT:
	case TCHAR:
	case TUCHAR:
	case TSHORT:
	case TUSHORT:
	case TLONG:
	case TULONG:
	case TVLONG:
	case TUVLONG:
	case TFLOAT:
	case TDOUBLE:
		if(s == S)
			Bprint(&amp;outbuf, "%s\"%c\", (char*)addr+%ld+_i*%ld);\n",
				picklestr, picklechar[t-&gt;etype], t-&gt;offset+off, t-&gt;width);
		else
			Bprint(&amp;outbuf, "%s\"%c\", &amp;addr-&gt;%s);\n",
				picklestr, picklechar[t-&gt;etype], pmap(s-&gt;name));
		break;
	case TARRAY:
		Bprint(&amp;outbuf, "\tfor(_i = 0; _i &lt; %ld; _i++) {\n\t",
			t-&gt;width/t-&gt;link-&gt;width);
		picklemember(t-&gt;link, t-&gt;offset+off);
		Bprint(&amp;outbuf, "\t}\n\t_i = 0;\n\tUSED(_i);\n");
		break;

	case TSTRUCT:
	case TUNION:
		s1 = picklesue(t-&gt;link);
		if(s1 == S)
			break;
		if(s == S) {
			Bprint(&amp;outbuf, "\tpickle_%s(s, un, (%s*)((char*)addr+%ld+_i*%ld));\n",
				pmap(s1-&gt;name), pmap(s1-&gt;name), t-&gt;offset+off, t-&gt;width);
		} else {
			Bprint(&amp;outbuf, "\tpickle_%s(s, un, &amp;addr-&gt;%s);\n",
				pmap(s1-&gt;name), pmap(s-&gt;name));
		}
		break;
	}
}

void
pickletype(Type *t)
{
	Sym *s;
	Type *l;
	Io *i;
	int n;
	char *an;

	if(!debug['P'])
		return;
	if(debug['P'] &gt; 1) {
		n = 0;
		for(i=iostack; i; i=i-&gt;link)
			n++;
		if(n &gt; 1)
			return;
	}
	s = picklesue(t-&gt;link);
	if(s == S)
		return;
	switch(t-&gt;etype) {
	default:
		Bprint(&amp;outbuf, "T%d\n", t-&gt;etype);
		return;

	case TUNION:
	case TSTRUCT:
		if(debug['s'])
			goto asmstr;
		an = pmap(s-&gt;name);

		Bprint(&amp;outbuf, "void\npickle_%s(void *s, int un, %s *addr)\n{\n\tint _i = 0;\n\n\tUSED(_i);\n", an, an);
		for(l = t-&gt;link; l != T; l = l-&gt;down)
			picklemember(l, 0);
		Bprint(&amp;outbuf, "}\n\n");
		break;
	asmstr:
		if(s == S)
			break;
		for(l = t-&gt;link; l != T; l = l-&gt;down)
			if(l-&gt;sym != S)
				Bprint(&amp;outbuf, "#define\t%s.%s\t%ld\n",
					s-&gt;name,
					l-&gt;sym-&gt;name,
					l-&gt;offset);
		break;
	}
}

void
picklevar(Sym *s)
{
	int n;
	Io *i;
	Type *t;
	Sym *s1, *s2;

	if(!debug['P'] || debug['s'])
		return;
	if(debug['P'] &gt; 1) {
		n = 0;
		for(i=iostack; i; i=i-&gt;link)
			n++;
		if(n &gt; 1)
			return;
	}
	t = s-&gt;type;
	while(t &amp;&amp; t-&gt;etype == TIND)
		t = t-&gt;link;
	if(t == T)
		return;
	if(t-&gt;etype == TENUM) {
		Bprint(&amp;outbuf, "%s = ", pmap(s-&gt;name));
		if(!typefd[t-&gt;etype])
			Bprint(&amp;outbuf, "%lld;\n", s-&gt;vconst);
		else
			Bprint(&amp;outbuf, "%f\n;", s-&gt;fconst);
		return;
	}
	if(!typesu[t-&gt;etype])
		return;
	s1 = picklesue(t-&gt;link);
	if(s1 == S)
		return;
	switch(s-&gt;class) {
	case CAUTO:
	case CPARAM:
		s2 = picklefun(thisfn);
		if(s2)
			Bprint(&amp;outbuf, "complex %s %s:%s;\n",
				pmap(s1-&gt;name), pmap(s2-&gt;name), pmap(s-&gt;name));
		break;
	
	case CSTATIC:
	case CEXTERN:
	case CGLOBL:
	case CLOCAL:
		Bprint(&amp;outbuf, "complex %s %s;\n",
			pmap(s1-&gt;name), pmap(s-&gt;name));
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

