<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cc/scon.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cc/scon.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "cc.h"

static Node*
acast(Type *t, Node *n)
{
	if(n-&gt;type-&gt;etype != t-&gt;etype || n-&gt;op == OBIT) {
		n = new1(OCAST, n, Z);
		if(nocast(n-&gt;left-&gt;type, t))
			*n = *n-&gt;left;
		n-&gt;type = t;
	}
	return n;
}


void
evconst(Node *n)
{
	Node *l, *r;
	int et, isf;
	vlong v;
	double d;

	if(n == Z || n-&gt;type == T)
		return;

	et = n-&gt;type-&gt;etype;
	isf = typefd[et];

	l = n-&gt;left;
	r = n-&gt;right;

	d = 0;
	v = 0;

	switch(n-&gt;op) {
	default:
		return;

	case ONEG:
		if(isf)
			d = -l-&gt;fconst;
		else
			v = -l-&gt;vconst;
		break;

	case OCOM:
		v = ~l-&gt;vconst;
		break;

	case OCAST:
		if(et == TVOID)
			return;
		et = l-&gt;type-&gt;etype;
		if(isf) {
			if(typefd[et])
				d = l-&gt;fconst;
			else
				d = l-&gt;vconst;
		} else {
			if(typefd[et])
				v = l-&gt;fconst;
			else
				v = convvtox(l-&gt;vconst, n-&gt;type-&gt;etype);
		}
		break;

	case OCONST:
		break;

	case OADD:
		if(isf)
			d = l-&gt;fconst + r-&gt;fconst;
		else {
			v = l-&gt;vconst + r-&gt;vconst;
		}
		break;

	case OSUB:
		if(isf)
			d = l-&gt;fconst - r-&gt;fconst;
		else
			v = l-&gt;vconst - r-&gt;vconst;
		break;

	case OMUL:
		if(isf)
			d = l-&gt;fconst * r-&gt;fconst;
		else {
			v = l-&gt;vconst * r-&gt;vconst;
		}
		break;

	case OLMUL:
		v = (uvlong)l-&gt;vconst * (uvlong)r-&gt;vconst;
		break;


	case ODIV:
		if(vconst(r) == 0) {
			warn(n, "divide by zero");
			return;
		}
		if(isf)
			d = l-&gt;fconst / r-&gt;fconst;
		else
			v = l-&gt;vconst / r-&gt;vconst;
		break;

	case OLDIV:
		if(vconst(r) == 0) {
			warn(n, "divide by zero");
			return;
		}
		v = (uvlong)l-&gt;vconst / (uvlong)r-&gt;vconst;
		break;

	case OMOD:
		if(vconst(r) == 0) {
			warn(n, "modulo by zero");
			return;
		}
		v = l-&gt;vconst % r-&gt;vconst;
		break;

	case OLMOD:
		if(vconst(r) == 0) {
			warn(n, "modulo by zero");
			return;
		}
		v = (uvlong)l-&gt;vconst % (uvlong)r-&gt;vconst;
		break;

	case OAND:
		v = l-&gt;vconst &amp; r-&gt;vconst;
		break;

	case OOR:
		v = l-&gt;vconst | r-&gt;vconst;
		break;

	case OXOR:
		v = l-&gt;vconst ^ r-&gt;vconst;
		break;

	case OLSHR:
		v = (uvlong)l-&gt;vconst &gt;&gt; r-&gt;vconst;
		break;

	case OASHR:
		v = l-&gt;vconst &gt;&gt; r-&gt;vconst;
		break;

	case OASHL:
		v = l-&gt;vconst &lt;&lt; r-&gt;vconst;
		break;

	case OLO:
		v = (uvlong)l-&gt;vconst &lt; (uvlong)r-&gt;vconst;
		break;

	case OLT:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst &lt; r-&gt;fconst;
		else
			v = l-&gt;vconst &lt; r-&gt;vconst;
		break;

	case OHI:
		v = (uvlong)l-&gt;vconst &gt; (uvlong)r-&gt;vconst;
		break;

	case OGT:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst &gt; r-&gt;fconst;
		else
			v = l-&gt;vconst &gt; r-&gt;vconst;
		break;

	case OLS:
		v = (uvlong)l-&gt;vconst &lt;= (uvlong)r-&gt;vconst;
		break;

	case OLE:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst &lt;= r-&gt;fconst;
		else
			v = l-&gt;vconst &lt;= r-&gt;vconst;
		break;

	case OHS:
		v = (uvlong)l-&gt;vconst &gt;= (uvlong)r-&gt;vconst;
		break;

	case OGE:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst &gt;= r-&gt;fconst;
		else
			v = l-&gt;vconst &gt;= r-&gt;vconst;
		break;

	case OEQ:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst == r-&gt;fconst;
		else
			v = l-&gt;vconst == r-&gt;vconst;
		break;

	case ONE:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst != r-&gt;fconst;
		else
			v = l-&gt;vconst != r-&gt;vconst;
		break;

	case ONOT:
		if(typefd[l-&gt;type-&gt;etype])
			v = !l-&gt;fconst;
		else
			v = !l-&gt;vconst;
		break;

	case OANDAND:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst &amp;&amp; r-&gt;fconst;
		else
			v = l-&gt;vconst &amp;&amp; r-&gt;vconst;
		break;

	case OOROR:
		if(typefd[l-&gt;type-&gt;etype])
			v = l-&gt;fconst || r-&gt;fconst;
		else
			v = l-&gt;vconst || r-&gt;vconst;
		break;
	}
	if(isf) {
		n-&gt;fconst = d;
	} else {
		n-&gt;vconst = convvtox(v, n-&gt;type-&gt;etype);
	}
	n-&gt;oldop = n-&gt;op;
	n-&gt;op = OCONST;
}

void
acom(Node *n)
{
	Type *t;
	Node *l, *r;
	int i;

	switch(n-&gt;op)
	{

	case ONAME:
	case OCONST:
	case OSTRING:
	case OINDREG:
	case OREGISTER:
		return;

	case ONEG:
		l = n-&gt;left;
		if(addo(n) &amp;&amp; addo(l))
			break;
		acom(l);
		return;

	case OADD:
	case OSUB:
	case OMUL:
		l = n-&gt;left;
		r = n-&gt;right;
		if(addo(n)) {
			if(addo(r))
				break;
			if(addo(l))
				break;
		}
		acom(l);
		acom(r);
		return;

	default:
		l = n-&gt;left;
		r = n-&gt;right;
		if(l != Z)
			acom(l);
		if(r != Z)
			acom(r);
		return;
	}

	/* bust terms out */
	t = n-&gt;type;
	term[0].mult = 0;
	term[0].node = Z;
	nterm = 1;
	acom1(1, n);
	if(debug['m'])
	for(i=0; i&lt;nterm; i++) {
		print("%d %3lld ", i, term[i].mult);
		prtree1(term[i].node, 1, 0);
	}
	if(nterm &lt; NTERM)
		acom2(n, t);
	n-&gt;type = t;
}

int
acomcmp1(const void *a1, const void *a2)
{
	vlong c1, c2;
	Term *t1, *t2;

	t1 = (Term*)a1;
	t2 = (Term*)a2;
	c1 = t1-&gt;mult;
	if(c1 &lt; 0)
		c1 = -c1;
	c2 = t2-&gt;mult;
	if(c2 &lt; 0)
		c2 = -c2;
	if(c1 &gt; c2)
		return 1;
	if(c1 &lt; c2)
		return -1;
	c1 = 1;
	if(t1-&gt;mult &lt; 0)
		c1 = 0;
	c2 = 1;
	if(t2-&gt;mult &lt; 0)
		c2 = 0;
	if(c2 -= c1)
		return c2;
	if(t2 &gt; t1)
		return 1;
	return -1;
}

int
acomcmp2(const void *a1, const void *a2)
{
	vlong c1, c2;
	Term *t1, *t2;

	t1 = (Term*)a1;
	t2 = (Term*)a2;
	c1 = t1-&gt;mult;
	c2 = t2-&gt;mult;
	if(c1 &gt; c2)
		return 1;
	if(c1 &lt; c2)
		return -1;
	if(t2 &gt; t1)
		return 1;
	return -1;
}

void
acom2(Node *n, Type *t)
{
	Node *l, *r;
	Term trm[NTERM];
	int et, nt, i, j;
	vlong c1, c2;

	/*
	 * copy into automatic
	 */
	c2 = 0;
	nt = nterm;
	for(i=0; i&lt;nt; i++)
		trm[i] = term[i];
	/*
	 * recur on subtrees
	 */
	j = 0;
	for(i=1; i&lt;nt; i++) {
		c1 = trm[i].mult;
		if(c1 == 0)
			continue;
		l = trm[i].node;
		if(l != Z) {
			j = 1;
			acom(l);
		}
	}
	c1 = trm[0].mult;
	if(j == 0) {
		n-&gt;oldop = n-&gt;op;
		n-&gt;op = OCONST;
		n-&gt;vconst = c1;
		return;
	}
	et = t-&gt;etype;

	/*
	 * prepare constant term,
	 * combine it with an addressing term
	 */
	if(c1 != 0) {
		l = new1(OCONST, Z, Z);
		l-&gt;type = t;
		l-&gt;vconst = c1;
		trm[0].mult = 1;
		for(i=1; i&lt;nt; i++) {
			if(trm[i].mult != 1)
				continue;
			r = trm[i].node;
			if(r-&gt;op != OADDR)
				continue;
			r-&gt;type = t;
			l = new1(OADD, r, l);
			l-&gt;type = t;
			trm[i].mult = 0;
			break;
		}
		trm[0].node = l;
	}
	/*
	 * look for factorable terms
	 * c1*i + c1*c2*j -&gt; c1*(i + c2*j)
	 */
	qsort(trm+1, nt-1, sizeof(trm[0]), acomcmp1);
	for(i=nt-1; i&gt;=0; i--) {
		c1 = trm[i].mult;
		if(c1 &lt; 0)
			c1 = -c1;
		if(c1 &lt;= 1)
			continue;
		for(j=i+1; j&lt;nt; j++) {
			c2 = trm[j].mult;
			if(c2 &lt; 0)
				c2 = -c2;
			if(c2 &lt;= 1)
				continue;
			if(c2 % c1)
				continue;
			r = trm[j].node;
			if(r-&gt;type-&gt;etype != et)
				r = acast(t, r);
			c2 = trm[j].mult/trm[i].mult;
			if(c2 != 1 &amp;&amp; c2 != -1) {
				r = new1(OMUL, r, new(OCONST, Z, Z));
				r-&gt;type = t;
				r-&gt;right-&gt;type = t;
				r-&gt;right-&gt;vconst = c2;
			}
			l = trm[i].node;
			if(l-&gt;type-&gt;etype != et)
				l = acast(t, l);
			r = new1(OADD, l, r);
			r-&gt;type = t;
			if(c2 == -1)
				r-&gt;op = OSUB;
			trm[i].node = r;
			trm[j].mult = 0;
		}
	}
	if(debug['m']) {
		print("\n");
		for(i=0; i&lt;nt; i++) {
			print("%d %3lld ", i, trm[i].mult);
			prtree1(trm[i].node, 1, 0);
		}
	}

	/*
	 * put it all back together
	 */
	qsort(trm+1, nt-1, sizeof(trm[0]), acomcmp2);
	l = Z;
	for(i=nt-1; i&gt;=0; i--) {
		c1 = trm[i].mult;
		if(c1 == 0)
			continue;
		r = trm[i].node;
		if(r-&gt;type-&gt;etype != et || r-&gt;op == OBIT)
			r = acast(t, r);
		if(c1 != 1 &amp;&amp; c1 != -1) {
			r = new1(OMUL, r, new(OCONST, Z, Z));
			r-&gt;type = t;
			r-&gt;right-&gt;type = t;
			if(c1 &lt; 0) {
				r-&gt;right-&gt;vconst = -c1;
				c1 = -1;
			} else {
				r-&gt;right-&gt;vconst = c1;
				c1 = 1;
			}
		}
		if(l == Z) {
			l = r;
			c2 = c1;
			continue;
		}
		if(c1 &lt; 0)
			if(c2 &lt; 0)
				l = new1(OADD, l, r);
			else
				l = new1(OSUB, l, r);
		else
			if(c2 &lt; 0) {
				l = new1(OSUB, r, l);
				c2 = 1;
			} else
				l = new1(OADD, l, r);
		l-&gt;type = t;
	}
	if(c2 &lt; 0) {
		r = new1(OCONST, 0, 0);
		r-&gt;vconst = 0;
		r-&gt;type = t;
		l = new1(OSUB, r, l);
		l-&gt;type = t;
	}
	*n = *l;
}

void
acom1(vlong v, Node *n)
{
	Node *l, *r;

	if(v == 0 || nterm &gt;= NTERM)
		return;
	if(!addo(n)) {
		if(n-&gt;op == OCONST)
		if(!typefd[n-&gt;type-&gt;etype]) {
			term[0].mult += v*n-&gt;vconst;
			return;
		}
		term[nterm].mult = v;
		term[nterm].node = n;
		nterm++;
		return;
	}
	switch(n-&gt;op) {

	case OCAST:
		acom1(v, n-&gt;left);
		break;

	case ONEG:
		acom1(-v, n-&gt;left);
		break;

	case OADD:
		acom1(v, n-&gt;left);
		acom1(v, n-&gt;right);
		break;

	case OSUB:
		acom1(v, n-&gt;left);
		acom1(-v, n-&gt;right);
		break;

	case OMUL:
		l = n-&gt;left;
		r = n-&gt;right;
		if(l-&gt;op == OCONST)
		if(!typefd[n-&gt;type-&gt;etype]) {
			acom1(v*l-&gt;vconst, r);
			break;
		}
		if(r-&gt;op == OCONST)
		if(!typefd[n-&gt;type-&gt;etype]) {
			acom1(v*r-&gt;vconst, l);
			break;
		}
		break;

	default:
		diag(n, "not addo");
	}
}

int
addo(Node *n)
{

	if(n != Z)
	if(!typefd[n-&gt;type-&gt;etype])
	if(!typev[n-&gt;type-&gt;etype] || ewidth[TVLONG] == ewidth[TIND])
	switch(n-&gt;op) {

	case OCAST:
		if(nilcast(n-&gt;left-&gt;type, n-&gt;type))
			return 1;
		break;

	case ONEG:
	case OADD:
	case OSUB:
		return 1;

	case OMUL:
		if(n-&gt;left-&gt;op == OCONST)
			return 1;
		if(n-&gt;right-&gt;op == OCONST)
			return 1;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

