<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cifs/pack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cifs/pack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* packet packing and unpacking */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include "cifs.h"

void *
pmem(Pkt *p, void *v, int len)
{
	uchar *str = v;
	void *s = p-&gt;pos;

	if(!len || !v)
		return s;
	while(len--)
		*p-&gt;pos++ = *str++;
	return s;
}

void *
ppath(Pkt *p, char *str)
{
	char c;
	Rune r;
	void *s = p-&gt;pos;

	if(!str)
		return s;

	if(p-&gt;s-&gt;caps &amp; CAP_UNICODE){
		if(((p-&gt;pos - p-&gt;buf) % 2) != 0)	/* pad to even offset */
			p8(p, 0);
		while(*str){
			str += chartorune(&amp;r, str);
			if(r == L'/')
				r = L'\\';
			pl16(p, r);
		}
		pl16(p, 0);
	} else {
		while((c = *str++) != 0){
			if(c == '/')
				c = '\\';
			*p-&gt;pos++ = c;
		}
		*p-&gt;pos++ = 0;
	}
	return s;
}

void *
pstr(Pkt *p, char *str)
{
	void *s = p-&gt;pos;
	Rune r;

	if(!str)
		return s;

	if(p-&gt;s-&gt;caps &amp; CAP_UNICODE){
		if(((p-&gt;pos - p-&gt;buf) % 2) != 0)
			p8(p, 0);		/* pad to even offset */
		while(*str){
			str += chartorune(&amp;r, str);
			pl16(p, r);
		}
		pl16(p, 0);
	} else {
		while(*str)
			*p-&gt;pos++ = *str++;
		*p-&gt;pos++ = 0;
	}
	return s;
}

void *
pascii(Pkt *p, char *str)
{
	void *s = p-&gt;pos;

	while(*str)
		*p-&gt;pos++ = *str++;
	*p-&gt;pos++ = 0;
	return s;
}


void *
pl64(Pkt *p, uvlong n)
{
	void *s = p-&gt;pos;

	*p-&gt;pos++ = n;
	*p-&gt;pos++ = n &gt;&gt; 8;
	*p-&gt;pos++ = n &gt;&gt; 16;
	*p-&gt;pos++ = n &gt;&gt; 24;
	*p-&gt;pos++ = n &gt;&gt; 32;
	*p-&gt;pos++ = n &gt;&gt; 40;
	*p-&gt;pos++ = n &gt;&gt; 48;
	*p-&gt;pos++ = n &gt;&gt; 56;
	return s;
}

void *
pb32(Pkt *p, uint n)
{
	void *s = p-&gt;pos;

	*p-&gt;pos++ = n &gt;&gt; 24;
	*p-&gt;pos++ = n &gt;&gt; 16;
	*p-&gt;pos++ = n &gt;&gt; 8;
	*p-&gt;pos++ = n;
	return s;
}

void *
pl32(Pkt *p, uint n)
{
	void *s = p-&gt;pos;

	*p-&gt;pos++ = n;
	*p-&gt;pos++ = n &gt;&gt; 8;
	*p-&gt;pos++ = n &gt;&gt; 16;
	*p-&gt;pos++ = n &gt;&gt; 24;
	return s;
}

void *
pb16(Pkt *p, uint n)
{
	void *s = p-&gt;pos;

	*p-&gt;pos++ = n &gt;&gt; 8;
	*p-&gt;pos++ = n;
	return s;
}

void *
pl16(Pkt *p, uint n)
{
	void *s = p-&gt;pos;

	*p-&gt;pos++ = n;
	*p-&gt;pos++ = n &gt;&gt; 8;
	return s;
}

void *
p8(Pkt *p, uint n)
{
	void *s = p-&gt;pos;

	*p-&gt;pos++ = n;
	return s;
}

/*
 * Encode a Netbios name
 */
void *
pname(Pkt *p, char *name, char pad)
{
	int i, done = 0;
	char c;
	void *s = p-&gt;pos;

	*p-&gt;pos++ = ' ';
	for(i = 0; i &lt; 16; i++) {
		c = pad;
		if(!done &amp;&amp; name[i] == '\0')
			done = 1;
		if(!done)
			c = islower(name[i])? toupper(name[i]): name[i];
		*p-&gt;pos++ = ((uchar)c &gt;&gt; 4) + 'A';
		*p-&gt;pos++ = (c &amp; 0xf) + 'A';
	}
	*p-&gt;pos++ = '\0';
	return s;
}

void *
pvtime(Pkt *p, uvlong n)
{
	void *s = p-&gt;pos;

	n += 11644473600LL;
	n *= 10000000LL;

	pl32(p, n);
	pl32(p, n &gt;&gt; 32);
	return s;
}

void *
pdatetime(Pkt *p, long utc)
{
	void *s = p-&gt;pos;
	Tm *tm = localtime(utc);
	int t = tm-&gt;hour &lt;&lt; 11 | tm-&gt;min &lt;&lt; 5 | (tm-&gt;sec / 2);
	int d = (tm-&gt;year - 80) &lt;&lt; 9 | (tm-&gt;mon + 1) &lt;&lt; 5 | tm-&gt;mday;

	/*
	 * bug in word swapping in Win95 requires this
	 */
	if(p-&gt;s-&gt;caps &amp; CAP_NT_SMBS){
		pl16(p, d);
		pl16(p, t);
	} else{
		pl16(p, t);
		pl16(p, d);
	}
	return s;
}


void
gmem(Pkt *p, void *v, int n)
{
	uchar *str = v;

	if(!n || !v)
		return;
	while(n-- &amp;&amp; p-&gt;pos &lt; p-&gt;eop)
		*str++ = *p-&gt;pos++;
}

/*
 * note len is the length of the source string in
 * in runes or bytes, in ASCII mode this is also the size
 * of the output buffer but this is not so in Unicode mode!
 */
void
gstr(Pkt *p, char *str, int n)
{
	int i;
	Rune r;

	if(!n || !str)
		return;

	if(p-&gt;s-&gt;caps &amp; CAP_UNICODE){
		i = 0;
		while(*p-&gt;pos &amp;&amp; n &amp;&amp; p-&gt;pos &lt; p-&gt;eop){
			r = gl16(p);
			i += runetochar(str +i, &amp;r);
			n -= 2;
		}
		*(str + i) = 0;

		while(*p-&gt;pos &amp;&amp; p-&gt;pos &lt; p-&gt;eop)
			gl16(p);
		/*
		 * some versions of windows terminate a rune string
		 * with a single nul so we do a dangerous hack...
		 */
		if(p-&gt;pos[1])
			g8(p);
		else
			gl16(p);
	} else {
		while(*p-&gt;pos &amp;&amp; n-- &amp;&amp; p-&gt;pos &lt; p-&gt;eop)
			*str++ = *p-&gt;pos++;
		*str = 0;
		while(*p-&gt;pos++ &amp;&amp; p-&gt;pos &lt; p-&gt;eop)
			continue;
	}
}

void
gascii(Pkt *p, char *str, int n)
{
	if(!n || !str)
		return;

	while(*p-&gt;pos &amp;&amp; n-- &amp;&amp; p-&gt;pos &lt; p-&gt;eop)
		*str++ = *p-&gt;pos++;
	*str = 0;
	while(*p-&gt;pos++ &amp;&amp; p-&gt;pos &lt; p-&gt;eop)
		continue;
}


uvlong
gl64(Pkt *p)
{
	uvlong n;

	if(p-&gt;pos + 8 &gt; p-&gt;eop)
		return 0;

	n  = (uvlong)*p-&gt;pos++;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 8;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 16;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 24;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 32;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 40;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 48;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 56;
	return n;
}

uvlong
gb48(Pkt *p)
{
	uvlong n;

	if(p-&gt;pos + 6 &gt; p-&gt;eop)
		return 0;

	n  = (uvlong)*p-&gt;pos++ &lt;&lt; 40;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 24;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 32;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 16;
	n |= (uvlong)*p-&gt;pos++ &lt;&lt; 8;
	n |= (uvlong)*p-&gt;pos++;
	return n;
}

uint
gb32(Pkt *p)
{
	uint n;

	if(p-&gt;pos + 4 &gt; p-&gt;eop)
		return 0;

	n  = (uint)*p-&gt;pos++ &lt;&lt; 24;
	n |= (uint)*p-&gt;pos++ &lt;&lt; 16;
	n |= (uint)*p-&gt;pos++ &lt;&lt; 8;
	n |= (uint)*p-&gt;pos++;
	return n;
}

uint
gl32(Pkt *p)
{
	uint n;

	if(p-&gt;pos + 4 &gt; p-&gt;eop)
		return 0;

	n  = (uint)*p-&gt;pos++;
	n |= (uint)*p-&gt;pos++ &lt;&lt; 8;
	n |= (uint)*p-&gt;pos++ &lt;&lt; 16;
	n |= (uint)*p-&gt;pos++ &lt;&lt; 24;
	return n;
}

uint
gb16(Pkt *p)
{
	uint n;

	if(p-&gt;pos + 2 &gt; p-&gt;eop)
		return 0;
	n  = (uint)*p-&gt;pos++ &lt;&lt; 8;
	n |= (uint)*p-&gt;pos++;
	return n;
}

uint
gl16(Pkt *p)
{
	uint n;

	if(p-&gt;pos + 2 &gt; p-&gt;eop)
		return 0;
	n  = (uint)*p-&gt;pos++;
	n |= (uint)*p-&gt;pos++ &lt;&lt; 8;
	return n;
}

uint
g8(Pkt *p)
{
	if(p-&gt;pos + 1 &gt; p-&gt;eop)
		return 0;
	return (uint)*p-&gt;pos++;
}

long
gdatetime(Pkt *p)
{
	Tm tm;
	uint d, t;

	if(p-&gt;pos + 4 &gt; p-&gt;eop)
		return 0;

	/*
	 * bug in word swapping in Win95 requires this
	 */
	if(p-&gt;s-&gt;caps &amp; CAP_NT_SMBS){
		d = gl16(p);
		t = gl16(p);
	}else{
		t = gl16(p);
		d = gl16(p);
	}

	tm.year = 80 + (d &gt;&gt; 9);
	tm.mon = ((d &gt;&gt; 5) &amp; 017) - 1;
	tm.mday = d &amp; 037;
	tm.zone[0] = 0;
	tm.tzoff = p-&gt;s-&gt;tz;

	tm.hour = t &gt;&gt; 11;
	tm.min = (t &gt;&gt; 5) &amp; 63;
	tm.sec = (t &amp; 31) &lt;&lt; 1;

	return tm2sec(&amp;tm);
}

long
gvtime(Pkt *p)
{
	uvlong vl;

	if(p-&gt;pos + 8 &gt; p-&gt;eop)
		return 0;

	vl  = (uvlong)gl32(p);
	vl |= (uvlong)gl32(p) &lt;&lt; 32;

	vl /= 10000000LL;
	vl -= 11644473600LL;
	return vl;
}

void
gconv(Pkt *p, int conv, char *str, int n)
{
	int off;
	uchar *pos;

	off = gl32(p) &amp; 0xffff;
	if(off == 0 || p-&gt;tdata - conv + off &gt; p-&gt;eop){
		memset(str, 0, n);
		return;
	}

	pos = p-&gt;pos;
	p-&gt;pos = p-&gt;tdata - conv + off;
	gascii(p, str, n);
	p-&gt;pos = pos;
}

void
goff(Pkt *p, uchar *base, char *str, int n)
{
	int off;
	uchar *pos;

	off = gl16(p);
	if(off == 0 || base + off &gt; p-&gt;eop){
		memset(str, 0, n);
		return;
	}
	pos = p-&gt;pos;
	p-&gt;pos = base + off;
	gstr(p, str, n);
	p-&gt;pos = pos;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

