<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cifs/trans2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cifs/trans2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "cifs.h"

static Pkt *
t2hdr(Session *s, Share *sp, int cmd)
{
	Pkt *p;

	p = cifshdr(s, sp, SMB_COM_TRANSACTION2);

	p-&gt;tbase = pl16(p, 0);	/* 0  Total parameter bytes to be sent, filled later */
	pl16(p, 0);		/* 2  Total data bytes to be sent, filled later */
	pl16(p, 64);			/* 4  Max parameter to return */
	pl16(p, (MTU - T2HDRLEN)-64);	/* 6  Max data to return */
	p8(p, 0);			/* 8  Max setup count to return */
	p8(p, 0);			/* 9  Reserved */
	pl16(p, 0);			/* 10 Flags */
	pl32(p, 1000);			/* 12 Timeout (ms) */
	pl16(p, 0);			/* 16 Reserved */
	pl16(p, 0);			/* 18 Parameter count, filled later */
	pl16(p, 0);			/* 20 Parameter offset, filled later */
	pl16(p, 0);			/* 22 Data count, filled later */
	pl16(p, 0);			/* 24 Data offset, filled later */
	p8(p, 1);			/* 26 Setup count (in words) */
	p8(p, 0);			/* 27 Reserved */
	pl16(p, cmd);			/* setup[0] */
	pbytes(p);
	p8(p, 0);			/* padding ??!?!? */

	return p;
}

static void
pt2param(Pkt *p)
{
	uchar *pos = p-&gt;pos;

	assert(p-&gt;tbase != 0);
	p-&gt;pos = p-&gt;tbase + 20;
	pl16(p, (pos - p-&gt;buf) - NBHDRLEN); /* param offset */

	p-&gt;tparam = p-&gt;pos = pos;
}

static void
pt2data(Pkt *p)
{
	uchar *pos = p-&gt;pos;

	assert(p-&gt;tbase != 0);
	assert(p-&gt;tparam != 0);

	p-&gt;pos = p-&gt;tbase +0;
	pl16(p, pos - p-&gt;tparam);		/* total param count */

	p-&gt;pos = p-&gt;tbase +18;
	pl16(p, pos - p-&gt;tparam);		/* param count */

	p-&gt;pos = p-&gt;tbase +24;
	pl16(p, (pos - p-&gt;buf) - NBHDRLEN);	/* data offset */

	p-&gt;tdata = p-&gt;pos = pos;
}

static int
t2rpc(Pkt *p)
{
	int got;
	uchar *pos;

	assert(p-&gt;tbase != 0);
	assert(p-&gt;tdata != 0);

	pos = p-&gt;pos;

	p-&gt;pos = p-&gt;tbase +2;
	pl16(p, pos - p-&gt;tdata);		/* total data count */

	p-&gt;pos = p-&gt;tbase +22;
	pl16(p, pos - p-&gt;tdata);		/* data count */

	p-&gt;pos = pos;
	if((got = cifsrpc(p)) == -1)
		return -1;

	gl16(p);			/* Total parameter count */
	gl16(p);			/* Total data count */
	gl16(p);			/* Reserved */
	gl16(p);			/* Parameter count in this buffer */
	p-&gt;tparam = p-&gt;buf +NBHDRLEN +gl16(p); /* Parameter offset */
	gl16(p);			/* Parameter displacement */
	gl16(p);			/* Data count (this buffer); */
	p-&gt;tdata = p-&gt;buf +NBHDRLEN +gl16(p); /* Data offset */
	gl16(p);			/* Data displacement */
	g8(p);				/* Setup count */
	g8(p);				/* Reserved */

	return got;
}

static void
gt2param(Pkt *p)
{
	p-&gt;pos = p-&gt;tparam;
}

static void
gt2data(Pkt *p)
{
	p-&gt;pos = p-&gt;tdata;
}


int
T2findfirst(Session *s, Share *sp, int slots, char *path, int *got,
	long *resume, FInfo *fip)
{
	int pktlen, i, n, sh;
	uchar *next;
	Pkt *p;

	p = t2hdr(s, sp, TRANS2_FIND_FIRST2);
	p8(p, 'D');			/* OS/2 */
	p8(p, ' ');			/* OS/2 */

	pt2param(p);
	pl16(p, ATTR_HIDDEN|ATTR_SYSTEM|ATTR_DIRECTORY); /* Search attributes */
	pl16(p, slots);			/* Search count */
	pl16(p, CIFS_SEARCH_RETURN_RESUME); /* Flags */
	pl16(p, SMB_FIND_FILE_FULL_DIRECTORY_INFO); /* Information level */
	pl32(p, 0);			/* SearchStorage type (?) */
	ppath(p, path);			/* path */

	pt2data(p);
	if((pktlen = t2rpc(p)) == -1){
		free(p);
		return -1;
	}

	s-&gt;lastfind = nsec();
	gt2param(p);

	sh = gl16(p);			/* Sid (search handle) */
	*got = gl16(p);			/* number of slots received */
	gl16(p);			/* End of search flag */
	gl16(p);			/* Offset into EA list if EA error */
	gl16(p);			/* Offset into data to file name of last entry */

	gt2data(p);
	memset(fip, 0, slots * sizeof(FInfo));
	for(i = 0; i &lt; *got; i++){
		next = p-&gt;pos;
		next += gl32(p);	/* offset to next entry */
		/*
		 * bug in Windows - somtimes it lies about how many
		 * directory entries it has put in the packet
		 */
		if(next - p-&gt;buf &gt; pktlen){
			*got = i;
			break;
		}

		*resume = gl32(p);		/* resume key for search */
		fip[i].created = gvtime(p);	/* creation time */
		fip[i].accessed = gvtime(p);	/* last access time */
		fip[i].written = gvtime(p);	/* last written time */
		fip[i].changed = gvtime(p);	/* change time */
		fip[i].size = gl64(p);		/* file size */
		gl64(p);			/* bytes allocated */
		fip[i].attribs = gl32(p);	/* extended attributes */
		n = gl32(p);			/* name length */
		gl32(p);			/* EA size */
		gstr(p, fip[i].name, n); 	/* name */
		p-&gt;pos = next;
	}

	free(p);
	return sh;

}

int
T2findnext(Session *s, Share *sp, int slots, char *path, int *got,
	long *resume, FInfo *fip, int sh)
{
	Pkt *p;
	int i, n;
	uchar *next;

	/*
	 * So I believe from comp.protocols.smb if you send
	 * TRANS2_FIND_NEXT2 requests too quickly to windows 95, it can
	 * get confused and fail to reply, so we slow up a bit in these
	 * circumstances.
	 */
	if(!(s-&gt;caps &amp; CAP_NT_SMBS) &amp;&amp; nsec() - s-&gt;lastfind &lt; 200000000LL)
		sleep(200);

	p = t2hdr(s, sp, TRANS2_FIND_NEXT2);
	p8(p, 'D');			/* OS/2 */
	p8(p, ' ');			/* OS/2 */

	pt2param(p);
	pl16(p, sh);				/* search handle */
	pl16(p, slots);				/* Search count */
	pl16(p, SMB_FIND_FILE_FULL_DIRECTORY_INFO); /* Information level */
	pl32(p, *resume);			/* resume key */
	pl16(p, CIFS_SEARCH_CONTINUE_FROM_LAST); /* Flags */
	ppath(p, path);				/* file+path to resume */

	pt2data(p);
	if(t2rpc(p) == -1){
		free(p);
		return -1;
	}

	s-&gt;lastfind = nsec();

	gt2param(p);
	*got = gl16(p);		/* number of slots received */
	gl16(p);		/* End of search flag */
	gl16(p);		/* Offset into EA list if EA error */
	gl16(p);		/* Offset into data to file name of last entry */

	gt2data(p);
	memset(fip, 0, slots * sizeof(FInfo));
	for(i = 0; i &lt; *got; i++){
		next = p-&gt;pos;
		next += gl32(p);		/* offset to next entry */
		*resume = gl32(p);		/* resume key for search */
		fip[i].created = gvtime(p);	/* creation time */
		fip[i].accessed = gvtime(p);	/* last access time */
		fip[i].written = gvtime(p);	/* last written time */
		fip[i].changed = gvtime(p);	/* change time */
		fip[i].size = gl64(p);		/* file size */
		gl64(p);			/* bytes allocated */
		fip[i].attribs = gl32(p);	/* extended attributes */
		n = gl32(p);			/* name length */
		gl32(p);			/* EA size */
		gstr(p, fip[i].name, n); 	/* name */
		p-&gt;pos = next;
	}
	free(p);
	return 0;
}


/* supported by 2k/XP/NT4 */
int
T2queryall(Session *s, Share *sp, char *path, FInfo *fip)
{
	int n;
	Pkt *p;

	p = t2hdr(s, sp, TRANS2_QUERY_PATH_INFORMATION);
	pt2param(p);
	pl16(p, SMB_QUERY_FILE_ALL_INFO); /* Information level	 */
	pl32(p, 0);			/* reserved */
	ppath(p, path);			/* path */

	pt2data(p);
	if(t2rpc(p) == -1){
		free(p);
		return -1;
	}
	gt2data(p);

	/*
	 * The layout of this struct is wrong in the SINA
	 * document, this layout gained by inspection.
	 */
	memset(fip, 0, sizeof(FInfo));
	fip-&gt;created = gvtime(p);	/* creation time */
	fip-&gt;accessed = gvtime(p);	/* last access time */
	fip-&gt;written = gvtime(p);	/* last written time */
	fip-&gt;changed = gvtime(p);	/* change time */
	fip-&gt;attribs = gl32(p);		/* attributes */
	gl32(p);			/* reserved */
	gl64(p);			/* bytes allocated */
	fip-&gt;size = gl64(p);		/* file size */
	gl32(p);			/* number of hard links */
	g8(p);				/* delete pending */
	g8(p);				/* is a directory */
	gl16(p);			/* reserved */
	gl32(p);			/* EA size */

	n = gl32(p);
	if(n &gt;= sizeof fip-&gt;name)
		n = sizeof fip-&gt;name - 1;
	gstr(p, fip-&gt;name, n);

	free(p);
	return 0;
}

/* supported by 95/98/ME */
int
T2querystandard(Session *s, Share *sp, char *path, FInfo *fip)
{
	Pkt *p;

	p = t2hdr(s, sp, TRANS2_QUERY_PATH_INFORMATION);
	pt2param(p);
	pl16(p, SMB_INFO_STANDARD);	/* Information level */
	pl32(p, 0);			/* reserved */
	ppath(p, path);			/* path */

	pt2data(p);
	if(t2rpc(p) == -1){
		free(p);
		return -1;
	}
	gt2data(p);
	memset(fip, 0, sizeof(FInfo));
	fip-&gt;created = gdatetime(p);	/* creation time */
	fip-&gt;accessed = gdatetime(p);	/* last access time */
	fip-&gt;written = gdatetime(p);	/* last written time */
	fip-&gt;changed = fip-&gt;written;	/* change time */
	fip-&gt;size = gl32(p);		/* file size */
	gl32(p);			/* bytes allocated */
	fip-&gt;attribs = gl16(p);		/* attributes */
	gl32(p);			/* EA size */

	free(p);
	return 0;
}

int
T2setpathinfo(Session *s, Share *sp, char *path, FInfo *fip)
{
	int rc;
	Pkt *p;

	p = t2hdr(s, sp, TRANS2_SET_PATH_INFORMATION);
	pt2param(p);
	pl16(p, SMB_INFO_STANDARD);	/* Information level */
	pl32(p, 0);			/* reserved */
	ppath(p, path);			/* path */

	pt2data(p);
	pdatetime(p, fip-&gt;created);	/* created */
	pdatetime(p, fip-&gt;accessed);	/* accessed */
	pdatetime(p, fip-&gt;written);	/* written */
	pl32(p, fip-&gt;size);		/* size */
	pl32(p, 0);			/* allocated */
	pl16(p, fip-&gt;attribs);		/* attributes */
	pl32(p, 0);			/* EA size */
	pl16(p, 0);			/* reserved */

	rc = t2rpc(p);
	free(p);
	return rc;

}

int
T2setfilelength(Session *s, Share *sp, int fh, FInfo *fip) /* FIXME: maybe broken, needs testing */
{
	int rc;
	Pkt *p;

	p = t2hdr(s, sp, TRANS2_SET_FILE_INFORMATION);
	pt2param(p);
	pl16(p, fh);			/* file handle */
	pl16(p, SMB_SET_FILE_END_OF_FILE_INFO); /* Information level */
	pl16(p, 0);			/* reserved */

	pt2data(p);
	pl64(p, fip-&gt;size);
	pl32(p, 0);			/* padding ?! */
	pl16(p, 0);

	rc = t2rpc(p);
	free(p);
	return rc;
}


int
T2fsvolumeinfo(Session *s, Share *sp, long *created, long *serialno,
	char *label, int labellen)
{
	Pkt *p;
	long ct, sn, n;

	p = t2hdr(s, sp, TRANS2_QUERY_FS_INFORMATION);
	pt2param(p);
	pl16(p, SMB_QUERY_FS_VOLUME_INFO);	/* Information level */

	pt2data(p);

	if(t2rpc(p) == -1){
		free(p);
		return -1;
	}

	gt2data(p);
	ct = gvtime(p);			/* creation time */
	sn = gl32(p);			/* serial number */
	n = gl32(p);			/* label name length */
	g8(p);				/* reserved */
	g8(p);				/* reserved */

	memset(label, 0, labellen);
	if(n &lt; labellen &amp;&amp; n &gt; 0)
		gstr(p, label, n);	/* file system label */
	if(created)
		*created = ct;
	if(serialno)
		*serialno = sn;

	free(p);
	return 0;
}

int
T2fssizeinfo(Session *s, Share *sp, uvlong *total, uvlong *unused)
{
	Pkt *p;
	uvlong t, f, n, b;

	p = t2hdr(s, sp, TRANS2_QUERY_FS_INFORMATION);
	pt2param(p);
	pl16(p, SMB_QUERY_FS_SIZE_INFO);	/* Information level */

	pt2data(p);

	if(t2rpc(p) == -1){
		free(p);
		return -1;
	}

	gt2data(p);
	t = gl64(p);		/* total blocks */
	f = gl64(p);		/* free blocks */
	n = gl32(p);		/* sectors per block */
	b = gl32(p);		/* bytes per sector */

	if(free)
		*unused = f * n * b;
	if(total)
		*total = t * n * b;

	free(p);
	return 0;
}

int
T2getdfsreferral(Session *s, Share *sp, char *path, int *gflags, int *used,
	Refer *re, int nent)
{
	int i, vers, nret, len;
	char tmp[1024];
	uchar *base;
	Pkt *p;

	p = t2hdr(s, sp, TRANS2_GET_DFS_REFERRAL);
	pt2param(p);
	pl16(p, 3); /* max info level we understand, must be &gt;= 3 for domain requests */
	ppath(p, path);

	pt2data(p);

	if(t2rpc(p) == -1){
		free(p);
		return -1;
	}

	memset(re, 0, sizeof *re * nent);
	gt2data(p);

	*used = gl16(p) / 2;	/* length used (/2 as Windows counts in runes) */
	nret = gl16(p);		/* number of referrals returned */
	*gflags = gl32(p);	/* global flags */

	for(i = 0; i &lt; nret &amp;&amp; i &lt; nent &amp;&amp; i &lt; 16; i++){
		base = p-&gt;pos;
		vers = gl16(p);		/* version of records */
		len = gl16(p);		/* length of records */
		re[i].type = gl16(p);	/* server type */
		re[i].flags = gl16(p);	/* referal flags */
		switch(vers){
		case 1:
			re[i].prox = 0;	/* nearby */
			re[i].ttl = 5*60;	/* 5 mins */
			gstr(p, tmp, sizeof tmp);
			re[i].addr = estrdup9p(tmp);
			re[i].path = estrdup9p(tmp);
			break;
		case 2:
			re[i].prox = gl32(p);	/* not implemented in v2 */
			re[i].ttl = gl32(p);
			goff(p, base, re[i].path, sizeof tmp);
			re[i].path = estrdup9p(tmp);
			goff(p, base, re[i].path, sizeof tmp);/* spurious 8.3 path */
			goff(p, base, tmp, sizeof tmp);
			re[i].addr = estrdup9p(tmp);
			break;
		case 3:
			if(re[i].flags &amp; DFS_REFERAL_LIST){
				re[i].prox = 0;
				re[i].ttl = gl32(p);
				goff(p, base, tmp, sizeof tmp);
				re[i].path = estrdup9p(tmp);
				gl16(p);
				goff(p, base, tmp, sizeof tmp);
				re[i].addr = estrdup9p(tmp);
			}
			else{
				re[i].prox = 0;
				re[i].ttl = gl32(p);
				goff(p, base, tmp, sizeof tmp);
				re[i].path = estrdup9p(tmp);
				gl16(p);	/* spurious 8.3 path */
				goff(p, base, tmp, sizeof tmp);
				re[i].addr = estrdup9p(tmp);
				gl16(p);	/* GUID (historic) */
			}
			break;
		default:
			/*
			 * this should never happen as we specify our maximum
			 * understood level in the request (above)
			 */
			fprint(2, "%d - unsupported DFS infolevel\n", vers);
			re[i].path = estrdup9p(tmp);
			re[i].addr = estrdup9p(tmp);
			break;
		}
		p-&gt;pos = base+len;
	}

	free(p);
	return i;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

