<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/col.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/col.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* col - eliminate reverse line feeds */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;bio.h&gt;

enum {
	ESC	= '\033',
	RLF	= '\013',

	PL	= 256,
	LINELN	= 800,

	Tabstop	= 8,		/* must be power of 2 */
};

static int bflag, xflag, fflag;
static int cp, lp;
static int half;
static int ll, llh, mustwr;
static int pcp = 0;

static char *page[PL];
static char *line;
static char lbuff[LINELN];
static Biobuf bin, bout;

void	emit(char *s, int lineno);
void	incr(void), decr(void);
void	outc(Rune);

static void
usage(void)
{
	fprint(2, "usage: %s [-bfx]\n", argv0);
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i, lno;
	long ch;
	Rune c;

	ARGBEGIN{
	case 'b':
		bflag++;
		break;
	case 'f':
		fflag++;
		break;
	case 'x':
		xflag++;
		break;
	default:
		usage();
	}ARGEND;

	for (ll=0; ll &lt; PL; ll++)
		page[ll] = nil;

	cp = 0;
	ll = 0;
	mustwr = PL;
	line = lbuff;

	Binit(&amp;bin, 0, OREAD);
	Binit(&amp;bout, 1, OWRITE);
	while ((ch = Bgetrune(&amp;bin)) != Beof) {
		c = ch;
		switch (c) {
		case '\n':
			incr();
			incr();
			cp = 0;
			break;

		case '\0':
			break;

		case ESC:
			c = Bgetrune(&amp;bin);
			switch (c) {
			case '7':	/* reverse full line feed */
				decr();
				decr();
				break;

			case '8':	/* reverse half line feed */
				if (fflag)
					decr();
				else
					if (--half &lt; -1) {
						decr();
						decr();
						half += 2;
					}
				break;

			case '9':	/* forward half line feed */
				if (fflag)
					incr();
				else
					if (++half &gt; 0) {
						incr();
						incr();
						half -= 2;
					}
				break;
			}
			break;

		case RLF:
			decr();
			decr();
			break;

		case '\r':
			cp = 0;
			break;

		case '\t':
			cp = (cp + Tabstop) &amp; -Tabstop;
			break;

		case '\b':
			if (cp &gt; 0)
				cp--;
			break;

		case ' ':
			cp++;
			break;

		default:
			if (!isascii(c) || isprint(c)) {
				outc(c);
				cp++;
			}
			break;
		}
	}

	for (i=0; i &lt; PL; i++) {
		lno = (mustwr+i) % PL;
		if (page[lno] != 0)
			emit(page[lno], mustwr+i-PL);
	}
	emit(" ", (llh + 1) &amp; -2);
	exits(0);
}

void
outc(Rune c)
{
	if (lp &gt; cp) {
		line = lbuff;
		lp = 0;
	}

	while (lp &lt; cp) {
		switch (*line) {
		case '\0':
			*line = ' ';
			lp++;
			break;
		case '\b':
			lp--;
			break;
		default:
			lp++;
			break;
		}
		line++;
	}
	while (*line == '\b')
		line += 2;
	if (bflag || *line == '\0' || *line == ' ')
		cp += runetochar(line, &amp;c) - 1;
	else {
		char c1, c2, c3;

		c1 = *++line;
		*line++ = '\b';
		c2 = *line;
		*line++ = c;
		while (c1) {
			c3 = *line;
			*line++ = c1;
			c1 = c2;
			c2 = c3;
		}
		lp = 0;
		line = lbuff;
	}
}

void
store(int lno)
{
	lno %= PL;
	if (page[lno] != nil)
		free(page[lno]);
	page[lno] = malloc((unsigned)strlen(lbuff) + 2);
	if (page[lno] == nil)
		sysfatal("out of memory");
	strcpy(page[lno], lbuff);
}

void
fetch(int lno)
{
	char *p;

	lno %= PL;
	p = lbuff;
	while (*p)
		*p++ = '\0';
	line = lbuff;
	lp = 0;
	if (page[lno])
		strcpy(line, page[lno]);
}

void
emit(char *s, int lineno)
{
	int ncp;
	char *p;
	static int cline = 0;

	if (*s) {
		while (cline &lt; lineno - 1) {
			Bputc(&amp;bout, '\n');
			pcp = 0;
			cline += 2;
		}
		if (cline != lineno) {
			Bputc(&amp;bout, ESC);
			Bputc(&amp;bout, '9');
			cline++;
		}
		if (pcp)
			Bputc(&amp;bout, '\r');
		pcp = 0;
		p = s;
		while (*p) {
			ncp = pcp;
			while (*p++ == ' ')
				if ((++ncp &amp; 7) == 0 &amp;&amp; !xflag) {
					pcp = ncp;
					Bputc(&amp;bout, '\t');
				}
			if (!*--p)
				break;
			while (pcp &lt; ncp) {
				Bputc(&amp;bout, ' ');
				pcp++;
			}
			Bputc(&amp;bout, *p);
			if (*p++ == '\b')
				pcp--;
			else
				pcp++;
		}
	}
}

void
incr(void)
{
	int lno;

	store(ll++);
	if (ll &gt; llh)
		llh = ll;
	lno = ll % PL;
	if (ll &gt;= mustwr &amp;&amp; page[lno]) {
		emit(page[lno], ll - PL);
		mustwr++;
		free(page[lno]);
		page[lno] = nil;
	}
	fetch(ll);
}

void
decr(void)
{
	if (ll &gt; mustwr - PL) {
		store(ll--);
		fetch(ll);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

