<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cpp/macro.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cpp/macro.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "cpp.h"

/*
 * do a macro definition.  tp points to the name being defined in the line
 */
void
dodefine(Tokenrow *trp)
{
	Token *tp;
	Nlist *np;
	Tokenrow *def, *args;
	int dots;

	dots = 0;
	tp = trp-&gt;tp+1;
	if (tp&gt;=trp-&gt;lp || tp-&gt;type!=NAME) {
		error(ERROR, "#defined token is not a name");
		return;
	}
	np = lookup(tp, 1);
	if (np-&gt;flag&amp;ISUNCHANGE) {
		error(ERROR, "#defined token %t can't be redefined", tp);
		return;
	}
	/* collect arguments */
	tp += 1;
	args = NULL;
	if (tp&lt;trp-&gt;lp &amp;&amp; tp-&gt;type==LP &amp;&amp; tp-&gt;wslen==0) {
		/* macro with args */
		int narg = 0;
		tp += 1;
		args = new(Tokenrow);
		maketokenrow(2, args);
		if (tp-&gt;type!=RP) {
			int err = 0;
			for (;;) {
				Token *atp;
				if (tp-&gt;type == ELLIPS)
					dots++;
				else if (tp-&gt;type!=NAME) {
					err++;
					break;
				}
				if (narg&gt;=args-&gt;max)
					growtokenrow(args);
				for (atp=args-&gt;bp; atp&lt;args-&gt;lp; atp++)
					if (atp-&gt;len==tp-&gt;len
					 &amp;&amp; strncmp((char*)atp-&gt;t, (char*)tp-&gt;t, tp-&gt;len)==0)
						error(ERROR, "Duplicate macro argument");
				*args-&gt;lp++ = *tp;
				narg++;
				tp += 1;
				if (tp-&gt;type==RP)
					break;
				if (dots)
					error(ERROR, "arguments after '...' in macro");
				if (tp-&gt;type!=COMMA) {
					err++;
					break;
				}
				tp += 1;
			}
			if (err) {
				error(ERROR, "Syntax error in macro parameters");
				return;
			}
		}
		tp += 1;
	}
	trp-&gt;tp = tp;
	if (((trp-&gt;lp)-1)-&gt;type==NL)
		trp-&gt;lp -= 1;
	def = normtokenrow(trp);
	if (np-&gt;flag&amp;ISDEFINED) {
		if (comparetokens(def, np-&gt;vp)
		 || (np-&gt;ap==NULL) != (args==NULL)
		 || np-&gt;ap &amp;&amp; comparetokens(args, np-&gt;ap))
			error(ERROR, "Macro redefinition of %t", trp-&gt;bp+2);
	}
	if (args) {
		Tokenrow *tap;
		tap = normtokenrow(args);
		dofree(args-&gt;bp);
		args = tap;
	}
	np-&gt;ap = args;
	np-&gt;vp = def;
	np-&gt;flag |= ISDEFINED;
	if(dots)
		np-&gt;flag |= ISVARMAC;
}

/*
 * Definition received via -D or -U
 */
void
doadefine(Tokenrow *trp, int type)
{
	Nlist *np;
	static unsigned char one[] = "1";
	static Token onetoken[1] = {{ NUMBER, 0, 0, 0, 1, one }};
	static Tokenrow onetr = { onetoken, onetoken, onetoken+1, 1 };

	trp-&gt;tp = trp-&gt;bp;
	if (type=='U') {
		if (trp-&gt;lp-trp-&gt;tp != 2 || trp-&gt;tp-&gt;type!=NAME)
			goto syntax;
		if ((np = lookup(trp-&gt;tp, 0)) == NULL)
			return;
		np-&gt;flag &amp;= ~ISDEFINED;
		return;
	}
	if (trp-&gt;tp &gt;= trp-&gt;lp || trp-&gt;tp-&gt;type!=NAME)
		goto syntax;
	np = lookup(trp-&gt;tp, 1);
	np-&gt;flag |= ISDEFINED;
	trp-&gt;tp += 1;
	if (trp-&gt;tp &gt;= trp-&gt;lp || trp-&gt;tp-&gt;type==END) {
		np-&gt;vp = &amp;onetr;
		return;
	}
	if (trp-&gt;tp-&gt;type!=ASGN)
		goto syntax;
	trp-&gt;tp += 1;
	if ((trp-&gt;lp-1)-&gt;type == END)
		trp-&gt;lp -= 1;
	np-&gt;vp = normtokenrow(trp);
	return;
syntax:
	error(FATAL, "Illegal -D or -U argument %r", trp);
}
			
/*
 * Do macro expansion in a row of tokens.
 * Flag is NULL if more input can be gathered.
 */
void
expandrow(Tokenrow *trp, char *flag, int inmacro)
{
	Token *tp;
	Nlist *np;

	if (flag)
		setsource(flag, -1, "");
	for (tp = trp-&gt;tp; tp&lt;trp-&gt;lp; ) {
		if (tp-&gt;type!=NAME
		 || quicklook(tp-&gt;t[0], tp-&gt;len&gt;1?tp-&gt;t[1]:0)==0
		 || (np = lookup(tp, 0))==NULL
		 || (np-&gt;flag&amp;(ISDEFINED|ISMAC))==0
		 || tp-&gt;hideset &amp;&amp; checkhideset(tp-&gt;hideset, np)) {
			tp++;
			continue;
		}
		trp-&gt;tp = tp;
		if (np-&gt;val==KDEFINED) {
			tp-&gt;type = DEFINED;
			if ((tp+1)&lt;trp-&gt;lp &amp;&amp; (tp+1)-&gt;type==NAME)
				(tp+1)-&gt;type = NAME1;
			else if ((tp+3)&lt;trp-&gt;lp &amp;&amp; (tp+1)-&gt;type==LP
			 &amp;&amp; (tp+2)-&gt;type==NAME &amp;&amp; (tp+3)-&gt;type==RP)
				(tp+2)-&gt;type = NAME1;
			else
				error(ERROR, "Incorrect syntax for `defined'");
			tp++;
			continue;
		}
		if (np-&gt;flag&amp;ISMAC)
			builtin(trp, np-&gt;val);
		else {
			expand(trp, np, inmacro);
		}
		tp = trp-&gt;tp;
	}
	if (flag)
		unsetsource();
}

/*
 * Expand the macro whose name is np, at token trp-&gt;tp, in the tokenrow.
 * Return trp-&gt;tp at the first token next to be expanded
 * (ordinarily the beginning of the expansion)
 */
void
expand(Tokenrow *trp, Nlist *np, int inmacro)
{
	Tokenrow ntr;
	int ntokc, narg, i;
	Token *tp;
	Tokenrow *atr[NARG+1];
	int hs;

	copytokenrow(&amp;ntr, np-&gt;vp);		/* copy macro value */
	if (np-&gt;ap==NULL)			/* parameterless */
		ntokc = 1;
	else {
		ntokc = gatherargs(trp, atr, (np-&gt;flag&amp;ISVARMAC) ? rowlen(np-&gt;ap) : 0, &amp;narg);
		if (narg&lt;0) {			/* not actually a call (no '(') */
/* error(WARNING, "%d %r\n", narg, trp); */
			/* gatherargs has already pushed trp-&gt;tr to the next token */
			return;
		}
		if (narg != rowlen(np-&gt;ap)) {
			error(ERROR, "Disagreement in number of macro arguments");
			trp-&gt;tp-&gt;hideset = newhideset(trp-&gt;tp-&gt;hideset, np);
			trp-&gt;tp += ntokc;
			return;
		}
		substargs(np, &amp;ntr, atr);	/* put args into replacement */
		for (i=0; i&lt;narg; i++) {
			dofree(atr[i]-&gt;bp);
			dofree(atr[i]);
		}
	}
	if(!inmacro)
		doconcat(&amp;ntr);				/* execute ## operators */
	hs = newhideset(trp-&gt;tp-&gt;hideset, np);
	for (tp=ntr.bp; tp&lt;ntr.lp; tp++) {	/* distribute hidesets */
		if (tp-&gt;type==NAME) {
			if (tp-&gt;hideset==0)
				tp-&gt;hideset = hs;
			else
				tp-&gt;hideset = unionhideset(tp-&gt;hideset, hs);
		}
	}
	ntr.tp = ntr.bp;
	insertrow(trp, ntokc, &amp;ntr);
	trp-&gt;tp -= rowlen(&amp;ntr);
	dofree(ntr.bp);
	return;
}	

/*
 * Gather an arglist, starting in trp with tp pointing at the macro name.
 * Return total number of tokens passed, stash number of args found.
 * trp-&gt;tp is not changed relative to the tokenrow.
 */
int
gatherargs(Tokenrow *trp, Tokenrow **atr, int dots, int *narg)
{
	int parens = 1;
	int ntok = 0;
	Token *bp, *lp;
	Tokenrow ttr;
	int ntokp;
	int needspace;

	*narg = -1;			/* means that there is no macro call */
	/* look for the ( */
	for (;;) {
		trp-&gt;tp++;
		ntok++;
		if (trp-&gt;tp &gt;= trp-&gt;lp) {
			gettokens(trp, 0);
			if ((trp-&gt;lp-1)-&gt;type==END) {
/* error(WARNING, "reach END\n"); */
				trp-&gt;lp -= 1;
				if (*narg&gt;=0)
					trp-&gt;tp -= ntok;
				return ntok;
			}
		}
		if (trp-&gt;tp-&gt;type==LP)
			break;
		if (trp-&gt;tp-&gt;type!=NL)
			return ntok;
	}
	*narg = 0;
	ntok++;
	ntokp = ntok;
	trp-&gt;tp++;
	/* search for the terminating ), possibly extending the row */
	needspace = 0;
	while (parens&gt;0) {
		if (trp-&gt;tp &gt;= trp-&gt;lp)
			gettokens(trp, 0);
		if (needspace) {
			needspace = 0;
			makespace(trp);
		}
		if (trp-&gt;tp-&gt;type==END) {
			trp-&gt;lp -= 1;
			trp-&gt;tp -= ntok;
			error(ERROR, "EOF in macro arglist");
			return ntok;
		}
		if (trp-&gt;tp-&gt;type==NL) {
			trp-&gt;tp += 1;
			adjustrow(trp, -1);
			trp-&gt;tp -= 1;
			makespace(trp);
			needspace = 1;
			continue;
		}
		if (trp-&gt;tp-&gt;type==LP)
			parens++;
		else if (trp-&gt;tp-&gt;type==RP)
			parens--;
		trp-&gt;tp++;
		ntok++;
	}
	trp-&gt;tp -= ntok;
	/* Now trp-&gt;tp won't move underneath us */
	lp = bp = trp-&gt;tp+ntokp;
	for (; parens&gt;=0; lp++) {
		if (lp-&gt;type == LP) {
			parens++;
			continue;
		}
		if (lp-&gt;type==RP)
			parens--;
		if (lp-&gt;type==DSHARP)
			lp-&gt;type = DSHARP1;	/* ## not special in arg */
		if ((lp-&gt;type==COMMA &amp;&amp; parens==0) || (parens&lt;0 &amp;&amp; (lp-1)-&gt;type!=LP)) {
			if (lp-&gt;type == COMMA &amp;&amp; dots &amp;&amp; *narg == dots-1)
				continue;
			if (*narg&gt;=NARG-1)
				error(FATAL, "Sorry, too many macro arguments");
			ttr.bp = ttr.tp = bp;
			ttr.lp = lp;
			atr[(*narg)++] = normtokenrow(&amp;ttr);
			bp = lp+1;
		}
	}
	return ntok;
}

/*
 * substitute the argument list into the replacement string
 *  This would be simple except for ## and #
 */
void
substargs(Nlist *np, Tokenrow *rtr, Tokenrow **atr)
{
	Tokenrow tatr;
	Token *tp;
	int ntok, argno;

	for (rtr-&gt;tp=rtr-&gt;bp; rtr-&gt;tp&lt;rtr-&gt;lp; ) {
		if (rtr-&gt;tp-&gt;type==SHARP) {	/* string operator */
			tp = rtr-&gt;tp;
			rtr-&gt;tp += 1;
			if ((argno = lookuparg(np, rtr-&gt;tp))&lt;0) {
				error(ERROR, "# not followed by macro parameter");
				continue;
			}
			ntok = 1 + (rtr-&gt;tp - tp);
			rtr-&gt;tp = tp;
			insertrow(rtr, ntok, stringify(atr[argno]));
			continue;
		}
		if (rtr-&gt;tp-&gt;type==NAME
		 &amp;&amp; (argno = lookuparg(np, rtr-&gt;tp)) &gt;= 0) {
			if (rtr-&gt;tp &lt; rtr-&gt;bp)
				error(ERROR, "access out of bounds");
			if ((rtr-&gt;tp+1)-&gt;type==DSHARP
			 || rtr-&gt;tp!=rtr-&gt;bp &amp;&amp; (rtr-&gt;tp-1)-&gt;type==DSHARP)
				insertrow(rtr, 1, atr[argno]);
			else {
				copytokenrow(&amp;tatr, atr[argno]);
				expandrow(&amp;tatr, "&lt;macro&gt;", Inmacro);
				insertrow(rtr, 1, &amp;tatr);
				dofree(tatr.bp);
			}
			continue;
		}
		rtr-&gt;tp++;
	}
}

/*
 * Evaluate the ## operators in a tokenrow
 */
void
doconcat(Tokenrow *trp)
{
	Token *ltp, *ntp;
	Tokenrow ntr;
	int len;

	for (trp-&gt;tp=trp-&gt;bp; trp-&gt;tp&lt;trp-&gt;lp; trp-&gt;tp++) {
		if (trp-&gt;tp-&gt;type==DSHARP1)
			trp-&gt;tp-&gt;type = DSHARP;
		else if (trp-&gt;tp-&gt;type==DSHARP) {
			char tt[128];
			ltp = trp-&gt;tp-1;
			ntp = trp-&gt;tp+1;
			if (ltp&lt;trp-&gt;bp || ntp&gt;=trp-&gt;lp) {
				error(ERROR, "## occurs at border of replacement");
				continue;
			}
			len = ltp-&gt;len + ntp-&gt;len;
			strncpy((char*)tt, (char*)ltp-&gt;t, ltp-&gt;len);
			strncpy((char*)tt+ltp-&gt;len, (char*)ntp-&gt;t, ntp-&gt;len);
			tt[len] = '\0';
			setsource("&lt;##&gt;", -1, tt);
			maketokenrow(3, &amp;ntr);
			gettokens(&amp;ntr, 1);
			unsetsource();
			if (ntr.lp-ntr.bp!=2 || ntr.bp-&gt;type==UNCLASS)
				error(WARNING, "Bad token %r produced by ##", &amp;ntr);
			ntr.lp = ntr.bp+1;
			trp-&gt;tp = ltp;
			makespace(&amp;ntr);
			insertrow(trp, (ntp-ltp)+1, &amp;ntr);
			dofree(ntr.bp);
			trp-&gt;tp--;
		}
	}
}

/*
 * tp is a potential parameter name of macro mac;
 * look it up in mac's arglist, and if found, return the
 * corresponding index in the argname array.  Return -1 if not found.
 */
int
lookuparg(Nlist *mac, Token *tp)
{
	Token *ap;

	if (tp-&gt;type!=NAME || mac-&gt;ap==NULL)
		return -1;
	if((mac-&gt;flag &amp; ISVARMAC) &amp;&amp; strcmp((char*)tp-&gt;t, "__VA_ARGS__") == 0)
		return rowlen(mac-&gt;ap) - 1;
	for (ap=mac-&gt;ap-&gt;bp; ap&lt;mac-&gt;ap-&gt;lp; ap++) {
		if (ap-&gt;len==tp-&gt;len &amp;&amp; strncmp((char*)ap-&gt;t,(char*)tp-&gt;t,ap-&gt;len)==0)
			return ap - mac-&gt;ap-&gt;bp;
	}
	return -1;
}

/*
 * Return a quoted version of the tokenrow (from # arg)
 */
#define	STRLEN	512
Tokenrow *
stringify(Tokenrow *vp)
{
	static Token t = { STRING };
	static Tokenrow tr = { &amp;t, &amp;t, &amp;t+1, 1 };
	Token *tp;
	uchar s[STRLEN];
	uchar *sp = s, *cp;
	int i, instring;

	*sp++ = '"';
	for (tp = vp-&gt;bp; tp &lt; vp-&gt;lp; tp++) {
		instring = tp-&gt;type==STRING || tp-&gt;type==CCON;
		if (sp+2*tp-&gt;len &gt;= &amp;s[STRLEN-10]) {
			error(ERROR, "Stringified macro arg is too long");
			break;
		}
		if (tp-&gt;wslen /* &amp;&amp; (tp-&gt;flag&amp;XPWS)==0 */)
			*sp++ = ' ';
		for (i=0, cp=tp-&gt;t; i&lt;tp-&gt;len; i++) {	
			if (instring &amp;&amp; (*cp=='"' || *cp=='\\'))
				*sp++ = '\\';
			*sp++ = *cp++;
		}
	}
	*sp++ = '"';
	*sp = '\0';
	sp = s;
	t.len = strlen((char*)sp);
	t.t = newstring(sp, t.len, 0);
	return &amp;tr;
}

/*
 * expand a builtin name
 */
void
builtin(Tokenrow *trp, int biname)
{
	char *op;
	Token *tp;
	Source *s;

	tp = trp-&gt;tp;
	trp-&gt;tp++;
	/* need to find the real source */
	s = cursource;
	while (s &amp;&amp; s-&gt;fd==-1)
		s = s-&gt;next;
	if (s==NULL)
		s = cursource;
	/* most are strings */
	tp-&gt;type = STRING;
	if (tp-&gt;wslen) {
		*outp++ = ' ';
		tp-&gt;wslen = 1;
	}
	op = outp;
	*op++ = '"';
	switch (biname) {

	case KLINENO:
		tp-&gt;type = NUMBER;
		op = outnum(op-1, s-&gt;line);
		break;

	case KFILE:
		strcpy(op, s-&gt;filename);
		op += strlen(s-&gt;filename);
		break;

	case KDATE:
		strncpy(op, curtime+4, 7);
		strncpy(op+7, curtime+24, 4); /* Plan 9 asctime disobeys standard */
		op += 11;
		break;

	case KTIME:
		strncpy(op, curtime+11, 8);
		op += 8;
		break;

	default:
		error(ERROR, "cpp botch: unknown internal macro");
		return;
	}
	if (tp-&gt;type==STRING)
		*op++ = '"';
	tp-&gt;t = (uchar*)outp;
	tp-&gt;len = op - outp;
	outp = op;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

