<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cpp/tokens.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cpp/tokens.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "cpp.h"

static char wbuf[2*OBS];
static char *wbp = wbuf;

/*
 * 1 for tokens that don't need whitespace when they get inserted
 * by macro expansion
 */
static char wstab[] = {
	0,	/* END */
	0,	/* UNCLASS */
	0,	/* NAME */
	0,	/* NUMBER */
	0,	/* STRING */
	0,	/* CCON */
	1,	/* NL */
	0,	/* WS */
	0,	/* DSHARP */
	0,	/* EQ */
	0,	/* NEQ */
	0,	/* LEQ */
	0,	/* GEQ */
	0,	/* LSH */
	0,	/* RSH */
	0,	/* LAND */
	0,	/* LOR */
	0,	/* PPLUS */
	0,	/* MMINUS */
	0,	/* ARROW */
	1,	/* SBRA */
	1,	/* SKET */
	1,	/* LP */
	1,	/* RP */
	0,	/* DOT */
	0,	/* AND */
	0,	/* STAR */
	0,	/* PLUS */
	0,	/* MINUS */
	0,	/* TILDE */
	0,	/* NOT */
	0,	/* SLASH */
	0,	/* PCT */
	0,	/* LT */
	0,	/* GT */
	0,	/* CIRC */
	0,	/* OR */
	0,	/* QUEST */
	0,	/* COLON */
	0,	/* ASGN */
	1,	/* COMMA */
	0,	/* SHARP */
	1,	/* SEMIC */
	1,	/* CBRA */
	1,	/* CKET */
	0,	/* ASPLUS */
 	0,	/* ASMINUS */
 	0,	/* ASSTAR */
 	0,	/* ASSLASH */
 	0,	/* ASPCT */
 	0,	/* ASCIRC */
 	0,	/* ASLSH */
	0,	/* ASRSH */
 	0,	/* ASOR */
 	0,	/* ASAND */
	0,	/* ELLIPS */
	0,	/* DSHARP1 */
	0,	/* NAME1 */
	0,	/* DEFINED */
	0,	/* UMINUS */
};

void
maketokenrow(int size, Tokenrow *trp)
{
	trp-&gt;max = size;
	if (size&gt;0)
		trp-&gt;bp = (Token *)domalloc(size*sizeof(Token));
	else
		trp-&gt;bp = NULL;
	trp-&gt;tp = trp-&gt;bp;
	trp-&gt;lp = trp-&gt;bp;
}

Token *
growtokenrow(Tokenrow *trp)
{
	int ncur = trp-&gt;tp - trp-&gt;bp;
	int nlast = trp-&gt;lp - trp-&gt;bp;

	trp-&gt;max = 3*trp-&gt;max/2 + 1;
	trp-&gt;bp = (Token *)realloc(trp-&gt;bp, trp-&gt;max*sizeof(Token));
	trp-&gt;lp = &amp;trp-&gt;bp[nlast];
	trp-&gt;tp = &amp;trp-&gt;bp[ncur];
	return trp-&gt;lp;
}

/*
 * Compare a row of tokens, ignoring the content of WS; return !=0 if different
 */
int
comparetokens(Tokenrow *tr1, Tokenrow *tr2)
{
	Token *tp1, *tp2;

	tp1 = tr1-&gt;tp;
	tp2 = tr2-&gt;tp;
	if (tr1-&gt;lp-tp1 != tr2-&gt;lp-tp2)
		return 1;
	for (; tp1&lt;tr1-&gt;lp ; tp1++, tp2++) {
		if (tp1-&gt;type != tp2-&gt;type
		 || (tp1-&gt;wslen==0) != (tp2-&gt;wslen==0)
		 || tp1-&gt;len != tp2-&gt;len
		 || strncmp((char*)tp1-&gt;t, (char*)tp2-&gt;t, tp1-&gt;len)!=0)
			return 1;
	}
	return 0;
}

/*
 * replace ntok tokens starting at dtr-&gt;tp with the contents of str.
 * tp ends up pointing just beyond the replacement.
 * Canonical whitespace is assured on each side.
 */
void
insertrow(Tokenrow *dtr, int ntok, Tokenrow *str)
{
	int nrtok = rowlen(str);

	dtr-&gt;tp += ntok;
	adjustrow(dtr, nrtok-ntok);
	dtr-&gt;tp -= ntok;
	movetokenrow(dtr, str);
	makespace(dtr);
	dtr-&gt;tp += nrtok;
	makespace(dtr);
}

/*
 * make sure there is WS before trp-&gt;tp, if tokens might merge in the output
 */
void
makespace(Tokenrow *trp)
{
	uchar *tt;
	Token *tp = trp-&gt;tp;

	if (tp &gt;= trp-&gt;lp)
		return;
	if (tp-&gt;wslen) {
		if (tp-&gt;flag&amp;XPWS
		 &amp;&amp; (wstab[tp-&gt;type] || trp-&gt;tp&gt;trp-&gt;bp &amp;&amp; wstab[(tp-1)-&gt;type])) {
			tp-&gt;wslen = 0;
			return;
		}
		tp-&gt;t[-1] = ' ';
		return;
	}
	if (wstab[tp-&gt;type] || trp-&gt;tp&gt;trp-&gt;bp &amp;&amp; wstab[(tp-1)-&gt;type])
		return;
	tt = newstring(tp-&gt;t, tp-&gt;len, 1);
	*tt++ = ' ';
	tp-&gt;t = tt;
	tp-&gt;wslen = 1;
	tp-&gt;flag |= XPWS;
}

/*
 * Copy an entire tokenrow into another, at tp.
 * It is assumed that there is enough space.
 *  Not strictly conforming.
 */
void
movetokenrow(Tokenrow *dtr, Tokenrow *str)
{
	int nby;

	/* nby = sizeof(Token) * (str-&gt;lp - str-&gt;bp); */
	nby = (char *)str-&gt;lp - (char *)str-&gt;bp;
	memmove(dtr-&gt;tp, str-&gt;bp, nby);
}

/*
 * Move the tokens in a row, starting at tr-&gt;tp, rightward by nt tokens;
 * nt may be negative (left move).
 * The row may need to be grown.
 * Non-strictly conforming because of the (char *), but easily fixed
 */
void
adjustrow(Tokenrow *trp, int nt)
{
	int nby, size;

	if (nt==0)
		return;
	size = (trp-&gt;lp - trp-&gt;bp) + nt;
	while (size &gt; trp-&gt;max)
		growtokenrow(trp);
	/* nby = sizeof(Token) * (trp-&gt;lp - trp-&gt;tp); */
	nby = (char *)trp-&gt;lp - (char *)trp-&gt;tp;
	if (nby)
		memmove(trp-&gt;tp+nt, trp-&gt;tp, nby);
	trp-&gt;lp += nt;
}

/*
 * Copy a row of tokens into the destination holder, allocating
 * the space for the contents.  Return the destination.
 */
Tokenrow *
copytokenrow(Tokenrow *dtr, Tokenrow *str)
{
	int len = rowlen(str);

	maketokenrow(len, dtr);
	movetokenrow(dtr, str);
	dtr-&gt;lp += len;
	return dtr;
}

/*
 * Produce a copy of a row of tokens.  Start at trp-&gt;tp.
 * The value strings are copied as well.  The first token
 * has WS available.
 */
Tokenrow *
normtokenrow(Tokenrow *trp)
{
	Token *tp;
	Tokenrow *ntrp = new(Tokenrow);
	int len;

	len = trp-&gt;lp - trp-&gt;tp;
	if (len&lt;=0)
		len = 1;
	maketokenrow(len, ntrp);
	for (tp=trp-&gt;tp; tp &lt; trp-&gt;lp; tp++) {
		*ntrp-&gt;lp = *tp;
		if (tp-&gt;len) {
			ntrp-&gt;lp-&gt;t = newstring(tp-&gt;t, tp-&gt;len, 1);
			*ntrp-&gt;lp-&gt;t++ = ' ';
			if (tp-&gt;wslen)
				ntrp-&gt;lp-&gt;wslen = 1;
		}
		ntrp-&gt;lp++;
	}
	if (ntrp-&gt;lp &gt; ntrp-&gt;bp)
		ntrp-&gt;bp-&gt;wslen = 0;
	return ntrp;
}

/*
 * Debugging
 */
void
peektokens(Tokenrow *trp, char *str)
{
	Token *tp;
	int c;

	tp = trp-&gt;tp;
	flushout();
	if (str)
		fprintf(stderr, "%s ", str);
	if (tp&lt;trp-&gt;bp || tp&gt;trp-&gt;lp)
		fprintf(stderr, "(tp offset %d) ", tp-trp-&gt;bp);
	for (tp=trp-&gt;bp; tp&lt;trp-&gt;lp &amp;&amp; tp&lt;trp-&gt;bp+32; tp++) {
		if (tp-&gt;type!=NL) {
			c = tp-&gt;t[tp-&gt;len];
			tp-&gt;t[tp-&gt;len] = 0;
			fprintf(stderr, "%s", tp-&gt;t, tp-&gt;len);
			tp-&gt;t[tp-&gt;len] = c;
		}
		if (tp-&gt;type==NAME) {
			fprintf(stderr, tp==trp-&gt;tp?"{*":"{");
			prhideset(tp-&gt;hideset);
			fprintf(stderr, "} ");
		} else
			fprintf(stderr, tp==trp-&gt;tp?"{%x*} ":"{%x} ", tp-&gt;type);
	}
	fprintf(stderr, "\n");
	fflush(stderr);
}

void
puttokens(Tokenrow *trp)
{
	Token *tp;
	int len;
	uchar *p;

	if (verbose)
		peektokens(trp, "");
	tp = trp-&gt;bp;
	for (; tp&lt;trp-&gt;lp; tp++) {
		len = tp-&gt;len+tp-&gt;wslen;
		p = tp-&gt;t-tp-&gt;wslen;
		while (tp&lt;trp-&gt;lp-1 &amp;&amp; p+len == (tp+1)-&gt;t - (tp+1)-&gt;wslen) {
			tp++;
			len += tp-&gt;wslen+tp-&gt;len;
		}
		if (Mflag==0) {
			if (len&gt;OBS/2) {		/* handle giant token */
				if (wbp &gt; wbuf)
					write(1, wbuf, wbp-wbuf);
				write(1, p, len);
				wbp = wbuf;
			} else {	
				memcpy(wbp, p, len);
				wbp += len;
			}
		}
		if (wbp &gt;= &amp;wbuf[OBS]) {
			write(1, wbuf, OBS);
			if (wbp &gt; &amp;wbuf[OBS])
				memcpy(wbuf, wbuf+OBS, wbp - &amp;wbuf[OBS]);
			wbp -= OBS;
		}
	}
	trp-&gt;tp = tp;
	if (cursource-&gt;fd==0)
		flushout();
}

void
flushout(void)
{
	if (wbp&gt;wbuf) {
		write(1, wbuf, wbp-wbuf);
		wbp = wbuf;
	}
}

/*
 * turn a row into just a newline
 */
void
setempty(Tokenrow *trp)
{
	trp-&gt;tp = trp-&gt;bp;
	trp-&gt;lp = trp-&gt;bp+1;
	*trp-&gt;bp = nltoken;
}

/*
 * generate a number
 */
char *
outnum(char *p, int n)
{
	if (n&gt;=10)
		p = outnum(p, n/10);
	*p++ = n%10 + '0';
	return p;
}

/*
 * allocate and initialize a new string from s, of length l, at offset o
 * Null terminated.
 */
uchar *
newstring(uchar *s, int l, int o)
{
	uchar *ns = (uchar *)domalloc(l+o+1);

	ns[l+o] = '\0';
	return (uchar*)strncpy((char*)ns+o, (char*)s, l) - o;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

