<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/sub.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/sub.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include "io.h"

enum {
	Slop = 256,	/* room at the start of a message buf for proto hdrs */
};

Filsys*
fsstr(char *p)
{
	Filsys *fs;

	for(fs=filsys; fs-&gt;name; fs++)
		if(strcmp(fs-&gt;name, p) == 0)
			return fs;
	return 0;
}

Filsys*
dev2fs(Device *dev)
{
	Filsys *fs;

	for(fs=filsys; fs-&gt;name; fs++)
		if(fs-&gt;dev == dev)
			return fs;
	return 0;
}

/*
 * allocate 'count' contiguous channels
 * of type 'type' and return pointer to base
 */
Chan*
fs_chaninit(int type, int count, int data)
{
	uchar *p;
	Chan *cp, *icp;
	int i;

	p = malloc(count * (sizeof(Chan)+data));
	icp = (Chan*)p;
	for(i = 0; i &lt; count; i++) {
		cp = (Chan*)p;
		cp-&gt;next = chans;
		chans = cp;
		cp-&gt;type = type;
		cp-&gt;chan = cons.chano;
		cons.chano++;
		strncpy(cp-&gt;whoname, "&lt;none&gt;", sizeof cp-&gt;whoname);
		wlock(&amp;cp-&gt;reflock);
		wunlock(&amp;cp-&gt;reflock);
		rlock(&amp;cp-&gt;reflock);
		runlock(&amp;cp-&gt;reflock);

		p += sizeof(Chan);
		if(data){
			cp-&gt;pdata = p;
			p += data;
		}
	}
	return icp;
}

void
fileinit(Chan *cp)
{
	File *f, *prev;
	Tlock *t;
	int h;

loop:
	lock(&amp;flock);
	for (h=0; h &lt; nelem(flist); h++)
		for (prev=0, f = flist[h]; f; prev=f, f=f-&gt;next) {
			if(f-&gt;cp != cp)
				continue;
			if(prev) {
				prev-&gt;next = f-&gt;next;
				f-&gt;next = flist[h];
				flist[h] = f;
			}
			flist[h] = f-&gt;next;
			unlock(&amp;flock);

			qlock(f);
			if(t = f-&gt;tlock) {
				if(t-&gt;file == f)
					t-&gt;time = 0;	/* free the lock */
				f-&gt;tlock = 0;
			}
			if(f-&gt;open &amp; FREMOV)
				doremove(f, 0);
			freewp(f-&gt;wpath);
			f-&gt;open = 0;
			authfree(f-&gt;auth);
			f-&gt;auth = 0;
			f-&gt;cp = 0;
			qunlock(f);
			goto loop;
		}
	unlock(&amp;flock);
}

enum { NOFID = (ulong)~0 };

/*
 * returns a locked file structure
 */
File*
filep(Chan *cp, ulong fid, int flag)
{
	File *f;
	int h;

	if(fid == NOFID)
		return 0;

	h = (long)(uintptr)cp + fid;
	if(h &lt; 0)
		h = ~h;
	h %= nelem(flist);

loop:
	lock(&amp;flock);
	for(f=flist[h]; f; f=f-&gt;next)
		if(f-&gt;fid == fid &amp;&amp; f-&gt;cp == cp){
			/*
			 * Already in use is an error
			 * when called from attach or clone (walk
			 * in 9P2000). The console uses FID[12] and
			 * never clunks them so catch that case.
			 */
			if(flag == 0 || cp == cons.chan)
				goto out;
			unlock(&amp;flock);
			return 0;
		}

	if(flag) {
		f = newfp();
		if(f) {
			f-&gt;fid = fid;
			f-&gt;cp = cp;
			f-&gt;wpath = 0;
			f-&gt;tlock = 0;
			f-&gt;doffset = 0;
			f-&gt;dslot = 0;
			f-&gt;auth = 0;
			f-&gt;next = flist[h];
			flist[h] = f;
			goto out;
		}
	}
	unlock(&amp;flock);
	return 0;

out:
	unlock(&amp;flock);
	qlock(f);
	if(f-&gt;fid == fid &amp;&amp; f-&gt;cp == cp)
		return f;
	qunlock(f);
	goto loop;
}

/*
 * always called with flock locked
 */
File*
newfp(void)
{
	static int first;
	File *f;
	int start, i;

	i = first;
	start = i;
	do {
		f = &amp;files[i];
		i++;
		if(i &gt;= conf.nfile)
			i = 0;
		if(f-&gt;cp)
			continue;
		first = i;
		return f;
	} while(i != start);

	print("out of files\n");
	return 0;
}

void
freefp(File *fp)
{
	Chan *cp;
	File *f, *prev;
	int h;

	if(!fp || !(cp = fp-&gt;cp))
		return;

	h = (long)(uintptr)cp + fp-&gt;fid;
	if(h &lt; 0)
		h = ~h;
	h %= nelem(flist);

	lock(&amp;flock);
	for(prev=0,f=flist[h]; f; prev=f,f=f-&gt;next)
		if(f == fp) {
			if(prev)
				prev-&gt;next = f-&gt;next;
			else
				flist[h] = f-&gt;next;
			break;
		}
	fp-&gt;cp = 0;
	unlock(&amp;flock);
}

int
iaccess(File *f, Dentry *d, int m)
{
	/* uid none gets only other permissions */
	if(f-&gt;uid != 0) {
		/*
		 * owner
		 */
		if(f-&gt;uid == d-&gt;uid)
			if((m&lt;&lt;6) &amp; d-&gt;mode)
				return 0;
		/*
		 * group membership
		 */
		if(ingroup(f-&gt;uid, d-&gt;gid))
			if((m&lt;&lt;3) &amp; d-&gt;mode)
				return 0;
	}

	/*
	 * other
	 */
	if(m &amp; d-&gt;mode) {
		if((d-&gt;mode &amp; DDIR) &amp;&amp; (m == DEXEC))
			return 0;
		if(!ingroup(f-&gt;uid, 9999))
			return 0;
	}

	/*
	 * various forms of superuser
	 */
	if(wstatallow)
		return 0;
	if(duallow != 0 &amp;&amp; duallow == f-&gt;uid)
		if((d-&gt;mode &amp; DDIR) &amp;&amp; (m == DREAD || m == DEXEC))
			return 0;

	return 1;
}

Tlock*
tlocked(Iobuf *p, Dentry *d)
{
	Tlock *t, *t1;
	Off qpath;
	Timet tim;
	Device *dev;

	tim = toytime();
	qpath = d-&gt;qid.path;
	dev = p-&gt;dev;

again:
	t1 = 0;
	for(t=tlocks+NTLOCK-1; t&gt;=tlocks; t--) {
		if(t-&gt;qpath == qpath)
		if(t-&gt;time &gt;= tim)
		if(t-&gt;dev == dev)
			return nil;		/* its locked */
		if(t1 != nil &amp;&amp; t-&gt;time == 0)
			t1 = t;			/* remember free lock */
	}
	if(t1 == 0) {
		// reclaim old locks
		lock(&amp;tlocklock);
		for(t=tlocks+NTLOCK-1; t&gt;=tlocks; t--)
			if(t-&gt;time &lt; tim) {
				t-&gt;time = 0;
				t1 = t;
			}
		unlock(&amp;tlocklock);
	}
	if(t1) {
		lock(&amp;tlocklock);
		if(t1-&gt;time != 0) {
			unlock(&amp;tlocklock);
			goto again;
		}
		t1-&gt;dev = dev;
		t1-&gt;qpath = qpath;
		t1-&gt;time = tim + TLOCK;
		unlock(&amp;tlocklock);
	}
	/* botch
	 * out of tlock nodes simulates
	 * a locked file
	 */
	return t1;
}

Wpath*
newwp(void)
{
	static int si = 0;
	int i;
	Wpath *w, *sw, *ew;

	i = si + 1;
	if(i &lt; 0 || i &gt;= conf.nwpath)
		i = 0;
	si = i;
	sw = &amp;wpaths[i];
	ew = &amp;wpaths[conf.nwpath];
	for(w=sw;;) {
		w++;
		if(w &gt;= ew)
			w = &amp;wpaths[0];
		if(w == sw) {
			print("out of wpaths\n");
			return 0;
		}
		if(w-&gt;refs)
			continue;
		lock(&amp;wpathlock);
		if(w-&gt;refs) {
			unlock(&amp;wpathlock);
			continue;
		}
		w-&gt;refs = 1;
		w-&gt;up = 0;
		unlock(&amp;wpathlock);
		return w;
	}

}

void
freewp(Wpath *w)
{
	lock(&amp;wpathlock);
	for(; w; w=w-&gt;up)
		w-&gt;refs--;
	unlock(&amp;wpathlock);
}

Off
qidpathgen(Device *dev)
{
	Iobuf *p;
	Superb *sb;
	Off path;

	p = getbuf(dev, superaddr(dev), Brd|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER))
		panic("newqid: super block");
	sb = (Superb*)p-&gt;iobuf;
	sb-&gt;qidgen++;
	path = sb-&gt;qidgen;
	putbuf(p);
	return path;
}

/* truncating to length &gt; 0 */
static void
truncfree(Truncstate *ts, Device *dev, int d, Iobuf *p, int i)
{
	int pastlast;
	Off a;

	pastlast = ts-&gt;pastlast;
	a = ((Off *)p-&gt;iobuf)[i];
	if (d &gt; 0 || pastlast)
		buffree(dev, a, d, ts);
	if (pastlast) {
		((Off *)p-&gt;iobuf)[i] = 0;
		p-&gt;flags |= Bmod|Bimm;
	} else if (d == 0 &amp;&amp; ts-&gt;relblk == ts-&gt;lastblk)
		ts-&gt;pastlast = 1;
	if (d == 0)
		ts-&gt;relblk++;
}

/*
 * free the block at `addr' on dev.
 * if it's an indirect block (d [depth] &gt; 0),
 * first recursively free all the blocks it names.
 *
 * ts-&gt;relblk is the block number within the file of this
 * block (or the first data block eventually pointed to via
 * this indirect block).
 */
void
buffree(Device *dev, Off addr, int d, Truncstate *ts)
{
	Iobuf *p;
	Off a;
	int i, pastlast;

	if(!addr)
		return;
	pastlast = (ts == nil? 1: ts-&gt;pastlast);
	/*
	 * if this is an indirect block, recurse and free any
	 * suitable blocks within it (possibly via further indirect blocks).
	 */
	if(d &gt; 0) {
		d--;
		p = getbuf(dev, addr, Brd);
		if(p) {
			if (ts == nil)		/* common case: create */
				for(i=INDPERBUF-1; i&gt;=0; i--) {
					a = ((Off *)p-&gt;iobuf)[i];
					buffree(dev, a, d, nil);
				}
			else			/* wstat truncation */
				for (i = 0; i &lt; INDPERBUF; i++)
					truncfree(ts, dev, d, p, i);
			putbuf(p);
		}
	}
	if (!pastlast)
		return;
	/*
	 * having zeroed the pointer to this block, add it to the free list.
	 * stop outstanding i/o
	 */
	p = getbuf(dev, addr, Bprobe);
	if(p) {
		p-&gt;flags &amp;= ~(Bmod|Bimm);
		putbuf(p);
	}
	/*
	 * dont put written worm
	 * blocks into free list
	 */
	if(dev-&gt;type == Devcw) {
		i = cwfree(dev, addr);
		if(i)
			return;
	}
	p = getbuf(dev, superaddr(dev), Brd|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER))
		panic("buffree: super block");
	addfree(dev, addr, (Superb*)p-&gt;iobuf);
	putbuf(p);
}

Off
bufalloc(Device *dev, int tag, long qid, int uid)
{
	Iobuf *bp, *p;
	Superb *sb;
	Off a, n;

	p = getbuf(dev, superaddr(dev), Brd|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER)) {
		print("bufalloc: super block\n");
		if(p)
			putbuf(p);
		return 0;
	}
	sb = (Superb*)p-&gt;iobuf;

loop:
	n = --sb-&gt;fbuf.nfree;
	sb-&gt;tfree--;
	if(n &lt; 0 || n &gt;= FEPERBUF) {
		print("bufalloc: %Z: bad freelist\n", dev);
		n = 0;
		sb-&gt;fbuf.free[0] = 0;
	}
	a = sb-&gt;fbuf.free[n];
	if(n &lt;= 0) {
		if(a == 0) {
			sb-&gt;tfree = 0;
			sb-&gt;fbuf.nfree = 1;
			if(dev-&gt;type == Devcw) {
				n = uid;
				if(n &lt; 0 || n &gt;= nelem(growacct))
					n = 0;
				growacct[n]++;
				if(cwgrow(dev, sb, uid))
					goto loop;
			}
			putbuf(p);
			print("fs %Z full uid=%d\n", dev, uid);
			return 0;
		}
		bp = getbuf(dev, a, Brd);
		if(!bp || checktag(bp, Tfree, QPNONE)) {
			if(bp)
				putbuf(bp);
			putbuf(p);
			return 0;
		}
		sb-&gt;fbuf = *(Fbuf*)bp-&gt;iobuf;
		putbuf(bp);
	}

	bp = getbuf(dev, a, Bmod);
	memset(bp-&gt;iobuf, 0, RBUFSIZE);
	settag(bp, tag, qid);
	if(tag == Tind1 || tag == Tind2 ||
#ifndef COMPAT32
	    tag == Tind3 || tag == Tind4 ||  /* add more Tind tags here ... */
#endif
	    tag == Tdir)
		bp-&gt;flags |= Bimm;
	putbuf(bp);
	putbuf(p);
	return a;
}

/*
 * what are legal characters in a name?
 * only disallow control characters.
 * a) utf avoids control characters.
 * b) '/' may not be the separator
 */
int
checkname(char *n)
{
	int i, c;

	for(i=0; i&lt;NAMELEN; i++) {
		c = *n &amp; 0xff;
		if(c == 0) {
			if(i == 0)
				return 1;
			memset(n, 0, NAMELEN-i);
			return 0;
		}
		if(c &lt;= 040)
			return 1;
		n++;
	}
	return 1;	/* too long */
}

void
addfree(Device *dev, Off addr, Superb *sb)
{
	int n;
	Iobuf *p;

	n = sb-&gt;fbuf.nfree;
	if(n &lt; 0 || n &gt; FEPERBUF)
		panic("addfree: bad freelist");
	if(n &gt;= FEPERBUF) {
		p = getbuf(dev, addr, Bmod|Bimm);
		if(p == 0)
			panic("addfree: getbuf");
		*(Fbuf*)p-&gt;iobuf = sb-&gt;fbuf;
		settag(p, Tfree, QPNONE);
		putbuf(p);
		n = 0;
	}
	sb-&gt;fbuf.free[n++] = addr;
	sb-&gt;fbuf.nfree = n;
	sb-&gt;tfree++;
	if(addr &gt;= sb-&gt;fsize)
		sb-&gt;fsize = addr+1;
}

/*
static int
Yfmt(Fmt* fmt)
{
	Chan *cp;
	char s[20];

	cp = va_arg(fmt-&gt;args, Chan*);
	sprint(s, "C%d.%.3d", cp-&gt;type, cp-&gt;chan);
	return fmtstrcpy(fmt, s);
}
 */

static int
Zfmt(Fmt* fmt)
{
	Device *d;
	int c, c1;
	char s[100];

	d = va_arg(fmt-&gt;args, Device*);
	if(d == nil) {
		sprint(s, "Z***");
		goto out;
	}
	c = c1 = '\0';
	switch(d-&gt;type) {
	default:
		sprint(s, "D%d", d-&gt;type);
		break;
	case Devwren:
		c = 'w';
		/* fallthrough */
	case Devworm:
		if (c == '\0')
			c = 'r';
		/* fallthrough */
	case Devlworm:
		if (c == '\0')
			c = 'l';
		if(d-&gt;wren.ctrl == 0 &amp;&amp; d-&gt;wren.lun == 0)
			sprint(s, "%c%d", c, d-&gt;wren.targ);
		else
			sprint(s, "%c%d.%d.%d", c, d-&gt;wren.ctrl, d-&gt;wren.targ,
				d-&gt;wren.lun);
		break;
	case Devmcat:
		c = '(';
		c1 = ')';
		/* fallthrough */
	case Devmlev:
		if (c == '\0') {
			c = '[';
			c1 = ']';
		}
		/* fallthrough */
	case Devmirr:
		if (c == '\0') {
			c = '{';
			c1 = '}';
		}
		if(d-&gt;cat.first == d-&gt;cat.last)
			sprint(s, "%c%Z%c", c, d-&gt;cat.first, c1);
		else if(d-&gt;cat.first-&gt;link == d-&gt;cat.last)
			sprint(s, "%c%Z%Z%c", c, d-&gt;cat.first, d-&gt;cat.last, c1);
		else
			sprint(s, "%c%Z-%Z%c", c, d-&gt;cat.first, d-&gt;cat.last, c1);
		break;
	case Devro:
		sprint(s, "o%Z%Z", d-&gt;ro.parent-&gt;cw.c, d-&gt;ro.parent-&gt;cw.w);
		break;
	case Devcw:
		sprint(s, "c%Z%Z", d-&gt;cw.c, d-&gt;cw.w);
		break;
	case Devjuke:
		sprint(s, "j%Z%Z", d-&gt;j.j, d-&gt;j.m);
		break;
	case Devfworm:
		sprint(s, "f%Z", d-&gt;fw.fw);
		break;
	case Devpart:
		sprint(s, "p(%Z)%ld.%ld", d-&gt;part.d, d-&gt;part.base, d-&gt;part.size);
		break;
	case Devswab:
		sprint(s, "x%Z", d-&gt;swab.d);
		break;
	case Devnone:
		sprint(s, "n");
		break;
	}
out:
	return fmtstrcpy(fmt, s);
}

static int
Gfmt(Fmt* fmt)
{
	int t;
	char *s;

	t = va_arg(fmt-&gt;args, int);
	s = "&lt;badtag&gt;";
	if(t &gt;= 0 &amp;&amp; t &lt; MAXTAG)
		s = tagnames[t];
	return fmtstrcpy(fmt, s);
}

void
formatinit(void)
{
	quotefmtinstall();
//	fmtinstall('Y', Yfmt);	/* print channels */
	fmtinstall('Z', Zfmt);	/* print devices */
	fmtinstall('G', Gfmt);	/* print tags */
	fmtinstall('T', Tfmt);	/* print times */
//	fmtinstall('E', eipfmt);	/* print ether addresses */
	fmtinstall('I', eipfmt);	/* print ip addresses */
}

void
rootream(Device *dev, Off addr)
{
	Iobuf *p;
	Dentry *d;

	p = getbuf(dev, addr, Bmod|Bimm);
	memset(p-&gt;iobuf, 0, RBUFSIZE);
	settag(p, Tdir, QPROOT);
	d = getdir(p, 0);
	strcpy(d-&gt;name, "/");
	d-&gt;uid = -1;
	d-&gt;gid = -1;
	d-&gt;mode = DALLOC | DDIR |
		((DREAD|DEXEC) &lt;&lt; 6) |
		((DREAD|DEXEC) &lt;&lt; 3) |
		((DREAD|DEXEC) &lt;&lt; 0);
	d-&gt;qid = QID9P1(QPROOT|QPDIR,0);
	d-&gt;atime = time(nil);
	d-&gt;mtime = d-&gt;atime;
	d-&gt;muid = 0;
	putbuf(p);
}

void
superream(Device *dev, Off addr)
{
	Iobuf *p;
	Superb *s;
	Off i;

	p = getbuf(dev, addr, Bmod|Bimm);
	memset(p-&gt;iobuf, 0, RBUFSIZE);
	settag(p, Tsuper, QPSUPER);

	s = (Superb*)p-&gt;iobuf;
	s-&gt;fstart = 2;
	s-&gt;fsize = devsize(dev);
	s-&gt;fbuf.nfree = 1;
	s-&gt;qidgen = 10;
	for(i = s-&gt;fsize-1; i &gt;= addr+2; i--)
		addfree(dev, i, s);
	putbuf(p);
}

struct
{
	Lock;
	Msgbuf	*smsgbuf;
	Msgbuf	*lmsgbuf;
} msgalloc;

/*
 * pre-allocate some message buffers at boot time.
 * if this supply is exhausted, more will be allocated as needed.
 */
void
mbinit(void)
{
	Msgbuf *mb;
	Rabuf *rb;
	int i;

	lock(&amp;msgalloc);
	unlock(&amp;msgalloc);
	msgalloc.lmsgbuf = 0;
	msgalloc.smsgbuf = 0;
	for(i=0; i&lt;conf.nlgmsg; i++) {
		mb = malloc(sizeof(Msgbuf));
		mb-&gt;magic = Mbmagic;
		mb-&gt;xdata = malloc(LARGEBUF+Slop);
		mb-&gt;flags = LARGE;
		mbfree(mb);
		cons.nlarge++;
	}
	for(i=0; i&lt;conf.nsmmsg; i++) {
		mb = malloc(sizeof(Msgbuf));
		mb-&gt;magic = Mbmagic;
		mb-&gt;xdata = malloc(SMALLBUF+Slop);
		mb-&gt;flags = 0;
		mbfree(mb);
		cons.nsmall++;
	}
	memset(mballocs, 0, sizeof(mballocs));

	lock(&amp;rabuflock);
	unlock(&amp;rabuflock);
	rabuffree = 0;
	for(i=0; i&lt;1000; i++) {
		rb = malloc(sizeof(*rb));
		rb-&gt;link = rabuffree;
		rabuffree = rb;
	}
}

Msgbuf*
mballoc(int count, Chan *cp, int category)
{
	Msgbuf *mb;

	lock(&amp;msgalloc);
	if(count &gt; SMALLBUF) {
		if(count &gt; LARGEBUF)
			panic("msgbuf count");
		mb = msgalloc.lmsgbuf;
		if(mb == nil) {
			mb = malloc(sizeof(Msgbuf));
			mb-&gt;xdata = malloc(LARGEBUF+Slop);
			cons.nlarge++;
		} else
			msgalloc.lmsgbuf = mb-&gt;next;
		mb-&gt;flags = LARGE;
	} else {
		mb = msgalloc.smsgbuf;
		if(mb == nil) {
			mb = malloc(sizeof(Msgbuf));
			mb-&gt;xdata = malloc(SMALLBUF+Slop);
			cons.nsmall++;
		} else
			msgalloc.smsgbuf = mb-&gt;next;
		mb-&gt;flags = 0;
	}
	mballocs[category]++;
	unlock(&amp;msgalloc);
	mb-&gt;magic = Mbmagic;
	mb-&gt;count = count;
	mb-&gt;chan = cp;
	mb-&gt;next = 0;
	mb-&gt;param = 0;
	mb-&gt;category = category;
	mb-&gt;data = mb-&gt;xdata+Slop;
	return mb;
}

void
mbfree(Msgbuf *mb)
{
	if(mb == nil)
		return;
	assert(mb-&gt;magic == Mbmagic);
	if (mb-&gt;magic != Mbmagic)
		panic("mbfree: bad magic 0x%lux", mb-&gt;magic);
	if(mb-&gt;flags &amp; BTRACE)
		print("mbfree: BTRACE cat=%d flags=%ux, caller %#p\n",
			mb-&gt;category, mb-&gt;flags, getcallerpc(&amp;mb));

	if(mb-&gt;flags &amp; FREE)
		panic("mbfree already free");

	lock(&amp;msgalloc);
	mballocs[mb-&gt;category]--;
	mb-&gt;flags |= FREE;
	if(mb-&gt;flags &amp; LARGE) {
		mb-&gt;next = msgalloc.lmsgbuf;
		msgalloc.lmsgbuf = mb;
	} else {
		mb-&gt;next = msgalloc.smsgbuf;
		msgalloc.smsgbuf = mb;
	}
	mb-&gt;data = 0;
	mb-&gt;magic = 0;
	unlock(&amp;msgalloc);
}

/*
 * returns 1 if n is prime
 * used for adjusting lengths
 * of hashing things.
 * there is no need to be clever
 */
int
prime(vlong n)
{
	long i;

	if((n%2) == 0)
		return 0;
	for(i=3;; i+=2) {
		if((n%i) == 0)
			return 0;
		if((vlong)i*i &gt;= n)
			return 1;
	}
}

char*
getwrd(char *word, char *line)
{
	int c, n;

	while(isascii(*line) &amp;&amp; isspace(*line) &amp;&amp; *line != '\n')
		line++;
	for(n = 0; n &lt; Maxword; n++) {
		c = *line;
		if(c == '\0' || isascii(c) &amp;&amp; isspace(c))
			break;
		line++;
		*word++ = c;
	}
	*word = 0;
	return line;
}

void
hexdump(void *a, int n)
{
	char s1[30], s2[4];
	uchar *p;
	int i;

	p = a;
	s1[0] = 0;
	for(i = 0; i &lt; n; i++) {
		sprint(s2, " %.2ux", p[i]);
		strcat(s1, s2);
		if((i&amp;7) == 7) {
			print("%s\n", s1);
			s1[0] = 0;
		}
	}
	if(s1[0])
		print("%s\n", s1);
}

void*
fs_recv(Queue *q, int)
{
	void *a;
	int i, c;

	if(q == nil)
		panic("recv null q");
	qlock(q);
	q-&gt;waitedfor = 1;
	while((c = q-&gt;count) &lt;= 0)
		rsleep(&amp;q-&gt;empty);
	i = q-&gt;loc;
	a = q-&gt;args[i];
	i++;
	if(i &gt;= q-&gt;size)
		i = 0;
	q-&gt;loc = i;
	q-&gt;count = c-1;
	rwakeup(&amp;q-&gt;full);			/* no longer full */
	qunlock(q);
	return a;
}

void
fs_send(Queue *q, void *a)
{
	int i, c;

	if(q == nil)
		panic("send null q");
	if(!q-&gt;waitedfor) {
		for (i = 0; i &lt; 5 &amp;&amp; !q-&gt;waitedfor; i++)
			sleep(1000);
		if(!q-&gt;waitedfor) {
			/* likely a bug; don't wait forever */
			print("no readers yet for %s q\n", q-&gt;name);
			abort();
		}
	}
	qlock(q);
	while((c = q-&gt;count) &gt;= q-&gt;size)
		rsleep(&amp;q-&gt;full);
	i = q-&gt;loc + c;
	if(i &gt;= q-&gt;size)
		i -= q-&gt;size;
	q-&gt;args[i] = a;
	q-&gt;count = c+1;
	rwakeup(&amp;q-&gt;empty);			/* no longer empty */
	qunlock(q);
}

Queue*
newqueue(int size, char *name)
{
	Queue *q;

	q = malloc(sizeof(Queue) + (size-1)*sizeof(void*));
	q-&gt;size = size;
	q-&gt;full.l = q-&gt;empty.l = &amp;q-&gt;QLock;
	q-&gt;name = name;
	return q;
}

int
devread(Device *d, Off b, void *c)
{
	int e;

	for (;;)
		switch(d-&gt;type) {
		case Devcw:
			return cwread(d, b, c);

		case Devjuke:
			d = d-&gt;j.m;
			break;

		case Devro:
			return roread(d, b, c);

		case Devwren:
			return wrenread(d, b, c);

		case Devworm:
		case Devlworm:
			return wormread(d, b, c);

		case Devfworm:
			return fwormread(d, b, c);

		case Devmcat:
			return mcatread(d, b, c);

		case Devmlev:
			return mlevread(d, b, c);

		case Devmirr:
			return mirrread(d, b, c);

		case Devpart:
			return partread(d, b, c);

		case Devswab:
			e = devread(d-&gt;swab.d, b, c);
			if(e == 0)
				swab(c, 0);
			return e;

		case Devnone:
			print("read from device none(%lld)\n", (Wideoff)b);
			return 1;
		default:
			panic("illegal device in devread: %Z %lld",
				d, (Wideoff)b);
			return 1;
		}
}

int
devwrite(Device *d, Off b, void *c)
{
	int e;

	/*
	 * set readonly to non-0 to prevent all writes;
	 * mainly for trying dangerous experiments.
	 */
	if (readonly)
		return 0;
	for (;;)
		switch(d-&gt;type) {
		case Devcw:
			return cwwrite(d, b, c);

		case Devjuke:
			d = d-&gt;j.m;
			break;

		case Devro:
			print("write to ro device %Z(%lld)\n", d, (Wideoff)b);
			return 1;

		case Devwren:
			return wrenwrite(d, b, c);

		case Devworm:
		case Devlworm:
			return wormwrite(d, b, c);

		case Devfworm:
			return fwormwrite(d, b, c);

		case Devmcat:
			return mcatwrite(d, b, c);

		case Devmlev:
			return mlevwrite(d, b, c);

		case Devmirr:
			return mirrwrite(d, b, c);

		case Devpart:
			return partwrite(d, b, c);

		case Devswab:
			swab(c, 1);
			e = devwrite(d-&gt;swab.d, b, c);
			swab(c, 0);
			return e;

		case Devnone:
			/* checktag() can generate blocks with type devnone */
			return 0;
		default:
			panic("illegal device in devwrite: %Z %lld",
				d, (Wideoff)b);
			return 1;
		}
}

Devsize
devsize(Device *d)
{
	for (;;)
		switch(d-&gt;type) {
		case Devcw:
		case Devro:
			return cwsize(d);

		case Devjuke:
			d = d-&gt;j.m;
			break;

		case Devwren:
			return wrensize(d);

		case Devworm:
		case Devlworm:
			return wormsize(d);

		case Devfworm:
			return fwormsize(d);

		case Devmcat:
			return mcatsize(d);

		case Devmlev:
			return mlevsize(d);

		case Devmirr:
			return mirrsize(d);

		case Devpart:
			return partsize(d);

		case Devswab:
			d = d-&gt;swab.d;
			break;
		default:
			panic("illegal device in devsize: %Z", d);
			return 0;
		}
}

/* result is malloced */
char *
sdof(Device *d)
{
	static char name[256];

	for (;;)
		switch(d-&gt;type) {
		case Devjuke:
			d = d-&gt;j.j;		/* robotics */
			break;
		case Devwren:
			snprint(name, sizeof name, "/dev/sd%d%d", d-&gt;wren.ctrl,
				d-&gt;wren.targ);
			return strdup(name);
		case Devswab:
			d = d-&gt;swab.d;
			break;
		default:
			panic("illegal device in sdof: %Z", d);
			return nil;
		}
}

Off
superaddr(Device *d)
{
	for (;;)
		switch(d-&gt;type) {
		default:
			return SUPER_ADDR;
		case Devcw:
		case Devro:
			return cwsaddr(d);
		case Devswab:
			d = d-&gt;swab.d;
			break;
		}
}

Off
getraddr(Device *d)
{
	for (;;)
		switch(d-&gt;type) {
		default:
			return ROOT_ADDR;
		case Devcw:
		case Devro:
			return cwraddr(d);
		case Devswab:
			d = d-&gt;swab.d;
			break;
		}
}

void
devream(Device *d, int top)
{
	Device *l;

loop:
	print("\tdevream: %Z %d\n", d, top);
	switch(d-&gt;type) {
	default:
		print("ream: unknown dev type %Z\n", d);
		return;

	case Devcw:
		devream(d-&gt;cw.w, 0);
		devream(d-&gt;cw.c, 0);
		if(top) {
			wlock(&amp;mainlock);
			cwream(d);
			wunlock(&amp;mainlock);
		}
		devinit(d);
		return;

	case Devfworm:
		devream(d-&gt;fw.fw, 0);
		fwormream(d);
		break;

	case Devpart:
		devream(d-&gt;part.d, 0);
		break;

	case Devmlev:
	case Devmcat:
	case Devmirr:
		for(l=d-&gt;cat.first; l; l=l-&gt;link)
			devream(l, 0);
		break;

	case Devjuke:
	case Devworm:
	case Devlworm:
	case Devwren:
		break;

	case Devswab:
		d = d-&gt;swab.d;
		goto loop;
	}
	devinit(d);
	if(top) {
		wlock(&amp;mainlock);
		rootream(d, ROOT_ADDR);
		superream(d, SUPER_ADDR);
		wunlock(&amp;mainlock);
	}
}

void
devrecover(Device *d)
{
	for (;;) {
		print("recover: %Z\n", d);
		switch(d-&gt;type) {
		default:
			print("recover: unknown dev type %Z\n", d);
			return;

		case Devcw:
			wlock(&amp;mainlock);	/* recover */
			cwrecover(d);
			wunlock(&amp;mainlock);
			return;

		case Devswab:
			d = d-&gt;swab.d;
			break;
		}
	}
}

void
devinit(Device *d)
{
	for (;;) {
		if(d-&gt;init)
			return;
		d-&gt;init = 1;
		print("\tdevinit %Z\n", d);
		switch(d-&gt;type) {
		default:
			print("devinit unknown device %Z\n", d);
			return;

		case Devro:
			cwinit(d-&gt;ro.parent);
			return;

		case Devcw:
			cwinit(d);
			return;

		case Devjuke:
			jukeinit(d);
			return;

		case Devwren:
			wreninit(d);
			return;

		case Devworm:
		case Devlworm:
			return;

		case Devfworm:
			fworminit(d);
			return;

		case Devmcat:
			mcatinit(d);
			return;

		case Devmlev:
			mlevinit(d);
			return;

		case Devmirr:
			mirrinit(d);
			return;

		case Devpart:
			partinit(d);
			return;

		case Devswab:
			d = d-&gt;swab.d;
			break;

		case Devnone:
			print("devinit of Devnone\n");
			return;
		}
	}
}

void
swab2(void *c)
{
	uchar *p;
	int t;

	p = c;

	t = p[0];
	p[0] = p[1];
	p[1] = t;
}

void
swab4(void *c)
{
	uchar *p;
	int t;

	p = c;

	t = p[0];
	p[0] = p[3];
	p[3] = t;

	t = p[1];
	p[1] = p[2];
	p[2] = t;
}

void
swab8(void *c)
{
	uchar *p;
	int t;

	p = c;

	t = p[0];
	p[0] = p[7];
	p[7] = t;

	t = p[1];
	p[1] = p[6];
	p[6] = t;

	t = p[2];
	p[2] = p[5];
	p[5] = t;

	t = p[3];
	p[3] = p[4];
	p[4] = t;
}

/*
 * swab a block
 *	flag = 0 -- convert from foreign to native
 *	flag = 1 -- convert from native to foreign
 */
void
swab(void *c, int flag)
{
	uchar *p;
	Tag *t;
	int i, j;
	Dentry *d;
	Cache *h;
	Bucket *b;
	Superb *s;
	Fbuf *f;
	Off *l;

	/* swab the tag */
	p = (uchar*)c;
	t = (Tag*)(p + BUFSIZE);
	if(!flag) {
		swab2(&amp;t-&gt;pad);
		swab2(&amp;t-&gt;tag);
		swaboff(&amp;t-&gt;path);
	}

	/* swab each block type */
	switch(t-&gt;tag) {

	default:
		print("no swab for tag=%G rw=%d\n", t-&gt;tag, flag);
		for(j=0; j&lt;16; j++)
			print(" %.2x", p[BUFSIZE+j]);
		print("\n");
		for(i=0; i&lt;16; i++) {
			print("%.4x", i*16);
			for(j=0; j&lt;16; j++)
				print(" %.2x", p[i*16+j]);
			print("\n");
		}
		panic("swab");
		break;

	case Tsuper:
		s = (Superb*)p;
		swaboff(&amp;s-&gt;fbuf.nfree);
		for(i=0; i&lt;FEPERBUF; i++)
			swaboff(&amp;s-&gt;fbuf.free[i]);
		swaboff(&amp;s-&gt;fstart);
		swaboff(&amp;s-&gt;fsize);
		swaboff(&amp;s-&gt;tfree);
		swaboff(&amp;s-&gt;qidgen);
		swaboff(&amp;s-&gt;cwraddr);
		swaboff(&amp;s-&gt;roraddr);
		swaboff(&amp;s-&gt;last);
		swaboff(&amp;s-&gt;next);
		break;

	case Tdir:
		for(i=0; i&lt;DIRPERBUF; i++) {
			d = (Dentry*)p + i;
			swab2(&amp;d-&gt;uid);
			swab2(&amp;d-&gt;gid);
			swab2(&amp;d-&gt;mode);
			swab2(&amp;d-&gt;muid);
			swaboff(&amp;d-&gt;qid.path);
			swab4(&amp;d-&gt;qid.version);
			swaboff(&amp;d-&gt;size);
			for(j=0; j&lt;NDBLOCK; j++)
				swaboff(&amp;d-&gt;dblock[j]);
			for (j = 0; j &lt; NIBLOCK; j++)
				swaboff(&amp;d-&gt;iblocks[j]);
			swab4(&amp;d-&gt;atime);
			swab4(&amp;d-&gt;mtime);
		}
		break;

	case Tind1:
	case Tind2:
#ifndef COMPAT32
	case Tind3:
	case Tind4:
	/* add more Tind tags here ... */
#endif
		l = (Off *)p;
		for(i=0; i&lt;INDPERBUF; i++) {
			swaboff(l);
			l++;
		}
		break;

	case Tfree:
		f = (Fbuf*)p;
		swaboff(&amp;f-&gt;nfree);
		for(i=0; i&lt;FEPERBUF; i++)
			swaboff(&amp;f-&gt;free[i]);
		break;

	case Tbuck:
		for(i=0; i&lt;BKPERBLK; i++) {
			b = (Bucket*)p + i;
			swab4(&amp;b-&gt;agegen);
			for(j=0; j&lt;CEPERBK; j++) {
				swab2(&amp;b-&gt;entry[j].age);
				swab2(&amp;b-&gt;entry[j].state);
				swaboff(&amp;b-&gt;entry[j].waddr);
			}
		}
		break;

	case Tcache:
		h = (Cache*)p;
		swaboff(&amp;h-&gt;maddr);
		swaboff(&amp;h-&gt;msize);
		swaboff(&amp;h-&gt;caddr);
		swaboff(&amp;h-&gt;csize);
		swaboff(&amp;h-&gt;fsize);
		swaboff(&amp;h-&gt;wsize);
		swaboff(&amp;h-&gt;wmax);
		swaboff(&amp;h-&gt;sbaddr);
		swaboff(&amp;h-&gt;cwraddr);
		swaboff(&amp;h-&gt;roraddr);
		swab4(&amp;h-&gt;toytime);
		swab4(&amp;h-&gt;time);
		break;

	case Tnone:	// unitialized
	case Tfile:	// someone elses problem
	case Tvirgo:	// bit map -- all bytes
	case Tconfig:	// configuration string -- all bytes
		break;
	}

	/* swab the tag */
	if(flag) {
		swab2(&amp;t-&gt;pad);
		swab2(&amp;t-&gt;tag);
		swaboff(&amp;t-&gt;path);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

