<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/db/pcs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/db/pcs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *
 *	debugger
 *
 */

#include "defs.h"
#include "fns.h"

char	NOPCS[] = "no process";

/* sub process control */

void
subpcs(int modif)
{
	int	check;
	int	runmode;
	int	keepnote;
	int	n, r;
	long line, curr;
	BKPT *bk;
	char *comptr;

	runmode=SINGLE;
	r = 0;
	keepnote=0;
	loopcnt=cntval;
	switch (modif) {

		/* delete breakpoint */
	case 'd': 
	case 'D':
		if ((bk=scanbkpt(dot)) == 0)
			error("no breakpoint set");
		bk-&gt;flag=BKPTCLR;
		return;

		/* set breakpoint */
	case 'b': 
	case 'B':
		if (bk=scanbkpt(dot))
			bk-&gt;flag=BKPTCLR;
		for (bk=bkpthead; bk; bk=bk-&gt;nxtbkpt)
			if (bk-&gt;flag == BKPTCLR)
				break;
		if (bk==0) {
			bk = (BKPT *)malloc(sizeof(*bk));
			if (bk == 0)
				error("too many breakpoints");
			bk-&gt;nxtbkpt=bkpthead;
			bkpthead=bk;
		}
		bk-&gt;loc = dot;
		bk-&gt;initcnt = bk-&gt;count = cntval;
		bk-&gt;flag = modif == 'b' ? BKPTSET : BKPTTMP;
		check=MAXCOM-1;
		comptr=bk-&gt;comm;
		rdc();
		reread();
		do {
			*comptr++ = readchar();
		} while (check-- &amp;&amp; lastc!=EOR);
		*comptr=0;
		if(bk-&gt;comm[0] != EOR &amp;&amp; cntflg == FALSE)
			bk-&gt;initcnt = bk-&gt;count = HUGEINT;
		reread();
		if (check)
			return;
		error("bkpt command too long");

		/* exit */
	case 'k' :
	case 'K':
		if (pid == 0)
			error(NOPCS);
		dprint("%d: killed", pid);
		pcsactive = 1;	/* force 'kill' ctl */
		endpcs();
		return;

		/* run program */
	case 'r': 
	case 'R':
		endpcs();
		setup();
		runmode = CONTIN;
		break;

		/* single step */
	case 's': 
		if (pid == 0) {
			setup();
			loopcnt--;
		}
		runmode=SINGLE;
		keepnote=defval(1);
		break;
	case 'S':
		if (pid == 0) {
			setup();
			loopcnt--;
		}
		keepnote=defval(1);
		line = pc2line(rget(cormap, mach-&gt;pc));
		n = loopcnt;
		dprint("%s: running\n", symfil);
		flush();
		for (loopcnt = 1; n &gt; 0; loopcnt = 1) {
			r = runpcs(SINGLE, keepnote);
			curr = pc2line(dot);
			if (line != curr) {	/* on a new line of c */
				line = curr;
				n--;
			}
		}
		loopcnt = 0;
		break;
		/* continue with optional note */
	case 'c': 
	case 'C': 
		if (pid==0)
			error(NOPCS);
		runmode=CONTIN;
		keepnote=defval(1);
		break;

	case 'n':	/* deal with notes */
		if (pid==0)
			error(NOPCS);
		n=defval(-1);
		if(n&gt;=0 &amp;&amp; n&lt;nnote){
			nnote--;
			memmove(note[n], note[n+1], (nnote-n)*sizeof(note[0]));
		}
		notes();
		return;

	case 'h':	/* halt the current process */
		if (adrflg &amp;&amp; adrval == 0) {
			if (pid == 0)
				error(NOPCS);
			ungrab();
		}
		else {
			grab();
			dprint("stopped at%16t");
			goto Return;
		}
		return;

	case 'x':	/* continue executing the current process */
		if (pid == 0)
			error(NOPCS);
		ungrab();
		return;

	default:
		error("bad `:' command");
	}

	if (loopcnt&gt;0) {
		dprint("%s: running\n", symfil);
		flush();
		r = runpcs(runmode,keepnote);
	}
	if (r)
		dprint("breakpoint%16t");
	else
		dprint("stopped at%16t");
    Return:
	delbp();
	printpc();
	notes();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

