<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/db/setup.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/db/setup.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->

/*
 * init routines
 */
#include "defs.h"
#include "fns.h"

char	*symfil;
char	*corfil;

Map	*symmap;
Map	*cormap;
Map	*dotmap;

int fsym, fcor;
static Fhdr fhdr;

static int getfile(char*, int, int);

void
setsym(void)
{
	Symbol s;

	if((fsym = getfile(symfil, 1, wtflag)) &lt; 0) {
		symmap = dumbmap(-1);
		return;
	}
	if (crackhdr(fsym, &amp;fhdr)) {
		machbytype(fhdr.type);
		symmap = loadmap(symmap, fsym, &amp;fhdr);
		if (symmap == 0)
			symmap = dumbmap(fsym);
		if (syminit(fsym, &amp;fhdr) &lt; 0)
			dprint("%r\n");
		if (mach-&gt;sbreg &amp;&amp; lookup(0, mach-&gt;sbreg, &amp;s))
			mach-&gt;sb = s.value;
	}
	else
		symmap = dumbmap(fsym);
}

void
setcor(void)
{
	int i;

	if (cormap) {
		for (i = 0; i &lt; cormap-&gt;nsegs; i++)
			if (cormap-&gt;seg[i].inuse)
				close(cormap-&gt;seg[i].fd);
	}

	fcor = getfile(corfil, 2, ORDWR);
	if (fcor &lt;= 0) {
		if (cormap)
			free(cormap);
		cormap = dumbmap(-1);
		return;
	}
	if(pid &gt; 0) {	/* provide addressability to executing process */
		cormap = attachproc(pid, kflag, fcor, &amp;fhdr);
		if (!cormap)
			cormap = dumbmap(-1);
	} else {
		cormap = newmap(cormap, 2);
		if (!cormap)
			cormap = dumbmap(-1);
		setmap(cormap, fcor, fhdr.txtaddr, fhdr.txtaddr+fhdr.txtsz, fhdr.txtaddr, "text");
		setmap(cormap, fcor, fhdr.dataddr, 0xffffffff, fhdr.dataddr, "data");
	}
	kmsys();
	return;
}

Map *
dumbmap(int fd)
{
	Map *dumb;

	extern Mach mi386;
	extern Machdata i386mach;

	dumb = newmap(0, 1);
	setmap(dumb, fd, 0, 0xffffffff, 0, "data");
	if (!mach) 			/* default machine = 386 */
		mach = &amp;mi386;
	if (!machdata)
		machdata = &amp;i386mach;
	return dumb;
}

/*
 * set up maps for a direct process image (/proc)
 */

void
cmdmap(Map *map)
{
	int i;
	char name[MAXSYM];

	extern char lastc;

	rdc();
	readsym(name);
	i = findseg(map, name);
	if (i &lt; 0)	/* not found */
		error("Invalid map name");

	if (expr(0)) {
		if (strcmp(name, "text") == 0)
			textseg(expv, &amp;fhdr);
		map-&gt;seg[i].b = expv;
	} else
		error("Invalid base address"); 
	if (expr(0))
		map-&gt;seg[i].e = expv;
	else
		error("Invalid end address"); 
	if (expr(0))
		map-&gt;seg[i].f = expv; 
	else
		error("Invalid file offset"); 
	if (rdc()=='?' &amp;&amp; map == cormap) {
		if (fcor)
			close(fcor);
		fcor=fsym;
		corfil=symfil;
		cormap = symmap;
	} else if (lastc == '/' &amp;&amp; map == symmap) {
		if (fsym)
			close(fsym);
		fsym=fcor;
		symfil=corfil;
		symmap=cormap;
	} else
		reread();
}

static int
getfile(char *filnam, int cnt, int omode)
{
	int f;

	if (filnam == 0)
		return -1;
	if (strcmp(filnam, "-") == 0)
		return 0;
	f = open(filnam, omode|OCEXEC);
	if(f &lt; 0 &amp;&amp; omode == ORDWR){
		f = open(filnam, OREAD|OCEXEC);
		if(f &gt;= 0)
			dprint("%s open read-only\n", filnam);
	}
	if (f &lt; 0 &amp;&amp; xargc &gt; cnt)
		if (wtflag)
			f = create(filnam, 1, 0666);
	if (f &lt; 0) {
		dprint("cannot open `%s': %r\n", filnam);
		return -1;
	}
	return f;
}

void
kmsys(void)
{
	int i;

	i = findseg(symmap, "text");
	if (i &gt;= 0) {
		symmap-&gt;seg[i].b = symmap-&gt;seg[i].b&amp;~mach-&gt;ktmask;
		symmap-&gt;seg[i].e = ~0;
	}
	i = findseg(symmap, "data");
	if (i &gt;= 0) {
		symmap-&gt;seg[i].b |= mach-&gt;kbase;
		symmap-&gt;seg[i].e |= mach-&gt;kbase;
	}
}

void
attachprocess(void)
{
	char buf[100];
	Dir *sym, *mem;
	int fd;

	if (!adrflg) {
		dprint("used pid$a\n");
		return;
	}
	sym = dirfstat(fsym);
	sprint(buf, "/proc/%lud/mem", adrval);
	corfil = buf;
	setcor();
	sprint(buf, "/proc/%lud/text", adrval);
	fd = open(buf, OREAD);
	mem = nil;
	if (sym==nil || fd &lt; 0 || (mem=dirfstat(fd))==nil
				|| sym-&gt;qid.path != mem-&gt;qid.path)
		dprint("warning: text images may be inconsistent\n");
	free(sym);
	free(mem);
	if (fd &gt;= 0)
		close(fd);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

