<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dial/expect.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dial/expect.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

void
usage(void)
{
	fprint(2, "usage: %s [-q] [-t secs] goodstring [badstring ...]\n", argv0);
	exits("usage");
}

void
catch(void*, char *s)
{
	exits(s);
}

int
writewithoutcr(int fd, char *p, int i)
{
	char *q, *e;

	/* dump cr's */
	for(e = p+i; p &lt; e; ){
		q = memchr(p, '\r', e-p);
		if(q == nil)
			break;
		if(q &gt; p)
			if(write(fd, p, q-p) &lt; 0)
				return -1;
		p = q+1;
	}
	if(p &lt; e)
		if(write(fd, p, e-p) &lt; 0)
			return -1;
	return i;
}

void
main(int argc, char **argv)
{
	int timeout = 5*60;
	int quiet = 0;
	int ignorecase = 0;
	int fd, i, m, n, bsize;
	char *good;
	char *buf;
	int sofar;

	ARGBEGIN {
	case 'i':
		ignorecase = 1;
		break;
	case 't':
		timeout = atoi(EARGF(usage()));
		break;
	case 'q':
		quiet = 1;
		break;
	} ARGEND;

	if(argc &lt; 1)
		usage();

	good = argv[0];
	n = strlen(good);

	for(i = 1; i &lt; argc; i++){
		m = strlen(argv[i]);
		if(m &gt; n)
			n = m;
	}

	fd = open("/dev/cons", ORDWR);
	if(fd &lt; 0)
		sysfatal("opening /dev/cons: %r");

	bsize = n+4096;
	buf = malloc(bsize+1);

	sofar = 0;
	alarm(timeout*1000);
	for(;;){
		if(sofar &gt; n){
			memmove(buf, &amp;buf[sofar-n], n);
			sofar = n;
		}
		i = read(0, buf+sofar, bsize);
		if(i &lt;= 0)
			exits("EOF");
		if(!quiet)
			writewithoutcr(fd, buf+sofar, i);
		sofar += i;
		buf[sofar] = 0;
		if(ignorecase){
			if(cistrstr(buf, good))
				break;
			for(i = 1; i &lt; argc; i++)
				if(cistrstr(buf, argv[i]))
					exits(argv[i]);
		} else {
			if(strstr(buf, good))
				break;
			for(i = 1; i &lt; argc; i++)
				if(strstr(buf, argv[i]))
					exits(argv[i]);
		}
	}

	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

