<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/dump.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/dump.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ctype.h&gt;
#include "iso9660.h"

static void
md5cd(Cdimg *cd, ulong block, ulong length, uchar *digest)
{
	int n;
	uchar buf[Blocksize];
	DigestState *s;

	s = md5(nil, 0, nil, nil);
	while(length &gt; 0) {
		n = length;
		if(n &gt; Blocksize)
			n = Blocksize;

		Creadblock(cd, buf, block, n);

		md5(buf, n, nil, s);

		block++;
		length -= n;
	}
	md5(nil, 0, digest, s);
}

static Dumpdir*
mkdumpdir(char *name, uchar *md5, ulong block, ulong length)
{
	Dumpdir *d;

	assert(block != 0);

	d = emalloc(sizeof *d);
	d-&gt;name = name;
	memmove(d-&gt;md5, md5, sizeof d-&gt;md5);
	d-&gt;block = block;
	d-&gt;length = length;

	return d;
}

static Dumpdir**
ltreewalkmd5(Dumpdir **l, uchar *md5)
{
	int i;

	while(*l) {
		i = memcmp(md5, (*l)-&gt;md5, MD5dlen);
		if(i &lt; 0)
			l = &amp;(*l)-&gt;md5left;
		else if(i == 0)
			return l;
		else
			l = &amp;(*l)-&gt;md5right;
	}
	return l;
}

static Dumpdir**
ltreewalkblock(Dumpdir **l, ulong block)
{
	while(*l) {
		if(block &lt; (*l)-&gt;block)
			l = &amp;(*l)-&gt;blockleft;
		else if(block == (*l)-&gt;block)
			return l;
		else
			l = &amp;(*l)-&gt;blockright;
	}
	return l;
}

/*
 * Add a particular file to our binary tree.
 */
static void
addfile(Cdimg *cd, Dump *d, char *name, Direc *dir)
{
	uchar md5[MD5dlen];
	Dumpdir **lblock;

	assert((dir-&gt;mode &amp; DMDIR) == 0);

	if(dir-&gt;length == 0)
		return;

	lblock = ltreewalkblock(&amp;d-&gt;blockroot, dir-&gt;block);
	if(*lblock != nil) {
		if((*lblock)-&gt;length == dir-&gt;length)
			return;
		fprint(2, "block %lud length %lud %s %lud %s\n", dir-&gt;block, (*lblock)-&gt;length, (*lblock)-&gt;name,
			dir-&gt;length, dir-&gt;name);
		assert(0);
	}

	md5cd(cd, dir-&gt;block, dir-&gt;length, md5);
	if(chatty &gt; 1)
		fprint(2, "note file %.16H %lud (%s)\n", md5, dir-&gt;length, dir-&gt;name);
	insertmd5(d, name, md5, dir-&gt;block, dir-&gt;length);
}

void
insertmd5(Dump *d, char *name, uchar *md5, ulong block, ulong length)
{
	Dumpdir **lmd5;
	Dumpdir **lblock;

	lblock = ltreewalkblock(&amp;d-&gt;blockroot, block);
	if(*lblock != nil) {
		if((*lblock)-&gt;length == length)
			return;
		fprint(2, "block %lud length %lud %lud\n", block, (*lblock)-&gt;length, length);
		assert(0);
	}

	assert(length != 0);
	*lblock = mkdumpdir(name, md5, block, length);

	lmd5 = ltreewalkmd5(&amp;d-&gt;md5root, md5);
	if(*lmd5 != nil)
		fprint(2, "warning: data duplicated on CD\n");
	else
		*lmd5 = *lblock;
}

/*
 * Fill all the children entries for a particular directory;
 * all we care about is block, length, and whether it is a directory.
 */
void
readkids(Cdimg *cd, Direc *dir, char *(*cvt)(uchar*, int))
{
	char *dot, *dotdot;
	int m, n;
	uchar buf[Blocksize], *ebuf, *p;
	ulong b, nb;
	Cdir *c;
	Direc dx;

	assert(dir-&gt;mode &amp; DMDIR);

	dot = atom(".");
	dotdot = atom("..");
	ebuf = buf+Blocksize;
	nb = (dir-&gt;length+Blocksize-1) / Blocksize;

	n = 0;
	for(b=0; b&lt;nb; b++) {
		Creadblock(cd, buf, dir-&gt;block + b, Blocksize);
		p = buf;
		while(p &lt; ebuf) {
			c = (Cdir*)p;
			if(c-&gt;len == 0)
				break;
			if(p+c-&gt;len &gt; ebuf)
				break;
			if(parsedir(cd, &amp;dx, p, ebuf-p, cvt) == 0 &amp;&amp; dx.name != dot &amp;&amp; dx.name != dotdot)
				n++;
			p += c-&gt;len;
		}
	}

	m = (n+Ndirblock-1)/Ndirblock * Ndirblock;
	dir-&gt;child = emalloc(m*sizeof dir-&gt;child[0]);
	dir-&gt;nchild = n;

	n = 0;
	for(b=0; b&lt;nb; b++) {
		assert(n &lt;= dir-&gt;nchild);
		Creadblock(cd, buf, dir-&gt;block + b, Blocksize);
		p = buf;
		while(p &lt; ebuf) {
			c = (Cdir*)p;
			if(c-&gt;len == 0)
				break;
			if(p+c-&gt;len &gt; ebuf)
				break;
			if(parsedir(cd, &amp;dx, p, ebuf-p, cvt) == 0 &amp;&amp; dx.name != dot &amp;&amp; dx.name != dotdot) {
				assert(n &lt; dir-&gt;nchild);
				dir-&gt;child[n++] = dx;
			}
			p += c-&gt;len;
		}
	}
}

/*
 * Free the children.  Make sure their children are free too.
 */
void
freekids(Direc *dir)
{
	int i;

	for(i=0; i&lt;dir-&gt;nchild; i++)
		assert(dir-&gt;child[i].nchild == 0);

	free(dir-&gt;child);
	dir-&gt;child = nil;
	dir-&gt;nchild = 0;
}

/*
 * Add a whole directory and all its children to our binary tree.
 */
static void
adddir(Cdimg *cd, Dump *d, Direc *dir)
{
	int i;

	readkids(cd, dir, isostring);
	for(i=0; i&lt;dir-&gt;nchild; i++) {
		if(dir-&gt;child[i].mode &amp; DMDIR)
			adddir(cd, d, &amp;dir-&gt;child[i]);
		else
			addfile(cd, d, atom(dir-&gt;name), &amp;dir-&gt;child[i]);
	}
	freekids(dir);
}

Dumpdir*
lookupmd5(Dump *d, uchar *md5)
{
	return *ltreewalkmd5(&amp;d-&gt;md5root, md5);
}

void
adddirx(Cdimg *cd, Dump *d, Direc *dir, int lev)
{
	int i;
	Direc dd;

	if(lev == 2){
		dd = *dir;
		adddir(cd, d, &amp;dd);
		return;
	}
	for(i=0; i&lt;dir-&gt;nchild; i++)
		adddirx(cd, d, &amp;dir-&gt;child[i], lev+1);
}

Dump*
dumpcd(Cdimg *cd, Direc *dir)
{
	Dump *d;

	d = emalloc(sizeof *d);
	d-&gt;cd = cd;
	adddirx(cd, d, dir, 0);
	return d;
}

/*
static ulong
minblock(Direc *root, int lev)
{
	int i;
	ulong m, n;

	m = root-&gt;block;
	for(i=0; i&lt;root-&gt;nchild; i++) {
		n = minblock(&amp;root-&gt;child[i], lev-1);
		if(m &gt; n)
			m = n;
	}
	return m;
}
*/

void
copybutname(Direc *d, Direc *s)
{
	Direc x;

	x = *d;
	*d = *s;
	d-&gt;name = x.name;
	d-&gt;confname = x.confname;
}

Direc*
createdumpdir(Direc *root, XDir *dir, char *utfname)
{
	char *p;
	Direc *d;

	if(utfname[0]=='/')
		sysfatal("bad dump name '%s'", utfname);
	p = strchr(utfname, '/');
	if(p == nil || strchr(p+1, '/'))
		sysfatal("bad dump name '%s'", utfname);
	*p++ = '\0';
	if((d = walkdirec(root, utfname)) == nil)
		d = adddirec(root, utfname, dir);
	if(walkdirec(d, p))
		sysfatal("duplicate dump name '%s/%s'", utfname, p);
	d = adddirec(d, p, dir);
	return d;
}

static void
rmdirec(Direc *d, Direc *kid)
{
	Direc *ekid;

	ekid = d-&gt;child+d-&gt;nchild;
	assert(d-&gt;child &lt;= kid &amp;&amp; kid &lt; ekid);
	if(ekid != kid+1)
		memmove(kid, kid+1, (ekid-(kid+1))*sizeof(*kid));
	d-&gt;nchild--;
}

void
rmdumpdir(Direc *root, char *utfname)
{
	char *p;
	Direc *d, *dd;

	if(utfname[0]=='/')
		sysfatal("bad dump name '%s'", utfname);
	p = strchr(utfname, '/');
	if(p == nil || strchr(p+1, '/'))
		sysfatal("bad dump name '%s'", utfname);
	*p++ = '\0';
	if((d = walkdirec(root, utfname)) == nil)
		sysfatal("cannot remove %s/%s: %s does not exist", utfname, p, utfname);
	p[-1] = '/';

	if((dd = walkdirec(d, p)) == nil)
		sysfatal("cannot remove %s: does not exist", utfname);

	rmdirec(d, dd);
	if(d-&gt;nchild == 0)
		rmdirec(root, d);
}

char*
adddumpdir(Direc *root, ulong now, XDir *dir)
{
	char buf[40], *p;
	int n;
	Direc *dday, *dyear;
	Tm tm;

	tm = *localtime(now);
	
	sprint(buf, "%d", tm.year+1900);
	if((dyear = walkdirec(root, buf)) == nil) {
		dyear = adddirec(root, buf, dir);
		assert(dyear != nil);
	}

	n = 0;
	sprint(buf, "%.2d%.2d", tm.mon+1, tm.mday);
	p = buf+strlen(buf);
	while(walkdirec(dyear, buf))
		sprint(p, "%d", ++n);

	dday = adddirec(dyear, buf, dir);
	assert(dday != nil);

	sprint(buf, "%s/%s", dyear-&gt;name, dday-&gt;name);
assert(walkdirec(root, buf)==dday);
	return atom(buf);
}

/*
 * The dump directory tree is inferred from a linked list of special blocks.
 * One block is written at the end of each dump.
 * The blocks have the form
 *
 * plan 9 dump cd
 * &lt;dump-name&gt; &lt;dump-time&gt; &lt;next-block&gt; &lt;conform-block&gt; &lt;conform-length&gt; \
 *	&lt;iroot-block&gt; &lt;iroot-length&gt; &lt;jroot-block&gt; &lt;jroot-length&gt;
 *
 * If only the first line is present, this is the end of the chain.
 */
static char magic[] = "plan 9 dump cd\n";
ulong
Cputdumpblock(Cdimg *cd)
{
	uvlong x;

	Cwseek(cd, (vlong)cd-&gt;nextblock * Blocksize);
	x = Cwoffset(cd);
	Cwrite(cd, magic, sizeof(magic)-1);
	Cpadblock(cd);
	return x/Blocksize;
}

int
hasdump(Cdimg *cd)
{
	int i;
	char buf[128];

	for(i=16; i&lt;24; i++) {
		Creadblock(cd, buf, i, sizeof buf);
		if(memcmp(buf, magic, sizeof(magic)-1) == 0)
			return i;
	}
	return 0;
}
	
Direc
readdumpdirs(Cdimg *cd, XDir *dir, char *(*cvt)(uchar*, int))
{
	char buf[Blocksize];
	char *p, *q, *f[16];
	int i, nf;
	ulong db, t;
	Direc *nr, root;
	XDir xd;

	mkdirec(&amp;root, dir);
	db = hasdump(cd);
	xd = *dir;
	for(;;){
		if(db == 0)
			sysfatal("error in dump blocks");

		Creadblock(cd, buf, db, sizeof buf);
		if(memcmp(buf, magic, sizeof(magic)-1) != 0)
			break;
		p = buf+sizeof(magic)-1;
		if(p[0] == '\0')
			break;
		if((q = strchr(p, '\n')) != nil)
			*q = '\0';

		nf = tokenize(p, f, nelem(f));
		i = 5;
		if(nf &lt; i || (cvt==jolietstring &amp;&amp; nf &lt; i+2))
			sysfatal("error in dump block %lud: nf=%d; p='%s'", db, nf, p);
		nr = createdumpdir(&amp;root, &amp;xd, f[0]);
		t = strtoul(f[1], 0, 0);
		xd.mtime = xd.ctime = xd.atime = t;
		db = strtoul(f[2], 0, 0);
		if(cvt == jolietstring)
			i += 2;
		nr-&gt;block = strtoul(f[i], 0, 0);
		nr-&gt;length = strtoul(f[i+1], 0, 0);
	}
	cd-&gt;nulldump = db;
	return root;
}

extern void addtx(char*, char*);

static int
isalldigit(char *s)
{
	while(*s)
		if(!isdigit(*s++))
			return 0;
	return 1;
}

void
readdumpconform(Cdimg *cd)
{
	char buf[Blocksize];
	char *p, *q, *f[10];
	int nf;
	ulong cb, nc, db;
	uvlong m;

	db = hasdump(cd);
	assert(map==nil || map-&gt;nt == 0);

	for(;;){
		if(db == 0)
			sysfatal("error0 in dump blocks");

		Creadblock(cd, buf, db, sizeof buf);
		if(memcmp(buf, magic, sizeof(magic)-1) != 0)
			break;
		p = buf+sizeof(magic)-1;
		if(p[0] == '\0')
			break;
		if((q = strchr(p, '\n')) != nil)
			*q = '\0';

		nf = tokenize(p, f, nelem(f));
		if(nf &lt; 5)
			sysfatal("error0 in dump block %lud", db);

		db = strtoul(f[2], 0, 0);
		cb = strtoul(f[3], 0, 0);
		nc = strtoul(f[4], 0, 0);

		Crseek(cd, (vlong)cb * Blocksize);
		m = (vlong)cb * Blocksize + nc;
		while(Croffset(cd) &lt; m &amp;&amp; (p = Crdline(cd, '\n')) != nil){
			p[Clinelen(cd)-1] = '\0';
			if(tokenize(p, f, 2) != 2 || (f[0][0] != 'D' &amp;&amp; f[0][0] != 'F')
			|| strlen(f[0]) != 7 || !isalldigit(f[0]+1))
				break;
	
			addtx(atom(f[1]), atom(f[0]));
		}
	}
	if(map)
		cd-&gt;nconform = map-&gt;nt;
	else
		cd-&gt;nconform = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

