<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/ichar.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/ichar.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ctype.h&gt;

#include "iso9660.h"

/*
 * ISO 9660 file names must be uppercase, digits, or underscore.
 * We use lowercase, digits, and underscore, translating lower to upper
 * in mkisostring, and upper to lower in isostring.
 * Files with uppercase letters in their names are thus nonconforming.
 * Conforming files also must have a basename
 * at most 8 letters and at most one suffix of at most 3 letters.
 */
char*
isostring(uchar *buf, int len)
{
	char *p, *q;

	p = emalloc(len+1);
	memmove(p, buf, len);
	p[len] = '\0';
	while(len &gt; 0 &amp;&amp; p[len-1] == ' ')
		p[--len] = '\0';
	for(q=p; *q; q++)
		*q = tolower(*q);

	q = atom(p);
	free(p);
	return q;
}

int 
isisofrog(char c)
{
	if(c &gt;= '0' &amp;&amp; c &lt;= '9')
		return 0;
	if(c &gt;= 'a' &amp;&amp; c &lt;= 'z')
		return 0;
	if(c == '_')
		return 0;

	return 1;
}

int
isbadiso9660(char *s)
{
	char *p, *q;
	int i;

	if((p = strchr(s, '.')) != nil) {
		if(p-s &gt; 8)
			return 1;
		for(q=s; q&lt;p; q++)
			if(isisofrog(*q))
				return 1;
		if(strlen(p+1) &gt; 3)
			return 1;
		for(q=p+1; *q; q++)
			if(isisofrog(*q))
				return 1;
	} else {
		if(strlen(s) &gt; 8)
			return 1;
		for(q=s; *q; q++)
			if(isisofrog(*q))
				return 1;

		/*
		 * we rename files of the form [FD]dddddd
		 * so they don't interfere with us.
		 */
		if(strlen(s) == 7 &amp;&amp; (s[0] == 'D' || s[0] == 'F')) {
			for(i=1; i&lt;7; i++)
				if(s[i] &lt; '0' || s[i] &gt; '9')
					break;
			if(i == 7)
				return 1;
		}
	}
	return 0;
}

/*
 * ISO9660 name comparison
 * 
 * The standard algorithm is as follows:
 *   Take the filenames without extensions, pad the shorter with 0x20s (spaces),
 *   and do strcmp.  If they are equal, go on.
 *   Take the extensions, pad the shorter with 0x20s (spaces),
 *   and do strcmp.  If they are equal, go on.
 *   Compare the version numbers.
 *
 * Since Plan 9 names are not allowed to contain characters 0x00-0x1F,
 * the padded comparisons are equivalent to using strcmp directly.
 * We still need to handle the base and extension differently,
 * so that .foo sorts before !foo.foo.
 */
int
isocmp(const void *va, const void *vb)
{
	int i;
	char s1[32], s2[32], *b1, *b2, *e1, *e2;
	const Direc *a, *b;

	a = va;
	b = vb;

	strecpy(s1, s1+sizeof s1, a-&gt;confname);
	b1 = s1;
	strecpy(s2, s2+sizeof s2, b-&gt;confname);
	b2 = s2;
	if((e1 = strchr(b1, '.')) != nil)
		*e1++ = '\0';
	else
		e1 = "";
	if((e2 = strchr(b2, '.')) != nil)
		*e2++ = '\0';
	else
		e2 = "";

	if((i = strcmp(b1, b2)) != 0)
		return i;

	return strcmp(e1, e2);
}

static char*
mkisostring(char *isobuf, int n, char *s)
{
	char *p, *q, *eq;

	eq = isobuf+n;
	for(p=s, q=isobuf; *p &amp;&amp; q &lt; eq; p++)
		if('a' &lt;= *p &amp;&amp; *p &lt;= 'z')
			*q++ = *p+'A'-'a';
		else
			*q++ = *p;

	while(q &lt; eq)
		*q++ = ' ';

	return isobuf;
}

void
Cputisopvd(Cdimg *cd, Cdinfo info)
{
	char buf[130];

	Cputc(cd, 1);				/* primary volume descriptor */
	Cputs(cd, "CD001", 5);			/* standard identifier */
	Cputc(cd, 1);				/* volume descriptor version */
	Cputc(cd, 0);				/* unused */

	assert(~info.flags &amp; (CDplan9|CDrockridge));

	/* system identifier */
	strcpy(buf, "");
	if(info.flags &amp; CDplan9)
		strcat(buf, "plan 9 ");
	if(info.flags &amp; CDrockridge)
		strcat(buf, "rrip ");
	if(info.flags &amp; CDbootable)
		strcat(buf, "boot ");
	if(info.flags &amp; CDconform)
		strcat(buf, "iso9660");
	else
		strcat(buf, "utf8");
	
	struprcpy(buf, buf);
	Cputs(cd, buf, 32);

	Cputs(cd, mkisostring(buf, 32, info.volumename), 32);			/* volume identifier */

	Crepeat(cd, 0, 8);				/* unused */
	Cputn(cd, 0, 4);				/* volume space size */
	Crepeat(cd, 0, 32);				/* unused */
	Cputn(cd, 1, 2);				/* volume set size */
	Cputn(cd, 1, 2);				/* volume sequence number */
	Cputn(cd, Blocksize, 2);			/* logical block size */
	Cputn(cd, 0, 4);				/* path table size */
	Cputnl(cd, 0, 4);				/* location of Lpath */
	Cputnl(cd, 0, 4);				/* location of optional Lpath */
	Cputnm(cd, 0, 4);				/* location of Mpath */
	Cputnm(cd, 0, 4);				/* location of optional Mpath */
	Cputisodir(cd, nil, DTroot, 1, Cwoffset(cd));			/* root directory */

	Cputs(cd, mkisostring(buf, 128, info.volumeset), 128);		/* volume set identifier */
	Cputs(cd, mkisostring(buf, 128, info.publisher), 128);			/* publisher identifier */
	Cputs(cd, mkisostring(buf, 128, info.preparer), 128);			/* data preparer identifier */
	Cputs(cd, mkisostring(buf, 128, info.application), 128);		/* application identifier */

	Cputs(cd, "", 37);			/* copyright notice */
	Cputs(cd, "", 37);			/* abstract */
	Cputs(cd, "", 37);			/* bibliographic file */
	Cputdate1(cd, now);				/* volume creation date */
	Cputdate1(cd, now);				/* volume modification date */
	Cputdate1(cd, 0);				/* volume expiration date */
	Cputdate1(cd, 0);				/* volume effective date */
	Cputc(cd, 1);				/* file structure version */
	Cpadblock(cd);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

