<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/format.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/format.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;disk.h&gt;

/*
 *  disk types (all MFM encoding)
 */
typedef struct Type	Type;
struct Type
{
	char	*name;
	int	bytes;		/* bytes/sector */
	int	sectors;	/* sectors/track */
	int	heads;		/* number of heads */
	int	tracks;		/* tracks/disk */
	int	media;		/* media descriptor byte */
	int	cluster;	/* default cluster size */
};
Type floppytype[] =
{
 { "3½HD",	512, 18,  2, 80, 0xf0, 1, },
 { "3½DD",	512,  9,  2, 80, 0xf9, 2, },
 { "3½QD",	512, 36, 2, 80, 0xf9, 2, },	/* invented */
 { "5¼HD",	512, 15,  2, 80, 0xf9, 1, },
 { "5¼DD",	512,  9,  2, 40, 0xfd, 2, },
 { "hard",	512,  0,  0, 0, 0xf8, 4, },
};

#define NTYPES (sizeof(floppytype)/sizeof(Type))

typedef struct Dosboot	Dosboot;
struct Dosboot{
	uchar	magic[3];	/* really an x86 JMP instruction */
	uchar	version[8];
	uchar	sectsize[2];
	uchar	clustsize;
	uchar	nresrv[2];
	uchar	nfats;
	uchar	rootsize[2];
	uchar	volsize[2];
	uchar	mediadesc;
	uchar	fatsize[2];
	uchar	trksize[2];
	uchar	nheads[2];
	uchar	nhidden[4];
	uchar	bigvolsize[4];
	uchar	driveno;
	uchar	reserved0;
	uchar	bootsig;
	uchar	volid[4];
	uchar	label[11];
	uchar	type[8];
};
#define	PUTSHORT(p, v) { (p)[1] = (v)&gt;&gt;8; (p)[0] = (v); }
#define	PUTLONG(p, v) { PUTSHORT((p), (v)); PUTSHORT((p)+2, (v)&gt;&gt;16); }
#define	GETSHORT(p)	(((p)[1]&lt;&lt;8)|(p)[0])
#define	GETLONG(p)	(((ulong)GETSHORT(p+2)&lt;&lt;16)|(ulong)GETSHORT(p))

typedef struct Dosdir	Dosdir;
struct Dosdir
{
	uchar	name[8];
	uchar	ext[3];
	uchar	attr;
	uchar	reserved[10];
	uchar	time[2];
	uchar	date[2];
	uchar	start[2];
	uchar	length[4];
};

#define	DRONLY	0x01
#define	DHIDDEN	0x02
#define	DSYSTEM	0x04
#define	DVLABEL	0x08
#define	DDIR	0x10
#define	DARCH	0x20

/*
 *  the boot program for the boot sector.
 */
int nbootprog = 188;	/* no. of bytes of boot program, including the first 0x3E */
uchar bootprog[512] =
{
[0x000]	0xEB, 0x3C, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
[0x03E] 0xFA, 0xFC, 0x8C, 0xC8, 0x8E, 0xD8, 0x8E, 0xD0,
	0xBC, 0x00, 0x7C, 0xBE, 0x77, 0x7C, 0xE8, 0x19,
	0x00, 0x33, 0xC0, 0xCD, 0x16, 0xBB, 0x40, 0x00,
	0x8E, 0xC3, 0xBB, 0x72, 0x00, 0xB8, 0x34, 0x12,
	0x26, 0x89, 0x07, 0xEA, 0x00, 0x00, 0xFF, 0xFF,
	0xEB, 0xD6, 0xAC, 0x0A, 0xC0, 0x74, 0x09, 0xB4,
	0x0E, 0xBB, 0x07, 0x00, 0xCD, 0x10, 0xEB, 0xF2,
	0xC3,  'N',  'o',  't',  ' ',  'a',  ' ',  'b',
	 'o',  'o',  't',  'a',  'b',  'l',  'e',  ' ',
	 'd',  'i',  's',  'c',  ' ',  'o',  'r',  ' ',
	 'd',  'i',  's',  'c',  ' ',  'e',  'r',  'r',
	 'o',  'r', '\r', '\n',  'P',  'r',  'e',  's',
	 's',  ' ',  'a',  'l',  'm',  'o',  's',  't',
	 ' ',  'a',  'n',  'y',  ' ',  'k',  'e',  'y',
	 ' ',  't',  'o',  ' ',  'r',  'e',  'b',  'o',
	 'o',  't',  '.',  '.',  '.', 0x00, 0x00, 0x00,
[0x1F0]	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0xAA,
};

char *dev;
int clustersize;
uchar *fat;	/* the fat */
int fatbits;
int fatsecs;
int fatlast;	/* last cluster allocated */
int clusters;
int fatsecs;
vlong volsecs;
uchar *root;	/* first block of root */
int rootsecs;
int rootfiles;
int rootnext;
int nresrv = 1;
int chatty;
vlong length;
Type *t;
int fflag;
int hflag;
int xflag;
char *file;
char *pbs;
char *type;
char *bootfile;
int dos;

enum
{
	Sof = 1,	/* start of file */
	Eof = 2,	/* end of file */
};

void	dosfs(int, int, Disk*, char*, int, char*[], int);
ulong	clustalloc(int);
void	addrname(uchar*, Dir*, char*, ulong);
void	sanitycheck(Disk*);

void
usage(void)
{
	fprint(2, "usage: disk/format [-df] [-b bootblock] [-c csize] "
		"[-l label] [-r nresrv] [-t type] disk [files ...]\n");
	exits("usage");
}

void
fatal(char *fmt, ...)
{
	char err[128];
	va_list arg;

	va_start(arg, fmt);
	vsnprint(err, sizeof(err), fmt, arg);
	va_end(arg);
	fprint(2, "format: %s\n", err);
	if(fflag &amp;&amp; file)
		remove(file);
	exits(err);
}

void
main(int argc, char **argv)
{
	int fd, n, writepbs;
	char buf[512], label[11];
	char *a;
	Disk *disk;

	dos = 0;
	type = nil;
	clustersize = 0;
	writepbs = 0;
	memmove(label, "CYLINDRICAL", sizeof(label));
	ARGBEGIN {
	case 'b':
		pbs = EARGF(usage());
		writepbs = 1;
		break;
	case 'c':
		clustersize = atoi(EARGF(usage()));
		break;
	case 'd':
		dos = 1;
		writepbs = 1;
		break;
	case 'f':
		fflag = 1;
		break;
	case 'l':
		a = EARGF(usage());
		n = strlen(a);
		if(n &gt; sizeof(label))
			n = sizeof(label);
		memmove(label, a, n);
		while(n &lt; sizeof(label))
			label[n++] = ' ';
		break;
	case 'r':
		nresrv = atoi(EARGF(usage()));
		break;
	case 't':
		type = EARGF(usage());
		break;
	case 'v':
		chatty++;
		break;
	case 'x':
		xflag = 1;
		break;
	default:
		usage();
	} ARGEND

	if(argc &lt; 1)
		usage();

	disk = opendisk(argv[0], 0, 0);
	if(disk == nil) {
		if(fflag) {
			if((fd = create(argv[0], ORDWR, 0666)) &gt;= 0) {
				file = argv[0];
				close(fd);
				disk = opendisk(argv[0], 0, 0);
			}
		}
	}
	if(disk == nil)
		fatal("opendisk: %r");

	if(disk-&gt;type == Tfile)
		fflag = 1;

	if(type == nil) {
		switch(disk-&gt;type){
		case Tfile:
			type = "3½HD";
			break;
		case Tfloppy:
			seek(disk-&gt;ctlfd, 0, 0);
			n = read(disk-&gt;ctlfd, buf, 10);
			if(n &lt;= 0 || n &gt;= 10)
				fatal("reading floppy type");
			buf[n] = 0;
			type = strdup(buf);
			if(type == nil)
				fatal("out of memory");
			break;
		case Tsd:
			type = "hard";
			break;
		default:
			type = "unknown";
			break;
		}
	}

	if(!fflag &amp;&amp; disk-&gt;type == Tfloppy)
		if(fprint(disk-&gt;ctlfd, "format %s", type) &lt; 0)
			fatal("formatting floppy as %s: %r", type);

	if(disk-&gt;type != Tfloppy)
		sanitycheck(disk);

	/* check that everything will succeed */
	dosfs(dos, writepbs, disk, label, argc-1, argv+1, 0);

	/* commit */
	dosfs(dos, writepbs, disk, label, argc-1, argv+1, 1);

	print("used %lld bytes\n", fatlast*clustersize*disk-&gt;secsize);
	exits(0);
}

/*
 * Look for a partition table on sector 1, as would be the
 * case if we were erroneously formatting 9fat without -r 2.
 * If it's there and nresrv is not big enough, complain and exit.
 * I've blown away my partition table too many times.
 */
void
sanitycheck(Disk *disk)
{
	char buf[512];
	int bad;

	if(xflag)
		return;

	bad = 0;
	if(dos &amp;&amp; nresrv &lt; 2 &amp;&amp; seek(disk-&gt;fd, disk-&gt;secsize, 0) == disk-&gt;secsize
	&amp;&amp; read(disk-&gt;fd, buf, sizeof(buf)) &gt;= 5 &amp;&amp; strncmp(buf, "part ", 5) == 0) {
		fprint(2, 
			"there's a plan9 partition on the disk\n"
			"and you didn't specify -r 2 (or greater).\n"
			"either specify -r 2 or -x to disable this check.\n");
		bad = 1;
	}

	if(disk-&gt;type == Tsd &amp;&amp; disk-&gt;offset == 0LL) {
		fprint(2,
			"you're attempting to format your disk (/dev/sdXX/data)\n"
			"rather than a partition like /dev/sdXX/9fat;\n"
			"this is likely a mistake.  specify -x to disable this check.\n");
		bad = 1;
	}

	if(bad)
		exits("failed disk sanity check");
}

/*
 * Return the BIOS drive number for the disk.
 * 0x80 is the first fixed disk, 0x81 the next, etc.
 * We map sdC0=0x80, sdC1=0x81, sdD0=0x82, sdD1=0x83
 */
int
getdriveno(Disk *disk)
{
	char buf[64], *p;

	if(disk-&gt;type != Tsd)
		return 0x80;	/* first hard disk */

	if(fd2path(disk-&gt;fd, buf, sizeof(buf)) &lt; 0)
		return 0x80;

	/*
	 * The name is of the format #SsdC0/foo 
	 * or /dev/sdC0/foo.
	 * So that we can just look for /sdC0, turn 
	 * #SsdC0/foo into #/sdC0/foo.
	 */
	if(buf[0] == '#' &amp;&amp; buf[1] == 'S')
		buf[1] = '/';

	for(p=buf; *p; p++)
		if(p[0] == 's' &amp;&amp; p[1] == 'd' &amp;&amp; (p[2]=='C' || p[2]=='D') &amp;&amp;
		    (p[3]=='0' || p[3]=='1'))
			return 0x80 + (p[2]-'C')*2 + (p[3]-'0');
		
	return 0x80;
}

long
writen(int fd, void *buf, long n)
{
	long m, tot;

	/* write 8k at a time, to be nice to the disk subsystem */
	for(tot=0; tot&lt;n; tot+=m){
		m = n - tot;
		if(m &gt; 8192)
			m = 8192;
		if(write(fd, (uchar*)buf+tot, m) != m)
			break;
	}
	return tot;
}

void
dosfs(int dofat, int dopbs, Disk *disk, char *label, int argc, char *argv[], int commit)
{
	char r[16];
	Dosboot *b;
	uchar *buf, *pbsbuf, *p;
	Dir *d;
	int i, data, newclusters, npbs, n, sysfd;
	ulong x;
	vlong length, secsize;

	if(dofat == 0 &amp;&amp; dopbs == 0)
		return;

	for(t = floppytype; t &lt; &amp;floppytype[NTYPES]; t++)
		if(strcmp(type, t-&gt;name) == 0)
			break;
	if(t == &amp;floppytype[NTYPES])
		fatal("unknown floppy type %s", type);

	if(t-&gt;sectors == 0 &amp;&amp; strcmp(type, "hard") == 0) {
		t-&gt;sectors = disk-&gt;s;
		t-&gt;heads = disk-&gt;h;
		t-&gt;tracks = disk-&gt;c;
	}

	if(t-&gt;sectors == 0 &amp;&amp; dofat)
		fatal("cannot format fat with type %s: geometry unknown\n", type);

	if(fflag){
		disk-&gt;size = t-&gt;bytes*t-&gt;sectors*t-&gt;heads*t-&gt;tracks;
		disk-&gt;secsize = t-&gt;bytes;
		disk-&gt;secs = disk-&gt;size / disk-&gt;secsize;
	}

	secsize = disk-&gt;secsize;
	length = disk-&gt;size;

	buf = malloc(secsize);
	if(buf == 0)
		fatal("out of memory");

	/*
	 * Make disk full size if a file.
	 */
	if(fflag &amp;&amp; disk-&gt;type == Tfile){
		if((d = dirfstat(disk-&gt;wfd)) == nil)
			fatal("fstat disk: %r");
		if(commit &amp;&amp; d-&gt;length &lt; disk-&gt;size) {
			if(seek(disk-&gt;wfd, disk-&gt;size-1, 0) &lt; 0)
				fatal("seek to 9: %r");
			if(write(disk-&gt;wfd, "9", 1) &lt; 0)
				fatal("writing 9: @%lld %r", seek(disk-&gt;wfd, 0LL, 1));
		}
		free(d);
	}

	/*
	 * Start with initial sector from disk
	 */
	if(seek(disk-&gt;fd, 0, 0) &lt; 0)
		fatal("seek to boot sector: %r\n");
	if(commit &amp;&amp; read(disk-&gt;fd, buf, secsize) != secsize)
		fatal("reading boot sector: %r");

	if(dofat)
		memset(buf, 0, sizeof(Dosboot));

	/*
	 * Jump instruction and OEM name.
	 */
	b = (Dosboot*)buf;
	b-&gt;magic[0] = 0xEB;
	b-&gt;magic[1] = 0x3C;
	b-&gt;magic[2] = 0x90;
	memmove(b-&gt;version, "Plan9.00", sizeof(b-&gt;version));
	
	/*
	 * Add bootstrapping code; assume it starts 
	 * at 0x3E (the destination of the jump we just
	 * wrote to b-&gt;magic).
	 */
	if(dopbs) {
		pbsbuf = malloc(secsize);
		if(pbsbuf == 0)
			fatal("out of memory");

		if(pbs){
			if((sysfd = open(pbs, OREAD)) &lt; 0)
				fatal("open %s: %r", pbs);
			if((npbs = read(sysfd, pbsbuf, secsize)) &lt; 0)
				fatal("read %s: %r", pbs);

			if(npbs &gt; secsize-2)
				fatal("boot block too large");

			close(sysfd);
		}
		else {
			memmove(pbsbuf, bootprog, sizeof(bootprog));
			npbs = nbootprog;
		}
		if(npbs &lt;= 0x3E)
			fprint(2, "warning: pbs too small\n");
		else
			memmove(buf+0x3E, pbsbuf+0x3E, npbs-0x3E);

		free(pbsbuf);
	}

	/*
	 * Add FAT BIOS parameter block.
	 */
	if(dofat) {
		if(commit) {
			print("Initializing FAT file system\n");
			print("type %s, %d tracks, %d heads, %d sectors/track, %lld bytes/sec\n",
				t-&gt;name, t-&gt;tracks, t-&gt;heads, t-&gt;sectors, secsize);
		}

		if(clustersize == 0)
			clustersize = t-&gt;cluster;
		/*
		 * the number of fat bits depends on how much disk is left
		 * over after you subtract out the space taken up by the fat tables. 
		 * try both.  what a crock.
		 */
		fatbits = 12;
Tryagain:
		volsecs = length/secsize;
		/*
		 * here's a crock inside a crock.  even having fixed fatbits,
		 * the number of fat sectors depends on the number of clusters,
		 * but of course we don't know yet.  maybe iterating will get us there.
		 * or maybe it will cycle.
		 */
		clusters = 0;
		for(i=0;; i++){
			fatsecs = (fatbits*clusters + 8*secsize - 1)/(8*secsize);
			rootsecs = volsecs/200;
			rootfiles = rootsecs * (secsize/sizeof(Dosdir));
			if(rootfiles &gt; 512){
				rootfiles = 512;
				rootsecs = rootfiles/(secsize/sizeof(Dosdir));
			}
			data = nresrv + 2*fatsecs + (rootfiles*sizeof(Dosdir) + secsize-1)/secsize;
			newclusters = 2 + (volsecs - data)/clustersize;
			if(newclusters == clusters)
				break;
			clusters = newclusters;
			if(i &gt; 10)
				fatal("can't decide how many clusters to use (%d? %d?)", clusters, newclusters);
if(chatty) print("clusters %d\n", clusters);
		}
				
if(chatty) print("try %d fatbits =&gt; %d clusters of %d\n", fatbits, clusters, clustersize);
		switch(fatbits){
		case 12:
			if(clusters &gt;= 4087){
				fatbits = 16;
				goto Tryagain;
			}
			break;
		case 16:
			if(clusters &gt;= 65527)
				fatal("disk too big; implement fat32");
			break;
		}
		PUTSHORT(b-&gt;sectsize, secsize);
		b-&gt;clustsize = clustersize;
		PUTSHORT(b-&gt;nresrv, nresrv);
		b-&gt;nfats = 2;
		PUTSHORT(b-&gt;rootsize, rootfiles);
		if(volsecs &lt; (1&lt;&lt;16))
			PUTSHORT(b-&gt;volsize, volsecs);
		b-&gt;mediadesc = t-&gt;media;
		PUTSHORT(b-&gt;fatsize, fatsecs);
		PUTSHORT(b-&gt;trksize, t-&gt;sectors);
		PUTSHORT(b-&gt;nheads, t-&gt;heads);
		PUTLONG(b-&gt;nhidden, disk-&gt;offset);
		PUTLONG(b-&gt;bigvolsize, volsecs);
	
		/*
		 * Extended BIOS Parameter Block.
		 */
		if(t-&gt;media == 0xF8)
			b-&gt;driveno = getdriveno(disk);
		else
			b-&gt;driveno = 0;
if(chatty) print("driveno = %ux\n", b-&gt;driveno);
	
		b-&gt;bootsig = 0x29;
		x = disk-&gt;offset + b-&gt;nfats*fatsecs + nresrv;
		PUTLONG(b-&gt;volid, x);
if(chatty) print("volid = %lux %lux\n", x, GETLONG(b-&gt;volid));
		memmove(b-&gt;label, label, sizeof(b-&gt;label));
		sprint(r, "FAT%d    ", fatbits);
		memmove(b-&gt;type, r, sizeof(b-&gt;type));
	}

	buf[secsize-2] = 0x55;
	buf[secsize-1] = 0xAA;

	if(commit) {
		if(seek(disk-&gt;wfd, 0, 0) &lt; 0)
			fatal("seek to boot sector: %r\n");
		if(write(disk-&gt;wfd, buf, secsize) != secsize)
			fatal("writing boot sector: %r");
	}

	free(buf);

	/*
	 * If we were only called to write the PBS, leave now.
	 */
	if(dofat == 0)
		return;

	/*
	 *  allocate an in memory fat
	 */
	if(seek(disk-&gt;wfd, nresrv*secsize, 0) &lt; 0)
		fatal("seek to fat: %r\n");
if(chatty) print("fat @%lluX\n", seek(disk-&gt;wfd, 0, 1));
	fat = malloc(fatsecs*secsize);
	if(fat == 0)
		fatal("out of memory");
	memset(fat, 0, fatsecs*secsize);
	fat[0] = t-&gt;media;
	fat[1] = 0xff;
	fat[2] = 0xff;
	if(fatbits == 16)
		fat[3] = 0xff;
	fatlast = 1;
	if(seek(disk-&gt;wfd, 2*fatsecs*secsize, 1) &lt; 0)	/* 2 fats */
		fatal("seek to root: %r");
if(chatty) print("root @%lluX\n", seek(disk-&gt;wfd, 0LL, 1));

	/*
	 *  allocate an in memory root
	 */
	root = malloc(rootsecs*secsize);
	if(root == 0)
		fatal("out of memory");
	memset(root, 0, rootsecs*secsize);
	if(seek(disk-&gt;wfd, rootsecs*secsize, 1) &lt; 0)	/* rootsecs */
		fatal("seek to files: %r");
if(chatty) print("files @%lluX\n", seek(disk-&gt;wfd, 0LL, 1));

	/*
	 * Now positioned at the Files Area.
	 * If we have any arguments, process 
	 * them and write out.
	 */
	for(p = root; argc &gt; 0; argc--, argv++, p += sizeof(Dosdir)){
		if(p &gt;= (root+(rootsecs*secsize)))
			fatal("too many files in root");
		/*
		 * Open the file and get its length.
		 */
		if((sysfd = open(*argv, OREAD)) &lt; 0)
			fatal("open %s: %r", *argv);
		if((d = dirfstat(sysfd)) == nil)
			fatal("stat %s: %r", *argv);
		if(d-&gt;length &gt; 0xFFFFFFFFU)
			fatal("file %s too big\n", *argv, d-&gt;length);
		if(commit)
			print("Adding file %s, length %lld\n", *argv, d-&gt;length);

		length = d-&gt;length;
		if(length){
			/*
			 * Allocate a buffer to read the entire file into.
			 * This must be rounded up to a cluster boundary.
			 *
			 * Read the file and write it out to the Files Area.
			 */
			length += secsize*clustersize - 1;
			length /= secsize*clustersize;
			length *= secsize*clustersize;
			if((buf = malloc(length)) == 0)
				fatal("out of memory");
	
			if(readn(sysfd, buf, d-&gt;length) != d-&gt;length)
				fatal("read %s: %r", *argv);
			memset(buf+d-&gt;length, 0, length-d-&gt;length);
if(chatty) print("%s @%lluX\n", d-&gt;name, seek(disk-&gt;wfd, 0LL, 1));
			if(commit &amp;&amp; writen(disk-&gt;wfd, buf, length) != length)
				fatal("write %s: %r", *argv);
			free(buf);

			close(sysfd);
	
			/*
			 * Allocate the FAT clusters.
			 * We're assuming here that where we
			 * wrote the file is in sync with
			 * the cluster allocation.
			 * Save the starting cluster.
			 */
			length /= secsize*clustersize;
			x = clustalloc(Sof);
			for(n = 0; n &lt; length-1; n++)
				clustalloc(0);
			clustalloc(Eof);
		}
		else
			x = 0;

		/*
		 * Add the filename to the root.
		 */
fprint(2, "add %s at clust %lux\n", d-&gt;name, x);
		addrname(p, d, *argv, x);
		free(d);
	}

	/*
	 *  write the fats and root
	 */
	if(commit) {
		if(seek(disk-&gt;wfd, nresrv*secsize, 0) &lt; 0)
			fatal("seek to fat #1: %r");
		if(write(disk-&gt;wfd, fat, fatsecs*secsize) &lt; 0)
			fatal("writing fat #1: %r");
		if(write(disk-&gt;wfd, fat, fatsecs*secsize) &lt; 0)
			fatal("writing fat #2: %r");
		if(write(disk-&gt;wfd, root, rootsecs*secsize) &lt; 0)
			fatal("writing root: %r");
	}

	free(fat);
	free(root);
}

/*
 *  allocate a cluster
 */
ulong
clustalloc(int flag)
{
	ulong o, x;

	if(flag != Sof){
		x = (flag == Eof) ? 0xffff : (fatlast+1);
		if(fatbits == 12){
			x &amp;= 0xfff;
			o = (3*fatlast)/2;
			if(fatlast &amp; 1){
				fat[o] = (fat[o]&amp;0x0f) | (x&lt;&lt;4);
				fat[o+1] = (x&gt;&gt;4);
			} else {
				fat[o] = x;
				fat[o+1] = (fat[o+1]&amp;0xf0) | ((x&gt;&gt;8) &amp; 0x0F);
			}
		} else {
			o = 2*fatlast;
			fat[o] = x;
			fat[o+1] = x&gt;&gt;8;
		}
	}
		
	if(flag == Eof)
		return 0;
	else{
		++fatlast;
		if(fatlast &gt;= clusters)
			sysfatal("data does not fit on disk (%d %d)", fatlast, clusters);
		return fatlast;
	}
}

void
putname(char *p, Dosdir *d)
{
	int i;

	memset(d-&gt;name, ' ', sizeof d-&gt;name+sizeof d-&gt;ext);
	for(i = 0; i&lt; sizeof(d-&gt;name); i++){
		if(*p == 0 || *p == '.')
			break;
		d-&gt;name[i] = toupper(*p++);
	}
	p = strrchr(p, '.');
	if(p){
		for(i = 0; i &lt; sizeof d-&gt;ext; i++){
			if(*++p == 0)
				break;
			d-&gt;ext[i] = toupper(*p);
		}
	}
}

void
puttime(Dosdir *d)
{
	Tm *t = localtime(time(0));
	ushort x;

	x = (t-&gt;hour&lt;&lt;11) | (t-&gt;min&lt;&lt;5) | (t-&gt;sec&gt;&gt;1);
	d-&gt;time[0] = x;
	d-&gt;time[1] = x&gt;&gt;8;
	x = ((t-&gt;year-80)&lt;&lt;9) | ((t-&gt;mon+1)&lt;&lt;5) | t-&gt;mday;
	d-&gt;date[0] = x;
	d-&gt;date[1] = x&gt;&gt;8;
}

void
addrname(uchar *entry, Dir *dir, char *name, ulong start)
{
	char *s;
	Dosdir *d;

	s = strrchr(name, '/');
	if(s)
		s++;
	else
		s = name;

	d = (Dosdir*)entry;
	putname(s, d);
	if(strcmp(s, "9load") == 0)
		d-&gt;attr = DSYSTEM;
	else
		d-&gt;attr = 0;
	puttime(d);
	d-&gt;start[0] = start;
	d-&gt;start[1] = start&gt;&gt;8;
	d-&gt;length[0] = dir-&gt;length;
	d-&gt;length[1] = dir-&gt;length&gt;&gt;8;
	d-&gt;length[2] = dir-&gt;length&gt;&gt;16;
	d-&gt;length[3] = dir-&gt;length&gt;&gt;24;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

