<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/9p1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/9p1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"
#include	"9p1.h"

/*
 * buggery to give false qid for
 * the top 2 levels of the dump fs
 */
void
mkqid(Qid* qid, Dentry *d, int buggery)
{
	int c;

	if(buggery &amp;&amp; d-&gt;qid.path == QPROOT &amp;&amp; (d-&gt;qid.path &amp; QPDIR)){
		c = d-&gt;name[0];
		if(c &gt;= '0' &amp;&amp; c &lt;= '9'){
			qid-&gt;path = 3;
			qid-&gt;vers = d-&gt;qid.version;
			qid-&gt;type = QTDIR;

			c = (c-'0')*10 + (d-&gt;name[1]-'0');
			if(c &gt;= 1 &amp;&amp; c &lt;= 12)
				qid-&gt;path = 4;
			return;
		}
	}

	mkqid9p2(qid, &amp;d-&gt;qid, d-&gt;mode);
}

int
mkqidcmp(Qid* qid, Dentry *d)
{
	Qid tmp;

	mkqid(&amp;tmp, d, 1);
	if(qid-&gt;path==tmp.path &amp;&amp; (qid-&gt;type&amp;QTDIR)==(tmp.type&amp;QTDIR))
		return 0;
	return Eqid;
}

void
f_nop(Chan *cp, Oldfcall *in, Oldfcall *ou)
{

	USED(in);
	USED(ou);
	if(CHAT(cp))
		print("c_nop %d\n", cp-&gt;chan);
}

void
f_flush(Chan *cp, Oldfcall *in, Oldfcall *ou)
{

	USED(in);
	USED(ou);
	if(CHAT(cp))
		print("c_flush %d\n", cp-&gt;chan);
	runlock(&amp;cp-&gt;reflock);
	wlock(&amp;cp-&gt;reflock);
	wunlock(&amp;cp-&gt;reflock);
	rlock(&amp;cp-&gt;reflock);
}

void
f_session(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	if(CHAT(cp))
		print("c_session %d\n", cp-&gt;chan);

	memmove(cp-&gt;rchal, in-&gt;chal, sizeof(cp-&gt;rchal));
	if(wstatallow || cp == cons.srvchan){
		memset(ou-&gt;chal, 0, sizeof(ou-&gt;chal));
		memset(ou-&gt;authid, 0, sizeof(ou-&gt;authid));
	}else{
		mkchallenge(cp);
		memmove(ou-&gt;chal, cp-&gt;chal, sizeof(ou-&gt;chal));
		memmove(ou-&gt;authid, nvr.authid, sizeof(ou-&gt;authid));
	}
	sprint(ou-&gt;authdom, "%s.%s", service, nvr.authdom);
	fileinit(cp);
}

void
f_attach(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p;
	Dentry *d;
	File *f;
	int u;
	Filsys *fs;
	long raddr;

	if(CHAT(cp)) {
		print("c_attach %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
		print("	uid = %s\n", in-&gt;uname);
		print("	arg = %s\n", in-&gt;aname);
	}

	ou-&gt;qid = QID9P1(0,0);
	ou-&gt;fid = in-&gt;fid;
	if(!in-&gt;aname[0])	/* default */
		strncpy(in-&gt;aname, filesys[0].name, sizeof(in-&gt;aname));
	p = 0;
	f = filep(cp, in-&gt;fid, 1);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	u = -1;
	if(cp != cons.chan){
		if(authorize(cp, in, ou) == 0 || strcmp(in-&gt;uname, "adm") == 0){
			ou-&gt;err = Eauth;
			goto out;
		}
		u = strtouid(in-&gt;uname);
		if(u &lt; 0){
			ou-&gt;err = Ebadu;
			goto out;
		}
	}

	fs = fsstr(in-&gt;aname);
	if(fs == 0) {
		ou-&gt;err = Ebadspc;
		goto out;
	}
	raddr = getraddr(fs-&gt;dev);
	p = getbuf(fs-&gt;dev, raddr, Bread);
	d = getdir(p, 0);
	if(!d || checktag(p, Tdir, QPROOT) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	f-&gt;uid = u;
	if(iaccess(f, d, DREAD)) {
		ou-&gt;err = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD);
	mkqid(&amp;f-&gt;qid, d, 1);
	f-&gt;fs = fs;
	f-&gt;addr = raddr;
	f-&gt;slot = 0;
	f-&gt;open = 0;
	freewp(f-&gt;wpath);
	f-&gt;wpath = 0;

	mkqid9p1(&amp;ou-&gt;qid, &amp;f-&gt;qid);

out:
	if(p)
		putbuf(p);
	if(f) {
		qunlock(f);
		if(ou-&gt;err)
			freefp(f);
	}
}

void
f_clone(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	File *f1, *f2;
	int fid, fid1;

	if(CHAT(cp)) {
		print("c_clone %d\n", cp-&gt;chan);
		print("	old fid = %d\n", in-&gt;fid);
		print("	new fid = %d\n", in-&gt;newfid);
	}

	fid = in-&gt;fid;
	fid1 = in-&gt;newfid;

	f1 = 0;
	f2 = 0;
	if(fid &lt; fid1) {
		f1 = filep(cp, fid, 0);
		f2 = filep(cp, fid1, 1);
	} else
	if(fid1 &lt; fid) {
		f2 = filep(cp, fid1, 1);
		f1 = filep(cp, fid, 0);
	}
	if(!f1 || !f2) {
		ou-&gt;err = Efid;
		goto out;
	}


	f2-&gt;fs = f1-&gt;fs;
	f2-&gt;addr = f1-&gt;addr;
	f2-&gt;open = f1-&gt;open &amp; ~FREMOV;
	f2-&gt;uid = f1-&gt;uid;
	f2-&gt;slot = f1-&gt;slot;
	f2-&gt;qid = f1-&gt;qid;

	freewp(f2-&gt;wpath);
	f2-&gt;wpath = getwp(f1-&gt;wpath);

out:
	ou-&gt;fid = fid;
	if(f1)
		qunlock(f1);
	if(f2)
		qunlock(f2);
}

void
f_walk(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *f;
	Wpath *w, *ow;
	int slot;
	long addr;

	if(CHAT(cp)) {
		print("c_walk %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
		print("	name = %s\n", in-&gt;name);
	}

	ou-&gt;fid = in-&gt;fid;
	ou-&gt;qid = QID9P1(0,0);
	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(!(d-&gt;mode &amp; DDIR)) {
		ou-&gt;err = Edir1;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(cp != cons.chan &amp;&amp; iaccess(f, d, DEXEC)) {
		ou-&gt;err = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD);
	if(strcmp(in-&gt;name, ".") == 0)
		goto setdot;
	if(strcmp(in-&gt;name, "..") == 0) {
		if(f-&gt;wpath == 0)
			goto setdot;
		putbuf(p);
		p = 0;
		addr = f-&gt;wpath-&gt;addr;
		slot = f-&gt;wpath-&gt;slot;
		p1 = getbuf(f-&gt;fs-&gt;dev, addr, Bread);
		d1 = getdir(p1, slot);
		if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
			if(p1)
				putbuf(p1);
			ou-&gt;err = Ephase;
			goto out;
		}
		ow = f-&gt;wpath;
		f-&gt;wpath = ow-&gt;up;
		putwp(ow);
		goto found;
	}
	for(addr=0;; addr++) {
		p1 = dnodebuf(p, d, addr, 0);
		if(!p1 || checktag(p1, Tdir, d-&gt;qid.path) ) {
			if(p1)
				putbuf(p1);
			ou-&gt;err = Eentry;
			goto out;
		}
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			if(strncmp(in-&gt;name, d1-&gt;name, sizeof(in-&gt;name)))
				continue;
			/*
			 * update walk path
			 */
			w = newwp();
			if(!w) {
				ou-&gt;err = Ewalk;
				putbuf(p1);
				goto out;
			}
			w-&gt;addr = f-&gt;addr;
			w-&gt;slot = f-&gt;slot;
			w-&gt;up = f-&gt;wpath;
			f-&gt;wpath = w;
			slot += DIRPERBUF*addr;
			goto found;
		}
		putbuf(p1);
	}

found:
	f-&gt;addr = p1-&gt;addr;
	mkqid(&amp;f-&gt;qid, d1, 1);
	putbuf(p1);
	f-&gt;slot = slot;

setdot:
	mkqid9p1(&amp;ou-&gt;qid, &amp;f-&gt;qid);
	f-&gt;open = 0;

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
}

void
f_clunk(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	File *f;
	Tlock *t;
	long tim;

	if(CHAT(cp)) {
		print("c_clunk %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
	}

	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		print("%p\n", f);
		ou-&gt;err = Efid;
		goto out;
	}
	if(t = f-&gt;tlock) {
		tim = time(0);
		if(t-&gt;time &lt; tim || t-&gt;file != f)
			ou-&gt;err = Ebroken;
		t-&gt;time = 0;	/* free the lock */
		f-&gt;tlock = 0;
	}
	if(f-&gt;open &amp; FREMOV)
		ou-&gt;err = doremove(f, 0);
	f-&gt;open = 0;
	freewp(f-&gt;wpath);
	freefp(f);

out:
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

void
f_clwalk(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	int er, fid;

	if(CHAT(cp))
		print("c_clwalk macro\n");

	f_clone(cp, in, ou);		/* sets tag, fid */
	if(ou-&gt;err)
		return;
	fid = in-&gt;fid;
	in-&gt;fid = in-&gt;newfid;
	f_walk(cp, in, ou);		/* sets tag, fid, qid */
	er = ou-&gt;err;
	if(er == Eentry) {
		/*
		 * if error is "no entry"
		 * return non error and fid
		 */
		ou-&gt;err = 0;
		f_clunk(cp, in, ou);	/* sets tag, fid */
		ou-&gt;err = 0;
		ou-&gt;fid = fid;
		if(CHAT(cp)) 
			print("	error: %s\n", errstring[er]);
		return;
	}
	if(er) {
		/*
		 * if any other error
		 * return an error
		 */
		ou-&gt;err = 0;
		f_clunk(cp, in, ou);	/* sets tag, fid */
		ou-&gt;err = er;
		return;
	}
	/*
	 * non error
	 * return newfid
	 */
}

void
f_open(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p;
	Dentry *d;
	File *f;
	Tlock *t;
	Qid qid;
	int ro, fmod;

	if(CHAT(cp)) {
		print("c_open %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
		print("	mode = %o\n", in-&gt;mode);
	}

	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}

	/*
	 * if remove on close, check access here
	 */
	ro = isro(f-&gt;fs-&gt;dev) || (cp != cons.chan &amp;&amp; writegroup &amp;&amp; !ingroup(f-&gt;uid, writegroup));
	if(in-&gt;mode &amp; MRCLOSE) {
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
		/*
		 * check on parent directory of file to be deleted
		 */
		if(f-&gt;wpath == 0 || f-&gt;wpath-&gt;addr == f-&gt;addr) {
			ou-&gt;err = Ephase;
			goto out;
		}
		p = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Bread);
		d = getdir(p, f-&gt;wpath-&gt;slot);
		if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
			ou-&gt;err = Ephase;
			goto out;
		}
		if(iaccess(f, d, DWRITE)) {
			ou-&gt;err = Eaccess;
			goto out;
		}
		putbuf(p);
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	mkqid(&amp;qid, d, 1);
	switch(in-&gt;mode &amp; 7) {

	case MREAD:
		if(iaccess(f, d, DREAD) &amp;&amp; !writeallow)
			goto badaccess;
		fmod = FREAD;
		break;

	case MWRITE:
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DWRITE) &amp;&amp; !writeallow))
			goto badaccess;
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
		fmod = FWRITE;
		break;

	case MBOTH:
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DREAD) &amp;&amp; !writeallow) ||
		   (iaccess(f, d, DWRITE) &amp;&amp; !writeallow))
			goto badaccess;
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
		fmod = FREAD+FWRITE;
		break;

	case MEXEC:
		if((d-&gt;mode &amp; DDIR) ||
		   iaccess(f, d, DEXEC))
			goto badaccess;
		fmod = FREAD;
		break;

	default:
		ou-&gt;err = Emode;
		goto out;
	}
	if(in-&gt;mode &amp; MTRUNC) {
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DWRITE) &amp;&amp; !writeallow))
			goto badaccess;
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
	}
	t = 0;
	if(d-&gt;mode &amp; DLOCK) {
		t = tlocked(p, d);
		if(t == 0) {
			ou-&gt;err = Elocked;
			goto out;
		}
		t-&gt;file = f;
	}
	if(in-&gt;mode &amp; MRCLOSE)
		fmod |= FREMOV;
	f-&gt;open = fmod;
	if(in-&gt;mode &amp; MTRUNC)
		if(!(d-&gt;mode &amp; DAPND))
			dtrunc(p, d);
	f-&gt;tlock = t;
	f-&gt;lastra = 0;
	mkqid9p1(&amp;ou-&gt;qid, &amp;qid);
	goto out;

badaccess:
	ou-&gt;err = Eaccess;
	f-&gt;open = 0;

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

void
f_create(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *f;
	int slot, slot1, fmod;
	long addr, addr1, path;
	Qid qid;
	Tlock *t;
	Wpath *w;

	if(CHAT(cp)) {
		print("c_create %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
		print("	name = %s\n", in-&gt;name);
		print("	perm = %lx+%lo\n", (in-&gt;perm&gt;&gt;28)&amp;0xf,
				in-&gt;perm&amp;0777);
		print("	mode = %d\n", in-&gt;mode);
	}

	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(isro(f-&gt;fs-&gt;dev) || (cp != cons.chan &amp;&amp; writegroup &amp;&amp; !ingroup(f-&gt;uid, writegroup))) {
		ou-&gt;err = Eronly;
		goto out;
	}

	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(!(d-&gt;mode &amp; DDIR)) {
		ou-&gt;err = Edir2;
		goto out;
	}
	if(cp != cons.chan &amp;&amp; iaccess(f, d, DWRITE) &amp;&amp; !writeallow) {
		ou-&gt;err = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD);
	if(!strncmp(in-&gt;name, ".", sizeof(in-&gt;name)) ||
	   !strncmp(in-&gt;name, "..", sizeof(in-&gt;name))) {
		ou-&gt;err = Edot;
		goto out;
	}
	if(checkname(in-&gt;name)) {
		ou-&gt;err = Ename;
		goto out;
	}
	addr1 = 0;
	slot1 = 0;	/* set */
	for(addr=0;; addr++) {
		p1 = dnodebuf(p, d, addr, 0);
		if(!p1) {
			if(addr1)
				break;
			p1 = dnodebuf(p, d, addr, Tdir);
		}
		if(p1 == 0) {
			ou-&gt;err = Efull;
			goto out;
		}
		if(checktag(p1, Tdir, d-&gt;qid.path)) {
			putbuf(p1);
			goto phase;
		}
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC)) {
				if(!addr1) {
					addr1 = p1-&gt;addr;
					slot1 = slot + addr*DIRPERBUF;
				}
				continue;
			}
			if(!strncmp(in-&gt;name, d1-&gt;name, sizeof(in-&gt;name))) {
				putbuf(p1);
				ou-&gt;err = Eexist;
				goto out;
			}
		}
		putbuf(p1);
	}
	switch(in-&gt;mode &amp; 7) {
	case MEXEC:
	case MREAD:		/* seems only useful to make directories */
		fmod = FREAD;
		break;

	case MWRITE:
		fmod = FWRITE;
		break;

	case MBOTH:
		fmod = FREAD+FWRITE;
		break;

	default:
		ou-&gt;err = Emode;
		goto out;
	}
	if(in-&gt;perm &amp; PDIR)
		if((in-&gt;mode &amp; MTRUNC) || (in-&gt;perm &amp; PAPND) || (fmod &amp; FWRITE))
			goto badaccess;
	/*
	 * do it
	 */
	path = qidpathgen(&amp;f-&gt;fs-&gt;dev);
	p1 = getbuf(f-&gt;fs-&gt;dev, addr1, Bread|Bimm|Bmod);
	d1 = getdir(p1, slot1);
	if(!d1 || checktag(p1, Tdir, d-&gt;qid.path)) {
		if(p1)
			putbuf(p1);
		goto phase;
	}
	if(d1-&gt;mode &amp; DALLOC) {
		putbuf(p1);
		goto phase;
	}

	strncpy(d1-&gt;name, in-&gt;name, sizeof(in-&gt;name));
	/*
	 * bogus argument passing -- see console.c
	 */
	if(cp == cons.chan) {
		d1-&gt;uid = cons.uid;
		d1-&gt;gid = cons.gid;
	} else {
		d1-&gt;uid = f-&gt;uid;
		d1-&gt;gid = d-&gt;gid;
		in-&gt;perm &amp;= d-&gt;mode | ~0666;
		if(in-&gt;perm &amp; PDIR)
			in-&gt;perm &amp;= d-&gt;mode | ~0777;
	}
	d1-&gt;qid.path = path;
	d1-&gt;qid.version = 0;
	d1-&gt;mode = DALLOC | (in-&gt;perm &amp; 0777);
	if(in-&gt;perm &amp; PDIR) {
		d1-&gt;mode |= DDIR;
		d1-&gt;qid.path |= QPDIR;
	}
	if(in-&gt;perm &amp; PAPND)
		d1-&gt;mode |= DAPND;
	t = 0;
	if(in-&gt;perm &amp; PLOCK) {
		d1-&gt;mode |= DLOCK;
		t = tlocked(p1, d1);
	}
	accessdir(p1, d1, FWRITE);
	mkqid(&amp;qid, d1, 0);
	putbuf(p1);
	accessdir(p, d, FWRITE);

	/*
	 * do a walk to new directory entry
	 */
	w = newwp();
	if(!w) {
		ou-&gt;err = Ewalk;
		goto out;
	}
	w-&gt;addr = f-&gt;addr;
	w-&gt;slot = f-&gt;slot;
	w-&gt;up = f-&gt;wpath;
	f-&gt;wpath = w;
	f-&gt;qid = qid;
	f-&gt;tlock = t;
	f-&gt;lastra = 0;
	if(in-&gt;mode &amp; MRCLOSE)
		fmod |= FREMOV;
	f-&gt;open = fmod;
	f-&gt;addr = addr1;
	f-&gt;slot = slot1;
	if(t)
		t-&gt;file = f;
	mkqid9p1(&amp;ou-&gt;qid, &amp;qid);
	goto out;

badaccess:
	ou-&gt;err = Eaccess;
	goto out;

phase:
	ou-&gt;err = Ephase;

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

void
f_read(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p, *p1;
	File *f;
	Dentry *d, *d1;
	Tlock *t;
	long addr, offset, tim;
	int nread, count, n, o, slot;

	if(CHAT(cp)) {
		print("c_read %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
		print("	offset = %ld\n", in-&gt;offset);
		print("	count = %ld\n", in-&gt;count);
	}

	p = 0;
	count = in-&gt;count;
	offset = in-&gt;offset;
	nread = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(!(f-&gt;open &amp; FREAD)) {
		ou-&gt;err = Eopen;
		goto out;
	}
	if(count &lt; 0 || count &gt; MAXDAT) {
		ou-&gt;err = Ecount;
		goto out;
	}
	if(offset &lt; 0) {
		ou-&gt;err = Eoffset;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(t = f-&gt;tlock) {
		tim = time(0);
		if(t-&gt;time &lt; tim || t-&gt;file != f) {
			ou-&gt;err = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FREAD);
	if(d-&gt;mode &amp; DDIR) {
		addr = 0;
		goto dread;
	}
	if(offset+count &gt; d-&gt;size)
		count = d-&gt;size - offset;
	while(count &gt; 0) {
		addr = offset / BUFSIZE;
		if(addr == f-&gt;lastra+1)
			dbufread(p, d, addr+1);
		f-&gt;lastra = addr;
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		p1 = dnodebuf(p, d, addr, 0);
		if(p1) {
			if(checktag(p1, Tfile, QPNONE)) {
				ou-&gt;err = Ephase;
				putbuf(p1);
				goto out;
			}
			memmove(ou-&gt;data+nread, p1-&gt;iobuf+o, n);
			putbuf(p1);
		} else
			memset(ou-&gt;data+nread, 0, n);
		count -= n;
		nread += n;
		offset += n;
	}
	goto out;

dread:
	p1 = dnodebuf(p, d, addr, 0);
	if(!p1)
		goto out;
	if(checktag(p1, Tdir, QPNONE)) {
		ou-&gt;err = Ephase;
		putbuf(p1);
		goto out;
	}
	n = DIRREC;
	for(slot=0; slot&lt;DIRPERBUF; slot++) {
		d1 = getdir(p1, slot);
		if(!(d1-&gt;mode &amp; DALLOC))
			continue;
		if(offset &gt;= n) {
			offset -= n;
			continue;
		}
		if(count &lt; n) {
			putbuf(p1);
			goto out;
		}
		if(convD2M9p1(d1, ou-&gt;data+nread) != n)
			print("dirread convD2M\n");
		nread += n;
		count -= n;
	}
	putbuf(p1);
	addr++;
	goto dread;

out:
	count = in-&gt;count - nread;
	if(count &gt; 0)
		memset(ou-&gt;data+nread, 0, count);
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
	ou-&gt;count = nread;
	if(CHAT(cp))
		print("	nread = %d\n", nread);
}

void
f_write(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d;
	File *f;
	Tlock *t;
	long offset, addr, tim;
	int count, nwrite, o, n;

	if(CHAT(cp)) {
		print("c_write %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
		print("	offset = %ld\n", in-&gt;offset);
		print("	count = %ld\n", in-&gt;count);
	}

	offset = in-&gt;offset;
	count = in-&gt;count;
	nwrite = 0;
	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(!(f-&gt;open &amp; FWRITE)) {
		ou-&gt;err = Eopen;
		goto out;
	}
	if(isro(f-&gt;fs-&gt;dev) || (cp != cons.chan &amp;&amp; writegroup &amp;&amp; !ingroup(f-&gt;uid, writegroup))) {
		ou-&gt;err = Eronly;
		goto out;
	}
	if(count &lt; 0 || count &gt; MAXDAT) {
		ou-&gt;err = Ecount;
		goto out;
	}
	if(offset &lt; 0) {
		ou-&gt;err = Eoffset;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread|Bmod);
	d = getdir(p, f-&gt;slot);
	if(!d || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(t = f-&gt;tlock) {
		tim = time(0);
		if(t-&gt;time &lt; tim || t-&gt;file != f) {
			ou-&gt;err = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FWRITE);
	if(d-&gt;mode &amp; DAPND)
		offset = d-&gt;size;
	if(offset+count &gt; d-&gt;size)
		d-&gt;size = offset+count;
	while(count &gt; 0) {
		addr = offset / BUFSIZE;
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		p1 = dnodebuf(p, d, addr, Tfile);
		if(p1 == 0) {
			ou-&gt;err = Efull;
			goto out;
		}
		if(checktag(p1, Tfile, d-&gt;qid.path)) {
			putbuf(p1);
			ou-&gt;err = Ephase;
			goto out;
		}
		memmove(p1-&gt;iobuf+o, in-&gt;data+nwrite, n);
		p1-&gt;flags |= Bmod;
		putbuf(p1);
		count -= n;
		nwrite += n;
		offset += n;
	}
	if(CHAT(cp))
		print("	nwrite = %d\n", nwrite);

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
	ou-&gt;count = nwrite;
}

int
doremove(File *f, int iscon)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	long addr;
	int slot, err;

	p = 0;
	p1 = 0;
	if(isro(f-&gt;fs-&gt;dev) || (f-&gt;cp != cons.chan &amp;&amp; writegroup &amp;&amp; !ingroup(f-&gt;uid, writegroup))) {
		err = Eronly;
		goto out;
	}
	/*
	 * check on parent directory of file to be deleted
	 */
	if(f-&gt;wpath == 0 || f-&gt;wpath-&gt;addr == f-&gt;addr) {
		err = Ephase;
		goto out;
	}
	p1 = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Bread);
	d1 = getdir(p1, f-&gt;wpath-&gt;slot);
	if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
		err = Ephase;
		goto out;
	}
	if(!iscon &amp;&amp; iaccess(f, d1, DWRITE)) {
		err = Eaccess;
		goto out;
	}
	accessdir(p1, d1, FWRITE);
	putbuf(p1);
	p1 = 0;

	/*
	 * check on file to be deleted
	 */
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		err = Ealloc;
		goto out;
	}
	if(err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;

	/*
	 * if deleting a directory, make sure it is empty
	 */
	if((d-&gt;mode &amp; DDIR))
	for(addr=0;; addr++) {
		p1 = dnodebuf(p, d, addr, 0);
		if(!p1)
			break;
		if(checktag(p1, Tdir, d-&gt;qid.path)) {
			err = Ephase;
			goto out;
		}
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			err = Eempty;
			goto out;
		}
		putbuf(p1);
	}

	/*
	 * do it
	 */
	dtrunc(p, d);
	memset(d, 0, sizeof(Dentry));
	settag(p, Tdir, QPNONE);

out:
	if(p1)
		putbuf(p1);
	if(p)
		putbuf(p);
	return err;
}

void
f_remove(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	File *f;

	if(CHAT(cp)) {
		print("c_remove %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
	}

	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	ou-&gt;err = doremove(f, cp==cons.chan);

out:
	ou-&gt;fid = in-&gt;fid;
	if(f)
		qunlock(f);
}

void
f_stat(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p;
	Dentry *d;
	File *f;

	if(CHAT(cp)) {
		print("c_stat %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
	}

	p = 0;
	memset(ou-&gt;stat, 0, sizeof(ou-&gt;stat));
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(d-&gt;qid.path == QPROOT)	/* stat of root gives time */
		d-&gt;atime = time(0);
	if(convD2M9p1(d, ou-&gt;stat) != DIRREC)
		print("stat convD2M\n");

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

void
f_wstat(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d, *d1, xd;
	File *f;
	int slot;
	long addr;

	if(CHAT(cp)) {
		print("c_wstat %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
	}

	p = 0;
	p1 = 0;
	d1 = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(isro(f-&gt;fs-&gt;dev) || (cp != cons.chan &amp;&amp; writegroup &amp;&amp; !ingroup(f-&gt;uid, writegroup))) {
		ou-&gt;err = Eronly;
		goto out;
	}

	/*
	 * first get parent
	 */
	if(f-&gt;wpath) {
		p1 = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Bread);
		d1 = getdir(p1, f-&gt;wpath-&gt;slot);
		if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
			ou-&gt;err = Ephase;
			goto out;
		}
	}

	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;

	convM2D9p1(in-&gt;stat, &amp;xd);
	if(CHAT(cp)) {
		print("	d.name = %s\n", xd.name);
		print("	d.uid  = %d\n", xd.uid);
		print("	d.gid  = %d\n", xd.gid);
		print("	d.mode = %.4x\n", xd.mode);
	}

	/*
	 * if chown,
	 * must be god
	 */
	while(xd.uid != d-&gt;uid) {
		if(wstatallow)			/* set to allow chown during boot */
			break;
		ou-&gt;err = Enotu;
		goto out;
	}

	/*
	 * if chgroup,
	 * must be either
	 *	a) owner and in new group
	 *	b) leader of both groups
	 */
	while(xd.gid != d-&gt;gid) {
		if(wstatallow || writeallow)		/* set to allow chgrp during boot */
			break;
		if(d-&gt;uid == f-&gt;uid &amp;&amp; ingroup(f-&gt;uid, xd.gid))
			break;
		if(leadgroup(f-&gt;uid, xd.gid))
			if(leadgroup(f-&gt;uid, d-&gt;gid))
				break;
		ou-&gt;err = Enotg;
		goto out;
	}

	/*
	 * if rename,
	 * must have write permission in parent
	 */
	if(xd.name[0] == 0)
		strncpy(xd.name, d-&gt;name, sizeof(xd.name));
	while(strncmp(d-&gt;name, xd.name, sizeof(d-&gt;name)) != 0) {
		if(checkname(xd.name)) {
			ou-&gt;err = Ename;
			goto out;
		}

		if(strcmp(xd.name, ".") == 0 || strcmp(xd.name, "..") == 0) {
			ou-&gt;err = Ename;
			goto out;
		}

		/*
		 * drop entry to prevent lock, then
		 * check that destination name is unique,
		 */
		putbuf(p);
		for(addr=0;; addr++) {
			p = dnodebuf(p1, d1, addr, 0);
			if(!p)
				break;
			if(checktag(p, Tdir, d1-&gt;qid.path)) {
				putbuf(p);
				continue;
			}
			for(slot=0; slot&lt;DIRPERBUF; slot++) {
				d = getdir(p, slot);
				if(!(d-&gt;mode &amp; DALLOC))
					continue;
				if(!strncmp(xd.name, d-&gt;name, sizeof(xd.name))) {
					ou-&gt;err = Eexist;
					goto out;
				}
			}
			putbuf(p);
		}

		/*
		 * reacquire entry
		 */
		p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
		d = getdir(p, f-&gt;slot);
		if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
			ou-&gt;err = Ephase;
			goto out;
		}

		if(wstatallow || writeallow) /* set to allow rename during boot */
			break;
		if(!d1 || iaccess(f, d1, DWRITE)) {
			ou-&gt;err = Eaccess;
			goto out;
		}
		break;
	}

	/*
	 * if mode/time, either
	 *	a) owner
	 *	b) leader of either group
	 */
	while(d-&gt;mtime != xd.mtime ||
	     ((d-&gt;mode^xd.mode) &amp; (DAPND|DLOCK|0777))) {
		if(wstatallow)			/* set to allow chmod during boot */
			break;
		if(d-&gt;uid == f-&gt;uid)
			break;
		if(leadgroup(f-&gt;uid, xd.gid))
			break;
		if(leadgroup(f-&gt;uid, d-&gt;gid))
			break;
		ou-&gt;err = Enotu;
		goto out;
	}
	d-&gt;mtime = xd.mtime;
	d-&gt;uid = xd.uid;
	d-&gt;gid = xd.gid;
	d-&gt;mode = (xd.mode &amp; (DAPND|DLOCK|0777)) | (d-&gt;mode &amp; (DALLOC|DDIR));

	strncpy(d-&gt;name, xd.name, sizeof(d-&gt;name));
	if(wstatallow) {
		p-&gt;flags |= Bmod;
		if(xd.atime)
			d-&gt;atime = xd.atime;
		if(xd.mtime)
			d-&gt;mtime = xd.mtime;
	} else
		accessdir(p, d, FWSTAT);

out:
	if(p)
		putbuf(p);
	if(p1)
		putbuf(p1);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

void
(*call9p1[MAXSYSCALL])(Chan*, Oldfcall*, Oldfcall*) =
{
	[Tnop9p1]		f_nop,
	[Tosession9p1]	f_session,
	[Tsession9p1]	f_session,
	[Tflush9p1]	f_flush,
	[Toattach9p1]	f_attach,
	[Tattach9p1]	f_attach,
	[Tclone9p1]	f_clone,
	[Twalk9p1]		f_walk,
	[Topen9p1]		f_open,
	[Tcreate9p1]	f_create,
	[Tread9p1]		f_read,
	[Twrite9p1]	f_write,
	[Tclunk9p1]	f_clunk,
	[Tremove9p1]	f_remove,
	[Tstat9p1]		f_stat,
	[Twstat9p1]	f_wstat,
	[Tclwalk9p1]	f_clwalk,
};

static void
send(Chan *c, uchar *buf, int n)
{
	int fd, m;

	fd = c-&gt;chan;
	m = write(fd, buf, n);
	if(m == n)
		return;
	panic("write failed");
}

void
error9p1(Chan *c, uchar *buf)
{
	buf[0] = Rnop9p1;
	buf[1] = ~0;
	buf[2] = ~0;

	send(c, buf, 3);
}

void
serve9p1(Chan *chan, uchar *ib, int nib)
{
	int n, t;
	uchar inbuf[MAXMSG+MAXDAT], outbuf[MAXMSG+MAXDAT];
	Oldfcall fi, fo;

	for(;;){
		if(nib){
			memmove(inbuf, ib, nib);
			n = nib;
			nib = 0;
		}else
			n = read(chan-&gt;chan, inbuf, sizeof inbuf);
		if(chat)
			print("read msg %d\n", n);
		if(n == 0 &amp;&amp; (chan == cons.srvchan || chan == cons.chan))
			continue;
		if(n &lt;= 0)
			return;
		if(convM2S9p1(inbuf, &amp;fi, n) != n){
			error9p1(chan, outbuf);
			continue;
		}

		t = fi.type;
		if(t &lt; 0 || t &gt;= MAXSYSCALL || (t&amp;1) || !call9p1[t]) {
			print("9p1: bad message type\n");
			error9p1(chan, outbuf);
			continue;
		}

		if(CHAT(chan))
			print("9p1: fi %O\n", &amp;fi);

		/*
		 * set up reply message
		 */
		fo.err = 0;
		if(t == Tread9p1)
			fo.data = (char*)outbuf + 8;
	
		/*
		 * call the file system
		 */
		cons.work.count++;
		cons.rate.count += n;

		/*
		 * call the file system
		 */
		rlock(&amp;mainlock);
		rlock(&amp;chan-&gt;reflock);
	
		(*call9p1[t])(chan, &amp;fi, &amp;fo);
	
		runlock(&amp;chan-&gt;reflock);
		runlock(&amp;mainlock);
	
		fo.type = t+1;
		fo.tag = fi.tag;
	
		if(chat)
			print("9p1: fo %O\n", &amp;fo);

		if(fo.err) {
			strcpy(fo.ename, errstring[fo.err]);
			if(CHAT(cp))
				print("	error: %s\n", fo.ename);
			fo.type = Terror9p1+1;
		}
	
		n = convS2M9p1(&amp;fo, outbuf);
		if(n == 0) {
			print("9p1: bad S2M conversion\n");
			error9p1(chan, outbuf);
			continue;
		}

		cons.rate.count += n;
		send(chan, outbuf, n);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

