<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/9p12.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/9p12.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

static int
readmsg(Chan *c, void *abuf, int n, int *ninep)
{
	int fd, len;
	uchar *buf;

	buf = abuf;
	fd = c-&gt;chan;
	qlock(&amp;c-&gt;rlock);
	if(readn(fd, buf, 3) != 3){
		qunlock(&amp;c-&gt;rlock);
		print("readn(3) fails: %r\n");
		return -1;
	}
	if((50 &lt;= buf[0] &amp;&amp; buf[0] &lt;= 87 &amp;&amp; (buf[0]&amp;1)==0 &amp;&amp; GBIT16(buf+1) == 0xFFFF)
	|| buf[0] == 86	/* Tattach */){
		*ninep = 1;
		/* assume message boundaries */
		n = read(fd, buf+3, n-3);
		if(n &lt; 0){
			qunlock(&amp;c-&gt;rlock);
			return -1;
		}
		return n+3;
	}

	*ninep = 2;
	if(read(fd, buf+3, 1) != 1){
		qunlock(&amp;c-&gt;rlock);
		print("read(1) fails: %r\n");
		return -1;
	}
	len = GBIT32(buf);
	if(len &gt; n){
		print("msg too large\n");
		qunlock(&amp;c-&gt;rlock);
		return -1;
	}
	if(readn(fd, buf+4, len-4) != len-4){
		print("readn(%d) fails: %r\n", len-4);
		qunlock(&amp;c-&gt;rlock);
		return -1;
	}
	qunlock(&amp;c-&gt;rlock);
	return len;
}

int
startserveproc(void (*f)(Chan*, uchar*, int), char *name, Chan *c, uchar *b, int nb)
{
	int pid;

	switch(pid = rfork(RFMEM|RFPROC)){
	case -1:
		panic("can't fork");
	case 0:
		break;
	default:
		return pid;
	}
	procname = name;
	f(c, b, nb);
	_exits(nil);
	return -1;	/* can't happen */
}

void
serve(Chan *chan)
{
	int i, nin, p9, npid;
	uchar inbuf[1024];
	void (*s)(Chan*, uchar*, int);
	int *pid;
	Waitmsg *w;

	p9 = 0;
	if((nin = readmsg(chan, inbuf, sizeof inbuf, &amp;p9)) &lt; 0)
		return;

	switch(p9){
	default:
		print("unknown 9P type\n");
		return;
	case 1:
		s = serve9p1;
		break;
	case 2:
		s = serve9p2;
		break;
	}

	pid = malloc(sizeof(pid)*(conf.nserve-1));
	if(pid == nil)
		return;
	for(i=1; i&lt;conf.nserve; i++)
		pid[i-1] = startserveproc(s, "srv", chan, nil, 0);

	(*s)(chan, inbuf, nin);

	/* wait till all other servers for this chan are done */
	for(npid = conf.nserve-1; npid &gt; 0;){
		w = wait();
		if(w == 0)
			break;
		for(i = 0; i &lt; conf.nserve-1; i++)
			if(pid[i] == w-&gt;pid)
				npid--;
		free(w);
	}
	free(pid);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

