<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/9p1lib.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/9p1lib.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include "9p1.h"

#define	CHAR(x)		*p++ = f-&gt;x
#define	SHORT(x)	{ ulong vvv = f-&gt;x; p[0] = vvv; p[1] = vvv&gt;&gt;8; p += 2; }
#define	VLONG(q)	p[0] = (q); p[1] = (q)&gt;&gt;8; p[2] = (q)&gt;&gt;16; p[3] = (q)&gt;&gt;24; p += 4
#define	LONG(x)		{ ulong vvv = f-&gt;x; VLONG(vvv); }
#define	BYTES(x,n)	memmove(p, f-&gt;x, n); p += n
#define	STRING(x,n)	strncpy((char*)p, f-&gt;x, n); p += n

int
convS2M9p1(Oldfcall *f, uchar *ap)
{
	uchar *p;
	int t;

	p = ap;
	CHAR(type);
	t = f-&gt;type;
	SHORT(tag);
	switch(t)
	{
	default:
		print("convS2M9p1: bad type: %d\n", t);
		return 0;

	case Tnop9p1:
	case Tosession9p1:
		break;

	case Tsession9p1:
		BYTES(chal, sizeof(f-&gt;chal));
		break;

	case Tflush9p1:
		SHORT(oldtag);
		break;

	case Tattach9p1:
		SHORT(fid);
		STRING(uname, sizeof(f-&gt;uname));
		STRING(aname, sizeof(f-&gt;aname));
		BYTES(ticket, sizeof(f-&gt;ticket));
		BYTES(auth, sizeof(f-&gt;auth));
		break;

	case Toattach9p1:
		SHORT(fid);
		STRING(uname, sizeof(f-&gt;uname));
		STRING(aname, sizeof(f-&gt;aname));
		BYTES(ticket, NAMELEN);
		break;

	case Tclone9p1:
		SHORT(fid);
		SHORT(newfid);
		break;

	case Twalk9p1:
		SHORT(fid);
		STRING(name, sizeof(f-&gt;name));
		break;

	case Tclwalk9p1:
		SHORT(fid);
		SHORT(newfid);
		STRING(name, sizeof(f-&gt;name));
		break;

	case Topen9p1:
		SHORT(fid);
		CHAR(mode);
		break;

	case Tcreate9p1:
		SHORT(fid);
		STRING(name, sizeof(f-&gt;name));
		LONG(perm);
		CHAR(mode);
		break;

	case Tread9p1:
		SHORT(fid);
		LONG(offset); VLONG(0);
		SHORT(count);
		break;

	case Twrite9p1:
		SHORT(fid);
		LONG(offset); VLONG(0);
		SHORT(count);
		p++;
		if((uchar*)p == (uchar*)f-&gt;data) {
			p += f-&gt;count;
			break;
		}
		BYTES(data, f-&gt;count);
		break;

	case Tclunk9p1:
	case Tremove9p1:
	case Tstat9p1:
		SHORT(fid);
		break;

	case Twstat9p1:
		SHORT(fid);
		BYTES(stat, sizeof(f-&gt;stat));
		break;
/*
 */
	case Rnop9p1:
	case Rosession9p1:
	case Rflush9p1:
		break;

	case Rsession9p1:
		BYTES(chal, sizeof(f-&gt;chal));
		BYTES(authid, sizeof(f-&gt;authid));
		BYTES(authdom, sizeof(f-&gt;authdom));
		break;

	case Rerror9p1:
		STRING(ename, sizeof(f-&gt;ename));
		break;

	case Rclone9p1:
	case Rclunk9p1:
	case Rremove9p1:
	case Rwstat9p1:
		SHORT(fid);
		break;

	case Rwalk9p1:
	case Ropen9p1:
	case Rcreate9p1:
	case Rclwalk9p1:
		SHORT(fid);
		LONG(qid.path);
		LONG(qid.version);
		break;

	case Rattach9p1:
		SHORT(fid);
		LONG(qid.path);
		LONG(qid.version);
		BYTES(rauth, sizeof(f-&gt;rauth));
		break;

	case Roattach9p1:
		SHORT(fid);
		LONG(qid.path);
		LONG(qid.version);
		break;

	case Rread9p1:
		SHORT(fid);
		SHORT(count);
		p++;
		if((uchar*)p == (uchar*)f-&gt;data) {
			p += f-&gt;count;
			break;
		}
		BYTES(data, f-&gt;count);
		break;

	case Rwrite9p1:
		SHORT(fid);
		SHORT(count);
		break;

	case Rstat9p1:
		SHORT(fid);
		BYTES(stat, sizeof(f-&gt;stat));
		break;
	}
	return p - (uchar*)ap;
}

/*
 * buggery to give false qid for
 * the top 2 levels of the dump fs
 */
static ulong
fakeqid9p1(Dentry *f)
{
	ulong q;
	int c;

	q = f-&gt;qid.path;
	if(q == (QPROOT|QPDIR)) {
		c = f-&gt;name[0];
		if(c &gt;= '0' &amp;&amp; c &lt;= '9') {
			q = 3|QPDIR;
			c = (c-'0')*10 + (f-&gt;name[1]-'0');
			if(c &gt;= 1 &amp;&amp; c &lt;= 12)
				q = 4|QPDIR;
		}
	}
	return q;
}

int
convD2M9p1(Dentry *f, char *ap)
{
	uchar *p;
	ulong q;

	p = (uchar*)ap;
	STRING(name, sizeof(f-&gt;name));

	memset(p, 0, 2*NAMELEN);
	uidtostr((char*)p, f-&gt;uid);
	p += NAMELEN;

	uidtostr((char*)p, f-&gt;gid);
	p += NAMELEN;

	q = fakeqid9p1(f);
	VLONG(q);
	LONG(qid.version);
	{
		q = f-&gt;mode &amp; 0x0fff;
		if(f-&gt;mode &amp; DDIR)
			q |= PDIR;
		if(f-&gt;mode &amp; DAPND)
			q |= PAPND;
		if(f-&gt;mode &amp; DLOCK)
			q |= PLOCK;
		VLONG(q);
	}
	LONG(atime);
	LONG(mtime);
	LONG(size); VLONG(0);
	VLONG(0);
	return p - (uchar*)ap;
}

#undef	CHAR
#undef	SHORT
#undef	LONG
#undef	VLONG
#undef	BYTES
#undef	STRING

#define	CHAR(x)		f-&gt;x = *p++
#define	SHORT(x)	f-&gt;x = (p[0] | (p[1]&lt;&lt;8)); p += 2
#define	VLONG(q)	q = (p[0] | (p[1]&lt;&lt;8) | (p[2]&lt;&lt;16) | (p[3]&lt;&lt;24)); p += 4
#define	LONG(x)		VLONG(f-&gt;x)
#define	BYTES(x,n)	memmove(f-&gt;x, p, n); p += n
#define	STRING(x,n)	memmove(f-&gt;x, p, n); p += n

int
convM2S9p1(uchar *ap, Oldfcall *f, int n)
{
	uchar *p;
	int t;

	p = ap;
	CHAR(type);
	t = f-&gt;type;
	SHORT(tag);
	switch(t)
	{
	default:
		/*
		 * only whine if it couldn't be a 9P2000 Tversion9p1.
		 */
		if(t != 19 || ap[4] != 100)
			print("convM2S9p1: bad type: %d\n", f-&gt;type);
		return 0;

	case Tnop9p1:
	case Tosession9p1:
		break;

	case Tsession9p1:
		BYTES(chal, sizeof(f-&gt;chal));
		break;

	case Tflush9p1:
		SHORT(oldtag);
		break;

	case Tattach9p1:
		SHORT(fid);
		BYTES(uname, sizeof(f-&gt;uname));
		BYTES(aname, sizeof(f-&gt;aname));
		BYTES(ticket, sizeof(f-&gt;ticket));
		BYTES(auth, sizeof(f-&gt;auth));
		break;

	case Toattach9p1:
		SHORT(fid);
		BYTES(uname, sizeof(f-&gt;uname));
		BYTES(aname, sizeof(f-&gt;aname));
		BYTES(ticket, NAMELEN);
		break;

	case Tclone9p1:
		SHORT(fid);
		SHORT(newfid);
		break;

	case Twalk9p1:
		SHORT(fid);
		BYTES(name, sizeof(f-&gt;name));
		break;

	case Tclwalk9p1:
		SHORT(fid);
		SHORT(newfid);
		BYTES(name, sizeof(f-&gt;name));
		break;

	case Tremove9p1:
		SHORT(fid);
		break;

	case Topen9p1:
		SHORT(fid);
		CHAR(mode);
		break;

	case Tcreate9p1:
		SHORT(fid);
		BYTES(name, sizeof(f-&gt;name));
		LONG(perm);
		CHAR(mode);
		break;

	case Tread9p1:
		SHORT(fid);
		LONG(offset); p += 4;
		SHORT(count);
		break;

	case Twrite9p1:
		SHORT(fid);
		LONG(offset); p += 4;
		SHORT(count);
		p++;
		f-&gt;data = (char*)p; p += f-&gt;count;
		break;

	case Tclunk9p1:
	case Tstat9p1:
		SHORT(fid);
		break;

	case Twstat9p1:
		SHORT(fid);
		BYTES(stat, sizeof(f-&gt;stat));
		break;

/*
 */
	case Rnop9p1:
	case Rosession9p1:
		break;

	case Rsession9p1:
		BYTES(chal, sizeof(f-&gt;chal));
		BYTES(authid, sizeof(f-&gt;authid));
		BYTES(authdom, sizeof(f-&gt;authdom));
		break;

	case Rerror9p1:
		BYTES(ename, sizeof(f-&gt;ename));
		break;

	case Rflush9p1:
		break;

	case Rclone9p1:
	case Rclunk9p1:
	case Rremove9p1:
	case Rwstat9p1:
		SHORT(fid);
		break;

	case Rwalk9p1:
	case Rclwalk9p1:
	case Ropen9p1:
	case Rcreate9p1:
		SHORT(fid);
		LONG(qid.path);
		LONG(qid.version);
		break;

	case Rattach9p1:
		SHORT(fid);
		LONG(qid.path);
		LONG(qid.version);
		BYTES(rauth, sizeof(f-&gt;rauth));
		break;

	case Roattach9p1:
		SHORT(fid);
		LONG(qid.path);
		LONG(qid.version);
		break;

	case Rread9p1:
		SHORT(fid);
		SHORT(count);
		p++;
		f-&gt;data = (char*)p; p += f-&gt;count;
		break;

	case Rwrite9p1:
		SHORT(fid);
		SHORT(count);
		break;

	case Rstat9p1:
		SHORT(fid);
		BYTES(stat, sizeof(f-&gt;stat));
		break;
	}
	if((uchar*)ap+n == p)
		return n;
	return 0;
}

int
convM2D9p1(char *ap, Dentry *f)
{
	uchar *p;
	char str[28];

	p = (uchar*)ap;
	BYTES(name, sizeof(f-&gt;name));

	memmove(str, p, NAMELEN);
	p += NAMELEN;
	f-&gt;uid = strtouid(str);

	memmove(str, p, NAMELEN);
	p += NAMELEN;
	f-&gt;gid = strtouid(str);

	LONG(qid.path);
	LONG(qid.version);
	{
		LONG(atime);
		f-&gt;mode = (f-&gt;atime &amp; 0x0fff) | DALLOC;
		if(f-&gt;atime &amp; PDIR)
			f-&gt;mode |= DDIR;
		if(f-&gt;atime &amp; PAPND)
			f-&gt;mode |= DAPND;
		if(f-&gt;atime &amp; PLOCK)
			f-&gt;mode |= DLOCK;
	}
	LONG(atime);
	LONG(mtime);
	LONG(size); p += 4;
	p += 4;
	return p - (uchar*)ap;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

