<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/9p2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/9p2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

#define MSIZE	(MAXDAT+128)

static void
seterror(Fcall *ou, int err)
{

	if(0 &lt;= err &amp;&amp; err &lt; MAXERR)
		ou-&gt;ename = errstring[err];
	else
		ou-&gt;ename = "unknown error";
}

static int
fsversion(Chan* chan, Fcall* f, Fcall* r)
{
	if(f-&gt;msize &lt; MSIZE)
		r-&gt;msize = f-&gt;msize;
	else
		r-&gt;msize = MSIZE;
	/*
	 * Should check the '.' stuff here.
	 * What happens if Tversion has already been seen?
	 */
	if(strcmp(f-&gt;version, VERSION9P) == 0){
		r-&gt;version = VERSION9P;
		chan-&gt;msize = r-&gt;msize;
	}else
		r-&gt;version = "unknown";

	fileinit(chan);
	return 0;
}

char *keyspec = "proto=p9any role=server";

static int
fsauth(Chan *chan, Fcall *f, Fcall *r)
{
	int err, fd;
	char *aname;
	File *file;
	int afd;
	AuthRpc *rpc;

	err = 0;
	if(chan == cons.srvchan)
		return Eauthmsg;
	file = filep(chan, f-&gt;afid, 1);
	if(file == nil)
		return Efidinuse;

	/* forget any previous authentication */
	file-&gt;cuid = 0;

	if(access("/mnt/factotum", 0) &lt; 0)
		if((fd = open("/srv/factotum", ORDWR)) &gt;= 0)
			mount(fd, -1, "/mnt", MBEFORE, "");

	afd = open("/mnt/factotum/rpc", ORDWR);
	if(afd &lt; 0){
		err = Esystem;
		goto out;
	}
	rpc = auth_allocrpc(afd);
	if(rpc == nil){
		close(afd);
		err = Esystem;
		goto out;
	}
	file-&gt;rpc = rpc;
	if(auth_rpc(rpc, "start", keyspec, strlen(keyspec)) != ARok){
		err = Esystem;
		goto out;
	}

	aname = f-&gt;aname;
	if(!aname[0])
		aname = "main";
	file-&gt;fs = fsstr(aname);
	if(file-&gt;fs == nil){
		err = Ebadspc;
		goto out;
	}
	file-&gt;uid = strtouid(f-&gt;uname);
	if(file-&gt;uid &lt; 0){
		err = Ebadu;
		goto out;
	}
	file-&gt;qid.path = 0;
	file-&gt;qid.vers = 0;
	file-&gt;qid.type = QTAUTH;
	r-&gt;qid = file-&gt;qid;

out:
	if(file != nil){
		qunlock(file);
		if(err != 0)
			freefp(file);
	}
	return err;
}

int
authread(File *file, uchar *data, int count)
{
	AuthInfo *ai;
	AuthRpc *rpc;
	int rv;

	rpc = file-&gt;rpc;
	if(rpc == nil)
		return -1;

	rv = auth_rpc(rpc, "read", nil, 0);
	switch(rv){
	case ARdone:
		ai = auth_getinfo(rpc);
		if(ai == nil)
			return -1;
		if(chat)
			print("authread identifies user as %s\n", ai-&gt;cuid);
		file-&gt;cuid = strtouid(ai-&gt;cuid);
		auth_freeAI(ai);
		if(file-&gt;cuid == 0)
			return -1;
		if(chat)
			print("%s is a known user\n", ai-&gt;cuid);
		return 0;
	case ARok:
		if(count &lt; rpc-&gt;narg)
			return -1;
		memmove(data, rpc-&gt;arg, rpc-&gt;narg);
		return rpc-&gt;narg;
	case ARphase:
		return -1;
	default:
		return -1;
	}
}

int
authwrite(File *file, uchar *data, int count)
{
	int ret;

	ret = auth_rpc(file-&gt;rpc, "write", data, count);
	if(ret != ARok)
		return -1;
	return count;
}

void
mkqid9p1(Qid9p1* qid9p1, Qid* qid)
{
	if(qid-&gt;path &amp; 0xFFFFFFFF00000000LL)
		panic("mkqid9p1: path %lluX\n", qid-&gt;path);
	qid9p1-&gt;path = qid-&gt;path &amp; 0xFFFFFFFF;
	if(qid-&gt;type &amp; QTDIR)
		qid9p1-&gt;path |= QPDIR;
	qid9p1-&gt;version = qid-&gt;vers;
}

void
authfree(File *fp)
{
	if(fp-&gt;rpc != nil){
		close(fp-&gt;rpc-&gt;afd);
		free(fp-&gt;rpc);
		fp-&gt;rpc = nil;
	}
}

void
mkqid9p2(Qid* qid, Qid9p1* qid9p1, int mode)
{
	qid-&gt;path = (ulong)(qid9p1-&gt;path &amp; ~QPDIR);
	qid-&gt;vers = qid9p1-&gt;version;
	qid-&gt;type = 0;
	if(mode &amp; DDIR)
		qid-&gt;type |= QTDIR;
	if(mode &amp; DAPND)
		qid-&gt;type |= QTAPPEND;
	if(mode &amp; DLOCK)
		qid-&gt;type |= QTEXCL;
}

static int
checkattach(Chan *chan, File *afile, File *file, Filsys *fs)
{
	uchar buf[1];

	if(chan == cons.srvchan || chan == cons.chan)
		return 0;

	/* if no afile, this had better be none */
	if(afile == nil){
		if(file-&gt;uid == 0){
			if(!allownone &amp;&amp; !chan-&gt;authed)
				return Eauth;
			return 0;
		}
		return Eauth;
	}

	/* otherwise, we'ld better have a usable cuid */
	if(!(afile-&gt;qid.type&amp;QTAUTH))
		return Eauth;
	if(afile-&gt;uid != file-&gt;uid || afile-&gt;fs != fs)
		return Eauth;
	if(afile-&gt;cuid &lt;= 0){
		if(authread(afile, buf, 0) != 0)
			return Eauth;
		if(afile-&gt;cuid &lt;= 0)
			return Eauth;
	}
	file-&gt;uid = afile-&gt;cuid;

	/* once someone has authenticated on the channel, others can become none */
	chan-&gt;authed = 1;

	return 0;
}		

static int
fsattach(Chan* chan, Fcall* f, Fcall* r)
{
	char *aname;
	Iobuf *p;
	Dentry *d;
	File *file;
	File *afile;
	Filsys *fs;
	long raddr;
	int error, u;

	aname = f-&gt;aname;
	if(!aname[0])	/* default */
		aname = "main";
	p = nil;
	afile = filep(chan, f-&gt;afid, 0);
	file = filep(chan, f-&gt;fid, 1);
	if(file == nil){
		error = Efidinuse;
		goto out;
	}

	u = -1;
	if(chan != cons.chan){
		if(strcmp(f-&gt;uname, "adm") == 0){
			error = Eauth;
			goto out;
		}
		u = strtouid(f-&gt;uname);
		if(u &lt; 0){
			error = Ebadu;
			goto out;
		}
	}
	file-&gt;uid = u;

	fs = fsstr(aname);
	if(fs == nil){
		error = Ebadspc;
		goto out;
	}

	if(error = checkattach(chan, afile, file, fs))
		goto out;

	raddr = getraddr(fs-&gt;dev);
	p = getbuf(fs-&gt;dev, raddr, Bread);
	d = getdir(p, 0);
	if(d == nil || checktag(p, Tdir, QPROOT) || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(iaccess(file, d, DEXEC)){
		error = Eaccess;
		goto out;
	}
	if(file-&gt;uid == 0 &amp;&amp; isro(fs-&gt;dev)) {
		/*
		 * 'none' not allowed on dump
		 */
		error = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD);
	mkqid(&amp;file-&gt;qid, d, 1);
	file-&gt;fs = fs;
	file-&gt;addr = raddr;
	file-&gt;slot = 0;
	file-&gt;open = 0;
	freewp(file-&gt;wpath);
	file-&gt;wpath = 0;

	r-&gt;qid = file-&gt;qid;

//	if(cons.flags &amp; attachflag)
//		print("9p2: attach %s %T to \"%s\" C%d\n",
//			chan-&gt;whoname, chan-&gt;whotime, fs-&gt;name, chan-&gt;chan);

out:
//	if((cons.flags &amp; attachflag) &amp;&amp; error)
//		print("9p2: attach %s %T SUCK EGGS --- %s\n",
//			f-&gt;uname, time(), errstr[error]);
	if(p != nil)
		putbuf(p);
	if(afile != nil)
		qunlock(afile);
	if(file != nil){
		qunlock(file);
		if(error)
			freefp(file);
	}

	return error;
}

static int
fsflush(Chan* chan, Fcall*, Fcall*)
{
	runlock(&amp;chan-&gt;reflock);
	wlock(&amp;chan-&gt;reflock);
	wunlock(&amp;chan-&gt;reflock);
	rlock(&amp;chan-&gt;reflock);

	return 0;
}

static void
clone(File* nfile, File* file)
{
	Wpath *wpath;

	nfile-&gt;qid = file-&gt;qid;

	lock(&amp;wpathlock);
	nfile-&gt;wpath = file-&gt;wpath;
	for(wpath = nfile-&gt;wpath; wpath != nil; wpath = wpath-&gt;up)
		wpath-&gt;refs++;
	unlock(&amp;wpathlock);

	nfile-&gt;fs = file-&gt;fs;
	nfile-&gt;addr = file-&gt;addr;
	nfile-&gt;slot = file-&gt;slot;
	nfile-&gt;uid = file-&gt;uid;
	nfile-&gt;cuid = 0;
	nfile-&gt;open = file-&gt;open &amp; ~FREMOV;
}

static int
walkname(File* file, char* wname, Qid* wqid)
{
	Wpath *w;
	Iobuf *p, *p1;
	Dentry *d, *d1;
	int error, slot;
	long addr, qpath;

	p = p1 = nil;

	/*
	 * File must not have been opened for I/O by an open
	 * or create message and must represent a directory.
	 */
	if(file-&gt;open != 0){
		error = Emode;
		goto out;
	}

	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Edir1;
		goto out;
	}
	if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(!(d-&gt;mode &amp; DDIR)){
		error = Edir1;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;

	/*
	 * For walked elements the implied user must
	 * have permission to search the directory.
	 */
	if(file-&gt;cp != cons.chan &amp;&amp; iaccess(file, d, DEXEC)){
		error = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD);

	if(strcmp(wname, ".") == 0){
setdot:
		if(wqid != nil)
			*wqid = file-&gt;qid;
		goto out;
	}
	if(strcmp(wname, "..") == 0){
		if(file-&gt;wpath == 0)
			goto setdot;
		putbuf(p);
		p = nil;
		addr = file-&gt;wpath-&gt;addr;
		slot = file-&gt;wpath-&gt;slot;
		p1 = getbuf(file-&gt;fs-&gt;dev, addr, Bread);
		if(p1 == nil || checktag(p1, Tdir, QPNONE)){
			error = Edir1;
			goto out;
		}
		if((d1 = getdir(p1, slot)) == nil || !(d1-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}
		lock(&amp;wpathlock);
		file-&gt;wpath-&gt;refs--;
		file-&gt;wpath = file-&gt;wpath-&gt;up;
		unlock(&amp;wpathlock);
		goto found;
	}

	for(addr = 0; ; addr++){
		if(p == nil){
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
			if(p == nil || checktag(p, Tdir, QPNONE)){
				error = Ealloc;
				goto out;
			}
			d = getdir(p, file-&gt;slot);
			if(d == nil ||  !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out;
			}
		}
		qpath = d-&gt;qid.path;
		p1 = dnodebuf1(p, d, addr, 0);
		p = nil;
		if(p1 == nil || checktag(p1, Tdir, qpath)){
			error = Eentry;
			goto out;
		}
		for(slot = 0; slot &lt; DIRPERBUF; slot++){
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			if(strncmp(wname, d1-&gt;name, NAMELEN) != 0)
				continue;
			/*
			 * update walk path
			 */
			if((w = newwp()) == nil){
				error = Ewalk;
				goto out;
			}
			w-&gt;addr = file-&gt;addr;
			w-&gt;slot = file-&gt;slot;
			w-&gt;up = file-&gt;wpath;
			file-&gt;wpath = w;
			slot += DIRPERBUF*addr;
			goto found;
		}
		putbuf(p1);
		p1 = nil;
	}

found:
	file-&gt;addr = p1-&gt;addr;
	mkqid(&amp;file-&gt;qid, d1, 1);
	putbuf(p1);
	p1 = nil;
	file-&gt;slot = slot;
	if(wqid != nil)
		*wqid = file-&gt;qid;

out:
	if(p1 != nil)
		putbuf(p1);
	if(p != nil)
		putbuf(p);

	return error;
}

static int
fswalk(Chan* chan, Fcall* f, Fcall* r)
{
	int error, nwname;
	File *file, *nfile, tfile;

	/*
	 * The file identified by f-&gt;fid must be valid in the
	 * current session and must not have been opened for I/O
	 * by an open or create message.
	 */
	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;
	if(file-&gt;open != 0){
		qunlock(file);
		return Emode;
	}

	/*
	 * If newfid is not the same as fid, allocate a new file;
	 * a side effect is checking newfid is not already in use (error);
	 * if there are no names to walk this will be equivalent to a
	 * simple 'clone' operation.
	 * Otherwise, fid and newfid are the same and if there are names
	 * to walk make a copy of 'file' to be used during the walk as
	 * 'file' must only be updated on success.
	 * Finally, it's a no-op if newfid is the same as fid and f-&gt;nwname
	 * is 0.
	 */
	r-&gt;nwqid = 0;
	if(f-&gt;newfid != f-&gt;fid){
		if((nfile = filep(chan, f-&gt;newfid, 1)) == nil){
			qunlock(file);
			return Efidinuse;
		}
	}
	else if(f-&gt;nwname != 0){
		nfile = &amp;tfile;
		memset(nfile, 0, sizeof(File));
		nfile-&gt;cp = chan;
		nfile-&gt;fid = ~0;
	}
	else{
		qunlock(file);
		return 0;
	}
	clone(nfile, file);

	/*
	 * Should check name is not too long.
	 */
	error = 0;
	for(nwname = 0; nwname &lt; f-&gt;nwname; nwname++){
		error = walkname(nfile, f-&gt;wname[nwname], &amp;r-&gt;wqid[r-&gt;nwqid]);
		if(error != 0 || ++r-&gt;nwqid &gt;= MAXDAT/sizeof(Qid))
			break;
	}

	if(f-&gt;nwname == 0){
		/*
		 * Newfid must be different to fid (see above)
		 * so this is a simple 'clone' operation - there's
		 * nothing to do except unlock unless there's
		 * an error.
		 */
		if(error){
			freewp(nfile-&gt;wpath);
			qunlock(nfile);
			freefp(nfile);
		}
		else
			qunlock(nfile);
	}
	else if(r-&gt;nwqid &lt; f-&gt;nwname){
		/*
		 * Didn't walk all elements, 'clunk' nfile
		 * and leave 'file' alone.
		 * Clear error if some of the elements were
		 * walked OK.
		 */
		freewp(nfile-&gt;wpath);
		if(nfile != &amp;tfile){
			qunlock(nfile);
			freefp(nfile);
		}
		if(r-&gt;nwqid != 0)
			error = 0;
	}
	else{
		/*
		 * Walked all elements. If newfid is the same
		 * as fid must update 'file' from the temporary
		 * copy used during the walk.
		 * Otherwise just unlock (when using tfile there's
		 * no need to unlock as it's a local).
		 */
		if(nfile == &amp;tfile){
			file-&gt;qid = nfile-&gt;qid;
			freewp(file-&gt;wpath);
			file-&gt;wpath = nfile-&gt;wpath;
			file-&gt;addr = nfile-&gt;addr;
			file-&gt;slot = nfile-&gt;slot;
		}
		else
			qunlock(nfile);
	}
	qunlock(file);

	return error;
}

static int
fsopen(Chan* chan, Fcall* f, Fcall* r)
{
	Iobuf *p;
	Dentry *d;
	File *file;
	Tlock *t;
	Qid qid;
	int error, ro, fmod, wok;

	wok = 0;
	p = nil;

	if(chan == cons.chan || writeallow)
		wok = 1;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}

	/*
	 * if remove on close, check access here
	 */
	ro = isro(file-&gt;fs-&gt;dev) || (writegroup &amp;&amp; !ingroup(file-&gt;uid, writegroup));
	if(f-&gt;mode &amp; ORCLOSE){
		if(ro){
			error = Eronly;
			goto out;
		}
		/*
		 * check on parent directory of file to be deleted
		 */
		if(file-&gt;wpath == 0 || file-&gt;wpath-&gt;addr == file-&gt;addr){
			error = Ephase;
			goto out;
		}
		p = getbuf(file-&gt;fs-&gt;dev, file-&gt;wpath-&gt;addr, Bread);
		if(p == nil || checktag(p, Tdir, QPNONE)){
			error = Ephase;
			goto out;
		}
		if((d = getdir(p, file-&gt;wpath-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}
		if(iaccess(file, d, DWRITE)){
			error = Eaccess;
			goto out;
		}
		putbuf(p);
	}
	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	mkqid(&amp;qid, d, 1);
	switch(f-&gt;mode &amp; 7){

	case OREAD:
		if(iaccess(file, d, DREAD) &amp;&amp; !wok)
			goto badaccess;
		fmod = FREAD;
		break;

	case OWRITE:
		if((d-&gt;mode &amp; DDIR) || (iaccess(file, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro){
			error = Eronly;
			goto out;
		}
		fmod = FWRITE;
		break;

	case ORDWR:
		if((d-&gt;mode &amp; DDIR)
		|| (iaccess(file, d, DREAD) &amp;&amp; !wok)
		|| (iaccess(file, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro){
			error = Eronly;
			goto out;
		}
		fmod = FREAD+FWRITE;
		break;

	case OEXEC:
		if((d-&gt;mode &amp; DDIR) || (iaccess(file, d, DEXEC) &amp;&amp; !wok))
			goto badaccess;
		fmod = FREAD;
		break;

	default:
		error = Emode;
		goto out;
	}
	if(f-&gt;mode &amp; OTRUNC){
		if((d-&gt;mode &amp; DDIR) || (iaccess(file, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro){
			error = Eronly;
			goto out;
		}
	}
	t = 0;
	if(d-&gt;mode &amp; DLOCK){
		if((t = tlocked(p, d)) == nil){
			error = Elocked;
			goto out;
		}
	}
	if(f-&gt;mode &amp; ORCLOSE)
		fmod |= FREMOV;
	file-&gt;open = fmod;
	if((f-&gt;mode &amp; OTRUNC) &amp;&amp; !(d-&gt;mode &amp; DAPND)){
		dtrunc(p, d);
		qid.vers = d-&gt;qid.version;
	}
	r-&gt;qid = qid;
	file-&gt;tlock = t;
	if(t != nil)
		t-&gt;file = file;
	file-&gt;lastra = 1;
	goto out;

badaccess:
	error = Eaccess;
	file-&gt;open = 0;

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);

	r-&gt;iounit = chan-&gt;msize-IOHDRSZ;

	return error;
}

static int
dir9p2(Dir* dir, Dentry* dentry, void* strs)
{
	char *op, *p;

	memset(dir, 0, sizeof(Dir));
	mkqid(&amp;dir-&gt;qid, dentry, 1);
	dir-&gt;mode = (dir-&gt;qid.type&lt;&lt;24)|(dentry-&gt;mode &amp; 0777);
	dir-&gt;atime = dentry-&gt;atime;
	dir-&gt;mtime = dentry-&gt;mtime;
	dir-&gt;length = dentry-&gt;size;

	op = p = strs;
	dir-&gt;name = p;
	p += sprint(p, "%s", dentry-&gt;name)+1;

	dir-&gt;uid = p;
	uidtostr(p, dentry-&gt;uid);
	p += strlen(p)+1;

	dir-&gt;gid = p;
	uidtostr(p, dentry-&gt;gid);
	p += strlen(p)+1;

	dir-&gt;muid = p;
	strcpy(p, "");
	p += strlen(p)+1;

	return p-op;
}

static int
checkname9p2(char* name)
{
	char *p;

	/*
	 * Return length of string if valid, 0 if not.
	 */
	if(name == nil)
		return 0;

	for(p = name; *p != 0; p++){
		if((*p &amp; 0xFF) &lt;= 040)
			return 0;
	}

	return p-name;
}

static int
fscreate(Chan* chan, Fcall* f, Fcall* r)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *file;
	int error, slot, slot1, fmod, wok, l;
	long addr, addr1, path;
	Tlock *t;
	Wpath *w;

	wok = 0;
	p = nil;

	if(chan == cons.chan || writeallow)
		wok = 1;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(isro(file-&gt;fs-&gt;dev) || (writegroup &amp;&amp; !ingroup(file-&gt;uid, writegroup))){
		error = Eronly;
		goto out;
	}

	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	if(!(d-&gt;mode &amp; DDIR)){
		error = Edir2;
		goto out;
	}
	if(iaccess(file, d, DWRITE) &amp;&amp; !wok) {
		error = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD);

	/*
	 * Check the name is valid and will fit in an old
	 * directory entry.
	 */
	if((l = checkname9p2(f-&gt;name)) == 0){
		error = Ename;
		goto out;
	}
	if(l+1 &gt; NAMELEN){
		error = Etoolong;
		goto out;
	}
	if(strcmp(f-&gt;name, ".") == 0 || strcmp(f-&gt;name, "..") == 0){
		error = Edot;
		goto out;
	}

	addr1 = 0;
	slot1 = 0;	/* set */
	for(addr = 0; ; addr++){
		if((p1 = dnodebuf(p, d, addr, 0)) == nil){
			if(addr1 != 0)
				break;
			p1 = dnodebuf(p, d, addr, Tdir);
		}
		if(p1 == nil){
			error = Efull;
			goto out;
		}
		if(checktag(p1, Tdir, d-&gt;qid.path)){
			putbuf(p1);
			goto phase;
		}
		for(slot = 0; slot &lt; DIRPERBUF; slot++){
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC)){
				if(addr1 == 0){
					addr1 = p1-&gt;addr;
					slot1 = slot + addr*DIRPERBUF;
				}
				continue;
			}
			if(strncmp(f-&gt;name, d1-&gt;name, sizeof(d1-&gt;name)) == 0){
				putbuf(p1);
				error = Eexist;
				goto out;
			}
		}
		putbuf(p1);
	}

	switch(f-&gt;mode &amp; 7){
	case OEXEC:
	case OREAD:		/* seems only useful to make directories */
		fmod = FREAD;
		break;

	case OWRITE:
		fmod = FWRITE;
		break;

	case ORDWR:
		fmod = FREAD+FWRITE;
		break;

	default:
		error = Emode;
		goto out;
	}
	if(f-&gt;perm &amp; PDIR)
		if((f-&gt;mode &amp; OTRUNC) || (f-&gt;perm &amp; PAPND) || (fmod &amp; FWRITE))
			goto badaccess;
	/*
	 * do it
	 */
	path = qidpathgen(&amp;file-&gt;fs-&gt;dev);
	if((p1 = getbuf(file-&gt;fs-&gt;dev, addr1, Bread|Bimm|Bmod)) == nil)
		goto phase;
	d1 = getdir(p1, slot1);
	if(d1 == nil || checktag(p1, Tdir, d-&gt;qid.path)) {
		putbuf(p1);
		goto phase;
	}
	if(d1-&gt;mode &amp; DALLOC){
		putbuf(p1);
		goto phase;
	}

	strncpy(d1-&gt;name, f-&gt;name, sizeof(d1-&gt;name));
	if(chan == cons.chan){
		d1-&gt;uid = cons.uid;
		d1-&gt;gid = cons.gid;
	}
	else{
		d1-&gt;uid = file-&gt;uid;
		d1-&gt;gid = d-&gt;gid;
		f-&gt;perm &amp;= d-&gt;mode | ~0666;
		if(f-&gt;perm &amp; PDIR)
			f-&gt;perm &amp;= d-&gt;mode | ~0777;
	}
	d1-&gt;qid.path = path;
	d1-&gt;qid.version = 0;
	d1-&gt;mode = DALLOC | (f-&gt;perm &amp; 0777);
	if(f-&gt;perm &amp; PDIR) {
		d1-&gt;mode |= DDIR;
		d1-&gt;qid.path |= QPDIR;
	}
	if(f-&gt;perm &amp; PAPND)
		d1-&gt;mode |= DAPND;
	t = nil;
	if(f-&gt;perm &amp; PLOCK){
		d1-&gt;mode |= DLOCK;
		t = tlocked(p1, d1);
		/* if nil, out of tlock structures */
	}
	accessdir(p1, d1, FWRITE);
	mkqid(&amp;r-&gt;qid, d1, 0);
	putbuf(p1);
	accessdir(p, d, FWRITE);

	/*
	 * do a walk to new directory entry
	 */
	if((w = newwp()) == nil){
		error = Ewalk;
		goto out;
	}
	w-&gt;addr = file-&gt;addr;
	w-&gt;slot = file-&gt;slot;
	w-&gt;up = file-&gt;wpath;
	file-&gt;wpath = w;
	file-&gt;qid = r-&gt;qid;
	file-&gt;tlock = t;
	if(t != nil)
		t-&gt;file = file;
	file-&gt;lastra = 1;
	if(f-&gt;mode &amp; ORCLOSE)
		fmod |= FREMOV;
	file-&gt;open = fmod;
	file-&gt;addr = addr1;
	file-&gt;slot = slot1;
	goto out;

badaccess:
	error = Eaccess;
	goto out;

phase:
	error = Ephase;

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);

	r-&gt;iounit = chan-&gt;msize-IOHDRSZ;

	return error;
}

static int
fsread(Chan* chan, Fcall* f, Fcall* r)
{
	uchar *data;
	Iobuf *p, *p1;
	File *file;
	Dentry *d, *d1;
	Tlock *t;
	long addr, offset, start, tim;
	int error, iounit, nread, count, n, o, slot;
	Dir dir;
	char strdata[28*10];

	p = nil;
	data = (uchar*)r-&gt;data;
	count = f-&gt;count;
	offset = f-&gt;offset;
	nread = 0;
	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(file-&gt;qid.type &amp; QTAUTH){
		nread = authread(file, data, count);
		if(nread &lt; 0)
			error = Esystem;
		else
			error = 0;
		goto out;
	}
	if(!(file-&gt;open &amp; FREAD)){
		error = Eopen;
		goto out;
	}
	iounit = chan-&gt;msize-IOHDRSZ;
	if(count &lt; 0 || count &gt; iounit){
		error = Ecount;
		goto out;
	}
	if(offset &lt; 0){
		error = Eoffset;
		goto out;
	}
	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	if(t = file-&gt;tlock){
		tim = time(0);
		if(t-&gt;time &lt; tim || t-&gt;file != file){
			error = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FREAD);
	if(d-&gt;mode &amp; DDIR)
		goto dread;
	if(offset+count &gt; d-&gt;size)
		count = d-&gt;size - offset;
	while(count &gt; 0){
		if(p == nil){
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
			if(p == nil || checktag(p, Tdir, QPNONE)){
				error = Ealloc;
				goto out;
			}
			if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out;
			}
		}
		addr = offset / BUFSIZE;
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		p1 = dnodebuf1(p, d, addr, 0);
		p = nil;
		if(p1 != nil){
			if(checktag(p1, Tfile, QPNONE)){
				error = Ephase;
				putbuf(p1);
				goto out;
			}
			memmove(data+nread, p1-&gt;iobuf+o, n);
			putbuf(p1);
		}
		else
			memset(data+nread, 0, n);
		count -= n;
		nread += n;
		offset += n;
	}
	goto out;

dread:
	/*
	 * Pick up where we left off last time if nothing has changed,
	 * otherwise must scan from the beginning.
	 */
	if(offset == file-&gt;doffset /*&amp;&amp; file-&gt;qid.vers == file-&gt;dvers*/){
		addr = file-&gt;dslot/DIRPERBUF;
		slot = file-&gt;dslot%DIRPERBUF;
		start = offset;
	}
	else{
		addr = 0;
		slot = 0;
		start = 0;
	}

dread1:
	if(p == nil){
		/*
		 * This is just a check to ensure the entry hasn't
		 * gone away during the read of each directory block.
		 */
		p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
		if(p == nil || checktag(p, Tdir, QPNONE)){
			error = Ealloc;
			goto out1;
		}
		if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
			error = Ealloc;
			goto out1;
		}
	}
	p1 = dnodebuf1(p, d, addr, 0);
	p = nil;
	if(p1 == nil)
		goto out1;
	if(checktag(p1, Tdir, QPNONE)){
		error = Ephase;
		putbuf(p1);
		goto out1;
	}

	for(; slot &lt; DIRPERBUF; slot++){
		d1 = getdir(p1, slot);
		if(!(d1-&gt;mode &amp; DALLOC))
			continue;
		dir9p2(&amp;dir, d1, strdata);
		if((n = convD2M(&amp;dir, data+nread, iounit - nread)) &lt;= BIT16SZ){
			putbuf(p1);
			goto out1;
		}
		start += n;
		if(start &lt; offset)
			continue;
		if(count &lt; n){
			putbuf(p1);
			goto out1;
		}
		count -= n;
		nread += n;
		offset += n;
	}
	putbuf(p1);
	slot = 0;
	addr++;
	goto dread1;

out1:
	if(error == 0){
		file-&gt;doffset = offset;
		file-&gt;dvers = file-&gt;qid.vers;
		file-&gt;dslot = slot+DIRPERBUF*addr;
	}

out:
	/*
	 * Do we need this any more?
	count = f-&gt;count - nread;
	if(count &gt; 0)
		memset(data+nread, 0, count);
	 */
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);
	r-&gt;count = nread;
	r-&gt;data = (char*)data;

	return error;
}

static int
fswrite(Chan* chan, Fcall* f, Fcall* r)
{
	Iobuf *p, *p1;
	Dentry *d;
	File *file;
	Tlock *t;
	long offset, addr, tim, qpath;
	int count, error, nwrite, o, n;

	offset = f-&gt;offset;
	count = f-&gt;count;

	nwrite = 0;
	p = nil;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(file-&gt;qid.type &amp; QTAUTH){
		nwrite = authwrite(file, (uchar*)f-&gt;data, count);
		if(nwrite &lt; 0)
			error = Esystem;
		else
			error = 0;
		goto out;
	}
	if(!(file-&gt;open &amp; FWRITE)){
		error = Eopen;
		goto out;
	}
	if(isro(file-&gt;fs-&gt;dev) || (writegroup &amp;&amp; !ingroup(file-&gt;uid, writegroup))){
		error = Eronly;
		goto out;
	}
	if(count &lt; 0 || count &gt; chan-&gt;msize-IOHDRSZ){
		error = Ecount;
		goto out;
	}
	if(offset &lt; 0) {
		error = Eoffset;
		goto out;
	}
	if((p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread|Bmod)) == nil){
		error = Ealloc;
		goto out;
	}
	if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	if(t = file-&gt;tlock) {
		tim = time(0);
		if(t-&gt;time &lt; tim || t-&gt;file != file){
			error = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FWRITE);
	if(d-&gt;mode &amp; DAPND)
		offset = d-&gt;size;
	if(offset+count &gt; d-&gt;size)
		d-&gt;size = offset+count;
	while(count &gt; 0){
		if(p == nil){
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread|Bmod);
			if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out;
			}
		}
		addr = offset / BUFSIZE;
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		qpath = d-&gt;qid.path;
		p1 = dnodebuf1(p, d, addr, Tfile);
		p = nil;
		if(p1 == nil) {
			error = Efull;
			goto out;
		}
		if(checktag(p1, Tfile, qpath)){
			putbuf(p1);
			error = Ephase;
			goto out;
		}
		memmove(p1-&gt;iobuf+o, f-&gt;data+nwrite, n);
		p1-&gt;flags |= Bmod;
		putbuf(p1);
		count -= n;
		nwrite += n;
		offset += n;
	}

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);
	r-&gt;count = nwrite;

	return error;
}

static int
_clunk(File* file, int remove, int wok)
{
	Tlock *t;
	int error;

	error = 0;
	if(t = file-&gt;tlock){
		if(t-&gt;file == file)
			t-&gt;time = 0;		/* free the lock */
		file-&gt;tlock = 0;
	}
	if(remove)
		error = doremove(file, wok);
	file-&gt;open = 0;
	freewp(file-&gt;wpath);
	freefp(file);
	qunlock(file);

	return error;
}

static int
fsclunk(Chan* chan, Fcall* f, Fcall*)
{
	File *file;

	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;

	_clunk(file, file-&gt;open &amp; FREMOV, 0);
	return 0;
}

static int
fsremove(Chan* chan, Fcall* f, Fcall*)
{
	File *file;

	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;

	return _clunk(file, 1, chan == cons.chan);
}

static int
fsstat(Chan* chan, Fcall* f, Fcall* r, uchar* data)
{
	Dir dir;
	Iobuf *p;
	Dentry *d;
	File *file;
	int error, len;

	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;

	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Edir1;
		goto out;
	}
	if((d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;

	if(d-&gt;qid.path == QPROOT)	/* stat of root gives time */
		d-&gt;atime = time(0);

	len = dir9p2(&amp;dir, d, data);
	data += len;
	if((r-&gt;nstat = convD2M(&amp;dir, data, chan-&gt;msize - len)) == 0)
		error = Ersc;
	else
		r-&gt;stat = data;

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);

	return error;
}

static int
fswstat(Chan* chan, Fcall* f, Fcall*, char *strs)
{
	Iobuf *p, *p1;
	Dentry *d, *d1, xd;
	File *file;
	int error, slot, uid, gid, l;
	long addr;
	Dir dir;
	ulong mode;

	p = p1 = nil;
	d1 = nil;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}

	/*
	 * if user none,
	 * can't do anything
	 * unless allow.
	 */
	if(file-&gt;uid == 0 &amp;&amp; !wstatallow){
		error = Eaccess;
		goto out;
	}

	if(isro(file-&gt;fs-&gt;dev) || (writegroup &amp;&amp; !ingroup(file-&gt;uid, writegroup))){
		error = Eronly;
		goto out;
	}

	/*
	 * first get parent
	 */
	if(file-&gt;wpath){
		p1 = getbuf(file-&gt;fs-&gt;dev, file-&gt;wpath-&gt;addr, Bread);
		if(p1 == nil){
			error = Ephase;
			goto out;
		}
		d1 = getdir(p1, file-&gt;wpath-&gt;slot);
		if(d1 == nil || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}
	}

	if((p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread)) == nil){
		error = Ealloc;
		goto out;
	}
	d = getdir(p, file-&gt;slot);
	if(d == nil || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;

	/*
	 * Convert the message and fix up
	 * fields not to be changed.
	 */
	if(convM2D(f-&gt;stat, f-&gt;nstat, &amp;dir, strs) == 0){
		print("9p2: convM2D returns 0\n");
		error = Econvert;
		goto out;
	}
	if(dir.uid == nil || strlen(dir.uid) == 0)
		uid = d-&gt;uid;
	else
		uid = strtouid(dir.uid);
	if(dir.gid == nil || strlen(dir.gid) == 0)
		gid = d-&gt;gid;
	else
		gid = strtouid(dir.gid);
	if(dir.name == nil || strlen(dir.name) == 0)
		dir.name = d-&gt;name;
	else{
		if((l = checkname9p2(dir.name)) == 0){
			error = Ename;
			goto out;
		}
		if(l &gt; NAMELEN){
			error = Etoolong;
			goto out;
		}
	}

	/*
	 * Before doing sanity checks, find out what the
	 * new 'mode' should be:
	 * if 'type' and 'mode' are both defaults, take the
	 * new mode from the old directory entry;
	 * else if 'type' is the default, use the new mode entry;
	 * else if 'mode' is the default, create the new mode from
	 * 'type' or'ed with the old directory mode;
	 * else neither are defaults, use the new mode but check
	 * it agrees with 'type'.
	 */
	if(dir.qid.type == 0xFF &amp;&amp; dir.mode == ~0){
		dir.mode = d-&gt;mode &amp; 0777;
		if(d-&gt;mode &amp; DLOCK)
			dir.mode |= DMEXCL;
		if(d-&gt;mode &amp; DAPND)
			dir.mode |= DMAPPEND;
		if(d-&gt;mode &amp; DDIR)
			dir.mode |= DMDIR;
	}
	else if(dir.qid.type == 0xFF){
		/* nothing to do */
	}
	else if(dir.mode == ~0)
		dir.mode = (dir.qid.type&lt;&lt;24)|(d-&gt;mode &amp; 0777);
	else if(dir.qid.type != ((dir.mode&gt;&gt;24) &amp; 0xFF)){
		error = Eqidmode;
		goto out;
	}

	/*
	 * Check for unknown type/mode bits
	 * and an attempt to change the directory bit.
	 */
	if(dir.mode &amp; ~(DMDIR|DMAPPEND|DMEXCL|0777)){
		error = Enotm;
		goto out;
	}
	if(d-&gt;mode &amp; DDIR)
		mode = DMDIR;
	else
		mode = 0;
	if((dir.mode^mode) &amp; DMDIR){
		error = Enotd;
		goto out;
	}

	if(dir.mtime == ~0)
		dir.mtime = d-&gt;mtime;
	if(dir.length == ~0)
		dir.length = d-&gt;size;

	/*
	 * Currently, can't change length.
	 */
	if(dir.length != d-&gt;size){
		error = Enotl;
		goto out;
	}

	/*
	 * if chown,
	 * must be god
	 * wstatallow set to allow chown during boot
	 */
	if(uid != d-&gt;uid &amp;&amp; !wstatallow) {
		error = Enotu;
		goto out;
	}

	/*
	 * if chgroup,
	 * must be either
	 *	a) owner and in new group
	 *	b) leader of both groups
	 * wstatallow and writeallow are set to allow chgrp during boot
	 */
	while(gid != d-&gt;gid) {
		if(wstatallow || writeallow)
			break;
		if(d-&gt;uid == file-&gt;uid &amp;&amp; ingroup(file-&gt;uid, gid))
			break;
		if(leadgroup(file-&gt;uid, gid))
			if(leadgroup(file-&gt;uid, d-&gt;gid))
				break;
		error = Enotg;
		goto out;
	}

	/*
	 * if rename,
	 * must have write permission in parent
	 */
	while(strncmp(d-&gt;name, dir.name, sizeof(d-&gt;name)) != 0) {
		if(checkname(dir.name) || d1 == nil) {
			error = Ename;
			goto out;
		}
		if(strcmp(dir.name, ".") == 0 || strcmp(xd.name, "..") == 0) {
			error = Ename;
			goto out;
		}

		/*
		 * drop entry to prevent lock, then
		 * check that destination name is unique,
		 */
		putbuf(p);
		for(addr = 0; ; addr++) {
			if((p = dnodebuf(p1, d1, addr, 0)) == nil)
				break;
			if(checktag(p, Tdir, d1-&gt;qid.path)) {
				putbuf(p);
				continue;
			}
			for(slot = 0; slot &lt; DIRPERBUF; slot++) {
				d = getdir(p, slot);
				if(!(d-&gt;mode &amp; DALLOC))
					continue;
				if(strncmp(dir.name, d-&gt;name, sizeof(d-&gt;name)) == 0) {
					error = Eexist;
					goto out;
				}
			}
			putbuf(p);
		}

		/*
		 * reacquire entry
		 */
		if((p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Bread)) == nil){
			error = Ephase;
			goto out;
		}
		d = getdir(p, file-&gt;slot);
		if(d == nil || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
			error = Ephase;
			goto out;
		}

		if(wstatallow || writeallow) /* set to allow rename during boot */
			break;
		if(d1 == nil || iaccess(file, d1, DWRITE)) {
			error = Eaccess;
			goto out;
		}
		break;
	}

	/*
	 * if mode/time, either
	 *	a) owner
	 *	b) leader of either group
	 */
	mode = dir.mode &amp; 0777;
	if(dir.mode &amp; DMAPPEND)
		mode |= DAPND;
	if(dir.mode &amp; DMEXCL)
		mode |= DLOCK;
	while(d-&gt;mtime != dir.mtime || ((d-&gt;mode^mode) &amp; (DAPND|DLOCK|0777))) {
		if(wstatallow)			/* set to allow chmod during boot */
			break;
		if(d-&gt;uid == file-&gt;uid)
			break;
		if(leadgroup(file-&gt;uid, gid))
			break;
		if(leadgroup(file-&gt;uid, d-&gt;gid))
			break;
		error = Enotu;
		goto out;
	}
	d-&gt;mtime = dir.mtime;
	d-&gt;uid = uid;
	d-&gt;gid = gid;
	d-&gt;mode = (mode &amp; (DAPND|DLOCK|0777)) | (d-&gt;mode &amp; (DALLOC|DDIR));

	strncpy(d-&gt;name, dir.name, sizeof(d-&gt;name));
	accessdir(p, d, FWSTAT);

out:
	if(p != nil)
		putbuf(p);
	if(p1 != nil)
		putbuf(p1);
	if(file != nil)
		qunlock(file);

	return error;
}

static int
recv(Chan *c, uchar *buf, int n)
{
	int fd, m, len;

	fd = c-&gt;chan;
	/* read count */
	qlock(&amp;c-&gt;rlock);
	m = readn(fd, buf, BIT32SZ);
	if(m != BIT32SZ){
		qunlock(&amp;c-&gt;rlock);
		if(m &lt; 0){
			print("readn(BIT32SZ) fails: %r\n");
			return -1;
		}
		print("readn(BIT32SZ) returns %d: %r\n", m);
		return 0;
	}

	len = GBIT32(buf);
	if(len &lt;= BIT32SZ || len &gt; n){
		print("recv bad length %d\n", len);
		werrstr("bad length in 9P2000 message header");
		qunlock(&amp;c-&gt;rlock);
		return -1;
	}
	len -= BIT32SZ;
	m = readn(fd, buf+BIT32SZ, len);
	qunlock(&amp;c-&gt;rlock);
	if(m &lt; len){
		print("recv wanted %d got %d\n", len, m);
		return 0;
	}
	return BIT32SZ+m;
}

static void
send(Chan *c, uchar *buf, int n)
{
	int fd, m;

	fd = c-&gt;chan;
	qlock(&amp;c-&gt;wlock);
	m = write(fd, buf, n);
	qunlock(&amp;c-&gt;wlock);
	if(m == n)
		return;
	panic("write failed");
}

void
serve9p2(Chan *chan, uchar *ib, int nib)
{
	uchar inbuf[MSIZE+IOHDRSZ], outbuf[MSIZE+IOHDRSZ];
	Fcall f, r;
	char ename[64];
	int error, n, type;

	chan-&gt;msize = MSIZE;
	fmtinstall('F', fcallfmt);

	for(;;){
		if(nib){
			memmove(inbuf, ib, nib);
			n = nib;
			nib = 0;
		}else
			n = recv(chan, inbuf, sizeof inbuf);
		if(chat){
			print("read msg %d (fd %d)\n", n, chan-&gt;chan);
			if(n &lt;= 0)
				print("\terr: %r\n");
		}
		if(n == 0 &amp;&amp; (chan == cons.srvchan || chan == cons.chan))
			continue;
		if(n &lt;= 0)
			break;
		if(convM2S(inbuf, n, &amp;f) != n){
			print("9p2: cannot decode\n");
			continue;
		}

		type = f.type;
		if(type &lt; Tversion || type &gt;= Tmax || (type&amp;1) || type == Terror){
			print("9p2: bad message type %d\n", type);
			continue;
		}

		if(CHAT(chan))
			print("9p2: f %F\n", &amp;f);

		r.type = type+1;
		r.tag = f.tag;
		error = 0;

		rlock(&amp;mainlock);
		rlock(&amp;chan-&gt;reflock);
		switch(type){
		default:
			r.type = Rerror;
			snprint(ename, sizeof ename, "unknown message: %F", &amp;f);
			r.ename = ename;
			break;
		case Tversion:
			error = fsversion(chan, &amp;f, &amp;r);
			break;
		case Tauth:
			error = fsauth(chan, &amp;f, &amp;r);
			break;
		case Tattach:
			error = fsattach(chan, &amp;f, &amp;r);
			break;
		case Tflush:
			error = fsflush(chan, &amp;f, &amp;r);
			break;
		case Twalk:
			error = fswalk(chan, &amp;f, &amp;r);
			break;
		case Topen:
			error = fsopen(chan, &amp;f, &amp;r);
			break;
		case Tcreate:
			error = fscreate(chan, &amp;f, &amp;r);
			break;
		case Tread:
			r.data = (char*)inbuf;
			error = fsread(chan, &amp;f, &amp;r);
			break;
		case Twrite:
			error = fswrite(chan, &amp;f, &amp;r);
			break;
		case Tclunk:
			error = fsclunk(chan, &amp;f, &amp;r);
			break;
		case Tremove:
			error = fsremove(chan, &amp;f, &amp;r);
			break;
		case Tstat:
			error = fsstat(chan, &amp;f, &amp;r, inbuf);
			break;
		case Twstat:
			error = fswstat(chan, &amp;f, &amp;r, (char*)outbuf);
			break;
		}
		runlock(&amp;chan-&gt;reflock);
		runlock(&amp;mainlock);

		if(error != 0){
			r.type = Rerror;
			if(error &gt;= MAXERR){
				snprint(ename, sizeof(ename), "error %d", error);
				r.ename = ename;
			}
			else
				r.ename = errstring[error];
		}
		if(CHAT(chan))
			print("9p2: r %F\n", &amp;r);
	
		n = convS2M(&amp;r, outbuf, sizeof outbuf);
		if(n == 0){
			type = r.type;
			r.type = Rerror;
			snprint(ename, sizeof(ename), "9p2: convS2M: type %d", type);
			r.ename = ename;
			print(ename);
			n = convS2M(&amp;r, outbuf, sizeof outbuf);
			if(n == 0){
				/*
				 * What to do here, the failure notification failed?
				 */
				panic("can't write anything at all");
			}
		}
		send(chan, outbuf, n);
	}
	fileinit(chan);
	close(chan-&gt;chan);
	if(chan == cons.srvchan || chan == cons.chan)
		print("console chan read error");
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

