<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/dentry.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/dentry.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

Dentry*
getdir(Iobuf *p, int slot)
{
	Dentry *d;

	if(!p)
		return 0;
	d = (Dentry*)p-&gt;iobuf + slot%DIRPERBUF;
	return d;
}

void
accessdir(Iobuf *p, Dentry *d, int f)
{
	long t;

	if(p &amp;&amp; !isro(p-&gt;dev)) {
		if(!(f &amp; (FWRITE|FWSTAT)) &amp;&amp; noatime)
			return;
		t = time(nil);
		if(f &amp; (FREAD|FWRITE|FWSTAT)){
			d-&gt;atime = t;
			p-&gt;flags |= Bmod;
		}
		if(f &amp; FWRITE) {
			d-&gt;mtime = t;
			d-&gt;qid.version++;
			p-&gt;flags |= Bmod;
		}
	}
}

void
dbufread(Iobuf *p, Dentry *d, long a)
{
	USED(p, d, a);
}

long
rel2abs(Iobuf *p, Dentry *d, long a, int tag, int putb)
{
	long addr, qpath;
	Device dev;

	if(a &lt; 0) {
		print("dnodebuf: neg\n");
		return 0;
	}
	qpath = d-&gt;qid.path;
	dev = p-&gt;dev;
	if(a &lt; NDBLOCK) {
		addr = d-&gt;dblock[a];
		if(!addr &amp;&amp; tag) {
			addr = balloc(dev, tag, qpath);
			d-&gt;dblock[a] = addr;
			p-&gt;flags |= Bmod|Bimm;
		}
		if(putb)
			putbuf(p);
		return addr;
	}
	a -= NDBLOCK;
	if(a &lt; INDPERBUF) {
		addr = d-&gt;iblock;
		if(!addr &amp;&amp; tag) {
			addr = balloc(dev, Tind1, qpath);
			d-&gt;iblock = addr;
			p-&gt;flags |= Bmod|Bimm;
		}
		if(putb)
			putbuf(p);
		addr = indfetch(p, d, addr, a, Tind1, tag);
		return addr;
	}
	a -= INDPERBUF;
	if(a &lt; INDPERBUF2) {
		addr = d-&gt;diblock;
		if(!addr &amp;&amp; tag) {
			addr = balloc(dev, Tind2, qpath);
			d-&gt;diblock = addr;
			p-&gt;flags |= Bmod|Bimm;
		}
		if(putb)
			putbuf(p);
		addr = indfetch(p, d, addr, a/INDPERBUF, Tind2, Tind1);
		addr = indfetch(p, d, addr, a%INDPERBUF, Tind1, tag);
		return addr;
	}
	if(putb)
		putbuf(p);
	print("dnodebuf: trip indirect\n");
	return 0;
}

Iobuf*
dnodebuf(Iobuf *p, Dentry *d, long a, int tag)
{
	long addr;

	addr = rel2abs(p, d, a, tag, 0);
	if(addr)
		return getbuf(p-&gt;dev, addr, Bread);
	return 0;
}

/*
 * same as dnodebuf but it calls putpuf(p)
 * to reduce interference.
 */
Iobuf*
dnodebuf1(Iobuf *p, Dentry *d, long a, int tag)
{
	long addr;
	Device dev;

	dev = p-&gt;dev;
	addr = rel2abs(p, d, a, tag, 1);
	if(addr)
		return getbuf(dev, addr, Bread);
	return 0;

}

long
indfetch(Iobuf *p, Dentry *d, long addr, long a, int itag, int tag)
{
	Iobuf *bp;

	if(!addr)
		return 0;
	bp = getbuf(p-&gt;dev, addr, Bread);
	if(!bp || checktag(bp, itag, d-&gt;qid.path)) {
		if(!bp) {
			print("ind fetch bp = 0\n");
			return 0;
		}
		print("ind fetch tag\n");
		putbuf(bp);
		return 0;
	}
	addr = ((long*)bp-&gt;iobuf)[a];
	if(!addr &amp;&amp; tag) {
		addr = balloc(p-&gt;dev, tag, d-&gt;qid.path);
		if(addr) {
			((long*)bp-&gt;iobuf)[a] = addr;
			bp-&gt;flags |= Bmod;
			if(localfs || tag == Tdir)
				bp-&gt;flags |= Bimm;
			settag(bp, itag, d-&gt;qid.path);
		}
	}
	putbuf(bp);
	return addr;
}

void
dtrunc(Iobuf *p, Dentry *d)
{
	int i;

	bfree(p-&gt;dev, d-&gt;diblock, 2);
	d-&gt;diblock = 0;
	bfree(p-&gt;dev, d-&gt;iblock, 1);
	d-&gt;iblock = 0;
	for(i=NDBLOCK-1; i&gt;=0; i--) {
		bfree(p-&gt;dev, d-&gt;dblock[i], 0);
		d-&gt;dblock[i] = 0;
	}
	d-&gt;size = 0;
	p-&gt;flags |= Bmod|Bimm;
	accessdir(p, d, FWRITE);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

