<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/iobuf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/iobuf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

#define	DEBUG	0

long	niob;
long	nhiob;
Hiob	*hiob;

Iobuf*
getbuf(Device dev, long addr, int flag)
{
	Iobuf *p, *s;
	Hiob *hp;
	long h;

	if(DEBUG)
		print("getbuf %D(%ld) f=%x\n", dev, addr, flag);
	h = addr +
		dev.type*1009L +
		dev.ctrl*10007L +
		dev.unit*100003L +
		dev.part*1000003L;
	if(h &lt; 0)
		h = ~h;
	h %= nhiob;
	hp = &amp;hiob[h];

loop:
	lock(hp);

/*
 * look for it in the active list
 */
	s = hp-&gt;link;
	for(p=s;;) {
		if(p-&gt;addr == addr &amp;&amp; !devcmp(p-&gt;dev, dev)) {
			if(p != s) {
				p-&gt;back-&gt;fore = p-&gt;fore;
				p-&gt;fore-&gt;back = p-&gt;back;
				p-&gt;fore = s;
				p-&gt;back = s-&gt;back;
				s-&gt;back = p;
				p-&gt;back-&gt;fore = p;
				hp-&gt;link = p;
			}
			unlock(hp);
			qlock(p);
			if(p-&gt;addr != addr || devcmp(p-&gt;dev, dev)) {
				qunlock(p);
				goto loop;
			}
			p-&gt;flags |= flag;
			cons.bhit.count++;
			p-&gt;iobuf = p-&gt;xiobuf;
			return p;
		}
		p = p-&gt;fore;
		if(p == s)
			break;
	}
	if(flag &amp; Bprobe) {
		unlock(hp);
		return 0;
	}

/*
 * not found
 * take oldest unlocked entry in this queue
 */
xloop:
	p = s-&gt;back;
	if(!canqlock(p)) {
		if(p == hp-&gt;link) {
			unlock(hp);
			print("iobuf all locked\n");
			goto loop;
		}
		s = p;
		goto xloop;
	}
	/*
	 * its dangerous to flush the pseudo
	 * devices since they recursively call
	 * getbuf/putbuf. deadlock!
	 */
	if(p-&gt;flags &amp; Bres) {
		qunlock(p);
		if(p == hp-&gt;link) {
			unlock(hp);
			print("iobuf all resed\n");
			goto loop;
		}
		s = p;
		goto xloop;
	}
	if(p-&gt;flags &amp; Bmod) {
		unlock(hp);
		if(!devwrite(p-&gt;dev, p-&gt;addr, p-&gt;xiobuf))
			p-&gt;flags &amp;= ~(Bimm|Bmod);
		qunlock(p);
		goto loop;
	}
	hp-&gt;link = p;
	p-&gt;addr = addr;
	p-&gt;dev = dev;
	p-&gt;flags = flag;
	unlock(hp);
	p-&gt;iobuf = p-&gt;xiobuf;
	if(flag &amp; Bread) {
		if(devread(p-&gt;dev, p-&gt;addr, p-&gt;iobuf)) {
			p-&gt;flags = 0;
			p-&gt;dev = devnone;
			p-&gt;addr = -1;
			p-&gt;iobuf = (char*)-1;
			qunlock(p);
			return 0;
		}
		cons.bread.count++;
		return p;
	}
	cons.binit.count++;
	return p;
}

/*
 * syncblock tries to put out a block per hashline
 * returns 0 all done,
 * returns 1 if it missed something
 */
int
syncblock(void)
{
	Iobuf *p, *s, *q;
	Hiob *hp;
	long h;
	int flag;

	flag = 0;
	for(h=0; h&lt;nhiob; h++) {
		q = 0;
		hp = &amp;hiob[h];
		lock(hp);
		s = hp-&gt;link;
		for(p=s;;) {
			if(p-&gt;flags &amp; Bmod) {
				if(q)
					flag = 1;	/* more than 1 mod/line */
				q = p;
			}
			p = p-&gt;fore;
			if(p == s)
				break;
		}
		unlock(hp);
		if(q) {
			if(!canqlock(q)) {
				flag = 1;		/* missed -- was locked */
				continue;
			}
			if(!(q-&gt;flags &amp; Bmod)) {
				qunlock(q);
				continue;
			}
			if(!devwrite(q-&gt;dev, q-&gt;addr, q-&gt;xiobuf))
				q-&gt;flags &amp;= ~(Bmod|Bimm);
			qunlock(q);
		}
	}
	return flag;
}

void
sync(char *reason)
{
	long i;

	print("sync: %s\n", reason);
	for(i=10*nhiob; i&gt;0; i--)
		if(!syncblock())
			return;
	print("sync shorted\n");
}

void
putbuf(Iobuf *p)
{
	if(canqlock(p))
		print("buffer not locked %D(%ld)\n", p-&gt;dev, p-&gt;addr);
	if(p-&gt;flags &amp; Bimm) {
		if(!(p-&gt;flags &amp; Bmod))
			print("imm and no mod %D(%ld)\n", p-&gt;dev, p-&gt;addr);
		if(!devwrite(p-&gt;dev, p-&gt;addr, p-&gt;iobuf))
			p-&gt;flags &amp;= ~(Bmod|Bimm);
	}
	p-&gt;iobuf = (char*)-1;
	qunlock(p);
}

int
checktag(Iobuf *p, int tag, long qpath)
{
	Tag *t;

	t = (Tag*)(p-&gt;iobuf+BUFSIZE);
	if(t-&gt;tag != tag) {
		if(1 || CHAT(0))
			print("	tag = %G; expected %G; addr = %lud\n",
				t-&gt;tag, tag, p-&gt;addr);
		return 2;
	}
	if(qpath != QPNONE) {
		qpath &amp;= ~QPDIR;
		if(qpath != t-&gt;path) {
			if(qpath == (t-&gt;path&amp;~QPDIR))	/* old bug */
				return 0;
			if(1 || CHAT(0))
				print("	tag/path = %lux; expected %G/%lux\n",
					t-&gt;path, tag, qpath);
			return 1;
		}
	}
	return 0;
}

void
settag(Iobuf *p, int tag, long qpath)
{
	Tag *t;

	t = (Tag*)(p-&gt;iobuf+BUFSIZE);
	t-&gt;tag = tag;
	if(qpath != QPNONE)
		t-&gt;path = qpath &amp; ~QPDIR;
	p-&gt;flags |= Bmod;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

