<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/sub.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/sub.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

Lock wpathlock;

struct {
	Lock	flock;
	File*	ffree;		/* free file structures */
	Wpath*	wfree;
} suballoc;

enum{
	Finc=	128,	/* allocation chunksize for files */
	Fmax=	10000,	/* maximum file structures to be allocated */
	
	Winc=	8*128,	/* allocation chunksize for wpath */
	Wmax=	8*10000,	/* maximum wpath structures to be allocated */
};


Filsys*
fsstr(char *p)
{
	Filsys *fs;

	for(fs=filesys; fs-&gt;name; fs++)
		if(strcmp(fs-&gt;name, p) == 0)
			return fs;
	return 0;
}

void
fileinit(Chan *cp)
{
	File *f;
	Tlock *t;

loop:
	lock(&amp;cp-&gt;flock);
	f = cp-&gt;flist;
	if(!f) {
		unlock(&amp;cp-&gt;flock);
		return;
	}
	cp-&gt;flist = f-&gt;next;
	unlock(&amp;cp-&gt;flock);

	qlock(f);
	if(t = f-&gt;tlock) {
		t-&gt;time = 0;
		f-&gt;tlock = 0;
	}
	if(f-&gt;open &amp; FREMOV)
		doremove(f, 0);
	freewp(f-&gt;wpath);
	f-&gt;open = 0;
	f-&gt;cp = 0;
	qunlock(f);

	goto loop;
}

/*
 * returns a locked file structure
 */
File*
filep(Chan *cp, int fid, int flag)
{
	File *f, *prev;

	if(fid == NOF)
		return 0;

loop:
	lock(&amp;cp-&gt;flock);
	for(prev=0,f=cp-&gt;flist; f; prev=f,f=f-&gt;next) {
		if(f-&gt;fid != fid)
			continue;
		if(prev) {
			prev-&gt;next = f-&gt;next;
			f-&gt;next = cp-&gt;flist;
			cp-&gt;flist = f;
		}
		goto out;
	}
	if(flag) {
		f = newfp(cp);
		if(f) {
			f-&gt;fid = fid;
			goto out;
		}
	}
else print("cannot find %p.%d (list=%p)\n", cp, fid, cp-&gt;flist);
	unlock(&amp;cp-&gt;flock);
	return 0;

out:
	unlock(&amp;cp-&gt;flock);
	qlock(f);
	if(f-&gt;fid != fid) {
		qunlock(f);
		goto loop;
	}
	return f;
}

void
sublockinit(void)
{
	lock(&amp;suballoc.flock);
	lock(&amp;wpathlock);
	conf.nfile = 0;
	conf.nwpath = 0;
	unlock(&amp;suballoc.flock);
	unlock(&amp;wpathlock);
}	

/*
 * always called with cp-&gt;flock locked
 */
File*
newfp(Chan *cp)
{
	File *f, *e;

retry:
	lock(&amp;suballoc.flock);
	f = suballoc.ffree;
	if(f != nil){
		suballoc.ffree = f-&gt;list;
		unlock(&amp;suballoc.flock);
		f-&gt;list = 0;
		f-&gt;cp = cp;
		f-&gt;next = cp-&gt;flist;
		f-&gt;wpath = 0;
		f-&gt;tlock = 0;
		f-&gt;dslot = 0;
		f-&gt;doffset = 0;
		f-&gt;uid = 0;
		f-&gt;cuid = 0;
		cp-&gt;flist = f;
		return f;
	}
	unlock(&amp;suballoc.flock);

	if(conf.nfile &gt; Fmax){
		print("%d: out of files\n", cp-&gt;chan);
		return 0;
	}

	/*
	 *  create a few new files
	 */
	f = malloc(Finc*sizeof(*f));
	memset(f, 0, Finc*sizeof(*f));
	lock(&amp;suballoc.flock);
	for(e = f+Finc; f &lt; e; f++){
		qlock(f);
		qunlock(f);
		f-&gt;list = suballoc.ffree;
		suballoc.ffree = f;
	}
	conf.nfile += Finc;
	unlock(&amp;suballoc.flock);
	goto retry;
}

void
freefp(File *fp)
{
	Chan *cp;
	File *f, *prev;

	if(!fp || !(cp = fp-&gt;cp))
		return;
	authfree(fp);
	lock(&amp;cp-&gt;flock);
	for(prev=0,f=cp-&gt;flist; f; prev=f,f=f-&gt;next) {
		if(f != fp)
			continue;
		if(prev)
			prev-&gt;next = f-&gt;next;
		else
			cp-&gt;flist = f-&gt;next;
		f-&gt;cp = 0;
		lock(&amp;suballoc.flock);
		f-&gt;list = suballoc.ffree;
		suballoc.ffree = f;
		unlock(&amp;suballoc.flock);
		break;
	}
	unlock(&amp;cp-&gt;flock);
}

Wpath*
newwp(void)
{
	Wpath *w, *e;

retry:
	lock(&amp;wpathlock);
	w = suballoc.wfree;
	if(w != nil){
		suballoc.wfree = w-&gt;list;
		unlock(&amp;wpathlock);
		memset(w, 0, sizeof(*w));
		w-&gt;refs = 1;
		w-&gt;up = 0;
		return w;
	}
	unlock(&amp;wpathlock);

	if(conf.nwpath &gt; Wmax){
		print("out of wpaths\n");
		return 0;
	}

	/*
	 *  create a few new wpaths
	 */
	w = malloc(Winc*sizeof(*w));
	memset(w, 0, Winc*sizeof(*w));
	lock(&amp;wpathlock);
	for(e = w+Winc; w &lt; e; w++){
		w-&gt;list = suballoc.wfree;
		suballoc.wfree = w;
	}
	conf.nwpath += Winc;
	unlock(&amp;wpathlock);
	goto retry;
}

/*
 *  increment the references for the whole path
 */
Wpath*
getwp(Wpath *w)
{
	Wpath *nw;

	lock(&amp;wpathlock);
	for(nw = w; nw; nw=nw-&gt;up)
		nw-&gt;refs++;
	unlock(&amp;wpathlock);
	return w;
}

/*
 *  decrement the reference for each element of the path
 */
void
freewp(Wpath *w)
{
	lock(&amp;wpathlock);
	for(; w; w=w-&gt;up){
		w-&gt;refs--;
		if(w-&gt;refs == 0){
			w-&gt;list = suballoc.wfree;
			suballoc.wfree = w;
		}
	}
	unlock(&amp;wpathlock);
}

/*
 *  decrement the reference for just this element
 */
void
putwp(Wpath *w)
{
	lock(&amp;wpathlock);
	w-&gt;refs--;
	if(w-&gt;refs == 0){
		w-&gt;list = suballoc.wfree;
		suballoc.wfree = w;
	}
	unlock(&amp;wpathlock);
}

int
iaccess(File *f, Dentry *d, int m)
{
	if(wstatallow)
		return 0;

	/*
	 * owner is next
	 */
	if(f-&gt;uid == d-&gt;uid)
		if((m&lt;&lt;6) &amp; d-&gt;mode)
			return 0;
	/*
	 * group membership is hard
	 */
	if(ingroup(f-&gt;uid, d-&gt;gid))
		if((m&lt;&lt;3) &amp; d-&gt;mode)
			return 0;
	/*
	 * other access for everyone except members of group 9999
	 */
	if(m &amp; d-&gt;mode){
		/* 
		 *  walk directories regardless.
		 *  otherwise its impossible to get
		 *  from the root to noworld's directories.
		 */
		if((d-&gt;mode &amp; DDIR) &amp;&amp; (m == DEXEC))
			return 0;
		if(!ingroup(f-&gt;uid, 9999))
			return 0;
	}
	return 1;
}

Tlock*
tlocked(Iobuf *p, Dentry *d)
{
	Tlock *t, *t1;
	long qpath, tim;
	Device dev;

	tim = time(0);
	qpath = d-&gt;qid.path;
	dev = p-&gt;dev;
	t1 = 0;
	for(t=tlocks+NTLOCK-1; t&gt;=tlocks; t--) {
		if(t-&gt;qpath == qpath)
		if(t-&gt;time &gt;= tim)
		if(devcmp(t-&gt;dev, dev) == 0)
			return 0;		/* its locked */
		if(!t1 &amp;&amp; t-&gt;time &lt; tim)
			t1 = t;			/* steal first lock */
	}
	if(t1) {
		t1-&gt;dev = dev;
		t1-&gt;qpath = qpath;
		t1-&gt;time = tim + TLOCK;
	}
	/* botch
	 * out of tlock nodes simulates
	 * a locked file
	 */
	return t1;
}

Qid
newqid(Device dev)
{
	Iobuf *p;
	Superb *sb;
	Qid qid;

	p = getbuf(dev, superaddr(dev), Bread|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER))
		panic("newqid: super block");
	sb = (Superb*)p-&gt;iobuf;
	sb-&gt;qidgen++;
	qid.path = sb-&gt;qidgen;
	qid.vers = 0;
	qid.type = 0;
	putbuf(p);
	return qid;
}

/*
 * what are legal characters in a name?
 * only disallow control characters.
 * a) utf avoids control characters.
 * b) '/' may not be the separator
 */
int
checkname(char *n)
{
	int i, c;

	for(i=0; i&lt;NAMELEN; i++) {
		c = *n &amp; 0xff;
		if(c == 0) {
			if(i == 0)
				return 1;
			memset(n, 0, NAMELEN-i);
			return 0;
		}
		if(c &lt;= 040)
			return 1;
		n++;
	}
	return 1;	/* too long */
}

void
bfree(Device dev, long addr, int d)
{
	Iobuf *p;
	long a;
	int i;

	if(!addr)
		return;
	if(d &gt; 0) {
		d--;
		p = getbuf(dev, addr, Bread);
		if(p) {
			for(i=INDPERBUF-1; i&gt;=0; i--) {
				a = ((long*)p-&gt;iobuf)[i];
				bfree(dev, a, d);
			}
			putbuf(p);
		}
	}
	/*
	 * stop outstanding i/o
	 */
	p = getbuf(dev, addr, Bprobe);
	if(p) {
		p-&gt;flags &amp;= ~(Bmod|Bimm);
		putbuf(p);
	}
	/*
	 * dont put written worm
	 * blocks into free list
	 */
	if(nofree(dev, addr))
		return;
	p = getbuf(dev, superaddr(dev), Bread|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER))
		panic("bfree: super block");
	addfree(dev, addr, (Superb*)p-&gt;iobuf);
	putbuf(p);
}

long
balloc(Device dev, int tag, long qid)
{
	Iobuf *bp, *p;
	Superb *sb;
	long a;
	int n;

	p = getbuf(dev, superaddr(dev), Bread|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER))
		panic("balloc: super block");
	sb = (Superb*)p-&gt;iobuf;

loop:
	n = --sb-&gt;fbuf.nfree;
	sb-&gt;tfree--;
	if(n &lt; 0 || n &gt;= FEPERBUF)
		panic("balloc: bad freelist");
	a = sb-&gt;fbuf.free[n];
	if(n &lt;= 0) {
		if(a == 0) {
			sb-&gt;tfree = 0;
			sb-&gt;fbuf.nfree = 1;
			if(devgrow(dev, sb))
				goto loop;
			putbuf(p);
			return 0;
		}
		bp = getbuf(dev, a, Bread);
		if(!bp || checktag(bp, Tfree, QPNONE)) {
			if(bp)
				putbuf(bp);
			putbuf(p);
			return 0;
		}
		memmove(&amp;sb-&gt;fbuf, bp-&gt;iobuf, (FEPERBUF+1)*sizeof(long));
		putbuf(bp);
	}
	bp = getbuf(dev, a, Bmod);
	memset(bp-&gt;iobuf, 0, RBUFSIZE);
	settag(bp, tag, qid);
	if(tag == Tind1 || tag == Tind2 || tag == Tdir)
		bp-&gt;flags |= Bimm;
	putbuf(bp);
	putbuf(p);
	return a;
}

void
addfree(Device dev, long addr, Superb *sb)
{
	int n;
	Iobuf *p;

	if(addr &gt;= sb-&gt;fsize){
		print("addfree: bad addr %lux\n", addr);
		return;
	}
	n = sb-&gt;fbuf.nfree;
	if(n &lt; 0 || n &gt; FEPERBUF)
		panic("addfree: bad freelist");
	if(n &gt;= FEPERBUF) {
		p = getbuf(dev, addr, Bmod);
		if(p == 0)
			panic("addfree: getbuf");
		memmove(p-&gt;iobuf, &amp;sb-&gt;fbuf, (FEPERBUF+1)*sizeof(long));
		settag(p, Tfree, QPNONE);
		putbuf(p);
		n = 0;
	}
	sb-&gt;fbuf.free[n++] = addr;
	sb-&gt;fbuf.nfree = n;
	sb-&gt;tfree++;
	if(addr &gt;= sb-&gt;fsize)
		sb-&gt;fsize = addr+1;
}

int
Cfmt(Fmt *f1)
{
	Chan *cp;

	cp = va_arg(f1-&gt;args, Chan*);
	return fmtprint(f1, "C%d.%.3d", cp-&gt;type, cp-&gt;chan);
}

int
Dfmt(Fmt *f1)
{
	Device d;

	d = va_arg(f1-&gt;args, Device);
	return fmtprint(f1, "D%d.%d.%d.%d", d.type, d.ctrl, d.unit, d.part);
}

int
Afmt(Fmt *f1)
{
	Filta a;

	a = va_arg(f1-&gt;args, Filta);
	return fmtprint(f1, "%6lud %6lud %6lud",
		fdf(a.f-&gt;filter[0], a.scale*60),
		fdf(a.f-&gt;filter[1], a.scale*600),
		fdf(a.f-&gt;filter[2], a.scale*6000));
}

int
Gfmt(Fmt *f1)
{
	int t;

	t = va_arg(f1-&gt;args, int);
	if(t &gt;= 0 &amp;&amp; t &lt; MAXTAG)
		return fmtstrcpy(f1, tagnames[t]);
	else
		return fmtprint(f1, "&lt;badtag %d&gt;", t);
}

void
formatinit(void)
{

	fmtinstall('C', Cfmt);	/* print channels */
	fmtinstall('D', Dfmt);	/* print devices */
	fmtinstall('A', Afmt);	/* print filters */
	fmtinstall('G', Gfmt);	/* print tags */
	fmtinstall('T', Tfmt);	/* print times */
	fmtinstall('O', ofcallfmt);	/* print old fcalls */
}
int
devcmp(Device d1, Device d2)
{

	if(d1.type == d2.type)
	if(d1.ctrl == d2.ctrl)
	if(d1.unit == d2.unit)
	if(d1.part == d2.part)
		return 0;
	return 1;
}

void
rootream(Device dev, long addr)
{
	Iobuf *p;
	Dentry *d;

	p = getbuf(dev, addr, Bmod|Bimm);
	memset(p-&gt;iobuf, 0, RBUFSIZE);
	settag(p, Tdir, QPROOT);
	d = getdir(p, 0);
	strcpy(d-&gt;name, "/");
	d-&gt;uid = -1;
	d-&gt;gid = -1;
	d-&gt;mode = DALLOC | DDIR |
		((DREAD|DWRITE|DEXEC) &lt;&lt; 6) |
		((DREAD|DWRITE|DEXEC) &lt;&lt; 3) |
		((DREAD|DWRITE|DEXEC) &lt;&lt; 0);
	d-&gt;qid = QID9P1(QPROOT|QPDIR,0);
	d-&gt;atime = time(0);
	d-&gt;mtime = d-&gt;atime;
	putbuf(p);
}

int
superok(Device dev, long addr, int set)
{
	Iobuf *p;
	Superb *s;
	int ok;

	p = getbuf(dev, addr, Bread|Bmod|Bimm);
	s = (Superb*)p-&gt;iobuf;
	ok = s-&gt;fsok;
	s-&gt;fsok = set;
	putbuf(p);
	return ok;
}

void
superream(Device dev, long addr)
{
	Iobuf *p;
	Superb *s;
	long i;

	p = getbuf(dev, addr, Bmod|Bimm);
	memset(p-&gt;iobuf, 0, RBUFSIZE);
	settag(p, Tsuper, QPSUPER);

	s = (Superb*)p-&gt;iobuf;
	s-&gt;fstart = 1;
	s-&gt;fsize = devsize(dev);
	s-&gt;fbuf.nfree = 1;
	s-&gt;qidgen = 10;
	for(i=s-&gt;fsize-1; i&gt;=addr+2; i--)
		addfree(dev, i, s);
	putbuf(p);
}

/*
 * returns 1 if n is prime
 * used for adjusting lengths
 * of hashing things.
 * there is no need to be clever
 */
int
prime(long n)
{
	long i;

	if((n%2) == 0)
		return 0;
	for(i=3;; i+=2) {
		if((n%i) == 0)
			return 0;
		if(i*i &gt;= n)
			return 1;
	}
}

void
hexdump(void *a, int n)
{
	char s1[30], s2[4];
	uchar *p;
	int i;

	p = a;
	s1[0] = 0;
	for(i=0; i&lt;n; i++) {
		sprint(s2, " %.2ux", p[i]);
		strcat(s1, s2);
		if((i&amp;7) == 7) {
			print("%s\n", s1);
			s1[0] = 0;
		}
	}
	if(s1[0])
		print("%s\n", s1);
}

long
qidpathgen(Device *dev)
{
	Iobuf *p;
	Superb *sb;
	long path;

	p = getbuf(*dev, superaddr((*dev)), Bread|Bmod);
	if(!p || checktag(p, Tsuper, QPSUPER))
		panic("newqid: super block");
	sb = (Superb*)p-&gt;iobuf;
	sb-&gt;qidgen++;
	path = sb-&gt;qidgen;
	putbuf(p);
	return path;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

