<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/partfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/partfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * partfs - serve an underlying file, with devsd-style partitions
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

typedef struct Part Part;
struct Part
{
	int	inuse;
	int	vers;
	ulong	mode;
	char	*name;
	vlong	offset;		/* in sectors */
	vlong	length;		/* in sectors */
};

enum
{
	Qroot = 0,
	Qdir,
	Qctl,
	Qpart,
};

int fd = -1, ctlfd = -1;
int rdonly;
ulong ctlmode = 0666;
ulong time0;
vlong nsect, sectsize;

char *inquiry = "partfs hard drive";
char *sdname = "sdXX";
Part tab[64];

char*
ctlstring(void)
{
	Part *p;
	Fmt fmt;

	fmtstrinit(&amp;fmt);
	fmtprint(&amp;fmt, "inquiry %s\n", inquiry);
	fmtprint(&amp;fmt, "geometry %lld %lld\n", nsect, sectsize);
	for (p = tab; p &lt; tab + nelem(tab); p++)
		if (p-&gt;inuse)
			fmtprint(&amp;fmt, "part %s %lld %lld\n",
				p-&gt;name, p-&gt;offset, p-&gt;length);
	return fmtstrflush(&amp;fmt);
}

int
addpart(char *name, vlong start, vlong end)
{
	Part *p;

	if(start &lt; 0 || start &gt; end || end &gt; nsect){
		werrstr("bad partition boundaries");
		return -1;
	}

	if (strcmp(name, "ctl") == 0 || strcmp(name, "data") == 0) {
		werrstr("partition name already in use");
		return -1;
	}
	for (p = tab; p &lt; tab + nelem(tab) &amp;&amp; p-&gt;inuse; p++)
		if (strcmp(p-&gt;name, name) == 0) {
			werrstr("partition name already in use");
			return -1;
		}
	if(p == tab + nelem(tab)){
		werrstr("no free partition slots");
		return -1;
	}

	p-&gt;inuse = 1;
	free(p-&gt;name);
	p-&gt;name = estrdup9p(name);
	p-&gt;offset = start;
	p-&gt;length = end - start;
	p-&gt;mode = ctlmode;
	p-&gt;vers++;
	return 0;
}

int
delpart(char *s)
{
	Part *p;

	for (p = tab; p &lt; tab + nelem(tab); p++)
		if(p-&gt;inuse &amp;&amp; strcmp(p-&gt;name, s) == 0)
			break;
	if(p == tab + nelem(tab)){
		werrstr("partition not found");
		return -1;
	}

	p-&gt;inuse = 0;
	free(p-&gt;name);
	p-&gt;name = nil;
	return 0;
}

static void
addparts(char *buf)
{
	char *f[4], *p, *q;

	/*
	 * Use partitions passed from boot program,
	 * e.g.
	 *	sdC0part=dos 63 123123/plan9 123123 456456
	 * This happens before /boot sets hostname so the
	 * partitions will have the null-string for user.
	 */
	for(p = buf; p != nil; p = q){
		if(q = strchr(p, '/'))
			*q++ = '\0';
		if(tokenize(p, f, nelem(f)) &gt;= 3 &amp;&amp;
		    addpart(f[0], strtoull(f[1], 0, 0), strtoull(f[2], 0, 0)) &lt; 0)
			fprint(2, "%s: addpart %s: %r\n", argv0, f[0]);
	}
}

static void
ctlwrite0(Req *r, char *msg, Cmdbuf *cb)
{
	vlong start, end;
	Part *p;

	r-&gt;ofcall.count = r-&gt;ifcall.count;

	if(cb-&gt;nf &lt; 1){
		respond(r, "empty control message");
		return;
	}

	if(strcmp(cb-&gt;f[0], "part") == 0){
		if(cb-&gt;nf != 4){
			respondcmderror(r, cb, "part takes 3 args");
			return;
		}
		start = strtoll(cb-&gt;f[2], 0, 0);
		end = strtoll(cb-&gt;f[3], 0, 0);
		if(addpart(cb-&gt;f[1], start, end) &lt; 0){
			respondcmderror(r, cb, "%r");
			return;
		}
	}
	else if(strcmp(cb-&gt;f[0], "delpart") == 0){
		if(cb-&gt;nf != 2){
			respondcmderror(r, cb, "delpart takes 1 arg");
			return;
		}
		if(delpart(cb-&gt;f[1]) &lt; 0){
			respondcmderror(r, cb, "%r");
			return;
		}
	}
	else if(strcmp(cb-&gt;f[0], "inquiry") == 0){
		if(cb-&gt;nf != 2){
			respondcmderror(r, cb, "inquiry takes 1 arg");
			return;
		}
		free(inquiry);
		inquiry = estrdup9p(cb-&gt;f[1]);
	}
	else if(strcmp(cb-&gt;f[0], "geometry") == 0){
		if(cb-&gt;nf != 3){
			respondcmderror(r, cb, "geometry takes 2 args");
			return;
		}
		nsect = strtoll(cb-&gt;f[1], 0, 0);
		sectsize = strtoll(cb-&gt;f[2], 0, 0);
		if(tab[0].inuse &amp;&amp; strcmp(tab[0].name, "data") == 0 &amp;&amp;
		    tab[0].vers == 0){
			tab[0].offset = 0;
			tab[0].length = nsect;
		}
		for(p = tab; p &lt; tab + nelem(tab); p++)
			if(p-&gt;inuse &amp;&amp; p-&gt;offset + p-&gt;length &gt; nsect){
				p-&gt;inuse = 0;
				free(p-&gt;name);
				p-&gt;name = nil;
			}
	} else
		/* pass through to underlying ctl file, if any */
		if (write(ctlfd, msg, r-&gt;ifcall.count) != r-&gt;ifcall.count) {
			respondcmderror(r, cb, "%r");
			return;
		}
	respond(r, nil);
}

void
ctlwrite(Req *r)
{
	char *msg;
	Cmdbuf *cb;

	r-&gt;ofcall.count = r-&gt;ifcall.count;

	msg = emalloc9p(r-&gt;ifcall.count+1);
	memmove(msg, r-&gt;ifcall.data, r-&gt;ifcall.count);
	msg[r-&gt;ifcall.count] = '\0';

	cb = parsecmd(r-&gt;ifcall.data, r-&gt;ifcall.count);
	ctlwrite0(r, msg, cb);

	free(cb);
	free(msg);
}

int
rootgen(int off, Dir *d, void*)
{
	memset(d, 0, sizeof *d);
	d-&gt;atime = time0;
	d-&gt;mtime = time0;
	if(off == 0){
		d-&gt;name = estrdup9p(sdname);
		d-&gt;mode = DMDIR|0777;
		d-&gt;qid.path = Qdir;
		d-&gt;qid.type = QTDIR;
		d-&gt;uid = estrdup9p("partfs");
		d-&gt;gid = estrdup9p("partfs");
		d-&gt;muid = estrdup9p("");
		return 0;
	}
	return -1;
}

int
dirgen(int off, Dir *d, void*)
{
	int n;
	Part *p;

	memset(d, 0, sizeof *d);
	d-&gt;atime = time0;
	d-&gt;mtime = time0;
	if(off == 0){
		d-&gt;name = estrdup9p("ctl");
		d-&gt;mode = ctlmode;
		d-&gt;qid.path = Qctl;
		goto Have;
	}

	off--;
	n = 0;
	for(p = tab; p &lt; tab + nelem(tab); p++, n++){
		if(!p-&gt;inuse)
			continue;
		if(n == off){
			d-&gt;name = estrdup9p(p-&gt;name);
			d-&gt;length = p-&gt;length*sectsize;
			d-&gt;mode = p-&gt;mode;
			d-&gt;qid.path = Qpart + p - tab;
			d-&gt;qid.vers = p-&gt;vers;
			goto Have;
		}
	}
	return -1;

Have:
	d-&gt;uid = estrdup9p("partfs");
	d-&gt;gid = estrdup9p("partfs");
	d-&gt;muid = estrdup9p("");
	return 0;
}

int
rdwrpart(Req *r)
{
	int q;
	long count, tot;
	vlong offset;
	uchar *dat;
	Part *p;

	q = r-&gt;fid-&gt;qid.path - Qpart;
	if(q &lt; 0 || q &gt; nelem(tab) || !tab[q].inuse ||
	    tab[q].vers != r-&gt;fid-&gt;qid.vers){
		respond(r, "unknown partition");
		return -1;
	}
	p = &amp;tab[q];

	offset = r-&gt;ifcall.offset;
	count = r-&gt;ifcall.count;
	if(offset &lt; 0){
		respond(r, "negative offset");
		return -1;
	}
	if(count &lt; 0){
		respond(r, "negative count");
		return -1;
	}
	if(offset &gt; p-&gt;length*sectsize){
		respond(r, "offset past end of partition");
		return -1;
	}
	if(offset+count &gt; p-&gt;length*sectsize)
		count = p-&gt;length*sectsize - offset;
	offset += p-&gt;offset*sectsize;

	if(r-&gt;ifcall.type == Tread)
		dat = (uchar*)r-&gt;ofcall.data;
	else
		dat = (uchar*)r-&gt;ifcall.data;

	/* pass i/o through to underlying file */
	seek(fd, offset, 0);
	if (r-&gt;ifcall.type == Twrite) {
		tot = write(fd, dat, count);
		if (tot != count) {
			respond(r, "%r");
			return -1;
		}
	} else {
		tot = read(fd, dat, count);
		if (tot &lt; 0) {
			respond(r, "%r");
			return -1;
		}
	}
	r-&gt;ofcall.count = tot;
	respond(r, nil);
	return 0;
}

void
fsread(Req *r)
{
	char *s;

	switch((int)r-&gt;fid-&gt;qid.path){
	case Qroot:
		dirread9p(r, rootgen, nil);
		break;
	case Qdir:
		dirread9p(r, dirgen, nil);
		break;
	case Qctl:
		s = ctlstring();
		readstr(r, s);
		free(s);
		break;
	default:
		rdwrpart(r);
		return;
	}
	respond(r, nil);
}

void
fswrite(Req *r)
{
	switch((int)r-&gt;fid-&gt;qid.path){
	case Qroot:
	case Qdir:
		respond(r, "write to a directory?");
		break;
	case Qctl:
		ctlwrite(r);
		break;
	default:
		rdwrpart(r);
		break;
	}
}

void
fsopen(Req *r)
{
	if(r-&gt;ifcall.mode&amp;ORCLOSE)
		respond(r, "cannot open ORCLOSE");

	switch((int)r-&gt;fid-&gt;qid.path){
	case Qroot:
	case Qdir:
		if(r-&gt;ifcall.mode != OREAD){
			respond(r, "bad mode for directory open");
			return;
		}
	}

	respond(r, nil);
}

void
fsstat(Req *r)
{
	int q;
	Dir *d;
	Part *p;

	d = &amp;r-&gt;d;
	memset(d, 0, sizeof *d);
	d-&gt;qid = r-&gt;fid-&gt;qid;
	d-&gt;atime = d-&gt;mtime = time0;
	q = r-&gt;fid-&gt;qid.path;
	switch(q){
	case Qroot:
		d-&gt;name = estrdup9p("/");
		d-&gt;mode = DMDIR|0777;
		break;

	case Qdir:
		d-&gt;name = estrdup9p(sdname);
		d-&gt;mode = DMDIR|0777;
		break;

	case Qctl:
		d-&gt;name = estrdup9p("ctl");
		d-&gt;mode = 0666;
		break;

	default:
		q -= Qpart;
		if(q &lt; 0 || q &gt; nelem(tab) || tab[q].inuse == 0 ||
		    r-&gt;fid-&gt;qid.vers != tab[q].vers){
			respond(r, "partition no longer exists");
			return;
		}
		p = &amp;tab[q];
		d-&gt;name = estrdup9p(p-&gt;name);
		d-&gt;length = p-&gt;length * sectsize;
		d-&gt;mode = p-&gt;mode;
		break;
	}

	d-&gt;uid = estrdup9p("partfs");
	d-&gt;gid = estrdup9p("partfs");
	d-&gt;muid = estrdup9p("");
	respond(r, nil);
}

void
fsattach(Req *r)
{
	char *spec;

	spec = r-&gt;ifcall.aname;
	if(spec &amp;&amp; spec[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;ofcall.qid = (Qid){Qroot, 0, QTDIR};
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	respond(r, nil);
}

char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	Part *p;

	switch((int)fid-&gt;qid.path){
	case Qroot:
		if(strcmp(name, sdname) == 0){
			fid-&gt;qid.path = Qdir;
			fid-&gt;qid.type = QTDIR;
			*qid = fid-&gt;qid;
			return nil;
		}
		break;
	case Qdir:
		if(strcmp(name, "ctl") == 0){
			fid-&gt;qid.path = Qctl;
			fid-&gt;qid.vers = 0;
			fid-&gt;qid.type = 0;
			*qid = fid-&gt;qid;
			return nil;
		}
		for(p = tab; p &lt; tab + nelem(tab); p++)
			if(p-&gt;inuse &amp;&amp; strcmp(p-&gt;name, name) == 0){
				fid-&gt;qid.path = p - tab + Qpart;
				fid-&gt;qid.vers = p-&gt;vers;
				fid-&gt;qid.type = 0;
				*qid = fid-&gt;qid;
				return nil;
			}
		break;
	}
	return "file not found";
}

Srv fs = {
	.attach=fsattach,
	.open=	fsopen,
	.read=	fsread,
	.write=	fswrite,
	.stat=	fsstat,
	.walk1=	fswalk1,
};

char *mtpt = "/dev";
char *srvname;

void
usage(void)
{
	fprint(2, "usage: %s [-Dr] [-d sdname] [-m mtpt] [-p 9parts] "
		"[-s srvname] diskimage\n", argv0);
	fprint(2, "\tdefault mtpt is /dev\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int isdir;
	char *file, *cname, *parts;
	Dir *dir;

	quotefmtinstall();
	time0 = time(0);
	parts = nil;

	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'd':
		sdname = EARGF(usage());
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	case 'p':
		parts = EARGF(usage());
		break;
	case 'r':
		rdonly = 1;
		break;
	case 's':
		srvname = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(argc != 1)
		usage();
	file = argv[0];
	dir = dirstat(file);
	if(!dir)
		sysfatal("%s: %r", file);
	isdir = (dir-&gt;mode &amp; DMDIR) != 0;
	free(dir);

	if (isdir) {
		cname = smprint("%s/ctl", file);
		if ((ctlfd = open(cname, ORDWR)) &lt; 0)
			sysfatal("open %s: %r", cname);
		file = smprint("%s/data", file);
	}
	if((fd = open(file, rdonly? OREAD: ORDWR)) &lt; 0)
		sysfatal("open %s: %r", file);

	sectsize = 512;			/* conventional */
	dir = dirfstat(fd);
	if (dir)
		nsect = dir-&gt;length / sectsize;
	free(dir);

	inquiry = estrdup9p(inquiry);
	tab[0].inuse = 1;
	tab[0].name = estrdup9p("data");
	tab[0].mode = 0666;
	tab[0].length = nsect;

	/*
	 * hack for booting from usb: add 9load partitions.
	 */
	if(parts != nil)
		addparts(parts);

	postmountsrv(&amp;fs, srvname, mtpt, MBEFORE);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

