<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/rd9660.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/rd9660.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * dump a 9660 cd image for a little while.
 * for debugging.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;disk.h&gt;

Biobuf *b;

#pragma varargck type "s" uchar*
#pragma varargck type "L" uchar*
#pragma varargck type "B" uchar*
#pragma varargck type "N" uchar*
#pragma varargck type "T" uchar*
#pragma varargck type "D" uchar*

typedef struct Voldesc Voldesc;
struct Voldesc {
	uchar	magic[8];	/* 0x01, "CD001", 0x01, 0x00 */
	uchar	systemid[32];	/* system identifier */
	uchar	volumeid[32];	/* volume identifier */
	uchar	unused[8];	/* character set in secondary desc */
	uchar	volsize[8];	/* volume size */
	uchar	charset[32];
	uchar	volsetsize[4];	/* volume set size = 1 */
	uchar	volseqnum[4];	/* volume sequence number = 1 */
	uchar	blocksize[4];	/* logical block size */
	uchar	pathsize[8];	/* path table size */
	uchar	lpathloc[4];	/* Lpath */
	uchar	olpathloc[4];	/* optional Lpath */
	uchar	mpathloc[4];	/* Mpath */
	uchar	ompathloc[4];	/* optional Mpath */
	uchar	rootdir[34];	/* root directory */
	uchar	volsetid[128];	/* volume set identifier */
	uchar	publisher[128];
	uchar	prepid[128];	/* data preparer identifier */
	uchar	applid[128];	/* application identifier */
	uchar	notice[37];	/* copyright notice file */
	uchar	abstract[37];	/* abstract file */
	uchar	biblio[37];	/* bibliographic file */
	uchar	cdate[17];	/* creation date */
	uchar	mdate[17];	/* modification date */
	uchar	xdate[17];	/* expiration date */
	uchar	edate[17];	/* effective date */
	uchar	fsvers;		/* file system version = 1 */
};

void
dumpbootvol(void *a)
{
	Voldesc *v;

	v = a;
	print("magic %.2ux %.5s %.2ux %2ux\n",
		v-&gt;magic[0], v-&gt;magic+1, v-&gt;magic[6], v-&gt;magic[7]);
	if(v-&gt;magic[0] == 0xFF)
		return;

	print("system %.32T\n", v-&gt;systemid);
	print("volume %.32T\n", v-&gt;volumeid);
	print("volume size %.4N\n", v-&gt;volsize);
	print("charset %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux\n",
		v-&gt;charset[0], v-&gt;charset[1], v-&gt;charset[2], v-&gt;charset[3],
		v-&gt;charset[4], v-&gt;charset[5], v-&gt;charset[6], v-&gt;charset[7]);
	print("volume set size %.2N\n", v-&gt;volsetsize);
	print("volume sequence number %.2N\n", v-&gt;volseqnum);
	print("logical block size %.2N\n", v-&gt;blocksize);
	print("path size %.4L\n", v-&gt;pathsize);
	print("lpath loc %.4L\n", v-&gt;lpathloc);
	print("opt lpath loc %.4L\n", v-&gt;olpathloc);
	print("mpath loc %.4B\n", v-&gt;mpathloc);
	print("opt mpath loc %.4B\n", v-&gt;ompathloc);
	print("rootdir %D\n", v-&gt;rootdir);
	print("volume set identifier %.128T\n", v-&gt;volsetid);
	print("publisher %.128T\n", v-&gt;publisher);
	print("preparer %.128T\n", v-&gt;prepid);
	print("application %.128T\n", v-&gt;applid);
	print("notice %.37T\n", v-&gt;notice);
	print("abstract %.37T\n", v-&gt;abstract);
	print("biblio %.37T\n", v-&gt;biblio);
	print("creation date %.17s\n", v-&gt;cdate);
	print("modification date %.17s\n", v-&gt;mdate);
	print("expiration date %.17s\n", v-&gt;xdate);
	print("effective date %.17s\n", v-&gt;edate);
	print("fs version %d\n", v-&gt;fsvers);
}

typedef struct Cdir Cdir;
struct Cdir {
	uchar	len;
	uchar	xlen;
	uchar	dloc[8];
	uchar	dlen[8];
	uchar	date[7];
	uchar	flags;
	uchar	unitsize;
	uchar	gapsize;
	uchar	volseqnum[4];
	uchar	namelen;
	uchar	name[1];	/* chumminess */
};
#pragma varargck type "D" Cdir*

int
Dfmt(Fmt *fmt)
{
	char buf[128];
	Cdir *c;

	c = va_arg(fmt-&gt;args, Cdir*);
	if(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\0' || c-&gt;name[0] == '\001') {
		snprint(buf, sizeof buf, ".%s dloc %.4N dlen %.4N",
			c-&gt;name[0] ? "." : "", c-&gt;dloc, c-&gt;dlen);
	} else {
		snprint(buf, sizeof buf, "%.*T dloc %.4N dlen %.4N", c-&gt;namelen, c-&gt;name,
			c-&gt;dloc, c-&gt;dlen);
	}
	fmtstrcpy(fmt, buf);
	return 0;
}

typedef struct Path Path;
struct Path {
	uchar	namelen;
	uchar	xlen;
	uchar	dloc[4];
	uchar	parent[2];
	uchar	name[1];	/* chumminess */
};
#pragma varargck type "P" Path*

char longc, shortc;
void
bigend(void)
{
	longc = 'B';
}

void
littleend(void)
{
	longc = 'L';
}

int
Pfmt(Fmt *fmt)
{
	char xfmt[128], buf[128];
	Path *p;

	p = va_arg(fmt-&gt;args, Path*);
	sprint(xfmt, "data=%%.4%c up=%%.2%c name=%%.*T (%%d)", longc, longc);
	snprint(buf, sizeof buf, xfmt, p-&gt;dloc, p-&gt;parent, p-&gt;namelen, p-&gt;name, p-&gt;namelen);
	fmtstrcpy(fmt, buf);
	return 0;
}

ulong
big(void *a, int n)
{
	uchar *p;
	ulong v;
	int i;

	p = a;
	v = 0;
	for(i=0; i&lt;n; i++)
		v = (v&lt;&lt;8) | *p++;
	return v;
}

ulong
little(void *a, int n)
{
	uchar *p;
	ulong v;
	int i;

	p = a;
	v = 0;
	for(i=0; i&lt;n; i++)
		v |= (*p++&lt;&lt;(i*8));
	return v;
}

/* numbers in big or little endian. */
int
BLfmt(Fmt *fmt)
{
	ulong v;
	uchar *p;
	char buf[20];

	p = va_arg(fmt-&gt;args, uchar*);

	if(!(fmt-&gt;flags&amp;FmtPrec)) {
		fmtstrcpy(fmt, "*BL*");
		return 0;
	}

	if(fmt-&gt;r == 'B')
		v = big(p, fmt-&gt;prec);
	else
		v = little(p, fmt-&gt;prec);

	sprint(buf, "0x%.*lux", fmt-&gt;prec*2, v);
	fmt-&gt;flags &amp;= ~FmtPrec;
	fmtstrcpy(fmt, buf);
	return 0;
}

/* numbers in both little and big endian */
int
Nfmt(Fmt *fmt)
{
	char buf[100];
	uchar *p;

	p = va_arg(fmt-&gt;args, uchar*);

	sprint(buf, "%.*L %.*B", fmt-&gt;prec, p, fmt-&gt;prec, p+fmt-&gt;prec);
	fmt-&gt;flags &amp;= ~FmtPrec;
	fmtstrcpy(fmt, buf);
	return 0;
}

int
asciiTfmt(Fmt *fmt)
{
	char *p, buf[256];
	int i;

	p = va_arg(fmt-&gt;args, char*);
	for(i=0; i&lt;fmt-&gt;prec; i++)
		buf[i] = *p++;
	buf[i] = '\0';
	for(p=buf+strlen(buf); p&gt;buf &amp;&amp; p[-1]==' '; p--)
		;
	p[0] = '\0';
	fmt-&gt;flags &amp;= ~FmtPrec;
	fmtstrcpy(fmt, buf);
	return 0;
}

int
runeTfmt(Fmt *fmt)
{
	Rune buf[256], *r;
	int i;
	uchar *p;

	p = va_arg(fmt-&gt;args, uchar*);
	for(i=0; i*2+2&lt;=fmt-&gt;prec; i++, p+=2)
		buf[i] = (p[0]&lt;&lt;8)|p[1];
	buf[i] = L'\0';
	for(r=buf+i; r&gt;buf &amp;&amp; r[-1]==L' '; r--)
		;
	r[0] = L'\0';
	fmt-&gt;flags &amp;= ~FmtPrec;
	return fmtprint(fmt, "%S", buf);
}

void
ascii(void)
{
	fmtinstall('T', asciiTfmt);
}

void
joliet(void)
{
	fmtinstall('T', runeTfmt);
}

void
getsect(uchar *buf, int n)
{
	if(Bseek(b, n*2048, 0) != n*2048 || Bread(b, buf, 2048) != 2048)
		sysfatal("reading block %ux", n);
}

void
pathtable(Voldesc *v, int islittle)
{
	int i, j, n, sz, addr;
	ulong (*word)(void*, int);
	uchar x[2048], *p, *ep;
	Path *pt;

	print("&gt;&gt;&gt; entire %s path table\n", islittle ? "little" : "big");
	littleend();
	if(islittle) {
		littleend();
		word = little;
	}else{
		bigend();
		word = big;
	}
	sz = little(v-&gt;pathsize, 4);	/* little, not word */
	addr = word(islittle ? v-&gt;lpathloc : v-&gt;mpathloc, 4);
	j = 0;
	n = 1;
	while(sz &gt; 0){
		getsect(x, addr);
		p = x;
		ep = x+sz;
		if(ep &gt; x+2048)
			ep = x+2048;
		for(i=0; p&lt;ep; i++) {
			pt = (Path*)p;
			if(pt-&gt;namelen==0)
				break;
			print("0x%.4x %4d+%-4ld %P\n", n, j, p-x, pt);
			n++;
			p += 8+pt-&gt;namelen+(pt-&gt;namelen&amp;1);
		}
		sz -= 2048;
		addr++;
		j++;
	}
}

void
dump(void *root)
{
	Voldesc *v;
	Cdir *c;
	long rootdirloc;
	uchar x[2048];
	int i;
	uchar *p;

	dumpbootvol(root);
	v = (Voldesc*)root;
	c = (Cdir*)v-&gt;rootdir;
	rootdirloc = little(c-&gt;dloc, 4);
	print("&gt;&gt;&gt; sed 5q root directory\n");
	getsect(x, rootdirloc);
	p = x;
	for(i=0; i&lt;5 &amp;&amp; (p-x)&lt;little(c-&gt;dlen, 4); i++) {
		print("%D\n", p);
		p += ((Cdir*)p)-&gt;len;
	}

	pathtable(v, 1);
	pathtable(v, 0);
}

void
main(int argc, char **argv)
{
	uchar root[2048], jroot[2048];

	if(argc != 2)
		sysfatal("usage: %s file", argv[0]);

	b = Bopen(argv[1], OREAD);
	if(b == nil)
		sysfatal("bopen %r");

	fmtinstall('L', BLfmt);
	fmtinstall('B', BLfmt);
	fmtinstall('N', Nfmt);
	fmtinstall('D', Dfmt);
	fmtinstall('P', Pfmt);

	getsect(root, 16);
	ascii();
	dump(root);

	getsect(jroot, 17);
	joliet();
	dump(jroot);
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

