<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dossrv/dossubs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dossrv/dossubs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "iotrack.h"
#include "dat.h"
#include "fns.h"

static uchar	isdos[256];

int
isdosfs(uchar *buf)
{
	/*
	 * When dynamic disc managers move the disc partition,
	 * they make it start with 0xE9.
	 */
	if(buf[0] == 0xE9)
		return 1;

	/*
	 * Check if the jump displacement (magic[1]) is too short for a FAT.
	 *
	 * check now omitted due to digital cameras that use a 0 jump.
	 * the ecma-107 standard says this is okay and that interoperable fat
	 * implementations shouldn't assume this:
	 * http://www.ecma-international.org/publications/files/ECMA-ST/Ecma-107.pdf,
	 * page 11.
	 */
	if(buf[0] == 0xEB &amp;&amp; buf[2] == 0x90 /* &amp;&amp; buf[1] &gt;= 0x30 */)
		return 1;
	if(chatty)
		fprint(2, "bad sig %.2ux %.2ux %.2uxn", buf[0], buf[1], buf[2]);

	return 0;
}

int
dosfs(Xfs *xf)
{
	Iosect *p, *p1;
	Dosboot *b;
	Fatinfo *fi;
	Dosboot32 *b32;
	Dosbpb *bp;
	long fisec, extflags;
	int i;

	if(!isdos['a']){
		for(i = 'a'; i &lt;= 'z'; i++)
			isdos[i] = 1;
		for(i = 'A'; i &lt;= 'Z'; i++)
			isdos[i] = 1;
		for(i = '0'; i &lt;= '9'; i++)
			isdos[i] = 1;
		isdos['$'] = 1;
		isdos['%'] = 1;
		isdos['''] = 1;
		isdos['-'] = 1;
		isdos['_'] = 1;
		isdos['@'] = 1;
		isdos['~'] = 1;
		isdos['`'] = 1;
		isdos['!'] = 1;
		isdos['('] = 1;
		isdos[')'] = 1;
		isdos['{'] = 1;
		isdos['}'] = 1;
		isdos['^'] = 1;
		isdos['#'] = 1;
		isdos['&amp;'] = 1;
	}

	p = getsect(xf, 0);
	if(p == 0)
		return -1;

	b = (Dosboot*)p-&gt;iobuf;
	if(b-&gt;clustsize == 0 || isdosfs(p-&gt;iobuf) == 0){
		putsect(p);
		return -1;
	}

	bp = malloc(sizeof(Dosbpb));
	memset(bp, 0, sizeof(Dosbpb));	/* clear lock */
	xf-&gt;ptr = bp;
	xf-&gt;fmt = 1;

	bp-&gt;sectsize = GSHORT(b-&gt;sectsize);
	bp-&gt;clustsize = b-&gt;clustsize;
	bp-&gt;nresrv = GSHORT(b-&gt;nresrv);
	bp-&gt;nfats = b-&gt;nfats;
	bp-&gt;rootsize = GSHORT(b-&gt;rootsize);
	bp-&gt;volsize = GSHORT(b-&gt;volsize);
	if(bp-&gt;volsize == 0)
		bp-&gt;volsize = GLONG(b-&gt;bigvolsize);
	bp-&gt;mediadesc = b-&gt;mediadesc;
	bp-&gt;fatsize = GSHORT(b-&gt;fatsize);
	bp-&gt;fataddr = GSHORT(b-&gt;nresrv);

	bp-&gt;fatinfo = 0;

	if(bp-&gt;fatsize == 0){	/* is FAT32 */
		if(chatty)
			bootsecdump32(2, xf, (Dosboot32*)b);
		xf-&gt;isfat32 = 1;
		b32 = (Dosboot32*)b;
		bp-&gt;fatsize = GLONG(b32-&gt;fatsize32);
		if(bp-&gt;fatsize == 0){
			putsect(p);
			if(chatty)
				fprint(2, "fatsize 0\n");
			return -1;
		}
		bp-&gt;dataaddr = bp-&gt;fataddr + bp-&gt;nfats*bp-&gt;fatsize;
		bp-&gt;rootaddr = 0;
		bp-&gt;rootstart = GLONG(b32-&gt;rootstart);

		/*
		 * disable fat mirroring?
		 */
		extflags = GSHORT(b32-&gt;extflags);
		if(extflags &amp; 0x0080){
			for(i = 0; i &lt; 4; i++){
				if(extflags &amp; (1 &lt;&lt; i)){
					bp-&gt;fataddr += i * bp-&gt;fatsize;
					bp-&gt;nfats = 1;
					break;
				}
			}
		}

		/*
		 * fat free list info
		 */
		bp-&gt;freeptr = FATRESRV;
		fisec = GSHORT(b32-&gt;infospec);
		if(fisec != 0 &amp;&amp; fisec &lt; GSHORT(b32-&gt;nresrv)){
			p1 = getsect(xf, fisec);
			if(p1 != nil){
				fi = (Fatinfo*)p1-&gt;iobuf;
				if(GLONG(fi-&gt;sig1) == FATINFOSIG1 &amp;&amp; GLONG(fi-&gt;sig) == FATINFOSIG){
					bp-&gt;fatinfo = fisec;
					bp-&gt;freeptr = GLONG(fi-&gt;nextfree);
					bp-&gt;freeclusters = GLONG(fi-&gt;freeclust);
					chat("fat info: %ld free clusters, next free %ld\n", bp-&gt;freeclusters, bp-&gt;freeptr);
				}
				putsect(p1);
			}
		}
	}else{
		if(chatty)
			bootdump(2, b);
		bp-&gt;rootaddr = bp-&gt;fataddr + bp-&gt;nfats*bp-&gt;fatsize;
		bp-&gt;rootstart = 0;
		i = bp-&gt;rootsize*DOSDIRSIZE + bp-&gt;sectsize-1;
		i /= bp-&gt;sectsize;
		bp-&gt;dataaddr = bp-&gt;rootaddr + i;
		bp-&gt;freeptr = FATRESRV;
	}
	bp-&gt;fatclusters = FATRESRV+(bp-&gt;volsize - bp-&gt;dataaddr)/bp-&gt;clustsize;

	if(xf-&gt;isfat32)
		bp-&gt;fatbits = 32;
	else if(bp-&gt;fatclusters &lt; 4087)
		bp-&gt;fatbits = 12;
	else
		bp-&gt;fatbits = 16;

	chat("fatbits=%d (%d clusters)...", bp-&gt;fatbits, bp-&gt;fatclusters);
	for(i=0; i&lt;b-&gt;nfats; i++)
		chat("fat %d: %ld...", i, bp-&gt;fataddr+i*bp-&gt;fatsize);
	chat("root: %ld...", bp-&gt;rootaddr);
	chat("data: %ld...", bp-&gt;dataaddr);
	putsect(p);
	return 0;
}

/*
 * initialize f to the root directory
 * this file has no Dosdir entry,
 * so we special case it all over.
 */
void
rootfile(Xfile *f)
{
	Dosptr *dp;

	dp = f-&gt;ptr;
	memset(dp, 0, sizeof(Dosptr));
	dp-&gt;prevaddr = -1;
}

int
isroot(ulong addr)
{
	return addr == 0;
}

int
getfile(Xfile *f)
{
	Dosptr *dp;
	Iosect *p;

	dp = f-&gt;ptr;
	if(dp-&gt;p)
		panic("getfile");
	p = getsect(f-&gt;xf, dp-&gt;addr);
	if(p == nil)
		return -1;

	/*
	 * we could also make up a Dosdir for the root
	 */
	dp-&gt;d = nil;
	if(!isroot(dp-&gt;addr)){
		if(f-&gt;qid.path != QIDPATH(dp)){
			chat("qid mismatch f=%#llux d=%#lux...", f-&gt;qid.path, QIDPATH(dp));
			putsect(p);
			errno = Enonexist;
			return -1;
		}
		dp-&gt;d = (Dosdir *)&amp;p-&gt;iobuf[dp-&gt;offset];
	}
	dp-&gt;p = p;
	return 0;
}

void
putfile(Xfile *f)
{
	Dosptr *dp;

	dp = f-&gt;ptr;
	if(!dp-&gt;p)
		panic("putfile");
	putsect(dp-&gt;p);
	dp-&gt;p = nil;
	dp-&gt;d = nil;
}

long
getstart(Xfs *xf, Dosdir *d)
{
	long start;

	start = GSHORT(d-&gt;start);
	if(xf-&gt;isfat32)
		start |= GSHORT(d-&gt;hstart)&lt;&lt;16;
	return start;
}

void
putstart(Xfs *xf, Dosdir *d, long start)
{
	PSHORT(d-&gt;start, start);
	if(xf-&gt;isfat32)
		PSHORT(d-&gt;hstart, start&gt;&gt;16);
}

/*
 * return the disk cluster for the iclust cluster in f
 */
long
fileclust(Xfile *f, long iclust, int cflag)
{
	Dosbpb *bp;
	Dosptr *dp;
	Dosdir *d;
	long start, clust, nskip, next;

	bp = f-&gt;xf-&gt;ptr;
	dp = f-&gt;ptr;
	d = dp-&gt;d;
	next = 0;

	/* 
	 * asking for the cluster of the root directory
	 * is not a well-formed question, since the root directory
	 * does not begin on a cluster boundary.
	 */
	if(!f-&gt;xf-&gt;isfat32 &amp;&amp; isroot(dp-&gt;addr))
		return -1;

	if(f-&gt;xf-&gt;isfat32 &amp;&amp; isroot(dp-&gt;addr)){
		start = bp-&gt;rootstart;
	}else{
		start = getstart(f-&gt;xf, d);
		if(start == 0){
			if(!cflag)
				return -1;
			mlock(bp);
			start = falloc(f-&gt;xf);
			unmlock(bp);
			if(start &lt;= 0)
				return -1;
			puttime(d, 0);
			putstart(f-&gt;xf, d, start);
			dp-&gt;p-&gt;flags |= BMOD;
			dp-&gt;clust = 0;
		}
	}
	if(dp-&gt;clust == 0 || iclust &lt; dp-&gt;iclust){
		clust = start;
		nskip = iclust;
	}else{
		clust = dp-&gt;clust;
		nskip = iclust - dp-&gt;iclust;
	}
	if(chatty &gt; 1 &amp;&amp; nskip &gt; 0)
		chat("clust %#lx, skip %ld...", clust, nskip);
	if(clust &lt;= 0)
		return -1;
	if(nskip &gt; 0){
		mlock(bp);
		while(--nskip &gt;= 0){
			next = getfat(f-&gt;xf, clust);
			if(chatty &gt; 1)
				chat("-&gt;%#lx", next);
			if(next &gt; 0){
				clust = next;
				continue;
			}else if(!cflag)
				break;
			if(d &amp;&amp; (d-&gt;attr&amp;DSYSTEM)){
				next = cfalloc(f);
				if(next &lt; 0)
					break;
				/* cfalloc will call putfat for us, since clust may change */
			} else {
				next = falloc(f-&gt;xf);
				if(next &lt; 0)
					break;
				putfat(f-&gt;xf, clust, next);
			}
			clust = next;
		}
		unmlock(bp);
		if(next &lt;= 0)
			return -1;
		dp-&gt;clust = clust;
		dp-&gt;iclust = iclust;
	}
	if(chatty &gt; 1)
		chat(" clust(%#lx)=%#lx...", iclust, clust);
	return clust;
}

/*
 * return the disk sector for the isect disk sector in f 
 */
long
fileaddr(Xfile *f, long isect, int cflag)
{
	Dosbpb *bp;
	Dosptr *dp;
	long clust;

	bp = f-&gt;xf-&gt;ptr;
	dp = f-&gt;ptr;
	if(!f-&gt;xf-&gt;isfat32 &amp;&amp; isroot(dp-&gt;addr)){
		if(isect*bp-&gt;sectsize &gt;= bp-&gt;rootsize*DOSDIRSIZE)
			return -1;
		return bp-&gt;rootaddr + isect;
	}
	clust = fileclust(f, isect/bp-&gt;clustsize, cflag);
	if(clust &lt; 0)
		return -1;

	return clust2sect(bp, clust) + isect%bp-&gt;clustsize;
}

/*
 * translate names
 */
void
fixname(char *buf)
{
	int c;
	char *p;

	p = buf;
	while(c = *p){
		if(c == ':' &amp;&amp; trspaces)
			*p = ' ';
		p++;
	}
}

/*
 * classify the file name as one of 
 *	Invalid - contains a bad character
 *	Short - short valid 8.3 name, no lowercase letters
 *	ShortLower - short valid 8.3 name except for lowercase letters
 *	Long - long name 
 */
int
classifyname(char *buf)
{
	char *p, *dot;
	int c, isextended, is8dot3, islower, ndot;

	p = buf;
	isextended = 0;
	islower = 0;
	dot = nil;
	ndot = 0;
	while(c = (uchar)*p){
		if(c&amp;0x80)	/* UTF8 */
			isextended = 1;
		else if(c == '.'){
			dot = p;
			ndot++;
		}else if(strchr("+,:;=[] ", c))
			isextended = 1;
		else if(!isdos[c])
			return Invalid;
		if('a' &lt;= c &amp;&amp; c &lt;= 'z')
			islower = 1;
		p++;
	}

	is8dot3 = (ndot==0 &amp;&amp; p-buf &lt;= 8) || (ndot==1 &amp;&amp; dot-buf &lt;= 8 &amp;&amp; p-(dot+1) &lt;= 3);
	
	if(!isextended &amp;&amp; is8dot3){
		if(islower)
			return ShortLower;
		return Short;
	}
	return Long;
}
		
/*
 * make an alias for a valid long file name
 */
void
mkalias(char *name, char *sname, int id)
{
	Rune r;
	char *s, *e, sid[10];
	int i, esuf, v;

	e = strrchr(name, '.');
	if(e == nil)
		e = strchr(name, '\0');

	s = name;
	i = 0;
	while(s &lt; e &amp;&amp; i &lt; 6){
		if(isdos[(uchar)*s])
			sname[i++] = *s++;
		else
			s += chartorune(&amp;r, s);
	}

	v = snprint(sid, 10, "%d", id);
	if(i + 1 + v &gt; 8)
		i = 8 - 1 - v;
	sname[i++] = '~';
	strcpy(&amp;sname[i], sid);
	i += v;

	sname[i++] = '.';
	esuf = i + 3;
	if(esuf &gt; 12)
		panic("bad mkalias");
	while(*e &amp;&amp; i &lt; esuf){
		if(isdos[(uchar)*e])
			sname[i++] = *e++;
		else
			e += chartorune(&amp;r, e);
	}
	if(sname[i-1] == '.')
		i--;
	sname[i] = '\0';
}

/*
 * check for valid plan 9 names,
 * rewrite ' ' to ':'
 */
char isfrog[256]={
	/*NUL*/	1, 1, 1, 1, 1, 1, 1, 1,
	/*BKS*/	1, 1, 1, 1, 1, 1, 1, 1,
	/*DLE*/	1, 1, 1, 1, 1, 1, 1, 1,
	/*CAN*/	1, 1, 1, 1, 1, 1, 1, 1,
/*	[' ']	1,	let's try this -rsc */
	['/']	1,
	[0x7f]	1,
};

int
nameok(char *elem)
{
	while(*elem) {
		if(*elem == ' ' &amp;&amp; trspaces)
			*elem = ':';
		if(isfrog[*(uchar*)elem])
			return 0;
		elem++;
	}
	return 1;
}

/*
 * look for a directory entry matching name
 * always searches for long names which match a short name
 */
int
searchdir(Xfile *f, char *name, Dosptr *dp, int cflag, int longtype)
{
	Xfs *xf;
	Iosect *p;
	Dosbpb *bp;
	Dosdir *d;
	char buf[261], *bname;
	int isect, addr, o, addr1, addr2, prevaddr, prevaddr1, o1, islong, have, need, sum;

	xf = f-&gt;xf;
	bp = xf-&gt;ptr;
	addr1 = -1;
	addr2 = -1;
	prevaddr1 = -1;
	o1 = 0;
	islong = 0;
	sum = -1;

	need = 1;
	if(longtype!=Short &amp;&amp; cflag)
		need += (utflen(name) + DOSRUNE-1) / DOSRUNE;

	memset(dp, 0, sizeof(Dosptr));
	dp-&gt;prevaddr = -1;
	dp-&gt;naddr = -1;
	dp-&gt;paddr = ((Dosptr *)f-&gt;ptr)-&gt;addr;
	dp-&gt;poffset = ((Dosptr *)f-&gt;ptr)-&gt;offset;

	have = 0;
	addr = -1;
	bname = nil;
	for(isect=0;; isect++){
		prevaddr = addr;
		addr = fileaddr(f, isect, cflag);
		if(addr &lt; 0)
			break;
		p = getsect(xf, addr);
		if(p == 0)
			break;
		for(o=0; o&lt;bp-&gt;sectsize; o+=DOSDIRSIZE){
			d = (Dosdir *)&amp;p-&gt;iobuf[o];
			if(d-&gt;name[0] == 0x00){
				chat("end dir(0)...");
				putsect(p);
				if(!cflag)
					return -1;

				/*
				 * addr1 &amp; o1 are the start of the dirs
				 * addr2 is the optional second cluster used if the long name
				 * entry does not fit within the addr1 cluster
				 *
				 * have tells us the number of contiguous free dirs
				 * starting at addr1.o1; need are necessary to hold the long name.
				 */
				if(addr1 &lt; 0){
					addr1 = addr;
					prevaddr1 = prevaddr;
					o1 = o;
				}
				if(addr2 &lt; 0 &amp;&amp; (bp-&gt;sectsize-o)/DOSDIRSIZE + have &lt; need){
					addr2 = fileaddr(f, isect+1, cflag);
					if(addr2 &lt; 0)
						goto breakout;
				}else if(addr2 &lt; 0)
					addr2 = addr;
				if(addr2 == addr1)
					addr2 = -1;
				dp-&gt;addr = addr1;
				dp-&gt;offset = o1;
				dp-&gt;prevaddr = prevaddr1;
				dp-&gt;naddr = addr2;
				return 0;
			}
			if(d-&gt;name[0] == DOSEMPTY){
				if(chatty)
					fprint(2, "empty dir\n");

				have++;
				if(addr1 == -1){
					addr1 = addr;
					o1 = o;
					prevaddr1 = prevaddr;
				}
				if(addr2 == -1 &amp;&amp; have &gt;= need)
					addr2 = addr;
				continue;
			}
			have = 0;
			if(addr2 == -1)
				addr1 = -1;

			dirdump(d);
			if((d-&gt;attr &amp; 0xf) == 0xf){
				bname = getnamesect(buf, bname, p-&gt;iobuf + o, &amp;islong, &amp;sum, 1);
				continue;
			}
			if(d-&gt;attr &amp; DVLABEL){
				islong = 0;
				continue;
			}
			if(islong != 1 || sum != aliassum(d) || cistrcmp(bname, name) != 0){
				bname = buf;
				getname(buf, d);
			}
			islong = 0;
			if(cistrcmp(bname, name) != 0)
				continue;
			if(chatty)
				fprint(2, "found\n");
			if(cflag){
				putsect(p);
				return -1;
			}
			dp-&gt;addr = addr;
			dp-&gt;prevaddr = prevaddr;
			dp-&gt;offset = o;
			dp-&gt;p = p;
			dp-&gt;d = d;
			return 0;
		}
		putsect(p);
	}
breakout:
	chat("end dir(1)...");
	return -1;
}

int
emptydir(Xfile *f)
{
	Xfs *xf = f-&gt;xf;
	Dosbpb *bp = xf-&gt;ptr;
	int isect, addr, o;
	Iosect *p;
	Dosdir *d;

	for(isect=0;; isect++){
		addr = fileaddr(f, isect, 0);
		if(addr &lt; 0)
			break;
		p = getsect(xf, addr);
		if(p == 0)
			return -1;
		for(o=0; o&lt;bp-&gt;sectsize; o+=DOSDIRSIZE){
			d = (Dosdir *)&amp;p-&gt;iobuf[o];
			if(d-&gt;name[0] == 0x00){
				putsect(p);
				return 0;
			}
			if(d-&gt;name[0] == DOSEMPTY)
				continue;
			if(d-&gt;name[0] == '.')
				continue;
			if(d-&gt;attr&amp;DVLABEL)
				continue;
			putsect(p);
			return -1;
		}
		putsect(p);
	}
	return 0;
}

long
readdir(Xfile *f, void *vbuf, long offset, long count)
{
	Xfs *xf;
	Dosbpb *bp;
	Dir dir;
	int isect, addr, o, islong, sum;
	Iosect *p;
	Dosdir *d;
	long rcnt, n;
	char *name, snamebuf[8+1+3+1], namebuf[DOSNAMELEN];
	uchar *buf;

	buf = vbuf;
	rcnt = 0;
	xf = f-&gt;xf;
	bp = xf-&gt;ptr;
	if(count &lt;= 0)
		return 0;
	islong = 0;
	sum = -1;
	name = nil;
	for(isect=0;; isect++){
		addr = fileaddr(f, isect, 0);
		if(addr &lt; 0)
			break;
		p = getsect(xf, addr);
		if(p == 0)
			return -1;
		for(o=0; o&lt;bp-&gt;sectsize; o+=DOSDIRSIZE){
			d = (Dosdir *)&amp;p-&gt;iobuf[o];
			if(d-&gt;name[0] == 0x00){
				putsect(p);
				return rcnt;
			}
			if(d-&gt;name[0] == DOSEMPTY)
				continue;
			dirdump(d);
			if(d-&gt;name[0] == '.'){
				if(d-&gt;name[1] == ' ' || d-&gt;name[1] == 0)
					continue;
				if(d-&gt;name[1] == '.' &amp;&amp;
				  (d-&gt;name[2] == ' ' || d-&gt;name[2] == 0))
					continue;
			}
			if((d-&gt;attr &amp; 0xf) == 0xf){
				name = getnamesect(namebuf, name, p-&gt;iobuf+o, &amp;islong, &amp;sum, 1);
				continue;
			}
			if(d-&gt;attr &amp; DVLABEL){
				islong = 0;
				continue;
			}
			dir.name = snamebuf;
			getdir(xf, &amp;dir, d, addr, o);
			if(islong == 1 &amp;&amp; nameok(name) &amp;&amp; sum == aliassum(d))
				dir.name = name;
			islong = 0;
			n = convD2M(&amp;dir, &amp;buf[rcnt], count - rcnt);
			name = nil;
			if(n &lt;= BIT16SZ){	/* no room for next entry */
				putsect(p);
				return rcnt;
			}
			rcnt += n;
			if(offset &gt; 0){
				offset -= rcnt;
				rcnt = 0;
				islong = 0;
				continue;
			}
			if(rcnt == count){
				putsect(p);
				return rcnt;
			}
		}
		putsect(p);
	}
	return rcnt;
}

/*
 * set up ndp for a directory's parent
 * the hardest part is setting up paddr
 */
int
walkup(Xfile *f, Dosptr *ndp)
{
	Dosbpb *bp;
	Dosptr *dp;
	Dosdir *xd;
	Iosect *p;
	long k, o, so, start, pstart, ppstart, st, ppclust;

	bp = f-&gt;xf-&gt;ptr;
	dp = f-&gt;ptr;
	memset(ndp, 0, sizeof(Dosptr));
	ndp-&gt;prevaddr = -1;
	ndp-&gt;naddr = -1;
	ndp-&gt;addr = dp-&gt;paddr;
	ndp-&gt;offset = dp-&gt;poffset;

	chat("walkup: paddr=%#lx...", dp-&gt;paddr);

	/*
	 * root's paddr is always itself
	 */
	if(isroot(dp-&gt;paddr))
		return 0;

	/*
	 * find the start of our parent's directory
	 */
	p = getsect(f-&gt;xf, dp-&gt;paddr);
	if(p == nil)
		goto error;
	xd = (Dosdir *)&amp;p-&gt;iobuf[dp-&gt;poffset];
	dirdump(xd);
	start = getstart(f-&gt;xf, xd);
	chat("start=%#lx...", start);
	if(start == 0)
		goto error;
	putsect(p);

	/*
	 * verify that parent's . points to itself
	 */
	p = getsect(f-&gt;xf, clust2sect(bp, start));
	if(p == nil)
		goto error;
	xd = (Dosdir *)p-&gt;iobuf;
	dirdump(xd);
	st = getstart(f-&gt;xf, xd);
	if(xd-&gt;name[0]!='.' || xd-&gt;name[1]!=' ' || start!=st)
		goto error;

	/*
	 * parent's .. is the next entry, and has start of parent's parent
	 */
	xd++;
	dirdump(xd);
	if(xd-&gt;name[0] != '.' || xd-&gt;name[1] != '.')
		goto error;
	pstart = getstart(f-&gt;xf, xd);
	putsect(p);

	/*
	 * we're done if parent is root
	 */
	if(pstart == 0 || f-&gt;xf-&gt;isfat32 &amp;&amp; pstart == bp-&gt;rootstart)
		return 0;

	/*
	 * verify that parent's . points to itself
	 */
	p = getsect(f-&gt;xf, clust2sect(bp, pstart));
	if(p == 0){
		chat("getsect %ld failed\n", pstart);
		goto error;
	}
	xd = (Dosdir *)p-&gt;iobuf;
	dirdump(xd);
	st = getstart(f-&gt;xf, xd);
	if(xd-&gt;name[0]!='.' || xd-&gt;name[1]!=' ' || pstart!=st)
		goto error;

	/*
	 * parent's parent's .. is the next entry, and has start of parent's parent's parent
	 */
	xd++;
	dirdump(xd);
	if(xd-&gt;name[0] != '.' || xd-&gt;name[1] != '.')
		goto error;
	ppstart = getstart(f-&gt;xf, xd);
	putsect(p);

	/*
	 * open parent's parent's parent, and walk through it until parent's parent is found
	 * need this to find parent's parent's addr and offset
	 */
	ppclust = ppstart;
	if(f-&gt;xf-&gt;isfat32 &amp;&amp; ppclust == 0){
		ppclust = bp-&gt;rootstart;
		chat("ppclust 0, resetting to rootstart\n");
	}
	k = ppclust ? clust2sect(bp, ppclust) : bp-&gt;rootaddr;
	p = getsect(f-&gt;xf, k);
	if(p == nil){
		chat("getsect %ld failed\n", k);
		goto error;
	}
	xd = (Dosdir *)p-&gt;iobuf;
	dirdump(xd);
	if(ppstart){
		st = getstart(f-&gt;xf, xd);
		if(xd-&gt;name[0]!='.' || xd-&gt;name[1]!=' ' || ppstart!=st)
			goto error;
	}
	for(so=1;; so++){
		for(o=0; o&lt;bp-&gt;sectsize; o+=DOSDIRSIZE){
			xd = (Dosdir *)&amp;p-&gt;iobuf[o];
			if(xd-&gt;name[0] == 0x00){
				chat("end dir\n");
				goto error;
			}
			if(xd-&gt;name[0] == DOSEMPTY)
				continue;
			st = getstart(f-&gt;xf, xd);
			if(st == pstart)
				goto out;
		}
		if(ppclust){
			if(so%bp-&gt;clustsize == 0){
				mlock(bp);
				ppclust = getfat(f-&gt;xf, ppclust);
				unmlock(bp);
				if(ppclust &lt; 0){
					chat("getfat %ld failed\n", ppclust);
					goto error;
				}
			}
			k = clust2sect(bp, ppclust) + 
				so%bp-&gt;clustsize;
		}else{
			if(so*bp-&gt;sectsize &gt;= bp-&gt;rootsize*DOSDIRSIZE)
				goto error;
			k = bp-&gt;rootaddr + so;
		}
		putsect(p);
		p = getsect(f-&gt;xf, k);
		if(p == 0){
			chat("getsect %ld failed\n", k);
			goto error;
		}
	}
out:
	putsect(p);
	ndp-&gt;paddr = k;
	ndp-&gt;poffset = o;
	return 0;

error:
	if(p)
		putsect(p);
	return -1;
}

long
readfile(Xfile *f, void *vbuf, long offset, long count)
{
	Xfs *xf = f-&gt;xf;
	Dosbpb *bp = xf-&gt;ptr;
	Dosptr *dp = f-&gt;ptr;
	Dosdir *d = dp-&gt;d;
	int isect, addr, o, c;
	Iosect *p;
	uchar *buf;
	long length, rcnt;

	rcnt = 0;
	length = GLONG(d-&gt;length);
	buf = vbuf;
	if(offset &gt;= length)
		return 0;
	if(offset+count &gt;= length)
		count = length - offset;
	isect = offset/bp-&gt;sectsize;
	o = offset%bp-&gt;sectsize;
	while(count &gt; 0){
		addr = fileaddr(f, isect++, 0);
		if(addr &lt; 0)
			break;
		c = bp-&gt;sectsize - o;
		if(c &gt; count)
			c = count;
		p = getsect(xf, addr);
		if(p == 0)
			return -1;
		memmove(&amp;buf[rcnt], &amp;p-&gt;iobuf[o], c);
		putsect(p);
		count -= c;
		rcnt += c;
		o = 0;
	}
	return rcnt;
}

long
writefile(Xfile *f, void *vbuf, long offset, long count)
{
	Xfs *xf = f-&gt;xf;
	Dosbpb *bp = xf-&gt;ptr;
	Dosptr *dp = f-&gt;ptr;
	Dosdir *d = dp-&gt;d;
	int isect, addr = 0, o, c;
	Iosect *p;
	uchar *buf;
	long length, rcnt = 0, dlen;

	buf = vbuf;
	isect = offset/bp-&gt;sectsize;
	o = offset%bp-&gt;sectsize;
	while(count &gt; 0){
		addr = fileaddr(f, isect++, 1);
		if(addr &lt; 0)
			break;
		c = bp-&gt;sectsize - o;
		if(c &gt; count)
			c = count;
		if(c == bp-&gt;sectsize){
			p = getosect(xf, addr);
			p-&gt;flags = 0;
		}else{
			p = getsect(xf, addr);
			if(p == nil)
				return -1;
		}
		memmove(&amp;p-&gt;iobuf[o], &amp;buf[rcnt], c);
		p-&gt;flags |= BMOD;
		putsect(p);
		count -= c;
		rcnt += c;
		o = 0;
	}
	if(rcnt &lt;= 0 &amp;&amp; addr &lt; 0)
		return -1;
	length = 0;
	dlen = GLONG(d-&gt;length);
	if(rcnt &gt; 0)
		length = offset+rcnt;
	else if(dp-&gt;addr &amp;&amp; dp-&gt;clust){
		c = bp-&gt;clustsize*bp-&gt;sectsize;
		if(dp-&gt;iclust &gt; (dlen+c-1)/c)
			length = c*dp-&gt;iclust;
	}
	if(length &gt; dlen)
		PLONG(d-&gt;length, length);
	puttime(d, 0);
	dp-&gt;p-&gt;flags |= BMOD;
	return rcnt;
}

int
truncfile(Xfile *f, long length)
{
	Xfs *xf = f-&gt;xf;
	Dosbpb *bp = xf-&gt;ptr;
	Dosptr *dp = f-&gt;ptr;
	Dosdir *d = dp-&gt;d;
	long clust, next, n;

	mlock(bp);
	clust = getstart(f-&gt;xf, d);
	n = length;
	if(n &lt;= 0)
		putstart(f-&gt;xf, d, 0);
	else
		n -= bp-&gt;sectsize;
	while(clust &gt; 0){
		next = getfat(xf, clust);
		if(n &lt;= 0)
			putfat(xf, clust, 0);
		else
			n -= bp-&gt;clustsize*bp-&gt;sectsize;
		clust = next;
	}
	unmlock(bp);
	PLONG(d-&gt;length, length);
	dp-&gt;iclust = 0;
	dp-&gt;clust = 0;
	dp-&gt;p-&gt;flags |= BMOD;
	return 0;
}

void
putdir(Dosdir *d, Dir *dp)
{
	if(dp-&gt;mode != ~0){
		if(dp-&gt;mode &amp; 2)
			d-&gt;attr &amp;= ~DRONLY;
		else
			d-&gt;attr |= DRONLY;
		if(dp-&gt;mode &amp; DMEXCL)
			d-&gt;attr |= DSYSTEM;
		else
			d-&gt;attr &amp;= ~DSYSTEM;
	}
	if(dp-&gt;mtime != ~0)
		puttime(d, dp-&gt;mtime);
}

/*
 * should extend this to deal with
 * creation and access dates
 */
void
getdir(Xfs *xfs, Dir *dp, Dosdir *d, int addr, int offset)
{
	if(d == nil || addr == 0)
		panic("getdir on root");
	dp-&gt;type = 0;
	dp-&gt;dev = 0;
	getname(dp-&gt;name, d);

	dp-&gt;qid.path = addr*(Sectorsize/DOSDIRSIZE) +
			offset/DOSDIRSIZE;
	dp-&gt;qid.vers = 0;

	if(d-&gt;attr &amp; DRONLY)
		dp-&gt;mode = 0444;
	else
		dp-&gt;mode = 0666;
	dp-&gt;atime = gtime(d);
	dp-&gt;mtime = dp-&gt;atime;
	dp-&gt;qid.type = QTFILE;
	if(d-&gt;attr &amp; DDIR){
		dp-&gt;qid.type = QTDIR;
		dp-&gt;mode |= DMDIR|0111;
		dp-&gt;length = 0;
	}else
		dp-&gt;length = GLONG(d-&gt;length);
	if(d-&gt;attr &amp; DSYSTEM){
		dp-&gt;mode |= DMEXCL;
		if(iscontig(xfs, d))
			dp-&gt;mode |= DMAPPEND;
	}

	dp-&gt;uid = "bill";
	dp-&gt;muid = "bill";
	dp-&gt;gid = "trog";
}

void
getname(char *p, Dosdir *d)
{
	int c, i;

	for(i=0; i&lt;8; i++){
		c = d-&gt;name[i];
		if(c == '\0' || c == ' ')
			break;
		if(i == 0 &amp;&amp; c == 0x05)
			c = 0xe5;
		*p++ = c;
	}
	for(i=0; i&lt;3; i++){
		c = d-&gt;ext[i];
		if(c == '\0' || c == ' ')
			break;
		if(i == 0)
			*p++ = '.';
		*p++ = c;
	}
	*p = 0;
}

static char*
getnamerunes(char *dst, uchar *buf, int step)
{
	int i;
	Rune r;
	char dbuf[DOSRUNE * UTFmax + 1], *d;

	d = dbuf;
	r = 1;
	for(i = 1; r &amp;&amp; i &lt; 11; i += 2){
		r = buf[i] | (buf[i+1] &lt;&lt; 8);
		d += runetochar(d, &amp;r);
	}
	for(i = 14; r &amp;&amp; i &lt; 26; i += 2){
		r = buf[i] | (buf[i+1] &lt;&lt; 8);
		d += runetochar(d, &amp;r);
	}
	for(i = 28; r &amp;&amp; i &lt; 32; i += 2){
		r = buf[i] | (buf[i+1] &lt;&lt; 8);
		d += runetochar(d, &amp;r);
	}

	if(step == 1)
		dst -= d - dbuf;

	memmove(dst, dbuf, d - dbuf);

	if(step == -1){
		dst += d - dbuf;
		*dst = '\0';
	}

	return dst;
}

char*
getnamesect(char *dbuf, char *d, uchar *buf, int *islong, int *sum, int step)
{
	/*
	 * validation checks to make sure we're
	 * making up a consistent name
	 */
	if(buf[11] != 0xf || buf[12] != 0){
		*islong = 0;
		return nil;
	}
	if(step == 1){
		if((buf[0] &amp; 0xc0) == 0x40){
			*islong = buf[0] &amp; 0x3f;
			*sum = buf[13];
			d = dbuf + DOSNAMELEN;
			*--d = '\0';
		}else if(*islong &amp;&amp; *islong == buf[0] + 1 &amp;&amp; *sum == buf[13]){
			*islong = buf[0];
		}else{
			*islong = 0;
			return nil;
		}
	}else{
		if(*islong + 1 == (buf[0] &amp; 0xbf) &amp;&amp; *sum == buf[13]){
			*islong = buf[0] &amp; 0x3f;
			if(buf[0] &amp; 0x40)
				*sum = -1;
		}else{
			*islong = 0;
			*sum = -1;
			return nil;
		}
	}
	if(*islong &gt; 20){
		*islong = 0;
		*sum = -1;
		return nil;
	}

	return getnamerunes(d, buf, step);
}

void
putname(char *p, Dosdir *d)
{
	int i;

	memset(d-&gt;name, ' ', sizeof d-&gt;name+sizeof d-&gt;ext);
	for(i=0; i&lt;sizeof d-&gt;name; i++){
		if(*p == 0 || *p == '.')
			break;
		d-&gt;name[i] = toupper(*p++);
	}
	p = strrchr(p, '.');
	if(p){
		for(i=0; i&lt;sizeof d-&gt;ext; i++){
			if(*++p == 0)
				break;
			d-&gt;ext[i] = toupper(*p);
		}
	}
}

static void
putnamesect(uchar *slot, Rune *longname, int curslot, int first, int sum)
{
	Rune r;
	Dosdir ds;
	int i, j;

	memset(&amp;ds, 0xff, sizeof ds);
	ds.attr = 0xf;
	ds.reserved[0] = 0;
	ds.reserved[1] = sum;
	ds.start[0] = 0;
	ds.start[1] = 0;
	if(first)
		ds.name[0] = 0x40 | curslot;
	else 
		ds.name[0] = curslot;
	memmove(slot, &amp;ds, sizeof ds);

	j = (curslot-1) * DOSRUNE;

	for(i = 1; i &lt; 11; i += 2){
		r = longname[j++];
		slot[i] = r;
		slot[i+1] = r &gt;&gt; 8;
		if(r == 0)
			return;
	}
	for(i = 14; i &lt; 26; i += 2){
		r = longname[j++];
		slot[i] = r;
		slot[i+1] = r &gt;&gt; 8;
		if(r == 0)
			return;
	}
	for(i = 28; i &lt; 32; i += 2){
		r = longname[j++];
		slot[i] = r;
		slot[i+1] = r &gt;&gt; 8;
		if(r == 0)
			return;
	}
}

int
aliassum(Dosdir *d)
{
	int i, sum;

	if(d == nil)
		return -1;
	sum = 0;
	for(i = 0; i &lt; 11; i++)
		sum = (((sum&amp;1)&lt;&lt;7) | ((sum&amp;0xfe)&gt;&gt;1)) + d-&gt;name[i];
	return sum &amp; 0xff;
}

int
putlongname(Xfs *xf, Dosptr *ndp, char *name, char sname[13])
{
	Dosbpb *bp;
	Dosdir tmpd;
	Rune longname[DOSNAMELEN+1];
	int i, first, sum, nds, len;

	/* calculate checksum */
	putname(sname, &amp;tmpd);
	sum = aliassum(&amp;tmpd);

	bp = xf-&gt;ptr;
	first = 1;
	len = utftorunes(longname, name, DOSNAMELEN);
	if(chatty){
		chat("utftorunes %s =", name);
		for(i=0; i&lt;len; i++)
			chat(" %.4X", longname[i]);
		chat("\n");
	}
	for(nds = (len + DOSRUNE-1) / DOSRUNE; nds &gt; 0; nds--){
		putnamesect(&amp;ndp-&gt;p-&gt;iobuf[ndp-&gt;offset], longname, nds, first, sum);
		first = 0;
		ndp-&gt;offset += 32;
		if(ndp-&gt;offset == bp-&gt;sectsize){
			chat("long name moving over sector boundary\n");
			ndp-&gt;p-&gt;flags |= BMOD;
			putsect(ndp-&gt;p);
			ndp-&gt;p = nil;

			/*
			 * switch to the next cluster for a long entry
			 * naddr should be set up correctly by searchdir
			 */
			ndp-&gt;prevaddr = ndp-&gt;addr;
			ndp-&gt;addr = ndp-&gt;naddr;
			ndp-&gt;naddr = -1;
			if(ndp-&gt;addr == -1)
				return -1;
			ndp-&gt;p = getsect(xf, ndp-&gt;addr);
			if(ndp-&gt;p == nil)
				return -1;
			ndp-&gt;offset = 0;
			ndp-&gt;d = (Dosdir *)&amp;ndp-&gt;p-&gt;iobuf[ndp-&gt;offset];
		}
	}
	return 0;
}

long
getfat(Xfs *xf, int n)
{
	Dosbpb *bp = xf-&gt;ptr;
	Iosect *p;
	ulong k, sect;
	int o, fb;

	if(n &lt; FATRESRV || n &gt;= bp-&gt;fatclusters)
		return -1;
	fb = bp-&gt;fatbits;
	k = (fb * n) &gt;&gt; 3;
	if(k &gt;= bp-&gt;fatsize*bp-&gt;sectsize)
		panic("getfat");
	sect = k/bp-&gt;sectsize + bp-&gt;fataddr;
	o = k%bp-&gt;sectsize;
	p = getsect(xf, sect);
	if(p == nil)
		return -1;
	k = p-&gt;iobuf[o++];
	if(o &gt;= bp-&gt;sectsize){
		putsect(p);
		p = getsect(xf, sect+1);
		if(p == nil)
			return -1;
		o = 0;
	}
	k |= p-&gt;iobuf[o++]&lt;&lt;8;
	if(fb == 32){
		/* fat32 is really fat28 */
		k |= p-&gt;iobuf[o++] &lt;&lt; 16;
		k |= (p-&gt;iobuf[o] &amp; 0x0f) &lt;&lt; 24;
		fb = 28;
	}
	putsect(p);
	if(fb == 12){
		if(n&amp;1)
			k &gt;&gt;= 4;
		else
			k &amp;= 0xfff;
	}
	if(chatty &gt; 1)
		chat("fat(%#x)=%#lx...", n, k);

	/*
	 * This is a very strange check for out of range.
	 * As a concrete example, for a 16-bit FAT,
	 * FFF8 through FFFF all signify ``end of cluster chain.''
	 * This generalizes to other-sized FATs.
	 */
	if(k &gt;= (1 &lt;&lt; fb) - 8)
		return -1;

	return k;
}

void
putfat(Xfs *xf, int n, ulong val)
{
	Fatinfo *fi;
	Dosbpb *bp;
	Iosect *p;
	ulong k, sect, esect;
	int o;

	bp = xf-&gt;ptr;
	if(n &lt; FATRESRV || n &gt;= bp-&gt;fatclusters)
		panic("putfat n=%d", n);
	k = (bp-&gt;fatbits * n) &gt;&gt; 3;
	if(k &gt;= bp-&gt;fatsize*bp-&gt;sectsize)
		panic("putfat");
	sect = k/bp-&gt;sectsize + bp-&gt;fataddr;
	esect = sect + bp-&gt;nfats * bp-&gt;fatsize;
	for(; sect&lt;esect; sect+=bp-&gt;fatsize){
		o = k%bp-&gt;sectsize;
		p = getsect(xf, sect);
		if(p == nil)
			continue;
		switch(bp-&gt;fatbits){
		case 12:
			if(n&amp;1){
				p-&gt;iobuf[o] &amp;= 0x0f;
				p-&gt;iobuf[o++] |= val&lt;&lt;4;
				if(o &gt;= bp-&gt;sectsize){
					p-&gt;flags |= BMOD;
					putsect(p);
					p = getsect(xf, sect+1);
					if(p == nil)
						continue;
					o = 0;
				}
				p-&gt;iobuf[o] = val&gt;&gt;4;
			}else{
				p-&gt;iobuf[o++] = val;
				if(o &gt;= bp-&gt;sectsize){
					p-&gt;flags |= BMOD;
					putsect(p);
					p = getsect(xf, sect+1);
					if(p == nil)
						continue;
					o = 0;
				}
				p-&gt;iobuf[o] &amp;= 0xf0;
				p-&gt;iobuf[o] |= (val&gt;&gt;8) &amp; 0x0f;
			}
			break;
		case 16:
			p-&gt;iobuf[o++] = val;
			p-&gt;iobuf[o] = val&gt;&gt;8;
			break;
		case 32:	/* fat32 is really fat28 */
			p-&gt;iobuf[o++] = val;
			p-&gt;iobuf[o++] = val&gt;&gt;8;
			p-&gt;iobuf[o++] = val&gt;&gt;16;
			p-&gt;iobuf[o] = (p-&gt;iobuf[o] &amp; 0xf0) | ((val&gt;&gt;24) &amp; 0x0f);
			break;
		default:
			panic("putfat fatbits");
		}
		p-&gt;flags |= BMOD;
		putsect(p);
	}

	if(val == 0)
		bp-&gt;freeclusters++;
	else
		bp-&gt;freeclusters--;

	if(bp-&gt;fatinfo){
		p = getsect(xf, bp-&gt;fatinfo);
		if(p != nil){
			fi = (Fatinfo*)p-&gt;iobuf;
			PLONG(fi-&gt;nextfree, bp-&gt;freeptr);
			PLONG(fi-&gt;freeclust, bp-&gt;freeclusters);
			p-&gt;flags |= BMOD;
			putsect(p);
		}
	}
}

/*
 * Contiguous falloc; if we can, use lastclust+1.
 * Otherwise, move the file to get some space.
 * If there just isn't enough contiguous space
 * anywhere on disk, fail.
 */
int
cfalloc(Xfile *f)
{
	int l;

	if((l=makecontig(f, 8)) &gt;= 0)
		return l;
	return makecontig(f, 1);
}

/*
 * Check whether a file is contiguous.
 */
int
iscontig(Xfs *xf, Dosdir *d)
{
	long clust, next;

	clust = getstart(xf, d);
	if(clust &lt;= 0)
		return 1;

	for(;;) {
		next = getfat(xf, clust);
		if(next &lt; 0)
			return 1;
		if(next != clust+1)
			return 0;
		clust = next;
	}
}

/*
 * Make a file contiguous, with nextra clusters of 
 * free space after it for later expansion.
 * Return the number of the first new cluster.
 */
int
makecontig(Xfile *f, int nextra)
{
	Dosbpb *bp;
	Dosdir *d;
	Dosptr *dp;
	Xfs *xf;
	Iosect *wp, *rp;
	long clust, next, last, start, rclust, wclust, eclust, ostart;
	int isok, i, n, nclust, nrun, rs, ws;

	xf = f-&gt;xf;
	bp = xf-&gt;ptr;
	dp = f-&gt;ptr;
	d = dp-&gt;d;

	isok = 1;
	nclust = 0;
	clust = fileclust(f, 0, 0);
	chat("clust %#lux", clust);
	if(clust != -1) {
		for(;;) {
			nclust++;
			chat(".");
			next = getfat(xf, clust);
			if(next &lt;= 0)
				break;
			if(next != clust+1)
				isok = 0;
			clust = next;
		}
	}
	chat("nclust %d\n", nclust);

	if(isok &amp;&amp; clust != -1) {
		eclust = clust+1;	/* eclust = first cluster past file */
		assert(eclust == fileclust(f, 0, 0)+nclust);
		for(i=0; i&lt;nextra; i++)
			if(getfat(xf, eclust+i) != 0)
				break;
		if(i == nextra) {	/* they were all free */
			chat("eclust=%#lx, getfat eclust-1 = %#lux\n", eclust, getfat(xf, eclust-1));
			assert(getfat(xf, eclust-1) == 0xffffffff);
			putfat(xf, eclust-1, eclust);
			putfat(xf, eclust, 0xffffffff);
			bp-&gt;freeptr = clust+1;	/* to help keep the blocks free */
			return eclust;
		}
	}

	/* need to search for nclust+nextra contiguous free blocks */
	last = -1;
	n = bp-&gt;freeptr;
	nrun = 0;
	for(;;){
		if(getfat(xf, n) == 0) {
			if(last+1 == n)
				nrun++;
			else
				nrun = 1;
			if(nrun &gt;= nclust+nextra)
				break;
			last = n;
		}
		if(++n &gt;= bp-&gt;fatclusters)
			n = FATRESRV;
		if(n == bp-&gt;freeptr) {
			errno = Econtig;
			return -1;
		}
	}
	bp-&gt;freeptr = n+1;

	/* copy old data over */
	start = n+1 - nrun;

	/* sanity check */
	for(i=0; i&lt;nclust+nextra; i++)
		assert(getfat(xf, start+i) == 0);

	chat("relocate chain %lux -&gt; 0x%lux len %d\n", fileclust(f, 0, 0), start, nclust);

	wclust = start;
	for(rclust = fileclust(f, 0, 0); rclust &gt; 0; rclust = next){
		rs = clust2sect(bp, rclust);
		ws = clust2sect(bp, wclust);
		for(i=0; i&lt;bp-&gt;clustsize; i++, rs++, ws++){
			rp = getsect(xf, rs);
			if(rp == nil)
				return -1;
			wp = getosect(xf, ws);
			assert(wp != nil);
			memmove(wp-&gt;iobuf, rp-&gt;iobuf, bp-&gt;sectsize);
			wp-&gt;flags = BMOD;
			putsect(rp);
			putsect(wp);
		}
		chat("move cluster %#lx -&gt; %#lx...", rclust, wclust);
		next = getfat(xf, rclust);
		putfat(xf, wclust, wclust+1);
		wclust++;
	}

	/* now wclust points at the first new cluster; chain it in */
	chat("wclust 0x%lux start 0x%lux (fat-&gt;0x%lux) nclust %d\n", wclust, start, getfat(xf, start), nclust);
	assert(wclust == start+nclust);
	putfat(xf, wclust, 0xffffffff);	/* end of file */

	/* update directory entry to point at new start */
	ostart = fileclust(f, 0, 0);
	putstart(xf, d, start);

	/* check our work */
	i = 0;
	clust = fileclust(f, 0, 0);
	if(clust != -1) {
		for(;;) {
			i++;
			next = getfat(xf, clust);
			if(next &lt;= 0)
				break;
			assert(next == clust+1);
			clust = next;
		}
	}
	chat("chain check: len %d\n", i);
	assert(i == nclust+1);

	/* succeeded; remove old chain. */
	for(rclust = ostart; rclust &gt; 0; rclust = next){
		next = getfat(xf, rclust);
		putfat(xf, rclust, 0);	/* free cluster */
	}

	return start+nclust;
}	

int
falloc(Xfs *xf)
{
	Dosbpb *bp = xf-&gt;ptr;
	Iosect *p;
	int n, i, k;

	n = bp-&gt;freeptr;
	for(;;){
		if(getfat(xf, n) == 0)
			break;
		if(++n &gt;= bp-&gt;fatclusters)
			n = FATRESRV;
		if(n == bp-&gt;freeptr)
			return -1;
	}
	bp-&gt;freeptr = n+1;
	if(bp-&gt;freeptr &gt;= bp-&gt;fatclusters)
		bp-&gt;freeptr = FATRESRV;
	putfat(xf, n, 0xffffffff);
	k = clust2sect(bp, n);
	for(i=0; i&lt;bp-&gt;clustsize; i++){
		p = getosect(xf, k+i);
		memset(p-&gt;iobuf, 0, bp-&gt;sectsize);
		p-&gt;flags = BMOD;
		putsect(p);
	}
	return n;
}

void
ffree(Xfs *xf, long start)
{
	putfat(xf, start, 0);
}

long
clust2sect(Dosbpb *bp, long clust)
{
	return bp-&gt;dataaddr + (clust - FATRESRV) * bp-&gt;clustsize;
}

long
sect2clust(Dosbpb *bp, long sect)
{
	long c;

	c = (sect - bp-&gt;dataaddr) / bp-&gt;clustsize + FATRESRV;
	assert(sect == clust2sect(bp, c));
	return c;
}

void
puttime(Dosdir *d, long s)
{
	Tm *t;
	ushort x;

	if(s == 0)
		s = time(0);
	t = localtime(s);

	x = (t-&gt;hour&lt;&lt;11) | (t-&gt;min&lt;&lt;5) | (t-&gt;sec&gt;&gt;1);
	PSHORT(d-&gt;time, x);
	x = ((t-&gt;year-80)&lt;&lt;9) | ((t-&gt;mon+1)&lt;&lt;5) | t-&gt;mday;
	PSHORT(d-&gt;date, x);
}

long
gtime(Dosdir *dp)
{
	Tm tm;
	int i;

	i = GSHORT(dp-&gt;time);
	tm.hour = i &gt;&gt; 11;
	tm.min = (i &gt;&gt; 5) &amp; 63;
	tm.sec = (i &amp; 31) &lt;&lt; 1;
	i = GSHORT(dp-&gt;date);
	tm.year = 80 + (i &gt;&gt; 9);
	tm.mon = ((i &gt;&gt; 5) &amp; 15) - 1;
	tm.mday = i &amp; 31;
	tm.zone[0] = '\0';
	tm.tzoff = 0;
	tm.yday = 0;

	return tm2sec(&amp;tm);
}

/*
 * structure dumps for debugging
 */
void
bootdump(int fd, Dosboot *b)
{
	Biobuf bp;

	Binit(&amp;bp, fd, OWRITE);
	Bprint(&amp;bp, "magic: 0x%2.2x 0x%2.2x 0x%2.2x\n",
		b-&gt;magic[0], b-&gt;magic[1], b-&gt;magic[2]);
	Bprint(&amp;bp, "version: \"%8.8s\"\n", (char*)b-&gt;version);
	Bprint(&amp;bp, "sectsize: %d\n", GSHORT(b-&gt;sectsize));
	Bprint(&amp;bp, "clustsize: %d\n", b-&gt;clustsize);
	Bprint(&amp;bp, "nresrv: %d\n", GSHORT(b-&gt;nresrv));
	Bprint(&amp;bp, "nfats: %d\n", b-&gt;nfats);
	Bprint(&amp;bp, "rootsize: %d\n", GSHORT(b-&gt;rootsize));
	Bprint(&amp;bp, "volsize: %d\n", GSHORT(b-&gt;volsize));
	Bprint(&amp;bp, "mediadesc: 0x%2.2x\n", b-&gt;mediadesc);
	Bprint(&amp;bp, "fatsize: %d\n", GSHORT(b-&gt;fatsize));
	Bprint(&amp;bp, "trksize: %d\n", GSHORT(b-&gt;trksize));
	Bprint(&amp;bp, "nheads: %d\n", GSHORT(b-&gt;nheads));
	Bprint(&amp;bp, "nhidden: %ld\n", GLONG(b-&gt;nhidden));
	Bprint(&amp;bp, "bigvolsize: %ld\n", GLONG(b-&gt;bigvolsize));
	Bprint(&amp;bp, "driveno: %d\n", b-&gt;driveno);
	Bprint(&amp;bp, "reserved0: 0x%2.2x\n", b-&gt;reserved0);
	Bprint(&amp;bp, "bootsig: 0x%2.2x\n", b-&gt;bootsig);
	Bprint(&amp;bp, "volid: 0x%8.8lux\n", GLONG(b-&gt;volid));
	Bprint(&amp;bp, "label: \"%11.11s\"\n", (char*)b-&gt;label);
	Bterm(&amp;bp);
}

void
bootdump32(int fd, Dosboot32 *b)
{
	Biobuf bp;

	Binit(&amp;bp, fd, OWRITE);
	Bprint(&amp;bp, "magic: 0x%2.2x 0x%2.2x 0x%2.2x\n",
		b-&gt;magic[0], b-&gt;magic[1], b-&gt;magic[2]);
	Bprint(&amp;bp, "version: \"%8.8s\"\n", (char*)b-&gt;version);
	Bprint(&amp;bp, "sectsize: %d\n", GSHORT(b-&gt;sectsize));
	Bprint(&amp;bp, "clustsize: %d\n", b-&gt;clustsize);
	Bprint(&amp;bp, "nresrv: %d\n", GSHORT(b-&gt;nresrv));
	Bprint(&amp;bp, "nfats: %d\n", b-&gt;nfats);
	Bprint(&amp;bp, "rootsize: %d\n", GSHORT(b-&gt;rootsize));
	Bprint(&amp;bp, "volsize: %d\n", GSHORT(b-&gt;volsize));
	Bprint(&amp;bp, "mediadesc: 0x%2.2x\n", b-&gt;mediadesc);
	Bprint(&amp;bp, "fatsize: %d\n", GSHORT(b-&gt;fatsize));
	Bprint(&amp;bp, "trksize: %d\n", GSHORT(b-&gt;trksize));
	Bprint(&amp;bp, "nheads: %d\n", GSHORT(b-&gt;nheads));
	Bprint(&amp;bp, "nhidden: %ld\n", GLONG(b-&gt;nhidden));
	Bprint(&amp;bp, "bigvolsize: %ld\n", GLONG(b-&gt;bigvolsize));
	Bprint(&amp;bp, "fatsize32: %ld\n", GLONG(b-&gt;fatsize32));
	Bprint(&amp;bp, "extflags: %d\n", GSHORT(b-&gt;extflags));
	Bprint(&amp;bp, "version: %d\n", GSHORT(b-&gt;version1));
	Bprint(&amp;bp, "rootstart: %ld\n", GLONG(b-&gt;rootstart));
	Bprint(&amp;bp, "infospec: %d\n", GSHORT(b-&gt;infospec));
	Bprint(&amp;bp, "backupboot: %d\n", GSHORT(b-&gt;backupboot));
	Bprint(&amp;bp, "reserved: %d %d %d %d %d %d %d %d %d %d %d %d\n",
		b-&gt;reserved[0], b-&gt;reserved[1], b-&gt;reserved[2], b-&gt;reserved[3],
		b-&gt;reserved[4], b-&gt;reserved[5], b-&gt;reserved[6], b-&gt;reserved[7],
		b-&gt;reserved[8], b-&gt;reserved[9], b-&gt;reserved[10], b-&gt;reserved[11]);
	Bterm(&amp;bp);
}

void
bootsecdump32(int fd, Xfs *xf, Dosboot32 *b32)
{
	Fatinfo *fi;
	Iosect *p1;
	int fisec, bsec, res;

	fprint(fd, "\nfat32\n");
	bootdump32(fd, b32);
	res = GSHORT(b32-&gt;nresrv);
	bsec = GSHORT(b32-&gt;backupboot);
	if(bsec &lt; res &amp;&amp; bsec != 0){
		p1 = getsect(xf, bsec);
		if(p1 == nil)
			fprint(fd, "\ncouldn't get backup boot sector: %r\n");
		else{
			fprint(fd, "\nbackup boot\n");
			bootdump32(fd, (Dosboot32*)p1-&gt;iobuf);
			putsect(p1);
		}
	}else if(bsec != 0xffff)
		fprint(fd, "bad backup boot sector: %d reserved %d\n", bsec, res);
	fisec = GSHORT(b32-&gt;infospec);
	if(fisec &lt; res &amp;&amp; fisec != 0){
		p1 = getsect(xf, fisec);
		if(p1 == nil)
			fprint(fd, "\ncouldn't get fat info sector: %r\n");
		else{
			fprint(fd, "\nfat info %d\n", fisec);
			fi = (Fatinfo*)p1-&gt;iobuf;
			fprint(fd, "sig1: 0x%lux sb 0x%lux\n", GLONG(fi-&gt;sig1), FATINFOSIG1);
			fprint(fd, "sig: 0x%lux sb 0x%lux\n", GLONG(fi-&gt;sig), FATINFOSIG);
			fprint(fd, "freeclust: %lud\n", GLONG(fi-&gt;freeclust));
			fprint(fd, "nextfree: %lud\n", GLONG(fi-&gt;nextfree));
			fprint(fd, "reserved: %lud %lud %lud\n", GLONG(fi-&gt;resrv), GLONG(fi-&gt;resrv+4), GLONG(fi-&gt;resrv+8));
			putsect(p1);
		}
	}else if(fisec != 0xffff)
		fprint(2, "bad fat info sector: %d reserved %d\n", bsec, res);
}

void
dirdump(void *vdbuf)
{
	static char attrchar[] = "rhsvda67";
	Dosdir *d;
	char *name, namebuf[DOSNAMELEN];
	char buf[128], *s, *ebuf;
	uchar *dbuf;
	int i;

	if(!chatty)
		return;

	d = vdbuf;

	ebuf = buf + sizeof(buf);
	if(d-&gt;attr == 0xf){
		dbuf = vdbuf;
		name = namebuf + DOSNAMELEN;
		*--name = '\0';
		name = getnamerunes(name, dbuf, 1);
		seprint(buf, ebuf, "\"%s\" %2.2x %2.2ux %2.2ux %d", name, dbuf[0], dbuf[12], dbuf[13], GSHORT(d-&gt;start));
	}else{
		s = seprint(buf, ebuf, "\"%.8s.%.3s\" ", (char*)d-&gt;name, (char*)d-&gt;ext);
		for(i=7; i&gt;=0; i--)
			*s++ = d-&gt;attr&amp;(1&lt;&lt;i) ? attrchar[i] : '-';
	
		i = GSHORT(d-&gt;time);
		s = seprint(s, ebuf, " %2.2d:%2.2d:%2.2d", i&gt;&gt;11, (i&gt;&gt;5)&amp;63, (i&amp;31)&lt;&lt;1);
		i = GSHORT(d-&gt;date);
		s = seprint(s, ebuf, " %2.2d.%2.2d.%2.2d", 80+(i&gt;&gt;9), (i&gt;&gt;5)&amp;15, i&amp;31);
	
		i = GSHORT(d-&gt;ctime);
		s = seprint(s, ebuf, " %2.2d:%2.2d:%2.2d", i&gt;&gt;11, (i&gt;&gt;5)&amp;63, (i&amp;31)&lt;&lt;1);
		i = GSHORT(d-&gt;cdate);
		s = seprint(s, ebuf, " %2.2d.%2.2d.%2.2d", 80+(i&gt;&gt;9), (i&gt;&gt;5)&amp;15, i&amp;31);
	
		i = GSHORT(d-&gt;adate);
		s = seprint(s, ebuf, " %2.2d.%2.2d.%2.2d", 80+(i&gt;&gt;9), (i&gt;&gt;5)&amp;15, i&amp;31);

		seprint(s, ebuf, " %d %d", GSHORT(d-&gt;start), GSHORT(d-&gt;length));
	}
	chat("%s\n", buf);
}

int
cistrcmp(char *s1, char *s2)
{
	int c1, c2;

	while(*s1){
		c1 = *s1++;
		c2 = *s2++;

		if(c1 &gt;= 'A' &amp;&amp; c1 &lt;= 'Z')
			c1 -= 'A' - 'a';

		if(c2 &gt;= 'A' &amp;&amp; c2 &lt;= 'Z')
			c2 -= 'A' - 'a';

		if(c1 != c2)
			return c1 - c2;
	}
	return -*s2;
}

int
utftorunes(Rune *rr, char *s, int n)
{
	Rune *r, *re;
	int c;

	r = rr;
	re = r + n - 1;
	while(c = (uchar)*s){
		if(c &lt; Runeself){
			*r = c;
			s++;
		}else
			s += chartorune(r, s);
		r++;
		if(r &gt;= re)
			break;
	}
	*r = 0;
	return r - rr;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

