<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dossrv/xfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dossrv/xfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "iotrack.h"
#include "dat.h"
#include "fns.h"

#define	FIDMOD	127	/* prime */

static Xfs	*xhead;
static Xfile	*xfiles[FIDMOD], *freelist;
static MLock	xlock, xlocks[FIDMOD], freelock;

static int
okmode(int omode, int fmode)
{
	if(omode == OREAD)
		return fmode &amp; 4;
	/* else ORDWR */
	return (fmode &amp; 6) == 6;
}

Xfs *
getxfs(char *user, char *name)
{
	Xfs *xf, *fxf;
	Dir *dir;
	Qid dqid;
	char *p, *q;
	long offset;
	int fd, omode;

	USED(user);
	if(name==nil || name[0]==0)
		name = deffile;
	if(name == nil){
		errno = Enofilsys;
		return 0;
	}

	/*
	 * If the name passed is of the form 'name:offset' then
	 * offset is used to prime xf-&gt;offset. This allows accessing
	 * a FAT-based filesystem anywhere within a partition.
	 * Typical use would be to mount a filesystem in the presence
	 * of a boot manager programme at the beginning of the disc.
	 */
	offset = 0;
	if(p = strrchr(name, ':')){
		*p++ = 0;
		offset = strtol(p, &amp;q, 0);
		chat("name %s, offset %ld\n", p, offset);
		if(offset &lt; 0 || p == q){
			errno = Enofilsys;
			return 0;
		}
		offset *= Sectorsize;
	}

	if(readonly)
		omode = OREAD;
	else
		omode = ORDWR;
	fd = open(name, omode);

	if(fd &lt; 0 &amp;&amp; omode==ORDWR){
		omode = OREAD;
		fd = open(name, omode);
	}

	if(fd &lt; 0){
		chat("can't open %s: %r\n", name);
		errno = Eerrstr;
		return 0;
	}
	dir = dirfstat(fd);
	if(dir == nil){
		errno = Eio;
		close(fd);
		return 0;
	}

	dqid = dir-&gt;qid;
	free(dir);
	mlock(&amp;xlock);
	for(fxf=0,xf=xhead; xf; xf=xf-&gt;next){
		if(xf-&gt;ref == 0){
			if(fxf == 0)
				fxf = xf;
			continue;
		}
		if(!eqqid(xf-&gt;qid, dqid))
			continue;
		if(strcmp(xf-&gt;name, name) != 0 || xf-&gt;dev &lt; 0)
			continue;
		if(devcheck(xf) &lt; 0) /* look for media change */
			continue;
		if(offset &amp;&amp; xf-&gt;offset != offset)
			continue;
		chat("incref \"%s\", dev=%d...", xf-&gt;name, xf-&gt;dev);
		++xf-&gt;ref;
		unmlock(&amp;xlock);
		close(fd);
		return xf;
	}
	if(fxf == nil){
		fxf = malloc(sizeof(Xfs));
		if(fxf == nil){
			unmlock(&amp;xlock);
			close(fd);
			errno = Enomem;
			return nil;
		}
		fxf-&gt;next = xhead;
		xhead = fxf;
	}
	chat("alloc \"%s\", dev=%d...", name, fd);
	fxf-&gt;name = strdup(name);
	fxf-&gt;ref = 1;
	fxf-&gt;qid = dqid;
	fxf-&gt;dev = fd;
	fxf-&gt;fmt = 0;
	fxf-&gt;offset = offset;
	fxf-&gt;ptr = nil;
	fxf-&gt;isfat32 = 0;
	fxf-&gt;omode = omode;
	unmlock(&amp;xlock);
	return fxf;
}

void
refxfs(Xfs *xf, int delta)
{
	mlock(&amp;xlock);
	xf-&gt;ref += delta;
	if(xf-&gt;ref == 0){
		chat("free \"%s\", dev=%d...", xf-&gt;name, xf-&gt;dev);
		free(xf-&gt;name);
		free(xf-&gt;ptr);
		purgebuf(xf);
		if(xf-&gt;dev &gt;= 0){
			close(xf-&gt;dev);
			xf-&gt;dev = -1;
		}
	}
	unmlock(&amp;xlock);
}

Xfile *
xfile(int fid, int flag)
{
	Xfile **hp, *f, *pf;
	int k;

	k = ((ulong)fid) % FIDMOD;
	hp = &amp;xfiles[k];
	mlock(&amp;xlocks[k]);
	pf = nil;
	for(f=*hp; f; f=f-&gt;next){
		if(f-&gt;fid == fid)
			break;
		pf = f;
	}
	if(f &amp;&amp; pf){
		pf-&gt;next = f-&gt;next;
		f-&gt;next = *hp;
		*hp = f;
	}
	switch(flag){
	default:
		panic("xfile");
	case Asis:
		unmlock(&amp;xlocks[k]);
		return (f &amp;&amp; f-&gt;xf &amp;&amp; f-&gt;xf-&gt;dev &lt; 0) ? nil : f;
	case Clean:
		break;
	case Clunk:
		if(f){
			*hp = f-&gt;next;
			unmlock(&amp;xlocks[k]);
			clean(f);
			mlock(&amp;freelock);
			f-&gt;next = freelist;
			freelist = f;
			unmlock(&amp;freelock);
		} else
			unmlock(&amp;xlocks[k]);
		return nil;
	}
	unmlock(&amp;xlocks[k]);
	if(f)
		return clean(f);
	mlock(&amp;freelock);
	if(f = freelist){	/* assign = */
		freelist = f-&gt;next;
		unmlock(&amp;freelock);
	} else {
		unmlock(&amp;freelock);
		f = malloc(sizeof(Xfile));
		if(f == nil){
			errno = Enomem;
			return nil;
		}
	}
	mlock(&amp;xlocks[k]);
	f-&gt;next = *hp;
	*hp = f;
	unmlock(&amp;xlocks[k]);
	f-&gt;fid = fid;
	f-&gt;flags = 0;
	f-&gt;qid = (Qid){0,0,0};
	f-&gt;xf = nil;
	f-&gt;ptr = nil;
	return f;
}

Xfile *
clean(Xfile *f)
{
	if(f-&gt;ptr){
		free(f-&gt;ptr);
		f-&gt;ptr = nil;
	}
	if(f-&gt;xf){
		refxfs(f-&gt;xf, -1);
		f-&gt;xf = nil;
	}
	f-&gt;flags = 0;
	f-&gt;qid = (Qid){0,0,0};
	return f;
}

/*
 * the file at &lt;addr, offset&gt; has moved
 * relocate the dos entries of all fids in the same file
 */
void
dosptrreloc(Xfile *f, Dosptr *dp, ulong addr, ulong offset)
{
	int i;
	Xfile *p;
	Dosptr *xdp;

	for(i=0; i &lt; FIDMOD; i++){
		for(p = xfiles[i]; p != nil; p = p-&gt;next){
			xdp = p-&gt;ptr;
			if(p != f &amp;&amp; p-&gt;xf == f-&gt;xf
			&amp;&amp; xdp != nil &amp;&amp; xdp-&gt;addr == addr &amp;&amp; xdp-&gt;offset == offset){
				memmove(xdp, dp, sizeof(Dosptr));
				xdp-&gt;p = nil;
				xdp-&gt;d = nil;
				p-&gt;qid.path = QIDPATH(xdp);
			}
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

