<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/eqn/input.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/eqn/input.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "e.h"
#include "y.tab.h"
#include &lt;ctype.h&gt;
#include &lt;errno.h&gt;

Infile	infile[10];
Infile	*curfile = infile;

#define	MAXSRC	50
Src	src[MAXSRC];	/* input source stack */
Src	*srcp	= src;

extern int getarg(char *);
extern	void eprint(void);

void pushsrc(int type, char *ptr)	/* new input source */
{
	if (++srcp &gt;= src + MAXSRC)
		ERROR "inputs nested too deep" FATAL;
	srcp-&gt;type = type;
	srcp-&gt;sp = ptr;
	if (dbg &gt; 1) {
		printf("\n%3d ", srcp - src);
		switch (srcp-&gt;type) {
		case File:
			printf("push file %s\n", ((Infile *)ptr)-&gt;fname);
			break;
		case Macro:
			printf("push macro &lt;%s&gt;\n", ptr);
			break;
		case Char:
			printf("push char &lt;%c&gt;\n", *ptr);
			break;
		case String:
			printf("push string &lt;%s&gt;\n", ptr);
			break;
		case Free:
			printf("push free &lt;%s&gt;\n", ptr);
			break;
		default:
			ERROR "pushed bad type %d\n", srcp-&gt;type FATAL;
		}
	}
}

void popsrc(void)	/* restore an old one */
{
	if (srcp &lt;= src)
		ERROR "too many inputs popped" FATAL;
	if (dbg &gt; 1) {
		printf("%3d ", srcp - src);
		switch (srcp-&gt;type) {
		case File:
			printf("pop file\n");
			break;
		case Macro:
			printf("pop macro\n");
			break;
		case Char:
			printf("pop char &lt;%c&gt;\n", *srcp-&gt;sp);
			break;
		case String:
			printf("pop string\n");
			break;
		case Free:
			printf("pop free\n");
			break;
		default:
			ERROR "pop weird input %d\n", srcp-&gt;type FATAL;
		}
	}
	srcp--;
}

Arg	args[10];	/* argument frames */
Arg	*argfp = args;	/* frame pointer */
int	argcnt;		/* number of arguments seen so far */

void dodef(tbl *stp)	/* collect args and switch input to defn */
{
	int i, len;
	char *p;
	Arg *ap;

	ap = argfp+1;
	if (ap &gt;= args+10)
		ERROR "more than arguments\n" FATAL;
	argcnt = 0;
	if (input() != '(')
		ERROR "disaster in dodef\n"FATAL;
	if (ap-&gt;argval == 0)
		ap-&gt;argval = malloc(1000);
	for (p = ap-&gt;argval; (len = getarg(p)) != -1; p += len) {
		ap-&gt;argstk[argcnt++] = p;
		if (input() == ')')
			break;
	}
	for (i = argcnt; i &lt; MAXARGS; i++)
		ap-&gt;argstk[i] = "";
	if (dbg)
		for (i = 0; i &lt; argcnt; i++)
			printf("arg %d.%d = &lt;%s&gt;\n", ap-args, i+1, ap-&gt;argstk[i]);
	argfp = ap;
	pushsrc(Macro, stp-&gt;cval);
}

getarg(char *p)	/* pick up single argument, store in p, return length */
{
	int n, c, npar;

	n = npar = 0;
	for ( ;; ) {
		c = input();
		if (c == EOF)
			ERROR "end of file in getarg!\n" FATAL;
		if (npar == 0 &amp;&amp; (c == ',' || c == ')'))
			break;
		if (c == '"')	/* copy quoted stuff intact */
			do {
				*p++ = c;
				n++;
			} while ((c = input()) != '"' &amp;&amp; c != EOF);
		else if (c == '(')
			npar++;
		else if (c == ')')
			npar--;
		n++;
		*p++ = c;
	}
	*p = 0;
	unput(c);
	return(n + 1);
}

#define	PBSIZE	2000
char	pbuf[PBSIZE];		/* pushback buffer */
char	*pb	= pbuf-1;	/* next pushed back character */

char	ebuf[200];		/* collect input here for error reporting */
char	*ep	= ebuf;

input(void)
{
	register int c = 0;

  loop:
	switch (srcp-&gt;type) {
	case File:
		c = getc(curfile-&gt;fin);
		if (c == EOF) {
			if (curfile == infile)
				break;
			if (curfile-&gt;fin != stdin) {
				fclose(curfile-&gt;fin);
				free(curfile-&gt;fname);	/* assumes allocated */
			}
			curfile--;
			printf(".lf %d %s\n", curfile-&gt;lineno, curfile-&gt;fname);
			popsrc();
			goto loop;
		}
		if (c == '\n')
			curfile-&gt;lineno++;
		break;
	case Char:
		if (pb &gt;= pbuf) {
			c = *pb--;
			popsrc();
			break;
		} else {	/* can't happen? */
			popsrc();
			goto loop;
		}
	case String:
		c = *srcp-&gt;sp++;
		if (c == '\0') {
			popsrc();
			goto loop;
		} else {
			if (*srcp-&gt;sp == '\0')	/* empty, so pop */
				popsrc();
			break;
		}
	case Macro:
		c = *srcp-&gt;sp++;
		if (c == '\0') {
			if (--argfp &lt; args)
				ERROR "argfp underflow" FATAL;
			popsrc();
			goto loop;
		} else if (c == '$' &amp;&amp; isdigit(*srcp-&gt;sp)) {
			int n = 0;
			while (isdigit(*srcp-&gt;sp))
				n = 10 * n + *srcp-&gt;sp++ - '0';
			if (n &gt; 0 &amp;&amp; n &lt;= MAXARGS)
				pushsrc(String, argfp-&gt;argstk[n-1]);
			goto loop;
		}
		break;
	case Free:	/* free string */
		free(srcp-&gt;sp);
		popsrc();
		goto loop;
	}
	if (ep &gt;= ebuf + sizeof ebuf)
		ep = ebuf;
	*ep++ = c;
	return c;
}


unput(int c)
{
	if (++pb &gt;= pbuf + sizeof pbuf)
		ERROR "pushback overflow\n"FATAL;
	if (--ep &lt; ebuf)
		ep = ebuf + sizeof(ebuf) - 1;
	*pb = c;
	pushsrc(Char, pb);
	return c;
}

void pbstr(char *s)
{
	pushsrc(String, s);
}

void error(int die, char *s)
{
	extern char *cmdname;

	if (synerr)
		return;
	fprintf(stderr, "%s: ", cmdname);
	fprintf(stderr, s);
	if (errno &gt; 0)
		perror("???");
	if (curfile-&gt;fin)
		fprintf(stderr, " near %s:%d",
			curfile-&gt;fname, curfile-&gt;lineno+1);
	fprintf(stderr, "\n");
	eprint();
	synerr = 1;
	errno = 0;
	if (die) {
		if (dbg)
			abort();
		else
			exit(1);
	}
}

void yyerror(char *s)
{
	error(0, s);	/* temporary */
}

char errbuf[200];

void eprint(void)	/* try to print context around error */
{
	char *p, *q;

	if (ep == ebuf)
		return;				/* no context */
	p = ep - 1;
	if (p &gt; ebuf &amp;&amp; *p == '\n')
		p--;
	for ( ; p &gt;= ebuf &amp;&amp; *p != '\n'; p--)
		;
	while (*p == '\n')
		p++;
	fprintf(stderr, " context is\n\t");
	for (q=ep-1; q&gt;=p &amp;&amp; *q!=' ' &amp;&amp; *q!='\t' &amp;&amp; *q!='\n'; q--)
		;
	while (p &lt; q)
		putc(*p++, stderr);
	fprintf(stderr, " &gt;&gt;&gt; ");
	while (p &lt; ep)
		putc(*p++, stderr);
	fprintf(stderr, " &lt;&lt;&lt; ");
	while (pb &gt;= pbuf)
		putc(*pb--, stderr);
	if (curfile-&gt;fin)
		fgets(ebuf, sizeof ebuf, curfile-&gt;fin);
	fprintf(stderr, "%s", ebuf);
	pbstr("\n.EN\n");	/* safety first */
	ep = ebuf;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

