<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ext2srv/ext2subs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ext2srv/ext2subs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ext2subs.c version 0.20
 * 
 * Some strategic functions come from linux/fs/ext2
 * kernel sources written by Remy Card.
 *
*/

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"
#include "fns.h"

#define putext2(e)	putbuf((e).buf)
#define dirtyext2(e)	dirtybuf((e).buf)

static Intmap *uidmap, *gidmap;

static int
getnum(char *s, int *n)
{
	char *r;

	*n = strtol(s, &amp;r, 10);
	return (r != s);
}

static Intmap*
idfile(char *f)
{
	Biobuf *bin;
	Intmap *map;
	char *fields[3];
	char *s;
	int nf, id;

	map = allocmap(0);
	bin = Bopen(f, OREAD);
	if (bin == 0)
		return 0;
	while ((s = Brdline(bin, '\n')) != 0) {
		s[Blinelen(bin)-1] = '\0';
		nf = getfields(s, fields, 3, 0, ":");
		if (nf == 3 &amp;&amp; getnum(fields[2], &amp;id))
			insertkey(map, id, strdup(fields[0]));
	}
	Bterm(bin);
	return map;
}

void
uidfile(char *f)
{
	uidmap = idfile(f);
}

void
gidfile(char *f)
{
	gidmap = idfile(f);
}

static char*
mapuid(int id)
{
	static char s[12];
	char *p;

	if (uidmap &amp;&amp; (p = lookupkey(uidmap, id)) != 0)
		return p;
	sprint(s, "%d", id);
	return s;
}

static char*
mapgid(int id)
{
	static char s[12];
	char *p;

	if (gidmap &amp;&amp; (p = lookupkey(gidmap, id)) != 0)
		return p;
	sprint(s, "%d", id);
	return s;
}

int
ext2fs(Xfs *xf)
{
	SuperBlock superblock;

	/* get the super block */
	seek(xf-&gt;dev, OFFSET_SUPER_BLOCK, 0);
	if( sizeof(SuperBlock) != 
				read(xf-&gt;dev, &amp;superblock, sizeof(SuperBlock)) ){
		chat("can't read super block %r...", xf-&gt;dev);
		errno = Eformat;
		return -1;
	}
	if( superblock.s_magic != EXT2_SUPER_MAGIC ){
		chat("Bad super block...");
		errno = Eformat;
		return -1;
	}
	if( !(superblock.s_state &amp; EXT2_VALID_FS) ){
		chat("fs not checked...");
		errno = Enotclean;
		return -1;
	}
	
	xf-&gt;block_size = EXT2_MIN_BLOCK_SIZE &lt;&lt; superblock.s_log_block_size;
	xf-&gt;desc_per_block = xf-&gt;block_size / sizeof (GroupDesc);
	xf-&gt;inodes_per_group = superblock.s_inodes_per_group;
	xf-&gt;inodes_per_block = xf-&gt;block_size / sizeof (Inode);
	xf-&gt;addr_per_block = xf-&gt;block_size / sizeof (uint);
	xf-&gt;blocks_per_group = superblock.s_blocks_per_group;

	if( xf-&gt;block_size == OFFSET_SUPER_BLOCK )
		xf-&gt;superaddr = 1, xf-&gt;superoff = 0, xf-&gt;grpaddr = 2;
	else if( xf-&gt;block_size == 2*OFFSET_SUPER_BLOCK ||
			xf-&gt;block_size == 4*OFFSET_SUPER_BLOCK )
		xf-&gt;superaddr = 0, xf-&gt;superoff = OFFSET_SUPER_BLOCK, xf-&gt;grpaddr = 1;
	else {
		chat(" blocks of %d bytes are not supported...", xf-&gt;block_size);
		errno = Eformat;
		return -1;
	}

	chat("good super block...");

	xf-&gt;ngroups = (superblock.s_blocks_count - 
				superblock.s_first_data_block + 
				superblock.s_blocks_per_group -1) / 
				superblock.s_blocks_per_group;

	superblock.s_state &amp;= ~EXT2_VALID_FS;
	superblock.s_mnt_count++;
	seek(xf-&gt;dev, OFFSET_SUPER_BLOCK, 0);
	if( !rdonly &amp;&amp; sizeof(SuperBlock) != 
				write(xf-&gt;dev, &amp;superblock, sizeof(SuperBlock)) ){
		chat("can't write super block...");
		errno = Eio;
		return -1;
	}

	return 0;
}
Ext2
getext2(Xfs *xf, char type, int n)
{
	Iobuf *bd;
	Ext2 e;

	switch(type){
	case EXT2_SUPER:
		e.buf = getbuf(xf, xf-&gt;superaddr);
		if( !e.buf ) goto error;
		e.u.sb = (SuperBlock *)(e.buf-&gt;iobuf + xf-&gt;superoff);
		e.type = EXT2_SUPER;
		break;
	case EXT2_DESC:
		e.buf = getbuf(xf, DESC_ADDR(xf, n));
		if( !e.buf ) goto error;
		e.u.gd = DESC_OFFSET(xf, e.buf-&gt;iobuf, n);
		e.type = EXT2_DESC;
		break;
	case EXT2_BBLOCK:
		bd = getbuf(xf, DESC_ADDR(xf, n));
		if( !bd ) goto error;
		e.buf = getbuf(xf, DESC_OFFSET(xf, bd-&gt;iobuf, n)-&gt;bg_block_bitmap);
		if( !e.buf ){
			putbuf(bd);
			goto error;
		}
		putbuf(bd);
		e.u.bmp = (char *)e.buf-&gt;iobuf;
		e.type = EXT2_BBLOCK;
		break;
	case EXT2_BINODE:
		bd = getbuf(xf, DESC_ADDR(xf, n));
		if( !bd ) goto error;
		e.buf = getbuf(xf, DESC_OFFSET(xf, bd-&gt;iobuf, n)-&gt;bg_inode_bitmap);
		if( !e.buf ){
			putbuf(bd);
			goto error;
		}
		putbuf(bd);
		e.u.bmp = (char *)e.buf-&gt;iobuf;
		e.type = EXT2_BINODE;
		break;
	default:
		goto error;
	}
	return e;
error:
	panic("getext2");
	return e;
}
int
get_inode( Xfile *file, uint nr )
{
	unsigned long block_group, block;
	Xfs *xf = file-&gt;xf;
	Ext2 ed, es;

	es = getext2(xf, EXT2_SUPER, 0);
	if(nr &gt; es.u.sb-&gt;s_inodes_count ){
		chat("inode number %d is too big...", nr);
		putext2(es);
		errno = Eio;
		return -1;
	}
	putext2(es);
	block_group = (nr - 1) / xf-&gt;inodes_per_group;
	if( block_group &gt;= xf-&gt;ngroups ){
		chat("block group (%d) &gt; groups count...", block_group);
		errno = Eio;
		return -1;
	}
	ed = getext2(xf, EXT2_DESC, block_group);
	block = ed.u.gd-&gt;bg_inode_table + (((nr-1) % xf-&gt;inodes_per_group) / 
			xf-&gt;inodes_per_block);
	putext2(ed);

	file-&gt;bufoffset = (nr-1) % xf-&gt;inodes_per_block;
	file-&gt;inbr = nr;
	file-&gt;bufaddr= block;

	return 1;
}
int
get_file( Xfile *f, char *name)
{	
	uint offset, nr, i;
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	int nblock;
	DirEntry *dir;
	Iobuf *buf, *ibuf;
	
	if( !S_ISDIR(getmode(f)) )
		return -1;
	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;
	nblock = (inode-&gt;i_blocks * 512) / xf-&gt;block_size;

	for(i=0 ; (i &lt; nblock) &amp;&amp; (i &lt; EXT2_NDIR_BLOCKS) ; i++){
		buf = getbuf(xf, inode-&gt;i_block[i]);
		if( !buf ){
			putbuf(ibuf);
			return -1;
		}
		for(offset=0 ; offset &lt; xf-&gt;block_size ;  ){
			dir = (DirEntry *)(buf-&gt;iobuf + offset);
			if( dir-&gt;name_len==strlen(name) &amp;&amp; 
					!strncmp(name, dir-&gt;name, dir-&gt;name_len) ){
				nr = dir-&gt;inode;
				putbuf(buf);
				putbuf(ibuf);
				return nr;
			}
			offset += dir-&gt;rec_len;
		}
		putbuf(buf);

	}
	putbuf(ibuf);
	errno = Enonexist;
	return -1;
}
char *
getname(Xfile *f, char *str)
{
	Xfile ft;
	int offset, i, len;
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	int nblock;
	DirEntry *dir;
	Iobuf *buf, *ibuf;

	ft = *f;
	if( get_inode(&amp;ft, f-&gt;pinbr) &lt; 0 )
		return 0;
	if( !S_ISDIR(getmode(&amp;ft)) )
		return 0;
	ibuf = getbuf(xf, ft.bufaddr);
	if( !ibuf )
		return 0;
	inode = ((Inode *)ibuf-&gt;iobuf) + ft.bufoffset;
	nblock = (inode-&gt;i_blocks * 512) / xf-&gt;block_size;

	for(i=0 ; (i &lt; nblock) &amp;&amp; (i &lt; EXT2_NDIR_BLOCKS) ; i++){
		buf = getbuf(xf, inode-&gt;i_block[i]);
		if( !buf ){
			putbuf(ibuf);
			return 0;
		}
		for(offset=0 ; offset &lt; xf-&gt;block_size ;  ){
			dir = (DirEntry *)(buf-&gt;iobuf + offset);
			if( f-&gt;inbr == dir-&gt;inode ){
				len = (dir-&gt;name_len &lt; EXT2_NAME_LEN) ? dir-&gt;name_len : EXT2_NAME_LEN;
				if (str == 0)
					str = malloc(len+1);
				strncpy(str, dir-&gt;name, len);   
				str[len] = 0;
				putbuf(buf);
				putbuf(ibuf);
				return str;
			}
			offset += dir-&gt;rec_len;
		}
		putbuf(buf);
	}
	putbuf(ibuf);
	errno = Enonexist;
	return 0;
}
void
dostat(Qid qid, Xfile *f, Dir *dir )
{
	Inode *inode;
	Iobuf *ibuf;
	char *name;

	memset(dir, 0, sizeof(Dir));

	if(  f-&gt;inbr == EXT2_ROOT_INODE ){
		dir-&gt;name = estrdup9p("/");
		dir-&gt;qid = (Qid){0,0,QTDIR};
		dir-&gt;mode = DMDIR | 0777;
	}else{
		ibuf = getbuf(f-&gt;xf, f-&gt;bufaddr);
		if( !ibuf )
			return;
		inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;
		dir-&gt;length = inode-&gt;i_size;
		dir-&gt;atime = inode-&gt;i_atime;
		dir-&gt;mtime = inode-&gt;i_mtime;
		putbuf(ibuf);
		name = getname(f, 0);
		dir-&gt;name = name;
		dir-&gt;uid = estrdup9p(mapuid(inode-&gt;i_uid));
		dir-&gt;gid = estrdup9p(mapgid(inode-&gt;i_gid));
		dir-&gt;qid = qid;
		dir-&gt;mode = getmode(f);
		if( qid.type &amp; QTDIR )
			dir-&gt;mode |= DMDIR;
	}

}
int 
dowstat(Xfile *f, Dir *stat)
{
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	Xfile fdir;
	Iobuf *ibuf;
	char name[EXT2_NAME_LEN+1];

	/* change name */
	getname(f, name);
	if( stat-&gt;name &amp;&amp; stat-&gt;name[0] != 0 &amp;&amp; strcmp(name, stat-&gt;name) ){

		/* get dir */
		fdir = *f;
		if( get_inode(&amp;fdir, f-&gt;pinbr) &lt; 0 ){
			chat("can't get inode %d...", f-&gt;pinbr);
			return -1;
		}
	
		ibuf = getbuf(xf, fdir.bufaddr);
		if( !ibuf )
			return -1;
		inode = ((Inode *)ibuf-&gt;iobuf) +fdir.bufoffset;

		/* Clean old dir entry */
		if( delete_entry(xf, inode, f-&gt;inbr) &lt; 0 ){
			chat("delete entry failed...");
			putbuf(ibuf);	
			return -1;
		}
		putbuf(ibuf);

		/* add the new entry */
		if( add_entry(&amp;fdir, stat-&gt;name, f-&gt;inbr) &lt; 0 ){
			chat("add entry failed...");	
			return -1;
		}
	
	}

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;

	if (stat-&gt;mode != ~0)
	if( (getmode(f) &amp; 0777) != (stat-&gt;mode &amp; 0777) ){
		inode-&gt;i_mode = (getmode(f) &amp; ~0777) | (stat-&gt;mode &amp; 0777);
		dirtybuf(ibuf);
	}
	if (stat-&gt;mtime != ~0)
	if(  inode-&gt;i_mtime != stat-&gt;mtime ){
		inode-&gt;i_mtime = stat-&gt;mtime;
		dirtybuf(ibuf);
	}

	putbuf(ibuf);

	return 1;
}
long
readfile(Xfile *f, void *vbuf, vlong offset, long count)
{
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	Iobuf *buffer, *ibuf;
	long rcount;
	int len, o, cur_block, baddr;
	uchar *buf;

	buf = vbuf;
	
	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;

	if( offset &gt;= inode-&gt;i_size ){
		putbuf(ibuf);
		return 0;
	}
	if( offset + count &gt; inode-&gt;i_size )
		count = inode-&gt;i_size - offset;

	/* fast link */
	if( S_ISLNK(getmode(f)) &amp;&amp; (inode-&gt;i_size &lt;= EXT2_N_BLOCKS&lt;&lt;2) ){
		memcpy(&amp;buf[0], ((char *)inode-&gt;i_block)+offset, count);
		putbuf(ibuf);	
		return count;
	}
	chat("read block [ ");
	cur_block = offset / xf-&gt;block_size;
	o = offset % xf-&gt;block_size;
	rcount = 0;
	while( count &gt; 0 ){
		baddr = bmap(f, cur_block++);
		if( !baddr ){
			putbuf(ibuf);
			return -1;
		}
		buffer = getbuf(xf, baddr);
		if( !buffer ){
			putbuf(ibuf);
			return -1;
		}
		chat("%d ", baddr);
		len = xf-&gt;block_size - o;
		if( len &gt; count )
			len = count;
		memcpy(&amp;buf[rcount], &amp;buffer-&gt;iobuf[o], len);
		rcount += len;
		count -= len;
		o = 0;
		putbuf(buffer);
	}
	chat("] ...");
	inode-&gt;i_atime = time(0);
	dirtybuf(ibuf);
	putbuf(ibuf);
	return rcount;
}
long
readdir(Xfile *f, void *vbuf, vlong offset, long count)
{
	int off, i, len;
	long rcount;
	Xfs *xf = f-&gt;xf;
	Inode *inode, *tinode;
	int nblock;
	DirEntry *edir;
	Iobuf *buffer, *ibuf, *tbuf;
	Dir pdir;
	Xfile ft;
	uchar *buf;
	char name[EXT2_NAME_LEN+1];
	unsigned int dirlen;
	int index;

	buf = vbuf;
	if (offset == 0)
		f-&gt;dirindex = 0;
	
	if( !S_ISDIR(getmode(f)) )
		return -1;

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;
	nblock = (inode-&gt;i_blocks * 512) / xf-&gt;block_size;
	ft = *f;
	chat("read block [ ");
	index = 0;
	for(i=0, rcount=0 ; (i &lt; nblock) &amp;&amp; (i &lt; EXT2_NDIR_BLOCKS) ; i++){
		
		buffer = getbuf(xf, inode-&gt;i_block[i]);
		if( !buffer ){
			putbuf(ibuf);
			return -1;
		}
		chat("%d, ", buffer-&gt;addr);
		for(off=0 ; off &lt; xf-&gt;block_size ;  ){
		
			edir = (DirEntry *)(buffer-&gt;iobuf + off);	
			off += edir-&gt;rec_len;
			if( (edir-&gt;name[0] == '.' ) &amp;&amp; (edir-&gt;name_len == 1))
				continue;
			if(edir-&gt;name[0] == '.' &amp;&amp; edir-&gt;name[1] == '.' &amp;&amp; 
										edir-&gt;name_len == 2)
				continue;
			if( edir-&gt;inode == 0 ) /* for lost+found dir ... */
				continue;
			if( index++ &lt; f-&gt;dirindex )
				continue;
			
			if( get_inode(&amp;ft, edir-&gt;inode) &lt; 0 ){
				chat("can't find ino no %d ] ...", edir-&gt;inode);
error:			putbuf(buffer);
				putbuf(ibuf);
				return -1;
			}
			tbuf = getbuf(xf, ft.bufaddr);
			if( !tbuf )
				goto error;
			tinode = ((Inode *)tbuf-&gt;iobuf) + ft.bufoffset;

			memset(&amp;pdir, 0, sizeof(Dir));			
			
			/* fill plan9 dir struct */			
			pdir.name = name;
			len = (edir-&gt;name_len &lt; EXT2_NAME_LEN) ? edir-&gt;name_len : EXT2_NAME_LEN;
			strncpy(pdir.name, edir-&gt;name, len);   
			pdir.name[len] = 0;
// chat("name %s len %d\n", pdir.name, edir-&gt;name_len);
			pdir.uid = mapuid(tinode-&gt;i_uid);
			pdir.gid = mapgid(tinode-&gt;i_gid);
			pdir.qid.path = edir-&gt;inode;
			pdir.mode = tinode-&gt;i_mode;
			if( edir-&gt;inode == EXT2_ROOT_INODE )
				pdir.qid.path = f-&gt;xf-&gt;rootqid.path;
			else if( S_ISDIR( tinode-&gt;i_mode) )
				pdir.qid.type |= QTDIR;
			if( pdir.qid.type &amp; QTDIR )
				pdir.mode |= DMDIR;
			pdir.length = tinode-&gt;i_size;
			pdir.atime = tinode-&gt;i_atime;
			pdir.mtime = tinode-&gt;i_mtime;
		
			putbuf(tbuf);

			dirlen = convD2M(&amp;pdir, &amp;buf[rcount], count-rcount);
			if ( dirlen &lt;= BIT16SZ ) {
				chat("] ...");
				putbuf(buffer);
				putbuf(ibuf);
				return rcount;
			}
			rcount += dirlen;
			f-&gt;dirindex++;

		}
		putbuf(buffer);
	}
	chat("] ...");
	putbuf(ibuf);
	return rcount;
}
int
bmap( Xfile *f, int block )
{
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	Iobuf *buf, *ibuf;
	int addr;
	int addr_per_block = xf-&gt;addr_per_block;
	int addr_per_block_bits = ffz(~addr_per_block);
	
	if(block &lt; 0) {
		chat("bmap() block &lt; 0 ...");
		return 0;
	}
	if(block &gt;= EXT2_NDIR_BLOCKS + addr_per_block +
		(1 &lt;&lt; (addr_per_block_bits * 2)) +
		((1 &lt;&lt; (addr_per_block_bits * 2)) &lt;&lt; addr_per_block_bits)) {
		chat("bmap() block &gt; big...");
		return 0;
	}

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return 0;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;

	/* direct blocks */
	if(block &lt; EXT2_NDIR_BLOCKS){
		putbuf(ibuf);
		return inode-&gt;i_block[block];
	}
	block -= EXT2_NDIR_BLOCKS;
	
	/* indirect blocks*/
	if(block &lt; addr_per_block) {
		addr = inode-&gt;i_block[EXT2_IND_BLOCK];
		if (!addr) goto error;
		buf = getbuf(xf, addr);
		if( !buf ) goto error;
		addr = *(((uint *)buf-&gt;iobuf) + block);
		putbuf(buf);
		putbuf(ibuf);
		return addr;	
	}
	block -= addr_per_block;
	
	/* double indirect blocks */
	if(block &lt; (1 &lt;&lt; (addr_per_block_bits * 2))) {
		addr = inode-&gt;i_block[EXT2_DIND_BLOCK];
		if (!addr) goto error;
		buf = getbuf(xf, addr);
		if( !buf ) goto error;
		addr = *(((uint *)buf-&gt;iobuf) + (block &gt;&gt; addr_per_block_bits));
		putbuf(buf);
		buf = getbuf(xf, addr);
		if( !buf ) goto error;
		addr = *(((uint *)buf-&gt;iobuf) + (block &amp; (addr_per_block - 1)));
		putbuf(buf);
		putbuf(ibuf);
		return addr;
	}
	block -= (1 &lt;&lt; (addr_per_block_bits * 2));

	/* triple indirect blocks */
	addr = inode-&gt;i_block[EXT2_TIND_BLOCK];
	if(!addr) goto error;
	buf = getbuf(xf, addr);
	if( !buf ) goto error;
	addr = *(((uint *)buf-&gt;iobuf) + (block &gt;&gt; (addr_per_block_bits * 2)));
	putbuf(buf);
	if(!addr) goto error;
	buf = getbuf(xf, addr);
	if( !buf ) goto error;
	addr = *(((uint *)buf-&gt;iobuf) +
			((block &gt;&gt; addr_per_block_bits) &amp; (addr_per_block - 1)));
	putbuf(buf);
	if(!addr) goto error;
	buf = getbuf(xf, addr);
	if( !buf ) goto error;
	addr = *(((uint *)buf-&gt;iobuf) + (block &amp; (addr_per_block - 1)));
	putbuf(buf);
	putbuf(ibuf);
	return addr;
error:
	putbuf(ibuf);
	return 0;
}
long
writefile(Xfile *f, void *vbuf, vlong offset, long count)
{
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	Iobuf *buffer, *ibuf;
	long w;
	int len, o, cur_block, baddr;
	char *buf;

	buf = vbuf;

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;

	chat("write block [ ");
	cur_block = offset / xf-&gt;block_size;
	o = offset % xf-&gt;block_size;
	w = 0;
	while( count &gt; 0 ){
		baddr = getblk(f, cur_block++);
		if( baddr &lt;= 0 )
			goto end;
		buffer = getbuf(xf, baddr);
		if( !buffer )
			goto end;
		chat("%d ", baddr);
		len = xf-&gt;block_size - o;
		if( len &gt; count )
			len = count;
		memcpy(&amp;buffer-&gt;iobuf[o], &amp;buf[w], len);
		dirtybuf(buffer);
		w += len;
		count -= len;
		o = 0;
		putbuf(buffer);
	}
end:
	if( inode-&gt;i_size &lt; offset + w )
		inode-&gt;i_size = offset + w;
	inode-&gt;i_atime = inode-&gt;i_mtime = time(0);
	dirtybuf(ibuf);
	putbuf(ibuf);
	chat("]...");
	if( errno )
		return -1;
	return w;
}
int 
new_block( Xfile *f, int goal )
{
	Xfs *xf= f-&gt;xf;
	int group, block, baddr, k, redo;
	ulong lmap;
	char *p, *r;
	Iobuf *buf;
	Ext2 ed, es, eb;
	
	es = getext2(xf, EXT2_SUPER, 0);
	redo = 0;
 
repeat:
	
	if( goal &lt; es.u.sb-&gt;s_first_data_block || goal &gt;= es.u.sb-&gt;s_blocks_count )
		goal = es.u.sb-&gt;s_first_data_block;
	group = (goal - es.u.sb-&gt;s_first_data_block) / xf-&gt;blocks_per_group;

	ed = getext2(xf, EXT2_DESC, group);
	eb = getext2(xf, EXT2_BBLOCK, group);

	/* 
	 * First, test if goal block is free
	 */
	if( ed.u.gd-&gt;bg_free_blocks_count &gt; 0 ){
		block = (goal - es.u.sb-&gt;s_first_data_block) % xf-&gt;blocks_per_group;
		
		if( !test_bit(block, eb.u.bmp) )
			goto got_block;
		
		if( block ){
			/*
			 * goal wasn't free ; search foward for a free 
			 * block within the next 32 blocks
			*/
			
			lmap = (((ulong *)eb.u.bmp)[block&gt;&gt;5]) &gt;&gt;
					((block &amp; 31) + 1);
			if( block &lt; xf-&gt;blocks_per_group - 32 )
				lmap |= (((ulong *)eb.u.bmp)[(block&gt;&gt;5)+1]) &lt;&lt;
					( 31-(block &amp; 31) );
			else
				lmap |= 0xffffffff &lt;&lt; ( 31-(block &amp; 31) );

			if( lmap != 0xffffffffl ){
				k = ffz(lmap) + 1;
				if( (block + k) &lt; xf-&gt;blocks_per_group ){
					block += k;
					goto got_block;
				}
			}			
		}
		/*
		 * Search in the remaider of the group
		*/
		p = eb.u.bmp + (block&gt;&gt;3);
		r = memscan(p, 0, (xf-&gt;blocks_per_group - block + 7) &gt;&gt;3);
		k = ( r - eb.u.bmp )&lt;&lt;3;
		if( k &lt; xf-&gt;blocks_per_group ){
			block = k;
			goto search_back;
		}
		k = find_next_zero_bit((unsigned long *)eb.u.bmp, 
						xf-&gt;blocks_per_group&gt;&gt;3, block);
		if( k &lt; xf-&gt;blocks_per_group ){
			block = k;
			goto got_block;
		}
	}

	/*
	 * Search the rest of groups
	*/
	putext2(ed); putext2(eb);
	for(k=0 ; k &lt; xf-&gt;ngroups ; k++){
		group++;
		if( group &gt;= xf-&gt;ngroups )
			group = 0;
		ed = getext2(xf, EXT2_DESC, group);
		if( ed.u.gd-&gt;bg_free_blocks_count &gt; 0 )
			break;
		putext2(ed);
	}
	if( redo &amp;&amp; group == xf-&gt;ngroups-1 ){
		putext2(ed);
		goto full;
	}
	if( k &gt;=xf-&gt;ngroups ){
		/*
		 * All groups are full or
		 * we have retry (because the last block) and all other
		 * groups are also full.
		*/
full:	
		chat("no free blocks ...");
	 	putext2(es); 
		errno = Enospace;
		return 0;
	}
	eb = getext2(xf, EXT2_BBLOCK, group);
	r = memscan(eb.u.bmp,  0, xf-&gt;blocks_per_group&gt;&gt;3);
	block = (r - eb.u.bmp) &lt;&lt;3;
	if( block &lt; xf-&gt;blocks_per_group )
		goto search_back;
	else
		block = find_first_zero_bit((ulong *)eb.u.bmp,
								xf-&gt;blocks_per_group&gt;&gt;3);
	if( block &gt;= xf-&gt;blocks_per_group ){
		chat("Free block count courupted for block group %d...", group);
		putext2(ed); putext2(eb); putext2(es);
		errno = Ecorrupt;
		return 0;
	}


search_back:
	/*
	 * A free byte was found in the block. Now search backwards up
	 * to 7 bits to find the start of this group of free block.
	*/
	for(k=0 ; k &lt; 7 &amp;&amp; block &gt; 0 &amp;&amp; 
		!test_bit(block-1, eb.u.bmp) ; k++, block--);

got_block:

	baddr = block + (group * xf-&gt;blocks_per_group) + 
				es.u.sb-&gt;s_first_data_block;
	
	if( baddr == ed.u.gd-&gt;bg_block_bitmap ||
	     baddr == ed.u.gd-&gt;bg_inode_bitmap ){
		chat("Allocating block in system zone...");
		putext2(ed); putext2(eb); putext2(es);
		errno = Eintern;
		return 0;
	}

	if( set_bit(block, eb.u.bmp) ){
		chat("bit already set (%d)...", block);
		putext2(ed); putext2(eb); putext2(es);
		errno = Ecorrupt;
		return 0;
	}
	dirtyext2(eb);
	
	if( baddr &gt;= es.u.sb-&gt;s_blocks_count ){
		chat("block &gt;= blocks count...");
		errno = Eintern;
error:
		clear_bit(block, eb.u.bmp);
		putext2(eb); putext2(ed); putext2(es);
		return 0;
	}
	
	buf = getbuf(xf, baddr);
	if( !buf ){
		if( !redo ){
			/*
			 * It's perhaps the last block of the disk and 
			 * it can't be acceded because the last sector.
			 * Therefore, we try one more time with goal at 0
			 * to force scanning all groups.
			*/
			clear_bit(block, eb.u.bmp);
			putext2(eb); putext2(ed);
			goal = 0; errno = 0; redo++;
			goto repeat;
		}
		goto error;
	}
	memset(&amp;buf-&gt;iobuf[0], 0, xf-&gt;block_size);
	dirtybuf(buf);
	putbuf(buf);

	es.u.sb-&gt;s_free_blocks_count--;
	dirtyext2(es);
	ed.u.gd-&gt;bg_free_blocks_count--;
	dirtyext2(ed);

	putext2(eb);
	putext2(ed);
	putext2(es);
	chat("new ");
	return baddr;
}
int
getblk(Xfile *f, int block)
{
	Xfs *xf = f-&gt;xf;
	int baddr;
	int addr_per_block = xf-&gt;addr_per_block;

	if (block &lt; 0) {
		chat("getblk() block &lt; 0 ...");
		return 0;
	}
	if(block &gt; EXT2_NDIR_BLOCKS + addr_per_block +
			addr_per_block * addr_per_block +
			addr_per_block * addr_per_block * addr_per_block ){
		chat("getblk() block &gt; big...");
		errno = Eintern;
		return 0;
	}
	if( block &lt; EXT2_NDIR_BLOCKS )
		return inode_getblk(f, block);
	block -= EXT2_NDIR_BLOCKS;	
	if( block &lt; addr_per_block ){
		baddr = inode_getblk(f, EXT2_IND_BLOCK);
		baddr = block_getblk(f, baddr, block);
		return baddr;
	}
	block -= addr_per_block;
	if( block &lt; addr_per_block * addr_per_block  ){
		baddr = inode_getblk(f, EXT2_DIND_BLOCK);
		baddr = block_getblk(f, baddr, block / addr_per_block);
		baddr = block_getblk(f, baddr, block &amp; ( addr_per_block-1));
		return baddr; 
	}
	block -= addr_per_block * addr_per_block;
	baddr = inode_getblk(f, EXT2_TIND_BLOCK);
	baddr = block_getblk(f, baddr, block / (addr_per_block * addr_per_block));
	baddr = block_getblk(f, baddr, (block / addr_per_block) &amp; ( addr_per_block-1));
	return block_getblk(f, baddr, block &amp; ( addr_per_block-1));
}
int
block_getblk(Xfile *f, int rb, int nr)
{
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	int tmp, goal = 0;
	int blocks = xf-&gt;block_size / 512;
	Iobuf *buf, *ibuf;
	uint *p;
	Ext2 es;

	if( !rb )
		return 0;

	buf = getbuf(xf, rb);
	if( !buf )
		return 0;
	p = (uint *)(buf-&gt;iobuf) + nr;
	if( *p ){
		tmp = *p;
		putbuf(buf);
		return tmp;
	}

	for(tmp=nr - 1 ; tmp &gt;= 0 ; tmp--){
		if( ((uint *)(buf-&gt;iobuf))[tmp] ){
			goal = ((uint *)(buf-&gt;iobuf))[tmp];
			break;
		}
	}
	if( !goal ){
		es = getext2(xf, EXT2_SUPER, 0);
		goal = (((f-&gt;inbr -1) / xf-&gt;inodes_per_group) *
				xf-&gt;blocks_per_group) +
				es.u.sb-&gt;s_first_data_block;
		putext2(es);
	}
	
	tmp = new_block(f, goal);
	if( !tmp ){
		putbuf(buf);
		return 0;
	}

	*p = tmp;
	dirtybuf(buf);
	putbuf(buf);
	
	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;
	inode-&gt;i_blocks += blocks;
	dirtybuf(ibuf);
	putbuf(ibuf);

	return tmp;
}
int 
inode_getblk(Xfile *f, int block)
{
	Xfs *xf = f-&gt;xf;
	Inode *inode;
	Iobuf *ibuf;
	int tmp, goal = 0;
	int blocks = xf-&gt;block_size / 512;
	Ext2 es;

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;


	if( inode-&gt;i_block[block] ){
		putbuf(ibuf);
		return inode-&gt;i_block[block];
	}

	for(tmp=block - 1 ; tmp &gt;= 0 ; tmp--){
		if( inode-&gt;i_block[tmp] ){
			goal = inode-&gt;i_block[tmp];
			break;
		}
	}
	if( !goal ){
		es = getext2(xf, EXT2_SUPER, 0);
		goal = (((f-&gt;inbr -1) / xf-&gt;inodes_per_group) *
				xf-&gt;blocks_per_group) +
				es.u.sb-&gt;s_first_data_block;
		putext2(es);
	}

	tmp = new_block(f, goal);
	if( !tmp ){
		putbuf(ibuf);
		return 0;
	}

	inode-&gt;i_block[block] = tmp;
	inode-&gt;i_blocks += blocks;
	dirtybuf(ibuf);
	putbuf(ibuf);

	return tmp;
}
int 
new_inode(Xfile *f, int mode)
{
	Xfs *xf = f-&gt;xf;
	Inode *inode, *finode;
	Iobuf *buf, *ibuf;
	int ave,group, i, j;
	Ext2 ed, es, eb;

	group = -1;

	es = getext2(xf, EXT2_SUPER, 0);

	if( S_ISDIR(mode) ){	/* create directory inode */
		ave = es.u.sb-&gt;s_free_inodes_count / xf-&gt;ngroups;
		for(i=0 ; i &lt; xf-&gt;ngroups ; i++){
			ed = getext2(xf, EXT2_DESC, i);
			if( ed.u.gd-&gt;bg_free_inodes_count &amp;&amp;
					ed.u.gd-&gt;bg_free_inodes_count &gt;= ave ){
				if( group&lt;0 || ed.u.gd-&gt;bg_free_inodes_count &gt;
								ed.u.gd-&gt;bg_free_inodes_count )
					group = i;
			}
			putext2(ed);
		}

	}else{		/* create file inode */
		/* Try to put inode in its parent directory */
		i = (f-&gt;inbr -1) / xf-&gt;inodes_per_group;
		ed = getext2(xf, EXT2_DESC, i);
		if( ed.u.gd-&gt;bg_free_inodes_count ){
			group = i;
			putext2(ed);
		}else{
			/*
			 * Use a quadratic hash to find a group whith
			 * a free inode
			 */
			putext2(ed);
			for( j=1 ; j &lt; xf-&gt;ngroups ; j &lt;&lt;= 1){
				i += j;
				if( i &gt;= xf-&gt;ngroups )
					i -= xf-&gt;ngroups;
				ed = getext2(xf, EXT2_DESC, i);
				if( ed.u.gd-&gt;bg_free_inodes_count ){
					group = i;
					putext2(ed);
					break;
				}
				putext2(ed);
			}
		}
		if( group &lt; 0 ){
			/* try a linear search */
			i = ((f-&gt;inbr -1) / xf-&gt;inodes_per_group) + 1;
			for(j=2 ; j &lt; xf-&gt;ngroups ; j++){
				if( ++i &gt;= xf-&gt;ngroups )
					i = 0;
				ed = getext2(xf, EXT2_DESC, i);
				if( ed.u.gd-&gt;bg_free_inodes_count ){
					group = i;
					putext2(ed);
					break;
				}
				putext2(ed);
			}
		}

	}
	if( group &lt; 0 ){
		chat("group &lt; 0...");
		putext2(es);
		return 0;
	}
	ed = getext2(xf, EXT2_DESC, group);
	eb = getext2(xf, EXT2_BINODE, group);
	if( (j = find_first_zero_bit(eb.u.bmp, 
			xf-&gt;inodes_per_group&gt;&gt;3)) &lt; xf-&gt;inodes_per_group){
		if( set_bit(j, eb.u.bmp) ){
			chat("inode %d of group %d is already allocated...", j, group);
			putext2(ed); putext2(eb); putext2(es);
			errno = Ecorrupt;
			return 0;
		}
		dirtyext2(eb);
	}else if( ed.u.gd-&gt;bg_free_inodes_count != 0 ){
		chat("free inodes count corrupted for group %d...", group);
		putext2(ed); putext2(eb); putext2(es);
		errno = Ecorrupt;
		return 0;
	}
	i = j;
	j += group * xf-&gt;inodes_per_group + 1;
	if( j &lt; EXT2_FIRST_INO || j &gt;= es.u.sb-&gt;s_inodes_count ){
		chat("reserved inode or inode &gt; inodes count...");
		errno = Ecorrupt;
error:
		clear_bit(i, eb.u.bmp);
		putext2(eb); putext2(ed); putext2(es);
		return 0;
	}
	
	buf = getbuf(xf, ed.u.gd-&gt;bg_inode_table +
			(((j-1) % xf-&gt;inodes_per_group) / 
			xf-&gt;inodes_per_block));
	if( !buf )
		goto error;
	inode = ((struct Inode *) buf-&gt;iobuf) + 
		((j-1) % xf-&gt;inodes_per_block);
	memset(inode, 0, sizeof(Inode));
	inode-&gt;i_mode = mode;
	inode-&gt;i_links_count = 1;
	inode-&gt;i_uid = DEFAULT_UID;
	inode-&gt;i_gid = DEFAULT_GID;
	inode-&gt;i_mtime = inode-&gt;i_atime = inode-&gt;i_ctime = time(0);
	dirtybuf(buf);

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf ){
		putbuf(buf);
		goto error;
	}
	finode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;
	inode-&gt;i_flags = finode-&gt;i_flags;
	inode-&gt;i_uid = finode-&gt;i_uid;
	inode-&gt;i_gid = finode-&gt;i_gid;
	dirtybuf(ibuf);
	putbuf(ibuf);

	putbuf(buf);

	ed.u.gd-&gt;bg_free_inodes_count--;
	if( S_ISDIR(mode) )
		ed.u.gd-&gt;bg_used_dirs_count++;
	dirtyext2(ed);

	es.u.sb-&gt;s_free_inodes_count--;
	dirtyext2(es);

	putext2(eb);
	putext2(ed);
	putext2(es);

	return j;
}
int
create_file(Xfile *fdir, char *name, int mode)
{
	int inr;

	inr = new_inode(fdir, mode);
	if( !inr ){
		chat("create one new inode failed...");
		return -1;
	}
	if( add_entry(fdir, name, inr) &lt; 0 ){
		chat("add entry failed...");	
		free_inode(fdir-&gt;xf, inr);
		return -1;
	}

	return inr;
}
void
free_inode( Xfs *xf, int inr)
{
	Inode *inode;
	ulong b, bg;
	Iobuf *buf;
	Ext2 ed, es, eb;

	bg = (inr -1) / xf-&gt;inodes_per_group;
	b = (inr -1) % xf-&gt;inodes_per_group;

	ed = getext2(xf, EXT2_DESC, bg);
	buf = getbuf(xf, ed.u.gd-&gt;bg_inode_table +
			(b / xf-&gt;inodes_per_block));
	if( !buf ){
		putext2(ed);
		return;
	}
	inode = ((struct Inode *) buf-&gt;iobuf) + 
		((inr-1) % xf-&gt;inodes_per_block);

	if( S_ISDIR(inode-&gt;i_mode) )
		ed.u.gd-&gt;bg_used_dirs_count--;
	memset(inode, 0, sizeof(Inode));
	inode-&gt;i_dtime = time(0);
	dirtybuf(buf);
	putbuf(buf);

	ed.u.gd-&gt;bg_free_inodes_count++;
	dirtyext2(ed);
	putext2(ed);

	eb = getext2(xf, EXT2_BINODE, bg);
	clear_bit(b, eb.u.bmp);
	dirtyext2(eb);
	putext2(eb);
	
	es = getext2(xf, EXT2_SUPER, 0);
	es.u.sb-&gt;s_free_inodes_count++;
	dirtyext2(es); putext2(es);
}
int
create_dir(Xfile *fdir, char *name, int mode)
{
	Xfs *xf = fdir-&gt;xf;
	DirEntry *de;
	Inode *inode;
	Iobuf *buf, *ibuf;
	Xfile tf;
	int inr, baddr;

	inr = new_inode(fdir, mode);
	if( inr == 0 ){
		chat("create one new inode failed...");
		return -1;
	}
	if( add_entry(fdir, name, inr) &lt; 0 ){
		chat("add entry failed...");
		free_inode(fdir-&gt;xf, inr);
		return -1;
	}

	/* create the empty dir */

	tf = *fdir;
	if( get_inode(&amp;tf, inr) &lt; 0 ){
		chat("can't get inode %d...", inr);
		free_inode(fdir-&gt;xf, inr);
		return -1;
	}

	ibuf = getbuf(xf, tf.bufaddr);
	if( !ibuf ){
		free_inode(fdir-&gt;xf, inr);
		return -1;
	}
	inode = ((Inode *)ibuf-&gt;iobuf) + tf.bufoffset;

	
	baddr = inode_getblk(&amp;tf, 0);
	if( !baddr ){
		putbuf(ibuf);
		ibuf = getbuf(xf, fdir-&gt;bufaddr);
		if( !ibuf ){
			free_inode(fdir-&gt;xf, inr);
			return -1;
		}
		inode = ((Inode *)ibuf-&gt;iobuf) + fdir-&gt;bufoffset;
		delete_entry(fdir-&gt;xf, inode, inr);
		putbuf(ibuf);
		free_inode(fdir-&gt;xf, inr);
		return -1;
	}	
	
	inode-&gt;i_size = xf-&gt;block_size;	
	buf = getbuf(xf, baddr);
	
	de = (DirEntry *)buf-&gt;iobuf;
	de-&gt;inode = inr;
	de-&gt;name_len = 1;
	de-&gt;rec_len = DIR_REC_LEN(de-&gt;name_len);
	strcpy(de-&gt;name, ".");
	
	de = (DirEntry *)( (char *)de + de-&gt;rec_len);
	de-&gt;inode = fdir-&gt;inbr;
	de-&gt;name_len = 2;
	de-&gt;rec_len = xf-&gt;block_size - DIR_REC_LEN(1);
	strcpy(de-&gt;name, "..");
	
	dirtybuf(buf);
	putbuf(buf);
	
	inode-&gt;i_links_count = 2;
	dirtybuf(ibuf);
	putbuf(ibuf);
	
	ibuf = getbuf(xf, fdir-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + fdir-&gt;bufoffset;

	inode-&gt;i_links_count++;

	dirtybuf(ibuf);
	putbuf(ibuf);

	return inr;
}
int
add_entry(Xfile *f, char *name, int inr)
{
	Xfs *xf = f-&gt;xf;
	DirEntry *de, *de1;
	int offset, baddr;
	int rec_len, cur_block;
	int namelen = strlen(name);
	Inode *inode;
	Iobuf *buf, *ibuf;

	ibuf = getbuf(xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;

	if( inode-&gt;i_size == 0 ){
		chat("add_entry() no entry !!!...");
		putbuf(ibuf);
		return -1;
	}
	cur_block = offset = 0;
	rec_len = DIR_REC_LEN(namelen);
	buf = getbuf(xf, inode-&gt;i_block[cur_block++]);
	if( !buf ){
		putbuf(ibuf);
		return -1;
	}
	de = (DirEntry *)buf-&gt;iobuf;
	
	for(;;){
		if( ((char *)de) &gt;= (xf-&gt;block_size + buf-&gt;iobuf) ){
			putbuf(buf);
			if( cur_block &gt;= EXT2_NDIR_BLOCKS ){
				errno = Enospace;
				putbuf(ibuf);
				return -1;
			}
			if( (baddr = inode_getblk(f, cur_block++)) == 0 ){
				putbuf(ibuf);
				return -1;
			}
			buf = getbuf(xf, baddr);
			if( !buf ){
				putbuf(ibuf);
				return -1;
			}
			if( inode-&gt;i_size &lt;= offset ){
				de  = (DirEntry *)buf-&gt;iobuf;
				de-&gt;inode = 0;
				de-&gt;rec_len = xf-&gt;block_size;
				dirtybuf(buf);
				inode-&gt;i_size = offset + xf-&gt;block_size;
				dirtybuf(ibuf);
			}else{
				de = (DirEntry *)buf-&gt;iobuf;
			}
		}
		if( de-&gt;inode != 0 &amp;&amp; de-&gt;name_len == namelen &amp;&amp;
				!strncmp(name, de-&gt;name, namelen) ){
			errno = Eexist;
			putbuf(ibuf); putbuf(buf);
			return -1;
		}
		offset += de-&gt;rec_len;
		if( (de-&gt;inode == 0 &amp;&amp; de-&gt;rec_len &gt;= rec_len) ||
				(de-&gt;rec_len &gt;= DIR_REC_LEN(de-&gt;name_len) + rec_len) ){
			if( de-&gt;inode ){
				de1 = (DirEntry *) ((char *)de + DIR_REC_LEN(de-&gt;name_len));
				de1-&gt;rec_len = de-&gt;rec_len - DIR_REC_LEN(de-&gt;name_len);
				de-&gt;rec_len = DIR_REC_LEN(de-&gt;name_len);
				de = de1;
			}	
			de-&gt;inode = inr;
			de-&gt;name_len = namelen;
			memcpy(de-&gt;name, name, namelen);
			dirtybuf(buf);
			putbuf(buf);
			inode-&gt;i_mtime = inode-&gt;i_ctime = time(0);
			dirtybuf(ibuf);
			putbuf(ibuf);
			return 0;
		}
		de = (DirEntry *)((char *)de + de-&gt;rec_len);
	}
	/* not reached */
}
int
unlink( Xfile *file )
{
	Xfs *xf = file-&gt;xf;	
	Inode *dir;
	int bg, b;
	Inode *inode;
	Iobuf *buf, *ibuf;
	Ext2 ed, es, eb;

	if( S_ISDIR(getmode(file)) &amp;&amp; !empty_dir(file) ){
			chat("non empty directory...");
			errno = Eperm;
			return -1;
	}

	es = getext2(xf, EXT2_SUPER, 0);

	/* get dir inode */
	if( file-&gt;pinbr &gt;= es.u.sb-&gt;s_inodes_count ){
    		chat("inode number %d is too big...",  file-&gt;pinbr);
		putext2(es);
		errno = Eintern;
    		return -1;
	}
	bg = (file-&gt;pinbr - 1) / xf-&gt;inodes_per_group;
	if( bg &gt;= xf-&gt;ngroups ){
		chat("block group (%d) &gt; groups count...", bg);
		putext2(es);
		errno = Eintern;
		return -1;
	}
	ed = getext2(xf, EXT2_DESC, bg);
	b = ed.u.gd-&gt;bg_inode_table +
			(((file-&gt;pinbr-1) % xf-&gt;inodes_per_group) / 
			xf-&gt;inodes_per_block);
	putext2(ed);
	buf = getbuf(xf, b);
	if( !buf ){	
		putext2(es);	
		return -1;
	}
	dir = ((struct Inode *) buf-&gt;iobuf) + 
		((file-&gt;pinbr-1) % xf-&gt;inodes_per_block);

	/* Clean dir entry */
	
	if( delete_entry(xf, dir, file-&gt;inbr) &lt; 0 ){
		putbuf(buf);
		putext2(es);
		return -1;
	}
	if( S_ISDIR(getmode(file)) ){
		dir-&gt;i_links_count--;
		dirtybuf(buf);
	}
	putbuf(buf);
	
	/* clean blocks */
	ibuf = getbuf(xf, file-&gt;bufaddr);
	if( !ibuf ){
		putext2(es);
		return -1;
	}
	inode = ((Inode *)ibuf-&gt;iobuf) + file-&gt;bufoffset;

	if( !S_ISLNK(getmode(file)) || 
		(S_ISLNK(getmode(file)) &amp;&amp; (inode-&gt;i_size &gt; EXT2_N_BLOCKS&lt;&lt;2)) )
		if( free_block_inode(file) &lt; 0 ){
			chat("error while freeing blocks...");
			putext2(es);
			putbuf(ibuf);
			return -1;
		}
	

	/* clean inode */	
	
	bg = (file-&gt;inbr -1) / xf-&gt;inodes_per_group;
	b = (file-&gt;inbr -1) % xf-&gt;inodes_per_group;

	eb = getext2(xf, EXT2_BINODE, bg);
	clear_bit(b, eb.u.bmp);
	dirtyext2(eb);
	putext2(eb);

	inode-&gt;i_dtime = time(0);
	inode-&gt;i_links_count--;
	if( S_ISDIR(getmode(file)) )
		inode-&gt;i_links_count = 0;

	es.u.sb-&gt;s_free_inodes_count++;
	dirtyext2(es);
	putext2(es);

	ed = getext2(xf, EXT2_DESC, bg);
	ed.u.gd-&gt;bg_free_inodes_count++;
	if( S_ISDIR(getmode(file)) )
		ed.u.gd-&gt;bg_used_dirs_count--;
	dirtyext2(ed);
	putext2(ed);

	dirtybuf(ibuf);
	putbuf(ibuf);

	return 1;
}
int
empty_dir(Xfile *dir)
{
	Xfs *xf = dir-&gt;xf;
	int nblock;
	uint offset, i,count;
	DirEntry *de;
	Inode *inode;
	Iobuf *buf, *ibuf;
	
	if( !S_ISDIR(getmode(dir)) )
		return 0;

	ibuf = getbuf(xf, dir-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + dir-&gt;bufoffset;
	nblock = (inode-&gt;i_blocks * 512) / xf-&gt;block_size;

	for(i=0, count=0 ; (i &lt; nblock) &amp;&amp; (i &lt; EXT2_NDIR_BLOCKS) ; i++){
		buf = getbuf(xf, inode-&gt;i_block[i]);
		if( !buf ){
			putbuf(ibuf);
			return 0;
		}
		for(offset=0 ; offset &lt; xf-&gt;block_size ;  ){
			de = (DirEntry *)(buf-&gt;iobuf + offset);
			if(de-&gt;inode)
				count++;
			offset += de-&gt;rec_len;
		}
		putbuf(buf);
		if( count &gt; 2 ){
			putbuf(ibuf);
			return 0;
		}
	}
	putbuf(ibuf);
	return 1;
}
int 
free_block_inode(Xfile *file)
{
	Xfs *xf = file-&gt;xf;
	int i, j, k;
	ulong b, *y, *z;
	uint *x;
	int naddr;
	Inode *inode;
	Iobuf *buf, *buf1, *buf2, *ibuf;

	ibuf = getbuf(xf, file-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + file-&gt;bufoffset;

	for(i=0 ; i &lt; EXT2_IND_BLOCK ; i++){
		x = inode-&gt;i_block + i;
		if( *x == 0 ){ putbuf(ibuf); return 0; }
		free_block(xf, *x);
	}
	naddr = xf-&gt;addr_per_block;

	/* indirect blocks */
	
	if( (b=inode-&gt;i_block[EXT2_IND_BLOCK]) ){
		buf = getbuf(xf, b);
		if( !buf ){ putbuf(ibuf); return -1; }
		for(i=0 ; i &lt; naddr ; i++){
			x = ((uint *)buf-&gt;iobuf) + i;
			if( *x == 0 ) break;
			free_block(xf, *x);
		}
		free_block(xf, b);
		putbuf(buf);
	}

	/* double indirect block */

	if( (b=inode-&gt;i_block[EXT2_DIND_BLOCK]) ){
		buf = getbuf(xf, b);
		if( !buf ){ putbuf(ibuf); return -1; }
		for(i=0 ; i &lt; naddr ; i++){
			x = ((uint *)buf-&gt;iobuf) + i;
			if( *x== 0 ) break;
			buf1 = getbuf(xf, *x);
			if( !buf1 ){ putbuf(buf); putbuf(ibuf); return -1; }
			for(j=0 ; j &lt; naddr ; j++){
				y = ((ulong *)buf1-&gt;iobuf) + j;
				if( *y == 0 ) break;
				free_block(xf, *y);
			}
			free_block(xf, *x);
			putbuf(buf1);
		}
		free_block(xf, b);
		putbuf(buf);
	}
	
	/* triple indirect block */
	
	if( (b=inode-&gt;i_block[EXT2_TIND_BLOCK]) ){
		buf = getbuf(xf, b);
		if( !buf ){ putbuf(ibuf); return -1; }
		for(i=0 ; i &lt; naddr ; i++){
			x = ((uint *)buf-&gt;iobuf) + i;
			if( *x == 0 ) break;
			buf1 = getbuf(xf, *x);
			if( !buf1 ){ putbuf(buf); putbuf(ibuf); return -1; }
			for(j=0 ; j &lt; naddr ; j++){
				y = ((ulong *)buf1-&gt;iobuf) + j;
				if( *y == 0 ) break;
				buf2 = getbuf(xf, *y);
				if( !buf2 ){ putbuf(buf); putbuf(buf1); putbuf(ibuf); return -1; }
				for(k=0 ; k &lt; naddr ; k++){
					z = ((ulong *)buf2-&gt;iobuf) + k;
					if( *z == 0 ) break;
					free_block(xf, *z);
				}
				free_block(xf, *y);
				putbuf(buf2);
			}
			free_block(xf, *x);
			putbuf(buf1);
		}
		free_block(xf, b);
		putbuf(buf);
	}

	putbuf(ibuf);
	return 0;
}
void free_block( Xfs *xf, ulong block )
{
	ulong bg;
	Ext2 ed, es, eb;

	es = getext2(xf, EXT2_SUPER, 0);

	bg = (block - es.u.sb-&gt;s_first_data_block) / xf-&gt;blocks_per_group;
	block = (block - es.u.sb-&gt;s_first_data_block) % xf-&gt;blocks_per_group;

	eb = getext2(xf, EXT2_BBLOCK, bg);
	clear_bit(block, eb.u.bmp);
	dirtyext2(eb);
	putext2(eb);

	es.u.sb-&gt;s_free_blocks_count++;
	dirtyext2(es);
	putext2(es);

	ed = getext2(xf, EXT2_DESC, bg);
	ed.u.gd-&gt;bg_free_blocks_count++;
	dirtyext2(ed);
	putext2(ed);

}
int 
delete_entry(Xfs *xf, Inode *inode, int inbr)
{
	int nblock = (inode-&gt;i_blocks * 512) / xf-&gt;block_size;
	uint offset, i;
	DirEntry *de, *pde;
	Iobuf *buf;
	
	if( !S_ISDIR(inode-&gt;i_mode) )
		return -1;

	for(i=0 ; (i &lt; nblock) &amp;&amp; (i &lt; EXT2_NDIR_BLOCKS) ; i++){
		buf = getbuf(xf, inode-&gt;i_block[i]);
		if( !buf )
			return -1;
		pde = 0;
		for(offset=0 ; offset &lt; xf-&gt;block_size ;  ){
			de = (DirEntry *)(buf-&gt;iobuf + offset);
			if( de-&gt;inode == inbr ){
				if( pde )
					pde-&gt;rec_len += de-&gt;rec_len;
				de-&gt;inode = 0;
				dirtybuf(buf);
				putbuf(buf);
				return 1;
			}
			offset += de-&gt;rec_len;
			pde = de;
		}
		putbuf(buf);

	}
	errno = Enonexist;
	return -1;
}
int
truncfile(Xfile *f)
{
	Inode *inode;
	Iobuf *ibuf;
	chat("trunc(fid=%d) ...", f-&gt;fid);
	ibuf = getbuf(f-&gt;xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	inode = ((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset;
	
	if( free_block_inode(f) &lt; 0 ){
		chat("error while freeing blocks...");
		putbuf(ibuf);
		return -1;
	}
	inode-&gt;i_atime = inode-&gt;i_mtime = time(0);
	inode-&gt;i_blocks = 0;
	inode-&gt;i_size = 0;
	memset(inode-&gt;i_block, 0, EXT2_N_BLOCKS*sizeof(ulong));
	dirtybuf(ibuf);
	putbuf(ibuf);
	chat("trunc ok...");
	return 0;
}
long
getmode(Xfile *f)
{
	Iobuf *ibuf;
	long mode;

	ibuf = getbuf(f-&gt;xf, f-&gt;bufaddr);
	if( !ibuf )
		return -1;
	mode = (((Inode *)ibuf-&gt;iobuf) + f-&gt;bufoffset)-&gt;i_mode;
	putbuf(ibuf);
	return mode;
}
void
CleanSuper(Xfs *xf)
{
	Ext2 es;

	es = getext2(xf, EXT2_SUPER, 0);
	es.u.sb-&gt;s_state = EXT2_VALID_FS;
	dirtyext2(es);
	putext2(es);
}
int 
test_bit(int i, void *data)
{
	char *pt = (char *)data;

	return pt[i&gt;&gt;3] &amp; (0x01 &lt;&lt; (i&amp;7));
}

int
set_bit(int i, void *data)
{
  	char *pt;

  	if( test_bit(i, data) )
    		return 1; /* bit already set !!! */
  
  	pt = (char *)data;
  	pt[i&gt;&gt;3] |= (0x01 &lt;&lt; (i&amp;7));

  	return 0;
}

int 
clear_bit(int i, void *data)
{
	char *pt;

  	if( !test_bit(i, data) )
    		return 1; /* bit already clear !!! */
  
 	 pt = (char *)data;
  	pt[i&gt;&gt;3] &amp;= ~(0x01 &lt;&lt; (i&amp;7));
	
	return 0;
}
void *
memscan( void *data, int c, int count )
{
	char *pt = (char *)data;

	while( count ){
		if( *pt == c )
			return (void *)pt;
		count--;
		pt++;
	}
	return (void *)pt;
}

int 
find_first_zero_bit( void *data, int count /* in byte */)
{
  char *pt = (char *)data;
  int n, i;
  
  n = 0;

  while( n &lt; count ){
    for(i=0 ; i &lt; 8 ; i++)
      if( !(*pt &amp; (0x01 &lt;&lt; (i&amp;7))) )
	return (n&lt;&lt;3) + i;
    n++; pt++;
  }
  return n &lt;&lt; 3;
}

int 
find_next_zero_bit( void *data, int count /* in byte */, int where)
{
  char *pt = (((char *)data) + (where &gt;&gt; 3));
  int n, i;
  
  n = where &gt;&gt; 3;
  i = where &amp; 7;

  while( n &lt; count ){
    for(; i &lt; 8 ; i++)
      if( !(*pt &amp; (0x01 &lt;&lt; (i&amp;7))) )
	return (n&lt;&lt;3) + i;
    n++; pt++; i=0;
  }
  return n &lt;&lt; 3;
}
int
ffz( int x )
{
	int c = 0;
	while( x&amp;1 ){
		c++;
		x &gt;&gt;= 1;
	}
	return c;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

