<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ext2srv/iobuf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ext2srv/iobuf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"
#include "fns.h"

#define	NIOBUF		100
#define	HIOB		(NIOBUF/3)

static Iobuf*	hiob[HIOB];		/* hash buckets */
static Iobuf	iobuf[NIOBUF];		/* buffer headers */
static Iobuf*	iohead;
static Iobuf*	iotail;

Iobuf*
getbuf(Xfs *dev, long addr)
{
	Iobuf *p, *h, **l, **f;

	l = &amp;hiob[addr%HIOB];
	for(p = *l; p; p = p-&gt;hash) {
		if(p-&gt;addr == addr &amp;&amp; p-&gt;dev == dev) {
			p-&gt;busy++;
			return p;
		}
	}
	/* Find a non-busy buffer from the tail */
	for(p = iotail; p &amp;&amp; (p-&gt;busy &gt; 0); p = p-&gt;prev)
		;
	if(!p)
		panic("all buffers busy");
	if(p-&gt;dirty){
		xwrite(p);
		p-&gt;dirty = 0;
	}

	if( xread(dev, p, addr) &lt; 0)
		return 0;
	/* Delete from hash chain */
	f = &amp;hiob[p-&gt;addr%HIOB];
	if( *f == p )
		*f = p-&gt;hash;
	else {
		for(h = *f; h ; h = h-&gt;hash)
			if( h-&gt;hash == p ){
				h-&gt;hash = p-&gt;hash;
				break;
			}
	}
	/* Fill and hash */
	p-&gt;hash = *l;
	*l = p;
	p-&gt;addr = addr;
	p-&gt;dev = dev;
	p-&gt;busy=1;

	return p;
}
void
putbuf(Iobuf *p)
{
	if(p-&gt;busy &lt;= 0)
		panic("putbuf");
	p-&gt;busy--;

	/* Link onto head for lru */
	if(p == iohead)
		return;
	if( p == iotail ){
		p-&gt;prev-&gt;next = 0;
		iotail = p-&gt;prev;
	}else{
		p-&gt;prev-&gt;next = p-&gt;next;
		p-&gt;next-&gt;prev = p-&gt;prev;
	}

	p-&gt;prev = 0;
	p-&gt;next = iohead;
	iohead-&gt;prev = p;
	iohead = p;
}
void
dirtybuf(Iobuf *p)
{
	if(p-&gt;busy &lt;=0)
		panic("dirtybuf");
	p-&gt;dirty = 1;
}
void
syncbuf(void)
{
	Iobuf *p;

	for(p=&amp;iobuf[0] ; p&lt;&amp;iobuf[NIOBUF]; p++)
		if( p-&gt;dirty ){
			xwrite(p);
			p-&gt;dirty = 0;
		}
}
void
purgebuf(Xfs *dev)
{
	Iobuf *p;

	for(p=&amp;iobuf[0]; p&lt;&amp;iobuf[NIOBUF]; p++)
		if(p-&gt;dev == dev)
			p-&gt;busy = 0;

	/* Blow hash chains */
	memset(hiob, 0, sizeof(hiob));
}
void
iobuf_init(void)
{
	Iobuf *p;

	iohead = iobuf;
	iotail = iobuf+NIOBUF-1;

	for(p = iobuf; p &lt;= iotail; p++) {
		p-&gt;next = p+1;
		p-&gt;prev = p-1;
		
		p-&gt;iobuf = (char *)malloc(EXT2_MAX_BLOCK_SIZE);
		if(p-&gt;iobuf == 0)
			panic("iobuf_init");
	}

	iohead-&gt;prev = 0;
	iotail-&gt;next = 0;
}
int
xread(Xfs *dev, Iobuf *p, long addr)
{
	/*chat("xread %d,%d...", dev-&gt;dev, addr);*/

	seek(dev-&gt;dev, (vlong)addr*dev-&gt;block_size, 0);
	if(read(dev-&gt;dev, p-&gt;iobuf, dev-&gt;block_size) != dev-&gt;block_size){
		chat("xread %d, block=%d failed ...", dev-&gt;dev, addr);
		errno = Eio;
		return -1;
	}
	/*chat("xread ok...");*/
	return 0;
}
void 
xwrite(Iobuf *p)
{
	Xfs *dev;
	long addr;

	dev = p-&gt;dev;
	addr = p-&gt;addr;
	/*chat("xwrite %d,%d...", dev-&gt;dev, addr);*/

	seek(dev-&gt;dev, (vlong)addr*dev-&gt;block_size, 0);
	if(write(dev-&gt;dev, p-&gt;iobuf, dev-&gt;block_size) != dev-&gt;block_size){
		chat("xwrite %d, block=%d failed ...", dev-&gt;dev, addr);
		errno = Eio;
		return;
	}
	/*chat("xwrite ok...");*/
}
void
dumpbuf(void)
{
	Iobuf *p;
	
	for(p = iotail; p ; p = p-&gt;prev)
		if( p-&gt;busy )
			mchat("\nHi ERROR buf(%x, %d, %d)\n", p, p-&gt;addr, p-&gt;busy);	
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

