<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fax/fax2receive.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fax/fax2receive.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "modem.h"

static char buf[102400];

static int
page(Modem *m, char *spool)
{
	int count, r;
	char c;

	/*
	 * Start data reception. We should receive CONNECT in response
	 * to +FDR, then data reception starts when we send DC2.
	 */
	m-&gt;valid &amp;= ~(Vfhng|Vfet|Vfpts);
	if(command(m, "AT+FDR") != Eok)
		return Esys;

	switch(response(m, 30)){

	case Rconnect:
		m-&gt;phase = 'C';
		if((r = createfaxfile(m, spool)) != Eok)
			return r;
		if((r = putmchar(m, "\022")) != Eok)
			return r;
		break;

	case Rhangup:
		return Eok;

	default:
		return seterror(m, Eattn);
	}

	/*
	 * Receive data.
	 */
	verbose("starting page %d", m-&gt;pageno);
	count = 0;
	while((r = getmchar(m, &amp;c, 6)) == Eok){
		if(c == '\020'){
			if((r = getmchar(m, &amp;c, 3)) != Eok)
				break;
			if(c == '\003')
				break;
			if(c != '\020'){
				verbose("B%2.2ux", c);
				continue;
			}
		}
		buf[count++] = c;
		if(count &gt;= sizeof(buf)){
			if(write(m-&gt;pagefd, buf, count) &lt; 0){
				close(m-&gt;pagefd);
				return seterror(m, Esys);
			}
			count = 0;
		}	
	}
	verbose("page %d done, count %d", m-&gt;pageno, count);
	if(count &amp;&amp; write(m-&gt;pagefd, buf, count) &lt; 0){
		close(m-&gt;pagefd);
		return seterror(m, Esys);
	}
	if(r != Eok)
		return r;

	/*
	 * Wait for either OK or ERROR.
	 */
	switch(r = response(m, 20)){

	case Rok:
	case Rrerror:
		return Eok;

	default:
		verbose("page: response %d", r);
		return Eproto;
	}
}

static int
receive(Modem *m, char *spool)
{
	int r;

   loop:
	switch(r = page(m, spool)){

	case Eok:
		/*
		 * Check we have a valid page reponse.
		 */
		if((m-&gt;valid &amp; Vfhng) == 0 &amp;&amp; (m-&gt;valid &amp; (Vfet|Vfpts)) != (Vfet|Vfpts)){
			verbose("receive: invalid page reponse: #%4.4ux", m-&gt;valid);
			return seterror(m, Eproto);
		}

		/*
		 * Was the page successfully received?
		 * If not, try again.
		 */
		if((m-&gt;valid &amp; Vfpts) &amp;&amp; m-&gt;fpts[0] != 1)
			goto loop;

		/*
		 * Another page of the same document, a new document
		 * or no more pages.
		 * If no more pages we still have to get the FHNG, so
		 * the code is just the same as if there was another
		 * page.
		 */
		if(m-&gt;valid &amp; Vfet){
			switch(m-&gt;fet){

			case 0:				/* another page */
			case 2:				/* no more pages */
				m-&gt;pageno++;
				goto loop;

			case 1:				/* new document */
				/*
				 * Bug: currently no way to run the
				 * fax-received process for this, so it
				 * just stays queued.
				 */
				faxrlog(m, Eok);
				m-&gt;pageno = 1;
				m-&gt;time = time(0);
				m-&gt;pid = getpid();
				goto loop;
			}

			verbose("receive: invalid FET: %d", m-&gt;fet);
			return seterror(m, Eproto);
		}

		/*
		 * All done or hangup error.
		 * On error remove all pages in the current document.
		 * Yik.
		 */
		if(m-&gt;valid &amp; Vfhng){
			if(m-&gt;fhng == 0)
				return Eok;
			verbose("receive: FHNG: %d", m-&gt;fhng);
			/*
			for(r = 1; r &lt;= m-&gt;pageno; r++){
				char pageid[128];

				setpageid(pageid, spool, m-&gt;time, m-&gt;pid, r);
				remove(pageid);
			}
			 */
			return seterror(m, Eattn);
		}
		/*FALLTHROUGH*/

	default:
		return r;
	}
}

int
faxreceive(Modem *m, char *spool)
{
	int r;

	verbose("faxdaemon");
	if((r = initfaxmodem(m)) != Eok)
		return r;

	/*
	 *  assume that the phone has been answered and
	 *  we have received +FCON
	 */
	m-&gt;pageno = 1;
	m-&gt;time = time(0);
	m-&gt;pid = getpid();
	fcon(m);

	/*
	 * I wish I knew how to set the default parameters on the
	 * MT1432 modem (+FIP in Class 2.0).
	 */
	return receive(m, spool);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

