<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fax/fax2send.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fax/fax2send.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "modem.h"

int
faxsend(Modem *m, int argc, char *argv[])
{
	int c, count, r, flow;
	char buf[128];

	verbose("faxsend");
	if((r = initfaxmodem(m)) != Eok)
		return r;

	/* telco just does the dialing */
	r = response(m, 120);
	switch(r){
	case Rok:
		break;
	default:
		r = seterror(m, Enoanswer);
		return r;
		
	}

	xonoff(m, 1);
	verbose("sending");
	m-&gt;pageno = 1;
	while(argc--){
		if(m-&gt;pageno != 1)
			sleep(1000);	/* let the paper catch up */

		m-&gt;valid &amp;= ~(Vfhng|Vfet|Vfpts|Vftsi|Vfdcs);
		if((r = openfaxfile(m, *argv)) != Eok)
			return r;

		verbose("sending geometry");
		sprint(buf, "AT+FDT=%ld,%ld,%ld,%ld", m-&gt;df, m-&gt;vr, m-&gt;wd, m-&gt;ln);
		if(command(m, buf) != Eok)
			goto buggery;
		if(response(m, 20) != Rconnect){
			r = seterror(m, Eincompatible);
			goto buggery;
		}

		/*
		 * Write the data, stuffing DLE's.
		 * After each bufferfull check if the remote
		 * sent us anything, e.g. CAN to abort.
		 * This also flushes out the ^S/^Q characters
		 * which the driver insists on sending us.
		 * (Could fix the driver, of course...).
		 */
		verbose("sending data");
		for(;;){
			flow = 0;
			count = 0;
			c = 0;
			while(count &lt; sizeof(buf)-1){
				if((c = Bgetc(m-&gt;bp)) &lt; 0)
					break;
				buf[count++] = c;
				if(c == '\020')
					buf[count++] = c;
			}
			verbose("sending %d bytes", count);
			if(count &amp;&amp; write(m-&gt;fd, buf, count) &lt; 0){
				verbose("write failed: %r");
				r = seterror(m, Esys);
				goto buggery;
			}
			/*
			 *  this does really rough flow control since the
			 *  avanstar is even worse
			 */
			verbose("flow control");
			while((r = rawmchar(m, buf)) == Eok || flow){
				if(r != Eok){
					if(flow-- == 0)
						break;
					sleep(250);
					continue;
				}
				switch(buf[0]){
				case '\030':
					verbose("%c", buf[0]);
					if(write(m-&gt;fd, "\020\003", 2) &lt; 0){
						r = seterror(m, Esys);
						goto buggery;
					}
					goto okexit;
				case '\021':
					flow = 0;
					break;
				case '\023':
					flow = 4;
					break;
				case '\n':
					break;
				default:
					verbose("%c", buf[0]);
					r = seterror(m, Eproto);
					goto buggery;
				
				}
			}
			if(c &lt; 0)
				break;
		}


		/*
		 * End of page, send DLE+ETX,
		 * get OK in response.
		 */
		verbose("sending end of page");
		if(write(m-&gt;fd, "\020\003", 2) &lt; 0){
			r = seterror(m, Esys);
			goto buggery;
		}
		verbose("waiting for OK");
		if(response(m, 120) != Rok){
			r = seterror(m, Enoresponse);
			goto buggery;
		}

		/*
		 * Did you hear me? - IT'S THE END OF THE PAGE.
		 * Argument is 0 if more pages to follow.
		 * Should get back an FPTS with an indication
		 * as to whether the page was successfully
		 * transmitted or not.
		 */
		sprint(buf, "AT+FET=%d", argc == 0? 2: 0);
		if(command(m, buf) != Eok)
			goto buggery;
		switch(response(m, 20)){
		case Rok:
			break;
		case Rhangup:
			if(m-&gt;fhng == 0 &amp;&amp; argc == 0)
				break;
			r = seterror(m, Eproto);
			goto buggery;
		default:
			r = seterror(m, Enoresponse);
			goto buggery;
		}

		if((m-&gt;valid &amp; Vfpts) == 0 || m-&gt;fpts[0] != 1){
			r = seterror(m, Eproto);
			goto buggery;
		}

		Bterm(m-&gt;bp);
		m-&gt;pageno++;
		argv++;
	}
okexit:
	xonoff(m, 0);
	return Eok;

buggery:
	xonoff(m, 0);
	Bterm(m-&gt;bp);
	command(m, "AT+FK");
	response(m, 5);
	return r;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

