<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fax/modem.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fax/modem.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "modem.h"

typedef struct {
	char	*terse;
	char	*verbose;
	int	result;
	int	(*f)(Modem*);
} ResultCode;

static ResultCode results[] = {
	{ "0",	"OK",		Rok,		0, },
	{ "1",	"CONNECT",	Rconnect,	0, },
	{ "2",	"RING",		Rring,		0, },
	{ "3",	"NO CARRIER", 	Rfailure,	0, },
	{ "4",	"ERROR",	Rrerror,	0, },
	{ "5",	"CONNECT 1200",	Rconnect,	0, },
	{ "6",	"NO DIALTONE",	Rfailure,	0, },
	{ "7",	"BUSY",		Rfailure,	0, },
	{ "8",	"NO ANSWER",	Rfailure,	0, },
	{ "9",	"CONNECT 2400",	Rconnect,	0, },		/* MT1432BA */
	{ "10",	"CONNECT 2400",	Rconnect,	0, },		/* Hayes */
	{ "11",	"CONNECT 4800",	Rconnect,	0, },
	{ "12",	"CONNECT 9600",	Rconnect,	0, },
	{ "13",	"CONNECT 14400",Rconnect,	0, },
	{ "23",	"CONNECT 1275",	Rconnect,	0, },		/* MT1432BA */

	{ "-1",	"+FCON",	Rcontinue,	fcon, },
	{ "-1",	"+FTSI",	Rcontinue,	ftsi, },
	{ "-1",	"+FDCS",	Rcontinue,	fdcs, },
	{ "-1",	"+FCFR",	Rcontinue,	fcfr, },
	{ "-1",	"+FPTS",	Rcontinue,	fpts, },
	{ "-1",	"+FET",		Rcontinue,	fet, },
	{ "-1",	"+FHNG",	Rcontinue,	fhng, },

	{ 0 },
};

void
initmodem(Modem *m, int fd, int cfd, char *type, char *id)
{
	m-&gt;fd = fd;
	m-&gt;cfd = cfd;
	if(id == 0)
		id = "Plan 9";
	m-&gt;id = id;
	m-&gt;t = type;
}

int
rawmchar(Modem *m, char *p)
{
	Dir *d;
	int n;

	if(m-&gt;icount == 0)
		m-&gt;iptr = m-&gt;ibuf;

	if(m-&gt;icount){
		*p = *m-&gt;iptr++;
		m-&gt;icount--;
		return Eok;
	}

	m-&gt;iptr = m-&gt;ibuf;

	if((d = dirfstat(m-&gt;fd)) == nil){
		verbose("rawmchar: dirfstat: %r");
		return seterror(m, Esys);
	}
	n = d-&gt;length;
	free(d);
	if(n == 0)
		return Enoresponse;

	if(n &gt; sizeof(m-&gt;ibuf)-1)
		n = sizeof(m-&gt;ibuf)-1;
	if((m-&gt;icount = read(m-&gt;fd, m-&gt;ibuf, n)) &lt;= 0){
		verbose("rawmchar: read: %r");
		m-&gt;icount = 0;
		return seterror(m, Esys);
	}
	*p = *m-&gt;iptr++;
	m-&gt;icount--;

	return Eok;
}

int
getmchar(Modem *m, char *buf, long timeout)
{
	int r, t;

	timeout += time(0);
	while((t = time(0)) &lt;= timeout){
		switch(r = rawmchar(m, buf)){

		case Eok:
			return Eok;

		case Enoresponse:
			sleep(100);
			continue;

		default:
			return r;
		}
	}
	verbose("getmchar: time %ud, timeout %ud", t, timeout);

	return seterror(m, Enoresponse);
}

int
putmchar(Modem *m, char *p)
{
	if(write(m-&gt;fd, p, 1) &lt; 0)
		return seterror(m, Esys);
	return Eok;
}

/*
 *  lines terminate with cr-lf
 */
static int
getmline(Modem *m, char *buf, int len, long timeout)
{
	int r, t;
	char *e = buf+len-1;
	char last = 0;

	timeout += time(0);
	while((t = time(0)) &lt;= timeout){
		switch(r = rawmchar(m, buf)){

		case Eok:
			/* ignore ^s ^q which are used for flow */
			if(*buf == '\021' || *buf == '\023')
				continue;
			if(*buf == '\n'){
				/* ignore nl if its not with a cr */
				if(last == '\r'){
					*buf = 0;
					return Eok;
				}
				continue;
			}
			last = *buf;
			if(*buf == '\r')
				continue;
			buf++;
			if(buf == e){
				*buf = 0;
				return Eok;
			}
			continue;

		case Enoresponse:
			sleep(100);
			continue;

		default:
			return r;
		}
	}
	verbose("getmline: time %ud, timeout %ud", t, timeout);

	return seterror(m, Enoresponse);
}

int
command(Modem *m, char *s)
{
	verbose("m-&gt;: %s", s);
	if(fprint(m-&gt;fd, "%s\r", s) &lt; 0)
		return seterror(m, Esys);
	return Eok;
}

/*
 * Read till we see a message or we time out.
 * BUG: line lengths not checked;
 *	newlines
 */
int
response(Modem *m, int timeout)
{
	int r;
	ResultCode *rp;

	while(getmline(m, m-&gt;response, sizeof(m-&gt;response), timeout) == Eok){
		if(m-&gt;response[0] == 0)
			continue;
		verbose("&lt;-m: %s", m-&gt;response);
		for(rp = results; rp-&gt;terse; rp++){
			if(strncmp(rp-&gt;verbose, m-&gt;response, strlen(rp-&gt;verbose)))
				continue;
			r = rp-&gt;result;
			if(rp-&gt;f &amp;&amp; (r = (*rp-&gt;f)(m)) == Rcontinue)
				break;
			return r;
		}
	}

	m-&gt;response[0] = 0;
	return Rnoise;
}

void
xonoff(Modem *m, int i)
{
	char buf[8];

	sprint(buf, "x%d", i);
	i = strlen(buf);
	write(m-&gt;cfd, buf, i);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

