<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/9auth.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/9auth.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "9.h"

int
authRead(Fid* afid, void* data, int count)
{
	AuthInfo *ai;
	AuthRpc *rpc;

	if((rpc = afid-&gt;rpc) == nil){
		vtSetError("not an auth fid");
		return -1;
	}

	switch(auth_rpc(rpc, "read", nil, 0)){
	default:
		vtSetError("fossil authRead: auth protocol not finished");
		return -1;
	case ARdone:
		if((ai = auth_getinfo(rpc)) == nil){
			vtSetError("%r");
			break;
		}
		if(ai-&gt;cuid == nil || *ai-&gt;cuid == '\0'){
			vtSetError("auth with no cuid");
			auth_freeAI(ai);
			break;
		}
		assert(afid-&gt;cuname == nil);
		afid-&gt;cuname = vtStrDup(ai-&gt;cuid);
		auth_freeAI(ai);
		if(Dflag)
			fprint(2, "authRead cuname %s\n", afid-&gt;cuname);
		assert(afid-&gt;uid == nil);
		if((afid-&gt;uid = uidByUname(afid-&gt;cuname)) == nil){
			vtSetError("unknown user %#q", afid-&gt;cuname);
			break;
		}
		return 0;
	case ARok:
		if(count &lt; rpc-&gt;narg){
			vtSetError("not enough data in auth read");
			break;
		}
		memmove(data, rpc-&gt;arg, rpc-&gt;narg);
		return rpc-&gt;narg;
	case ARphase:
		vtSetError("%r");
		break;
	}
	return -1;
}

int
authWrite(Fid* afid, void* data, int count)
{
	assert(afid-&gt;rpc != nil);
	if(auth_rpc(afid-&gt;rpc, "write", data, count) != ARok)
		return -1;
	return count;
}

int
authCheck(Fcall* t, Fid* fid, Fsys* fsys)
{
	Con *con;
	Fid *afid;
	uchar buf[1];

	/*
	 * Can't lookup with FidWlock here as there may be
	 * protocol to do. Use a separate lock to protect altering
	 * the auth information inside afid.
	 */
	con = fid-&gt;con;
	if(t-&gt;afid == NOFID){
		/*
		 * If no authentication is asked for, allow
		 * "none" provided the connection has already
		 * been authenticatated.
		 *
		 * The console is allowed to attach without
		 * authentication.
		 */
		vtRLock(con-&gt;alock);
		if(con-&gt;isconsole){
			/* anything goes */
		}else if((con-&gt;flags&amp;ConNoneAllow) || con-&gt;aok){
			static int noneprint;

			if(noneprint++ &lt; 10)
				consPrint("attach %s as %s: allowing as none\n",
					fsysGetName(fsys), fid-&gt;uname);
			vtMemFree(fid-&gt;uname);
			fid-&gt;uname = vtStrDup(unamenone);
		}else{
			vtRUnlock(con-&gt;alock);
			consPrint("attach %s as %s: connection not authenticated, not console\n",
				fsysGetName(fsys), fid-&gt;uname);
			vtSetError("cannot attach as none before authentication");
			return 0;
		}
		vtRUnlock(con-&gt;alock);

		if((fid-&gt;uid = uidByUname(fid-&gt;uname)) == nil){
			consPrint("attach %s as %s: unknown uname\n",
				fsysGetName(fsys), fid-&gt;uname);
			vtSetError("unknown user");
			return 0;
		}
		return 1;
	}

	if((afid = fidGet(con, t-&gt;afid, 0)) == nil){
		consPrint("attach %s as %s: bad afid\n",
			fsysGetName(fsys), fid-&gt;uname);
		vtSetError("bad authentication fid");
		return 0;
	}

	/*
	 * Check valid afid;
	 * check uname and aname match.
	 */
	if(!(afid-&gt;qid.type &amp; QTAUTH)){
		consPrint("attach %s as %s: afid not an auth file\n",
			fsysGetName(fsys), fid-&gt;uname);
		fidPut(afid);
		vtSetError("bad authentication fid");
		return 0;
	}
	if(strcmp(afid-&gt;uname, fid-&gt;uname) != 0 || afid-&gt;fsys != fsys){
		consPrint("attach %s as %s: afid is for %s as %s\n",
			fsysGetName(fsys), fid-&gt;uname,
			fsysGetName(afid-&gt;fsys), afid-&gt;uname);
		fidPut(afid);
		vtSetError("attach/auth mismatch");
		return 0;
	}

	vtLock(afid-&gt;alock);
	if(afid-&gt;cuname == nil){
		if(authRead(afid, buf, 0) != 0 || afid-&gt;cuname == nil){
			vtUnlock(afid-&gt;alock);
			consPrint("attach %s as %s: %R\n",
				fsysGetName(fsys), fid-&gt;uname);
			fidPut(afid);
			vtSetError("fossil authCheck: auth protocol not finished");
			return 0;
		}
	}
	vtUnlock(afid-&gt;alock);

	assert(fid-&gt;uid == nil);
	if((fid-&gt;uid = uidByUname(afid-&gt;cuname)) == nil){
		consPrint("attach %s as %s: unknown cuname %s\n",
			fsysGetName(fsys), fid-&gt;uname, afid-&gt;cuname);
		fidPut(afid);
		vtSetError("unknown user");
		return 0;
	}

	vtMemFree(fid-&gt;uname);
	fid-&gt;uname = vtStrDup(afid-&gt;cuname);
	fidPut(afid);

	/*
	 * Allow "none" once the connection has been authenticated.
	 */
	vtLock(con-&gt;alock);
	con-&gt;aok = 1;
	vtUnlock(con-&gt;alock);

	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

