<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/9fid.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/9fid.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"

#include "9.h"

static struct {
	VtLock*	lock;

	Fid*	free;
	int	nfree;
	int	inuse;
} fbox;

static void
fidLock(Fid* fid, int flags)
{
	if(flags &amp; FidFWlock){
		vtLock(fid-&gt;lock);
		fid-&gt;flags = flags;
	}
	else
		vtRLock(fid-&gt;lock);

	/*
	 * Callers of file* routines are expected to lock fsys-&gt;fs-&gt;elk
	 * before making any calls in order to make sure the epoch doesn't
	 * change underfoot. With the exception of Tversion and Tattach,
	 * that implies all 9P functions need to lock on entry and unlock
	 * on exit. Fortunately, the general case is the 9P functions do
	 * fidGet on entry and fidPut on exit, so this is a convenient place
	 * to do the locking.
	 * No fsys-&gt;fs-&gt;elk lock is required if the fid is being created
	 * (Tauth, Tattach and Twalk). FidFCreate is always accompanied by
	 * FidFWlock so the setting and testing of FidFCreate here and in
	 * fidUnlock below is always done under fid-&gt;lock.
	 * A side effect is that fidFree is called with the fid locked, and
	 * must call fidUnlock only after it has disposed of any File
	 * resources still held.
	 */
	if(!(flags &amp; FidFCreate))
		fsysFsRlock(fid-&gt;fsys);
}

static void
fidUnlock(Fid* fid)
{
	if(!(fid-&gt;flags &amp; FidFCreate))
		fsysFsRUnlock(fid-&gt;fsys);
	if(fid-&gt;flags &amp; FidFWlock){
		fid-&gt;flags = 0;
		vtUnlock(fid-&gt;lock);
		return;
	}
	vtRUnlock(fid-&gt;lock);
}

static Fid*
fidAlloc(void)
{
	Fid *fid;

	vtLock(fbox.lock);
	if(fbox.nfree &gt; 0){
		fid = fbox.free;
		fbox.free = fid-&gt;hash;
		fbox.nfree--;
	}
	else{
		fid = vtMemAllocZ(sizeof(Fid));
		fid-&gt;lock = vtLockAlloc();
		fid-&gt;alock = vtLockAlloc();
	}
	fbox.inuse++;
	vtUnlock(fbox.lock);

	fid-&gt;con = nil;
	fid-&gt;fidno = NOFID;
	fid-&gt;ref = 0;
	fid-&gt;flags = 0;
	fid-&gt;open = FidOCreate;
	assert(fid-&gt;fsys == nil);
	assert(fid-&gt;file == nil);
	fid-&gt;qid = (Qid){0, 0, 0};
	assert(fid-&gt;uid == nil);
	assert(fid-&gt;uname == nil);
	assert(fid-&gt;db == nil);
	assert(fid-&gt;excl == nil);
	assert(fid-&gt;rpc == nil);
	assert(fid-&gt;cuname == nil);
	fid-&gt;hash = fid-&gt;next = fid-&gt;prev = nil;

	return fid;
}

static void
fidFree(Fid* fid)
{
	if(fid-&gt;file != nil){
		fileDecRef(fid-&gt;file);
		fid-&gt;file = nil;
	}
	if(fid-&gt;db != nil){
		dirBufFree(fid-&gt;db);
		fid-&gt;db = nil;
	}
	fidUnlock(fid);

	if(fid-&gt;uid != nil){
		vtMemFree(fid-&gt;uid);
		fid-&gt;uid = nil;
	}
	if(fid-&gt;uname != nil){
		vtMemFree(fid-&gt;uname);
		fid-&gt;uname = nil;
	}
	if(fid-&gt;excl != nil)
		exclFree(fid);
	if(fid-&gt;rpc != nil){
		close(fid-&gt;rpc-&gt;afd);
		auth_freerpc(fid-&gt;rpc);
		fid-&gt;rpc = nil;
	}
	if(fid-&gt;fsys != nil){
		fsysPut(fid-&gt;fsys);
		fid-&gt;fsys = nil;
	}
	if(fid-&gt;cuname != nil){
		vtMemFree(fid-&gt;cuname);
		fid-&gt;cuname = nil;
	}

	vtLock(fbox.lock);
	fbox.inuse--;
	if(fbox.nfree &lt; 10){
		fid-&gt;hash = fbox.free;
		fbox.free = fid;
		fbox.nfree++;
	}
	else{
		vtLockFree(fid-&gt;alock);
		vtLockFree(fid-&gt;lock);
		vtMemFree(fid);
	}
	vtUnlock(fbox.lock);
}

static void
fidUnHash(Fid* fid)
{
	Fid *fp, **hash;

	assert(fid-&gt;ref == 0);

	hash = &amp;fid-&gt;con-&gt;fidhash[fid-&gt;fidno % NFidHash];
	for(fp = *hash; fp != nil; fp = fp-&gt;hash){
		if(fp == fid){
			*hash = fp-&gt;hash;
			break;
		}
		hash = &amp;fp-&gt;hash;
	}
	assert(fp == fid);

	if(fid-&gt;prev != nil)
		fid-&gt;prev-&gt;next = fid-&gt;next;
	else
		fid-&gt;con-&gt;fhead = fid-&gt;next;
	if(fid-&gt;next != nil)
		fid-&gt;next-&gt;prev = fid-&gt;prev;
	else
		fid-&gt;con-&gt;ftail = fid-&gt;prev;
	fid-&gt;prev = fid-&gt;next = nil;

	fid-&gt;con-&gt;nfid--;
}

Fid*
fidGet(Con* con, u32int fidno, int flags)
{
	Fid *fid, **hash;

	if(fidno == NOFID)
		return nil;

	hash = &amp;con-&gt;fidhash[fidno % NFidHash];
	vtLock(con-&gt;fidlock);
	for(fid = *hash; fid != nil; fid = fid-&gt;hash){
		if(fid-&gt;fidno != fidno)
			continue;

		/*
		 * Already in use is an error
		 * when called from attach, clone or walk.
		 */
		if(flags &amp; FidFCreate){
			vtUnlock(con-&gt;fidlock);
			vtSetError("%s: fid 0x%ud in use", argv0, fidno);
			return nil;
		}
		fid-&gt;ref++;
		vtUnlock(con-&gt;fidlock);

		fidLock(fid, flags);
		if((fid-&gt;open &amp; FidOCreate) || fid-&gt;fidno == NOFID){
			fidPut(fid);
			vtSetError("%s: fid invalid", argv0);
			return nil;
		}
		return fid;
	}

	if((flags &amp; FidFCreate) &amp;&amp; (fid = fidAlloc()) != nil){
		assert(flags &amp; FidFWlock);
		fid-&gt;con = con;
		fid-&gt;fidno = fidno;
		fid-&gt;ref = 1;

		fid-&gt;hash = *hash;
		*hash = fid;
		if(con-&gt;ftail != nil){
			fid-&gt;prev = con-&gt;ftail;
			con-&gt;ftail-&gt;next = fid;
		}
		else{
			con-&gt;fhead = fid;
			fid-&gt;prev = nil;
		}
		con-&gt;ftail = fid;
		fid-&gt;next = nil;

		con-&gt;nfid++;
		vtUnlock(con-&gt;fidlock);

		/*
		 * The FidOCreate flag is used to prevent any
		 * accidental access to the Fid between unlocking the
		 * hash and acquiring the Fid lock for return.
		 */
		fidLock(fid, flags);
		fid-&gt;open &amp;= ~FidOCreate;
		return fid;
	}
	vtUnlock(con-&gt;fidlock);

	vtSetError("%s: fid not found", argv0);
	return nil;
}

void
fidPut(Fid* fid)
{
	vtLock(fid-&gt;con-&gt;fidlock);
	assert(fid-&gt;ref &gt; 0);
	fid-&gt;ref--;
	vtUnlock(fid-&gt;con-&gt;fidlock);

	if(fid-&gt;ref == 0 &amp;&amp; fid-&gt;fidno == NOFID){
		fidFree(fid);
		return;
	}
	fidUnlock(fid);
}

void
fidClunk(Fid* fid)
{
	assert(fid-&gt;flags &amp; FidFWlock);

	vtLock(fid-&gt;con-&gt;fidlock);
	assert(fid-&gt;ref &gt; 0);
	fid-&gt;ref--;
	fidUnHash(fid);
	fid-&gt;fidno = NOFID;
	vtUnlock(fid-&gt;con-&gt;fidlock);

	if(fid-&gt;ref &gt; 0){
		/* not reached - fidUnHash requires ref == 0 */
		fidUnlock(fid);
		return;
	}
	fidFree(fid);
}

void
fidClunkAll(Con* con)
{
	Fid *fid;
	u32int fidno;

	vtLock(con-&gt;fidlock);
	while(con-&gt;fhead != nil){
		fidno = con-&gt;fhead-&gt;fidno;
		vtUnlock(con-&gt;fidlock);
		if((fid = fidGet(con, fidno, FidFWlock)) != nil)
			fidClunk(fid);
		vtLock(con-&gt;fidlock);
	}
	vtUnlock(con-&gt;fidlock);
}

void
fidInit(void)
{
	fbox.lock = vtLockAlloc();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

