<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/9proc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/9proc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"

#include "9.h"
#include "dat.h"
#include "fns.h"

enum {
	NConInit	= 128,
	NMsgInit	= 384,
	NMsgProcInit	= 64,
	NMsizeInit	= 8192+IOHDRSZ,
};

static struct {
	VtLock*	alock;			/* alloc */
	Msg*	ahead;
	VtRendez* arendez;

	int	maxmsg;
	int	nmsg;
	int	nmsgstarve;

	VtLock*	rlock;			/* read */
	Msg*	rhead;
	Msg*	rtail;
	VtRendez* rrendez;

	int	maxproc;
	int	nproc;
	int	nprocstarve;

	u32int	msize;			/* immutable */
} mbox;

static struct {
	VtLock*	alock;			/* alloc */
	Con*	ahead;
	VtRendez* arendez;

	VtLock*	clock;
	Con*	chead;
	Con*	ctail;

	int	maxcon;
	int	ncon;
	int	nconstarve;

	u32int	msize;
} cbox;

static void
conFree(Con* con)
{
	assert(con-&gt;version == nil);
	assert(con-&gt;mhead == nil);
	assert(con-&gt;whead == nil);
	assert(con-&gt;nfid == 0);
	assert(con-&gt;state == ConMoribund);

	if(con-&gt;fd &gt;= 0){
		close(con-&gt;fd);
		con-&gt;fd = -1;
	}
	con-&gt;state = ConDead;
	con-&gt;aok = 0;
	con-&gt;flags = 0;
	con-&gt;isconsole = 0;

	vtLock(cbox.alock);
	if(con-&gt;cprev != nil)
		con-&gt;cprev-&gt;cnext = con-&gt;cnext;
	else
		cbox.chead = con-&gt;cnext;
	if(con-&gt;cnext != nil)
		con-&gt;cnext-&gt;cprev = con-&gt;cprev;
	else
		cbox.ctail = con-&gt;cprev;
	con-&gt;cprev = con-&gt;cnext = nil;

	if(cbox.ncon &gt; cbox.maxcon){
		if(con-&gt;name != nil)
			vtMemFree(con-&gt;name);
		vtLockFree(con-&gt;fidlock);
		vtMemFree(con-&gt;data);
		vtRendezFree(con-&gt;wrendez);
		vtLockFree(con-&gt;wlock);
		vtRendezFree(con-&gt;mrendez);
		vtLockFree(con-&gt;mlock);
		vtRendezFree(con-&gt;rendez);
		vtLockFree(con-&gt;lock);
		vtMemFree(con);
		cbox.ncon--;
		vtUnlock(cbox.alock);
		return;
	}
	con-&gt;anext = cbox.ahead;
	cbox.ahead = con;
	if(con-&gt;anext == nil)
		vtWakeup(cbox.arendez);
	vtUnlock(cbox.alock);
}

static void
msgFree(Msg* m)
{
	assert(m-&gt;rwnext == nil);
	assert(m-&gt;flush == nil);

	vtLock(mbox.alock);
	if(mbox.nmsg &gt; mbox.maxmsg){
		vtMemFree(m-&gt;data);
		vtMemFree(m);
		mbox.nmsg--;
		vtUnlock(mbox.alock);
		return;
	}
	m-&gt;anext = mbox.ahead;
	mbox.ahead = m;
	if(m-&gt;anext == nil)
		vtWakeup(mbox.arendez);
	vtUnlock(mbox.alock);
}

static Msg*
msgAlloc(Con* con)
{
	Msg *m;

	vtLock(mbox.alock);
	while(mbox.ahead == nil){
		if(mbox.nmsg &gt;= mbox.maxmsg){
			mbox.nmsgstarve++;
			vtSleep(mbox.arendez);
			continue;
		}
		m = vtMemAllocZ(sizeof(Msg));
		m-&gt;data = vtMemAlloc(mbox.msize);
		m-&gt;msize = mbox.msize;
		mbox.nmsg++;
		mbox.ahead = m;
		break;
	}
	m = mbox.ahead;
	mbox.ahead = m-&gt;anext;
	m-&gt;anext = nil;
	vtUnlock(mbox.alock);

	m-&gt;con = con;
	m-&gt;state = MsgR;
	m-&gt;nowq = 0;

	return m;
}

static void
msgMunlink(Msg* m)
{
	Con *con;

	con = m-&gt;con;

	if(m-&gt;mprev != nil)
		m-&gt;mprev-&gt;mnext = m-&gt;mnext;
	else
		con-&gt;mhead = m-&gt;mnext;
	if(m-&gt;mnext != nil)
		m-&gt;mnext-&gt;mprev = m-&gt;mprev;
	else
		con-&gt;mtail = m-&gt;mprev;
	m-&gt;mprev = m-&gt;mnext = nil;
}

void
msgFlush(Msg* m)
{
	Con *con;
	Msg *flush, *old;

	con = m-&gt;con;

	if(Dflag)
		fprint(2, "msgFlush %F\n", &amp;m-&gt;t);

	/*
	 * If this Tflush has been flushed, nothing to do.
	 * Look for the message to be flushed in the
	 * queue of all messages still on this connection.
	 * If it's not found must assume Elvis has already
	 * left the building and reply normally.
	 */
	vtLock(con-&gt;mlock);
	if(m-&gt;state == MsgF){
		vtUnlock(con-&gt;mlock);
		return;
	}
	for(old = con-&gt;mhead; old != nil; old = old-&gt;mnext)
		if(old-&gt;t.tag == m-&gt;t.oldtag)
			break;
	if(old == nil){
		if(Dflag)
			fprint(2, "msgFlush: cannot find %d\n", m-&gt;t.oldtag);
		vtUnlock(con-&gt;mlock);
		return;
	}

	if(Dflag)
		fprint(2, "\tmsgFlush found %F\n", &amp;old-&gt;t);

	/*
	 * Found it.
	 * There are two cases where the old message can be
	 * truly flushed and no reply to the original message given.
	 * The first is when the old message is in MsgR state; no
	 * processing has been done yet and it is still on the read
	 * queue. The second is if old is a Tflush, which doesn't
	 * affect the server state. In both cases, put the old
	 * message into MsgF state and let MsgWrite toss it after
	 * pulling it off the queue.
	 */
	if(old-&gt;state == MsgR || old-&gt;t.type == Tflush){
		old-&gt;state = MsgF;
		if(Dflag)
			fprint(2, "msgFlush: change %d from MsgR to MsgF\n",
				m-&gt;t.oldtag);
	}

	/*
	 * Link this flush message and the old message
	 * so multiple flushes can be coalesced (if there are
	 * multiple Tflush messages for a particular pending
	 * request, it is only necessary to respond to the last
	 * one, so any previous can be removed) and to be
	 * sure flushes wait for their corresponding old
	 * message to go out first.
	 * Waiting flush messages do not go on the write queue,
	 * they are processed after the old message is dealt
	 * with. There's no real need to protect the setting of
	 * Msg.nowq, the only code to check it runs in this
	 * process after this routine returns.
	 */
	if((flush = old-&gt;flush) != nil){
		if(Dflag)
			fprint(2, "msgFlush: remove %d from %d list\n",
				old-&gt;flush-&gt;t.tag, old-&gt;t.tag);
		m-&gt;flush = flush-&gt;flush;
		flush-&gt;flush = nil;
		msgMunlink(flush);
		msgFree(flush);
	}
	old-&gt;flush = m;
	m-&gt;nowq = 1;

	if(Dflag)
		fprint(2, "msgFlush: add %d to %d queue\n",
			m-&gt;t.tag, old-&gt;t.tag);
	vtUnlock(con-&gt;mlock);
}

static void
msgProc(void*)
{
	Msg *m;
	char *e;
	Con *con;

	vtThreadSetName("msgProc");

	for(;;){
		/*
		 * If surplus to requirements, exit.
		 * If not, wait for and pull a message off
		 * the read queue.
		 */
		vtLock(mbox.rlock);
		if(mbox.nproc &gt; mbox.maxproc){
			mbox.nproc--;
			vtUnlock(mbox.rlock);
			break;
		}
		while(mbox.rhead == nil)
			vtSleep(mbox.rrendez);
		m = mbox.rhead;
		mbox.rhead = m-&gt;rwnext;
		m-&gt;rwnext = nil;
		vtUnlock(mbox.rlock);

		con = m-&gt;con;
		e = nil;

		/*
		 * If the message has been flushed before
		 * any 9P processing has started, mark it so
		 * none will be attempted.
		 */
		vtLock(con-&gt;mlock);
		if(m-&gt;state == MsgF)
			e = "flushed";
		else
			m-&gt;state = Msg9;
		vtUnlock(con-&gt;mlock);

		if(e == nil){
			/*
			 * explain this
			 */
			vtLock(con-&gt;lock);
			if(m-&gt;t.type == Tversion){
				con-&gt;version = m;
				con-&gt;state = ConDown;
				while(con-&gt;mhead != m)
					vtSleep(con-&gt;rendez);
				assert(con-&gt;state == ConDown);
				if(con-&gt;version == m){
					con-&gt;version = nil;
					con-&gt;state = ConInit;
				}
				else
					e = "Tversion aborted";
			}
			else if(con-&gt;state != ConUp)
				e = "connection not ready";
			vtUnlock(con-&gt;lock);
		}

		/*
		 * Dispatch if not error already.
		 */
		m-&gt;r.tag = m-&gt;t.tag;
		if(e == nil &amp;&amp; !(*rFcall[m-&gt;t.type])(m))
			e = vtGetError();
		if(e != nil){
			m-&gt;r.type = Rerror;
			m-&gt;r.ename = e;
		}
		else
			m-&gt;r.type = m-&gt;t.type+1;

		/*
		 * Put the message (with reply) on the
		 * write queue and wakeup the write process.
		 */
		if(!m-&gt;nowq){
			vtLock(con-&gt;wlock);
			if(con-&gt;whead == nil)
				con-&gt;whead = m;
			else
				con-&gt;wtail-&gt;rwnext = m;
			con-&gt;wtail = m;
			vtWakeup(con-&gt;wrendez);
			vtUnlock(con-&gt;wlock);
		}
	}
}

static void
msgRead(void* v)
{
	Msg *m;
	Con *con;
	int eof, fd, n;

	vtThreadSetName("msgRead");

	con = v;
	fd = con-&gt;fd;
	eof = 0;

	while(!eof){
		m = msgAlloc(con);

		while((n = read9pmsg(fd, m-&gt;data, con-&gt;msize)) == 0)
			;
		if(n &lt; 0){
			m-&gt;t.type = Tversion;
			m-&gt;t.fid = NOFID;
			m-&gt;t.tag = NOTAG;
			m-&gt;t.msize = con-&gt;msize;
			m-&gt;t.version = "9PEoF";
			eof = 1;
		}
		else if(convM2S(m-&gt;data, n, &amp;m-&gt;t) != n){
			if(Dflag)
				fprint(2, "msgRead: convM2S error: %s\n",
					con-&gt;name);
			msgFree(m);
			continue;
		}
		if(Dflag)
			fprint(2, "msgRead %p: t %F\n", con, &amp;m-&gt;t);

		vtLock(con-&gt;mlock);
		if(con-&gt;mtail != nil){
			m-&gt;mprev = con-&gt;mtail;
			con-&gt;mtail-&gt;mnext = m;
		}
		else{
			con-&gt;mhead = m;
			m-&gt;mprev = nil;
		}
		con-&gt;mtail = m;
		vtUnlock(con-&gt;mlock);

		vtLock(mbox.rlock);
		if(mbox.rhead == nil){
			mbox.rhead = m;
			if(!vtWakeup(mbox.rrendez)){
				if(mbox.nproc &lt; mbox.maxproc){
					if(vtThread(msgProc, nil) &gt; 0)
						mbox.nproc++;
				}
				else
					mbox.nprocstarve++;
			}
			/*
			 * don't need this surely?
			vtWakeup(mbox.rrendez);
			 */
		}
		else
			mbox.rtail-&gt;rwnext = m;
		mbox.rtail = m;
		vtUnlock(mbox.rlock);
	}
}

static void
msgWrite(void* v)
{
	Con *con;
	int eof, n;
	Msg *flush, *m;

	vtThreadSetName("msgWrite");

	con = v;
	if(vtThread(msgRead, con) &lt; 0){
		conFree(con);
		return;
	}

	for(;;){
		/*
		 * Wait for and pull a message off the write queue.
		 */
		vtLock(con-&gt;wlock);
		while(con-&gt;whead == nil)
			vtSleep(con-&gt;wrendez);
		m = con-&gt;whead;
		con-&gt;whead = m-&gt;rwnext;
		m-&gt;rwnext = nil;
		assert(!m-&gt;nowq);
		vtUnlock(con-&gt;wlock);

		eof = 0;

		/*
		 * Write each message (if it hasn't been flushed)
		 * followed by any messages waiting for it to complete.
		 */
		vtLock(con-&gt;mlock);
		while(m != nil){
			msgMunlink(m);

			if(Dflag)
				fprint(2, "msgWrite %d: r %F\n",
					m-&gt;state, &amp;m-&gt;r);

			if(m-&gt;state != MsgF){
				m-&gt;state = MsgW;
				vtUnlock(con-&gt;mlock);

				n = convS2M(&amp;m-&gt;r, con-&gt;data, con-&gt;msize);
				if(write(con-&gt;fd, con-&gt;data, n) != n)
					eof = 1;

				vtLock(con-&gt;mlock);
			}

			if((flush = m-&gt;flush) != nil){
				assert(flush-&gt;nowq);
				m-&gt;flush = nil;
			}
			msgFree(m);
			m = flush;
		}
		vtUnlock(con-&gt;mlock);

		vtLock(con-&gt;lock);
		if(eof &amp;&amp; con-&gt;fd &gt;= 0){
			close(con-&gt;fd);
			con-&gt;fd = -1;
		}
		if(con-&gt;state == ConDown)
			vtWakeup(con-&gt;rendez);
		if(con-&gt;state == ConMoribund &amp;&amp; con-&gt;mhead == nil){
			vtUnlock(con-&gt;lock);
			conFree(con);
			break;
		}
		vtUnlock(con-&gt;lock);
	}
}

Con*
conAlloc(int fd, char* name, int flags)
{
	Con *con;
	char buf[128], *p;
	int rfd, n;

	vtLock(cbox.alock);
	while(cbox.ahead == nil){
		if(cbox.ncon &gt;= cbox.maxcon){
			cbox.nconstarve++;
			vtSleep(cbox.arendez);
			continue;
		}
		con = vtMemAllocZ(sizeof(Con));
		con-&gt;lock = vtLockAlloc();
		con-&gt;rendez = vtRendezAlloc(con-&gt;lock);
		con-&gt;data = vtMemAlloc(cbox.msize);
		con-&gt;msize = cbox.msize;
		con-&gt;alock = vtLockAlloc();
		con-&gt;mlock = vtLockAlloc();
		con-&gt;mrendez = vtRendezAlloc(con-&gt;mlock);
		con-&gt;wlock = vtLockAlloc();
		con-&gt;wrendez = vtRendezAlloc(con-&gt;wlock);
		con-&gt;fidlock = vtLockAlloc();

		cbox.ncon++;
		cbox.ahead = con;
		break;
	}
	con = cbox.ahead;
	cbox.ahead = con-&gt;anext;
	con-&gt;anext = nil;

	if(cbox.ctail != nil){
		con-&gt;cprev = cbox.ctail;
		cbox.ctail-&gt;cnext = con;
	}
	else{
		cbox.chead = con;
		con-&gt;cprev = nil;
	}
	cbox.ctail = con;

	assert(con-&gt;mhead == nil);
	assert(con-&gt;whead == nil);
	assert(con-&gt;fhead == nil);
	assert(con-&gt;nfid == 0);

	con-&gt;state = ConNew;
	con-&gt;fd = fd;
	if(con-&gt;name != nil){
		vtMemFree(con-&gt;name);
		con-&gt;name = nil;
	}
	if(name != nil)
		con-&gt;name = vtStrDup(name);
	else
		con-&gt;name = vtStrDup("unknown");
	con-&gt;remote[0] = 0;
	snprint(buf, sizeof buf, "%s/remote", con-&gt;name);
	if((rfd = open(buf, OREAD)) &gt;= 0){
		n = read(rfd, buf, sizeof buf-1);
		close(rfd);
		if(n &gt; 0){
			buf[n] = 0;
			if((p = strchr(buf, '\n')) != nil)
				*p = 0;
			strecpy(con-&gt;remote, con-&gt;remote+sizeof con-&gt;remote, buf);
		}
	}
	con-&gt;flags = flags;
	con-&gt;isconsole = 0;
	vtUnlock(cbox.alock);

	if(vtThread(msgWrite, con) &lt; 0){
		conFree(con);
		return nil;
	}

	return con;
}

static int
cmdMsg(int argc, char* argv[])
{
	char *p;
	char *usage = "usage: msg [-m nmsg] [-p nproc]";
	int maxmsg, nmsg, nmsgstarve, maxproc, nproc, nprocstarve;

	maxmsg = maxproc = 0;

	ARGBEGIN{
	default:
		return cliError(usage);
	case 'm':
		p = ARGF();
		if(p == nil)
			return cliError(usage);
		maxmsg = strtol(argv[0], &amp;p, 0);
		if(maxmsg &lt;= 0 || p == argv[0] || *p != '\0')
			return cliError(usage);
		break;
	case 'p':
		p = ARGF();
		if(p == nil)
			return cliError(usage);
		maxproc = strtol(argv[0], &amp;p, 0);
		if(maxproc &lt;= 0 || p == argv[0] || *p != '\0')
			return cliError(usage);
		break;
	}ARGEND
	if(argc)
		return cliError(usage);

	vtLock(mbox.alock);
	if(maxmsg)
		mbox.maxmsg = maxmsg;
	maxmsg = mbox.maxmsg;
	nmsg = mbox.nmsg;
	nmsgstarve = mbox.nmsgstarve;
	vtUnlock(mbox.alock);

	vtLock(mbox.rlock);
	if(maxproc)
		mbox.maxproc = maxproc;
	maxproc = mbox.maxproc;
	nproc = mbox.nproc;
	nprocstarve = mbox.nprocstarve;
	vtUnlock(mbox.rlock);

	consPrint("\tmsg -m %d -p %d\n", maxmsg, maxproc);
	consPrint("\tnmsg %d nmsgstarve %d nproc %d nprocstarve %d\n",
		nmsg, nmsgstarve, nproc, nprocstarve);

	return 1;
}

static int
scmp(Fid *a, Fid *b)
{
	if(a == 0)
		return 1;
	if(b == 0)
		return -1;
	return strcmp(a-&gt;uname, b-&gt;uname);
}

static Fid*
fidMerge(Fid *a, Fid *b)
{
	Fid *s, **l;

	l = &amp;s;
	while(a || b){
		if(scmp(a, b) &lt; 0){
			*l = a;
			l = &amp;a-&gt;sort;
			a = a-&gt;sort;
		}else{
			*l = b;
			l = &amp;b-&gt;sort;
			b = b-&gt;sort;
		}
	}
	*l = 0;
	return s;
}

static Fid*
fidMergeSort(Fid *f)
{
	int delay;
	Fid *a, *b;

	if(f == nil)
		return nil;
	if(f-&gt;sort == nil)
		return f;

	a = b = f;
	delay = 1;
	while(a &amp;&amp; b){
		if(delay)	/* easy way to handle 2-element list */
			delay = 0;
		else
			a = a-&gt;sort;
		if(b = b-&gt;sort)
			b = b-&gt;sort;
	}

	b = a-&gt;sort;
	a-&gt;sort = nil;

	a = fidMergeSort(f);
	b = fidMergeSort(b);

	return fidMerge(a, b);
}

static int
cmdWho(int argc, char* argv[])
{
	char *usage = "usage: who";
	int i, l1, l2, l;
	Con *con;
	Fid *fid, *last;

	ARGBEGIN{
	default:
		return cliError(usage);
	}ARGEND

	if(argc &gt; 0)
		return cliError(usage);

	vtRLock(cbox.clock);
	l1 = 0;
	l2 = 0;
	for(con=cbox.chead; con; con=con-&gt;cnext){
		if((l = strlen(con-&gt;name)) &gt; l1)
			l1 = l;
		if((l = strlen(con-&gt;remote)) &gt; l2)
			l2 = l;
	}
	for(con=cbox.chead; con; con=con-&gt;cnext){
		consPrint("\t%-*s %-*s", l1, con-&gt;name, l2, con-&gt;remote);
		vtLock(con-&gt;fidlock);
		last = nil;
		for(i=0; i&lt;NFidHash; i++)
			for(fid=con-&gt;fidhash[i]; fid; fid=fid-&gt;hash)
				if(fid-&gt;fidno != NOFID &amp;&amp; fid-&gt;uname){
					fid-&gt;sort = last;
					last = fid;
				}
		fid = fidMergeSort(last);
		last = nil;
		for(; fid; last=fid, fid=fid-&gt;sort)
			if(last==nil || strcmp(fid-&gt;uname, last-&gt;uname) != 0)
				consPrint(" %q", fid-&gt;uname);
		vtUnlock(con-&gt;fidlock);
		consPrint("\n");
	}
	vtRUnlock(cbox.clock);
	return 1;
}

void
msgInit(void)
{
	mbox.alock = vtLockAlloc();
	mbox.arendez = vtRendezAlloc(mbox.alock);

	mbox.rlock = vtLockAlloc();
	mbox.rrendez = vtRendezAlloc(mbox.rlock);

	mbox.maxmsg = NMsgInit;
	mbox.maxproc = NMsgProcInit;
	mbox.msize = NMsizeInit;

	cliAddCmd("msg", cmdMsg);
}

static int
cmdCon(int argc, char* argv[])
{
	char *p;
	Con *con;
	char *usage = "usage: con [-m ncon]";
	int maxcon, ncon, nconstarve;

	maxcon = 0;

	ARGBEGIN{
	default:
		return cliError(usage);
	case 'm':
		p = ARGF();
		if(p == nil)
			return cliError(usage);
		maxcon = strtol(argv[0], &amp;p, 0);
		if(maxcon &lt;= 0 || p == argv[0] || *p != '\0')
			return cliError(usage);
		break;
	}ARGEND
	if(argc)
		return cliError(usage);

	vtLock(cbox.clock);
	if(maxcon)
		cbox.maxcon = maxcon;
	maxcon = cbox.maxcon;
	ncon = cbox.ncon;
	nconstarve = cbox.nconstarve;
	vtUnlock(cbox.clock);

	consPrint("\tcon -m %d\n", maxcon);
	consPrint("\tncon %d nconstarve %d\n", ncon, nconstarve);

	vtRLock(cbox.clock);
	for(con = cbox.chead; con != nil; con = con-&gt;cnext){
		consPrint("\t%s\n", con-&gt;name);
	}
	vtRUnlock(cbox.clock);

	return 1;
}

void
conInit(void)
{
	cbox.alock = vtLockAlloc();
	cbox.arendez = vtRendezAlloc(cbox.alock);

	cbox.clock = vtLockAlloc();

	cbox.maxcon = NConInit;
	cbox.msize = NMsizeInit;

	cliAddCmd("con", cmdCon);
	cliAddCmd("who", cmdWho);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

