<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/Ccons.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/Ccons.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"

#include "9.h"

enum {
	Nl	= 256,			/* max. command line length */
	Nq	= 8*1024,		/* amount of I/O buffered */
};

typedef struct Q {
	VtLock*	lock;
	VtRendez* full;
	VtRendez* empty;

	char	q[Nq];
	int	n;
	int	r;
	int	w;
} Q;

typedef struct Cons {
	VtLock*	lock;
	int	ref;
	int	closed;
	int	fd;
	int	srvfd;
	int	ctlfd;
	Q*	iq;		/* points to console.iq */
	Q*	oq;		/* points to console.oq */
} Cons;

char *currfsysname;

static struct {
	Q*	iq;		/* input */
	Q*	oq;		/* output */
	char	l[Nl];		/* command line assembly */
	int	nl;		/* current line length */
	int	nopens;

	char*	prompt;
	int	np;
} console;

static void
consClose(Cons* cons)
{
	vtLock(cons-&gt;lock);
	cons-&gt;closed = 1;

	cons-&gt;ref--;
	if(cons-&gt;ref &gt; 0){
		vtLock(cons-&gt;iq-&gt;lock);
		vtWakeup(cons-&gt;iq-&gt;full);
		vtUnlock(cons-&gt;iq-&gt;lock);
		vtLock(cons-&gt;oq-&gt;lock);
		vtWakeup(cons-&gt;oq-&gt;empty);
		vtUnlock(cons-&gt;oq-&gt;lock);
		vtUnlock(cons-&gt;lock);
		return;
	}

	if(cons-&gt;ctlfd != -1){
		close(cons-&gt;ctlfd);
		cons-&gt;srvfd = -1;
	}
	if(cons-&gt;srvfd != -1){
		close(cons-&gt;srvfd);
		cons-&gt;srvfd = -1;
	}
	if(cons-&gt;fd != -1){
		close(cons-&gt;fd);
		cons-&gt;fd = -1;
	}
	vtUnlock(cons-&gt;lock);
	vtLockFree(cons-&gt;lock);
	vtMemFree(cons);
	console.nopens--;
}

static void
consIProc(void* v)
{
	Q *q;
	Cons *cons;
	int n, w;
	char buf[Nq/4];

	vtThreadSetName("consI");

	cons = v;
	q = cons-&gt;iq;
	for(;;){
		/*
		 * Can't tell the difference between zero-length read
		 * and eof, so keep calling read until we get an error.
		 */
		if(cons-&gt;closed || (n = read(cons-&gt;fd, buf, Nq/4)) &lt; 0)
			break;
		vtLock(q-&gt;lock);
		while(Nq - q-&gt;n &lt; n &amp;&amp; !cons-&gt;closed)
			vtSleep(q-&gt;full);
		w = Nq - q-&gt;w;
		if(w &lt; n){
			memmove(&amp;q-&gt;q[q-&gt;w], buf, w);
			memmove(&amp;q-&gt;q[0], buf + w, n - w);
		}
		else
			memmove(&amp;q-&gt;q[q-&gt;w], buf, n);
		q-&gt;w = (q-&gt;w + n) % Nq;
		q-&gt;n += n;
		vtWakeup(q-&gt;empty);
		vtUnlock(q-&gt;lock);
	}
	consClose(cons);
}

static void
consOProc(void* v)
{
	Q *q;
	Cons *cons;
	char buf[Nq];
	int lastn, n, r;

	vtThreadSetName("consO");

	cons = v;
	q = cons-&gt;oq;
	vtLock(q-&gt;lock);
	lastn = 0;
	for(;;){
		while(lastn == q-&gt;n &amp;&amp; !cons-&gt;closed)
			vtSleep(q-&gt;empty);
		if((n = q-&gt;n - lastn) &gt; Nq)
			n = Nq;
		if(n &gt; q-&gt;w){
			r = n - q-&gt;w;
			memmove(buf, &amp;q-&gt;q[Nq - r], r);
			memmove(buf+r, &amp;q-&gt;q[0], n - r);
		}
		else
			memmove(buf, &amp;q-&gt;q[q-&gt;w - n], n);
		lastn = q-&gt;n;
		vtUnlock(q-&gt;lock);
		if(cons-&gt;closed || write(cons-&gt;fd, buf, n) &lt; 0)
			break;
		vtLock(q-&gt;lock);
		vtWakeup(q-&gt;empty);
	}
	consClose(cons);
}

int
consOpen(int fd, int srvfd, int ctlfd)
{
	Cons *cons;

	cons = vtMemAllocZ(sizeof(Cons));
	cons-&gt;lock = vtLockAlloc();
	cons-&gt;fd = fd;
	cons-&gt;srvfd = srvfd;
	cons-&gt;ctlfd = ctlfd;
	cons-&gt;iq = console.iq;
	cons-&gt;oq = console.oq;
	console.nopens++;

	vtLock(cons-&gt;lock);
	cons-&gt;ref = 2;
	cons-&gt;closed = 0;
	if(vtThread(consOProc, cons) &lt; 0){
		cons-&gt;ref--;
		vtUnlock(cons-&gt;lock);
		consClose(cons);
		return 0;
	}
	vtUnlock(cons-&gt;lock);

	if(ctlfd &gt;= 0)
		consIProc(cons);
	else if(vtThread(consIProc, cons) &lt; 0){
		consClose(cons);
		return 0;
	}

	return 1;
}

static int
qWrite(Q* q, char* p, int n)
{
	int w;

	vtLock(q-&gt;lock);
	if(n &gt; Nq - q-&gt;w){
		w = Nq - q-&gt;w;
		memmove(&amp;q-&gt;q[q-&gt;w], p, w);
		memmove(&amp;q-&gt;q[0], p + w, n - w);
		q-&gt;w = n - w;
	}
	else{
		memmove(&amp;q-&gt;q[q-&gt;w], p, n);
		q-&gt;w += n;
	}
	q-&gt;n += n;
	vtWakeup(q-&gt;empty);
	vtUnlock(q-&gt;lock);

	return n;
}

static Q*
qAlloc(void)
{
	Q *q;

	q = vtMemAllocZ(sizeof(Q));
	q-&gt;lock = vtLockAlloc();
	q-&gt;full = vtRendezAlloc(q-&gt;lock);
	q-&gt;empty = vtRendezAlloc(q-&gt;lock);
	q-&gt;n = q-&gt;r = q-&gt;w = 0;

	return q;
}

static void
consProc(void*)
{
	Q *q;
	int argc, i, n, r;
	char *argv[20], buf[Nq], *lp, *wbuf;
	char procname[64];

	snprint(procname, sizeof procname, "cons %s", currfsysname);
	vtThreadSetName(procname);

	q = console.iq;
	qWrite(console.oq, console.prompt, console.np);
	vtLock(q-&gt;lock);
	for(;;){
		while((n = q-&gt;n) == 0)
			vtSleep(q-&gt;empty);
		r = Nq - q-&gt;r;
		if(r &lt; n){
			memmove(buf, &amp;q-&gt;q[q-&gt;r], r);
			memmove(buf + r, &amp;q-&gt;q[0], n - r);
		}
		else
			memmove(buf, &amp;q-&gt;q[q-&gt;r], n);
		q-&gt;r = (q-&gt;r + n) % Nq;
		q-&gt;n -= n;
		vtWakeup(q-&gt;full);
		vtUnlock(q-&gt;lock);

		for(i = 0; i &lt; n; i++){
			switch(buf[i]){
			case '\004':				/* ^D */
				if(console.nl == 0){
					qWrite(console.oq, "\n", 1);
					break;
				}
				/*FALLTHROUGH*/
			default:
				if(console.nl &lt; Nl-1){
					qWrite(console.oq, &amp;buf[i], 1);
					console.l[console.nl++] = buf[i];
				}
				continue;
			case '\b':
				if(console.nl != 0){
					qWrite(console.oq, &amp;buf[i], 1);
					console.nl--;
				}
				continue;
			case '\n':
				qWrite(console.oq, &amp;buf[i], 1);
				break;
			case '\025':				/* ^U */
				qWrite(console.oq, "^U\n", 3);
				console.nl = 0;
				break;
			case '\027':				/* ^W */
				console.l[console.nl] = '\0';
				wbuf = vtMemAlloc(console.nl+1);
				memmove(wbuf, console.l, console.nl+1);
				argc = tokenize(wbuf, argv, nelem(argv));
				if(argc &gt; 0)
					argc--;
				console.nl = 0;
				lp = console.l;
				for(i = 0; i &lt; argc; i++)
					lp += sprint(lp, "%q ", argv[i]);
				console.nl = lp - console.l;
				vtMemFree(wbuf);
				qWrite(console.oq, "^W\n", 3);
				if(console.nl == 0)
					break;
				qWrite(console.oq, console.l, console.nl);
				continue;
			case '\177':
				qWrite(console.oq, "\n", 1);
				console.nl = 0;
				break;
			}

			console.l[console.nl] = '\0';
			if(console.nl != 0)
				cliExec(console.l);

			console.nl = 0;
			qWrite(console.oq, console.prompt, console.np);
		}

		vtLock(q-&gt;lock);
	}
}

int
consWrite(char* buf, int len)
{
	if(console.oq == nil)
		return write(2, buf, len);
	if(console.nopens == 0)
		write(2, buf, len);
	return qWrite(console.oq, buf, len);
}

int
consPrompt(char* prompt)
{
	char buf[ERRMAX];

	if(prompt == nil)
		prompt = "prompt";

	vtMemFree(console.prompt);
	console.np = snprint(buf, sizeof(buf), "%s: ", prompt);
	console.prompt = vtStrDup(buf);

	return console.np;
}

int
consTTY(void)
{
	int ctl, fd;
	char *name, *p;

	name = "/dev/cons";
	if((fd = open(name, ORDWR)) &lt; 0){
		name = "#c/cons";
		if((fd = open(name, ORDWR)) &lt; 0){
			vtSetError("consTTY: open %s: %r", name);
			return 0;
		}
	}

	p = smprint("%sctl", name);
	if((ctl = open(p, OWRITE)) &lt; 0){
		close(fd);
		vtSetError("consTTY: open %s: %r", p);
		free(p);
		return 0;
	}
	if(write(ctl, "rawon", 5) &lt; 0){
		close(ctl);
		close(fd);
		vtSetError("consTTY: write %s: %r", p);
		free(p);
		return 0;
	}
	free(p);

	if(consOpen(fd, fd, ctl) == 0){
		close(ctl);
		close(fd);
		return 0;
	}

	return 1;
}

int
consInit(void)
{
	console.iq = qAlloc();
	console.oq = qAlloc();
	console.nl = 0;

	consPrompt(nil);

	if(vtThread(consProc, nil) &lt; 0){
		vtFatal("can't start console proc");
		return 0;
	}

	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

