<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/cache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/cache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "error.h"

#include "9.h"	/* for cacheFlush */

typedef struct FreeList FreeList;
typedef struct BAddr BAddr;

enum {
	BadHeap = ~0,
};

/*
 * Store data to the memory cache in c-&gt;size blocks
 * with the block zero extended to fill it out.  When writing to
 * Venti, the block will be zero truncated.  The walker will also check
 * that the block fits within psize or dsize as the case may be.
 */

struct Cache
{
	VtLock	*lk;
	int 	ref;
	int	mode;

	Disk 	*disk;
	int	size;			/* block size */
	int	ndmap;		/* size of per-block dirty pointer map used in blockWrite */
	VtSession *z;
	u32int	now;			/* ticks for usage timestamps */
	Block	**heads;		/* hash table for finding address */
	int	nheap;			/* number of available victims */
	Block	**heap;			/* heap for locating victims */
	long	nblocks;		/* number of blocks allocated */
	Block	*blocks;		/* array of block descriptors */
	u8int	*mem;			/* memory for all block data &amp; blists */

	BList	*blfree;
	VtRendez *blrend;

	int 	ndirty;			/* number of dirty blocks in the cache */
	int 	maxdirty;		/* max number of dirty blocks */
	u32int	vers;

	long hashSize;

	FreeList *fl;

	VtRendez *die;			/* daemon threads should die when != nil */

	VtRendez *flush;
	VtRendez *flushwait;
	VtRendez *heapwait;
	BAddr *baddr;
	int bw, br, be;
	int nflush;

	Periodic *sync;

	/* unlink daemon */
	BList *uhead;
	BList *utail;
	VtRendez *unlink;

	/* block counts */
	int nused;
	int ndisk;
};

struct BList {
	int part;
	u32int addr;
	uchar type;
	u32int tag;
	u32int epoch;
	u32int vers;

	int recurse;	/* for block unlink */

	/* for roll back */
	int index;			/* -1 indicates not valid */
	union {
		uchar score[VtScoreSize];
		uchar entry[VtEntrySize];
	} old;
	BList *next;
};

struct BAddr {
	int part;
	u32int addr;
	u32int vers;
};

struct FreeList {
	VtLock *lk;
	u32int last;		/* last block allocated */
	u32int end;		/* end of data partition */
	u32int nused;		/* number of used blocks */
	u32int epochLow;	/* low epoch when last updated nused */
};

static FreeList *flAlloc(u32int end);
static void flFree(FreeList *fl);

static Block *cacheBumpBlock(Cache *c);
static void heapDel(Block*);
static void heapIns(Block*);
static void cacheCheck(Cache*);
static void unlinkThread(void *a);
static void flushThread(void *a);
static void unlinkBody(Cache *c);
static int cacheFlushBlock(Cache *c);
static void cacheSync(void*);
static BList *blistAlloc(Block*);
static void blistFree(Cache*, BList*);
static void doRemoveLink(Cache*, BList*);

/*
 * Mapping from local block type to Venti type
 */
int vtType[BtMax] = {
	VtDataType,		/* BtData | 0  */
	VtPointerType0,		/* BtData | 1  */
	VtPointerType1,		/* BtData | 2  */
	VtPointerType2,		/* BtData | 3  */
	VtPointerType3,		/* BtData | 4  */
	VtPointerType4,		/* BtData | 5  */
	VtPointerType5,		/* BtData | 6  */
	VtPointerType6,		/* BtData | 7  */
	VtDirType,		/* BtDir | 0  */
	VtPointerType0,		/* BtDir | 1  */
	VtPointerType1,		/* BtDir | 2  */
	VtPointerType2,		/* BtDir | 3  */
	VtPointerType3,		/* BtDir | 4  */
	VtPointerType4,		/* BtDir | 5  */
	VtPointerType5,		/* BtDir | 6  */
	VtPointerType6,		/* BtDir | 7  */
};

/*
 * Allocate the memory cache.
 */
Cache *
cacheAlloc(Disk *disk, VtSession *z, ulong nblocks, int mode)
{
	int i;
	Cache *c;
	Block *b;
	BList *bl;
	u8int *p;
	int nbl;

	c = vtMemAllocZ(sizeof(Cache));

	/* reasonable number of BList elements */
	nbl = nblocks * 4;

	c-&gt;lk = vtLockAlloc();
	c-&gt;ref = 1;
	c-&gt;disk = disk;
	c-&gt;z = z;
	c-&gt;size = diskBlockSize(disk);
bwatchSetBlockSize(c-&gt;size);
	/* round c-&gt;size up to be a nice multiple */
	c-&gt;size = (c-&gt;size + 127) &amp; ~127;
	c-&gt;ndmap = (c-&gt;size/20 + 7) / 8;
	c-&gt;nblocks = nblocks;
	c-&gt;hashSize = nblocks;
	c-&gt;heads = vtMemAllocZ(c-&gt;hashSize*sizeof(Block*));
	c-&gt;heap = vtMemAllocZ(nblocks*sizeof(Block*));
	c-&gt;blocks = vtMemAllocZ(nblocks*sizeof(Block));
	c-&gt;mem = vtMemAllocZ(nblocks * (c-&gt;size + c-&gt;ndmap) + nbl * sizeof(BList));
	c-&gt;baddr = vtMemAllocZ(nblocks * sizeof(BAddr));
	c-&gt;mode = mode;
	c-&gt;vers++;
	p = c-&gt;mem;
	for(i = 0; i &lt; nblocks; i++){
		b = &amp;c-&gt;blocks[i];
		b-&gt;lk = vtLockAlloc();
		b-&gt;c = c;
		b-&gt;data = p;
		b-&gt;heap = i;
		b-&gt;ioready = vtRendezAlloc(b-&gt;lk);
		c-&gt;heap[i] = b;
		p += c-&gt;size;
	}
	c-&gt;nheap = nblocks;
	for(i = 0; i &lt; nbl; i++){
		bl = (BList*)p;
		bl-&gt;next = c-&gt;blfree;
		c-&gt;blfree = bl;
		p += sizeof(BList);
	}
	/* separate loop to keep blocks and blists reasonably aligned */
	for(i = 0; i &lt; nblocks; i++){
		b = &amp;c-&gt;blocks[i];
		b-&gt;dmap = p;
		p += c-&gt;ndmap;
	}

	c-&gt;blrend = vtRendezAlloc(c-&gt;lk);

	c-&gt;maxdirty = nblocks*(DirtyPercentage*0.01);

	c-&gt;fl = flAlloc(diskSize(disk, PartData));

	c-&gt;unlink = vtRendezAlloc(c-&gt;lk);
	c-&gt;flush = vtRendezAlloc(c-&gt;lk);
	c-&gt;flushwait = vtRendezAlloc(c-&gt;lk);
	c-&gt;heapwait = vtRendezAlloc(c-&gt;lk);
	c-&gt;sync = periodicAlloc(cacheSync, c, 30*1000);

	if(mode == OReadWrite){
		c-&gt;ref += 2;
		vtThread(unlinkThread, c);
		vtThread(flushThread, c);
	}
	cacheCheck(c);

	return c;
}

/*
 * Free the whole memory cache, flushing all dirty blocks to the disk.
 */
void
cacheFree(Cache *c)
{
	int i;

	/* kill off daemon threads */
	vtLock(c-&gt;lk);
	c-&gt;die = vtRendezAlloc(c-&gt;lk);
	periodicKill(c-&gt;sync);
	vtWakeup(c-&gt;flush);
	vtWakeup(c-&gt;unlink);
	while(c-&gt;ref &gt; 1)
		vtSleep(c-&gt;die);

	/* flush everything out */
	do {
		unlinkBody(c);
		vtUnlock(c-&gt;lk);
		while(cacheFlushBlock(c))
			;
		diskFlush(c-&gt;disk);
		vtLock(c-&gt;lk);
	} while(c-&gt;uhead || c-&gt;ndirty);
	vtUnlock(c-&gt;lk);

	cacheCheck(c);

	for(i = 0; i &lt; c-&gt;nblocks; i++){
		assert(c-&gt;blocks[i].ref == 0);
		vtRendezFree(c-&gt;blocks[i].ioready);
		vtLockFree(c-&gt;blocks[i].lk);
	}
	flFree(c-&gt;fl);
	vtMemFree(c-&gt;baddr);
	vtMemFree(c-&gt;heads);
	vtMemFree(c-&gt;blocks);
	vtMemFree(c-&gt;mem);
	vtLockFree(c-&gt;lk);
	diskFree(c-&gt;disk);
	vtRendezFree(c-&gt;blrend);
	/* don't close vtSession */
	vtMemFree(c);
}

static void
cacheDump(Cache *c)
{
	int i;
	Block *b;

	for(i = 0; i &lt; c-&gt;nblocks; i++){
		b = &amp;c-&gt;blocks[i];
		fprint(2, "%d. p=%d a=%ud %V t=%d ref=%d state=%s io=%s pc=%#p\n",
			i, b-&gt;part, b-&gt;addr, b-&gt;score, b-&gt;l.type, b-&gt;ref,
			bsStr(b-&gt;l.state), bioStr(b-&gt;iostate), b-&gt;pc);
	}
}

static void
cacheCheck(Cache *c)
{
	u32int size, now;
	int i, k, refed;
	static uchar zero[VtScoreSize];
	Block *b;

	size = c-&gt;size;
	now = c-&gt;now;

	for(i = 0; i &lt; c-&gt;nheap; i++){
		if(c-&gt;heap[i]-&gt;heap != i)
			vtFatal("mis-heaped at %d: %d", i, c-&gt;heap[i]-&gt;heap);
		if(i &gt; 0 &amp;&amp; c-&gt;heap[(i - 1) &gt;&gt; 1]-&gt;used - now &gt; c-&gt;heap[i]-&gt;used - now)
			vtFatal("bad heap ordering");
		k = (i &lt;&lt; 1) + 1;
		if(k &lt; c-&gt;nheap &amp;&amp; c-&gt;heap[i]-&gt;used - now &gt; c-&gt;heap[k]-&gt;used - now)
			vtFatal("bad heap ordering");
		k++;
		if(k &lt; c-&gt;nheap &amp;&amp; c-&gt;heap[i]-&gt;used - now &gt; c-&gt;heap[k]-&gt;used - now)
			vtFatal("bad heap ordering");
	}

	refed = 0;
	for(i = 0; i &lt; c-&gt;nblocks; i++){
		b = &amp;c-&gt;blocks[i];
		if(b-&gt;data != &amp;c-&gt;mem[i * size])
			vtFatal("mis-blocked at %d", i);
		if(b-&gt;ref &amp;&amp; b-&gt;heap == BadHeap){
			refed++;
		}
	}
if(c-&gt;nheap + refed != c-&gt;nblocks){
fprint(2, "%s: cacheCheck: nheap %d refed %d nblocks %ld\n", argv0, c-&gt;nheap, refed, c-&gt;nblocks);
cacheDump(c);
}
	assert(c-&gt;nheap + refed == c-&gt;nblocks);
	refed = 0;
	for(i = 0; i &lt; c-&gt;nblocks; i++){
		b = &amp;c-&gt;blocks[i];
		if(b-&gt;ref){
if(1)fprint(2, "%s: p=%d a=%ud %V ref=%d %L\n", argv0, b-&gt;part, b-&gt;addr, b-&gt;score, b-&gt;ref, &amp;b-&gt;l);
			refed++;
		}
	}
if(refed &gt; 0)fprint(2, "%s: cacheCheck: in used %d\n", argv0, refed);
}


/*
 * locate the block with the oldest second to last use.
 * remove it from the heap, and fix up the heap.
 */
/* called with c-&gt;lk held */
static Block *
cacheBumpBlock(Cache *c)
{
	int printed;
	Block *b;

	/*
	 * locate the block with the oldest second to last use.
	 * remove it from the heap, and fix up the heap.
	 */
	printed = 0;
	if(c-&gt;nheap == 0){
		while(c-&gt;nheap == 0){
			vtWakeup(c-&gt;flush);
			vtSleep(c-&gt;heapwait);
			if(c-&gt;nheap == 0){
				printed = 1;
				fprint(2, "%s: entire cache is busy, %d dirty "
					"-- waking flush thread\n",
					argv0, c-&gt;ndirty);
			}
		}
		if(printed)
			fprint(2, "%s: cache is okay again, %d dirty\n",
				argv0, c-&gt;ndirty);
	}

	b = c-&gt;heap[0];
	heapDel(b);

	assert(b-&gt;heap == BadHeap);
	assert(b-&gt;ref == 0);
	assert(b-&gt;iostate != BioDirty &amp;&amp; b-&gt;iostate != BioReading &amp;&amp; b-&gt;iostate != BioWriting);
	assert(b-&gt;prior == nil);
	assert(b-&gt;uhead == nil);

	/*
	 * unchain the block from hash chain
	 */
	if(b-&gt;prev){
		*(b-&gt;prev) = b-&gt;next;
		if(b-&gt;next)
			b-&gt;next-&gt;prev = b-&gt;prev;
		b-&gt;prev = nil;
	}


if(0)fprint(2, "%s: dropping %d:%x:%V\n", argv0, b-&gt;part, b-&gt;addr, b-&gt;score);
	/* set block to a reasonable state */
	b-&gt;ref = 1;
	b-&gt;part = PartError;
	memset(&amp;b-&gt;l, 0, sizeof(b-&gt;l));
	b-&gt;iostate = BioEmpty;

	return b;
}

/*
 * look for a particular version of the block in the memory cache.
 */
static Block *
_cacheLocalLookup(Cache *c, int part, u32int addr, u32int vers,
	int waitlock, int *lockfailure)
{
	Block *b;
	ulong h;

	h = addr % c-&gt;hashSize;

	if(lockfailure)
		*lockfailure = 0;

	/*
	 * look for the block in the cache
	 */
	vtLock(c-&gt;lk);
	for(b = c-&gt;heads[h]; b != nil; b = b-&gt;next){
		if(b-&gt;part == part &amp;&amp; b-&gt;addr == addr)
			break;
	}
	if(b == nil || b-&gt;vers != vers){
		vtUnlock(c-&gt;lk);
		return nil;
	}
	if(!waitlock &amp;&amp; !vtCanLock(b-&gt;lk)){
		*lockfailure = 1;
		vtUnlock(c-&gt;lk);
		return nil;
	}
	heapDel(b);
	b-&gt;ref++;
	vtUnlock(c-&gt;lk);

	bwatchLock(b);
	if(waitlock)
		vtLock(b-&gt;lk);
	b-&gt;nlock = 1;

	for(;;){
		switch(b-&gt;iostate){
		default:
			abort();
		case BioEmpty:
		case BioLabel:
		case BioClean:
		case BioDirty:
			if(b-&gt;vers != vers){
				blockPut(b);
				return nil;
			}
			return b;
		case BioReading:
		case BioWriting:
			vtSleep(b-&gt;ioready);
			break;
		case BioVentiError:
			blockPut(b);
			vtSetError("venti i/o error block 0x%.8ux", addr);
			return nil;
		case BioReadError:
			blockPut(b);
			vtSetError("error reading block 0x%.8ux", addr);
			return nil;
		}
	}
	/* NOT REACHED */
}
static Block*
cacheLocalLookup(Cache *c, int part, u32int addr, u32int vers)
{
	return _cacheLocalLookup(c, part, addr, vers, Waitlock, 0);
}


/*
 * fetch a local (on-disk) block from the memory cache.
 * if it's not there, load it, bumping some other block.
 */
Block *
_cacheLocal(Cache *c, int part, u32int addr, int mode, u32int epoch)
{
	Block *b;
	ulong h;

	assert(part != PartVenti);

	h = addr % c-&gt;hashSize;

	/*
	 * look for the block in the cache
	 */
	vtLock(c-&gt;lk);
	for(b = c-&gt;heads[h]; b != nil; b = b-&gt;next){
		if(b-&gt;part != part || b-&gt;addr != addr)
			continue;
		if(epoch &amp;&amp; b-&gt;l.epoch != epoch){
fprint(2, "%s: _cacheLocal want epoch %ud got %ud\n", argv0, epoch, b-&gt;l.epoch);
			vtUnlock(c-&gt;lk);
			vtSetError(ELabelMismatch);
			return nil;
		}
		heapDel(b);
		b-&gt;ref++;
		break;
	}

	if(b == nil){
		b = cacheBumpBlock(c);

		b-&gt;part = part;
		b-&gt;addr = addr;
		localToGlobal(addr, b-&gt;score);

		/* chain onto correct hash */
		b-&gt;next = c-&gt;heads[h];
		c-&gt;heads[h] = b;
		if(b-&gt;next != nil)
			b-&gt;next-&gt;prev = &amp;b-&gt;next;
		b-&gt;prev = &amp;c-&gt;heads[h];
	}

	vtUnlock(c-&gt;lk);

	/*
	 * BUG: what if the epoch changes right here?
	 * In the worst case, we could end up in some weird
	 * lock loop, because the block we want no longer exists,
	 * and instead we're trying to lock a block we have no
	 * business grabbing.
	 *
	 * For now, I'm not going to worry about it.
	 */

if(0)fprint(2, "%s: cacheLocal: %d: %d %x\n", argv0, getpid(), b-&gt;part, b-&gt;addr);
	bwatchLock(b);
	vtLock(b-&gt;lk);
	b-&gt;nlock = 1;

	if(part == PartData &amp;&amp; b-&gt;iostate == BioEmpty){
		if(!readLabel(c, &amp;b-&gt;l, addr)){
			blockPut(b);
			return nil;
		}
		blockSetIOState(b, BioLabel);
	}
	if(epoch &amp;&amp; b-&gt;l.epoch != epoch){
		blockPut(b);
fprint(2, "%s: _cacheLocal want epoch %ud got %ud\n", argv0, epoch, b-&gt;l.epoch);
		vtSetError(ELabelMismatch);
		return nil;
	}

	b-&gt;pc = getcallerpc(&amp;c);
	for(;;){
		switch(b-&gt;iostate){
		default:
			abort();
		case BioLabel:
			if(mode == OOverWrite)
				/*
				 * leave iostate as BioLabel because data
				 * hasn't been read.
				 */
				return b;
			/* fall through */
		case BioEmpty:
			diskRead(c-&gt;disk, b);
			vtSleep(b-&gt;ioready);
			break;
		case BioClean:
		case BioDirty:
			return b;
		case BioReading:
		case BioWriting:
			vtSleep(b-&gt;ioready);
			break;
		case BioReadError:
			blockSetIOState(b, BioEmpty);
			blockPut(b);
			vtSetError("error reading block 0x%.8ux", addr);
			return nil;
		}
	}
	/* NOT REACHED */
}

Block *
cacheLocal(Cache *c, int part, u32int addr, int mode)
{
	return _cacheLocal(c, part, addr, mode, 0);
}

/*
 * fetch a local (on-disk) block from the memory cache.
 * if it's not there, load it, bumping some other block.
 * check tag and type.
 */
Block *
cacheLocalData(Cache *c, u32int addr, int type, u32int tag, int mode, u32int epoch)
{
	Block *b;

	b = _cacheLocal(c, PartData, addr, mode, epoch);
	if(b == nil)
		return nil;
	if(b-&gt;l.type != type || b-&gt;l.tag != tag){
		fprint(2, "%s: cacheLocalData: addr=%d type got %d exp %d: tag got %ux exp %ux\n",
			argv0, addr, b-&gt;l.type, type, b-&gt;l.tag, tag);
		vtSetError(ELabelMismatch);
		blockPut(b);
		return nil;
	}
	b-&gt;pc = getcallerpc(&amp;c);
	return b;
}

/*
 * fetch a global (Venti) block from the memory cache.
 * if it's not there, load it, bumping some other block.
 * check tag and type if it's really a local block in disguise.
 */
Block *
cacheGlobal(Cache *c, uchar score[VtScoreSize], int type, u32int tag, int mode)
{
	int n;
	Block *b;
	ulong h;
	u32int addr;

	addr = globalToLocal(score);
	if(addr != NilBlock){
		b = cacheLocalData(c, addr, type, tag, mode, 0);
		if(b)
			b-&gt;pc = getcallerpc(&amp;c);
		return b;
	}

	h = (u32int)(score[0]|(score[1]&lt;&lt;8)|(score[2]&lt;&lt;16)|(score[3]&lt;&lt;24)) % c-&gt;hashSize;

	/*
	 * look for the block in the cache
	 */
	vtLock(c-&gt;lk);
	for(b = c-&gt;heads[h]; b != nil; b = b-&gt;next){
		if(b-&gt;part != PartVenti || memcmp(b-&gt;score, score, VtScoreSize) != 0 || b-&gt;l.type != type)
			continue;
		heapDel(b);
		b-&gt;ref++;
		break;
	}

	if(b == nil){
if(0)fprint(2, "%s: cacheGlobal %V %d\n", argv0, score, type);

		b = cacheBumpBlock(c);

		b-&gt;part = PartVenti;
		b-&gt;addr = NilBlock;
		b-&gt;l.type = type;
		memmove(b-&gt;score, score, VtScoreSize);

		/* chain onto correct hash */
		b-&gt;next = c-&gt;heads[h];
		c-&gt;heads[h] = b;
		if(b-&gt;next != nil)
			b-&gt;next-&gt;prev = &amp;b-&gt;next;
		b-&gt;prev = &amp;c-&gt;heads[h];
	}
	vtUnlock(c-&gt;lk);

	bwatchLock(b);
	vtLock(b-&gt;lk);
	b-&gt;nlock = 1;
	b-&gt;pc = getcallerpc(&amp;c);

	switch(b-&gt;iostate){
	default:
		abort();
	case BioEmpty:
		n = vtRead(c-&gt;z, score, vtType[type], b-&gt;data, c-&gt;size);
		if(n &lt; 0 || !vtSha1Check(score, b-&gt;data, n)){
			blockSetIOState(b, BioVentiError);
			blockPut(b);
			vtSetError(
			"venti error reading block %V or wrong score: %r",
				score);
			return nil;
		}
		vtZeroExtend(vtType[type], b-&gt;data, n, c-&gt;size);
		blockSetIOState(b, BioClean);
		return b;
	case BioClean:
		return b;
	case BioVentiError:
		blockPut(b);
		vtSetError("venti i/o error or wrong score, block %V", score);
		return nil;
	case BioReadError:
		blockPut(b);
		vtSetError("error reading block %V", b-&gt;score);
		return nil;
	}
	/* NOT REACHED */
}

/*
 * allocate a new on-disk block and load it into the memory cache.
 * BUG: if the disk is full, should we flush some of it to Venti?
 */
static u32int lastAlloc;

Block *
cacheAllocBlock(Cache *c, int type, u32int tag, u32int epoch, u32int epochLow)
{
	FreeList *fl;
	u32int addr;
	Block *b;
	int n, nwrap;
	Label lab;

	n = c-&gt;size / LabelSize;
	fl = c-&gt;fl;

	vtLock(fl-&gt;lk);
	addr = fl-&gt;last;
	b = cacheLocal(c, PartLabel, addr/n, OReadOnly);
	if(b == nil){
		fprint(2, "%s: cacheAllocBlock: xxx %R\n", argv0);
		vtUnlock(fl-&gt;lk);
		return nil;
	}
	nwrap = 0;
	for(;;){
		if(++addr &gt;= fl-&gt;end){
			addr = 0;
			if(++nwrap &gt;= 2){
				blockPut(b);
				vtSetError("disk is full");
				/*
				 * try to avoid a continuous spew of console
				 * messages.
				 */
				if (fl-&gt;last != 0)
					fprint(2, "%s: cacheAllocBlock: xxx1 %R\n",
						argv0);
				fl-&gt;last = 0;
				vtUnlock(fl-&gt;lk);
				return nil;
			}
		}
		if(addr%n == 0){
			blockPut(b);
			b = cacheLocal(c, PartLabel, addr/n, OReadOnly);
			if(b == nil){
				fl-&gt;last = addr;
				fprint(2, "%s: cacheAllocBlock: xxx2 %R\n", argv0);
				vtUnlock(fl-&gt;lk);
				return nil;
			}
		}
		if(!labelUnpack(&amp;lab, b-&gt;data, addr%n))
			continue;
		if(lab.state == BsFree)
			goto Found;
		if(lab.state&amp;BsClosed)
		if(lab.epochClose &lt;= epochLow || lab.epoch==lab.epochClose)
			goto Found;
	}
Found:
	blockPut(b);
	b = cacheLocal(c, PartData, addr, OOverWrite);
	if(b == nil){
		fprint(2, "%s: cacheAllocBlock: xxx3 %R\n", argv0);
		return nil;
	}
assert(b-&gt;iostate == BioLabel || b-&gt;iostate == BioClean);
	fl-&gt;last = addr;
	lab.type = type;
	lab.tag = tag;
	lab.state = BsAlloc;
	lab.epoch = epoch;
	lab.epochClose = ~(u32int)0;
	if(!blockSetLabel(b, &amp;lab, 1)){
		fprint(2, "%s: cacheAllocBlock: xxx4 %R\n", argv0);
		blockPut(b);
		return nil;
	}
	vtZeroExtend(vtType[type], b-&gt;data, 0, c-&gt;size);
if(0)diskWrite(c-&gt;disk, b);

if(0)fprint(2, "%s: fsAlloc %ud type=%d tag = %ux\n", argv0, addr, type, tag);
	lastAlloc = addr;
	fl-&gt;nused++;
	vtUnlock(fl-&gt;lk);
	b-&gt;pc = getcallerpc(&amp;c);
	return b;
}

int
cacheDirty(Cache *c)
{
	return c-&gt;ndirty;
}

void
cacheCountUsed(Cache *c, u32int epochLow, u32int *used, u32int *total, u32int *bsize)
{
	int n;
	u32int addr, nused;
	Block *b;
	Label lab;
	FreeList *fl;

	fl = c-&gt;fl;
	n = c-&gt;size / LabelSize;
	*bsize = c-&gt;size;
	vtLock(fl-&gt;lk);
	if(fl-&gt;epochLow == epochLow){
		*used = fl-&gt;nused;
		*total = fl-&gt;end;
		vtUnlock(fl-&gt;lk);
		return;
	}
	b = nil;
	nused = 0;
	for(addr=0; addr&lt;fl-&gt;end; addr++){
		if(addr%n == 0){
			blockPut(b);
			b = cacheLocal(c, PartLabel, addr/n, OReadOnly);
			if(b == nil){
				fprint(2, "%s: flCountUsed: loading %ux: %R\n",
					argv0, addr/n);
				break;
			}
		}
		if(!labelUnpack(&amp;lab, b-&gt;data, addr%n))
			continue;
		if(lab.state == BsFree)
			continue;
		if(lab.state&amp;BsClosed)
		if(lab.epochClose &lt;= epochLow || lab.epoch==lab.epochClose)
			continue;
		nused++;
	}
	blockPut(b);
	if(addr == fl-&gt;end){
		fl-&gt;nused = nused;
		fl-&gt;epochLow = epochLow;
	}
	*used = nused;
	*total = fl-&gt;end;
	vtUnlock(fl-&gt;lk);
	return;
}

static FreeList *
flAlloc(u32int end)
{
	FreeList *fl;

	fl = vtMemAllocZ(sizeof(*fl));
	fl-&gt;lk = vtLockAlloc();
	fl-&gt;last = 0;
	fl-&gt;end = end;
	return fl;
}

static void
flFree(FreeList *fl)
{
	vtLockFree(fl-&gt;lk);
	vtMemFree(fl);
}

u32int
cacheLocalSize(Cache *c, int part)
{
	return diskSize(c-&gt;disk, part);
}

/*
 * The thread that has locked b may refer to it by
 * multiple names.  Nlock counts the number of
 * references the locking thread holds.  It will call
 * blockPut once per reference.
 */
void
blockDupLock(Block *b)
{
	assert(b-&gt;nlock &gt; 0);
	b-&gt;nlock++;
}

/*
 * we're done with the block.
 * unlock it.  can't use it after calling this.
 */
void
blockPut(Block* b)
{
	Cache *c;

	if(b == nil)
		return;

if(0)fprint(2, "%s: blockPut: %d: %d %x %d %s\n", argv0, getpid(), b-&gt;part, b-&gt;addr, c-&gt;nheap, bioStr(b-&gt;iostate));

	if(b-&gt;iostate == BioDirty)
		bwatchDependency(b);

	if(--b-&gt;nlock &gt; 0)
		return;

	/*
	 * b-&gt;nlock should probably stay at zero while
	 * the block is unlocked, but diskThread and vtSleep
	 * conspire to assume that they can just vtLock(b-&gt;lk); blockPut(b),
	 * so we have to keep b-&gt;nlock set to 1 even
	 * when the block is unlocked.
	 */
	assert(b-&gt;nlock == 0);
	b-&gt;nlock = 1;
//	b-&gt;pc = 0;

	bwatchUnlock(b);
	vtUnlock(b-&gt;lk);
	c = b-&gt;c;
	vtLock(c-&gt;lk);

	if(--b-&gt;ref &gt; 0){
		vtUnlock(c-&gt;lk);
		return;
	}

	assert(b-&gt;ref == 0);
	switch(b-&gt;iostate){
	default:
		b-&gt;used = c-&gt;now++;
		heapIns(b);
		break;
	case BioEmpty:
	case BioLabel:
		if(c-&gt;nheap == 0)
			b-&gt;used = c-&gt;now++;
		else
			b-&gt;used = c-&gt;heap[0]-&gt;used;
		heapIns(b);
		break;
	case BioDirty:
		break;
	}
	vtUnlock(c-&gt;lk);
}

/*
 * set the label associated with a block.
 */
Block*
_blockSetLabel(Block *b, Label *l)
{
	int lpb;
	Block *bb;
	u32int a;
	Cache *c;

	c = b-&gt;c;

	assert(b-&gt;part == PartData);
	assert(b-&gt;iostate == BioLabel || b-&gt;iostate == BioClean || b-&gt;iostate == BioDirty);
	lpb = c-&gt;size / LabelSize;
	a = b-&gt;addr / lpb;
	bb = cacheLocal(c, PartLabel, a, OReadWrite);
	if(bb == nil){
		blockPut(b);
		return nil;
	}
	b-&gt;l = *l;
	labelPack(l, bb-&gt;data, b-&gt;addr%lpb);
	blockDirty(bb);
	return bb;
}

int
blockSetLabel(Block *b, Label *l, int allocating)
{
	Block *lb;
	Label oldl;

	oldl = b-&gt;l;
	lb = _blockSetLabel(b, l);
	if(lb == nil)
		return 0;

	/*
	 * If we're allocating the block, make sure the label (bl)
	 * goes to disk before the data block (b) itself.  This is to help
	 * the blocks that in turn depend on b.
	 *
	 * Suppose bx depends on (must be written out after) b.
	 * Once we write b we'll think it's safe to write bx.
	 * Bx can't get at b unless it has a valid label, though.
	 *
	 * Allocation is the only case in which having a current label
	 * is vital because:
	 *
	 *	- l.type is set at allocation and never changes.
	 *	- l.tag is set at allocation and never changes.
	 *	- l.state is not checked when we load blocks.
	 *	- the archiver cares deeply about l.state being
	 *		BaActive vs. BaCopied, but that's handled
	 *		by direct calls to _blockSetLabel.
	 */

	if(allocating)
		blockDependency(b, lb, -1, nil, nil);
	blockPut(lb);
	return 1;
}

/*
 * Record that bb must be written out before b.
 * If index is given, we're about to overwrite the score/e
 * at that index in the block.  Save the old value so we
 * can write a safer ``old'' version of the block if pressed.
 */
void
blockDependency(Block *b, Block *bb, int index, uchar *score, Entry *e)
{
	BList *p;

	if(bb-&gt;iostate == BioClean)
		return;

	/*
	 * Dependencies for blocks containing Entry structures
	 * or scores must always be explained.  The problem with
	 * only explaining some of them is this.  Suppose we have two
	 * dependencies for the same field, the first explained
	 * and the second not.  We try to write the block when the first
	 * dependency is not written but the second is.  We will roll back
	 * the first change even though the second trumps it.
	 */
	if(index == -1 &amp;&amp; bb-&gt;part == PartData)
		assert(b-&gt;l.type == BtData);

	if(bb-&gt;iostate != BioDirty){
		fprint(2, "%s: %d:%x:%d iostate is %d in blockDependency\n",
			argv0, bb-&gt;part, bb-&gt;addr, bb-&gt;l.type, bb-&gt;iostate);
		abort();
	}

	p = blistAlloc(bb);
	if(p == nil)
		return;

	assert(bb-&gt;iostate == BioDirty);
if(0)fprint(2, "%s: %d:%x:%d depends on %d:%x:%d\n", argv0, b-&gt;part, b-&gt;addr, b-&gt;l.type, bb-&gt;part, bb-&gt;addr, bb-&gt;l.type);

	p-&gt;part = bb-&gt;part;
	p-&gt;addr = bb-&gt;addr;
	p-&gt;type = bb-&gt;l.type;
	p-&gt;vers = bb-&gt;vers;
	p-&gt;index = index;
	if(p-&gt;index &gt;= 0){
		/*
		 * This test would just be b-&gt;l.type==BtDir except
		 * we need to exclude the super block.
		 */
		if(b-&gt;l.type == BtDir &amp;&amp; b-&gt;part == PartData)
			entryPack(e, p-&gt;old.entry, 0);
		else
			memmove(p-&gt;old.score, score, VtScoreSize);
	}
	p-&gt;next = b-&gt;prior;
	b-&gt;prior = p;
}

/*
 * Mark an in-memory block as dirty.  If there are too many
 * dirty blocks, start writing some out to disk. 
 * 
 * If there were way too many dirty blocks, we used to
 * try to do some flushing ourselves, but it's just too dangerous -- 
 * it implies that the callers cannot have any of our priors locked,
 * but this is hard to avoid in some cases.
 */
int
blockDirty(Block *b)
{
	Cache *c;

	c = b-&gt;c;

	assert(b-&gt;part != PartVenti);

	if(b-&gt;iostate == BioDirty)
		return 1;
	assert(b-&gt;iostate == BioClean || b-&gt;iostate == BioLabel);

	vtLock(c-&gt;lk);
	b-&gt;iostate = BioDirty;
	c-&gt;ndirty++;
	if(c-&gt;ndirty &gt; (c-&gt;maxdirty&gt;&gt;1))
		vtWakeup(c-&gt;flush);
	vtUnlock(c-&gt;lk);

	return 1;
}

/*
 * We've decided to write out b.  Maybe b has some pointers to blocks
 * that haven't yet been written to disk.  If so, construct a slightly out-of-date
 * copy of b that is safe to write out.  (diskThread will make sure the block
 * remains marked as dirty.)
 */
uchar *
blockRollback(Block *b, uchar *buf)
{
	u32int addr;
	BList *p;
	Super super;

	/* easy case */
	if(b-&gt;prior == nil)
		return b-&gt;data;

	memmove(buf, b-&gt;data, b-&gt;c-&gt;size);
	for(p=b-&gt;prior; p; p=p-&gt;next){
		/*
		 * we know p-&gt;index &gt;= 0 because blockWrite has vetted this block for us.
		 */
		assert(p-&gt;index &gt;= 0);
		assert(b-&gt;part == PartSuper || (b-&gt;part == PartData &amp;&amp; b-&gt;l.type != BtData));
		if(b-&gt;part == PartSuper){
			assert(p-&gt;index == 0);
			superUnpack(&amp;super, buf);
			addr = globalToLocal(p-&gt;old.score);
			if(addr == NilBlock){
				fprint(2, "%s: rolling back super block: "
					"bad replacement addr %V\n",
					argv0, p-&gt;old.score);
				abort();
			}
			super.active = addr;
			superPack(&amp;super, buf);
			continue;
		}
		if(b-&gt;l.type == BtDir)
			memmove(buf+p-&gt;index*VtEntrySize, p-&gt;old.entry, VtEntrySize);
		else
			memmove(buf+p-&gt;index*VtScoreSize, p-&gt;old.score, VtScoreSize);
	}
	return buf;
}

/*
 * Try to write block b.
 * If b depends on other blocks:
 *
 *	If the block has been written out, remove the dependency.
 *	If the dependency is replaced by a more recent dependency,
 *		throw it out.
 *	If we know how to write out an old version of b that doesn't
 *		depend on it, do that.
 *
 *	Otherwise, bail.
 */
int
blockWrite(Block *b, int waitlock)
{
	uchar *dmap;
	Cache *c;
	BList *p, **pp;
	Block *bb;
	int lockfail;

	c = b-&gt;c;

	if(b-&gt;iostate != BioDirty)
		return 1;

	dmap = b-&gt;dmap;
	memset(dmap, 0, c-&gt;ndmap);
	pp = &amp;b-&gt;prior;
	for(p=*pp; p; p=*pp){
		if(p-&gt;index &gt;= 0){
			/* more recent dependency has succeeded; this one can go */
			if(dmap[p-&gt;index/8] &amp; (1&lt;&lt;(p-&gt;index%8)))
				goto ignblock;
		}

		lockfail = 0;
		bb = _cacheLocalLookup(c, p-&gt;part, p-&gt;addr, p-&gt;vers, waitlock,
			&amp;lockfail);
		if(bb == nil){
			if(lockfail)
				return 0;
			/* block not in cache =&gt; was written already */
			dmap[p-&gt;index/8] |= 1&lt;&lt;(p-&gt;index%8);
			goto ignblock;
		}

		/*
		 * same version of block is still in cache.
		 *
		 * the assertion is true because the block still has version p-&gt;vers,
		 * which means it hasn't been written out since we last saw it.
		 */
		if(bb-&gt;iostate != BioDirty){
			fprint(2, "%s: %d:%x:%d iostate is %d in blockWrite\n",
				argv0, bb-&gt;part, bb-&gt;addr, bb-&gt;l.type, bb-&gt;iostate);
			/* probably BioWriting if it happens? */
			if(bb-&gt;iostate == BioClean)
				goto ignblock;
		}

		blockPut(bb);

		if(p-&gt;index &lt; 0){
			/*
			 * We don't know how to temporarily undo
			 * b's dependency on bb, so just don't write b yet.
			 */
			if(0) fprint(2, "%s: blockWrite skipping %d %x %d %d; need to write %d %x %d\n",
				argv0, b-&gt;part, b-&gt;addr, b-&gt;vers, b-&gt;l.type, p-&gt;part, p-&gt;addr, bb-&gt;vers);
			return 0;
		}
		/* keep walking down the list */
		pp = &amp;p-&gt;next;
		continue;

ignblock:
		*pp = p-&gt;next;
		blistFree(c, p);
		continue;
	}

	/*
	 * DiskWrite must never be called with a double-locked block.
	 * This call to diskWrite is okay because blockWrite is only called
	 * from the cache flush thread, which never double-locks a block.
	 */
	diskWrite(c-&gt;disk, b);
	return 1;
}

/*
 * Change the I/O state of block b.
 * Just an assignment except for magic in
 * switch statement (read comments there).
 */
void
blockSetIOState(Block *b, int iostate)
{
	int dowakeup;
	Cache *c;
	BList *p, *q;

if(0) fprint(2, "%s: iostate part=%d addr=%x %s-&gt;%s\n", argv0, b-&gt;part, b-&gt;addr, bioStr(b-&gt;iostate), bioStr(iostate));

	c = b-&gt;c;

	dowakeup = 0;
	switch(iostate){
	default:
		abort();
	case BioEmpty:
		assert(!b-&gt;uhead);
		break;
	case BioLabel:
		assert(!b-&gt;uhead);
		break;
	case BioClean:
		bwatchDependency(b);
		/*
		 * If b-&gt;prior is set, it means a write just finished.
		 * The prior list isn't needed anymore.
		 */
		for(p=b-&gt;prior; p; p=q){
			q = p-&gt;next;
			blistFree(c, p);
		}
		b-&gt;prior = nil;
		/*
		 * Freeing a block or just finished a write.
		 * Move the blocks from the per-block unlink
		 * queue to the cache unlink queue.
		 */
		if(b-&gt;iostate == BioDirty || b-&gt;iostate == BioWriting){
			vtLock(c-&gt;lk);
			c-&gt;ndirty--;
			b-&gt;iostate = iostate;	/* change here to keep in sync with ndirty */
			b-&gt;vers = c-&gt;vers++;
			if(b-&gt;uhead){
				/* add unlink blocks to unlink queue */
				if(c-&gt;uhead == nil){
					c-&gt;uhead = b-&gt;uhead;
					vtWakeup(c-&gt;unlink);
				}else
					c-&gt;utail-&gt;next = b-&gt;uhead;
				c-&gt;utail = b-&gt;utail;
				b-&gt;uhead = nil;
			}
			vtUnlock(c-&gt;lk);
		}
		assert(!b-&gt;uhead);
		dowakeup = 1;
		break;
	case BioDirty:
		/*
		 * Wrote out an old version of the block (see blockRollback).
		 * Bump a version count, leave it dirty.
		 */
		if(b-&gt;iostate == BioWriting){
			vtLock(c-&gt;lk);
			b-&gt;vers = c-&gt;vers++;
			vtUnlock(c-&gt;lk);
			dowakeup = 1;
		}
		break;
	case BioReading:
	case BioWriting:
		/*
		 * Adding block to disk queue.  Bump reference count.
		 * diskThread decs the count later by calling blockPut.
		 * This is here because we need to lock c-&gt;lk to
		 * manipulate the ref count.
		 */
		vtLock(c-&gt;lk);
		b-&gt;ref++;
		vtUnlock(c-&gt;lk);
		break;
	case BioReadError:
	case BioVentiError:
		/*
		 * Oops.
		 */
		dowakeup = 1;
		break;
	}
	b-&gt;iostate = iostate;
	/*
	 * Now that the state has changed, we can wake the waiters.
	 */
	if(dowakeup)
		vtWakeupAll(b-&gt;ioready);
}

/*
 * The active file system is a tree of blocks. 
 * When we add snapshots to the mix, the entire file system
 * becomes a dag and thus requires a bit more care.
 * 
 * The life of the file system is divided into epochs.  A snapshot
 * ends one epoch and begins the next.  Each file system block
 * is marked with the epoch in which it was created (b.epoch).
 * When the block is unlinked from the file system (closed), it is marked
 * with the epoch in which it was removed (b.epochClose).  
 * Once we have discarded or archived all snapshots up to 
 * b.epochClose, we can reclaim the block.
 *
 * If a block was created in a past epoch but is not yet closed,
 * it is treated as copy-on-write.  Of course, in order to insert the
 * new pointer into the tree, the parent must be made writable,
 * and so on up the tree.  The recursion stops because the root
 * block is always writable.
 *
 * If blocks are never closed, they will never be reused, and
 * we will run out of disk space.  But marking a block as closed
 * requires some care about dependencies and write orderings.
 *
 * (1) If a block p points at a copy-on-write block b and we
 * copy b to create bb, then p must be written out after bb and
 * lbb (bb's label block).
 *
 * (2) We have to mark b as closed, but only after we switch
 * the pointer, so lb must be written out after p.  In fact, we 
 * can't even update the in-memory copy, or the cache might
 * mistakenly give out b for reuse before p gets written.
 *
 * CacheAllocBlock's call to blockSetLabel records a "bb after lbb" dependency.
 * The caller is expected to record a "p after bb" dependency
 * to finish (1), and also expected to call blockRemoveLink
 * to arrange for (2) to happen once p is written.
 *
 * Until (2) happens, some pieces of the code (e.g., the archiver)
 * still need to know whether a block has been copied, so we 
 * set the BsCopied bit in the label and force that to disk *before*
 * the copy gets written out.
 */
Block*
blockCopy(Block *b, u32int tag, u32int ehi, u32int elo)
{
	Block *bb, *lb;
	Label l;

	if((b-&gt;l.state&amp;BsClosed) || b-&gt;l.epoch &gt;= ehi)
		fprint(2, "%s: blockCopy %#ux %L but fs is [%ud,%ud]\n",
			argv0, b-&gt;addr, &amp;b-&gt;l, elo, ehi);

	bb = cacheAllocBlock(b-&gt;c, b-&gt;l.type, tag, ehi, elo);
	if(bb == nil){
		blockPut(b);
		return nil;
	}

	/*
	 * Update label so we know the block has been copied.
	 * (It will be marked closed once it has been unlinked from
	 * the tree.)  This must follow cacheAllocBlock since we
	 * can't be holding onto lb when we call cacheAllocBlock.
	 */
	if((b-&gt;l.state&amp;BsCopied)==0)
	if(b-&gt;part == PartData){	/* not the superblock */
		l = b-&gt;l;
		l.state |= BsCopied;
		lb = _blockSetLabel(b, &amp;l);
		if(lb == nil){
			/* can't set label =&gt; can't copy block */
			blockPut(b);
			l.type = BtMax;
			l.state = BsFree;
			l.epoch = 0;
			l.epochClose = 0;
			l.tag = 0;
			blockSetLabel(bb, &amp;l, 0);
			blockPut(bb);
			return nil;
		}
		blockDependency(bb, lb, -1, nil, nil);
		blockPut(lb);
	}

	memmove(bb-&gt;data, b-&gt;data, b-&gt;c-&gt;size);
	blockDirty(bb);
	blockPut(b);
	return bb;
}

/*
 * Block b once pointed at the block bb at addr/type/tag, but no longer does.
 * If recurse is set, we are unlinking all of bb's children as well.
 *
 * We can't reclaim bb (or its kids) until the block b gets written to disk.  We add
 * the relevant information to b's list of unlinked blocks.  Once b is written,
 * the list will be queued for processing.
 *
 * If b depends on bb, it doesn't anymore, so we remove bb from the prior list.
 */
void
blockRemoveLink(Block *b, u32int addr, int type, u32int tag, int recurse)
{
	BList *p, **pp, bl;
	
	/* remove bb from prior list */
	for(pp=&amp;b-&gt;prior; (p=*pp)!=nil; ){
		if(p-&gt;part == PartData &amp;&amp; p-&gt;addr == addr){
			*pp = p-&gt;next;
			blistFree(b-&gt;c, p);
		}else
			pp = &amp;p-&gt;next;
	}

	bl.part = PartData;
	bl.addr = addr;
	bl.type = type;
	bl.tag = tag;
	if(b-&gt;l.epoch == 0)
		assert(b-&gt;part == PartSuper);
	bl.epoch = b-&gt;l.epoch;
	bl.next = nil;
	bl.recurse = recurse;

	if(b-&gt;part == PartSuper &amp;&amp; b-&gt;iostate == BioClean)
		p = nil;
	else
		p = blistAlloc(b);
	if(p == nil){
		/*
		 * b has already been written to disk.
		 */
		doRemoveLink(b-&gt;c, &amp;bl);
		return;
	}

	/* Uhead is only processed when the block goes from Dirty -&gt; Clean */
	assert(b-&gt;iostate == BioDirty);

	*p = bl;
	if(b-&gt;uhead == nil)
		b-&gt;uhead = p;
	else
		b-&gt;utail-&gt;next = p;
	b-&gt;utail = p;
}

/* 
 * Process removal of a single block and perhaps its children.
 */
static void
doRemoveLink(Cache *c, BList *p)
{
	int i, n, recurse;
	u32int a;
	Block *b;
	Label l;
	BList bl;

	recurse = (p-&gt;recurse &amp;&amp; p-&gt;type != BtData &amp;&amp; p-&gt;type != BtDir);

	/*
	 * We're not really going to overwrite b, but if we're not
	 * going to look at its contents, there is no point in reading
	 * them from the disk.
	 */
	b = cacheLocalData(c, p-&gt;addr, p-&gt;type, p-&gt;tag, recurse ? OReadOnly : OOverWrite, 0);
	if(b == nil)
		return;

	/*
	 * When we're unlinking from the superblock, close with the next epoch.
	 */
	if(p-&gt;epoch == 0)
		p-&gt;epoch = b-&gt;l.epoch+1;

	/* sanity check */
	if(b-&gt;l.epoch &gt; p-&gt;epoch){
		fprint(2, "%s: doRemoveLink: strange epoch %ud &gt; %ud\n",
			argv0, b-&gt;l.epoch, p-&gt;epoch);
		blockPut(b);
		return;
	}

	if(recurse){
		n = c-&gt;size / VtScoreSize;
		for(i=0; i&lt;n; i++){
			a = globalToLocal(b-&gt;data + i*VtScoreSize);
			if(a == NilBlock || !readLabel(c, &amp;l, a))
				continue;
			if(l.state&amp;BsClosed)
				continue;
			/*
			 * If stack space becomes an issue...
			p-&gt;addr = a;
			p-&gt;type = l.type;
			p-&gt;tag = l.tag;
			doRemoveLink(c, p);
			 */

			bl.part = PartData;
			bl.addr = a;
			bl.type = l.type;
			bl.tag = l.tag;
			bl.epoch = p-&gt;epoch;
			bl.next = nil;
			bl.recurse = 1;
			/* give up the block lock - share with others */
			blockPut(b);
			doRemoveLink(c, &amp;bl);
			b = cacheLocalData(c, p-&gt;addr, p-&gt;type, p-&gt;tag, OReadOnly, 0);
			if(b == nil){
				fprint(2, "%s: warning: lost block in doRemoveLink\n",
					argv0);
				return;
			}
		}
	}

	l = b-&gt;l;
	l.state |= BsClosed;
	l.epochClose = p-&gt;epoch;
	if(l.epochClose == l.epoch){
		vtLock(c-&gt;fl-&gt;lk);
		if(l.epoch == c-&gt;fl-&gt;epochLow)
			c-&gt;fl-&gt;nused--;
		blockSetLabel(b, &amp;l, 0);
		vtUnlock(c-&gt;fl-&gt;lk);
	}else
		blockSetLabel(b, &amp;l, 0);
	blockPut(b);
}

/*
 * Allocate a BList so that we can record a dependency
 * or queue a removal related to block b.
 * If we can't find a BList, we write out b and return nil.
 */
static BList *
blistAlloc(Block *b)
{
	Cache *c;
	BList *p;

	if(b-&gt;iostate != BioDirty){
		/*
		 * should not happen anymore -
	 	 * blockDirty used to flush but no longer does.
		 */
		assert(b-&gt;iostate == BioClean);
		fprint(2, "%s: blistAlloc: called on clean block\n", argv0);
		return nil;
	}

	c = b-&gt;c;
	vtLock(c-&gt;lk);
	if(c-&gt;blfree == nil){
		/*
		 * No free BLists.  What are our options?
		 */
	
		/* Block has no priors? Just write it. */
		if(b-&gt;prior == nil){
			vtUnlock(c-&gt;lk);
			diskWriteAndWait(c-&gt;disk, b);
			return nil;
		}

		/*
		 * Wake the flush thread, which will hopefully free up
		 * some BLists for us.  We used to flush a block from
		 * our own prior list and reclaim that BList, but this is
		 * a no-no: some of the blocks on our prior list may
		 * be locked by our caller.  Or maybe their label blocks
		 * are locked by our caller.  In any event, it's too hard
		 * to make sure we can do I/O for ourselves.  Instead,
		 * we assume the flush thread will find something.
		 * (The flush thread never blocks waiting for a block,
		 * so it can't deadlock like we can.)
		 */
		while(c-&gt;blfree == nil){
			vtWakeup(c-&gt;flush);
			vtSleep(c-&gt;blrend);
			if(c-&gt;blfree == nil)
				fprint(2, "%s: flushing for blists\n", argv0);
		}
	}

	p = c-&gt;blfree;
	c-&gt;blfree = p-&gt;next;
	vtUnlock(c-&gt;lk);
	return p;
}

static void
blistFree(Cache *c, BList *bl)
{
	vtLock(c-&gt;lk);
	bl-&gt;next = c-&gt;blfree;
	c-&gt;blfree = bl;
	vtWakeup(c-&gt;blrend);
	vtUnlock(c-&gt;lk);
}

char*
bsStr(int state)
{
	static char s[100];

	if(state == BsFree)
		return "Free";
	if(state == BsBad)
		return "Bad";

	sprint(s, "%x", state);
	if(!(state&amp;BsAlloc))
		strcat(s, ",Free");	/* should not happen */
	if(state&amp;BsCopied)
		strcat(s, ",Copied");
	if(state&amp;BsVenti)
		strcat(s, ",Venti");
	if(state&amp;BsClosed)
		strcat(s, ",Closed");
	return s;
}

char *
bioStr(int iostate)
{
	switch(iostate){
	default:
		return "Unknown!!";
	case BioEmpty:
		return "Empty";
	case BioLabel:
		return "Label";
	case BioClean:
		return "Clean";
	case BioDirty:
		return "Dirty";
	case BioReading:
		return "Reading";
	case BioWriting:
		return "Writing";
	case BioReadError:
		return "ReadError";
	case BioVentiError:
		return "VentiError";
	case BioMax:
		return "Max";
	}
}

static char *bttab[] = {
	"BtData",
	"BtData+1",
	"BtData+2",
	"BtData+3",
	"BtData+4",
	"BtData+5",
	"BtData+6",
	"BtData+7",
	"BtDir",
	"BtDir+1",
	"BtDir+2",
	"BtDir+3",
	"BtDir+4",
	"BtDir+5",
	"BtDir+6",
	"BtDir+7",
};

char*
btStr(int type)
{
	if(type &lt; nelem(bttab))
		return bttab[type];
	return "unknown";
}

int
labelFmt(Fmt *f)
{
	Label *l;

	l = va_arg(f-&gt;args, Label*);
	return fmtprint(f, "%s,%s,e=%ud,%d,tag=%#ux",
		btStr(l-&gt;type), bsStr(l-&gt;state), l-&gt;epoch, (int)l-&gt;epochClose, l-&gt;tag);
}

int
scoreFmt(Fmt *f)
{
	uchar *v;
	int i;
	u32int addr;

	v = va_arg(f-&gt;args, uchar*);
	if(v == nil){
		fmtprint(f, "*");
	}else if((addr = globalToLocal(v)) != NilBlock)
		fmtprint(f, "0x%.8ux", addr);
	else{
		for(i = 0; i &lt; VtScoreSize; i++)
			fmtprint(f, "%2.2ux", v[i]);
	}

	return 0;
}

static int
upHeap(int i, Block *b)
{
	Block *bb;
	u32int now;
	int p;
	Cache *c;

	c = b-&gt;c;
	now = c-&gt;now;
	for(; i != 0; i = p){
		p = (i - 1) &gt;&gt; 1;
		bb = c-&gt;heap[p];
		if(b-&gt;used - now &gt;= bb-&gt;used - now)
			break;
		c-&gt;heap[i] = bb;
		bb-&gt;heap = i;
	}
	c-&gt;heap[i] = b;
	b-&gt;heap = i;

	return i;
}

static int
downHeap(int i, Block *b)
{
	Block *bb;
	u32int now;
	int k;
	Cache *c;

	c = b-&gt;c;
	now = c-&gt;now;
	for(; ; i = k){
		k = (i &lt;&lt; 1) + 1;
		if(k &gt;= c-&gt;nheap)
			break;
		if(k + 1 &lt; c-&gt;nheap &amp;&amp; c-&gt;heap[k]-&gt;used - now &gt; c-&gt;heap[k + 1]-&gt;used - now)
			k++;
		bb = c-&gt;heap[k];
		if(b-&gt;used - now &lt;= bb-&gt;used - now)
			break;
		c-&gt;heap[i] = bb;
		bb-&gt;heap = i;
	}
	c-&gt;heap[i] = b;
	b-&gt;heap = i;
	return i;
}

/*
 * Delete a block from the heap.
 * Called with c-&gt;lk held.
 */
static void
heapDel(Block *b)
{
	int i, si;
	Cache *c;

	c = b-&gt;c;

	si = b-&gt;heap;
	if(si == BadHeap)
		return;
	b-&gt;heap = BadHeap;
	c-&gt;nheap--;
	if(si == c-&gt;nheap)
		return;
	b = c-&gt;heap[c-&gt;nheap];
	i = upHeap(si, b);
	if(i == si)
		downHeap(i, b);
}

/*
 * Insert a block into the heap.
 * Called with c-&gt;lk held.
 */
static void
heapIns(Block *b)
{
	assert(b-&gt;heap == BadHeap);
	upHeap(b-&gt;c-&gt;nheap++, b);
	vtWakeup(b-&gt;c-&gt;heapwait);
}

/*
 * Get just the label for a block.
 */
int
readLabel(Cache *c, Label *l, u32int addr)
{
	int lpb;
	Block *b;
	u32int a;

	lpb = c-&gt;size / LabelSize;
	a = addr / lpb;
	b = cacheLocal(c, PartLabel, a, OReadOnly);
	if(b == nil){
		blockPut(b);
		return 0;
	}

	if(!labelUnpack(l, b-&gt;data, addr%lpb)){
		blockPut(b);
		return 0;
	}
	blockPut(b);
	return 1;
}

/*
 * Process unlink queue.
 * Called with c-&gt;lk held.
 */
static void
unlinkBody(Cache *c)
{
	BList *p;

	while(c-&gt;uhead != nil){
		p = c-&gt;uhead;
		c-&gt;uhead = p-&gt;next;
		vtUnlock(c-&gt;lk);
		doRemoveLink(c, p);
		vtLock(c-&gt;lk);
		p-&gt;next = c-&gt;blfree;
		c-&gt;blfree = p;
	}
}

/*
 * Occasionally unlink the blocks on the cache unlink queue.
 */
static void
unlinkThread(void *a)
{
	Cache *c = a;

	vtThreadSetName("unlink");

	vtLock(c-&gt;lk);
	for(;;){
		while(c-&gt;uhead == nil &amp;&amp; c-&gt;die == nil)
			vtSleep(c-&gt;unlink);
		if(c-&gt;die != nil)
			break;
		unlinkBody(c);
	}
	c-&gt;ref--;
	vtWakeup(c-&gt;die);
	vtUnlock(c-&gt;lk);
}

static int
baddrCmp(void *a0, void *a1)
{
	BAddr *b0, *b1;
	b0 = a0;
	b1 = a1;

	if(b0-&gt;part &lt; b1-&gt;part)
		return -1;
	if(b0-&gt;part &gt; b1-&gt;part)
		return 1;
	if(b0-&gt;addr &lt; b1-&gt;addr)
		return -1;
	if(b0-&gt;addr &gt; b1-&gt;addr)
		return 1;
	return 0;
}

/*
 * Scan the block list for dirty blocks; add them to the list c-&gt;baddr.
 */
static void
flushFill(Cache *c)
{
	int i, ndirty;
	BAddr *p;
	Block *b;

	vtLock(c-&gt;lk);
	if(c-&gt;ndirty == 0){
		vtUnlock(c-&gt;lk);
		return;
	}

	p = c-&gt;baddr;
	ndirty = 0;
	for(i=0; i&lt;c-&gt;nblocks; i++){
		b = c-&gt;blocks + i;
		if(b-&gt;part == PartError)
			continue;
		if(b-&gt;iostate == BioDirty || b-&gt;iostate == BioWriting)
			ndirty++;
		if(b-&gt;iostate != BioDirty)
			continue;
		p-&gt;part = b-&gt;part;
		p-&gt;addr = b-&gt;addr;
		p-&gt;vers = b-&gt;vers;
		p++;
	}
	if(ndirty != c-&gt;ndirty){
		fprint(2, "%s: ndirty mismatch expected %d found %d\n",
			argv0, c-&gt;ndirty, ndirty);
		c-&gt;ndirty = ndirty;
	}
	vtUnlock(c-&gt;lk);

	c-&gt;bw = p - c-&gt;baddr;
	qsort(c-&gt;baddr, c-&gt;bw, sizeof(BAddr), baddrCmp);
}

/*
 * This is not thread safe, i.e. it can't be called from multiple threads.
 *
 * It's okay how we use it, because it only gets called in
 * the flushThread.  And cacheFree, but only after
 * cacheFree has killed off the flushThread.
 */
static int
cacheFlushBlock(Cache *c)
{
	Block *b;
	BAddr *p;
	int lockfail, nfail;

	nfail = 0;
	for(;;){
		if(c-&gt;br == c-&gt;be){
			if(c-&gt;bw == 0 || c-&gt;bw == c-&gt;be)
				flushFill(c);
			c-&gt;br = 0;
			c-&gt;be = c-&gt;bw;
			c-&gt;bw = 0;
			c-&gt;nflush = 0;
		}

		if(c-&gt;br == c-&gt;be)
			return 0;
		p = c-&gt;baddr + c-&gt;br;
		c-&gt;br++;
		b = _cacheLocalLookup(c, p-&gt;part, p-&gt;addr, p-&gt;vers, Nowaitlock,
			&amp;lockfail);

		if(b &amp;&amp; blockWrite(b, Nowaitlock)){
			c-&gt;nflush++;
			blockPut(b);
			return 1;
		}
		if(b)
			blockPut(b);

		/*
		 * Why didn't we write the block?
		 */

		/* Block already written out */
		if(b == nil &amp;&amp; !lockfail)
			continue;

		/* Failed to acquire lock; sleep if happens a lot. */
		if(lockfail &amp;&amp; ++nfail &gt; 100){
			sleep(500);
			nfail = 0;
		}
		/* Requeue block. */
		if(c-&gt;bw &lt; c-&gt;be)
			c-&gt;baddr[c-&gt;bw++] = *p;
	}
}

/*
 * Occasionally flush dirty blocks from memory to the disk.
 */
static void
flushThread(void *a)
{
	Cache *c = a;
	int i;

	vtThreadSetName("flush");
	vtLock(c-&gt;lk);
	while(c-&gt;die == nil){
		vtSleep(c-&gt;flush);
		vtUnlock(c-&gt;lk);
		for(i=0; i&lt;FlushSize; i++)
			if(!cacheFlushBlock(c)){
				/*
				 * If i==0, could be someone is waking us repeatedly
				 * to flush the cache but there's no work to do.
				 * Pause a little.
				 */
				if(i==0){
					// fprint(2, "%s: flushthread found "
					//	"nothing to flush - %d dirty\n",
					//	argv0, c-&gt;ndirty);
					sleep(250);
				}
				break;
			}
		if(i==0 &amp;&amp; c-&gt;ndirty){
			/*
			 * All the blocks are being written right now -- there's nothing to do.
			 * We might be spinning with cacheFlush though -- he'll just keep
			 * kicking us until c-&gt;ndirty goes down.  Probably we should sleep
			 * on something that the diskThread can kick, but for now we'll
			 * just pause for a little while waiting for disks to finish.
			 */
			sleep(100);
		}
		vtLock(c-&gt;lk);
		vtWakeupAll(c-&gt;flushwait);
	}
	c-&gt;ref--;
	vtWakeup(c-&gt;die);
	vtUnlock(c-&gt;lk);
}

/*
 * Flush the cache.
 */
void
cacheFlush(Cache *c, int wait)
{
	vtLock(c-&gt;lk);
	if(wait){
		while(c-&gt;ndirty){
		//	consPrint("cacheFlush: %d dirty blocks, uhead %p\n",
		//		c-&gt;ndirty, c-&gt;uhead);
			vtWakeup(c-&gt;flush);
			vtSleep(c-&gt;flushwait);
		}
	//	consPrint("cacheFlush: done (uhead %p)\n", c-&gt;ndirty, c-&gt;uhead);
	}else if(c-&gt;ndirty)
		vtWakeup(c-&gt;flush);
	vtUnlock(c-&gt;lk);
}

/*
 * Kick the flushThread every 30 seconds.
 */
static void
cacheSync(void *v)
{
	Cache *c;

	c = v;
	cacheFlush(c, 0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

