<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/check.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/check.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static void	checkDirs(Fsck*);
static void	checkEpochs(Fsck*);
static void	checkLeak(Fsck*);
static void	closenop(Fsck*, Block*, u32int);
static void	clrenop(Fsck*, Block*, int);
static void	clrinop(Fsck*, char*, MetaBlock*, int, Block*);
static void	error(Fsck*, char*, ...);
static int	getBit(uchar*, u32int);
static int	printnop(char*, ...);
static void	setBit(uchar*, u32int);
static int	walkEpoch(Fsck *chk, Block *b, uchar score[VtScoreSize],
			int type, u32int tag, u32int epoch);
static void	warn(Fsck*, char*, ...);

#pragma varargck argpos error 2
#pragma varargck argpos printnop 1
#pragma varargck argpos warn 2

static Fsck*
checkInit(Fsck *chk)
{
	chk-&gt;cache = chk-&gt;fs-&gt;cache;
	chk-&gt;nblocks = cacheLocalSize(chk-&gt;cache, PartData);;
	chk-&gt;bsize = chk-&gt;fs-&gt;blockSize;
	chk-&gt;walkdepth = 0;
	chk-&gt;hint = 0;
	chk-&gt;quantum = chk-&gt;nblocks/100;
	if(chk-&gt;quantum == 0)
		chk-&gt;quantum = 1;
	if(chk-&gt;print == nil)
		chk-&gt;print = printnop;
	if(chk-&gt;clre == nil)
		chk-&gt;clre = clrenop;
	if(chk-&gt;close == nil)
		chk-&gt;close = closenop;
	if(chk-&gt;clri == nil)
		chk-&gt;clri = clrinop;
	return chk;
}

/*
 * BUG: Should merge checkEpochs and checkDirs so that
 * bad blocks are only reported once, and so that errors in checkEpochs
 * can have the affected file names attached, and so that the file system
 * is only read once.
 *
 * Also should summarize the errors instead of printing for every one
 * (e.g., XXX bad or unreachable blocks in /active/usr/rsc/foo).
 */

void
fsCheck(Fsck *chk)
{
	Block *b;
	Super super;

	checkInit(chk);
	b = superGet(chk-&gt;cache, &amp;super);
	if(b == nil){
		chk-&gt;print("could not load super block: %R");
		return;
	}
	blockPut(b);

	chk-&gt;hint = super.active;
	checkEpochs(chk);

	chk-&gt;smap = vtMemAllocZ(chk-&gt;nblocks/8+1);
	checkDirs(chk);
	vtMemFree(chk-&gt;smap);
}

static void checkEpoch(Fsck*, u32int);

/*
 * Walk through all the blocks in the write buffer.
 * Then we can look for ones we missed -- those are leaks.
 */
static void
checkEpochs(Fsck *chk)
{
	u32int e;
	uint nb;

	nb = chk-&gt;nblocks;
	chk-&gt;amap = vtMemAllocZ(nb/8+1);
	chk-&gt;emap = vtMemAllocZ(nb/8+1);
	chk-&gt;xmap = vtMemAllocZ(nb/8+1);
	chk-&gt;errmap = vtMemAllocZ(nb/8+1);

	for(e = chk-&gt;fs-&gt;ehi; e &gt;= chk-&gt;fs-&gt;elo; e--){
		memset(chk-&gt;emap, 0, chk-&gt;nblocks/8+1);
		memset(chk-&gt;xmap, 0, chk-&gt;nblocks/8+1);
		checkEpoch(chk, e);
	}
	checkLeak(chk);
	vtMemFree(chk-&gt;amap);
	vtMemFree(chk-&gt;emap);
	vtMemFree(chk-&gt;xmap);
	vtMemFree(chk-&gt;errmap);
}

static void
checkEpoch(Fsck *chk, u32int epoch)
{
	u32int a;
	Block *b;
	Entry e;
	Label l;

	chk-&gt;print("checking epoch %ud...\n", epoch);

	for(a=0; a&lt;chk-&gt;nblocks; a++){
		if(!readLabel(chk-&gt;cache, &amp;l, (a+chk-&gt;hint)%chk-&gt;nblocks)){
			error(chk, "could not read label for addr 0x%.8#ux", a);
			continue;
		}
		if(l.tag == RootTag &amp;&amp; l.epoch == epoch)
			break;
	}

	if(a == chk-&gt;nblocks){
		chk-&gt;print("could not find root block for epoch %ud", epoch);
		return;
	}

	a = (a+chk-&gt;hint)%chk-&gt;nblocks;
	b = cacheLocalData(chk-&gt;cache, a, BtDir, RootTag, OReadOnly, 0);
	if(b == nil){
		error(chk, "could not read root block 0x%.8#ux: %R", a);
		return;
	}

	/* no one should point at root blocks */
	setBit(chk-&gt;amap, a);
	setBit(chk-&gt;emap, a);
	setBit(chk-&gt;xmap, a);

	/*
	 * First entry is the rest of the file system.
	 * Second entry is link to previous epoch root,
	 * just a convenience to help the search.
	 */
	if(!entryUnpack(&amp;e, b-&gt;data, 0)){
		error(chk, "could not unpack root block 0x%.8#ux: %R", a);
		blockPut(b);
		return;
	}
	walkEpoch(chk, b, e.score, BtDir, e.tag, epoch);
	if(entryUnpack(&amp;e, b-&gt;data, 1))
		chk-&gt;hint = globalToLocal(e.score);
	blockPut(b);
}

/*
 * When b points at bb, need to check:
 *
 * (i) b.e in [bb.e, bb.eClose)
 * (ii) if b.e==bb.e,  then no other b' in e points at bb.
 * (iii) if !(b.state&amp;Copied) and b.e==bb.e then no other b' points at bb.
 * (iv) if b is active then no other active b' points at bb.
 * (v) if b is a past life of b' then only one of b and b' is active
 *	(too hard to check)
 */
static int
walkEpoch(Fsck *chk, Block *b, uchar score[VtScoreSize], int type, u32int tag,
	u32int epoch)
{
	int i, ret;
	u32int addr, ep;
	Block *bb;
	Entry e;

	if(b &amp;&amp; chk-&gt;walkdepth == 0 &amp;&amp; chk-&gt;printblocks)
		chk-&gt;print("%V %d %#.8ux %#.8ux\n", b-&gt;score, b-&gt;l.type,
			b-&gt;l.tag, b-&gt;l.epoch);

	if(!chk-&gt;useventi &amp;&amp; globalToLocal(score) == NilBlock)
		return 1;

	chk-&gt;walkdepth++;

	bb = cacheGlobal(chk-&gt;cache, score, type, tag, OReadOnly);
	if(bb == nil){
		error(chk, "could not load block %V type %d tag %ux: %R",
			score, type, tag);
		chk-&gt;walkdepth--;
		return 0;
	}
	if(chk-&gt;printblocks)
		chk-&gt;print("%*s%V %d %#.8ux %#.8ux\n", chk-&gt;walkdepth*2, "",
			score, type, tag, bb-&gt;l.epoch);

	ret = 0;
	addr = globalToLocal(score);
	if(addr == NilBlock){
		ret = 1;
		goto Exit;
	}

	if(b){
		/* (i) */
		if(b-&gt;l.epoch &lt; bb-&gt;l.epoch || bb-&gt;l.epochClose &lt;= b-&gt;l.epoch){
			error(chk, "walk: block %#ux [%ud, %ud) points at %#ux [%ud, %ud)",
				b-&gt;addr, b-&gt;l.epoch, b-&gt;l.epochClose,
				bb-&gt;addr, bb-&gt;l.epoch, bb-&gt;l.epochClose);
			goto Exit;
		}

		/* (ii) */
		if(b-&gt;l.epoch == epoch &amp;&amp; bb-&gt;l.epoch == epoch){
			if(getBit(chk-&gt;emap, addr)){
				error(chk, "walk: epoch join detected: addr %#ux %L",
					bb-&gt;addr, &amp;bb-&gt;l);
				goto Exit;
			}
			setBit(chk-&gt;emap, addr);
		}

		/* (iii) */
		if(!(b-&gt;l.state&amp;BsCopied) &amp;&amp; b-&gt;l.epoch == bb-&gt;l.epoch){
			if(getBit(chk-&gt;xmap, addr)){
				error(chk, "walk: copy join detected; addr %#ux %L",
					bb-&gt;addr, &amp;bb-&gt;l);
				goto Exit;
			}
			setBit(chk-&gt;xmap, addr);
		}
	}

	/* (iv) */
	if(epoch == chk-&gt;fs-&gt;ehi){
		/*
		 * since epoch==fs-&gt;ehi is first, amap is same as
		 * ``have seen active''
		 */
		if(getBit(chk-&gt;amap, addr)){
			error(chk, "walk: active join detected: addr %#ux %L",
				bb-&gt;addr, &amp;bb-&gt;l);
			goto Exit;
		}
		if(bb-&gt;l.state&amp;BsClosed)
			error(chk, "walk: addr %#ux: block is in active tree but is closed",
				addr);
	}else
		if(!getBit(chk-&gt;amap, addr))
			if(!(bb-&gt;l.state&amp;BsClosed)){
				// error(chk, "walk: addr %#ux: block is not in active tree, not closed (%d)",
				// addr, bb-&gt;l.epochClose);
				chk-&gt;close(chk, bb, epoch+1);
				chk-&gt;nclose++;
			}

	if(getBit(chk-&gt;amap, addr)){
		ret = 1;
		goto Exit;
	}
	setBit(chk-&gt;amap, addr);

	if(chk-&gt;nseen++%chk-&gt;quantum == 0)
		chk-&gt;print("check: visited %d/%d blocks (%.0f%%)\n",
			chk-&gt;nseen, chk-&gt;nblocks, chk-&gt;nseen*100./chk-&gt;nblocks);

	b = nil;		/* make sure no more refs to parent */
	USED(b);

	switch(type){
	default:
		/* pointer block */
		for(i = 0; i &lt; chk-&gt;bsize/VtScoreSize; i++)
			if(!walkEpoch(chk, bb, bb-&gt;data + i*VtScoreSize,
			    type-1, tag, epoch)){
				setBit(chk-&gt;errmap, bb-&gt;addr);
				chk-&gt;clrp(chk, bb, i);
				chk-&gt;nclrp++;
			}
		break;
	case BtData:
		break;
	case BtDir:
		for(i = 0; i &lt; chk-&gt;bsize/VtEntrySize; i++){
			if(!entryUnpack(&amp;e, bb-&gt;data, i)){
				// error(chk, "walk: could not unpack entry: %ux[%d]: %R",
				//	addr, i);
				setBit(chk-&gt;errmap, bb-&gt;addr);
				chk-&gt;clre(chk, bb, i);
				chk-&gt;nclre++;
				continue;
			}
			if(!(e.flags &amp; VtEntryActive))
				continue;
if(0)			fprint(2, "%x[%d] tag=%x snap=%d score=%V\n",
				addr, i, e.tag, e.snap, e.score);
			ep = epoch;
			if(e.snap != 0){
				if(e.snap &gt;= epoch){
					// error(chk, "bad snap in entry: %ux[%d] snap = %ud: epoch = %ud",
					//	addr, i, e.snap, epoch);
					setBit(chk-&gt;errmap, bb-&gt;addr);
					chk-&gt;clre(chk, bb, i);
					chk-&gt;nclre++;
					continue;
				}
				continue;
			}
			if(e.flags &amp; VtEntryLocal){
				if(e.tag &lt; UserTag)
				if(e.tag != RootTag || tag != RootTag || i != 1){
					// error(chk, "bad tag in entry: %ux[%d] tag = %ux",
					//	addr, i, e.tag);
					setBit(chk-&gt;errmap, bb-&gt;addr);
					chk-&gt;clre(chk, bb, i);
					chk-&gt;nclre++;
					continue;
				}
			}else
				if(e.tag != 0){
					// error(chk, "bad tag in entry: %ux[%d] tag = %ux",
					//	addr, i, e.tag);
					setBit(chk-&gt;errmap, bb-&gt;addr);
					chk-&gt;clre(chk, bb, i);
					chk-&gt;nclre++;
					continue;
				}
			if(!walkEpoch(chk, bb, e.score, entryType(&amp;e),
			    e.tag, ep)){
				setBit(chk-&gt;errmap, bb-&gt;addr);
				chk-&gt;clre(chk, bb, i);
				chk-&gt;nclre++;
			}
		}
		break;
	}

	ret = 1;

Exit:
	chk-&gt;walkdepth--;
	blockPut(bb);
	return ret;
}

/*
 * We've just walked the whole write buffer.  Notice blocks that
 * aren't marked available but that we didn't visit.  They are lost.
 */
static void
checkLeak(Fsck *chk)
{
	u32int a, nfree, nlost;
	Block *b;
	Label l;

	nfree = 0;
	nlost = 0;

	for(a = 0; a &lt; chk-&gt;nblocks; a++){
		if(!readLabel(chk-&gt;cache, &amp;l, a)){
			error(chk, "could not read label: addr 0x%ux %d %d: %R",
				a, l.type, l.state);
			continue;
		}
		if(getBit(chk-&gt;amap, a))
			continue;
		if(l.state == BsFree || l.epochClose &lt;= chk-&gt;fs-&gt;elo ||
		    l.epochClose == l.epoch){
			nfree++;
			setBit(chk-&gt;amap, a);
			continue;
		}
		if(l.state&amp;BsClosed)
			continue;
		nlost++;
//		warn(chk, "unreachable block: addr 0x%ux type %d tag 0x%ux "
//			"state %s epoch %ud close %ud", a, l.type, l.tag,
//			bsStr(l.state), l.epoch, l.epochClose);
		b = cacheLocal(chk-&gt;cache, PartData, a, OReadOnly);
		if(b == nil){
			error(chk, "could not read block 0x%#.8ux", a);
			continue;
		}
		chk-&gt;close(chk, b, 0);
		chk-&gt;nclose++;
		setBit(chk-&gt;amap, a);
		blockPut(b);
	}
	chk-&gt;print("fsys blocks: total=%ud used=%ud(%.1f%%) free=%ud(%.1f%%) lost=%ud(%.1f%%)\n",
		chk-&gt;nblocks,
		chk-&gt;nblocks - nfree-nlost,
		100.*(chk-&gt;nblocks - nfree - nlost)/chk-&gt;nblocks,
		nfree, 100.*nfree/chk-&gt;nblocks,
		nlost, 100.*nlost/chk-&gt;nblocks);
}


/*
 * Check that all sources in the tree are accessible.
 */
static Source *
openSource(Fsck *chk, Source *s, char *name, uchar *bm, u32int offset,
	u32int gen, int dir, MetaBlock *mb, int i, Block *b)
{
	Source *r;

	r = nil;
	if(getBit(bm, offset)){
		warn(chk, "multiple references to source: %s -&gt; %d",
			name, offset);
		goto Err;
	}
	setBit(bm, offset);

	r = sourceOpen(s, offset, OReadOnly, 0);
	if(r == nil){
		warn(chk, "could not open source: %s -&gt; %d: %R", name, offset);
		goto Err;
	}

	if(r-&gt;gen != gen){
		warn(chk, "source has been removed: %s -&gt; %d", name, offset);
		goto Err;
	}

	if(r-&gt;dir != dir){
		warn(chk, "dir mismatch: %s -&gt; %d", name, offset);
		goto Err;
	}
	return r;
Err:
	chk-&gt;clri(chk, name, mb, i, b);
	chk-&gt;nclri++;
	if(r)
		sourceClose(r);
	return nil;
}

typedef struct MetaChunk MetaChunk;
struct MetaChunk {
	ushort	offset;
	ushort	size;
	ushort	index;
};

static int
offsetCmp(void *s0, void *s1)
{
	MetaChunk *mc0, *mc1;

	mc0 = s0;
	mc1 = s1;
	if(mc0-&gt;offset &lt; mc1-&gt;offset)
		return -1;
	if(mc0-&gt;offset &gt; mc1-&gt;offset)
		return 1;
	return 0;
}

/*
 * Fsck that MetaBlock has reasonable header, sorted entries,
 */
static int
chkMetaBlock(MetaBlock *mb)
{
	MetaChunk *mc;
	int oo, o, n, i;
	uchar *p;

	mc = vtMemAlloc(mb-&gt;nindex*sizeof(MetaChunk));
	p = mb-&gt;buf + MetaHeaderSize;
	for(i = 0; i &lt; mb-&gt;nindex; i++){
		mc[i].offset = p[0]&lt;&lt;8 | p[1];
		mc[i].size =   p[2]&lt;&lt;8 | p[3];
		mc[i].index = i;
		p += MetaIndexSize;
	}

	qsort(mc, mb-&gt;nindex, sizeof(MetaChunk), offsetCmp);

	/* check block looks ok */
	oo = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;
	o = oo;
	n = 0;
	for(i = 0; i &lt; mb-&gt;nindex; i++){
		o = mc[i].offset;
		n = mc[i].size;
		if(o &lt; oo)
			goto Err;
		oo += n;
	}
	if(o+n &gt; mb-&gt;size || mb-&gt;size - oo != mb-&gt;free)
		goto Err;

	vtMemFree(mc);
	return 1;

Err:
if(0){
	fprint(2, "metaChunks failed!\n");
	oo = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;
	for(i=0; i&lt;mb-&gt;nindex; i++){
		fprint(2, "\t%d: %d %d\n", i, mc[i].offset,
			mc[i].offset + mc[i].size);
		oo += mc[i].size;
	}
	fprint(2, "\tused=%d size=%d free=%d free2=%d\n",
		oo, mb-&gt;size, mb-&gt;free, mb-&gt;size - oo);
}
	vtMemFree(mc);
	return 0;
}

static void
scanSource(Fsck *chk, char *name, Source *r)
{
	u32int a, nb, o;
	Block *b;
	Entry e;

	if(!chk-&gt;useventi &amp;&amp; globalToLocal(r-&gt;score)==NilBlock)
		return;
	if(!sourceGetEntry(r, &amp;e)){
		error(chk, "could not get entry for %s", name);
		return;
	}
	a = globalToLocal(e.score);
	if(!chk-&gt;useventi &amp;&amp; a==NilBlock)
		return;
	if(getBit(chk-&gt;smap, a))
		return;
	setBit(chk-&gt;smap, a);

	nb = (sourceGetSize(r) + r-&gt;dsize-1) / r-&gt;dsize;
	for(o = 0; o &lt; nb; o++){
		b = sourceBlock(r, o, OReadOnly);
		if(b == nil){
			error(chk, "could not read block in data file %s", name);
			continue;
		}
		if(b-&gt;addr != NilBlock &amp;&amp; getBit(chk-&gt;errmap, b-&gt;addr)){
			warn(chk, "previously reported error in block %ux is in file %s",
				b-&gt;addr, name);
		}
		blockPut(b);
	}
}

/*
 * Walk the source tree making sure that the BtData
 * sources containing directory entries are okay.
 */
static void
chkDir(Fsck *chk, char *name, Source *source, Source *meta)
{
	int i;
	u32int a1, a2, nb, o;
	char *s, *nn;
	uchar *bm;
	Block *b, *bb;
	DirEntry de;
	Entry e1, e2;
	MetaBlock mb;
	MetaEntry me;
	Source *r, *mr;

	if(!chk-&gt;useventi &amp;&amp; globalToLocal(source-&gt;score)==NilBlock &amp;&amp;
	    globalToLocal(meta-&gt;score)==NilBlock)
		return;

	if(!sourceLock2(source, meta, OReadOnly)){
		warn(chk, "could not lock sources for %s: %R", name);
		return;
	}
	if(!sourceGetEntry(source, &amp;e1) || !sourceGetEntry(meta, &amp;e2)){
		warn(chk, "could not load entries for %s: %R", name);
		return;
	}
	a1 = globalToLocal(e1.score);
	a2 = globalToLocal(e2.score);
	if((!chk-&gt;useventi &amp;&amp; a1==NilBlock &amp;&amp; a2==NilBlock)
	|| (getBit(chk-&gt;smap, a1) &amp;&amp; getBit(chk-&gt;smap, a2))){
		sourceUnlock(source);
		sourceUnlock(meta);
		return;
	}
	setBit(chk-&gt;smap, a1);
	setBit(chk-&gt;smap, a2);

	bm = vtMemAllocZ(sourceGetDirSize(source)/8 + 1);

	nb = (sourceGetSize(meta) + meta-&gt;dsize - 1)/meta-&gt;dsize;
	for(o = 0; o &lt; nb; o++){
		b = sourceBlock(meta, o, OReadOnly);
		if(b == nil){
			error(chk, "could not read block in meta file: %s[%ud]: %R",
				name, o);
			continue;
		}
if(0)		fprint(2, "source %V:%d block %d addr %d\n", source-&gt;score,
			source-&gt;offset, o, b-&gt;addr);
		if(b-&gt;addr != NilBlock &amp;&amp; getBit(chk-&gt;errmap, b-&gt;addr))
			warn(chk, "previously reported error in block %ux is in %s",
				b-&gt;addr, name);

		if(!mbUnpack(&amp;mb, b-&gt;data, meta-&gt;dsize)){
			error(chk, "could not unpack meta block: %s[%ud]: %R",
				name, o);
			blockPut(b);
			continue;
		}
		if(!chkMetaBlock(&amp;mb)){
			error(chk, "bad meta block: %s[%ud]: %R", name, o);
			blockPut(b);
			continue;
		}
		s = nil;
		for(i=mb.nindex-1; i&gt;=0; i--){
			meUnpack(&amp;me, &amp;mb, i);
			if(!deUnpack(&amp;de, &amp;me)){
				error(chk,
				  "could not unpack dir entry: %s[%ud][%d]: %R",
					name, o, i);
				continue;
			}
			if(s &amp;&amp; strcmp(s, de.elem) &lt;= 0)
				error(chk,
			   "dir entry out of order: %s[%ud][%d] = %s last = %s",
					name, o, i, de.elem, s);
			vtMemFree(s);
			s = vtStrDup(de.elem);
			nn = smprint("%s/%s", name, de.elem);
			if(nn == nil){
				error(chk, "out of memory");
				continue;
			}
			if(chk-&gt;printdirs)
				if(de.mode&amp;ModeDir)
					chk-&gt;print("%s/\n", nn);
			if(chk-&gt;printfiles)
				if(!(de.mode&amp;ModeDir))
					chk-&gt;print("%s\n", nn);
			if(!(de.mode &amp; ModeDir)){
				r = openSource(chk, source, nn, bm, de.entry,
					de.gen, 0, &amp;mb, i, b);
				if(r != nil){
					if(sourceLock(r, OReadOnly)){
						scanSource(chk, nn, r);
						sourceUnlock(r);
					}
					sourceClose(r);
				}
				deCleanup(&amp;de);
				free(nn);
				continue;
			}

			r = openSource(chk, source, nn, bm, de.entry,
				de.gen, 1, &amp;mb, i, b);
			if(r == nil){
				deCleanup(&amp;de);
				free(nn);
				continue;
			}

			mr = openSource(chk, source, nn, bm, de.mentry,
				de.mgen, 0, &amp;mb, i, b);
			if(mr == nil){
				sourceClose(r);
				deCleanup(&amp;de);
				free(nn);
				continue;
			}

			if(!(de.mode&amp;ModeSnapshot) || chk-&gt;walksnapshots)
				chkDir(chk, nn, r, mr);

			sourceClose(mr);
			sourceClose(r);
			deCleanup(&amp;de);
			free(nn);
			deCleanup(&amp;de);

		}
		vtMemFree(s);
		blockPut(b);
	}

	nb = sourceGetDirSize(source);
	for(o=0; o&lt;nb; o++){
		if(getBit(bm, o))
			continue;
		r = sourceOpen(source, o, OReadOnly, 0);
		if(r == nil)
			continue;
		warn(chk, "non referenced entry in source %s[%d]", name, o);
		if((bb = sourceBlock(source, o/(source-&gt;dsize/VtEntrySize),
		    OReadOnly)) != nil){
			if(bb-&gt;addr != NilBlock){
				setBit(chk-&gt;errmap, bb-&gt;addr);
				chk-&gt;clre(chk, bb, o%(source-&gt;dsize/VtEntrySize));
				chk-&gt;nclre++;
			}
			blockPut(bb);
		}
		sourceClose(r);
	}

	sourceUnlock(source);
	sourceUnlock(meta);
	vtMemFree(bm);
}

static void
checkDirs(Fsck *chk)
{
	Source *r, *mr;

	sourceLock(chk-&gt;fs-&gt;source, OReadOnly);
	r = sourceOpen(chk-&gt;fs-&gt;source, 0, OReadOnly, 0);
	mr = sourceOpen(chk-&gt;fs-&gt;source, 1, OReadOnly, 0);
	sourceUnlock(chk-&gt;fs-&gt;source);
	chkDir(chk, "", r, mr);

	sourceClose(r);
	sourceClose(mr);
}

static void
setBit(uchar *bmap, u32int addr)
{
	if(addr == NilBlock)
		return;

	bmap[addr&gt;&gt;3] |= 1 &lt;&lt; (addr &amp; 7);
}

static int
getBit(uchar *bmap, u32int addr)
{
	if(addr == NilBlock)
		return 0;

	return (bmap[addr&gt;&gt;3] &gt;&gt; (addr &amp; 7)) &amp; 1;
}

static void
error(Fsck *chk, char *fmt, ...)
{
	char buf[256];
	va_list arg;
	static int nerr;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof buf, fmt, arg);
	va_end(arg);

	chk-&gt;print("error: %s\n", buf);

//	if(nerr++ &gt; 20)
//		vtFatal("too many errors");
}

static void
warn(Fsck *chk, char *fmt, ...)
{
	char buf[256];
	va_list arg;
	static int nerr;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof buf, fmt, arg);
	va_end(arg);

	chk-&gt;print("error: %s\n", buf);
}

static void
clrenop(Fsck*, Block*, int)
{
}

static void
closenop(Fsck*, Block*, u32int)
{
}

static void
clrinop(Fsck*, char*, MetaBlock*, int, Block*)
{
}

static int
printnop(char*, ...)
{
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

