<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/flfmt9660.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/flfmt9660.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Initialize a fossil file system from an ISO9660 image already in the
 * file system.  This is a fairly bizarre thing to do, but it lets us generate
 * installation CDs that double as valid Plan 9 disk partitions.  
 * People having trouble booting the CD can just copy it into a disk
 * partition and you've got a working Plan 9 system.
 *
 * I've tried hard to keep all the associated cruft in this file.
 * If you deleted this file and cut out the three calls into it from flfmt.c,
 * no traces would remain.
 */

#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "flfmt9660.h"
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;

static Biobuf *b;

enum{
	Tag = 0x96609660,
	Blocksize = 2048,
};

#pragma varargck type "s" uchar*
#pragma varargck type "L" uchar*
#pragma varargck type "B" uchar*
#pragma varargck type "N" uchar*
#pragma varargck type "T" uchar*
#pragma varargck type "D" uchar*

typedef struct Voldesc Voldesc;
struct Voldesc {
	uchar	magic[8];	/* 0x01, "CD001", 0x01, 0x00 */
	uchar	systemid[32];	/* system identifier */
	uchar	volumeid[32];	/* volume identifier */
	uchar	unused[8];	/* character set in secondary desc */
	uchar	volsize[8];	/* volume size */
	uchar	charset[32];
	uchar	volsetsize[4];	/* volume set size = 1 */
	uchar	volseqnum[4];	/* volume sequence number = 1 */
	uchar	blocksize[4];	/* logical block size */
	uchar	pathsize[8];	/* path table size */
	uchar	lpathloc[4];	/* Lpath */
	uchar	olpathloc[4];	/* optional Lpath */
	uchar	mpathloc[4];	/* Mpath */
	uchar	ompathloc[4];	/* optional Mpath */
	uchar	rootdir[34];	/* root directory */
	uchar	volsetid[128];	/* volume set identifier */
	uchar	publisher[128];
	uchar	prepid[128];	/* data preparer identifier */
	uchar	applid[128];	/* application identifier */
	uchar	notice[37];	/* copyright notice file */
	uchar	abstract[37];	/* abstract file */
	uchar	biblio[37];	/* bibliographic file */
	uchar	cdate[17];	/* creation date */
	uchar	mdate[17];	/* modification date */
	uchar	xdate[17];	/* expiration date */
	uchar	edate[17];	/* effective date */
	uchar	fsvers;		/* file system version = 1 */
};

static void
dumpbootvol(void *a)
{
	Voldesc *v;

	v = a;
	print("magic %.2ux %.5s %.2ux %2ux\n",
		v-&gt;magic[0], v-&gt;magic+1, v-&gt;magic[6], v-&gt;magic[7]);
	if(v-&gt;magic[0] == 0xFF)
		return;

	print("system %.32T\n", v-&gt;systemid);
	print("volume %.32T\n", v-&gt;volumeid);
	print("volume size %.4N\n", v-&gt;volsize);
	print("charset %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux\n",
		v-&gt;charset[0], v-&gt;charset[1], v-&gt;charset[2], v-&gt;charset[3],
		v-&gt;charset[4], v-&gt;charset[5], v-&gt;charset[6], v-&gt;charset[7]);
	print("volume set size %.2N\n", v-&gt;volsetsize);
	print("volume sequence number %.2N\n", v-&gt;volseqnum);
	print("logical block size %.2N\n", v-&gt;blocksize);
	print("path size %.4L\n", v-&gt;pathsize);
	print("lpath loc %.4L\n", v-&gt;lpathloc);
	print("opt lpath loc %.4L\n", v-&gt;olpathloc);
	print("mpath loc %.4B\n", v-&gt;mpathloc);
	print("opt mpath loc %.4B\n", v-&gt;ompathloc);
	print("rootdir %D\n", v-&gt;rootdir);
	print("volume set identifier %.128T\n", v-&gt;volsetid);
	print("publisher %.128T\n", v-&gt;publisher);
	print("preparer %.128T\n", v-&gt;prepid);
	print("application %.128T\n", v-&gt;applid);
	print("notice %.37T\n", v-&gt;notice);
	print("abstract %.37T\n", v-&gt;abstract);
	print("biblio %.37T\n", v-&gt;biblio);
	print("creation date %.17s\n", v-&gt;cdate);
	print("modification date %.17s\n", v-&gt;mdate);
	print("expiration date %.17s\n", v-&gt;xdate);
	print("effective date %.17s\n", v-&gt;edate);
	print("fs version %d\n", v-&gt;fsvers);
}

typedef struct Cdir Cdir;
struct Cdir {
	uchar	len;
	uchar	xlen;
	uchar	dloc[8];
	uchar	dlen[8];
	uchar	date[7];
	uchar	flags;
	uchar	unitsize;
	uchar	gapsize;
	uchar	volseqnum[4];
	uchar	namelen;
	uchar	name[1];	/* chumminess */
};
#pragma varargck type "D" Cdir*

static int
Dfmt(Fmt *fmt)
{
	char buf[128];
	Cdir *c;

	c = va_arg(fmt-&gt;args, Cdir*);
	if(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\0' || c-&gt;name[0] == '\001') {
		snprint(buf, sizeof buf, ".%s dloc %.4N dlen %.4N",
			c-&gt;name[0] ? "." : "", c-&gt;dloc, c-&gt;dlen);
	} else {
		snprint(buf, sizeof buf, "%.*T dloc %.4N dlen %.4N", c-&gt;namelen, c-&gt;name,
			c-&gt;dloc, c-&gt;dlen);
	}
	fmtstrcpy(fmt, buf);
	return 0;
}

char longc, shortc;
static void
bigend(void)
{
	longc = 'B';
}

static void
littleend(void)
{
	longc = 'L';
}

static ulong
big(void *a, int n)
{
	uchar *p;
	ulong v;
	int i;

	p = a;
	v = 0;
	for(i=0; i&lt;n; i++)
		v = (v&lt;&lt;8) | *p++;
	return v;
}

static ulong
little(void *a, int n)
{
	uchar *p;
	ulong v;
	int i;

	p = a;
	v = 0;
	for(i=0; i&lt;n; i++)
		v |= (*p++&lt;&lt;(i*8));
	return v;
}

/* numbers in big or little endian. */
static int
BLfmt(Fmt *fmt)
{
	ulong v;
	uchar *p;
	char buf[20];

	p = va_arg(fmt-&gt;args, uchar*);

	if(!(fmt-&gt;flags&amp;FmtPrec)) {
		fmtstrcpy(fmt, "*BL*");
		return 0;
	}

	if(fmt-&gt;r == 'B')
		v = big(p, fmt-&gt;prec);
	else
		v = little(p, fmt-&gt;prec);

	sprint(buf, "0x%.*lux", fmt-&gt;prec*2, v);
	fmt-&gt;flags &amp;= ~FmtPrec;
	fmtstrcpy(fmt, buf);
	return 0;
}

/* numbers in both little and big endian */
static int
Nfmt(Fmt *fmt)
{
	char buf[100];
	uchar *p;

	p = va_arg(fmt-&gt;args, uchar*);

	sprint(buf, "%.*L %.*B", fmt-&gt;prec, p, fmt-&gt;prec, p+fmt-&gt;prec);
	fmt-&gt;flags &amp;= ~FmtPrec;
	fmtstrcpy(fmt, buf);
	return 0;
}

static int
asciiTfmt(Fmt *fmt)
{
	char *p, buf[256];
	int i;

	p = va_arg(fmt-&gt;args, char*);
	for(i=0; i&lt;fmt-&gt;prec; i++)
		buf[i] = *p++;
	buf[i] = '\0';
	for(p=buf+strlen(buf); p&gt;buf &amp;&amp; p[-1]==' '; p--)
		;
	p[0] = '\0';
	fmt-&gt;flags &amp;= ~FmtPrec;
	fmtstrcpy(fmt, buf);
	return 0;
}

static void
ascii(void)
{
	fmtinstall('T', asciiTfmt);
}

static int
runeTfmt(Fmt *fmt)
{
	Rune buf[256], *r;
	int i;
	uchar *p;

	p = va_arg(fmt-&gt;args, uchar*);
	for(i=0; i*2+2&lt;=fmt-&gt;prec; i++, p+=2)
		buf[i] = (p[0]&lt;&lt;8)|p[1];
	buf[i] = L'\0';
	for(r=buf+i; r&gt;buf &amp;&amp; r[-1]==L' '; r--)
		;
	r[0] = L'\0';
	fmt-&gt;flags &amp;= ~FmtPrec;
	return fmtprint(fmt, "%S", buf);
}

static void
getsect(uchar *buf, int n)
{
	if(Bseek(b, n*2048, 0) != n*2048 || Bread(b, buf, 2048) != 2048)
{
abort();
		sysfatal("reading block at %,d: %r", n*2048);
}
}

static Header *h;
static int fd;
static char *file9660;
static int off9660;
static ulong startoff;
static ulong endoff;
static ulong fsoff;
static uchar root[2048];
static Voldesc *v;
static ulong iso9660start(Cdir*);
static void iso9660copydir(Fs*, File*, Cdir*);
static void iso9660copyfile(Fs*, File*, Cdir*);

void
iso9660init(int xfd, Header *xh, char *xfile9660, int xoff9660)
{
	uchar sect[2048], sect2[2048];

	fmtinstall('L', BLfmt);
	fmtinstall('B', BLfmt);
	fmtinstall('N', Nfmt);
	fmtinstall('D', Dfmt);

	fd = xfd;
	h = xh;
	file9660 = xfile9660;
	off9660 = xoff9660;

	if((b = Bopen(file9660, OREAD)) == nil)
		vtFatal("Bopen %s: %r", file9660);

	getsect(root, 16);
	ascii();

	v = (Voldesc*)root;
	if(memcmp(v-&gt;magic, "\x01CD001\x01\x00", 8) != 0)
		vtFatal("%s not a cd image", file9660);

	startoff = iso9660start((Cdir*)v-&gt;rootdir)*Blocksize;
	endoff = little(v-&gt;volsize, 4);	/* already in bytes */

	fsoff = off9660 + h-&gt;data*h-&gt;blockSize;
	if(fsoff &gt; startoff)
		vtFatal("fossil data starts after cd data");
	if(off9660 + (vlong)h-&gt;end*h-&gt;blockSize &lt; endoff)
		vtFatal("fossil data ends before cd data");
	if(fsoff%h-&gt;blockSize)
		vtFatal("cd offset not a multiple of fossil block size");

	/* Read "same" block via CD image and via Fossil image */
	getsect(sect, startoff/Blocksize);
	if(seek(fd, startoff-off9660, 0) &lt; 0)
		vtFatal("cannot seek to first data sector on cd via fossil");
fprint(2, "look for %lud at %lud\n", startoff, startoff-off9660);
	if(readn(fd, sect2, Blocksize) != Blocksize)
		vtFatal("cannot read first data sector on cd via fossil");
	if(memcmp(sect, sect2, Blocksize) != 0)
		vtFatal("iso9660 offset is a lie %08ux %08ux", *(long*)sect, *(long*)sect2);
}

void
iso9660labels(Disk *disk, uchar *buf, void (*write)(int, u32int))
{
	ulong sb, eb, bn, lb, llb;
	Label l;
	int lpb;
	uchar sect[Blocksize];

	if(!diskReadRaw(disk, PartData, (startoff-fsoff)/h-&gt;blockSize, buf))
		vtFatal("disk read failed: %r");
	getsect(sect, startoff/Blocksize);
	if(memcmp(buf, sect, Blocksize) != 0)
		vtFatal("fsoff is wrong");

	sb = (startoff-fsoff)/h-&gt;blockSize;
	eb = (endoff-fsoff+h-&gt;blockSize-1)/h-&gt;blockSize;

	lpb = h-&gt;blockSize/LabelSize;

	/* for each reserved block, mark label */
	llb = ~0;
	l.type = BtData;
	l.state = BsAlloc;
	l.tag = Tag;
	l.epoch = 1;
	l.epochClose = ~(u32int)0;
	for(bn=sb; bn&lt;eb; bn++){
		lb = bn/lpb;
		if(lb != llb){
			if(llb != ~0)
				(*write)(PartLabel, llb);
			memset(buf, 0, h-&gt;blockSize);
		}
		llb = lb;
		labelPack(&amp;l, buf, bn%lpb);
	}
	if(llb != ~0)
		(*write)(PartLabel, llb);
}

void
iso9660copy(Fs *fs)
{
	File *root;

	root = fileOpen(fs, "/active");
	iso9660copydir(fs, root, (Cdir*)v-&gt;rootdir);
	fileDecRef(root);
	vtRUnlock(fs-&gt;elk);
	if(!fsSnapshot(fs, nil, nil, 0))
		vtFatal("snapshot failed: %R");
	vtRLock(fs-&gt;elk);
}

/*
 * The first block used is the first data block of the leftmost file in the tree.
 * (Just an artifact of how mk9660 works.)
 */
static ulong
iso9660start(Cdir *c)
{
	uchar sect[Blocksize];

	while(c-&gt;flags&amp;2){
		getsect(sect, little(c-&gt;dloc, 4));
		c = (Cdir*)sect;
		c = (Cdir*)((uchar*)c+c-&gt;len);	/* skip dot */
		c = (Cdir*)((uchar*)c+c-&gt;len);	/* skip dotdot */
		/* oops: might happen if leftmost directory is empty or leftmost file is zero length! */
		if(little(c-&gt;dloc, 4) == 0)
			vtFatal("error parsing cd image or unfortunate cd image");	
	}
	return little(c-&gt;dloc, 4);
}

static void
iso9660copydir(Fs *fs, File *dir, Cdir *cd)
{
	ulong off, end, len;
	uchar sect[Blocksize], *esect, *p;
	Cdir *c;

	len = little(cd-&gt;dlen, 4);
	off = little(cd-&gt;dloc, 4)*Blocksize;
	end = off+len;
	esect = sect+Blocksize;

	for(; off&lt;end; off+=Blocksize){
		getsect(sect, off/Blocksize);
		p = sect;
		while(p &lt; esect){
			c = (Cdir*)p;
			if(c-&gt;len &lt;= 0)
				break;
			if(c-&gt;namelen!=1 || c-&gt;name[0]&gt;1)
				iso9660copyfile(fs, dir, c);
			p += c-&gt;len;
		}
	}
}

static char*
getname(uchar **pp)
{
	uchar *p;
	int l;

	p = *pp;
	l = *p;
	*pp = p+1+l;
	if(l == 0)
		return "";
	memmove(p, p+1, l);
	p[l] = 0;
	return (char*)p;
}

static char*
getcname(Cdir *c)
{
	uchar *up;
	char *p, *q;

	up = &amp;c-&gt;namelen;
	p = getname(&amp;up);
	for(q=p; *q; q++)
		*q = tolower(*q);
	return p;
}

static char
dmsize[12] =
{
	31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31,
};

static ulong
getcdate(uchar *p)	/* yMdhmsz */
{
	Tm tm;
	int y, M, d, h, m, s, tz;

	y=p[0]; M=p[1]; d=p[2];
	h=p[3]; m=p[4]; s=p[5]; tz=p[6];
	USED(tz);
	if (y &lt; 70)
		return 0;
	if (M &lt; 1 || M &gt; 12)
		return 0;
	if (d &lt; 1 || d &gt; dmsize[M-1])
		return 0;
	if (h &gt; 23)
		return 0;
	if (m &gt; 59)
		return 0;
	if (s &gt; 59)
		return 0;

	memset(&amp;tm, 0, sizeof tm);
	tm.sec = s;
	tm.min = m;
	tm.hour = h;
	tm.mday = d;
	tm.mon = M-1;
	tm.year = 1900+y;
	tm.zone[0] = 0;
	return tm2sec(&amp;tm);
}

static int ind;

static void
iso9660copyfile(Fs *fs, File *dir, Cdir *c)
{
	Dir d;
	DirEntry de;
	int sysl;
	uchar score[VtScoreSize];
	ulong off, foff, len, mode;
	uchar *p;
	File *f;

	ind++;
	memset(&amp;d, 0, sizeof d);
	p = c-&gt;name + c-&gt;namelen;
	if(((uintptr)p) &amp; 1)
		p++;
	sysl = (uchar*)c + c-&gt;len - p;
	if(sysl &lt;= 0)
		vtFatal("missing plan9 directory entry on %d/%d/%.*s", c-&gt;namelen, c-&gt;name[0], c-&gt;namelen, c-&gt;name);
	d.name = getname(&amp;p);
	d.uid = getname(&amp;p);
	d.gid = getname(&amp;p);
	if((uintptr)p &amp; 1)
		p++;
	d.mode = little(p, 4);
	if(d.name[0] == 0)
		d.name = getcname(c);
	d.mtime = getcdate(c-&gt;date);
	d.atime = d.mtime;

if(d.mode&amp;DMDIR)	print("%*scopy %s %s %s %luo\n", ind*2, "", d.name, d.uid, d.gid, d.mode);

	mode = d.mode&amp;0777;
	if(d.mode&amp;DMDIR)
		mode |= ModeDir;
	if((f = fileCreate(dir, d.name, mode, d.uid)) == nil)
		vtFatal("could not create file '%s': %r", d.name);
	if(d.mode&amp;DMDIR)
		iso9660copydir(fs, f, c);
	else{
		len = little(c-&gt;dlen, 4);
		off = little(c-&gt;dloc, 4)*Blocksize;
		for(foff=0; foff&lt;len; foff+=h-&gt;blockSize){
			localToGlobal((off+foff-fsoff)/h-&gt;blockSize, score);
			if(!fileMapBlock(f, foff/h-&gt;blockSize, score, Tag))
				vtFatal("fileMapBlock: %R");
		}
		if(!fileSetSize(f, len))
			vtFatal("fileSetSize: %R");
	}
	if(!fileGetDir(f, &amp;de))
		vtFatal("fileGetDir: %R");
	de.uid = d.uid;
	de.gid = d.gid;
	de.mtime = d.mtime;
	de.atime = d.atime;
	de.mode = d.mode&amp;0777;
	if(!fileSetDir(f, &amp;de, "sys"))
		vtFatal("fileSetDir: %R");
	fileDecRef(f);
	ind--;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

