<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "error.h"

static void fsMetaFlush(void *a);
static Snap *snapInit(Fs*);
static void snapClose(Snap*);

Fs *
fsOpen(char *file, VtSession *z, long ncache, int mode)
{
	int fd, m;
	uchar oscore[VtScoreSize];
	Block *b, *bs;
	Disk *disk;
	Fs *fs;
	Super super;

	switch(mode){
	default:
		vtSetError(EBadMode);
		return nil;
	case OReadOnly:
		m = OREAD;
		break;
	case OReadWrite:
		m = ORDWR;
		break;
	}
	fd = open(file, m);
	if(fd &lt; 0){
		vtSetError("open %s: %r", file);
		return nil;
	}

	bwatchInit();
	disk = diskAlloc(fd);
	if(disk == nil){
		vtSetError("diskAlloc: %R");
		close(fd);
		return nil;
	}

	fs = vtMemAllocZ(sizeof(Fs));
	fs-&gt;mode = mode;
	fs-&gt;name = vtStrDup(file);
	fs-&gt;blockSize = diskBlockSize(disk);
	fs-&gt;elk = vtLockAlloc();
	fs-&gt;cache = cacheAlloc(disk, z, ncache, mode);
	if(mode == OReadWrite &amp;&amp; z)
		fs-&gt;arch = archInit(fs-&gt;cache, disk, fs, z);
	fs-&gt;z = z;

	b = cacheLocal(fs-&gt;cache, PartSuper, 0, mode);
	if(b == nil)
		goto Err;
	if(!superUnpack(&amp;super, b-&gt;data)){
		blockPut(b);
		vtSetError("bad super block");
		goto Err;
	}
	blockPut(b);

	fs-&gt;ehi = super.epochHigh;
	fs-&gt;elo = super.epochLow;

//fprint(2, "%s: fs-&gt;ehi %d fs-&gt;elo %d active=%d\n", argv0, fs-&gt;ehi, fs-&gt;elo, super.active);

	fs-&gt;source = sourceRoot(fs, super.active, mode);
	if(fs-&gt;source == nil){
		/*
		 * Perhaps it failed because the block is copy-on-write.
		 * Do the copy and try again.
		 */
		if(mode == OReadOnly || strcmp(vtGetError(), EBadRoot) != 0)
			goto Err;
		b = cacheLocalData(fs-&gt;cache, super.active, BtDir, RootTag,
			OReadWrite, 0);
		if(b == nil){
			vtSetError("cacheLocalData: %R");
			goto Err;
		}
		if(b-&gt;l.epoch == fs-&gt;ehi){
			blockPut(b);
			vtSetError("bad root source block");
			goto Err;
		}
		b = blockCopy(b, RootTag, fs-&gt;ehi, fs-&gt;elo);
		if(b == nil)
			goto Err;
		localToGlobal(super.active, oscore);
		super.active = b-&gt;addr;
		bs = cacheLocal(fs-&gt;cache, PartSuper, 0, OReadWrite);
		if(bs == nil){
			blockPut(b);
			vtSetError("cacheLocal: %R");
			goto Err;
		}
		superPack(&amp;super, bs-&gt;data);
		blockDependency(bs, b, 0, oscore, nil);
		blockPut(b);
		blockDirty(bs);
		blockRemoveLink(bs, globalToLocal(oscore), BtDir, RootTag, 0);
		blockPut(bs);
		fs-&gt;source = sourceRoot(fs, super.active, mode);
		if(fs-&gt;source == nil){
			vtSetError("sourceRoot: %R");
			goto Err;
		}
	}

//fprint(2, "%s: got fs source\n", argv0);

	vtRLock(fs-&gt;elk);
	fs-&gt;file = fileRoot(fs-&gt;source);
	fs-&gt;source-&gt;file = fs-&gt;file;		/* point back */
	vtRUnlock(fs-&gt;elk);
	if(fs-&gt;file == nil){
		vtSetError("fileRoot: %R");
		goto Err;
	}

//fprint(2, "%s: got file root\n", argv0);

	if(mode == OReadWrite){
		fs-&gt;metaFlush = periodicAlloc(fsMetaFlush, fs, 1000);
		fs-&gt;snap = snapInit(fs);
	}
	return fs;

Err:
fprint(2, "%s: fsOpen error\n", argv0);
	fsClose(fs);
	return nil;
}

void
fsClose(Fs *fs)
{
	vtRLock(fs-&gt;elk);
	periodicKill(fs-&gt;metaFlush);
	snapClose(fs-&gt;snap);
	if(fs-&gt;file){
		fileMetaFlush(fs-&gt;file, 0);
		if(!fileDecRef(fs-&gt;file))
			vtFatal("fsClose: files still in use: %r\n");
	}
	fs-&gt;file = nil;
	sourceClose(fs-&gt;source);
	cacheFree(fs-&gt;cache);
	if(fs-&gt;arch)
		archFree(fs-&gt;arch);
	vtMemFree(fs-&gt;name);
	vtRUnlock(fs-&gt;elk);
	vtLockFree(fs-&gt;elk);
	memset(fs, ~0, sizeof(Fs));
	vtMemFree(fs);
}

int
fsRedial(Fs *fs, char *host)
{
	if(!vtRedial(fs-&gt;z, host))
		return 0;
	if(!vtConnect(fs-&gt;z, 0))
		return 0;
	return 1;
}

File *
fsGetRoot(Fs *fs)
{
	return fileIncRef(fs-&gt;file);
}

int
fsGetBlockSize(Fs *fs)
{
	return fs-&gt;blockSize;
}

Block*
superGet(Cache *c, Super* super)
{
	Block *b;

	if((b = cacheLocal(c, PartSuper, 0, OReadWrite)) == nil){
		fprint(2, "%s: superGet: cacheLocal failed: %R\n", argv0);
		return nil;
	}
	if(!superUnpack(super, b-&gt;data)){
		fprint(2, "%s: superGet: superUnpack failed: %R\n", argv0);
		blockPut(b);
		return nil;
	}

	return b;
}

void
superWrite(Block* b, Super* super, int forceWrite)
{
	superPack(super, b-&gt;data);
	blockDirty(b);
	if(forceWrite){
		while(!blockWrite(b, Waitlock)){
			/* this should no longer happen */
			fprint(2, "%s: could not write super block; "
				"waiting 10 seconds\n", argv0);
			sleep(10*1000);
		}
		while(b-&gt;iostate != BioClean &amp;&amp; b-&gt;iostate != BioDirty){
			assert(b-&gt;iostate == BioWriting);
			vtSleep(b-&gt;ioready);
		}
		/*
		 * it's okay that b might still be dirty.
		 * that means it got written out but with an old root pointer,
		 * but the other fields went out, and those are the ones
		 * we really care about.  (specifically, epochHigh; see fsSnapshot).
		 */
	}
}

/*
 * Prepare the directory to store a snapshot.
 * Temporary snapshots go into /snapshot/yyyy/mmdd/hhmm[.#]
 * Archival snapshots go into /archive/yyyy/mmdd[.#].
 *
 * TODO This should be rewritten to eliminate most of the duplication.
 */
static File*
fileOpenSnapshot(Fs *fs, char *dstpath, int doarchive)
{
	int n;
	char buf[30], *s, *p, *elem;
	File *dir, *f;
	Tm now;

	if(dstpath){
		if((p = strrchr(dstpath, '/')) != nil){
			*p++ = '\0';
			elem = p;
			p = dstpath;
			if(*p == '\0')
				p = "/";
		}else{
			p = "/";
			elem = dstpath;
		}
		if((dir = fileOpen(fs, p)) == nil)
			return nil;
		f = fileCreate(dir, elem, ModeDir|ModeSnapshot|0555, "adm");
		fileDecRef(dir);
		return f;
	}else if(doarchive){
		/*
		 * a snapshot intended to be archived to venti.
		 */
		dir = fileOpen(fs, "/archive");
		if(dir == nil)
			return nil;
		now = *localtime(time(0));

		/* yyyy */
		snprint(buf, sizeof(buf), "%d", now.year+1900);
		f = fileWalk(dir, buf);
		if(f == nil)
			f = fileCreate(dir, buf, ModeDir|0555, "adm");
		fileDecRef(dir);
		if(f == nil)
			return nil;
		dir = f;

		/* mmdd[#] */
		snprint(buf, sizeof(buf), "%02d%02d", now.mon+1, now.mday);
		s = buf+strlen(buf);
		for(n=0;; n++){
			if(n)
				seprint(s, buf+sizeof(buf), ".%d", n);
			f = fileWalk(dir, buf);
			if(f != nil){
				fileDecRef(f);
				continue;
			}
			f = fileCreate(dir, buf, ModeDir|ModeSnapshot|0555, "adm");
			break;
		}
		fileDecRef(dir);
		return f;
	}else{
		/*
		 * Just a temporary snapshot
		 * We'll use /snapshot/yyyy/mmdd/hhmm.
		 * There may well be a better naming scheme.
		 * (I'd have used hh:mm but ':' is reserved in Microsoft file systems.)
		 */
		dir = fileOpen(fs, "/snapshot");
		if(dir == nil)
			return nil;

		now = *localtime(time(0));

		/* yyyy */
		snprint(buf, sizeof(buf), "%d", now.year+1900);
		f = fileWalk(dir, buf);
		if(f == nil)
			f = fileCreate(dir, buf, ModeDir|0555, "adm");
		fileDecRef(dir);
		if(f == nil)
			return nil;
		dir = f;

		/* mmdd */
		snprint(buf, sizeof(buf), "%02d%02d", now.mon+1, now.mday);
		f = fileWalk(dir, buf);
		if(f == nil)
			f = fileCreate(dir, buf, ModeDir|0555, "adm");
		fileDecRef(dir);
		if(f == nil)
			return nil;
		dir = f;

		/* hhmm[.#] */
		snprint(buf, sizeof buf, "%02d%02d", now.hour, now.min);
		s = buf+strlen(buf);
		for(n=0;; n++){
			if(n)
				seprint(s, buf+sizeof(buf), ".%d", n);
			f = fileWalk(dir, buf);
			if(f != nil){
				fileDecRef(f);
				continue;
			}
			f = fileCreate(dir, buf, ModeDir|ModeSnapshot|0555, "adm");
			break;
		}
		fileDecRef(dir);
		return f;
	}
}

static int
fsNeedArch(Fs *fs, uint archMinute)
{
	int need;
	File *f;
	char buf[100];
	Tm now;
	ulong then;

	then = time(0);
	now = *localtime(then);

	/* back up to yesterday if necessary */
	if(now.hour &lt; archMinute/60
	|| now.hour == archMinute/60 &amp;&amp; now.min &lt; archMinute%60)
		now = *localtime(then-86400);

	snprint(buf, sizeof buf, "/archive/%d/%02d%02d",
		now.year+1900, now.mon+1, now.mday);
	need = 1;
	vtRLock(fs-&gt;elk);
	f = fileOpen(fs, buf);
	if(f){
		need = 0;
		fileDecRef(f);
	}
	vtRUnlock(fs-&gt;elk);
	return need;
}

int
fsEpochLow(Fs *fs, u32int low)
{
	Block *bs;
	Super super;

	vtLock(fs-&gt;elk);
	if(low &gt; fs-&gt;ehi){
		vtSetError("bad low epoch (must be &lt;= %ud)", fs-&gt;ehi);
		vtUnlock(fs-&gt;elk);
		return 0;
	}

	if((bs = superGet(fs-&gt;cache, &amp;super)) == nil){
		vtUnlock(fs-&gt;elk);
		return 0;
	}

	super.epochLow = low;
	fs-&gt;elo = low;
	superWrite(bs, &amp;super, 1);
	blockPut(bs);
	vtUnlock(fs-&gt;elk);

	return 1;
}

static int
bumpEpoch(Fs *fs, int doarchive)
{
	uchar oscore[VtScoreSize];
	u32int oldaddr;
	Block *b, *bs;
	Entry e;
	Source *r;
	Super super;

	/*
	 * Duplicate the root block.
	 *
	 * As a hint to flchk, the garbage collector,
	 * and any (human) debuggers, store a pointer
	 * to the old root block in entry 1 of the new root block.
	 */
	r = fs-&gt;source;
	b = cacheGlobal(fs-&gt;cache, r-&gt;score, BtDir, RootTag, OReadOnly);
	if(b == nil)
		return 0;

	memset(&amp;e, 0, sizeof e);
	e.flags = VtEntryActive | VtEntryLocal | VtEntryDir;
	memmove(e.score, b-&gt;score, VtScoreSize);
	e.tag = RootTag;
	e.snap = b-&gt;l.epoch;

	b = blockCopy(b, RootTag, fs-&gt;ehi+1, fs-&gt;elo);
	if(b == nil){
		fprint(2, "%s: bumpEpoch: blockCopy: %R\n", argv0);
		return 0;
	}

	if(0) fprint(2, "%s: snapshot root from %d to %d\n", argv0, oldaddr, b-&gt;addr);
	entryPack(&amp;e, b-&gt;data, 1);
	blockDirty(b);

	/*
	 * Update the superblock with the new root and epoch.
	 */
	if((bs = superGet(fs-&gt;cache, &amp;super)) == nil)
		return 0;

	fs-&gt;ehi++;
	memmove(r-&gt;score, b-&gt;score, VtScoreSize);
	r-&gt;epoch = fs-&gt;ehi;

	super.epochHigh = fs-&gt;ehi;
	oldaddr = super.active;
	super.active = b-&gt;addr;
	if(doarchive)
		super.next = oldaddr;

	/*
	 * Record that the new super.active can't get written out until
	 * the new b gets written out.  Until then, use the old value.
	 */
	localToGlobal(oldaddr, oscore);
	blockDependency(bs, b, 0, oscore, nil);
	blockPut(b);

	/*
	 * We force the super block to disk so that super.epochHigh gets updated.
	 * Otherwise, if we crash and come back, we might incorrectly treat as active
	 * some of the blocks that making up the snapshot we just created.
	 * Basically every block in the active file system and all the blocks in
	 * the recently-created snapshot depend on the super block now.
	 * Rather than record all those dependencies, we just force the block to disk.
	 *
	 * Note that blockWrite might actually (will probably) send a slightly outdated
	 * super.active to disk.  It will be the address of the most recent root that has
	 * gone to disk.
	 */
	superWrite(bs, &amp;super, 1);
	blockRemoveLink(bs, globalToLocal(oscore), BtDir, RootTag, 0);
	blockPut(bs);

	return 1;
}

int
saveQid(Fs *fs)
{
	Block *b;
	Super super;
	u64int qidMax;

	if((b = superGet(fs-&gt;cache, &amp;super)) == nil)
		return 0;
	qidMax = super.qid;
	blockPut(b);

	if(!fileSetQidSpace(fs-&gt;file, 0, qidMax))
		return 0;

	return 1;
}

int
fsSnapshot(Fs *fs, char *srcpath, char *dstpath, int doarchive)
{
	File *src, *dst;

	assert(fs-&gt;mode == OReadWrite);

	dst = nil;

	if(fs-&gt;halted){
		vtSetError("file system is halted");
		return 0;
	}

	/*
	 * Freeze file system activity.
	 */
	vtLock(fs-&gt;elk);

	/*
	 * Get the root of the directory we're going to save.
	 */
	if(srcpath == nil)
		srcpath = "/active";
	src = fileOpen(fs, srcpath);
	if(src == nil)
		goto Err;

	/*
	 * It is important that we maintain the invariant that:
	 *	if both b and bb are marked as Active with start epoch e
	 *	and b points at bb, then no other pointers to bb exist.
	 * 
	 * When bb is unlinked from b, its close epoch is set to b's epoch.
	 * A block with epoch == close epoch is
	 * treated as free by cacheAllocBlock; this aggressively
	 * reclaims blocks after they have been stored to Venti.
	 *
	 * Let's say src-&gt;source is block sb, and src-&gt;msource is block
	 * mb.  Let's also say that block b holds the Entry structures for
	 * both src-&gt;source and src-&gt;msource (their Entry structures might
	 * be in different blocks, but the argument is the same).
	 * That is, right now we have:
	 *
	 *	b	Active w/ epoch e, holds ptrs to sb and mb.
	 *	sb	Active w/ epoch e.
	 *	mb	Active w/ epoch e.
	 *
	 * With things as they are now, the invariant requires that
	 * b holds the only pointers to sb and mb.  We want to record
	 * pointers to sb and mb in new Entries corresponding to dst,
	 * which breaks the invariant.  Thus we need to do something
	 * about b.  Specifically, we bump the file system's epoch and
	 * then rewalk the path from the root down to and including b.
	 * This will copy-on-write as we walk, so now the state will be:
	 *
	 *	b	Snap w/ epoch e, holds ptrs to sb and mb.
	 *	new-b	Active w/ epoch e+1, holds ptrs to sb and mb.
	 *	sb	Active w/ epoch e.
	 *	mb	Active w/ epoch e.
	 *
	 * In this state, it's perfectly okay to make more pointers to sb and mb.
	 */
	if(!bumpEpoch(fs, 0) || !fileWalkSources(src))
		goto Err;

	/*
	 * Sync to disk.  I'm not sure this is necessary, but better safe than sorry.
	 */
	cacheFlush(fs-&gt;cache, 1);

	/*
	 * Create the directory where we will store the copy of src.
	 */
	dst = fileOpenSnapshot(fs, dstpath, doarchive);
	if(dst == nil)
		goto Err;

	/*
	 * Actually make the copy by setting dst's source and msource
	 * to be src's.
	 */
	if(!fileSnapshot(dst, src, fs-&gt;ehi-1, doarchive))
		goto Err;

	fileDecRef(src);
	fileDecRef(dst);
	src = nil;
	dst = nil;

	/*
	 * Make another copy of the file system.  This one is for the
	 * archiver, so that the file system we archive has the recently
	 * added snapshot both in /active and in /archive/yyyy/mmdd[.#].
	 */
	if(doarchive){
		if(!saveQid(fs))
			goto Err;
		if(!bumpEpoch(fs, 1))
			goto Err;
	}

	vtUnlock(fs-&gt;elk);

	/* BUG? can fs-&gt;arch fall out from under us here? */
	if(doarchive &amp;&amp; fs-&gt;arch)
		archKick(fs-&gt;arch);

	return 1;

Err:
	fprint(2, "%s: fsSnapshot: %R\n", argv0);
	if(src)
		fileDecRef(src);
	if(dst)
		fileDecRef(dst);
	vtUnlock(fs-&gt;elk);
	return 0;
}

int
fsVac(Fs *fs, char *name, uchar score[VtScoreSize])
{
	int r;
	DirEntry de;
	Entry e, ee;
	File *f;

	vtRLock(fs-&gt;elk);
	f = fileOpen(fs, name);
	if(f == nil){
		vtRUnlock(fs-&gt;elk);
		return 0;
	}

	if(!fileGetSources(f, &amp;e, &amp;ee) || !fileGetDir(f, &amp;de)){
		fileDecRef(f);
		vtRUnlock(fs-&gt;elk);
		return 0;
	}
	fileDecRef(f);

	r = mkVac(fs-&gt;z, fs-&gt;blockSize, &amp;e, &amp;ee, &amp;de, score);
	vtRUnlock(fs-&gt;elk);
	return r;
}

static int
vtWriteBlock(VtSession *z, uchar *buf, uint n, uint type, uchar score[VtScoreSize])
{
	if(!vtWrite(z, score, type, buf, n))
		return 0;
	if(!vtSha1Check(score, buf, n))
		return 0;
	return 1;
}

int
mkVac(VtSession *z, uint blockSize, Entry *pe, Entry *pee, DirEntry *pde, uchar score[VtScoreSize])
{
	uchar buf[8192];
	int i;
	uchar *p;
	uint n;
	DirEntry de;
	Entry e, ee, eee;
	MetaBlock mb;
	MetaEntry me;
	VtRoot root;

	e = *pe;
	ee = *pee;
	de = *pde;

	if(globalToLocal(e.score) != NilBlock
	|| (ee.flags&amp;VtEntryActive &amp;&amp; globalToLocal(ee.score) != NilBlock)){
		vtSetError("can only vac paths already stored on venti");
		return 0;
	}

	/*
	 * Build metadata source for root.
	 */
	n = deSize(&amp;de);
	if(n+MetaHeaderSize+MetaIndexSize &gt; sizeof buf){
		vtSetError("DirEntry too big");
		return 0;
	}
	memset(buf, 0, sizeof buf);
	mbInit(&amp;mb, buf, n+MetaHeaderSize+MetaIndexSize, 1);
	p = mbAlloc(&amp;mb, n);
	if(p == nil)
		abort();
	mbSearch(&amp;mb, de.elem, &amp;i, &amp;me);
	assert(me.p == nil);
	me.p = p;
	me.size = n;
	dePack(&amp;de, &amp;me);
	mbInsert(&amp;mb, i, &amp;me);
	mbPack(&amp;mb);

	eee.size = n+MetaHeaderSize+MetaIndexSize;
	if(!vtWriteBlock(z, buf, eee.size, VtDataType, eee.score))
		return 0;
	eee.psize = 8192;
	eee.dsize = 8192;
	eee.depth = 0;
	eee.flags = VtEntryActive;

	/*
	 * Build root source with three entries in it.
	 */
	entryPack(&amp;e, buf, 0);
	entryPack(&amp;ee, buf, 1);
	entryPack(&amp;eee, buf, 2);

	n = VtEntrySize*3;
	memset(&amp;root, 0, sizeof root);
	if(!vtWriteBlock(z, buf, n, VtDirType, root.score))
		return 0;

	/*
	 * Save root.
	 */
	root.version = VtRootVersion;
	strecpy(root.type, root.type+sizeof root.type, "vac");
	strecpy(root.name, root.name+sizeof root.name, de.elem);
	root.blockSize = blockSize;
	vtRootPack(&amp;root, buf);
	if(!vtWriteBlock(z, buf, VtRootSize, VtRootType, score))
		return 0;

	return 1;
}

int
fsSync(Fs *fs)
{
	vtLock(fs-&gt;elk);
	fileMetaFlush(fs-&gt;file, 1);
	cacheFlush(fs-&gt;cache, 1);
	vtUnlock(fs-&gt;elk);
	return 1;
}

int
fsHalt(Fs *fs)
{
	vtLock(fs-&gt;elk);
	fs-&gt;halted = 1;
	fileMetaFlush(fs-&gt;file, 1);
	cacheFlush(fs-&gt;cache, 1);
	return 1;
}

int
fsUnhalt(Fs *fs)
{
	if(!fs-&gt;halted)
		return 0;
	fs-&gt;halted = 0;
	vtUnlock(fs-&gt;elk);
	return 1;
}

int
fsNextQid(Fs *fs, u64int *qid)
{
	Block *b;
	Super super;

	if((b = superGet(fs-&gt;cache, &amp;super)) == nil)
		return 0;

	*qid = super.qid++;

	/*
	 * It's okay if the super block doesn't go to disk immediately,
	 * since fileMetaAlloc will record a dependency between the
	 * block holding this qid and the super block.  See file.c:/^fileMetaAlloc.
	 */
	superWrite(b, &amp;super, 0);
	blockPut(b);
	return 1;
}

static void
fsMetaFlush(void *a)
{
	int rv;
	Fs *fs = a;

	vtRLock(fs-&gt;elk);
	rv = fileMetaFlush(fs-&gt;file, 1);
	vtRUnlock(fs-&gt;elk);
	if(rv &gt; 0)
		cacheFlush(fs-&gt;cache, 0);
}

static int
fsEsearch1(File *f, char *path, u32int savetime, u32int *plo)
{
	int n, r;
	DirEntry de;
	DirEntryEnum *dee;
	File *ff;
	Entry e, ee;
	char *t;

	dee = deeOpen(f);
	if(dee == nil)
		return 0;

	n = 0;
	for(;;){
		r = deeRead(dee, &amp;de);
		if(r &lt;= 0)
			break;
		if(de.mode &amp; ModeSnapshot){
			if((ff = fileWalk(f, de.elem)) != nil){
				if(fileGetSources(ff, &amp;e, &amp;ee))
					if(de.mtime &gt;= savetime &amp;&amp; e.snap != 0)
						if(e.snap &lt; *plo)
							*plo = e.snap;
				fileDecRef(ff);
			}
		}
		else if(de.mode &amp; ModeDir){
			if((ff = fileWalk(f, de.elem)) != nil){
				t = smprint("%s/%s", path, de.elem);
				n += fsEsearch1(ff, t, savetime, plo);
				vtMemFree(t);
				fileDecRef(ff);
			}
		}
		deCleanup(&amp;de);
		if(r &lt; 0)
			break;
	}
	deeClose(dee);

	return n;
}

static int
fsEsearch(Fs *fs, char *path, u32int savetime, u32int *plo)
{
	int n;
	File *f;
	DirEntry de;

	f = fileOpen(fs, path);
	if(f == nil)
		return 0;
	if(!fileGetDir(f, &amp;de)){
		fileDecRef(f);
		return 0;
	}
	if((de.mode &amp; ModeDir) == 0){
		fileDecRef(f);
		deCleanup(&amp;de);
		return 0;
	}
	deCleanup(&amp;de);
	n = fsEsearch1(f, path, savetime, plo);
	fileDecRef(f);
	return n;
}

void
fsSnapshotCleanup(Fs *fs, u32int age)
{
	u32int lo;

	/*
	 * Find the best low epoch we can use,
	 * given that we need to save all the unventied archives
	 * and all the snapshots younger than age.
	 */
	vtRLock(fs-&gt;elk);
	lo = fs-&gt;ehi;
	fsEsearch(fs, "/archive", 0, &amp;lo);
	fsEsearch(fs, "/snapshot", time(0)-age*60, &amp;lo);
	vtRUnlock(fs-&gt;elk);

	fsEpochLow(fs, lo);
	fsSnapshotRemove(fs);
}

/* remove all snapshots that have expired */
/* return number of directory entries remaining */
static int
fsRsearch1(File *f, char *s)
{
	int n, r;
	DirEntry de;
	DirEntryEnum *dee;
	File *ff;
	char *t;

	dee = deeOpen(f);
	if(dee == nil)
		return 0;

	n = 0;
	for(;;){
		r = deeRead(dee, &amp;de);
		if(r &lt;= 0)
			break;
		n++;
		if(de.mode &amp; ModeSnapshot){
			if((ff = fileWalk(f, de.elem)) != nil)
				fileDecRef(ff);
			else if(strcmp(vtGetError(), ESnapOld) == 0){
				if(fileClri(f, de.elem, "adm"))
					n--;
			}
		}
		else if(de.mode &amp; ModeDir){
			if((ff = fileWalk(f, de.elem)) != nil){
				t = smprint("%s/%s", s, de.elem);
				if(fsRsearch1(ff, t) == 0)
					if(fileRemove(ff, "adm"))
						n--;
				vtMemFree(t);
				fileDecRef(ff);
			}
		}
		deCleanup(&amp;de);
		if(r &lt; 0)
			break;
	}
	deeClose(dee);

	return n;
}

static int
fsRsearch(Fs *fs, char *path)
{
	File *f;
	DirEntry de;

	f = fileOpen(fs, path);
	if(f == nil)
		return 0;
	if(!fileGetDir(f, &amp;de)){
		fileDecRef(f);
		return 0;
	}
	if((de.mode &amp; ModeDir) == 0){
		fileDecRef(f);
		deCleanup(&amp;de);
		return 0;
	}
	deCleanup(&amp;de);
	fsRsearch1(f, path);
	fileDecRef(f);
	return 1;
}

void
fsSnapshotRemove(Fs *fs)
{
	vtRLock(fs-&gt;elk);
	fsRsearch(fs, "/snapshot");
	vtRUnlock(fs-&gt;elk);
}

struct Snap
{
	Fs	*fs;
	Periodic*tick;
	VtLock	*lk;
	uint	snapMinutes;
	uint	archMinute;
	uint	snapLife;
	u32int	lastSnap;
	u32int	lastArch;
	u32int	lastCleanup;
	uint	ignore;
};

static void
snapEvent(void *v)
{
	Snap *s;
	u32int now, min;
	Tm tm;
	int need;
	u32int snaplife;

	s = v;

	now = time(0)/60;
	vtLock(s-&gt;lk);

	/*
	 * Snapshots happen every snapMinutes minutes.
	 * If we miss a snapshot (for example, because we
	 * were down), we wait for the next one.
	 */
	if(s-&gt;snapMinutes != ~0 &amp;&amp; s-&gt;snapMinutes != 0
	&amp;&amp; now%s-&gt;snapMinutes==0 &amp;&amp; now != s-&gt;lastSnap){
		if(!fsSnapshot(s-&gt;fs, nil, nil, 0))
			fprint(2, "%s: fsSnapshot snap: %R\n", argv0);
		s-&gt;lastSnap = now;
	}

	/*
	 * Archival snapshots happen at archMinute.
	 * If we miss an archive (for example, because we
	 * were down), we do it as soon as possible.
	 */
	tm = *localtime(now*60);
	min = tm.hour*60+tm.min;
	if(s-&gt;archMinute != ~0){
		need = 0;
		if(min == s-&gt;archMinute &amp;&amp; now != s-&gt;lastArch)
			need = 1;
		if(s-&gt;lastArch == 0){
			s-&gt;lastArch = 1;
			if(fsNeedArch(s-&gt;fs, s-&gt;archMinute))
				need = 1;
		}
		if(need){
			fsSnapshot(s-&gt;fs, nil, nil, 1);
			s-&gt;lastArch = now;
		}
	}

	/*
	 * Snapshot cleanup happens every snaplife or every day.
	 */
	snaplife = s-&gt;snapLife;
	if(snaplife == ~0)
		snaplife = 24*60;
	if(s-&gt;lastCleanup+snaplife &lt; now){
		fsSnapshotCleanup(s-&gt;fs, s-&gt;snapLife);
		s-&gt;lastCleanup = now;
	}
	vtUnlock(s-&gt;lk);
}

static Snap*
snapInit(Fs *fs)
{
	Snap *s;

	s = vtMemAllocZ(sizeof(Snap));
	s-&gt;fs = fs;
	s-&gt;tick = periodicAlloc(snapEvent, s, 10*1000);
	s-&gt;lk = vtLockAlloc();
	s-&gt;snapMinutes = -1;
	s-&gt;archMinute = -1;
	s-&gt;snapLife = -1;
	s-&gt;ignore = 5*2;	/* wait five minutes for clock to stabilize */
	return s;
}

void
snapGetTimes(Snap *s, u32int *arch, u32int *snap, u32int *snaplen)
{
	if(s == nil){
		*snap = -1;
		*arch = -1;
		*snaplen = -1;
		return;
	}

	vtLock(s-&gt;lk);
	*snap = s-&gt;snapMinutes;
	*arch = s-&gt;archMinute;
	*snaplen = s-&gt;snapLife;
	vtUnlock(s-&gt;lk);
}

void
snapSetTimes(Snap *s, u32int arch, u32int snap, u32int snaplen)
{
	if(s == nil)
		return;

	vtLock(s-&gt;lk);
	s-&gt;snapMinutes = snap;
	s-&gt;archMinute = arch;
	s-&gt;snapLife = snaplen;
	vtUnlock(s-&gt;lk);
}

static void
snapClose(Snap *s)
{
	if(s == nil)
		return;

	periodicKill(s-&gt;tick);
	vtMemFree(s);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

