<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/vac.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/vac.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"

typedef struct MetaChunk MetaChunk;

struct MetaChunk {
	ushort offset;
	ushort size;
	ushort index;
};

static int stringUnpack(char **s, uchar **p, int *n);
static int meCmp(MetaEntry*, char *s);
static int meCmpOld(MetaEntry*, char *s);



static char EBadMeta[] = "corrupted meta data";
static char ENoFile[] = "file does not exist";

/*
 * integer conversion routines
 */
#define	U8GET(p)	((p)[0])
#define	U16GET(p)	(((p)[0]&lt;&lt;8)|(p)[1])
#define	U32GET(p)	(((p)[0]&lt;&lt;24)|((p)[1]&lt;&lt;16)|((p)[2]&lt;&lt;8)|(p)[3])
#define	U48GET(p)	(((uvlong)U16GET(p)&lt;&lt;32)|(uvlong)U32GET((p)+2))
#define	U64GET(p)	(((uvlong)U32GET(p)&lt;&lt;32)|(uvlong)U32GET((p)+4))

#define	U8PUT(p,v)	(p)[0]=(v)
#define	U16PUT(p,v)	(p)[0]=(v)&gt;&gt;8;(p)[1]=(v)
#define	U32PUT(p,v)	(p)[0]=(v)&gt;&gt;24;(p)[1]=(v)&gt;&gt;16;(p)[2]=(v)&gt;&gt;8;(p)[3]=(v)
#define	U48PUT(p,v,t32)	t32=(v)&gt;&gt;32;U16PUT(p,t32);t32=(v);U32PUT((p)+2,t32)
#define	U64PUT(p,v,t32)	t32=(v)&gt;&gt;32;U32PUT(p,t32);t32=(v);U32PUT((p)+4,t32)

static int
stringUnpack(char **s, uchar **p, int *n)
{
	int nn;

	if(*n &lt; 2)
		return 0;

	nn = U16GET(*p);
	*p += 2;
	*n -= 2;
	if(nn &gt; *n)
		return 0;
	*s = vtMemAlloc(nn+1);
	memmove(*s, *p, nn);
	(*s)[nn] = 0;
	*p += nn;
	*n -= nn;
	return 1;
}

static int
stringPack(char *s, uchar *p)
{
	int n;

	n = strlen(s);
	U16PUT(p, n);
	memmove(p+2, s, n);
	return n+2;
}

int
mbSearch(MetaBlock *mb, char *elem, int *ri, MetaEntry *me)
{
	int i;
	int b, t, x;
if(0)fprint(2, "mbSearch %s\n", elem);

	/* binary search within block */
	b = 0;
	t = mb-&gt;nindex;
	while(b &lt; t){
		i = (b+t)&gt;&gt;1;
		meUnpack(me, mb, i);

		if(mb-&gt;botch)
			x = meCmpOld(me, elem);
		else
			x = meCmp(me, elem);

		if(x == 0){
			*ri = i;
			return 1;
		}

		if(x &lt; 0)
			b = i+1;
		else /* x &gt; 0 */
			t = i;
	}

	assert(b == t);

	*ri = b;	/* b is the index to insert this entry */
	memset(me, 0, sizeof(*me));

	vtSetError(ENoFile);
	return 0;
}

void
mbInit(MetaBlock *mb, uchar *p, int n, int ne)
{
	memset(p, 0, n);
	mb-&gt;maxsize = n;
	mb-&gt;maxindex = ne;
	mb-&gt;nindex = 0;
	mb-&gt;free = 0;
	mb-&gt;size = MetaHeaderSize + ne*MetaIndexSize;
	mb-&gt;buf = p;
	mb-&gt;botch = 0;
}

int
mbUnpack(MetaBlock *mb, uchar *p, int n)
{
	u32int magic;
	int i;
	int eo, en, omin;
	uchar *q;

	mb-&gt;maxsize = n;
	mb-&gt;buf = p;

	if(n == 0){
		memset(mb, 0, sizeof(MetaBlock));
		return 1;
	}

	magic = U32GET(p);
	if(magic != MetaMagic &amp;&amp; magic != MetaMagic-1)
		goto Err;
	mb-&gt;size = U16GET(p+4);
	mb-&gt;free = U16GET(p+6);
	mb-&gt;maxindex = U16GET(p+8);
	mb-&gt;nindex = U16GET(p+10);
	mb-&gt;botch = magic != MetaMagic;
	if(mb-&gt;size &gt; n)
		goto Err;

	omin = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;
	if(n &lt; omin)
		goto Err;


	p += MetaHeaderSize;

	/* check the index table - ensures that meUnpack and meCmp never fail */
	for(i=0; i&lt;mb-&gt;nindex; i++){
		eo = U16GET(p);
		en = U16GET(p+2);
		if(eo &lt; omin || eo+en &gt; mb-&gt;size || en &lt; 8)
			goto Err;
		q = mb-&gt;buf + eo;
		if(U32GET(q) != DirMagic)
			goto Err;
		p += 4;
	}

	return 1;
Err:
	vtSetError(EBadMeta);
	return 0;
}


void
mbPack(MetaBlock *mb)
{
	uchar *p;

	p = mb-&gt;buf;

	assert(!mb-&gt;botch);

	U32PUT(p, MetaMagic);
	U16PUT(p+4, mb-&gt;size);
	U16PUT(p+6, mb-&gt;free);
	U16PUT(p+8, mb-&gt;maxindex);
	U16PUT(p+10, mb-&gt;nindex);
}


void
mbDelete(MetaBlock *mb, int i)
{
	uchar *p;
	int n;
	MetaEntry me;

	assert(i &lt; mb-&gt;nindex);
	meUnpack(&amp;me, mb, i);
	memset(me.p, 0, me.size);

	if(me.p - mb-&gt;buf + me.size == mb-&gt;size)
		mb-&gt;size -= me.size;
	else
		mb-&gt;free += me.size;

	p = mb-&gt;buf + MetaHeaderSize + i*MetaIndexSize;
	n = (mb-&gt;nindex-i-1)*MetaIndexSize;
	memmove(p, p+MetaIndexSize, n);
	memset(p+n, 0, MetaIndexSize);
	mb-&gt;nindex--;
}

void
mbInsert(MetaBlock *mb, int i, MetaEntry *me)
{
	uchar *p;
	int o, n;

	assert(mb-&gt;nindex &lt; mb-&gt;maxindex);

	o = me-&gt;p - mb-&gt;buf;
	n = me-&gt;size;
	if(o+n &gt; mb-&gt;size){
		mb-&gt;free -= mb-&gt;size - o;
		mb-&gt;size = o + n;
	}else
		mb-&gt;free -= n;

	p = mb-&gt;buf + MetaHeaderSize + i*MetaIndexSize;
	n = (mb-&gt;nindex-i)*MetaIndexSize;
	memmove(p+MetaIndexSize, p, n);
	U16PUT(p, me-&gt;p - mb-&gt;buf);
	U16PUT(p+2, me-&gt;size);
	mb-&gt;nindex++;
}

int
mbResize(MetaBlock *mb, MetaEntry *me, int n)
{
	uchar *p, *ep;

	/* easy case */
	if(n &lt;= me-&gt;size){
		me-&gt;size = n;
		return 1;
	}

	/* try and expand entry */

	p = me-&gt;p + me-&gt;size;
	ep = mb-&gt;buf + mb-&gt;maxsize;
	while(p &lt; ep &amp;&amp; *p == 0)
		p++;
	if(n &lt;= p - me-&gt;p){
		me-&gt;size = n;
		return 1;
	}

	p = mbAlloc(mb, n);
	if(p != nil){
		me-&gt;p = p;
		me-&gt;size = n;
		return 1;
	}

	return 0;
}

void
meUnpack(MetaEntry *me, MetaBlock *mb, int i)
{
	uchar *p;
	int eo, en;

	assert(i &gt;= 0 &amp;&amp; i &lt; mb-&gt;nindex);

	p = mb-&gt;buf + MetaHeaderSize + i*MetaIndexSize;
	eo = U16GET(p);
	en = U16GET(p+2);

	me-&gt;p = mb-&gt;buf + eo;
	me-&gt;size = en;

	/* checked by mbUnpack */
	assert(me-&gt;size &gt;= 8);
}

/* assumes a small amount of checking has been done in mbEntry */
static int
meCmp(MetaEntry *me, char *s)
{
	int n;
	uchar *p;

	p = me-&gt;p;

	/* skip magic &amp; version */
	p += 6;
	n = U16GET(p);
	p += 2;

	if(n &gt; me-&gt;size - 8)
		n = me-&gt;size - 8;

	while(n &gt; 0){
		if(*s == 0)
			return 1;
		if(*p &lt; (uchar)*s)
			return -1;
		if(*p &gt; (uchar)*s)
			return 1;
		p++;
		s++;
		n--;
	}
	return -(*s != 0);
}

/*
 * This is the old and broken meCmp.
 * This cmp routine reverse the sense of the comparison
 * when one string is a prefix of the other.
 * In other words, it put "ab" after "abc" rather
 * than before.  This behaviour is ok; binary search
 * and sort still work.  However, it is goes against
 * the usual convention.
 */
static int
meCmpOld(MetaEntry *me, char *s)
{
	int n;
	uchar *p;

	p = me-&gt;p;

	/* skip magic &amp; version */
	p += 6;
	n = U16GET(p);
	p += 2;

	if(n &gt; me-&gt;size - 8)
		n = me-&gt;size - 8;

	while(n &gt; 0){
		if(*s == 0)
			return -1;
		if(*p &lt; (uchar)*s)
			return -1;
		if(*p &gt; (uchar)*s)
			return 1;
		p++;
		s++;
		n--;
	}
	return *s != 0;
}

static int
offsetCmp(void *s0, void *s1)
{
	MetaChunk *mc0, *mc1;

	mc0 = s0;
	mc1 = s1;
	if(mc0-&gt;offset &lt; mc1-&gt;offset)
		return -1;
	if(mc0-&gt;offset &gt; mc1-&gt;offset)
		return 1;
	return 0;
}

static MetaChunk *
metaChunks(MetaBlock *mb)
{
	MetaChunk *mc;
	int oo, o, n, i;
	uchar *p;

	mc = vtMemAlloc(mb-&gt;nindex*sizeof(MetaChunk));
	p = mb-&gt;buf + MetaHeaderSize;
	for(i = 0; i&lt;mb-&gt;nindex; i++){
		mc[i].offset = U16GET(p);
		mc[i].size = U16GET(p+2);
		mc[i].index = i;
		p += MetaIndexSize;
	}

	qsort(mc, mb-&gt;nindex, sizeof(MetaChunk), offsetCmp);

	/* check block looks ok */
	oo = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;
	o = oo;
	n = 0;
	for(i=0; i&lt;mb-&gt;nindex; i++){
		o = mc[i].offset;
		n = mc[i].size;
		if(o &lt; oo)
			goto Err;
		oo += n;
	}
	if(o+n &gt; mb-&gt;size)
		goto Err;
	if(mb-&gt;size - oo != mb-&gt;free)
		goto Err;

	return mc;
Err:
fprint(2, "metaChunks failed!\n");
oo = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;
for(i=0; i&lt;mb-&gt;nindex; i++){
fprint(2, "\t%d: %d %d\n", i, mc[i].offset, mc[i].offset + mc[i].size);
oo += mc[i].size;
}
fprint(2, "\tused=%d size=%d free=%d free2=%d\n", oo, mb-&gt;size, mb-&gt;free, mb-&gt;size - oo);
	vtSetError(EBadMeta);
	vtMemFree(mc);
	return nil;
}

static void
mbCompact(MetaBlock *mb, MetaChunk *mc)
{
	int oo, o, n, i;

	oo = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;

	for(i=0; i&lt;mb-&gt;nindex; i++){
		o = mc[i].offset;
		n = mc[i].size;
		if(o != oo){
			memmove(mb-&gt;buf + oo, mb-&gt;buf + o, n);
			U16PUT(mb-&gt;buf + MetaHeaderSize + mc[i].index*MetaIndexSize, oo);
		}
		oo += n;
	}

	mb-&gt;size = oo;
	mb-&gt;free = 0;
}

uchar *
mbAlloc(MetaBlock *mb, int n)
{
	int i, o;
	MetaChunk *mc;

	/* off the end */
	if(mb-&gt;maxsize - mb-&gt;size &gt;= n)
		return mb-&gt;buf + mb-&gt;size;

	/* check if possible */
	if(mb-&gt;maxsize - mb-&gt;size + mb-&gt;free &lt; n)
		return nil;

	mc = metaChunks(mb);
	if(mc == nil){
fprint(2, "mbAlloc: metaChunks failed: %r\n");
		return nil;
	}

	/* look for hole */
	o = MetaHeaderSize + mb-&gt;maxindex*MetaIndexSize;
	for(i=0; i&lt;mb-&gt;nindex; i++){
		if(mc[i].offset - o &gt;= n){
			vtMemFree(mc);
			return mb-&gt;buf + o;
		}
		o = mc[i].offset + mc[i].size;
	}

	if(mb-&gt;maxsize - o &gt;= n){
		vtMemFree(mc);
		return mb-&gt;buf + o;
	}

	/* compact and return off the end */
	mbCompact(mb, mc);
	vtMemFree(mc);

	if(mb-&gt;maxsize - mb-&gt;size &lt; n){
		vtSetError(EBadMeta);
		return nil;
	}
	return mb-&gt;buf + mb-&gt;size;
}

int
deSize(DirEntry *dir)
{
	int n;

	/* constant part */

	n = 	4 +	/* magic */
		2 + 	/* version */
		4 +	/* entry */
		4 + 	/* guid */
		4 + 	/* mentry */
		4 + 	/* mgen */
		8 +	/* qid */
		4 + 	/* mtime */
		4 + 	/* mcount */
		4 + 	/* ctime */
		4 + 	/* atime */
		4 +	/* mode */
		0;

	/* strings */
	n += 2 + strlen(dir-&gt;elem);
	n += 2 + strlen(dir-&gt;uid);
	n += 2 + strlen(dir-&gt;gid);
	n += 2 + strlen(dir-&gt;mid);

	/* optional sections */
	if(dir-&gt;qidSpace){
		n += 	3 + 	/* option header */
			8 + 	/* qidOffset */
			8;	/* qid Max */
	}

	return n;
}

void
dePack(DirEntry *dir, MetaEntry *me)
{
	uchar *p;
	ulong t32;

	p = me-&gt;p;

	U32PUT(p, DirMagic);
	U16PUT(p+4, 9);		/* version */
	p += 6;

	p += stringPack(dir-&gt;elem, p);

	U32PUT(p, dir-&gt;entry);
	U32PUT(p+4, dir-&gt;gen);
	U32PUT(p+8, dir-&gt;mentry);
	U32PUT(p+12, dir-&gt;mgen);
	U64PUT(p+16, dir-&gt;qid, t32);
	p += 24;

	p += stringPack(dir-&gt;uid, p);
	p += stringPack(dir-&gt;gid, p);
	p += stringPack(dir-&gt;mid, p);

	U32PUT(p, dir-&gt;mtime);
	U32PUT(p+4, dir-&gt;mcount);
	U32PUT(p+8, dir-&gt;ctime);
	U32PUT(p+12, dir-&gt;atime);
	U32PUT(p+16, dir-&gt;mode);
	p += 5*4;

	if(dir-&gt;qidSpace){
		U8PUT(p, DeQidSpace);
		U16PUT(p+1, 2*8);
		p += 3;
		U64PUT(p, dir-&gt;qidOffset, t32);
		U64PUT(p+8, dir-&gt;qidMax, t32);
		p += 16;
	}

	assert(p == me-&gt;p + me-&gt;size);
}


int
deUnpack(DirEntry *dir, MetaEntry *me)
{
	int t, nn, n, version;
	uchar *p;

	p = me-&gt;p;
	n = me-&gt;size;

	memset(dir, 0, sizeof(DirEntry));

if(0)print("deUnpack\n");
	/* magic */
	if(n &lt; 4 || U32GET(p) != DirMagic)
		goto Err;
	p += 4;
	n -= 4;

if(0)print("deUnpack: got magic\n");
	/* version */
	if(n &lt; 2)
		goto Err;
	version = U16GET(p);
	if(version &lt; 7 || version &gt; 9)
		goto Err;
	p += 2;
	n -= 2;

if(0)print("deUnpack: got version\n");

	/* elem */
	if(!stringUnpack(&amp;dir-&gt;elem, &amp;p, &amp;n))
		goto Err;

if(0)print("deUnpack: got elem\n");

	/* entry  */
	if(n &lt; 4)
		goto Err;
	dir-&gt;entry = U32GET(p);
	p += 4;
	n -= 4;

if(0)print("deUnpack: got entry\n");

	if(version &lt; 9){
		dir-&gt;gen = 0;
		dir-&gt;mentry = dir-&gt;entry+1;
		dir-&gt;mgen = 0;
	}else{
		if(n &lt; 3*4)
			goto Err;
		dir-&gt;gen = U32GET(p);
		dir-&gt;mentry = U32GET(p+4);
		dir-&gt;mgen = U32GET(p+8);
		p += 3*4;
		n -= 3*4;
	}

if(0)print("deUnpack: got gen etc\n");

	/* size is gotten from VtEntry */
	dir-&gt;size = 0;

	/* qid */
	if(n &lt; 8)
		goto Err;
	dir-&gt;qid = U64GET(p);
	p += 8;
	n -= 8;

if(0)print("deUnpack: got qid\n");
	/* skip replacement */
	if(version == 7){
		if(n &lt; VtScoreSize)
			goto Err;
		p += VtScoreSize;
		n -= VtScoreSize;
	}

	/* uid */
	if(!stringUnpack(&amp;dir-&gt;uid, &amp;p, &amp;n))
		goto Err;

	/* gid */
	if(!stringUnpack(&amp;dir-&gt;gid, &amp;p, &amp;n))
		goto Err;

	/* mid */
	if(!stringUnpack(&amp;dir-&gt;mid, &amp;p, &amp;n))
		goto Err;

if(0)print("deUnpack: got ids\n");
	if(n &lt; 5*4)
		goto Err;
	dir-&gt;mtime = U32GET(p);
	dir-&gt;mcount = U32GET(p+4);
	dir-&gt;ctime = U32GET(p+8);
	dir-&gt;atime = U32GET(p+12);
	dir-&gt;mode = U32GET(p+16);
	p += 5*4;
	n -= 5*4;

if(0)print("deUnpack: got times\n");
	/* optional meta data */
	while(n &gt; 0){
		if(n &lt; 3)
			goto Err;
		t = p[0];
		nn = U16GET(p+1);
		p += 3;
		n -= 3;
		if(n &lt; nn)
			goto Err;
		switch(t){
		case DePlan9:
			/* not valid in version &gt;= 9 */
			if(version &gt;= 9)
				break;
			if(dir-&gt;plan9 || nn != 12)
				goto Err;
			dir-&gt;plan9 = 1;
			dir-&gt;p9path = U64GET(p);
			dir-&gt;p9version = U32GET(p+8);
			if(dir-&gt;mcount == 0)
				dir-&gt;mcount = dir-&gt;p9version;
			break;
		case DeGen:
			/* not valid in version &gt;= 9 */
			if(version &gt;= 9)
				break;
			break;
		case DeQidSpace:
			if(dir-&gt;qidSpace || nn != 16)
				goto Err;
			dir-&gt;qidSpace = 1;
			dir-&gt;qidOffset = U64GET(p);
			dir-&gt;qidMax = U64GET(p+8);
			break;
		}
		p += nn;
		n -= nn;
	}
if(0)print("deUnpack: got options\n");

	if(p != me-&gt;p + me-&gt;size)
		goto Err;

if(0)print("deUnpack: correct size\n");
	return 1;
Err:
if(0)print("deUnpack: XXXXXXXXXXXX EBadMeta\n");
	vtSetError(EBadMeta);
	deCleanup(dir);
	return 0;
}

void
deCleanup(DirEntry *dir)
{
	vtMemFree(dir-&gt;elem);
	dir-&gt;elem = nil;
	vtMemFree(dir-&gt;uid);
	dir-&gt;uid = nil;
	vtMemFree(dir-&gt;gid);
	dir-&gt;gid = nil;
	vtMemFree(dir-&gt;mid);
	dir-&gt;mid = nil;
}

void
deCopy(DirEntry *dst, DirEntry *src)
{
	*dst = *src;
	dst-&gt;elem = vtStrDup(src-&gt;elem);
	dst-&gt;uid = vtStrDup(src-&gt;uid);
	dst-&gt;gid = vtStrDup(src-&gt;gid);
	dst-&gt;mid = vtStrDup(src-&gt;mid);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

