<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/freq.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/freq.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

uvlong	count[Runemax+1];
Biobuf	bout;

void	usage(void);
void	freq(int, char*);
long	flag;
enum
{
	Fdec	= 1&lt;&lt;0,
	Fhex	= 1&lt;&lt;1,
	Foct	= 1&lt;&lt;2,
	Fchar	= 1&lt;&lt;3,
	Frune	= 1&lt;&lt;4,
};

void
main(int argc, char *argv[])
{
	int f, i;

	flag = 0;
	Binit(&amp;bout, 1, OWRITE);
	ARGBEGIN{
	case 'd':
		flag |= Fdec;
		break;
	case 'x':
		flag |= Fhex;
		break;
	case 'o':
		flag |= Foct;
		break;
	case 'c':
		flag |= Fchar;
		break;
	case 'r':
		flag |= Frune;
		break;
	default:
		usage();
	}ARGEND
	if((flag&amp;(Fdec|Fhex|Foct|Fchar)) == 0)
		flag |= Fdec | Fhex | Foct | Fchar;
	if(argc &lt; 1) {
		freq(0, "-");
		exits(0);
	}
	for(i=0; i&lt;argc; i++) {
		f = open(argv[i], 0);
		if(f &lt; 0) {
			fprint(2, "open %s: %r\n", argv[i]);
			continue;
		}
		freq(f, argv[i]);
		close(f);
	}
	exits(0);
}

void
usage(void)
{
	fprint(2, "usage: freq [-cdorx] [file ...]\n");
	exits("usage");
}

void
freq(int f, char *s)
{
	Biobuf bin;
	long c, i;

	memset(count, 0, sizeof(count));
	Binit(&amp;bin, f, OREAD);
	if(flag &amp; Frune) {
		for(;;) {
			c = Bgetrune(&amp;bin);
			if(c &lt; 0)
				break;
			count[c]++;
		}
	} else {
		for(;;) {
			c = Bgetc(&amp;bin);
			if(c &lt; 0)
				break;
			count[c]++;
		}
	}
	Bterm(&amp;bin);
	if(c != Beof)
		fprint(2, "freq: read error on %s\n", s);

	for(i=0; i&lt;nelem(count); i++) {
		if(count[i] == 0)
			continue;
		if(flag &amp; Fdec)
			Bprint(&amp;bout, "%3ld ", i);
		if(flag &amp; Foct)
			Bprint(&amp;bout, "%.3lo ", i);
		if(flag &amp; Fhex)
			Bprint(&amp;bout, "%.2lx ", i);
		if(flag &amp; Fchar) {
			if(i &lt;= 0x20 ||
			   i &gt;= 0x7f &amp;&amp; i &lt; 0xa0 ||
			   i &gt; 0xff &amp;&amp; !(flag &amp; Frune))
				Bprint(&amp;bout, "- ");
			else
				Bprint(&amp;bout, "%C ", (int)i);
		}
		Bprint(&amp;bout, "%8llud\n", count[i]);
	}
	Bflush(&amp;bout);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

