<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/grep/sub.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/grep/sub.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"grep.h"

void*
mal(int n)
{
	static char *s;
	static int m = 0;
	void *v;

	n = (n+3) &amp; ~3;
	if(m &lt; n) {
		if(n &gt; Nhunk) {
			v = sbrk(n);
			memset(v, 0, n);
			return v;
		}
		s = sbrk(Nhunk);
		m = Nhunk;
	}
	v = s;
	s += n;
	m -= n;
	memset(v, 0, n);
	return v;
}

State*
sal(int n)
{
	State *s;

	s = mal(sizeof(*s));
//	s-&gt;next = mal(256*sizeof(*s-&gt;next));
	s-&gt;count = n;
	s-&gt;re = mal(n*sizeof(*state0-&gt;re));
	return s;
}

Re*
ral(int type)
{
	Re *r;

	r = mal(sizeof(*r));
	r-&gt;type = type;
	maxfollow++;
	return r;
}

void
error(char *s)
{
	fprint(2, "grep: internal error: %s\n", s);
	exits(s);
}

int
countor(Re *r)
{
	int n;

	n = 0;
loop:
	switch(r-&gt;type) {
	case Tor:
		n += countor(r-&gt;alt);
		r = r-&gt;next;
		goto loop;
	case Tclass:
		return n + r-&gt;hi - r-&gt;lo + 1;
	}
	return n;
}

Re*
oralloc(int t, Re *r, Re *b)
{
	Re *a;

	if(b == 0)
		return r;
	a = ral(t);
	a-&gt;alt = r;
	a-&gt;next = b;
	return a;
}

void
case1(Re *c, Re *r)
{
	int n;

loop:
	switch(r-&gt;type) {
	case Tor:
		case1(c, r-&gt;alt);
		r = r-&gt;next;
		goto loop;

	case Tclass:	/* add to character */
		for(n=r-&gt;lo; n&lt;=r-&gt;hi; n++)
			c-&gt;cases[n] = oralloc(Tor, r-&gt;next, c-&gt;cases[n]);
		break;

	default:	/* add everything unknown to next */
		c-&gt;next = oralloc(Talt, r, c-&gt;next);
		break;
	}
}

Re*
addcase(Re *r)
{
	int i, n;
	Re *a;

	if(r-&gt;gen == gen)
		return r;
	r-&gt;gen = gen;
	switch(r-&gt;type) {
	default:
		error("addcase");

	case Tor:
		n = countor(r);
		if(n &gt;= Caselim) {
			a = ral(Tcase);
			a-&gt;cases = mal(256*sizeof(*a-&gt;cases));
			case1(a, r);
			for(i=0; i&lt;256; i++)
				if(a-&gt;cases[i]) {
					r = a-&gt;cases[i];
					if(countor(r) &lt; n)
						a-&gt;cases[i] = addcase(r);
				}
			return a;
		}
		return r;

	case Talt:
		r-&gt;next = addcase(r-&gt;next);
		r-&gt;alt = addcase(r-&gt;alt);
		return r;

	case Tbegin:
	case Tend:
	case Tclass:
		return r;
	}
}

void
str2top(char *p)
{
	Re2 oldtop;

	oldtop = topre;
	input = p;
	if (*p == '\0')
		yyerror("empty pattern");	/* can't be a file name here */
	if (!flags['f'])
		pattern = p;
	topre.beg = 0;
	topre.end = 0;
	yyparse();
	gen++;
	if(topre.beg == 0)
		yyerror("syntax");
	if(oldtop.beg)
		topre = re2or(oldtop, topre);
}

void
appendnext(Re *a, Re *b)
{
	Re *n;

	while(n = a-&gt;next)
		a = n;
	a-&gt;next = b;
}

void
patchnext(Re *a, Re *b)
{
	Re *n;

	while(a) {
		n = a-&gt;next;
		a-&gt;next = b;
		a = n;
	}
}

int
getrec(void)
{
	int c;

	if(flags['f']) {
		c = Bgetc(rein);
		if(c &lt;= 0)
			return 0;
	} else
		c = *input++ &amp; 0xff;
	if(flags['i'] &amp;&amp; c &gt;= 'A' &amp;&amp; c &lt;= 'Z')
		c += 'a'-'A';
	if(c == '\n')
		lineno++;
	return c;
}

Re2
re2cat(Re2 a, Re2 b)
{
	Re2 c;

	c.beg = a.beg;
	c.end = b.end;
	patchnext(a.end, b.beg);
	return c;
}

Re2
re2star(Re2 a)
{
	Re2 c;

	c.beg = ral(Talt);
	c.beg-&gt;alt = a.beg;
	patchnext(a.end, c.beg);
	c.end = c.beg;
	return c;
}

Re2
re2or(Re2 a, Re2 b)
{
	Re2 c;

	c.beg = ral(Tor);
	c.beg-&gt;alt = b.beg;
	c.beg-&gt;next = a.beg;
	c.end = b.end;
	appendnext(c.end,  a.end);
	return c;
}

Re2
re2char(int c0, int c1)
{
	Re2 c;

	c.beg = ral(Tclass);
	c.beg-&gt;lo = c0 &amp; 0xff;
	c.beg-&gt;hi = c1 &amp; 0xff;
	c.end = c.beg;
	return c;
}

void
reprint1(Re *a)
{
	int i, j;

loop:
	if(a == 0)
		return;
	if(a-&gt;gen == gen)
		return;
	a-&gt;gen = gen;
	print("%p: ", a);
	switch(a-&gt;type) {
	default:
		print("type %d\n", a-&gt;type);
		error("print1 type");

	case Tcase:
		print("case -&gt;%p\n", a-&gt;next);
		for(i=0; i&lt;256; i++)
			if(a-&gt;cases[i]) {
				for(j=i+1; j&lt;256; j++)
					if(a-&gt;cases[i] != a-&gt;cases[j])
						break;
				print("	[%.2x-%.2x] -&gt;%p\n", i, j-1, a-&gt;cases[i]);
				i = j-1;
			}
		for(i=0; i&lt;256; i++)
			reprint1(a-&gt;cases[i]);
		break;

	case Tbegin:
		print("^ -&gt;%p\n", a-&gt;next);
		break;

	case Tend:
		print("$ -&gt;%p\n", a-&gt;next);
		break;

	case Tclass:
		print("[%.2x-%.2x] -&gt;%p\n", a-&gt;lo, a-&gt;hi, a-&gt;next);
		break;

	case Tor:
	case Talt:
		print("| %p -&gt;%p\n", a-&gt;alt, a-&gt;next);
		reprint1(a-&gt;alt);
		break;
	}
	a = a-&gt;next;
	goto loop;
}

void
reprint(char *s, Re *r)
{
	print("%s:\n", s);
	gen++;
	reprint1(r);
	print("\n\n");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

