<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/doc/gsdoc.el - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/doc/gsdoc.el</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
;; gsdoc.el
;;
;; GNU emacs (19.34) functions to help working with the HTML form of
;; Ghostscript documentation.
;;
;; Pete Kaiser 8 September 1998 V1.2
;;		2 December 1999 V1.3	Correct improper "--" to "=="
;;					in HTML marker comments
;;============================================================
;; One global key setting, which runs the function to bind some keys
;; locally -- presumably in a buffer containing HTML code.  Plus that
;; function itself.

(global-set-key [?\C-\S-k]	'gskeys)

(defun gskeys ()

"Set the keys in this buffer to use with Ghostscript HTML docs."

(interactive)
(local-set-key [?\C-\S-b]	'gs-bold)
(local-set-key [?\C-\S-c]	'gs-code)
(local-set-key [?\C-\S-e]	'gs-emphatic)
(local-set-key [?\C-\S-g]	'gs-get-anchor)
(local-set-key [?\C-\S-h]	'gs-href)
(local-set-key [?\C-\S-i]	'gs-italic)
(local-set-key [?\C-\S-m]	'gs-mailto)
(local-set-key [?\C-\S-n]	'gs-name)
(local-set-key [?\C-\S-p]	'gs-put-anchor)
(local-set-key [?\C-\S-q]	'gs-quote)
(local-set-key [?\C-\S-r]	'gs-row-of-table)
(local-set-key [?\C-\S-s]	'gs-selfref)
(local-set-key [?\C-\S-t]	'gs-table)
(local-set-key [?\C-\S-u]	'gs-tag)
(local-set-key [?\C-\S-x]	'gs-example)
)

;;============================================================
;; Each of these next few functions just wraps a region in a
;; &lt;TAG&gt;...&lt;/TAG&gt;, or two nested tags.  Where there are two, the first one
;; is inner.  See the inner function ~gsregion.

(defun gs-bold ()	"Make text strong (bold)."
(interactive)
(~gsregion "b"))

(defun gs-code ()	"Make text strong code (bold TT)."
(interactive)
(~gsregion "tt")
(~gsregion "b"))

(defun gs-emphatic ()	"Make text emphatic (bold italic)."
(interactive)
(~gsregion "em")
(~gsregion "b"))

(defun gs-italic ()	"Make text italic."
(interactive)
(~gsregion "em"))

;;============================================================

(defun gs-quote ()

"Indent a region with BLOCKQUOTE and separate it with empty lines from
surrounding text."

(interactive)

(save-restriction (narrow-to-region (region-beginning) (region-end))
    (goto-char (point-min)) (insert "\n\n")
    (push-mark (1+ (point-min)) t)
    (goto-char (point-max))
    (~gsregion "blockquote")
    (insert "\n\n")
    )
)

;;============================================================

(defun gs-example ()

"Make an indented literatim example BLOCKQUOTE PRE and separate it with
empty lines from surrounding text."

(interactive)

(save-restriction (narrow-to-region (region-beginning) (region-end))
    (goto-char (point-min)) (insert "\n")
    (push-mark (point-min) t)
    (goto-char (point-max))
    (~gsregion "pre")
    (~gsregion "blockquote")
    (insert "\n")
    )
)

;;============================================================

(defun gs-get-anchor ()

"Beginning at the head of this line, pick up the next anchor name for later
use along with its HTML file name.  This is useful when picking up an
anchor name from a file in one buffer and using it in another buffer
containing a different file."

(interactive)

;; From the beginning of this line find and pick up the next non-empty
;; anchor, which might, of course not be right here -- though that's how it
;; ought to be used, to pick up an anchor for immediate use.  The regular
;; expression picks up only the name itself.

(beginning-of-line)
(re-search-forward "&lt;a name=\"?\\([^\"&gt;]+\\)\"?&gt;&lt;/a&gt;" nil t)
(setq gs-anchor (buffer-substring (match-beginning 1) (match-end 1)))

;; Get the name of this buffer, treating it as the filename.

(setq gs-anchor-file (buffer-name))
)

;;============================================================

(defun gs-href ()

"Wrap a region in an empty link and leave point in the middle of the
emptiness to write the link.  Maybe some day read the URL and put it
there."

(interactive)

(save-restriction
  (narrow-to-region (region-beginning) (region-end))
  (goto-char (point-min)) (insert "&lt;a href=\"#\"&gt;")
  (setq HREF (- (point) 2))
  (goto-char (point-max)) (insert "&lt;/a&gt;")
  (goto-char HREF)
  )
)

;;============================================================

(defun gs-mailto ()

"Turn an address into a proper \"mailto:\" visually bracketed with &lt;&gt;."

(interactive)

(save-restriction
  (narrow-to-region (region-beginning) (region-end))
  (setq gs-address (buffer-substring (point-min) (point-max)))
  (goto-char (point-min)) (insert "&amp;lt;&lt;a href=\"mailto:")
  (goto-char (point-max)) (insert "\"&gt;" gs-address "&lt;/a&gt;&amp;gt;")
  )
)

;;============================================================

(defun gs-tag (Tag)

"Bracket a region with some arbitrary tag read from the minibuffer, leaving
point right after the opening word of the opening tag, and the end of the
region at the end of the closing tag.  Leaving point there makes it
possible, for instance, to enter additional matter in a &lt;FONT&gt; tag.  Get to
the end of a region with ^x-^x."

(interactive "*sTag: ")

    (~gsregion Tag)
    (exchange-point-and-mark) (forward-word 1)
)

;;============================================================

(defun gs-toc ()

"[Re]build the table of contents by picking up all the &lt;Hn&gt; lines and
converting them to properly indented &lt;UL&gt; entries, placing the TOC within
the standard TOC markers.  Note that several of the original Ghostscript
HTML files have hand-modified TOCs, so it's wise to check before running
this function.  It can be run from anywhere within the HTML file.

This function relies on the specific format of the structure comments for
the table of contents, which are set by the g~marker function used in
defvars run when this package is loaded."

(interactive)

(setq g~html-buffer (buffer-name))

(save-restriction (save-excursion
  (widen)

;; Since we're building the TOC, delete any current TOC.  Locate the place
;; for the TOC using the standard markers, deleting everything between the
;; TOC-beginning and TOC-end markers.  The new TOC is built entirely in the
;; work buffer before being copied into the HTML buffer at that point.

  (goto-char (point-min))
  (search-forward g~toc-begin nil t)
  (next-line 1) (beginning-of-line) (setq g~toc-insert (point))
  (search-forward g~toc-end nil t)
  (beginning-of-line) (delete-region g~toc-insert (point))

;; Empty the work buffer by copying nothing into it.

  (copy-to-buffer gs-work-buffer 1 1)

;; Now collect all the following header lines into a buffer to work on
;; them.  The later append-to-buffer needs point to be in the middle of the
;; empty list, so go there before entering the work buffer.

  (save-excursion (while (re-search-forward "^&lt;h[1-6][^&gt;]*&gt;" nil t)
    (beginning-of-line) (setq BOH (point))
    (re-search-forward "&lt;/h[1-6]&gt;\n" nil t)
    (append-to-buffer gs-work-buffer BOH (point))
    ))
  (goto-char g~toc-insert)

;; All the useful header lines should be in the work buffer now.

  (save-excursion
    (set-buffer gs-work-buffer)

;; Formatting as list entries: insert &lt;ul&gt; when the level deepens and &lt;/ul&gt;
;; when it rises.

    (goto-char (point-min))
    (while (search-forward "&lt;/a&gt;" nil t) (replace-match ""))
    (goto-char (point-min))
    (while (re-search-forward "&lt;/h[1-6]&gt;" nil t) (replace-match "&lt;/a&gt;"))
    (goto-char (point-min))
    (while (re-search-forward "&lt;a name=\"" nil t) (replace-match "&lt;a href=\"#"))

;; Change &lt;h[1-6]&gt; to &lt;li&gt;, inserting &lt;ul&gt;...&lt;/ul&gt; as needed.  Pick up the
;; upmost level from the first header, usually &lt;h1&gt;, and save a copy to
;; use to insert any terminating &lt;/ul&gt;.

    (goto-char (point-min))
    (re-search-forward "^&lt;h\\([1-6]\\)[^&gt;]*&gt;" nil t)
    (setq First (string-to-number
		 (buffer-substring (match-beginning 1) (match-end 1))))
    (setq Previous First)
    (replace-match "&lt;li&gt;" t t)

;; Got the first one, now handle the rest.

    (while (re-search-forward "^&lt;h\\([1-6]\\)[^&gt;]*&gt;" nil t)
      (setq This (string-to-number
		  (buffer-substring (match-beginning 1) (match-end 1))))
      (setq Hold This)
      (replace-match "&lt;li&gt;" t t) (beginning-of-line)

;; No point being too fancy with conditionals: the "while" statements here
;; make at most one logically unnecessary test.

      (while (&gt; This Previous) (insert  "&lt;ul&gt;\n") (setq This (1- This)))
      (while (&lt; This Previous) (insert "&lt;/ul&gt;\n") (setq This (1+ This)))
      (setq Previous Hold)
      )

;; Done with the loop.  Clean up by inserting at the end any &lt;/ul&gt; needed
;; to get back to the top level.

    (goto-char (point-max))
    (while (&gt; Previous First) (insert "&lt;/ul&gt;\n") (setq Previous (1- Previous)))

;; Finally add the trailing whitespace and leading whitespace and header line.

    (insert "&lt;/ul&gt;&lt;/blockquote&gt;\n\n")
    (goto-char (point-min))
    (insert "\n&lt;h2&gt;Table of contents&lt;/h2&gt;\n\n&lt;blockquote&gt;&lt;ul&gt;\n")

;; The TOC is now entirely built in the work buffer.  Move it to where it's
;; supposed to be in the original buffer.

    (append-to-buffer g~html-buffer (point-min) (point-max))
    )
  ))
)

;;============================================================

(defun gs-name ()

"Insert a name anchor at point and leave point ready to enter the anchor's
name.  Anchors are always empty (that is, &lt;a name=...&gt;&lt;/a&gt;)."

(interactive)

(insert "&lt;a name=\"\"&gt;&lt;/a&gt;")
(backward-char 6)
)

;;============================================================

(defun gs-put-anchor ()

"Insert around the current region the last anchor picked up with
gs-get-anchor.  This includes the HTML file name if the href is put in a
file other than the anchor."

(interactive)

(save-restriction
  (narrow-to-region (region-beginning) (region-end))
  (goto-char (point-min))
  (insert (concat
    "&lt;a href=\""

;; Insert the filename (buffer name) picked up by gs-get-anchor only if
;; this is a different buffer.

    (if (string-equal gs-anchor-file (buffer-name)) "" gs-anchor-file)

;; And finish unconditionally with the specific anchor name.

    "#" gs-anchor "\"&gt;"))
  (goto-char (point-max)) (insert "&lt;/a&gt;"))
)

;;============================================================

(defun gs-row-of-table ()

"Set up a row of a table from the line containing point.

Insert the right things at beginning and end, and in between convert tab
and \"|\" into column breaks with a nonbreaking space in between -- which
means that no entry can contain a tab or \"|\".  Format the HTML nicely
for readability.

Between each two substantive columns this function puts a column containing
a single nonbreaking space to provide a visual break.  Generally in the
first row of a table those columns should be given enough NBSPs to make
the table look right on screen and when converted to text, but this has to
be done by hand."

(interactive)

(save-restriction
  (end-of-line) (setq EOL (point))
  (beginning-of-line) (narrow-to-region (point) EOL)
  (insert "&lt;tr valign=top&gt;\t&lt;td&gt;")
  (while (re-search-forward "[|\t]" nil t)
    (replace-match "\n\t&lt;td&gt;&amp;nbsp;\n\t&lt;td&gt;" t t))
  (goto-char (point-max))
  )
(next-line 1) (beginning-of-line)
)

;;============================================================

(defun gs-selfref ()

"Wrap an URL to make it its own link.  This is useful for links that should
be visible when converted to text."

(interactive)

(save-restriction
  (narrow-to-region (region-beginning) (region-end))
  (goto-char (point-min))
  (if (not (looking-at "http:\\|ftp:")) (insert "http://"))
  (setq g~url (buffer-substring (point-min) (point-max)))
  (goto-char (point-min))
  (insert "&lt;a href=\"")
  (goto-char (point-max)) (insert "\"&gt;" g~url "&lt;/a&gt;")
  )
)

;;============================================================

(defun gs-table ()

"Set up an indented table around this region, leaving plenty of white space
around the table within the HTML.  The number of columns in the table is
hardcoded here as 3, so that number must be changed by hand if the table
has more than 3 columns.  See gs-row-of-table for how rows are built: a
table with N visible columns generally has 2N-1 HTML columns, including the
columns that provide vertical white space."

(interactive)

(save-restriction
  (narrow-to-region (region-beginning) (region-end))
  (indent-rigidly (region-beginning) (region-end) -80)
  (goto-char (point-min))
  (insert (concat
	"\n\n&lt;blockquote&gt;&lt;table cellpadding=0 cellspacing=0&gt;\n"
	"&lt;tr&gt;&lt;th colspan=3 bgcolor=\"#CCCC00\"&gt;&lt;hr&gt;&lt;font size=\"+1\"&gt;XXXXXXXXXX&lt;/font&gt;&lt;hr&gt;\n"
	"&lt;tr valign=bottom&gt;\n"
	"\t&lt;th align=left&gt;\n"
	"\t&lt;td&gt;&amp;nbsp;&amp;nbsp;\n"
	"\t&lt;th align=left&gt;\n"
	"&lt;tr&gt;\t&lt;td colspan=3&gt;&lt;hr&gt;\n"
	))
  (goto-char (point-max))
  (insert "&lt;/table&gt;&lt;/blockquote&gt;\n")
  )
)

;;============================================================

(defun gs-text-chars ()

"Prepare text for inclusion in HTML by converting \"&amp;\", \"&lt;\", and \"&gt;\"  into
their HTML special forms.  The function acts from point to end-of-region or
end-of-buffer, whichever comes first.

This function is NOT idempotent -- running it twice on the same text will
certainly do the wrong thing, unless at first the text contained none of
those characters."

(interactive)
(setq BEGIN (point))

;; Replace significant characters: "&amp;", "&lt;", and "&gt;".

(while (search-forward "&amp;" nil t) (replace-match "&amp;amp;" t t))

(goto-char BEGIN)
(while (search-forward "&lt;" nil t) (replace-match "&amp;lt;" t t))

(goto-char BEGIN)
(while (search-forward "&gt;" nil t) (replace-match "&amp;gt;" t t))

(goto-char BEGIN)
)

;;============================================================

(defun gs-wrap-textfile ()

"Prepare a text file for inclusion between &lt;pre&gt; and &lt;/pre&gt;, then put a
header and footer around it.  One would generally run this function on a
buffer containing only an original text file; it is how the original
history and news files were first prepared.  At this point it's likely to
be most useful in preparing new sections for the news document."

(interactive)

(widen)

;; First prepare the entire text by replacing special characters.

(goto-char (point-min))
(gs-text-chars)

;; At the end of the file, end as-is text and add the standard footer.

(goto-char (point-max))
(backward-word 1) (next-line 1) (beginning-of-line)
(delete-region (point) (point-max))
(insert "\n&lt;/pre&gt;\n")
(insert-file "Footer.htm")

;; At the beginning of the file, begin as-is text and delete everything
;; up to the identity string (if any), saving the identity string.

(goto-char (point-min))
(insert "&lt;pre&gt;\n") (setq g~pre-point (point))
(setq g~ID " [No pre-existing ID] ")
(if (re-search-forward "^\\$Id:\\( [^ ]+ \\)\\$" nil t) (progn
    (setq g~ID (buffer-substring (match-beginning 1) (match-end 1)))
    (next-line 1) (beginning-of-line) (delete-region g~pre-point (point))
    ))

;; Insert the standard header and fill in the identity string.

(goto-char (point-min)) (insert-file "Header.htm")
(goto-char (point-min)) (search-forward "&lt;!--" nil t)
(delete-horizontal-space) (insert g~ID)
(search-forward "&lt;pre&gt;\n" nil t)
)

;;============================================================

(defun ~gsregion (Tag)

"Tag a region, leaving point at its end and the region around the whole
thing including the new surrounding tags; thus invoking this function twice
successively makes the first invocation the inner tags and the second the
outer.

Not intended for interactive use; for that use gs-tag, which gives a little
bit of additional service."

(interactive)

(if (not (= 0 (length Tag))) (save-restriction
  (narrow-to-region (region-beginning) (region-end))
  (goto-char (point-min)) (insert "&lt;"  Tag "&gt;")
  (goto-char (point-max)) (insert "&lt;/" Tag "&gt;")
  (push-mark (point-min) t)
  (goto-char (point-max))
  )
  )
)

;;============================================================

(defun gs-structure ()

"For historical interest only: add structuring commentary to a Ghostscript
HTML file.  It's crude, but it did most of the work.  Future files will
acquire their structure through plagiarism, like any other code.

Now they've all been structured, and this function was used to do it.  The
placement of table-of-contents lines never worked, because most of the
files didn't yet have TOCS.  Now all files that should have TOCs have
properly placed markers, but that's history."

(interactive)

(setq g~thisfile (buffer-name))

(widen)
(goto-char (point-min))

;; Replace the RCS $Id if one can be found in exactly the right format, and
;; otherwise insert one just after the title, along with a warning message.

(if (re-search-forward "&lt;!-- $Id: *\\([^ ]*\\) $ --&gt;" nil t)
    (progn
      (setq Original (buffer-substring (match-beginning 1) (match-end 1)))
      (replace-match g~thisfile t t nil 1)
      )
    (progn
      (search-forward "&lt;/title&gt;" nil t) (end-of-line)
      (insert (concat "\n&lt;!-- $Id: " g~thisfile " $ --&gt;"))
      (setq Original "(UNSET by gs-structure)")
      )
    )

(end-of-line)
(insert (concat "\n&lt;!-- Originally: " Original " --&gt;"))

;; Place the visible header marker immediately after &lt;BODY&gt;.

(re-search-forward "&lt;body[^&gt;]*&gt;" nil t)
    (end-of-line) (forward-char 1)
    (insert (concat g~header-begin "\n\n"))

;; Place the headline marker before the first &lt;table&gt; block.

(search-forward "&lt;table" nil t) (search-backward "\n\n" nil t)
    (forward-word 1) (beginning-of-line)
    (insert (concat g~headline-begin "\n\n"))

;; After the first table block place the end-headline marker and both
;; table-of-contents markers, without worrying where the table of contents
;; really is.  The TOC markers can easily be moved by hand later.

(search-forward "\n\n" nil t)
    (backward-word 1) (end-of-line) (forward-char 1)
    (insert (concat
	"\n"
	g~headline-end	"\n\n"
	g~toc-begin	"\n\n"
	g~toc-end	"\n\n"))

;; The hints section begins with the first paragraph after where the TOC
;; markers are placed, and ends with &lt;HR&gt;.  This isn't precise, and in fact
;; fails for several files, but once again only an approximation is needed
;; because it'll be edited by hand later.

(search-forward "&lt;p&gt;" nil t) (beginning-of-line)
    (insert (concat g~hint-begin "\n\n"))

(search-forward "&lt;hr&gt;" nil t) (beginning-of-line)
    (insert (concat g~hint-end "\n\n"))

;; The visible header ends with (and includes) the first &lt;HR&gt;, and the
;; contents begin immediately thereafter.

(search-forward "&lt;hr&gt;\n" nil t)
    (insert (concat "\n" g~header-end "\n\n"))

(forward-word 1) (beginning-of-line)
    (insert (concat g~contents-begin "\n\n"))

;; The contents end before the final &lt;HR&gt; and the trailer begins
;; immediately thereafter.

(goto-char (point-max)) (search-backward "&lt;hr&gt;" nil t)
    (backward-word 1) (end-of-line) (forward-char 1)
    (insert (concat
	"\n"
	g~contents-end	"\n\n"
	g~trailer-begin	"\n\n"))

;; The trailer ends with &lt;/BODY&gt;.

(goto-char (point-max)) (search-backward "&lt;/body&gt;" nil t)
    (insert (concat "\n" g~trailer-end "\n\n"))

;; We may have introduced trailing whitespace and extra empty lines.
;; Remove them.

(goto-char (point-min))
(while (re-search-forward "[ \t\240\r]+$" nil t) (replace-match "" t t))
(goto-char (point-min))
(while (re-search-forward "\n\n\n+" nil t) (replace-match "\n\n" t t))

)

;;============================================================
;; When this file is loaded into emacs, define the structure markers for GS
;; HTML files.  These markers have two purposes: first, to make the HTML
;; more readable, and second, to enable these functions to locate sections
;; unambiguously (see gs-toc, the table of contents builder).  Note that
;; the markers do not include LF.

(defun g~marker (basic)

"Build a complete Ghostscript HTML file marker from its text-only part.
gs-toc relies entirely on this function, so if it's ever changed, gs-toc
and existing markers would also have to be changed to keep pace.

Intended only for initialization, not interactive use.

All the existing files are now marked up, and since any future ones are
(properly) likely to be created by plagiarism, it's difficult to imagine
why anyone would want to change this unless they want to go to the trouble
of coming up with a much more useful marking scheme."

(interactive)

(setq HEAD (concat "&lt;!-- [" basic "] "))
(concat HEAD
    (substring
    "====================================================================== --&gt;"
    (- (length HEAD) 80)
    ))
)

;;============================================================
;; Initialization code that must run after functions are defined.
;;
;; Look in a Ghostscript HTML file to see how these markers are used,
;; generally
;;
;;	begin visible header
;;		begin headline
;;		end headline
;;		begin table of contents
;;		end table of contents
;;		begin hint
;;		end hint
;;	end visible header
;;	begin contents
;;	end contents
;;	begin visible trailer
;;	end visible trailer
;;
;; although the TOC is in slightly different positions in a few files.

(defvar g~header-begin		(g~marker "1.0 begin visible header")
	"Begin the HTML file's visible header material")

(defvar g~header-end		(g~marker "1.0 end visible header")
	"End the HTML file's visible header")

(defvar g~headline-begin	(g~marker "1.1 begin headline")
	"Begin the conspicuous headline")

(defvar g~headline-end		(g~marker "1.1 end headline")
	"End the conspicuous headline")

(defvar g~toc-begin		(g~marker "1.2 begin table of contents")
	"Begin the table of contents")

(defvar g~toc-end		(g~marker "1.2 end table of contents")
	"End the table of contents")

(defvar g~hint-begin		(g~marker "1.3 begin hint")
	"Begin the \"for other information\" section")

(defvar g~hint-end		(g~marker "1.3 end hint")
	"End the \"for other information\" section")

(defvar g~contents-begin	(g~marker "2.0 begin contents")
	"Begin the main contents")

(defvar g~contents-end		(g~marker "2.0 end contents")
	"End the main contents")

(defvar g~trailer-begin		(g~marker "3.0 begin visible trailer")
	"Begin the visible standard trailer material")

(defvar g~trailer-end		(g~marker "3.0 end visible trailer")
	"End the visible standard trailer material")

;;============================================================
;; Some working variables

(defvar gs-anchor	"JUNK"		"*Anchor name to insert")
(defvar gs-anchor-file	"JUNKFILE"	"*Anchor filename to insert")
(defvar gs-work-buffer	"*GS work*"	"*Ghostscript working buffer")
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

