<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/jpeg/jdinput.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/jpeg/jdinput.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * jdinput.c
 *
 * Copyright (C) 1991-1997, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file contains input control logic for the JPEG decompressor.
 * These routines are concerned with controlling the decompressor's input
 * processing (marker reading and coefficient decoding).  The actual input
 * reading is done in jdmarker.c, jdhuff.c, and jdphuff.c.
 */

#define JPEG_INTERNALS
#include "jinclude.h"
#include "jpeglib.h"


/* Private state */

typedef struct {
  struct jpeg_input_controller pub; /* public fields */

  boolean inheaders;		/* TRUE until first SOS is reached */
} my_input_controller;

typedef my_input_controller * my_inputctl_ptr;


/* Forward declarations */
METHODDEF(int) consume_markers JPP((j_decompress_ptr cinfo));


/*
 * Routines to calculate various quantities related to the size of the image.
 */

LOCAL(void)
initial_setup (j_decompress_ptr cinfo)
/* Called once, when first SOS marker is reached */
{
  int ci;
  jpeg_component_info *compptr;

  /* Make sure image isn't bigger than I can handle */
  if ((long) cinfo-&gt;image_height &gt; (long) JPEG_MAX_DIMENSION ||
      (long) cinfo-&gt;image_width &gt; (long) JPEG_MAX_DIMENSION)
    ERREXIT1(cinfo, JERR_IMAGE_TOO_BIG, (unsigned int) JPEG_MAX_DIMENSION);

  /* For now, precision must match compiled-in value... */
  if (cinfo-&gt;data_precision != BITS_IN_JSAMPLE)
    ERREXIT1(cinfo, JERR_BAD_PRECISION, cinfo-&gt;data_precision);

  /* Check that number of components won't exceed internal array sizes */
  if (cinfo-&gt;num_components &gt; MAX_COMPONENTS)
    ERREXIT2(cinfo, JERR_COMPONENT_COUNT, cinfo-&gt;num_components,
	     MAX_COMPONENTS);

  /* Compute maximum sampling factors; check factor validity */
  cinfo-&gt;max_h_samp_factor = 1;
  cinfo-&gt;max_v_samp_factor = 1;
  for (ci = 0, compptr = cinfo-&gt;comp_info; ci &lt; cinfo-&gt;num_components;
       ci++, compptr++) {
    if (compptr-&gt;h_samp_factor&lt;=0 || compptr-&gt;h_samp_factor&gt;MAX_SAMP_FACTOR ||
	compptr-&gt;v_samp_factor&lt;=0 || compptr-&gt;v_samp_factor&gt;MAX_SAMP_FACTOR)
      ERREXIT(cinfo, JERR_BAD_SAMPLING);
    cinfo-&gt;max_h_samp_factor = MAX(cinfo-&gt;max_h_samp_factor,
				   compptr-&gt;h_samp_factor);
    cinfo-&gt;max_v_samp_factor = MAX(cinfo-&gt;max_v_samp_factor,
				   compptr-&gt;v_samp_factor);
  }

  /* We initialize DCT_scaled_size and min_DCT_scaled_size to DCTSIZE.
   * In the full decompressor, this will be overridden by jdmaster.c;
   * but in the transcoder, jdmaster.c is not used, so we must do it here.
   */
  cinfo-&gt;min_DCT_scaled_size = DCTSIZE;

  /* Compute dimensions of components */
  for (ci = 0, compptr = cinfo-&gt;comp_info; ci &lt; cinfo-&gt;num_components;
       ci++, compptr++) {
    compptr-&gt;DCT_scaled_size = DCTSIZE;
    /* Size in DCT blocks */
    compptr-&gt;width_in_blocks = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width * (long) compptr-&gt;h_samp_factor,
		    (long) (cinfo-&gt;max_h_samp_factor * DCTSIZE));
    compptr-&gt;height_in_blocks = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height * (long) compptr-&gt;v_samp_factor,
		    (long) (cinfo-&gt;max_v_samp_factor * DCTSIZE));
    /* downsampled_width and downsampled_height will also be overridden by
     * jdmaster.c if we are doing full decompression.  The transcoder library
     * doesn't use these values, but the calling application might.
     */
    /* Size in samples */
    compptr-&gt;downsampled_width = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width * (long) compptr-&gt;h_samp_factor,
		    (long) cinfo-&gt;max_h_samp_factor);
    compptr-&gt;downsampled_height = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height * (long) compptr-&gt;v_samp_factor,
		    (long) cinfo-&gt;max_v_samp_factor);
    /* Mark component needed, until color conversion says otherwise */
    compptr-&gt;component_needed = TRUE;
    /* Mark no quantization table yet saved for component */
    compptr-&gt;quant_table = NULL;
  }

  /* Compute number of fully interleaved MCU rows. */
  cinfo-&gt;total_iMCU_rows = (JDIMENSION)
    jdiv_round_up((long) cinfo-&gt;image_height,
		  (long) (cinfo-&gt;max_v_samp_factor*DCTSIZE));

  /* Decide whether file contains multiple scans */
  if (cinfo-&gt;comps_in_scan &lt; cinfo-&gt;num_components || cinfo-&gt;progressive_mode)
    cinfo-&gt;inputctl-&gt;has_multiple_scans = TRUE;
  else
    cinfo-&gt;inputctl-&gt;has_multiple_scans = FALSE;
}


LOCAL(void)
per_scan_setup (j_decompress_ptr cinfo)
/* Do computations that are needed before processing a JPEG scan */
/* cinfo-&gt;comps_in_scan and cinfo-&gt;cur_comp_info[] were set from SOS marker */
{
  int ci, mcublks, tmp;
  jpeg_component_info *compptr;
  
  if (cinfo-&gt;comps_in_scan == 1) {
    
    /* Noninterleaved (single-component) scan */
    compptr = cinfo-&gt;cur_comp_info[0];
    
    /* Overall image size in MCUs */
    cinfo-&gt;MCUs_per_row = compptr-&gt;width_in_blocks;
    cinfo-&gt;MCU_rows_in_scan = compptr-&gt;height_in_blocks;
    
    /* For noninterleaved scan, always one block per MCU */
    compptr-&gt;MCU_width = 1;
    compptr-&gt;MCU_height = 1;
    compptr-&gt;MCU_blocks = 1;
    compptr-&gt;MCU_sample_width = compptr-&gt;DCT_scaled_size;
    compptr-&gt;last_col_width = 1;
    /* For noninterleaved scans, it is convenient to define last_row_height
     * as the number of block rows present in the last iMCU row.
     */
    tmp = (int) (compptr-&gt;height_in_blocks % compptr-&gt;v_samp_factor);
    if (tmp == 0) tmp = compptr-&gt;v_samp_factor;
    compptr-&gt;last_row_height = tmp;
    
    /* Prepare array describing MCU composition */
    cinfo-&gt;blocks_in_MCU = 1;
    cinfo-&gt;MCU_membership[0] = 0;
    
  } else {
    
    /* Interleaved (multi-component) scan */
    if (cinfo-&gt;comps_in_scan &lt;= 0 || cinfo-&gt;comps_in_scan &gt; MAX_COMPS_IN_SCAN)
      ERREXIT2(cinfo, JERR_COMPONENT_COUNT, cinfo-&gt;comps_in_scan,
	       MAX_COMPS_IN_SCAN);
    
    /* Overall image size in MCUs */
    cinfo-&gt;MCUs_per_row = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width,
		    (long) (cinfo-&gt;max_h_samp_factor*DCTSIZE));
    cinfo-&gt;MCU_rows_in_scan = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height,
		    (long) (cinfo-&gt;max_v_samp_factor*DCTSIZE));
    
    cinfo-&gt;blocks_in_MCU = 0;
    
    for (ci = 0; ci &lt; cinfo-&gt;comps_in_scan; ci++) {
      compptr = cinfo-&gt;cur_comp_info[ci];
      /* Sampling factors give # of blocks of component in each MCU */
      compptr-&gt;MCU_width = compptr-&gt;h_samp_factor;
      compptr-&gt;MCU_height = compptr-&gt;v_samp_factor;
      compptr-&gt;MCU_blocks = compptr-&gt;MCU_width * compptr-&gt;MCU_height;
      compptr-&gt;MCU_sample_width = compptr-&gt;MCU_width * compptr-&gt;DCT_scaled_size;
      /* Figure number of non-dummy blocks in last MCU column &amp; row */
      tmp = (int) (compptr-&gt;width_in_blocks % compptr-&gt;MCU_width);
      if (tmp == 0) tmp = compptr-&gt;MCU_width;
      compptr-&gt;last_col_width = tmp;
      tmp = (int) (compptr-&gt;height_in_blocks % compptr-&gt;MCU_height);
      if (tmp == 0) tmp = compptr-&gt;MCU_height;
      compptr-&gt;last_row_height = tmp;
      /* Prepare array describing MCU composition */
      mcublks = compptr-&gt;MCU_blocks;
      if (cinfo-&gt;blocks_in_MCU + mcublks &gt; D_MAX_BLOCKS_IN_MCU)
	ERREXIT(cinfo, JERR_BAD_MCU_SIZE);
      while (mcublks-- &gt; 0) {
	cinfo-&gt;MCU_membership[cinfo-&gt;blocks_in_MCU++] = ci;
      }
    }
    
  }
}


/*
 * Save away a copy of the Q-table referenced by each component present
 * in the current scan, unless already saved during a prior scan.
 *
 * In a multiple-scan JPEG file, the encoder could assign different components
 * the same Q-table slot number, but change table definitions between scans
 * so that each component uses a different Q-table.  (The IJG encoder is not
 * currently capable of doing this, but other encoders might.)  Since we want
 * to be able to dequantize all the components at the end of the file, this
 * means that we have to save away the table actually used for each component.
 * We do this by copying the table at the start of the first scan containing
 * the component.
 * The JPEG spec prohibits the encoder from changing the contents of a Q-table
 * slot between scans of a component using that slot.  If the encoder does so
 * anyway, this decoder will simply use the Q-table values that were current
 * at the start of the first scan for the component.
 *
 * The decompressor output side looks only at the saved quant tables,
 * not at the current Q-table slots.
 */

LOCAL(void)
latch_quant_tables (j_decompress_ptr cinfo)
{
  int ci, qtblno;
  jpeg_component_info *compptr;
  JQUANT_TBL * qtbl;

  for (ci = 0; ci &lt; cinfo-&gt;comps_in_scan; ci++) {
    compptr = cinfo-&gt;cur_comp_info[ci];
    /* No work if we already saved Q-table for this component */
    if (compptr-&gt;quant_table != NULL)
      continue;
    /* Make sure specified quantization table is present */
    qtblno = compptr-&gt;quant_tbl_no;
    if (qtblno &lt; 0 || qtblno &gt;= NUM_QUANT_TBLS ||
	cinfo-&gt;quant_tbl_ptrs[qtblno] == NULL)
      ERREXIT1(cinfo, JERR_NO_QUANT_TABLE, qtblno);
    /* OK, save away the quantization table */
    qtbl = (JQUANT_TBL *)
      (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				  SIZEOF(JQUANT_TBL));
    MEMCOPY(qtbl, cinfo-&gt;quant_tbl_ptrs[qtblno], SIZEOF(JQUANT_TBL));
    compptr-&gt;quant_table = qtbl;
  }
}


/*
 * Initialize the input modules to read a scan of compressed data.
 * The first call to this is done by jdmaster.c after initializing
 * the entire decompressor (during jpeg_start_decompress).
 * Subsequent calls come from consume_markers, below.
 */

METHODDEF(void)
start_input_pass (j_decompress_ptr cinfo)
{
  per_scan_setup(cinfo);
  latch_quant_tables(cinfo);
  (*cinfo-&gt;entropy-&gt;start_pass) (cinfo);
  (*cinfo-&gt;coef-&gt;start_input_pass) (cinfo);
  cinfo-&gt;inputctl-&gt;consume_input = cinfo-&gt;coef-&gt;consume_data;
}


/*
 * Finish up after inputting a compressed-data scan.
 * This is called by the coefficient controller after it's read all
 * the expected data of the scan.
 */

METHODDEF(void)
finish_input_pass (j_decompress_ptr cinfo)
{
  cinfo-&gt;inputctl-&gt;consume_input = consume_markers;
}


/*
 * Read JPEG markers before, between, or after compressed-data scans.
 * Change state as necessary when a new scan is reached.
 * Return value is JPEG_SUSPENDED, JPEG_REACHED_SOS, or JPEG_REACHED_EOI.
 *
 * The consume_input method pointer points either here or to the
 * coefficient controller's consume_data routine, depending on whether
 * we are reading a compressed data segment or inter-segment markers.
 */

METHODDEF(int)
consume_markers (j_decompress_ptr cinfo)
{
  my_inputctl_ptr inputctl = (my_inputctl_ptr) cinfo-&gt;inputctl;
  int val;

  if (inputctl-&gt;pub.eoi_reached) /* After hitting EOI, read no further */
    return JPEG_REACHED_EOI;

  val = (*cinfo-&gt;marker-&gt;read_markers) (cinfo);

  switch (val) {
  case JPEG_REACHED_SOS:	/* Found SOS */
    if (inputctl-&gt;inheaders) {	/* 1st SOS */
      initial_setup(cinfo);
      inputctl-&gt;inheaders = FALSE;
      /* Note: start_input_pass must be called by jdmaster.c
       * before any more input can be consumed.  jdapimin.c is
       * responsible for enforcing this sequencing.
       */
    } else {			/* 2nd or later SOS marker */
      if (! inputctl-&gt;pub.has_multiple_scans)
	ERREXIT(cinfo, JERR_EOI_EXPECTED); /* Oops, I wasn't expecting this! */
      start_input_pass(cinfo);
    }
    break;
  case JPEG_REACHED_EOI:	/* Found EOI */
    inputctl-&gt;pub.eoi_reached = TRUE;
    if (inputctl-&gt;inheaders) {	/* Tables-only datastream, apparently */
      if (cinfo-&gt;marker-&gt;saw_SOF)
	ERREXIT(cinfo, JERR_SOF_NO_SOS);
    } else {
      /* Prevent infinite loop in coef ctlr's decompress_data routine
       * if user set output_scan_number larger than number of scans.
       */
      if (cinfo-&gt;output_scan_number &gt; cinfo-&gt;input_scan_number)
	cinfo-&gt;output_scan_number = cinfo-&gt;input_scan_number;
    }
    break;
  case JPEG_SUSPENDED:
    break;
  }

  return val;
}


/*
 * Reset state to begin a fresh datastream.
 */

METHODDEF(void)
reset_input_controller (j_decompress_ptr cinfo)
{
  my_inputctl_ptr inputctl = (my_inputctl_ptr) cinfo-&gt;inputctl;

  inputctl-&gt;pub.consume_input = consume_markers;
  inputctl-&gt;pub.has_multiple_scans = FALSE; /* "unknown" would be better */
  inputctl-&gt;pub.eoi_reached = FALSE;
  inputctl-&gt;inheaders = TRUE;
  /* Reset other modules */
  (*cinfo-&gt;err-&gt;reset_error_mgr) ((j_common_ptr) cinfo);
  (*cinfo-&gt;marker-&gt;reset_marker_reader) (cinfo);
  /* Reset progression state -- would be cleaner if entropy decoder did this */
  cinfo-&gt;coef_bits = NULL;
}


/*
 * Initialize the input controller module.
 * This is called only once, when the decompression object is created.
 */

GLOBAL(void)
jinit_input_controller (j_decompress_ptr cinfo)
{
  my_inputctl_ptr inputctl;

  /* Create subobject in permanent pool */
  inputctl = (my_inputctl_ptr)
    (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
				SIZEOF(my_input_controller));
  cinfo-&gt;inputctl = (struct jpeg_input_controller *) inputctl;
  /* Initialize method pointers */
  inputctl-&gt;pub.consume_input = consume_markers;
  inputctl-&gt;pub.reset_input_controller = reset_input_controller;
  inputctl-&gt;pub.start_input_pass = start_input_pass;
  inputctl-&gt;pub.finish_input_pass = finish_input_pass;
  /* Initialize state: can't use reset_input_controller since we don't
   * want to try to reset other modules yet.
   */
  inputctl-&gt;pub.has_multiple_scans = FALSE; /* "unknown" would be better */
  inputctl-&gt;pub.eoi_reached = FALSE;
  inputctl-&gt;inheaders = TRUE;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

