<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/jpeg/jdmaster.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/jpeg/jdmaster.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * jdmaster.c
 *
 * Copyright (C) 1991-1997, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file contains master control logic for the JPEG decompressor.
 * These routines are concerned with selecting the modules to be executed
 * and with determining the number of passes and the work to be done in each
 * pass.
 */

#define JPEG_INTERNALS
#include "jinclude.h"
#include "jpeglib.h"


/* Private state */

typedef struct {
  struct jpeg_decomp_master pub; /* public fields */

  int pass_number;		/* # of passes completed */

  boolean using_merged_upsample; /* TRUE if using merged upsample/cconvert */

  /* Saved references to initialized quantizer modules,
   * in case we need to switch modes.
   */
  struct jpeg_color_quantizer * quantizer_1pass;
  struct jpeg_color_quantizer * quantizer_2pass;
} my_decomp_master;

typedef my_decomp_master * my_master_ptr;


/*
 * Determine whether merged upsample/color conversion should be used.
 * CRUCIAL: this must match the actual capabilities of jdmerge.c!
 */

LOCAL(boolean)
use_merged_upsample (j_decompress_ptr cinfo)
{
#ifdef UPSAMPLE_MERGING_SUPPORTED
  /* Merging is the equivalent of plain box-filter upsampling */
  if (cinfo-&gt;do_fancy_upsampling || cinfo-&gt;CCIR601_sampling)
    return FALSE;
  /* jdmerge.c only supports YCC=&gt;RGB color conversion */
  if (cinfo-&gt;jpeg_color_space != JCS_YCbCr || cinfo-&gt;num_components != 3 ||
      cinfo-&gt;out_color_space != JCS_RGB ||
      cinfo-&gt;out_color_components != RGB_PIXELSIZE)
    return FALSE;
  /* and it only handles 2h1v or 2h2v sampling ratios */
  if (cinfo-&gt;comp_info[0].h_samp_factor != 2 ||
      cinfo-&gt;comp_info[1].h_samp_factor != 1 ||
      cinfo-&gt;comp_info[2].h_samp_factor != 1 ||
      cinfo-&gt;comp_info[0].v_samp_factor &gt;  2 ||
      cinfo-&gt;comp_info[1].v_samp_factor != 1 ||
      cinfo-&gt;comp_info[2].v_samp_factor != 1)
    return FALSE;
  /* furthermore, it doesn't work if we've scaled the IDCTs differently */
  if (cinfo-&gt;comp_info[0].DCT_scaled_size != cinfo-&gt;min_DCT_scaled_size ||
      cinfo-&gt;comp_info[1].DCT_scaled_size != cinfo-&gt;min_DCT_scaled_size ||
      cinfo-&gt;comp_info[2].DCT_scaled_size != cinfo-&gt;min_DCT_scaled_size)
    return FALSE;
  /* ??? also need to test for upsample-time rescaling, when &amp; if supported */
  return TRUE;			/* by golly, it'll work... */
#else
  return FALSE;
#endif
}


/*
 * Compute output image dimensions and related values.
 * NOTE: this is exported for possible use by application.
 * Hence it mustn't do anything that can't be done twice.
 * Also note that it may be called before the master module is initialized!
 */

GLOBAL(void)
jpeg_calc_output_dimensions (j_decompress_ptr cinfo)
/* Do computations that are needed before master selection phase */
{
#ifdef IDCT_SCALING_SUPPORTED
  int ci;
  jpeg_component_info *compptr;
#endif

  /* Prevent application from calling me at wrong times */
  if (cinfo-&gt;global_state != DSTATE_READY)
    ERREXIT1(cinfo, JERR_BAD_STATE, cinfo-&gt;global_state);

#ifdef IDCT_SCALING_SUPPORTED

  /* Compute actual output image dimensions and DCT scaling choices. */
  if (cinfo-&gt;scale_num * 8 &lt;= cinfo-&gt;scale_denom) {
    /* Provide 1/8 scaling */
    cinfo-&gt;output_width = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width, 8L);
    cinfo-&gt;output_height = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height, 8L);
    cinfo-&gt;min_DCT_scaled_size = 1;
  } else if (cinfo-&gt;scale_num * 4 &lt;= cinfo-&gt;scale_denom) {
    /* Provide 1/4 scaling */
    cinfo-&gt;output_width = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width, 4L);
    cinfo-&gt;output_height = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height, 4L);
    cinfo-&gt;min_DCT_scaled_size = 2;
  } else if (cinfo-&gt;scale_num * 2 &lt;= cinfo-&gt;scale_denom) {
    /* Provide 1/2 scaling */
    cinfo-&gt;output_width = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width, 2L);
    cinfo-&gt;output_height = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height, 2L);
    cinfo-&gt;min_DCT_scaled_size = 4;
  } else {
    /* Provide 1/1 scaling */
    cinfo-&gt;output_width = cinfo-&gt;image_width;
    cinfo-&gt;output_height = cinfo-&gt;image_height;
    cinfo-&gt;min_DCT_scaled_size = DCTSIZE;
  }
  /* In selecting the actual DCT scaling for each component, we try to
   * scale up the chroma components via IDCT scaling rather than upsampling.
   * This saves time if the upsampler gets to use 1:1 scaling.
   * Note this code assumes that the supported DCT scalings are powers of 2.
   */
  for (ci = 0, compptr = cinfo-&gt;comp_info; ci &lt; cinfo-&gt;num_components;
       ci++, compptr++) {
    int ssize = cinfo-&gt;min_DCT_scaled_size;
    while (ssize &lt; DCTSIZE &amp;&amp;
	   (compptr-&gt;h_samp_factor * ssize * 2 &lt;=
	    cinfo-&gt;max_h_samp_factor * cinfo-&gt;min_DCT_scaled_size) &amp;&amp;
	   (compptr-&gt;v_samp_factor * ssize * 2 &lt;=
	    cinfo-&gt;max_v_samp_factor * cinfo-&gt;min_DCT_scaled_size)) {
      ssize = ssize * 2;
    }
    compptr-&gt;DCT_scaled_size = ssize;
  }

  /* Recompute downsampled dimensions of components;
   * application needs to know these if using raw downsampled data.
   */
  for (ci = 0, compptr = cinfo-&gt;comp_info; ci &lt; cinfo-&gt;num_components;
       ci++, compptr++) {
    /* Size in samples, after IDCT scaling */
    compptr-&gt;downsampled_width = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_width *
		    (long) (compptr-&gt;h_samp_factor * compptr-&gt;DCT_scaled_size),
		    (long) (cinfo-&gt;max_h_samp_factor * DCTSIZE));
    compptr-&gt;downsampled_height = (JDIMENSION)
      jdiv_round_up((long) cinfo-&gt;image_height *
		    (long) (compptr-&gt;v_samp_factor * compptr-&gt;DCT_scaled_size),
		    (long) (cinfo-&gt;max_v_samp_factor * DCTSIZE));
  }

#else /* !IDCT_SCALING_SUPPORTED */

  /* Hardwire it to "no scaling" */
  cinfo-&gt;output_width = cinfo-&gt;image_width;
  cinfo-&gt;output_height = cinfo-&gt;image_height;
  /* jdinput.c has already initialized DCT_scaled_size to DCTSIZE,
   * and has computed unscaled downsampled_width and downsampled_height.
   */

#endif /* IDCT_SCALING_SUPPORTED */

  /* Report number of components in selected colorspace. */
  /* Probably this should be in the color conversion module... */
  switch (cinfo-&gt;out_color_space) {
  case JCS_GRAYSCALE:
    cinfo-&gt;out_color_components = 1;
    break;
  case JCS_RGB:
#if RGB_PIXELSIZE != 3
    cinfo-&gt;out_color_components = RGB_PIXELSIZE;
    break;
#endif /* else share code with YCbCr */
  case JCS_YCbCr:
    cinfo-&gt;out_color_components = 3;
    break;
  case JCS_CMYK:
  case JCS_YCCK:
    cinfo-&gt;out_color_components = 4;
    break;
  default:			/* else must be same colorspace as in file */
    cinfo-&gt;out_color_components = cinfo-&gt;num_components;
    break;
  }
  cinfo-&gt;output_components = (cinfo-&gt;quantize_colors ? 1 :
			      cinfo-&gt;out_color_components);

  /* See if upsampler will want to emit more than one row at a time */
  if (use_merged_upsample(cinfo))
    cinfo-&gt;rec_outbuf_height = cinfo-&gt;max_v_samp_factor;
  else
    cinfo-&gt;rec_outbuf_height = 1;
}


/*
 * Several decompression processes need to range-limit values to the range
 * 0..MAXJSAMPLE; the input value may fall somewhat outside this range
 * due to noise introduced by quantization, roundoff error, etc.  These
 * processes are inner loops and need to be as fast as possible.  On most
 * machines, particularly CPUs with pipelines or instruction prefetch,
 * a (subscript-check-less) C table lookup
 *		x = sample_range_limit[x];
 * is faster than explicit tests
 *		if (x &lt; 0)  x = 0;
 *		else if (x &gt; MAXJSAMPLE)  x = MAXJSAMPLE;
 * These processes all use a common table prepared by the routine below.
 *
 * For most steps we can mathematically guarantee that the initial value
 * of x is within MAXJSAMPLE+1 of the legal range, so a table running from
 * -(MAXJSAMPLE+1) to 2*MAXJSAMPLE+1 is sufficient.  But for the initial
 * limiting step (just after the IDCT), a wildly out-of-range value is 
 * possible if the input data is corrupt.  To avoid any chance of indexing
 * off the end of memory and getting a bad-pointer trap, we perform the
 * post-IDCT limiting thus:
 *		x = range_limit[x &amp; MASK];
 * where MASK is 2 bits wider than legal sample data, ie 10 bits for 8-bit
 * samples.  Under normal circumstances this is more than enough range and
 * a correct output will be generated; with bogus input data the mask will
 * cause wraparound, and we will safely generate a bogus-but-in-range output.
 * For the post-IDCT step, we want to convert the data from signed to unsigned
 * representation by adding CENTERJSAMPLE at the same time that we limit it.
 * So the post-IDCT limiting table ends up looking like this:
 *   CENTERJSAMPLE,CENTERJSAMPLE+1,...,MAXJSAMPLE,
 *   MAXJSAMPLE (repeat 2*(MAXJSAMPLE+1)-CENTERJSAMPLE times),
 *   0          (repeat 2*(MAXJSAMPLE+1)-CENTERJSAMPLE times),
 *   0,1,...,CENTERJSAMPLE-1
 * Negative inputs select values from the upper half of the table after
 * masking.
 *
 * We can save some space by overlapping the start of the post-IDCT table
 * with the simpler range limiting table.  The post-IDCT table begins at
 * sample_range_limit + CENTERJSAMPLE.
 *
 * Note that the table is allocated in near data space on PCs; it's small
 * enough and used often enough to justify this.
 */

LOCAL(void)
prepare_range_limit_table (j_decompress_ptr cinfo)
/* Allocate and fill in the sample_range_limit table */
{
  JSAMPLE * table;
  int i;

  table = (JSAMPLE *)
    (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
		(5 * (MAXJSAMPLE+1) + CENTERJSAMPLE) * SIZEOF(JSAMPLE));
  table += (MAXJSAMPLE+1);	/* allow negative subscripts of simple table */
  cinfo-&gt;sample_range_limit = table;
  /* First segment of "simple" table: limit[x] = 0 for x &lt; 0 */
  MEMZERO(table - (MAXJSAMPLE+1), (MAXJSAMPLE+1) * SIZEOF(JSAMPLE));
  /* Main part of "simple" table: limit[x] = x */
  for (i = 0; i &lt;= MAXJSAMPLE; i++)
    table[i] = (JSAMPLE) i;
  table += CENTERJSAMPLE;	/* Point to where post-IDCT table starts */
  /* End of simple table, rest of first half of post-IDCT table */
  for (i = CENTERJSAMPLE; i &lt; 2*(MAXJSAMPLE+1); i++)
    table[i] = MAXJSAMPLE;
  /* Second half of post-IDCT table */
  MEMZERO(table + (2 * (MAXJSAMPLE+1)),
	  (2 * (MAXJSAMPLE+1) - CENTERJSAMPLE) * SIZEOF(JSAMPLE));
  MEMCOPY(table + (4 * (MAXJSAMPLE+1) - CENTERJSAMPLE),
	  cinfo-&gt;sample_range_limit, CENTERJSAMPLE * SIZEOF(JSAMPLE));
}


/*
 * Master selection of decompression modules.
 * This is done once at jpeg_start_decompress time.  We determine
 * which modules will be used and give them appropriate initialization calls.
 * We also initialize the decompressor input side to begin consuming data.
 *
 * Since jpeg_read_header has finished, we know what is in the SOF
 * and (first) SOS markers.  We also have all the application parameter
 * settings.
 */

LOCAL(void)
master_selection (j_decompress_ptr cinfo)
{
  my_master_ptr master = (my_master_ptr) cinfo-&gt;master;
  boolean use_c_buffer;
  long samplesperrow;
  JDIMENSION jd_samplesperrow;

  /* Initialize dimensions and other stuff */
  jpeg_calc_output_dimensions(cinfo);
  prepare_range_limit_table(cinfo);

  /* Width of an output scanline must be representable as JDIMENSION. */
  samplesperrow = (long) cinfo-&gt;output_width * (long) cinfo-&gt;out_color_components;
  jd_samplesperrow = (JDIMENSION) samplesperrow;
  if ((long) jd_samplesperrow != samplesperrow)
    ERREXIT(cinfo, JERR_WIDTH_OVERFLOW);

  /* Initialize my private state */
  master-&gt;pass_number = 0;
  master-&gt;using_merged_upsample = use_merged_upsample(cinfo);

  /* Color quantizer selection */
  master-&gt;quantizer_1pass = NULL;
  master-&gt;quantizer_2pass = NULL;
  /* No mode changes if not using buffered-image mode. */
  if (! cinfo-&gt;quantize_colors || ! cinfo-&gt;buffered_image) {
    cinfo-&gt;enable_1pass_quant = FALSE;
    cinfo-&gt;enable_external_quant = FALSE;
    cinfo-&gt;enable_2pass_quant = FALSE;
  }
  if (cinfo-&gt;quantize_colors) {
    if (cinfo-&gt;raw_data_out)
      ERREXIT(cinfo, JERR_NOTIMPL);
    /* 2-pass quantizer only works in 3-component color space. */
    if (cinfo-&gt;out_color_components != 3) {
      cinfo-&gt;enable_1pass_quant = TRUE;
      cinfo-&gt;enable_external_quant = FALSE;
      cinfo-&gt;enable_2pass_quant = FALSE;
      cinfo-&gt;colormap = NULL;
    } else if (cinfo-&gt;colormap != NULL) {
      cinfo-&gt;enable_external_quant = TRUE;
    } else if (cinfo-&gt;two_pass_quantize) {
      cinfo-&gt;enable_2pass_quant = TRUE;
    } else {
      cinfo-&gt;enable_1pass_quant = TRUE;
    }

    if (cinfo-&gt;enable_1pass_quant) {
#ifdef QUANT_1PASS_SUPPORTED
      jinit_1pass_quantizer(cinfo);
      master-&gt;quantizer_1pass = cinfo-&gt;cquantize;
#else
      ERREXIT(cinfo, JERR_NOT_COMPILED);
#endif
    }

    /* We use the 2-pass code to map to external colormaps. */
    if (cinfo-&gt;enable_2pass_quant || cinfo-&gt;enable_external_quant) {
#ifdef QUANT_2PASS_SUPPORTED
      jinit_2pass_quantizer(cinfo);
      master-&gt;quantizer_2pass = cinfo-&gt;cquantize;
#else
      ERREXIT(cinfo, JERR_NOT_COMPILED);
#endif
    }
    /* If both quantizers are initialized, the 2-pass one is left active;
     * this is necessary for starting with quantization to an external map.
     */
  }

  /* Post-processing: in particular, color conversion first */
  if (! cinfo-&gt;raw_data_out) {
    if (master-&gt;using_merged_upsample) {
#ifdef UPSAMPLE_MERGING_SUPPORTED
      jinit_merged_upsampler(cinfo); /* does color conversion too */
#else
      ERREXIT(cinfo, JERR_NOT_COMPILED);
#endif
    } else {
      jinit_color_deconverter(cinfo);
      jinit_upsampler(cinfo);
    }
    jinit_d_post_controller(cinfo, cinfo-&gt;enable_2pass_quant);
  }
  /* Inverse DCT */
  jinit_inverse_dct(cinfo);
  /* Entropy decoding: either Huffman or arithmetic coding. */
  if (cinfo-&gt;arith_code) {
    ERREXIT(cinfo, JERR_ARITH_NOTIMPL);
  } else {
    if (cinfo-&gt;progressive_mode) {
#ifdef D_PROGRESSIVE_SUPPORTED
      jinit_phuff_decoder(cinfo);
#else
      ERREXIT(cinfo, JERR_NOT_COMPILED);
#endif
    } else
      jinit_huff_decoder(cinfo);
  }

  /* Initialize principal buffer controllers. */
  use_c_buffer = cinfo-&gt;inputctl-&gt;has_multiple_scans || cinfo-&gt;buffered_image;
  jinit_d_coef_controller(cinfo, use_c_buffer);

  if (! cinfo-&gt;raw_data_out)
    jinit_d_main_controller(cinfo, FALSE /* never need full buffer here */);

  /* We can now tell the memory manager to allocate virtual arrays. */
  (*cinfo-&gt;mem-&gt;realize_virt_arrays) ((j_common_ptr) cinfo);

  /* Initialize input side of decompressor to consume first scan. */
  (*cinfo-&gt;inputctl-&gt;start_input_pass) (cinfo);

#ifdef D_MULTISCAN_FILES_SUPPORTED
  /* If jpeg_start_decompress will read the whole file, initialize
   * progress monitoring appropriately.  The input step is counted
   * as one pass.
   */
  if (cinfo-&gt;progress != NULL &amp;&amp; ! cinfo-&gt;buffered_image &amp;&amp;
      cinfo-&gt;inputctl-&gt;has_multiple_scans) {
    int nscans;
    /* Estimate number of scans to set pass_limit. */
    if (cinfo-&gt;progressive_mode) {
      /* Arbitrarily estimate 2 interleaved DC scans + 3 AC scans/component. */
      nscans = 2 + 3 * cinfo-&gt;num_components;
    } else {
      /* For a nonprogressive multiscan file, estimate 1 scan per component. */
      nscans = cinfo-&gt;num_components;
    }
    cinfo-&gt;progress-&gt;pass_counter = 0L;
    cinfo-&gt;progress-&gt;pass_limit = (long) cinfo-&gt;total_iMCU_rows * nscans;
    cinfo-&gt;progress-&gt;completed_passes = 0;
    cinfo-&gt;progress-&gt;total_passes = (cinfo-&gt;enable_2pass_quant ? 3 : 2);
    /* Count the input pass as done */
    master-&gt;pass_number++;
  }
#endif /* D_MULTISCAN_FILES_SUPPORTED */
}


/*
 * Per-pass setup.
 * This is called at the beginning of each output pass.  We determine which
 * modules will be active during this pass and give them appropriate
 * start_pass calls.  We also set is_dummy_pass to indicate whether this
 * is a "real" output pass or a dummy pass for color quantization.
 * (In the latter case, jdapistd.c will crank the pass to completion.)
 */

METHODDEF(void)
prepare_for_output_pass (j_decompress_ptr cinfo)
{
  my_master_ptr master = (my_master_ptr) cinfo-&gt;master;

  if (master-&gt;pub.is_dummy_pass) {
#ifdef QUANT_2PASS_SUPPORTED
    /* Final pass of 2-pass quantization */
    master-&gt;pub.is_dummy_pass = FALSE;
    (*cinfo-&gt;cquantize-&gt;start_pass) (cinfo, FALSE);
    (*cinfo-&gt;post-&gt;start_pass) (cinfo, JBUF_CRANK_DEST);
    (*cinfo-&gt;main-&gt;start_pass) (cinfo, JBUF_CRANK_DEST);
#else
    ERREXIT(cinfo, JERR_NOT_COMPILED);
#endif /* QUANT_2PASS_SUPPORTED */
  } else {
    if (cinfo-&gt;quantize_colors &amp;&amp; cinfo-&gt;colormap == NULL) {
      /* Select new quantization method */
      if (cinfo-&gt;two_pass_quantize &amp;&amp; cinfo-&gt;enable_2pass_quant) {
	cinfo-&gt;cquantize = master-&gt;quantizer_2pass;
	master-&gt;pub.is_dummy_pass = TRUE;
      } else if (cinfo-&gt;enable_1pass_quant) {
	cinfo-&gt;cquantize = master-&gt;quantizer_1pass;
      } else {
	ERREXIT(cinfo, JERR_MODE_CHANGE);
      }
    }
    (*cinfo-&gt;idct-&gt;start_pass) (cinfo);
    (*cinfo-&gt;coef-&gt;start_output_pass) (cinfo);
    if (! cinfo-&gt;raw_data_out) {
      if (! master-&gt;using_merged_upsample)
	(*cinfo-&gt;cconvert-&gt;start_pass) (cinfo);
      (*cinfo-&gt;upsample-&gt;start_pass) (cinfo);
      if (cinfo-&gt;quantize_colors)
	(*cinfo-&gt;cquantize-&gt;start_pass) (cinfo, master-&gt;pub.is_dummy_pass);
      (*cinfo-&gt;post-&gt;start_pass) (cinfo,
	    (master-&gt;pub.is_dummy_pass ? JBUF_SAVE_AND_PASS : JBUF_PASS_THRU));
      (*cinfo-&gt;main-&gt;start_pass) (cinfo, JBUF_PASS_THRU);
    }
  }

  /* Set up progress monitor's pass info if present */
  if (cinfo-&gt;progress != NULL) {
    cinfo-&gt;progress-&gt;completed_passes = master-&gt;pass_number;
    cinfo-&gt;progress-&gt;total_passes = master-&gt;pass_number +
				    (master-&gt;pub.is_dummy_pass ? 2 : 1);
    /* In buffered-image mode, we assume one more output pass if EOI not
     * yet reached, but no more passes if EOI has been reached.
     */
    if (cinfo-&gt;buffered_image &amp;&amp; ! cinfo-&gt;inputctl-&gt;eoi_reached) {
      cinfo-&gt;progress-&gt;total_passes += (cinfo-&gt;enable_2pass_quant ? 2 : 1);
    }
  }
}


/*
 * Finish up at end of an output pass.
 */

METHODDEF(void)
finish_output_pass (j_decompress_ptr cinfo)
{
  my_master_ptr master = (my_master_ptr) cinfo-&gt;master;

  if (cinfo-&gt;quantize_colors)
    (*cinfo-&gt;cquantize-&gt;finish_pass) (cinfo);
  master-&gt;pass_number++;
}


#ifdef D_MULTISCAN_FILES_SUPPORTED

/*
 * Switch to a new external colormap between output passes.
 */

GLOBAL(void)
jpeg_new_colormap (j_decompress_ptr cinfo)
{
  my_master_ptr master = (my_master_ptr) cinfo-&gt;master;

  /* Prevent application from calling me at wrong times */
  if (cinfo-&gt;global_state != DSTATE_BUFIMAGE)
    ERREXIT1(cinfo, JERR_BAD_STATE, cinfo-&gt;global_state);

  if (cinfo-&gt;quantize_colors &amp;&amp; cinfo-&gt;enable_external_quant &amp;&amp;
      cinfo-&gt;colormap != NULL) {
    /* Select 2-pass quantizer for external colormap use */
    cinfo-&gt;cquantize = master-&gt;quantizer_2pass;
    /* Notify quantizer of colormap change */
    (*cinfo-&gt;cquantize-&gt;new_color_map) (cinfo);
    master-&gt;pub.is_dummy_pass = FALSE; /* just in case */
  } else
    ERREXIT(cinfo, JERR_MODE_CHANGE);
}

#endif /* D_MULTISCAN_FILES_SUPPORTED */


/*
 * Initialize master decompression control and select active modules.
 * This is performed at the start of jpeg_start_decompress.
 */

GLOBAL(void)
jinit_master_decompress (j_decompress_ptr cinfo)
{
  my_master_ptr master;

  master = (my_master_ptr)
      (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				  SIZEOF(my_decomp_master));
  cinfo-&gt;master = (struct jpeg_decomp_master *) master;
  master-&gt;pub.prepare_for_output_pass = prepare_for_output_pass;
  master-&gt;pub.finish_output_pass = finish_output_pass;

  master-&gt;pub.is_dummy_pass = FALSE;

  master_selection(cinfo);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

