<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/dxmain.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/dxmain.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2001 Ghostgum Software Pty Ltd.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: dxmain.c,v 1.15 2004/09/14 06:42:32 ghostgum Exp $ */

/* dxmain.c */
/* 
 * Ghostscript frontend which provides a graphical window 
 * using Gtk+.  Load time linking to libgs.so 
 * Compile using
 *    gcc `gtk-config --cflags` -o gs dxmain.c -lgs `gtk-config --libs`
 *
 * The ghostscript library needs to be compiled with
 *  gcc -fPIC -g -c -Wall file.c
 *  gcc -shared -Wl,-soname,libgs.so.6 -o libgs.so.6.60 file.o -lc
 */

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;unistd.h&gt;
#include &lt;fcntl.h&gt;
#include &lt;gtk/gtk.h&gt;
#define __PROTOTYPES__
#include "ierrors.h"
#include "iapi.h"
#include "gdevdsp.h"

const char start_string[] = "systemdict /start get exec\n";

static void read_stdin_handler(gpointer data, gint fd, 
	GdkInputCondition condition);
static int gsdll_stdin(void *instance, char *buf, int len);
static int gsdll_stdout(void *instance, const char *str, int len);
static int gsdll_stdout(void *instance, const char *str, int len);
static int display_open(void *handle, void *device);
static int display_preclose(void *handle, void *device);
static int display_close(void *handle, void *device);
static int display_presize(void *handle, void *device, int width, int height, 
	int raster, unsigned int format);
static int display_size(void *handle, void *device, int width, int height, 
	int raster, unsigned int format, unsigned char *pimage);
static int display_sync(void *handle, void *device);
static int display_page(void *handle, void *device, int copies, int flush);
static int display_update(void *handle, void *device, int x, int y, 
	int w, int h);

#ifndef min
#define min(a,b) ((a) &lt; (b) ? (a) : (b))
#endif

/*********************************************************************/
/* stdio functions */

struct stdin_buf {
   char *buf;
   int len;	/* length of buffer */
   int count;	/* number of characters returned */
};

/* handler for reading non-blocking stdin */
static void 
read_stdin_handler(gpointer data, gint fd, GdkInputCondition condition)
{
    struct stdin_buf *input = (struct stdin_buf *)data;

    if (condition &amp; GDK_INPUT_EXCEPTION) {
	g_print("input exception");
	input-&gt;count = 0;	/* EOF */
    }
    else if (condition &amp; GDK_INPUT_READ) {
	/* read returns -1 for error, 0 for EOF and +ve for OK */
	input-&gt;count = read(fd, input-&gt;buf, input-&gt;len);
	if (input-&gt;count &lt; 0)
	    input-&gt;count = 0;
    }
    else {
	g_print("input condition unknown");
	input-&gt;count = 0;	/* EOF */
    }
}

/* callback for reading stdin */
static int 
gsdll_stdin(void *instance, char *buf, int len)
{
    struct stdin_buf input;
    gint input_tag;

    input.len = len;
    input.buf = buf;
    input.count = -1;

    input_tag = gdk_input_add(fileno(stdin), 
	(GdkInputCondition)(GDK_INPUT_READ | GDK_INPUT_EXCEPTION),
	read_stdin_handler, &amp;input);
    while (input.count &lt; 0)
	gtk_main_iteration_do(TRUE);
    gdk_input_remove(input_tag);

    return input.count;
}

static int 
gsdll_stdout(void *instance, const char *str, int len)
{
    gtk_main_iteration_do(FALSE);
    fwrite(str, 1, len, stdout);
    fflush(stdout);
    return len;
}

static int 
gsdll_stderr(void *instance, const char *str, int len)
{
    gtk_main_iteration_do(FALSE);
    fwrite(str, 1, len, stderr);
    fflush(stderr);
    return len;
}

/*********************************************************************/
/* dll display device */

typedef struct IMAGE_DEVICEN_S IMAGE_DEVICEN;
struct IMAGE_DEVICEN_S {
    int used;		/* non-zero if in use */
    int visible;	/* show on window */
    char name[64];
    int cyan;
    int magenta;
    int yellow;
    int black;
    int menu;		/* non-zero if menu item added to system menu */
};
#define IMAGE_DEVICEN_MAX 8

typedef struct IMAGE_S IMAGE;
struct IMAGE_S {
    void *handle;
    void *device;
    GtkWidget *window;
    GtkWidget *vbox;
    GtkWidget *cmyk_bar;
    GtkWidget *separation[IMAGE_DEVICEN_MAX];
    GtkWidget *show_as_gray;
    GtkWidget *scroll;
    GtkWidget *darea;
    guchar *buf;
    gint width;
    gint height;
    gint rowstride;
    unsigned int format;
    GdkRgbCmap *cmap;
    int devicen_gray;	/* true if a single separation should be shown gray */
    IMAGE_DEVICEN devicen[IMAGE_DEVICEN_MAX];
    guchar *rgbbuf;	/* used when we need to convert raster format */
    IMAGE *next;
};

IMAGE *first_image;
static IMAGE *image_find(void *handle, void *device);
static void window_destroy(GtkWidget *w, gpointer data);
static void window_create(IMAGE *img);
static void window_resize(IMAGE *img);
static gboolean window_draw(GtkWidget *widget, GdkEventExpose *event, gpointer user_data);

static IMAGE *
image_find(void *handle, void *device)
{
    IMAGE *img;
    for (img = first_image; img!=0; img=img-&gt;next) {
	if ((img-&gt;handle == handle) &amp;&amp; (img-&gt;device == device))
	    return img;
    }
    return NULL;
}



static gboolean
window_draw(GtkWidget *widget, GdkEventExpose *event, gpointer user_data)
{
    IMAGE *img = (IMAGE *)user_data;
    if (img &amp;&amp; img-&gt;window &amp;&amp; img-&gt;buf) {
        int color = img-&gt;format &amp; DISPLAY_COLORS_MASK;
	int depth = img-&gt;format &amp; DISPLAY_DEPTH_MASK;
	int x, y, width, height;
	if (event-&gt;area.x + event-&gt;area.width &gt; img-&gt;width) {
	    x = img-&gt;width;
	    width = (event-&gt;area.x + event-&gt;area.width) - x;
	    y = event-&gt;area.y;
            height = min(img-&gt;height, event-&gt;area.y + event-&gt;area.height) - y;
	    gdk_window_clear_area(widget-&gt;window, x, y, width, height);
	}
	if (event-&gt;area.y + event-&gt;area.height &gt; img-&gt;height) {
	    x = event-&gt;area.x;
	    width = event-&gt;area.width;
	    y = img-&gt;height;
	    height = (event-&gt;area.y + event-&gt;area.height) - y;
	    gdk_window_clear_area(widget-&gt;window, x, y, width, height);
	}
	x = event-&gt;area.x;
	y = event-&gt;area.y;
	width = event-&gt;area.width;
	height = event-&gt;area.height;
	if ((x&gt;=0) &amp;&amp; (y&gt;=0) &amp;&amp; (x &lt; img-&gt;width) &amp;&amp; (y &lt; img-&gt;height)) {
	    /* drawing area intersects bitmap */
	    if (x + width &gt; img-&gt;width)
		width = img-&gt;width - x;
	    if (y + height &gt; img-&gt;height)
		height =  img-&gt;height - y;
	    switch (color) {
		case DISPLAY_COLORS_NATIVE:
		    if (depth == DISPLAY_DEPTH_8)
			gdk_draw_indexed_image(widget-&gt;window, 
			    widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
			    x, y, width, height, 
			    GDK_RGB_DITHER_MAX, 
			    img-&gt;buf + x + y*img-&gt;rowstride, 
			    img-&gt;rowstride, img-&gt;cmap);
		    else if ((depth == DISPLAY_DEPTH_16) &amp;&amp; img-&gt;rgbbuf)
			gdk_draw_rgb_image(widget-&gt;window, 
			    widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
			    x, y, width, height, 
			    GDK_RGB_DITHER_MAX, 
			    img-&gt;rgbbuf + x*3 + y*img-&gt;width*3, 
			    img-&gt;width * 3);
		    break;
		case DISPLAY_COLORS_GRAY:
		    if (depth == DISPLAY_DEPTH_8)
			gdk_draw_gray_image(widget-&gt;window, 
			    widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
			    x, y, width, height,
			    GDK_RGB_DITHER_MAX, 
			    img-&gt;buf + x + y*img-&gt;rowstride, 
			    img-&gt;rowstride);
		    break;
		case DISPLAY_COLORS_RGB:
		    if (depth == DISPLAY_DEPTH_8) {
			if (img-&gt;rgbbuf)
			    gdk_draw_rgb_image(widget-&gt;window, 
				widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
				x, y, width, height,
				GDK_RGB_DITHER_MAX, 
				img-&gt;rgbbuf + x*3 + y*img-&gt;width*3, 
				img-&gt;width * 3);
			else
			    gdk_draw_rgb_image(widget-&gt;window, 
				widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
				x, y, width, height,
				GDK_RGB_DITHER_MAX, 
				img-&gt;buf + x*3 + y*img-&gt;rowstride, 
				img-&gt;rowstride);
		    }
		    break;
		case DISPLAY_COLORS_CMYK:
		    if (((depth == DISPLAY_DEPTH_1) || 
		        (depth == DISPLAY_DEPTH_8)) &amp;&amp; img-&gt;rgbbuf)
			gdk_draw_rgb_image(widget-&gt;window, 
			    widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
			    x, y, width, height,
			    GDK_RGB_DITHER_MAX, 
			    img-&gt;rgbbuf + x*3 + y*img-&gt;width*3, 
			    img-&gt;width * 3);
		    break;
		case DISPLAY_COLORS_SEPARATION:
		    if ((depth == DISPLAY_DEPTH_8) &amp;&amp; img-&gt;rgbbuf)
			gdk_draw_rgb_image(widget-&gt;window, 
			    widget-&gt;style-&gt;fg_gc[GTK_STATE_NORMAL],
			    x, y, width, height,
			    GDK_RGB_DITHER_MAX, 
			    img-&gt;rgbbuf + x*3 + y*img-&gt;width*3, 
			    img-&gt;width * 3);
		    break;
	    }
	}
    }
    return TRUE;
}

static void window_destroy(GtkWidget *w, gpointer data)
{
    IMAGE *img = (IMAGE *)data;
    img-&gt;window = NULL;
    img-&gt;scroll = NULL;
    img-&gt;darea = NULL;
}

static void window_create(IMAGE *img)
{
    /* Create a gtk window */
    img-&gt;window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(img-&gt;window), "gs");
    img-&gt;vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(img-&gt;window), img-&gt;vbox);
    gtk_widget_show(img-&gt;vbox);

    img-&gt;darea = gtk_drawing_area_new();
    gtk_widget_show(img-&gt;darea);
    img-&gt;scroll = gtk_scrolled_window_new(NULL, NULL);
    gtk_widget_show(img-&gt;scroll);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(img-&gt;scroll),
	GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(img-&gt;scroll),
	img-&gt;darea);
    gtk_box_pack_start(GTK_BOX(img-&gt;vbox), img-&gt;scroll, TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT (img-&gt;darea), "expose-event",
                        GTK_SIGNAL_FUNC (window_draw), img);
    gtk_signal_connect(GTK_OBJECT (img-&gt;window), "destroy", 
			GTK_SIGNAL_FUNC (window_destroy), img);
    /* do not show img-&gt;window until we know the image size */
}

static void window_resize(IMAGE *img)
{
    gtk_drawing_area_size(GTK_DRAWING_AREA (img-&gt;darea), 
	img-&gt;width, img-&gt;height);
    if (!(GTK_WIDGET_FLAGS(img-&gt;window) &amp; GTK_VISIBLE)) {
	/* We haven't yet shown the window, so set a default size 
	 * which is smaller than the desktop to allow room for 
	 * desktop toolbars, and if possible a little larger than 
	 * the image to allow room for the scroll bars.
	 * We don't know the width of the scroll bars, so just guess. */
	gtk_window_set_default_size(GTK_WINDOW(img-&gt;window), 
	    min(gdk_screen_width()-96, img-&gt;width+24),
	    min(gdk_screen_height()-96, img-&gt;height+24));
    }
}

static void window_separation(IMAGE *img, int sep)
{
    img-&gt;devicen[sep].visible = !img-&gt;devicen[sep].visible;
    display_sync(img-&gt;handle, img-&gt;device);
}

static void signal_sep0(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 0);
}

static void signal_sep1(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 1);
}

static void signal_sep2(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 2);
}

static void signal_sep3(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 3);
}

static void signal_sep4(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 4);
}

static void signal_sep5(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 5);
}

static void signal_sep6(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 6);
}

static void signal_sep7(GtkWidget *w, gpointer data)
{
    window_separation((IMAGE *)data, 7);
}

GtkSignalFunc signal_separation[IMAGE_DEVICEN_MAX] = {
    signal_sep0, 
    signal_sep1, 
    signal_sep2, 
    signal_sep3, 
    signal_sep4, 
    signal_sep5, 
    signal_sep6, 
    signal_sep7
};

static GtkWidget *
window_add_button(IMAGE *img, const char *label, GtkSignalFunc fn)
{
    GtkWidget *w;
    w = gtk_check_button_new_with_label(label);
    gtk_box_pack_start(GTK_BOX(img-&gt;cmyk_bar), w, FALSE, FALSE, 5);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), TRUE);
    gtk_signal_connect(GTK_OBJECT(w), "clicked", fn, img);
    gtk_widget_show(w);
    return w;
}

static void signal_show_as_gray(GtkWidget *w, gpointer data)
{
    IMAGE *img= (IMAGE *)data;
    img-&gt;devicen_gray= !img-&gt;devicen_gray;
    display_sync(img-&gt;handle, img-&gt;device);
}


/* New device has been opened */
static int display_open(void *handle, void *device)
{

    IMAGE *img = (IMAGE *)malloc(sizeof(IMAGE));
    if (img == NULL)
	return -1;
    memset(img, 0, sizeof(IMAGE));

    if (first_image == NULL) {
	gdk_rgb_init();
	gtk_widget_set_default_colormap(gdk_rgb_get_cmap());
	gtk_widget_set_default_visual(gdk_rgb_get_visual());
    }

    /* add to list */
    if (first_image)
	img-&gt;next = first_image;
    first_image = img;

    /* remember device and handle */
    img-&gt;handle = handle;
    img-&gt;device = device;

    /* create window */
    window_create(img);

    gtk_main_iteration_do(FALSE);
    return 0;
}

static int display_preclose(void *handle, void *device)
{
    IMAGE *img = image_find(handle, device);
    if (img == NULL)
	return -1;

    gtk_main_iteration_do(FALSE);

    img-&gt;buf = NULL;
    img-&gt;width = 0;
    img-&gt;height = 0;
    img-&gt;rowstride = 0;
    img-&gt;format = 0;

    gtk_widget_destroy(img-&gt;window);
    img-&gt;window = NULL;
    img-&gt;scroll = NULL;
    img-&gt;darea = NULL;
    if (img-&gt;cmap)
	gdk_rgb_cmap_free(img-&gt;cmap);
    img-&gt;cmap = NULL;
    if (img-&gt;rgbbuf)
	free(img-&gt;rgbbuf);
    img-&gt;rgbbuf = NULL;

    gtk_main_iteration_do(FALSE);

    return 0;
}

static int display_close(void *handle, void *device)
{
    IMAGE *img = image_find(handle, device);
    if (img == NULL)
	return -1;

    /* remove from list */
    if (img == first_image) {
	first_image = img-&gt;next;
    }
    else {
	IMAGE *tmp;
	for (tmp = first_image; tmp!=0; tmp=tmp-&gt;next) {
	    if (img == tmp-&gt;next)
		tmp-&gt;next = img-&gt;next;
	}
    }

    return 0;
}

static int display_presize(void *handle, void *device, int width, int height, 
	int raster, unsigned int format)
{
    /* Assume everything is OK.
     * It would be better to return e_rangecheck if we can't 
     * support the format.
     */
    return 0;
}
   
static int display_size(void *handle, void *device, int width, int height, 
	int raster, unsigned int format, unsigned char *pimage)
{
    IMAGE *img = image_find(handle, device);
    int color;
    int depth;
    int i;
    if (img == NULL)
	return -1;

    if (img-&gt;cmap)
	gdk_rgb_cmap_free(img-&gt;cmap);
    img-&gt;cmap = NULL;
    if (img-&gt;rgbbuf)
	free(img-&gt;rgbbuf);
    img-&gt;rgbbuf = NULL;

    img-&gt;width = width;
    img-&gt;height = height;
    img-&gt;rowstride = raster;
    img-&gt;buf = pimage;
    img-&gt;format = format;

    /* Reset separations */
    for (i=0; i&lt;IMAGE_DEVICEN_MAX; i++) {
	img-&gt;devicen[i].used = 0;
	img-&gt;devicen[i].visible = 1;
	memset(img-&gt;devicen[i].name, 0, sizeof(img-&gt;devicen[i].name));
	img-&gt;devicen[i].cyan = 0;
	img-&gt;devicen[i].magenta = 0;
	img-&gt;devicen[i].yellow = 0;
	img-&gt;devicen[i].black = 0;
    }

    color = img-&gt;format &amp; DISPLAY_COLORS_MASK;
    depth = img-&gt;format &amp; DISPLAY_DEPTH_MASK;
    switch (color) {
	case DISPLAY_COLORS_NATIVE:
	    if (depth == DISPLAY_DEPTH_8) {
		/* palette of 96 colors */
		guint32 color[96];
		int i;
		int one = 255 / 3;
		for (i=0; i&lt;96; i++) {
		    /* 0-&gt;63 = 00RRGGBB, 64-&gt;95 = 010YYYYY */
		    if (i &lt; 64) {
			color[i] = 
			    (((i &amp; 0x30) &gt;&gt; 4) * one &lt;&lt; 16) + 	/* r */
			    (((i &amp; 0x0c) &gt;&gt; 2) * one &lt;&lt; 8) + 	/* g */
			    (i &amp; 0x03) * one;		        /* b */
		    }
		    else {
			int val = i &amp; 0x1f;
			val = (val &lt;&lt; 3) + (val &gt;&gt; 2);
			color[i] = (val &lt;&lt; 16) + (val &lt;&lt; 8) + val;
		    }
		}
		img-&gt;cmap = gdk_rgb_cmap_new(color, 96);
		break;
	    }
	    else if (depth == DISPLAY_DEPTH_16) {
		/* need to convert to 24RGB */
		img-&gt;rgbbuf = (guchar *)malloc(width * height * 3);
		if (img-&gt;rgbbuf == NULL)
		    return -1;
	    }
	    else
		return e_rangecheck;	/* not supported */
	case DISPLAY_COLORS_GRAY:
	    if (depth == DISPLAY_DEPTH_8)
		break;
	    else
		return -1;	/* not supported */
	case DISPLAY_COLORS_RGB:
	    if (depth == DISPLAY_DEPTH_8) {
		if (((img-&gt;format &amp; DISPLAY_ALPHA_MASK) == DISPLAY_ALPHA_NONE)
		    &amp;&amp; ((img-&gt;format &amp; DISPLAY_ENDIAN_MASK) 
			== DISPLAY_BIGENDIAN))
		    break;
		else {
		    /* need to convert to 24RGB */
		    img-&gt;rgbbuf = (guchar *)malloc(width * height * 3);
		    if (img-&gt;rgbbuf == NULL)
			return -1;
		}
	    }
	    else
		return -1;	/* not supported */
	    break;
	case DISPLAY_COLORS_CMYK:
	    if ((depth == DISPLAY_DEPTH_1) || (depth == DISPLAY_DEPTH_8)) {
		/* need to convert to 24RGB */
		img-&gt;rgbbuf = (guchar *)malloc(width * height * 3);
		if (img-&gt;rgbbuf == NULL)
		    return -1;
		/* We already know about the CMYK components */
		img-&gt;devicen[0].used = 1;
		img-&gt;devicen[0].cyan = 65535;
		strncpy(img-&gt;devicen[0].name, "Cyan", 
		    sizeof(img-&gt;devicen[0].name));
		img-&gt;devicen[1].used = 1;
		img-&gt;devicen[1].magenta = 65535;
		strncpy(img-&gt;devicen[1].name, "Magenta", 
		    sizeof(img-&gt;devicen[1].name));
		img-&gt;devicen[2].used = 1;
		img-&gt;devicen[2].yellow = 65535;
		strncpy(img-&gt;devicen[2].name, "Yellow", 
		    sizeof(img-&gt;devicen[2].name));
		img-&gt;devicen[3].used = 1;
		img-&gt;devicen[3].black = 65535;
		strncpy(img-&gt;devicen[3].name, "Black", 
		    sizeof(img-&gt;devicen[3].name));
	    }
	    else
		return -1;	/* not supported */
	    break;
	case DISPLAY_COLORS_SEPARATION:
	    /* we can't display this natively */
	    /* we will convert it just before displaying */
	    if (depth != DISPLAY_DEPTH_8)
		return -1;	/* not supported */
	    img-&gt;rgbbuf = (guchar *)malloc(width * height * 3);
	    if (img-&gt;rgbbuf == NULL)
		return -1;
	    break;
    }


    if ((color == DISPLAY_COLORS_CMYK) || 
	(color == DISPLAY_COLORS_SEPARATION)) {
	if (!img-&gt;cmyk_bar) {
	    /* add bar to select separation */
	    img-&gt;cmyk_bar = gtk_hbox_new(FALSE, 0);
	    gtk_box_pack_start(GTK_BOX(img-&gt;vbox), img-&gt;cmyk_bar, 
		FALSE, FALSE, 0);
	    for (i=0; i&lt;IMAGE_DEVICEN_MAX; i++) {
	       img-&gt;separation[i] = 
		window_add_button(img, img-&gt;devicen[i].name,
		   signal_separation[i]);
	    }
	    img-&gt;show_as_gray = gtk_check_button_new_with_label("Show as Gray");
	    gtk_box_pack_end(GTK_BOX(img-&gt;cmyk_bar), img-&gt;show_as_gray, 
		FALSE, FALSE, 5);
	    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(img-&gt;show_as_gray), 
		FALSE);
	    gtk_signal_connect(GTK_OBJECT(img-&gt;show_as_gray), "clicked", 
		signal_show_as_gray, img);
	    gtk_widget_show(img-&gt;show_as_gray);
	}
	gtk_widget_show(img-&gt;cmyk_bar);
    }
    else {
	if (img-&gt;cmyk_bar)
	    gtk_widget_hide(img-&gt;cmyk_bar);
    }

    window_resize(img);
    if (!(GTK_WIDGET_FLAGS(img-&gt;window) &amp; GTK_VISIBLE))
	gtk_widget_show(img-&gt;window);

    gtk_main_iteration_do(FALSE);
    return 0;
}
   
static int display_sync(void *handle, void *device)
{
    IMAGE *img = image_find(handle, device);
    int color;
    int depth;
    int endian;
    int native555;
    int alpha;
    if (img == NULL)
	return -1;

    color = img-&gt;format &amp; DISPLAY_COLORS_MASK;
    depth = img-&gt;format &amp; DISPLAY_DEPTH_MASK;
    endian = img-&gt;format &amp; DISPLAY_ENDIAN_MASK;
    native555 = img-&gt;format &amp; DISPLAY_555_MASK;
    alpha = img-&gt;format &amp; DISPLAY_ALPHA_MASK;

    if ((color == DISPLAY_COLORS_CMYK) ||
	(color == DISPLAY_COLORS_SEPARATION)) {
	/* check if separations have changed */
	int i;
	int num_visible = 0;
	gchar *str;
	for (i=0; i&lt;IMAGE_DEVICEN_MAX; i++) {
	    gtk_label_get(
		GTK_LABEL(GTK_BIN(img-&gt;separation[i])-&gt;child), &amp;str);
	    if (!img-&gt;devicen[i].used)
		gtk_widget_hide(img-&gt;separation[i]);
	    else if (strcmp(img-&gt;devicen[i].name, str) != 0) {
		/* text has changed, update it */
		gtk_label_set_text(
		    GTK_LABEL(GTK_BIN(img-&gt;separation[i])-&gt;child),
		    img-&gt;devicen[i].name);
		gtk_widget_show(img-&gt;separation[i]);
	    }
	    if (img-&gt;devicen[i].used &amp;&amp; img-&gt;devicen[i].visible)
		num_visible++;
	}
	if (num_visible &lt;= 1)
	    gtk_widget_show(img-&gt;separation[i]);
	else
	    gtk_widget_hide(img-&gt;separation[i]);
    }
		
    /* some formats need to be converted for use by GdkRgb */
    switch (color) {
	case DISPLAY_COLORS_NATIVE:
	    if (depth == DISPLAY_DEPTH_16) {
	      if (endian == DISPLAY_LITTLEENDIAN) {
		if (native555 == DISPLAY_NATIVE_555) {
		    /* BGR555 */
		    int x, y;
		    unsigned short w;
		    unsigned char value;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    w = s[0] + (s[1] &lt;&lt; 8);
			    value = (w &gt;&gt; 10) &amp; 0x1f;	/* red */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    value = (w &gt;&gt; 5) &amp; 0x1f;	/* green */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    value = w &amp; 0x1f;		/* blue */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    s += 2;
			}
		    }
		}
		else {
		    /* BGR565 */
		    int x, y;
		    unsigned short w;
		    unsigned char value;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    w = s[0] + (s[1] &lt;&lt; 8);
			    value = (w &gt;&gt; 11) &amp; 0x1f;	/* red */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    value = (w &gt;&gt; 5) &amp; 0x3f;	/* green */
			    *d++ = (value &lt;&lt; 2) + (value &gt;&gt; 4);
			    value = w &amp; 0x1f;		/* blue */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    s += 2;
			}
		    }
		}
	      }
	      else {
		if (native555 == DISPLAY_NATIVE_555) {
		    /* RGB555 */
		    int x, y;
		    unsigned short w;
		    unsigned char value;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    w = s[1] + (s[0] &lt;&lt; 8);
			    value = (w &gt;&gt; 10) &amp; 0x1f;	/* red */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    value = (w &gt;&gt; 5) &amp; 0x1f;	/* green */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    value = w &amp; 0x1f;		/* blue */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    s += 2;
			}
		    }
		}
		else {
		    /* RGB565 */
		    int x, y;
		    unsigned short w;
		    unsigned char value;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    w = s[1] + (s[0] &lt;&lt; 8);
			    value = (w &gt;&gt; 11) &amp; 0x1f;	/* red */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    value = (w &gt;&gt; 5) &amp; 0x3f;	/* green */
			    *d++ = (value &lt;&lt; 2) + (value &gt;&gt; 4);
			    value = w &amp; 0x1f;		/* blue */
			    *d++ = (value &lt;&lt; 3) + (value &gt;&gt; 2);
			    s += 2;
			}
		    }
		}
	      }
	    }
	    break;
	case DISPLAY_COLORS_RGB:
	    if ( (depth == DISPLAY_DEPTH_8) &amp;&amp; 
		 ((alpha == DISPLAY_ALPHA_FIRST) || 
	          (alpha == DISPLAY_UNUSED_FIRST)) &amp;&amp;
		 (endian == DISPLAY_BIGENDIAN) ) {
		/* Mac format */
		int x, y;
		unsigned char *s, *d;
		for (y = 0; y&lt;img-&gt;height; y++) {
		    s = img-&gt;buf + y * img-&gt;rowstride;
		    d = img-&gt;rgbbuf + y * img-&gt;width * 3;
		    for (x=0; x&lt;img-&gt;width; x++) {
			s++;		/* x = filler */
			*d++ = *s++;	/* r */
			*d++ = *s++;	/* g */
			*d++ = *s++;	/* b */
		    }
		}
	    }
	    else if ( (depth == DISPLAY_DEPTH_8) &amp;&amp;
		      (endian == DISPLAY_LITTLEENDIAN) ) {
	        if ((alpha == DISPLAY_UNUSED_LAST) ||
	            (alpha == DISPLAY_ALPHA_LAST)) {
		    /* Windows format + alpha = BGRx */
		    int x, y;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    *d++ = s[2];	/* r */
			    *d++ = s[1];	/* g */
			    *d++ = s[0];	/* b */
			    s += 4;
			}
		    }
		}
	        else if ((alpha == DISPLAY_UNUSED_FIRST) ||
	            (alpha == DISPLAY_ALPHA_FIRST)) {
		    /* xBGR */
		    int x, y;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    *d++ = s[3];	/* r */
			    *d++ = s[2];	/* g */
			    *d++ = s[1];	/* b */
			    s += 4;
			}
		    }
		}
		else {
		    /* Windows BGR24 */
		    int x, y;
		    unsigned char *s, *d;
		    for (y = 0; y&lt;img-&gt;height; y++) {
			s = img-&gt;buf + y * img-&gt;rowstride;
			d = img-&gt;rgbbuf + y * img-&gt;width * 3;
			for (x=0; x&lt;img-&gt;width; x++) {
			    *d++ = s[2];	/* r */
			    *d++ = s[1];	/* g */
			    *d++ = s[0];	/* b */
			    s += 3;
			}
		    }
		}
	    }
	    break;
	case DISPLAY_COLORS_CMYK:
	    if (depth == DISPLAY_DEPTH_8) {
	    	/* Separations */
		int x, y;
		int cyan, magenta, yellow, black;
		unsigned char *s, *d;
		int vc = img-&gt;devicen[0].visible;
		int vm = img-&gt;devicen[1].visible;
		int vy = img-&gt;devicen[2].visible;
		int vk = img-&gt;devicen[3].visible;
		int vall = vc &amp;&amp; vm &amp;&amp; vy &amp;&amp; vk;
		int show_gray = (vc + vm + vy + vk == 1) &amp;&amp; img-&gt;devicen_gray;
		for (y = 0; y&lt;img-&gt;height; y++) {
		    s = img-&gt;buf + y * img-&gt;rowstride;
		    d = img-&gt;rgbbuf + y * img-&gt;width * 3;
		    for (x=0; x&lt;img-&gt;width; x++) {
			cyan = *s++;
			magenta = *s++;
			yellow = *s++;
			black = *s++;
			if (!vall) {
			    if (!vc)
				cyan = 0;
			    if (!vm)
				magenta = 0;
			    if (!vy)
				yellow = 0;
			    if (!vk)
				black = 0;
			    if (show_gray) {
				black += cyan + magenta + yellow;
				cyan = magenta = yellow = 0;
			    }
			}
			*d++ = (255-cyan)    * (255-black) / 255; /* r */
			*d++ = (255-magenta) * (255-black) / 255; /* g */
			*d++ = (255-yellow)  * (255-black) / 255; /* b */
		    }
		}
	    }
	    else if (depth == DISPLAY_DEPTH_1) {
	    	/* Separations */
		int x, y;
		int cyan, magenta, yellow, black;
		unsigned char *s, *d;
		int vc = img-&gt;devicen[0].visible;
		int vm = img-&gt;devicen[1].visible;
		int vy = img-&gt;devicen[2].visible;
		int vk = img-&gt;devicen[3].visible;
		int vall = vc &amp;&amp; vm &amp;&amp; vy &amp;&amp; vk;
		int show_gray = (vc + vm + vy + vk == 1) &amp;&amp; img-&gt;devicen_gray;
		int value;
		for (y = 0; y&lt;img-&gt;height; y++) {
		    s = img-&gt;buf + y * img-&gt;rowstride;
		    d = img-&gt;rgbbuf + y * img-&gt;width * 3;
		    for (x=0; x&lt;img-&gt;width; x++) {
			value = s[x/2];
			if (x &amp; 0)
			    value &gt;&gt;= 4;
			cyan = ((value &gt;&gt; 3) &amp; 1) * 255;
			magenta = ((value &gt;&gt; 2) &amp; 1) * 255;
			yellow = ((value &gt;&gt; 1) &amp; 1) * 255;
			black = (value &amp; 1) * 255;
			if (!vall) {
			    if (!vc)
				cyan = 0;
			    if (!vm)
				magenta = 0;
			    if (!vy)
				yellow = 0;
			    if (!vk)
				black = 0;
			    if (show_gray) {
				black += cyan + magenta + yellow;
				cyan = magenta = yellow = 0;
			    }
			}
			*d++ = (255-cyan)    * (255-black) / 255; /* r */
			*d++ = (255-magenta) * (255-black) / 255; /* g */
			*d++ = (255-yellow)  * (255-black) / 255; /* b */
		    }
		}
	    }
	    break;
	case DISPLAY_COLORS_SEPARATION:
	    if (depth == DISPLAY_DEPTH_8) {
		int j;
		int x, y;
		unsigned char *s, *d;
		int cyan, magenta, yellow, black;
		int num_comp = 0;
		int value;
		int num_visible = 0;
		int show_gray = 0;
	        IMAGE_DEVICEN *devicen = img-&gt;devicen;
		for (j=0; j&lt;IMAGE_DEVICEN_MAX; j++) {
		    if (img-&gt;devicen[j].used) {
		       num_comp = j+1;
		       if (img-&gt;devicen[j].visible)
			    num_visible++;
		    }
		}
		if ((num_visible == 1) &amp;&amp; img-&gt;devicen_gray)
		    show_gray = 1;

		for (y = 0; y&lt;img-&gt;height; y++) {
		    s = img-&gt;buf + y * img-&gt;rowstride;
		    d = img-&gt;rgbbuf + y * img-&gt;width * 3;
		    for (x=0; x&lt;img-&gt;width; x++) {
			cyan = magenta = yellow = black = 0;
			if (show_gray) {
			    for (j=0; j&lt;num_comp; j++) {
				devicen = &amp;img-&gt;devicen[j];
				if (devicen-&gt;visible &amp;&amp; devicen-&gt;used)
				    black += s[j];
			    }
			}
			else {
			    for (j=0; j&lt;num_comp; j++) {
				devicen = &amp;img-&gt;devicen[j];
				if (devicen-&gt;visible &amp;&amp; devicen-&gt;used) {
				    value = s[j];
				    cyan    += value*devicen-&gt;cyan   /65535;
				    magenta += value*devicen-&gt;magenta/65535;
				    yellow  += value*devicen-&gt;yellow /65535;
				    black   += value*devicen-&gt;black  /65535;
				}
			    }
			}
			if (cyan &gt; 255)
			   cyan = 255;
			if (magenta &gt; 255)
			   magenta = 255;
			if (yellow &gt; 255)
			   yellow = 255;
			if (black &gt; 255)
			   black = 255;
			*d++ = (255-cyan)    * (255-black) / 255; /* r */
			*d++ = (255-magenta) * (255-black) / 255; /* g */
			*d++ = (255-yellow)  * (255-black) / 255; /* b */
			s += 8;
		    }
		}
	    }
	    break;
    }

    if (img-&gt;window == NULL) {
	window_create(img);
	window_resize(img);
    }
    if (!(GTK_WIDGET_FLAGS(img-&gt;window) &amp; GTK_VISIBLE))
	gtk_widget_show_all(img-&gt;window);

    gtk_widget_draw(img-&gt;darea, NULL);
    gtk_main_iteration_do(FALSE);
    return 0;
}

static int display_page(void *handle, void *device, int copies, int flush)
{
    display_sync(handle, device);
    return 0;
}

static int display_update(void *handle, void *device, 
    int x, int y, int w, int h)
{
    /* not implemented - eventually this will be used for progressive update */
    return 0;
}


static int 
display_separation(void *handle, void *device,
    int comp_num, const char *name,
    unsigned short c, unsigned short m,
    unsigned short y, unsigned short k)
{
    IMAGE *img = image_find(handle, device);
    if (img == NULL)
	return -1;
    if ((comp_num &lt; 0) || (comp_num &gt; IMAGE_DEVICEN_MAX))
	return -1;
    img-&gt;devicen[comp_num].used = 1;
    strncpy(img-&gt;devicen[comp_num].name, name,
	sizeof(img-&gt;devicen[comp_num].name)-1);
    img-&gt;devicen[comp_num].cyan    = c;
    img-&gt;devicen[comp_num].magenta = m;
    img-&gt;devicen[comp_num].yellow  = y;
    img-&gt;devicen[comp_num].black   = k;
    return 0;
}


/* callback structure for "display" device */
display_callback display = { 
    sizeof(display_callback),
    DISPLAY_VERSION_MAJOR,
    DISPLAY_VERSION_MINOR,
    display_open,
    display_preclose,
    display_close,
    display_presize,
    display_size,
    display_sync,
    display_page,
    display_update,
    NULL,	/* memalloc */
    NULL,	/* memfree */
    display_separation
};

/*********************************************************************/

int main(int argc, char *argv[])
{
    int exit_status;
    int code = 1, code1;
    void *instance;
    int nargc;
    char **nargv;
    char dformat[64];
    int exit_code;
    gboolean use_gui;

    /* Gtk initialisation */
    gtk_set_locale();
    use_gui = gtk_init_check(&amp;argc, &amp;argv);

    /* insert display device parameters as first arguments */
    sprintf(dformat, "-dDisplayFormat=%d", 
 	    DISPLAY_COLORS_RGB | DISPLAY_ALPHA_NONE | DISPLAY_DEPTH_8 | 
	    DISPLAY_BIGENDIAN | DISPLAY_TOPFIRST);
    nargc = argc + 1;
    nargv = (char **)malloc((nargc + 1) * sizeof(char *));
    nargv[0] = argv[0];
    nargv[1] = dformat;
    memcpy(&amp;nargv[2], &amp;argv[1], argc * sizeof(char *));

    /* run Ghostscript */
    if ((code = gsapi_new_instance(&amp;instance, NULL)) == 0) {
        gsapi_set_stdio(instance, gsdll_stdin, gsdll_stdout, gsdll_stderr);
	if (use_gui)
            gsapi_set_display_callback(instance, &amp;display);
	code = gsapi_init_with_args(instance, nargc, nargv);

	if (code == 0)
	    code = gsapi_run_string(instance, start_string, 0, &amp;exit_code);
        code1 = gsapi_exit(instance);
	if (code == 0 || code == e_Quit)
	    code = code1;
	if (code == e_Quit)
	    code = 0;	/* user executed 'quit' */

	gsapi_delete_instance(instance);
    }

    exit_status = 0;
    switch (code) {
	case 0:
	case e_Info:
	case e_Quit:
	    break;
	case e_Fatal:
	    exit_status = 1;
	    break;
	default:
	    exit_status = 255;
    }

    return exit_status;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

