<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevcgml.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevcgml.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 1996, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevcgml.c,v 1.5 2002/06/16 05:48:54 lpd Exp $ */
/* CGM-writing library */
#include "memory_.h"
#include "stdio_.h"
#include "gdevcgmx.h"

/* Forward references to command-writing procedures */
private void begin_command(cgm_state *, cgm_op_index);

#define OP(op) begin_command(st, op)
private cgm_result end_command(cgm_state *);

#define END_OP (void)end_command(st)
#define DONE return end_command(st)
/* Parameters */
private void put_int(cgm_state *, cgm_int, int);

#define CI(ci) put_int(st, ci, st-&gt;metafile.color_index_precision)
#define I(i) put_int(st, i, st-&gt;metafile.integer_precision)
#define IX(ix) put_int(st, ix, st-&gt;metafile.index_precision)
#define E(e) put_int(st, (int)(e), 16)
private void put_real(cgm_state *, cgm_real, const cgm_precision *);

#define R(r) put_real(st, r, &amp;st-&gt;metafile.real_precision)
private void put_vdc(cgm_state *, const cgm_vdc *);

#define VDC(vdc) put_vdc(st, vdc)
#define VDC2(vdc1, vdc2) VDC(vdc1); VDC(vdc2)
#define VDC4(vdc1, vdc2, vdc3, vdc4) VDC2(vdc1, vdc2); VDC2(vdc3, vdc4)
private void put_vdc_r(cgm_state *, const cgm_line_marker_extent *, cgm_line_marker_specification_mode);

#define VDC_R(vdcr, mode) put_vdc_r(st, vdcr, mode)
private void put_point(cgm_state *, const cgm_point *);

#define P(p) put_point(st, p)
private void put_points(cgm_state *, const cgm_point *, int);

#define nP(p, n) put_points(st, p, n)
private void put_string(cgm_state *, const char *, uint);

#define S(s, l) put_string(st, s, l)
private void put_color(cgm_state *, const cgm_color *);

#define CO(co) put_color(st, co)
private void put_rgb(cgm_state *, const cgm_rgb *);

#define CD(cd) put_rgb(st, cd)
/* Other data types */
#define put_byte(st, b)\
  if ( st-&gt;command_count == command_max_count ) write_command(st, false);\
  st-&gt;command[st-&gt;command_count++] = (byte)(b)
private void put_bytes(cgm_state *, const byte *, uint);
private void write_command(cgm_state *, bool);
private void put_real_precision(cgm_state *, const cgm_precision *);

/* ================ Public routines ================ */

/* ---------------- Initialize/terminate ---------------- */

/* Initialize a CGM writer. */
cgm_state *
cgm_initialize(FILE * file, const cgm_allocator * cal)
{
    cgm_state *st = (*cal-&gt;alloc) (cal-&gt;private_data, sizeof(cgm_state));

    if (st == 0)
	return 0;
    st-&gt;file = file;
    st-&gt;allocator = *cal;
    /* Initialize metafile elements. */
    st-&gt;metafile.vdc_type = cgm_vdc_integer;
    st-&gt;metafile.integer_precision = 16;
    st-&gt;metafile.real_precision.representation = cgm_representation_fixed;
    st-&gt;metafile.real_precision.exponent_or_whole_width = 16;
    st-&gt;metafile.real_precision.fraction_width = 16;
    st-&gt;metafile.index_precision = 16;
    st-&gt;metafile.color_precision = 8;
    st-&gt;metafile.color_index_precision = 8;
    st-&gt;metafile.maximum_color_index = 63;
    /* color_value_extent */
    /*st-&gt;metafile.character_coding_announcer = 0; */
    /* Initialize picture elements. */
    st-&gt;picture.scaling_mode = cgm_scaling_abstract;
    st-&gt;picture.color_selection_mode = cgm_color_selection_indexed;
    st-&gt;picture.line_width_specification_mode = cgm_line_marker_absolute;
    st-&gt;picture.marker_size_specification_mode = cgm_line_marker_absolute;
    st-&gt;picture.edge_width_specification_mode = cgm_line_marker_absolute;
    /* vdc_extent */
    /* background_color */
    /* Initialize control elements. */
    st-&gt;vdc_integer_precision = st-&gt;metafile.integer_precision;
    st-&gt;vdc_real_precision = st-&gt;metafile.real_precision;
    st-&gt;transparency = cgm_transparency_on;
    /* clip_rectangle */
    st-&gt;clip_indicator = cgm_clip_on;
    /* Initialize other state elements. */
    st-&gt;line_bundle_index = 1;
    st-&gt;line_type = cgm_line_solid;
    /* line_width */
    /* line_color */
    st-&gt;marker_bundle_index = 1;
    st-&gt;marker_type = cgm_marker_asterisk;
    /* marker_size */
    /* marker_color */
    st-&gt;text_bundle_index = 1;
    st-&gt;text_font_index = 1;
    st-&gt;text_precision = cgm_text_precision_string;
    st-&gt;character_expansion_factor = 1.0;
    st-&gt;character_spacing = 0.0;
    /* text_color */
    /* character_height */
    /* character_orientation */
    st-&gt;text_path = cgm_text_path_right;
    /* text_alignment */
    st-&gt;character_set_index = 1;
    st-&gt;alternate_character_set_index = 1;
    st-&gt;fill_bundle_index = 1;
    st-&gt;interior_style = cgm_interior_style_hollow;
    st-&gt;hatch_index = cgm_hatch_horizontal;
    st-&gt;pattern_index = 1;
    st-&gt;edge_bundle_index = 1;
    st-&gt;edge_type = cgm_edge_solid;
    /* edge_width */
    st-&gt;edge_visibility = false;
    /* fill_reference_point */
    /* pattern_table */
    /* pattern_size */
    /* color_table */
    memset(st-&gt;source_flags, (byte) cgm_aspect_source_individual,
	   sizeof(st-&gt;source_flags));
    return st;
}

/* Terminate a CGM writer. */
cgm_result
cgm_terminate(cgm_state * st)
{
    (*st-&gt;allocator.free) (st-&gt;allocator.private_data, st);
    return cgm_result_ok;
}

/* ---------------- Metafile elements ---------------- */

cgm_result
cgm_BEGIN_METAFILE(cgm_state * st, const char *str, uint len)
{
    OP(BEGIN_METAFILE);
    S(str, len);
    DONE;
}

cgm_result
cgm_set_metafile_elements(cgm_state * st, const cgm_metafile_elements * meta, long mask)
{
    if ((mask &amp; cgm_set_METAFILE_VERSION)) {
	OP(METAFILE_VERSION);
	I(meta-&gt;metafile_version);
	END_OP;
	st-&gt;metafile.metafile_version = meta-&gt;metafile_version;
    }
    if ((mask &amp; cgm_set_METAFILE_DESCRIPTION)) {
	OP(METAFILE_DESCRIPTION);
	S(meta-&gt;metafile_description.chars, meta-&gt;metafile_description.length);
	END_OP;
	st-&gt;metafile.metafile_description = meta-&gt;metafile_description;
    }
    if ((mask &amp; cgm_set_VDC_TYPE)) {
	OP(VDC_TYPE);
	E(meta-&gt;vdc_type);
	END_OP;
	st-&gt;metafile.vdc_type = meta-&gt;vdc_type;
    }
    if ((mask &amp; cgm_set_INTEGER_PRECISION)) {
	OP(INTEGER_PRECISION);
	I(meta-&gt;integer_precision);
	END_OP;
	st-&gt;metafile.integer_precision = meta-&gt;integer_precision;
    }
    if ((mask &amp; cgm_set_REAL_PRECISION)) {
	OP(REAL_PRECISION);
	put_real_precision(st, &amp;meta-&gt;real_precision);
	END_OP;
	st-&gt;metafile.real_precision = meta-&gt;real_precision;
    }
    if ((mask &amp; cgm_set_INDEX_PRECISION)) {
	OP(INDEX_PRECISION);
	I(meta-&gt;index_precision);
	END_OP;
	st-&gt;metafile.index_precision = meta-&gt;index_precision;
    }
    if ((mask &amp; cgm_set_COLOR_PRECISION)) {
	OP(COLOR_PRECISION);
	I(meta-&gt;color_precision);
	END_OP;
	st-&gt;metafile.color_index_precision = meta-&gt;color_index_precision;
    }
    if ((mask &amp; cgm_set_COLOR_INDEX_PRECISION)) {
	OP(COLOR_INDEX_PRECISION);
	I(meta-&gt;color_index_precision);
	END_OP;
	st-&gt;metafile.color_index_precision = meta-&gt;color_index_precision;
    }
    if ((mask &amp; cgm_set_MAXIMUM_COLOR_INDEX)) {
	OP(MAXIMUM_COLOR_INDEX);
	CI(meta-&gt;maximum_color_index);
	END_OP;
	st-&gt;metafile.maximum_color_index = meta-&gt;maximum_color_index;
    }
    if ((mask &amp; cgm_set_METAFILE_ELEMENT_LIST)) {
	int i;
	const int *p;

	OP(METAFILE_ELEMENT_LIST);
	for (i = 0, p = meta-&gt;metafile_element_list;
	     i &lt; meta-&gt;metafile_element_list_count;
	     i++, p += 2
	    ) {
	    I(p[0]);
	    I(p[1]);
	}
	END_OP;
	st-&gt;metafile.metafile_element_list =
	    meta-&gt;metafile_element_list;
	st-&gt;metafile.metafile_element_list_count =
	    meta-&gt;metafile_element_list_count;
    }
    /* element list */
    if ((mask &amp; cgm_set_FONT_LIST)) {
	int i;

	OP(FONT_LIST);
	for (i = 0; i &lt; meta-&gt;font_list_count; ++i)
	    S(meta-&gt;font_list[i].chars, meta-&gt;font_list[i].length);
	END_OP;
	st-&gt;metafile.font_list = meta-&gt;font_list;
	st-&gt;metafile.font_list_count = meta-&gt;font_list_count;
    }
    /* character set list */
    /* character coding announcer */
    return st-&gt;result;
}

cgm_result
cgm_END_METAFILE(cgm_state * st)
{
    OP(END_METAFILE);
    DONE;
}

/* ---------------- Picture elements ---------------- */

cgm_result
cgm_BEGIN_PICTURE(cgm_state * st, const char *str, uint len)
{
    OP(BEGIN_PICTURE);
    S(str, len);
    DONE;
}

cgm_result
cgm_set_picture_elements(cgm_state * st, const cgm_picture_elements * pic, long mask)
{
    if ((mask &amp; cgm_set_SCALING_MODE)) {
	OP(SCALING_MODE);
	E(pic-&gt;scaling_mode);
	R(pic-&gt;scale_factor);
	st-&gt;picture.scaling_mode = pic-&gt;scaling_mode;
	st-&gt;picture.scale_factor = pic-&gt;scale_factor;
	END_OP;
    }
    if ((mask &amp; cgm_set_COLOR_SELECTION_MODE)) {
	OP(COLOR_SELECTION_MODE);
	E(pic-&gt;color_selection_mode);
	END_OP;
	st-&gt;picture.color_selection_mode = pic-&gt;color_selection_mode;
    }
    if ((mask &amp; cgm_set_LINE_WIDTH_SPECIFICATION_MODE)) {
	OP(LINE_WIDTH_SPECIFICATION_MODE);
	E(pic-&gt;line_width_specification_mode);
	END_OP;
	st-&gt;picture.line_width_specification_mode = pic-&gt;line_width_specification_mode;
    }
    if ((mask &amp; cgm_set_MARKER_SIZE_SPECIFICATION_MODE)) {
	OP(MARKER_SIZE_SPECIFICATION_MODE);
	E(pic-&gt;marker_size_specification_mode);
	END_OP;
	st-&gt;picture.marker_size_specification_mode = pic-&gt;marker_size_specification_mode;
    }
    if ((mask &amp; cgm_set_EDGE_WIDTH_SPECIFICATION_MODE)) {
	OP(EDGE_WIDTH_SPECIFICATION_MODE);
	E(pic-&gt;edge_width_specification_mode);
	END_OP;
	st-&gt;picture.edge_width_specification_mode = pic-&gt;edge_width_specification_mode;
    }
    if ((mask &amp; cgm_set_VDC_EXTENT)) {
	OP(VDC_EXTENT);
	P(&amp;pic-&gt;vdc_extent[0]);
	P(&amp;pic-&gt;vdc_extent[1]);
	END_OP;
	st-&gt;picture.vdc_extent[0] = pic-&gt;vdc_extent[0];
	st-&gt;picture.vdc_extent[1] = pic-&gt;vdc_extent[1];
    }
    if ((mask &amp; cgm_set_BACKGROUND_COLOR)) {
	OP(BACKGROUND_COLOR);
	CD(&amp;pic-&gt;background_color.rgb);
	DONE;
	st-&gt;picture.background_color = pic-&gt;background_color;
    }
    return st-&gt;result;
}

cgm_result
cgm_BEGIN_PICTURE_BODY(cgm_state * st)
{
    OP(BEGIN_PICTURE_BODY);
    DONE;
}

cgm_result
cgm_END_PICTURE(cgm_state * st)
{
    OP(END_PICTURE);
    DONE;
}

/* ---------------- Control elements ---------------- */

cgm_result
cgm_VDC_INTEGER_PRECISION(cgm_state * st, int precision)
{
    if (st-&gt;vdc_integer_precision != precision) {
	OP(VDC_INTEGER_PRECISION);
	I(precision);
	st-&gt;vdc_integer_precision = precision;
	DONE;
    } else
	return cgm_result_ok;
}

cgm_result
cgm_VDC_REAL_PRECISION(cgm_state * st, const cgm_precision * precision)
{
    OP(VDC_REAL_PRECISION);
    put_real_precision(st, precision);
    st-&gt;vdc_real_precision = *precision;
    DONE;
}

cgm_result
cgm_AUXILIARY_COLOR(cgm_state * st, const cgm_color * color)
{
    OP(AUXILIARY_COLOR);
    CO(color);
    st-&gt;auxiliary_color = *color;
    DONE;
}

cgm_result
cgm_TRANSPARENCY(cgm_state * st, cgm_transparency transparency)
{
    OP(TRANSPARENCY);
    E(transparency);
    st-&gt;transparency = transparency;
    DONE;
}

cgm_result
cgm_CLIP_RECTANGLE(cgm_state * st, const cgm_point rectangle[2])
{
    OP(CLIP_RECTANGLE);
    P(&amp;rectangle[0]);
    st-&gt;clip_rectangle[0] = rectangle[0];
    P(&amp;rectangle[1]);
    st-&gt;clip_rectangle[1] = rectangle[1];
    DONE;
}

cgm_result
cgm_CLIP_INDICATOR(cgm_state * st, cgm_clip_indicator clip)
{
    OP(CLIP_INDICATOR);
    E(clip);
    st-&gt;clip_indicator = clip;
    DONE;
}

/* ---------------- Graphical primitive elements ---------------- */

cgm_result
cgm_POLYLINE(cgm_state * st, const cgm_point * vertices, int count)
{
    OP(POLYLINE);
    nP(vertices, count);
    DONE;
}

cgm_result
cgm_DISJOINT_POLYLINE(cgm_state * st, const cgm_point * endpoints, int count)
{
    OP(DISJOINT_POLYLINE);
    nP(endpoints, count);
    DONE;
}

cgm_result
cgm_POLYMARKER(cgm_state * st, const cgm_point * positions, int count)
{
    OP(POLYMARKER);
    nP(positions, count);
    DONE;
}

cgm_result
cgm_TEXT(cgm_state * st, const cgm_point * position, bool final, const char *str, uint len)
{
    OP(TEXT);
    P(position);
    E(final);
    S(str, len);
    DONE;
}

cgm_result
cgm_RESTRICTED_TEXT(cgm_state * st, const cgm_vdc * delta_width, const cgm_vdc * delta_height, const cgm_point * position, bool final, const char *str, uint len)
{
    OP(RESTRICTED_TEXT);
    VDC2(delta_width, delta_height);
    P(position);
    E(final);
    S(str, len);
    DONE;
}

cgm_result
cgm_APPEND_TEXT(cgm_state * st, bool final, const char *str, uint len)
{
    OP(APPEND_TEXT);
    E(final);
    S(str, len);
    DONE;
}

cgm_result
cgm_POLYGON(cgm_state * st, const cgm_point * vertices, int count)
{
    OP(POLYGON);
    nP(vertices, count);
    DONE;
}

cgm_result
cgm_POLYGON_SET(cgm_state * st, const cgm_polygon_edge * vertices, int count)
{
    int i;

    OP(POLYGON);
    for (i = 0; i &lt; count; ++i) {
	P(&amp;vertices[i].vertex);
	E(vertices[i].edge_out);
    }
    DONE;
}

cgm_result
cgm_CELL_ARRAY(cgm_state * st, const cgm_point * pqr /*[3] */ , cgm_int nx, cgm_int ny, cgm_int local_color_precision, cgm_cell_representation_mode mode, const byte * values, uint source_bit, uint raster)
{
    int precision = local_color_precision;
    int bits_per_pixel;
    uint row_bytes;
    const byte *row = values + (source_bit &gt;&gt; 3);
    int bit = source_bit &amp; 7;
    int y;

    /* Currently we ignore the cell representation_mode, and always */
    /* produce cell arrays in 'packed' format. */
    mode = cgm_cell_mode_packed;
    OP(CELL_ARRAY);
    nP(pqr, 3);
    I(nx);
    I(ny);
    I(local_color_precision);
    E(mode);
    if (precision == 0)
	precision = (st-&gt;picture.color_selection_mode ==
		     cgm_color_selection_indexed ?
		     st-&gt;metafile.color_index_precision :
		     st-&gt;metafile.color_precision);
    bits_per_pixel =
	(st-&gt;picture.color_selection_mode == cgm_color_selection_indexed ?
	 precision : precision * 3);
    row_bytes = (bits_per_pixel * nx + 7) &gt;&gt; 3;
    for (y = 0; y &lt; ny; y++, row += raster) {
	if (bit == 0)
	    put_bytes(st, row, row_bytes);
	else {
	    uint i;

	    for (i = 0; i &lt; row_bytes; i++) {
		byte b = (row[i] &lt;&lt; bit) +
		(row[i + 1] &gt;&gt; (8 - bit));

		put_byte(st, b);
	    }
	}
	if ((row_bytes &amp; 1)) {
	    put_byte(st, 0);
	}
    }
    DONE;
}

cgm_result
cgm_RECTANGLE(cgm_state * st, const cgm_point * corner1, const cgm_point * corner2)
{
    OP(RECTANGLE);
    P(corner1);
    P(corner2);
    DONE;
}

cgm_result
cgm_CIRCLE(cgm_state * st, const cgm_point * center, const cgm_vdc * radius)
{
    OP(CIRCLE);
    P(center);
    VDC(radius);
    DONE;
}

cgm_result
cgm_CIRCULAR_ARC_3_POINT(cgm_state * st, const cgm_point * start, const cgm_point * intermediate, const cgm_point * end)
{
    OP(CIRCULAR_ARC_3_POINT);
    P(start);
    P(intermediate);
    P(end);
    DONE;
}

cgm_result
cgm_CIRCULAR_ARC_3_POINT_CLOSE(cgm_state * st, const cgm_point * start, const cgm_point * intermediate, const cgm_point * end, cgm_arc_closure closure)
{
    OP(CIRCULAR_ARC_3_POINT_CLOSE);
    P(start);
    P(intermediate);
    P(end);
    E(closure);
    DONE;
}

cgm_result
cgm_CIRCULAR_ARC_CENTER(cgm_state * st, const cgm_point * center, const cgm_vdc * dx_start, const cgm_vdc * dy_start, const cgm_vdc * dx_end, const cgm_vdc * dy_end, const cgm_vdc * radius)
{
    OP(CIRCULAR_ARC_CENTER);
    P(center);
    VDC4(dx_start, dy_start, dx_end, dy_end);
    VDC(radius);
    DONE;
}

cgm_result
cgm_CIRCULAR_ARC_CENTER_CLOSE(cgm_state * st, const cgm_point * center, const cgm_vdc * dx_start, const cgm_vdc * dy_start, const cgm_vdc * dx_end, const cgm_vdc * dy_end, const cgm_vdc * radius, cgm_arc_closure closure)
{
    OP(CIRCULAR_ARC_CENTER_CLOSE);
    P(center);
    VDC4(dx_start, dy_start, dx_end, dy_end);
    VDC(radius);
    E(closure);
    DONE;
}

cgm_result
cgm_ELLIPSE(cgm_state * st, const cgm_point * center, const cgm_point * cd1_end, const cgm_point * cd2_end)
{
    OP(ELLIPSE);
    P(center);
    P(cd1_end);
    P(cd2_end);
    DONE;
}

cgm_result
cgm_ELLIPTICAL_ARC(cgm_state * st, const cgm_point * center, const cgm_point * cd1_end, const cgm_point * cd2_end, const cgm_vdc * dx_start, const cgm_vdc * dy_start, const cgm_vdc * dx_end, const cgm_vdc * dy_end)
{
    OP(ELLIPTICAL_ARC);
    P(center);
    P(cd1_end);
    P(cd2_end);
    VDC4(dx_start, dy_start, dx_end, dy_end);
    DONE;
}

cgm_result
cgm_ELLIPTICAL_ARC_CLOSE(cgm_state * st, const cgm_point * center, const cgm_point * cd1_end, const cgm_point * cd2_end, const cgm_vdc * dx_start, const cgm_vdc * dy_start, const cgm_vdc * dx_end, const cgm_vdc * dy_end, cgm_arc_closure closure)
{
    OP(ELLIPTICAL_ARC_CLOSE);
    P(center);
    P(cd1_end);
    P(cd2_end);
    VDC4(dx_start, dy_start, dx_end, dy_end);
    E(closure);
    DONE;
}

/* ---------------- Attribute elements ---------------- */

cgm_result
cgm_LINE_BUNDLE_INDEX(cgm_state * st, cgm_int index)
{
    OP(LINE_BUNDLE_INDEX);
    IX(index);
    st-&gt;line_bundle_index = index;
    DONE;
}

cgm_result
cgm_LINE_TYPE(cgm_state * st, cgm_line_type line_type)
{
    OP(LINE_TYPE);
    IX((int)line_type);
    st-&gt;line_type = line_type;
    DONE;
}

cgm_result
cgm_LINE_WIDTH(cgm_state * st, const cgm_line_width * line_width)
{
    OP(LINE_WIDTH);
    VDC_R(line_width, st-&gt;picture.line_width_specification_mode);
    st-&gt;line_width = *line_width;
    DONE;
}

cgm_result
cgm_LINE_COLOR(cgm_state * st, const cgm_color * color)
{
    OP(LINE_COLOR);
    CO(color);
    st-&gt;line_color = *color;
    DONE;
}

cgm_result
cgm_MARKER_BUNDLE_INDEX(cgm_state * st, cgm_int index)
{
    OP(MARKER_BUNDLE_INDEX);
    IX(index);
    st-&gt;marker_bundle_index = index;
    DONE;
}

cgm_result
cgm_MARKER_TYPE(cgm_state * st, cgm_marker_type marker_type)
{
    OP(MARKER_TYPE);
    IX((int)marker_type);
    st-&gt;marker_type = marker_type;
    DONE;
}

cgm_result
cgm_MARKER_SIZE(cgm_state * st, const cgm_marker_size * marker_size)
{
    OP(MARKER_SIZE);
    VDC_R(marker_size, st-&gt;picture.marker_size_specification_mode);
    st-&gt;marker_size = *marker_size;
    DONE;
}

cgm_result
cgm_MARKER_COLOR(cgm_state * st, const cgm_color * color)
{
    OP(MARKER_COLOR);
    CO(color);
    st-&gt;marker_color = *color;
    DONE;
}

cgm_result
cgm_TEXT_BUNDLE_INDEX(cgm_state * st, cgm_int index)
{
    OP(TEXT_BUNDLE_INDEX);
    IX(index);
    st-&gt;text_bundle_index = index;
    DONE;
}

cgm_result
cgm_TEXT_FONT_INDEX(cgm_state * st, cgm_int index)
{
    OP(TEXT_FONT_INDEX);
    IX(index);
    st-&gt;text_font_index = index;
    DONE;
}

cgm_result
cgm_TEXT_PRECISION(cgm_state * st, cgm_text_precision precision)
{
    OP(TEXT_PRECISION);
    E(precision);
    st-&gt;text_precision = precision;
    DONE;
}

cgm_result
cgm_CHARACTER_EXPANSION_FACTOR(cgm_state * st, cgm_real factor)
{
    OP(CHARACTER_EXPANSION_FACTOR);
    R(factor);
    st-&gt;character_expansion_factor = factor;
    DONE;
}

cgm_result
cgm_CHARACTER_SPACING(cgm_state * st, cgm_real spacing)
{
    OP(CHARACTER_SPACING);
    R(spacing);
    st-&gt;character_spacing = spacing;
    DONE;
}

cgm_result
cgm_TEXT_COLOR(cgm_state * st, const cgm_color * color)
{
    OP(TEXT_COLOR);
    CO(color);
    st-&gt;text_color = *color;
    DONE;
}

cgm_result
cgm_CHARACTER_HEIGHT(cgm_state * st, const cgm_vdc * height)
{
    OP(CHARACTER_HEIGHT);
    VDC(height);
    st-&gt;character_height = *height;
    DONE;
}

cgm_result
cgm_CHARACTER_ORIENTATION(cgm_state * st, const cgm_vdc * x_up, const cgm_vdc * y_up, const cgm_vdc * x_base, const cgm_vdc * y_base)
{
    OP(CHARACTER_ORIENTATION);
    VDC4(x_up, y_up, x_base, y_base);
    st-&gt;character_orientation[0] = *x_up;
    st-&gt;character_orientation[1] = *y_up;
    st-&gt;character_orientation[2] = *x_base;
    st-&gt;character_orientation[3] = *y_base;
    DONE;
}

cgm_result
cgm_TEXT_PATH(cgm_state * st, cgm_text_path text_path)
{
    OP(TEXT_PATH);
    E(text_path);
    st-&gt;text_path = text_path;
    DONE;
}

cgm_result
cgm_TEXT_ALIGNMENT(cgm_state * st, cgm_text_alignment_horizontal align_h, cgm_text_alignment_vertical align_v, cgm_real align_cont_h, cgm_real align_cont_v)
{
    OP(TEXT_ALIGNMENT);
    E(align_h);
    E(align_v);
    R(align_cont_h);
    R(align_cont_v);
    DONE;
}

cgm_result
cgm_CHARACTER_SET_INDEX(cgm_state * st, cgm_int index)
{
    OP(CHARACTER_SET_INDEX);
    IX(index);
    st-&gt;character_set_index = index;
    DONE;
}

/* See gdevcgml.c for why this isn't named cgm_ALTERNATE_.... */
cgm_result
cgm_ALT_CHARACTER_SET_INDEX(cgm_state * st, cgm_int index)
{
    OP(ALTERNATE_CHARACTER_SET_INDEX);
    IX(index);
    st-&gt;alternate_character_set_index = index;
    DONE;
}

cgm_result
cgm_FILL_BUNDLE_INDEX(cgm_state * st, cgm_int index)
{
    OP(FILL_BUNDLE_INDEX);
    IX(index);
    st-&gt;fill_bundle_index = index;
    DONE;
}

cgm_result
cgm_INTERIOR_STYLE(cgm_state * st, cgm_interior_style interior_style)
{
    OP(INTERIOR_STYLE);
    E(interior_style);
    st-&gt;interior_style = interior_style;
    DONE;
}

cgm_result
cgm_FILL_COLOR(cgm_state * st, const cgm_color * color)
{
    OP(FILL_COLOR);
    CO(color);
    st-&gt;fill_color = *color;
    DONE;
}

cgm_result
cgm_HATCH_INDEX(cgm_state * st, cgm_hatch_index hatch_index)
{
    OP(HATCH_INDEX);
    IX((int)hatch_index);
    st-&gt;hatch_index = hatch_index;
    DONE;
}

cgm_result
cgm_PATTERN_INDEX(cgm_state * st, cgm_int index)
{
    OP(PATTERN_INDEX);
    IX(index);
    st-&gt;pattern_index = index;
    DONE;
}

cgm_result
cgm_EDGE_BUNDLE_INDEX(cgm_state * st, cgm_int index)
{
    OP(EDGE_BUNDLE_INDEX);
    IX(index);
    st-&gt;edge_bundle_index = index;
    DONE;
}

cgm_result
cgm_EDGE_TYPE(cgm_state * st, cgm_edge_type edge_type)
{
    OP(EDGE_TYPE);
    IX((int)edge_type);
    st-&gt;edge_type = edge_type;
    DONE;
}

cgm_result
cgm_EDGE_WIDTH(cgm_state * st, const cgm_edge_width * edge_width)
{
    OP(EDGE_WIDTH);
    VDC_R(edge_width, st-&gt;picture.edge_width_specification_mode);
    st-&gt;edge_width = *edge_width;
    DONE;
}

cgm_result
cgm_EDGE_COLOR(cgm_state * st, const cgm_color * color)
{
    OP(EDGE_COLOR);
    CO(color);
    DONE;
}

cgm_result
cgm_EDGE_VISIBILITY(cgm_state * st, bool visibility)
{
    OP(EDGE_VISIBILITY);
    E(visibility);
    st-&gt;edge_visibility = visibility;
    DONE;
}

cgm_result
cgm_FILL_REFERENCE_POINT(cgm_state * st, const cgm_point * reference_point)
{
    OP(FILL_REFERENCE_POINT);
    P(reference_point);
    st-&gt;fill_reference_point = *reference_point;
    DONE;
}

/* PATTERN_TABLE */

cgm_result
cgm_PATTERN_SIZE(cgm_state * st, const cgm_vdc * x_height, const cgm_vdc * y_height, const cgm_vdc * x_width, const cgm_vdc * y_width)
{
    OP(PATTERN_SIZE);
    VDC4(x_height, y_height, x_width, y_width);
    st-&gt;pattern_size[0] = *x_height;
    st-&gt;pattern_size[1] = *y_height;
    st-&gt;pattern_size[2] = *x_width;
    st-&gt;pattern_size[3] = *y_width;
    DONE;
}

cgm_result
cgm_COLOR_TABLE(cgm_state * st, cgm_int index, const cgm_color * values, int count)
{
    int i;

    OP(COLOR_TABLE);
    CI(index);
    for (i = 0; i &lt; count; ++i)
	CD(&amp;values[i].rgb);
    DONE;
}

cgm_result 
cgm_ASPECT_SOURCE_FLAGS(cgm_state * st, const cgm_aspect_source_flag * flags, int count)
{
    int i;

    OP(ASPECT_SOURCE_FLAGS);
    for (i = 0; i &lt; count; ++i) {
	E(flags[i].type);
	E(flags[i].source);
	st-&gt;source_flags[flags[i].type] = (byte) flags[i].source;
    }
    DONE;
}

/* ================ Internal routines ================ */

/* Begin a command. */
private void
begin_command(cgm_state * st, cgm_op_index op)
{
    uint op_word = (uint) op &lt;&lt; cgm_op_id_shift;

    st-&gt;command[0] = (byte) (op_word &gt;&gt; 8);
    st-&gt;command[1] = (byte) (op_word);
    st-&gt;command_count = 4;	/* leave room for extension */
    st-&gt;command_first = true;
    st-&gt;result = cgm_result_ok;
}

/* Write the buffer for a partial command. */
/* Note that we always write an even number of bytes. */
private void
write_command(cgm_state * st, bool last)
{
    byte *command = st-&gt;command;
    int count = st-&gt;command_count;

    if (st-&gt;command_first) {
	if (count &lt;= 34) {
	    command[2] = command[0];
	    command[3] = command[1] + count - 4;
	    command += 2, count -= 2;
	} else {
	    int pcount = count - 4;

	    command[1] |= 31;
	    command[2] = (byte) (pcount &gt;&gt; 8);
	    if (!last)
		command[2] |= 0x80;
	    command[3] = (byte) pcount;
	}
	st-&gt;command_first = false;
    } else {
	int pcount = count - 2;

	command[0] = (byte) (pcount &gt;&gt; 8);
	if (!last)
	    command[0] |= 0x80;
	command[1] = (byte) pcount;
    }
    fwrite(command, sizeof(byte), count + (count &amp; 1), st-&gt;file);
    st-&gt;command_count = 2;	/* leave room for extension header */
    if (ferror(st-&gt;file))
	st-&gt;result = cgm_result_io_error;
}

/* End a command. */
private cgm_result
end_command(cgm_state * st)
{
    write_command(st, true);
    return st-&gt;result;
}

/* Put an integer value. */
private void
put_int(cgm_state * st, cgm_int value, int precision)
{
    switch (precision) {
	case 32:
	    put_byte(st, value &gt;&gt; 24);
	case 24:
	    put_byte(st, value &gt;&gt; 16);
	case 16:
	    put_byte(st, value &gt;&gt; 8);
	case 8:
	    put_byte(st, value);
    }
}

/* Put a real value. */
private void
put_real(cgm_state * st, cgm_real value, const cgm_precision * pr)
{
    if (pr-&gt;representation == cgm_representation_floating) {
    } else {			/* Casting to integer simply discards the fraction, */
	/* so we need to be careful with negative values. */
	long whole = (long)value;
	double fpart;

	if (value &lt; whole)
	    --whole;
	fpart = value - whole;
	put_int(st, whole, pr-&gt;exponent_or_whole_width);
	if (pr-&gt;fraction_width == 16) {
	    uint fraction = (uint) (fpart * (1.0 * 0x10000));

	    put_int(st, fraction, 16);
	} else {		/* pr-&gt;fraction_width == 32 */
	    ulong fraction =
	    (ulong) (fpart * (1.0 * 0x10000 * 0x10000));

	    put_int(st, fraction, 32);
	}
    }
}

/* Put a real precision. */
private void
put_real_precision(cgm_state * st, const cgm_precision * precision)
{
    I((int)precision-&gt;representation);
    I(precision-&gt;exponent_or_whole_width);
    I(precision-&gt;fraction_width);
}

/* Put a VDC. */
private void
put_vdc(cgm_state * st, const cgm_vdc * pvdc)
{
    if (st-&gt;metafile.vdc_type == cgm_vdc_integer)
	put_int(st, pvdc-&gt;integer, st-&gt;vdc_integer_precision);
    else
	put_real(st, pvdc-&gt;real, &amp;st-&gt;vdc_real_precision);
}

/* Put a VDC or a real. */
private void
put_vdc_r(cgm_state * st, const cgm_line_marker_extent * extent,
	  cgm_line_marker_specification_mode mode)
{
    if (mode == cgm_line_marker_absolute)
	VDC(&amp;extent-&gt;absolute);
    else
	R(extent-&gt;scaled);
}

/* Put a point (pair of VDCs). */
private void
put_point(cgm_state * st, const cgm_point * ppt)
{
    if (st-&gt;metafile.vdc_type == cgm_vdc_integer) {
	put_int(st, ppt-&gt;integer.x, st-&gt;vdc_integer_precision);
	put_int(st, ppt-&gt;integer.y, st-&gt;vdc_integer_precision);
    } else {
	put_real(st, ppt-&gt;real.x, &amp;st-&gt;vdc_real_precision);
	put_real(st, ppt-&gt;real.y, &amp;st-&gt;vdc_real_precision);
    }
}

/* Put a list of points. */
private void
put_points(cgm_state * st, const cgm_point * ppt, int count)
{
    int i;

    for (i = 0; i &lt; count; i++)
	P(ppt + i);
}

/* Put bytes. */
private void
put_bytes(cgm_state * st, const byte * data, uint length)
{
    int count;

    while (length &gt; (count = command_max_count - st-&gt;command_count)) {
	memcpy(st-&gt;command + st-&gt;command_count, data, count);
	st-&gt;command_count += count;
	write_command(st, false);
	data += count;
	length -= count;
    }
    memcpy(st-&gt;command + st-&gt;command_count, data, length);
    st-&gt;command_count += length;
}

/* Put a string. */
private void
put_string(cgm_state * st, const char *data, uint length)
{				/* The CGM specification seems to imply that the continuation */
    /* mechanism for commands and the mechanism for strings */
    /* are orthogonal; we take this interpretation. */
    if (length &gt;= 255) {
	put_byte(st, 255);
	while (length &gt; 32767) {
	    put_int(st, 65535, 2);
	    put_bytes(st, (const byte *)data, 32767);
	    data += 32767;
	    length -= 32767;
	}
    }
    put_byte(st, length);
    put_bytes(st, (const byte *)data, length);
}

/* Put a color. */
private void
put_color(cgm_state * st, const cgm_color * color)
{
    if (st-&gt;picture.color_selection_mode == cgm_color_selection_indexed)
	CI(color-&gt;index);
    else
	CD(&amp;color-&gt;rgb);
}

/* Put an RGB value. */
private void
put_rgb(cgm_state * st, const cgm_rgb * rgb)
{
    put_int(st, rgb-&gt;r, st-&gt;metafile.color_precision);
    put_int(st, rgb-&gt;g, st-&gt;metafile.color_precision);
    put_int(st, rgb-&gt;b, st-&gt;metafile.color_precision);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

