<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevmswn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevmswn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1998, 1999, 2000, 2001 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevmswn.c,v 1.12 2004/09/20 22:14:59 dan Exp $ */
/*
 * Microsoft Windows 3.n driver for Ghostscript.
 *
 * Original version by Russell Lang and Maurice Castro with help from
 * Programming Windows, 2nd Ed., Charles Petzold, Microsoft Press;
 * created from gdevbgi.c and gnuplot/term/win.trm 5th June 1992.
 * Extensively modified by L. Peter Deutsch, Aladdin Enterprises.
 */
#include "gdevmswn.h"
#include "gp.h"
#include "gpcheck.h"
#include "gsparam.h"
#include "gdevpccm.h"
#include "gsdll.h"

/* Forward references */
private int win_set_bits_per_pixel(gx_device_win *, int);

#define TIMER_ID 1

/* Open the win driver */
int
win_open(gx_device * dev)
{
    HDC hdc;
    int code;

    if (dev-&gt;width == INITIAL_WIDTH)
	dev-&gt;width = (int)(8.5 * dev-&gt;x_pixels_per_inch);
    if (dev-&gt;height == INITIAL_HEIGHT)
	dev-&gt;height = (int)(11.0 * dev-&gt;y_pixels_per_inch);

    if (wdev-&gt;BitsPerPixel == 0) {
	int depth;

	/* Set parameters that were unknown before opening device */
	/* Find out if the device supports color */
	/* We recognize 1, 4, 8, 16, 24 bit/pixel devices */
	hdc = GetDC(NULL);	/* get hdc for desktop */
	depth = GetDeviceCaps(hdc, PLANES) * GetDeviceCaps(hdc, BITSPIXEL);
	if (depth &gt; 16) {
	    wdev-&gt;BitsPerPixel = 24;
	} else if (depth &gt; 8) {
	    wdev-&gt;BitsPerPixel = 16;
	} else if (depth &gt;= 8) {
	    wdev-&gt;BitsPerPixel = 8;
	} else if (depth &gt;= 4) {
	    wdev-&gt;BitsPerPixel = 4;
	} else {
	    wdev-&gt;BitsPerPixel = 1;
	}
	ReleaseDC(NULL, hdc);
	wdev-&gt;mapped_color_flags = 0;
    }
    if ((code = win_set_bits_per_pixel(wdev, wdev-&gt;BitsPerPixel)) &lt; 0)
	return code;

    if (wdev-&gt;nColors &gt; 0) {
	/* create palette for display */
	if ((wdev-&gt;limgpalette = win_makepalette(wdev))
	    == (LPLOGPALETTE) NULL)
	    return win_nomemory();
	wdev-&gt;himgpalette = CreatePalette(wdev-&gt;limgpalette);
    }
    return 0;
}

/* Make the output appear on the screen. */
int
win_sync_output(gx_device * dev)
{
    if (pgsdll_callback)
	(*pgsdll_callback) (GSDLL_SYNC, (unsigned char *)wdev, 0);
    return (0);
}

/* Make the window visible, and display the output. */
int
win_output_page(gx_device * dev, int copies, int flush)
{
    if (pgsdll_callback)
	(*pgsdll_callback) (GSDLL_PAGE, (unsigned char *)wdev, 0);
    return gx_finish_output_page(dev, copies, flush);;
}

/* Close the win driver */
int
win_close(gx_device * dev)
{
    /* Free resources */
    if (wdev-&gt;nColors &gt; 0) {
	gs_free(dev-&gt;memory, 
		wdev-&gt;mapped_color_flags, 4096, 1, "win_set_bits_per_pixel");
	DeleteObject(wdev-&gt;himgpalette);
	gs_free(dev-&gt;memory, 
		(char *)(wdev-&gt;limgpalette), 1, sizeof(LOGPALETTE) +
		(1 &lt;&lt; (wdev-&gt;color_info.depth)) * sizeof(PALETTEENTRY),
		"win_close");
    }
    return (0);
}

/* Map a r-g-b color to the colors available under Windows */
gx_color_index
win_map_rgb_color(gx_device * dev, const gx_color_value cv[])
{
    gx_color_value r = cv[0];
    gx_color_value g = cv[1];
    gx_color_value b = cv[2];
    switch (wdev-&gt;BitsPerPixel) {
	case 24:
	    return (((unsigned long)b &gt;&gt; (gx_color_value_bits - 8)) &lt;&lt; 16) +
		(((unsigned long)g &gt;&gt; (gx_color_value_bits - 8)) &lt;&lt; 8) +
		(((unsigned long)r &gt;&gt; (gx_color_value_bits - 8)));
	case 16:{
		gx_color_index color = ((r &gt;&gt; (gx_color_value_bits - 5)) &lt;&lt; 11) +
				       ((g &gt;&gt; (gx_color_value_bits - 6)) &lt;&lt; 5) +
				       (b &gt;&gt; (gx_color_value_bits - 5));
#if arch_is_big_endian
		ushort color16 = (ushort)color;
#else
		ushort color16 = (ushort)((color &lt;&lt; 8) | (color &gt;&gt; 8));
#endif
		return color16;
	    }
	case 15:{
		gx_color_index color = ((r &gt;&gt; (gx_color_value_bits - 5)) &lt;&lt; 10) +
				       ((g &gt;&gt; (gx_color_value_bits - 5)) &lt;&lt; 5) +
				       (b &gt;&gt; (gx_color_value_bits - 5));
#if arch_is_big_endian
		ushort color15 = (ushort)color;
#else
		ushort color15 = (ushort)((color &lt;&lt; 8) | (color &gt;&gt; 8));
#endif
		return color15;
	    }
	case 8:{
		int i;
		LPLOGPALETTE lpal = wdev-&gt;limgpalette;
		PALETTEENTRY *pep;
		byte cr, cg, cb;
		int mc_index;
		byte mc_mask;

		/* Check for a color in the palette of 64. */
		{
		    static const byte pal64[32] =
		    {
			1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			1
		    };

		    if (pal64[r &gt;&gt; (gx_color_value_bits - 5)] &amp;&amp;
			pal64[g &gt;&gt; (gx_color_value_bits - 5)] &amp;&amp;
			pal64[b &gt;&gt; (gx_color_value_bits - 5)]
			)
			return (gx_color_index) (
				   ((r &gt;&gt; (gx_color_value_bits - 2)) &lt;&lt; 4) +
				   ((g &gt;&gt; (gx_color_value_bits - 2)) &lt;&lt; 2) +
					    (b &gt;&gt; (gx_color_value_bits - 2))
			    );
		}

		/* map colors to 0-&gt;255 in 32 steps */
		cr = win_color_value(r);
		cg = win_color_value(g);
		cb = win_color_value(b);

		/* Search in palette, skipping the first 64. */
		mc_index = ((cr &gt;&gt; 3) &lt;&lt; 7) + ((cg &gt;&gt; 3) &lt;&lt; 2) + (cb &gt;&gt; 6);
		mc_mask = 0x80 &gt;&gt; ((cb &gt;&gt; 3) &amp; 7);
		if (wdev-&gt;mapped_color_flags[mc_index] &amp; mc_mask)
		    for (i = wdev-&gt;nColors, pep = &amp;lpal-&gt;palPalEntry[i];
			 --pep, --i &gt;= 64;
			) {
			if (cr == pep-&gt;peRed &amp;&amp;
			    cg == pep-&gt;peGreen &amp;&amp;
			    cb == pep-&gt;peBlue
			    )
			    return ((gx_color_index) i);	/* found it */
		    }
		/* next try adding it to palette */
		i = wdev-&gt;nColors;
		if (i &lt; 220) {	/* allow 36 for windows and other apps */
		    LPLOGPALETTE lipal = wdev-&gt;limgpalette;

		    wdev-&gt;nColors = i + 1;

		    DeleteObject(wdev-&gt;himgpalette);
		    lipal-&gt;palPalEntry[i].peFlags = 0;
		    lipal-&gt;palPalEntry[i].peRed = cr;
		    lipal-&gt;palPalEntry[i].peGreen = cg;
		    lipal-&gt;palPalEntry[i].peBlue = cb;
		    lipal-&gt;palNumEntries = wdev-&gt;nColors;
		    wdev-&gt;himgpalette = CreatePalette(lipal);

		    wdev-&gt;mapped_color_flags[mc_index] |= mc_mask;
		    return ((gx_color_index) i);	/* return new palette index */
		}
		return (gx_no_color_index);	/* not found - dither instead */
	    }
	case 4:
	    return pc_4bit_map_rgb_color(dev, cv);
    }
    return (gx_default_map_rgb_color(dev, cv));
}

/* Map a color code to r-g-b. */
int
win_map_color_rgb(gx_device * dev, gx_color_index color,
		  gx_color_value prgb[3])
{
    gx_color_value one;
    ushort value;

    switch (wdev-&gt;BitsPerPixel) {
	case 24:
	    one = (gx_color_value) (gx_max_color_value / 255);
	    prgb[0] = ((color) &amp; 255) * one;
	    prgb[1] = ((color &gt;&gt; 8) &amp; 255) * one;
	    prgb[2] = ((color &gt;&gt; 16) &amp; 255) * one;
	    break;
	case 16:
	    value = (color &gt;&gt; 11) &amp; 0x1f;
	    prgb[0] = ((value &lt;&lt; 11) + (value &lt;&lt; 6) + (value &lt;&lt; 1) + (value &gt;&gt; 4)) &gt;&gt; (16 - gx_color_value_bits);
	    value = (color &gt;&gt; 5) &amp; 0x3f;
	    prgb[1] = ((value &lt;&lt; 10) + (value &lt;&lt; 4) + (value &gt;&gt; 2)) &gt;&gt; (16 - gx_color_value_bits);
	    value = (color) &amp; 0x1f;
	    prgb[2] = ((value &lt;&lt; 11) + (value &lt;&lt; 6) + (value &lt;&lt; 1) + (value &gt;&gt; 4)) &gt;&gt; (16 - gx_color_value_bits);
	    break;
	case 15:
	    value = (color &gt;&gt; 10) &amp; 0x1f;
	    prgb[0] = ((value &lt;&lt; 11) + (value &lt;&lt; 6) + (value &lt;&lt; 1) + (value &gt;&gt; 4)) &gt;&gt; (16 - gx_color_value_bits);
	    value = (color &gt;&gt; 5) &amp; 0x1f;
	    prgb[1] = ((value &lt;&lt; 11) + (value &lt;&lt; 6) + (value &lt;&lt; 1) + (value &gt;&gt; 4)) &gt;&gt; (16 - gx_color_value_bits);
	    value = (color) &amp; 0x1f;
	    prgb[2] = ((value &lt;&lt; 11) + (value &lt;&lt; 6) + (value &lt;&lt; 1) + (value &gt;&gt; 4)) &gt;&gt; (16 - gx_color_value_bits);
	    break;
	case 8:
	    if (!dev-&gt;is_open)
		return -1;
	    one = (gx_color_value) (gx_max_color_value / 255);
	    prgb[0] = wdev-&gt;limgpalette-&gt;palPalEntry[(int)color].peRed * one;
	    prgb[1] = wdev-&gt;limgpalette-&gt;palPalEntry[(int)color].peGreen * one;
	    prgb[2] = wdev-&gt;limgpalette-&gt;palPalEntry[(int)color].peBlue * one;
	    break;
	case 4:
	    pc_4bit_map_color_rgb(dev, color, prgb);
	    break;
	default:
	    prgb[0] = prgb[1] = prgb[2] =
		(int)color ? gx_max_color_value : 0;
    }
    return 0;
}

/* Get Win parameters */
int
win_get_params(gx_device * dev, gs_param_list * plist)
{
    int code = gx_default_get_params(dev, plist);

    return code;
}

/* Put parameters. */
/* Set window parameters -- size and resolution. */
/* We implement this ourselves so that we can do it without */
/* closing and opening the device. */
int
win_put_params(gx_device * dev, gs_param_list * plist)
{
    int ecode = 0, code;
    bool is_open = dev-&gt;is_open;
    int width = dev-&gt;width;
    int height = dev-&gt;height;
    int old_bpp = dev-&gt;color_info.depth;
    int bpp = old_bpp;
    byte *old_flags = wdev-&gt;mapped_color_flags;

    /* Handle extra parameters */

    switch (code = param_read_int(plist, "BitsPerPixel", &amp;bpp)) {
	case 0:
	    if (dev-&gt;is_open &amp;&amp; bpp != old_bpp)
		ecode = gs_error_rangecheck;
	    else {		/* Don't release existing mapped_color_flags. */
		if (bpp != 8)
		    wdev-&gt;mapped_color_flags = 0;
		code = win_set_bits_per_pixel(wdev, bpp);
		if (code &lt; 0)
		    ecode = code;
		else
		    break;
	    }
	    goto bppe;
	default:
	    ecode = code;
	  bppe:param_signal_error(plist, "BitsPerPixel", ecode);
	case 1:
	    break;
    }

    if (ecode &gt;= 0) {		/* Prevent gx_default_put_params from closing the device. */
	dev-&gt;is_open = false;
	ecode = gx_default_put_params(dev, plist);
	dev-&gt;is_open = is_open;
    }
    if (ecode &lt; 0) {		/* If we allocated mapped_color_flags, release it. */
	if (wdev-&gt;mapped_color_flags != 0 &amp;&amp; old_flags == 0)
	    gs_free(wdev-&gt;memory,
		    wdev-&gt;mapped_color_flags, 4096, 1,
		    "win_put_params");
	wdev-&gt;mapped_color_flags = old_flags;
	if (bpp != old_bpp)
	    win_set_bits_per_pixel(wdev, old_bpp);
	return ecode;
    }
    if (wdev-&gt;mapped_color_flags == 0 &amp;&amp; old_flags != 0) {	/* Release old mapped_color_flags. */
	gs_free(dev-&gt;memory,
		old_flags, 4096, 1, "win_put_params");
    }
    /* Hand off the change to the implementation. */
    if (is_open &amp;&amp; (bpp != old_bpp ||
		    dev-&gt;width != width || dev-&gt;height != height)
	) {
	int ccode;

	(*wdev-&gt;free_bitmap) (wdev);
	ccode = (*wdev-&gt;alloc_bitmap) (wdev, (gx_device *) wdev);
	if (ccode &lt; 0) {	/* Bad news!  Some of the other device parameters */
	    /* may have changed.  We don't handle this. */
	    /* This is ****** WRONG ******. */
	    dev-&gt;width = width;
	    dev-&gt;height = height;
	    win_set_bits_per_pixel(wdev, old_bpp);
	    (*wdev-&gt;alloc_bitmap) (wdev, dev);
	    return ccode;
	}
    }
    return 0;
}

/* ------ Internal routines ------ */

#undef wdev



/* out of memory error message box */
int
win_nomemory(void)
{
    MessageBox((HWND) NULL, (LPSTR) "Not enough memory", (LPSTR) szAppName, MB_ICONSTOP);
    return gs_error_limitcheck;
}


LPLOGPALETTE
win_makepalette(gx_device_win * wdev)
{
    int i, val;
    LPLOGPALETTE logpalette;

    logpalette = (LPLOGPALETTE) gs_malloc(wdev-&gt;memory, 1, sizeof(LOGPALETTE) +
		     (1 &lt;&lt; (wdev-&gt;color_info.depth)) * sizeof(PALETTEENTRY),
					  "win_makepalette");
    if (logpalette == (LPLOGPALETTE) NULL)
	return (0);
    logpalette-&gt;palVersion = 0x300;
    logpalette-&gt;palNumEntries = wdev-&gt;nColors;
    for (i = 0; i &lt; wdev-&gt;nColors; i++) {
	logpalette-&gt;palPalEntry[i].peFlags = 0;
	switch (wdev-&gt;nColors) {
	    case 64:
		/* colors are rrggbb */
		logpalette-&gt;palPalEntry[i].peRed = ((i &amp; 0x30) &gt;&gt; 4) * 85;
		logpalette-&gt;palPalEntry[i].peGreen = ((i &amp; 0xC) &gt;&gt; 2) * 85;
		logpalette-&gt;palPalEntry[i].peBlue = (i &amp; 3) * 85;
		break;
	    case 16:
		/* colors are irgb */
		val = (i &amp; 8 ? 255 : 128);
		logpalette-&gt;palPalEntry[i].peRed = i &amp; 4 ? val : 0;
		logpalette-&gt;palPalEntry[i].peGreen = i &amp; 2 ? val : 0;
		logpalette-&gt;palPalEntry[i].peBlue = i &amp; 1 ? val : 0;
		if (i == 8) {	/* light gray */
		    logpalette-&gt;palPalEntry[i].peRed =
			logpalette-&gt;palPalEntry[i].peGreen =
			logpalette-&gt;palPalEntry[i].peBlue = 192;
		}
		break;
	    case 2:
		logpalette-&gt;palPalEntry[i].peRed =
		    logpalette-&gt;palPalEntry[i].peGreen =
		    logpalette-&gt;palPalEntry[i].peBlue = (i ? 255 : 0);
		break;
	}
    }
    return (logpalette);
}


private int
win_set_bits_per_pixel(gx_device_win * wdev, int bpp)
{
    static const gx_device_color_info win_24bit_color = dci_color(24, 255, 255);
    static const gx_device_color_info win_16bit_color = dci_color(16, 255, 255);
    static const gx_device_color_info win_8bit_color = dci_color(8, 31, 4);
    static const gx_device_color_info win_ega_color = dci_pc_4bit;
    static const gx_device_color_info win_vga_color = dci_pc_4bit;
    static const gx_device_color_info win_mono_color = dci_black_and_white;
    /* remember old anti_alias info */
    gx_device_anti_alias_info anti_alias = wdev-&gt;color_info.anti_alias;
    HDC hdc;

    switch (bpp) {
	case 24:
	    wdev-&gt;color_info = win_24bit_color;
	    wdev-&gt;nColors = -1;
	    break;
	case 16:
	case 15:
	    wdev-&gt;color_info = win_16bit_color;
	    wdev-&gt;nColors = -1;
	    break;
	case 8:
	    /* use 64 static colors and 166 dynamic colors from 8 planes */
	    wdev-&gt;color_info = win_8bit_color;
	    wdev-&gt;nColors = 64;
	    break;
	case 4:
	    hdc = GetDC(NULL);
	    if (GetDeviceCaps(hdc, VERTRES) &lt;= 350)
		wdev-&gt;color_info = win_ega_color;
	    else
		wdev-&gt;color_info = win_vga_color;
	    ReleaseDC(NULL, hdc);
	    wdev-&gt;nColors = 16;
	    break;
	case 1:
	    wdev-&gt;color_info = win_mono_color;
	    wdev-&gt;nColors = 2;
	    break;
	default:
	    return (gs_error_rangecheck);
    }
    wdev-&gt;BitsPerPixel = bpp;

    /* If necessary, allocate and clear the mapped color flags. */
    if (bpp == 8) {
	if (wdev-&gt;mapped_color_flags == 0) {
	    wdev-&gt;mapped_color_flags = gs_malloc(wdev-&gt;memory,
						 4096, 1, "win_set_bits_per_pixel");
	    if (wdev-&gt;mapped_color_flags == 0)
		return_error(gs_error_VMerror);
	}
	memset(wdev-&gt;mapped_color_flags, 0, 4096);
    } else {
	gs_free(wdev-&gt;memory, 
		wdev-&gt;mapped_color_flags, 4096, 1, "win_set_bits_per_pixel");
	wdev-&gt;mapped_color_flags = 0;
    }

    /* copy encode/decode procedures */
    wdev-&gt;procs.encode_color = wdev-&gt;procs.map_rgb_color;
    wdev-&gt;procs.decode_color = wdev-&gt;procs.map_color_rgb;
    if (bpp == 1) {
	wdev-&gt;procs.get_color_mapping_procs = 
	    gx_default_DevGray_get_color_mapping_procs;
	wdev-&gt;procs.get_color_comp_index = 
	    gx_default_DevGray_get_color_comp_index;
    }
    else {
	wdev-&gt;procs.get_color_mapping_procs = 
	    gx_default_DevRGB_get_color_mapping_procs;
	wdev-&gt;procs.get_color_comp_index = 
	    gx_default_DevRGB_get_color_comp_index;
    }

    /* restore old anti_alias info */
    wdev-&gt;color_info.anti_alias = anti_alias;
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

