<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevpdts.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevpdts.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2002 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevpdts.c,v 1.28 2005/01/24 15:37:48 igor Exp $ */
/* Text state management for pdfwrite */
#include "math_.h"
#include "memory_.h"
#include "gx.h"
#include "gdevpdfx.h"
#include "gdevpdtx.h"
#include "gdevpdtf.h"		/* for pdfont-&gt;FontType */
#include "gdevpdts.h"

/* ================ Types and structures ================ */

/*
 * We accumulate text, and possibly horizontal or vertical moves (depending
 * on the font's writing direction), until forced to emit them.  This
 * happens when changing text state parameters, when the buffer is full, or
 * when exiting text mode.
 *
 * Note that movement distances are measured in unscaled text space.
 */
typedef struct pdf_text_move_s {
    int index;			/* within buffer.chars */
    float amount;
} pdf_text_move_t;
#define MAX_TEXT_BUFFER_CHARS 200 /* arbitrary, but overflow costs 5 chars */
#define MAX_TEXT_BUFFER_MOVES 50 /* ibid. */
typedef struct pdf_text_buffer_s {
    /*
     * Invariant:
     *   count_moves &lt;= MAX_TEXT_BUFFER_MOVES
     *   count_chars &lt;= MAX_TEXT_BUFFER_CHARS
     *   0 &lt; moves[0].index &lt; moves[1].index &lt; ... moves[count_moves-1].index
     *	   &lt;= count_chars
     *   moves[*].amount != 0
     */
    pdf_text_move_t moves[MAX_TEXT_BUFFER_MOVES + 1];
    byte chars[MAX_TEXT_BUFFER_CHARS];
    int count_moves;
    int count_chars;
} pdf_text_buffer_t;
#define TEXT_BUFFER_DEFAULT\
    { { 0, 0 } },		/* moves */\
    { 0 },			/* chars */\
    0,				/* count_moves */\
    0				/* count_chars */

/*
 * We maintain two sets of text state values (as defined in gdevpdts.h): the
 * "in" set reflects the current state as seen by the client, while the
 * "out" set reflects the current state as seen by an interpreter processing
 * the content stream emitted so far.  We emit commands to make "out" the
 * same as "in" when necessary.
 */
/*typedef struct pdf_text_state_s pdf_text_state_t;*/  /* gdevpdts.h */
struct pdf_text_state_s {
    /* State as seen by client */
    pdf_text_state_values_t in; /* see above */
    gs_point start;		/* in.txy as of start of buffer */
    pdf_text_buffer_t buffer;
    int wmode;			/* WMode of in.font */
    /* State relative to content stream */
    pdf_text_state_values_t out; /* see above */
    double leading;		/* TL (not settable, only used internally) */
    bool use_leading;		/* if true, use T* or ' */
    bool continue_line;
    gs_point line_start;
    gs_point out_pos;		/* output position */
};
private const pdf_text_state_t ts_default = {
    /* State as seen by client */
    { TEXT_STATE_VALUES_DEFAULT },	/* in */
    { 0, 0 },			/* start */
    { TEXT_BUFFER_DEFAULT },	/* buffer */
    0,				/* wmode */
    /* State relative to content stream */
    { TEXT_STATE_VALUES_DEFAULT },	/* out */
    0,				/* leading */
    0 /*false*/,		/* use_leading */
    0 /*false*/,		/* continue_line */
    { 0, 0 },			/* line_start */
    { 0, 0 }			/* output position */
};
/* GC descriptor */
gs_private_st_ptrs2(st_pdf_text_state, pdf_text_state_t,  "pdf_text_state_t",
		    pdf_text_state_enum_ptrs, pdf_text_state_reloc_ptrs,
		    in.pdfont, out.pdfont);

/* ================ Procedures ================ */

/* ---------------- Private ---------------- */

/*
 * Append a writing-direction movement to the text being accumulated.  If
 * the buffer is full, or the requested movement is not in writing
 * direction, return &lt;0 and do nothing.  (This is different from
 * pdf_append_chars.)  Requires pts-&gt;buffer.count_chars &gt; 0.
 */
private int
append_text_move(pdf_text_state_t *pts, floatp dw)
{
    int count = pts-&gt;buffer.count_moves;
    int pos = pts-&gt;buffer.count_chars;
    double rounded;

    if (count &gt; 0 &amp;&amp; pts-&gt;buffer.moves[count - 1].index == pos) {
	/* Merge adjacent moves. */
	dw += pts-&gt;buffer.moves[--count].amount;
    }
    /* Round dw if it's very close to an integer. */
    rounded = floor(dw + 0.5);
    if (fabs(dw - rounded) &lt; 0.001)
	dw = rounded;
    if (dw &lt; -MAX_USER_COORD) {
	/* Acrobat reader 4.0c, 5.0 can't handle big offsets. 
	   Adobe Reader 6 can. */
	return -1;
    }
    if (dw != 0) {
	if (count == MAX_TEXT_BUFFER_MOVES)
	    return -1;
	pts-&gt;buffer.moves[count].index = pos;
	pts-&gt;buffer.moves[count].amount = dw;
	++count;
    }
    pts-&gt;buffer.count_moves = count;
    return 0;
}

/*
 * Set *pdist to the distance (dx,dy), in the space defined by *pmat.
 */
private int
set_text_distance(gs_point *pdist, floatp dx, floatp dy, const gs_matrix *pmat)
{
    int code = gs_distance_transform_inverse(dx, dy, pmat, pdist);
    double rounded;

    if (code &lt; 0)
	return code;
    /* If the distance is very close to integers, round it. */
    if (fabs(pdist-&gt;x - (rounded = floor(pdist-&gt;x + 0.5))) &lt; 0.0005)
	pdist-&gt;x = rounded;
    if (fabs(pdist-&gt;y - (rounded = floor(pdist-&gt;y + 0.5))) &lt; 0.0005)
	pdist-&gt;y = rounded;
    return 0;
}

/*
 * Test whether the transformation parts of two matrices are compatible.
 */
private bool
matrix_is_compatible(const gs_matrix *pmat1, const gs_matrix *pmat2)
{
    return (pmat2-&gt;xx == pmat1-&gt;xx &amp;&amp; pmat2-&gt;xy == pmat1-&gt;xy &amp;&amp;
	    pmat2-&gt;yx == pmat1-&gt;yx &amp;&amp; pmat2-&gt;yy == pmat1-&gt;yy);
}

/*
 * Try to handle a change of text position with TJ or a space
 * character.  If successful, return &gt;=0, if not, return &lt;0.
 */
private int
add_text_delta_move(gx_device_pdf *pdev, const gs_matrix *pmat)
{
    pdf_text_state_t *const pts = pdev-&gt;text-&gt;text_state;

    if (matrix_is_compatible(pmat, &amp;pts-&gt;in.matrix)) {
	double dx = pmat-&gt;tx - pts-&gt;in.matrix.tx,
	    dy = pmat-&gt;ty - pts-&gt;in.matrix.ty;
	gs_point dist;
	double dw, dnotw, tdw;
	int code;

	code = set_text_distance(&amp;dist, dx, dy, pmat);
	if (code &lt; 0)
	    return code;
	if (pts-&gt;wmode)
	    dw = dist.y, dnotw = dist.x;
	else
	    dw = dist.x, dnotw = dist.y;
	if (dnotw == 0 &amp;&amp; pts-&gt;buffer.count_chars &gt; 0 &amp;&amp;
	    /*
	     * Acrobat Reader limits the magnitude of user-space
	     * coordinates.  Also, AR apparently doesn't handle large
	     * positive movement values (negative X displacements), even
	     * though the PDF Reference says this bug was fixed in AR3.
	     *
	     * Old revisions used the upper threshold 1000 for tdw,
	     * but it appears too big when a font sets a too big
	     * character width in setcachedevice. Particularly this happens 
	     * with a Type 3 font generated by Aldus Freehand 4.0
	     * to represent a texture - see bug #687051.
	     * The problem is that when the Widths is multiplied 
	     * to the font size, the viewer represents the result
	     * with insufficient fraction bits to represent the precise width.
	     * We work around that problem here restricting tdw
	     * with a smaller threshold 990. Our intention is to 
	     * disable Tj when the real glyph width appears smaller
	     * than 1% of the width specified in setcachedevice.
	     * A Td instruction will be generated instead.
	     * Note that the value 990 is arbitrary and may need a
	     * further adjustment.
	     */
	    (tdw = dw * -1000.0 / pts-&gt;in.size,
	     tdw &gt;= -MAX_USER_COORD &amp;&amp; tdw &lt; 990)
	    ) {
	    /* Use TJ. */
	    int code = append_text_move(pts, tdw);

	    if (code &gt;= 0)
		goto finish;
	}
    }
    return -1;
 finish:
    pts-&gt;in.matrix = *pmat;
    return 0;
}

/*
 * Set the text matrix for writing text.  The translation component of the
 * matrix is the text origin.  If the non-translation components of the
 * matrix differ from the current ones, write a Tm command; if there is only
 * a Y translation, set use_leading so the next text string will be written
 * with ' rather than Tj; otherwise, write a Td command.
 */
private int
pdf_set_text_matrix(gx_device_pdf * pdev)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;
    stream *s = pdev-&gt;strm;

    pts-&gt;use_leading = false;
    if (matrix_is_compatible(&amp;pts-&gt;out.matrix, &amp;pts-&gt;in.matrix)) {
	gs_point dist;
	int code;

	code = set_text_distance(&amp;dist, pts-&gt;start.x - pts-&gt;line_start.x,
			  pts-&gt;start.y - pts-&gt;line_start.y, &amp;pts-&gt;in.matrix);
	if (code &lt; 0)
	    return code;
	if (dist.x == 0 &amp;&amp; dist.y &lt; 0) {
	    /* Use TL, if needed, and T* or '. */
	    float dist_y = (float)-dist.y;

	    if (fabs(pts-&gt;leading - dist_y) &gt; 0.0005) {
		pprintg1(s, "%g TL\n", dist_y);
		pts-&gt;leading = dist_y;
	    }
	    pts-&gt;use_leading = true;
	} else {
	    /* Use Td. */
	    pprintg2(s, "%g %g Td\n", dist.x, dist.y);
	}
    } else {			/* Use Tm. */
	/*
	 * See stream_to_text in gdevpdfu.c for why we need the following
	 * matrix adjustments.
	 */
	double sx = 72.0 / pdev-&gt;HWResolution[0],
	    sy = 72.0 / pdev-&gt;HWResolution[1];

	pprintg6(s, "%g %g %g %g %g %g Tm\n",
		 pts-&gt;in.matrix.xx * sx, pts-&gt;in.matrix.xy * sy,
		 pts-&gt;in.matrix.yx * sx, pts-&gt;in.matrix.yy * sy,
		 pts-&gt;start.x * sx, pts-&gt;start.y * sy);
    }
    pts-&gt;line_start.x = pts-&gt;start.x;
    pts-&gt;line_start.y = pts-&gt;start.y;
    pts-&gt;out.matrix = pts-&gt;in.matrix;
    return 0;
}

/* ---------------- Public ---------------- */

/*
 * Allocate and initialize text state bookkeeping.
 */
pdf_text_state_t *
pdf_text_state_alloc(gs_memory_t *mem)
{
    pdf_text_state_t *pts =
	gs_alloc_struct(mem, pdf_text_state_t, &amp;st_pdf_text_state,
			"pdf_text_state_alloc");

    if (pts == 0)
	return 0;
    *pts = ts_default;
    return pts;
}

/*
 * Set the text state to default values.
 */
void
pdf_set_text_state_default(pdf_text_state_t *pts)
{
    *pts = ts_default;
}

/*
 * Copy the text state.
 */
void
pdf_text_state_copy(pdf_text_state_t *pts_to, pdf_text_state_t *pts_from)
{
    *pts_to = *pts_from;
}

/*
 * Reset the text state to its condition at the beginning of the page.
 */
void
pdf_reset_text_page(pdf_text_data_t *ptd)
{
    pdf_set_text_state_default(ptd-&gt;text_state);
}

/*
 * Reset the text state after a grestore.
 */
void
pdf_reset_text_state(pdf_text_data_t *ptd)
{
    pdf_text_state_t *pts = ptd-&gt;text_state;

    pts-&gt;out = ts_default.out;
    pts-&gt;leading = 0;
}

/*
 * Transition from stream context to text context.
 */
int
pdf_from_stream_to_text(gx_device_pdf *pdev)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;

    gs_make_identity(&amp;pts-&gt;out.matrix);
    pts-&gt;line_start.x = pts-&gt;line_start.y = 0;
    pts-&gt;continue_line = false; /* Not sure, probably doesn't matter. */
    pts-&gt;buffer.count_chars = 0;
    pts-&gt;buffer.count_moves = 0;
    return 0;
}


/*
 *  Flush text from buffer.
 */
private int
flush_text_buffer(gx_device_pdf *pdev)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;
    stream *s = pdev-&gt;strm;

    if (pts-&gt;buffer.count_moves &gt; 0) {
	int i, cur = 0;

	if (pts-&gt;use_leading)
	    stream_puts(s, "T*");
	stream_puts(s, "[");
	for (i = 0; i &lt; pts-&gt;buffer.count_moves; ++i) {
	    int next = pts-&gt;buffer.moves[i].index;

	    pdf_put_string(pdev, pts-&gt;buffer.chars + cur, next - cur);
	    pprintg1(s, "%g", pts-&gt;buffer.moves[i].amount);
	    cur = next;
	}
	if (pts-&gt;buffer.count_chars &gt; cur)
	    pdf_put_string(pdev, pts-&gt;buffer.chars + cur,
			   pts-&gt;buffer.count_chars - cur);
	stream_puts(s, "]TJ\n");
    } else {
	pdf_put_string(pdev, pts-&gt;buffer.chars, pts-&gt;buffer.count_chars);
	stream_puts(s, (pts-&gt;use_leading ? "'\n" : "Tj\n"));
    }
    pts-&gt;buffer.count_chars = 0;
    pts-&gt;buffer.count_moves = 0;
    pts-&gt;use_leading = false;
    return 0;
}

/*
 * Transition from string context to text context.
 */
private int
sync_text_state(gx_device_pdf *pdev)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;
    stream *s = pdev-&gt;strm;
    int code;

    if (pts-&gt;buffer.count_chars == 0)
	return 0;		/* nothing to output */

    if (pts-&gt;continue_line) 
	return flush_text_buffer(pdev);

    /* Bring text state parameters up to date. */

    if (pts-&gt;out.character_spacing != pts-&gt;in.character_spacing) {
	pprintg1(s, "%g Tc\n", pts-&gt;in.character_spacing);
	pts-&gt;out.character_spacing = pts-&gt;in.character_spacing;
    }

    if (pts-&gt;out.pdfont != pts-&gt;in.pdfont || pts-&gt;out.size != pts-&gt;in.size) {
	pdf_font_resource_t *pdfont = pts-&gt;in.pdfont;

	pprints1(s, "/%s ", ((pdf_resource_t *)pts-&gt;in.pdfont)-&gt;rname);
	pprintg1(s, "%g Tf\n", pts-&gt;in.size);
	pts-&gt;out.pdfont = pdfont;
	pts-&gt;out.size = pts-&gt;in.size;
	/*
	 * In PDF, the only place to specify WMode is in the CMap
	 * (a.k.a. Encoding) of a Type 0 font.
	 */
	pts-&gt;wmode =
	    (pdfont-&gt;FontType == ft_composite ?
	     pdfont-&gt;u.type0.WMode : 0);
	code = pdf_used_charproc_resources(pdev, pdfont);
	if (code &lt; 0)
	    return code;
    }

    if (memcmp(&amp;pts-&gt;in.matrix, &amp;pts-&gt;out.matrix, sizeof(pts-&gt;in.matrix)) ||
	 ((pts-&gt;start.x != pts-&gt;out_pos.x || pts-&gt;start.y != pts-&gt;out_pos.y) &amp;&amp;
	  (pts-&gt;buffer.count_chars != 0 || pts-&gt;buffer.count_moves != 0))) {
	/* pdf_set_text_matrix sets out.matrix = in.matrix */
	code = pdf_set_text_matrix(pdev);
	if (code &lt; 0)
	    return code;
    }

    if (pts-&gt;out.render_mode != pts-&gt;in.render_mode) {
	pprintg1(s, "%g Tr\n", pts-&gt;in.render_mode);
	pts-&gt;out.render_mode = pts-&gt;in.render_mode;
    }

    if (pts-&gt;out.word_spacing != pts-&gt;in.word_spacing) {
	if (memchr(pts-&gt;buffer.chars, 32, pts-&gt;buffer.count_chars)) {
	    pprintg1(s, "%g Tw\n", pts-&gt;in.word_spacing);
	    pts-&gt;out.word_spacing = pts-&gt;in.word_spacing;
	}
    }

    return flush_text_buffer(pdev);
}

int
pdf_from_string_to_text(gx_device_pdf *pdev)
{
    return sync_text_state(pdev);
}

/*
 * Close the text aspect of the current contents part.
 */
void
pdf_close_text_contents(gx_device_pdf *pdev)
{
    /*
     * Clear the font pointer.  This is probably left over from old code,
     * but it is appropriate in case we ever choose in the future to write
     * out and free font resources before the end of the document.
     */
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;

    pts-&gt;in.pdfont = pts-&gt;out.pdfont = 0;
    pts-&gt;in.size = pts-&gt;out.size = 0;
}

/*
 * Test whether a change in render_mode requires resetting the stroke
 * parameters.
 */
bool
pdf_render_mode_uses_stroke(const gx_device_pdf *pdev,
			    const pdf_text_state_values_t *ptsv)
{
    return (pdev-&gt;text-&gt;text_state-&gt;in.render_mode != ptsv-&gt;render_mode &amp;&amp;
	    ptsv-&gt;render_mode != 0);
}

/*
 * Read the stored client view of text state values.
 */
void
pdf_get_text_state_values(gx_device_pdf *pdev, pdf_text_state_values_t *ptsv)
{
    *ptsv = pdev-&gt;text-&gt;text_state-&gt;in;
}

/*
 * Set wmode to text state.
 */
void
pdf_set_text_wmode(gx_device_pdf *pdev, int wmode)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;

    pts-&gt;wmode = wmode;
}


/*
 * Set the stored client view of text state values.
 */
int
pdf_set_text_state_values(gx_device_pdf *pdev,
			  const pdf_text_state_values_t *ptsv)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;

    if (pts-&gt;buffer.count_chars &gt; 0) {
	int code;

	if (pts-&gt;in.character_spacing == ptsv-&gt;character_spacing &amp;&amp;
	    pts-&gt;in.pdfont == ptsv-&gt;pdfont &amp;&amp; pts-&gt;in.size == ptsv-&gt;size &amp;&amp;
	    pts-&gt;in.render_mode == ptsv-&gt;render_mode &amp;&amp;
	    pts-&gt;in.word_spacing == ptsv-&gt;word_spacing
	    ) {
	    if (!memcmp(&amp;pts-&gt;in.matrix, &amp;ptsv-&gt;matrix,
			sizeof(pts-&gt;in.matrix)))
		return 0;
	    /* add_text_delta_move sets pts-&gt;in.matrix if successful */
	    code = add_text_delta_move(pdev, &amp;ptsv-&gt;matrix);
	    if (code &gt;= 0)
		return 0;
	}
	code = sync_text_state(pdev);
	if (code &lt; 0)
	    return code;
    }

    pts-&gt;in = *ptsv;
    pts-&gt;continue_line = false;
    return 0;
}

/*
 * Transform a distance from unscaled text space (text space ignoring the
 * scaling implied by the font size) to device space.
 */
int
pdf_text_distance_transform(floatp wx, floatp wy, const pdf_text_state_t *pts,
			    gs_point *ppt)
{
    return gs_distance_transform(wx, wy, &amp;pts-&gt;in.matrix, ppt);
}

/*
 * Return the current (x,y) text position as seen by the client, in
 * unscaled text space.
 */
void
pdf_text_position(const gx_device_pdf *pdev, gs_point *ppt)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;

    ppt-&gt;x = pts-&gt;in.matrix.tx;
    ppt-&gt;y = pts-&gt;in.matrix.ty;
}

/*
 * Append characters to text being accumulated, giving their advance width
 * in device space.
 */
int
pdf_append_chars(gx_device_pdf * pdev, const byte * str, uint size,
		 floatp wx, floatp wy, bool nobreak)
{
    pdf_text_state_t *pts = pdev-&gt;text-&gt;text_state;
    const byte *p = str;
    uint left = size;

    if (pts-&gt;buffer.count_chars == 0 &amp;&amp; pts-&gt;buffer.count_moves == 0) {
	pts-&gt;out_pos.x = pts-&gt;start.x = pts-&gt;in.matrix.tx;
	pts-&gt;out_pos.y = pts-&gt;start.y = pts-&gt;in.matrix.ty;
    }
    while (left)
	if (pts-&gt;buffer.count_chars == MAX_TEXT_BUFFER_CHARS ||
	    (nobreak &amp;&amp; pts-&gt;buffer.count_chars + left &gt; MAX_TEXT_BUFFER_CHARS)) {
	    int code = sync_text_state(pdev);

	    if (code &lt; 0)
		return code;
	    /* We'll keep a continuation of this line in the buffer,
	     * but the current input parameters don't correspond to
	     * the current position, because the text was broken in a
	     * middle with unknown current point.
	     * Don't change the output text state parameters
	     * until input parameters are changed. 
	     * pdf_set_text_state_values will reset the 'continue_line' flag 
	     * at that time.
	     */
	    pts-&gt;continue_line = true;
	} else {
	    int code = pdf_open_page(pdev, PDF_IN_STRING);
	    uint copy;

	    if (code &lt; 0)
		return code;
	    copy = min(MAX_TEXT_BUFFER_CHARS - pts-&gt;buffer.count_chars, left);
	    memcpy(pts-&gt;buffer.chars + pts-&gt;buffer.count_chars, p, copy);
	    pts-&gt;buffer.count_chars += copy;
	    p += copy;
	    left -= copy;
	}
    pts-&gt;in.matrix.tx += wx;
    pts-&gt;in.matrix.ty += wy;
    pts-&gt;out_pos.x += wx;
    pts-&gt;out_pos.y += wy;
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

