<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gscolor2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gscolor2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1992, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gscolor2.c,v 1.20 2004/04/08 07:59:19 igor Exp $ */
/* Level 2 color operators for Ghostscript library */
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gxarith.h"
#include "gxfixed.h"		/* ditto */
#include "gxmatrix.h"		/* for gzstate.h */
#include "gxcspace.h"		/* for gscolor2.h */
#include "gxcolor2.h"
#include "gzstate.h"
#include "gxpcolor.h"
#include "stream.h"

/* ---------------- General colors and color spaces ---------------- */

/* setcolorspace */
int
gs_setcolorspace(gs_state * pgs, const gs_color_space * pcs)
{
    int             code = 0;
    gs_color_space  cs_old = *pgs-&gt;color_space;
    gs_client_color cc_old = *pgs-&gt;ccolor;

    if (pgs-&gt;in_cachedevice)
	return_error(gs_error_undefined);

    if (pcs-&gt;id != pgs-&gt;color_space-&gt;id) {
        pcs-&gt;type-&gt;adjust_cspace_count(pcs, 1);
        *pgs-&gt;color_space = *pcs;
        if ( (code = pcs-&gt;type-&gt;install_cspace(pcs, pgs)) &lt; 0          ||
              (pgs-&gt;overprint &amp;&amp; (code = gs_do_set_overprint(pgs)) &lt; 0)  ) {
            *pgs-&gt;color_space = cs_old;
            pcs-&gt;type-&gt;adjust_cspace_count(pcs, -1);
        } else
            cs_old.type-&gt;adjust_cspace_count(&amp;cs_old, -1);
    }

    if (code &gt;= 0) {
        cs_full_init_color(pgs-&gt;ccolor, pcs);
        cs_old.type-&gt;adjust_color_count(&amp;cc_old, &amp;cs_old, -1);
        gx_unset_dev_color(pgs);
    }

    return code;
}

/* currentcolorspace */
const gs_color_space *
gs_currentcolorspace(const gs_state * pgs)
{
    return pgs-&gt;color_space;
}

/* setcolor */
int
gs_setcolor(gs_state * pgs, const gs_client_color * pcc)
{
    gs_color_space *    pcs = pgs-&gt;color_space;
    gs_client_color     cc_old = *pgs-&gt;ccolor;

   if (pgs-&gt;in_cachedevice)
	return_error(gs_error_undefined); /* PLRM3 page 215. */
    gx_unset_dev_color(pgs);
    (*pcs-&gt;type-&gt;adjust_color_count)(pcc, pcs, 1);
    *pgs-&gt;ccolor = *pcc;
    (*pcs-&gt;type-&gt;restrict_color)(pgs-&gt;ccolor, pcs);
    (*pcs-&gt;type-&gt;adjust_color_count)(&amp;cc_old, pcs, -1);

    return 0;
}

/* currentcolor */
const gs_client_color *
gs_currentcolor(const gs_state * pgs)
{
    return pgs-&gt;ccolor;
}

/* ------ Internal procedures ------ */

/* GC descriptors */
private_st_indexed_map();

/* Define a lookup_index procedure that just returns the map values. */
int
lookup_indexed_map(const gs_indexed_params * params, int index, float *values)
{
    int m = cs_num_components((const gs_color_space *)&amp;params-&gt;base_space);
    const float *pv = &amp;params-&gt;lookup.map-&gt;values[index * m];

    memcpy(values, pv, sizeof(*values) * m);
    return 0;
}

/* Free an indexed map and its values when the reference count goes to 0. */
void
free_indexed_map(gs_memory_t * pmem, void *pmap, client_name_t cname)
{
    gs_free_object(pmem, ((gs_indexed_map *) pmap)-&gt;values, cname);
    gs_free_object(pmem, pmap, cname);
}

/*
 * Allocate an indexed map for an Indexed or Separation color space.
 */
int
alloc_indexed_map(gs_indexed_map ** ppmap, int nvals, gs_memory_t * pmem,
		  client_name_t cname)
{
    gs_indexed_map *pimap;

    rc_alloc_struct_1(pimap, gs_indexed_map, &amp;st_indexed_map, pmem,
		      return_error(gs_error_VMerror), cname);
    if (nvals &gt; 0) {
	pimap-&gt;values =
	    (float *)gs_alloc_byte_array(pmem, nvals, sizeof(float), cname);

	if (pimap-&gt;values == 0) {
	    gs_free_object(pmem, pimap, cname);
	    return_error(gs_error_VMerror);
	}
    } else
	pimap-&gt;values = 0;
    pimap-&gt;rc.free = free_indexed_map;
    pimap-&gt;proc_data = 0;	/* for GC */
    pimap-&gt;num_values = nvals;
    *ppmap = pimap;
    return 0;
}

/* ---------------- Indexed color spaces ---------------- */

gs_private_st_composite(st_color_space_Indexed, gs_paint_color_space,
     "gs_color_space_Indexed", cs_Indexed_enum_ptrs, cs_Indexed_reloc_ptrs);

/* ------ Color space ------ */

/* Define the Indexed color space type. */
private cs_proc_base_space(gx_base_space_Indexed);
private cs_proc_restrict_color(gx_restrict_Indexed);
private cs_proc_concrete_space(gx_concrete_space_Indexed);
private cs_proc_concretize_color(gx_concretize_Indexed);
private cs_proc_install_cspace(gx_install_Indexed);
private cs_proc_set_overprint(gx_set_overprint_Indexed);
private cs_proc_adjust_cspace_count(gx_adjust_cspace_Indexed);
private cs_proc_serialize(gx_serialize_Indexed);
const gs_color_space_type gs_color_space_type_Indexed = {
    gs_color_space_index_Indexed, false, false,
    &amp;st_color_space_Indexed, gx_num_components_1,
    gx_base_space_Indexed,
    gx_init_paint_1, gx_restrict_Indexed,
    gx_concrete_space_Indexed,
    gx_concretize_Indexed, NULL,
    gx_default_remap_color, gx_install_Indexed,
    gx_set_overprint_Indexed,
    gx_adjust_cspace_Indexed, gx_no_adjust_color_count,
    gx_serialize_Indexed,
    gx_cspace_is_linear_default
};

/* GC procedures. */

private uint
indexed_table_size(const gs_color_space *pcs)
{
    return (pcs-&gt;params.indexed.hival + 1) *
	cs_num_components((const gs_color_space *)
			  &amp;pcs-&gt;params.indexed.base_space);

}
private 
ENUM_PTRS_WITH(cs_Indexed_enum_ptrs, gs_color_space *pcs)
{
    return ENUM_USING(*pcs-&gt;params.indexed.base_space.type-&gt;stype,
		      &amp;pcs-&gt;params.indexed.base_space,
		      sizeof(pcs-&gt;params.indexed.base_space), index - 1);
}
case 0:
if (pcs-&gt;params.indexed.use_proc)
    ENUM_RETURN((void *)pcs-&gt;params.indexed.lookup.map);
else
    return ENUM_CONST_STRING2(pcs-&gt;params.indexed.lookup.table.data,
			      indexed_table_size(pcs));
ENUM_PTRS_END
private RELOC_PTRS_WITH(cs_Indexed_reloc_ptrs, gs_color_space *pcs)
{
    RELOC_USING(*pcs-&gt;params.indexed.base_space.type-&gt;stype,
		&amp;pcs-&gt;params.indexed.base_space,
		sizeof(gs_base_color_space));
    if (pcs-&gt;params.indexed.use_proc)
	RELOC_PTR(gs_color_space, params.indexed.lookup.map);
    else {
	gs_const_string table;

	table.data = pcs-&gt;params.indexed.lookup.table.data;
	table.size = indexed_table_size(pcs);
	RELOC_CONST_STRING_VAR(table);
	pcs-&gt;params.indexed.lookup.table.data = table.data;
    }
}
RELOC_PTRS_END

/* Return the base space of an Indexed color space. */
private const gs_color_space *
gx_base_space_Indexed(const gs_color_space * pcs)
{
    return (const gs_color_space *)&amp;(pcs-&gt;params.indexed.base_space);
}


/* Color space installation ditto. */

private int
gx_install_Indexed(const gs_color_space * pcs, gs_state * pgs)
{
    return (*pcs-&gt;params.indexed.base_space.type-&gt;install_cspace)
	((const gs_color_space *) &amp; pcs-&gt;params.indexed.base_space, pgs);
}

/* Color space overprint setting ditto. */

private int
gx_set_overprint_Indexed(const gs_color_space * pcs, gs_state * pgs)
{
    return (*pcs-&gt;params.indexed.base_space.type-&gt;set_overprint)
	((const gs_color_space *)&amp;pcs-&gt;params.indexed.base_space, pgs);
}

/* Color space reference count adjustment ditto. */

private void
gx_adjust_cspace_Indexed(const gs_color_space * pcs, int delta)
{
    if (pcs-&gt;params.indexed.use_proc) {
	rc_adjust_const(pcs-&gt;params.indexed.lookup.map, delta,
			"gx_adjust_Indexed");
    }
    (*pcs-&gt;params.indexed.base_space.type-&gt;adjust_cspace_count)
	((const gs_color_space *)&amp;pcs-&gt;params.indexed.base_space, delta);
}

/*
 * Default palette mapping functions for indexed color maps. These just
 * return the values already in the palette.
 *
 * For performance reasons, we provide four functions: special cases for 1,
 * 3, and 4 entry palettes, and a general case. Note that these procedures
 * do not range-check their input values.
 */
private int
map_palette_entry_1(const gs_indexed_params * params, int indx, float *values)
{
    values[0] = params-&gt;lookup.map-&gt;values[indx];
    return 0;
}

private int
map_palette_entry_3(const gs_indexed_params * params, int indx, float *values)
{
    const float *pv = &amp;(params-&gt;lookup.map-&gt;values[3 * indx]);

    values[0] = pv[0];
    values[1] = pv[1];
    values[2] = pv[2];
    return 0;
}

private int
map_palette_entry_4(const gs_indexed_params * params, int indx, float *values)
{
    const float *pv = &amp;(params-&gt;lookup.map-&gt;values[4 * indx]);

    values[0] = pv[0];
    values[1] = pv[1];
    values[2] = pv[2];
    values[3] = pv[3];
    return 0;
}

private int
map_palette_entry_n(const gs_indexed_params * params, int indx, float *values)
{
    int m = cs_num_components((const gs_color_space *)&amp;params-&gt;base_space);

    memcpy((void *)values,
	   (const void *)(params-&gt;lookup.map-&gt;values + indx * m),
	   m * sizeof(float)
    );

    return 0;
}

/*
 * Allocate an indexed map to be used as a palette for indexed color space.
 */
private gs_indexed_map *
alloc_indexed_palette(
			 const gs_color_space * pbase_cspace,
			 int nvals,
			 gs_memory_t * pmem
)
{
    int num_comps = gs_color_space_num_components(pbase_cspace);
    gs_indexed_map *pimap;
    int code =
    alloc_indexed_map(&amp;pimap, nvals * num_comps, pmem,
		      "alloc_indexed_palette");

    if (code &lt; 0)
	return 0;
    if (num_comps == 1)
	pimap-&gt;proc.lookup_index = map_palette_entry_1;
    else if (num_comps == 3)
	pimap-&gt;proc.lookup_index = map_palette_entry_3;
    else if (num_comps == 4)
	pimap-&gt;proc.lookup_index = map_palette_entry_4;
    else
	pimap-&gt;proc.lookup_index = map_palette_entry_n;
    return pimap;
}

/*
 * Build an indexed color space.
 */
int
gs_cspace_build_Indexed(
			   gs_color_space ** ppcspace,
			   const gs_color_space * pbase_cspace,
			   uint num_entries,
			   const gs_const_string * ptbl,
			   gs_memory_t * pmem
)
{
    gs_color_space *pcspace = 0;
    gs_indexed_params *pindexed = 0;
    int code;

    if ((pbase_cspace == 0) || !pbase_cspace-&gt;type-&gt;can_be_base_space)
	return_error(gs_error_rangecheck);

    code = gs_cspace_alloc(&amp;pcspace, &amp;gs_color_space_type_Indexed, pmem);
    if (code &lt; 0)
	return code;
    pindexed = &amp;(pcspace-&gt;params.indexed);
    if (ptbl == 0) {
	pindexed-&gt;lookup.map =
	    alloc_indexed_palette(pbase_cspace, num_entries, pmem);
	if (pindexed-&gt;lookup.map == 0) {
	    gs_free_object(pmem, pcspace, "gs_cspace_build_Indexed");
	    return_error(gs_error_VMerror);
	}
	pindexed-&gt;use_proc = true;
    } else {
	pindexed-&gt;lookup.table = *ptbl;
	pindexed-&gt;use_proc = false;
    }
    gs_cspace_init_from((gs_color_space *) &amp; (pindexed-&gt;base_space),
			pbase_cspace);
    pindexed-&gt;hival = num_entries - 1;
    *ppcspace = pcspace;
    return 0;
}

/*
 * Return the number of entries in an indexed color space.
 */
int
gs_cspace_indexed_num_entries(const gs_color_space * pcspace)
{
    if (gs_color_space_get_index(pcspace) != gs_color_space_index_Indexed)
	return 0;
    return pcspace-&gt;params.indexed.hival + 1;
}

/*
 * Get the palette for an indexed color space. This will return a null
 * pointer if the color space is not an indexed color space or if the
 * color space does not use the mapped index palette.
 */
float *
gs_cspace_indexed_value_array(const gs_color_space * pcspace)
{
    if ((gs_color_space_get_index(pcspace) != gs_color_space_index_Indexed) ||
	pcspace-&gt;params.indexed.use_proc
	)
	return 0;
    return pcspace-&gt;params.indexed.lookup.map-&gt;values;
}

/*
 * Set the lookup procedure to be used with an indexed color space.
 */
int
gs_cspace_indexed_set_proc(
			   gs_color_space * pcspace,
			   int (*proc)(const gs_indexed_params *, int, float *)
)
{
    if ((gs_color_space_get_index(pcspace) != gs_color_space_index_Indexed) ||
	!pcspace-&gt;params.indexed.use_proc
	)
	return_error(gs_error_rangecheck);
    pcspace-&gt;params.indexed.lookup.map-&gt;proc.lookup_index = proc;
    return 0;
}

/* ------ Colors ------ */

/* Force an Indexed color into legal range. */
private void
gx_restrict_Indexed(gs_client_color * pcc, const gs_color_space * pcs)
{
    float value = pcc-&gt;paint.values[0];

    pcc-&gt;paint.values[0] =
	(is_fneg(value) ? 0 :
	 value &gt;= pcs-&gt;params.indexed.hival ? pcs-&gt;params.indexed.hival :
	 value);
}

/* Color remapping for Indexed color spaces. */
private const gs_color_space *
gx_concrete_space_Indexed(const gs_color_space * pcs,
			  const gs_imager_state * pis)
{
    const gs_color_space *pbcs =
    (const gs_color_space *)&amp;pcs-&gt;params.indexed.base_space;

    return cs_concrete_space(pbcs, pis);
}

private int
gx_concretize_Indexed(const gs_client_color * pc, const gs_color_space * pcs,
		      frac * pconc, const gs_imager_state * pis)
{
    float value = pc-&gt;paint.values[0];
    int index =
	(is_fneg(value) ? 0 :
	 value &gt;= pcs-&gt;params.indexed.hival ? pcs-&gt;params.indexed.hival :
	 (int)value);
    const gs_color_space *pbcs =
	(const gs_color_space *)&amp;pcs-&gt;params.indexed.base_space;
    gs_client_color cc;
    int code = gs_cspace_indexed_lookup(&amp;pcs-&gt;params.indexed, index, &amp;cc);

    if (code &lt; 0)
	return code;
    return (*pbcs-&gt;type-&gt;concretize_color) (&amp;cc, pbcs, pconc, pis);
}

/* Look up an index in an Indexed color space. */
int
gs_cspace_indexed_lookup(const gs_indexed_params *pip, int index,
			 gs_client_color *pcc)
{
    if (pip-&gt;use_proc) {
	return pip-&gt;lookup.map-&gt;proc.lookup_index
	    (pip, index, &amp;pcc-&gt;paint.values[0]);
    } else {
	const gs_color_space *pbcs = (const gs_color_space *)&amp;pip-&gt;base_space;
	int m = cs_num_components(pbcs);
	const byte *pcomp = pip-&gt;lookup.table.data + m * index;

	switch (m) {
	    default: {		/* DeviceN */
		int i;

		for (i = 0; i &lt; m; ++i)
		    pcc-&gt;paint.values[i] = pcomp[i] * (1.0 / 255.0);
	    }
		break;
	    case 4:
		pcc-&gt;paint.values[3] = pcomp[3] * (1.0 / 255.0);
	    case 3:
		pcc-&gt;paint.values[2] = pcomp[2] * (1.0 / 255.0);
	    case 2:
		pcc-&gt;paint.values[1] = pcomp[1] * (1.0 / 255.0);
	    case 1:
		pcc-&gt;paint.values[0] = pcomp[0] * (1.0 / 255.0);
	}
	return 0;
    }
}

/* ---------------- Serialization. -------------------------------- */

private int 
gx_serialize_Indexed(const gs_color_space * pcs, stream * s)
{
    const gs_indexed_params * p = &amp;pcs-&gt;params.indexed;
    uint n;
    int code = gx_serialize_cspace_type(pcs, s);

    if (code &lt; 0)
	return code;
    code = cs_serialize((const gs_color_space *)&amp;p-&gt;base_space, s);
    if (code &lt; 0)
	return code;
    code = sputs(s, (const byte *)&amp;p-&gt;hival, sizeof(p-&gt;hival), &amp;n);
    if (code &lt; 0)
	return code;
    code = sputs(s, (const byte *)&amp;p-&gt;use_proc, sizeof(p-&gt;use_proc), &amp;n);
    if (code &lt; 0)
	return code;
    if (p-&gt;use_proc) {
	code = sputs(s, (const byte *)&amp;p-&gt;lookup.map-&gt;num_values, 
		sizeof(p-&gt;lookup.map-&gt;num_values), &amp;n);
	if (code &lt; 0)
	    return code;
	code = sputs(s, (const byte *)&amp;p-&gt;lookup.map-&gt;values[0], 
		sizeof(p-&gt;lookup.map-&gt;values[0]) * p-&gt;lookup.map-&gt;num_values, &amp;n);
    } else {
	code = sputs(s, (const byte *)&amp;p-&gt;lookup.table.size, 
			sizeof(p-&gt;lookup.table.size), &amp;n);
	if (code &lt; 0)
	    return code;
	code = sputs(s, p-&gt;lookup.table.data, p-&gt;lookup.table.size, &amp;n);
    }
    return code;
}

/* ---------------- High level device support -------------------------------- */

/*
 * This special function forces a device to include the current
 * color space into the output. Returns 'rangecheck' if the device can't handle it.
 * The primary reason is to include DefaultGray, DefaultRGB, DefaultCMYK into PDF.
 * Should be called for each page that requires the resource.
 * Redundant calls per page with same cspace id are allowed.
 * Redundant calls per page with different cspace id are are allowed but 
 * highly undesirable.
 * No need to call it with color spaces explicitly referred by the document,
 * because they are included automatically.
 * res_name and name_length passes the resource name.
 */
int
gs_includecolorspace(gs_state * pgs, const byte *res_name, int name_length)
{
    return (*dev_proc(pgs-&gt;device, include_color_space))(pgs-&gt;device, pgs-&gt;color_space, res_name, name_length);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

