<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gscparam.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gscparam.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gscparam.c,v 1.10 2004/08/04 19:36:12 stefan Exp $ */
/* Default implementation of parameter lists */
#include "memory_.h"
#include "string_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsparam.h"
#include "gsstruct.h"

/* Forward references */
typedef union c_param_value_s {
    GS_PARAM_VALUE_UNION(gs_c_param_list);
} gs_c_param_value;
/*typedef struct gs_c_param_s gs_c_param; *//* in gsparam.h */

/* Define the GC type for a parameter list. */
private_st_c_param_list();

/* Lengths corresponding to various gs_param_type_xxx types */
const byte gs_param_type_sizes[] = {
    GS_PARAM_TYPE_SIZES(sizeof(gs_c_param_list))
};

/* Lengths of *actual* data-containing type pointed to or contained by gs_param_type_xxx's */
const byte gs_param_type_base_sizes[] = {
    GS_PARAM_TYPE_BASE_SIZES(0)
};

/*
 * Define a parameter list element.  We use gs_param_type_any to identify
 * elements that have been requested but not yet written.  The reading
 * procedures must recognize such elements as undefined, and ignore them.
 */
struct gs_c_param_s {
    gs_c_param *next;
    gs_param_key_t key;
    bool free_key;
    gs_c_param_value value;
    gs_param_type type;
    void *alternate_typed_data;
};

/* GC descriptor and procedures */
gs_private_st_composite(st_c_param, gs_c_param, "gs_c_param",
			c_param_enum_ptrs, c_param_reloc_ptrs);
ENUM_PTRS_WITH(c_param_enum_ptrs, gs_c_param *param) {
    index -= 3;
    switch (param-&gt;type) {
	/* Only the aggregate types are handled specially. */
    case gs_param_type_dict:
    case gs_param_type_dict_int_keys:
    case gs_param_type_array:
	return ENUM_USING(st_c_param_list, &amp;param-&gt;value.d,
			  sizeof(param-&gt;value.d), index);
    default: {
	gs_param_typed_value value;

	value.value = *(const gs_param_value *)&amp;param-&gt;value;
	value.type = param-&gt;type;
	return gs_param_typed_value_enum_ptrs(mem, &amp;value, sizeof(value), index,
					      pep, NULL, gcst);
    }
    }
}
case 0: return ENUM_OBJ(param-&gt;next);
case 1: return ENUM_OBJ(param-&gt;alternate_typed_data);
case 2:
    if (!param-&gt;key.persistent) {
	gs_const_string key;

	key.data = param-&gt;key.data;
	key.size = param-&gt;key.size;
	return ENUM_STRING(&amp;key);
    } else
	return ENUM_OBJ(0);	/* keep going */
ENUM_PTRS_END
RELOC_PTRS_WITH(c_param_reloc_ptrs, gs_c_param *param) {
    RELOC_VAR(param-&gt;next);
    RELOC_VAR(param-&gt;alternate_typed_data);
    if (!param-&gt;key.persistent) {
	gs_const_string key;

	key.data = param-&gt;key.data;
	key.size = param-&gt;key.size;
	RELOC_CONST_STRING_VAR(key);
	param-&gt;key.data = key.data;
    }
    switch (param-&gt;type) {
	/* Only the aggregate types are handled specially. */
    case gs_param_type_dict:
    case gs_param_type_dict_int_keys:
    case gs_param_type_array:
	RELOC_USING(st_c_param_list, &amp;param-&gt;value.d, sizeof(param-&gt;value.d));
	break;
    default: {
	gs_param_typed_value value;

	value.value = *(gs_param_value *)&amp;param-&gt;value;
	value.type = param-&gt;type;
	gs_param_typed_value_reloc_ptrs(&amp;value, sizeof(value), NULL, gcst);
	*(gs_param_value *)&amp;param-&gt;value = value.value;
    }
    }
}
RELOC_PTRS_END

/* ---------------- Utilities ---------------- */

gs_c_param_list *
gs_c_param_list_alloc(gs_memory_t *mem, client_name_t cname)
{
    return gs_alloc_struct(mem, gs_c_param_list, &amp;st_c_param_list, cname);
}

private gs_c_param *
c_param_find(const gs_c_param_list *plist, gs_param_name pkey, bool any)
{
    gs_c_param *pparam = plist-&gt;head;
    uint len = strlen(pkey);

    for (; pparam != 0; pparam = pparam-&gt;next)
	if (pparam-&gt;key.size == len &amp;&amp; !memcmp(pparam-&gt;key.data, pkey, len))
	    return (pparam-&gt;type != gs_param_type_any || any ? pparam : 0);
    return 0;
}

/* ---------------- Writing parameters to a list ---------------- */

private param_proc_begin_xmit_collection(c_param_begin_write_collection);
private param_proc_end_xmit_collection(c_param_end_write_collection);
private param_proc_xmit_typed(c_param_write_typed);
private param_proc_request(c_param_request);
private param_proc_requested(c_param_requested);
private const gs_param_list_procs c_write_procs =
{
    c_param_write_typed,
    c_param_begin_write_collection,
    c_param_end_write_collection,
    NULL,			/* get_next_key */
    c_param_request,
    c_param_requested
};

/* Initialize a list for writing. */
void
gs_c_param_list_write(gs_c_param_list * plist, gs_memory_t * mem)
{
    plist-&gt;memory = mem;
    plist-&gt;head = 0;
    plist-&gt;target = 0;		/* not used for writing */
    plist-&gt;count = 0;
    plist-&gt;any_requested = false;
    plist-&gt;persistent_keys = true;
    gs_c_param_list_write_more(plist);
}

/* Set the target of a list.  Only relevant for reading. */
void
gs_c_param_list_set_target(gs_c_param_list *plist, gs_param_list *target)
{
    plist-&gt;target = target;
}

/* Re-enable a list for writing, without clearing it. */
/* gs_c_param_list_write must have been called previously. */
void
gs_c_param_list_write_more(gs_c_param_list * plist)
{
    plist-&gt;procs = &amp;c_write_procs;
    plist-&gt;coll_type = gs_param_collection_dict_any;
}

/* Release a list. */
void
gs_c_param_list_release(gs_c_param_list * plist)
{
    gs_memory_t *mem = plist-&gt;memory;
    gs_c_param *pparam;

    while ((pparam = plist-&gt;head) != 0) {
	gs_c_param *next = pparam-&gt;next;

	switch (pparam-&gt;type) {
	    case gs_param_type_dict:
	    case gs_param_type_dict_int_keys:
	    case gs_param_type_array:
		gs_c_param_list_release(&amp;pparam-&gt;value.d);
		break;
	    case gs_param_type_string:
	    case gs_param_type_name:
	    case gs_param_type_int_array:
	    case gs_param_type_float_array:
	    case gs_param_type_string_array:
	    case gs_param_type_name_array:
		if (!pparam-&gt;value.s.persistent)
		    gs_free_const_object(mem, pparam-&gt;value.s.data,
					 "gs_c_param_list_release data");
		break;
	    default:
		break;
	}
	if (pparam-&gt;free_key) {
	    /* We allocated this, so we must free it. */
	    gs_free_const_string(mem, pparam-&gt;key.data, pparam-&gt;key.size,
				 "gs_c_param_list_release key");
	}
	gs_free_object(mem, pparam-&gt;alternate_typed_data,
		       "gs_c_param_list_release alternate data");
	gs_free_object(mem, pparam,
		       "gs_c_param_list_release entry");
	plist-&gt;head = next;
	plist-&gt;count--;
    }
}

/* Add an entry to a list.  Doesn't set: value, type, plist-&gt;head. */
private gs_c_param *
c_param_add(gs_c_param_list * plist, gs_param_name pkey)
{
    gs_c_param *pparam =
	gs_alloc_struct(plist-&gt;memory, gs_c_param, &amp;st_c_param,
			"c_param_add entry");
    uint len = strlen(pkey);

    if (pparam == 0)
	return 0;
    pparam-&gt;next = plist-&gt;head;
    if (!plist-&gt;persistent_keys) {
	/* We must copy the key. */
	byte *str = gs_alloc_string(plist-&gt;memory, len, "c_param_add key");

	if (str == 0) {
	    gs_free_object(plist-&gt;memory, pparam, "c_param_add entry");
	    return 0;
	}
	memcpy(str, pkey, len);
	pparam-&gt;key.data = str;
	pparam-&gt;key.persistent = false; /* we will free it */
	pparam-&gt;free_key = true;
    } else {
	pparam-&gt;key.data = (const byte *)pkey;
	pparam-&gt;key.persistent = true;
	pparam-&gt;free_key = false;
    }
    pparam-&gt;key.size = len;
    pparam-&gt;alternate_typed_data = 0;
    return pparam;
}

/*  Write a dynamically typed parameter to a list. */
private int
c_param_write(gs_c_param_list * plist, gs_param_name pkey, void *pvalue,
	      gs_param_type type)
{
    unsigned top_level_sizeof = 0;
    unsigned second_level_sizeof = 0;
    gs_c_param *pparam = c_param_add(plist, pkey);

    if (pparam == 0)
	return_error(gs_error_VMerror);
    memcpy(&amp;pparam-&gt;value, pvalue, gs_param_type_sizes[(int)type]);
    pparam-&gt;type = type;

    /* Need deeper copies of data if it's not persistent */
    switch (type) {
	    gs_param_string const *curr_string;
	    gs_param_string const *end_string;

	case gs_param_type_string_array:
	case gs_param_type_name_array:
	    /* Determine how much mem needed to hold actual string data */
	    curr_string = pparam-&gt;value.sa.data;
	    end_string = curr_string + pparam-&gt;value.sa.size;
	    for (; curr_string &lt; end_string; ++curr_string)
		if (!curr_string-&gt;persistent)
		    second_level_sizeof += curr_string-&gt;size;
	    /* fall thru */

	case gs_param_type_string:
	case gs_param_type_name:
	case gs_param_type_int_array:
	case gs_param_type_float_array:
	    if (!pparam-&gt;value.s.persistent) {	/* Allocate &amp; copy object pointed to by array or string */
		byte *top_level_memory = NULL;

		top_level_sizeof =
		    pparam-&gt;value.s.size * gs_param_type_base_sizes[type];
		if (top_level_sizeof + second_level_sizeof &gt; 0) {
		    top_level_memory =
			gs_alloc_bytes_immovable(plist-&gt;memory,
				     top_level_sizeof + second_level_sizeof,
					     "c_param_write data");
		    if (top_level_memory == 0) {
			gs_free_object(plist-&gt;memory, pparam, "c_param_write entry");
			return_error(gs_error_VMerror);
		    }
		    memcpy(top_level_memory, pparam-&gt;value.s.data, top_level_sizeof);
		}
		pparam-&gt;value.s.data = top_level_memory;

		/* String/name arrays need to copy actual str data */

		if (second_level_sizeof &gt; 0) {
		    byte *second_level_memory =
		    top_level_memory + top_level_sizeof;

		    curr_string = pparam-&gt;value.sa.data;
		    end_string = curr_string + pparam-&gt;value.sa.size;
		    for (; curr_string &lt; end_string; ++curr_string)
			if (!curr_string-&gt;persistent) {
			    memcpy(second_level_memory,
				   curr_string-&gt;data, curr_string-&gt;size);
			    ((gs_param_string *) curr_string)-&gt;data
				= second_level_memory;
			    second_level_memory += curr_string-&gt;size;
			}
		}
	    }
	    break;
	default:
	    break;
    }

    plist-&gt;head = pparam;
    plist-&gt;count++;
    return 0;
}

/* Individual writing routines. */
private int
c_param_begin_write_collection(gs_param_list * plist, gs_param_name pkey,
	       gs_param_dict * pvalue, gs_param_collection_type_t coll_type)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_c_param_list *dlist =
	gs_c_param_list_alloc(cplist-&gt;memory,
			      "c_param_begin_write_collection");

    if (dlist == 0)
	return_error(gs_error_VMerror);
    gs_c_param_list_write(dlist, cplist-&gt;memory);
    dlist-&gt;coll_type = coll_type;
    pvalue-&gt;list = (gs_param_list *) dlist;
    return 0;
}
private int
c_param_end_write_collection(gs_param_list * plist, gs_param_name pkey,
			     gs_param_dict * pvalue)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_c_param_list *dlist = (gs_c_param_list *) pvalue-&gt;list;

    return c_param_write(cplist, pkey, pvalue-&gt;list,
		    (dlist-&gt;coll_type == gs_param_collection_dict_int_keys ?
		     gs_param_type_dict_int_keys :
		     dlist-&gt;coll_type == gs_param_collection_array ?
		     gs_param_type_array : gs_param_type_dict));
}
private int
c_param_write_typed(gs_param_list * plist, gs_param_name pkey,
		    gs_param_typed_value * pvalue)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_param_collection_type_t coll_type;

    switch (pvalue-&gt;type) {
	case gs_param_type_dict:
	    coll_type = gs_param_collection_dict_any;
	    break;
	case gs_param_type_dict_int_keys:
	    coll_type = gs_param_collection_dict_int_keys;
	    break;
	case gs_param_type_array:
	    coll_type = gs_param_collection_array;
	    break;
	default:
	    return c_param_write(cplist, pkey, &amp;pvalue-&gt;value, pvalue-&gt;type);
    }
    return c_param_begin_write_collection
	(plist, pkey, &amp;pvalue-&gt;value.d, coll_type);
}

/* Other procedures */

private int
c_param_request(gs_param_list * plist, gs_param_name pkey)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_c_param *pparam;

    cplist-&gt;any_requested = true;
    if (c_param_find(cplist, pkey, true))
	return 0;
    pparam = c_param_add(cplist, pkey);
    if (pparam == 0)
	return_error(gs_error_VMerror);
    pparam-&gt;type = gs_param_type_any; /* mark as undefined */
    cplist-&gt;head = pparam;
    return 0;
}

private int
c_param_requested(const gs_param_list * plist, gs_param_name pkey)
{
    const gs_c_param_list *const cplist = (const gs_c_param_list *)plist;
    gs_param_list *target = cplist-&gt;target;
    int code;

    if (!cplist-&gt;any_requested)
	return (target ? param_requested(target, pkey) : -1);
    if (c_param_find(cplist, pkey, true) != 0)
	return 1;
    if (!target)
	return 0;
    code = param_requested(target, pkey);
    return (code &lt; 0 ? 0 : 1);
}

/* ---------------- Reading from a list to parameters ---------------- */

private param_proc_begin_xmit_collection(c_param_begin_read_collection);
private param_proc_end_xmit_collection(c_param_end_read_collection);
private param_proc_xmit_typed(c_param_read_typed);
private param_proc_next_key(c_param_get_next_key);
private param_proc_get_policy(c_param_read_get_policy);
private param_proc_signal_error(c_param_read_signal_error);
private param_proc_commit(c_param_read_commit);
private const gs_param_list_procs c_read_procs =
{
    c_param_read_typed,
    c_param_begin_read_collection,
    c_param_end_read_collection,
    c_param_get_next_key,
    NULL,			/* request, N/A */
    NULL,			/* requested, N/A */
    c_param_read_get_policy,
    c_param_read_signal_error,
    c_param_read_commit
};

/* Switch a list from writing to reading. */
void
gs_c_param_list_read(gs_c_param_list * plist)
{
    plist-&gt;procs = &amp;c_read_procs;
}

/* Generic routine for reading a parameter from a list. */

private int
c_param_read_typed(gs_param_list * plist, gs_param_name pkey,
		   gs_param_typed_value * pvalue)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_param_type req_type = pvalue-&gt;type;
    gs_c_param *pparam = c_param_find(cplist, pkey, false);
    int code;

    if (pparam == 0)
	return (cplist-&gt;target ?
		param_read_typed(cplist-&gt;target, pkey, pvalue) : 1);
    pvalue-&gt;type = pparam-&gt;type;
    switch (pvalue-&gt;type) {
	case gs_param_type_dict:
	case gs_param_type_dict_int_keys:
	case gs_param_type_array:
	    gs_c_param_list_read(&amp;pparam-&gt;value.d);
	    pvalue-&gt;value.d.list = (gs_param_list *) &amp; pparam-&gt;value.d;
	    pvalue-&gt;value.d.size = pparam-&gt;value.d.count;
	    return 0;
	default:
	    break;
    }
    memcpy(&amp;pvalue-&gt;value, &amp;pparam-&gt;value,
	   gs_param_type_sizes[(int)pparam-&gt;type]);
    code = param_coerce_typed(pvalue, req_type, NULL);
/****** SHOULD LET param_coerce_typed DO THIS ******/
    if (code == gs_error_typecheck &amp;&amp;
	req_type == gs_param_type_float_array &amp;&amp;
	pvalue-&gt;type == gs_param_type_int_array
	) {
	/* Convert int array to float dest */
	gs_param_float_array fa;
	int element;

	fa.size = pparam-&gt;value.ia.size;
	fa.persistent = false;

	if (pparam-&gt;alternate_typed_data == 0) {
	    if ((pparam-&gt;alternate_typed_data
		 = (void *)gs_alloc_bytes_immovable(cplist-&gt;memory,
						    fa.size * sizeof(float),
			     "gs_c_param_read alternate float array")) == 0)
		      return_error(gs_error_VMerror);

	    for (element = 0; element &lt; fa.size; ++element)
		((float *)(pparam-&gt;alternate_typed_data))[element]
		    = (float)pparam-&gt;value.ia.data[element];
	}
	fa.data = (float *)pparam-&gt;alternate_typed_data;

	pvalue-&gt;value.fa = fa;
	return 0;
    }
    return code;
}

/* Individual reading routines. */
private int
c_param_begin_read_collection(gs_param_list * plist, gs_param_name pkey,
	       gs_param_dict * pvalue, gs_param_collection_type_t coll_type)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_c_param *pparam = c_param_find(cplist, pkey, false);

    if (pparam == 0)
	return
	    (cplist-&gt;target ?
	     param_begin_read_collection(cplist-&gt;target,
					 pkey, pvalue, coll_type) :
	     1);
    switch (pparam-&gt;type) {
	case gs_param_type_dict:
	    if (coll_type != gs_param_collection_dict_any)
		return_error(gs_error_typecheck);
	    break;
	case gs_param_type_dict_int_keys:
	    if (coll_type == gs_param_collection_array)
		return_error(gs_error_typecheck);
	    break;
	case gs_param_type_array:
	    break;
	default:
	    return_error(gs_error_typecheck);
    }
    gs_c_param_list_read(&amp;pparam-&gt;value.d);
    pvalue-&gt;list = (gs_param_list *) &amp; pparam-&gt;value.d;
    pvalue-&gt;size = pparam-&gt;value.d.count;
    return 0;
}
private int
c_param_end_read_collection(gs_param_list * plist, gs_param_name pkey,
			    gs_param_dict * pvalue)
{
    return 0;
}

/* Other procedures */
private int			/* ret 0 ok, 1 if EOF, or -ve err */
c_param_get_next_key(gs_param_list * plist, gs_param_enumerator_t * penum,
		     gs_param_key_t * key)
{
    gs_c_param_list *const cplist = (gs_c_param_list *)plist;
    gs_c_param *pparam =
    (penum-&gt;pvoid ? ((gs_c_param *) (penum-&gt;pvoid))-&gt;next :
     cplist-&gt;head);

    if (pparam == 0)
	return 1;
    penum-&gt;pvoid = pparam;
    *key = pparam-&gt;key;
    return 0;
}
private int
c_param_read_get_policy(gs_param_list * plist, gs_param_name pkey)
{
    return gs_param_policy_ignore;
}
private int
c_param_read_signal_error(gs_param_list * plist, gs_param_name pkey, int code)
{
    return code;
}
private int
c_param_read_commit(gs_param_list * plist)
{
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

