<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gscrdp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gscrdp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gscrdp.c,v 1.6 2002/10/08 00:49:49 dan Exp $ */
/* CIE color rendering dictionary creation */
#include "math_.h"
#include "memory_.h"
#include "string_.h"
#include "gx.h"
#include "gsdevice.h"
#include "gserrors.h"
#include "gsmatrix.h"		/* for gscolor2.h */
#include "gsstruct.h"
#include "gxcspace.h"
#include "gscolor2.h"		/* for gs_set/currentcolorrendering */
#include "gscrdp.h"
#include "gxarith.h"

/* ---------------- Writing ---------------- */

/* Internal procedures for writing parameter values. */
private void
store_vector3(float *p, const gs_vector3 * pvec)
{
    p[0] = pvec-&gt;u, p[1] = pvec-&gt;v, p[2] = pvec-&gt;w;
}
private int
write_floats(gs_param_list * plist, gs_param_name key,
	     const float *values, int size, gs_memory_t * mem)
{
    float *p = (float *)
	gs_alloc_byte_array(mem, size, sizeof(float), "write_floats");
    gs_param_float_array fa;

    if (p == 0)
	return_error(gs_error_VMerror);
    memcpy(p, values, size * sizeof(float));

    fa.data = p;
    fa.size = size;
    fa.persistent = true;
    return param_write_float_array(plist, key, &amp;fa);
}
private int
write_vector3(gs_param_list * plist, gs_param_name key,
	      const gs_vector3 * pvec, gs_memory_t * mem)
{
    float values[3];

    store_vector3(values, pvec);
    return write_floats(plist, key, values, 3, mem);
}
private int
write_matrix3(gs_param_list * plist, gs_param_name key,
	      const gs_matrix3 * pmat, gs_memory_t * mem)
{
    float values[9];

    if (!memcmp(pmat, &amp;Matrix3_default, sizeof(*pmat)))
	return 0;
    store_vector3(values, &amp;pmat-&gt;cu);
    store_vector3(values + 3, &amp;pmat-&gt;cv);
    store_vector3(values + 6, &amp;pmat-&gt;cw);
    return write_floats(plist, key, values, 9, mem);
}
private int
write_range3(gs_param_list * plist, gs_param_name key,
	     const gs_range3 * prange, gs_memory_t * mem)
{
    float values[6];

    if (!memcmp(prange, &amp;Range3_default, sizeof(*prange)))
	return 0;
    values[0] = prange-&gt;ranges[0].rmin, values[1] = prange-&gt;ranges[0].rmax;
    values[2] = prange-&gt;ranges[1].rmin, values[3] = prange-&gt;ranges[1].rmax;
    values[4] = prange-&gt;ranges[2].rmin, values[5] = prange-&gt;ranges[2].rmax;
    return write_floats(plist, key, values, 6, mem);
}
private int
write_proc3(gs_param_list * plist, gs_param_name key,
	    const gs_cie_render * pcrd, const gs_cie_render_proc3 * procs,
	    const gs_range3 * domain, gs_memory_t * mem)
{
    float *values;
    uint size = gx_cie_cache_size;
    gs_param_float_array fa;
    int i;

    if (!memcmp(procs, &amp;Encode_default, sizeof(*procs)))
	return 0;
    values = (float *)gs_alloc_byte_array(mem, size * 3, sizeof(float),
					  "write_proc3");

    if (values == 0)
	return_error(gs_error_VMerror);
    for (i = 0; i &lt; 3; ++i) {
	double base = domain-&gt;ranges[i].rmin;
	double scale = (domain-&gt;ranges[i].rmax - base) / (size - 1);
	int j;

	for (j = 0; j &lt; size; ++j)
	    values[i * size + j] =
		(*procs-&gt;procs[i]) (j * scale + base, pcrd);
    }
    fa.data = values;
    fa.size = size * 3;
    fa.persistent = true;
    return param_write_float_array(plist, key, &amp;fa);
}

/* Write a CRD as a device parameter. */
int
param_write_cie_render1(gs_param_list * plist, gs_param_name key,
			gs_cie_render * pcrd, gs_memory_t * mem)
{
    gs_param_dict dict;
    int code, dcode;

    dict.size = 20;
    if ((code = param_begin_write_dict(plist, key, &amp;dict, false)) &lt; 0)
	return code;
    code = param_put_cie_render1(dict.list, pcrd, mem);
    dcode = param_end_write_dict(plist, key, &amp;dict);
    return (code &lt; 0 ? code : dcode);
}

/* Write a CRD directly to a parameter list. */
int
param_put_cie_render1(gs_param_list * plist, gs_cie_render * pcrd,
		      gs_memory_t * mem)
{
    int crd_type = GX_DEVICE_CRD1_TYPE;
    int code = gs_cie_render_sample(pcrd); /* we need RenderTableT_is_id' */

    if (code &lt; 0)
	return code;
    if (pcrd-&gt;TransformPQR.proc_name) {
	gs_param_string pn, pd;

	param_string_from_string(pn, pcrd-&gt;TransformPQR.proc_name);
	pn.size++;		/* include terminating null */
	pd.data = pcrd-&gt;TransformPQR.proc_data.data;
	pd.size = pcrd-&gt;TransformPQR.proc_data.size;
	pd.persistent = true;  /****** WRONG ******/
	if ((code = param_write_name(plist, "TransformPQRName", &amp;pn)) &lt; 0 ||
	    (code = param_write_string(plist, "TransformPQRData", &amp;pd)) &lt; 0
	    )
	    return code;
    }
    else if (pcrd-&gt;TransformPQR.proc != TransformPQR_default.proc) {
	/* We have no way to represent the procedure, so return an error. */
	return_error(gs_error_rangecheck);
    }
    if ((code = param_write_int(plist, "ColorRenderingType", &amp;crd_type)) &lt; 0 ||
	(code = write_vector3(plist, "WhitePoint", &amp;pcrd-&gt;points.WhitePoint, mem)) &lt; 0
	)
	return code;
    if (memcmp(&amp;pcrd-&gt;points.BlackPoint, &amp;BlackPoint_default,
	       sizeof(pcrd-&gt;points.BlackPoint))) {
	if ((code = write_vector3(plist, "BlackPoint", &amp;pcrd-&gt;points.BlackPoint, mem)) &lt; 0)
	    return code;
    }
    if ((code = write_matrix3(plist, "MatrixPQR", &amp;pcrd-&gt;MatrixPQR, mem)) &lt; 0 ||
	(code = write_range3(plist, "RangePQR", &amp;pcrd-&gt;RangePQR, mem)) &lt; 0 ||
    /* TransformPQR is handled separately */
    (code = write_matrix3(plist, "MatrixLMN", &amp;pcrd-&gt;MatrixLMN, mem)) &lt; 0 ||
	(code = write_proc3(plist, "EncodeLMNValues", pcrd,
			    &amp;pcrd-&gt;EncodeLMN, &amp;pcrd-&gt;DomainLMN, mem)) &lt; 0 ||
	(code = write_range3(plist, "RangeLMN", &amp;pcrd-&gt;RangeLMN, mem)) &lt; 0 ||
    (code = write_matrix3(plist, "MatrixABC", &amp;pcrd-&gt;MatrixABC, mem)) &lt; 0 ||
	(code = write_proc3(plist, "EncodeABCValues", pcrd,
			    &amp;pcrd-&gt;EncodeABC, &amp;pcrd-&gt;DomainABC, mem)) &lt; 0 ||
	(code = write_range3(plist, "RangeABC", &amp;pcrd-&gt;RangeABC, mem)) &lt; 0
	)
	return code;
    if (pcrd-&gt;RenderTable.lookup.table) {
	int n = pcrd-&gt;RenderTable.lookup.n;
	int m = pcrd-&gt;RenderTable.lookup.m;
	int na = pcrd-&gt;RenderTable.lookup.dims[0];
	int *size = (int *)
	    gs_alloc_byte_array(mem, n + 1, sizeof(int), "RenderTableSize");

	/*
	 * In principle, we should use gs_alloc_struct_array with a
	 * type descriptor for gs_param_string.  However, it is widely
	 * assumed that parameter lists are transient, and don't require
	 * accurate GC information; so we can get away with allocating
	 * the string table as bytes.
	 */
	gs_param_string *table =
	    (gs_param_string *)
	    gs_alloc_byte_array(mem, na, sizeof(gs_param_string),
				"RenderTableTable");
	gs_param_int_array ia;

	if (size == 0 || table == 0)
	    code = gs_note_error(gs_error_VMerror);
	else {
	    memcpy(size, pcrd-&gt;RenderTable.lookup.dims, sizeof(int) * n);

	    size[n] = m;
	    ia.data = size;
	    ia.size = n + 1;
	    ia.persistent = true;
	    code = param_write_int_array(plist, "RenderTableSize", &amp;ia);
	}
	if (code &gt;= 0) {
	    gs_param_string_array sa;
	    int a;

	    for (a = 0; a &lt; na; ++a)
		table[a].data = pcrd-&gt;RenderTable.lookup.table[a].data,
		    table[a].size = pcrd-&gt;RenderTable.lookup.table[a].size,
		    table[a].persistent = true;
	    sa.data = table;
	    sa.size = na;
	    sa.persistent = true;
	    code = param_write_string_array(plist, "RenderTableTable", &amp;sa);
	    if (code &gt;= 0 &amp;&amp; !pcrd-&gt;caches.RenderTableT_is_identity) {
		/****** WRITE RenderTableTValues LIKE write_proc3 ******/
		uint size = gx_cie_cache_size;
		float *values =
		    (float *)gs_alloc_byte_array(mem, size * m,
						 sizeof(float),
						 "write_proc3");
		gs_param_float_array fa;
		int i;

		if (values == 0)
		    return_error(gs_error_VMerror);
		for (i = 0; i &lt; m; ++i) {
		    double scale = 255.0 / (size - 1);
		    int j;

		    for (j = 0; j &lt; size; ++j)
			values[i * size + j] =
			    frac2float((*pcrd-&gt;RenderTable.T.procs[i])
				       ((byte)(j * scale), pcrd));
		}
		fa.data = values;
		fa.size = size * m;
		fa.persistent = true;
		code = param_write_float_array(plist, "RenderTableTValues",
					       &amp;fa);
	    }
	}
	if (code &lt; 0) {
	    gs_free_object(mem, table, "RenderTableTable");
	    gs_free_object(mem, size, "RenderTableSize");
	    return code;
	}
    }
    return code;
}

/* ---------------- Reading ---------------- */

/* Internal procedures for reading parameter values. */
private void
load_vector3(gs_vector3 * pvec, const float *p)
{
    pvec-&gt;u = p[0], pvec-&gt;v = p[1], pvec-&gt;w = p[2];
}
private int
read_floats(gs_param_list * plist, gs_param_name key, float *values, int count)
{
    gs_param_float_array fa;
    int code = param_read_float_array(plist, key, &amp;fa);

    if (code)
	return code;
    if (fa.size != count)
	return_error(gs_error_rangecheck);
    memcpy(values, fa.data, sizeof(float) * count);

    return 0;
}
private int
read_vector3(gs_param_list * plist, gs_param_name key,
	     gs_vector3 * pvec, const gs_vector3 * dflt)
{
    float values[3];
    int code = read_floats(plist, key, values, 3);

    switch (code) {
	case 1:		/* not defined */
	    if (dflt)
		*pvec = *dflt;
	    break;
	case 0:
	    load_vector3(pvec, values);
	default:		/* error */
	    break;
    }
    return code;
}
private int
read_matrix3(gs_param_list * plist, gs_param_name key, gs_matrix3 * pmat)
{
    float values[9];
    int code = read_floats(plist, key, values, 9);

    switch (code) {
	case 1:		/* not defined */
	    *pmat = Matrix3_default;
	    break;
	case 0:
	    load_vector3(&amp;pmat-&gt;cu, values);
	    load_vector3(&amp;pmat-&gt;cv, values + 3);
	    load_vector3(&amp;pmat-&gt;cw, values + 6);
	default:		/* error */
	    break;
    }
    return code;
}
private int
read_range3(gs_param_list * plist, gs_param_name key, gs_range3 * prange)
{
    float values[6];
    int code = read_floats(plist, key, values, 6);

    switch (code) {
	case 1:		/* not defined */
	    *prange = Range3_default;
	    break;
	case 0:
	    prange-&gt;ranges[0].rmin = values[0];
	    prange-&gt;ranges[0].rmax = values[1];
	    prange-&gt;ranges[1].rmin = values[2];
	    prange-&gt;ranges[1].rmax = values[3];
	    prange-&gt;ranges[2].rmin = values[4];
	    prange-&gt;ranges[2].rmax = values[5];
	default:		/* error */
	    break;
    }
    return code;
}
private int
read_proc3(gs_param_list * plist, gs_param_name key,
	   float values[gx_cie_cache_size * 3])
{
    return read_floats(plist, key, values, gx_cie_cache_size * 3);
}

/* Read a CRD from a device parameter. */
int
gs_cie_render1_param_initialize(gs_cie_render * pcrd, gs_param_list * plist,
				gs_param_name key, gx_device * dev)
{
    gs_param_dict dict;
    int code = param_begin_read_dict(plist, key, &amp;dict, false);
    int dcode;

    if (code &lt; 0)
	return code;
    code = param_get_cie_render1(pcrd, dict.list, dev);
    dcode = param_end_read_dict(plist, key, &amp;dict);
    if (code &lt; 0)
	return code;
    if (dcode &lt; 0)
	return dcode;
    gs_cie_render_init(pcrd);
    gs_cie_render_sample(pcrd);
    return gs_cie_render_complete(pcrd);
}

/* Define the structure for passing Encode values as "client data". */
typedef struct encode_data_s {
    float lmn[gx_cie_cache_size * 3]; /* EncodeLMN */
    float abc[gx_cie_cache_size * 3]; /* EncodeABC */
    float t[gx_cie_cache_size * 4]; /* RenderTable.T */
} encode_data_t;

/* Define procedures that retrieve the Encode values read from the list. */
private float
encode_from_data(floatp v, const float values[gx_cie_cache_size],
		 const gs_range * range)
{
    return (v &lt;= range-&gt;rmin ? values[0] :
	    v &gt;= range-&gt;rmax ? values[gx_cie_cache_size - 1] :
	    values[(int)((v - range-&gt;rmin) / (range-&gt;rmax - range-&gt;rmin) *
			 (gx_cie_cache_size - 1) + 0.5)]);
}
/*
 * The repetitive boilerplate in the next 10 procedures really sticks in
 * my craw, but I've got a mandate not to use macros....
 */
private float
encode_lmn_0_from_data(floatp v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return encode_from_data(v, &amp;data-&gt;lmn[0],
			    &amp;pcrd-&gt;DomainLMN.ranges[0]);
}
private float
encode_lmn_1_from_data(floatp v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return encode_from_data(v, &amp;data-&gt;lmn[gx_cie_cache_size],
			    &amp;pcrd-&gt;DomainLMN.ranges[1]);
}
private float
encode_lmn_2_from_data(floatp v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return encode_from_data(v, &amp;data-&gt;lmn[gx_cie_cache_size * 2],
			    &amp;pcrd-&gt;DomainLMN.ranges[2]);
}
private float
encode_abc_0_from_data(floatp v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return encode_from_data(v, &amp;data-&gt;abc[0],
			    &amp;pcrd-&gt;DomainABC.ranges[0]);
}
private float
encode_abc_1_from_data(floatp v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return encode_from_data(v, &amp;data-&gt;abc[gx_cie_cache_size],
			    &amp;pcrd-&gt;DomainABC.ranges[1]);
}
private float
encode_abc_2_from_data(floatp v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return encode_from_data(v, &amp;data-&gt;abc[gx_cie_cache_size * 2],
			    &amp;pcrd-&gt;DomainABC.ranges[2]);
}
private frac
render_table_t_0_from_data(byte v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return float2frac(encode_from_data(v / 255.0,
				       &amp;data-&gt;t[0],
				       &amp;Range3_default.ranges[0]));
}
private frac
render_table_t_1_from_data(byte v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return float2frac(encode_from_data(v / 255.0,
				       &amp;data-&gt;t[gx_cie_cache_size],
				       &amp;Range3_default.ranges[0]));
}
private frac
render_table_t_2_from_data(byte v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return float2frac(encode_from_data(v / 255.0,
				       &amp;data-&gt;t[gx_cie_cache_size * 2],
				       &amp;Range3_default.ranges[0]));
}
private frac
render_table_t_3_from_data(byte v, const gs_cie_render * pcrd)
{
    const encode_data_t *data = pcrd-&gt;client_data;

    return float2frac(encode_from_data(v / 255.0,
				       &amp;data-&gt;t[gx_cie_cache_size * 3],
				       &amp;Range3_default.ranges[0]));
}
private const gs_cie_render_proc3 EncodeLMN_from_data = {
    {encode_lmn_0_from_data, encode_lmn_1_from_data, encode_lmn_2_from_data}
};
private const gs_cie_render_proc3 EncodeABC_from_data = {
    {encode_abc_0_from_data, encode_abc_1_from_data, encode_abc_2_from_data}
};
private const gs_cie_render_table_procs RenderTableT_from_data = {
    {render_table_t_0_from_data, render_table_t_1_from_data,
     render_table_t_2_from_data, render_table_t_3_from_data
    }
};

/* Read a CRD directly from a parameter list. */
int
param_get_cie_render1(gs_cie_render * pcrd, gs_param_list * plist,
		      gx_device * dev)
{
    encode_data_t data;
    gs_param_int_array rt_size;
    int crd_type;
    int code, code_lmn, code_abc, code_rt, code_t;
    gs_param_string pname, pdata;

    /* Reset the status to invalidate cached information. */
    pcrd-&gt;status = CIE_RENDER_STATUS_BUILT;
    if ((code = param_read_int(plist, "ColorRenderingType", &amp;crd_type)) &lt; 0 ||
	crd_type != GX_DEVICE_CRD1_TYPE ||
	(code = read_vector3(plist, "WhitePoint", &amp;pcrd-&gt;points.WhitePoint,
			     NULL)) &lt; 0 ||
	(code = read_vector3(plist, "BlackPoint", &amp;pcrd-&gt;points.BlackPoint,
			     &amp;BlackPoint_default)) &lt; 0 ||
	(code = read_matrix3(plist, "MatrixPQR", &amp;pcrd-&gt;MatrixPQR)) &lt; 0 ||
	(code = read_range3(plist, "RangePQR", &amp;pcrd-&gt;RangePQR)) &lt; 0 ||
	/* TransformPQR is handled specially below. */
	(code = read_matrix3(plist, "MatrixLMN", &amp;pcrd-&gt;MatrixLMN)) &lt; 0 ||
	(code_lmn = code =
	 read_proc3(plist, "EncodeLMNValues", data.lmn)) &lt; 0 ||
	(code = read_range3(plist, "RangeLMN", &amp;pcrd-&gt;RangeLMN)) &lt; 0 ||
	(code = read_matrix3(plist, "MatrixABC", &amp;pcrd-&gt;MatrixABC)) &lt; 0 ||
	(code_abc = code =
	 read_proc3(plist, "EncodeABCValues", data.abc)) &lt; 0 ||
	(code = read_range3(plist, "RangeABC", &amp;pcrd-&gt;RangeABC)) &lt; 0
	)
	return code;
    /* Handle the sampled functions. */
    switch (code = param_read_string(plist, "TransformPQRName", &amp;pname)) {
	default:		/* error */
	    return code;
	case 1:			/* missing */
	    pcrd-&gt;TransformPQR = TransformPQR_default;
	    break;
	case 0:			/* specified */
	    /* The procedure name must be null-terminated: */
	    /* see param_put_cie_render1 above. */
	    if (pname.size &lt; 1 || pname.data[pname.size - 1] != 0)
		return_error(gs_error_rangecheck);
	    pcrd-&gt;TransformPQR.proc = TransformPQR_lookup_proc_name;
	    pcrd-&gt;TransformPQR.proc_name = (const char *)pname.data;
	    switch (code = param_read_string(plist, "TransformPQRData", &amp;pdata)) {
		default:	/* error */
		    return code;
		case 1:		/* missing */
		    pcrd-&gt;TransformPQR.proc_data.data = 0;
		    pcrd-&gt;TransformPQR.proc_data.size = 0;
		    break;
		case 0:
		    pcrd-&gt;TransformPQR.proc_data.data = pdata.data;
		    pcrd-&gt;TransformPQR.proc_data.size = pdata.size;
	    }
	    pcrd-&gt;TransformPQR.driver_name = gs_devicename(dev);
	    break;
    }
    pcrd-&gt;client_data = &amp;data;
    if (code_lmn &gt; 0)
	pcrd-&gt;EncodeLMN = Encode_default;
    else
	pcrd-&gt;EncodeLMN = EncodeLMN_from_data;
    if (code_abc &gt; 0)
	pcrd-&gt;EncodeABC = Encode_default;
    else
	pcrd-&gt;EncodeABC = EncodeABC_from_data;
    code_rt = code = param_read_int_array(plist, "RenderTableSize", &amp;rt_size);
    if (code == 1) {
	if (pcrd-&gt;RenderTable.lookup.table) {
	    gs_free_object(pcrd-&gt;rc.memory,
		(void *)pcrd-&gt;RenderTable.lookup.table, /* break const */
		"param_get_cie_render1(RenderTable)");
	    pcrd-&gt;RenderTable.lookup.table = 0;
	}
	pcrd-&gt;RenderTable.T = RenderTableT_default;
	code_t = 1;
    } else if (code &lt; 0)
	return code;
    else if (rt_size.size != 4)
	return_error(gs_error_rangecheck);
    else {
	gs_param_string_array rt_values;
	gs_const_string *table;
	int n, m, j;

	for (j = 0; j &lt; rt_size.size; ++j)
	    if (rt_size.data[j] &lt; 1)
		return_error(gs_error_rangecheck);
	code = param_read_string_array(plist, "RenderTableTable", &amp;rt_values);
	if (code &lt; 0)
	    return code;
	if (code &gt; 0 || rt_values.size != rt_size.data[0])
	    return_error(gs_error_rangecheck);
	/* Note: currently n = 3 (rt_size.size = 4) always. */
	for (j = 0; j &lt; rt_values.size; ++j)
	    if (rt_values.data[j].size !=
		rt_size.data[1] * rt_size.data[2] * rt_size.data[3])
		return_error(gs_error_rangecheck);
	pcrd-&gt;RenderTable.lookup.n = n = rt_size.size - 1;
	pcrd-&gt;RenderTable.lookup.m = m = rt_size.data[n];
	if (n &gt; 4 || m &gt; 4)
	    return_error(gs_error_rangecheck);
	memcpy(pcrd-&gt;RenderTable.lookup.dims, rt_size.data, n * sizeof(int));
	table =
	    gs_alloc_struct_array(pcrd-&gt;rc.memory,
				  pcrd-&gt;RenderTable.lookup.dims[0],
				  gs_const_string, &amp;st_const_string_element,
				  "RenderTable table");
	if (table == 0)
	    return_error(gs_error_VMerror);
	for (j = 0; j &lt; pcrd-&gt;RenderTable.lookup.dims[0]; ++j) {
	    table[j].data = rt_values.data[j].data;
	    table[j].size = rt_values.data[j].size;
	}
	pcrd-&gt;RenderTable.lookup.table = table;
	pcrd-&gt;RenderTable.T = RenderTableT_from_data;
	code_t = code = read_floats(plist, "RenderTableTValues", data.t,
				    gx_cie_cache_size * m);
	if (code &gt; 0)
	    pcrd-&gt;RenderTable.T = RenderTableT_default;
	else if (code == 0)
	    pcrd-&gt;RenderTable.T = RenderTableT_from_data;
    }
    if ((code = gs_cie_render_init(pcrd)) &gt;= 0 &amp;&amp;
	(code = gs_cie_render_sample(pcrd)) &gt;= 0
	)
	code = gs_cie_render_complete(pcrd);
    /* Clean up before exiting. */
    pcrd-&gt;client_data = 0;
    if (code_lmn == 0)
	pcrd-&gt;EncodeLMN = EncodeLMN_from_cache;
    if (code_abc == 0)
	pcrd-&gt;EncodeABC = EncodeABC_from_cache;
    if (code_t == 0)
	pcrd-&gt;RenderTable.T = RenderTableT_from_cache;
    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

