<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gsfcid2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gsfcid2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2002 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gsfcid2.c,v 1.6 2004/08/04 19:36:12 stefan Exp $ */
/* Create a CIDFontType 2 font from a Type 42 font. */
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gsutil.h"
#include "gxfont.h"
#include "gxfcid.h"
#include "gxfcmap.h"
#include "gxfont0c.h"

/*
 * Create a Type 2 CIDFont from a Type 42 font.
 */
private int
identity_CIDMap_proc(gs_font_cid2 *pfont, gs_glyph glyph)
{
    ulong cid = glyph - gs_min_cid_glyph;

    if (cid &gt;= pfont-&gt;cidata.common.CIDCount)
	return_error(gs_error_rangecheck);
    return (int)cid;
}
int
gs_font_cid2_from_type42(gs_font_cid2 **ppfcid, gs_font_type42 *pfont42,
			 int wmode, gs_memory_t *mem)
{
    gs_font_cid2 *pfcid =
	gs_alloc_struct(mem, gs_font_cid2, &amp;st_gs_font_cid2,
			"gs_font_cid2_from_type42");

    if (pfcid == 0)
	return_error(gs_error_VMerror);

    /* CIDFontType 2 is a subclass (extension) of FontType 42. */
    memcpy(pfcid, pfont42, sizeof(*pfont42));
    pfcid-&gt;memory = mem;
    pfcid-&gt;next = pfcid-&gt;prev = 0; /* probably not necessary */
    pfcid-&gt;is_resource = 0;
    gs_font_notify_init((gs_font *)pfcid);
    pfcid-&gt;id = gs_next_ids(mem, 1);
    pfcid-&gt;base = (gs_font *)pfcid;
    pfcid-&gt;FontType = ft_CID_TrueType;
    /* Fill in the rest of the CIDFont data. */
    cid_system_info_set_null(&amp;pfcid-&gt;cidata.common.CIDSystemInfo);
    pfcid-&gt;cidata.common.CIDCount = pfont42-&gt;data.numGlyphs;
    pfcid-&gt;cidata.common.GDBytes = 2; /* not used */
    pfcid-&gt;cidata.MetricsCount = 0;
    pfcid-&gt;cidata.CIDMap_proc = identity_CIDMap_proc;
    /* Since MetricsCount == 0, don't need orig_procs. */

    *ppfcid = pfcid;
    return 0;
}

/* Set up a pointer to a substring of the font data. */
#define ACCESS(base, length, vptr)\
  BEGIN\
    code = pfont-&gt;data.string_proc(pfont, (ulong)(base), length, &amp;vptr);\
    if ( code &lt; 0 ) return code;\
  END
#define U16(p) (((uint)((p)[0]) &lt;&lt; 8) + (p)[1])
#define U32(p) get_u32_msb(p)
#define PUT16(p, v)\
  BEGIN (p)[0] = (byte)((v) &gt;&gt; 8); (p)[1] = (byte)(v); END

/*
 * Define a subclass of gs_cmap_t that accesses the most common type of
 * TrueType cmap (Platform 3, Encoding 1, Format 4) directly.
 */
typedef struct gs_cmap_tt_16bit_format4_s {
    GS_CMAP_COMMON;
    gs_font_type42 *font;
    uint segCount2;
    ulong endCount, startCount, idDelta, idRangeOffset, glyphIdArray;
} gs_cmap_tt_16bit_format4_t;
gs_private_st_suffix_add1(st_cmap_tt_16bit_format4, gs_cmap_tt_16bit_format4_t,
  "gs_cmap_tt_16bit_format4_t",
  cmap_tt_16bit_format4_enum_ptrs, cmap_tt_16bit_format4_reloc_ptrs,
  st_cmap, font);

private int
tt_16bit_format4_decode_next(const gs_cmap_t * pcmap_in,
		       const gs_const_string * pstr,
		       uint * pindex, uint * pfidx,
		       gs_char * pchr, gs_glyph * pglyph)
{
    const gs_cmap_tt_16bit_format4_t *pcmap =
	(const gs_cmap_tt_16bit_format4_t *)pcmap_in;
    gs_font_type42 *pfont = pcmap-&gt;font;
    const byte *ttdata;
    int code;
    uint chr, value = 0;
    uint segment2;

    if (pstr-&gt;size &lt; *pindex + 2) {
	*pglyph = gs_no_glyph;
	return (*pindex == pstr-&gt;size ? 2 : -1);
    }
    chr = U16(pstr-&gt;data + *pindex);
    /* The table is sorted, but we use linear search for simplicity. */
    for (segment2 = 0; segment2 &lt; pcmap-&gt;segCount2; segment2 += 2) {
	uint start, delta, roff;

	ACCESS(pcmap-&gt;endCount + segment2, 2, ttdata);
	if (chr &gt; U16(ttdata))
	    continue;
	ACCESS(pcmap-&gt;startCount + segment2, 2, ttdata);
	start = U16(ttdata);
	if (chr &lt; start)
	    continue;
	ACCESS(pcmap-&gt;idDelta + segment2, 2, ttdata);
	delta = U16(ttdata);
	ACCESS(pcmap-&gt;idRangeOffset + segment2, 2, ttdata);
	roff = U16(ttdata);
	if (roff) {
	    ulong gidoff = pcmap-&gt;idRangeOffset + segment2 + roff +
		(chr - start) * 2;

	    ACCESS(gidoff, 2, ttdata);
	    value = U16(ttdata);
	    if (value != 0)
		value += delta;
	} else
	    value = chr + delta;
	break;
    }
    *pglyph = gs_min_cid_glyph + (value &amp; 0xffff);
    *pchr = chr;
    *pindex += 2;
    *pfidx = 0;
    return 0;
}
private int
tt_16bit_format4_next_range(gs_cmap_ranges_enum_t *penum)
{
    /* There is just a single 2-byte range. */
    if (penum-&gt;index == 0) {
	penum-&gt;range.first[0] = penum-&gt;range.first[1] = 0;
	penum-&gt;range.last[0] = penum-&gt;range.last[1] = 0xff;
	penum-&gt;range.size = 2;
	penum-&gt;index = 1;
	return 0;
    }
    return 1;
}
private const gs_cmap_ranges_enum_procs_t tt_16bit_format4_range_procs = {
    tt_16bit_format4_next_range
};
private void
tt_16bit_format4_enum_ranges(const gs_cmap_t *pcmap,
			     gs_cmap_ranges_enum_t *pre)
{
    gs_cmap_ranges_enum_setup(pre, pcmap, &amp;tt_16bit_format4_range_procs);
}
private int
tt_16bit_format4_next_lookup(gs_cmap_lookups_enum_t *penum)
{
    if (penum-&gt;index[0] == 0) {
	penum-&gt;entry.key_size = 2;
	penum-&gt;entry.key_is_range = true;
	penum-&gt;entry.value_type = CODE_VALUE_CID;
	penum-&gt;entry.value.size = 2;
	penum-&gt;entry.font_index = 0;
	penum-&gt;index[0] = 1;
	return 0;
    }
    return 1;
}
private int
tt_16bit_format4_next_entry(gs_cmap_lookups_enum_t *penum)
{
    /* index[1] is segment # &lt;&lt; 17 + first code. */
    uint segment2 = penum-&gt;index[1] &gt;&gt; 16;
    uint next = penum-&gt;index[1] &amp; 0xffff;
    const gs_cmap_tt_16bit_format4_t *pcmap =
	(const gs_cmap_tt_16bit_format4_t *)penum-&gt;cmap;
    gs_font_type42 *pfont = pcmap-&gt;font;
    const byte *ttdata;
    int code;
    uint start, end, delta, roff;
    uint value;

 top:
    if (segment2 &gt;= pcmap-&gt;segCount2)
	return 1;
    ACCESS(pcmap-&gt;endCount + segment2, 2, ttdata);
    end = U16(ttdata);
    if (next &gt; end) {
	segment2 += 2;
	goto top;
    }
    ACCESS(pcmap-&gt;startCount + segment2, 2, ttdata);
    start = U16(ttdata);
    if (next &lt; start)
	next = start;
    PUT16(penum-&gt;entry.key[0], next);
    ACCESS(pcmap-&gt;idDelta + segment2, 2, ttdata);
    delta = U16(ttdata);
    ACCESS(pcmap-&gt;idRangeOffset + segment2, 2, ttdata);
    roff = U16(ttdata);
    if (roff) {
	/* Non-zero offset, table lookup. */
	ulong gidoff = pcmap-&gt;idRangeOffset + segment2 + roff;

	ACCESS(gidoff, 2, ttdata);
	value = U16(ttdata);
	if (value != 0)
	    value += delta;
	++next;
    } else {
	/* Zero offset, account for high-order byte changes. */
	value = next + delta;
	next = min(end, (next | 0xff)) + 1;
    }
    PUT16(penum-&gt;entry.key[1], next - 1);
    PUT16(penum-&gt;temp_value, value);
    penum-&gt;entry.value.data = penum-&gt;temp_value;
    penum-&gt;entry.value.size = 2;
    penum-&gt;index[1] = (segment2 &lt;&lt; 16) + next;
    return 0;
}
private const gs_cmap_lookups_enum_procs_t tt_16bit_format4_lookup_procs = {
    tt_16bit_format4_next_lookup, tt_16bit_format4_next_entry
};
private void
tt_16bit_format4_enum_lookups(const gs_cmap_t *pcmap, int which,
			gs_cmap_lookups_enum_t *pre)
{
    gs_cmap_lookups_enum_setup(pre, pcmap,
			       (which ? &amp;gs_cmap_no_lookups_procs :
				&amp;tt_16bit_format4_lookup_procs));
}

private const gs_cmap_procs_t tt_16bit_format4_procs = {
    tt_16bit_format4_decode_next,
    tt_16bit_format4_enum_ranges,
    tt_16bit_format4_enum_lookups,
    gs_cmap_compute_identity
};

/*
 * Create a CMap from a TrueType Platform 3, Encoding 1, Format 4 cmap.
 */
int
gs_cmap_from_type42_cmap(gs_cmap_t **ppcmap, gs_font_type42 *pfont,
			 int wmode, gs_memory_t *mem)
{
    ulong origin = pfont-&gt;data.cmap;
    gs_cmap_tt_16bit_format4_t *pcmap;
    int code;
    const byte *ttdata;
    ulong offset = origin;
    uint segCount2;

    if (origin == 0)
	return_error(gs_error_invalidfont);

    /*
     * Find the desired cmap sub-table, if any.
     */
    {
	uint cmap_count;
	uint i;
	
	ACCESS(origin + 2, 2, ttdata);
	cmap_count = U16(ttdata);
	for (i = 0; i &lt; cmap_count; ++i) {
	    ACCESS(origin + 4 + i * 8, 8, ttdata);
	    if (U16(ttdata) != 3 || /* platform ID */
		U16(ttdata + 2) != 1 /* encoding ID */
		)
		continue;
	    offset = origin + U32(ttdata + 4);
	    ACCESS(offset, 2, ttdata);
	    if (U16(ttdata) != 4 /* format */)
		continue;
	    break;
	}
	if (i &gt;= cmap_count)	/* not found */
	    return_error(gs_error_invalidfont);
	ACCESS(offset + 6, 2, ttdata);
	segCount2 = U16(ttdata);
    }

    /* Allocate the CMap. */
    {
	static const gs_cid_system_info_t null_cidsi = {
	    { (const byte*) "none", 4 },
	    { (const byte*) "none", 4 },
	    0
	};
	code = gs_cmap_alloc(ppcmap, &amp;st_cmap_tt_16bit_format4, wmode,
			     (const byte *)"none", 4, &amp;null_cidsi, 1,
			     &amp;tt_16bit_format4_procs, mem);
	if (code &lt; 0)
	    return code;
    }
    pcmap = (gs_cmap_tt_16bit_format4_t *)*ppcmap;
    pcmap-&gt;from_Unicode = true;
    pcmap-&gt;font = pfont;
    pcmap-&gt;segCount2 = segCount2;
    pcmap-&gt;endCount = offset + 14;
    pcmap-&gt;startCount = pcmap-&gt;endCount + segCount2 + 2;
    pcmap-&gt;idDelta = pcmap-&gt;startCount + segCount2;
    pcmap-&gt;idRangeOffset = pcmap-&gt;idDelta + segCount2;
    pcmap-&gt;glyphIdArray = pcmap-&gt;idRangeOffset + segCount2;
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

