<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gsfont.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gsfont.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gsfont.c,v 1.37 2005/07/27 11:24:38 igor Exp $ */
/* Font operators for Ghostscript library */
#include "gx.h"
#include "memory_.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gsutil.h"
#include "gxfixed.h"
#include "gxmatrix.h"
#include "gzstate.h"		/* must precede gxdevice */
#include "gxdevice.h"		/* must precede gxfont */
#include "gxfont.h"
#include "gxfcache.h"
#include "gzpath.h"		/* for default implementation */

/* Define the sizes of the various aspects of the font/character cache. */
/*** Big memory machines ***/
#define smax_LARGE 50		/* smax - # of scaled fonts */
#define bmax_LARGE 500000	/* bmax - space for cached chars */
#define mmax_LARGE 200		/* mmax - # of cached font/matrix pairs */
#define cmax_LARGE 5000		/* cmax - # of cached chars */
#define blimit_LARGE 2500	/* blimit/upper - max size of a single cached char */
/*** Small memory machines ***/
#define smax_SMALL 20		/* smax - # of scaled fonts */
#define bmax_SMALL 25000	/* bmax - space for cached chars */
#define mmax_SMALL 40		/* mmax - # of cached font/matrix pairs */
#define cmax_SMALL 500		/* cmax - # of cached chars */
#define blimit_SMALL 100	/* blimit/upper - max size of a single cached char */

/* Define a default procedure vector for fonts. */
const gs_font_procs gs_font_procs_default = {
    gs_no_define_font,		/* (actually a default) */
    gs_no_make_font,		/* (actually a default) */
    gs_default_font_info,
    gs_default_same_font,
    gs_no_encode_char,
    gs_no_decode_glyph,
    gs_no_enumerate_glyph,
    gs_default_glyph_info,
    gs_no_glyph_outline,
    gs_no_glyph_name,
    gs_default_init_fstack,
    gs_default_next_char_glyph,
    gs_no_build_char
};

private_st_font_dir();
private struct_proc_enum_ptrs(font_enum_ptrs);
private struct_proc_reloc_ptrs(font_reloc_ptrs);

public_st_gs_font_info();
public_st_gs_font();
public_st_gs_font_base();
private_st_gs_font_ptr();
public_st_gs_font_ptr_element();

/*
 * Garbage collection of fonts poses some special problems.  On the one
 * hand, we need to keep track of all existing base (not scaled) fonts,
 * using the next/prev list whose head is the orig_fonts member of the font
 * directory; on the other hand, we want these to be "weak" pointers that
 * don't keep fonts in existence if the fonts aren't referenced from
 * anywhere else.  We accomplish this as follows:
 *
 *     We don't trace through gs_font_dir.orig_fonts or gs_font.{next,prev}
 * during the mark phase of the GC.
 *
 *     When we finalize a base gs_font, we unlink it from the list.  (A
 * gs_font is a base font iff its base member points to itself.)
 *
 *     We *do* relocate the orig_fonts and next/prev pointers during the
 * relocation phase of the GC.  */

/* Font directory GC procedures */
private 
ENUM_PTRS_WITH(font_dir_enum_ptrs, gs_font_dir *dir)
{
    /* Enumerate pointers from cached characters to f/m pairs, */
    /* and mark the cached character glyphs. */
    /* See gxfcache.h for why we do this here. */
    uint cci = index - st_font_dir_max_ptrs;
    uint offset, count;
    uint tmask = dir-&gt;ccache.table_mask;

    if (cci == 0)
	offset = 0, count = 1;
    else if (cci == dir-&gt;enum_index + 1)
	offset = dir-&gt;enum_offset + 1, count = 1;
    else
	offset = 0, count = cci;
    for (; offset &lt;= tmask; ++offset) {
	cached_char *cc = dir-&gt;ccache.table[offset];

	if (cc != 0 &amp;&amp; !--count) {
	    (*dir-&gt;ccache.mark_glyph)
		(mem, cc-&gt;code, dir-&gt;ccache.mark_glyph_data);
	    /****** HACK: break const.  We'll fix this someday. ******/
	    ((gs_font_dir *)dir)-&gt;enum_index = cci;
	    ((gs_font_dir *)dir)-&gt;enum_offset = offset;
	    ENUM_RETURN(cc_pair(cc) - cc-&gt;pair_index);
	}
    }
}
return 0;
#define e1(i,elt) ENUM_PTR(i,gs_font_dir,elt);
font_dir_do_ptrs(e1)
#undef e1
ENUM_PTRS_END
private RELOC_PTRS_WITH(font_dir_reloc_ptrs, gs_font_dir *dir);
    /* Relocate the pointers from cached characters to f/m pairs. */
    /* See gxfcache.h for why we do this here. */
{
    int chi;

    for (chi = dir-&gt;ccache.table_mask; chi &gt;= 0; --chi) {
	cached_char *cc = dir-&gt;ccache.table[chi];

	if (cc != 0)
	    cc_set_pair_only(cc,
			     (cached_fm_pair *)
			     RELOC_OBJ(cc_pair(cc) - cc-&gt;pair_index) +
			     cc-&gt;pair_index);
    }
}
    /* We have to relocate the cached characters before we */
    /* relocate dir-&gt;ccache.table! */
RELOC_PTR(gs_font_dir, orig_fonts);
#define r1(i,elt) RELOC_PTR(gs_font_dir, elt);
font_dir_do_ptrs(r1)
#undef r1
RELOC_PTRS_END

/* GC procedures for fonts */
/*
 * When we finalize a base font, we unlink it from the orig_fonts list;
 * when we finalize a scaled font, we unlink it from scaled_fonts.
 * See above for more information.
 */
void
gs_font_finalize(void *vptr)
{
    gs_font *const pfont = vptr;
    gs_font **ppfirst;
    gs_font *next = pfont-&gt;next;
    gs_font *prev = pfont-&gt;prev;

    if_debug4('u', "[u]unlinking font 0x%lx, base=0x%lx, prev=0x%lx, next=0x%lx\n",
	    (ulong) pfont, (ulong) pfont-&gt;base, (ulong) prev, (ulong) next);
    /* Notify clients that the font is being freed. */
    gs_notify_all(&amp;pfont-&gt;notify_list, NULL);
    if (pfont-&gt;dir == 0)
	ppfirst = 0;
    else if (pfont-&gt;base == pfont)
	ppfirst = &amp;pfont-&gt;dir-&gt;orig_fonts;
    else {
	/*
	 * Track the number of cached scaled fonts.  Only decrement the
	 * count if we didn't do this already in gs_makefont.
	 */
	if (next || prev || pfont-&gt;dir-&gt;scaled_fonts == pfont)
	    pfont-&gt;dir-&gt;ssize--;
	ppfirst = &amp;pfont-&gt;dir-&gt;scaled_fonts;
    }
    /*
     * gs_purge_font may have unlinked this font already:
     * don't unlink it twice.
     */
    if (next != 0 &amp;&amp; next-&gt;prev == pfont)
	next-&gt;prev = prev;
    if (prev != 0) {
	if (prev-&gt;next == pfont)
	    prev-&gt;next = next;
    } else if (ppfirst != 0 &amp;&amp; *ppfirst == pfont)
	*ppfirst = next;
    gs_notify_release(&amp;pfont-&gt;notify_list);
}
private 
ENUM_PTRS_WITH(font_enum_ptrs, gs_font *pfont) return ENUM_USING(st_gs_notify_list, &amp;pfont-&gt;notify_list, sizeof(gs_notify_list_t), index - 5);
	/* We don't enumerate next or prev of base fonts. */
	/* See above for details. */
case 0: ENUM_RETURN((pfont-&gt;base == pfont ? 0 : pfont-&gt;next));
case 1: ENUM_RETURN((pfont-&gt;base == pfont ? 0 : pfont-&gt;prev));
ENUM_PTR3(2, gs_font, dir, base, client_data);
ENUM_PTRS_END
private RELOC_PTRS_WITH(font_reloc_ptrs, gs_font *pfont);
RELOC_USING(st_gs_notify_list, &amp;pfont-&gt;notify_list, sizeof(gs_notify_list_t));
	/* We *do* always relocate next and prev. */
	/* Again, see above for details. */
RELOC_PTR(gs_font, next);
RELOC_PTR(gs_font, prev);
RELOC_PTR3(gs_font, dir, base, client_data);
RELOC_PTRS_END

/* Allocate a font directory */
private bool
cc_no_mark_glyph(const gs_memory_t *mem, gs_glyph glyph, void *ignore_data)
{
    return false;
}
gs_font_dir *
gs_font_dir_alloc2(gs_memory_t * struct_mem, gs_memory_t * bits_mem)
{
    gs_font_dir *pdir = 0;

#if !arch_small_memory
#  ifdef DEBUG
    if (!gs_debug_c('.'))
#  endif
    {				/* Try allocating a very large cache. */
	/* If this fails, allocate a small one. */
	pdir = gs_font_dir_alloc2_limits(struct_mem, bits_mem,
					 smax_LARGE, bmax_LARGE, mmax_LARGE,
					 cmax_LARGE, blimit_LARGE);
    }
    if (pdir == 0)
#endif
	pdir = gs_font_dir_alloc2_limits(struct_mem, bits_mem,
					 smax_SMALL, bmax_SMALL, mmax_SMALL,
					 cmax_SMALL, blimit_SMALL);
    if (pdir == 0)
	return 0;
    pdir-&gt;ccache.mark_glyph = cc_no_mark_glyph;
    pdir-&gt;ccache.mark_glyph_data = 0;
    return pdir;
}
gs_font_dir *
gs_font_dir_alloc2_limits(gs_memory_t * struct_mem, gs_memory_t * bits_mem,
		     uint smax, uint bmax, uint mmax, uint cmax, uint upper)
{
    gs_font_dir *pdir =
	gs_alloc_struct(struct_mem, gs_font_dir, &amp;st_font_dir,
			"font_dir_alloc(dir)");
    int code;

    if (pdir == 0)
	return 0;
    code = gx_char_cache_alloc(struct_mem, bits_mem, pdir,
			       bmax, mmax, cmax, upper);
    if (code &lt; 0) {
	gs_free_object(struct_mem, pdir, "font_dir_alloc(dir)");
	return 0;
    }
    pdir-&gt;orig_fonts = 0;
    pdir-&gt;scaled_fonts = 0;
    pdir-&gt;ssize = 0;
    pdir-&gt;smax = smax;
    pdir-&gt;align_to_pixels = false;
    pdir-&gt;glyph_to_unicode_table = NULL;
    pdir-&gt;grid_fit_tt = 2;
    pdir-&gt;memory = struct_mem;
    pdir-&gt;tti = 0;
    pdir-&gt;san = 0;
    pdir-&gt;global_glyph_code = NULL;
    return pdir;
}

/* Allocate and minimally initialize a font. */
gs_font *
gs_font_alloc(gs_memory_t *mem, gs_memory_type_ptr_t pstype,
	      const gs_font_procs *procs, gs_font_dir *dir,
	      client_name_t cname)
{
    gs_font *pfont = gs_alloc_struct(mem, gs_font, pstype, cname);

    if (pfont == 0)
	return 0;
#if 1 /* Clear entire structure to avoid unitialized pointers 
         when the initialization exits prematurely by error. */
    memset(pfont, 0, pstype-&gt;ssize);
    pfont-&gt;memory = mem;
    pfont-&gt;dir = dir;
    gs_font_notify_init(pfont);
    pfont-&gt;id = gs_next_ids(mem, 1);
    pfont-&gt;base = pfont;
    pfont-&gt;ExactSize = pfont-&gt;InBetweenSize = pfont-&gt;TransformedChar =
	fbit_use_outlines;
    pfont-&gt;procs = *procs;
#else
    /* For clarity we leave old initializations here
       to know which fields needs to be initialized. */
    pfont-&gt;next = pfont-&gt;prev = 0;
    pfont-&gt;memory = mem;
    pfont-&gt;dir = dir;
    pfont-&gt;is_resource = false;
    gs_font_notify_init(pfont);
    pfont-&gt;id = gs_next_ids(mem, 1);
    pfont-&gt;base = pfont;
    pfont-&gt;client_data = 0;
    /* not FontMatrix, FontType */
    pfont-&gt;BitmapWidths = false;
    pfont-&gt;ExactSize = pfont-&gt;InBetweenSize = pfont-&gt;TransformedChar =
	fbit_use_outlines;
    pfont-&gt;WMode = 0;
    pfont-&gt;PaintType = 0;
    pfont-&gt;StrokeWidth = 0;
    pfont-&gt;procs = *procs;
    memset(&amp;pfont-&gt;orig_FontMatrix, 0, sizeof(pfont-&gt;orig_FontMatrix));
#endif
    /* not key_name, font_name */
    return pfont;
}
/* Allocate and minimally initialize a base font. */
gs_font_base *
gs_font_base_alloc(gs_memory_t *mem, gs_memory_type_ptr_t pstype,
		   const gs_font_procs *procs, gs_font_dir *dir,
		   client_name_t cname)
{
    gs_font_base *pfont =
	(gs_font_base *)gs_font_alloc(mem, pstype, procs, dir, cname);

    if (pfont == 0)
	return 0;
    pfont-&gt;FontBBox.p.x = pfont-&gt;FontBBox.p.y =
	pfont-&gt;FontBBox.q.x = pfont-&gt;FontBBox.q.y = 0;
    uid_set_invalid(&amp;pfont-&gt;UID);
    pfont-&gt;encoding_index = pfont-&gt;nearest_encoding_index = -1;
    return pfont;
}

/* Initialize the notification list for a font. */
void
gs_font_notify_init(gs_font *font)
{
    /*
     * The notification list for a font must be allocated in the font's
     * stable memory, because of the following possible sequence of events:
     *
     *   - Allocate font X in local VM.
     *   - Client A registers for notification when X is freed.
     *   - 'save'
     *   - Client B registers for notification when X is freed.
     *   - 'restore'
     *
     * If the notification list element for client B is allocated in
     * restorable local VM (i.e., the same VM as the font), then when the
     * 'restore' occurs, either the list element will be deleted (not what
     * client B wants, because font X hasn't been freed yet), or there will
     * be a dangling pointer.
     */
    gs_notify_init(&amp;font-&gt;notify_list, gs_memory_stable(font-&gt;memory));
}


/*
 * Register/unregister a client for notification by a font.  Currently
 * the clients are only notified when a font is freed.  Note that any
 * such client must unregister itself when *it* is freed.
 */
int
gs_font_notify_register(gs_font *font, gs_notify_proc_t proc, void *proc_data)
{
    return gs_notify_register(&amp;font-&gt;notify_list, proc, proc_data);
}
int
gs_font_notify_unregister(gs_font *font, gs_notify_proc_t proc, void *proc_data)
{
    return gs_notify_unregister(&amp;font-&gt;notify_list, proc, proc_data);
}

/* Link an element at the head of a chain. */
private void
font_link_first(gs_font **pfirst, gs_font *elt)
{
    gs_font *first = elt-&gt;next = *pfirst;

    if (first)
	first-&gt;prev = elt;
    elt-&gt;prev = 0;
    *pfirst = elt;
}

/* definefont */
/* Use this only for original (unscaled) fonts! */
/* Note that it expects pfont-&gt;procs.define_font to be set already. */
int
gs_definefont(gs_font_dir * pdir, gs_font * pfont)
{
    int code;

    pfont-&gt;dir = pdir;
    pfont-&gt;base = pfont;
    code = (*pfont-&gt;procs.define_font) (pdir, pfont);
    if (code &lt; 0) {		/* Make sure we don't try to finalize this font. */
	pfont-&gt;base = 0;
	return code;
    }
    font_link_first(&amp;pdir-&gt;orig_fonts, pfont);
    if_debug2('m', "[m]defining font 0x%lx, next=0x%lx\n",
	      (ulong) pfont, (ulong) pfont-&gt;next);
    return 0;
}

/* Find a sililar registered font of same type. */
int
gs_font_find_similar(const gs_font_dir * pdir, const gs_font **ppfont, 
		       int (*similar)(const gs_font *, const gs_font *))
{
    const gs_font *pfont0 = *ppfont;
    const gs_font *pfont1 = pdir-&gt;orig_fonts;

    for (; pfont1 != NULL; pfont1 = pfont1-&gt;next) {
	if (pfont1 != pfont0 &amp;&amp; pfont1-&gt;FontType == pfont0-&gt;FontType) {
	    int code = similar(pfont0, pfont1);
	    if (code != 0) {
		*ppfont = pfont1;
		return code;
	    }
	}
    }
    return 0;
}

/* scalefont */
int
gs_scalefont(gs_font_dir * pdir, const gs_font * pfont, floatp scale,
	     gs_font ** ppfont)
{
    gs_matrix mat;

    gs_make_scaling(scale, scale, &amp;mat);
    return gs_makefont(pdir, pfont, &amp;mat, ppfont);
}

/* makefont */
int
gs_makefont(gs_font_dir * pdir, const gs_font * pfont,
	    const gs_matrix * pmat, gs_font ** ppfont)
{
    int code;
    gs_font *prev = 0;
    gs_font *pf_out = pdir-&gt;scaled_fonts;
    gs_memory_t *mem = pfont-&gt;memory;
    gs_matrix newmat;
    bool can_cache;

    if ((code = gs_matrix_multiply(&amp;pfont-&gt;FontMatrix, pmat, &amp;newmat)) &lt; 0)
	return code;
    /*
     * Check for the font already being in the scaled font cache.
     * Until version 5.97, we only cached scaled fonts if the base
     * (unscaled) font had a valid UniqueID or XUID; now, we will cache
     * scaled versions of any non-composite font.
     */
#ifdef DEBUG
    if (gs_debug_c('m')) {
	const gs_font_base *const pbfont = (const gs_font_base *)pfont;

	if (pfont-&gt;FontType == ft_composite)
	    dlprintf("[m]composite");
	else if (uid_is_UniqueID(&amp;pbfont-&gt;UID))
	    dlprintf1("[m]UniqueID=%ld", pbfont-&gt;UID.id);
	else if (uid_is_XUID(&amp;pbfont-&gt;UID))
	    dlprintf1("[m]XUID(%u)", (uint) (-pbfont-&gt;UID.id));
	else
	    dlprintf("[m]no UID");
	dprintf7(", FontType=%d,\n[m]  new FontMatrix=[%g %g %g %g %g %g]\n",
		 pfont-&gt;FontType,
		 pmat-&gt;xx, pmat-&gt;xy, pmat-&gt;yx, pmat-&gt;yy,
		 pmat-&gt;tx, pmat-&gt;ty);
    }
#endif
    /*
     * Don't try to cache scaled composite fonts, because of the side
     * effects on FDepVector and descendant fonts that occur in makefont.
     */
    if (pfont-&gt;FontType != ft_composite) {
	for (; pf_out != 0; prev = pf_out, pf_out = pf_out-&gt;next)
	    if (pf_out-&gt;FontType == pfont-&gt;FontType &amp;&amp;
		pf_out-&gt;base == pfont-&gt;base &amp;&amp;
		pf_out-&gt;FontMatrix.xx == newmat.xx &amp;&amp;
		pf_out-&gt;FontMatrix.xy == newmat.xy &amp;&amp;
		pf_out-&gt;FontMatrix.yx == newmat.yx &amp;&amp;
		pf_out-&gt;FontMatrix.yy == newmat.yy &amp;&amp;
		pf_out-&gt;FontMatrix.tx == newmat.tx &amp;&amp;
		pf_out-&gt;FontMatrix.ty == newmat.ty
		) {
		*ppfont = pf_out;
		if_debug1('m', "[m]found font=0x%lx\n", (ulong) pf_out);
		return 0;
	    }
	can_cache = true;
    } else
	can_cache = false;
    pf_out = gs_alloc_struct(mem, gs_font, gs_object_type(mem, pfont),
			     "gs_makefont");
    if (!pf_out)
	return_error(gs_error_VMerror);
    memcpy(pf_out, pfont, gs_object_size(mem, pfont));
    gs_font_notify_init(pf_out);
    pf_out-&gt;FontMatrix = newmat;
    pf_out-&gt;client_data = 0;
    pf_out-&gt;dir = pdir;
    pf_out-&gt;base = pfont-&gt;base;
    *ppfont = pf_out;
    code = (*pf_out-&gt;procs.make_font) (pdir, pfont, pmat, ppfont);
    if (code &lt; 0)
	return code;
    if (can_cache) {
	if (pdir-&gt;ssize &gt;= pdir-&gt;smax &amp;&amp; prev != 0) {
	    /*
	     * We must discard a cached scaled font.
	     * prev points to the last (oldest) font.
	     * (We can't free it, because there might be
	     * other references to it.)
	     */
	    if_debug1('m', "[m]discarding font 0x%lx\n",
		      (ulong) prev);
	    if (prev-&gt;prev != 0)
		prev-&gt;prev-&gt;next = 0;
	    else
		pdir-&gt;scaled_fonts = 0;
	    pdir-&gt;ssize--;
	    prev-&gt;prev = 0;
	    if (prev-&gt;FontType != ft_composite) {
		if_debug1('m', "[m]discarding UID 0x%lx\n",
			  (ulong) ((gs_font_base *) prev)-&gt;
			  UID.xvalues);
		uid_free(&amp;((gs_font_base *) prev)-&gt;UID,
			 prev-&gt;memory,
			 "gs_makefont(discarding)");
		uid_set_invalid(&amp;((gs_font_base *) prev)-&gt;UID);
	    }
	}
	pdir-&gt;ssize++;
	font_link_first(&amp;pdir-&gt;scaled_fonts, pf_out);
    } else {			/* Prevent garbage pointers. */
	pf_out-&gt;next = pf_out-&gt;prev = 0;
    }
    if_debug2('m', "[m]new font=0x%lx can_cache=%s\n",
	      (ulong) * ppfont, (can_cache ? "true" : "false"));
    return 1;
}

/* Set the current font.  This is provided only for the benefit of cshow, */
/* which must reset the current font without disturbing the root font. */
void
gs_set_currentfont(gs_state * pgs, gs_font * pfont)
{
    pgs-&gt;font = pfont;
    pgs-&gt;char_tm_valid = false;
}

/* setfont */
int
gs_setfont(gs_state * pgs, gs_font * pfont)
{
    pgs-&gt;font = pgs-&gt;root_font = pfont;
    pgs-&gt;char_tm_valid = false;
    return 0;
}

/* currentfont */
gs_font *
gs_currentfont(const gs_state * pgs)
{
    return pgs-&gt;font;
}

/* rootfont */
gs_font *
gs_rootfont(const gs_state * pgs)
{
    return pgs-&gt;root_font;
}

/* cachestatus */
void
gs_cachestatus(register const gs_font_dir * pdir, register uint pstat[7])
{
    pstat[0] = pdir-&gt;ccache.bsize;
    pstat[1] = pdir-&gt;ccache.bmax;
    pstat[2] = pdir-&gt;fmcache.msize;
    pstat[3] = pdir-&gt;fmcache.mmax;
    pstat[4] = pdir-&gt;ccache.csize;
    pstat[5] = pdir-&gt;ccache.cmax;
    pstat[6] = pdir-&gt;ccache.upper;
}

/* setcacheparams */
int
gs_setcachesize(gs_font_dir * pdir, uint size)
{				/* This doesn't delete anything from the cache yet. */
    pdir-&gt;ccache.bmax = size;
    return 0;
}
int
gs_setcachelower(gs_font_dir * pdir, uint size)
{
    pdir-&gt;ccache.lower = size;
    return 0;
}
int
gs_setcacheupper(gs_font_dir * pdir, uint size)
{
    pdir-&gt;ccache.upper = size;
    return 0;
}
int
gs_setaligntopixels(gs_font_dir * pdir, uint v)
{
    pdir-&gt;align_to_pixels = v;
    return 0;
}
int
gs_setgridfittt(gs_font_dir * pdir, uint v)
{
    pdir-&gt;grid_fit_tt = v;
    return 0;
}

/* currentcacheparams */
uint
gs_currentcachesize(const gs_font_dir * pdir)
{
    return pdir-&gt;ccache.bmax;
}
uint
gs_currentcachelower(const gs_font_dir * pdir)
{
    return pdir-&gt;ccache.lower;
}
uint
gs_currentcacheupper(const gs_font_dir * pdir)
{
    return pdir-&gt;ccache.upper;
}
uint
gs_currentaligntopixels(const gs_font_dir * pdir)
{
    return pdir-&gt;align_to_pixels;
}
uint
gs_currentgridfittt(const gs_font_dir * pdir)
{
    return pdir-&gt;grid_fit_tt;
}

/* Purge a font from all font- and character-related tables. */
/* This is only used by restore (and, someday, the GC). */
void
gs_purge_font(gs_font * pfont)
{
    gs_font_dir *pdir = pfont-&gt;dir;
    gs_font *pf;

    /* Remove the font from its list (orig_fonts or scaled_fonts). */
    gs_font *prev = pfont-&gt;prev;
    gs_font *next = pfont-&gt;next;

    if (next != 0)
	next-&gt;prev = prev, pfont-&gt;next = 0;
    if (prev != 0)
	prev-&gt;next = next, pfont-&gt;prev = 0;
    else if (pdir-&gt;orig_fonts == pfont)
	pdir-&gt;orig_fonts = next;
    else if (pdir-&gt;scaled_fonts == pfont)
	pdir-&gt;scaled_fonts = next;
    else {			/* Shouldn't happen! */
	lprintf1("purged font 0x%lx not found\n", (ulong) pfont);
    }

    /* Purge the font from the scaled font cache. */
    for (pf = pdir-&gt;scaled_fonts; pf != 0;) {
	if (pf-&gt;base == pfont) {
	    gs_purge_font(pf);
	    pf = pdir-&gt;scaled_fonts;	/* start over */
	} else
	    pf = pf-&gt;next;
    }

    /* Purge the font from the font/matrix pair cache, */
    /* including all cached characters rendered with that font. */
    gs_purge_font_from_char_caches(pdir, pfont);

}

/* Locate a gs_font by gs_id. */
gs_font *
gs_find_font_by_id(gs_font_dir *pdir, gs_id id, gs_matrix *FontMatrix)
 {
    gs_font *pfont = pdir-&gt;orig_fonts;

    for(; pfont != NULL; pfont = pfont-&gt;next)
	if(pfont-&gt;id == id &amp;&amp;
	    !memcmp(&amp;pfont-&gt;FontMatrix, FontMatrix, sizeof(pfont-&gt;FontMatrix)))
	    return pfont;
    return NULL;
 }

/* ---------------- Default font procedures ---------------- */

/* ------ Font-level procedures ------ */

/* Default (vacuous) definefont handler. */
int
gs_no_define_font(gs_font_dir * pdir, gs_font * pfont)
{
    return 0;
}

/* Default (vacuous) makefont handler. */
int
gs_no_make_font(gs_font_dir * pdir, const gs_font * pfont,
		const gs_matrix * pmat, gs_font ** ppfont)
{
    return 0;
}
/* Makefont handler for base fonts, which must copy the XUID. */
int
gs_base_make_font(gs_font_dir * pdir, const gs_font * pfont,
		  const gs_matrix * pmat, gs_font ** ppfont)
{
    return uid_copy(&amp;((gs_font_base *)*ppfont)-&gt;UID, (*ppfont)-&gt;memory,
		    "gs_base_make_font(XUID)");
}

/* Default font info procedure */
int
gs_default_font_info(gs_font *font, const gs_point *pscale, int members,
		     gs_font_info_t *info)
{
    int wmode = font-&gt;WMode;
    gs_font_base *bfont = (gs_font_base *)font;
    gs_point scale;
    gs_matrix smat;
    const gs_matrix *pmat;

    if (pscale == 0) {
	scale.x = scale.y = 0;
	pmat = 0;
    } else {
	scale = *pscale;
	gs_make_scaling(scale.x, scale.y, &amp;smat);
	pmat = &amp;smat;
    }
    info-&gt;members = 0;
    if (members &amp; FONT_INFO_FLAGS)
	info-&gt;Flags_returned = 0;
    if (font-&gt;FontType == ft_composite)
	return 0;		/* nothing available */
    if (members &amp; FONT_INFO_BBOX) {
	info-&gt;BBox.p.x = (int)bfont-&gt;FontBBox.p.x;
	info-&gt;BBox.p.y = (int)bfont-&gt;FontBBox.p.y;
	info-&gt;BBox.q.x = (int)bfont-&gt;FontBBox.q.x;
	info-&gt;BBox.q.y = (int)bfont-&gt;FontBBox.q.y;
	info-&gt;Flags_returned |= FONT_INFO_BBOX;
    }
    if ((members &amp; FONT_INFO_FLAGS) &amp;&amp;
	(info-&gt;Flags_requested &amp; FONT_IS_FIXED_WIDTH)
	) {
	/*
	 * Scan the glyph space to compute the fixed width if any.
	 */
	gs_glyph notdef = gs_no_glyph;
	gs_glyph glyph;
	int fixed_width = 0;
	int index;
	int code = 0; /* Quiet compiler. */

	for (index = 0;
	     fixed_width &gt;= 0 &amp;&amp;
	     (code = font-&gt;procs.enumerate_glyph(font, &amp;index, GLYPH_SPACE_NAME, &amp;glyph)) &gt;= 0 &amp;&amp;
		 index != 0;
	     ) {
	    gs_glyph_info_t glyph_info;

	    code = font-&gt;procs.glyph_info(font, glyph, pmat,
					  (GLYPH_INFO_WIDTH0 &lt;&lt; wmode),
					  &amp;glyph_info);
	    if (code &lt; 0)
		return code;
	    if (notdef == gs_no_glyph &amp;&amp; gs_font_glyph_is_notdef(bfont, glyph)) {
		notdef = glyph;
		info-&gt;MissingWidth = (int)glyph_info.width[wmode].x;
		info-&gt;members |= FONT_INFO_MISSING_WIDTH;
	    }
	    if (glyph_info.width[wmode].y != 0)
		fixed_width = min_int;
	    else if (fixed_width == 0)
		fixed_width = (int)glyph_info.width[wmode].x;
	    else if (glyph_info.width[wmode].x != fixed_width)
		fixed_width = min_int;
	}
	if (code &lt; 0)
	    return code;
	if (fixed_width &gt; 0) {
	    info-&gt;Flags |= FONT_IS_FIXED_WIDTH;
	    info-&gt;members |= FONT_INFO_AVG_WIDTH | FONT_INFO_MAX_WIDTH |
		FONT_INFO_MISSING_WIDTH;
	    info-&gt;AvgWidth = info-&gt;MaxWidth = info-&gt;MissingWidth = fixed_width;
	}
	info-&gt;Flags_returned |= FONT_IS_FIXED_WIDTH;
    } else if (members &amp; FONT_INFO_MISSING_WIDTH) {
	gs_glyph glyph;
	int index;

	for (index = 0;
	     font-&gt;procs.enumerate_glyph(font, &amp;index, GLYPH_SPACE_NAME, &amp;glyph) &gt;= 0 &amp;&amp;
		 index != 0;
	     ) {
	    /*
	     * If this is a CIDFont or TrueType font that uses integers as
	     * glyph names, check for glyph 0; otherwise, check for .notdef.
	     */
	    if (!gs_font_glyph_is_notdef(bfont, glyph))
		continue;
	    {
		gs_glyph_info_t glyph_info;
		int code = font-&gt;procs.glyph_info(font, glyph, pmat,
						  (GLYPH_INFO_WIDTH0 &lt;&lt; wmode),
						  &amp;glyph_info);

		if (code &lt; 0)
		    return code;
		info-&gt;MissingWidth = (int)glyph_info.width[wmode].x;
		info-&gt;members |= FONT_INFO_MISSING_WIDTH;
		break;
	    }
	}
    }
    return 0;
}

/* Default font similarity testing procedure */
int
gs_default_same_font(const gs_font *font, const gs_font *ofont, int mask)
{
    while (font-&gt;base != font)
	font = font-&gt;base;
    while (ofont-&gt;base != ofont)
	ofont = ofont-&gt;base;
    if (ofont == font)
	return mask;
    /* In general, we can't determine similarity. */
    return 0;
}
int
gs_base_same_font(const gs_font *font, const gs_font *ofont, int mask)
{
    int same = gs_default_same_font(font, ofont, mask);

    if (!same) {
	const gs_font_base *const bfont = (const gs_font_base *)font;
	const gs_font_base *const obfont = (const gs_font_base *)ofont;

	if (mask &amp; FONT_SAME_ENCODING) {
	    if (bfont-&gt;encoding_index != ENCODING_INDEX_UNKNOWN ||
		obfont-&gt;encoding_index != ENCODING_INDEX_UNKNOWN
		) {
		if (bfont-&gt;encoding_index == obfont-&gt;encoding_index)
		    same |= FONT_SAME_ENCODING;
	    }
	}
    }
    return same;
}

/* ------ Glyph-level procedures ------ */

/*
 * Test whether a glyph is the notdef glyph for a base font.
 * The test is somewhat adhoc: perhaps this should be a virtual procedure.
 */
bool
gs_font_glyph_is_notdef(gs_font_base *bfont, gs_glyph glyph)
{
    gs_const_string gnstr;

    if (glyph == gs_no_glyph)
	return false;
    if (glyph &gt;= gs_min_cid_glyph)
	return (glyph == gs_min_cid_glyph);
    return (bfont-&gt;procs.glyph_name((gs_font *)bfont, glyph, &amp;gnstr) &gt;= 0 &amp;&amp;
	    gnstr.size == 7 &amp;&amp; !memcmp(gnstr.data, ".notdef", 7));
}

/* Dummy character encoding procedure */
gs_glyph
gs_no_encode_char(gs_font *pfont, gs_char chr, gs_glyph_space_t glyph_space)
{
    return gs_no_glyph;
}

/* Dummy glyph decoding procedure */
gs_char
gs_no_decode_glyph(gs_font *pfont, gs_glyph glyph)
{
    return GS_NO_CHAR;
}

/* Dummy glyph enumeration procedure */
int
gs_no_enumerate_glyph(gs_font *font, int *pindex, gs_glyph_space_t glyph_space,
		      gs_glyph *pglyph)
{
    return_error(gs_error_undefined);
}

/* Default glyph info procedure */
int
gs_default_glyph_info(gs_font *font, gs_glyph glyph, const gs_matrix *pmat,
		      int members, gs_glyph_info_t *info)
{   /* WMode may be inherited from an upper font. */
    gx_path path;
    int returned = 0;
    int code;
    int wmode = ((members &amp; GLYPH_INFO_WIDTH1) != 0);
    double sbw[4] = {0, 0, 0, 0};
    /* Currently glyph_outline retrieves sbw only with type 1,2,9 fonts. */
    bool charstrings_font = (font-&gt;FontType == ft_encrypted || 
			     font-&gt;FontType == ft_encrypted2 || 
			     font-&gt;FontType == ft_CID_encrypted);

    gx_path_init_bbox_accumulator(&amp;path);
    code = gx_path_add_point(&amp;path, fixed_0, fixed_0);
    if (code &lt; 0)
	goto out;
    code = font-&gt;procs.glyph_outline(font, wmode, glyph, pmat, &amp;path, sbw);
    if (code &lt; 0)
	goto out;
    if (members &amp; GLYPH_INFO_WIDTHS) {
	int wmode = font-&gt;WMode;
	int wmask = GLYPH_INFO_WIDTH0 &lt;&lt; wmode;

	if (members &amp; wmask) {
	    gs_fixed_point pt;

	    code = gx_path_current_point(&amp;path, &amp;pt);
	    if (code &lt; 0)
		goto out;
	    info-&gt;width[wmode].x = fixed2float(pt.x);
	    info-&gt;width[wmode].y = fixed2float(pt.y);
	    returned |= wmask;
	}
    }
    if (members &amp; GLYPH_INFO_BBOX) {
	gs_fixed_rect bbox;

	code = gx_path_bbox(&amp;path, &amp;bbox);
	if (code &lt; 0)
	    goto out;
	info-&gt;bbox.p.x = fixed2float(bbox.p.x);
	info-&gt;bbox.p.y = fixed2float(bbox.p.y);
	info-&gt;bbox.q.x = fixed2float(bbox.q.x);
	info-&gt;bbox.q.y = fixed2float(bbox.q.y);
	returned |= GLYPH_INFO_BBOX;
    }
    if (members &amp; (GLYPH_INFO_WIDTH0 &lt;&lt; wmode) &amp;&amp; charstrings_font) {
	if (pmat == 0) {
	    info-&gt;width[wmode].x = sbw[2];
	    info-&gt;width[wmode].y = sbw[3];
	} else {
	    code = gs_distance_transform(sbw[2], sbw[3], pmat, &amp;info-&gt;width[wmode]);
	    if (code &lt; 0)
		return code;
	}
	returned |= GLYPH_INFO_WIDTH0 &lt;&lt; wmode;
    }
    if (members &amp; (GLYPH_INFO_VVECTOR0 &lt;&lt; wmode) &amp;&amp; charstrings_font) {
	if (pmat == 0) {
	    info-&gt;v.x = sbw[0];
	    info-&gt;v.y = sbw[1];
	} else {
	    gs_distance_transform(sbw[0], sbw[1], pmat, &amp;info-&gt;v);
	    if (code &lt; 0)
		return code;
	}
	returned |= GLYPH_INFO_VVECTOR0 &lt;&lt; wmode;
    }
    if (members &amp; GLYPH_INFO_NUM_PIECES) {
	info-&gt;num_pieces = 0;
	returned |= GLYPH_INFO_NUM_PIECES;
    }
    returned |= members &amp; GLYPH_INFO_PIECES; /* no pieces stored */
 out:
    info-&gt;members = returned;
    return code;
}

/* Dummy glyph outline procedure */
int
gs_no_glyph_outline(gs_font *font, int WMode, gs_glyph glyph, const gs_matrix *pmat,
		    gx_path *ppath, double sbw[4])
{
    return_error(gs_error_undefined);
}

/* Dummy glyph name procedure */
int
gs_no_glyph_name(gs_font *font, gs_glyph glyph, gs_const_string *pstr)
{
    return_error(gs_error_undefined);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

