<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gsfunc3.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gsfunc3.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1997, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gsfunc3.c,v 1.26 2005/05/03 10:50:48 igor Exp $ */
/* Implementation of LL3 Functions */
#include "math_.h"
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsfunc3.h"
#include "gsparam.h"
#include "gxfunc.h"
#include "stream.h"

/* ---------------- Utilities ---------------- */

#define MASK1 ((uint)(~0) / 3)

/*
 * Free an array of subsidiary Functions.  Note that this may be called
 * before the Functions array has been fully initialized.  Note also that
 * its argument conforms to the Functions array in the parameter structure,
 * but it (necessarily) deconstifies it.
 */
private void
fn_free_functions(const gs_function_t *const * Functions, int count,
		  gs_memory_t * mem)
{
    int i;

    for (i = count; --i &gt;= 0;)
	if (Functions[i])
	    gs_function_free((gs_function_t *)Functions[i], true, mem);
    gs_free_const_object(mem, Functions, "Functions");
}

/*
 * Scale an array of subsidiary functions.  Note that the scale may either
 * be propagated unchanged (step_ranges = false) or divided among the
 * (1-output) subfunctions (step_ranges = true).
 */
private int
fn_scale_functions(gs_function_t ***ppsfns, const gs_function_t *const *pfns,
		   int count, const gs_range_t *pranges, bool step_ranges,
		   gs_memory_t *mem)
{
    gs_function_t **psfns;
    int code = alloc_function_array(count, &amp;psfns, mem);
    const gs_range_t *ranges = pranges;
    int i;
    
    if (code &lt; 0)
	return code;
    for (i = 0; i &lt; count; ++i) {
	int code = gs_function_make_scaled(pfns[i], &amp;psfns[i], ranges, mem);

	if (code &lt; 0) {
	    fn_free_functions((const gs_function_t *const *)psfns, count, mem);
	    return code;
	}
	if (step_ranges)
	    ++ranges;
    }
    *ppsfns = psfns;
    return 0;
}

/* ---------------- Exponential Interpolation functions ---------------- */

typedef struct gs_function_ElIn_s {
    gs_function_head_t head;
    gs_function_ElIn_params_t params;
} gs_function_ElIn_t;

private_st_function_ElIn();

/* Evaluate an Exponential Interpolation function. */
private int
fn_ElIn_evaluate(const gs_function_t * pfn_common, const float *in, float *out)
{
    const gs_function_ElIn_t *const pfn =
	(const gs_function_ElIn_t *)pfn_common;
    double arg = in[0], raised;
    int i;

    if (arg &lt; pfn-&gt;params.Domain[0])
	arg = pfn-&gt;params.Domain[0];
    else if (arg &gt; pfn-&gt;params.Domain[1])
	arg = pfn-&gt;params.Domain[1];
    raised = pow(arg, pfn-&gt;params.N);
    for (i = 0; i &lt; pfn-&gt;params.n; ++i) {
	float v0 = (pfn-&gt;params.C0 == 0 ? 0.0 : pfn-&gt;params.C0[i]);
	float v1 = (pfn-&gt;params.C1 == 0 ? 1.0 : pfn-&gt;params.C1[i]);
	double value = v0 + raised * (v1 - v0);

	if (pfn-&gt;params.Range) {
	    float r0 = pfn-&gt;params.Range[2 * i],
		r1 = pfn-&gt;params.Range[2 * i + 1];

	    if (value &lt; r0)
		value = r0;
	    else if (value &gt; r1)
		value = r1;
	}
	out[i] = value;
	if_debug3('~', "[~]ElIn %g =&gt; [%d]%g\n", arg, i, out[i]);
    }
    return 0;
}

/* Test whether an Exponential function is monotonic.  (They always are.) */
private int
fn_ElIn_is_monotonic(const gs_function_t * pfn_common,
		     const float *lower, const float *upper, uint *mask)
{
    const gs_function_ElIn_t *const pfn =
	(const gs_function_ElIn_t *)pfn_common;

    if (lower[0] &gt; pfn-&gt;params.Domain[1] ||
	upper[0] &lt; pfn-&gt;params.Domain[0]
	)
	return_error(gs_error_rangecheck);
    *mask = 0;
    return 1;
}

/* Write Exponential Interpolation function parameters on a parameter list. */
private int
fn_ElIn_get_params(const gs_function_t *pfn_common, gs_param_list *plist)
{
    const gs_function_ElIn_t *const pfn =
	(const gs_function_ElIn_t *)pfn_common;
    int ecode = fn_common_get_params(pfn_common, plist);
    int code;

    if (pfn-&gt;params.C0) {
	if ((code = param_write_float_values(plist, "C0", pfn-&gt;params.C0,
					     pfn-&gt;params.n, false)) &lt; 0)
	    ecode = code;
    }
    if (pfn-&gt;params.C1) {
	if ((code = param_write_float_values(plist, "C1", pfn-&gt;params.C1,
					     pfn-&gt;params.n, false)) &lt; 0)
	    ecode = code;
    }
    if ((code = param_write_float(plist, "N", &amp;pfn-&gt;params.N)) &lt; 0)
	ecode = code;
    return ecode;
}

/* Make a scaled copy of an Exponential Interpolation function. */
private int
fn_ElIn_make_scaled(const gs_function_ElIn_t *pfn,
		     gs_function_ElIn_t **ppsfn,
		     const gs_range_t *pranges, gs_memory_t *mem)
{
    gs_function_ElIn_t *psfn =
	gs_alloc_struct(mem, gs_function_ElIn_t, &amp;st_function_ElIn,
			"fn_ElIn_make_scaled");
    float *c0;
    float *c1;
    int code, i;

    if (psfn == 0)
	return_error(gs_error_VMerror);
    psfn-&gt;params = pfn-&gt;params;
    psfn-&gt;params.C0 = c0 =
	fn_copy_values(pfn-&gt;params.C0, pfn-&gt;params.n, sizeof(float), mem);
    psfn-&gt;params.C1 = c1 =
	fn_copy_values(pfn-&gt;params.C1, pfn-&gt;params.n, sizeof(float), mem);
    if ((code = ((c0 == 0 &amp;&amp; pfn-&gt;params.C0 != 0) ||
		 (c1 == 0 &amp;&amp; pfn-&gt;params.C1 != 0) ?
		 gs_note_error(gs_error_VMerror) : 0)) &lt; 0 ||
	(code = fn_common_scale((gs_function_t *)psfn,
				(const gs_function_t *)pfn,
				pranges, mem)) &lt; 0) {
	gs_function_free((gs_function_t *)psfn, true, mem);
	return code;
    }
    for (i = 0; i &lt; pfn-&gt;params.n; ++i) {
	double base = pranges[i].rmin, factor = pranges[i].rmax - base;

	c1[i] = c1[i] * factor + base;
	c0[i] = c0[i] * factor + base;
    }
    *ppsfn = psfn;
    return 0;
}

/* Free the parameters of an Exponential Interpolation function. */
void
gs_function_ElIn_free_params(gs_function_ElIn_params_t * params,
			     gs_memory_t * mem)
{
    gs_free_const_object(mem, params-&gt;C1, "C1");
    gs_free_const_object(mem, params-&gt;C0, "C0");
    fn_common_free_params((gs_function_params_t *) params, mem);
}

/* Serialize. */
private int
gs_function_ElIn_serialize(const gs_function_t * pfn, stream *s)
{
    uint n;
    const gs_function_ElIn_params_t * p = (const gs_function_ElIn_params_t *)&amp;pfn-&gt;params;
    int code = fn_common_serialize(pfn, s);

    if (code &lt; 0)
	return code;
    code = sputs(s, (const byte *)&amp;p-&gt;C0[0], sizeof(p-&gt;C0[0]) * p-&gt;n, &amp;n);
    if (code &lt; 0)
	return code;
    code = sputs(s, (const byte *)&amp;p-&gt;C1[0], sizeof(p-&gt;C1[0]) * p-&gt;n, &amp;n);
    if (code &lt; 0)
	return code;
    return sputs(s, (const byte *)&amp;p-&gt;N, sizeof(p-&gt;N), &amp;n);
}

/* Allocate and initialize an Exponential Interpolation function. */
int
gs_function_ElIn_init(gs_function_t ** ppfn,
		      const gs_function_ElIn_params_t * params,
		      gs_memory_t * mem)
{
    static const gs_function_head_t function_ElIn_head = {
	function_type_ExponentialInterpolation,
	{
	    (fn_evaluate_proc_t) fn_ElIn_evaluate,
	    (fn_is_monotonic_proc_t) fn_ElIn_is_monotonic,
	    gs_function_get_info_default,
	    (fn_get_params_proc_t) fn_ElIn_get_params,
	    (fn_make_scaled_proc_t) fn_ElIn_make_scaled,
	    (fn_free_params_proc_t) gs_function_ElIn_free_params,
	    fn_common_free,
	    (fn_serialize_proc_t) gs_function_ElIn_serialize,
	}
    };
    int code;

    *ppfn = 0;			/* in case of error */
    code = fn_check_mnDR((const gs_function_params_t *)params, 1, params-&gt;n);
    if (code &lt; 0)
	return code;
    if ((params-&gt;C0 == 0 || params-&gt;C1 == 0) &amp;&amp; params-&gt;n != 1)
	return_error(gs_error_rangecheck);
    if (params-&gt;N != floor(params-&gt;N)) {
	/* Non-integral exponent, all inputs must be non-negative. */
	if (params-&gt;Domain[0] &lt; 0)
	    return_error(gs_error_rangecheck);
    }
    if (params-&gt;N &lt; 0) {
	/* Negative exponent, input must not be zero. */
	if (params-&gt;Domain[0] &lt;= 0 &amp;&amp; params-&gt;Domain[1] &gt;= 0)
	    return_error(gs_error_rangecheck);
    } {
	gs_function_ElIn_t *pfn =
	    gs_alloc_struct(mem, gs_function_ElIn_t, &amp;st_function_ElIn,
			    "gs_function_ElIn_init");

	if (pfn == 0)
	    return_error(gs_error_VMerror);
	pfn-&gt;params = *params;
	pfn-&gt;params.m = 1;
	pfn-&gt;head = function_ElIn_head;
	*ppfn = (gs_function_t *) pfn;
    }
    return 0;
}

/* ---------------- 1-Input Stitching functions ---------------- */

typedef struct gs_function_1ItSg_s {
    gs_function_head_t head;
    gs_function_1ItSg_params_t params;
} gs_function_1ItSg_t;

private_st_function_1ItSg();

/* Evaluate a 1-Input Stitching function. */
private int
fn_1ItSg_evaluate(const gs_function_t * pfn_common, const float *in, float *out)
{
    const gs_function_1ItSg_t *const pfn =
	(const gs_function_1ItSg_t *)pfn_common;
    float arg = in[0], b0, b1, e0, encoded;
    int k = pfn-&gt;params.k;
    int i;

    if (arg &lt; pfn-&gt;params.Domain[0]) {
	arg = pfn-&gt;params.Domain[0];
	i = 0;
    } else if (arg &gt; pfn-&gt;params.Domain[1]) {
	arg = pfn-&gt;params.Domain[1];
	i = k - 1;
    } else {
	for (i = 0; i &lt; k - 1; ++i)
	    if (arg &lt;= pfn-&gt;params.Bounds[i])
		break;
    }
    b0 = (i == 0 ? pfn-&gt;params.Domain[0] : pfn-&gt;params.Bounds[i - 1]);
    b1 = (i == k - 1 ? pfn-&gt;params.Domain[1] : pfn-&gt;params.Bounds[i]);
    e0 = pfn-&gt;params.Encode[2 * i];
    if (b1 == b0)
	encoded = e0;
    else
	encoded =
	    (arg - b0) * (pfn-&gt;params.Encode[2 * i + 1] - e0) / (b1 - b0) + e0;
    if_debug3('~', "[~]1ItSg %g in %d =&gt; %g\n", arg, i, encoded);
    return gs_function_evaluate(pfn-&gt;params.Functions[i], &amp;encoded, out);
}

/* Test whether a 1-Input Stitching function is monotonic. */
private int
fn_1ItSg_is_monotonic(const gs_function_t * pfn_common,
		      const float *lower, const float *upper, uint *mask)
{
    const gs_function_1ItSg_t *const pfn =
	(const gs_function_1ItSg_t *)pfn_common;
    float v0 = lower[0], v1 = upper[0];
    float d0 = pfn-&gt;params.Domain[0], d1 = pfn-&gt;params.Domain[1];
    int k = pfn-&gt;params.k;
    int i;

    *mask = 0;
    if (v0 &gt; v1) {
	v0 = v1; v1 = lower[0];
    }
    if (v0 &gt; d1 || v1 &lt; d0)
	return_error(gs_error_rangecheck);
    if (v0 &lt; d0)
	v0 = d0;
    if (v1 &gt; d1)
	v1 = d1;
    for (i = 0; i &lt; pfn-&gt;params.k; ++i) {
	float b0 = (i == 0 ? d0 : pfn-&gt;params.Bounds[i - 1]);
	float b1 = (i == k - 1 ? d1 : pfn-&gt;params.Bounds[i]);
	const float small = 0.0000001 * (b1 - b0);
	float e0, e1;
	float w0, w1;
	float vv0, vv1;
	double vb0, vb1;

	if (v0 &gt;= b1)
	    continue;
	if (v0 &gt;= b1 - small)
	    continue; /* Ignore a small noize */
	vv0 = max(b0, v0);
	vv1 = v1;
	if (vv1 &gt; b1 &amp;&amp; v1 &lt; b1 + small)
	    vv1 = b1; /* Ignore a small noize */
	if (vv0 == vv1)
	    return 1;
	if (vv0 &lt; b1 &amp;&amp; vv1 &gt; b1)
	    return 0; /* Consider stitches as monotonity beraks. */
	e0 = pfn-&gt;params.Encode[2 * i];
	e1 = pfn-&gt;params.Encode[2 * i + 1];
	vb0 = max(vv0, b0);
	vb1 = min(vv1, b1);
	w0 = (float)(vb0 - b0) * (e1 - e0) / (b1 - b0) + e0;
	w1 = (float)(vb1 - b0) * (e1 - e0) / (b1 - b0) + e0;
	/* Note that w0 &gt; w1 is now possible if e0 &gt; e1. */
	if (e0 &gt; e1) {
	    if (w0 &gt; e0 &amp;&amp; w0 - small &lt;= e0)
		w0 = e0; /* Suppress a small noize */
	    if (w1 &lt; e1 &amp;&amp; w1 + small &gt;= e1)
		w1 = e1; /* Suppress a small noize */
	} else {
	    if (w0 &lt; e0 &amp;&amp; w0 + small &gt;= e0)
		w0 = e0; /* Suppress a small noize */
	    if (w1 &gt; e1 &amp;&amp; w1 - small &lt;= e1)
		w1 = e1; /* Suppress a small noize */
	}
	if (w0 &gt; w1)
	    return gs_function_is_monotonic(pfn-&gt;params.Functions[i],
					    &amp;w1, &amp;w0, mask);
	else
	    return gs_function_is_monotonic(pfn-&gt;params.Functions[i],
					    &amp;w0, &amp;w1, mask);
    }
    /* v0 is equal to the range end. */
    *mask = 0;
    return 1; 
}

/* Return 1-Input Stitching function information. */
private void
fn_1ItSg_get_info(const gs_function_t *pfn_common, gs_function_info_t *pfi)
{
    const gs_function_1ItSg_t *const pfn =
	(const gs_function_1ItSg_t *)pfn_common;

    gs_function_get_info_default(pfn_common, pfi);
    pfi-&gt;Functions = pfn-&gt;params.Functions;
    pfi-&gt;num_Functions = pfn-&gt;params.k;
}

/* Write 1-Input Stitching function parameters on a parameter list. */
private int
fn_1ItSg_get_params(const gs_function_t *pfn_common, gs_param_list *plist)
{
    const gs_function_1ItSg_t *const pfn =
	(const gs_function_1ItSg_t *)pfn_common;
    int ecode = fn_common_get_params(pfn_common, plist);
    int code;

    if ((code = param_write_float_values(plist, "Bounds", pfn-&gt;params.Bounds,
					 pfn-&gt;params.k - 1, false)) &lt; 0)
	ecode = code;
    if ((code = param_write_float_values(plist, "Encode", pfn-&gt;params.Encode,
					 2 * pfn-&gt;params.k, false)) &lt; 0)
	ecode = code;
    return ecode;
}

/* Make a scaled copy of a 1-Input Stitching function. */
private int
fn_1ItSg_make_scaled(const gs_function_1ItSg_t *pfn,
		     gs_function_1ItSg_t **ppsfn,
		     const gs_range_t *pranges, gs_memory_t *mem)
{
    gs_function_1ItSg_t *psfn =
	gs_alloc_struct(mem, gs_function_1ItSg_t, &amp;st_function_1ItSg,
			"fn_1ItSg_make_scaled");
    int code;

    if (psfn == 0)
	return_error(gs_error_VMerror);
    psfn-&gt;params = pfn-&gt;params;
    psfn-&gt;params.Functions = 0;	/* in case of failure */
    psfn-&gt;params.Bounds =
	fn_copy_values(pfn-&gt;params.Bounds, pfn-&gt;params.k - 1, sizeof(float),
		       mem);
    psfn-&gt;params.Encode =
	fn_copy_values(pfn-&gt;params.Encode, 2 * pfn-&gt;params.k, sizeof(float),
		       mem);
    if ((code = (psfn-&gt;params.Bounds == 0 || psfn-&gt;params.Encode == 0 ?
		 gs_note_error(gs_error_VMerror) : 0)) &lt; 0 ||
	(code = fn_common_scale((gs_function_t *)psfn,
				(const gs_function_t *)pfn,
				pranges, mem)) &lt; 0 ||
	(code = fn_scale_functions((gs_function_t ***)&amp;psfn-&gt;params.Functions,
				   pfn-&gt;params.Functions,
				   pfn-&gt;params.n, pranges, false, mem)) &lt; 0) {
	gs_function_free((gs_function_t *)psfn, true, mem);
	return code;
    }
    *ppsfn = psfn;
    return 0;
}

/* Free the parameters of a 1-Input Stitching function. */
void
gs_function_1ItSg_free_params(gs_function_1ItSg_params_t * params,
			      gs_memory_t * mem)
{
    gs_free_const_object(mem, params-&gt;Encode, "Encode");
    gs_free_const_object(mem, params-&gt;Bounds, "Bounds");
    fn_free_functions(params-&gt;Functions, params-&gt;k, mem);
    fn_common_free_params((gs_function_params_t *) params, mem);
}

/* Serialize. */
private int
gs_function_1ItSg_serialize(const gs_function_t * pfn, stream *s)
{
    uint n;
    const gs_function_1ItSg_params_t * p = (const gs_function_1ItSg_params_t *)&amp;pfn-&gt;params;
    int code = fn_common_serialize(pfn, s);
    int k;

    if (code &lt; 0)
	return code;
    code = sputs(s, (const byte *)&amp;p-&gt;k, sizeof(p-&gt;k), &amp;n);
    if (code &lt; 0)
	return code;

    for (k = 0; k &lt; p-&gt;k &amp;&amp; code &gt;= 0; k++) 
	code = gs_function_serialize(p-&gt;Functions[k], s);
    if (code &lt; 0)
	return code;
    code = sputs(s, (const byte *)&amp;p-&gt;Bounds[0], sizeof(p-&gt;Bounds[0]) * (p-&gt;k - 1), &amp;n);
    if (code &lt; 0)
	return code;
    return sputs(s, (const byte *)&amp;p-&gt;Encode[0], sizeof(p-&gt;Encode[0]) * (p-&gt;k * 2), &amp;n);
}

/* Allocate and initialize a 1-Input Stitching function. */
int
gs_function_1ItSg_init(gs_function_t ** ppfn,
	       const gs_function_1ItSg_params_t * params, gs_memory_t * mem)
{
    static const gs_function_head_t function_1ItSg_head = {
	function_type_1InputStitching,
	{
	    (fn_evaluate_proc_t) fn_1ItSg_evaluate,
	    (fn_is_monotonic_proc_t) fn_1ItSg_is_monotonic,
	    (fn_get_info_proc_t) fn_1ItSg_get_info,
	    (fn_get_params_proc_t) fn_1ItSg_get_params,
	    (fn_make_scaled_proc_t) fn_1ItSg_make_scaled,
	    (fn_free_params_proc_t) gs_function_1ItSg_free_params,
	    fn_common_free,
	    (fn_serialize_proc_t) gs_function_1ItSg_serialize,
	}
    };
    int n = (params-&gt;Range == 0 ? 0 : params-&gt;n);
    float prev = params-&gt;Domain[0];
    int i;

    *ppfn = 0;			/* in case of error */
    for (i = 0; i &lt; params-&gt;k; ++i) {
	const gs_function_t *psubfn = params-&gt;Functions[i];

	if (psubfn-&gt;params.m != 1)
	    return_error(gs_error_rangecheck);
	if (n == 0)
	    n = psubfn-&gt;params.n;
	else if (psubfn-&gt;params.n != n)
	    return_error(gs_error_rangecheck);
	/* There are only k - 1 Bounds, not k. */
	if (i &lt; params-&gt;k - 1) {
	    if (params-&gt;Bounds[i] &lt; prev)
		return_error(gs_error_rangecheck);
	    prev = params-&gt;Bounds[i];
	}
    }
    if (params-&gt;Domain[1] &lt; prev)
	return_error(gs_error_rangecheck);
    fn_check_mnDR((const gs_function_params_t *)params, 1, n);
    {
	gs_function_1ItSg_t *pfn =
	    gs_alloc_struct(mem, gs_function_1ItSg_t, &amp;st_function_1ItSg,
			    "gs_function_1ItSg_init");

	if (pfn == 0)
	    return_error(gs_error_VMerror);
	pfn-&gt;params = *params;
	pfn-&gt;params.m = 1;
	pfn-&gt;params.n = n;
	pfn-&gt;head = function_1ItSg_head;
	*ppfn = (gs_function_t *) pfn;
    }
    return 0;
}

/* ---------------- Arrayed Output functions ---------------- */

typedef struct gs_function_AdOt_s {
    gs_function_head_t head;
    gs_function_AdOt_params_t params;
} gs_function_AdOt_t;

private_st_function_AdOt();

/* Evaluate an Arrayed Output function. */
private int
fn_AdOt_evaluate(const gs_function_t *pfn_common, const float *in0, float *out)
{
    const gs_function_AdOt_t *const pfn =
	(const gs_function_AdOt_t *)pfn_common;
    const float *in = in0;
#define MAX_ADOT_IN 16
    float in_buf[MAX_ADOT_IN];
    int i;

    /*
     * We have to take special care to handle the case where in and out
     * overlap.  For the moment, handle it only for a limited number of
     * input values.
     */
    if (in &lt;= out + (pfn-&gt;params.n - 1) &amp;&amp; out &lt;= in + (pfn-&gt;params.m - 1)) {
	if (pfn-&gt;params.m &gt; MAX_ADOT_IN)
	    return_error(gs_error_rangecheck);
	memcpy(in_buf, in, pfn-&gt;params.m * sizeof(*in));
	in = in_buf;
    }
    for (i = 0; i &lt; pfn-&gt;params.n; ++i) {
	int code =
	    gs_function_evaluate(pfn-&gt;params.Functions[i], in, out + i);

	if (code &lt; 0)
	    return code;
    }
    return 0;
#undef MAX_ADOT_IN
}

/* Test whether an Arrayed Output function is monotonic. */
private int
fn_AdOt_is_monotonic(const gs_function_t * pfn_common,
		     const float *lower, const float *upper, uint *mask)
{
    const gs_function_AdOt_t *const pfn =
	(const gs_function_AdOt_t *)pfn_common;
    int i;

    for (i = 0; i &lt; pfn-&gt;params.n; ++i) {
	int code =
	    gs_function_is_monotonic(pfn-&gt;params.Functions[i], lower, upper, mask);

	if (code &lt;= 0)
	    return code;
    }
    return 1;
}

/* Return Arrayed Output function information. */
private void
fn_AdOt_get_info(const gs_function_t *pfn_common, gs_function_info_t *pfi)
{
    const gs_function_AdOt_t *const pfn =
	(const gs_function_AdOt_t *)pfn_common;

    gs_function_get_info_default(pfn_common, pfi);
    pfi-&gt;Functions = pfn-&gt;params.Functions;
    pfi-&gt;num_Functions = pfn-&gt;params.n;
}

/* Make a scaled copy of an Arrayed Output function. */
private int
fn_AdOt_make_scaled(const gs_function_AdOt_t *pfn, gs_function_AdOt_t **ppsfn,
		    const gs_range_t *pranges, gs_memory_t *mem)
{
    gs_function_AdOt_t *psfn =
	gs_alloc_struct(mem, gs_function_AdOt_t, &amp;st_function_AdOt,
			"fn_AdOt_make_scaled");
    int code;

    if (psfn == 0)
	return_error(gs_error_VMerror);
    psfn-&gt;params = pfn-&gt;params;
    psfn-&gt;params.Functions = 0;	/* in case of failure */
    if ((code = fn_common_scale((gs_function_t *)psfn,
				(const gs_function_t *)pfn,
				pranges, mem)) &lt; 0 ||
	(code = fn_scale_functions((gs_function_t ***)&amp;psfn-&gt;params.Functions,
				   pfn-&gt;params.Functions,
				   pfn-&gt;params.n, pranges, true, mem)) &lt; 0) {
	gs_function_free((gs_function_t *)psfn, true, mem);
	return code;
    }
    *ppsfn = psfn;
    return 0;
}

/* Free the parameters of an Arrayed Output function. */
void
gs_function_AdOt_free_params(gs_function_AdOt_params_t * params,
			     gs_memory_t * mem)
{
    fn_free_functions(params-&gt;Functions, params-&gt;n, mem);
    fn_common_free_params((gs_function_params_t *) params, mem);
}

/* Serialize. */
private int
gs_function_AdOt_serialize(const gs_function_t * pfn, stream *s)
{
    const gs_function_AdOt_params_t * p = (const gs_function_AdOt_params_t *)&amp;pfn-&gt;params;
    int code = fn_common_serialize(pfn, s);
    int k;

    if (code &lt; 0)
	return code;
    for (k = 0; k &lt; p-&gt;n &amp;&amp; code &gt;= 0; k++) 
	code = gs_function_serialize(p-&gt;Functions[k], s);
    return code;
}

/* Allocate and initialize an Arrayed Output function. */
int
gs_function_AdOt_init(gs_function_t ** ppfn,
		const gs_function_AdOt_params_t * params, gs_memory_t * mem)
{
    static const gs_function_head_t function_AdOt_head = {
	function_type_ArrayedOutput,
	{
	    (fn_evaluate_proc_t) fn_AdOt_evaluate,
	    (fn_is_monotonic_proc_t) fn_AdOt_is_monotonic,
	    (fn_get_info_proc_t) fn_AdOt_get_info,
	    fn_common_get_params,	/****** WHAT TO DO ABOUT THIS? ******/
	    (fn_make_scaled_proc_t) fn_AdOt_make_scaled,
	    (fn_free_params_proc_t) gs_function_AdOt_free_params,
	    fn_common_free,
	    (fn_serialize_proc_t) gs_function_AdOt_serialize,
	}
    };
    int m = params-&gt;m, n = params-&gt;n;

    *ppfn = 0;			/* in case of error */
    if (m &lt;= 0 || n &lt;= 0)
	return_error(gs_error_rangecheck);
    {
	gs_function_AdOt_t *pfn =
	    gs_alloc_struct(mem, gs_function_AdOt_t, &amp;st_function_AdOt,
			    "gs_function_AdOt_init");
	float *domain = (float *)
	    gs_alloc_byte_array(mem, 2 * m, sizeof(float),
				"gs_function_AdOt_init(Domain)");
	int i, j;

	if (pfn == 0)
	    return_error(gs_error_VMerror);
	pfn-&gt;params = *params;
	pfn-&gt;params.Domain = domain;
	pfn-&gt;params.Range = 0;
	pfn-&gt;head = function_AdOt_head;
	if (domain == 0) {
	    gs_function_free((gs_function_t *)pfn, true, mem);
	    return_error(gs_error_VMerror);
	}
	/*
	 * We compute the Domain as the intersection of the Domains of
	 * the individual subfunctions.  This isn't quite right: some
	 * subfunction might actually make use of a larger domain of
	 * input values.  However, the only place that Arrayed Output
	 * functions are used is in Shading and similar dictionaries,
	 * where the input values are clamped to the intersection of
	 * the individual Domains anyway.
	 */
	memcpy(domain, params-&gt;Functions[0]-&gt;params.Domain,
	       2 * sizeof(float) * m);
	for (i = 1; i &lt; n; ++i) {
	    const float *dom = params-&gt;Functions[i]-&gt;params.Domain;

	    for (j = 0; j &lt; 2 * m; j += 2, dom += 2) {
		domain[j] = max(domain[j], dom[0]);
		domain[j + 1] = min(domain[j + 1], dom[1]);
	    }
	}
	*ppfn = (gs_function_t *) pfn;
    }
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

