<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gshtx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gshtx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gshtx.c,v 1.6 2004/08/04 19:36:12 stefan Exp $ */
/* Stand-alone halftone/transfer function related code */
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gsutil.h"		/* for gs_next_ids */
#include "gxfmap.h"
#include "gzstate.h"
#include "gzht.h"
#include "gshtx.h"		/* must come after g*ht.h */

/*
 * Procedure to free the set of components when a halftone is released.
 */
private void
free_comps(
	      gs_memory_t * pmem,
	      void *pvht,
	      client_name_t cname
)
{
    gs_ht *pht = (gs_ht *) pvht;

    gs_free_object(pmem, pht-&gt;params.ht_multiple.components, cname);
    gs_free_object(pmem, pvht, cname);
}

/*
 * Stub transfer function, to be applied to components that are not provided
 * with a transfer function.
 */
private float
null_closure_transfer(
			 floatp val,
			 const gx_transfer_map * pmap_dummy,	/* NOTUSED */
			 const void *dummy	/* NOTUSED */
)
{
    return val;
}


/*
 * Build a gs_ht halftone structure.
 */
int
gs_ht_build(
	       gs_ht ** ppht,
	       uint num_comps,
	       gs_memory_t * pmem
)
{
    gs_ht *pht;
    gs_ht_component *phtc;
    int i;

    /* must have at least one component */
    *ppht = 0;
    if (num_comps == 0)
	return_error(gs_error_rangecheck);

    /* allocate the halftone and the array of components */
    rc_alloc_struct_1(pht,
		      gs_ht,
		      &amp;st_gs_ht,
		      pmem,
		      return_error(gs_error_VMerror),
		      "gs_ht_build"
	);
    phtc = gs_alloc_struct_array(pmem,
				 num_comps,
				 gs_ht_component,
				 &amp;st_ht_comp_element,
				 "gs_ht_build"
	);
    if (phtc == 0) {
	gs_free_object(pmem, pht, "gs_ht_build");
	return_error(gs_error_VMerror);
    }
    /* initialize the halftone */
    pht-&gt;type = ht_type_multiple;
    pht-&gt;rc.free = free_comps;
    pht-&gt;params.ht_multiple.components = phtc;
    pht-&gt;params.ht_multiple.num_comp = num_comps;

    for (i = 0; i &lt; num_comps; i++) {
        phtc[i].comp_number = i;
	phtc[i].cname = 0;
	phtc[i].type = ht_type_none;
    }

    *ppht = pht;

    return 0;
}

/*
 * Set a spot-function halftone component in a gs_ht halftone.
 */
int
gs_ht_set_spot_comp(
		       gs_ht * pht,
		       int comp,
		       floatp freq,
		       floatp angle,
		       float (*spot_func) (floatp, floatp),
		       bool accurate,
		       gs_ht_transfer_proc transfer,
		       const void *client_data
)
{
    gs_ht_component *phtc = &amp;(pht-&gt;params.ht_multiple.components[comp]);

    if (comp &gt;= pht-&gt;params.ht_multiple.num_comp)
	return_error(gs_error_rangecheck);
    if (phtc-&gt;type != ht_type_none)
	return_error(gs_error_invalidaccess);

    phtc-&gt;type = ht_type_spot;
    phtc-&gt;params.ht_spot.screen.frequency = freq;
    phtc-&gt;params.ht_spot.screen.angle = angle;
    phtc-&gt;params.ht_spot.screen.spot_function = spot_func;
    phtc-&gt;params.ht_spot.accurate_screens = accurate;
    phtc-&gt;params.ht_spot.transfer = gs_mapped_transfer;

    phtc-&gt;params.ht_spot.transfer_closure.proc =
	(transfer == 0 ? null_closure_transfer : transfer);
    phtc-&gt;params.ht_spot.transfer_closure.data = client_data;

    return 0;
}

/*
 * Set a threshold halftone component in a gs_ht halftone. Note that the
 * caller is responsible for releasing the threshold data.
 */
int
gs_ht_set_threshold_comp(
			    gs_ht * pht,
			    int comp,
			    int width,
			    int height,
			    const gs_const_string * thresholds,
			    gs_ht_transfer_proc transfer,
			    const void *client_data
)
{
    gs_ht_component *phtc = &amp;(pht-&gt;params.ht_multiple.components[comp]);

    if (comp &gt;= pht-&gt;params.ht_multiple.num_comp)
	return_error(gs_error_rangecheck);
    if (phtc-&gt;type != ht_type_none)
	return_error(gs_error_invalidaccess);

    phtc-&gt;type = ht_type_threshold;
    phtc-&gt;params.ht_threshold.width = width;
    phtc-&gt;params.ht_threshold.height = height;
    phtc-&gt;params.ht_threshold.thresholds = *thresholds;
    phtc-&gt;params.ht_threshold.transfer = gs_mapped_transfer;

    phtc-&gt;params.ht_threshold.transfer_closure.proc =
	(transfer == 0 ? null_closure_transfer : transfer);
    phtc-&gt;params.ht_threshold.transfer_closure.data = client_data;

    return 0;
}

/*
 * Increase the reference count of a gs_ht structure by 1.
 */
void
gs_ht_reference(
		   gs_ht * pht
)
{
    rc_increment(pht);
}

/*
 * Decrement the reference count of a gs_ht structure by 1. Free the
 * structure if the reference count reaches 0.
 */
void
gs_ht_release(
		 gs_ht * pht
)
{
    rc_decrement_only(pht, "gs_ht_release");
}


/*
 *  Verify that a gs_ht halftone is legitimate.
 */
private int
check_ht(
	    gs_ht * pht
)
{
    int i;
    int num_comps = pht-&gt;params.ht_multiple.num_comp;

    if (pht-&gt;type != ht_type_multiple)
	return_error(gs_error_unregistered);
    for (i = 0; i &lt; num_comps; i++) {
	gs_ht_component *phtc = &amp;(pht-&gt;params.ht_multiple.components[i]);
	if ((phtc-&gt;type != ht_type_spot) &amp;&amp; (phtc-&gt;type != ht_type_threshold))
	    return_error(gs_error_unregistered);
    }
    return 0;
}

/*
 *  Load a transfer map from a gs_ht_transfer_proc function.
 */
private void
build_transfer_map(
		      gs_ht_component * phtc,
		      gx_transfer_map * pmap
)
{
    gs_ht_transfer_proc proc;
    const void *client_info;
    int i;
    frac *values = pmap-&gt;values;

    if (phtc-&gt;type == ht_type_spot) {
	proc = phtc-&gt;params.ht_spot.transfer_closure.proc;
	client_info = phtc-&gt;params.ht_spot.transfer_closure.data;
    } else {
	proc = phtc-&gt;params.ht_threshold.transfer_closure.proc;
	client_info = phtc-&gt;params.ht_threshold.transfer_closure.data;
    }

    for (i = 0; i &lt; transfer_map_size; i++) {
	float fval =
	    proc(i * (1 / (double)(transfer_map_size - 1)), pmap, client_info);

	values[i] =
	    (fval &lt;= 0.0 ? frac_0 : fval &gt;= 1.0 ? frac_1 :
	     float2frac(fval));
    }
}

/*
 *  Allocate the order and transfer maps required by a halftone, and perform
 *  some elementary initialization. This will also build the component index
 *  to order index map.
 */
private gx_ht_order_component *
alloc_ht_order(
		  const gs_ht * pht,
		  gs_memory_t * pmem,
		  byte * comp2order
)
{
    int num_comps = pht-&gt;params.ht_multiple.num_comp;
    gx_ht_order_component *pocs = gs_alloc_struct_array(
							   pmem,
					   pht-&gt;params.ht_multiple.num_comp,
						      gx_ht_order_component,
					     &amp;st_ht_order_component_element,
							   "alloc_ht_order"
    );
    int inext = 0;
    int i;

    if (pocs == 0)
	return 0;
    pocs-&gt;corder.transfer = 0;

    for (i = 0; i &lt; num_comps; i++) {
	gs_ht_component *phtc = &amp;(pht-&gt;params.ht_multiple.components[i]);
	gx_transfer_map *pmap = gs_alloc_struct(pmem,
						gx_transfer_map,
						&amp;st_transfer_map,
						"alloc_ht_order"
	);

	if (pmap == 0) {
	    int j;

	    for (j = 0; j &lt; inext; j++)
		gs_free_object(pmem, pocs[j].corder.transfer, "alloc_ht_order");
	    gs_free_object(pmem, pocs, "alloc_ht_order");
	    return 0;
	}
	pmap-&gt;proc = gs_mapped_transfer;
	pmap-&gt;id = gs_next_ids(pmem, 1);
	pocs[inext].corder.levels = 0;
	pocs[inext].corder.bit_data = 0;
	pocs[inext].corder.cache = 0;
	pocs[inext].corder.transfer = pmap;
	pocs[inext].cname = phtc-&gt;cname;
        pocs[inext].comp_number = phtc-&gt;comp_number;
	comp2order[i] = inext++;
    }

    return pocs;
}

/*
 *  Build the halftone order for one component.
 */
private int
build_component(
		   gs_ht_component * phtc,
		   gx_ht_order * porder,
		   gs_state * pgs,
		   gs_memory_t * pmem
)
{
    if (phtc-&gt;type == ht_type_spot) {
	gs_screen_enum senum;
	int code;

	code = gx_ht_process_screen_memory(&amp;senum,
					   pgs,
					   &amp;phtc-&gt;params.ht_spot.screen,
				      phtc-&gt;params.ht_spot.accurate_screens,
					   pmem
	    );
	if (code &lt; 0)
	    return code;

	/* avoid wiping out the transfer structure pointer */
	senum.order.transfer = porder-&gt;transfer;
	*porder = senum.order;

    } else {			/* ht_type_threshold */
	int code;
	gx_transfer_map *transfer = porder-&gt;transfer;

	porder-&gt;params.M = phtc-&gt;params.ht_threshold.width;
	porder-&gt;params.N = 0;
	porder-&gt;params.R = 1;
	porder-&gt;params.M1 = phtc-&gt;params.ht_threshold.height;
	porder-&gt;params.N1 = 0;
	porder-&gt;params.R1 = 1;
	code = gx_ht_alloc_threshold_order(porder,
					   phtc-&gt;params.ht_threshold.width,
					   phtc-&gt;params.ht_threshold.height,
					   256,
					   pmem
	    );
	if (code &lt; 0)
	    return code;
	gx_ht_construct_threshold_order(
				porder,
				phtc-&gt;params.ht_threshold.thresholds.data
	    );
	/*
	 * gx_ht_construct_threshold_order wipes out transfer map pointer,
	 * restore it here.
	 */
	porder-&gt;transfer = transfer;
    }

    build_transfer_map(phtc, porder-&gt;transfer);
    return 0;
}

/*
 * Free an order array and all elements it points to.
 */
private void
free_order_array(
		    gx_ht_order_component * pocs,
		    int num_comps,
		    gs_memory_t * pmem
)
{
    int i;

    for (i = 0; i &lt; num_comps; i++)
	gx_ht_order_release(&amp;(pocs[i].corder), pmem, true);
    gs_free_object(pmem, pocs, "gs_ht_install");
}


/*
 *  Install a gs_ht halftone as the current halftone in the graphic state.
 */
int
gs_ht_install(
		 gs_state * pgs,
		 gs_ht * pht
)
{
    int code = 0;
    gs_memory_t *pmem = pht-&gt;rc.memory;
    gx_device_halftone dev_ht;
    gx_ht_order_component *pocs;
    byte comp2order[32];	/* ample component to order map */
    int num_comps = pht-&gt;params.ht_multiple.num_comp;
    int i;

    /* perform so sanity checks (must have one default component) */
    if ((code = check_ht(pht)) != 0)
	return code;

    /* allocate the halftone order structure and transfer maps */
    if ((pocs = alloc_ht_order(pht, pmem, comp2order)) == 0)
	return_error(gs_error_VMerror);

    /* build all of the order for each component */
    for (i = 0; i &lt; num_comps; i++) {
	int j = comp2order[i];

	code = build_component(&amp;(pht-&gt;params.ht_multiple.components[i]),
			       &amp;(pocs[j].corder),
			       pgs,
			       pmem
	    );

	if ((code &gt;= 0) &amp;&amp; (j != 0)) {
	    gx_ht_cache *pcache;

	    pcache = gx_ht_alloc_cache(pmem,
				       4,
				       pocs[j].corder.raster *
				       (pocs[j].corder.num_bits /
					pocs[j].corder.width) * 4
		);

	    if (pcache == 0)
		code = gs_note_error(gs_error_VMerror);
	    else {
		pocs[j].corder.cache = pcache;
		gx_ht_init_cache(pmem, pcache, &amp;(pocs[j].corder));
	    }
	}
	if (code &lt; 0)
	    break;
    }

    if (code &lt; 0) {
	free_order_array(pocs, num_comps, pmem);
	return code;
    }
    /* initialize the device halftone structure */
    dev_ht.rc.memory = pmem;
    dev_ht.order = pocs[0].corder;	/* Default */
    if (num_comps == 1) {
	/* we have only a Default; we don't need components. */
	gs_free_object(pmem, pocs, "gs_ht_install");
	dev_ht.components = 0;
    } else {
	dev_ht.components = pocs;
	dev_ht.num_comp = num_comps;
    }

    /* at last, actually install the halftone in the graphic state */
    if ((code = gx_ht_install(pgs, (gs_halftone *) pht, &amp;dev_ht)) &lt; 0)
        gx_device_halftone_release(&amp;dev_ht, pmem);
    return code;
}

/* ---------------- Mask-defined halftones ---------------- */

/*
 * Create a halftone order from an array of explicit masks.  This is
 * silly, because the rendering machinery actually wants masks, but doing
 * it right seems to require too many changes in existing code.
 */
private int
create_mask_bits(const byte * mask1, const byte * mask2,
		 int width, int height, gx_ht_bit * bits)
{
    /*
     * We do this with the slowest, simplest possible algorithm....
     */
    int width_bytes = (width + 7) &gt;&gt; 3;
    int x, y;
    int count = 0;

    for (y = 0; y &lt; height; ++y)
	for (x = 0; x &lt; width; ++x) {
	    int offset = y * width_bytes + (x &gt;&gt; 3);
	    byte bit_mask = 0x80 &gt;&gt; (x &amp; 7);

	    if ((mask1[offset] ^ mask2[offset]) &amp; bit_mask) {
		if (bits)
		    gx_ht_construct_bit(&amp;bits[count], width, y * width + x);
		++count;
	    }
	}
    return count;
}
private int
create_mask_order(gx_ht_order * porder, gs_state * pgs,
		  const gs_client_order_halftone * phcop,
		  gs_memory_t * mem)
{
    int width_bytes = (phcop-&gt;width + 7) &gt;&gt; 3;
    const byte *masks = (const byte *)phcop-&gt;client_data;
    int bytes_per_mask = width_bytes * phcop-&gt;height;
    const byte *prev_mask;
    int num_levels = phcop-&gt;num_levels;
    int num_bits = 0;
    int i;
    int code;

    /* Do a first pass to compute how many bits entries will be needed. */
    for (prev_mask = masks, num_bits = 0, i = 0;
	 i &lt; num_levels - 1;
	 ++i, prev_mask += bytes_per_mask
	)
	num_bits += create_mask_bits(prev_mask, prev_mask + bytes_per_mask,
				     phcop-&gt;width, phcop-&gt;height, NULL);
    code = gx_ht_alloc_client_order(porder, phcop-&gt;width, phcop-&gt;height,
				    num_levels, num_bits, mem);
    if (code &lt; 0)
	return code;
    /* Fill in the bits and levels entries. */
    for (prev_mask = masks, num_bits = 0, i = 0;
	 i &lt; num_levels - 1;
	 ++i, prev_mask += bytes_per_mask
	) {
	porder-&gt;levels[i] = num_bits;
	num_bits += create_mask_bits(prev_mask, prev_mask + bytes_per_mask,
				     phcop-&gt;width, phcop-&gt;height,
				     ((gx_ht_bit *)porder-&gt;bit_data) +
				      num_bits);
    }
    porder-&gt;levels[num_levels - 1] = num_bits;
    return 0;
}

/* Define the client-order halftone procedure structure. */
private const gs_client_order_ht_procs_t mask_order_procs =
{
    create_mask_order
};

/*
 * Define a halftone by an explicit set of masks.  We translate these
 * internally into a threshold array, since that's what the halftone
 * rendering machinery knows how to deal with.
 */
int
gs_ht_set_mask_comp(gs_ht * pht,
		    int component_index,
		    int width, int height, int num_levels,
		    const byte * masks,		/* width x height x num_levels bits */
		    gs_ht_transfer_proc transfer,
		    const void *client_data)
{
    gs_ht_component *phtc =
    &amp;(pht-&gt;params.ht_multiple.components[component_index]);

    if (component_index &gt;= pht-&gt;params.ht_multiple.num_comp)
	return_error(gs_error_rangecheck);
    if (phtc-&gt;type != ht_type_none)
	return_error(gs_error_invalidaccess);

    phtc-&gt;type = ht_type_client_order;
    phtc-&gt;params.client_order.width = width;
    phtc-&gt;params.client_order.height = height;
    phtc-&gt;params.client_order.num_levels = num_levels;
    phtc-&gt;params.client_order.procs = &amp;mask_order_procs;
    phtc-&gt;params.client_order.client_data = masks;
    phtc-&gt;params.client_order.transfer_closure.proc =
	(transfer == 0 ? null_closure_transfer : transfer);
    phtc-&gt;params.client_order.transfer_closure.data = client_data;

    return 0;

}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

