<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gslibctx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gslibctx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Portions Copyright (C) 2003 artofcode LLC.
   Portions Copyright (C) 2003 Artifex Software Inc.
   This software is based in part on the work of the Independent JPEG Group.
   All Rights Reserved.

   This software is distributed under license and may not be copied, modified
   or distributed except as expressly authorized under the terms of that
   license.  Refer to licensing information at http://www.artifex.com/ or
   contact Artifex Software, Inc., 101 Lucas Valley Road #110,
   San Rafael, CA  94903, (415)492-9861, for further information. */

/*$Id: gslibctx.c,v 1.7 2004/12/08 21:35:13 stefan Exp $ */

/* library context functionality for ghostscript 
 * api callers get a gs_main_instance 
 */

/* Capture stdin/out/err before gs.h redefines them. */
#include "stdio_.h"

static void
gs_lib_ctx_get_real_stdio(FILE **in, FILE **out, FILE **err)
{
    *in = stdin;
    *out = stdout;
    *err = stderr;
}


#include "gslibctx.h"
#include "gsmemory.h"

static gs_memory_t *mem_err_print = NULL;


const gs_memory_t *
gs_lib_ctx_get_non_gc_memory_t() 
{
    return mem_err_print ? mem_err_print-&gt;non_gc_memory : NULL;
}


int gs_lib_ctx_init( gs_memory_t *mem )
{
    gs_lib_ctx_t *pio = 0;

    if ( mem == 0 ) 
	return -1;  /* assert mem != 0 */

    mem_err_print = mem;
    
    if (mem-&gt;gs_lib_ctx) /* one time initialization */
	return 0;  

    pio = mem-&gt;gs_lib_ctx = 
	(gs_lib_ctx_t*)gs_alloc_bytes_immovable(mem, 
						sizeof(gs_lib_ctx_t), 
						"gs_lib_ctx_init");
    if( pio == 0 ) 
	return -1;
    pio-&gt;memory = mem;

    gs_lib_ctx_get_real_stdio(&amp;pio-&gt;fstdin, &amp;pio-&gt;fstdout, &amp;pio-&gt;fstderr );

    pio-&gt;fstdout2 = NULL;
    pio-&gt;stdout_is_redirected = false;
    pio-&gt;stdout_to_stderr = false;
    pio-&gt;stdin_is_interactive = true;
    pio-&gt;stdin_fn = 0;
    pio-&gt;stdout_fn = 0;
    pio-&gt;stderr_fn = 0;
    pio-&gt;poll_fn = 0;

    pio-&gt;gs_next_id = 1;  /* this implies that each thread has its own complete state */

    pio-&gt;dict_auto_expand = false;
    return 0;
}

/* Provide a single point for all "C" stdout and stderr.
 */

int outwrite(const gs_memory_t *mem, const char *str, int len)
{
    int code;
    FILE *fout;
    gs_lib_ctx_t *pio = mem-&gt;gs_lib_ctx;

    if (len == 0)
	return 0;
    if (pio-&gt;stdout_is_redirected) {
	if (pio-&gt;stdout_to_stderr)
	    return errwrite(str, len);
	fout = pio-&gt;fstdout2;
    }
    else if (pio-&gt;stdout_fn) {
	return (*pio-&gt;stdout_fn)(pio-&gt;caller_handle, str, len);
    }
    else {
	fout = pio-&gt;fstdout;
    }
    code = fwrite(str, 1, len, fout);
    fflush(fout);
    return code;
}

int errwrite(const char *str, int len)
{    
    int code;
    if (len == 0)
	return 0;
    if (mem_err_print-&gt;gs_lib_ctx-&gt;stderr_fn)
	return (*mem_err_print-&gt;gs_lib_ctx-&gt;stderr_fn)(mem_err_print-&gt;gs_lib_ctx-&gt;caller_handle, str, len);

    code = fwrite(str, 1, len, mem_err_print-&gt;gs_lib_ctx-&gt;fstderr);
    fflush(mem_err_print-&gt;gs_lib_ctx-&gt;fstderr);
    return code;
}

void outflush(const gs_memory_t *mem)
{
    if (mem-&gt;gs_lib_ctx-&gt;stdout_is_redirected) {
	if (mem-&gt;gs_lib_ctx-&gt;stdout_to_stderr) {
	    if (!mem-&gt;gs_lib_ctx-&gt;stderr_fn)
		fflush(mem-&gt;gs_lib_ctx-&gt;fstderr);
	}
	else
	    fflush(mem-&gt;gs_lib_ctx-&gt;fstdout2);
    }
    else if (!mem-&gt;gs_lib_ctx-&gt;stdout_fn)
        fflush(mem-&gt;gs_lib_ctx-&gt;fstdout);
}

void errflush(void)
{
    if (!mem_err_print-&gt;gs_lib_ctx-&gt;stderr_fn)
        fflush(mem_err_print-&gt;gs_lib_ctx-&gt;fstderr);
    /* else nothing to flush */
}


<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

