<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gsmatrix.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gsmatrix.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gsmatrix.c,v 1.8 2004/08/31 13:23:16 igor Exp $ */
/* Matrix operators for Ghostscript library */
#include "math_.h"
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gxfarith.h"
#include "gxfixed.h"
#include "gxmatrix.h"
#include "stream.h"

/* The identity matrix */
private const gs_matrix gs_identity_matrix =
{identity_matrix_body};

/* ------ Matrix creation ------ */

/* Create an identity matrix */
void
gs_make_identity(gs_matrix * pmat)
{
    *pmat = gs_identity_matrix;
}

/* Create a translation matrix */
int
gs_make_translation(floatp dx, floatp dy, gs_matrix * pmat)
{
    *pmat = gs_identity_matrix;
    pmat-&gt;tx = dx;
    pmat-&gt;ty = dy;
    return 0;
}

/* Create a scaling matrix */
int
gs_make_scaling(floatp sx, floatp sy, gs_matrix * pmat)
{
    *pmat = gs_identity_matrix;
    pmat-&gt;xx = sx;
    pmat-&gt;yy = sy;
    return 0;
}

/* Create a rotation matrix. */
/* The angle is in degrees. */
int
gs_make_rotation(floatp ang, gs_matrix * pmat)
{
    gs_sincos_t sincos;

    gs_sincos_degrees(ang, &amp;sincos);
    pmat-&gt;yy = pmat-&gt;xx = sincos.cos;
    pmat-&gt;xy = sincos.sin;
    pmat-&gt;yx = -sincos.sin;
    pmat-&gt;tx = pmat-&gt;ty = 0.0;
    return 0;
}

/* ------ Matrix arithmetic ------ */

/* Multiply two matrices.  We should check for floating exceptions, */
/* but for the moment it's just too awkward. */
/* Since this is used heavily, we check for shortcuts. */
int
gs_matrix_multiply(const gs_matrix * pm1, const gs_matrix * pm2, gs_matrix * pmr)
{
    double xx1 = pm1-&gt;xx, yy1 = pm1-&gt;yy;
    double tx1 = pm1-&gt;tx, ty1 = pm1-&gt;ty;
    double xx2 = pm2-&gt;xx, yy2 = pm2-&gt;yy;
    double xy2 = pm2-&gt;xy, yx2 = pm2-&gt;yx;

    if (is_xxyy(pm1)) {
	pmr-&gt;tx = tx1 * xx2 + pm2-&gt;tx;
	pmr-&gt;ty = ty1 * yy2 + pm2-&gt;ty;
	if (is_fzero(xy2))
	    pmr-&gt;xy = 0;
	else
	    pmr-&gt;xy = xx1 * xy2,
		pmr-&gt;ty += tx1 * xy2;
	pmr-&gt;xx = xx1 * xx2;
	if (is_fzero(yx2))
	    pmr-&gt;yx = 0;
	else
	    pmr-&gt;yx = yy1 * yx2,
		pmr-&gt;tx += ty1 * yx2;
	pmr-&gt;yy = yy1 * yy2;
    } else {
	double xy1 = pm1-&gt;xy, yx1 = pm1-&gt;yx;

	pmr-&gt;xx = xx1 * xx2 + xy1 * yx2;
	pmr-&gt;xy = xx1 * xy2 + xy1 * yy2;
	pmr-&gt;yy = yx1 * xy2 + yy1 * yy2;
	pmr-&gt;yx = yx1 * xx2 + yy1 * yx2;
	pmr-&gt;tx = tx1 * xx2 + ty1 * yx2 + pm2-&gt;tx;
	pmr-&gt;ty = tx1 * xy2 + ty1 * yy2 + pm2-&gt;ty;
    }
    return 0;
}

/* Invert a matrix.  Return gs_error_undefinedresult if not invertible. */
int
gs_matrix_invert(const gs_matrix * pm, gs_matrix * pmr)
{				/* We have to be careful about fetch/store order, */
    /* because pm might be the same as pmr. */
    if (is_xxyy(pm)) {
	if (is_fzero(pm-&gt;xx) || is_fzero(pm-&gt;yy))
	    return_error(gs_error_undefinedresult);
	pmr-&gt;tx = -(pmr-&gt;xx = 1.0 / pm-&gt;xx) * pm-&gt;tx;
	pmr-&gt;xy = 0.0;
	pmr-&gt;yx = 0.0;
	pmr-&gt;ty = -(pmr-&gt;yy = 1.0 / pm-&gt;yy) * pm-&gt;ty;
    } else {
	double det = pm-&gt;xx * pm-&gt;yy - pm-&gt;xy * pm-&gt;yx;
	double mxx = pm-&gt;xx, mtx = pm-&gt;tx;

	if (det == 0)
	    return_error(gs_error_undefinedresult);
	pmr-&gt;xx = pm-&gt;yy / det;
	pmr-&gt;xy = -pm-&gt;xy / det;
	pmr-&gt;yx = -pm-&gt;yx / det;
	pmr-&gt;yy = mxx / det;	/* xx is already changed */
	pmr-&gt;tx = -(mtx * pmr-&gt;xx + pm-&gt;ty * pmr-&gt;yx);
	pmr-&gt;ty = -(mtx * pmr-&gt;xy + pm-&gt;ty * pmr-&gt;yy);	/* tx ditto */
    }
    return 0;
}

/* Translate a matrix, possibly in place. */
int
gs_matrix_translate(const gs_matrix * pm, floatp dx, floatp dy, gs_matrix * pmr)
{
    gs_point trans;
    int code = gs_distance_transform(dx, dy, pm, &amp;trans);

    if (code &lt; 0)
	return code;
    if (pmr != pm)
	*pmr = *pm;
    pmr-&gt;tx += trans.x;
    pmr-&gt;ty += trans.y;
    return 0;
}

/* Scale a matrix, possibly in place. */
int
gs_matrix_scale(const gs_matrix * pm, floatp sx, floatp sy, gs_matrix * pmr)
{
    pmr-&gt;xx = pm-&gt;xx * sx;
    pmr-&gt;xy = pm-&gt;xy * sx;
    pmr-&gt;yx = pm-&gt;yx * sy;
    pmr-&gt;yy = pm-&gt;yy * sy;
    if (pmr != pm) {
	pmr-&gt;tx = pm-&gt;tx;
	pmr-&gt;ty = pm-&gt;ty;
    }
    return 0;
}

/* Rotate a matrix, possibly in place.  The angle is in degrees. */
int
gs_matrix_rotate(const gs_matrix * pm, floatp ang, gs_matrix * pmr)
{
    double mxx, mxy;
    gs_sincos_t sincos;

    gs_sincos_degrees(ang, &amp;sincos);
    mxx = pm-&gt;xx, mxy = pm-&gt;xy;
    pmr-&gt;xx = sincos.cos * mxx + sincos.sin * pm-&gt;yx;
    pmr-&gt;xy = sincos.cos * mxy + sincos.sin * pm-&gt;yy;
    pmr-&gt;yx = sincos.cos * pm-&gt;yx - sincos.sin * mxx;
    pmr-&gt;yy = sincos.cos * pm-&gt;yy - sincos.sin * mxy;
    if (pmr != pm) {
	pmr-&gt;tx = pm-&gt;tx;
	pmr-&gt;ty = pm-&gt;ty;
    }
    return 0;
}

/* ------ Coordinate transformations (floating point) ------ */

/* Note that all the transformation routines take separate */
/* x and y arguments, but return their result in a point. */

/* Transform a point. */
int
gs_point_transform(floatp x, floatp y, const gs_matrix * pmat,
		   gs_point * ppt)
{
    ppt-&gt;x = x * pmat-&gt;xx + pmat-&gt;tx;
    ppt-&gt;y = y * pmat-&gt;yy + pmat-&gt;ty;
    if (!is_fzero(pmat-&gt;yx))
	ppt-&gt;x += y * pmat-&gt;yx;
    if (!is_fzero(pmat-&gt;xy))
	ppt-&gt;y += x * pmat-&gt;xy;
    return 0;
}

/* Inverse-transform a point. */
/* Return gs_error_undefinedresult if the matrix is not invertible. */
int
gs_point_transform_inverse(floatp x, floatp y, const gs_matrix * pmat,
			   gs_point * ppt)
{
    if (is_xxyy(pmat)) {
	if (is_fzero(pmat-&gt;xx) || is_fzero(pmat-&gt;yy))
	    return_error(gs_error_undefinedresult);
	ppt-&gt;x = (x - pmat-&gt;tx) / pmat-&gt;xx;
	ppt-&gt;y = (y - pmat-&gt;ty) / pmat-&gt;yy;
	return 0;
    } else if (is_xyyx(pmat)) {
	if (is_fzero(pmat-&gt;xy) || is_fzero(pmat-&gt;yx))
	    return_error(gs_error_undefinedresult);
	ppt-&gt;x = (y - pmat-&gt;ty) / pmat-&gt;xy;
	ppt-&gt;y = (x - pmat-&gt;tx) / pmat-&gt;yx;
	return 0;
    } else {			/* There are faster ways to do this, */
	/* but we won't implement one unless we have to. */
	gs_matrix imat;
	int code = gs_matrix_invert(pmat, &amp;imat);

	if (code &lt; 0)
	    return code;
	return gs_point_transform(x, y, &amp;imat, ppt);
    }
}

/* Transform a distance. */
int
gs_distance_transform(floatp dx, floatp dy, const gs_matrix * pmat,
		      gs_point * pdpt)
{
    pdpt-&gt;x = dx * pmat-&gt;xx;
    pdpt-&gt;y = dy * pmat-&gt;yy;
    if (!is_fzero(pmat-&gt;yx))
	pdpt-&gt;x += dy * pmat-&gt;yx;
    if (!is_fzero(pmat-&gt;xy))
	pdpt-&gt;y += dx * pmat-&gt;xy;
    return 0;
}

/* Inverse-transform a distance. */
/* Return gs_error_undefinedresult if the matrix is not invertible. */
int
gs_distance_transform_inverse(floatp dx, floatp dy,
			      const gs_matrix * pmat, gs_point * pdpt)
{
    if (is_xxyy(pmat)) {
	if (is_fzero(pmat-&gt;xx) || is_fzero(pmat-&gt;yy))
	    return_error(gs_error_undefinedresult);
	pdpt-&gt;x = dx / pmat-&gt;xx;
	pdpt-&gt;y = dy / pmat-&gt;yy;
    } else if (is_xyyx(pmat)) {
	if (is_fzero(pmat-&gt;xy) || is_fzero(pmat-&gt;yx))
	    return_error(gs_error_undefinedresult);
	pdpt-&gt;x = dy / pmat-&gt;xy;
	pdpt-&gt;y = dx / pmat-&gt;yx;
    } else {
	double det = pmat-&gt;xx * pmat-&gt;yy - pmat-&gt;xy * pmat-&gt;yx;

	if (det == 0)
	    return_error(gs_error_undefinedresult);
	pdpt-&gt;x = (dx * pmat-&gt;yy - dy * pmat-&gt;yx) / det;
	pdpt-&gt;y = (dy * pmat-&gt;xx - dx * pmat-&gt;xy) / det;
    }
    return 0;
}

/* Compute the bounding box of 4 points. */
int
gs_points_bbox(const gs_point pts[4], gs_rect * pbox)
{
#define assign_min_max(vmin, vmax, v0, v1)\
  if ( v0 &lt; v1 ) vmin = v0, vmax = v1; else vmin = v1, vmax = v0
#define assign_min_max_4(vmin, vmax, v0, v1, v2, v3)\
  { double min01, max01, min23, max23;\
    assign_min_max(min01, max01, v0, v1);\
    assign_min_max(min23, max23, v2, v3);\
    vmin = min(min01, min23);\
    vmax = max(max01, max23);\
  }
    assign_min_max_4(pbox-&gt;p.x, pbox-&gt;q.x,
		     pts[0].x, pts[1].x, pts[2].x, pts[3].x);
    assign_min_max_4(pbox-&gt;p.y, pbox-&gt;q.y,
		     pts[0].y, pts[1].y, pts[2].y, pts[3].y);
#undef assign_min_max
#undef assign_min_max_4
    return 0;
}

/* Transform or inverse-transform a bounding box. */
/* Return gs_error_undefinedresult if the matrix is not invertible. */
private int
bbox_transform_either_only(const gs_rect * pbox_in, const gs_matrix * pmat,
			   gs_point pts[4],
     int (*point_xform) (floatp, floatp, const gs_matrix *, gs_point *))
{
    int code;

    if ((code = (*point_xform) (pbox_in-&gt;p.x, pbox_in-&gt;p.y, pmat, &amp;pts[0])) &lt; 0 ||
	(code = (*point_xform) (pbox_in-&gt;p.x, pbox_in-&gt;q.y, pmat, &amp;pts[1])) &lt; 0 ||
	(code = (*point_xform) (pbox_in-&gt;q.x, pbox_in-&gt;p.y, pmat, &amp;pts[2])) &lt; 0 ||
     (code = (*point_xform) (pbox_in-&gt;q.x, pbox_in-&gt;q.y, pmat, &amp;pts[3])) &lt; 0
	)
	DO_NOTHING;
    return code;
}

private int
bbox_transform_either(const gs_rect * pbox_in, const gs_matrix * pmat,
		      gs_rect * pbox_out,
     int (*point_xform) (floatp, floatp, const gs_matrix *, gs_point *))
{
    int code;

    /*
     * In principle, we could transform only one point and two
     * distance vectors; however, because of rounding, we will only
     * get fully consistent results if we transform all 4 points.
     * We must compute the max and min after transforming,
     * since a rotation may be involved.
     */
    gs_point pts[4];

    if ((code = bbox_transform_either_only(pbox_in, pmat, pts, point_xform)) &lt; 0)
	return code;
    return gs_points_bbox(pts, pbox_out);
}
int
gs_bbox_transform(const gs_rect * pbox_in, const gs_matrix * pmat,
		  gs_rect * pbox_out)
{
    return bbox_transform_either(pbox_in, pmat, pbox_out,
				 gs_point_transform);
}
int
gs_bbox_transform_only(const gs_rect * pbox_in, const gs_matrix * pmat,
		       gs_point points[4])
{
    return bbox_transform_either_only(pbox_in, pmat, points,
				      gs_point_transform);
}
int
gs_bbox_transform_inverse(const gs_rect * pbox_in, const gs_matrix * pmat,
			  gs_rect * pbox_out)
{
    return bbox_transform_either(pbox_in, pmat, pbox_out,
				 gs_point_transform_inverse);
}

/* ------ Coordinate transformations (to fixed point) ------ */

#define f_fits_in_fixed(f) f_fits_in_bits(f, fixed_int_bits)

/* Make a gs_matrix_fixed from a gs_matrix. */
int
gs_matrix_fixed_from_matrix(gs_matrix_fixed *pfmat, const gs_matrix *pmat)
{
    *(gs_matrix *)pfmat = *pmat;
    if (f_fits_in_fixed(pmat-&gt;tx) &amp;&amp; f_fits_in_fixed(pmat-&gt;ty)) {
	pfmat-&gt;tx = fixed2float(pfmat-&gt;tx_fixed = float2fixed(pmat-&gt;tx));
	pfmat-&gt;ty = fixed2float(pfmat-&gt;ty_fixed = float2fixed(pmat-&gt;ty));
	pfmat-&gt;txy_fixed_valid = true;
    } else {
	pfmat-&gt;txy_fixed_valid = false;
    }
    return 0;
}

/* Transform a point with a fixed-point result. */
int
gs_point_transform2fixed(const gs_matrix_fixed * pmat,
			 floatp x, floatp y, gs_fixed_point * ppt)
{
    fixed px, py, t;
    double xtemp, ytemp;
    int code;

    if (!pmat-&gt;txy_fixed_valid) {	/* The translation is out of range.  Do the */
	/* computation in floating point, and convert to */
	/* fixed at the end. */
	gs_point fpt;

	gs_point_transform(x, y, (const gs_matrix *)pmat, &amp;fpt);
	if (!(f_fits_in_fixed(fpt.x) &amp;&amp; f_fits_in_fixed(fpt.y)))
	    return_error(gs_error_limitcheck);
	ppt-&gt;x = float2fixed(fpt.x);
	ppt-&gt;y = float2fixed(fpt.y);
	return 0;
    }
    if (!is_fzero(pmat-&gt;xy)) {	/* Hope for 90 degree rotation */
	if ((code = CHECK_DFMUL2FIXED_VARS(px, y, pmat-&gt;yx, xtemp)) &lt; 0 ||
	    (code = CHECK_DFMUL2FIXED_VARS(py, x, pmat-&gt;xy, ytemp)) &lt; 0
	    )
	    return code;
	FINISH_DFMUL2FIXED_VARS(px, xtemp);
	FINISH_DFMUL2FIXED_VARS(py, ytemp);
	if (!is_fzero(pmat-&gt;xx)) {
	    if ((code = CHECK_DFMUL2FIXED_VARS(t, x, pmat-&gt;xx, xtemp)) &lt; 0)
		return code;
	    FINISH_DFMUL2FIXED_VARS(t, xtemp);
	    if ((code = CHECK_SET_FIXED_SUM(px, px, t)) &lt; 0)
	        return code;
	}
	if (!is_fzero(pmat-&gt;yy)) {
	    if ((code = CHECK_DFMUL2FIXED_VARS(t, y, pmat-&gt;yy, ytemp)) &lt; 0)
		return code;
	    FINISH_DFMUL2FIXED_VARS(t, ytemp);
	    if ((code = CHECK_SET_FIXED_SUM(py, py, t)) &lt; 0)
	        return code;
	}
    } else {
	if ((code = CHECK_DFMUL2FIXED_VARS(px, x, pmat-&gt;xx, xtemp)) &lt; 0 ||
	    (code = CHECK_DFMUL2FIXED_VARS(py, y, pmat-&gt;yy, ytemp)) &lt; 0
	    )
	    return code;
	FINISH_DFMUL2FIXED_VARS(px, xtemp);
	FINISH_DFMUL2FIXED_VARS(py, ytemp);
	if (!is_fzero(pmat-&gt;yx)) {
	    if ((code = CHECK_DFMUL2FIXED_VARS(t, y, pmat-&gt;yx, ytemp)) &lt; 0)
		return code;
	    FINISH_DFMUL2FIXED_VARS(t, ytemp);
	    if ((code = CHECK_SET_FIXED_SUM(px, px, t)) &lt; 0)
	        return code;
	}
    }
    if (((code = CHECK_SET_FIXED_SUM(ppt-&gt;x, px, pmat-&gt;tx_fixed)) &lt; 0) ||
        ((code = CHECK_SET_FIXED_SUM(ppt-&gt;y, py, pmat-&gt;ty_fixed)) &lt; 0) )
        return code;
    return 0;
}

#if PRECISE_CURRENTPOINT
/* Transform a point with a fixed-point result. */
/* Used for the best precision of the current point,
   see comment in clamp_point_aux. */
int
gs_point_transform2fixed_rounding(const gs_matrix_fixed * pmat,
			 floatp x, floatp y, gs_fixed_point * ppt)
{
    gs_point fpt;

    gs_point_transform(x, y, (const gs_matrix *)pmat, &amp;fpt);
    if (!(f_fits_in_fixed(fpt.x) &amp;&amp; f_fits_in_fixed(fpt.y)))
	return_error(gs_error_limitcheck);
    ppt-&gt;x = float2fixed_rounded(fpt.x);
    ppt-&gt;y = float2fixed_rounded(fpt.y);
    return 0;
}
#endif

/* Transform a distance with a fixed-point result. */
int
gs_distance_transform2fixed(const gs_matrix_fixed * pmat,
			    floatp dx, floatp dy, gs_fixed_point * ppt)
{
    fixed px, py, t;
    double xtemp, ytemp;
    int code;

    if ((code = CHECK_DFMUL2FIXED_VARS(px, dx, pmat-&gt;xx, xtemp)) &lt; 0 ||
	(code = CHECK_DFMUL2FIXED_VARS(py, dy, pmat-&gt;yy, ytemp)) &lt; 0
	)
	return code;
    FINISH_DFMUL2FIXED_VARS(px, xtemp);
    FINISH_DFMUL2FIXED_VARS(py, ytemp);
    if (!is_fzero(pmat-&gt;yx)) {
	if ((code = CHECK_DFMUL2FIXED_VARS(t, dy, pmat-&gt;yx, ytemp)) &lt; 0)
	    return code;
	FINISH_DFMUL2FIXED_VARS(t, ytemp);
	if ((code = CHECK_SET_FIXED_SUM(px, px, t)) &lt; 0)
	    return code;
    }
    if (!is_fzero(pmat-&gt;xy)) {
	if ((code = CHECK_DFMUL2FIXED_VARS(t, dx, pmat-&gt;xy, xtemp)) &lt; 0)
	    return code;
	FINISH_DFMUL2FIXED_VARS(t, xtemp);
	if ((code = CHECK_SET_FIXED_SUM(py, py, t)) &lt; 0)
	    return code;
    }
    ppt-&gt;x = px;
    ppt-&gt;y = py;
    return 0;
}

/* ------ Serialization ------ */

/*
 * For maximum conciseness in band lists, we write a matrix as a control
 * byte followed by 0 to 6 values.  The control byte has the format
 * AABBCD00.  AA and BB control (xx,yy) and (xy,yx) as follows:
 *	00 = values are (0.0, 0.0)
 *	01 = values are (V, V) [1 value follows]
 *	10 = values are (V, -V) [1 value follows]
 *	11 = values are (U, V) [2 values follow]
 * C and D control tx and ty as follows:
 *	0 = value is 0.0
 *	1 = value follows
 * The following code is the only place that knows this representation.
 */

/* Put a matrix on a stream. */
int
sput_matrix(stream *s, const gs_matrix *pmat)
{
    byte buf[1 + 6 * sizeof(float)];
    byte *cp = buf + 1;
    byte b = 0;
    float coeff[6];
    int i;
    uint ignore;

    coeff[0] = pmat-&gt;xx;
    coeff[1] = pmat-&gt;xy;
    coeff[2] = pmat-&gt;yx;
    coeff[3] = pmat-&gt;yy;
    coeff[4] = pmat-&gt;tx;
    coeff[5] = pmat-&gt;ty;
    for (i = 0; i &lt; 4; i += 2) {
	float u = coeff[i], v = coeff[i ^ 3];

	b &lt;&lt;= 2;
	if (u != 0 || v != 0) {
	    memcpy(cp, &amp;u, sizeof(float));
	    cp += sizeof(float);

	    if (v == u)
		b += 1;
	    else if (v == -u)
		b += 2;
	    else {
		b += 3;
		memcpy(cp, &amp;v, sizeof(float));
		cp += sizeof(float);
	    }
	}
    }
    for (; i &lt; 6; ++i) {
	float v = coeff[i];

	b &lt;&lt;= 1;
	if (v != 0) {
	    ++b;
	    memcpy(cp, &amp;v, sizeof(float));
	    cp += sizeof(float);
	}
    }
    buf[0] = b &lt;&lt; 2;
    return sputs(s, buf, cp - buf, &amp;ignore);
}

/* Get a matrix from a stream. */
int
sget_matrix(stream *s, gs_matrix *pmat)
{
    int b = sgetc(s);
    float coeff[6];
    int i;
    int status;
    uint nread;

    if (b &lt; 0)
	return b;
    for (i = 0; i &lt; 4; i += 2, b &lt;&lt;= 2)
	if (!(b &amp; 0xc0))
	    coeff[i] = coeff[i ^ 3] = 0.0;
	else {
	    float value;

	    status = sgets(s, (byte *)&amp;value, sizeof(value), &amp;nread);
	    if (status &lt; 0 &amp;&amp; status != EOFC)
		return_error(gs_error_ioerror);
	    coeff[i] = value;
	    switch ((b &gt;&gt; 6) &amp; 3) {
		case 1:
		    coeff[i ^ 3] = value;
		    break;
		case 2:
		    coeff[i ^ 3] = -value;
		    break;
		case 3:
		    status = sgets(s, (byte *)&amp;coeff[i ^ 3],
				   sizeof(coeff[0]), &amp;nread);
		    if (status &lt; 0 &amp;&amp; status != EOFC)
			return_error(gs_error_ioerror);
	    }
	}
    for (; i &lt; 6; ++i, b &lt;&lt;= 1)
	if (b &amp; 0x80) {
	    status = sgets(s, (byte *)&amp;coeff[i], sizeof(coeff[0]), &amp;nread);
	    if (status &lt; 0 &amp;&amp; status != EOFC)
		return_error(gs_error_ioerror);
	} else
	    coeff[i] = 0.0;
    pmat-&gt;xx = coeff[0];
    pmat-&gt;xy = coeff[1];
    pmat-&gt;yx = coeff[2];
    pmat-&gt;yy = coeff[3];
    pmat-&gt;tx = coeff[4];
    pmat-&gt;ty = coeff[5];
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

