<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gspaint.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gspaint.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gspaint.c,v 1.10 2005/10/12 17:59:55 leonardo Exp $ */
/* Painting procedures for Ghostscript library */
#include "math_.h"		/* for fabs */
#include "gx.h"
#include "gpcheck.h"
#include "gserrors.h"
#include "gsropt.h"		/* for gxpaint.h */
#include "gxfixed.h"
#include "gxmatrix.h"		/* for gs_state */
#include "gspaint.h"
#include "gspath.h"
#include "gzpath.h"
#include "gxpaint.h"
#include "gzstate.h"
#include "gxdevice.h"
#include "gxdevmem.h"
#include "gzcpath.h"
#include "gxhldevc.h"

/* Define the nominal size for alpha buffers. */
#define abuf_nominal_SMALL 500
#define abuf_nominal_LARGE 2000
#if arch_small_memory
#  define abuf_nominal abuf_nominal_SMALL
#else
#  define abuf_nominal\
     (gs_debug_c('.') ? abuf_nominal_SMALL : abuf_nominal_LARGE)
#endif

/* Erase the page */
int
gs_erasepage(gs_state * pgs)
{
    /*
     * We can't just fill with device white; we must take the
     * transfer function into account.
     */
    int code;

    if ((code = gs_gsave(pgs)) &lt; 0)
	return code;
    if ((code = gs_setgray(pgs, 1.0)) &gt;= 0) {
	/* Fill the page directly, ignoring clipping. */
	code = gs_fillpage(pgs);
    }
    gs_grestore(pgs);
    return code;
}

/* Fill the page with the current color. */
int
gs_fillpage(gs_state * pgs)
{
    gx_device *dev;
    int code = 0;
    gs_logical_operation_t save_lop;
    bool hl_color_available = gx_hld_is_hl_color_available((gs_imager_state *)pgs, 
						    pgs-&gt;dev_color);
    gx_set_dev_color(pgs);
    dev = gs_currentdevice(pgs);
    /* Fill the page directly, ignoring clipping. */
    /* Use the default RasterOp. */
    save_lop = pgs-&gt;log_op;
    gs_init_rop(pgs);
    if (hl_color_available) {
	gs_fixed_rect rect;

	rect.p.x = rect.p.y = 0;
	rect.q.x = int2fixed(dev-&gt;width);
	rect.q.y = int2fixed(dev-&gt;height);
	code = dev_proc(pgs-&gt;device, fill_rectangle_hl_color)(pgs-&gt;device, 
		&amp;rect, (const gs_imager_state *)pgs, pgs-&gt;dev_color, NULL);
    }
    if (!hl_color_available || code == gs_error_rangecheck)
	code = gx_fill_rectangle(0, 0, dev-&gt;width, dev-&gt;height,
				 pgs-&gt;dev_color, pgs);
    pgs-&gt;log_op = save_lop;
    if (code &lt; 0)
	return code;
    return (*dev_proc(dev, sync_output)) (dev);
}

/*
 * Determine the number of bits of alpha buffer for a stroke or fill.
 * We should do alpha buffering iff this value is &gt;1.
 */
private int
alpha_buffer_bits(gs_state * pgs)
{
    gx_device *dev;

    if (!color_is_pure(pgs-&gt;dev_color))
	return 0;
    dev = gs_currentdevice_inline(pgs);
    if (gs_device_is_abuf(dev)) {
	/* We're already writing into an alpha buffer. */
	return 0;
    }
    return (*dev_proc(dev, get_alpha_bits))
	(dev, (pgs-&gt;in_cachedevice ? go_text : go_graphics));
}
/*
 * Set up an alpha buffer for a stroke or fill operation.  Return 0
 * if no buffer could be allocated, 1 if a buffer was installed,
 * or the usual negative error code.
 *
 * The fill/stroke code sets up a clipping device if needed; however,
 * since we scale up all the path coordinates, we either need to scale up
 * the clipping region, or do clipping after, rather than before,
 * alpha buffering.  Either of these is a little inconvenient, but
 * the former is less inconvenient.
 */
private int
scale_paths(gs_state * pgs, int log2_scale_x, int log2_scale_y, bool do_path)
{
    /*
     * Because of clip and clippath, any of path, clip_path, and view_clip
     * may be aliases for each other.  The only reliable way to detect
     * this is by comparing the segments pointers.  Note that we must
     * scale the non-segment parts of the paths even if the segments are
     * aliased.
     */
    const gx_path_segments *seg_clip =
	(pgs-&gt;clip_path-&gt;path_valid ? pgs-&gt;clip_path-&gt;path.segments : 0);
    const gx_clip_rect_list *list_clip = pgs-&gt;clip_path-&gt;rect_list;
    const gx_path_segments *seg_view_clip;
    const gx_clip_rect_list *list_view_clip;
    const gx_path_segments *seg_effective_clip =
	(pgs-&gt;effective_clip_path-&gt;path_valid ?
	 pgs-&gt;effective_clip_path-&gt;path.segments : 0);
    const gx_clip_rect_list *list_effective_clip =
	pgs-&gt;effective_clip_path-&gt;rect_list;

    gx_cpath_scale_exp2_shared(pgs-&gt;clip_path, log2_scale_x, log2_scale_y,
			       false, false);
    if (pgs-&gt;view_clip != 0 &amp;&amp; pgs-&gt;view_clip != pgs-&gt;clip_path) {
	seg_view_clip =
	    (pgs-&gt;view_clip-&gt;path_valid ? pgs-&gt;view_clip-&gt;path.segments : 0);
	list_view_clip = pgs-&gt;view_clip-&gt;rect_list;
	gx_cpath_scale_exp2_shared(pgs-&gt;view_clip, log2_scale_x, log2_scale_y,
				   list_view_clip == list_clip,
				   seg_view_clip &amp;&amp; seg_view_clip == seg_clip);
    } else
	seg_view_clip = 0, list_view_clip = 0;
    if (pgs-&gt;effective_clip_path != pgs-&gt;clip_path &amp;&amp;
	pgs-&gt;effective_clip_path != pgs-&gt;view_clip
	)
	gx_cpath_scale_exp2_shared(pgs-&gt;effective_clip_path, log2_scale_x,
				   log2_scale_y,
				   list_effective_clip == list_clip ||
				   list_effective_clip == list_view_clip,
				   seg_effective_clip &amp;&amp;
				   (seg_effective_clip == seg_clip ||
				    seg_effective_clip == seg_view_clip));
    if (do_path) {
	const gx_path_segments *seg_path = pgs-&gt;path-&gt;segments;

	gx_path_scale_exp2_shared(pgs-&gt;path, log2_scale_x, log2_scale_y,
				  seg_path == seg_clip ||
				  seg_path == seg_view_clip ||
				  seg_path == seg_effective_clip);
    }
    return 0;
}
private void
scale_dash_pattern(gs_state * pgs, floatp scale)
{
    int i;

    for (i = 0; i &lt; pgs-&gt;line_params.dash.pattern_size; ++i)
	pgs-&gt;line_params.dash.pattern[i] *= scale;
    pgs-&gt;line_params.dash.offset *= scale;
    pgs-&gt;line_params.dash.pattern_length *= scale;
    pgs-&gt;line_params.dash.init_dist_left *= scale;
    if (pgs-&gt;line_params.dot_length_absolute)
	pgs-&gt;line_params.dot_length *= scale;
}
private int
alpha_buffer_init(gs_state * pgs, fixed extra_x, fixed extra_y, int alpha_bits)
{
    gx_device *dev = gs_currentdevice_inline(pgs);
    int log2_alpha_bits = ilog2(alpha_bits);
    gs_fixed_rect bbox;
    gs_int_rect ibox;
    uint width, raster, band_space;
    uint height;
    gs_log2_scale_point log2_scale;
    gs_memory_t *mem;
    gx_device_memory *mdev;

    log2_scale.x = log2_scale.y = log2_alpha_bits;
    gx_path_bbox(pgs-&gt;path, &amp;bbox);
    ibox.p.x = fixed2int(bbox.p.x - extra_x) - 1;
    ibox.p.y = fixed2int(bbox.p.y - extra_y) - 1;
    ibox.q.x = fixed2int_ceiling(bbox.q.x + extra_x) + 1;
    ibox.q.y = fixed2int_ceiling(bbox.q.y + extra_y) + 1;
    width = (ibox.q.x - ibox.p.x) &lt;&lt; log2_scale.x;
    raster = bitmap_raster(width);
    band_space = raster &lt;&lt; log2_scale.y;
    height = (abuf_nominal / band_space) &lt;&lt; log2_scale.y;
    if (height == 0)
	height = 1 &lt;&lt; log2_scale.y;
    mem = pgs-&gt;memory;
    mdev = gs_alloc_struct(mem, gx_device_memory, &amp;st_device_memory,
			   "alpha_buffer_init");
    if (mdev == 0)
	return 0;		/* if no room, don't buffer */
    gs_make_mem_abuf_device(mdev, mem, dev, &amp;log2_scale,
			    alpha_bits, ibox.p.x &lt;&lt; log2_scale.x);
    mdev-&gt;width = width;
    mdev-&gt;height = height;
    mdev-&gt;bitmap_memory = mem;
    if ((*dev_proc(mdev, open_device)) ((gx_device *) mdev) &lt; 0) {
	/* No room for bits, punt. */
	gs_free_object(mem, mdev, "alpha_buffer_init");
	return 0;
    }
    gx_set_device_only(pgs, (gx_device *) mdev);
    scale_paths(pgs, log2_scale.x, log2_scale.y, true);
    return 1;
}

/* Release an alpha buffer. */
private void
alpha_buffer_release(gs_state * pgs, bool newpath)
{
    gx_device_memory *mdev =
    (gx_device_memory *) gs_currentdevice_inline(pgs);

    (*dev_proc(mdev, close_device)) ((gx_device *) mdev);
    scale_paths(pgs, -mdev-&gt;log2_scale.x, -mdev-&gt;log2_scale.y,
		!(newpath &amp;&amp; !gx_path_is_shared(pgs-&gt;path)));
    /* Reference counting will free mdev. */
    gx_set_device_only(pgs, mdev-&gt;target);
}

/* Fill the current path using a specified rule. */
private int
fill_with_rule(gs_state * pgs, int rule)
{
    int code;

    /* If we're inside a charpath, just merge the current path */
    /* into the parent's path. */
    if (pgs-&gt;in_charpath)
	code = gx_path_add_char_path(pgs-&gt;show_gstate-&gt;path, pgs-&gt;path,
				     pgs-&gt;in_charpath);
    else if (gs_is_null_device(pgs-&gt;device)) {
	/* Handle separately to prevent gs_state_color_load - bug 688308. */
	gs_newpath(pgs);
	code = 0;
    } else {
	int abits, acode;

	gx_set_dev_color(pgs);
	code = gs_state_color_load(pgs);
	if (code &lt; 0)
	    return code;
	abits = alpha_buffer_bits(pgs);
	if (abits &gt; 1) {
	    acode = alpha_buffer_init(pgs, pgs-&gt;fill_adjust.x,
				      pgs-&gt;fill_adjust.y, abits);
	    if (acode &lt; 0)
		return acode;
	} else
	    acode = 0;
	code = gx_fill_path(pgs-&gt;path, pgs-&gt;dev_color, pgs, rule,
			    pgs-&gt;fill_adjust.x, pgs-&gt;fill_adjust.y);
	if (acode &gt; 0)
	    alpha_buffer_release(pgs, code &gt;= 0);
	if (code &gt;= 0)
	    gs_newpath(pgs);

    }
    return code;
}
/* Fill using the winding number rule */
int
gs_fill(gs_state * pgs)
{
    return fill_with_rule(pgs, gx_rule_winding_number);
}
/* Fill using the even/odd rule */
int
gs_eofill(gs_state * pgs)
{
    return fill_with_rule(pgs, gx_rule_even_odd);
}

/* Stroke the current path */
int
gs_stroke(gs_state * pgs)
{
    int code;

    /*
     * If we're inside a charpath, just merge the current path
     * into the parent's path.
     */
    if (pgs-&gt;in_charpath) {
	if (pgs-&gt;in_charpath == cpm_true_charpath) {
	    /*
	     * A stroke inside a true charpath should do the
	     * equivalent of strokepath.
	     */
	    code = gs_strokepath(pgs);
	    if (code &lt; 0)
		return code;
	}
	code = gx_path_add_char_path(pgs-&gt;show_gstate-&gt;path, pgs-&gt;path,
				     pgs-&gt;in_charpath);
    } else if (gs_is_null_device(pgs-&gt;device)) {
	/* Handle separately to prevent gs_state_color_load. */
	gs_newpath(pgs);
	code = 0;
    } else {
	int abits, acode;

	gx_set_dev_color(pgs);
	code = gs_state_color_load(pgs);
	if (code &lt; 0)
	    return code;
	abits = alpha_buffer_bits(pgs);
	if (abits &gt; 1) {
	    /*
	     * Expand the bounding box by the line width.
	     * This is expensive to compute, so we only do it
	     * if we know we're going to buffer.
	     */
	    float xxyy = fabs(pgs-&gt;ctm.xx) + fabs(pgs-&gt;ctm.yy);
	    float xyyx = fabs(pgs-&gt;ctm.xy) + fabs(pgs-&gt;ctm.yx);
	    float scale = (float)(1 &lt;&lt; (abits / 2));
	    float orig_width = gs_currentlinewidth(pgs);
	    float new_width = orig_width * scale;
	    fixed extra_adjust =
		float2fixed(max(xxyy, xyyx) * new_width / 2);
	    float orig_flatness = gs_currentflat(pgs);
	    gx_path spath;

	    /* Scale up the line width, dash pattern, and flatness. */
	    if (extra_adjust &lt; fixed_1)
		extra_adjust = fixed_1;
	    acode = alpha_buffer_init(pgs,
				      pgs-&gt;fill_adjust.x + extra_adjust,
				      pgs-&gt;fill_adjust.y + extra_adjust,
				      abits);
	    if (acode &lt; 0)
		return acode;
	    gs_setlinewidth(pgs, new_width);
	    scale_dash_pattern(pgs, scale);
	    gs_setflat(pgs, orig_flatness * scale);
	    /*
	     * The alpha-buffer device requires that we fill the
	     * entire path as a single unit.
	     */
	    gx_path_init_local(&amp;spath, pgs-&gt;memory);
	    code = gx_stroke_add(pgs-&gt;path, &amp;spath, pgs);
	    gs_setlinewidth(pgs, orig_width);
	    scale_dash_pattern(pgs, 1.0 / scale);
	    if (code &gt;= 0)
		code = gx_fill_path(&amp;spath, pgs-&gt;dev_color, pgs,
				    gx_rule_winding_number,
				    pgs-&gt;fill_adjust.x,
				    pgs-&gt;fill_adjust.y);
	    gs_setflat(pgs, orig_flatness);
	    gx_path_free(&amp;spath, "gs_stroke");
	    if (acode &gt; 0)
		alpha_buffer_release(pgs, code &gt;= 0);
	} else
	    code = gx_stroke_fill(pgs-&gt;path, pgs);
	if (code &gt;= 0)
	    gs_newpath(pgs);
    }
    return code;
}

/* Compute the stroked outline of the current path */
int
gs_strokepath(gs_state * pgs)
{
    gx_path spath;
    int code;

    gx_path_init_local(&amp;spath, pgs-&gt;path-&gt;memory);
    code = gx_stroke_add(pgs-&gt;path, &amp;spath, pgs);
    if (code &lt; 0) {
	gx_path_free(&amp;spath, "gs_strokepath");
	return code;
    }
    code = gx_path_assign_free(pgs-&gt;path, &amp;spath);
    if (code &lt; 0)
	return code;
    gx_setcurrentpoint(pgs, fixed2float(spath.position.x), fixed2float(spath.position.y));
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

