<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxclbits.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxclbits.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxclbits.c,v 1.9 2004/08/04 19:36:12 stefan Exp $ */
/* Halftone and bitmap writing for command lists */
#include "memory_.h"
#include "gx.h"
#include "gpcheck.h"
#include "gserrors.h"
#include "gsbitops.h"
#include "gxdevice.h"
#include "gxdevmem.h"		/* must precede gxcldev.h */
#include "gxcldev.h"
#include "gxfmap.h"

/*
 * Define when, if ever, to write character bitmaps in all bands.
 * Set this to:
 *      0 to always write in all bands;
 *      N to write in all bands when the character has been seen in N+1
 *         bands on a page;
 *      max_ushort to never write in all bands.
 */
#define CHAR_ALL_BANDS_COUNT max_ushort

/* ------ Writing ------ */

/*
 * Determine the (possibly unpadded) width in bytes for writing a bitmap,
 * per the algorithm in gxcldev.h.  If compression_mask has any of the
 * cmd_mask_compress_any bits set, we assume the bitmap will be compressed.
 * Return the total size of the bitmap.
 */
uint
clist_bitmap_bytes(uint width_bits, uint height, int compression_mask,
		   uint * width_bytes, uint * raster)
{
    uint full_raster = *raster = bitmap_raster(width_bits);
    uint short_raster = (width_bits + 7) &gt;&gt; 3;
    uint width_bytes_last;

    if (compression_mask &amp; cmd_mask_compress_any)
	*width_bytes = width_bytes_last = full_raster;
    else if (short_raster &lt;= cmd_max_short_width_bytes ||
	     height &lt;= 1 ||
	     (compression_mask &amp; decompress_spread) != 0
	)
	*width_bytes = width_bytes_last = short_raster;
    else
	*width_bytes = full_raster, width_bytes_last = short_raster;
    return
	(height == 0 ? 0 : *width_bytes * (height - 1) + width_bytes_last);
}

/*
 * Compress a bitmap, skipping extra padding bytes at the end of each row if
 * necessary.  We require height &gt;= 1, raster &gt;= bitmap_raster(width_bits).
 */
private int
cmd_compress_bitmap(stream_state * st, const byte * data, uint width_bits,
		    uint raster, uint height, stream_cursor_write * pw)
{
    uint width_bytes = bitmap_raster(width_bits);
    int status = 0;
    stream_cursor_read r;

    r.ptr = data - 1;
    if (raster == width_bytes) {
	r.limit = r.ptr + raster * height;
	status = (*st-&gt;template-&gt;process) (st, &amp;r, pw, true);
    } else {			/* Compress row-by-row. */
	uint y;

	for (y = 1; (r.limit = r.ptr + width_bytes), y &lt; height; ++y) {
	    status = (*st-&gt;template-&gt;process) (st, &amp;r, pw, false);
	    if (status)
		break;
	    if (r.ptr != r.limit) {	/* We don't attempt to handle compressors that */
		/* require &gt;1 input byte to make progress. */
		status = -1;
		break;
	    }
	    r.ptr += raster - width_bytes;
	}
	if (status == 0)
	    status = (*st-&gt;template-&gt;process) (st, &amp;r, pw, true);
    }
    if (st-&gt;template-&gt;release)
	(*st-&gt;template-&gt;release) (st);
    return status;
}

/*
 * Put a bitmap in the buffer, compressing if appropriate.
 * pcls == 0 means put the bitmap in all bands.
 * Return &lt;0 if error, otherwise the compression method.
 * A return value of gs_error_limitcheck means that the bitmap was too big
 * to fit in the command reading buffer.
 * Note that this leaves room for the command and initial arguments,
 * but doesn't fill them in.
 */
int
cmd_put_bits(gx_device_clist_writer * cldev, gx_clist_state * pcls,
  const byte * data, uint width_bits, uint height, uint raster, int op_size,
	     int compression_mask, byte ** pdp, uint * psize)
{
    uint short_raster, full_raster;
    uint short_size =
    clist_bitmap_bytes(width_bits, height,
		       compression_mask &amp; ~cmd_mask_compress_any,
		       &amp;short_raster, &amp;full_raster);
    uint uncompressed_raster;
    uint uncompressed_size =
    clist_bitmap_bytes(width_bits, height, compression_mask,
		       &amp;uncompressed_raster, &amp;full_raster);
    uint max_size = cbuf_size - op_size;
    gs_memory_t *mem = cldev-&gt;memory;
    byte *dp;
    int compress = 0;

    /*
     * See if compressing the bits is possible and worthwhile.
     * Currently we can't compress if the compressed data won't fit in
     * the command reading buffer, or if the decompressed data won't fit
     * in the buffer and decompress_elsewhere isn't set.
     */
    if (short_size &gt;= 50 &amp;&amp;
	(compression_mask &amp; cmd_mask_compress_any) != 0 &amp;&amp;
	(uncompressed_size &lt;= max_size ||
	 (compression_mask &amp; decompress_elsewhere) != 0)
	) {
	union ss_ {
	    stream_state ss;
	    stream_CFE_state cf;
	    stream_RLE_state rl;
	} sstate;
	int code;
	int try_size = op_size + min(uncompressed_size, max_size);

	*psize = try_size;
	code = (pcls != 0 ?
		set_cmd_put_op(dp, cldev, pcls, 0, try_size) :
		set_cmd_put_all_op(dp, cldev, 0, try_size));
	if (code &lt; 0)
	    return code;
	cmd_uncount_op(0, try_size);
	/*
	 * Note that we currently keep all the padding if we are
	 * compressing.  This is ridiculous, but it's too hard to
	 * change right now.
	 */
	if (compression_mask &amp; (1 &lt;&lt; cmd_compress_cfe)) {
	    /* Try CCITTFax compression. */
	    clist_cfe_init(&amp;sstate.cf,
			   uncompressed_raster &lt;&lt; 3 /*width_bits*/,
			   mem);
	    compress = cmd_compress_cfe;
	} else if (compression_mask &amp; (1 &lt;&lt; cmd_compress_rle)) {
	    /* Try RLE compression. */
	    clist_rle_init(&amp;sstate.rl);
	    compress = cmd_compress_rle;
	}
	if (compress) {
	    byte *wbase = dp + (op_size - 1);
	    stream_cursor_write w;

	    /*
	     * We can give up on compressing if we generate too much
	     * output to fit in the command reading buffer, or too
	     * much to make compression worthwhile.
	     */
	    uint wmax = min(uncompressed_size, max_size);
	    int status;

	    w.ptr = wbase;
	    w.limit = w.ptr + min(wmax, short_size &gt;&gt; 1);
	    status = cmd_compress_bitmap((stream_state *) &amp; sstate, data,
				  uncompressed_raster &lt;&lt; 3 /*width_bits */ ,
					 raster, height, &amp;w);
	    if (status == 0) {	/* Use compressed representation. */
		uint wcount = w.ptr - wbase;

		cmd_shorten_list_op(cldev,
			     (pcls ? &amp;pcls-&gt;list : &amp;cldev-&gt;band_range_list),
				    try_size - (op_size + wcount));
		*psize = op_size + wcount;
		goto out;
	    }
	}
	if (uncompressed_size &gt; max_size) {
	    /* Shorten to zero, erasing the operation altogether */
	    if_debug1 ('L', "[L]Uncompressed bits %u too large for buffer\n",
		       uncompressed_size);
	    cmd_shorten_list_op(cldev,
			     (pcls ? &amp;pcls-&gt;list : &amp;cldev-&gt;band_range_list),
				try_size);
	    return_error(gs_error_limitcheck);
	}
	if (uncompressed_size != short_size) {
	    if_debug2 ('L', "[L]Shortening bits from %u to %u\n",
		       try_size, op_size + short_size);
	    cmd_shorten_list_op(cldev,
			     (pcls ? &amp;pcls-&gt;list : &amp;cldev-&gt;band_range_list),
				try_size - (op_size + short_size));
	    *psize = op_size + short_size;
	}
	compress = 0;
    } else if (uncompressed_size &gt; max_size)
	return_error(gs_error_limitcheck);
    else {
	int code;

	*psize = op_size + short_size;
	code = (pcls != 0 ?
		set_cmd_put_op(dp, cldev, pcls, 0, *psize) :
		set_cmd_put_all_op(dp, cldev, 0, *psize));
	if (code &lt; 0)
	    return code;
	cmd_uncount_op(0, *psize);
    }
    bytes_copy_rectangle(dp + op_size, short_raster, data, raster,
			 short_raster, height);
out:
    *pdp = dp;
    return compress;
}

/* Add a command to set the tile size and depth. */
private uint
cmd_size_tile_params(const gx_strip_bitmap * tile)
{
    return 2 + cmd_size_w(tile-&gt;rep_width) + cmd_size_w(tile-&gt;rep_height) +
	(tile-&gt;rep_width == tile-&gt;size.x ? 0 :
	 cmd_size_w(tile-&gt;size.x / tile-&gt;rep_width)) +
	(tile-&gt;rep_height == tile-&gt;size.y ? 0 :
	 cmd_size_w(tile-&gt;size.y / tile-&gt;rep_height)) +
	(tile-&gt;rep_shift == 0 ? 0 : cmd_size_w(tile-&gt;rep_shift));
}
private void
cmd_store_tile_params(byte * dp, const gx_strip_bitmap * tile, int depth,
		      uint csize)
{
    byte *p = dp + 2;
    byte bd = cmd_depth_to_code(depth);

    *dp = cmd_count_op(cmd_opv_set_tile_size, csize);
    p = cmd_put_w(tile-&gt;rep_width, p);
    p = cmd_put_w(tile-&gt;rep_height, p);
    if (tile-&gt;rep_width != tile-&gt;size.x) {
	p = cmd_put_w(tile-&gt;size.x / tile-&gt;rep_width, p);
	bd |= 0x20;
    }
    if (tile-&gt;rep_height != tile-&gt;size.y) {
	p = cmd_put_w(tile-&gt;size.y / tile-&gt;rep_height, p);
	bd |= 0x40;
    }
    if (tile-&gt;rep_shift != 0) {
	cmd_put_w(tile-&gt;rep_shift, p);
	bd |= 0x80;
    }
    dp[1] = bd;
}

/* Add a command to set the tile index. */
/* This is a relatively high-frequency operation, so we declare it `inline'. */
inline private int
cmd_put_tile_index(gx_device_clist_writer *cldev, gx_clist_state *pcls,
		   uint indx)
{
    int idelta = indx - pcls-&gt;tile_index + 8;
    byte *dp;
    int code;

    if (!(idelta &amp; ~15)) {
	code = set_cmd_put_op(dp, cldev, pcls,
			      cmd_op_delta_tile_index + idelta, 1);
	if (code &lt; 0)
	    return code;
    } else {
	code = set_cmd_put_op(dp, cldev, pcls,
			      cmd_op_set_tile_index + (indx &gt;&gt; 8), 2);
	if (code &lt; 0)
	    return code;
	dp[1] = indx &amp; 0xff;
    }
    if_debug2('L', "[L]writing index=%u, offset=%lu\n",
	      indx, cldev-&gt;tile_table[indx].offset);
    return 0;
}

/* If necessary, write out data for a single color map. */
int
cmd_put_color_map(gx_device_clist_writer * cldev, cmd_map_index map_index,
	int comp_num, const gx_transfer_map * map, gs_id * pid)
{
    byte *dp;
    int code;

    if (map == 0) {
	if (pid &amp;&amp; *pid == gs_no_id)
	    return 0;	/* no need to write */
	code = set_cmd_put_all_op(dp, cldev, cmd_opv_set_misc, 3);
	if (code &lt; 0)
	    return code;
	dp[1] = cmd_set_misc_map + (cmd_map_none &lt;&lt; 4) + map_index;
	dp[2] = comp_num;
	if (pid)
	    *pid = gs_no_id;
    } else {
	if (pid &amp;&amp; map-&gt;id == *pid)
	    return 0;	/* no need to write */
	if (map-&gt;proc == gs_identity_transfer) {
	    code = set_cmd_put_all_op(dp, cldev, cmd_opv_set_misc, 3);
	    if (code &lt; 0)
		return code;
	    dp[1] = cmd_set_misc_map + (cmd_map_identity &lt;&lt; 4) + map_index;
	    dp[2] = comp_num;
	} else {
	    code = set_cmd_put_all_op(dp, cldev, cmd_opv_set_misc,
				      3 + sizeof(map-&gt;values));
	    if (code &lt; 0)
		return code;
	    dp[1] = cmd_set_misc_map + (cmd_map_other &lt;&lt; 4) + map_index;
	    dp[2] = comp_num;
	    memcpy(dp + 3, map-&gt;values, sizeof(map-&gt;values));
	}
	if (pid)
	    *pid = map-&gt;id;
    }
    return 0;
}

/* ------ Tile cache management ------ */

/* We want consecutive ids to map to consecutive hash slots if possible, */
/* so we can use a delta representation when setting the index. */
/* NB that we cannot emit 'delta' style tile indices if VM error recovery */
/* is in effect, since reader &amp; writer's tile indices may get out of phase */
/* as a consequence of error recovery occurring. */
#define tile_id_hash(id) (id)
#define tile_hash_next(index) ((index) + 413)	/* arbitrary large odd # */
typedef struct tile_loc_s {
    uint index;
    tile_slot *tile;
} tile_loc;

/* Look up a tile or character in the cache.  If found, set the index and */
/* pointer; if not, set the index to the insertion point. */
private bool
clist_find_bits(gx_device_clist_writer * cldev, gx_bitmap_id id, tile_loc * ploc)
{
    uint index = tile_id_hash(id);
    const tile_hash *table = cldev-&gt;tile_table;
    uint mask = cldev-&gt;tile_hash_mask;
    ulong offset;

    for (; (offset = table[index &amp;= mask].offset) != 0;
	 index = tile_hash_next(index)
	) {
	tile_slot *tile = (tile_slot *) (cldev-&gt;data + offset);

	if (tile-&gt;id == id) {
	    ploc-&gt;index = index;
	    ploc-&gt;tile = tile;
	    return true;
	}
    }
    ploc-&gt;index = index;
    return false;
}

/* Delete a tile from the cache. */
private void
clist_delete_tile(gx_device_clist_writer * cldev, tile_slot * slot)
{
    tile_hash *table = cldev-&gt;tile_table;
    uint mask = cldev-&gt;tile_hash_mask;
    uint index = slot-&gt;index;
    ulong offset;

    if_debug2('L', "[L]deleting index=%u, offset=%lu\n",
	      index, (ulong) ((byte *) slot - cldev-&gt;data));
    gx_bits_cache_free(&amp;cldev-&gt;bits, (gx_cached_bits_head *) slot,
		       &amp;cldev-&gt;chunk);
    table[index].offset = 0;
    /* Delete the entry from the hash table. */
    /* We'd like to move up any later entries, so that we don't need */
    /* a deleted mark, but it's too difficult to note this in the */
    /* band list, so instead, we just delete any entries that */
    /* would need to be moved. */
    while ((offset = table[index = tile_hash_next(index) &amp; mask].offset) != 0) {
	tile_slot *tile = (tile_slot *) (cldev-&gt;data + offset);
	tile_loc loc;

	if (!clist_find_bits(cldev, tile-&gt;id, &amp;loc)) {	/* We didn't find it, so it should be moved into a slot */
	    /* that we just vacated; instead, delete it. */
	    if_debug2('L', "[L]move-deleting index=%u, offset=%lu\n",
		      index, offset);
	    gx_bits_cache_free(&amp;cldev-&gt;bits,
			     (gx_cached_bits_head *) (cldev-&gt;data + offset),
			       &amp;cldev-&gt;chunk);
	    table[index].offset = 0;
	}
    }
}

/* Add a tile to the cache. */
/* tile-&gt;raster holds the raster for the replicated tile; */
/* we pass the raster of the actual data separately. */
private int
clist_add_tile(gx_device_clist_writer * cldev, const gx_strip_bitmap * tiles,
	       uint sraster, int depth)
{
    uint raster = tiles-&gt;raster;
    uint size_bytes = raster * tiles-&gt;size.y;
    uint tsize =
    sizeof(tile_slot) + cldev-&gt;tile_band_mask_size + size_bytes;
    gx_cached_bits_head *slot_head;

#define slot ((tile_slot *)slot_head)

    if (cldev-&gt;bits.csize == cldev-&gt;tile_max_count) {	/* Don't let the hash table get too full: delete an entry. */
	/* Since gx_bits_cache_alloc returns an entry to delete when */
	/* it fails, just force it to fail. */
	gx_bits_cache_alloc(&amp;cldev-&gt;bits, (ulong) cldev-&gt;chunk.size,
			    &amp;slot_head);
	if (slot_head == 0) {	/* Wrap around and retry. */
	    cldev-&gt;bits.cnext = 0;
	    gx_bits_cache_alloc(&amp;cldev-&gt;bits, (ulong) cldev-&gt;chunk.size,
				&amp;slot_head);
#ifdef DEBUG
	    if (slot_head == 0) {
		lprintf("No entry to delete!\n");
		return_error(gs_error_Fatal);
	    }
#endif
	}
	clist_delete_tile(cldev, slot);
    }
    /* Allocate the space for the new entry, deleting entries as needed. */
    while (gx_bits_cache_alloc(&amp;cldev-&gt;bits, (ulong) tsize, &amp;slot_head) &lt; 0) {
	if (slot_head == 0) {	/* Wrap around. */
	    if (cldev-&gt;bits.cnext == 0) {	/* Too big to fit.  We should probably detect this */
		/* sooner, since if we get here, we've cleared the */
		/* cache. */
		return_error(gs_error_limitcheck);
	    }
	    cldev-&gt;bits.cnext = 0;
	} else
	    clist_delete_tile(cldev, slot);
    }
    /* Fill in the entry. */
    slot-&gt;cb_depth = depth;
    slot-&gt;cb_raster = raster;
    slot-&gt;width = tiles-&gt;rep_width;
    slot-&gt;height = tiles-&gt;rep_height;
    slot-&gt;shift = slot-&gt;rep_shift = tiles-&gt;rep_shift;
    slot-&gt;x_reps = slot-&gt;y_reps = 1;
    slot-&gt;id = tiles-&gt;id;
    memset(ts_mask(slot), 0, cldev-&gt;tile_band_mask_size);
    bytes_copy_rectangle(ts_bits(cldev, slot), raster,
			 tiles-&gt;data, sraster,
			 (tiles-&gt;rep_width * depth + 7) &gt;&gt; 3,
			 tiles-&gt;rep_height);
    /* Make the hash table entry. */
    {
	tile_loc loc;

#ifdef DEBUG
	if (clist_find_bits(cldev, tiles-&gt;id, &amp;loc))
	    lprintf1("clist_find_bits(0x%lx) should have failed!\n",
		     (ulong) tiles-&gt;id);
#else
	clist_find_bits(cldev, tiles-&gt;id, &amp;loc);	/* always fails */
#endif
	slot-&gt;index = loc.index;
	cldev-&gt;tile_table[loc.index].offset =
	    (byte *) slot_head - cldev-&gt;data;
	if_debug2('L', "[L]adding index=%u, offset=%lu\n",
		  loc.index, cldev-&gt;tile_table[loc.index].offset);
    }
    slot-&gt;num_bands = 0;
    return 0;
}

/* ------ Driver procedure support ------ */

/* Change the tile parameters (size and depth). */
/* Currently we do this for all bands at once. */
private void
clist_new_tile_params(gx_strip_bitmap * new_tile, const gx_strip_bitmap * tiles,
		      int depth, const gx_device_clist_writer * cldev)
{				/*
				 * Adjust the replication factors.  If we can, we replicate
				 * the tile in X up to 32 bytes, and then in Y up to 4 copies,
				 * as long as we don't exceed a total tile size of 256 bytes,
				 * or more than 255 repetitions in X or Y, or make the tile so
				 * large that not all possible tiles will fit in the cache.
				 * Also, don't attempt Y replication if shifting is required. 
				 */
#define max_tile_reps_x 255
#define max_tile_bytes_x 32
#define max_tile_reps_y 4
#define max_tile_bytes 256
    uint rep_width = tiles-&gt;rep_width;
    uint rep_height = tiles-&gt;rep_height;
    uint rep_width_bits = rep_width * depth;
    uint tile_overhead =
    sizeof(tile_slot) + cldev-&gt;tile_band_mask_size;
    uint max_bytes = cldev-&gt;chunk.size / (rep_width_bits * rep_height);

    max_bytes -= min(max_bytes, tile_overhead);
    if (max_bytes &gt; max_tile_bytes)
	max_bytes = max_tile_bytes;
    *new_tile = *tiles;
    {
	uint max_bits_x = max_bytes * 8 / rep_height;
	uint reps_x =
	min(max_bits_x, max_tile_bytes_x * 8) / rep_width_bits;
	uint reps_y;

	while (reps_x &gt; max_tile_reps_x)
	    reps_x &gt;&gt;= 1;
	new_tile-&gt;size.x = max(reps_x, 1) * rep_width;
	new_tile-&gt;raster = bitmap_raster(new_tile-&gt;size.x * depth);
	if (tiles-&gt;shift != 0)
	    reps_y = 1;
	else {
	    reps_y = max_bytes / (new_tile-&gt;raster * rep_height);
	    if (reps_y &gt; max_tile_reps_y)
		reps_y = max_tile_reps_y;
	    else if (reps_y &lt; 1)
		reps_y = 1;
	}
	new_tile-&gt;size.y = reps_y * rep_height;
    }
#undef max_tile_reps_x
#undef max_tile_bytes_x
#undef max_tile_reps_y
#undef max_tile_bytes
}

/* Change tile for clist_tile_rectangle. */
int
clist_change_tile(gx_device_clist_writer * cldev, gx_clist_state * pcls,
		  const gx_strip_bitmap * tiles, int depth)
{
    tile_loc loc;
    int code;

#define tile_params_differ(cldev, tiles, depth)\
  ((tiles)-&gt;rep_width != (cldev)-&gt;tile_params.rep_width ||\
   (tiles)-&gt;rep_height != (cldev)-&gt;tile_params.rep_height ||\
   (tiles)-&gt;rep_shift != (cldev)-&gt;tile_params.rep_shift ||\
   (depth) != (cldev)-&gt;tile_depth)

  top:if (clist_find_bits(cldev, tiles-&gt;id, &amp;loc)) {	/* The bitmap is in the cache.  Check whether this band */
	/* knows about it. */
	int band_index = pcls - cldev-&gt;states;
	byte *bptr = ts_mask(loc.tile) + (band_index &gt;&gt; 3);
	byte bmask = 1 &lt;&lt; (band_index &amp; 7);

	if (*bptr &amp; bmask) {	/* Already known.  Just set the index. */
	    if (pcls-&gt;tile_index == loc.index)
		return 0;
	    if ((code = cmd_put_tile_index(cldev, pcls, loc.index)) &lt; 0)
	    	return code;
	} else {
	    uint extra = 0;

	    if tile_params_differ
		(cldev, tiles, depth) {		/*
						 * We have a cached tile whose parameters differ from
						 * the current ones.  Because of the way tile IDs are
						 * managed, this is currently only possible when mixing
						 * Patterns and halftones, but if we didn't generate new
						 * IDs each time the main halftone cache needed to be
						 * refreshed, this could also happen simply from
						 * switching screens.
						 */
		int band;

		clist_new_tile_params(&amp;cldev-&gt;tile_params, tiles, depth,
				      cldev);
		cldev-&gt;tile_depth = depth;
		/* No band knows about the new parameters. */
		for (band = cldev-&gt;tile_known_min;
		     band &lt;= cldev-&gt;tile_known_max;
		     ++band
		    )
		    cldev-&gt;states[band].known &amp;= ~tile_params_known;
		cldev-&gt;tile_known_min = cldev-&gt;nbands;
		cldev-&gt;tile_known_max = -1;
		}
	    if (!(pcls-&gt;known &amp; tile_params_known)) {	/* We're going to have to write the tile parameters. */
		extra = cmd_size_tile_params(&amp;cldev-&gt;tile_params);
	    } {			/*
				 * This band doesn't know this tile yet, so output the
				 * bits.  Note that the offset we write is the one used by
				 * the reading phase, not the writing phase.  Note also
				 * that the size of the cached and written tile may differ
				 * from that of the client's tile.  Finally, note that
				 * this tile's size parameters are guaranteed to be
				 * compatible with those stored in the device
				 * (cldev-&gt;tile_params).
				 */
		ulong offset = (byte *) loc.tile - cldev-&gt;chunk.data;
		uint rsize =
		    extra + 1 + cmd_size_w(loc.index) + cmd_size_w(offset);
		byte *dp;
		uint csize;
		int code =
		cmd_put_bits(cldev, pcls, ts_bits(cldev, loc.tile),
			     tiles-&gt;rep_width * depth, tiles-&gt;rep_height,
			     loc.tile-&gt;cb_raster, rsize,
			     (cldev-&gt;tile_params.size.x &gt; tiles-&gt;rep_width ?
			      decompress_elsewhere | decompress_spread :
			      decompress_elsewhere),
			     &amp;dp, &amp;csize);

		if (code &lt; 0)
		    return code;
		if (extra) {	/* Write the tile parameters before writing the bits. */
		    cmd_store_tile_params(dp, &amp;cldev-&gt;tile_params, depth,
					  extra);
		    dp += extra;
		    /* This band now knows the parameters. */
		    pcls-&gt;known |= tile_params_known;
		    if (band_index &lt; cldev-&gt;tile_known_min)
			cldev-&gt;tile_known_min = band_index;
		    if (band_index &gt; cldev-&gt;tile_known_max)
			cldev-&gt;tile_known_max = band_index;
		}
		*dp = cmd_count_op(cmd_opv_set_tile_bits, csize - extra);
		dp++;
		dp = cmd_put_w(loc.index, dp);
		cmd_put_w(offset, dp);
		*bptr |= bmask;
		loc.tile-&gt;num_bands++;
	    }
	}
	pcls-&gt;tile_index = loc.index;
	pcls-&gt;tile_id = loc.tile-&gt;id;
	return 0;
    }
    /* The tile is not in the cache, add it. */
    {
	gx_strip_bitmap new_tile;
	gx_strip_bitmap *ptile;

	/* Ensure that the tile size is compatible. */
	if (tile_params_differ(cldev, tiles, depth)) {	/* We'll reset cldev-&gt;tile_params when we write the bits. */
	    clist_new_tile_params(&amp;new_tile, tiles, depth, cldev);
	    ptile = &amp;new_tile;
	} else {
	    cldev-&gt;tile_params.id = tiles-&gt;id;
	    cldev-&gt;tile_params.data = tiles-&gt;data;
	    ptile = &amp;cldev-&gt;tile_params;
	}
	code = clist_add_tile(cldev, ptile, tiles-&gt;raster, depth);
	if (code &lt; 0)
	    return code;
    }
    goto top;
#undef tile_params_differ
}

/* Change "tile" for clist_copy_*.  tiles-&gt;[rep_]shift must be zero. */
int
clist_change_bits(gx_device_clist_writer * cldev, gx_clist_state * pcls,
		  const gx_strip_bitmap * tiles, int depth)
{
    tile_loc loc;
    int code;

  top:if (clist_find_bits(cldev, tiles-&gt;id, &amp;loc)) {	/* The bitmap is in the cache.  Check whether this band */
	/* knows about it. */
	uint band_index = pcls - cldev-&gt;states;
	byte *bptr = ts_mask(loc.tile) + (band_index &gt;&gt; 3);
	byte bmask = 1 &lt;&lt; (band_index &amp; 7);

	if (*bptr &amp; bmask) {	/* Already known.  Just set the index. */
	    if (pcls-&gt;tile_index == loc.index)
		return 0;
	    cmd_put_tile_index(cldev, pcls, loc.index);
	} else {		/* Not known yet.  Output the bits. */
	    /* Note that the offset we write is the one used by */
	    /* the reading phase, not the writing phase. */
	    ulong offset = (byte *) loc.tile - cldev-&gt;chunk.data;
	    uint rsize = 2 + cmd_size_w(loc.tile-&gt;width) +
	    cmd_size_w(loc.tile-&gt;height) + cmd_size_w(loc.index) +
	    cmd_size_w(offset);
	    byte *dp;
	    uint csize;
	    gx_clist_state *bit_pcls = pcls;
	    int code;

	    if (loc.tile-&gt;num_bands == CHAR_ALL_BANDS_COUNT)
		bit_pcls = NULL;
	    code = cmd_put_bits(cldev, bit_pcls, ts_bits(cldev, loc.tile),
				loc.tile-&gt;width * depth,
				loc.tile-&gt;height, loc.tile-&gt;cb_raster,
				rsize,
			     (1 &lt;&lt; cmd_compress_cfe) | decompress_elsewhere,
				&amp;dp, &amp;csize);

	    if (code &lt; 0)
		return code;
	    *dp = cmd_count_op(cmd_opv_set_bits, csize);
	    dp[1] = (depth &lt;&lt; 2) + code;
	    dp += 2;
	    dp = cmd_put_w(loc.tile-&gt;width, dp);
	    dp = cmd_put_w(loc.tile-&gt;height, dp);
	    dp = cmd_put_w(loc.index, dp);
	    cmd_put_w(offset, dp);
	    if (bit_pcls == NULL) {
		memset(ts_mask(loc.tile), 0xff,
		       cldev-&gt;tile_band_mask_size);
		loc.tile-&gt;num_bands = cldev-&gt;nbands;
	    } else {
		*bptr |= bmask;
		loc.tile-&gt;num_bands++;
	    }
	}
	pcls-&gt;tile_index = loc.index;
	pcls-&gt;tile_id = loc.tile-&gt;id;
	return 0;
    }
    /* The tile is not in the cache. */
    code = clist_add_tile(cldev, tiles, tiles-&gt;raster, depth);
    if (code &lt; 0)
	return code;
    goto top;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

