<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxclist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxclist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1991, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/*$Id: gxclist.c,v 1.15 2005/03/14 18:08:36 dan Exp $ */
/* Command list document- and page-level code. */
#include "memory_.h"
#include "string_.h"
#include "gx.h"
#include "gp.h"
#include "gpcheck.h"
#include "gserrors.h"
#include "gxdevice.h"
#include "gxdevmem.h"		/* must precede gxcldev.h */
#include "gxcldev.h"
#include "gxclpath.h"
#include "gsparams.h"
#include "gxdcolor.h"

/* GC information */
#define CLIST_IS_WRITER(cdev) ((cdev)-&gt;common.ymin &lt; 0)
extern_st(st_imager_state);
private
ENUM_PTRS_WITH(device_clist_enum_ptrs, gx_device_clist *cdev)
    if (index &lt; st_device_forward_max_ptrs) {
	gs_ptr_type_t ret = ENUM_USING_PREFIX(st_device_forward, 0);

	return (ret ? ret : ENUM_OBJ(0));
    }
    if (!CLIST_IS_WRITER(cdev))
	return 0;
    index -= st_device_forward_max_ptrs;
    switch (index) {
    case 0: return ENUM_OBJ((cdev-&gt;writer.image_enum_id != gs_no_id ?
			     cdev-&gt;writer.clip_path : 0));
    case 1: return ENUM_OBJ((cdev-&gt;writer.image_enum_id != gs_no_id ?
			     cdev-&gt;writer.color_space.space : 0));
    default:
	return ENUM_USING(st_imager_state, &amp;cdev-&gt;writer.imager_state,
			  sizeof(gs_imager_state), index - 2);
    }
ENUM_PTRS_END
private
RELOC_PTRS_WITH(device_clist_reloc_ptrs, gx_device_clist *cdev)
{
    RELOC_PREFIX(st_device_forward);
    if (!CLIST_IS_WRITER(cdev))
	return;
    if (cdev-&gt;writer.image_enum_id != gs_no_id) {
	RELOC_VAR(cdev-&gt;writer.clip_path);
	RELOC_VAR(cdev-&gt;writer.color_space.space);
    }
    RELOC_USING(st_imager_state, &amp;cdev-&gt;writer.imager_state,
		sizeof(gs_imager_state));
} RELOC_PTRS_END
public_st_device_clist();

/* Forward declarations of driver procedures */
private dev_proc_open_device(clist_open);
private dev_proc_output_page(clist_output_page);
private dev_proc_close_device(clist_close);
private dev_proc_get_band(clist_get_band);
/* Driver procedures defined in other files are declared in gxcldev.h. */

/* Other forward declarations */
private int clist_put_current_params(gx_device_clist_writer *cldev);

/* The device procedures */
const gx_device_procs gs_clist_device_procs = {
    clist_open,
    gx_forward_get_initial_matrix,
    gx_default_sync_output,
    clist_output_page,
    clist_close,
    gx_forward_map_rgb_color,
    gx_forward_map_color_rgb,
    clist_fill_rectangle,
    gx_default_tile_rectangle,
    clist_copy_mono,
    clist_copy_color,
    gx_default_draw_line,
    gx_default_get_bits,
    gx_forward_get_params,
    gx_forward_put_params,
    gx_forward_map_cmyk_color,
    gx_forward_get_xfont_procs,
    gx_forward_get_xfont_device,
    gx_forward_map_rgb_alpha_color,
    gx_forward_get_page_device,
    gx_forward_get_alpha_bits,
    clist_copy_alpha,
    clist_get_band,
    gx_default_copy_rop,
    clist_fill_path,
    clist_stroke_path,
    clist_fill_mask,
    gx_default_fill_trapezoid,
    clist_fill_parallelogram,
    clist_fill_triangle,
    gx_default_draw_thin_line,
    gx_default_begin_image,
    gx_default_image_data,
    gx_default_end_image,
    clist_strip_tile_rectangle,
    clist_strip_copy_rop,
    gx_forward_get_clipping_box,
    clist_begin_typed_image,
    clist_get_bits_rectangle,
    gx_forward_map_color_rgb_alpha,
    clist_create_compositor,
    gx_forward_get_hardware_params,
    gx_default_text_begin,
    gx_default_finish_copydevice,
    NULL,			/* begin_transparency_group */
    NULL,			/* end_transparency_group */
    NULL,			/* begin_transparency_mask */
    NULL,			/* end_transparency_mask */
    NULL,			/* discard_transparency_layer */
    gx_forward_get_color_mapping_procs,
    gx_forward_get_color_comp_index,
    gx_forward_encode_color,
    gx_forward_decode_color,
    gx_default_pattern_manage,
    gx_default_fill_rectangle_hl_color,
    gx_default_include_color_space,
    gx_default_fill_linear_color_scanline,
    gx_default_fill_linear_color_trapezoid, /* fixme : write to clist. */
    gx_default_fill_linear_color_triangle,
    gx_forward_update_spot_equivalent_colors
};

/* ------ Define the command set and syntax ------ */

/* Initialization for imager state. */
/* The initial scale is arbitrary. */
const gs_imager_state clist_imager_state_initial =
{gs_imager_state_initial(300.0 / 72.0)};

/*
 * The buffer area (data, data_size) holds a bitmap cache when both writing
 * and reading.  The rest of the space is used for the command buffer and
 * band state bookkeeping when writing, and for the rendering buffer (image
 * device) when reading.  For the moment, we divide the space up
 * arbitrarily, except that we allocate less space for the bitmap cache if
 * the device doesn't need halftoning.
 *
 * All the routines for allocating tables in the buffer are idempotent, so
 * they can be used to check whether a given-size buffer is large enough.
 */

/*
 * Calculate the desired size for the tile cache.
 */
private uint
clist_tile_cache_size(const gx_device * target, uint data_size)
{
    uint bits_size =
    (data_size / 5) &amp; -align_cached_bits_mod;	/* arbitrary */

    if (!gx_device_must_halftone(target)) {	/* No halftones -- cache holds only Patterns &amp; characters. */
	bits_size -= bits_size &gt;&gt; 2;
    }
#define min_bits_size 1024
    if (bits_size &lt; min_bits_size)
	bits_size = min_bits_size;
#undef min_bits_size
    return bits_size;
}

/*
 * Initialize the allocation for the tile cache.  Sets: tile_hash_mask,
 * tile_max_count, tile_table, chunk (structure), bits (structure).
 */
private int
clist_init_tile_cache(gx_device * dev, byte * init_data, ulong data_size)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    byte *data = init_data;
    uint bits_size = data_size;
    /*
     * Partition the bits area between the hash table and the actual
     * bitmaps.  The per-bitmap overhead is about 24 bytes; if the
     * average character size is 10 points, its bitmap takes about 24 +
     * 0.5 * 10/72 * xdpi * 10/72 * ydpi / 8 bytes (the 0.5 being a
     * fudge factor to account for characters being narrower than they
     * are tall), which gives us a guideline for the size of the hash
     * table.
     */
    uint avg_char_size =
	(uint)(dev-&gt;HWResolution[0] * dev-&gt;HWResolution[1] *
	       (0.5 * 10 / 72 * 10 / 72 / 8)) + 24;
    uint hc = bits_size / avg_char_size;
    uint hsize;

    while ((hc + 1) &amp; hc)
	hc |= hc &gt;&gt; 1;		/* make mask (power of 2 - 1) */
    if (hc &lt; 0xff)
	hc = 0xff;		/* make allowance for halftone tiles */
    else if (hc &gt; 0xfff)
	hc = 0xfff;		/* cmd_op_set_tile_index has 12-bit operand */
    /* Make sure the tables will fit. */
    while (hc &gt;= 3 &amp;&amp; (hsize = (hc + 1) * sizeof(tile_hash)) &gt;= bits_size)
	hc &gt;&gt;= 1;
    if (hc &lt; 3)
	return_error(gs_error_rangecheck);
    cdev-&gt;tile_hash_mask = hc;
    cdev-&gt;tile_max_count = hc - (hc &gt;&gt; 2);
    cdev-&gt;tile_table = (tile_hash *) data;
    data += hsize;
    bits_size -= hsize;
    gx_bits_cache_chunk_init(&amp;cdev-&gt;chunk, data, bits_size);
    gx_bits_cache_init(&amp;cdev-&gt;bits, &amp;cdev-&gt;chunk);
    return 0;
}

/*
 * Initialize the allocation for the bands.  Requires: target.  Sets:
 * page_band_height (=page_info.band_params.BandHeight), nbands.
 */
private int
clist_init_bands(gx_device * dev, gx_device_memory *bdev, uint data_size,
		 int band_width, int band_height)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int nbands;

    if (gdev_mem_data_size(bdev, band_width, band_height) &gt; data_size)
	return_error(gs_error_rangecheck);
    cdev-&gt;page_band_height = band_height;
    nbands = (cdev-&gt;target-&gt;height + band_height - 1) / band_height;
    cdev-&gt;nbands = nbands;
#ifdef DEBUG
    if (gs_debug_c('l') | gs_debug_c(':'))
	dlprintf4("[:]width=%d, band_width=%d, band_height=%d, nbands=%d\n",
		  bdev-&gt;width, band_width, band_height, nbands);
#endif
    return 0;
}

/*
 * Initialize the allocation for the band states, which are used only
 * when writing.  Requires: nbands.  Sets: states, cbuf, cend.
 */
private int
clist_init_states(gx_device * dev, byte * init_data, uint data_size)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    ulong state_size = cdev-&gt;nbands * (ulong) sizeof(gx_clist_state);

    /*
     * The +100 in the next line is bogus, but we don't know what the
     * real check should be. We're effectively assuring that at least 100
     * bytes will be available to buffer command operands.
     */
    if (state_size + sizeof(cmd_prefix) + cmd_largest_size + 100 &gt; data_size)
	return_error(gs_error_rangecheck);
    cdev-&gt;states = (gx_clist_state *) init_data;
    cdev-&gt;cbuf = init_data + state_size;
    cdev-&gt;cend = init_data + data_size;
    return 0;
}

/*
 * Initialize all the data allocations.  Requires: target.  Sets:
 * page_tile_cache_size, page_info.band_params.BandWidth,
 * page_info.band_params.BandBufferSpace, + see above.
 */
private int
clist_init_data(gx_device * dev, byte * init_data, uint data_size)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    gx_device *target = cdev-&gt;target;
    const int band_width =
	cdev-&gt;page_info.band_params.BandWidth =
	(cdev-&gt;band_params.BandWidth ? cdev-&gt;band_params.BandWidth :
	 target-&gt;width);
    int band_height = cdev-&gt;band_params.BandHeight;
    bool page_uses_transparency = cdev-&gt;page_uses_transparency;
    const uint band_space =
    cdev-&gt;page_info.band_params.BandBufferSpace =
	(cdev-&gt;band_params.BandBufferSpace ?
	 cdev-&gt;band_params.BandBufferSpace : data_size);
    byte *data = init_data;
    uint size = band_space;
    uint bits_size;
    gx_device_memory bdev;
    gx_device *pbdev = (gx_device *)&amp;bdev;
    int code;

    /* Call create_buf_device to get the memory planarity set up. */
    cdev-&gt;buf_procs.create_buf_device(&amp;pbdev, target, NULL, NULL, true);
    /* HACK - if the buffer device can't do copy_alpha, disallow */
    /* copy_alpha in the commmand list device as well. */
    if (dev_proc(pbdev, copy_alpha) == gx_no_copy_alpha)
	cdev-&gt;disable_mask |= clist_disable_copy_alpha;
    if (band_height) {
	/*
	 * The band height is fixed, so the band buffer requirement
	 * is completely determined.
	 */
	uint band_data_size =
	    gdev_mem_data_size(&amp;bdev, band_width, band_height);

	if (band_data_size &gt;= band_space)
	    return_error(gs_error_rangecheck);
	bits_size = min(band_space - band_data_size, data_size &gt;&gt; 1);
    } else {
	/*
	 * Choose the largest band height that will fit in the
	 * rendering-time buffer.
	 */
	bits_size = clist_tile_cache_size(target, band_space);
	bits_size = min(bits_size, data_size &gt;&gt; 1);
	band_height = gdev_mem_max_height(&amp;bdev, band_width,
			  band_space - bits_size, page_uses_transparency);
	if (band_height == 0)
	    return_error(gs_error_rangecheck);
    }
    code = clist_init_tile_cache(dev, data, bits_size);
    if (code &lt; 0)
	return code;
    cdev-&gt;page_tile_cache_size = bits_size;
    data += bits_size;
    size -= bits_size;
    code = clist_init_bands(dev, &amp;bdev, size, band_width, band_height);
    if (code &lt; 0)
	return code;
    return clist_init_states(dev, data, data_size - bits_size);
}
/*
 * Reset the device state (for writing).  This routine requires only
 * data, data_size, and target to be set, and is idempotent.
 */
private int
clist_reset(gx_device * dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int code = clist_init_data(dev, cdev-&gt;data, cdev-&gt;data_size);
    int nbands;

    if (code &lt; 0)
	return (cdev-&gt;permanent_error = code);
    /* Now initialize the rest of the state. */
    cdev-&gt;permanent_error = 0;
    nbands = cdev-&gt;nbands;
    cdev-&gt;ymin = cdev-&gt;ymax = -1;	/* render_init not done yet */
    memset(cdev-&gt;tile_table, 0, (cdev-&gt;tile_hash_mask + 1) *
	   sizeof(*cdev-&gt;tile_table));
    cdev-&gt;cnext = cdev-&gt;cbuf;
    cdev-&gt;ccl = 0;
    cdev-&gt;band_range_list.head = cdev-&gt;band_range_list.tail = 0;
    cdev-&gt;band_range_min = 0;
    cdev-&gt;band_range_max = nbands - 1;
    {
	int band;
	gx_clist_state *states = cdev-&gt;states;

	for (band = 0; band &lt; nbands; band++, states++) {
	    static const gx_clist_state cls_initial =
	    {cls_initial_values};

	    *states = cls_initial;
	}
    }
    /*
     * Round up the size of the per-tile band mask so that the bits,
     * which follow it, stay aligned.
     */
    cdev-&gt;tile_band_mask_size =
	((nbands + (align_bitmap_mod * 8 - 1)) &gt;&gt; 3) &amp;
	~(align_bitmap_mod - 1);
    /*
     * Initialize the all-band parameters to impossible values,
     * to force them to be written the first time they are used.
     */
    memset(&amp;cdev-&gt;tile_params, 0, sizeof(cdev-&gt;tile_params));
    cdev-&gt;tile_depth = 0;
    cdev-&gt;tile_known_min = nbands;
    cdev-&gt;tile_known_max = -1;
    cdev-&gt;imager_state = clist_imager_state_initial;
    cdev-&gt;clip_path = NULL;
    cdev-&gt;clip_path_id = gs_no_id;
    cdev-&gt;color_space.byte1 = 0;
    cdev-&gt;color_space.id = gs_no_id;
    cdev-&gt;color_space.space = 0;
    {
	int i;

	for (i = 0; i &lt; countof(cdev-&gt;transfer_ids); ++i)
	    cdev-&gt;transfer_ids[i] = gs_no_id;
    }
    cdev-&gt;black_generation_id = gs_no_id;
    cdev-&gt;undercolor_removal_id = gs_no_id;
    cdev-&gt;device_halftone_id = gs_no_id;
    cdev-&gt;image_enum_id = gs_no_id;
    return 0;
}
/*
 * Initialize the device state (for writing).  This routine requires only
 * data, data_size, and target to be set, and is idempotent.
 */
private int
clist_init(gx_device * dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int code = clist_reset(dev);

    if (code &gt;= 0) {
	cdev-&gt;image_enum_id = gs_no_id;
	cdev-&gt;error_is_retryable = 0;
	cdev-&gt;driver_call_nesting = 0;
	cdev-&gt;ignore_lo_mem_warnings = 0;
    }
    return code;
}

/* (Re)init open band files for output (set block size, etc). */
private int	/* ret 0 ok, -ve error code */
clist_reinit_output_file(gx_device *dev)
{    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int code = 0;

    /* bfile needs to guarantee cmd_blocks for: 1 band range, nbands */
    /*  &amp; terminating entry */
    int b_block = sizeof(cmd_block) * (cdev-&gt;nbands + 2);

    /* cfile needs to guarantee one writer buffer */
    /*  + one end_clip cmd (if during image's clip path setup) */
    /*  + an end_image cmd for each band (if during image) */
    /*  + end_cmds for each band and one band range */
    int c_block =
	cdev-&gt;cend - cdev-&gt;cbuf + 2 + cdev-&gt;nbands * 2 + (cdev-&gt;nbands + 1);

    /* All this is for partial page rendering's benefit, do only */
    /* if partial page rendering is available */
    if ( clist_test_VMerror_recoverable(cdev) )
	{ if (cdev-&gt;page_bfile != 0)
	    code = clist_set_memory_warning(cdev-&gt;page_bfile, b_block);
	if (code &gt;= 0 &amp;&amp; cdev-&gt;page_cfile != 0)
	    code = clist_set_memory_warning(cdev-&gt;page_cfile, c_block);
	}
    return code;
}

/* Write out the current parameters that must be at the head of each page */
/* if async rendering is in effect */
private int
clist_emit_page_header(gx_device *dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int code = 0;

    if ((cdev-&gt;disable_mask &amp; clist_disable_pass_thru_params)) {
	do
	    if ((code = clist_put_current_params(cdev)) &gt;= 0)
	        break;
	while ((code = clist_VMerror_recover(cdev, code)) &gt;= 0);
	cdev-&gt;permanent_error = (code &lt; 0 ? code : 0);
	if (cdev-&gt;permanent_error &lt; 0)
	    cdev-&gt;error_is_retryable = 0;
    }
    return code;
}

/* Reset parameters for the beginning of a page. */
private void
clist_reset_page(gx_device_clist_writer *cwdev)
{
    cwdev-&gt;page_bfile_end_pos = 0;
    /* Indicate that the colors_used information hasn't been computed. */
    cwdev-&gt;page_info.scan_lines_per_colors_used = 0;
    memset(cwdev-&gt;page_info.band_colors_used, 0,
	   sizeof(cwdev-&gt;page_info.band_colors_used));
}

/* Open the device's bandfiles */
private int
clist_open_output_file(gx_device *dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    char fmode[4];
    int code;

    if (cdev-&gt;do_not_open_or_close_bandfiles)
	return 0; /* external bandfile open/close managed externally */
    cdev-&gt;page_cfile = 0;	/* in case of failure */
    cdev-&gt;page_bfile = 0;	/* ditto */
    code = clist_init(dev);
    if (code &lt; 0)
	return code;
    strcpy(fmode, "w+");
    strcat(fmode, gp_fmode_binary_suffix);
    cdev-&gt;page_cfname[0] = 0;	/* create a new file */
    cdev-&gt;page_bfname[0] = 0;	/* ditto */
    clist_reset_page(cdev);
    if ((code = clist_fopen(cdev-&gt;page_cfname, fmode, &amp;cdev-&gt;page_cfile,
			    cdev-&gt;bandlist_memory, cdev-&gt;bandlist_memory,
			    true)) &lt; 0 ||
	(code = clist_fopen(cdev-&gt;page_bfname, fmode, &amp;cdev-&gt;page_bfile,
			    cdev-&gt;bandlist_memory, cdev-&gt;bandlist_memory,
			    true)) &lt; 0 ||
	(code = clist_reinit_output_file(dev)) &lt; 0
	) {
	clist_close_output_file(dev);
	cdev-&gt;permanent_error = code;
	cdev-&gt;error_is_retryable = 0;
    }
    return code;
}

/* Close, and free the contents of, the temporary files of a page. */
/* Note that this does not deallocate the buffer. */
int
clist_close_page_info(gx_band_page_info_t *ppi)
{
    if (ppi-&gt;cfile != NULL) {
	clist_fclose(ppi-&gt;cfile, ppi-&gt;cfname, true);
	ppi-&gt;cfile = NULL;
    }
    if (ppi-&gt;bfile != NULL) {
	clist_fclose(ppi-&gt;bfile, ppi-&gt;bfname, true);
	ppi-&gt;bfile = NULL;
    }
    return 0;
}

/* Close the device by freeing the temporary files. */
/* Note that this does not deallocate the buffer. */
int
clist_close_output_file(gx_device *dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;

    return clist_close_page_info(&amp;cdev-&gt;page_info);
}

/* Open the device by initializing the device state and opening the */
/* scratch files. */
private int
clist_open(gx_device *dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int code;

    cdev-&gt;permanent_error = 0;
    code = clist_init(dev);
    if (code &lt; 0)
	return code;
    code = clist_open_output_file(dev);
    if ( code &gt;= 0)
	code = clist_emit_page_header(dev);
    return code;
}

private int
clist_close(gx_device *dev)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;

    if (cdev-&gt;do_not_open_or_close_bandfiles)
	return 0;	
    return clist_close_output_file(dev);
}

/* The output_page procedure should never be called! */
private int
clist_output_page(gx_device * dev, int num_copies, int flush)
{
    return_error(gs_error_Fatal);
}

/* Reset (or prepare to append to) the command list after printing a page. */
int
clist_finish_page(gx_device *dev, bool flush)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int code;

    if (flush) {
	if (cdev-&gt;page_cfile != 0)
	    clist_rewind(cdev-&gt;page_cfile, true, cdev-&gt;page_cfname);
	if (cdev-&gt;page_bfile != 0)
	    clist_rewind(cdev-&gt;page_bfile, true, cdev-&gt;page_bfname);
	clist_reset_page(cdev);
    } else {
	if (cdev-&gt;page_cfile != 0)
	    clist_fseek(cdev-&gt;page_cfile, 0L, SEEK_END, cdev-&gt;page_cfname);
	if (cdev-&gt;page_bfile != 0)
	    clist_fseek(cdev-&gt;page_bfile, 0L, SEEK_END, cdev-&gt;page_bfname);
    }
    code = clist_init(dev);		/* reinitialize */
    if (code &gt;= 0)
	code = clist_reinit_output_file(dev);
    if (code &gt;= 0)
	code = clist_emit_page_header(dev);

    return code;
}

/* ------ Writing ------ */

/* End a page by flushing the buffer and terminating the command list. */
int	/* ret 0 all-ok, -ve error code, or +1 ok w/low-mem warning */
clist_end_page(gx_device_clist_writer * cldev)
{
    int code = cmd_write_buffer(cldev, cmd_opv_end_page);
    cmd_block cb;
    int ecode = 0;

    if (code &gt;= 0) {
	/*
	 * Write the terminating entry in the block file.
	 * Note that because of copypage, there may be many such entries.
	 */
	cb.band_min = cb.band_max = cmd_band_end;
	cb.pos = (cldev-&gt;page_cfile == 0 ? 0 : clist_ftell(cldev-&gt;page_cfile));
	code = clist_fwrite_chars(&amp;cb, sizeof(cb), cldev-&gt;page_bfile);
	if (code &gt; 0)
	    code = 0;
    }
    if (code &gt;= 0) {
	clist_compute_colors_used(cldev);
	ecode |= code;
	cldev-&gt;page_bfile_end_pos = clist_ftell(cldev-&gt;page_bfile);
    }
    if (code &lt; 0)
	ecode = code;

    /* Reset warning margin to 0 to release reserve memory if mem files */
    if (cldev-&gt;page_bfile != 0)
	clist_set_memory_warning(cldev-&gt;page_bfile, 0);
    if (cldev-&gt;page_cfile != 0)
	clist_set_memory_warning(cldev-&gt;page_cfile, 0);

#ifdef DEBUG
    if (gs_debug_c('l') | gs_debug_c(':'))
	dlprintf2("[:]clist_end_page at cfile=%ld, bfile=%ld\n",
		  cb.pos, cldev-&gt;page_bfile_end_pos);
#endif
    return 0;
}

/* Compute the set of used colors in the page_info structure. */
void
clist_compute_colors_used(gx_device_clist_writer *cldev)
{
    int nbands = cldev-&gt;nbands;
    int bands_per_colors_used =
	(nbands + PAGE_INFO_NUM_COLORS_USED - 1) /
	PAGE_INFO_NUM_COLORS_USED;
    int band;

    cldev-&gt;page_info.scan_lines_per_colors_used =
	cldev-&gt;page_band_height * bands_per_colors_used;
    memset(cldev-&gt;page_info.band_colors_used, 0,
	   sizeof(cldev-&gt;page_info.band_colors_used));
    for (band = 0; band &lt; nbands; ++band) {
	int entry = band / bands_per_colors_used;

	cldev-&gt;page_info.band_colors_used[entry].or |=
	    cldev-&gt;states[band].colors_used.or;
	cldev-&gt;page_info.band_colors_used[entry].slow_rop |=
	    cldev-&gt;states[band].colors_used.slow_rop;
    }
}

/* Recover recoverable VM error if possible without flushing */
int	/* ret -ve err, &gt;= 0 if recovered w/# = cnt pages left in page queue */
clist_VMerror_recover(gx_device_clist_writer *cldev,
		      int old_error_code)
{
    int code = old_error_code;
    int pages_remain;

    if (!clist_test_VMerror_recoverable(cldev) ||
	!cldev-&gt;error_is_retryable ||
	old_error_code != gs_error_VMerror
	)
	return old_error_code;

    /* Do some rendering, return if enough memory is now free */
    do {
	pages_remain =
	    (*cldev-&gt;free_up_bandlist_memory)( (gx_device *)cldev, false );
	if (pages_remain &lt; 0) {
	    code = pages_remain;	/* abort, error or interrupt req */
	    break;
	}
	if (clist_reinit_output_file( (gx_device *)cldev ) == 0) {
	    code = pages_remain;	/* got enough memory to continue */
	    break;
	}
    } while (pages_remain);

    if_debug1('L', "[L]soft flush of command list, status: %d\n", code);
    return code;
}

/* If recoverable VM error, flush &amp; try to recover it */
int	/* ret 0 ok, else -ve error */
clist_VMerror_recover_flush(gx_device_clist_writer *cldev,
			    int old_error_code)
{
    int free_code = 0;
    int reset_code = 0;
    int code;

    /* If the device has the ability to render partial pages, flush
     * out the bandlist, and reset the writing state. Then, get the
     * device to render this band. When done, see if there's now enough
     * memory to satisfy the minimum low-memory guarantees. If not, 
     * get the device to render some more. If there's nothing left to
     * render &amp; still insufficient memory, declare an error condition.
     */
    if (!clist_test_VMerror_recoverable(cldev) ||
	old_error_code != gs_error_VMerror
	)
	return old_error_code;	/* sorry, don't have any means to recover this error */
    free_code = (*cldev-&gt;free_up_bandlist_memory)( (gx_device *)cldev, true );

    /* Reset the state of bands to "don't know anything" */
    reset_code = clist_reset( (gx_device *)cldev );
    if (reset_code &gt;= 0)
	reset_code = clist_open_output_file( (gx_device *)cldev );
    if ( reset_code &gt;= 0 &amp;&amp;
	 (cldev-&gt;disable_mask &amp; clist_disable_pass_thru_params)
	 )
	reset_code = clist_put_current_params(cldev);
    if (reset_code &lt; 0) {
	cldev-&gt;permanent_error = reset_code;
	cldev-&gt;error_is_retryable = 0;
    }
 
    code = (reset_code &lt; 0 ? reset_code : free_code &lt; 0 ? old_error_code : 0);
    if_debug1('L', "[L]hard flush of command list, status: %d\n", code);
    return code;
}

/* Write the target device's current parameter list */
private int	/* ret 0 all ok, -ve error */
clist_put_current_params(gx_device_clist_writer *cldev)
{
    gx_device *target = cldev-&gt;target;
    gs_c_param_list param_list;
    int code;

    /*
     * If a put_params call fails, the device will be left in a closed
     * state, but higher-level code won't notice this fact.  We flag this by
     * setting permanent_error, which prevents writing to the command list.
     */

    if (cldev-&gt;permanent_error)
	return cldev-&gt;permanent_error;
    gs_c_param_list_write(&amp;param_list, cldev-&gt;memory);
    code = (*dev_proc(target, get_params))
	(target, (gs_param_list *)&amp;param_list);
    if (code &gt;= 0) {
	gs_c_param_list_read(&amp;param_list);
	code = cmd_put_params( cldev, (gs_param_list *)&amp;param_list );
    }
    gs_c_param_list_release(&amp;param_list);

    return code;
}

/* ---------------- Driver interface ---------------- */

private int
clist_get_band(gx_device * dev, int y, int *band_start)
{
    gx_device_clist_writer * const cdev =
	&amp;((gx_device_clist *)dev)-&gt;writer;
    int band_height = cdev-&gt;page_band_height;
    int start;

    if (y &lt; 0)
	y = 0;
    else if (y &gt;= dev-&gt;height)
	y = dev-&gt;height;
    *band_start = start = y - y % band_height;
    return min(dev-&gt;height - start, band_height);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

