<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxclmem.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxclmem.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 1996, 1997, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxclmem.c,v 1.5 2002/06/16 05:48:55 lpd Exp $ */
/* RAM-based command list implementation */
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gxclmem.h"

/*
 * Based on: memfile.c        Version: 1.4 3/21/95 14:59:33 by Ray Johnston.
 * Copyright assigned to Aladdin Enterprises.
 */

/*****************************************************************************

   This package is more or less optimal for use by the clist routines, with
   a couple of the more likely to change "tuning" parameters given in the
   two macros below -- NEED_TO_COMPRESS and GET_NUM_RAW_BUFFERS. Usually
   the NEED_TO_COMPRESS decision will be deferred as long as possible based
   on some total system free RAM space remaining.

   The data structures are in "memfile.h", and the primary 'tuning' parameter
   is MEMFILE_DATA_SIZE. This should not be too small to keep the overhead
   ratio of the block structures to the clist data small. A value of 16384
   is probably in the ballpark.

   The concept is that a memory based "file" is created initially without
   compression, with index blocks every MEMFILE_DATA_SIZE of the file. The
   primary blocks (used by the memfile_fseek logic) for indexing into the
   file are called 'logical' (LOG_MEMFILE_BLK) and the data in stored in a
   different block called a 'physical' block (PHYS_MEMFILE_BLK). When the
   file is not yet compressed, indicated by (f-&gt;phys_curr==NULL), then there
   is one physical block for each logical block. The physical block also has
   the 'data_limit' set to NULL if the data is not compressed. Thus when a
   file is not compressed there is one physical block for each logical block.

COMPRESSION.

   When compression is triggered for a file then all of the blocks except
   the last are compressed.  Compression will result in a physical block
   that holds data for more than one logical block. Each logical block now
   points to the start of compressed data in a physical block with the
   'phys_pdata' pointer. The 'data_limit' pointer in the physical block is
   where the compression logic stopped storing data (as stream data
   compressors are allowed to do). The data for the logical block may span
   to the next physical block. Once physical blocks are compressed, they are
   chained together using the 'link' field.

   The 'f-&gt;phys_curr' points to the block being filled by compression, with
   the 'f-&gt;wt.ptr' pointing to the last byte filled in the block. These are
   used during subsequent compression when the last logical block of the
   file fills the physical block.

DECOMPRESSION.

   During reading the clist, if the logical block points to an uncompressed
   physical block, then 'memfile_get_pdata' simply sets the 'pdata' and the
   'pdata_end' pointers. If the logical block was compressed, then it may
   still be resident in a cache of decompression buffers. The number of these
   decompression buffers is not critical -- even one is enough, but having
   more may prevent decompressing blocks more than once (a cache_miss). The
   number of decompression buffers, called "raw" buffers, that are attempted
   to allocate can be changed with the GET_NUM_RAW_BUFFERS macro, but no
   error occurs if less than that number can be allocated.

   If the logical block still resides in a decompression cache buffer, then
   the 'raw_block' will identify the block. If the data for a logical block
   only exists in compressed form, then the "tail" of the list of decompression
   buffers is re-used, marking the 'raw_block' of the logical block that was
   previously associated with this data to NULL.

   Whichever raw decompression buffer is accessed is moved to the head of the
   decompression buffer list in order to keep the tail of the list as the
   "least recently used".

   There are some DEBUG global static variables used to count the number of
   cache hits "tot_cache_hits" and the number of times a logical block is
   decompressed "tot_cache_miss". Note that the actual number of cache miss
   events is 'f-&gt;log_length/MEMFILE_DATA_SIZE - tot_cache_miss' since we
   assume that every logical block must be decmpressed at least once.

   Empirical results so far indicate that if one cache raw buffer for every
   32 logical blocks, then the hit/miss ratio exceeds 99%. Of course, the
   number of raw buffers should be more than 1 if possible, and in many
   implementations (single threaded), the memory usage does not increase
   during the page output step so almost all of memory can be used for
   these raw buffers to prevent the likelihood of a cache miss.

   Of course, this is dependent on reasonably efficient clist blocking
   during writing which is dependent on the data and on the BufferSpace
   value which determines the number of clist band data buffers available.
   Empirical testing shows that the overall efficiency is best if the
   BufferSpace value is 1,000,000 (as in the original Ghostscript source).
   [Note: I expected to be able to use smaller buffer sizes for some cases,
    but this resulted in a high level of thrashing...RJJ]

LIMITATIONS.

   The most serious limitation is caused by the way 'memfile_fwrite' decides
   to free up and re-initialize a file. If memfile_fwrite is called after
   a seek to any location except the start of the file, then an error is
   issued since logic is not present to properly free up on a partial file.
   This is not a problem as used by the 'clist' logic since rewind is used
   to position to the start of a file when re-using it after an 'erasepage'.

   Since the 'clist' logic always traverses the clist using fseek's to ever
   increasing locations, no optimizations of backward seeks was implemented.
   This would be relatively easy with back chain links or bi-directional
   "X-OR" pointer information to link the logical block chain. The rewind
   function is optimal and moves directly to the start of the file.

********************************************************************************/

/*
   The need to compress should be conditional on the amount of available
   memory, but we don't have a way to communicate this to these routines.
   Instead, we simply start compressing when we've allocated more than
   COMPRESSION_THRESHOLD amount of data.  The threshold should be at
   least as large as the fixed overhead of the compressor plus the
   decompressor, plus the expected compressed size of a block that size.
 */
private const long COMPRESSION_THRESHOLD = 300000;

#define NEED_TO_COMPRESS(f)\
  ((f)-&gt;ok_to_compress &amp;&amp; (f)-&gt;total_space &gt; COMPRESSION_THRESHOLD)

   /* FOR NOW ALLOCATE 1 raw buffer for every 32 blocks (at least 8)    */
#define GET_NUM_RAW_BUFFERS( f ) 					\
	 max(f-&gt;log_length/MEMFILE_DATA_SIZE/32, 8)

#define MALLOC(f, siz, cname)\
  (void *)gs_alloc_bytes((f)-&gt;data_memory, siz, cname)
#define FREE(f, obj, cname)\
  (gs_free_object((f)-&gt;data_memory, obj, cname),\
   (f)-&gt;total_space -= sizeof(*(obj)))

/* Structure descriptor for GC */
private_st_MEMFILE();

	/* forward references */
private void memfile_free_mem(MEMFILE * f);
private int memfile_init_empty(MEMFILE * f);

/************************************************/
/*   #define DEBUG      /- force statistics -/  */
/************************************************/

#ifdef DEBUG
long tot_compressed;
long tot_raw;
long tot_cache_miss;
long tot_cache_hits;
long tot_swap_out;

/*
   The following pointers are here only for helping with a dumb debugger
   that can't inspect local variables!
 */
byte *decomp_wt_ptr0, *decomp_wt_limit0;
const byte *decomp_rd_ptr0, *decomp_rd_limit0;
byte *decomp_wt_ptr1, *decomp_wt_limit1;
const byte *decomp_rd_ptr1, *decomp_rd_limit1;

#endif

/* ----------------------------- Memory Allocation --------------------- */
void *	/* allocated memory's address, 0 if failure */
allocateWithReserve(
         MEMFILE  *f,			/* file to allocate mem to */
         int      sizeofBlock,		/* size of block to allocate */
         int      *return_code,         /* RET 0 ok, -ve GS-style error, or +1 if OK but low memory */
	 const   char     *allocName,		/* name to allocate by */
	 const   char     *errorMessage         /* error message to print */
)
{
    int code = 0;	/* assume success */
    void *block = MALLOC(f, sizeofBlock, allocName);

    if (block == NULL) {
	/* Try to recover block from reserve */
	if (sizeofBlock == sizeof(LOG_MEMFILE_BLK)) {
	    if (f-&gt;reserveLogBlockCount &gt; 0) {
		block = f-&gt;reserveLogBlockChain;
		f-&gt;reserveLogBlockChain = f-&gt;reserveLogBlockChain-&gt;link;
		--f-&gt;reserveLogBlockCount;
	    }
	} else if (sizeofBlock == sizeof(PHYS_MEMFILE_BLK) ||
		   sizeofBlock == sizeof(RAW_BUFFER)
		   ) {
	    if (f-&gt;reservePhysBlockCount &gt; 0) {
		block = f-&gt;reservePhysBlockChain;
		f-&gt;reservePhysBlockChain = f-&gt;reservePhysBlockChain-&gt;link;
		--f-&gt;reservePhysBlockCount;
	    }
	}
	if (block != NULL)
	    code = 1;	/* successful, but allocated from reserve */
    }
    if (block != NULL)
	f-&gt;total_space += sizeofBlock;
    else
	code = gs_note_error(gs_error_VMerror);
    *return_code = code;
    return block;
}   

/* ---------------- Open/close/unlink ---------------- */

int
memfile_fopen(char fname[gp_file_name_sizeof], const char *fmode,
	      clist_file_ptr /*MEMFILE * */  * pf,
	      gs_memory_t *mem, gs_memory_t *data_mem, bool ok_to_compress)
{
    MEMFILE *f = 0;
    int code = 0;

    /* We don't implement reopening an existing file. */
    if (fname[0] != 0 || fmode[0] != 'w') {
	code = gs_note_error(gs_error_invalidfileaccess);
	goto finish;
    }

    /* There is no need to set fname in this implementation, */
    /* but we do it anyway. */
    fname[0] = (ok_to_compress ? 'a' : 'b');
    fname[1] = 0;

    f = gs_alloc_struct(mem, MEMFILE, &amp;st_MEMFILE,
			"memfile_open_scratch(MEMFILE)");
    if (f == NULL) {
	eprintf1("memfile_open_scratch(%s): gs_alloc_struct failed\n", fname);
	code = gs_note_error(gs_error_VMerror);
	goto finish;
    }
    f-&gt;memory = mem;
    f-&gt;data_memory = data_mem;
    /* init an empty file, BEFORE allocating de/compress state */
    f-&gt;compress_state = 0;	/* make clean for GC, or alloc'n failure */
    f-&gt;decompress_state = 0;
    f-&gt;total_space = 0;
    f-&gt;reservePhysBlockChain = NULL;
    f-&gt;reservePhysBlockCount = 0;
    f-&gt;reserveLogBlockChain = NULL;
    f-&gt;reserveLogBlockCount = 0;
    /* init an empty file           */
    if ((code = memfile_init_empty(f)) &lt; 0)
	goto finish;
    if ((code = memfile_set_memory_warning(f, 0)) &lt; 0)
	goto finish;
    /*
     * Disregard the ok_to_compress flag, since the size threshold gives us
     * a much better criterion for deciding when compression is appropriate.
     */
    f-&gt;ok_to_compress = /*ok_to_compress */ true;
    f-&gt;compress_state = 0;	/* make clean for GC */
    f-&gt;decompress_state = 0;
    if (f-&gt;ok_to_compress) {
	const stream_state *compress_proto = clist_compressor_state(NULL);
	const stream_state *decompress_proto = clist_decompressor_state(NULL);
	const stream_template *compress_template = compress_proto-&gt;template;
	const stream_template *decompress_template = decompress_proto-&gt;template;

	f-&gt;compress_state =
	    gs_alloc_struct(mem, stream_state, compress_template-&gt;stype,
			    "memfile_open_scratch(compress_state)");
	f-&gt;decompress_state =
	    gs_alloc_struct(mem, stream_state, decompress_template-&gt;stype,
			    "memfile_open_scratch(decompress_state)");
	if (f-&gt;compress_state == 0 || f-&gt;decompress_state == 0) {
	    eprintf1("memfile_open_scratch(%s): gs_alloc_struct failed\n", fname);
	    code = gs_note_error(gs_error_VMerror);
	    goto finish;
	}
	memcpy(f-&gt;compress_state, compress_proto,
	       gs_struct_type_size(compress_template-&gt;stype));
	f-&gt;compress_state-&gt;memory = mem;
	memcpy(f-&gt;decompress_state, decompress_proto,
	       gs_struct_type_size(decompress_template-&gt;stype));
	f-&gt;decompress_state-&gt;memory = mem;
	if (compress_template-&gt;set_defaults)
	    (*compress_template-&gt;set_defaults) (f-&gt;compress_state);
	if (decompress_template-&gt;set_defaults)
	    (*decompress_template-&gt;set_defaults) (f-&gt;decompress_state);
    }
    f-&gt;total_space = 0;

#ifdef DEBUG
    /* If this is the start, init some statistics.       */
    /* Hack: we know the 'a' file is opened first. */
    if (*fname == 'a') {
	tot_compressed = 0;
	tot_raw = 0;
	tot_cache_miss = 0;
	tot_cache_hits = 0;
	tot_swap_out = 0;
    }
#endif
finish:
    if (code &lt; 0) {
	/* return failure, clean up memory before leaving */
	if (f != NULL)
	    memfile_fclose((clist_file_ptr)f, fname, true);
    } else {
      /* return success */
      *pf = f;
    }
    return code;
}

int
memfile_fclose(clist_file_ptr cf, const char *fname, bool delete)
{
    MEMFILE *const f = (MEMFILE *)cf;

    /* We don't implement closing without deletion. */
    if (!delete)
	return_error(gs_error_invalidfileaccess);
    memfile_free_mem(f);

    /* Free reserve blocks; don't do it in memfile_free_mem because */
    /* that routine gets called to reinit file */
    while (f-&gt;reserveLogBlockChain != NULL) {
	LOG_MEMFILE_BLK *block = f-&gt;reserveLogBlockChain;

	f-&gt;reserveLogBlockChain = block-&gt;link;
	FREE(f, block, "memfile_set_block_size");
    }
    while (f-&gt;reservePhysBlockChain != NULL) {
	PHYS_MEMFILE_BLK *block = f-&gt;reservePhysBlockChain;

	f-&gt;reservePhysBlockChain = block-&gt;link;
	FREE(f, block, "memfile_set_block_size");
    }

    /* deallocate de/compress state */
    gs_free_object(f-&gt;memory, f-&gt;decompress_state,
		   "memfile_close_and_unlink(decompress_state)");
    gs_free_object(f-&gt;memory, f-&gt;compress_state,
		   "memfile_close_and_unlink(compress_state)");

    /* deallocate the memfile object proper */
    gs_free_object(f-&gt;memory, f, "memfile_close_and_unlink(MEMFILE)");
    return 0;
}

int
memfile_unlink(const char *fname)
{
    /*
     * Since we have no way to represent a memfile other than by the
     * pointer, we don't (can't) implement unlinking.
     */
    return_error(gs_error_invalidfileaccess);
}

/* ---------------- Writing ---------------- */

/* Pre-alloc enough reserve mem blox to guarantee a write of N bytes will succeed */
int	/* returns 0 ok, gs_error_VMerror if insufficient */
memfile_set_memory_warning(clist_file_ptr cf, int bytes_left)
{
    MEMFILE *const f = (MEMFILE *)cf;
    int code = 0;
    /*
     * Determine req'd memory block count from bytes_left.
     * Allocate enough phys &amp; log blocks to hold bytes_left
     * + 1 phys blk for compress_log_blk + 1 phys blk for decompress.
     */
    int logNeeded =
	(bytes_left + MEMFILE_DATA_SIZE - 1) / MEMFILE_DATA_SIZE;
    int physNeeded = logNeeded;

    if (bytes_left &gt; 0)
	++physNeeded;
    if (f-&gt;raw_head == NULL)
	++physNeeded;	/* have yet to allocate read buffers */

    /* Allocate or free memory depending on need */
    while (logNeeded &gt; f-&gt;reserveLogBlockCount) {
	LOG_MEMFILE_BLK *block =
	    MALLOC( f, sizeof(LOG_MEMFILE_BLK), "memfile_set_block_size" );

	if (block == NULL) {
	    code = gs_note_error(gs_error_VMerror);
	    goto finish;
	}
	block-&gt;link = f-&gt;reserveLogBlockChain;
	f-&gt;reserveLogBlockChain = block;
	++f-&gt;reserveLogBlockCount;
    }
    while (logNeeded &lt; f-&gt;reserveLogBlockCount) {
	LOG_MEMFILE_BLK *block = f-&gt;reserveLogBlockChain;

	f-&gt;reserveLogBlockChain = block-&gt;link;
	FREE(f, block, "memfile_set_block_size");
	--f-&gt;reserveLogBlockCount;
    }
    while (physNeeded &gt; f-&gt;reservePhysBlockCount) {
	PHYS_MEMFILE_BLK *block =
	    MALLOC( f,
		    max( sizeof(PHYS_MEMFILE_BLK), sizeof(RAW_BUFFER) ),
		    "memfile_set_block_size");

	if (block == NULL) {
	    code = gs_note_error(gs_error_VMerror);
	    goto finish;
	}
	block-&gt;link = f-&gt;reservePhysBlockChain;
	f-&gt;reservePhysBlockChain = block;
	++f-&gt;reservePhysBlockCount;
    }
    while (physNeeded &lt; f-&gt;reservePhysBlockCount) {
	PHYS_MEMFILE_BLK *block = f-&gt;reservePhysBlockChain;

	f-&gt;reservePhysBlockChain = block-&gt;link;
	FREE(f, block, "memfile_set_block_size");
	--f-&gt;reservePhysBlockCount;
    }
    f-&gt;error_code = 0;	/* memfile_set_block_size is how user resets this */
finish:
    return code;
}

private int
compress_log_blk(MEMFILE * f, LOG_MEMFILE_BLK * bp)
{
    int status;
    int ecode = 0;		/* accumulate low-memory warnings */
    int code;
    long compressed_size;
    byte *start_ptr;
    PHYS_MEMFILE_BLK *newphys;

    /* compress this block */
    f-&gt;rd.ptr = (const byte *)(bp-&gt;phys_blk-&gt;data) - 1;
    f-&gt;rd.limit = f-&gt;rd.ptr + MEMFILE_DATA_SIZE;

    bp-&gt;phys_blk = f-&gt;phys_curr;
    bp-&gt;phys_pdata = (char *)(f-&gt;wt.ptr) + 1;
    if (f-&gt;compress_state-&gt;template-&gt;reinit != 0)
	(*f-&gt;compress_state-&gt;template-&gt;reinit)(f-&gt;compress_state);
    compressed_size = 0;

    start_ptr = f-&gt;wt.ptr;
    status = (*f-&gt;compress_state-&gt;template-&gt;process)(f-&gt;compress_state,
						     &amp;(f-&gt;rd), &amp;(f-&gt;wt), true);
    bp-&gt;phys_blk-&gt;data_limit = (char *)(f-&gt;wt.ptr);

    if (status == 1) {		/* More output space needed (see strimpl.h) */
	/* allocate another physical block, then compress remainder       */
	compressed_size = f-&gt;wt.limit - start_ptr;
	newphys =
	    allocateWithReserve(f, sizeof(*newphys), &amp;code, "memfile newphys",
			"compress_log_blk : MALLOC for 'newphys' failed\n");
	if (code &lt; 0)
	    return code;
	ecode |= code;	/* accumulate any low-memory warnings */
	newphys-&gt;link = NULL;
	bp-&gt;phys_blk-&gt;link = newphys;
	f-&gt;phys_curr = newphys;
	f-&gt;wt.ptr = (byte *) (newphys-&gt;data) - 1;
	f-&gt;wt.limit = f-&gt;wt.ptr + MEMFILE_DATA_SIZE;

	start_ptr = f-&gt;wt.ptr;
	status =
	    (*f-&gt;compress_state-&gt;template-&gt;process)(f-&gt;compress_state,
						    &amp;(f-&gt;rd), &amp;(f-&gt;wt), true);
	if (status != 0) {
	    /*
	     * You'd think the above line is a bug, but in real life 1 src
	     * block never ends up getting split across 3 dest blocks.
	     */
	    /* CHANGE memfile_set_memory_warning if this assumption changes. */
	    eprintf("Compression required more than one full block!\n");
	    return_error(gs_error_Fatal);
	}
	newphys-&gt;data_limit = (char *)(f-&gt;wt.ptr);
    }
    compressed_size += f-&gt;wt.ptr - start_ptr;
    if (compressed_size &gt; MEMFILE_DATA_SIZE) {
	eprintf2("\nCompression didn't - raw=%d, compressed=%ld\n",
		 MEMFILE_DATA_SIZE, compressed_size);
    }
#ifdef DEBUG
    tot_compressed += compressed_size;
#endif
    return (status &lt; 0 ? gs_note_error(gs_error_ioerror) : ecode);
}				/* end "compress_log_blk()"                                     */

/*      Internal (private) routine to handle end of logical block       */
private int	/* ret 0 ok, -ve error, or +ve low-memory warning */
memfile_next_blk(MEMFILE * f)
{
    LOG_MEMFILE_BLK *bp = f-&gt;log_curr_blk;
    LOG_MEMFILE_BLK *newbp;
    PHYS_MEMFILE_BLK *newphys, *oldphys;
    int ecode = 0;		/* accumulate low-memory warnings */
    int code;

    if (f-&gt;phys_curr == NULL) {	/* means NOT compressing                */
	/* allocate a new block                                           */
	newphys =
	    allocateWithReserve(f, sizeof(*newphys), &amp;code, "memfile newphys",
			"memfile_next_blk: MALLOC 1 for 'newphys' failed\n");
	if (code &lt; 0)
	    return code;
	ecode |= code;	/* accumulate low-mem warnings */
	newphys-&gt;link = NULL;
	newphys-&gt;data_limit = NULL;	/* raw                          */

	newbp =
	    allocateWithReserve(f, sizeof(*newbp), &amp;code, "memfile newbp",
			"memfile_next_blk: MALLOC 1 for 'newbp' failed\n");
	if (code &lt; 0) {
	    FREE(f, newphys, "memfile newphys");
	    return code;
	}
	ecode |= code;	/* accumulate low-mem warnings */
	bp-&gt;link = newbp;
	newbp-&gt;link = NULL;
	newbp-&gt;raw_block = NULL;
	f-&gt;log_curr_blk = newbp;

	/* check if need to start compressing                             */
	if (NEED_TO_COMPRESS(f)) {
	    if_debug0(':', "[:]Beginning compression\n");
	    /* compress the entire file up to this point                   */
	    if (!f-&gt;compressor_initialized) {
		int code = 0;

		if (f-&gt;compress_state-&gt;template-&gt;init != 0)
		    code = (*f-&gt;compress_state-&gt;template-&gt;init) (f-&gt;compress_state);
		if (code &lt; 0)
		    return_error(gs_error_VMerror);  /****** BOGUS ******/
		if (f-&gt;decompress_state-&gt;template-&gt;init != 0)
		    code = (*f-&gt;decompress_state-&gt;template-&gt;init)
			(f-&gt;decompress_state);
		if (code &lt; 0)
		    return_error(gs_error_VMerror);  /****** BOGUS ******/
		f-&gt;compressor_initialized = true;
	    }
	    /* Write into the new physical block we just allocated,        */
	    /* replace it after the loop (after some blocks are freed)     */
	    f-&gt;phys_curr = newphys;
	    f-&gt;wt.ptr = (byte *) (newphys-&gt;data) - 1;
	    f-&gt;wt.limit = f-&gt;wt.ptr + MEMFILE_DATA_SIZE;
	    bp = f-&gt;log_head;
	    while (bp != newbp) {	/* don't compress last block    */
		int code;

		oldphys = bp-&gt;phys_blk;
		if ((code = compress_log_blk(f, bp)) &lt; 0)
		    return code;
		ecode |= code;
		FREE(f, oldphys, "memfile_next_blk(oldphys)");
		bp = bp-&gt;link;
	    }			/* end while( ) compress loop                           */
	    /* Allocate a physical block for this (last) logical block     */
	    newphys =
		allocateWithReserve(f, sizeof(*newphys), &amp;code,
			"memfile newphys",
			"memfile_next_blk: MALLOC 2 for 'newphys' failed\n");
	    if (code &lt; 0)
		return code;
	    ecode |= code;	/* accumulate low-mem warnings */
	    newphys-&gt;link = NULL;
	    newphys-&gt;data_limit = NULL;		/* raw                  */

	}			/* end convert file to compressed                                 */
	newbp-&gt;phys_blk = newphys;
	f-&gt;pdata = newphys-&gt;data;
	f-&gt;pdata_end = newphys-&gt;data + MEMFILE_DATA_SIZE;
    }    /* end if NOT compressing                                 */
    /* File IS being compressed                                       */ 
    else {
	int code;

	oldphys = bp-&gt;phys_blk;	/* save raw phys block ID               */
	/* compresses bp on phys list  */
	if ((code = compress_log_blk(f, bp)) &lt; 0)
	    return code;
	ecode |= code;
	newbp =
	    allocateWithReserve(f, sizeof(*newbp), &amp;code, "memfile newbp",
			"memfile_next_blk: MALLOC 2 for 'newbp' failed\n");
	if (code &lt; 0)
	    return code;
	ecode |= code;
	bp-&gt;link = newbp;
	newbp-&gt;link = NULL;
	newbp-&gt;raw_block = NULL;
	/* Re-use the raw phys block for this new logical blk             */
	newbp-&gt;phys_blk = oldphys;
	f-&gt;pdata = oldphys-&gt;data;
	f-&gt;pdata_end = f-&gt;pdata + MEMFILE_DATA_SIZE;
	f-&gt;log_curr_blk = newbp;
    }				/* end else (when we are compressing)                           */

    return (ecode);
}

int	/* returns # of chars actually written */
memfile_fwrite_chars(const void *data, uint len, clist_file_ptr cf)
{
    const char *str = (const char *)data;
    MEMFILE *f = (MEMFILE *) cf;
    uint count = len;
    int ecode;

    /* check if we are writing to the start of the file.  If so, then    */
    /* free the file memory and re-initialize it (frees memory)          */
    if (f-&gt;log_curr_pos == 0) {
	int code;

	memfile_free_mem(f);
	if ((code = memfile_init_empty(f)) &lt; 0) {
	    f-&gt;error_code = code;
	    return 0;
	}
    }
    if (f-&gt;log_curr_blk-&gt;link != 0) {
	eprintf(" Write file truncate -- need to free physical blocks.\n");
    }
    while (count) {
	uint move_count = f-&gt;pdata_end - f-&gt;pdata;

	if (move_count == 0) {
	    if ((ecode = memfile_next_blk(f)) != 0) {
		f-&gt;error_code = ecode;
		if (ecode &lt; 0)
		    return 0;
	    }
	} else {
	    if (move_count &gt; count)
		move_count = count;
	    memmove(f-&gt;pdata, str, move_count);
	    f-&gt;pdata += move_count;
	    str += move_count;
	    count -= move_count;
	}
    }
    f-&gt;log_curr_pos += len;
    f-&gt;log_length = f-&gt;log_curr_pos;	/* truncate length to here      */
#ifdef DEBUG
    tot_raw += len;
#endif
    return (len);
}

/*                                                                      */
/*      Internal routine to set the f-&gt;pdata and f-&gt;pdata_end pointers  */
/*      for the current logical block f-&gt;log_curr_blk                   */
/*                                                                      */
/*      If data only exists in compressed form, allocate a raw buffer   */
/*      and decompress it.                                              */
/*                                                                      */

private int
memfile_get_pdata(MEMFILE * f)
{
    int i, num_raw_buffers, status;
    LOG_MEMFILE_BLK *bp = f-&gt;log_curr_blk;

    if (bp-&gt;phys_blk-&gt;data_limit == NULL) {
	/* Not compressed, return this data pointer                       */
	f-&gt;pdata = (bp-&gt;phys_blk)-&gt;data;
	i = f-&gt;log_curr_pos % MEMFILE_DATA_SIZE;	/* pos within block     */
	i = f-&gt;log_curr_pos - i;	/* base of block        */
	if (i + MEMFILE_DATA_SIZE &gt; f-&gt;log_length)
	    f-&gt;pdata_end = f-&gt;pdata + f-&gt;log_length - i;
	else
	    f-&gt;pdata_end = f-&gt;pdata + MEMFILE_DATA_SIZE;
    } else {
	/* data was compressed                                            */
	if (f-&gt;raw_head == NULL) {
	    /* need to allocate the raw buffer pool                        */
	    num_raw_buffers = GET_NUM_RAW_BUFFERS(f);
	    if (f-&gt;reservePhysBlockCount) {
            /* HACK: allocate reserve block that's been reserved for
	     * decompression.  This buffer's block was pre-allocated to make
	     * sure we won't come up short here. Take from chain instead of
	     * allocateWithReserve() since this buf would just be wasted if
	     * allowed to remain preallocated. */
		f-&gt;raw_head = (RAW_BUFFER *)f-&gt;reservePhysBlockChain;
		f-&gt;reservePhysBlockChain = f-&gt;reservePhysBlockChain-&gt;link;
		--f-&gt;reservePhysBlockCount;
	    } else {
		int code;

		f-&gt;raw_head =
		    allocateWithReserve(f, sizeof(*f-&gt;raw_head), &amp;code,
					"memfile raw buffer",
			"memfile_get_pdata: MALLOC for 'raw_head' failed\n");
		if (code &lt; 0)
		    return code;
	    }
	    f-&gt;raw_head-&gt;back = NULL;
	    f-&gt;raw_tail = f-&gt;raw_head;
	    f-&gt;raw_tail-&gt;log_blk = NULL;
	    for (i = 0; i &lt; num_raw_buffers; i++) {
		f-&gt;raw_tail-&gt;fwd = (RAW_BUFFER *) MALLOC(f, sizeof(RAW_BUFFER),
						      "memfile raw buffer");
		/* if MALLOC fails, then just stop allocating            */
		if (!f-&gt;raw_tail-&gt;fwd)
		    break;
		f-&gt;total_space += sizeof(RAW_BUFFER);
		f-&gt;raw_tail-&gt;fwd-&gt;back = f-&gt;raw_tail;
		f-&gt;raw_tail = f-&gt;raw_tail-&gt;fwd;
		f-&gt;raw_tail-&gt;log_blk = NULL;
	    }
	    f-&gt;raw_tail-&gt;fwd = NULL;
	    num_raw_buffers = i + 1;	/* if MALLOC failed, then OK    */
	    if_debug1(':', "[:]Number of raw buffers allocated=%d\n",
		      num_raw_buffers);
	}			/* end allocating the raw buffer pool (first time only)           */
	if (bp-&gt;raw_block == NULL) {
#ifdef DEBUG
	    tot_cache_miss++;	/* count every decompress       */
#endif
	    /* find a raw buffer and decompress                            */
	    if (f-&gt;raw_tail-&gt;log_blk != NULL) {
		/* This block was in use, grab it                           */
#ifdef DEBUG
		tot_swap_out++;
#endif
		f-&gt;raw_tail-&gt;log_blk-&gt;raw_block = NULL;		/* data no longer here */
		f-&gt;raw_tail-&gt;log_blk = NULL;
	    }
	    /* Use the last raw block in the chain (the oldest)            */
	    f-&gt;raw_tail-&gt;back-&gt;fwd = NULL;	/* disconnect from tail */
	    f-&gt;raw_tail-&gt;fwd = f-&gt;raw_head;	/* new head             */
	    f-&gt;raw_head-&gt;back = f-&gt;raw_tail;
	    f-&gt;raw_tail = f-&gt;raw_tail-&gt;back;
	    f-&gt;raw_head = f-&gt;raw_head-&gt;back;
	    f-&gt;raw_head-&gt;back = NULL;
	    f-&gt;raw_head-&gt;log_blk = bp;

	    /* Decompress the data into this raw block                     */
	    /* Initialize the decompressor                              */
	    if (f-&gt;decompress_state-&gt;template-&gt;reinit != 0)
		(*f-&gt;decompress_state-&gt;template-&gt;reinit) (f-&gt;decompress_state);
	    /* Set pointers and call the decompress routine             */
	    f-&gt;wt.ptr = (byte *) (f-&gt;raw_head-&gt;data) - 1;
	    f-&gt;wt.limit = f-&gt;wt.ptr + MEMFILE_DATA_SIZE;
	    f-&gt;rd.ptr = (const byte *)(bp-&gt;phys_pdata) - 1;
	    f-&gt;rd.limit = (const byte *)bp-&gt;phys_blk-&gt;data_limit;
#ifdef DEBUG
	    decomp_wt_ptr0 = f-&gt;wt.ptr;
	    decomp_wt_limit0 = f-&gt;wt.limit;
	    decomp_rd_ptr0 = f-&gt;rd.ptr;
	    decomp_rd_limit0 = f-&gt;rd.limit;
#endif
	    status = (*f-&gt;decompress_state-&gt;template-&gt;process)
		(f-&gt;decompress_state, &amp;(f-&gt;rd), &amp;(f-&gt;wt), true);
	    if (status == 0) {	/* More input data needed */
		/* switch to next block and continue decompress             */
		int back_up = 0;	/* adjust pointer backwards     */

		if (f-&gt;rd.ptr != f-&gt;rd.limit) {
		    /* transfer remainder bytes from the previous block      */
		    back_up = f-&gt;rd.limit - f-&gt;rd.ptr;
		    for (i = 0; i &lt; back_up; i++)
			*(bp-&gt;phys_blk-&gt;link-&gt;data - back_up + i) = *++f-&gt;rd.ptr;
		}
		f-&gt;rd.ptr = (const byte *)bp-&gt;phys_blk-&gt;link-&gt;data - back_up - 1;
		f-&gt;rd.limit = (const byte *)bp-&gt;phys_blk-&gt;link-&gt;data_limit;
#ifdef DEBUG
		decomp_wt_ptr1 = f-&gt;wt.ptr;
		decomp_wt_limit1 = f-&gt;wt.limit;
		decomp_rd_ptr1 = f-&gt;rd.ptr;
		decomp_rd_limit1 = f-&gt;rd.limit;
#endif
		status = (*f-&gt;decompress_state-&gt;template-&gt;process)
		    (f-&gt;decompress_state, &amp;(f-&gt;rd), &amp;(f-&gt;wt), true);
		if (status == 0) {
		    eprintf("Decompression required more than one full block!\n");
		    return_error(gs_error_Fatal);
		}
	    }
	    bp-&gt;raw_block = f-&gt;raw_head;	/* point to raw block           */
	}
	/* end if( raw_block == NULL ) meaning need to decompress data    */ 
	else {
	    /* data exists in the raw data cache, if not raw_head, move it */
	    if (bp-&gt;raw_block != f-&gt;raw_head) {
		/*          move to raw_head                                */
		/*          prev.fwd = this.fwd                             */
		bp-&gt;raw_block-&gt;back-&gt;fwd = bp-&gt;raw_block-&gt;fwd;
		if (bp-&gt;raw_block-&gt;fwd != NULL)
		    /*               next.back = this.back                   */
		    bp-&gt;raw_block-&gt;fwd-&gt;back = bp-&gt;raw_block-&gt;back;
		else
		    f-&gt;raw_tail = bp-&gt;raw_block-&gt;back;	/* tail = prev        */
		f-&gt;raw_head-&gt;back = bp-&gt;raw_block;	/* head.back = this     */
		bp-&gt;raw_block-&gt;fwd = f-&gt;raw_head;	/* this.fwd = orig head */
		f-&gt;raw_head = bp-&gt;raw_block;	/* head = this          */
		f-&gt;raw_head-&gt;back = NULL;	/* this.back = NULL     */
#ifdef DEBUG
		tot_cache_hits++;	/* counting here prevents repeats since */
		/* won't count if already at head       */
#endif
	    }
	}
	f-&gt;pdata = bp-&gt;raw_block-&gt;data;
	f-&gt;pdata_end = f-&gt;pdata + MEMFILE_DATA_SIZE;
	/* NOTE: last block is never compressed, so a compressed block    */
	/*        is always full size.                                    */
    }				/* end else (when data was compressed)                             */

    return (0);
}

/* ---------------- Reading ---------------- */

int
memfile_fread_chars(void *data, uint len, clist_file_ptr cf)
{
    char *str = (char *)data;
    MEMFILE *f = (MEMFILE *) cf;
    uint count = len, num_read, move_count;

    num_read = f-&gt;log_length - f-&gt;log_curr_pos;
    if (count &gt; num_read)
	count = num_read;
    num_read = count;

    while (count) {
	f-&gt;log_curr_pos++;	/* move into next byte */
	if (f-&gt;pdata == f-&gt;pdata_end) {
	    f-&gt;log_curr_blk = (f-&gt;log_curr_blk)-&gt;link;
	    memfile_get_pdata(f);
	}
	move_count = f-&gt;pdata_end - f-&gt;pdata;
	if (move_count &gt; count)
	    move_count = count;
	f-&gt;log_curr_pos += move_count - 1;	/* new position         */
	memmove(str, f-&gt;pdata, move_count);
	str += move_count;
	f-&gt;pdata += move_count;
	count -= move_count;
    }

    return (num_read);
}

/* ---------------- Position/status ---------------- */

int
memfile_ferror_code(clist_file_ptr cf)
{
    return (((MEMFILE *) cf)-&gt;error_code);	/* errors stored here */
}

long
memfile_ftell(clist_file_ptr cf)
{
    return (((MEMFILE *) cf)-&gt;log_curr_pos);
}

void
memfile_rewind(clist_file_ptr cf, bool discard_data, const char *ignore_fname)
{
    MEMFILE *f = (MEMFILE *) cf;

    if (discard_data) {
	memfile_free_mem(f);
	/* We have to call memfile_init_empty to preserve invariants. */
	memfile_init_empty(f);
    } else {
	f-&gt;log_curr_blk = f-&gt;log_head;
	f-&gt;log_curr_pos = 0;
	memfile_get_pdata(f);
    }
}

int
memfile_fseek(clist_file_ptr cf, long offset, int mode, const char *ignore_fname)
{
    MEMFILE *f = (MEMFILE *) cf;
    long i, block_num, new_pos;

    switch (mode) {
	case SEEK_SET:		/* offset from the beginning of the file */
	    new_pos = offset;
	    break;

	case SEEK_CUR:		/* offset from the current position in the file */
	    new_pos = offset + f-&gt;log_curr_pos;
	    break;

	case SEEK_END:		/* offset back from the end of the file */
	    new_pos = f-&gt;log_length - offset;
	    break;

	default:
	    return (-1);
    }
    if (new_pos &lt; 0 || new_pos &gt; f-&gt;log_length)
	return -1;
    if ((f-&gt;pdata == f-&gt;pdata_end) &amp;&amp; (f-&gt;log_curr_blk-&gt;link != NULL)) {
	/* log_curr_blk is actually one block behind log_curr_pos         */
	f-&gt;log_curr_blk = f-&gt;log_curr_blk-&gt;link;
    }
    block_num = new_pos / MEMFILE_DATA_SIZE;
    i = f-&gt;log_curr_pos / MEMFILE_DATA_SIZE;
    if (block_num &lt; i) {	/* if moving backwards, start at beginning */
	f-&gt;log_curr_blk = f-&gt;log_head;
	i = 0;
    }
    for (; i &lt; block_num; i++) {
	f-&gt;log_curr_blk = f-&gt;log_curr_blk-&gt;link;
    }
    f-&gt;log_curr_pos = new_pos;
    memfile_get_pdata(f);	/* pointers to start of block           */
    f-&gt;pdata += new_pos - (block_num * MEMFILE_DATA_SIZE);

    return 0;			/* return "normal" status                       */
}

/* ---------------- Internal routines ---------------- */

private void
memfile_free_mem(MEMFILE * f)
{
    LOG_MEMFILE_BLK *bp, *tmpbp;

#ifdef DEBUG
    /* output some diagnostics about the effectiveness                   */
    if (tot_raw &gt; 100) {
	if_debug2(':', "[:]tot_raw=%ld, tot_compressed=%ld\n",
		  tot_raw, tot_compressed);
    }
    if (tot_cache_hits != 0) {
	if_debug3(':', "[:]Cache hits=%ld, cache misses=%ld, swapouts=%ld\n",
		 tot_cache_hits,
		 tot_cache_miss - (f-&gt;log_length / MEMFILE_DATA_SIZE),
		 tot_swap_out);
    }
    tot_raw = 0;
    tot_compressed = 0;
    tot_cache_hits = 0;
    tot_cache_miss = 0;
    tot_swap_out = 0;
#endif

    /* Free up memory that was allocated for the memfile              */
    bp = f-&gt;log_head;

/******************************************************************
 * The following was the original algorithm here.  This algorithm has a bug:
 * the second loop references the physical blocks again after they have been
 * freed.
 ******************************************************************/

#if 0				/**************** *************** */

    if (bp != NULL) {
	/* Free the physical blocks that make up the compressed data      */
	PHYS_MEMFILE_BLK *pphys = (f-&gt;log_head)-&gt;phys_blk;

	if (pphys-&gt;data_limit != NULL) {
	    /* the data was compressed, free the chain of blocks             */
	    while (pphys != NULL) {
		PHYS_MEMFILE_BLK *tmpphys = pphys-&gt;link;

		FREE(f, pphys, "memfile_free_mem(pphys)");
		pphys = tmpphys;
	    }
	}
    }
    /* free the logical blocks                                        */
    while (bp != NULL) {
	/* if this logical block was not compressed, free the phys_blk  */
	if (bp-&gt;phys_blk-&gt;data_limit == NULL) {
	    FREE(f, bp-&gt;phys_blk, "memfile_free_mem(phys_blk)");
	}
	tmpbp = bp-&gt;link;
	FREE(f, bp, "memfile_free_mem(log_blk)");
	bp = tmpbp;
    }

#else /**************** *************** */
# if 1				/**************** *************** */

/****************************************************************
 * This algorithm is correct (we think).
 ****************************************************************/

    if (bp != NULL) {
	/* Null out phys_blk pointers to compressed data. */
	PHYS_MEMFILE_BLK *pphys = bp-&gt;phys_blk;

	{
	    for (tmpbp = bp; tmpbp != NULL; tmpbp = tmpbp-&gt;link)
		if (tmpbp-&gt;phys_blk-&gt;data_limit != NULL)
		    tmpbp-&gt;phys_blk = 0;
	}
	/* Free the physical blocks that make up the compressed data      */
	if (pphys-&gt;data_limit != NULL) {
	    /* the data was compressed, free the chain of blocks             */
	    while (pphys != NULL) {
		PHYS_MEMFILE_BLK *tmpphys = pphys-&gt;link;

		FREE(f, pphys, "memfile_free_mem(pphys)");
		pphys = tmpphys;
	    }
	}
    }
    /* Now free the logical blocks, and any uncompressed physical blocks. */
    while (bp != NULL) {
	if (bp-&gt;phys_blk != NULL) {
	    FREE(f, bp-&gt;phys_blk, "memfile_free_mem(phys_blk)");
	}
	tmpbp = bp-&gt;link;
	FREE(f, bp, "memfile_free_mem(log_blk)");
	bp = tmpbp;
    }

/***********************************************************************
 * This algorithm appears to be both simpler and free of the bug that
 * occasionally causes the older one to reference freed blocks; but in
 * fact it can miss blocks, because the very last compressed logical block
 * can have spill into a second physical block, which is not referenced by
 * any logical block.
 ***********************************************************************/

# else				/**************** *************** */

    {
	PHYS_MEMFILE_BLK *prev_phys = 0;

	while (bp != NULL) {
	    PHYS_MEMFILE_BLK *phys = bp-&gt;phys_blk;

	    if (phys != prev_phys) {
		FREE(f, phys, "memfile_free_mem(phys_blk)");
		prev_phys = phys;
	    }
	    tmpbp = bp-&gt;link;
	    FREE(f, bp, "memfile_free_mem(log_blk)");
	    bp = tmpbp;
	}
    }

# endif				/**************** *************** */
#endif /**************** *************** */

    f-&gt;log_head = NULL;

    /* Free any internal compressor state. */
    if (f-&gt;compressor_initialized) {
	if (f-&gt;decompress_state-&gt;template-&gt;release != 0)
	    (*f-&gt;decompress_state-&gt;template-&gt;release) (f-&gt;decompress_state);
	if (f-&gt;compress_state-&gt;template-&gt;release != 0)
	    (*f-&gt;compress_state-&gt;template-&gt;release) (f-&gt;compress_state);
	f-&gt;compressor_initialized = false;
    }
    /* free the raw buffers                                           */
    while (f-&gt;raw_head != NULL) {
	RAW_BUFFER *tmpraw = f-&gt;raw_head-&gt;fwd;

	FREE(f, f-&gt;raw_head, "memfile_free_mem(raw)");
	f-&gt;raw_head = tmpraw;
    }
}

private int
memfile_init_empty(MEMFILE * f)
{
    PHYS_MEMFILE_BLK *pphys;
    LOG_MEMFILE_BLK *plog;

   /* Zero out key fields so that allocation failure will be unwindable */
    f-&gt;phys_curr = NULL; 	/* flag as file not compressed    	*/
    f-&gt;log_head = NULL;
    f-&gt;log_curr_blk = NULL;
    f-&gt;log_curr_pos = 0;
    f-&gt;log_length = 0;
    f-&gt;raw_head = NULL;
    f-&gt;compressor_initialized = false;
    f-&gt;total_space = 0;

    /* File empty - get a physical mem block (includes the buffer area)  */
    pphys = MALLOC(f, sizeof(*pphys), "memfile pphys");
    if (!pphys) {
	eprintf("memfile_init_empty: MALLOC for 'pphys' failed\n");
	return_error(gs_error_VMerror);
    }
    f-&gt;total_space += sizeof(*pphys);
    pphys-&gt;data_limit = NULL;	/* raw data for now     */

   /* Get logical mem block to go with physical one */
    plog = (LOG_MEMFILE_BLK *)MALLOC( f, sizeof(*plog), "memfile_init_empty" );
    if (plog == NULL) {
	FREE(f, pphys, "memfile_init_empty");
	eprintf("memfile_init_empty: MALLOC for log_curr_blk failed\n");
	return_error(gs_error_VMerror);
    }
    f-&gt;total_space += sizeof(*plog);
    f-&gt;log_head = f-&gt;log_curr_blk = plog;
    f-&gt;log_curr_blk-&gt;link = NULL;
    f-&gt;log_curr_blk-&gt;phys_blk = pphys;
    f-&gt;log_curr_blk-&gt;phys_pdata = NULL;
    f-&gt;log_curr_blk-&gt;raw_block = NULL;

    f-&gt;pdata = pphys-&gt;data;
    f-&gt;pdata_end = f-&gt;pdata + MEMFILE_DATA_SIZE;

    f-&gt;error_code = 0;

    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

