<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxclread.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxclread.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1991, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxclread.c,v 1.13 2004/10/07 05:18:34 ray Exp $ */
/* Command list reading for Ghostscript. */
#include "memory_.h"
#include "gx.h"
#include "gp.h"			/* for gp_fmode_rb */
#include "gpcheck.h"
#include "gserrors.h"
#include "gxdevice.h"
#include "gscoord.h"		/* requires gsmatrix.h */
#include "gsdevice.h"		/* for gs_deviceinitialmatrix */
#include "gxdevmem.h"		/* must precede gxcldev.h */
#include "gxcldev.h"
#include "gxgetbit.h"
#include "gxhttile.h"
#include "gdevplnx.h"
/*
 * We really don't like the fact that gdevprn.h is included here, since
 * command lists are supposed to be usable for purposes other than printer
 * devices; but gdev_prn_colors_used and gdev_create_buf_device are
 * currently only applicable to printer devices.
 */
#include "gdevprn.h"
#include "stream.h"
#include "strimpl.h"

/* ------ Band file reading stream ------ */

/*
 * To separate banding per se from command list interpretation,
 * we make the command list interpreter simply read from a stream.
 * When we are actually doing banding, the stream filters the band file
 * and only passes through the commands for the current bands (or band
 * ranges that include a current band).
 */
typedef struct stream_band_read_state_s {
    stream_state_common;
    gx_band_page_info_t page_info;
    int band_first, band_last;
    uint left;			/* amount of data left in this run */
    cmd_block b_this;
} stream_band_read_state;

private int
s_band_read_init(stream_state * st)
{
    stream_band_read_state *const ss = (stream_band_read_state *) st;

    ss-&gt;left = 0;
    ss-&gt;b_this.band_min = 0;
    ss-&gt;b_this.band_max = 0;
    ss-&gt;b_this.pos = 0;
    clist_rewind(ss-&gt;page_bfile, false, ss-&gt;page_bfname);
    return 0;
}

private int
s_band_read_process(stream_state * st, stream_cursor_read * ignore_pr,
		    stream_cursor_write * pw, bool last)
{
    stream_band_read_state *const ss = (stream_band_read_state *) st;
    register byte *q = pw-&gt;ptr;
    byte *wlimit = pw-&gt;limit;
    clist_file_ptr cfile = ss-&gt;page_cfile;
    clist_file_ptr bfile = ss-&gt;page_bfile;
    uint left = ss-&gt;left;
    int status = 1;
    uint count;

    while ((count = wlimit - q) != 0) {
	if (left) {		/* Read more data for the current run. */
	    if (count &gt; left)
		count = left;
	    clist_fread_chars(q + 1, count, cfile);
	    if (clist_ferror_code(cfile) &lt; 0) {
		status = ERRC;
		break;
	    }
	    q += count;
	    left -= count;
	    process_interrupts(st-&gt;memory);
	    continue;
	}
rb:
	/*
	 * Scan for the next run for the current bands (or a band range
	 * that includes a current band).
	 */
	if (ss-&gt;b_this.band_min == cmd_band_end &amp;&amp;
	    clist_ftell(bfile) == ss-&gt;page_bfile_end_pos
	    ) {
	    status = EOFC;
	    break;
	} {
	    int bmin = ss-&gt;b_this.band_min;
	    int bmax = ss-&gt;b_this.band_max;
	    long pos = ss-&gt;b_this.pos;

	    clist_fread_chars(&amp;ss-&gt;b_this, sizeof(ss-&gt;b_this), bfile);
	    if (!(ss-&gt;band_last &gt;= bmin &amp;&amp; ss-&gt;band_first &lt;= bmax))
		goto rb;
	    clist_fseek(cfile, pos, SEEK_SET, ss-&gt;page_cfname);
	    left = (uint) (ss-&gt;b_this.pos - pos);
	    if_debug5('l', "[l]reading for bands (%d,%d) at bfile %ld, cfile %ld, length %u\n",
		      bmin, bmax,
		      clist_ftell(bfile) - 2 * sizeof(ss-&gt;b_this),
		      pos, left);
	}
    }
    pw-&gt;ptr = q;
    ss-&gt;left = left;
    return status;
}

/* Stream template */
private const stream_template s_band_read_template = {
    &amp;st_stream_state, s_band_read_init, s_band_read_process, 1, cbuf_size
};


/* ------ Reading/rendering ------ */

/* Forward references */

private int clist_render_init(gx_device_clist *);
private int clist_playback_file_bands(clist_playback_action action,
				      gx_device_clist_reader *cdev,
				      gx_band_page_info_t *page_info,
				      gx_device *target,
				      int band_first, int band_last,
				      int x0, int y0);
private int clist_rasterize_lines(gx_device *dev, int y, int lineCount,
				  gx_device *bdev,
				  const gx_render_plane_t *render_plane,
				  int *pmy);

/* Calculate the raster for a chunky or planar device. */
private int
clist_plane_raster(const gx_device *dev, const gx_render_plane_t *render_plane)
{
    return bitmap_raster(dev-&gt;width *
			 (render_plane &amp;&amp; render_plane-&gt;index &gt;= 0 ?
			  render_plane-&gt;depth : dev-&gt;color_info.depth));
}

/* Select full-pixel rendering if required for RasterOp. */
private void
clist_select_render_plane(gx_device *dev, int y, int height,
			  gx_render_plane_t *render_plane, int index)
{
    if (index &gt;= 0) {
	gx_colors_used_t colors_used;
	int ignore_start;

	gdev_prn_colors_used(dev, y, height, &amp;colors_used,  &amp;ignore_start);
	if (colors_used.slow_rop)
	    index = -1;
    }
    if (index &lt; 0)
	render_plane-&gt;index = index;
    else
	gx_render_plane_init(render_plane, dev, index);
}

/*
 * Do device setup from params stored in command list. This is only for
 * async rendering &amp; assumes that the first command in every command list
 * is a put_params command which sets all space-related parameters to the
 * value they will have for the duration of that command list.
 */
int
clist_setup_params(gx_device *dev)
{
    gx_device_clist_reader * const crdev =
	&amp;((gx_device_clist *)dev)-&gt;reader;
    int code = clist_render_init((gx_device_clist *)dev);
    if (code &lt; 0)
	return code;

    code = clist_playback_file_bands(playback_action_setup,
				     crdev, &amp;crdev-&gt;page_info, 0, 0, 0, 0, 0);

    /* put_params may have reinitialized device into a writer */
    clist_render_init((gx_device_clist *)dev);

    return code;
}

/* Copy a rasterized rectangle to the client, rasterizing if needed. */
int
clist_get_bits_rectangle(gx_device *dev, const gs_int_rect * prect,
			 gs_get_bits_params_t *params, gs_int_rect **unread)
{
    gx_device_clist_common *cdev = (gx_device_clist_common *)dev;
    gs_get_bits_options_t options = params-&gt;options;
    int y = prect-&gt;p.y;
    int end_y = prect-&gt;q.y;
    int line_count = end_y - y;
    gs_int_rect band_rect;
    int lines_rasterized;
    gx_device *bdev;
    int num_planes =
	(options &amp; GB_PACKING_CHUNKY ? 1 :
	 options &amp; GB_PACKING_PLANAR ? dev-&gt;color_info.num_components :
	 options &amp; GB_PACKING_BIT_PLANAR ? dev-&gt;color_info.depth :
	 0 /****** NOT POSSIBLE ******/);
    gx_render_plane_t render_plane;
    int plane_index;
    int my;
    int code;

    if (prect-&gt;p.x &lt; 0 || prect-&gt;q.x &gt; dev-&gt;width ||
	y &lt; 0 || end_y &gt; dev-&gt;height
	)
	return_error(gs_error_rangecheck);
    if (line_count &lt;= 0 || prect-&gt;p.x &gt;= prect-&gt;q.x)
	return 0;

    /*
     * Calculate the render_plane from the params.  There are two cases:
     * full pixels, or a single plane.
     */
    plane_index = -1;
    if (options &amp; GB_SELECT_PLANES) {
	/* Look for the one selected plane. */
	int i;

	for (i = 0; i &lt; num_planes; ++i)
	    if (params-&gt;data[i]) {
		if (plane_index &gt;= 0)  /* &gt;1 plane requested */
		    return gx_default_get_bits_rectangle(dev, prect, params,
							 unread);
		plane_index = i;
	    }
    }
    clist_select_render_plane(dev, y, line_count, &amp;render_plane, plane_index);
    code = gdev_create_buf_device(cdev-&gt;buf_procs.create_buf_device,
				  &amp;bdev, cdev-&gt;target, &amp;render_plane,
				  dev-&gt;memory, true);
    if (code &lt; 0)
	return code;
    code = clist_rasterize_lines(dev, y, line_count, bdev, &amp;render_plane, &amp;my);
    if (code &lt; 0)
	return code;
    lines_rasterized = min(code, line_count);
    /* Return as much of the rectangle as falls within the rasterized lines. */
    band_rect = *prect;
    band_rect.p.y = my;
    band_rect.q.y = my + lines_rasterized;
    code = dev_proc(bdev, get_bits_rectangle)
	(bdev, &amp;band_rect, params, unread);
    cdev-&gt;buf_procs.destroy_buf_device(bdev);
    if (code &lt; 0 || lines_rasterized == line_count)
	return code;
    /*
     * We'll have to return the rectangle in pieces.  Force GB_RETURN_COPY
     * rather than GB_RETURN_POINTER, and require all subsequent pieces to
     * use the same values as the first piece for all of the other format
     * options.  If copying isn't allowed, or if there are any unread
     * rectangles, punt.
     */
    if (!(options &amp; GB_RETURN_COPY) || code &gt; 0)
	return gx_default_get_bits_rectangle(dev, prect, params, unread);
    options = params-&gt;options;
    if (!(options &amp; GB_RETURN_COPY)) {
	/* Redo the first piece with copying. */
	params-&gt;options = options =
	    (params-&gt;options &amp; ~GB_RETURN_ALL) | GB_RETURN_COPY;
	lines_rasterized = 0;
    }
    {
	gs_get_bits_params_t band_params;
	uint raster = gx_device_raster(bdev, true);

	code = gdev_create_buf_device(cdev-&gt;buf_procs.create_buf_device,
				      &amp;bdev, cdev-&gt;target, &amp;render_plane,
				      dev-&gt;memory, true);
	if (code &lt; 0)
	    return code;
	band_params = *params;
	while ((y += lines_rasterized) &lt; end_y) {
	    int i;

	    /* Increment data pointers by lines_rasterized. */
	    for (i = 0; i &lt; num_planes; ++i)
		if (band_params.data[i])
		    band_params.data[i] += raster * lines_rasterized;
	    line_count = end_y - y;
	    code = clist_rasterize_lines(dev, y, line_count, bdev,
					 &amp;render_plane, &amp;my);
	    if (code &lt; 0)
		break;
	    lines_rasterized = min(code, line_count);
	    band_rect.p.y = my;
	    band_rect.q.y = my + lines_rasterized;
	    code = dev_proc(bdev, get_bits_rectangle)
		(bdev, &amp;band_rect, &amp;band_params, unread);
	    if (code &lt; 0)
		break;
	    params-&gt;options = options = band_params.options;
	    if (lines_rasterized == line_count)
		break;
	}
	cdev-&gt;buf_procs.destroy_buf_device(bdev);
    }
    return code;
}

/* Copy scan lines to the client.  This is where rendering gets done. */
/* Processes min(requested # lines, # lines available thru end of band) */
private int	/* returns -ve error code, or # scan lines copied */
clist_rasterize_lines(gx_device *dev, int y, int line_count,
		      gx_device *bdev, const gx_render_plane_t *render_plane,
		      int *pmy)
{
    gx_device_clist * const cdev = (gx_device_clist *)dev;
    gx_device_clist_reader * const crdev = &amp;cdev-&gt;reader;
    gx_device *target = crdev-&gt;target;
    uint raster = clist_plane_raster(target, render_plane);
    byte *mdata = crdev-&gt;data + crdev-&gt;page_tile_cache_size;
    int plane_index = (render_plane ? render_plane-&gt;index : -1);
    int code;

    /* Render a band if necessary, and copy it incrementally. */
    if (crdev-&gt;ymin &lt; 0 || crdev-&gt;yplane.index != plane_index ||
	!(y &gt;= crdev-&gt;ymin &amp;&amp; y &lt; crdev-&gt;ymax)
	) {
	int band_height = crdev-&gt;page_band_height;
	int band = y / band_height;
	int band_begin_line = band * band_height;
	int band_end_line = band_begin_line + band_height;
	int band_num_lines;
	gs_int_rect band_rect;

	if (band_end_line &gt; dev-&gt;height)
	    band_end_line = dev-&gt;height;
	/* Clip line_count to current band */
	if (line_count &gt; band_end_line - y)
	    line_count = band_end_line - y;
	band_num_lines = band_end_line - band_begin_line;

	if (y &lt; 0 || y &gt; dev-&gt;height)
	    return_error(gs_error_rangecheck);
	code = crdev-&gt;buf_procs.setup_buf_device
	    (bdev, mdata, raster, NULL, 0, band_num_lines, band_num_lines);
	band_rect.p.x = 0;
	band_rect.p.y = band_begin_line;
	band_rect.q.x = dev-&gt;width;
	band_rect.q.y = band_end_line;
	if (code &gt;= 0)
	    code = clist_render_rectangle(cdev, &amp;band_rect, bdev, render_plane,
					  true);
	/* Reset the band boundaries now, so that we don't get */
	/* an infinite loop. */
	crdev-&gt;ymin = band_begin_line;
	crdev-&gt;ymax = band_end_line;
	if (code &lt; 0)
	    return code;
    }

    if (line_count &gt; crdev-&gt;ymax - y)
	line_count = crdev-&gt;ymax - y;
    code = crdev-&gt;buf_procs.setup_buf_device
	(bdev, mdata, raster, NULL, y - crdev-&gt;ymin, line_count,
	 crdev-&gt;ymax - crdev-&gt;ymin);
    if (code &lt; 0)
	return code;

    *pmy = 0;
    return line_count;
}

/* Initialize for reading. */
private int
clist_render_init(gx_device_clist *dev)
{
    gx_device_clist_reader * const crdev = &amp;dev-&gt;reader;

    crdev-&gt;ymin = crdev-&gt;ymax = 0;
    crdev-&gt;yplane.index = -1;
    /* For normal rasterizing, pages and num_pages are zero. */
    crdev-&gt;pages = 0;
    crdev-&gt;num_pages = 0;
    return 0;
}

/*
 * Render a rectangle to a client-supplied device.  There is no necessary
 * relationship between band boundaries and the region being rendered.
 */
int
clist_render_rectangle(gx_device_clist *cdev, const gs_int_rect *prect,
		       gx_device *bdev,
		       const gx_render_plane_t *render_plane, bool clear)
{
    gx_device_clist_reader * const crdev = &amp;cdev-&gt;reader;
    const gx_placed_page *ppages;
    int num_pages = crdev-&gt;num_pages;
    int band_height = crdev-&gt;page_band_height;
    int band_first = prect-&gt;p.y / band_height;
    int band_last = (prect-&gt;q.y - 1) / band_height;
    gx_saved_page current_page;
    gx_placed_page placed_page;
    int code = 0;
    int i;

    /* Initialize for rendering if we haven't done so yet. */
    if (crdev-&gt;ymin &lt; 0) {
	code = clist_end_page(&amp;cdev-&gt;writer);
	if (code &lt; 0)
	    return code;
	code = clist_render_init(cdev);
	if (code &lt; 0)
	    return code;
    }
    if (render_plane)
	crdev-&gt;yplane = *render_plane;
    else
	crdev-&gt;yplane.index = -1;
    if_debug2('l', "[l]rendering bands (%d,%d)\n", band_first, band_last);
    if (clear)
	dev_proc(bdev, fill_rectangle)
	    (bdev, 0, 0, bdev-&gt;width, bdev-&gt;height, gx_device_white(bdev));

    /*
     * If we aren't rendering saved pages, do the current one.
     * Note that this is the only case in which we may encounter
     * a gx_saved_page with non-zero cfile or bfile.
     */
    ppages = crdev-&gt;pages;
    if (ppages == 0) {
	current_page.info = crdev-&gt;page_info;
	placed_page.page = &amp;current_page;
	placed_page.offset.x = placed_page.offset.y = 0;
	ppages = &amp;placed_page;
	num_pages = 1;
    }
    for (i = 0; i &lt; num_pages &amp;&amp; code &gt;= 0; ++i) {
	const gx_placed_page *ppage = &amp;ppages[i];

	code = clist_playback_file_bands(playback_action_render,
					 crdev, &amp;ppage-&gt;page-&gt;info,
					 bdev, band_first, band_last,
					 prect-&gt;p.x - ppage-&gt;offset.x,
					 prect-&gt;p.y);
    }
    return code;
}

/* Playback the band file, taking the indicated action w/ its contents. */
private int
clist_playback_file_bands(clist_playback_action action, 
			  gx_device_clist_reader *cdev,
			  gx_band_page_info_t *page_info, gx_device *target,
			  int band_first, int band_last, int x0, int y0)
{
    int code = 0;
    bool opened_bfile = false;
    bool opened_cfile = false;

    /* We have to pick some allocator for rendering.... */
    gs_memory_t *mem =cdev-&gt;memory;
 
    stream_band_read_state rs;

    /* setup stream */
    s_init_state((stream_state *)&amp;rs, &amp;s_band_read_template,
		 (gs_memory_t *)0);
    rs.band_first = band_first;
    rs.band_last = band_last;
    rs.page_info = *page_info;

    /* If this is a saved page, open the files. */
    if (rs.page_cfile == 0) {
	code = clist_fopen(rs.page_cfname,
			   gp_fmode_rb, &amp;rs.page_cfile, cdev-&gt;bandlist_memory,
			   cdev-&gt;bandlist_memory, true);
	opened_cfile = (code &gt;= 0);
    }
    if (rs.page_bfile == 0 &amp;&amp; code &gt;= 0) {
	code = clist_fopen(rs.page_bfname,
			   gp_fmode_rb, &amp;rs.page_bfile, cdev-&gt;bandlist_memory,
			   cdev-&gt;bandlist_memory, false);
	opened_bfile = (code &gt;= 0);
    }
    if (rs.page_cfile != 0 &amp;&amp; rs.page_bfile != 0) {
	stream s;
	byte sbuf[cbuf_size];
	static const stream_procs no_procs = {
	    s_std_noavailable, s_std_noseek, s_std_read_reset,
	    s_std_read_flush, s_std_close, s_band_read_process
	};

	s_band_read_init((stream_state *)&amp;rs);
	  /* The stream doesn't need a memory, but we'll need to access s.memory-&gt;gs_lib_ctx. */
	s_init(&amp;s, mem);
	s_std_init(&amp;s, sbuf, cbuf_size, &amp;no_procs, s_mode_read);
	s.foreign = 1;
	s.state = (stream_state *)&amp;rs;
	code = clist_playback_band(action, cdev, &amp;s, target, x0, y0, mem);
    }

    /* Close the files if we just opened them. */
    if (opened_bfile &amp;&amp; rs.page_bfile != 0)
	clist_fclose(rs.page_bfile, rs.page_bfname, false);
    if (opened_cfile &amp;&amp; rs.page_cfile != 0)
	clist_fclose(rs.page_cfile, rs.page_cfname, false);

    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

