<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxfill.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxfill.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989-2003 artofcode LLC.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxfill.c,v 1.122 2005/08/22 14:29:18 igor Exp $ */
/* A topological spot decomposition algorithm with dropout prevention. */
/* 
   This is a dramaticly reorganized and improved revision of the 
   filling algorithm, iwhich was nitially coded by Henry Stiles. 
   The main improvements are: 
	1. A dropout prevention for character fill.
	2. The spot topology analysys support
	   for True Type grid fitting.
	3. Fixed the contiguty of a spot covering 
	   for shading fills with no dropouts.
*/
/* See PSEUDO_RASTERISATION and "pseudo_rasterization".
   about the dropout previntion logics. */
/* See is_spotan about the spot topology analyzis support. */
/* Also defining lower-level path filling procedures */

#include "gx.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gxfixed.h"
#include "gxdevice.h"
#include "gzpath.h"
#include "gzcpath.h"
#include "gxdcolor.h"
#include "gxhttile.h"
#include "gxistate.h"
#include "gxpaint.h"		/* for prototypes */
#include "gxfdrop.h"
#include "gxfill.h"
#include "gsptype2.h"
#include "gdevddrw.h"
#include "gzspotan.h" /* Only for gx_san_trap_store. */
#include "memory_.h"
#include "stdint_.h"
#include "vdtrace.h"
/*
#include "gxfilltr.h" - Do not remove this comment. "gxfilltr.h" is included below.
#include "gxfillsl.h" - Do not remove this comment. "gxfillsl.h" is included below.
#include "gxfillts.h" - Do not remove this comment. "gxfillts.h" is included below.
*/

#ifdef DEBUG
/* Define the statistics structure instance. */
stats_fill_t stats_fill;
#endif

/* A predicate for spot insideness. */
/* rule = -1 for winding number rule, i.e. */
/* we are inside if the winding number is non-zero; */
/* rule = 1 for even-odd rule, i.e. */
/* we are inside if the winding number is odd. */
#define INSIDE_PATH_P(inside, rule) ((inside &amp; rule) != 0)


/* ---------------- Active line management ---------------- */


/*
 * Define the ordering criterion for active lines that overlap in Y.
 * Return -1, 0, or 1 if lp1 precedes, coincides with, or follows lp2.
 *
 * The lines' x_current values are correct for some Y value that crosses
 * both of them and that is not both the start of one and the end of the
 * other.  (Neither line is horizontal.)  We want the ordering at this
 * Y value, or, of the x_current values are equal, greater Y values
 * (if any: this Y value might be the end of both lines).
 */
private int
x_order(const active_line *lp1, const active_line *lp2)
{
    bool s1;

    INCR(order);
    if (lp1-&gt;x_current &lt; lp2-&gt;x_current)
	return -1;
    else if (lp1-&gt;x_current &gt; lp2-&gt;x_current)
	return 1;
    /*
     * We need to compare the slopes of the lines.  Start by
     * checking one fast case, where the slopes have opposite signs.
     */
    if ((s1 = lp1-&gt;start.x &lt; lp1-&gt;end.x) != (lp2-&gt;start.x &lt; lp2-&gt;end.x))
	return (s1 ? 1 : -1);
    /*
     * We really do have to compare the slopes.  Fortunately, this isn't
     * needed very often.  We want the sign of the comparison
     * dx1/dy1 - dx2/dy2, or (since we know dy1 and dy2 are positive)
     * dx1 * dy2 - dx2 * dy1.  In principle, we can't simply do this using
     * doubles, since we need complete accuracy and doubles don't have
     * enough fraction bits.  However, with the usual 20+12-bit fixeds and
     * 64-bit doubles, both of the factors would have to exceed 2^15
     * device space pixels for the result to be inaccurate, so we
     * simply disregard this possibility.  ****** FIX SOMEDAY ******
     */
    INCR(slow_order);
    {
	fixed dx1 = lp1-&gt;end.x - lp1-&gt;start.x,
	    dy1 = lp1-&gt;end.y - lp1-&gt;start.y;
	fixed dx2 = lp2-&gt;end.x - lp2-&gt;start.x,
	    dy2 = lp2-&gt;end.y - lp2-&gt;start.y;
	double diff = (double)dx1 * dy2 - (double)dx2 * dy1;

	return (diff &lt; 0 ? -1 : diff &gt; 0 ? 1 : 0);
    }
}

/*
 * The active_line structure isn't really simple, but since its instances
 * only exist temporarily during a fill operation, we don't have to
 * worry about a garbage collection occurring.
 */
gs_private_st_simple(st_active_line, active_line, "active_line");

#ifdef DEBUG
/* Internal procedures for printing and checking active lines. */
private void
print_active_line(const char *label, const active_line * alp)
{
    dlprintf5("[f]%s 0x%lx(%d): x_current=%f x_next=%f\n",
	      label, (ulong) alp, alp-&gt;direction,
	      fixed2float(alp-&gt;x_current), fixed2float(alp-&gt;x_next));
    dlprintf5("    start=(%f,%f) pt_end=0x%lx(%f,%f)\n",
	      fixed2float(alp-&gt;start.x), fixed2float(alp-&gt;start.y),
	      (ulong) alp-&gt;pseg,
	      fixed2float(alp-&gt;end.x), fixed2float(alp-&gt;end.y));
    dlprintf2("    prev=0x%lx next=0x%lx\n",
	      (ulong) alp-&gt;prev, (ulong) alp-&gt;next);
}
private void
print_line_list(const active_line * flp)
{
    const active_line *lp;

    for (lp = flp; lp != 0; lp = lp-&gt;next) {
	fixed xc = lp-&gt;x_current, xn = lp-&gt;x_next;

	dlprintf3("[f]0x%lx(%d): x_current/next=%g",
		  (ulong) lp, lp-&gt;direction,
		  fixed2float(xc));
	if (xn != xc)
	    dprintf1("/%g", fixed2float(xn));
	dputc('\n');
    }
}
inline private void
print_al(const char *label, const active_line * alp)
{
    if (gs_debug_c('F'))
	print_active_line(label, alp);
}
#else
#define print_al(label,alp) DO_NOTHING
#endif

private inline bool
is_spotan_device(gx_device * dev)
{
    return dev-&gt;memory != NULL &amp;&amp; 
	    gs_object_type(dev-&gt;memory, dev) == &amp;st_device_spot_analyzer;
}

/* Forward declarations */
private void free_line_list(line_list *);
private int add_y_list(gx_path *, line_list *);
private int add_y_line_aux(const segment * prev_lp, const segment * lp, 
	    const gs_fixed_point *curr, const gs_fixed_point *prev, int dir, line_list *ll);
private void insert_x_new(active_line *, line_list *);
private bool end_x_line(active_line *, const line_list *, bool);
private void step_al(active_line *alp, bool move_iterator);


#define FILL_LOOP_PROC(proc) int proc(line_list *, fixed band_mask)
private FILL_LOOP_PROC(spot_into_scan_lines);
private FILL_LOOP_PROC(spot_into_trapezoids);

/*
 * This is the general path filling algorithm.
 * It uses the center-of-pixel rule for filling
 * (except for pseudo_rasterization - see below).
 * We can implement Microsoft's upper-left-corner-of-pixel rule
 * by subtracting (0.5, 0.5) from all the coordinates in the path.
 *
 * The adjust parameters are a hack for keeping regions
 * from coming out too faint: they specify an amount by which to expand
 * the sides of every filled region.
 * Setting adjust = fixed_half is supposed to produce the effect of Adobe's
 * any-part-of-pixel rule, but it doesn't quite, because of the
 * closed/open interval rule for regions.  We detect this as a special case
 * and do the slightly ugly things necessary to make it work.
 */

/* Initialize the line list for a path. */
private inline void
init_line_list(line_list *ll, gs_memory_t * mem)
{
    ll-&gt;memory = mem;
    ll-&gt;active_area = 0;
    ll-&gt;next_active = ll-&gt;local_active;
    ll-&gt;limit = ll-&gt;next_active + MAX_LOCAL_ACTIVE;
    ll-&gt;close_count = 0;
    ll-&gt;y_list = 0;
    ll-&gt;y_line = 0;
    ll-&gt;h_list0 = ll-&gt;h_list1 = 0;
    ll-&gt;margin_set0.margin_list = ll-&gt;margin_set1.margin_list = 0;
    ll-&gt;margin_set0.margin_touched = ll-&gt;margin_set1.margin_touched = 0;
    ll-&gt;margin_set0.y = ll-&gt;margin_set1.y = 0; /* A stub against indeterminism. Don't use it. */
    ll-&gt;free_margin_list = 0;
    ll-&gt;local_margin_alloc_count = 0;
    ll-&gt;margin_set0.sect = ll-&gt;local_section0;
    ll-&gt;margin_set1.sect = ll-&gt;local_section1;
    /* Do not initialize ll-&gt;bbox_left, ll-&gt;bbox_width - they were set in advance. */
    INCR(fill);
}


/* Unlink any line_close segments added temporarily. */
private inline void
unclose_path(gx_path * ppath, int count)
{
    subpath *psub;

    for (psub = ppath-&gt;first_subpath; count != 0;
	 psub = (subpath *) psub-&gt;last-&gt;next
	)
	if (psub-&gt;last == (segment *) &amp; psub-&gt;closer) {
	    segment *prev = psub-&gt;closer.prev, *next = psub-&gt;closer.next;

	    prev-&gt;next = next;
	    if (next)
		next-&gt;prev = prev;
	    psub-&gt;last = prev;
	    count--;
	}
}

/*
 * Tweak the fill adjustment if necessary so that (nearly) empty
 * rectangles are guaranteed to produce some output.  This is a hack
 * to work around a bug in the Microsoft Windows PostScript driver,
 * which draws thin lines by filling zero-width rectangles, and in
 * some other drivers that try to fill epsilon-width rectangles.
 */
void
gx_adjust_if_empty(const gs_fixed_rect * pbox, gs_fixed_point * adjust)
{
    /*
     * For extremely large coordinates, the obvious subtractions could
     * overflow.  We can work around this easily by noting that since
     * we know q.{x,y} &gt;= p.{x,y}, the subtraction overflows iff the
     * result is negative.
     */
    const fixed
	  dx = pbox-&gt;q.x - pbox-&gt;p.x, dy = pbox-&gt;q.y - pbox-&gt;p.y;

    if (dx &lt; fixed_half &amp;&amp; dx &gt; 0 &amp;&amp; (dy &gt;= int2fixed(2) || dy &lt; 0)) {
	adjust-&gt;x = arith_rshift_1(fixed_1 + fixed_epsilon - dx);
	if_debug1('f', "[f]thin adjust_x=%g\n",
		  fixed2float(adjust-&gt;x));
    } else if (dy &lt; fixed_half &amp;&amp; dy &gt; 0 &amp;&amp; (dx &gt;= int2fixed(2) || dx &lt; 0)) {
	adjust-&gt;y = arith_rshift_1(fixed_1 + fixed_epsilon - dy);
	if_debug1('f', "[f]thin adjust_y=%g\n",
		  fixed2float(adjust-&gt;y));
    }
}

/*
 * The general fill  path algorithm.
 */
private int
gx_general_fill_path(gx_device * pdev, const gs_imager_state * pis,
		     gx_path * ppath, const gx_fill_params * params,
		 const gx_device_color * pdevc, const gx_clip_path * pcpath)
{
    gs_fixed_point adjust;
    gs_logical_operation_t lop = pis-&gt;log_op;
    gs_fixed_rect ibox, bbox, sbox;
    gx_device_clip cdev;
    gx_device *dev = pdev;
    gx_device *save_dev = dev;
    gx_path ffpath;
    gx_path *pfpath;
    int code;
    int max_fill_band = dev-&gt;max_fill_band;
#define NO_BAND_MASK ((fixed)(-1) &lt;&lt; (sizeof(fixed) * 8 - 1))
    const bool is_character = params-&gt;adjust.x == -1; /* See gxistate.h */
    bool fill_by_trapezoids;
    bool pseudo_rasterization;
    bool big_path = ppath-&gt;subpath_count &gt; 50;
    fill_options fo;
    line_list lst;

    *(const fill_options **)&amp;lst.fo = &amp;fo; /* break 'const'. */
    /*
     * Compute the bounding box before we flatten the path.
     * This can save a lot of time if the path has curves.
     * If the path is neither fully within nor fully outside
     * the quick-check boxes, we could recompute the bounding box
     * and make the checks again after flattening the path,
     * but right now we don't bother.
     */
    gx_path_bbox(ppath, &amp;ibox);
#   define SMALL_CHARACTER 500
    pseudo_rasterization = (is_character &amp;&amp; 
			    !is_spotan_device(dev) &amp;&amp;
			    ibox.q.y - ibox.p.y &lt; SMALL_CHARACTER * fixed_scale &amp;&amp;
			    ibox.q.x - ibox.p.x &lt; SMALL_CHARACTER * fixed_scale);
    if (is_character)
	adjust.x = adjust.y = 0;
    else
	adjust = params-&gt;adjust;
    if (params-&gt;fill_zero_width &amp;&amp; !pseudo_rasterization)
	gx_adjust_if_empty(&amp;ibox, &amp;adjust);
    lst.bbox_left = fixed2int(ibox.p.x - adjust.x - fixed_epsilon);
    lst.bbox_width = fixed2int(fixed_ceiling(ibox.q.x + adjust.x)) - lst.bbox_left;
    if (vd_enabled) {
	fixed x0 = int2fixed(fixed2int(ibox.p.x - adjust.x - fixed_epsilon));
	fixed x1 = int2fixed(fixed2int(ibox.q.x + adjust.x + fixed_scale - fixed_epsilon));
	fixed y0 = int2fixed(fixed2int(ibox.p.y - adjust.y - fixed_epsilon));
	fixed y1 = int2fixed(fixed2int(ibox.q.y + adjust.y + fixed_scale - fixed_epsilon)), k;

	for (k = x0; k &lt;= x1; k += fixed_scale)
	    vd_bar(k, y0, k, y1, 1, RGB(128, 128, 128));
	for (k = y0; k &lt;= y1; k += fixed_scale)
	    vd_bar(x0, k, x1, k, 1, RGB(128, 128, 128));
    }
    /* Check the bounding boxes. */
    if_debug6('f', "[f]adjust=%g,%g bbox=(%g,%g),(%g,%g)\n",
	      fixed2float(adjust.x), fixed2float(adjust.y),
	      fixed2float(ibox.p.x), fixed2float(ibox.p.y),
	      fixed2float(ibox.q.x), fixed2float(ibox.q.y));
    if (pcpath)
	gx_cpath_inner_box(pcpath, &amp;bbox);
    else
	(*dev_proc(dev, get_clipping_box)) (dev, &amp;bbox);
    if (!rect_within(ibox, bbox)) {
	/*
	 * Intersect the path box and the clip bounding box.
	 * If the intersection is empty, this fill is a no-op.
	 */
	if (pcpath)
	    gx_cpath_outer_box(pcpath, &amp;bbox);
	if_debug4('f', "   outer_box=(%g,%g),(%g,%g)\n",
		  fixed2float(bbox.p.x), fixed2float(bbox.p.y),
		  fixed2float(bbox.q.x), fixed2float(bbox.q.y));
	rect_intersect(ibox, bbox);
	if (ibox.p.x - adjust.x &gt;= ibox.q.x + adjust.x ||
	    ibox.p.y - adjust.y &gt;= ibox.q.y + adjust.y
	    ) { 		/* Intersection of boxes is empty! */
	    return 0;
	}
	/*
	 * The path is neither entirely inside the inner clip box
	 * nor entirely outside the outer clip box.
	 * If we had to flatten the path, this is where we would
	 * recompute its bbox and make the tests again,
	 * but we don't bother right now.
	 *
	 * If there is a clipping path, set up a clipping device.
	 */
	if (pcpath) {
	    dev = (gx_device *) &amp; cdev;
	    gx_make_clip_device(&amp;cdev, gx_cpath_list(pcpath));
	    cdev.target = save_dev;
	    cdev.max_fill_band = save_dev-&gt;max_fill_band;
	    (*dev_proc(dev, open_device)) (dev);
	}
    }
    /*
     * Compute the proper adjustment values.
     * To get the effect of the any-part-of-pixel rule,
     * we may have to tweak them slightly.
     * NOTE: We changed the adjust_right/above value from 0.5+epsilon
     * to 0.5 in release 5.01; even though this does the right thing
     * in every case we could imagine, we aren't confident that it's
     * correct.  (The old values were definitely incorrect, since they
     * caused 1-pixel-wide/high objects to color 2 pixels even if
     * they fell exactly on pixel boundaries.)
     */
    if (adjust.x == fixed_half)
	fo.adjust_left = fixed_half - fixed_epsilon,
	    fo.adjust_right = fixed_half /* + fixed_epsilon */ ;	/* see above */
    else
	fo.adjust_left = fo.adjust_right = adjust.x;
    if (adjust.y == fixed_half)
	fo.adjust_below = fixed_half - fixed_epsilon,
	    fo.adjust_above = fixed_half /* + fixed_epsilon */ ;	/* see above */
    else
	fo.adjust_below = fo.adjust_above = adjust.y;
    /* Initialize the active line list. */
    init_line_list(&amp;lst, ppath-&gt;memory);
    sbox.p.x = ibox.p.x - adjust.x;
    sbox.p.y = ibox.p.y - adjust.y;
    sbox.q.x = ibox.q.x + adjust.x;
    sbox.q.y = ibox.q.y + adjust.y;
    fo.pseudo_rasterization = pseudo_rasterization;
    fo.pdevc = pdevc;
    fo.lop = lop;
    fo.fixed_flat = float2fixed(params-&gt;flatness);
    fo.ymin = ibox.p.y;
    fo.ymax = ibox.q.y;
    fo.dev = dev;
    fo.lop = lop;
    fo.pbox = &amp;sbox;
    fo.rule = params-&gt;rule;
    fo.is_spotan = is_spotan_device(dev);
    fo.fill_direct = color_writes_pure(pdevc, lop);
    fo.fill_rect = (fo.fill_direct ? dev_proc(dev, fill_rectangle) : NULL);
    fo.fill_trap = dev_proc(dev, fill_trapezoid);

    /*
     * We have a choice of two different filling algorithms:
     * scan-line-based and trapezoid-based.  They compare as follows:
     *
     *	    Scan    Trap
     *	    ----    ----
     *	     skip   +draw   0-height horizontal lines
     *	     slow   +fast   rectangles
     *	    +fast    slow   curves
     *	    +yes     no     write pixels at most once when adjust != 0
     *
     * Normally we use the scan line algorithm for characters, where curve
     * speed is important, and for non-idempotent RasterOps, where double
     * pixel writing must be avoided, and the trapezoid algorithm otherwise.
     * However, we always use the trapezoid algorithm for rectangles.
     */
    fill_by_trapezoids =
	(pseudo_rasterization || !gx_path_has_curves(ppath) || 
	 params-&gt;flatness &gt;= 1.0 || fo.is_spotan);
    if (fill_by_trapezoids &amp;&amp; !fo.is_spotan &amp;&amp; !lop_is_idempotent(lop)) {
	gs_fixed_rect rbox;

	if (gx_path_is_rectangular(ppath, &amp;rbox)) {
	    int x0 = fixed2int_pixround(rbox.p.x - fo.adjust_left);
	    int y0 = fixed2int_pixround(rbox.p.y - fo.adjust_below);
	    int x1 = fixed2int_pixround(rbox.q.x + fo.adjust_right);
	    int y1 = fixed2int_pixround(rbox.q.y + fo.adjust_above);

	    return gx_fill_rectangle_device_rop(x0, y0, x1 - x0, y1 - y0,
						pdevc, dev, lop);
	}
	if (fo.adjust_left | fo.adjust_right | fo.adjust_below | fo.adjust_above)
	    fill_by_trapezoids = false; /* avoid double writing pixels */
    }
    gx_path_init_local(&amp;ffpath, ppath-&gt;memory);
    if (!big_path &amp;&amp; !gx_path_has_curves(ppath))	/* don't need to flatten */
	pfpath = ppath;
    else if (is_spotan_device(dev))
	pfpath = ppath;
    else if (!big_path &amp;&amp; gx_path__check_curves(ppath, pco_small_curves, fo.fixed_flat))
	pfpath = ppath;
    else {
	code = gx_path_copy_reducing(ppath, &amp;ffpath, fo.fixed_flat, NULL, 
			    pco_small_curves);
	if (code &lt; 0)
	    return code;
	pfpath = &amp;ffpath;
	if (big_path) {
	    code = gx_path_merge_contacting_contours(pfpath);
	    if (code &lt; 0)
		return code;
	}
    }
    fo.fill_by_trapezoids = fill_by_trapezoids;
    if ((code = add_y_list(pfpath, &amp;lst)) &lt; 0)
	goto nope;
    {
	FILL_LOOP_PROC((*fill_loop));

	/* Some short-sighted compilers won't allow a conditional here.... */
	if (fill_by_trapezoids)
	    fill_loop = spot_into_trapezoids;
	else
	    fill_loop = spot_into_scan_lines;
	if (lst.bbox_width &gt; MAX_LOCAL_SECTION &amp;&amp; fo.pseudo_rasterization) {
	    /*
	     * Note that execution pass here only for character size
	     * grater that MAX_LOCAL_SECTION and lesser than 
	     * SMALL_CHARACTER. Therefore with !arch_small_memory
	     * the dynamic allocation only happens for characters 
	     * wider than 100 pixels.
	     */
	    lst.margin_set0.sect = (section *)gs_alloc_struct_array(pdev-&gt;memory, lst.bbox_width * 2, 
						   section, &amp;st_section, "section");
	    if (lst.margin_set0.sect == 0)
		return_error(gs_error_VMerror);
	    lst.margin_set1.sect = lst.margin_set0.sect + lst.bbox_width;
	}
	if (fo.pseudo_rasterization) {
	    init_section(lst.margin_set0.sect, 0, lst.bbox_width);
	    init_section(lst.margin_set1.sect, 0, lst.bbox_width);
	}
	code = (*fill_loop)
	    (&amp;lst, (max_fill_band == 0 ? NO_BAND_MASK : int2fixed(-max_fill_band)));
	if (lst.margin_set0.sect != lst.local_section0 &amp;&amp; 
	    lst.margin_set0.sect != lst.local_section1)
	    gs_free_object(pdev-&gt;memory, min(lst.margin_set0.sect, lst.margin_set1.sect), "section");
    }
  nope:if (lst.close_count != 0)
	unclose_path(pfpath, lst.close_count);
    free_line_list(&amp;lst);
    if (pfpath != ppath)	/* had to flatten */
	gx_path_free(pfpath, "gx_general_fill_path");
#ifdef DEBUG
    if (gs_debug_c('f')) {
	dlputs("[f]  # alloc    up  down horiz step slowx  iter  find  band bstep bfill\n");
	dlprintf5(" %5ld %5ld %5ld %5ld %5ld",
		  stats_fill.fill, stats_fill.fill_alloc,
		  stats_fill.y_up, stats_fill.y_down,
		  stats_fill.horiz);
	dlprintf4(" %5ld %5ld %5ld %5ld",
		  stats_fill.x_step, stats_fill.slow_x,
		  stats_fill.iter, stats_fill.find_y);
	dlprintf3(" %5ld %5ld %5ld\n",
		  stats_fill.band, stats_fill.band_step,
		  stats_fill.band_fill);
	dlputs("[f]    afill slant shall sfill mqcrs order slowo\n");
	dlprintf7("       %5ld %5ld %5ld %5ld %5ld %5ld %5ld\n",
		  stats_fill.afill, stats_fill.slant,
		  stats_fill.slant_shallow, stats_fill.sfill,
		  stats_fill.mq_cross, stats_fill.order,
		  stats_fill.slow_order);
    }
#endif
    return code;
}

/*
 * Fill a path.  This is the default implementation of the driver
 * fill_path procedure.
 */
int
gx_default_fill_path(gx_device * pdev, const gs_imager_state * pis,
		     gx_path * ppath, const gx_fill_params * params,
		 const gx_device_color * pdevc, const gx_clip_path * pcpath)
{
    int code;

    if (gx_dc_is_pattern2_color(pdevc)) {
	/*  Optimization for shading fill :
	    The general path filling algorithm subdivides fill region with 
	    trapezoid or rectangle subregions and then paints each subregion 
	    with given color. If the color is shading, each subregion to be 
	    subdivided into areas of constant color. But with radial 
	    shading each area is a high order polygon, being 
	    subdivided into smaller subregions, so as total number of
	    subregions grows huge. Faster processing is done here by changing 
	    the order of subdivision cycles : we first subdivide the shading into 
	    areas of constant color, then apply the general path filling algorithm 
	    (i.e. subdivide each area into trapezoids or rectangles), using the 
	    filling path as clip mask.
	*/

	gx_clip_path cpath_intersection;
	gx_path path_intersection;

	/*  Shading fill algorithm uses "current path" parameter of the general
	    path filling algorithm as boundary of constant color area,
	    so we need to intersect the filling path with the clip path now,
	    reducing the number of pathes passed to it :
	*/
	gx_path_init_local(&amp;path_intersection, pdev-&gt;memory);
	gx_cpath_init_local_shared(&amp;cpath_intersection, pcpath, pdev-&gt;memory);
	if ((code = gx_cpath_intersect(&amp;cpath_intersection, ppath, params-&gt;rule, (gs_imager_state *)pis)) &gt;= 0)
	    code = gx_cpath_to_path(&amp;cpath_intersection, &amp;path_intersection);

	/* Do fill : */
	if (code &gt;= 0)
	    code = gx_dc_pattern2_fill_path(pdevc, &amp;path_intersection, NULL,  pdev);

	/* Destruct local data and return :*/
	gx_path_free(&amp;path_intersection, "shading_fill_path_intersection");
	gx_cpath_free(&amp;cpath_intersection, "shading_fill_cpath_intersection");
    } else {
	bool got_dc = false;
        vd_save;
	if (vd_allowed('F') || vd_allowed('f')) {
	    if (!vd_enabled) {
		vd_get_dc( (params-&gt;adjust.x | params-&gt;adjust.y)  ? 'F' : 'f');
		got_dc = vd_enabled;
	    }
	    if (vd_enabled) {
		vd_set_shift(0, 100);
		vd_set_scale(VD_SCALE);
		vd_set_origin(0, 0);
		vd_erase(RGB(192, 192, 192));
	    }
	} else
	    vd_disable;
	code = gx_general_fill_path(pdev, pis, ppath, params, pdevc, pcpath);
	if (got_dc)
	    vd_release_dc;
	vd_restore;
    }
    return code;
}

/* Free the line list. */
private void
free_line_list(line_list *ll)
{
    /* Free any individually allocated active_lines. */
    gs_memory_t *mem = ll-&gt;memory;
    active_line *alp;

    while ((alp = ll-&gt;active_area) != 0) {
	active_line *next = alp-&gt;alloc_next;

	gs_free_object(mem, alp, "active line");
	ll-&gt;active_area = next;
    }
    free_all_margins(ll);
}

private inline active_line *
make_al(line_list *ll)
{
    active_line *alp = ll-&gt;next_active;

    if (alp == ll-&gt;limit) {	/* Allocate separately */
	alp = gs_alloc_struct(ll-&gt;memory, active_line,
			      &amp;st_active_line, "active line");
	if (alp == 0)
	    return NULL;
	alp-&gt;alloc_next = ll-&gt;active_area;
	ll-&gt;active_area = alp;
	INCR(fill_alloc);
    } else
	ll-&gt;next_active++;
    return alp;
}

/* Insert the new line in the Y ordering */
private void
insert_y_line(line_list *ll, active_line *alp)
{
    active_line *yp = ll-&gt;y_line;
    active_line *nyp;
    fixed y_start = alp-&gt;start.y;

    vd_bar(alp-&gt;start.x, alp-&gt;start.y, alp-&gt;end.x, alp-&gt;end.y, 0, RGB(255, 0, 0));
    if (yp == 0) {
	alp-&gt;next = alp-&gt;prev = 0;
	ll-&gt;y_list = alp;
    } else if (y_start &gt;= yp-&gt;start.y) {	/* Insert the new line after y_line */
	while (INCR_EXPR(y_up),
	       ((nyp = yp-&gt;next) != NULL &amp;&amp;
		y_start &gt; nyp-&gt;start.y)
	    )
	    yp = nyp;
	alp-&gt;next = nyp;
	alp-&gt;prev = yp;
	yp-&gt;next = alp;
	if (nyp)
	    nyp-&gt;prev = alp;
    } else {		/* Insert the new line before y_line */
	while (INCR_EXPR(y_down),
	       ((nyp = yp-&gt;prev) != NULL &amp;&amp;
		y_start &lt; nyp-&gt;start.y)
	    )
	    yp = nyp;
	alp-&gt;prev = nyp;
	alp-&gt;next = yp;
	yp-&gt;prev = alp;
	if (nyp)
	    nyp-&gt;next = alp;
	else
	    ll-&gt;y_list = alp;
    }
    ll-&gt;y_line = alp;
    vd_bar(alp-&gt;start.x, alp-&gt;start.y, alp-&gt;end.x, alp-&gt;end.y, 1, RGB(0, 255, 0));
    print_al("add ", alp);
}

typedef struct contour_cursor_s {
    segment *prev, *pseg, *pfirst, *plast;
    gx_flattened_iterator *fi;
    bool more_flattened;
    bool first_flattened;
    int dir;
    bool monotonic_y;
    bool monotonic_x;
    bool crossing;
} contour_cursor;

private inline int
compute_dir(const fill_options *fo, fixed y0, fixed y1)
{
    if (max(y0, y1) &lt; fo-&gt;ymin)
	return 2;
    if (min(y0, y1) &gt; fo-&gt;ymax)
	return 2;
    return (y0 &lt; y1 ? DIR_UP : 
	    y0 &gt; y1 ? DIR_DOWN : DIR_HORIZONTAL);
}

private inline int
add_y_curve_part(line_list *ll, segment *s0, segment *s1, int dir, 
    gx_flattened_iterator *fi, bool more1, bool step_back, bool monotonic_x)
{
    active_line *alp = make_al(ll);

    if (alp == NULL)
	return_error(gs_error_VMerror);
    alp-&gt;pseg = (dir == DIR_UP ? s1 : s0);
    alp-&gt;direction = dir;
    alp-&gt;fi = *fi;
    alp-&gt;more_flattened = more1;
    if (dir != DIR_UP &amp;&amp; more1)
	gx_flattened_iterator__switch_to_backscan(&amp;alp-&gt;fi, more1);
    if (step_back) {
	do {
	    alp-&gt;more_flattened = gx_flattened_iterator__prev(&amp;alp-&gt;fi);
	    if (compute_dir(ll-&gt;fo, alp-&gt;fi.ly0, alp-&gt;fi.ly1) != 2)
		break;
	} while (alp-&gt;more_flattened);
    }
    step_al(alp, false);
    alp-&gt;monotonic_y = false;
    alp-&gt;monotonic_x = monotonic_x;
    insert_y_line(ll, alp);
    return 0;
}

private inline int
add_y_line(const segment * prev_lp, const segment * lp, int dir, line_list *ll)
{
    return add_y_line_aux(prev_lp, lp, &amp;lp-&gt;pt, &amp;prev_lp-&gt;pt, dir, ll);
}

private inline int
start_al_pair(line_list *ll, contour_cursor *q, contour_cursor *p)
{
    int code;
    
    if (q-&gt;monotonic_y)
	code = add_y_line(q-&gt;prev, q-&gt;pseg, DIR_DOWN, ll);
    else 
	code = add_y_curve_part(ll, q-&gt;prev, q-&gt;pseg, DIR_DOWN, q-&gt;fi, 
			    !q-&gt;first_flattened, false, q-&gt;monotonic_x);
    if (code &lt; 0) 
	return code;
    if (p-&gt;monotonic_y)
	code = add_y_line(p-&gt;prev, p-&gt;pseg, DIR_UP, ll);
    else
	code = add_y_curve_part(ll, p-&gt;prev, p-&gt;pseg, DIR_UP, p-&gt;fi, 
			    p-&gt;more_flattened, false, p-&gt;monotonic_x);
    return code;
}

/* Start active lines from a minimum of a possibly non-monotonic curve. */
private int
start_al_pair_from_min(line_list *ll, contour_cursor *q)
{
    int dir, code;
    const fill_options * const fo = ll-&gt;fo;

    /* q stands at the first segment, which isn't last. */
    do {
	q-&gt;more_flattened = gx_flattened_iterator__next(q-&gt;fi);
	dir = compute_dir(fo, q-&gt;fi-&gt;ly0, q-&gt;fi-&gt;ly1);
	if (q-&gt;fi-&gt;ly0 &gt; fo-&gt;ymax &amp;&amp; ll-&gt;y_break &gt; q-&gt;fi-&gt;y0)
	    ll-&gt;y_break = q-&gt;fi-&gt;ly0;
	if (q-&gt;fi-&gt;ly1 &gt; fo-&gt;ymax &amp;&amp; ll-&gt;y_break &gt; q-&gt;fi-&gt;ly1)
	    ll-&gt;y_break = q-&gt;fi-&gt;ly1;
	if (dir == DIR_UP &amp;&amp; ll-&gt;main_dir == DIR_DOWN &amp;&amp; q-&gt;fi-&gt;ly0 &gt;= fo-&gt;ymin) {
	    code = add_y_curve_part(ll, q-&gt;prev, q-&gt;pseg, DIR_DOWN, q-&gt;fi, 
			    true, true, q-&gt;monotonic_x);
	    if (code &lt; 0) 
		return code; 
	    code = add_y_curve_part(ll, q-&gt;prev, q-&gt;pseg, DIR_UP, q-&gt;fi, 
			    q-&gt;more_flattened, false, q-&gt;monotonic_x);
	    if (code &lt; 0) 
		return code; 
	} else if (q-&gt;fi-&gt;ly0 &lt; fo-&gt;ymin &amp;&amp; q-&gt;fi-&gt;ly1 &gt;= fo-&gt;ymin) {
	    code = add_y_curve_part(ll, q-&gt;prev, q-&gt;pseg, DIR_UP, q-&gt;fi, 
			    q-&gt;more_flattened, false, q-&gt;monotonic_x);
	    if (code &lt; 0) 
		return code; 
	} else if (q-&gt;fi-&gt;ly0 &gt;= fo-&gt;ymin &amp;&amp; q-&gt;fi-&gt;ly1 &lt; fo-&gt;ymin) {
	    code = add_y_curve_part(ll, q-&gt;prev, q-&gt;pseg, DIR_DOWN, q-&gt;fi, 
			    true, false, q-&gt;monotonic_x);
	    if (code &lt; 0) 
		return code; 
	}
	q-&gt;first_flattened = false;
        q-&gt;dir = dir;
	ll-&gt;main_dir = (dir == DIR_DOWN ? DIR_DOWN : 
			dir == DIR_UP ? DIR_UP : ll-&gt;main_dir);
	if (!q-&gt;more_flattened)
	    break;
    } while(q-&gt;more_flattened);
    /* q stands at the last segment. */
    return 0;
    /* note : it doesn't depend on the number of curve minimums,
       which may vary due to arithmetic errors. */
}

private inline void
init_contour_cursor(line_list *ll, contour_cursor *q) 
{
    const fill_options * const fo = ll-&gt;fo;

    if (q-&gt;pseg-&gt;type == s_curve) {
	curve_segment *s = (curve_segment *)q-&gt;pseg;
	fixed ymin = min(min(q-&gt;prev-&gt;pt.y, s-&gt;p1.y), min(s-&gt;p2.y, s-&gt;pt.y));
	fixed ymax = max(max(q-&gt;prev-&gt;pt.y, s-&gt;p1.y), max(s-&gt;p2.y, s-&gt;pt.y));
	bool in_band = ymin &lt;= fo-&gt;ymax &amp;&amp; ymax &gt;= fo-&gt;ymin;
	q-&gt;crossing = ymin &lt; fo-&gt;ymin &amp;&amp; ymax &gt;= fo-&gt;ymin;
	q-&gt;monotonic_y = !in_band ||
	    (!q-&gt;crossing &amp;&amp;
	    ((q-&gt;prev-&gt;pt.y &lt;= s-&gt;p1.y &amp;&amp; s-&gt;p1.y &lt;= s-&gt;p2.y &amp;&amp; s-&gt;p2.y &lt;= s-&gt;pt.y) ||
	     (q-&gt;prev-&gt;pt.y &gt;= s-&gt;p1.y &amp;&amp; s-&gt;p1.y &gt;= s-&gt;p2.y &amp;&amp; s-&gt;p2.y &gt;= s-&gt;pt.y)));
	q-&gt;monotonic_x = 
	    ((q-&gt;prev-&gt;pt.x &lt;= s-&gt;p1.x &amp;&amp; s-&gt;p1.x &lt;= s-&gt;p2.x &amp;&amp; s-&gt;p2.x &lt;= s-&gt;pt.x) ||
	     (q-&gt;prev-&gt;pt.x &gt;= s-&gt;p1.x &amp;&amp; s-&gt;p1.x &gt;= s-&gt;p2.x &amp;&amp; s-&gt;p2.x &gt;= s-&gt;pt.x));
    } else 
	q-&gt;monotonic_y = true;
    if (!q-&gt;monotonic_y) {
	curve_segment *s = (curve_segment *)q-&gt;pseg;
	int k = gx_curve_log2_samples(q-&gt;prev-&gt;pt.x, q-&gt;prev-&gt;pt.y, s, fo-&gt;fixed_flat);

	gx_flattened_iterator__init(q-&gt;fi, q-&gt;prev-&gt;pt.x, q-&gt;prev-&gt;pt.y, s, k);
    } else {
	q-&gt;dir = compute_dir(fo, q-&gt;prev-&gt;pt.y, q-&gt;pseg-&gt;pt.y);
	gx_flattened_iterator__init_line(q-&gt;fi, 
	    q-&gt;prev-&gt;pt.x, q-&gt;prev-&gt;pt.y, q-&gt;pseg-&gt;pt.x, q-&gt;pseg-&gt;pt.y); /* fake for curves. */
	vd_bar(q-&gt;prev-&gt;pt.x, q-&gt;prev-&gt;pt.y, q-&gt;pseg-&gt;pt.x, q-&gt;pseg-&gt;pt.y, 1, RGB(0, 0, 255));
    }
    q-&gt;first_flattened = true;
}

private int
scan_contour(line_list *ll, contour_cursor *q)
{
    contour_cursor p;
    gx_flattened_iterator fi, save_fi;
    segment *pseg;
    int code;
    bool only_horizontal = true, saved = false;
    const fill_options * const fo = ll-&gt;fo;
    contour_cursor save_q;

    p.fi = &amp;fi;
    save_q.dir = 2;
    ll-&gt;main_dir = DIR_HORIZONTAL;
    for (; ; q-&gt;pseg = q-&gt;prev, q-&gt;prev = q-&gt;prev-&gt;prev) {
	init_contour_cursor(ll, q);
	while(gx_flattened_iterator__next(q-&gt;fi)) {
	    q-&gt;first_flattened = false;
	    q-&gt;dir = compute_dir(fo, q-&gt;fi-&gt;ly0, q-&gt;fi-&gt;ly1);
	    ll-&gt;main_dir = (q-&gt;dir == DIR_DOWN ? DIR_DOWN : 
			    q-&gt;dir == DIR_UP ? DIR_UP : ll-&gt;main_dir);
	}
	q-&gt;dir = compute_dir(fo, q-&gt;fi-&gt;ly0, q-&gt;fi-&gt;ly1);
	q-&gt;more_flattened = false;
	ll-&gt;main_dir = (q-&gt;dir == DIR_DOWN ? DIR_DOWN : 
			q-&gt;dir == DIR_UP ? DIR_UP : ll-&gt;main_dir);
	if (ll-&gt;main_dir != DIR_HORIZONTAL) {
	    only_horizontal = false;
	    break;
	}
	if (!saved &amp;&amp; q-&gt;dir != 2) {
	    save_q = *q;
	    save_fi = *q-&gt;fi;
	    saved = true;
	}
	if (q-&gt;prev == q-&gt;pfirst)
	    break;
    }
    if (saved) {
	*q = save_q;
	*q-&gt;fi = save_fi;
    }
    for (pseg = q-&gt;pfirst; pseg != q-&gt;plast; pseg = pseg-&gt;next) {
	p.prev = pseg;
	p.pseg = pseg-&gt;next;
	if (!fo-&gt;pseudo_rasterization || only_horizontal
		|| p.prev-&gt;pt.x != p.pseg-&gt;pt.x || p.prev-&gt;pt.y != p.pseg-&gt;pt.y 
		|| p.pseg-&gt;type == s_curve) {
	    init_contour_cursor(ll, &amp;p);
	    p.more_flattened = gx_flattened_iterator__next(p.fi);
	    p.dir = compute_dir(fo, p.fi-&gt;ly0, p.fi-&gt;ly1);
	    if (p.fi-&gt;ly0 &gt; fo-&gt;ymax &amp;&amp; ll-&gt;y_break &gt; p.fi-&gt;ly0)
		ll-&gt;y_break = p.fi-&gt;ly0;
	    if (p.fi-&gt;ly1 &gt; fo-&gt;ymax &amp;&amp; ll-&gt;y_break &gt; p.fi-&gt;ly1)
		ll-&gt;y_break = p.fi-&gt;ly1;
	    if (p.monotonic_y &amp;&amp; p.dir == DIR_HORIZONTAL &amp;&amp; 
		    !fo-&gt;pseudo_rasterization &amp;&amp; 
		    fixed2int_pixround(p.pseg-&gt;pt.y - fo-&gt;adjust_below) &lt;
		    fixed2int_pixround(p.pseg-&gt;pt.y + fo-&gt;adjust_above)) {
		/* Add it here to avoid double processing in process_h_segments. */
		code = add_y_line(p.prev, p.pseg, DIR_HORIZONTAL, ll);
		if (code &lt; 0)
		    return code;
	    }
	    if (p.monotonic_y &amp;&amp; p.dir == DIR_HORIZONTAL &amp;&amp; 
		    fo-&gt;pseudo_rasterization &amp;&amp; only_horizontal) {
		/* Add it here to avoid double processing in process_h_segments. */
		code = add_y_line(p.prev, p.pseg, DIR_HORIZONTAL, ll);
		if (code &lt; 0)
		    return code;
	    } 
	    if (p.fi-&gt;ly0 &gt;= fo-&gt;ymin &amp;&amp; p.dir == DIR_UP &amp;&amp; ll-&gt;main_dir == DIR_DOWN) {
		code = start_al_pair(ll, q, &amp;p);
		if (code &lt; 0)
		    return code;
	    }
	    if (p.fi-&gt;ly0 &lt; fo-&gt;ymin &amp;&amp; p.fi-&gt;ly1 &gt;= fo-&gt;ymin) {
		if (p.monotonic_y)
		    code = add_y_line(p.prev, p.pseg, DIR_UP, ll);
		else
		    code = add_y_curve_part(ll, p.prev, p.pseg, DIR_UP, p.fi, 
					p.more_flattened, false, p.monotonic_x);
		if (code &lt; 0)
		    return code;
	    }	    
	    if (p.fi-&gt;ly0 &gt;= fo-&gt;ymin &amp;&amp; p.fi-&gt;ly1 &lt; fo-&gt;ymin) {
		if (p.monotonic_y)
		    code = add_y_line(p.prev, p.pseg, DIR_DOWN, ll);
		else
		    code = add_y_curve_part(ll, p.prev, p.pseg, DIR_DOWN, p.fi, 
					!p.first_flattened, false, p.monotonic_x);
		if (code &lt; 0)
		    return code;
	    }	    
	    ll-&gt;main_dir = (p.dir == DIR_DOWN ? DIR_DOWN : 
			    p.dir == DIR_UP ? DIR_UP : ll-&gt;main_dir);
	    if (!p.monotonic_y &amp;&amp; p.more_flattened) {
		code = start_al_pair_from_min(ll, &amp;p);
		if (code &lt; 0)
		    return code;
	    }
	    if (p.dir == DIR_DOWN || p.dir == DIR_HORIZONTAL) {
		gx_flattened_iterator *fi1 = q-&gt;fi;
		q-&gt;prev = p.prev;
		q-&gt;pseg = p.pseg;
		q-&gt;monotonic_y = p.monotonic_y;
		q-&gt;more_flattened = p.more_flattened;
		q-&gt;first_flattened = p.first_flattened;
		q-&gt;fi = p.fi;
		q-&gt;dir = p.dir;
		p.fi = fi1;
	    } 
	}
    }
    q-&gt;fi = NULL; /* safety. */
    return 0;
}

/*
 * Construct a Y-sorted list of segments for rasterizing a path.  We assume
 * the path is non-empty.  Only include non-horizontal lines or (monotonic)
 * curve segments where one endpoint is locally Y-minimal, and horizontal
 * lines that might color some additional pixels.
 */
private int
add_y_list(gx_path * ppath, line_list *ll)
{
    subpath *psub = ppath-&gt;first_subpath;
    int close_count = 0;
    int code;
    contour_cursor q;
    gx_flattened_iterator fi;

    ll-&gt;y_break = max_fixed;

    for (;psub; psub = (subpath *)psub-&gt;last-&gt;next) {
	/* We know that pseg points to a subpath head (s_start). */
	segment *pfirst = (segment *)psub;
	segment *plast = psub-&gt;last, *prev;

	q.fi = &amp;fi;
	if (plast-&gt;type != s_line_close) {
	    /* Create a fake s_line_close */
	    line_close_segment *lp = &amp;psub-&gt;closer;
	    segment *next = plast-&gt;next;

	    lp-&gt;next = next;
	    lp-&gt;prev = plast;
	    plast-&gt;next = (segment *) lp;
	    if (next)
		next-&gt;prev = (segment *) lp;
	    lp-&gt;type = s_line_close;
	    lp-&gt;pt = psub-&gt;pt;
	    lp-&gt;sub = psub;
	    psub-&gt;last = plast = (segment *) lp;
	    ll-&gt;close_count++;
	}
	prev = plast-&gt;prev;
	if (ll-&gt;fo-&gt;pseudo_rasterization &amp;&amp; prev != pfirst &amp;&amp;
		prev-&gt;pt.x == plast-&gt;pt.x &amp;&amp; prev-&gt;pt.y == plast-&gt;pt.y) {
	    plast = prev;
	    prev = prev-&gt;prev;
	}
	q.prev = prev;
	q.pseg = plast;
	q.pfirst = pfirst;
	q.plast = plast;
	code = scan_contour(ll, &amp;q);
	if (code &lt; 0)
	    return code;
    }
    return close_count;
}


private void 
step_al(active_line *alp, bool move_iterator)
{
    bool forth = (alp-&gt;direction == DIR_UP || !alp-&gt;fi.curve);

    if (move_iterator) {
	if (forth)
	    alp-&gt;more_flattened = gx_flattened_iterator__next(&amp;alp-&gt;fi);
	else
	    alp-&gt;more_flattened = gx_flattened_iterator__prev(&amp;alp-&gt;fi);
    } else
	vd_bar(alp-&gt;fi.lx0, alp-&gt;fi.ly0, alp-&gt;fi.lx1, alp-&gt;fi.ly1, 1, RGB(0, 0, 255));
    /* Note that we can get alp-&gt;fi.ly0 == alp-&gt;fi.ly1 
       if the curve tangent is horizontal. */
    alp-&gt;start.x = (forth ? alp-&gt;fi.lx0 : alp-&gt;fi.lx1);
    alp-&gt;start.y = (forth ? alp-&gt;fi.ly0 : alp-&gt;fi.ly1);
    alp-&gt;end.x = (forth ? alp-&gt;fi.lx1 : alp-&gt;fi.lx0);
    alp-&gt;end.y = (forth ? alp-&gt;fi.ly1 : alp-&gt;fi.ly0);
    alp-&gt;diff.x = alp-&gt;end.x - alp-&gt;start.x;
    alp-&gt;diff.y = alp-&gt;end.y - alp-&gt;start.y;
    SET_NUM_ADJUST(alp);
    (alp)-&gt;y_fast_max = MAX_MINUS_NUM_ADJUST(alp) /
      ((alp-&gt;diff.x &gt;= 0 ? alp-&gt;diff.x : -alp-&gt;diff.x) | 1) + alp-&gt;start.y;
}

private void
init_al(active_line *alp, const segment *s0, const segment *s1, const line_list *ll)
{
    const segment *ss = (alp-&gt;direction == DIR_UP ? s1 : s0);
    /* Warning : p0 may be equal to &amp;alp-&gt;end. */
    bool curve = (ss != NULL &amp;&amp; ss-&gt;type == s_curve);

    if (curve) {
	if (alp-&gt;direction == DIR_UP) {
	    const curve_segment *cs = (const curve_segment *)s1;
	    int k = gx_curve_log2_samples(s0-&gt;pt.x, s0-&gt;pt.y, cs, ll-&gt;fo-&gt;fixed_flat);

	    gx_flattened_iterator__init(&amp;alp-&gt;fi, 
		s0-&gt;pt.x, s0-&gt;pt.y, (const curve_segment *)s1, k);
	    step_al(alp, true);
	    if (!ll-&gt;fo-&gt;fill_by_trapezoids) {
		alp-&gt;monotonic_y = (s0-&gt;pt.y &lt;= cs-&gt;p1.y &amp;&amp; cs-&gt;p1.y &lt;= cs-&gt;p2.y &amp;&amp; cs-&gt;p2.y &lt;= cs-&gt;pt.y);
		alp-&gt;monotonic_x = (s0-&gt;pt.x &lt;= cs-&gt;p1.x &amp;&amp; cs-&gt;p1.x &lt;= cs-&gt;p2.x &amp;&amp; cs-&gt;p2.x &lt;= cs-&gt;pt.x) ||
				   (s0-&gt;pt.x &gt;= cs-&gt;p1.x &amp;&amp; cs-&gt;p1.x &gt;= cs-&gt;p2.x &amp;&amp; cs-&gt;p2.x &gt;= cs-&gt;pt.x);
	    }
	} else {
	    const curve_segment *cs = (const curve_segment *)s0;
	    int k = gx_curve_log2_samples(s1-&gt;pt.x, s1-&gt;pt.y, cs, ll-&gt;fo-&gt;fixed_flat);
	    bool more;

	    gx_flattened_iterator__init(&amp;alp-&gt;fi, 
		s1-&gt;pt.x, s1-&gt;pt.y, (const curve_segment *)s0, k);
	    alp-&gt;more_flattened = false;
	    do {
		more = gx_flattened_iterator__next(&amp;alp-&gt;fi);
		alp-&gt;more_flattened |= more;
	    } while(more);
	    gx_flattened_iterator__switch_to_backscan(&amp;alp-&gt;fi, alp-&gt;more_flattened);
	    step_al(alp, false);
	    if (!ll-&gt;fo-&gt;fill_by_trapezoids) {
		alp-&gt;monotonic_y = (s0-&gt;pt.y &gt;= cs-&gt;p1.y &amp;&amp; cs-&gt;p1.y &gt;= cs-&gt;p2.y &amp;&amp; cs-&gt;p2.y &gt;= cs-&gt;pt.y);
		alp-&gt;monotonic_x = (s0-&gt;pt.x &lt;= cs-&gt;p1.x &amp;&amp; cs-&gt;p1.x &lt;= cs-&gt;p2.x &amp;&amp; cs-&gt;p2.x &lt;= cs-&gt;pt.x) ||
				   (s0-&gt;pt.x &gt;= cs-&gt;p1.x &amp;&amp; cs-&gt;p1.x &gt;= cs-&gt;p2.x &amp;&amp; cs-&gt;p2.x &gt;= cs-&gt;pt.x);
	    }
	}
    } else {
	gx_flattened_iterator__init_line(&amp;alp-&gt;fi, 
		s0-&gt;pt.x, s0-&gt;pt.y, s1-&gt;pt.x, s1-&gt;pt.y);
	step_al(alp, true);
	alp-&gt;monotonic_x = alp-&gt;monotonic_y = true;
    }
    alp-&gt;pseg = s1;
}
/*
 * Internal routine to test a segment and add it to the pending list if
 * appropriate.
 */
private int
add_y_line_aux(const segment * prev_lp, const segment * lp, 
	    const gs_fixed_point *curr, const gs_fixed_point *prev, int dir, line_list *ll)
{
    active_line *alp = make_al(ll);
    if (alp == NULL)
	return_error(gs_error_VMerror);
    alp-&gt;more_flattened = false;
    switch ((alp-&gt;direction = dir)) {
	case DIR_UP:
	    init_al(alp, prev_lp, lp, ll);
	    break;
	case DIR_DOWN:
	    init_al(alp, lp, prev_lp, ll);
	    break;
	case DIR_HORIZONTAL:
	    alp-&gt;start = *prev;
	    alp-&gt;end = *curr;
	    /* Don't need to set dx or y_fast_max */
	    alp-&gt;pseg = prev_lp;	/* may not need this either */
	    break;
	default:		/* can't happen */
	    return_error(gs_error_unregistered);
    }
    insert_y_line(ll, alp);
    return 0;
}


/* ---------------- Filling loop utilities ---------------- */

/* Insert a newly active line in the X ordering. */
private void
insert_x_new(active_line * alp, line_list *ll)
{
    active_line *next;
    active_line *prev = &amp;ll-&gt;x_head;

    vd_bar(alp-&gt;start.x, alp-&gt;start.y, alp-&gt;end.x, alp-&gt;end.y, 1, RGB(128, 128, 0));
    alp-&gt;x_current = alp-&gt;start.x;
    alp-&gt;x_next = alp-&gt;start.x; /*	If the spot starts with a horizontal segment,
				    we need resort_x_line to work properly
				    in the very beginning. */
    while (INCR_EXPR(x_step),
	   (next = prev-&gt;next) != 0 &amp;&amp; x_order(next, alp) &lt; 0
	)
	prev = next;
    alp-&gt;next = next;
    alp-&gt;prev = prev;
    if (next != 0)
	next-&gt;prev = alp;
    prev-&gt;next = alp;
}

/* Insert a newly active line in the h list. */
/* h list isn't ordered because x intervals may overlap. */
/* todo : optimize with maintaining ordered interval list;
   Unite contacting inrevals, like we did in add_margin.
 */
private inline void
insert_h_new(active_line * alp, line_list *ll)
{
    alp-&gt;next = ll-&gt;h_list0;
    alp-&gt;prev = 0;
    if (ll-&gt;h_list0 != 0)
	ll-&gt;h_list0-&gt;prev = alp;
    ll-&gt;h_list0 = alp;
    /*
     * h list keeps horizontal lines for a given y.
     * There are 2 lists, corresponding to upper and lower ends 
     * of the Y-interval, which spot_into_trapezoids currently proceeds.
     * Parts of horizontal lines, which do not contact a filled trapezoid,
     * are parts of the spot bondairy. They to be marked in
     * the 'sect' array.  - see process_h_lists.
     */
}

private inline void
remove_al(const line_list *ll, active_line *alp)
{
    active_line *nlp = alp-&gt;next;

    alp-&gt;prev-&gt;next = nlp;
    if (nlp)
	nlp-&gt;prev = alp-&gt;prev;
    if_debug1('F', "[F]drop 0x%lx\n", (ulong) alp);
}

/*
 * Handle a line segment that just ended.  Return true iff this was
 * the end of a line sequence.
 */
private bool
end_x_line(active_line *alp, const line_list *ll, bool update)
{
    const segment *pseg = alp-&gt;pseg;
    /*
     * The computation of next relies on the fact that
     * all subpaths have been closed.  When we cycle
     * around to the other end of a subpath, we must be
     * sure not to process the start/end point twice.
     */
    const segment *next =
	(alp-&gt;direction == DIR_UP ?
	 (			/* Upward line, go forward along path. */
	  pseg-&gt;type == s_line_close ?	/* end of subpath */
	  ((const line_close_segment *)pseg)-&gt;sub-&gt;next :
	  pseg-&gt;next) :
	 (			/* Downward line, go backward along path. */
	  pseg-&gt;type == s_start ?	/* start of subpath */
	  ((const subpath *)pseg)-&gt;last-&gt;prev :
	  pseg-&gt;prev)
	);

    if (alp-&gt;end.y &lt; alp-&gt;start.y) {
	/* fixme: The condition above causes a horizontal
	   part of a curve near an Y maximum to process twice :
	   once scanning the left spot boundary and once scanning the right one.
	   In both cases it will go to the H list.
	   However the dropout prevention logic isn't
	   sensitive to that, and such segments does not affect 
	   trapezoids. Thus the resulting raster doesn't depend on that.
	   However it would be nice to improve someday.
	 */
	remove_al(ll, alp);
	return true;
    } else if (alp-&gt;more_flattened)
	return false;
    init_al(alp, pseg, next, ll);
    if (alp-&gt;start.y &gt; alp-&gt;end.y) {
	/* See comment above. */
	remove_al(ll, alp);
	return true;
    }
    alp-&gt;x_current = alp-&gt;x_next = alp-&gt;start.x;
    vd_bar(alp-&gt;start.x, alp-&gt;start.y, alp-&gt;end.x, alp-&gt;end.y, 1, RGB(128, 0, 128));
    print_al("repl", alp);
    return false;
}

private inline int 
add_margin(line_list * ll, active_line * flp, active_line * alp, fixed y0, fixed y1)
{   vd_bar(alp-&gt;start.x, alp-&gt;start.y, alp-&gt;end.x, alp-&gt;end.y, 1, RGB(255, 255, 255));
    vd_bar(flp-&gt;start.x, flp-&gt;start.y, flp-&gt;end.x, flp-&gt;end.y, 1, RGB(255, 255, 255));
    return continue_margin_common(ll, &amp;ll-&gt;margin_set0, flp, alp, y0, y1);
}

private inline int 
continue_margin(line_list * ll, active_line * flp, active_line * alp, fixed y0, fixed y1)
{   
    return continue_margin_common(ll, &amp;ll-&gt;margin_set0, flp, alp, y0, y1);
}

private inline int 
complete_margin(line_list * ll, active_line * flp, active_line * alp, fixed y0, fixed y1)
{   
    return continue_margin_common(ll, &amp;ll-&gt;margin_set1, flp, alp, y0, y1);
}

/*
 * Handle the case of a slanted trapezoid with adjustment.
 * To do this exactly right requires filling a central trapezoid
 * (or rectangle) plus two horizontal almost-rectangles.
 */
private int
fill_slant_adjust(const line_list *ll, 
	const active_line *flp, const active_line *alp, fixed y, fixed y1)
{
    const fill_options * const fo = ll-&gt;fo;
    const fixed Yb = y - fo-&gt;adjust_below;
    const fixed Ya = y + fo-&gt;adjust_above;
    const fixed Y1b = y1 - fo-&gt;adjust_below;
    const fixed Y1a = y1 + fo-&gt;adjust_above;
    const gs_fixed_edge *plbot, *prbot, *pltop, *prtop;
    gs_fixed_edge vert_left, slant_left, vert_right, slant_right;
    int code;

    INCR(slant);
    vd_quad(flp-&gt;x_current, y, alp-&gt;x_current, y, 
	    alp-&gt;x_next, y1, flp-&gt;x_next, y1, 1, VD_TRAP_COLOR); /* fixme: Wrong X. */

    /* Set up all the edges, even though we may not need them all. */

    if (flp-&gt;start.x &lt; flp-&gt;end.x) {
	vert_left.start.x = vert_left.end.x = flp-&gt;x_current - fo-&gt;adjust_left;
	vert_left.start.y = Yb, vert_left.end.y = Ya;
	vert_right.start.x = vert_right.end.x = alp-&gt;x_next + fo-&gt;adjust_right;
	vert_right.start.y = Y1b, vert_right.end.y = Y1a;
	slant_left.start.y = flp-&gt;start.y + fo-&gt;adjust_above; 
	slant_left.end.y = flp-&gt;end.y + fo-&gt;adjust_above;
	slant_right.start.y = alp-&gt;start.y - fo-&gt;adjust_below; 
	slant_right.end.y = alp-&gt;end.y - fo-&gt;adjust_below;
	plbot = &amp;vert_left, prbot = &amp;slant_right;
	pltop = &amp;slant_left, prtop = &amp;vert_right;
    } else {
	vert_left.start.x = vert_left.end.x = flp-&gt;x_next - fo-&gt;adjust_left;
	vert_left.start.y = Y1b, vert_left.end.y = Y1a;
	vert_right.start.x = vert_right.end.x = alp-&gt;x_current + fo-&gt;adjust_right;
	vert_right.start.y = Yb, vert_right.end.y = Ya;
	slant_left.start.y = flp-&gt;start.y - fo-&gt;adjust_below;
	slant_left.end.y = flp-&gt;end.y - fo-&gt;adjust_below;
	slant_right.start.y = alp-&gt;start.y + fo-&gt;adjust_above;
	slant_right.end.y = alp-&gt;end.y + fo-&gt;adjust_above;
	plbot = &amp;slant_left, prbot = &amp;vert_right;
	pltop = &amp;vert_left, prtop = &amp;slant_right;
    }
    slant_left.start.x = flp-&gt;start.x - fo-&gt;adjust_left; 
    slant_left.end.x = flp-&gt;end.x - fo-&gt;adjust_left;
    slant_right.start.x = alp-&gt;start.x + fo-&gt;adjust_right; 
    slant_right.end.x = alp-&gt;end.x + fo-&gt;adjust_right;

    if (Ya &gt;= Y1b) {
	/*
	 * The upper and lower adjustment bands overlap.
	 * Since the entire entity is less than 2 pixels high
	 * in this case, we could handle it very efficiently
	 * with no more than 2 rectangle fills, but for right now
	 * we don't attempt to do this.
	 */
	int iYb = fixed2int_var_pixround(Yb);
	int iYa = fixed2int_var_pixround(Ya);
	int iY1b = fixed2int_var_pixround(Y1b);
	int iY1a = fixed2int_var_pixround(Y1a);

	INCR(slant_shallow);
	if (iY1b &gt; iYb) {
	    code = fo-&gt;fill_trap(fo-&gt;dev, plbot, prbot,
				 Yb, Y1b, false, fo-&gt;pdevc, fo-&gt;lop);
	    if (code &lt; 0)
		return code;
	}
	if (iYa &gt; iY1b) {
	    int ix = fixed2int_var_pixround(vert_left.start.x);
	    int iw = fixed2int_var_pixround(vert_right.start.x) - ix;

	    code = gx_fill_rectangle_device_rop(ix, iY1b, iw, iYa - iY1b, 
			fo-&gt;pdevc, fo-&gt;dev, fo-&gt;lop);
	    if (code &lt; 0)
		return code;
	}
	if (iY1a &gt; iYa)
	    code = fo-&gt;fill_trap(fo-&gt;dev, pltop, prtop,
				 Ya, Y1a, false, fo-&gt;pdevc, fo-&gt;lop);
	else
	    code = 0;
    } else {
	/*
	 * Clip the trapezoid if possible.  This can save a lot
	 * of work when filling paths that cross band boundaries.
	 */
	fixed Yac;

	if (fo-&gt;pbox-&gt;p.y &lt; Ya) {
	    code = fo-&gt;fill_trap(fo-&gt;dev, plbot, prbot,
				 Yb, Ya, false, fo-&gt;pdevc, fo-&gt;lop);
	    if (code &lt; 0)
		return code;
	    Yac = Ya;
	} else
	    Yac = fo-&gt;pbox-&gt;p.y;
	if (fo-&gt;pbox-&gt;q.y &gt; Y1b) {
	    code = fo-&gt;fill_trap(fo-&gt;dev, &amp;slant_left, &amp;slant_right,
				 Yac, Y1b, false, fo-&gt;pdevc, fo-&gt;lop);
	    if (code &lt; 0)
		return code;
	    code = fo-&gt;fill_trap(fo-&gt;dev, pltop, prtop,
				 Y1b, Y1a, false, fo-&gt;pdevc, fo-&gt;lop);
	} else
	    code = fo-&gt;fill_trap(fo-&gt;dev, &amp;slant_left, &amp;slant_right,
				 Yac, fo-&gt;pbox-&gt;q.y, false, fo-&gt;pdevc, fo-&gt;lop);
    }
    return code;
}

/* Re-sort the x list by moving alp backward to its proper spot. */
private inline void
resort_x_line(active_line * alp)
{
    active_line *prev = alp-&gt;prev;
    active_line *next = alp-&gt;next;

    prev-&gt;next = next;
    if (next)
	next-&gt;prev = prev;
    while (x_order(prev, alp) &gt; 0) {
	if_debug2('F', "[F]swap 0x%lx,0x%lx\n",
		  (ulong) alp, (ulong) prev);
	next = prev, prev = prev-&gt;prev;
    }
    alp-&gt;next = next;
    alp-&gt;prev = prev;
    /* next might be null, if alp was in the correct spot already. */
    if (next)
	next-&gt;prev = alp;
    prev-&gt;next = alp;
}

/* Move active lines by Y. */
private inline void
move_al_by_y(line_list *ll, fixed y1)
{
    fixed x;
    active_line *alp, *nlp;

    for (x = min_fixed, alp = ll-&gt;x_list; alp != 0; alp = nlp) {
	bool notend = false;
	alp-&gt;x_current = alp-&gt;x_next;

	nlp = alp-&gt;next;
	if (alp-&gt;end.y == y1 &amp;&amp; alp-&gt;more_flattened) {
	    step_al(alp, true);
	    alp-&gt;x_current = alp-&gt;x_next = alp-&gt;start.x;
	    notend = (alp-&gt;end.y &gt;= alp-&gt;start.y);
	}
	if (alp-&gt;end.y &gt; y1 || notend || !end_x_line(alp, ll, true)) {
	    if (alp-&gt;x_next &lt;= x)
		resort_x_line(alp);
	    else
		x = alp-&gt;x_next;
	}
    }
    if (ll-&gt;x_list != 0 &amp;&amp; ll-&gt;fo-&gt;pseudo_rasterization) {
	/* Ensure that contacting vertical stems are properly ordered.
	   We don't want to unite contacting stems into
	   a single margin, because it can cause a dropout :
	   narrow stems are widened against a dropout, but 
	   an united wide one may be left unwidened.
	 */
	for (alp = ll-&gt;x_list; alp-&gt;next != 0; ) {
	    if (alp-&gt;start.x == alp-&gt;end.x &amp;&amp;
		alp-&gt;start.x == alp-&gt;next-&gt;start.x &amp;&amp;
		alp-&gt;next-&gt;start.x == alp-&gt;next-&gt;end.x &amp;&amp;
		alp-&gt;direction &gt; alp-&gt;next-&gt;direction) {
		/* Exchange. */
		active_line *prev = alp-&gt;prev;
		active_line *next = alp-&gt;next;
		active_line *next2 = next-&gt;next;
		if (prev)
		    prev-&gt;next = next;
		else
		    ll-&gt;x_list = next;
		next-&gt;prev = prev;
		alp-&gt;prev = next;
		alp-&gt;next = next2;
		next-&gt;next = alp;
		if (next2)
		    next2-&gt;prev = alp;
	    } else
		alp = alp-&gt;next;
	}
    }
}

/* Process horizontal segment of curves. */
private inline int
process_h_segments(line_list *ll, fixed y)
{
    active_line *alp, *nlp;
    int code, inserted = 0;

    for (alp = ll-&gt;x_list; alp != 0; alp = nlp) {
	nlp = alp-&gt;next;
	if (alp-&gt;start.y == y &amp;&amp; alp-&gt;end.y == y) {
	    if (ll-&gt;fo-&gt;pseudo_rasterization) {
		code = add_y_line_aux(NULL, NULL, &amp;alp-&gt;start, &amp;alp-&gt;end, DIR_HORIZONTAL, ll);
		if (code &lt; 0)
		    return code;
	    }
	    inserted = 1;
	}
    }
    return inserted;
    /* After this should call move_al_by_y and step to the next band. */
}

private inline int
loop_fill_trap_np(const line_list *ll, const gs_fixed_edge *le, const gs_fixed_edge *re, fixed y, fixed y1)
{
    const fill_options * const fo = ll-&gt;fo;
    fixed ybot = max(y, fo-&gt;pbox-&gt;p.y);
    fixed ytop = min(y1, fo-&gt;pbox-&gt;q.y);

    if (ybot &gt;= ytop)
	return 0;
    vd_quad(le-&gt;start.x, ybot, re-&gt;start.x, ybot, re-&gt;end.x, ytop, le-&gt;end.x, ytop, 1, VD_TRAP_COLOR);
    return (*fo-&gt;fill_trap)
	(fo-&gt;dev, le, re, ybot, ytop, false, fo-&gt;pdevc, fo-&gt;lop);
}

/* Define variants of the algorithm for filling a slanted trapezoid. */
#define TEMPLATE_slant_into_trapezoids slant_into_trapezoids__fd
#define FILL_DIRECT 1
#include "gxfillts.h"
#undef TEMPLATE_slant_into_trapezoids
#undef FILL_DIRECT

#define TEMPLATE_slant_into_trapezoids slant_into_trapezoids__nd
#define FILL_DIRECT 0
#include "gxfillts.h"
#undef TEMPLATE_slant_into_trapezoids
#undef FILL_DIRECT


#define COVERING_PIXEL_CENTERS(y, y1, adjust_below, adjust_above)\
    (fixed_pixround(y - adjust_below) &lt; fixed_pixround(y1 + adjust_above))

/* Find an intersection within y, y1. */
/* lp-&gt;x_current, lp-&gt;x_next must be set for y, y1. */
private bool
intersect(active_line *endp, active_line *alp, fixed y, fixed y1, fixed *p_y_new)
{
    fixed y_new, dy;
    fixed dx_old = alp-&gt;x_current - endp-&gt;x_current;
    fixed dx_den = dx_old + endp-&gt;x_next - alp-&gt;x_next;
	    
    if (dx_den &lt;= dx_old)
	return false; /* Intersection isn't possible. */
    dy = y1 - y;
    if_debug3('F', "[F]cross: dy=%g, dx_old=%g, dx_new=%g\n",
	      fixed2float(dy), fixed2float(dx_old),
	      fixed2float(dx_den - dx_old));
    /* Do the computation in single precision */
    /* if the values are small enough. */
    y_new =
	((dy | dx_old) &lt; 1L &lt;&lt; (size_of(fixed) * 4 - 1) ?
	 dy * dx_old / dx_den :
	 (INCR_EXPR(mq_cross), fixed_mult_quo(dy, dx_old, dx_den)))
	+ y;
    /* The crossing value doesn't have to be */
    /* very accurate, but it does have to be */
    /* greater than y and less than y1. */
    if_debug3('F', "[F]cross y=%g, y_new=%g, y1=%g\n",
	      fixed2float(y), fixed2float(y_new),
	      fixed2float(y1));
    if (y_new &lt;= y) {
	/*
	 * This isn't possible.  Recompute the intersection
	 * accurately.
	 */
	fixed ys, xs0, xs1, ye, xe0, xe1, dy, dx0, dx1;

	INCR(cross_slow);
	if (endp-&gt;start.y &lt; alp-&gt;start.y)
	    ys = alp-&gt;start.y,
		xs0 = AL_X_AT_Y(endp, ys), xs1 = alp-&gt;start.x;
	else
	    ys = endp-&gt;start.y,
		xs0 = endp-&gt;start.x, xs1 = AL_X_AT_Y(alp, ys);
	if (endp-&gt;end.y &gt; alp-&gt;end.y)
	    ye = alp-&gt;end.y,
		xe0 = AL_X_AT_Y(endp, ye), xe1 = alp-&gt;end.x;
	else
	    ye = endp-&gt;end.y,
		xe0 = endp-&gt;end.x, xe1 = AL_X_AT_Y(alp, ye);
	dy = ye - ys;
	dx0 = xe0 - xs0;
	dx1 = xe1 - xs1;
	/* We need xs0 + cross * dx0 == xs1 + cross * dx1. */
	if (dx0 == dx1) {
	    /* The two lines are coincident.  Do nothing. */
	    y_new = y1;
	} else {
	    double cross = (double)(xs0 - xs1) / (dx1 - dx0);

	    y_new = (fixed)(ys + cross * dy);
	    if (y_new &lt;= y) {
		/*
		 * This can only happen through some kind of
		 * numeric disaster, but we have to check.
		 */
		INCR(cross_low);
		y_new = y + fixed_epsilon;
	    }
	}
    }
    *p_y_new = y_new;
    return true;
}

private inline void
set_x_next(active_line *endp, active_line *alp, fixed x)
{
    while(endp != alp) {
	endp-&gt;x_next = x;
	endp = endp-&gt;next;
    }
}

private inline int
coord_weight(const active_line *alp)
{
    return 1 + min(any_abs((int)((int64_t)alp-&gt;diff.y * 8 / alp-&gt;diff.x)), 256);
}


/* Find intersections of active lines within the band. 
   Intersect and reorder them, and correct the bund top. */
private void
intersect_al(line_list *ll, fixed y, fixed *y_top, int draw, bool all_bands)
{
    fixed x = min_fixed, y1 = *y_top;
    active_line *alp, *stopx = NULL;
    active_line *endp = NULL;

    /* don't bother if no pixels with no pseudo_rasterization */
    if (y == y1) {
	/* Rather the intersection algorithm can handle this case with
	   retrieving x_next equal to x_current, 
	   we bypass it for safety reason.
	 */
    } else if (ll-&gt;fo-&gt;pseudo_rasterization || draw &gt;= 0 || all_bands) {
	/*
	 * Loop invariants:
	 *	alp = endp-&gt;next;
	 *	for all lines lp from stopx up to alp,
	 *	  lp-&gt;x_next = AL_X_AT_Y(lp, y1).
	 */
	for (alp = stopx = ll-&gt;x_list;
	     INCR_EXPR(find_y), alp != 0;
	     endp = alp, alp = alp-&gt;next
	    ) {
	    fixed nx = AL_X_AT_Y(alp, y1);
	    fixed y_new;

	    alp-&gt;x_next = nx;
	    /* Check for intersecting lines. */
	    if (nx &gt;= x)
		x = nx;
	    else if (alp-&gt;x_current &gt;= endp-&gt;x_current &amp;&amp;
		     intersect(endp, alp, y, y1, &amp;y_new)) {
		if (y_new &lt;= y1) {
		    stopx = endp;
		    y1 = y_new;
		    if (endp-&gt;diff.x == 0)
			nx = endp-&gt;start.x;
		    else if (alp-&gt;diff.x == 0)
			nx = alp-&gt;start.x;
		    else {
			fixed nx0 = AL_X_AT_Y(endp, y1);
			fixed nx1 = AL_X_AT_Y(alp, y1);
			if (nx0 != nx1) {
			    /* Different results due to arithmetic errors.
			       Choose an imtermediate point. 
			       We don't like to use floating numbners here,
			       but the code with int64_t isn't much better. */
			    int64_t w0 = coord_weight(endp);
			    int64_t w1 = coord_weight(alp);

			    nx = (fixed)((w0 * nx0 + w1 * nx1) / (w0 + w1));
			} else
			    nx = nx0;
		    }
		    endp-&gt;x_next = alp-&gt;x_next = nx;  /* Ensure same X. */
		    draw = 0;
		    /* Can't guarantee same x for triple intersections here. 
		       Will take care below */
		}
		if (nx &gt; x)
		    x = nx;
	    }
	}
	/* Recompute next_x for lines before the intersection. */
	for (alp = ll-&gt;x_list; alp != stopx; alp = alp-&gt;next)
	    alp-&gt;x_next = AL_X_AT_Y(alp, y1);
	/* Ensure X monotonity (particularly imporoves triple intersections). */
	if (ll-&gt;x_list != NULL) {
	    for (;;) {
		fixed x1;
		double sx = 0xbaadf00d; /* 'fixed' can overflow. We operate 7-bytes integers. */
		int k = 0xbaadf00d, n;

		endp = ll-&gt;x_list;
		x1 = endp-&gt;x_next;
		for (alp = endp-&gt;next; alp != NULL; x1 = alp-&gt;x_next, alp = alp-&gt;next)
		    if (alp-&gt;x_next &lt; x1)
			break;
		if (alp == NULL)
		    break;
		x1 = endp-&gt;x_next;
		n = 0;
		for (alp = endp-&gt;next; alp != NULL; alp = alp-&gt;next) {
		     x = alp-&gt;x_next;
		     if (x &lt; x1) {
			if (n == 0) {
			    if (endp-&gt;diff.x == 0) {
				k = -1;
				sx = x1;
			    } else {
				k = coord_weight(endp);
				sx = (double)x1 * k;
			    }
			    n = 1;
			}
			n++;
			if (alp-&gt;diff.x == 0) {
			    /* Vertical lines have a higher priority. */
			    if (k &lt;= -1) {
				sx += x;
				k--;
			    } else {
				k = -1;
				sx = x;
			    }
			} else if (k &gt; 0) {
			    int w = coord_weight(alp);

			    sx += (double)x * w;
			    k += w;
			}
		     } else {
			if (n &gt; 1) { 
			    k = any_abs(k);
			    set_x_next(endp, alp, (fixed)((sx + k / 2) / k));
			}
			x1 = alp-&gt;x_next;
			n = 0;
			endp = alp;
		     }
		}
		if (n &gt; 1) {
		    k = any_abs(k);
    		    set_x_next(endp, alp, (fixed)((sx + k / 2) / k));
		}
	    }
	}
    } else {
	/* Recompute next_x for lines before the intersection. */
	for (alp = ll-&gt;x_list; alp != stopx; alp = alp-&gt;next)
	    alp-&gt;x_next = AL_X_AT_Y(alp, y1);
    }
#ifdef DEBUG
    if (gs_debug_c('F')) {
	dlprintf1("[F]after loop: y1=%f\n", fixed2float(y1));
	print_line_list(ll-&gt;x_list);
    }
#endif
    *y_top = y1;
}

/* ---------------- Trapezoid filling loop ---------------- */

/* Generate specialized algorythms for the most important cases : */

#define IS_SPOTAN 1
#define PSEUDO_RASTERIZATION 0
#define FILL_ADJUST 0
#define FILL_DIRECT 1
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__spotan
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids

#define IS_SPOTAN 0
#define PSEUDO_RASTERIZATION 1
#define FILL_ADJUST 0
#define FILL_DIRECT 1
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__pr_fd
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids

#define IS_SPOTAN 0
#define PSEUDO_RASTERIZATION 1
#define FILL_ADJUST 0
#define FILL_DIRECT 0
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__pr_nd
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids

#define IS_SPOTAN 0
#define PSEUDO_RASTERIZATION 0
#define FILL_ADJUST 1
#define FILL_DIRECT 1
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__aj_fd
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids

#define IS_SPOTAN 0
#define PSEUDO_RASTERIZATION 0
#define FILL_ADJUST 1
#define FILL_DIRECT 0
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__aj_nd
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids

#define IS_SPOTAN 0
#define PSEUDO_RASTERIZATION 0
#define FILL_ADJUST 0
#define FILL_DIRECT 1
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__nj_fd
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids

#define IS_SPOTAN 0
#define PSEUDO_RASTERIZATION 0
#define FILL_ADJUST 0
#define FILL_DIRECT 0
#define TEMPLATE_spot_into_trapezoids spot_into_trapezoids__nj_nd
#include "gxfilltr.h"
#undef IS_SPOTAN
#undef PSEUDO_RASTERIZATION
#undef FILL_ADJUST
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_trapezoids


/* Main filling loop.  Takes lines off of y_list and adds them to */
/* x_list as needed.  band_mask limits the size of each band, */
/* by requiring that ((y1 - 1) &amp; band_mask) == (y0 &amp; band_mask). */
private int
spot_into_trapezoids(line_list *ll, fixed band_mask)
{
    /* For better porformance, choose a specialized algorithm : */
    const fill_options * const fo = ll-&gt;fo;

    if (fo-&gt;is_spotan)
	return spot_into_trapezoids__spotan(ll, band_mask);
    if (fo-&gt;pseudo_rasterization) {
	if (fo-&gt;fill_direct)
	    return spot_into_trapezoids__pr_fd(ll, band_mask);
	else
	    return spot_into_trapezoids__pr_nd(ll, band_mask);
    }
    if (fo-&gt;adjust_below | fo-&gt;adjust_above | fo-&gt;adjust_left | fo-&gt;adjust_right) {
	if (fo-&gt;fill_direct)
	    return spot_into_trapezoids__aj_fd(ll, band_mask);
	else
	    return spot_into_trapezoids__aj_nd(ll, band_mask);
    } else {
	if (fo-&gt;fill_direct)
	    return spot_into_trapezoids__nj_fd(ll, band_mask);
	else
	    return spot_into_trapezoids__nj_nd(ll, band_mask);
    }
}

/* ---------------- Range list management ---------------- */

/*
 * We originally thought we would store fixed values in coordinate ranges,
 * but it turned out we want to store integers.
 */
typedef int coord_value_t;
#define MIN_COORD_VALUE min_int
#define MAX_COORD_VALUE max_int
/*
 * The invariant for coord_range_ts in a coord_range_list_t:
 *	if prev == 0:
 *		next != 0
 *		rmin == rmax == MIN_COORD_VALUE
 *	else if next == 0:
 *		prev != 0
 *		rmin == rmax == MAX_COORD_VALUE
 *	else
 *		rmin &lt; rmax
 *	if prev != 0:
 *		prev-&gt;next == this
 *		prev-&gt;rmax &lt; rmin
 *	if next != 0:
 *		next-&gt;prev = this
 *		next-&gt;rmin &gt; rmax
 * A coord_range_list_t has a boundary element at each end to avoid having
 * to test for null pointers in the insertion loop.  The boundary elements
 * are the only empty ranges.
 */
typedef struct coord_range_s coord_range_t;
struct coord_range_s {
    coord_value_t rmin, rmax;
    coord_range_t *prev, *next;
    coord_range_t *alloc_next;
};
/* We declare coord_range_ts as simple because they only exist transiently. */
gs_private_st_simple(st_coord_range, coord_range_t, "coord_range_t");

typedef struct coord_range_list_s {
    gs_memory_t *memory;
    struct rl_ {
	coord_range_t *first, *next, *limit;
    } local;
    coord_range_t *allocated;
    coord_range_t *freed;
    coord_range_t *current;
    coord_range_t first, last;
} coord_range_list_t;

private coord_range_t *
range_alloc(coord_range_list_t *pcrl)
{
    coord_range_t *pcr;

    if (pcrl-&gt;freed) {
	pcr = pcrl-&gt;freed;
	pcrl-&gt;freed = pcr-&gt;next;
    } else if (pcrl-&gt;local.next &lt; pcrl-&gt;local.limit)
	pcr = pcrl-&gt;local.next++;
    else {
	pcr = gs_alloc_struct(pcrl-&gt;memory, coord_range_t, &amp;st_coord_range,
			      "range_alloc");
	if (pcr == 0)
	    return 0;
	pcr-&gt;alloc_next = pcrl-&gt;allocated;
	pcrl-&gt;allocated = pcr;
    }
    return pcr;
}

private void
range_delete(coord_range_list_t *pcrl, coord_range_t *pcr)
{
    if_debug3('Q', "[Qr]delete 0x%lx: [%d,%d)\n", (ulong)pcr, pcr-&gt;rmin,
	      pcr-&gt;rmax);
    pcr-&gt;prev-&gt;next = pcr-&gt;next;
    pcr-&gt;next-&gt;prev = pcr-&gt;prev;
    pcr-&gt;next = pcrl-&gt;freed;
    pcrl-&gt;freed = pcr;
}

private void
range_list_clear(coord_range_list_t *pcrl)
{
    if_debug0('Q', "[Qr]clearing\n");
    pcrl-&gt;first.next = &amp;pcrl-&gt;last;
    pcrl-&gt;last.prev = &amp;pcrl-&gt;first;
    pcrl-&gt;current = &amp;pcrl-&gt;last;
}

/* ------ "Public" procedures ------ */

/* Initialize a range list.  We require num_local &gt;= 2. */
private void range_list_clear(coord_range_list_t *);
private void
range_list_init(coord_range_list_t *pcrl, coord_range_t *pcr_local,
		int num_local, gs_memory_t *mem)
{
    pcrl-&gt;memory = mem;
    pcrl-&gt;local.first = pcrl-&gt;local.next = pcr_local;
    pcrl-&gt;local.limit = pcr_local + num_local;
    pcrl-&gt;allocated = pcrl-&gt;freed = 0;
    pcrl-&gt;first.rmin = pcrl-&gt;first.rmax = MIN_COORD_VALUE;
    pcrl-&gt;first.prev = 0;
    pcrl-&gt;last.rmin = pcrl-&gt;last.rmax = MAX_COORD_VALUE;
    pcrl-&gt;last.next = 0;
    range_list_clear(pcrl);
}

/* Reset an initialized range list to the empty state. */
private void
range_list_reset(coord_range_list_t *pcrl)
{
    if (pcrl-&gt;first.next != &amp;pcrl-&gt;last) {
	pcrl-&gt;last.prev-&gt;next = pcrl-&gt;freed;
	pcrl-&gt;freed = pcrl-&gt;first.next;
	range_list_clear(pcrl);
    }
}

/*
 * Move the cursor to the beginning of a range list, in the belief that
 * the next added ranges will roughly parallel the existing ones.
 * (Only affects performance, not function.)
 */
inline private void
range_list_rescan(coord_range_list_t *pcrl)
{
    pcrl-&gt;current = pcrl-&gt;first.next;
}

/* Free a range list. */
private void
range_list_free(coord_range_list_t *pcrl)
{
    coord_range_t *pcr;

    while ((pcr = pcrl-&gt;allocated) != 0) {
	coord_range_t *next = pcr-&gt;alloc_next;

	gs_free_object(pcrl-&gt;memory, pcr, "range_list_free");
	pcrl-&gt;allocated = next;
    }
}

/* Add a range. */
private int
range_list_add(coord_range_list_t *pcrl, coord_value_t rmin, coord_value_t rmax)
{
    coord_range_t *pcr = pcrl-&gt;current;

    if (rmin &gt;= rmax)
	return 0;
    /*
     * Usually, ranges are added in increasing order within each scan line,
     * and overlapping ranges don't differ much.  Optimize accordingly.
     */
 top:
    if (rmax &lt; pcr-&gt;rmin) {
	if (rmin &gt; pcr-&gt;prev-&gt;rmax)
	    goto ins;
	pcr = pcr-&gt;prev;
	goto top;
    }
    if (rmin &gt; pcr-&gt;rmax) {
	pcr = pcr-&gt;next;
	if (rmax &lt; pcr-&gt;rmin)
	    goto ins;
	goto top;
    }
    /*
     * Now we know that (rmin,rmax) overlaps (pcr-&gt;rmin,pcr-&gt;rmax).
     * Don't delete or merge into the special min and max ranges.
     */
    while (rmin &lt;= pcr-&gt;prev-&gt;rmax) {
	/* Merge the range below pcr into this one. */
	if (!pcr-&gt;prev-&gt;prev)
	    break;		/* don't merge into the min range */
	pcr-&gt;rmin = pcr-&gt;prev-&gt;rmin;
	range_delete(pcrl, pcr-&gt;prev);
    }
    while (rmax &gt;= pcr-&gt;next-&gt;rmin) {
	/* Merge the range above pcr into this one. */
	if (!pcr-&gt;next-&gt;next)
	    break;		/* don't merge into the max range */
	pcr-&gt;rmax = pcr-&gt;next-&gt;rmax;
	range_delete(pcrl, pcr-&gt;next);
    }
    /*
     * Now we know that the union of (rmin,rmax) and (pcr-&gt;rmin,pcr-&gt;rmax)
     * doesn't overlap or abut either adjacent range, except that it may
     * abut if the adjacent range is the special min or max range.
     */
    if (rmin &lt; pcr-&gt;rmin) {
	if_debug3('Q', "[Qr]update 0x%lx =&gt; [%d,%d)\n", (ulong)pcr, rmin,
		  pcr-&gt;rmax);
	pcr-&gt;rmin = rmin;
    }
    if (rmax &gt; pcr-&gt;rmax) {
	if_debug3('Q', "[Qr]update 0x%lx =&gt; [%d,%d)\n", (ulong)pcr, pcr-&gt;rmin,
		  rmax);
	pcr-&gt;rmax = rmax;
    }
    pcrl-&gt;current = pcr-&gt;next;
    return 0;
 ins:
    /* Insert a new range below pcr. */
    {
	coord_range_t *prev = range_alloc(pcrl);

	if (prev == 0)
	    return_error(gs_error_VMerror);
	if_debug3('Q', "[Qr]insert 0x%lx: [%d,%d)\n", (ulong)prev, rmin, rmax);
	prev-&gt;rmin = rmin, prev-&gt;rmax = rmax;
	(prev-&gt;prev = pcr-&gt;prev)-&gt;next = prev;
	prev-&gt;next = pcr;
	pcr-&gt;prev = prev;
    }
    pcrl-&gt;current = pcr;
    return 0;
}

/*
 * Merge regions for active segments starting at a given Y, or all active
 * segments, up to the end of the sampling band or the end of the segment,
 * into the range list.
 */
private int
merge_ranges(coord_range_list_t *pcrl, const line_list *ll, fixed y_min, fixed y_top)
{
    active_line *alp, *nlp;
    int code = 0;

    range_list_rescan(pcrl);
    for (alp = ll-&gt;x_list; alp != 0 &amp;&amp; code &gt;= 0; alp = nlp) {
	fixed x0 = alp-&gt;x_current, x1, xt;

	nlp = alp-&gt;next;
	if (alp-&gt;start.y &lt; y_min)
	    continue;
	if (alp-&gt;monotonic_x &amp;&amp; alp-&gt;monotonic_y &amp;&amp; alp-&gt;fi.y3 &lt;= y_top) {
    	    vd_bar(alp-&gt;start.x, alp-&gt;start.y, alp-&gt;end.x, alp-&gt;end.y, 0, RGB(255, 0, 0));
	    x1 = alp-&gt;fi.x3;
	    if (x0 &gt; x1)
		xt = x0, x0 = x1, x1 = xt;
	    code = range_list_add(pcrl,
				  fixed2int_pixround(x0 - ll-&gt;fo-&gt;adjust_left),
				  fixed2int_rounded(x1 + ll-&gt;fo-&gt;adjust_right));
	    alp-&gt;more_flattened = false; /* Skip all the segments left. */
	} else {
	    x1 = x0;
	    for (;;) {
		if (alp-&gt;end.y &lt;= y_top)
		    xt = alp-&gt;end.x;
		else
		    xt = AL_X_AT_Y(alp, y_top);
		x0 = min(x0, xt);
		x1 = max(x1, xt);
		if (!alp-&gt;more_flattened || alp-&gt;end.y &gt; y_top)
		    break;
		step_al(alp, true);
		if (alp-&gt;end.y &lt; alp-&gt;start.y) {
		    remove_al(ll, alp); /* End of a monotonic part of a curve. */
		    break;
		}
	    }
	    code = range_list_add(pcrl,
				  fixed2int_pixround(x0 - ll-&gt;fo-&gt;adjust_left),
				  fixed2int_rounded(x1 + ll-&gt;fo-&gt;adjust_right));
	}

    }
    return code;
}

/* ---------------- Scan line filling loop ---------------- */

/* defina specializations of the scanline algorithm. */

#define FILL_DIRECT 1
#define TEMPLATE_spot_into_scanlines spot_into_scan_lines_fd
#include "gxfillsl.h"
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_scanlines

#define FILL_DIRECT 0
#define TEMPLATE_spot_into_scanlines spot_into_scan_lines_nd
#include "gxfillsl.h"
#undef FILL_DIRECT
#undef TEMPLATE_spot_into_scanlines

private int
spot_into_scan_lines(line_list *ll, fixed band_mask)
{
    if (ll-&gt;fo-&gt;fill_direct)
	return spot_into_scan_lines_fd(ll, band_mask);
    else
	return spot_into_scan_lines_nd(ll, band_mask);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

