<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxfillsl.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxfillsl.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2002 artofcode LLC. All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxfillsl.h,v 1.8 2005/02/15 14:47:37 igor Exp $ */
/* Configurable algorithm for filling a path by scanlines. */

/*
 * Since we need several statically defined variants of this agorithm,
 * we store it in .h file and include it several times into gxfill.c .
 * Configuration macros (template arguments) are :
 * 
 *  FILL_DIRECT - See LOOP_FILL_RECTANGLE_DIRECT.
 *  TEMPLATE_spot_into_scanlines - the name of the procedure to generate.
*/

private int
TEMPLATE_spot_into_scanlines (line_list *ll, fixed band_mask)
{
    const fill_options fo = *ll-&gt;fo;
    active_line *yll = ll-&gt;y_list;
    fixed y_limit = fo.ymax;
    /*
     * The meaning of adjust_below (B) and adjust_above (A) is that the
     * pixels that would normally be painted at coordinate Y get "smeared"
     * to coordinates Y-B through Y+A-epsilon, inclusive.  This is
     * equivalent to saying that the pixels actually painted at coordinate Y
     * are those contributed by scan lines Y-A+epsilon through Y+B,
     * inclusive.  (A = B = 0 is a special case, equivalent to B = 0, A =
     * epsilon.)
     */
    fixed y_frac_min =
	(fo.adjust_above == fixed_0 ? fixed_half :
	 fixed_half + fixed_epsilon - fo.adjust_above);
    fixed y_frac_max =
	fixed_half + fo.adjust_below;
    int y0 = fixed2int(min_fixed);
    fixed y_bot = min_fixed;	/* normally int2fixed(y0) + y_frac_min */
    fixed y_top = min_fixed;	/* normally int2fixed(y0) + y_frac_max */
    fixed y = min_fixed;
    coord_range_list_t rlist;
    coord_range_t rlocal[MAX_LOCAL_ACTIVE];
    int code = 0;

    if (yll == 0)		/* empty list */
	return 0;
    range_list_init(&amp;rlist, rlocal, countof(rlocal), ll-&gt;memory);
    ll-&gt;x_list = 0;
    ll-&gt;x_head.x_current = min_fixed;	/* stop backward scan */
    while (code &gt;= 0) {
	active_line *alp, *nlp;
	fixed x;
	bool new_band;

	INCR(iter);

	move_al_by_y(ll, y); /* Skip horizontal pieces. */
	/*
	 * Find the next sampling point, either the bottom of a sampling
	 * band or a line start.
	 */

	if (ll-&gt;x_list == 0)
	    y = (yll == 0 ? ll-&gt;y_break : yll-&gt;start.y);
	else {
	    y = y_bot + fixed_1;
	    if (yll != 0)
		y = min(y, yll-&gt;start.y);
	    for (alp = ll-&gt;x_list; alp != 0; alp = alp-&gt;next) {
		fixed yy = max(alp-&gt;fi.y3, alp-&gt;fi.y0);
		
		yy = max(yy, alp-&gt;end.y); /* Non-monotonic curves may have an inner extreme. */
		y = min(y, yy);
	    }
	}

	/* Move newly active lines from y to x list. */

	while (yll != 0 &amp;&amp; yll-&gt;start.y == y) {
	    active_line *ynext = yll-&gt;next;	/* insert smashes next/prev links */

	    if (yll-&gt;direction == DIR_HORIZONTAL) {
		/* Ignore for now. */
	    } else
		insert_x_new(yll, ll);
	    yll = ynext;
	}

	/* Update active lines to y. */

	x = min_fixed;
	for (alp = ll-&gt;x_list; alp != 0; alp = nlp) {
	    fixed nx;

	    nlp = alp-&gt;next;
	  e:if (alp-&gt;end.y &lt;= y || alp-&gt;start.y == alp-&gt;end.y) {
		if (end_x_line(alp, ll, true))
		    continue;
		if (alp-&gt;more_flattened)
		    if (alp-&gt;end.y &lt;= y || alp-&gt;start.y == alp-&gt;end.y)
			step_al(alp, true);
		goto e;
	    }
	    nx = alp-&gt;x_current = (alp-&gt;start.y &gt;= y ? alp-&gt;start.x : AL_X_AT_Y(alp, y));
	    if (nx &lt; x) {
		/* Move this line backward in the list. */
		active_line *ilp = alp;

		while (nx &lt; (ilp = ilp-&gt;prev)-&gt;x_current)
		    DO_NOTHING;
		/* Now ilp-&gt;x_current &lt;= nx &lt; ilp-&gt;next-&gt;x_cur. */
		alp-&gt;prev-&gt;next = alp-&gt;next;
		if (alp-&gt;next)
		    alp-&gt;next-&gt;prev = alp-&gt;prev;
		if (ilp-&gt;next)
		    ilp-&gt;next-&gt;prev = alp;
		alp-&gt;next = ilp-&gt;next;
		ilp-&gt;next = alp;
		alp-&gt;prev = ilp;
		continue;
	    }
	    x = nx;
	}

	if (y &gt; y_top || y &gt;= y_limit) {
	    /* We're beyond the end of the previous sampling band. */
	    const coord_range_t *pcr;

	    /* Fill the ranges for y0. */

	    for (pcr = rlist.first.next; pcr != &amp;rlist.last;
		 pcr = pcr-&gt;next
		 ) {
		int x0 = pcr-&gt;rmin, x1 = pcr-&gt;rmax;

		if_debug4('Q', "[Qr]draw 0x%lx: [%d,%d),%d\n", (ulong)pcr,
			  x0, x1, y0);
		VD_RECT(x0, y0, x1 - x0, 1, VD_TRAP_COLOR);
		code = LOOP_FILL_RECTANGLE_DIRECT(&amp;fo, x0, y0, x1 - x0, 1);
		if_debug3('F', "[F]drawing [%d:%d),%d\n", x0, x1, y0);
		if (code &lt; 0)
		    goto done;
	    }
	    range_list_reset(&amp;rlist);

	    /* Check whether we've reached the maximum y. */

	    if (y &gt;= y_limit)
		break;

	    /* Reset the sampling band. */

	    y0 = fixed2int(y);
	    if (fixed_fraction(y) &lt; y_frac_min)
		--y0;
	    y_bot = int2fixed(y0) + y_frac_min;
	    y_top = int2fixed(y0) + y_frac_max;
	    new_band = true;
	} else
	    new_band = false;

	if (y &lt;= y_top) {
	    /*
	     * We're within the same Y pixel.  Merge regions for segments
	     * starting here (at y), up to y_top or the end of the segment.
	     * If this is the first sampling within the band, run the
	     * fill/eofill algorithm.
	     */
	    fixed y_min;

	    if (new_band) {
		int inside = 0;

		INCR(band);
		for (alp = ll-&gt;x_list; alp != 0; alp = alp-&gt;next) {
		    int x0 = fixed2int_pixround(alp-&gt;x_current - fo.adjust_left);

		    for (;;) {
			/* We're inside a filled region. */
			print_al("step", alp);
			INCR(band_step);
			inside += alp-&gt;direction;
			if (!INSIDE_PATH_P(inside, fo.rule))
			    break;
			/*
			 * Since we're dealing with closed paths, the test
			 * for alp == 0 shouldn't be needed, but we may have
			 * omitted lines that are to the right of the
			 * clipping region.
			 */
			if ((alp = alp-&gt;next) == 0)
			    goto out;
		    }
		    /* We just went from inside to outside, so fill the region. */
		    code = range_list_add(&amp;rlist, x0,
					  fixed2int_rounded(alp-&gt;x_current +
							    fo.adjust_right));
		    if (code &lt; 0)
			goto done;
		}
	    out:
		y_min = min_fixed;
	    } else
		y_min = y;
	    code = merge_ranges(&amp;rlist, ll, y_min, y_top);
	} /* else y &lt; y_bot + 1, do nothing */
    }
 done:
    range_list_free(&amp;rlist);
    return code;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

