<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxidata.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxidata.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxidata.c,v 1.9 2005/06/08 14:38:21 igor Exp $ */
/* Generic image enumeration and cleanup */
#include "gx.h"
#include "memory_.h"
#include "gserrors.h"
#include "gxdevice.h"
#include "gxcpath.h"
#include "gximage.h"

/* Forward declarations */
private void update_strip(gx_image_enum *penum);
private void repack_bit_planes(const gx_image_plane_t *src_planes,
			       const ulong *offsets, int num_planes,
			       byte *buffer, int width,
			       const sample_lookup_t * ptab, int spread);
private gx_device *setup_image_device(const gx_image_enum *penum);

/* Process the next piece of an ImageType 1 image. */
int
gx_image1_plane_data(gx_image_enum_common_t * info,
		     const gx_image_plane_t * planes, int height,
		     int *rows_used)
{
    gx_image_enum *penum = (gx_image_enum *) info;
    gx_device *dev;
    const int y = penum-&gt;y;
    int y_end = min(y + height, penum-&gt;rect.h);
    int width_spp = penum-&gt;rect.w * penum-&gt;spp;
    int num_planes = penum-&gt;num_planes;
    int num_components_per_plane = 1;

#define BCOUNT(plane)		/* bytes per data row */\
  (((penum-&gt;rect.w + (plane).data_x) * penum-&gt;spp * penum-&gt;bps / num_planes\
    + 7) &gt;&gt; 3)

    fixed adjust = penum-&gt;adjust;
    ulong offsets[gs_image_max_planes];
    int ignore_data_x;
    bool bit_planar = penum-&gt;num_planes &gt; penum-&gt;spp;
    int code;

    if (height == 0) {
	*rows_used = 0;
	return 0;
    }
    dev = setup_image_device(penum);

    /* Now render complete rows. */

    if (penum-&gt;used.y) {
	/*
	 * Processing was interrupted by an error.  Skip over rows
	 * already processed.
	 */
	int px;

	for (px = 0; px &lt; num_planes; ++px)
	    offsets[px] = planes[px].raster * penum-&gt;used.y;
	penum-&gt;used.y = 0;
    } else
	memset(offsets, 0, num_planes * sizeof(offsets[0]));
    if (num_planes == 1 &amp;&amp; penum-&gt;plane_depths[0] != penum-&gt;bps) {
	/* A single plane with multiple components. */
	num_components_per_plane = penum-&gt;plane_depths[0] / penum-&gt;bps;
    }
    for (; penum-&gt;y &lt; y_end; penum-&gt;y++) {
	int px;
	const byte *buffer;
	int sourcex;
	int x_used = penum-&gt;used.x;

	if (bit_planar) {
	    /* Repack the bit planes into byte-wide samples. */
	    
	    buffer = penum-&gt;buffer;
	    sourcex = 0;
	    for (px = 0; px &lt; num_planes; px += penum-&gt;bps)
		repack_bit_planes(planes, offsets, penum-&gt;bps, penum-&gt;buffer,
				  penum-&gt;rect.w, &amp;penum-&gt;map[px].table,
				  penum-&gt;spread);
	    for (px = 0; px &lt; num_planes; ++px)
		offsets[px] += planes[px].raster;
	} else {
	    /*
	     * Normally, we unpack the data into the buffer, but if
	     * there is only one plane and we don't need to expand the
	     * input samples, we may use the data directly.
	     */
	    sourcex = planes[0].data_x;
	    buffer =
		(*penum-&gt;unpack)(penum-&gt;buffer, &amp;sourcex,
				 planes[0].data + offsets[0],
				 planes[0].data_x, BCOUNT(planes[0]),
				 &amp;penum-&gt;map[0], penum-&gt;spread, num_components_per_plane);

	    offsets[0] += planes[0].raster;
	    for (px = 1; px &lt; num_planes; ++px) {
		(*penum-&gt;unpack)(penum-&gt;buffer + (px &lt;&lt; penum-&gt;log2_xbytes),
				 &amp;ignore_data_x,
				 planes[px].data + offsets[px],
				 planes[px].data_x, BCOUNT(planes[px]),
				 &amp;penum-&gt;map[px], penum-&gt;spread, 1);
		offsets[px] += planes[px].raster;
	    }
	}
#ifdef DEBUG
	if (gs_debug_c('b'))
	    dprintf1("[b]image1 y=%d\n", y);
	if (gs_debug_c('B')) {
	    int i, n = width_spp;

	    if (penum-&gt;bps &gt; 8)
		n *= 2;
	    else if (penum-&gt;bps == 1 &amp;&amp; penum-&gt;unpack_bps == 8)
		n = (n + 7) / 8;
	    dlputs("[B]row:");
	    for (i = 0; i &lt; n; i++)
		dprintf1(" %02x", buffer[i]);
	    dputs("\n");
	}
#endif
	penum-&gt;cur.x = dda_current(penum-&gt;dda.row.x);
	dda_next(penum-&gt;dda.row.x);
	penum-&gt;cur.y = dda_current(penum-&gt;dda.row.y);
	dda_next(penum-&gt;dda.row.y);
	if (!penum-&gt;interpolate)
	    switch (penum-&gt;posture) {
		case image_portrait:
		    {		/* Precompute integer y and height, */
			/* and check for clipping. */
			fixed yc = penum-&gt;cur.y,
			    yn = dda_current(penum-&gt;dda.row.y);

			if (yn &lt; yc) {
			    fixed temp = yn;

			    yn = yc;
			    yc = temp;
			}
			yc -= adjust;
			if (yc &gt;= penum-&gt;clip_outer.q.y)
			    goto mt;
			yn += adjust;
			if (yn &lt;= penum-&gt;clip_outer.p.y)
			    goto mt;
			penum-&gt;yci = fixed2int_pixround(yc);
			penum-&gt;hci = fixed2int_pixround(yn) - penum-&gt;yci;
			if (penum-&gt;hci == 0)
			    goto mt;
			if_debug2('b', "[b]yci=%d, hci=%d\n",
				  penum-&gt;yci, penum-&gt;hci);
		    }
		    break;
		case image_landscape:
		    {		/* Check for no pixel centers in x. */
			fixed xc = penum-&gt;cur.x,
			    xn = dda_current(penum-&gt;dda.row.x);

			if (xn &lt; xc) {
			    fixed temp = xn;

			    xn = xc;
			    xc = temp;
			}
			xc -= adjust;
			if (xc &gt;= penum-&gt;clip_outer.q.x)
			    goto mt;
			xn += adjust;
			if (xn &lt;= penum-&gt;clip_outer.p.x)
			    goto mt;
			penum-&gt;xci = fixed2int_pixround(xc);
			penum-&gt;wci = fixed2int_pixround(xn) - penum-&gt;xci;
			if (penum-&gt;wci == 0)
			    goto mt;
			if_debug2('b', "[b]xci=%d, wci=%d\n",
				  penum-&gt;xci, penum-&gt;wci);
		    }
		    break;
		case image_skewed:
		    ;
	    }
	update_strip(penum);
	if (x_used) {
	    /*
	     * Processing was interrupted by an error.  Skip over pixels
	     * already processed.
	     */
	    dda_advance(penum-&gt;dda.pixel0.x, x_used);
	    dda_advance(penum-&gt;dda.pixel0.y, x_used);
	    penum-&gt;used.x = 0;
	}
	if_debug2('b', "[b]pixel0 x=%g, y=%g\n",
		  fixed2float(dda_current(penum-&gt;dda.pixel0.x)),
		  fixed2float(dda_current(penum-&gt;dda.pixel0.y)));
	code = (*penum-&gt;render)(penum, buffer, sourcex + x_used,
				width_spp - x_used * penum-&gt;spp, 1, dev);
	if (code &lt; 0) {
	    /* Error or interrupt, restore original state. */
	    penum-&gt;used.x += x_used;
	    if (!penum-&gt;used.y) {
		dda_previous(penum-&gt;dda.row.x);
		dda_previous(penum-&gt;dda.row.y);
		dda_translate(penum-&gt;dda.strip.x,
			      penum-&gt;prev.x - penum-&gt;cur.x);
		dda_translate(penum-&gt;dda.strip.y,
			      penum-&gt;prev.y - penum-&gt;cur.y);
	    }
	    goto out;
	}
	penum-&gt;prev = penum-&gt;cur;
      mt:;
    }
    if (penum-&gt;y &lt; penum-&gt;rect.h) {
	code = 0;
    } else {
	/* End of input data.  Render any left-over buffered data. */
	code = gx_image1_flush(info);
	if (code &gt;= 0)
	    code = 1;
    }
out:
    /* Note that caller must call end_image */
    /* for both error and normal termination. */
    *rows_used = penum-&gt;y - y;
    return code;
}

/* Flush any buffered data. */
int
gx_image1_flush(gx_image_enum_common_t * info)
{
    gx_image_enum *penum = (gx_image_enum *)info;
    int width_spp = penum-&gt;rect.w * penum-&gt;spp;
    fixed adjust = penum-&gt;adjust;

    penum-&gt;cur.x = dda_current(penum-&gt;dda.row.x);
    penum-&gt;cur.y = dda_current(penum-&gt;dda.row.y);
    switch (penum-&gt;posture) {
	case image_portrait:
	    {
		fixed yc = penum-&gt;cur.y;

		penum-&gt;yci = fixed2int_rounded(yc - adjust);
		penum-&gt;hci = fixed2int_rounded(yc + adjust) - penum-&gt;yci;
	    }
	    break;
	case image_landscape:
	    {
		fixed xc = penum-&gt;cur.x;

		penum-&gt;xci = fixed2int_rounded(xc - adjust);
		penum-&gt;wci = fixed2int_rounded(xc + adjust) - penum-&gt;xci;
	    }
	    break;
	case image_skewed:	/* pacify compilers */
	    ;
    }
    update_strip(penum);
    penum-&gt;prev = penum-&gt;cur;
    return (*penum-&gt;render)(penum, NULL, 0, width_spp, 0,
			    setup_image_device(penum));
}

/* Update the strip DDA when moving to a new row. */
private void
update_strip(gx_image_enum *penum)
{
    dda_translate(penum-&gt;dda.strip.x, penum-&gt;cur.x - penum-&gt;prev.x);
    dda_translate(penum-&gt;dda.strip.y, penum-&gt;cur.y - penum-&gt;prev.y);
    penum-&gt;dda.pixel0 = penum-&gt;dda.strip;
}

/*
 * Repack 1 to 8 individual bit planes into 8-bit samples.
 * buffer is aligned, and includes padding to an 8-byte boundary.
 * This procedure repacks one row, so the only relevant members of
 * src_planes are data and data_x (not raster).
 */
private void
repack_bit_planes(const gx_image_plane_t *src_planes, const ulong *offsets,
		  int num_planes, byte *buffer, int width,
		  const sample_lookup_t * ptab, int spread)
{
    gx_image_plane_t planes[8];
    byte *zeros = 0;
    byte *dest = buffer;
    int any_data_x = 0;
    bool direct = (spread == 1 &amp;&amp; ptab-&gt;lookup8[0] == 0 &amp;&amp;
		   ptab-&gt;lookup8[255] == 255);
    int pi, x;
    gx_image_plane_t *pp;

    /*
     * Set up the row pointers, taking data_x and null planes into account.
     * If there are any null rows, we need to create a block of zeros in
     * order to avoid tests in the loop.
     */
    for (pi = 0, pp = planes; pi &lt; num_planes; ++pi, ++pp)
	if (src_planes[pi].data == 0) {
	    if (!zeros) {
		zeros = buffer + width - ((width + 7) &gt;&gt; 3);
	    }
	    pp-&gt;data = zeros;
	    pp-&gt;data_x = 0;
	} else {
	    int dx = src_planes[pi].data_x;

	    pp-&gt;data = src_planes[pi].data + (dx &gt;&gt; 3) + offsets[pi];
	    any_data_x |= (pp-&gt;data_x = dx &amp; 7);
	}
    if (zeros)
	memset(zeros, 0, buffer + width - zeros);

    /*
     * Now process the data, in blocks of one input byte column
     * (8 output bytes).
     */
    for (x = 0; x &lt; width; x += 8) {
	bits32 w0 = 0, w1 = 0;
#if arch_is_big_endian
	static const bits32 expand[16] = {
	    0x00000000, 0x00000001, 0x00000100, 0x00000101,
	    0x00010000, 0x00010001, 0x00010100, 0x00010101,
	    0x01000000, 0x01000001, 0x01000100, 0x01000101,
	    0x01010000, 0x01010001, 0x01010100, 0x01010101
	};
#else
	static const bits32 expand[16] = {
	    0x00000000, 0x01000000, 0x00010000, 0x01010000,
	    0x00000100, 0x01000100, 0x00010100, 0x01010100,
	    0x00000001, 0x01000001, 0x00010001, 0x01010001,
	    0x00000101, 0x01000101, 0x00010101, 0x01010101
	};
#endif

	if (any_data_x) {
	    for (pi = 0, pp = planes; pi &lt; num_planes; ++pi, ++pp) {
		uint b = *(pp-&gt;data++);
		int dx = pp-&gt;data_x;

		if (dx) {
		    b &lt;&lt;= dx;
		    if (x + 8 - dx &lt; width)
			b += *pp-&gt;data &gt;&gt; (8 - dx);
		}
		w0 = (w0 &lt;&lt; 1) | expand[b &gt;&gt; 4];
		w1 = (w1 &lt;&lt; 1) | expand[b &amp; 0xf];
	    }
	} else {
	    for (pi = 0, pp = planes; pi &lt; num_planes; ++pi, ++pp) {
		uint b = *(pp-&gt;data++);

		w0 = (w0 &lt;&lt; 1) | expand[b &gt;&gt; 4];
		w1 = (w1 &lt;&lt; 1) | expand[b &amp; 0xf];
	    }
	}
	/*
	 * We optimize spread == 1 and identity ptab together, although
	 * we could subdivide these 2 cases into 4 if we wanted.
	 */
	if (direct) {
	    ((bits32 *)dest)[0] = w0;
	    ((bits32 *)dest)[1] = w1;
	    dest += 8;
	} else {
#define MAP_BYTE(v) (ptab-&gt;lookup8[(byte)(v)])
	    dest[0] = MAP_BYTE(w0 &gt;&gt; 24); dest += spread;
	    dest[1] = MAP_BYTE(w0 &gt;&gt; 16); dest += spread;
	    dest[2] = MAP_BYTE(w0 &gt;&gt; 8); dest += spread;
	    dest[3] = MAP_BYTE(w0); dest += spread;
	    dest[4] = MAP_BYTE(w1 &gt;&gt; 24); dest += spread;
	    dest[5] = MAP_BYTE(w1 &gt;&gt; 16); dest += spread;
	    dest[6] = MAP_BYTE(w1 &gt;&gt; 8); dest += spread;
	    dest[7] = MAP_BYTE(w1); dest += spread;
#undef MAP_BYTE
	}
    }
}

/* Set up the device for drawing an image. */
private gx_device *
setup_image_device(const gx_image_enum *penum)
{
    gx_device *dev = penum-&gt;dev;

    if (penum-&gt;clip_dev) {
	gx_device_clip *cdev = penum-&gt;clip_dev;

	gx_device_set_target((gx_device_forward *)cdev, dev);
	dev = (gx_device *) cdev;
    }
    if (penum-&gt;rop_dev) {
	gx_device_rop_texture *rtdev = penum-&gt;rop_dev;

	gx_device_set_target((gx_device_forward *)rtdev, dev);
	dev = (gx_device *) rtdev;
    }
    return dev;
}

/* Clean up by releasing the buffers. */
/* Currently we ignore draw_last. */
int
gx_image1_end_image(gx_image_enum_common_t * info, bool draw_last)
{
    gx_image_enum *penum = (gx_image_enum *) info;
    gs_memory_t *mem = penum-&gt;memory;
    stream_image_scale_state *scaler = penum-&gt;scaler;

    if_debug2('b', "[b]%send_image, y=%d\n",
	      (penum-&gt;y &lt; penum-&gt;rect.h ? "premature " : ""), penum-&gt;y);
    if (draw_last) {
	int code = gx_image_flush(info);

	if (code &lt; 0)
	    return code;
    }
    gs_free_object(mem, penum-&gt;rop_dev, "image RasterOp");
    gs_free_object(mem, penum-&gt;clip_dev, "image clipper");
    if (scaler != 0) {
	(*scaler-&gt;template-&gt;release) ((stream_state *) scaler);
	gs_free_object(mem, scaler, "image scaler state");
    }
    gs_free_object(mem, penum-&gt;line, "image line");
    gs_free_object(mem, penum-&gt;buffer, "image buffer");
    gs_free_object(mem, penum, "gx_default_end_image");
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

