<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxpath2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxpath2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/*$Id: gxpath2.c,v 1.6 2002/08/30 02:38:24 dan Exp $ */
/* Path tracing procedures for Ghostscript library */
#include "math_.h"
#include "gx.h"
#include "gserrors.h"
#include "gspath.h"		/* for gs_path_enum_alloc prototype */
#include "gsstruct.h"
#include "gxfixed.h"
#include "gxarith.h"
#include "gzpath.h"

/* Define the enumeration structure. */
public_st_path_enum();

/* Read the current point of a path. */
int
gx_path_current_point(const gx_path * ppath, gs_fixed_point * ppt)
{
    if (!path_position_valid(ppath))
	return_error(gs_error_nocurrentpoint);
    /* Copying the coordinates individually */
    /* is much faster on a PC, and almost as fast on other machines.... */
    ppt-&gt;x = ppath-&gt;position.x, ppt-&gt;y = ppath-&gt;position.y;
    return 0;
}

/* Read the start point of the current subpath. */
int
gx_path_subpath_start_point(const gx_path * ppath, gs_fixed_point * ppt)
{
    const subpath *psub = ppath-&gt;current_subpath;

    if (!psub)
	return_error(gs_error_nocurrentpoint);
    *ppt = psub-&gt;pt;
    return 0;
}

/* Read the bounding box of a path. */
/* Note that if the last element of the path is a moveto, */
/* the bounding box does not include this point, */
/* unless this is the only element of the path. */
int
gx_path_bbox(gx_path * ppath, gs_fixed_rect * pbox)
{
    if (ppath-&gt;bbox_accurate) {
	/* The bounding box was set by setbbox. */
	*pbox = ppath-&gt;bbox;
	return 0;
    }
    if (ppath-&gt;first_subpath == 0) {
	/* The path is empty, use the current point if any. */
	int code = gx_path_current_point(ppath, &amp;pbox-&gt;p);

	if (code &lt; 0) {
	    /*
	     * Don't return garbage, in case the caller doesn't
	     * check the return code.
	     */
	    pbox-&gt;p.x = pbox-&gt;p.y = 0;
	}
	pbox-&gt;q = pbox-&gt;p;
	return code;
    }
    /* The stored bounding box may not be up to date. */
    /* Correct it now if necessary. */
    if (ppath-&gt;box_last == ppath-&gt;current_subpath-&gt;last) {
	/* Box is up to date */
	*pbox = ppath-&gt;bbox;
    } else {
	fixed px, py, qx, qy;
	const segment *pseg = ppath-&gt;box_last;

	if (pseg == 0) {	/* box is uninitialized */
	    pseg = (const segment *)ppath-&gt;first_subpath;
	    px = qx = pseg-&gt;pt.x;
	    py = qy = pseg-&gt;pt.y;
	} else {
	    px = ppath-&gt;bbox.p.x, py = ppath-&gt;bbox.p.y;
	    qx = ppath-&gt;bbox.q.x, qy = ppath-&gt;bbox.q.y;
	}

/* Macro for adjusting the bounding box when adding a point */
#define ADJUST_BBOX(pt)\
  if ((pt).x &lt; px) px = (pt).x;\
  else if ((pt).x &gt; qx) qx = (pt).x;\
  if ((pt).y &lt; py) py = (pt).y;\
  else if ((pt).y &gt; qy) qy = (pt).y

	while ((pseg = pseg-&gt;next) != 0) {
	    switch (pseg-&gt;type) {
		case s_curve:
		    ADJUST_BBOX(((const curve_segment *)pseg)-&gt;p1);
		    ADJUST_BBOX(((const curve_segment *)pseg)-&gt;p2);
		    /* falls through */
		default:
		    ADJUST_BBOX(pseg-&gt;pt);
	    }
	}
#undef ADJUST_BBOX

#define STORE_BBOX(b)\
  (b).p.x = px, (b).p.y = py, (b).q.x = qx, (b).q.y = qy;
	STORE_BBOX(*pbox);
	STORE_BBOX(ppath-&gt;bbox);
#undef STORE_BBOX

	ppath-&gt;box_last = ppath-&gt;current_subpath-&gt;last;
    }
    return 0;
}

/* A variation of gs_path_bbox, to be used by the patbbox operator */
int
gx_path_bbox_set(gx_path * ppath, gs_fixed_rect * pbox)
{
    if (ppath-&gt;bbox_set) {
	/* The bounding box was set by setbbox. */
	*pbox = ppath-&gt;bbox;
	return 0;
    } else
	return gx_path_bbox(ppath, pbox);
}


/* Test if a path has any curves. */
#undef gx_path_has_curves
bool
gx_path_has_curves(const gx_path * ppath)
{
    return gx_path_has_curves_inline(ppath);
}
#define gx_path_has_curves(ppath)\
  gx_path_has_curves_inline(ppath)

/* Test if a path has no segments. */
#undef gx_path_is_void
bool
gx_path_is_void(const gx_path * ppath)
{
    return gx_path_is_void_inline(ppath);
}
#define gx_path_is_void(ppath)\
  gx_path_is_void_inline(ppath)

/* Test if a path has no elements at all. */
bool
gx_path_is_null(const gx_path * ppath)
{
    return gx_path_is_null_inline(ppath);
}

/*
 * Test if a subpath is a rectangle; if so, return its bounding box
 * and the start of the next subpath.
 * Note that this must recognize:
 *      ordinary closed rectangles (M, L, L, L, C);
 *      open rectangles (M, L, L, L);
 *      rectangles closed with lineto (Mo, L, L, L, Lo);
 *      rectangles closed with *both* lineto and closepath (bad PostScript,
 *        but unfortunately not rare) (Mo, L, L, L, Lo, C).
 */
gx_path_rectangular_type
gx_subpath_is_rectangular(const subpath * pseg0, gs_fixed_rect * pbox,
			  const subpath ** ppnext)
{
    const segment *pseg1, *pseg2, *pseg3, *pseg4;
    gx_path_rectangular_type type;

    if (pseg0-&gt;curve_count == 0 &amp;&amp;
	(pseg1 = pseg0-&gt;next) != 0 &amp;&amp;
	(pseg2 = pseg1-&gt;next) != 0 &amp;&amp;
	(pseg3 = pseg2-&gt;next) != 0
	) {
	if ((pseg4 = pseg3-&gt;next) == 0 || pseg4-&gt;type == s_start)
	    type = prt_open;	/* M, L, L, L */
	else if (pseg4-&gt;type != s_line)		/* must be s_line_close */
	    type = prt_closed;	/* M, L, L, L, C */
	else if (pseg4-&gt;pt.x != pseg0-&gt;pt.x ||
		 pseg4-&gt;pt.y != pseg0-&gt;pt.y
	    )
	    return prt_none;
	else if (pseg4-&gt;next == 0 || pseg4-&gt;next-&gt;type == s_start)
	    type = prt_fake_closed;	/* Mo, L, L, L, Lo */
	else if (pseg4-&gt;next-&gt;type != s_line)	/* must be s_line_close */
	    type = prt_closed;	/* Mo, L, L, L, Lo, C */
	else
	    return prt_none;
	{
	    fixed x0 = pseg0-&gt;pt.x, y0 = pseg0-&gt;pt.y;
	    fixed x2 = pseg2-&gt;pt.x, y2 = pseg2-&gt;pt.y;

	    if ((x0 == pseg1-&gt;pt.x &amp;&amp; pseg1-&gt;pt.y == y2 &amp;&amp;
		 x2 == pseg3-&gt;pt.x &amp;&amp; pseg3-&gt;pt.y == y0) ||
		(x0 == pseg3-&gt;pt.x &amp;&amp; pseg3-&gt;pt.y == y2 &amp;&amp;
		 x2 == pseg1-&gt;pt.x &amp;&amp; pseg1-&gt;pt.y == y0)
		) {		/* Path is a rectangle.  Return the bounding box. */
		if (x0 &lt; x2)
		    pbox-&gt;p.x = x0, pbox-&gt;q.x = x2;
		else
		    pbox-&gt;p.x = x2, pbox-&gt;q.x = x0;
		if (y0 &lt; y2)
		    pbox-&gt;p.y = y0, pbox-&gt;q.y = y2;
		else
		    pbox-&gt;p.y = y2, pbox-&gt;q.y = y0;
		while (pseg4 != 0 &amp;&amp; pseg4-&gt;type != s_start)
		    pseg4 = pseg4-&gt;next;
		*ppnext = (const subpath *)pseg4;
		return type;
	    }
	}
    }
    return prt_none;
}
/* Test if an entire path to be filled is a rectangle. */
gx_path_rectangular_type
gx_path_is_rectangular(const gx_path * ppath, gs_fixed_rect * pbox)
{
    const subpath *pnext;

    return
	(gx_path_subpath_count(ppath) == 1 ?
	 gx_subpath_is_rectangular(ppath-&gt;first_subpath, pbox, &amp;pnext) :
	 prt_none);
}

/* Translate an already-constructed path (in device space). */
/* Don't bother to update the cbox. */
int
gx_path_translate(gx_path * ppath, fixed dx, fixed dy)
{
    segment *pseg;

#define update_xy(pt)\
  pt.x += dx, pt.y += dy
    if (ppath-&gt;box_last != 0) {
	update_xy(ppath-&gt;bbox.p);
	update_xy(ppath-&gt;bbox.q);
    }
    if (path_position_valid(ppath))
	update_xy(ppath-&gt;position);
    for (pseg = (segment *) (ppath-&gt;first_subpath); pseg != 0;
	 pseg = pseg-&gt;next
	)
	switch (pseg-&gt;type) {
	    case s_curve:
#define pcseg ((curve_segment *)pseg)
		update_xy(pcseg-&gt;p1);
		update_xy(pcseg-&gt;p2);
#undef pcseg
	    default:
		update_xy(pseg-&gt;pt);
	}
#undef update_xy
    return 0;
}

/* Scale an existing path by a power of 2 (positive or negative). */
void
gx_point_scale_exp2(gs_fixed_point * pt, int sx, int sy)
{
    if (sx &gt;= 0)
	pt-&gt;x &lt;&lt;= sx;
    else
	pt-&gt;x &gt;&gt;= -sx;
    if (sy &gt;= 0)
	pt-&gt;y &lt;&lt;= sy;
    else
	pt-&gt;y &gt;&gt;= -sy;
}
void
gx_rect_scale_exp2(gs_fixed_rect * pr, int sx, int sy)
{
    gx_point_scale_exp2(&amp;pr-&gt;p, sx, sy);
    gx_point_scale_exp2(&amp;pr-&gt;q, sx, sy);
}
int
gx_path_scale_exp2_shared(gx_path * ppath, int log2_scale_x, int log2_scale_y,
			  bool segments_shared)
{
    segment *pseg;

    gx_rect_scale_exp2(&amp;ppath-&gt;bbox, log2_scale_x, log2_scale_y);
#define SCALE_XY(pt) gx_point_scale_exp2(&amp;pt, log2_scale_x, log2_scale_y)
    SCALE_XY(ppath-&gt;position);
    if (!segments_shared) {
	for (pseg = (segment *) (ppath-&gt;first_subpath); pseg != 0;
	     pseg = pseg-&gt;next
	     )
	    switch (pseg-&gt;type) {
	    case s_curve:
		SCALE_XY(((curve_segment *)pseg)-&gt;p1);
		SCALE_XY(((curve_segment *)pseg)-&gt;p2);
	    default:
		SCALE_XY(pseg-&gt;pt);
	    }
    }
#undef SCALE_XY
    return 0;
}

/*
 * Reverse a path.  We know ppath != ppath_old.
 * NOTE: in releases 5.01 and earlier, the implicit line added by closepath
 * became the first segment of the reversed path.  Starting in release
 * 5.02, the code follows the Adobe implementation (and LanguageLevel 3
 * specification), in which this line becomes the *last* segment of the
 * reversed path.  This can produce some quite unintuitive results.
 */
int
gx_path_copy_reversed(const gx_path * ppath_old, gx_path * ppath)
{
    const subpath *psub = ppath_old-&gt;first_subpath;

#ifdef DEBUG
    if (gs_debug_c('P'))
	gx_dump_path(ppath_old, "before reversepath");
#endif
 nsp:
    if (psub) {
	const segment *prev = psub-&gt;last;
	const segment *pseg;
	segment_notes notes =
	    (prev == (const segment *)psub ? sn_none :
	     psub-&gt;next-&gt;notes);
	segment_notes prev_notes;
	int code;

	if (!psub-&gt;is_closed) {
	    code = gx_path_add_point(ppath, prev-&gt;pt.x, prev-&gt;pt.y);
	    if (code &lt; 0)
		return code;
	}
	/*
	 * The do ... while structure of this loop is artificial,
	 * designed solely to keep compilers from complaining about
	 * 'statement not reached' or 'end-of-loop code not reached'.
	 * The normal exit from this loop is the goto statement in
	 * the s_start arm of the switch.
	 */
	do {
	    pseg = prev;
	    prev_notes = notes;
	    prev = pseg-&gt;prev;
	    notes = pseg-&gt;notes;
	    prev_notes = (prev_notes &amp; sn_not_first) |
		(notes &amp; ~sn_not_first);
	    switch (pseg-&gt;type) {
		case s_start:
		    /* Finished subpath */
		    if (psub-&gt;is_closed) {
			code =
			    gx_path_close_subpath_notes(ppath, prev_notes);
			if (code &lt; 0)
			    return code;
		    }
		    psub = (const subpath *)psub-&gt;last-&gt;next;
		    goto nsp;
		case s_curve:
		    {
			const curve_segment *pc =
			(const curve_segment *)pseg;

			code = gx_path_add_curve_notes(ppath,
						       pc-&gt;p2.x, pc-&gt;p2.y,
						       pc-&gt;p1.x, pc-&gt;p1.y,
					prev-&gt;pt.x, prev-&gt;pt.y, prev_notes);
			break;
		    }
		case s_line:
		    code = gx_path_add_line_notes(ppath,
					prev-&gt;pt.x, prev-&gt;pt.y, prev_notes);
		    break;
		case s_line_close:
		    /* Skip the closing line. */
		    code = gx_path_add_point(ppath, prev-&gt;pt.x,
					     prev-&gt;pt.y);
		    break;
		default:	/* not possible */
		    return_error(gs_error_Fatal);
	    }
	} while (code &gt;= 0);
	return code;		/* only reached if code &lt; 0 */
    }
#undef sn_not_end
    /*
     * In the Adobe implementations, reversepath discards a trailing
     * moveto unless the path consists only of a moveto.  We reproduce
     * this behavior here, even though we consider it a bug.
     */
    if (ppath_old-&gt;first_subpath == 0 &amp;&amp;
	path_last_is_moveto(ppath_old)
	) {
	int code = gx_path_add_point(ppath, ppath_old-&gt;position.x,
				     ppath_old-&gt;position.y);

	if (code &lt; 0)
	    return code;
    }
#ifdef DEBUG
    if (gs_debug_c('P'))
	gx_dump_path(ppath, "after reversepath");
#endif
    return 0;
}

/* ------ Path enumeration ------ */

/* Allocate a path enumerator. */
gs_path_enum *
gs_path_enum_alloc(gs_memory_t * mem, client_name_t cname)
{
    return gs_alloc_struct(mem, gs_path_enum, &amp;st_path_enum, cname);
}

/* Start enumerating a path. */
int
gx_path_enum_init(gs_path_enum * penum, const gx_path * ppath)
{
    penum-&gt;memory = 0;		/* path not copied */
    penum-&gt;path = ppath;
    penum-&gt;copied_path = 0;	/* not copied */
    penum-&gt;pseg = (const segment *)ppath-&gt;first_subpath;
    penum-&gt;moveto_done = false;
    penum-&gt;notes = sn_none;
    return 0;
}

/* Enumerate the next element of a path. */
/* If the path is finished, return 0; */
/* otherwise, return the element type. */
int
gx_path_enum_next(gs_path_enum * penum, gs_fixed_point ppts[3])
{
    const segment *pseg = penum-&gt;pseg;

    if (pseg == 0) {		/* We've enumerated all the segments, but there might be */
	/* a trailing moveto. */
	const gx_path *ppath = penum-&gt;path;

	if (path_last_is_moveto(ppath) &amp;&amp; !penum-&gt;moveto_done) {	/* Handle a trailing moveto */
	    penum-&gt;moveto_done = true;
	    penum-&gt;notes = sn_none;
	    ppts[0] = ppath-&gt;position;
	    return gs_pe_moveto;
	}
	return 0;
    }
    penum-&gt;pseg = pseg-&gt;next;
    penum-&gt;notes = pseg-&gt;notes;
    switch (pseg-&gt;type) {
	case s_start:
	    ppts[0] = pseg-&gt;pt;
	    return gs_pe_moveto;
	case s_line:
	    ppts[0] = pseg-&gt;pt;
	    return gs_pe_lineto;
	case s_line_close:
	    ppts[0] = pseg-&gt;pt;
	    return gs_pe_closepath;
	case s_curve:
#define pcseg ((const curve_segment *)pseg)
	    ppts[0] = pcseg-&gt;p1;
	    ppts[1] = pcseg-&gt;p2;
	    ppts[2] = pseg-&gt;pt;
	    return gs_pe_curveto;
#undef pcseg
	default:
	    lprintf1("bad type %x in gx_path_enum_next!\n", pseg-&gt;type);
	    return_error(gs_error_Fatal);
    }
}

/* Return the notes from the last-enumerated segment. */
segment_notes
gx_path_enum_notes(const gs_path_enum * penum)
{
    return penum-&gt;notes;
}

/* Back up 1 element in the path being enumerated. */
/* Return true if successful, false if we are at the beginning of the path. */
/* This implementation allows backing up multiple times, */
/* but no client currently relies on this. */
bool
gx_path_enum_backup(gs_path_enum * penum)
{
    const segment *pseg = penum-&gt;pseg;

    if (pseg != 0) {
	if ((pseg = pseg-&gt;prev) == 0)
	    return false;
	penum-&gt;pseg = pseg;
	return true;
    }
    /* We're at the end of the path.  Check to see whether */
    /* we need to back up over a trailing moveto. */
    {
	const gx_path *ppath = penum-&gt;path;

	if (path_last_is_moveto(ppath) &amp;&amp; penum-&gt;moveto_done) {		/* Back up over the trailing moveto. */
	    penum-&gt;moveto_done = false;
	    return true;
	} {
	    const subpath *psub = ppath-&gt;current_subpath;

	    if (psub == 0)	/* empty path */
		return false;
	    /* Back up to the last segment of the last subpath. */
	    penum-&gt;pseg = psub-&gt;last;
	    return true;
	}
    }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

