<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxpcopy.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxpcopy.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1992, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxpcopy.c,v 1.26 2005/08/30 06:38:44 igor Exp $ */
/* Path copying and flattening */
#include "math_.h"
#include "gx.h"
#include "gserrors.h"
#include "gconfigv.h"		/* for USE_FPU */
#include "gxfixed.h"
#include "gxfarith.h"
#include "gxistate.h"		/* for access to line params */
#include "gzpath.h"
#include "vdtrace.h"

/* Forward declarations */
private void adjust_point_to_tangent(segment *, const segment *,
				     const gs_fixed_point *);
/* Copy a path, optionally flattening or monotonizing it. */
/* If the copy fails, free the new path. */
int
gx_path_copy_reducing(const gx_path *ppath_old, gx_path *ppath,
		      fixed fixed_flatness, const gs_imager_state *pis,
		      gx_path_copy_options options)
{
    const segment *pseg;
    fixed flat = fixed_flatness;
    gs_fixed_point expansion;
    /*
     * Since we're going to be adding to the path, unshare it
     * before we start.
     */
    int code = gx_path_unshare(ppath);

    if (code &lt; 0)
	return code;
#ifdef DEBUG
    if (gs_debug_c('P'))
	gx_dump_path(ppath_old, "before reducing");
#endif
    if (options &amp; pco_for_stroke) {
	/* Precompute the maximum expansion of the bounding box. */
	double width = pis-&gt;line_params.half_width;

	expansion.x =
	    float2fixed((fabs(pis-&gt;ctm.xx) + fabs(pis-&gt;ctm.yx)) * width) * 2;
	expansion.y =
	    float2fixed((fabs(pis-&gt;ctm.xy) + fabs(pis-&gt;ctm.yy)) * width) * 2;
    }
    vd_setcolor(RGB(255,255,0));
    pseg = (const segment *)(ppath_old-&gt;first_subpath);
    while (pseg) {
	switch (pseg-&gt;type) {
	    case s_start:
		code = gx_path_add_point(ppath,
					 pseg-&gt;pt.x, pseg-&gt;pt.y);
		vd_moveto(pseg-&gt;pt.x, pseg-&gt;pt.y);
		break;
	    case s_curve:
		{
		    const curve_segment *pc = (const curve_segment *)pseg;

		    if (fixed_flatness == max_fixed) {	/* don't flatten */
			if (options &amp; pco_monotonize)
			    code = gx_curve_monotonize(ppath, pc);
			else
			    code = gx_path_add_curve_notes(ppath,
				     pc-&gt;p1.x, pc-&gt;p1.y, pc-&gt;p2.x, pc-&gt;p2.y,
					   pc-&gt;pt.x, pc-&gt;pt.y, pseg-&gt;notes);
		    } else {
			fixed x0 = ppath-&gt;position.x;
			fixed y0 = ppath-&gt;position.y;
			segment_notes notes = pseg-&gt;notes;
			curve_segment cseg;
			int k;

			if (options &amp; pco_for_stroke) {
			    /*
			     * When flattening for stroking, the flatness
			     * must apply to the outside of the resulting
			     * stroked region.  We approximate this by
			     * dividing the flatness by the ratio of the
			     * expanded bounding box to the original
			     * bounding box.  This is crude, but pretty
			     * simple to calculate, and produces reasonably
			     * good results.
			     */
			    fixed min01, max01, min23, max23;
			    fixed ex, ey, flat_x, flat_y;

#define SET_EXTENT(r, c0, c1, c2, c3)\
    BEGIN\
	if (c0 &lt; c1) min01 = c0, max01 = c1;\
	else         min01 = c1, max01 = c0;\
	if (c2 &lt; c3) min23 = c2, max23 = c3;\
	else         min23 = c3, max23 = c2;\
	r = max(max01, max23) - min(min01, min23);\
    END
			    SET_EXTENT(ex, x0, pc-&gt;p1.x, pc-&gt;p2.x, pc-&gt;pt.x);
			    SET_EXTENT(ey, y0, pc-&gt;p1.y, pc-&gt;p2.y, pc-&gt;pt.y);
#undef SET_EXTENT
			    /*
			     * We check for the degenerate case specially
			     * to avoid a division by zero.
			     */
			    if (ex == 0 || ey == 0)
				k = 0;
			    else {
				flat_x =
				    fixed_mult_quo(fixed_flatness, ex,
						   ex + expansion.x);
				flat_y =
				    fixed_mult_quo(fixed_flatness, ey,
						   ey + expansion.y);
				flat = min(flat_x, flat_y);
				k = gx_curve_log2_samples(x0, y0, pc, flat);
			    }
			} else
			    k = gx_curve_log2_samples(x0, y0, pc, flat);
			if (options &amp; pco_accurate) {
			    segment *start;
			    segment *end;

			    /*
			     * Add an extra line, which will become
			     * the tangent segment.
			     */
			    code = gx_path_add_line_notes(ppath, x0, y0,
							  notes);
			    if (code &lt; 0)
				break;
			    vd_lineto(x0, y0);
			    start = ppath-&gt;current_subpath-&gt;last;
			    notes |= sn_not_first;
			    cseg = *pc;
			    code = gx_subdivide_curve(ppath, k, &amp;cseg, notes);
			    if (code &lt; 0)
				break;
			    /*
			     * Adjust the first and last segments so that
			     * they line up with the tangents.
			     */
			    end = ppath-&gt;current_subpath-&gt;last;
			    vd_lineto(ppath-&gt;position.x, ppath-&gt;position.y);
			    if ((code = gx_path_add_line_notes(ppath,
							  ppath-&gt;position.x,
							  ppath-&gt;position.y,
					    pseg-&gt;notes | sn_not_first)) &lt; 0)
				break;
			    if (start-&gt;next-&gt;pt.x != pc-&gt;p1.x || start-&gt;next-&gt;pt.y != pc-&gt;p1.y)
				adjust_point_to_tangent(start, start-&gt;next, &amp;pc-&gt;p1);
			    else if (start-&gt;next-&gt;pt.x != pc-&gt;p2.x || start-&gt;next-&gt;pt.y != pc-&gt;p2.y)
				adjust_point_to_tangent(start, start-&gt;next, &amp;pc-&gt;p2);
			    else
				adjust_point_to_tangent(start, start-&gt;next, &amp;end-&gt;prev-&gt;pt);
			    if (end-&gt;prev-&gt;pt.x != pc-&gt;p2.x || end-&gt;prev-&gt;pt.y != pc-&gt;p2.y)
				adjust_point_to_tangent(end, end-&gt;prev, &amp;pc-&gt;p2);
			    else if (end-&gt;prev-&gt;pt.x != pc-&gt;p1.x || end-&gt;prev-&gt;pt.y != pc-&gt;p1.y)
				adjust_point_to_tangent(end, end-&gt;prev, &amp;pc-&gt;p1);
			    else
				adjust_point_to_tangent(end, end-&gt;prev, &amp;start-&gt;pt);
			} else {
			    cseg = *pc;
			    code = gx_subdivide_curve(ppath, k, &amp;cseg, notes);
			}
		    }
		    break;
		}
	    case s_line:
		code = gx_path_add_line_notes(ppath,
				       pseg-&gt;pt.x, pseg-&gt;pt.y, pseg-&gt;notes);
		vd_lineto(pseg-&gt;pt.x, pseg-&gt;pt.y);
		break;
	    case s_line_close:
		code = gx_path_close_subpath(ppath);
		vd_closepath;
		break;
	    default:		/* can't happen */
		code = gs_note_error(gs_error_unregistered);
	}
	if (code &lt; 0) {
	    gx_path_new(ppath);
	    return code;
	}
	pseg = pseg-&gt;next;
    }
    if (path_last_is_moveto(ppath_old))
	gx_path_add_point(ppath, ppath_old-&gt;position.x,
			  ppath_old-&gt;position.y);
    if (ppath_old-&gt;bbox_set) {
	if (ppath-&gt;bbox_set) {
	    ppath-&gt;bbox.p.x = min(ppath_old-&gt;bbox.p.x, ppath-&gt;bbox.p.x);
	    ppath-&gt;bbox.p.y = min(ppath_old-&gt;bbox.p.y, ppath-&gt;bbox.p.y);
	    ppath-&gt;bbox.q.x = max(ppath_old-&gt;bbox.q.x, ppath-&gt;bbox.q.x);
	    ppath-&gt;bbox.q.y = max(ppath_old-&gt;bbox.q.y, ppath-&gt;bbox.q.y);
	} else {
	    ppath-&gt;bbox_set = true;
	    ppath-&gt;bbox = ppath_old-&gt;bbox;
	}
    }
#ifdef DEBUG
    if (gs_debug_c('P'))
	gx_dump_path(ppath, "after reducing");
#endif
    return 0;
}

/*
 * Adjust one end of a line (the first or last line of a flattened curve)
 * so it falls on the curve tangent.  The closest point on the line from
 * (0,0) to (C,D) to a point (U,V) -- i.e., the point on the line at which
 * a perpendicular line from the point intersects it -- is given by
 *      T = (C*U + D*V) / (C^2 + D^2)
 *      (X,Y) = (C*T,D*T)
 * However, any smaller value of T will also work: the one we actually
 * use is 0.25 * the value we just derived.  We must check that
 * numerical instabilities don't lead to a negative value of T.
 */
private void
adjust_point_to_tangent(segment * pseg, const segment * next,
			const gs_fixed_point * p1)
{
    const fixed x0 = pseg-&gt;pt.x, y0 = pseg-&gt;pt.y;
    const fixed fC = p1-&gt;x - x0, fD = p1-&gt;y - y0;

    /*
     * By far the commonest case is that the end of the curve is
     * horizontal or vertical.  Check for this specially, because
     * we can handle it with far less work (and no floating point).
     */
    if (fC == 0) {
	/* Vertical tangent. */
	const fixed DT = arith_rshift(next-&gt;pt.y - y0, 2);

	if (fD == 0)
	    return;		/* anomalous case */
	if_debug1('2', "[2]adjusting vertical: DT = %g\n",
		  fixed2float(DT));
	if ((DT ^ fD) &gt; 0)
	    pseg-&gt;pt.y = DT + y0;
    } else if (fD == 0) {
	/* Horizontal tangent. */
	const fixed CT = arith_rshift(next-&gt;pt.x - x0, 2);

	if_debug1('2', "[2]adjusting horizontal: CT = %g\n",
		  fixed2float(CT));
	if ((CT ^ fC) &gt; 0)
	    pseg-&gt;pt.x = CT + x0;
    } else {
	/* General case. */
	const double C = fC, D = fD;
	double T = (C * (next-&gt;pt.x - x0) + D * (next-&gt;pt.y - y0)) /
	(C * C + D * D);

	if_debug3('2', "[2]adjusting: C = %g, D = %g, T = %g\n",
		  C, D, T);
	if (T &gt; 0) {
	    if (T &gt; 1) {
		/* Don't go outside the curve bounding box. */
		T = 1;
	    }
	    pseg-&gt;pt.x = arith_rshift((fixed) (C * T), 2) + x0;
	    pseg-&gt;pt.y = arith_rshift((fixed) (D * T), 2) + y0;
	}
    }
}

/* ---------------- Monotonic curves ---------------- */

/* Test whether a path is free of non-monotonic curves. */
bool
gx_path__check_curves(const gx_path * ppath, gx_path_copy_options options, fixed fixed_flat)
{
    const segment *pseg = (const segment *)(ppath-&gt;first_subpath);
    gs_fixed_point pt0;

    while (pseg) {
	switch (pseg-&gt;type) {
	    case s_start:
		{
		    const subpath *psub = (const subpath *)pseg;

		    /* Skip subpaths without curves. */
		    if (!psub-&gt;curve_count)
			pseg = psub-&gt;last;
		}
		break;
	    case s_curve:
		{
		    const curve_segment *pc = (const curve_segment *)pseg;

		    if (options &amp; pco_monotonize) {
			double t[2];
			int nz = gx_curve_monotonic_points(pt0.y,
					       pc-&gt;p1.y, pc-&gt;p2.y, pc-&gt;pt.y, t);

			if (nz != 0)
			    return false;
			nz = gx_curve_monotonic_points(pt0.x,
					       pc-&gt;p1.x, pc-&gt;p2.x, pc-&gt;pt.x, t);
			if (nz != 0)
			    return false;
		    }
		    if (options &amp; pco_small_curves) {
			fixed ax, bx, cx, ay, by, cy; 
			int k = gx_curve_log2_samples(pt0.x, pt0.y, pc, fixed_flat);

			if(!curve_coeffs_ranged(pt0.x, pc-&gt;p1.x, pc-&gt;p2.x, pc-&gt;pt.x,
				pt0.y, pc-&gt;p1.y, pc-&gt;p2.y, pc-&gt;pt.y,
				&amp;ax, &amp;bx, &amp;cx, &amp;ay, &amp;by, &amp;cy, k))
			    return false;
		    }
		}
		break;
	    default:
		;
	}
	pt0 = pseg-&gt;pt;
	pseg = pseg-&gt;next;
    }
    return true;
}

/* Monotonize a curve, by splitting it if necessary. */
/* In the worst case, this could split the curve into 9 pieces. */
int
gx_curve_monotonize(gx_path * ppath, const curve_segment * pc)
{
    fixed x0 = ppath-&gt;position.x, y0 = ppath-&gt;position.y;
    segment_notes notes = pc-&gt;notes;
    double t[4], tt = 1, tp;
    int c[4];
    int n0, n1, n, i, j, k = 0;
    fixed ax, bx, cx, ay, by, cy, v01, v12;
    fixed px, py, qx, qy, rx, ry, sx, sy;
    const double delta = 0.0000001;

    /* Roots of the derivative : */
    n0 = gx_curve_monotonic_points(x0, pc-&gt;p1.x, pc-&gt;p2.x, pc-&gt;pt.x, t);
    n1 = gx_curve_monotonic_points(y0, pc-&gt;p1.y, pc-&gt;p2.y, pc-&gt;pt.y, t + n0);
    n = n0 + n1;
    if (n == 0)
	return gx_path_add_curve_notes(ppath, pc-&gt;p1.x, pc-&gt;p1.y,
		pc-&gt;p2.x, pc-&gt;p2.y, pc-&gt;pt.x, pc-&gt;pt.y, notes);
    if (n0 &gt; 0)
	c[0] = 1;
    if (n0 &gt; 1)
	c[1] = 1;
    if (n1 &gt; 0)
	c[n0] = 2;
    if (n1 &gt; 1)
	c[n0 + 1] = 2;
    /* Order roots : */
    for (i = 0; i &lt; n; i++)
	for (j = i + 1; j &lt; n; j++)
	    if (t[i] &gt; t[j]) {
		int w;
		double v = t[i]; t[i] = t[j]; t[j] = v;
		w = c[i]; c[i] = c[j]; c[j] = w;
	    }
    /* Drop roots near zero : */
    for (k = 0; k &lt; n; k++)
	if (t[k] &gt;= delta)
	    break;
    /* Merge close roots, and drop roots at 1 : */
    if (t[n - 1] &gt; 1 - delta)
	n--;
    for (i = k + 1, j = k; i &lt; n &amp;&amp; t[k] &lt; 1 - delta; i++)
	if (any_abs(t[i] - t[j]) &lt; delta) {
	    t[j] = (t[j] + t[i]) / 2; /* Unlikely 3 roots are close. */
	    c[j] |= c[i];
	} else {
	    j++;
	    t[j] = t[i];
	    c[j] = c[i];
	}
    n = j + 1;
    /* Do split : */
    curve_points_to_coefficients(x0, pc-&gt;p1.x, pc-&gt;p2.x, pc-&gt;pt.x, ax, bx, cx, v01, v12);
    curve_points_to_coefficients(y0, pc-&gt;p1.y, pc-&gt;p2.y, pc-&gt;pt.y, ay, by, cy, v01, v12);
    ax *= 3, bx *= 2; /* Coefficients of the derivative. */
    ay *= 3, by *= 2;
    px = x0;
    py = y0;
    qx = (fixed)((pc-&gt;p1.x - px) * t[0] + 0.5);
    qy = (fixed)((pc-&gt;p1.y - py) * t[0] + 0.5);
    tp = 0;
    for (i = k; i &lt; n; i++) {
	double ti = t[i];
	double t2 = ti * ti, t3 = t2 * ti;
	double omt = 1 - ti, omt2 = omt * omt, omt3 = omt2 * omt;
	double x = x0 * omt3 + 3 * pc-&gt;p1.x * omt2 * ti + 3 * pc-&gt;p2.x * omt * t2 + pc-&gt;pt.x * t3;
	double y = y0 * omt3 + 3 * pc-&gt;p1.y * omt2 * ti + 3 * pc-&gt;p2.y * omt * t2 + pc-&gt;pt.y * t3;
	double ddx = (c[i] &amp; 1 ? 0 : ax * t2 + bx * ti + cx); /* Suppress noize. */
	double ddy = (c[i] &amp; 2 ? 0 : ay * t2 + by * ti + cy);
	fixed dx = (fixed)(ddx + 0.5);
	fixed dy = (fixed)(ddy + 0.5);
	int code;

	tt = (i + 1 &lt; n ? t[i + 1] : 1) - ti;
	rx = (fixed)(dx * (t[i] - tp) / 3 + 0.5);
	ry = (fixed)(dy * (t[i] - tp) / 3 + 0.5);
	sx = (fixed)(x + 0.5);
	sy = (fixed)(y + 0.5);
	/* Suppress the derivative sign noize near a beak : */
	if ((double)(sx - px) * qx + (double)(sy - py) * qy &lt; 0)
	    qx = -qx, qy = -qy;
	if ((double)(sx - px) * rx + (double)(sy - py) * ry &lt; 0)
	    rx = -rx, ry = -qy;
	/* Do add : */
	code = gx_path_add_curve_notes(ppath, px + qx, py + qy, sx - rx, sy - ry, sx, sy, notes);
	if (code &lt; 0)
	    return code;
	notes |= sn_not_first;
	px = sx;
	py = sy;
	qx = (fixed)(dx * tt / 3 + 0.5);
	qy = (fixed)(dy * tt / 3 + 0.5);
	tp = t[i];
    }
    sx = pc-&gt;pt.x;
    sy = pc-&gt;pt.y;
    rx = (fixed)((pc-&gt;pt.x - pc-&gt;p2.x) * tt + 0.5);
    ry = (fixed)((pc-&gt;pt.y - pc-&gt;p2.y) * tt + 0.5);
    /* Suppress the derivative sign noize near peaks : */
    if ((double)(sx - px) * qx + (double)(sy - py) * qy &lt; 0)
	qx = -qx, qy = -qy;
    if ((double)(sx - px) * rx + (double)(sy - py) * ry &lt; 0)
	rx = -rx, ry = -qy;
    return gx_path_add_curve_notes(ppath, px + qx, py + qy, sx - rx, sy - ry, sx, sy, notes);
}

/*
 * Split a curve if necessary into pieces that are monotonic in X or Y as a
 * function of the curve parameter t.  This allows us to rasterize curves
 * directly without pre-flattening.  This takes a fair amount of analysis....
 * Store the values of t of the split points in pst[0] and pst[1].  Return
 * the number of split points (0, 1, or 2).
 */
int
gx_curve_monotonic_points(fixed v0, fixed v1, fixed v2, fixed v3,
			  double pst[2])
{
    /*
       Let
       v(t) = a*t^3 + b*t^2 + c*t + d, 0 &lt;= t &lt;= 1.
       Then
       dv(t) = 3*a*t^2 + 2*b*t + c.
       v(t) has a local minimum or maximum (or inflection point)
       precisely where dv(t) = 0.  Now the roots of dv(t) = 0 (i.e.,
       the zeros of dv(t)) are at
       t =  ( -2*b +/- sqrt(4*b^2 - 12*a*c) ) / 6*a
       =    ( -b +/- sqrt(b^2 - 3*a*c) ) / 3*a
       (Note that real roots exist iff b^2 &gt;= 3*a*c.)
       We want to know if these lie in the range (0..1).
       (The endpoints don't count.)  Call such a root a "valid zero."
       Since computing the roots is expensive, we would like to have
       some cheap tests to filter out cases where they don't exist
       (i.e., where the curve is already monotonic).
     */
    fixed v01, v12, a, b, c, b2, a3;
    fixed dv_end, b2abs, a3abs;

    curve_points_to_coefficients(v0, v1, v2, v3, a, b, c, v01, v12);
    b2 = b &lt;&lt; 1;
    a3 = (a &lt;&lt; 1) + a;
    /*
       If a = 0, the only possible zero is t = -c / 2*b.
       This zero is valid iff sign(c) != sign(b) and 0 &lt; |c| &lt; 2*|b|.
     */
    if (a == 0) {
	if ((b ^ c) &lt; 0 &amp;&amp; any_abs(c) &lt; any_abs(b2) &amp;&amp; c != 0) {
	    *pst = (double)(-c) / b2;
	    return 1;
	} else
	    return 0;
    }
    /*
       Iff a curve is horizontal at t = 0, c = 0.  In this case,
       there can be at most one other zero, at -2*b / 3*a.
       This zero is valid iff sign(a) != sign(b) and 0 &lt; 2*|b| &lt; 3*|a|.
     */
    if (c == 0) {
	if ((a ^ b) &lt; 0 &amp;&amp; any_abs(b2) &lt; any_abs(a3) &amp;&amp; b != 0) {
	    *pst = (double)(-b2) / a3;
	    return 1;
	} else
	    return 0;
    }
    /*
       Similarly, iff a curve is horizontal at t = 1, 3*a + 2*b + c = 0.
       In this case, there can be at most one other zero,
       at -1 - 2*b / 3*a, iff sign(a) != sign(b) and 1 &lt; -2*b / 3*a &lt; 2,
       i.e., 3*|a| &lt; 2*|b| &lt; 6*|a|.
     */
    else if ((dv_end = a3 + b2 + c) == 0) {
	if ((a ^ b) &lt; 0 &amp;&amp;
	    (b2abs = any_abs(b2)) &gt; (a3abs = any_abs(a3)) &amp;&amp;
	    b2abs &lt; a3abs &lt;&lt; 1
	    ) {
	    *pst = (double)(-b2 - a3) / a3;
	    return 1;
	} else
	    return 0;
    }
    /*
       If sign(dv_end) != sign(c), at least one valid zero exists,
       since dv(0) and dv(1) have opposite signs and hence
       dv(t) must be zero somewhere in the interval [0..1].
     */
    else if ((dv_end ^ c) &lt; 0);
    /*
       If sign(a) = sign(b), no valid zero exists,
       since dv is monotonic on [0..1] and has the same sign
       at both endpoints.
     */
    else if ((a ^ b) &gt;= 0)
	return 0;
    /*
       Otherwise, dv(t) may be non-monotonic on [0..1]; it has valid zeros
       iff its sign anywhere in this interval is different from its sign
       at the endpoints, which occurs iff it has an extremum in this
       interval and the extremum is of the opposite sign from c.
       To find this out, we look for the local extremum of dv(t)
       by observing
       d2v(t) = 6*a*t + 2*b
       which has a zero only at
       t1 = -b / 3*a
       Now if t1 &lt;= 0 or t1 &gt;= 1, no valid zero exists.
       Note that we just determined that sign(a) != sign(b), so we know t1 &gt; 0.
     */
    else if (any_abs(b) &gt;= any_abs(a3))
	return 0;
    /*
       Otherwise, we just go ahead with the computation of the roots,
       and test them for being in the correct range.  Note that a valid
       zero is an inflection point of v(t) iff d2v(t) = 0; we don't
       bother to check for this case, since it's rare.
     */
    {
	double nbf = (double)(-b);
	double a3f = (double)a3;
	double radicand = nbf * nbf - a3f * c;

	if (radicand &lt; 0) {
	    if_debug1('2', "[2]negative radicand = %g\n", radicand);
	    return 0;
	} {
	    double root = sqrt(radicand);
	    int nzeros = 0;
	    double z = (nbf - root) / a3f;

	    /*
	     * We need to return the zeros in the correct order.
	     * We know that root is non-negative, but a3f may be either
	     * positive or negative, so we need to check the ordering
	     * explicitly.
	     */
	    if_debug2('2', "[2]zeros at %g, %g\n", z, (nbf + root) / a3f);
	    if (z &gt; 0 &amp;&amp; z &lt; 1)
		*pst = z, nzeros = 1;
	    if (root != 0) {
		z = (nbf + root) / a3f;
		if (z &gt; 0 &amp;&amp; z &lt; 1) {
		    if (nzeros &amp;&amp; a3f &lt; 0)	/* order is reversed */
			pst[1] = *pst, *pst = z;
		    else
			pst[nzeros] = z;
		    nzeros++;
		}
	    }
	    return nzeros;
	}
    }
}

/* ---------------- Path optimization for the filling algorithm. ---------------- */

private bool
find_contacting_segments(const subpath *sp0, segment *sp0last, 
			 const subpath *sp1, segment *sp1last, 
			 segment **sc0, segment **sc1)
{
    segment *s0, *s1;
    const segment *s0s, *s1s;
    int count0, count1, search_limit = 50;
    int min_length = fixed_1 * 1;

    /* This is a simplified algorithm, which only checks for quazi-colinear vertical lines.
       "Quazi-vertical" means dx &lt;= 1 &amp;&amp; dy &gt;= min_length . */
    /* To avoid a big unuseful expence of the processor time,
       we search the first subpath from the end
       (assuming that it was recently merged near the end), 
       and restrict the search with search_limit segments 
       against a quadratic scanning of two long subpaths. 
       Thus algorithm is not necessary finds anything contacting.
       Instead it either quickly finds something, or maybe not. */
    for (s0 = sp0last, count0 = 0; count0 &lt; search_limit &amp;&amp; s0 != (segment *)sp0; s0 = s0-&gt;prev, count0++) {
	s0s = s0-&gt;prev;
	if (s0-&gt;type == s_line &amp;&amp; (s0s-&gt;pt.x == s0-&gt;pt.x ||
	    (any_abs(s0s-&gt;pt.x - s0-&gt;pt.x) == 1 &amp;&amp; any_abs(s0s-&gt;pt.y - s0-&gt;pt.y) &gt; min_length))) {
	    for (s1 = sp1last, count1 = 0; count1 &lt; search_limit &amp;&amp; s1 != (segment *)sp1; s1 = s1-&gt;prev, count1++) {
		s1s = s1-&gt;prev;
		if (s1-&gt;type == s_line &amp;&amp; (s1s-&gt;pt.x == s1-&gt;pt.x || 
		    (any_abs(s1s-&gt;pt.x - s1-&gt;pt.x) == 1 &amp;&amp; any_abs(s1s-&gt;pt.y - s1-&gt;pt.y) &gt; min_length))) {
		    if (s0s-&gt;pt.x == s1s-&gt;pt.x || s0-&gt;pt.x == s1-&gt;pt.x || s0-&gt;pt.x == s1s-&gt;pt.x || s0s-&gt;pt.x == s1-&gt;pt.x) {
			if (s0s-&gt;pt.y &lt; s0-&gt;pt.y &amp;&amp; s1s-&gt;pt.y &gt; s1-&gt;pt.y) {
			    fixed y0 = max(s0s-&gt;pt.y, s1-&gt;pt.y);
			    fixed y1 = min(s0-&gt;pt.y, s1s-&gt;pt.y);

			    if (y0 &lt;= y1) {
				*sc0 = s0;
				*sc1 = s1;
				return true;
			    }
			}
			if (s0s-&gt;pt.y &gt; s0-&gt;pt.y &amp;&amp; s1s-&gt;pt.y &lt; s1-&gt;pt.y) {
			    fixed y0 = max(s0-&gt;pt.y, s1s-&gt;pt.y);
			    fixed y1 = min(s0s-&gt;pt.y, s1-&gt;pt.y);

			    if (y0 &lt;= y1) {
				*sc0 = s0;
				*sc1 = s1;
				return true;
			    }
			}
		    }
		}
	    }
	}
    }
    return false;
}

int
gx_path_merge_contacting_contours(gx_path *ppath)
{
    /* Now this is a simplified algorithm,
       which merge only contours by a common quazi-vertical line. */
    int window = 5/* max spot holes */ * 6/* segments per subpath */;
    subpath *sp0 = ppath-&gt;segments-&gt;contents.subpath_first;

    for (; sp0 != NULL; sp0 = (subpath *)sp0-&gt;last-&gt;next) {
	segment *sp0last = sp0-&gt;last;
	subpath *sp1 = (subpath *)sp0last-&gt;next, *spnext;
	subpath *sp1p = sp0;
	int count;
	
	for (count = 0; sp1 != NULL &amp;&amp; count &lt; window; sp1 = spnext, count++) {
	    segment *sp1last = sp1-&gt;last;
	    segment *sc0, *sc1;
		
	    spnext = (subpath *)sp1last-&gt;next;
	    if (find_contacting_segments(sp0, sp0last, sp1, sp1last, &amp;sc0, &amp;sc1)) {
		/* Detach the subpath 1 from the path: */
		sp1-&gt;prev-&gt;next = sp1last-&gt;next;
		if (sp1last-&gt;next != NULL)
		    sp1last-&gt;next-&gt;prev = sp1-&gt;prev;
		sp1-&gt;prev = 0;
		sp1last-&gt;next = 0;
		/* Change 'closepath' of the subpath 1 to a line (maybe degenerate) : */
		if (sp1last-&gt;type == s_line_close)
		    sp1last-&gt;type = s_line;
		/* Rotate the subpath 1 to sc1 : */
		{   segment *old_first = sp1-&gt;next;

		    /* Detach s_start and make a loop : */
		    sp1last-&gt;next = old_first;
		    old_first-&gt;prev = sp1last;
		    /* Unlink before sc1 : */
		    sp1last = sc1-&gt;prev;
		    sc1-&gt;prev-&gt;next = 0;
		    sc1-&gt;prev = 0; /* Safety. */
		    /* sp1 is not longer in use. Free it : */
		    if (ppath-&gt;segments-&gt;contents.subpath_current == sp1) {
			ppath-&gt;segments-&gt;contents.subpath_current = sp1p;
		    }
		    gs_free_object(ppath-&gt;memory, sp1, "gx_path_merge_contacting_contours");
		    sp1 = 0; /* Safety. */
		}
		/* Insert the subpath 1 into the subpath 0 before sc0 :*/
		sc0-&gt;prev-&gt;next = sc1;
		sc1-&gt;prev = sc0-&gt;prev;
		sp1last-&gt;next = sc0;
		sc0-&gt;prev = sp1last;
		/* Remove degenearte "bridge" segments : (fixme: Not done due to low importance). */
		/* Edit the subpath count : */
		ppath-&gt;subpath_count--;
	    } else
		sp1p = sp1;
	}
    }
    return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

