<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxpflat.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxpflat.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1997, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxpflat.c,v 1.45 2005/08/10 19:36:11 igor Exp $ */
/* Path flattening algorithms */
#include "string_.h"
#include "gx.h"
#include "gxarith.h"
#include "gxfixed.h"
#include "gzpath.h"
#include "memory_.h"
#include "vdtrace.h"
#include &lt;assert.h&gt;

/* ---------------- Curve flattening ---------------- */

/*
 * To calculate how many points to sample along a path in order to
 * approximate it to the desired degree of flatness, we define
 *      dist((x,y)) = abs(x) + abs(y);
 * then the number of points we need is
 *      N = 1 + sqrt(3/4 * D / flatness),
 * where
 *      D = max(dist(p0 - 2*p1 + p2), dist(p1 - 2*p2 + p3)).
 * Since we are going to use a power of 2 for the number of intervals,
 * we can avoid the square root by letting
 *      N = 1 + 2^(ceiling(log2(3/4 * D / flatness) / 2)).
 * (Reference: DEC Paris Research Laboratory report #1, May 1989.)
 *
 * We treat two cases specially.  First, if the curve is very
 * short, we halve the flatness, to avoid turning short shallow curves
 * into short straight lines.  Second, if the curve forms part of a
 * character (indicated by flatness = 0), we let
 *      N = 1 + 2 * max(abs(x3-x0), abs(y3-y0)).
 * This is probably too conservative, but it produces good results.
 */
int
gx_curve_log2_samples(fixed x0, fixed y0, const curve_segment * pc,
		      fixed fixed_flat)
{
    fixed
	x03 = pc-&gt;pt.x - x0,
	y03 = pc-&gt;pt.y - y0;
    int k;

    if (x03 &lt; 0)
	x03 = -x03;
    if (y03 &lt; 0)
	y03 = -y03;
    if ((x03 | y03) &lt; int2fixed(16))
	fixed_flat &gt;&gt;= 1;
    if (fixed_flat == 0) {	/* Use the conservative method. */
	fixed m = max(x03, y03);

	for (k = 1; m &gt; fixed_1;)
	    k++, m &gt;&gt;= 1;
    } else {
	const fixed
	      x12 = pc-&gt;p1.x - pc-&gt;p2.x, y12 = pc-&gt;p1.y - pc-&gt;p2.y, 
	      dx0 = x0 - pc-&gt;p1.x - x12, dy0 = y0 - pc-&gt;p1.y - y12,
	      dx1 = x12 - pc-&gt;p2.x + pc-&gt;pt.x, dy1 = y12 - pc-&gt;p2.y + pc-&gt;pt.y, 
	      adx0 = any_abs(dx0), ady0 = any_abs(dy0), 
	      adx1 = any_abs(dx1), ady1 = any_abs(dy1);
	fixed
	    d = max(adx0, adx1) + max(ady0, ady1);
	/*
	 * The following statement is split up to work around a
	 * bug in the gcc 2.7.2 optimizer on H-P RISC systems.
	 */
	uint qtmp = d - (d &gt;&gt; 2) /* 3/4 * D */ +fixed_flat - 1;
	uint q = qtmp / fixed_flat;

	if_debug6('2', "[2]d01=%g,%g d12=%g,%g d23=%g,%g\n",
		  fixed2float(pc-&gt;p1.x - x0), fixed2float(pc-&gt;p1.y - y0),
		  fixed2float(-x12), fixed2float(-y12),
		  fixed2float(pc-&gt;pt.x - pc-&gt;p2.x), fixed2float(pc-&gt;pt.y - pc-&gt;p2.y));
	if_debug2('2', "     D=%f, flat=%f,",
		  fixed2float(d), fixed2float(fixed_flat));
	/* Now we want to set k = ceiling(log2(q) / 2). */
	for (k = 0; q &gt; 1;)
	    k++, q = (q + 3) &gt;&gt; 2;
	if_debug1('2', " k=%d\n", k);
    }
    return k;
}

/*
 * Split a curve segment into two pieces at the (parametric) midpoint.
 * Algorithm is from "The Beta2-split: A special case of the Beta-spline
 * Curve and Surface Representation," B. A. Barsky and A. D. DeRose, IEEE,
 * 1985, courtesy of Crispin Goswell.
 */
private void
split_curve_midpoint(fixed x0, fixed y0, const curve_segment * pc,
		     curve_segment * pc1, curve_segment * pc2)
{				/*
				 * We have to define midpoint carefully to avoid overflow.
				 * (If it overflows, something really pathological is going
				 * on, but we could get infinite recursion that way....)
				 */
#define midpoint(a,b)\
  (arith_rshift_1(a) + arith_rshift_1(b) + (((a) | (b)) &amp; 1))
    fixed x12 = midpoint(pc-&gt;p1.x, pc-&gt;p2.x);
    fixed y12 = midpoint(pc-&gt;p1.y, pc-&gt;p2.y);

    /*
     * pc1 or pc2 may be the same as pc, so we must be a little careful
     * about the order in which we store the results.
     */
    pc1-&gt;p1.x = midpoint(x0, pc-&gt;p1.x);
    pc1-&gt;p1.y = midpoint(y0, pc-&gt;p1.y);
    pc2-&gt;p2.x = midpoint(pc-&gt;p2.x, pc-&gt;pt.x);
    pc2-&gt;p2.y = midpoint(pc-&gt;p2.y, pc-&gt;pt.y);
    pc1-&gt;p2.x = midpoint(pc1-&gt;p1.x, x12);
    pc1-&gt;p2.y = midpoint(pc1-&gt;p1.y, y12);
    pc2-&gt;p1.x = midpoint(x12, pc2-&gt;p2.x);
    pc2-&gt;p1.y = midpoint(y12, pc2-&gt;p2.y);
    if (pc2 != pc)
	pc2-&gt;pt.x = pc-&gt;pt.x,
	    pc2-&gt;pt.y = pc-&gt;pt.y;
    pc1-&gt;pt.x = midpoint(pc1-&gt;p2.x, pc2-&gt;p1.x);
    pc1-&gt;pt.y = midpoint(pc1-&gt;p2.y, pc2-&gt;p1.y);
#undef midpoint
}

private inline void
print_points(const gs_fixed_point *points, int count)
{
#ifdef DEBUG    
    int i;

    if (!gs_debug_c('3'))
	return;
    for (i = 0; i &lt; count; i++)
	if_debug2('3', "[3]out x=%d y=%d\n", points[i].x, points[i].y);
#endif
}


bool
curve_coeffs_ranged(fixed x0, fixed x1, fixed x2, fixed x3, 
		    fixed y0, fixed y1, fixed y2, fixed y3, 
		    fixed *ax, fixed *bx, fixed *cx, 
		    fixed *ay, fixed *by, fixed *cy, 
		    int k)
{
    fixed x01, x12, y01, y12;

    curve_points_to_coefficients(x0, x1, x2, x3, 
				 *ax, *bx, *cx, x01, x12);
    curve_points_to_coefficients(y0, y1, y2, y3, 
				 *ay, *by, *cy, y01, y12);
#   define max_fast (max_fixed / 6)
#   define min_fast (-max_fast)
#   define in_range(v) (v &lt; max_fast &amp;&amp; v &gt; min_fast)
    if (k &gt; k_sample_max ||
	!in_range(*ax) || !in_range(*ay) ||
	!in_range(*bx) || !in_range(*by) ||
	!in_range(*cx) || !in_range(*cy)
	)
	return false;
#undef max_fast
#undef min_fast
#undef in_range
    return true;
}

/*  Initialize the iterator. 
    Momotonic curves with non-zero length are only allowed.
 */
bool
gx_flattened_iterator__init(gx_flattened_iterator *this, 
	    fixed x0, fixed y0, const curve_segment *pc, int k)
{
    /* Note : Immediately after the ininialization it keeps an invalid (zero length) segment. */
    fixed x1, y1, x2, y2;
    const int k2 = k &lt;&lt; 1, k3 = k2 + k;
    fixed bx2, by2, ax6, ay6;

    x1 = pc-&gt;p1.x;
    y1 = pc-&gt;p1.y;
    x2 = pc-&gt;p2.x;
    y2 = pc-&gt;p2.y;
    this-&gt;x0 = this-&gt;lx0 = this-&gt;lx1 = x0;
    this-&gt;y0 = this-&gt;ly0 = this-&gt;ly1 = y0;
    this-&gt;x3 = pc-&gt;pt.x;
    this-&gt;y3 = pc-&gt;pt.y;
    if (!curve_coeffs_ranged(this-&gt;x0, x1, x2, this-&gt;x3,
			     this-&gt;y0, y1, y2, this-&gt;y3, 
			     &amp;this-&gt;ax, &amp;this-&gt;bx, &amp;this-&gt;cx, 
			     &amp;this-&gt;ay, &amp;this-&gt;by, &amp;this-&gt;cy, k))
	return false;
    this-&gt;curve = true;
    vd_curve(this-&gt;x0, this-&gt;y0, x1, y1, x2, y2, this-&gt;x3, this-&gt;y3, 0, RGB(255, 255, 255));
    this-&gt;k = k;
#   ifdef DEBUG
	if (gs_debug_c('3')) {
	    dlprintf4("[3]x0=%f y0=%f x1=%f y1=%f\n",
		      fixed2float(this-&gt;x0), fixed2float(this-&gt;y0),
		      fixed2float(x1), fixed2float(y1));
	    dlprintf5("   x2=%f y2=%f x3=%f y3=%f  k=%d\n",
		      fixed2float(x2), fixed2float(y2),
		      fixed2float(this-&gt;x3), fixed2float(this-&gt;y3), this-&gt;k);
	}
#   endif
    if (k == -1) {
	/* A special hook for gx_subdivide_curve_rec.
	   Only checked the range. 
	   Returning with no initialization. */
	return true;
    }
    this-&gt;rmask = (1 &lt;&lt; k3) - 1;
    this-&gt;i = (1 &lt;&lt; k);
    this-&gt;rx = this-&gt;ry = 0;
    if_debug6('3', "[3]ax=%f bx=%f cx=%f\n   ay=%f by=%f cy=%f\n",
	      fixed2float(this-&gt;ax), fixed2float(this-&gt;bx), fixed2float(this-&gt;cx),
	      fixed2float(this-&gt;ay), fixed2float(this-&gt;by), fixed2float(this-&gt;cy));
    bx2 = this-&gt;bx &lt;&lt; 1;
    by2 = this-&gt;by &lt;&lt; 1;
    ax6 = ((this-&gt;ax &lt;&lt; 1) + this-&gt;ax) &lt;&lt; 1;
    ay6 = ((this-&gt;ay &lt;&lt; 1) + this-&gt;ay) &lt;&lt; 1;
    this-&gt;idx = arith_rshift(this-&gt;cx, this-&gt;k);
    this-&gt;idy = arith_rshift(this-&gt;cy, this-&gt;k);
    this-&gt;rdx = ((uint)this-&gt;cx &lt;&lt; k2) &amp; this-&gt;rmask;
    this-&gt;rdy = ((uint)this-&gt;cy &lt;&lt; k2) &amp; this-&gt;rmask;
    /* bx/y terms */
    this-&gt;id2x = arith_rshift(bx2, k2);
    this-&gt;id2y = arith_rshift(by2, k2);
    this-&gt;rd2x = ((uint)bx2 &lt;&lt; this-&gt;k) &amp; this-&gt;rmask;
    this-&gt;rd2y = ((uint)by2 &lt;&lt; this-&gt;k) &amp; this-&gt;rmask;
#   define adjust_rem(r, q, rmask) if ( r &gt; rmask ) q ++, r &amp;= rmask
    /* We can compute all the remainders as ints, */
    /* because we know they don't exceed M. */
    /* cx/y terms */
    this-&gt;idx += arith_rshift_1(this-&gt;id2x);
    this-&gt;idy += arith_rshift_1(this-&gt;id2y);
    this-&gt;rdx += ((uint)this-&gt;bx &lt;&lt; this-&gt;k) &amp; this-&gt;rmask,
    this-&gt;rdy += ((uint)this-&gt;by &lt;&lt; this-&gt;k) &amp; this-&gt;rmask;
    adjust_rem(this-&gt;rdx, this-&gt;idx, this-&gt;rmask);
    adjust_rem(this-&gt;rdy, this-&gt;idy, this-&gt;rmask);
    /* ax/y terms */
    this-&gt;idx += arith_rshift(this-&gt;ax, k3);
    this-&gt;idy += arith_rshift(this-&gt;ay, k3);
    this-&gt;rdx += (uint)this-&gt;ax &amp; this-&gt;rmask;
    this-&gt;rdy += (uint)this-&gt;ay &amp; this-&gt;rmask;
    adjust_rem(this-&gt;rdx, this-&gt;idx, this-&gt;rmask);
    adjust_rem(this-&gt;rdy, this-&gt;idy, this-&gt;rmask);
    this-&gt;id2x += this-&gt;id3x = arith_rshift(ax6, k3);
    this-&gt;id2y += this-&gt;id3y = arith_rshift(ay6, k3);
    this-&gt;rd2x += this-&gt;rd3x = (uint)ax6 &amp; this-&gt;rmask,
    this-&gt;rd2y += this-&gt;rd3y = (uint)ay6 &amp; this-&gt;rmask;
    adjust_rem(this-&gt;rd2x, this-&gt;id2x, this-&gt;rmask);
    adjust_rem(this-&gt;rd2y, this-&gt;id2y, this-&gt;rmask);
#   undef adjust_rem
    return true;
}

private inline bool 
check_diff_overflow(fixed v0, fixed v1)
{
    if (v0 &lt; v1) {
	if (v1 - v0 &lt; 0)
	    return true;
    } else {
	if (v0 - v1 &lt; 0)
	    return true;
    }
    return false;
}

/*  Initialize the iterator with a line. */
bool
gx_flattened_iterator__init_line(gx_flattened_iterator *this, 
	    fixed x0, fixed y0, fixed x1, fixed y1)
{
    bool ox = check_diff_overflow(x0, x1);
    bool oy = check_diff_overflow(y0, y1);

    this-&gt;x0 = this-&gt;lx0 = this-&gt;lx1 = x0;
    this-&gt;y0 = this-&gt;ly0 = this-&gt;ly1 = y0;
    this-&gt;x3 = x1;
    this-&gt;y3 = y1;
    if (ox || oy) {
	/* Subdivide a long line into 2 segments, because the filling algorithm 
	   and the stroking algorithm need to compute differences 
	   of coordinates of end points. */
	/* Note : the result of subdivision may be not strongly colinear. */
	this-&gt;ax = this-&gt;bx = 0;
	this-&gt;ay = this-&gt;by = 0;
	this-&gt;cx = (ox ? (x1 &gt;&gt; 1) - (x0 &gt;&gt; 1) : (x1 - x0) / 2);
	this-&gt;cy = (oy ? (y1 &gt;&gt; 1) - (y0 &gt;&gt; 1) : (y1 - y0) / 2);
	this-&gt;k = 1;
	this-&gt;i = 2;
    } else {
	this-&gt;k = 0;
	this-&gt;i = 1;
    }
    this-&gt;curve = false;
    return true;
}

#ifdef DEBUG
private inline void
gx_flattened_iterator__print_state(gx_flattened_iterator *this)
{
    if (!gs_debug_c('3'))
	return;
    dlprintf4("[3]dx=%f+%d, dy=%f+%d\n",
	      fixed2float(this-&gt;idx), this-&gt;rdx,
	      fixed2float(this-&gt;idy), this-&gt;rdy);
    dlprintf4("   d2x=%f+%d, d2y=%f+%d\n",
	      fixed2float(this-&gt;id2x), this-&gt;rd2x,
	      fixed2float(this-&gt;id2y), this-&gt;rd2y);
    dlprintf4("   d3x=%f+%d, d3y=%f+%d\n",
	      fixed2float(this-&gt;id3x), this-&gt;rd3x,
	      fixed2float(this-&gt;id3y), this-&gt;rd3y);
}
#endif

/* Move to the next segment and store it to this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1 .
 * Return true iff there exist more segments.
 */
bool
gx_flattened_iterator__next(gx_flattened_iterator *this)
{
    /*
     * We can compute successive values by finite differences,
     * using the formulas:
     x(t) =
     a*t^3 + b*t^2 + c*t + d =&gt;
     dx(t) = x(t+e)-x(t) =
     a*(3*t^2*e + 3*t*e^2 + e^3) + b*(2*t*e + e^2) + c*e =
     (3*a*e)*t^2 + (3*a*e^2 + 2*b*e)*t + (a*e^3 + b*e^2 + c*e) =&gt;
     d2x(t) = dx(t+e)-dx(t) =
     (3*a*e)*(2*t*e + e^2) + (3*a*e^2 + 2*b*e)*e =
     (6*a*e^2)*t + (6*a*e^3 + 2*b*e^2) =&gt;
     d3x(t) = d2x(t+e)-d2x(t) =
     6*a*e^3;
     x(0) = d, dx(0) = (a*e^3 + b*e^2 + c*e),
     d2x(0) = 6*a*e^3 + 2*b*e^2;
     * In these formulas, e = 1/2^k; of course, there are separate
     * computations for the x and y values.
     *
     * There is a tradeoff in doing the above computation in fixed
     * point.  If we separate out the constant term (d) and require that
     * all the other values fit in a long, then on a 32-bit machine with
     * 12 bits of fraction in a fixed, k = 4 implies a maximum curve
     * size of 128 pixels; anything larger requires subdividing the
     * curve.  On the other hand, doing the computations in explicit
     * double precision slows down the loop by a factor of 3 or so.  We

     * found to our surprise that the latter is actually faster, because
     * the additional subdivisions cost more than the slower loop.
     *
     * We represent each quantity as I+R/M, where I is an "integer" and
     * the "remainder" R lies in the range 0 &lt;= R &lt; M=2^(3*k).  Note
     * that R may temporarily exceed M; for this reason, we require that
     * M have at least one free high-order bit.  To reduce the number of
     * variables, we don't actually compute M, only M-1 (rmask).  */
    fixed x = this-&gt;lx1, y = this-&gt;ly1;

    this-&gt;lx0 = this-&gt;lx1;
    this-&gt;ly0 = this-&gt;ly1;
    /* Fast check for N == 3, a common special case for small characters. */
    if (this-&gt;k &lt;= 1) {
	--this-&gt;i;
	if (this-&gt;i == 0)
	    goto last;
#	define poly2(a,b,c) arith_rshift_1(arith_rshift_1(arith_rshift_1(a) + b) + c)
	x += poly2(this-&gt;ax, this-&gt;bx, this-&gt;cx);
	y += poly2(this-&gt;ay, this-&gt;by, this-&gt;cy);
#	undef poly2
	if_debug2('3', "[3]dx=%f, dy=%f\n",
		  fixed2float(x - this-&gt;x0), fixed2float(y - this-&gt;y0));
	if_debug5('3', "[3]%s x=%g, y=%g x=%d y=%d\n",
		  (((x ^ this-&gt;x0) | (y ^ this-&gt;y0)) &amp; float2fixed(-0.5) ?
		   "add" : "skip"),
		  fixed2float(x), fixed2float(y), x, y);
	this-&gt;lx1 = x, this-&gt;ly1 = y;
	vd_bar(this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1, 1, RGB(0, 255, 0));
	return true;
    } else {
	--this-&gt;i;
	if (this-&gt;i == 0)
	    goto last; /* don't bother with last accum */
#	ifdef DEBUG
	    gx_flattened_iterator__print_state(this);
#	endif
#	define accum(i, r, di, dr, rmask)\
			if ( (r += dr) &gt; rmask ) r &amp;= rmask, i += di + 1;\
			else i += di
	accum(x, this-&gt;rx, this-&gt;idx, this-&gt;rdx, this-&gt;rmask);
	accum(y, this-&gt;ry, this-&gt;idy, this-&gt;rdy, this-&gt;rmask);
	accum(this-&gt;idx, this-&gt;rdx, this-&gt;id2x, this-&gt;rd2x, this-&gt;rmask);
	accum(this-&gt;idy, this-&gt;rdy, this-&gt;id2y, this-&gt;rd2y, this-&gt;rmask);
	accum(this-&gt;id2x, this-&gt;rd2x, this-&gt;id3x, this-&gt;rd3x, this-&gt;rmask);
	accum(this-&gt;id2y, this-&gt;rd2y, this-&gt;id3y, this-&gt;rd3y, this-&gt;rmask);
	if_debug5('3', "[3]%s x=%g, y=%g x=%d y=%d\n",
		  (((x ^ this-&gt;lx0) | (y ^ this-&gt;ly0)) &amp; float2fixed(-0.5) ?
		   "add" : "skip"),
		  fixed2float(x), fixed2float(y), x, y);
#	undef accum
	this-&gt;lx1 = this-&gt;x = x;
	this-&gt;ly1 = this-&gt;y = y;
	vd_bar(this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1, 1, RGB(0, 255, 0));
	return true;
    }
last:
    this-&gt;lx1 = this-&gt;x3;
    this-&gt;ly1 = this-&gt;y3;
    if_debug4('3', "[3]last x=%g, y=%g x=%d y=%d\n",
	      fixed2float(this-&gt;lx1), fixed2float(this-&gt;ly1), this-&gt;lx1, this-&gt;ly1);
    vd_bar(this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1, 1, RGB(0, 255, 0));
    return false;
}

private inline void
gx_flattened_iterator__unaccum(gx_flattened_iterator *this)
{
#   define unaccum(i, r, di, dr, rmask)\
		    if ( r &lt; dr ) r += rmask + 1 - dr, i -= di + 1;\
		    else r -= dr, i -= di
    unaccum(this-&gt;id2x, this-&gt;rd2x, this-&gt;id3x, this-&gt;rd3x, this-&gt;rmask);
    unaccum(this-&gt;id2y, this-&gt;rd2y, this-&gt;id3y, this-&gt;rd3y, this-&gt;rmask);
    unaccum(this-&gt;idx, this-&gt;rdx, this-&gt;id2x, this-&gt;rd2x, this-&gt;rmask);
    unaccum(this-&gt;idy, this-&gt;rdy, this-&gt;id2y, this-&gt;rd2y, this-&gt;rmask);
    unaccum(this-&gt;x, this-&gt;rx, this-&gt;idx, this-&gt;rdx, this-&gt;rmask);
    unaccum(this-&gt;y, this-&gt;ry, this-&gt;idy, this-&gt;rdy, this-&gt;rmask);
#   undef unaccum
}

/* Move back to the previous segment and store it to this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1 .
 * This only works for states reached with gx_flattened_iterator__next.
 * Return true iff there exist more segments.
 */
bool
gx_flattened_iterator__prev(gx_flattened_iterator *this)
{
    bool last; /* i.e. the first one in the forth order. */

    assert(this-&gt;i &lt; 1 &lt;&lt; this-&gt;k);
    this-&gt;lx1 = this-&gt;lx0;
    this-&gt;ly1 = this-&gt;ly0;
    if (this-&gt;k &lt;= 1) {
	/* If k==0, we have a single segment, return it.
	   If k==1 &amp;&amp; i &lt; 2, return the last segment.
	   Otherwise must not pass here.
	   We caould allow to pass here with this-&gt;i == 1 &lt;&lt; this-&gt;k,
	   but we want to check the assertion about the last segment below.
	 */
	this-&gt;i++;
	this-&gt;lx0 = this-&gt;x0;
	this-&gt;ly0 = this-&gt;y0;
	vd_bar(this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1, 1, RGB(0, 0, 255));
	return false;
    }
    gx_flattened_iterator__unaccum(this);
    this-&gt;i++;
#   ifdef DEBUG
    if_debug5('3', "[3]%s x=%g, y=%g x=%d y=%d\n",
	      (((this-&gt;x ^ this-&gt;lx1) | (this-&gt;y ^ this-&gt;ly1)) &amp; float2fixed(-0.5) ?
	       "add" : "skip"),
	      fixed2float(this-&gt;x), fixed2float(this-&gt;y), this-&gt;x, this-&gt;y);
    gx_flattened_iterator__print_state(this);
#   endif
    last = (this-&gt;i == (1 &lt;&lt; this-&gt;k) - 1);
    this-&gt;lx0 = this-&gt;x;
    this-&gt;ly0 = this-&gt;y;
    vd_bar(this-&gt;lx0, this-&gt;ly0, this-&gt;lx1, this-&gt;ly1, 1, RGB(0, 0, 255));
    if (last)
	assert(this-&gt;lx0 == this-&gt;x0 &amp;&amp; this-&gt;ly0 == this-&gt;y0);
    return !last;
}

/* Switching from the forward scanning to the backward scanning for the filtered1. */
void
gx_flattened_iterator__switch_to_backscan(gx_flattened_iterator *this, bool not_first)
{
    /*	When scanning forth, the accumulator stands on the end of a segment,
	except for the last segment.
	When scanning back, the accumulator should stand on the beginning of a segment.
	Asuuming that at least one forward step is done.
    */
    if (not_first)
	if (this-&gt;i &gt; 0 &amp;&amp; this-&gt;k != 1 /* This case doesn't use the accumulator. */)
	    gx_flattened_iterator__unaccum(this);
}

#define max_points 50		/* arbitrary */

private int
generate_segments(gx_path * ppath, const gs_fixed_point *points, 
		    int count, segment_notes notes)
{
    /* vd_moveto(ppath-&gt;position.x, ppath-&gt;position.y); */
    if (notes &amp; sn_not_first) {
	/* vd_lineto_multi(points, count); */
	print_points(points, count);
	return gx_path_add_lines_notes(ppath, points, count, notes);
    } else {
	int code;

	/* vd_lineto(points[0].x, points[0].y); */
	print_points(points, 1);
	code = gx_path_add_line_notes(ppath, points[0].x, points[0].y, notes);
	if (code &lt; 0)
	    return code;
	/* vd_lineto_multi(points + 1, count - 1); */
	print_points(points + 1, count - 1);
	return gx_path_add_lines_notes(ppath, points + 1, count - 1, notes | sn_not_first);
    }
}

private int
gx_subdivide_curve_rec(gx_flattened_iterator *this, 
		  gx_path * ppath, int k, curve_segment * pc,
		  segment_notes notes, gs_fixed_point *points)
{
    int code;

top :
    if (!gx_flattened_iterator__init(this, 
		ppath-&gt;position.x, ppath-&gt;position.y, pc, k)) {
	/* Curve is too long.  Break into two pieces and recur. */
	curve_segment cseg;

	k--;
	split_curve_midpoint(ppath-&gt;position.x, ppath-&gt;position.y, pc, &amp;cseg, pc);
	code = gx_subdivide_curve_rec(this, ppath, k, &amp;cseg, notes, points);
	if (code &lt; 0)
	    return code;
	notes |= sn_not_first;
	goto top;
    } else if (k == -1) {
	/* fixme : Don't need to init the iterator. Just wanted to check in_range. */
	return gx_path_add_curve_notes(ppath, pc-&gt;p1.x, pc-&gt;p1.y, pc-&gt;p2.x, pc-&gt;p2.y, 
			pc-&gt;pt.x, pc-&gt;pt.y, notes);
    } else {
	gs_fixed_point *ppt = points;
	bool more;

	for(;;) {
	    more = gx_flattened_iterator__next(this);
	    ppt-&gt;x = this-&gt;lx1;
	    ppt-&gt;y = this-&gt;ly1;
	    ppt++;
	    if (ppt == &amp;points[max_points] || !more) {
		gs_fixed_point *pe = (more ?  ppt - 2 : ppt);

		code = generate_segments(ppath, points, pe - points, notes);
		if (code &lt; 0)
		    return code;
		if (!more)
		    return 0;
		notes |= sn_not_first;
		memcpy(points, pe, (char *)ppt - (char *)pe);
		ppt = points + (ppt - pe);
	    }
	}
    }
}

#undef coord_near

/*
 * Flatten a segment of the path by repeated sampling.
 * 2^k is the number of lines to produce (i.e., the number of points - 1,
 * including the endpoints); we require k &gt;= 1.
 * If k or any of the coefficient values are too large,
 * use recursive subdivision to whittle them down.
 */

int
gx_subdivide_curve(gx_path * ppath, int k, curve_segment * pc, segment_notes notes)
{
    gs_fixed_point points[max_points + 1];
    gx_flattened_iterator iter;

    return gx_subdivide_curve_rec(&amp;iter, ppath, k, pc, notes, points);
}

#undef max_points


<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

