<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxshade6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxshade6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxshade6.c,v 1.100 2005/05/25 15:57:58 igor Exp $ */
/* Rendering for Coons and tensor patch shadings */
/*
   A contiguous non-overlapping decomposition 
   of a tensor shading into linear color triangles.
 */
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsmatrix.h"		/* for gscoord.h */
#include "gscoord.h"
#include "gxcspace.h"
#include "gxdcolor.h"
#include "gxistate.h"
#include "gxshade.h"
#include "gxshade4.h"
#include "gxdevcli.h"
#include "gxarith.h"
#include "gzpath.h"
#include "stdint_.h"
#include "math_.h"
#include "vdtrace.h"
#include &lt;assert.h&gt;

#define VD_TRACE_TENSOR_PATCH 1

#if NOFILL_TEST
static bool dbg_nofill = false;
#endif
#if SKIP_TEST
static int dbg_patch_cnt = 0;
static int dbg_quad_cnt = 0;
static int dbg_triangle_cnt = 0;
static int dbg_wedge_triangle_cnt = 0;
#endif

static int min_linear_grades = 255; /* The minimal number of device color grades,
            required to apply linear color device functions. */

/* ================ Utilities ================ */

/* Get colors for patch vertices. */
private int
shade_next_colors(shade_coord_stream_t * cs, patch_curve_t * curves,
		  int num_vertices)
{
    int i, code = 0;

    for (i = 0; i &lt; num_vertices &amp;&amp; code &gt;= 0; ++i) {
        curves[i].vertex.cc[1] = 0; /* safety. (patch_fill may assume 2 arguments) */
	code = shade_next_color(cs, curves[i].vertex.cc);
    }
    return code;
}

/* Get a Bezier or tensor patch element. */
private int
shade_next_curve(shade_coord_stream_t * cs, patch_curve_t * curve)
{
    int code = shade_next_coords(cs, &amp;curve-&gt;vertex.p, 1);

    if (code &gt;= 0)
	code = shade_next_coords(cs, curve-&gt;control,
				 countof(curve-&gt;control));
    return code;
}

/*
 * Parse the next patch out of the input stream.  Return 1 if done,
 * 0 if patch, &lt;0 on error.
 */
private int
shade_next_patch(shade_coord_stream_t * cs, int BitsPerFlag,
	patch_curve_t curve[4], gs_fixed_point interior[4] /* 0 for Coons patch */ )
{
    int flag = shade_next_flag(cs, BitsPerFlag);
    int num_colors, code;

    if (flag &lt; 0) {
	if (!cs-&gt;is_eod(cs))
	    return_error(gs_error_rangecheck);
	return 1;		/* no more data */
    }
    switch (flag &amp; 3) {
	default:
	    return_error(gs_error_rangecheck);	/* not possible */
	case 0:
	    if ((code = shade_next_curve(cs, &amp;curve[0])) &lt; 0 ||
		(code = shade_next_coords(cs, &amp;curve[1].vertex.p, 1)) &lt; 0
		)
		return code;
	    num_colors = 4;
	    goto vx;
	case 1:
	    curve[0] = curve[1], curve[1].vertex = curve[2].vertex;
	    goto v3;
	case 2:
	    curve[0] = curve[2], curve[1].vertex = curve[3].vertex;
	    goto v3;
	case 3:
	    curve[1].vertex = curve[0].vertex, curve[0] = curve[3];
v3:	    num_colors = 2;
vx:	    if ((code = shade_next_coords(cs, curve[1].control, 2)) &lt; 0 ||
		(code = shade_next_curve(cs, &amp;curve[2])) &lt; 0 ||
		(code = shade_next_curve(cs, &amp;curve[3])) &lt; 0 ||
		(interior != 0 &amp;&amp;
		 (code = shade_next_coords(cs, interior, 4)) &lt; 0) ||
		(code = shade_next_colors(cs, &amp;curve[4 - num_colors],
					  num_colors)) &lt; 0
		)
		return code;
    }
    return 0;
}

int
init_patch_fill_state(patch_fill_state_t *pfs)
{
    /* Warning : pfs-&gt;Function must be set in advance. */
    const gs_color_space *pcs = pfs-&gt;direct_space;
    gs_client_color fcc0, fcc1;
    int i, code;

    for (i = 0; i &lt; pfs-&gt;num_components; i++) {
	fcc0.paint.values[i] = -1000000;
	fcc1.paint.values[i] = 1000000;
    }
    pcs-&gt;type-&gt;restrict_color(&amp;fcc0, pcs);
    pcs-&gt;type-&gt;restrict_color(&amp;fcc1, pcs);
    for (i = 0; i &lt; pfs-&gt;num_components; i++)
	pfs-&gt;color_domain.paint.values[i] = max(fcc1.paint.values[i] - fcc0.paint.values[i], 1);
    pfs-&gt;vectorization = false; /* A stub for a while. Will use with pclwrite. */
    pfs-&gt;maybe_self_intersecting = true;
    pfs-&gt;monotonic_color = (pfs-&gt;Function == NULL);
    pfs-&gt;linear_color = false;
    pfs-&gt;inside = false;
    pfs-&gt;n_color_args = 1;
    pfs-&gt;fixed_flat = float2fixed(pfs-&gt;pis-&gt;flatness);
    pfs-&gt;smoothness = pfs-&gt;pis-&gt;smoothness;
#   if LAZY_WEDGES
	code = wedge_vertex_list_elem_buffer_alloc(pfs);
	if (code &lt; 0)
	    return code;
#   endif
    pfs-&gt;max_small_coord = 1 &lt;&lt; ((sizeof(int64_t) * 8 - 1/*sign*/) / 3);
return 0;
}

void
term_patch_fill_state(patch_fill_state_t *pfs)
{
#   if LAZY_WEDGES
	wedge_vertex_list_elem_buffer_free(pfs);
#   endif
}

/* Resolve a patch color using the Function if necessary. */
inline private void
patch_resolve_color_inline(patch_color_t * ppcr, const patch_fill_state_t *pfs)
{
    if (pfs-&gt;Function) {
	const gs_color_space *pcs = pfs-&gt;direct_space;

	gs_function_evaluate(pfs-&gt;Function, ppcr-&gt;t, ppcr-&gt;cc.paint.values);
	pcs-&gt;type-&gt;restrict_color(&amp;ppcr-&gt;cc, pcs);
    }
}

void
patch_resolve_color(patch_color_t * ppcr, const patch_fill_state_t *pfs)
{
    patch_resolve_color_inline(ppcr, pfs);
}


/*
 * Calculate the interpolated color at a given point.
 * Note that we must do this twice for bilinear interpolation.
 * We use the name ppcr rather than ppc because an Apple compiler defines
 * ppc when compiling on PowerPC systems (!).
 */
private void
patch_interpolate_color(patch_color_t * ppcr, const patch_color_t * ppc0,
       const patch_color_t * ppc1, const patch_fill_state_t *pfs, floatp t)
{
    /* The old code gives -IND on Intel. */
    if (pfs-&gt;Function) {
	ppcr-&gt;t[0] = ppc0-&gt;t[0] * (1 - t) + t * ppc1-&gt;t[0];
	ppcr-&gt;t[1] = ppc0-&gt;t[1] * (1 - t) + t * ppc1-&gt;t[1];
	patch_resolve_color_inline(ppcr, pfs);
    } else {
	int ci;

	for (ci = pfs-&gt;num_components - 1; ci &gt;= 0; --ci)
	    ppcr-&gt;cc.paint.values[ci] =
		ppc0-&gt;cc.paint.values[ci] * (1 - t) + t * ppc1-&gt;cc.paint.values[ci];
    }
}

/* ================ Specific shadings ================ */

/*
 * The curves are stored in a clockwise or counter-clockwise order that maps
 * to the patch definition in a non-intuitive way.  The documentation
 * (pp. 277-281 of the PostScript Language Reference Manual, Third Edition)
 * says that the curves are in the order D1, C2, D2, C1.
 */
/* The starting points of the curves: */
#define D1START 0
#define C2START 1
#define D2START 3
#define C1START 0
/* The control points of the curves (x means reversed order): */
#define D1CTRL 0
#define C2CTRL 1
#define D2XCTRL 2
#define C1XCTRL 3
/* The end points of the curves: */
#define D1END 1
#define C2END 2
#define D2END 2
#define C1END 3

/* ---------------- Common code ---------------- */

/* Evaluate a curve at a given point. */
private void
curve_eval(gs_fixed_point * pt, const gs_fixed_point * p0,
	   const gs_fixed_point * p1, const gs_fixed_point * p2,
	   const gs_fixed_point * p3, floatp t)
{
    fixed a, b, c, d;
    fixed t01, t12;

    d = p0-&gt;x;
    curve_points_to_coefficients(d, p1-&gt;x, p2-&gt;x, p3-&gt;x,
				 a, b, c, t01, t12);
    pt-&gt;x = (fixed) (((a * t + b) * t + c) * t + d);
    d = p0-&gt;y;
    curve_points_to_coefficients(d, p1-&gt;y, p2-&gt;y, p3-&gt;y,
				 a, b, c, t01, t12);
    pt-&gt;y = (fixed) (((a * t + b) * t + c) * t + d);
    if_debug3('2', "[2]t=%g =&gt; (%g,%g)\n", t, fixed2float(pt-&gt;x),
	      fixed2float(pt-&gt;y));
}

/* ---------------- Coons patch shading ---------------- */

/* Calculate the device-space coordinate corresponding to (u,v). */
private void
Cp_transform(gs_fixed_point * pt, const patch_curve_t curve[4],
	     const gs_fixed_point ignore_interior[4], floatp u, floatp v)
{
    double co_u = 1.0 - u, co_v = 1.0 - v;
    gs_fixed_point c1u, d1v, c2u, d2v;

    curve_eval(&amp;c1u, &amp;curve[C1START].vertex.p,
	       &amp;curve[C1XCTRL].control[1], &amp;curve[C1XCTRL].control[0],
	       &amp;curve[C1END].vertex.p, u);
    curve_eval(&amp;d1v, &amp;curve[D1START].vertex.p,
	       &amp;curve[D1CTRL].control[0], &amp;curve[D1CTRL].control[1],
	       &amp;curve[D1END].vertex.p, v);
    curve_eval(&amp;c2u, &amp;curve[C2START].vertex.p,
	       &amp;curve[C2CTRL].control[0], &amp;curve[C2CTRL].control[1],
	       &amp;curve[C2END].vertex.p, u);
    curve_eval(&amp;d2v, &amp;curve[D2START].vertex.p,
	       &amp;curve[D2XCTRL].control[1], &amp;curve[D2XCTRL].control[0],
	       &amp;curve[D2END].vertex.p, v);
#define COMPUTE_COORD(xy)\
    pt-&gt;xy = (fixed)\
	((co_v * c1u.xy + v * c2u.xy) + (co_u * d1v.xy + u * d2v.xy) -\
	 (co_v * (co_u * curve[C1START].vertex.p.xy +\
		  u * curve[C1END].vertex.p.xy) +\
	  v * (co_u * curve[C2START].vertex.p.xy +\
	       u * curve[C2END].vertex.p.xy)))
    COMPUTE_COORD(x);
    COMPUTE_COORD(y);
#undef COMPUTE_COORD
    if_debug4('2', "[2](u=%g,v=%g) =&gt; (%g,%g)\n",
	      u, v, fixed2float(pt-&gt;x), fixed2float(pt-&gt;y));
}

int
gs_shading_Cp_fill_rectangle(const gs_shading_t * psh0, const gs_rect * rect,
			     const gs_fixed_rect * rect_clip,
			     gx_device * dev, gs_imager_state * pis)
{
    const gs_shading_Cp_t * const psh = (const gs_shading_Cp_t *)psh0;
    patch_fill_state_t state;
    shade_coord_stream_t cs;
    patch_curve_t curve[4];
    int code;

    code = mesh_init_fill_state((mesh_fill_state_t *) &amp;state,
			 (const gs_shading_mesh_t *)psh0, rect_clip, dev, pis);
    if (code &lt; 0)
	return code;
    state.Function = psh-&gt;params.Function;
    code = init_patch_fill_state(&amp;state);
    if(code &lt; 0)
	return code;
    if (VD_TRACE_TENSOR_PATCH &amp;&amp; vd_allowed('s')) {
	vd_get_dc('s');
	vd_set_shift(0, 0);
	vd_set_scale(0.01);
	vd_set_origin(0, 0);
	/* vd_erase(RGB(192, 192, 192)); */
    }

    curve[0].straight = curve[1].straight = curve[2].straight = curve[3].straight = false;
    shade_next_init(&amp;cs, (const gs_shading_mesh_params_t *)&amp;psh-&gt;params, pis);
    while ((code = shade_next_patch(&amp;cs, psh-&gt;params.BitsPerFlag,
				    curve, NULL)) == 0 &amp;&amp;
	   (code = patch_fill(&amp;state, curve, NULL, Cp_transform)) &gt;= 0
	) {
	DO_NOTHING;
    }
    if (VD_TRACE_TENSOR_PATCH &amp;&amp; vd_allowed('s'))
	vd_release_dc;
    term_patch_fill_state(&amp;state);
    return min(code, 0);
}

/* ---------------- Tensor product patch shading ---------------- */

/* Calculate the device-space coordinate corresponding to (u,v). */
private void
Tpp_transform(gs_fixed_point * pt, const patch_curve_t curve[4],
	      const gs_fixed_point interior[4], floatp u, floatp v)
{
    double Bu[4], Bv[4];
    gs_fixed_point pts[4][4];
    int i, j;
    double x = 0, y = 0;

    /* Compute the Bernstein polynomials of u and v. */
    {
	double u2 = u * u, co_u = 1.0 - u, co_u2 = co_u * co_u;
	double v2 = v * v, co_v = 1.0 - v, co_v2 = co_v * co_v;

	Bu[0] = co_u * co_u2, Bu[1] = 3 * u * co_u2,
	    Bu[2] = 3 * u2 * co_u, Bu[3] = u * u2;
	Bv[0] = co_v * co_v2, Bv[1] = 3 * v * co_v2,
	    Bv[2] = 3 * v2 * co_v, Bv[3] = v * v2;
    }

    /* Arrange the points into an indexable order. */
    pts[0][0] = curve[0].vertex.p;
    pts[0][1] = curve[0].control[0];
    pts[0][2] = curve[0].control[1];
    pts[0][3] = curve[1].vertex.p;
    pts[1][3] = curve[1].control[0];
    pts[2][3] = curve[1].control[1];
    pts[3][3] = curve[2].vertex.p;
    pts[3][2] = curve[2].control[0];
    pts[3][1] = curve[2].control[1];
    pts[3][0] = curve[3].vertex.p;
    pts[2][0] = curve[3].control[0];
    pts[1][0] = curve[3].control[1];
    pts[1][1] = interior[0];
    pts[2][1] = interior[1];
    pts[2][2] = interior[2];
    pts[1][2] = interior[3];

    /* Now compute the actual point. */
    for (i = 0; i &lt; 4; ++i)
	for (j = 0; j &lt; 4; ++j) {
	    double coeff = Bu[i] * Bv[j];

	    x += pts[i][j].x * coeff, y += pts[i][j].y * coeff;
	}
    pt-&gt;x = (fixed)x, pt-&gt;y = (fixed)y;
}

int
gs_shading_Tpp_fill_rectangle(const gs_shading_t * psh0, const gs_rect * rect,
			     const gs_fixed_rect * rect_clip,
			      gx_device * dev, gs_imager_state * pis)
{
    const gs_shading_Tpp_t * const psh = (const gs_shading_Tpp_t *)psh0;
    patch_fill_state_t state;
    shade_coord_stream_t cs;
    patch_curve_t curve[4];
    gs_fixed_point interior[4];
    int code;

    code = mesh_init_fill_state((mesh_fill_state_t *) &amp; state,
			 (const gs_shading_mesh_t *)psh0, rect_clip, dev, pis);
    if (code &lt; 0)
	return code;
    state.Function = psh-&gt;params.Function;
    code = init_patch_fill_state(&amp;state);
    if(code &lt; 0)
	return code;
    if (VD_TRACE_TENSOR_PATCH &amp;&amp; vd_allowed('s')) {
	vd_get_dc('s');
	vd_set_shift(0, 0);
	vd_set_scale(0.01);
	vd_set_origin(0, 0);
	/* vd_erase(RGB(192, 192, 192)); */
    }
    curve[0].straight = curve[1].straight = curve[2].straight = curve[3].straight = false;
    shade_next_init(&amp;cs, (const gs_shading_mesh_params_t *)&amp;psh-&gt;params, pis);
    while ((code = shade_next_patch(&amp;cs, psh-&gt;params.BitsPerFlag,
				    curve, interior)) == 0) {
	/*
	 * The order of points appears to be consistent with that for Coons
	 * patches, which is different from that documented in Red Book 3.
	 */
	gs_fixed_point swapped_interior[4];

	swapped_interior[0] = interior[0];
	swapped_interior[1] = interior[3];
	swapped_interior[2] = interior[2];
	swapped_interior[3] = interior[1];
	code = patch_fill(&amp;state, curve, swapped_interior, Tpp_transform);
	if (code &lt; 0)
	    break;
    }
    term_patch_fill_state(&amp;state);
    if (VD_TRACE_TENSOR_PATCH &amp;&amp; vd_allowed('s'))
	vd_release_dc;
    return min(code, 0);
}

/*
    This algorithm performs a decomposition of the shading area
    into a set of constant color trapezoids, some of which
    may use the transpozed coordinate system.

    The target device assumes semi-open intrvals by X to be painted
    (See PLRM3, 7.5. Scan conversion details), i.e.
    it doesn't paint pixels which falls exactly to the right side.
    Note that with raster devices the algorithm doesn't paint pixels, 
    whigh are partially covered by the shading area, 
    but which's centers are outside the area.

    Pixels inside a monotonic part of the shading area are painted 
    at once, but some exceptions may happen :

        - While flattening boundaries of a subpatch,
	to keep the plane coverage contiguity we insert wedges 
	between neighbor subpatches, which use a different
	flattening factor. With non-monotonic curves
	those wedges may overlap or be self-overlapping, and a pixel 
	is painted so many times as many wedges cover it. Fortunately
	the area of most wedges is zero or extremily small.

	- Since quazi-horizontal wedges may have a non-constant color,
	they can't decompose into constant color trapezoids with
	keeping the coverage contiguity. To represent them we
	apply the XY plane transposition. But with the transposition 
	a semiopen interval can met a non-transposed one,
	so that some lines are not covered. Therefore we emulate 
	closed intervals with expanding the transposed trapesoids in 
	fixed_epsilon, and pixels at that boundary may be painted twice.

	- A boundary of a monotonic area can't compute in XY 
	preciselly due to high order polynomial equations. 
	Therefore the subdivision near the monotonity boundary 
	may paint some pixels twice within same monotonic part.

    Non-monotonic areas slow down due to a tinny subdivision required.
    
    The target device may be either raster or vector. 
    Vector devices should preciselly pass trapezoids to the output.
    Note that ends of sides of a trapesoid are not necessary 
    the trapezoid's vertices. Converting this thing into
    an exact quadrangle may cause an arithmetic error,
    and the rounding must be done so that the coverage
    contiguity is not lost. 

    When a device passes a trapezoid to it's output, 
    a regular rounding would keep the coverage contiguity, 
    except for the transposed trapesoids. 
    If a transposed trapezoid is being transposed back, 
    it doesn't become a canonic trapezoid, and a further
    decomposition is neccessary. But rounding errors here
    would break the coverage contiguity at boundaries
    of the tansposed part of the area.

    Devices, which have no transposed trapezoids and represent 
    trapezoids only with 8 coordinates of vertices of the quadrangle
    (pclwrite is an example) may apply the backward transposition,
    and a clipping instead the further decomposition.
    Note that many clip regions may appear for all wedges. 
    Note that in some cases the adjustment of the right side to be 
    withdrown before the backward transposition.
 */
 /* We believe that a multiplication of 32-bit integers with a 
    64-bit result is performed by modern platforms performs 
    in hardware level. Therefore we widely use it here, 
    but we minimize the usage of a multiplication of longer integers. 
    
    Unfortunately we do need a multiplication of long integers
    in intersection_of_small_bars, because solving the linear system
    requires tripple multiples of 'fixed'. Therefore we retain
    of it's usage in the algorithm of the main branch.
    Configuration macro QUADRANGLES prevents it.
  */

typedef struct {
    gs_fixed_point pole[4][4]; /* [v][u] */
    patch_color_t c[2][2];     /* [v][u] */
} tensor_patch;

typedef struct {
    const shading_vertex_t *p[2][2]; /* [v][u] */
    wedge_vertex_list_t *l0001, *l0111, *l1110, *l1000;
} quadrangle_patch;

typedef enum {
    interpatch_padding = 1, /* A Padding between patches for poorly designed documents. */
    inpatch_wedge = 2  /* Wedges while a patch decomposition. */
} wedge_type_t;

int
wedge_vertex_list_elem_buffer_alloc(patch_fill_state_t *pfs)
{
    const int max_level = LAZY_WEDGES_MAX_LEVEL;
    gs_memory_t *memory = pfs-&gt;pis-&gt;memory;

    pfs-&gt;wedge_vertex_list_elem_count_max = max_level * (1 &lt;&lt; max_level);
    pfs-&gt;wedge_vertex_list_elem_buffer = (wedge_vertex_list_elem_t *)gs_alloc_bytes(memory, 
	    sizeof(wedge_vertex_list_elem_t) * pfs-&gt;wedge_vertex_list_elem_count_max, 
	    "alloc_wedge_vertex_list_elem_buffer");
    if (pfs-&gt;wedge_vertex_list_elem_buffer == NULL)
	return_error(gs_error_VMerror);
    pfs-&gt;free_wedge_vertex = NULL;
    pfs-&gt;wedge_vertex_list_elem_count = 0;
    return 0;
}

void
wedge_vertex_list_elem_buffer_free(patch_fill_state_t *pfs)
{
    gs_memory_t *memory = pfs-&gt;pis-&gt;memory;

    gs_free_object(memory, pfs-&gt;wedge_vertex_list_elem_buffer, 
		"wedge_vertex_list_elem_buffer_free");
    pfs-&gt;wedge_vertex_list_elem_buffer = NULL;
    pfs-&gt;free_wedge_vertex = NULL;
}

private inline wedge_vertex_list_elem_t *
wedge_vertex_list_elem_reserve(patch_fill_state_t *pfs)
{
    wedge_vertex_list_elem_t *e = pfs-&gt;free_wedge_vertex;

    if (e != NULL) {
	pfs-&gt;free_wedge_vertex = e-&gt;next;
	return e;
    }
    if (pfs-&gt;wedge_vertex_list_elem_count &lt; pfs-&gt;wedge_vertex_list_elem_count_max)
	return pfs-&gt;wedge_vertex_list_elem_buffer + pfs-&gt;wedge_vertex_list_elem_count++;
    return NULL;
}

private inline void
wedge_vertex_list_elem_release(patch_fill_state_t *pfs, wedge_vertex_list_elem_t *e)
{
    e-&gt;next = pfs-&gt;free_wedge_vertex;
    pfs-&gt;free_wedge_vertex = e;
}

private inline void
release_triangle_wedge_vertex_list_elem(patch_fill_state_t *pfs, 
    wedge_vertex_list_elem_t *beg, wedge_vertex_list_elem_t *end)
{
    wedge_vertex_list_elem_t *e = beg-&gt;next;

    assert(beg-&gt;next-&gt;next == end);
    beg-&gt;next = end;
    end-&gt;prev = beg;
    wedge_vertex_list_elem_release(pfs, e);
}

private inline void
release_wedge_vertex_list_interval(patch_fill_state_t *pfs, 
    wedge_vertex_list_elem_t *beg, wedge_vertex_list_elem_t *end)
{
    wedge_vertex_list_elem_t *e = beg-&gt;next, *ee;

    beg-&gt;next = end;
    end-&gt;prev = beg;
    for (; e != end; e = ee) {
	ee = e-&gt;next;
	wedge_vertex_list_elem_release(pfs, e);
    }
}

private inline void
release_wedge_vertex_list(patch_fill_state_t *pfs, wedge_vertex_list_t *ll, int n)
{
    int i;

    for (i = 0; i &lt; n; i++) {
	wedge_vertex_list_t *l = ll + i;

	if (l-&gt;beg != NULL) {
	    assert(l-&gt;end != NULL);
	    release_wedge_vertex_list_interval(pfs, l-&gt;beg, l-&gt;end);
	    wedge_vertex_list_elem_release(pfs, l-&gt;beg);
	    wedge_vertex_list_elem_release(pfs, l-&gt;end);
	    l-&gt;beg = l-&gt;end = NULL;
	} else
	    assert(l-&gt;end == NULL);
    }
}

private inline wedge_vertex_list_elem_t *
wedge_vertex_list_find(wedge_vertex_list_elem_t *beg, const wedge_vertex_list_elem_t *end, 
	    int level)
{
    wedge_vertex_list_elem_t *e = beg;
    
    assert(beg != NULL &amp;&amp; end != NULL);
    for (; e != end; e = e-&gt;next)
	if (e-&gt;level == level)
	    return e;
    return NULL;
}

private inline void
init_wedge_vertex_list(wedge_vertex_list_t *l, int n)
{
    memset(l, 0, sizeof(*l) * n);
}

private void
draw_patch(const tensor_patch *p, bool interior, ulong rgbcolor)
{
#ifdef DEBUG
#if 0 /* Disabled for a better view with a specific purpose. 
	 Feel free to enable fo needed. */
    int i, step = (interior ? 1 : 3);

    for (i = 0; i &lt; 4; i += step) {
	vd_curve(p-&gt;pole[i][0].x, p-&gt;pole[i][0].y, 
		 p-&gt;pole[i][1].x, p-&gt;pole[i][1].y, 
		 p-&gt;pole[i][2].x, p-&gt;pole[i][2].y, 
		 p-&gt;pole[i][3].x, p-&gt;pole[i][3].y, 
		 0, rgbcolor);
	vd_curve(p-&gt;pole[0][i].x, p-&gt;pole[0][i].y, 
		 p-&gt;pole[1][i].x, p-&gt;pole[1][i].y, 
		 p-&gt;pole[2][i].x, p-&gt;pole[2][i].y, 
		 p-&gt;pole[3][i].x, p-&gt;pole[3][i].y, 
		 0, rgbcolor);
    }
#endif
#endif
}

private inline void
draw_triangle(const gs_fixed_point *p0, const gs_fixed_point *p1, 
		const gs_fixed_point *p2, ulong rgbcolor)
{
#ifdef DEBUG
    if (!vd_enabled)
	return;
    vd_quad(p0-&gt;x, p0-&gt;y, p0-&gt;x, p0-&gt;y, p1-&gt;x, p1-&gt;y, p2-&gt;x, p2-&gt;y, 0, rgbcolor);
#endif
}

private inline void
draw_quadrangle(const quadrangle_patch *p, ulong rgbcolor)
{
#ifdef DEBUG
	vd_quad(p-&gt;p[0][0]-&gt;p.x, p-&gt;p[0][0]-&gt;p.y, 
	    p-&gt;p[0][1]-&gt;p.x, p-&gt;p[0][1]-&gt;p.y,
	    p-&gt;p[1][1]-&gt;p.x, p-&gt;p[1][1]-&gt;p.y,
	    p-&gt;p[1][0]-&gt;p.x, p-&gt;p[1][0]-&gt;p.y,
	    0, rgbcolor);
#endif
}

private inline int
curve_samples(patch_fill_state_t *pfs, 
		const gs_fixed_point *pole, int pole_step, fixed fixed_flat)
{
    curve_segment s;
    int k;

    s.p1.x = pole[pole_step].x;
    s.p1.y = pole[pole_step].y;
    s.p2.x = pole[pole_step * 2].x;
    s.p2.y = pole[pole_step * 2].y;
    s.pt.x = pole[pole_step * 3].x;
    s.pt.y = pole[pole_step * 3].y;
    k = gx_curve_log2_samples(pole[0].x, pole[0].y, &amp;s, fixed_flat);
    {	
#	if LAZY_WEDGES || QUADRANGLES
	    int k1;
	    fixed L = any_abs(pole[1].x - pole[0].x) + any_abs(pole[1].y - pole[0].y) +
		      any_abs(pole[2].x - pole[1].x) + any_abs(pole[2].y - pole[1].y) +
		      any_abs(pole[3].x - pole[2].x) + any_abs(pole[3].y - pole[2].y);
#	endif

#	if LAZY_WEDGES
	    /* Restrict lengths for a reasonable memory consumption : */
	    k1 = ilog2(L / fixed_1 / (1 &lt;&lt; (LAZY_WEDGES_MAX_LEVEL - 1)));
	    k = max(k, k1);
#	endif
#	if QUADRANGLES
	    /* Restrict lengths for intersection_of_small_bars : */
	    k = max(k, ilog2(L) - ilog2(pfs-&gt;max_small_coord));
#	endif
    }
    return 1 &lt;&lt; k;
}

private bool 
intersection_of_small_bars(const gs_fixed_point q[4], int i0, int i1, int i2, int i3, fixed *ry, fixed *ey)
{
    /* This function is only used with QUADRANGLES. */
    fixed dx1 = q[i1].x - q[i0].x, dy1 = q[i1].y - q[i0].y;
    fixed dx2 = q[i2].x - q[i0].x, dy2 = q[i2].y - q[i0].y;
    fixed dx3 = q[i3].x - q[i0].x, dy3 = q[i3].y - q[i0].y;
    int64_t vp2a, vp2b, vp3a, vp3b;
    int s2, s3;

    if (dx1 == 0 &amp;&amp; dy1 == 0)
	return false; /* Zero length bars are out of interest. */
    if (dx2 == 0 &amp;&amp; dy2 == 0)
	return false; /* Contacting ends are out of interest. */
    if (dx3 == 0 &amp;&amp; dy3 == 0)
	return false; /* Contacting ends are out of interest. */
    if (dx2 == dx1 &amp;&amp; dy2 == dy1)
	return false; /* Contacting ends are out of interest. */
    if (dx3 == dx1 &amp;&amp; dy3 == dy1)
	return false; /* Contacting ends are out of interest. */
    if (dx2 == dx3 &amp;&amp; dy2 == dy3)
	return false; /* Zero length bars are out of interest. */
    vp2a = (int64_t)dx1 * dy2;
    vp2b = (int64_t)dy1 * dx2; 
    /* vp2 = vp2a - vp2b; It can overflow int64_t, but we only need the sign. */
    if (vp2a &gt; vp2b)
	s2 = 1;
    else if (vp2a &lt; vp2b)
	s2 = -1;
    else 
	s2 = 0;
    vp3a = (int64_t)dx1 * dy3;
    vp3b = (int64_t)dy1 * dx3; 
    /* vp3 = vp3a - vp3b; It can overflow int64_t, but we only need the sign. */
    if (vp3a &gt; vp3b)
	s3 = 1;
    else if (vp3a &lt; vp3b)
	s3 = -1;
    else 
	s3 = 0;
    if (s2 == 0) {
	if (s3 == 0)
	    return false; /* Collinear bars - out of interest. */
	if (0 &lt;= dx2 &amp;&amp; dx2 &lt;= dx1 &amp;&amp; 0 &lt;= dy2 &amp;&amp; dy2 &lt;= dy1) {
	    /* The start of the bar 2 is in the bar 1. */
	    *ry = q[i2].y;
	    *ey = 0;
	    return true;
	}
    } else if (s3 == 0) {
	if (0 &lt;= dx3 &amp;&amp; dx3 &lt;= dx1 &amp;&amp; 0 &lt;= dy3 &amp;&amp; dy3 &lt;= dy1) {
	    /* The end of the bar 2 is in the bar 1. */
	    *ry = q[i3].y;
	    *ey = 0;
	    return true;
	}
    } else if (s2 * s3 &lt; 0) {
	/* The intersection definitely exists, so the determinant isn't zero.  */
	fixed d23x = dx3 - dx2, d23y = dy3 - dy2;
	int64_t det = (int64_t)dx1 * d23y - (int64_t)dy1 * d23x;
	int64_t mul = (int64_t)dx2 * d23y - (int64_t)dy2 * d23x;
#	define USE_DOUBLE 0
#	define USE_INT64_T (1 || !USE_DOUBLE)
#	if USE_DOUBLE
	{ 
	    /* Assuming big bars. Not a good thing due to 'double'.  */
	    /* The determinant can't compute in double due to 
	       possible loss of all significant bits when subtracting the 
	       trucnated prodicts. But after we subtract in int64_t,
	       it converts to 'double' with a reasonable truncation. */
	    double dy = dy1 * (double)mul / (double)det;
	    fixed iy;

	    if (dy1 &gt; 0 &amp;&amp; dy &gt;= dy1)
		return false; /* Outside the bar 1. */
	    if (dy1 &lt; 0 &amp;&amp; dy &lt;= dy1)
		return false; /* Outside the bar 1. */
	    if (dy2 &lt; dy3) {
		if (dy &lt;= dy2 || dy &gt;= dy3)
		    return false; /* Outside the bar 2. */
	    } else {
		if (dy &gt;= dy2 || dy &lt;= dy3)
		    return false; /* Outside the bar 2. */
	    }
	    iy = (int)floor(dy);
	    *ry = q[i0].y + iy;
	    *ey = (dy &gt; iy ? 1 : 0);
	}
#	endif
#	if USE_INT64_T
	{
	    /* Assuming small bars : cubes of coordinates must fit into int64_t.
	       curve_samples must provide that.  */
	    int64_t num = dy1 * mul, iiy;
	    fixed iy;
	    fixed pry, pey;

	    {	/* Likely when called form wedge_trap_decompose or constant_color_quadrangle,
		   we always have det &gt; 0 &amp;&amp; num &gt;= 0, but we check here for a safety reason. */
		if (det &lt; 0)
		    {num = -num; det = -det;}
		if(num &gt;= 0)
			iiy = num / det;
		else
			iiy = (num - det + 1) / det;
		iy = (fixed)iiy;
		if (iy != iiy) {
		    /* If it is inside the bars, it must fit into fixed. */
		    return false;
		}
	    }
	    if (dy1 &gt; 0 &amp;&amp; iy &gt;= dy1)
		return false; /* Outside the bar 1. */
	    if (dy1 &lt; 0 &amp;&amp; iy &lt;= dy1)
		return false; /* Outside the bar 1. */
	    if (dy2 &lt; dy3) {
		if (iy &lt;= dy2 || iy &gt;= dy3)
		    return false; /* Outside the bar 2. */
	    } else {
		if (iy &gt;= dy2 || iy &lt;= dy3)
		    return false; /* Outside the bar 2. */
	    }
	    pry = q[i0].y + (fixed)iy;
	    pey = (iy * det &lt; num ? 1 : 0);
#	    if USE_DOUBLE &amp;&amp; USE_INT64_T
		assert(*ry == pry);
		assert(*ey == pey);
#	    endif
	    *ry = pry;
	    *ey = pey;
	}
#	endif
	return true;
    }
    return false;
}

private inline void
adjust_swapped_boundary(fixed *b, bool swap_axes)
{
    if (swap_axes) {
	/*  Sinse the rasterizer algorithm assumes semi-open interval
	    when computing pixel coverage, we should expand
	    the right side of the area. Otherwise a dropout can happen :
	    if the left neighbour is painted with !swap_axes,
	    the left side of this area appears to be the left side 
	    of the neighbour area, and the side is not included
	    into both areas.
	 */
	*b += fixed_epsilon;
    }
}

private inline void
make_trapezoid(const gs_fixed_point q[4], 
	int vi0, int vi1, int vi2, int vi3, fixed ybot, fixed ytop, 
	bool swap_axes, bool orient, gs_fixed_edge *le, gs_fixed_edge *re)
{
    if (!orient) {
	le-&gt;start = q[vi0];
	le-&gt;end = q[vi1];
	re-&gt;start = q[vi2];
	re-&gt;end = q[vi3];
    } else {
	le-&gt;start = q[vi2];
	le-&gt;end = q[vi3];
	re-&gt;start = q[vi0];
	re-&gt;end = q[vi1];
    }
    adjust_swapped_boundary(&amp;re-&gt;start.x, swap_axes);
    adjust_swapped_boundary(&amp;re-&gt;end.x, swap_axes);
}

private inline int 
gx_shade_trapezoid(patch_fill_state_t *pfs, const gs_fixed_point q[4], 
	int vi0, int vi1, int vi2, int vi3, fixed ybot0, fixed ytop0, 
	bool swap_axes, const gx_device_color *pdevc, bool orient)
{
    gs_fixed_edge le, re;
    int code;
    fixed ybot = max(ybot0, swap_axes ? pfs-&gt;rect.p.x : pfs-&gt;rect.p.y);
    fixed ytop = min(ytop0, swap_axes ? pfs-&gt;rect.q.x : pfs-&gt;rect.q.y);
    vd_save;

    if (ybot &gt; ytop)
	return 0;
#   if NOFILL_TEST
	if (dbg_nofill)
	    return 0;
#   endif
    make_trapezoid(q, vi0, vi1, vi2, vi3, ybot, ytop, swap_axes, orient, &amp;le, &amp;re);
    if (!VD_TRACE_DOWN)
	vd_disable;
    code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
	    &amp;le, &amp;re, ybot, ytop, swap_axes, pdevc, pfs-&gt;pis-&gt;log_op);
    vd_restore;
    return code;
}

private int
patch_color_to_device_color(const patch_fill_state_t *pfs, const patch_color_t *c, gx_device_color *pdevc)
{
    /* A code fragment copied from mesh_fill_triangle. */
    gs_client_color fcc;
    const gs_color_space *pcs = pfs-&gt;direct_space;

    memcpy(fcc.paint.values, c-&gt;cc.paint.values, 
		sizeof(fcc.paint.values[0]) * pfs-&gt;num_components);
    return pcs-&gt;type-&gt;remap_color(&amp;fcc, pcs, pdevc, pfs-&gt;pis,
			      pfs-&gt;dev, gs_color_select_texture);
}

private inline double
color_span(const patch_fill_state_t *pfs, const patch_color_t *c0, const patch_color_t *c1)
{
    int n = pfs-&gt;num_components, i;
    double m;

    /* Dont want to copy colors, which are big things. */
    m = any_abs(c1-&gt;cc.paint.values[0] - c0-&gt;cc.paint.values[0]) / pfs-&gt;color_domain.paint.values[0];
    for (i = 1; i &lt; n; i++)
	m = max(m, any_abs(c1-&gt;cc.paint.values[i] - c0-&gt;cc.paint.values[i]) / pfs-&gt;color_domain.paint.values[i]);
    return m;
}

private inline void
color_diff(const patch_fill_state_t *pfs, const patch_color_t *c0, const patch_color_t *c1, patch_color_t *d)
{
    int n = pfs-&gt;num_components, i;

    for (i = 0; i &lt; n; i++)
	d-&gt;cc.paint.values[i] = c1-&gt;cc.paint.values[i] - c0-&gt;cc.paint.values[i];
}

private inline double
color_norm(const patch_fill_state_t *pfs, const patch_color_t *c)
{
    int n = pfs-&gt;num_components, i;
    double m;

    m = any_abs(c-&gt;cc.paint.values[0]) / pfs-&gt;color_domain.paint.values[0];
    for (i = 1; i &lt; n; i++)
	m = max(m, any_abs(c-&gt;cc.paint.values[i]) / pfs-&gt;color_domain.paint.values[i]);
    return m;
}

private inline int
isnt_color_monotonic(const patch_fill_state_t *pfs, const patch_color_t *c0, const patch_color_t *c1)
{   /* checks whether the color is monotonic in the n-dimensional interval,
       where n is the number of parameters in c0-&gt;t, c1-&gt;t.
       returns : 0 = monotonic, 
       bit 0 = not or don't know by t0, 
       bit 1 = not or don't know by t1, 
       &lt;0 = error. */
    /* When pfs-&gt;Function is not set, the color is monotonic.
       In this case do not call this function because 
       it doesn't check whether pfs-&gt;Function is set. 
       Actually pfs-&gt;monotonic_color prevents that.
     */
    uint mask;
    int code = gs_function_is_monotonic(pfs-&gt;Function, c0-&gt;t, c1-&gt;t, &amp;mask);

    if (code &gt;= 0)
	return mask;
    return code;
}

private inline bool
covers_pixel_centers(fixed ybot, fixed ytop)
{
    return fixed_pixround(ybot) &lt; fixed_pixround(ytop);
}

private inline int
constant_color_trapezoid(patch_fill_state_t *pfs, gs_fixed_edge *le, gs_fixed_edge *re, 
	fixed ybot, fixed ytop, bool swap_axes, const patch_color_t *c)
{
    patch_color_t c1 = *c;
    gx_device_color dc;
    int code;
    vd_save;

#   if NOFILL_TEST
	/* if (dbg_nofill)
		return 0; */
#   endif
    code = patch_color_to_device_color(pfs, &amp;c1, &amp;dc);
    if (code &lt; 0)
	return code;
    if (!VD_TRACE_DOWN)
	vd_disable;
    code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
	le, re, ybot, ytop, swap_axes, &amp;dc, pfs-&gt;pis-&gt;log_op);
    vd_restore;
    return code;
}

private inline void
dc2fc(const patch_fill_state_t *pfs, gx_color_index c, 
	    frac31 fc[GX_DEVICE_COLOR_MAX_COMPONENTS])
{
    int j;
    const gx_device_color_info *cinfo = &amp;pfs-&gt;dev-&gt;color_info;

    for (j = 0; j &lt; cinfo-&gt;num_components; j++) {
	    int shift = cinfo-&gt;comp_shift[j];
	    int bits = cinfo-&gt;comp_bits[j];

	    fc[j] = ((c &gt;&gt; shift) &amp; ((1 &lt;&lt; bits) - 1)) &lt;&lt; (sizeof(frac31) * 8 - 1 - bits);
    }
}

private inline float
function_linearity(const patch_fill_state_t *pfs, const patch_color_t *c0, const patch_color_t *c1)
{
    float smoothness = max(pfs-&gt;smoothness, 1.0 / min_linear_grades), s = 0;
    /* Restrict the smoothness with 1/min_linear_grades, because cs_is_linear
       can't provide a better precision due to the color
       representation with integers.
     */

    if (pfs-&gt;Function != NULL) {
	patch_color_t c;
	const float q[2] = {(float)0.3, (float)0.7};
	int i, j;

	for (j = 0; j &lt; count_of(q); j++) {
	    c.t[0] = c0-&gt;t[0] * (1 - q[j]) + c1-&gt;t[0] * q[j];
	    c.t[1] = c0-&gt;t[1] * (1 - q[j]) + c1-&gt;t[1] * q[j];
	    patch_resolve_color_inline(&amp;c, pfs);
	    for (i = 0; i &lt; pfs-&gt;num_components; i++) {
		float v = c0-&gt;cc.paint.values[i] * (1 - q[j]) + c1-&gt;cc.paint.values[i] * q[j];
		float d = v - c.cc.paint.values[i];
		float s1 = any_abs(d) / pfs-&gt;color_domain.paint.values[i];

		if (s1 &gt; smoothness)
		    return s1;
		if (s &lt; s1)
		    s = s1;
	    }
	}
    }
    return s;
}

private inline int
is_color_linear(const patch_fill_state_t *pfs, const patch_color_t *c0, const patch_color_t *c1)
{   /* returns : 1 = linear, 0 = unlinear, &lt;0 = error. */
    if (pfs-&gt;unlinear)
	return 1; /* Disable this check. */
    else {
	gs_direct_color_space *cs = 
		    (gs_direct_color_space *)pfs-&gt;direct_space; /* break 'const'. */
	int code;
	float smoothness = max(pfs-&gt;smoothness, 1.0 / min_linear_grades);
	/* Restrict the smoothness with 1/min_linear_grades, because cs_is_linear
	   can't provide a better precision due to the color
	   representation with integers.
	 */
	float s = function_linearity(pfs, c0, c1);

	if (s &gt; smoothness)
	    return 0;
	code = cs_is_linear(cs, pfs-&gt;pis, pfs-&gt;dev, 
		&amp;c0-&gt;cc, &amp;c1-&gt;cc, NULL, NULL, smoothness - s);
	if (code &lt;= 0)
	    return code;
	return 1;
    }
}

private int
decompose_linear_color(patch_fill_state_t *pfs, gs_fixed_edge *le, gs_fixed_edge *re, 
	fixed ybot, fixed ytop, bool swap_axes, const patch_color_t *c0, 
	const patch_color_t *c1, int level)
{
    /* Assuming a very narrow trapezoid - ignore the transversal color variation. */
    /* Assuming the XY span is restricted with curve_samples. 
       It is important for intersection_of_small_bars to compute faster. */
    int code;
    patch_color_t c;

    if (level &gt; 100)
	return_error(gs_error_unregistered); /* Must not happen. */
    /* Use the recursive decomposition due to isnt_color_monotonic
       based on fn_is_monotonic_proc_t is_monotonic, 
       which applies to intervals. */
    patch_interpolate_color(&amp;c, c0, c1, pfs, 0.5);
    if (ytop - ybot &lt; fixed_1 / 2) /* Prevent an infinite color decomposition. */
	return constant_color_trapezoid(pfs, le, re, ybot, ytop, swap_axes, &amp;c);
    else {  
	bool monotonic_color_save = pfs-&gt;monotonic_color;
	bool linear_color_save = pfs-&gt;linear_color;

	if (!pfs-&gt;monotonic_color) {
	    code = isnt_color_monotonic(pfs, c0, c1);
	    if (code &lt; 0)
		return code;
	    if (!code)
		pfs-&gt;monotonic_color = true;
	}
	if (pfs-&gt;monotonic_color &amp;&amp; !pfs-&gt;linear_color) {
	    code = is_color_linear(pfs, c0, c1);
	    if (code &lt; 0)
		return code;
	    if (code &gt; 0)
		pfs-&gt;linear_color =  true;
	}
	if (!pfs-&gt;unlinear &amp;&amp; pfs-&gt;linear_color) {
	    gx_device *pdev = pfs-&gt;dev;
	    frac31 fc[2][GX_DEVICE_COLOR_MAX_COMPONENTS];
	    gs_fill_attributes fa;
	    gx_device_color dc[2];
	    gs_fixed_rect clip;
	    int code;

	    clip = pfs-&gt;rect;
	    if (swap_axes) {
		fixed v;

		v = clip.p.x; clip.p.x = clip.p.y; clip.p.y = v;
		v = clip.q.x; clip.q.x = clip.q.y; clip.q.y = v;
		/* Don't need adjust_swapped_boundary here. */
	    }
	    clip.p.y = max(clip.p.y, ybot);
	    clip.q.y = min(clip.q.y, ytop);
	    fa.clip = &amp;clip; 
	    fa.ht = NULL;
	    fa.swap_axes = swap_axes;
	    fa.lop = 0;
	    fa.ystart = ybot;
	    fa.yend = ytop;
	    code = patch_color_to_device_color(pfs, c0, &amp;dc[0]);
	    if (code &lt; 0)
		return code;
	    if (dc[0].type == &amp;gx_dc_type_data_pure) {
		dc2fc(pfs, dc[0].colors.pure, fc[0]);
		code = patch_color_to_device_color(pfs, c1, &amp;dc[1]);
		if (code &lt; 0)
		    return code;
		dc2fc(pfs, dc[1].colors.pure, fc[1]);
		code = dev_proc(pdev, fill_linear_color_trapezoid)(pdev, &amp;fa, 
				&amp;le-&gt;start, &amp;le-&gt;end, &amp;re-&gt;start, &amp;re-&gt;end, 
				fc[0], fc[1], NULL, NULL);
		if (code == 1) {
		    pfs-&gt;monotonic_color = monotonic_color_save;
		    pfs-&gt;linear_color = linear_color_save;
		    return 0; /* The area is filled. */
		}
		if (code &lt; 0)
		    return code;
		else /* code == 0, the device requested to decompose the area. */ 
		    return_error(gs_error_unregistered); /* Must not happen. */
	    }
	}
	if (!pfs-&gt;unlinear || !pfs-&gt;linear_color || 
		color_span(pfs, c0, c1) &gt; pfs-&gt;smoothness) {
	    fixed y = (ybot + ytop) / 2;

	    code = decompose_linear_color(pfs, le, re, ybot, y, swap_axes, c0, &amp;c, level + 1);
	    if (code &gt;= 0)
		code = decompose_linear_color(pfs, le, re, y, ytop, swap_axes, &amp;c, c1, level + 1);
	} else
	    code = constant_color_trapezoid(pfs, le, re, ybot, ytop, swap_axes, &amp;c);
	pfs-&gt;monotonic_color = monotonic_color_save;
	pfs-&gt;linear_color = linear_color_save;
	return code;
    }
}

private inline int 
linear_color_trapezoid(patch_fill_state_t *pfs, gs_fixed_point q[4], int i0, int i1, int i2, int i3, 
		fixed ybot, fixed ytop, bool swap_axes, const patch_color_t *c0, const patch_color_t *c1, 
		bool orient)
{
    /* Assuming a very narrow trapezoid - ignore the transversal color change. */
    gs_fixed_edge le, re;

    make_trapezoid(q, i0, i1, i2, i3, ybot, ytop, swap_axes, orient, &amp;le, &amp;re);
    return decompose_linear_color(pfs, &amp;le, &amp;re, ybot, ytop, swap_axes, c0, c1, 0);
}

private int
wedge_trap_decompose(patch_fill_state_t *pfs, gs_fixed_point q[4],
	fixed ybot, fixed ytop, const patch_color_t *c0, const patch_color_t *c1, 
	bool swap_axes, bool self_intersecting)
{
    /* Assuming a very narrow trapezoid - ignore the transversal color change. */
    fixed dx1, dy1, dx2, dy2;
    bool orient;

    if (!pfs-&gt;vectorization &amp;&amp; !covers_pixel_centers(ybot, ytop))
	return 0;
    if (ybot == ytop)
	return 0;
    dx1 = q[1].x - q[0].x, dy1 = q[1].y - q[0].y;
    dx2 = q[2].x - q[0].x, dy2 = q[2].y - q[0].y;
#if 1
    if (!swap_axes)
	vd_quad(q[0].x, q[0].y, q[1].x, q[1].y, q[3].x, q[3].y, q[2].x, q[2].y, 0, RGB(255, 0, 0));
    else
	vd_quad(q[0].y, q[0].x, q[1].y, q[1].x, q[3].y, q[3].x, q[2].y, q[2].x, 0, RGB(255, 0, 0));
#endif
    if ((int64_t)dx1 * dy2 != (int64_t)dy1 * dx2) {
	orient = ((int64_t)dx1 * dy2 &gt; (int64_t)dy1 * dx2);
	return linear_color_trapezoid(pfs, q, 0, 1, 2, 3, ybot, ytop, swap_axes, c0, c1, orient);
    } else {
	fixed dx3 = q[3].x - q[0].x, dy3 = q[3].y - q[0].y;

	orient = ((int64_t)dx1 * dy3 &gt; (int64_t)dy1 * dx3);
	return linear_color_trapezoid(pfs, q, 0, 1, 2, 3, ybot, ytop, swap_axes, c0, c1, orient);
    }
}

private inline int
fill_wedge_trap(patch_fill_state_t *pfs, const gs_fixed_point *p0, const gs_fixed_point *p1, 
	    const gs_fixed_point *q0, const gs_fixed_point *q1, const patch_color_t *c0, const patch_color_t *c1, 
	    bool swap_axes, bool self_intersecting)
{
    /* We assume that the width of the wedge is close to zero,
       so we can ignore the slope when computing transversal distances. */
    gs_fixed_point p[4];
    const patch_color_t *cc0, *cc1;

    if (p0-&gt;y &lt; p1-&gt;y) {
	p[2] = *p0;
	p[3] = *p1;
	cc0 = c0;
	cc1 = c1;
    } else {
	p[2] = *p1;
	p[3] = *p0;
	cc0 = c1;
	cc1 = c0;
    }
    p[0] = *q0;
    p[1] = *q1;
    return wedge_trap_decompose(pfs, p, p[2].y, p[3].y, cc0, cc1, swap_axes, self_intersecting);
}

private void
split_curve_s(const gs_fixed_point *pole, gs_fixed_point *q0, gs_fixed_point *q1, int pole_step)
{
    /*	This copies a code fragment from split_curve_midpoint,
        substituting another data type. 
     */				
    /*
     * We have to define midpoint carefully to avoid overflow.
     * (If it overflows, something really pathological is going
     * on, but we could get infinite recursion that way....)
     */
#define midpoint(a,b)\
  (arith_rshift_1(a) + arith_rshift_1(b) + (((a) | (b)) &amp; 1))
    fixed x12 = midpoint(pole[1 * pole_step].x, pole[2 * pole_step].x);
    fixed y12 = midpoint(pole[1 * pole_step].y, pole[2 * pole_step].y);

    /* q[0] and q[1] must not be the same as pole. */
    q0[1 * pole_step].x = midpoint(pole[0 * pole_step].x, pole[1 * pole_step].x);
    q0[1 * pole_step].y = midpoint(pole[0 * pole_step].y, pole[1 * pole_step].y);
    q1[2 * pole_step].x = midpoint(pole[2 * pole_step].x, pole[3 * pole_step].x);
    q1[2 * pole_step].y = midpoint(pole[2 * pole_step].y, pole[3 * pole_step].y);
    q0[2 * pole_step].x = midpoint(q0[1 * pole_step].x, x12);
    q0[2 * pole_step].y = midpoint(q0[1 * pole_step].y, y12);
    q1[1 * pole_step].x = midpoint(x12, q1[2 * pole_step].x);
    q1[1 * pole_step].y = midpoint(y12, q1[2 * pole_step].y);
    q0[0 * pole_step].x = pole[0 * pole_step].x;
    q0[0 * pole_step].y = pole[0 * pole_step].y;
    q0[3 * pole_step].x = q1[0 * pole_step].x = midpoint(q0[2 * pole_step].x, q1[1 * pole_step].x);
    q0[3 * pole_step].y = q1[0 * pole_step].y = midpoint(q0[2 * pole_step].y, q1[1 * pole_step].y);
    q1[3 * pole_step].x = pole[3 * pole_step].x;
    q1[3 * pole_step].y = pole[3 * pole_step].y;
#undef midpoint
}

private void
split_curve(const gs_fixed_point pole[4], gs_fixed_point q0[4], gs_fixed_point q1[4])
{
    split_curve_s(pole, q0, q1, 1);
}


private void
generate_inner_vertices(gs_fixed_point *p, const gs_fixed_point pole[4], int k)
{
    /* Recure to get exactly same points as when devided a patch. */
    /* An iteration can't give them preciselly. */
    if (k &gt; 1) {
	gs_fixed_point q[2][4];

	split_curve(pole, q[0], q[1]);
	p[k / 2] = q[0][3];
	generate_inner_vertices(p, q[0], k / 2);
	generate_inner_vertices(p + k / 2, q[1], k / 2);
    }
}

private inline void
do_swap_axes(gs_fixed_point *p, int k)
{
    int i;

    for (i = 0; i &lt; k; i++) {
	p[i].x ^= p[i].y; p[i].y ^= p[i].x; p[i].x ^= p[i].y;
    }
}

private inline void
y_extreme_vertice(gs_fixed_point *q, const gs_fixed_point *p, int k, int minmax)
{
    int i;
    gs_fixed_point r = *p;

    for (i = 1; i &lt; k; i++)
	if ((p[i].y - r.y) * minmax &gt; 0)
	    r = p[i];
    *q = r;	
}

private inline fixed
span_x(const gs_fixed_point *p, int k)
{
    int i;
    fixed xmin = p[0].x, xmax = p[0].x;

    for (i = 1; i &lt; k; i++) {
	xmin = min(xmin, p[i].x);
	xmax = max(xmax, p[i].x);
    }
    return xmax - xmin;
}

private inline fixed
span_y(const gs_fixed_point *p, int k)
{
    int i;
    fixed ymin = p[0].y, ymax = p[0].y;

    for (i = 1; i &lt; k; i++) {
	ymin = min(ymin, p[i].y);
	ymax = max(ymax, p[i].y);
    }
    return ymax - ymin;
}

private inline void
draw_wedge(const gs_fixed_point *p, int n)
{
#ifdef DEBUG
    int i;

    if (!vd_enabled)
	return;
    vd_setlinewidth(4);
    vd_setcolor(RGB(255, 0, 0));
    vd_beg_path;
    vd_moveto(p[0].x, p[0].y);
    for (i = 1; i &lt; n; i++)
	vd_lineto(p[i].x, p[i].y);
    vd_closepath;
    vd_end_path;
    vd_fill;
    /*vd_stroke;*/
#endif
}

private inline fixed
manhattan_dist(const gs_fixed_point *p0, const gs_fixed_point *p1)
{
    fixed dx = any_abs(p1-&gt;x - p0-&gt;x), dy = any_abs(p1-&gt;y - p0-&gt;y);

    return max(dx, dy);
}

private inline void
create_wedge_vertex_list(patch_fill_state_t *pfs, wedge_vertex_list_t *l, 
	const gs_fixed_point *p0, const gs_fixed_point *p1)
{
    assert(l-&gt;end == NULL);
    l-&gt;beg = wedge_vertex_list_elem_reserve(pfs);
    l-&gt;end = wedge_vertex_list_elem_reserve(pfs);
    assert(l-&gt;beg != NULL);
    assert(l-&gt;end != NULL);
    l-&gt;beg-&gt;prev = l-&gt;end-&gt;next = NULL;
    l-&gt;beg-&gt;next = l-&gt;end;
    l-&gt;end-&gt;prev = l-&gt;beg;
    l-&gt;beg-&gt;p = *p0;
    l-&gt;end-&gt;p = *p1;
    l-&gt;beg-&gt;level = l-&gt;end-&gt;level = 0;
}

private inline wedge_vertex_list_elem_t *
insert_wedge_vertex_list_elem(patch_fill_state_t *pfs, wedge_vertex_list_t *l, const gs_fixed_point *p)
{
    wedge_vertex_list_elem_t *e = wedge_vertex_list_elem_reserve(pfs);

    /* We have got enough free elements due to the preliminary decomposition 
       of curves to LAZY_WEDGES_MAX_LEVEL, see curve_samples. */
    assert(e != NULL); 
    assert(l-&gt;beg-&gt;next == l-&gt;end);
    assert(l-&gt;end-&gt;prev == l-&gt;beg);
    e-&gt;next = l-&gt;end;
    e-&gt;prev = l-&gt;beg;
    e-&gt;p = *p;
    e-&gt;level = max(l-&gt;beg-&gt;level, l-&gt;end-&gt;level) + 1;
    e-&gt;divide_count = 0;
    l-&gt;beg-&gt;next = l-&gt;end-&gt;prev = e;
    {	int sx = l-&gt;beg-&gt;p.x &lt; l-&gt;end-&gt;p.x ? 1 : -1;
	int sy = l-&gt;beg-&gt;p.y &lt; l-&gt;end-&gt;p.y ? 1 : -1;

	assert((p-&gt;x - l-&gt;beg-&gt;p.x) * sx &gt;= 0);
	assert((p-&gt;y - l-&gt;beg-&gt;p.y) * sy &gt;= 0);
	assert((l-&gt;end-&gt;p.x - p-&gt;x) * sx &gt;= 0);
	assert((l-&gt;end-&gt;p.y - p-&gt;y) * sy &gt;= 0);
    }
    return e;
}

private inline wedge_vertex_list_elem_t *
open_wedge_median(patch_fill_state_t *pfs, wedge_vertex_list_t *l,
	const gs_fixed_point *p0, const gs_fixed_point *p1, const gs_fixed_point *pm)
{
    wedge_vertex_list_elem_t *e;

    if (!l-&gt;last_side) {
	if (l-&gt;beg == NULL)
	    create_wedge_vertex_list(pfs, l, p0, p1);
	assert(l-&gt;beg-&gt;p.x == p0-&gt;x);
	assert(l-&gt;beg-&gt;p.y == p0-&gt;y);
	assert(l-&gt;end-&gt;p.x == p1-&gt;x);
	assert(l-&gt;end-&gt;p.y == p1-&gt;y);
	e = insert_wedge_vertex_list_elem(pfs, l, pm);
	e-&gt;divide_count++;
	return e;
    } else {
	if (l-&gt;beg == NULL) {
	    create_wedge_vertex_list(pfs, l, p1, p0);
	    e = insert_wedge_vertex_list_elem(pfs, l, pm);
	    e-&gt;divide_count++;
	    return e;
	}
	assert(l-&gt;beg-&gt;p.x == p1-&gt;x);
	assert(l-&gt;beg-&gt;p.y == p1-&gt;y);
	assert(l-&gt;end-&gt;p.x == p0-&gt;x);
	assert(l-&gt;end-&gt;p.y == p0-&gt;y);
	if (l-&gt;beg-&gt;next == l-&gt;end) {
	    e = insert_wedge_vertex_list_elem(pfs, l, pm);
	    e-&gt;divide_count++;
	    return e;
	} else {
	    e = wedge_vertex_list_find(l-&gt;beg, l-&gt;end, 
			max(l-&gt;beg-&gt;level, l-&gt;end-&gt;level) + 1);
	    assert(e != NULL);
	    assert(e-&gt;p.x == pm-&gt;x &amp;&amp; e-&gt;p.y == pm-&gt;y);
    	    e-&gt;divide_count++;
	    return e;
	}
    }
}

private inline void
make_wedge_median(patch_fill_state_t *pfs, wedge_vertex_list_t *l, 
	wedge_vertex_list_t *l0, bool forth, 
	const gs_fixed_point *p0, const gs_fixed_point *p1, const gs_fixed_point *pm)
{
    l-&gt;last_side = l0-&gt;last_side;
    if (!l-&gt;last_side ^ !forth) {
	l-&gt;end = open_wedge_median(pfs, l0, p0, p1, pm);
	l-&gt;beg = l0-&gt;beg;
    } else {
	l-&gt;beg = open_wedge_median(pfs, l0, p0, p1, pm);
	l-&gt;end = l0-&gt;end;
    }
}

private int fill_wedge_from_list(patch_fill_state_t *pfs, const wedge_vertex_list_t *l,
	    const patch_color_t *c0, const patch_color_t *c1);

private inline int
close_wedge_median(patch_fill_state_t *pfs, wedge_vertex_list_t *l,
	const patch_color_t *c0, const patch_color_t *c1)
{
    int code;

    if (!l-&gt;last_side)
	return 0;
    code = fill_wedge_from_list(pfs, l, c1, c0);
    if (code &lt; 0)
	return code;
    release_wedge_vertex_list_interval(pfs, l-&gt;beg, l-&gt;end);
    return 0;
}

private inline void
move_wedge(wedge_vertex_list_t *l, const wedge_vertex_list_t *l0, bool forth)
{
    if (!l-&gt;last_side ^ !forth) {
	l-&gt;beg = l-&gt;end;
	l-&gt;end = l0-&gt;end;
    } else {
	l-&gt;end = l-&gt;beg;
	l-&gt;beg = l0-&gt;beg;
    }
}

private inline int 
fill_triangle_wedge_aux(patch_fill_state_t *pfs,
	    const shading_vertex_t *q0, const shading_vertex_t *q1, const shading_vertex_t *q2)
{   int code;
    const gs_fixed_point *p0, *p1, *p2;
    gs_fixed_point qq0, qq1, qq2;
    fixed dx = any_abs(q0-&gt;p.x - q1-&gt;p.x), dy = any_abs(q0-&gt;p.y - q1-&gt;p.y);
    bool swap_axes;

#   if SKIP_TEST
	dbg_wedge_triangle_cnt++;
#   endif
    if (dx &gt; dy) {
	swap_axes = true;
	qq0.x = q0-&gt;p.y;
	qq0.y = q0-&gt;p.x;
	qq1.x = q1-&gt;p.y;
	qq1.y = q1-&gt;p.x;
	qq2.x = q2-&gt;p.y;
	qq2.y = q2-&gt;p.x;
	p0 = &amp;qq0;
	p1 = &amp;qq1;
	p2 = &amp;qq2;
    } else {
	swap_axes = false;
	p0 = &amp;q0-&gt;p;
	p1 = &amp;q1-&gt;p;
	p2 = &amp;q2-&gt;p;
    }
    /* We decompose the thin triangle into 2 thin trapezoids.
       An optimization with decomposing into 2 triangles
       appears low useful, because the self_intersecting argument
       with inline expansion does that job perfectly. */
    if (p0-&gt;y &lt; p1-&gt;y) {
	code = fill_wedge_trap(pfs, p0, p2, p0, p1, &amp;q0-&gt;c, &amp;q2-&gt;c, swap_axes, false);
	if (code &lt; 0)
	    return code;
	return fill_wedge_trap(pfs, p2, p1, p0, p1, &amp;q2-&gt;c, &amp;q1-&gt;c, swap_axes, false);
    } else {
	code = fill_wedge_trap(pfs, p0, p2, p1, p0, &amp;q0-&gt;c, &amp;q2-&gt;c, swap_axes, false);
	if (code &lt; 0)
	    return code;
	return fill_wedge_trap(pfs, p2, p1, p1, p0, &amp;q2-&gt;c, &amp;q1-&gt;c, swap_axes, false);
    }
}

private inline int
try_device_linear_color(patch_fill_state_t *pfs, bool wedge,
	const shading_vertex_t *p0, const shading_vertex_t *p1, 
	const shading_vertex_t *p2)
{
    /*	Returns :
	&lt;0 - error;
	0 - success;
	1 - decompose to linear color areas;
	2 - decompose to constant color areas;
     */
    int code;

    if (pfs-&gt;unlinear)
	return 2;
    if (!wedge) {
	gs_direct_color_space *cs = 
		(gs_direct_color_space *)pfs-&gt;direct_space; /* break 'const'. */
	float smoothness = max(pfs-&gt;smoothness, 1.0 / min_linear_grades);
	/* Restrict the smoothness with 1/min_linear_grades, because cs_is_linear
	   can't provide a better precision due to the color
	   representation with integers.
	 */
	float s0, s1, s2, s01, s012;

	s0 = function_linearity(pfs, &amp;p0-&gt;c, &amp;p1-&gt;c);
	if (s0 &gt; smoothness)
	    return 1;
	s1 = function_linearity(pfs, &amp;p1-&gt;c, &amp;p2-&gt;c);
	if (s1 &gt; smoothness)
	    return 1;
	s2 = function_linearity(pfs, &amp;p2-&gt;c, &amp;p0-&gt;c);
	if (s2 &gt; smoothness)
	    return 1;
	/* fixme: check an inner color ? */
	s01 = max(s0, s1);
	s012 = max(s01, s2);
	code = cs_is_linear(cs, pfs-&gt;pis, pfs-&gt;dev, 
			    &amp;p0-&gt;c.cc, &amp;p1-&gt;c.cc, &amp;p2-&gt;c.cc, NULL, smoothness - s012);
	if (code &lt; 0)
	    return code;
	if (code == 0)
	    return 1;
    }
    {   gx_device *pdev = pfs-&gt;dev;
	frac31 fc[3][GX_DEVICE_COLOR_MAX_COMPONENTS];
	gs_fill_attributes fa;
	gx_device_color dc[3];
	vd_save;

	fa.clip = &amp;pfs-&gt;rect;
	fa.ht = NULL;
	fa.swap_axes = false;
	fa.lop = 0;
	code = patch_color_to_device_color(pfs, &amp;p0-&gt;c, &amp;dc[0]);
	if (code &lt; 0)
	    return code;
	if (dc[0].type != &amp;gx_dc_type_data_pure)
	    return 2;
	dc2fc(pfs, dc[0].colors.pure, fc[0]);
	if (!wedge) {
	    code = patch_color_to_device_color(pfs, &amp;p1-&gt;c, &amp;dc[1]);
	    if (code &lt; 0)
		return code;
	    dc2fc(pfs, dc[1].colors.pure, fc[1]);
	}
	code = patch_color_to_device_color(pfs, &amp;p2-&gt;c, &amp;dc[2]);
	if (code &lt; 0)
	    return code;
	dc2fc(pfs, dc[2].colors.pure, fc[2]);
	draw_triangle(&amp;p0-&gt;p, &amp;p1-&gt;p, &amp;p2-&gt;p, RGB(255, 0, 0));
	if (!VD_TRACE_DOWN)
	    vd_disable;
	code = dev_proc(pdev, fill_linear_color_triangle)(pdev, &amp;fa, 
			&amp;p0-&gt;p, &amp;p1-&gt;p, &amp;p2-&gt;p, 
			fc[0], (wedge ? NULL : fc[1]), fc[2]);
	vd_restore;
	if (code == 1)
	    return 0; /* The area is filled. */
	if (code &lt; 0)
	    return code;
	else /* code == 0, the device requested to decompose the area. */ 
	    return 1;
    }
}

private inline int 
fill_triangle_wedge(patch_fill_state_t *pfs,
	    const shading_vertex_t *q0, const shading_vertex_t *q1, const shading_vertex_t *q2)
{
    if ((int64_t)(q1-&gt;p.x - q0-&gt;p.x) * (q2-&gt;p.y - q0-&gt;p.y) == 
	(int64_t)(q1-&gt;p.y - q0-&gt;p.y) * (q2-&gt;p.x - q0-&gt;p.x))
	return 0; /* Zero area. */
    draw_triangle(&amp;q0-&gt;p, &amp;q1-&gt;p, &amp;q2-&gt;p, RGB(255, 255, 0));
    /*
	Can't apply try_device_linear_color here
	because didn't check is_color_linear.
	Maybe need a decomposition.
	Do same as for 'unlinear', and branch later.
     */
    return fill_triangle_wedge_aux(pfs, q0, q1, q2);
}

private inline int
fill_triangle_wedge_from_list(patch_fill_state_t *pfs, 
    const wedge_vertex_list_elem_t *beg, const wedge_vertex_list_elem_t *end, 
    const wedge_vertex_list_elem_t *mid,
    const patch_color_t *c0, const patch_color_t *c1)
{
    shading_vertex_t p[3];

    p[0].p = beg-&gt;p;
    p[0].c = *c0; /* fixme : unhappy copying colors. */
    p[1].p = end-&gt;p;
    p[1].c = *c1;
    p[2].p = mid-&gt;p;
    patch_interpolate_color(&amp;p[2].c, c0, c1, pfs, 0.5);
    return fill_triangle_wedge(pfs, &amp;p[0], &amp;p[1], &amp;p[2]);
}

private int 
fill_wedge_from_list_rec(patch_fill_state_t *pfs, 
	    wedge_vertex_list_elem_t *beg, const wedge_vertex_list_elem_t *end, 
	    int level, const patch_color_t *c0, const patch_color_t *c1)
{
    if (beg-&gt;next == end)
	return 0;
    else if (beg-&gt;next-&gt;next == end) {
	assert(beg-&gt;next-&gt;divide_count == 1 || beg-&gt;next-&gt;divide_count == 2);
	if (beg-&gt;next-&gt;divide_count != 1)
	    return 0;
	return fill_triangle_wedge_from_list(pfs, beg, end, beg-&gt;next, c0, c1);
    } else {
	gs_fixed_point p;
	wedge_vertex_list_elem_t *e;
	patch_color_t c;
	int code;

	p.x = (beg-&gt;p.x + end-&gt;p.x) / 2;
	p.y = (beg-&gt;p.y + end-&gt;p.y) / 2;
	e = wedge_vertex_list_find(beg, end, level + 1);
	assert(e != NULL);
	assert(e-&gt;p.x == p.x &amp;&amp; e-&gt;p.y == p.y);
	patch_interpolate_color(&amp;c, c0, c1, pfs, 0.5);
	code = fill_wedge_from_list_rec(pfs, beg, e, level + 1, c0, &amp;c);
	if (code &lt; 0)
	    return code;
	code = fill_wedge_from_list_rec(pfs, e, end, level + 1, &amp;c, c1);
	if (code &lt; 0)
	    return code;
	assert(e-&gt;divide_count == 1 || e-&gt;divide_count == 2);
	if (e-&gt;divide_count != 1)
	    return 0;
	return fill_triangle_wedge_from_list(pfs, beg, end, e, c0, c1);
    }
}

private int 
fill_wedge_from_list(patch_fill_state_t *pfs, const wedge_vertex_list_t *l,
	    const patch_color_t *c0, const patch_color_t *c1)
{
    return fill_wedge_from_list_rec(pfs, l-&gt;beg, l-&gt;end, 
		    max(l-&gt;beg-&gt;level, l-&gt;end-&gt;level), c0, c1);
}

private inline int
terminate_wedge_vertex_list(patch_fill_state_t *pfs, wedge_vertex_list_t *l,
	const patch_color_t *c0, const patch_color_t *c1)
{
    if (l-&gt;beg != NULL) {
	int code = fill_wedge_from_list(pfs, l, c0, c1);

	if (code &lt; 0)
	    return code;
	release_wedge_vertex_list(pfs, l, 1);
    }
    return 0;
}

private int
wedge_by_triangles(patch_fill_state_t *pfs, int ka, 
	const gs_fixed_point pole[4], const patch_color_t *c0, const patch_color_t *c1)
{   /* Assuming ka &gt;= 2, see fill_wedges. */
    gs_fixed_point q[2][4];
    shading_vertex_t p[3];
    int code;

    split_curve(pole, q[0], q[1]);
    p[0].p = pole[0];
    p[0].c = *c0; /* fixme : unhappy copying colors. */
    p[1].p = pole[3];
    p[1].c = *c1;
    p[2].p = q[0][3];
    patch_interpolate_color(&amp;p[2].c, c0, c1, pfs, 0.5);
    code = fill_triangle_wedge(pfs, &amp;p[0], &amp;p[1], &amp;p[2]);
    if (code &lt; 0)
	return code;
    if (ka == 2)
	return 0;
    code = wedge_by_triangles(pfs, ka / 2, q[0], c0, &amp;p[2].c);
    if (code &lt; 0)
	return code;
    return wedge_by_triangles(pfs, ka / 2, q[1], &amp;p[2].c, c1);
}

private inline bool
is_linear_color_applicable(const patch_fill_state_t *pfs)
{
    if (!USE_LINEAR_COLOR_PROCS)
	return false;
    if (pfs-&gt;dev-&gt;color_info.separable_and_linear != GX_CINFO_SEP_LIN)
	return false;
    if (gx_get_cmap_procs(pfs-&gt;pis, pfs-&gt;dev)-&gt;is_halftoned(pfs-&gt;pis, pfs-&gt;dev))
	return false;
    return true;
}

int
mesh_padding(patch_fill_state_t *pfs, const gs_fixed_point *p0, const gs_fixed_point *p1, 
	    const patch_color_t *c0, const patch_color_t *c1)
{
    gs_fixed_point q0, q1;
    const patch_color_t *cc0, *cc1;
    fixed dx = p1-&gt;x - p0-&gt;x;
    fixed dy = p1-&gt;y - p0-&gt;y;
    bool swap_axes = (any_abs(dx) &gt; any_abs(dy));
    gs_fixed_edge le, re;
    const fixed adjust = INTERPATCH_PADDING;

    pfs-&gt;unlinear = !is_linear_color_applicable(pfs);
    if (swap_axes) {
	if (p0-&gt;x &lt; p1-&gt;x) {
	    q0.x = p0-&gt;y;
	    q0.y = p0-&gt;x;
	    q1.x = p1-&gt;y;
	    q1.y = p1-&gt;x;
	    cc0 = c0;
	    cc1 = c1;
	} else {
	    q0.x = p1-&gt;y;
	    q0.y = p1-&gt;x;
	    q1.x = p0-&gt;y;
	    q1.y = p0-&gt;x;
	    cc0 = c1;
	    cc1 = c0;
	}
    } else if (p0-&gt;y &lt; p1-&gt;y) {
	q0 = *p0;
	q1 = *p1;
	cc0 = c0;
	cc1 = c1;
    } else {
	q0 = *p1;
	q1 = *p0;
	cc0 = c1;
	cc1 = c0;
    }
    le.start.x = q0.x - adjust;
    re.start.x = q0.x + adjust;
    le.start.y = re.start.y = q0.y - adjust;
    le.end.x = q1.x - adjust;
    re.end.x = q1.x + adjust;
    le.end.y = re.end.y = q1.y + adjust;
    adjust_swapped_boundary(&amp;re.start.x, swap_axes);
    adjust_swapped_boundary(&amp;re.end.x, swap_axes);
    return decompose_linear_color(pfs, &amp;le, &amp;re, le.start.y, le.end.y, swap_axes, cc0, cc1, 0);
    /* fixme : for a better performance and quality, we would like to 
       consider the bar as an oriented one and to know at what side of it the spot resides.
       If we know that, we could expand only to outside the spot.
       Note that if the boundary has a self-intersection,
       we still need to expand to both directions.
     */
}

private int
fill_wedges_aux(patch_fill_state_t *pfs, int k, int ka, 
	const gs_fixed_point pole[4], const patch_color_t *c0, const patch_color_t *c1,
	int wedge_type)
{
    int code;

    if (k &gt; 1) {
	gs_fixed_point q[2][4];
	patch_color_t c;

	patch_interpolate_color(&amp;c, c0, c1, pfs, 0.5);
	split_curve(pole, q[0], q[1]);
	code = fill_wedges_aux(pfs, k / 2, ka, q[0], c0, &amp;c, wedge_type);
	if (code &lt; 0)
	    return code;
	return fill_wedges_aux(pfs, k / 2, ka, q[1], &amp;c, c1, wedge_type);
    } else {
	if (INTERPATCH_PADDING &amp;&amp; (wedge_type &amp; interpatch_padding)) {
	    vd_bar(pole[0].x, pole[0].y, pole[3].x, pole[3].y, 0, RGB(255, 0, 0));
	    code = mesh_padding(pfs, &amp;pole[0], &amp;pole[3], c0, c1);
	    if (code &lt; 0)
		return code;
	}
	if (ka &gt;= 2 &amp;&amp; (wedge_type &amp; inpatch_wedge))
	    return wedge_by_triangles(pfs, ka, pole, c0, c1);
	return 0;
    }
}

private int
fill_wedges(patch_fill_state_t *pfs, int k0, int k1, 
	const gs_fixed_point *pole, int pole_step, 
	const patch_color_t *c0, const patch_color_t *c1, int wedge_type)
{
    /* Generate wedges between 2 variants of a curve flattening. */
    /* k0, k1 is a power of 2. */
    gs_fixed_point p[4];

    if (!(wedge_type &amp; interpatch_padding) &amp;&amp; k0 == k1)
	return 0; /* Wedges are zero area. */
    if (k0 &gt; k1) {
	k0 ^= k1; k1 ^= k0; k0 ^= k1;
    }
    p[0] = pole[0];
    p[1] = pole[pole_step];
    p[2] = pole[pole_step * 2];
    p[3] = pole[pole_step * 3];
    return fill_wedges_aux(pfs, k0, k1 / k0, p, c0, c1, wedge_type);
}

private inline void
make_vertices(gs_fixed_point q[4], const quadrangle_patch *p)
{
    q[0] = p-&gt;p[0][0]-&gt;p;
    q[1] = p-&gt;p[0][1]-&gt;p;
    q[2] = p-&gt;p[1][1]-&gt;p;
    q[3] = p-&gt;p[1][0]-&gt;p;
}

private inline void
wrap_vertices_by_y(gs_fixed_point q[4], const gs_fixed_point s[4])
{
    fixed y = s[0].y;
    int i = 0;

    if (y &gt; s[1].y)
	i = 1, y = s[1].y;
    if (y &gt; s[2].y)
	i = 2, y = s[2].y;
    if (y &gt; s[3].y)
	i = 3, y = s[3].y;
    q[0] = s[(i + 0) % 4];
    q[1] = s[(i + 1) % 4];
    q[2] = s[(i + 2) % 4];
    q[3] = s[(i + 3) % 4];
}

private int 
ordered_triangle(patch_fill_state_t *pfs, gs_fixed_edge *le, gs_fixed_edge *re, patch_color_t *c)
{
    gs_fixed_edge ue;
    int code;
    gx_device_color dc;
    vd_save;

#   if NOFILL_TEST
	if (dbg_nofill)
	    return 0;
#   endif
    if (!VD_TRACE_DOWN)
        vd_disable;
    code = patch_color_to_device_color(pfs, c, &amp;dc);
    if (code &lt; 0)
	return code;
    if (le-&gt;end.y &lt; re-&gt;end.y) {
	code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
	    le, re, le-&gt;start.y, le-&gt;end.y, false, &amp;dc, pfs-&gt;pis-&gt;log_op);
	if (code &gt;= 0) {
	    ue.start = le-&gt;end;
	    ue.end = re-&gt;end;
	    code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
		&amp;ue, re, le-&gt;end.y, re-&gt;end.y, false, &amp;dc, pfs-&gt;pis-&gt;log_op);
	}
    } else if (le-&gt;end.y &gt; re-&gt;end.y) {
	code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
	    le, re, le-&gt;start.y, re-&gt;end.y, false, &amp;dc, pfs-&gt;pis-&gt;log_op);
	if (code &gt;= 0) {
	    ue.start = re-&gt;end;
	    ue.end = le-&gt;end;
	    code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
		le, &amp;ue, re-&gt;end.y, le-&gt;end.y, false, &amp;dc, pfs-&gt;pis-&gt;log_op);
	}
    } else
	code = dev_proc(pfs-&gt;dev, fill_trapezoid)(pfs-&gt;dev,
	    le, re, le-&gt;start.y, le-&gt;end.y, false, &amp;dc, pfs-&gt;pis-&gt;log_op);
    vd_restore;
    return code;
}

private int 
constant_color_triangle(patch_fill_state_t *pfs,
	const shading_vertex_t *p0, const shading_vertex_t *p1, const shading_vertex_t *p2)
{
    patch_color_t c, cc;
    gs_fixed_edge le, re;
    fixed dx0, dy0, dx1, dy1;
    const shading_vertex_t *pp;
    int i;

    draw_triangle(&amp;p0-&gt;p, &amp;p1-&gt;p, &amp;p2-&gt;p, RGB(255, 0, 0));
    patch_interpolate_color(&amp;c, &amp;p0-&gt;c, &amp;p1-&gt;c, pfs, 0.5);
    patch_interpolate_color(&amp;cc, &amp;p2-&gt;c, &amp;c, pfs, 0.5);
    for (i = 0; i &lt; 3; i++) {
	/* fixme : does optimizer compiler expand this cycle ? */
	if (p0-&gt;p.y &lt;= p1-&gt;p.y &amp;&amp; p0-&gt;p.y &lt;= p2-&gt;p.y) {
	    le.start = re.start = p0-&gt;p;
	    le.end = p1-&gt;p; 
	    re.end = p2-&gt;p;

	    dx0 = le.end.x - le.start.x;
	    dy0 = le.end.y - le.start.y;
	    dx1 = re.end.x - re.start.x;
	    dy1 = re.end.y - re.start.y;
	    if ((int64_t)dx0 * dy1 &lt; (int64_t)dy0 * dx1)
    		return ordered_triangle(pfs, &amp;le, &amp;re, &amp;c);
	    else
    		return ordered_triangle(pfs, &amp;re, &amp;le, &amp;c);
	}
	pp = p0; p0 = p1; p1 = p2; p2 = pp;
    }
    return 0;
}


private int 
constant_color_quadrangle(patch_fill_state_t *pfs, const quadrangle_patch *p, bool self_intersecting)
{
    /* Assuming the XY span is restricted with curve_samples. 
       It is important for intersection_of_small_bars to compute faster. */
    gs_fixed_point q[4];
    fixed ry, ey;
    int code;
    bool swap_axes = false;
    gx_device_color dc;
    patch_color_t c1, c2, c;
    bool orient;

    draw_quadrangle(p, RGB(0, 255, 0));
    patch_interpolate_color(&amp;c1, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[0][1]-&gt;c, pfs, 0.5);
    patch_interpolate_color(&amp;c2, &amp;p-&gt;p[1][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c, pfs, 0.5);
    patch_interpolate_color(&amp;c, &amp;c1, &amp;c2, pfs, 0.5);
    code = patch_color_to_device_color(pfs, &amp;c, &amp;dc);
    if (code &lt; 0)
	return code;
    {	gs_fixed_point qq[4];

	make_vertices(qq, p);
#	if 0 /* Swapping axes may improve the precision, 
		but slows down due to the area expantion needed
		in gx_shade_trapezoid. */
	    dx = span_x(qq, 4);
	    dy = span_y(qq, 4);
	    if (dy &lt; dx) {
		do_swap_axes(qq, 4);
		swap_axes = true;
	    }
#	endif
	wrap_vertices_by_y(q, qq);
    }
    {	fixed dx1 = q[1].x - q[0].x, dy1 = q[1].y - q[0].y;
	fixed dx3 = q[3].x - q[0].x, dy3 = q[3].y - q[0].y;
	int64_t g13 = (int64_t)dx1 * dy3, h13 = (int64_t)dy1 * dx3;

	if (g13 == h13) {
	    fixed dx2 = q[2].x - q[0].x, dy2 = q[2].y - q[0].y;
	    int64_t g23 = (int64_t)dx2 * dy3, h23 = (int64_t)dy2 * dx3;

	    if (dx1 == 0 &amp;&amp; dy1 == 0 &amp;&amp; g23 == h23)
		return 0;
	    if (g23 != h23) {
		orient = (g23 &gt; h23);
		if (q[2].y &lt;= q[3].y) {
		    if ((code = gx_shade_trapezoid(pfs, q, 1, 2, 0, 3, q[1].y, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
			return code;
		    return gx_shade_trapezoid(pfs, q, 2, 3, 0, 3, q[2].y, q[3].y, swap_axes, &amp;dc, orient);
		} else {
		    if ((code = gx_shade_trapezoid(pfs, q, 1, 2, 0, 3, q[1].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
			return code;
		    return gx_shade_trapezoid(pfs, q, 1, 2, 3, 2, q[3].y, q[2].y, swap_axes, &amp;dc, orient);
		}
	    } else {
		int64_t g12 = (int64_t)dx1 * dy2, h12 = (int64_t)dy1 * dx2;

		if (dx3 == 0 &amp;&amp; dy3 == 0 &amp;&amp; g12 == h12)
		    return 0;
		orient = (g12 &gt; h12);
		if (q[1].y &lt;= q[2].y) {
		    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 3, 2, q[0].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
			return code;
		    return gx_shade_trapezoid(pfs, q, 1, 2, 3, 2, q[1].y, q[2].y, swap_axes, &amp;dc, orient);
		} else {
		    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 3, 2, q[0].y, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
			return code;
		    return gx_shade_trapezoid(pfs, q, 0, 1, 2, 1, q[2].y, q[1].y, swap_axes, &amp;dc, orient);
		}
	    }
	}
	orient = ((int64_t)dx1 * dy3 &gt; (int64_t)dy1 * dx3);
    }
    if (q[1].y &lt;= q[2].y &amp;&amp; q[2].y &lt;= q[3].y) {
	if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 3, 1, 2, &amp;ry, &amp;ey)) {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 3, 1, 2, q[1].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 1, 2, 0, 3, ry, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 0, 3, 2, 3, q[2].y, q[3].y, swap_axes, &amp;dc, orient);
	} else {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 1, 2, 0, 3, q[1].y, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 2, 3, 0, 3, q[2].y, q[3].y, swap_axes, &amp;dc, orient);
	}
    } else if (q[1].y &lt;= q[3].y &amp;&amp; q[3].y &lt;= q[2].y) {
	if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 3, 1, 2, &amp;ry, &amp;ey)) {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 1, 2, 0, 3, q[1].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 3, 1, 2, ry, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 3, 2, 1, 2, q[3].y, q[2].y, swap_axes, &amp;dc, orient);
	} else {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 1, 2, 0, 3, q[1].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 1, 2, 3, 2, q[3].y, q[2].y, swap_axes, &amp;dc, orient);
	}
    } else if (q[2].y &lt;= q[1].y &amp;&amp; q[1].y &lt;= q[3].y) {
	if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 1, 2, 3, &amp;ry, &amp;ey)) {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 1, 2, 3, q[2].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 1, 0, 1, ry, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 2, 3, 0, 3, ry, q[3].y, swap_axes, &amp;dc, orient);
	} else if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 3, 1, 2, &amp;ry, &amp;ey)) {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 1, 2, 3, q[2].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 2, 1, ry, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 0, 3, 2, 3, ry, q[3].y, swap_axes, &amp;dc, orient);
	} else {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 3, 2, 1, q[2].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 2, 3, 0, 3, q[1].y, q[3].y, swap_axes, &amp;dc, orient);
	}
    } else if (q[2].y &lt;= q[3].y &amp;&amp; q[3].y &lt;= q[1].y) {
	if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 1, 2, 3, &amp;ry, &amp;ey)) {
	    /* Same code as someone above. */
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 1, 2, 3, q[2].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 1, 0, 1, ry, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 2, 3, 0, 3, ry, q[3].y, swap_axes, &amp;dc, orient);
	} else if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 3, 2, 1, &amp;ry, &amp;ey)) {
	    /* Same code as someone above. */
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 1, 2, 3, q[2].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 2, 1, ry, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 0, 3, 2, 3, ry, q[3].y, swap_axes, &amp;dc, orient);
	} else {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 2, 3, 0, 3, q[2].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 0, 1, 2, 1, q[2].y, q[1].y, swap_axes, &amp;dc, orient);
	}
    } else if (q[3].y &lt;= q[1].y &amp;&amp; q[1].y &lt;= q[2].y) {
	if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 1, 3, 2, &amp;ry, &amp;ey)) {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 3, 2, q[3].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 3, 2, 0, 1, ry, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 3, 2, 1, 2, q[1].y, q[2].y, swap_axes, &amp;dc, orient);
	} else {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 3, 2, q[3].y, q[1].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 1, 2, 3, 2, q[1].y, q[2].y, swap_axes, &amp;dc, orient);
	}
    } else if (q[3].y &lt;= q[2].y &amp;&amp; q[2].y &lt;= q[1].y) {
	if (self_intersecting &amp;&amp; intersection_of_small_bars(q, 0, 1, 2, 3, &amp;ry, &amp;ey)) {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 3, 2, q[3].y, ry + ey, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 3, 2, 0, 1, ry, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 2, 1, 0, 1, q[2].y, q[1].y, swap_axes, &amp;dc, orient);
	} else {
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 0, 3, q[0].y, q[3].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    if ((code = gx_shade_trapezoid(pfs, q, 0, 1, 3, 2, q[3].y, q[2].y, swap_axes, &amp;dc, orient)) &lt; 0)
		return code;
	    return gx_shade_trapezoid(pfs, q, 0, 1, 2, 1, q[2].y, q[1].y, swap_axes, &amp;dc, orient);
	}
    } else {
	/* Impossible. */
	return_error(gs_error_unregistered);
    }
}

private inline void
divide_quadrangle_by_v(patch_fill_state_t *pfs, quadrangle_patch *s0, quadrangle_patch *s1, 
	    shading_vertex_t q[2], const quadrangle_patch *p)
{
    q[0].p.x = (p-&gt;p[0][0]-&gt;p.x + p-&gt;p[1][0]-&gt;p.x) / 2;
    q[1].p.x = (p-&gt;p[0][1]-&gt;p.x + p-&gt;p[1][1]-&gt;p.x) / 2;
    q[0].p.y = (p-&gt;p[0][0]-&gt;p.y + p-&gt;p[1][0]-&gt;p.y) / 2;
    q[1].p.y = (p-&gt;p[0][1]-&gt;p.y + p-&gt;p[1][1]-&gt;p.y) / 2;
    patch_interpolate_color(&amp;q[0].c, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[1][0]-&gt;c, pfs, 0.5);
    patch_interpolate_color(&amp;q[1].c, &amp;p-&gt;p[0][1]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c, pfs, 0.5);
    s0-&gt;p[0][0] = p-&gt;p[0][0];
    s0-&gt;p[0][1] = p-&gt;p[0][1];
    s0-&gt;p[1][0] = s1-&gt;p[0][0] = &amp;q[0];
    s0-&gt;p[1][1] = s1-&gt;p[0][1] = &amp;q[1];
    s1-&gt;p[1][0] = p-&gt;p[1][0];
    s1-&gt;p[1][1] = p-&gt;p[1][1];
}

private inline void
divide_quadrangle_by_u(patch_fill_state_t *pfs, quadrangle_patch *s0, quadrangle_patch *s1, 
	    shading_vertex_t q[2], const quadrangle_patch *p)
{
    q[0].p.x = (p-&gt;p[0][0]-&gt;p.x + p-&gt;p[0][1]-&gt;p.x) / 2;
    q[1].p.x = (p-&gt;p[1][0]-&gt;p.x + p-&gt;p[1][1]-&gt;p.x) / 2;
    q[0].p.y = (p-&gt;p[0][0]-&gt;p.y + p-&gt;p[0][1]-&gt;p.y) / 2;
    q[1].p.y = (p-&gt;p[1][0]-&gt;p.y + p-&gt;p[1][1]-&gt;p.y) / 2;
    patch_interpolate_color(&amp;q[0].c, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[0][1]-&gt;c, pfs, 0.5);
    patch_interpolate_color(&amp;q[1].c, &amp;p-&gt;p[1][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c, pfs, 0.5);
    s0-&gt;p[0][0] = p-&gt;p[0][0];
    s0-&gt;p[1][0] = p-&gt;p[1][0];
    s0-&gt;p[0][1] = s1-&gt;p[0][0] = &amp;q[0];
    s0-&gt;p[1][1] = s1-&gt;p[1][0] = &amp;q[1];
    s1-&gt;p[0][1] = p-&gt;p[0][1];
    s1-&gt;p[1][1] = p-&gt;p[1][1];
}

private inline int
is_quadrangle_color_monotonic(const patch_fill_state_t *pfs, const quadrangle_patch *p, 
			      bool *not_monotonic_by_u, bool *not_monotonic_by_v) 
{   /* returns : 1 = monotonic, 0 = don't know, &lt;0 = error. */
    int code;

    code = isnt_color_monotonic(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
    if (code &lt;= 0)
	return code;
    if (code &amp; 1)
	*not_monotonic_by_v = true;
    if (code &amp; 2)
	*not_monotonic_by_u = true;
    return !code;
}

private inline bool
quadrangle_bbox_covers_pixel_centers(const quadrangle_patch *p)
{
    fixed xbot, xtop, ybot, ytop;
    
    xbot = min(min(p-&gt;p[0][0]-&gt;p.x, p-&gt;p[0][1]-&gt;p.x),
	       min(p-&gt;p[1][0]-&gt;p.x, p-&gt;p[1][1]-&gt;p.x));
    xtop = max(max(p-&gt;p[0][0]-&gt;p.x, p-&gt;p[0][1]-&gt;p.x),
	       max(p-&gt;p[1][0]-&gt;p.x, p-&gt;p[1][1]-&gt;p.x));
    if (covers_pixel_centers(xbot, xtop))
	return true;
    ybot = min(min(p-&gt;p[0][0]-&gt;p.y, p-&gt;p[0][1]-&gt;p.y),
	       min(p-&gt;p[1][0]-&gt;p.y, p-&gt;p[1][1]-&gt;p.y));
    ytop = max(max(p-&gt;p[0][0]-&gt;p.y, p-&gt;p[0][1]-&gt;p.y),
	       max(p-&gt;p[1][0]-&gt;p.y, p-&gt;p[1][1]-&gt;p.y));
    if (covers_pixel_centers(ybot, ytop))
	return true;
    return false;
}

private inline void
divide_bar(patch_fill_state_t *pfs, 
	const shading_vertex_t *p0, const shading_vertex_t *p1, int radix, shading_vertex_t *p)
{
    p-&gt;p.x = (fixed)((int64_t)p0-&gt;p.x * (radix - 1) + p1-&gt;p.x) / radix;
    p-&gt;p.y = (fixed)((int64_t)p0-&gt;p.y * (radix - 1) + p1-&gt;p.y) / radix;
    patch_interpolate_color(&amp;p-&gt;c, &amp;p0-&gt;c, &amp;p1-&gt;c, pfs, (double)(radix - 1) / radix);
}

private inline void
bbox_of_points(gs_fixed_rect *r, 
	const gs_fixed_point *p0, const gs_fixed_point *p1,
	const gs_fixed_point *p2, const gs_fixed_point *p3)
{
    r-&gt;p.x = r-&gt;q.x = p0-&gt;x;
    r-&gt;p.y = r-&gt;q.y = p0-&gt;y;

    if (r-&gt;p.x &gt; p1-&gt;x)
	r-&gt;p.x = p1-&gt;x;
    if (r-&gt;q.x &lt; p1-&gt;x)
	r-&gt;q.x = p1-&gt;x;
    if (r-&gt;p.y &gt; p1-&gt;y)
	r-&gt;p.y = p1-&gt;y;
    if (r-&gt;q.y &lt; p1-&gt;y)
	r-&gt;q.y = p1-&gt;y;

    if (r-&gt;p.x &gt; p2-&gt;x)
	r-&gt;p.x = p2-&gt;x;
    if (r-&gt;q.x &lt; p2-&gt;x)
	r-&gt;q.x = p2-&gt;x;
    if (r-&gt;p.y &gt; p2-&gt;y)
	r-&gt;p.y = p2-&gt;y;
    if (r-&gt;q.y &lt; p2-&gt;y)
	r-&gt;q.y = p2-&gt;y;

    if (p3 == NULL)
	return;

    if (r-&gt;p.x &gt; p3-&gt;x)
	r-&gt;p.x = p3-&gt;x;
    if (r-&gt;q.x &lt; p3-&gt;x)
	r-&gt;q.x = p3-&gt;x;
    if (r-&gt;p.y &gt; p3-&gt;y)
	r-&gt;p.y = p3-&gt;y;
    if (r-&gt;q.y &lt; p3-&gt;y)
	r-&gt;q.y = p3-&gt;y;
}

private int 
triangle_by_4(patch_fill_state_t *pfs, 
	const shading_vertex_t *p0, const shading_vertex_t *p1, const shading_vertex_t *p2, 
	wedge_vertex_list_t *l01, wedge_vertex_list_t *l12, wedge_vertex_list_t *l20,
	double cd, fixed sd)
{
    shading_vertex_t p01, p12, p20;
    wedge_vertex_list_t L01, L12, L20, L[3];
    bool inside_save = pfs-&gt;inside;
    gs_fixed_rect r, r1;
    int code;
    
    if (!pfs-&gt;inside) {
	bbox_of_points(&amp;r, &amp;p0-&gt;p, &amp;p1-&gt;p, &amp;p2-&gt;p, NULL);
	r1 = r;
	rect_intersect(r, pfs-&gt;rect);
	if (r.q.x &lt;= r.p.x || r.q.y &lt;= r.p.y)
	    return 0; /* Outside. */
    }
    code = try_device_linear_color(pfs, false, p0, p1, p2);
    switch(code) {
	case 0: /* The area is filled. */
	    return 0;
	case 2: /* decompose to constant color areas */
	    if (sd &lt; fixed_1 * 4)
		return constant_color_triangle(pfs, p2, p0, p1);
	    if (pfs-&gt;Function != NULL) {
		double d01 = color_span(pfs, &amp;p1-&gt;c, &amp;p0-&gt;c);
		double d12 = color_span(pfs, &amp;p2-&gt;c, &amp;p1-&gt;c);
		double d20 = color_span(pfs, &amp;p0-&gt;c, &amp;p2-&gt;c);

		if (d01 &lt;= pfs-&gt;smoothness / COLOR_CONTIGUITY &amp;&amp; 
		    d12 &lt;= pfs-&gt;smoothness / COLOR_CONTIGUITY &amp;&amp; 
		    d20 &lt;= pfs-&gt;smoothness / COLOR_CONTIGUITY)
		    return constant_color_triangle(pfs, p2, p0, p1);
	    } else if (cd &lt;= pfs-&gt;smoothness / COLOR_CONTIGUITY)
		return constant_color_triangle(pfs, p2, p0, p1);
	    break;
	case 1: /* decompose to linear color areas */
	    if (sd &lt; fixed_1)
		return constant_color_triangle(pfs, p2, p0, p1);
	    break;
	default: /* Error. */
	    return code;
    }
    if (!pfs-&gt;inside) {
	if (r.p.x == r1.p.x &amp;&amp; r.p.y == r1.p.y &amp;&amp; 
	    r.q.x == r1.q.x &amp;&amp; r.q.y == r1.q.y)
	    pfs-&gt;inside = true;
    }
    divide_bar(pfs, p0, p1, 2, &amp;p01);
    divide_bar(pfs, p1, p2, 2, &amp;p12);
    divide_bar(pfs, p2, p0, 2, &amp;p20);
    if (LAZY_WEDGES) {
	init_wedge_vertex_list(L, count_of(L));
	make_wedge_median(pfs, &amp;L01, l01, true,  &amp;p0-&gt;p, &amp;p1-&gt;p, &amp;p01.p);
	make_wedge_median(pfs, &amp;L12, l12, true,  &amp;p1-&gt;p, &amp;p2-&gt;p, &amp;p12.p);
	make_wedge_median(pfs, &amp;L20, l20, false, &amp;p2-&gt;p, &amp;p0-&gt;p, &amp;p20.p);
    } else {
	code = fill_triangle_wedge(pfs, p0, p1, &amp;p01);
	if (code &lt; 0)
	    return code;
	code = fill_triangle_wedge(pfs, p1, p2, &amp;p12);
	if (code &lt; 0)
	    return code;
	code = fill_triangle_wedge(pfs, p2, p0, &amp;p20);
	if (code &lt; 0)
	    return code;
    }
    code = triangle_by_4(pfs, p0, &amp;p01, &amp;p20, &amp;L01, &amp;L[0], &amp;L20, cd / 2, sd / 2);
    if (code &lt; 0)
	return code;
    if (LAZY_WEDGES) {
	move_wedge(&amp;L01, l01, true);
	move_wedge(&amp;L20, l20, false);
    }
    code = triangle_by_4(pfs, p1, &amp;p12, &amp;p01, &amp;L12, &amp;L[1], &amp;L01, cd / 2, sd / 2);
    if (code &lt; 0)
	return code;
    if (LAZY_WEDGES)
	move_wedge(&amp;L12, l12, true);
    code = triangle_by_4(pfs, p2, &amp;p20, &amp;p12, &amp;L20, &amp;L[2], &amp;L12, cd / 2, sd / 2);
    if (code &lt; 0)
	return code;
    L[0].last_side = L[1].last_side = L[2].last_side = true;
    code = triangle_by_4(pfs, &amp;p01, &amp;p12, &amp;p20, &amp;L[1], &amp;L[2], &amp;L[0], cd / 2, sd / 2);
    if (code &lt; 0)
	return code;
    if (LAZY_WEDGES) {
	code = close_wedge_median(pfs, l01, &amp;p0-&gt;c, &amp;p1-&gt;c);
	if (code &lt; 0)
	    return code;
	code = close_wedge_median(pfs, l12, &amp;p1-&gt;c, &amp;p2-&gt;c);
	if (code &lt; 0)
	    return code;
	code = close_wedge_median(pfs, l20, &amp;p2-&gt;c, &amp;p0-&gt;c);
	if (code &lt; 0)
	    return code;
	code = terminate_wedge_vertex_list(pfs, &amp;L[0], &amp;p01.c, &amp;p20.c);
	if (code &lt; 0)
	    return code;
	code = terminate_wedge_vertex_list(pfs, &amp;L[1], &amp;p12.c, &amp;p01.c);
	if (code &lt; 0)
	    return code;
	code = terminate_wedge_vertex_list(pfs, &amp;L[2], &amp;p20.c, &amp;p12.c);
	if (code &lt; 0)
	    return code;
    }
    pfs-&gt;inside = inside_save;
    return 0;
}

private inline int 
fill_triangle(patch_fill_state_t *pfs, 
	const shading_vertex_t *p0, const shading_vertex_t *p1, const shading_vertex_t *p2,
	wedge_vertex_list_t *l01, wedge_vertex_list_t *l12, wedge_vertex_list_t *l20)
{
    fixed sd01 = max(any_abs(p1-&gt;p.x - p0-&gt;p.x), any_abs(p1-&gt;p.y - p0-&gt;p.y));
    fixed sd12 = max(any_abs(p2-&gt;p.x - p1-&gt;p.x), any_abs(p2-&gt;p.y - p1-&gt;p.y));
    fixed sd20 = max(any_abs(p0-&gt;p.x - p2-&gt;p.x), any_abs(p0-&gt;p.y - p2-&gt;p.y));
    fixed sd1 = max(sd01, sd12);
    fixed sd = max(sd1, sd20);
    double cd = 0;

#   if SKIP_TEST
	dbg_triangle_cnt++;
#   endif
    if (pfs-&gt;Function == NULL) {
    	double d01 = color_span(pfs, &amp;p1-&gt;c, &amp;p0-&gt;c);
	double d12 = color_span(pfs, &amp;p2-&gt;c, &amp;p1-&gt;c);
	double d20 = color_span(pfs, &amp;p0-&gt;c, &amp;p2-&gt;c);
	double cd1 = max(d01, d12);
	
	cd = max(cd1, d20);
    }
    return triangle_by_4(pfs, p0, p1, p2, l01, l12, l20, cd, sd);
}

private int 
small_mesh_triangle(patch_fill_state_t *pfs, 
	const shading_vertex_t *p0, const shading_vertex_t *p1, const shading_vertex_t *p2)
{
    int code;
    wedge_vertex_list_t l[3];

    init_wedge_vertex_list(l, count_of(l));
    code = fill_triangle(pfs, p0, p1, p2, &amp;l[0], &amp;l[1], &amp;l[2]);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l[0], &amp;p0-&gt;c, &amp;p1-&gt;c);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l[1], &amp;p1-&gt;c, &amp;p2-&gt;c);
    if (code &lt; 0)
	return code;
    return terminate_wedge_vertex_list(pfs, &amp;l[2], &amp;p2-&gt;c, &amp;p0-&gt;c);
}

private int
mesh_triangle_rec(patch_fill_state_t *pfs, 
	const shading_vertex_t *p0, const shading_vertex_t *p1, const shading_vertex_t *p2)
{
    pfs-&gt;unlinear = !is_linear_color_applicable(pfs);
    if (manhattan_dist(&amp;p0-&gt;p, &amp;p1-&gt;p) &lt; pfs-&gt;max_small_coord &amp;&amp;
	manhattan_dist(&amp;p1-&gt;p, &amp;p2-&gt;p) &lt; pfs-&gt;max_small_coord &amp;&amp;
	manhattan_dist(&amp;p2-&gt;p, &amp;p0-&gt;p) &lt; pfs-&gt;max_small_coord)
	return small_mesh_triangle(pfs, p0, p1, p2);
    else {
	/* Subdivide into 4 triangles with 3 triangle non-lazy wedges.
	   Doing so against the wedge_vertex_list_elem_buffer overflow.
	   We could apply a smarter method, dividing long sides 
	   with no wedges and short sides with lazy wedges.
	   This needs to start wedges dynamically when 
	   a side becomes short. We don't do so because the 
	   number of checks per call significantly increases
	   and the logics is complicated, but the performance 
	   advantage appears small due to big meshes are rare.
	 */
	shading_vertex_t p01, p12, p20;
	int code;

	divide_bar(pfs, p0, p1, 2, &amp;p01);
	divide_bar(pfs, p1, p2, 2, &amp;p12);
	divide_bar(pfs, p2, p0, 2, &amp;p20);
	code = fill_triangle_wedge(pfs, p0, p1, &amp;p01);
	if (code &lt; 0)
	    return code;
	code = fill_triangle_wedge(pfs, p1, p2, &amp;p12);
	if (code &lt; 0)
	    return code;
	code = fill_triangle_wedge(pfs, p2, p0, &amp;p20);
	if (code &lt; 0)
	    return code;
	code = mesh_triangle_rec(pfs, p0, &amp;p01, &amp;p20);
	if (code &lt; 0)
	    return code;
	code = mesh_triangle_rec(pfs, p1, &amp;p12, &amp;p01);
	if (code &lt; 0)
	    return code;
	code = mesh_triangle_rec(pfs, p2, &amp;p20, &amp;p12);
	if (code &lt; 0)
	    return code;
	return mesh_triangle_rec(pfs, &amp;p01, &amp;p12, &amp;p20);
    }
}

int
mesh_triangle(patch_fill_state_t *pfs, 
	const shading_vertex_t *p0, const shading_vertex_t *p1, const shading_vertex_t *p2)
{
    if ((*dev_proc(pfs-&gt;dev, pattern_manage))(pfs-&gt;dev, 
	    gs_no_id, NULL, pattern_manage__shading_area) &gt; 0) {
	/* Inform the device with the shading coverage area. 
	   First compute the sign of the area, because
	   all areas to be clipped in same direction. */
	gx_device *pdev = pfs-&gt;dev;
	gx_path path;
	int code;
	fixed d01x = p1-&gt;p.x - p0-&gt;p.x, d01y = p1-&gt;p.y - p0-&gt;p.y;
	fixed d12x = p2-&gt;p.x - p1-&gt;p.x, d12y = p2-&gt;p.y - p1-&gt;p.y;
	int64_t s1 = (int64_t)d01x * d12y - (int64_t)d01y * d12x;

	gx_path_init_local(&amp;path, pdev-&gt;memory);
	code = gx_path_add_point(&amp;path, p0-&gt;p.x, p0-&gt;p.y);
	if (code &gt;= 0 &amp;&amp; s1 &gt;= 0)
	    code = gx_path_add_line(&amp;path, p1-&gt;p.x, p1-&gt;p.y);
	if (code &gt;= 0)
	    code = gx_path_add_line(&amp;path, p2-&gt;p.x, p2-&gt;p.y);
	if (code &gt;= 0 &amp;&amp; s1 &lt; 0)
	    code = gx_path_add_line(&amp;path, p1-&gt;p.x, p1-&gt;p.y);
	if (code &gt;= 0)
	    code = gx_path_close_subpath(&amp;path);
	if (code &gt;= 0)
	    code = (*dev_proc(pfs-&gt;dev, fill_path))(pdev, NULL, &amp;path, NULL, NULL, NULL);
	gx_path_free(&amp;path, "mesh_triangle");
	if (code &lt; 0)
	    return code;
    }
    return mesh_triangle_rec(pfs, p0, p1, p2);
}

private inline int 
triangles4(patch_fill_state_t *pfs, const quadrangle_patch *p, bool dummy_argument)
{
    shading_vertex_t p0001, p1011, q;
    wedge_vertex_list_t l[4];
    int code;

    init_wedge_vertex_list(l, count_of(l));
    divide_bar(pfs, p-&gt;p[0][0], p-&gt;p[0][1], 2, &amp;p0001);
    divide_bar(pfs, p-&gt;p[1][0], p-&gt;p[1][1], 2, &amp;p1011);
    divide_bar(pfs, &amp;p0001, &amp;p1011, 2, &amp;q);
    code = fill_triangle(pfs, p-&gt;p[0][0], p-&gt;p[0][1], &amp;q, p-&gt;l0001, &amp;l[0], &amp;l[3]);
    if (code &lt; 0)
	return code;
    l[0].last_side = true;
    l[3].last_side = true;
    code = fill_triangle(pfs, p-&gt;p[0][1], p-&gt;p[1][1], &amp;q, p-&gt;l0111, &amp;l[1], &amp;l[0]);
    if (code &lt; 0)
	return code;
    l[1].last_side = true;
    code = fill_triangle(pfs, p-&gt;p[1][1], p-&gt;p[1][0], &amp;q, p-&gt;l1110, &amp;l[2], &amp;l[1]);
    if (code &lt; 0)
	return code;
    l[2].last_side = true;
    code = fill_triangle(pfs, p-&gt;p[1][0], p-&gt;p[0][0], &amp;q, p-&gt;l1000, &amp;l[3], &amp;l[2]);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l[0], &amp;p-&gt;p[0][1]-&gt;c, &amp;q.c);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l[1], &amp;p-&gt;p[1][1]-&gt;c, &amp;q.c);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l[2], &amp;p-&gt;p[1][0]-&gt;c, &amp;q.c);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l[3], &amp;q.c, &amp;p-&gt;p[0][0]-&gt;c);
    if (code &lt; 0)
	return code;
    return 0;
}

private inline int 
triangles2(patch_fill_state_t *pfs, const quadrangle_patch *p, bool dummy_argument)
{
    wedge_vertex_list_t l;
    int code;

    init_wedge_vertex_list(&amp;l, 1);
    code = fill_triangle(pfs, p-&gt;p[0][0], p-&gt;p[0][1], p-&gt;p[1][1], p-&gt;l0001, p-&gt;l0111, &amp;l);
    if (code &lt; 0)
	return code;
    l.last_side = true;
    code = fill_triangle(pfs, p-&gt;p[1][1], p-&gt;p[1][0], p-&gt;p[0][0], p-&gt;l1110, p-&gt;l1000, &amp;l);
    if (code &lt; 0)
	return code;
    code = terminate_wedge_vertex_list(pfs, &amp;l, &amp;p-&gt;p[1][1]-&gt;c, &amp;p-&gt;p[0][0]-&gt;c);
    if (code &lt; 0)
	return code;
    return 0;
}

private inline void 
make_quadrangle(const tensor_patch *p, shading_vertex_t qq[2][2], 
	wedge_vertex_list_t l[4], quadrangle_patch *q)
{
    qq[0][0].p = p-&gt;pole[0][0];
    qq[0][1].p = p-&gt;pole[0][3];
    qq[1][0].p = p-&gt;pole[3][0];
    qq[1][1].p = p-&gt;pole[3][3];
    qq[0][0].c = p-&gt;c[0][0];
    qq[0][1].c = p-&gt;c[0][1];
    qq[1][0].c = p-&gt;c[1][0];
    qq[1][1].c = p-&gt;c[1][1];
    q-&gt;p[0][0] = &amp;qq[0][0];
    q-&gt;p[0][1] = &amp;qq[0][1];
    q-&gt;p[1][0] = &amp;qq[1][0];
    q-&gt;p[1][1] = &amp;qq[1][1];
    q-&gt;l0001 = &amp;l[0];
    q-&gt;l0111 = &amp;l[1];
    q-&gt;l1110 = &amp;l[2];
    q-&gt;l1000 = &amp;l[3];
}

private inline int
is_quadrangle_color_linear_by_u(const patch_fill_state_t *pfs, const quadrangle_patch *p)
{   /* returns : 1 = linear, 0 = unlinear, &lt;0 = error. */
    int code;

    code = is_color_linear(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[0][1]-&gt;c);
    if (code &lt;= 0)
	return code;
    return is_color_linear(pfs, &amp;p-&gt;p[1][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
}

private inline int
is_quadrangle_color_linear_by_v(const patch_fill_state_t *pfs, const quadrangle_patch *p)
{   /* returns : 1 = linear, 0 = unlinear, &lt;0 = error. */
    int code;

    code = is_color_linear(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[1][0]-&gt;c);
    if (code &lt;= 0)
	return code;
    return is_color_linear(pfs, &amp;p-&gt;p[0][1]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
}

private inline int
is_quadrangle_color_linear_by_diagonals(const patch_fill_state_t *pfs, const quadrangle_patch *p)
{   /* returns : 1 = linear, 0 = unlinear, &lt;0 = error. */
    int code;

    code = is_color_linear(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
    if (code &lt;= 0)
	return code;
    return is_color_linear(pfs, &amp;p-&gt;p[0][1]-&gt;c, &amp;p-&gt;p[1][0]-&gt;c);
}

typedef enum {
    color_change_small,
    color_change_gradient,
    color_change_linear,
    color_change_bilinear,
    color_change_general
} color_change_type_t;

private inline color_change_type_t
quadrangle_color_change(const patch_fill_state_t *pfs, const quadrangle_patch *p, 
			bool is_big_u, bool is_big_v, bool *divide_u, bool *divide_v)
{
    patch_color_t d0001, d1011, d;
    double D, D0001, D1011, D0010, D0111, D0011, D0110;
    double Du, Dv;

    color_diff(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[0][1]-&gt;c, &amp;d0001);
    color_diff(pfs, &amp;p-&gt;p[1][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c, &amp;d1011);
    D0001 = color_norm(pfs, &amp;d0001);
    D1011 = color_norm(pfs, &amp;d1011);
    D0010 = color_span(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[1][0]-&gt;c);
    D0111 = color_span(pfs, &amp;p-&gt;p[0][1]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
    D0011 = color_span(pfs, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
    D0110 = color_span(pfs, &amp;p-&gt;p[0][1]-&gt;c, &amp;p-&gt;p[1][0]-&gt;c);
    if (pfs-&gt;unlinear) {
	if (D0001 &lt;= pfs-&gt;smoothness &amp;&amp; D1011 &lt;= pfs-&gt;smoothness &amp;&amp;
	    D0010 &lt;= pfs-&gt;smoothness &amp;&amp; D0111 &lt;= pfs-&gt;smoothness &amp;&amp;
	    D0011 &lt;= pfs-&gt;smoothness &amp;&amp; D0110 &lt;= pfs-&gt;smoothness)
	    return color_change_small;
	if (D0001 &lt;= pfs-&gt;smoothness &amp;&amp; D1011 &lt;= pfs-&gt;smoothness) {
	    if (!is_big_v) {
		/* The color function looks uncontiguous. */
		return color_change_small;
	    }
	    *divide_v = true;
	    return color_change_gradient;
	}
	if (D0010 &lt;= pfs-&gt;smoothness &amp;&amp; D0111 &lt;= pfs-&gt;smoothness) {
	    if (!is_big_u) {
		/* The color function looks uncontiguous. */
		return color_change_small;
	    }
	    *divide_u = true;
	    return color_change_gradient;
	}
    }
    color_diff(pfs, &amp;d0001, &amp;d1011, &amp;d);
    Du = max(D0001, D1011);
    Dv = max(D0010, D0111);
    if (Du &lt;= pfs-&gt;smoothness / 8 &amp;&amp; Dv &lt;= pfs-&gt;smoothness / 8)
	return color_change_small;
    if (Du &lt;= pfs-&gt;smoothness / 8)
	return color_change_linear;
    if (Dv &lt;= pfs-&gt;smoothness / 8)
	return color_change_linear;
    D = color_norm(pfs, &amp;d);
    if (D &lt;= pfs-&gt;smoothness)
	return color_change_bilinear;
#if 0 /* Disabled due to a 0.5% slowdown with the test file of the Bug 687948. */
    if (Du &gt; Dv &amp;&amp; is_big_u)
	*divide_u = true;
    else if (Du &lt; Dv &amp;&amp; is_big_v)
	*divide_v = true;
    else if (is_big_u)
	*divide_u = true;
    else if (is_big_v)
	*divide_v = true;
    else {
	/* The color function looks uncontiguous. */
	return color_change_small;
    }
#else
    if (Du &gt; Dv)
	*divide_u = true;
    else
	*divide_v = true;
#endif
    return color_change_general;
}

private int 
fill_quadrangle(patch_fill_state_t *pfs, const quadrangle_patch *p, bool big, int level)
{
    /* The quadrangle is flattened enough by V and U, so ignore inner poles. */
    /* Assuming the XY span is restricted with curve_samples. 
       It is important for intersection_of_small_bars to compute faster. */
    quadrangle_patch s0, s1;
    wedge_vertex_list_t l0, l1, l2;
    int code;
    bool divide_u = false, divide_v = false, big1 = big;
    shading_vertex_t q[2];
    bool monotonic_color_save = pfs-&gt;monotonic_color;
    bool linear_color_save = pfs-&gt;linear_color;
    bool inside_save = pfs-&gt;inside;
    gs_fixed_rect r, r1;
    /* Warning : pfs-&gt;monotonic_color is not restored on error. */

    if (level &gt; 100)
	return_error(gs_error_unregistered); /* Safety. */
    if (!pfs-&gt;inside) {
	bbox_of_points(&amp;r, &amp;p-&gt;p[0][0]-&gt;p, &amp;p-&gt;p[0][1]-&gt;p, &amp;p-&gt;p[1][0]-&gt;p, &amp;p-&gt;p[1][1]-&gt;p);
	r1 = r;
	rect_intersect(r, pfs-&gt;rect);
	if (r.q.x &lt;= r.p.x || r.q.y &lt;= r.p.y)
	    return 0; /* Outside. */
    }
    if (big) {
	/* Likely 'big' is an unuseful rudiment due to curve_samples
	   restricts lengthes. We keep it for a while because its implementation 
	   isn't obvious and its time consumption is invisibly small.
	 */
	fixed size_u = max(max(any_abs(p-&gt;p[0][0]-&gt;p.x - p-&gt;p[0][1]-&gt;p.x), 
			       any_abs(p-&gt;p[1][0]-&gt;p.x - p-&gt;p[1][1]-&gt;p.x)),
			   max(any_abs(p-&gt;p[0][0]-&gt;p.y - p-&gt;p[0][1]-&gt;p.y),
			       any_abs(p-&gt;p[1][0]-&gt;p.y - p-&gt;p[1][1]-&gt;p.y)));
	fixed size_v = max(max(any_abs(p-&gt;p[0][0]-&gt;p.x - p-&gt;p[1][0]-&gt;p.x),
			       any_abs(p-&gt;p[0][1]-&gt;p.x - p-&gt;p[1][1]-&gt;p.x)),
			   max(any_abs(p-&gt;p[0][0]-&gt;p.y - p-&gt;p[1][0]-&gt;p.y),
			       any_abs(p-&gt;p[0][1]-&gt;p.y - p-&gt;p[1][1]-&gt;p.y)));

	if (QUADRANGLES &amp;&amp; pfs-&gt;maybe_self_intersecting) {
	    if (size_v &gt; pfs-&gt;max_small_coord) {
		/* constant_color_quadrangle can't handle big self-intersecting areas
		   because we don't want int64_t in it. */
		divide_v = true;
	    } else if (size_u &gt; pfs-&gt;max_small_coord) {
		/* constant_color_quadrangle can't handle big self-intersecting areas, 
		   because we don't want int64_t in it. */
		divide_u = true;
	    } else
		big1 = false;
	} else
	    big1 = false;
    }
    if (!big1) {
	bool is_big_u = false, is_big_v = false;
	double d0001x = any_abs(p-&gt;p[0][0]-&gt;p.x - p-&gt;p[0][1]-&gt;p.x);
	double d1011x = any_abs(p-&gt;p[1][0]-&gt;p.x - p-&gt;p[1][1]-&gt;p.x);
	double d0001y = any_abs(p-&gt;p[0][0]-&gt;p.y - p-&gt;p[0][1]-&gt;p.y);
	double d1011y = any_abs(p-&gt;p[1][0]-&gt;p.y - p-&gt;p[1][1]-&gt;p.y);
	double d0010x = any_abs(p-&gt;p[0][0]-&gt;p.x - p-&gt;p[1][0]-&gt;p.x);
	double d0111x = any_abs(p-&gt;p[0][1]-&gt;p.x - p-&gt;p[1][1]-&gt;p.x);
	double d0010y = any_abs(p-&gt;p[0][0]-&gt;p.y - p-&gt;p[1][0]-&gt;p.y);
	double d0111y = any_abs(p-&gt;p[0][1]-&gt;p.y - p-&gt;p[1][1]-&gt;p.y);

	if (d0001x &gt; fixed_1 || d1011x &gt; fixed_1 || d0001y &gt; fixed_1 || d1011y &gt; fixed_1)
	    is_big_u = true;
	if (d0010x &gt; fixed_1 || d0111x &gt; fixed_1 || d0010y &gt; fixed_1 || d0111y &gt; fixed_1)
	    is_big_v = true;
	else if (!is_big_u)
	    return (QUADRANGLES || !pfs-&gt;maybe_self_intersecting ? 
			constant_color_quadrangle : triangles4)(pfs, p, 
			    pfs-&gt;maybe_self_intersecting);
	if (!pfs-&gt;monotonic_color) {
	    bool not_monotonic_by_u = false, not_monotonic_by_v = false;

	    code = is_quadrangle_color_monotonic(pfs, p, &amp;not_monotonic_by_u, &amp;not_monotonic_by_v);
	    if (code &lt; 0)
		return code;
	    if (is_big_u)
		divide_u = not_monotonic_by_u;
	    if (is_big_v)
		divide_v = not_monotonic_by_v;
	    if (!divide_u &amp;&amp; !divide_v)
		pfs-&gt;monotonic_color = true;
	}
	if (pfs-&gt;monotonic_color &amp;&amp; !pfs-&gt;linear_color) {
	    if (divide_v &amp;&amp; divide_u) {
		if (d0001x + d1011x + d0001y + d1011y &gt; d0010x + d0111x + d0010y + d0111y)
		    divide_v = false;
		else
		    divide_u = false;
	    } else if (!divide_u &amp;&amp; !divide_v &amp;&amp; !pfs-&gt;unlinear) {
		if (is_big_u) {
		    code = is_quadrangle_color_linear_by_u(pfs, p);
		    if (code &lt; 0)
			return code;
		    divide_u = !code;
		}
		if (is_big_v) {
		    code = is_quadrangle_color_linear_by_v(pfs, p);
		    if (code &lt; 0)
			return code;
		    divide_v = !code;
		}
		if (is_big_u &amp;&amp; is_big_v) {
		    code = is_quadrangle_color_linear_by_diagonals(pfs, p);
		    if (code &lt; 0)
			return code;
		    if (!code) {
			if (d0001x + d1011x + d0001y + d1011y &gt; d0010x + d0111x + d0010y + d0111y) {
			    divide_u = true;
			    divide_v = false;
			} else {
			    divide_v = true;
			    divide_u = false;
			}
		    }
		}
	    }
	    if (!divide_u &amp;&amp; !divide_v)
		pfs-&gt;linear_color = true;
	}
	if (!pfs-&gt;linear_color) {
	    /* go to divide. */
	} else switch(quadrangle_color_change(pfs, p, is_big_u, is_big_v, &amp;divide_u, &amp;divide_v)) {
	    case color_change_small: 
		code = (QUADRANGLES || !pfs-&gt;maybe_self_intersecting ? 
			    constant_color_quadrangle : triangles4)(pfs, p, 
				pfs-&gt;maybe_self_intersecting);
		pfs-&gt;monotonic_color = monotonic_color_save;
		pfs-&gt;linear_color = linear_color_save;
		return code;
	    case color_change_bilinear:
		if (!QUADRANGLES) {
		    code = triangles4(pfs, p, true);
		    pfs-&gt;monotonic_color = monotonic_color_save;
		    pfs-&gt;linear_color = linear_color_save;
		    return code;
		}
	    case color_change_linear:
		if (!QUADRANGLES) {
		    code = triangles2(pfs, p, true);
		    pfs-&gt;monotonic_color = monotonic_color_save;
		    pfs-&gt;linear_color = linear_color_save;
		    return code;
		}
	    case color_change_gradient:
	    case color_change_general:
		; /* goto divide. */
	}
    }
    if (!pfs-&gt;inside) {
	if (r.p.x == r1.p.x &amp;&amp; r.p.y == r1.p.y &amp;&amp; 
	    r.q.x == r1.q.x &amp;&amp; r.q.y == r1.q.y)
	    pfs-&gt;inside = true;
    }
    if (LAZY_WEDGES)
	init_wedge_vertex_list(&amp;l0, 1);
    if (divide_v) {
	divide_quadrangle_by_v(pfs, &amp;s0, &amp;s1, q, p);
	if (LAZY_WEDGES) {
	    make_wedge_median(pfs, &amp;l1, p-&gt;l0111, true,  &amp;p-&gt;p[0][1]-&gt;p, &amp;p-&gt;p[1][1]-&gt;p, &amp;s0.p[1][1]-&gt;p);
	    make_wedge_median(pfs, &amp;l2, p-&gt;l1000, false, &amp;p-&gt;p[1][0]-&gt;p, &amp;p-&gt;p[0][0]-&gt;p, &amp;s0.p[1][0]-&gt;p);
	    s0.l1110 = s1.l0001 = &amp;l0;
	    s0.l0111 = s1.l0111 = &amp;l1;
	    s0.l1000 = s1.l1000 = &amp;l2;
	    s0.l0001 = p-&gt;l0001;
	    s1.l1110 = p-&gt;l1110;
	} else {
	    code = fill_triangle_wedge(pfs, s0.p[0][0], s1.p[1][0], s0.p[1][0]);
	    if (code &lt; 0)
		return code;
	    code = fill_triangle_wedge(pfs, s0.p[0][1], s1.p[1][1], s0.p[1][1]);
	    if (code &lt; 0)
		return code;
	}
	code = fill_quadrangle(pfs, &amp;s0, big, level + 1);
	if (code &lt; 0)
	    return code;
	if (LAZY_WEDGES) {
	    l0.last_side = true;
	    move_wedge(&amp;l1, p-&gt;l0111, true);
	    move_wedge(&amp;l2, p-&gt;l1000, false);
	}
	code = fill_quadrangle(pfs, &amp;s1, big1, level + 1);
	if (LAZY_WEDGES) {
	    if (code &lt; 0)
		return code;
	    code = close_wedge_median(pfs, p-&gt;l0111, &amp;p-&gt;p[0][1]-&gt;c, &amp;p-&gt;p[1][1]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = close_wedge_median(pfs, p-&gt;l1000, &amp;p-&gt;p[1][0]-&gt;c, &amp;p-&gt;p[0][0]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = terminate_wedge_vertex_list(pfs, &amp;l0, &amp;s0.p[1][0]-&gt;c, &amp;s0.p[1][1]-&gt;c);
	}
    } else if (divide_u) {
	divide_quadrangle_by_u(pfs, &amp;s0, &amp;s1, q, p);
	if (LAZY_WEDGES) {
	    make_wedge_median(pfs, &amp;l1, p-&gt;l0001, true,  &amp;p-&gt;p[0][0]-&gt;p, &amp;p-&gt;p[0][1]-&gt;p, &amp;s0.p[0][1]-&gt;p);
	    make_wedge_median(pfs, &amp;l2, p-&gt;l1110, false, &amp;p-&gt;p[1][1]-&gt;p, &amp;p-&gt;p[1][0]-&gt;p, &amp;s0.p[1][1]-&gt;p);
	    s0.l0111 = s1.l1000 = &amp;l0;
	    s0.l0001 = s1.l0001 = &amp;l1;
	    s0.l1110 = s1.l1110 = &amp;l2;
	    s0.l1000 = p-&gt;l1000;
	    s1.l0111 = p-&gt;l0111;
	} else {
	    code = fill_triangle_wedge(pfs, s0.p[0][0], s1.p[0][1], s0.p[0][1]);
	    if (code &lt; 0)
		return code;
	    code = fill_triangle_wedge(pfs, s0.p[1][0], s1.p[1][1], s0.p[1][1]);
	    if (code &lt; 0)
		return code;
	}
	code = fill_quadrangle(pfs, &amp;s0, big1, level + 1);
	if (code &lt; 0)
	    return code;
	if (LAZY_WEDGES) {
	    l0.last_side = true;
	    move_wedge(&amp;l1, p-&gt;l0001, true);
	    move_wedge(&amp;l2, p-&gt;l1110, false);
	}
	code = fill_quadrangle(pfs, &amp;s1, big1, level + 1);
	if (LAZY_WEDGES) {
	    if (code &lt; 0)
		return code;
	    code = close_wedge_median(pfs, p-&gt;l0001, &amp;p-&gt;p[0][0]-&gt;c, &amp;p-&gt;p[0][1]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = close_wedge_median(pfs, p-&gt;l1110, &amp;p-&gt;p[1][1]-&gt;c, &amp;p-&gt;p[1][0]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = terminate_wedge_vertex_list(pfs, &amp;l0, &amp;s0.p[0][1]-&gt;c, &amp;s0.p[1][1]-&gt;c);
	}
    } else 
	code = (QUADRANGLES || !pfs-&gt;maybe_self_intersecting ? 
		    constant_color_quadrangle : triangles4)(pfs, p, 
			pfs-&gt;maybe_self_intersecting);
    pfs-&gt;monotonic_color = monotonic_color_save;
    pfs-&gt;linear_color = linear_color_save;
    pfs-&gt;inside = inside_save;
    return code;
}



private inline void
split_stripe(patch_fill_state_t *pfs, tensor_patch *s0, tensor_patch *s1, const tensor_patch *p)
{
    split_curve_s(p-&gt;pole[0], s0-&gt;pole[0], s1-&gt;pole[0], 1);
    split_curve_s(p-&gt;pole[1], s0-&gt;pole[1], s1-&gt;pole[1], 1);
    split_curve_s(p-&gt;pole[2], s0-&gt;pole[2], s1-&gt;pole[2], 1);
    split_curve_s(p-&gt;pole[3], s0-&gt;pole[3], s1-&gt;pole[3], 1);
    s0-&gt;c[0][0] = p-&gt;c[0][0];
    s0-&gt;c[1][0] = p-&gt;c[1][0];
    patch_interpolate_color(&amp;s0-&gt;c[0][1], &amp;p-&gt;c[0][0], &amp;p-&gt;c[0][1], pfs, 0.5);
    patch_interpolate_color(&amp;s0-&gt;c[1][1], &amp;p-&gt;c[1][0], &amp;p-&gt;c[1][1], pfs, 0.5);
    s1-&gt;c[0][0] = s0-&gt;c[0][1];
    s1-&gt;c[1][0] = s0-&gt;c[1][1];
    s1-&gt;c[0][1] = p-&gt;c[0][1];
    s1-&gt;c[1][1] = p-&gt;c[1][1];
}

private inline void
split_patch(patch_fill_state_t *pfs, tensor_patch *s0, tensor_patch *s1, const tensor_patch *p)
{
    split_curve_s(&amp;p-&gt;pole[0][0], &amp;s0-&gt;pole[0][0], &amp;s1-&gt;pole[0][0], 4);
    split_curve_s(&amp;p-&gt;pole[0][1], &amp;s0-&gt;pole[0][1], &amp;s1-&gt;pole[0][1], 4);
    split_curve_s(&amp;p-&gt;pole[0][2], &amp;s0-&gt;pole[0][2], &amp;s1-&gt;pole[0][2], 4);
    split_curve_s(&amp;p-&gt;pole[0][3], &amp;s0-&gt;pole[0][3], &amp;s1-&gt;pole[0][3], 4);
    s0-&gt;c[0][0] = p-&gt;c[0][0];
    s0-&gt;c[0][1] = p-&gt;c[0][1];
    patch_interpolate_color(&amp;s0-&gt;c[1][0], &amp;p-&gt;c[0][0], &amp;p-&gt;c[1][0], pfs, 0.5);
    patch_interpolate_color(&amp;s0-&gt;c[1][1], &amp;p-&gt;c[0][1], &amp;p-&gt;c[1][1], pfs, 0.5);
    s1-&gt;c[0][0] = s0-&gt;c[1][0];
    s1-&gt;c[0][1] = s0-&gt;c[1][1];
    s1-&gt;c[1][0] = p-&gt;c[1][0];
    s1-&gt;c[1][1] = p-&gt;c[1][1];
}

private int 
decompose_stripe(patch_fill_state_t *pfs, const tensor_patch *p, int ku)
{
    if (ku &gt; 1) {
	tensor_patch s0, s1;
	int code;

	split_stripe(pfs, &amp;s0, &amp;s1, p);
	if (0) { /* Debug purpose only. */
	    draw_patch(&amp;s0, true, RGB(0, 128, 128));
	    draw_patch(&amp;s1, true, RGB(0, 128, 128));
	}
	code = decompose_stripe(pfs, &amp;s0, ku / 2);
	if (code &lt; 0)
	    return code;
	return decompose_stripe(pfs, &amp;s1, ku / 2);
    } else {
	quadrangle_patch q;
	shading_vertex_t qq[2][2];
	wedge_vertex_list_t l[4];
	int code;

	init_wedge_vertex_list(l, count_of(l));
	make_quadrangle(p, qq, l, &amp;q);
#	if SKIP_TEST
	    dbg_quad_cnt++;
#	endif
	code = fill_quadrangle(pfs, &amp;q, true, 0);
	if (LAZY_WEDGES) {
	    code = terminate_wedge_vertex_list(pfs, &amp;l[0], &amp;q.p[0][0]-&gt;c, &amp;q.p[0][1]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = terminate_wedge_vertex_list(pfs, &amp;l[1], &amp;q.p[0][1]-&gt;c, &amp;q.p[1][1]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = terminate_wedge_vertex_list(pfs, &amp;l[2], &amp;q.p[1][1]-&gt;c, &amp;q.p[1][0]-&gt;c);
	    if (code &lt; 0)
		return code;
	    code = terminate_wedge_vertex_list(pfs, &amp;l[3], &amp;q.p[1][0]-&gt;c, &amp;q.p[0][1]-&gt;c);
	    if (code &lt; 0)
		return code;
	}
	return code;
    }
}

private int 
fill_stripe(patch_fill_state_t *pfs, const tensor_patch *p)
{
    /* The stripe is flattened enough by V, so ignore inner poles. */
    int ku[4], kum, code;

    /* We would like to apply iterations for enumerating the kum curve parts,
       but the roundinmg errors would be too complicated due to
       the dependence on the direction. Note that neigbour
       patches may use the opposite direction for same bounding curve.
       We apply the recursive dichotomy, in which 
       the rounding errors do not depend on the direction. */
    ku[0] = curve_samples(pfs, p-&gt;pole[0], 1, pfs-&gt;fixed_flat);
    ku[3] = curve_samples(pfs, p-&gt;pole[3], 1, pfs-&gt;fixed_flat);
    kum = max(ku[0], ku[3]);
    code = fill_wedges(pfs, ku[0], kum, p-&gt;pole[0], 1, &amp;p-&gt;c[0][0], &amp;p-&gt;c[0][1], inpatch_wedge);
    if (code &lt; 0)
	return code;
    if (INTERPATCH_PADDING) {
	vd_bar(p-&gt;pole[0][0].x, p-&gt;pole[0][0].y, p-&gt;pole[3][0].x, p-&gt;pole[3][0].y, 0, RGB(255, 0, 0));
	code = mesh_padding(pfs, &amp;p-&gt;pole[0][0], &amp;p-&gt;pole[3][0], &amp;p-&gt;c[0][0], &amp;p-&gt;c[1][0]);
	if (code &lt; 0)
	    return code;
	vd_bar(p-&gt;pole[0][3].x, p-&gt;pole[0][3].y, p-&gt;pole[3][3].x, p-&gt;pole[3][3].y, 0, RGB(255, 0, 0));
	code = mesh_padding(pfs, &amp;p-&gt;pole[0][3], &amp;p-&gt;pole[3][3], &amp;p-&gt;c[0][1], &amp;p-&gt;c[1][1]);
	if (code &lt; 0)
	    return code;
    }
    code = decompose_stripe(pfs, p, kum);
    if (code &lt; 0)
	return code;
    return fill_wedges(pfs, ku[3], kum, p-&gt;pole[3], 1, &amp;p-&gt;c[1][0], &amp;p-&gt;c[1][1], inpatch_wedge);
}

private inline bool
is_curve_x_monotonic(const gs_fixed_point *pole, int pole_step)
{   /* true = monotonic, false = don't know. */
    return (pole[0 * pole_step].x &lt;= pole[1 * pole_step].x &amp;&amp; 
	    pole[1 * pole_step].x &lt;= pole[2 * pole_step].x &amp;&amp;
	    pole[2 * pole_step].x &lt;= pole[3 * pole_step].x) ||
	   (pole[0 * pole_step].x &gt;= pole[1 * pole_step].x &amp;&amp; 
	    pole[1 * pole_step].x &gt;= pole[2 * pole_step].x &amp;&amp;
	    pole[2 * pole_step].x &gt;= pole[3 * pole_step].x);
}

private inline bool
is_curve_y_monotonic(const gs_fixed_point *pole, int pole_step)
{   /* true = monotonic, false = don't know. */
    return (pole[0 * pole_step].y &lt;= pole[1 * pole_step].y &amp;&amp; 
	    pole[1 * pole_step].y &lt;= pole[2 * pole_step].y &amp;&amp;
	    pole[2 * pole_step].y &lt;= pole[3 * pole_step].y) ||
	   (pole[0 * pole_step].y &gt;= pole[1 * pole_step].y &amp;&amp; 
	    pole[1 * pole_step].y &gt;= pole[2 * pole_step].y &amp;&amp;
	    pole[2 * pole_step].y &gt;= pole[3 * pole_step].y);
}

private inline bool neqs(int *a, int b)
{   /* Unequal signs. Assuming -1, 0, 1 only. */
    if (*a * b &lt; 0)
	return true;
    if (!*a)
	*a = b;
    return false;
}

private inline int
vector_pair_orientation(const gs_fixed_point *p0, const gs_fixed_point *p1, const gs_fixed_point *p2)
{   fixed dx1 = p1-&gt;x - p0-&gt;x, dy1 = p1-&gt;y - p0-&gt;y;
    fixed dx2 = p2-&gt;x - p0-&gt;x, dy2 = p2-&gt;y - p0-&gt;y;
    int64_t vp = (int64_t)dx1 * dy2 - (int64_t)dy1 * dx2;

    return (vp &gt; 0 ? 1 : vp &lt; 0 ? -1 : 0);
}

private inline bool
is_x_bended(const tensor_patch *p)
{   
    int sign = vector_pair_orientation(&amp;p-&gt;pole[0][0], &amp;p-&gt;pole[0][1], &amp;p-&gt;pole[1][0]);

    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[0][1], &amp;p-&gt;pole[0][2], &amp;p-&gt;pole[1][1])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[0][2], &amp;p-&gt;pole[0][3], &amp;p-&gt;pole[1][2])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[0][3], &amp;p-&gt;pole[0][2], &amp;p-&gt;pole[1][3])))
	return true;

    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][1], &amp;p-&gt;pole[1][2], &amp;p-&gt;pole[2][1])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][1], &amp;p-&gt;pole[1][2], &amp;p-&gt;pole[2][1])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][2], &amp;p-&gt;pole[1][3], &amp;p-&gt;pole[2][2])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[1][3], &amp;p-&gt;pole[1][2], &amp;p-&gt;pole[2][3])))
	return true;

    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[2][1], &amp;p-&gt;pole[2][2], &amp;p-&gt;pole[3][1])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[2][1], &amp;p-&gt;pole[2][2], &amp;p-&gt;pole[3][1])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[2][2], &amp;p-&gt;pole[2][3], &amp;p-&gt;pole[3][2])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[2][3], &amp;p-&gt;pole[2][2], &amp;p-&gt;pole[3][3])))
	return true;

    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[3][1], &amp;p-&gt;pole[3][2], &amp;p-&gt;pole[2][1])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[3][1], &amp;p-&gt;pole[3][2], &amp;p-&gt;pole[2][1])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[3][2], &amp;p-&gt;pole[3][3], &amp;p-&gt;pole[2][2])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[3][3], &amp;p-&gt;pole[3][2], &amp;p-&gt;pole[2][3])))
	return true;
    return false;
}

private inline bool
is_y_bended(const tensor_patch *p)
{   
    int sign = vector_pair_orientation(&amp;p-&gt;pole[0][0], &amp;p-&gt;pole[1][0], &amp;p-&gt;pole[0][1]);

    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][0], &amp;p-&gt;pole[2][0], &amp;p-&gt;pole[1][1])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[2][0], &amp;p-&gt;pole[3][0], &amp;p-&gt;pole[2][1])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[3][0], &amp;p-&gt;pole[2][0], &amp;p-&gt;pole[3][1])))
	return true;

    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][1], &amp;p-&gt;pole[2][1], &amp;p-&gt;pole[1][2])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][1], &amp;p-&gt;pole[2][1], &amp;p-&gt;pole[1][2])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[2][1], &amp;p-&gt;pole[3][1], &amp;p-&gt;pole[2][2])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[3][1], &amp;p-&gt;pole[2][1], &amp;p-&gt;pole[3][2])))
	return true;

    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][2], &amp;p-&gt;pole[2][2], &amp;p-&gt;pole[1][3])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[1][2], &amp;p-&gt;pole[2][2], &amp;p-&gt;pole[1][3])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[2][2], &amp;p-&gt;pole[3][2], &amp;p-&gt;pole[2][3])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[3][2], &amp;p-&gt;pole[2][2], &amp;p-&gt;pole[3][3])))
	return true;

    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[1][3], &amp;p-&gt;pole[2][3], &amp;p-&gt;pole[1][2])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[1][3], &amp;p-&gt;pole[2][3], &amp;p-&gt;pole[1][2])))
	return true;
    if (neqs(&amp;sign, -vector_pair_orientation(&amp;p-&gt;pole[2][3], &amp;p-&gt;pole[3][3], &amp;p-&gt;pole[2][2])))
	return true;
    if (neqs(&amp;sign, vector_pair_orientation(&amp;p-&gt;pole[3][3], &amp;p-&gt;pole[2][3], &amp;p-&gt;pole[3][2])))
	return true;
    return false;
}

private inline bool
is_curve_x_small(const gs_fixed_point *pole, int pole_step, fixed fixed_flat)
{   /* Is curve within a single pixel, or smaller than half pixel ? */
    fixed xmin0 = min(pole[0 * pole_step].x, pole[1 * pole_step].x);
    fixed xmin1 = min(pole[2 * pole_step].x, pole[3 * pole_step].x);
    fixed xmin =  min(xmin0, xmin1);
    fixed xmax0 = max(pole[0 * pole_step].x, pole[1 * pole_step].x);
    fixed xmax1 = max(pole[2 * pole_step].x, pole[3 * pole_step].x);
    fixed xmax =  max(xmax0, xmax1);

    if(xmax - xmin &lt;= fixed_1)
	return true;
    return false;	
}

private inline bool
is_curve_y_small(const gs_fixed_point *pole, int pole_step, fixed fixed_flat)
{   /* Is curve within a single pixel, or smaller than half pixel ? */
    fixed ymin0 = min(pole[0 * pole_step].y, pole[1 * pole_step].y);
    fixed ymin1 = min(pole[2 * pole_step].y, pole[3 * pole_step].y);
    fixed ymin =  min(ymin0, ymin1);
    fixed ymax0 = max(pole[0 * pole_step].y, pole[1 * pole_step].y);
    fixed ymax1 = max(pole[2 * pole_step].y, pole[3 * pole_step].y);
    fixed ymax =  max(ymax0, ymax1);

    if (ymax - ymin &lt;= fixed_1)
	return true;
    return false;	
}

private inline bool
is_patch_narrow(const patch_fill_state_t *pfs, const tensor_patch *p)
{
    if (!is_curve_x_small(&amp;p-&gt;pole[0][0], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_x_small(&amp;p-&gt;pole[0][1], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_x_small(&amp;p-&gt;pole[0][2], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_x_small(&amp;p-&gt;pole[0][3], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_y_small(&amp;p-&gt;pole[0][0], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_y_small(&amp;p-&gt;pole[0][1], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_y_small(&amp;p-&gt;pole[0][2], 4, pfs-&gt;fixed_flat))
	return false;
    if (!is_curve_y_small(&amp;p-&gt;pole[0][3], 4, pfs-&gt;fixed_flat))
	return false;
    return true;
}

private int 
fill_patch(patch_fill_state_t *pfs, const tensor_patch *p, int kv, int kv0, int kv1)
{
    if (kv &lt;= 1) {
	if (is_patch_narrow(pfs, p))
	    return fill_stripe(pfs, p);
	if (!is_x_bended(p))
	    return fill_stripe(pfs, p);
    }
    {	tensor_patch s0, s1;
        shading_vertex_t q0, q1, q2;
	int code;

	split_patch(pfs, &amp;s0, &amp;s1, p);
	if (kv0 &lt;= 1) {
	    q0.p = s0.pole[0][0];
	    q0.c = s0.c[0][0];
	    q1.p = s1.pole[3][0];
	    q1.c = s1.c[1][0];
	    q2.p = s0.pole[3][0];
	    q2.c = s0.c[1][0];
	    code = fill_triangle_wedge(pfs, &amp;q0, &amp;q1, &amp;q2);
	    if (code &lt; 0)
		return code;
	}
	if (kv1 &lt;= 1) {
	    q0.p = s0.pole[0][3];
	    q0.c = s0.c[0][1];
	    q1.p = s1.pole[3][3];
	    q1.c = s1.c[1][1];
	    q2.p = s0.pole[3][3];
	    q2.c = s0.c[1][1];
	    code = fill_triangle_wedge(pfs, &amp;q0, &amp;q1, &amp;q2);
	    if (code &lt; 0)
		return code;
	}
	code = fill_patch(pfs, &amp;s0, kv / 2, kv0 / 2, kv1 / 2);
	if (code &lt; 0)
	    return code;
	return fill_patch(pfs, &amp;s1, kv / 2, kv0 / 2, kv1 / 2);
	/* fixme : To privide the precise filling order, we must
	   decompose left and right wedges into pieces by intersections
	   with stripes, and fill each piece with its stripe.
	   A lazy wedge list would be fine for storing 
	   the necessary information.

	   If the patch is created from a radial shading,
	   the wedge color appears a constant, so the filling order
	   isn't important. The order is important for other 
	   self-overlapping patches, but the visible effect is 
	   just a slight norrowing the patch (as its lower layer appears
	   visible through the upper layer near the side). 
	   This kind of dropout isn't harmful, because
	   contacring self-overlapping patches are painted 
	   one after one by definition, so that a side coverage break
	   appears unavoidable by definition.

	   Delaying this improvement because it is low important.
	 */
    }
}

private inline fixed
lcp1(fixed p0, fixed p3)
{   /* Computing the 1st pole of a 3d order besier, which applears a line. */
    return (p0 + p0 + p3) / 3;
}
private inline fixed
lcp2(fixed p0, fixed p3)
{   /* Computing the 2nd pole of a 3d order besier, which applears a line. */
    return (p0 + p3 + p3) / 3;
}

private void
patch_set_color(const patch_fill_state_t *pfs, patch_color_t *c, const float *cc)
{
    if (pfs-&gt;Function) {
	c-&gt;t[0] = cc[0];
	c-&gt;t[1] = cc[1];
    } else 
	memcpy(c-&gt;cc.paint.values, cc, sizeof(c-&gt;cc.paint.values[0]) * pfs-&gt;num_components);
}

private void
make_tensor_patch(const patch_fill_state_t *pfs, tensor_patch *p, const patch_curve_t curve[4],
	   const gs_fixed_point interior[4])
{
    const gs_color_space *pcs = pfs-&gt;direct_space;

    p-&gt;pole[0][0] = curve[0].vertex.p;
    p-&gt;pole[1][0] = curve[0].control[0];
    p-&gt;pole[2][0] = curve[0].control[1];
    p-&gt;pole[3][0] = curve[1].vertex.p;
    p-&gt;pole[3][1] = curve[1].control[0];
    p-&gt;pole[3][2] = curve[1].control[1];
    p-&gt;pole[3][3] = curve[2].vertex.p;
    p-&gt;pole[2][3] = curve[2].control[0];
    p-&gt;pole[1][3] = curve[2].control[1];
    p-&gt;pole[0][3] = curve[3].vertex.p;
    p-&gt;pole[0][2] = curve[3].control[0];
    p-&gt;pole[0][1] = curve[3].control[1];
    if (interior != NULL) {
	p-&gt;pole[1][1] = interior[0];
	p-&gt;pole[1][2] = interior[1];
	p-&gt;pole[2][2] = interior[2];
	p-&gt;pole[2][1] = interior[3];
    } else {
	p-&gt;pole[1][1].x = lcp1(p-&gt;pole[0][1].x, p-&gt;pole[3][1].x) +
			  lcp1(p-&gt;pole[1][0].x, p-&gt;pole[1][3].x) -
			  lcp1(lcp1(p-&gt;pole[0][0].x, p-&gt;pole[0][3].x),
			       lcp1(p-&gt;pole[3][0].x, p-&gt;pole[3][3].x));
	p-&gt;pole[1][2].x = lcp1(p-&gt;pole[0][2].x, p-&gt;pole[3][2].x) +
			  lcp2(p-&gt;pole[1][0].x, p-&gt;pole[1][3].x) -
			  lcp1(lcp2(p-&gt;pole[0][0].x, p-&gt;pole[0][3].x),
			       lcp2(p-&gt;pole[3][0].x, p-&gt;pole[3][3].x));
	p-&gt;pole[2][1].x = lcp2(p-&gt;pole[0][1].x, p-&gt;pole[3][1].x) +
			  lcp1(p-&gt;pole[2][0].x, p-&gt;pole[2][3].x) -
			  lcp2(lcp1(p-&gt;pole[0][0].x, p-&gt;pole[0][3].x),
			       lcp1(p-&gt;pole[3][0].x, p-&gt;pole[3][3].x));
	p-&gt;pole[2][2].x = lcp2(p-&gt;pole[0][2].x, p-&gt;pole[3][2].x) +
			  lcp2(p-&gt;pole[2][0].x, p-&gt;pole[2][3].x) -
			  lcp2(lcp2(p-&gt;pole[0][0].x, p-&gt;pole[0][3].x),
			       lcp2(p-&gt;pole[3][0].x, p-&gt;pole[3][3].x));

	p-&gt;pole[1][1].y = lcp1(p-&gt;pole[0][1].y, p-&gt;pole[3][1].y) +
			  lcp1(p-&gt;pole[1][0].y, p-&gt;pole[1][3].y) -
			  lcp1(lcp1(p-&gt;pole[0][0].y, p-&gt;pole[0][3].y),
			       lcp1(p-&gt;pole[3][0].y, p-&gt;pole[3][3].y));
	p-&gt;pole[1][2].y = lcp1(p-&gt;pole[0][2].y, p-&gt;pole[3][2].y) +
			  lcp2(p-&gt;pole[1][0].y, p-&gt;pole[1][3].y) -
			  lcp1(lcp2(p-&gt;pole[0][0].y, p-&gt;pole[0][3].y),
			       lcp2(p-&gt;pole[3][0].y, p-&gt;pole[3][3].y));
	p-&gt;pole[2][1].y = lcp2(p-&gt;pole[0][1].y, p-&gt;pole[3][1].y) +
			  lcp1(p-&gt;pole[2][0].y, p-&gt;pole[2][3].y) -
			  lcp2(lcp1(p-&gt;pole[0][0].y, p-&gt;pole[0][3].y),
			       lcp1(p-&gt;pole[3][0].y, p-&gt;pole[3][3].y));
	p-&gt;pole[2][2].y = lcp2(p-&gt;pole[0][2].y, p-&gt;pole[3][2].y) +
			  lcp2(p-&gt;pole[2][0].y, p-&gt;pole[2][3].y) -
			  lcp2(lcp2(p-&gt;pole[0][0].y, p-&gt;pole[0][3].y),
			       lcp2(p-&gt;pole[3][0].y, p-&gt;pole[3][3].y));
    }
    patch_set_color(pfs, &amp;p-&gt;c[0][0], curve[0].vertex.cc);
    patch_set_color(pfs, &amp;p-&gt;c[1][0], curve[1].vertex.cc);
    patch_set_color(pfs, &amp;p-&gt;c[1][1], curve[2].vertex.cc);
    patch_set_color(pfs, &amp;p-&gt;c[0][1], curve[3].vertex.cc);
    patch_resolve_color_inline(&amp;p-&gt;c[0][0], pfs);
    patch_resolve_color_inline(&amp;p-&gt;c[0][1], pfs);
    patch_resolve_color_inline(&amp;p-&gt;c[1][0], pfs);
    patch_resolve_color_inline(&amp;p-&gt;c[1][1], pfs);
    if (!pfs-&gt;Function) {
	pcs-&gt;type-&gt;restrict_color(&amp;p-&gt;c[0][0].cc, pcs);
	pcs-&gt;type-&gt;restrict_color(&amp;p-&gt;c[0][1].cc, pcs);
	pcs-&gt;type-&gt;restrict_color(&amp;p-&gt;c[1][0].cc, pcs);
	pcs-&gt;type-&gt;restrict_color(&amp;p-&gt;c[1][1].cc, pcs);
    }
}

int 
gx_shade_background(gx_device *pdev, const gs_fixed_rect *rect, 
	const gx_device_color *pdevc, gs_logical_operation_t log_op)
{
    gs_fixed_edge le, re;

    le.start.x = rect-&gt;p.x - INTERPATCH_PADDING;
    le.start.y = rect-&gt;p.y - INTERPATCH_PADDING;
    le.end.x = rect-&gt;p.x - INTERPATCH_PADDING;
    le.end.y = rect-&gt;q.y + INTERPATCH_PADDING;
    re.start.x = rect-&gt;q.x + INTERPATCH_PADDING;
    re.start.y = rect-&gt;p.y - INTERPATCH_PADDING;
    re.end.x = rect-&gt;q.x + INTERPATCH_PADDING;
    re.end.y = rect-&gt;q.y + INTERPATCH_PADDING;
    return dev_proc(pdev, fill_trapezoid)(pdev,
	    &amp;le, &amp;re, le.start.y, le.end.y, false, pdevc, log_op);
}


int
patch_fill(patch_fill_state_t *pfs, const patch_curve_t curve[4],
	   const gs_fixed_point interior[4],
	   void (*transform) (gs_fixed_point *, const patch_curve_t[4],
			      const gs_fixed_point[4], floatp, floatp))
{
    tensor_patch p;
    int kv[4], kvm, ku[4], kum, km;
    int code = 0;

#if SKIP_TEST
    dbg_patch_cnt++;
    /*if (dbg_patch_cnt != 67 &amp;&amp; dbg_patch_cnt != 78)
	return 0;*/
#endif
    /* We decompose the patch into tiny quadrangles,
       possibly inserting wedges between them against a dropout. */
    make_tensor_patch(pfs, &amp;p, curve, interior);
    pfs-&gt;unlinear = !is_linear_color_applicable(pfs);
    pfs-&gt;linear_color = false;
    if ((*dev_proc(pfs-&gt;dev, pattern_manage))(pfs-&gt;dev, 
	    gs_no_id, NULL, pattern_manage__shading_area) &gt; 0) {
	/* Inform the device with the shading coverage area. 
	   First compute the sign of the area, because
	   all areas to be clipped in same direction. */
	gx_device *pdev = pfs-&gt;dev;
	gx_path path;
	fixed d01x = (curve[1].vertex.p.x - curve[0].vertex.p.x) &gt;&gt; 1;
	fixed d01y = (curve[1].vertex.p.y - curve[0].vertex.p.y) &gt;&gt; 1;
	fixed d12x = (curve[2].vertex.p.x - curve[1].vertex.p.x) &gt;&gt; 1;
	fixed d12y = (curve[2].vertex.p.y - curve[1].vertex.p.y) &gt;&gt; 1;
	fixed d23x = (curve[3].vertex.p.x - curve[2].vertex.p.x) &gt;&gt; 1;
	fixed d23y = (curve[3].vertex.p.y - curve[2].vertex.p.y) &gt;&gt; 1;
	fixed d30x = (curve[0].vertex.p.x - curve[3].vertex.p.x) &gt;&gt; 1;
	fixed d30y = (curve[0].vertex.p.y - curve[3].vertex.p.y) &gt;&gt; 1;
	int64_t s1 = (int64_t)d01x * d12y - (int64_t)d01y * d12x;
	int64_t s2 = (int64_t)d23x * d30y - (int64_t)d23y * d30x;
	int s = (s1 + s2 &gt; 0 ? 1 : 3), i, j, k, jj, l = (s == 1 ? 0 : 1);

	gx_path_init_local(&amp;path, pdev-&gt;memory);
	if (is_x_bended(&amp;p) || is_y_bended(&amp;p)) {
	    /* The patch possibly is self-overlapping,
	       so the patch coverage may fall outside the patch outline.
	       In this case we pass an empty path,
	       and the device must use a bitmap mask instead clipping. */
	} else {
    	    code = gx_path_add_point(&amp;path, curve[0].vertex.p.x, curve[0].vertex.p.y);
	    for (i = k = 0; k &lt; 4 &amp;&amp; code &gt;= 0; i = j, k++) {
		j = (i + s) % 4, jj = (s == 1 ? i : j);
		if (curve[jj].straight)
		    code = gx_path_add_line(&amp;path, curve[j].vertex.p.x, 
						curve[j].vertex.p.y);
		else
		    code = gx_path_add_curve(&amp;path, curve[jj].control[l].x, curve[jj].control[l].y, 
						    curve[jj].control[(l + 1) &amp; 1].x, curve[jj].control[(l + 1) &amp; 1].y,
						    curve[j].vertex.p.x, 
						    curve[j].vertex.p.y);
	    }
	    if (code &gt;= 0)
		code = gx_path_close_subpath(&amp;path);
	}
	if (code &gt;= 0)
	    code = (*dev_proc(pfs-&gt;dev, fill_path))(pdev, NULL, &amp;path, NULL, NULL, NULL);
	gx_path_free(&amp;path, "patch_fill");
	if (code &lt; 0)
	    return code;
    }
    /* draw_patch(&amp;p, true, RGB(0, 0, 0)); */
    kv[0] = curve_samples(pfs, &amp;p.pole[0][0], 4, pfs-&gt;fixed_flat);
    kv[1] = curve_samples(pfs, &amp;p.pole[0][1], 4, pfs-&gt;fixed_flat);
    kv[2] = curve_samples(pfs, &amp;p.pole[0][2], 4, pfs-&gt;fixed_flat);
    kv[3] = curve_samples(pfs, &amp;p.pole[0][3], 4, pfs-&gt;fixed_flat);
    kvm = max(max(kv[0], kv[1]), max(kv[2], kv[3]));
    ku[0] = curve_samples(pfs, p.pole[0], 1, pfs-&gt;fixed_flat);
    ku[3] = curve_samples(pfs, p.pole[3], 1, pfs-&gt;fixed_flat);
    kum = max(ku[0], ku[3]);
    km = max(kvm, kum);
#   if NOFILL_TEST
	dbg_nofill = false;
#   endif
    code = fill_wedges(pfs, ku[0], kum, p.pole[0], 1, &amp;p.c[0][0], &amp;p.c[0][1], 
		interpatch_padding | inpatch_wedge);
    if (code &gt;= 0) {
	/* We would like to apply iterations for enumerating the kvm curve parts,
	   but the roundinmg errors would be too complicated due to
	   the dependence on the direction. Note that neigbour
	   patches may use the opposite direction for same bounding curve.
	   We apply the recursive dichotomy, in which 
	   the rounding errors do not depend on the direction. */
#	if NOFILL_TEST
	    dbg_nofill = false;
	    code = fill_patch(pfs, &amp;p, kvm, kv[0], kv[3]);
	    dbg_nofill = true;
#	endif
	code = fill_patch(pfs, &amp;p, kvm, kv[0], kv[3]);
    }
    if (code &gt;= 0)
	code = fill_wedges(pfs, ku[3], kum, p.pole[3], 1, &amp;p.c[1][0], &amp;p.c[1][1], 
		interpatch_padding | inpatch_wedge);
    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

