<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gzspotan.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gzspotan.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2003 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/*$Id: gzspotan.c,v 1.14 2005/05/12 02:01:32 alexcher Exp $ */
/* A spot analyzer device implementation. */
/*
    This implements a spot topology analyzis and 
    stem recognition for True Type grid fitting.
*/
#include "gx.h"
#include "gserrors.h"
#include "gsdevice.h"
#include "gzspotan.h"
#include "gxfixed.h"
#include "gxdevice.h"
#include "gxfdrop.h" /* Only for VD_* constants. */
#include "gzpath.h"
#include "memory_.h"
#include "math_.h"
#include "vdtrace.h"
#include &lt;assert.h&gt;

#define VD_TRAP_N_COLOR RGB(128, 128, 0)
#define VD_TRAP_U_COLOR RGB(0, 0, 255)
#define VD_CONT_COLOR RGB(0, 255, 0)
#define VD_STEM_COLOR RGB(255, 255, 255)
#define VD_HINT_COLOR RGB(255, 0, 0)

public_st_device_spot_analyzer();
private_st_san_trap();
private_st_san_trap_contact();

private dev_proc_open_device(san_open);
private dev_proc_close_device(san_close);
private dev_proc_get_clipping_box(san_get_clipping_box);


/* --------------------- List management ------------------------- */
/* fixme : use something like C++ patterns to generate same functions for various types. */


private inline void
free_trap_list(gs_memory_t *mem, gx_san_trap **list)
{
    gx_san_trap *t = *list, *t1;

    for (t = *list; t != NULL; t = t1) {
	t1 = t-&gt;link;
	gs_free_object(mem, t, "free_trap_list");
    }
    *list = 0;
}

private inline void
free_cont_list(gs_memory_t *mem, gx_san_trap_contact **list)
{
    gx_san_trap_contact *t = *list, *t1;

    for (t = *list; t != NULL; t = t1) {
	t1 = t-&gt;link;
	gs_free_object(mem, t, "free_trap_list");
    }
    *list = 0;
}

private inline gx_san_trap *
trap_reserve(gx_device_spot_analyzer *padev)
{
    gx_san_trap *t = padev-&gt;trap_free;

    if (t != NULL) {
	padev-&gt;trap_free = t-&gt;link;
    } else {
	if (padev-&gt;trap_buffer_count &gt; 10000)
	    return NULL;
	t = gs_alloc_struct(padev-&gt;memory, gx_san_trap, 
		&amp;st_san_trap, "trap_reserve");
	if (t == NULL)
	    return NULL;
	t-&gt;link = NULL;
	if (padev-&gt;trap_buffer_last == NULL)
	    padev-&gt;trap_buffer = t;
	else
	    padev-&gt;trap_buffer_last-&gt;link = t;
	padev-&gt;trap_buffer_last = t;
	padev-&gt;trap_buffer_count++;
    }
    return t;
}

private inline gx_san_trap_contact *
cont_reserve(gx_device_spot_analyzer *padev)
{
    gx_san_trap_contact *t = padev-&gt;cont_free;

    if (t != NULL) {
	padev-&gt;cont_free = t-&gt;link;
    } else {
	if (padev-&gt;cont_buffer_count &gt; 10000)
	    return NULL;
	t = gs_alloc_struct(padev-&gt;memory, gx_san_trap_contact, 
		&amp;st_san_trap_contact, "cont_reserve");
	if (t == NULL)
	    return NULL;
	t-&gt;link = NULL;
	if (padev-&gt;cont_buffer_last == NULL)
	    padev-&gt;cont_buffer = t;
	else
	    padev-&gt;cont_buffer_last-&gt;link = t;
	padev-&gt;cont_buffer_last = t;
	padev-&gt;cont_buffer_count++;
    }
    return t;
}

private inline void
trap_unreserve(gx_device_spot_analyzer *padev, gx_san_trap *t)
{
    /* Assuming the last reserved one. */
    assert(t-&gt;link == padev-&gt;trap_free);
    padev-&gt;trap_free = t;
}

private inline void
cont_unreserve(gx_device_spot_analyzer *padev, gx_san_trap_contact *t)
{
    /* Assuming the last reserved one. */
    assert(t-&gt;link == padev-&gt;cont_free);
    padev-&gt;cont_free = t;
}

private inline gx_san_trap *
band_list_last(const gx_san_trap *list)
{
    /* Assuming a non-empty cyclic list, and the anchor points to the first element.  */
    return list-&gt;prev;
}

private inline gx_san_trap_contact *
cont_list_last(const gx_san_trap_contact *list)
{
    /* Assuming a non-empty cyclic list, and the anchor points to the first element.  */
    return list-&gt;prev;
}

private inline void
band_list_remove(gx_san_trap **list, gx_san_trap *t)
{
    /* Assuming a cyclic list, and the element is in it. */
    if (t-&gt;next == t) {
	*list = NULL;
    } else {
	if (*list == t)
	    *list = t-&gt;next;
	t-&gt;next-&gt;prev = t-&gt;prev;
	t-&gt;prev-&gt;next = t-&gt;next;
    }
    t-&gt;next = t-&gt;prev = NULL; /* Safety. */
}

private inline void
band_list_insert_last(gx_san_trap **list, gx_san_trap *t)
{
    /* Assuming a cyclic list. */
    if (*list == 0) {
	*list = t-&gt;next = t-&gt;prev = t;
    } else {
	gx_san_trap *last = band_list_last(*list);
	gx_san_trap *first = *list;

	t-&gt;next = first;
	t-&gt;prev = last;
	last-&gt;next = first-&gt;prev = t;
    }
}

private inline void
cont_list_insert_last(gx_san_trap_contact **list, gx_san_trap_contact *t)
{
    /* Assuming a cyclic list. */
    if (*list == 0) {
	*list = t-&gt;next = t-&gt;prev = t;
    } else {
	gx_san_trap_contact *last = cont_list_last(*list);
	gx_san_trap_contact *first = *list;

	t-&gt;next = first;
	t-&gt;prev = last;
	last-&gt;next = first-&gt;prev = t;
    }
}

private inline bool
trap_is_last(const gx_san_trap *list, const gx_san_trap *t)
{
    /* Assuming a non-empty cyclic list, and the anchor points to the first element.  */
    return t-&gt;next == list; 
}

/* ---------------------The device ---------------------------- */

/* The device descriptor */
/* Many of these procedures won't be called; they are set to NULL. */
private const gx_device_spot_analyzer gx_spot_analyzer_device =
{std_device_std_body(gx_device_spot_analyzer, 0, "spot analyzer",
		     0, 0, 1, 1),
 {san_open,
  NULL,
  NULL,
  NULL,
  san_close,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  gx_default_fill_path,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  san_get_clipping_box,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  gx_default_finish_copydevice,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
 }
};

private int
san_open(register gx_device * dev)
{
    gx_device_spot_analyzer * const padev = (gx_device_spot_analyzer *)dev;

    padev-&gt;trap_buffer = padev-&gt;trap_buffer_last = NULL;
    padev-&gt;cont_buffer = padev-&gt;cont_buffer_last = NULL;
    padev-&gt;trap_buffer_count = 0;
    padev-&gt;cont_buffer_count = 0;
    padev-&gt;xmin = 0;
    padev-&gt;xmax = -1;
    return 0;
}

private int
san_close(gx_device * dev)
{
    gx_device_spot_analyzer * const padev = (gx_device_spot_analyzer *)dev;

    free_trap_list(padev-&gt;memory, &amp;padev-&gt;trap_buffer);
    free_cont_list(padev-&gt;memory, &amp;padev-&gt;cont_buffer);
    padev-&gt;trap_buffer_last = NULL;
    padev-&gt;cont_buffer_last = NULL;
    return 0;
}

void
san_get_clipping_box(gx_device * dev, gs_fixed_rect * pbox)
{
    pbox-&gt;p.x = min_int;
    pbox-&gt;p.y = min_int;
    pbox-&gt;q.x = max_int;
    pbox-&gt;q.y = max_int;
}

/* --------------------- Utilities ------------------------- */

private inline void
check_band_list(const gx_san_trap *list)
{
#ifdef DEBUG
    if (list != NULL) {
	const gx_san_trap *t = list;

	while (t-&gt;next != list) {
	    assert(t-&gt;xrtop &lt;= t-&gt;next-&gt;xltop);
	    t = t-&gt;next;
	}
    }
#endif
}

private void
try_unite_last_trap(gx_device_spot_analyzer *padev, fixed xlbot)
{
    if (padev-&gt;bot_band != NULL &amp;&amp; padev-&gt;top_band != NULL) {
	gx_san_trap *last = band_list_last(padev-&gt;top_band);
	gx_san_trap *t = padev-&gt;bot_current;
	/* If the last trapezoid is a prolongation of its bottom contact, 
	   unite it and release the last trapezoid and the last contact. */
	if (t != NULL &amp;&amp; t-&gt;upper != NULL &amp;&amp; last-&gt;xrbot &lt; xlbot &amp;&amp; 
		(last-&gt;prev == last || last-&gt;prev-&gt;xrbot &lt; last-&gt;xlbot)) {
	    if ((t-&gt;next == NULL || t-&gt;xrtop &lt; t-&gt;next-&gt;xltop) &amp;&amp;
	        (t-&gt;upper-&gt;next == t-&gt;upper &amp;&amp;
		    t-&gt;l == last-&gt;l &amp;&amp; t-&gt;r == last-&gt;r)) {
		if (padev-&gt;bot_current == t)
		    padev-&gt;bot_current = (t == band_list_last(padev-&gt;bot_band) ? NULL : t-&gt;next);
		assert(t-&gt;upper-&gt;upper == last); 
		band_list_remove(&amp;padev-&gt;top_band, last);
		band_list_remove(&amp;padev-&gt;bot_band, t);
		band_list_insert_last(&amp;padev-&gt;top_band, t);
		t-&gt;ytop = last-&gt;ytop;
		t-&gt;xltop = last-&gt;xltop;
		t-&gt;xrtop = last-&gt;xrtop;
		t-&gt;rightmost &amp;= last-&gt;rightmost;
		t-&gt;leftmost &amp;= last-&gt;leftmost;
		vd_quad(t-&gt;xlbot, t-&gt;ybot, t-&gt;xrbot, t-&gt;ybot, 
			t-&gt;xrtop, t-&gt;ytop, t-&gt;xltop, t-&gt;ytop, 1, VD_TRAP_U_COLOR);
		trap_unreserve(padev, last);
		cont_unreserve(padev, t-&gt;upper);
		t-&gt;upper = NULL;
	    }
	}
    }
}

private inline double 
trap_area(gx_san_trap *t)
{
    return (double)(t-&gt;xrbot - t-&gt;xlbot + t-&gt;xrtop - t-&gt;xltop) * (t-&gt;ytop - t-&gt;ybot) / 2;
}

private inline double 
trap_axis_length(gx_san_trap *t)
{
    double xbot = (t-&gt;xlbot + t-&gt;xrbot) / 2.0;
    double xtop = (t-&gt;xltop + t-&gt;xrtop) / 2.0;

    return hypot(xtop - xbot, (double)t-&gt;ytop - t-&gt;ybot); /* See Bug 687238 */
}

private inline bool
is_stem_boundaries(gx_san_trap *t, int side_mask)
{
    double dx, norm, cosine;
    const double cosine_threshold = 0.9; /* Arbitrary */
    double dy = t-&gt;ytop - t-&gt;ybot;

    if (side_mask &amp; 1) {
	dx = t-&gt;xltop - t-&gt;xlbot;
	norm = hypot(dx, dy);
	cosine = dx / norm;
	if (any_abs(cosine) &gt; cosine_threshold)
	    return false;
    }
    if (side_mask &amp; 2) {
	dx = t-&gt;xrtop - t-&gt;xrbot;
	norm = hypot(dx, dy);
	cosine = dx / norm;
	if (any_abs(cosine) &gt; cosine_threshold)
	    return false;
    }
    return true;
}

/* --------------------- Accessories ------------------------- */

/* Obtain a spot analyzer device. */
int
gx_san__obtain(gs_memory_t *mem, gx_device_spot_analyzer **ppadev)
{
    gx_device_spot_analyzer *padev;
    int code;

    if (*ppadev != 0) {
	(*ppadev)-&gt;lock++;
	return 0;
    }
    padev = gs_alloc_struct(mem, gx_device_spot_analyzer, 
		&amp;st_device_spot_analyzer, "gx_san__obtain");
    if (padev == 0)
	return_error(gs_error_VMerror);
    gx_device_init((gx_device *)padev, (const gx_device *)&amp;gx_spot_analyzer_device,
		   mem, false);
    code = gs_opendevice((gx_device *)padev);
    if (code &lt; 0) {
	gs_free_object(mem, padev, "gx_san__obtain");
	return code;
    }
    padev-&gt;lock = 1;
    *ppadev = padev;
    return 0;
}

void
gx_san__release(gx_device_spot_analyzer **ppadev)
{
    gx_device_spot_analyzer *padev = *ppadev;

    if (padev == NULL) {
	eprintf("Extra call to gx_san__release.");
	return;
    }
    if(--padev-&gt;lock &lt; 0) {
	eprintf("Wrong lock to gx_san__release.");
	return;
    }
    if (padev-&gt;lock == 0) {
	*ppadev = NULL;
	rc_decrement(padev, "gx_san__release");
    }
}

/* Start accumulating a path. */
void 
gx_san_begin(gx_device_spot_analyzer *padev)
{
    padev-&gt;bot_band = NULL;
    padev-&gt;top_band = NULL;
    padev-&gt;bot_current = NULL;
    padev-&gt;trap_free = padev-&gt;trap_buffer;
    padev-&gt;cont_free = padev-&gt;cont_buffer;
}

/* Store a tarpezoid. */
/* Assumes an Y-band scanning order with increasing X inside a band. */
int
gx_san_trap_store(gx_device_spot_analyzer *padev, 
    fixed ybot, fixed ytop, fixed xlbot, fixed xrbot, fixed xltop, fixed xrtop,
    const segment *l, const segment *r, int dir_l, int dir_r)
{
    gx_san_trap *last;

    if (padev-&gt;top_band != NULL &amp;&amp; padev-&gt;top_band-&gt;ytop != ytop) {
	try_unite_last_trap(padev, max_int);
	/* Step to a new band. */
	padev-&gt;bot_band = padev-&gt;bot_current = padev-&gt;top_band;
	padev-&gt;top_band = NULL;
    }
    if (padev-&gt;bot_band != NULL &amp;&amp; padev-&gt;bot_band-&gt;ytop != ybot) {
	/* The Y-projection of the spot is not contiguous. */
	padev-&gt;top_band = NULL;
    }
    if (padev-&gt;top_band != NULL)
	try_unite_last_trap(padev, xlbot);
    check_band_list(padev-&gt;bot_band);
    check_band_list(padev-&gt;top_band);
    /* Make new trapezoid. */
    last = trap_reserve(padev);
    if (last == NULL)
	return_error(gs_error_VMerror);
    last-&gt;ybot = ybot;
    last-&gt;ytop = ytop;
    last-&gt;xlbot = xlbot;
    last-&gt;xrbot = xrbot;
    last-&gt;xltop = xltop;
    last-&gt;xrtop = xrtop;
    last-&gt;l = l;
    last-&gt;r = r;
    last-&gt;dir_l = dir_l;
    last-&gt;dir_r = dir_r;
    last-&gt;upper = 0;
    last-&gt;fork = 0;
    last-&gt;visited = false;
    last-&gt;leftmost = last-&gt;rightmost = true;
    vd_quad(last-&gt;xlbot, last-&gt;ybot, last-&gt;xrbot, last-&gt;ybot, 
	    last-&gt;xrtop, last-&gt;ytop, last-&gt;xltop, last-&gt;ytop, 1, VD_TRAP_N_COLOR);
    if (padev-&gt;top_band != NULL) {
	padev-&gt;top_band-&gt;rightmost = false;
	last-&gt;leftmost = false;
    }
    band_list_insert_last(&amp;padev-&gt;top_band, last);
    check_band_list(padev-&gt;top_band);
    while (padev-&gt;bot_current != NULL &amp;&amp; padev-&gt;bot_current-&gt;xrtop &lt; xlbot)
	padev-&gt;bot_current = (trap_is_last(padev-&gt;bot_band, padev-&gt;bot_current)
				    ? NULL : padev-&gt;bot_current-&gt;next);
    if (padev-&gt;bot_current != 0) {
	gx_san_trap *t = padev-&gt;bot_current;
	gx_san_trap *bot_last = band_list_last(padev-&gt;bot_band);

	while(t-&gt;xltop &lt;= xrbot) {
	    gx_san_trap_contact *cont = cont_reserve(padev);

	    if (cont == NULL)
		return_error(gs_error_VMerror);
	    cont-&gt;lower = t;
	    cont-&gt;upper = last;
	    vd_bar((t-&gt;xltop + t-&gt;xrtop + t-&gt;xlbot + t-&gt;xrbot) / 4, (t-&gt;ytop + t-&gt;ybot) / 2,
		   (last-&gt;xltop + last-&gt;xrtop + last-&gt;xlbot + last-&gt;xrbot) / 4, 
		   (last-&gt;ytop + last-&gt;ybot) / 2, 0, VD_CONT_COLOR);
	    cont_list_insert_last(&amp;t-&gt;upper, cont);
	    last-&gt;fork++;
	    if (t == bot_last)
		break;
	    t = t-&gt;next;
	}
    }
    if (padev-&gt;xmin &gt; padev-&gt;xmax) {
	padev-&gt;xmin = min(xlbot, xltop);
	padev-&gt;xmax = max(xrbot, xrtop);
    } else {
	padev-&gt;xmin = min(padev-&gt;xmin, min(xlbot, xltop));
	padev-&gt;xmax = max(padev-&gt;xmax, max(xrbot, xrtop));
    }
    return 0;
}


/* Finish accumulating a path. */
void 
gx_san_end(const gx_device_spot_analyzer *padev)
{
}

private int
hint_by_trap(gx_device_spot_analyzer *padev, int side_mask,
    void *client_data, gx_san_trap *t0, gx_san_trap *t1, double ave_width,
    int (*handler)(void *client_data, gx_san_sect *ss))
{   gx_san_trap *t;
    double w, wd, best_width_diff = ave_width * 10;
    gx_san_trap *best_trap = NULL;
    bool at_top = false;
    gx_san_sect sect;
    int code;

    for (t = t0; ; t = t-&gt;upper-&gt;upper) {
	w = t-&gt;xrbot - t-&gt;xlbot;
	wd = any_abs(w - ave_width);
	if (w &gt; 0 &amp;&amp; wd &lt; best_width_diff) {
	    best_width_diff = wd;
	    best_trap = t;
	}
	if (t == t1)
	    break;
    }
    w = t-&gt;xrtop - t-&gt;xltop;
    wd = any_abs(w - ave_width);
    if (w &gt; 0 &amp;&amp; wd &lt; best_width_diff) {
	best_width_diff = wd;
	best_trap = t;
	at_top = true;
    }
    if (best_trap != NULL) {
	/* Make a stem section hint at_top of best_trap : */
	sect.yl = at_top ? best_trap-&gt;ytop : best_trap-&gt;ybot; 
	sect.yr = sect.yl;
	sect.xl = at_top ? best_trap-&gt;xltop : best_trap-&gt;xlbot; 
	sect.xr = at_top ? best_trap-&gt;xrtop : best_trap-&gt;xrbot;
	sect.l = best_trap-&gt;l; 
	sect.r = best_trap-&gt;r;
	vd_bar(sect.xl, sect.yl, sect.xr, sect.yr, 0, VD_HINT_COLOR);
	code = handler(client_data, &amp;sect);
	if (code &lt; 0)
	    return code;
    }
    return 0;
}

private inline void
choose_by_vector(fixed x0, fixed y0, fixed x1, fixed y1, const segment *s, 
	double *slope, double *len, const segment **store_segm, fixed *store_x, fixed *store_y)
{
    if (y0 != y1) {
	double t = (double)any_abs(x1 - x0) / any_abs(y1 - y0);
	double l = any_abs(y1 - y0); /* Don't want 'hypot'. */

	if (*slope &gt; t || (*slope == t &amp;&amp; l &gt; *len)) {
	    *slope = t;
	    *len = l;
	    *store_segm = s;
	    *store_x = x1;
	    *store_y = y1;
	}
    }
}

private inline void
choose_by_tangent(const segment *p, const segment *s, 
	double *slope, double *len, const segment **store_segm, fixed *store_x, fixed *store_y,
	fixed ybot, fixed ytop)
{
    if (s-&gt;type == s_curve) {
	const curve_segment *c = (const curve_segment *)s;
	vd_curve(p-&gt;pt.x, p-&gt;pt.y, c-&gt;p1.x, c-&gt;p1.y, c-&gt;p2.x, c-&gt;p2.y, 
		 s-&gt;pt.x, s-&gt;pt.y, 0, VD_HINT_COLOR);
	if (ybot &lt;= p-&gt;pt.y &amp;&amp; p-&gt;pt.y &lt;= ytop)
	    choose_by_vector(c-&gt;p1.x, c-&gt;p1.y, p-&gt;pt.x, p-&gt;pt.y, s, slope, len, store_segm, store_x, store_y);
	if (ybot &lt;= s-&gt;pt.y &amp;&amp; s-&gt;pt.y &lt;= ytop)
	    choose_by_vector(c-&gt;p2.x, c-&gt;p2.y, s-&gt;pt.x, s-&gt;pt.y, s, slope, len, store_segm, store_x, store_y);
    } else {
	vd_bar(p-&gt;pt.x, p-&gt;pt.y, s-&gt;pt.x, s-&gt;pt.y, 0, VD_HINT_COLOR);
	choose_by_vector(s-&gt;pt.x, s-&gt;pt.y, p-&gt;pt.x, p-&gt;pt.y, s, slope, len, store_segm, store_x, store_y);
    }
}

private gx_san_trap * 
upper_neighbour(gx_san_trap *t0, int left_right)
{
    gx_san_trap_contact *cont = t0-&gt;upper, *c0 = cont, *c;
    fixed x = (!left_right ? cont-&gt;upper-&gt;xlbot : cont-&gt;upper-&gt;xrbot);

    for (c = c0-&gt;next; c != c0; c = c-&gt;next) {
	fixed xx = (!left_right ? c-&gt;upper-&gt;xlbot : c-&gt;upper-&gt;xrbot);

	if ((xx - x) * (left_right * 2 - 1) &gt; 0) {
    	    cont = c;
	    x = xx;
	}
    }
    return cont-&gt;upper;
}

private int
hint_by_tangent(gx_device_spot_analyzer *padev, int side_mask,
    void *client_data, gx_san_trap *t0, gx_san_trap *t1, double ave_width,
    int (*handler)(void *client_data, gx_san_sect *ss))
{   gx_san_trap *t;
    gx_san_sect sect;
    double slope0 = 0.2, slope1 = slope0, len0 = 0, len1 = 0;
    const segment *s, *p;
    int left_right = (side_mask &amp; 1 ? 0 : 1);
    int code;
    
    sect.l = sect.r = NULL;
    sect.xl = t0-&gt;xltop; /* only for vdtrace. */
    sect.xr = t0-&gt;xrtop; /* only for vdtrace. */
    sect.yl = sect.yr = t0-&gt;ytop; /* only for vdtrace. */
    sect.side_mask = side_mask;
    for (t = t0; ; t = upper_neighbour(t, left_right)) {
	if (side_mask &amp; 1) {
	    s = t-&gt;l;
	    if (t-&gt;dir_l &lt; 0)
		s = (s-&gt;type == s_line_close ? ((const line_close_segment *)s)-&gt;sub-&gt;next : s-&gt;next);
	    p = (s-&gt;type == s_start ? ((const subpath *)s)-&gt;last-&gt;prev : s-&gt;prev);
	    choose_by_tangent(p, s, &amp;slope0, &amp;len0, &amp;sect.l, &amp;sect.xl, &amp;sect.yl, t-&gt;ybot, t-&gt;ytop);
	}
	if (side_mask &amp; 2) {
	    s = t-&gt;r;
	    if (t-&gt;dir_r &lt; 0)
		s = (s-&gt;type == s_line_close ? ((const line_close_segment *)s)-&gt;sub-&gt;next : s-&gt;next);
	    p = (s-&gt;type == s_start ? ((const subpath *)s)-&gt;last-&gt;prev : s-&gt;prev);
	    choose_by_tangent(p, s, &amp;slope1, &amp;len1, &amp;sect.r, &amp;sect.xr, &amp;sect.yr, t-&gt;ybot, t-&gt;ytop);
	}
	if (t == t1)
	    break;
    }
    if ((sect.l != NULL  || !(side_mask &amp; 1)) &amp;&amp; 
	(sect.r != NULL  || !(side_mask &amp; 2))) {
	const int w = 3;

	if (!(side_mask &amp; 1)) {
	    if (sect.xr &lt; (padev-&gt;xmin * w + padev-&gt;xmax) / (w + 1))
		return 0;
	    sect.xl = padev-&gt;xmin - 1000; /* ignore side */
	}
	if (!(side_mask &amp; 2)) {
	    if (sect.xl &gt; (padev-&gt;xmax * w + padev-&gt;xmin) / (w + 1))
		return 0;
	    sect.xr = padev-&gt;xmax + 1000; /* ignore side */
	}
	vd_bar(sect.xl, sect.yl, sect.xr, sect.yr, 0, VD_HINT_COLOR);
	code = handler(client_data, &amp;sect);
	if (code &lt; 0)
	    return code;
    }
    return 0;
}

/* Generate stems. */
private int 
gx_san_generate_stems_aux(gx_device_spot_analyzer *padev, 
		bool overall_hints, void *client_data,
		int (*handler)(void *client_data, gx_san_sect *ss))
{
    gx_san_trap *t0;
    const bool by_trap = false;
    int k;

    /* Overall hints : */
    /* An overall hint designates an outer side of a glyph,
       being nearly parallel to a coordinate axis. 
       It aligns a stem end rather than stem sides.
       See t1_hinter__overall_hstem.
     */
    for (k = 0; overall_hints &amp;&amp; k &lt; 2; k++) { /* left, right. */
	for (t0 = padev-&gt;trap_buffer; t0 != padev-&gt;trap_free; t0 = t0-&gt;link) {
	    if (!t0-&gt;visited &amp;&amp; (!k ? t0-&gt;leftmost : t0-&gt;rightmost)) {
		if (is_stem_boundaries(t0, 1 &lt;&lt; k)) {
		    gx_san_trap *t1 = t0, *tt = t0, *t = t0;
		    int code;

		    while (t-&gt;upper != NULL) {
			t = upper_neighbour(tt, k);
			if (!k ? !t-&gt;leftmost : !t-&gt;rightmost) {
			    break;
			}
			if (!is_stem_boundaries(t, 1 &lt;&lt; k)) {
			    t-&gt;visited = true;
			    break;
			}
			if ((!k ? tt-&gt;xltop : tt-&gt;xrtop) != (!k ? t-&gt;xlbot : t-&gt;xrbot))
			    break; /* Not a contigouos boundary. */
    			t-&gt;visited = true;
			tt = t;
		    }
		    if (!k ? !t-&gt;leftmost : !t-&gt;rightmost)
			continue;
		    t1 = t;
		    /* leftmost/rightmost boundary from t0 to t1. */
		    code = hint_by_tangent(padev, 1 &lt;&lt; k, client_data, t0, t1, 0, handler);
		    if (code &lt; 0)
			return code;
		}
	    }
	}
	for (t0 = padev-&gt;trap_buffer; t0 != padev-&gt;trap_free; t0 = t0-&gt;link)
	    t0-&gt;visited = false;
    }
    /* Stem hints : */
    for (t0 = padev-&gt;trap_buffer; t0 != padev-&gt;trap_free; t0 = t0-&gt;link) {
	if (!t0-&gt;visited) {
	    if (is_stem_boundaries(t0, 3)) {
		gx_san_trap_contact *cont = t0-&gt;upper;
		gx_san_trap *t1 = t0, *t;
		double area = 0, length = 0, ave_width;
		
		while(cont != NULL &amp;&amp; cont-&gt;next == cont /* &lt;= 1 descendent. */) {
		    gx_san_trap *t = cont-&gt;upper;

		    if (!is_stem_boundaries(t, 3)) {
			t-&gt;visited = true;
			break;
		    }
		    if (t-&gt;fork &gt; 1)
			break; /* &gt; 1 accendents.  */
		    if (t1-&gt;xltop != t-&gt;xlbot || t1-&gt;xrtop != t-&gt;xrbot)
			break; /* Not a contigouos boundary. */
		    t1 = t;
		    cont = t1-&gt;upper;
		    t1-&gt;visited = true;
		}
		/* We've got a stem suspection from t0 to t1. */
		vd_quad(t0-&gt;xlbot, t0-&gt;ybot, t0-&gt;xrbot, t0-&gt;ybot, 
			t1-&gt;xrtop, t1-&gt;ytop, t1-&gt;xltop, t1-&gt;ytop, 1, VD_STEM_COLOR);
		for (t = t0; ; t = t-&gt;upper-&gt;upper) {
		    length += trap_axis_length(t);
		    area += trap_area(t);
		    if (t == t1)
			break;
		}
		ave_width = area / length;
		if (length &gt; ave_width / ( 2.0 /* arbitrary */)) {
		    /* We've got a stem from t0 to t1. */
		    int code = (by_trap ? hint_by_trap : hint_by_tangent)(padev, 
			3, client_data, t0, t1, ave_width, handler);

		    if (code &lt; 0)
			return code;
		}
	    }
	}
	t0-&gt;visited = true;
    }
    return 0;
}

int 
gx_san_generate_stems(gx_device_spot_analyzer *padev, 
		bool overall_hints, void *client_data,
		int (*handler)(void *client_data, gx_san_sect *ss))
{
    int code;

    vd_get_dc('f');
    vd_set_shift(0, 0);
    vd_set_scale(VD_SCALE);
    vd_set_origin(0, 0);
    code = gx_san_generate_stems_aux(padev, overall_hints, client_data, handler);
    vd_release_dc;
    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

