<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/ilocate.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/ilocate.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995-2000, 2004 artofcode LLC.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: ilocate.c,v 1.14 2005/10/12 11:05:11 leonardo Exp $ */
/* Object locating and validating for Ghostscript memory manager */
#include "ghost.h"
#include "memory_.h"
#include "ierrors.h"
#include "gsexit.h"
#include "gsstruct.h"
#include "iastate.h"
#include "idict.h"
#include "igc.h"	/* for gc_state_t and gcst_get_memory_ptr() */
#include "igcstr.h"	/* for prototype */
#include "iname.h"
#include "ipacked.h"
#include "isstate.h"
#include "iutil.h"	/* for packed_get */
#include "ivmspace.h"
#include "store.h"

/* ================ Locating ================ */

/* Locate a pointer in the chunks of a space being collected. */
/* This is only used for string garbage collection and for debugging. */
chunk_t *
gc_locate(const void *ptr, gc_state_t * gcst)
{
    const gs_ref_memory_t *mem;
    const gs_ref_memory_t *other;

    if (chunk_locate(ptr, &amp;gcst-&gt;loc))
	return gcst-&gt;loc.cp;
    mem = gcst-&gt;loc.memory;

    /*
     * Try the stable allocator of this space, or, if the current memory
     * is the stable one, the non-stable allocator of this space.
     */

    if ((other = (const gs_ref_memory_t *)mem-&gt;stable_memory) != mem ||
	(other = gcst-&gt;spaces_indexed[mem-&gt;space &gt;&gt; r_space_shift]) != mem
	) {
	gcst-&gt;loc.memory = other;
	gcst-&gt;loc.cp = 0;
	if (chunk_locate(ptr, &amp;gcst-&gt;loc))
	    return gcst-&gt;loc.cp;
    }

    /*
     * Try the other space, if there is one, including its stable allocator
     * and all save levels.  (If the original space is system space, try
     * local space.)
     */

    if (gcst-&gt;space_local != gcst-&gt;space_global) {
	gcst-&gt;loc.memory = other =
	    (mem-&gt;space == avm_local ? gcst-&gt;space_global : gcst-&gt;space_local);
	gcst-&gt;loc.cp = 0;
	if (chunk_locate(ptr, &amp;gcst-&gt;loc))
	    return gcst-&gt;loc.cp;
	/* Try its stable allocator. */
	if (other-&gt;stable_memory != (const gs_memory_t *)other) {
	    gcst-&gt;loc.memory = (gs_ref_memory_t *)other-&gt;stable_memory;
	    gcst-&gt;loc.cp = 0;
	    if (chunk_locate(ptr, &amp;gcst-&gt;loc))
		return gcst-&gt;loc.cp;
	    gcst-&gt;loc.memory = other;
	}
	/* Try other save levels of this space. */
	while (gcst-&gt;loc.memory-&gt;saved != 0) {
	    gcst-&gt;loc.memory = &amp;gcst-&gt;loc.memory-&gt;saved-&gt;state;
	    gcst-&gt;loc.cp = 0;
	    if (chunk_locate(ptr, &amp;gcst-&gt;loc))
		return gcst-&gt;loc.cp;
	}
    }

    /*
     * Try system space.  This is simpler because it isn't subject to
     * save/restore and doesn't have a separate stable allocator.
     */

    if (mem != gcst-&gt;space_system) {
	gcst-&gt;loc.memory = gcst-&gt;space_system;
	gcst-&gt;loc.cp = 0;
	if (chunk_locate(ptr, &amp;gcst-&gt;loc))
	    return gcst-&gt;loc.cp;
    }

    /*
     * Try other save levels of the initial space, or of global space if the
     * original space was system space.  In the latter case, try all
     * levels, and its stable allocator.
     */

    switch (mem-&gt;space) {
    default:			/* system */
	other = gcst-&gt;space_global;
	if (other-&gt;stable_memory != (const gs_memory_t *)other) {
	    gcst-&gt;loc.memory = (gs_ref_memory_t *)other-&gt;stable_memory;
	    gcst-&gt;loc.cp = 0;
	    if (chunk_locate(ptr, &amp;gcst-&gt;loc))
		return gcst-&gt;loc.cp;
	}
	gcst-&gt;loc.memory = other;
	break;
    case avm_global:
	gcst-&gt;loc.memory = gcst-&gt;space_global;
	break;
    case avm_local:
	gcst-&gt;loc.memory = gcst-&gt;space_local;
	break;
    }
    for (;;) {
	if (gcst-&gt;loc.memory != mem) {	/* don't do twice */
	    gcst-&gt;loc.cp = 0;
	    if (chunk_locate(ptr, &amp;gcst-&gt;loc))
		return gcst-&gt;loc.cp;
	}
	if (gcst-&gt;loc.memory-&gt;saved == 0)
	    break;
	gcst-&gt;loc.memory = &amp;gcst-&gt;loc.memory-&gt;saved-&gt;state;
    }

    /* Restore locator to a legal state and report failure. */

    gcst-&gt;loc.memory = mem;
    gcst-&gt;loc.cp = 0;
    return 0;
}

/* ================ Debugging ================ */

#ifdef DEBUG

/* Define the structure for temporarily saving allocator state. */
typedef struct alloc_temp_save_s {
	chunk_t cc;
	uint rsize;
	ref rlast;
} alloc_temp_save_t;
/* Temporarily save the state of an allocator. */
private void
alloc_temp_save(alloc_temp_save_t *pats, gs_ref_memory_t *mem)
{
    chunk_t *pcc = mem-&gt;pcc;
    obj_header_t *rcur = mem-&gt;cc.rcur;

    if (pcc != 0) {
	pats-&gt;cc = *pcc;
	*pcc = mem-&gt;cc;
    }
    if (rcur != 0) {
	pats-&gt;rsize = rcur[-1].o_size;
	rcur[-1].o_size = mem-&gt;cc.rtop - (byte *) rcur;
	/* Create the final ref, reserved for the GC. */
	pats-&gt;rlast = ((ref *) mem-&gt;cc.rtop)[-1];
	make_mark((ref *) mem-&gt;cc.rtop - 1);
    }
}
/* Restore the temporarily saved state. */
private void
alloc_temp_restore(alloc_temp_save_t *pats, gs_ref_memory_t *mem)
{
    chunk_t *pcc = mem-&gt;pcc;
    obj_header_t *rcur = mem-&gt;cc.rcur;

    if (rcur != 0) {
	rcur[-1].o_size = pats-&gt;rsize;
	((ref *) mem-&gt;cc.rtop)[-1] = pats-&gt;rlast;
    }
    if (pcc != 0)
	*pcc = pats-&gt;cc;
}

/* Validate the contents of an allocator. */
void
ialloc_validate_spaces(const gs_dual_memory_t * dmem)
{
    int i;
    gc_state_t state;
    alloc_temp_save_t
	save[countof(dmem-&gt;spaces_indexed)],
	save_stable[countof(dmem-&gt;spaces_indexed)];
    gs_ref_memory_t *mem;

    state.spaces = dmem-&gt;spaces;
    state.loc.memory = state.space_local;
    state.loc.cp = 0;

    /* Save everything we need to reset temporarily. */

    for (i = 0; i &lt; countof(save); i++)
	if ((mem = dmem-&gt;spaces_indexed[i]) != 0) {
	    alloc_temp_save(&amp;save[i], mem);
	    if (mem-&gt;stable_memory != (gs_memory_t *)mem)
		alloc_temp_save(&amp;save_stable[i],
				(gs_ref_memory_t *)mem-&gt;stable_memory);
	}

    /* Validate memory. */

    for (i = 0; i &lt; countof(save); i++)
	if ((mem = dmem-&gt;spaces_indexed[i]) != 0) {
	    ialloc_validate_memory(mem, &amp;state);
	    if (mem-&gt;stable_memory != (gs_memory_t *)mem)
		ialloc_validate_memory((gs_ref_memory_t *)mem-&gt;stable_memory,
				       &amp;state);
	}

    /* Undo temporary changes. */

    for (i = 0; i &lt; countof(save); i++)
	if ((mem = dmem-&gt;spaces_indexed[i]) != 0) {
	    if (mem-&gt;stable_memory != (gs_memory_t *)mem)
		alloc_temp_restore(&amp;save_stable[i],
				   (gs_ref_memory_t *)mem-&gt;stable_memory);
	    alloc_temp_restore(&amp;save[i], mem);
	}
}
void
ialloc_validate_memory(const gs_ref_memory_t * mem, gc_state_t * gcst)
{
    const gs_ref_memory_t *smem;
    int level;

    for (smem = mem, level = 0; smem != 0;
	 smem = &amp;smem-&gt;saved-&gt;state, --level
	) {
	const chunk_t *cp;
	int i;

	if_debug3('6', "[6]validating memory 0x%lx, space %d, level %d\n",
		  (ulong) mem, mem-&gt;space, level);
	/* Validate chunks. */
	for (cp = smem-&gt;cfirst; cp != 0; cp = cp-&gt;cnext)
	    ialloc_validate_chunk(cp, gcst);
	/* Validate freelists. */
	for (i = 0; i &lt; num_freelists; ++i) {
	    uint free_size = i &lt;&lt; log2_obj_align_mod;
	    const obj_header_t *pfree;

	    for (pfree = mem-&gt;freelists[i]; pfree != 0;
		 pfree = *(const obj_header_t * const *)pfree
		) {
		uint size = pfree[-1].o_size;

		if (pfree[-1].o_type != &amp;st_free) {
		    lprintf3("Non-free object 0x%lx(%u) on freelist %i!\n",
			     (ulong) pfree, size, i);
		    break;
		}
		if ((i == LARGE_FREELIST_INDEX &amp;&amp; size &lt; max_freelist_size) ||
		 (i != LARGE_FREELIST_INDEX &amp;&amp; 
		 (size &lt; free_size - obj_align_mask || size &gt; free_size))) {
		    lprintf3("Object 0x%lx(%u) size wrong on freelist %i!\n",
			     (ulong) pfree, size, i);
		    break;
		}
	    }
	}
    };
}

/* Check the validity of an object's size. */
inline private bool
object_size_valid(const obj_header_t * pre, uint size, const chunk_t * cp)
{
    return (pre-&gt;o_alone ? (const byte *)pre == cp-&gt;cbase :
	    size &lt;= cp-&gt;ctop - (const byte *)(pre + 1));
}

/* Validate all the objects in a chunk. */
#if IGC_PTR_STABILITY_CHECK
void ialloc_validate_pointer_stability(const obj_header_t * ptr_from, 
				   const obj_header_t * ptr_to);
private void ialloc_validate_ref(const ref *, gc_state_t *, const obj_header_t *pre_fr);
private void ialloc_validate_ref_packed(const ref_packed *, gc_state_t *, const obj_header_t *pre_fr);
#else
private void ialloc_validate_ref(const ref *, gc_state_t *);
private void ialloc_validate_ref_packed(const ref_packed *, gc_state_t *);
#endif
void
ialloc_validate_chunk(const chunk_t * cp, gc_state_t * gcst)
{
    if_debug_chunk('6', "[6]validating chunk", cp);
    SCAN_CHUNK_OBJECTS(cp);
    DO_ALL
	if (pre-&gt;o_type == &amp;st_free) {
	    if (!object_size_valid(pre, size, cp))
		lprintf3("Bad free object 0x%lx(%lu), in chunk 0x%lx!\n",
			 (ulong) (pre + 1), (ulong) size, (ulong) cp);
	} else
	    ialloc_validate_object(pre + 1, cp, gcst);
    if_debug3('7', " [7]validating %s(%lu) 0x%lx\n",
	      struct_type_name_string(pre-&gt;o_type),
	      (ulong) size, (ulong) pre);
    if (pre-&gt;o_type == &amp;st_refs) {
	const ref_packed *rp = (const ref_packed *)(pre + 1);
	const char *end = (const char *)rp + size;

	while ((const char *)rp &lt; end) {
#	    if IGC_PTR_STABILITY_CHECK
	    ialloc_validate_ref_packed(rp, gcst, pre);
#	    else
	    ialloc_validate_ref_packed(rp, gcst);
#	    endif
	    rp = packed_next(rp);
	}
    } else {
	struct_proc_enum_ptrs((*proc)) = pre-&gt;o_type-&gt;enum_ptrs;
	uint index = 0;
	enum_ptr_t eptr;
	gs_ptr_type_t ptype;

	if (proc != gs_no_struct_enum_ptrs)
	    for (; (ptype = (*proc) (gcst_get_memory_ptr(gcst), 
				     pre + 1, size, index, &amp;eptr, 
				     pre-&gt;o_type, gcst)) != 0; ++index) {
		if (eptr.ptr == 0)
		    DO_NOTHING;
		else if (ptype == ptr_struct_type) {
		    ialloc_validate_object(eptr.ptr, NULL, gcst);
#		    if IGC_PTR_STABILITY_CHECK
			ialloc_validate_pointer_stability(pre, 
			    (const obj_header_t *)eptr.ptr - 1);
#		    endif
		} else if (ptype == ptr_ref_type)
#		    if IGC_PTR_STABILITY_CHECK
		    ialloc_validate_ref_packed(eptr.ptr, gcst, pre);
#		    else
		    ialloc_validate_ref_packed(eptr.ptr, gcst);
#		    endif
	    }
    }
    END_OBJECTS_SCAN
}
/* Validate a ref. */
#if IGC_PTR_STABILITY_CHECK
private void
ialloc_validate_ref_packed(const ref_packed * rp, gc_state_t * gcst, const obj_header_t *pre_fr)
{
    const gs_memory_t *cmem = gcst-&gt;spaces.memories.named.system-&gt;stable_memory;

    if (r_is_packed(rp)) {
	ref unpacked;

	packed_get(cmem, rp, &amp;unpacked);
	ialloc_validate_ref(&amp;unpacked, gcst, pre_fr);
    } else {
	ialloc_validate_ref((const ref *)rp, gcst, pre_fr);
    }
}
#else
private void
ialloc_validate_ref_packed(const ref_packed * rp, gc_state_t * gcst)
{
    const gs_memory_t *cmem = gcst-&gt;spaces.memories.named.system-&gt;stable_memory;

    if (r_is_packed(rp)) {
	ref unpacked;

	packed_get(cmem, rp, &amp;unpacked);
	ialloc_validate_ref(&amp;unpacked, gcst);
    } else {
	ialloc_validate_ref((const ref *)rp, gcst);
    }
}
#endif
private void
ialloc_validate_ref(const ref * pref, gc_state_t * gcst
#		    if IGC_PTR_STABILITY_CHECK
			, const obj_header_t *pre_fr
#		    endif
		    )
{
    const void *optr;
    const ref *rptr;
    const char *tname;
    uint size;
    const gs_memory_t *cmem = gcst-&gt;spaces.memories.named.system-&gt;stable_memory;

    if (!gs_debug_c('?'))
	return;			/* no check */
    if (r_space(pref) == avm_foreign)
	return;
    switch (r_type(pref)) {
	case t_file:
	    optr = pref-&gt;value.pfile;
	    goto cks;
	case t_device:
	    optr = pref-&gt;value.pdevice;
	    goto cks;
	case t_fontID:
	case t_struct:
	case t_astruct:
	    optr = pref-&gt;value.pstruct;
cks:	    if (optr != 0) {
		ialloc_validate_object(optr, NULL, gcst);
#		if IGC_PTR_STABILITY_CHECK
		    ialloc_validate_pointer_stability(pre_fr, 
			    (const obj_header_t *)optr - 1);
#		endif
	    }
	    break;
	case t_name:
	    if (name_index_ptr(cmem, name_index(cmem, pref)) != pref-&gt;value.pname) {
		lprintf3("At 0x%lx, bad name %u, pname = 0x%lx\n",
			 (ulong) pref, (uint)name_index(cmem, pref),
			 (ulong) pref-&gt;value.pname);
		break;
	    } {
		ref sref;

		name_string_ref(cmem, pref, &amp;sref);
		if (r_space(&amp;sref) != avm_foreign &amp;&amp;
		    !gc_locate(sref.value.const_bytes, gcst)
		    ) {
		    lprintf4("At 0x%lx, bad name %u, pname = 0x%lx, string 0x%lx not in any chunk\n",
			     (ulong) pref, (uint) r_size(pref),
			     (ulong) pref-&gt;value.pname,
			     (ulong) sref.value.const_bytes);
		}
	    }
	    break;
	case t_string:
	    if (r_size(pref) != 0 &amp;&amp; !gc_locate(pref-&gt;value.bytes, gcst))
		lprintf3("At 0x%lx, string ptr 0x%lx[%u] not in any chunk\n",
			 (ulong) pref, (ulong) pref-&gt;value.bytes,
			 (uint) r_size(pref));
	    break;
	case t_array:
	    if (r_size(pref) == 0)
		break;
	    rptr = pref-&gt;value.refs;
	    size = r_size(pref);
	    tname = "array";
cka:	    if (!gc_locate(rptr, gcst)) {
		lprintf3("At 0x%lx, %s 0x%lx not in any chunk\n",
			 (ulong) pref, tname, (ulong) rptr);
		break;
	    } {
		uint i;

		for (i = 0; i &lt; size; ++i) {
		    const ref *elt = rptr + i;

		    if (r_is_packed(elt))
			lprintf5("At 0x%lx, %s 0x%lx[%u] element %u is not a ref\n",
				 (ulong) pref, tname, (ulong) rptr, size, i);
		}
	    }
	    break;
	case t_shortarray:
	case t_mixedarray:
	    if (r_size(pref) == 0)
		break;
	    optr = pref-&gt;value.packed;
	    if (!gc_locate(optr, gcst))
		lprintf2("At 0x%lx, packed array 0x%lx not in any chunk\n",
			 (ulong) pref, (ulong) optr);
	    break;
	case t_dictionary:
	    {
		const dict *pdict = pref-&gt;value.pdict;

		if (!r_has_type(&amp;pdict-&gt;values, t_array) ||
		    !r_is_array(&amp;pdict-&gt;keys) ||
		    !r_has_type(&amp;pdict-&gt;count, t_integer) ||
		    !r_has_type(&amp;pdict-&gt;maxlength, t_integer)
		    )
		    lprintf2("At 0x%lx, invalid dict 0x%lx\n",
			     (ulong) pref, (ulong) pdict);
		rptr = (const ref *)pdict;
	    }
	    size = sizeof(dict) / sizeof(ref);
	    tname = "dict";
	    goto cka;
    }
}

#if IGC_PTR_STABILITY_CHECK
/* Validate an pointer stability. */
void
ialloc_validate_pointer_stability(const obj_header_t * ptr_fr, 
				   const obj_header_t * ptr_to)
{
    static const char *sn[] = {"undef", "undef", "system", "undef", 
		"global_stable", "global", "local_stable", "local"};

    if (ptr_fr-&gt;d.o.space_id &lt; ptr_to-&gt;d.o.space_id) {
	const char *sn_fr = (ptr_fr-&gt;d.o.space_id &lt; count_of(sn) 
			? sn[ptr_fr-&gt;d.o.space_id] : "unknown");
	const char *sn_to = (ptr_to-&gt;d.o.space_id &lt; count_of(sn) 
			? sn[ptr_to-&gt;d.o.space_id] : "unknown");

	lprintf6("Reference to a less stable object 0x%lx&lt;%s&gt; "
	         "in the space \'%s\' from 0x%lx&lt;%s&gt; in the space \'%s\' !\n",
		 (ulong) ptr_to, ptr_to-&gt;d.o.t.type-&gt;sname, sn_to, 
		 (ulong) ptr_fr, ptr_fr-&gt;d.o.t.type-&gt;sname, sn_fr);
    }
}
#endif

/* Validate an object. */
void
ialloc_validate_object(const obj_header_t * ptr, const chunk_t * cp,
		       gc_state_t * gcst)
{
    const obj_header_t *pre = ptr - 1;
    ulong size = pre_obj_contents_size(pre);
    gs_memory_type_ptr_t otype = pre-&gt;o_type;
    const char *oname;

    if (!gs_debug_c('?'))
	return;			/* no check */
    if (cp == 0 &amp;&amp; gcst != 0) {
	gc_state_t st;

	st = *gcst;		/* no side effects! */
	if (!(cp = gc_locate(pre, &amp;st))) {
	    lprintf1("Object 0x%lx not in any chunk!\n",
		     (ulong) ptr);
	    return;		/*gs_abort(); */
	}
    }
    if (otype == &amp;st_free) {
	lprintf3("Reference to free object 0x%lx(%lu), in chunk 0x%lx!\n",
		 (ulong) ptr, (ulong) size, (ulong) cp);
	gs_abort(gcst-&gt;heap);
    }
    if ((cp != 0 &amp;&amp; !object_size_valid(pre, size, cp)) ||
	otype-&gt;ssize == 0 ||
	size % otype-&gt;ssize != 0 ||
	(oname = struct_type_name_string(otype),
	 *oname &lt; 33 || *oname &gt; 126)
	) {
	lprintf2("Bad object 0x%lx(%lu),\n",
		 (ulong) ptr, (ulong) size);
	dprintf2(" ssize = %u, in chunk 0x%lx!\n",
		 otype-&gt;ssize, (ulong) cp);
	gs_abort(gcst-&gt;heap);
    }
}

#else /* !DEBUG */

void
ialloc_validate_spaces(const gs_dual_memory_t * dmem)
{
}

void
ialloc_validate_memory(const gs_ref_memory_t * mem, gc_state_t * gcst)
{
}

void
ialloc_validate_chunk(const chunk_t * cp, gc_state_t * gcst)
{
}

void
ialloc_validate_object(const obj_header_t * ptr, const chunk_t * cp,
		       gc_state_t * gcst)
{
}

#endif /* (!)DEBUG */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

