<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/imainarg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/imainarg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1996-2003 artofcode LLC.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: imainarg.c,v 1.34 2004/11/30 20:31:54 ghostgum Exp $ */
/* Command line parsing and dispatching */
#include "ctype_.h"
#include "memory_.h"
#include "string_.h"
#include &lt;stdlib.h&gt;	/* for qsort */

#include "ghost.h"
#include "gp.h"
#include "gsargs.h"
#include "gscdefs.h"
#include "gsmalloc.h"		/* for gs_malloc_limit */
#include "gsmdebug.h"
#include "gxdevice.h"
#include "gxdevmem.h"
#include "gsdevice.h"
#include "stream.h"
#include "ierrors.h"
#include "estack.h"
#include "ialloc.h"
#include "strimpl.h"		/* for sfilter.h */
#include "sfilter.h"		/* for iscan.h */
#include "ostack.h"		/* must precede iscan.h */
#include "iscan.h"
#include "iconf.h"
#include "imain.h"
#include "imainarg.h"
#include "iapi.h"
#include "iminst.h"
#include "iname.h"
#include "store.h"
#include "files.h"		/* requires stream.h */
#include "interp.h"
#include "iutil.h"
#include "ivmspace.h"
#include "vdtrace.h"

/* Import operator procedures */
extern int zflush(i_ctx_t *);
extern int zflushpage(i_ctx_t *);

#ifndef GS_LIB
#  define GS_LIB "GS_LIB"
#endif

#ifndef GS_OPTIONS
#  define GS_OPTIONS "GS_OPTIONS"
#endif

#ifndef GS_MAX_LIB_DIRS
#  define GS_MAX_LIB_DIRS 25
#endif

#ifndef GS_BUG_MAILBOX
#  define GS_BUG_MAILBOX "bug-gs@ghostscript.com"
#endif

#define MAX_BUFFERED_SIZE 1024

/* Note: sscanf incorrectly defines its first argument as char * */
/* rather than const char *.  This accounts for the ugly casts below. */

/* Redefine puts to use outprintf, */
/* so it will work even without stdio. */
#undef puts
#define puts(mem, str) outprintf(mem, "%s\n", str)

/* Forward references */
#define runInit 1
#define runFlush 2
#define runBuffer 4
private int swproc(gs_main_instance *, const char *, arg_list *);
private int argproc(gs_main_instance *, const char *);
private int run_buffered(gs_main_instance *, const char *);
private int esc_strlen(const char *);
private void esc_strcat(char *, const char *);
private int runarg(gs_main_instance *, const char *, const char *, const char *, int);
private int run_string(gs_main_instance *, const char *, int);
private int run_finish(gs_main_instance *, int, int, ref *);
private int try_stdout_redirect(gs_main_instance * minst, 
				const char *command, const char *filename);

/* Forward references for help printout */
private void print_help(gs_main_instance *);
private void print_revision(const gs_main_instance *);
private void print_version(const gs_main_instance *);
private void print_usage(const gs_main_instance *);
private void print_devices(const gs_main_instance *);
private void print_emulators(const gs_main_instance *);
private void print_paths(gs_main_instance *);
private void print_help_trailer(const gs_main_instance *);

/* ------ Main program ------ */

/* Process the command line with a given instance. */
private FILE *
gs_main_arg_fopen(const char *fname, void *vminst)
{
    gs_main_set_lib_paths((gs_main_instance *) vminst);
    return lib_fopen(&amp;((gs_main_instance *)vminst)-&gt;lib_path, 
		     ((gs_main_instance *)vminst)-&gt;heap, fname);
}
private void
set_debug_flags(const char *arg, char *flags)
{
    byte value = (*arg == '-' ? (++arg, 0) : 0xff);

    while (*arg)
	flags[*arg++ &amp; 127] = value;
}

int
gs_main_init_with_args(gs_main_instance * minst, int argc, char *argv[])
{
    const char *arg;
    arg_list args;
    int code;

    arg_init(&amp;args, (const char **)argv, argc,
	     gs_main_arg_fopen, (void *)minst);
    code = gs_main_init0(minst, 0, 0, 0, GS_MAX_LIB_DIRS);
    if (code &lt; 0)
	return code;
/* This first check is not needed on VMS since GS_LIB evaluates to the same
   value as that returned by gs_lib_default_path.  Also, since GS_LIB is
   defined as a searchlist logical and getenv only returns the first entry
   in the searchlist, it really doesn't make sense to search that particular
   directory twice.
*/
#ifndef __VMS
    {
	int len = 0;
	int code = gp_getenv(GS_LIB, (char *)0, &amp;len);

	if (code &lt; 0) {		/* key present, value doesn't fit */
	    char *path = (char *)gs_alloc_bytes(minst-&gt;heap, len, "GS_LIB");

	    gp_getenv(GS_LIB, path, &amp;len);	/* can't fail */
	    minst-&gt;lib_path.env = path;
	}
    }
#endif /* __VMS */
    minst-&gt;lib_path.final = gs_lib_default_path;
    code = gs_main_set_lib_paths(minst);
    if (code &lt; 0)
	return code;
    /* Prescan the command line for --help and --version. */
    {
	int i;
	bool helping = false;

	for (i = 1; i &lt; argc; ++i)
	    if (!strcmp(argv[i], "--")) {
		/* A PostScript program will be interpreting all the */
		/* remaining switches, so stop scanning. */
		helping = false;
		break;
	    } else if (!strcmp(argv[i], "--help")) {
		print_help(minst);
		helping = true;
	    } else if (!strcmp(argv[i], "--version")) {
		print_version(minst);
		puts(minst-&gt;heap, "");	/* \n */
		helping = true;
	    }
	if (helping)
	    return e_Info;
    }
    /* Execute files named in the command line, */
    /* processing options along the way. */
    /* Wait until the first file name (or the end */
    /* of the line) to finish initialization. */
    minst-&gt;run_start = true;

    {
	int len = 0;
	int code = gp_getenv(GS_OPTIONS, (char *)0, &amp;len);

	if (code &lt; 0) {		/* key present, value doesn't fit */
	    char *opts =
	    (char *)gs_alloc_bytes(minst-&gt;heap, len, "GS_OPTIONS");

	    gp_getenv(GS_OPTIONS, opts, &amp;len);	/* can't fail */
	    if (arg_push_memory_string(&amp;args, opts, minst-&gt;heap))
		return e_Fatal;
	}
    }
    while ((arg = arg_next(&amp;args, &amp;code)) != 0) {
	switch (*arg) {
	    case '-':
		code = swproc(minst, arg, &amp;args);
		if (code &lt; 0)
		    return code;
		if (code &gt; 0)
		    outprintf(minst-&gt;heap, "Unknown switch %s - ignoring\n", arg);
		break;
	    default:
		code = argproc(minst, arg);
		if (code &lt; 0)
		    return code;
	}
    }
    if (code &lt; 0)
	return code;


    code = gs_main_init2(minst);
    if (code &lt; 0)
	return code;

    if (!minst-&gt;run_start)
	return e_Quit;
    return code ;
}

/*
 * Run the 'start' procedure (after processing the command line).
 */
int
gs_main_run_start(gs_main_instance * minst)
{
    return run_string(minst, "systemdict /start get exec", runFlush);
}

/* Process switches.  Return 0 if processed, 1 for unknown switch, */
/* &lt;0 if error. */
private int
swproc(gs_main_instance * minst, const char *arg, arg_list * pal)
{
    char sw = arg[1];
    ref vtrue;
    int code = 0;
#undef initial_enter_name
#define initial_enter_name(nstr, pvalue)\
  i_initial_enter_name(minst-&gt;i_ctx_p, nstr, pvalue)

    make_true(&amp;vtrue);
    arg += 2;			/* skip - and letter */
    switch (sw) {
	default:
	    return 1;
	case 0:		/* read stdin as a file char-by-char */
	    /* This is a ******HACK****** for Ghostview. */
	    minst-&gt;heap-&gt;gs_lib_ctx-&gt;stdin_is_interactive = true;
	    goto run_stdin;
	case '_':	/* read stdin with normal buffering */
	    minst-&gt;heap-&gt;gs_lib_ctx-&gt;stdin_is_interactive = false;
run_stdin:
	    minst-&gt;run_start = false;	/* don't run 'start' */
	    /* Set NOPAUSE so showpage won't try to read from stdin. */
	    code = swproc(minst, "-dNOPAUSE", pal);
	    if (code)
		return code;
	    code = gs_main_init2(minst);	/* Finish initialization */
	    if (code &lt; 0)
		return code;

	    code = run_string(minst, ".runstdin", runFlush);
	    if (code &lt; 0)
		return code;
	    break;
	case '-':		/* run with command line args */
	case '+':
	    pal-&gt;expand_ats = false;
	case '@':		/* ditto with @-expansion */
	    {
		const char *psarg = arg_next(pal, &amp;code);

		if (code &lt; 0)
		    return e_Fatal;
		if (psarg == 0) {
		    outprintf(minst-&gt;heap, "Usage: gs ... -%c file.ps arg1 ... argn\n", sw);
		    arg_finit(pal);
		    return e_Fatal;
		}
		psarg = arg_copy(psarg, minst-&gt;heap);
		if (psarg == NULL)
		    return e_Fatal;
		code = gs_main_init2(minst);
		if (code &lt; 0)
		    return code;
		code = run_string(minst, "userdict/ARGUMENTS[", 0);
		if (code &lt; 0)
		    return code;
		while ((arg = arg_next(pal, &amp;code)) != 0) {
		    char *fname = arg_copy(arg, minst-&gt;heap);
		    if (fname == NULL)
			return e_Fatal;
		    code = runarg(minst, "", fname, "", runInit);
		    if (code &lt; 0)
			return code;
		}
		if (code &lt; 0)
		    return e_Fatal;
		runarg(minst, "]put", psarg, ".runfile", runInit | runFlush);
		return e_Quit;
	    }
	case 'A':		/* trace allocator */
	    switch (*arg) {
		case 0:
		    gs_alloc_debug = 1;
		    break;
		case '-':
		    gs_alloc_debug = 0;
		    break;
		default:
		    puts(minst-&gt;heap, "-A may only be followed by -");
		    return e_Fatal;
	    }
	    break;
	case 'B':		/* set run_string buffer size */
	    if (*arg == '-')
		minst-&gt;run_buffer_size = 0;
	    else {
		uint bsize;

		if (sscanf((const char *)arg, "%u", &amp;bsize) != 1 ||
		    bsize &lt;= 0 || bsize &gt; MAX_BUFFERED_SIZE
		    ) {
		    outprintf(minst-&gt;heap, 
			      "-B must be followed by - or size between 1 and %u\n", 
			      MAX_BUFFERED_SIZE);
		    return e_Fatal;
		}
		minst-&gt;run_buffer_size = bsize;
	    }
	    break;
	case 'c':		/* code follows */
	    {
		bool ats = pal-&gt;expand_ats;

		code = gs_main_init2(minst);
		if (code &lt; 0)
		    return code;
		pal-&gt;expand_ats = false;
		while ((arg = arg_next(pal, &amp;code)) != 0) {
		    char *sarg;

		    if (arg[0] == '@' ||
			(arg[0] == '-' &amp;&amp; !isdigit(arg[1]))
			)
			break;
		    sarg = arg_copy(arg, minst-&gt;heap);
		    if (sarg == NULL)
			return e_Fatal;
		    code = runarg(minst, "", sarg, ".runstring", 0);
		    if (code &lt; 0)
			return code;
		}
		if (code &lt; 0)
		    return e_Fatal;
		if (arg != 0) {
		    char *p = arg_copy(arg, minst-&gt;heap);
		    if (p == NULL)
			return e_Fatal;
		    arg_push_string(pal, p);
		}
		pal-&gt;expand_ats = ats;
		break;
	    }
	case 'E':		/* log errors */
	    switch (*arg) {
		case 0:
		    gs_log_errors = 1;
		    break;
		case '-':
		    gs_log_errors = 0;
		    break;
		default:
		    puts(minst-&gt;heap, "-E may only be followed by -");
		    return e_Fatal;
	    }
	    break;
	case 'f':		/* run file of arbitrary name */
	    if (*arg != 0) {
		code = argproc(minst, arg);
		if (code &lt; 0)
		    return code;
	    }
	    break;
	case 'F':		/* run file with buffer_size = 1 */
	    if (!*arg) {
		puts(minst-&gt;heap, "-F requires a file name");
		return e_Fatal;
	    } {
		uint bsize = minst-&gt;run_buffer_size;

		minst-&gt;run_buffer_size = 1;
		code = argproc(minst, arg);
		minst-&gt;run_buffer_size = bsize;
		if (code &lt; 0)
		    return code;
	    }
	    break;
	case 'g':		/* define device geometry */
	    {
		long width, height;
		ref value;

		if ((code = gs_main_init1(minst)) &lt; 0)
		    return code;
		if (sscanf((const char *)arg, "%ldx%ld", &amp;width, &amp;height) != 2) {
		    puts(minst-&gt;heap, "-g must be followed by &lt;width&gt;x&lt;height&gt;");
		    return e_Fatal;
		}
		make_int(&amp;value, width);
		initial_enter_name("DEVICEWIDTH", &amp;value);
		make_int(&amp;value, height);
		initial_enter_name("DEVICEHEIGHT", &amp;value);
		initial_enter_name("FIXEDMEDIA", &amp;vtrue);
		break;
	    }
	case 'h':		/* print help */
	case '?':		/* ditto */
	    print_help(minst);
	    return e_Info;	/* show usage info on exit */
	case 'I':		/* specify search path */
	    {
		char *path = arg_copy(arg, minst-&gt;heap);
		if (path == NULL)
		    return e_Fatal;
		gs_main_add_lib_path(minst, path);
	    }
	    break;
	case 'K':		/* set malloc limit */
	    {
		long msize = 0;
		gs_malloc_memory_t *rawheap = gs_malloc_wrapped_contents(minst-&gt;heap);

		sscanf((const char *)arg, "%ld", &amp;msize);
		if (msize &lt;= 0 || msize &gt; max_long &gt;&gt; 10) {
		    outprintf(minst-&gt;heap, "-K&lt;numK&gt; must have 1 &lt;= numK &lt;= %ld\n",
			      max_long &gt;&gt; 10);
		    return e_Fatal;
		}
	        rawheap-&gt;limit = msize &lt;&lt; 10;
	    }
	    break;
	case 'M':		/* set memory allocation increment */
	    {
		unsigned msize = 0;

		sscanf((const char *)arg, "%u", &amp;msize);
#if arch_ints_are_short
		if (msize &lt;= 0 || msize &gt;= 64) {
		    puts(minst-&gt;heap, "-M must be between 1 and 63");
		    return e_Fatal;
		}
#endif
		minst-&gt;memory_chunk_size = msize &lt;&lt; 10;
	    }
	    break;
	case 'N':		/* set size of name table */
	    {
		unsigned nsize = 0;

		sscanf((const char *)arg, "%d", &amp;nsize);
#if arch_ints_are_short
		if (nsize &lt; 2 || nsize &gt; 64) {
		    puts(minst-&gt;heap, "-N must be between 2 and 64");
		    return e_Fatal;
		}
#endif
		minst-&gt;name_table_size = (ulong) nsize &lt;&lt; 10;
	    }
	    break;
	case 'P':		/* choose whether search '.' first */
	    if (!strcmp(arg, ""))
		minst-&gt;search_here_first = true;
	    else if (!strcmp(arg, "-"))
		minst-&gt;search_here_first = false;
	    else {
		puts(minst-&gt;heap, "Only -P or -P- is allowed.");
		return e_Fatal;
	    }
	    break;
	case 'q':		/* quiet startup */
	    if ((code = gs_main_init1(minst)) &lt; 0)
		return code;
	    initial_enter_name("QUIET", &amp;vtrue);
	    break;
	case 'r':		/* define device resolution */
	    {
		float xres, yres;
		ref value;

		if ((code = gs_main_init1(minst)) &lt; 0)
		    return code;
		switch (sscanf((const char *)arg, "%fx%f", &amp;xres, &amp;yres)) {
		    default:
			puts(minst-&gt;heap, "-r must be followed by &lt;res&gt; or &lt;xres&gt;x&lt;yres&gt;");
			return e_Fatal;
		    case 1:	/* -r&lt;res&gt; */
			yres = xres;
		    case 2:	/* -r&lt;xres&gt;x&lt;yres&gt; */
			make_real(&amp;value, xres);
			initial_enter_name("DEVICEXRESOLUTION", &amp;value);
			make_real(&amp;value, yres);
			initial_enter_name("DEVICEYRESOLUTION", &amp;value);
			initial_enter_name("FIXEDRESOLUTION", &amp;vtrue);
		}
		break;
	    }
	case 'D':		/* define name */
	case 'd':
	case 'S':		/* define name as string */
	case 's':
	    {
		char *adef = arg_copy(arg, minst-&gt;heap);
		char *eqp;
		bool isd = (sw == 'D' || sw == 'd');
		ref value;

		if (adef == NULL)
		    return e_Fatal;
		eqp = strchr(adef, '=');

		if (eqp == NULL)
		    eqp = strchr(adef, '#');
		/* Initialize the object memory, scanner, and */
		/* name table now if needed. */
		if ((code = gs_main_init1(minst)) &lt; 0)
		    return code;
		if (eqp == adef) {
		    puts(minst-&gt;heap, "Usage: -dname, -dname=token, -sname=string");
		    return e_Fatal;
		}
		if (eqp == NULL) {
		    if (isd)
			make_true(&amp;value);
		    else
			make_empty_string(&amp;value, a_readonly);
		} else {
		    int code;
		    i_ctx_t *i_ctx_p = minst-&gt;i_ctx_p;
		    uint space = icurrent_space;

		    *eqp++ = 0;
		    ialloc_set_space(idmemory, avm_system);
		    if (isd) {
			stream astream;
			scanner_state state;

			s_init(&amp;astream, NULL);
			sread_string(&amp;astream,
				     (const byte *)eqp, strlen(eqp));
			scanner_state_init(&amp;state, false);
			code = scan_token(minst-&gt;i_ctx_p, &amp;astream, &amp;value,
					  &amp;state);
			if (code) {
			    puts(minst-&gt;heap, "-dname= must be followed by a valid token");
			    return e_Fatal;
			}
			if (r_has_type_attrs(&amp;value, t_name,
					     a_executable)) {
			    ref nsref;

			    name_string_ref(minst-&gt;heap, &amp;value, &amp;nsref);
#define string_is(nsref, str, len)\
  (r_size(&amp;(nsref)) == (len) &amp;&amp;\
   !strncmp((const char *)(nsref).value.const_bytes, str, (len)))
			    if (string_is(nsref, "null", 4))
				make_null(&amp;value);
			    else if (string_is(nsref, "true", 4))
				make_true(&amp;value);
			    else if (string_is(nsref, "false", 5))
				make_false(&amp;value);
			    else {
				puts(minst-&gt;heap, 
				     "-dvar=name requires name=null, true, or false");
				return e_Fatal;
			    }
#undef name_is_string
			}
		    } else {
			int len = strlen(eqp);
			char *str =
			(char *)gs_alloc_bytes(minst-&gt;heap,
					       (uint) len, "-s");

			if (str == 0) {
			    lprintf("Out of memory!\n");
			    return e_Fatal;
			}
			memcpy(str, eqp, len);
			make_const_string(&amp;value,
					  a_readonly | avm_foreign,
					  len, (const byte *)str);
			if ((code = try_stdout_redirect(minst, adef, eqp)) &lt; 0)
			    return code;
		    }
		    ialloc_set_space(idmemory, space);
		}
		/* Enter the name in systemdict. */
		initial_enter_name(adef, &amp;value);
		break;
	    }
	case 'T':
            set_debug_flags(arg, vd_flags);
	    break;
	case 'u':		/* undefine name */
	    if (!*arg) {
		puts(minst-&gt;heap, "-u requires a name to undefine.");
		return e_Fatal;
	    }
	    if ((code = gs_main_init1(minst)) &lt; 0)
		return code;
	    i_initial_remove_name(minst-&gt;i_ctx_p, arg);
	    break;
	case 'v':		/* print revision */
	    print_revision(minst);
	    return e_Info;
/*#ifdef DEBUG */
	    /*
	     * Here we provide a place for inserting debugging code that can be
	     * run in place of the normal interpreter code.
	     */
	case 'X':
	    code = gs_main_init2(minst);
	    if (code &lt; 0)
		return code;
	    {
		int xec;	/* exit_code */
		ref xeo;	/* error_object */

#define start_x()\
  gs_main_run_string_begin(minst, 1, &amp;xec, &amp;xeo)
#define run_x(str)\
  gs_main_run_string_continue(minst, str, strlen(str), 1, &amp;xec, &amp;xeo)
#define stop_x()\
  gs_main_run_string_end(minst, 1, &amp;xec, &amp;xeo)
		start_x();
		run_x("\216\003abc");
		run_x("== flush\n");
		stop_x();
	    }
	    return e_Quit;
/*#endif */
	case 'Z':
            set_debug_flags(arg, gs_debug);
	    break;
    }
    return 0;
}

/* Define versions of strlen and strcat that encode strings in hex. */
/* This is so we can enter escaped characters regardless of whether */
/* the Level 1 convention of ignoring \s in strings-within-strings */
/* is being observed (sigh). */
private int
esc_strlen(const char *str)
{
    return strlen(str) * 2 + 2;
}
private void
esc_strcat(char *dest, const char *src)
{
    char *d = dest + strlen(dest);
    const char *p;
    static const char *const hex = "0123456789abcdef";

    *d++ = '&lt;';
    for (p = src; *p; p++) {
	byte c = (byte) * p;

	*d++ = hex[c &gt;&gt; 4];
	*d++ = hex[c &amp; 0xf];
    }
    *d++ = '&gt;';
    *d = 0;
}

/* Process file names */
private int
argproc(gs_main_instance * minst, const char *arg)
{
    int code = gs_main_init1(minst);		/* need i_ctx_p to proceed */
    char *filearg;

    if (code &lt; 0)
        return code;
    filearg = arg_copy(arg, minst-&gt;heap);
    if (filearg == NULL)
        return e_Fatal;
    if (minst-&gt;run_buffer_size) {
	/* Run file with run_string. */
	return run_buffered(minst, filearg);
    } else {
	/* Run file directly in the normal way. */
	return runarg(minst, "", filearg, ".runfile", runInit | runFlush);
    }
}
private int
run_buffered(gs_main_instance * minst, const char *arg)
{
    FILE *in = gp_fopen(arg, gp_fmode_rb);
    int exit_code;
    ref error_object;
    int code;

    if (in == 0) {
	outprintf(minst-&gt;heap, "Unable to open %s for reading", arg);
	return_error(e_invalidfileaccess);
    }
    code = gs_main_init2(minst);
    if (code &lt; 0)
	return code;
    code = gs_main_run_string_begin(minst, minst-&gt;user_errors,
				    &amp;exit_code, &amp;error_object);
    if (!code) {
	char buf[MAX_BUFFERED_SIZE];
	int count;

	code = e_NeedInput;
	while ((count = fread(buf, 1, minst-&gt;run_buffer_size, in)) &gt; 0) {
	    code = gs_main_run_string_continue(minst, buf, count,
					       minst-&gt;user_errors,
					       &amp;exit_code, &amp;error_object);
	    if (code != e_NeedInput)
		break;
	}
	if (code == e_NeedInput) {
	    code = gs_main_run_string_end(minst, minst-&gt;user_errors,
					  &amp;exit_code, &amp;error_object);
	}
    }
    fclose(in);
    zflush(minst-&gt;i_ctx_p);
    zflushpage(minst-&gt;i_ctx_p);
    return run_finish(minst, code, exit_code, &amp;error_object);
}
private int
runarg(gs_main_instance * minst, const char *pre, const char *arg,
       const char *post, int options)
{
    int len = strlen(pre) + esc_strlen(arg) + strlen(post) + 1;
    int code;
    char *line;

    if (options &amp; runInit) {
	code = gs_main_init2(minst);	/* Finish initialization */

	if (code &lt; 0)
	    return code;
    }
    line = (char *)gs_alloc_bytes(minst-&gt;heap, len, "argproc");
    if (line == 0) {
	lprintf("Out of memory!\n");
	return_error(e_VMerror);
    }
    strcpy(line, pre);
    esc_strcat(line, arg);
    strcat(line, post);
    minst-&gt;i_ctx_p-&gt;starting_arg_file = true;
    code = run_string(minst, line, options);
    minst-&gt;i_ctx_p-&gt;starting_arg_file = false;
    return code;
}
private int
run_string(gs_main_instance * minst, const char *str, int options)
{
    int exit_code;
    ref error_object;
    int code = gs_main_run_string(minst, str, minst-&gt;user_errors,
				  &amp;exit_code, &amp;error_object);

    if ((options &amp; runFlush) || code != 0) {
	zflush(minst-&gt;i_ctx_p);		/* flush stdout */
	zflushpage(minst-&gt;i_ctx_p);	/* force display update */
    }
    return run_finish(minst, code, exit_code, &amp;error_object);
}
private int
run_finish(gs_main_instance *minst, int code, int exit_code,
	   ref * perror_object)
{
    switch (code) {
	case e_Quit:
	case 0:
	    break;
	case e_Fatal:
	    eprintf1("Unrecoverable error, exit code %d\n", exit_code);
	    break;
	default:
	    gs_main_dump_stack(minst, code, perror_object);
    }
    return code;
}

/* Redirect stdout to a file:
 *  -sstdout=filename
 *  -sstdout=-
 *  -sstdout=%stdout
 *  -sstdout=%stderr
 * -sOutputFile=- is not affected.
 * File is closed at program exit (if not stdout/err)
 * or when -sstdout is used again.
 */
private int 
try_stdout_redirect(gs_main_instance * minst, 
    const char *command, const char *filename)
{
    if (strcmp(command, "stdout") == 0) {
	minst-&gt;heap-&gt;gs_lib_ctx-&gt;stdout_to_stderr = 0;
	minst-&gt;heap-&gt;gs_lib_ctx-&gt;stdout_is_redirected = 0;
	/* If stdout already being redirected and it is not stdout
	 * or stderr, close it
	 */
	if (minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout2 
	    &amp;&amp; (minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout2 != minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout)
	    &amp;&amp; (minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout2 != minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstderr)) {
	    fclose(minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout2);
	    minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout2 = (FILE *)NULL;
	}
	/* If stdout is being redirected, set minst-&gt;fstdout2 */
	if ( (filename != 0) &amp;&amp; strlen(filename) &amp;&amp;
	    strcmp(filename, "-") &amp;&amp; strcmp(filename, "%stdout") ) {
	    if (strcmp(filename, "%stderr") == 0) {
		minst-&gt;heap-&gt;gs_lib_ctx-&gt;stdout_to_stderr = 1;
	    }
	    else if ((minst-&gt;heap-&gt;gs_lib_ctx-&gt;fstdout2 = 
		      fopen(filename, "w")) == (FILE *)NULL)
		return_error(e_invalidfileaccess);
	    minst-&gt;heap-&gt;gs_lib_ctx-&gt;stdout_is_redirected = 1;
	}
	return 0;
    }
    return 1;
}

/* ---------------- Print information ---------------- */

/*
 * Help strings.  We have to break them up into parts, because
 * the Watcom compiler has a limit of 510 characters for a single token.
 * For PC displays, we want to limit the strings to 24 lines.
 */
private const char help_usage1[] = "\
Usage: gs [switches] [file1.ps file2.ps ...]\n\
Most frequently used switches: (you can use # in place of =)\n\
 -dNOPAUSE           no pause after page   | -q       `quiet', fewer messages\n\
 -g&lt;width&gt;x&lt;height&gt;  page size in pixels   | -r&lt;res&gt;  pixels/inch resolution\n";
private const char help_usage2[] = "\
 -sDEVICE=&lt;devname&gt;  select device         | -dBATCH  exit after last file\n\
 -sOutputFile=&lt;file&gt; select output file: - for stdout, |command for pipe,\n\
                                         embed %d or %ld for page #\n";
private const char help_trailer[] = "\
For more information, see %s.\n\
Report bugs to %s, using the form in Bug-form.htm.\n";
private const char help_devices[] = "Available devices:";
private const char help_default_device[] = "Default output device:";
private const char help_emulators[] = "Input formats:";
private const char help_paths[] = "Search path:";

/* Print the standard help message. */
private void
print_help(gs_main_instance * minst)
{
    print_revision(minst);
    print_usage(minst);
    print_emulators(minst);
    print_devices(minst);
    print_paths(minst);
    if (gs_init_string_sizeof &gt; 0) {
        outprintf(minst-&gt;heap, "Initialization files are compiled into the executable.\n");
    }
    print_help_trailer(minst);
}

/* Print the revision, revision date, and copyright. */
private void
print_revision(const gs_main_instance *minst)
{
    printf_program_ident(minst-&gt;heap, gs_product, gs_revision);
    outprintf(minst-&gt;heap, " (%d-%02d-%02d)\n%s\n",
	    (int)(gs_revisiondate / 10000),
	    (int)(gs_revisiondate / 100 % 100),
	    (int)(gs_revisiondate % 100),
	    gs_copyright);
}

/* Print the version number. */
private void
print_version(const gs_main_instance *minst)
{
    printf_program_ident(minst-&gt;heap, NULL, gs_revision);
}

/* Print usage information. */
private void
print_usage(const gs_main_instance *minst)
{
    outprintf(minst-&gt;heap, "%s", help_usage1);
    outprintf(minst-&gt;heap, "%s", help_usage2);
}

/* compare function for qsort */
private int
cmpstr(const void *v1, const void *v2)
{
    return strcmp( *(char * const *)v1, *(char * const *)v2 );
}

/* Print the list of available devices. */
private void
print_devices(const gs_main_instance *minst)
{
    outprintf(minst-&gt;heap, "%s", help_default_device);
    outprintf(minst-&gt;heap, " %s\n", gs_devicename(gs_getdevice(0)));
    outprintf(minst-&gt;heap, "%s", help_devices);
    {
	int i;
	int pos = 100;
	const gx_device *pdev;
	const char **names;
	size_t ndev = 0;

	for (i = 0; (pdev = gs_getdevice(i)) != 0; i++)
	    ;
	ndev = (size_t)i;
	names = (const char **)gs_alloc_bytes(minst-&gt;heap, ndev * sizeof(const char*), "print_devices");
	if (names == (const char **)NULL) { /* old-style unsorted device list */
	    for (i = 0; (pdev = gs_getdevice(i)) != 0; i++) {
		const char *dname = gs_devicename(pdev);
		int len = strlen(dname);

		if (pos + 1 + len &gt; 76)
		    outprintf(minst-&gt;heap, "\n  "), pos = 2;
		outprintf(minst-&gt;heap, " %s", dname);
		pos += 1 + len;
	    }
	}
	else {				/* new-style sorted device list */
	    for (i = 0; (pdev = gs_getdevice(i)) != 0; i++)
		names[i] = gs_devicename(pdev);
	    qsort((void*)names, ndev, sizeof(const char*), cmpstr);
	    for (i = 0; i &lt; ndev; i++) {
		int len = strlen(names[i]);

		if (pos + 1 + len &gt; 76)
		    outprintf(minst-&gt;heap, "\n  "), pos = 2;
		outprintf(minst-&gt;heap, " %s", names[i]);
		pos += 1 + len;
	    }
	    gs_free(minst-&gt;heap, (char *)names, ndev * sizeof(const char*), 1, "print_devices");
	}
    }
    outprintf(minst-&gt;heap, "\n");
}

/* Print the list of language emulators. */
private void
print_emulators(const gs_main_instance *minst)
{
    outprintf(minst-&gt;heap, "%s", help_emulators);
    {
	const ref *pes;

	for (pes = gs_emulator_name_array;
	     pes-&gt;value.const_bytes != 0; pes++
	    )
	    /*
	     * Even though gs_emulator_name_array is declared and used as
	     * an array of string refs, each string is actually a
	     * (null terminated) C string.
	     */
	    outprintf(minst-&gt;heap, " %s", (const char *)pes-&gt;value.const_bytes);
    }
    outprintf(minst-&gt;heap, "\n");
}

/* Print the search paths. */
private void
print_paths(gs_main_instance * minst)
{
    outprintf(minst-&gt;heap, "%s", help_paths);
    gs_main_set_lib_paths(minst);
    {
	uint count = r_size(&amp;minst-&gt;lib_path.list);
	uint i;
	int pos = 100;
	char fsepr[3];

	fsepr[0] = ' ', fsepr[1] = gp_file_name_list_separator,
	    fsepr[2] = 0;
	for (i = 0; i &lt; count; ++i) {
	    const ref *prdir =
	    minst-&gt;lib_path.list.value.refs + i;
	    uint len = r_size(prdir);
	    const char *sepr = (i == count - 1 ? "" : fsepr);

	    if (1 + pos + strlen(sepr) + len &gt; 76)
		outprintf(minst-&gt;heap, "\n  "), pos = 2;
	    outprintf(minst-&gt;heap, " ");
	    /*
	     * This is really ugly, but it's necessary because some
	     * platforms rely on all console output being funneled through
	     * outprintf.  We wish we could just do:
	     fwrite(prdir-&gt;value.bytes, 1, len, minst-&gt;fstdout);
	     */
	    {
		const char *p = (const char *)prdir-&gt;value.bytes;
		uint j;

		for (j = len; j; j--)
		    outprintf(minst-&gt;heap, "%c", *p++);
	    }
	    outprintf(minst-&gt;heap, "%s", sepr);
	    pos += 1 + len + strlen(sepr);
	}
    }
    outprintf(minst-&gt;heap, "\n");
}

/* Print the help trailer. */
private void
print_help_trailer(const gs_main_instance *minst)
{
    char buffer[gp_file_name_sizeof];
    const char *use_htm = "Use.htm", *p = buffer;
    uint blen = sizeof(buffer);

    if (gp_file_name_combine(gs_doc_directory, strlen(gs_doc_directory), 
	    use_htm, strlen(use_htm), false, buffer, &amp;blen) != gp_combine_success)
	p = use_htm;
    outprintf(minst-&gt;heap, help_trailer, p, GS_BUG_MAILBOX);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

