<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/iparam.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/iparam.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1993, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: iparam.c,v 1.10 2004/08/04 19:36:13 stefan Exp $ */
/* Interpreter implementations of parameter dictionaries */
#include "memory_.h"
#include "string_.h"
#include "ghost.h"
#include "ierrors.h"
#include "oper.h"		/* for check_type */
#include "opcheck.h"
#include "ialloc.h"
#include "idict.h"
#include "imemory.h"		/* for iutil.h */
#include "iname.h"
#include "istack.h"
#include "iparam.h"
#include "iutil.h"		/* for num_params */
#include "ivmspace.h"
#include "store.h"

/* ================ Utilities ================ */

/* Convert a key to a ref. */
private int
ref_param_key(const iparam_list * plist, gs_param_name pkey, ref * pkref)
{
    if (plist-&gt;int_keys) {
	long key;

	if (sscanf(pkey, "%ld", &amp;key) != 1)
	    return_error(e_rangecheck);
	make_int(pkref, key);
	return 0;
    } else
        return name_ref(plist-&gt;memory, (const byte *)pkey, strlen(pkey), pkref, 0);
}

/* Fill in a gs_param_key_t from a name or int ref. */
private int
ref_to_key(const ref * pref, gs_param_key_t * key, iparam_list *plist)
{
    if (r_has_type(pref, t_name)) {
	ref nref;

	name_string_ref(plist-&gt;memory, pref, &amp;nref);
	key-&gt;data = nref.value.const_bytes;
	key-&gt;size = r_size(&amp;nref);
	key-&gt;persistent = false; /* names may be freed */
    } else if (r_has_type(pref, t_integer)) {
	char istr[sizeof(long) * 8 / 3 + 2];
	int len;
	byte *buf;

	sprintf(istr, "%ld", pref-&gt;value.intval);
	len = strlen(istr);
	/* GC will take care of freeing this: */
	buf = gs_alloc_string(plist-&gt;memory, len, "ref_to_key");
	if (!buf)
	    return_error(e_VMerror);
	key-&gt;data = buf;
	key-&gt;size = len;
	key-&gt;persistent = true;
    } else
	return_error(e_typecheck);
    return 0;
}

/* ================ Writing parameters to refs ================ */

/* Forward references */
private int array_new_indexed_plist_write(dict_param_list *plist,
					  ref *parray, const ref *pwanted,
					  gs_ref_memory_t *imem);

/* ---------------- Generic writing procedures ---------------- */

private param_proc_begin_xmit_collection(ref_param_begin_write_collection);
private param_proc_end_xmit_collection(ref_param_end_write_collection);
private param_proc_xmit_typed(ref_param_write_typed);
private param_proc_next_key(ref_param_get_next_key);
private param_proc_requested(ref_param_requested);
private const gs_param_list_procs ref_write_procs =
{
    ref_param_write_typed,
    ref_param_begin_write_collection,
    ref_param_end_write_collection,
    ref_param_get_next_key,
    NULL,			/* request */
    ref_param_requested
};
private int ref_array_param_requested(const iparam_list *, gs_param_name,
				      ref *, uint, client_name_t);
private int ref_param_write(iparam_list *, gs_param_name, const ref *);
private int ref_param_write_string_value(ref *, const gs_param_string *,
					 gs_ref_memory_t *);
private int ref_param_write_name_value(const gs_memory_t *mem, ref *, const gs_param_string *);
private int
ref_param_make_int(ref *pe, const void *pvalue, uint i, gs_ref_memory_t *imem)
{
    make_tav(pe, t_integer, imemory_new_mask(imem), intval,
	     ((const gs_param_int_array *)pvalue)-&gt;data[i]);
    return 0;
}
private int
ref_param_make_float(ref *pe, const void *pvalue, uint i, gs_ref_memory_t *imem)
{
    make_tav(pe, t_real, imemory_new_mask(imem), realval,
	     ((const gs_param_float_array *)pvalue)-&gt;data[i]);
    return 0;
}
private int
ref_param_make_string(ref *pe, const void *pvalue, uint i, gs_ref_memory_t *imem)
{
    return ref_param_write_string_value(pe,
			 &amp;((const gs_param_string_array *)pvalue)-&gt;data[i],
					imem);
}
private int
ref_param_make_name(ref * pe, const void *pvalue, uint i, gs_ref_memory_t *imem)
{
    return ref_param_write_name_value((const gs_memory_t *)imem, pe,
			 &amp;((const gs_param_string_array *)pvalue)-&gt;data[i]);
}
private int
ref_param_write_typed_array(gs_param_list * plist, gs_param_name pkey,
			    void *pvalue, uint count,
			    int (*make)(ref *, const void *, uint,
					gs_ref_memory_t *))
{
    iparam_list *const iplist = (iparam_list *) plist;
    ref value;
    uint i;
    ref *pe;
    int code;

    if ((code = ref_array_param_requested(iplist, pkey, &amp;value, count,
				       "ref_param_write_typed_array")) &lt;= 0)
	return code;
    for (i = 0, pe = value.value.refs; i &lt; count; ++i, ++pe)
	if ((code = (*make) (pe, pvalue, i, iplist-&gt;ref_memory)) &lt; 0)
	    return code;
    return ref_param_write(iplist, pkey, &amp;value);
}
private int
ref_param_begin_write_collection(gs_param_list * plist, gs_param_name pkey,
				 gs_param_dict * pvalue,
				 gs_param_collection_type_t coll_type)
{
    iparam_list *const iplist = (iparam_list *) plist;
    gs_ref_memory_t *imem = iplist-&gt;ref_memory;
    dict_param_list *dlist = (dict_param_list *)
	gs_alloc_bytes(plist-&gt;memory, size_of(dict_param_list),
		       "ref_param_begin_write_collection");
    int code;

    if (dlist == 0)
	return_error(e_VMerror);
    if (coll_type != gs_param_collection_array) {
	ref dref;

	code = dict_alloc(imem, pvalue-&gt;size, &amp;dref);
	if (code &gt;= 0) {
	    code = dict_param_list_write(dlist, &amp;dref, NULL, imem);
	    dlist-&gt;int_keys = coll_type == gs_param_collection_dict_int_keys;
	}
    } else {
	ref aref;

	code = gs_alloc_ref_array(imem, &amp;aref, a_all, pvalue-&gt;size,
				  "ref_param_begin_write_collection");
	if (code &gt;= 0)
	    code = array_new_indexed_plist_write(dlist, &amp;aref, NULL, imem);
    }
    if (code &lt; 0)
	gs_free_object(plist-&gt;memory, dlist, "ref_param_begin_write_collection");
    else
	pvalue-&gt;list = (gs_param_list *) dlist;
    return code;
}
private int
ref_param_end_write_collection(gs_param_list * plist, gs_param_name pkey,
			       gs_param_dict * pvalue)
{
    iparam_list *const iplist = (iparam_list *) plist;
    int code = ref_param_write(iplist, pkey,
			       &amp;((dict_param_list *) pvalue-&gt;list)-&gt;dict);

    gs_free_object(plist-&gt;memory, pvalue-&gt;list, "ref_param_end_write_collection");
    return code;
}
private int
ref_param_write_typed(gs_param_list * plist, gs_param_name pkey,
		      gs_param_typed_value * pvalue)
{
    iparam_list *const iplist = (iparam_list *) plist;
    ref value;
    int code = 0;

    switch (pvalue-&gt;type) {
	case gs_param_type_null:
	    make_null(&amp;value);
	    break;
	case gs_param_type_bool:
	    make_bool(&amp;value, pvalue-&gt;value.b);
	    break;
	case gs_param_type_int:
	    make_int(&amp;value, pvalue-&gt;value.i);
	    break;
	case gs_param_type_long:
	    make_int(&amp;value, pvalue-&gt;value.l);
	    break;
	case gs_param_type_float:
	    make_real(&amp;value, pvalue-&gt;value.f);
	    break;
	case gs_param_type_string:
	    if (!ref_param_requested(plist, pkey))
		return 0;
	    code = ref_param_write_string_value(&amp;value, &amp;pvalue-&gt;value.s,
						iplist-&gt;ref_memory);
	    break;
	case gs_param_type_name:
	    if (!ref_param_requested(plist, pkey))
		return 0;
	    code = ref_param_write_name_value(iplist-&gt;memory, &amp;value, &amp;pvalue-&gt;value.n);
	    break;
	case gs_param_type_int_array:
	    return ref_param_write_typed_array(plist, pkey, &amp;pvalue-&gt;value.ia,
					       pvalue-&gt;value.ia.size,
					       ref_param_make_int);
	case gs_param_type_float_array:
	    return ref_param_write_typed_array(plist, pkey, &amp;pvalue-&gt;value.fa,
					       pvalue-&gt;value.fa.size,
					       ref_param_make_float);
	case gs_param_type_string_array:
	    return ref_param_write_typed_array(plist, pkey, &amp;pvalue-&gt;value.sa,
					       pvalue-&gt;value.sa.size,
					       ref_param_make_string);
	case gs_param_type_name_array:
	    return ref_param_write_typed_array(plist, pkey, &amp;pvalue-&gt;value.na,
					       pvalue-&gt;value.na.size,
					       ref_param_make_name);
	case gs_param_type_dict:
	case gs_param_type_dict_int_keys:
	case gs_param_type_array:
	    return ref_param_begin_write_collection(plist, pkey,
						    &amp;pvalue-&gt;value.d,
	      (gs_param_collection_type_t)(pvalue-&gt;type - gs_param_type_dict));
	default:
	    return_error(e_typecheck);
    }
    if (code &lt; 0)
	return code;
    return ref_param_write(iplist, pkey, &amp;value);
}

/* Check whether a given parameter was requested. */
private int
ref_param_requested(const gs_param_list * plist, gs_param_name pkey)
{
    const iparam_list *const ciplist = (const iparam_list *)plist;
    ref kref;
    ref *ignore_value;

    if (!r_has_type(&amp;ciplist-&gt;u.w.wanted, t_dictionary))
	return -1;
    if (ref_param_key(ciplist, pkey, &amp;kref) &lt; 0)
	return -1;		/* catch it later */
    return (dict_find(&amp;ciplist-&gt;u.w.wanted, &amp;kref, &amp;ignore_value) &gt; 0);
}

/* Check whether an array parameter is wanted, and allocate it if so. */
/* Return &lt;0 on error, 0 if not wanted, 1 if wanted. */
private int
ref_array_param_requested(const iparam_list *iplist, gs_param_name pkey,
			  ref *pvalue, uint size, client_name_t cname)
{
    int code;

    if (!ref_param_requested((const gs_param_list *)iplist, pkey))
	return 0;
    code = gs_alloc_ref_array(iplist-&gt;ref_memory, pvalue, a_all, size, cname);
    return (code &lt; 0 ? code : 1);
}

/* ---------------- Internal routines ---------------- */

/* Prepare to write a string value. */
private int
ref_param_write_string_value(ref * pref, const gs_param_string * pvalue,
			     gs_ref_memory_t *imem)
{
    const byte *pdata = pvalue-&gt;data;
    uint n = pvalue-&gt;size;

    if (pvalue-&gt;persistent)
	make_const_string(pref, a_readonly | avm_foreign, n, pdata);
    else {
	byte *pstr = gs_alloc_string((gs_memory_t *)imem, n,
				     "ref_param_write_string");

	if (pstr == 0)
	    return_error(e_VMerror);
	memcpy(pstr, pdata, n);
	make_string(pref, a_readonly | imemory_space(imem), n, pstr);
    }
    return 0;
}

/* Prepare to write a name value. */
private int
ref_param_write_name_value(const gs_memory_t *mem, ref * pref, const gs_param_string * pvalue)
{
    return name_ref(mem, pvalue-&gt;data, pvalue-&gt;size, pref,
		    (pvalue-&gt;persistent ? 0 : 1));
}

/* Generic routine for writing a ref parameter. */
private int
ref_param_write(iparam_list * plist, gs_param_name pkey, const ref * pvalue)
{
    ref kref;
    int code;

    if (!ref_param_requested((gs_param_list *) plist, pkey))
	return 0;
    code = ref_param_key(plist, pkey, &amp;kref);
    if (code &lt; 0)
	return code;
    return (*plist-&gt;u.w.write) (plist, &amp;kref, pvalue);
}

/* ---------------- Implementations ---------------- */

/* Initialize for writing parameters. */
private void
ref_param_write_init(iparam_list * plist, const ref * pwanted,
		     gs_ref_memory_t *imem)
{
    gs_param_list_init((gs_param_list *)plist, &amp;ref_write_procs,
		       (gs_memory_t *)imem);
    plist-&gt;ref_memory = imem;
    if (pwanted == 0)
	make_null(&amp;plist-&gt;u.w.wanted);
    else
	plist-&gt;u.w.wanted = *pwanted;
    plist-&gt;results = 0;
    plist-&gt;int_keys = false;
}

/* Implementation for getting parameters to a stack. */
private int
stack_param_write(iparam_list * plist, const ref * pkey, const ref * pvalue)
{
    stack_param_list *const splist = (stack_param_list *) plist;
    ref_stack_t *pstack = splist-&gt;pstack;
    s_ptr p = pstack-&gt;p;

    if (pstack-&gt;top - p &lt; 2) {
	int code = ref_stack_push(pstack, 2);

	if (code &lt; 0)
	    return code;
	*ref_stack_index(pstack, 1) = *pkey;
	p = pstack-&gt;p;
    } else {
	pstack-&gt;p = p += 2;
	p[-1] = *pkey;
    }
    *p = *pvalue;
    splist-&gt;count++;
    return 0;
}

/* Implementation for enumerating parameters on a stack */
private int			/* ret 0 ok, 1 if EOF, or -ve err */
stack_param_enumerate(iparam_list * plist, gs_param_enumerator_t * penum,
		      gs_param_key_t * key, ref_type * type)
{
    int code;
    stack_param_list *const splist = (stack_param_list *) plist;
    long index = penum-&gt;intval;
    ref *stack_element;

    do {
	stack_element =
	    ref_stack_index(splist-&gt;pstack, index + 1 + splist-&gt;skip);
	if (!stack_element)
	    return 1;
    } while (index += 2, !r_has_type(stack_element, t_name));
    *type = r_type(stack_element);
    code = ref_to_key(stack_element, key, plist);
    penum-&gt;intval = index;
    return code;
}

int
stack_param_list_write(stack_param_list * plist, ref_stack_t * pstack,
		       const ref * pwanted, gs_ref_memory_t *imem)
{
    plist-&gt;u.w.write = stack_param_write;
    ref_param_write_init((iparam_list *) plist, pwanted, imem);
    plist-&gt;enumerate = stack_param_enumerate;
    plist-&gt;pstack = pstack;
    plist-&gt;skip = 0;
    plist-&gt;count = 0;
    return 0;
}

/* Implementation for getting parameters to a dictionary. */
private int
dict_param_write(iparam_list * plist, const ref * pkey, const ref * pvalue)
{
    int code =
	dict_put(&amp;((dict_param_list *) plist)-&gt;dict, pkey, pvalue, NULL);

    return min(code, 0);
}

/* Implementation for enumerating parameters in a dictionary */
private int			/* ret 0 ok, 1 if EOF, or -ve err */
dict_param_enumerate(iparam_list * plist, gs_param_enumerator_t * penum,
		     gs_param_key_t * key, ref_type * type)
{
    ref elt[2];
    int code;
    dict_param_list *const pdlist = (dict_param_list *) plist;
    int index =
    (penum-&gt;intval != 0 ? penum-&gt;intval : dict_first(&amp;pdlist-&gt;dict));

    index = dict_next(&amp;pdlist-&gt;dict, index, elt);
    if (index &lt; 0)
	return 1;
    *type = r_type(&amp;elt[1]);
    code = ref_to_key(&amp;elt[0], key, plist);
    penum-&gt;intval = index;
    return code;
}

int
dict_param_list_write(dict_param_list *plist, ref *pdict, const ref *pwanted,
		      gs_ref_memory_t *imem)
{
    check_dict_write(*pdict);
    plist-&gt;u.w.write = dict_param_write;
    plist-&gt;enumerate = dict_param_enumerate;
    ref_param_write_init((iparam_list *) plist, pwanted, imem);
    plist-&gt;dict = *pdict;
    return 0;
}

/* Implementation for getting parameters to an indexed array. */
/* Note that this is now internal, since it only handles "new" arrays. */
private int
array_new_indexed_param_write(iparam_list * iplist, const ref * pkey,
			  const ref * pvalue)
{
    const ref *const arr = &amp;((dict_param_list *)iplist)-&gt;dict;
    ref *eltp;

    if (!r_has_type(pkey, t_integer))
	return_error(e_typecheck);
    check_int_ltu(*pkey, r_size(arr));
    store_check_dest(arr, pvalue);
    eltp = arr-&gt;value.refs + pkey-&gt;value.intval;
    /* ref_assign_new(eltp, pvalue); */
    ref_assign(eltp, pvalue);
    r_set_attrs(eltp, imemory_new_mask(iplist-&gt;ref_memory));
    return 0;
}
private int
array_new_indexed_plist_write(dict_param_list * plist, ref * parray,
			      const ref * pwanted, gs_ref_memory_t *imem)
{
    check_array(*parray);
    check_write(*parray);
    plist-&gt;u.w.write = array_new_indexed_param_write;
    ref_param_write_init((iparam_list *) plist, pwanted, imem);
    plist-&gt;dict = *parray;
    plist-&gt;int_keys = true;
    return 0;
}

/* ================ Reading refs to parameters ================ */

/* ---------------- Generic reading procedures ---------------- */

private param_proc_begin_xmit_collection(ref_param_begin_read_collection);
private param_proc_end_xmit_collection(ref_param_end_read_collection);
private param_proc_xmit_typed(ref_param_read_typed);

/*private param_proc_next_key(ref_param_get_next_key); already dec'ld above */
private param_proc_get_policy(ref_param_read_get_policy);
private param_proc_signal_error(ref_param_read_signal_error);
private param_proc_commit(ref_param_read_commit);
private const gs_param_list_procs ref_read_procs =
{
    ref_param_read_typed,
    ref_param_begin_read_collection,
    ref_param_end_read_collection,
    ref_param_get_next_key,
    NULL,			/* request */
    NULL,			/* requested */
    ref_param_read_get_policy,
    ref_param_read_signal_error,
    ref_param_read_commit
};
private int ref_param_read(iparam_list *, gs_param_name,
			   iparam_loc *, int);
private int ref_param_read_string_value(const gs_memory_t *mem,
					const iparam_loc *,
					gs_param_string *);
private int ref_param_read_array(iparam_list *, gs_param_name,
				 iparam_loc *);

#define iparam_note_error(loc, code)\
  gs_note_error(*(loc).presult = code)
#define iparam_check_type(loc, typ)\
  if ( !r_has_type((loc).pvalue, typ) )\
    return iparam_note_error(loc, e_typecheck)
#define iparam_check_read(loc)\
  if ( !r_has_attr((loc).pvalue, a_read) )\
    return iparam_note_error(loc, e_invalidaccess)

private int
ref_param_read_int_array(gs_param_list * plist, gs_param_name pkey,
			 gs_param_int_array * pvalue)
{
    iparam_list *const iplist = (iparam_list *) plist;
    iparam_loc loc;
    int code = ref_param_read_array(iplist, pkey, &amp;loc);
    int *piv;
    uint size;
    long i;

    if (code != 0)
	return code;
    size = r_size(loc.pvalue);
    piv = (int *)gs_alloc_byte_array(plist-&gt;memory, size, sizeof(int),
				     "ref_param_read_int_array");

    if (piv == 0)
	return_error(e_VMerror);
    for (i = 0; i &lt; size; i++) {
	ref elt;

	array_get(plist-&gt;memory, loc.pvalue, i, &amp;elt);
	if (!r_has_type(&amp;elt, t_integer)) {
	    code = gs_note_error(e_typecheck);
	    break;
	}
#if arch_sizeof_int &lt; arch_sizeof_long
	if (elt.value.intval != (int)elt.value.intval) {
	    code = gs_note_error(e_rangecheck);
	    break;
	}
#endif
	piv[i] = (int)elt.value.intval;
    }
    if (code &lt; 0) {
	gs_free_object(plist-&gt;memory, piv, "ref_param_read_int_array");
	return (*loc.presult = code);
    }
    pvalue-&gt;data = piv;
    pvalue-&gt;size = size;
    pvalue-&gt;persistent = true;
    return 0;
}
private int
ref_param_read_float_array(gs_param_list * plist, gs_param_name pkey,
			   gs_param_float_array * pvalue)
{
    iparam_list *const iplist = (iparam_list *) plist;
    iparam_loc loc;
    ref aref, elt;
    int code = ref_param_read_array(iplist, pkey, &amp;loc);
    float *pfv;
    uint size;
    long i;

    if (code != 0)
	return code;
    size = r_size(loc.pvalue);
    pfv = (float *)gs_alloc_byte_array(plist-&gt;memory, size, sizeof(float),
				       "ref_param_read_float_array");

    if (pfv == 0)
	return_error(e_VMerror);
    aref = *loc.pvalue;
    loc.pvalue = &amp;elt;
    for (i = 0; code &gt;= 0 &amp;&amp; i &lt; size; i++) {
        array_get(plist-&gt;memory, &amp;aref, i, &amp;elt);
	code = float_param(&amp;elt, pfv + i);
    }
    if (code &lt; 0) {
	gs_free_object(plist-&gt;memory, pfv, "ref_read_float_array_param");
	return (*loc.presult = code);
    }
    pvalue-&gt;data = pfv;
    pvalue-&gt;size = size;
    pvalue-&gt;persistent = true;
    return 0;
}
private int
ref_param_read_string_array(gs_param_list * plist, gs_param_name pkey,
			    gs_param_string_array * pvalue)
{
    iparam_list *const iplist = (iparam_list *) plist;
    iparam_loc loc;
    ref aref;
    int code = ref_param_read_array(iplist, pkey, &amp;loc);
    gs_param_string *psv;
    uint size;
    long i;

    if (code != 0)
	return code;
    size = r_size(loc.pvalue);
    psv = (gs_param_string *)
	gs_alloc_byte_array(plist-&gt;memory, size, sizeof(gs_param_string),
			    "ref_param_read_string_array");
    if (psv == 0)
	return_error(e_VMerror);
    aref = *loc.pvalue;
    if (r_has_type(&amp;aref, t_array)) {
	for (i = 0; code &gt;= 0 &amp;&amp; i &lt; size; i++) {
	    loc.pvalue = aref.value.refs + i;
	    code = ref_param_read_string_value(plist-&gt;memory, &amp;loc, psv + i);
	}
    } else {
	ref elt;

	loc.pvalue = &amp;elt;
	for (i = 0; code &gt;= 0 &amp;&amp; i &lt; size; i++) {
	    array_get(plist-&gt;memory, &amp;aref, i, &amp;elt);
	    code = ref_param_read_string_value(plist-&gt;memory, &amp;loc, psv + i);
	}
    }
    if (code &lt; 0) {
	gs_free_object(plist-&gt;memory, psv, "ref_param_read_string_array");
	return (*loc.presult = code);
    }
    pvalue-&gt;data = psv;
    pvalue-&gt;size = size;
    pvalue-&gt;persistent = true;
    return 0;
}
private int
ref_param_begin_read_collection(gs_param_list * plist, gs_param_name pkey,
				gs_param_dict * pvalue,
				gs_param_collection_type_t coll_type)
{
    iparam_list *const iplist = (iparam_list *) plist;
    iparam_loc loc;
    bool int_keys = coll_type != 0;
    int code = ref_param_read(iplist, pkey, &amp;loc, -1);
    dict_param_list *dlist;

    if (code != 0)
	return code;
    dlist = (dict_param_list *)
	gs_alloc_bytes(plist-&gt;memory, size_of(dict_param_list),
		       "ref_param_begin_read_collection");
    if (dlist == 0)
	return_error(e_VMerror);
    if (r_has_type(loc.pvalue, t_dictionary)) {
	code = dict_param_list_read(dlist, loc.pvalue, NULL, false,
				    iplist-&gt;ref_memory);
	dlist-&gt;int_keys = int_keys;
	if (code &gt;= 0)
	    pvalue-&gt;size = dict_length(loc.pvalue);
    } else if (int_keys &amp;&amp; r_is_array(loc.pvalue)) {
	code = array_indexed_param_list_read(dlist, loc.pvalue, NULL, false,
					     iplist-&gt;ref_memory);
	if (code &gt;= 0)
	    pvalue-&gt;size = r_size(loc.pvalue);
    } else
	code = gs_note_error(e_typecheck);
    if (code &lt; 0) {
	gs_free_object(plist-&gt;memory, dlist, "ref_param_begin_write_collection");
	return iparam_note_error(loc, code);
    }
    pvalue-&gt;list = (gs_param_list *) dlist;
    return 0;
}
private int
ref_param_end_read_collection(gs_param_list * plist, gs_param_name pkey,
			      gs_param_dict * pvalue)
{
    iparam_list_release((dict_param_list *) pvalue-&gt;list);
    gs_free_object(plist-&gt;memory, pvalue-&gt;list,
		   "ref_param_end_read_collection");
    return 0;
}
private int
ref_param_read_typed(gs_param_list * plist, gs_param_name pkey,
		     gs_param_typed_value * pvalue)
{
    iparam_list *const iplist = (iparam_list *) plist;
    iparam_loc loc;
    ref elt;
    int code = ref_param_read(iplist, pkey, &amp;loc, -1);

    if (code != 0)
	return code;
    switch (r_type(loc.pvalue)) {
	case t_array:
	case t_mixedarray:
	case t_shortarray:
	    iparam_check_read(loc);
	    if (r_size(loc.pvalue) &lt;= 0) {
		/* 0-length array; can't get type info */
		pvalue-&gt;type = gs_param_type_array;
		pvalue-&gt;value.d.list = 0;
		pvalue-&gt;value.d.size = 0;
		return 0;
	    }
	    /*
	     * We have to guess at the array type.  First we guess based
	     * on the type of the first element of the array.  If that
	     * fails, we try again with more general types.
	     */
	    array_get(plist-&gt;memory, loc.pvalue, 0, &amp;elt);
	    switch (r_type(&amp;elt)) {
		case t_integer:
		    pvalue-&gt;type = gs_param_type_int_array;
		    code = ref_param_read_int_array(plist, pkey,
						    &amp;pvalue-&gt;value.ia);
		    if (code != e_typecheck)
			return code;
		    /* This might be a float array.  Fall through. */
		    *loc.presult = 0;  /* reset error */
		case t_real:
		    pvalue-&gt;type = gs_param_type_float_array;
		    return ref_param_read_float_array(plist, pkey,
						      &amp;pvalue-&gt;value.fa);
		case t_string:
		    pvalue-&gt;type = gs_param_type_string_array;
		    return ref_param_read_string_array(plist, pkey,
						       &amp;pvalue-&gt;value.sa);
		case t_name:
		    pvalue-&gt;type = gs_param_type_name_array;
		    return ref_param_read_string_array(plist, pkey,
						       &amp;pvalue-&gt;value.na);
		default:
		    break;
	    }
	    return gs_note_error(e_typecheck);
	case t_boolean:
	    pvalue-&gt;type = gs_param_type_bool;
	    pvalue-&gt;value.b = loc.pvalue-&gt;value.boolval;
	    return 0;
	case t_dictionary:
	    code = ref_param_begin_read_collection(plist, pkey,
			    &amp;pvalue-&gt;value.d, gs_param_collection_dict_any);
	    if (code &lt; 0)
		return code;
	    pvalue-&gt;type = gs_param_type_dict;

	    /* fixup new dict's type &amp; int_keys field if contents have int keys */
	    {
		gs_param_enumerator_t enumr;
		gs_param_key_t key;
		ref_type keytype;

		param_init_enumerator(&amp;enumr);
		if (!(*((iparam_list *) plist)-&gt;enumerate)
		    ((iparam_list *) pvalue-&gt;value.d.list, &amp;enumr, &amp;key, &amp;keytype)
		    &amp;&amp; keytype == t_integer) {
		    ((dict_param_list *) pvalue-&gt;value.d.list)-&gt;int_keys = 1;
		    pvalue-&gt;type = gs_param_type_dict_int_keys;
		}
	    }
	    return 0;
	case t_integer:
	    pvalue-&gt;type = gs_param_type_long;
	    pvalue-&gt;value.l = loc.pvalue-&gt;value.intval;
	    return 0;
	case t_name:
	    pvalue-&gt;type = gs_param_type_name;
	    return ref_param_read_string_value(plist-&gt;memory, &amp;loc, &amp;pvalue-&gt;value.n);
	case t_null:
	    pvalue-&gt;type = gs_param_type_null;
	    return 0;
	case t_real:
	    pvalue-&gt;value.f = loc.pvalue-&gt;value.realval;
	    pvalue-&gt;type = gs_param_type_float;
	    return 0;
	case t_string:
	    pvalue-&gt;type = gs_param_type_string;
	    return ref_param_read_string_value(plist-&gt;memory, &amp;loc, &amp;pvalue-&gt;value.s);
	default:
	    break;
    }
    return gs_note_error(e_typecheck);
}

private int
ref_param_read_get_policy(gs_param_list * plist, gs_param_name pkey)
{
    iparam_list *const iplist = (iparam_list *) plist;
    ref *pvalue;

    if (!(r_has_type(&amp;iplist-&gt;u.r.policies, t_dictionary) &amp;&amp;
	  dict_find_string(&amp;iplist-&gt;u.r.policies, pkey, &amp;pvalue) &gt; 0 &amp;&amp;
	  r_has_type(pvalue, t_integer))
	)
	return gs_param_policy_ignore;
    return (int)pvalue-&gt;value.intval;
}
private int
ref_param_read_signal_error(gs_param_list * plist, gs_param_name pkey, int code)
{
    iparam_list *const iplist = (iparam_list *) plist;
    iparam_loc loc;

    ref_param_read(iplist, pkey, &amp;loc, -1);	/* can't fail */
    *loc.presult = code;
    switch (ref_param_read_get_policy(plist, pkey)) {
	case gs_param_policy_ignore:
	    return 0;
	case gs_param_policy_consult_user:
	    return_error(e_configurationerror);
	default:
	    return code;
    }
}
private int
ref_param_read_commit(gs_param_list * plist)
{
    iparam_list *const iplist = (iparam_list *) plist;
    int i;
    int ecode = 0;

    if (!iplist-&gt;u.r.require_all)
	return 0;
    /* Check to make sure that all parameters were actually read. */
    for (i = 0; i &lt; iplist-&gt;count; ++i)
	if (iplist-&gt;results[i] == 0)
	    iplist-&gt;results[i] = ecode = gs_note_error(e_undefined);
    return ecode;
}
private int
ref_param_get_next_key(gs_param_list * plist, gs_param_enumerator_t * penum,
		       gs_param_key_t * key)
{
    ref_type keytype;		/* result not needed here */
    iparam_list *const pilist = (iparam_list *) plist;

    return (*pilist-&gt;enumerate) (pilist, penum, key, &amp;keytype);
}

/* ---------------- Internal routines ---------------- */

/* Read a string value. */
private int
ref_param_read_string_value(const gs_memory_t *mem, const iparam_loc * ploc, gs_param_string * pvalue)
{
    const ref *pref = ploc-&gt;pvalue;

    switch (r_type(pref)) {
	case t_name: {
	    ref nref;

	    name_string_ref(mem, pref, &amp;nref);
	    pvalue-&gt;data = nref.value.const_bytes;
	    pvalue-&gt;size = r_size(&amp;nref);
	    pvalue-&gt;persistent = true;
	}
	    break;
	case t_string:
	    iparam_check_read(*ploc);
	    pvalue-&gt;data = pref-&gt;value.const_bytes;
	    pvalue-&gt;size = r_size(pref);
	    pvalue-&gt;persistent = false;
	    break;
	default:
	    return iparam_note_error(*ploc, e_typecheck);
    }
    return 0;
}

/* Read an array (or packed array) parameter. */
private int
ref_param_read_array(iparam_list * plist, gs_param_name pkey, iparam_loc * ploc)
{
    int code = ref_param_read(plist, pkey, ploc, -1);

    if (code != 0)
	return code;
    if (!r_is_array(ploc-&gt;pvalue))
	return iparam_note_error(*ploc, e_typecheck);
    iparam_check_read(*ploc);
    return 0;
}

/* Generic routine for reading a ref parameter. */
private int
ref_param_read(iparam_list * plist, gs_param_name pkey, iparam_loc * ploc,
	       int type)
{
    iparam_list *const iplist = (iparam_list *) plist;
    ref kref;
    int code = ref_param_key(plist, pkey, &amp;kref);

    if (code &lt; 0)
	return code;
    code = (*plist-&gt;u.r.read) (iplist, &amp;kref, ploc);
    if (code != 0)
	return code;
    if (type &gt;= 0)
	iparam_check_type(*ploc, type);
    return 0;
}

/* ---------------- Implementations ---------------- */

/* Implementation for putting parameters from an empty collection. */
private int
empty_param_read(iparam_list * plist, const ref * pkey, iparam_loc * ploc)
{
    return 1;
}

/* Initialize for reading parameters. */
private int
ref_param_read_init(iparam_list * plist, uint count, const ref * ppolicies,
		    bool require_all, gs_ref_memory_t *imem)
{
    gs_param_list_init((gs_param_list *)plist, &amp;ref_read_procs,
		       (gs_memory_t *)imem);
    plist-&gt;ref_memory = imem;
    if (ppolicies == 0)
	make_null(&amp;plist-&gt;u.r.policies);
    else
	plist-&gt;u.r.policies = *ppolicies;
    plist-&gt;u.r.require_all = require_all;
    plist-&gt;count = count;
    plist-&gt;results = (int *)
	gs_alloc_byte_array(plist-&gt;memory, count, sizeof(int),
			    "ref_param_read_init");

    if (plist-&gt;results == 0)
	return_error(e_VMerror);
    memset(plist-&gt;results, 0, count * sizeof(int));

    plist-&gt;int_keys = false;
    return 0;
}

/* Implementation for putting parameters from an indexed array. */
private int
array_indexed_param_read(iparam_list * plist, const ref * pkey, iparam_loc * ploc)
{
    ref *const arr = &amp;((dict_param_list *) plist)-&gt;dict;

    check_type(*pkey, t_integer);
    if (pkey-&gt;value.intval &lt; 0 || pkey-&gt;value.intval &gt;= r_size(arr))
	return 1;
    ploc-&gt;pvalue = arr-&gt;value.refs + pkey-&gt;value.intval;
    ploc-&gt;presult = &amp;plist-&gt;results[pkey-&gt;value.intval];
    *ploc-&gt;presult = 1;
    return 0;
}
int
array_indexed_param_list_read(dict_param_list * plist, const ref * parray,
			      const ref * ppolicies, bool require_all,
			      gs_ref_memory_t *ref_memory)
{
    iparam_list *const iplist = (iparam_list *) plist;
    int code;

    check_read_type(*parray, t_array);
    plist-&gt;u.r.read = array_indexed_param_read;
    plist-&gt;dict = *parray;
    code = ref_param_read_init(iplist, r_size(parray), ppolicies,
			       require_all, ref_memory);
    plist-&gt;int_keys = true;
    return code;
}

/* Implementation for putting parameters from an array. */
private int
array_param_read(iparam_list * plist, const ref * pkey, iparam_loc * ploc)
{
    ref *bot = ((array_param_list *) plist)-&gt;bot;
    ref *ptr = bot;
    ref *top = ((array_param_list *) plist)-&gt;top;

    for (; ptr &lt; top; ptr += 2) {
	if (r_has_type(ptr, t_name) &amp;&amp; name_eq(ptr, pkey)) {
	    ploc-&gt;pvalue = ptr + 1;
	    ploc-&gt;presult = &amp;plist-&gt;results[ptr - bot];
	    *ploc-&gt;presult = 1;
	    return 0;
	}
    }
    return 1;
}

/* Implementation for enumerating parameters in an array */
private int			/* ret 0 ok, 1 if EOF, or -ve err */
array_param_enumerate(iparam_list * plist, gs_param_enumerator_t * penum,
		      gs_param_key_t * key, ref_type * type)
{
    int index = penum-&gt;intval;
    ref *bot = ((array_param_list *) plist)-&gt;bot;
    ref *ptr = bot + index;
    ref *top = ((array_param_list *) plist)-&gt;top;

    for (; ptr &lt; top; ptr += 2) {
	index += 2;

	if (r_has_type(ptr, t_name)) {
	    int code = ref_to_key(ptr, key, plist);

	    *type = r_type(ptr);
	    penum-&gt;intval = index;
	    return code;
	}
    }
    return 1;
}

int
array_param_list_read(array_param_list * plist, ref * bot, uint count,
		      const ref * ppolicies, bool require_all,
		      gs_ref_memory_t *imem)
{
    iparam_list *const iplist = (iparam_list *) plist;

    if (count &amp; 1)
	return_error(e_rangecheck);
    plist-&gt;u.r.read = array_param_read;
    plist-&gt;enumerate = array_param_enumerate;
    plist-&gt;bot = bot;
    plist-&gt;top = bot + count;
    return ref_param_read_init(iplist, count, ppolicies, require_all, imem);
}

/* Implementation for putting parameters from a stack. */
private int
stack_param_read(iparam_list * plist, const ref * pkey, iparam_loc * ploc)
{
    stack_param_list *const splist = (stack_param_list *) plist;
    ref_stack_t *pstack = splist-&gt;pstack;

    /* This implementation is slow, but it probably doesn't matter. */
    uint index = splist-&gt;skip + 1;
    uint count = splist-&gt;count;

    for (; count; count--, index += 2) {
	const ref *p = ref_stack_index(pstack, index);

	if (r_has_type(p, t_name) &amp;&amp; name_eq(p, pkey)) {
	    ploc-&gt;pvalue = ref_stack_index(pstack, index - 1);
	    ploc-&gt;presult = &amp;plist-&gt;results[count - 1];
	    *ploc-&gt;presult = 1;
	    return 0;
	}
    }
    return 1;
}
int
stack_param_list_read(stack_param_list * plist, ref_stack_t * pstack,
		      uint skip, const ref * ppolicies, bool require_all,
		      gs_ref_memory_t *imem)
{
    iparam_list *const iplist = (iparam_list *) plist;
    uint count = ref_stack_counttomark(pstack);

    if (count == 0)
	return_error(e_unmatchedmark);
    count -= skip + 1;
    if (count &amp; 1)
	return_error(e_rangecheck);
    plist-&gt;u.r.read = stack_param_read;
    plist-&gt;enumerate = stack_param_enumerate;
    plist-&gt;pstack = pstack;
    plist-&gt;skip = skip;
    return ref_param_read_init(iplist, count &gt;&gt; 1, ppolicies, require_all, imem);
}

/* Implementation for putting parameters from a dictionary. */
private int
dict_param_read(iparam_list * plist, const ref * pkey, iparam_loc * ploc)
{
    ref const *spdict = &amp;((dict_param_list *) plist)-&gt;dict;
    int code = dict_find(spdict, pkey, &amp;ploc-&gt;pvalue);

    if (code != 1)
	return 1;
    ploc-&gt;presult =
	&amp;plist-&gt;results[dict_value_index(spdict, ploc-&gt;pvalue)];
    *ploc-&gt;presult = 1;
    return 0;
}
int
dict_param_list_read(dict_param_list * plist, const ref * pdict,
		     const ref * ppolicies, bool require_all,
		     gs_ref_memory_t *imem)
{
    iparam_list *const iplist = (iparam_list *) plist;
    uint count;

    if (pdict == 0) {
	plist-&gt;u.r.read = empty_param_read;
	count = 0;
    } else {
	check_dict_read(*pdict);
	plist-&gt;u.r.read = dict_param_read;
	plist-&gt;dict = *pdict;
	count = dict_max_index(pdict) + 1;
    }
    plist-&gt;enumerate = dict_param_enumerate;
    return ref_param_read_init(iplist, count, ppolicies, require_all, imem);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

