<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/istack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/istack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1992, 1995, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: istack.c,v 1.6 2003/09/03 03:22:59 giles Exp $ */
/* Manager for expandable stacks of refs */
#include "memory_.h"
#include "ghost.h"
#include "gsstruct.h"
#include "gsutil.h"
#include "ierrors.h"
#include "ialloc.h"
#include "istack.h"
#include "istkparm.h"
#include "istruct.h"		/* for RELOC_REF_VAR */
#include "iutil.h"
#include "ivmspace.h"		/* for local/global test */
#include "store.h"

/* Forward references */
private void init_block(ref_stack_t *pstack, const ref *pblock_array,
			uint used);
private int ref_stack_push_block(ref_stack_t *pstack, uint keep, uint add);

/* GC descriptors and procedures */
private_st_ref_stack_params();
private 
CLEAR_MARKS_PROC(ref_stack_clear_marks)
{
    ref_stack_t *const sptr = vptr;

    r_clear_attrs(&amp;sptr-&gt;current, l_mark);
}
private 
ENUM_PTRS_WITH(ref_stack_enum_ptrs, ref_stack_t *sptr) return 0;
case 0: ENUM_RETURN_REF(&amp;sptr-&gt;current);
case 1: return ENUM_OBJ(sptr-&gt;params);
ENUM_PTRS_END
private RELOC_PTRS_WITH(ref_stack_reloc_ptrs, ref_stack_t *sptr)
{
    /* Note that the relocation must be a multiple of sizeof(ref_packed) */
    /* * align_packed_per_ref, but it need not be a multiple of */
    /* sizeof(ref).  Therefore, we must do the adjustments using */
    /* ref_packed pointers rather than ref pointers. */
    ref_packed *bot = (ref_packed *) sptr-&gt;current.value.refs;
    long reloc;

    RELOC_REF_VAR(sptr-&gt;current);
    r_clear_attrs(&amp;sptr-&gt;current, l_mark);
    reloc = bot - (ref_packed *) sptr-&gt;current.value.refs;
#define RELOC_P(p)\
  sptr-&gt;p = (ref *)((ref_packed *)sptr-&gt;p - reloc);
    RELOC_P(p);
    RELOC_P(bot);
    RELOC_P(top);
#undef RELOC_P
    RELOC_OBJ_VAR(sptr-&gt;params);
} RELOC_PTRS_END
/* Structure type for a ref_stack. */
public_st_ref_stack();

/* Initialize a stack. */
int
ref_stack_init(ref_stack_t *pstack, const ref *pblock_array,
	       uint bot_guard, uint top_guard, const ref *pguard_value,
	       gs_ref_memory_t *mem, ref_stack_params_t *params)
{
    uint size = r_size(pblock_array);
    uint avail = size - (stack_block_refs + bot_guard + top_guard);
    ref_stack_block *pblock = (ref_stack_block *)pblock_array-&gt;value.refs;
    s_ptr body = (s_ptr)(pblock + 1);

    if (params == 0) {
	params = gs_alloc_struct((gs_memory_t *)mem, ref_stack_params_t,
				 &amp;st_ref_stack_params,
				 "ref_stack_alloc(stack.params)");
	if (params == 0)
	    return_error(-1);	/* avoid binding in any error codes */
    }

    pstack-&gt;bot = body + bot_guard;
    pstack-&gt;p = pstack-&gt;bot - 1;
    pstack-&gt;top = pstack-&gt;p + avail;
    pstack-&gt;current = *pblock_array;
    pstack-&gt;extension_size = 0;
    pstack-&gt;extension_used = 0;

    make_int(&amp;pstack-&gt;max_stack, avail);
    pstack-&gt;requested = 0;
    pstack-&gt;margin = 0;
    pstack-&gt;body_size = avail;

    pstack-&gt;params = params;
    pstack-&gt;memory = mem;

    params-&gt;bot_guard = bot_guard;
    params-&gt;top_guard = top_guard;
    params-&gt;block_size = size;
    params-&gt;data_size = avail;
    if (pguard_value != 0)
	params-&gt;guard_value = *pguard_value;
    else
	make_tav(&amp;params-&gt;guard_value, t__invalid, 0, intval, 0);
    params-&gt;underflow_error = -1;
    params-&gt;overflow_error = -1;
    params-&gt;allow_expansion = true;
    init_block(pstack, pblock_array, 0);
    refset_null_new(pstack-&gt;bot, avail, 0);
    make_empty_array(&amp;pblock-&gt;next, 0);
    return 0;
}

/* Set whether a stack is allowed to expand.  The initial value is true. */
void
ref_stack_allow_expansion(ref_stack_t *pstack, bool expand)
{
    pstack-&gt;params-&gt;allow_expansion = expand;
}

/* Set the error codes for under- and overflow.  The initial values are -1. */
void
ref_stack_set_error_codes(ref_stack_t *pstack, int underflow_error,
			  int overflow_error)
{
    pstack-&gt;params-&gt;underflow_error = underflow_error;
    pstack-&gt;params-&gt;overflow_error = overflow_error;
}

/* Set the maximum number of elements allowed on a stack. */
int
ref_stack_set_max_count(ref_stack_t *pstack, long nmax)
{
    uint nmin = ref_stack_count_inline(pstack);

    if (nmax &lt; nmin)
	nmax = nmin;
    if (nmax &gt; max_uint / sizeof(ref))
	nmax = max_uint / sizeof(ref);
    if (!pstack-&gt;params-&gt;allow_expansion) {
	uint ncur = pstack-&gt;body_size;

	if (nmax &gt; ncur)
	    nmax = ncur;
    }
    pstack-&gt;max_stack.value.intval = nmax;
    return 0;
}

/*
 * Set the margin between the limit and the top of the stack.
 * Note that this may require allocating a block.
 */
int
ref_stack_set_margin(ref_stack_t *pstack, uint margin)
{
    const ref_stack_params_t *params = pstack-&gt;params;
    uint data_size = params-&gt;data_size;

    if (margin &lt;= pstack-&gt;margin) {
	refset_null_new(pstack-&gt;top + 1, pstack-&gt;margin - margin, 0);
    } else {
	if (margin &gt; data_size &gt;&gt; 1)
	    return_error(e_rangecheck);
	if (pstack-&gt;top - pstack-&gt;p &lt; margin) {
	    uint used = pstack-&gt;p + 1 - pstack-&gt;bot;
	    uint keep = data_size - margin;
	    int code = ref_stack_push_block(pstack, keep, used - keep);

	    if (code &lt; 0)
		return code;
	}
    }
    pstack-&gt;margin = margin;
    pstack-&gt;body_size = data_size - margin;
    pstack-&gt;top = pstack-&gt;bot + pstack-&gt;body_size - 1;
    return 0;
}

/* Return the number of elements on a stack. */
uint
ref_stack_count(const ref_stack_t *pstack)
{
    return ref_stack_count_inline(pstack);
}

/*
 * Return a pointer to a given element from the stack, counting from
 * 0 as the top element.  If the index is out of range, return 0.
 */
ref *
ref_stack_index(const ref_stack_t *pstack, long idx)
{
    ref_stack_block *pblock;
    uint used = pstack-&gt;p + 1 - pstack-&gt;bot;

    if (idx &lt; 0)
	return NULL;
    if (idx &lt; used)		/* common case */
	return pstack-&gt;p - (uint) idx;
    pblock = (ref_stack_block *) pstack-&gt;current.value.refs;
    do {
	pblock = (ref_stack_block *) pblock-&gt;next.value.refs;
	if (pblock == 0)
	    return NULL;
	idx -= used;
	used = r_size(&amp;pblock-&gt;used);
    } while (idx &gt;= used);
    return pblock-&gt;used.value.refs + (used - 1 - (uint) idx);
}

/*
 * Count the number of elements down to and including the first mark.
 * If no mark is found, return 0.
 */
uint
ref_stack_counttomark(const ref_stack_t *pstack)
{
    uint scanned = 0;
    ref_stack_enum_t rsenum;

    ref_stack_enum_begin(&amp;rsenum, pstack);
    do {
	uint count = rsenum.size;
	const ref *p = rsenum.ptr + count - 1;

	for (; count; count--, p--)
	    if (r_has_type(p, t_mark))
		return scanned + (rsenum.size - count + 1);
	scanned += rsenum.size;
    } while (ref_stack_enum_next(&amp;rsenum));
    return 0;
}

/*
 * Do the store check for storing 'count' elements of a stack, starting
 * 'skip' elements below the top, into an array.  Return 0 or e_invalidaccess.
 */
int
ref_stack_store_check(const ref_stack_t *pstack, ref *parray, uint count,
		      uint skip)
{
    uint space = r_space(parray);

    if (space != avm_local) {
	uint left = count, pass = skip;
	ref_stack_enum_t rsenum;

	ref_stack_enum_begin(&amp;rsenum, pstack);
	do {
	    ref *ptr = rsenum.ptr;
	    uint size = rsenum.size;

	    if (size &lt;= pass)
		pass -= size;
	    else {
		int code;

		if (pass != 0)
		    size -= pass, pass = 0;
		ptr += size;
		if (size &gt; left)
		    size = left;
		left -= size;
		code = refs_check_space(ptr - size, size, space);
		if (code &lt; 0)
		    return code;
		if (left == 0)
		    break;
	    }
	} while (ref_stack_enum_next(&amp;rsenum));
    }
    return 0;
}

/*
 * Store the top 'count' elements of a stack, starting 'skip' elements below
 * the top, into an array, with or without store/undo checking.  age=-1 for
 * no check, 0 for old, 1 for new.  May return e_rangecheck or
 * e_invalidaccess.
 */
#undef idmemory			/****** NOTA BENE ******/
int
ref_stack_store(const ref_stack_t *pstack, ref *parray, uint count,
		uint skip, int age, bool check, gs_dual_memory_t *idmemory,
		client_name_t cname)
{
    uint left, pass;
    ref *to;
    ref_stack_enum_t rsenum;

    if (count &gt; ref_stack_count(pstack) || count &gt; r_size(parray))
	return_error(e_rangecheck);
    if (check) {
	int code = ref_stack_store_check(pstack, parray, count, skip);

	if (code &lt; 0)
	    return code;
    }
    to = parray-&gt;value.refs + count;
    left = count, pass = skip;
    ref_stack_enum_begin(&amp;rsenum, pstack);
    do {
	ref *from = rsenum.ptr;
	uint size = rsenum.size;

	if (size &lt;= pass)
	    pass -= size;
	else {
	    if (pass != 0)
		size -= pass, pass = 0;
	    from += size;
	    if (size &gt; left)
		size = left;
	    left -= size;
	    switch (age) {
	    case -1:		/* not an array */
		while (size--) {
		    from--, to--;
		    ref_assign(to, from);
		}
		break;
	    case 0:		/* old array */
		while (size--) {
		    from--, to--;
		    ref_assign_old(parray, to, from, cname);
		}
		break;
	    case 1:		/* new array */
		while (size--) {
		    from--, to--;
		    ref_assign_new(to, from);
		}
		break;
	    }
	    if (left == 0)
		break;
	}
    } while (ref_stack_enum_next(&amp;rsenum));
    r_set_size(parray, count);
    return 0;
}

/*
 * Pop the top N elements off a stack.
 * The number must not exceed the number of elements in use.
 */
void
ref_stack_pop(ref_stack_t *pstack, uint count)
{
    uint used;

    while ((used = pstack-&gt;p + 1 - pstack-&gt;bot) &lt; count) {
	count -= used;
	pstack-&gt;p = pstack-&gt;bot - 1;
	ref_stack_pop_block(pstack);
    }
    pstack-&gt;p -= count;
}

/* Pop the top block off a stack.  May return underflow_error. */
int
ref_stack_pop_block(ref_stack_t *pstack)
{
    s_ptr bot = pstack-&gt;bot;
    uint count = pstack-&gt;p + 1 - bot;
    ref_stack_block *pcur =
    (ref_stack_block *) pstack-&gt;current.value.refs;
    ref_stack_block *pnext =
    (ref_stack_block *) pcur-&gt;next.value.refs;
    uint used;
    ref *body;
    ref next;

    if (pnext == 0)
	return_error(pstack-&gt;params-&gt;underflow_error);
    used = r_size(&amp;pnext-&gt;used);
    body = (ref *) (pnext + 1) + pstack-&gt;params-&gt;bot_guard;
    next = pcur-&gt;next;
    /*
       * If the contents of the two blocks won't fit in a single block, we
       * move up the used part of the top block, and copy up as much of
       * the contents of the next block under it as will fit.  If the
       * contents of both blocks fit in a single block, we copy the used
       * part of the top block to the top of the next block, and free the
       * top block.
     */
    if (used + count &gt; pstack-&gt;body_size) {
	/*
	 * The contents of the two blocks won't fit into a single block.
	 * On the assumption that we're recovering from a local stack
	 * underflow and need to increase the number of contiguous
	 * elements available, move up the used part of the top block, and
	 * copy up as much of the contents of the next block under it as
	 * will fit.
	 */
	uint moved = pstack-&gt;body_size - count;
	uint left;

	if (moved == 0)
	    return_error(e_Fatal);
	memmove(bot + moved, bot, count * sizeof(ref));
	left = used - moved;
	memcpy(bot, body + left, moved * sizeof(ref));
	refset_null_new(body + left, moved, 0);
	r_dec_size(&amp;pnext-&gt;used, moved);
	pstack-&gt;p = pstack-&gt;top;
	pstack-&gt;extension_used -= moved;
    } else {
	/*
	   * The contents of the two blocks will fit into a single block.
	   * Copy the used part of the top block to the top of the next
	   * block, and free the top block.
	 */
	memcpy(body + used, bot, count * sizeof(ref));
	pstack-&gt;bot = bot = body;
	pstack-&gt;top = bot + pstack-&gt;body_size - 1;
	gs_free_ref_array(pstack-&gt;memory, &amp;pstack-&gt;current,
			  "ref_stack_pop_block");
	pstack-&gt;current = next;
	pstack-&gt;p = bot + (used + count - 1);
	pstack-&gt;extension_size -= pstack-&gt;body_size;
	pstack-&gt;extension_used -= used;
    }
    return 0;
}

/*
 * Extend a stack to recover from an overflow condition.
 * May return overflow_error or e_VMerror.
 */
int
ref_stack_extend(ref_stack_t *pstack, uint request)
{
    uint keep = (pstack-&gt;top - pstack-&gt;bot + 1) / 3;
    uint count = pstack-&gt;p - pstack-&gt;bot + 1;
    const ref_stack_params_t *params = pstack-&gt;params;

    if (request &gt; params-&gt;data_size)
	return_error(params-&gt;overflow_error);
    if (keep + request &gt; pstack-&gt;body_size)
	keep = pstack-&gt;body_size - request;
    if (keep &gt; count)
	keep = count;		/* required by ref_stack_push_block */
    return ref_stack_push_block(pstack, keep, request);
}

/*
 * Push N empty slots onto a stack.  These slots are not initialized:
 * the caller must immediately fill them.  May return overflow_error
 * (if max_stack would be exceeded, or the stack has no allocator)
 * or e_VMerror.
 */
int
ref_stack_push(ref_stack_t *pstack, uint count)
{
    /* Don't bother to pre-check for overflow: we must be able to */
    /* back out in the case of a VMerror anyway, and */
    /* ref_stack_push_block will make the check itself. */
    uint needed = count;
    uint added;

    for (; (added = pstack-&gt;top - pstack-&gt;p) &lt; needed; needed -= added) {
	int code;

	pstack-&gt;p = pstack-&gt;top;
	code = ref_stack_push_block(pstack,
				    (pstack-&gt;top - pstack-&gt;bot + 1) / 3,
				    added);
	if (code &lt; 0) {
	    /* Back out. */
	    ref_stack_pop(pstack, count - needed + added);
	    pstack-&gt;requested = count;
	    return code;
	}
    }
    pstack-&gt;p += needed;
    return 0;
}

/*
 * Push a block onto the stack, specifying how many elements of the current
 * top block should remain in the top block and also how many elements we
 * are trying to add.  Requires keep &lt;= count.  May return overflow_error or
 * e_VMerror.
 */
private int
ref_stack_push_block(ref_stack_t *pstack, uint keep, uint add)
{
    const ref_stack_params_t *params = pstack-&gt;params;
    uint count = pstack-&gt;p - pstack-&gt;bot + 1;
    uint move = count - keep;
    ref_stack_block *pcur = (ref_stack_block *) pstack-&gt;current.value.refs;
    ref next;
    ref_stack_block *pnext;
    ref *body;
    int code;

    if (keep &gt; count)
	return_error(e_Fatal);
    /* Check for overflowing the maximum size, */
    /* or expansion not allowed.  */
    if (pstack-&gt;extension_used + (pstack-&gt;top - pstack-&gt;bot) + add &gt;=
	pstack-&gt;max_stack.value.intval ||
	!params-&gt;allow_expansion
	)
	return_error(params-&gt;overflow_error);
    code = gs_alloc_ref_array(pstack-&gt;memory, &amp;next, 0,
			      params-&gt;block_size, "ref_stack_push_block");
    if (code &lt; 0)
	return code;
    pnext = (ref_stack_block *) next.value.refs;
    body = (ref *) (pnext + 1);
    /* Copy the top keep elements into the new block, */
    /* and make the new block the top block. */
    init_block(pstack, &amp;next, keep);
    body += params-&gt;bot_guard;
    memcpy(body, pstack-&gt;bot + move, keep * sizeof(ref));
    /* Clear the elements above the top of the new block. */
    refset_null_new(body + keep, params-&gt;data_size - keep, 0);
    /* Clear the elements above the top of the old block. */
    refset_null_new(pstack-&gt;bot + move, keep, 0);
    pnext-&gt;next = pstack-&gt;current;
    pcur-&gt;used.value.refs = pstack-&gt;bot;
    r_set_size(&amp;pcur-&gt;used, move);
    pstack-&gt;current = next;
    pstack-&gt;bot = body;
    pstack-&gt;top = pstack-&gt;bot + pstack-&gt;body_size - 1;
    pstack-&gt;p = pstack-&gt;bot + keep - 1;
    pstack-&gt;extension_size += pstack-&gt;body_size;
    pstack-&gt;extension_used += move;
    return 0;
}

/* Begin enumerating the blocks of a stack. */
void
ref_stack_enum_begin(ref_stack_enum_t *prse, const ref_stack_t *pstack)
{
    prse-&gt;block = (ref_stack_block *)pstack-&gt;current.value.refs;
    prse-&gt;ptr = pstack-&gt;bot;
    prse-&gt;size = pstack-&gt;p + 1 - pstack-&gt;bot;
}

bool
ref_stack_enum_next(ref_stack_enum_t *prse)
{
    ref_stack_block *block =
	prse-&gt;block = (ref_stack_block *)prse-&gt;block-&gt;next.value.refs;

    if (block == 0)
	return false;
    prse-&gt;ptr = block-&gt;used.value.refs;
    prse-&gt;size = r_size(&amp;block-&gt;used);
    return true;
}

/* Clean up a stack for garbage collection. */
void
ref_stack_cleanup(ref_stack_t *pstack)
{
    ref_stack_block *pblock =
	(ref_stack_block *) pstack-&gt;current.value.refs;

    refset_null_new(pstack-&gt;p + 1, pstack-&gt;top - pstack-&gt;p, 0);
    pblock-&gt;used = pstack-&gt;current;	/* set attrs */
    pblock-&gt;used.value.refs = pstack-&gt;bot;
    r_set_size(&amp;pblock-&gt;used, pstack-&gt;p + 1 - pstack-&gt;bot);
}

/*
 * Free the entire contents of a stack, including the bottom block.
 * The client must still call ref_stack_free.  Note that after calling
 * ref_stack_release, the stack is no longer usable.
 */
void
ref_stack_release(ref_stack_t *pstack)
{
    gs_ref_memory_t *mem = pstack-&gt;memory;

    ref_stack_clear(pstack);
    /* Free the parameter structure. */
    gs_free_object((gs_memory_t *)mem, pstack-&gt;params,
		   "ref_stack_release(stack.params)");
    /* Free the original (bottom) block. */
    gs_free_ref_array(mem, &amp;pstack-&gt;current, "ref_stack_release");
}

/*
 * Release a stack and then free the ref_stack object.
 */
void
ref_stack_free(ref_stack_t *pstack)
{
    gs_memory_t *mem = (gs_memory_t *)pstack-&gt;memory;

    ref_stack_release(pstack);
    gs_free_object(mem, pstack, "ref_stack_free");
}

/* ------ Internal routines ------ */

/* Initialize the guards and body of a stack block. */
private void
init_block(ref_stack_t *pstack, const ref *psb, uint used)
{
    ref_stack_params_t *params = pstack-&gt;params;
    ref *brefs = psb-&gt;value.refs;
    uint i;
    ref *p;

    for (i = params-&gt;bot_guard, p = brefs + stack_block_refs;
	 i != 0; i--, p++
	)
	ref_assign(p, &amp;params-&gt;guard_value);
    /* The top guard elements will never be read, */
    /* but we need to initialize them for the sake of the GC. */
    /* We can use refset_null for this, because even though it uses */
    /* make_null_new and stack elements must not be marked new, */
    /* these slots will never actually be read or written. */
    if (params-&gt;top_guard) {
	ref *top = brefs + r_size(psb);
	int top_guard = params-&gt;top_guard;

	refset_null_new(top - top_guard, top_guard, 0);
    } {
	ref_stack_block *const pblock = (ref_stack_block *) brefs;

	pblock-&gt;used = *psb;
	pblock-&gt;used.value.refs = brefs + stack_block_refs + params-&gt;bot_guard;
	r_set_size(&amp;pblock-&gt;used, 0);
    }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

