<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/sbhc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/sbhc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1994, 1995, 1996, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: sbhc.c,v 1.5 2002/02/21 22:24:53 giles Exp $ */
/* Bounded Huffman code filters */
#include "memory_.h"
#include "stdio_.h"
#include "gdebug.h"
#include "strimpl.h"
#include "sbhc.h"
#include "shcgen.h"

/* ------ BoundedHuffmanEncode ------ */

private_st_BHCE_state();

/* Initialize BoundedHuffmanEncode filter. */
private int
s_BHCE_reinit(stream_state * st)
{
    stream_BHCE_state *const ss = (stream_BHCE_state *) st;

    ss-&gt;encode.count = ss-&gt;definition.num_values;
    s_bhce_init_inline(ss);
    return 0;
}
private int
s_BHCE_init(register stream_state * st)
{
    stream_BHCE_state *const ss = (stream_BHCE_state *) st;
    hce_code *encode = ss-&gt;encode.codes =
    (hce_code *) gs_alloc_byte_array(st-&gt;memory,
				     ss-&gt;definition.num_values,
				     sizeof(hce_code), "BHCE encode");

    if (encode == 0)
	return ERRC;
/****** WRONG ******/
    hc_make_encoding(encode, &amp;ss-&gt;definition);
    return s_BHCE_reinit(st);
}

/* Release the filter. */
private void
s_BHCE_release(stream_state * st)
{
    stream_BHCE_state *const ss = (stream_BHCE_state *) st;

    gs_free_object(st-&gt;memory, ss-&gt;encode.codes, "BHCE encode");
}

/* Process a buffer. */
private int
s_BHCE_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    stream_BHCE_state *const ss = (stream_BHCE_state *) st;
    const byte *p = pr-&gt;ptr;
    const byte *rlimit = pr-&gt;limit;
    byte *q = pw-&gt;ptr;
    byte *wlimit = pw-&gt;limit - (hc_bits_size &gt;&gt; 3);
    const hce_code *encode = ss-&gt;encode.codes;
    uint num_values = ss-&gt;definition.num_values;
    uint zero_runs = ss-&gt;EncodeZeroRuns;
    uint zero_max = num_values - zero_runs + (ss-&gt;EndOfData ? 0 : 1);
    uint zero_value = (zero_max &gt; 1 ? 0 : 0x100);
    int zeros = ss-&gt;zeros;
    int status = 0;

    hce_declare_state;

    hce_load_state();
    while (p &lt; rlimit &amp;&amp; q &lt; wlimit) {
	uint value = *++p;
	const hce_code *cp;

	if (value &gt;= num_values) {
	    status = ERRC;
	    break;
	}
	if (value == zero_value) {	/* Accumulate a run of zeros. */
	    ++zeros;
	    if (zeros != zero_max)
		continue;
	    /* We've scanned the longest run we can encode. */
	    cp = &amp;encode[zeros - 2 + zero_runs];
	    zeros = 0;
	    hc_put_code((stream_hc_state *) ss, q, cp);
	    continue;
	}
	/* Check whether we need to put out a zero run. */
	if (zeros &gt; 0) {
	    --p;
	    cp = (zeros == 1 ? &amp;encode[0] :
		  &amp;encode[zeros - 2 + zero_runs]);
	    zeros = 0;
	    hc_put_code((stream_hc_state *) ss, q, cp);
	    continue;
	}
	cp = &amp;encode[value];
	hc_put_code((stream_hc_state *) ss, q, cp);
    }
    if (q &gt;= wlimit)
	status = 1;
    wlimit = pw-&gt;limit;
    if (last &amp;&amp; status == 0) {
	if (zeros &gt; 0) {	/* Put out a final run of zeros. */
	    const hce_code *cp = (zeros == 1 ? &amp;encode[0] :
				  &amp;encode[zeros - 2 + zero_runs]);

	    if (!hce_bits_available(cp-&gt;code_length))
		status = 1;
	    else {
		hc_put_code((stream_hc_state *) ss, q, cp);
		zeros = 0;
	    }
	}
	if (ss-&gt;EndOfData) {	/* Put out the EOD code if we have room. */
	    const hce_code *cp = &amp;encode[num_values - 1];

	    if (!hce_bits_available(cp-&gt;code_length))
		status = 1;
	    else
		hc_put_code((stream_hc_state *) ss, q, cp);
	} else {
	    if (q &gt;= wlimit)
		status = 1;
	}
	if (!status) {
	    q = hc_put_last_bits((stream_hc_state *) ss, q);
	    goto ns;
	}
    }
    hce_store_state();
  ns:pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    ss-&gt;zeros = zeros;
    return (p == rlimit ? 0 : 1);
}

/* Stream template */
const stream_template s_BHCE_template =
{&amp;st_BHCE_state, s_BHCE_init, s_BHCE_process,
 1, hc_bits_size &gt;&gt; 3, s_BHCE_release, NULL, s_BHCE_reinit
};

/* ------ BoundedHuffmanDecode ------ */

private_st_BHCD_state();

#define hcd_initial_bits 7	/* arbitrary, &gt;= 1 and &lt;= 8 */

/* Initialize BoundedHuffmanDecode filter. */
private int
s_BHCD_reinit(stream_state * st)
{
    stream_BHCD_state *const ss = (stream_BHCD_state *) st;

    ss-&gt;decode.count = ss-&gt;definition.num_values;
    s_bhcd_init_inline(ss);
    return 0;
}
private int
s_BHCD_init(register stream_state * st)
{
    stream_BHCD_state *const ss = (stream_BHCD_state *) st;
    uint initial_bits = ss-&gt;decode.initial_bits =
    min(hcd_initial_bits, ss-&gt;definition.num_counts);
    uint dsize = hc_sizeof_decoding(&amp;ss-&gt;definition, initial_bits);
    hcd_code *decode = ss-&gt;decode.codes =
	(hcd_code *) gs_alloc_byte_array(st-&gt;memory, dsize,
					 sizeof(hcd_code), "BHCD decode");

    if (decode == 0)
	return ERRC;
/****** WRONG ******/
    hc_make_decoding(decode, &amp;ss-&gt;definition, initial_bits);
    st-&gt;min_left = 1;
    return s_BHCD_reinit(st);
}

/* Release the filter. */
private void
s_BHCD_release(stream_state * st)
{
    stream_BHCD_state *const ss = (stream_BHCD_state *) st;

    gs_free_object(st-&gt;memory, ss-&gt;decode.codes, "BHCD decode");
}

/* Process a buffer. */
private int
s_BHCD_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    stream_BHCD_state *const ss = (stream_BHCD_state *) st;

    bhcd_declare_state;
    byte *q = pw-&gt;ptr;
    byte *wlimit = pw-&gt;limit;
    const hcd_code *decode = ss-&gt;decode.codes;
    uint initial_bits = ss-&gt;decode.initial_bits;
    uint zero_runs = ss-&gt;EncodeZeroRuns;
    int status = 0;
    int eod = (ss-&gt;EndOfData ? ss-&gt;definition.num_values - 1 : -1);

    bhcd_load_state();
  z:for (; zeros &gt; 0; --zeros) {
	if (q &gt;= wlimit) {
	    status = 1;
	    goto out;
	}
	*++q = 0;
    }
    for (;;) {
	const hcd_code *cp;
	int clen;

	hcd_ensure_bits(initial_bits, x1);
	cp = &amp;decode[hcd_peek_var_bits(initial_bits)];
      w1:if (q &gt;= wlimit) {
	    status = 1;
	    break;
	}
	if ((clen = cp-&gt;code_length) &gt; initial_bits) {
	    if (!hcd_bits_available(clen)) {	/* We don't have enough bits for */
		/* all possible codes that begin this way, */
		/* but we might have enough for */
		/* the next code. */
/****** NOT IMPLEMENTED YET ******/
		break;
	    }
	    clen -= initial_bits;
	    hcd_skip_bits(initial_bits);
	    hcd_ensure_bits(clen, out);		/* can't exit */
	    cp = &amp;decode[cp-&gt;value + hcd_peek_var_bits(clen)];
	    hcd_skip_bits(cp-&gt;code_length);
	} else {
	    hcd_skip_bits(clen);
	}
	if (cp-&gt;value &gt;= zero_runs) {
	    if (cp-&gt;value == eod) {
		status = EOFC;
		goto out;
	    }
	    /* This code represents a run of zeros, */
	    /* not a single output value. */
	    zeros = cp-&gt;value - zero_runs + 2;
	    goto z;
	}
	*++q = cp-&gt;value;
	continue;
	/* We don't have enough bits for all possible */
	/* codes, but we might have enough for */
	/* the next code. */
      x1:cp = &amp;decode[(bits &amp; ((1 &lt;&lt; bits_left) - 1)) &lt;&lt;
		     (initial_bits - bits_left)];
	if ((clen = cp-&gt;code_length) &lt;= bits_left)
	    goto w1;
	break;
    }
  out:bhcd_store_state();
    pw-&gt;ptr = q;
    return status;
}

/* Stream template */
const stream_template s_BHCD_template =
{&amp;st_BHCD_state, s_BHCD_init, s_BHCD_process, 1, 1, s_BHCD_release,
 NULL, s_BHCD_reinit
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

