<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/scfdgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/scfdgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1992, 1994, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: scfdgen.c,v 1.5 2002/06/16 03:58:14 lpd Exp $ */
/* Generate the CCITTFaxDecode tables */
#include "stdio_.h"		/* includes std.h */
#include "scf.h"
#include "malloc_.h"
#include "memory_.h"

typedef void (*cfd_node_proc) (cfd_node *, cfd_node *, uint, int, int, int);
typedef void (*cfd_enum_proc) (cfd_node_proc, cfd_node *, cfd_node *, int);
private void cfd_build_tree(cfd_node *, cfd_enum_proc, int, FILE *);
private void cfd_enumerate_white(cfd_node_proc, cfd_node *, cfd_node *, int);
private void cfd_enumerate_black(cfd_node_proc, cfd_node *, cfd_node *, int);
private void cfd_enumerate_2d(cfd_node_proc, cfd_node *, cfd_node *, int);
private void cfd_enumerate_uncompressed(cfd_node_proc, cfd_node *, cfd_node *, int);

main()
{
    FILE *out = fopen("scfdtab.c", "w");
    cfd_node area[1 &lt;&lt; max(cfd_white_initial_bits, cfd_black_initial_bits)];

    fputs("/* Copyright (C) 1992, 1993, 1998, 1999 Aladdin Enterprises.  All rights reserved. */\n\n", out);
    fputs("/* $Id: scfdgen.c,v 1.5 2002/06/16 03:58:14 lpd Exp $ */\n", out);
    fputs("/* Tables for CCITTFaxDecode filter. */\n\n", out);
    fputs("/* This file was generated automatically.  It is governed by the same terms */\n", out);
    fputs("/* as the files scfetab.c and scfdgen.c from which it was derived. */\n", out);
    fputs("/* Consult those files for the licensing terms and conditions. */\n\n", out);
    fputs("#include \"std.h\"\n", out);
    fputs("#include \"scommon.h\"\t\t/* for scf.h */\n", out);
    fputs("#include \"scf.h\"\n\n", out);
    fputs("/* White decoding table. */\n", out);
    fputs("const cfd_node cf_white_decode[] = {\n", out);
    cfd_build_tree(area, cfd_enumerate_white, cfd_white_initial_bits, out);
    fputs("\n};\n\n", out);
    fputs("/* Black decoding table. */\n", out);
    fputs("const cfd_node cf_black_decode[] = {\n", out);
    cfd_build_tree(area, cfd_enumerate_black, cfd_black_initial_bits, out);
    fputs("\n};\n\n", out);
    fputs("/* 2-D decoding table. */\n", out);
    fputs("const cfd_node cf_2d_decode[] = {\n", out);
    cfd_build_tree(area, cfd_enumerate_2d, cfd_2d_initial_bits, out);
    fputs("\n};\n\n", out);
    fputs("/* Uncompresssed decoding table. */\n", out);
    fputs("const cfd_node cf_uncompressed_decode[] = {\n", out);
    cfd_build_tree(area, cfd_enumerate_uncompressed, cfd_uncompressed_initial_bits, out);
    fputs("\n};\n\n", out);
    fputs("/* Dummy executable code to pacify compilers. */\n", out);
    fputs("void scfdtab_dummy(void);\n", out);
    fputs("void\nscfdtab_dummy(void)\n{\n}\n", out);
    fclose(out);
    return 0;
}

/* Initialize first-level leaves, count second-level nodes. */
private void
cfd_count_nodes(cfd_node * tree, cfd_node * ignore_extn,
		uint code, int code_length, int run_length, int initial_bits)
{
    if (code_length &lt;= initial_bits) {
	/* Initialize one or more first-level leaves. */
	int sh = initial_bits - code_length;
	cfd_node *np = &amp;tree[code &lt;&lt; sh];
	int i;

	for (i = 1 &lt;&lt; sh; i &gt; 0; i--, np++)
	    np-&gt;run_length = run_length,
		np-&gt;code_length = code_length;
    } else {
	/* Note the need for a second level. */
	cfd_node *np = &amp;tree[code &gt;&gt; (code_length - initial_bits)];

	np-&gt;code_length = max(np-&gt;code_length, code_length);
    }
}

/* Initialize second-level nodes. */
private void
cfd_init2_nodes(cfd_node * tree, cfd_node * extn,
		uint code, int code_length, int run_length, int initial_bits)
{
    int xbits = code_length - initial_bits;
    int xrep;
    cfd_node *np1, *np2;
    int i;

    if (xbits &lt;= 0)
	return;
    np1 = &amp;tree[code &gt;&gt; xbits];
    np2 = &amp;extn[np1-&gt;run_length - (1 &lt;&lt; initial_bits)];
    xrep = np1-&gt;code_length - code_length;
    i = 1 &lt;&lt; xrep;
    np2 += (code &amp; ((1 &lt;&lt; xbits) - 1)) * i;
    for (; i &gt; 0; i--, np2++)
	np2-&gt;run_length = run_length,
	    np2-&gt;code_length = xbits;
}

/* Enumerate all the relevant white or black codes. */
private void
cfd_enumerate_codes(cfd_node_proc proc, cfd_node * tree, cfd_node * extn,
		  int initial_bits, const cfe_run * tt, const cfe_run * mut)
{
    int i;
    const cfe_run *ep;

    for (i = 0, ep = tt; i &lt; 64; i++, ep++)
	(*proc) (tree, extn, ep-&gt;code, ep-&gt;code_length, i, initial_bits);
    for (i = 1, ep = mut + 1; i &lt; 41; i++, ep++)
	(*proc) (tree, extn, ep-&gt;code, ep-&gt;code_length, i &lt;&lt; 6, initial_bits);
    (*proc) (tree, extn,
	     cf1_run_uncompressed.code, cf1_run_uncompressed.code_length,
	     run_uncompressed, initial_bits);
    (*proc) (tree, extn,
	     0, run_eol_code_length - 1,
	     run_zeros, initial_bits);
}
private void
cfd_enumerate_white(cfd_node_proc proc, cfd_node * tree, cfd_node * extn,
		    int initial_bits)
{
    cfd_enumerate_codes(proc, tree, extn, initial_bits,
			cf_white_runs.termination, cf_white_runs.make_up);
}
private void
cfd_enumerate_black(cfd_node_proc proc, cfd_node * tree, cfd_node * extn,
		    int initial_bits)
{
    cfd_enumerate_codes(proc, tree, extn, initial_bits,
			cf_black_runs.termination, cf_black_runs.make_up);
}

/* Enumerate the 2-D codes. */
private void
cfd_enumerate_2d(cfd_node_proc proc, cfd_node * tree, cfd_node * extn,
		 int initial_bits)
{
    int i;
    const cfe_run *ep;

    (*proc) (tree, extn, cf2_run_pass.code, cf2_run_pass.code_length,
	     run2_pass, initial_bits);
    (*proc) (tree, extn, cf2_run_horizontal.code, cf2_run_horizontal.code_length,
	     run2_horizontal, initial_bits);
    for (i = 0; i &lt; countof(cf2_run_vertical); i++) {
	ep = &amp;cf2_run_vertical[i];
	(*proc) (tree, extn, ep-&gt;code, ep-&gt;code_length, i, initial_bits);
    }
    (*proc) (tree, extn, cf2_run_uncompressed.code, cf2_run_uncompressed.code_length,
	     run_uncompressed, initial_bits);
    (*proc) (tree, extn, 0, run_eol_code_length - 1, run_zeros, initial_bits);
}

/* Enumerate the uncompressed codes. */
private void
cfd_enumerate_uncompressed(cfd_node_proc proc, cfd_node * tree, cfd_node * extn,
			   int initial_bits)
{
    int i;
    const cfe_run *ep;

    for (i = 0; i &lt; countof(cf_uncompressed); i++) {
	ep = &amp;cf_uncompressed[i];
	(*proc) (tree, extn, ep-&gt;code, ep-&gt;code_length, i, initial_bits);
    }
    for (i = 0; i &lt; countof(cf_uncompressed_exit); i++) {
	ep = &amp;cf_uncompressed_exit[i];
	(*proc) (tree, extn, ep-&gt;code, ep-&gt;code_length, i, initial_bits);
    }
}

/* Build and write out the table. */
private void
cfd_build_tree(cfd_node * tree, cfd_enum_proc enum_proc, int initial_bits,
	       FILE * f)
{
    cfd_node *np;
    const char *prev = "";
    int i, next;
    cfd_node *extn;

    memset(tree, 0, sizeof(cfd_node) &lt;&lt; initial_bits);
    /* Construct and write the first level of the tree. */
    (*enum_proc) (cfd_count_nodes, tree, (cfd_node *) 0, initial_bits);
    next = 0;
    for (i = 0, np = tree; i &lt; 1 &lt;&lt; initial_bits; i++, np++) {
	if (np-&gt;code_length &gt; initial_bits) {	/* second level needed */
	    np-&gt;run_length = next + (1 &lt;&lt; initial_bits);
	    next += 1 &lt;&lt; (np-&gt;code_length - initial_bits);
	}
	fprintf(f, "%s\t{ %d, %d }", prev, np-&gt;run_length, np-&gt;code_length);
	prev = ",\n";
    }
    /* Construct and write the second level. */
    extn = (cfd_node *) malloc(sizeof(cfd_node) * next);
    for (i = 0, np = extn; i &lt; next; i++, np++)
	np-&gt;run_length = run_error,
	    np-&gt;code_length = 0;
    (*enum_proc) (cfd_init2_nodes, tree, extn, initial_bits);
    for (i = 0, np = extn; i &lt; next; i++, np++)
	fprintf(f, ",\n\t{ %d, %d }", np-&gt;run_length, np-&gt;code_length);
    free((char *)extn);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

