<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/sdctd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/sdctd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1994, 1995, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: sdctd.c,v 1.4 2002/02/21 22:24:53 giles Exp $ */
/* DCT decoding filter stream */
#include "memory_.h"
#include "stdio_.h"
#include "jpeglib_.h"
#include "jerror_.h"
#include "gdebug.h"
#include "gsmemory.h"		/* for gsmalloc.h */
#include "gsmalloc.h"		/* for gs_memory_default */
#include "strimpl.h"
#include "sdct.h"
#include "sjpeg.h"

/* ------ DCTDecode ------ */

/* JPEG source manager procedures */
private void
dctd_init_source(j_decompress_ptr dinfo)
{
}
static const JOCTET fake_eoi[2] =
{0xFF, JPEG_EOI};
private boolean
dctd_fill_input_buffer(j_decompress_ptr dinfo)
{
    jpeg_decompress_data *jddp =
    (jpeg_decompress_data *) ((char *)dinfo -
			      offset_of(jpeg_decompress_data, dinfo));

    if (!jddp-&gt;input_eod)
	return FALSE;		/* normal case: suspend processing */
    /* Reached end of source data without finding EOI */
    WARNMS(dinfo, JWRN_JPEG_EOF);
    /* Insert a fake EOI marker */
    dinfo-&gt;src-&gt;next_input_byte = fake_eoi;
    dinfo-&gt;src-&gt;bytes_in_buffer = 2;
    jddp-&gt;faked_eoi = true;	/* so process routine doesn't use next_input_byte */
    return TRUE;
}
private void
dctd_skip_input_data(j_decompress_ptr dinfo, long num_bytes)
{
    struct jpeg_source_mgr *src = dinfo-&gt;src;
    jpeg_decompress_data *jddp =
    (jpeg_decompress_data *) ((char *)dinfo -
			      offset_of(jpeg_decompress_data, dinfo));

    if (num_bytes &gt; 0) {
	if (num_bytes &gt; src-&gt;bytes_in_buffer) {
	    jddp-&gt;skip += num_bytes - src-&gt;bytes_in_buffer;
	    src-&gt;next_input_byte += src-&gt;bytes_in_buffer;
	    src-&gt;bytes_in_buffer = 0;
	    return;
	}
	src-&gt;next_input_byte += num_bytes;
	src-&gt;bytes_in_buffer -= num_bytes;
    }
}
private void
dctd_term_source(j_decompress_ptr dinfo)
{
}

/* Set the defaults for the DCTDecode filter. */
private void
s_DCTD_set_defaults(stream_state * st)
{
    s_DCT_set_defaults(st);
}

/* Initialize DCTDecode filter */
private int
s_DCTD_init(stream_state * st)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;
    struct jpeg_source_mgr *src = &amp;ss-&gt;data.decompress-&gt;source;

    src-&gt;init_source = dctd_init_source;
    src-&gt;fill_input_buffer = dctd_fill_input_buffer;
    src-&gt;skip_input_data = dctd_skip_input_data;
    src-&gt;term_source = dctd_term_source;
    src-&gt;resync_to_restart = jpeg_resync_to_restart;	/* use default method */
    ss-&gt;data.common-&gt;memory = ss-&gt;jpeg_memory;
    ss-&gt;data.decompress-&gt;dinfo.src = src;
    ss-&gt;data.decompress-&gt;skip = 0;
    ss-&gt;data.decompress-&gt;input_eod = false;
    ss-&gt;data.decompress-&gt;faked_eoi = false;
    ss-&gt;phase = 0;
    return 0;
}

/* Process a buffer */
private int
s_DCTD_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;
    jpeg_decompress_data *jddp = ss-&gt;data.decompress;
    struct jpeg_source_mgr *src = jddp-&gt;dinfo.src;
    int code;

    if_debug3('w', "[wdd]process avail=%u, skip=%u, last=%d\n",
	      (uint) (pr-&gt;limit - pr-&gt;ptr), (uint) jddp-&gt;skip, last);
    if (jddp-&gt;skip != 0) {
	long avail = pr-&gt;limit - pr-&gt;ptr;

	if (avail &lt; jddp-&gt;skip) {
	    jddp-&gt;skip -= avail;
	    pr-&gt;ptr = pr-&gt;limit;
	    if (!last)
		return 0;	/* need more data */
	    jddp-&gt;skip = 0;	/* don't skip past input EOD */
	}
	pr-&gt;ptr += jddp-&gt;skip;
	jddp-&gt;skip = 0;
    }
    src-&gt;next_input_byte = pr-&gt;ptr + 1;
    src-&gt;bytes_in_buffer = pr-&gt;limit - pr-&gt;ptr;
    jddp-&gt;input_eod = last;
    switch (ss-&gt;phase) {
	case 0:		/* not initialized yet */
	    /*
	     * Adobe implementations seem to ignore leading garbage bytes,
	     * even though neither the standard nor Adobe's own
	     * documentation mention this.
	     */
	    while (pr-&gt;ptr &lt; pr-&gt;limit &amp;&amp; pr-&gt;ptr[1] != 0xff)
		pr-&gt;ptr++;
	    if (pr-&gt;ptr == pr-&gt;limit)
		return 0;
	    src-&gt;next_input_byte = pr-&gt;ptr + 1;
	    src-&gt;bytes_in_buffer = pr-&gt;limit - pr-&gt;ptr;
	    ss-&gt;phase = 1;
	    /* falls through */
	case 1:		/* reading header markers */
	    if ((code = gs_jpeg_read_header(ss, TRUE)) &lt; 0)
		return ERRC;
	    pr-&gt;ptr =
		(jddp-&gt;faked_eoi ? pr-&gt;limit : src-&gt;next_input_byte - 1);
	    switch (code) {
		case JPEG_SUSPENDED:
		    return 0;
		    /*case JPEG_HEADER_OK: */
	    }
	    /* If we have a ColorTransform parameter, and it's not
	     * overridden by an Adobe marker in the data, set colorspace.
	     */
	    if (ss-&gt;ColorTransform &gt;= 0 &amp;&amp;
		!jddp-&gt;dinfo.saw_Adobe_marker) {
		switch (jddp-&gt;dinfo.num_components) {
		    case 3:
			jddp-&gt;dinfo.jpeg_color_space =
			    (ss-&gt;ColorTransform ? JCS_YCbCr : JCS_RGB);
			/* out_color_space will default to JCS_RGB */
			break;
		    case 4:
			jddp-&gt;dinfo.jpeg_color_space =
			    (ss-&gt;ColorTransform ? JCS_YCCK : JCS_CMYK);
			/* out_color_space will default to JCS_CMYK */
			break;
		}
	    }
	    ss-&gt;phase = 2;
	    /* falls through */
	case 2:		/* start_decompress */
	    if ((code = gs_jpeg_start_decompress(ss)) &lt; 0)
		return ERRC;
	    pr-&gt;ptr =
		(jddp-&gt;faked_eoi ? pr-&gt;limit : src-&gt;next_input_byte - 1);
	    if (code == 0)
		return 0;
	    ss-&gt;scan_line_size =
		jddp-&gt;dinfo.output_width * jddp-&gt;dinfo.output_components;
	    if_debug4('w', "[wdd]width=%u, components=%d, scan_line_size=%u, min_out_size=%u\n",
		      jddp-&gt;dinfo.output_width,
		      jddp-&gt;dinfo.output_components,
		      ss-&gt;scan_line_size, jddp-&gt;template.min_out_size);
	    if (ss-&gt;scan_line_size &gt; (uint) jddp-&gt;template.min_out_size) {
		/* Create a spare buffer for oversize scanline */
		jddp-&gt;scanline_buffer =
		    gs_alloc_bytes_immovable(jddp-&gt;memory,
					     ss-&gt;scan_line_size,
					 "s_DCTD_process(scanline_buffer)");
		if (jddp-&gt;scanline_buffer == NULL)
		    return ERRC;
	    }
	    jddp-&gt;bytes_in_scanline = 0;
	    ss-&gt;phase = 3;
	    /* falls through */
	case 3:		/* reading data */
	  dumpbuffer:
	    if (jddp-&gt;bytes_in_scanline != 0) {
		uint avail = pw-&gt;limit - pw-&gt;ptr;
		uint tomove = min(jddp-&gt;bytes_in_scanline,
				  avail);

		if_debug2('w', "[wdd]moving %u/%u\n",
			  tomove, avail);
		memcpy(pw-&gt;ptr + 1, jddp-&gt;scanline_buffer +
		       (ss-&gt;scan_line_size - jddp-&gt;bytes_in_scanline),
		       tomove);
		pw-&gt;ptr += tomove;
		jddp-&gt;bytes_in_scanline -= tomove;
		if (jddp-&gt;bytes_in_scanline != 0)
		    return 1;	/* need more room */
	    }
	    while (jddp-&gt;dinfo.output_height &gt; jddp-&gt;dinfo.output_scanline) {
		int read;
		byte *samples;

		if (jddp-&gt;scanline_buffer != NULL)
		    samples = jddp-&gt;scanline_buffer;
		else {
		    if ((uint) (pw-&gt;limit - pw-&gt;ptr) &lt; ss-&gt;scan_line_size)
			return 1;	/* need more room */
		    samples = pw-&gt;ptr + 1;
		}
		read = gs_jpeg_read_scanlines(ss, &amp;samples, 1);
		if (read &lt; 0)
		    return ERRC;
		if_debug3('w', "[wdd]read returns %d, used=%u, faked_eoi=%d\n",
			  read,
			  (uint) (src-&gt;next_input_byte - 1 - pr-&gt;ptr),
			  (int)jddp-&gt;faked_eoi);
		pr-&gt;ptr =
		    (jddp-&gt;faked_eoi ? pr-&gt;limit : src-&gt;next_input_byte - 1);
		if (!read)
		    return 0;	/* need more data */
		if (jddp-&gt;scanline_buffer != NULL) {
		    jddp-&gt;bytes_in_scanline = ss-&gt;scan_line_size;
		    goto dumpbuffer;
		}
		pw-&gt;ptr += ss-&gt;scan_line_size;
	    }
	    ss-&gt;phase = 4;
	    /* falls through */
	case 4:		/* end of image; scan for EOI */
	    if ((code = gs_jpeg_finish_decompress(ss)) &lt; 0)
		return ERRC;
	    pr-&gt;ptr =
		(jddp-&gt;faked_eoi ? pr-&gt;limit : src-&gt;next_input_byte - 1);
	    if (code == 0)
		return 0;
	    ss-&gt;phase = 5;
	    /* falls through */
	case 5:		/* we are DONE */
	    return EOFC;
    }
    /* Default case can't happen.... */
    return ERRC;
}

/* Release the stream */
private void
s_DCTD_release(stream_state * st)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;

    gs_jpeg_destroy(ss);
    if (ss-&gt;data.decompress-&gt;scanline_buffer != NULL)
	gs_free_object(ss-&gt;data.common-&gt;memory,
		       ss-&gt;data.decompress-&gt;scanline_buffer,
		       "s_DCTD_release(scanline_buffer)");
    gs_free_object(ss-&gt;data.common-&gt;memory, ss-&gt;data.decompress,
		   "s_DCTD_release");
    /* Switch the template pointer back in case we still need it. */
    st-&gt;template = &amp;s_DCTD_template;
}

/* Stream template */
const stream_template s_DCTD_template =
{&amp;st_DCT_state, s_DCTD_init, s_DCTD_process, 2000, 4000, s_DCTD_release,
 s_DCTD_set_defaults
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

