<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/sfilter1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/sfilter1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1993, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: sfilter1.c,v 1.8 2002/02/21 22:24:54 giles Exp $ */
/* Filters included in Level 1 systems: NullEncode/Decode, PFBDecode, */
/*   SubFileDecode. */
#include "stdio_.h"		/* includes std.h */
#include "memory_.h"
#include "strimpl.h"
#include "sfilter.h"

/* ------ PFBDecode ------ */

private_st_PFBD_state();

/* Initialize the state */
private int
s_PFBD_init(stream_state * st)
{
    stream_PFBD_state *const ss = (stream_PFBD_state *) st;

    ss-&gt;record_type = -1;
    return 0;
}

/* Process a buffer */
private int
s_PFBD_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    stream_PFBD_state *const ss = (stream_PFBD_state *) st;
    register const byte *p = pr-&gt;ptr;
    register byte *q = pw-&gt;ptr;
    int rcount, wcount;
    int c;
    int status = 0;

top:
    rcount = pr-&gt;limit - p;
    wcount = pw-&gt;limit - q;
    switch (ss-&gt;record_type) {
	case -1:		/* new record */
	    if (rcount &lt; 2)
		goto out;
	    if (p[1] != 0x80)
		goto err;
	    c = p[2];
	    switch (c) {
		case 1:
		case 2:
		    break;
		case 3:
		    status = EOFC;
		    p += 2;
		    goto out;
		default:
		    p += 2;
		    goto err;
	    }
	    if (rcount &lt; 6)
		goto out;
	    ss-&gt;record_type = c;
	    ss-&gt;record_left = p[3] + ((uint) p[4] &lt;&lt; 8) +
		((ulong) p[5] &lt;&lt; 16) +
		((ulong) p[6] &lt;&lt; 24);
	    p += 6;
	    goto top;
	case 1:		/* text data */
	    /* Translate \r to \n. */
	    {
		int count = (wcount &lt; rcount ? (status = 1, wcount) : rcount);

		if (count &gt; ss-&gt;record_left)
		    count = ss-&gt;record_left,
			status = 0;
		ss-&gt;record_left -= count;
		for (; count != 0; count--) {
		    c = *++p;
		    *++q = (c == '\r' ? '\n' : c);
		}
	    }
	    break;
	case 2:		/* binary data */
	    if (ss-&gt;binary_to_hex) {
		/* Translate binary to hex. */
		int count;
		const char *const hex_digits = "0123456789abcdef";

		wcount &gt;&gt;= 1;	/* 2 chars per input byte */
		count = (wcount &lt; rcount ? (status = 1, wcount) : rcount);
		if (count &gt; ss-&gt;record_left)
		    count = ss-&gt;record_left,
			status = 0;
		ss-&gt;record_left -= count;
		for (; count != 0; count--) {
		    c = *++p;
		    q[1] = hex_digits[c &gt;&gt; 4];
		    q[2] = hex_digits[c &amp; 0xf];
		    q += 2;
		}
	    } else {		/* Just read binary data. */
		int count = (wcount &lt; rcount ? (status = 1, wcount) : rcount);

		if (count &gt; ss-&gt;record_left)
		    count = ss-&gt;record_left,
			status = 0;
		ss-&gt;record_left -= count;
		memcpy(q + 1, p + 1, count);
		p += count;
		q += count;
	    }
	    break;
    }
    if (ss-&gt;record_left == 0) {
	ss-&gt;record_type = -1;
	goto top;
    }
out:
    pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    return status;
err:
    pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    return ERRC;
}

/* Stream template */
const stream_template s_PFBD_template = {
    &amp;st_PFBD_state, s_PFBD_init, s_PFBD_process, 6, 2
};

/* ------ SubFileDecode ------ */

private_st_SFD_state();

/* Set default parameter values. */
private void
s_SFD_set_defaults(stream_state * st)
{
    stream_SFD_state *const ss = (stream_SFD_state *) st;

    ss-&gt;count = 0;
    ss-&gt;eod.data = 0;
    ss-&gt;eod.size = 0;
    ss-&gt;skip_count = 0;
}

/* Initialize the stream */
private int
s_SFD_init(stream_state * st)
{
    stream_SFD_state *const ss = (stream_SFD_state *) st;

    ss-&gt;match = 0;
    ss-&gt;copy_count = 0;
    ss-&gt;min_left = (ss-&gt;eod.size != 0);

    return 0;
}

/* Refill the buffer */
private int
s_SFD_process(stream_state * st, stream_cursor_read * pr,
	      stream_cursor_write * pw, bool last)
{
    stream_SFD_state *const ss = (stream_SFD_state *) st;
    register const byte *p = pr-&gt;ptr;
    register byte *q = pw-&gt;ptr;
    const byte *rlimit = pr-&gt;limit;
    byte *wlimit = pw-&gt;limit;
    int status = 0;

    if (ss-&gt;eod.size == 0) {	/* Just read, with no EOD pattern. */
	int rcount = rlimit - p;
	int wcount = wlimit - q;
	int count;

	if (rcount &lt;= ss-&gt;skip_count) { /* skipping */
	    ss-&gt;skip_count -= rcount;
	    pr-&gt;ptr = rlimit;
	    return 0;
	} else if (ss-&gt;skip_count &gt; 0) {
	    rcount -= ss-&gt;skip_count;
	    pr-&gt;ptr = p += ss-&gt;skip_count;
	    ss-&gt;skip_count = 0;
	}
	count = min(rcount, wcount);
	if (ss-&gt;count == 0)	/* no EOD limit */
	    return stream_move(pr, pw);
	else if (ss-&gt;count &gt; count) {	/* not EOD yet */
	    ss-&gt;count -= count;
	    return stream_move(pr, pw);
	} else {		/* We're going to reach EOD. */
	    count = ss-&gt;count;
	    if (count &gt; 0) {
		memcpy(q + 1, p + 1, count);
		pr-&gt;ptr = p + count;
		pw-&gt;ptr = q + count;
	    }
	    ss-&gt;count = -1;
	    return EOFC;
	}
    } else {			/* Read looking for an EOD pattern. */
	const byte *pattern = ss-&gt;eod.data;
	uint match = ss-&gt;match;

cp:
	/* Check whether we're still copying a partial match. */
	if (ss-&gt;copy_count) {
	    int count = min(wlimit - q, ss-&gt;copy_count);

	    memcpy(q + 1, ss-&gt;eod.data + ss-&gt;copy_ptr, count);
	    ss-&gt;copy_count -= count;
	    ss-&gt;copy_ptr += count;
	    q += count;
	    if (ss-&gt;copy_count != 0) {	/* hit wlimit */
		status = 1;
		goto xit;
	    } else if (ss-&gt;count &lt; 0) {
		status = EOFC;
		goto xit;
	    }
	}
	while (p &lt; rlimit) {
	    int c = *++p;

	    if (c == pattern[match]) {
		if (++match == ss-&gt;eod.size) {
		    if (ss-&gt;skip_count &gt; 0) {
			q = pw-&gt;ptr; /* undo any writes */
			ss-&gt;skip_count--;
			match = 0;
			continue;
		    }
		    /*
		     * We use if/else rather than switch because the value
		     * is long, which is not supported as a switch value in
		     * pre-ANSI C.
		     */
		    if (ss-&gt;count &lt;= 0) {
			status = EOFC;
			goto xit;
		    } else if (ss-&gt;count == 1) {
			ss-&gt;count = -1;
		    } else
			ss-&gt;count--;
		    ss-&gt;copy_ptr = 0;
		    ss-&gt;copy_count = match;
		    match = 0;
		    goto cp;
		}
		continue;
	    }
	    /*
	     * No match here, back up to find the longest one.
	     * This may be quadratic in string_size, but
	     * we don't expect this to be a real problem.
	     */
	    if (match &gt; 0) {
		int end = match;

		while (match &gt; 0) {
		    match--;
		    if (!memcmp(pattern, pattern + end - match, match))
			break;
		}
		/*
		 * Copy the unmatched initial portion of
		 * the EOD string to the output.
		 */
		p--;
		ss-&gt;copy_ptr = 0;
		ss-&gt;copy_count = end - match;
		goto cp;
	    }
	    if (q == wlimit) {
		p--;
		status = 1;
		break;
	    }
	    *++q = c;
	}
xit:	pr-&gt;ptr = p;
	if (ss-&gt;skip_count &lt;= 0)
	    pw-&gt;ptr = q;
	ss-&gt;match = match;
    }
    return status;
}

/* Stream template */
const stream_template s_SFD_template = {
    &amp;st_SFD_state, s_SFD_init, s_SFD_process, 1, 1, 0, s_SFD_set_defaults
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

