<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/shcgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/shcgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1994, 1996, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: shcgen.c,v 1.4 2002/02/21 22:24:54 giles Exp $ */
/* Generate (bounded) Huffman code definitions from frequencies, */
/* and tables from definitions. */
#include "memory_.h"
#include "stdio_.h"
#include &lt;stdlib.h&gt;		/* for qsort */
#include "gdebug.h"
#include "gserror.h"
#include "gserrors.h"
#include "gsmemory.h"
#include "scommon.h"
#include "shc.h"
#include "shcgen.h"

/* ------ Frequency -&gt; definition procedure ------ */

/* Define a node for the Huffman code tree. */
typedef struct count_node_s count_node;
struct count_node_s {
    long freq;			/* frequency of value */
    uint value;			/* data value being encoded */
    uint code_length;		/* length of Huffman code */
    count_node *next;		/* next node in freq-sorted list */
    count_node *left;		/* left child in tree (smaller code_length) */
    count_node *right;		/* right child in tree (greater code_length) */
};

#ifdef DEBUG
#  define debug_print_nodes(nodes, n, tag, lengths)\
     if ( gs_debug_c('W') ) print_nodes_proc(nodes, n, tag, lengths);
private void
print_nodes_proc(const count_node * nodes, int n, const char *tag, int lengths)
{
    int i;

    dlprintf1("[w]---------------- %s ----------------\n", tag);
    for (i = 0; i &lt; n; ++i)
	dlprintf7("[w]node %d: f=%ld v=%d len=%d N=%d L=%d R=%d\n",
		  i, nodes[i].freq, nodes[i].value, nodes[i].code_length,
		  (nodes[i].next == 0 ? -1 : (int)(nodes[i].next - nodes)),
		  (nodes[i].left == 0 ? -1 : (int)(nodes[i].left - nodes)),
		(nodes[i].right == 0 ? -1 : (int)(nodes[i].right - nodes)));
    for (i = lengths; i &gt; 0;) {
	int j = i;
	int len = nodes[--j].code_length;

	while (j &gt; 0 &amp;&amp; nodes[j - 1].code_length == len)
	    --j;
	dlprintf2("[w]%d codes of length %d\n", i - j, len);
	i = j;
    }
}
#else
#  define debug_print_nodes(nodes, n, tag, lengths) DO_NOTHING
#endif

/* Node comparison procedures for sorting. */
#define pn1 ((const count_node *)p1)
#define pn2 ((const count_node *)p2)
/* Sort by decreasing frequency. */
private int
compare_freqs(const void *p1, const void *p2)
{
    long diff = pn2-&gt;freq - pn1-&gt;freq;

    return (diff &lt; 0 ? -1 : diff &gt; 0 ? 1 : 0);
}
/* Sort by increasing code length, and secondarily by decreasing frequency. */
private int
compare_code_lengths(const void *p1, const void *p2)
{
    int diff = pn1-&gt;code_length - pn2-&gt;code_length;

    return (diff &lt; 0 ? -1 : diff &gt; 0 ? 1 : compare_freqs(p1, p2));
}
/* Sort by increasing code value. */
private int
compare_values(const void *p1, const void *p2)
{
    return (pn1-&gt;value &lt; pn2-&gt;value ? -1 :
	    pn1-&gt;value &gt; pn2-&gt;value ? 1 : 0);
}
#undef pn1
#undef pn2

/* Adjust code lengths so that none of them exceeds max_length. */
/* We break this out just to help organize the code; it's only called */
/* from one place in hc_compute. */
private void
hc_limit_code_lengths(count_node * nodes, uint num_values, int max_length)
{
    int needed;			/* # of max_length codes we need to free up */
    count_node *longest = nodes + num_values;

    {				/* Compute the number of additional max_length codes */
	/* we need to make available. */
	int length = longest[-1].code_length;
	int next_length;
	int avail = 0;

	while ((next_length = longest[-1].code_length) &gt; max_length) {
	    avail &gt;&gt;= length - next_length;
	    length = next_length;
	    (--longest)-&gt;code_length = max_length;
	    ++avail;
	}
	needed = (nodes + num_values - longest) -
	    (avail &gt;&gt;= (length - max_length));
	if_debug2('W', "[w]avail=%d, needed=%d\n",
		  avail, needed);
    }
    /* Skip over all max_length codes. */
    while (longest[-1].code_length == max_length)
	--longest;

    /*
     * To make available a code of length N, suppose that the next
     * shortest used code is of length M.
     * We take the lowest-frequency code of length M and change it
     * to M+1; we then have to compensate by reducing the length of
     * some of the highest-frequency codes of length N, as follows:
     *       M      new lengths for codes of length N
     *      ---     -----------
     *      N-1     (none)
     *      N-2     N-1
     *      &lt;N-2    M+2, M+2, N-1
     * In the present situation, N = max_length.
     */
    for (; needed &gt; 0; --needed) {	/* longest points to the first code of length max_length. */
	/* Since codes are sorted by increasing code length, */
	/* longest-1 is the desired code of length M. */
	int M1 = ++(longest[-1].code_length);

	switch (max_length - M1) {
	    case 0:		/* M == N-1 */
		--longest;
		break;
	    case 1:		/* M == N-2 */
		longest++-&gt;code_length = M1;
		break;
	    default:
		longest-&gt;code_length = M1 + 1;
		longest[1].code_length = M1 + 1;
		longest[2].code_length--;
		longest += 3;
	}
    }
}

/* Compute an optimal Huffman code from an input data set. */
/* The client must have set all the elements of *def. */
int
hc_compute(hc_definition * def, const long *freqs, gs_memory_t * mem)
{
    uint num_values = def-&gt;num_values;
    count_node *nodes =
    (count_node *) gs_alloc_byte_array(mem, num_values * 2 - 1,
				       sizeof(count_node), "hc_compute");
    int i;
    count_node *lowest;
    count_node *comb;

    if (nodes == 0)
	return_error(gs_error_VMerror);

    /* Create leaf nodes for the input data. */
    for (i = 0; i &lt; num_values; ++i)
	nodes[i].freq = freqs[i], nodes[i].value = i;

    /* Create a list sorted by increasing frequency. */
    /* Also initialize the tree structure. */
    qsort(nodes, num_values, sizeof(count_node), compare_freqs);
    for (i = 0; i &lt; num_values; ++i)
	nodes[i].next = &amp;nodes[i - 1],
	    nodes[i].code_length = 0,
	    nodes[i].left = nodes[i].right = 0;
    nodes[0].next = 0;
    debug_print_nodes(nodes, num_values, "after sort", 0);

    /* Construct the Huffman code tree. */
    for (lowest = &amp;nodes[num_values - 1], comb = &amp;nodes[num_values];;
	 ++comb
	) {
	count_node *pn1 = lowest;
	count_node *pn2 = pn1-&gt;next;
	long freq = pn1-&gt;freq + pn2-&gt;freq;

	/* Create a parent for the two lowest-frequency nodes. */
	lowest = pn2-&gt;next;
	comb-&gt;freq = freq;
	if (pn1-&gt;code_length &lt;= pn2-&gt;code_length)
	    comb-&gt;left = pn1, comb-&gt;right = pn2,
		comb-&gt;code_length = pn2-&gt;code_length + 1;
	else
	    comb-&gt;left = pn2, comb-&gt;right = pn1,
		comb-&gt;code_length = pn1-&gt;code_length + 1;
	if (lowest == 0)	/* no nodes left to combine */
	    break;
	/* Insert comb in the sorted list. */
	if (freq &lt; lowest-&gt;freq)
	    comb-&gt;next = lowest, lowest = comb;
	else {
	    count_node *here = lowest;

	    while (here-&gt;next != 0 &amp;&amp; freq &gt;= here-&gt;next-&gt;freq)
		here = here-&gt;next;
	    comb-&gt;next = here-&gt;next;
	    here-&gt;next = comb;
	}
    }

    /* comb (i.e., &amp;nodes[num_values * 2 - 2] is the root of the tree. */
    /* Note that the left and right children of an interior node */
    /* were constructed before, and therefore have lower indices */
    /* in the nodes array than, the parent node.  Thus we can assign */
    /* the code lengths (node depths) in a single descending-order */
    /* sweep. */
    comb++-&gt;code_length = 0;
    while (comb &gt; nodes + num_values) {
	--comb;
	comb-&gt;left-&gt;code_length = comb-&gt;right-&gt;code_length =
	    comb-&gt;code_length + 1;
    }
    debug_print_nodes(nodes, num_values * 2 - 1, "after combine", 0);

    /* Sort the leaves again by code length. */
    qsort(nodes, num_values, sizeof(count_node), compare_code_lengths);
    debug_print_nodes(nodes, num_values, "after re-sort", num_values);

    /* Limit the code length to def-&gt;num_counts. */
    hc_limit_code_lengths(nodes, num_values, def-&gt;num_counts);
    debug_print_nodes(nodes, num_values, "after limit", num_values);

    /* Sort within each code length by increasing code value. */
    /* This doesn't affect data compression, but it makes */
    /* the code definition itself compress better using our */
    /* incremental encoding. */
    for (i = num_values; i &gt; 0;) {
	int j = i;
	int len = nodes[--j].code_length;

	while (j &gt; 0 &amp;&amp; nodes[j - 1].code_length == len)
	    --j;
	qsort(&amp;nodes[j], i - j, sizeof(count_node), compare_values);
	i = j;
    }

    /* Extract the definition from the nodes. */
    memset(def-&gt;counts, 0, sizeof(*def-&gt;counts) * (def-&gt;num_counts + 1));
    for (i = 0; i &lt; num_values; ++i) {
	def-&gt;values[i] = nodes[i].value;
	def-&gt;counts[nodes[i].code_length]++;
    }

    /* All done, release working storage. */
    gs_free_object(mem, nodes, "hc_compute");
    return 0;
}

/* ------ Byte string &lt;-&gt; definition procedures ------ */

/*
 * We define a compressed representation for (well-behaved) definitions
 * as a byte string.  A "well-behaved" definition is one where if
 * code values A and B have the same code length and A &lt; B,
 * A precedes B in the values table of the definition, and hence
 * A's encoding lexicographically precedes B's.
 *
 * The successive bytes in the compressed string  give the code lengths for
 * runs of decoded values, in the form nnnnllll where nnnn is the number of
 * consecutive values -1 and llll is the code length -1.
 */

/* Convert a definition to a byte string. */
/* The caller must provide the byte string, of length def-&gt;num_values. */
/* Assume (do not check) that the definition is well-behaved. */
/* Return the actual length of the string. */
int
hc_bytes_from_definition(byte * dbytes, const hc_definition * def)
{
    int i, j;
    byte *bp = dbytes;
    const byte *lp = dbytes;
    const byte *end = dbytes + def-&gt;num_values;
    const ushort *values = def-&gt;values;

    /* Temporarily use the output string as a map from */
    /* values to code lengths. */
    for (i = 1; i &lt;= def-&gt;num_counts; i++)
	for (j = 0; j &lt; def-&gt;counts[i]; j++)
	    bp[*values++] = i;

    /* Now construct the actual string. */
    while (lp &lt; end) {
	const byte *vp;
	byte len = *lp;

	for (vp = lp + 1; vp &lt; end &amp;&amp; vp &lt; lp + 16 &amp;&amp; *vp == len;)
	    vp++;
	*bp++ = ((vp - lp - 1) &lt;&lt; 4) + (len - 1);
	lp = vp;
    }

    return bp - dbytes;
}

/* Extract num_counts and num_values from a byte string. */
void
hc_sizes_from_bytes(hc_definition * def, const byte * dbytes, int num_bytes)
{
    uint num_counts = 0, num_values = 0;
    int i;

    for (i = 0; i &lt; num_bytes; i++) {
	int n = (dbytes[i] &gt;&gt; 4) + 1;
	int l = (dbytes[i] &amp; 15) + 1;

	if (l &gt; num_counts)
	    num_counts = l;
	num_values += n;
    }
    def-&gt;num_counts = num_counts;
    def-&gt;num_values = num_values;
}

/* Convert a byte string back to a definition. */
/* The caller must initialize *def, including allocating counts and values. */
void
hc_definition_from_bytes(hc_definition * def, const byte * dbytes)
{
    int v, i;
    ushort counts[max_hc_length + 1];

    /* Make a first pass to set the counts for each code length. */
    memset(counts, 0, sizeof(counts[0]) * (def-&gt;num_counts + 1));
    for (i = 0, v = 0; v &lt; def-&gt;num_values; i++) {
	int n = (dbytes[i] &gt;&gt; 4) + 1;
	int l = (dbytes[i] &amp; 15) + 1;

	counts[l] += n;
	v += n;
    }

    /* Now fill in the definition. */
    memcpy(def-&gt;counts, counts, sizeof(counts[0]) * (def-&gt;num_counts + 1));
    for (i = 1, v = 0; i &lt;= def-&gt;num_counts; i++) {
	uint prev = counts[i];

	counts[i] = v;
	v += prev;
    }
    for (i = 0, v = 0; v &lt; def-&gt;num_values; i++) {
	int n = (dbytes[i] &gt;&gt; 4) + 1;
	int l = (dbytes[i] &amp; 15) + 1;
	int j;

	for (j = 0; j &lt; n; n++)
	    def-&gt;values[counts[l]++] = v++;
    }
}

/* ------ Definition -&gt; table procedures ------ */

/* Generate the encoding table from the definition. */
/* The size of the encode array is def-&gt;num_values. */
void
hc_make_encoding(hce_code * encode, const hc_definition * def)
{
    uint next = 0;
    const ushort *pvalue = def-&gt;values;
    uint i, k;

    for (i = 1; i &lt;= def-&gt;num_counts; i++) {
	for (k = 0; k &lt; def-&gt;counts[i]; k++, pvalue++, next++) {
	    hce_code *pce = encode + *pvalue;

	    pce-&gt;code = next;
	    pce-&gt;code_length = i;
	}
	next &lt;&lt;= 1;
    }
}

/* We decode in two steps, first indexing into a table with */
/* a fixed number of bits from the source, and then indexing into */
/* an auxiliary table if necessary.  (See shc.h for details.) */

/* Calculate the size of the decoding table. */
uint
hc_sizeof_decoding(const hc_definition * def, int initial_bits)
{
    uint size = 1 &lt;&lt; initial_bits;
    uint carry = 0, mask = (uint) ~ 1;
    uint i;

    for (i = initial_bits + 1; i &lt;= def-&gt;num_counts;
	 i++, carry &lt;&lt;= 1, mask &lt;&lt;= 1
	) {
	carry += def-&gt;counts[i];
	size += carry &amp; mask;
	carry &amp;= ~mask;
    }
    return size;
}

/* Generate the decoding tables. */
void
hc_make_decoding(hcd_code * decode, const hc_definition * def,
		 int initial_bits)
{				/* Make entries for single-dispatch codes. */
    {
	hcd_code *pcd = decode;
	const ushort *pvalue = def-&gt;values;
	uint i, k, d;

	for (i = 0; i &lt;= initial_bits; i++) {
	    for (k = 0; k &lt; def-&gt;counts[i]; k++, pvalue++) {
		for (d = 1 &lt;&lt; (initial_bits - i); d &gt; 0;
		     d--, pcd++
		    )
		    pcd-&gt;value = *pvalue,
			pcd-&gt;code_length = i;
	    }
	}
    }
    /* Make entries for two-dispatch codes. */
    /* By working backward, we can do this more easily */
    /* in a single pass. */
    {
	uint dsize = hc_sizeof_decoding(def, initial_bits);
	hcd_code *pcd = decode + (1 &lt;&lt; initial_bits);
	hcd_code *pcd2 = decode + dsize;
	const ushort *pvalue = def-&gt;values + def-&gt;num_values;
	uint entries_left = 0, slots_left = 0, mult_shift = 0;
	uint i = def-&gt;num_counts + 1, j;

	for (;;) {
	    if (slots_left == 0) {
		if (entries_left != 0) {
		    slots_left = 1 &lt;&lt; (i - initial_bits);
		    mult_shift = 0;
		    continue;
		}
		if (--i &lt;= initial_bits)
		    break;
		entries_left = def-&gt;counts[i];
		continue;
	    }
	    if (entries_left == 0) {
		entries_left = def-&gt;counts[--i];
		mult_shift++;
		continue;
	    }
	    --entries_left, --pvalue;
	    for (j = 1 &lt;&lt; mult_shift; j &gt; 0; j--) {
		--pcd2;
		pcd2-&gt;value = *pvalue;
		pcd2-&gt;code_length = i - initial_bits;
	    }
	    if ((slots_left -= 1 &lt;&lt; mult_shift) == 0) {
		--pcd;
		pcd-&gt;value = pcd2 - decode;
		pcd-&gt;code_length = i + mult_shift;
	    }
	}
    }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

