<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/siinterp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/siinterp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: siinterp.c,v 1.7 2004/12/08 21:35:13 stefan Exp $ */
/* Image interpolation filter */
#include "memory_.h"
#include &lt;assert.h&gt;
#include "gxfixed.h"		/* for gxdda.h */
#include "gxdda.h"
#include "gxfrac.h"
#include "strimpl.h"
#include "siinterp.h"

/* ImageInterpolateEncode state */
typedef struct gx_dda_int_s {
    dda_state_struct(ia_, int, uint) state;
    dda_step_struct(ie_, int, uint) step;
} gx_dda_int_t;
typedef enum {
    SCALE_SAME = 0,
    SCALE_SAME_ALIGNED,
    SCALE_8_8,
    SCALE_8_8_ALIGNED,
    SCALE_8_16_BYTE2FRAC,
    SCALE_8_16_BYTE2FRAC_ALIGNED,
    SCALE_8_16_BYTE2FRAC_3,
    SCALE_8_16_BYTE2FRAC_3_ALIGNED,
    SCALE_8_16_GENERAL,
    SCALE_8_16_GENERAL_ALIGNED,
    SCALE_16_8,
    SCALE_16_8_ALIGNED,
    SCALE_16_16,
    SCALE_16_16_ALIGNED
} scale_case_t;
typedef struct stream_IIEncode_state_s {
    /* The client sets the params values before initialization. */
    stream_image_scale_state_common;  /* = state_common + params */
    /* The init procedure sets the following. */
    int sizeofPixelIn;		/* bytes per input pixel, 1 or 2 * Colors */
    int sizeofPixelOut;		/* bytes per output pixel, 1 or 2 * Colors */
    uint src_size;		/* bytes per row of input */
    uint dst_size;		/* bytes per row of output */
    void /*PixelOut */ *prev;	/* previous row of input data in output fmt, */
				/* [WidthIn * sizeofPixelOut] */
    void /*PixelOut */ *cur;	/* current row of input data in output fmt, */
				/* [WidthIn * sizeofPixelOut] */
    scale_case_t scale_case;
    /* The following are updated dynamically. */
    int dst_x;
    gx_dda_int_t dda_x;		/* DDA for dest X in current scan line */
    gx_dda_int_t dda_x_init;	/* initial setting of dda_x */
    int src_y, dst_y;
    gx_dda_int_t dda_y;		/* DDA for dest Y */
    int src_offset, dst_offset;
} stream_IIEncode_state;

gs_private_st_ptrs2(st_IIEncode_state, stream_IIEncode_state,
    "ImageInterpolateEncode state",
    iiencode_state_enum_ptrs, iiencode_state_reloc_ptrs,
    prev, cur);

/* Forward references */
private void s_IIEncode_release(stream_state * st);

/* Initialize the filter. */
private int
s_IIEncode_init(stream_state * st)
{
    stream_IIEncode_state *const ss = (stream_IIEncode_state *) st;
    gs_memory_t *mem = ss-&gt;memory;

    ss-&gt;sizeofPixelIn =
	ss-&gt;params.BitsPerComponentIn / 8 * ss-&gt;params.Colors;
    ss-&gt;sizeofPixelOut =
	ss-&gt;params.BitsPerComponentOut / 8 * ss-&gt;params.Colors;
    ss-&gt;src_size = ss-&gt;sizeofPixelIn * ss-&gt;params.WidthIn;
    ss-&gt;dst_size = ss-&gt;sizeofPixelOut * ss-&gt;params.WidthOut;

    /* Initialize destination DDAs. */
    ss-&gt;dst_x = 0;
    ss-&gt;src_offset = ss-&gt;dst_offset = 0;
    dda_init(ss-&gt;dda_x, 0, ss-&gt;params.WidthIn, ss-&gt;params.WidthOut);
    ss-&gt;dda_x_init = ss-&gt;dda_x;
    ss-&gt;src_y = ss-&gt;dst_y = 0;
    dda_init(ss-&gt;dda_y, 0, ss-&gt;params.HeightOut, ss-&gt;params.HeightIn);

    /* Allocate buffers for 2 rows of input data. */
    ss-&gt;prev = gs_alloc_byte_array(mem, ss-&gt;params.WidthIn,
				   ss-&gt;sizeofPixelOut, "IIEncode prev");
    ss-&gt;cur = gs_alloc_byte_array(mem, ss-&gt;params.WidthIn,
				  ss-&gt;sizeofPixelOut, "IIEncode cur");
    if (ss-&gt;prev == 0 || ss-&gt;cur == 0) {
	s_IIEncode_release(st);
	return ERRC;	/****** WRONG ******/
    }

    /* Determine the case for the inner loop. */
    ss-&gt;scale_case =
	(ss-&gt;params.BitsPerComponentIn == 8 ?
	 (ss-&gt;params.BitsPerComponentOut == 8 ?
	  (ss-&gt;params.MaxValueIn == ss-&gt;params.MaxValueOut ?
	   SCALE_SAME : SCALE_8_8) :
	  (ss-&gt;params.MaxValueIn == 255 &amp;&amp; ss-&gt;params.MaxValueOut == frac_1 ?
	   (ss-&gt;params.Colors == 3 ? SCALE_8_16_BYTE2FRAC_3 :
	    SCALE_8_16_BYTE2FRAC) :
	   SCALE_8_16_GENERAL)) :
	 (ss-&gt;params.BitsPerComponentOut == 8 ? SCALE_16_8 :
	  ss-&gt;params.MaxValueIn == ss-&gt;params.MaxValueOut ?
	  SCALE_SAME : SCALE_16_16));

    return 0;
}

/* Process a buffer. */
private int
s_IIEncode_process(stream_state * st, stream_cursor_read * pr,
		   stream_cursor_write * pw, bool last)
{
    stream_IIEncode_state *const ss = (stream_IIEncode_state *) st;
    const scale_case_t scale_case = ss-&gt;scale_case +
	ALIGNMENT_MOD(pw-&gt;ptr, 2); /* ptr odd =&gt; buffer is aligned */
    byte *out = pw-&gt;ptr + 1;
    /****** WRONG, requires an entire output pixel ******/
    byte *limit = pw-&gt;limit + 1 - ss-&gt;sizeofPixelOut;

    /* Check whether we need to deliver any output. */

top:
    if (dda_current(ss-&gt;dda_y) &gt; ss-&gt;dst_y) {
	/* Deliver some or all of the current scaled row. */
	while (ss-&gt;dst_x &lt; ss-&gt;params.WidthOut) {
	    uint sx = dda_current(ss-&gt;dda_x) * ss-&gt;sizeofPixelIn;
	    const byte *in = (const byte *)ss-&gt;cur + sx;
	    int c;

	    if (out &gt; limit) {
		pw-&gt;ptr = out - 1;
		return 1;
	    }
	    switch (scale_case) {
	    case SCALE_SAME:
	    case SCALE_SAME_ALIGNED:
		memcpy(out, in, ss-&gt;sizeofPixelIn);
		out += ss-&gt;sizeofPixelIn;
		break;
	    case SCALE_8_8:
	    case SCALE_8_8_ALIGNED:
		for (c = ss-&gt;params.Colors; --c &gt;= 0; ++in, ++out)
		    *out = (byte)(*in * ss-&gt;params.MaxValueOut /
				  ss-&gt;params.MaxValueIn);
		break;
	    case SCALE_8_16_BYTE2FRAC:
	    case SCALE_8_16_BYTE2FRAC_ALIGNED: /* could be optimized */
	    case SCALE_8_16_BYTE2FRAC_3: /* could be optimized */
		for (c = ss-&gt;params.Colors; --c &gt;= 0; ++in, out += 2) {
		    uint b = *in;
		    uint value = byte2frac(b);

		    out[0] = (byte)(value &gt;&gt; 8), out[1] = (byte)value;
		}
		break;
	    case SCALE_8_16_BYTE2FRAC_3_ALIGNED:
		{
		    uint b = in[0];

		    ((bits16 *)out)[0] = byte2frac(b);
		    b = in[1];
		    ((bits16 *)out)[1] = byte2frac(b);
		    b = in[2];
		    ((bits16 *)out)[2] = byte2frac(b);
		}
		out += 6;
		break;
	    case SCALE_8_16_GENERAL:
	    case SCALE_8_16_GENERAL_ALIGNED: /* could be optimized */
		for (c = ss-&gt;params.Colors; --c &gt;= 0; ++in, out += 2) {
		    uint value = *in * ss-&gt;params.MaxValueOut /
			ss-&gt;params.MaxValueIn;

		    out[0] = (byte)(value &gt;&gt; 8), out[1] = (byte)value;
		}
		break;
	    case SCALE_16_8:
	    case SCALE_16_8_ALIGNED:
		for (c = ss-&gt;params.Colors; --c &gt;= 0; in += 2, ++out)
		    *out = (byte)(*(const bits16 *)in *
				  ss-&gt;params.MaxValueOut /
				  ss-&gt;params.MaxValueIn);
		break;
	    case SCALE_16_16:
	    case SCALE_16_16_ALIGNED: /* could be optimized */
		for (c = ss-&gt;params.Colors; --c &gt;= 0; in += 2, out += 2) {
		    uint value = *(const bits16 *)in *
			ss-&gt;params.MaxValueOut / ss-&gt;params.MaxValueIn;

		    out[0] = (byte)(value &gt;&gt; 8), out[1] = (byte)value;
		}
	    }
	    dda_next(ss-&gt;dda_x);
	    ss-&gt;dst_x++;
	}
	ss-&gt;dst_x = 0;
	ss-&gt;dst_y++;
	ss-&gt;dda_x = ss-&gt;dda_x_init;
	goto top;
    }
    pw-&gt;ptr = out - 1;
    if (ss-&gt;dst_y &gt;= ss-&gt;params.HeightOut)
	return EOFC;

    if (ss-&gt;src_offset &lt; ss-&gt;src_size) {
	uint count = min(ss-&gt;src_size - ss-&gt;src_offset, pr-&gt;limit - pr-&gt;ptr);

	if (count == 0)
	    return 0;
	memcpy((byte *)ss-&gt;cur + ss-&gt;src_offset, pr-&gt;ptr + 1, count);
	ss-&gt;src_offset += count;
	pr-&gt;ptr += count;
	if (ss-&gt;src_offset &lt; ss-&gt;src_size)
	    return 0;
    }
    ss-&gt;src_offset = 0;
    ss-&gt;dst_x = 0;
    ss-&gt;dda_x = ss-&gt;dda_x_init;
    dda_next(ss-&gt;dda_y);
    goto top;
}

/* Release the filter's storage. */
private void
s_IIEncode_release(stream_state * st)
{
    stream_IIEncode_state *const ss = (stream_IIEncode_state *) st;
    gs_memory_t *mem = ss-&gt;memory;

    gs_free_object(mem, ss-&gt;cur, "IIEncode cur");
    ss-&gt;cur = 0;
    gs_free_object(mem, ss-&gt;prev, "IIEncode prev");
    ss-&gt;prev = 0;
}

/* Stream template */
const stream_template s_IIEncode_template = {
    &amp;st_IIEncode_state, s_IIEncode_init, s_IIEncode_process, 1, 1,
    s_IIEncode_release
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

