<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/slzwe.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/slzwe.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1993 Aladdin Enterprises.  All rights reserved.
  
  This file is part of Aladdin Ghostscript.
  
  Aladdin Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author
  or distributor accepts any responsibility for the consequences of using it,
  or for whether it serves any particular purpose or works at all, unless he
  or she says so in writing.  Refer to the Aladdin Ghostscript Free Public
  License (the "License") for full details.
  
  Every copy of Aladdin Ghostscript must include a copy of the License,
  normally in a plain ASCII text file named PUBLIC.  The License grants you
  the right to copy, modify and redistribute Aladdin Ghostscript, but only
  under certain conditions described in the License.  Among other things, the
  License requires that the copyright notice and this notice be preserved on
  all copies.
*/

/* $Id: slzwe.c,v 1.4 2005/04/04 23:00:24 igor Exp $ */
/* LZW encoding filter */
#include "stdio_.h"	/* includes std.h */
#include "gdebug.h"
#include "strimpl.h"
#include "slzwx.h"

/********************************************************/
/* LZW routines are based on:				*/
/* Dr. Dobbs Journal --- Oct. 1989. 			*/
/* Article on LZW Data Compression by Mark R. Nelson 	*/
/********************************************************/

/* Define the special codes */
#define code_reset 256
#define code_eod 257
#define code_0 258			/* first assignable code */

/* Import the stream closing procedure */
extern stream_proc_release(s_LZW_release);

typedef struct lzw_encode_s {
	byte datum;			/* last byte of this code */
	ushort prefix;			/* code for prefix of this code */
} lzw_encode;

#define encode_max 4095		/* max # of codes, must be */
				/* &gt; code_0 and &lt;= 4095 */
#define hash_size (encode_max + encode_max / 4)

struct lzw_encode_table_s {
	lzw_encode encode[encode_max];
	ushort hashed[hash_size];
};
gs_private_st_simple(st_lzwe_table, lzw_encode_table, "lzw_encode_table");

/* Hashing function */
#define encode_hash(code, chr)\
  ((uint)((code) * 59 + (chr) * ((hash_size / 256) | 1)) % hash_size)

/* Internal routine to put a code into the output buffer. */
/* Let S = ss-&gt;code_size, M = ss-&gt;next_code, N = 1 &lt;&lt; M. */
/* Relevant invariants: 9 &lt;= S &lt;= 12; N / 2 &lt;= M &lt; N; 0 &lt;= code &lt; N; */
/* 1 &lt;= ss-&gt;bits_left &lt;= 8; only the rightmost (8 - ss-&gt;bits_left) */
/* bits of ss-&gt;bits contain valid data. */
private byte *
lzw_put_code(register stream_LZW_state *ss, byte *q, uint code)
{	uint size = ss-&gt;code_size;
	byte cb = (ss-&gt;bits &lt;&lt; ss-&gt;bits_left) +
		(code &gt;&gt; (size - ss-&gt;bits_left));
	if_debug2('W', "[w]writing 0x%x,%d\n", code, ss-&gt;code_size);
	*++q = cb;
	if ( (ss-&gt;bits_left += 8 - size) &lt;= 0 )
	{	*++q = code &gt;&gt; -ss-&gt;bits_left;
		ss-&gt;bits_left += 8;
	}
	ss-&gt;bits = code;
	return q;
}

/* Internal routine to reset the encoding table */
private void
lzw_reset_encode(stream_LZW_state *ss)
{	register int c;
	lzw_encode_table *table = ss-&gt;table.encode;
	ss-&gt;next_code = code_0;
	ss-&gt;code_size = 9;
	ss-&gt;prev_code = code_eod;
	for ( c = 0; c &lt; hash_size; c++ )
		table-&gt;hashed[c] = code_eod;
	for ( c = 0; c &lt; 256; c++ )
	{	lzw_encode *ec = &amp;table-&gt;encode[c];
		register ushort *tc = &amp;table-&gt;hashed[encode_hash(code_eod, c)];
		while ( *tc != code_eod )
		  if ( ++tc == &amp;table-&gt;hashed[hash_size] )
		    tc = &amp;table-&gt;hashed[0];
		*tc = c;
		ec-&gt;datum = c, ec-&gt;prefix = code_eod;
	}
	table-&gt;encode[code_eod].prefix = code_reset;	/* guarantee no match */
}

#define ss ((stream_LZW_state *)st)

/* Initialize LZWEncode filter */
private int
s_LZWE_init(stream_state *st)
{	ss-&gt;bits_left = 8;
	ss-&gt;table.encode = gs_alloc_struct(st-&gt;memory,
			lzw_encode_table, &amp;st_lzwe_table, "LZWEncode init");
	if ( ss-&gt;table.encode == 0 )
		return ERRC;		/****** WRONG ******/
	ss-&gt;first = true;
	lzw_reset_encode(ss);
	return 0;
}

/* Process a buffer */
private int
s_LZWE_process(stream_state *st, stream_cursor_read *pr,
  stream_cursor_write *pw, bool last)
{	register const byte *p = pr-&gt;ptr;
	const byte *rlimit = pr-&gt;limit;
	register byte *q = pw-&gt;ptr;
	byte *wlimit = pw-&gt;limit;
	int code = ss-&gt;prev_code;
	lzw_encode_table *table = ss-&gt;table.encode;
	ushort *table_end = &amp;table-&gt;hashed[hash_size];
	int status = 0;
	int limit_code;
#define set_limit_code()\
  limit_code = (1 &lt;&lt; ss-&gt;code_size) - ss-&gt;EarlyChange;\
  if ( limit_code &gt; encode_max ) limit_code = encode_max
	set_limit_code();
	if ( ss-&gt;first )
	{	/* Emit the initial reset code. */
		if ( wlimit - q &lt; 2 )
			return 1;
		q = lzw_put_code(ss, q, code_reset);
		ss-&gt;first = false;
	}
	while ( p &lt; rlimit )
	{	byte c = p[1];
		ushort *tp;
		for ( tp = &amp;table-&gt;hashed[encode_hash(code, c)]; ; )
		{	lzw_encode *ep = &amp;table-&gt;encode[*tp];
			if ( ep-&gt;prefix == code &amp;&amp; ep-&gt;datum == c )
			{	code = *tp;
				p++;
				break;
			}
			else if ( *tp != code_eod )
			{	if ( ++tp == table_end )
				  tp = &amp;table-&gt;hashed[0]; /* wrap around */
			}
			else
			{	/* end of recognized sequence */
				if ( wlimit - q &lt;= 4 )
				{	status = 1;
					goto out;
				}
				q = lzw_put_code(ss, q, code);
				if ( ss-&gt;next_code == limit_code )
				{	/* Reached power of 2 or limit. */
					/* Determine which. */
					if ( ss-&gt;next_code == encode_max )
					{	q = lzw_put_code(ss, q, code_reset);
						lzw_reset_encode(ss);
						set_limit_code();
						goto cx;
					}
					ss-&gt;code_size++;
					set_limit_code();
				}
				if_debug3('W', "[W]encoding 0x%x=0x%x+%c\n",
					  ss-&gt;next_code, code, c);
				*tp = ss-&gt;next_code++;
				ep = &amp;table-&gt;encode[*tp];
				ep-&gt;datum = c;
				ep-&gt;prefix = code;
cx:				code = code_eod;
				break;
			}
		}
	}
	if ( last &amp;&amp; status == 0 )
	{	if ( wlimit - q &lt; 4 )
			status = 1;
		else
		  {	if ( code != code_eod )
			  {	q = lzw_put_code(ss, q, code);	/* put out final code */
			  }
			q = lzw_put_code(ss, q, code_eod);
			if ( ss-&gt;bits_left &lt; 8 )
			  *++q = ss-&gt;bits &lt;&lt; ss-&gt;bits_left;  /* final byte */
		  }
	}
out:	ss-&gt;prev_code = code;
	pr-&gt;ptr = p;
	pw-&gt;ptr = q;
	return status;
}

#undef ss

/* Stream template */
const stream_template s_LZWE_template =
{	&amp;st_LZW_state, s_LZWE_init, s_LZWE_process, 1, 4, s_LZW_release,
	s_LZW_set_defaults
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

