<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/stream.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/stream.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 2000, 2001 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: stream.c,v 1.26 2004/10/07 05:18:34 ray Exp $ */
/* Stream package for Ghostscript interpreter */
#include "stdio_.h"		/* includes std.h */
#include "memory_.h"
#include "gdebug.h"
#include "gpcheck.h"
#include "stream.h"
#include "strimpl.h"

/* Forward declarations */
private int sreadbuf(stream *, stream_cursor_write *);
private int swritebuf(stream *, stream_cursor_read *, bool);
private void stream_compact(stream *, bool);

/* Structure types for allocating streams. */
public_st_stream();
public_st_stream_state();	/* default */
/* GC procedures */
private 
ENUM_PTRS_WITH(stream_enum_ptrs, stream *st) return 0;
case 0:
if (st-&gt;foreign)
    ENUM_RETURN(NULL);
else if (st-&gt;cbuf_string.data != 0)
    ENUM_RETURN_STRING_PTR(stream, cbuf_string);
else
    ENUM_RETURN(st-&gt;cbuf);
ENUM_PTR3(1, stream, strm, prev, next);
ENUM_PTR(4, stream, state);
case 5: return ENUM_CONST_STRING(&amp;st-&gt;file_name);
ENUM_PTRS_END
private RELOC_PTRS_WITH(stream_reloc_ptrs, stream *st)
{
    byte *cbuf_old = st-&gt;cbuf;

    if (cbuf_old != 0 &amp;&amp; !st-&gt;foreign) {
	long reloc;

	if (st-&gt;cbuf_string.data != 0) {
	    RELOC_STRING_VAR(st-&gt;cbuf_string);
	    st-&gt;cbuf = st-&gt;cbuf_string.data;
	} else
	    RELOC_VAR(st-&gt;cbuf);
	reloc = cbuf_old - st-&gt;cbuf;
	/* Relocate the other buffer pointers. */
	st-&gt;srptr -= reloc;
	st-&gt;srlimit -= reloc;	/* same as swptr */
	st-&gt;swlimit -= reloc;
    }
    RELOC_VAR(st-&gt;strm);
    RELOC_VAR(st-&gt;prev);
    RELOC_VAR(st-&gt;next);
    RELOC_VAR(st-&gt;state);
    RELOC_CONST_STRING_VAR(st-&gt;file_name);
}
RELOC_PTRS_END
/* Finalize a stream by closing it. */
/* We only do this for file streams, because other kinds of streams */
/* may attempt to free storage when closing. */
private void
stream_finalize(void *vptr)
{
    stream *const st = vptr;

    if_debug2('u', "[u]%s 0x%lx\n",
	      (!s_is_valid(st) ? "already closed:" :
	       st-&gt;is_temp ? "is_temp set:" :
	       st-&gt;file == 0 ? "not file:" :
	       "closing file:"), (ulong) st);
    if (s_is_valid(st) &amp;&amp; !st-&gt;is_temp &amp;&amp; st-&gt;file != 0) {
	/* Prevent any attempt to free the buffer. */
	st-&gt;cbuf = 0;
	st-&gt;cbuf_string.data = 0;
	sclose(st);		/* ignore errors */
    }
}

/* Dummy template for streams that don't have a separate state. */
private const stream_template s_no_template = {
    &amp;st_stream_state, 0, 0, 1, 1, 0
};

/* ------ Generic procedures ------ */

/* Allocate a stream and initialize it minimally. */
void
s_init(stream *s, gs_memory_t * mem)
{
    s-&gt;memory = mem;
    s-&gt;report_error = s_no_report_error;
    s-&gt;min_left = 0;
    s-&gt;error_string[0] = 0;
    s-&gt;prev = s-&gt;next = 0;	/* clean for GC */
    s-&gt;file_name.data = 0;	/* ibid. */
    s-&gt;file_name.size = 0;	
    s-&gt;close_strm = false;	/* default */
    s-&gt;close_at_eod = true;	/* default */
}
stream *
s_alloc(gs_memory_t * mem, client_name_t cname)
{
    stream *s = gs_alloc_struct(mem, stream, &amp;st_stream, cname);

    if_debug2('s', "[s]alloc(%s) = 0x%lx\n",
	      client_name_string(cname), (ulong) s);
    if (s == 0)
	return 0;
    s_init(s, mem);
    return s;
}

/* Allocate a stream state and initialize it minimally. */
void
s_init_state(stream_state *st, const stream_template *template,
	     gs_memory_t *mem)
{
    st-&gt;template = template;
    st-&gt;memory = mem;
    st-&gt;report_error = s_no_report_error;
    st-&gt;min_left = 0;
}
stream_state *
s_alloc_state(gs_memory_t * mem, gs_memory_type_ptr_t stype,
	      client_name_t cname)
{
    stream_state *st = gs_alloc_struct(mem, stream_state, stype, cname);

    if_debug3('s', "[s]alloc_state %s(%s) = 0x%lx\n",
	      client_name_string(cname),
	      client_name_string(stype-&gt;sname),
	      (ulong) st);
    if (st)
	s_init_state(st, NULL, mem);
    return st;
}

/* Standard stream initialization */
void
s_std_init(register stream * s, byte * ptr, uint len, const stream_procs * pp,
	   int modes)
{
    s-&gt;template = &amp;s_no_template;
    s-&gt;cbuf = ptr;
    s-&gt;srptr = s-&gt;srlimit = s-&gt;swptr = ptr - 1;
    s-&gt;swlimit = ptr - 1 + len;
    s-&gt;end_status = 0;
    s-&gt;foreign = 0;
    s-&gt;modes = modes;
    s-&gt;cbuf_string.data = 0;
    s-&gt;position = 0;
    s-&gt;bsize = s-&gt;cbsize = len;
    s-&gt;strm = 0;		/* not a filter */
    s-&gt;is_temp = 0;
    s-&gt;procs = *pp;
    s-&gt;state = (stream_state *) s;	/* hack to avoid separate state */
    s-&gt;file = 0;
    s-&gt;file_name.data = 0;	/* in case stream is on stack */
    s-&gt;file_name.size = 0;
    if_debug4('s', "[s]init 0x%lx, buf=0x%lx, len=%u, modes=%d\n",
	      (ulong) s, (ulong) ptr, len, modes);
}


/* Set the file name of a stream, copying the name. */
/* Return &lt;0 if the copy could not be allocated. */
int
ssetfilename(stream *s, const byte *data, uint size)
{
    byte *str =
	(s-&gt;file_name.data == 0 ?
	 gs_alloc_string(s-&gt;memory, size + 1, "ssetfilename") :
	 gs_resize_string(s-&gt;memory,
			  (byte *)s-&gt;file_name.data,	/* break const */
			  s-&gt;file_name.size,
			  size + 1, "ssetfilename"));

    if (str == 0)
	return -1;
    memcpy(str, data, size);
    str[size] = 0;
    s-&gt;file_name.data = str;
    s-&gt;file_name.size = size + 1;
    return 0;
}

/* Return the file name of a stream, if any. */
/* There is a guaranteed 0 byte after the string. */
int
sfilename(stream *s, gs_const_string *pfname)
{
    pfname-&gt;data = s-&gt;file_name.data;
    if (pfname-&gt;data == 0) {
	pfname-&gt;size = 0;
	return -1;
    }
    pfname-&gt;size = s-&gt;file_name.size - 1; /* omit terminator */
    return 0;
}

/* Implement a stream procedure as a no-op. */
int
s_std_null(stream * s)
{
    return 0;
}

/* Discard the contents of the buffer when reading. */
void
s_std_read_reset(stream * s)
{
    s-&gt;srptr = s-&gt;srlimit = s-&gt;cbuf - 1;
}

/* Discard the contents of the buffer when writing. */
void
s_std_write_reset(stream * s)
{
    s-&gt;swptr = s-&gt;cbuf - 1;
}

/* Flush data to end-of-file when reading. */
int
s_std_read_flush(stream * s)
{
    while (1) {
	s-&gt;srptr = s-&gt;srlimit = s-&gt;cbuf - 1;
	if (s-&gt;end_status)
	    break;
	s_process_read_buf(s);
    }
    return (s-&gt;end_status == EOFC ? 0 : s-&gt;end_status);
}

/* Flush buffered data when writing. */
int
s_std_write_flush(stream * s)
{
    return s_process_write_buf(s, false);
}

/* Indicate that the number of available input bytes is unknown. */
int
s_std_noavailable(stream * s, long *pl)
{
    *pl = -1;
    return 0;
}

/* Indicate an error when asked to seek. */
int
s_std_noseek(stream * s, long pos)
{
    return ERRC;
}

/* Standard stream closing. */
int
s_std_close(stream * s)
{
    return 0;
}

/* Standard stream mode switching. */
int
s_std_switch_mode(stream * s, bool writing)
{
    return ERRC;
}

/* Standard stream finalization.  Disable the stream. */
void
s_disable(register stream * s)
{
    s-&gt;cbuf = 0;
    s-&gt;bsize = 0;
    s-&gt;end_status = EOFC;
    s-&gt;modes = 0;
    s-&gt;cbuf_string.data = 0;
    /* The pointers in the next two statements should really be */
    /* initialized to ([const] byte *)0 - 1, but some very picky */
    /* compilers complain about this. */
    s-&gt;cursor.r.ptr = s-&gt;cursor.r.limit = 0;
    s-&gt;cursor.w.limit = 0;
    s-&gt;procs.close = s_std_null;
    /* Clear pointers for GC */
    s-&gt;strm = 0;
    s-&gt;state = (stream_state *) s;
    s-&gt;template = &amp;s_no_template;
    /* Free the file name. */
    if (s-&gt;file_name.data) {
	gs_free_const_string(s-&gt;memory, s-&gt;file_name.data, s-&gt;file_name.size,
			     "s_disable(file_name)");
	s-&gt;file_name.data = 0;
	s-&gt;file_name.size = 0;
    }
    /****** SHOULD DO MORE THAN THIS ******/
    if_debug1('s', "[s]disable 0x%lx\n", (ulong) s);
}

/* Implement flushing for encoding filters. */
int
s_filter_write_flush(register stream * s)
{
    int status = s_process_write_buf(s, false);

    if (status != 0)
	return status;
    return sflush(s-&gt;strm);
}

/* Close a filter.  If this is an encoding filter, flush it first. */
/* If CloseTarget was specified (close_strm), then propagate the sclose */
int
s_filter_close(register stream * s)
{
    int status;
    bool close = s-&gt;close_strm;
    stream *stemp = s-&gt;strm;

    if (s_is_writing(s)) {
	int status = s_process_write_buf(s, true);

	if (status != 0 &amp;&amp; status != EOFC)
	    return status;
        status = sflush(stemp);
	if (status != 0 &amp;&amp; status != EOFC)
	    return status;
    }
    status = s_std_close(s);
    if (status != 0 &amp;&amp; status != EOFC)
	return status;
    if (close &amp;&amp; stemp != 0)
	return sclose(stemp);
    return status;
}

/* Disregard a stream error message. */
int
s_no_report_error(stream_state * st, const char *str)
{
    return 0;
}

/* Generic procedure structures for filters. */

const stream_procs s_filter_read_procs = {
    s_std_noavailable, s_std_noseek, s_std_read_reset,
    s_std_read_flush, s_filter_close
};

const stream_procs s_filter_write_procs = {
    s_std_noavailable, s_std_noseek, s_std_write_reset,
    s_filter_write_flush, s_filter_close
};

/* ------ Implementation-independent procedures ------ */

/* Store the amount of available data in a(n input) stream. */
int
savailable(stream * s, long *pl)
{
    return (*(s)-&gt;procs.available) (s, pl);
}

/* Return the current position of a stream. */
long
stell(stream * s)
{
    /*
     * The stream might have been closed, but the position
     * is still meaningful in this case.
     */
    const byte *ptr = (s_is_writing(s) ? s-&gt;swptr : s-&gt;srptr);

    return (ptr == 0 ? 0 : ptr + 1 - s-&gt;cbuf) + s-&gt;position;
}

/* Set the position of a stream. */
int
spseek(stream * s, long pos)
{
    if_debug3('s', "[s]seek 0x%lx to %ld, position was %ld\n",
	      (ulong) s, pos, stell(s));
    return (*(s)-&gt;procs.seek) (s, pos);
}

/* Switch a stream to read or write mode. */
/* Return 0 or ERRC. */
int
sswitch(register stream * s, bool writing)
{
    if (s-&gt;procs.switch_mode == 0)
	return ERRC;
    return (*s-&gt;procs.switch_mode) (s, writing);
}

/* Close a stream, disabling it if successful. */
/* (The stream may already be closed.) */
int
sclose(register stream * s)
{
    stream_state *st;
    int status = (*s-&gt;procs.close) (s);

    if (status &lt; 0)
	return status;
    st = s-&gt;state;
    if (st != 0) {
	stream_proc_release((*release)) = st-&gt;template-&gt;release;
	if (release != 0)
	    (*release) (st);
	if (st != (stream_state *) s &amp;&amp; st-&gt;memory != 0)
	    gs_free_object(st-&gt;memory, st, "s_std_close");
	s-&gt;state = (stream_state *) s;
    }
    s_disable(s);
    return status;
}

/*
 * Implement sgetc when the buffer may be empty.  If the buffer really is
 * empty, refill it and then read a byte.  Note that filters must read one
 * byte ahead, so that they can close immediately after the client reads the
 * last data byte if the next thing is an EOD.
 */
int
spgetcc(register stream * s, bool close_at_eod)
{
    int status, left;
    int min_left = sbuf_min_left(s);

    while (status = s-&gt;end_status,
	   left = s-&gt;srlimit - s-&gt;srptr,
	   left &lt;= min_left &amp;&amp; status &gt;= 0
	)
	s_process_read_buf(s);
    if (left &lt;= min_left &amp;&amp;
	(left == 0 || (status != EOFC &amp;&amp; status != ERRC))
	) {
	/* Compact the stream so stell will return the right result. */
	stream_compact(s, true);
	if (status == EOFC &amp;&amp; close_at_eod &amp;&amp; s-&gt;close_at_eod) {
	    status = sclose(s);
	    if (status == 0)
		status = EOFC;
	    s-&gt;end_status = status;
	}
	return status;
    }
    return *++(s-&gt;srptr);
}

/* Implementing sputc when the buffer is full, */
/* by flushing the buffer and then writing the byte. */
int
spputc(register stream * s, byte b)
{
    for (;;) {
	if (s-&gt;end_status)
	    return s-&gt;end_status;
	if (!sendwp(s)) {
	    *++(s-&gt;swptr) = b;
	    return b;
	}
	s_process_write_buf(s, false);
    }
}

/* Push back a character onto a (read) stream. */
/* The character must be the same as the last one read. */
/* Return 0 on success, ERRC on failure. */
int
sungetc(register stream * s, byte c)
{
    if (!s_is_reading(s) || s-&gt;srptr &lt; s-&gt;cbuf || *(s-&gt;srptr) != c)
	return ERRC;
    s-&gt;srptr--;
    return 0;
}

/* Get a string from a stream. */
/* Return 0 if the string was filled, or an exception status. */
int
sgets(stream * s, byte * buf, uint nmax, uint * pn)
{
    stream_cursor_write cw;
    int status = 0;
    int min_left = sbuf_min_left(s);

    cw.ptr = buf - 1;
    cw.limit = cw.ptr + nmax;
    while (cw.ptr &lt; cw.limit) {
	int left;

	if ((left = s-&gt;srlimit - s-&gt;srptr) &gt; min_left) {
	    s-&gt;srlimit -= min_left;
	    stream_move(&amp;s-&gt;cursor.r, &amp;cw);
	    s-&gt;srlimit += min_left;
	} else {
	    uint wanted = cw.limit - cw.ptr;
	    int c;
	    stream_state *st;

	    if (wanted &gt;= s-&gt;bsize &gt;&gt; 2 &amp;&amp;
		(st = s-&gt;state) != 0 &amp;&amp;
		wanted &gt;= st-&gt;template-&gt;min_out_size &amp;&amp;
		s-&gt;end_status == 0 &amp;&amp;
		left == 0
		) {
		byte *wptr = cw.ptr;

		cw.limit -= min_left;
		status = sreadbuf(s, &amp;cw);
		cw.limit += min_left;
		/* Compact the stream so stell will return the right result. */
		stream_compact(s, true);
		/*
		 * We know the stream buffer is empty, so it's safe to
		 * update position.  However, we need to reset the read
		 * cursor to indicate that there is no data in the buffer.
		 */
		s-&gt;srptr = s-&gt;srlimit = s-&gt;cbuf - 1;
		s-&gt;position += cw.ptr - wptr;
		if (status != 1 || cw.ptr == cw.limit)
		    break;
	    }
	    c = spgetc(s);
	    if (c &lt; 0) {
		status = c;
		break;
	    }
	    *++(cw.ptr) = c;
	}
    }
    *pn = cw.ptr + 1 - buf;
    return (status &gt;= 0 ? 0 : status);
}

/* Write a string on a stream. */
/* Return 0 if the entire string was written, or an exception status. */
int
sputs(register stream * s, const byte * str, uint wlen, uint * pn)
{
    uint len = wlen;
    int status = s-&gt;end_status;

    if (status &gt;= 0)
	while (len &gt; 0) {
	    uint count = s-&gt;swlimit - s-&gt;swptr;

	    if (count &gt; 0) {
		if (count &gt; len)
		    count = len;
		memcpy(s-&gt;swptr + 1, str, count);
		s-&gt;swptr += count;
		str += count;
		len -= count;
	    } else {
		byte ch = *str++;

		status = sputc(s, ch);
		if (status &lt; 0)
		    break;
		len--;
	    }
	}
    *pn = wlen - len;
    return (status &gt;= 0 ? 0 : status);
}

/* Skip ahead a specified distance in a read stream. */
/* Return 0 or an exception status. */
/* Store the number of bytes skipped in *pskipped. */
int
spskip(register stream * s, long nskip, long *pskipped)
{
    long n = nskip;
    int min_left;

    if (nskip &lt; 0 || !s_is_reading(s)) {
	*pskipped = 0;
	return ERRC;
    }
    if (s_can_seek(s)) {
	long pos = stell(s);
	int status = sseek(s, pos + n);

	*pskipped = stell(s) - pos;
	return status;
    }
    min_left = sbuf_min_left(s);
    while (sbufavailable(s) &lt; n + min_left) {
	int status;

	n -= sbufavailable(s);
	s-&gt;srptr = s-&gt;srlimit;
	if (s-&gt;end_status) {
	    *pskipped = nskip - n;
	    return s-&gt;end_status;
	}
	status = sgetc(s);
	if (status &lt; 0) {
	    *pskipped = nskip - n;
	    return status;
	}
	--n;
    }
    /* Note that if min_left &gt; 0, n &lt; 0 is possible; this is harmless. */
    s-&gt;srptr += n;
    *pskipped = nskip;
    return 0;
}

/* Read a line from a stream.  See srdline.h for the specification. */
int
sreadline(stream *s_in, stream *s_out, void *readline_data,
	  gs_const_string *prompt, gs_string * buf,
	  gs_memory_t * bufmem, uint * pcount, bool *pin_eol,
	  bool (*is_stdin)(const stream *))
{
    uint count = *pcount;

    /* Most systems define \n as 0xa and \r as 0xd; however, */
    /* OS-9 has \n == \r == 0xd and \l == 0xa.  The following */
    /* code works properly regardless of environment. */
#if '\n' == '\r'
#  define LF 0xa
#else
#  define LF '\n'
#endif

    if (count == 0 &amp;&amp; s_out &amp;&amp; prompt) {
	uint ignore_n;
	int ch = sputs(s_out, prompt-&gt;data, prompt-&gt;size, &amp;ignore_n);

	if (ch &lt; 0)
	    return ch;
    }

top:
    if (*pin_eol) {
	/*
	 * We're in the middle of checking for a two-character
	 * end-of-line sequence.  If we get an EOF here, stop, but
	 * don't signal EOF now; wait till the next read.
	 */
	int ch = spgetcc(s_in, false);

	if (ch == EOFC) {
	    *pin_eol = false;
	    return 0;
	} else if (ch &lt; 0)
	    return ch;
	else if (ch != LF)
	    sputback(s_in);
	*pin_eol = false;
	return 0;
    }
    for (;;) {
	int ch = sgetc(s_in);

	if (ch &lt; 0) {		/* EOF or exception */
	    *pcount = count;
	    return ch;
	}
	switch (ch) {
	    case '\r':
		{
#if '\n' == '\r'		/* OS-9 or similar */
		    if (!is_stdin(s_in))
#endif
		    {
			*pcount = count;
			*pin_eol = true;
			goto top;
		    }
		}
		/* falls through */
	    case LF:
#undef LF
		*pcount = count;
		return 0;
	}
	if (count &gt;= buf-&gt;size) {	/* filled the string */
	    if (!bufmem) {
		sputback(s_in);
		*pcount = count;
		return 1;
	    }
	    {
		uint nsize = count + max(count, 20);
		byte *ndata = gs_resize_string(bufmem, buf-&gt;data, buf-&gt;size,
					       nsize, "sreadline(buffer)");

		if (ndata == 0)
		    return ERRC; /* no better choice */
		buf-&gt;data = ndata;
		buf-&gt;size = nsize;
	    }
	}
	buf-&gt;data[count++] = ch;
    }
    /*return 0; *//* not reached */
}

/* ------ Utilities ------ */

/*
 * Attempt to refill the buffer of a read stream.  Only call this if the
 * end_status is not EOFC, and if the buffer is (nearly) empty.
 */
int
s_process_read_buf(stream * s)
{
    int status;

    stream_compact(s, false);
    status = sreadbuf(s, &amp;s-&gt;cursor.w);
    s-&gt;end_status = (status &gt;= 0 ? 0 : status);
    return 0;
}

/*
 * Attempt to empty the buffer of a write stream.  Only call this if the
 * end_status is not EOFC.
 */
int
s_process_write_buf(stream * s, bool last)
{
    int status = swritebuf(s, &amp;s-&gt;cursor.r, last);

    stream_compact(s, false);
    return (status &gt;= 0 ? 0 : status);
}

/* Move forward or backward in a pipeline.  We temporarily reverse */
/* the direction of the pointers while doing this. */
/* (Cf the Deutsch-Schorr-Waite graph marking algorithm.) */
#define MOVE_BACK(curr, prev)\
  BEGIN\
    stream *back = prev-&gt;strm;\
    prev-&gt;strm = curr; curr = prev; prev = back;\
  END
#define MOVE_AHEAD(curr, prev)\
  BEGIN\
    stream *ahead = curr-&gt;strm;\
    curr-&gt;strm = prev; prev = curr; curr = ahead;\
  END

/*
 * Read from a stream pipeline.  Update end_status for all streams that were
 * actually touched.  Return the status from the outermost stream: this is
 * normally the same as s-&gt;end_status, except that if s-&gt;procs.process
 * returned 1, sreadbuf sets s-&gt;end_status to 0, but returns 1.
 */
private int
sreadbuf(stream * s, stream_cursor_write * pbuf)
{
    stream *prev = 0;
    stream *curr = s;
    int status;

    for (;;) {
	stream *strm;
	stream_cursor_write *pw;
	byte *oldpos;

	for (;;) {		/* Descend into the recursion. */
	    stream_cursor_read cr;
	    stream_cursor_read *pr;
	    int left;
	    bool eof;

	    strm = curr-&gt;strm;
	    if (strm == 0) {
		cr.ptr = 0, cr.limit = 0;
		pr = &amp;cr;
		left = 0;
		eof = false;
	    } else {
		pr = &amp;strm-&gt;cursor.r;
		left = sbuf_min_left(strm);
		left = min(left, pr-&gt;limit - pr-&gt;ptr);
		pr-&gt;limit -= left;
		eof = strm-&gt;end_status == EOFC;
	    }
	    pw = (prev == 0 ? pbuf : &amp;curr-&gt;cursor.w);
	    if_debug4('s', "[s]read process 0x%lx, nr=%u, nw=%u, eof=%d\n",
		      (ulong) curr, (uint) (pr-&gt;limit - pr-&gt;ptr),
		      (uint) (pw-&gt;limit - pw-&gt;ptr), eof);
	    oldpos = pw-&gt;ptr;
	    status = (*curr-&gt;procs.process) (curr-&gt;state, pr, pw, eof);
	    pr-&gt;limit += left;
	    if_debug5('s', "[s]after read 0x%lx, nr=%u, nw=%u, status=%d, position=%d\n",
		      (ulong) curr, (uint) (pr-&gt;limit - pr-&gt;ptr),
		      (uint) (pw-&gt;limit - pw-&gt;ptr), status, s-&gt;position);
	    if (strm == 0 || status != 0)
		break;
	    if (strm-&gt;end_status &lt; 0) {
		if (strm-&gt;end_status != EOFC || pw-&gt;ptr == oldpos)
		    status = strm-&gt;end_status;
		break;
	    }
	    MOVE_AHEAD(curr, prev);
	    stream_compact(curr, false);
	}
	/* If curr reached EOD and is a filter or file stream, close it. */
	/* (see PLRM 3rd, sec 3.8.2, p80) */
	if ((strm != 0 || curr-&gt;file) &amp;&amp; status == EOFC &amp;&amp;
	    curr-&gt;cursor.r.ptr &gt;= curr-&gt;cursor.r.limit &amp;&amp;
	    curr-&gt;close_at_eod
	    ) {
	    int cstat = sclose(curr);

	    if (cstat != 0)
		status = cstat;
	}
	/* Unwind from the recursion. */
	curr-&gt;end_status = (status &gt;= 0 ? 0 : status);
	if (prev == 0)
	    return status;
	MOVE_BACK(curr, prev);
    }
}

/* Write to a pipeline. */
private int
swritebuf(stream * s, stream_cursor_read * pbuf, bool last)
{
    stream *prev = 0;
    stream *curr = s;
    int depth = 0;		/* # of non-temp streams before curr */
    int status;

    /*
     * The handling of EOFC is a little tricky.  There are two
     * invariants that keep it straight:
     *      - We only pass last = true to a stream if either it is
     * the first stream in the pipeline, or it is a temporary stream
     * below the first stream and the stream immediately above it has
     * end_status = EOFC.
     */
    for (;;) {
	for (;;) {
	    /* Move ahead in the pipeline. */
	    stream *strm = curr-&gt;strm;
	    stream_cursor_write cw;
	    stream_cursor_read *pr;
	    stream_cursor_write *pw;

	    /*
	     * We only want to set the last/end flag for
	     * the top-level stream and any temporary streams
	     * immediately below it.
	     */
	    bool end = last &amp;&amp;
		(prev == 0 ||
		 (depth &lt;= 1 &amp;&amp; prev-&gt;end_status == EOFC));

	    if (strm == 0)
		cw.ptr = 0, cw.limit = 0, pw = &amp;cw;
	    else
		pw = &amp;strm-&gt;cursor.w;
	    if (prev == 0)
		pr = pbuf;
	    else
		pr = &amp;curr-&gt;cursor.r;
	    if_debug5('s',
		      "[s]write process 0x%lx(%s), nr=%u, nw=%u, end=%d\n",
		      (ulong)curr,
		      gs_struct_type_name(curr-&gt;state-&gt;template-&gt;stype),
		      (uint)(pr-&gt;limit - pr-&gt;ptr),
		      (uint)(pw-&gt;limit - pw-&gt;ptr), end);
	    status = curr-&gt;end_status;
	    if (status &gt;= 0) {
		status = (*curr-&gt;procs.process)(curr-&gt;state, pr, pw, end);
		if_debug5('s',
			  "[s]after write 0x%lx, nr=%u, nw=%u, end=%d, status=%d\n",
			  (ulong) curr, (uint) (pr-&gt;limit - pr-&gt;ptr),
			  (uint) (pw-&gt;limit - pw-&gt;ptr), end, status);
		if (status == 0 &amp;&amp; end)
		    status = EOFC;
		if (status == EOFC || status == ERRC)
		    curr-&gt;end_status = status;
	    }
	    if (strm == 0 || (status &lt; 0 &amp;&amp; status != EOFC))
		break;
	    if (status != 1) {
		/*
		 * Keep going if we are closing a filter with a sub-stream.
		 * We know status == 0 or EOFC.
		 */
		if (!end || !strm-&gt;is_temp)
		    break;
	    }
	    status = strm-&gt;end_status;
	    if (status &lt; 0)
		break;
	    if (!curr-&gt;is_temp)
		++depth;
	    if_debug1('s', "[s]moving ahead, depth = %d\n", depth);
	    MOVE_AHEAD(curr, prev);
	    stream_compact(curr, false);
	}
	/* Move back in the pipeline. */
	curr-&gt;end_status = (status &gt;= 0 ? 0 : status);
	if (status &lt; 0 || prev == 0) {
	    /*
	     * All streams up to here were called with last = true
	     * and returned 0 or EOFC (so their end_status is now EOFC):
	     * finish unwinding and then return.  Change the status of
	     * the prior streams to ERRC if the new status is ERRC,
	     * otherwise leave it alone.
	     */
	    while (prev) {
		if_debug0('s', "[s]unwinding\n");
		MOVE_BACK(curr, prev);
		if (status &gt;= 0)
		    curr-&gt;end_status = 0;
		else if (status == ERRC)
		    curr-&gt;end_status = ERRC;
	    }
	    return status;
	}
	MOVE_BACK(curr, prev);
	if (!curr-&gt;is_temp)
	    --depth;
	if_debug1('s', "[s]moving back, depth = %d\n", depth);
    }
}

/* Move as much data as possible from one buffer to another. */
/* Return 0 if the input became empty, 1 if the output became full. */
int
stream_move(stream_cursor_read * pr, stream_cursor_write * pw)
{
    uint rcount = pr-&gt;limit - pr-&gt;ptr;
    uint wcount = pw-&gt;limit - pw-&gt;ptr;
    uint count;
    int status;

    if (rcount &lt;= wcount)
	count = rcount, status = 0;
    else
	count = wcount, status = 1;
    memmove(pw-&gt;ptr + 1, pr-&gt;ptr + 1, count);
    pr-&gt;ptr += count;
    pw-&gt;ptr += count;
    return status;
}

/* If possible, compact the information in a stream buffer to the bottom. */
private void
stream_compact(stream * s, bool always)
{
    if (s-&gt;cursor.r.ptr &gt;= s-&gt;cbuf &amp;&amp; (always || s-&gt;end_status &gt;= 0)) {
	uint dist = s-&gt;cursor.r.ptr + 1 - s-&gt;cbuf;

	memmove(s-&gt;cbuf, s-&gt;cursor.r.ptr + 1,
		(uint) (s-&gt;cursor.r.limit - s-&gt;cursor.r.ptr));
	s-&gt;cursor.r.ptr = s-&gt;cbuf - 1;
	s-&gt;cursor.r.limit -= dist;	/* same as w.ptr */
	s-&gt;position += dist;
    }
}

/* ------ String streams ------ */

/* String stream procedures */
private int
    s_string_available(stream *, long *),
    s_string_read_seek(stream *, long),
    s_string_write_seek(stream *, long),
    s_string_read_process(stream_state *, stream_cursor_read *,
			  stream_cursor_write *, bool),
    s_string_write_process(stream_state *, stream_cursor_read *,
			   stream_cursor_write *, bool);

/* Initialize a stream for reading a string. */
void
sread_string(register stream *s, const byte *ptr, uint len)
{
    static const stream_procs p = {
	 s_string_available, s_string_read_seek, s_std_read_reset,
	 s_std_read_flush, s_std_null, s_string_read_process
    };

    s_std_init(s, (byte *)ptr, len, &amp;p, s_mode_read + s_mode_seek);
    s-&gt;cbuf_string.data = (byte *)ptr;
    s-&gt;cbuf_string.size = len;
    s-&gt;end_status = EOFC;
    s-&gt;srlimit = s-&gt;swlimit;
}
/* Initialize a reusable stream for reading a string. */
private void
s_string_reusable_reset(stream *s)
{
    s-&gt;srptr = s-&gt;cbuf - 1;	/* just reset to the beginning */
    s-&gt;srlimit = s-&gt;srptr + s-&gt;bsize;  /* might have gotten reset */
}
private int
s_string_reusable_flush(stream *s)
{
    s-&gt;srptr = s-&gt;srlimit = s-&gt;cbuf + s-&gt;bsize - 1;  /* just set to the end */
    return 0;
}
void
sread_string_reusable(stream *s, const byte *ptr, uint len)
{
    static const stream_procs p = {
	 s_string_available, s_string_read_seek, s_string_reusable_reset,
	 s_string_reusable_flush, s_std_null, s_string_read_process
    };

    sread_string(s, ptr, len);
    s-&gt;procs = p;
    s-&gt;close_at_eod = false;
}

/* Return the number of available bytes when reading from a string. */
private int
s_string_available(stream *s, long *pl)
{
    *pl = sbufavailable(s);
    if (*pl == 0 &amp;&amp; s-&gt;close_at_eod)	/* EOF */
	*pl = -1;
    return 0;
}

/* Seek in a string being read.  Return 0 if OK, ERRC if not. */
private int
s_string_read_seek(register stream * s, long pos)
{
    if (pos &lt; 0 || pos &gt; s-&gt;bsize)
	return ERRC;
    s-&gt;srptr = s-&gt;cbuf + pos - 1;
    /* We might be seeking after a reusable string reached EOF. */
    s-&gt;srlimit = s-&gt;cbuf + s-&gt;bsize - 1;
    /* 
     * When the file reaches EOF,
     * stream_compact sets s-&gt;position to its end. 
     * Reset it now to allow stell to work properly
     * after calls to this function.
     * Note that if the riched EOF and this fuction
     * was not called, stell still returns a wrong value.
     */
    s-&gt;position = 0;
    return 0;
}

/* Initialize a stream for writing a string. */
void
swrite_string(register stream * s, byte * ptr, uint len)
{
    static const stream_procs p = {
	s_std_noavailable, s_string_write_seek, s_std_write_reset,
	s_std_null, s_std_null, s_string_write_process
    };

    s_std_init(s, ptr, len, &amp;p, s_mode_write + s_mode_seek);
    s-&gt;cbuf_string.data = ptr;
    s-&gt;cbuf_string.size = len;
}

/* Seek in a string being written.  Return 0 if OK, ERRC if not. */
private int
s_string_write_seek(register stream * s, long pos)
{
    if (pos &lt; 0 || pos &gt; s-&gt;bsize)
	return ERRC;
    s-&gt;swptr = s-&gt;cbuf + pos - 1;
    return 0;
}

/* Since we initialize the input buffer of a string read stream */
/* to contain all of the data in the string, if we are ever asked */
/* to refill the buffer, we should signal EOF. */
private int
s_string_read_process(stream_state * st, stream_cursor_read * ignore_pr,
		      stream_cursor_write * pw, bool last)
{
    return EOFC;
}
/* Similarly, if we are ever asked to empty the buffer, it means that */
/* there has been an overrun (unless we are closing the stream). */
private int
s_string_write_process(stream_state * st, stream_cursor_read * pr,
		       stream_cursor_write * ignore_pw, bool last)
{
    return (last ? EOFC : ERRC);
}

/* ------ Position-tracking stream ------ */

private int
    s_write_position_process(stream_state *, stream_cursor_read *,
			     stream_cursor_write *, bool);

/* Set up a write stream that just keeps track of the position. */
void
swrite_position_only(stream *s)
{
    static byte discard_buf[50];	/* size is arbitrary */

    swrite_string(s, discard_buf, sizeof(discard_buf));
    s-&gt;procs.process = s_write_position_process;
}

private int
s_write_position_process(stream_state * st, stream_cursor_read * pr,
			 stream_cursor_write * ignore_pw, bool last)
{
    pr-&gt;ptr = pr-&gt;limit;	/* discard data */
    return 0;
}

/* ------ Filter pipelines ------ */

/*
 * Add a filter to an output pipeline.  The client must have allocated the
 * stream state, if any, using the given allocator.  For s_init_filter, the
 * client must have called s_init and s_init_state.
 */
int
s_init_filter(stream *fs, stream_state *fss, byte *buf, uint bsize,
	      stream *target)
{
    const stream_template *template = fss-&gt;template;

    if (bsize &lt; template-&gt;min_in_size)
	return ERRC;
    s_std_init(fs, buf, bsize, &amp;s_filter_write_procs, s_mode_write);
    fs-&gt;procs.process = template-&gt;process;
    fs-&gt;state = fss;
    if (template-&gt;init) {
	fs-&gt;end_status = (template-&gt;init)(fss);
	if (fs-&gt;end_status &lt; 0)
	    return fs-&gt;end_status;
    }
    fs-&gt;strm = target;
    return 0;
}
stream *
s_add_filter(stream **ps, const stream_template *template,
	     stream_state *ss, gs_memory_t *mem)
{
    stream *es;
    stream_state *ess;
    uint bsize = max(template-&gt;min_in_size, 256);	/* arbitrary */
    byte *buf;

    /*
     * Ensure enough buffering.  This may require adding an additional
     * stream.
     */
    if (bsize &gt; (*ps)-&gt;bsize &amp;&amp; template-&gt;process != s_NullE_template.process) {
	stream_template null_template;

	null_template = s_NullE_template;
	null_template.min_in_size = bsize;
	if (s_add_filter(ps, &amp;null_template, NULL, mem) == 0)
	    return 0;
    }
    es = s_alloc(mem, "s_add_filter(stream)");
    buf = gs_alloc_bytes(mem, bsize, "s_add_filter(buf)");
    if (es == 0 || buf == 0) {
	gs_free_object(mem, buf, "s_add_filter(buf)");
	gs_free_object(mem, es, "s_add_filter(stream)");
	return 0;
    }
    ess = (ss == 0 ? (stream_state *)es : ss);
    ess-&gt;template = template;
    ess-&gt;memory = mem;
    es-&gt;memory = mem;
    if (s_init_filter(es, ess, buf, bsize, *ps) &lt; 0)
	return 0;
    *ps = es;
    return es;
}

/*
 * Close the filters in a pipeline, up to a given target stream, freeing
 * their buffers and state structures.
 */
int
s_close_filters(stream **ps, stream *target)
{
    while (*ps != target) {
	stream *s = *ps;
	gs_memory_t *mem = s-&gt;state-&gt;memory;
	byte *sbuf = s-&gt;cbuf;
	stream *next = s-&gt;strm;
	int status = sclose(s);
	stream_state *ss = s-&gt;state; /* sclose may set this to s */

	if (status &lt; 0)
	    return status;
	if (mem) {
	    gs_free_object(mem, sbuf, "s_close_filters(buf)");
	    gs_free_object(mem, s, "s_close_filters(stream)");
	    if (ss != (stream_state *)s)
		gs_free_object(mem, ss, "s_close_filters(state)");
	}
	*ps = next;
    }
    return 0;
}

/* ------ NullEncode/Decode ------ */

/* Process a buffer */
private int
s_Null_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    return stream_move(pr, pw);
}

/* Stream template */
const stream_template s_NullE_template = {
    &amp;st_stream_state, NULL, s_Null_process, 1, 1
};
const stream_template s_NullD_template = {
    &amp;st_stream_state, NULL, s_Null_process, 1, 1
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

