<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zcie.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zcie.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1992, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zcie.c,v 1.13 2005/07/28 15:24:29 alexcher Exp $ */
/* CIE color operators */
#include "math_.h"
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gsstruct.h"
#include "gxcspace.h"		/* gscolor2.h requires gscspace.h */
#include "gscolor2.h"
#include "gscie.h"
#include "estack.h"
#include "ialloc.h"
#include "idict.h"
#include "idparam.h"
#include "igstate.h"
#include "icie.h"
#include "isave.h"
#include "ivmspace.h"
#include "store.h"		/* for make_null */

/* Empty procedures */
static const ref empty_procs[4] =
{
    empty_ref_data(t_array, a_readonly | a_executable),
    empty_ref_data(t_array, a_readonly | a_executable),
    empty_ref_data(t_array, a_readonly | a_executable),
    empty_ref_data(t_array, a_readonly | a_executable)
};

/* ------ Parameter extraction utilities ------ */

/* Get a range array parameter from a dictionary. */
/* We know that count &lt;= 4. */
int
dict_ranges_param(const gs_memory_t *mem,
		  const ref * pdref, const char *kstr, int count,
		  gs_range * prange)
{
    int code = dict_floats_param(mem, pdref, kstr, count * 2,
				 (float *)prange, NULL);

    if (code &lt; 0)
	return code;
    else if (code == 0)
	memcpy(prange, Range4_default.ranges, count * sizeof(gs_range));
    return 0;
}

/* Get an array of procedures from a dictionary. */
/* We know count &lt;= countof(empty_procs). */
int
dict_proc_array_param(const gs_memory_t *mem,
		      const ref *pdict, const char *kstr,
		      uint count, ref *pparray)
{
    ref *pvalue;

    if (dict_find_string(pdict, kstr, &amp;pvalue) &gt; 0) {
	uint i;

	check_array_only(*pvalue);
	if (r_size(pvalue) != count)
	    return_error(e_rangecheck);
	for (i = 0; i &lt; count; i++) {
	    ref proc;

	    array_get(mem, pvalue, (long)i, &amp;proc);
	    check_proc_only(proc);
	}
	*pparray = *pvalue;
    } else
	make_const_array(pparray, a_readonly | avm_foreign,
			 count, &amp;empty_procs[0]);
    return 0;
}

/* Get 3 ranges from a dictionary. */
int
dict_range3_param(const gs_memory_t *mem,
		  const ref *pdref, const char *kstr, 
		  gs_range3 *prange3)
{
    return dict_ranges_param(mem, pdref, kstr, 3, prange3-&gt;ranges);
}

/* Get a 3x3 matrix from a dictionary. */
int
dict_matrix3_param(const gs_memory_t *mem,
		   const ref *pdref, const char *kstr, gs_matrix3 *pmat3)
{
    /*
     * We can't simply call dict_float_array_param with the matrix
     * cast to a 9-element float array, because compilers may insert
     * padding elements after each of the vectors.  However, we can be
     * confident that there is no padding within a single vector.
     */
    float values[9], defaults[9];
    int code;

    memcpy(&amp;defaults[0], &amp;Matrix3_default.cu, 3 * sizeof(float));
    memcpy(&amp;defaults[3], &amp;Matrix3_default.cv, 3 * sizeof(float));
    memcpy(&amp;defaults[6], &amp;Matrix3_default.cw, 3 * sizeof(float));
    code = dict_floats_param(mem, pdref, kstr, 9, values, defaults);
    if (code &lt; 0)
	return code;
    memcpy(&amp;pmat3-&gt;cu, &amp;values[0], 3 * sizeof(float));
    memcpy(&amp;pmat3-&gt;cv, &amp;values[3], 3 * sizeof(float));
    memcpy(&amp;pmat3-&gt;cw, &amp;values[6], 3 * sizeof(float));
    return 0;
}

/* Get 3 procedures from a dictionary. */
int
dict_proc3_param(const gs_memory_t *mem, const ref *pdref, const char *kstr, ref proc3[3])
{
    return dict_proc_array_param(mem, pdref, kstr, 3, proc3);
}

/* Get WhitePoint and BlackPoint values. */
int
cie_points_param(const gs_memory_t *mem, 
		 const ref * pdref, gs_cie_wb * pwb)
{
    int code;

    if ((code = dict_floats_param(mem, pdref, "WhitePoint", 3, (float *)&amp;pwb-&gt;WhitePoint, NULL)) &lt; 0 ||
	(code = dict_floats_param(mem, pdref, "BlackPoint", 3, (float *)&amp;pwb-&gt;BlackPoint, (const float *)&amp;BlackPoint_default)) &lt; 0
	)
	return code;
    if (pwb-&gt;WhitePoint.u &lt;= 0 ||
	pwb-&gt;WhitePoint.v != 1 ||
	pwb-&gt;WhitePoint.w &lt;= 0 ||
	pwb-&gt;BlackPoint.u &lt; 0 ||
	pwb-&gt;BlackPoint.v &lt; 0 ||
	pwb-&gt;BlackPoint.w &lt; 0
	)
	return_error(e_rangecheck);
    return 0;
}

/* Process a 3- or 4-dimensional lookup table from a dictionary. */
/* The caller has set pclt-&gt;n and pclt-&gt;m. */
/* ptref is known to be a readable array of size at least n+1. */
private int cie_3d_table_param(const ref * ptable, uint count, uint nbytes,
			       gs_const_string * strings);
int
cie_table_param(const ref * ptref, gx_color_lookup_table * pclt,
		gs_memory_t * mem)
{
    int n = pclt-&gt;n, m = pclt-&gt;m;
    const ref *pta = ptref-&gt;value.const_refs;
    int i;
    uint nbytes;
    int code;
    gs_const_string *table;

    for (i = 0; i &lt; n; ++i) {
	check_type_only(pta[i], t_integer);
	if (pta[i].value.intval &lt;= 1 || pta[i].value.intval &gt; max_ushort)
	    return_error(e_rangecheck);
	pclt-&gt;dims[i] = (int)pta[i].value.intval;
    }
    nbytes = m * pclt-&gt;dims[n - 2] * pclt-&gt;dims[n - 1];
    if (n == 3) {
	table =
	    gs_alloc_struct_array(mem, pclt-&gt;dims[0], gs_const_string,
				  &amp;st_const_string_element, "cie_table_param");
	if (table == 0)
	    return_error(e_VMerror);
	code = cie_3d_table_param(pta + 3, pclt-&gt;dims[0], nbytes, table);
    } else {			/* n == 4 */
	int d0 = pclt-&gt;dims[0], d1 = pclt-&gt;dims[1];
	uint ntables = d0 * d1;
	const ref *psuba;

	check_read_type(pta[4], t_array);
	if (r_size(pta + 4) != d0)
	    return_error(e_rangecheck);
	table =
	    gs_alloc_struct_array(mem, ntables, gs_const_string,
				  &amp;st_const_string_element, "cie_table_param");
	if (table == 0)
	    return_error(e_VMerror);
	psuba = pta[4].value.const_refs;
	/*
	 * We know that d0 &gt; 0, so code will always be set in the loop:
	 * we initialize code to 0 here solely to pacify stupid compilers.
	 */
	for (code = 0, i = 0; i &lt; d0; ++i) {
	    code = cie_3d_table_param(psuba + i, d1, nbytes, table + d1 * i);
	    if (code &lt; 0)
		break;
	}
    }
    if (code &lt; 0) {
	gs_free_object(mem, table, "cie_table_param");
	return code;
    }
    pclt-&gt;table = table;
    return 0;
}
private int
cie_3d_table_param(const ref * ptable, uint count, uint nbytes,
		   gs_const_string * strings)
{
    const ref *rstrings;
    uint i;

    check_read_type(*ptable, t_array);
    if (r_size(ptable) != count)
	return_error(e_rangecheck);
    rstrings = ptable-&gt;value.const_refs;
    for (i = 0; i &lt; count; ++i) {
	const ref *const prt2 = rstrings + i;

	check_read_type(*prt2, t_string);
	if (r_size(prt2) != nbytes)
	    return_error(e_rangecheck);
	strings[i].data = prt2-&gt;value.const_bytes;
	strings[i].size = nbytes;
    }
    return 0;
}

/* ------ CIE setcolorspace ------ */

/* Common code for the CIEBased* cases of setcolorspace. */
private int
cie_lmnp_param(const gs_memory_t *mem, const ref * pdref, gs_cie_common * pcie, ref_cie_procs * pcprocs)
{
    int code;

    if ((code = dict_range3_param(mem, pdref, "RangeLMN", &amp;pcie-&gt;RangeLMN)) &lt; 0 ||
	(code = dict_proc3_param(mem, pdref, "DecodeLMN", &amp;pcprocs-&gt;DecodeLMN)) &lt; 0 ||
	(code = dict_matrix3_param(mem, pdref, "MatrixLMN", &amp;pcie-&gt;MatrixLMN)) &lt; 0 ||
	(code = cie_points_param(mem, pdref, &amp;pcie-&gt;points)) &lt; 0
	)
	return code;
    pcie-&gt;DecodeLMN = DecodeLMN_default;
    return 0;
}

/* Common code for the CIEBasedABC/DEF[G] cases of setcolorspace. */
private int
cie_abc_param(const gs_memory_t *mem, const ref * pdref, gs_cie_abc * pcie, ref_cie_procs * pcprocs)
{
    int code;

    if ((code = dict_range3_param(mem, pdref, "RangeABC", &amp;pcie-&gt;RangeABC)) &lt; 0 ||
	(code = dict_proc3_param(mem, pdref, "DecodeABC", &amp;pcprocs-&gt;Decode.ABC)) &lt; 0 ||
	(code = dict_matrix3_param(mem, pdref, "MatrixABC", &amp;pcie-&gt;MatrixABC)) &lt; 0 ||
	(code = cie_lmnp_param(mem, pdref, &amp;pcie-&gt;common, pcprocs)) &lt; 0
	)
	return code;
    pcie-&gt;DecodeABC = DecodeABC_default;
    return 0;
}

/* Finish setting a CIE space (successful or not). */
int
cie_set_finish(i_ctx_t *i_ctx_p, gs_color_space * pcs,
	       const ref_cie_procs * pcprocs, int edepth, int code)
{
    if (code &gt;= 0)
	code = gs_setcolorspace(igs, pcs);
    /* Delete the extra reference to the parameter tables. */
    gs_cspace_release(pcs);
    /* Free the top-level object, which was copied by gs_setcolorspace. */
    gs_free_object(gs_state_memory(igs), pcs, "cie_set_finish");
    if (code &lt; 0) {
	ref_stack_pop_to(&amp;e_stack, edepth);
	return code;
    }
    istate-&gt;colorspace.procs.cie = *pcprocs;
    pop(1);
    return (ref_stack_count(&amp;e_stack) == edepth ? 0 : o_push_estack);
}

/* Forward references */
private int cache_common(i_ctx_t *, gs_cie_common *, const ref_cie_procs *,
			 void *, gs_ref_memory_t *);
private int cache_abc_common(i_ctx_t *, gs_cie_abc *, const ref_cie_procs *,
			     void *, gs_ref_memory_t *);

/* &lt;dict&gt; .setciedefgspace - */
private int cie_defg_finish(i_ctx_t *);
private int
zsetciedefgspace(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int edepth = ref_stack_count(&amp;e_stack);
    gs_memory_t *mem = gs_state_memory(igs);
    gs_ref_memory_t *imem = (gs_ref_memory_t *)mem;
    gs_color_space *pcs;
    ref_cie_procs procs;
    gs_cie_defg *pcie;
    int code;
    ref *ptref;

    check_type(*op, t_dictionary);
    check_dict_read(*op);
    if ((code = dict_find_string(op, "Table", &amp;ptref)) &lt;= 0)
	return (code &lt; 0 ? code : gs_note_error(e_rangecheck));
    check_read_type(*ptref, t_array);
    if (r_size(ptref) != 5)
	return_error(e_rangecheck);
    procs = istate-&gt;colorspace.procs.cie;
    code = gs_cspace_build_CIEDEFG(&amp;pcs, NULL, mem);
    if (code &lt; 0)
	return code;
    pcie = pcs-&gt;params.defg;
    pcie-&gt;Table.n = 4;
    pcie-&gt;Table.m = 3;
    if ((code = dict_ranges_param(mem, op, "RangeDEFG", 4, pcie-&gt;RangeDEFG.ranges)) &lt; 0 ||
	(code = dict_proc_array_param(mem, op, "DecodeDEFG", 4, &amp;procs.PreDecode.DEFG)) &lt; 0 ||
	(code = dict_ranges_param(mem, op, "RangeHIJK", 4, pcie-&gt;RangeHIJK.ranges)) &lt; 0 ||
	(code = cie_table_param(ptref, &amp;pcie-&gt;Table, mem)) &lt; 0 ||
	(code = cie_abc_param(imemory, op, (gs_cie_abc *) pcie, &amp;procs)) &lt; 0 ||
	(code = cie_cache_joint(i_ctx_p, &amp;istate-&gt;colorrendering.procs, (gs_cie_common *)pcie, igs)) &lt; 0 ||	/* do this last */
	(code = cie_cache_push_finish(i_ctx_p, cie_defg_finish, imem, pcie)) &lt; 0 ||
	(code = cie_prepare_cache4(i_ctx_p, &amp;pcie-&gt;RangeDEFG,
				   procs.PreDecode.DEFG.value.const_refs,
				   &amp;pcie-&gt;caches_defg.DecodeDEFG[0],
				   pcie, imem, "Decode.DEFG")) &lt; 0 ||
	(code = cache_abc_common(i_ctx_p, (gs_cie_abc *)pcie, &amp;procs, pcie, imem)) &lt; 0
	)
	DO_NOTHING;
    return cie_set_finish(i_ctx_p, pcs, &amp;procs, edepth, code);
}
private int
cie_defg_finish(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_cie_defg *pcie = r_ptr(op, gs_cie_defg);

    pcie-&gt;DecodeDEFG = DecodeDEFG_from_cache;
    pcie-&gt;DecodeABC = DecodeABC_from_cache;
    pcie-&gt;common.DecodeLMN = DecodeLMN_from_cache;
    gs_cie_defg_complete(pcie);
    pop(1);
    return 0;
}

/* &lt;dict&gt; .setciedefspace - */
private int cie_def_finish(i_ctx_t *);
private int
zsetciedefspace(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int edepth = ref_stack_count(&amp;e_stack);
    gs_memory_t *mem = gs_state_memory(igs);
    gs_ref_memory_t *imem = (gs_ref_memory_t *)mem;
    gs_color_space *pcs;
    ref_cie_procs procs;
    gs_cie_def *pcie;
    int code;
    ref *ptref;

    check_type(*op, t_dictionary);
    check_dict_read(*op);
    if ((code = dict_find_string(op, "Table", &amp;ptref)) &lt;= 0)
	return (code &lt; 0 ? code : gs_note_error(e_rangecheck));
    check_read_type(*ptref, t_array);
    if (r_size(ptref) != 4)
	return_error(e_rangecheck);
    procs = istate-&gt;colorspace.procs.cie;
    code = gs_cspace_build_CIEDEF(&amp;pcs, NULL, mem);
    if (code &lt; 0)
	return code;
    pcie = pcs-&gt;params.def;
    pcie-&gt;Table.n = 3;
    pcie-&gt;Table.m = 3;
    if ((code = dict_range3_param(mem, op, "RangeDEF", &amp;pcie-&gt;RangeDEF)) &lt; 0 ||
	(code = dict_proc3_param(mem, op, "DecodeDEF", &amp;procs.PreDecode.DEF)) &lt; 0 ||
	(code = dict_range3_param(mem, op, "RangeHIJ", &amp;pcie-&gt;RangeHIJ)) &lt; 0 ||
	(code = cie_table_param(ptref, &amp;pcie-&gt;Table, mem)) &lt; 0 ||
	(code = cie_abc_param(imemory, op, (gs_cie_abc *) pcie, &amp;procs)) &lt; 0 ||
	(code = cie_cache_joint(i_ctx_p, &amp;istate-&gt;colorrendering.procs, (gs_cie_common *)pcie, igs)) &lt; 0 ||	/* do this last */
	(code = cie_cache_push_finish(i_ctx_p, cie_def_finish, imem, pcie)) &lt; 0 ||
	(code = cie_prepare_cache3(i_ctx_p, &amp;pcie-&gt;RangeDEF,
				   procs.PreDecode.DEF.value.const_refs,
				   &amp;pcie-&gt;caches_def.DecodeDEF[0],
				   pcie, imem, "Decode.DEF")) &lt; 0 ||
	(code = cache_abc_common(i_ctx_p, (gs_cie_abc *)pcie, &amp;procs, pcie, imem)) &lt; 0
	)
	DO_NOTHING;
    return cie_set_finish(i_ctx_p, pcs, &amp;procs, edepth, code);
}
private int
cie_def_finish(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_cie_def *pcie = r_ptr(op, gs_cie_def);

    pcie-&gt;DecodeDEF = DecodeDEF_from_cache;
    pcie-&gt;DecodeABC = DecodeABC_from_cache;
    pcie-&gt;common.DecodeLMN = DecodeLMN_from_cache;
    gs_cie_def_complete(pcie);
    pop(1);
    return 0;
}

/* &lt;dict&gt; .setcieabcspace - */
private int cie_abc_finish(i_ctx_t *);
private int
zsetcieabcspace(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int edepth = ref_stack_count(&amp;e_stack);
    gs_memory_t *mem = gs_state_memory(igs);
    gs_ref_memory_t *imem = (gs_ref_memory_t *)mem;
    gs_color_space *pcs;
    ref_cie_procs procs;
    gs_cie_abc *pcie;
    int code;

    check_type(*op, t_dictionary);
    check_dict_read(*op);
    procs = istate-&gt;colorspace.procs.cie;
    code = gs_cspace_build_CIEABC(&amp;pcs, NULL, mem);
    if (code &lt; 0)
	return code;
    pcie = pcs-&gt;params.abc;
    code = cie_abc_param(imemory, op, pcie, &amp;procs);
    if (code &lt; 0 ||
	(code = cie_cache_joint(i_ctx_p, &amp;istate-&gt;colorrendering.procs, (gs_cie_common *)pcie, igs)) &lt; 0 ||	/* do this last */
	(code = cie_cache_push_finish(i_ctx_p, cie_abc_finish, imem, pcie)) &lt; 0 ||
	(code = cache_abc_common(i_ctx_p, pcie, &amp;procs, pcie, imem)) &lt; 0
	)
	DO_NOTHING;
    return cie_set_finish(i_ctx_p, pcs, &amp;procs, edepth, code);
}
private int
cie_abc_finish(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_cie_abc *pcie = r_ptr(op, gs_cie_abc);

    pcie-&gt;DecodeABC = DecodeABC_from_cache;
    pcie-&gt;common.DecodeLMN = DecodeLMN_from_cache;
    gs_cie_abc_complete(pcie);
    pop(1);
    return 0;
}

/* &lt;dict&gt; .setcieaspace - */
private int cie_a_finish(i_ctx_t *);
private int
zsetcieaspace(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int edepth = ref_stack_count(&amp;e_stack);
    gs_memory_t *mem = gs_state_memory(igs);
    gs_ref_memory_t *imem = (gs_ref_memory_t *)mem;
    gs_color_space *pcs;
    ref_cie_procs procs;
    gs_cie_a *pcie;
    int code;

    check_type(*op, t_dictionary);
    check_dict_read(*op);
    procs = istate-&gt;colorspace.procs.cie;
    if ((code = dict_proc_param(op, "DecodeA", &amp;procs.Decode.A, true)) &lt; 0)
	return code;
    code = gs_cspace_build_CIEA(&amp;pcs, NULL, mem);
    if (code &lt; 0)
	return code;
    pcie = pcs-&gt;params.a;
    if ((code = dict_floats_param(imemory, op, "RangeA", 2, (float *)&amp;pcie-&gt;RangeA, (const float *)&amp;RangeA_default)) &lt; 0 ||
	(code = dict_floats_param(imemory, op, "MatrixA", 3, (float *)&amp;pcie-&gt;MatrixA, (const float *)&amp;MatrixA_default)) &lt; 0 ||
	(code = cie_lmnp_param(imemory, op, &amp;pcie-&gt;common, &amp;procs)) &lt; 0 ||
	(code = cie_cache_joint(i_ctx_p, &amp;istate-&gt;colorrendering.procs, (gs_cie_common *)pcie, igs)) &lt; 0 ||	/* do this last */
	(code = cie_cache_push_finish(i_ctx_p, cie_a_finish, imem, pcie)) &lt; 0 ||
	(code = cie_prepare_cache(i_ctx_p, &amp;pcie-&gt;RangeA, &amp;procs.Decode.A, &amp;pcie-&gt;caches.DecodeA.floats, pcie, imem, "Decode.A")) &lt; 0 ||
	(code = cache_common(i_ctx_p, &amp;pcie-&gt;common, &amp;procs, pcie, imem)) &lt; 0
	)
	DO_NOTHING;
    pcie-&gt;DecodeA = DecodeA_default;
    return cie_set_finish(i_ctx_p, pcs, &amp;procs, edepth, code);
}
private int
cie_a_finish(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_cie_a *pcie = r_ptr(op, gs_cie_a);

    pcie-&gt;DecodeA = DecodeA_from_cache;
    pcie-&gt;common.DecodeLMN = DecodeLMN_from_cache;
    gs_cie_a_complete(pcie);
    pop(1);
    return 0;
}

/* Common cache code */

private int
cache_abc_common(i_ctx_t *i_ctx_p, gs_cie_abc * pcie,
		 const ref_cie_procs * pcprocs,
		 void *container, gs_ref_memory_t * imem)
{
    int code =
	cie_prepare_cache3(i_ctx_p, &amp;pcie-&gt;RangeABC,
			   pcprocs-&gt;Decode.ABC.value.const_refs,
			   pcie-&gt;caches.DecodeABC.caches, pcie, imem,
			   "Decode.ABC");

    return (code &lt; 0 ? code :
	    cache_common(i_ctx_p, &amp;pcie-&gt;common, pcprocs, pcie, imem));
}

private int
cache_common(i_ctx_t *i_ctx_p, gs_cie_common * pcie,
	     const ref_cie_procs * pcprocs,
	     void *container, gs_ref_memory_t * imem)
{
    return cie_prepare_cache3(i_ctx_p, &amp;pcie-&gt;RangeLMN,
			      pcprocs-&gt;DecodeLMN.value.const_refs,
			      &amp;pcie-&gt;caches.DecodeLMN[0], container, imem,
			      "Decode.LMN");
}

/* ------ Internal routines ------ */

/* Prepare to cache the values for one or more procedures. */
private int cie_cache_finish1(i_ctx_t *);
private int cie_cache_finish(i_ctx_t *);
int
cie_prepare_cache(i_ctx_t *i_ctx_p, const gs_range * domain, const ref * proc,
		  cie_cache_floats * pcache, void *container,
		  gs_ref_memory_t * imem, client_name_t cname)
{
    int space = imemory_space(imem);
    gs_sample_loop_params_t lp;
    es_ptr ep;

    gs_cie_cache_init(&amp;pcache-&gt;params, &amp;lp, domain, cname);
    pcache-&gt;params.is_identity = r_size(proc) == 0;
    check_estack(9);
    ep = esp;
    make_real(ep + 9, lp.A);
    make_int(ep + 8, lp.N);
    make_real(ep + 7, lp.B);
    ep[6] = *proc;
    r_clear_attrs(ep + 6, a_executable);
    make_op_estack(ep + 5, zcvx);
    make_op_estack(ep + 4, zfor_samples);
    make_op_estack(ep + 3, cie_cache_finish);
    esp += 9;
    /*
     * The caches are embedded in the middle of other
     * structures, so we represent the pointer to the cache
     * as a pointer to the container plus an offset.
     */
    make_int(ep + 2, (char *)pcache - (char *)container);
    make_struct(ep + 1, space, container);
    return o_push_estack;
}
/* Note that pc3 may be 0, indicating that there are only 3 caches to load. */
int
cie_prepare_caches_4(i_ctx_t *i_ctx_p, const gs_range * domains,
		     const ref * procs,
		     cie_cache_floats * pc0, cie_cache_floats * pc1,
		     cie_cache_floats * pc2, cie_cache_floats * pc3,
		     void *container,
		     gs_ref_memory_t * imem, client_name_t cname)
{
    cie_cache_floats *pcn[4];
    int i, n, code = 0;

    pcn[0] = pc0, pcn[1] = pc1, pcn[2] = pc2;
    if (pc3 == 0)
	n = 3;
    else
	pcn[3] = pc3, n = 4;
    for (i = 0; i &lt; n &amp;&amp; code &gt;= 0; ++i)
	code = cie_prepare_cache(i_ctx_p, domains + i, procs + i, pcn[i],
				 container, imem, cname);
    return code;
}

/* Store the result of caching one procedure. */
private int
cie_cache_finish_store(i_ctx_t *i_ctx_p, bool replicate)
{
    os_ptr op = osp;
    cie_cache_floats *pcache;
    int code;

    check_esp(2);
    /* See above for the container + offset representation of */
    /* the pointer to the cache. */
    pcache = (cie_cache_floats *) (r_ptr(esp - 1, char) + esp-&gt;value.intval);

    pcache-&gt;params.is_identity = false;	/* cache_set_linear computes this */
    if_debug3('c', "[c]cache 0x%lx base=%g, factor=%g:\n",
	      (ulong) pcache, pcache-&gt;params.base, pcache-&gt;params.factor);
    if (replicate ||
	(code = float_params(op, gx_cie_cache_size, &amp;pcache-&gt;values[0])) &lt; 0
	) {
	/* We might have underflowed the current stack block. */
	/* Handle the parameters one-by-one. */
	uint i;

	for (i = 0; i &lt; gx_cie_cache_size; i++) {
	    code = float_param(ref_stack_index(&amp;o_stack,
			       (replicate ? 0 : gx_cie_cache_size - 1 - i)),
			       &amp;pcache-&gt;values[i]);
	    if (code &lt; 0)
		return code;
	}
    }
#ifdef DEBUG
    if (gs_debug_c('c')) {
	int i;

	for (i = 0; i &lt; gx_cie_cache_size; i += 4)
	    dlprintf5("[c]  cache[%3d]=%g, %g, %g, %g\n", i,
		      pcache-&gt;values[i], pcache-&gt;values[i + 1],
		      pcache-&gt;values[i + 2], pcache-&gt;values[i + 3]);
    }
#endif
    ref_stack_pop(&amp;o_stack, (replicate ? 1 : gx_cie_cache_size));
    esp -= 2;			/* pop pointer to cache */
    return o_pop_estack;
}
private int
cie_cache_finish(i_ctx_t *i_ctx_p)
{
    return cie_cache_finish_store(i_ctx_p, false);
}
private int
cie_cache_finish1(i_ctx_t *i_ctx_p)
{
    return cie_cache_finish_store(i_ctx_p, true);
}

/* Push a finishing procedure on the e-stack. */
/* ptr will be the top element of the o-stack. */
int
cie_cache_push_finish(i_ctx_t *i_ctx_p, op_proc_t finish_proc,
		      gs_ref_memory_t * imem, void *data)
{
    check_estack(2);
    push_op_estack(finish_proc);
    ++esp;
    make_struct(esp, imemory_space(imem), data);
    return o_push_estack;
}

/* ------ Initialization procedure ------ */

const op_def zcie_l2_op_defs[] =
{
    op_def_begin_level2(),
    {"1.setcieaspace", zsetcieaspace},
    {"1.setcieabcspace", zsetcieabcspace},
    {"1.setciedefspace", zsetciedefspace},
    {"1.setciedefgspace", zsetciedefgspace},
		/* Internal operators */
    {"1%cie_defg_finish", cie_defg_finish},
    {"1%cie_def_finish", cie_def_finish},
    {"1%cie_abc_finish", cie_abc_finish},
    {"1%cie_a_finish", cie_a_finish},
    {"0%cie_cache_finish", cie_cache_finish},
    {"1%cie_cache_finish1", cie_cache_finish1},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

