<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfapi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfapi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1991, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfapi.c,v 1.53 2004/10/05 12:45:29 igor Exp $ */
/* Font API client */

#include "memory_.h"
#include "string_.h"
#include "math_.h"
#include "ghost.h"
#include "gp.h"
#include "oper.h"
#include "gxdevice.h"
#include "gxfont.h"
#include "gxfont1.h"
#include "gxchar.h"
#include "gxpath.h"
#include "gxfcache.h"
#include "gxchrout.h"
#include "gscoord.h"
#include "gspaint.h"
#include "gsfont.h"
#include "gspath.h"
#include "bfont.h"
#include "dstack.h"
#include "ichar.h"
#include "idict.h"
#include "iddict.h"
#include "idparam.h"
#include "iname.h"
#include "ifont.h"
#include "icid.h"
#include "igstate.h"
#include "icharout.h"
#include "ifapi.h"
#include "iplugin.h"
#include "store.h"
#include "gzstate.h"
#include "gdevpsf.h"
#include "stream.h"		/* for files.h */
#include "files.h"
#include "gscrypt1.h"
#include "gxfcid.h"

/* -------------------------------------------------------- */

typedef struct FAPI_outline_handler_s {
    struct gx_path_s *path;
    fixed x0, y0;
    bool close_path, need_close; /* This stuff fixes unclosed paths being rendered with UFST */
} FAPI_outline_handler;

private inline int import_shift(int x, int n)
{   return n &gt; 0 ? x &lt;&lt; n : x &gt;&gt; -n;
}

private inline int export_shift(int x, int n)
{   return n &gt; 0 ? x &gt;&gt; n : x &lt;&lt; -n;
}

private inline int fapi_round(double x)
{   return (int)(x + 0.5);
}

private int add_closepath(FAPI_path *I)
{   FAPI_outline_handler *olh = (FAPI_outline_handler *)I-&gt;olh;

    olh-&gt;need_close = false;
    return gx_path_close_subpath_notes(olh-&gt;path, 0);
}

private int add_move(FAPI_path *I, FracInt x, FracInt y)
{   FAPI_outline_handler *olh = (FAPI_outline_handler *)I-&gt;olh;
    int code;

    if (olh-&gt;need_close &amp;&amp; olh-&gt;close_path)
        if ((code = add_closepath(I)) &lt; 0)
	    return code;
    olh-&gt;need_close = false;
    return gx_path_add_point(olh-&gt;path, import_shift(x, I-&gt;shift) + olh-&gt;x0, -import_shift(y, I-&gt;shift) + olh-&gt;y0);
}

private int add_line(FAPI_path *I, FracInt x, FracInt y)
{   FAPI_outline_handler *olh = (FAPI_outline_handler *)I-&gt;olh;

    olh-&gt;need_close = true;
    return gx_path_add_line_notes(olh-&gt;path, import_shift(x, I-&gt;shift) + olh-&gt;x0, -import_shift(y, I-&gt;shift) + olh-&gt;y0, 0);
}

private int add_curve(FAPI_path *I, FracInt x0, FracInt y0, FracInt x1, FracInt y1, FracInt x2, FracInt y2)
{   FAPI_outline_handler *olh = (FAPI_outline_handler *)I-&gt;olh;

    olh-&gt;need_close = true;
    return gx_path_add_curve_notes(olh-&gt;path, import_shift(x0, I-&gt;shift) + olh-&gt;x0, -import_shift(y0, I-&gt;shift) + olh-&gt;y0, 
					      import_shift(x1, I-&gt;shift) + olh-&gt;x0, -import_shift(y1, I-&gt;shift) + olh-&gt;y0, 
					      import_shift(x2, I-&gt;shift) + olh-&gt;x0, -import_shift(y2, I-&gt;shift) + olh-&gt;y0, 0);
}

private FAPI_path path_interface_stub = { NULL, 0, add_move, add_line, add_curve, add_closepath };

private inline bool IsCIDFont(const gs_font_base *pbfont)
{   return (pbfont-&gt;FontType == ft_CID_encrypted ||
            pbfont-&gt;FontType == ft_CID_user_defined ||
            pbfont-&gt;FontType == ft_CID_TrueType);
    /* The font type 10 (ft_CID_user_defined) must not pass to FAPI. */
}

private inline bool IsType1GlyphData(const gs_font_base *pbfont)
{   return pbfont-&gt;FontType == ft_encrypted ||
           pbfont-&gt;FontType == ft_encrypted2 ||
           pbfont-&gt;FontType == ft_CID_encrypted;
}

/* -------------------------------------------------------- */

typedef struct sfnts_reader_s sfnts_reader;
struct sfnts_reader_s { 
    ref *sfnts;
    const gs_memory_t *memory;
    const byte *p;
    long index;
    uint offset;
    uint length;
    bool error;
    byte (*rbyte)(sfnts_reader *r);
    ushort (*rword)(sfnts_reader *r);
    ulong (*rlong)(sfnts_reader *r);
    void (*rstring)(sfnts_reader *r, byte *v, int length);
    void (*seek)(sfnts_reader *r, ulong pos);
};

private void sfnts_next_elem(sfnts_reader *r)
{   ref s;

    if (r-&gt;error)
        return;
    r-&gt;index++;
    r-&gt;error |= (array_get(r-&gt;memory, r-&gt;sfnts, r-&gt;index, &amp;s) &lt; 0);
    if (r-&gt;error)
        return;
    r-&gt;p = s.value.const_bytes;
    r-&gt;length = r_size(&amp;s) &amp; ~(uint)1; /* See Adobe Technical Note # 5012, section 4.2. */
    r-&gt;offset = 0;
}

private inline byte sfnts_reader_rbyte_inline(sfnts_reader *r)
{   if (r-&gt;offset &gt;= r-&gt;length)
        sfnts_next_elem(r);
    return (r-&gt;error ? 0 : r-&gt;p[r-&gt;offset++]);
}

private byte sfnts_reader_rbyte(sfnts_reader *r) /* old compiler compatibility */
{   return sfnts_reader_rbyte_inline(r);
}

private ushort sfnts_reader_rword(sfnts_reader *r)
{   return (sfnts_reader_rbyte_inline(r) &lt;&lt; 8) + sfnts_reader_rbyte_inline(r);
}

private ulong sfnts_reader_rlong(sfnts_reader *r)
{   return (sfnts_reader_rbyte_inline(r) &lt;&lt; 24) + (sfnts_reader_rbyte_inline(r) &lt;&lt; 16) + 
           (sfnts_reader_rbyte_inline(r) &lt;&lt; 8) + sfnts_reader_rbyte_inline(r);
}

private void sfnts_reader_rstring(sfnts_reader *r, byte *v, int length)
{   if (length &lt; 0)
        return;
    while (!r-&gt;error) {
        int l = min(length, r-&gt;length - r-&gt;offset);
        memcpy(v, r-&gt;p + r-&gt;offset, l);
        r-&gt;p += l;
        length -= l;
        if (length &lt;= 0)
            return;
        sfnts_next_elem(r);
    }
}

private void sfnts_reader_seek(sfnts_reader *r, ulong pos)
{   /* fixme : optimize */
    ulong skipped = 0;

    r-&gt;index = -1;
    sfnts_next_elem(r);
    while (skipped + r-&gt;length &lt; pos &amp;&amp; !r-&gt;error) {
        skipped += r-&gt;length;
        sfnts_next_elem(r);
    }
    r-&gt;offset = pos - skipped;
}

private void sfnts_reader_init(sfnts_reader *r, ref *pdr)
{   r-&gt;rbyte = sfnts_reader_rbyte;
    r-&gt;rword = sfnts_reader_rword;
    r-&gt;rlong = sfnts_reader_rlong;
    r-&gt;rstring = sfnts_reader_rstring;
    r-&gt;seek = sfnts_reader_seek;
    r-&gt;index = -1;
    r-&gt;error = false;
    if (r_type(pdr) != t_dictionary ||
        dict_find_string(pdr, "sfnts", &amp;r-&gt;sfnts) &lt;= 0)
        r-&gt;error = true;
    sfnts_next_elem(r);
}

/* -------------------------------------------------------- */

typedef struct sfnts_writer_s sfnts_writer;
struct sfnts_writer_s {
    byte *buf, *p;
    int buf_size;
    void (*wbyte)(sfnts_writer *w, byte v);
    void (*wword)(sfnts_writer *w, ushort v);
    void (*wlong)(sfnts_writer *w, ulong v);
    void (*wstring)(sfnts_writer *w, byte *v, int length);
};

private void sfnts_writer_wbyte(sfnts_writer *w, byte v)
{   if (w-&gt;buf + w-&gt;buf_size &lt; w-&gt;p + 1)
        return; /* safety */
    w-&gt;p[0] = v;
    w-&gt;p++;
}

private void sfnts_writer_wword(sfnts_writer *w, ushort v)
{   if (w-&gt;buf + w-&gt;buf_size &lt; w-&gt;p + 2)
        return; /* safety */
    w-&gt;p[0] = v / 256;
    w-&gt;p[1] = v % 256;
    w-&gt;p += 2;
}

private void sfnts_writer_wlong(sfnts_writer *w, ulong v)
{   if (w-&gt;buf + w-&gt;buf_size &lt; w-&gt;p + 4)
        return; /* safety */
    w-&gt;p[0] = v &gt;&gt; 24;
    w-&gt;p[1] = (v &gt;&gt; 16) &amp; 0xFF;
    w-&gt;p[2] = (v &gt;&gt;  8) &amp; 0xFF;
    w-&gt;p[3] = v &amp; 0xFF;
    w-&gt;p += 4;
}

private void sfnts_writer_wstring(sfnts_writer *w, byte *v, int length)
{   if (w-&gt;buf + w-&gt;buf_size &lt; w-&gt;p + length)
        return; /* safety */
    memcpy(w-&gt;p, v, length);
    w-&gt;p += length;
}

private const sfnts_writer sfnts_writer_stub = {
    0, 0, 0,
    sfnts_writer_wbyte,
    sfnts_writer_wword,
    sfnts_writer_wlong,
    sfnts_writer_wstring
};

/* -------------------------------------------------------- */

private inline bool sfnts_need_copy_table(byte *tag)
{ return memcmp(tag, "glyf", 4) &amp;&amp;
         memcmp(tag, "glyx", 4) &amp;&amp; /* Presents in files created by AdobePS5.dll Version 5.1.2 */
         memcmp(tag, "loca", 4) &amp;&amp;
         memcmp(tag, "locx", 4) &amp;&amp; /* Presents in files created by AdobePS5.dll Version 5.1.2 */
         memcmp(tag, "cmap", 4);
}

private void sfnt_copy_table(sfnts_reader *r, sfnts_writer *w, int length)
{   byte buf[1024];

    while (length &gt; 0 &amp;&amp; !r-&gt;error) {
        int l = min(length, sizeof(buf));
        r-&gt;rstring(r, buf, l);
        w-&gt;wstring(w, buf, l);
        length -= l;
    }
}

private ulong sfnts_copy_except_glyf(sfnts_reader *r, sfnts_writer *w)
{   /* Note : TTC is not supported and probably is unuseful for Type 42. */
    /* This skips glyf, loca and cmap from copying. */
    struct {
        byte tag[4];
        ulong checkSum, offset, offset_new, length;
    } tables[30];
    const ushort alignment = 4; /* Not sure, maybe 2 */
    ulong version = r-&gt;rlong(r);
    ushort num_tables = r-&gt;rword(r);
    ushort i, num_tables_new = 0;
    ushort searchRange, entrySelector = 0, rangeShift, v;
    ulong size_new = 12;

    r-&gt;rword(r); /* searchRange */
    r-&gt;rword(r); /* entrySelector */
    r-&gt;rword(r); /* rangeShift */
    for (i = 0; i &lt; num_tables; i++) {
        if (r-&gt;error)
            return 0;
        r-&gt;rstring(r, tables[i].tag, 4);
        tables[i].checkSum = r-&gt;rlong(r);
        tables[i].offset = r-&gt;rlong(r);
        tables[i].length = r-&gt;rlong(r);
        tables[i].offset_new = size_new;
        if (sfnts_need_copy_table(tables[i].tag)) {
            num_tables_new ++;
            size_new += (tables[i].length + alignment - 1) / alignment * alignment;
        }
    }
    size_new += num_tables_new * 16;
    if (w == 0)
        return size_new;

    searchRange = v = num_tables_new * 16;
    for (i = 0; v; i++) {
        v &gt;&gt;= 1;
        searchRange |= v;
        entrySelector++;
    }
    searchRange -= searchRange &gt;&gt; 1;
    rangeShift = num_tables_new * 16 - searchRange;

    w-&gt;wlong(w, version);
    w-&gt;wword(w, num_tables_new);
    w-&gt;wword(w, searchRange);
    w-&gt;wword(w, entrySelector);
    w-&gt;wword(w, rangeShift);
    for (i = 0; i &lt; num_tables; i++)
        if (sfnts_need_copy_table(tables[i].tag)) {
            w-&gt;wstring(w, tables[i].tag, 4);
            w-&gt;wlong(w, tables[i].checkSum);
            w-&gt;wlong(w, tables[i].offset_new + num_tables_new * 16);
            w-&gt;wlong(w, tables[i].length);
        }
    for (i = 0; i &lt; num_tables; i++)
        if (sfnts_need_copy_table(tables[i].tag)) {
            int k = tables[i].length;
            r-&gt;seek(r, tables[i].offset);
            if (r-&gt;error)
                return 0;
            if (w-&gt;p - w-&gt;buf != tables[i].offset_new + num_tables_new * 16)
                return 0; /* the algorithm consistency check */
            sfnt_copy_table(r, w, tables[i].length);
            for (; k &amp; (alignment - 1); k++)
                w-&gt;wbyte(w, 0);
        }
    return size_new;
}

private ulong true_type_size(ref *pdr)
{   sfnts_reader r;

    sfnts_reader_init(&amp;r, pdr);
    return sfnts_copy_except_glyf(&amp;r, 0);
}

private ushort FAPI_FF_serialize_tt_font(FAPI_font *ff, void *buf, int buf_size)
{   ref *pdr = (ref *)ff-&gt;client_font_data2;
    sfnts_reader r;
    sfnts_writer w = sfnts_writer_stub;

    w.buf_size = buf_size;
    w.buf = w.p = buf;
    sfnts_reader_init(&amp;r, pdr);
    if(!sfnts_copy_except_glyf(&amp;r, &amp;w))
        return 1;
    return r.error;
}

private inline ushort float_to_ushort(float v)
{   return (ushort)(v * 16); /* fixme : the scale may depend on renderer */
}

private ushort FAPI_FF_get_word(FAPI_font *ff, fapi_font_feature var_id, int index)
{   gs_font_type1 *pfont = (gs_font_type1 *)ff-&gt;client_font_data;
    ref *pdr = (ref *)ff-&gt;client_font_data2;

    switch((int)var_id) {
        case FAPI_FONT_FEATURE_Weight: return 0; /* wrong */
        case FAPI_FONT_FEATURE_ItalicAngle: return 0; /* wrong */
        case FAPI_FONT_FEATURE_IsFixedPitch: return 0; /* wrong */
        case FAPI_FONT_FEATURE_UnderLinePosition: return 0; /* wrong */
        case FAPI_FONT_FEATURE_UnderlineThickness: return 0; /* wrong */
        case FAPI_FONT_FEATURE_FontType: return (pfont-&gt;FontType == 2 ? 2 : 1);
        case FAPI_FONT_FEATURE_FontBBox: 
            switch (index) {
                case 0 : return (ushort)pfont-&gt;FontBBox.p.x;
                case 1 : return (ushort)pfont-&gt;FontBBox.p.y;
                case 2 : return (ushort)pfont-&gt;FontBBox.q.x;
                case 3 : return (ushort)pfont-&gt;FontBBox.q.y;
            }
            return 0;
        case FAPI_FONT_FEATURE_BlueValues_count: return pfont-&gt;data.BlueValues.count;
        case FAPI_FONT_FEATURE_BlueValues: return float_to_ushort(pfont-&gt;data.BlueValues.values[index]);
        case FAPI_FONT_FEATURE_OtherBlues_count: return pfont-&gt;data.OtherBlues.count;
        case FAPI_FONT_FEATURE_OtherBlues: return float_to_ushort(pfont-&gt;data.OtherBlues.values[index]);
        case FAPI_FONT_FEATURE_FamilyBlues_count: return pfont-&gt;data.FamilyBlues.count;
        case FAPI_FONT_FEATURE_FamilyBlues: return float_to_ushort(pfont-&gt;data.FamilyBlues.values[index]);
        case FAPI_FONT_FEATURE_FamilyOtherBlues_count: return pfont-&gt;data.FamilyOtherBlues.count;
        case FAPI_FONT_FEATURE_FamilyOtherBlues: return float_to_ushort(pfont-&gt;data.FamilyOtherBlues.values[index]);
        case FAPI_FONT_FEATURE_BlueShift: return float_to_ushort(pfont-&gt;data.BlueShift);
        case FAPI_FONT_FEATURE_BlueFuzz: return float_to_ushort(pfont-&gt;data.BlueShift);
        case FAPI_FONT_FEATURE_StdHW: return (pfont-&gt;data.StdHW.count == 0 ? 0 : float_to_ushort(pfont-&gt;data.StdHW.values[0])); /* UFST bug ? */
        case FAPI_FONT_FEATURE_StdVW: return (pfont-&gt;data.StdVW.count == 0 ? 0 : float_to_ushort(pfont-&gt;data.StdVW.values[0])); /* UFST bug ? */
        case FAPI_FONT_FEATURE_StemSnapH_count: return pfont-&gt;data.StemSnapH.count;
        case FAPI_FONT_FEATURE_StemSnapH: return float_to_ushort(pfont-&gt;data.StemSnapH.values[index]);
        case FAPI_FONT_FEATURE_StemSnapV_count: return pfont-&gt;data.StemSnapV.count;
        case FAPI_FONT_FEATURE_StemSnapV: return float_to_ushort(pfont-&gt;data.StemSnapV.values[index]);
        case FAPI_FONT_FEATURE_ForceBold: return pfont-&gt;data.ForceBold;
        case FAPI_FONT_FEATURE_LanguageGroup: return pfont-&gt;data.LanguageGroup;
        case FAPI_FONT_FEATURE_lenIV: return (ff-&gt;need_decrypt ? 0 : pfont-&gt;data.lenIV);
        case FAPI_FONT_FEATURE_Subrs_count: 
            {   ref *Private, *Subrs, *GlobalSubrs;
                int n1, n2;
                if (dict_find_string(pdr, "Private", &amp;Private) &lt;= 0)
                    return 0;
                if (dict_find_string(Private, "Subrs", &amp;Subrs) &lt;= 0)
                    Subrs = NULL;
                if (dict_find_string(Private, "GlobalSubrs", &amp;GlobalSubrs) &lt;= 0)
                    GlobalSubrs = NULL;
                n1 = (Subrs != NULL ? r_size(Subrs) : 0);
                n2 = (GlobalSubrs != NULL ? r_size(GlobalSubrs) : 0);
                /* trick : we return twice maximum of n1, n2 to pass both Subrs and GlobalSubrs in same array.
                */
                return (n1 &lt; n2 ? n2 : n1) * 2;
            }
    }
    return 0;
}

private ulong FAPI_FF_get_long(FAPI_font *ff, fapi_font_feature var_id, int index)
{   gs_font_type1 *pfont = (gs_font_type1 *)ff-&gt;client_font_data;
    ref *pdr = (ref *)ff-&gt;client_font_data2;

    switch((int)var_id) {
        case FAPI_FONT_FEATURE_UniqueID: return pfont-&gt;UID.id;
        case FAPI_FONT_FEATURE_BlueScale: return (ulong)(pfont-&gt;data.BlueScale * 65536); 
        case FAPI_FONT_FEATURE_Subrs_total_size :
            {   ref *Private, *Subrs, v;
                int lenIV = max(pfont-&gt;data.lenIV, 0), k;
                ulong size = 0;
                long i;
                const char *name[2] = {"Subrs", "GlobalSubrs"};
                if (dict_find_string(pdr, "Private", &amp;Private) &lt;= 0)
                    return 0;
                for (k = 0; k &lt; 2; k++) {
                    if (dict_find_string(Private, name[k], &amp;Subrs) &gt; 0)
                        for (i = r_size(Subrs) - 1; i &gt;= 0; i--) {
                            array_get(pfont-&gt;memory, Subrs, i, &amp;v);
                            size += r_size(&amp;v) - (ff-&gt;need_decrypt ? 0 : lenIV);
                        }
                }
                return size;
            }
        case FAPI_FONT_FEATURE_TT_size:
            return true_type_size(pdr);
    }
    return 0;
}

private float FAPI_FF_get_float(FAPI_font *ff, fapi_font_feature var_id, int index)
{   gs_font_base *pbfont = (gs_font_base *)ff-&gt;client_font_data;

    switch((int)var_id) {
        case FAPI_FONT_FEATURE_FontMatrix:
            {   double FontMatrix_div = (ff-&gt;is_cid &amp;&amp; !IsCIDFont(pbfont) ? 1000 : 1);
                switch(index) {
                    case 0 : return pbfont-&gt;base-&gt;FontMatrix.xx / FontMatrix_div;
                    case 1 : return pbfont-&gt;base-&gt;FontMatrix.xy / FontMatrix_div;
                    case 2 : return pbfont-&gt;base-&gt;FontMatrix.yx / FontMatrix_div;
                    case 3 : return pbfont-&gt;base-&gt;FontMatrix.yy / FontMatrix_div;
                    case 4 : return pbfont-&gt;base-&gt;FontMatrix.tx / FontMatrix_div;
                    case 5 : return pbfont-&gt;base-&gt;FontMatrix.ty / FontMatrix_div;
                }
            } 
    }
    return 0;
}

private inline void decode_bytes(byte *p, const byte *s, int l, int lenIV)
{   ushort state = 4330;

    for (; l; s++, l--) {
        uchar c = (*s ^ (state &gt;&gt; 8));
        state = (*s + state) * crypt_c1 + crypt_c2;
        if (lenIV &gt; 0) 
            lenIV--;
        else {
            *p = c;
            p++;
        }
    }
}

private ushort get_type1_data(FAPI_font *ff, const ref *type1string,
			      byte *buf, ushort buf_length)
{   gs_font_type1 *pfont = (gs_font_type1 *)ff-&gt;client_font_data;
    int lenIV = max(pfont-&gt;data.lenIV, 0);
    int length = r_size(type1string) - (ff-&gt;need_decrypt ? lenIV : 0);

    if (buf != 0) {
        int l = min(length, buf_length); /*safety */
        if (ff-&gt;need_decrypt &amp;&amp; pfont-&gt;data.lenIV &gt;= 0)
            decode_bytes(buf, type1string-&gt;value.const_bytes, l + lenIV, lenIV);
        else
            memcpy(buf, type1string-&gt;value.const_bytes, l);
    }
    return length;
}

private ushort FAPI_FF_get_subr(FAPI_font *ff, int index, byte *buf, ushort buf_length)
{   ref *pdr = (ref *)ff-&gt;client_font_data2;
    ref *Private, *Subrs, *GlobalSubrs, subr;
    int n1, n2, n;

    if (dict_find_string(pdr, "Private", &amp;Private) &lt;= 0)
        return 0;
    if (dict_find_string(Private, "Subrs", &amp;Subrs) &lt;= 0)
        Subrs = NULL;
    if (dict_find_string(Private, "GlobalSubrs", &amp;GlobalSubrs) &lt;= 0)
        GlobalSubrs = NULL;
    n1 = (Subrs != NULL ? r_size(Subrs) : 0);
    n2 = (GlobalSubrs != NULL ? r_size(GlobalSubrs) : 0);
    /* trick : we use the maximum of n1, n2 to pass both Subrs and GlobalSubrs in same array.
    */
    n = (n1 &lt; n2 ? n2 : n1);
    if (index &lt; n &amp;&amp; Subrs != NULL) {
        if (array_get(ff-&gt;memory, Subrs, index, &amp;subr) &lt; 0 || r_type(&amp;subr) != t_string)
            return 0;
    } else if (index &gt;= n &amp;&amp; GlobalSubrs != NULL) {
        if (array_get(ff-&gt;memory, 
		      GlobalSubrs, index - n, &amp;subr) &lt; 0 || r_type(&amp;subr) != t_string)
            return 0;
    } else
        return 0;
    return get_type1_data(ff, &amp;subr, buf, buf_length);
}

private bool sfnt_get_glyph_offset(ref *pdr, gs_font_type42 *pfont42, int index, ulong *offset0, ulong *offset1)
{   /* Note : TTC is not supported and probably is unuseful for Type 42. */
    sfnts_reader r;
    int glyf_elem_size = (2 &lt;&lt; pfont42-&gt;data.indexToLocFormat);

    sfnts_reader_init(&amp;r, pdr);
    r.seek(&amp;r, pfont42-&gt;data.loca + index * glyf_elem_size);
    *offset0 = pfont42-&gt;data.glyf + (glyf_elem_size == 2 ? r.rword(&amp;r) * 2 : r.rlong(&amp;r));
    *offset1 = pfont42-&gt;data.glyf + (glyf_elem_size == 2 ? r.rword(&amp;r) * 2 : r.rlong(&amp;r));
    return r.error;
}

private int get_GlyphDirectory_data_ptr(const gs_memory_t *mem,
					ref *pdr, int char_code, const byte **ptr)
{
    ref *GlyphDirectory, glyph0, *glyph = &amp;glyph0, glyph_index;
    if ((dict_find_string(pdr, "GlyphDirectory", &amp;GlyphDirectory) &gt; 0 &amp;&amp;
         (r_type(GlyphDirectory) == t_dictionary &amp;&amp;
          ( make_int(&amp;glyph_index, char_code),
            dict_find(GlyphDirectory, &amp;glyph_index, &amp;glyph) &gt; 0))) ||
        ((r_type(GlyphDirectory) == t_array &amp;&amp;
          array_get(mem, GlyphDirectory, char_code, &amp;glyph0) &gt;= 0) &amp;&amp;
         r_type(glyph) == t_string)) {
        *ptr = glyph-&gt;value.const_bytes;
	return r_size(glyph);
    }
    return -1;
}

private bool get_MetricsCount(FAPI_font *ff)
{   if (!ff-&gt;is_type1 &amp;&amp; ff-&gt;is_cid) {
	gs_font_cid2 *pfcid = (gs_font_cid2 *)ff-&gt;client_font_data;

	return pfcid-&gt;cidata.MetricsCount;
    }
    return 0;
}



private ushort FAPI_FF_get_glyph(FAPI_font *ff, int char_code, byte *buf, ushort buf_length)
{   /* 
     * We assume that renderer requests glyph data with multiple consequtive
     * calls to this function. 
     *
     * For a simple glyph it calls this
     * function exactly twice : first with buf == NULL for requesting
     * the necessary buffer length, and second with
     * buf != NULL for requesting the data (the second call may be skept
     * if the renderer discontinues the rendering on an exception).
     *
     * For a composite glyph it calls this function 2 * (N + 1)
     * times : 2 calls for the main glyph (same as above) followed with 
     * 2 * N calls for subglyphs, where N is less or equal to the number of
     * subglyphs ( N may be less if the renderer caches glyph data,
     * or discontinues the rendering on an exception).
     */
    ref *pdr = (ref *)ff-&gt;client_font_data2;
    ushort glyph_length;

    if (ff-&gt;is_type1) {
        if (ff-&gt;is_cid) {
            const ref *glyph = ff-&gt;char_data;

            glyph_length = get_type1_data(ff, glyph, buf, buf_length);
        } else {
            ref *CharStrings, char_name, *glyph;
            if (ff-&gt;char_data != NULL) {
		/*
		 * Can't use char_code in this case because hooked Type 1 fonts
		 * with 'glyphshow' may render a character which has no
		 * Encoding entry.
		 */
                if (name_ref(ff-&gt;memory, ff-&gt;char_data, 
			     ff-&gt;char_data_len, &amp;char_name, -1) &lt; 0)
		    return -1;
		if (buf != NULL) {
		    /* 
		     * Trigger the next call to the 'seac' case below. 
		     * Here we use the assumption about call sequence
		     * being documented above.
		     */
		    ff-&gt;char_data = NULL; 
		}
	    }  else { /* seac */
		i_ctx_t *i_ctx_p = (i_ctx_t *)ff-&gt;client_ctx_p;
		ref *StandardEncoding;

		if (dict_find_string(systemdict, "StandardEncoding", &amp;StandardEncoding) &lt;= 0 ||
		    array_get(ff-&gt;memory, StandardEncoding, char_code, &amp;char_name) &lt; 0)
		    if (name_ref(ff-&gt;memory, (const byte *)".notdef", 7, &amp;char_name, -1) &lt; 0)
			return -1;
	    }
            if (dict_find_string(pdr, "CharStrings", &amp;CharStrings) &lt;= 0)
                return -1;
            if (dict_find(CharStrings, &amp;char_name, &amp;glyph) &lt;= 0)
                return -1;
            glyph_length = get_type1_data(ff, glyph, buf, buf_length);
        }
    } else { /* type 42 */
	const byte *data_ptr;
	int l = get_GlyphDirectory_data_ptr(ff-&gt;memory, pdr, char_code, &amp;data_ptr);

	if (l &gt;= 0) {
	    int MetricsCount = get_MetricsCount(ff), mc = MetricsCount &lt;&lt; 1;

            glyph_length = max((ushort)(l - mc), 0); /* safety */
            if (buf != 0 &amp;&amp; glyph_length &gt; 0)
                memcpy(buf, data_ptr + mc, min(glyph_length, buf_length)/* safety */);
        } else {
            gs_font_type42 *pfont42 = (gs_font_type42 *)ff-&gt;client_font_data;
            ulong offset0, offset1;
            bool error = sfnt_get_glyph_offset(pdr, pfont42, char_code, &amp;offset0, &amp;offset1);

            glyph_length = (error ? -1 : offset1 - offset0);
            if (buf != 0 &amp;&amp; !error) {
                sfnts_reader r;
                sfnts_reader_init(&amp;r, pdr);

                r.seek(&amp;r, offset0);
                r.rstring(&amp;r, buf, min(glyph_length, buf_length)/* safety */);
                if (r.error)
                    glyph_length = -1;
            }
        }
    }
    return glyph_length;
}

private const FAPI_font ff_stub = {
    0, /* server_font_data */
    0, /* need_decrypt */
    NULL, /* const gs_memory_t */
    0, /* font_file_path */
    0, /* subfont */
    false, /* is_type1 */
    false, /* is_cid */
    false, /* is_mtx_skipped */
    0, /* client_ctx_p */
    0, /* client_font_data */
    0, /* client_font_data2 */
    0, /* char_data */
    0, /* char_data_len */
    FAPI_FF_get_word,
    FAPI_FF_get_long,
    FAPI_FF_get_float,
    FAPI_FF_get_subr,
    FAPI_FF_get_glyph,
    FAPI_FF_serialize_tt_font
};

private int FAPI_get_xlatmap(i_ctx_t *i_ctx_p, char **xlatmap)
{   ref *pref;
    int code;

    if ((code = dict_find_string(systemdict, ".xlatmap", &amp;pref)) &lt; 0)
	return code;
    if (r_type(pref) != t_string)
        return_error(e_typecheck);
    *xlatmap = (char *)pref-&gt;value.bytes;
    /*  Note : this supposes that xlatmap doesn't move in virtual memory.
        Garbager must not be called while plugin executes get_scaled_font, get_decodingID.
        Fix some day with making copy of xlatmap in system memory.
    */
    return 0;
}

private int renderer_retcode(i_ctx_t *i_ctx_p, FAPI_server *I, FAPI_retcode rc)
{   if (rc == 0)
	return 0;
    eprintf2("Error: Font Renderer Plugin ( %s ) return code = %d\n", I-&gt;ig.d-&gt;subtype, rc);
    return rc &lt; 0 ? rc : e_invalidfont;
}

private int zFAPIavailable(i_ctx_t *i_ctx_p)
{   i_plugin_holder *h = i_plugin_get_list(i_ctx_p);
    bool available = true;
    os_ptr op = osp;

    for (; h != 0; h = h-&gt;next)
       	if (!strcmp(h-&gt;I-&gt;d-&gt;type,"FAPI"))
            goto found;
    available = false;
    found :
    push(1);
    make_bool(op, available);
    return 0;
} 


private int FAPI_find_plugin(i_ctx_t *i_ctx_p, const char *subtype, FAPI_server **pI)
{   i_plugin_holder *h = i_plugin_get_list(i_ctx_p);
    int code;

    for (; h != 0; h = h-&gt;next)
       	if (!strcmp(h-&gt;I-&gt;d-&gt;type,"FAPI"))
	    if (!strcmp(h-&gt;I-&gt;d-&gt;subtype, subtype)) {
	        FAPI_server *I = *pI = (FAPI_server *)h-&gt;I;

	        if ((code = renderer_retcode(i_ctx_p, I, I-&gt;ensure_open(I))) &lt; 0)
		    return code;
	        return 0;
	    }
    return_error(e_invalidfont);
}

private int FAPI_prepare_font(i_ctx_t *i_ctx_p, FAPI_server *I, ref *pdr, gs_font_base *pbfont, 
                              const char *font_file_path, const FAPI_font_scale *font_scale, 
			      const char *xlatmap, int BBox[4], const char **decodingID)
{   /* Returns 1 iff BBox is set. */
    /* Cleans up server's font data if failed. */

    /* A renderer may need to access the top level font's data of 
     * a CIDFontType 0 (FontType 9) font while preparing its subfonts,
     * and/or perform a completion action with the top level font after
     * its descendants are prepared. Therefore with such fonts
     * we first call get_scaled_font(..., FAPI_TOPLEVEL_BEGIN), then
     * get_scaled_font(..., i) with eash descendant font index i,
     * and then get_scaled_font(..., FAPI_TOPLEVEL_COMPLETE).
     * For other fonts we don't call with 'i'.
     *
     * Actually server's data for top level CIDFontTYpe 0 non-disk fonts should not be important, 
     * because with non-disk fonts FAPI_do_char never deals with the top-level font, 
     * but does with its descendants individually.
     * Therefore a recommendation for the renderer is don't build any special
     * data for the top-level non-disk font of CIDFontType 0, but return immediately
     * with success code and NULL data pointer.
     *
     * get_scaled_font may be called for same font at second time,
     * so the renderen must check whether the data is already built.
     */
    int code, bbox_set = 0, subfont = 0;
    FAPI_font ff = ff_stub;
    ref *SubfontId;

    if (dict_find_string(pdr, "SubfontId", &amp;SubfontId) &gt;= 0 &amp;&amp; r_has_type(SubfontId, t_integer))
        subfont = SubfontId-&gt;value.intval;
    ff.font_file_path = font_file_path;
    ff.is_type1 = IsType1GlyphData(pbfont);
    ff.memory = imemory;
    ff.client_ctx_p = i_ctx_p;
    ff.client_font_data = pbfont;
    ff.client_font_data2 = pdr;
    ff.server_font_data = pbfont-&gt;FAPI_font_data; /* Possibly pass it from zFAPIpassfont. */
    ff.is_cid = IsCIDFont(pbfont);
    ff.is_mtx_skipped = (get_MetricsCount(&amp;ff) != 0);
    if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_scaled_font(I, &amp;ff, subfont,
                                         font_scale, xlatmap, false, FAPI_TOPLEVEL_BEGIN))) &lt; 0)
	return code;
    pbfont-&gt;FAPI_font_data = ff.server_font_data; /* Save it back to GS font. */
    if (ff.server_font_data != 0) {
	if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_font_bbox(I, &amp;ff, BBox))) &lt; 0) {
	    I-&gt;release_typeface(I, ff.server_font_data);
	    return code;
	}
	bbox_set = 1;
    }
    if (xlatmap != NULL &amp;&amp; pbfont-&gt;FAPI_font_data != NULL)
	if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_decodingID(I, &amp;ff, decodingID))) &lt; 0) {
	    I-&gt;release_typeface(I, pbfont-&gt;FAPI_font_data);
	    pbfont-&gt;FAPI_font_data = 0;
	    return code;
	}
    /* Prepare descendant fonts : */
    if (font_file_path == NULL &amp;&amp; ff.is_type1 &amp;&amp; ff.is_cid) { /* Renderers should expect same condition. */
        gs_font_cid0 *pfcid = (gs_font_cid0 *)pbfont;
        gs_font_type1 **FDArray = pfcid-&gt;cidata.FDArray;
        int i, n = pfcid-&gt;cidata.FDArray_size;
        ref *rFDArray, f;

        if (dict_find_string(pdr, "FDArray", &amp;rFDArray) &lt;= 0 || r_type(rFDArray) != t_array)
            return_error(e_invalidfont);
        ff = ff_stub;
        ff.is_type1 = true;
	ff.memory = imemory;
	ff.client_ctx_p = i_ctx_p;
        for (i = 0; i &lt; n; i++) {
            gs_font_type1 *pbfont1 = FDArray[i];
	    int BBox_temp[4];

            pbfont1-&gt;FontBBox = pbfont-&gt;FontBBox; /* Inherit FontBBox from the type 9 font. */
            if(array_get(imemory, rFDArray, i, &amp;f) &lt; 0 || r_type(&amp;f) != t_dictionary)
                return_error(e_invalidfont);
            ff.client_font_data = pbfont1;
            pbfont1-&gt;FAPI = pbfont-&gt;FAPI;
            ff.client_font_data2 = &amp;f;
            ff.server_font_data = pbfont1-&gt;FAPI_font_data;
            ff.is_cid = true;
	    ff.is_mtx_skipped = (get_MetricsCount(&amp;ff) != 0);
            if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_scaled_font(I, &amp;ff, 0, 
	                                 font_scale, NULL, false, i))) &lt; 0)
		break;
            pbfont1-&gt;FAPI_font_data = ff.server_font_data; /* Save it back to GS font. */
	    /* Try to do something with the descendant font to ensure that it's working : */
	    if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_font_bbox(I, &amp;ff, BBox_temp))) &lt; 0)
		break;
        }
	if (i == n) {
	    code = renderer_retcode(i_ctx_p, I, I-&gt;get_scaled_font(I, &amp;ff, subfont, 
	                                 font_scale, NULL, false, FAPI_TOPLEVEL_COMPLETE));
	    if (code &gt;= 0)
		return bbox_set; /* Full success. */
	}
	/* Fail, release server's font data : */
        for (i = 0; i &lt; n; i++) {
            gs_font_type1 *pbfont1 = FDArray[i];

	    if (pbfont1-&gt;FAPI_font_data != NULL)
		I-&gt;release_typeface(I, pbfont1-&gt;FAPI_font_data);
	    pbfont1-&gt;FAPI_font_data = 0;
	}
	if (pbfont-&gt;FAPI_font_data != NULL)
	    I-&gt;release_typeface(I, pbfont-&gt;FAPI_font_data);
	pbfont-&gt;FAPI_font_data = 0;
	return_error(e_invalidfont);
    } else {
	code = renderer_retcode(i_ctx_p, I, I-&gt;get_scaled_font(I, &amp;ff, subfont, 
	                                 font_scale, xlatmap, false, FAPI_TOPLEVEL_COMPLETE));
        if (code &lt; 0) {
	    I-&gt;release_typeface(I, pbfont-&gt;FAPI_font_data);
	    pbfont-&gt;FAPI_font_data = 0;
	    return code;
        }
	return bbox_set;
    }
}

private int FAPI_refine_font(i_ctx_t *i_ctx_p, os_ptr op, gs_font_base *pbfont, const char *font_file_path)
{   ref *pdr = op;  /* font dict */
    double size, size1;
    int BBox[4], scale;
    const char *decodingID = NULL;
    char *xlatmap = NULL;
    FAPI_server *I = pbfont-&gt;FAPI;
    FAPI_font_scale font_scale = {{1, 0, 0, 1, 0, 0}, {0, 0}, {1, 1}, true};
    int code;

    if (font_file_path != NULL &amp;&amp; pbfont-&gt;FAPI_font_data == NULL)
        if ((code = FAPI_get_xlatmap(i_ctx_p, &amp;xlatmap)) &lt; 0)
	    return code;
    scale = 1 &lt;&lt; I-&gt;frac_shift;
    size1 = size = 1 / hypot(pbfont-&gt;FontMatrix.xx, pbfont-&gt;FontMatrix.xy);
    if (size &lt; 1000)
	size = 1000;
    if (size1 &gt; 100)
        size1 = (int)(size1 + 0.5);
    font_scale.matrix[0] = font_scale.matrix[3] = (int)(size * scale + 0.5);
    font_scale.HWResolution[0] = (FracInt)(72 * scale);
    font_scale.HWResolution[1] = (FracInt)(72 * scale);

    code = FAPI_prepare_font(i_ctx_p, I, pdr, pbfont, font_file_path, &amp;font_scale, xlatmap, BBox, &amp;decodingID);
    if (code &lt; 0)
	return code;

    if (code &gt; 0) {
	/* Refine FontBBox : */
	ref *v, x0, y0, x1, y1;

	pbfont-&gt;FontBBox.p.x = (double)BBox[0] * size1 / size;
	pbfont-&gt;FontBBox.p.y = (double)BBox[1] * size1 / size;
	pbfont-&gt;FontBBox.q.x = (double)BBox[2] * size1 / size;
	pbfont-&gt;FontBBox.q.y = (double)BBox[3] * size1 / size;
	if (dict_find_string(op, "FontBBox", &amp;v) &lt;= 0 || !r_has_type(v, t_array))
	    return_error(e_invalidfont);
	if (r_size(v) &lt; 4)
	    return_error(e_invalidfont);
	make_real(&amp;x0, pbfont-&gt;FontBBox.p.x);
	make_real(&amp;y0, pbfont-&gt;FontBBox.p.y);
	make_real(&amp;x1, pbfont-&gt;FontBBox.q.x);
	make_real(&amp;y1, pbfont-&gt;FontBBox.q.y);
	ref_assign_old(v, v-&gt;value.refs + 0, &amp;x0, "FAPI_refine_font_BBox");
	ref_assign_old(v, v-&gt;value.refs + 1, &amp;y0, "FAPI_refine_font_BBox");
	ref_assign_old(v, v-&gt;value.refs + 2, &amp;x1, "FAPI_refine_font_BBox");
	ref_assign_old(v, v-&gt;value.refs + 3, &amp;y1, "FAPI_refine_font_BBox");
    }

    /* Assign a Decoding : */
    if (decodingID != 0 &amp;&amp; *decodingID) {
       ref Decoding;

       if (IsCIDFont(pbfont)) {
            ref *CIDSystemInfo, *Ordering, SubstNWP;
            byte buf[30];
            int ordering_length, decodingID_length = min(strlen(decodingID), sizeof(buf) - 2);

            if (dict_find_string(pdr, "CIDSystemInfo", &amp;CIDSystemInfo) &lt;= 0 || !r_has_type(CIDSystemInfo, t_dictionary))
                return_error(e_invalidfont);
            if (dict_find_string(CIDSystemInfo, "Ordering", &amp;Ordering) &lt;= 0 || !r_has_type(Ordering, t_string))
                return_error(e_invalidfont);
            ordering_length = min(r_size(Ordering), sizeof(buf) - 2 - decodingID_length);
            memcpy(buf, Ordering-&gt;value.const_bytes, ordering_length);
            if ((code = name_ref(imemory, buf, ordering_length, &amp;SubstNWP, 0)) &lt; 0)
		return code;
            if ((code = dict_put_string(pdr, "SubstNWP", &amp;SubstNWP, NULL)) &lt; 0)
		return code;
            buf[ordering_length] = '.';
            memcpy(buf + ordering_length + 1, decodingID, decodingID_length);
            buf[decodingID_length + 1 + ordering_length] = 0; /* Debug purpose only */
            if ((code = name_ref(imemory, buf, 
				 decodingID_length + 1 + ordering_length, &amp;Decoding, 0)) &lt; 0)
		return code;
        } else
            if ((code = name_ref(imemory, (const byte *)decodingID, 
				 strlen(decodingID), &amp;Decoding, 0)) &lt; 0)
		return code;
        if ((code = dict_put_string(pdr, "Decoding", &amp;Decoding, NULL)) &lt; 0)
	    return code;
    }
    return 0;
}

private int notify_remove_font(void *proc_data, void *event_data)
{   /* gs_font_finalize passes event_data == NULL, so check it here. */
    if (event_data == NULL) {
        gs_font_base *pbfont = proc_data;

        if (pbfont-&gt;FAPI_font_data != 0)
            pbfont-&gt;FAPI-&gt;release_typeface(pbfont-&gt;FAPI, pbfont-&gt;FAPI_font_data);
    }
    return 0;
}

/*  &lt;string|name&gt; &lt;font&gt; &lt;is_disk_font&gt; .rebuildfontFAPI &lt;string|name&gt; &lt;font&gt; */
/*  Rebuild a font for handling it with an external renderer. 
    
    The font was built as a native GS font to allow easy access
    to font features. Then zFAPIrebuildfont sets FAPI entry
    into gx_font_base and replaces BuildGlyph and BuildChar 
    to enforce the FAPI handling.

    This operator must not be called with devices which embed fonts.

*/
private int zFAPIrebuildfont(i_ctx_t *i_ctx_p)
{   os_ptr op = osp;
    build_proc_refs build;
    gs_font *pfont;

    int code = font_param(op - 1, &amp;pfont), code1;
    gs_font_base *pbfont = (gs_font_base *)pfont;
    ref *v;
    char *font_file_path = NULL, FAPI_ID[20];
    const byte *pchars;
    uint len;
    font_data *pdata;

    if (code &lt; 0)
	return code;
    check_type(*op, t_boolean);
    if (pbfont-&gt;FAPI != 0) {
        /*  If the font was processed with zFAPIpassfont,
            it already has an attached FAPI and server_font_data.
            Don't change them here.
        */
    } else {
        if (dict_find_string(op - 1, "FAPI", &amp;v) &lt;= 0 || !r_has_type(v, t_name))
	    return_error(e_invalidfont);
        obj_string_data(imemory, v, &amp;pchars, &amp;len);
        len = min(len, sizeof(FAPI_ID) - 1);
        strncpy(FAPI_ID, (const char *)pchars, len);
        FAPI_ID[len] = 0;
        if ((code = FAPI_find_plugin(i_ctx_p, FAPI_ID, &amp;pbfont-&gt;FAPI)) &lt; 0)
	    return code;
    }
    pdata = (font_data *)pfont-&gt;client_data;
    if (dict_find_string(op - 1, "Path", &amp;v) &lt;= 0 || !r_has_type(v, t_string))
        v = NULL;
    if (pfont-&gt;FontType == ft_CID_encrypted &amp;&amp; v == NULL) {
        if ((code = build_proc_name_refs(imemory, &amp;build, ".FAPIBuildGlyph9", ".FAPIBuildGlyph9")) &lt; 0)
	    return code;
    } else
        if ((code = build_proc_name_refs(imemory, &amp;build, ".FAPIBuildChar", ".FAPIBuildGlyph")) &lt; 0)
	    return code;
    if (name_index(imemory, &amp;pdata-&gt;BuildChar) == name_index(imemory, &amp;build.BuildChar)) {
        /* Already rebuilt - maybe a substituted font. */
    } else {
        ref_assign_new(&amp;pdata-&gt;BuildChar, &amp;build.BuildChar);
        ref_assign_new(&amp;pdata-&gt;BuildGlyph, &amp;build.BuildGlyph);
        if (v != NULL)
            font_file_path = ref_to_string(v, imemory_global, "font file path");
        code = FAPI_refine_font(i_ctx_p, op - 1, pbfont, font_file_path);
        if (font_file_path != NULL)
            gs_free_string(imemory_global, (byte *)font_file_path, r_size(v) + 1, "font file path");
        code1 = gs_notify_register(&amp;pfont-&gt;notify_list, notify_remove_font, pbfont);
        (void)code1;  /* Recover possible error just ignoring it. */
    }
    pop(1);
    return code;
}

private ulong array_find(const gs_memory_t *mem, ref *Encoding, ref *char_name) {
    ulong n = r_size(Encoding), i;
    ref v;
    for (i = 0; i &lt; n; i++)
        if (array_get(mem, Encoding, i, &amp;v) &lt; 0)
            break;
        else if(r_type(char_name) == r_type(&amp;v) &amp;&amp; char_name-&gt;value.const_pname == v.value.const_pname)
            return i;
    return 0;
}

private int outline_char(i_ctx_t *i_ctx_p, FAPI_server *I, int import_shift_v, gs_show_enum *penum_s, struct gx_path_s *path, bool close_path)
{   FAPI_path path_interface = path_interface_stub;
    FAPI_outline_handler olh;
    int code;

    olh.path = path;
    olh.x0 = penum_s-&gt;pgs-&gt;ctm.tx_fixed;
    olh.y0 = penum_s-&gt;pgs-&gt;ctm.ty_fixed;
    olh.close_path = close_path;
    olh.need_close = false;
    path_interface.olh = &amp;olh;
    path_interface.shift = import_shift_v;
    if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_char_outline(I, &amp;path_interface))) &lt; 0)
	return code;
    if (olh.need_close &amp;&amp; olh.close_path)
        if ((code = add_closepath(&amp;path_interface)) &lt; 0)
	    return code;
    return 0;
}

private void compute_em_scale(const gs_font_base *pbfont, FAPI_metrics *metrics, double FontMatrix_div, double *em_scale_x, double *em_scale_y)
{   /* optimize : move this stuff to FAPI_refine_font */
    gs_matrix *m = &amp;pbfont-&gt;base-&gt;FontMatrix;
    int rounding_x, rounding_y; /* Striking out the 'float' representation error in FontMatrix. */
    double sx, sy;

    sx = hypot(m-&gt;xx, m-&gt;xy) * metrics-&gt;em_x / FontMatrix_div;
    sy = hypot(m-&gt;yx, m-&gt;yy) * metrics-&gt;em_y / FontMatrix_div;
    rounding_x = (int)(0x00800000 / sx);
    rounding_y = (int)(0x00800000 / sy);
    *em_scale_x = (int)(sx * rounding_x + 0.5) / (double)rounding_x;
    *em_scale_y = (int)(sy * rounding_y + 0.5) / (double)rounding_y;
}

private int fapi_copy_mono(gx_device *dev1, FAPI_raster *rast, int dx, int dy)
{   if ((rast-&gt;line_step &amp; (align_bitmap_mod - 1)) == 0)
        return dev_proc(dev1, copy_mono)(dev1, rast-&gt;p, 0, rast-&gt;line_step, 0, dx, dy, rast-&gt;width, rast-&gt;height, 0, 1);
    else { /* bitmap data needs to be aligned, make the aligned copy : */
        int line_step = bitmap_raster(rast-&gt;width), code;
        byte *p = gs_alloc_byte_array(dev1-&gt;memory, rast-&gt;height, line_step, "fapi_copy_mono");
        byte *q = p, *r = rast-&gt;p, *pe;
        if (p == NULL)
            return_error(e_VMerror);
        pe = p + rast-&gt;height * line_step;
        for (; q &lt; pe; q+=line_step, r += rast-&gt;line_step)
            memcpy(q, r, rast-&gt;line_step);
        code = dev_proc(dev1, copy_mono)(dev1, p, 0, line_step, 0, dx, dy, rast-&gt;width, rast-&gt;height, 0, 1);
        gs_free_object(dev1-&gt;memory, p, "fapi_copy_mono");
        return code;
    }
}

private const int frac_pixel_shift = 4;

private int fapi_finish_render_aux(i_ctx_t *i_ctx_p, gs_font_base *pbfont, FAPI_server *I)
{   gs_text_enum_t *penum = op_show_find(i_ctx_p);
    gs_show_enum *penum_s = (gs_show_enum *)penum;
    gs_state *pgs = penum_s-&gt;pgs;
    gx_device *dev1 = gs_currentdevice_inline(pgs); /* Possibly changed by zchar_set_cache. */
    gx_device *dev = penum_s-&gt;dev;
    const int import_shift_v = _fixed_shift - I-&gt;frac_shift;
    FAPI_raster rast;
    int code;

    if (SHOW_IS(penum, TEXT_DO_NONE)) {
        /* do nothing */
    } else if (igs-&gt;in_charpath) {
        if ((code = outline_char(i_ctx_p, I, import_shift_v, penum_s, pgs-&gt;show_gstate-&gt;path, !pbfont-&gt;PaintType)) &lt; 0)
	    return code;
    } else {
        int code = I-&gt;get_char_raster(I, &amp;rast);
        if (code == e_limitcheck) {
            /* The rerver provides an outline instead the raster. */
            gs_imager_state *pis = (gs_imager_state *)pgs-&gt;show_gstate;
            gs_point pt;
            if ((code = gs_currentpoint(pgs-&gt;show_gstate, &amp;pt)) &lt; 0)
		return code;
            if ((code = outline_char(i_ctx_p, I, import_shift_v, penum_s, pgs-&gt;show_gstate-&gt;path, !pbfont-&gt;PaintType)) &lt; 0)
		return code;
            if ((code = gs_imager_setflat(pis, gs_char_flatness(pis, 1.0))) &lt; 0)
		return code;
            if (pbfont-&gt;PaintType) {
                if ((code = gs_stroke(pgs-&gt;show_gstate)) &lt; 0)
		    return code;
            } else
                if ((code = gs_fill(pgs-&gt;show_gstate)) &lt; 0)
		    return code;
            if ((code = gs_moveto(pgs-&gt;show_gstate, pt.x, pt.y)) &lt; 0)
		return code;
        } else {
	    int rast_orig_x =   rast.orig_x - (int)(penum_s-&gt;fapi_glyph_shift.x * (1 &lt;&lt; frac_pixel_shift));
	    int rast_orig_y = - rast.orig_y - (int)(penum_s-&gt;fapi_glyph_shift.y * (1 &lt;&lt; frac_pixel_shift));

            if ((code = renderer_retcode(i_ctx_p, I, code)) &lt; 0)
		return code;
            if (pgs-&gt;in_cachedevice == CACHE_DEVICE_CACHING) { /* Using GS cache */
                /*  GS and renderer may transform coordinates few differently.
                    The best way is to make set_cache_device to take the renderer's bitmap metrics immediately,
                    but we need to account CDevProc, which may truncate the bitmap.
                    Perhaps GS overestimates the bitmap size,
                    so now we only add a compensating shift - the dx and dy.
                */              
                int shift_rd = _fixed_shift  - frac_pixel_shift;
                int rounding = 1 &lt;&lt; (frac_pixel_shift - 1);
                int dx = arith_rshift_slow((pgs-&gt;ctm.tx_fixed &gt;&gt; shift_rd) + rast_orig_x + rounding, frac_pixel_shift);
                int dy = arith_rshift_slow((pgs-&gt;ctm.ty_fixed &gt;&gt; shift_rd) + rast_orig_y + rounding, frac_pixel_shift);
                if ((code = fapi_copy_mono(dev1, &amp;rast, dx, dy)) &lt; 0)
		    return code;
            } else { /* Not using GS cache */
	        const gx_clip_path * pcpath = i_ctx_p-&gt;pgs-&gt;clip_path; 
                const gx_drawing_color * pdcolor = penum-&gt;pdcolor;
	        if ((code = dev_proc(dev, fill_mask)(dev, rast.p, 0, rast.line_step, 0,
			          (int)(penum_s-&gt;pgs-&gt;ctm.tx + (double)rast_orig_x / (1 &lt;&lt; frac_pixel_shift) + 0.5), 
			          (int)(penum_s-&gt;pgs-&gt;ctm.ty + (double)rast_orig_y / (1 &lt;&lt; frac_pixel_shift) + 0.5), 
			          rast.width, rast.height,
			          pdcolor, 1, rop3_default, pcpath)) &lt; 0)
				    return code;
            }
        }
    }
    pop(2);
    return 0;
}

private int fapi_finish_render(i_ctx_t *i_ctx_p)
{   os_ptr op = osp;
    gs_font *pfont;
    int code = font_param(op - 1, &amp;pfont);

    if (code == 0) {
        gs_font_base *pbfont = (gs_font_base *) pfont;
        FAPI_server *I = pbfont-&gt;FAPI;
        code = fapi_finish_render_aux(i_ctx_p, pbfont, I);
        I-&gt;release_char_data(I);
    }
    return code;
}

#define GET_U16_MSB(p) (((uint)((p)[0]) &lt;&lt; 8) + (p)[1])
#define GET_S16_MSB(p) (int)((GET_U16_MSB(p) ^ 0x8000) - 0x8000)

private int FAPI_do_char(i_ctx_t *i_ctx_p, gs_font_base *pbfont, gx_device *dev, char *font_file_path, bool bBuildGlyph, ref *charstring)
{   /* Stack : &lt;font&gt; &lt;code|name&gt; --&gt; - */
    os_ptr op = osp;
    ref *pdr = op - 1;
    gs_text_enum_t *penum = op_show_find(i_ctx_p);
    gs_show_enum *penum_s = (gs_show_enum *)penum;
    /* 
        fixme: the following code needs to optimize with a maintainence of scaled font objects 
        in graphics library and in interpreter. Now we suppose that the renderer
        uses font cache, so redundant font opening isn't a big expense.
    */
    FAPI_char_ref cr = {0, false, NULL, 0, 0, 0, 0, 0, FAPI_METRICS_NOTDEF};
    const gs_matrix * ctm = &amp;ctm_only(igs);
    int scale;
    FAPI_font_scale font_scale = {{1, 0, 0, 1, 0, 0}, {0, 0}, {1, 1}, true};
    FAPI_metrics metrics;
    FAPI_server *I = pbfont-&gt;FAPI;
    int client_char_code = 0;
    ref char_name, *SubfontId;
    int subfont = 0;
    bool is_TT_from_type42 = (pbfont-&gt;FontType == ft_TrueType &amp;&amp; font_file_path == NULL);
    bool is_embedded_type1 = ((pbfont-&gt;FontType == ft_encrypted ||
			       pbfont-&gt;FontType == ft_encrypted2) &amp;&amp; 
			      font_file_path == NULL);
    bool bCID = (IsCIDFont(pbfont) || charstring != NULL);
    bool bIsType1GlyphData = IsType1GlyphData(pbfont);
    FAPI_font ff = ff_stub;
    gs_log2_scale_point log2_scale = {0, 0};
    int alpha_bits = (*dev_proc(dev, get_alpha_bits)) (dev, go_text);
    double FontMatrix_div = (bCID &amp;&amp; bIsType1GlyphData &amp;&amp; font_file_path == NULL ? 1000 : 1);
    bool bVertical = (gs_rootfont(igs)-&gt;WMode != 0), bVertical0 = bVertical;
    double sbw[4] = {0, 0, 0, 0};
    double em_scale_x, em_scale_y;
    gs_rect char_bbox;
    op_proc_t exec_cont = 0;
    int code;
    enum {
	SBW_DONE,
	SBW_SCALE,
	SBW_FROM_RENDERER
    } sbw_state = SBW_SCALE;

    if(bBuildGlyph &amp;&amp; !bCID) {
        check_type(*op, t_name);
    } else
        check_type(*op, t_integer);

    /* Compute the sacle : */
    if (!SHOW_IS(penum, TEXT_DO_NONE) &amp;&amp; !igs-&gt;in_charpath) {
        gs_currentcharmatrix(igs, NULL, 1); /* make char_tm valid */
        penum_s-&gt;fapi_log2_scale.x = -1;
        gx_compute_text_oversampling(penum_s, (gs_font *)pbfont, alpha_bits, &amp;log2_scale);
        penum_s-&gt;fapi_log2_scale = log2_scale;
    }
retry_oversampling:
    font_scale.subpixels[0] = 1 &lt;&lt; log2_scale.x;
    font_scale.subpixels[1] = 1 &lt;&lt; log2_scale.y;
    font_scale.align_to_pixels = gs_currentaligntopixels(pbfont-&gt;dir);
    if (penum == 0)
	return_error(e_undefined);
    scale = 1 &lt;&lt; I-&gt;frac_shift;
    {   gs_matrix *base_font_matrix = &amp;pbfont-&gt;base-&gt;FontMatrix;
        double dx = hypot(base_font_matrix-&gt;xx, base_font_matrix-&gt;xy);
        double dy = hypot(base_font_matrix-&gt;yx, base_font_matrix-&gt;yy);
        /*  Trick : we need to restore the font scale from ctm, pbfont-&gt;FontMatrix,
            and base_font_matrix. We assume that base_font_matrix is
            a multiple of pbfont-&gt;FontMatrix with a constant from scalefont.
            But we cannot devide ctm by pbfont-&gt;FontMatrix for getting
            a proper result: the base_font_matrix may be XY transposition,
            but we must not cut out the transposition from ctm.
            Therefore we use the norm of base_font_matrix columns as the divisors
            for X and Y. It is not clear what to do when base_font_matrix is anisotropic
            (i.e. dx != dy), but we did not meet such fonts before now.
        */
        font_scale.matrix[0] =  (FracInt)(ctm-&gt;xx * FontMatrix_div / dx * 72 / dev-&gt;HWResolution[0] * scale);
        font_scale.matrix[1] = -(FracInt)(ctm-&gt;xy * FontMatrix_div / dy * 72 / dev-&gt;HWResolution[0] * scale);
        font_scale.matrix[2] =  (FracInt)(ctm-&gt;yx * FontMatrix_div / dx * 72 / dev-&gt;HWResolution[1] * scale);
        font_scale.matrix[3] = -(FracInt)(ctm-&gt;yy * FontMatrix_div / dy * 72 / dev-&gt;HWResolution[1] * scale);
        font_scale.matrix[4] =  (FracInt)(ctm-&gt;tx * FontMatrix_div / dx * 72 / dev-&gt;HWResolution[0] * scale);
        font_scale.matrix[5] =  (FracInt)(ctm-&gt;ty * FontMatrix_div / dy * 72 / dev-&gt;HWResolution[1] * scale);
        /* Note: the ctm mapping here is upside down. */
    }
    font_scale.HWResolution[0] = (FracInt)((double)dev-&gt;HWResolution[0] * font_scale.subpixels[0] * scale);
    font_scale.HWResolution[1] = (FracInt)((double)dev-&gt;HWResolution[1] * font_scale.subpixels[1] * scale);

    /* Prepare font data : */
    if (dict_find_string(pdr, "SubfontId", &amp;SubfontId) &gt; 0 &amp;&amp; r_has_type(SubfontId, t_integer))
        subfont = SubfontId-&gt;value.intval;
    ff.memory = pbfont-&gt;memory;
    ff.font_file_path = font_file_path;
    ff.client_font_data = pbfont;
    ff.client_font_data2 = pdr;
    ff.server_font_data = pbfont-&gt;FAPI_font_data;
    ff.is_type1 = bIsType1GlyphData;
    ff.is_cid = bCID;
    ff.is_mtx_skipped = (get_MetricsCount(&amp;ff) != 0);
    ff.client_ctx_p = i_ctx_p;
    if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_scaled_font(I, &amp;ff, subfont, &amp;font_scale, 
				 NULL, bVertical, 
				 (!bCID || (pbfont-&gt;FontType != ft_encrypted  &amp;&amp;
				            pbfont-&gt;FontType != ft_encrypted2)
				        ? FAPI_TOPLEVEL_PREPARED : FAPI_DESCENDANT_PREPARED)))) &lt; 0)
	return code;
    /* fixme : it would be nice to call get_scaled_font at once for entire 'show' string. */

    /* Obtain the character name : */
    if (bCID) {
	int_param(op, 0xFFFF, &amp;client_char_code);
        make_null(&amp;char_name);
    } else if (r_has_type(op, t_integer)) {
	/* Translate from PS encoding to char name : */
	ref *Encoding;
	int_param(op, 0xFF, &amp;client_char_code);
        if (dict_find_string(pdr, "Encoding", &amp;Encoding) &gt; 0 &amp;&amp; 
            (r_has_type(Encoding, t_array) || r_has_type(Encoding, t_shortarray))) {
	    if (array_get(imemory, Encoding, client_char_code, &amp;char_name) &lt; 0)
	        if ((code = name_ref(imemory, (const byte *)".notdef", 7, &amp;char_name, -1)) &lt; 0)
		    return code;
	} else
            return_error(e_invalidfont);
    } else 
	char_name = *op;

    /* Obtain the character code or glyph index : */
    if (bCID) {
        if (font_file_path != NULL) {
            ref *Decoding, *SubstNWP, src_type, dst_type;
	    uint c;

            if (dict_find_string(pdr, "Decoding", &amp;Decoding) &lt;= 0 || !r_has_type(Decoding, t_dictionary))
                return_error(e_invalidfont);
            if (dict_find_string(pdr, "SubstNWP", &amp;SubstNWP) &lt;= 0 || !r_has_type(SubstNWP, t_array))
                return_error(e_invalidfont);

	    code = cid_to_TT_charcode(imemory, Decoding, NULL, SubstNWP, 
				      client_char_code, &amp;c, &amp;src_type, &amp;dst_type);
	    if (code &lt; 0)
		return code;
	    cr.char_code = c;
	    cr.is_glyph_index = (code == 0);
            /* fixme : process the narrow/wide/proportional mapping type,
	       using src_type, dst_type. Should adjust the 'matrix' above.
               Call get_font_proportional_feature for proper choice.
            */
        } else
            cr.char_code = client_char_code;
    } else if (is_TT_from_type42) {
        /* This font must not use 'cmap', so compute glyph index from CharStrings : */
	ref *CharStrings, *glyph_index;
        if (dict_find_string(pdr, "CharStrings", &amp;CharStrings) &lt;= 0 || !r_has_type(CharStrings, t_dictionary))
            return_error(e_invalidfont);
        if (dict_find(CharStrings, &amp;char_name, &amp;glyph_index) &lt; 0) {
            cr.char_code = 0; /* .notdef */
            if ((code = name_ref(imemory, (const byte *)".notdef", 7, &amp;char_name, -1)) &lt; 0)
		return code;
        } else if (r_has_type(glyph_index, t_integer))
            cr.char_code = glyph_index-&gt;value.intval;
        else
            return_error(e_invalidfont);
        cr.is_glyph_index = true;
    } else if (is_embedded_type1) {
        /*  Since the client passes charstring by callback using ff.char_data,
            the client doesn't need to provide a good cr here.
            Perhaps since UFST uses char codes as glyph cache keys (UFST 4.2 cannot use names),
            we provide font char codes equal to document's char codes.
            This trick assumes that Encoding can't point different glyphs
            for same char code. The last should be true due to 
            PLRM3, "5.9.4 Subsetting and Incremental Definition of Glyphs".
        */
        if (r_has_type(op, t_integer))
            cr.char_code = client_char_code;
        else {
            /* 
	     * Reverse Encoding here, because it can be an incremental one. 
	     * Note that this can cause problems with UFST (see the comment above),
	     * if the encoding doesn't contain the glyph name rendered with glyphshow.
	     */
            ref *Encoding;
            if (dict_find_string(osp - 1, "Encoding", &amp;Encoding) &gt; 0)
                cr.char_code = (uint)array_find(imemory, Encoding, op);
            else
                return_error(e_invalidfont);
        }
    } else { /* a non-embedded font, i.e. a disk font */
        bool can_retrieve_char_by_name = false;
        obj_string_data(imemory, &amp;char_name, &amp;cr.char_name, &amp;cr.char_name_length);
        if ((code = renderer_retcode(i_ctx_p, I, I-&gt;can_retrieve_char_by_name(I, &amp;ff, &amp;cr, &amp;can_retrieve_char_by_name))) &lt; 0)
	    return code;
        if (!can_retrieve_char_by_name) {
	    /* Translate from char name to encoding used with 3d party font technology : */
	    ref *Decoding, *char_code;
            if (dict_find_string(osp - 1, "Decoding", &amp;Decoding) &gt; 0 &amp;&amp; r_has_type(Decoding, t_dictionary)) {
	        if (dict_find(Decoding, &amp;char_name, &amp;char_code) &gt;= 0 &amp;&amp; r_has_type(char_code, t_integer))
		    int_param(char_code, 0xFFFF, &amp;cr.char_code);
	    }
        }
    } 

    /* Provide glyph data for renderer : */
    if (!ff.is_cid) {
	ref sname;
	name_string_ref(imemory, &amp;char_name, &amp;sname);
        ff.char_data = sname.value.const_bytes;
	ff.char_data_len = r_size(&amp;sname);
    } else if (ff.is_type1)
        ff.char_data = charstring;

    /* Compute the metrics replacement : */

    if(bCID &amp;&amp; !bIsType1GlyphData) {
	gs_font_cid2 *pfcid = (gs_font_cid2 *)pbfont;
	int MetricsCount = pfcid-&gt;cidata.MetricsCount;

	if (MetricsCount &gt; 0) {
	    const byte *data_ptr;
	    int l = get_GlyphDirectory_data_ptr(imemory, pdr, cr.char_code, &amp;data_ptr);

	    if (MetricsCount == 2 &amp;&amp; l &gt;= 4) {
		if (!bVertical0) {
		    cr.sb_x = GET_S16_MSB(data_ptr + 2) * scale;
		    cr.aw_x = GET_U16_MSB(data_ptr + 0) * scale;
		    cr.metrics_type = FAPI_METRICS_REPLACE;
		}
	    } else if (l &gt;= 8){
		cr.sb_y = GET_S16_MSB(data_ptr + 2) * scale;
		cr.aw_y = GET_U16_MSB(data_ptr + 0) * scale;
		cr.sb_x = GET_S16_MSB(data_ptr + 6) * scale;
		cr.aw_x = GET_U16_MSB(data_ptr + 4) * scale;
		cr.metrics_type = FAPI_METRICS_REPLACE;
	    }
	}
    }
    if (cr.metrics_type != FAPI_METRICS_REPLACE &amp;&amp; bVertical) {
	double pwv[4];
	code = zchar_get_metrics2(pbfont, &amp;char_name, pwv);
	if (code &lt; 0)
	    return code;
	if (code == metricsNone) {
	    if (bCID) {
		cr.sb_x = fapi_round(sbw[2] / 2 * scale);
		cr.sb_y = fapi_round(pbfont-&gt;FontBBox.q.y * scale);
		cr.aw_y = fapi_round(- pbfont-&gt;FontBBox.q.x * scale); /* Sic ! */
		cr.metrics_scale = (bIsType1GlyphData ? 1000 : 1);
		cr.metrics_type = FAPI_METRICS_REPLACE;
		sbw[0] = sbw[2] / 2;
		sbw[1] = pbfont-&gt;FontBBox.q.y;
		sbw[2] = 0;
		sbw[3] = - pbfont-&gt;FontBBox.q.x; /* Sic ! */
		sbw_state = SBW_DONE;
	    } else
		bVertical = false;
	} else {
	    cr.sb_x = fapi_round(pwv[2] * scale);
	    cr.sb_y = fapi_round(pwv[3] * scale);
	    cr.aw_x = fapi_round(pwv[0] * scale);
	    cr.aw_y = fapi_round(pwv[1] * scale);
	    cr.metrics_scale = (bIsType1GlyphData ? 1000 : 1);
	    cr.metrics_type = (code == metricsSideBearingAndWidth ? 
				FAPI_METRICS_REPLACE : FAPI_METRICS_REPLACE_WIDTH);
	    sbw[0] = pwv[2];
	    sbw[1] = pwv[3];
	    sbw[2] = pwv[0];
	    sbw[3] = pwv[1];
	    sbw_state = SBW_DONE;
	}
    }
    if (cr.metrics_type == FAPI_METRICS_NOTDEF &amp;&amp; !bVertical) {
	code = zchar_get_metrics(pbfont, &amp;char_name, sbw);
	if (code &lt; 0)
	    return code;
	if (code == metricsNone) {
	    sbw_state = SBW_FROM_RENDERER;
	    if (pbfont-&gt;FontType == 2) {
		gs_font_type1 *pfont1 = (gs_font_type1 *)pbfont;

		cr.aw_x = export_shift(pfont1-&gt;data.defaultWidthX, _fixed_shift - I-&gt;frac_shift);
		cr.metrics_scale = 1000;
		cr.metrics_type = FAPI_METRICS_ADD;
	    }
	} else {
	    cr.sb_x = fapi_round(sbw[2] * scale);
	    cr.sb_y = fapi_round(sbw[3] * scale);
	    cr.aw_x = fapi_round(sbw[0] * scale);
	    cr.aw_y = fapi_round(sbw[1] * scale);
	    cr.metrics_scale = (bIsType1GlyphData ? 1000 : 1);
	    cr.metrics_type = (code == metricsSideBearingAndWidth ? 
				FAPI_METRICS_REPLACE : FAPI_METRICS_REPLACE_WIDTH);
	    sbw_state = SBW_DONE;
	}
    }
    
    /* Take metrics from font : */
    if (SHOW_IS(penum, TEXT_DO_NONE)) {
	if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_char_width(I, &amp;ff, &amp;cr, &amp;metrics))) &lt; 0)
	    return code;
    } else if (igs-&gt;in_charpath) {
        if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_char_outline_metrics(I, &amp;ff, &amp;cr, &amp;metrics))) &lt; 0)
	    return code;
    } else {
        code = I-&gt;get_char_raster_metrics(I, &amp;ff, &amp;cr, &amp;metrics);
        if (code == e_limitcheck) {
            if(log2_scale.x &gt; 0 || log2_scale.y &gt; 0) {
                penum_s-&gt;fapi_log2_scale.x = log2_scale.x = penum_s-&gt;fapi_log2_scale.y = log2_scale.y = 0;
                I-&gt;release_char_data(I);
                goto retry_oversampling;
            }
            if ((code = renderer_retcode(i_ctx_p, I, I-&gt;get_char_outline_metrics(I, &amp;ff, &amp;cr, &amp;metrics))) &lt; 0)
		return code;
        } else {
            if ((code = renderer_retcode(i_ctx_p, I, code)) &lt; 0)
		return code;
        }
    }
    compute_em_scale(pbfont, &amp;metrics, FontMatrix_div, &amp;em_scale_x, &amp;em_scale_y);
    char_bbox.p.x = metrics.bbox_x0 / em_scale_x;
    char_bbox.p.y = metrics.bbox_y0 / em_scale_y;
    char_bbox.q.x = metrics.bbox_x1 / em_scale_x;
    char_bbox.q.y = metrics.bbox_y1 / em_scale_y;
    penum_s-&gt;fapi_glyph_shift.x = penum_s-&gt;fapi_glyph_shift.y = 0;
    if (sbw_state == SBW_FROM_RENDERER) {
	sbw[2] = metrics.escapement / em_scale_x;
	if (pbfont-&gt;FontType == 2) {
	    gs_font_type1 *pfont1 = (gs_font_type1 *)pbfont;

	    sbw[2] += fixed2float(pfont1-&gt;data.defaultWidthX);
	}
    } else if (sbw_state == SBW_SCALE) {
	sbw[0] = (double)cr.sb_x / scale / em_scale_x;
	sbw[1] = (double)cr.sb_y / scale / em_scale_y;
	sbw[2] = (double)cr.aw_x / scale / em_scale_x;
	sbw[3] = (double)cr.aw_y / scale / em_scale_y;
    }

    /* Setup cache and render : */
    if (cr.metrics_type == FAPI_METRICS_REPLACE) {
	/*
	 * Here we don't take care of replaced advance width 
	 * because gs_text_setcachedevice handles it.
	 */
	int can_replace_metrics;

        if ((code = renderer_retcode(i_ctx_p, I, I-&gt;can_replace_metrics(I, &amp;ff, &amp;cr, &amp;can_replace_metrics))) &lt; 0)
	    return code;
	if (!can_replace_metrics) {
	    /* 
	     * The renderer should replace the lsb, but it can't.
	     * To work around we compute a displacement in integral pixels
	     * and later shift the bitmap to it. The raster will be inprecise
	     * with non-integral pixels shift.
	     */
	    char_bbox.q.x -= char_bbox.p.x;
	    char_bbox.p.x = 0;
	    gs_distance_transform((metrics.bbox_x0 / em_scale_x - sbw[0]), 
				  0, ctm, &amp;penum_s-&gt;fapi_glyph_shift);
	    penum_s-&gt;fapi_glyph_shift.x *= font_scale.subpixels[0];
	    penum_s-&gt;fapi_glyph_shift.y *= font_scale.subpixels[1];
	}
    }
    /*
     * We assume that if bMetricsFromGlyphDirectory is true,
     * the font does not specify Metrics[2] and/or CDevProc
     * If someday we meet a font contradicting this assumption,
     * zchar_set_cache to be improved with additional flag,
     * to ignore Metrics[2] and CDevProc.
     *
     * Note that for best quality the result of CDevProc
     * to be passed to I-&gt;get_char_raster_metrics, because
     * both raster and metrics depend on replaced lsb.
     * Perhaps in many cases the metrics from font is
     * used as an argument for CDevProc. Only way to resolve
     * is to call I-&gt;get_char_raster_metrics twice (before
     * and after CDevProc), or better to split it into
     * smaller functions. Unfortunately UFST cannot retrieve metrics 
     * quickly and separately from raster. Only way to resolve is 
     * to devide the replaced lsb into 2 parts, which correspond to
     * integral and fractinal pixels, then pass the fractional shift
     * to renderer and apply the integer shift after it.
     *
     * Besides that, we are not sure what to do if a font
     * contains both Metrics[2] and CDevProc. Should
     * CDevProc to be applied to Metrics[2] or to the metrics
     * from glyph code ? Currently we keep a compatibility
     * to the native GS font renderer without a deep analyzis.
     */
    code = zchar_set_cache(i_ctx_p, pbfont, &amp;char_name,
		           NULL, sbw + 2, &amp;char_bbox,
			   fapi_finish_render, &amp;exec_cont, sbw);
    if (code &gt;= 0 &amp;&amp; exec_cont != 0)
	code = (*exec_cont)(i_ctx_p);
    if (code != 0) {
        if (code &lt; 0) {
            /* An error */
            I-&gt;release_char_data(I);
        } else { 
            /* Callout to CDevProc, zsetcachedevice2, fapi_finish_render. */
        }
    }
    return code;
}

private int FAPI_char(i_ctx_t *i_ctx_p, bool bBuildGlyph, ref *charstring)
{   /* Stack : &lt;font&gt; &lt;code|name&gt; --&gt; - */
    ref *v;
    char *font_file_path = NULL;
    gx_device *dev = gs_currentdevice_inline(igs);
    gs_font *pfont;
    int code = font_param(osp - 1, &amp;pfont);

    if (code == 0) {
        gs_font_base *pbfont = (gs_font_base *) pfont;
        if (dict_find_string(osp - 1, "Path", &amp;v) &gt; 0 &amp;&amp; r_has_type(v, t_string))
            font_file_path = ref_to_string(v, imemory, "font file path");
        code = FAPI_do_char(i_ctx_p, pbfont, dev, font_file_path, bBuildGlyph, charstring);
        if (font_file_path != NULL)
            gs_free_string(imemory, (byte *)font_file_path, r_size(v) + 1, "font file path");
    }
    return code;
}

private int FAPIBuildGlyph9aux(i_ctx_t *i_ctx_p)
{   os_ptr op = osp;                  /* &lt;font0&gt; &lt;cid&gt; &lt;font9&gt; &lt;cid&gt; */
    ref font9 = *pfont_dict(gs_currentfont(igs));
    ref *rFDArray, f;
    int font_index;
    int code;

    if ((code = ztype9mapcid(i_ctx_p)) &lt; 0)
	return code;  /* &lt;font0&gt; &lt;cid&gt; &lt;charstring&gt; &lt;font_index&gt; */
    /* fixme: what happens if the charstring is absent ? 
       Can FDArray contain 'null' (see %Type9BuildGlyph in gs_cidfn.ps)? */
    font_index = op[0].value.intval;
    if (dict_find_string(&amp;font9, "FDArray", &amp;rFDArray) &lt;= 0 || r_type(rFDArray) != t_array)
        return_error(e_invalidfont);
    if(array_get(imemory, rFDArray, font_index, &amp;f) &lt; 0 || r_type(&amp;f) != t_dictionary)
        return_error(e_invalidfont);
    op[0] = op[-2];                   
    op[-2] = op[-1]; /* Keep the charstring on ostack for the garbager. */
    op[-1] = f;                       /* &lt;font0&gt; &lt;charstring&gt; &lt;subfont&gt; &lt;cid&gt; */
    if ((code = FAPI_char(i_ctx_p, true, op - 2)) &lt; 0)
	return code;
                                      /* &lt;font0&gt; &lt;charstring&gt; */
    return 0;
}

/* &lt;font&gt; &lt;code&gt; .FAPIBuildChar - */
private int zFAPIBuildChar(i_ctx_t *i_ctx_p)
{   return FAPI_char(i_ctx_p, false, NULL);
}

/* non-CID : &lt;font&gt; &lt;code&gt; .FAPIBuildGlyph - */
/*     CID : &lt;font&gt; &lt;name&gt; .FAPIBuildGlyph - */
private int zFAPIBuildGlyph(i_ctx_t *i_ctx_p)
{   return FAPI_char(i_ctx_p, true, NULL);
}

/* &lt;font&gt; &lt;cid&gt; .FAPIBuildGlyph9 - */
private int zFAPIBuildGlyph9(i_ctx_t *i_ctx_p)
{   /*  The alghorithm is taken from %Type9BuildGlyph - see gs_cidfn.ps .  */
    os_ptr op = osp;
    int cid, code;
    avm_space s = ialloc_space(idmemory);

    check_type(op[ 0], t_integer);
    check_type(op[-1], t_dictionary);
    cid = op[0].value.intval;
    push(2);
    op[-1] = *pfont_dict(gs_currentfont(igs));
    op[0] = op[-2];                   /* &lt;font0&gt; &lt;cid&gt; &lt;font9&gt; &lt;cid&gt; */
    ialloc_set_space(idmemory, (r_is_local(op - 3) ? avm_global : avm_local)); /* for ztype9mapcid */
    code = FAPIBuildGlyph9aux(i_ctx_p);
    if (code != 0) {                  /* &lt;font0&gt; &lt;dirty&gt; &lt;dirty&gt; &lt;dirty&gt; */
        /* Adjust ostack for the correct error handling : */
        make_int(op - 2, cid);        
        pop(2);                       /* &lt;font0&gt; &lt;cid&gt; */
    } else {                          /* &lt;font0&gt; &lt;dirty&gt; */
        pop(2);                       /* */
        /*  Note that this releases the charstring, and it may be garbage-collected
            before the interpreter calls fapi_finish_render. This requires the server
            to keep glyph raster internally between calls to get_char_raster_metrics
            and get_char_raster. Perhaps UFST cannot provide metrics without 
            building a raster, so this constraint actually goes from UFST.
        */
    }
    ialloc_set_space(idmemory, s);
    return code;
}

private int do_FAPIpassfont(i_ctx_t *i_ctx_p, char *font_file_path, bool *success)
{   ref *pdr = osp;  /* font dict */
    gs_font *pfont;
    int code = font_param(osp, &amp;pfont);
    gs_font_base *pbfont;
    int BBox[4];
    i_plugin_holder *h = i_plugin_get_list(i_ctx_p);
    char *xlatmap = NULL;
    FAPI_font_scale font_scale = {{1, 0, 0, 1, 0, 0}, {0, 0}, {1, 1}, true};
    const char *decodingID = NULL;

    if (code &lt; 0)
	return code;
    code = FAPI_get_xlatmap(i_ctx_p, &amp;xlatmap);	/* Useful for emulated fonts hooked with FAPI. */
    if (code &lt; 0)
	return code;
    pbfont = (gs_font_base *)pfont;
    *success = false;
    for (; h != 0; h = h-&gt;next) {
	ref FAPI_ID;
        FAPI_server *I;
       	if (strcmp(h-&gt;I-&gt;d-&gt;type, "FAPI"))
            continue;
        I = (FAPI_server *)h-&gt;I;
        if ((code = renderer_retcode(i_ctx_p, I, I-&gt;ensure_open(I))) &lt; 0)
	    return code;
	font_scale.HWResolution[0] = font_scale.HWResolution[1] = 72 &lt;&lt; I-&gt;frac_shift;
	font_scale.matrix[0] = font_scale.matrix[3] = 1 &lt;&lt; I-&gt;frac_shift;

	code = FAPI_prepare_font(i_ctx_p, I, pdr, pbfont, font_file_path, &amp;font_scale, xlatmap, BBox, &amp;decodingID);
	if (code &lt; 0) {
            /* Failed, skip this renderer : */
	    continue;
	}
        pbfont-&gt;FAPI = I; /* We found a good renderer, so go with it */
        if ((code = name_ref(imemory, (const byte *)I-&gt;ig.d-&gt;subtype, strlen(I-&gt;ig.d-&gt;subtype), &amp;FAPI_ID, false)) &lt; 0)
	    return code;
	if ((code = dict_put_string(pdr, "FAPI", &amp;FAPI_ID, NULL)) &lt; 0)
	    return code; /* Insert FAPI entry to font dictionary. */
	*success = true;
	return 0;
    }
    /* Could not find renderer, return with false success. */
    return 0;
}

/* &lt;font_dict&gt; .FAPIpassfont bool &lt;font_dict&gt; */
/* must insert /FAPI to font dictionary */
/* This operator must not be called with devices which embed fonts. */
private int zFAPIpassfont(i_ctx_t *i_ctx_p)
{   os_ptr op = osp;
    int code;
    bool found;
    char *font_file_path = NULL;
    ref *v;

    /* Normally embedded fonts have no Path, but if a CID font is
     * emulated with a TT font, and it is hooked with FAPI,
     * the path presents and is neccessary to access the full font data.
     */
    check_type(*op, t_dictionary);
    if (dict_find_string(op, "Path", &amp;v) &gt; 0 &amp;&amp; r_has_type(v, t_string))
        font_file_path = ref_to_string(v, imemory_global, "font file path");
    code = do_FAPIpassfont(i_ctx_p, font_file_path, &amp;found);
    if (font_file_path != NULL)
        gs_free_string(imemory_global, (byte *)font_file_path, r_size(v) + 1, "font file path");
    if(code != 0)
	return code;
    push(1);
    make_bool(op, found);
    return 0;
}

const op_def zfapi_op_defs[] =
{   {"2.FAPIavailable",   zFAPIavailable},
    {"2.FAPIpassfont",    zFAPIpassfont},
    {"2.FAPIrebuildfont", zFAPIrebuildfont},
    {"2.FAPIBuildChar",   zFAPIBuildChar},
    {"2.FAPIBuildGlyph",  zFAPIBuildGlyph},
    {"2.FAPIBuildGlyph9", zFAPIBuildGlyph9},
    op_def_end(0)
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

