<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfcid0.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfcid0.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfcid0.c,v 1.25 2004/11/19 04:39:11 ray Exp $ */
/* CIDFontType 0 operators */
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gsmatrix.h"
#include "gsccode.h"
#include "gsstruct.h"
#include "gxfcid.h"
#include "gxfont1.h"
#include "gxalloc.h"		/* for gs_ref_memory_t */
#include "stream.h"		/* for files.h */
#include "bfont.h"
#include "files.h"
#include "ichar.h"
#include "ichar1.h"
#include "icid.h"
#include "idict.h"
#include "idparam.h"
#include "ifcid.h"
#include "ifont1.h"
#include "ifont2.h"
#include "ifont42.h"
#include "store.h"

/* Type 1 font procedures (defined in zchar1.c) */
font_proc_glyph_outline(zcharstring_glyph_outline);

/* ---------------- CIDFontType 0 (FontType 9) ---------------- */

/* ------ Accessing ------ */

/* Parse a multi-byte integer from a string. */
private int
get_index(gs_glyph_data_t *pgd, int count, ulong *pval)
{
    int i;

    if (pgd-&gt;bits.size &lt; count)
	return_error(e_rangecheck);
    *pval = 0;
    for (i = 0; i &lt; count; ++i)
	*pval = (*pval &lt;&lt; 8) + pgd-&gt;bits.data[i];
    pgd-&gt;bits.data += count;
    pgd-&gt;bits.size -= count;
    return 0;
}

/* Get bytes from GlyphData or DataSource. */
private int
cid0_read_bytes(gs_font_cid0 *pfont, ulong base, uint count, byte *buf,
		gs_glyph_data_t *pgd)
{
    const font_data *pfdata = pfont_data(pfont);
    byte *data = buf;
    gs_font *gdfont = 0;	/* pfont if newly allocated, 0 if not */
    int code = 0;

    /* Check for overflow. */
    if (base != (long)base || base &gt; base + count)
	return_error(e_rangecheck);
    if (r_has_type(&amp;pfdata-&gt;u.cid0.DataSource, t_null)) {
	/* Get the bytes from GlyphData (a string or array of strings). */
	const ref *pgdata = &amp;pfdata-&gt;u.cid0.GlyphData;

	if (r_has_type(pgdata, t_string)) {  /* single string */
	    uint size = r_size(pgdata);

	    if (base &gt;= size || count &gt; size - base)
		return_error(e_rangecheck);
	    data = pgdata-&gt;value.bytes + base;
	} else {		/* array of strings */
	    /*
	     * The algorithm is similar to the one in
	     * string_array_access_proc in zfont42.c, but it also has to
	     * deal with the case where the requested string crosses array
	     * elements.
	     */
	    ulong skip = base;
	    uint copied = 0;
	    uint index = 0;
	    ref rstr;
	    uint size;

	    for (;; skip -= size, ++index) {
		int code = array_get(pfont-&gt;memory, pgdata, index, &amp;rstr);

		if (code &lt; 0)
		    return code;
		if (!r_has_type(&amp;rstr, t_string))
		    return_error(e_typecheck);
		size = r_size(&amp;rstr);
		if (skip &lt; size)
		    break;
	    }
	    size -= skip;
	    if (count &lt;= size) {
		data = rstr.value.bytes + skip;
	    } else {		/* multiple strings needed */
		if (data == 0) {  /* no buffer provided */
		    data = gs_alloc_string(pfont-&gt;memory, count,
					   "cid0_read_bytes");
		    if (data == 0)
			return_error(e_VMerror);
		    gdfont = (gs_font *)pfont; /* newly allocated */
		}
		memcpy(data, rstr.value.bytes + skip, size);
		copied = size;
		while (copied &lt; count) {
		    int code = array_get(pfont-&gt;memory, pgdata, ++index, &amp;rstr);

		    if (code &lt; 0)
			goto err;
		    if (!r_has_type(&amp;rstr, t_string)) {
			code = gs_note_error(e_typecheck);
			goto err;
		    }
		    size = r_size(&amp;rstr);
		    if (size &gt; count - copied)
			size = count - copied;
		    memcpy(data + copied, rstr.value.bytes, size);
		    copied += size;
		}
	    }
	}
    } else {
	/* Get the bytes from DataSource (a stream). */
	stream *s;
	uint nread;

	check_read_known_file(s, &amp;pfdata-&gt;u.cid0.DataSource, return_error);
	if (sseek(s, base) &lt; 0)
	    return_error(e_ioerror);
	if (data == 0) {	/* no buffer provided */
	    data = gs_alloc_string(pfont-&gt;memory, count, "cid0_read_bytes");
	    if (data == 0)
		return_error(e_VMerror);
	    gdfont = (gs_font *)pfont; /* newly allocated */
	}
	if (sgets(s, data, count, &amp;nread) &lt; 0 || nread != count) {
	    code = gs_note_error(e_ioerror);
	    goto err;
	}
    }
    gs_glyph_data_from_string(pgd, data, count, gdfont);
    return code;
 err:
    if (data != buf)
	gs_free_string(pfont-&gt;memory, data, count, "cid0_read_bytes");
    return code;
}

/* Get the CharString data for a CIDFontType 0 font. */
/* This is the glyph_data procedure in the font itself. */
/* Note that pgd may be NULL. */
private int
z9_glyph_data(gs_font_base *pbfont, gs_glyph glyph, gs_glyph_data_t *pgd,
	      int *pfidx)
{
    gs_font_cid0 *pfont = (gs_font_cid0 *)pbfont;
    const font_data *pfdata = pfont_data(pfont);
    long glyph_index = (long)(glyph - gs_min_cid_glyph);
    gs_glyph_data_t gdata;
    ulong fidx;
    int code;

    gdata.memory = pfont-&gt;memory;
    if (!r_has_type(&amp;pfdata-&gt;u.cid0.GlyphDirectory, t_null)) {
        code = font_gdir_get_outline(pfont-&gt;memory,
				     &amp;pfdata-&gt;u.cid0.GlyphDirectory,
				     glyph_index, &amp;gdata);
	if (code &lt; 0)
	    return code;
	/* Get the definition from GlyphDirectory. */
	if (!gdata.bits.data)
	    return_error(e_rangecheck);
	code = get_index(&amp;gdata, pfont-&gt;cidata.FDBytes, &amp;fidx);
	if (code &lt; 0)
	    return code;
	if (fidx &gt;= pfont-&gt;cidata.FDArray_size)
	    return_error(e_rangecheck);
	if (pgd)
	    *pgd = gdata;
	*pfidx = (int)fidx;
	return code;
    }
    /* Get the definition from the binary data (GlyphData or DataSource). */
    if (glyph_index &lt; 0 || glyph_index &gt;= pfont-&gt;cidata.common.CIDCount) {
	*pfidx = 0;
	if (pgd)
	    gs_glyph_data_from_null(pgd);
	return_error(e_rangecheck);
    }
    {
	byte fd_gd[(MAX_FDBytes + MAX_GDBytes) * 2];
	uint num_bytes = pfont-&gt;cidata.FDBytes + pfont-&gt;cidata.common.GDBytes;
	ulong base = pfont-&gt;cidata.CIDMapOffset + glyph_index * num_bytes;
	ulong gidx, fidx_next, gidx_next;
	int rcode = cid0_read_bytes(pfont, base, (ulong)(num_bytes * 2), fd_gd,
				    &amp;gdata);
	gs_glyph_data_t orig_data;

	if (rcode &lt; 0)
	    return rcode;
	orig_data = gdata;
	if ((code = get_index(&amp;gdata, pfont-&gt;cidata.FDBytes, &amp;fidx)) &lt; 0 ||
	    (code = get_index(&amp;gdata, pfont-&gt;cidata.common.GDBytes, &amp;gidx)) &lt; 0 ||
	    (code = get_index(&amp;gdata, pfont-&gt;cidata.FDBytes, &amp;fidx_next)) &lt; 0 ||
	    (code = get_index(&amp;gdata, pfont-&gt;cidata.common.GDBytes, &amp;gidx_next)) &lt; 0
	    )
	    DO_NOTHING;
	gs_glyph_data_free(&amp;orig_data, "z9_glyph_data");
	if (code &lt; 0)
	    return code;
	/*
	 * Some CID fonts (from Adobe!) have invalid font indexes for
	 * missing glyphs.  Handle this now.
	 */
	if (gidx_next &lt;= gidx) { /* missing glyph */
	    *pfidx = 0;
	    if (pgd)
		gs_glyph_data_from_null(pgd);
	    return_error(e_undefined);
	}
	if (fidx &gt;= pfont-&gt;cidata.FDArray_size)
	    return_error(e_rangecheck);
	*pfidx = (int)fidx;
	if (pgd == 0)
	    return 0;
	return cid0_read_bytes(pfont, gidx, gidx_next - gidx, NULL, pgd);
    }
}

/* Get the outline of a CIDFontType 0 glyph. */
private int
z9_glyph_outline(gs_font *font, int WMode, gs_glyph glyph, const gs_matrix *pmat,
		 gx_path *ppath, double sbw[4])
{
    gs_font_cid0 *const pfcid = (gs_font_cid0 *)font;
    ref gref;
    gs_glyph_data_t gdata;
    int code, fidx, ocode;

    gdata.memory = font-&gt;memory;
    code = pfcid-&gt;cidata.glyph_data((gs_font_base *)pfcid, glyph, &amp;gdata,
				    &amp;fidx);
    if (code &lt; 0)
	return code;
    glyph_ref(font-&gt;memory, glyph, &amp;gref);
    ocode = zcharstring_outline(pfcid-&gt;cidata.FDArray[fidx], WMode, &amp;gref, &amp;gdata,
				pmat, ppath, sbw);
    gs_glyph_data_free(&amp;gdata, "z9_glyph_outline");
    return ocode;
}

private int
z9_glyph_info(gs_font *font, gs_glyph glyph, const gs_matrix *pmat,
		     int members, gs_glyph_info_t *info)
{   /* fixme : same as z11_glyph_info. */
    int wmode = (members &amp; GLYPH_INFO_WIDTH0 ? 0 : 1);

    return z1_glyph_info_generic(font, glyph, pmat, members, info, 
				    &amp;gs_default_glyph_info, wmode);
}


/*
 * The "fonts" in the FDArray don't have access to their outlines -- the
 * outlines are always provided externally.  Replace the accessor procedures
 * with ones that will give an error if called.
 */
private int
z9_FDArray_glyph_data(gs_font_type1 * pfont, gs_glyph glyph,
		      gs_glyph_data_t *pgd)
{
    return_error(e_invalidfont);
}
private int
z9_FDArray_seac_data(gs_font_type1 *pfont, int ccode, gs_glyph *pglyph,
		     gs_const_string *gstr, gs_glyph_data_t *pgd)
{
    return_error(e_invalidfont);
}

/* ------ Defining ------ */

/* Get one element of a FDArray. */
private int
fd_array_element(i_ctx_t *i_ctx_p, gs_font_type1 **ppfont, ref *prfd)
{
    charstring_font_refs_t refs;
    gs_type1_data data1;
    build_proc_refs build;
    gs_font_base *pbfont;
    gs_font_type1 *pfont;
    /*
     * Standard CIDFontType 0 fonts have Type 1 fonts in the FDArray, but
     * CFF CIDFontType 0 fonts have Type 2 fonts there.
     */
    int fonttype = 1;		/* default */
    int code = charstring_font_get_refs(prfd, &amp;refs);

    if (code &lt; 0 ||
	(code = dict_int_param(prfd, "FontType", 1, 2, 1, &amp;fonttype)) &lt; 0
	)
	return code;
    /*
     * We don't handle the alternate Subr representation (SubrCount,
     * SDBytes, SubrMapOffset) here: currently that is handled in
     * PostScript code (lib/gs_cidfn.ps).
     */
    switch (fonttype) {
    case 1:
	data1.interpret = gs_type1_interpret;
	data1.subroutineNumberBias = 0;
	data1.lenIV = DEFAULT_LENIV_1;
	code = charstring_font_params(imemory, prfd, &amp;refs, &amp;data1);
	if (code &lt; 0)
	    return code;
	code = build_proc_name_refs(imemory, &amp;build,
				    "%Type1BuildChar", "%Type1BuildGlyph");
	break;
    case 2:
	code = type2_font_params(prfd, &amp;refs, &amp;data1);
	if (code &lt; 0)
	    return code;
	code = charstring_font_params(imemory, prfd, &amp;refs, &amp;data1);
	if (code &lt; 0)
	    return code;
	code = build_proc_name_refs(imemory, &amp;build,
				    "%Type2BuildChar", "%Type2BuildGlyph");
	break;
    default:			/* can't happen */
	return_error(e_Fatal);
    }
    if (code &lt; 0)
	return code;
    code = build_gs_FDArray_font(i_ctx_p, prfd, &amp;pbfont, fonttype,
				 &amp;st_gs_font_type1, &amp;build);
    if (code &lt; 0)
	return code;
    pfont = (gs_font_type1 *)pbfont;
    pbfont-&gt;FAPI = NULL;
    pbfont-&gt;FAPI_font_data = NULL;
    charstring_font_init(pfont, &amp;refs, &amp;data1);
    pfont-&gt;data.procs.glyph_data = z9_FDArray_glyph_data;
    pfont-&gt;data.procs.seac_data = z9_FDArray_seac_data;
    *ppfont = pfont;
    return 0;
}



private int 
notify_remove_font_type9(void *proc_data, void *event_data)
{  /* Likely type 9 font descendents are never released explicitly.
      So releaseing a type 9 font we must reset pointers in descendents.
    */
    /* gs_font_finalize passes event_data == NULL, so check it here. */
    if (event_data == NULL) {
        gs_font_cid0 *pfcid = proc_data;
	int i;

	for (i = 0; i &lt; pfcid-&gt;cidata.FDArray_size; ++i) {
	    if (pfcid-&gt;cidata.FDArray[i]-&gt;data.parent == (gs_font_base *)pfcid)
		pfcid-&gt;cidata.FDArray[i]-&gt;data.parent = NULL;
	}
    }
    return 0;
}

/* &lt;string|name&gt; &lt;font_dict&gt; .buildfont9 &lt;string|name&gt; &lt;font&gt; */
private int
zbuildfont9(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    build_proc_refs build;
    int code = build_proc_name_refs(imemory, &amp;build, NULL, "%Type9BuildGlyph");
    gs_font_cid_data common;
    ref GlyphDirectory, GlyphData, DataSource;
    ref *prfda, cfnstr;
    ref *pCIDFontName, CIDFontName;
    gs_font_type1 **FDArray;
    uint FDArray_size;
    int FDBytes;
    uint CIDMapOffset;
    gs_font_base *pfont;
    gs_font_cid0 *pfcid;
    uint i;

    /*
     * If the CIDFont's data have been loaded into VM, GlyphData will be
     * a string or an array of strings; if they are loaded incrementally
     * from a file, GlyphData will be an integer, and DataSource will be
     * a (reusable) stream.
     */
    if (code &lt; 0 ||
	(code = cid_font_data_param(op, &amp;common, &amp;GlyphDirectory)) &lt; 0 ||
	(code = dict_find_string(op, "FDArray", &amp;prfda)) &lt; 0 ||
	(code = dict_find_string(op, "CIDFontName", &amp;pCIDFontName)) &lt;= 0 ||
	(code = dict_int_param(op, "FDBytes", 0, MAX_FDBytes, -1, &amp;FDBytes)) &lt; 0
	)
	return code;
    /*
     * Since build_gs_simple_font may resize the dictionary and cause
     * pointers to become invalid, save CIDFontName
     */
    CIDFontName = *pCIDFontName;
    if (r_has_type(&amp;GlyphDirectory, t_null)) {
	/* Standard CIDFont, require GlyphData and CIDMapOffset. */
	ref *pGlyphData;

	if ((code = dict_find_string(op, "GlyphData", &amp;pGlyphData)) &lt; 0 ||
	    (code = dict_uint_param(op, "CIDMapOffset", 0, max_uint - 1,
				    max_uint, &amp;CIDMapOffset)) &lt; 0)
	    return code;
	GlyphData = *pGlyphData;
	if (r_has_type(&amp;GlyphData, t_integer)) {
	    ref *pds;
	    stream *ignore_s;

	    if ((code = dict_find_string(op, "DataSource", &amp;pds)) &lt; 0)
		return code;
	    check_read_file(ignore_s, pds);
	    DataSource = *pds;
	} else {
	    if (!r_has_type(&amp;GlyphData, t_string) &amp;&amp; !r_is_array(&amp;GlyphData))
		return_error(e_typecheck);
	    make_null(&amp;DataSource);
	}
    } else {
	make_null(&amp;GlyphData);
	make_null(&amp;DataSource);
	CIDMapOffset = 0;
    }
    if (!r_is_array(prfda))
	return_error(e_invalidfont);
    FDArray_size = r_size(prfda);
    if (FDArray_size == 0)
	return_error(e_invalidfont);
    FDArray = ialloc_struct_array(FDArray_size, gs_font_type1 *,
				  &amp;st_gs_font_type1_ptr_element,
				  "buildfont9(FDarray)");
    if (FDArray == 0)
	return_error(e_VMerror);
    memset(FDArray, 0, sizeof(gs_font_type1 *) * FDArray_size);
    for (i = 0; i &lt; FDArray_size; ++i) {
	ref rfd;

	array_get(imemory, prfda, (long)i, &amp;rfd);
	code = fd_array_element(i_ctx_p, &amp;FDArray[i], &amp;rfd);
	if (code &lt; 0)
	    goto fail;
    }
    code = build_gs_simple_font(i_ctx_p, op, &amp;pfont, ft_CID_encrypted,
				&amp;st_gs_font_cid0, &amp;build,
				bf_Encoding_optional |
				bf_UniqueID_ignored);
    if (code &lt; 0)
	goto fail;
    pfont-&gt;procs.enumerate_glyph = gs_font_cid0_enumerate_glyph;
    pfont-&gt;procs.glyph_outline = z9_glyph_outline;
    pfont-&gt;procs.glyph_info = z9_glyph_info;
    pfcid = (gs_font_cid0 *)pfont;
    pfcid-&gt;cidata.common = common;
    pfcid-&gt;cidata.CIDMapOffset = CIDMapOffset;
    pfcid-&gt;cidata.FDArray = FDArray;
    pfcid-&gt;cidata.FDArray_size = FDArray_size;
    pfcid-&gt;cidata.FDBytes = FDBytes;
    pfcid-&gt;cidata.glyph_data = z9_glyph_data;
    pfcid-&gt;cidata.proc_data = 0;	/* for GC */
    get_font_name(imemory, &amp;cfnstr, &amp;CIDFontName);
    copy_font_name(&amp;pfcid-&gt;font_name, &amp;cfnstr);
    ref_assign(&amp;pfont_data(pfont)-&gt;u.cid0.GlyphDirectory, &amp;GlyphDirectory);
    ref_assign(&amp;pfont_data(pfont)-&gt;u.cid0.GlyphData, &amp;GlyphData);
    ref_assign(&amp;pfont_data(pfont)-&gt;u.cid0.DataSource, &amp;DataSource);
    code = define_gs_font((gs_font *)pfont);
    if (code &gt;= 0)
       code = gs_notify_register(&amp;pfont-&gt;notify_list, notify_remove_font_type9, pfont);
    if (code &gt;= 0) {
	for (i = 0; i &lt; FDArray_size; ++i) {
	    FDArray[i]-&gt;dir = pfont-&gt;dir;
	    FDArray[i]-&gt;data.parent = pfont;
	}
	return code;
    }
 fail:
    ifree_object(FDArray, "buildfont9(FDarray)");
    return code;
}

/* &lt;cid9font&gt; &lt;cid&gt; .type9mapcid &lt;charstring&gt; &lt;font_index&gt; */
int
ztype9mapcid(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_font *pfont;
    gs_font_cid0 *pfcid;
    int code = font_param(op - 1, &amp;pfont);
    gs_glyph_data_t gdata;
    int fidx;

    if (code &lt; 0)
	return code;
    if (pfont-&gt;FontType != ft_CID_encrypted)
	return_error(e_invalidfont);
    check_type(*op, t_integer);
    pfcid = (gs_font_cid0 *)pfont;
    gdata.memory = pfont-&gt;memory;
    code = pfcid-&gt;cidata.glyph_data((gs_font_base *)pfcid,
			(gs_glyph)(gs_min_cid_glyph + op-&gt;value.intval),
				    &amp;gdata, &amp;fidx);

    /* return code; original error-sensitive &amp; fragile code */
    if (code &lt; 0) { /* failed to load glyph data, put CID 0 */
       int default_fallback_CID = 0 ;

       if_debug2('J', "[J]ztype9cidmap() use CID %d instead of glyph-missing CID %d\n", default_fallback_CID, op-&gt;value.intval);

       op-&gt;value.intval = default_fallback_CID;

       /* reload glyph for default_fallback_CID */

       code = pfcid-&gt;cidata.glyph_data((gs_font_base *)pfcid,
                    (gs_glyph)(gs_min_cid_glyph + default_fallback_CID),
                                   &amp;gdata, &amp;fidx);

       if (code &lt; 0) {
           if_debug1('J', "[J]ztype9cidmap() could not load default glyph (CID %d)\n", op-&gt;value.intval);
           return_error(e_invalidfont);
       }

    }

    /****** FOLLOWING IS NOT GENERAL W.R.T. ALLOCATION OF GLYPH DATA ******/
    make_const_string(op - 1, 
		      a_readonly | imemory_space((gs_ref_memory_t *)pfont-&gt;memory), 
		      gdata.bits.size, 
		      gdata.bits.data);
    make_int(op, fidx);
    return code;
}

/* ------ Initialization procedure ------ */

const op_def zfcid0_op_defs[] =
{
    {"2.buildfont9", zbuildfont9},
    {"2.type9mapcid", ztype9mapcid},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

