<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfilter.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfilter.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1993, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfilter.c,v 1.10 2004/01/17 20:46:32 dan Exp $ */
/* Filter creation */
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gsstruct.h"
#include "ialloc.h"
#include "idict.h"
#include "idparam.h"
#include "ilevel.h"		/* SubFileDecode is different in LL3 */
#include "stream.h"
#include "strimpl.h"
#include "sfilter.h"
#include "srlx.h"
#include "sstring.h"
#include "ifilter.h"
#include "files.h"		/* for filter_open, file_d'_buffer_size */

/* &lt;source&gt; ASCIIHexEncode/filter &lt;file&gt; */
/* &lt;source&gt; &lt;dict&gt; ASCIIHexEncode/filter &lt;file&gt; */
private int
zAXE(i_ctx_t *i_ctx_p)
{
    return filter_write_simple(i_ctx_p, &amp;s_AXE_template);
}

/* &lt;target&gt; ASCIIHexDecode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;dict&gt; ASCIIHexDecode/filter &lt;file&gt; */
private int
zAXD(i_ctx_t *i_ctx_p)
{
    return filter_read_simple(i_ctx_p, &amp;s_AXD_template);
}

/* &lt;target&gt; NullEncode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;dict_ignored&gt; NullEncode/filter &lt;file&gt; */
private int
zNullE(i_ctx_t *i_ctx_p)
{
    return filter_write_simple(i_ctx_p, &amp;s_NullE_template);
}

/* &lt;source&gt; &lt;bool&gt; PFBDecode/filter &lt;file&gt; */
/* &lt;source&gt; &lt;dict&gt; &lt;bool&gt; PFBDecode/filter &lt;file&gt; */
private int
zPFBD(i_ctx_t *i_ctx_p)
{
    os_ptr sop = osp;
    stream_PFBD_state state;

    check_type(*sop, t_boolean);
    state.binary_to_hex = sop-&gt;value.boolval;
    return filter_read(i_ctx_p, 1, &amp;s_PFBD_template, (stream_state *)&amp;state, 0);
}

/* &lt;target&gt; PSStringEncode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;dict&gt; PSStringEncode/filter &lt;file&gt; */
private int
zPSSE(i_ctx_t *i_ctx_p)
{
    return filter_write_simple(i_ctx_p, &amp;s_PSSE_template);
}

/* ------ RunLength filters ------ */

/* Common setup for RLE and RLD filters. */
private int
rl_setup(os_ptr dop, bool * eod)
{
    if (r_has_type(dop, t_dictionary)) {
	int code;

	check_dict_read(*dop);
	if ((code = dict_bool_param(dop, "EndOfData", true, eod)) &lt; 0)
	    return code;
	return 1;
    } else {
	*eod = true;
	return 0;
    }
}

/* &lt;target&gt; &lt;record_size&gt; RunLengthEncode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;dict&gt; &lt;record_size&gt; RunLengthEncode/filter &lt;file&gt; */
private int
zRLE(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_RLE_state state;
    int code;

    check_op(2);
    code = rl_setup(op - 1, &amp;state.EndOfData);
    if (code &lt; 0)
	return code;
    check_int_leu(*op, max_uint);
    state.record_size = op-&gt;value.intval;
    return filter_write(i_ctx_p, 1, &amp;s_RLE_template, (stream_state *) &amp; state, 0);
}

/* &lt;source&gt; RunLengthDecode/filter &lt;file&gt; */
/* &lt;source&gt; &lt;dict&gt; RunLengthDecode/filter &lt;file&gt; */
private int
zRLD(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_RLD_state state;
    int code = rl_setup(op, &amp;state.EndOfData);

    if (code &lt; 0)
	return code;
    return filter_read(i_ctx_p, 0, &amp;s_RLD_template, (stream_state *) &amp; state, 0);
}

/* &lt;source&gt; &lt;EODcount&gt; &lt;EODstring&gt; SubFileDecode/filter &lt;file&gt; */
/* &lt;source&gt; &lt;dict&gt; &lt;EODcount&gt; &lt;EODstring&gt; SubFileDecode/filter &lt;file&gt; */
/* &lt;source&gt; &lt;dict&gt; SubFileDecode/filter &lt;file&gt; *//* (LL3 only) */
private int
zSFD(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_SFD_state state;
    ref *sop = op;
    int npop;

    if (s_SFD_template.set_defaults)
	s_SFD_template.set_defaults((stream_state *)&amp;state);
    if (LL3_ENABLED &amp;&amp; r_has_type(op, t_dictionary)) {
	int count;
	int code;

	check_dict_read(*op);
	/*
	 * The PLRM-3rd says that EODCount is a required parameter.  However
	 * Adobe accepts files without this value and apparently defaults to
	 * zero.  Thus we are doing the same.
	 */
	if ((code = dict_int_param(op, "EODCount", 0, max_int, 0, &amp;count)) &lt; 0)
	    return code;
	if (dict_find_string(op, "EODString", &amp;sop) &lt;= 0)
	    return_error(e_rangecheck);
	state.count = count;
	npop = 0;
    } else {
	check_type(sop[-1], t_integer);
	if (sop[-1].value.intval &lt; 0)
	    return_error(e_rangecheck);
	state.count = sop[-1].value.intval;
	npop = 2;
    }
    check_read_type(*sop, t_string);
    state.eod.data = sop-&gt;value.const_bytes;
    state.eod.size = r_size(sop);
    return filter_read(i_ctx_p, npop, &amp;s_SFD_template,
		       (stream_state *)&amp;state, r_space(sop));
}

/* ------ Utilities ------ */

/* Forward references */
private int filter_ensure_buf(stream **, uint, gs_ref_memory_t *, bool);

/* Set up an input filter. */
int
filter_read(i_ctx_t *i_ctx_p, int npop, const stream_template * template,
	    stream_state * st, uint space)
{
    os_ptr op = osp;
    uint min_size = template-&gt;min_out_size + max_min_left;
    uint save_space = ialloc_space(idmemory);
    uint use_space = max(space, save_space);
    os_ptr sop = op - npop;
    stream *s;
    stream *sstrm;
    bool close = false;
    int code;

    /* Skip over an optional dictionary parameter. */
    if (r_has_type(sop, t_dictionary)) {
	check_dict_read(*sop);
	if ((code = dict_bool_param(sop, "CloseSource", false, &amp;close)) &lt; 0)
	    return code;
	--sop;
    }
    /*
     * Check to make sure that the underlying data
     * can function as a source for reading.
     */
    use_space = max(use_space, r_space(sop));
    switch (r_type(sop)) {
	case t_string:
	    check_read(*sop);
	    ialloc_set_space(idmemory, use_space);
	    sstrm = file_alloc_stream(imemory, "filter_read(string stream)");
	    if (sstrm == 0) {
		code = gs_note_error(e_VMerror);
		goto out;
	    }
	    sread_string(sstrm, sop-&gt;value.bytes, r_size(sop));
	    sstrm-&gt;is_temp = 1;
	    break;
	case t_file:
	    check_read_known_file(sstrm, sop, return);
	    ialloc_set_space(idmemory, use_space);
	    goto ens;
	default:
	    check_proc(*sop);
	    ialloc_set_space(idmemory, use_space);
	    code = sread_proc(sop, &amp;sstrm, iimemory);
	    if (code &lt; 0)
		goto out;
	    sstrm-&gt;is_temp = 2;
	  ens:
	    code = filter_ensure_buf(&amp;sstrm,
				     template-&gt;min_in_size +
				     sstrm-&gt;state-&gt;template-&gt;min_out_size,
				     iimemory, false);
	    if (code &lt; 0)
		goto out;
	    break;
    }
    if (min_size &lt; 128)
	min_size = file_default_buffer_size;
    code = filter_open("r", min_size, (ref *) sop,
		       &amp;s_filter_read_procs, template, st, imemory);
    if (code &lt; 0)
	goto out;
    s = fptr(sop);
    s-&gt;strm = sstrm;
    s-&gt;close_strm = close;
    pop(op - sop);
out:
    ialloc_set_space(idmemory, save_space);
    return code;
}
int
filter_read_simple(i_ctx_t *i_ctx_p, const stream_template * template)
{
    return filter_read(i_ctx_p, 0, template, NULL, 0);
}

/* Set up an output filter. */
int
filter_write(i_ctx_t *i_ctx_p, int npop, const stream_template * template,
	     stream_state * st, uint space)
{
    os_ptr op = osp;
    uint min_size = template-&gt;min_in_size + max_min_left;
    uint save_space = ialloc_space(idmemory);
    uint use_space = max(space, save_space);
    register os_ptr sop = op - npop;
    stream *s;
    stream *sstrm;
    bool close = false;
    int code;

    /* Skip over an optional dictionary parameter. */
    if (r_has_type(sop, t_dictionary)) {
	check_dict_read(*sop);
	if ((code = dict_bool_param(sop, "CloseTarget", false, &amp;close)) &lt; 0)
	    return code;
	--sop;
    }
    /*
     * Check to make sure that the underlying data
     * can function as a sink for writing.
     */
    use_space = max(use_space, r_space(sop));
    switch (r_type(sop)) {
	case t_string:
	    check_write(*sop);
	    ialloc_set_space(idmemory, use_space);
	    sstrm = file_alloc_stream(imemory, "filter_write(string)");
	    if (sstrm == 0) {
		code = gs_note_error(e_VMerror);
		goto out;
	    }
	    swrite_string(sstrm, sop-&gt;value.bytes, r_size(sop));
	    sstrm-&gt;is_temp = 1;
	    break;
	case t_file:
	    check_write_known_file(sstrm, sop, return);
	    ialloc_set_space(idmemory, use_space);
	    goto ens;
	default:
	    check_proc(*sop);
	    ialloc_set_space(idmemory, use_space);
	    code = swrite_proc(sop, &amp;sstrm, iimemory);
	    if (code &lt; 0)
		goto out;
	    sstrm-&gt;is_temp = 2;
	  ens:
	    code = filter_ensure_buf(&amp;sstrm,
				     template-&gt;min_out_size +
				     sstrm-&gt;state-&gt;template-&gt;min_in_size,
				     iimemory, true);
	    if (code &lt; 0)
		goto out;
	    break;
    }
    if (min_size &lt; 128)
	min_size = file_default_buffer_size;
    code = filter_open("w", min_size, (ref *) sop,
		       &amp;s_filter_write_procs, template, st, imemory);
    if (code &lt; 0)
	goto out;
    s = fptr(sop);
    s-&gt;strm = sstrm;
    s-&gt;close_strm = close;
    pop(op - sop);
out:
    ialloc_set_space(idmemory, save_space);
    return code;
}
int
filter_write_simple(i_ctx_t *i_ctx_p, const stream_template * template)
{
    return filter_write(i_ctx_p, 0, template, NULL, 0);
}

/* Define a byte-at-a-time NullDecode filter for intermediate buffers. */
/* (The standard NullDecode filter can read ahead too far.) */
private int
s_Null1D_process(stream_state * st, stream_cursor_read * pr,
		 stream_cursor_write * pw, bool last)
{
    if (pr-&gt;ptr &gt;= pr-&gt;limit)
	return 0;
    if (pw-&gt;ptr &gt;= pw-&gt;limit)
	return 1;
    *++(pw-&gt;ptr) = *++(pr-&gt;ptr);
    return 1;
}
private const stream_template s_Null1D_template = {
    &amp;st_stream_state, NULL, s_Null1D_process, 1, 1
};

/* A utility filter that returns an immediate EOF without consuming */
/* any data from its source. Used by PDF interpreter for unknown    */
/* filter types.                                                    */
private int
s_EOFD_process(stream_state * st, stream_cursor_read * pr,
		 stream_cursor_write * pw, bool last)
{
    return EOFC;
}
private const stream_template s_EOFD_template = {
    &amp;st_stream_state, NULL, s_EOFD_process, 1, 1
};

/* &lt;target&gt; /.EOFDecode filter &lt;file&gt; */
/* &lt;target&gt; &lt;dict&gt; /.EOFDecode filter &lt;file&gt; */
private int
zEOFD(i_ctx_t *i_ctx_p)
{
    return filter_read_simple(i_ctx_p, &amp;s_EOFD_template);
}


/* Ensure a minimum buffer size for a filter. */
/* This may require creating an intermediate stream. */
private int
filter_ensure_buf(stream ** ps, uint min_buf_size, gs_ref_memory_t *imem,
		  bool writing)
{
    stream *s = *ps;
    uint min_size = min_buf_size + max_min_left;
    stream *bs;
    ref bsop;
    int code;

    if (s-&gt;modes == 0 /* stream is closed */  || s-&gt;bsize &gt;= min_size)
	return 0;
    /* Otherwise, allocate an intermediate stream. */
    if (s-&gt;cbuf == 0) {
	/* This is a newly created procedure stream. */
	/* Just allocate a buffer for it. */
	uint len = max(min_size, 128);
	byte *buf = gs_alloc_bytes((gs_memory_t *)imem, len,
				   "filter_ensure_buf");

	if (buf == 0)
	    return_error(e_VMerror);
	s-&gt;cbuf = buf;
	s-&gt;srptr = s-&gt;srlimit = s-&gt;swptr = buf - 1;
	s-&gt;swlimit = buf - 1 + len;
	s-&gt;bsize = s-&gt;cbsize = len;
	return 0;
    } else {
	/* Allocate an intermediate stream. */
	if (writing)
	    code = filter_open("w", min_size, &amp;bsop, &amp;s_filter_write_procs,
			       &amp;s_NullE_template, NULL, (gs_memory_t *)imem);
	else
	    code = filter_open("r", min_size, &amp;bsop, &amp;s_filter_read_procs,
			       &amp;s_Null1D_template, NULL, (gs_memory_t *)imem);
	if (code &lt; 0)
	    return code;
	bs = fptr(&amp;bsop);
	bs-&gt;strm = s;
	bs-&gt;is_temp = 2;
	*ps = bs;
	return code;
    }
}

/* Mark a (filter) stream as temporary. */
/* We define this here to avoid importing stream.h into zf*.c. */
void
filter_mark_temp(const ref * fop, int is_temp)
{
    fptr(fop)-&gt;is_temp = is_temp;
}

/* Mark the source or target of a filter as temporary, and propagate */
/* close_strm from the temporary stream to the filter. */
void
filter_mark_strm_temp(const ref * fop, int is_temp)
{
    stream *s = fptr(fop);
    stream *strm = s-&gt;strm;

    strm-&gt;is_temp = is_temp;
    s-&gt;close_strm = strm-&gt;close_strm;
}

/* ------ Initialization procedure ------ */

const op_def zfilter_op_defs[] = {
		/* We enter PSStringEncode and SubFileDecode (only) */
		/* as separate operators. */
    {"1.psstringencode", zPSSE},
    {"2.subfiledecode", zSFD},
    op_def_begin_filter(),
    {"1ASCIIHexEncode", zAXE},
    {"1ASCIIHexDecode", zAXD},
    {"1NullEncode", zNullE},
    {"2PFBDecode", zPFBD},
    {"1PSStringEncode", zPSSE},
    {"2RunLengthEncode", zRLE},
    {"1RunLengthDecode", zRLD},
    {"3SubFileDecode", zSFD},
    {"1.EOFDecode", zEOFD},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

