<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfilterx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfilterx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 1996, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfilterx.c,v 1.4 2002/02/21 22:24:54 giles Exp $ */
/* Extended (non-standard) filter creation */
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gsstruct.h"
#include "ialloc.h"
#include "idict.h"
#include "idparam.h"
#include "store.h"
#include "strimpl.h"
#include "sfilter.h"
#include "sbwbs.h"
#include "sbhc.h"
#include "sbtx.h"
#include "shcgen.h"
#include "smtf.h"
#include "ifilter.h"

/* ------ Bounded Huffman code filters ------ */

/* Common setup for encoding and decoding filters */
private int
bhc_setup(os_ptr op, stream_BHC_state * pbhcs)
{
    int code;
    int num_counts;
    int data[max_hc_length + 1 + 256 + max_zero_run + 1];
    uint dsize;
    int i;
    uint num_values, accum;
    ushort *counts;
    ushort *values;

    check_type(*op, t_dictionary);
    check_dict_read(*op);
    if ((code = dict_bool_param(op, "FirstBitLowOrder", false,
				&amp;pbhcs-&gt;FirstBitLowOrder)) &lt; 0 ||
	(code = dict_int_param(op, "MaxCodeLength", 1, max_hc_length,
			       max_hc_length, &amp;num_counts)) &lt; 0 ||
	(code = dict_bool_param(op, "EndOfData", true,
				&amp;pbhcs-&gt;EndOfData)) &lt; 0 ||
	(code = dict_uint_param(op, "EncodeZeroRuns", 2, 256,
				256, &amp;pbhcs-&gt;EncodeZeroRuns)) &lt; 0 ||
    /* Note: the code returned from the following call */
    /* is actually the number of elements in the array. */
	(code = dict_int_array_param(op, "Tables", countof(data),
				     data)) &lt;= 0
	)
	return (code &lt; 0 ? code : gs_note_error(e_rangecheck));
    dsize = code;
    if (dsize &lt;= num_counts + 2)
	return_error(e_rangecheck);
    for (i = 0, num_values = 0, accum = 0; i &lt;= num_counts;
	 i++, accum &lt;&lt;= 1
	) {
	int count = data[i];

	if (count &lt; 0)
	    return_error(e_rangecheck);
	num_values += count;
	accum += count;
    }
    if (dsize != num_counts + 1 + num_values ||
	accum != 1 &lt;&lt; (num_counts + 1) ||
	pbhcs-&gt;EncodeZeroRuns &gt;
	(pbhcs-&gt;EndOfData ? num_values - 1 : num_values)
	)
	return_error(e_rangecheck);
    for (; i &lt; num_counts + 1 + num_values; i++) {
	int value = data[i];

	if (value &lt; 0 || value &gt;= num_values)
	    return_error(e_rangecheck);
    }
    pbhcs-&gt;definition.counts = counts =
	(ushort *) ialloc_byte_array(num_counts + 1, sizeof(ushort),
				     "bhc_setup(counts)");
    pbhcs-&gt;definition.values = values =
	(ushort *) ialloc_byte_array(num_values, sizeof(ushort),
				     "bhc_setup(values)");
    if (counts == 0 || values == 0) {
	ifree_object(values, "bhc_setup(values)");
	ifree_object(counts, "bhc_setup(counts)");
	return_error(e_VMerror);
    }
    for (i = 0; i &lt;= num_counts; i++)
	counts[i] = data[i];
    pbhcs-&gt;definition.counts = counts;
    pbhcs-&gt;definition.num_counts = num_counts;
    for (i = 0; i &lt; num_values; i++)
	values[i] = data[i + num_counts + 1];
    pbhcs-&gt;definition.values = values;
    pbhcs-&gt;definition.num_values = num_values;
    return 0;
}

/* &lt;target&gt; &lt;dict&gt; BoundedHuffmanEncode/filter &lt;file&gt; */
private int
zBHCE(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_BHCE_state bhcs;
    int code = bhc_setup(op, (stream_BHC_state *)&amp;bhcs);

    if (code &lt; 0)
	return code;
    return filter_write(op, 0, &amp;s_BHCE_template, (stream_state *)&amp;bhcs, 0);
}

/* &lt;source&gt; &lt;dict&gt; BoundedHuffmanDecode/filter &lt;file&gt; */
private int
zBHCD(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_BHCD_state bhcs;
    int code = bhc_setup(op, (stream_BHC_state *)&amp;bhcs);

    if (code &lt; 0)
	return code;
    return filter_read(i_ctx_p, 0, &amp;s_BHCD_template, (stream_state *)&amp;bhcs, 0);
}

/* &lt;array&gt; &lt;max_length&gt; .computecodes &lt;array&gt; */
/* The first max_length+1 elements of the array will be filled in with */
/* the code counts; the remaining elements will be replaced with */
/* the code values.  This is the form needed for the Tables element of */
/* the dictionary parameter for the BoundedHuffman filters. */
private int
zcomputecodes(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    os_ptr op1 = op - 1;
    uint asize;
    hc_definition def;
    ushort *data;
    long *freqs;
    int code = 0;

    check_type(*op, t_integer);
    check_write_type(*op1, t_array);
    asize = r_size(op1);
    if (op-&gt;value.intval &lt; 1 || op-&gt;value.intval &gt; max_hc_length)
	return_error(e_rangecheck);
    def.num_counts = op-&gt;value.intval;
    if (asize &lt; def.num_counts + 2)
	return_error(e_rangecheck);
    def.num_values = asize - (def.num_counts + 1);
    data = (ushort *) gs_alloc_byte_array(imemory, asize, sizeof(ushort),
					  "zcomputecodes");
    freqs = (long *)gs_alloc_byte_array(imemory, def.num_values,
					sizeof(long),
					"zcomputecodes(freqs)");

    if (data == 0 || freqs == 0)
	code = gs_note_error(e_VMerror);
    else {
	uint i;

	def.counts = data;
	def.values = data + (def.num_counts + 1);
	for (i = 0; i &lt; def.num_values; i++) {
	    const ref *pf = op1-&gt;value.const_refs + i + def.num_counts + 1;

	    if (!r_has_type(pf, t_integer)) {
		code = gs_note_error(e_typecheck);
		break;
	    }
	    freqs[i] = pf-&gt;value.intval;
	}
	if (!code) {
	    code = hc_compute(&amp;def, freqs, imemory);
	    if (code &gt;= 0) {
		/* Copy back results. */
		for (i = 0; i &lt; asize; i++)
		    make_int(op1-&gt;value.refs + i, data[i]);
	    }
	}
    }
    gs_free_object(imemory, freqs, "zcomputecodes(freqs)");
    gs_free_object(imemory, data, "zcomputecodes");
    if (code &lt; 0)
	return code;
    pop(1);
    return code;
}

/* ------ Burrows/Wheeler block sorting filters ------ */

/* Common setup for encoding and decoding filters */
private int
bwbs_setup(os_ptr op, stream_BWBS_state * pbwbss)
{
    int code =
	dict_int_param(op, "BlockSize", 1, max_int / sizeof(int) - 10, 16384,
		       &amp;pbwbss-&gt;BlockSize);

    if (code &lt; 0)
	return code;
    return 0;
}

/* &lt;target&gt; &lt;dict&gt; BWBlockSortEncode/filter &lt;file&gt; */
private int
zBWBSE(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_BWBSE_state bwbss;
    int code;

    check_type(*op, t_dictionary);
    check_dict_read(*op);
    code = bwbs_setup(op, (stream_BWBS_state *)&amp;bwbss);
    if (code &lt; 0)
	return code;
    return filter_write(op, 0, &amp;s_BWBSE_template, (stream_state *)&amp;bwbss, 0);
}

/* &lt;source&gt; &lt;dict&gt; BWBlockSortDecode/filter &lt;file&gt; */
private int
zBWBSD(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_BWBSD_state bwbss;
    int code = bwbs_setup(op, (stream_BWBS_state *)&amp;bwbss);

    if (code &lt; 0)
	return code;
    return filter_read(i_ctx_p, 0, &amp;s_BWBSD_template, (stream_state *)&amp;bwbss, 0);
}

/* ------ Byte translation filters ------ */

/* Common setup */
private int
bt_setup(os_ptr op, stream_BT_state * pbts)
{
    check_read_type(*op, t_string);
    if (r_size(op) != 256)
	return_error(e_rangecheck);
    memcpy(pbts-&gt;table, op-&gt;value.const_bytes, 256);
    return 0;
}

/* &lt;target&gt; &lt;table&gt; ByteTranslateEncode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;table&gt; &lt;dict&gt; ByteTranslateEncode/filter &lt;file&gt; */
private int
zBTE(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_BT_state bts;
    int code = bt_setup(op, &amp;bts);

    if (code &lt; 0)
	return code;
    return filter_write(op, 0, &amp;s_BTE_template, (stream_state *)&amp;bts, 0);
}

/* &lt;target&gt; &lt;table&gt; ByteTranslateDecode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;table&gt; &lt;dict&gt; ByteTranslateDecode/filter &lt;file&gt; */
private int
zBTD(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    stream_BT_state bts;
    int code = bt_setup(op, &amp;bts);

    if (code &lt; 0)
	return code;
    return filter_read(i_ctx_p, 0, &amp;s_BTD_template, (stream_state *)&amp;bts, 0);
}

/* ------ Move-to-front filters ------ */

/* &lt;target&gt; MoveToFrontEncode/filter &lt;file&gt; */
/* &lt;target&gt; &lt;dict&gt; MoveToFrontEncode/filter &lt;file&gt; */
private int
zMTFE(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;

    return filter_write_simple(op, &amp;s_MTFE_template);
}

/* &lt;source&gt; MoveToFrontDecode/filter &lt;file&gt; */
/* &lt;source&gt; &lt;dict&gt; MoveToFrontDecode/filter &lt;file&gt; */
private int
zMTFD(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;

    return filter_read_simple(op, &amp;s_MTFD_template);
}

/* ================ Initialization procedure ================ */

const op_def zfilterx_op_defs[] =
{
    {"2.computecodes", zcomputecodes},	/* not a filter */
    op_def_begin_filter(),
		/* Non-standard filters */
    {"2BoundedHuffmanEncode", zBHCE},
    {"2BoundedHuffmanDecode", zBHCD},
    {"2BWBlockSortEncode", zBWBSE},
    {"2BWBlockSortDecode", zBWBSD},
    {"2ByteTranslateEncode", zBTE},
    {"2ByteTranslateDecode", zBTD},
    {"1MoveToFrontEncode", zMTFE},
    {"1MoveToFrontDecode", zMTFD},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

