<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfont.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfont.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1997, 1998, 1999, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfont.c,v 1.12 2004/08/19 19:33:09 stefan Exp $ */
/* Generic font operators */
#include "ghost.h"
#include "oper.h"
#include "gsstruct.h"		/* for registering root */
#include "gzstate.h"		/* must precede gxdevice */
#include "gxdevice.h"		/* must precede gxfont */
#include "gxfont.h"
#include "gxfcache.h"
#include "bfont.h"
#include "ialloc.h"
#include "iddict.h"
#include "igstate.h"
#include "iname.h"		/* for name_mark_index */
#include "isave.h"
#include "store.h"
#include "ivmspace.h"

/* Forward references */
private int make_font(i_ctx_t *, const gs_matrix *);
private void make_uint_array(os_ptr, const uint *, int);
private int setup_unicode_decoder(i_ctx_t *i_ctx_p, ref *Decoding);

/* The (global) font directory */
gs_font_dir *ifont_dir = 0;	/* needed for buildfont */

/* Mark a glyph as a PostScript name (if it isn't a CID). */
bool
zfont_mark_glyph_name(const gs_memory_t *mem, gs_glyph glyph, void *ignore_data)
{
    return (glyph &gt;= gs_min_cid_glyph || glyph == gs_no_glyph ? false :
	    name_mark_index(mem, (uint) glyph));
}

/* Get a global glyph code.  */
private int 
zfont_global_glyph_code(const gs_memory_t *mem, gs_const_string *gstr, gs_glyph *pglyph)
{
    ref v;
    int code = name_ref(mem, gstr-&gt;data, gstr-&gt;size, &amp;v, 0);

    if (code &lt; 0)
	return code;
    *pglyph = (gs_glyph)name_index(mem, &amp;v);
    return 0;
}

/* Initialize the font operators */
private int
zfont_init(i_ctx_t *i_ctx_p)
{
    ifont_dir = gs_font_dir_alloc2(imemory, imemory-&gt;non_gc_memory);
    ifont_dir-&gt;ccache.mark_glyph = zfont_mark_glyph_name;
    ifont_dir-&gt;global_glyph_code = zfont_global_glyph_code;
    return gs_register_struct_root(imemory, NULL, (void **)&amp;ifont_dir,
				   "ifont_dir");
}

/* &lt;font&gt; &lt;scale&gt; scalefont &lt;new_font&gt; */
private int
zscalefont(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    double scale;
    gs_matrix mat;

    if ((code = real_param(op, &amp;scale)) &lt; 0)
	return code;
    if ((code = gs_make_scaling(scale, scale, &amp;mat)) &lt; 0)
	return code;
    return make_font(i_ctx_p, &amp;mat);
}

/* &lt;font&gt; &lt;matrix&gt; makefont &lt;new_font&gt; */
private int
zmakefont(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    gs_matrix mat;

    if ((code = read_matrix(imemory, op, &amp;mat)) &lt; 0)
	return code;
    return make_font(i_ctx_p, &amp;mat);
}

/* &lt;font&gt; setfont - */
int
zsetfont(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_font *pfont;
    int code = font_param(op, &amp;pfont);

    if (code &lt; 0 || (code = gs_setfont(igs, pfont)) &lt; 0)
	return code;
    pop(1);
    return code;
}

/* - currentfont &lt;font&gt; */
private int
zcurrentfont(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;

    push(1);
    *op = *pfont_dict(gs_currentfont(igs));
    return 0;
}

/* - cachestatus &lt;mark&gt; &lt;bsize&gt; &lt;bmax&gt; &lt;msize&gt; &lt;mmax&gt; &lt;csize&gt; &lt;cmax&gt; &lt;blimit&gt; */
private int
zcachestatus(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    uint status[7];

    gs_cachestatus(ifont_dir, status);
    push(7);
    make_uint_array(op - 6, status, 7);
    return 0;
}

/* &lt;blimit&gt; setcachelimit - */
private int
zsetcachelimit(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;

    check_int_leu(*op, max_uint);
    gs_setcachelimit(ifont_dir, (uint) op-&gt;value.intval);
    pop(1);
    return 0;
}

/* &lt;mark&gt; &lt;size&gt; &lt;lower&gt; &lt;upper&gt; setcacheparams - */
private int
zsetcacheparams(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    uint params[3];
    int i, code;
    os_ptr opp = op;

    for (i = 0; i &lt; 3 &amp;&amp; !r_has_type(opp, t_mark); i++, opp--) {
	check_int_leu(*opp, max_uint);
	params[i] = opp-&gt;value.intval;
    }
    switch (i) {
	case 3:
	    if ((code = gs_setcachesize(ifont_dir, params[2])) &lt; 0)
		return code;
	case 2:
	    if ((code = gs_setcachelower(ifont_dir, params[1])) &lt; 0)
		return code;
	case 1:
	    if ((code = gs_setcacheupper(ifont_dir, params[0])) &lt; 0)
		return code;
	case 0:;
    }
    return zcleartomark(i_ctx_p);
}

/* - currentcacheparams &lt;mark&gt; &lt;size&gt; &lt;lower&gt; &lt;upper&gt; */
private int
zcurrentcacheparams(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    uint params[3];

    params[0] = gs_currentcachesize(ifont_dir);
    params[1] = gs_currentcachelower(ifont_dir);
    params[2] = gs_currentcacheupper(ifont_dir);
    push(4);
    make_mark(op - 3);
    make_uint_array(op - 2, params, 3);
    return 0;
}

/* &lt;font&gt; .registerfont - */
private int
zregisterfont(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_font *pfont;
    int code = font_param(op, &amp;pfont);

    if (code &lt; 0)
	return code;
    pfont-&gt;is_resource = true;
    pop(1);
    return 0;
}


/* &lt;Decoding&gt; .setupUnicodeDecoder - */
private int
zsetupUnicodeDecoder(i_ctx_t *i_ctx_p)
{   /* The allocation mode must be global. */
    os_ptr op = osp;
    int code;

    check_type(*op, t_dictionary);
    code = setup_unicode_decoder(i_ctx_p, op);
    if (code &lt; 0)
	return code;
    pop(1);
    return 0;
}

/* ------ Initialization procedure ------ */

const op_def zfont_op_defs[] =
{
    {"0currentfont", zcurrentfont},
    {"2makefont", zmakefont},
    {"2scalefont", zscalefont},
    {"1setfont", zsetfont},
    {"0cachestatus", zcachestatus},
    {"1setcachelimit", zsetcachelimit},
    {"1setcacheparams", zsetcacheparams},
    {"0currentcacheparams", zcurrentcacheparams},
    {"1.registerfont", zregisterfont},
    {"1.setupUnicodeDecoder", zsetupUnicodeDecoder},
    op_def_end(zfont_init)
};

/* ------ Subroutines ------ */

/* Validate a font parameter. */
int
font_param(const ref * pfdict, gs_font ** ppfont)
{	/*
	 * Check that pfdict is a read-only dictionary, that it has a FID
	 * entry whose value is a fontID, and that the fontID points to a
	 * gs_font structure whose associated PostScript dictionary is
	 * pfdict.
	 */
    ref *pid;
    gs_font *pfont;
    const font_data *pdata;

    check_type(*pfdict, t_dictionary);
    if (dict_find_string(pfdict, "FID", &amp;pid) &lt;= 0 ||
	!r_has_type(pid, t_fontID)
	)
	return_error(e_invalidfont);
    pfont = r_ptr(pid, gs_font);
    pdata = pfont-&gt;client_data;
    if (!obj_eq(pfont-&gt;memory, &amp;pdata-&gt;dict, pfdict))
	return_error(e_invalidfont);
    *ppfont = pfont;
    if (pfont == 0)
	return_error(e_invalidfont);	/* unregistered font */
    return 0;
}

/* Add the FID entry to a font dictionary. */
/* Note that i_ctx_p may be NULL. */
int
add_FID(i_ctx_t *i_ctx_p, ref * fp /* t_dictionary */ , gs_font * pfont,
	gs_ref_memory_t *imem)
{
    ref fid;

    make_tav(&amp;fid, t_fontID,
	     a_readonly | imemory_space(imem) | imemory_new_mask(imem),
	     pstruct, (void *)pfont);
    return (i_ctx_p ? idict_put_string(fp, "FID", &amp;fid) :
	    dict_put_string(fp, "FID", &amp;fid, NULL));
}

/* Make a transformed font (common code for makefont/scalefont). */
private int
make_font(i_ctx_t *i_ctx_p, const gs_matrix * pmat)
{
    os_ptr op = osp;
    os_ptr fp = op - 1;
    gs_font *oldfont, *newfont;
    int code;
    ref *pencoding = 0;

    code = font_param(fp, &amp;oldfont);
    if (code &lt; 0)
	return code;
    {
	uint space = ialloc_space(idmemory);

	ialloc_set_space(idmemory, r_space(fp));
	if (dict_find_string(fp, "Encoding", &amp;pencoding) &gt; 0 &amp;&amp;
	    !r_is_array(pencoding)
	    )
	    code = gs_note_error(e_invalidfont);
	else {
		/*
		 * Temporarily substitute the new dictionary
		 * for the old one, in case the Encoding changed.
		 */
	    ref olddict;

	    olddict = *pfont_dict(oldfont);
	    *pfont_dict(oldfont) = *fp;
	    code = gs_makefont(ifont_dir, oldfont, pmat, &amp;newfont);
	    *pfont_dict(oldfont) = olddict;
	}
	ialloc_set_space(idmemory, space);
    }
    if (code &lt; 0)
	return code;
    /*
     * We have to allow for the possibility that the font's Encoding
     * is different from that of the base font.  Note that the
     * font_data of the new font was simply copied from the old one.
     */
    if (pencoding != 0 &amp;&amp;
	!obj_eq(imemory, pencoding, &amp;pfont_data(newfont)-&gt;Encoding)
	) {
	if (newfont-&gt;FontType == ft_composite)
	    return_error(e_rangecheck);
	/* We should really do validity checking here.... */
	ref_assign(&amp;pfont_data(newfont)-&gt;Encoding, pencoding);
	lookup_gs_simple_font_encoding((gs_font_base *) newfont);
    }
    *fp = *pfont_dict(newfont);
    pop(1);
    return 0;
}
/* Create the transformed font dictionary. */
/* This is the make_font completion procedure for all non-composite fonts */
/* created at the interpreter level (see build_gs_simple_font in zbfont.c.) */
int
zbase_make_font(gs_font_dir * pdir, const gs_font * oldfont,
		const gs_matrix * pmat, gs_font ** ppfont)
{
    /*
     * We must call gs_base_make_font so that the XUID gets copied
     * if necessary.
     */
    int code = gs_base_make_font(pdir, oldfont, pmat, ppfont);

    if (code &lt; 0)
	return code;
    return zdefault_make_font(pdir, oldfont, pmat, ppfont);
}
int
zdefault_make_font(gs_font_dir * pdir, const gs_font * oldfont,
		   const gs_matrix * pmat, gs_font ** ppfont)
{
    gs_font *newfont = *ppfont;
    gs_memory_t *mem = newfont-&gt;memory;
    /* HACK: we know this font was allocated by the interpreter. */
    gs_ref_memory_t *imem = (gs_ref_memory_t *)mem;
    ref *fp = pfont_dict(oldfont);
    font_data *pdata;
    ref newdict, newmat, scalemat;
    uint dlen = dict_maxlength(fp);
    uint mlen = dict_length(fp) + 3;	/* FontID, OrigFont, ScaleMatrix */
    int code;

    if (dlen &lt; mlen)
	dlen = mlen;
    if ((pdata = gs_alloc_struct(mem, font_data, &amp;st_font_data,
				 "make_font(font_data)")) == 0
	)
	return_error(e_VMerror);
    /*
     * This dictionary is newly created: it's safe to pass NULL as the
     * dstack pointer to dict_copy and dict_put_string.
     */
    if ((code = dict_alloc(imem, dlen, &amp;newdict)) &lt; 0 ||
	(code = dict_copy(fp, &amp;newdict, NULL)) &lt; 0 ||
	(code = gs_alloc_ref_array(imem, &amp;newmat, a_all, 12,
				   "make_font(matrices)")) &lt; 0
	)
	return code;
    refset_null_new(newmat.value.refs, 12, imemory_new_mask(imem));
    ref_assign(&amp;scalemat, &amp;newmat);
    r_set_size(&amp;scalemat, 6);
    scalemat.value.refs += 6;
    /*
     * Create the scaling matrix.  We could do this several different
     * ways: by "dividing" the new FontMatrix by the base FontMatrix, by
     * multiplying the current scaling matrix by a ScaleMatrix kept in
     * the gs_font, or by multiplying the current scaling matrix by the
     * ScaleMatrix from the font dictionary.  We opt for the last of
     * these.
     */
    {
	gs_matrix scale, prev_scale;
	ref *ppsm;

	if (!(dict_find_string(fp, "ScaleMatrix", &amp;ppsm) &gt; 0 &amp;&amp;
	      read_matrix(mem, ppsm, &amp;prev_scale) &gt;= 0 &amp;&amp;
	      gs_matrix_multiply(pmat, &amp;prev_scale, &amp;scale) &gt;= 0)
	    )
	    scale = *pmat;
	write_matrix_new(&amp;scalemat, &amp;scale, imem);
    }
    r_clear_attrs(&amp;scalemat, a_write);
    r_set_size(&amp;newmat, 6);
    write_matrix_new(&amp;newmat, &amp;newfont-&gt;FontMatrix, imem);
    r_clear_attrs(&amp;newmat, a_write);
    if ((code = dict_put_string(&amp;newdict, "FontMatrix", &amp;newmat, NULL)) &lt; 0 ||
	(code = dict_put_string(&amp;newdict, "OrigFont", pfont_dict(oldfont-&gt;base), NULL)) &lt; 0 ||
	(code = dict_put_string(&amp;newdict, "ScaleMatrix", &amp;scalemat, NULL)) &lt; 0 ||
	(code = add_FID(NULL, &amp;newdict, newfont, imem)) &lt; 0
	)
	return code;
    newfont-&gt;client_data = pdata;
    *pdata = *pfont_data(oldfont);
    pdata-&gt;dict = newdict;
    r_clear_attrs(dict_access_ref(&amp;newdict), a_write);
    return 0;
}

/* Convert an array of (unsigned) integers to stack form. */
private void
make_uint_array(register os_ptr op, const uint * intp, int count)
{
    int i;

    for (i = 0; i &lt; count; i++, op++, intp++)
	make_int(op, *intp);
}

/* Remove scaled font and character cache entries that would be */
/* invalidated by a restore. */
private bool
purge_if_name_removed(const gs_memory_t *mem, cached_char * cc, void *vsave)
{
    return alloc_name_index_is_since_save(mem, cc-&gt;code, vsave);
}

/* Remove entries from font and character caches. */
void
font_restore(const alloc_save_t * save)
{
    gs_font_dir *pdir = ifont_dir;
    const gs_memory_t *mem = 0;

    if (pdir == 0)		/* not initialized yet */
	return;

    /* Purge original (unscaled) fonts. */

    {
	gs_font *pfont;

otop:
	for (pfont = pdir-&gt;orig_fonts; pfont != 0;
	     pfont = pfont-&gt;next
	    ) {
	    mem = pfont-&gt;memory;
	    if (alloc_is_since_save((char *)pfont, save)) {
		gs_purge_font(pfont);
		goto otop;
	    }
	}
    }

    /* Purge cached scaled fonts. */

    {
	gs_font *pfont;

top:
	for (pfont = pdir-&gt;scaled_fonts; pfont != 0;
	     pfont = pfont-&gt;next
	    ) {
	    if (alloc_is_since_save((char *)pfont, save)) {
		gs_purge_font(pfont);
		goto top;
	    }
	}
    }

    /* Purge xfonts and uncached scaled fonts. */

    {
	cached_fm_pair *pair;
	uint n;

	for (pair = pdir-&gt;fmcache.mdata, n = pdir-&gt;fmcache.mmax;
	     n &gt; 0; pair++, n--
	    )
	    if (!fm_pair_is_free(pair)) {
		if ((uid_is_XUID(&amp;pair-&gt;UID) &amp;&amp;
		     alloc_is_since_save((char *)pair-&gt;UID.xvalues,
					 save))
		    ) {
		    gs_purge_fm_pair(pdir, pair, 0);
		    continue;
		}
		if (pair-&gt;font != 0 &amp;&amp;
		    alloc_is_since_save((char *)pair-&gt;font, save)
		    ) {
		    if (!uid_is_valid(&amp;pair-&gt;UID)) {
			gs_purge_fm_pair(pdir, pair, 0);
			continue;
		    }
		    /* Don't discard pairs with a surviving UID. */
		    pair-&gt;font = 0;
		}
		if (pair-&gt;xfont != 0 &amp;&amp;
		    alloc_is_since_save((char *)pair-&gt;xfont, save)
		    )
		    gs_purge_fm_pair(pdir, pair, 1);
	    }
    }

    /* Purge characters with names about to be removed. */
    /* We only need to do this if any new names have been created */
    /* since the save. */

    if (alloc_any_names_since_save(save))
	gx_purge_selected_cached_chars(pdir, purge_if_name_removed,
				       (void *)save);

}

/* ------ Font procedures for PostScript fonts ------ */

/* font_info procedure */
private bool
zfont_info_has(const ref *pfidict, const char *key, gs_const_string *pmember)
{
    ref *pvalue;

    if (dict_find_string(pfidict, key, &amp;pvalue) &gt; 0 &amp;&amp;
	r_has_type(pvalue, t_string)
	) {
	pmember-&gt;data = pvalue-&gt;value.const_bytes;
	pmember-&gt;size = r_size(pvalue);
	return true;
    }
    return false;
}
int
zfont_info(gs_font *font, const gs_point *pscale, int members,
	   gs_font_info_t *info)
{
    int code = gs_default_font_info(font, pscale, members &amp;
		    ~(FONT_INFO_COPYRIGHT | FONT_INFO_NOTICE |
		      FONT_INFO_FAMILY_NAME | FONT_INFO_FULL_NAME),
				    info);
    const ref *pfdict;
    ref *pfontinfo;

    if (code &lt; 0)
	return code;
    pfdict = &amp;pfont_data(font)-&gt;dict;
    if (dict_find_string(pfdict, "FontInfo", &amp;pfontinfo) &lt;= 0 ||
	!r_has_type(pfontinfo, t_dictionary))
	return 0;
    if ((members &amp; FONT_INFO_COPYRIGHT) &amp;&amp;
	zfont_info_has(pfontinfo, "Copyright", &amp;info-&gt;Copyright))
	info-&gt;members |= FONT_INFO_COPYRIGHT;
    if ((members &amp; FONT_INFO_NOTICE) &amp;&amp;
	zfont_info_has(pfontinfo, "Notice", &amp;info-&gt;Notice))
	info-&gt;members |= FONT_INFO_NOTICE;
    if ((members &amp; FONT_INFO_FAMILY_NAME) &amp;&amp;
	zfont_info_has(pfontinfo, "FamilyName", &amp;info-&gt;FamilyName))
	info-&gt;members |= FONT_INFO_FAMILY_NAME;
    if ((members &amp; FONT_INFO_FULL_NAME) &amp;&amp;
	zfont_info_has(pfontinfo, "FullName", &amp;info-&gt;FullName))
	info-&gt;members |= FONT_INFO_FULL_NAME;
    return code;
}

/* -------------------- Utilities --------------*/

typedef struct gs_unicode_decoder_s {
    ref data;
} gs_unicode_decoder;

/* GC procedures */
private 
CLEAR_MARKS_PROC(unicode_decoder_clear_marks)
{   gs_unicode_decoder *const pptr = vptr;

    r_clear_attrs(&amp;pptr-&gt;data, l_mark);
}
private 
ENUM_PTRS_WITH(unicode_decoder_enum_ptrs, gs_unicode_decoder *pptr) return 0;
case 0:
ENUM_RETURN_REF(&amp;pptr-&gt;data);
ENUM_PTRS_END
private RELOC_PTRS_WITH(unicode_decoder_reloc_ptrs, gs_unicode_decoder *pptr);
RELOC_REF_VAR(pptr-&gt;data);
r_clear_attrs(&amp;pptr-&gt;data, l_mark);
RELOC_PTRS_END

gs_private_st_complex_only(st_unicode_decoder, gs_unicode_decoder,\
    "unicode_decoder", unicode_decoder_clear_marks, unicode_decoder_enum_ptrs, 
    unicode_decoder_reloc_ptrs, 0);

/* Get the Unicode value for a glyph. */
const ref *
zfont_get_to_unicode_map(gs_font_dir *dir)
{
    const gs_unicode_decoder *pud = (gs_unicode_decoder *)dir-&gt;glyph_to_unicode_table;
    
    return (pud == NULL ? NULL : &amp;pud-&gt;data);
}

private int
setup_unicode_decoder(i_ctx_t *i_ctx_p, ref *Decoding)
{
    gs_unicode_decoder *pud = gs_alloc_struct(imemory, gs_unicode_decoder, 
                             &amp;st_unicode_decoder, "setup_unicode_decoder");
    if (pud == NULL)
	return_error(e_VMerror);
    ref_assign_new(&amp;pud-&gt;data, Decoding);
    ifont_dir-&gt;glyph_to_unicode_table = pud;
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

