<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfont1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfont1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1991, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfont1.c,v 1.13 2004/09/22 13:52:33 igor Exp $ */
/* Type 1 and Type 4 font creation operators */
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gxfixed.h"
#include "gsmatrix.h"
#include "gxdevice.h"
#include "gxfont.h"
#include "gxfont1.h"
#include "bfont.h"
#include "ialloc.h"
#include "icharout.h"
#include "ichar1.h"
#include "idict.h"
#include "idparam.h"
#include "ifont1.h"
#include "iname.h"		/* for name_index in enumerate_glyph */
#include "store.h"

/* Type 1 font procedures (defined in zchar1.c) */
extern const gs_type1_data_procs_t z1_data_procs;
font_proc_glyph_info(z1_glyph_info);
/* Font procedures defined here */
private font_proc_same_font(z1_same_font);

/* ------ Private utilities ------ */

private void
find_zone_height(float *pmax_height, int count, const float *values)
{
    int i;
    float zone_height;

    for (i = 0; i &lt; count; i += 2)
	if ((zone_height = values[i + 1] - values[i]) &gt; *pmax_height)
	    *pmax_height = zone_height;
}

/* ------ Font procedures ------ */

private int
z1_enumerate_glyph(gs_font * pfont, int *pindex, gs_glyph_space_t ignored,
		   gs_glyph * pglyph)
{
    const gs_font_type1 *const pfont1 = (gs_font_type1 *)pfont;
    const ref *pcsdict = &amp;pfont_data(pfont1)-&gt;CharStrings;

    return zchar_enumerate_glyph(pfont-&gt;memory, pcsdict, pindex, pglyph);
}

/* ------ Public procedures ------ */

/* Extract pointers to internal structures. */
int
charstring_font_get_refs(const_os_ptr op, charstring_font_refs_t *pfr)
{
    check_type(*op, t_dictionary);
    if (dict_find_string(op, "Private", &amp;pfr-&gt;Private) &lt;= 0 ||
	!r_has_type(pfr-&gt;Private, t_dictionary)
	)
	return_error(e_invalidfont);
    make_empty_array(&amp;pfr-&gt;no_subrs, 0);
    if (dict_find_string(pfr-&gt;Private, "OtherSubrs", &amp;pfr-&gt;OtherSubrs) &gt; 0) {
	if (!r_is_array(pfr-&gt;OtherSubrs))
	    return_error(e_typecheck);
    } else
	pfr-&gt;OtherSubrs = &amp;pfr-&gt;no_subrs;
    if (dict_find_string(pfr-&gt;Private, "Subrs", &amp;pfr-&gt;Subrs) &gt; 0) {
	if (!r_is_array(pfr-&gt;Subrs))
	    return_error(e_typecheck);
    } else
	pfr-&gt;Subrs = &amp;pfr-&gt;no_subrs;
    pfr-&gt;GlobalSubrs = &amp;pfr-&gt;no_subrs;
    return 0;
}

/* Get the parameters of a CharString-based font or a FDArray entry. */
int
charstring_font_params(const gs_memory_t *mem, 
		       const_os_ptr op, charstring_font_refs_t *pfr,
		       gs_type1_data *pdata1)
{
    const ref *pprivate = pfr-&gt;Private;
    int code;

    /* Get the rest of the information from the Private dictionary. */
    if ((code = dict_int_param(pprivate, "lenIV", -1, 255, pdata1-&gt;lenIV,
			       &amp;pdata1-&gt;lenIV)) &lt; 0 ||
	(code = dict_uint_param(pprivate, "subroutineNumberBias",
				0, max_uint, pdata1-&gt;subroutineNumberBias,
				&amp;pdata1-&gt;subroutineNumberBias)) &lt; 0 ||
	(code = dict_int_param(pprivate, "BlueFuzz", 0, 1999, 1,
			       &amp;pdata1-&gt;BlueFuzz)) &lt; 0 ||
	(code = dict_float_param(pprivate, "BlueScale", 0.039625,
				 &amp;pdata1-&gt;BlueScale)) &lt; 0 ||
	(code = dict_float_param(pprivate, "BlueShift", 7.0,
				 &amp;pdata1-&gt;BlueShift)) &lt; 0 ||
	(code = pdata1-&gt;BlueValues.count =
	 dict_float_array_param(mem, pprivate, "BlueValues", max_BlueValues * 2,
				&amp;pdata1-&gt;BlueValues.values[0], NULL)) &lt; 0 ||
	(code = dict_float_param(pprivate, "ExpansionFactor", 0.06,
				 &amp;pdata1-&gt;ExpansionFactor)) &lt; 0 ||
	(code = pdata1-&gt;FamilyBlues.count =
	 dict_float_array_param(mem, pprivate, "FamilyBlues", max_FamilyBlues * 2,
				&amp;pdata1-&gt;FamilyBlues.values[0], NULL)) &lt; 0 ||
	(code = pdata1-&gt;FamilyOtherBlues.count =
	 dict_float_array_param(mem, pprivate,
				"FamilyOtherBlues", max_FamilyOtherBlues * 2,
			    &amp;pdata1-&gt;FamilyOtherBlues.values[0], NULL)) &lt; 0 ||
	(code = dict_bool_param(pprivate, "ForceBold", false,
				&amp;pdata1-&gt;ForceBold)) &lt; 0 ||
    /*
     * We've seen a few fonts with out-of-range LanguageGroup values;
     * if it weren't for this, the only legal values should be 0 or 1.
     */
	(code = dict_int_param(pprivate, "LanguageGroup", min_int, max_int, 0,
			       &amp;pdata1-&gt;LanguageGroup)) &lt; 0 ||
	(code = pdata1-&gt;OtherBlues.count =
	 dict_float_array_param(mem, pprivate, "OtherBlues", max_OtherBlues * 2,
				&amp;pdata1-&gt;OtherBlues.values[0], NULL)) &lt; 0 ||
	(code = dict_bool_param(pprivate, "RndStemUp", true,
				&amp;pdata1-&gt;RndStemUp)) &lt; 0 ||
	(code = pdata1-&gt;StdHW.count =
	 dict_float_array_check_param(mem, pprivate, "StdHW", 1,
				      &amp;pdata1-&gt;StdHW.values[0], NULL,
				      0, e_rangecheck)) &lt; 0 ||
	(code = pdata1-&gt;StdVW.count =
	 dict_float_array_check_param(mem, pprivate, "StdVW", 1,
				      &amp;pdata1-&gt;StdVW.values[0], NULL,
				      0, e_rangecheck)) &lt; 0 ||
	(code = pdata1-&gt;StemSnapH.count =
	 dict_float_array_param(mem, pprivate, "StemSnapH", max_StemSnap,
				&amp;pdata1-&gt;StemSnapH.values[0], NULL)) &lt; 0 ||
	(code = pdata1-&gt;StemSnapV.count =
	 dict_float_array_param(mem, pprivate, "StemSnapV", max_StemSnap,
				&amp;pdata1-&gt;StemSnapV.values[0], NULL)) &lt; 0 ||
    /* The WeightVector is in the font dictionary, not Private. */
	(code = pdata1-&gt;WeightVector.count =
	 dict_float_array_param(mem, op, "WeightVector", max_WeightVector,
				pdata1-&gt;WeightVector.values, NULL)) &lt; 0
	)
	return code;
    /*
     * According to section 5.6 of the "Adobe Type 1 Font Format",
     * there is a requirement that BlueScale times the maximum
     * alignment zone height must be less than 1.  Some fonts
     * produced by Fontographer have ridiculously large BlueScale
     * values, so we force BlueScale back into range here.
     */
    {
	float max_zone_height = 1.0;

#define SCAN_ZONE(z)\
    find_zone_height(&amp;max_zone_height, pdata1-&gt;z.count, pdata1-&gt;z.values);

	SCAN_ZONE(BlueValues);
	SCAN_ZONE(OtherBlues);
	SCAN_ZONE(FamilyBlues);
	SCAN_ZONE(FamilyOtherBlues);

#undef SCAN_ZONE

	if (pdata1-&gt;BlueScale * max_zone_height &gt; 1.0)
	    pdata1-&gt;BlueScale = 1.0 / max_zone_height;
    }
    /*
     * According to the same Adobe book, section 5.11, only values
     * 0 and 1 are allowed for LanguageGroup and we have encountered
     * fonts with other values. If the value is anything else, map it to 0
     * so that the remainder of the graphics library won't see an
     * unexpected value.
     */
    if (pdata1-&gt;LanguageGroup &gt; 1 || pdata1-&gt;LanguageGroup &lt; 0)
	pdata1-&gt;LanguageGroup = 0;
    return 0;
}

/* Fill in a newly built CharString-based font or FDArray entry. */
int
charstring_font_init(gs_font_type1 *pfont, const charstring_font_refs_t *pfr,
		     const gs_type1_data *pdata1)
{
    font_data *pdata;

    pdata = pfont_data(pfont);
    pfont-&gt;data = *pdata1;
    pfont-&gt;data.parent = NULL;
    ref_assign(&amp;pdata-&gt;u.type1.OtherSubrs, pfr-&gt;OtherSubrs);
    ref_assign(&amp;pdata-&gt;u.type1.Subrs, pfr-&gt;Subrs);
    ref_assign(&amp;pdata-&gt;u.type1.GlobalSubrs, pfr-&gt;GlobalSubrs);
    pfont-&gt;data.procs = z1_data_procs;
    pfont-&gt;data.proc_data = (char *)pdata;
    pfont-&gt;procs.same_font = z1_same_font;
    pfont-&gt;procs.glyph_info = z1_glyph_info;
    pfont-&gt;procs.enumerate_glyph = z1_enumerate_glyph;
    pfont-&gt;procs.glyph_outline = zchar1_glyph_outline;
    return 0;
}

/* Build a Type 1, Type 2, or Type 4 font. */
int
build_charstring_font(i_ctx_t *i_ctx_p, os_ptr op, build_proc_refs *pbuild,
		      font_type ftype, charstring_font_refs_t *pfr,
		      gs_type1_data *pdata1, build_font_options_t options)
{
    int code = charstring_font_params(imemory, op, pfr, pdata1);
    gs_font_type1 *pfont;

    if (code &lt; 0)
	return code;
    code = build_gs_primitive_font(i_ctx_p, op, (gs_font_base **)&amp;pfont, ftype,
				   &amp;st_gs_font_type1, pbuild, options);
    if (code != 0)
	return code;
    /* This is a new font, fill it in. */
    charstring_font_init(pfont, pfr, pdata1);
    return define_gs_font((gs_font *)pfont);
}

/* ------ Operators ------ */

/* Build a Type 1 or Type 4 font. */
private int
buildfont1or4(i_ctx_t *i_ctx_p, os_ptr op, build_proc_refs * pbuild,
	      font_type ftype, build_font_options_t options)
{
    charstring_font_refs_t refs;
    int code = charstring_font_get_refs(op, &amp;refs);
    gs_type1_data data1;

    if (code &lt; 0)
	return code;
    data1.interpret = gs_type1_interpret;
    data1.subroutineNumberBias = 0;
    data1.lenIV = DEFAULT_LENIV_1;
    return build_charstring_font(i_ctx_p, op, pbuild, ftype, &amp;refs, &amp;data1,
				 options);
}

/* &lt;string|name&gt; &lt;font_dict&gt; .buildfont1 &lt;string|name&gt; &lt;font&gt; */
/* Build a type 1 (Adobe encrypted) font. */
private int
zbuildfont1(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    build_proc_refs build;
    int code = build_proc_name_refs(imemory, &amp;build,
				    "%Type1BuildChar", "%Type1BuildGlyph");

    if (code &lt; 0)
	return code;
    return buildfont1or4(i_ctx_p, op, &amp;build, ft_encrypted,
			 bf_notdef_required);
}

/* &lt;string|name&gt; &lt;font_dict&gt; .buildfont4 &lt;string|name&gt; &lt;font&gt; */
/* Build a type 4 (disk-based Adobe encrypted) font. */
private int
zbuildfont4(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    build_proc_refs build;
    int code = build_gs_font_procs(op, &amp;build);

    if (code &lt; 0)
	return code;
    return buildfont1or4(i_ctx_p, op, &amp;build, ft_disk_based, bf_options_none);
}

/* ------ Initialization procedure ------ */

const op_def zfont1_op_defs[] =
{
    {"2.buildfont1", zbuildfont1},
    {"2.buildfont4", zbuildfont4},
    op_def_end(0)
};

/* ------ Font procedures for Type 1 fonts ------ */

/* same_font procedure */
private bool
same_font_dict(const font_data *pdata, const font_data *podata,
	       const char *key)
{
    ref *pvalue;
    bool present = dict_find_string(&amp;pdata-&gt;dict, key, &amp;pvalue) &gt; 0;
    ref *povalue;
    bool opresent = dict_find_string(&amp;podata-&gt;dict, key, &amp;povalue) &gt; 0;
    dict *pdict = (&amp;(podata-&gt;dict))-&gt;value.pdict;

    return (present == opresent &amp;&amp;
	    (present &lt;= 0 || obj_eq(dict_mem(pdict), pvalue, povalue)));
}
private int
z1_same_font(const gs_font *font, const gs_font *ofont, int mask)
{
    if (ofont-&gt;FontType != font-&gt;FontType)
	return 0;
    while (font-&gt;base != font)
	font = font-&gt;base;
    while (ofont-&gt;base != ofont)
	ofont = ofont-&gt;base;
    if (ofont == font)
	return mask;
    {
	int same = gs_base_same_font(font, ofont, mask);
	int check = mask &amp; ~same;
	const gs_font_type1 *const pfont1 = (const gs_font_type1 *)font;
	const font_data *const pdata = pfont_data(pfont1);
	const gs_font_type1 *pofont1 = (const gs_font_type1 *)ofont;
	const font_data *const podata = pfont_data(pofont1);

	if ((check &amp; (FONT_SAME_OUTLINES | FONT_SAME_METRICS)) &amp;&amp;
	    !memcmp(&amp;pofont1-&gt;data.procs, &amp;z1_data_procs, sizeof(z1_data_procs)) &amp;&amp;
	    obj_eq(font-&gt;memory, &amp;pdata-&gt;CharStrings, &amp;podata-&gt;CharStrings) &amp;&amp;
	    /*
	     * We use same_font_dict for convenience: we know that
	     * both fonts do have Private dictionaries.
	     */
	    same_font_dict(pdata, podata, "Private")
	    )
	    same |= FONT_SAME_OUTLINES;

	if ((check &amp; FONT_SAME_METRICS) &amp;&amp; (same &amp; FONT_SAME_OUTLINES) &amp;&amp;
	    !memcmp(&amp;pofont1-&gt;data.procs, &amp;z1_data_procs, sizeof(z1_data_procs)) &amp;&amp;
	    /* Metrics may be affected by CDevProc, Metrics, Metrics2. */
	    same_font_dict(pdata, podata, "Metrics") &amp;&amp;
	    same_font_dict(pdata, podata, "Metrics2") &amp;&amp;
	    same_font_dict(pdata, podata, "CDevProc")
	    )
	    same |= FONT_SAME_METRICS;

	if ((check &amp; FONT_SAME_ENCODING) &amp;&amp;
	    pofont1-&gt;procs.same_font == z1_same_font &amp;&amp;
	    obj_eq(font-&gt;memory, &amp;pdata-&gt;Encoding, &amp;podata-&gt;Encoding)
	    )
	    same |= FONT_SAME_ENCODING;

	return same &amp; mask;
    }
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

