<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zshade.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zshade.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1997, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zshade.c,v 1.15 2004/08/04 19:36:13 stefan Exp $ */
/* PostScript language interface to shading */
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gscolor3.h"
#include "gscspace.h"
#include "gscolor2.h"		/* requires gscspace.h */
#include "gsfunc3.h"
#include "gsptype2.h"
#include "gsstruct.h"		/* must precede gsshade.h */
#include "gsshade.h"
#include "gsuid.h"
#include "stream.h"		/* for files.h */
#include "files.h"
#include "ialloc.h"
#include "idict.h"
#include "idparam.h"
#include "ifunc.h"
#include "igstate.h"
#include "ipcolor.h"
#include "store.h"

/* Forward references */
private int shading_param(const_os_ptr op, const gs_shading_t ** ppsh);

/* ---------------- Standard operators ---------------- */

/* - currentsmoothness &lt;smoothness&gt; */
private int
zcurrentsmoothness(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;

    push(1);
    make_real(op, gs_currentsmoothness(igs));
    return 0;
}

/* &lt;smoothness&gt; setsmoothness - */
private int
zsetsmoothness(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    double smoothness;
    int code;

    if (real_param(op, &amp;smoothness) &lt; 0)
	return_op_typecheck(op);
    if ((code = gs_setsmoothness(igs, smoothness)) &lt; 0)
	return code;
    pop(1);
    return 0;
}

/* &lt;shading&gt; .shfill - */
private int
zshfill(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    const gs_shading_t *psh;
    int code = shading_param(op, &amp;psh);

    if (code &lt; 0 || (code = gs_shfill(igs, psh)) &lt; 0)
	return code;
    pop(1);
    return 0;
}

/* ------ Non-standard operators ------ */

/* &lt;pattern&gt; &lt;matrix&gt; &lt;shading&gt; .buildshadingpattern &lt;pattern&gt; &lt;instance&gt; */
private int
zbuildshadingpattern(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    os_ptr op2 = op - 2;
    gs_matrix mat;
    gs_pattern2_template_t template;
    int_pattern *pdata;
    gs_client_color cc_instance;
    int code;

    check_type(*op2, t_dictionary);
    check_dict_read(*op2);
    gs_pattern2_init(&amp;template);
    if ((code = read_matrix(imemory, op - 1, &amp;mat)) &lt; 0 ||
	(code = dict_uid_param(op2, &amp;template.uid, 1, imemory, i_ctx_p)) != 1 ||
	(code = shading_param(op, &amp;template.Shading)) &lt; 0 ||
	(code = int_pattern_alloc(&amp;pdata, op2, imemory)) &lt; 0
	)
	return_error((code &lt; 0 ? code : e_rangecheck));
    template.client_data = pdata;
    code = gs_make_pattern(&amp;cc_instance,
			   (const gs_pattern_template_t *)&amp;template,
			   &amp;mat, igs, imemory);
    if (code &lt; 0) {
	ifree_object(pdata, "int_pattern");
	return code;
    }
    make_istruct(op - 1, a_readonly, cc_instance.pattern);
    pop(1);
    return code;
}

/* ------ Internal procedures ------ */

/* Get a shading parameter. */
private int
shading_param(const_os_ptr op, const gs_shading_t ** ppsh)
{	/*
	 * Since shadings form a subclass hierarchy, we currently have
	 * no way to check whether a structure is actually a shading.
	 */
    if (!r_is_struct(op) ||
	r_has_masked_attrs(op, a_executable | a_execute, a_all)
	)
	return_error(e_typecheck);
    *ppsh = (gs_shading_t *) op-&gt;value.pstruct;
    return 0;
}

/* ---------------- Shading dictionaries ---------------- */

/* ------ Common code ------ */

extern_st(st_color_space);

typedef int (*build_shading_proc_t)
     (i_ctx_t *i_ctx_p, const ref *op, const gs_shading_params_t *params,
      gs_shading_t **ppsh, gs_memory_t *mem);

/* Operators */

/* Common framework for building shadings. */
private int
build_shading(i_ctx_t *i_ctx_p, build_shading_proc_t proc)
{
    os_ptr op = osp;
    int code;
    float box[4];
    gs_shading_params_t params;
    gs_shading_t *psh;
    ref *pvalue;

    check_type(*op, t_dictionary);
    params.ColorSpace = 0;
    params.Background = 0;
    /* Collect parameters common to all shading types. */
    {
	const gs_color_space *pcs_orig = gs_currentcolorspace(igs);
	int num_comp = gs_color_space_num_components(pcs_orig);
	gs_color_space *pcs;

	if (num_comp &lt; 0)	/* Pattern color space */
	    return_error(e_rangecheck);
	pcs = ialloc_struct(gs_color_space, &amp;st_color_space,
			    "build_shading");
	if (pcs == 0)
	    return_error(e_VMerror);
	gs_cspace_init_from(pcs, pcs_orig);
	params.ColorSpace = pcs;
	if (dict_find_string(op, "Background", &amp;pvalue) &gt; 0) {
	    gs_client_color *pcc =
		ialloc_struct(gs_client_color, &amp;st_client_color,
			      "build_shading");

	    if (pcc == 0) {
		code = gs_note_error(e_VMerror);
		goto fail;
	    }
	    pcc-&gt;pattern = 0;
	    params.Background = pcc;
	    code = dict_floats_param(imemory, op, "Background",
				     gs_color_space_num_components(pcs),
				     pcc-&gt;paint.values, NULL);
	    if (code &lt; 0)
		goto fail;
	}
    }
    if (dict_find_string(op, "BBox", &amp;pvalue) &lt;= 0)
	params.have_BBox = false;
    else if ((code = dict_floats_param(imemory, op, "BBox", 
				       4, box, NULL)) == 4) {
	params.BBox.p.x = box[0];
	params.BBox.p.y = box[1];
	params.BBox.q.x = box[2];
	params.BBox.q.y = box[3];
	params.have_BBox = true;
    } else
	goto fail;
    code = dict_bool_param(op, "AntiAlias", false, &amp;params.AntiAlias);
    if (code &lt; 0)
	goto fail;
    /* Finish building the shading. */
    code = (*proc)(i_ctx_p, op, &amp;params, &amp;psh, imemory);
    if (code &lt; 0)
	goto fail;
    make_istruct_new(op, 0, psh);
    return code;
fail:
    gs_free_object(imemory, params.Background, "Background");
    if (params.ColorSpace) {
	gs_cspace_release(params.ColorSpace);
	gs_free_object(imemory, params.ColorSpace, "ColorSpace");
    }
    return (code &lt; 0 ? code : gs_note_error(e_rangecheck));
}

/* Collect a Function value. */
private int
build_shading_function(i_ctx_t *i_ctx_p, const ref * op, gs_function_t ** ppfn,
		       int num_inputs, gs_memory_t *mem)
{
    ref *pFunction;
    int code;

    *ppfn = 0;
    if (dict_find_string(op, "Function", &amp;pFunction) &lt;= 0)
	return 0;
    if (r_is_array(pFunction)) {
	uint size = r_size(pFunction);
	gs_function_t **Functions;
	uint i;
	gs_function_AdOt_params_t params;

	check_read(*pFunction);
	if (size == 0)
	    return_error(e_rangecheck);
	code = alloc_function_array(size, &amp;Functions, mem);
	if (code &lt; 0)
	    return code;
	for (i = 0; i &lt; size; ++i) {
	    ref rsubfn;

	    array_get(imemory, pFunction, (long)i, &amp;rsubfn);
	    code = fn_build_function(i_ctx_p, &amp;rsubfn, &amp;Functions[i], mem);
	    if (code &lt; 0)
		break;
	}
	params.m = num_inputs;
	params.Domain = 0;
	params.n = size;
	params.Range = 0;
	params.Functions = (const gs_function_t * const *)Functions;
	if (code &gt;= 0)
	    code = gs_function_AdOt_init(ppfn, &amp;params, mem);
	if (code &lt; 0)
	    gs_function_AdOt_free_params(&amp;params, mem);
    } else {
	code = fn_build_function(i_ctx_p, pFunction, ppfn, mem);
	if (code &lt; 0)
	    return code;
	if ((*ppfn)-&gt;params.m != num_inputs) {
	    gs_function_free(*ppfn, true, mem);
	    return_error(e_rangecheck);
	}
    }
    return code;
}

/* According to PLRM 3rd ed, p. 264  "indexed color space is not
 * allowed in any shading whose color values are generated by a function;
 * this applies to any shading dictionary that contains a Function entry."
 * Adobe interpreters follow PLRM in this respect and we follow them.
 */
private int
check_indexed_vs_function(const gs_color_space *pcs, const gs_function_t *foo)
{ if (foo &amp;&amp; gs_color_space_get_index(pcs) == gs_color_space_index_Indexed)
    return_error(e_rangecheck);
  return 0;
}

/* ------ Build shadings ------ */

/* Build a ShadingType 1 (Function-based) shading. */
private int
build_shading_1(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_Fb_params_t params;
    int code;
    static const float default_Domain[4] = {0, 1, 0, 1};
    ref *pmatrix;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    gs_make_identity(&amp;params.Matrix);
    params.Function = 0;
    if ((code = dict_floats_param(imemory, op, "Domain", 
				  4, params.Domain,
				  default_Domain)) &lt; 0 ||
	(dict_find_string(op, "Matrix", &amp;pmatrix) &gt; 0 &amp;&amp;
	 (code = read_matrix(imemory, pmatrix, &amp;params.Matrix)) &lt; 0) ||
	(code = build_shading_function(i_ctx_p, op, &amp;params.Function, 2, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = gs_shading_Fb_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
	return code;
    }
    return 0;
}
/* &lt;dict&gt; .buildshading1 &lt;shading_struct&gt; */
private int
zbuildshading1(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_1);
}

/* Collect parameters for an Axial or Radial shading. */
private int
build_directional_shading(i_ctx_t *i_ctx_p, const ref * op, float *Coords, int num_Coords,
			  float Domain[2], gs_function_t ** pFunction,
			  bool Extend[2], gs_memory_t *mem)
{
    int code = dict_floats_param(imemory, op, "Coords", 
				 num_Coords, Coords, NULL);
    static const float default_Domain[2] = {0, 1};
    ref *pExtend;

    *pFunction = 0;
    if (code &lt; 0 ||
	(code = dict_floats_param(imemory, op, "Domain", 2, Domain,
				  default_Domain)) &lt; 0 ||
	(code = build_shading_function(i_ctx_p, op, pFunction, 1, mem)) &lt; 0
	)
	return code;
    if (!*pFunction)
	    return_error(e_undefined);
    if (dict_find_string(op, "Extend", &amp;pExtend) &lt;= 0)
	Extend[0] = Extend[1] = false;
    else {
	ref E0, E1;

	if (!r_is_array(pExtend))
	    return_error(e_typecheck);
	else if (r_size(pExtend) != 2)
	    return_error(e_rangecheck);
	else if ((array_get(imemory, pExtend, 0L, &amp;E0), 
		  !r_has_type(&amp;E0, t_boolean)) ||
		 (array_get(imemory, pExtend, 1L, &amp;E1), 
		  !r_has_type(&amp;E1, t_boolean))
	    )
	    return_error(e_typecheck);
	Extend[0] = E0.value.boolval, Extend[1] = E1.value.boolval;
    }
    return 0;
}

/* Build a ShadingType 2 (Axial) shading. */
private int
build_shading_2(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_A_params_t params;
    int code;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    if ((code = build_directional_shading(i_ctx_p, op, params.Coords, 4,
					  params.Domain, &amp;params.Function,
					  params.Extend, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = gs_shading_A_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
    }
    return code;
}
/* &lt;dict&gt; .buildshading2 &lt;shading_struct&gt; */
private int
zbuildshading2(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_2);
}

/* Build a ShadingType 3 (Radial) shading. */
private int
build_shading_3(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_R_params_t params;
    int code;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    if ((code = build_directional_shading(i_ctx_p, op, params.Coords, 6,
					  params.Domain, &amp;params.Function,
					  params.Extend, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = gs_shading_R_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
    }
    return code;
}
/* &lt;dict&gt; .buildshading3 &lt;shading_struct&gt; */
private int
zbuildshading3(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_3);
}

/* Collect parameters for a mesh shading. */
private int
build_mesh_shading(i_ctx_t *i_ctx_p, const ref * op,
		   gs_shading_mesh_params_t * params,
		   float **pDecode, gs_function_t ** pFunction,
		   gs_memory_t *mem)
{
    int code;
    float *data = 0;
    ref *pDataSource;

    *pDecode = 0;
    *pFunction = 0;
    if (dict_find_string(op, "DataSource", &amp;pDataSource) &lt;= 0)
	return_error(e_rangecheck);
    if (r_is_array(pDataSource)) {
	uint size = r_size(pDataSource);

	data = (float *)gs_alloc_byte_array(mem, size, sizeof(float),
					    "build_mesh_shading");
	if (data == 0)
	    return_error(e_VMerror);
	code = process_float_array(mem, pDataSource, size, data);
	if (code &lt; 0) {
	    gs_free_object(mem, data, "build_mesh_shading");
	    return code;
	}
	data_source_init_floats(&amp;params-&gt;DataSource, data, size);
    } else
	switch (r_type(pDataSource)) {
	    case t_file: {
		stream *s;

		check_read_file(s, pDataSource);
		data_source_init_stream(&amp;params-&gt;DataSource, s);
		break;
	    }
	    case t_string:
		check_read(*pDataSource);
		data_source_init_string2(&amp;params-&gt;DataSource,
					 pDataSource-&gt;value.bytes,
					 r_size(pDataSource));
		break;
	    default:
		return_error(e_typecheck);
	}
    code = build_shading_function(i_ctx_p, op, pFunction, 1, mem);
    if (code &lt; 0) {
	gs_free_object(mem, data, "build_mesh_shading");
	return code;
    }
    if (data_source_is_array(params-&gt;DataSource)) {
	params-&gt;BitsPerCoordinate = 0;
	params-&gt;BitsPerComponent = 0;
    } else {
	int num_decode = 4 +
	    (*pFunction != 0 ? 1 :
	     gs_color_space_num_components(params-&gt;ColorSpace)) * 2;

	if ((code = dict_int_param(op, "BitsPerCoordinate", 1, 32, 0,
				   &amp;params-&gt;BitsPerCoordinate)) &gt;= 0 &amp;&amp;
	    (code = dict_int_param(op, "BitsPerComponent", 1, 16, 0,
				   &amp;params-&gt;BitsPerComponent)) &gt;= 0
	    ) {
	    *pDecode = (float *)
		gs_alloc_byte_array(mem, num_decode, sizeof(float),
				    "build_mesh_shading");
	    if (*pDecode == 0)
		code = gs_note_error(e_VMerror);
	    else {
	        code = dict_floats_param(mem, op, "Decode", num_decode, *pDecode, NULL);
		if (code &lt; 0) {
		    gs_free_object(mem, *pDecode, "build_mesh_shading");
		    *pDecode = 0;
		}
	    }
	}
    }
    if (code &lt; 0) {
	if (*pFunction != 0) {
	    gs_function_free(*pFunction, true, mem);
	    *pFunction = 0;
	}
	gs_free_object(mem, data, "build_mesh_shading");
    }
    return code;
}

/* Collect the BitsPerFlag parameter, if relevant. */
private int
flag_bits_param(const ref * op, const gs_shading_mesh_params_t * params,
		int *pBitsPerFlag)
{
    if (data_source_is_array(params-&gt;DataSource)) {
	*pBitsPerFlag = 0;
	return 0;
    } else {
	return dict_int_param(op, "BitsPerFlag", 2, 8, 0, pBitsPerFlag);
    }
}

/* Build a ShadingType 4 (Free-form Gouraud triangle mesh) shading. */
private int
build_shading_4(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_FfGt_params_t params;
    int code;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    if ((code =
	 build_mesh_shading(i_ctx_p, op, (gs_shading_mesh_params_t *)&amp;params,
			    &amp;params.Decode, &amp;params.Function, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = flag_bits_param(op, (gs_shading_mesh_params_t *)&amp;params,
				&amp;params.BitsPerFlag)) &lt; 0 ||
	(code = gs_shading_FfGt_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
	gs_free_object(mem, params.Decode, "Decode");
    }
    return code;
}
/* &lt;dict&gt; .buildshading4 &lt;shading_struct&gt; */
private int
zbuildshading4(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_4);
}

/* Build a ShadingType 5 (Lattice-form Gouraud triangle mesh) shading. */
private int
build_shading_5(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_LfGt_params_t params;
    int code;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    if ((code =
	 build_mesh_shading(i_ctx_p, op, (gs_shading_mesh_params_t *)&amp;params,
			    &amp;params.Decode, &amp;params.Function, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = dict_int_param(op, "VerticesPerRow", 2, max_int, 0,
			       &amp;params.VerticesPerRow)) &lt; 0 ||
	(code = gs_shading_LfGt_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
	gs_free_object(mem, params.Decode, "Decode");
    }
    return code;
}
/* &lt;dict&gt; .buildshading5 &lt;shading_struct&gt; */
private int
zbuildshading5(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_5);
}

/* Build a ShadingType 6 (Coons patch mesh) shading. */
private int
build_shading_6(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_Cp_params_t params;
    int code;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    if ((code =
	 build_mesh_shading(i_ctx_p, op, (gs_shading_mesh_params_t *)&amp;params,
			    &amp;params.Decode, &amp;params.Function, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = flag_bits_param(op, (gs_shading_mesh_params_t *)&amp;params,
				&amp;params.BitsPerFlag)) &lt; 0 ||
	(code = gs_shading_Cp_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
	gs_free_object(mem, params.Decode, "Decode");
    }
    return code;
}
/* &lt;dict&gt; .buildshading6 &lt;shading_struct&gt; */
private int
zbuildshading6(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_6);
}

/* Build a ShadingType 7 (Tensor product patch mesh) shading. */
private int
build_shading_7(i_ctx_t *i_ctx_p, const ref * op, const gs_shading_params_t * pcommon,
		gs_shading_t ** ppsh, gs_memory_t *mem)
{
    gs_shading_Tpp_params_t params;
    int code;

    *(gs_shading_params_t *)&amp;params = *pcommon;
    if ((code =
	 build_mesh_shading(i_ctx_p, op, (gs_shading_mesh_params_t *)&amp;params,
			    &amp;params.Decode, &amp;params.Function, mem)) &lt; 0 ||
	(code = check_indexed_vs_function(params.ColorSpace, params.Function)) &lt; 0 ||
	(code = flag_bits_param(op, (gs_shading_mesh_params_t *)&amp;params,
				&amp;params.BitsPerFlag)) &lt; 0 ||
	(code = gs_shading_Tpp_init(ppsh, &amp;params, mem)) &lt; 0
	) {
	gs_free_object(mem, params.Function, "Function");
	gs_free_object(mem, params.Decode, "Decode");
    }
    return code;
}
/* &lt;dict&gt; .buildshading7 &lt;shading_struct&gt; */
private int
zbuildshading7(i_ctx_t *i_ctx_p)
{
    return build_shading(i_ctx_p, build_shading_7);
}

/* ------ Initialization procedure ------ */

const op_def zshade_op_defs[] =
{
    op_def_begin_ll3(),
    {"0currentsmoothness", zcurrentsmoothness},
    {"1setsmoothness", zsetsmoothness},
    {"1.shfill", zshfill},
    {"1.buildshading1", zbuildshading1},
    {"1.buildshading2", zbuildshading2},
    {"1.buildshading3", zbuildshading3},
    {"1.buildshading4", zbuildshading4},
    {"1.buildshading5", zbuildshading5},
    {"1.buildshading6", zbuildshading6},
    {"1.buildshading7", zbuildshading7},
    {"3.buildshadingpattern", zbuildshadingpattern},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

