<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/zlib/deflate.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/zlib/deflate.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* deflate.c -- compress data using the deflation algorithm
 * Copyright (C) 1995-2004 Jean-loup Gailly.
 * For conditions of distribution and use, see copyright notice in zlib.h
 */

/*
 *  ALGORITHM
 *
 *      The "deflation" process depends on being able to identify portions
 *      of the input text which are identical to earlier input (within a
 *      sliding window trailing behind the input currently being processed).
 *
 *      The most straightforward technique turns out to be the fastest for
 *      most input files: try all possible matches and select the longest.
 *      The key feature of this algorithm is that insertions into the string
 *      dictionary are very simple and thus fast, and deletions are avoided
 *      completely. Insertions are performed at each input character, whereas
 *      string matches are performed only when the previous match ends. So it
 *      is preferable to spend more time in matches to allow very fast string
 *      insertions and avoid deletions. The matching algorithm for small
 *      strings is inspired from that of Rabin &amp; Karp. A brute force approach
 *      is used to find longer strings when a small match has been found.
 *      A similar algorithm is used in comic (by Jan-Mark Wams) and freeze
 *      (by Leonid Broukhis).
 *         A previous version of this file used a more sophisticated algorithm
 *      (by Fiala and Greene) which is guaranteed to run in linear amortized
 *      time, but has a larger average cost, uses more memory and is patented.
 *      However the F&amp;G algorithm may be faster for some highly redundant
 *      files if the parameter max_chain_length (described below) is too large.
 *
 *  ACKNOWLEDGEMENTS
 *
 *      The idea of lazy evaluation of matches is due to Jan-Mark Wams, and
 *      I found it in 'freeze' written by Leonid Broukhis.
 *      Thanks to many people for bug reports and testing.
 *
 *  REFERENCES
 *
 *      Deutsch, L.P.,"DEFLATE Compressed Data Format Specification".
 *      Available in http://www.ietf.org/rfc/rfc1951.txt
 *
 *      A description of the Rabin and Karp algorithm is given in the book
 *         "Algorithms" by R. Sedgewick, Addison-Wesley, p252.
 *
 *      Fiala,E.R., and Greene,D.H.
 *         Data Compression with Finite Windows, Comm.ACM, 32,4 (1989) 490-595
 *
 */

/* @(#) $Id: deflate.c,v 1.1.1.1 2005/04/24 21:39:40 giles Exp $ */

#include "deflate.h"

const char deflate_copyright[] =
   " deflate 1.2.2 Copyright 1995-2004 Jean-loup Gailly ";
/*
  If you use the zlib library in a product, an acknowledgment is welcome
  in the documentation of your product. If for some reason you cannot
  include such an acknowledgment, I would appreciate that you keep this
  copyright string in the executable of your product.
 */

/* ===========================================================================
 *  Function prototypes.
 */
typedef enum {
    need_more,      /* block not completed, need more input or more output */
    block_done,     /* block flush performed */
    finish_started, /* finish started, need only more output at next deflate */
    finish_done     /* finish done, accept no more input or output */
} block_state;

typedef block_state (*compress_func) OF((deflate_state *s, int flush));
/* Compression function. Returns the block state after the call. */

local void fill_window    OF((deflate_state *s));
local block_state deflate_stored OF((deflate_state *s, int flush));
local block_state deflate_fast   OF((deflate_state *s, int flush));
#ifndef FASTEST
local block_state deflate_slow   OF((deflate_state *s, int flush));
#endif
local void lm_init        OF((deflate_state *s));
local void putShortMSB    OF((deflate_state *s, uInt b));
local void flush_pending  OF((z_streamp strm));
local int read_buf        OF((z_streamp strm, Bytef *buf, unsigned size));
#ifndef FASTEST
#ifdef ASMV
      void match_init OF((void)); /* asm code initialization */
      uInt longest_match  OF((deflate_state *s, IPos cur_match));
#else
local uInt longest_match  OF((deflate_state *s, IPos cur_match));
#endif
#endif
local uInt longest_match_fast OF((deflate_state *s, IPos cur_match));

#ifdef DEBUG
local  void check_match OF((deflate_state *s, IPos start, IPos match,
                            int length));
#endif

/* ===========================================================================
 * Local data
 */

#define NIL 0
/* Tail of hash chains */

#ifndef TOO_FAR
#  define TOO_FAR 4096
#endif
/* Matches of length 3 are discarded if their distance exceeds TOO_FAR */

#define MIN_LOOKAHEAD (MAX_MATCH+MIN_MATCH+1)
/* Minimum amount of lookahead, except at the end of the input file.
 * See deflate.c for comments about the MIN_MATCH+1.
 */

/* Values for max_lazy_match, good_match and max_chain_length, depending on
 * the desired pack level (0..9). The values given below have been tuned to
 * exclude worst case performance for pathological files. Better values may be
 * found for specific files.
 */
typedef struct config_s {
   ush good_length; /* reduce lazy search above this match length */
   ush max_lazy;    /* do not perform lazy search above this match length */
   ush nice_length; /* quit search above this match length */
   ush max_chain;
   compress_func func;
} config;

#ifdef FASTEST
local const config configuration_table[2] = {
/*      good lazy nice chain */
/* 0 */ {0,    0,  0,    0, deflate_stored},  /* store only */
/* 1 */ {4,    4,  8,    4, deflate_fast}}; /* max speed, no lazy matches */
#else
local const config configuration_table[10] = {
/*      good lazy nice chain */
/* 0 */ {0,    0,  0,    0, deflate_stored},  /* store only */
/* 1 */ {4,    4,  8,    4, deflate_fast}, /* max speed, no lazy matches */
/* 2 */ {4,    5, 16,    8, deflate_fast},
/* 3 */ {4,    6, 32,   32, deflate_fast},

/* 4 */ {4,    4, 16,   16, deflate_slow},  /* lazy matches */
/* 5 */ {8,   16, 32,   32, deflate_slow},
/* 6 */ {8,   16, 128, 128, deflate_slow},
/* 7 */ {8,   32, 128, 256, deflate_slow},
/* 8 */ {32, 128, 258, 1024, deflate_slow},
/* 9 */ {32, 258, 258, 4096, deflate_slow}}; /* max compression */
#endif

/* Note: the deflate() code requires max_lazy &gt;= MIN_MATCH and max_chain &gt;= 4
 * For deflate_fast() (levels &lt;= 3) good is ignored and lazy has a different
 * meaning.
 */

#define EQUAL 0
/* result of memcmp for equal strings */

#ifndef NO_DUMMY_DECL
struct static_tree_desc_s {int dummy;}; /* for buggy compilers */
#endif

/* ===========================================================================
 * Update a hash value with the given input byte
 * IN  assertion: all calls to to UPDATE_HASH are made with consecutive
 *    input characters, so that a running hash key can be computed from the
 *    previous key instead of complete recalculation each time.
 */
#define UPDATE_HASH(s,h,c) (h = (((h)&lt;&lt;s-&gt;hash_shift) ^ (c)) &amp; s-&gt;hash_mask)


/* ===========================================================================
 * Insert string str in the dictionary and set match_head to the previous head
 * of the hash chain (the most recent string with same hash key). Return
 * the previous length of the hash chain.
 * If this file is compiled with -DFASTEST, the compression level is forced
 * to 1, and no hash chains are maintained.
 * IN  assertion: all calls to to INSERT_STRING are made with consecutive
 *    input characters and the first MIN_MATCH bytes of str are valid
 *    (except for the last MIN_MATCH-1 bytes of the input file).
 */
#ifdef FASTEST
#define INSERT_STRING(s, str, match_head) \
   (UPDATE_HASH(s, s-&gt;ins_h, s-&gt;window[(str) + (MIN_MATCH-1)]), \
    match_head = s-&gt;head[s-&gt;ins_h], \
    s-&gt;head[s-&gt;ins_h] = (Pos)(str))
#else
#define INSERT_STRING(s, str, match_head) \
   (UPDATE_HASH(s, s-&gt;ins_h, s-&gt;window[(str) + (MIN_MATCH-1)]), \
    match_head = s-&gt;prev[(str) &amp; s-&gt;w_mask] = s-&gt;head[s-&gt;ins_h], \
    s-&gt;head[s-&gt;ins_h] = (Pos)(str))
#endif

/* ===========================================================================
 * Initialize the hash table (avoiding 64K overflow for 16 bit systems).
 * prev[] will be initialized on the fly.
 */
#define CLEAR_HASH(s) \
    s-&gt;head[s-&gt;hash_size-1] = NIL; \
    zmemzero((Bytef *)s-&gt;head, (unsigned)(s-&gt;hash_size-1)*sizeof(*s-&gt;head));

/* ========================================================================= */
int ZEXPORT deflateInit_(strm, level, version, stream_size)
    z_streamp strm;
    int level;
    const char *version;
    int stream_size;
{
    return deflateInit2_(strm, level, Z_DEFLATED, MAX_WBITS, DEF_MEM_LEVEL,
                         Z_DEFAULT_STRATEGY, version, stream_size);
    /* To do: ignore strm-&gt;next_in if we use it as window */
}

/* ========================================================================= */
int ZEXPORT deflateInit2_(strm, level, method, windowBits, memLevel, strategy,
                  version, stream_size)
    z_streamp strm;
    int  level;
    int  method;
    int  windowBits;
    int  memLevel;
    int  strategy;
    const char *version;
    int stream_size;
{
    deflate_state *s;
    int wrap = 1;
    static const char my_version[] = ZLIB_VERSION;

    ushf *overlay;
    /* We overlay pending_buf and d_buf+l_buf. This works since the average
     * output size for (length,distance) codes is &lt;= 24 bits.
     */

    if (version == Z_NULL || version[0] != my_version[0] ||
        stream_size != sizeof(z_stream)) {
        return Z_VERSION_ERROR;
    }
    if (strm == Z_NULL) return Z_STREAM_ERROR;

    strm-&gt;msg = Z_NULL;
    if (strm-&gt;zalloc == (alloc_func)0) {
        strm-&gt;zalloc = zcalloc;
        strm-&gt;opaque = (voidpf)0;
    }
    if (strm-&gt;zfree == (free_func)0) strm-&gt;zfree = zcfree;

#ifdef FASTEST
    if (level != 0) level = 1;
#else
    if (level == Z_DEFAULT_COMPRESSION) level = 6;
#endif

    if (windowBits &lt; 0) { /* suppress zlib wrapper */
        wrap = 0;
        windowBits = -windowBits;
    }
#ifdef GZIP
    else if (windowBits &gt; 15) {
        wrap = 2;       /* write gzip wrapper instead */
        windowBits -= 16;
    }
#endif
    if (memLevel &lt; 1 || memLevel &gt; MAX_MEM_LEVEL || method != Z_DEFLATED ||
        windowBits &lt; 8 || windowBits &gt; 15 || level &lt; 0 || level &gt; 9 ||
        strategy &lt; 0 || strategy &gt; Z_RLE) {
        return Z_STREAM_ERROR;
    }
    if (windowBits == 8) windowBits = 9;  /* until 256-byte window bug fixed */
    s = (deflate_state *) ZALLOC(strm, 1, sizeof(deflate_state));
    if (s == Z_NULL) return Z_MEM_ERROR;
    strm-&gt;state = (struct internal_state FAR *)s;
    s-&gt;strm = strm;

    s-&gt;wrap = wrap;
    s-&gt;w_bits = windowBits;
    s-&gt;w_size = 1 &lt;&lt; s-&gt;w_bits;
    s-&gt;w_mask = s-&gt;w_size - 1;

    s-&gt;hash_bits = memLevel + 7;
    s-&gt;hash_size = 1 &lt;&lt; s-&gt;hash_bits;
    s-&gt;hash_mask = s-&gt;hash_size - 1;
    s-&gt;hash_shift =  ((s-&gt;hash_bits+MIN_MATCH-1)/MIN_MATCH);

    s-&gt;window = (Bytef *) ZALLOC(strm, s-&gt;w_size, 2*sizeof(Byte));
    s-&gt;prev   = (Posf *)  ZALLOC(strm, s-&gt;w_size, sizeof(Pos));
    s-&gt;head   = (Posf *)  ZALLOC(strm, s-&gt;hash_size, sizeof(Pos));

    s-&gt;lit_bufsize = 1 &lt;&lt; (memLevel + 6); /* 16K elements by default */

    overlay = (ushf *) ZALLOC(strm, s-&gt;lit_bufsize, sizeof(ush)+2);
    s-&gt;pending_buf = (uchf *) overlay;
    s-&gt;pending_buf_size = (ulg)s-&gt;lit_bufsize * (sizeof(ush)+2L);

    if (s-&gt;window == Z_NULL || s-&gt;prev == Z_NULL || s-&gt;head == Z_NULL ||
        s-&gt;pending_buf == Z_NULL) {
        s-&gt;status = FINISH_STATE;
        strm-&gt;msg = (char*)ERR_MSG(Z_MEM_ERROR);
        deflateEnd (strm);
        return Z_MEM_ERROR;
    }
    s-&gt;d_buf = overlay + s-&gt;lit_bufsize/sizeof(ush);
    s-&gt;l_buf = s-&gt;pending_buf + (1+sizeof(ush))*s-&gt;lit_bufsize;

    s-&gt;level = level;
    s-&gt;strategy = strategy;
    s-&gt;method = (Byte)method;

    return deflateReset(strm);
}

/* ========================================================================= */
int ZEXPORT deflateSetDictionary (strm, dictionary, dictLength)
    z_streamp strm;
    const Bytef *dictionary;
    uInt  dictLength;
{
    deflate_state *s;
    uInt length = dictLength;
    uInt n;
    IPos hash_head = 0;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL || dictionary == Z_NULL ||
        strm-&gt;state-&gt;wrap == 2 ||
        (strm-&gt;state-&gt;wrap == 1 &amp;&amp; strm-&gt;state-&gt;status != INIT_STATE))
        return Z_STREAM_ERROR;

    s = strm-&gt;state;
    if (s-&gt;wrap)
        strm-&gt;adler = adler32(strm-&gt;adler, dictionary, dictLength);

    if (length &lt; MIN_MATCH) return Z_OK;
    if (length &gt; MAX_DIST(s)) {
        length = MAX_DIST(s);
#ifndef USE_DICT_HEAD
        dictionary += dictLength - length; /* use the tail of the dictionary */
#endif
    }
    zmemcpy(s-&gt;window, dictionary, length);
    s-&gt;strstart = length;
    s-&gt;block_start = (long)length;

    /* Insert all strings in the hash table (except for the last two bytes).
     * s-&gt;lookahead stays null, so s-&gt;ins_h will be recomputed at the next
     * call of fill_window.
     */
    s-&gt;ins_h = s-&gt;window[0];
    UPDATE_HASH(s, s-&gt;ins_h, s-&gt;window[1]);
    for (n = 0; n &lt;= length - MIN_MATCH; n++) {
        INSERT_STRING(s, n, hash_head);
    }
    if (hash_head) hash_head = 0;  /* to make compiler happy */
    return Z_OK;
}

/* ========================================================================= */
int ZEXPORT deflateReset (strm)
    z_streamp strm;
{
    deflate_state *s;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL ||
        strm-&gt;zalloc == (alloc_func)0 || strm-&gt;zfree == (free_func)0) {
        return Z_STREAM_ERROR;
    }

    strm-&gt;total_in = strm-&gt;total_out = 0;
    strm-&gt;msg = Z_NULL; /* use zfree if we ever allocate msg dynamically */
    strm-&gt;data_type = Z_UNKNOWN;

    s = (deflate_state *)strm-&gt;state;
    s-&gt;pending = 0;
    s-&gt;pending_out = s-&gt;pending_buf;

    if (s-&gt;wrap &lt; 0) {
        s-&gt;wrap = -s-&gt;wrap; /* was made negative by deflate(..., Z_FINISH); */
    }
    s-&gt;status = s-&gt;wrap ? INIT_STATE : BUSY_STATE;
    strm-&gt;adler =
#ifdef GZIP
        s-&gt;wrap == 2 ? crc32(0L, Z_NULL, 0) :
#endif
        adler32(0L, Z_NULL, 0);
    s-&gt;last_flush = Z_NO_FLUSH;

    _tr_init(s);
    lm_init(s);

    return Z_OK;
}

/* ========================================================================= */
int ZEXPORT deflatePrime (strm, bits, value)
    z_streamp strm;
    int bits;
    int value;
{
    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;
    strm-&gt;state-&gt;bi_valid = bits;
    strm-&gt;state-&gt;bi_buf = (ush)(value &amp; ((1 &lt;&lt; bits) - 1));
    return Z_OK;
}

/* ========================================================================= */
int ZEXPORT deflateParams(strm, level, strategy)
    z_streamp strm;
    int level;
    int strategy;
{
    deflate_state *s;
    compress_func func;
    int err = Z_OK;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;
    s = strm-&gt;state;

#ifdef FASTEST
    if (level != 0) level = 1;
#else
    if (level == Z_DEFAULT_COMPRESSION) level = 6;
#endif
    if (level &lt; 0 || level &gt; 9 || strategy &lt; 0 || strategy &gt; Z_RLE) {
        return Z_STREAM_ERROR;
    }
    func = configuration_table[s-&gt;level].func;

    if (func != configuration_table[level].func &amp;&amp; strm-&gt;total_in != 0) {
        /* Flush the last buffer: */
        err = deflate(strm, Z_PARTIAL_FLUSH);
    }
    if (s-&gt;level != level) {
        s-&gt;level = level;
        s-&gt;max_lazy_match   = configuration_table[level].max_lazy;
        s-&gt;good_match       = configuration_table[level].good_length;
        s-&gt;nice_match       = configuration_table[level].nice_length;
        s-&gt;max_chain_length = configuration_table[level].max_chain;
    }
    s-&gt;strategy = strategy;
    return err;
}

/* =========================================================================
 * For the default windowBits of 15 and memLevel of 8, this function returns
 * a close to exact, as well as small, upper bound on the compressed size.
 * They are coded as constants here for a reason--if the #define's are
 * changed, then this function needs to be changed as well.  The return
 * value for 15 and 8 only works for those exact settings.
 *
 * For any setting other than those defaults for windowBits and memLevel,
 * the value returned is a conservative worst case for the maximum expansion
 * resulting from using fixed blocks instead of stored blocks, which deflate
 * can emit on compressed data for some combinations of the parameters.
 *
 * This function could be more sophisticated to provide closer upper bounds
 * for every combination of windowBits and memLevel, as well as wrap.
 * But even the conservative upper bound of about 14% expansion does not
 * seem onerous for output buffer allocation.
 */
uLong ZEXPORT deflateBound(strm, sourceLen)
    z_streamp strm;
    uLong sourceLen;
{
    deflate_state *s;
    uLong destLen;

    /* conservative upper bound */
    destLen = sourceLen +
              ((sourceLen + 7) &gt;&gt; 3) + ((sourceLen + 63) &gt;&gt; 6) + 11;

    /* if can't get parameters, return conservative bound */
    if (strm == Z_NULL || strm-&gt;state == Z_NULL)
        return destLen;

    /* if not default parameters, return conservative bound */
    s = strm-&gt;state;
    if (s-&gt;w_bits != 15 || s-&gt;hash_bits != 8 + 7)
        return destLen;

    /* default settings: return tight bound for that case */
    return compressBound(sourceLen);
}

/* =========================================================================
 * Put a short in the pending buffer. The 16-bit value is put in MSB order.
 * IN assertion: the stream state is correct and there is enough room in
 * pending_buf.
 */
local void putShortMSB (s, b)
    deflate_state *s;
    uInt b;
{
    put_byte(s, (Byte)(b &gt;&gt; 8));
    put_byte(s, (Byte)(b &amp; 0xff));
}

/* =========================================================================
 * Flush as much pending output as possible. All deflate() output goes
 * through this function so some applications may wish to modify it
 * to avoid allocating a large strm-&gt;next_out buffer and copying into it.
 * (See also read_buf()).
 */
local void flush_pending(strm)
    z_streamp strm;
{
    unsigned len = strm-&gt;state-&gt;pending;

    if (len &gt; strm-&gt;avail_out) len = strm-&gt;avail_out;
    if (len == 0) return;

    zmemcpy(strm-&gt;next_out, strm-&gt;state-&gt;pending_out, len);
    strm-&gt;next_out  += len;
    strm-&gt;state-&gt;pending_out  += len;
    strm-&gt;total_out += len;
    strm-&gt;avail_out  -= len;
    strm-&gt;state-&gt;pending -= len;
    if (strm-&gt;state-&gt;pending == 0) {
        strm-&gt;state-&gt;pending_out = strm-&gt;state-&gt;pending_buf;
    }
}

/* ========================================================================= */
int ZEXPORT deflate (strm, flush)
    z_streamp strm;
    int flush;
{
    int old_flush; /* value of flush param for previous deflate call */
    deflate_state *s;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL ||
        flush &gt; Z_FINISH || flush &lt; 0) {
        return Z_STREAM_ERROR;
    }
    s = strm-&gt;state;

    if (strm-&gt;next_out == Z_NULL ||
        (strm-&gt;next_in == Z_NULL &amp;&amp; strm-&gt;avail_in != 0) ||
        (s-&gt;status == FINISH_STATE &amp;&amp; flush != Z_FINISH)) {
        ERR_RETURN(strm, Z_STREAM_ERROR);
    }
    if (strm-&gt;avail_out == 0) ERR_RETURN(strm, Z_BUF_ERROR);

    s-&gt;strm = strm; /* just in case */
    old_flush = s-&gt;last_flush;
    s-&gt;last_flush = flush;

    /* Write the header */
    if (s-&gt;status == INIT_STATE) {
#ifdef GZIP
        if (s-&gt;wrap == 2) {
            put_byte(s, 31);
            put_byte(s, 139);
            put_byte(s, 8);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, s-&gt;level == 9 ? 2 :
                        (s-&gt;strategy &gt;= Z_HUFFMAN_ONLY || s-&gt;level &lt; 2 ?
                         4 : 0));
            put_byte(s, 255);
            s-&gt;status = BUSY_STATE;
            strm-&gt;adler = crc32(0L, Z_NULL, 0);
        }
        else
#endif
        {
            uInt header = (Z_DEFLATED + ((s-&gt;w_bits-8)&lt;&lt;4)) &lt;&lt; 8;
            uInt level_flags;

            if (s-&gt;strategy &gt;= Z_HUFFMAN_ONLY || s-&gt;level &lt; 2)
                level_flags = 0;
            else if (s-&gt;level &lt; 6)
                level_flags = 1;
            else if (s-&gt;level == 6)
                level_flags = 2;
            else
                level_flags = 3;
            header |= (level_flags &lt;&lt; 6);
            if (s-&gt;strstart != 0) header |= PRESET_DICT;
            header += 31 - (header % 31);

            s-&gt;status = BUSY_STATE;
            putShortMSB(s, header);

            /* Save the adler32 of the preset dictionary: */
            if (s-&gt;strstart != 0) {
                putShortMSB(s, (uInt)(strm-&gt;adler &gt;&gt; 16));
                putShortMSB(s, (uInt)(strm-&gt;adler &amp; 0xffff));
            }
            strm-&gt;adler = adler32(0L, Z_NULL, 0);
        }
    }

    /* Flush as much pending output as possible */
    if (s-&gt;pending != 0) {
        flush_pending(strm);
        if (strm-&gt;avail_out == 0) {
            /* Since avail_out is 0, deflate will be called again with
             * more output space, but possibly with both pending and
             * avail_in equal to zero. There won't be anything to do,
             * but this is not an error situation so make sure we
             * return OK instead of BUF_ERROR at next call of deflate:
             */
            s-&gt;last_flush = -1;
            return Z_OK;
        }

    /* Make sure there is something to do and avoid duplicate consecutive
     * flushes. For repeated and useless calls with Z_FINISH, we keep
     * returning Z_STREAM_END instead of Z_BUF_ERROR.
     */
    } else if (strm-&gt;avail_in == 0 &amp;&amp; flush &lt;= old_flush &amp;&amp;
               flush != Z_FINISH) {
        ERR_RETURN(strm, Z_BUF_ERROR);
    }

    /* User must not provide more input after the first FINISH: */
    if (s-&gt;status == FINISH_STATE &amp;&amp; strm-&gt;avail_in != 0) {
        ERR_RETURN(strm, Z_BUF_ERROR);
    }

    /* Start a new block or continue the current one.
     */
    if (strm-&gt;avail_in != 0 || s-&gt;lookahead != 0 ||
        (flush != Z_NO_FLUSH &amp;&amp; s-&gt;status != FINISH_STATE)) {
        block_state bstate;

        bstate = (*(configuration_table[s-&gt;level].func))(s, flush);

        if (bstate == finish_started || bstate == finish_done) {
            s-&gt;status = FINISH_STATE;
        }
        if (bstate == need_more || bstate == finish_started) {
            if (strm-&gt;avail_out == 0) {
                s-&gt;last_flush = -1; /* avoid BUF_ERROR next call, see above */
            }
            return Z_OK;
            /* If flush != Z_NO_FLUSH &amp;&amp; avail_out == 0, the next call
             * of deflate should use the same flush parameter to make sure
             * that the flush is complete. So we don't have to output an
             * empty block here, this will be done at next call. This also
             * ensures that for a very small output buffer, we emit at most
             * one empty block.
             */
        }
        if (bstate == block_done) {
            if (flush == Z_PARTIAL_FLUSH) {
                _tr_align(s);
            } else { /* FULL_FLUSH or SYNC_FLUSH */
                _tr_stored_block(s, (char*)0, 0L, 0);
                /* For a full flush, this empty block will be recognized
                 * as a special marker by inflate_sync().
                 */
                if (flush == Z_FULL_FLUSH) {
                    CLEAR_HASH(s);             /* forget history */
                }
            }
            flush_pending(strm);
            if (strm-&gt;avail_out == 0) {
              s-&gt;last_flush = -1; /* avoid BUF_ERROR at next call, see above */
              return Z_OK;
            }
        }
    }
    Assert(strm-&gt;avail_out &gt; 0, "bug2");

    if (flush != Z_FINISH) return Z_OK;
    if (s-&gt;wrap &lt;= 0) return Z_STREAM_END;

    /* Write the trailer */
#ifdef GZIP
    if (s-&gt;wrap == 2) {
        put_byte(s, (Byte)(strm-&gt;adler &amp; 0xff));
        put_byte(s, (Byte)((strm-&gt;adler &gt;&gt; 8) &amp; 0xff));
        put_byte(s, (Byte)((strm-&gt;adler &gt;&gt; 16) &amp; 0xff));
        put_byte(s, (Byte)((strm-&gt;adler &gt;&gt; 24) &amp; 0xff));
        put_byte(s, (Byte)(strm-&gt;total_in &amp; 0xff));
        put_byte(s, (Byte)((strm-&gt;total_in &gt;&gt; 8) &amp; 0xff));
        put_byte(s, (Byte)((strm-&gt;total_in &gt;&gt; 16) &amp; 0xff));
        put_byte(s, (Byte)((strm-&gt;total_in &gt;&gt; 24) &amp; 0xff));
    }
    else
#endif
    {
        putShortMSB(s, (uInt)(strm-&gt;adler &gt;&gt; 16));
        putShortMSB(s, (uInt)(strm-&gt;adler &amp; 0xffff));
    }
    flush_pending(strm);
    /* If avail_out is zero, the application will call deflate again
     * to flush the rest.
     */
    if (s-&gt;wrap &gt; 0) s-&gt;wrap = -s-&gt;wrap; /* write the trailer only once! */
    return s-&gt;pending != 0 ? Z_OK : Z_STREAM_END;
}

/* ========================================================================= */
int ZEXPORT deflateEnd (strm)
    z_streamp strm;
{
    int status;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;

    status = strm-&gt;state-&gt;status;
    if (status != INIT_STATE &amp;&amp; status != BUSY_STATE &amp;&amp;
        status != FINISH_STATE) {
      return Z_STREAM_ERROR;
    }

    /* Deallocate in reverse order of allocations: */
    TRY_FREE(strm, strm-&gt;state-&gt;pending_buf);
    TRY_FREE(strm, strm-&gt;state-&gt;head);
    TRY_FREE(strm, strm-&gt;state-&gt;prev);
    TRY_FREE(strm, strm-&gt;state-&gt;window);

    ZFREE(strm, strm-&gt;state);
    strm-&gt;state = Z_NULL;

    return status == BUSY_STATE ? Z_DATA_ERROR : Z_OK;
}

/* =========================================================================
 * Copy the source state to the destination state.
 * To simplify the source, this is not supported for 16-bit MSDOS (which
 * doesn't have enough memory anyway to duplicate compression states).
 */
int ZEXPORT deflateCopy (dest, source)
    z_streamp dest;
    z_streamp source;
{
#ifdef MAXSEG_64K
    return Z_STREAM_ERROR;
#else
    deflate_state *ds;
    deflate_state *ss;
    ushf *overlay;


    if (source == Z_NULL || dest == Z_NULL || source-&gt;state == Z_NULL) {
        return Z_STREAM_ERROR;
    }

    ss = source-&gt;state;

    *dest = *source;

    ds = (deflate_state *) ZALLOC(dest, 1, sizeof(deflate_state));
    if (ds == Z_NULL) return Z_MEM_ERROR;
    dest-&gt;state = (struct internal_state FAR *) ds;
    *ds = *ss;
    ds-&gt;strm = dest;

    ds-&gt;window = (Bytef *) ZALLOC(dest, ds-&gt;w_size, 2*sizeof(Byte));
    ds-&gt;prev   = (Posf *)  ZALLOC(dest, ds-&gt;w_size, sizeof(Pos));
    ds-&gt;head   = (Posf *)  ZALLOC(dest, ds-&gt;hash_size, sizeof(Pos));
    overlay = (ushf *) ZALLOC(dest, ds-&gt;lit_bufsize, sizeof(ush)+2);
    ds-&gt;pending_buf = (uchf *) overlay;

    if (ds-&gt;window == Z_NULL || ds-&gt;prev == Z_NULL || ds-&gt;head == Z_NULL ||
        ds-&gt;pending_buf == Z_NULL) {
        deflateEnd (dest);
        return Z_MEM_ERROR;
    }
    /* following zmemcpy do not work for 16-bit MSDOS */
    zmemcpy(ds-&gt;window, ss-&gt;window, ds-&gt;w_size * 2 * sizeof(Byte));
    zmemcpy(ds-&gt;prev, ss-&gt;prev, ds-&gt;w_size * sizeof(Pos));
    zmemcpy(ds-&gt;head, ss-&gt;head, ds-&gt;hash_size * sizeof(Pos));
    zmemcpy(ds-&gt;pending_buf, ss-&gt;pending_buf, (uInt)ds-&gt;pending_buf_size);

    ds-&gt;pending_out = ds-&gt;pending_buf + (ss-&gt;pending_out - ss-&gt;pending_buf);
    ds-&gt;d_buf = overlay + ds-&gt;lit_bufsize/sizeof(ush);
    ds-&gt;l_buf = ds-&gt;pending_buf + (1+sizeof(ush))*ds-&gt;lit_bufsize;

    ds-&gt;l_desc.dyn_tree = ds-&gt;dyn_ltree;
    ds-&gt;d_desc.dyn_tree = ds-&gt;dyn_dtree;
    ds-&gt;bl_desc.dyn_tree = ds-&gt;bl_tree;

    return Z_OK;
#endif /* MAXSEG_64K */
}

/* ===========================================================================
 * Read a new buffer from the current input stream, update the adler32
 * and total number of bytes read.  All deflate() input goes through
 * this function so some applications may wish to modify it to avoid
 * allocating a large strm-&gt;next_in buffer and copying from it.
 * (See also flush_pending()).
 */
local int read_buf(strm, buf, size)
    z_streamp strm;
    Bytef *buf;
    unsigned size;
{
    unsigned len = strm-&gt;avail_in;

    if (len &gt; size) len = size;
    if (len == 0) return 0;

    strm-&gt;avail_in  -= len;

    if (strm-&gt;state-&gt;wrap == 1) {
        strm-&gt;adler = adler32(strm-&gt;adler, strm-&gt;next_in, len);
    }
#ifdef GZIP
    else if (strm-&gt;state-&gt;wrap == 2) {
        strm-&gt;adler = crc32(strm-&gt;adler, strm-&gt;next_in, len);
    }
#endif
    zmemcpy(buf, strm-&gt;next_in, len);
    strm-&gt;next_in  += len;
    strm-&gt;total_in += len;

    return (int)len;
}

/* ===========================================================================
 * Initialize the "longest match" routines for a new zlib stream
 */
local void lm_init (s)
    deflate_state *s;
{
    s-&gt;window_size = (ulg)2L*s-&gt;w_size;

    CLEAR_HASH(s);

    /* Set the default configuration parameters:
     */
    s-&gt;max_lazy_match   = configuration_table[s-&gt;level].max_lazy;
    s-&gt;good_match       = configuration_table[s-&gt;level].good_length;
    s-&gt;nice_match       = configuration_table[s-&gt;level].nice_length;
    s-&gt;max_chain_length = configuration_table[s-&gt;level].max_chain;

    s-&gt;strstart = 0;
    s-&gt;block_start = 0L;
    s-&gt;lookahead = 0;
    s-&gt;match_length = s-&gt;prev_length = MIN_MATCH-1;
    s-&gt;match_available = 0;
    s-&gt;ins_h = 0;
#ifdef ASMV
    match_init(); /* initialize the asm code */
#endif
}

#ifndef FASTEST
/* ===========================================================================
 * Set match_start to the longest match starting at the given string and
 * return its length. Matches shorter or equal to prev_length are discarded,
 * in which case the result is equal to prev_length and match_start is
 * garbage.
 * IN assertions: cur_match is the head of the hash chain for the current
 *   string (strstart) and its distance is &lt;= MAX_DIST, and prev_length &gt;= 1
 * OUT assertion: the match length is not greater than s-&gt;lookahead.
 */
#ifndef ASMV
/* For 80x86 and 680x0, an optimized version will be provided in match.asm or
 * match.S. The code will be functionally equivalent.
 */
local uInt longest_match(s, cur_match)
    deflate_state *s;
    IPos cur_match;                             /* current match */
{
    unsigned chain_length = s-&gt;max_chain_length;/* max hash chain length */
    register Bytef *scan = s-&gt;window + s-&gt;strstart; /* current string */
    register Bytef *match;                       /* matched string */
    register int len;                           /* length of current match */
    int best_len = s-&gt;prev_length;              /* best match length so far */
    int nice_match = s-&gt;nice_match;             /* stop if match long enough */
    IPos limit = s-&gt;strstart &gt; (IPos)MAX_DIST(s) ?
        s-&gt;strstart - (IPos)MAX_DIST(s) : NIL;
    /* Stop when cur_match becomes &lt;= limit. To simplify the code,
     * we prevent matches with the string of window index 0.
     */
    Posf *prev = s-&gt;prev;
    uInt wmask = s-&gt;w_mask;

#ifdef UNALIGNED_OK
    /* Compare two bytes at a time. Note: this is not always beneficial.
     * Try with and without -DUNALIGNED_OK to check.
     */
    register Bytef *strend = s-&gt;window + s-&gt;strstart + MAX_MATCH - 1;
    register ush scan_start = *(ushf*)scan;
    register ush scan_end   = *(ushf*)(scan+best_len-1);
#else
    register Bytef *strend = s-&gt;window + s-&gt;strstart + MAX_MATCH;
    register Byte scan_end1  = scan[best_len-1];
    register Byte scan_end   = scan[best_len];
#endif

    /* The code is optimized for HASH_BITS &gt;= 8 and MAX_MATCH-2 multiple of 16.
     * It is easy to get rid of this optimization if necessary.
     */
    Assert(s-&gt;hash_bits &gt;= 8 &amp;&amp; MAX_MATCH == 258, "Code too clever");

    /* Do not waste too much time if we already have a good match: */
    if (s-&gt;prev_length &gt;= s-&gt;good_match) {
        chain_length &gt;&gt;= 2;
    }
    /* Do not look for matches beyond the end of the input. This is necessary
     * to make deflate deterministic.
     */
    if ((uInt)nice_match &gt; s-&gt;lookahead) nice_match = s-&gt;lookahead;

    Assert((ulg)s-&gt;strstart &lt;= s-&gt;window_size-MIN_LOOKAHEAD, "need lookahead");

    do {
        Assert(cur_match &lt; s-&gt;strstart, "no future");
        match = s-&gt;window + cur_match;

        /* Skip to next match if the match length cannot increase
         * or if the match length is less than 2:
         */
#if (defined(UNALIGNED_OK) &amp;&amp; MAX_MATCH == 258)
        /* This code assumes sizeof(unsigned short) == 2. Do not use
         * UNALIGNED_OK if your compiler uses a different size.
         */
        if (*(ushf*)(match+best_len-1) != scan_end ||
            *(ushf*)match != scan_start) continue;

        /* It is not necessary to compare scan[2] and match[2] since they are
         * always equal when the other bytes match, given that the hash keys
         * are equal and that HASH_BITS &gt;= 8. Compare 2 bytes at a time at
         * strstart+3, +5, ... up to strstart+257. We check for insufficient
         * lookahead only every 4th comparison; the 128th check will be made
         * at strstart+257. If MAX_MATCH-2 is not a multiple of 8, it is
         * necessary to put more guard bytes at the end of the window, or
         * to check more often for insufficient lookahead.
         */
        Assert(scan[2] == match[2], "scan[2]?");
        scan++, match++;
        do {
        } while (*(ushf*)(scan+=2) == *(ushf*)(match+=2) &amp;&amp;
                 *(ushf*)(scan+=2) == *(ushf*)(match+=2) &amp;&amp;
                 *(ushf*)(scan+=2) == *(ushf*)(match+=2) &amp;&amp;
                 *(ushf*)(scan+=2) == *(ushf*)(match+=2) &amp;&amp;
                 scan &lt; strend);
        /* The funny "do {}" generates better code on most compilers */

        /* Here, scan &lt;= window+strstart+257 */
        Assert(scan &lt;= s-&gt;window+(unsigned)(s-&gt;window_size-1), "wild scan");
        if (*scan == *match) scan++;

        len = (MAX_MATCH - 1) - (int)(strend-scan);
        scan = strend - (MAX_MATCH-1);

#else /* UNALIGNED_OK */

        if (match[best_len]   != scan_end  ||
            match[best_len-1] != scan_end1 ||
            *match            != *scan     ||
            *++match          != scan[1])      continue;

        /* The check at best_len-1 can be removed because it will be made
         * again later. (This heuristic is not always a win.)
         * It is not necessary to compare scan[2] and match[2] since they
         * are always equal when the other bytes match, given that
         * the hash keys are equal and that HASH_BITS &gt;= 8.
         */
        scan += 2, match++;
        Assert(*scan == *match, "match[2]?");

        /* We check for insufficient lookahead only every 8th comparison;
         * the 256th check will be made at strstart+258.
         */
        do {
        } while (*++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
                 *++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
                 *++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
                 *++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
                 scan &lt; strend);

        Assert(scan &lt;= s-&gt;window+(unsigned)(s-&gt;window_size-1), "wild scan");

        len = MAX_MATCH - (int)(strend - scan);
        scan = strend - MAX_MATCH;

#endif /* UNALIGNED_OK */

        if (len &gt; best_len) {
            s-&gt;match_start = cur_match;
            best_len = len;
            if (len &gt;= nice_match) break;
#ifdef UNALIGNED_OK
            scan_end = *(ushf*)(scan+best_len-1);
#else
            scan_end1  = scan[best_len-1];
            scan_end   = scan[best_len];
#endif
        }
    } while ((cur_match = prev[cur_match &amp; wmask]) &gt; limit
             &amp;&amp; --chain_length != 0);

    if ((uInt)best_len &lt;= s-&gt;lookahead) return (uInt)best_len;
    return s-&gt;lookahead;
}
#endif /* ASMV */
#endif /* FASTEST */

/* ---------------------------------------------------------------------------
 * Optimized version for level == 1 or strategy == Z_RLE only
 */
local uInt longest_match_fast(s, cur_match)
    deflate_state *s;
    IPos cur_match;                             /* current match */
{
    register Bytef *scan = s-&gt;window + s-&gt;strstart; /* current string */
    register Bytef *match;                       /* matched string */
    register int len;                           /* length of current match */
    register Bytef *strend = s-&gt;window + s-&gt;strstart + MAX_MATCH;

    /* The code is optimized for HASH_BITS &gt;= 8 and MAX_MATCH-2 multiple of 16.
     * It is easy to get rid of this optimization if necessary.
     */
    Assert(s-&gt;hash_bits &gt;= 8 &amp;&amp; MAX_MATCH == 258, "Code too clever");

    Assert((ulg)s-&gt;strstart &lt;= s-&gt;window_size-MIN_LOOKAHEAD, "need lookahead");

    Assert(cur_match &lt; s-&gt;strstart, "no future");

    match = s-&gt;window + cur_match;

    /* Return failure if the match length is less than 2:
     */
    if (match[0] != scan[0] || match[1] != scan[1]) return MIN_MATCH-1;

    /* The check at best_len-1 can be removed because it will be made
     * again later. (This heuristic is not always a win.)
     * It is not necessary to compare scan[2] and match[2] since they
     * are always equal when the other bytes match, given that
     * the hash keys are equal and that HASH_BITS &gt;= 8.
     */
    scan += 2, match += 2;
    Assert(*scan == *match, "match[2]?");

    /* We check for insufficient lookahead only every 8th comparison;
     * the 256th check will be made at strstart+258.
     */
    do {
    } while (*++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
             *++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
             *++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
             *++scan == *++match &amp;&amp; *++scan == *++match &amp;&amp;
             scan &lt; strend);

    Assert(scan &lt;= s-&gt;window+(unsigned)(s-&gt;window_size-1), "wild scan");

    len = MAX_MATCH - (int)(strend - scan);

    if (len &lt; MIN_MATCH) return MIN_MATCH - 1;

    s-&gt;match_start = cur_match;
    return (uInt)len &lt;= s-&gt;lookahead ? (uInt)len : s-&gt;lookahead;
}

#ifdef DEBUG
/* ===========================================================================
 * Check that the match at match_start is indeed a match.
 */
local void check_match(s, start, match, length)
    deflate_state *s;
    IPos start, match;
    int length;
{
    /* check that the match is indeed a match */
    if (zmemcmp(s-&gt;window + match,
                s-&gt;window + start, length) != EQUAL) {
        fprintf(stderr, " start %u, match %u, length %d\n",
                start, match, length);
        do {
            fprintf(stderr, "%c%c", s-&gt;window[match++], s-&gt;window[start++]);
        } while (--length != 0);
        z_error("invalid match");
    }
    if (z_verbose &gt; 1) {
        fprintf(stderr,"\\[%d,%d]", start-match, length);
        do { putc(s-&gt;window[start++], stderr); } while (--length != 0);
    }
}
#else
#  define check_match(s, start, match, length)
#endif /* DEBUG */

/* ===========================================================================
 * Fill the window when the lookahead becomes insufficient.
 * Updates strstart and lookahead.
 *
 * IN assertion: lookahead &lt; MIN_LOOKAHEAD
 * OUT assertions: strstart &lt;= window_size-MIN_LOOKAHEAD
 *    At least one byte has been read, or avail_in == 0; reads are
 *    performed for at least two bytes (required for the zip translate_eol
 *    option -- not supported here).
 */
local void fill_window(s)
    deflate_state *s;
{
    register unsigned n, m;
    register Posf *p;
    unsigned more;    /* Amount of free space at the end of the window. */
    uInt wsize = s-&gt;w_size;

    do {
        more = (unsigned)(s-&gt;window_size -(ulg)s-&gt;lookahead -(ulg)s-&gt;strstart);

        /* Deal with !@#$% 64K limit: */
        if (sizeof(int) &lt;= 2) {
            if (more == 0 &amp;&amp; s-&gt;strstart == 0 &amp;&amp; s-&gt;lookahead == 0) {
                more = wsize;

            } else if (more == (unsigned)(-1)) {
                /* Very unlikely, but possible on 16 bit machine if
                 * strstart == 0 &amp;&amp; lookahead == 1 (input done a byte at time)
                 */
                more--;
            }
        }

        /* If the window is almost full and there is insufficient lookahead,
         * move the upper half to the lower one to make room in the upper half.
         */
        if (s-&gt;strstart &gt;= wsize+MAX_DIST(s)) {

            zmemcpy(s-&gt;window, s-&gt;window+wsize, (unsigned)wsize);
            s-&gt;match_start -= wsize;
            s-&gt;strstart    -= wsize; /* we now have strstart &gt;= MAX_DIST */
            s-&gt;block_start -= (long) wsize;

            /* Slide the hash table (could be avoided with 32 bit values
               at the expense of memory usage). We slide even when level == 0
               to keep the hash table consistent if we switch back to level &gt; 0
               later. (Using level 0 permanently is not an optimal usage of
               zlib, so we don't care about this pathological case.)
             */
            n = s-&gt;hash_size;
            p = &amp;s-&gt;head[n];
            do {
                m = *--p;
                *p = (Pos)(m &gt;= wsize ? m-wsize : NIL);
            } while (--n);

            n = wsize;
#ifndef FASTEST
            p = &amp;s-&gt;prev[n];
            do {
                m = *--p;
                *p = (Pos)(m &gt;= wsize ? m-wsize : NIL);
                /* If n is not on any hash chain, prev[n] is garbage but
                 * its value will never be used.
                 */
            } while (--n);
#endif
            more += wsize;
        }
        if (s-&gt;strm-&gt;avail_in == 0) return;

        /* If there was no sliding:
         *    strstart &lt;= WSIZE+MAX_DIST-1 &amp;&amp; lookahead &lt;= MIN_LOOKAHEAD - 1 &amp;&amp;
         *    more == window_size - lookahead - strstart
         * =&gt; more &gt;= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
         * =&gt; more &gt;= window_size - 2*WSIZE + 2
         * In the BIG_MEM or MMAP case (not yet supported),
         *   window_size == input_size + MIN_LOOKAHEAD  &amp;&amp;
         *   strstart + s-&gt;lookahead &lt;= input_size =&gt; more &gt;= MIN_LOOKAHEAD.
         * Otherwise, window_size == 2*WSIZE so more &gt;= 2.
         * If there was sliding, more &gt;= WSIZE. So in all cases, more &gt;= 2.
         */
        Assert(more &gt;= 2, "more &lt; 2");

        n = read_buf(s-&gt;strm, s-&gt;window + s-&gt;strstart + s-&gt;lookahead, more);
        s-&gt;lookahead += n;

        /* Initialize the hash value now that we have some input: */
        if (s-&gt;lookahead &gt;= MIN_MATCH) {
            s-&gt;ins_h = s-&gt;window[s-&gt;strstart];
            UPDATE_HASH(s, s-&gt;ins_h, s-&gt;window[s-&gt;strstart+1]);
#if MIN_MATCH != 3
            Call UPDATE_HASH() MIN_MATCH-3 more times
#endif
        }
        /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
         * but this is not important since only literal bytes will be emitted.
         */

    } while (s-&gt;lookahead &lt; MIN_LOOKAHEAD &amp;&amp; s-&gt;strm-&gt;avail_in != 0);
}

/* ===========================================================================
 * Flush the current block, with given end-of-file flag.
 * IN assertion: strstart is set to the end of the current match.
 */
#define FLUSH_BLOCK_ONLY(s, eof) { \
   _tr_flush_block(s, (s-&gt;block_start &gt;= 0L ? \
                   (charf *)&amp;s-&gt;window[(unsigned)s-&gt;block_start] : \
                   (charf *)Z_NULL), \
                (ulg)((long)s-&gt;strstart - s-&gt;block_start), \
                (eof)); \
   s-&gt;block_start = s-&gt;strstart; \
   flush_pending(s-&gt;strm); \
   Tracev((stderr,"[FLUSH]")); \
}

/* Same but force premature exit if necessary. */
#define FLUSH_BLOCK(s, eof) { \
   FLUSH_BLOCK_ONLY(s, eof); \
   if (s-&gt;strm-&gt;avail_out == 0) return (eof) ? finish_started : need_more; \
}

/* ===========================================================================
 * Copy without compression as much as possible from the input stream, return
 * the current block state.
 * This function does not insert new strings in the dictionary since
 * uncompressible data is probably not useful. This function is used
 * only for the level=0 compression option.
 * NOTE: this function should be optimized to avoid extra copying from
 * window to pending_buf.
 */
local block_state deflate_stored(s, flush)
    deflate_state *s;
    int flush;
{
    /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
     * to pending_buf_size, and each stored block has a 5 byte header:
     */
    ulg max_block_size = 0xffff;
    ulg max_start;

    if (max_block_size &gt; s-&gt;pending_buf_size - 5) {
        max_block_size = s-&gt;pending_buf_size - 5;
    }

    /* Copy as much as possible from input to output: */
    for (;;) {
        /* Fill the window as much as possible: */
        if (s-&gt;lookahead &lt;= 1) {

            Assert(s-&gt;strstart &lt; s-&gt;w_size+MAX_DIST(s) ||
                   s-&gt;block_start &gt;= (long)s-&gt;w_size, "slide too late");

            fill_window(s);
            if (s-&gt;lookahead == 0 &amp;&amp; flush == Z_NO_FLUSH) return need_more;

            if (s-&gt;lookahead == 0) break; /* flush the current block */
        }
        Assert(s-&gt;block_start &gt;= 0L, "block gone");

        s-&gt;strstart += s-&gt;lookahead;
        s-&gt;lookahead = 0;

        /* Emit a stored block if pending_buf will be full: */
        max_start = s-&gt;block_start + max_block_size;
        if (s-&gt;strstart == 0 || (ulg)s-&gt;strstart &gt;= max_start) {
            /* strstart == 0 is possible when wraparound on 16-bit machine */
            s-&gt;lookahead = (uInt)(s-&gt;strstart - max_start);
            s-&gt;strstart = (uInt)max_start;
            FLUSH_BLOCK(s, 0);
        }
        /* Flush if we may have to slide, otherwise block_start may become
         * negative and the data will be gone:
         */
        if (s-&gt;strstart - (uInt)s-&gt;block_start &gt;= MAX_DIST(s)) {
            FLUSH_BLOCK(s, 0);
        }
    }
    FLUSH_BLOCK(s, flush == Z_FINISH);
    return flush == Z_FINISH ? finish_done : block_done;
}

/* ===========================================================================
 * Compress as much as possible from the input stream, return the current
 * block state.
 * This function does not perform lazy evaluation of matches and inserts
 * new strings in the dictionary only for unmatched strings or for short
 * matches. It is used only for the fast compression options.
 */
local block_state deflate_fast(s, flush)
    deflate_state *s;
    int flush;
{
    IPos hash_head = NIL; /* head of the hash chain */
    int bflush;           /* set if current block must be flushed */

    for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the next match, plus MIN_MATCH bytes to insert the
         * string following the next match.
         */
        if (s-&gt;lookahead &lt; MIN_LOOKAHEAD) {
            fill_window(s);
            if (s-&gt;lookahead &lt; MIN_LOOKAHEAD &amp;&amp; flush == Z_NO_FLUSH) {
                return need_more;
            }
            if (s-&gt;lookahead == 0) break; /* flush the current block */
        }

        /* Insert the string window[strstart .. strstart+2] in the
         * dictionary, and set hash_head to the head of the hash chain:
         */
        if (s-&gt;lookahead &gt;= MIN_MATCH) {
            INSERT_STRING(s, s-&gt;strstart, hash_head);
        }

        /* Find the longest match, discarding those &lt;= prev_length.
         * At this point we have always match_length &lt; MIN_MATCH
         */
        if (hash_head != NIL &amp;&amp; s-&gt;strstart - hash_head &lt;= MAX_DIST(s)) {
            /* To simplify the code, we prevent matches with the string
             * of window index 0 (in particular we have to avoid a match
             * of the string with itself at the start of the input file).
             */
#ifdef FASTEST
            if ((s-&gt;strategy &lt; Z_HUFFMAN_ONLY) ||
                (s-&gt;strategy == Z_RLE &amp;&amp; s-&gt;strstart - hash_head == 1)) {
                s-&gt;match_length = longest_match_fast (s, hash_head);
            }
#else
            if (s-&gt;strategy &lt; Z_HUFFMAN_ONLY) {
                s-&gt;match_length = longest_match (s, hash_head);
            } else if (s-&gt;strategy == Z_RLE &amp;&amp; s-&gt;strstart - hash_head == 1) {
                s-&gt;match_length = longest_match_fast (s, hash_head);
            }
#endif
            /* longest_match() or longest_match_fast() sets match_start */
        }
        if (s-&gt;match_length &gt;= MIN_MATCH) {
            check_match(s, s-&gt;strstart, s-&gt;match_start, s-&gt;match_length);

            _tr_tally_dist(s, s-&gt;strstart - s-&gt;match_start,
                           s-&gt;match_length - MIN_MATCH, bflush);

            s-&gt;lookahead -= s-&gt;match_length;

            /* Insert new strings in the hash table only if the match length
             * is not too large. This saves time but degrades compression.
             */
#ifndef FASTEST
            if (s-&gt;match_length &lt;= s-&gt;max_insert_length &amp;&amp;
                s-&gt;lookahead &gt;= MIN_MATCH) {
                s-&gt;match_length--; /* string at strstart already in table */
                do {
                    s-&gt;strstart++;
                    INSERT_STRING(s, s-&gt;strstart, hash_head);
                    /* strstart never exceeds WSIZE-MAX_MATCH, so there are
                     * always MIN_MATCH bytes ahead.
                     */
                } while (--s-&gt;match_length != 0);
                s-&gt;strstart++;
            } else
#endif
            {
                s-&gt;strstart += s-&gt;match_length;
                s-&gt;match_length = 0;
                s-&gt;ins_h = s-&gt;window[s-&gt;strstart];
                UPDATE_HASH(s, s-&gt;ins_h, s-&gt;window[s-&gt;strstart+1]);
#if MIN_MATCH != 3
                Call UPDATE_HASH() MIN_MATCH-3 more times
#endif
                /* If lookahead &lt; MIN_MATCH, ins_h is garbage, but it does not
                 * matter since it will be recomputed at next deflate call.
                 */
            }
        } else {
            /* No match, output a literal byte */
            Tracevv((stderr,"%c", s-&gt;window[s-&gt;strstart]));
            _tr_tally_lit (s, s-&gt;window[s-&gt;strstart], bflush);
            s-&gt;lookahead--;
            s-&gt;strstart++;
        }
        if (bflush) FLUSH_BLOCK(s, 0);
    }
    FLUSH_BLOCK(s, flush == Z_FINISH);
    return flush == Z_FINISH ? finish_done : block_done;
}

#ifndef FASTEST
/* ===========================================================================
 * Same as above, but achieves better compression. We use a lazy
 * evaluation for matches: a match is finally adopted only if there is
 * no better match at the next window position.
 */
local block_state deflate_slow(s, flush)
    deflate_state *s;
    int flush;
{
    IPos hash_head = NIL;    /* head of hash chain */
    int bflush;              /* set if current block must be flushed */

    /* Process the input block. */
    for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the next match, plus MIN_MATCH bytes to insert the
         * string following the next match.
         */
        if (s-&gt;lookahead &lt; MIN_LOOKAHEAD) {
            fill_window(s);
            if (s-&gt;lookahead &lt; MIN_LOOKAHEAD &amp;&amp; flush == Z_NO_FLUSH) {
                return need_more;
            }
            if (s-&gt;lookahead == 0) break; /* flush the current block */
        }

        /* Insert the string window[strstart .. strstart+2] in the
         * dictionary, and set hash_head to the head of the hash chain:
         */
        if (s-&gt;lookahead &gt;= MIN_MATCH) {
            INSERT_STRING(s, s-&gt;strstart, hash_head);
        }

        /* Find the longest match, discarding those &lt;= prev_length.
         */
        s-&gt;prev_length = s-&gt;match_length, s-&gt;prev_match = s-&gt;match_start;
        s-&gt;match_length = MIN_MATCH-1;

        if (hash_head != NIL &amp;&amp; s-&gt;prev_length &lt; s-&gt;max_lazy_match &amp;&amp;
            s-&gt;strstart - hash_head &lt;= MAX_DIST(s)) {
            /* To simplify the code, we prevent matches with the string
             * of window index 0 (in particular we have to avoid a match
             * of the string with itself at the start of the input file).
             */
            if (s-&gt;strategy &lt; Z_HUFFMAN_ONLY) {
                s-&gt;match_length = longest_match (s, hash_head);
            } else if (s-&gt;strategy == Z_RLE &amp;&amp; s-&gt;strstart - hash_head == 1) {
                s-&gt;match_length = longest_match_fast (s, hash_head);
            }
            /* longest_match() or longest_match_fast() sets match_start */

            if (s-&gt;match_length &lt;= 5 &amp;&amp; (s-&gt;strategy == Z_FILTERED
#if TOO_FAR &lt;= 32767
                || (s-&gt;match_length == MIN_MATCH &amp;&amp;
                    s-&gt;strstart - s-&gt;match_start &gt; TOO_FAR)
#endif
                )) {

                /* If prev_match is also MIN_MATCH, match_start is garbage
                 * but we will ignore the current match anyway.
                 */
                s-&gt;match_length = MIN_MATCH-1;
            }
        }
        /* If there was a match at the previous step and the current
         * match is not better, output the previous match:
         */
        if (s-&gt;prev_length &gt;= MIN_MATCH &amp;&amp; s-&gt;match_length &lt;= s-&gt;prev_length) {
            uInt max_insert = s-&gt;strstart + s-&gt;lookahead - MIN_MATCH;
            /* Do not insert strings in hash table beyond this. */

            check_match(s, s-&gt;strstart-1, s-&gt;prev_match, s-&gt;prev_length);

            _tr_tally_dist(s, s-&gt;strstart -1 - s-&gt;prev_match,
                           s-&gt;prev_length - MIN_MATCH, bflush);

            /* Insert in hash table all strings up to the end of the match.
             * strstart-1 and strstart are already inserted. If there is not
             * enough lookahead, the last two strings are not inserted in
             * the hash table.
             */
            s-&gt;lookahead -= s-&gt;prev_length-1;
            s-&gt;prev_length -= 2;
            do {
                if (++s-&gt;strstart &lt;= max_insert) {
                    INSERT_STRING(s, s-&gt;strstart, hash_head);
                }
            } while (--s-&gt;prev_length != 0);
            s-&gt;match_available = 0;
            s-&gt;match_length = MIN_MATCH-1;
            s-&gt;strstart++;

            if (bflush) FLUSH_BLOCK(s, 0);

        } else if (s-&gt;match_available) {
            /* If there was no match at the previous position, output a
             * single literal. If there was a match but the current match
             * is longer, truncate the previous match to a single literal.
             */
            Tracevv((stderr,"%c", s-&gt;window[s-&gt;strstart-1]));
            _tr_tally_lit(s, s-&gt;window[s-&gt;strstart-1], bflush);
            if (bflush) {
                FLUSH_BLOCK_ONLY(s, 0);
            }
            s-&gt;strstart++;
            s-&gt;lookahead--;
            if (s-&gt;strm-&gt;avail_out == 0) return need_more;
        } else {
            /* There is no previous match to compare with, wait for
             * the next step to decide.
             */
            s-&gt;match_available = 1;
            s-&gt;strstart++;
            s-&gt;lookahead--;
        }
    }
    Assert (flush != Z_NO_FLUSH, "no flush?");
    if (s-&gt;match_available) {
        Tracevv((stderr,"%c", s-&gt;window[s-&gt;strstart-1]));
        _tr_tally_lit(s, s-&gt;window[s-&gt;strstart-1], bflush);
        s-&gt;match_available = 0;
    }
    FLUSH_BLOCK(s, flush == Z_FINISH);
    return flush == Z_FINISH ? finish_done : block_done;
}
#endif /* FASTEST */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

