<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/zlib/gzio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/zlib/gzio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* gzio.c -- IO on .gz files
 * Copyright (C) 1995-2003 Jean-loup Gailly.
 * For conditions of distribution and use, see copyright notice in zlib.h
 *
 * Compile this file with -DNO_GZCOMPRESS to avoid the compression code.
 */

/* @(#) $Id: gzio.c,v 1.1.1.1 2005/04/24 21:39:39 giles Exp $ */

#include &lt;stdio.h&gt;

#include "zutil.h"

#ifdef NO_DEFLATE       /* for compatiblity with old definition */
#  define NO_GZCOMPRESS
#endif

#ifndef NO_DUMMY_DECL
struct internal_state {int dummy;}; /* for buggy compilers */
#endif

#ifndef Z_BUFSIZE
#  ifdef MAXSEG_64K
#    define Z_BUFSIZE 4096 /* minimize memory usage for 16-bit DOS */
#  else
#    define Z_BUFSIZE 16384
#  endif
#endif
#ifndef Z_PRINTF_BUFSIZE
#  define Z_PRINTF_BUFSIZE 4096
#endif

#ifdef __MVS__
#  pragma map (fdopen , "\174\174FDOPEN")
   FILE *fdopen(int, const char *);
#endif

#ifndef STDC
extern voidp  malloc OF((uInt size));
extern void   free   OF((voidpf ptr));
#endif

#define ALLOC(size) malloc(size)
#define TRYFREE(p) {if (p) free(p);}

static int const gz_magic[2] = {0x1f, 0x8b}; /* gzip magic header */

/* gzip flag byte */
#define ASCII_FLAG   0x01 /* bit 0 set: file probably ascii text */
#define HEAD_CRC     0x02 /* bit 1 set: header CRC present */
#define EXTRA_FIELD  0x04 /* bit 2 set: extra field present */
#define ORIG_NAME    0x08 /* bit 3 set: original file name present */
#define COMMENT      0x10 /* bit 4 set: file comment present */
#define RESERVED     0xE0 /* bits 5..7: reserved */

typedef struct gz_stream {
    z_stream stream;
    int      z_err;   /* error code for last stream operation */
    int      z_eof;   /* set if end of input file */
    FILE     *file;   /* .gz file */
    Byte     *inbuf;  /* input buffer */
    Byte     *outbuf; /* output buffer */
    uLong    crc;     /* crc32 of uncompressed data */
    char     *msg;    /* error message */
    char     *path;   /* path name for debugging only */
    int      transparent; /* 1 if input file is not a .gz file */
    char     mode;    /* 'w' or 'r' */
    z_off_t  start;   /* start of compressed data in file (header skipped) */
    z_off_t  in;      /* bytes into deflate or inflate */
    z_off_t  out;     /* bytes out of deflate or inflate */
    int      back;    /* one character push-back */
    int      last;    /* true if push-back is last character */
} gz_stream;


local gzFile gz_open      OF((const char *path, const char *mode, int  fd));
local int do_flush        OF((gzFile file, int flush));
local int    get_byte     OF((gz_stream *s));
local void   check_header OF((gz_stream *s));
local int    destroy      OF((gz_stream *s));
local void   putLong      OF((FILE *file, uLong x));
local uLong  getLong      OF((gz_stream *s));

/* ===========================================================================
     Opens a gzip (.gz) file for reading or writing. The mode parameter
   is as in fopen ("rb" or "wb"). The file is given either by file descriptor
   or path name (if fd == -1).
     gz_open returns NULL if the file could not be opened or if there was
   insufficient memory to allocate the (de)compression state; errno
   can be checked to distinguish the two cases (if errno is zero, the
   zlib error is Z_MEM_ERROR).
*/
local gzFile gz_open (path, mode, fd)
    const char *path;
    const char *mode;
    int  fd;
{
    int err;
    int level = Z_DEFAULT_COMPRESSION; /* compression level */
    int strategy = Z_DEFAULT_STRATEGY; /* compression strategy */
    char *p = (char*)mode;
    gz_stream *s;
    char fmode[80]; /* copy of mode, without the compression level */
    char *m = fmode;

    if (!path || !mode) return Z_NULL;

    s = (gz_stream *)ALLOC(sizeof(gz_stream));
    if (!s) return Z_NULL;

    s-&gt;stream.zalloc = (alloc_func)0;
    s-&gt;stream.zfree = (free_func)0;
    s-&gt;stream.opaque = (voidpf)0;
    s-&gt;stream.next_in = s-&gt;inbuf = Z_NULL;
    s-&gt;stream.next_out = s-&gt;outbuf = Z_NULL;
    s-&gt;stream.avail_in = s-&gt;stream.avail_out = 0;
    s-&gt;file = NULL;
    s-&gt;z_err = Z_OK;
    s-&gt;z_eof = 0;
    s-&gt;in = 0;
    s-&gt;out = 0;
    s-&gt;back = EOF;
    s-&gt;crc = crc32(0L, Z_NULL, 0);
    s-&gt;msg = NULL;
    s-&gt;transparent = 0;

    s-&gt;path = (char*)ALLOC(strlen(path)+1);
    if (s-&gt;path == NULL) {
        return destroy(s), (gzFile)Z_NULL;
    }
    strcpy(s-&gt;path, path); /* do this early for debugging */

    s-&gt;mode = '\0';
    do {
        if (*p == 'r') s-&gt;mode = 'r';
        if (*p == 'w' || *p == 'a') s-&gt;mode = 'w';
        if (*p &gt;= '0' &amp;&amp; *p &lt;= '9') {
            level = *p - '0';
        } else if (*p == 'f') {
          strategy = Z_FILTERED;
        } else if (*p == 'h') {
          strategy = Z_HUFFMAN_ONLY;
        } else if (*p == 'R') {
          strategy = Z_RLE;
        } else {
            *m++ = *p; /* copy the mode */
        }
    } while (*p++ &amp;&amp; m != fmode + sizeof(fmode));
    if (s-&gt;mode == '\0') return destroy(s), (gzFile)Z_NULL;

    if (s-&gt;mode == 'w') {
#ifdef NO_GZCOMPRESS
        err = Z_STREAM_ERROR;
#else
        err = deflateInit2(&amp;(s-&gt;stream), level,
                           Z_DEFLATED, -MAX_WBITS, DEF_MEM_LEVEL, strategy);
        /* windowBits is passed &lt; 0 to suppress zlib header */

        s-&gt;stream.next_out = s-&gt;outbuf = (Byte*)ALLOC(Z_BUFSIZE);
#endif
        if (err != Z_OK || s-&gt;outbuf == Z_NULL) {
            return destroy(s), (gzFile)Z_NULL;
        }
    } else {
        s-&gt;stream.next_in  = s-&gt;inbuf = (Byte*)ALLOC(Z_BUFSIZE);

        err = inflateInit2(&amp;(s-&gt;stream), -MAX_WBITS);
        /* windowBits is passed &lt; 0 to tell that there is no zlib header.
         * Note that in this case inflate *requires* an extra "dummy" byte
         * after the compressed stream in order to complete decompression and
         * return Z_STREAM_END. Here the gzip CRC32 ensures that 4 bytes are
         * present after the compressed stream.
         */
        if (err != Z_OK || s-&gt;inbuf == Z_NULL) {
            return destroy(s), (gzFile)Z_NULL;
        }
    }
    s-&gt;stream.avail_out = Z_BUFSIZE;

    errno = 0;
    s-&gt;file = fd &lt; 0 ? F_OPEN(path, fmode) : (FILE*)fdopen(fd, fmode);

    if (s-&gt;file == NULL) {
        return destroy(s), (gzFile)Z_NULL;
    }
    if (s-&gt;mode == 'w') {
        /* Write a very simple .gz header:
         */
        fprintf(s-&gt;file, "%c%c%c%c%c%c%c%c%c%c", gz_magic[0], gz_magic[1],
             Z_DEFLATED, 0 /*flags*/, 0,0,0,0 /*time*/, 0 /*xflags*/, OS_CODE);
        s-&gt;start = 10L;
        /* We use 10L instead of ftell(s-&gt;file) to because ftell causes an
         * fflush on some systems. This version of the library doesn't use
         * start anyway in write mode, so this initialization is not
         * necessary.
         */
    } else {
        check_header(s); /* skip the .gz header */
        s-&gt;start = ftell(s-&gt;file) - s-&gt;stream.avail_in;
    }

    return (gzFile)s;
}

/* ===========================================================================
     Opens a gzip (.gz) file for reading or writing.
*/
gzFile ZEXPORT gzopen (path, mode)
    const char *path;
    const char *mode;
{
    return gz_open (path, mode, -1);
}

/* ===========================================================================
     Associate a gzFile with the file descriptor fd. fd is not dup'ed here
   to mimic the behavio(u)r of fdopen.
*/
gzFile ZEXPORT gzdopen (fd, mode)
    int fd;
    const char *mode;
{
    char name[20];

    if (fd &lt; 0) return (gzFile)Z_NULL;
    sprintf(name, "&lt;fd:%d&gt;", fd); /* for debugging */

    return gz_open (name, mode, fd);
}

/* ===========================================================================
 * Update the compression level and strategy
 */
int ZEXPORT gzsetparams (file, level, strategy)
    gzFile file;
    int level;
    int strategy;
{
    gz_stream *s = (gz_stream*)file;

    if (s == NULL || s-&gt;mode != 'w') return Z_STREAM_ERROR;

    /* Make room to allow flushing */
    if (s-&gt;stream.avail_out == 0) {

        s-&gt;stream.next_out = s-&gt;outbuf;
        if (fwrite(s-&gt;outbuf, 1, Z_BUFSIZE, s-&gt;file) != Z_BUFSIZE) {
            s-&gt;z_err = Z_ERRNO;
        }
        s-&gt;stream.avail_out = Z_BUFSIZE;
    }

    return deflateParams (&amp;(s-&gt;stream), level, strategy);
}

/* ===========================================================================
     Read a byte from a gz_stream; update next_in and avail_in. Return EOF
   for end of file.
   IN assertion: the stream s has been sucessfully opened for reading.
*/
local int get_byte(s)
    gz_stream *s;
{
    if (s-&gt;z_eof) return EOF;
    if (s-&gt;stream.avail_in == 0) {
        errno = 0;
        s-&gt;stream.avail_in = fread(s-&gt;inbuf, 1, Z_BUFSIZE, s-&gt;file);
        if (s-&gt;stream.avail_in == 0) {
            s-&gt;z_eof = 1;
            if (ferror(s-&gt;file)) s-&gt;z_err = Z_ERRNO;
            return EOF;
        }
        s-&gt;stream.next_in = s-&gt;inbuf;
    }
    s-&gt;stream.avail_in--;
    return *(s-&gt;stream.next_in)++;
}

/* ===========================================================================
      Check the gzip header of a gz_stream opened for reading. Set the stream
    mode to transparent if the gzip magic header is not present; set s-&gt;err
    to Z_DATA_ERROR if the magic header is present but the rest of the header
    is incorrect.
    IN assertion: the stream s has already been created sucessfully;
       s-&gt;stream.avail_in is zero for the first time, but may be non-zero
       for concatenated .gz files.
*/
local void check_header(s)
    gz_stream *s;
{
    int method; /* method byte */
    int flags;  /* flags byte */
    uInt len;
    int c;

    /* Assure two bytes in the buffer so we can peek ahead -- handle case
       where first byte of header is at the end of the buffer after the last
       gzip segment */
    len = s-&gt;stream.avail_in;
    if (len &lt; 2) {
        if (len) s-&gt;inbuf[0] = s-&gt;stream.next_in[0];
        errno = 0;
        len = fread(s-&gt;inbuf + len, 1, Z_BUFSIZE &gt;&gt; len, s-&gt;file);
        if (len == 0 &amp;&amp; ferror(s-&gt;file)) s-&gt;z_err = Z_ERRNO;
        s-&gt;stream.avail_in += len;
        s-&gt;stream.next_in = s-&gt;inbuf;
        if (s-&gt;stream.avail_in &lt; 2) {
            s-&gt;transparent = s-&gt;stream.avail_in;
            return;
        }
    }

    /* Peek ahead to check the gzip magic header */
    if (s-&gt;stream.next_in[0] != gz_magic[0] ||
        s-&gt;stream.next_in[1] != gz_magic[1]) {
        s-&gt;transparent = 1;
        return;
    }
    s-&gt;stream.avail_in -= 2;
    s-&gt;stream.next_in += 2;

    /* Check the rest of the gzip header */
    method = get_byte(s);
    flags = get_byte(s);
    if (method != Z_DEFLATED || (flags &amp; RESERVED) != 0) {
        s-&gt;z_err = Z_DATA_ERROR;
        return;
    }

    /* Discard time, xflags and OS code: */
    for (len = 0; len &lt; 6; len++) (void)get_byte(s);

    if ((flags &amp; EXTRA_FIELD) != 0) { /* skip the extra field */
        len  =  (uInt)get_byte(s);
        len += ((uInt)get_byte(s))&lt;&lt;8;
        /* len is garbage if EOF but the loop below will quit anyway */
        while (len-- != 0 &amp;&amp; get_byte(s) != EOF) ;
    }
    if ((flags &amp; ORIG_NAME) != 0) { /* skip the original file name */
        while ((c = get_byte(s)) != 0 &amp;&amp; c != EOF) ;
    }
    if ((flags &amp; COMMENT) != 0) {   /* skip the .gz file comment */
        while ((c = get_byte(s)) != 0 &amp;&amp; c != EOF) ;
    }
    if ((flags &amp; HEAD_CRC) != 0) {  /* skip the header crc */
        for (len = 0; len &lt; 2; len++) (void)get_byte(s);
    }
    s-&gt;z_err = s-&gt;z_eof ? Z_DATA_ERROR : Z_OK;
}

 /* ===========================================================================
 * Cleanup then free the given gz_stream. Return a zlib error code.
   Try freeing in the reverse order of allocations.
 */
local int destroy (s)
    gz_stream *s;
{
    int err = Z_OK;

    if (!s) return Z_STREAM_ERROR;

    TRYFREE(s-&gt;msg);

    if (s-&gt;stream.state != NULL) {
        if (s-&gt;mode == 'w') {
#ifdef NO_GZCOMPRESS
            err = Z_STREAM_ERROR;
#else
            err = deflateEnd(&amp;(s-&gt;stream));
#endif
        } else if (s-&gt;mode == 'r') {
            err = inflateEnd(&amp;(s-&gt;stream));
        }
    }
    if (s-&gt;file != NULL &amp;&amp; fclose(s-&gt;file)) {
#ifdef ESPIPE
        if (errno != ESPIPE) /* fclose is broken for pipes in HP/UX */
#endif
            err = Z_ERRNO;
    }
    if (s-&gt;z_err &lt; 0) err = s-&gt;z_err;

    TRYFREE(s-&gt;inbuf);
    TRYFREE(s-&gt;outbuf);
    TRYFREE(s-&gt;path);
    TRYFREE(s);
    return err;
}

/* ===========================================================================
     Reads the given number of uncompressed bytes from the compressed file.
   gzread returns the number of bytes actually read (0 for end of file).
*/
int ZEXPORT gzread (file, buf, len)
    gzFile file;
    voidp buf;
    unsigned len;
{
    gz_stream *s = (gz_stream*)file;
    Bytef *start = (Bytef*)buf; /* starting point for crc computation */
    Byte  *next_out; /* == stream.next_out but not forced far (for MSDOS) */

    if (s == NULL || s-&gt;mode != 'r') return Z_STREAM_ERROR;

    if (s-&gt;z_err == Z_DATA_ERROR || s-&gt;z_err == Z_ERRNO) return -1;
    if (s-&gt;z_err == Z_STREAM_END) return 0;  /* EOF */

    next_out = (Byte*)buf;
    s-&gt;stream.next_out = (Bytef*)buf;
    s-&gt;stream.avail_out = len;

    if (s-&gt;stream.avail_out &amp;&amp; s-&gt;back != EOF) {
        *next_out++ = s-&gt;back;
        s-&gt;stream.next_out++;
        s-&gt;stream.avail_out--;
        s-&gt;back = EOF;
        s-&gt;out++;
        if (s-&gt;last) {
            s-&gt;z_err = Z_STREAM_END;
            return 1;
        }
    }

    while (s-&gt;stream.avail_out != 0) {

        if (s-&gt;transparent) {
            /* Copy first the lookahead bytes: */
            uInt n = s-&gt;stream.avail_in;
            if (n &gt; s-&gt;stream.avail_out) n = s-&gt;stream.avail_out;
            if (n &gt; 0) {
                zmemcpy(s-&gt;stream.next_out, s-&gt;stream.next_in, n);
                next_out += n;
                s-&gt;stream.next_out = next_out;
                s-&gt;stream.next_in   += n;
                s-&gt;stream.avail_out -= n;
                s-&gt;stream.avail_in  -= n;
            }
            if (s-&gt;stream.avail_out &gt; 0) {
                s-&gt;stream.avail_out -= fread(next_out, 1, s-&gt;stream.avail_out,
                                             s-&gt;file);
            }
            len -= s-&gt;stream.avail_out;
            s-&gt;in  += len;
            s-&gt;out += len;
            if (len == 0) s-&gt;z_eof = 1;
            return (int)len;
        }
        if (s-&gt;stream.avail_in == 0 &amp;&amp; !s-&gt;z_eof) {

            errno = 0;
            s-&gt;stream.avail_in = fread(s-&gt;inbuf, 1, Z_BUFSIZE, s-&gt;file);
            if (s-&gt;stream.avail_in == 0) {
                s-&gt;z_eof = 1;
                if (ferror(s-&gt;file)) {
                    s-&gt;z_err = Z_ERRNO;
                    break;
                }
                if (feof(s-&gt;file)) {        /* avoid error for empty file */
                    s-&gt;z_err = Z_STREAM_END;
                    break;
                }
            }
            s-&gt;stream.next_in = s-&gt;inbuf;
        }
        s-&gt;in += s-&gt;stream.avail_in;
        s-&gt;out += s-&gt;stream.avail_out;
        s-&gt;z_err = inflate(&amp;(s-&gt;stream), Z_NO_FLUSH);
        s-&gt;in -= s-&gt;stream.avail_in;
        s-&gt;out -= s-&gt;stream.avail_out;

        if (s-&gt;z_err == Z_STREAM_END) {
            /* Check CRC and original size */
            s-&gt;crc = crc32(s-&gt;crc, start, (uInt)(s-&gt;stream.next_out - start));
            start = s-&gt;stream.next_out;

            if (getLong(s) != s-&gt;crc) {
                s-&gt;z_err = Z_DATA_ERROR;
            } else {
                (void)getLong(s);
                /* The uncompressed length returned by above getlong() may be
                 * different from s-&gt;out in case of concatenated .gz files.
                 * Check for such files:
                 */
                check_header(s);
                if (s-&gt;z_err == Z_OK) {
                    inflateReset(&amp;(s-&gt;stream));
                    s-&gt;crc = crc32(0L, Z_NULL, 0);
                }
            }
        }
        if (s-&gt;z_err != Z_OK || s-&gt;z_eof) break;
    }
    s-&gt;crc = crc32(s-&gt;crc, start, (uInt)(s-&gt;stream.next_out - start));

    return (int)(len - s-&gt;stream.avail_out);
}


/* ===========================================================================
      Reads one byte from the compressed file. gzgetc returns this byte
   or -1 in case of end of file or error.
*/
int ZEXPORT gzgetc(file)
    gzFile file;
{
    unsigned char c;

    return gzread(file, &amp;c, 1) == 1 ? c : -1;
}


/* ===========================================================================
      Push one byte back onto the stream.
*/
int ZEXPORT gzungetc(c, file)
    int c;
    gzFile file;
{
    gz_stream *s = (gz_stream*)file;

    if (s == NULL || s-&gt;mode != 'r' || c == EOF || s-&gt;back != EOF) return EOF;
    s-&gt;back = c;
    s-&gt;out--;
    s-&gt;last = (s-&gt;z_err == Z_STREAM_END);
    if (s-&gt;last) s-&gt;z_err = Z_OK;
    s-&gt;z_eof = 0;
    return c;
}


/* ===========================================================================
      Reads bytes from the compressed file until len-1 characters are
   read, or a newline character is read and transferred to buf, or an
   end-of-file condition is encountered.  The string is then terminated
   with a null character.
      gzgets returns buf, or Z_NULL in case of error.

      The current implementation is not optimized at all.
*/
char * ZEXPORT gzgets(file, buf, len)
    gzFile file;
    char *buf;
    int len;
{
    char *b = buf;
    if (buf == Z_NULL || len &lt;= 0) return Z_NULL;

    while (--len &gt; 0 &amp;&amp; gzread(file, buf, 1) == 1 &amp;&amp; *buf++ != '\n') ;
    *buf = '\0';
    return b == buf &amp;&amp; len &gt; 0 ? Z_NULL : b;
}


#ifndef NO_GZCOMPRESS
/* ===========================================================================
     Writes the given number of uncompressed bytes into the compressed file.
   gzwrite returns the number of bytes actually written (0 in case of error).
*/
int ZEXPORT gzwrite (file, buf, len)
    gzFile file;
    voidpc buf;
    unsigned len;
{
    gz_stream *s = (gz_stream*)file;

    if (s == NULL || s-&gt;mode != 'w') return Z_STREAM_ERROR;

    s-&gt;stream.next_in = (Bytef*)buf;
    s-&gt;stream.avail_in = len;

    while (s-&gt;stream.avail_in != 0) {

        if (s-&gt;stream.avail_out == 0) {

            s-&gt;stream.next_out = s-&gt;outbuf;
            if (fwrite(s-&gt;outbuf, 1, Z_BUFSIZE, s-&gt;file) != Z_BUFSIZE) {
                s-&gt;z_err = Z_ERRNO;
                break;
            }
            s-&gt;stream.avail_out = Z_BUFSIZE;
        }
        s-&gt;in += s-&gt;stream.avail_in;
        s-&gt;out += s-&gt;stream.avail_out;
        s-&gt;z_err = deflate(&amp;(s-&gt;stream), Z_NO_FLUSH);
        s-&gt;in -= s-&gt;stream.avail_in;
        s-&gt;out -= s-&gt;stream.avail_out;
        if (s-&gt;z_err != Z_OK) break;
    }
    s-&gt;crc = crc32(s-&gt;crc, (const Bytef *)buf, len);

    return (int)(len - s-&gt;stream.avail_in);
}


/* ===========================================================================
     Converts, formats, and writes the args to the compressed file under
   control of the format string, as in fprintf. gzprintf returns the number of
   uncompressed bytes actually written (0 in case of error).
*/
#ifdef STDC
#include &lt;stdarg.h&gt;

int ZEXPORTVA gzprintf (gzFile file, const char *format, /* args */ ...)
{
    char buf[Z_PRINTF_BUFSIZE];
    va_list va;
    int len;

    buf[sizeof(buf) - 1] = 0;
    va_start(va, format);
#ifdef NO_vsnprintf
#  ifdef HAS_vsprintf_void
    (void)vsprintf(buf, format, va);
    va_end(va);
    for (len = 0; len &lt; sizeof(buf); len++)
        if (buf[len] == 0) break;
#  else
    len = vsprintf(buf, format, va);
    va_end(va);
#  endif
#else
#  ifdef HAS_vsnprintf_void
    (void)vsnprintf(buf, sizeof(buf), format, va);
    va_end(va);
    len = strlen(buf);
#  else
    len = vsnprintf(buf, sizeof(buf), format, va);
    va_end(va);
#  endif
#endif
    if (len &lt;= 0 || len &gt;= (int)sizeof(buf) || buf[sizeof(buf) - 1] != 0)
        return 0;
    return gzwrite(file, buf, (unsigned)len);
}
#else /* not ANSI C */

int ZEXPORTVA gzprintf (file, format, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10,
                       a11, a12, a13, a14, a15, a16, a17, a18, a19, a20)
    gzFile file;
    const char *format;
    int a1, a2, a3, a4, a5, a6, a7, a8, a9, a10,
        a11, a12, a13, a14, a15, a16, a17, a18, a19, a20;
{
    char buf[Z_PRINTF_BUFSIZE];
    int len;

    buf[sizeof(buf) - 1] = 0;
#ifdef NO_snprintf
#  ifdef HAS_sprintf_void
    sprintf(buf, format, a1, a2, a3, a4, a5, a6, a7, a8,
            a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
    for (len = 0; len &lt; sizeof(buf); len++)
        if (buf[len] == 0) break;
#  else
    len = sprintf(buf, format, a1, a2, a3, a4, a5, a6, a7, a8,
                a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
#  endif
#else
#  ifdef HAS_snprintf_void
    snprintf(buf, sizeof(buf), format, a1, a2, a3, a4, a5, a6, a7, a8,
             a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
    len = strlen(buf);
#  else
    len = snprintf(buf, sizeof(buf), format, a1, a2, a3, a4, a5, a6, a7, a8,
                 a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
#  endif
#endif
    if (len &lt;= 0 || len &gt;= sizeof(buf) || buf[sizeof(buf) - 1] != 0)
        return 0;
    return gzwrite(file, buf, len);
}
#endif

/* ===========================================================================
      Writes c, converted to an unsigned char, into the compressed file.
   gzputc returns the value that was written, or -1 in case of error.
*/
int ZEXPORT gzputc(file, c)
    gzFile file;
    int c;
{
    unsigned char cc = (unsigned char) c; /* required for big endian systems */

    return gzwrite(file, &amp;cc, 1) == 1 ? (int)cc : -1;
}


/* ===========================================================================
      Writes the given null-terminated string to the compressed file, excluding
   the terminating null character.
      gzputs returns the number of characters written, or -1 in case of error.
*/
int ZEXPORT gzputs(file, s)
    gzFile file;
    const char *s;
{
    return gzwrite(file, (char*)s, (unsigned)strlen(s));
}


/* ===========================================================================
     Flushes all pending output into the compressed file. The parameter
   flush is as in the deflate() function.
*/
local int do_flush (file, flush)
    gzFile file;
    int flush;
{
    uInt len;
    int done = 0;
    gz_stream *s = (gz_stream*)file;

    if (s == NULL || s-&gt;mode != 'w') return Z_STREAM_ERROR;

    s-&gt;stream.avail_in = 0; /* should be zero already anyway */

    for (;;) {
        len = Z_BUFSIZE - s-&gt;stream.avail_out;

        if (len != 0) {
            if ((uInt)fwrite(s-&gt;outbuf, 1, len, s-&gt;file) != len) {
                s-&gt;z_err = Z_ERRNO;
                return Z_ERRNO;
            }
            s-&gt;stream.next_out = s-&gt;outbuf;
            s-&gt;stream.avail_out = Z_BUFSIZE;
        }
        if (done) break;
        s-&gt;out += s-&gt;stream.avail_out;
        s-&gt;z_err = deflate(&amp;(s-&gt;stream), flush);
        s-&gt;out -= s-&gt;stream.avail_out;

        /* Ignore the second of two consecutive flushes: */
        if (len == 0 &amp;&amp; s-&gt;z_err == Z_BUF_ERROR) s-&gt;z_err = Z_OK;

        /* deflate has finished flushing only when it hasn't used up
         * all the available space in the output buffer:
         */
        done = (s-&gt;stream.avail_out != 0 || s-&gt;z_err == Z_STREAM_END);

        if (s-&gt;z_err != Z_OK &amp;&amp; s-&gt;z_err != Z_STREAM_END) break;
    }
    return  s-&gt;z_err == Z_STREAM_END ? Z_OK : s-&gt;z_err;
}

int ZEXPORT gzflush (file, flush)
     gzFile file;
     int flush;
{
    gz_stream *s = (gz_stream*)file;
    int err = do_flush (file, flush);

    if (err) return err;
    fflush(s-&gt;file);
    return  s-&gt;z_err == Z_STREAM_END ? Z_OK : s-&gt;z_err;
}
#endif /* NO_GZCOMPRESS */

/* ===========================================================================
      Sets the starting position for the next gzread or gzwrite on the given
   compressed file. The offset represents a number of bytes in the
      gzseek returns the resulting offset location as measured in bytes from
   the beginning of the uncompressed stream, or -1 in case of error.
      SEEK_END is not implemented, returns error.
      In this version of the library, gzseek can be extremely slow.
*/
z_off_t ZEXPORT gzseek (file, offset, whence)
    gzFile file;
    z_off_t offset;
    int whence;
{
    gz_stream *s = (gz_stream*)file;

    if (s == NULL || whence == SEEK_END ||
        s-&gt;z_err == Z_ERRNO || s-&gt;z_err == Z_DATA_ERROR) {
        return -1L;
    }

    if (s-&gt;mode == 'w') {
#ifdef NO_GZCOMPRESS
        return -1L;
#else
        if (whence == SEEK_SET) {
            offset -= s-&gt;in;
        }
        if (offset &lt; 0) return -1L;

        /* At this point, offset is the number of zero bytes to write. */
        if (s-&gt;inbuf == Z_NULL) {
            s-&gt;inbuf = (Byte*)ALLOC(Z_BUFSIZE); /* for seeking */
            if (s-&gt;inbuf == Z_NULL) return -1L;
            zmemzero(s-&gt;inbuf, Z_BUFSIZE);
        }
        while (offset &gt; 0)  {
            uInt size = Z_BUFSIZE;
            if (offset &lt; Z_BUFSIZE) size = (uInt)offset;

            size = gzwrite(file, s-&gt;inbuf, size);
            if (size == 0) return -1L;

            offset -= size;
        }
        return s-&gt;in;
#endif
    }
    /* Rest of function is for reading only */

    /* compute absolute position */
    if (whence == SEEK_CUR) {
        offset += s-&gt;out;
    }
    if (offset &lt; 0) return -1L;

    if (s-&gt;transparent) {
        /* map to fseek */
        s-&gt;back = EOF;
        s-&gt;stream.avail_in = 0;
        s-&gt;stream.next_in = s-&gt;inbuf;
        if (fseek(s-&gt;file, offset, SEEK_SET) &lt; 0) return -1L;

        s-&gt;in = s-&gt;out = offset;
        return offset;
    }

    /* For a negative seek, rewind and use positive seek */
    if (offset &gt;= s-&gt;out) {
        offset -= s-&gt;out;
    } else if (gzrewind(file) &lt; 0) {
        return -1L;
    }
    /* offset is now the number of bytes to skip. */

    if (offset != 0 &amp;&amp; s-&gt;outbuf == Z_NULL) {
        s-&gt;outbuf = (Byte*)ALLOC(Z_BUFSIZE);
        if (s-&gt;outbuf == Z_NULL) return -1L;
    }
    if (offset &amp;&amp; s-&gt;back != EOF) {
        s-&gt;back = EOF;
        s-&gt;out++;
        offset--;
        if (s-&gt;last) s-&gt;z_err = Z_STREAM_END;
    }
    while (offset &gt; 0)  {
        int size = Z_BUFSIZE;
        if (offset &lt; Z_BUFSIZE) size = (int)offset;

        size = gzread(file, s-&gt;outbuf, (uInt)size);
        if (size &lt;= 0) return -1L;
        offset -= size;
    }
    return s-&gt;out;
}

/* ===========================================================================
     Rewinds input file.
*/
int ZEXPORT gzrewind (file)
    gzFile file;
{
    gz_stream *s = (gz_stream*)file;

    if (s == NULL || s-&gt;mode != 'r') return -1;

    s-&gt;z_err = Z_OK;
    s-&gt;z_eof = 0;
    s-&gt;back = EOF;
    s-&gt;stream.avail_in = 0;
    s-&gt;stream.next_in = s-&gt;inbuf;
    s-&gt;crc = crc32(0L, Z_NULL, 0);
    if (!s-&gt;transparent) (void)inflateReset(&amp;s-&gt;stream);
    s-&gt;in = 0;
    s-&gt;out = 0;
    return fseek(s-&gt;file, s-&gt;start, SEEK_SET);
}

/* ===========================================================================
     Returns the starting position for the next gzread or gzwrite on the
   given compressed file. This position represents a number of bytes in the
   uncompressed data stream.
*/
z_off_t ZEXPORT gztell (file)
    gzFile file;
{
    return gzseek(file, 0L, SEEK_CUR);
}

/* ===========================================================================
     Returns 1 when EOF has previously been detected reading the given
   input stream, otherwise zero.
*/
int ZEXPORT gzeof (file)
    gzFile file;
{
    gz_stream *s = (gz_stream*)file;

    /* With concatenated compressed files that can have embedded
     * crc trailers, z_eof is no longer the only/best indicator of EOF
     * on a gz_stream. Handle end-of-stream error explicitly here.
     */
    if (s == NULL || s-&gt;mode != 'r') return 0;
    if (s-&gt;z_eof) return 1;
    return s-&gt;z_err == Z_STREAM_END;
}

/* ===========================================================================
   Outputs a long in LSB order to the given file
*/
local void putLong (file, x)
    FILE *file;
    uLong x;
{
    int n;
    for (n = 0; n &lt; 4; n++) {
        fputc((int)(x &amp; 0xff), file);
        x &gt;&gt;= 8;
    }
}

/* ===========================================================================
   Reads a long in LSB order from the given gz_stream. Sets z_err in case
   of error.
*/
local uLong getLong (s)
    gz_stream *s;
{
    uLong x = (uLong)get_byte(s);
    int c;

    x += ((uLong)get_byte(s))&lt;&lt;8;
    x += ((uLong)get_byte(s))&lt;&lt;16;
    c = get_byte(s);
    if (c == EOF) s-&gt;z_err = Z_DATA_ERROR;
    x += ((uLong)c)&lt;&lt;24;
    return x;
}

/* ===========================================================================
     Flushes all pending output if necessary, closes the compressed file
   and deallocates all the (de)compression state.
*/
int ZEXPORT gzclose (file)
    gzFile file;
{
    int err;
    gz_stream *s = (gz_stream*)file;

    if (s == NULL) return Z_STREAM_ERROR;

    if (s-&gt;mode == 'w') {
#ifdef NO_GZCOMPRESS
        return Z_STREAM_ERROR;
#else
        err = do_flush (file, Z_FINISH);
        if (err != Z_OK) return destroy((gz_stream*)file);

        putLong (s-&gt;file, s-&gt;crc);
        putLong (s-&gt;file, (uLong)(s-&gt;in &amp; 0xffffffff));
#endif
    }
    return destroy((gz_stream*)file);
}

/* ===========================================================================
     Returns the error message for the last error which occured on the
   given compressed file. errnum is set to zlib error number. If an
   error occured in the file system and not in the compression library,
   errnum is set to Z_ERRNO and the application may consult errno
   to get the exact error code.
*/
const char * ZEXPORT gzerror (file, errnum)
    gzFile file;
    int *errnum;
{
    char *m;
    gz_stream *s = (gz_stream*)file;

    if (s == NULL) {
        *errnum = Z_STREAM_ERROR;
        return (const char*)ERR_MSG(Z_STREAM_ERROR);
    }
    *errnum = s-&gt;z_err;
    if (*errnum == Z_OK) return (const char*)"";

    m = (char*)(*errnum == Z_ERRNO ? zstrerror(errno) : s-&gt;stream.msg);

    if (m == NULL || *m == '\0') m = (char*)ERR_MSG(s-&gt;z_err);

    TRYFREE(s-&gt;msg);
    s-&gt;msg = (char*)ALLOC(strlen(s-&gt;path) + strlen(m) + 3);
    if (s-&gt;msg == Z_NULL) return (const char*)ERR_MSG(Z_MEM_ERROR);
    strcpy(s-&gt;msg, s-&gt;path);
    strcat(s-&gt;msg, ": ");
    strcat(s-&gt;msg, m);
    return (const char*)s-&gt;msg;
}

/* ===========================================================================
     Clear the error and end-of-file flags, and do the same for the real file.
*/
void ZEXPORT gzclearerr (file)
    gzFile file;
{
    gz_stream *s = (gz_stream*)file;

    if (s == NULL) return;
    if (s-&gt;z_err != Z_STREAM_END) s-&gt;z_err = Z_OK;
    s-&gt;z_eof = 0;
    clearerr(s-&gt;file);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

