<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/zlib/inflate.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/zlib/inflate.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* inflate.c -- zlib decompression
 * Copyright (C) 1995-2003 Mark Adler
 * For conditions of distribution and use, see copyright notice in zlib.h
 */

/*
 * Change history:
 *
 * 1.2.beta0    24 Nov 2002
 * - First version -- complete rewrite of inflate to simplify code, avoid
 *   creation of window when not needed, minimize use of window when it is
 *   needed, make inffast.c even faster, implement gzip decoding, and to
 *   improve code readability and style over the previous zlib inflate code
 *
 * 1.2.beta1    25 Nov 2002
 * - Use pointers for available input and output checking in inffast.c
 * - Remove input and output counters in inffast.c
 * - Change inffast.c entry and loop from avail_in &gt;= 7 to &gt;= 6
 * - Remove unnecessary second byte pull from length extra in inffast.c
 * - Unroll direct copy to three copies per loop in inffast.c
 *
 * 1.2.beta2    4 Dec 2002
 * - Change external routine names to reduce potential conflicts
 * - Correct filename to inffixed.h for fixed tables in inflate.c
 * - Make hbuf[] unsigned char to match parameter type in inflate.c
 * - Change strm-&gt;next_out[-state-&gt;offset] to *(strm-&gt;next_out - state-&gt;offset)
 *   to avoid negation problem on Alphas (64 bit) in inflate.c
 *
 * 1.2.beta3    22 Dec 2002
 * - Add comments on state-&gt;bits assertion in inffast.c
 * - Add comments on op field in inftrees.h
 * - Fix bug in reuse of allocated window after inflateReset()
 * - Remove bit fields--back to byte structure for speed
 * - Remove distance extra == 0 check in inflate_fast()--only helps for lengths
 * - Change post-increments to pre-increments in inflate_fast(), PPC biased?
 * - Add compile time option, POSTINC, to use post-increments instead (Intel?)
 * - Make MATCH copy in inflate() much faster for when inflate_fast() not used
 * - Use local copies of stream next and avail values, as well as local bit
 *   buffer and bit count in inflate()--for speed when inflate_fast() not used
 *
 * 1.2.beta4    1 Jan 2003
 * - Split ptr - 257 statements in inflate_table() to avoid compiler warnings
 * - Move a comment on output buffer sizes from inffast.c to inflate.c
 * - Add comments in inffast.c to introduce the inflate_fast() routine
 * - Rearrange window copies in inflate_fast() for speed and simplification
 * - Unroll last copy for window match in inflate_fast()
 * - Use local copies of window variables in inflate_fast() for speed
 * - Pull out common write == 0 case for speed in inflate_fast()
 * - Make op and len in inflate_fast() unsigned for consistency
 * - Add FAR to lcode and dcode declarations in inflate_fast()
 * - Simplified bad distance check in inflate_fast()
 * - Added inflateBackInit(), inflateBack(), and inflateBackEnd() in new
 *   source file infback.c to provide a call-back interface to inflate for
 *   programs like gzip and unzip -- uses window as output buffer to avoid
 *   window copying
 *
 * 1.2.beta5    1 Jan 2003
 * - Improved inflateBack() interface to allow the caller to provide initial
 *   input in strm.
 * - Fixed stored blocks bug in inflateBack()
 *
 * 1.2.beta6    4 Jan 2003
 * - Added comments in inffast.c on effectiveness of POSTINC
 * - Typecasting all around to reduce compiler warnings
 * - Changed loops from while (1) or do {} while (1) to for (;;), again to
 *   make compilers happy
 * - Changed type of window in inflateBackInit() to unsigned char *
 *
 * 1.2.beta7    27 Jan 2003
 * - Changed many types to unsigned or unsigned short to avoid warnings
 * - Added inflateCopy() function
 *
 * 1.2.0        9 Mar 2003
 * - Changed inflateBack() interface to provide separate opaque descriptors
 *   for the in() and out() functions
 * - Changed inflateBack() argument and in_func typedef to swap the length
 *   and buffer address return values for the input function
 * - Check next_in and next_out for Z_NULL on entry to inflate()
 *
 * The history for versions after 1.2.0 are in ChangeLog in zlib distribution.
 */

#include "zutil.h"
#include "inftrees.h"
#include "inflate.h"
#include "inffast.h"

#ifdef MAKEFIXED
#  ifndef BUILDFIXED
#    define BUILDFIXED
#  endif
#endif

/* function prototypes */
local void fixedtables OF((struct inflate_state FAR *state));
local int updatewindow OF((z_streamp strm, unsigned out));
#ifdef BUILDFIXED
   void makefixed OF((void));
#endif
local unsigned syncsearch OF((unsigned FAR *have, unsigned char FAR *buf,
                              unsigned len));

int ZEXPORT inflateReset(strm)
z_streamp strm;
{
    struct inflate_state FAR *state;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;
    state = (struct inflate_state FAR *)strm-&gt;state;
    strm-&gt;total_in = strm-&gt;total_out = state-&gt;total = 0;
    strm-&gt;msg = Z_NULL;
    strm-&gt;adler = 1;        /* to support ill-conceived Java test suite */
    state-&gt;mode = HEAD;
    state-&gt;last = 0;
    state-&gt;havedict = 0;
    state-&gt;wsize = 0;
    state-&gt;whave = 0;
    state-&gt;hold = 0;
    state-&gt;bits = 0;
    state-&gt;lencode = state-&gt;distcode = state-&gt;next = state-&gt;codes;
    Tracev((stderr, "inflate: reset\n"));
    return Z_OK;
}

int ZEXPORT inflateInit2_(strm, windowBits, version, stream_size)
z_streamp strm;
int windowBits;
const char *version;
int stream_size;
{
    struct inflate_state FAR *state;

    if (version == Z_NULL || version[0] != ZLIB_VERSION[0] ||
        stream_size != (int)(sizeof(z_stream)))
        return Z_VERSION_ERROR;
    if (strm == Z_NULL) return Z_STREAM_ERROR;
    strm-&gt;msg = Z_NULL;                 /* in case we return an error */
    if (strm-&gt;zalloc == (alloc_func)0) {
        strm-&gt;zalloc = zcalloc;
        strm-&gt;opaque = (voidpf)0;
    }
    if (strm-&gt;zfree == (free_func)0) strm-&gt;zfree = zcfree;
    state = (struct inflate_state FAR *)
            ZALLOC(strm, 1, sizeof(struct inflate_state));
    if (state == Z_NULL) return Z_MEM_ERROR;
    Tracev((stderr, "inflate: allocated\n"));
    strm-&gt;state = (voidpf)state;
    if (windowBits &lt; 0) {
        state-&gt;wrap = 0;
        windowBits = -windowBits;
    }
    else {
        state-&gt;wrap = (windowBits &gt;&gt; 4) + 1;
#ifdef GUNZIP
        if (windowBits &lt; 48) windowBits &amp;= 15;
#endif
    }
    if (windowBits &lt; 8 || windowBits &gt; 15) {
        ZFREE(strm, state);
        strm-&gt;state = Z_NULL;
        return Z_STREAM_ERROR;
    }
    state-&gt;wbits = (unsigned)windowBits;
    state-&gt;window = Z_NULL;
    return inflateReset(strm);
}

int ZEXPORT inflateInit_(strm, version, stream_size)
z_streamp strm;
const char *version;
int stream_size;
{
    return inflateInit2_(strm, DEF_WBITS, version, stream_size);
}

/*
   Return state with length and distance decoding tables and index sizes set to
   fixed code decoding.  Normally this returns fixed tables from inffixed.h.
   If BUILDFIXED is defined, then instead this routine builds the tables the
   first time it's called, and returns those tables the first time and
   thereafter.  This reduces the size of the code by about 2K bytes, in
   exchange for a little execution time.  However, BUILDFIXED should not be
   used for threaded applications, since the rewriting of the tables and virgin
   may not be thread-safe.
 */
local void fixedtables(state)
struct inflate_state FAR *state;
{
#ifdef BUILDFIXED
    static int virgin = 1;
    static code *lenfix, *distfix;
    static code fixed[544];

    /* build fixed huffman tables if first call (may not be thread safe) */
    if (virgin) {
        unsigned sym, bits;
        static code *next;

        /* literal/length table */
        sym = 0;
        while (sym &lt; 144) state-&gt;lens[sym++] = 8;
        while (sym &lt; 256) state-&gt;lens[sym++] = 9;
        while (sym &lt; 280) state-&gt;lens[sym++] = 7;
        while (sym &lt; 288) state-&gt;lens[sym++] = 8;
        next = fixed;
        lenfix = next;
        bits = 9;
        inflate_table(LENS, state-&gt;lens, 288, &amp;(next), &amp;(bits), state-&gt;work);

        /* distance table */
        sym = 0;
        while (sym &lt; 32) state-&gt;lens[sym++] = 5;
        distfix = next;
        bits = 5;
        inflate_table(DISTS, state-&gt;lens, 32, &amp;(next), &amp;(bits), state-&gt;work);

        /* do this just once */
        virgin = 0;
    }
#else /* !BUILDFIXED */
#   include "inffixed.h"
#endif /* BUILDFIXED */
    state-&gt;lencode = lenfix;
    state-&gt;lenbits = 9;
    state-&gt;distcode = distfix;
    state-&gt;distbits = 5;
}

#ifdef MAKEFIXED
#include &lt;stdio.h&gt;

/*
   Write out the inffixed.h that is #include'd above.  Defining MAKEFIXED also
   defines BUILDFIXED, so the tables are built on the fly.  makefixed() writes
   those tables to stdout, which would be piped to inffixed.h.  A small program
   can simply call makefixed to do this:

    void makefixed(void);

    int main(void)
    {
        makefixed();
        return 0;
    }

   Then that can be linked with zlib built with MAKEFIXED defined and run:

    a.out &gt; inffixed.h
 */
void makefixed()
{
    unsigned low, size;
    struct inflate_state state;

    fixedtables(&amp;state);
    puts("    /* inffixed.h -- table for decoding fixed codes");
    puts("     * Generated automatically by makefixed().");
    puts("     */");
    puts("");
    puts("    /* WARNING: this file should *not* be used by applications.");
    puts("       It is part of the implementation of this library and is");
    puts("       subject to change. Applications should only use zlib.h.");
    puts("     */");
    puts("");
    size = 1U &lt;&lt; 9;
    printf("    static const code lenfix[%u] = {", size);
    low = 0;
    for (;;) {
        if ((low % 7) == 0) printf("\n        ");
        printf("{%u,%u,%d}", state.lencode[low].op, state.lencode[low].bits,
               state.lencode[low].val);
        if (++low == size) break;
        putchar(',');
    }
    puts("\n    };");
    size = 1U &lt;&lt; 5;
    printf("\n    static const code distfix[%u] = {", size);
    low = 0;
    for (;;) {
        if ((low % 6) == 0) printf("\n        ");
        printf("{%u,%u,%d}", state.distcode[low].op, state.distcode[low].bits,
               state.distcode[low].val);
        if (++low == size) break;
        putchar(',');
    }
    puts("\n    };");
}
#endif /* MAKEFIXED */

/*
   Update the window with the last wsize (normally 32K) bytes written before
   returning.  If window does not exist yet, create it.  This is only called
   when a window is already in use, or when output has been written during this
   inflate call, but the end of the deflate stream has not been reached yet.
   It is also called to create a window for dictionary data when a dictionary
   is loaded.

   Providing output buffers larger than 32K to inflate() should provide a speed
   advantage, since only the last 32K of output is copied to the sliding window
   upon return from inflate(), and since all distances after the first 32K of
   output will fall in the output data, making match copies simpler and faster.
   The advantage may be dependent on the size of the processor's data caches.
 */
local int updatewindow(strm, out)
z_streamp strm;
unsigned out;
{
    struct inflate_state FAR *state;
    unsigned copy, dist;

    state = (struct inflate_state FAR *)strm-&gt;state;

    /* if it hasn't been done already, allocate space for the window */
    if (state-&gt;window == Z_NULL) {
        state-&gt;window = (unsigned char FAR *)
                        ZALLOC(strm, 1U &lt;&lt; state-&gt;wbits,
                               sizeof(unsigned char));
        if (state-&gt;window == Z_NULL) return 1;
    }

    /* if window not in use yet, initialize */
    if (state-&gt;wsize == 0) {
        state-&gt;wsize = 1U &lt;&lt; state-&gt;wbits;
        state-&gt;write = 0;
        state-&gt;whave = 0;
    }

    /* copy state-&gt;wsize or less output bytes into the circular window */
    copy = out - strm-&gt;avail_out;
    if (copy &gt;= state-&gt;wsize) {
        zmemcpy(state-&gt;window, strm-&gt;next_out - state-&gt;wsize, state-&gt;wsize);
        state-&gt;write = 0;
        state-&gt;whave = state-&gt;wsize;
    }
    else {
        dist = state-&gt;wsize - state-&gt;write;
        if (dist &gt; copy) dist = copy;
        zmemcpy(state-&gt;window + state-&gt;write, strm-&gt;next_out - copy, dist);
        copy -= dist;
        if (copy) {
            zmemcpy(state-&gt;window, strm-&gt;next_out - copy, copy);
            state-&gt;write = copy;
            state-&gt;whave = state-&gt;wsize;
        }
        else {
            state-&gt;write += dist;
            if (state-&gt;write == state-&gt;wsize) state-&gt;write = 0;
            if (state-&gt;whave &lt; state-&gt;wsize) state-&gt;whave += dist;
        }
    }
    return 0;
}

/* Macros for inflate(): */

/* check function to use adler32() for zlib or crc32() for gzip */
#ifdef GUNZIP
#  define UPDATE(check, buf, len) \
    (state-&gt;flags ? crc32(check, buf, len) : adler32(check, buf, len))
#else
#  define UPDATE(check, buf, len) adler32(check, buf, len)
#endif

/* check macros for header crc */
#ifdef GUNZIP
#  define CRC2(check, word) \
    do { \
        hbuf[0] = (unsigned char)(word); \
        hbuf[1] = (unsigned char)((word) &gt;&gt; 8); \
        check = crc32(check, hbuf, 2); \
    } while (0)

#  define CRC4(check, word) \
    do { \
        hbuf[0] = (unsigned char)(word); \
        hbuf[1] = (unsigned char)((word) &gt;&gt; 8); \
        hbuf[2] = (unsigned char)((word) &gt;&gt; 16); \
        hbuf[3] = (unsigned char)((word) &gt;&gt; 24); \
        check = crc32(check, hbuf, 4); \
    } while (0)
#endif

/* Load registers with state in inflate() for speed */
#define LOAD() \
    do { \
        put = strm-&gt;next_out; \
        left = strm-&gt;avail_out; \
        next = strm-&gt;next_in; \
        have = strm-&gt;avail_in; \
        hold = state-&gt;hold; \
        bits = state-&gt;bits; \
    } while (0)

/* Restore state from registers in inflate() */
#define RESTORE() \
    do { \
        strm-&gt;next_out = put; \
        strm-&gt;avail_out = left; \
        strm-&gt;next_in = next; \
        strm-&gt;avail_in = have; \
        state-&gt;hold = hold; \
        state-&gt;bits = bits; \
    } while (0)

/* Clear the input bit accumulator */
#define INITBITS() \
    do { \
        hold = 0; \
        bits = 0; \
    } while (0)

/* Get a byte of input into the bit accumulator, or return from inflate()
   if there is no input available. */
#define PULLBYTE() \
    do { \
        if (have == 0) goto inf_leave; \
        have--; \
        hold += (unsigned long)(*next++) &lt;&lt; bits; \
        bits += 8; \
    } while (0)

/* Assure that there are at least n bits in the bit accumulator.  If there is
   not enough available input to do that, then return from inflate(). */
#define NEEDBITS(n) \
    do { \
        while (bits &lt; (unsigned)(n)) \
            PULLBYTE(); \
    } while (0)

/* Return the low n bits of the bit accumulator (n &lt; 16) */
#define BITS(n) \
    ((unsigned)hold &amp; ((1U &lt;&lt; (n)) - 1))

/* Remove n bits from the bit accumulator */
#define DROPBITS(n) \
    do { \
        hold &gt;&gt;= (n); \
        bits -= (unsigned)(n); \
    } while (0)

/* Remove zero to seven bits as needed to go to a byte boundary */
#define BYTEBITS() \
    do { \
        hold &gt;&gt;= bits &amp; 7; \
        bits -= bits &amp; 7; \
    } while (0)

/* Reverse the bytes in a 32-bit value */
#define REVERSE(q) \
    ((((q) &gt;&gt; 24) &amp; 0xff) + (((q) &gt;&gt; 8) &amp; 0xff00) + \
     (((q) &amp; 0xff00) &lt;&lt; 8) + (((q) &amp; 0xff) &lt;&lt; 24))

/*
   inflate() uses a state machine to process as much input data and generate as
   much output data as possible before returning.  The state machine is
   structured roughly as follows:

    for (;;) switch (state) {
    ...
    case STATEn:
        if (not enough input data or output space to make progress)
            return;
        ... make progress ...
        state = STATEm;
        break;
    ...
    }

   so when inflate() is called again, the same case is attempted again, and
   if the appropriate resources are provided, the machine proceeds to the
   next state.  The NEEDBITS() macro is usually the way the state evaluates
   whether it can proceed or should return.  NEEDBITS() does the return if
   the requested bits are not available.  The typical use of the BITS macros
   is:

        NEEDBITS(n);
        ... do something with BITS(n) ...
        DROPBITS(n);

   where NEEDBITS(n) either returns from inflate() if there isn't enough
   input left to load n bits into the accumulator, or it continues.  BITS(n)
   gives the low n bits in the accumulator.  When done, DROPBITS(n) drops
   the low n bits off the accumulator.  INITBITS() clears the accumulator
   and sets the number of available bits to zero.  BYTEBITS() discards just
   enough bits to put the accumulator on a byte boundary.  After BYTEBITS()
   and a NEEDBITS(8), then BITS(8) would return the next byte in the stream.

   NEEDBITS(n) uses PULLBYTE() to get an available byte of input, or to return
   if there is no input available.  The decoding of variable length codes uses
   PULLBYTE() directly in order to pull just enough bytes to decode the next
   code, and no more.

   Some states loop until they get enough input, making sure that enough
   state information is maintained to continue the loop where it left off
   if NEEDBITS() returns in the loop.  For example, want, need, and keep
   would all have to actually be part of the saved state in case NEEDBITS()
   returns:

    case STATEw:
        while (want &lt; need) {
            NEEDBITS(n);
            keep[want++] = BITS(n);
            DROPBITS(n);
        }
        state = STATEx;
    case STATEx:

   As shown above, if the next state is also the next case, then the break
   is omitted.

   A state may also return if there is not enough output space available to
   complete that state.  Those states are copying stored data, writing a
   literal byte, and copying a matching string.

   When returning, a "goto inf_leave" is used to update the total counters,
   update the check value, and determine whether any progress has been made
   during that inflate() call in order to return the proper return code.
   Progress is defined as a change in either strm-&gt;avail_in or strm-&gt;avail_out.
   When there is a window, goto inf_leave will update the window with the last
   output written.  If a goto inf_leave occurs in the middle of decompression
   and there is no window currently, goto inf_leave will create one and copy
   output to the window for the next call of inflate().

   In this implementation, the flush parameter of inflate() only affects the
   return code (per zlib.h).  inflate() always writes as much as possible to
   strm-&gt;next_out, given the space available and the provided input--the effect
   documented in zlib.h of Z_SYNC_FLUSH.  Furthermore, inflate() always defers
   the allocation of and copying into a sliding window until necessary, which
   provides the effect documented in zlib.h for Z_FINISH when the entire input
   stream available.  So the only thing the flush parameter actually does is:
   when flush is set to Z_FINISH, inflate() cannot return Z_OK.  Instead it
   will return Z_BUF_ERROR if it has not reached the end of the stream.
 */

int ZEXPORT inflate(strm, flush)
z_streamp strm;
int flush;
{
    struct inflate_state FAR *state;
    unsigned char FAR *next;    /* next input */
    unsigned char FAR *put;     /* next output */
    unsigned have, left;        /* available input and output */
    unsigned long hold;         /* bit buffer */
    unsigned bits;              /* bits in bit buffer */
    unsigned in, out;           /* save starting available input and output */
    unsigned copy;              /* number of stored or match bytes to copy */
    unsigned char FAR *from;    /* where to copy match bytes from */
    code this;                  /* current decoding table entry */
    code last;                  /* parent table entry */
    unsigned len;               /* length to copy for repeats, bits to drop */
    int ret;                    /* return code */
#ifdef GUNZIP
    unsigned char hbuf[4];      /* buffer for gzip header crc calculation */
#endif
    static const unsigned short order[19] = /* permutation of code lengths */
        {16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15};

    if (strm == Z_NULL || strm-&gt;state == Z_NULL || strm-&gt;next_out == Z_NULL ||
        (strm-&gt;next_in == Z_NULL &amp;&amp; strm-&gt;avail_in != 0))
        return Z_STREAM_ERROR;

    state = (struct inflate_state FAR *)strm-&gt;state;
    if (state-&gt;mode == TYPE) state-&gt;mode = TYPEDO;      /* skip check */
    LOAD();
    in = have;
    out = left;
    ret = Z_OK;
    for (;;)
        switch (state-&gt;mode) {
        case HEAD:
            if (state-&gt;wrap == 0) {
                state-&gt;mode = TYPEDO;
                break;
            }
            NEEDBITS(16);
#ifdef GUNZIP
            if ((state-&gt;wrap &amp; 2) &amp;&amp; hold == 0x8b1f) {  /* gzip header */
                state-&gt;check = crc32(0L, Z_NULL, 0);
                CRC2(state-&gt;check, hold);
                INITBITS();
                state-&gt;mode = FLAGS;
                break;
            }
            state-&gt;flags = 0;           /* expect zlib header */
            if (!(state-&gt;wrap &amp; 1) ||   /* check if zlib header allowed */
#else
            if (
#endif
                ((BITS(8) &lt;&lt; 8) + (hold &gt;&gt; 8)) % 31) {
                strm-&gt;msg = (char *)"incorrect header check";
                state-&gt;mode = BAD;
                break;
            }
            if (BITS(4) != Z_DEFLATED) {
                strm-&gt;msg = (char *)"unknown compression method";
                state-&gt;mode = BAD;
                break;
            }
            DROPBITS(4);
            if (BITS(4) + 8 &gt; state-&gt;wbits) {
                strm-&gt;msg = (char *)"invalid window size";
                state-&gt;mode = BAD;
                break;
            }
            Tracev((stderr, "inflate:   zlib header ok\n"));
            strm-&gt;adler = state-&gt;check = adler32(0L, Z_NULL, 0);
            state-&gt;mode = hold &amp; 0x200 ? DICTID : TYPE;
            INITBITS();
            break;
#ifdef GUNZIP
        case FLAGS:
            NEEDBITS(16);
            state-&gt;flags = (int)(hold);
            if ((state-&gt;flags &amp; 0xff) != Z_DEFLATED) {
                strm-&gt;msg = (char *)"unknown compression method";
                state-&gt;mode = BAD;
                break;
            }
            if (state-&gt;flags &amp; 0xe000) {
                strm-&gt;msg = (char *)"unknown header flags set";
                state-&gt;mode = BAD;
                break;
            }
            if (state-&gt;flags &amp; 0x0200) CRC2(state-&gt;check, hold);
            INITBITS();
            state-&gt;mode = TIME;
        case TIME:
            NEEDBITS(32);
            if (state-&gt;flags &amp; 0x0200) CRC4(state-&gt;check, hold);
            INITBITS();
            state-&gt;mode = OS;
        case OS:
            NEEDBITS(16);
            if (state-&gt;flags &amp; 0x0200) CRC2(state-&gt;check, hold);
            INITBITS();
            state-&gt;mode = EXLEN;
        case EXLEN:
            if (state-&gt;flags &amp; 0x0400) {
                NEEDBITS(16);
                state-&gt;length = (unsigned)(hold);
                if (state-&gt;flags &amp; 0x0200) CRC2(state-&gt;check, hold);
                INITBITS();
            }
            state-&gt;mode = EXTRA;
        case EXTRA:
            if (state-&gt;flags &amp; 0x0400) {
                copy = state-&gt;length;
                if (copy &gt; have) copy = have;
                if (copy) {
                    if (state-&gt;flags &amp; 0x0200)
                        state-&gt;check = crc32(state-&gt;check, next, copy);
                    have -= copy;
                    next += copy;
                    state-&gt;length -= copy;
                }
                if (state-&gt;length) goto inf_leave;
            }
            state-&gt;mode = NAME;
        case NAME:
            if (state-&gt;flags &amp; 0x0800) {
                if (have == 0) goto inf_leave;
                copy = 0;
                do {
                    len = (unsigned)(next[copy++]);
                } while (len &amp;&amp; copy &lt; have);
                if (state-&gt;flags &amp; 0x02000)
                    state-&gt;check = crc32(state-&gt;check, next, copy);
                have -= copy;
                next += copy;
                if (len) goto inf_leave;
            }
            state-&gt;mode = COMMENT;
        case COMMENT:
            if (state-&gt;flags &amp; 0x1000) {
                if (have == 0) goto inf_leave;
                copy = 0;
                do {
                    len = (unsigned)(next[copy++]);
                } while (len &amp;&amp; copy &lt; have);
                if (state-&gt;flags &amp; 0x02000)
                    state-&gt;check = crc32(state-&gt;check, next, copy);
                have -= copy;
                next += copy;
                if (len) goto inf_leave;
            }
            state-&gt;mode = HCRC;
        case HCRC:
            if (state-&gt;flags &amp; 0x0200) {
                NEEDBITS(16);
                if (hold != (state-&gt;check &amp; 0xffff)) {
                    strm-&gt;msg = (char *)"header crc mismatch";
                    state-&gt;mode = BAD;
                    break;
                }
                INITBITS();
            }
            strm-&gt;adler = state-&gt;check = crc32(0L, Z_NULL, 0);
            state-&gt;mode = TYPE;
            break;
#endif
        case DICTID:
            NEEDBITS(32);
            strm-&gt;adler = state-&gt;check = REVERSE(hold);
            INITBITS();
            state-&gt;mode = DICT;
        case DICT:
            if (state-&gt;havedict == 0) {
                RESTORE();
                return Z_NEED_DICT;
            }
            strm-&gt;adler = state-&gt;check = adler32(0L, Z_NULL, 0);
            state-&gt;mode = TYPE;
        case TYPE:
            if (flush == Z_BLOCK) goto inf_leave;
        case TYPEDO:
            if (state-&gt;last) {
                BYTEBITS();
                state-&gt;mode = CHECK;
                break;
            }
            NEEDBITS(3);
            state-&gt;last = BITS(1);
            DROPBITS(1);
            switch (BITS(2)) {
            case 0:                             /* stored block */
                Tracev((stderr, "inflate:     stored block%s\n",
                        state-&gt;last ? " (last)" : ""));
                state-&gt;mode = STORED;
                break;
            case 1:                             /* fixed block */
                fixedtables(state);
                Tracev((stderr, "inflate:     fixed codes block%s\n",
                        state-&gt;last ? " (last)" : ""));
                state-&gt;mode = LEN;              /* decode codes */
                break;
            case 2:                             /* dynamic block */
                Tracev((stderr, "inflate:     dynamic codes block%s\n",
                        state-&gt;last ? " (last)" : ""));
                state-&gt;mode = TABLE;
                break;
            case 3:
                strm-&gt;msg = (char *)"invalid block type";
                state-&gt;mode = BAD;
            }
            DROPBITS(2);
            break;
        case STORED:
            BYTEBITS();                         /* go to byte boundary */
            NEEDBITS(32);
            if ((hold &amp; 0xffff) != ((hold &gt;&gt; 16) ^ 0xffff)) {
                strm-&gt;msg = (char *)"invalid stored block lengths";
                state-&gt;mode = BAD;
                break;
            }
            state-&gt;length = (unsigned)hold &amp; 0xffff;
            Tracev((stderr, "inflate:       stored length %u\n",
                    state-&gt;length));
            INITBITS();
            state-&gt;mode = COPY;
        case COPY:
            copy = state-&gt;length;
            if (copy) {
                if (copy &gt; have) copy = have;
                if (copy &gt; left) copy = left;
                if (copy == 0) goto inf_leave;
                zmemcpy(put, next, copy);
                have -= copy;
                next += copy;
                left -= copy;
                put += copy;
                state-&gt;length -= copy;
                break;
            }
            Tracev((stderr, "inflate:       stored end\n"));
            state-&gt;mode = TYPE;
            break;
        case TABLE:
            NEEDBITS(14);
            state-&gt;nlen = BITS(5) + 257;
            DROPBITS(5);
            state-&gt;ndist = BITS(5) + 1;
            DROPBITS(5);
            state-&gt;ncode = BITS(4) + 4;
            DROPBITS(4);
#ifndef PKZIP_BUG_WORKAROUND
            if (state-&gt;nlen &gt; 286 || state-&gt;ndist &gt; 30) {
                strm-&gt;msg = (char *)"too many length or distance symbols";
                state-&gt;mode = BAD;
                break;
            }
#endif
            Tracev((stderr, "inflate:       table sizes ok\n"));
            state-&gt;have = 0;
            state-&gt;mode = LENLENS;
        case LENLENS:
            while (state-&gt;have &lt; state-&gt;ncode) {
                NEEDBITS(3);
                state-&gt;lens[order[state-&gt;have++]] = (unsigned short)BITS(3);
                DROPBITS(3);
            }
            while (state-&gt;have &lt; 19)
                state-&gt;lens[order[state-&gt;have++]] = 0;
            state-&gt;next = state-&gt;codes;
            state-&gt;lencode = (code const FAR *)(state-&gt;next);
            state-&gt;lenbits = 7;
            ret = inflate_table(CODES, state-&gt;lens, 19, &amp;(state-&gt;next),
                                &amp;(state-&gt;lenbits), state-&gt;work);
            if (ret) {
                strm-&gt;msg = (char *)"invalid code lengths set";
                state-&gt;mode = BAD;
                break;
            }
            Tracev((stderr, "inflate:       code lengths ok\n"));
            state-&gt;have = 0;
            state-&gt;mode = CODELENS;
        case CODELENS:
            while (state-&gt;have &lt; state-&gt;nlen + state-&gt;ndist) {
                for (;;) {
                    this = state-&gt;lencode[BITS(state-&gt;lenbits)];
                    if ((unsigned)(this.bits) &lt;= bits) break;
                    PULLBYTE();
                }
                if (this.val &lt; 16) {
                    NEEDBITS(this.bits);
                    DROPBITS(this.bits);
                    state-&gt;lens[state-&gt;have++] = this.val;
                }
                else {
                    if (this.val == 16) {
                        NEEDBITS(this.bits + 2);
                        DROPBITS(this.bits);
                        if (state-&gt;have == 0) {
                            strm-&gt;msg = (char *)"invalid bit length repeat";
                            state-&gt;mode = BAD;
                            break;
                        }
                        len = state-&gt;lens[state-&gt;have - 1];
                        copy = 3 + BITS(2);
                        DROPBITS(2);
                    }
                    else if (this.val == 17) {
                        NEEDBITS(this.bits + 3);
                        DROPBITS(this.bits);
                        len = 0;
                        copy = 3 + BITS(3);
                        DROPBITS(3);
                    }
                    else {
                        NEEDBITS(this.bits + 7);
                        DROPBITS(this.bits);
                        len = 0;
                        copy = 11 + BITS(7);
                        DROPBITS(7);
                    }
                    if (state-&gt;have + copy &gt; state-&gt;nlen + state-&gt;ndist) {
                        strm-&gt;msg = (char *)"invalid bit length repeat";
                        state-&gt;mode = BAD;
                        break;
                    }
                    while (copy--)
                        state-&gt;lens[state-&gt;have++] = (unsigned short)len;
                }
            }

            /* handle error breaks in while */
            if (state-&gt;mode == BAD) break;

            /* build code tables */
            state-&gt;next = state-&gt;codes;
            state-&gt;lencode = (code const FAR *)(state-&gt;next);
            state-&gt;lenbits = 9;
            ret = inflate_table(LENS, state-&gt;lens, state-&gt;nlen, &amp;(state-&gt;next),
                                &amp;(state-&gt;lenbits), state-&gt;work);
            if (ret) {
                strm-&gt;msg = (char *)"invalid literal/lengths set";
                state-&gt;mode = BAD;
                break;
            }
            state-&gt;distcode = (code const FAR *)(state-&gt;next);
            state-&gt;distbits = 6;
            ret = inflate_table(DISTS, state-&gt;lens + state-&gt;nlen, state-&gt;ndist,
                            &amp;(state-&gt;next), &amp;(state-&gt;distbits), state-&gt;work);
            if (ret) {
                strm-&gt;msg = (char *)"invalid distances set";
                state-&gt;mode = BAD;
                break;
            }
            Tracev((stderr, "inflate:       codes ok\n"));
            state-&gt;mode = LEN;
        case LEN:
            if (have &gt;= 6 &amp;&amp; left &gt;= 258) {
                RESTORE();
                inflate_fast(strm, out);
                LOAD();
                break;
            }
            for (;;) {
                this = state-&gt;lencode[BITS(state-&gt;lenbits)];
                if ((unsigned)(this.bits) &lt;= bits) break;
                PULLBYTE();
            }
            if (this.op &amp;&amp; (this.op &amp; 0xf0) == 0) {
                last = this;
                for (;;) {
                    this = state-&gt;lencode[last.val +
                            (BITS(last.bits + last.op) &gt;&gt; last.bits)];
                    if ((unsigned)(last.bits + this.bits) &lt;= bits) break;
                    PULLBYTE();
                }
                DROPBITS(last.bits);
            }
            DROPBITS(this.bits);
            state-&gt;length = (unsigned)this.val;
            if ((int)(this.op) == 0) {
                Tracevv((stderr, this.val &gt;= 0x20 &amp;&amp; this.val &lt; 0x7f ?
                        "inflate:         literal '%c'\n" :
                        "inflate:         literal 0x%02x\n", this.val));
                state-&gt;mode = LIT;
                break;
            }
            if (this.op &amp; 32) {
                Tracevv((stderr, "inflate:         end of block\n"));
                state-&gt;mode = TYPE;
                break;
            }
            if (this.op &amp; 64) {
                strm-&gt;msg = (char *)"invalid literal/length code";
                state-&gt;mode = BAD;
                break;
            }
            state-&gt;extra = (unsigned)(this.op) &amp; 15;
            state-&gt;mode = LENEXT;
        case LENEXT:
            if (state-&gt;extra) {
                NEEDBITS(state-&gt;extra);
                state-&gt;length += BITS(state-&gt;extra);
                DROPBITS(state-&gt;extra);
            }
            Tracevv((stderr, "inflate:         length %u\n", state-&gt;length));
            state-&gt;mode = DIST;
        case DIST:
            for (;;) {
                this = state-&gt;distcode[BITS(state-&gt;distbits)];
                if ((unsigned)(this.bits) &lt;= bits) break;
                PULLBYTE();
            }
            if ((this.op &amp; 0xf0) == 0) {
                last = this;
                for (;;) {
                    this = state-&gt;distcode[last.val +
                            (BITS(last.bits + last.op) &gt;&gt; last.bits)];
                    if ((unsigned)(last.bits + this.bits) &lt;= bits) break;
                    PULLBYTE();
                }
                DROPBITS(last.bits);
            }
            DROPBITS(this.bits);
            if (this.op &amp; 64) {
                strm-&gt;msg = (char *)"invalid distance code";
                state-&gt;mode = BAD;
                break;
            }
            state-&gt;offset = (unsigned)this.val;
            state-&gt;extra = (unsigned)(this.op) &amp; 15;
            state-&gt;mode = DISTEXT;
        case DISTEXT:
            if (state-&gt;extra) {
                NEEDBITS(state-&gt;extra);
                state-&gt;offset += BITS(state-&gt;extra);
                DROPBITS(state-&gt;extra);
            }
            if (state-&gt;offset &gt; state-&gt;whave + out - left) {
                strm-&gt;msg = (char *)"invalid distance too far back";
                state-&gt;mode = BAD;
                break;
            }
            Tracevv((stderr, "inflate:         distance %u\n", state-&gt;offset));
            state-&gt;mode = MATCH;
        case MATCH:
            if (left == 0) goto inf_leave;
            copy = out - left;
            if (state-&gt;offset &gt; copy) {         /* copy from window */
                copy = state-&gt;offset - copy;
                if (copy &gt; state-&gt;write) {
                    copy -= state-&gt;write;
                    from = state-&gt;window + (state-&gt;wsize - copy);
                }
                else
                    from = state-&gt;window + (state-&gt;write - copy);
                if (copy &gt; state-&gt;length) copy = state-&gt;length;
            }
            else {                              /* copy from output */
                from = put - state-&gt;offset;
                copy = state-&gt;length;
            }
            if (copy &gt; left) copy = left;
            left -= copy;
            state-&gt;length -= copy;
            do {
                *put++ = *from++;
            } while (--copy);
            if (state-&gt;length == 0) state-&gt;mode = LEN;
            break;
        case LIT:
            if (left == 0) goto inf_leave;
            *put++ = (unsigned char)(state-&gt;length);
            left--;
            state-&gt;mode = LEN;
            break;
        case CHECK:
            if (state-&gt;wrap) {
                NEEDBITS(32);
                out -= left;
                strm-&gt;total_out += out;
                state-&gt;total += out;
                if (out)
                    strm-&gt;adler = state-&gt;check =
                        UPDATE(state-&gt;check, put - out, out);
                out = left;
                if ((
#ifdef GUNZIP
                     state-&gt;flags ? hold :
#endif
                     REVERSE(hold)) != state-&gt;check) {
                    strm-&gt;msg = (char *)"incorrect data check";
                    state-&gt;mode = BAD;
                    break;
                }
                INITBITS();
                Tracev((stderr, "inflate:   check matches trailer\n"));
            }
#ifdef GUNZIP
            state-&gt;mode = LENGTH;
        case LENGTH:
            if (state-&gt;wrap &amp;&amp; state-&gt;flags) {
                NEEDBITS(32);
                if (hold != (state-&gt;total &amp; 0xffffffffUL)) {
                    strm-&gt;msg = (char *)"incorrect length check";
                    state-&gt;mode = BAD;
                    break;
                }
                INITBITS();
                Tracev((stderr, "inflate:   length matches trailer\n"));
            }
#endif
            state-&gt;mode = DONE;
        case DONE:
            ret = Z_STREAM_END;
            goto inf_leave;
        case BAD:
            ret = Z_DATA_ERROR;
            goto inf_leave;
        case MEM:
            return Z_MEM_ERROR;
        case SYNC:
        default:
            return Z_STREAM_ERROR;
        }

    /*
       Return from inflate(), updating the total counts and the check value.
       If there was no progress during the inflate() call, return a buffer
       error.  Call updatewindow() to create and/or update the window state.
       Note: a memory error from inflate() is non-recoverable.
     */
  inf_leave:
    RESTORE();
    if (state-&gt;wsize || (state-&gt;mode &lt; CHECK &amp;&amp; out != strm-&gt;avail_out))
        if (updatewindow(strm, out)) {
            state-&gt;mode = MEM;
            return Z_MEM_ERROR;
        }
    in -= strm-&gt;avail_in;
    out -= strm-&gt;avail_out;
    strm-&gt;total_in += in;
    strm-&gt;total_out += out;
    state-&gt;total += out;
    if (state-&gt;wrap &amp;&amp; out)
        strm-&gt;adler = state-&gt;check =
            UPDATE(state-&gt;check, strm-&gt;next_out - out, out);
    strm-&gt;data_type = state-&gt;bits + (state-&gt;last ? 64 : 0) +
                      (state-&gt;mode == TYPE ? 128 : 0);
    if (((in == 0 &amp;&amp; out == 0) || flush == Z_FINISH) &amp;&amp; ret == Z_OK)
        ret = Z_BUF_ERROR;
    return ret;
}

int ZEXPORT inflateEnd(strm)
z_streamp strm;
{
    struct inflate_state FAR *state;
    if (strm == Z_NULL || strm-&gt;state == Z_NULL || strm-&gt;zfree == (free_func)0)
        return Z_STREAM_ERROR;
    state = (struct inflate_state FAR *)strm-&gt;state;
    if (state-&gt;window != Z_NULL) ZFREE(strm, state-&gt;window);
    ZFREE(strm, strm-&gt;state);
    strm-&gt;state = Z_NULL;
    Tracev((stderr, "inflate: end\n"));
    return Z_OK;
}

int ZEXPORT inflateSetDictionary(strm, dictionary, dictLength)
z_streamp strm;
const Bytef *dictionary;
uInt dictLength;
{
    struct inflate_state FAR *state;
    unsigned long id;

    /* check state */
    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;
    state = (struct inflate_state FAR *)strm-&gt;state;
    if (state-&gt;mode != DICT) return Z_STREAM_ERROR;

    /* check for correct dictionary id */
    id = adler32(0L, Z_NULL, 0);
    id = adler32(id, dictionary, dictLength);
    if (id != state-&gt;check) return Z_DATA_ERROR;

    /* copy dictionary to window */
    if (updatewindow(strm, strm-&gt;avail_out)) {
        state-&gt;mode = MEM;
        return Z_MEM_ERROR;
    }
    if (dictLength &gt; state-&gt;wsize) {
        zmemcpy(state-&gt;window, dictionary + dictLength - state-&gt;wsize,
                state-&gt;wsize);
        state-&gt;whave = state-&gt;wsize;
    }
    else {
        zmemcpy(state-&gt;window + state-&gt;wsize - dictLength, dictionary,
                dictLength);
        state-&gt;whave = dictLength;
    }
    state-&gt;havedict = 1;
    Tracev((stderr, "inflate:   dictionary set\n"));
    return Z_OK;
}

/*
   Search buf[0..len-1] for the pattern: 0, 0, 0xff, 0xff.  Return when found
   or when out of input.  When called, *have is the number of pattern bytes
   found in order so far, in 0..3.  On return *have is updated to the new
   state.  If on return *have equals four, then the pattern was found and the
   return value is how many bytes were read including the last byte of the
   pattern.  If *have is less than four, then the pattern has not been found
   yet and the return value is len.  In the latter case, syncsearch() can be
   called again with more data and the *have state.  *have is initialized to
   zero for the first call.
 */
local unsigned syncsearch(have, buf, len)
unsigned FAR *have;
unsigned char FAR *buf;
unsigned len;
{
    unsigned got;
    unsigned next;

    got = *have;
    next = 0;
    while (next &lt; len &amp;&amp; got &lt; 4) {
        if ((int)(buf[next]) == (got &lt; 2 ? 0 : 0xff))
            got++;
        else if (buf[next])
            got = 0;
        else
            got = 4 - got;
        next++;
    }
    *have = got;
    return next;
}

int ZEXPORT inflateSync(strm)
z_streamp strm;
{
    unsigned len;               /* number of bytes to look at or looked at */
    unsigned long in, out;      /* temporary to save total_in and total_out */
    unsigned char buf[4];       /* to restore bit buffer to byte string */
    struct inflate_state FAR *state;

    /* check parameters */
    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;
    state = (struct inflate_state FAR *)strm-&gt;state;
    if (strm-&gt;avail_in == 0 &amp;&amp; state-&gt;bits &lt; 8) return Z_BUF_ERROR;

    /* if first time, start search in bit buffer */
    if (state-&gt;mode != SYNC) {
        state-&gt;mode = SYNC;
        state-&gt;hold &lt;&lt;= state-&gt;bits &amp; 7;
        state-&gt;bits -= state-&gt;bits &amp; 7;
        len = 0;
        while (state-&gt;bits &gt;= 8) {
            buf[len++] = (unsigned char)(state-&gt;hold);
            state-&gt;hold &gt;&gt;= 8;
            state-&gt;bits -= 8;
        }
        state-&gt;have = 0;
        syncsearch(&amp;(state-&gt;have), buf, len);
    }

    /* search available input */
    len = syncsearch(&amp;(state-&gt;have), strm-&gt;next_in, strm-&gt;avail_in);
    strm-&gt;avail_in -= len;
    strm-&gt;next_in += len;
    strm-&gt;total_in += len;

    /* return no joy or set up to restart inflate() on a new block */
    if (state-&gt;have != 4) return Z_DATA_ERROR;
    in = strm-&gt;total_in;  out = strm-&gt;total_out;
    inflateReset(strm);
    strm-&gt;total_in = in;  strm-&gt;total_out = out;
    state-&gt;mode = TYPE;
    return Z_OK;
}

/*
   Returns true if inflate is currently at the end of a block generated by
   Z_SYNC_FLUSH or Z_FULL_FLUSH. This function is used by one PPP
   implementation to provide an additional safety check. PPP uses
   Z_SYNC_FLUSH but removes the length bytes of the resulting empty stored
   block. When decompressing, PPP checks that at the end of input packet,
   inflate is waiting for these length bytes.
 */
int ZEXPORT inflateSyncPoint(strm)
z_streamp strm;
{
    struct inflate_state FAR *state;

    if (strm == Z_NULL || strm-&gt;state == Z_NULL) return Z_STREAM_ERROR;
    state = (struct inflate_state FAR *)strm-&gt;state;
    return state-&gt;mode == STORED &amp;&amp; state-&gt;bits == 0;
}

int ZEXPORT inflateCopy(dest, source)
z_streamp dest;
z_streamp source;
{
    struct inflate_state FAR *state;
    struct inflate_state FAR *copy;
    unsigned char FAR *window;

    /* check input */
    if (dest == Z_NULL || source == Z_NULL || source-&gt;state == Z_NULL ||
        source-&gt;zalloc == (alloc_func)0 || source-&gt;zfree == (free_func)0)
        return Z_STREAM_ERROR;
    state = (struct inflate_state FAR *)source-&gt;state;

    /* allocate space */
    copy = (struct inflate_state FAR *)
           ZALLOC(source, 1, sizeof(struct inflate_state));
    if (copy == Z_NULL) return Z_MEM_ERROR;
    window = Z_NULL;
    if (state-&gt;window != Z_NULL) {
        window = (unsigned char FAR *)
                 ZALLOC(source, 1U &lt;&lt; state-&gt;wbits, sizeof(unsigned char));
        if (window == Z_NULL) {
            ZFREE(source, copy);
            return Z_MEM_ERROR;
        }
    }

    /* copy state */
    *dest = *source;
    *copy = *state;
    copy-&gt;lencode = copy-&gt;codes + (state-&gt;lencode - state-&gt;codes);
    copy-&gt;distcode = copy-&gt;codes + (state-&gt;distcode - state-&gt;codes);
    copy-&gt;next = copy-&gt;codes + (state-&gt;next - state-&gt;codes);
    if (window != Z_NULL)
        zmemcpy(window, state-&gt;window, 1U &lt;&lt; state-&gt;wbits);
    copy-&gt;window = window;
    dest-&gt;state = (voidpf)copy;
    return Z_OK;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

