<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/histogram.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/histogram.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;bio.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;

enum {
	STACK 	= 8*1024,

	Dot	= 2,	/* height of dot */
	Lx	= 4,	/* x offset */
	Ly	= 4,	/* y offset */
	Bw	= 2,	/* border width */
};

Image *neutral;
Image *light;
Image *dark;
Image *txtcolor;

char *title = "histogram";
Rectangle hrect;
Point maxvloc;
double *data;
double vmax = 100, scale = 1.0;
uint nval;
int dontdie = 0, col = 1;

int colors[][3] = {
	{ 0xFFAAAAFF,	0xFFAAAAFF,	0xBB5D5DFF },		/* Peach */
	{ DPalebluegreen, DPalegreygreen, DPurpleblue },	/* Aqua */
	{ DPaleyellow,	DDarkyellow,	DYellowgreen },		/* Yellow */
	{ DPalegreen,	DMedgreen,	DDarkgreen },		/* Green */
	{ 0x00AAFFFF,	0x00AAFFFF,	0x0088CCFF },		/* Blue */
	{ 0xEEEEEEFF,	0xCCCCCCFF,	0x888888F },		/* Grey */
};

void
initcolor(int i)
{
	neutral = allocimagemix(display, colors[i][0], DWhite);
	light = allocimage(display, Rect(0,0,1,1), CMAP8, 1, colors[i][1]);
	dark  = allocimage(display, Rect(0,0,1,1), CMAP8, 1, colors[i][2]);
	txtcolor = display-&gt;black;
}

void*
erealloc(void *v, ulong sz)
{
	v = realloc(v, sz);
	if(v == nil){
		sysfatal("realloc: %r");
		threadexitsall("memory");
	}
	return v;
}

Point
datapoint(int x, double v)
{
	Point p;
	double y;

	p.x = x;
	y = (v*scale) / vmax;
	p.y = hrect.max.y - Dy(hrect)*y - Dot;
	if(p.y &lt; hrect.min.y)
		p.y = hrect.min.y;
	if(p.y &gt; hrect.max.y - Dot)
		p.y = hrect.max.y - Dot;
	return p;
}

void
drawdatum(int x, double prev, double v)
{
	Point p, q;

	p = datapoint(x, v);
	q = datapoint(x, prev);
	if(p.y &lt; q.y){
		draw(screen, Rect(p.x, hrect.min.y, p.x+1, p.y), neutral,
			nil, ZP);
		draw(screen, Rect(p.x, p.y, p.x+1, q.y+Dot), dark, nil, ZP);
		draw(screen, Rect(p.x, q.y+Dot, p.x+1, hrect.max.y), light,
			nil, ZP);
	}else{
		draw(screen, Rect(p.x, hrect.min.y, p.x+1, q.y), neutral,
			nil, ZP);
		draw(screen, Rect(p.x, q.y, p.x+1, p.y+Dot), dark, nil, ZP);
		draw(screen, Rect(p.x, p.y+Dot, p.x+1, hrect.max.y), light,
			nil, ZP);
	}

}

void
updatehistogram(double v)
{
	char buf[32];

	draw(screen, hrect, screen, nil, Pt(hrect.min.x+1, hrect.min.y));
	if(v * scale &gt; vmax)
		v = vmax / scale;
	drawdatum(hrect.max.x-1, data[0], v);
	memmove(&amp;data[1], &amp;data[0], (nval-1) * sizeof data[0]);
	data[0] = v;
	snprint(buf, sizeof buf, "%0.9f", v);
	stringbg(screen, maxvloc, txtcolor, ZP, display-&gt;defaultfont, buf,
		neutral, ZP);
	flushimage(display, 1);
}

void
redrawhistogram(int new)
{
	Point p, q;
	Rectangle r;
	uint onval = nval;
	int i;
	char buf[32];

	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0)
		sysfatal("getwindow: %r");

	r = screen-&gt;r;
	draw(screen, r, neutral, nil, ZP);
	p = string(screen, addpt(r.min, Pt(Lx, Ly)), txtcolor, ZP,
		display-&gt;defaultfont, title);

	p.x = r.min.x + Lx;
	p.y += display-&gt;defaultfont-&gt;height + Ly;

	q = subpt(r.max, Pt(Lx, Ly));
	hrect = Rpt(p, q);

	maxvloc = Pt(r.max.x - Lx - stringwidth(display-&gt;defaultfont,
		"999999999"), r.min.y + Ly);

	nval = abs(Dx(hrect));
	if(nval != onval){
		data = erealloc(data, nval * sizeof data[0]);
		if(nval &gt; onval)
			memset(data+onval, 0, (nval - onval) * sizeof data[0]);
	}

	border(screen, hrect, -Bw, dark, ZP);
	snprint(buf, sizeof buf, "%0.9f", data[0]);
	stringbg(screen, maxvloc, txtcolor, ZP, display-&gt;defaultfont, buf,
		neutral, ZP);
	draw(screen, hrect, neutral, nil, ZP);
	for(i = 1; i &lt; nval - 1; i++)
		drawdatum(hrect.max.x - i, data[i-1], data[i]);
	drawdatum(hrect.min.x, data[i], data[i]);
	flushimage(display, 1);
}

void
reader(void *arg)
{
	int fd;
	double v;
	char *p, *f[2];
	uchar buf[512];
	Biobufhdr b;
	Channel *c = arg;

	threadsetname("reader");
	fd = dup(0, -1);
	Binits(&amp;b, fd, OREAD, buf, sizeof buf);

	while((p = Brdline(&amp;b, '\n')) != nil) {
		p[Blinelen(&amp;b) - 1] = '\0';
		if(tokenize(p, f, 1) != 1)
			continue;
		v = strtod(f[0], 0);
		send(c, &amp;v);
	}
	if(!dontdie)
		threadexitsall(nil);
}


void
histogram(char *rect)
{
	int rm;
	double dm;
	Channel *dc;
	Keyboardctl *kc;
	Mouse mm;
	Mousectl *mc;
	Rune km;
	Alt a[] = {
		/* c	v	op */
		{nil,	&amp;dm,	CHANRCV},	/* data from stdin */
		{nil,	&amp;mm,	CHANRCV},	/* mouse message */
		{nil,	&amp;km,	CHANRCV},	/* keyboard runes */
		{nil,	&amp;rm,	CHANRCV},	/* resize event */
		{nil,	nil,	CHANEND},
	};
	static char *mitems[] = {
		"exit",
		nil
	};
	static Menu menu = {
		mitems,
		nil,
		-1
	};

	memset(&amp;mm, 0, sizeof mm);
	memset(&amp;km, 0, sizeof km);
	dm = rm = 0;

	if(newwindow(rect) &lt; 0)
		sysfatal("newwindow: %r");
	if(initdraw(nil, nil, "histogram") &lt; 0)
		sysfatal("initdraw: %r");

	initcolor(col);

	mc = initmouse(nil, screen);
	if(!mc)
		sysfatal("initmouse: %r");
	kc = initkeyboard(nil);
	if(!kc)
		sysfatal("initkeyboard: %r");

	dc = chancreate(sizeof dm, 10);
	if(!dc)
		sysfatal("chancreate: %r");

	a[0].c = dc;
	a[1].c = mc-&gt;c;
	a[2].c = kc-&gt;c;
	a[3].c = mc-&gt;resizec;

	proccreate(reader, a[0].c, STACK + sizeof(Biobuf));

	redrawhistogram(0);
	for(;;)
		switch(alt(a)){
		case 0:
			updatehistogram(dm);
			break;
		case 1:
			if(mm.buttons &amp; 4 &amp;&amp; menuhit(3, mc, &amp;menu, nil) == 0)
				goto done;
			break;
		case 2:
			if(km == 0x7F)
				goto done;
			break;
		case 3:
			redrawhistogram(1);
			break;
		default:
			sysfatal("shouldn't happen");
		}
done:
	closekeyboard(kc);
	closemouse(mc);
	chanfree(a[0].c);
	threadexitsall(nil);
}

void
usage(void)
{
	fprint(2, "usage: histogram [-h] [-c index] [-r minx,miny,maxx,maxy] "
		"[-s scale] [-t title] [-v maxv]\n");
	exits("usage");
}

void
threadmain(int argc, char **argv)
{
	char *p, *q;

	p = "-r 0,0,400,150";

	ARGBEGIN{
	case 'v':
		vmax = strtod(EARGF(usage()), 0);
		break;
	case 'r':
		p = smprint("-r %s", EARGF(usage()));
		break;
	case 's':
		scale = strtod(EARGF(usage()), 0);
		if(scale &lt;= 0)
			usage();
		break;
	case 'h':
		dontdie = 1;
		break;
	case 't':
		title = EARGF(usage());
		break;
	case 'c':
		col = atoi(EARGF(usage())) % nelem(colors);
		break;
	default:
		usage();
	}ARGEND;

	while((q = strchr(p, ',')) != nil)
		*q = ' ';

	histogram(p);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

