<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/htmlroff/t1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/htmlroff/t1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "a.h"
 
/*
 * Section 1 - General Explanation.
 */

/* 1.3 - Numerical parameter input.  */
char *units = "icPmnpuvx";
int
scale2units(char c)
{
	int x;
	
	switch(c){
	case 'i':	/* inch */
		return UPI;
	case 'c':	/* centimeter */
		return 0.3937008 * UPI;
	case 'P':	/* pica = 1/6 inch */
		return UPI / 6;
	case 'm':	/* em = S points */
		return UPI / 72.0 * getnr(L(".s"));
	case 'n':	/* en = em/2 */
		return UPI / 72.0 * getnr(L(".s")) / 2;
	case 'p':	/* point = 1/72 inch */
		return UPI / 72;
	case 'u':	/* basic unit */
		return 1;
	case 'v':	/* vertical line space V */
		x = getnr(L(".v"));
		if(x == 0)
			x = 12 * UPI / 72;
		return x;
	case 'x':	/* pixel (htmlroff addition) */
		return UPX;
	default:
		return 1;
	}
}

/* 1.4 - Numerical expressions. */
int eval0(Rune**, int, int);
int
eval(Rune *s)
{
	return eval0(&amp;s, 1, 1);
}
long
runestrtol(Rune *a, Rune **p)
{
	long n;
	
	n = 0;
	while('0' &lt;= *a &amp;&amp; *a &lt;= '9'){
		n = n*10 + *a-'0';
		a++;
	}
	*p = a;
	return n;
}

int
evalscale(Rune *s, int c)
{
	return eval0(&amp;s, scale2units(c), 1);
}

int
eval0(Rune **pline, int scale, int recur)
{
	Rune *p;
	int neg;
	double f, p10;
	int x, y;

	neg = 0;
	p = *pline;
	while(*p == '-'){
		neg = 1 - neg;
		p++;
	}
	if(*p == '('){
		p++;
		x = eval0(&amp;p, scale, 1);
		if (*p != ')'){
			*pline = p;
			return x;
		}
		p++;
	}else{
		f = runestrtol(p, &amp;p);
		if(*p == '.'){
			p10 = 1.0;
			p++;
			while('0' &lt;= *p &amp;&amp; *p &lt;= '9'){
				p10 /= 10;
				f += p10*(*p++ - '0');
			}
		}
		if(*p &amp;&amp; strchr(units, *p)){
			if(scale)
				f *= scale2units(*p);
			p++;
		}else if(scale)
			f *= scale;
		x = f;
	}
	if(neg)
		x = -x;
	if(!recur){
		*pline = p;
		return x;
	}
	
	while(*p){
		switch(*p++) {
		case '+':
			x += eval0(&amp;p, scale, 0);
			continue;
		case '-':
			x -= eval0(&amp;p, scale, 0);
			continue;
		case '*':
			x *= eval0(&amp;p, scale, 0);
			continue;
		case '/':
			y = eval0(&amp;p, scale, 0);
			if (y == 0) {
				fprint(2, "%L: divide by zero %S\n", p);
				y = 1;
			}
			x /= y;
			continue;
		case '%':
			y = eval0(&amp;p, scale, 0);
			if (!y) {
				fprint(2, "%L: modulo by zero %S\n", p);
				y = 1;
			}
			x %= y;
			continue;
		case '&lt;':
			if (*p == '=') {
				p++;
				x = x &lt;= eval0(&amp;p, scale, 0);
				continue;
			}
			x = x &lt; eval0(&amp;p, scale, 0);
			continue;
		case '&gt;':
			if (*p == '=') {
				p++;
				x = x &gt;= eval0(&amp;p, scale, 0);
				continue;
			}
			x = x &gt; eval0(&amp;p, scale, 0);
			continue;
		case '=':
			if (*p == '=')
				p++;
			x = x == eval0(&amp;p, scale, 0);
			continue;
		case '&amp;':
			x &amp;= eval0(&amp;p, scale, 0);
			continue;
		case ':':
			x |= eval0(&amp;p, scale, 0);
			continue;
		}
	}
	*pline = p;
	return x;
}

void
t1init(void)
{
	Tm tm;
	
	tm = *localtime(time(0));
	nr(L("dw"), tm.wday+1);
	nr(L("dy"), tm.mday);
	nr(L("mo"), tm.mon);
	nr(L("yr"), tm.year%100);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

