<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/dhcpd/db.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/dhcpd/db.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;ctype.h&gt;
#include "dat.h"

/*
 *  format of a binding entry:
 *	char ipaddr[32];
 *	char id[32];
 *	char hwa[32];
 *	char otime[10];
 */
Binding *bcache;
uchar bfirst[IPaddrlen];
char *binddir = "/lib/ndb/dhcp";

/*
 *  convert a byte array to hex
 */
static char
hex(int x)
{
	if(x &lt; 10)
		return x + '0';
	return x - 10 + 'a';
}
extern char*
tohex(char *hdr, uchar *p, int len)
{
	char *s, *sp;
	int hlen;

	hlen = strlen(hdr);
	s = malloc(hlen + 2*len + 1);
	sp = s;
	strcpy(sp, hdr);
	sp += hlen;
	for(; len &gt; 0; len--){
		*sp++ = hex(*p&gt;&gt;4);
		*sp++ = hex(*p &amp; 0xf);
		p++;
	}
	*sp = 0;
	return s;
}

/*
 *  convert a client id to a string.  If it's already
 *  ascii, leave it be.  Otherwise, convert it to hex.
 */
extern char*
toid(uchar *p, int n)
{
	int i;
	char *s;

	for(i = 0; i &lt; n; i++)
		if(!isprint(p[i]))
			return tohex("id", p, n);
	s = malloc(n + 1);
	memmove(s, p, n);
	s[n] = 0;
	return s;
}

/*
 *  increment an ip address
 */
static void
incip(uchar *ip)
{
	int i, x;

	for(i = IPaddrlen-1; i &gt;= 0; i--){
		x = ip[i];
		x++;
		ip[i] = x;
		if((x &amp; 0x100) == 0)
			break;
	}
}

/*
 *  find a binding for an id or hardware address
 */
static int
lockopen(char *file)
{
	char err[ERRMAX];
	int fd, tries;

	for(tries = 0; tries &lt; 5; tries++){
		fd = open(file, ORDWR);
		if(fd &gt;= 0)
			return fd;
		errstr(err, sizeof err);
		if(strstr(err, "lock")){
			/* wait for other process to let go of lock */
			sleep(250);

			/* try again */
			continue;
		}
		if(strstr(err, "exist")){
			/* no file, create an exclusive access file */
			fd = create(file, ORDWR, DMEXCL|0664);
			if(fd &gt;= 0)
				return fd;
		}
	}
	return -1;
}

void
setbinding(Binding *b, char *id, long t)
{
	if(b-&gt;boundto)
		free(b-&gt;boundto);

	b-&gt;boundto = strdup(id);
	b-&gt;lease = t;
}

static void
parsebinding(Binding *b, char *buf)
{
	long t;
	char *id, *p;

	/* parse */
	t = atoi(buf);
	id = strchr(buf, '\n');
	if(id){
		*id++ = 0;
		p = strchr(id, '\n');
		if(p)
			*p = 0;
	} else
		id = "";

	/* replace any past info */
	setbinding(b, id, t);
}

static int
writebinding(int fd, Binding *b)
{
	Dir *d;

	seek(fd, 0, 0);
	if(fprint(fd, "%ld\n%s\n", b-&gt;lease, b-&gt;boundto) &lt; 0)
		return -1;
	d = dirfstat(fd);
	if(d == nil)
		return -1;
	b-&gt;q.type = d-&gt;qid.type;
	b-&gt;q.path = d-&gt;qid.path;
	b-&gt;q.vers = d-&gt;qid.vers;
	free(d);
	return 0;
}

/*
 *  synchronize cached binding with file.  the file always wins.
 */
int
syncbinding(Binding *b, int returnfd)
{
	char buf[512];
	int i, fd;
	Dir *d;

	snprint(buf, sizeof(buf), "%s/%I", binddir, b-&gt;ip);
	fd = lockopen(buf);
	if(fd &lt; 0){
		/* assume someone else is using it */
		b-&gt;lease = time(0) + OfferTimeout;
		return -1;
	}

	/* reread if changed */
	d = dirfstat(fd);
	if(d != nil)	/* BUG? */
	if(d-&gt;qid.type != b-&gt;q.type || d-&gt;qid.path != b-&gt;q.path || d-&gt;qid.vers != b-&gt;q.vers){
		i = read(fd, buf, sizeof(buf)-1);
		if(i &lt; 0)
			i = 0;
		buf[i] = 0;
		parsebinding(b, buf);
		b-&gt;lasttouched = d-&gt;mtime;
		b-&gt;q.path = d-&gt;qid.path;
		b-&gt;q.vers = d-&gt;qid.vers;
	}

	free(d);

	if(returnfd)
		return fd;

	close(fd);
	return 0;
}

extern int
samenet(uchar *ip, Info *iip)
{
	uchar x[IPaddrlen];

	maskip(iip-&gt;ipmask, ip, x);
	return ipcmp(x, iip-&gt;ipnet) == 0;
}

/*
 *  create a record for each binding
 */
extern void
initbinding(uchar *first, int n)
{
	while(n-- &gt; 0){
		iptobinding(first, 1);
		incip(first);
	}
}

/*
 *  find a binding for a specific ip address
 */
extern Binding*
iptobinding(uchar *ip, int mk)
{
	Binding *b;

	for(b = bcache; b; b = b-&gt;next){
		if(ipcmp(b-&gt;ip, ip) == 0){
			syncbinding(b, 0);
			return b;
		}
	}

	if(mk == 0)
		return 0;
	b = malloc(sizeof(*b));
	memset(b, 0, sizeof(*b));
	ipmove(b-&gt;ip, ip);
	b-&gt;next = bcache;
	bcache = b;
	syncbinding(b, 0);
	return b;
}

static void
lognolease(Binding *b)
{
	/* renew the old binding, and hope it eventually goes away */
	b-&gt;offer = 5*60;
	commitbinding(b);

	/* complain if we haven't in the last 5 minutes */
	if(now - b-&gt;lastcomplained &lt; 5*60)
		return;
	syslog(0, blog, "dhcp: lease for %I to %s ended at %ld but still in use\n",
		b-&gt;ip, b-&gt;boundto != nil ? b-&gt;boundto : "?", b-&gt;lease);
	b-&gt;lastcomplained = now;
}

/*
 *  find a free binding for a hw addr or id on the same network as iip
 */
extern Binding*
idtobinding(char *id, Info *iip, int ping)
{
	Binding *b, *oldest;
	int oldesttime;

	/*
	 *  first look for an old binding that matches.  that way
	 *  clients will tend to keep the same ip addresses.
	 */
	for(b = bcache; b; b = b-&gt;next){
		if(b-&gt;boundto &amp;&amp; strcmp(b-&gt;boundto, id) == 0){
			if(!samenet(b-&gt;ip, iip))
				continue;

			/* check with the other servers */
			syncbinding(b, 0);
			if(strcmp(b-&gt;boundto, id) == 0)
				return b;
		}
	}

	/*
	 *  look for oldest binding that we think is unused
	 */
	for(;;){
		oldest = nil;
		oldesttime = 0;
		for(b = bcache; b; b = b-&gt;next){
			if(b-&gt;tried != now)
			if(b-&gt;lease &lt; now &amp;&amp; b-&gt;expoffer &lt; now &amp;&amp; samenet(b-&gt;ip, iip))
			if(oldest == nil || b-&gt;lasttouched &lt; oldesttime){
				/* sync and check again */
				syncbinding(b, 0);
				if(b-&gt;lease &lt; now &amp;&amp; b-&gt;expoffer &lt; now &amp;&amp; samenet(b-&gt;ip, iip))
				if(oldest == nil || b-&gt;lasttouched &lt; oldesttime){
					oldest = b;
					oldesttime = b-&gt;lasttouched;
				}
			}
		}
		if(oldest == nil)
			break;

		/* make sure noone is still using it */
		oldest-&gt;tried = now;
		if(ping == 0 || icmpecho(oldest-&gt;ip) == 0)
			return oldest;

		lognolease(oldest);	/* sets lastcomplained */
	}

	/* try all bindings */
	for(b = bcache; b; b = b-&gt;next){
		syncbinding(b, 0);
		if(b-&gt;tried != now)
		if(b-&gt;lease &lt; now &amp;&amp; b-&gt;expoffer &lt; now &amp;&amp; samenet(b-&gt;ip, iip)){
			b-&gt;tried = now;
			if(ping == 0 || icmpecho(b-&gt;ip) == 0)
				return b;

			lognolease(b);
		}
	}

	/* nothing worked, give up */
	return 0;
}

/*
 *  create an offer
 */
extern void
mkoffer(Binding *b, char *id, long leasetime)
{
	if(leasetime &lt;= 0){
		if(b-&gt;lease &gt; now + minlease)
			leasetime = b-&gt;lease - now;
		else
			leasetime = minlease;
	}
	if(b-&gt;offeredto)
		free(b-&gt;offeredto);
	b-&gt;offeredto = strdup(id);
	b-&gt;offer = leasetime;
	b-&gt;expoffer = now + OfferTimeout;
}

/*
 *  find an offer for this id
 */
extern Binding*
idtooffer(char *id, Info *iip)
{
	Binding *b;

	/* look for an offer to this id */
	for(b = bcache; b; b = b-&gt;next){
		if(b-&gt;offeredto &amp;&amp; strcmp(b-&gt;offeredto, id) == 0 &amp;&amp; samenet(b-&gt;ip, iip)){
			/* make sure some other system hasn't stolen it */
			syncbinding(b, 0);
			if(b-&gt;lease &lt; now
			|| (b-&gt;boundto &amp;&amp; strcmp(b-&gt;boundto, b-&gt;offeredto) == 0))
				return b;
		}
	}
	return 0;
}

/*
 *  commit a lease, this could fail
 */
extern int
commitbinding(Binding *b)
{
	int fd;
	long now;

	now = time(0);

	if(b-&gt;offeredto == 0)
		return -1;
	fd = syncbinding(b, 1);
	if(fd &lt; 0)
		return -1;
	if(b-&gt;lease &gt; now &amp;&amp; b-&gt;boundto &amp;&amp; strcmp(b-&gt;boundto, b-&gt;offeredto) != 0){
		close(fd);
		return -1;
	}
	setbinding(b, b-&gt;offeredto, now + b-&gt;offer);
	b-&gt;lasttouched = now;
	
	if(writebinding(fd, b) &lt; 0){
		close(fd);
		return -1;
	}
	close(fd);
	return 0;
}

/*
 *  commit a lease, this could fail
 */
extern int
releasebinding(Binding *b, char *id)
{
	int fd;
	long now;

	now = time(0);

	fd = syncbinding(b, 1);
	if(fd &lt; 0)
		return -1;
	if(b-&gt;lease &gt; now &amp;&amp; b-&gt;boundto &amp;&amp; strcmp(b-&gt;boundto, id) != 0){
		close(fd);
		return -1;
	}
	b-&gt;lease = 0;
	b-&gt;expoffer = 0;
	
	if(writebinding(fd, b) &lt; 0){
		close(fd);
		return -1;
	}
	close(fd);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

