<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ftpfs/ftpfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ftpfs/ftpfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;String.h&gt;
#include "ftpfs.h"

/* an active fid */
typedef struct Fid	Fid;
struct Fid
{
	int	fid;
	Node	*node;		/* path to remote file */
	int	busy;
	Fid	*next;
	int	open;
};

Fid	*fids;			/* linked list of fids */
char	errstring[128];		/* error to return */
int	mfd;			/* fd for 9fs */
int	messagesize = 4*1024*IOHDRSZ;
uchar	mdata[8*1024*IOHDRSZ];
uchar	mbuf[8*1024*IOHDRSZ];
Fcall	rhdr;
Fcall	thdr;
int	debug;
int	usenlst;
int	usetls;
char	*ext;
int	quiet;
int	kapid = -1;
int	dying;		/* set when any process decides to die */
int	dokeepalive;

char	*rflush(Fid*), *rnop(Fid*), *rversion(Fid*),
	*rattach(Fid*), *rclone(Fid*), *rwalk(Fid*),
	*rclwalk(Fid*), *ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*),
	*rauth(Fid*);;
void	mountinit(char*);
void	io(void);
int	readpdir(Node*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tattach]	rattach,
	[Tauth]		rauth,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

/* these names are matched as prefixes, so VMS must precede VM */
OS oslist[] = {
	{ Plan9,	"Plan 9", },
	{ Plan9,	"Plan9", },
	{ Plan9,	"UNIX Type: L8 Version: Plan 9", },
	{ Unix,		"SUN", },
	{ Unix,		"UNIX", },
	{ VMS,		"VMS", },
	{ VM,		"VM", },
	{ Tops,		"TOPS", },
	{ MVS,		"MVS", },
	{ NetWare,	"NetWare", },
	{ NetWare,	"NETWARE", },
	{ OS½,		"OS/2", },
	{ TSO,		"TSO", },
	{ NT,		"Windows_NT", },	/* DOS like interface */
	{ NT,		"WINDOWS_NT", },	/* Unix like interface */
	{ Unknown,	0 },
};

char *nouid = "?uid?";

#define S2P(x) (((ulong)(x)) &amp; 0xffffff)

char *nosuchfile = "file does not exist";
char *keyspec = "";

void
usage(void)
{
	fprint(2, "ftpfs [-/dqnt] [-a passwd] [-m mountpoint] [-e ext] [-k keyspec] [-o os] [-r root] [net!]address\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	char *mountroot = 0;
	char *mountpoint = "/n/ftp";
	char *cpassword = 0;
	char *cp;
	int p[2];
	OS *o;

	defos = Unix;
	user = strdup(getuser());
	usetls = 0;

	ARGBEGIN {
	case '/':
		mountroot = "/";
		break;
	case 'a':
		cpassword = ARGF();
		break;
	case 'd':
		debug = 1;
		break;
	case 'k':
		keyspec = EARGF(usage());
		break;
	case 'K':
		dokeepalive = 1;
		break;
	case 'm':
		mountpoint = ARGF();
		break;
	case 'n':
		usenlst = 1;
		break;
	case 'e':
		ext = ARGF();
		break;
	case 't':
		usetls = 1;
		break;
	case 'o':
		cp = ARGF();
		for(o = oslist; o-&gt;os != Unknown; o++)
			if(strncmp(cp, o-&gt;name, strlen(o-&gt;name)) == 0){
				defos = o-&gt;os;
				break;
			}
		break;
	case 'r':
		mountroot = ARGF();
		break;
	case 'q':
		quiet = 1;
		break;
	} ARGEND
	if(argc != 1)
		usage();

	/* get a pipe to mount and run 9fs on */
	if(pipe(p) &lt; 0)
		fatal("pipe failed: %r");
	mfd = p[0];

	/* initial handshakes with remote side */
	hello(*argv);
	if(cpassword == 0)
		rlogin(*argv, keyspec);
	else
		clogin("anonymous", cpassword);
	preamble(mountroot);

	/* start the 9fs protocol */
	switch(rfork(RFPROC|RFNAMEG|RFENVG|RFFDG|RFNOTEG|RFREND)){
	case -1:
		fatal("fork: %r");
	case 0:
		/* seal off standard input/output */
		close(0);
		open("/dev/null", OREAD);
		close(1);
		open("/dev/null", OWRITE);

		close(p[1]);
		fmtinstall('F', fcallfmt); /* debugging */
		fmtinstall('D', dirfmt); /* expected by %F */
		fmtinstall('M', dirmodefmt); /* expected by %F */
		io();
		quit();
		break;
	default:
		close(p[0]);
		if(mount(p[1], -1, mountpoint, MREPL|MCREATE, "") &lt; 0)
			fatal("mount failed: %r");
	}
	exits(0);
}

/*
 *  lookup an fid. if not found, create a new one.
 */
Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next){
		if(f-&gt;fid == fid){
			if(f-&gt;busy)
				return f;
			else{
				ff = f;
				break;
			}
		} else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	}
	if(ff == 0){
		ff = mallocz(sizeof(*f), 1);
		ff-&gt;next = fids;
		fids = ff;
	}
	ff-&gt;node = nil;
	ff-&gt;fid = fid;
	return ff;
}

/*
 *  a process that sends keep alive messages to
 *  keep the server from shutting down the connection
 */
int
kaproc(void)
{
	int pid;

	if(!dokeepalive)
		return -1;

	switch(pid = rfork(RFPROC|RFMEM)){
	case -1:
		return -1;
	case 0:
		break;
	default:
		return pid;
	}

	while(!dying){
		sleep(5000);
		nop();
	}

	_exits(0);
	return -1;
}

void
io(void)
{
	char *err, buf[ERRMAX];
	int n;

	kapid = kaproc();

	while(!dying){
		n = read9pmsg(mfd, mdata, messagesize);
		if(n &lt;= 0){
			errstr(buf, sizeof buf);
			if(buf[0]=='\0' || strstr(buf, "hungup"))
				exits("");
			fatal("mount read: %s\n", buf);
		}
		if(convM2S(mdata, n, &amp;thdr) == 0)
			continue;

		if(debug)
			fprint(2, "&lt;-%F\n", &amp;thdr);/**/

		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[thdr.type])(newfid(thdr.fid));
		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		if(debug)
			fprint(2, "-&gt;%F\n", &amp;rhdr);/**/
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(write(mfd, mdata, n) != n)
			fatal("mount write");
	}
}

char*
rnop(Fid *f)
{
	USED(f);
	return 0;
}

char*
rversion(Fid*)
{
	if(thdr.msize &gt; sizeof(mdata))
		rhdr.msize = messagesize;
	else
		rhdr.msize = thdr.msize;
	messagesize = thdr.msize;

	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return "unknown 9P version";
	rhdr.version = "9P2000";
	return nil;
}

char*
rflush(Fid*)
{
	return 0;
}

char*
rauth(Fid*)
{
	return "auth unimplemented";
}

char*
rattach(Fid *f)
{
	f-&gt;busy = 1;
	f-&gt;node = remroot;
	rhdr.qid = f-&gt;node-&gt;d-&gt;qid;
	return 0;
}

char*
rwalk(Fid *f)
{
	Node *np;
	Fid *nf;
	char **elems;
	int i, nelems;
	char *err;
	Node *node;

	/* clone fid */
	nf = nil;
	if(thdr.newfid != thdr.fid){
		nf = newfid(thdr.newfid);
		if(nf-&gt;busy)
			return "newfid in use";
		nf-&gt;busy = 1;
		nf-&gt;node = f-&gt;node;
		f = nf;
	}

	err = nil;
	elems = thdr.wname;
	nelems = thdr.nwname;
	node = f-&gt;node;
	rhdr.nwqid = 0;
	if(nelems &gt; 0){
		/* walk fid */
		for(i=0; i&lt;nelems &amp;&amp; i&lt;MAXWELEM; i++){
			if((node-&gt;d-&gt;qid.type &amp; QTDIR) == 0){
				err = "not a directory";
				break;
			}
			if(strcmp(elems[i], ".") == 0){
   Found:
				rhdr.wqid[i] = node-&gt;d-&gt;qid;
				rhdr.nwqid++;
				continue;
			}
			if(strcmp(elems[i], "..") == 0){
				node = node-&gt;parent;
				goto Found;
			}
			if(strcmp(elems[i], ".flush.ftpfs") == 0){
				/* hack to flush the cache */
				invalidate(node);
				readdir(node);
				goto Found;
			}

			/* some top level names are special */
			if((os == Tops || os == VM || os == VMS) &amp;&amp; node == remroot){
				np = newtopsdir(elems[i]);
				if(np){
					node = np;
					goto Found;
				} else {
					err = nosuchfile;
					break;
				}
			}

			/* everything else */
			node = extendpath(node, s_copy(elems[i]));
			if(ISCACHED(node-&gt;parent)){
				/* the cache of the parent is good, believe it */
				if(!ISVALID(node)){
					err = nosuchfile;
					break;
				}
				if(node-&gt;parent-&gt;chdirunknown || (node-&gt;d-&gt;mode &amp; DMSYML))
					fixsymbolic(node);
			} else if(!ISVALID(node)){
				/* this isn't a valid node, try cd'ing */
				if(changedir(node) == 0){
					node-&gt;d-&gt;qid.type = QTDIR;
					node-&gt;d-&gt;mode |= DMDIR;
				}else{
					node-&gt;d-&gt;qid.type = QTFILE;
					node-&gt;d-&gt;mode &amp;= ~DMDIR;
				}
			}
			goto Found;
		}
		if(i == 0 &amp;&amp; err == 0)
			err = "file does not exist";
	}

	/* clunk a newly cloned fid if the walk didn't succeed */
	if(nf != nil &amp;&amp; (err != nil || rhdr.nwqid&lt;nelems)){
		nf-&gt;busy = 0;
		nf-&gt;fid = 0;
	}

	/* if it all worked, point the fid to the enw node */
	if(err == nil)
		f-&gt;node = node;

	return err;
}

char *
ropen(Fid *f)
{
	int mode;

	mode = thdr.mode;
	if(f-&gt;node-&gt;d-&gt;qid.type &amp; QTDIR)
		if(mode != OREAD)
			return "permission denied";

	if(mode &amp; OTRUNC){
		uncache(f-&gt;node);
		uncache(f-&gt;node-&gt;parent);
		filedirty(f-&gt;node);
	} else {
		/* read the remote file or directory */
		if(!ISCACHED(f-&gt;node)){
			filefree(f-&gt;node);
			if(f-&gt;node-&gt;d-&gt;qid.type &amp; QTDIR){
				invalidate(f-&gt;node);
				if(readdir(f-&gt;node) &lt; 0)
					return nosuchfile;
			} else {
				if(readfile(f-&gt;node) &lt; 0)
					return errstring;
			}
			CACHED(f-&gt;node);
		}
	}

	rhdr.qid = f-&gt;node-&gt;d-&gt;qid;
	f-&gt;open = 1;
	f-&gt;node-&gt;opens++;
	return 0;
}

char*
rcreate(Fid *f)
{
	char *name;

	if((f-&gt;node-&gt;d-&gt;qid.type&amp;QTDIR) == 0)
		return "not a directory";

	name = thdr.name;
	f-&gt;node = extendpath(f-&gt;node, s_copy(name));
	uncache(f-&gt;node);
	if(thdr.perm &amp; DMDIR){
		if(createdir(f-&gt;node) &lt; 0)
			return "permission denied";
	} else
		filedirty(f-&gt;node);
	invalidate(f-&gt;node-&gt;parent);
	uncache(f-&gt;node-&gt;parent);

	rhdr.qid = f-&gt;node-&gt;d-&gt;qid;
	f-&gt;open = 1;
	f-&gt;node-&gt;opens++;
	return 0;
}

char*
rread(Fid *f)
{
	long off;
	int n, cnt, rv;
	Node *np;

	rhdr.count = 0;
	off = thdr.offset;
	cnt = thdr.count;
	if(cnt &gt; messagesize-IOHDRSZ)
		cnt = messagesize-IOHDRSZ;

	if(f-&gt;node-&gt;d-&gt;qid.type &amp; QTDIR){
		rv = 0;
		for(np = f-&gt;node-&gt;children; np != nil; np = np-&gt;sibs){
			if(!ISVALID(np))
				continue;
			if(off &lt;= BIT16SZ)
				break;
			n = convD2M(np-&gt;d, mbuf, messagesize-IOHDRSZ);
			off -= n;
		}
		for(; rv &lt; cnt &amp;&amp; np != nil; np = np-&gt;sibs){
			if(!ISVALID(np))
				continue;
			if(np-&gt;d-&gt;mode &amp; DMSYML)
				fixsymbolic(np);
			n = convD2M(np-&gt;d, mbuf + rv, cnt-rv);
			if(n &lt;= BIT16SZ)
				break;
			rv += n;
		}
	} else {
		/* reread file if it's fallen out of the cache */
		if(!ISCACHED(f-&gt;node))
			if(readfile(f-&gt;node) &lt; 0)
				return errstring;
		CACHED(f-&gt;node);
		rv = fileread(f-&gt;node, (char*)mbuf, off, cnt);
		if(rv &lt; 0)
			return errstring;
	}

	rhdr.data = (char*)mbuf;
	rhdr.count = rv;
	return 0;
}

char*
rwrite(Fid *f)
{
	long off;
	int cnt;

	if(f-&gt;node-&gt;d-&gt;qid.type &amp; QTDIR)
		return "directories are not writable";

	rhdr.count = 0;
	off = thdr.offset;
	cnt = thdr.count;
	cnt = filewrite(f-&gt;node, thdr.data, off, cnt);
	if(cnt &lt; 0)
		return errstring;
	filedirty(f-&gt;node);
	rhdr.count = cnt;
	return 0;
}

char *
rclunk(Fid *f)
{
	if(fileisdirty(f-&gt;node)){
		if(createfile(f-&gt;node) &lt; 0)
			fprint(2, "ftpfs: couldn't create %s\n", f-&gt;node-&gt;d-&gt;name);
		fileclean(f-&gt;node);
		uncache(f-&gt;node);
	}
	if(f-&gt;open){
		f-&gt;open = 0;
		f-&gt;node-&gt;opens--;
	}
	f-&gt;busy = 0;
	return 0;
}

/*
 *  remove is an implicit clunk
 */
char *
rremove(Fid *f)
{
	char *e;
	e = nil;
	if(QTDIR &amp; f-&gt;node-&gt;d-&gt;qid.type){
		if(removedir(f-&gt;node) &lt; 0)
			e = errstring;
	} else {
		if(removefile(f-&gt;node) &lt; 0)
			e = errstring;
	}
	uncache(f-&gt;node-&gt;parent);
	uncache(f-&gt;node);
	if(e == nil)
		INVALID(f-&gt;node);
	f-&gt;busy = 0;
	return e;
}

char *
rstat(Fid *f)
{
	Node *p;

	p = f-&gt;node-&gt;parent;
	if(!ISCACHED(p)){
		invalidate(p);
		readdir(p);
		CACHED(p);
	}
	if(!ISVALID(f-&gt;node))
		return nosuchfile;
	if(p-&gt;chdirunknown)
		fixsymbolic(f-&gt;node);
	rhdr.nstat = convD2M(f-&gt;node-&gt;d, mbuf, messagesize-IOHDRSZ);
	rhdr.stat = mbuf;
	return 0;
}

char *
rwstat(Fid *f)
{
	USED(f);
	return "wstat not implemented";
}

/*
 *  print message and die
 */
void
fatal(char *fmt, ...)
{
	va_list arg;
	char buf[8*1024];

	dying = 1;

	va_start(arg, fmt);
	vseprint(buf, buf + (sizeof(buf)-1) / sizeof(*buf), fmt, arg);
	va_end(arg);

	fprint(2, "ftpfs: %s\n", buf);
	if(kapid &gt; 0)
		postnote(PNGROUP, kapid, "die");
	exits(buf);
}

/*
 *  like strncpy but make sure there's a terminating null
 */
void*
safecpy(void *to, void *from, int n)
{
	char *a = ((char*)to) + n - 1;

	strncpy(to, from, n);
	*a = 0;
	return to;
}

/*
 *  set the error string
 */
int
seterr(char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	vsnprint(errstring, sizeof errstring, fmt, arg);
	va_end(arg);
	return -1;
}

/*
 *  create a new node
 */
Node*
newnode(Node *parent, String *name)
{
	Node *np;
	static ulong path;
	Dir d;

	np = mallocz(sizeof(Node), 1);
	if(np == 0)
		fatal("out of memory");

	np-&gt;children = 0;
	if(parent){
		np-&gt;parent = parent;
		np-&gt;sibs = parent-&gt;children;
		parent-&gt;children = np;
		np-&gt;depth = parent-&gt;depth + 1;
		d.dev = 0;		/* not stat'd */
	} else {
		/* the root node */
		np-&gt;parent = np;
		np-&gt;sibs = 0;
		np-&gt;depth = 0;
		d.dev = 1;
	}
	np-&gt;remname = name;
	d.name = s_to_c(name);
	d.atime = time(0);
	d.mtime = d.atime;
	d.uid = nouid;
	d.gid = nouid;
	d.muid = nouid;
	np-&gt;fp = 0;
	d.qid.path = ++path;
	d.qid.vers = 0;
	d.qid.type = QTFILE;
	d.type = 0;
	np-&gt;d = reallocdir(&amp;d, 0);

	return np;
}

/*
 *  walk one down the local mirror of the remote directory tree
 */
Node*
extendpath(Node *parent, String *elem)
{
	Node *np;

	for(np = parent-&gt;children; np; np = np-&gt;sibs)
		if(strcmp(s_to_c(np-&gt;remname), s_to_c(elem)) == 0){
			s_free(elem);
			return np;
		}

	return newnode(parent, elem);
}

/*
 *  flush the cached file, write it back if it's dirty
 */
void
uncache(Node *np)
{
	if(fileisdirty(np))
		createfile(np);
	filefree(np);
	UNCACHED(np);
}

/*
 *  invalidate all children of a node
 */
void
invalidate(Node *node)
{
	Node *np;

	if(node-&gt;opens)
		return;		/* don't invalidate something that's open */

	uncachedir(node, 0);

	/* invalidate children */
	for(np = node-&gt;children; np; np = np-&gt;sibs){
		if(np-&gt;opens)
			continue;	/* don't invalidate something that's open */
		UNCACHED(np);
		invalidate(np);
		np-&gt;d-&gt;dev = 0;
	}
}

/*
 *  make a top level tops-20 directory.  They are automaticly valid.
 */
Node*
newtopsdir(char *name)
{
	Node *np;

	np = extendpath(remroot, s_copy(name));
	if(!ISVALID(np)){
		np-&gt;d-&gt;qid.type = QTDIR;
		np-&gt;d-&gt;atime = time(0);
		np-&gt;d-&gt;mtime = np-&gt;d-&gt;atime;
		np-&gt;d-&gt;uid = "?uid?";
		np-&gt;d-&gt;gid = "?uid?";
		np-&gt;d-&gt;muid = "?uid?";
		np-&gt;d-&gt;mode = DMDIR|0777;
		np-&gt;d-&gt;length = 0;
		np-&gt;d = reallocdir(np-&gt;d, 1);
		
		if(changedir(np) &gt;= 0)
			VALID(np);
	}
	return np;
}

/*
 *  figure out if a symbolic link is to a directory or a file
 */
void
fixsymbolic(Node *node)
{
	if(changedir(node) == 0){
		node-&gt;d-&gt;mode |= DMDIR;
		node-&gt;d-&gt;qid.type = QTDIR;
	} else
		node-&gt;d-&gt;qid.type = QTFILE;
	node-&gt;d-&gt;mode &amp;= ~DMSYML; 
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

