<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/imagemap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/imagemap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "httpd.h"
#include "httpsrv.h"

typedef struct Point	Point;
typedef struct OkPoint	OkPoint;
typedef struct Strings	Strings;

struct Point 
{
	int	x;
	int	y;
};

struct OkPoint 
{
	Point	p;
	int	ok;
};

struct Strings
{
	char	*s1;
	char	*s2;
};

static	char *me;

int		polytest(int, Point, Point, Point);
Strings		getfield(char*);
OkPoint		pt(char*);
char*		translate(HConnect*, char*, char*);
Point		sub(Point, Point);
float		dist(Point, Point);

void
main(int argc, char **argv)
{
	HConnect *c;
	Hio *hout;
	char *dest;

	me = "imagemap";
	c = init(argc, argv);
	hout = &amp;c-&gt;hout;
	if(hparseheaders(c, HSTIMEOUT) &lt; 0)
		exits("failed");
	anonymous(c);

	if(strcmp(c-&gt;req.meth, "GET") != 0 &amp;&amp; strcmp(c-&gt;req.meth, "HEAD") != 0){
		hunallowed(c, "GET, HEAD");
		exits("unallowed");
	}
	if(c-&gt;head.expectother || c-&gt;head.expectcont){
		hfail(c, HExpectFail, nil);
		exits("failed");
	}
	dest = translate(c, c-&gt;req.uri, c-&gt;req.search);

	if(dest == nil){
		if(c-&gt;req.vermaj){
			hokheaders(c);
			hprint(hout, "Content-type: text/html\r\n");
			hprint(hout, "\r\n");
		}
		hprint(hout, "&lt;head&gt;&lt;title&gt;Nothing Found&lt;/title&gt;&lt;/head&gt;&lt;body&gt;\n");
		hprint(hout, "Nothing satisfying your search request could be found.\n&lt;/body&gt;\n");
		hflush(hout);
		writelog(c, "Reply: 200 imagemap %ld %ld\n", hout-&gt;seek, hout-&gt;seek);
		exits(nil);
	}

	if(http11(c) &amp;&amp; strcmp(c-&gt;req.meth, "POST") == 0)
		hredirected(c, "303 See Other", dest);
	else
		hredirected(c, "302 Found", dest);
	exits(nil);
}

char*
translate(HConnect *c, char *uri, char *search)
{
	Biobuf *b;
	Strings ss;
	OkPoint okp;
	Point p, cen, q, start;
	float close, d;
	char *line, *to, *def, *s, *dst;
	int n, inside, r, ncsa;

	if(search == nil){
		hfail(c, HNoData, me);
		exits("failed");
	}
	okp = pt(search);
	if(!okp.ok){
		hfail(c, HBadSearch, me);
		exits("failed");
	}
	p = okp.p;

	b = Bopen(uri, OREAD);
	if(b == nil){
		hfail(c, HNotFound, uri);
		exits("failed");
	}

	to = nil;
	def = nil;
	dst = nil;
	close = 0.;
	ncsa = 1;
	while(line = Brdline(b, '\n')){
		line[Blinelen(b)-1] = 0;

		ss = getfield(line);
		s = ss.s1;
		line = ss.s2;
		if(ncsa){
			ss = getfield(line);
			dst = ss.s1;
			line = ss.s2;
		}
		if(strcmp(s, "#cern") == 0){
			ncsa = 0;
			continue;
		}
		if(strcmp(s, "rect") == 0){
			ss = getfield(line);
			s = ss.s1;
			line = ss.s2;
			okp = pt(s);
			q = okp.p;
			if(!okp.ok || q.x &gt; p.x || q.y &gt; p.y)
				continue;
			ss = getfield(line);
			s = ss.s1;
			line = ss.s2;
			okp = pt(s);
			q = okp.p;
			if(!okp.ok || q.x &lt; p.x || q.y &lt; p.y)
				continue;
			if(!ncsa){
				ss = getfield(line);
				dst = ss.s1;
			}
			return dst;
		}else if(strcmp(s, "circle") == 0){
			ss = getfield(line);
			s = ss.s1;
			line = ss.s2;
			okp = pt(s);
			cen = okp.p;
			if(!okp.ok)
				continue;
			ss = getfield(line);
			s = ss.s1;
			line = ss.s2;
			if(ncsa){
				okp = pt(s);
				if(!okp.ok)
					continue;
				if(dist(okp.p, cen) &gt;= dist(p, cen))
					return dst;
			}else{
				r = strtol(s, nil, 10);
				ss = getfield(line);
				dst = ss.s1;
				d = (float)r * r;
				if(d &gt;= dist(p, cen))
					return dst;
			}
		}else if(strcmp(s, "poly") == 0){
			ss = getfield(line);
			s = ss.s1;
			line = ss.s2;
			okp = pt(s);
			start = okp.p;
			if(!okp.ok)
				continue;
			inside = 0;
			cen = start;
			for(n = 1; ; n++){
				ss = getfield(line);
				s = ss.s1;
				line = ss.s2;
				okp = pt(s);
				q = okp.p;
				if(!okp.ok)
					break;
				inside = polytest(inside, p, cen, q);
				cen = q;
			}
			inside = polytest(inside, p, cen, start);
			if(!ncsa)
				dst = s;
			if(n &gt;= 3 &amp;&amp; inside)
				return dst;
		}else if(strcmp(s, "point") == 0){
			ss = getfield(line);
			s = ss.s1;
			line = ss.s2;
			okp = pt(s);
			q = okp.p;
			if(!okp.ok)
				continue;
			d = dist(p, q);
			if(!ncsa){
				ss = getfield(line);
				dst = ss.s1;
			}
			if(d == 0.)
				return dst;
			if(close == 0. || d &lt; close){
				close = d;
				to = dst;
			}
		}else if(strcmp(s, "default") == 0){
			if(!ncsa){
				ss = getfield(line);
				dst = ss.s1;
			}
			def = dst;
		}
	}
	if(to == nil)
		to = def;
	return to;
}

int
polytest(int inside, Point p, Point b, Point a)
{
	Point pa, ba;

	if(b.y&gt;a.y){
		pa=sub(p, a);
		ba=sub(b, a);
	}else{
		pa=sub(p, b);
		ba=sub(a, b);
	}
	if(0&lt;=pa.y &amp;&amp; pa.y&lt;ba.y &amp;&amp; pa.y*ba.x&lt;=pa.x*ba.y)
		inside = !inside;
	return inside;
}

Point
sub(Point p, Point q)
{
	p.x -= q.x;
	p.y -= q.y;
	return p;
}

float
dist(Point p, Point q)
{
	p.x -= q.x;
	p.y -= q.y;
	return (float)p.x * p.x + (float)p.y * p.y;
}

OkPoint
pt(char *s)
{
	OkPoint okp;
	Point p;
	char *t, *e;

	if(*s == '(')
		s++;
	t = strchr(s, ')');
	if(t != nil)
		*t = 0;
	p.x = 0;
	p.y = 0;
	t = strchr(s, ',');
	if(t == nil){
		okp.p = p;
		okp.ok = 0;
		return okp;
	}
	e = nil;
	p.x = strtol(s, &amp;e, 10);
	if(e != t){
		okp.p = p;
		okp.ok = 0;
		return okp;
	}
	p.y = strtol(t+1, &amp;e, 10);
	if(e == nil || *e != 0){
		okp.p = p;
		okp.ok = 0;
		return okp;
	}
	okp.p = p;
	okp.ok = 1;
	return okp;
}

Strings
getfield(char *s)
{
	Strings ss;
	char *f;

	while(*s == '\t' || *s == ' ')
		s++;
	f = s;
	while(*s &amp;&amp; *s != '\t' &amp;&amp; *s != ' ')
		s++;
	if(*s)
		*s++ = 0;
	ss.s1 = f;
	ss.s2 = s;
	return ss;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

