<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/log.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/log.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "httpd.h"
#include "httpsrv.h"

int		logall[3];  /* logall[2] is in "Common Log Format" */

static char *
monname[12] =
{
	"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

void
logit(HConnect *c, char *fmt, ...)
{
	char buf[4096];
	va_list arg;
	HSPriv *p;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	p = nil;
	if(c != nil)
		p = c-&gt;private;
	if(p != nil &amp;&amp; p-&gt;remotesys != nil)
		syslog(0, HTTPLOG, "%s %s", p-&gt;remotesys, buf);
	else
		syslog(0, HTTPLOG, "%s", buf);
}

void
writelog(HConnect *c, char *fmt, ...)
{
	HSPriv *p;
	char buf[HBufSize+500], *bufp, *bufe;
	char statuscode[4];
	vlong objectsize;
	ulong now, today;
	int logfd;
	va_list arg;
	Tm *tm;

	if(c == nil)
		return;
	p = c-&gt;private;
	bufe = buf + sizeof(buf);
	now = time(nil);
	tm = gmtime(now);
	today = now / (24*60*60);

	/* verbose logfile, for research on web traffic */
	logfd = logall[today &amp; 1];
	if(logfd &gt; 0){
		if(c-&gt;hstop == c-&gt;header || c-&gt;hstop[-1] != '\n')
			*c-&gt;hstop = '\n';
		*c-&gt;hstop = '\0';
		bufp = seprint(buf, bufe, "==========\n");
		bufp = seprint(bufp, bufe, "LogTime:  %D\n", now);
		bufp = seprint(bufp, bufe, "ConnTime: %D\n", c-&gt;reqtime);
		bufp = seprint(bufp, bufe, "RemoteIP: %s\n", p-&gt;remotesys);
		bufp = seprint(bufp, bufe, "Port: %s\n", p-&gt;remoteserv);
		va_start(arg, fmt);
		bufp = vseprint(bufp, bufe, fmt, arg);
		va_end(arg);
		if(c-&gt;req.uri != nil &amp;&amp; c-&gt;req.uri[0] != 0)
			bufp = seprint(bufp, bufe, "FinalURI: %s\n", c-&gt;req.uri);
		bufp = seprint(bufp, bufe, "----------\n%s\n", (char*)c-&gt;header);
		write(logfd, buf, bufp-buf);   /* append-only file */
	}

	/* another log, with less information but formatted for common analysis tools */
	if(logall[2] &gt; 0 &amp;&amp; strncmp(fmt, "Reply: ", 7) == 0){
		objectsize = 0;
		strecpy(statuscode, statuscode+4, fmt+7);
		if( fmt[7] == '%'){
			va_start(arg, fmt);
			vseprint(statuscode, statuscode+4, fmt+7, arg);
			va_end(arg);
		}else if(
			strcmp(fmt+7, "200 file %lld %lld\n") == 0 ||
			strcmp(fmt+7, "206 partial content %lld %lld\n") == 0 ||
			strcmp(fmt+7, "206 partial content, early termination %lld %lld\n") == 0){
			va_start(arg, fmt);
			objectsize = va_arg(arg, vlong); /* length in sendfd.c */
			USED(objectsize);
			objectsize = va_arg(arg, vlong); /* wrote in sendfd.c */
			va_end(arg);
		}
		bufp = seprint(buf, bufe, "%s - -", p-&gt;remotesys);
		bufp = seprint(bufp, bufe, " [%.2d/%s/%d:%.2d:%.2d:%.2d +0000]", tm-&gt;mday, monname[tm-&gt;mon], tm-&gt;year+1900, tm-&gt;hour, tm-&gt;min, tm-&gt;sec);
		if(c-&gt;req.uri == nil || c-&gt;req.uri[0] == 0){
			bufp = seprint(bufp, bufe, " \"%.*s\"",
				(int)utfnlen((char*)c-&gt;header, strcspn((char*)c-&gt;header, "\r\n")),
				(char*)c-&gt;header);
		}else{
			/* use more canonical form of URI, if available */
			bufp = seprint(bufp, bufe, " \"%s %s HTTP/%d.%d\"", c-&gt;req.meth, c-&gt;req.uri, c-&gt;req.vermaj,  c-&gt;req.vermin);
		}
		bufp = seprint(bufp, bufe, " %s %lld\n", statuscode, objectsize);
		write(logall[2], buf, bufp-buf);   /* append-only file */
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

