<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/man2html.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/man2html.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "httpd.h"
#include "httpsrv.h"

static	Hio		*hout;
static	Hio		houtb;
static	HConnect	*connect;

void	doconvert(char*, int);

void
error(char *title, char *fmt, ...)
{
	va_list arg;
	char buf[1024], *out;

	va_start(arg, fmt);
	out = vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	*out = 0;

	hprint(hout, "%s 404 %s\n", hversion, title);
	hprint(hout, "Date: %D\n", time(nil));
	hprint(hout, "Server: Plan9\n");
	hprint(hout, "Content-type: text/html\n");
	hprint(hout, "\n");
	hprint(hout, "&lt;head&gt;&lt;title&gt;%s&lt;/title&gt;&lt;/head&gt;\n", title);
	hprint(hout, "&lt;body&gt;&lt;h1&gt;%s&lt;/h1&gt;&lt;/body&gt;\n", title);
	hprint(hout, "%s\n", buf);
	hflush(hout);
	writelog(connect, "Reply: 404\nReason: %s\n", title);
	exits(nil);
}

typedef struct Hit	Hit;
struct Hit 
{
	Hit *next;
	char *file;
};

void
lookup(char *object, int section, Hit **list)
{
	int fd;
	char *p, *f;
	Biobuf b;
	char file[256];
	Hit *h;

	while(*list != nil)
		list = &amp;(*list)-&gt;next;

	snprint(file, sizeof(file), "/sys/man/%d/INDEX", section);
	fd = open(file, OREAD);
	if(fd &gt; 0){
		Binit(&amp;b, fd, OREAD);
		for(;;){
			p = Brdline(&amp;b, '\n');
			if(p == nil)
				break;
			p[Blinelen(&amp;b)-1] = 0;
			f = strchr(p, ' ');
			if(f == nil)
				continue;
			*f++ = 0;
			if(strcmp(p, object) == 0){
				h = ezalloc(sizeof *h);
				*list = h;
				h-&gt;next = nil;
				snprint(file, sizeof(file), "/%d/%s", section, f);
				h-&gt;file = estrdup(file);
				close(fd);
				return;
			}
		}
		close(fd);
	}
	snprint(file, sizeof(file), "/sys/man/%d/%s", section, object);
	if(access(file, 0) == 0){
		h = ezalloc(sizeof *h);
		*list = h;
		h-&gt;next = nil;
		h-&gt;file = estrdup(file+8);
	}
}

void
manindex(int sect, int vermaj)
{
	int i;

	if(vermaj){
		hokheaders(connect);
		hprint(hout, "Content-type: text/html\r\n");
		hprint(hout, "\r\n");
	}

	hprint(hout, "&lt;head&gt;&lt;title&gt;plan 9 section index");
	if(sect)
		hprint(hout, "(%d)\n", sect);
	hprint(hout, "&lt;/title&gt;&lt;/head&gt;&lt;body&gt;\n");
	hprint(hout, "&lt;H6&gt;Section Index");
	if(sect)
		hprint(hout, "(%d)\n", sect);
	hprint(hout, "&lt;/H6&gt;\n");

	if(sect)
		hprint(hout, "&lt;p&gt;&lt;a href=\"/plan9/man%d.html\"&gt;/plan9/man%d.html&lt;/a&gt;\n",
			sect, sect);
	else for(i = 1; i &lt; 10; i++)
		hprint(hout, "&lt;p&gt;&lt;a href=\"/plan9/man%d.html\"&gt;/plan9/man%d.html&lt;/a&gt;\n",
			i, i);
	hprint(hout, "&lt;/body&gt;\n");
}

void
man(char *o, int sect, int vermaj)
{
	int i;
	Hit *list;

	list = nil;

	if(*o == 0){
		manindex(sect, vermaj);
		return;
	}

	if(sect &gt; 0 &amp;&amp; sect &lt; 10)
		lookup(o, sect, &amp;list);
	else
		for(i = 1; i &lt; 9; i++)
			lookup(o, i, &amp;list);

	if(list != nil &amp;&amp; list-&gt;next == nil){
		doconvert(list-&gt;file, vermaj);
		return;
	}

	if(vermaj){
		hokheaders(connect);
		hprint(hout, "Content-type: text/html\r\n");
		hprint(hout, "\r\n");
	}

	hprint(hout, "&lt;head&gt;&lt;title&gt;plan 9 man %H", o);
	if(sect)
		hprint(hout, "(%d)\n", sect);
	hprint(hout, "&lt;/title&gt;&lt;/head&gt;&lt;body&gt;\n");
	hprint(hout, "&lt;H6&gt;Search for %H", o);
	if(sect)
		hprint(hout, "(%d)\n", sect);
	hprint(hout, "&lt;/H6&gt;\n");

	for(; list; list = list-&gt;next)
		hprint(hout, "&lt;p&gt;&lt;a href=\"/magic/man2html%U\"&gt;/magic/man2html%H&lt;/a&gt;\n",
			list-&gt;file, list-&gt;file);
	hprint(hout, "&lt;/body&gt;\n");
}

void
strlwr(char *p)
{
	for(; *p; p++)
		if('A' &lt;= *p &amp;&amp; *p &lt;= 'Z')
			*p += 'a'-'A';
}

void
redirectto(char *uri)
{
	if(connect){
		hmoved(connect, uri);
		exits(0);
	}else
		hprint(hout, "Your selection moved to &lt;a href=\"%U\"&gt; here&lt;/a&gt;.&lt;p&gt;&lt;/body&gt;\r\n", uri);
}

void
searchfor(char *search)
{
	int i, j, n, fd;
	char *p, *sp;
	Biobufhdr *b;
	char *arg[32];

	hprint(hout, "&lt;head&gt;&lt;title&gt;plan 9 search for %H&lt;/title&gt;&lt;/head&gt;\n", search);
	hprint(hout, "&lt;body&gt;\n");

	hprint(hout, "&lt;p&gt;This is a keyword search through Plan 9 man pages.\n");
	hprint(hout, "The search is case insensitive; blanks denote \"boolean and\".\n");
	hprint(hout, "&lt;FORM METHOD=\"GET\" ACTION=\"/magic/man2html\"&gt;\n");
	hprint(hout, "&lt;INPUT NAME=\"pat\" TYPE=\"text\" SIZE=\"60\"&gt;\n");
	hprint(hout, "&lt;INPUT TYPE=\"submit\" VALUE=\"Submit\"&gt;\n");
	hprint(hout, "&lt;/FORM&gt;\n");

	hprint(hout, "&lt;hr&gt;&lt;H6&gt;Search for %H&lt;/H6&gt;\n", search);
	n = getfields(search, arg, 32, 1, "+");
	for(i = 0; i &lt; n; i++){
		for(j = i+1; j &lt; n; j++){
			if(strcmp(arg[i], arg[j]) &gt; 0){
				sp = arg[j];
				arg[j] = arg[i];
				arg[i] = sp;
			}
		}
		sp = malloc(strlen(arg[i]) + 2);
		if(sp != nil){
			strcpy(sp+1, arg[i]);
			sp[0] = ' ';
			arg[i] = sp;
		}
	}

	/*
	 *  search index till line starts alphabetically &lt; first token
	 */
	fd = open("/sys/man/searchindex", OREAD);
	if(fd &lt; 0){
		hprint(hout, "&lt;body&gt;error: No Plan 9 search index\n");
		hprint(hout, "&lt;/body&gt;");
		return;
	}
	p = malloc(32*1024);
	if(p == nil){
		close(fd);
		return;
	}
	b = ezalloc(sizeof *b);
	Binits(b, fd, OREAD, (uchar*)p, 32*1024);
	for(;;){
		p = Brdline(b, '\n');
		if(p == nil)
			break;
		p[Blinelen(b)-1] = 0;
		for(i = 0; i &lt; n; i++){
			sp = strstr(p, arg[i]);
			if(sp == nil)
				break;
			p = sp;
		}
		if(i &lt; n)
			continue;
		sp = strrchr(p, '\t');
		if(sp == nil)
			continue;
		sp++;
		hprint(hout, "&lt;p&gt;&lt;a href=\"/magic/man2html/%U\"&gt;/magic/man2html/%H&lt;/a&gt;\n",
			sp, sp);
	}
	hprint(hout, "&lt;/body&gt;");

	Bterm(b);
	free(b);
	free(p);
	close(fd);
}

/*
 *  find man pages mentioning the search string
 */
void
dosearch(int vermaj, char *search)
{
	int sect;
	char *p;

	if(strncmp(search, "man=", 4) == 0){
		sect = 0;
		search = hurlunesc(connect, search+4);
		p = strchr(search, '&amp;');
		if(p != nil){
			*p++ = 0;
			if(strncmp(p, "sect=", 5) == 0)
				sect = atoi(p+5);
		}
		man(search, sect, vermaj);
		return;
	}

	if(vermaj){
		hokheaders(connect);
		hprint(hout, "Content-type: text/html\r\n");
		hprint(hout, "\r\n");
	}

	if(strncmp(search, "pat=", 4) == 0){
		search = hurlunesc(connect, search+4);
		search = hlower(search);
		searchfor(search);
		return;
	}

	hprint(hout, "&lt;head&gt;&lt;title&gt;illegal search&lt;/title&gt;&lt;/head&gt;\n");
	hprint(hout, "&lt;body&gt;&lt;p&gt;Illegally formatted Plan 9 man page search&lt;/p&gt;\n");
	search = hurlunesc(connect, search);
	hprint(hout, "&lt;body&gt;&lt;p&gt;%H&lt;/p&gt;\n", search);
	hprint(hout, "&lt;/body&gt;");
}

/*
 *  convert a man page to html and output
 */
void
doconvert(char *uri, int vermaj)
{
	char *p;
	char file[256];
	char title[256];
	char err[ERRMAX];
	int pfd[2];
	Dir *d;
	Waitmsg *w;
	int x;

	if(strstr(uri, ".."))
		error("bad URI", "man page URI cannot contain ..");
	p = strstr(uri, "/intro");

	if(p == nil){
		while(*uri == '/')
			uri++;
		/* redirect section requests */
		snprint(file, sizeof(file), "/sys/man/%s", uri);
		d = dirstat(file);
		if(d == nil){
			strlwr(file);
			if(dirstat(file) != nil){
				snprint(file, sizeof(file), "/magic/man2html/%s", uri);
				strlwr(file);
				redirectto(file);
			}
			error(uri, "man page not found");
		}
		x = d-&gt;qid.type;
		free(d);
		if(x &amp; QTDIR){
			if(*uri == 0 || strcmp(uri, "/") == 0)
				redirectto("/sys/man/index.html");
			else {
				snprint(file, sizeof(file), "/sys/man/%s/INDEX.html",
					uri+1);
				redirectto(file);
			}
			return;
		}
	} else {
		/* rewrite the name intro */
		*p = 0;
		snprint(file, sizeof(file), "/sys/man/%s/0intro", uri);
		d = dirstat(file);
		free(d);
		if(d == nil)
			error(uri, "man page not found");
	}

	if(vermaj){
		hokheaders(connect);
		hprint(hout, "Content-type: text/html\r\n");
		hprint(hout, "\r\n");
	}
	hflush(hout);

	if(pipe(pfd) &lt; 0)
		error("out of resources", "pipe failed");

	/* troff -manhtml &lt;file&gt; | troff2html -t '' */
	switch(fork()){
	case -1:
		error("out of resources", "fork failed");
	case 0:
		snprint(title, sizeof(title), "Plan 9 %s", file);
		close(0);
		dup(pfd[0], 0);
		close(pfd[0]);
		close(pfd[1]);
		execl("/bin/troff2html", "troff2html", "-t", title, nil);
		errstr(err, sizeof err);
		exits(err);
	}
	switch(fork()){
	case -1:
		error("out of resources", "fork failed");
	case 0:
		snprint(title, sizeof(title), "Plan 9 %s", file);
		close(0);
		close(1);
		dup(pfd[1], 1);
		close(pfd[0]);
		close(pfd[1]);
		execl("/bin/troff", "troff", "-manhtml", file, nil);
		errstr(err, sizeof err);
		exits(err);
	}
	close(pfd[0]);
	close(pfd[1]);

	/* wait for completion */
	for(;;){
		w = wait();
		if(w == nil)
			break;
		if(w-&gt;msg[0] != 0)
			print("whoops %s\n", w-&gt;msg);
		free(w);
	}
}

void
main(int argc, char **argv)
{
	fmtinstall('H', httpfmt);
	fmtinstall('U', hurlfmt);

	if(argc == 2){
		hinit(&amp;houtb, 1, Hwrite);
		hout = &amp;houtb;
		doconvert(argv[1], 0);
		exits(nil);
	}
	close(2);

	connect = init(argc, argv);
	hout = &amp;connect-&gt;hout;
	if(hparseheaders(connect, HSTIMEOUT) &lt; 0)
		exits("failed");

	if(strcmp(connect-&gt;req.meth, "GET") != 0 &amp;&amp; strcmp(connect-&gt;req.meth, "HEAD") != 0){
		hunallowed(connect, "GET, HEAD");
		exits("not allowed");
	}
	if(connect-&gt;head.expectother || connect-&gt;head.expectcont){
		hfail(connect, HExpectFail, nil);
		exits("failed");
	}

	bind("/usr/web/sys/man", "/sys/man", MREPL);

	if(connect-&gt;req.search != nil)
		dosearch(connect-&gt;req.vermaj, connect-&gt;req.search);
	else
		doconvert(connect-&gt;req.uri, connect-&gt;req.vermaj);
	hflush(hout);
	writelog(connect, "200 man2html %ld %ld\n", hout-&gt;seek, hout-&gt;seek);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

