<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/netlib_find.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/netlib_find.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* invoked from /netlib/pub/search.html */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "httpd.h"
#include "httpsrv.h"

void bib_fmt(char*,char*);
void index_fmt(char*,char*);
void no_fmt(char*,char*);
int send(HConnect*);

Hio *hout;

/********** table of databases ************/

typedef struct DB	DB;
struct DB 
{
	int	SELECT;	/* value from search.html */
	char	*log;	/* abbreviation for logfile */
	int	maxhit;	/* maximum number of hits to return */
	char	*file;	/* searchfs database */
	void	(*fmt)(char*,char*); /* convert one record to HTML */
	char	*postlude;	/* trailer text */
};

DB db[] =
{
 {0, "netlib",	250, "/srv/netlib_DEFAULT", index_fmt,
	"&lt;HR&gt;&lt;A HREF=\"/netlib/master\"&gt;browse netlib&lt;/A&gt;&lt;/BODY&gt;\r\n"},
 {1, "BibNet",	250, "/srv/netlib_bibnet", bib_fmt,
	"&lt;HR&gt;&lt;A HREF=\"/netlib/bibnet\"&gt;browse BibNet&lt;/A&gt;&lt;/BODY&gt;\r\n"},
 {2, "compgeom",	250, "/srv/netlib_compgeom", no_fmt, "&lt;/BODY&gt;\r\n"},
 {3, "approx",	250, "/srv/netlib_approximation", no_fmt,
	"&lt;HR&gt;&lt;A HREF=\"/netlib/a/catalog.html.gz\"&gt;hierarchical catalog&lt;/A&gt;&lt;/BODY&gt;\r\n"},
 {4, "siam",	 50, "/srv/netlib_siam-Secret", no_fmt, "&lt;/BODY&gt;\r\n"},
 {-1,"",0,"",no_fmt,""}
};



/********** reformat database record as HTML ************/

void /* tr '\015' '\012' ("uncombline") */
no_fmt(char*s,char*e)
{
	/* s = start, e = (one past) end of database record */
	char *p;
	for(p = s; p&lt;e; p++)
		if(*p=='\r'){
			hwrite(hout, s,p-s);
			hprint(hout, "\n");
			s = p+1;
		}
}

int /* should the filename have .gz appended? */
suffix(char*filename)
{
	int n;
	char *z;

	if(!filename || *filename==0)
		return(0);
	n = strlen(filename);
	if(strncmp(".html",filename+n-5,5)==0)
		return(0);
	z = malloc(n+50);
	if(z == nil)
		return(0);
	strcpy(z,"/netlib/pub/");
	strcat(z,filename);
	strcat(z,".gz");
	if(access(z,4)==0){
		free(z);
		return(1);
	}
	free(z);
	return(0);
}

void /* add HREF to "file:" lines */
index_fmt(char*s,char*e)
{
	char *p, *filename;
	if(strncmp(s,"file",4)==0 &amp;&amp; (s[4]==' '||s[4]=='\t')){
		for(filename = s+4; strchr(" \t",*filename); filename++){}
		for(s = filename; *s &amp;&amp; strchr("\r\n",*s)==nil; s++){}
		*s++ = '\0';
		if(*s=='\n') s++;
		hprint(hout, "file:   &lt;A HREF=\"/netlib/%s",filename);
		if(suffix(filename))
			hprint(hout, ".gz");
		hprint(hout, "\"&gt;%s&lt;/A&gt;\r\n",filename);
		for(p = s; p&lt;e; p++)
			if(*p=='\r'){
				hwrite(hout, s,p-s);
				hprint(hout, "\n");
				s = p+1;
			}
	}else if(strncmp(s,"lib",3)==0 &amp;&amp; (s[3]==' '||s[3]=='\t')){
		for(filename = s+3; strchr(" \t",*filename); filename++){}
		for(s = filename; *s &amp;&amp; strchr("\r\n",*s)==nil; s++){}
		*s++ = '\0';
		if(*s=='\n') s++;
		hprint(hout, "lib:    &lt;A HREF=\"/netlib/%s",filename);
		hprint(hout, "\"&gt;%s&lt;/A&gt;\r\n",filename);
		for(p = s; p&lt;e; p++)
			if(*p=='\r'){
				hwrite(hout, s,p-s);
				hprint(hout, "\n");
				s = p+1;
			}
	}else{
		no_fmt(s,e);
	}
}

void /* add HREF to "URL" lines */
bib_fmt(char*s,char*e)
{
	char *p, *filename;
	for(p = s; p&lt;e; p++)
		if(*p=='\r'){
			hwrite(hout, s,p-s);
			hprint(hout, "\n");
			s = p+1;
			if(strncmp(s," URL =",6)==0 &amp;&amp;
					(filename = strchr(s+6,'"'))!=nil){
				filename++;
				for(s = filename; *s &amp;&amp; strchr("\"\r\n",*s)==nil; s++){}
				*s++ = '\0';
				p = s;
				hprint(hout, " URL =&lt;A HREF=\"%s\"&gt;%s&lt;/A&gt;",
					filename,filename);
			}
		}
}


/********** main() calls httpheadget() calls send() ************/

void
main(int argc, char **argv)
{
	HConnect *c;

	c = init(argc, argv);
	hout = &amp;c-&gt;hout;
	if(hparseheaders(c, HSTIMEOUT) &gt;= 0)
		send(c);
	exits(nil);
}

Biobuf Blist;

Biobuf*
init800fs(char*name,char*pat)
{
	int fd800fs, n;
	char*search;

	fd800fs = open(name, ORDWR);
	if(fd800fs &lt; 0)
		exits("can't connect to 800fs server");
	if(mount(fd800fs, -1, "/mnt", MREPL, "") &lt; 0)
		exits("can't mount /mnt");
	fd800fs = open("/mnt/search", ORDWR);
	n = strlen("search=")+strlen(pat)+1;
	search = ezalloc(n);
	strcpy(search,"search=");
	strcat(search,pat);
	write(fd800fs,search,n);
	free(search);
	Binit(&amp;Blist, fd800fs,OREAD);
	return(&amp;Blist);
}


static char *
hq(char *text)
{
	int textlen = strlen(text), escapedlen = textlen;
	char *escaped, *s, *w;

	for(s = text; *s; s++)
		if(*s=='&lt;' || *s=='&gt;' || *s=='&amp;')
			escapedlen += 4;
	escaped = ezalloc(escapedlen+1);
	for(s = text, w = escaped; *s; s++){
		if(*s == '&lt;'){
			strcpy(w, "&amp;lt;");
			w += 4;
		}else if(*s == '&gt;'){
			strcpy(w, "&amp;gt;");
			w += 4;
		}else if(*s == '&amp;'){
			strcpy(w, "&amp;amp;");
			w += 5;
		}else{
			*w++ = *s;
		}
	}
	return escaped;
}

int
send(HConnect *c)
{
	Biobuf*blist;
	int m, n, dbi, nmatch;
	char *pat, *s, *e;
	HSPairs *q;

	if(strcmp(c-&gt;req.meth, "GET") != 0 &amp;&amp; strcmp(c-&gt;req.meth, "HEAD") != 0)
		return hunallowed(c, "GET, HEAD");
	if(c-&gt;head.expectother || c-&gt;head.expectcont)
		return hfail(c, HExpectFail, nil);
	if(c-&gt;req.search == nil || !*c-&gt;req.search)
		return hfail(c, HNoData, "netlib_find");
	s = c-&gt;req.search;
	while((s = strchr(s, '+')) != nil)
		*s++ = ' ';
	dbi = -1;
	pat = nil;
	for(q = hparsequery(c, hstrdup(c, c-&gt;req.search)); q; q = q-&gt;next){
		if(strcmp(q-&gt;s, "db") == 0){
			m = atoi(q-&gt;t);
			for(dbi = 0; m!=db[dbi].SELECT; dbi++)
				if(db[dbi].SELECT&lt;0)
					exits("unrecognized db");
		}else if(strcmp(q-&gt;s, "pat") == 0){
			pat = q-&gt;t;
		}
	}
	if(dbi &lt; 0)
		exits("missing db field in query");
	if(pat == nil)
		exits("missing pat field in query");
	logit(c, "netlib_find %s %s", db[dbi].log,pat);

	blist = init800fs(db[dbi].file,pat);

	if(c-&gt;req.vermaj){
		hokheaders(c);
		hprint(hout, "Content-type: text/html\r\n");
		hprint(hout, "\r\n");
	}
	if(strcmp(c-&gt;req.meth, "HEAD") == 0){
		writelog(c, "Reply: 200 netlib_find 0\n");
		hflush(hout);
		exits(nil);
	}

	hprint(hout, "&lt;HEAD&gt;&lt;TITLE&gt;%s/%s&lt;/TITLE&gt;&lt;/HEAD&gt;\r\n&lt;BODY&gt;\r\n",
		db[dbi].log,hq(pat));
	nmatch = 0;

	while(s = Brdline(blist, '\n')){ /* get next database record */
		n = Blinelen(blist);
		e = s+n;
		hprint(hout, "&lt;PRE&gt;");
		(*db[dbi].fmt)(s,e);
		hprint(hout, "&lt;/PRE&gt;\r\n");
		if(nmatch++&gt;=db[dbi].maxhit){
			hprint(hout, "&lt;H4&gt;reached limit at %d hits&lt;/H4&gt;\n\r",nmatch);
			break;
		}
	}
	if(nmatch==0)
		hprint(hout, "&lt;H4&gt;Nothing Found.&lt;/H4&gt;\r\n");
	hprint(hout, db[dbi].postlude);
	hflush(hout);
	writelog(c, "Reply: 200 netlib_find %ld %ld\n", hout-&gt;seek, hout-&gt;seek);
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

