<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/netlib_history.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/netlib_history.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "httpd.h"
#include "httpsrv.h"

Hio *HO;
int diffb;

enum{ DAY = 24*60*60 };

void
lastbefore(ulong t, char *f, char *b)
{
	Tm *tm;
	Dir *dir;
	int try;
	ulong t0, mtime;

	t0 = t;
	for(try=0; try&lt;10; try++) {
		tm = localtime(t);
		t -= DAY;
		sprint(b,"%.4d/%.2d%.2d/netlib/pub/%s",tm-&gt;year+1900,tm-&gt;mon+1,tm-&gt;mday,f);
		dir = dirstat(b);
		if(dir == nil)
			continue;
		mtime = dir-&gt;mtime;
		free(dir);
		if(mtime &gt; t0)
			continue;
		return;
	}
	strcpy(b, "filenotfound");
}

// create explicit file for diff, which otherwise would create a
// mode 0600 file that it couldn't read (because running as none)
void
gunzip(char *f, char *tmp)
{
	int fd = open(tmp, OWRITE);

	if(fd &lt; 0)  // can't happen
		return;
	switch(fork()){
	case 0:
		dup(fd, 1);
		close(fd);
		close(0);
		execl("/bin/gunzip", "gunzip", "-c", f, nil);
		hprint(HO, "can't exec gunzip: %r\n");
		break;
	case -1:
		hprint(HO, "fork failed: %r\n");
	default:
		while(waitpid() != -1)
			;
		break;
	}
	close(fd);
}

void
netlibhistory(char *file)
{
	char buf[500], pair[2][500], tmpf[2][30], *f;
	int toggle = 0, started = 0, limit;
	Dir *dir;
	ulong otime, dt;
	int i, fd, tmpcnt;

	if(strncmp(file, "../", 3) == 0 || strstr(file, "/../") ||
		strlen(file) &gt;= sizeof(buf) - strlen("1997/0204/netlib/pub/0"))
		return;
	limit = 50;
	if(diffb){
		limit = 10;
		// create two tmp files for gunzip
		for(i = 0, tmpcnt = 0; i &lt; 2 &amp;&amp; tmpcnt &lt; 20; tmpcnt++){
			snprint(tmpf[i], sizeof(tmpf[0]), "/tmp/d%x", tmpcnt);
			if(access(buf, AEXIST) == 0)
				continue;
			fd = create(tmpf[i], OWRITE, 0666);
			if(fd &lt; 0)
				goto done;
			close(fd);
			i++;
		}
	}
	otime = time(0);
	hprint(HO,"&lt;UL&gt;\n");
	while(limit--){
		lastbefore(otime, file, buf);
		dir = dirstat(buf);
		if(dir == nil)
			goto done;
		dt = DAY/2;
		while(otime &lt;= dir-&gt;mtime){
			lastbefore(otime-dt, file, buf);
			free(dir);
			dir = dirstat(buf);
			if(dir == nil)
				goto done;
			dt += DAY/2;
		}
		f = pair[toggle];
		strcpy(f, buf);
		if(diffb &amp;&amp; strcmp(f+strlen(f)-3, ".gz") == 0){
			gunzip(f, tmpf[toggle]);
			strcpy(f, tmpf[toggle]);
		}
		if(diffb &amp;&amp; started){
			hprint(HO, "&lt;PRE&gt;\n");
			hflush(HO);
			switch(fork()){
			case 0:
				execl("/bin/diff", "diff", "-nb",
					pair[1-toggle], pair[toggle], nil);
				hprint(HO, "can't exec diff: %r\n");
				break;
			case -1:
				hprint(HO, "fork failed: %r\n");
				break;
			default:
				while(waitpid() != -1)
					;
				break;
			}
			hprint(HO, "&lt;/PRE&gt;\n");
		}
		hprint(HO,"&lt;LI&gt;&lt;A HREF=\"/historic/%s\"&gt;%s&lt;/A&gt; %lld bytes\n",
			buf, 4+asctime(gmtime(dir-&gt;mtime)), dir-&gt;length);
		if(diffb)
			hprint(HO," &lt;FONT SIZE=-1&gt;(%s)&lt;/FONT&gt;\n", pair[toggle]);
		toggle = 1-toggle;
		started = 1;
		otime = dir-&gt;mtime;
		free(dir);
	}
	hprint(HO,"&lt;LI&gt;...\n");
done:
	hprint(HO,"&lt;/UL&gt;\n");
	if(diffb){
		remove(tmpf[0]);
		remove(tmpf[1]);
	}
}

int
send(HConnect *c)
{
	char *file, *s;
	HSPairs *q;

	if(strcmp(c-&gt;req.meth, "GET") != 0 &amp;&amp; strcmp(c-&gt;req.meth, "HEAD") != 0)
		return hunallowed(c, "GET, HEAD");
	if(c-&gt;head.expectother || c-&gt;head.expectcont)
		return hfail(c, HExpectFail, nil);
	if(c-&gt;req.search == nil || !*c-&gt;req.search)
		return hfail(c, HNoData, "netlib_history");
	s = c-&gt;req.search;
	while((s = strchr(s, '+')) != nil)
		*s++ = ' ';
	file = nil;
	for(q = hparsequery(c, hstrdup(c, c-&gt;req.search)); q; q = q-&gt;next){
		if(strcmp(q-&gt;s, "file") == 0)
			file = q-&gt;t;
		else if(strcmp(q-&gt;s, "diff") == 0)
			diffb = 1;
	}
	if(file == nil)
		return hfail(c, HNoData, "netlib_history missing file field");
	logit(c, "netlib_hist %s%s", file, diffb?" DIFF":"");

	if(c-&gt;req.vermaj){
		hokheaders(c);
		hprint(HO, "Content-type: text/html\r\n");
		hprint(HO, "\r\n");
	}
	if(strcmp(c-&gt;req.meth, "HEAD") == 0){
		writelog(c, "Reply: 200 netlib_history 0\n");
		hflush(HO);
		exits(nil);
	}

	hprint(HO, "&lt;HEAD&gt;&lt;TITLE&gt;%s history&lt;/TITLE&gt;&lt;/HEAD&gt;\n&lt;BODY&gt;\n",file);
	hprint(HO, "&lt;H2&gt;%s history&lt;/H2&gt;\n",file);
	hprint(HO, "&lt;I&gt;Netlib's copy of %s was changed\n", file);
	hprint(HO, "on the dates shown.  &lt;BR&gt;Click on the date link\n");
	hprint(HO, "to retrieve the corresponding version.&lt;/I&gt;\n");
	if(diffb){
		hprint(HO, "&lt;BR&gt;&lt;I&gt;Lines beginning with &amp;lt; are for the\n");
		hprint(HO, "newer of the two versions.&lt;/I&gt;\n");
	}

	if(chdir("/usr/web/historic") &lt; 0)
		hprint(HO, "chdir failed: %r\n");
	netlibhistory(file);

	hprint(HO, "&lt;BR&gt;&lt;A HREF=\"http://cm.bell-labs.com/who/ehg\"&gt;Eric Grosse&lt;/A&gt;\n");
	hprint(HO, "&lt;/BODY&gt;&lt;/HTML&gt;\n");
	hflush(HO);
	writelog(c, "Reply: 200 netlib_history %ld %ld\n", HO-&gt;seek, HO-&gt;seek);
	return 1;
}

void
main(int argc, char **argv)
{
	HConnect *c;

	c = init(argc, argv);
	HO = &amp;c-&gt;hout;
	if(hparseheaders(c, HSTIMEOUT) &gt;= 0)
		send(c);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

