<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* contributed by 20h@r-36.net, September 2005 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include &lt;9p.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;

enum
{
	Blocksize = 64*1024,
	Stacksize = 8192,
};

char *host;
char *file;
char *port;
char *url;
char *get;
char *user;
char *net = "net";

vlong size;
int usetls;
int debug;
int ncache;
int mcache;

void
usage(void)
{
	fprint(2, "usage: httpfile [-Dd] [-c count] [-f file] [-m mtpt] [-s srvname] [-x net] url\n");
	exits("usage");
}

enum
{
	Qroot,
	Qfile,
};

#define PATH(type, n)		((type)|((n)&lt;&lt;8))
#define TYPE(path)			((int)(path) &amp; 0xFF)
#define NUM(path)			((uint)(path)&gt;&gt;8)

Channel *reqchan;
Channel *httpchan;
Channel *finishchan;
ulong time0;

typedef struct Block Block;
struct Block
{
	uchar *p;
	vlong off;
	vlong len;
	Block *link;
	long lastuse;
	Req *rq;
	Req **erq;
};

typedef struct Blocklist Blocklist;
struct Blocklist
{
	Block *first;
	Block **end;
};

Blocklist cache;
Blocklist inprogress;

void
queuereq(Block *b, Req *r)
{
	if(b-&gt;rq==nil)
		b-&gt;erq = &amp;b-&gt;rq;
	*b-&gt;erq = r;
	r-&gt;aux = nil;
	b-&gt;erq = (Req**)&amp;r-&gt;aux;
}

void
addblock(Blocklist *l, Block *b)
{
	if(debug)
		print("adding: %p %lld\n", b, b-&gt;off);

	if(l-&gt;first == nil)
		l-&gt;end = &amp;l-&gt;first;
	*l-&gt;end = b;
	b-&gt;link = nil;
	l-&gt;end = &amp;b-&gt;link;
	b-&gt;lastuse = time(0);
}

void
delreq(Block *b, Req *r)
{
	Req **l;

	for(l = &amp;b-&gt;rq; *l; l = (Req**)&amp;(*l)-&gt;aux){
		if(*l == r){
			*l = r-&gt;aux;
			if(*l == nil)
				b-&gt;erq = l;
			free(r);
			return;
		}
	}
}

void
evictblock(Blocklist *cache)
{
	Block **l, **oldest, *b;

	if(cache-&gt;first == nil)
		return;

	oldest = nil;
	for(l=&amp;cache-&gt;first; *l; l=&amp;(*l)-&gt;link)
		if(oldest == nil || (*oldest)-&gt;lastuse &gt; (*l)-&gt;lastuse)
			oldest = l;

	b = *oldest;
	*oldest = (*oldest)-&gt;link;
	if(*oldest == nil)
		cache-&gt;end = oldest;
	free(b-&gt;p);
	free(b);
	ncache--;
}

Block *
findblock(Blocklist *s, vlong off)
{
	Block *b;

	for(b = s-&gt;first; b != nil; b = b-&gt;link){
		if(b-&gt;off &lt;= off &amp;&amp; off &lt; b-&gt;off + Blocksize){
			if(debug)
				print("found: %lld -&gt; %lld\n", off, b-&gt;off);
			b-&gt;lastuse = time(0);
			return b;
		}
	}

	return nil;
}

void
readfrom(Req *r, Block *b)
{
	int d, n;

	b-&gt;lastuse = time(0);

	n = r-&gt;ifcall.count;
	d = r-&gt;ifcall.offset - b-&gt;off;
	if(b-&gt;off + d + n &gt; b-&gt;off + b-&gt;len)
		n = b-&gt;len - d;
	if(debug)
		print("Reading from: %p %d %d\n", b-&gt;p, d, n);
	memmove(r-&gt;ofcall.data, b-&gt;p + d, n);
	r-&gt;ofcall.count = n;

	respond(r, nil);
}

void
hangupclient(Srv*)
{
	if(debug)
		print("Hangup.\n");

	threadexitsall("done");
}

int
dotls(int fd)
{
	TLSconn conn;

	if((fd=tlsClient(fd, &amp;conn)) &lt; 0)
		sysfatal("tlsclient: %r");

	if(conn.cert != nil)
		free(conn.cert);

	return fd;
}

char*
nocr(char *s)
{
	char *r, *w;

	for(r=w=s; *r; r++)
		if(*r != '\r')
			*w++ = *r;
	*w = 0;
	return s;
}

char*
readhttphdr(Biobuf *netbio, vlong *size)
{
	char *s, *stat;

	stat = nil;
	while((s = Brdstr(netbio, '\n', 1)) != nil &amp;&amp; s[0] != '\r'
			&amp;&amp; s[0] != '\0'){
		if(stat == nil)
			stat = estrdup9p(s);
		if(strncmp(s, "Content-Length: ", 16) == 0 &amp;&amp; size != nil)
			*size = atoll(s + 16);
		free(s);
	}
	if(stat)
		nocr(stat);

	return stat;
}

int
dialhttp(Biobuf *netbio)
{
	int netfd;

	netfd = dial(netmkaddr(host, net, port), 0, 0, 0);
	if(netfd &lt; 0)
		sysfatal("dial: %r");
	if(usetls)
		netfd = dotls(netfd);
	Binit(netbio, netfd, OREAD);

	return netfd;
}

uchar*
getrange(Block *b)
{
	uchar *data;
	char *status;
	int netfd;
	static Biobuf netbio;

	b-&gt;len = Blocksize;
	if(b-&gt;off + b-&gt;len &gt; size)
		b-&gt;len = size - b-&gt;off;

	if(debug)
		print("getrange: %lld %lld\n", b-&gt;off, b-&gt;len);

	netfd = dialhttp(&amp;netbio);

	fprint(netfd, 
		"GET %s HTTP/1.1\r\n"
		"Host: %s\r\n"
		"Accept-Encoding:\r\n"
		"Range: bytes=%lld-%lld\r\n"
		"\r\n",
		get, host, b-&gt;off, b-&gt;off+b-&gt;len);
	Bflush(&amp;netbio);

	status = readhttphdr(&amp;netbio, nil);
	if(status == nil)
		return nil;

	/*
	 * Some servers (e.g., www.google.com) return 200 OK
	 * when you ask for the entire page in one range.
	 */
	if(strstr(status, "206 Partial Content")==nil
	&amp;&amp; (b-&gt;off!=0 || b-&gt;len!=size || strstr(status, "200 OK")==nil)){
		free(status);
		close(netfd);
		werrstr("did not get requested range");
		return nil;
	}
	free(status);

	data = emalloc9p(b-&gt;len);
	if(Bread(&amp;netbio, data, b-&gt;len) != b-&gt;len){
		free(data);
		close(netfd);
		werrstr("not enough bytes read");
		return nil;
	}

	b-&gt;p = data;

	close(netfd);
	return data;
}

void
httpfilereadproc(void*)
{
	Block *b;

	threadsetname("httpfilereadproc");

	for(;;){
		b = recvp(httpchan);
		if(b == nil)
			continue;
		if(getrange(b) == nil)
			sysfatal("getrange: %r");
		sendp(finishchan, b);
	}
}

typedef struct Tab Tab;
struct Tab
{
	char *name;
	ulong mode;
};

Tab tab[] =
{
	"/",		DMDIR|0555,
	nil,		0444,
};

static void
fillstat(Dir *d, uvlong path)
{
	Tab *t;

	memset(d, 0, sizeof(*d));
	d-&gt;uid = estrdup9p(user);
	d-&gt;gid = estrdup9p(user);
	d-&gt;qid.path = path;
	d-&gt;atime = d-&gt;mtime = time0;
	t = &amp;tab[TYPE(path)];
	d-&gt;name = estrdup9p(t-&gt;name);
	d-&gt;length = size;
	d-&gt;qid.type = t-&gt;mode&gt;&gt;24;
	d-&gt;mode = t-&gt;mode;
}

static void
fsattach(Req *r)
{
	if(r-&gt;ifcall.aname &amp;&amp; r-&gt;ifcall.aname[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;fid-&gt;qid.path = PATH(Qroot, 0);
	r-&gt;fid-&gt;qid.type = QTDIR;
	r-&gt;fid-&gt;qid.vers = 0;
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

static void
fsstat(Req *r)
{
	fillstat(&amp;r-&gt;d, r-&gt;fid-&gt;qid.path);
	respond(r, nil);
}

static int
rootgen(int i, Dir *d, void*)
{
	i += Qroot + 1;
	if(i &lt;= Qfile){
		fillstat(d, i);
		return 0;
	}
	return -1;
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	int i;
	ulong path;

	path = fid-&gt;qid.path;
	if(!(fid-&gt;qid.type &amp; QTDIR))
		return "walk in non-directory";

	if(strcmp(name, "..") == 0){
		switch(TYPE(path)){
		case Qroot:
			return nil;
		default:
			return "bug in fswalk1";
		}
	}

	i = TYPE(path) + 1;
	while(i &lt; nelem(tab)){
		if(strcmp(name, tab[i].name) == 0){
			qid-&gt;path = PATH(i, NUM(path));
			qid-&gt;type = tab[i].mode&gt;&gt;24;
			return nil;
		}
		if(tab[i].mode &amp; DMDIR)
			break;
		i++;
	}
	return "directory entry not found";
}

vlong
getfilesize(void)
{
	char *status;
	vlong size;
	int netfd;
	static Biobuf netbio;

	netfd = dialhttp(&amp;netbio);

	fprint(netfd, 
		"HEAD %s HTTP/1.1\r\n"
		"Host: %s\r\n"
		"Accept-Encoding:\r\n"
		"\r\n",
		get, host);

	status = readhttphdr(&amp;netbio, &amp;size);
	if(strstr(status, "200 OK") == nil){
		werrstr("%s", status);
		size = -1;
	}
	free(status);

	close(netfd);
	return size;
}

void
fileread(Req *r)
{
	Block *b;

	if(r-&gt;ifcall.offset &gt; size){
		respond(r, nil);
		return;
	}

	if((b = findblock(&amp;cache, r-&gt;ifcall.offset)) != nil){
		readfrom(r, b);
		return;
	}
	if((b = findblock(&amp;inprogress, r-&gt;ifcall.offset)) == nil){
		b = emalloc9p(sizeof(Block));
		b-&gt;off = r-&gt;ifcall.offset - (r-&gt;ifcall.offset % Blocksize);
		addblock(&amp;inprogress, b);
		if(inprogress.first == b)
			sendp(httpchan, b);
	}
	queuereq(b, r);
}

static void
fsopen(Req *r)
{
	if(r-&gt;ifcall.mode != OREAD){
		respond(r, "permission denied");
		return;
	}
	respond(r, nil);
}

void
finishthread(void*)
{
	Block *b;
	Req *r, *nextr;

	threadsetname("finishthread");

	for(;;){
		b = recvp(finishchan);
		assert(b == inprogress.first);
		inprogress.first = b-&gt;link;
		ncache++;
		if(ncache &gt;= mcache)
			evictblock(&amp;cache);
		addblock(&amp;cache, b);
		for(r=b-&gt;rq; r; r=nextr){
			nextr = r-&gt;aux;
			readfrom(r, b);
		}
		b-&gt;rq = nil;
		if(inprogress.first)
			sendp(httpchan, inprogress.first);
	}
}

void
fsnetproc(void*)
{
	Req *r;
	Block *b;

	threadcreate(finishthread, nil, 8192);

	threadsetname("fsnetproc");

	for(;;){
		r = recvp(reqchan);
		switch(r-&gt;ifcall.type){
		case Tflush:
			b = findblock(&amp;inprogress, r-&gt;ifcall.offset);
			delreq(b, r-&gt;oldreq);
			respond(r-&gt;oldreq, "interrupted");
			respond(r, nil);
			break;
		case Tread:
			fileread(r);
			break;
		default:
			respond(r, "bug in fsthread");
			break;
		}
	}
}

static void
fsflush(Req *r)
{
	sendp(reqchan, r);
}

static void
fsread(Req *r)
{
	char e[ERRMAX];
	ulong path;

	path = r-&gt;fid-&gt;qid.path;
	switch(TYPE(path)){
	case Qroot:
		dirread9p(r, rootgen, nil);
		respond(r, nil);
		break;
	case Qfile:
		sendp(reqchan, r);
		break;
	default:
		snprint(e, sizeof(e), "bug in fsread path=%lux", path);
		respond(r, e);
		break;
	}
}

Srv fs = 
{
.attach=		fsattach,
.walk1=		fswalk1,
.open=		fsopen,
.read=		fsread,
.stat=		fsstat,
.flush=		fsflush,
.end=		hangupclient,
};

void
threadmain(int argc, char **argv)
{
	char *defport, *mtpt, *srvname, *p;

	mtpt = nil;
	srvname = nil;
	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'd':
		debug++;
		break;
	case 's':
		srvname = EARGF(usage());
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	case 'c':
		mcache = atoi(EARGF(usage()));
		break;
	case 'f':
		file = EARGF(usage());
		break;
	case 'x':
		net = smprint("%s/net", EARGF(usage()));
		break;
	default:
		usage();
	}ARGEND;

	if(srvname == nil &amp;&amp; mtpt == nil)
		mtpt = ".";

	if(argc &lt; 1)
		usage();
	if(mcache &lt;= 0)
		mcache = 32;

	time0 = time(0);
	host = url = estrdup9p(argv[0]);

	defport = nil;
	if(!cistrncmp(url, "https://", 8)){
		host += 8;
		usetls = 1;
		defport = "https";
	}else if(!cistrncmp(url, "http://", 7)){
		host += 7;
		defport = "http";
	}else
		sysfatal("unsupported url: %s", url);

	if((p = strchr(host, '/')) != nil){
		get = estrdup9p(p);
		*p = '\0';
	}else
		get = "/";

	port = strchr(host, ':');
	if(port != nil)
		*port++ = '\0';
	else
		port = defport;

	if(file == nil){
		file = strrchr(get, '/')+1;
		if(*file == 0)
			file = "index";
	}

	tab[Qfile].name = file;
	user = getuser();
	size = getfilesize();
	if(size &lt; 0)
		sysfatal("getfilesize: %r");

	reqchan = chancreate(sizeof(Req*), 0);
	httpchan = chancreate(sizeof(Block*), 0);
	finishchan = chancreate(sizeof(Block*), 0);

	procrfork(fsnetproc, nil, Stacksize, RFNAMEG|RFNOTEG);
	procrfork(httpfilereadproc, nil, Stacksize, RFNAMEG|RFNOTEG);

	threadpostmountsrv(&amp;fs, srvname, mtpt, MBEFORE);
	threadexits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

