<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/date.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/date.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

char *
wdayname[7] =
{
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

char *
monname[12] =
{
	"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

static void	time2tm(Tm *tm, char *s);
static void	zone2tm(Tm *tm, char *s);
static int	dateindex(char *d, char **tab, int n);

int
rfc822date(char *s, int n, Tm *tm)
{
	char *plus;
	int m;

	plus = "+";
	if(tm-&gt;tzoff &lt; 0)
		plus = "";
	m = 0;
	if(0 &lt;= tm-&gt;wday &amp;&amp; tm-&gt;wday &lt; 7){
		m = snprint(s, n, "%s, ", wdayname[tm-&gt;wday]);
		if(m &lt; 0)
			return m;
	}
	return snprint(s+m, n-m, "%.2d %s %.4d %.2d:%.2d:%.2d %s%.4d",
		tm-&gt;mday, monname[tm-&gt;mon], tm-&gt;year+1900, tm-&gt;hour, tm-&gt;min, tm-&gt;sec,
		plus, (tm-&gt;tzoff/3600)*100 + (tm-&gt;tzoff/60)%60);
}

int
imap4date(char *s, int n, Tm *tm)
{
	char *plus;

	plus = "+";
	if(tm-&gt;tzoff &lt; 0)
		plus = "";
	return snprint(s, n, "%2d-%s-%.4d %2.2d:%2.2d:%2.2d %s%4.4d",
		tm-&gt;mday, monname[tm-&gt;mon], tm-&gt;year+1900, tm-&gt;hour, tm-&gt;min, tm-&gt;sec, plus, (tm-&gt;tzoff/3600)*100 + (tm-&gt;tzoff/60)%60);
}

int
imap4Date(Tm *tm, char *date)
{
	char *flds[4];

	if(getfields(date, flds, 3, 0, "-") != 3)
		return 0;

	tm-&gt;mday = strtol(flds[0], nil, 10);
	tm-&gt;mon = dateindex(flds[1], monname, 12);
	tm-&gt;year = strtol(flds[2], nil, 10) - 1900;
	return 1;
}

/*
 * parse imap4 dates
 */
ulong
imap4DateTime(char *date)
{
	Tm tm;
	char *flds[4], *sflds[4];
	ulong t;

	if(getfields(date, flds, 4, 0, " ") != 3)
		return ~0;

	if(!imap4Date(&amp;tm, flds[0]))
		return ~0;

	if(getfields(flds[1], sflds, 3, 0, ":") != 3)
		return ~0;

	tm.hour = strtol(sflds[0], nil, 10);
	tm.min = strtol(sflds[1], nil, 10);
	tm.sec = strtol(sflds[2], nil, 10);

	strcpy(tm.zone, "GMT");
	tm.yday = 0;
	t = tm2sec(&amp;tm);
	zone2tm(&amp;tm, flds[2]);
	t -= tm.tzoff;
	return t;
}

/*
 * parse dates of formats
 * [Wkd[,]] DD Mon YYYY HH:MM:SS zone
 * [Wkd] Mon ( D|DD) HH:MM:SS zone YYYY
 * plus anything similar
 * return nil for a failure
 */
Tm*
date2tm(Tm *tm, char *date)
{
	Tm gmt, *atm;
	char *flds[7], *s, dstr[64];
	int n;

	/*
	 * default date is Thu Jan  1 00:00:00 GMT 1970
	 */
	tm-&gt;wday = 4;
	tm-&gt;mday = 1;
	tm-&gt;mon = 1;
	tm-&gt;hour = 0;
	tm-&gt;min = 0;
	tm-&gt;sec = 0;
	tm-&gt;year = 70;
	strcpy(tm-&gt;zone, "GMT");
	tm-&gt;tzoff = 0;

	strncpy(dstr, date, sizeof(dstr));
	dstr[sizeof(dstr)-1] = '\0';
	n = tokenize(dstr, flds, 7);
	if(n != 6 &amp;&amp; n != 5)
		return nil;

	if(n == 5){
		for(n = 5; n &gt;= 1; n--)
			flds[n] = flds[n - 1];
		n = 5;
	}else{
		/*
		 * Wday[,]
		 */
		s = strchr(flds[0], ',');
		if(s != nil)
			*s = '\0';
		tm-&gt;wday = dateindex(flds[0], wdayname, 7);
		if(tm-&gt;wday &lt; 0)
			return nil;
	}

	/*
	 * check for the two major formats:
	 * Month first or day first
	 */
	tm-&gt;mon = dateindex(flds[1], monname, 12);
	if(tm-&gt;mon &gt;= 0){
		tm-&gt;mday = strtoul(flds[2], nil, 10);
		time2tm(tm, flds[3]);
		zone2tm(tm, flds[4]);
		tm-&gt;year = strtoul(flds[5], nil, 10);
		if(strlen(flds[5]) &gt; 2)
			tm-&gt;year -= 1900;
	}else{
		tm-&gt;mday = strtoul(flds[1], nil, 10);
		tm-&gt;mon = dateindex(flds[2], monname, 12);
		tm-&gt;year = strtoul(flds[3], nil, 10);
		if(strlen(flds[3]) &gt; 2)
			tm-&gt;year -= 1900;
		time2tm(tm, flds[4]);
		zone2tm(tm, flds[5]);
	}

	if(n == 5){
		gmt = *tm;
		strncpy(gmt.zone, "", 4);
		gmt.tzoff = 0;
		atm = gmtime(tm2sec(&amp;gmt));
		tm-&gt;wday = atm-&gt;wday;
	}else{
		/*
		 * Wday[,]
		 */
		s = strchr(flds[0], ',');
		if(s != nil)
			*s = '\0';
		tm-&gt;wday = dateindex(flds[0], wdayname, 7);
		if(tm-&gt;wday &lt; 0)
			return nil;
	}
	return tm;
}

/*
 * zone	: [A-Za-z][A-Za-z][A-Za-z]	some time zone names
 *	| [A-IK-Z]			military time; rfc1123 says the rfc822 spec is wrong.
 *	| "UT"				universal time
 *	| [+-][0-9][0-9][0-9][0-9]
 * zones is the rfc-822 list of time zone names
 */
static NamedInt zones[] =
{
	{"A",	-1 * 3600},
	{"B",	-2 * 3600},
	{"C",	-3 * 3600},
	{"CDT", -5 * 3600},
	{"CST", -6 * 3600},
	{"D",	-4 * 3600},
	{"E",	-5 * 3600},
	{"EDT", -4 * 3600},
	{"EST", -5 * 3600},
	{"F",	-6 * 3600},
	{"G",	-7 * 3600},
	{"GMT", 0},
	{"H",	-8 * 3600},
	{"I",	-9 * 3600},
	{"K",	-10 * 3600},
	{"L",	-11 * 3600},
	{"M",	-12 * 3600},
	{"MDT", -6 * 3600},
	{"MST", -7 * 3600},
	{"N",	+1 * 3600},
	{"O",	+2 * 3600},
	{"P",	+3 * 3600},
	{"PDT", -7 * 3600},
	{"PST", -8 * 3600},
	{"Q",	+4 * 3600},
	{"R",	+5 * 3600},
	{"S",	+6 * 3600},
	{"T",	+7 * 3600},
	{"U",	+8 * 3600},
	{"UT",	0},
	{"V",	+9 * 3600},
	{"W",	+10 * 3600},
	{"X",	+11 * 3600},
	{"Y",	+12 * 3600},
	{"Z",	0},
	{nil,	0}
};

static void
zone2tm(Tm *tm, char *s)
{
	Tm aux, *atm;
	int i;

	if(*s == '+' || *s == '-'){
		i = strtol(s, &amp;s, 10);
		tm-&gt;tzoff = (i / 100) * 3600 + i % 100;
		strncpy(tm-&gt;zone, "", 4);
		return;
	}

	/*
	 * look it up in the standard rfc822 table
	 */
	strncpy(tm-&gt;zone, s, 3);
	tm-&gt;zone[3] = '\0';
	tm-&gt;tzoff = 0;
	for(i = 0; zones[i].name != nil; i++){
		if(cistrcmp(zones[i].name, s) == 0){
			tm-&gt;tzoff = zones[i].v;
			return;
		}
	}

	/*
	 * one last try: look it up in the current local timezone
	 * probe a couple of times to get daylight/standard time change.
	 */
	aux = *tm;
	memset(aux.zone, 0, 4);
	aux.hour--;
	for(i = 0; i &lt; 2; i++){
		atm = localtime(tm2sec(&amp;aux));
		if(cistrcmp(tm-&gt;zone, atm-&gt;zone) == 0){
			tm-&gt;tzoff = atm-&gt;tzoff;
			return;
		}
		aux.hour++;
	}

	strncpy(tm-&gt;zone, "GMT", 4);
	tm-&gt;tzoff = 0;
}

/*
 * hh[:mm[:ss]]
 */
static void
time2tm(Tm *tm, char *s)
{
	tm-&gt;hour = strtoul(s, &amp;s, 10);
	if(*s++ != ':')
		return;
	tm-&gt;min = strtoul(s, &amp;s, 10);
	if(*s++ != ':')
		return;
	tm-&gt;sec = strtoul(s, &amp;s, 10);
}

static int
dateindex(char *d, char **tab, int n)
{
	int i;

	for(i = 0; i &lt; n; i++)
		if(cistrcmp(d, tab[i]) == 0)
			return i;
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

