<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/debug.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/debug.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;bio.h&gt;
#include "imap4d.h"

void
debuglog(char *fmt, ...)
{
	va_list arg;
	static int logfd;

	if(debug == 0)
		return;
	if(logfd == 0)
		logfd = open("/sys/log/imap4d", OWRITE);
	if(logfd &gt; 0){
		va_start(arg, fmt);
		fprint(logfd, "%s: ", username);
		vfprint(logfd, fmt, arg);
		va_end(arg);
	}
}

void
boxVerify(Box *box)
{
	Msg *m;
	ulong seq, uid, recent;

	if(box == nil)
		return;
	recent = 0;
	seq = 0;
	uid = 0;
	for(m = box-&gt;msgs; m != nil; m = m-&gt;next){
		if(m-&gt;seq == 0)
			fprint(2, "m-&gt;seq == 0: m-&gt;seq=%lud\n", m-&gt;seq);
		else if(m-&gt;seq &lt;= seq)
			fprint(2, "m-&gt;seq=%lud out of order: last=%lud\n", m-&gt;seq, seq);
		seq = m-&gt;seq;

		if(m-&gt;uid == 0)
			fprint(2, "m-&gt;uid == 0: m-&gt;seq=%lud\n", m-&gt;seq);
		else if(m-&gt;uid &lt;= uid)
			fprint(2, "m-&gt;uid=%lud out of order: last=%lud\n", m-&gt;uid, uid);
		uid = m-&gt;uid;

		if(m-&gt;flags &amp; MRecent)
			recent++;
	}
	if(seq != box-&gt;max)
		fprint(2, "max=%lud, should be %lud\n", box-&gt;max, seq);
	if(uid &gt;= box-&gt;uidnext)
		fprint(2, "uidnext=%lud, maxuid=%lud\n", box-&gt;uidnext, uid);
	if(recent != box-&gt;recent)
		fprint(2, "recent=%lud, should be %lud\n", box-&gt;recent, recent);
}

void
openfiles(void)
{
	Dir *d;
	int i;

	for(i = 0; i &lt; 20; i++){
		d = dirfstat(i);
		if(d != nil){
			fprint(2, "fd[%d]='%s' type=%c dev=%d user='%s group='%s'\n", i, d-&gt;name, d-&gt;type, d-&gt;dev, d-&gt;uid, d-&gt;gid);
			free(d);
		}
	}
}

void
ls(char *file)
{
	Dir *d;
	int fd, i, nd;

	fd = open(file, OREAD);
	if(fd &lt; 0)
		return;

	/*
	 * read box to find all messages
	 * each one has a directory, and is in numerical order
	 */
	d = dirfstat(fd);
	if(d == nil){
		close(fd);
		return;
	}
	if(!(d-&gt;mode &amp; DMDIR)){
		fprint(2, "file %s\n", file);
		free(d);
		close(fd);
		return;
	}
	free(d);
	while((nd = dirread(fd, &amp;d)) &gt; 0){
		for(i = 0; i &lt; nd; i++){
			fprint(2, "%s/%s %c\n", file, d[i].name, "-d"[(d[i].mode &amp; DMDIR) == DMDIR]);
		}
		free(d);
	}
	close(fd);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

