<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/imap4d.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/imap4d.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * mailbox and message representations
 *
 * these structures are allocated with emalloc and must be explicitly freed
 */
typedef struct Box	Box;
typedef struct Header	Header;
typedef struct MAddr	MAddr;
typedef struct MbLock	MbLock;
typedef struct MimeHdr	MimeHdr;
typedef struct Msg	Msg;
typedef struct NamedInt	NamedInt;
typedef struct Pair	Pair;

enum
{
	StrAlloc	= 32,		/* characters allocated at a time */
	BufSize		= 8*1024,	/* size of transfer block */
	NDigest		= 40,		/* length of digest string */
	NUid		= 10,		/* length of .imp uid string */
	NFlags		= 8,		/* length of .imp flag string */
	LockSecs	= 5 * 60,	/* seconds to wait for acquiring a locked file */
	MboxNameLen	= 256,		/* max. length of upas/fs mbox name */
	MsgNameLen	= 32,		/* max. length of a file in a upas/fs mbox */
	UserNameLen	= 64,		/* max. length of user's name */

	MUtf7Max	= 6,		/* max length for a modified utf7 character: &amp;bbbb- */

	/*
	 * message flags
	 */
	MSeen		= 1 &lt;&lt; 0,
	MAnswered	= 1 &lt;&lt; 1,
	MFlagged	= 1 &lt;&lt; 2,
	MDeleted	= 1 &lt;&lt; 3,
	MDraft		= 1 &lt;&lt; 4,
	MRecent		= 1 &lt;&lt; 5,

	/*
	 * message bogus flags
	 */
	NotBogus	= 0,	/* the message is displayable */
	BogusHeader	= 1,	/* the header had bad characters */
	BogusBody	= 2,	/* the body had bad characters */
	BogusTried	= 4,	/* attempted to open the fake message */
};

struct Box
{
	char	*name;		/* path name of mailbox */
	char	*fs;		/* fs name of mailbox */
	char	*fsDir;		/* /mail/fs/box-&gt;fs */
	char	*imp;		/* path name of .imp file */
	uchar	writable;	/* can write back messages? */
	uchar	dirtyImp;	/* .imp file needs to be written? */
	uchar	sendFlags;	/* need flags update */
	Qid	qid;		/* qid of fs mailbox */
	Qid	impQid;		/* qid of .imp when last synched */
	long	mtime;		/* file mtime when last read */
	ulong	max;		/* maximum msgs-&gt;seq, same as number of messages */
	ulong	toldMax;	/* last value sent to client */
	ulong	recent;		/* number of recently received messaged */
	ulong	toldRecent;	/* last value sent to client */
	ulong	uidnext;	/* next uid value assigned to a message */
	ulong	uidvalidity;	/* uid of mailbox */
	Msg	*msgs;
};

/*
 * fields of Msg-&gt;info
 */
enum
{
	/*
	 * read from upasfs
	 */
	IFrom,
	ITo,
	ICc,
	IReplyTo,
	IUnixDate,
	ISubject,
	IType,
	IDisposition,
	IFilename,
	IDigest,
	IBcc,
	IInReplyTo,	/* aka internal date */
	IDate,
	ISender,
	IMessageId,
	ILines,		/* number of lines of raw body */

	IMax
};

struct Header
{
	char	*buf;		/* header, including terminating \r\n */
	ulong	size;		/* strlen(buf) */
	ulong	lines;		/* number of \n characters in buf */

	/*
	 * pre-parsed mime headers
	 */
	MimeHdr	*type;		/* content-type */
	MimeHdr	*id;		/* content-id */
	MimeHdr	*description;	/* content-description */
	MimeHdr	*encoding;	/* content-transfer-encoding */
	MimeHdr	*md5;		/* content-md5 */
	MimeHdr	*disposition;	/* content-disposition */
	MimeHdr	*language;	/* content-language */
};

struct Msg
{
	Msg	*next;
	Msg	*prev;
	Msg	*kids;
	Msg	*parent;
	char	*fsDir;		/* box-&gt;fsDir of enclosing message */
	Header	head;		/* message header */
	Header	mime;		/* mime header from enclosing multipart spec */
	int	flags;
	uchar	sendFlags;	/* flags value needs to be sent to client */
	uchar	expunged;	/* message actually expunged, but not yet reported to client */
	uchar	matched;	/* search succeeded? */
	uchar	bogus;		/* implies the message is invalid, ie contains nulls; see flags above */
	ulong	uid;		/* imap unique identifier */
	ulong	seq;		/* position in box; 1 is oldest */
	ulong	id;		/* number of message directory in upas/fs */
	char	*fs;		/* name of message directory */
	char	*efs;		/* pointer after / in fs; enough space for file name */

	ulong	size;		/* size of fs/rawbody, in bytes, with \r added before \n */
	ulong	lines;		/* number of lines in rawbody */

	char	*iBuf;
	char	*info[IMax];	/* all info about message */

	char	*unixDate;
	MAddr	*unixFrom;

	MAddr	*to;		/* parsed out address lines */
	MAddr	*from;
	MAddr	*replyTo;
	MAddr	*sender;
	MAddr	*cc;
	MAddr	*bcc;
};

/*
 * pre-parsed header lines
 */
struct MAddr
{
	char	*personal;
	char	*box;
	char	*host;
	MAddr	*next;
};

struct MimeHdr
{
	char	*s;
	char	*t;
	MimeHdr	*next;
};

/*
 * mapping of integer &amp; names
 */
struct NamedInt
{
	char	*name;
	int	v;
};

/*
 * lock for all mail file operations
 */
struct MbLock
{
	int	fd;
};

/*
 * parse nodes for imap4rev1 protocol
 *
 * important: all of these items are allocated
 * in one can, so they can be tossed out at the same time.
 * this allows leakless parse error recovery by simply tossing the can away.
 * however, it means these structures cannot be mixed with the mailbox structures
 */

typedef struct Fetch	Fetch;
typedef struct NList	NList;
typedef struct SList	SList;
typedef struct MsgSet	MsgSet;
typedef struct Store	Store;
typedef struct Search	Search;

/*
 * parse tree for fetch command
 */
enum
{
	FEnvelope,
	FFlags,
	FInternalDate,
	FRfc822,
	FRfc822Head,
	FRfc822Size,
	FRfc822Text,
	FBodyStruct,
	FUid,
	FBody,			/* BODY */
	FBodySect,		/* BODY [...] */
	FBodyPeek,

	FMax
};

enum
{
	FPAll,
	FPHead,
	FPHeadFields,
	FPHeadFieldsNot,
	FPMime,
	FPText,

	FPMax
};

struct Fetch
{
	uchar	op;		/* F.* operator */
	uchar	part;		/* FP.* subpart for body[] &amp; body.peek[]*/
	uchar	partial;	/* partial fetch? */
	long	start;		/* partial fetch amounts */
	long	size;
	NList	*sect;
	SList	*hdrs;
	Fetch	*next;
};

/*
 * status items
 */
enum{
	SMessages	= 1 &lt;&lt; 0,
	SRecent		= 1 &lt;&lt; 1,
	SUidNext	= 1 &lt;&lt; 2,
	SUidValidity	= 1 &lt;&lt; 3,
	SUnseen		= 1 &lt;&lt; 4,
};

/*
 * parse tree for store command
 */
enum
{
	STFlags,
	STFlagsSilent,

	STMax
};

struct Store
{
	uchar	sign;
	uchar	op;
	int	flags;
};

/*
 * parse tree for search command
 */
enum
{
	SKNone,

	SKCharset,

	SKAll,
	SKAnswered,
	SKBcc,
	SKBefore,
	SKBody,
	SKCc,
	SKDeleted,
	SKDraft,
	SKFlagged,
	SKFrom,
	SKHeader,
	SKKeyword,
	SKLarger,
	SKNew,
	SKNot,
	SKOld,
	SKOn,
	SKOr,
	SKRecent,
	SKSeen,
	SKSentBefore,
	SKSentOn,
	SKSentSince,
	SKSet,
	SKSince,
	SKSmaller,
	SKSubject,
	SKText,
	SKTo,
	SKUid,
	SKUnanswered,
	SKUndeleted,
	SKUndraft,
	SKUnflagged,
	SKUnkeyword,
	SKUnseen,

	SKMax
};

struct Search
{
	int	key;
	char	*s;
	char	*hdr;
	ulong	num;
	int	year;
	int	mon;
	int	mday;
	MsgSet	*set;
	Search	*left;
	Search	*right;
	Search	*next;
};

struct NList
{
	ulong	n;
	NList	*next;
};

struct SList
{
	char	*s;
	SList	*next;
};

struct MsgSet
{
	ulong	from;
	ulong	to;
	MsgSet	*next;
};

struct Pair
{
	ulong	start;
	ulong	stop;
};

#include "bin.h"

extern	Bin	*parseBin;
extern	Biobuf	bout;
extern	Biobuf	bin;
extern	char	username[UserNameLen];
extern	char	mboxDir[MboxNameLen];
extern	char	*fetchPartNames[FPMax];
extern	char	*site;
extern	char	*remote;
extern	int	debug;

#include "fns.h"
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

