<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/list.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/list.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

#define SUBSCRIBED	"imap.subscribed"

static int	matches(char *ref, char *pat, char *name);
static int	mayMatch(char *pat, char *name, int star);
static int	checkMatch(char *cmd, char *ref, char *pat, char *mbox, long mtime, int isdir);
static int	listAll(char *cmd, char *ref, char *pat, char *mbox, long mtime);
static int	listMatch(char *cmd, char *ref, char *pat, char *mbox, char *mm);
static int	mkSubscribed(void);

static long
listMtime(char *file)
{
	Dir *d;
	long mtime;

	d = cdDirstat(mboxDir, file);
	if(d == nil)
		return 0;
	mtime = d-&gt;mtime;
	free(d);
	return mtime;
}

/*
 * check for subscribed mailboxes
 * each line is either a comment starting with #
 * or is a subscribed mailbox name
 */
int
lsubBoxes(char *cmd, char *ref, char *pat)
{
	MbLock *mb;
	Dir *d;
	Biobuf bin;
	char *s;
	long mtime;
	int fd, ok, isdir;

	mb = mbLock();
	if(mb == nil)
		return 0;
	fd = cdOpen(mboxDir, SUBSCRIBED, OREAD);
	if(fd &lt; 0)
		fd = mkSubscribed();
	if(fd &lt; 0){
		mbUnlock(mb);
		return 0;
	}
	ok = 0;
	Binit(&amp;bin, fd, OREAD);
	while(s = Brdline(&amp;bin, '\n')){
		s[Blinelen(&amp;bin) - 1] = '\0';
		if(s[0] == '#')
			continue;
		isdir = 1;
		if(cistrcmp(s, "INBOX") == 0){
			if(access("msgs", AEXIST) == 0)
				mtime = listMtime("msgs");
			else
				mtime = listMtime("mbox");
			isdir = 0;
		}else{
			d = cdDirstat(mboxDir, s);
			if(d != nil){
				mtime = d-&gt;mtime;
				if(!(d-&gt;mode &amp; DMDIR))
					isdir = 0;
				free(d);
			}else
				mtime = 0;
		}
		ok |= checkMatch(cmd, ref, pat, s, mtime, isdir);
	}
	Bterm(&amp;bin);
	close(fd);
	mbUnlock(mb);
	return ok;
}

static int
mkSubscribed(void)
{
	int fd;

	fd = cdCreate(mboxDir, SUBSCRIBED, ORDWR, 0664);
	if(fd &lt; 0)
		return -1;
	fprint(fd, "#imap4 subscription list\nINBOX\n");
	seek(fd, 0, 0);
	return fd;
}

/*
 * either subscribe or unsubscribe to a mailbox
 */
int
subscribe(char *mbox, int how)
{
	MbLock *mb;
	char *s, *in, *ein;
	int fd, tfd, ok, nmbox;

	if(cistrcmp(mbox, "inbox") == 0)
		mbox = "INBOX";
	mb = mbLock();
	if(mb == nil)
		return 0;
	fd = cdOpen(mboxDir, SUBSCRIBED, ORDWR);
	if(fd &lt; 0)
		fd = mkSubscribed();
	if(fd &lt; 0){
		mbUnlock(mb);
		return 0;
	}
	in = readFile(fd);
	if(in == nil){
		mbUnlock(mb);
		return 0;
	}
	nmbox = strlen(mbox);
	s = strstr(in, mbox);
	while(s != nil &amp;&amp; (s != in &amp;&amp; s[-1] != '\n' || s[nmbox] != '\n'))
		s = strstr(s+1, mbox);
	ok = 0;
	if(how == 's' &amp;&amp; s == nil){
		if(fprint(fd, "%s\n", mbox) &gt; 0)
			ok = 1;
	}else if(how == 'u' &amp;&amp; s != nil){
		ein = strchr(s, '\0');
		memmove(s, &amp;s[nmbox+1], ein - &amp;s[nmbox+1]);
		ein -= nmbox+1;
		tfd = cdOpen(mboxDir, SUBSCRIBED, OWRITE|OTRUNC);
		if(tfd &gt;= 0 &amp;&amp; seek(fd, 0, 0) &gt;= 0 &amp;&amp; write(fd, in, ein-in) == ein-in)
			ok = 1;
		if(tfd &gt; 0)
			close(tfd);
	}else
		ok = 1;
	close(fd);
	mbUnlock(mb);
	return ok;
}

/*
 * stupidly complicated so that % doesn't read entire directory structure
 * yet * works
 * note: in most places, inbox is case-insensitive,
 * but here INBOX is checked for a case-sensitve match.
 */
int
listBoxes(char *cmd, char *ref, char *pat)
{
	int ok;

	ok = checkMatch(cmd, ref, pat, "INBOX", listMtime("mbox"), 0);
	return ok | listMatch(cmd, ref, pat, ref, pat);
}

/*
 * look for all messages which may match the pattern
 * punt when a * is reached
 */
static int
listMatch(char *cmd, char *ref, char *pat, char *mbox, char *mm)
{
	Dir *dir, *dirs;
	char *mdir, *m, *mb, *wc;
	long mode;
	int c, i, nmb, nmdir, nd, ok, fd;

	mdir = nil;
	for(m = mm; c = *m; m++){
		if(c == '%' || c == '*'){
			if(mdir == nil){
				fd = cdOpen(mboxDir, ".", OREAD);
				if(fd &lt; 0)
					return 0;
				mbox = "";
				nmdir = 0;
			}else{
				*mdir = '\0';
				fd = cdOpen(mboxDir, mbox, OREAD);
				*mdir = '/';
				nmdir = mdir - mbox + 1;
				if(fd &lt; 0)
					return 0;
				dir = dirfstat(fd);
				if(dir == nil){
					close(fd);
					return 0;
				}
				mode = dir-&gt;mode;
				free(dir);
				if(!(mode &amp; DMDIR))
					break;
			}
			wc = m;
			for(; c = *m; m++)
				if(c == '/')
					break;
			nmb = nmdir + strlen(m) + MboxNameLen + 3;
			mb = emalloc(nmb);
			strncpy(mb, mbox, nmdir);
			ok = 0;
			while((nd = dirread(fd, &amp;dirs)) &gt; 0){
				for(i = 0; i &lt; nd; i++){
					if(strcmp(mbox, "") == 0 &amp;&amp;
					    !okMbox(dirs[i].name))
						continue;
					/* Safety: ignore message dirs */
					if(strstr(dirs[i].name, "mails") != 0 ||
					   strcmp(dirs[i].name, "out") == 0 ||
					   strcmp(dirs[i].name, "obox") == 0 ||
					   strcmp(dirs[i].name, "ombox") == 0)
						continue;
					if(strcmp(dirs[i].name, "msgs") == 0)
						dirs[i].mode &amp;= ~DMDIR;
					if(*wc == '*' &amp;&amp; dirs[i].mode &amp; DMDIR &amp;&amp;
					    mayMatch(mm, dirs[i].name, 1)){
						snprint(mb+nmdir, nmb-nmdir,
							"%s", dirs[i].name);
						ok |= listAll(cmd, ref, pat, mb,
							dirs[i].mtime);
					}else if(mayMatch(mm, dirs[i].name, 0)){
						snprint(mb+nmdir, nmb-nmdir,
							"%s%s", dirs[i].name, m);
						if(*m == '\0')
							ok |= checkMatch(cmd,
								ref, pat, mb,
								dirs[i].mtime,
								dirs[i].mode &amp;
								DMDIR);
						else if(dirs[i].mode &amp; DMDIR)
							ok |= listMatch(cmd,
								ref, pat, mb, mb
								+ nmdir + strlen(
								dirs[i].name));
					}
				}
				free(dirs);
			}
			close(fd);
			free(mb);
			return ok;
		}
		if(c == '/'){
			mdir = m;
			mm = m + 1;
		}
	}
	m = mbox;
	if(*mbox == '\0')
		m = ".";
	dir = cdDirstat(mboxDir, m);
	if(dir == nil)
		return 0;
	ok = checkMatch(cmd, ref, pat, mbox, dir-&gt;mtime, (dir-&gt;mode &amp; DMDIR) == DMDIR);
	free(dir);
	return ok;
}

/*
 * too hard: recursively list all files rooted at mbox,
 * and list checkMatch figure it out
 */
static int
listAll(char *cmd, char *ref, char *pat, char *mbox, long mtime)
{
	Dir *dirs;
	char *mb;
	int i, nmb, nd, ok, fd;

	ok = checkMatch(cmd, ref, pat, mbox, mtime, 1);
	fd = cdOpen(mboxDir, mbox, OREAD);
	if(fd &lt; 0)
		return ok;

	nmb = strlen(mbox) + MboxNameLen + 2;
	mb = emalloc(nmb);
	while((nd = dirread(fd, &amp;dirs)) &gt; 0){
		for(i = 0; i &lt; nd; i++){
			snprint(mb, nmb, "%s/%s", mbox, dirs[i].name);
			/* safety: do not recurr */
			if(0 &amp;&amp; dirs[i].mode &amp; DMDIR)
				ok |= listAll(cmd, ref, pat, mb, dirs[i].mtime);
			else
				ok |= checkMatch(cmd, ref, pat, mb, dirs[i].mtime, 0);
		}
		free(dirs);
	}
	close(fd);
	free(mb);
	return ok;
}

static int
mayMatch(char *pat, char *name, int star)
{
	Rune r;
	int i, n;

	for(; *pat &amp;&amp; *pat != '/'; pat += n){
		r = *(uchar*)pat;
		if(r &lt; Runeself)
			n = 1;
		else
			n = chartorune(&amp;r, pat);

		if(r == '*' || r == '%'){
			pat += n;
			if(r == '*' &amp;&amp; star || *pat == '\0' || *pat == '/')
				return 1;
			while(*name){
				if(mayMatch(pat, name, star))
					return 1;
				name += chartorune(&amp;r, name);
			}
			return 0;
		}
		for(i = 0; i &lt; n; i++)
			if(name[i] != pat[i])
				return 0;
		name += n;
	}
	if(*name == '\0')
		return 1;
	return 0;
}

/*
 * mbox is a mailbox name which might match pat.
 * verify the match
 * generates response
 */
static int
checkMatch(char *cmd, char *ref, char *pat, char *mbox, long mtime, int isdir)
{
	char *s, *flags;

	if(!matches(ref, pat, mbox) || !okMbox(mbox))
		return 0;
	if(strcmp(mbox, ".") == 0)
		mbox = "";

	if(isdir)
		flags = "(\\Noselect)";
	else{
		s = impName(mbox);
		if(s != nil &amp;&amp; listMtime(s) &lt; mtime)
			flags = "(\\Noinferiors \\Marked)";
		else
			flags = "(\\Noinferiors)";
	}

	s = strmutf7(mbox);
	if(s != nil)
		Bprint(&amp;bout, "* %s %s \"/\" \"%s\"\r\n", cmd, flags, s);
	return 1;
}

static int
matches(char *ref, char *pat, char *name)
{
	Rune r;
	int i, n;

	while(ref != pat)
		if(*name++ != *ref++)
			return 0;
	for(; *pat; pat += n){
		r = *(uchar*)pat;
		if(r &lt; Runeself)
			n = 1;
		else
			n = chartorune(&amp;r, pat);

		if(r == '*'){
			pat += n;
			if(*pat == '\0')
				return 1;
			while(*name){
				if(matches(pat, pat, name))
					return 1;
				name += chartorune(&amp;r, name);
			}
			return 0;
		}
		if(r == '%'){
			pat += n;
			while(*name &amp;&amp; *name != '/'){
				if(matches(pat, pat, name))
					return 1;
				name += chartorune(&amp;r, name);
			}
			pat -= n;
			continue;
		}
		for(i = 0; i &lt; n; i++)
			if(name[i] != pat[i])
				return 0;
		name += n;
	}
	if(*name == '\0')
		return 1;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

