<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/nodes.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/nodes.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

/*
 * iterated over all of the items in the message set.
 * errors are accumulated, but processing continues.
 * if uids, then ignore non-existent messages.
 * otherwise, that's an error
 */
int
forMsgs(Box *box, MsgSet *ms, ulong max, int uids, int (*f)(Box*, Msg*, int, void*), void *rock)
{
	Msg *m;
	ulong id;
	int ok, rok;

	ok = 1;
	for(; ms != nil; ms = ms-&gt;next){
		id = ms-&gt;from;
		rok = 0;
		for(m = box-&gt;msgs; m != nil &amp;&amp; m-&gt;seq &lt;= max; m = m-&gt;next){
			if(!uids &amp;&amp; m-&gt;seq &gt; id
			|| uids &amp;&amp; m-&gt;uid &gt; ms-&gt;to)
				break;
			if(!uids &amp;&amp; m-&gt;seq == id
			|| uids &amp;&amp; m-&gt;uid &gt;= id){
				if(!(*f)(box, m, uids, rock))
					ok = 0;
				if(uids)
					id = m-&gt;uid;
				if(id &gt;= ms-&gt;to){
					rok = 1;
					break;
				}
				if(ms-&gt;to == ~0UL)
					rok = 1;
				id++;
			}
		}
		if(!uids &amp;&amp; !rok)
			ok = 0;
	}
	return ok;
}

Store *
mkStore(int sign, int op, int flags)
{
	Store *st;

	st = binalloc(&amp;parseBin, sizeof(Store), 1);
	if(st == nil)
		parseErr("out of memory");
	st-&gt;sign = sign;
	st-&gt;op = op;
	st-&gt;flags = flags;
	return st;
}

Fetch *
mkFetch(int op, Fetch *next)
{
	Fetch *f;

	f = binalloc(&amp;parseBin, sizeof(Fetch), 1);
	if(f == nil)
		parseErr("out of memory");
	f-&gt;op = op;
	f-&gt;next = next;
	return f;
}

Fetch*
revFetch(Fetch *f)
{
	Fetch *last, *next;

	last = nil;
	for(; f != nil; f = next){
		next = f-&gt;next;
		f-&gt;next = last;
		last = f;
	}
	return last;
}

NList*
mkNList(ulong n, NList *next)
{
	NList *nl;

	nl = binalloc(&amp;parseBin, sizeof(NList), 0);
	if(nl == nil)
		parseErr("out of memory");
	nl-&gt;n = n;
	nl-&gt;next = next;
	return nl;
}

NList*
revNList(NList *nl)
{
	NList *last, *next;

	last = nil;
	for(; nl != nil; nl = next){
		next = nl-&gt;next;
		nl-&gt;next = last;
		last = nl;
	}
	return last;
}

SList*
mkSList(char *s, SList *next)
{
	SList *sl;

	sl = binalloc(&amp;parseBin, sizeof(SList), 0);
	if(sl == nil)
		parseErr("out of memory");
	sl-&gt;s = s;
	sl-&gt;next = next;
	return sl;
}

SList*
revSList(SList *sl)
{
	SList *last, *next;

	last = nil;
	for(; sl != nil; sl = next){
		next = sl-&gt;next;
		sl-&gt;next = last;
		last = sl;
	}
	return last;
}

int
BNList(Biobuf *b, NList *nl, char *sep)
{
	char *s;
	int n;

	s = "";
	n = 0;
	for(; nl != nil; nl = nl-&gt;next){
		n += Bprint(b, "%s%lud", s, nl-&gt;n);
		s = sep;
	}
	return n;
}

int
BSList(Biobuf *b, SList *sl, char *sep)
{
	char *s;
	int n;

	s = "";
	n = 0;
	for(; sl != nil; sl = sl-&gt;next){
		n += Bprint(b, "%s", s);
		n += Bimapstr(b, sl-&gt;s);
		s = sep;
	}
	return n;
}

int
Bimapdate(Biobuf *b, Tm *tm)
{
	char buf[64];

	if(tm == nil)
		tm = localtime(time(nil));
	imap4date(buf, sizeof(buf), tm);
	return Bimapstr(b, buf);
}

int
Brfc822date(Biobuf *b, Tm *tm)
{
	char buf[64];

	if(tm == nil)
		tm = localtime(time(nil));
	rfc822date(buf, sizeof(buf), tm);
	return Bimapstr(b, buf);
}

int
Bimapstr(Biobuf *b, char *s)
{
	char *t;
	int c;

	if(s == nil)
		return Bprint(b, "NIL");
	for(t = s; ; t++){
		c = *t;
		if(c == '\0')
			return Bprint(b, "\"%s\"", s);
		if(t - s &gt; 64 || c &gt;= 0x7f || strchr("\"\\\r\n", c) != nil)
			break;
	}
	return Bprint(b, "{%lud}\r\n%s", strlen(s), s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

