<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/search.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/search.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

static int	dateCmp(char *date, Search *s);
static int	addrSearch(MAddr *a, char *s);
static int	fileSearch(Msg *m, char *file, char *pat);
static int	headerSearch(Msg *m, char *hdr, char *pat);

/*
 * free to exit, parseErr, since called before starting any client reply
 *
 * the header and envelope searches should convert mime character set escapes.
 */
int
searchMsg(Msg *m, Search *s)
{
	MsgSet *ms;
	int ok;

	if(!msgStruct(m, 1) || m-&gt;expunged)
		return 0;
	for(ok = 1; ok &amp;&amp; s != nil; s = s-&gt;next){
		switch(s-&gt;key){
		default:
			ok = 0;
			break;
		case SKNot:
			ok = !searchMsg(m, s-&gt;left);
			break;
		case SKOr:
			ok = searchMsg(m, s-&gt;left) || searchMsg(m, s-&gt;right);
			break;
		case SKAll:
			ok = 1;
			break;
		case SKAnswered:
			ok = (m-&gt;flags &amp; MAnswered) == MAnswered;
			break;
		case SKDeleted:
			ok = (m-&gt;flags &amp; MDeleted) == MDeleted;
			break;
		case SKDraft:
			ok = (m-&gt;flags &amp; MDraft) == MDraft;
			break;
		case SKFlagged:
			ok = (m-&gt;flags &amp; MFlagged) == MFlagged;
			break;
		case SKKeyword:
			ok = (m-&gt;flags &amp; s-&gt;num) == s-&gt;num;
			break;
		case SKNew:
			ok = (m-&gt;flags &amp; (MRecent|MSeen)) == MRecent;
			break;
		case SKOld:
			ok = (m-&gt;flags &amp; MRecent) != MRecent;
			break;
		case SKRecent:
			ok = (m-&gt;flags &amp; MRecent) == MRecent;
			break;
		case SKSeen:
			ok = (m-&gt;flags &amp; MSeen) == MSeen;
			break;
		case SKUnanswered:
			ok = (m-&gt;flags &amp; MAnswered) != MAnswered;
			break;
		case SKUndeleted:
			ok = (m-&gt;flags &amp; MDeleted) != MDeleted;
			break;
		case SKUndraft:
			ok = (m-&gt;flags &amp; MDraft) != MDraft;
			break;
		case SKUnflagged:
			ok = (m-&gt;flags &amp; MFlagged) != MFlagged;
			break;
		case SKUnkeyword:
			ok = (m-&gt;flags &amp; s-&gt;num) != s-&gt;num;
			break;
		case SKUnseen:
			ok = (m-&gt;flags &amp; MSeen) != MSeen;
			break;

		case SKLarger:
			ok = msgSize(m) &gt; s-&gt;num;
			break;
		case SKSmaller:
			ok = msgSize(m) &lt; s-&gt;num;
			break;

		case SKBcc:
			ok = addrSearch(m-&gt;bcc, s-&gt;s);
			break;
		case SKCc:
			ok = addrSearch(m-&gt;cc, s-&gt;s);
			break;
		case SKFrom:
			ok = addrSearch(m-&gt;from, s-&gt;s);
			break;
		case SKTo:
			ok = addrSearch(m-&gt;to, s-&gt;s);
			break;
		case SKSubject:
			ok = 0;
			if(m-&gt;info[ISubject])
				ok = cistrstr(m-&gt;info[ISubject], s-&gt;s) != nil;
			break;

		case SKBefore:
			ok = dateCmp(m-&gt;unixDate, s) &lt; 0;
			break;
		case SKOn:
			ok = dateCmp(m-&gt;unixDate, s) == 0;
			break;
		case SKSince:
			ok = dateCmp(m-&gt;unixDate, s) &gt; 0;
			break;
		case SKSentBefore:
			ok = dateCmp(m-&gt;info[IDate], s) &lt; 0;
			break;
		case SKSentOn:
			ok = dateCmp(m-&gt;info[IDate], s) == 0;
			break;
		case SKSentSince:
			ok = dateCmp(m-&gt;info[IDate], s) &gt; 0;
			break;

		case SKUid:
		case SKSet:
			for(ms = s-&gt;set; ms != nil; ms = ms-&gt;next)
				if(s-&gt;key == SKUid &amp;&amp; m-&gt;uid &gt;= ms-&gt;from &amp;&amp; m-&gt;uid &lt;= ms-&gt;to
				|| s-&gt;key == SKSet &amp;&amp; m-&gt;seq &gt;= ms-&gt;from &amp;&amp; m-&gt;seq &lt;= ms-&gt;to)
					break;
			ok = ms != nil;
			break;

		case SKHeader:
			ok = headerSearch(m, s-&gt;hdr, s-&gt;s);
			break;

		case SKBody:
		case SKText:
			if(s-&gt;key == SKText &amp;&amp; cistrstr(m-&gt;head.buf, s-&gt;s)){
				ok = 1;
				break;
			}
			ok = fileSearch(m, "body", s-&gt;s);
			break;
		}
	}
	return ok;
}

static int
fileSearch(Msg *m, char *file, char *pat)
{
	char buf[BufSize + 1];
	int n, nbuf, npat, fd, ok;

	npat = strlen(pat);
	if(npat &gt;= BufSize / 2)
		return 0;

	fd = msgFile(m, file);
	if(fd &lt; 0)
		return 0;
	ok = 0;
	nbuf = 0;
	for(;;){
		n = read(fd, &amp;buf[nbuf], BufSize - nbuf);
		if(n &lt;= 0)
			break;
		nbuf += n;
		buf[nbuf] = '\0';
		if(cistrstr(buf, pat) != nil){
			ok = 1;
			break;
		}
		if(nbuf &gt; npat){
			memmove(buf, &amp;buf[nbuf - npat], npat);
			nbuf = npat;
		}
	}
	close(fd);
	return ok;
}

static int
headerSearch(Msg *m, char *hdr, char *pat)
{
	SList hdrs;
	char *s, *t;
	int ok, n;

	n = m-&gt;head.size + 3;
	s = emalloc(n);
	hdrs.next = nil;
	hdrs.s = hdr;
	ok = 0;
	if(selectFields(s, n, m-&gt;head.buf, &amp;hdrs, 1) &gt; 0){
		t = strchr(s, ':');
		if(t != nil &amp;&amp; cistrstr(t+1, pat) != nil)
			ok = 1;
	}
	free(s);
	return ok;
}

static int
addrSearch(MAddr *a, char *s)
{
	char *ok, *addr;

	for(; a != nil; a = a-&gt;next){
		addr = maddrStr(a);
		ok = cistrstr(addr, s);
		free(addr);
		if(ok != nil)
			return 1;
	}
	return 0;
}

static int
dateCmp(char *date, Search *s)
{
	Tm tm;

	date2tm(&amp;tm, date);
	if(tm.year &lt; s-&gt;year)
		return -1;
	if(tm.year &gt; s-&gt;year)
		return 1;
	if(tm.mon &lt; s-&gt;mon)
		return -1;
	if(tm.mon &gt; s-&gt;mon)
		return 1;
	if(tm.mday &lt; s-&gt;mday)
		return -1;
	if(tm.mday &gt; s-&gt;mday)
		return 1;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

