<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ping.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ping.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* ping for ip v4 and v6 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;ip.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include "icmp.h"

enum {
	MAXMSG		= 32,
	SLEEPMS		= 1000,

	SECOND		= 1000000000LL,
	MINUTE		= 60*SECOND,
};

typedef struct Req Req;
struct Req
{
	ushort	seq;	/* sequence number */
	vlong	time;	/* time sent */
	vlong	rtt;
	int	ttl;
	int	replied;
	Req	 *next;
};

typedef struct {
	int	version;
	char	*net;
	int	echocmd;
	int	echoreply;
	unsigned iphdrsz;

	void	(*prreply)(Req *r, void *v);
	void	(*prlost)(ushort seq, void *v);
} Proto;


Req	*first;		/* request list */
Req	*last;		/* ... */
Lock	listlock;

char *argv0;

int addresses;
int debug;
int done;
int flood;
int lostmsgs;
int lostonly;
int quiet;
int rcvdmsgs;
int rint;
ushort firstseq;
vlong sum;
int waittime = 5000;

static char *network, *target;

void lost(Req*, void*);
void reply(Req*, void*);

static void
usage(void)
{
	fprint(2,
	    "usage: %s [-6alq] [-s msgsize] [-i millisecs] [-n #pings] dest\n",
		argv0);
	exits("usage");
}

static void
catch(void *a, char *msg)
{
	USED(a);
	if(strstr(msg, "alarm"))
		noted(NCONT);
	else if(strstr(msg, "die"))
		exits("errors");
	else
		noted(NDFLT);
}

static void
prlost4(ushort seq, void *v)
{
	Ip4hdr *ip4 = v;

	print("lost %ud: %V -&gt; %V\n", seq, ip4-&gt;src, ip4-&gt;dst);
}

static void
prlost6(ushort seq, void *v)
{
	Ip6hdr *ip6 = v;

	print("lost %ud: %I -&gt; %I\n", seq, ip6-&gt;src, ip6-&gt;dst);
}

static void
prreply4(Req *r, void *v)
{
	Ip4hdr *ip4 = v;

	print("%ud: %V -&gt; %V rtt %lld µs, avg rtt %lld µs, ttl = %d\n",
		r-&gt;seq - firstseq, ip4-&gt;src, ip4-&gt;dst, r-&gt;rtt, sum/rcvdmsgs,
		r-&gt;ttl);
}

static void
prreply6(Req *r, void *v)
{
	Ip6hdr *ip6 = v;

	print("%ud: %I -&gt; %I rtt %lld µs, avg rtt %lld µs, ttl = %d\n",
		r-&gt;seq - firstseq, ip6-&gt;src, ip6-&gt;dst, r-&gt;rtt, sum/rcvdmsgs,
		r-&gt;ttl);
}

static Proto v4pr = {
	4,		"icmp",
	EchoRequest,	EchoReply,
	IPV4HDR_LEN,
	prreply4,	prlost4,
};
static Proto v6pr = {
	6,		"icmpv6",
	EchoRequestV6,	EchoReplyV6,
	IPV6HDR_LEN,
	prreply6,	prlost6,
};

static Proto *proto = &amp;v4pr;


Icmphdr *
geticmp(void *v)
{
	char *p = v;

	return (Icmphdr *)(p + proto-&gt;iphdrsz);
}

void
clean(ushort seq, vlong now, void *v)
{
	int ttl;
	Req **l, *r;

	ttl = 0;
	if (v) {
		if (proto-&gt;version == 4)
			ttl = ((Ip4hdr *)v)-&gt;ttl;
		else
			ttl = ((Ip6hdr *)v)-&gt;ttl;
	}
	lock(&amp;listlock);
	last = nil;
	for(l = &amp;first; *l; ){
		r = *l;

		if(v &amp;&amp; r-&gt;seq == seq){
			r-&gt;rtt = now-r-&gt;time;
			r-&gt;ttl = ttl;
			reply(r, v);
		}

		if(now-r-&gt;time &gt; MINUTE){
			*l = r-&gt;next;
			r-&gt;rtt = now-r-&gt;time;
			if(v)
				r-&gt;ttl = ttl;
			if(r-&gt;replied == 0)
				lost(r, v);
			free(r);
		}else{
			last = r;
			l = &amp;r-&gt;next;
		}
	}
	unlock(&amp;listlock);
}

static uchar loopbacknet[IPaddrlen] = {
	0, 0, 0, 0,
	0, 0, 0, 0,
	0, 0, 0xff, 0xff,
	127, 0, 0, 0
};
static uchar loopbackmask[IPaddrlen] = {
	0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff,
	0xff, 0, 0, 0
};

/*
 * find first ip addr suitable for proto and
 * that isn't the friggin loopback address.
 * deprecate link-local and multicast addresses.
 */
static int
myipvnaddr(uchar *ip, Proto *proto, char *net)
{
	int ipisv4, wantv4;
	Ipifc *nifc;
	Iplifc *lifc;
	uchar mynet[IPaddrlen], linklocal[IPaddrlen];
	static Ipifc *ifc;

	ipmove(linklocal, IPnoaddr);
	wantv4 = proto-&gt;version == 4;
	ifc = readipifc(net, ifc, -1);
	for(nifc = ifc; nifc; nifc = nifc-&gt;next)
		for(lifc = nifc-&gt;lifc; lifc; lifc = lifc-&gt;next){
			maskip(lifc-&gt;ip, loopbackmask, mynet);
			if(ipcmp(mynet, loopbacknet) == 0)
				continue;
			if(ISIPV6MCAST(lifc-&gt;ip) || ISIPV6LINKLOCAL(lifc-&gt;ip)) {
				ipmove(linklocal, lifc-&gt;ip);
				continue;
			}
			ipisv4 = isv4(lifc-&gt;ip) != 0;
			if(ipcmp(lifc-&gt;ip, IPnoaddr) != 0 &amp;&amp; wantv4 == ipisv4){
				ipmove(ip, lifc-&gt;ip);
				return 0;
			}
		}
	/* no global unicast addrs found, fall back to link-local, if any */
	ipmove(ip, linklocal);
	return ipcmp(ip, IPnoaddr) == 0? -1: 0;
}

void
sender(int fd, int msglen, int interval, int n)
{
	int i, extra;
	ushort seq;
	char buf[64*1024+512];
	uchar me[IPaddrlen], mev4[IPv4addrlen];
	Icmphdr *icmp;
	Req *r;

	srand(time(0));
	firstseq = seq = rand();

	icmp = geticmp(buf);
	memset(buf, 0, proto-&gt;iphdrsz + ICMP_HDRSIZE);
	for(i = proto-&gt;iphdrsz + ICMP_HDRSIZE; i &lt; msglen; i++)
		buf[i] = i;
	icmp-&gt;type = proto-&gt;echocmd;
	icmp-&gt;code = 0;

	/* arguably the kernel should fill in the right src addr. */
	myipvnaddr(me, proto, network);
	if (proto-&gt;version == 4) {
		v6tov4(mev4, me);
		memmove(((Ip4hdr *)buf)-&gt;src, mev4, IPv4addrlen);
	} else
		ipmove(((Ip6hdr *)buf)-&gt;src, me);
	if (addresses)
		print("\t%I -&gt; %s\n", me, target);

	if(rint != 0 &amp;&amp; interval &lt;= 0)
		rint = 0;
	extra = 0;
	for(i = 0; i &lt; n; i++){
		if(i != 0){
			if(rint != 0)
				extra = nrand(interval);
			sleep(interval + extra);
		}
		r = malloc(sizeof *r);
		if (r == nil)
			continue;
		hnputs(icmp-&gt;seq, seq);
		r-&gt;seq = seq;
		r-&gt;next = nil;
		r-&gt;replied = 0;
		r-&gt;time = nsec();	/* avoid early free in reply! */
		lock(&amp;listlock);
		if(first == nil)
			first = r;
		else
			last-&gt;next = r;
		last = r;
		unlock(&amp;listlock);
		r-&gt;time = nsec();
		if(write(fd, buf, msglen) &lt; msglen){
			fprint(2, "%s: write failed: %r\n", argv0);
			return;
		}
		seq++;
	}
	done = 1;
}

void
rcvr(int fd, int msglen, int interval, int nmsg)
{
	int i, n, munged;
	ushort x;
	vlong now;
	uchar buf[64*1024+512];
	Icmphdr *icmp;
	Req *r;

	sum = 0;
	while(lostmsgs+rcvdmsgs &lt; nmsg){
		alarm((nmsg-lostmsgs-rcvdmsgs)*interval+waittime);
		n = read(fd, buf, sizeof buf);
		alarm(0);
		now = nsec();
		if(n &lt;= 0){	/* read interrupted - time to go */
			clean(0, now+MINUTE, nil);
			continue;
		}
		if(n &lt; msglen){
			print("bad len %d/%d\n", n, msglen);
			continue;
		}
		icmp = geticmp(buf);
		munged = 0;
		for(i = proto-&gt;iphdrsz + ICMP_HDRSIZE; i &lt; msglen; i++)
			if(buf[i] != (uchar)i)
				munged++;
		if(munged)
			print("corrupted reply\n");
		x = nhgets(icmp-&gt;seq);
		if(icmp-&gt;type != proto-&gt;echoreply || icmp-&gt;code != 0) {
			print("bad type/code/sequence %d/%d/%d (want %d/%d/%d)\n",
				icmp-&gt;type, icmp-&gt;code, x,
				proto-&gt;echoreply, 0, x);
			continue;
		}
		clean(x, now, buf);
	}

	lock(&amp;listlock);
	for(r = first; r; r = r-&gt;next)
		if(r-&gt;replied == 0)
			lostmsgs++;
	unlock(&amp;listlock);

	if(!quiet &amp;&amp; lostmsgs)
		print("%d out of %d messages lost\n", lostmsgs,
			lostmsgs+rcvdmsgs);
}

static int
isdottedquad(char *name)
{
	int dot = 0, digit = 0;

	for (; *name != '\0'; name++)
		if (*name == '.')
			dot++;
		else if (isdigit(*name))
			digit++;
		else
			return 0;
	return dot &amp;&amp; digit;
}

static int
isv6lit(char *name)
{
	int colon = 0, hex = 0;

	for (; *name != '\0'; name++)
		if (*name == ':')
			colon++;
		else if (isxdigit(*name))
			hex++;
		else
			return 0;
	return colon;
}

/* from /sys/src/libc/9sys/dial.c */

enum
{
	Maxstring	= 128,
	Maxpath		= 256,
};

typedef struct DS DS;
struct DS {
	/* dist string */
	char	buf[Maxstring];
	char	*netdir;
	char	*proto;
	char	*rem;

	/* other args */
	char	*local;
	char	*dir;
	int	*cfdp;
};

/*
 *  parse a dial string
 */
static void
_dial_string_parse(char *str, DS *ds)
{
	char *p, *p2;

	strncpy(ds-&gt;buf, str, Maxstring);
	ds-&gt;buf[Maxstring-1] = 0;

	p = strchr(ds-&gt;buf, '!');
	if(p == 0) {
		ds-&gt;netdir = 0;
		ds-&gt;proto = "net";
		ds-&gt;rem = ds-&gt;buf;
	} else {
		if(*ds-&gt;buf != '/' &amp;&amp; *ds-&gt;buf != '#'){
			ds-&gt;netdir = 0;
			ds-&gt;proto = ds-&gt;buf;
		} else {
			for(p2 = p; *p2 != '/'; p2--)
				;
			*p2++ = 0;
			ds-&gt;netdir = ds-&gt;buf;
			ds-&gt;proto = p2;
		}
		*p = 0;
		ds-&gt;rem = p + 1;
	}
}

/* end excerpt from /sys/src/libc/9sys/dial.c */

/* side effect: sets network &amp; target */
static int
isv4name(char *name)
{
	int r = 1;
	char *root, *ip, *pr;
	DS ds;

	_dial_string_parse(name, &amp;ds);

	/* cope with leading /net.alt/icmp! and the like */
	root = nil;
	if (ds.netdir != nil) {
		pr = strrchr(ds.netdir, '/');
		if (pr == nil)
			pr = ds.netdir;
		else {
			*pr++ = '\0';
			root = ds.netdir;
			network = strdup(root);
		}
		if (strcmp(pr, v4pr.net) == 0)
			return 1;
		if (strcmp(pr, v6pr.net) == 0)
			return 0;
	}

	/* if it's a literal, it's obvious from syntax which proto it is */
	free(target);
	target = strdup(ds.rem);
	if (isdottedquad(ds.rem))
		return 1;
	else if (isv6lit(ds.rem))
		return 0;

	/* map name to ip and look at its syntax */
	ip = csgetvalue(root, "sys", ds.rem, "ip", nil);
	if (ip == nil)
		ip = csgetvalue(root, "dom", ds.rem, "ip", nil);
	if (ip == nil)
		ip = csgetvalue(root, "sys", ds.rem, "ipv6", nil);
	if (ip == nil)
		ip = csgetvalue(root, "dom", ds.rem, "ipv6", nil);
	if (ip != nil)
		r = isv4name(ip);
	free(ip);
	return r;
}

void
main(int argc, char **argv)
{
	int fd, msglen, interval, nmsg;
	char *ds;

	nsec();		/* make sure time file is already open */

	fmtinstall('V', eipfmt);
	fmtinstall('I', eipfmt);

	msglen = interval = 0;
	nmsg = MAXMSG;
	ARGBEGIN {
	case '6':
		proto = &amp;v6pr;
		break;
	case 'a':
		addresses = 1;
		break;
	case 'd':
		debug++;
		break;
	case 'f':
		flood = 1;
		break;
	case 'i':
		interval = atoi(EARGF(usage()));
		if(interval &lt; 0)
			usage();
		break;
	case 'l':
		lostonly++;
		break;
	case 'n':
		nmsg = atoi(EARGF(usage()));
		if(nmsg &lt; 0)
			usage();
		break;
	case 'q':
		quiet = 1;
		break;
	case 'r':
		rint = 1;
		break;
	case 's':
		msglen = atoi(EARGF(usage()));
		break;
	case 'w':
		waittime = atoi(EARGF(usage()));
		if(waittime &lt; 0)
			usage();
		break;
	default:
		usage();
		break;
	} ARGEND;

	if(msglen &lt; proto-&gt;iphdrsz + ICMP_HDRSIZE)
		msglen = proto-&gt;iphdrsz + ICMP_HDRSIZE;
	if(msglen &lt; 64)
		msglen = 64;
	if(msglen &gt;= 64*1024)
		msglen = 64*1024-1;
	if(interval &lt;= 0 &amp;&amp; !flood)
		interval = SLEEPMS;

	if(argc &lt; 1)
		usage();

	notify(catch);

	if (!isv4name(argv[0]))
		proto = &amp;v6pr;
	ds = netmkaddr(argv[0], proto-&gt;net, "1");
	fd = dial(ds, 0, 0, 0);
	if(fd &lt; 0){
		fprint(2, "%s: couldn't dial %s: %r\n", argv0, ds);
		exits("dialing");
	}

	if (!quiet)
		print("sending %d %d byte messages %d ms apart to %s\n",
			nmsg, msglen, interval, ds);

	switch(rfork(RFPROC|RFMEM|RFFDG)){
	case -1:
		fprint(2, "%s: can't fork: %r\n", argv0);
		/* fallthrough */
	case 0:
		rcvr(fd, msglen, interval, nmsg);
		exits(0);
	default:
		sender(fd, msglen, interval, nmsg);
		wait();
		exits(lostmsgs ? "lost messages" : "");
	}
}

void
reply(Req *r, void *v)
{
	r-&gt;rtt /= 1000LL;
	sum += r-&gt;rtt;
	if(!r-&gt;replied)
		rcvdmsgs++;
	if(!quiet &amp;&amp; !lostonly)
		if(addresses)
			(*proto-&gt;prreply)(r, v);
		else
			print("%ud: rtt %lld µs, avg rtt %lld µs, ttl = %d\n",
				r-&gt;seq - firstseq, r-&gt;rtt, sum/rcvdmsgs, r-&gt;ttl);
	r-&gt;replied = 1;
}

void
lost(Req *r, void *v)
{
	if(!quiet)
		if(addresses &amp;&amp; v != nil)
			(*proto-&gt;prlost)(r-&gt;seq - firstseq, v);
		else
			print("lost %ud\n", r-&gt;seq - firstseq);
	lostmsgs++;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

