<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/block.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/block.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;auth.h&gt;
#include "ppp.h"

enum
{
	PAD	= 128,
	NLIST	= (1&lt;&lt;5),
	BPOW	= 10,
};

typedef struct Barena Barena;
struct Barena
{
	QLock;
	Block*	list[NLIST];
};
static Barena area;

#define ADEBUG if(0)


/*
 *  allocation tracing
 */
enum
{
	Npc=	64,
};
typedef struct Arefent Arefent;
struct Arefent
{
	uint	pc;
	uint	n;
};
typedef struct Aref Aref;
struct  Aref
{
	Arefent	tab[Npc];
	QLock;
};
Aref arefblock;

static ulong	callerpc(void*);
static void	aref(Aref*, ulong);
static void	aunref(Aref*, ulong);

Block*
allocb(int len)
{
	int sz;
	Block *bp, **l;

	len += PAD;
	sz = (len&gt;&gt;BPOW)&amp;(NLIST-1);
	
	qlock(&amp;area);
	l = &amp;area.list[sz];
	for(bp = *l; bp; bp = bp-&gt;flist) {
		if(bp-&gt;bsz &gt;= len) {
			*l = bp-&gt;flist;
			qunlock(&amp;area);

			bp-&gt;next = nil;
			bp-&gt;list = nil;
			bp-&gt;flist = nil;
			bp-&gt;base = (uchar*)bp+sizeof(Block);
			bp-&gt;rptr = bp-&gt;base+PAD;
			bp-&gt;wptr = bp-&gt;rptr;
			bp-&gt;lim  = bp-&gt;base+bp-&gt;bsz;
			bp-&gt;flow = nil;
			bp-&gt;flags= 0;
			ADEBUG {
				bp-&gt;pc = callerpc(&amp;len);
				aref(&amp;arefblock, bp-&gt;pc);
			}
			return bp;
		}
		l = &amp;bp-&gt;flist;
	}

	qunlock(&amp;area);

	bp = mallocz(sizeof(Block)+len, 1);

	bp-&gt;bsz  = len;
	bp-&gt;base = (uchar*)bp+sizeof(Block);
	bp-&gt;rptr = bp-&gt;base+PAD;
	bp-&gt;wptr = bp-&gt;rptr;
	bp-&gt;lim  = bp-&gt;base+len;
	ADEBUG {
		bp-&gt;pc = callerpc(&amp;len);
		aref(&amp;arefblock, bp-&gt;pc);
	}
	return bp;
}

void
freeb(Block *bp)
{
	int sz;
	Block **l, *next;

	qlock(&amp;area);
	while(bp) {
		sz = (bp-&gt;bsz&gt;&gt;BPOW)&amp;(NLIST-1);

		l = &amp;area.list[sz];
		bp-&gt;flist = *l;
		*l = bp;

		next = bp-&gt;next;

		/* to catch use after free */
		bp-&gt;rptr = (uchar*)0xdeadbabe;
		bp-&gt;wptr = (uchar*)0xdeadbabe;
		bp-&gt;next = (Block*)0xdeadbabe;
		bp-&gt;list = (Block*)0xdeadbabe;

		ADEBUG aunref(&amp;arefblock, bp-&gt;pc);

		bp = next;
	}
	qunlock(&amp;area);
}

/*
 *  concatenate a list of blocks into a single one and make sure
 *  the result is at least min uchars
 */
Block*
concat(Block *bp)
{
	int len;
	Block *nb, *f;

	nb = allocb(blen(bp));
	for(f = bp; f; f = f-&gt;next) {
		len = BLEN(f);
		memmove(nb-&gt;wptr, f-&gt;rptr, len);
		nb-&gt;wptr += len;
	}
	freeb(bp);
	return nb;
}

int
blen(Block *bp)
{
	int len;

	len = 0;
	while(bp) {
		len += BLEN(bp);
		bp = bp-&gt;next;
	}
	return len;
}

Block *
pullup(Block *bp, int n)
{
	int i;
	Block *nbp;

	/*
	 *  this should almost always be true, the rest it
	 *  just for to avoid every caller checking.
	 */
	if(BLEN(bp) &gt;= n)
		return bp;

	/*
	 *  if not enough room in the first block,
	 *  add another to the front of the list.
	 */
	if(bp-&gt;lim - bp-&gt;rptr &lt; n){
		nbp = allocb(n);
		nbp-&gt;next = bp;
		bp = nbp;
	}

	/*
	 *  copy uchars from the trailing blocks into the first
	 */
	n -= BLEN(bp);
	while(nbp = bp-&gt;next){
		i = BLEN(nbp);
		if(i &gt;= n) {
			memmove(bp-&gt;wptr, nbp-&gt;rptr, n);
			bp-&gt;wptr += n;
			nbp-&gt;rptr += n;
			return bp;
		}
		else {
			memmove(bp-&gt;wptr, nbp-&gt;rptr, i);
			bp-&gt;wptr += i;
			bp-&gt;next = nbp-&gt;next;
			nbp-&gt;next = nil;
			freeb(nbp);
			n -= i;
		}
	}
	freeb(bp);
	return nil;
}

/*
 *  Pad a block to the front with n uchars.  This is used to add protocol
 *  headers to the front of blocks.
 */
Block*
padb(Block *bp, int n)
{
	Block *nbp;

	if(bp-&gt;rptr-bp-&gt;base &gt;= n) {
		bp-&gt;rptr -= n;
		return bp;
	}
	else {
		/* fprint(2, "padb: required %d PAD %d\n", n, PAD) = malloc(sizeof(*required %d PAD %d\n", n, PAD))); */
		nbp = allocb(n);
		nbp-&gt;wptr = nbp-&gt;lim;
		nbp-&gt;rptr = nbp-&gt;wptr - n;
		nbp-&gt;next = bp;
		return nbp;
	}
} 

Block *
btrim(Block *bp, int offset, int len)
{
	ulong l;
	Block *nb, *startb;

	if(blen(bp) &lt; offset+len) {
		freeb(bp);
		return nil;
	}

	while((l = BLEN(bp)) &lt; offset) {
		offset -= l;
		nb = bp-&gt;next;
		bp-&gt;next = nil;
		freeb(bp);
		bp = nb;
	}

	startb = bp;
	bp-&gt;rptr += offset;

	while((l = BLEN(bp)) &lt; len) {
		len -= l;
		bp = bp-&gt;next;
	}

	bp-&gt;wptr -= (BLEN(bp) - len);
	bp-&gt;flags |= S_DELIM;

	if(bp-&gt;next) {
		freeb(bp-&gt;next);
		bp-&gt;next = nil;
	}

	return startb;
}

Block*
copyb(Block *bp, int count)
{
	int l;
	Block *nb, *head, **p;

	p = &amp;head;
	head = nil;
	while(bp != nil &amp;&amp; count != 0) {
		l = BLEN(bp);
		if(count &lt; l)
			l = count;
		nb = allocb(l);
		memmove(nb-&gt;wptr, bp-&gt;rptr, l);
		nb-&gt;wptr += l;
		count -= l;
		nb-&gt;flags = bp-&gt;flags;
		*p = nb;
		p = &amp;nb-&gt;next;
		bp = bp-&gt;next;
	}
	if(count) {
		nb = allocb(count);
		memset(nb-&gt;wptr, 0, count);
		nb-&gt;wptr += count;
		nb-&gt;flags |= S_DELIM;
		*p = nb;
	}
	if(blen(head) == 0)
		fprint(2, "copyb: zero length\n");

	return head;
}

int
pullb(Block **bph, int count)
{
	Block *bp;
	int n, uchars;

	uchars = 0;
	if(bph == nil)
		return 0;

	while(*bph != nil &amp;&amp; count != 0) {
		bp = *bph;
		n = BLEN(bp);
		if(count &lt; n)
			n = count;
		uchars += n;
		count -= n;
		bp-&gt;rptr += n;
		if(BLEN(bp) == 0) {
			*bph = bp-&gt;next;
			bp-&gt;next = nil;
			freeb(bp);
		}
	}
	return uchars;
}

/*
 *  handy routines for keeping track of allocations
 */
static ulong
callerpc(void *a)
{
	return ((ulong*)a)[-1];
}
static void
aref(Aref *ap, ulong pc)
{
	Arefent *a, *e;

	e = &amp;ap-&gt;tab[Npc-1];
	qlock(ap);
	for(a = ap-&gt;tab; a &lt; e; a++)
		if(a-&gt;pc == pc || a-&gt;pc == 0)
			break;
	a-&gt;pc = pc;
	a-&gt;n++;
	qunlock(ap);
}
static void
aunref(Aref *ap, ulong pc)
{
	Arefent *a, *e;

	e = &amp;ap-&gt;tab[Npc-1];
	qlock(ap);
	for(a = ap-&gt;tab; a &lt; e; a++)
		if(a-&gt;pc == pc || a-&gt;pc == 0)
			break;
	a-&gt;n--;
	qunlock(ap);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

