<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/compress.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/compress.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;auth.h&gt;
#include "ppp.h"

typedef struct Iphdr Iphdr;
struct Iphdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;		/* Time to live */
	uchar	proto;		/* Protocol */
	uchar	cksum[2];	/* Header checksum */
	ulong	src;		/* Ip source (uchar ordering unimportant) */
	ulong	dst;		/* Ip destination (uchar ordering unimportant) */
};

typedef struct Tcphdr Tcphdr;
struct Tcphdr
{
	ulong	ports;		/* defined as a ulong to make comparisons easier */
	uchar	seq[4];
	uchar	ack[4];
	uchar	flag[2];
	uchar	win[2];
	uchar	cksum[2];
	uchar	urg[2];
};

typedef struct Ilhdr Ilhdr;
struct Ilhdr
{
	uchar	sum[2];	/* Checksum including header */
	uchar	len[2];	/* Packet length */
	uchar	type;		/* Packet type */
	uchar	spec;		/* Special */
	uchar	src[2];	/* Src port */
	uchar	dst[2];	/* Dst port */
	uchar	id[4];	/* Sequence id */
	uchar	ack[4];	/* Acked sequence */
};

enum
{
	URG		= 0x20,		/* Data marked urgent */
	ACK		= 0x10,		/* Aknowledge is valid */
	PSH		= 0x08,		/* Whole data pipe is pushed */
	RST		= 0x04,		/* Reset connection */
	SYN		= 0x02,		/* Pkt. is synchronise */
	FIN		= 0x01,		/* Start close down */

	IP_DF		= 0x4000,	/* Don't fragment */

	IP_TCPPROTO	= 6,
	IP_ILPROTO	= 40,
	IL_IPHDR	= 20,
};

typedef struct Hdr Hdr;
struct Hdr
{
	uchar	buf[128];
	Iphdr	*ip;
	Tcphdr	*tcp;
	int	len;
};

typedef struct Tcpc Tcpc;
struct Tcpc
{
	uchar	lastrecv;
	uchar	lastxmit;
	uchar	basexmit;
	uchar	err;
	uchar	compressid;
	Hdr	t[MAX_STATES];
	Hdr	r[MAX_STATES];
};

enum
{	/* flag bits for what changed in a packet */
	NEW_U=(1&lt;&lt;0),	/* tcp only */
	NEW_W=(1&lt;&lt;1),	/* tcp only */
	NEW_A=(1&lt;&lt;2),	/* il tcp */
	NEW_S=(1&lt;&lt;3),	/* tcp only */
	NEW_P=(1&lt;&lt;4),	/* tcp only */
	NEW_I=(1&lt;&lt;5),	/* il tcp */
	NEW_C=(1&lt;&lt;6),	/* il tcp */
	NEW_T=(1&lt;&lt;7),	/* il only */
	TCP_PUSH_BIT	= 0x10,
};

/* reserved, special-case values of above for tcp */
#define SPECIAL_I (NEW_S|NEW_W|NEW_U)		/* echoed interactive traffic */
#define SPECIAL_D (NEW_S|NEW_A|NEW_W|NEW_U)	/* unidirectional data */
#define SPECIALS_MASK (NEW_S|NEW_A|NEW_W|NEW_U)

int
encode(void *p, ulong n)
{
	uchar	*cp;

	cp = p;
	if(n &gt;= 256 || n == 0) {
		*cp++ = 0;
		cp[0] = n &gt;&gt; 8;
		cp[1] = n;
		return 3;
	}
	*cp = n;
	return 1;
}

#define DECODEL(f) { \
	if (*cp == 0) {\
		hnputl(f, nhgetl(f) + ((cp[1] &lt;&lt; 8) | cp[2])); \
		cp += 3; \
	} else { \
		hnputl(f, nhgetl(f) + (ulong)*cp++); \
	} \
}
#define DECODES(f) { \
	if (*cp == 0) {\
		hnputs(f, nhgets(f) + ((cp[1] &lt;&lt; 8) | cp[2])); \
		cp += 3; \
	} else { \
		hnputs(f, nhgets(f) + (ulong)*cp++); \
	} \
}

Block*
tcpcompress(Tcpc *comp, Block *b, int *protop)
{
	Iphdr	*ip;		/* current packet */
	Tcphdr	*tcp;		/* current pkt */
	ulong 	iplen, tcplen, hlen;	/* header length in uchars */
	ulong 	deltaS, deltaA;	/* general purpose temporaries */
	ulong 	changes;	/* change mask */
	uchar 	new_seq[16];	/* changes from last to current */
	uchar 	*cp;
	Hdr	*h;		/* last packet */
	int 	i, j;

	/*
	 * Bail if this is not a compressible TCP/IP packet
	 */
	ip = (Iphdr*)b-&gt;rptr;
	iplen = (ip-&gt;vihl &amp; 0xf) &lt;&lt; 2;
	tcp = (Tcphdr*)(b-&gt;rptr + iplen);
	tcplen = (tcp-&gt;flag[0] &amp; 0xf0) &gt;&gt; 2;
	hlen = iplen + tcplen;
	if((tcp-&gt;flag[1] &amp; (SYN|FIN|RST|ACK)) != ACK){
		*protop = Pip;
		return b;		/* connection control */
	}

	/*
	 * Packet is compressible, look for a connection
	 */
	changes = 0;
	cp = new_seq;
	j = comp-&gt;lastxmit;
	h = &amp;comp-&gt;t[j];
	if(ip-&gt;src != h-&gt;ip-&gt;src || ip-&gt;dst != h-&gt;ip-&gt;dst
	|| tcp-&gt;ports != h-&gt;tcp-&gt;ports) {
		for(i = 0; i &lt; MAX_STATES; ++i) {
			j = (comp-&gt;basexmit + i) % MAX_STATES;
			h = &amp;comp-&gt;t[j];
			if(ip-&gt;src == h-&gt;ip-&gt;src &amp;&amp; ip-&gt;dst == h-&gt;ip-&gt;dst
			&amp;&amp; tcp-&gt;ports == h-&gt;tcp-&gt;ports)
				goto found;
		}

		/* no connection, reuse the oldest */
		if(i == MAX_STATES) {
			j = comp-&gt;basexmit;
			j = (j + MAX_STATES - 1) % MAX_STATES;
			comp-&gt;basexmit = j;
			h = &amp;comp-&gt;t[j];
			goto rescue;
		}
	}
found:

	/*
	 * Make sure that only what we expect to change changed. 
	 */
	if(ip-&gt;vihl  != h-&gt;ip-&gt;vihl || ip-&gt;tos   != h-&gt;ip-&gt;tos ||
	   ip-&gt;ttl   != h-&gt;ip-&gt;ttl  || ip-&gt;proto != h-&gt;ip-&gt;proto)
		goto rescue;	/* headers changed */
	if(iplen != sizeof(Iphdr) &amp;&amp; memcmp(ip+1, h-&gt;ip+1, iplen - sizeof(Iphdr)))
		goto rescue;	/* ip options changed */
	if(tcplen != sizeof(Tcphdr) &amp;&amp; memcmp(tcp+1, h-&gt;tcp+1, tcplen - sizeof(Tcphdr)))
		goto rescue;	/* tcp options changed */

	if(tcp-&gt;flag[1] &amp; URG) {
		cp += encode(cp, nhgets(tcp-&gt;urg));
		changes |= NEW_U;
	} else if(memcmp(tcp-&gt;urg, h-&gt;tcp-&gt;urg, sizeof(tcp-&gt;urg)) != 0)
		goto rescue;
	if(deltaS = nhgets(tcp-&gt;win) - nhgets(h-&gt;tcp-&gt;win)) {
		cp += encode(cp, deltaS);
		changes |= NEW_W;
	}
	if(deltaA = nhgetl(tcp-&gt;ack) - nhgetl(h-&gt;tcp-&gt;ack)) {
		if(deltaA &gt; 0xffff)
			goto rescue;
		cp += encode(cp, deltaA);
		changes |= NEW_A;
	}
	if(deltaS = nhgetl(tcp-&gt;seq) - nhgetl(h-&gt;tcp-&gt;seq)) {
		if (deltaS &gt; 0xffff)
			goto rescue;
		cp += encode(cp, deltaS);
		changes |= NEW_S;
	}

	/*
	 * Look for the special-case encodings.
	 */
	switch(changes) {
	case 0:
		/*
		 * Nothing changed. If this packet contains data and the last
		 * one didn't, this is probably a data packet following an
		 * ack (normal on an interactive connection) and we send it
		 * compressed. Otherwise it's probably a retransmit,
		 * retransmitted ack or window probe.  Send it uncompressed
		 * in case the other side missed the compressed version.
		 */
		if(nhgets(ip-&gt;length) == nhgets(h-&gt;ip-&gt;length) ||
		   nhgets(h-&gt;ip-&gt;length) != hlen)
			goto rescue;
		break;
	case SPECIAL_I:
	case SPECIAL_D:
		/*
		 * Actual changes match one of our special case encodings --
		 * send packet uncompressed.
		 */
		goto rescue;
	case NEW_S | NEW_A:
		if (deltaS == deltaA &amp;&amp;
			deltaS == nhgets(h-&gt;ip-&gt;length) - hlen) {
			/* special case for echoed terminal traffic */
			changes = SPECIAL_I;
			cp = new_seq;
		}
		break;
	case NEW_S:
		if (deltaS == nhgets(h-&gt;ip-&gt;length) - hlen) {
			/* special case for data xfer */
			changes = SPECIAL_D;
			cp = new_seq;
		}
		break;
	}
	deltaS = nhgets(ip-&gt;id) - nhgets(h-&gt;ip-&gt;id);
	if(deltaS != 1) {
		cp += encode(cp, deltaS);
		changes |= NEW_I;
	}
	if (tcp-&gt;flag[1] &amp; PSH)
		changes |= TCP_PUSH_BIT;
	/*
	 * Grab the cksum before we overwrite it below. Then update our
	 * state with this packet's header.
	 */
	deltaA = nhgets(tcp-&gt;cksum);
	memmove(h-&gt;buf, b-&gt;rptr, hlen);
	h-&gt;len = hlen;
	h-&gt;tcp = (Tcphdr*)(h-&gt;buf + iplen);

	/*
	 * We want to use the original packet as our compressed packet. (cp -
	 * new_seq) is the number of uchars we need for compressed sequence
	 * numbers. In addition we need one uchar for the change mask, one
	 * for the connection id and two for the tcp checksum. So, (cp -
	 * new_seq) + 4 uchars of header are needed. hlen is how many uchars
	 * of the original packet to toss so subtract the two to get the new
	 * packet size. The temporaries are gross -egs.
	 */
	deltaS = cp - new_seq;
	cp = b-&gt;rptr;
	if(comp-&gt;lastxmit != j || comp-&gt;compressid == 0) {
		comp-&gt;lastxmit = j;
		hlen -= deltaS + 4;
		cp += hlen;
		*cp++ = (changes | NEW_C);
		*cp++ = j;
	} else {
		hlen -= deltaS + 3;
		cp += hlen;
		*cp++ = changes;
	}
	b-&gt;rptr += hlen;
	hnputs(cp, deltaA);
	cp += 2;
	memmove(cp, new_seq, deltaS);
	*protop = Pvjctcp;
	return b;

rescue:
	/*
	 * Update connection state &amp; send uncompressed packet
	 */
	memmove(h-&gt;buf, b-&gt;rptr, hlen);
	h-&gt;tcp = (Tcphdr*)(h-&gt;buf + iplen);
	h-&gt;len = hlen;
	ip-&gt;proto = j;
	comp-&gt;lastxmit = j;
	*protop = Pvjutcp;
	return b;
}

Block*
tcpuncompress(Tcpc *comp, Block *b, int type)
{
	uchar	*cp, changes;
	int	i;
	int	iplen, len;
	Iphdr	*ip;
	Tcphdr	*tcp;
	Hdr	*h;

	if(type == Pvjutcp) {
		/*
		 *  Locate the saved state for this connection. If the state
		 *  index is legal, clear the 'discard' flag.
		 */
		ip = (Iphdr*)b-&gt;rptr;
		if(ip-&gt;proto &gt;= MAX_STATES)
			goto rescue;
		iplen = (ip-&gt;vihl &amp; 0xf) &lt;&lt; 2;
		tcp = (Tcphdr*)(b-&gt;rptr + iplen);
		comp-&gt;lastrecv = ip-&gt;proto;
		len = iplen + ((tcp-&gt;flag[0] &amp; 0xf0) &gt;&gt; 2);
		comp-&gt;err = 0;
		/*
		 * Restore the IP protocol field then save a copy of this
		 * packet header. The checksum is zeroed in the copy so we
		 * don't have to zero it each time we process a compressed
		 * packet.
		 */
		ip-&gt;proto = IP_TCPPROTO;
		h = &amp;comp-&gt;r[comp-&gt;lastrecv];
		memmove(h-&gt;buf, b-&gt;rptr, len);
		h-&gt;tcp = (Tcphdr*)(h-&gt;buf + iplen);
		h-&gt;len = len;
		h-&gt;ip-&gt;cksum[0] = h-&gt;ip-&gt;cksum[1] = 0;
		return b;
	}

	cp = b-&gt;rptr;
	changes = *cp++;
	if(changes &amp; NEW_C) {
		/*
		 * Make sure the state index is in range, then grab the
		 * state. If we have a good state index, clear the 'discard'
		 * flag.
		 */
		if(*cp &gt;= MAX_STATES)
			goto rescue;
		comp-&gt;err = 0;
		comp-&gt;lastrecv = *cp++;
	} else {
		/*
		 * This packet has no state index. If we've had a
		 * line error since the last time we got an explicit state
		 * index, we have to toss the packet.
		 */
		if(comp-&gt;err != 0){
			freeb(b);
			return nil;
		}
	}

	/*
	 * Find the state then fill in the TCP checksum and PUSH bit.
	 */
	h = &amp;comp-&gt;r[comp-&gt;lastrecv];
	ip = h-&gt;ip;
	tcp = h-&gt;tcp;
	len = h-&gt;len;
	memmove(tcp-&gt;cksum, cp, sizeof tcp-&gt;cksum);
	cp += 2;
	if(changes &amp; TCP_PUSH_BIT)
		tcp-&gt;flag[1] |= PSH;
	else
		tcp-&gt;flag[1] &amp;= ~PSH;
	/*
	 * Fix up the state's ack, seq, urg and win fields based on the
	 * changemask.
	 */
	switch (changes &amp; SPECIALS_MASK) {
	case SPECIAL_I:
		i = nhgets(ip-&gt;length) - len;
		hnputl(tcp-&gt;ack, nhgetl(tcp-&gt;ack) + i);
		hnputl(tcp-&gt;seq, nhgetl(tcp-&gt;seq) + i);
		break;

	case SPECIAL_D:
		hnputl(tcp-&gt;seq, nhgetl(tcp-&gt;seq) + nhgets(ip-&gt;length) - len);
		break;

	default:
		if(changes &amp; NEW_U) {
			tcp-&gt;flag[1] |= URG;
			if(*cp == 0){
				hnputs(tcp-&gt;urg, nhgets(cp+1));
				cp += 3;
			}else
				hnputs(tcp-&gt;urg, *cp++);
		} else
			tcp-&gt;flag[1] &amp;= ~URG;
		if(changes &amp; NEW_W)
			DECODES(tcp-&gt;win)
		if(changes &amp; NEW_A)
			DECODEL(tcp-&gt;ack)
		if(changes &amp; NEW_S)
			DECODEL(tcp-&gt;seq)
		break;
	}

	/* Update the IP ID */
	if(changes &amp; NEW_I)
		DECODES(ip-&gt;id)
	else
		hnputs(ip-&gt;id, nhgets(ip-&gt;id) + 1);

	/*
	 *  At this point, cp points to the first uchar of data in the packet.
	 *  Back up cp by the TCP/IP header length to make room for the
	 *  reconstructed header.
	 *  We assume the packet we were handed has enough space to prepend
	 *  up to 128 uchars of header.
	 */
	b-&gt;rptr = cp;
	if(b-&gt;rptr - b-&gt;base &lt; len){
		b = padb(b, len);
		b = pullup(b, blen(b));
	} else
		b-&gt;rptr -= len;
	hnputs(ip-&gt;length, BLEN(b));
	memmove(b-&gt;rptr, ip, len);
	
	/* recompute the ip header checksum */
	ip = (Iphdr*)b-&gt;rptr;
	ip-&gt;cksum[0] = ip-&gt;cksum[1] = 0;
	hnputs(ip-&gt;cksum, ipcsum(b-&gt;rptr));

	return b;

rescue:
	netlog("ppp: vj: Bad Packet!\n");
	comp-&gt;err = 1;
	freeb(b);
	return nil;
}

Tcpc*
compress_init(Tcpc *c)
{
	int i;
	Hdr *h;

	if(c == nil)
		c = malloc(sizeof(Tcpc));

	memset(c, 0, sizeof(*c));
	for(i = 0; i &lt; MAX_STATES; i++){
		h = &amp;c-&gt;t[i];
		h-&gt;ip = (Iphdr*)h-&gt;buf;
		h-&gt;tcp = (Tcphdr*)(h-&gt;buf + 20);
		h-&gt;len = 40;
		h = &amp;c-&gt;r[i];
		h-&gt;ip = (Iphdr*)h-&gt;buf;
		h-&gt;tcp = (Tcphdr*)(h-&gt;buf + 20);
		h-&gt;len = 40;
	}

	return c;
}

Block*
compress(Tcpc *tcp, Block *b, int *protop)
{
	Iphdr		*ip;

	/*
	 * Bail if this is not a compressible IP packet
	 */
	ip = (Iphdr*)b-&gt;rptr;
	if((nhgets(ip-&gt;frag) &amp; 0x3fff) != 0){
		*protop = Pip;
		return b;
	}

	switch(ip-&gt;proto) {
	case IP_TCPPROTO:
		return tcpcompress(tcp, b, protop);
	default:
		*protop = Pip;
		return b;
	}
}

int
compress_negotiate(Tcpc *tcp, uchar *data)
{
	if(data[0] != MAX_STATES - 1)
		return -1;
	tcp-&gt;compressid = data[1];
	return 0;
}

/* called by ppp when there was a bad frame received */
void
compress_error(Tcpc *tcp)
{
	tcp-&gt;err = 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

