<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/testppp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/testppp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;

int	debug;
long	errrate;
long	droprate;
int	framing;
int	nocompress;
int	noipcompress;
char	*ppp = "8.out";
char	*mtu;

void
pppopen(int fd, char *net, char *local, char *remote)
{
	char *argv[16];
	int argc;

	switch(fork()){
	case -1:
		fprint(2, "testppp: can't fork: %r\n");
		exits(0);
	case 0:
		return;
	default:
		break;
	}

	dup(fd, 0);
	dup(fd, 1);

	argc = 0;
	argv[argc++] = ppp;
	if(debug)
		argv[argc++] = "-d";
	if(framing)
		argv[argc++] = "-f";
	if(nocompress)
		argv[argc++] = "-c";
	if(noipcompress)
		argv[argc++] = "-C";
	if(mtu){
		argv[argc++] = "-m";
		argv[argc++] = mtu;
	}
	argv[argc++] = "-x";
	argv[argc++] = net;
	if(local){
		argv[argc++] = local;
		if(remote)
			argv[argc++] = remote;
	}
	argv[argc] = 0;
	exec(ppp, argv);
}

void
printbuf(uchar *p, int n)
{
	int i;
	uchar *e;
	char buf[32*5];

	if(n &gt; 32)
		n = 32;
	
	i = 0;
	for(e = p + n; p &lt; e; p++){
		if(isprint(*p))
			i += sprint(buf+i, "%c ", *p);
		else
			i += sprint(buf+i, "%2.2ux ", *p);
	}
	fprint(2, "%s\n", buf);
}

void
xfer(int from, int to)
{
	uchar buf[4096];
	int i, n, modified, ok, total, errs, dropped;

	if(fork() == 0)
		return;

	total = ok = errs = dropped = 0;
	for(;;){
		n = read(from, buf, sizeof(buf));
		if(n &lt;= 0){
			fprint(2, "%d -&gt; %d EOF\n", from, to);
			exits(0);
		}
		modified = 0;
		if(errrate){
			for(i = 0; i &lt; n; i++){
				if(lnrand(errrate) == 0){
					buf[i] ^= 0xff;
					modified = 1;
				}
			}
		}
		if(droprate &amp;&amp; lnrand(droprate) == 0){
			fprint(2, "!!!!!!!!!!!!!!%d -&gt; %d dropped %d (%d/%d)\n", from, to, ok, dropped, total);
			ok = 0;
			dropped++;
			total++;
			continue;
		}
		if(modified){
			fprint(2, "!!!!!!!!!!!!!!%d -&gt; %d %d (%d/%d)\n", from, to, ok, errs, total);
			ok = 0;
			errs++;
		} else
			ok++;
		total++;
		if(debug &gt; 1){
			fprint(2, "%d -&gt; %d (%d)", from, to, n);
			printbuf(buf, n);
		}
		n = write(to, buf, n);
		if(n &lt; 0){
			fprint(2, "%d -&gt; %d write err\n", from, to);
			exits(0);
		}
	}
}

void
usage(void)
{
	fprint(2, "usage: testppp [-cCDf] [-e errrate] [-d droprate] [-m mtu] [-p ppp]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	char *s;
	int pfd1[2];
	int pfd2[2];

	errrate = 0;
	droprate = 0;
	ARGBEGIN{
	case 'c':
		nocompress = 1;
		break;
	case 'C':
		noipcompress = 1;
		break;
	case 'd':
		s = ARGF();
		if(s)
			droprate = strtol(s, nil, 0);
		break;
	case 'D':
		debug++;
		break;
	case 'e':
		s = ARGF();
		if(s)
			errrate = strtol(s, nil, 0);
		break;
	case 'f':
		framing = 1;
		break;
	case 'm':
		mtu = ARGF();
		break;
	case 'p':
		ppp = ARGF();
		if(ppp == nil)
			usage();
		break;
	default:
		usage();
		break;
	}ARGEND
	if(argc)
		usage();

	pipe(pfd1);
	pipe(pfd2);

	bind("#I2", "/net.alt2", MCREATE);
	bind("#I1", "/net.alt", MCREATE);
	pppopen(pfd1[0], "/net.alt2", "135.104.99.1", "135.104.99.2");
	pppopen(pfd2[0], "/net.alt", 0, 0);

	close(pfd1[0]);
	close(pfd2[0]);

	xfer(pfd1[1], pfd2[1]);
	xfer(pfd2[1], pfd1[1]);
	exits(0);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

