<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/thw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/thw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;auth.h&gt;
#include "ppp.h"
#include "thwack.h"

typedef struct Cstate Cstate;
struct Cstate
{
	ulong		seq;
	Thwack		th;
	ulong		stats[ThwStats];
};

typedef struct Uncstate Uncstate;
struct Uncstate
{
	QLock		ackl;			/* lock for acks sent back to compressor */
	int		doack;			/* send an ack? */
	int		badpacks;		/* bad packets seen in a row */
	ulong		ackseq;			/* packets to ack */
	int		ackmask;

	int		active;			/* 0 =&gt; waiting for resetack */
	int		resetid;		/* id of most recent reset */
	Unthwack	ut;
};

enum
{
	ThwAcked	= 1UL &lt;&lt; 23,
	ThwCompMask	= 3UL &lt;&lt; 21,
	ThwCompressed	= 0UL &lt;&lt; 21,
	ThwUncomp	= 1UL &lt;&lt; 21,
	ThwUncompAdd	= 2UL &lt;&lt; 21,		/* uncompressed, but add to decompression buffer */
	ThwSeqMask	= 0x0fffff,
	ThwSmallPack	= 96,
};

static	void		*compinit(PPP*);
static	Block*		comp(PPP*, ushort, Block*, int*);
static	Block		*compresetreq(void*, Block*);
static	void		compcompack(void*, Block*);
static	void		compfini(void*);

static	void		*uncinit(PPP*);
static	Block*		uncomp(PPP*, Block*, int *protop, Block**);
static	void		uncfini(void*);
static	void		uncresetack(void*, Block*);

Comptype cthwack = {
	compinit,
	comp,
	compresetreq,
	compfini
};

Uncomptype uncthwack = {
	uncinit,
	uncomp,
	uncresetack,
	uncfini
};

static void *
compinit(PPP *)
{
	Cstate *cs;

	cs = mallocz(sizeof(Cstate), 1);
	thwackinit(&amp;cs-&gt;th);
	return cs;
}

static void
compfini(void *as)
{
	Cstate *cs;

	cs = as;
	thwackcleanup(&amp;cs-&gt;th);
	free(cs);
}


static Block *
compresetreq(void *as, Block *b)
{
	Cstate *cs;
	Lcpmsg *m;
	int id;

	cs = as;
	m = (Lcpmsg*)b-&gt;rptr;
	id = m-&gt;id;

	thwackinit(&amp;cs-&gt;th);

	freeb(b);

	netlog("thwack resetreq id=%d \n", id);

	b = alloclcp(Lresetack, id, 4, &amp;m);
	hnputs(m-&gt;len, 4);

	return b;
}

static Block*
comp(PPP *ppp, ushort proto, Block *b, int *protop)
{
	Uncstate *uncs;
	Cstate *cs;
	Block *bb;
	ulong seq, acked;
	int n, nn, mustadd;

	cs = ppp-&gt;cstate;
	*protop = 0;

	/* put ack and protocol into b */
	n = BLEN(b);
	if(b-&gt;rptr - (2+4) &lt; b-&gt;base)
		sysfatal("thwack: not enough header in block");
	acked = 0;
	if(ppp-&gt;unctype == &amp;uncthwack){
		uncs = ppp-&gt;uncstate;
		qlock(&amp;uncs-&gt;ackl);
		if(uncs-&gt;doack){
			uncs-&gt;doack = 0;
			b-&gt;rptr -= 4;
			b-&gt;rptr[0] = uncs-&gt;ackseq &gt;&gt; 16;
			b-&gt;rptr[1] = uncs-&gt;ackseq &gt;&gt; 8;
			b-&gt;rptr[2] = uncs-&gt;ackseq;
			b-&gt;rptr[3] = uncs-&gt;ackmask;
			acked = ThwAcked;
		}
		qunlock(&amp;uncs-&gt;ackl);
	}
	if(proto &gt; 0xff){
		b-&gt;rptr -= 2;
		b-&gt;rptr[0] = proto &gt;&gt; 8;
		b-&gt;rptr[1] = proto;
	}else{
		b-&gt;rptr--;
		b-&gt;rptr[0] = proto;
	}

	bb = allocb(BLEN(b) + 3);

	seq = cs-&gt;seq;
	if(n &lt;= 3){
		mustadd = 0;
		nn = -1;
	}else{
		mustadd = n &lt; ThwSmallPack;
		nn = thwack(&amp;cs-&gt;th, mustadd, bb-&gt;wptr + 3, n - 3, b, seq, cs-&gt;stats);
	}
	if(nn &lt; 0 &amp;&amp; !mustadd){
		if(!acked || BLEN(b) + 1 &gt; ppp-&gt;mtu){
			freeb(bb);
			if(acked)
				b-&gt;rptr += 4;
			if(proto &gt; 0xff)
				b-&gt;rptr += 2;
			else
				b-&gt;rptr++;
			*protop = proto;
			return b;
		}
		bb-&gt;wptr[0] = (ThwUncomp | ThwAcked) &gt;&gt; 16;

		memmove(bb-&gt;wptr + 1, b-&gt;rptr, BLEN(b));

		bb-&gt;wptr += BLEN(b) + 1;
		freeb(b);
	}else{
		cs-&gt;seq = (seq + 1) &amp; ThwSeqMask;
		if(nn &lt; 0){
			nn = BLEN(b);
			memmove(bb-&gt;wptr + 3, b-&gt;rptr, nn);
			seq |= ThwUncompAdd;
		}else
			seq |= ThwCompressed;
		seq |= acked;
		bb-&gt;wptr[0] = seq&gt;&gt;16;
		bb-&gt;wptr[1] = seq&gt;&gt;8;
		bb-&gt;wptr[2] = seq;

		bb-&gt;wptr += nn + 3;
	}

	*protop = Pcdata;
	return bb;
}

static	void *
uncinit(PPP *)
{
	Uncstate *s;

	s = mallocz(sizeof(Uncstate), 1);

	s-&gt;active = 1;

	unthwackinit(&amp;s-&gt;ut);

	return s;
}

static	void
uncfini(void *as)
{
	free(as);
}

static	void
uncresetack(void *as, Block *b)
{
	Uncstate *s;
	Lcpmsg *m;

	s = as;
	m = (Lcpmsg*)b-&gt;rptr;

	/*
	 * rfc 1962 says we must reset every message
	 * we don't since we may have acked some messages
	 * which the compressor will use in the future.
	 */
	netlog("unthwack resetack id=%d resetid=%d active=%d\n", m-&gt;id, s-&gt;resetid, s-&gt;active);
	if(m-&gt;id == (uchar)s-&gt;resetid &amp;&amp; !s-&gt;active){
		s-&gt;active = 1;
		unthwackinit(&amp;s-&gt;ut);
	}
}

static	Block*
uncomp(PPP *ppp, Block *bb, int *protop, Block **reply)
{
	Lcpmsg *m;
	Cstate *cs;
	Uncstate *uncs;
	Block *b, *r;
	ulong seq, mseq;
	ushort proto;
	uchar mask;
	int n;

	*reply = nil;
	*protop = 0;
	uncs = ppp-&gt;uncstate;

	if(BLEN(bb) &lt; 4){
		syslog(0, "ppp", ": thwack: short packet\n");
		freeb(bb);
		return nil;
	}

	if(!uncs-&gt;active){
		netlog("unthwack: inactive, killing packet\n");
		freeb(bb);
		r = alloclcp(Lresetreq, uncs-&gt;resetid, 4, &amp;m);
		hnputs(m-&gt;len, 4);
		*reply = r;
		return nil;
	}

	seq = bb-&gt;rptr[0] &lt;&lt; 16;
	if((seq &amp; ThwCompMask) == ThwUncomp){
		bb-&gt;rptr++;
		b = bb;
	}else{
		seq |= (bb-&gt;rptr[1]&lt;&lt;8) | bb-&gt;rptr[2];
		bb-&gt;rptr += 3;
		if((seq &amp; ThwCompMask) == ThwCompressed){
			b = allocb(ThwMaxBlock);
			n = unthwack(&amp;uncs-&gt;ut, b-&gt;wptr, ThwMaxBlock, bb-&gt;rptr, BLEN(bb), seq &amp; ThwSeqMask);
			freeb(bb);
			if(n &lt; 2){
				syslog(0, "ppp", ": unthwack: short or corrupted packet %d seq=%ld\n", n, seq);
				netlog("unthwack: short or corrupted packet n=%d seq=%ld: %s\n", n, seq, uncs-&gt;ut.err);
				freeb(b);

				r = alloclcp(Lresetreq, ++uncs-&gt;resetid, 4, &amp;m);
				hnputs(m-&gt;len, 4);
				*reply = r;
				uncs-&gt;active = 0;
				return nil;
			}
			b-&gt;wptr += n;
		}else{
			unthwackadd(&amp;uncs-&gt;ut, bb-&gt;rptr, BLEN(bb), seq &amp; ThwSeqMask);
			b = bb;
		}

		/*
		 * update ack state
		 */
		mseq = unthwackstate(&amp;uncs-&gt;ut, &amp;mask);
		qlock(&amp;uncs-&gt;ackl);
		uncs-&gt;ackseq = mseq;
		uncs-&gt;ackmask = mask;
		uncs-&gt;doack = 1;
		qunlock(&amp;uncs-&gt;ackl);
	}

	/*
	 * grab the compressed protocol field
	 */
	proto = *b-&gt;rptr++;
	if((proto &amp; 1) == 0)
		proto = (proto &lt;&lt; 8) | *b-&gt;rptr++;
	*protop = proto;

	/*
	 * decode the ack, and forward to compressor
	 */
	if(seq &amp; ThwAcked){
		if(ppp-&gt;ctype == &amp;cthwack){
			cs = ppp-&gt;cstate;
			mseq = (b-&gt;rptr[0]&lt;&lt;16) | (b-&gt;rptr[1]&lt;&lt;8) | b-&gt;rptr[2];
			mask = b-&gt;rptr[3];
			thwackack(&amp;cs-&gt;th, mseq, mask);
		}
		b-&gt;rptr += 4;
	}
	return b;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

