<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/unthwack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/unthwack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;auth.h&gt;
#include "ppp.h"
#include "thwack.h"

enum
{
	DMaxFastLen	= 7,
	DBigLenCode	= 0x3c,		/* minimum code for large lenth encoding */
	DBigLenBits	= 6,
	DBigLenBase	= 1		/* starting items to encode for big lens */
};

static uchar lenval[1 &lt;&lt; (DBigLenBits - 1)] =
{
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	3, 3, 3, 3, 3, 3, 3, 3,
	4, 4, 4, 4,
	5,
	6,
	255,
	255
};

static uchar lenbits[] =
{
	0, 0, 0,
	2, 3, 5, 5,
};

static uchar offbits[16] =
{
	5, 5, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 12, 13
};

static ushort offbase[16] =
{
	0, 0x20,
	0x40, 0x60,
	0x80, 0xc0,
	0x100, 0x180,
	0x200, 0x300,
	0x400, 0x600,
	0x800, 0xc00,
	0x1000,
	0x2000
};

void
unthwackinit(Unthwack *ut)
{
	int i;

	memset(ut, 0, sizeof *ut);
	for(i = 0; i &lt; DWinBlocks; i++)
		ut-&gt;blocks[i].data = ut-&gt;data[i];
}

ulong
unthwackstate(Unthwack *ut, uchar *mask)
{
	ulong bseq, seq;
	int slot, m;

	seq = ~0UL;
	m = 0;
	slot = ut-&gt;slot;
	for(;;){
		slot--;
		if(slot &lt; 0)
			slot += DWinBlocks;
		if(slot == ut-&gt;slot)
			break;
		if(ut-&gt;blocks[slot].maxoff == 0)
			continue;
		bseq = ut-&gt;blocks[slot].seq;
		if(seq == ~0UL)
			seq = bseq;
		else if(seq - bseq &gt; MaxSeqMask)
			break;
		else
			m |= 1 &lt;&lt; (seq - bseq - 1);
	}
	*mask = m;
	return seq;
}

/*
 * insert this block in it's correct sequence number order.
 * replace the oldest block, which is always pointed to by ut-&gt;slot.
 * the encoder doesn't use a history at wraparound,
 * so don't worry about that case.
 */
static int
unthwackinsert(Unthwack *ut, int len, ulong seq)
{
	uchar *d;
	int slot, tslot;

	tslot = ut-&gt;slot;
	for(;;){
		slot = tslot - 1;
		if(slot &lt; 0)
			slot += DWinBlocks;
		if(ut-&gt;blocks[slot].seq &lt;= seq || ut-&gt;blocks[slot].maxoff == 0)
			break;
		d = ut-&gt;blocks[tslot].data;
		ut-&gt;blocks[tslot] = ut-&gt;blocks[slot];
		ut-&gt;blocks[slot].data = d;
		tslot = slot;
	}
	ut-&gt;blocks[tslot].seq = seq;
	ut-&gt;blocks[tslot].maxoff = len;

	ut-&gt;slot++;
	if(ut-&gt;slot &gt;= DWinBlocks)
		ut-&gt;slot = 0;

	ut-&gt;blocks[ut-&gt;slot].seq = ~0UL;
	ut-&gt;blocks[ut-&gt;slot].maxoff = 0;

	return tslot;
}

int
unthwackadd(Unthwack *ut, uchar *src, int nsrc, ulong seq)
{
	int tslot;

	if(nsrc &gt; ThwMaxBlock)
		return -1;

	tslot = unthwackinsert(ut, nsrc, seq);
	if(tslot &lt; 0)
		return -1;
	
	memmove(ut-&gt;blocks[tslot].data, src, nsrc);

	return nsrc;
}

int
unthwack(Unthwack *ut, uchar *dst, int ndst, uchar *src, int nsrc, ulong seq)
{
	UnthwBlock blocks[CompBlocks], *b, *eblocks;
	uchar *s, *d, *dmax, *smax, lit;
	ulong cmask, cseq, bseq, utbits;
	int i, off, len, bits, slot, use, code, utnbits, overbits, lithist;

	if(nsrc &lt; 4 || nsrc &gt; ThwMaxBlock){
		snprint(ut-&gt;err, ThwErrLen, "block too small or large");
		return -1;
	}

	slot = ut-&gt;slot;
	b = blocks;
	*b = ut-&gt;blocks[slot];
	d = b-&gt;data;
	dmax = d + ndst;

	/*
	 * set up the history blocks
	 */
	cseq = seq - src[0];
	cmask = src[1];
	b++;
	while(cseq != seq &amp;&amp; b &lt; blocks + CompBlocks){
		slot--;
		if(slot &lt; 0)
			slot += DWinBlocks;
		if(slot == ut-&gt;slot)
			break;
		bseq = ut-&gt;blocks[slot].seq;
		if(bseq == cseq){
			*b = ut-&gt;blocks[slot];
			b++;
			if(cmask == 0){
				cseq = seq;
				break;
			}
			do{
				bits = cmask &amp; 1;
				cseq--;
				cmask &gt;&gt;= 1;
			}while(!bits);
		}
	}
	eblocks = b;
	if(cseq != seq){
		snprint(ut-&gt;err, ThwErrLen, "blocks dropped: seq=%ld cseq=%ld %d cmask=%#lx %#x\n", seq, cseq, src[0], cmask, src[1]);
		return -2;
	}

	smax = src + nsrc;
	src += 2;
	utnbits = 0;
	utbits = 0;
	overbits = 0;
	lithist = ~0;
	while(src &lt; smax || utnbits - overbits &gt;= MinDecode){
		while(utnbits &lt;= 24){
			utbits &lt;&lt;= 8;
			if(src &lt; smax)
				utbits |= *src++;
			else
				overbits += 8;
			utnbits += 8;
		}

		/*
		 * literal
		 */
		len = lenval[(utbits &gt;&gt; (utnbits - 5)) &amp; 0x1f];
		if(len == 0){
			if(lithist &amp; 0xf){
				utnbits -= 9;
				lit = (utbits &gt;&gt; utnbits) &amp; 0xff;
				lit &amp;= 255;
			}else{
				utnbits -= 8;
				lit = (utbits &gt;&gt; utnbits) &amp; 0x7f;
				if(lit &lt; 32){
					if(lit &lt; 24){
						utnbits -= 2;
						lit = (lit &lt;&lt; 2) | ((utbits &gt;&gt; utnbits) &amp; 3);
					}else{
						utnbits -= 3;
						lit = (lit &lt;&lt; 3) | ((utbits &gt;&gt; utnbits) &amp; 7);
					}
					lit = (lit - 64) &amp; 0xff;
				}
			}
			if(d &gt;= dmax){
				snprint(ut-&gt;err, ThwErrLen, "too much output");
				return -1;
			}
			*d++ = lit;
			lithist = (lithist &lt;&lt; 1) | (lit &lt; 32) | (lit &gt; 127);
			blocks-&gt;maxoff++;
			continue;
		}

		/*
		 * length
		 */
		if(len &lt; 255)
			utnbits -= lenbits[len];
		else{
			utnbits -= DBigLenBits;
			code = ((utbits &gt;&gt; utnbits) &amp; ((1 &lt;&lt; DBigLenBits) - 1)) - DBigLenCode;
			len = DMaxFastLen;
			use = DBigLenBase;
			bits = (DBigLenBits &amp; 1) ^ 1;
			while(code &gt;= use){
				len += use;
				code -= use;
				code &lt;&lt;= 1;
				utnbits--;
				if(utnbits &lt; 0){
					snprint(ut-&gt;err, ThwErrLen, "len out of range");
					return -1;
				}
				code |= (utbits &gt;&gt; utnbits) &amp; 1;
				use &lt;&lt;= bits;
				bits ^= 1;
			}
			len += code;

			while(utnbits &lt;= 24){
				utbits &lt;&lt;= 8;
				if(src &lt; smax)
					utbits |= *src++;
				else
					overbits += 8;
				utnbits += 8;
			}
		}

		/*
		 * offset
		 */
		utnbits -= 4;
		bits = (utbits &gt;&gt; utnbits) &amp; 0xf;
		off = offbase[bits];
		bits = offbits[bits];

		utnbits -= bits;
		off |= (utbits &gt;&gt; utnbits) &amp; ((1 &lt;&lt; bits) - 1);
		off++;

		b = blocks;
		while(off &gt; b-&gt;maxoff){
			off -= b-&gt;maxoff;
			b++;
			if(b &gt;= eblocks){
				snprint(ut-&gt;err, ThwErrLen, "offset out of range");
				return -1;
			}
		}
		if(d + len &gt; dmax
		|| b != blocks &amp;&amp; len &gt; off){
			snprint(ut-&gt;err, ThwErrLen, "len out of range");
			return -1;
		}
		s = b-&gt;data + b-&gt;maxoff - off;
		blocks-&gt;maxoff += len;

		for(i = 0; i &lt; len; i++)
			d[i] = s[i];
		d += len;
	}
	if(utnbits &lt; overbits){
		snprint(ut-&gt;err, ThwErrLen, "compressed data overrun");
		return -1;
	}

	len = d - blocks-&gt;data;
	memmove(dst, blocks-&gt;data, len);

	unthwackinsert(ut, len, seq);

	return len;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

