<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/aoeata.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/aoeata.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct{
	uchar	aflag;
	uchar	feat;
	uchar	sectors;
	uchar	cmd;
	uchar	lba[6];
}Hdr;

enum{
	Hsize	= 10,
};

enum{
	Oaflag,
	Ocmd,
	Ofeat,
	Osectors,
	Olba,

	Ostat,
	Oerr,
};

static Field p_fields[] =
{
	{"aflag",	Fnum,	Oaflag,		"aflag",		},
	{"cmd",		Fnum,	Ocmd,		"command register",	},
	{"feat",	Fnum,	Ofeat,		"features",		},
	{"sectors",	Fnum,	Osectors,	"number of sectors",	},
	{"lba",		Fnum,	Olba,		"lba",			},
	{"stat",	Fnum,	Ostat,		"status",		},
	{"err",		Fnum,	Oerr,		"error",		},
	{0}
};

static void
p_compile(Filter *f)
{
	if(f-&gt;op == '='){
		compile_cmp(aoeata.name, f, p_fields);
		return;
	}
	sysfatal("unknown aoeata field: %s", f-&gt;s);
}

uvlong
llba(uchar *c)
{
	uvlong l;

	l = c[0];
	l |= c[1]&lt;&lt;8;
	l |= c[2]&lt;&lt;16;
	l |= c[3]&lt;&lt;24;
	l |= (uvlong)c[4]&lt;&lt;32;
	l |= (uvlong)c[5]&lt;&lt;40;
	return l;
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; Hsize)
		return 0;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += Hsize;

	switch(f-&gt;subop){
	case Oaflag:
		return h-&gt;aflag == f-&gt;ulv;
	case Ocmd:
		return h-&gt;cmd == f-&gt;ulv;
	case Ofeat:
		return h-&gt;feat == f-&gt;ulv;
	case Osectors:
		return h-&gt;sectors == f-&gt;ulv;
	case Olba:
		return llba(h-&gt;lba) == f-&gt;vlv;

	/* this is wrong, but we don't have access to the direction here */
	case Ostat:
		return h-&gt;cmd == f-&gt;ulv;
	case Oerr:
		return h-&gt;feat == f-&gt;ulv;
	}
	return 0;
}

static int
p_seprint(Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; Hsize)
		return 0;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += Hsize;

	/* no next protocol */
	m-&gt;pr = nil;

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "aflag=%ux errfeat=%ux sectors=%ux cmdstat=%ux lba=%lld",
		h-&gt;aflag, h-&gt;feat, h-&gt;sectors, h-&gt;cmd, llba(h-&gt;lba));
	return 0;
}

Proto aoeata =
{
	"aoeata",
	p_compile,
	p_filter,
	p_seprint,
	nil,
	nil,
	p_fields,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

