<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/dns.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/dns.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"
#include "../../ndb/dns.h"

/* names of RR types - /sys/src/cmd/ndb/dn.c:/rrtname */
char *rrtname[] =
{
[Ta]		"ip",
[Tns]		"ns",
[Tmd]		"md",
[Tmf]		"mf",
[Tcname]	"cname",
[Tsoa]		"soa",
[Tmb]		"mb",
[Tmg]		"mg",
[Tmr]		"mr",
[Tnull]		"null",
[Twks]		"wks",
[Tptr]		"ptr",
[Thinfo]	"hinfo",
[Tminfo]	"minfo",
[Tmx]		"mx",
[Ttxt]		"txt",
[Trp]		"rp",
[Tafsdb]	"afsdb",
[Tx25]		"x.25",
[Tisdn]		"isdn",
[Trt]		"rt",
[Tnsap]		"nsap",
[Tnsapptr]	"nsap-ptr",
[Tsig]		"sig",
[Tkey]		"key",
[Tpx]		"px",
[Tgpos]		"gpos",
[Taaaa]		"ipv6",
[Tloc]		"loc",
[Tnxt]		"nxt",
[Teid]		"eid",
[Tnimloc]	"nimrod",
[Tsrv]		"srv",
[Tatma]		"atma",
[Tnaptr]	"naptr",
[Tkx]		"kx",
[Tcert]		"cert",
[Ta6]		"a6",
[Tdname]	"dname",
[Tsink]		"sink",
[Topt]		"opt",
[Tapl]		"apl",
[Tds]		"ds",
[Tsshfp]	"sshfp",
[Tipseckey]	"ipseckey",
[Trrsig]	"rrsig",
[Tnsec]		"nsec",
[Tdnskey]	"dnskey",
[Tspf]		"spf",
[Tuinfo]	"uinfo",
[Tuid]		"uid",
[Tgid]		"gid",
[Tunspec]	"unspec",
[Ttkey]		"tkey",
[Ttsig]		"tsig",
[Tixfr]		"ixfr",
[Taxfr]		"axfr",
[Tmailb]	"mailb",
[Tmaila]	"maila",
[Tall]		"all",
		0,
};
static char*
rrtypestr(int t)
{
	char buf[20];

	if(t &gt;= 0 &amp;&amp; t &lt; nelem(rrtname) &amp;&amp; rrtname[t])
		return rrtname[t];
	snprint(buf, sizeof buf, "type%d", t);
	return buf;
}

static void
fmtrr(Msg *m, RR **rrp, int quest)
{
	Txt *t;
	RR *rr;

	rr = *rrp;
	if(rr == nil)
		return;
	*rrp = rr-&gt;next;

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "%s name=%s ttl=%lud",
		rrtypestr(rr-&gt;type),
		rr-&gt;owner-&gt;name, rr-&gt;ttl);
	if(!quest)
	switch(rr-&gt;type){
	default:
		break;
	case Thinfo:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " cpu=%s os=%s",
			rr-&gt;cpu-&gt;name, rr-&gt;os-&gt;name);
		break;
	case Tcname:
	case Tmb:
	case Tmd:
	case Tmf:
	case Tns:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " host=%s", rr-&gt;host-&gt;name);
		break;
	case Tmg:
	case Tmr:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " mb=%s", rr-&gt;mb-&gt;name);
		break;
	case Tminfo:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " rmb=%s", rr-&gt;rmb-&gt;name);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " mb=%s", rr-&gt;mb-&gt;name);
		break;
	case Tmx:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " pref=%lud", rr-&gt;pref);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " host=%s", rr-&gt;host-&gt;name);
		break;
	case Ta:
	case Taaaa:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " ip=%s", rr-&gt;ip-&gt;name);
		break;
	case Tptr:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " ptr=%s", rr-&gt;ptr-&gt;name);
		break;
	case Tsoa:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " host=%s", rr-&gt;host-&gt;name);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " rmb=%s", rr-&gt;rmb-&gt;name);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " soa.serial=%lud", rr-&gt;soa-&gt;serial);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " soa.refresh=%lud", rr-&gt;soa-&gt;refresh);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " soa.retry=%lud", rr-&gt;soa-&gt;retry);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " soa.expire=%lud", rr-&gt;soa-&gt;expire);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " soa.minttl=%lud", rr-&gt;soa-&gt;minttl);
		break;
	case Ttxt:
		for(t=rr-&gt;txt; t; t=t-&gt;next)
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, " txt=%q", t-&gt;p);
		break;
	case Tnull:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " null=%.*H",
			rr-&gt;null-&gt;dlen, rr-&gt;null-&gt;data);
		break;
	case Trp:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " rmb=%s", rr-&gt;rmb-&gt;name);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " rp=%s", rr-&gt;rp-&gt;name);
		break;
	case Tkey:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " flags=%d proto=%d alg=%d data=%.*H",
			rr-&gt;key-&gt;flags, rr-&gt;key-&gt;proto, rr-&gt;key-&gt;alg,
			rr-&gt;key-&gt;dlen, rr-&gt;key-&gt;data);
		break;
	case Tsig:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e,
" type=%d alg=%d labels=%d ttl=%lud exp=%lud incep=%lud tag=%d signer=%s data=%.*H",
			rr-&gt;sig-&gt;type, rr-&gt;sig-&gt;alg, rr-&gt;sig-&gt;labels,
			rr-&gt;sig-&gt;ttl, rr-&gt;sig-&gt;exp, rr-&gt;sig-&gt;incep, rr-&gt;sig-&gt;tag,
			rr-&gt;sig-&gt;signer-&gt;name, rr-&gt;sig-&gt;dlen, rr-&gt;sig-&gt;data);
		break;
	case Tcert:
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " type=%d tag=%d alg=%d data=%.*H",
			rr-&gt;cert-&gt;type, rr-&gt;cert-&gt;tag, rr-&gt;cert-&gt;alg,
			rr-&gt;cert-&gt;dlen, rr-&gt;cert-&gt;data);
		break;
	}
	rrfree(rr);
}

void freealldn(void);
static Proto dnsqd, dnsan, dnsns, dnsar;

static void donext(Msg*);
static DNSmsg dm;

static int
p_seprint(Msg *m)
{
	char *e;

	if((e = convM2DNS(m-&gt;ps, m-&gt;pe-m-&gt;ps, &amp;dm, nil)) != nil){
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, "error: %s", e);
		return 0;
	}
	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "id=%d flags=%#ux", dm.id, dm.flags);
	donext(m);
	return 0;
}

static void
donext(Msg *m)
{
	if(dm.qd)
		m-&gt;pr = &amp;dnsqd;
	else if(dm.an)
		m-&gt;pr = &amp;dnsan;
	else if(dm.ns)
		m-&gt;pr = &amp;dnsns;
	else if(dm.ar)
		m-&gt;pr = &amp;dnsar;
	else{
		freealldn();
		memset(&amp;dm, 0, sizeof dm);
		m-&gt;pr = nil;
	}
}

static int
p_seprintqd(Msg *m)
{
	fmtrr(m, &amp;dm.qd, 1);
	donext(m);
	return 0;
}

static int
p_seprintan(Msg *m)
{
	fmtrr(m, &amp;dm.an, 0);
	donext(m);
	return 0;
}

static int
p_seprintns(Msg *m)
{
	fmtrr(m, &amp;dm.ns, 1);
	donext(m);
	return 0;
}

static int
p_seprintar(Msg *m)
{
	fmtrr(m, &amp;dm.ar, 1);
	donext(m);
	return 0;
}

Proto dns =
{
	"dns",
	nil,
	nil,
	p_seprint,
	nil,
	nil,
	nil,
	defaultframer,
};

static Proto dnsqd =
{
	"dns.qd",
	nil,
	nil,
	p_seprintqd,
	nil,
	nil,
	nil,
	defaultframer,
};

static Proto dnsan =
{
	"dns.an",
	nil,
	nil,
	p_seprintan,
	nil,
	nil,
	nil,
	defaultframer,
};

static Proto dnsns =
{
	"dns.ns",
	nil,
	nil,
	p_seprintns,
	nil,
	nil,
	nil,
	defaultframer,
};

static Proto dnsar =
{
	"dns.ar",
	nil,
	nil,
	p_seprintar,
	nil,
	nil,
	nil,
	defaultframer,
};


void*
emalloc(int n)
{
	void *v;

	v = mallocz(n, 1);
	if(v == nil)
		sysfatal("out of memory");
	return v;
}

char*
estrdup(char *s)
{
	s = strdup(s);
	if(s == nil)
		sysfatal("out of memory");
	return s;
}

DN *alldn;

DN*
dnlookup(char *name, int class, int)
{
	DN *dn;

	dn = emalloc(sizeof *dn);
	dn-&gt;name = estrdup(name);
	dn-&gt;class = class;
	dn-&gt;magic = DNmagic;
	dn-&gt;next = alldn;
	alldn = dn;
	return dn;
}

void
freealldn(void)
{
	DN *dn;

	while(dn = alldn){
		alldn = dn-&gt;next;
		free(dn-&gt;name);
		free(dn);
	}
}

int debug;				/* for ndb/dns.h */
ulong now = 0;

void
dnslog(char *fmt, ...)			/* don't log */
{
	USED(fmt);
}

/*************************************************
 * Everything below here is copied from /sys/src/cmd/ndb/dn.c
 * without modification and can be recopied to update.
 */

/*
 *  convert an integer RR type to it's ascii name
 */
char*
rrname(int type, char *buf, int len)
{
	char *t;

	t = nil;
	if(type &gt;= 0 &amp;&amp; type &lt;= Tall)
		t = rrtname[type];
	if(t==nil){
		snprint(buf, len, "%d", type);
		t = buf;
	}
	return t;
}

/*
 *  free a list of resource records and any related structs
 */
void
rrfreelist(RR *rp)
{
	RR *next;

	for(; rp; rp = next){
		next = rp-&gt;next;
		rrfree(rp);
	}
}

void
freeserverlist(Server *s)
{
	Server *next;

	for(; s != nil; s = next){
		next = s-&gt;next;
		free(s);
	}
}

/*
 *  allocate a resource record of a given type
 */
RR*
rralloc(int type)
{
	RR *rp;

	rp = emalloc(sizeof(*rp));
	rp-&gt;magic = RRmagic;
	rp-&gt;pc = getcallerpc(&amp;type);
	rp-&gt;type = type;
	setmalloctag(rp, rp-&gt;pc);
	switch(type){
	case Tsoa:
		rp-&gt;soa = emalloc(sizeof(*rp-&gt;soa));
		rp-&gt;soa-&gt;slaves = nil;
		setmalloctag(rp-&gt;soa, rp-&gt;pc);
		break;
	case Tsrv:
		rp-&gt;srv = emalloc(sizeof(*rp-&gt;srv));
		setmalloctag(rp-&gt;srv, rp-&gt;pc);
		break;
	case Tkey:
		rp-&gt;key = emalloc(sizeof(*rp-&gt;key));
		setmalloctag(rp-&gt;key, rp-&gt;pc);
		break;
	case Tcert:
		rp-&gt;cert = emalloc(sizeof(*rp-&gt;cert));
		setmalloctag(rp-&gt;cert, rp-&gt;pc);
		break;
	case Tsig:
		rp-&gt;sig = emalloc(sizeof(*rp-&gt;sig));
		setmalloctag(rp-&gt;sig, rp-&gt;pc);
		break;
	case Tnull:
		rp-&gt;null = emalloc(sizeof(*rp-&gt;null));
		setmalloctag(rp-&gt;null, rp-&gt;pc);
		break;
	}
	rp-&gt;ttl = 0;
	rp-&gt;expire = 0;
	rp-&gt;next = 0;
	return rp;
}

/*
 *  free a resource record and any related structs
 */
void
rrfree(RR *rp)
{
	DN *dp;
	RR *nrp;
	Txt *t;

	assert(rp-&gt;magic = RRmagic);
	assert(!rp-&gt;cached);

	dp = rp-&gt;owner;
	if(dp){
		assert(dp-&gt;magic == DNmagic);
		for(nrp = dp-&gt;rr; nrp; nrp = nrp-&gt;next)
			assert(nrp != rp);	/* "rrfree of live rr" */
	}

	switch(rp-&gt;type){
	case Tsoa:
		freeserverlist(rp-&gt;soa-&gt;slaves);
		memset(rp-&gt;soa, 0, sizeof *rp-&gt;soa);	/* cause trouble */
		free(rp-&gt;soa);
		break;
	case Tsrv:
		memset(rp-&gt;srv, 0, sizeof *rp-&gt;srv);	/* cause trouble */
		free(rp-&gt;srv);
		break;
	case Tkey:
		free(rp-&gt;key-&gt;data);
		memset(rp-&gt;key, 0, sizeof *rp-&gt;key);	/* cause trouble */
		free(rp-&gt;key);
		break;
	case Tcert:
		free(rp-&gt;cert-&gt;data);
		memset(rp-&gt;cert, 0, sizeof *rp-&gt;cert);	/* cause trouble */
		free(rp-&gt;cert);
		break;
	case Tsig:
		free(rp-&gt;sig-&gt;data);
		memset(rp-&gt;sig, 0, sizeof *rp-&gt;sig);	/* cause trouble */
		free(rp-&gt;sig);
		break;
	case Tnull:
		free(rp-&gt;null-&gt;data);
		memset(rp-&gt;null, 0, sizeof *rp-&gt;null);	/* cause trouble */
		free(rp-&gt;null);
		break;
	case Ttxt:
		while(rp-&gt;txt != nil){
			t = rp-&gt;txt;
			rp-&gt;txt = t-&gt;next;
			free(t-&gt;p);
			memset(t, 0, sizeof *t);	/* cause trouble */
			free(t);
		}
		break;
	}

	rp-&gt;magic = ~rp-&gt;magic;
	memset(rp, 0, sizeof *rp);		/* cause trouble */
	free(rp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

