<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/icmp6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/icmp6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr	Hdr;
struct Hdr
{	uchar	type;
	uchar	code;
	uchar	cksum[2];	/* Checksum */
	uchar	data[1];
};

enum
{
	ICMP6LEN=	4,
};

enum
{
	Ot,	/* type */
	Op,	/* next protocol */
};

static Field p_fields[] =
{
	{"t",		Fnum,	Ot,	"type",	} ,
	{0}
};

enum
{
	/* ICMPv6 types */
	EchoReply	= 0,
	UnreachableV6	= 1,
	PacketTooBigV6	= 2,
	TimeExceedV6	= 3,
	ParamProblemV6	= 4,
	Redirect	= 5,
	EchoRequest	= 8,
	TimeExceed	= 11,
	InParmProblem	= 12,
	Timestamp	= 13,
	TimestampReply	= 14,
	InfoRequest	= 15,
	InfoReply	= 16,
	AddrMaskRequest = 17,
	AddrMaskReply   = 18,
	EchoRequestV6	= 128,
	EchoReplyV6	= 129,
	RouterSolicit	= 133,
	RouterAdvert	= 134,
	NbrSolicit	= 135,
	NbrAdvert	= 136,
	RedirectV6	= 137,

	Maxtype6	= 137,
};

static Mux p_mux[] =
{
	{"ip6",	UnreachableV6, },
	{"ip6",	RedirectV6, },
	{"ip6",	TimeExceedV6, },
	{0},
};

char *icmpmsg6[256] =
{
[EchoReply]		"EchoReply",
[UnreachableV6]		"UnreachableV6",
[PacketTooBigV6]	"PacketTooBigV6",
[TimeExceedV6]		"TimeExceedV6",
[Redirect]		"Redirect",
[EchoRequest]		"EchoRequest",
[TimeExceed]		"TimeExceed",
[InParmProblem]		"InParmProblem",
[Timestamp]		"Timestamp",
[TimestampReply]	"TimestampReply",
[InfoRequest]		"InfoRequest",
[InfoReply]		"InfoReply",
[AddrMaskRequest]	"AddrMaskRequest",
[AddrMaskReply]		"AddrMaskReply",
[EchoRequestV6]		"EchoRequestV6",
[EchoReplyV6]		"EchoReplyV6",
[RouterSolicit]		"RouterSolicit",
[RouterAdvert]		"RouterAdvert",
[NbrSolicit]		"NbrSolicit",
[NbrAdvert]		"NbrAdvert",
[RedirectV6]		"RedirectV6",
};

static char *unreachcode[] =
{
[0]	"no route to destination",
[1]	"comm with destination administratively prohibited",
[2]	"icmp unreachable: unassigned error code (2)",
[3]	"address unreachable",
[4]	"port unreachable",
[5]	"icmp unreachable: unknown code",
};

static char *timexcode[] =
{
[0]	"hop limit exc",
[1]	"reassmbl time exc",
[2]	"icmp time exc: unknown code",
};

static char *parpcode[] =
{
[0]	"erroneous header field encountered",
[1]	"unrecognized Next Header type encountered",
[2]	"unrecognized IPv6 option encountered",
[3]	"icmp par prob: unknown code",
};
enum
{
	sll	= 1,
	tll	= 2,
	pref	= 3,
	redir	= 4,
	mtu	= 5,
};

static char *icmp6opts[256] =
{
[0]	"unknown opt",
[1]	"sll_addr",
[2]	"tll_addr",
[3]	"pref_opt",
[4]	"redirect",
[5]	"mtu_opt",
};

static void
p_compile(Filter *f)
{
	if(f-&gt;op == '='){
		compile_cmp(icmp6.name, f, p_fields);
		return;
	}
	if(strcmp(f-&gt;s, "ip6") == 0){
		f-&gt;pr = p_mux-&gt;pr;
		f-&gt;subop = Op;
		return;
	}
	sysfatal("unknown icmp field or protocol: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; ICMP6LEN)
		return 0;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += ICMP6LEN;

	switch(f-&gt;subop){

	case Ot:
		if(h-&gt;type == f-&gt;ulv)
			return 1;
		break;
	case Op:
		switch(h-&gt;type){
		case UnreachableV6:
		case RedirectV6:
		case TimeExceedV6:
			m-&gt;ps += 4;
			return 1;
		}
	}
	return 0;
}

static char*
opt_seprint(Msg *m)
{
	int otype, osz, pktsz;
	uchar *a;
	char *p = m-&gt;p;
	char *e = m-&gt;e;
	char *opt;
	char optbuf[12];

	pktsz = m-&gt;pe - m-&gt;ps;
	a = m-&gt;ps;
	while (pktsz &gt; 0) {
		otype = *a;
		opt = icmp6opts[otype];
		if(opt == nil){
			sprint(optbuf, "0x%ux", otype);
			opt = optbuf;
		}
		osz = (*(a+1)) * 8;

		switch (otype) {
		default:
			p = seprint(p, e, "\n	  option=%s ", opt);
			m-&gt;pr = &amp;dump;
			return p;

		case sll:
		case tll:
			if (pktsz &lt; osz || osz != 8) {
				p = seprint(p, e, "\n	  option=%s bad size=%d",
					opt, osz);
				m-&gt;pr = &amp;dump;
				return p;
			}
			p = seprint(p, e, "\n	  option=%s maddr=%E", opt, a+2);
			pktsz -= osz;
			a += osz;
			break;

		case pref:
			if ((pktsz &lt; osz) || (osz != 32)) {
				p = seprint(p, e, "\n	  option=%s: bad size=%d",
					opt, osz);
				m-&gt;pr = &amp;dump;
				return p;
			}

			p = seprint(p, e, "\n	  option=%s pref=%I "
				"preflen=%3.3d lflag=%1.1d aflag=%1.1d "
				"unused1=%1.1d validlt=%d preflt=%d unused2=%1.1d",
				opt,
				a+16,
				(int) (*(a+2)),
				(*(a+3) &amp; (1 &lt;&lt; 7)) != 0,
				(*(a+3) &amp; (1 &lt;&lt; 6)) != 0,
				(*(a+3) &amp; 63) != 0,
				NetL(a+4),
				NetL(a+8),
				NetL(a+12)!=0);

			pktsz -= osz;
			a += osz;
			break;

		case redir:
			if (pktsz &lt; osz) {
				p = seprint(p, e, "\n	  option=%s: bad size=%d",
					opt, osz);
				m-&gt;pr = &amp;dump;
				return p;
			}

			p = seprint(p, e, "\n	  option=%s len %d", opt, osz);
			a += osz;
			m-&gt;ps = a;
			return p;

		case mtu:
			if (pktsz &lt; osz || osz != 8) {
				p = seprint(p, e, "\n	  option=%s: bad size=%d",
					opt, osz);
				m-&gt;pr = &amp;dump;
				return p;
			}

			p = seprint(p, e, "\n	  option=%s unused=%1.1d mtu=%d",
				opt, NetL(a+2) != 0, NetL(a+4));
			pktsz -= osz;
			a += osz;
			break;
		}
	}

	m-&gt;ps = a;
	return p;
}

static int
p_seprint(Msg *m)
{
	int i;
//	ushort cksum2, cksum;
	char *tn;
	char *p = m-&gt;p;
	char *e = m-&gt;e;
	uchar *a;
	Hdr *h;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += ICMP6LEN;
	m-&gt;pr = &amp;dump;
	a = m-&gt;ps;

	if(m-&gt;pe - m-&gt;ps &lt; ICMP6LEN)
		return -1;

	tn = icmpmsg6[h-&gt;type];
	if(tn == nil)
		p = seprint(p, e, "t=%ud c=%d ck=%4.4ux", h-&gt;type,
			h-&gt;code, (ushort)NetS(h-&gt;cksum));
	else
		p = seprint(p, e, "t=%s c=%d ck=%4.4ux", tn,
			h-&gt;code, (ushort)NetS(h-&gt;cksum));

/*
	if(Cflag){
		cksum = NetS(h-&gt;cksum);
		h-&gt;cksum[0] = 0;
		h-&gt;cksum[1] = 0;
		cksum2 = ~ptclbsum((uchar*)h, m-&gt;pe - m-&gt;ps + ICMP6LEN) &amp; 0xffff;
		if(cksum != cksum2)
			p = seprint(p,e, " !ck=%4.4ux", cksum2);
	}
 */

	switch(h-&gt;type){

	case UnreachableV6:
		m-&gt;ps += 4;
		m-&gt;pr = &amp;ip6;
		if (h-&gt;code &gt;= nelem(unreachcode))
			i = nelem(unreachcode)-1;
		else
			i = h-&gt;code;
		p = seprint(p, e, " code=%s unused=%1.1d ", unreachcode[i],
			NetL(a) != 0);
		break;

	case PacketTooBigV6:
		m-&gt;ps += 4;
		m-&gt;pr = &amp;ip6;
		p = seprint(p, e, " mtu=%4.4d ", NetL(a));
		break;

	case TimeExceedV6:
		m-&gt;ps += 4;
		m-&gt;pr = &amp;ip6;
		if (h-&gt;code &gt;= nelem(timexcode))
			i = nelem(timexcode)-1;
		else
			i = h-&gt;code;
		p = seprint(p, e, " code=%s unused=%1.1d ", timexcode[i],
			NetL(a) != 0);
		break;

	case ParamProblemV6:
		m-&gt;ps += 4;
		m-&gt;pr = &amp;ip6;
		if (h-&gt;code &gt; nelem(parpcode))
			i = nelem(parpcode)-1;
		else
			i = h-&gt;code;
		p = seprint(p, e, " code=%s ptr=%2.2ux", parpcode[i], h-&gt;data[0]);
		break;

	case EchoReplyV6:
	case EchoRequestV6:
		m-&gt;ps += 4;
		p = seprint(p, e, " id=%ux seq=%ux",
			NetS(h-&gt;data), NetS(h-&gt;data+2));
		break;

	case RouterSolicit:
		m-&gt;ps += 4;
		m-&gt;pr = nil;
		m-&gt;p = seprint(p, e, " unused=%1.1d ", NetL(a)!=0);
		p = opt_seprint(m);
		break;

	case RouterAdvert:
		m-&gt;ps += 12;
		m-&gt;pr = nil;
		m-&gt;p = seprint(p, e, " hoplim=%3.3d mflag=%1.1d oflag=%1.1d "
			"unused=%1.1d routerlt=%8.8d reachtime=%d rxmtimer=%d",
			(int) *a,
			(*(a+1) &amp; (1 &lt;&lt; 7)) != 0,
			(*(a+1) &amp; (1 &lt;&lt; 6)) != 0,
			(*(a+1) &amp; 63) != 0,
			NetS(a+2),
			NetL(a+4),
			NetL(a+8));
		p = opt_seprint(m);
		break;

	case NbrSolicit:
		m-&gt;ps += 20;
		m-&gt;pr = nil;
		m-&gt;p = seprint(p, e, " unused=%1.1d targ %I", NetL(a) != 0, a+4);
		p = opt_seprint(m);
		break;

	case NbrAdvert:
		m-&gt;ps += 20;
		m-&gt;pr = nil;
		m-&gt;p = seprint(p, e, " rflag=%1.1d sflag=%1.1d oflag=%1.1d targ=%I",
			(*a &amp; (1 &lt;&lt; 7)) != 0,
			(*a &amp; (1 &lt;&lt; 6)) != 0,
			(*a &amp; (1 &lt;&lt; 5)) != 0,
			a+4);
		p = opt_seprint(m);
		break;

	case RedirectV6:
		m-&gt;ps += 36;
		m-&gt;pr = &amp;ip6;
		m-&gt;p = seprint(p, e, " unused=%1.1d targ=%I dest=%I",
			NetL(a) != 0, a+4, a+20);
		p = opt_seprint(m);
		break;

	case Timestamp:
	case TimestampReply:
		m-&gt;ps += 12;
		p = seprint(p, e, " orig=%ud rcv=%ux xmt=%ux",
			NetL(h-&gt;data), NetL(h-&gt;data+4), NetL(h-&gt;data+8));
		m-&gt;pr = nil;
		break;

	case InfoRequest:
	case InfoReply:
		break;

	}
	m-&gt;p = p;
	return 0;
}

Proto icmp6 =
{
	"icmp6",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%lud",
	p_fields,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

