<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * snoopy - network sniffer
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;bio.h&gt;
#include &lt;fcall.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ndb.h&gt;
#include "dat.h"
#include "protos.h"
#include "y.tab.h"

int Cflag;
int pflag;
int Nflag;
int Mflag;
int sflag;
int tiflag;
int toflag;

char *prom = "promiscuous";

enum
{
	Pktlen=	64*1024,
	Blen=	16*1024,
};

Filter *filter;
Proto *root;
Biobuf out;
vlong starttime, pkttime;
int pcap;

int	filterpkt(Filter *f, uchar *ps, uchar *pe, Proto *pr, int);
void	printpkt(char *p, char *e, uchar *ps, uchar *pe);
void	mkprotograph(void);
Proto*	findproto(char *name);
Filter*	compile(Filter *f);
void	printfilter(Filter *f, char *tag);
void	printhelp(char*);
void	tracepkt(uchar*, int);
void	pcaphdr(void);

void
printusage(void)
{
	fprint(2, "usage: %s [-CDdpst] [-N n] [-f filter] [-h first-header] path\n", argv0);
	fprint(2, "  for protocol help: %s -? [proto]\n", argv0);
}

void
usage(void)
{
	printusage();
	exits("usage");
}

void
main(int argc, char **argv)
{
	uchar *pkt;
	char *buf, *file, *p, *e;
	int fd, cfd;
	int n;

	Binit(&amp;out, 1, OWRITE);

	fmtinstall('E', eipfmt);
	fmtinstall('V', eipfmt);
	fmtinstall('I', eipfmt);
	fmtinstall('H', encodefmt);
	fmtinstall('F', fcallfmt);

	pkt = malloc(Pktlen+16);
	pkt += 16;
	buf = malloc(Blen);
	e = buf+Blen-1;

	pflag = 1;
	Nflag = 32;
	sflag = 0;

	mkprotograph();

	ARGBEGIN{
	default:
		usage();
	case '?':
		printusage();
		printhelp(ARGF());
		exits(0);
		break;
	case 'M':
		p = EARGF(usage());
		Mflag = atoi(p);
		break;
	case 'N':
		p = EARGF(usage());
		Nflag = atoi(p);
		break;
	case 'f':
		p = EARGF(usage());
		yyinit(p);
		yyparse();
		break;
	case 's':
		sflag = 1;
		break;
	case 'h':
		p = EARGF(usage());
		root = findproto(p);
		if(root == nil)
			sysfatal("unknown protocol: %s", p);
		break;
	case 'd':
		toflag = 1;
		break;
	case 'D':
		toflag = 1;
		pcap = 1;
		break;
	case 't':
		tiflag = 1;
		break;
	case 'C':
		Cflag = 1;
		break;
	case 'p':
		pflag = 0;
		break;
	}ARGEND;

	if(pcap)
		pcaphdr();

	if(argc == 0){
		file = "/net/ether0";
		if(root != nil)
			root = &amp;ether;
	} else
		file = argv[0];

	if((!tiflag) &amp;&amp; strstr(file, "ether")){
		if(root == nil)
			root = &amp;ether;
		snprint(buf, Blen, "%s!-1", file);
		fd = dial(buf, 0, 0, &amp;cfd);
		if(fd &lt; 0)
			sysfatal("dialing %s: %r", buf);
		if(pflag &amp;&amp; fprint(cfd, prom, strlen(prom)) &lt; 0)
			sysfatal("setting %s", prom);
	} else if((!tiflag) &amp;&amp; strstr(file, "ipifc")){
		if(root == nil)
			root = &amp;ip;
		snprint(buf, Blen, "%s/snoop", file);
		fd = open(buf, OREAD);
		if(fd &lt; 0)
			sysfatal("opening %s: %r", buf);
	} else {
		if(root == nil)
			root = &amp;ether;
		fd = open(file, OREAD);
		if(fd &lt; 0)
			sysfatal("opening %s: %r", file);
	}
	filter = compile(filter);

	if(tiflag){
		/* read a trace file */
		for(;;){
			n = read(fd, pkt, 10);
			if(n != 10)
				break;
			pkttime = NetL(pkt+2);
			pkttime = (pkttime&lt;&lt;32) | NetL(pkt+6);
			if(starttime == 0LL)
				starttime = pkttime;
			n = NetS(pkt);
			if(readn(fd, pkt, n) != n)
				break;
			if(filterpkt(filter, pkt, pkt+n, root, 1))
				if(toflag)
					tracepkt(pkt, n);
				else
					printpkt(buf, e, pkt, pkt+n);
		}
	} else {
		/* read a real time stream */
		starttime = nsec();
		for(;;){
			n = root-&gt;framer(fd, pkt, Pktlen);
			if(n &lt;= 0)
				break;
			pkttime = nsec();
			if(filterpkt(filter, pkt, pkt+n, root, 1))
				if(toflag)
					tracepkt(pkt, n);
				else
					printpkt(buf, e, pkt, pkt+n);
		}
	}
}

/* create a new filter node */
Filter*
newfilter(void)
{
	Filter *f;

	f = mallocz(sizeof(*f), 1);
	if(f == nil)
		sysfatal("newfilter: %r");
	return f;
}

/*
 *  apply filter to packet
 */
int
_filterpkt(Filter *f, Msg *m)
{
	Msg ma;

	if(f == nil)
		return 1;

	switch(f-&gt;op){
	case '!':
		return !_filterpkt(f-&gt;l, m);
	case LAND:
		ma = *m;
		return _filterpkt(f-&gt;l, &amp;ma) &amp;&amp; _filterpkt(f-&gt;r, m);
	case LOR:
		ma = *m;
		return _filterpkt(f-&gt;l, &amp;ma) || _filterpkt(f-&gt;r, m);
	case WORD:
		if(m-&gt;needroot){
			if(m-&gt;pr != f-&gt;pr)
				return 0;
			m-&gt;needroot = 0;
		}else{
			if(m-&gt;pr &amp;&amp; (m-&gt;pr-&gt;filter==nil || !(m-&gt;pr-&gt;filter)(f, m)))
				return 0;
		}
		if(f-&gt;l == nil)
			return 1;
		m-&gt;pr = f-&gt;pr;
		return _filterpkt(f-&gt;l, m);
	}
	sysfatal("internal error: filterpkt op: %d", f-&gt;op);
	return 0;
}
int
filterpkt(Filter *f, uchar *ps, uchar *pe, Proto *pr, int needroot)
{
	Msg m;

	if(f == nil)
		return 1;

	m.needroot = needroot;
	m.ps = ps;
	m.pe = pe;
	m.pr = pr;
	return _filterpkt(f, &amp;m);
}

/*
 *  from the Unix world
 */
#define PCAP_VERSION_MAJOR 2
#define PCAP_VERSION_MINOR 4
#define TCPDUMP_MAGIC 0xa1b2c3d4

struct pcap_file_header {
	ulong		magic;
	ushort		version_major;
	ushort		version_minor;
	long		thiszone;    /* gmt to local correction */
	ulong		sigfigs;    /* accuracy of timestamps */
	ulong		snaplen;    /* max length saved portion of each pkt */
	ulong		linktype;   /* data link type (DLT_*) */
};

struct pcap_pkthdr {
        uvlong	ts;	/* time stamp */
        ulong	caplen;	/* length of portion present */
        ulong	len;	/* length this packet (off wire) */
};

/*
 *  pcap trace header 
 */
void
pcaphdr(void)
{
	struct pcap_file_header hdr;

	hdr.magic = TCPDUMP_MAGIC;
	hdr.version_major = PCAP_VERSION_MAJOR;
	hdr.version_minor = PCAP_VERSION_MINOR;
  
	hdr.thiszone = 0;
	hdr.snaplen = 1500;
	hdr.sigfigs = 0;
	hdr.linktype = 1;

	write(1, &amp;hdr, sizeof(hdr));
}

/*
 *  write out a packet trace
 */
void
tracepkt(uchar *ps, int len)
{
	struct pcap_pkthdr *goo;

	if(Mflag &amp;&amp; len &gt; Mflag)
		len = Mflag;
	if(pcap){
		goo = (struct pcap_pkthdr*)(ps-16);
		goo-&gt;ts = pkttime;
		goo-&gt;caplen = len;
		goo-&gt;len = len;
		write(1, goo, len+16);
	} else {
		hnputs(ps-10, len);
		hnputl(ps-8, pkttime&gt;&gt;32);
		hnputl(ps-4, pkttime);
		write(1, ps-10, len+10);
	}
}

/*
 *  format and print a packet
 */
void
printpkt(char *p, char *e, uchar *ps, uchar *pe)
{
	Msg m;
	ulong dt;

	dt = (pkttime-starttime)/1000000LL;
	m.p = seprint(p, e, "%6.6uld ms ", dt);
	m.ps = ps;
	m.pe = pe;
	m.e = e;
	m.pr = root;
	while(m.p &lt; m.e){
		if(!sflag)
			m.p = seprint(m.p, m.e, "\n\t");
		m.p = seprint(m.p, m.e, "%s(", m.pr-&gt;name);
		if((*m.pr-&gt;seprint)(&amp;m) &lt; 0){
			m.p = seprint(m.p, m.e, "TOO SHORT");
			m.ps = m.pe;
		}
		m.p = seprint(m.p, m.e, ")");
		if(m.pr == nil || m.ps &gt;= m.pe)
			break;
	}
	*m.p++ = '\n';

	if(write(1, p, m.p - p) &lt; 0)
		sysfatal("stdout: %r");
}

Proto **xprotos;
int nprotos;

/* look up a protocol by its name */
Proto*
findproto(char *name)
{
	int i;

	for(i = 0; i &lt; nprotos; i++)
		if(strcmp(xprotos[i]-&gt;name, name) == 0)
			return xprotos[i];
	return nil;
}

/*
 *  add an undefined protocol to protos[]
 */
Proto*
addproto(char *name)
{
	Proto *pr;

	xprotos = realloc(xprotos, (nprotos+1)*sizeof(Proto*));
	pr = malloc(sizeof *pr);
	*pr = dump;
	pr-&gt;name = name;
	xprotos[nprotos++] = pr;
	return pr;
}

/*
 *  build a graph of protocols, this could easily be circular.  This
 *  links together all the multiplexing in the protocol modules.
 */
void
mkprotograph(void)
{
	Proto **l;
	Proto *pr;
	Mux *m;

	/* copy protos into a reallocable area */
	for(nprotos = 0; protos[nprotos] != nil; nprotos++)
		;
	xprotos = malloc(nprotos*sizeof(Proto*));
	memmove(xprotos, protos, nprotos*sizeof(Proto*));

	for(l = protos; *l != nil; l++){
		pr = *l;
		for(m = pr-&gt;mux; m != nil &amp;&amp; m-&gt;name != nil; m++){
			m-&gt;pr = findproto(m-&gt;name);
			if(m-&gt;pr == nil)
				m-&gt;pr = addproto(m-&gt;name);
		}
	}
}

/*
 *  add in a protocol node
 */
static Filter*
addnode(Filter *f, Proto *pr)
{
	Filter *nf;
	nf = newfilter();
	nf-&gt;pr = pr;
	nf-&gt;s = pr-&gt;name;
	nf-&gt;l = f;
	nf-&gt;op = WORD;
	return nf;
}

/*
 *  recurse through the protocol graph adding missing nodes
 *  to the filter if we reach the filter's protocol
 */
static Filter*
_fillin(Filter *f, Proto *last, int depth)
{
	Mux *m;
	Filter *nf;

	if(depth-- &lt;= 0)
		return nil;

	for(m = last-&gt;mux; m != nil &amp;&amp; m-&gt;name != nil; m++){
		if(m-&gt;pr == nil)
			continue;
		if(f-&gt;pr == m-&gt;pr)
			return f;
		nf = _fillin(f, m-&gt;pr, depth);
		if(nf != nil)
			return addnode(nf, m-&gt;pr);
	}
	return nil;
}

static Filter*
fillin(Filter *f, Proto *last)
{
	int i;
	Filter *nf;

	/* hack to make sure top level node is the root */
	if(last == nil){
		if(f-&gt;pr == root)
			return f;
		f = fillin(f, root);
		if(f == nil)
			return nil;
		return addnode(f, root);
	}

	/* breadth first search though the protocol graph */
	nf = f;
	for(i = 1; i &lt; 20; i++){
		nf = _fillin(f, last, i);
		if(nf != nil)
			break;
	}
	return nf;
}

/*
 *  massage tree so that all paths from the root to a leaf
 *  contain a filter node for each header.
 *
 *  also, set f-&gt;pr where possible
 */
Filter*
complete(Filter *f, Proto *last)
{
	Proto *pr;

	if(f == nil)
		return f;

	/* do a depth first traversal of the filter tree */
	switch(f-&gt;op){
	case '!':
		f-&gt;l = complete(f-&gt;l, last);
		break;
	case LAND:
	case LOR:
		f-&gt;l = complete(f-&gt;l, last);
		f-&gt;r = complete(f-&gt;r, last);
		break;
	case '=':
		break;
	case WORD:
		pr = findproto(f-&gt;s);
		f-&gt;pr = pr;
		if(pr == nil){
			if(f-&gt;l != nil){
				fprint(2, "%s unknown proto, ignoring params\n",
					f-&gt;s);
				f-&gt;l = nil;
			}
		} else {
			f-&gt;l = complete(f-&gt;l, pr);
			f = fillin(f, last);
			if(f == nil)
				sysfatal("internal error: can't get to %s", pr-&gt;name);
		}
		break;
	}
	return f;
}

/*
 *  merge common nodes under | and &amp; moving the merged node
 *  above the | or &amp;.
 *
 *  do some constant foldong, e.g. `true &amp; x' becomes x and
 *  'true | x' becomes true.
 */
static int changed;

static Filter*
_optimize(Filter *f)
{
	Filter *l;

	if(f == nil)
		return f;

	switch(f-&gt;op){
	case '!':
		/* is child also a not */
		if(f-&gt;l-&gt;op == '!'){
			changed = 1;
			return f-&gt;l-&gt;l;
		}
		break;
	case LOR:
		/* are two children the same protocol? */
		if(f-&gt;l-&gt;op != f-&gt;r-&gt;op || f-&gt;r-&gt;op != WORD
		|| f-&gt;l-&gt;pr != f-&gt;r-&gt;pr || f-&gt;l-&gt;pr == nil)
			break;	/* no optimization */

		changed = 1;

		/* constant folding */
		/* if either child is childless, just return that */
		if(f-&gt;l-&gt;l == nil)
			return f-&gt;l;
		else if(f-&gt;r-&gt;l == nil)
			return f-&gt;r;

		/* move the common node up, thow away one node */
		l = f-&gt;l;
		f-&gt;l = l-&gt;l;
		f-&gt;r = f-&gt;r-&gt;l;
		l-&gt;l = f;
		return l;
	case LAND:
		/* are two children the same protocol? */
		if(f-&gt;l-&gt;op != f-&gt;r-&gt;op || f-&gt;r-&gt;op != WORD
		|| f-&gt;l-&gt;pr != f-&gt;r-&gt;pr || f-&gt;l-&gt;pr == nil)
			break;	/* no optimization */

		changed = 1;

		/* constant folding */
		/* if either child is childless, ignore it */
		if(f-&gt;l-&gt;l == nil)
			return f-&gt;r;
		else if(f-&gt;r-&gt;l == nil)
			return f-&gt;l;

		/* move the common node up, thow away one node */
		l = f-&gt;l;
		f-&gt;l = _optimize(l-&gt;l);
		f-&gt;r = _optimize(f-&gt;r-&gt;l);
		l-&gt;l = f;
		return l;
	}
	f-&gt;l = _optimize(f-&gt;l);
	f-&gt;r = _optimize(f-&gt;r);
	return f;
}

Filter*
optimize(Filter *f)
{
	do{
		changed = 0;
		f = _optimize(f);
	}while(changed);

	return f;
}

/*
 *  find any top level nodes that aren't the root
 */
int
findbogus(Filter *f)
{
	int rv;

	if(f-&gt;op != WORD){
		rv = findbogus(f-&gt;l);
		if(f-&gt;r)
			rv |= findbogus(f-&gt;r);
		return rv;
	} else if(f-&gt;pr != root){
		fprint(2, "bad top-level protocol: %s\n", f-&gt;s);
		return 1;
	}
	return 0;
}

/*
 *  compile the filter
 */
static void
_compile(Filter *f, Proto *last)
{
	if(f == nil)
		return;

	switch(f-&gt;op){
	case '!':
		_compile(f-&gt;l, last);
		break;
	case LOR:
	case LAND:
		_compile(f-&gt;l, last);
		_compile(f-&gt;r, last);
		break;
	case WORD:
		if(last != nil){
			if(last-&gt;compile == nil)
				sysfatal("unknown %s subprotocol: %s", f-&gt;pr-&gt;name, f-&gt;s);
			(*last-&gt;compile)(f);
		}
		if(f-&gt;l)
			_compile(f-&gt;l, f-&gt;pr);
		break;
	case '=':
		if(last == nil)
			sysfatal("internal error: compilewalk: badly formed tree");
		
		if(last-&gt;compile == nil)
			sysfatal("unknown %s field: %s", f-&gt;pr-&gt;name, f-&gt;s);
		(*last-&gt;compile)(f);
		break;
	default:
		sysfatal("internal error: compilewalk op: %d", f-&gt;op);
	}
}

Filter*
compile(Filter *f)
{
	if(f == nil)
		return f;

	/* fill in the missing header filters */
	f = complete(f, nil);

	/* constant folding */
	f = optimize(f);
	if(!toflag)
		printfilter(f, "after optimize");

	/* protocol specific compilations */
	_compile(f, nil);

	/* at this point, the root had better be the root proto */
	if(findbogus(f)){
		fprint(2, "bogus filter\n");
		exits("bad filter");
	}

	return f;
}

/*
 *  parse a byte array
 */
int
parseba(uchar *to, char *from)
{
	char nip[4];
	char *p;
	int i;

	p = from;
	for(i = 0; i &lt; 16; i++){
		if(*p == 0)
			return -1;
		nip[0] = *p++;
		if(*p == 0)
			return -1;
		nip[1] = *p++;
		nip[2] = 0;
		to[i] = strtoul(nip, 0, 16);
	}
	return i;
}

/*
 *  compile WORD = WORD, becomes a single node with a subop
 */
void
compile_cmp(char *proto, Filter *f, Field *fld)
{
	uchar x[IPaddrlen];
	char *v;

	if(f-&gt;op != '=')
		sysfatal("internal error: compile_cmp %s: not a cmp", proto);

	for(; fld-&gt;name != nil; fld++){
		if(strcmp(f-&gt;l-&gt;s, fld-&gt;name) == 0){
			f-&gt;op = WORD;
			f-&gt;subop = fld-&gt;subop;
			switch(fld-&gt;ftype){
			case Fnum:
				f-&gt;ulv = atoi(f-&gt;r-&gt;s);
				break;
			case Fether:
				v = csgetvalue(nil, "sys", (char*)f-&gt;r-&gt;s,
					"ether", 0);
				if(v){
					parseether(f-&gt;a, v);
					free(v);
				} else
					parseether(f-&gt;a, f-&gt;r-&gt;s);
				break;
			case Fv4ip:
				v = csgetvalue(nil, "sys", (char*)f-&gt;r-&gt;s,
					"ip", 0);
				if(v){
					f-&gt;ulv = parseip(x, v);
					free(v);
				}else
					f-&gt;ulv = parseip(x, f-&gt;r-&gt;s);
				break;
			case Fv6ip:
				v = csgetvalue(nil, "sys", (char*)f-&gt;r-&gt;s,
					"ipv6", 0);
				if(v){
					parseip(f-&gt;a, v);
					free(v);
				}else
					parseip(f-&gt;a, f-&gt;r-&gt;s);
				break;
			case Fba:
				parseba(f-&gt;a, f-&gt;r-&gt;s);
				break;
			default:
				sysfatal("internal error: compile_cmp %s: %d",
					proto, fld-&gt;ftype);
			}
			f-&gt;l = f-&gt;r = nil;
			return;
		}
	}
	sysfatal("unknown %s field in: %s = %s", proto, f-&gt;l-&gt;s, f-&gt;r-&gt;s);
}

void
_pf(Filter *f)
{
	char *s;

	if(f == nil)
		return;

	s = nil;
	switch(f-&gt;op){
	case '!':
		fprint(2, "!");
		_pf(f-&gt;l);
		break;
	case WORD:
		fprint(2, "%s", f-&gt;s);
		if(f-&gt;l != nil){
			fprint(2, "(");
			_pf(f-&gt;l);
			fprint(2, ")");
		}
		break;
	case LAND:
		s = "&amp;&amp;";
		goto print;
	case LOR:
		s = "||";
		goto print;
	case '=':
	print:
		_pf(f-&gt;l);
		if(s)
			fprint(2, " %s ", s);
		else
			fprint(2, " %c ", f-&gt;op);
		_pf(f-&gt;r);
		break;
	default:
		fprint(2, "???");
		break;
	}
}

void
printfilter(Filter *f, char *tag)
{
	fprint(2, "%s: ", tag);
	_pf(f);
	fprint(2, "\n");
}

void
cat(void)
{
	char buf[1024];
	int n;
	
	while((n = read(0, buf, sizeof buf)) &gt; 0)
		write(1, buf, n);
}

static int fd1 = -1;
void
startmc(void)
{
	int p[2];
	
	if(fd1 == -1)
		fd1 = dup(1, -1);
	
	if(pipe(p) &lt; 0)
		return;
	switch(fork()){
	case -1:
		return;
	default:
		close(p[0]);
		dup(p[1], 1);
		if(p[1] != 1)
			close(p[1]);
		return;
	case 0:
		close(p[1]);
		dup(p[0], 0);
		if(p[0] != 0)
			close(p[0]);
		execl("/bin/mc", "mc", nil);
		cat();
		_exits(0);
	}
}

void
stopmc(void)
{
	close(1);
	dup(fd1, 1);
	waitpid();
}

void
printhelp(char *name)
{
	int len;
	Proto *pr, **l;
	Mux *m;
	Field *f;
	char fmt[40];
	
	if(name == nil){
		print("protocols:\n");
		startmc();
		for(l=protos; (pr=*l) != nil; l++)
			print("  %s\n", pr-&gt;name);
		stopmc();
		return;
	}
	
	pr = findproto(name);
	if(pr == nil){
		print("unknown protocol %s\n", name);
		return;
	}
	
	if(pr-&gt;field){
		print("%s's filter attributes:\n", pr-&gt;name);
		len = 0;
		for(f=pr-&gt;field; f-&gt;name; f++)
			if(len &lt; strlen(f-&gt;name))
				len = strlen(f-&gt;name);
		startmc();
		for(f=pr-&gt;field; f-&gt;name; f++)
			print("  %-*s - %s\n", len, f-&gt;name, f-&gt;help);
		stopmc();
	}
	if(pr-&gt;mux){
		print("%s's subprotos:\n", pr-&gt;name);
		startmc();
		snprint(fmt, sizeof fmt, "  %s %%s\n", pr-&gt;valfmt);
		for(m=pr-&gt;mux; m-&gt;name != nil; m++)
			print(fmt, m-&gt;val, m-&gt;name);
		stopmc();
	}
}

/*
 *  demultiplex to next prototol header
 */
void
demux(Mux *mx, ulong val1, ulong val2, Msg *m, Proto *def)
{
	m-&gt;pr = def;
	for(mx = mx; mx-&gt;name != nil; mx++){
		if(val1 == mx-&gt;val || val2 == mx-&gt;val){
			m-&gt;pr = mx-&gt;pr;
			break;
		}
	}
}

/*
 *  default framer just assumes the input packet is
 *  a single read
 */
int
defaultframer(int fd, uchar *pkt, int pktlen)
{
	return read(fd, pkt, pktlen);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

