<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/ppp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/ppp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;libsec.h&gt;
#include "dat.h"
#include "protos.h"

/* PPP stuff */
enum {
	PPP_addr=	0xff,
	PPP_ctl=	0x3,
	PPP_period=	3*1000,	/* period of retransmit process (in ms) */
};

/* PPP protocols */
enum {
	PPP_ip=		0x21,		/* internet */
	PPP_vjctcp=	0x2d,		/* compressing van jacobson tcp */
	PPP_vjutcp=	0x2f,		/* uncompressing van jacobson tcp */
	PPP_ml=		0x3d,		/* multi link */
	PPP_comp=	0xfd,		/* compressed packets */
	PPP_ipcp=	0x8021,		/* ip control */
	PPP_ccp=	0x80fd,		/* compression control */
	PPP_passwd=	0xc023,		/* passwd authentication */
	PPP_lcp=	0xc021,		/* link control */
	PPP_lqm=	0xc025,		/* link quality monitoring */
	PPP_chap=	0xc223,		/* challenge/response */
};

/* LCP protocol (and IPCP) */


typedef struct Lcppkt	Lcppkt;
struct Lcppkt
{
	uchar	code;
	uchar	id;
	uchar	len[2];
	uchar	data[1];
};

typedef struct Lcpopt	Lcpopt;
struct Lcpopt
{
	uchar	type;
	uchar	len;
	uchar	data[1];
};

enum
{
	/* LCP codes */
	Lconfreq=	1,
	Lconfack=	2,
	Lconfnak=	3,
	Lconfrej=	4,
	Ltermreq=	5,
	Ltermack=	6,
	Lcoderej=	7,
	Lprotorej=	8,
	Lechoreq=	9,
	Lechoack=	10,
	Ldiscard=	11,
	Lresetreq=	14,	/* for ccp only */
	Lresetack=	15,	/* for ccp only */

	/* Lcp configure options */
	Omtu=		1,
	Octlmap=	2,
	Oauth=		3,
	Oquality=	4,
	Omagic=		5,
	Opc=		7,
	Oac=		8,

	/* authentication protocols */
	APmd5=		5,
	APmschap=	128,

	/* Chap codes */
	Cchallenge=	1,
	Cresponse=	2,
	Csuccess=	3,
	Cfailure=	4,

	/* ipcp configure options */
	Oipaddrs=	1,
	Oipcompress=	2,
	Oipaddr=	3,
	Oipdns=		129,
	Oipwins=	130,
	Oipdns2=	131,
	Oipwins2=	132,
};

char *
lcpcode[] = {
	0,
	"confreq",
	"confack",
	"confnak",
	"confrej",
	"termreq",
	"termack",
	"coderej",
	"protorej",
	"echoreq",
	"echoack",
	"discard",
	"id",
	"timeremain",
	"resetreq",
	"resetack",
};

static Mux p_mux[] =
{
	{"ip",		PPP_ip, },
	{"ppp_vjctcp",	PPP_vjctcp, },
	{"ppp_vjutcp",	PPP_vjutcp, },
	{"ppp_ml",	PPP_ml, },
	{"ppp_comp",	PPP_comp, },
	{"ppp_ipcp",	PPP_ipcp, },
	{"ppp_ccp",	PPP_ccp, },
	{"ppp_passwd",	PPP_passwd, },
	{"ppp_lcp",	PPP_lcp, },
	{"ppp_lqm",	PPP_lqm, },
	{"ppp_chap",	PPP_chap, },
	{0},
};

enum
{
	OOproto,
};

static void
p_compile(Filter *f)
{
	Mux *m;

	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = OOproto;
			return;
		}

	sysfatal("unknown ppp field or protocol: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	int proto;
	int len;

	if(f-&gt;subop != OOproto)
		return 0;

	len = m-&gt;pe - m-&gt;ps;
	if(len &lt; 3)
		return -1;

	if(m-&gt;ps[0] == PPP_addr &amp;&amp; m-&gt;ps[1] == PPP_ctl)
		m-&gt;ps += 2;

	proto = *m-&gt;ps++;
	if((proto&amp;1) == 0)
		proto = (proto&lt;&lt;8) | *m-&gt;ps++;

	if(proto == f-&gt;ulv)
		return 1;

	return 0;
}

static int
p_seprint(Msg *m)
{
	int proto;
	int len;

	len = m-&gt;pe - m-&gt;ps;
	if(len &lt; 3)
		return -1;

	if(m-&gt;ps[0] == PPP_addr &amp;&amp; m-&gt;ps[1] == PPP_ctl)
		m-&gt;ps += 2;

	proto = *m-&gt;ps++;
	if((proto&amp;1) == 0)
		proto = (proto&lt;&lt;8) | *m-&gt;ps++;
	
	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "pr=%ud len=%d", proto, len);
	demux(p_mux, proto, proto, m, &amp;dump);

	return 0;
}

static int
p_seprintchap(Msg *m)
{
	Lcppkt *lcp;
	char *p, *e;
	int len;

	if(m-&gt;pe-m-&gt;ps &lt; 4)
		return -1;

	p = m-&gt;p;
	e = m-&gt;e;
	m-&gt;pr = nil;

	/* resize packet */
	lcp = (Lcppkt*)m-&gt;ps;
	len = NetS(lcp-&gt;len);
	if(m-&gt;ps+len &lt; m-&gt;pe)
		m-&gt;pe = m-&gt;ps+len;
	else if(m-&gt;ps+len &gt; m-&gt;pe)
		return -1;

	p = seprint(p, e, "id=%d code=%d", lcp-&gt;id, lcp-&gt;code);
	switch(lcp-&gt;code) {
	default:
		p = seprint(p, e, " data=%.*H", len&gt;64?64:len, lcp-&gt;data);
		break;
	case 1:
	case 2:
		if(lcp-&gt;data[0] &gt; len-4){
			p = seprint(p, e, "%.*H", len-4, lcp-&gt;data);
		} else {
			p = seprint(p, e, " %s=", lcp-&gt;code==1?"challenge ":"response ");
			p = seprint(p, e, "%.*H", lcp-&gt;data[0], lcp-&gt;data+1);
			p = seprint(p, e, " name=");
			p = seprint(p, e, "%.*H", len-4-lcp-&gt;data[0]-1, lcp-&gt;data+lcp-&gt;data[0]+1);
		}
		break;
	case 3:
	case 4:
		if(len &gt; 64)
			len = 64;
		p = seprint(p, e, " %s=%.*H", lcp-&gt;code==3?"success ":"failure",
				len&gt;64?64:len, lcp-&gt;data);
		break;
	}
	m-&gt;p = seprint(p, e, " len=%d", len);
	return 0;
}

static char*
seprintlcpopt(char *p, char *e, void *a, int len)
{
	Lcpopt *o;
	int proto, x, period;
	uchar *cp, *ecp;

	cp = a;
	ecp = cp+len;

	for(; cp &lt; ecp; cp += o-&gt;len){
		o = (Lcpopt*)cp;
		if(cp + o-&gt;len &gt; ecp || o-&gt;len == 0){
			p = seprint(p, e, " bad-opt-len=%d", o-&gt;len);
			return p;
		}

		switch(o-&gt;type){
		default:
			p = seprint(p, e, " (type=%d len=%d)", o-&gt;type, o-&gt;len);
			break;
		case Omtu:
			p = seprint(p, e, " mtu=%d", NetS(o-&gt;data));
			break;
		case Octlmap:
			p = seprint(p, e, " ctlmap=%ux", NetL(o-&gt;data));
			break;
		case Oauth:
			proto = NetS(o-&gt;data);
			switch(proto) {
			default:
				p = seprint(p, e, " auth=%d", proto);
				break;
			case PPP_passwd:
				p = seprint(p, e, " auth=passwd");
				break;
			case PPP_chap:
				p = seprint(p, e, " (auth=chap data=%2.2ux)", o-&gt;data[2]);
				break;
			}
			break;
		case Oquality:
			proto = NetS(o-&gt;data);
			switch(proto) {
			default:
				p = seprint(p, e, " qproto=%d", proto);
				break;
			case PPP_lqm:
				x = NetL(o-&gt;data+2)*10;
				period = (x+(PPP_period-1))/PPP_period;
				p = seprint(p, e, " (qproto=lqm period=%d)", period);
				break;
			}
		case Omagic:
			p = seprint(p, e, " magic=%ux", NetL(o-&gt;data));
			break;
		case Opc:
			p = seprint(p, e, " protocol-compress");
			break;
		case Oac:
			p = seprint(p, e, " addr-compress");
			break;
		}
	}
	return p;
}


static int
p_seprintlcp(Msg *m)
{
	Lcppkt *lcp;
	char *p, *e;
	int len;

	if(m-&gt;pe-m-&gt;ps &lt; 4)
		return -1;

	p = m-&gt;p;
	e = m-&gt;e;
	m-&gt;pr = nil;

	lcp = (Lcppkt*)m-&gt;ps;
	len = NetS(lcp-&gt;len);
	if(m-&gt;ps+len &lt; m-&gt;pe)
		m-&gt;pe = m-&gt;ps+len;
	else if(m-&gt;ps+len &gt; m-&gt;pe)
		return -1;

	p = seprint(p, e, "id=%d code=%d", lcp-&gt;id, lcp-&gt;code);
	switch(lcp-&gt;code) {
	default:
		p = seprint(p, e, " data=%.*H", len&gt;64?64:len, lcp-&gt;data);
		break;
	case Lconfreq:
	case Lconfack:
	case Lconfnak:
	case Lconfrej:
		p = seprint(p, e, "=%s", lcpcode[lcp-&gt;code]);
		p = seprintlcpopt(p, e, lcp-&gt;data, len-4);
		break;
	case Ltermreq:
	case Ltermack:
	case Lcoderej:
	case Lprotorej:
	case Lechoreq:
	case Lechoack:
	case Ldiscard:
		p = seprint(p, e, "=%s", lcpcode[lcp-&gt;code]);
		break;
	}
	m-&gt;p = seprint(p, e, " len=%d", len);
	return 0;
}

static char*
seprintipcpopt(char *p, char *e, void *a, int len)
{
	Lcpopt *o;
	uchar *cp, *ecp;

	cp = a;
	ecp = cp+len;

	for(; cp &lt; ecp; cp += o-&gt;len){
		o = (Lcpopt*)cp;
		if(cp + o-&gt;len &gt; ecp){
			p = seprint(p, e, " bad opt len %ux", o-&gt;type);
			return p;
		}

		switch(o-&gt;type){
		default:
			p = seprint(p, e, " (type=%d len=%d)", o-&gt;type, o-&gt;len);
			break;
		case Oipaddrs:	
			p = seprint(p, e, " ipaddrs(deprecated)");
			break;
		case Oipcompress:
			p = seprint(p, e, " ipcompress");
			break;
		case Oipaddr:	
			p = seprint(p, e, " ipaddr=%V", o-&gt;data);
			break;
		case Oipdns:	
			p = seprint(p, e, " dnsaddr=%V", o-&gt;data);
			break;
		case Oipwins:	
			p = seprint(p, e, " winsaddr=%V", o-&gt;data);
			break;
		case Oipdns2:	
			p = seprint(p, e, " dns2addr=%V", o-&gt;data);
			break;
		case Oipwins2:	
			p = seprint(p, e, " wins2addr=%V", o-&gt;data);
			break;
		}
	}
	return p;
}

static int
p_seprintipcp(Msg *m)
{
	Lcppkt *lcp;
	char *p, *e;
	int len;

	if(m-&gt;pe-m-&gt;ps &lt; 4)
		return -1;

	p = m-&gt;p;
	e = m-&gt;e;
	m-&gt;pr = nil;

	lcp = (Lcppkt*)m-&gt;ps;
	len = NetS(lcp-&gt;len);
	if(m-&gt;ps+len &lt; m-&gt;pe)
		m-&gt;pe = m-&gt;ps+len;
	else if(m-&gt;ps+len &gt; m-&gt;pe)
		return -1;
		
	p = seprint(p, e, "id=%d code=%d", lcp-&gt;id, lcp-&gt;code);
	switch(lcp-&gt;code) {
	default:
		p = seprint(p, e, " data=%.*H", len&gt;64?64:len, lcp-&gt;data);
		break;
	case Lconfreq:
	case Lconfack:
	case Lconfnak:
	case Lconfrej:
		p = seprint(p, e, "=%s", lcpcode[lcp-&gt;code]);
		p = seprintipcpopt(p, e, lcp-&gt;data, len-4);
		break;
	case Ltermreq:
	case Ltermack:
		p = seprint(p, e, "=%s", lcpcode[lcp-&gt;code]);
		break;
	}
	m-&gt;p = seprint(p, e, " len=%d", len);
	return 0;
}

static char*
seprintccpopt(char *p, char *e, void *a, int len)
{
	Lcpopt *o;
	uchar *cp, *ecp;

	cp = a;
	ecp = cp+len;

	for(; cp &lt; ecp; cp += o-&gt;len){
		o = (Lcpopt*)cp;
		if(cp + o-&gt;len &gt; ecp){
			p = seprint(p, e, " bad opt len %ux", o-&gt;type);
			return p;
		}
		
		switch(o-&gt;type){
		default:
			p = seprint(p, e, " type=%d ", o-&gt;type);
			break;
		case 0:
			p = seprint(p, e, " OUI=(%d %.2ux%.2ux%.2ux) ", o-&gt;type, 
				o-&gt;data[0], o-&gt;data[1], o-&gt;data[2]);
			break;
		case 17:
			p = seprint(p, e, " Stac-LZS");
			break;
		case 18:
			p = seprint(p, e, " Microsoft-PPC=%ux", NetL(o-&gt;data));
			break;
		}
	}
	return p;
}

static int
p_seprintccp(Msg *m)
{
	Lcppkt *lcp;
	char *p, *e;
	int len;

	if(m-&gt;pe-m-&gt;ps &lt; 4)
		return -1;

	p = m-&gt;p;
	e = m-&gt;e;
	m-&gt;pr = nil;

	lcp = (Lcppkt*)m-&gt;ps;
	len = NetS(lcp-&gt;len);
	if(m-&gt;ps+len &lt; m-&gt;pe)
		m-&gt;pe = m-&gt;ps+len;
	else if(m-&gt;ps+len &gt; m-&gt;pe)
		return -1;
		
	p = seprint(p, e, "id=%d code=%d", lcp-&gt;id, lcp-&gt;code);
	switch(lcp-&gt;code) {
	default:
		p = seprint(p, e, " data=%.*H", len&gt;64?64:len, lcp-&gt;data);
		break;
	case Lconfreq:
	case Lconfack:
	case Lconfnak:
	case Lconfrej:
		p = seprint(p, e, "=%s", lcpcode[lcp-&gt;code]);
		p = seprintccpopt(p, e, lcp-&gt;data, len-4);
		break;
	case Ltermreq:
	case Ltermack:
	case Lresetreq:
	case Lresetack:
		p = seprint(p, e, "=%s", lcpcode[lcp-&gt;code]);
		break;
	}
	m-&gt;p = seprint(p, e, " len=%d", len);
	
	return 0;
}

static int
p_seprintcomp(Msg *m)
{
	char compflag[5];
	ushort x;
	int i;
	int len;

	len = m-&gt;pe-m-&gt;ps;
	if(len &lt; 2)
		return -1;

	x = NetS(m-&gt;ps);
	m-&gt;ps += 2;
	i = 0;
	if(x &amp; (1&lt;&lt;15))
		compflag[i++] = 'r';
	if(x &amp; (1&lt;&lt;14))
		compflag[i++] = 'f';
	if(x &amp; (1&lt;&lt;13))
		compflag[i++] = 'c';
	if(x &amp; (1&lt;&lt;12))
		compflag[i++] = 'e';
	compflag[i] = 0;
	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "flag=%s count=%.3ux", compflag, x&amp;0xfff);
	m-&gt;p = seprint(m-&gt;p, m-&gt;e, " data=%.*H", len&gt;64?64:len, m-&gt;ps);
	m-&gt;pr = nil;
	return 0;
}

Proto ppp =
{
	"ppp",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%#.4lux",
	nil,
	defaultframer,
};

Proto ppp_ipcp =
{
	"ppp_ipcp",
	p_compile,
	p_filter,
	p_seprintipcp,
	nil,
	nil,
	nil,
	defaultframer,
};

Proto ppp_lcp =
{
	"ppp_lcp",
	p_compile,
	p_filter,
	p_seprintlcp,
	nil,
	nil,
	nil,
	defaultframer,
};

Proto ppp_ccp =
{
	"ppp_ccp",
	p_compile,
	p_filter,
	p_seprintccp,
	nil,
	nil,
	nil,
	defaultframer,
};

Proto ppp_chap =
{
	"ppp_chap",
	p_compile,
	p_filter,
	p_seprintchap,
	nil,
	nil,
	nil,
	defaultframer,
};

Proto ppp_comp =
{
	"ppp_comp",
	p_compile,
	p_filter,
	p_seprintcomp,
	nil,
	nil,
	nil,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

