<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/rtcp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/rtcp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr Hdr;
struct Hdr {
	uchar	hdr;		/* RTCP header */
	uchar	pt;		/* Packet type */
	uchar	len[2];		/* Report length */
	uchar	ssrc[4];	/* Synchronization source identifier */
	uchar	ntp[8];		/* NTP time stamp */
	uchar	rtp[4];		/* RTP time stamp */
	uchar	pktc[4];	/* Sender's packet count */
	uchar	octc[4];	/* Sender's octet count */
};

typedef struct Report Report;
struct Report {
	uchar	ssrc[4];	/* SSRC identifier */
	uchar	lost[4];	/* Fraction + cumu lost */
	uchar	seqhi[4];	/* Highest seq number received */
	uchar	jitter[4];	/* Interarrival jitter */
	uchar	lsr[4];		/* Last SR */
	uchar	dlsr[4];	/* Delay since last SR */
};

enum{
	RTCPLEN = 28,		/* Minimum size of an RTCP header */
	REPORTLEN = 24,
};

static int
p_seprint(Msg *m)
{
	int rc, i, frac;
	float dlsr;
	Hdr*h;
	Report*r;

	if(m-&gt;pe - m-&gt;ps &lt; RTCPLEN)
		return -1;

	h = (Hdr*)m-&gt;ps;
	if(m-&gt;pe - m-&gt;ps &lt; (NetS(h-&gt;len) + 1) * 4)
		return -1;

	rc = h-&gt;hdr &amp; 0x1f;
	m-&gt;ps += RTCPLEN;
	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "version=%d rc=%d tp=%d ssrc=%8ux "
		"ntp=%d.%.10ud rtp=%d pktc=%d octc=%d hlen=%d",
		(h-&gt;hdr &gt;&gt; 6) &amp; 3, rc, h-&gt;pt, NetL(h-&gt;ssrc), NetL(h-&gt;ntp),
		(uint)NetL(&amp;h-&gt;ntp[4]), NetL(h-&gt;rtp), NetL(h-&gt;pktc),
		NetL(h-&gt;octc), (NetS(h-&gt;len) + 1) * 4);

	for(i = 0; i &lt; rc; i++){
		r = (Report*)m-&gt;ps;
		m-&gt;ps += REPORTLEN;

		frac = (int)((r-&gt;lost[0] * 100.) / 256.);
		r-&gt;lost[0] = 0;
		dlsr = NetL(r-&gt;dlsr) / 65536.;

		m-&gt;p = seprint(m-&gt;p, m-&gt;e, "\n\trr(csrc=%8ux frac=%3d%% "
			"cumu=%10d seqhi=%10ud jitter=%10d lsr=%8ux dlsr=%f)",
			NetL(r-&gt;ssrc), frac, NetL(r-&gt;lost), NetL(r-&gt;seqhi),
			NetL(r-&gt;jitter), NetL(r-&gt;lsr), dlsr);
	}
	m-&gt;pr = nil;
	return 0;
}

Proto rtcp = {
	"rtcp",
	nil,
	nil,
	p_seprint,
	nil,
	nil,
	nil,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

