<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/tcp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/tcp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr	Hdr;
struct Hdr
{
	uchar	sport[2];
	uchar	dport[2];
	uchar	seq[4];
	uchar	ack[4];
	uchar	flag[2];
	uchar	win[2];
	uchar	cksum[2];
	uchar	urg[2];
	uchar	opt[1];
};

typedef struct PseudoHdr{
	uchar	src[4];
	uchar	dst[4];
	uchar	zero;
	uchar	proto;
	uchar	length[2];
	uchar	hdrdata[1580];
} PseudoHdr;

enum
{
	TCPLEN= 20,
};

enum
{
	Os,
	Od,
	Osd,
};

static Field p_fields[] =
{
	{"s",		Fnum,	Os,	"source port",	} ,
	{"d",		Fnum,	Od,	"dest port",	} ,
	{"a",		Fnum,	Osd,	"source/dest port",	} ,
	{"sd",		Fnum,	Osd,	"source/dest port",	} ,
	{0}
};

static Mux p_mux[] =
{
	{"dns",		53, },
	{"ninep",	17007, },	/* exportfs */
	{"ninep",	564, },		/* 9fs */
	{"ninep",	17005, },	/* ocpu */
	{"ninep",	17010, },	/* ncpu */
	{"ninep",	17013, },	/* cpu */
	{0},
};

enum
{
	EOLOPT		= 0,
	NOOPOPT		= 1,
	MSSOPT		= 2,
	MSS_LENGTH	= 4,		/* Mean segment size */
	WSOPT		= 3,
	WS_LENGTH	= 3,		/* Bits to scale window size by */
};

static void
p_compile(Filter *f)
{
	Mux *m;

	if(f-&gt;op == '='){
		compile_cmp(tcp.name, f, p_fields);
		return;
	}
	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = Osd;
			return;
		}
	sysfatal("unknown tcp field or protocol: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; TCPLEN)
		return 0;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += (NetS(h-&gt;flag)&gt;&gt;10) &amp; 0x3f;

	switch(f-&gt;subop){
	case Os:
		return NetS(h-&gt;sport) == f-&gt;ulv;
	case Od:
		return NetS(h-&gt;dport) == f-&gt;ulv;
	case Osd:
		return NetS(h-&gt;sport) == f-&gt;ulv || NetS(h-&gt;dport) == f-&gt;ulv;
	}
	return 0;
}

enum
{
	URG		= 0x20,		/* Data marked urgent */
	ACK		= 0x10,		/* Aknowledge is valid */
	PSH		= 0x08,		/* Whole data pipe is pushed */
	RST		= 0x04,		/* Reset connection */
	SYN		= 0x02,		/* Pkt. is synchronise */
	FIN		= 0x01,		/* Start close down */
};

static char*
flags(int f)
{
	static char fl[20];
	char *p;

	p = fl;
	if(f &amp; URG)
		*p++ = 'U';
	if(f &amp; ACK)
		*p++ = 'A';
	if(f &amp; PSH)
		*p++ = 'P';
	if(f &amp; RST)
		*p++ = 'R';
	if(f &amp; SYN)
		*p++ = 'S';
	if(f &amp; FIN)
		*p++ = 'F';
	*p = 0;
	return fl;
}


static int
p_seprint(Msg *m)
{
	int dport, sport, len, flag, optlen;
	uchar *optr;
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; TCPLEN)
		return -1;
	h = (Hdr*)m-&gt;ps;

	/* get tcp header length */
	flag = NetS(h-&gt;flag);
	len = (flag&gt;&gt;10) &amp; ~3;
	flag &amp;= 0x3ff;
	m-&gt;ps += len;

	/* next protocol */
	dport = NetS(h-&gt;dport);
	sport = NetS(h-&gt;sport);
	demux(p_mux, sport, dport, m, &amp;dump);

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "s=%d d=%d seq=%lud ack=%lud fl=%s win=%d ck=%4.4ux",
			NetS(h-&gt;sport), dport,
			(ulong)NetL(h-&gt;seq), (ulong)NetL(h-&gt;ack),
			flags(flag), NetS(h-&gt;win),
			NetS(h-&gt;cksum));

	/* tcp options */
	len -= TCPLEN;
	optr = h-&gt;opt;
	while(len &gt; 0) {
		if(*optr == EOLOPT){
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, " opt=EOL");
			break;
		}
		if(*optr == NOOPOPT) {
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, " opt=NOOP");
			len--;
			optr++;
			continue;
		}
		optlen = optr[1];
		if(optlen &lt; 2 || optlen &gt; len)
			break;
		switch(*optr) {
		case MSSOPT:
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, " opt%d=(mss %ud)",
				optlen, nhgets(optr+2));
			break;
		case WSOPT:
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, " opt%d=(wscale %ud)",
				optlen, *(optr+2));
			break;
		default:
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, " opt%d=(%ud %.*H)",
				optlen, *optr, optlen-2, optr+2);
		}
		len -= optlen;
		optr += optlen;
	}
	return 0;
}

Proto tcp =
{
	"tcp",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%lud",
	p_fields,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

