<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/udp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/udp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr	Hdr;
struct Hdr
{
	uchar	sport[2];	/* Source port */
	uchar	dport[2];	/* Destination port */
	uchar	len[2];		/* data length */
	uchar	cksum[2];	/* Checksum */
};

enum
{
	UDPLEN=	8,
};

enum
{
	Os,
	Od,
	Osd,
	Osetport,
};

static Field p_fields[] = 
{
	{"s",		Fnum,	Os,	"source port",	} ,
	{"d",		Fnum,	Od,	"dest port",	} ,
	{"a",		Fnum,	Osd,	"source/dest port",	} ,
	{"sd",		Fnum,	Osd,	"source/dest port",	} ,
	{0}
};

#define ANYPORT ~0UL

static Mux p_mux[] =
{
	{"dns",	53, },
	{"bootp",	67, },
	{"ninep",	6346, },	/* tvs */
	{"rtp",		ANYPORT, },
	{"rtcp",	ANYPORT, },
	{0},
};

/* default next protocol, can be changed by p_filter, reset by p_compile */
static Proto	*defproto = &amp;dump;

static void
p_compile(Filter *f)
{
	Mux *m;

	if(f-&gt;op == '='){
		compile_cmp(udp.name, f, p_fields);
		return;
	}
	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = Osd;
			return;
		}

	sysfatal("unknown udp field or protocol: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; UDPLEN)
		return 0;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += UDPLEN;

	switch(f-&gt;subop){
	case Os:
		return NetS(h-&gt;sport) == f-&gt;ulv;
	case Od:
		return NetS(h-&gt;dport) == f-&gt;ulv;
	case Osd:
		if(f-&gt;ulv == ANYPORT){
			defproto = f-&gt;pr;
			return 1;
		}
		return NetS(h-&gt;sport) == f-&gt;ulv || NetS(h-&gt;dport) == f-&gt;ulv;
	}
	return 0;
}

static int
p_seprint(Msg *m)
{
	Hdr *h;
	int dport, sport;


	if(m-&gt;pe - m-&gt;ps &lt; UDPLEN)
		return -1;
	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += UDPLEN;

	/* next protocol */
	sport = NetS(h-&gt;sport);
	dport = NetS(h-&gt;dport);
	demux(p_mux, sport, dport, m, defproto);
	defproto = &amp;dump;

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "s=%d d=%d ck=%4.4ux ln=%4d",
			NetS(h-&gt;sport), dport,
			NetS(h-&gt;cksum), NetS(h-&gt;len));
	return 0;
}

Proto udp =
{
	"udp",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%lud",
	p_fields,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

