<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/ico.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/ico.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;
#include &lt;cursor.h&gt;

typedef struct Icon Icon;
struct Icon
{
	Icon	*next;

	uchar	w;		/* icon width */
	uchar	h;		/* icon height */
	ushort	ncolor;		/* number of colors */
	ushort	nplane;		/* number of bit planes */
	ushort	bits;		/* bits per pixel */
	ulong	len;		/* length of data */
	ulong	offset;		/* file offset to data */

	Image	*img;
	Image	*mask;

	Rectangle r;		/* relative */
	Rectangle sr;		/* abs */
};

typedef struct Header Header;
struct Header
{
	uint	n;
	Icon	*first;
	Icon	*last;
};

int debug;
Mouse mouse;
Header h;
Image *background;

ushort
gets(uchar *p)
{
	return p[0] | (p[1]&lt;&lt;8);
}

ulong
getl(uchar *p)
{
	return p[0] | (p[1]&lt;&lt;8) | (p[2]&lt;&lt;16) | (p[3]&lt;&lt;24);
}

int
Bgetheader(Biobuf *b, Header *h)
{
	Icon *icon;
	int i;
	uchar buf[40];

	memset(h, 0, sizeof(*h));
	if(Bread(b, buf, 6) != 6)
		goto eof;
	if(gets(&amp;buf[0]) != 0)
		goto header;
	if(gets(&amp;buf[2]) != 1)
		goto header;
	h-&gt;n = gets(&amp;buf[4]);

	for(i = 0; i &lt; h-&gt;n; i++){
		icon = mallocz(sizeof(*icon), 1);
		if(icon == nil)
			sysfatal("malloc: %r");
		if(Bread(b, buf, 16) != 16)
			goto eof;
		icon-&gt;w = buf[0];
		icon-&gt;h = buf[1];
		icon-&gt;ncolor = buf[2] == 0 ? 256 : buf[2];
		if(buf[3] != 0)
			goto header;
		icon-&gt;nplane = gets(&amp;buf[4]);
		icon-&gt;bits = gets(&amp;buf[6]);
		icon-&gt;len = getl(&amp;buf[8]);
		icon-&gt;offset = getl(&amp;buf[12]);

		if(i == 0)
			h-&gt;first = icon;
		else
			h-&gt;last-&gt;next = icon;
		h-&gt;last = icon;
	}
	return 0;

eof:
	werrstr("unexpected EOF");
	return -1;
header:
	werrstr("unknown header format");
	return -1;
}

uchar*
transcmap(Icon *icon, uchar *map)
{
	uchar *m, *p;
	int i;

	p = m = malloc(sizeof(int)*(1&lt;&lt;icon-&gt;bits));
	for(i = 0; i &lt; icon-&gt;ncolor; i++){
		*p++ = rgb2cmap(map[2], map[1], map[0]);
		map += 4;
	}
	return m;
}

Image*
xor2img(Icon *icon, uchar *xor, uchar *map)
{
	uchar *data;
	Image *img;
	int inxlen;
	uchar *from, *to;
	int s, byte, mask;
	int x, y;

	inxlen = 4*((icon-&gt;bits*icon-&gt;w+31)/32);
	to = data = malloc(icon-&gt;w*icon-&gt;h);

	/* rotate around the y axis, go to 8 bits, and convert color */
	mask = (1&lt;&lt;icon-&gt;bits)-1;
	for(y = 0; y &lt; icon-&gt;h; y++){
		s = -1;
		byte = 0;
		from = xor + (icon-&gt;h - 1 - y)*inxlen;
		for(x = 0; x &lt; icon-&gt;w; x++){
			if(s &lt; 0){
				byte = *from++;
				s = 8-icon-&gt;bits;
			}
			*to++ = map[(byte&gt;&gt;s) &amp; mask];
			s -= icon-&gt;bits;
		}
	}

	/* stick in an image */
	img = allocimage(display, Rect(0,0,icon-&gt;w,icon-&gt;h), CMAP8, 0, DNofill);
	loadimage(img, Rect(0,0,icon-&gt;w,icon-&gt;h), data, icon-&gt;h*icon-&gt;w);

	free(data);
	return img;
}

Image*
and2img(Icon *icon, uchar *and)
{
	uchar *data;
	Image *img;
	int inxlen;
	int outxlen;
	uchar *from, *to;
	int x, y;

	inxlen = 4*((icon-&gt;w+31)/32);
	to = data = malloc(inxlen*icon-&gt;h);

	/* rotate around the y axis and invert bits */
	outxlen = (icon-&gt;w+7)/8;
	for(y = 0; y &lt; icon-&gt;h; y++){
		from = and + (icon-&gt;h - 1 - y)*inxlen;
		for(x = 0; x &lt; outxlen; x++){
			*to++ = ~(*from++);
		}
	}

	/* stick in an image */
	img = allocimage(display, Rect(0,0,icon-&gt;w,icon-&gt;h), GREY1, 0, DNofill);
	loadimage(img, Rect(0,0,icon-&gt;w,icon-&gt;h), data, icon-&gt;h*outxlen);

	free(data);
	return img;
}

int
Bgeticon(Biobuf *b, Icon *icon)
{
	ulong l;
	ushort s;
	uchar *xor;
	uchar *and;
	uchar *cm;
	uchar *buf;
	uchar *map2map;
	Image *img;

	Bseek(b, icon-&gt;offset, 0);
	buf = malloc(icon-&gt;len);
	if(buf == nil)
		return -1;
	if(Bread(b, buf, icon-&gt;len) != icon-&gt;len){
		werrstr("unexpected EOF");
		return -1;
	}

	/* this header's info takes precedence over previous one */
	if(getl(buf) != 40){
		werrstr("bad icon header");
		return -1;
	}
	l = getl(buf+4);
	if(l != icon-&gt;w)
		icon-&gt;w = l;
	l = getl(buf+8);
	if(l&gt;&gt;1 != icon-&gt;h)
		icon-&gt;h = l&gt;&gt;1;
	s = gets(buf+12);
	if(s != icon-&gt;nplane)
		icon-&gt;nplane = s;
	s = gets(buf+14);
	if(s != icon-&gt;bits)
		icon-&gt;bits = s;

	/* limit what we handle */
	switch(icon-&gt;bits){
	case 1:
	case 2:
	case 4:
	case 8:
		break;
	default:
		werrstr("don't support %d bit pixels", icon-&gt;bits);
		return -1;
	}
	if(icon-&gt;nplane != 1){
		werrstr("don't support %d planes", icon-&gt;nplane);
		return -1;
	}

	cm = buf + 40;
	xor = cm + 4*icon-&gt;ncolor;
	and = xor + icon-&gt;h*4*((icon-&gt;bits*icon-&gt;w+31)/32);

	/* translate the color map to a plan 9 one */
	map2map = transcmap(icon, cm);

	/* convert the images */
	icon-&gt;img = xor2img(icon, xor, map2map);
	icon-&gt;mask = and2img(icon, and);

	/* so that we save an image with a white background */
	img = allocimage(display, icon-&gt;img-&gt;r, CMAP8, 0, DWhite);
	draw(img, icon-&gt;img-&gt;r, icon-&gt;img, icon-&gt;mask, ZP);
	icon-&gt;img = img;

	free(buf);
	free(map2map);
	return 0;
}

void
usage(void)
{
	fprint(2, "usage: %s [file]\n", argv0);
	exits("usage");
}

enum
{
	Mimage,
	Mmask,
	Mexit,

	Up= 1,
	Down= 0,
};

char	*menu3str[] = {
	[Mimage]	"write image",
	[Mmask]		"write mask",
	[Mexit]		"exit",
	0,
};

Menu	menu3 = {
	menu3str
};

Cursor sight = {
	{-7, -7},
	{0x1F, 0xF8, 0x3F, 0xFC, 0x7F, 0xFE, 0xFB, 0xDF,
	 0xF3, 0xCF, 0xE3, 0xC7, 0xFF, 0xFF, 0xFF, 0xFF,
	 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0xC7, 0xF3, 0xCF,
	 0x7B, 0xDF, 0x7F, 0xFE, 0x3F, 0xFC, 0x1F, 0xF8,},
	{0x00, 0x00, 0x0F, 0xF0, 0x31, 0x8C, 0x21, 0x84,
	 0x41, 0x82, 0x41, 0x82, 0x41, 0x82, 0x7F, 0xFE,
	 0x7F, 0xFE, 0x41, 0x82, 0x41, 0x82, 0x41, 0x82,
	 0x21, 0x84, 0x31, 0x8C, 0x0F, 0xF0, 0x00, 0x00,}
};

void
buttons(int ud)
{
	while((mouse.buttons==0) != ud)
		mouse = emouse();
}

void
mesg(char *fmt, ...)
{
	va_list arg;
	char buf[1024];
	static char obuf[1024];

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	string(screen, screen-&gt;r.min, background, ZP, font, obuf);
	string(screen, screen-&gt;r.min, display-&gt;white, ZP, font, buf);
	strcpy(obuf, buf);
}

void
doimage(Icon *icon)
{
	int rv;
	char file[256];
	int fd;

	rv = -1;
	snprint(file, sizeof(file), "%dx%d.img", icon-&gt;w, icon-&gt;h);
	fd = create(file, OWRITE, 0664);
	if(fd &gt;= 0){
		rv = writeimage(fd, icon-&gt;img, 0);
		close(fd);
	}
	if(rv &lt; 0)
		mesg("error writing %s: %r", file);
	else
		mesg("created %s", file);
}

void
domask(Icon *icon)
{
	int rv;
	char file[64];
	int fd;

	rv = -1;
	snprint(file, sizeof(file), "%dx%d.mask", icon-&gt;w, icon-&gt;h);
	fd = create(file, OWRITE, 0664);
	if(fd &gt;= 0){
		rv = writeimage(fd, icon-&gt;mask, 0);
		close(fd);
	}
	if(rv &lt; 0)
		mesg("error writing %s: %r", file);
	else
		mesg("created %s", file);
}

void
apply(void (*f)(Icon*))
{
	Icon *icon;

	esetcursor(&amp;sight);
	buttons(Down);
	if(mouse.buttons == 4)
		for(icon = h.first; icon; icon = icon-&gt;next)
			if(ptinrect(mouse.xy, icon-&gt;sr)){
				buttons(Up);
				f(icon);
				break;
			}
	buttons(Up);
	esetcursor(0);
}

void
menu(void)
{
	int sel;

	sel = emenuhit(3, &amp;mouse, &amp;menu3);
	switch(sel){
	case Mimage:
		apply(doimage);
		break;
	case Mmask:
		apply(domask);
		break;
	case Mexit:
		exits(0);
		break;
	}
}

void
mousemoved(void)
{
	Icon *icon;

	for(icon = h.first; icon; icon = icon-&gt;next)
		if(ptinrect(mouse.xy, icon-&gt;sr)){
			mesg("%dx%d", icon-&gt;w, icon-&gt;h);
			return;
		}
	mesg("");
}

enum
{
	BORDER= 1,
};

void
eresized(int new)
{
	Icon *icon;
	Rectangle r;

	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0)
		sysfatal("can't reattach to window");
	draw(screen, screen-&gt;clipr, background, nil, ZP);
	r.max.x = screen-&gt;r.min.x;
	r.min.y = screen-&gt;r.min.y + font-&gt;height + 2*BORDER;
	for(icon = h.first; icon != nil; icon = icon-&gt;next){
		r.min.x = r.max.x + BORDER;
		r.max.x = r.min.x + Dx(icon-&gt;img-&gt;r);
		r.max.y = r.min.y + Dy(icon-&gt;img-&gt;r);
		draw(screen, r, icon-&gt;img, nil, ZP);
		border(screen, r, -BORDER, display-&gt;black, ZP);
		icon-&gt;sr = r;
	}
	flushimage(display, 1);
}

void
main(int argc, char **argv)
{
	Biobuf in;
	Icon *icon;
	int num, fd;
	Rectangle r;
	Event e;

	ARGBEGIN{
	case 'd':
		debug = 1;
		break;
	}ARGEND;

	fd = -1;
	switch(argc){
	case 0:
		fd = 0;
		break;
	case 1:
		fd = open(argv[0], OREAD);
		if(fd &lt; 0)
			sysfatal("opening: %r");
		break;
	default:
		usage();
		break;
	}

	Binit(&amp;in, fd, OREAD);

	if(Bgetheader(&amp;in, &amp;h) &lt; 0)
		sysfatal("reading header: %r");

	initdraw(nil, nil, "ico");
	background = allocimage(display, Rect(0, 0, 1, 1), screen-&gt;chan, 1, (128&lt;&lt;24)|(128&lt;&lt;16)|(128&lt;&lt;8)|0xFF);

	einit(Emouse|Ekeyboard);

	num = 0;
	r.min = Pt(4, 4);
	for(icon = h.first; icon != nil; icon = icon-&gt;next){
		if(Bgeticon(&amp;in, icon) &lt; 0){
			fprint(2, "%s: read fail: %r\n", argv0);
			continue;
		}
		if(debug)
			fprint(2, "w %ud h %ud ncolor %ud bits %ud len %lud offset %lud\n",
			   icon-&gt;w, icon-&gt;h, icon-&gt;ncolor, icon-&gt;bits, icon-&gt;len, icon-&gt;offset);
		r.max = addpt(r.min, Pt(icon-&gt;w, icon-&gt;h));
		icon-&gt;r = r;
		r.min.x += r.max.x;
		num++;
	}

	if(num == 0)
		exits("no images");
	eresized(0);

	for(;;)
		switch(event(&amp;e)){
		case Ekeyboard:
			break;
		case Emouse:
			mouse = e.mouse;
			if(mouse.buttons &amp; 4)
				menu();
			else
				mousemoved();
			break;
		}
	/* not reached */
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

