<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/readgif.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/readgif.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include "imagefile.h"

typedef struct Entry Entry;
typedef struct Header Header;

struct Entry{
	int		prefix;
	int		exten;
};


struct Header{
	Biobuf	*fd;
	char		err[256];
	jmp_buf	errlab;
	uchar 	buf[3*256];
	char 		vers[8];
	uchar 	*globalcmap;
	int		screenw;
	int		screenh;
	int		fields;
	int		bgrnd;
	int		aspect;
	int		flags;
	int		delay;
	int		trindex;
	int		loopcount;
	Entry	tbl[4096];
	Rawimage	**array;
	Rawimage	*new;

	uchar	*pic;
};

static char		readerr[] = "ReadGIF: read error: %r";
static char		extreaderr[] = "ReadGIF: can't read extension: %r";
static char		memerr[] = "ReadGIF: malloc failed: %r";

static Rawimage**	readarray(Header*);
static Rawimage*	readone(Header*);
static void			readheader(Header*);
static void			skipextension(Header*);
static uchar*		readcmap(Header*, int);
static uchar*		decode(Header*, Rawimage*, Entry*);
static void			interlace(Header*, Rawimage*);

static
void
clear(void **p)
{
	if(*p){
		free(*p);
		*p = nil;
	}
}

static
void
giffreeall(Header *h, int freeimage)
{
	int i;

	if(h-&gt;fd){
		Bterm(h-&gt;fd);
		h-&gt;fd = nil;
	}
	clear(&amp;h-&gt;pic);
	if(h-&gt;new){
		clear(&amp;h-&gt;new-&gt;cmap);
		clear(&amp;h-&gt;new-&gt;chans[0]);
		clear(&amp;h-&gt;new);
	}
	clear(&amp;h-&gt;globalcmap);
	if(freeimage &amp;&amp; h-&gt;array!=nil){
		for(i=0; h-&gt;array[i]; i++){
			clear(&amp;h-&gt;array[i]-&gt;cmap);
			clear(&amp;h-&gt;array[i]-&gt;chans[0]);
		}
		clear(&amp;h-&gt;array);
	}
}

static
void
giferror(Header *h, char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	vseprint(h-&gt;err, h-&gt;err+sizeof h-&gt;err, fmt, arg);
	va_end(arg);

	werrstr(h-&gt;err);
	giffreeall(h, 1);
	longjmp(h-&gt;errlab, 1);
}


Rawimage**
readgif(int fd, int colorspace)
{
	Rawimage **a;
	Biobuf b;
	Header *h;
	char buf[ERRMAX];

	buf[0] = '\0';
	USED(colorspace);
	if(Binit(&amp;b, fd, OREAD) &lt; 0)
		return nil;
	h = malloc(sizeof(Header));
	if(h == nil){
		Bterm(&amp;b);
		return nil;
	}
	memset(h, 0, sizeof(Header));
	h-&gt;fd = &amp;b;
	errstr(buf, sizeof buf);	/* throw it away */
	if(setjmp(h-&gt;errlab))
		a = nil;
	else
		a = readarray(h);
	giffreeall(h, 0);
	free(h);
	return a;
}

static
void
inittbl(Header *h)
{
	int i;
	Entry *tbl;

	tbl = h-&gt;tbl;
	for(i=0; i&lt;258; i++) {
		tbl[i].prefix = -1;
		tbl[i].exten = i;
	}
}

static
Rawimage**
readarray(Header *h)
{
	Entry *tbl;
	Rawimage *new, **array;
	int c, nimages;

	tbl = h-&gt;tbl;

	readheader(h);

	if(h-&gt;fields &amp; 0x80)
		h-&gt;globalcmap = readcmap(h, (h-&gt;fields&amp;7)+1);

	array = malloc(sizeof(Rawimage**));
	if(array == nil)
		giferror(h, memerr);
	nimages = 0;
	array[0] = nil;
	h-&gt;array = array;
		
	for(;;){
		switch(c = Bgetc(h-&gt;fd)){
		case Beof:
			goto Return;

		case 0x21:	/* Extension (ignored) */
			skipextension(h);
			break;

		case 0x2C:	/* Image Descriptor */
			inittbl(h);
			new = readone(h);
			if(new-&gt;fields &amp; 0x80){
				new-&gt;cmaplen = 3*(1&lt;&lt;((new-&gt;fields&amp;7)+1));
				new-&gt;cmap = readcmap(h, (new-&gt;fields&amp;7)+1);
			}else{
				new-&gt;cmaplen = 3*(1&lt;&lt;((h-&gt;fields&amp;7)+1));
				new-&gt;cmap = malloc(new-&gt;cmaplen);
				memmove(new-&gt;cmap, h-&gt;globalcmap, new-&gt;cmaplen);
			}
			h-&gt;new = new;
			new-&gt;chans[0] = decode(h, new, tbl);
			if(new-&gt;fields &amp; 0x40)
				interlace(h, new);
			new-&gt;gifflags = h-&gt;flags;
			new-&gt;gifdelay = h-&gt;delay;
			new-&gt;giftrindex = h-&gt;trindex;
			new-&gt;gifloopcount = h-&gt;loopcount;
			array = realloc(h-&gt;array, (nimages+2)*sizeof(Rawimage*));
			if(array == nil)
				giferror(h, memerr);
			array[nimages++] = new;
			array[nimages] = nil;
			h-&gt;array = array;
			h-&gt;new = nil;
			break;

		case 0x3B:	/* Trailer */
			goto Return;

		default:
			fprint(2, "ReadGIF: unknown block type: 0x%.2x\n", c);
			goto Return;
		}
	}

   Return:
	if(array[0]==nil || array[0]-&gt;chans[0] == nil)
		giferror(h, "ReadGIF: no picture in file");

	return array;
}

static
void
readheader(Header *h)
{
	if(Bread(h-&gt;fd, h-&gt;buf, 13) != 13)
		giferror(h, "ReadGIF: can't read header: %r");
	memmove(h-&gt;vers, h-&gt;buf, 6);
	if(strcmp(h-&gt;vers, "GIF87a")!=0 &amp;&amp;  strcmp(h-&gt;vers, "GIF89a")!=0)
		giferror(h, "ReadGIF: can't recognize format %s", h-&gt;vers);
	h-&gt;screenw = h-&gt;buf[6]+(h-&gt;buf[7]&lt;&lt;8);
	h-&gt;screenh = h-&gt;buf[8]+(h-&gt;buf[9]&lt;&lt;8);
	h-&gt;fields = h-&gt;buf[10];
	h-&gt;bgrnd = h-&gt;buf[11];
	h-&gt;aspect = h-&gt;buf[12];
	h-&gt;flags = 0;
	h-&gt;delay = 0;
	h-&gt;trindex = 0;
	h-&gt;loopcount = -1;
}

static
uchar*
readcmap(Header *h, int size)
{
	uchar *map;

	if(size &gt; 8)
		giferror(h, "ReadGIF: can't handles %d bits per pixel", size);
	size = 3*(1&lt;&lt;size);
	if(Bread(h-&gt;fd, h-&gt;buf, size) != size)
		giferror(h, "ReadGIF: short read on color map");
	map = malloc(size);
	if(map == nil)
		giferror(h, memerr);
	memmove(map, h-&gt;buf, size);
	return map;
}

static
Rawimage*
readone(Header *h)
{
	Rawimage *i;
	int left, top, width, height;

	if(Bread(h-&gt;fd, h-&gt;buf, 9) != 9)
		giferror(h, "ReadGIF: can't read image descriptor: %r");
	i = malloc(sizeof(Rawimage));
	if(i == nil)
		giferror(h, memerr);
	left = h-&gt;buf[0]+(h-&gt;buf[1]&lt;&lt;8);
	top = h-&gt;buf[2]+(h-&gt;buf[3]&lt;&lt;8);
	width = h-&gt;buf[4]+(h-&gt;buf[5]&lt;&lt;8);
	height = h-&gt;buf[6]+(h-&gt;buf[7]&lt;&lt;8);
	i-&gt;fields = h-&gt;buf[8];
	i-&gt;r.min.x = left;
	i-&gt;r.min.y = top;
	i-&gt;r.max.x = left+width;
	i-&gt;r.max.y = top+height;
	i-&gt;nchans = 1;
	i-&gt;chandesc = CRGB1;
	memset(i-&gt;chans, 0, sizeof(i-&gt;chans));
	return i;
}


static
int
readdata(Header *h, uchar *data)
{
	int nbytes, n;

	nbytes = Bgetc(h-&gt;fd);
	if(nbytes &lt; 0)
		giferror(h, "ReadGIF: can't read data: %r");
	if(nbytes == 0)
		return 0;
	n = Bread(h-&gt;fd, data, nbytes);
	if(n &lt; 0)
		giferror(h, "ReadGIF: can't read data: %r");
	if(n != nbytes)
		fprint(2, "ReadGIF: short data subblock\n");
	return n;
}

static
void
graphiccontrol(Header *h)
{
	if(Bread(h-&gt;fd, h-&gt;buf, 5+1) != 5+1)
		giferror(h, readerr);
	h-&gt;flags = h-&gt;buf[1];
	h-&gt;delay = h-&gt;buf[2]+(h-&gt;buf[3]&lt;&lt;8);
	h-&gt;trindex = h-&gt;buf[4];
}

static
void
skipextension(Header *h)
{
	int type, hsize, hasdata, n;
	uchar data[256];

	hsize = 0;
	hasdata = 0;

	type = Bgetc(h-&gt;fd);
	switch(type){
	case Beof:
		giferror(h, extreaderr);
		break;
	case 0x01:	/* Plain Text Extension */
		hsize = 13;
		hasdata = 1;
		break;
	case 0xF9:	/* Graphic Control Extension */
		graphiccontrol(h);
		return;
	case 0xFE:	/* Comment Extension */
		hasdata = 1;
		break;
	case 0xFF:	/* Application Extension */
		hsize = Bgetc(h-&gt;fd);
		/* standard says this must be 11, but Adobe likes to put out 10-byte ones,
		 * so we pay attention to the field. */
		hasdata = 1;
		break;
	default:
		giferror(h, "ReadGIF: unknown extension");
	}
	if(hsize&gt;0 &amp;&amp; Bread(h-&gt;fd, h-&gt;buf, hsize) != hsize)
		giferror(h, extreaderr);
	if(!hasdata){
		/*
		 * This code used to check h-&gt;buf[hsize-1] != 0
		 * and giferror if so, but if !hasdata, hsize == 0.
		 */
		return;
	}

	/* loop counter: Application Extension with NETSCAPE2.0 as string and 1 &lt;loop.count&gt; in data */
	if(type == 0xFF &amp;&amp; hsize==11 &amp;&amp; memcmp(h-&gt;buf, "NETSCAPE2.0", 11)==0){
		n = readdata(h, data);
		if(n == 0)
			return;
		if(n==3 &amp;&amp; data[0]==1)
			h-&gt;loopcount = data[1] | (data[2]&lt;&lt;8);
	}
	while(readdata(h, data) != 0)
		;
}

static
uchar*
decode(Header *h, Rawimage *i, Entry *tbl)
{
	int c, doclip, incode, codesize, CTM, EOD, pici, datai, stacki, nbits, sreg, fc, code, piclen;
	int csize, nentry, maxentry, first, ocode, ndata, nb;
	uchar clip, *p, *pic;
	uchar stack[4096], data[256];

	if(Bread(h-&gt;fd, h-&gt;buf, 1) != 1)
		giferror(h, "ReadGIF: can't read data: %r");
	codesize = h-&gt;buf[0];
	if(codesize&gt;8 || 0&gt;codesize)
		giferror(h, "ReadGIF: can't handle codesize %d", codesize);
	doclip = 0;
	if(i-&gt;cmap!=nil &amp;&amp; i-&gt;cmaplen!=3*(1&lt;&lt;codesize)
	  &amp;&amp; (codesize!=2 || i-&gt;cmaplen!=3*2))			/* peculiar GIF bitmap files... */
		doclip = 1;

	CTM =1&lt;&lt;codesize;
	EOD = CTM+1;

	piclen = (i-&gt;r.max.x-i-&gt;r.min.x)*(i-&gt;r.max.y-i-&gt;r.min.y);
	i-&gt;chanlen = piclen;
	pic = malloc(piclen);
	if(pic == nil)
		giferror(h, memerr);
	h-&gt;pic = pic;
	pici = 0;
	ndata = 0;
	datai = 0;
	nbits = 0;
	sreg = 0;
	fc = 0;

    Loop:
	for(;;){
		csize = codesize+1;
		nentry = EOD+1;
		maxentry = (1&lt;&lt;csize)-1;
		first = 1;
		ocode = -1;

		for(;; ocode = incode) {
			while(nbits &lt; csize) {
				if(datai == ndata){
					ndata = readdata(h, data);
					if(ndata == 0)
						goto Return;
					datai = 0;
				}
				c = data[datai++];
				sreg |= c&lt;&lt;nbits;
				nbits += 8;
			}
			code = sreg &amp; ((1&lt;&lt;csize) - 1);
			sreg &gt;&gt;= csize;
			nbits -= csize;

			if(code == EOD){
				ndata = readdata(h, data);
				if(ndata != 0)
					fprint(2, "ReadGIF: unexpected data past EOD\n");
				goto Return;
			}

			if(code == CTM)
				goto Loop;

			stacki = (sizeof stack)-1;

			incode = code;

			/* special case for KwKwK */
			if(code == nentry) {
				stack[stacki--] = fc;
				code = ocode;
			}

			if(code &gt; nentry){
				fprint(2, "ReadGIF: GIF invalid, code out of range, %x &gt; %x\n", code, nentry);
				code = nentry;
			}
			for(c=code; stacki&gt;0 &amp;&amp; c&gt;=0; c=tbl[c].prefix)
				stack[stacki--] = tbl[c].exten;

			nb = (sizeof stack)-(stacki+1);
			if(pici+nb &gt; piclen){
				/* this common error is harmless
				 * we have to keep reading to keep the blocks in sync */
				;
			}else{
				memmove(pic+pici, stack+stacki+1, sizeof stack - (stacki+1));
				pici += nb;
			}

			fc = stack[stacki+1];

			if(first){
				first = 0;
				continue;
			}
			#define early 0 /* peculiar tiff feature here for reference */
			if(nentry == maxentry-early) {
				if(csize &gt;= 12)
					continue;
				csize++;
				maxentry = (1&lt;&lt;csize);
				if(csize &lt; 12)
					maxentry--;
			}
			tbl[nentry].prefix = ocode;
			tbl[nentry].exten = fc;
			nentry++;
		}
	}

Return:
	if(doclip){
		clip = i-&gt;cmaplen/3;
		for(p = pic; p &lt; pic+piclen; p++)
			if(*p &gt;= clip)
				*p = clip;
	}
	h-&gt;pic = nil;
	return pic;
}

static
void
interlace(Header *h, Rawimage *image)
{
	uchar *pic;
	Rectangle r;
	int dx, yy, y;
	uchar *ipic;

	pic = image-&gt;chans[0];
	r = image-&gt;r;
	dx = r.max.x-r.min.x;
	ipic = malloc(dx*(r.max.y-r.min.y));
	if(ipic == nil)
		giferror(h, nil);

	/* Group 1: every 8th row, starting with row 0 */
	yy = 0;
	for(y=r.min.y; y&lt;r.max.y; y+=8){
		memmove(&amp;ipic[(y-r.min.y)*dx], &amp;pic[yy*dx], dx);
		yy++;
	}

	/* Group 2: every 8th row, starting with row 4 */
	for(y=r.min.y+4; y&lt;r.max.y; y+=8){
		memmove(&amp;ipic[(y-r.min.y)*dx], &amp;pic[yy*dx], dx);
		yy++;
	}

	/* Group 3: every 4th row, starting with row 2 */
	for(y=r.min.y+2; y&lt;r.max.y; y+=4){
		memmove(&amp;ipic[(y-r.min.y)*dx], &amp;pic[yy*dx], dx);
		yy++;
	}

	/* Group 4: every 2nd row, starting with row 1 */
	for(y=r.min.y+1; y&lt;r.max.y; y+=2){
		memmove(&amp;ipic[(y-r.min.y)*dx], &amp;pic[yy*dx], dx);
		yy++;
	}

	free(image-&gt;chans[0]);
	image-&gt;chans[0] = ipic;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

