<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/readjpg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/readjpg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include "imagefile.h"

enum {
	/* Constants, all preceded by byte 0xFF */
	SOF	=0xC0,	/* Start of Frame */
	SOF2=0xC2,	/* Start of Frame; progressive Huffman */
	JPG	=0xC8,	/* Reserved for JPEG extensions */
	DHT	=0xC4,	/* Define Huffman Tables */
	DAC	=0xCC,	/* Arithmetic coding conditioning */
	RST	=0xD0,	/* Restart interval termination */
	RST7	=0xD7,	/* Restart interval termination (highest value) */
	SOI	=0xD8,	/* Start of Image */
	EOI	=0xD9,	/* End of Image */
	SOS	=0xDA,	/* Start of Scan */
	DQT	=0xDB,	/* Define quantization tables */
	DNL	=0xDC,	/* Define number of lines */
	DRI	=0xDD,	/* Define restart interval */
	DHP	=0xDE,	/* Define hierarchical progression */
	EXP	=0xDF,	/* Expand reference components */
	APPn	=0xE0,	/* Reserved for application segments */
	JPGn	=0xF0,	/* Reserved for JPEG extensions */
	COM	=0xFE,	/* Comment */

	CLAMPOFF	= 300,
	NCLAMP		= CLAMPOFF+700
};

typedef struct Framecomp Framecomp;
typedef struct Header Header;
typedef struct Huffman Huffman;

struct Framecomp	/* Frame component specifier from SOF marker */
{
	int	C;
	int	H;
	int	V;
	int	Tq;
};

struct Huffman
{
	int	*size;	/* malloc'ed */
	int	*code;	/* malloc'ed */
	int	*val;		/* malloc'ed */
	int	mincode[17];
	int	maxcode[17];
	int	valptr[17];
	/* fast lookup */
	int	value[256];
	int	shift[256];
};


struct Header
{
	Biobuf	*fd;
	char		err[256];
	jmp_buf	errlab;
	/* variables in i/o routines */
	int		sr;	/* shift register, right aligned */
	int		cnt;	/* # bits in right part of sr */
	uchar	*buf;
	int		nbuf;
	int		peek;

	int		Nf;

	Framecomp	comp[3];
	uchar	mode;
	int		X;
	int		Y;
	int		qt[4][64];		/* quantization tables */
	Huffman	dcht[4];
	Huffman	acht[4];
	int		**data[3];
	int		ndata[3];
	
	uchar	*sf;	/* start of frame; do better later */
	uchar	*ss;	/* start of scan; do better later */
	int		ri;	/* restart interval */

	/* progressive scan */
	Rawimage *image;
	Rawimage **array;
	int		*dccoeff[3];
	int		**accoeff[3];	/* only need 8 bits plus quantization */
	int		naccoeff[3];
	int		nblock[3];
	int		nacross;
	int		ndown;
	int		Hmax;
	int		Vmax;
};

static	uchar	clamp[NCLAMP];

static	Rawimage	*readslave(Header*, int);
static	int			readsegment(Header*, int*);
static	void			quanttables(Header*, uchar*, int);
static	void			huffmantables(Header*, uchar*, int);
static	void			soiheader(Header*);
static	int			nextbyte(Header*, int);
static	int			int2(uchar*, int);
static	void			nibbles(int, int*, int*);
static	int			receive(Header*, int);
static	int			receiveEOB(Header*, int);
static	int			receivebit(Header*);
static	void			restart(Header*, int);
static	int			decode(Header*, Huffman*);
static	Rawimage*	baselinescan(Header*, int);
static	void			progressivescan(Header*, int);
static	Rawimage*	progressiveIDCT(Header*, int);
static	void			idct(int*);
static	void			colormap1(Header*, int, Rawimage*, int*, int, int);
static	void			colormapall1(Header*, int, Rawimage*, int*, int*, int*, int, int);
static	void			colormap(Header*, int, Rawimage*, int**, int**, int**, int, int, int, int, int*, int*);
static	void			jpgerror(Header*, char*, ...);

static	char		readerr[] = "ReadJPG: read error: %r";
static	char		memerr[] = "ReadJPG: malloc failed: %r";

static	int zig[64] = {
	0, 1, 8, 16, 9, 2, 3, 10, 17, /* 0-7 */
	24, 32, 25, 18, 11, 4, 5, /* 8-15 */
	12, 19, 26, 33, 40, 48, 41, 34, /* 16-23 */
	27, 20, 13, 6, 7, 14, 21, 28, /* 24-31 */
	35, 42, 49, 56, 57, 50, 43, 36, /* 32-39 */
	29, 22, 15, 23, 30, 37, 44, 51, /* 40-47 */
	58, 59, 52, 45, 38, 31, 39, 46, /* 48-55 */
	53, 60, 61, 54, 47, 55, 62, 63 /* 56-63 */
};

static
void
jpginit(void)
{
	int k;
	static int inited;

	if(inited)
		return;
	inited = 1;
	for(k=0; k&lt;CLAMPOFF; k++)
		clamp[k] = 0;
	for(; k&lt;CLAMPOFF+256; k++)
		clamp[k] = k-CLAMPOFF;
	for(; k&lt;NCLAMP; k++)
		clamp[k] = 255;
}

static
void*
jpgmalloc(Header *h, int n, int clear)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		jpgerror(h, memerr);
	if(clear)
		memset(p, 0, n);
	return p;
}

static
void
clear(void **p)
{
	if(*p){
		free(*p);
		*p = nil;
	}
}

static
void
jpgfreeall(Header *h, int freeimage)
{
	int i, j;

	clear(&amp;h-&gt;buf);
	if(h-&gt;dccoeff[0])
		for(i=0; i&lt;3; i++)
			clear(&amp;h-&gt;dccoeff[i]);
	if(h-&gt;accoeff[0])
		for(i=0; i&lt;3; i++){
			if(h-&gt;accoeff[i])
				for(j=0; j&lt;h-&gt;naccoeff[i]; j++)
					clear(&amp;h-&gt;accoeff[i][j]);
			clear(&amp;h-&gt;accoeff[i]);
		}
	for(i=0; i&lt;4; i++){
		clear(&amp;h-&gt;dcht[i].size);
		clear(&amp;h-&gt;acht[i].size);
		clear(&amp;h-&gt;dcht[i].code);
		clear(&amp;h-&gt;acht[i].code);
		clear(&amp;h-&gt;dcht[i].val);
		clear(&amp;h-&gt;acht[i].val);
	}
	if(h-&gt;data[0])
		for(i=0; i&lt;3; i++){
			if(h-&gt;data[i])
				for(j=0; j&lt;h-&gt;ndata[i]; j++)
					clear(&amp;h-&gt;data[i][j]);
			clear(&amp;h-&gt;data[i]);
		}
	if(freeimage &amp;&amp; h-&gt;image!=nil){
		clear(&amp;h-&gt;array);
		clear(&amp;h-&gt;image-&gt;cmap);
		for(i=0; i&lt;3; i++)
			clear(&amp;h-&gt;image-&gt;chans[i]);
		clear(&amp;h-&gt;image);
	}
}

static
void
jpgerror(Header *h, char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	vseprint(h-&gt;err, h-&gt;err+sizeof h-&gt;err, fmt, arg);
	va_end(arg);

	werrstr(h-&gt;err);
	jpgfreeall(h, 1);
	longjmp(h-&gt;errlab, 1);
}

Rawimage**
Breadjpg(Biobuf *b, int colorspace)
{
	Rawimage *r, **array;
	Header *h;
	char buf[ERRMAX];

	buf[0] = '\0';
	if(colorspace!=CYCbCr &amp;&amp; colorspace!=CRGB){
		errstr(buf, sizeof buf);	/* throw it away */
		werrstr("ReadJPG: unknown color space");
		return nil;
	}
	jpginit();
	h = malloc(sizeof(Header));
	array = malloc(sizeof(Header));
	if(h==nil || array==nil){
		free(h);
		free(array);
		return nil;
	}
	h-&gt;array = array;
	memset(h, 0, sizeof(Header));
	h-&gt;fd = b;
	errstr(buf, sizeof buf);	/* throw it away */
	if(setjmp(h-&gt;errlab))
		r = nil;
	else
		r = readslave(h, colorspace);
	jpgfreeall(h, 0);
	free(h);
	array[0] = r;
	array[1] = nil;
	return array;
}

Rawimage**
readjpg(int fd, int colorspace)
{
	Rawimage** a;
	Biobuf b;

	if(Binit(&amp;b, fd, OREAD) &lt; 0)
		return nil;
	a = Breadjpg(&amp;b, colorspace);
	Bterm(&amp;b);
	return a;
}

static
Rawimage*
readslave(Header *header, int colorspace)
{
	Rawimage *image;
	int nseg, i, H, V, m, n;
	uchar *b;

	soiheader(header);
	nseg = 0;
	image = nil;

	header-&gt;buf = jpgmalloc(header, 4096, 0);
	header-&gt;nbuf = 4096;
	while(header-&gt;err[0] == '\0'){
		nseg++;
		n = readsegment(header, &amp;m);
		b = header-&gt;buf;
		switch(m){
		case -1:
			return image;

		case APPn+0:
			if(nseg==1 &amp;&amp; strncmp((char*)b, "JFIF", 4)==0)  /* JFIF header; check version */
				if(b[5]&gt;1 || b[6]&gt;2)
					sprint(header-&gt;err, "ReadJPG: can't handle JFIF version %d.%2d", b[5], b[6]);
			break;

		case APPn+1: case APPn+2: case APPn+3: case APPn+4: case APPn+5:
		case APPn+6: case APPn+7: case APPn+8: case APPn+9: case APPn+10:
		case APPn+11: case APPn+12: case APPn+13: case APPn+14: case APPn+15:
			break;

		case DQT:
			quanttables(header, b, n);
			break;

		case SOF:
		case SOF2:
			header-&gt;Y = int2(b, 1);
			header-&gt;X = int2(b, 3);
			header-&gt;Nf =b[5];
			for(i=0; i&lt;header-&gt;Nf; i++){
				header-&gt;comp[i].C = b[6+3*i+0];
				nibbles(b[6+3*i+1], &amp;H, &amp;V);
				if(H&lt;=0 || V&lt;=0)
					jpgerror(header, "non-positive sampling factor (Hsamp or Vsamp)");
				header-&gt;comp[i].H = H;
				header-&gt;comp[i].V = V;
				header-&gt;comp[i].Tq = b[6+3*i+2];
			}
			header-&gt;mode = m;
			header-&gt;sf = b;
			break;

		case  SOS:
			header-&gt;ss = b;
			switch(header-&gt;mode){
			case SOF:
				image = baselinescan(header, colorspace);
				break;
			case SOF2:
				progressivescan(header, colorspace);
				break;
			default:
				sprint(header-&gt;err, "unrecognized or unspecified encoding %d", header-&gt;mode);
				break;
			}
			break;

		case  DHT:
			huffmantables(header, b, n);
			break;

		case  DRI:
			header-&gt;ri = int2(b, 0);
			break;

		case  COM:
			break;

		case EOI:
			if(header-&gt;mode == SOF2)
				image = progressiveIDCT(header, colorspace);
			return image;

		default:
			sprint(header-&gt;err, "ReadJPG: unknown marker %.2x", m);
			break;
		}
	}
	return image;
}

/* readsegment is called after reading scan, which can have */
/* read ahead a byte.  so we must check peek here */
static
int
readbyte(Header *h)
{
	uchar x;

	if(h-&gt;peek &gt;= 0){
		x = h-&gt;peek;
		h-&gt;peek = -1;
	}else if(Bread(h-&gt;fd, &amp;x, 1) != 1)
		jpgerror(h, readerr);
	return x;
}

static
int
marker(Header *h)
{
	int c;

	while((c=readbyte(h)) == 0)
		fprint(2, "ReadJPG: skipping zero byte at offset %lld\n", Boffset(h-&gt;fd));
	if(c != 0xFF)
		jpgerror(h, "ReadJPG: expecting marker; found 0x%x at offset %lld\n", c, Boffset(h-&gt;fd));
	while(c == 0xFF)
		c = readbyte(h);
	return c;
}

static
int
int2(uchar *buf, int n)
{
	return (buf[n]&lt;&lt;8) + buf[n+1];
}

static
void
nibbles(int b, int *p0, int *p1)
{
	*p0 = (b&gt;&gt;4) &amp; 0xF;
	*p1 = b &amp; 0xF;
}

static
void
soiheader(Header *h)
{
	h-&gt;peek = -1;
	if(marker(h) != SOI)
		jpgerror(h, "ReadJPG: unrecognized marker in header");
	h-&gt;err[0] = '\0';
	h-&gt;mode = 0;
	h-&gt;ri = 0;
}

static
int
readsegment(Header *h, int *markerp)
{
	int m, n;
	uchar tmp[2];

	m = marker(h);
	switch(m){
	case EOI:
		*markerp = m;
		return 0;
	case 0:
		jpgerror(h, "ReadJPG: expecting marker; saw %.2x at offset %lld", m, Boffset(h-&gt;fd));
	}
	if(Bread(h-&gt;fd, tmp, 2) != 2)
    Readerr:
		jpgerror(h, readerr);
	n = int2(tmp, 0);
	if(n &lt; 2)
		goto Readerr;
	n -= 2;
	if(n &gt; h-&gt;nbuf){
		free(h-&gt;buf);
		/* zero in case of short read later */
		h-&gt;buf = jpgmalloc(h, n+1, 1); /* +1 for sentinel */
		h-&gt;nbuf = n;
	}
	/* accept short reads to cope with some real-world jpegs */
	if(Bread(h-&gt;fd, h-&gt;buf, n) &lt; 0)
		goto Readerr;
	*markerp = m;
	return n;
}

static
int
huffmantable(Header *h, uchar *b)
{
	Huffman *t;
	int Tc, th, n, nsize, i, j, k, v, cnt, code, si, sr, m;
	int *maxcode;

	nibbles(b[0], &amp;Tc, &amp;th);
	if(Tc &gt; 1)
		jpgerror(h, "ReadJPG: unknown Huffman table class %d", Tc);
	if(th&gt;3 || (h-&gt;mode==SOF &amp;&amp; th&gt;1))
		jpgerror(h, "ReadJPG: unknown Huffman table index %d", th);
	if(Tc == 0)
		t = &amp;h-&gt;dcht[th];
	else
		t = &amp;h-&gt;acht[th];

	/* flow chart C-2 */
	nsize = 0;
	for(i=0; i&lt;16; i++)
		nsize += b[1+i];
	t-&gt;size = jpgmalloc(h, (nsize+1)*sizeof(int), 1);
	k = 0;
	for(i=1; i&lt;=16; i++){
		n = b[i];
		for(j=0; j&lt;n; j++)
			t-&gt;size[k++] = i;
	}
	t-&gt;size[k] = 0;

	/* initialize HUFFVAL */
	t-&gt;val = jpgmalloc(h, nsize*sizeof(int), 1);
	for(i=0; i&lt;nsize; i++)
		t-&gt;val[i] = b[17+i];

	/* flow chart C-3 */
	t-&gt;code = jpgmalloc(h, (nsize+1)*sizeof(int), 1);
	k = 0;
	code = 0;
	si = t-&gt;size[0];
	for(;;){
		do
			t-&gt;code[k++] = code++;
		while(t-&gt;size[k] == si);
		if(t-&gt;size[k] == 0)
			break;
		do{
			code &lt;&lt;= 1;
			si++;
		}while(t-&gt;size[k] != si);
	}

	/* flow chart F-25 */
	i = 0;
	j = 0;
	for(;;){
		for(;;){
			i++;
			if(i &gt; 16)
				goto outF25;
			if(b[i] != 0)
				break;
			t-&gt;maxcode[i] = -1;
		}
		t-&gt;valptr[i] = j;
		t-&gt;mincode[i] = t-&gt;code[j];
		j += b[i]-1;
		t-&gt;maxcode[i] = t-&gt;code[j];
		j++;
	}
outF25:

	/* create byte-indexed fast path tables */
	maxcode = t-&gt;maxcode;
	/* stupid startup algorithm: just run machine for each byte value */
	for(v=0; v&lt;256; ){
		cnt = 7;
		m = 1&lt;&lt;7;
		code = 0;
		sr = v;
		i = 1;
		for(;;i++){
			if(sr &amp; m)
				code |= 1;
			if(code &lt;= maxcode[i])
				break;
			code &lt;&lt;= 1;
			m &gt;&gt;= 1;
			if(m == 0){
				t-&gt;shift[v] = 0;
				t-&gt;value[v] = -1;
				goto continueBytes;
			}
			cnt--;
		}
		t-&gt;shift[v] = 8-cnt;
		t-&gt;value[v] = t-&gt;val[t-&gt;valptr[i]+(code-t-&gt;mincode[i])];

    continueBytes:
		v++;
	}

	return nsize;
}

static
void
huffmantables(Header *h, uchar *b, int n)
{
	int l, mt;

	for(l=0; l&lt;n; l+=17+mt)
		mt = huffmantable(h, &amp;b[l]);
}

static
int
quanttable(Header *h, uchar *b)
{
	int i, pq, tq, *q;

	nibbles(b[0], &amp;pq, &amp;tq);
	if(pq &gt; 1)
		jpgerror(h, "ReadJPG: unknown quantization table class %d", pq);
	if(tq &gt; 3)
		jpgerror(h, "ReadJPG: unknown quantization table index %d", tq);
	q = h-&gt;qt[tq];
	for(i=0; i&lt;64; i++){
		if(pq == 0)
			q[i] = b[1+i];
		else
			q[i] = int2(b, 1+2*i);
	}
	return 64*(1+pq);
}

static
void
quanttables(Header *h, uchar *b, int n)
{
	int l, m;

	for(l=0; l&lt;n; l+=1+m)
		m = quanttable(h, &amp;b[l]);
}

static
Rawimage*
baselinescan(Header *h, int colorspace)
{
	int Ns, z, k, m, Hmax, Vmax, comp;
	int allHV1, nblock, ri, mcu, nacross, nmcu;
	Huffman *dcht, *acht;
	int block, t, diff, *qt;
	uchar *ss;
	Rawimage *image;
	int Td[3], Ta[3], H[3], V[3], DC[3];
	int ***data, *zz;

	ss = h-&gt;ss;
	Ns = ss[0];
	if((Ns!=3 &amp;&amp; Ns!=1) || Ns!=h-&gt;Nf)
		jpgerror(h, "ReadJPG: can't handle scan not 3 components");

	image = jpgmalloc(h, sizeof(Rawimage), 1);
	h-&gt;image = image;
	image-&gt;r = Rect(0, 0, h-&gt;X, h-&gt;Y);
	image-&gt;cmap = nil;
	image-&gt;cmaplen = 0;
	image-&gt;chanlen = h-&gt;X*h-&gt;Y;
	image-&gt;fields = 0;
	image-&gt;gifflags = 0;
	image-&gt;gifdelay = 0;
	image-&gt;giftrindex = 0;
	if(Ns == 3)
		image-&gt;chandesc = colorspace;
	else
		image-&gt;chandesc = CY;
	image-&gt;nchans = h-&gt;Nf;
	for(k=0; k&lt;h-&gt;Nf; k++)
		image-&gt;chans[k] = jpgmalloc(h, h-&gt;X*h-&gt;Y, 0);

	/* compute maximum H and V */
	Hmax = 0;
	Vmax = 0;
	for(comp=0; comp&lt;Ns; comp++){
		if(h-&gt;comp[comp].H &gt; Hmax)
			Hmax = h-&gt;comp[comp].H;
		if(h-&gt;comp[comp].V &gt; Vmax)
			Vmax = h-&gt;comp[comp].V;
	}

	/* initialize data structures */
	allHV1 = 1;
	data = h-&gt;data;
	for(comp=0; comp&lt;Ns; comp++){
		/* JPEG requires scan components to be in same order as in frame, */
		/* so if both have 3 we know scan is Y Cb Cr and there's no need to */
		/* reorder */
		nibbles(ss[2+2*comp], &amp;Td[comp], &amp;Ta[comp]);
		H[comp] = h-&gt;comp[comp].H;
		V[comp] = h-&gt;comp[comp].V;
		nblock = H[comp]*V[comp];
		if(nblock != 1)
			allHV1 = 0;
		data[comp] = jpgmalloc(h, nblock*sizeof(int*), 0);
		h-&gt;ndata[comp] = nblock;
		DC[comp] = 0;
		for(m=0; m&lt;nblock; m++)
			data[comp][m] = jpgmalloc(h, 8*8*sizeof(int), 0);
	}

	ri = h-&gt;ri;

	h-&gt;cnt = 0;
	h-&gt;sr = 0;
	h-&gt;peek = -1;
	nacross = ((h-&gt;X+(8*Hmax-1))/(8*Hmax));
	nmcu = ((h-&gt;Y+(8*Vmax-1))/(8*Vmax))*nacross;
	for(mcu=0; mcu&lt;nmcu; ){
		for(comp=0; comp&lt;Ns; comp++){
			dcht = &amp;h-&gt;dcht[Td[comp]];
			acht = &amp;h-&gt;acht[Ta[comp]];
			qt = h-&gt;qt[h-&gt;comp[comp].Tq];

			for(block=0; block&lt;H[comp]*V[comp]; block++){
				/* F-22 */
				t = decode(h, dcht);
				diff = receive(h, t);
				DC[comp] += diff;

				/* F-23 */
				zz = data[comp][block];
				memset(zz, 0, 8*8*sizeof(int));
				zz[0] = qt[0]*DC[comp];
				k = 1;

				for(;;){
					t = decode(h, acht);
					if((t&amp;0x0F) == 0){
						if((t&amp;0xF0) != 0xF0)
							break;
						k += 16;
					}else{
						k += t&gt;&gt;4;
						z = receive(h, t&amp;0xF);
						zz[zig[k]] = z*qt[k];
						if(k == 63)
							break;
						k++;
					}
				}

				idct(zz);
			}
		}

		/* rotate colors to RGB and assign to bytes */
		if(Ns == 1) /* very easy */
			colormap1(h, colorspace, image, data[0][0], mcu, nacross);
		else if(allHV1) /* fairly easy */
			colormapall1(h, colorspace, image, data[0][0], data[1][0], data[2][0], mcu, nacross);
		else /* miserable general case */
			colormap(h, colorspace, image, data[0], data[1], data[2], mcu, nacross, Hmax, Vmax, H, V);
		/* process restart marker, if present */
		mcu++;
		if(ri&gt;0 &amp;&amp; mcu&lt;nmcu &amp;&amp; mcu%ri==0){
			restart(h, mcu);
			for(comp=0; comp&lt;Ns; comp++)
				DC[comp] = 0;
		}
	}
	return image;
}

static
void
restart(Header *h, int mcu)
{
	int rest, rst, nskip;

	rest = mcu/h-&gt;ri-1;
	nskip = 0;
	do{
		do{
			rst = nextbyte(h, 1);
			nskip++;
		}while(rst&gt;=0 &amp;&amp; rst!=0xFF);
		if(rst == 0xFF){
			rst = nextbyte(h, 1);
			nskip++;
		}
	}while(rst&gt;=0 &amp;&amp; (rst&amp;~7)!=RST);
	if(nskip != 2)
		sprint(h-&gt;err, "ReadJPG: skipped %d bytes at restart %d\n", nskip-2, rest);
	if(rst &lt; 0)
		jpgerror(h, readerr);
	if((rst&amp;7) != (rest&amp;7))
		jpgerror(h, "ReadJPG: expected RST%d got %d", rest&amp;7, rst&amp;7);
	h-&gt;cnt = 0;
	h-&gt;sr = 0;
}

static
Rawimage*
progressiveIDCT(Header *h, int colorspace)
{
	int k, m, comp, block, Nf, bn;
	int allHV1, nblock, mcu, nmcu;
	int H[3], V[3], blockno[3];
	int *dccoeff, **accoeff;
	int ***data, *zz;

	Nf = h-&gt;Nf;
	allHV1 = 1;
	data = h-&gt;data;

	for(comp=0; comp&lt;Nf; comp++){
		H[comp] = h-&gt;comp[comp].H;
		V[comp] = h-&gt;comp[comp].V;
		nblock = h-&gt;nblock[comp];
		if(nblock != 1)
			allHV1 = 0;
		h-&gt;ndata[comp] = nblock;
		data[comp] = jpgmalloc(h, nblock*sizeof(int*), 0);
		for(m=0; m&lt;nblock; m++)
			data[comp][m] = jpgmalloc(h, 8*8*sizeof(int), 0);
	}

	memset(blockno, 0, sizeof blockno);
	nmcu = h-&gt;nacross*h-&gt;ndown;
	for(mcu=0; mcu&lt;nmcu; mcu++){
		for(comp=0; comp&lt;Nf; comp++){
			dccoeff = h-&gt;dccoeff[comp];
			accoeff = h-&gt;accoeff[comp];
			bn = blockno[comp];
			for(block=0; block&lt;h-&gt;nblock[comp]; block++){
				zz = data[comp][block];
				memset(zz, 0, 8*8*sizeof(int));
				zz[0] = dccoeff[bn];

				for(k=1; k&lt;64; k++)
					zz[zig[k]] = accoeff[bn][k];

				idct(zz);
				bn++;
			}
			blockno[comp] = bn;
		}

		/* rotate colors to RGB and assign to bytes */
		if(Nf == 1) /* very easy */
			colormap1(h, colorspace, h-&gt;image, data[0][0], mcu, h-&gt;nacross);
		else if(allHV1) /* fairly easy */
			colormapall1(h, colorspace, h-&gt;image, data[0][0], data[1][0], data[2][0], mcu, h-&gt;nacross);
		else /* miserable general case */
			colormap(h, colorspace, h-&gt;image, data[0], data[1], data[2], mcu, h-&gt;nacross, h-&gt;Hmax, h-&gt;Vmax, H, V);
	}

	return h-&gt;image;
}

static
void
progressiveinit(Header *h, int colorspace)
{
	int Nf, Ns, j, k, nmcu, comp;
	uchar *ss;
	Rawimage *image;

	ss = h-&gt;ss;
	Ns = ss[0];
	Nf = h-&gt;Nf;
	if((Ns!=3 &amp;&amp; Ns!=1) || Ns!=Nf)
		jpgerror(h, "ReadJPG: image must have 1 or 3 components");

	image = jpgmalloc(h, sizeof(Rawimage), 1);
	h-&gt;image = image;
	image-&gt;r = Rect(0, 0, h-&gt;X, h-&gt;Y);
	image-&gt;cmap = nil;
	image-&gt;cmaplen = 0;
	image-&gt;chanlen = h-&gt;X*h-&gt;Y;
	image-&gt;fields = 0;
	image-&gt;gifflags = 0;
	image-&gt;gifdelay = 0;
	image-&gt;giftrindex = 0;
	if(Nf == 3)
		image-&gt;chandesc = colorspace;
	else
		image-&gt;chandesc = CY;
	image-&gt;nchans = h-&gt;Nf;
	for(k=0; k&lt;Nf; k++){
		image-&gt;chans[k] = jpgmalloc(h, h-&gt;X*h-&gt;Y, 0);
		h-&gt;nblock[k] = h-&gt;comp[k].H*h-&gt;comp[k].V;
	}

	/* compute maximum H and V */
	h-&gt;Hmax = 0;
	h-&gt;Vmax = 0;
	for(comp=0; comp&lt;Nf; comp++){
		if(h-&gt;comp[comp].H &gt; h-&gt;Hmax)
			h-&gt;Hmax = h-&gt;comp[comp].H;
		if(h-&gt;comp[comp].V &gt; h-&gt;Vmax)
			h-&gt;Vmax = h-&gt;comp[comp].V;
	}
	h-&gt;nacross = ((h-&gt;X+(8*h-&gt;Hmax-1))/(8*h-&gt;Hmax));
	h-&gt;ndown = ((h-&gt;Y+(8*h-&gt;Vmax-1))/(8*h-&gt;Vmax));
	nmcu = h-&gt;nacross*h-&gt;ndown;

	for(k=0; k&lt;Nf; k++){
		h-&gt;dccoeff[k] = jpgmalloc(h, h-&gt;nblock[k]*nmcu * sizeof(int), 1);
		h-&gt;accoeff[k] = jpgmalloc(h, h-&gt;nblock[k]*nmcu * sizeof(int*), 1);
		h-&gt;naccoeff[k] = h-&gt;nblock[k]*nmcu;
		for(j=0; j&lt;h-&gt;nblock[k]*nmcu; j++)
			h-&gt;accoeff[k][j] = jpgmalloc(h, 64*sizeof(int), 1);
	}

}

static
void
progressivedc(Header *h, int comp, int Ah, int Al)
{
	int Ns, z, ri, mcu,  nmcu;
	int block, t, diff, qt, *dc, bn;
	Huffman *dcht;
	uchar *ss;
	int Td[3], DC[3], blockno[3];

	ss= h-&gt;ss;
	Ns = ss[0];
	if(Ns!=h-&gt;Nf)
		jpgerror(h, "ReadJPG: can't handle progressive with Nf!=Ns in DC scan");

	/* initialize data structures */
	h-&gt;cnt = 0;
	h-&gt;sr = 0;
	h-&gt;peek = -1;
	for(comp=0; comp&lt;Ns; comp++){
		/*
		 * JPEG requires scan components to be in same order as in frame,
		 * so if both have 3 we know scan is Y Cb Cr and there's no need to
		 * reorder
		 */
		nibbles(ss[2+2*comp], &amp;Td[comp], &amp;z);	/* z is ignored */
		DC[comp] = 0;
	}

	ri = h-&gt;ri;

	nmcu = h-&gt;nacross*h-&gt;ndown;
	memset(blockno, 0, sizeof blockno);
	for(mcu=0; mcu&lt;nmcu; ){
		for(comp=0; comp&lt;Ns; comp++){
			dcht = &amp;h-&gt;dcht[Td[comp]];
			qt = h-&gt;qt[h-&gt;comp[comp].Tq][0];
			dc = h-&gt;dccoeff[comp];
			bn = blockno[comp];

			for(block=0; block&lt;h-&gt;nblock[comp]; block++){
				if(Ah == 0){
					t = decode(h, dcht);
					diff = receive(h, t);
					DC[comp] += diff;
					dc[bn] = qt*DC[comp]&lt;&lt;Al;
				}else
					dc[bn] |= qt*receivebit(h)&lt;&lt;Al;
				bn++;
			}
			blockno[comp] = bn;
		}

		/* process restart marker, if present */
		mcu++;
		if(ri&gt;0 &amp;&amp; mcu&lt;nmcu &amp;&amp; mcu%ri==0){
			restart(h, mcu);
			for(comp=0; comp&lt;Ns; comp++)
				DC[comp] = 0;
		}
	}
}

static
void
progressiveac(Header *h, int comp, int Al)
{
	int Ns, Ss, Se, z, k, eobrun, x, y, nver, tmcu, blockno, *acc, rs;
	int ri, mcu, nacross, ndown, nmcu, nhor;
	Huffman *acht;
	int *qt, rrrr, ssss, q;
	uchar *ss;
	int Ta, H, V;

	ss = h-&gt;ss;
	Ns = ss[0];
	if(Ns != 1)
		jpgerror(h, "ReadJPG: illegal Ns&gt;1 in progressive AC scan");
	Ss = ss[1+2];
	Se = ss[2+2];
	H = h-&gt;comp[comp].H;
	V = h-&gt;comp[comp].V;

	nacross = h-&gt;nacross*H;
	ndown = h-&gt;ndown*V;
	q = 8*h-&gt;Hmax/H;
	nhor = (h-&gt;X+q-1)/q;
	q = 8*h-&gt;Vmax/V;
	nver = (h-&gt;Y+q-1)/q;

	/* initialize data structures */
	h-&gt;cnt = 0;
	h-&gt;sr = 0;
	h-&gt;peek = -1;
	nibbles(ss[1+1], &amp;z, &amp;Ta);	/* z is thrown away */

	ri = h-&gt;ri;

	eobrun = 0;
	acht = &amp;h-&gt;acht[Ta];
	qt = h-&gt;qt[h-&gt;comp[comp].Tq];
	nmcu = nacross*ndown;
	mcu = 0;
	for(y=0; y&lt;nver; y++){
		for(x=0; x&lt;nhor; x++){
			/* Figure G-3  */
			if(eobrun &gt; 0){
				--eobrun;
				continue;
			}

			/* arrange blockno to be in same sequence as original scan calculation. */
			tmcu = x/H + (nacross/H)*(y/V);
			blockno = tmcu*H*V + H*(y%V) + x%H;
			acc = h-&gt;accoeff[comp][blockno];
			k = Ss;
			for(;;){
				rs = decode(h, acht);
				/* XXX remove rrrr ssss as in baselinescan */
				nibbles(rs, &amp;rrrr, &amp;ssss);
				if(ssss == 0){
					if(rrrr &lt; 15){
						eobrun = 0;
						if(rrrr &gt; 0)
							eobrun = receiveEOB(h, rrrr)-1;
						break;
					}
					k += 16;
				}else{
					k += rrrr;
					z = receive(h, ssss);
					acc[k] = z*qt[k]&lt;&lt;Al;
					if(k == Se)
						break;
					k++;
				}
			}
		}

		/* process restart marker, if present */
		mcu++;
		if(ri&gt;0 &amp;&amp; mcu&lt;nmcu &amp;&amp; mcu%ri==0){
			restart(h, mcu);
			eobrun = 0;
		}
	}
}

static
void
increment(Header *h, int acc[], int k, int Pt)
{
	if(acc[k] == 0)
		return;
	if(receivebit(h) != 0)
		if(acc[k] &lt; 0)
			acc[k] -= Pt;
		else
			acc[k] += Pt;
}

static
void
progressiveacinc(Header *h, int comp, int Al)
{
	int Ns, i, z, k, Ss, Se, Ta, **ac, H, V;
	int ri, mcu, nacross, ndown, nhor, nver, eobrun, nzeros, pending, x, y, tmcu, blockno, q, nmcu;
	Huffman *acht;
	int *qt, rrrr, ssss, *acc, rs;
	uchar *ss;

	ss = h-&gt;ss;
	Ns = ss[0];
	if(Ns != 1)
		jpgerror(h, "ReadJPG: illegal Ns&gt;1 in progressive AC scan");
	Ss = ss[1+2];
	Se = ss[2+2];
	H = h-&gt;comp[comp].H;
	V = h-&gt;comp[comp].V;

	nacross = h-&gt;nacross*H;
	ndown = h-&gt;ndown*V;
	q = 8*h-&gt;Hmax/H;
	nhor = (h-&gt;X+q-1)/q;
	q = 8*h-&gt;Vmax/V;
	nver = (h-&gt;Y+q-1)/q;

	/* initialize data structures */
	h-&gt;cnt = 0;
	h-&gt;sr = 0;
	h-&gt;peek = -1;
	nibbles(ss[1+1], &amp;z, &amp;Ta);	/* z is thrown away */
	ri = h-&gt;ri;

	eobrun = 0;
	ac = h-&gt;accoeff[comp];
	acht = &amp;h-&gt;acht[Ta];
	qt = h-&gt;qt[h-&gt;comp[comp].Tq];
	nmcu = nacross*ndown;
	mcu = 0;
	pending = 0;
	nzeros = -1;
	for(y=0; y&lt;nver; y++){
		for(x=0; x&lt;nhor; x++){
			/* Figure G-7 */

			/*  arrange blockno to be in same sequence as original scan calculation. */
			tmcu = x/H + (nacross/H)*(y/V);
			blockno = tmcu*H*V + H*(y%V) + x%H;
			acc = ac[blockno];
			if(eobrun &gt; 0){
				if(nzeros &gt; 0)
					jpgerror(h, "ReadJPG: zeros pending at block start");
				for(k=Ss; k&lt;=Se; k++)
					increment(h, acc, k, qt[k]&lt;&lt;Al);
				--eobrun;
				continue;
			}

			for(k=Ss; k&lt;=Se; ){
				if(nzeros &gt;= 0){
					if(acc[k] != 0)
						increment(h, acc, k, qt[k]&lt;&lt;Al);
					else if(nzeros-- == 0)
						acc[k] = pending;
					k++;
					continue;
				}
				rs = decode(h, acht);
				nibbles(rs, &amp;rrrr, &amp;ssss);
				if(ssss == 0){
					if(rrrr &lt; 15){
						eobrun = 0;
						if(rrrr &gt; 0)
							eobrun = receiveEOB(h, rrrr)-1;
						while(k &lt;= Se){
							increment(h, acc, k, qt[k]&lt;&lt;Al);
							k++;
						}
						break;
					}
					for(i=0; i&lt;16; k++){
						increment(h, acc, k, qt[k]&lt;&lt;Al);
						if(acc[k] == 0)
							i++;
					}
					continue;
				}else if(ssss != 1)
					jpgerror(h, "ReadJPG: ssss!=1 in progressive increment");
				nzeros = rrrr;
				pending = receivebit(h);
				if(pending == 0)
					pending = -1;
				pending *= qt[k]&lt;&lt;Al;
			}
		}

		/* process restart marker, if present */
		mcu++;
		if(ri&gt;0 &amp;&amp; mcu&lt;nmcu &amp;&amp; mcu%ri==0){
			restart(h, mcu);
			eobrun = 0;
			nzeros = -1;
		}
	}
}

static
void
progressivescan(Header *h, int colorspace)
{
	uchar *ss;
	int Ns, Ss, Ah, Al, c, comp, i;

	if(h-&gt;dccoeff[0] == nil)
		progressiveinit(h, colorspace);

	ss = h-&gt;ss;
	Ns = ss[0];
	Ss = ss[1+2*Ns];
	nibbles(ss[3+2*Ns], &amp;Ah, &amp;Al);
	c = ss[1];
	comp = -1;
	for(i=0; i&lt;h-&gt;Nf; i++)
		if(h-&gt;comp[i].C == c)
			comp = i;
	if(comp == -1)
		jpgerror(h, "ReadJPG: bad component index in scan header");

	if(Ss == 0){
		progressivedc(h, comp, Ah, Al);
		return;
	}
	if(Ah == 0){
		progressiveac(h, comp, Al);
		return;
	}
	progressiveacinc(h, comp, Al);
}

enum {
	c1 = 2871,	/* 1.402 * 2048 */
	c2 = 705,		/* 0.34414 * 2048 */
	c3 = 1463,	/* 0.71414 * 2048 */
	c4 = 3629,	/* 1.772 * 2048 */
};

static
void
colormap1(Header *h, int colorspace, Rawimage *image, int data[8*8], int mcu, int nacross)
{
	uchar *pic;
	int x, y, dx, dy, minx, miny;
	int r, k, pici;

	USED(colorspace);
	pic = image-&gt;chans[0];
	minx = 8*(mcu%nacross);
	dx = 8;
	if(minx+dx &gt; h-&gt;X)
		dx = h-&gt;X-minx;
	miny = 8*(mcu/nacross);
	dy = 8;
	if(miny+dy &gt; h-&gt;Y)
		dy = h-&gt;Y-miny;
	pici = miny*h-&gt;X+minx;
	k = 0;
	for(y=0; y&lt;dy; y++){
		for(x=0; x&lt;dx; x++){
			r = clamp[(data[k+x]+128)+CLAMPOFF];
			pic[pici+x] = r;
		}
		pici += h-&gt;X;
		k += 8;
	}
}

static
void
colormapall1(Header *h, int colorspace, Rawimage *image, int data0[8*8], int data1[8*8], int data2[8*8], int mcu, int nacross)
{
	uchar *rpic, *gpic, *bpic, *rp, *gp, *bp;
	int *p0, *p1, *p2;
	int x, y, dx, dy, minx, miny;
	int r, g, b, k, pici;
	int Y, Cr, Cb;

	rpic = image-&gt;chans[0];
	gpic = image-&gt;chans[1];
	bpic = image-&gt;chans[2];
	minx = 8*(mcu%nacross);
	dx = 8;
	if(minx+dx &gt; h-&gt;X)
		dx = h-&gt;X-minx;
	miny = 8*(mcu/nacross);
	dy = 8;
	if(miny+dy &gt; h-&gt;Y)
		dy = h-&gt;Y-miny;
	pici = miny*h-&gt;X+minx;
	k = 0;
	for(y=0; y&lt;dy; y++){
		p0 = data0+k;
		p1 = data1+k;
		p2 = data2+k;
		rp = rpic+pici;
		gp = gpic+pici;
		bp = bpic+pici;
		if(colorspace == CYCbCr)
			for(x=0; x&lt;dx; x++){
				*rp++ = clamp[*p0++ + 128 + CLAMPOFF];
				*gp++ = clamp[*p1++ + 128 + CLAMPOFF];
				*bp++ = clamp[*p2++ + 128 + CLAMPOFF];
			}
		else
			for(x=0; x&lt;dx; x++){
				Y = (*p0++ + 128) &lt;&lt; 11;
				Cb = *p1++;
				Cr = *p2++;
				r = Y+c1*Cr;
				g = Y-c2*Cb-c3*Cr;
				b = Y+c4*Cb;
				*rp++ = clamp[(r&gt;&gt;11)+CLAMPOFF];
				*gp++ = clamp[(g&gt;&gt;11)+CLAMPOFF];
				*bp++ = clamp[(b&gt;&gt;11)+CLAMPOFF];
			}
		pici += h-&gt;X;
		k += 8;
	}
}

static
void
colormap(Header *h, int colorspace, Rawimage *image, int *data0[8*8], int *data1[8*8], int *data2[8*8], int mcu, int nacross, int Hmax, int Vmax,  int *H, int *V)
{
	uchar *rpic, *gpic, *bpic;
	int x, y, dx, dy, minx, miny;
	int r, g, b, pici, H0, H1, H2;
	int t, b0, b1, b2, y0, y1, y2, x0, x1, x2;
	int Y, Cr, Cb;

	rpic = image-&gt;chans[0];
	gpic = image-&gt;chans[1];
	bpic = image-&gt;chans[2];
	minx = 8*Hmax*(mcu%nacross);
	dx = 8*Hmax;
	if(minx+dx &gt; h-&gt;X)
		dx = h-&gt;X-minx;
	miny = 8*Vmax*(mcu/nacross);
	dy = 8*Vmax;
	if(miny+dy &gt; h-&gt;Y)
		dy = h-&gt;Y-miny;
	pici = miny*h-&gt;X+minx;
	H0 = H[0];
	H1 = H[1];
	H2 = H[2];
	for(y=0; y&lt;dy; y++){
		t = y*V[0];
		b0 = H0*(t/(8*Vmax));
		y0 = 8*((t/Vmax)&amp;7);
		t = y*V[1];
		b1 = H1*(t/(8*Vmax));
		y1 = 8*((t/Vmax)&amp;7);
		t = y*V[2];
		b2 = H2*(t/(8*Vmax));
		y2 = 8*((t/Vmax)&amp;7);
		x0 = 0;
		x1 = 0;
		x2 = 0;
		for(x=0; x&lt;dx; x++){
			if(colorspace == CYCbCr){
				rpic[pici+x] = clamp[data0[b0][y0+x0++*H0/Hmax] + 128 + CLAMPOFF];
				gpic[pici+x] = clamp[data1[b1][y1+x1++*H1/Hmax] + 128 + CLAMPOFF];
				bpic[pici+x] = clamp[data2[b2][y2+x2++*H2/Hmax] + 128 + CLAMPOFF];
			}else{
				Y = (data0[b0][y0+x0++*H0/Hmax]+128)&lt;&lt;11;
				Cb = data1[b1][y1+x1++*H1/Hmax];
				Cr = data2[b2][y2+x2++*H2/Hmax];
				r = Y+c1*Cr;
				g = Y-c2*Cb-c3*Cr;
				b = Y+c4*Cb;
				rpic[pici+x] = clamp[(r&gt;&gt;11)+CLAMPOFF];
				gpic[pici+x] = clamp[(g&gt;&gt;11)+CLAMPOFF];
				bpic[pici+x] = clamp[(b&gt;&gt;11)+CLAMPOFF];
			}
			if(x0*H0/Hmax &gt;= 8){
				x0 = 0;
				b0++;
			}
			if(x1*H1/Hmax &gt;= 8){
				x1 = 0;
				b1++;
			}
			if(x2*H2/Hmax &gt;= 8){
				x2 = 0;
				b2++;
			}
		}
		pici += h-&gt;X;
	}
}

/*
 * decode next 8-bit value from entropy-coded input.  chart F-26
 */
static
int
decode(Header *h, Huffman *t)
{
	int code, v, cnt, m, sr, i;
	int *maxcode;
	static int badcode;

	maxcode = t-&gt;maxcode;
	if(h-&gt;cnt &lt; 8)
		nextbyte(h, 0);
	/* fast lookup */
	code = (h-&gt;sr&gt;&gt;(h-&gt;cnt-8))&amp;0xFF;
	v = t-&gt;value[code];
	if(v &gt;= 0){
		h-&gt;cnt -= t-&gt;shift[code];
		return v;
	}

	h-&gt;cnt -= 8;
	if(h-&gt;cnt == 0)
		nextbyte(h, 0);
	h-&gt;cnt--;
	cnt = h-&gt;cnt;
	m = 1&lt;&lt;cnt;
	sr = h-&gt;sr;
	code &lt;&lt;= 1;
	i = 9;
	for(;;i++){
		if(sr &amp; m)
			code |= 1;
		if(code &lt;= maxcode[i])
			break;
		code &lt;&lt;= 1;
		m &gt;&gt;= 1;
		if(m == 0){
			sr = nextbyte(h, 0);
			m = 0x80;
			cnt = 8;
		}
		cnt--;
	}
	if(i &gt;= 17){
		if(badcode == 0)
			fprint(2, "badly encoded %dx%d JPEG file; ignoring bad value\n", h-&gt;X, h-&gt;Y);
		badcode = 1;
		i = 0;
	}
	h-&gt;cnt = cnt;
	return t-&gt;val[t-&gt;valptr[i]+(code-t-&gt;mincode[i])];
}

/*
 * load next byte of input
 */
static
int
nextbyte(Header *h, int marker)
{
	int b, b2;

	if(h-&gt;peek &gt;= 0){
		b = h-&gt;peek;
		h-&gt;peek = -1;
	}else{
		b = Bgetc(h-&gt;fd);
		if(b == Beof)
			jpgerror(h, "truncated file");
		b &amp;= 0xFF;
	}

	if(b == 0xFF){
		if(marker)
			return b;
		b2 = Bgetc(h-&gt;fd);
		if(b2 != 0){
			if(b2 == Beof)
				jpgerror(h, "truncated file");
			b2 &amp;= 0xFF;
			if(b2 == DNL)
				jpgerror(h, "ReadJPG: DNL marker unimplemented");
			/* decoder is reading into marker; satisfy it and restore state */
			Bungetc(h-&gt;fd);
			h-&gt;peek = b;
		}
	}
	h-&gt;cnt += 8;
	h-&gt;sr = (h-&gt;sr&lt;&lt;8) | b;
	return b;
}

/*
 * return next s bits of input, MSB first, and level shift it
 */
static
int
receive(Header *h, int s)
{
	int v, m;

	while(h-&gt;cnt &lt; s)
		nextbyte(h, 0);
	h-&gt;cnt -= s;
	v = h-&gt;sr &gt;&gt; h-&gt;cnt;
	m = (1&lt;&lt;s);
	v &amp;= m-1;
	/* level shift */
	if(v &lt; (m&gt;&gt;1))
		v += ~(m-1)+1;
	return v;
}

/*
 * return next s bits of input, decode as EOB
 */
static
int
receiveEOB(Header *h, int s)
{
	int v, m;

	while(h-&gt;cnt &lt; s)
		nextbyte(h, 0);
	h-&gt;cnt -= s;
	v = h-&gt;sr &gt;&gt; h-&gt;cnt;
	m = (1&lt;&lt;s);
	v &amp;= m-1;
	/* level shift */
	v += m;
	return v;
}

/* 
 * return next bit of input
 */
static
int
receivebit(Header *h)
{
	if(h-&gt;cnt &lt; 1)
		nextbyte(h, 0);
	h-&gt;cnt--;
	return (h-&gt;sr &gt;&gt; h-&gt;cnt) &amp; 1;
}

/*
 *  Scaled integer implementation.
 *  inverse two dimensional DCT, Chen-Wang algorithm
 * (IEEE ASSP-32, pp. 803-816, Aug. 1984)
 * 32-bit integer arithmetic (8 bit coefficients)
 * 11 mults, 29 adds per DCT
 *
 * coefficients extended to 12 bit for IEEE1180-1990 compliance
 */

enum {
	W1		= 2841,	/* 2048*sqrt(2)*cos(1*pi/16)*/
	W2		= 2676,	/* 2048*sqrt(2)*cos(2*pi/16)*/
	W3		= 2408,	/* 2048*sqrt(2)*cos(3*pi/16)*/
	W5		= 1609,	/* 2048*sqrt(2)*cos(5*pi/16)*/
	W6		= 1108,	/* 2048*sqrt(2)*cos(6*pi/16)*/
	W7		= 565,	/* 2048*sqrt(2)*cos(7*pi/16)*/

	W1pW7	= 3406,	/* W1+W7*/
	W1mW7	= 2276,	/* W1-W7*/
	W3pW5	= 4017,	/* W3+W5*/
	W3mW5	= 799,	/* W3-W5*/
	W2pW6	= 3784,	/* W2+W6*/
	W2mW6	= 1567,	/* W2-W6*/

	R2		= 181	/* 256/sqrt(2)*/
};

static
void
idct(int b[8*8])
{
	int x, y, eighty, v;
	int x0, x1, x2, x3, x4, x5, x6, x7, x8;
	int *p;

	/* transform horizontally*/
	for(y=0; y&lt;8; y++){
		eighty = y&lt;&lt;3;
		/* if all non-DC components are zero, just propagate the DC term*/
		p = b+eighty;
		if(p[1]==0)
		if(p[2]==0 &amp;&amp; p[3]==0)
		if(p[4]==0 &amp;&amp; p[5]==0)
		if(p[6]==0 &amp;&amp; p[7]==0){
			v = p[0]&lt;&lt;3;
			p[0] = v;
			p[1] = v;
			p[2] = v;
			p[3] = v;
			p[4] = v;
			p[5] = v;
			p[6] = v;
			p[7] = v;
			continue;
		}
		/* prescale*/
		x0 = (p[0]&lt;&lt;11)+128;
		x1 = p[4]&lt;&lt;11;
		x2 = p[6];
		x3 = p[2];
		x4 = p[1];
		x5 = p[7];
		x6 = p[5];
		x7 = p[3];
		/* first stage*/
		x8 = W7*(x4+x5);
		x4 = x8 + W1mW7*x4;
		x5 = x8 - W1pW7*x5;
		x8 = W3*(x6+x7);
		x6 = x8 - W3mW5*x6;
		x7 = x8 - W3pW5*x7;
		/* second stage*/
		x8 = x0 + x1;
		x0 -= x1;
		x1 = W6*(x3+x2);
		x2 = x1 - W2pW6*x2;
		x3 = x1 + W2mW6*x3;
		x1 = x4 + x6;
		x4 -= x6;
		x6 = x5 + x7;
		x5 -= x7;
		/* third stage*/
		x7 = x8 + x3;
		x8 -= x3;
		x3 = x0 + x2;
		x0 -= x2;
		x2 = (R2*(x4+x5)+128)&gt;&gt;8;
		x4 = (R2*(x4-x5)+128)&gt;&gt;8;
		/* fourth stage*/
		p[0] = (x7+x1)&gt;&gt;8;
		p[1] = (x3+x2)&gt;&gt;8;
		p[2] = (x0+x4)&gt;&gt;8;
		p[3] = (x8+x6)&gt;&gt;8;
		p[4] = (x8-x6)&gt;&gt;8;
		p[5] = (x0-x4)&gt;&gt;8;
		p[6] = (x3-x2)&gt;&gt;8;
		p[7] = (x7-x1)&gt;&gt;8;
	}
	/* transform vertically*/
	for(x=0; x&lt;8; x++){
		/* if all non-DC components are zero, just propagate the DC term*/
		p = b+x;
		if(p[8*1]==0)
		if(p[8*2]==0 &amp;&amp; p[8*3]==0)
		if(p[8*4]==0 &amp;&amp; p[8*5]==0)
		if(p[8*6]==0 &amp;&amp; p[8*7]==0){
			v = (p[8*0]+32)&gt;&gt;6;
			p[8*0] = v;
			p[8*1] = v;
			p[8*2] = v;
			p[8*3] = v;
			p[8*4] = v;
			p[8*5] = v;
			p[8*6] = v;
			p[8*7] = v;
			continue;
		}
		/* prescale*/
		x0 = (p[8*0]&lt;&lt;8)+8192;
		x1 = p[8*4]&lt;&lt;8;
		x2 = p[8*6];
		x3 = p[8*2];
		x4 = p[8*1];
		x5 = p[8*7];
		x6 = p[8*5];
		x7 = p[8*3];
		/* first stage*/
		x8 = W7*(x4+x5) + 4;
		x4 = (x8+W1mW7*x4)&gt;&gt;3;
		x5 = (x8-W1pW7*x5)&gt;&gt;3;
		x8 = W3*(x6+x7) + 4;
		x6 = (x8-W3mW5*x6)&gt;&gt;3;
		x7 = (x8-W3pW5*x7)&gt;&gt;3;
		/* second stage*/
		x8 = x0 + x1;
		x0 -= x1;
		x1 = W6*(x3+x2) + 4;
		x2 = (x1-W2pW6*x2)&gt;&gt;3;
		x3 = (x1+W2mW6*x3)&gt;&gt;3;
		x1 = x4 + x6;
		x4 -= x6;
		x6 = x5 + x7;
		x5 -= x7;
		/* third stage*/
		x7 = x8 + x3;
		x8 -= x3;
		x3 = x0 + x2;
		x0 -= x2;
		x2 = (R2*(x4+x5)+128)&gt;&gt;8;
		x4 = (R2*(x4-x5)+128)&gt;&gt;8;
		/* fourth stage*/
		p[8*0] = (x7+x1)&gt;&gt;14;
		p[8*1] = (x3+x2)&gt;&gt;14;
		p[8*2] = (x0+x4)&gt;&gt;14;
		p[8*3] = (x8+x6)&gt;&gt;14;
		p[8*4] = (x8-x6)&gt;&gt;14;
		p[8*5] = (x0-x4)&gt;&gt;14;
		p[8*6] = (x3-x2)&gt;&gt;14;
		p[8*7] = (x7-x1)&gt;&gt;14;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

