<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/readpng.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/readpng.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;bio.h&gt;
#include &lt;flate.h&gt;
#include &lt;draw.h&gt;
#include "imagefile.h"

int debug;

enum
{
	IDATSIZE = 1000000,

	/* filtering algorithms */
	FilterNone =	0,	/* new[x][y] = buf[x][y] */
	FilterSub =	1,	/* new[x][y] = buf[x][y] + new[x-1][y] */ 
	FilterUp =	2,	/* new[x][y] = buf[x][y] + new[x][y-1] */ 
	FilterAvg =	3,	/* new[x][y] = buf[x][y] + (new[x-1][y]+new[x][y-1])/2 */ 
	FilterPaeth =	4,	/* new[x][y] = buf[x][y] + paeth(new[x-1][y],new[x][y-1],new[x-1][y-1]) */
	FilterLast =	5,

	PropertyBit = 1&lt;&lt;5,
};

typedef struct ZlibR ZlibR;
typedef struct ZlibW ZlibW;

struct ZlibW
{
	uchar *data;		/* Rawimage data */
	int ndata;
	int noutchan;
	int chandesc;
	int nchan;

	uchar *scan;		/* new scanline */
	uchar *lastscan;	/* previous scan line */
	int scanlen;		/* scan line length */
	int scanpos;		/* scan position */

	int dx;			/* width of image */
	int dy;			/* height of image */
	int bpc;			/* bits per channel (per pixel) */
	int y;				/* current scan line */
	int pass;			/* adam7 pass#; 0 means no adam7 */
	uchar palette[3*256];	/* color palette */
	int palsize;		/* number of palette entries */
};

struct ZlibR
{
	Biobuf *io;		/* input buffer */
	uchar *buf;		/* malloc'ed staging buffer */
	uchar *p;			/* next byte to decompress */
	uchar *e;			/* end of buffer */
	ZlibW *w;
};

static ulong *crctab;
static uchar PNGmagic[] = { 137, 'P', 'N', 'G', '\r', '\n', 26, '\n'};

static ulong
get4(uchar *a)
{
	return (a[0]&lt;&lt;24) | (a[1]&lt;&lt;16) | (a[2]&lt;&lt;8) | a[3];
}

static
void
pnginit(void)
{
	static int inited;

	if(inited)
		return;
	inited = 1;
	crctab = mkcrctab(0xedb88320);
	if(crctab == nil)
		sysfatal("mkcrctab error");
	inflateinit();
}

static
void*
pngmalloc(ulong n, int clear)
{
	void *p;

	p = mallocz(n, clear);
	if(p == nil)
		sysfatal("malloc: %r");
	return p;
}

static int
getchunk(Biobuf *b, char *type, uchar *d, int m)
{
	uchar buf[8];
	ulong crc = 0, crc2;
	int n, nr;

	if(Bread(b, buf, 8) != 8)
		return -1;
	n = get4(buf);
	memmove(type, buf+4, 4);
	type[4] = 0;
	if(n &gt; m)
		sysfatal("getchunk needed %d, had %d", n, m);
	nr = Bread(b, d, n);
	if(nr != n)
		sysfatal("getchunk read %d, expected %d", nr, n);
	crc = blockcrc(crctab, crc, type, 4);
	crc = blockcrc(crctab, crc, d, n);
	if(Bread(b, buf, 4) != 4)
		sysfatal("getchunk tlr failed");
	crc2 = get4(buf);
	if(crc != crc2)
		sysfatal("getchunk crc failed");
	return n;
}

static int
zread(void *va)
{
	ZlibR *z = va;
	char type[5];
	int n;

	if(z-&gt;p &gt;= z-&gt;e){
	Again:
		z-&gt;p = z-&gt;buf;
		z-&gt;e = z-&gt;p;
		n = getchunk(z-&gt;io, type, z-&gt;p, IDATSIZE);
		if(n &lt; 0 || strcmp(type, "IEND") == 0)
			return -1;
		z-&gt;e = z-&gt;p + n;
		if(!strcmp(type,"PLTE")){
			if(n &lt; 3 || n &gt; 3*256 || n%3)
				sysfatal("invalid PLTE chunk len %d", n);
			memcpy(z-&gt;w-&gt;palette, z-&gt;p, n);
			z-&gt;w-&gt;palsize = 256;
			goto Again;
		}
		if(type[0] &amp; PropertyBit)
			goto Again;  /* skip auxiliary chunks fornow */
		if(strcmp(type,"IDAT")){
			sysfatal("unrecognized mandatory chunk %s", type);
			goto Again;
		}
	}
	return *z-&gt;p++;
}

static uchar 
paeth(uchar a, uchar b, uchar c)
{
	int p, pa, pb, pc;

	p = a + b - c;
	pa = abs(p - a);
	pb = abs(p - b);
	pc = abs(p - c);

	if(pa &lt;= pb &amp;&amp; pa &lt;= pc)
		return a;
	else if(pb &lt;= pc)
		return b;
	return c;
}

static void
unfilter(int alg, uchar *buf, uchar *up, int len, int bypp)
{
	int i;

	switch(alg){
	case FilterNone:
		break;

	case FilterSub:
		for(i = bypp; i &lt; len; ++i)
			buf[i] += buf[i-bypp];
		break;

	case FilterUp:
		for(i = 0; i &lt; len; ++i)
			buf[i] += up[i];
		break;

	case FilterAvg:
		for(i = 0; i &lt; bypp; ++i)
			buf[i] += (0+up[i])/2;
		for(; i &lt; len; ++i)
			buf[i] += (buf[i-bypp]+up[i])/2;
		break;

	case FilterPaeth:
		for(i = 0; i &lt; bypp; ++i)
			buf[i] += paeth(0, up[i], 0);
		for(; i &lt; len; ++i)
			buf[i] += paeth(buf[i-bypp], up[i], up[i-bypp]);
		break;

	default:
		sysfatal("unknown filtering scheme %d\n", alg);
	}
}

struct {
	int x;
	int y;
	int dx;
	int dy;
} adam7[] = {
	{0,0,1,1},	/* eve alone */
	{0,0,8,8},	/* pass 1 */
	{4,0,8,8},	/* pass 2 */
	{0,4,4,8},	/* pass 3 */
	{2,0,4,4},	/* pass 4 */
	{0,2,2,4},	/* pass 5 */
	{1,0,2,2},	/* pass 6 */
	{0,1,1,2},	/* pass 7 */
};

static void
scan(int len, ZlibW *z)
{
	int chan, i, j, nbit, off, val;
	uchar pixel[4], *p, *w;

	unfilter(z-&gt;scan[0], z-&gt;scan+1, z-&gt;lastscan+1, len-1, (z-&gt;nchan*z-&gt;bpc+7)/8);

	/*
	 * loop over raw bits extracting pixel values and converting to 8-bit
	 */
	nbit = 0;
	chan = 0;
	val = 0;
	off = z-&gt;y*z-&gt;dx + adam7[z-&gt;pass].x;
	w = z-&gt;data + z-&gt;noutchan*off;
	p = z-&gt;scan+1;	/* skip alg byte */
	len--;
	for(i=0; i&lt;len*8; i++){
		val &lt;&lt;= 1;
		if(p[i&gt;&gt;3] &amp; (1&lt;&lt;(7-(i&amp;7))))
			val++;
		if(++nbit == z-&gt;bpc){
			/* finished the value */
			pixel[chan++] = (val*255)/((1&lt;&lt;z-&gt;bpc)-1);
			val = 0;
			nbit = 0;
			if(chan == z-&gt;nchan){
				/* finished the pixel */
				if(off &lt; z-&gt;dx*z-&gt;dy){
					if(z-&gt;nchan &lt; 3 &amp;&amp; z-&gt;palsize){
						j = pixel[0];
						if(z-&gt;bpc &lt; 8)
							j &gt;&gt;= 8-z-&gt;bpc;
						if(j &gt;= z-&gt;palsize)
							sysfatal("index %d &gt;= palette size %d", j, z-&gt;palsize);
						pixel[3] = pixel[1];	/* alpha */
						pixel[0] = z-&gt;palette[3*j];
						pixel[1] = z-&gt;palette[3*j+1];
						pixel[2] = z-&gt;palette[3*j+2];
					}
					switch(z-&gt;chandesc){
					case CYA16:
					//	print("%.2x%.2x ", pixel[0], pixel[1]);
						*w++ = pixel[1];
						*w++ += (pixel[0]*pixel[1])/255;
						break;
					case CRGBA32:
					//	print("%.2x%.2x%.2x%.2x ", pixel[0], pixel[1], pixel[2], pixel[3]);
						*w++ += pixel[3];
						*w++ += (pixel[2]*pixel[3])/255;
						*w++ += (pixel[1]*pixel[3])/255;
						*w++ += (pixel[0]*pixel[3])/255;
						break;
					case CRGB24:
						*w++ = pixel[2];
						*w++ = pixel[1];
					case CY:
						*w++ = pixel[0];
						break;
					}
					w += (adam7[z-&gt;pass].dx-1)*z-&gt;noutchan;
				}
				off += adam7[z-&gt;pass].dx;
				if(off &gt;= (z-&gt;y+1)*z-&gt;dx){
					/* finished the line */
					return;
				}
				chan = 0;
			}
		}
	}
	sysfatal("scan line too short");
}

static int
scanbytes(ZlibW *z)
{
	int bits, n, adx, dx;

	if(adam7[z-&gt;pass].y &gt;= z-&gt;dy || adam7[z-&gt;pass].x &gt;= z-&gt;dx)
		return 0;
	adx = adam7[z-&gt;pass].dx;
	dx = z-&gt;dx - adam7[z-&gt;pass].x;
	if(dx &lt;= 0)
		n = 1;
	else
		n = (dx+adx-1)/adx;
	if(n != 1 + (z-&gt;dx - (adam7[z-&gt;pass].x+1)) / adam7[z-&gt;pass].dx){
		print("%d/%d != 1+(%d-1)/%d = %d\n",
			z-&gt;dx - adam7[z-&gt;pass].x - 1 + adx, adx,
			z-&gt;dx - (adam7[z-&gt;pass].x+1), adam7[z-&gt;pass].dx,
			1 + (z-&gt;dx - (adam7[z-&gt;pass].x+1)) / adam7[z-&gt;pass].dx);
	}
	bits = n*z-&gt;bpc*z-&gt;nchan;
	return 1 + (bits+7)/8;
}

static int
nextpass(ZlibW *z)
{
	int len;

	memset(z-&gt;lastscan, 0, z-&gt;scanlen);
	do{
		z-&gt;pass = (z-&gt;pass+1)%8;
		z-&gt;y = adam7[z-&gt;pass].y;
		len = scanbytes(z);
	}while(len &lt; 2);
	return len;
}

static int
zwrite(void *vz, void *vbuf, int n)
{
	int oldn, m, len;
	uchar *buf, *t;
	ZlibW *z;

	z = vz;
	buf = vbuf;
	oldn = n;

	len = scanbytes(z);
	if(len &lt; 2)
		len = nextpass(z);

	while(n &gt; 0){
		m = len - z-&gt;scanpos;
		if(m &gt; n){
			/* save final partial line */
			memmove(z-&gt;scan+z-&gt;scanpos, buf, n);
			z-&gt;scanpos += n;
			break;
		}

		/* fill line */
		memmove(z-&gt;scan+z-&gt;scanpos, buf, m);
		buf += m;
		n -= m;

		/* process line */
		scan(len, z);
		t = z-&gt;scan;
		z-&gt;scan = z-&gt;lastscan;
		z-&gt;lastscan = t;

		z-&gt;scanpos = 0;
		z-&gt;y += adam7[z-&gt;pass].dy;
		if(z-&gt;y &gt;= z-&gt;dy)
			len = nextpass(z);
	}
	return oldn;
}

static Rawimage*
readslave(Biobuf *b)
{
	char type[5];
	int bpc, colorfmt, dx, dy, err, n, nchan, nout, useadam7;
	uchar *buf, *h;
	Rawimage *image;
	ZlibR zr;
	ZlibW zw;

	buf = pngmalloc(IDATSIZE, 0);
	if(Bread(b, buf, sizeof PNGmagic) != sizeof PNGmagic ||
	    memcmp(PNGmagic, buf, sizeof PNGmagic) != 0)
		sysfatal("bad PNGmagic");

	n = getchunk(b, type, buf, IDATSIZE);
	if(n &lt; 13 || strcmp(type,"IHDR") != 0)
		sysfatal("missing IHDR chunk");
	h = buf;
	dx = get4(h);
	h += 4;
	dy = get4(h);
	h += 4;
	if(dx &lt;= 0 || dy &lt;= 0)
		sysfatal("impossible image size %dx%d", dx, dy);
	if(debug)
		fprint(2, "readpng %dx%d\n", dx, dy);

	bpc = *h++;
	colorfmt = *h++;
	nchan = 0;
	if(*h++ != 0)
		sysfatal("only deflate supported for now [%d]", h[-1]);
	if(*h++ != FilterNone)
		sysfatal("only FilterNone supported for now [%d]", h[-1]);
	useadam7 = *h++;
	USED(h);

	image = pngmalloc(sizeof(Rawimage), 1);
	image-&gt;r = Rect(0, 0, dx, dy);
	nout = 0;
	switch(colorfmt){
	case 0:	/* grey */
		image-&gt;nchans = 1;
		image-&gt;chandesc = CY;
		nout = 1;
		nchan = 1;
		break;
	case 2:	/* rgb */
		image-&gt;nchans = 1;
		image-&gt;chandesc = CRGB24;
		nout = 3;
		nchan = 3;
		break;
	case 3: /* indexed rgb with PLTE */
		image-&gt;nchans = 1;
		image-&gt;chandesc = CRGB24;
		nout = 3;
		nchan = 1;
		break;
	case 4:	/* grey+alpha */
		image-&gt;nchans = 1;
		image-&gt;chandesc = CYA16;
		nout = 2;
		nchan = 2;
		break;
	case 6:	/* rgb+alpha */
		image-&gt;nchans = 1;
		image-&gt;chandesc = CRGBA32;
		nout = 4;
		nchan = 4;
		break;
	default:
		sysfatal("unsupported color scheme %d", h[-1]);
	}
	image-&gt;chanlen = dx*dy*nout;
	image-&gt;chans[0] = pngmalloc(image-&gt;chanlen, 0);
	memset(image-&gt;chans[0], 0, image-&gt;chanlen);

	memset(&amp;zr, 0, sizeof zr);
	zr.w = &amp;zw;
	zr.io = b;
	zr.buf = buf;

	memset(&amp;zw, 0, sizeof zw);
	if(useadam7)
		zw.pass = 1;
	zw.data = image-&gt;chans[0];
	zw.ndata = image-&gt;chanlen;
	zw.chandesc = image-&gt;chandesc;
	zw.noutchan = nout;

	zw.dx = dx;
	zw.dy = dy;
	zw.scanlen = (nchan*dx*bpc+7)/8+1;
	zw.scan = pngmalloc(zw.scanlen, 1);
	zw.lastscan = pngmalloc(zw.scanlen, 1);
	zw.nchan = nchan;
	zw.bpc = bpc;

	err = inflatezlib(&amp;zw, zwrite, &amp;zr, zread);

	if(err)
		sysfatal("inflatezlib %s\n", flateerr(err));

	free(buf);
	free(zw.scan);
	free(zw.lastscan);
	return image;
}

Rawimage**
Breadpng(Biobuf *b, int colorspace)
{
	Rawimage **array, *r;

	if(colorspace != CRGB){
		werrstr("ReadPNG: unknown color space %d", colorspace);
		return nil;
	}
	pnginit();
	array = malloc(2*sizeof(*array));
	if(array==nil)
		return nil;
	r = readslave(b);
	array[0] = r;
	array[1] = nil;
	return array;
}

Rawimage**
readpng(int fd, int colorspace)
{
	Biobuf b;
	Rawimage **a;

	if(Binit(&amp;b, fd, OREAD) &lt; 0)
		return nil;
	a = Breadpng(&amp;b, colorspace);
	Bterm(&amp;b);
	return a;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

