<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/rgbycc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/rgbycc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;

float c1 = 1.402;
float c2 = 0.34414;
float c3 = 0.71414;
float c4 = 1.772;

int
closest(int Y, int Cb, int Cr)
{
	double r, g, b;
	double diff, min;
	int rgb, R, G, B, v, i;
	int y1, cb1, cr1;

	Cb -= 128;
	Cr -= 128;
	r = Y+c1*Cr;
	g = Y-c2*Cb-c3*Cr;
	b = Y+c4*Cb;

//print("YCbCr: %d %d %d, RGB: %g %g %g\n", Y, Cb, Cr, r, g, b);

	min = 1000000.;
	v = 1000;
	for(i=0; i&lt;256; i++){
		rgb =  cmap2rgb(i);
		R = (rgb &gt;&gt; 16) &amp; 0xFF;
		G = (rgb &gt;&gt; 8) &amp; 0xFF;
		B = (rgb &gt;&gt; 0) &amp; 0xFF;
		diff = (R-r)*(R-r) + (G-g)*(G-g) + (B-b)*(B-b);
		y1 = 0.5870*G + 0.114*B + 0.299*R;
		cb1 = (B-y1)/1.772;
		cr1 = (R-y1)/1.402;
		if(diff &lt; min){
//			if(Y==0 &amp;&amp; y1!=0)
//				continue;
			if(Y==256-16 &amp;&amp; y1&lt;256-16)
				continue;
//			if(Cb==0 &amp;&amp; cb1!=0)
//				continue;
			if(Cb==256-16 &amp;&amp; cb1&lt;256-16)
				continue;
//			if(Cr==0 &amp;&amp; cr1!=0)
//				continue;
			if(Cr==256-16 &amp;&amp; cr1&lt;256-16)
				continue;
//print("%d %d %d\n", R, G, B);
			min = diff;
			v = i;
		}
	}
	if(v &gt; 255)
		abort();
	return v;
}

void
main(int argc, char *argv[])
{
	int i, rgb;
	int r, g, b;
	double Y, Cr, Cb;
	int y, cb, cr;
	uchar close[16*16*16];

//print("%d\n", closest(atoi(argv[1]), atoi(argv[2]), atoi(argv[3])));
//exits("X");

	/* ycbcrmap */
	print("uint ycbcrmap[256] = {\n");
	for(i=0; i&lt;256; i++){
		if(i%8 == 0)
			print("\t");
		rgb = cmap2rgb(i);
		r = (rgb&gt;&gt;16) &amp; 0xFF;
		g = (rgb&gt;&gt;8) &amp; 0xFF;
		b = (rgb&gt;&gt;0) &amp; 0xFF;
		Y = 0.5870*g + 0.114*b + 0.299*r;
		Cr = (r-Y)/1.402 + 128.;
		Cb = (b-Y)/1.772 + 128.;
		if(Y&lt;0. || Y&gt;=256. || Cr&lt;0. || Cr&gt;=256. || Cb&lt;0. || Cb&gt;=256.)
			print("bad at %d: %d %d %d; %g %g %g\n", i, r, g, b, Y, Cb, Cr);
		r = Y;
		g = Cb;
		b = Cr;
		print("0x%.6ulX, ", (r&lt;&lt;16) | (g&lt;&lt;8) | b);
		if(i%8 == 7)
			print("\n");
	}
	print("};\n\n");

	/* closestycbcr */
	print("uchar closestycbcr[16*16*16] = {\n");
	for(y=0; y&lt;256; y+=16)
	for(cb=0; cb&lt;256; cb+=16)
	for(cr=0; cr&lt;256; cr+=16)
		close[(cr/16)+16*((cb/16)+16*(y/16))] = closest(y, cb, cr);
if(0){
	/*weird: set white for nearly white */
	for(cb=128-32; cb&lt;=128+32; cb+=16)
	for(cr=128-32; cr&lt;=128+32; cr+=16)
		close[(cr/16)+16*((cb/16)+16*(255/16))] = 0;
	/*weird: set black for nearly black */
	for(cb=128-32; cb&lt;=128+32; cb+=16)
	for(cr=128-32; cr&lt;=128+32; cr+=16)
		close[(cr/16)+16*((cb/16)+16*(0/16))] = 255;
}
	for(i=0; i&lt;16*16*16; i++){
		if(i%16 == 0)
			print("\t");
		print("%d,", close[i]);
		if(i%16 == 15)
			print("\n");
	}
	print("};\n\n");
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

