<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/totruecolor.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/totruecolor.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include "imagefile.h"

enum {
	c1 = 2871,	/* 1.402 * 2048 */
	c2 = 705,		/* 0.34414 * 2048 */
	c3 = 1463,	/* 0.71414 * 2048 */
	c4 = 3629,	/* 1.772 * 2048 */
};

Rawimage*
totruecolor(Rawimage *i, int chandesc)
{
	int j, k;
	Rawimage *im;
	char err[ERRMAX];
	uchar *rp, *gp, *bp, *cmap, *inp, *outp, cmap1[3*256];
	int r, g, b, Y, Cr, Cb;

	if(chandesc!=CY &amp;&amp; chandesc!=CRGB24)
		return _remaperror("remap: can't convert to chandesc %d", chandesc);

	err[0] = '\0';
	errstr(err, sizeof err);	/* throw it away */
	im = malloc(sizeof(Rawimage));
	if(im == nil)
		return nil;
	memset(im, 0, sizeof(Rawimage));
	if(chandesc == CY)
		im-&gt;chanlen = i-&gt;chanlen;
	else
		im-&gt;chanlen = 3*i-&gt;chanlen;
	im-&gt;chandesc = chandesc;
	im-&gt;chans[0] = malloc(im-&gt;chanlen);
	if(im-&gt;chans[0] == nil){
		free(im);
		return nil;
	}
	im-&gt;r = i-&gt;r;
	im-&gt;nchans = 1;

	cmap = i-&gt;cmap;

	outp = im-&gt;chans[0];

	switch(i-&gt;chandesc){
	default:
		return _remaperror("remap: can't recognize channel type %d", i-&gt;chandesc);
	case CY:
		if(i-&gt;nchans != 1)
			return _remaperror("remap: Y image has %d chans", i-&gt;nchans);
		if(chandesc == CY){
			memmove(im-&gt;chans[0], i-&gt;chans[0], i-&gt;chanlen);
			break;
		}
		/* convert to three color */
		inp = i-&gt;chans[0];
		for(j=0; j&lt;i-&gt;chanlen; j++){
			k = *inp++;
			*outp++ = k;
			*outp++ = k;
			*outp++ = k;
		}
		break;

	case CRGB1:
		if(cmap == nil)
			return _remaperror("remap: image has no color map");
		if(i-&gt;nchans != 1)
			return _remaperror("remap: can't handle nchans %d", i-&gt;nchans);
		for(j=1; j&lt;=8; j++)
			if(i-&gt;cmaplen == 3*(1&lt;&lt;j))
				break;
		if(j &gt; 8)
			return _remaperror("remap: can't do colormap size 3*%d", i-&gt;cmaplen/3);
		if(i-&gt;cmaplen != 3*256){
			/* to avoid a range check in loop below, make a full-size cmap */
			memmove(cmap1, cmap, i-&gt;cmaplen);
			cmap = cmap1;
		}
		inp = i-&gt;chans[0];
		if(chandesc == CY){
			for(j=0; j&lt;i-&gt;chanlen; j++){
				k = *inp++;
				r = cmap[3*k+2];
				g = cmap[3*k+1];
				b = cmap[3*k+0];
				r = (2125*r + 7154*g + 721*b)/10000;	/* Poynton page 84 */
				*outp++ = r;
			}
		}else{
			for(j=0; j&lt;i-&gt;chanlen; j++){
				k = *inp++;
				*outp++ = cmap[3*k+2];
				*outp++ = cmap[3*k+1];
				*outp++ = cmap[3*k+0];
			}
		}
		break;

	case CRGB:
		if(i-&gt;nchans != 3)
			return _remaperror("remap: can't handle nchans %d", i-&gt;nchans);
		rp = i-&gt;chans[0];
		gp = i-&gt;chans[1];
		bp = i-&gt;chans[2];
		if(chandesc == CY){
			for(j=0; j&lt;i-&gt;chanlen; j++){
				r = *bp++;
				g = *gp++;
				b = *rp++;
				r = (2125*r + 7154*g + 721*b)/10000;	/* Poynton page 84 */
				*outp++ = r;
			}
		}else
			for(j=0; j&lt;i-&gt;chanlen; j++){
				*outp++ = *bp++;
				*outp++ = *gp++;
				*outp++ = *rp++;
			}
		break;

	case CYCbCr:
		if(i-&gt;nchans != 3)
			return _remaperror("remap: can't handle nchans %d", i-&gt;nchans);
		rp = i-&gt;chans[0];
		gp = i-&gt;chans[1];
		bp = i-&gt;chans[2];
		for(j=0; j&lt;i-&gt;chanlen; j++){
			Y = *rp++ &lt;&lt; 11;
			Cb = *gp++ - 128;
			Cr = *bp++ - 128;
			r = (Y+c1*Cr) &gt;&gt; 11;
			g = (Y-c2*Cb-c3*Cr) &gt;&gt; 11;
			b = (Y+c4*Cb) &gt;&gt; 11;
			if(r &lt; 0)
				r = 0;
			if(r &gt; 255)
				r = 255;
			if(g &lt; 0)
				g = 0;
			if(g &gt; 255)
				g = 255;
			if(b &lt; 0)
				b = 0;
			if(b &gt; 255)
				b = 255;
			if(chandesc == CY){
				r = (2125*r + 7154*g + 721*b)/10000;
				*outp++ = r;
			}else{
				*outp++ = b;
				*outp++ = g;
				*outp++ = r;
			}
		}
		break;
	}
	return im;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

