<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/writepng.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/writepng.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * See PNG 1.2 spec, also RFC 2083.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;ctype.h&gt;
#include &lt;bio.h&gt;
#include &lt;flate.h&gt;
#include "imagefile.h"

enum
{
	IDATSIZE = 	20000,
	FilterNone =	0,
};

typedef struct ZlibR ZlibR;
typedef struct ZlibW ZlibW;

struct ZlibR
{
	uchar *data;
	int width;
	int dx;
	int dy;
	int x;
	int y;
	int pixwid;
};

struct ZlibW
{
	Biobuf *io;
	uchar *buf;
	uchar *b;
	uchar *e;
};

static ulong *crctab;
static uchar PNGmagic[] = { 137, 'P', 'N', 'G', '\r', '\n', 26, '\n'};

static void
put4(uchar *a, ulong v)
{
	a[0] = v&gt;&gt;24;
	a[1] = v&gt;&gt;16;
	a[2] = v&gt;&gt;8;
	a[3] = v;
}

static void
chunk(Biobuf *bo, char *type, uchar *d, int n)
{
	uchar buf[4];
	ulong crc = 0;

	if(strlen(type) != 4)
		return;
	put4(buf, n);
	Bwrite(bo, buf, 4);
	Bwrite(bo, type, 4);
	Bwrite(bo, d, n);
	crc = blockcrc(crctab, crc, type, 4);
	crc = blockcrc(crctab, crc, d, n);
	put4(buf, crc);
	Bwrite(bo, buf, 4);
}

static int
zread(void *va, void *buf, int n)
{
	int a, i, pixels, pixwid;
	uchar *b, *e, *img;
	ZlibR *z;

	z = va;
	pixwid = z-&gt;pixwid;
	b = buf;
	e = b+n;
	while(b+pixwid &lt; e){	/* one less for filter alg byte */
		if(z-&gt;y &gt;= z-&gt;dy)
			break;
		if(z-&gt;x == 0)
			*b++ = FilterNone;
		pixels = (e-b)/pixwid;
		if(pixels &gt; z-&gt;dx - z-&gt;x)
			pixels = z-&gt;dx - z-&gt;x;
		img = z-&gt;data + z-&gt;width*z-&gt;y + pixwid*z-&gt;x;
		memmove(b, img, pixwid*pixels);
		if(pixwid == 4){
			/*
			 * Convert to non-premultiplied alpha.
			 */
			for(i=0; i&lt;pixels; i++, b+=4){
				a = b[3];
				if(a == 0)
					b[0] = b[1] = b[2] = 0;
				else if(a != 255){
					if(b[0] &gt;= a)
						b[0] = a;
					b[0] = (b[0]*255)/a;
					if(b[1] &gt;= a)
						b[1] = a;
					b[1] = (b[1]*255)/a;
					if(b[2] &gt;= a)
						b[2] = a;
					b[2] = (b[2]*255)/a;
				}
			}
		}else	
			b += pixwid*pixels;

		z-&gt;x += pixels;
		if(z-&gt;x &gt;= z-&gt;dx){
			z-&gt;x = 0;
			z-&gt;y++;
		}
	}
	return b - (uchar*)buf;
}

static void
IDAT(ZlibW *z)
{
	chunk(z-&gt;io, "IDAT", z-&gt;buf, z-&gt;b - z-&gt;buf);
	z-&gt;b = z-&gt;buf;
}

static int
zwrite(void *va, void *buf, int n)
{
	int m;
	uchar *b, *e;
	ZlibW *z;

	z = va;
	b = buf;
	e = b+n;

	while(b &lt; e){
		m = z-&gt;e - z-&gt;b;
		if(m &gt; e - b)
			m = e - b;
		memmove(z-&gt;b, b, m);
		z-&gt;b += m;
		b += m;
		if(z-&gt;b &gt;= z-&gt;e)
			IDAT(z);
	}
	return n;
}

static Memimage*
memRGBA(Memimage *i)
{
	Memimage *ni;
	char buf[32];
	ulong dst;
	
	/*
	 * [A]BGR because we want R,G,B,[A] in big-endian order.  Sigh.
	 */
	chantostr(buf, i-&gt;chan);
	if(strchr(buf, 'a'))
		dst = ABGR32;
	else
		dst = BGR24;
		
	if(i-&gt;chan == dst)
		return i;

	ni = allocmemimage(i-&gt;r, dst);
	if(ni == nil)
		return ni;
	memimagedraw(ni, ni-&gt;r, i, i-&gt;r.min, nil, i-&gt;r.min, S);
	return ni;
}

char*
memwritepng(Biobuf *io, Memimage *m, ImageInfo *II)
{
	int err, n;
	uchar buf[200], *h;
	ulong vgamma;
	Tm *tm;
	Memimage *rgb;
	ZlibR zr;
	ZlibW zw;

	crctab = mkcrctab(0xedb88320);
	if(crctab == nil)
		sysfatal("mkcrctab error");
	deflateinit();

	rgb = memRGBA(m);
	if(rgb == nil)
		return "allocmemimage nil";

	Bwrite(io, PNGmagic, sizeof PNGmagic);

	/* IHDR chunk */
	h = buf;
	put4(h, Dx(m-&gt;r)); h += 4;
	put4(h, Dy(m-&gt;r)); h += 4;
	*h++ = 8;	/* 8 bits per channel */
	if(rgb-&gt;chan == BGR24)
		*h++ = 2;		/* RGB */
	else
		*h++ = 6;		/* RGBA */
	*h++ = 0;	/* compression - deflate */
	*h++ = 0;	/* filter - none */
	*h++ = 0;	/* interlace - none */
	chunk(io, "IHDR", buf, h-buf);

	/* time - using now is suspect */
	tm = gmtime(time(0));
	h = buf;
	*h++ = (tm-&gt;year + 1900)&gt;&gt;8;
	*h++ = (tm-&gt;year + 1900)&amp;0xff;
	*h++ = tm-&gt;mon + 1;
	*h++ = tm-&gt;mday;
	*h++ = tm-&gt;hour;
	*h++ = tm-&gt;min;
	*h++ = tm-&gt;sec;
	chunk(io, "tIME", buf, h-buf);

	/* gamma */
	if(II-&gt;fields_set &amp; II_GAMMA){
		vgamma = II-&gt;gamma*100000;
		put4(buf, vgamma);
		chunk(io, "gAMA", buf, 4);
	}

	/* comment */
	if(II-&gt;fields_set &amp; II_COMMENT){
		strncpy((char*)buf, "Comment", sizeof buf);
		n = strlen((char*)buf)+1; // leave null between Comment and text
		strncpy((char*)(buf+n), II-&gt;comment, sizeof buf - n);
		chunk(io, "tEXt", buf, n+strlen((char*)buf+n));
	}

	/* image data */
	zr.dx = Dx(m-&gt;r);
	zr.dy = Dy(m-&gt;r);
	zr.width = rgb-&gt;width * sizeof(ulong);
	zr.data = rgb-&gt;data-&gt;bdata;
	zr.x = 0;
	zr.y = 0;
	zr.pixwid = chantodepth(rgb-&gt;chan)/8;
	zw.io = io;
	zw.buf = malloc(IDATSIZE);
	if(zw.buf == nil)
		sysfatal("malloc: %r");
	zw.b = zw.buf;
	zw.e = zw.b + IDATSIZE;
	if((err=deflatezlib(&amp;zw, zwrite, &amp;zr, zread, 6, 0)) &lt; 0)
		sysfatal("deflatezlib %s", flateerr(err));
	if(zw.b &gt; zw.buf)
		IDAT(&amp;zw);
	free(zw.buf);
	chunk(io, "IEND", nil, 0);
	if(m != rgb)
		freememimage(rgb);
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

