<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/kbmap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/kbmap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

typedef struct KbMap KbMap;
struct KbMap {
	char *name;
	char *file;
	Rectangle r;
	int current;
};

KbMap *map;
int nmap;
Image *lightblue;
Image *justblue;

enum {
	PAD = 3,
	MARGIN = 5
};

char *dir = "/sys/lib/kbmap";

void*
erealloc(void *v, ulong n)
{
	v = realloc(v, n);
	if(v == nil)
		sysfatal("out of memory reallocating %lud", n);
	return v;
}

void*
emalloc(ulong n)
{
	void *v;

	v = malloc(n);
	if(v == nil)
		sysfatal("out of memory allocating %lud", n);
	memset(v, 0, n);
	return v;
}

char*
estrdup(char *s)
{
	int l;
	char *t;

	if (s == nil)
		return nil;
	l = strlen(s)+1;
	t = emalloc(l);
	memcpy(t, s, l);

	return t;
}

void
init(void)
{
	int i, fd, nr;
	Dir *pd;
	char buf[128];

	if((fd = open(dir, OREAD)) &lt; 0)
		return;

	nmap = nr = dirreadall(fd, &amp;pd);
	map = emalloc(nr * sizeof(KbMap));
	for(i=0; i&lt;nr; i++){
		sprint(buf, "%s/%s", dir, pd[i].name);
		map[i].file = estrdup(buf);
		map[i].name = estrdup(pd[i].name);
		map[i].current = 0;
	}
	free(pd);

	close(fd);
}

void
drawmap(int i)
{
	if(map[i].current)
		draw(screen, map[i].r, justblue, nil, ZP);
	else
		draw(screen, map[i].r, lightblue, nil, ZP);

	_string(screen, addpt(map[i].r.min, Pt(2,0)), display-&gt;black, ZP,
		font, map[i].name, nil, strlen(map[i].name), 
		map[i].r, nil, ZP, SoverD);
	border(screen, map[i].r, 1, display-&gt;black, ZP);	
}

void
geometry(void)
{
	int i, rows;
	Rectangle r;

	rows = (Dy(screen-&gt;r)-2*MARGIN+PAD)/(font-&gt;height+PAD);

	r = Rect(0,0,(Dx(screen-&gt;r)-2*MARGIN), font-&gt;height);
	for(i=0; i&lt;nmap; i++)
		map[i].r = rectaddpt(rectaddpt(r, Pt(MARGIN+(PAD+Dx(r))*(i/rows),
					MARGIN+(PAD+Dy(r))*(i%rows))), screen-&gt;r.min);

}

void
redraw(Image *screen)
{
	int i;

	draw(screen, screen-&gt;r, lightblue, nil, ZP);
	for(i=0; i&lt;nmap; i++)
		drawmap(i);
	flushimage(display, 1);
}

void
eresized(int new)
{
	if(new &amp;&amp; getwindow(display, Refmesg) &lt; 0)
		fprint(2,"can't reattach to window");
	geometry();
	redraw(screen);
}

int
writemap(char *file)
{
	int i, fd, ofd;
	char buf[8192];

	if((fd = open(file, OREAD)) &lt; 0){
		fprint(2, "cannot open %s: %r", file);
		return -1;
	}
	if((ofd = open("/dev/kbmap", OWRITE)) &lt; 0) {
		fprint(2, "cannot open /dev/kbmap: %r");
		close(fd);
		return -1;
	}
	while((i = read(fd, buf, sizeof buf)) &gt; 0)
		if(write(ofd, buf, i) != i){
			fprint(2, "writing /dev/kbmap: %r");
			break;
		}

	close(fd);
	close(ofd);
	return 0;
}

void
click(Mouse m)
{
	int i, j;
	char buf[128];

	if(m.buttons == 0 || (m.buttons &amp; ~4))
		return;

	for(i=0; i&lt;nmap; i++)
		if(ptinrect(m.xy, map[i].r))
			break;
	if(i == nmap)
		return;

	do
		m = emouse();
	while(m.buttons == 4);

	if(m.buttons != 0){
		do
			m = emouse();
		while(m.buttons);
		return;
	}

	for(j=0; j&lt;nmap; j++)
		if(ptinrect(m.xy, map[j].r))
			break;
	if(j != i)
		return;

	/* since maps are often just a delta of the distributed map... */
	snprint(buf, sizeof buf, "%s/ascii", dir);
	writemap(buf);
	writemap(map[i].file);

	/* clean the previous current map */
	for(j=0; j&lt;nmap; j++)
		map[j].current = 0;

	map[i].current = 1;

	redraw(screen);
}

void
usage(void)
{
	fprint(2, "usage: kbmap [file...]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	Event e;
	char *c;

	if(argc &gt; 1) {
		argv++; argc--;
		map = emalloc((argc)*sizeof(KbMap));
		while(argc--) {
			map[argc].file = estrdup(argv[argc]);
			c = strrchr(map[argc].file, '/');
			map[argc].name = (c == nil ? map[argc].file : c+1);
			map[argc].current = 0;
			nmap++;
		}
	} else 
		init();

	initdraw(0, 0, "kbmap");
	lightblue = allocimagemix(display, DPalebluegreen, DWhite);
	if(lightblue == nil)
		sysfatal("allocimagemix: %r");
	justblue = allocimagemix(display, DBlue, DWhite);
	if(justblue == nil)
		sysfatal("allocimagemix: %r");

	eresized(0);
	einit(Emouse|Ekeyboard);

	for(;;){
		switch(eread(Emouse|Ekeyboard, &amp;e)){
		case Ekeyboard:
			if(e.kbdc==0x7F || e.kbdc=='q')
				exits(0);
			break;
		case Emouse:
			if(e.mouse.buttons)
				click(e.mouse);
			break;
		}
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

