<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/kl/obj.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/kl/obj.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#define	EXTERN
#include	"l.h"
#include	&lt;ar.h&gt;

#ifndef	DEFAULT
#define	DEFAULT	'9'
#endif

char	*noname		= "&lt;none&gt;";
char	symname[]	= SYMDEF;
char	thechar		= 'k';
char	*thestring 	= "sparc";

char**	libdir;
int	nlibdir	= 0;
static	int	maxlibdir = 0;

/*
 *	-H0 -T0x200000 -R0		is boot
 *	-H2 -T4128 -R4096		is plan9 format
 *	-H3 -T0xE0004000 -R4		is javastation boot format
 */

void
usage(void)
{
	diag("usage: %s [-options] objects", argv0);
	errorexit();
}

void
main(int argc, char *argv[])
{
	int c;
	char *a;
	char name[LIBNAMELEN];

	Binit(&amp;bso, 1, OWRITE);
	cout = -1;
	listinit();
	outfile = 0;
	nerrors = 0;
	curtext = P;
	HEADTYPE = -1;
	INITTEXT = -1;
	INITDAT = -1;
	INITRND = -1;
	INITENTRY = 0;

	ARGBEGIN {
	default:
		c = ARGC();
		if(c &gt;= 0 &amp;&amp; c &lt; sizeof(debug))
			debug[c]++;
		break;
	case 'o':
		outfile = ARGF();
		break;
	case 'E':
		a = ARGF();
		if(a)
			INITENTRY = a;
		break;
	case 'T':
		a = ARGF();
		if(a)
			INITTEXT = atolwhex(a);
		break;
	case 'D':
		a = ARGF();
		if(a)
			INITDAT = atolwhex(a);
		break;
	case 'R':
		a = ARGF();
		if(a)
			INITRND = atolwhex(a);
		break;
	case 'H':
		a = ARGF();
		if(a)
			HEADTYPE = atolwhex(a);
		break;
	case 'L':
		addlibpath(EARGF(usage()));
		break;
	} ARGEND
	USED(argc);
	if(*argv == 0)
		usage();
	if(!debug['9'] &amp;&amp; !debug['U'] &amp;&amp; !debug['B'])
		debug[DEFAULT] = 1;
	a = getenv("ccroot");
	if(a != nil &amp;&amp; *a != '\0') {
		if(!fileexists(a)) {
			diag("nonexistent $ccroot: %s", a);
			errorexit();
		}
	}else
		a = "";
	snprint(name, sizeof(name), "%s/%s/lib", a, thestring);
	addlibpath(name);
	if(HEADTYPE == -1) {
		if(debug['U'])
			HEADTYPE = 0;
		if(debug['B'])
			HEADTYPE = 1;
		if(debug['9'])
			HEADTYPE = 2;
	}
	switch(HEADTYPE) {
	default:
		diag("unknown -H option");
		errorexit();

	case 0:	/* boot */
		HEADR = 32L;
		if(INITTEXT == -1)
			INITTEXT = 0x200000L;
		if(INITDAT == -1)
			INITDAT = 0;
		if(INITRND == -1)
			INITRND = 4096L;
		break;
	case 1:	/* garbage */
		HEADR = 20L+60L;
		if(INITTEXT == -1)
			INITTEXT = 0x80020000L;
		if(INITDAT == -1)
			INITDAT = 0;
		if(INITRND == -1)
			INITRND = 4;
		break;
	case 2:	/* plan 9 */
		HEADR = 32L;
		if(INITTEXT == -1)
			INITTEXT = 4128;
		if(INITDAT == -1)
			INITDAT = 0;
		if(INITRND == -1)
			INITRND = 4096;
		break;
	case 3:	/* javastation boot */
		HEADR = 32L;
		if(INITTEXT == -1)
			INITTEXT = 0xE0004020L;
		if(INITDAT == -1)
			INITDAT = 0;
		if(INITRND == -1)
			INITRND = 4;
		break;
	}
	if(INITDAT != 0 &amp;&amp; INITRND != 0)
		print("warning: -D0x%lux is ignored because of -R0x%lux\n",
			INITDAT, INITRND);
	if(debug['v'])
		Bprint(&amp;bso, "HEADER = -H0x%d -T0x%lux -D0x%lux -R0x%lux\n",
			HEADTYPE, INITTEXT, INITDAT, INITRND);
	Bflush(&amp;bso);
	zprg.as = AGOK;
	zprg.reg = NREG;
	zprg.from.name = D_NONE;
	zprg.from.type = D_NONE;
	zprg.from.reg = NREG;
	zprg.to = zprg.from;
	buildop();
	histgen = 0;
	textp = P;
	datap = P;
	pc = 0;
	dtype = 4;
	if(outfile == 0)
		outfile = "k.out";
	cout = create(outfile, 1, 0775);
	if(cout &lt; 0) {
		diag("cannot create %s: %r", outfile);
		errorexit();
	}
	nuxiinit();
	version = 0;
	cbp = buf.cbuf;
	cbc = sizeof(buf.cbuf);
	firstp = prg();
	lastp = firstp;

	if(INITENTRY == 0) {
		INITENTRY = "_main";
		if(debug['p'])
			INITENTRY = "_mainp";
		if(!debug['l'])
			lookup(INITENTRY, 0)-&gt;type = SXREF;
	} else if(!(*INITENTRY &gt;= '0' &amp;&amp; *INITENTRY &lt;= '9'))
		lookup(INITENTRY, 0)-&gt;type = SXREF;

	while(*argv)
		objfile(*argv++);
	if(!debug['l'])
		loadlib();
	firstp = firstp-&gt;link;
	if(firstp == P)
		goto out;
	patch();
	if(debug['p'])
		if(debug['1'])
			doprof1();
		else
			doprof2();
	dodata();
	follow();
	if(firstp == P)
		goto out;
	noops();
	span();
	asmb();
	undef();

out:
	if(debug['v']) {
		Bprint(&amp;bso, "%5.2f cpu time\n", cputime());
		Bprint(&amp;bso, "%ld memory used\n", tothunk);
		Bprint(&amp;bso, "%d sizeof adr\n", sizeof(Adr));
		Bprint(&amp;bso, "%d sizeof prog\n", sizeof(Prog));
	}
	errorexit();
}

void
addlibpath(char *arg)
{
	char **p;

	if(nlibdir &gt;= maxlibdir) {
		if(maxlibdir == 0)
			maxlibdir = 8;
		else
			maxlibdir *= 2;
		p = malloc(maxlibdir*sizeof(*p));
		if(p == nil) {
			diag("out of memory");
			errorexit();
		}
		memmove(p, libdir, nlibdir*sizeof(*p));
		free(libdir);
		libdir = p;
	}
	libdir[nlibdir++] = strdup(arg);
}

char*
findlib(char *file)
{
	int i;
	char name[LIBNAMELEN];

	for(i = 0; i &lt; nlibdir; i++) {
		snprint(name, sizeof(name), "%s/%s", libdir[i], file);
		if(fileexists(name))
			return libdir[i];
	}
	return nil;
}

void
loadlib(void)
{
	int i;
	long h;
	Sym *s;

loop:
	xrefresolv = 0;
	for(i=0; i&lt;libraryp; i++) {
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f autolib: %s (from %s)\n", cputime(), library[i], libraryobj[i]);
		objfile(library[i]);
	}
	if(xrefresolv)
	for(h=0; h&lt;nelem(hash); h++)
	for(s = hash[h]; s != S; s = s-&gt;link)
		if(s-&gt;type == SXREF)
			goto loop;
}

void
errorexit(void)
{

	Bflush(&amp;bso);
	if(nerrors) {
		if(cout &gt;= 0)
			remove(outfile);
		exits("error");
	}
	exits(0);
}

void
objfile(char *file)
{
	long off, esym, cnt, l;
	int f, work;
	Sym *s;
	char magbuf[SARMAG];
	char name[LIBNAMELEN], pname[LIBNAMELEN];
	struct ar_hdr arhdr;
	char *e, *start, *stop;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f ldobj: %s\n", cputime(), file);
	Bflush(&amp;bso);
	if(file[0] == '-' &amp;&amp; file[1] == 'l') {
		snprint(pname, sizeof(pname), "lib%s.a", file+2);
		e = findlib(pname);
		if(e == nil) {
			diag("cannot find library: %s", file);
			errorexit();
		}
		snprint(name, sizeof(name), "%s/%s", e, pname);
		file = name;
	}
	f = open(file, 0);
	if(f &lt; 0) {
		diag("cannot open %s: %r", file);
		errorexit();
	}
	l = read(f, magbuf, SARMAG);
	if(l != SARMAG || strncmp(magbuf, ARMAG, SARMAG)){
		/* load it as a regular file */
		l = seek(f, 0L, 2);
		seek(f, 0L, 0);
		ldobj(f, l, file);
		close(f);
		return;
	}

	l = read(f, &amp;arhdr, SAR_HDR);
	if(l != SAR_HDR) {
		diag("%s: short read on archive file symbol header", file);
		goto out;
	}
	if(strncmp(arhdr.name, symname, strlen(symname))) {
		diag("%s: first entry not symbol header", file);
		goto out;
	}

	esym = SARMAG + SAR_HDR + atolwhex(arhdr.size);
	off = SARMAG + SAR_HDR;

	/*
	 * just bang the whole symbol file into memory
	 */
	seek(f, off, 0);
	cnt = esym - off;
	start = malloc(cnt + 10);
	cnt = read(f, start, cnt);
	if(cnt &lt;= 0){
		close(f);
		return;
	}
	stop = &amp;start[cnt];
	memset(stop, 0, 10);

	work = 1;
	while(work){
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f library pass: %s\n", cputime(), file);
		Bflush(&amp;bso);
		work = 0;
		for(e = start; e &lt; stop; e = strchr(e+5, 0) + 1) {
			s = lookup(e+5, 0);
			if(s-&gt;type != SXREF)
				continue;
			sprint(pname, "%s(%s)", file, s-&gt;name);
			if(debug['v'])
				Bprint(&amp;bso, "%5.2f library: %s\n", cputime(), pname);
			Bflush(&amp;bso);
			l = e[1] &amp; 0xff;
			l |= (e[2] &amp; 0xff) &lt;&lt; 8;
			l |= (e[3] &amp; 0xff) &lt;&lt; 16;
			l |= (e[4] &amp; 0xff) &lt;&lt; 24;
			seek(f, l, 0);
			/* need readn to read the dumps (at least) */
			l = readn(f, &amp;arhdr, SAR_HDR);
			if(l != SAR_HDR)
				goto bad;
			if(strncmp(arhdr.fmag, ARFMAG, sizeof(arhdr.fmag)))
				goto bad;
			l = atolwhex(arhdr.size);
			ldobj(f, l, pname);
			if(s-&gt;type == SXREF) {
				diag("%s: failed to load: %s", file, s-&gt;name);
				errorexit();
			}
			work = 1;
			xrefresolv = 1;
		}
	}
	return;

bad:
	diag("%s: bad or out of date archive", file);
out:
	close(f);
}

int
zaddr(uchar *p, Adr *a, Sym *h[])
{
	int i, c;
	int l;
	Sym *s;
	Auto *u;

	c = p[2];
	if(c &lt; 0 || c &gt; NSYM){
		print("sym out of range: %d\n", c);
		p[0] = AEND+1;
		return 0;
	}
	a-&gt;type = p[0];
	a-&gt;reg = p[1];
	a-&gt;sym = h[c];
	a-&gt;name = p[3];
	c = 4;

	if(a-&gt;reg &lt; 0 || a-&gt;reg &gt; NREG) {
		print("register out of range %d\n", a-&gt;reg);
		p[0] = AEND+1;
		return 0;	/*  force real diagnostic */
	}

	switch(a-&gt;type) {
	default:
		print("unknown type %d\n", a-&gt;type);
		p[0] = AEND+1;
		return 0;	/* force real diagnostic */

	case D_NONE:
	case D_REG:
	case D_FREG:
	case D_CREG:
	case D_PREG:
		break;

	case D_BRANCH:
	case D_OREG:
	case D_ASI:
	case D_CONST:
		a-&gt;offset = p[4] | (p[5]&lt;&lt;8) |
			(p[6]&lt;&lt;16) | (p[7]&lt;&lt;24);
		c += 4;
		break;

	case D_SCONST:
		memmove(a-&gt;sval, p+4, NSNAME);
		c += NSNAME;
		break;

	case D_FCONST:
		a-&gt;ieee.l = p[4] | (p[5]&lt;&lt;8) |
			(p[6]&lt;&lt;16) | (p[7]&lt;&lt;24);
		a-&gt;ieee.h = p[8] | (p[9]&lt;&lt;8) |
			(p[10]&lt;&lt;16) | (p[11]&lt;&lt;24);
		c += 8;
		break;
	}
	s = a-&gt;sym;
	if(s == S)
		goto out;
	i = a-&gt;name;
	if(i != D_AUTO &amp;&amp; i != D_PARAM)
		goto out;

	l = a-&gt;offset;
	for(u=curauto; u; u=u-&gt;link)
		if(u-&gt;asym == s)
		if(u-&gt;type == i) {
			if(u-&gt;aoffset &gt; l)
				u-&gt;aoffset = l;
			goto out;
		}

	u = malloc(sizeof(Auto));

	u-&gt;link = curauto;
	curauto = u;
	u-&gt;asym = s;
	u-&gt;aoffset = l;
	u-&gt;type = i;
out:
	return c;
}

void
addlib(char *obj)
{
	char fn1[LIBNAMELEN], fn2[LIBNAMELEN], comp[LIBNAMELEN], *p, *name;
	int i, search;

	if(histfrogp &lt;= 0)
		return;

	name = fn1;
	search = 0;
	if(histfrog[0]-&gt;name[1] == '/') {
		sprint(name, "");
		i = 1;
	} else if(histfrog[0]-&gt;name[1] == '.') {
		sprint(name, ".");
		i = 0;
	} else {
		sprint(name, "");
		i = 0;
		search = 1;
	}

	for(; i&lt;histfrogp; i++) {
		snprint(comp, sizeof comp, histfrog[i]-&gt;name+1);
		for(;;) {
			p = strstr(comp, "$O");
			if(p == 0)
				break;
			memmove(p+1, p+2, strlen(p+2)+1);
			p[0] = thechar;
		}
		for(;;) {
			p = strstr(comp, "$M");
			if(p == 0)
				break;
			if(strlen(comp)+strlen(thestring)-2+1 &gt;= sizeof comp) {
				diag("library component too long");
				return;
			}
			memmove(p+strlen(thestring), p+2, strlen(p+2)+1);
			memmove(p, thestring, strlen(thestring));
		}
		if(strlen(fn1) + strlen(comp) + 3 &gt;= sizeof(fn1)) {
			diag("library component too long");
			return;
		}
		if(i &gt; 0 || !search)
			strcat(fn1, "/");
		strcat(fn1, comp);
	}

	cleanname(name);

	if(search){
		p = findlib(name);
		if(p != nil){
			snprint(fn2, sizeof(fn2), "%s/%s", p, name);
			name = fn2;
		}
	}

	for(i=0; i&lt;libraryp; i++)
		if(strcmp(name, library[i]) == 0)
			return;
	if(libraryp == nelem(library)){
		diag("too many autolibs; skipping %s", name);
		return;
	}

	p = malloc(strlen(name) + 1);
	strcpy(p, name);
	library[libraryp] = p;
	p = malloc(strlen(obj) + 1);
	strcpy(p, obj);
	libraryobj[libraryp] = p;
	libraryp++;
}

void
addhist(long line, int type)
{
	Auto *u;
	Sym *s;
	int i, j, k;

	u = malloc(sizeof(Auto));
	s = malloc(sizeof(Sym));
	s-&gt;name = malloc(2*(histfrogp+1) + 1);

	u-&gt;asym = s;
	u-&gt;type = type;
	u-&gt;aoffset = line;
	u-&gt;link = curhist;
	curhist = u;

	j = 1;
	for(i=0; i&lt;histfrogp; i++) {
		k = histfrog[i]-&gt;value;
		s-&gt;name[j+0] = k&gt;&gt;8;
		s-&gt;name[j+1] = k;
		j += 2;
	}
}

void
histtoauto(void)
{
	Auto *l;

	while(l = curhist) {
		curhist = l-&gt;link;
		l-&gt;link = curauto;
		curauto = l;
	}
}

void
collapsefrog(Sym *s)
{
	int i;

	/*
	 * bad encoding of path components only allows
	 * MAXHIST components. if there is an overflow,
	 * first try to collapse xxx/..
	 */
	for(i=1; i&lt;histfrogp; i++)
		if(strcmp(histfrog[i]-&gt;name+1, "..") == 0) {
			memmove(histfrog+i-1, histfrog+i+1,
				(histfrogp-i-1)*sizeof(histfrog[0]));
			histfrogp--;
			goto out;
		}

	/*
	 * next try to collapse .
	 */
	for(i=0; i&lt;histfrogp; i++)
		if(strcmp(histfrog[i]-&gt;name+1, ".") == 0) {
			memmove(histfrog+i, histfrog+i+1,
				(histfrogp-i-1)*sizeof(histfrog[0]));
			goto out;
		}

	/*
	 * last chance, just truncate from front
	 */
	memmove(histfrog+0, histfrog+1,
		(histfrogp-1)*sizeof(histfrog[0]));

out:
	histfrog[histfrogp-1] = s;
}

void
nopout(Prog *p)
{
	p-&gt;as = ANOP;
	p-&gt;from.type = D_NONE;
	p-&gt;to.type = D_NONE;
}

uchar*
readsome(int f, uchar *buf, uchar *good, uchar *stop, int max)
{
	int n;

	n = stop - good;
	memmove(buf, good, stop - good);
	stop = buf + n;
	n = MAXIO - n;
	if(n &gt; max)
		n = max;
	n = read(f, stop, n);
	if(n &lt;= 0)
		return 0;
	return stop + n;
}

void
ldobj(int f, long c, char *pn)
{
	Prog *p, *t;
	Sym *h[NSYM], *s, *di;
	int v, o, r, skip;
	long ipc;
	uchar *bloc, *bsize, *stop;

	bsize = buf.xbuf;
	bloc = buf.xbuf;
	di = S;

newloop:
	memset(h, 0, sizeof(h));
	histfrogp = 0;
	version++;
	ipc = pc;
	skip = 0;

loop:
	if(c &lt;= 0)
		goto eof;
	r = bsize - bloc;
	if(r &lt; 100 &amp;&amp; r &lt; c) {		/* enough for largest prog */
		bsize = readsome(f, buf.xbuf, bloc, bsize, c);
		if(bsize == 0)
			goto eof;
		bloc = buf.xbuf;
		goto loop;
	}
	o = bloc[0];		/* as */
	if(o &lt;= 0 || o &gt;= ALAST) {
		diag("%s: opcode out of range %d", pn, o);
		print("	probably not a .k file\n");
		errorexit();
	}
	if(o == ANAME || o == ASIGNAME) {
		if(o == ASIGNAME) {
			bloc += 4;
			c -= 4;
		}
		stop = memchr(&amp;bloc[3], 0, bsize-&amp;bloc[3]);
		if(stop == 0){
			bsize = readsome(f, buf.xbuf, bloc, bsize, c);
			if(bsize == 0)
				goto eof;
			bloc = buf.xbuf;
			stop = memchr(&amp;bloc[3], 0, bsize-&amp;bloc[3]);
			if(stop == 0){
				fprint(2, "%s: name too long\n", pn);
				errorexit();
			}
		}
		v = bloc[1];	/* type */
		o = bloc[2];	/* sym */
		bloc += 3;
		c -= 3;

		r = 0;
		if(v == D_STATIC)
			r = version;
		s = lookup((char*)bloc, r);
		c -= &amp;stop[1] - bloc;
		bloc = stop + 1;

		if(debug['W'])
			print("	ANAME	%s\n", s-&gt;name);
		h[o] = s;
		if((v == D_EXTERN || v == D_STATIC) &amp;&amp; s-&gt;type == 0)
			s-&gt;type = SXREF;
		if(v == D_FILE) {
			if(s-&gt;type != SFILE) {
				histgen++;
				s-&gt;type = SFILE;
				s-&gt;value = histgen;
			}
			if(histfrogp &lt; MAXHIST) {
				histfrog[histfrogp] = s;
				histfrogp++;
			} else
				collapsefrog(s);
		}
		goto loop;
	}

	if(nhunk &lt; sizeof(Prog))
		gethunk();
	p = (Prog*)hunk;
	nhunk -= sizeof(Prog);
	hunk += sizeof(Prog);

	p-&gt;as = o;
	p-&gt;reg = bloc[1] &amp; 0x7f;
	if(bloc[1] &amp; 0x80)
		p-&gt;mark = NOSCHED;
	p-&gt;line = bloc[2] | (bloc[3]&lt;&lt;8) | (bloc[4]&lt;&lt;16) | (bloc[5]&lt;&lt;24);
	r = zaddr(bloc+6, &amp;p-&gt;from, h) + 6;
	r += zaddr(bloc+r, &amp;p-&gt;to, h);
	bloc += r;
	c -= r;

	if(p-&gt;reg &lt; 0 || p-&gt;reg &gt; NREG)
		diag("register out of range %d", p-&gt;reg);

	p-&gt;link = P;
	p-&gt;cond = P;

	if(debug['W'])
		print("%P\n", p);

	switch(o) {
	case AHISTORY:
		if(p-&gt;to.offset == -1) {
			addlib(pn);
			histfrogp = 0;
			goto loop;
		}
		addhist(p-&gt;line, D_FILE);		/* 'z' */
		if(p-&gt;to.offset)
			addhist(p-&gt;to.offset, D_FILE1);	/* 'Z' */
		histfrogp = 0;
		goto loop;

	case AEND:
		histtoauto();
		if(curtext != P)
			curtext-&gt;to.autom = curauto;
		curauto = 0;
		curtext = P;
		if(c)
			goto newloop;
		return;

	case AGLOBL:
		s = p-&gt;from.sym;
		if(s == S) {
			diag("GLOBL must have a name\n%P", p);
			errorexit();
		}
		if(s-&gt;type == 0 || s-&gt;type == SXREF) {
			s-&gt;type = SBSS;
			s-&gt;value = 0;
		}
		if(s-&gt;type != SBSS) {
			diag("redefinition: %s\n%P", s-&gt;name, p);
			s-&gt;type = SBSS;
			s-&gt;value = 0;
		}
		if(p-&gt;to.offset &gt; s-&gt;value)
			s-&gt;value = p-&gt;to.offset;
		break;

	case ADYNT:
		if(p-&gt;to.sym == S) {
			diag("DYNT without a sym\n%P", p);
			break;
		}
		di = p-&gt;to.sym;
		p-&gt;reg = 4;
		if(di-&gt;type == SXREF) {
			if(debug['z'])
				Bprint(&amp;bso, "%P set to %d\n", p, dtype);
			di-&gt;type = SCONST;
			di-&gt;value = dtype;
			dtype += 4;
		}
		if(p-&gt;from.sym == S)
			break;

		p-&gt;from.offset = di-&gt;value;
		p-&gt;from.sym-&gt;type = SDATA;
		if(curtext == P) {
			diag("DYNT not in text: %P", p);
			break;
		}
		p-&gt;to.sym = curtext-&gt;from.sym;
		p-&gt;to.type = D_CONST;
		p-&gt;link = datap;
		datap = p;
		break;

	case AINIT:
		if(p-&gt;from.sym == S) {
			diag("INIT without a sym\n%P", p);
			break;
		}
		if(di == S) {
			diag("INIT without previous DYNT\n%P", p);
			break;
		}
		p-&gt;from.offset = di-&gt;value;
		p-&gt;from.sym-&gt;type = SDATA;
		p-&gt;link = datap;
		datap = p;
		break;

	case ADATA:
		p-&gt;link = datap;
		datap = p;
		break;

	case AGOK:
		diag("unknown opcode\n%P", p);
		p-&gt;pc = pc;
		pc++;
		break;

	case ATEXT:
		if(curtext != P) {
			histtoauto();
			curtext-&gt;to.autom = curauto;
			curauto = 0;
		}
		curtext = p;
		autosize = (p-&gt;to.offset+3L) &amp; ~3L;
		p-&gt;to.offset = autosize;
		autosize += 4;
		s = p-&gt;from.sym;
		if(s == S) {
			diag("TEXT must have a name\n%P", p);
			errorexit();
		}
		if(s-&gt;type != 0 &amp;&amp; s-&gt;type != SXREF) {
			if(p-&gt;reg &amp; DUPOK) {
				skip = 1;
				goto casedef;
			}
			diag("redefinition: %s\n%P", s-&gt;name, p);
		}
		s-&gt;type = STEXT;
		s-&gt;value = pc;
		if(textp != P) {
			for(t = textp; t-&gt;cond != P; t = t-&gt;cond)
				;
			t-&gt;cond = p;
		} else
			textp = p;
		lastp-&gt;link = p;
		lastp = p;
		p-&gt;pc = pc;
		pc++;
		break;

	case AFMOVF:
		if(skip)
			goto casedef;

		if(p-&gt;from.type == D_FCONST) {
			/* size sb 9 max */
			sprint(literal, "$%lux", ieeedtof(&amp;p-&gt;from.ieee));
			s = lookup(literal, 0);
			if(s-&gt;type == 0) {
				s-&gt;type = SBSS;
				s-&gt;value = 4;
				t = prg();
				t-&gt;as = ADATA;
				t-&gt;line = p-&gt;line;
				t-&gt;from.type = D_OREG;
				t-&gt;from.sym = s;
				t-&gt;from.name = D_EXTERN;
				t-&gt;reg = 4;
				t-&gt;to = p-&gt;from;
				t-&gt;link = datap;
				datap = t;
			}
			p-&gt;from.type = D_OREG;
			p-&gt;from.sym = s;
			p-&gt;from.name = D_EXTERN;
			p-&gt;from.offset = 0;
		}
		goto casedef;

	case AFMOVD:
		if(skip)
			goto casedef;
		if(p-&gt;from.type == D_FCONST) {
			/* size sb 18 max */
			sprint(literal, "$%lux.%lux",
				p-&gt;from.ieee.l, p-&gt;from.ieee.h);
			s = lookup(literal, 0);
			if(s-&gt;type == 0) {
				s-&gt;type = SBSS;
				s-&gt;value = 8;
				t = prg();
				t-&gt;as = ADATA;
				t-&gt;line = p-&gt;line;
				t-&gt;from.type = D_OREG;
				t-&gt;from.sym = s;
				t-&gt;from.name = D_EXTERN;
				t-&gt;reg = 8;
				t-&gt;to = p-&gt;from;
				t-&gt;link = datap;
				datap = t;
			}
			p-&gt;from.type = D_OREG;
			p-&gt;from.sym = s;
			p-&gt;from.name = D_EXTERN;
			p-&gt;from.offset = 0;
		}
		goto casedef;

	default:
	casedef:
		if(skip)
			nopout(p);

		if(p-&gt;to.type == D_BRANCH)
			p-&gt;to.offset += ipc;
		lastp-&gt;link = p;
		lastp = p;
		p-&gt;pc = pc;
		pc++;
		break;
	}
	goto loop;

eof:
	diag("truncated object file: %s", pn);
}

Sym*
lookup(char *symb, int v)
{
	Sym *s;
	char *p;
	long h;
	int c, l;

	h = v;
	for(p=symb; c = *p; p++)
		h = h+h+h + c;
	l = (p - symb) + 1;
	h &amp;= 0xffffff;
	h %= NHASH;
	for(s = hash[h]; s != S; s = s-&gt;link)
		if(s-&gt;version == v)
		if(memcmp(s-&gt;name, symb, l) == 0)
			return s;

	while(nhunk &lt; sizeof(Sym))
		gethunk();
	s = (Sym*)hunk;
	nhunk -= sizeof(Sym);
	hunk += sizeof(Sym);

	s-&gt;name = malloc(l + 1);
	memmove(s-&gt;name, symb, l);

	s-&gt;link = hash[h];
	s-&gt;type = 0;
	s-&gt;version = v;
	s-&gt;value = 0;
	hash[h] = s;
	return s;
}

Prog*
prg(void)
{
	Prog *p;
	int n;

	n = (sizeof(Prog) + 3) &amp; ~3;
	while(nhunk &lt; n)
		gethunk();

	p = (Prog*)hunk;
	nhunk -= n;
	hunk += n;

	*p = zprg;
	return p;
}

void
gethunk(void)
{
	char *h;
	long nh;

	nh = NHUNK;
	if(tothunk &gt;= 5L*NHUNK) {
		nh = 5L*NHUNK;
		if(tothunk &gt;= 25L*NHUNK)
			nh = 25L*NHUNK;
	}
	h = mysbrk(nh);
	if(h == (char *)-1) {
		diag("out of memory");
		errorexit();
	}

	hunk = h;
	nhunk = nh;
	tothunk += nh;
}

void
doprof1(void)
{
	Sym *s;
	long n;
	Prog *p, *q;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f profile 1\n", cputime());
	Bflush(&amp;bso);
	s = lookup("__mcount", 0);
	n = 1;
	for(p = firstp-&gt;link; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT) {
			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;link = datap;
			datap = q;
			q-&gt;as = ADATA;
			q-&gt;from.type = D_OREG;
			q-&gt;from.name = D_EXTERN;
			q-&gt;from.offset = n*4;
			q-&gt;from.sym = s;
			q-&gt;reg = 4;
			q-&gt;to = p-&gt;from;
			q-&gt;to.type = D_CONST;

			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;pc = p-&gt;pc;
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;
			p-&gt;as = AMOVW;
			p-&gt;from.type = D_OREG;
			p-&gt;from.name = D_EXTERN;
			p-&gt;from.sym = s;
			p-&gt;from.offset = n*4 + 4;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGTMP;

			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;pc = p-&gt;pc;
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;
			p-&gt;as = AADD;
			p-&gt;from.type = D_CONST;
			p-&gt;from.offset = 1;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGTMP;

			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;pc = p-&gt;pc;
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;
			p-&gt;as = AMOVW;
			p-&gt;from.type = D_REG;
			p-&gt;from.reg = REGTMP;
			p-&gt;to.type = D_OREG;
			p-&gt;to.name = D_EXTERN;
			p-&gt;to.sym = s;
			p-&gt;to.offset = n*4 + 4;

			n += 2;
			continue;
		}
	}
	q = prg();
	q-&gt;line = 0;
	q-&gt;link = datap;
	datap = q;

	q-&gt;as = ADATA;
	q-&gt;from.type = D_OREG;
	q-&gt;from.name = D_EXTERN;
	q-&gt;from.sym = s;
	q-&gt;reg = 4;
	q-&gt;to.type = D_CONST;
	q-&gt;to.offset = n;

	s-&gt;type = SBSS;
	s-&gt;value = n*4;
}

void
doprof2(void)
{
	Sym *s2, *s4;
	Prog *p, *q, *q2, *ps2, *ps4;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f profile 2\n", cputime());
	Bflush(&amp;bso);

	if(debug['e']){
		s2 = lookup("_tracein", 0);
		s4 = lookup("_traceout", 0);
	}else{
		s2 = lookup("_profin", 0);
		s4 = lookup("_profout", 0);
	}
	if(s2-&gt;type != STEXT || s4-&gt;type != STEXT) {
		if(debug['e'])
			diag("_tracein/_traceout not defined %d %d", s2-&gt;type, s4-&gt;type);
		else
			diag("_profin/_profout not defined");
		return;
	}

	ps2 = P;
	ps4 = P;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT) {
			if(p-&gt;from.sym == s2) {
				p-&gt;reg = 1;
				ps2 = p;
			}
			if(p-&gt;from.sym == s4) {
				p-&gt;reg = 1;
				ps4 = p;
			}
		}
	}
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT) {
			curtext = p;

			if(p-&gt;reg &amp; NOPROF) {	/* dont profile */
				for(;;) {
					q = p-&gt;link;
					if(q == P)
						break;
					if(q-&gt;as == ATEXT)
						break;
					p = q;
				}
				continue;
			}

			/*
			 * JMPL	profin
			 */
			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;pc = p-&gt;pc;
			q-&gt;link = p-&gt;link;
			if(debug['e']){		/* embedded tracing */
				q2 = prg();
				p-&gt;link = q2;
				q2-&gt;link = q;

				q2-&gt;line = p-&gt;line;
				q2-&gt;pc = p-&gt;pc;

				q2-&gt;as = AJMP;
				q2-&gt;to.type = D_BRANCH;
				q2-&gt;to.sym = p-&gt;to.sym;
				q2-&gt;cond = q-&gt;link;
			}else
				p-&gt;link = q;
			p = q;
			p-&gt;as = AJMPL;
			p-&gt;to.type = D_BRANCH;
			p-&gt;cond = ps2;
			p-&gt;to.sym = s2;

			continue;
		}
		if(p-&gt;as == ARETURN) {
			/*
			 * RETURN (default)
			 */
			if(debug['e']){		/* embedded tracing */
				q = prg();
				q-&gt;line = p-&gt;line;
				q-&gt;pc = p-&gt;pc;
				q-&gt;link = p-&gt;link;
				p-&gt;link = q;
				p = q;
			}
			/*
			 * RETURN
			 */
			q = prg();
			q-&gt;as = ARETURN;
			q-&gt;from = p-&gt;from;
			q-&gt;to = p-&gt;to;
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;

			/*
			 * JMPL profout
			 */
			p-&gt;as = AJMPL;
			p-&gt;from = zprg.from;
			p-&gt;to = zprg.to;
			p-&gt;to.type = D_BRANCH;
			p-&gt;cond = ps4;
			p-&gt;to.sym = s4;

			p = q;

			continue;
		}
	}
}

void
nuxiinit(void)
{
	int i, c;

	for(i=0; i&lt;4; i++) {
		c = find1(0x01020304L, i+1);
		if(i &gt;= 2)
			inuxi2[i-2] = c;
		if(i &gt;= 3)
			inuxi1[i-3] = c;
		inuxi4[i] = c;

		fnuxi8[i] = c+4;
		fnuxi8[i+4] = c;
	}
	if(debug['v']) {
		Bprint(&amp;bso, "inuxi = ");
		for(i=0; i&lt;1; i++)
			Bprint(&amp;bso, "%d", inuxi1[i]);
		Bprint(&amp;bso, " ");
		for(i=0; i&lt;2; i++)
			Bprint(&amp;bso, "%d", inuxi2[i]);
		Bprint(&amp;bso, " ");
		for(i=0; i&lt;4; i++)
			Bprint(&amp;bso, "%d", inuxi4[i]);
		Bprint(&amp;bso, "\nfnuxi = ");
		for(i=0; i&lt;8; i++)
			Bprint(&amp;bso, "%d", fnuxi8[i]);
		Bprint(&amp;bso, "\n");
	}
	Bflush(&amp;bso);
}

int
find1(long l, int c)
{
	char *p;
	int i;

	p = (char*)&amp;l;
	for(i=0; i&lt;4; i++)
		if(*p++ == c)
			return i;
	return 0;
}

long
ieeedtof(Ieee *ieeep)
{
	int exp;
	long v;

	if(ieeep-&gt;h == 0)
		return 0;
	exp = (ieeep-&gt;h&gt;&gt;20) &amp; ((1L&lt;&lt;11)-1L);
	exp -= (1L&lt;&lt;10) - 2L;
	v = (ieeep-&gt;h &amp; 0xfffffL) &lt;&lt; 3;
	v |= (ieeep-&gt;l &gt;&gt; 29) &amp; 0x7L;
	if((ieeep-&gt;l &gt;&gt; 28) &amp; 1) {
		v++;
		if(v &amp; 0x800000L) {
			v = (v &amp; 0x7fffffL) &gt;&gt; 1;
			exp++;
		}
	}
	if(exp &lt;= -126 || exp &gt;= 130)
		diag("double fp to single fp overflow");
	v |= ((exp + 126) &amp; 0xffL) &lt;&lt; 23;
	v |= ieeep-&gt;h &amp; 0x80000000L;
	return v;
}

double
ieeedtod(Ieee *ieeep)
{
	Ieee e;
	double fr;
	int exp;

	if(ieeep-&gt;h &amp; (1L&lt;&lt;31)) {
		e.h = ieeep-&gt;h &amp; ~(1L&lt;&lt;31);
		e.l = ieeep-&gt;l;
		return -ieeedtod(&amp;e);
	}
	if(ieeep-&gt;l == 0 &amp;&amp; ieeep-&gt;h == 0)
		return 0;
	fr = ieeep-&gt;l &amp; ((1L&lt;&lt;16)-1L);
	fr /= 1L&lt;&lt;16;
	fr += (ieeep-&gt;l&gt;&gt;16) &amp; ((1L&lt;&lt;16)-1L);
	fr /= 1L&lt;&lt;16;
	fr += (ieeep-&gt;h &amp; (1L&lt;&lt;20)-1L) | (1L&lt;&lt;20);
	fr /= 1L&lt;&lt;21;
	exp = (ieeep-&gt;h&gt;&gt;20) &amp; ((1L&lt;&lt;11)-1L);
	exp -= (1L&lt;&lt;10) - 2L;
	return ldexp(fr, exp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

