<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/lnfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/lnfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;String.h&gt;
#include &lt;libsec.h&gt;

enum
{
	OPERM	= 0x3,		/* mask of all permission types in open mode */
	Maxsize	= 512*1024*1024,
	Maxfdata	= 8192,
	NAMELEN = 28,
};

typedef struct Fid Fid;
struct Fid
{
	short	busy;
	int	fid;
	Fid	*next;
	char	*user;
	String	*path;		/* complete path */

	int	fd;		/* set on open or create */
	Qid	qid;		/* set on open or create */
	int	attach;		/* this is an attach fd */

	ulong	diroff;		/* directory offset */
	Dir	*dir;		/* directory entries */
	int	ndir;		/* number of directory entries */
};

Fid	*fids;
int	mfd[2];
char	*user;
uchar	mdata[IOHDRSZ+Maxfdata];
uchar	rdata[Maxfdata];	/* buffer for data in reply */
uchar	statbuf[STATMAX];
Fcall	thdr;
Fcall	rhdr;
int	messagesize = sizeof mdata;
int	readonly;
char	*srvname;
int	debug;

Fid *	newfid(int);
void	io(void);
void	*erealloc(void*, ulong);
void	*emalloc(ulong);
char	*estrdup(char*);
void	usage(void);
void	fidqid(Fid*, Qid*);
char*	short2long(char*);
char*	long2short(char*, int);
void	readnames(void);
void	post(char*, int);

char	*rflush(Fid*), *rversion(Fid*), *rauth(Fid*),
	*rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tversion]	rversion,
	[Tflush]	rflush,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"lnfs: authentication not required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Eisdir[] =	"file is a directory";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Eversion[] =	"unknown 9P version";

void
usage(void)
{
	fprint(2, "usage: %s [-r] [-s srvname] mountpoint\n", argv0);
	exits("usage");
}

void
notifyf(void *a, char *s)
{
	USED(a);
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

void
main(int argc, char *argv[])
{
	char *defmnt;
	int p[2];
	Dir *d;

	ARGBEGIN{
	case 'r':
		readonly = 1;
		break;
	case 'd':
		debug = 1;
		break;
	case 's':
		srvname = ARGF();
		if(srvname == nil)
			usage();
		break;
	default:
		usage();
	}ARGEND

	if(argc &lt; 1)
		usage();
	defmnt = argv[0];
	d = dirstat(defmnt);
	if(d == nil || !(d-&gt;qid.type &amp; QTDIR))
		sysfatal("mountpoint must be an accessible directory");
	free(d);

	if(pipe(p) &lt; 0)
		sysfatal("pipe failed");
	mfd[0] = p[0];
	mfd[1] = p[0];

	user = getuser();
	notify(notifyf);

	if(srvname != nil)
		post(srvname, p[1]);

	if(debug)
		fmtinstall('F', fcallfmt);
	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFNOTEG)){
	case -1:
		sysfatal("fork: %r");
	case 0:
		close(p[1]);
		chdir(defmnt);
		io();
		break;
	default:
		close(p[0]);	/* don't deadlock if child fails */
		if(mount(p[1], -1, defmnt, MREPL|MCREATE, "") &lt; 0)
			sysfatal("mount failed: %r");
	}
	exits(0);
}

void
post(char *srvname, int pfd)
{
	char name[128];
	int fd;

	snprint(name, sizeof name, "#s/%s", srvname);
	fd = create(name, OWRITE, 0666);
	if(fd &lt; 0)
		sysfatal("create of %s failed: %r", srvname);
	sprint(name, "%d", pfd);
	if(write(fd, name, strlen(name)) &lt; 0)
		sysfatal("writing %s: %r", srvname);
}
char*
rversion(Fid*)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);
	if(thdr.msize &gt; sizeof mdata)
		rhdr.msize = sizeof mdata;
	else
		rhdr.msize = thdr.msize;
	messagesize = rhdr.msize;
	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return Eversion;
	rhdr.version = "9P2000";
	return nil;
}

char*
rauth(Fid*)
{
	return Enoauth;
}

char*
rflush(Fid *f)
{
	USED(f);
	return nil;
}

char*
rattach(Fid *f)
{
	/* no authentication! */
	f-&gt;busy = 1;
	if(thdr.uname[0])
		f-&gt;user = estrdup(thdr.uname);
	else
		f-&gt;user = "none";
	if(strcmp(user, "none") == 0)
		user = f-&gt;user;
	if(f-&gt;path)
		s_free(f-&gt;path);
	f-&gt;path = s_copy(".");
	fidqid(f, &amp;rhdr.qid);
	f-&gt;attach = 1;
	return nil;
}

char*
clone(Fid *f, Fid **nf)
{
	if(f-&gt;fd &gt;= 0)
		return Eisopen;
	*nf = newfid(thdr.newfid);
	(*nf)-&gt;busy = 1;
	if((*nf)-&gt;path)
		s_free((*nf)-&gt;path);
	(*nf)-&gt;path = s_clone(f-&gt;path);
	(*nf)-&gt;fd = -1;
	(*nf)-&gt;user = f-&gt;user;
	(*nf)-&gt;attach = 0;
	return nil;
}

char*
rwalk(Fid *f)
{
	char *name;
	Fid *nf;
	char *err;
	int i;
	String *npath;
	Dir *d;
	char *cp;
	Qid qid;

	err = nil;
	nf = nil;
	rhdr.nwqid = 0;
	if(rhdr.newfid != rhdr.fid){
		err = clone(f, &amp;nf);
		if(err)
			return err;
		f = nf;	/* walk the new fid */
	}
	readnames();
	npath = s_clone(f-&gt;path);
	if(thdr.nwname &gt; 0){
		for(i=0; i&lt;thdr.nwname &amp;&amp; i&lt;MAXWELEM; i++){
			name = long2short(thdr.wname[i], 0);
			if(strcmp(name, ".") == 0){
				;
			} else if(strcmp(name, "..") == 0){
				cp = strrchr(s_to_c(npath), '/');
				if(cp != nil){
					*cp = 0;
					npath-&gt;ptr = cp;
				}
			} else {
				s_append(npath, "/");
				s_append(npath, name);
			}
			d = dirstat(s_to_c(npath));
			if(d == nil)
				break;
			rhdr.nwqid++;
			qid = d-&gt;qid;
			rhdr.wqid[i] = qid;
			free(d);
		}
		if(i==0 &amp;&amp; err == nil)
			err = Enotexist;
	}

	/* if there was an error and we cloned, get rid of the new fid */
	if(nf != nil &amp;&amp; (err!=nil || rhdr.nwqid&lt;thdr.nwname)){
		f-&gt;busy = 0;
		s_free(npath);
	}

	/* update the fid after a successful walk */
	if(rhdr.nwqid == thdr.nwname){
		s_free(f-&gt;path);
		f-&gt;path = npath;
	}
	return err;
}

static char*
passerror(void)
{
	static char err[256];

	rerrstr(err, sizeof err);
	return err;
}

char*
ropen(Fid *f)
{
	if(readonly &amp;&amp; (thdr.mode &amp; 3))
		return Eperm;
	if(f-&gt;fd &gt;= 0)
		return Eisopen;
	f-&gt;fd = open(s_to_c(f-&gt;path), thdr.mode);
	if(f-&gt;fd &lt; 0)
		return passerror();
	fidqid(f, &amp;rhdr.qid);
	f-&gt;qid = rhdr.qid;
	rhdr.iounit = messagesize-IOHDRSZ;
	return nil;
}

char*
rcreate(Fid *f)
{
	char *name;

	if(readonly)
		return Eperm;
	readnames();
	name = long2short(thdr.name, 1);
	if(f-&gt;fd &gt;= 0)
		return Eisopen;
	s_append(f-&gt;path, "/");
	s_append(f-&gt;path, name);
	f-&gt;fd = create(s_to_c(f-&gt;path), thdr.mode, thdr.perm);
	if(f-&gt;fd &lt; 0)
		return passerror();
	fidqid(f, &amp;rhdr.qid);
	f-&gt;qid = rhdr.qid;
	rhdr.iounit = messagesize-IOHDRSZ;
	return nil;
}

char*
rreaddir(Fid *f)
{
	int i;
	int n;

	/* reread the directory */
	if(thdr.offset == 0){
		if(f-&gt;dir)
			free(f-&gt;dir);
		f-&gt;dir = nil;
		if(f-&gt;diroff != 0)
			seek(f-&gt;fd, 0, 0);
		f-&gt;ndir = dirreadall(f-&gt;fd, &amp;f-&gt;dir);
		f-&gt;diroff = 0;
		if(f-&gt;ndir &lt; 0)
			return passerror();
		readnames();
		for(i = 0; i &lt; f-&gt;ndir; i++)
			f-&gt;dir[i].name = short2long(f-&gt;dir[i].name);
	}

	/* copy in as many directory entries as possible */
	for(n = 0; f-&gt;diroff &lt; f-&gt;ndir; n += i){
		i = convD2M(&amp;f-&gt;dir[f-&gt;diroff], rdata+n, thdr.count - n);
		if(i &lt;= BIT16SZ)
			break;
		f-&gt;diroff++;
	}
	rhdr.data = (char*)rdata;
	rhdr.count = n;
	return nil;
}

char*
rread(Fid *f)
{
	long n;

	if(f-&gt;fd &lt; 0)
		return Enotexist;
	if(thdr.count &gt; messagesize-IOHDRSZ)
		thdr.count = messagesize-IOHDRSZ;
	if(f-&gt;qid.type &amp; QTDIR)
		return rreaddir(f);
	n = pread(f-&gt;fd, rdata, thdr.count, thdr.offset);
	if(n &lt; 0)
		return passerror();
	rhdr.data = (char*)rdata;
	rhdr.count = n;
	return nil;
}

char*
rwrite(Fid *f)
{
	long n;

	if(readonly || (f-&gt;qid.type &amp; QTDIR))
		return Eperm;
	if(f-&gt;fd &lt; 0)
		return Enotexist;
	if(thdr.count &gt; messagesize-IOHDRSZ)	/* shouldn't happen, anyway */
		thdr.count = messagesize-IOHDRSZ;
	n = pwrite(f-&gt;fd, thdr.data, thdr.count, thdr.offset);
	if(n &lt; 0)
		return passerror();
	rhdr.count = n;
	return nil;
}

char*
rclunk(Fid *f)
{
	f-&gt;busy = 0;
	close(f-&gt;fd);
	f-&gt;fd = -1;
	f-&gt;path = s_reset(f-&gt;path);
	if(f-&gt;attach){
		free(f-&gt;user);
		f-&gt;user = nil;
	}
	f-&gt;attach = 0;
	if(f-&gt;dir != nil){
		free(f-&gt;dir);
		f-&gt;dir = nil;
	}
	f-&gt;diroff = f-&gt;ndir = 0;
	return nil;
}

char*
rremove(Fid *f)
{
	if(remove(s_to_c(f-&gt;path)) &lt; 0)
		return passerror();
	return nil;
}

char*
rstat(Fid *f)
{
	int n;
	Dir *d;

	d = dirstat(s_to_c(f-&gt;path));
	if(d == nil)
		return passerror();
	d-&gt;name = short2long(d-&gt;name);
	n = convD2M(d, statbuf, sizeof statbuf);
	free(d);
	if(n &lt;= BIT16SZ)
		return passerror();
	rhdr.nstat = n;
	rhdr.stat = statbuf;
	return nil;
}

char*
rwstat(Fid *f)
{
	int n;
	Dir d;

	if(readonly)
		return Eperm;
	convM2D(thdr.stat, thdr.nstat, &amp;d, (char*)rdata);
	d.name = long2short(d.name, 1);
	n = dirwstat(s_to_c(f-&gt;path), &amp;d);
	if(n &lt; 0)
		return passerror();
	return nil;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;path = s_reset(f-&gt;path);
	f-&gt;fd = -1;
	f-&gt;fid = fid;
	f-&gt;next = fids;
	fids = f;
	return f;
}

void
io(void)
{
	char *err;
	int n, pid;

	pid = getpid();

	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads.
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error.
		 */
		n = read9pmsg(mfd[0], mdata, messagesize);
		if(n &lt; 0)
			sysfatal("mount read");
		if(n == 0)
			continue;
		if(convM2S(mdata, n, &amp;thdr) == 0)
			continue;

		if(debug)
			fprint(2, "%s %d:&lt;-%F\n", argv0, pid, &amp;thdr);

		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[thdr.type])(newfid(thdr.fid));
		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		if(debug)
			fprint(2, "%s %d:-&gt;%F\n", argv0, pid, &amp;rhdr);/**/
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(n == 0)
			sysfatal("convS2M error on write");
		if(write(mfd[1], mdata, n) != n)
			sysfatal("mount write");
	}
}

void *
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(!p)
		sysfatal("out of memory");
	memset(p, 0, n);
	return p;
}

void *
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(!p)
		sysfatal("out of memory");
	return p;
}

char *
estrdup(char *q)
{
	char *p;
	int n;

	n = strlen(q)+1;
	p = malloc(n);
	if(!p)
		sysfatal("out of memory");
	memmove(p, q, n);
	return p;
}

void
fidqid(Fid *f, Qid *q)
{
	Dir *d;

	d = dirstat(s_to_c(f-&gt;path));
	if(d == nil)
		*q = (Qid){0, 0, QTFILE};
	else {
		*q = d-&gt;qid;
		free(d);
	}
}

/*
 *  table of name translations
 *
 *  the file ./.longnames contains all the known long names.
 *  the short name is the first NAMELEN-1 bytes of the base64
 *  encoding of the MD5 hash of the longname.
 */

typedef struct Name Name;
struct Name
{
	Name	*next;
	char	shortname[NAMELEN];
	char	*longname;
};

Dir *dbstat;	/* last stat of the name file */
char *namefile = "./.longnames";
char *namebuf;
Name *names;

Name*
newname(char *longname, int writeflag)
{
	Name *np;
	int n;
	uchar digest[MD5dlen];
	int fd;

	/* chain in new name */
	n = strlen(longname);
	np = emalloc(sizeof(*np)+n+1);
	np-&gt;longname = (char*)&amp;np[1];
	strcpy(np-&gt;longname, longname);
	md5((uchar*)longname, n, digest, nil);
	enc32(np-&gt;shortname, sizeof(np-&gt;shortname), digest, MD5dlen);
	np-&gt;next = names;
	names = np;

	/* don't change namefile if we're read only */
	if(!writeflag)
		return np;

	/* add to namefile */
	fd = open(namefile, OWRITE);
	if(fd &gt;= 0){
		seek(fd, 0, 2);
		fprint(fd, "%s\n", longname);
		close(fd);
	}
	return np;
}

void
freenames(void)
{
	Name *np, *next;

	for(np = names; np != nil; np = next){
		next = np-&gt;next;
		free(np);
	}
	names = nil;
}

/*
 *  reread the file if the qid.path has changed.
 *
 *  read any new entries if length has changed.
 */
void
readnames(void)
{
	Dir *d;
	int fd;
	vlong offset;
	Biobuf *b;
	char *p;

	d = dirstat(namefile);
	if(d == nil){
		if(readonly)
			return;

		/* create file if it doesn't exist */
		fd = create(namefile, OREAD, DMAPPEND|0666);
		if(fd &lt; 0)
			return;
		if(dbstat != nil)
			free(dbstat);
		dbstat = nil;
		close(fd);
		return;
	}

	/* up to date? */
	offset = 0;
	if(dbstat != nil){
		if(d-&gt;qid.path == dbstat-&gt;qid.path){
			if(d-&gt;length &lt;= dbstat-&gt;length){
				free(d);
				return;
			}
			offset = dbstat-&gt;length;
		} else {
			freenames();
		}
		free(dbstat);
		dbstat = nil;
	}

	/* read file */
	b = Bopen(namefile, OREAD);
	if(b == nil){
		free(d);
		return;
	}
	Bseek(b, offset, 0);
	while((p = Brdline(b, '\n')) != nil){
		p[Blinelen(b)-1] = 0;
		newname(p, 0);
	}
	Bterm(b);
	dbstat = d;
}

/*
 *  look up a long name,  if it doesn't exist in the
 *  file, add an entry to the file if the writeflag is
 *  non-zero.  Return a pointer to the short name.
 */
char*
long2short(char *longname, int writeflag)
{
	Name *np;

	if(strlen(longname) &lt; NAMELEN-1 &amp;&amp; strpbrk(longname, " ")==nil)
		return longname;

	for(np = names; np != nil; np = np-&gt;next)
		if(strcmp(longname, np-&gt;longname) == 0)
			return np-&gt;shortname;
	if(!writeflag)
		return longname;
	np = newname(longname, !readonly);
	return np-&gt;shortname;
}

/*
 *  look up a short name, if it doesn't exist, return the
 *  longname.
 */
char*
short2long(char *shortname)
{
	Name *np;

	for(np = names; np != nil; np = np-&gt;next)
		if(strcmp(shortname, np-&gt;shortname) == 0)
			return np-&gt;longname;
	return shortname;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

