<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/map/libmap/zcoord.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/map/libmap/zcoord.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "map.h"

static double cirmod(double);

static struct place pole;	/* map pole is tilted to here */
static struct coord twist;	/* then twisted this much */
static struct place ipole;	/* inverse transfrom */
static struct coord itwist;

void
orient(double lat, double lon, double theta)
{
	lat = cirmod(lat);
	if(lat&gt;90.) {
		lat = 180. - lat;
		lon -= 180.;
		theta -= 180.;
	} else if(lat &lt; -90.) {
		lat = -180. - lat;
		lon -= 180.;
		theta -= 180;
	}
	latlon(lat,lon,&amp;pole);
	deg2rad(theta, &amp;twist);
	latlon(lat,180.-theta,&amp;ipole);
	deg2rad(180.-lon, &amp;itwist);
}

void
latlon(double lat, double lon, struct place *p)
{
	lat = cirmod(lat);
	if(lat&gt;90.) {
		lat = 180. - lat;
		lon -= 180.;
	} else if(lat &lt; -90.) {
		lat = -180. - lat;
		lon -= 180.;
	}
	deg2rad(lat,&amp;p-&gt;nlat);
	deg2rad(lon,&amp;p-&gt;wlon);
}

void
deg2rad(double theta, struct coord *coord)
{
	theta = cirmod(theta);
	coord-&gt;l = theta*RAD;
	if(theta==90) {
		coord-&gt;s = 1;
		coord-&gt;c = 0;
	} else if(theta== -90) {
		coord-&gt;s = -1;
		coord-&gt;c = 0;
	} else
		sincos(coord);
}

static double
cirmod(double theta)
{
	while(theta &gt;= 180.)
		theta -= 360;
	while(theta&lt;-180.)
		theta += 360.;
	return(theta);
}

void
sincos(struct coord *coord)
{
	coord-&gt;s = sin(coord-&gt;l);
	coord-&gt;c = cos(coord-&gt;l);
}

void
normalize(struct place *gg)
{
	norm(gg,&amp;pole,&amp;twist);
}

void
invert(struct place *g)
{
	norm(g,&amp;ipole,&amp;itwist);
}

void
norm(struct place *gg, struct place *pp, struct coord *tw)
{
	register struct place *g;	/*geographic coords */
	register struct place *p;	/* new pole in old coords*/
	struct place m;			/* standard map coords*/
	g = gg;
	p = pp;
	if(p-&gt;nlat.s == 1.) {
		if(p-&gt;wlon.l+tw-&gt;l == 0.)
			return;
		g-&gt;wlon.l -= p-&gt;wlon.l+tw-&gt;l;
	} else {
		if(p-&gt;wlon.l != 0) {
			g-&gt;wlon.l -= p-&gt;wlon.l;
			sincos(&amp;g-&gt;wlon);
		}
		m.nlat.s = p-&gt;nlat.s * g-&gt;nlat.s
			+ p-&gt;nlat.c * g-&gt;nlat.c * g-&gt;wlon.c;
		m.nlat.c = sqrt(1. - m.nlat.s * m.nlat.s);
		m.nlat.l = atan2(m.nlat.s, m.nlat.c);
		m.wlon.s = g-&gt;nlat.c * g-&gt;wlon.s;
		m.wlon.c = p-&gt;nlat.c * g-&gt;nlat.s
			- p-&gt;nlat.s * g-&gt;nlat.c * g-&gt;wlon.c;
		m.wlon.l = atan2(m.wlon.s, - m.wlon.c)
			- tw-&gt;l;
		*g = m;
	}
	sincos(&amp;g-&gt;wlon);
	if(g-&gt;wlon.l&gt;PI)
		g-&gt;wlon.l -= 2*PI;
	else if(g-&gt;wlon.l&lt;-PI)
		g-&gt;wlon.l += 2*PI;
}

double
tan(double x)
{
	return(sin(x)/cos(x));
}

void
printp(struct place *g)
{
printf("%.3f %.3f %.3f %.3f %.3f %.3f\n",
g-&gt;nlat.l,g-&gt;nlat.s,g-&gt;nlat.c,g-&gt;wlon.l,g-&gt;wlon.s,g-&gt;wlon.c);
}

void
copyplace(struct place *g1, struct place *g2)
{
	*g2 = *g1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

