<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/map/map.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/map/map.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "map.h"
#include "iplot.h"

#define NVERT 20	/* max number of vertices in a -v polygon */
#define HALFWIDTH 8192	/* output scaled to fit in -HALFWIDTH,HALFWIDTH */
#define LONGLINES (HALFWIDTH*4)	/* permissible segment lengths */
#define SHORTLINES (HALFWIDTH/8)
#define SCALERATIO 10	/* of abs to rel data (see map(5)) */
#define RESOL 2.	/* coarsest resolution for tracing grid (degrees) */
#define TWO_THRD 0.66666666666666667

int normproj(double, double, double *, double *);
int posproj(double, double, double *, double *);
int picut(struct place *, struct place *, double *);
double reduce(double);
short getshort(FILE *);
char *mapindex(char *);
proj projection;


static char *mapdir = "/lib/map";	/* default map directory */
struct file {
	char *name;
	char *color;
	char *style;
};
static struct file dfltfile = {
	"world", BLACK, SOLID	/* default map */
};
static struct file *file = &amp;dfltfile;	/* list of map files */
static int nfile = 1;			/* length of list */
static char *currcolor = BLACK;		/* current color */
static char *gridcolor = BLACK;
static char *bordcolor = BLACK;

extern struct index index[];
int halfwidth = HALFWIDTH;

static int (*cut)(struct place *, struct place *, double *);
static int (*limb)(double*, double*, double);
static void dolimb(void);
static int onlimb;
static int poles;
static double orientation[3] = { 90., 0., 0. };	/* -o option */
static oriented;	/* nonzero if -o option occurred */
static upright;		/* 1 if orientation[0]==90, -1 if -90, else 0*/
static int delta = 1;	/* -d setting */
static double limits[4] = {	/* -l parameters */
	-90., 90., -180., 180.
};
static double klimits[4] = {	/* -k parameters */
	-90., 90., -180., 180.
};
static int limcase;
static double rlimits[4];	/* limits expressed in radians */
static double lolat, hilat, lolon, hilon;
static double window[4] = {	/* option -w */
	-90., 90., -180., 180.
};
static windowed;	/* nozero if option -w */
static struct vert { double x, y; } v[NVERT+2];	/*clipping polygon*/
static struct edge { double a, b, c; } e[NVERT]; /* coeffs for linear inequality */
static int nvert;	/* number of vertices in clipping polygon */

static double rwindow[4];	/* window, expressed in radians */
static double params[2];		/* projection params */
/* bounds on output values before scaling; found by coarse survey */
static double xmin = 100.;
static double xmax = -100.;
static double ymin = 100.;
static double ymax = -100.;
static double xcent, ycent;
static double xoff, yoff;
double xrange, yrange;
static int left = -HALFWIDTH;
static int right = HALFWIDTH;
static int bottom = -HALFWIDTH;
static int top = HALFWIDTH;
static int longlines = SHORTLINES; /* drop longer segments */
static int shortlines = SHORTLINES;
static int bflag = 1;	/* 0 for option -b */
static int s1flag = 0;	/* 1 for option -s1 */
static int s2flag = 0;	/* 1 for option -s2 */
static int rflag = 0;	/* 1 for option -r */
static int kflag = 0;	/* 1 if option -k occurred */
static int xflag = 0;	/* 1 for option -x */
       int vflag = 1;	/* -1 if option -v occurred */
static double position[3];	/* option -p */
static double center[3] = {0., 0., 0.};	/* option -c */
static struct coord crot;		/* option -c */
static double grid[3] = { 10., 10., RESOL };	/* option -g */
static double dlat, dlon;	/* resolution for tracing grid in lat and lon */
static double scaling;	/* to compute final integer output */
static struct file *track;	/* options -t and -u */
static int ntrack;		/* number of tracks present */
static char *symbolfile;	/* option -y */

void	clamp(double *px, double v);
void	clipinit(void);
double	diddle(struct place *, double, double);
double	diddle(struct place *, double, double);
void	dobounds(double, double, double, double, int);
void	dogrid(double, double, double, double);
int	duple(struct place *, double);
double	fmax(double, double);
double	fmin(double, double);
void	getdata(char *);
int	gridpt(double, double, int);
int	inpoly(double, double);
int	inwindow(struct place *);
void	pathnames(void);
int	pnorm(double);
void	radbds(double *w, double *rw);
void	revlon(struct place *, double);
void	satellite(struct file *);
int	seeable(double, double);
void	windlim(void);
void	realcut(void);

int
option(char *s) 
{

	if(s[0]=='-' &amp;&amp; (s[1]&lt;'0'||s[1]&gt;'9'))
		return(s[1]!='.'&amp;&amp;s[1]!=0);
	else
		return(0);
}

void
conv(int k, struct coord *g)
{
	g-&gt;l = (0.0001/SCALERATIO)*k;
	sincos(g);
}

int
main(int argc, char *argv[])
{
	int i,k;
	char *s, *t, *style;
	double x, y;
	double lat, lon;
	double *wlim;
	double dd;
	if(sizeof(short)!=2)
		abort();	/* getshort() won't work */
	s = getenv("MAP");
	if(s)
		file[0].name = s;
	s = getenv("MAPDIR");
	if(s)
		mapdir = s;
	if(argc&lt;=1) 
		error("usage: map projection params options");
	for(k=0;index[k].name;k++) {
		s = index[k].name;
		t = argv[1];
		while(*s == *t){
			if(*s==0) goto found;
			s++;
			t++;
		}
	}
	fprintf(stderr,"projections:\n");
	for(i=0;index[i].name;i++)  {
		fprintf(stderr,"%s",index[i].name);
		for(k=0; k&lt;index[i].npar; k++)
			fprintf(stderr," p%d", k);
		fprintf(stderr,"\n");
	}
	exits("error");
found:
	argv += 2;
	argc -= 2;
	cut = index[k].cut;
	limb = index[k].limb;
	poles = index[k].poles;
	for(i=0;i&lt;index[k].npar;i++) {
		if(i&gt;=argc||option(argv[i])) {
			fprintf(stderr,"%s needs %d params\n",index[k].name,index[k].npar);
			exits("error");
		}
		params[i] = atof(argv[i]);
	}
	argv += i;
	argc -= i;
	while(argc&gt;0&amp;&amp;option(argv[0])) {
		argc--;
		argv++;
		switch(argv[-1][1]) {
		case 'm':
			if(file == &amp;dfltfile) {
				file = 0;
				nfile = 0;
			}
			while(argc &amp;&amp; !option(*argv)) {
				file = realloc(file,(nfile+1)*sizeof(*file));
				file[nfile].name = *argv;
				file[nfile].color = currcolor;
				file[nfile].style = SOLID;
				nfile++;
				argv++;
				argc--;
			}
			break;
		case 'b':
			bflag = 0;
			for(nvert=0;nvert&lt;NVERT&amp;&amp;argc&gt;=2;nvert++) {
				if(option(*argv))
					break;
				v[nvert].x = atof(*argv++);
				argc--;
				if(option(*argv))
					break;
				v[nvert].y = atof(*argv++);
				argc--;
			}
			if(nvert&gt;=NVERT)
				error("too many clipping vertices");
			break;
		case 'g':
			gridcolor = currcolor;
			for(i=0;i&lt;3&amp;&amp;argc&gt;i&amp;&amp;!option(argv[i]);i++)
				grid[i] = atof(argv[i]);
			switch(i) {
			case 0:
				grid[0] = grid[1] = 0.;
				break;
			case 1:
				grid[1] = grid[0];
			}
			argc -= i;
			argv += i;
			break;
		case 't':
			style = SOLID;
			goto casetu;
		case 'u':
			style = DOTDASH;
		casetu:
			while(argc &amp;&amp; !option(*argv)) {
				track = realloc(track,(ntrack+1)*sizeof(*track));
				track[ntrack].name = *argv;
				track[ntrack].color = currcolor;
				track[ntrack].style = style;
				ntrack++;
				argv++;
				argc--;
			}
			break;
		case 'r':
			rflag++;
			break;
		case 's':
			switch(argv[-1][2]) {
			case '1':
				s1flag++;
				break;
			case 0:		/* compatibility */
			case '2':
				s2flag++;
			}
			break;
		case 'o':
			for(i=0;i&lt;3&amp;&amp;i&lt;argc&amp;&amp;!option(argv[i]);i++)
				orientation[i] = atof(argv[i]);
			oriented++;
			argv += i;
			argc -= i;
			break;
		case 'l':
			bordcolor = currcolor;
			for(i=0;i&lt;argc&amp;&amp;i&lt;4&amp;&amp;!option(argv[i]);i++)
				limits[i] = atof(argv[i]);
			argv += i;
			argc -= i;
			break;
		case 'k':
			kflag++;
			for(i=0;i&lt;argc&amp;&amp;i&lt;4&amp;&amp;!option(argv[i]);i++)
				klimits[i] = atof(argv[i]);
			argv += i;
			argc -= i;
			break;
		case 'd':
			if(argc&gt;0&amp;&amp;!option(argv[0])) {
				delta = atoi(argv[0]);
				argv++;
				argc--;
			}
			break;
		case 'w':
			bordcolor = currcolor;
			windowed++;
			for(i=0;i&lt;argc&amp;&amp;i&lt;4&amp;&amp;!option(argv[i]);i++)
				window[i] = atof(argv[i]);
			argv += i;
			argc -= i;
			break;
		case 'c':
			for(i=0;i&lt;3&amp;&amp;argc&gt;i&amp;&amp;!option(argv[i]);i++) 
				center[i] = atof(argv[i]);
			argc -= i;
			argv += i;
			break;
		case 'p':
			for(i=0;i&lt;3&amp;&amp;argc&gt;i&amp;&amp;!option(argv[i]);i++)
				position[i] = atof(argv[i]);
			argc -= i;
			argv += i;
			if(i!=3||position[2]&lt;=0) 
				error("incomplete positioning");
			break;
		case 'y':
			if(argc&gt;0&amp;&amp;!option(argv[0])) {
				symbolfile = argv[0];
				argc--;
				argv++;
			}
			break;
		case 'v':
			if(index[k].limb == 0)
				error("-v does not apply here");
			vflag = -1;
			break;
		case 'x':
			xflag = 1;
			break;
		case 'C':
			if(argc &amp;&amp; !option(*argv)) {
				currcolor = colorcode(*argv);
				argc--;
				argv++;
			}
			break;
		}
	}
	if(argc&gt;0)
		error("error in arguments");
	pathnames();
	clamp(&amp;limits[0],-90.);
	clamp(&amp;limits[1],90.);
	clamp(&amp;klimits[0],-90.);
	clamp(&amp;klimits[1],90.);
	clamp(&amp;window[0],-90.);
	clamp(&amp;window[1],90.);
	radbds(limits,rlimits);
	limcase = limits[2]&lt;-180.?0:
		  limits[3]&gt;180.?2:
		  1;
	if(
		window[0]&gt;=window[1]||
		window[2]&gt;=window[3]||
		window[0]&gt;90.||
		window[1]&lt;-90.||
		window[2]&gt;180.||
		window[3]&lt;-180.)
		error("unreasonable window");
	windlim();
	radbds(window,rwindow);
	upright = orientation[0]==90? 1: orientation[0]==-90? -1: 0;
	if(index[k].spheroid &amp;&amp; !upright)
		error("can't tilt the spheroid");
	if(limits[2]&gt;limits[3])
		limits[3] += 360;
	if(!oriented)
		orientation[2] = (limits[2]+limits[3])/2;
	orient(orientation[0],orientation[1],orientation[2]);
	projection = (*index[k].prog)(params[0],params[1]);
	if(projection == 0)
		error("unreasonable projection parameters");
	clipinit();
	grid[0] = fabs(grid[0]);
	grid[1] = fabs(grid[1]);
	if(!kflag)
		for(i=0;i&lt;4;i++)
			klimits[i] = limits[i];
	if(klimits[2]&gt;klimits[3])
		klimits[3] += 360;
	lolat = limits[0];
	hilat = limits[1];
	lolon = limits[2];
	hilon = limits[3];
	if(lolon&gt;=hilon||lolat&gt;=hilat||lolat&lt;-90.||hilat&gt;90.)
		error("unreasonable limits");
	wlim = kflag? klimits: window;
	dlat = fmin(hilat-lolat,wlim[1]-wlim[0])/16;
	dlon = fmin(hilon-lolon,wlim[3]-wlim[2])/32;
	dd = fmax(dlat,dlon);
	while(grid[2]&gt;fmin(dlat,dlon)/2)
		grid[2] /= 2;
	realcut();
	if(nvert&lt;=0) {
		for(lat=klimits[0];lat&lt;klimits[1]+dd-FUZZ;lat+=dd) {
			if(lat&gt;klimits[1])
				lat = klimits[1];
			for(lon=klimits[2];lon&lt;klimits[3]+dd-FUZZ;lon+=dd) {
				i = (kflag?posproj:normproj)
					(lat,lon+(lon&lt;klimits[3]?FUZZ:-FUZZ),
				   &amp;x,&amp;y);
				if(i*vflag &lt;= 0)
					continue;
				if(x&lt;xmin) xmin = x;
				if(x&gt;xmax) xmax = x;
				if(y&lt;ymin) ymin = y;
				if(y&gt;ymax) ymax = y;
			}
		}
	} else {
		for(i=0; i&lt;nvert; i++) {
			x = v[i].x;
			y = v[i].y;
			if(x&lt;xmin) xmin = x;
			if(x&gt;xmax) xmax = x;
			if(y&lt;ymin) ymin = y;
			if(y&gt;ymax) ymax = y;
		}
	}
	xrange = xmax - xmin;
	yrange = ymax - ymin;
	if(xrange&lt;=0||yrange&lt;=0)
		error("map seems to be empty");
	scaling = 2;	/*plotting area from -1 to 1*/
	if(position[2]!=0) {
		if(posproj(position[0]-.5,position[1],&amp;xcent,&amp;ycent)==0||
		   posproj(position[0]+.5,position[1],&amp;x,&amp;y)==0)
			error("unreasonable position");
		scaling /= (position[2]*hypot(x-xcent,y-ycent));
		if(posproj(position[0],position[1],&amp;xcent,&amp;ycent)==0)
			error("unreasonable position");
	} else {
		scaling /= (xrange&gt;yrange?xrange:yrange);
		xcent = (xmin+xmax)/2;
		ycent = (ymin+ymax)/2;
	}
	xoff = center[0]/scaling;
	yoff = center[1]/scaling;
	crot.l = center[2]*RAD;
	sincos(&amp;crot);
	scaling *= HALFWIDTH*0.9;
	if(symbolfile) 
		getsyms(symbolfile);
	if(!s2flag) {
		openpl();
		erase();
	}
	range(left,bottom,right,top);
	comment("grid","");
	colorx(gridcolor);
	pen(DOTTED);
	if(grid[0]&gt;0.)
		for(lat=ceil(lolat/grid[0])*grid[0];
		    lat&lt;=hilat;lat+=grid[0]) 
			dogrid(lat,lat,lolon,hilon);
	if(grid[1]&gt;0.)
		for(lon=ceil(lolon/grid[1])*grid[1];
		    lon&lt;=hilon;lon+=grid[1]) 
			dogrid(lolat,hilat,lon,lon);
	comment("border","");
	colorx(bordcolor);
	pen(SOLID);
	if(bflag) {
		dolimb();
		dobounds(lolat,hilat,lolon,hilon,0);
		dobounds(window[0],window[1],window[2],window[3],1);
	}
	lolat = floor(limits[0]/10)*10;
	hilat = ceil(limits[1]/10)*10;
	lolon = floor(limits[2]/10)*10;
	hilon = ceil(limits[3]/10)*10;
	if(lolon&gt;hilon)
		hilon += 360.;
	/*do tracks first so as not to lose the standard input*/
	for(i=0;i&lt;ntrack;i++) {
		longlines = LONGLINES;
		satellite(&amp;track[i]);
		longlines = shortlines;
	}
	for(i=0;i&lt;nfile;i++) {
		comment("mapfile",file[i].name);
		colorx(file[i].color);
		pen(file[i].style);
		getdata(file[i].name);
	}
	move(right,bottom);
	if(!s1flag)
		closepl();
	return 0;
}

/* Out of perverseness (really to recover from a dubious,
   but documented, convention) the returns from projection
   functions (-1 unplottable, 0 wrong sheet, 1 good) are
   recoded into -1 wrong sheet, 0 unplottable, 1 good. */

int
fixproj(struct place *g, double *x, double *y)
{
	int i = (*projection)(g,x,y);
	return i&lt;0? 0: i==0? -1: 1;
}

int
normproj(double lat, double lon, double *x, double *y)
{
	int i;
	struct place geog;
	latlon(lat,lon,&amp;geog);
/*
	printp(&amp;geog);
*/
	normalize(&amp;geog);
	if(!inwindow(&amp;geog))
		return(-1);
	i = fixproj(&amp;geog,x,y);
	if(rflag) 
		*x = -*x;
/*
	printp(&amp;geog);
	fprintf(stderr,"%d %.3f %.3f\n",i,*x,*y);
*/
	return(i);
}

int
posproj(double lat, double lon, double *x, double *y)
{
	int i;
	struct place geog;
	latlon(lat,lon,&amp;geog);
	normalize(&amp;geog);
	i = fixproj(&amp;geog,x,y);
	if(rflag) 
		*x = -*x;
	return(i);
}

int
inwindow(struct place *geog)
{
	if(geog-&gt;nlat.l&lt;rwindow[0]-FUZZ||
	   geog-&gt;nlat.l&gt;rwindow[1]+FUZZ||
	   geog-&gt;wlon.l&lt;rwindow[2]-FUZZ||
	   geog-&gt;wlon.l&gt;rwindow[3]+FUZZ)
		return(0);
	else return(1);
}

int
inlimits(struct place *g)
{
	if(rlimits[0]-FUZZ&gt;g-&gt;nlat.l||
	   rlimits[1]+FUZZ&lt;g-&gt;nlat.l)
		return(0);
	switch(limcase) {
	case 0:
		if(rlimits[2]+TWOPI-FUZZ&gt;g-&gt;wlon.l&amp;&amp;
		   rlimits[3]+FUZZ&lt;g-&gt;wlon.l)
			return(0);
		break;
	case 1:
		if(rlimits[2]-FUZZ&gt;g-&gt;wlon.l||
		   rlimits[3]+FUZZ&lt;g-&gt;wlon.l)
			return(0);
		break;
	case 2:
		if(rlimits[2]&gt;g-&gt;wlon.l&amp;&amp;
		   rlimits[3]-TWOPI+FUZZ&lt;g-&gt;wlon.l)
			return(0);
		break;
	}
	return(1);
}


long patch[18][36];

void
getdata(char *mapfile)
{
	char *indexfile;
	int kx,ky,c;
	int k;
	long b;
	long *p;
	int ip, jp;
	int n;
	struct place g;
	int i, j;
	double lat, lon;
	int conn;
	FILE *ifile, *xfile;

	indexfile = mapindex(mapfile);
	xfile = fopen(indexfile,"r");
	if(xfile==NULL)
		filerror("can't find map index", indexfile);
	free(indexfile);
	for(i=0,p=patch[0];i&lt;18*36;i++,p++)
		*p = 1;
	while(!feof(xfile) &amp;&amp; fscanf(xfile,"%d%d%ld",&amp;i,&amp;j,&amp;b)==3)
		patch[i+9][j+18] = b;
	fclose(xfile);
	ifile = fopen(mapfile,"r");
	if(ifile==NULL)
		filerror("can't find map data", mapfile);
	for(lat=lolat;lat&lt;hilat;lat+=10.)
		for(lon=lolon;lon&lt;hilon;lon+=10.) {
			if(!seeable(lat,lon))
				continue;
			i = pnorm(lat);
			j = pnorm(lon);
			if((b=patch[i+9][j+18])&amp;1)
				continue;
			fseek(ifile,b,0);
			while((ip=getc(ifile))&gt;=0&amp;&amp;(jp=getc(ifile))&gt;=0){
				if(ip!=(i&amp;0377)||jp!=(j&amp;0377))
					break;
				n = getshort(ifile);
				conn = 0;
				if(n &gt; 0) {	/* absolute coordinates */
					kx = ky = 0;	/* set */
					for(k=0;k&lt;n;k++){
						kx = SCALERATIO*getshort(ifile);
						ky = SCALERATIO*getshort(ifile);
						if (((k%delta) != 0) &amp;&amp; (k != (n-1)))
							continue;
						conv(kx,&amp;g.nlat);
						conv(ky,&amp;g.wlon);
						conn = plotpt(&amp;g,conn);
					}
				} else {	/* differential, scaled by SCALERATI0 */
					n = -n;
					kx = SCALERATIO*getshort(ifile);
					ky = SCALERATIO*getshort(ifile);
					for(k=0; k&lt;n; k++) {
						c = getc(ifile);
						if(c&amp;0200) c|= ~0177;
						kx += c;
						c = getc(ifile);
						if(c&amp;0200) c|= ~0177;
						ky += c;
						if(k%delta!=0&amp;&amp;k!=n-1)
							continue;
						conv(kx,&amp;g.nlat);
						conv(ky,&amp;g.wlon);
						conn = plotpt(&amp;g,conn);
					}
				}
				if(k==1) {
					conv(kx,&amp;g.nlat);
					conv(ky,&amp;g.wlon);
					plotpt(&amp;g,conn);
				}
			}
		}
	fclose(ifile);
}

int
seeable(double lat0, double lon0)
{
	double x, y;
	double lat, lon;
	for(lat=lat0;lat&lt;=lat0+10;lat+=2*grid[2])
		for(lon=lon0;lon&lt;=lon0+10;lon+=2*grid[2])
			if(normproj(lat,lon,&amp;x,&amp;y)*vflag&gt;0)
				return(1);
	return(0);
}

void
satellite(struct file *t)
{
	char sym[50];
	char lbl[50];
	double scale;
	register conn;
	double lat,lon;
	struct place place;
	static FILE *ifile = stdin;
	if(t-&gt;name[0]!='-'||t-&gt;name[1]!=0) {
		fclose(ifile);
		if((ifile=fopen(t-&gt;name,"r"))==NULL)
			filerror("can't find track", t-&gt;name);
	}
	comment("track",t-&gt;name);
	colorx(t-&gt;color);
	pen(t-&gt;style);
	for(;;) {
		conn = 0;
		while(!feof(ifile) &amp;&amp; fscanf(ifile,"%lf%lf",&amp;lat,&amp;lon)==2){
			latlon(lat,lon,&amp;place);
			if(fscanf(ifile,"%1s",lbl) == 1) {
				if(strchr("+-.0123456789",*lbl)==0)
					break;
				ungetc(*lbl,ifile);
			}
			conn = plotpt(&amp;place,conn);
		}
		if(feof(ifile))
			return;
		fscanf(ifile,"%[^\n]",lbl+1);
		switch(*lbl) {
		case '"':
			if(plotpt(&amp;place,conn))
				text(lbl+1);
			break;
		case ':':
		case '!':
			if(sscanf(lbl+1,"%s %lf",sym,&amp;scale) &lt;= 1)
				scale = 1;
			if(plotpt(&amp;place,conn?conn:-1)) {
				int r = *lbl=='!'?0:rflag?-1:1;
				pen(SOLID);
				if(putsym(&amp;place,sym,scale,r) == 0)
					text(lbl);
				pen(t-&gt;style);
			}
			break;
		default:
			if(plotpt(&amp;place,conn))
				text(lbl);
			break;
		}
	}
}

int
pnorm(double x)
{
	int i;
	i = x/10.;
	i %= 36;
	if(i&gt;=18) return(i-36);
	if(i&lt;-18) return(i+36);
	return(i);
}

void
error(char *s)
{
	fprintf(stderr,"map: \r\n%s\n",s);
	exits("error");
}

void
filerror(char *s, char *f)
{
	fprintf(stderr,"\r\n%s %s\n",s,f);
	exits("error");
}

char *
mapindex(char *s)
{
	char *t = malloc(strlen(s)+3);
	strcpy(t,s);
	strcat(t,".x");
	return t;
}

#define NOPT 32767
static ox = NOPT, oy = NOPT;

int
cpoint(int xi, int yi, int conn)
{
	int dx = abs(ox-xi);
	int dy = abs(oy-yi);
	if(!xflag &amp;&amp; (xi&lt;left||xi&gt;=right || yi&lt;bottom||yi&gt;=top)) {
		ox = oy = NOPT;
		return 0;
	}
	if(conn == -1)		/* isolated plotting symbol */
		{}
	else if(!conn)
		point(xi,yi);
	else {
		if(dx+dy&gt;longlines) {
			ox = oy = NOPT;	/* don't leap across cuts */
			return 0;
		}
		if(dx || dy)
			vec(xi,yi);
	}
	ox = xi, oy = yi;
	return dx+dy&lt;=2? 2: 1;	/* 2=very near; see dogrid */
}


struct place oldg;

int
plotpt(struct place *g, int conn)
{
	int kx,ky;
	int ret;
	double cutlon;
	if(!inlimits(g)) {
		return(0);
}
	normalize(g);
	if(!inwindow(g)) {
		return(0);
}
	switch((*cut)(g,&amp;oldg,&amp;cutlon)) {
	case 2:
		if(conn) {
			ret = duple(g,cutlon)|duple(g,cutlon);
			oldg = *g;
			return(ret);
		}
	case 0:
		conn = 0;
	default:	/* prevent diags about bad return value */
	case 1:
		oldg = *g;
		ret = doproj(g,&amp;kx,&amp;ky);
		if(ret==0 || !onlimb &amp;&amp; ret*vflag&lt;=0)
			return(0);
		ret = cpoint(kx,ky,conn);
		return ret;
	}
}

int
doproj(struct place *g, int *kx, int *ky)
{
	int i;
	double x,y,x1,y1;
/*fprintf(stderr,"dopr1 %f %f \n",g-&gt;nlat.l,g-&gt;wlon.l);*/
	i = fixproj(g,&amp;x,&amp;y);
	if(i == 0)
		return(0);
	if(rflag)
		x = -x;
/*fprintf(stderr,"dopr2 %f %f\n",x,y);*/
	if(!inpoly(x,y)) {
		return 0;
}
	x1 = x - xcent;
	y1 = y - ycent;
	x = (x1*crot.c - y1*crot.s + xoff)*scaling;
	y = (x1*crot.s + y1*crot.c + yoff)*scaling;
	*kx = x + (x&gt;0?.5:-.5);
	*ky = y + (y&gt;0?.5:-.5);
	return(i);
}

int
duple(struct place *g, double cutlon)
{
	int kx,ky;
	int okx,oky;
	struct place ig;
	revlon(g,cutlon);
	revlon(&amp;oldg,cutlon);
	ig = *g;
	invert(&amp;ig);
	if(!inlimits(&amp;ig))
		return(0);
	if(doproj(g,&amp;kx,&amp;ky)*vflag&lt;=0 ||
	   doproj(&amp;oldg,&amp;okx,&amp;oky)*vflag&lt;=0)
		return(0);
	cpoint(okx,oky,0);
	cpoint(kx,ky,1);
	return(1);
}

void
revlon(struct place *g, double cutlon)
{
	g-&gt;wlon.l = reduce(cutlon-reduce(g-&gt;wlon.l-cutlon));
	sincos(&amp;g-&gt;wlon);
}


/*	recognize problems of cuts
 *	move a point across cut to side of its predecessor
 *	if its very close to the cut
 *	return(0) if cut interrupts the line
 *	return(1) if line is to be drawn normally
 *	return(2) if line is so close to cut as to
 *	be properly drawn on both sheets
*/

int
picut(struct place *g, struct place *og, double *cutlon)
{
	*cutlon = PI;
	return(ckcut(g,og,PI));
}

int
nocut(struct place *g, struct place *og, double *cutlon)
{
	USED(g, og, cutlon);
/*
#pragma	ref g
#pragma	ref og
#pragma	ref cutlon
*/
	return(1);
}

int
ckcut(struct place *g1, struct place *g2, double lon)
{
	double d1, d2;
	double f1, f2;
	int kx,ky;
	d1 = reduce(g1-&gt;wlon.l -lon);
	d2 = reduce(g2-&gt;wlon.l -lon);
	if((f1=fabs(d1))&lt;FUZZ)
		d1 = diddle(g1,lon,d2);
	if((f2=fabs(d2))&lt;FUZZ) {
		d2 = diddle(g2,lon,d1);
		if(doproj(g2,&amp;kx,&amp;ky)*vflag&gt;0)
			cpoint(kx,ky,0);
	}
	if(f1&lt;FUZZ&amp;&amp;f2&lt;FUZZ)
		return(2);
	if(f1&gt;PI*TWO_THRD||f2&gt;PI*TWO_THRD)
		return(1);
	return(d1*d2&gt;=0);
}

double
diddle(struct place *g, double lon, double d)
{
	double d1;
	d1 = FUZZ/2;
	if(d&lt;0)
		d1 = -d1;
	g-&gt;wlon.l = reduce(lon+d1);
	sincos(&amp;g-&gt;wlon);
	return(d1);
}

double
reduce(double lon)
{
	if(lon&gt;PI)
		lon -= 2*PI;
	else if(lon&lt;-PI)
		lon += 2*PI;
	return(lon);
}


double tetrapt = 35.26438968;	/* atan(1/sqrt(2)) */

void
dogrid(double lat0, double lat1, double lon0, double lon1)
{
	double slat,slon,tlat,tlon;
	register int conn, oconn;
	slat = tlat = slon = tlon = 0;
	if(lat1&gt;lat0)
		slat = tlat = fmin(grid[2],dlat);
	else
		slon = tlon = fmin(grid[2],dlon);;
	conn = oconn = 0;
	while(lat0&lt;=lat1&amp;&amp;lon0&lt;=lon1) {
		conn = gridpt(lat0,lon0,conn);
		if(projection==Xguyou&amp;&amp;slat&gt;0) {
			if(lat0&lt;-45&amp;&amp;lat0+slat&gt;-45)
				conn = gridpt(-45.,lon0,conn);
			else if(lat0&lt;45&amp;&amp;lat0+slat&gt;45)
				conn = gridpt(45.,lon0,conn);
		} else if(projection==Xtetra&amp;&amp;slat&gt;0) {
			if(lat0&lt;-tetrapt&amp;&amp;lat0+slat&gt;-tetrapt) {
				gridpt(-tetrapt-.001,lon0,conn);
				conn = gridpt(-tetrapt+.001,lon0,0);
			}
			else if(lat0&lt;tetrapt&amp;&amp;lat0+slat&gt;tetrapt) {
				gridpt(tetrapt-.001,lon0,conn);
				conn = gridpt(tetrapt+.001,lon0,0);
			}
		}
		if(conn==0 &amp;&amp; oconn!=0) {
			if(slat+slon&gt;.05) {
				lat0 -= slat;	/* steps too big */
				lon0 -= slon;	/* or near bdry */
				slat /= 2;
				slon /= 2;
				conn = oconn = gridpt(lat0,lon0,conn);
			} else
				oconn = 0;
		} else {
			if(conn==2) {
				slat = tlat;
				slon = tlon;
				conn = 1;
			}
			oconn = conn;
	 	}
		lat0 += slat;
		lon0 += slon;
	}
	gridpt(lat1,lon1,conn);
}

static gridinv;		/* nonzero when doing window bounds */

int
gridpt(double lat, double lon, int conn)
{
	struct place g;
/*fprintf(stderr,"%f %f\n",lat,lon);*/
	latlon(lat,lon,&amp;g);
	if(gridinv)
		invert(&amp;g);
	return(plotpt(&amp;g,conn));
}

/* win=0 ordinary grid lines, win=1 window lines */

void
dobounds(double lolat, double hilat, double lolon, double hilon, int win)
{
	gridinv = win;
	if(lolat&gt;-90 || win &amp;&amp; (poles&amp;1)!=0)
		dogrid(lolat+FUZZ,lolat+FUZZ,lolon,hilon);
	if(hilat&lt;90 || win &amp;&amp; (poles&amp;2)!=0)
		dogrid(hilat-FUZZ,hilat-FUZZ,lolon,hilon);
	if(hilon-lolon&lt;360 || win &amp;&amp; cut==picut) {
		dogrid(lolat,hilat,lolon+FUZZ,lolon+FUZZ);
		dogrid(lolat,hilat,hilon-FUZZ,hilon-FUZZ);
	}
	gridinv = 0;
}

static void
dolimb(void)
{
	double lat, lon;
	double res = fmin(dlat, dlon)/4;
	int conn = 0;
	int newconn;
	if(limb == 0)
		return;
	onlimb = gridinv = 1;
	for(;;) {
		newconn = (*limb)(&amp;lat, &amp;lon, res);
		if(newconn == -1)
			break;
		conn = gridpt(lat, lon, conn*newconn);
	}
	onlimb = gridinv = 0;
}


void
radbds(double *w, double *rw)
{
	int i;
	for(i=0;i&lt;4;i++)
		rw[i] = w[i]*RAD;
	rw[0] -= FUZZ;
	rw[1] += FUZZ;
	rw[2] -= FUZZ;
	rw[3] += FUZZ;
}

void
windlim(void)
{
	double center = orientation[0];
	double colat;
	if(center&gt;90)
		center = 180 - center;
	if(center&lt;-90)
		center = -180 - center;
	if(fabs(center)&gt;90)
		error("unreasonable orientation");
	colat = 90 - window[0];
	if(center-colat&gt;limits[0])
		limits[0] = center - colat;
	if(center+colat&lt;limits[1])
		limits[1] = center + colat;
}


short
getshort(FILE *f)
{
	int c, r;
	c = getc(f);
	r = (c | getc(f)&lt;&lt;8);
	if (r&amp;0x8000)
		r |= ~0xFFFF;	/* in case short &gt; 16 bits */
	return r;
}

double
fmin(double x, double y)
{
	return(x&lt;y?x:y);
}

double
fmax(double x, double y)
{
	return(x&gt;y?x:y);
}

void
clamp(double *px, double v)
{
	*px = (v&lt;0?fmax:fmin)(*px,v);
}

void
pathnames(void)
{
	int i;
	char *t, *indexfile, *name;
	FILE *f, *fx;
	for(i=0; i&lt;nfile; i++) {
		name = file[i].name;
		if(*name=='/')
			continue;
		indexfile = mapindex(name);
			/* ansi equiv of unix access() call */
		f = fopen(name, "r");
		fx = fopen(indexfile, "r");
		if(f) fclose(f);
		if(fx) fclose(fx);
		free(indexfile);
		if(f &amp;&amp; fx)
			continue;
		t = malloc(strlen(name)+strlen(mapdir)+2);
		strcpy(t,mapdir);
		strcat(t,"/");
		strcat(t,name);
		file[i].name = t;
	}
}

void
clipinit(void)
{
	register i;
	double s,t;
	if(nvert&lt;=0)
		return;
	for(i=0; i&lt;nvert; i++) {	/*convert latlon to xy*/
		if(normproj(v[i].x,v[i].y,&amp;v[i].x,&amp;v[i].y)==0)
			error("invisible clipping vertex");
	}
	if(nvert==2) {			/*rectangle with diag specified*/
		nvert = 4;
		v[2] = v[1];
		v[1].x=v[0].x, v[1].y=v[2].y, v[3].x=v[2].x, v[3].y=v[0].y;
	}	
	v[nvert] = v[0];
	v[nvert+1] = v[1];
	s = 0;
	for(i=1; i&lt;=nvert; i++) {	/*test for convexity*/
		t = (v[i-1].x-v[i].x)*(v[i+1].y-v[i].y) -
		    (v[i-1].y-v[i].y)*(v[i+1].x-v[i].x);
		if(t&lt;-FUZZ &amp;&amp; s&gt;=0) s = 1;
		if(t&gt;FUZZ &amp;&amp; s&lt;=0) s = -1;
		if(-FUZZ&lt;=t&amp;&amp;t&lt;=FUZZ || t*s&gt;0) {
			s = 0;
			break;
		}
	}
	if(s==0)
		error("improper clipping polygon");
	for(i=0; i&lt;nvert; i++) {	/*edge equation ax+by=c*/
		e[i].a = s*(v[i+1].y - v[i].y);
		e[i].b = s*(v[i].x - v[i+1].x);
		e[i].c = s*(v[i].x*v[i+1].y - v[i].y*v[i+1].x);
	}
}

int
inpoly(double x, double y)
{
	register i;
	for(i=0; i&lt;nvert; i++) {
		register struct edge *ei = &amp;e[i];
		double val = x*ei-&gt;a + y*ei-&gt;b - ei-&gt;c;
		if(val&gt;10*FUZZ)
			return(0);
	}
	return 1;
}

void
realcut()
{
	struct place g;
	double lat;
	
	if(cut != picut)	/* punt on unusual cuts */
		return;
	for(lat=window[0]; lat&lt;=window[1]; lat+=grid[2]) {
		g.wlon.l = PI;
		sincos(&amp;g.wlon);
		g.nlat.l = lat*RAD;
		sincos(&amp;g.nlat);
		if(!inwindow(&amp;g)) {
			break;
}
		invert(&amp;g);
		if(inlimits(&amp;g)) {
			return;
}
	}
	longlines = shortlines = LONGLINES;
	cut = nocut;		/* not necessary; small eff. gain */
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

