<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/map/symbol.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/map/symbol.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "map.h"
#include "iplot.h"

#define NSYMBOL 20

enum flag { POINT,ENDSEG,ENDSYM };
struct symb {
	double x, y;
	char name[10+1];
	enum flag flag;
} *symbol[NSYMBOL];

static int nsymbol;
static double halfrange = 1;
extern int halfwidth;
extern int vflag;

static int	getrange(FILE *);
static int	getsymbol(FILE *, int);
static void	setrot(struct place *, double, int);
static void	dorot(struct symb *, double *, double *);


void
getsyms(char *file)
{
	FILE *sf = fopen(file,"r");
	if(sf==0)
		filerror("cannot open", file);
	while(nsymbol&lt;NSYMBOL-1 &amp;&amp; getsymbol(sf,nsymbol))
		nsymbol++;
	fclose(sf);
}

static int
getsymbol(FILE *sf, int n)
{
	double x,y;
	char s[2];
	int i;
	struct symb *sp;
	for(;;) {
		if(fscanf(sf,"%1s",s)==EOF)
			return 0;
		switch(s[0]) {
		case ':':
			break;
		case 'o':
		case 'c':	/* cl */
			fscanf(sf,"%*[^\n]");
			continue;
		case 'r':
			if(getrange(sf))
				continue;
		default:
			error("-y file syntax error");
		}
		break;
	}
	sp = (struct symb*)malloc(sizeof(struct symb));
	symbol[n] = sp;
	if(fscanf(sf,"%10s",sp-&gt;name)!=1)
		return 0;
	i = 0;
	while(fscanf(sf,"%1s",s)!=EOF) {
		switch(s[0]) {
		case 'r':
			if(!getrange(sf))
				break;
			continue;
		case 'm':
			if(i&gt;0)
				symbol[n][i-1].flag = ENDSEG;
			continue;
		case ':':
			ungetc(s[0],sf);
			break;
		default:
			ungetc(s[0],sf);
		case 'v':
			if(fscanf(sf,"%lf %lf",&amp;x,&amp;y)!=2)
				break;
			sp[i].x = x*halfwidth/halfrange;
			sp[i].y = y*halfwidth/halfrange;
			sp[i].flag = POINT;
			i++;
			sp = symbol[n] = (struct symb*)realloc(symbol[n],
					(i+1)*sizeof(struct symb));
			continue;
		}
		break;
	}
	if(i&gt;0)
		symbol[n][i-1].flag = ENDSYM;
	else
		symbol[n] = 0;
	return 1;
}

static int
getrange(FILE *sf)
{
	double x,y,xmin,ymin;
	if(fscanf(sf,"%*s %lf %lf %lf %lf",
		&amp;xmin,&amp;ymin,&amp;x,&amp;y)!=4)
		return 0;
	x -= xmin;
	y -= ymin;
	halfrange = (x&gt;y? x: y)/2;
	if(halfrange&lt;=0)
		error("bad ra command in -y file");
	return 1;
}

/* r=0 upright;=1 normal;=-1 reverse*/
int
putsym(struct place *p, char *name, double s, int r)
{
	int x,y,n;
	struct symb *sp;
	double dx,dy;
	int conn = 0;
	for(n=0; symbol[n]; n++)
		if(strcmp(name,symbol[n]-&gt;name)==0)
			break;
	sp = symbol[n];
	if(sp==0)
		return 0;
	if(doproj(p,&amp;x,&amp;y)*vflag &lt;= 0)
		return 1;
	setrot(p,s,r);
	for(;;) {
		dorot(sp,&amp;dx,&amp;dy);
		conn = cpoint(x+(int)dx,y+(int)dy,conn);
		switch(sp-&gt;flag) {
		case ENDSEG:
			conn = 0;
		case POINT:
			sp++;
			continue;
		case ENDSYM:
			break;
		}
		break;
	}
	return 1;
}

static double rot[2][2];

static void
setrot(struct place *p, double s, int r)
{
	double x0,y0,x1,y1;
	struct place up;
	up = *p;
	up.nlat.l += .5*RAD;
	sincos(&amp;up.nlat);
	if(r&amp;&amp;(*projection)(p,&amp;x0,&amp;y0)) {
		if((*projection)(&amp;up,&amp;x1,&amp;y1)&lt;=0) {
			up.nlat.l -= RAD;
			sincos(&amp;up.nlat);
			if((*projection)(&amp;up,&amp;x1,&amp;y1)&lt;=0)
				goto unit;
			x1 = x0 - x1;
			y1 = y0 - y1;
		} else {
			x1 -= x0;
			y1 -= y0;
		}
		x1 = r*x1;
		s /= hypot(x1,y1);
		rot[0][0] = y1*s;
		rot[0][1] = x1*s;
		rot[1][0] = -x1*s;
		rot[1][1] = y1*s;
	} else {
unit:
		rot[0][0] = rot[1][1] = s;
		rot[0][1] = rot[1][0] = 0;
	}
}

static void
dorot(struct symb *sp, double *px, double *py)
{
	*px = rot[0][0]*sp-&gt;x + rot[0][1]*sp-&gt;y;
	*py = rot[1][0]*sp-&gt;x + rot[1][1]*sp-&gt;y;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

