<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mk/graph.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mk/graph.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"mk.h"

static Node *applyrules(char *, char *);
static void togo(Node *);
static int vacuous(Node *);
static Node *newnode(char *);
static void trace(char *, Arc *);
static void cyclechk(Node *);
static void ambiguous(Node *);
static void attribute(Node *);

Node *
graph(char *target)
{
	Node *node;
	char *cnt;

	cnt = rulecnt();
	node = applyrules(target, cnt);
	free(cnt);
	cyclechk(node);
	node-&gt;flags |= PROBABLE;	/* make sure it doesn't get deleted */
	vacuous(node);
	ambiguous(node);
	attribute(node);
	return(node);
}

static Node *
applyrules(char *target, char *cnt)
{
	Symtab *sym;
	Node *node;
	Rule *r;
	Arc head, *a = &amp;head;
	Word *w;
	char stem[NAMEBLOCK], buf[NAMEBLOCK];
	Resub rmatch[NREGEXP];

/*	print("applyrules(%lux='%s')\n", target, target);/**/
	sym = symlook(target, S_NODE, 0);
	if(sym)
		return sym-&gt;u.ptr;
	target = strdup(target);
	node = newnode(target);
	head.n = 0;
	head.next = 0;
	sym = symlook(target, S_TARGET, 0);
	memset((char*)rmatch, 0, sizeof(rmatch));
	for(r = sym? sym-&gt;u.ptr:0; r; r = r-&gt;chain){
		if(r-&gt;attr&amp;META) continue;
		if(strcmp(target, r-&gt;target)) continue;
		if((!r-&gt;recipe || !*r-&gt;recipe) &amp;&amp; (!r-&gt;tail || !r-&gt;tail-&gt;s || !*r-&gt;tail-&gt;s)) continue;	/* no effect; ignore */
		if(cnt[r-&gt;rule] &gt;= nreps) continue;
		cnt[r-&gt;rule]++;
		node-&gt;flags |= PROBABLE;

/*		if(r-&gt;attr&amp;VIR)
 *			node-&gt;flags |= VIRTUAL;
 *		if(r-&gt;attr&amp;NOREC)
 *			node-&gt;flags |= NORECIPE;
 *		if(r-&gt;attr&amp;DEL)
 *			node-&gt;flags |= DELETE;
 */
		if(!r-&gt;tail || !r-&gt;tail-&gt;s || !*r-&gt;tail-&gt;s) {
			a-&gt;next = newarc((Node *)0, r, "", rmatch);
			a = a-&gt;next;
		} else
			for(w = r-&gt;tail; w; w = w-&gt;next){
				a-&gt;next = newarc(applyrules(w-&gt;s, cnt), r, "", rmatch);
				a = a-&gt;next;
		}
		cnt[r-&gt;rule]--;
		head.n = node;
	}
	for(r = metarules; r; r = r-&gt;next){
		if((!r-&gt;recipe || !*r-&gt;recipe) &amp;&amp; (!r-&gt;tail || !r-&gt;tail-&gt;s || !*r-&gt;tail-&gt;s)) continue;	/* no effect; ignore */
		if ((r-&gt;attr&amp;NOVIRT) &amp;&amp; a != &amp;head &amp;&amp; (a-&gt;r-&gt;attr&amp;VIR))
			continue;
		if(r-&gt;attr&amp;REGEXP){
			stem[0] = 0;
			patrule = r;
			memset((char*)rmatch, 0, sizeof(rmatch));
			if(regexec(r-&gt;pat, node-&gt;name, rmatch, NREGEXP) == 0)
				continue;
		} else {
			if(!match(node-&gt;name, r-&gt;target, stem)) continue;
		}
		if(cnt[r-&gt;rule] &gt;= nreps) continue;
		cnt[r-&gt;rule]++;

/*		if(r-&gt;attr&amp;VIR)
 *			node-&gt;flags |= VIRTUAL;
 *		if(r-&gt;attr&amp;NOREC)
 *			node-&gt;flags |= NORECIPE;
 *		if(r-&gt;attr&amp;DEL)
 *			node-&gt;flags |= DELETE;
 */
		if(!r-&gt;tail || !r-&gt;tail-&gt;s || !*r-&gt;tail-&gt;s) {
			a-&gt;next = newarc((Node *)0, r, stem, rmatch);
			a = a-&gt;next;
		} else
			for(w = r-&gt;tail; w; w = w-&gt;next){
				if(r-&gt;attr&amp;REGEXP)
					regsub(w-&gt;s, buf, sizeof(buf), rmatch, NREGEXP);
				else
					subst(stem, w-&gt;s, buf, sizeof(buf));
				a-&gt;next = newarc(applyrules(buf, cnt), r, stem, rmatch);
				a = a-&gt;next;
			}
		cnt[r-&gt;rule]--;
	}
	a-&gt;next = node-&gt;prereqs;
	node-&gt;prereqs = head.next;
	return(node);
}

static void
togo(Node *node)
{
	Arc *la, *a;

	/* delete them now */
	la = 0;
	for(a = node-&gt;prereqs; a; la = a, a = a-&gt;next)
		if(a-&gt;flag&amp;TOGO){
			if(a == node-&gt;prereqs)
				node-&gt;prereqs = a-&gt;next;
			else
				la-&gt;next = a-&gt;next, a = la;
		}
}

static
vacuous(Node *node)
{
	Arc *la, *a;
	int vac = !(node-&gt;flags&amp;PROBABLE);

	if(node-&gt;flags&amp;READY)
		return(node-&gt;flags&amp;VACUOUS);
	node-&gt;flags |= READY;
	for(a = node-&gt;prereqs; a; a = a-&gt;next)
		if(a-&gt;n &amp;&amp; vacuous(a-&gt;n) &amp;&amp; (a-&gt;r-&gt;attr&amp;META))
			a-&gt;flag |= TOGO;
		else
			vac = 0;
	/* if a rule generated arcs that DON'T go; no others from that rule go */
	for(a = node-&gt;prereqs; a; a = a-&gt;next)
		if((a-&gt;flag&amp;TOGO) == 0)
			for(la = node-&gt;prereqs; la; la = la-&gt;next)
				if((la-&gt;flag&amp;TOGO) &amp;&amp; (la-&gt;r == a-&gt;r)){
					la-&gt;flag &amp;= ~TOGO;
				}
	togo(node);
	if(vac)
		node-&gt;flags |= VACUOUS;
	return(vac);
}

static Node *
newnode(char *name)
{
	register Node *node;

	node = (Node *)Malloc(sizeof(Node));
	symlook(name, S_NODE, (void *)node);
	node-&gt;name = name;
	node-&gt;time = timeof(name, 0);
	node-&gt;prereqs = 0;
	node-&gt;flags = node-&gt;time? PROBABLE : 0;
	node-&gt;next = 0;
	return(node);
}

void
dumpn(char *s, Node *n)
{
	char buf[1024];
	Arc *a;

	Bprint(&amp;bout, "%s%s@%p: time=%ld flags=0x%x next=%p\n",
		s, n-&gt;name, n, n-&gt;time, n-&gt;flags, n-&gt;next);
	for(a = n-&gt;prereqs; a; a = a-&gt;next){
		snprint(buf, sizeof buf, "%s   ", (*s == ' ')? s:"");
		dumpa(buf, a);
	}
}

static void
trace(char *s, Arc *a)
{
	fprint(2, "\t%s", s);
	while(a){
		fprint(2, " &lt;-(%s:%d)- %s", a-&gt;r-&gt;file, a-&gt;r-&gt;line,
			a-&gt;n? a-&gt;n-&gt;name:"");
		if(a-&gt;n){
			for(a = a-&gt;n-&gt;prereqs; a; a = a-&gt;next)
				if(*a-&gt;r-&gt;recipe) break;
		} else
			a = 0;
	}
	fprint(2, "\n");
}

static void
cyclechk(Node *n)
{
	Arc *a;

	if((n-&gt;flags&amp;CYCLE) &amp;&amp; n-&gt;prereqs){
		fprint(2, "mk: cycle in graph detected at target %s\n", n-&gt;name);
		Exit();
	}
	n-&gt;flags |= CYCLE;
	for(a = n-&gt;prereqs; a; a = a-&gt;next)
		if(a-&gt;n)
			cyclechk(a-&gt;n);
	n-&gt;flags &amp;= ~CYCLE;
}

static void
ambiguous(Node *n)
{
	Arc *a;
	Rule *r = 0;
	Arc *la;
	int bad = 0;

	la = 0;
	for(a = n-&gt;prereqs; a; a = a-&gt;next){
		if(a-&gt;n)
			ambiguous(a-&gt;n);
		if(*a-&gt;r-&gt;recipe == 0) continue;
		if(r == 0)
			r = a-&gt;r, la = a;
		else{
			if(r-&gt;recipe != a-&gt;r-&gt;recipe){
				if((r-&gt;attr&amp;META) &amp;&amp; !(a-&gt;r-&gt;attr&amp;META)){
					la-&gt;flag |= TOGO;
					r = a-&gt;r, la = a;
				} else if(!(r-&gt;attr&amp;META) &amp;&amp; (a-&gt;r-&gt;attr&amp;META)){
					a-&gt;flag |= TOGO;
					continue;
				}
			}
			if(r-&gt;recipe != a-&gt;r-&gt;recipe){
				if(bad == 0){
					fprint(2, "mk: ambiguous recipes for %s:\n", n-&gt;name);
					bad = 1;
					trace(n-&gt;name, la);
				}
				trace(n-&gt;name, a);
			}
		}
	}
	if(bad)
		Exit();
	togo(n);
}

static void
attribute(Node *n)
{
	register Arc *a;

	for(a = n-&gt;prereqs; a; a = a-&gt;next){
		if(a-&gt;r-&gt;attr&amp;VIR)
			n-&gt;flags |= VIRTUAL;
		if(a-&gt;r-&gt;attr&amp;NOREC)
			n-&gt;flags |= NORECIPE;
		if(a-&gt;r-&gt;attr&amp;DEL)
			n-&gt;flags |= DELETE;
		if(a-&gt;n)
			attribute(a-&gt;n);
	}
	if(n-&gt;flags&amp;VIRTUAL)
		n-&gt;time = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

