<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mk/mk.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mk/mk.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"mk.h"

int runerrs;

void
mk(char *target)
{
	Node *node;
	int did = 0;

	nproc();		/* it can be updated dynamically */
	nrep();			/* it can be updated dynamically */
	runerrs = 0;
	node = graph(target);
	if(DEBUG(D_GRAPH)){
		dumpn("new target\n", node);
		Bflush(&amp;bout);
	}
	clrmade(node);
	while(node-&gt;flags&amp;NOTMADE){
		if(work(node, (Node *)0, (Arc *)0))
			did = 1;	/* found something to do */
		else {
			if(waitup(1, (int *)0) &gt; 0){
				if(node-&gt;flags&amp;(NOTMADE|BEINGMADE)){
					assert(/*must be run errors*/ runerrs);
					break;	/* nothing more waiting */
				}
			}
		}
	}
	if(node-&gt;flags&amp;BEINGMADE)
		waitup(-1, (int *)0);
	while(jobs)
		waitup(-2, (int *)0);
	assert(/*target didnt get done*/ runerrs || (node-&gt;flags&amp;MADE));
	if(did == 0)
		Bprint(&amp;bout, "mk: '%s' is up to date\n", node-&gt;name);
}

void
clrmade(Node *n)
{
	Arc *a;

	n-&gt;flags &amp;= ~(CANPRETEND|PRETENDING);
	if(strchr(n-&gt;name, '(') ==0 || n-&gt;time)
		n-&gt;flags |= CANPRETEND;
	MADESET(n, NOTMADE);
	for(a = n-&gt;prereqs; a; a = a-&gt;next)
		if(a-&gt;n)
			clrmade(a-&gt;n);
}

static void
unpretend(Node *n)
{
	MADESET(n, NOTMADE);
	n-&gt;flags &amp;= ~(CANPRETEND|PRETENDING);
	n-&gt;time = 0;
}

int
work(Node *node, Node *p, Arc *parc)
{
	Arc *a, *ra;
	int weoutofdate;
	int ready;
	int did = 0;
	char cwd[256];

	/*print("work(%s) flags=0x%x time=%lud\n", node-&gt;name, node-&gt;flags, node-&gt;time);/**/
	if(node-&gt;flags&amp;BEINGMADE)
		return(did);
	if((node-&gt;flags&amp;MADE) &amp;&amp; (node-&gt;flags&amp;PRETENDING) &amp;&amp; p &amp;&amp; outofdate(p, parc, 0)){
		if(explain)
			fprint(1, "unpretending %s(%lud) because %s is out of date(%lud)\n",
				node-&gt;name, node-&gt;time, p-&gt;name, p-&gt;time);
		unpretend(node);
	}
	/*
		have a look if we are pretending in case
		someone has been unpretended out from underneath us
	*/
	if(node-&gt;flags&amp;MADE){
		if(node-&gt;flags&amp;PRETENDING){
			node-&gt;time = 0;
		}else
			return(did);
	}
	/* consider no prerequisite case */
	if(node-&gt;prereqs == 0){
		if(node-&gt;time == 0){
			if(getwd(cwd, sizeof cwd))
				fprint(2, "mk: don't know how to make '%s' in directory %s\n", node-&gt;name, cwd);
			else
				fprint(2, "mk: don't know how to make '%s'\n", node-&gt;name);
			if(kflag){
				node-&gt;flags |= BEINGMADE;
				runerrs++;
			} else
				Exit();
		} else
			MADESET(node, MADE);
		return(did);
	}
	/*
		now see if we are out of date or what
	*/
	ready = 1;
	weoutofdate = aflag;
	ra = 0;
	for(a = node-&gt;prereqs; a; a = a-&gt;next)
		if(a-&gt;n){
			did = work(a-&gt;n, node, a) || did;
			if(a-&gt;n-&gt;flags&amp;(NOTMADE|BEINGMADE))
				ready = 0;
			if(outofdate(node, a, 0)){
				weoutofdate = 1;
				if((ra == 0) || (ra-&gt;n == 0)
						|| (ra-&gt;n-&gt;time &lt; a-&gt;n-&gt;time))
					ra = a;
			}
		} else {
			if(node-&gt;time == 0){
				if(ra == 0)
					ra = a;
				weoutofdate = 1;
			}
		}
	if(ready == 0)	/* can't do anything now */
		return(did);
	if(weoutofdate == 0){
		MADESET(node, MADE);
		return(did);
	}
	/*
		can we pretend to be made?
	*/
	if((iflag == 0) &amp;&amp; (node-&gt;time == 0) &amp;&amp; (node-&gt;flags&amp;(PRETENDING|CANPRETEND))
			&amp;&amp; p &amp;&amp; ra-&gt;n &amp;&amp; !outofdate(p, ra, 0)){
		node-&gt;flags &amp;= ~CANPRETEND;
		MADESET(node, MADE);
		if(explain &amp;&amp; ((node-&gt;flags&amp;PRETENDING) == 0))
			fprint(1, "pretending %s has time %lud\n", node-&gt;name, node-&gt;time);
		node-&gt;flags |= PRETENDING;
		return(did);
	}
	/*
		node is out of date and we REALLY do have to do something.
		quickly rescan for pretenders
	*/
	for(a = node-&gt;prereqs; a; a = a-&gt;next)
		if(a-&gt;n &amp;&amp; (a-&gt;n-&gt;flags&amp;PRETENDING)){
			if(explain)
				Bprint(&amp;bout, "unpretending %s because of %s because of %s\n",
				a-&gt;n-&gt;name, node-&gt;name, ra-&gt;n? ra-&gt;n-&gt;name : "rule with no prerequisites");

			unpretend(a-&gt;n);
			did = work(a-&gt;n, node, a) || did;
			ready = 0;
		}
	if(ready == 0)	/* try later unless nothing has happened for -k's sake */
		return(did || work(node, p, parc));
	did = dorecipe(node) || did;
	return(did);
}

void
update(int fake, Node *node)
{
	Arc *a;

	MADESET(node, fake? BEINGMADE : MADE);
	if(((node-&gt;flags&amp;VIRTUAL) == 0) &amp;&amp; (access(node-&gt;name, 0) == 0)){
		node-&gt;time = timeof(node-&gt;name, 1);
		node-&gt;flags &amp;= ~(CANPRETEND|PRETENDING);
		for(a = node-&gt;prereqs; a; a = a-&gt;next)
			if(a-&gt;prog)
				outofdate(node, a, 1);
	} else {
		node-&gt;time = 1;
		for(a = node-&gt;prereqs; a; a = a-&gt;next)
			if(a-&gt;n &amp;&amp; outofdate(node, a, 1))
				node-&gt;time = a-&gt;n-&gt;time;
	}
/*	print("----node %s time=%lud flags=0x%x\n", node-&gt;name, node-&gt;time, node-&gt;flags);/**/
}

static
pcmp(char *prog, char *p, char *q)
{
	char buf[3*NAMEBLOCK];
	int pid;

	Bflush(&amp;bout);
	snprint(buf, sizeof buf, "%s '%s' '%s'\n", prog, p, q);
	pid = pipecmd(buf, 0, 0);
	while(waitup(-3, &amp;pid) &gt;= 0)
		;
	return(pid? 2:1);
}

int
outofdate(Node *node, Arc *arc, int eval)
{
	char buf[3*NAMEBLOCK], *str;
	Symtab *sym;
	int ret;

	str = 0;
	if(arc-&gt;prog){
		snprint(buf, sizeof buf, "%s%c%s", node-&gt;name, 0377,
			arc-&gt;n-&gt;name);
		sym = symlook(buf, S_OUTOFDATE, 0);
		if(sym == 0 || eval){
			if(sym == 0)
				str = strdup(buf);
			ret = pcmp(arc-&gt;prog, node-&gt;name, arc-&gt;n-&gt;name);
			if(sym)
				sym-&gt;u.value = ret;
			else
				symlook(str, S_OUTOFDATE, (void *)ret);
		} else
			ret = sym-&gt;u.value;
		return(ret-1);
	} else if(strchr(arc-&gt;n-&gt;name, '(') &amp;&amp; arc-&gt;n-&gt;time == 0)  /* missing archive member */
		return 1;
	else
		/*
		 * Treat equal times as out-of-date.
		 * It's a race, and the safer option is to do
		 * extra building rather than not enough.
	 	 */
		return node-&gt;time &lt;= arc-&gt;n-&gt;time;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

