<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mk/word.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mk/word.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"mk.h"

static	Word	*nextword(char**);

Word*
newword(char *s)
{
	Word *w;

	w = (Word *)Malloc(sizeof(Word));
	w-&gt;s = strdup(s);
	w-&gt;next = 0;
	return(w);
}

Word *
stow(char *s)
{
	Word *head, *w, *new;

	w = head = 0;
	while(*s){
		new = nextword(&amp;s);
		if(new == 0)
			break;
		if (w)
			w-&gt;next = new;
		else
			head = w = new;
		while(w-&gt;next)
			w = w-&gt;next;
		
	}
	if (!head)
		head = newword("");
	return(head);
}

char *
wtos(Word *w, int sep)
{
	Bufblock *buf;
	char *cp;

	buf = newbuf();
	for(; w; w = w-&gt;next){
		for(cp = w-&gt;s; *cp; cp++)
			insert(buf, *cp);
		if(w-&gt;next)
			insert(buf, sep);
	}
	insert(buf, 0);
	cp = strdup(buf-&gt;start);
	freebuf(buf);
	return(cp);
}

Word*
wdup(Word *w)
{
	Word *v, *new, *base;

	v = base = 0;
	while(w){
		new = newword(w-&gt;s);
		if(v)
			v-&gt;next = new;
		else
			base = new;
		v = new;
		w = w-&gt;next;
	}
	return base;
}

void
delword(Word *w)
{
	Word *v;

	while(v = w){
		w = w-&gt;next;
		if(v-&gt;s)
			free(v-&gt;s);
		free(v);
	}
}

/*
 *	break out a word from a string handling quotes, executions,
 *	and variable expansions.
 */
static Word*
nextword(char **s)
{
	Bufblock *b;
	Word *head, *tail, *w;
	Rune r;
	char *cp;
	int empty;

	cp = *s;
	b = newbuf();
restart:
	head = tail = 0;
	while(*cp == ' ' || *cp == '\t')		/* leading white space */
		cp++;
	empty = 1;
	while(*cp){
		cp += chartorune(&amp;r, cp);
		switch(r)
		{
		case ' ':
		case '\t':
		case '\n':
			goto out;
		case '\\':
		case '\'':
		case '"':
			empty = 0;
			cp = expandquote(cp, r, b);
			if(cp == 0){
				fprint(2, "missing closing quote: %s\n", *s);
				Exit();
			}
			break;
		case '$':
			w = varsub(&amp;cp);
			if(w == 0){
				if(empty)
					goto restart;
				break;
			}
			empty = 0;
			if(b-&gt;current != b-&gt;start){
				bufcpy(b, w-&gt;s, strlen(w-&gt;s));
				insert(b, 0);
				free(w-&gt;s);
				w-&gt;s = strdup(b-&gt;start);
				b-&gt;current = b-&gt;start;
			}
			if(head){
				bufcpy(b, tail-&gt;s, strlen(tail-&gt;s));
				bufcpy(b, w-&gt;s, strlen(w-&gt;s));
				insert(b, 0);
				free(tail-&gt;s);
				tail-&gt;s = strdup(b-&gt;start);
				tail-&gt;next = w-&gt;next;
				free(w-&gt;s);
				free(w);
				b-&gt;current = b-&gt;start;
			} else
				tail = head = w;
			while(tail-&gt;next)
				tail = tail-&gt;next;
			break;
		default:
			empty = 0;
			rinsert(b, r);
			break;
		}
	}
out:
	*s = cp;
	if(b-&gt;current != b-&gt;start){
		if(head){
			cp = b-&gt;current;
			bufcpy(b, tail-&gt;s, strlen(tail-&gt;s));
			bufcpy(b, b-&gt;start, cp-b-&gt;start);
			insert(b, 0);
			free(tail-&gt;s);
			tail-&gt;s = strdup(cp);
		} else {
			insert(b, 0);
			head = newword(b-&gt;start);
		}
	}
	freebuf(b);
	return head;
}

void
dumpw(char *s, Word *w)
{
	Bprint(&amp;bout, "%s", s);
	for(; w; w = w-&gt;next)
		Bprint(&amp;bout, " '%s'", w-&gt;s);
	Bputc(&amp;bout, '\n');
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

