<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ms2html.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ms2html.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;bio.h&gt;

enum
{
	SSIZE = 10,

	Maxnh=	8,		/* highest NH level */
	HH=	4,		/* heading level used for SH and NH */
	Maxmstack=	10,	/* deepest macro/string nesting */
	Narg=	20,		/* max args to a macro */
	Maxsstack=	5,	/* deepest nesting of .so's */
	Nline=	1024,
	Maxget= 10,
	Maxif = 20,
	Maxfsp = 100,

	/* list types */
	Lordered = 1,
	Lunordered,
	Ldef,
	Lother,
};

char *delim = "$$";
char *basename;
char *title;
int eqnmode;

int 	quiet;
float	indent; /* from .in */
Biobuf	bout;
int	isup;
int	isdown;
int	debug;

int nh[Maxnh];
int ifwastrue[Maxif];

int list, listnum, example;
int hangingau, hangingdt, hanginghead, hangingcenter;
int indirective, paragraph, sol, titleseen, ignore_nl, weBref;
void dohangingcenter(void);

typedef struct Goobie Goobie;
typedef struct Goobieif Goobieif;
struct Goobie
{
	char *name;
	void (*f)(int, char**);
};

typedef void F(int, char**);
typedef void Fif(char*, char*);

struct Goobieif
{
	char *name;
	Fif *f;
};

/* if, ie */
Fif g_as, g_ds, g_el, g_ie, g_if;
Goobieif gtabif[] = {
	{ "as", g_as },
	{ "ds", g_ds },
	{ "if", g_if },
	{ "ie", g_ie },
	{ "el", g_el },
	{ nil, nil },
	};

/* pseudo ops */
F g_notyet, g_ignore, g_hrule, g_startgif;

/* ms macros */
F g_AU, g_B, g_BI, g_CW, g_I, g_IP, g_LP, g_PP, g_SH, g_NH;
F g_P1, g_P2, g_TL, g_R, g_AB, g_AE, g_EQ, g_TS, g_TE, g_FS, g_FE;
F g_PY, g_IH, g_MH, g_HO, g_BX, g_QS, g_QE, g_RS, g_RE;

/* pictures macro */
F g_BP;

/* real troff */
F g_br, g_ft, g_sp, g_de, g_lf, g_so, g_rm, g_in;
F g_nr, g_ig, g_RT, g_BS, g_BE, g_LB, g_ta;

/* macros to include ML in output */
F g__H, g__T;

Goobie gtab[] =
{
	{ "_T", g__T, },
	{ "_H", g__H, },
	{ "1C",	g_ignore, },
	{ "2C",	g_ignore, },
	{ "AB", g_AB, },
	{ "AE", g_AE, },
	{ "AI", g_ignore, },
	{ "AU", g_AU, },
	{ "B",	g_B, },
	{ "B1", g_hrule, },
	{ "B2", g_hrule, },
	{ "BI",	g_BI, },
	{ "BP",	g_BP, },
	{ "BT",	g_ignore, },
	{ "BX",	g_BX, },
	{ "CW",	g_CW, },
	{ "CT",	g_ignore, },
	{ "DA",	g_ignore, },
	{ "DE",	g_P2, },
	{ "DS",	g_P1, },
	{ "EG",	g_ignore, },
	{ "EN",	g_ignore, },
	{ "EQ",	g_startgif, },
	{ "FE",	g_FE, },
	{ "FP",	g_ignore, },
	{ "FS",	g_FS, },
	{ "HO",	g_HO, },
	{ "I",	g_I, },
	{ "IH",	g_IH, },
	{ "IM",	g_ignore, },
	{ "IP",	g_IP, },
	{ "KE",	g_ignore, },
	{ "KF",	g_ignore, },
	{ "KS",	g_ignore, },
	{ "LG",	g_ignore, },
	{ "LP",	g_LP, },
	{ "LT",	g_ignore, },
	{ "MF",	g_ignore, },
	{ "MH",	g_MH, },
	{ "MR",	g_ignore, },
	{ "ND",	g_ignore, },
	{ "NH",	g_NH, },
	{ "NL",	g_ignore, },
	{ "P1",	g_P1, },
	{ "P2",	g_P2, },
	{ "PE",	g_ignore, },
	{ "PF",	g_ignore, },
	{ "PP",	g_PP, },
	{ "PS",	g_startgif, },
	{ "PY",	g_PY, },
	{ "QE",	g_QE, },
	{ "QP",	g_QS, },
	{ "QS",	g_QS, },
	{ "R",		g_R, },
	{ "RE",	g_RE, },
	{ "RP",	g_ignore, },
	{ "RS",	g_RS, },
	{ "SG",	g_ignore, },
	{ "SH",	g_SH, },
	{ "SM",	g_ignore, },
	{ "TA",	g_ignore, },
	{ "TE",	g_ignore, },
	{ "TH",	g_TL, },
	{ "TL",	g_TL, },
	{ "TM",	g_ignore, },
	{ "TR",	g_ignore, },
	{ "TS",	g_startgif, },
	{ "UL",	g_I, },
	{ "UX",	g_ignore, },
	{ "WH",	g_ignore, },
	{ "RT", 	g_RT, },

	{ "br",	g_br, },
	{ "ti",		g_br, },
	{ "nf",	g_P1, },
	{ "fi",		g_P2, },
	{ "ft",		g_ft, },
	{ "sp", 	g_sp, },
	{ "rm", 	g_rm, },
	{ "de", 	g_de, },
	{ "am", 	g_de, },
	{ "lf", 	g_lf, },
	{ "so", 	g_so, },
	{ "ps", 	g_ignore },
	{ "vs", 	g_ignore },
	{ "nr", 	g_nr },
	{ "in", 	g_in },
	{ "ne", 	g_ignore },
	{ "ig", 	g_ig },
	{ "BS", 	g_BS },
	{ "BE", 	g_BE },
	{ "LB", 	g_LB },
	{ nil, nil },
};

typedef struct Entity Entity;
struct Entity
{
	char *name;
	int value;
};

Entity entity[] =
{
	{ "&amp;#SPACE;",	L' ', },
	{ "&amp;#RS;",		L'\n', },
	{ "&amp;#RE;",		L'\r', },
	{ "&amp;quot;",		L'"', },
	{ "&amp;AElig;",	L'Æ', },
	{ "&amp;Aacute;",	L'Á', },
	{ "&amp;Acirc;",	L'Â', },
	{ "&amp;Agrave;",	L'À', },
	{ "&amp;Aring;",	L'Å', },
	{ "&amp;Atilde;",	L'Ã', },
	{ "&amp;Auml;",	L'Ä', },
	{ "&amp;Ccedil;",	L'Ç', },
	{ "&amp;ETH;",		L'Ð', },
	{ "&amp;Eacute;",	L'É', },
	{ "&amp;Ecirc;",	L'Ê', },
	{ "&amp;Egrave;",	L'È', },
	{ "&amp;Euml;",	L'Ë', },
	{ "&amp;Iacute;",	L'Í', },
	{ "&amp;Icirc;",		L'Î', },
	{ "&amp;Igrave;",	L'Ì', },
	{ "&amp;Iuml;",		L'Ï', },
	{ "&amp;Ntilde;",	L'Ñ', },
	{ "&amp;Oacute;",	L'Ó', },
	{ "&amp;Ocirc;",	L'Ô', },
	{ "&amp;Ograve;",	L'Ò', },
	{ "&amp;Oslash;",	L'Ø', },
	{ "&amp;Otilde;",	L'Õ', },
	{ "&amp;Ouml;",	L'Ö', },
	{ "&amp;THORN;",	L'Þ', },
	{ "&amp;Uacute;",	L'Ú', },
	{ "&amp;Ucirc;",	L'Û', },
	{ "&amp;Ugrave;",	L'Ù', },
	{ "&amp;Uuml;",	L'Ü', },
	{ "&amp;Yacute;",	L'Ý', },
	{ "&amp;aacute;",	L'á', },
	{ "&amp;acirc;",	L'â', },
	{ "&amp;aelig;",	L'æ', },
	{ "&amp;agrave;",	L'à', },
	{ "&amp;amp;",		L'&amp;', },
	{ "&amp;aring;",	L'å', },
	{ "&amp;atilde;",	L'ã', },
	{ "&amp;auml;",	L'ä', },
	{ "&amp;ccedil;",	L'ç', },
	{ "&amp;eacute;",	L'é', },
	{ "&amp;ecirc;",	L'ê', },
	{ "&amp;egrave;",	L'è', },
	{ "&amp;eth;",		L'ð', },
	{ "&amp;euml;",	L'ë', },
	{ "&amp;gt;",		L'&gt;', },
	{ "&amp;iacute;",	L'í', },
	{ "&amp;icirc;",		L'î', },
	{ "&amp;igrave;",	L'ì', },
	{ "&amp;iuml;",		L'ï', },
	{ "&amp;lt;",		L'&lt;', },
	{ "&amp;ntilde;",	L'ñ', },
	{ "&amp;oacute;",	L'ó', },
	{ "&amp;ocirc;",	L'ô', },
	{ "&amp;ograve;",	L'ò', },
	{ "&amp;oslash;",	L'ø', },
	{ "&amp;otilde;",	L'õ', },
	{ "&amp;ouml;",	L'ö', },
	{ "&amp;szlig;",		L'ß', },
	{ "&amp;thorn;",	L'þ', },
	{ "&amp;uacute;",	L'ú', },
	{ "&amp;ucirc;",	L'û', },
	{ "&amp;ugrave;",	L'ù', },
	{ "&amp;uuml;",	L'ü', },
	{ "&amp;yacute;",	L'ý', },
	{ "&amp;yuml;",	L'ÿ', },
	{ "&amp;#161;",	L'¡', },
	{ "&amp;#162;",	L'¢', },
	{ "&amp;#163;",	L'£', },
	{ "&amp;#164;",	L'¤', },
	{ "&amp;#165;",	L'¥', },
	{ "&amp;#166;",	L'¦', },
	{ "&amp;#167;",	L'§', },
	{ "&amp;#168;",	L'¨', },
	{ "&amp;#169;",	L'©', },
	{ "&amp;#170;",	L'ª', },
	{ "&amp;#171;",	L'«', },
	{ "&amp;#172;",	L'¬', },
	{ "&amp;#173;",	L'­', },
	{ "&amp;#174;",	L'®', },
	{ "&amp;#175;",	L'¯', },
	{ "&amp;#176;",	L'°', },
	{ "&amp;#177;",	L'±', },
	{ "&amp;#178;",	L'²', },
	{ "&amp;#179;",	L'³', },
	{ "&amp;#180;",	L'´', },
	{ "&amp;#181;",	L'µ', },
	{ "&amp;#182;",	L'¶', },
	{ "&amp;#183;",	L'·', },
	{ "&amp;#184;",	L'¸', },
	{ "&amp;#185;",	L'¹', },
	{ "&amp;#186;",	L'º', },
	{ "&amp;#187;",	L'»', },
	{ "&amp;#188;",	L'¼', },
	{ "&amp;#189;",	L'½', },
	{ "&amp;#190;",	L'¾', },
	{ "&amp;#191;",	L'¿', },

	{ "*",			L'•', },
	{ "&amp;#164;",	L'□', },
	{ "&amp;#186;",	L'◊', },
	{ "(tm)",		L'™', },
	{"&amp;#913;",		L'Α',},
	{"&amp;#914;",		L'Β',},
	{"&amp;#915;",		L'Γ',},
	{"&amp;#916;",		L'Δ',},
	{"&amp;#917;",		L'Ε',},
	{"&amp;#918;",		L'Ζ',},
	{"&amp;#919;",		L'Η',},
	{"&amp;#920;",		L'Θ',},
	{"&amp;#921;",		L'Ι',},
	{"&amp;#922;",		L'Κ',},
	{"&amp;#923;",		L'Λ',},
	{"&amp;#924;",		L'Μ',},
	{"&amp;#925;",		L'Ν',},
	{"&amp;#926;",		L'Ξ',},
	{"&amp;#927;",		L'Ο',},
	{"&amp;#928;",		L'Π',},
	{"&amp;#929;",		L'Ρ',},
	{"&amp;#930;",		L'΢',},
	{"&amp;#931;",		L'Σ',},
	{"&amp;#932;",		L'Τ',},
	{"&amp;#933;",		L'Υ',},
	{"&amp;#934;",		L'Φ',},
	{"&amp;#935;",		L'Χ',},
	{"&amp;#936;",		L'Ψ',},
	{"&amp;#937;",		L'Ω',},
	{"&amp;#945;",		L'α',},
	{"&amp;#946;",		L'β',},
	{"&amp;#947;",		L'γ',},
	{"&amp;#948;",		L'δ',},
	{"&amp;#949;",		L'ε',},
	{"&amp;#950;",		L'ζ',},
	{"&amp;#951;",		L'η',},
	{"&amp;#952;",		L'θ',},
	{"&amp;#953;",		L'ι',},
	{"&amp;#954;",		L'κ',},
	{"&amp;#955;",		L'λ',},
	{"&amp;#956;",		L'μ',},
	{"&amp;#957;",		L'ν',},
	{"&amp;#958;",		L'ξ',},
	{"&amp;#959;",		L'ο',},
	{"&amp;#960;",		L'π',},
	{"&amp;#961;",		L'ρ',},
	{"&amp;#962;",		L'ς',},
	{"&amp;#963;",		L'σ',},
	{"&amp;#964;",		L'τ',},
	{"&amp;#965;",		L'υ',},
	{"&amp;#966;",		L'φ',},
	{"&amp;#967;",		L'χ',},
	{"&amp;#968;",		L'ψ',},
	{"&amp;#969;",		L'ω',},

	{ "&lt;-",		L'←', },
	{ "^",			L'↑', },
	{ "-&gt;",		L'→', },
	{ "v",			L'↓', },
	{ "!=",		L'≠', },
	{ "&lt;=",		L'≤', },
	{ "...",		L'⋯', },
	{"&amp;isin;",		L'∈', },

	{"&amp;#8211;",	L'–', },
	{"&amp;#8212;",	L'—', },

	{ "CYRILLIC XYZZY",	L'й', },
	{ "CYRILLIC XYZZY",	L'ъ', },
	{ "CYRILLIC Y",		L'ь', },
	{ "CYRILLIC YA",	L'я', },
	{ "CYRILLIC YA",	L'ё', },
	{ "&amp;#191;",		L'ℱ', },

	{ nil, 0 },
};

typedef struct Troffspec Troffspec;
struct Troffspec
{
	char *name;
	char *value;
};

Troffspec tspec[] =
{
	{ "A*", "&amp;Aring;", },
	{ "o\"", "&amp;ouml;", },
	{ "ff", "ff", },
	{ "fi", "fi", },
	{ "fl", "fl", },
	{ "Fi", "ffi", },
	{ "ru", "_", },
	{ "em", "&amp;#173;", },
	{ "14", "&amp;#188;", },
	{ "12", "&amp;#189;", },
	{ "co", "&amp;#169;", },
	{ "de", "&amp;#176;", },
	{ "dg", "&amp;#161;", },
	{ "fm", "&amp;#180;", },
	{ "rg", "&amp;#174;", },
	{ "bu", "*", },
	{ "sq", "&amp;#164;", },
	{ "hy", "-", },
	{ "pl", "+", },
	{ "mi", "-", },
	{ "mu", "&amp;#215;", },
	{ "di", "&amp;#247;", },
	{ "eq", "=", },
	{ "==", "==", },
	{ "&gt;=", "&gt;=", },
	{ "&lt;=", "&lt;=", },
	{ "!=", "!=", },
	{ "+-", "&amp;#177;", },
	{ "no", "&amp;#172;", },
	{ "sl", "/", },
	{ "ap", "&amp;", },
	{ "~=", "~=", },
	{ "pt", "oc", },
	{ "gr", "GRAD", },
	{ "-&gt;", "-&gt;", },
	{ "&lt;-", "&lt;-", },
	{ "ua", "^", },
	{ "da", "v", },
	{ "is", "Integral", },
	{ "pd", "DIV", },
	{ "if", "oo", },
	{ "sr", "-/", },
	{ "sb", "(~", },
	{ "sp", "~)", },
	{ "cu", "U", },
	{ "ca", "(^)", },
	{ "ib", "(=", },
	{ "ip", "=)", },
	{ "mo", "C", },
	{ "es", "&amp;Oslash;", },
	{ "aa", "&amp;#180;", },
	{ "ga", "`", },
	{ "ci", "O", },
	{ "L1", "DEATHSTAR", },
	{ "sc", "&amp;#167;", },
	{ "dd", "++", },
	{ "lh", "&lt;=", },
	{ "rh", "=&gt;", },
	{ "lt", "(", },
	{ "rt", ")", },
	{ "lc", "|", },
	{ "rc", "|", },
	{ "lb", "(", },
	{ "rb", ")", },
	{ "lf", "|", },
	{ "rf", "|", },
	{ "lk", "|", },
	{ "rk", "|", },
	{ "bv", "|", },
	{ "ts", "s", },
	{ "br", "|", },
	{ "or", "|", },
	{ "ul", "_", },
	{ "rn", " ", },
	{ "**", "*", },
	{ "tm", "&amp;#153", },
	{ nil, nil, },
};

typedef struct Font Font;
struct Font
{
	char	*start;
	char	*end;
};
Font bfont = { "&lt;B&gt;", "&lt;/B&gt;" };
Font ifont = { "&lt;I&gt;", "&lt;/I&gt;" };
Font bifont = { "&lt;B&gt;&lt;I&gt;", "&lt;/I&gt;&lt;/B&gt;" };
Font cwfont = { "&lt;TT&gt;", "&lt;/TT&gt;" };
Font *fstack[Maxfsp];
int fsp = -1;

typedef struct String String;
struct String
{
	String *next;
	char *name;
	char *val;
};
String *numregs, *strings;
char *strstack[Maxmstack];
char *mustfree[Maxmstack];
int strsp = -1;
int elsetop = -1;

typedef struct Mstack Mstack;
struct Mstack
{
	char *ptr;
	char *argv[Narg+1];
};
String *macros;
Mstack mstack[Maxmstack];
int msp = -1;

typedef struct Srcstack Srcstack;
struct Srcstack
{
	char	filename[256];
	int	fd;
	int	lno;
	int	rlno;
	Biobuf	in;
};
Srcstack sstack[Maxsstack];
Srcstack *ssp = &amp;sstack[-1];

char token[128];

void	closel(void);
void	closefont(void);

void*
emalloc(uint n)
{
	void *p;

	p = mallocz(n, 1);
	if(p == nil){
		fprint(2, "ms2html: malloc failed: %r\n");
		exits("malloc");
	}
	return p;
}


/* define a string variable */
void
dsnr(char *name, char *val, String **l)
{
	String *s;

	for(s = *l; s != nil; s = *l){
		if(strcmp(s-&gt;name, name) == 0)
			break;
		l = &amp;s-&gt;next;
	}
	if(s == nil){
		s = emalloc(sizeof(String));
		*l = s;
		s-&gt;name = strdup(name);
	} else
		free(s-&gt;val);
	s-&gt;val = strdup(val);
}

void
ds(char *name, char *val)
{
	dsnr(name, val, &amp;strings);
}

/* look up a defined string */
char*
getds(char *name)
{
	String *s;

	for(s = strings; s != nil; s = s-&gt;next)
		if(strcmp(name, s-&gt;name) == 0)
			break;
	if(s != nil)
		return s-&gt;val;
	return "";
}

char *
getnr(char *name)
{
	String *s;

	for(s = numregs; s != nil; s = s-&gt;next)
		if(strcmp(name, s-&gt;name) == 0)
			break;
	if(s != nil)
		return s-&gt;val;
	return "0";
}

void
pushstr(char *p)
{
	if(p == nil)
		return;
	if(strsp &gt;= Maxmstack - 1)
		return;
	strstack[++strsp] = p;
}


/* lookup a defined macro */
char*
getmacro(char *name)
{
	String *s;

	for(s = macros; s != nil; s = s-&gt;next)
		if(strcmp(name, s-&gt;name) == 0)
			return s-&gt;val;
	return nil;
}

enum
{
	Dstring,
	Macro,
	Input,
};
int lastsrc;

void
pushsrc(char *name)
{
	Dir *d;
	int fd;

	if(ssp == &amp;sstack[Maxsstack-1]){
		fprint(2, "ms2html: .so's too deep\n");
		return;
	}
	d = nil;
	if(name == nil){
		d = dirfstat(0);
		if(d == nil){
			fprint(2, "ms2html: can't stat %s: %r\n", name);
			return;
		}
		name = d-&gt;name;
		fd = 0;
	} else {
		fd = open(name, OREAD);
		if(fd &lt; 0){
			fprint(2, "ms2html: can't open %s: %r\n", name);
			return;
		}
	}
	ssp++;
	ssp-&gt;fd = fd;
	Binit(&amp;ssp-&gt;in, fd, OREAD);
	snprint(ssp-&gt;filename, sizeof(ssp-&gt;filename), "%s", name);
	ssp-&gt;lno = ssp-&gt;rlno = 1;
	free(d);
}

/* get next logical byte.  from stdin or a defined string */
int
getrune(void)
{
	int i;
	Rune r;
	int c;
	Mstack *m;

	while(strsp &gt;= 0){
		i = chartorune(&amp;r, strstack[strsp]);
		if(r != 0){
			strstack[strsp] += i;
			lastsrc = Dstring;
			return r;
		}
		if (mustfree[strsp]) {
			free(mustfree[strsp]);
			mustfree[strsp] = nil;
		}
		strsp--;
 	}
	while(msp &gt;= 0){
		m = &amp;mstack[msp];
		i = chartorune(&amp;r, m-&gt;ptr);
		if(r != 0){
			m-&gt;ptr += i;
			lastsrc = Macro;
			return r;
		}
		for(i = 0; m-&gt;argv[i] != nil; i++)
			free(m-&gt;argv[i]);
		msp--;
 	}

	lastsrc = Input;
	for(;;) {
		if(ssp &lt; sstack)
			return -1;
		c = Bgetrune(&amp;ssp-&gt;in);
		if(c &gt;= 0){
			r = c;
			break;
		}
		close(ssp-&gt;fd);
		ssp--;
	}

	return r;
}

void
ungetrune(void)
{
	switch(lastsrc){
	case Dstring:
		if(strsp &gt;= 0)
			strstack[strsp]--;
		break;
	case Macro:
		if(msp &gt;= 0)
			mstack[msp].ptr--;
		break;
	case Input:
		if(ssp &gt;= sstack)
			Bungetrune(&amp;ssp-&gt;in);
		break;
	}
}

int vert;

char*
changefont(Font *f)
{
	token[0] = 0;
	if(fsp == Maxfsp)
		return token;
	if(fsp &gt;= 0 &amp;&amp; fstack[fsp])
		strcpy(token, fstack[fsp]-&gt;end);
	if(f != nil)
		strcat(token, f-&gt;start);
	fstack[++fsp] = f;
	return token;
}

char*
changebackfont(void)
{
	token[0] = 0;
	if(fsp &gt;= 0){
		if(fstack[fsp])
			strcpy(token, fstack[fsp]-&gt;end);
		fsp--;
	}
	if(fsp &gt;= 0 &amp;&amp; fstack[fsp])
		strcat(token, fstack[fsp]-&gt;start);
	return token;
}

char*
changesize(int amount)
{
	static int curamount;
	static char buf[200];
	int i;

	buf[0] = 0;
	if (curamount &gt;= 0)
		for (i = 0; i &lt; curamount; i++)
			strcat(buf, "&lt;/big&gt;");
	else
		for (i = 0; i &lt; -curamount; i++)
			strcat(buf, "&lt;/small&gt;");
	curamount = 0;
	if (amount &gt;= 0)
		for (i = 0; i &lt; amount; i++)
			strcat(buf, "&lt;big&gt;");
	else
		for (i = 0; i &lt; -amount; i++)
			strcat(buf, "&lt;small&gt;");
	curamount = amount;
	return buf;
}

/* get next logical character.  expand it with escapes */
char*
getnext(void)
{
	int r;
	Entity *e;
	Troffspec *t;
	Rune R;
	char str[4];
	static char buf[8];

	r = getrune();
	if(r &lt; 0)
		return nil;
	if(r &gt; 128 || r == '&lt;' || r == '&gt;'){
		for(e = entity; e-&gt;name; e++)
			if(e-&gt;value == r)
				return e-&gt;name;
		sprint(buf, "&amp;#%d;", r);
		return buf;
	}

	if (r == delim[eqnmode]){
		if (eqnmode == 0){
			eqnmode = 1;
			return changefont(&amp;ifont);
		}
		eqnmode = 0;
		return changebackfont();
	}
	switch(r){
	case '\\':
		r = getrune();
		if(r &lt; 0)
			return nil;
		switch(r){
		case ' ':
			return " ";

		/* chars to ignore */
		case '&amp;':
		case '|':
		case '%':
			return "";

		/* small space in troff, nothing in nroff */
		case '^':
			return getnext();

		/* ignore arg */
		case 'k':
			getrune();
			return getnext();

		/* comment */
		case '"':
			while(getrune() != '\n')
				;
			return "\n";
		/* ignore line */
		case '!':
			while(getrune() != '\n')
				;
			ungetrune();
			return getnext();

		/* defined strings */
		case '*':
			r = getrune();
			if(r == '('){
				str[0] = getrune();
				str[1] = getrune();
				str[2] = 0;
			} else {
				str[0] = r;
				str[1] = 0;
			}
			pushstr(getds(str));
			return getnext();

		/* macro args */
		case '$':
			r = getrune();
			if(r &lt; '1' || r &gt; '9'){
				token[0] = '\\';
				token[1] = '$';
				token[2] = r;
				token[3] = 0;
				return token;
			}
			r -= '0';
			if(msp &gt;= 0) 
				pushstr(mstack[msp].argv[r]);
			return getnext();

		/* special chars */
		case '(':
			token[0] = getrune();
			token[1] = getrune();
			token[2] = 0;
			for(t = tspec; t-&gt;name; t++)
				if(strcmp(token, t-&gt;name) == 0)
					return t-&gt;value;
			return "&amp;#191;";

		/* ignore immediately following newline */
		case 'c':
			r = getrune();
			if (r == '\n') {
				sol = ignore_nl = 1;
				if (indirective)
					break;
				}
			else
				ungetrune();
			return getnext();

		/* escape backslash */
		case 'e':
			return "\\";

		/* font change */
		case 'f':
			r = getrune();
			switch(r){
			case '(':
				str[0] = getrune();
				str[1] = getrune();
				str[2] = 0;
				token[0] = 0;
				if(strcmp("BI", str) == 0)
					return changefont(&amp;bifont);
				else if(strcmp("CW", str) == 0)
					return changefont(&amp;cwfont);
				else
					return changefont(nil);
			case '3':
			case 'B':
				return changefont(&amp;bfont);
			case '2':
			case 'I':
				return changefont(&amp;ifont);
			case '4':
				return changefont(&amp;bifont);
			case '5':
				return changefont(&amp;cwfont);
			case 'P':
				return changebackfont();
			case 'R':
			default:
				return changefont(nil);
			}

		/* number register */
		case 'n':
			r = getrune();
			if (r == '(') /*)*/ {
				r = getrune();
				if (r &lt; 0)
					return nil;
				str[0] = r;
				r = getrune();
				if (r &lt; 0)
					return nil;
				str[1] = r;
				str[2] = 0;
				}
			else {
				str[0] = r;
				str[1] = 0;
				}
			pushstr(getnr(str));
			return getnext();

		/* font size */
		case 's':
			r = getrune();
			switch(r){
			case '0':
				return changesize(0);
			case '-':
				r = getrune();
				if (!isdigit(r))
					return getnext();
				return changesize(-(r - '0'));
			case '+':
				r = getrune();
				if (!isdigit(r))
					return getnext();
				return changesize(r - '0');
			}
			return getnext();
		/* vertical movement */
		case 'v':
			r = getrune();
			if(r != '\''){
				ungetrune();
				return getnext();
			}
			r = getrune();
			if(r != '-')
				vert--;
			else
				vert++;
			while(r != '\'' &amp;&amp; r != '\n')
				r = getrune();
			if(r != '\'')
				ungetrune();
			
			if(vert &gt; 0)
				return "^";
			return getnext();
			

		/* horizontal line */
		case 'l':
			r = getrune();
			if(r != '\''){
				ungetrune();
				return "&lt;HR&gt;";
			}
			while(getrune() != '\'')
				;
			return "&lt;HR&gt;";

		/* character height and slant */
		case 'S':
		case 'H':
			r = getrune();
			if(r != '\''){
				ungetrune();
				return "&lt;HR&gt;";
			}
			while(getrune() != '\'')
				;
			return getnext();

		/* digit-width space */
		case '0':
			return " ";

		/*for .if, .ie, .el */
		case '{':
			return "\\{"; /*}*/
		case '}':
			return "";
		/* up and down */
		case 'u':
			if (isdown) {
				isdown = 0;
				return "&lt;/sub&gt;";
			}
			isup = 1;
			return "&lt;sup&gt;";
		case 'd':
			if (isup) {
				isup = 0;
				return "&lt;/sup&gt;";
			}
			isdown = 1;
			return "&lt;sub&gt;";
		}
		break;
	case '&amp;':
		if(msp &gt;= 0 || strsp &gt;= 0)
			return "&amp;";
		return "&amp;amp;";
	case '&lt;':
		if(msp &gt;= 0 || strsp &gt;= 0)
			return "&lt;";
		return "&amp;#60;";
	case '&gt;':
		if(msp &gt;= 0 || strsp &gt;= 0)
			return "&gt;";
		return "&amp;#62;";
	}
	if (r &lt; Runeself) {
		token[0] = r;
		token[1] = 0;
		}
	else {
		R = r;
		token[runetochar(token,&amp;R)] = 0;
	}
	return token;
}

/* if arg0 is set, read up to (and expand) to the next whitespace, else to the end of line */
char*
copyline(char *p, char *e, int arg0)
{
	int c;
	Rune r;
	char *p1;

	while((c = getrune()) == ' ' || c == '\t')
		;
	for(indirective = 1; p &lt; e; c = getrune()) {
		if (c &lt; 0)
			goto done;
		switch(c) {
		case '\\':
			break;
		case '\n':
			if (arg0)
				ungetrune();
			goto done;
		case ' ':
		case '\t':
			if (arg0)
				goto done;
		default:
			r = c;
			p += runetochar(p,&amp;r);
			continue;
		}
		ungetrune();
		p1 = getnext();
		if (p1 == nil)
			goto done;
		if (*p1 == '\n') {
			if (arg0)
				ungetrune();
			break;
		}
		while((*p = *p1++) &amp;&amp; p &lt; e)
			p++;
	}
done:
	indirective = 0;
	*p++ = 0;
	return p;
}

char*
copyarg(char *p, char *e, int *nullarg)
{
	int c, quoted, last;
	Rune r;

	*nullarg = 0;
	quoted = 0;
	do{
		c = getrune();
	} while(c == ' ' || c == '\t');

	if(c == '"'){
		quoted = 1;
		*nullarg = 1;
		c = getrune();
	}

	if(c == '\n')
		goto done;

	last = 0;
	for(; p &lt; e; c = getrune()) {
		if (c &lt; 0)
			break;
		switch(c) {
		case '\n':
			ungetrune();
			goto done;
		case '\\':
			r = c;
			p += runetochar(p,&amp;r);
			if(last == '\\')
				r = 0;
			break;
		case ' ':
		case '\t':
			if(!quoted &amp;&amp; last != '\\')
				goto done;
			r = c;
			p += runetochar(p,&amp;r);
			break;
		case '"':
			if(quoted &amp;&amp; last != '\\')
				goto done;
			r = c;
			p += runetochar(p,&amp;r);
			break;
		default:
			r = c;
			p += runetochar(p,&amp;r);
			break;
		}
		last = r;
	}
done:
	*p++ = 0;
	return p;

}

int
parseargs(char *p, char *e, char **argv)
{
	int argc;
	char *np;
	int nullarg;

	indirective = 1;
	*p++ = 0;
	for(argc = 1; argc &lt; Narg; argc++){
		np = copyarg(p, e, &amp;nullarg);
		if(nullarg==0 &amp;&amp; np == p+1)
			break;
		argv[argc] = p;
		p = np;
	}
	argv[argc] = nil;
	indirective = 0;


	return argc;
}

void
dodirective(void)
{
	char *p, *e;
	Goobie *g;
	Goobieif *gif;
	char line[Nline], *line1;
	int i, argc;
	char *argv[Narg];
	Mstack *m;

	/* read line, translate special bytes */
	e = line + sizeof(line) - UTFmax - 1;
	line1 = copyline(line, e, 1);
	if (!line[0])
		return;
	argv[0] = line;

	/* first look through user defined macros */
	p = getmacro(argv[0]);
	if(p != nil){
		if(msp == Maxmstack-1){
			fprint(2, "ms2html: macro stack overflow\n");
			return;
		}
		argc = parseargs(line1, e, argv);
		m = &amp;mstack[++msp];
		m-&gt;ptr = p;
		memset(m-&gt;argv, 0, sizeof(m-&gt;argv));
		for(i = 0; i &lt; argc; i++)
			m-&gt;argv[i] = strdup(argv[i]);
		return;
	}

	/* check for .if or .ie */
	for(gif = gtabif; gif-&gt;name; gif++)
		if(strcmp(gif-&gt;name, argv[0]) == 0){
			(*gif-&gt;f)(line1, e);
			return;
		}

	argc = parseargs(line1, e, argv);

	/* try standard ms macros */
	for(g = gtab; g-&gt;name; g++)
		if(strcmp(g-&gt;name, argv[0]) == 0){
			(*g-&gt;f)(argc, argv);
			return;
		}

	if(debug)
		fprint(2, "stdin %d(%s:%d): unknown directive %s\n",
			ssp-&gt;lno, ssp-&gt;filename, ssp-&gt;rlno, line);
}

void
printarg(char *a)
{
	char *e, *p;
	
	e = a + strlen(a);
	pushstr(a);
	while(strsp &gt;= 0 &amp;&amp; strstack[strsp] &gt;= a &amp;&amp; strstack[strsp] &lt; e){
		p = getnext();
		if(p == nil)
			return;
		Bprint(&amp;bout, "%s", p);
	}
}

void
printargs(int argc, char **argv)
{
	argc--;
	argv++;
	while(--argc &gt; 0){
		printarg(*argv++);
		Bprint(&amp;bout, " ");
	}
	if(argc == 0)
		printarg(*argv);
}

void
dohangingdt(void)
{
	switch(hangingdt){
	case 3:
		hangingdt--;
		break;
	case 2:
		Bprint(&amp;bout, "&lt;dd&gt;");
		hangingdt = 0;
		break;
	}

}

void
dohangingau(void)
{
	if(hangingau == 0)
		return;
	Bprint(&amp;bout, "&lt;/I&gt;&lt;/DL&gt;\n");
	hangingau = 0;
}

void
dohanginghead(void)
{
	if(hanginghead == 0)
		return;
	Bprint(&amp;bout, "&lt;/H%d&gt;\n", hanginghead);
	hanginghead = 0;
}

/*
 *  convert a man page to html and output
 */
void
doconvert(void)
{
	char c, *p;
	Tm *t;

	pushsrc(nil);

	sol = 1;
	Bprint(&amp;bout, "&lt;html&gt;\n");
	Bflush(&amp;bout);
	for(;;){
		p = getnext();
		if(p == nil)
			break;
		c = *p;
		if(c == '.' &amp;&amp; sol){
			dodirective();
			dohangingdt();
			ssp-&gt;lno++;
			ssp-&gt;rlno++;
			sol = 1;
		} else if(c == '\n'){
			if (ignore_nl)
				ignore_nl = 0;
			else {
				if(hangingau)
					Bprint(&amp;bout, "&lt;br&gt;\n");
				else
					Bprint(&amp;bout, "%s", p);
				dohangingdt();
				}
			ssp-&gt;lno++;
			ssp-&gt;rlno++;
			sol = 1;
		} else{
			Bprint(&amp;bout, "%s", p);
			ignore_nl = sol = 0;
		}
	}
	dohanginghead();
	dohangingdt();
	closel();
	if(fsp &gt;= 0 &amp;&amp; fstack[fsp])
		Bprint(&amp;bout, "%s", fstack[fsp]-&gt;end);
	Bprint(&amp;bout, "&lt;br&gt;&amp;#32;&lt;br&gt;\n");
	Bprint(&amp;bout, "&lt;A href=http://www.lucent.com/copyright.html&gt;\n");
	t = localtime(time(nil));
	Bprint(&amp;bout, "Copyright&lt;/A&gt; &amp;#169; %d Alcatel-Lucent Inc.  All rights reserved.\n",
			t-&gt;year+1900);
	Bprint(&amp;bout, "&lt;/body&gt;&lt;/html&gt;\n");
}

static void
usage(void)
{
	sysfatal("usage: ms2html [-q] [-b basename] [-d '$$'] [-t title]");
}

void
main(int argc, char **argv)
{
	quiet = 1;
	ARGBEGIN {
	case 't':
		title = EARGF(usage());
		break;
	case 'b':
		basename = EARGF(usage());
		break;
	case 'q':
		quiet = 0;
		break;
	case 'd':
		delim = EARGF(usage());
		break;
	case '?':
	default:
		usage();
	} ARGEND;

	Binit(&amp;bout, 1, OWRITE);

	ds("R", "&amp;#174;");

	doconvert();
	exits(nil);
}

void
g_notyet(int, char **argv)
{
	fprint(2, "ms2html: .%s not yet supported\n", argv[0]);
}

void
g_ignore(int, char **argv)
{
	if(quiet)
		return;
	fprint(2, "ms2html: line %d: ignoring .%s\n", ssp-&gt;lno, argv[0]);
}

void
g_PP(int, char**)
{
	dohanginghead();
	closel();
	closefont();
	Bprint(&amp;bout, "&lt;P&gt;\n");
	paragraph = 1;
}

void
g_LP(int, char**)
{
	dohanginghead();
	closel();
	closefont();
	Bprint(&amp;bout, "&lt;br&gt;&amp;#32;&lt;br&gt;\n");
}

/* close a list */
void
closel(void)
{
	g_P2(1, nil);
	dohangingau();
	if(paragraph){
		Bprint(&amp;bout, "&lt;/P&gt;\n");
		paragraph = 0;
	}
	switch(list){
	case Lordered:
		Bprint(&amp;bout, "&lt;/ol&gt;\n");
		break;
	case Lunordered:
		Bprint(&amp;bout, "&lt;/ul&gt;\n");
		break;
	case Lother:
	case Ldef:
		Bprint(&amp;bout, "&lt;/dl&gt;\n");
		break;
	}
	list = 0;
	
}


void
g_IP(int argc, char **argv)
{
	dohanginghead();
	switch(list){
	default:
		closel();
		if(argc &gt; 1){
			if(strcmp(argv[1], "1") == 0){
				list = Lordered;
				listnum = 1;
				Bprint(&amp;bout, "&lt;OL&gt;\n");
			} else if(strcmp(argv[1], "\\(bu") == 0){
				list = Lunordered;
				Bprint(&amp;bout, "&lt;UL&gt;\n");
			} else {
				list = Lother;
				Bprint(&amp;bout, "&lt;DL COMPACT&gt;\n");
			}
		} else {
			list = Lother;
			Bprint(&amp;bout, "&lt;DL&gt;\n");
		}
		break;
	case Lother:
	case Lordered:
	case Lunordered:
		break;
	}

	switch(list){
	case Lother:
		Bprint(&amp;bout, "&lt;DT&gt;");
		if(argc &gt; 1)
			printarg(argv[1]);
		else
			Bprint(&amp;bout, "&lt;DT&gt;&amp;#32;");
		Bprint(&amp;bout, "&lt;DD&gt;\n");
		break;
	case Lordered:
	case Lunordered:
		Bprint(&amp;bout, "&lt;LI&gt;\n");
		break;
	}
}

/*
 *  .5i is one &lt;DL&gt;&lt;DT&gt;&lt;DD&gt;
 */
void
g_in(int argc, char **argv)
{
	float	f;
	int	delta, x;
	char	*p;

	f = indent/0.5;
	delta = f;
	if(argc &lt;= 1){
		indent = 0.0;
	} else {
		f = strtod(argv[1], &amp;p);
		switch(*p){
		case 'i':
			break;
		case 'c':
			f = f / 2.54;
			break;
		case 'P':
			f = f / 6;
			break;
		default:
		case 'u':
		case 'm':
			f = f * (12 / 72);
			break;
		case 'n':
			f = f * (6 / 72);
			break;
		case 'p':
			f = f / 72.0;
			break;
		}
		switch(argv[1][0]){
		case '+':
		case '-':
			indent += f;
			break;
		default:
			indent = f;
			break;
		}
	}
	if(indent &lt; 0.0)
		indent = 0.0;
	f = (indent/0.5);
	x = f;
	delta = x - delta;
	while(delta &lt; 0){
		Bprint(&amp;bout, "&lt;/DL&gt;\n");
		delta++;
	}
	while(delta &gt; 0){
		Bprint(&amp;bout, "&lt;DL&gt;&lt;DT&gt;&lt;DD&gt;\n");
		delta--;
	}
}

void
g_HP(int, char**)
{
	switch(list){
	default:
		closel();
		list = Ldef;
		hangingdt = 1;
		Bprint(&amp;bout, "&lt;DL&gt;&lt;DT&gt;\n");
		break;
	case Ldef:
		if(hangingdt)
			Bprint(&amp;bout, "&lt;DD&gt;");
		Bprint(&amp;bout, "&lt;DT&gt;");
		hangingdt = 1;
		break;
	}
}

void
g_SH(int, char**)
{
	dohanginghead();
	dohangingcenter();
	closel();
	closefont();
	Bprint(&amp;bout, "&lt;H%d&gt;", HH);
	hanginghead = HH;
}

void
g_NH(int argc, char **argv)
{
	int i, level;

	closel();
	closefont();

	dohanginghead();
	dohangingcenter();
	if(argc == 1)
		level = 0;
	else {
		level = atoi(argv[1])-1;
		if(level &lt; 0 || level &gt;= Maxnh)
			level = Maxnh - 1;
	}
	nh[level]++;

	Bprint(&amp;bout, "&lt;H%d&gt;", HH);
	hanginghead = HH;

	Bprint(&amp;bout, "%d", nh[0]);
	for(i = 1; i &lt;= level; i++)
		Bprint(&amp;bout, ".%d", nh[i]);
	Bprint(&amp;bout, " ");

	for(i = level+1; i &lt; Maxnh; i++)
		nh[i] = 0;
}

void
g_TL(int, char**)
{
	char *p, *np;
	char name[128];

	closefont();

	if(!titleseen){
		if(!title){
			/* get base part of filename */
			p = strrchr(ssp-&gt;filename, '/');
			if(p == nil)
				p = ssp-&gt;filename;
			else
				p++;
			strncpy(name, p, sizeof(name));
			name[sizeof(name)-1] = 0;
		
			/* dump any extensions */
			np = strchr(name, '.');
			if(np)
				*np = 0;
			title = p;
		}
		Bprint(&amp;bout, "&lt;title&gt;\n");
		Bprint(&amp;bout, "%s\n", title);
		Bprint(&amp;bout, "&lt;/title&gt;\n");
		Bprint(&amp;bout, "&lt;body BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#330088\" ALINK=\"#FF0044\"&gt;\n");
		titleseen = 1;
	}

	Bprint(&amp;bout, "&lt;center&gt;");
	hangingcenter = 1;
	Bprint(&amp;bout, "&lt;H%d&gt;", 1);
	hanginghead = 1;
}

void
dohangingcenter(void)
{
	if(hangingcenter){
		Bprint(&amp;bout, "&lt;/center&gt;");
		hangingcenter = 1;
	}
}

void
g_AU(int, char**)
{
	closel();
	dohanginghead();
	Bprint(&amp;bout, "&lt;DL&gt;&lt;DD&gt;&lt;I&gt;");
	hangingau = 1;
}

void
pushfont(Font *f)
{
	if(fsp == Maxfsp)
		return;
	if(fsp &gt;= 0 &amp;&amp; fstack[fsp])
		Bprint(&amp;bout, "%s", fstack[fsp]-&gt;end);
	if(f != nil)
		Bprint(&amp;bout, "%s", f-&gt;start);
	fstack[++fsp] = f;
}

void
popfont(void)
{
	if(fsp &gt;= 0){
		if(fstack[fsp])
			Bprint(&amp;bout, "%s", fstack[fsp]-&gt;end);
		fsp--;
	}
}

/*
 *  for 3 args print arg3 \fxarg1\fP arg2
 *  for 2 args print arg1 \fxarg2\fP
 *  for 1 args print \fxarg1\fP
 */
void
font(Font *f, int argc, char **argv)
{
	if(argc == 1){
		pushfont(nil);
		return;
	}
	if(argc &gt; 3)
		printarg(argv[3]);
	pushfont(f);
	printarg(argv[1]);
	popfont();
	if(argc &gt; 2)
		printarg(argv[2]);
	Bprint(&amp;bout, "\n");
}

void
closefont(void)
{
	if(fsp &gt;= 0 &amp;&amp; fstack[fsp])
		Bprint(&amp;bout, "%s", fstack[fsp]-&gt;end);
	fsp = -1;
}

void
g_B(int argc, char **argv)
{
	font(&amp;bfont, argc, argv);
}

void
g_R(int argc, char **argv)
{
	font(nil, argc, argv);
}

void
g_BI(int argc, char **argv)
{
	font(&amp;bifont, argc, argv);
}

void
g_CW(int argc, char **argv)
{
	font(&amp;cwfont, argc, argv);
}

char*
lower(char *p)
{
	char *x;

	for(x = p; *x; x++)
		if(*x &gt;= 'A' &amp;&amp; *x &lt;= 'Z')
			*x -= 'A' - 'a';
	return p;
}

void
g_I(int argc, char **argv)
{
	int anchor;
	char *p;

	anchor = 0;
	if(argc &gt; 2){
		p = argv[2];
		if(p[0] == '(')
		if(p[1] &gt;= '0' &amp;&amp; p[1] &lt;= '9')
		if(p[2] == ')'){
			anchor = 1;
			Bprint(&amp;bout, "&lt;A href=\"/magic/man2html/%c/%s\"&gt;",
				p[1], lower(argv[1]));
		}
	}
	font(&amp;ifont, argc, argv);
	if(anchor)
		Bprint(&amp;bout, "&lt;/A&gt;");
}

void
g_br(int, char**)
{
	if(hangingdt){
		Bprint(&amp;bout, "&lt;dd&gt;");
		hangingdt = 0;
	}else
		Bprint(&amp;bout, "&lt;br&gt;\n");
}

void
g_P1(int, char**)
{
	if(example == 0){
		example = 1;
		Bprint(&amp;bout, "&lt;DL&gt;&lt;DT&gt;&lt;DD&gt;&lt;TT&gt;&lt;PRE&gt;\n");
	}
}

void
g_P2(int, char**)
{
	if(example){
		example = 0;
		Bprint(&amp;bout, "&lt;/PRE&gt;&lt;/TT&gt;&lt;/DL&gt;\n");
	}
}

void
g_SM(int, char **argv)
{
	Bprint(&amp;bout, "%s", argv[1]);
}

void
g_ft(int argc, char **argv)
{
	if(argc &lt; 2){
		pushfont(nil);
		return;
	}

	switch(argv[1][0]){
	case '3':
	case 'B':
		pushfont(&amp;bfont);
		break;
	case '2':
	case 'I':
		pushfont(&amp;ifont);
		break;
	case '4':
		pushfont(&amp;bifont);
		break;
	case '5':
		pushfont(&amp;cwfont);
		break;
	case 'P':
		popfont();
		break;
	case 'R':
	default:
		pushfont(nil);
		break;
	}
}

void
g_sp(int argc, char **argv)
{
	int n;

	n = 1;
	if(argc &gt; 1){
		n = atoi(argv[1]);
		if(n &lt; 1)
			n = 1;
		if(argv[1][strlen(argv[1])-1] == 'i')
			n *= 4;
	}
	if(n &gt; 5){
		Bprint(&amp;bout, "&lt;br&gt;&amp;#32;&lt;br&gt;\n");
		Bprint(&amp;bout, "&lt;HR&gt;\n");
		Bprint(&amp;bout, "&lt;br&gt;&amp;#32;&lt;br&gt;\n");
	} else
		for(; n &gt; 0; n--)
			Bprint(&amp;bout, "&lt;br&gt;&amp;#32;&lt;br&gt;\n");
}

 void
rm_loop(char *name, String **l)
{
	String *s;
	for(s = *l; s != nil; s = *l){
		if(strcmp(name, s-&gt;name) == 0){
			*l = s-&gt;next;
			free(s-&gt;name);
			free(s-&gt;val);
			free(s);
			break;
			}
		l = &amp;s-&gt;next;
		}
	}

void
g_rm(int argc, char **argv)
{
	Goobie *g;
	char *name;
	int i;

	for(i = 1; i &lt; argc; i++) {
		name = argv[i];
		rm_loop(name, &amp;strings);
		rm_loop(name, &amp;macros);
		for(g = gtab; g-&gt;name; g++)
			if (strcmp(g-&gt;name, name) == 0) {
				g-&gt;f = g_ignore;
				break;
				}
		}
	}

void
g_AB(int, char**)
{
	closel();
	dohangingcenter();
	Bprint(&amp;bout, "&lt;center&gt;&lt;H4&gt;ABSTRACT&lt;/H4&gt;&lt;/center&gt;&lt;DL&gt;&lt;DD&gt;\n");
}

void
g_AE(int, char**)
{
	Bprint(&amp;bout, "&lt;/DL&gt;\n");
}

void
g_FS(int, char **)
{
	char *argv[3];

	argv[0] = "IP";
	argv[1] = nil;
	argv[2] = nil;
	g_IP(1, argv);
	Bprint(&amp;bout, "NOTE:&lt;I&gt; ");
}

void
g_FE(int, char **)
{
	Bprint(&amp;bout, "&lt;/I&gt;&lt;DT&gt;&amp;#32;&lt;DD&gt;");
	closel();
	Bprint(&amp;bout, "&lt;br&gt;\n");
}

void
g_de(int argc, char **argv)
{
	int r;
	char *p, *cp;
	String *m;
	int len;

	if(argc &lt; 2)
		return;

	m = nil;
	len = 0;
	if(strcmp(argv[0], "am") == 0){
		for(m = macros; m != nil; m = m-&gt;next)
			if(strcmp(argv[1], m-&gt;name) == 0){
				len = strlen(m-&gt;val);
				break;
			}

		if(m == nil){
			/* nothing to append to */
			for(;;){
				p = Brdline(&amp;ssp-&gt;in, '\n');
				if(p == nil)
					break;
				p[Blinelen(&amp;ssp-&gt;in)-1] = 0;
				if(strcmp(p, "..") == 0)
					break;
			}
			return;
		}
	}

	if(m == nil){
		m = emalloc(sizeof(*m));
		m-&gt;next = macros;
		macros = m;
		m-&gt;name = strdup(argv[1]);
		m-&gt;val = nil;
		len = 0;
	}

	/* read up to a .. removing double backslashes */
	for(;;){
		p = Brdline(&amp;ssp-&gt;in, '\n');
		if(p == nil)
			break;
		p[Blinelen(&amp;ssp-&gt;in)-1] = 0;
		if(strcmp(p, "..") == 0)
			break;
		m-&gt;val = realloc(m-&gt;val, len + Blinelen(&amp;ssp-&gt;in)+1);
		cp = m-&gt;val + len;
		while(*p){
			r = *p++;
			if(r == '\\' &amp;&amp; *p == '\\')
				p++;
			*cp++ = r;
		}
		*cp++ = '\n';
		len = cp - m-&gt;val;
		*cp = 0;
	}
}

void
g_hrule(int, char**)
{
	Bprint(&amp;bout, "&lt;HR&gt;\n");
}

void
g_BX(int argc, char **argv)
{
	Bprint(&amp;bout, "&lt;HR&gt;\n");
	printargs(argc, argv);
	Bprint(&amp;bout, "&lt;HR&gt;\n");
}

void
g_IH(int, char**)
{
	Bprint(&amp;bout, "Bell Laboratories, Naperville, Illinois, 60540\n");
}

void
g_MH(int, char**)
{
	Bprint(&amp;bout, "Bell Laboratories, Murray Hill, NJ, 07974\n");
}

void
g_PY(int, char**)
{
	Bprint(&amp;bout, "Bell Laboratories, Piscataway, NJ, 08854\n");
}

void
g_HO(int, char**)
{
	Bprint(&amp;bout, "Bell Laboratories, Holmdel, NJ, 07733\n");
}

void
g_QS(int, char**)
{
	Bprint(&amp;bout, "&lt;BLOCKQUOTE&gt;\n");
}

void
g_QE(int, char**)
{
	Bprint(&amp;bout, "&lt;/BLOCKQUOTE&gt;\n");
}

void
g_RS(int, char**)
{
	Bprint(&amp;bout, "&lt;DL&gt;&lt;DD&gt;\n");
}

void
g_RE(int, char**)
{
	Bprint(&amp;bout, "&lt;/DL&gt;\n");
}

int gif;

void
g_startgif(int, char **argv)
{
	int fd;
	int pfd[2];
	char *e, *p;
	char name[32];
	Dir *d;

	if(strcmp(argv[0], "EQ") == 0)
		e = ".EN";
	else if(strcmp(argv[0], "TS") == 0)
		e = ".TE";
	else if(strcmp(argv[0], "PS") == 0)
		e = ".PE";
	else
		return;

	if(basename)
		p = basename;
	else{
		p = strrchr(sstack[0].filename, '/');
		if(p != nil)
			p++;
		else
			p = sstack[0].filename;
	}
	snprint(name, sizeof(name), "%s.%d.gif", p, gif++);
	fd = create(name, OWRITE, 0664);
	if(fd &lt; 0){
		fprint(2, "ms2html: can't create %s: %r\n", name);
		return;
	}

	if(pipe(pfd) &lt; 0){
		fprint(2, "ms2html: can't create pipe: %r\n");
		close(fd);
		return;
	}
	switch(rfork(RFFDG|RFPROC)){
	case -1:
		fprint(2, "ms2html: can't fork: %r\n");
		close(fd);
		return;
	case 0:
		dup(fd, 1);
		close(fd);
		dup(pfd[0], 0);
		close(pfd[0]);
		close(pfd[1]);
		execl("/bin/troff2gif", "troff2gif", nil);
		fprint(2, "ms2html: couldn't exec troff2gif: %r\n");
		_exits(nil);
	default:
		close(fd);
		close(pfd[0]);
		fprint(pfd[1], ".ll 7i\n");
	/*	fprint(pfd[1], ".EQ\ndelim %s\n.EN\n", delim); */
	/*	fprint(pfd[1], ".%s\n", argv[0]); */
		for(;;){
			p = Brdline(&amp;ssp-&gt;in, '\n');
			if(p == nil)
				break;
			ssp-&gt;lno++;
			ssp-&gt;rlno++;
			if(write(pfd[1], p, Blinelen(&amp;ssp-&gt;in)) &lt; 0)
				break;
			if(strncmp(p, e, 3) == 0)
				break;
		}
		close(pfd[1]);
		waitpid();
		d = dirstat(name);
		if(d == nil)
			break;
		if(d-&gt;length == 0){
			remove(name);
			free(d);
			break;
		}
		free(d);
		fprint(2, "ms2html: created auxiliary file %s\n", name);
		Bprint(&amp;bout, "&lt;br&gt;&lt;img src=\"%s\"&gt;&lt;br&gt;\n", name);
		break;
	}
}

void
g_lf(int argc, char **argv)
{
	if(argc &gt; 2)
		snprint(ssp-&gt;filename, sizeof(ssp-&gt;filename), argv[2]);
	if(argc &gt; 1)
		ssp-&gt;rlno = atoi(argv[1]);
}

void
g_so(int argc, char **argv)
{
	ssp-&gt;lno++;
	ssp-&gt;rlno++;
	if(argc &gt; 1)
		pushsrc(argv[1]);
}


void
g_BP(int argc, char **argv)
{
	int fd;
	char *p, *ext;
	char name[32];
	Dir *d;

	if(argc &lt; 2)
		return;

	p = strrchr(argv[1], '/');
	if(p != nil)
		p++;
	else
		p = argv[1];


	ext = strrchr(p, '.');
	if(ext){
		if(strcmp(ext, ".jpeg") == 0
		|| strcmp(ext, ".gif") == 0){
			Bprint(&amp;bout, "&lt;br&gt;&lt;img src=\"%s\"&gt;&lt;br&gt;\n", argv[1]);
			return;
		}
	}


	snprint(name, sizeof(name), "%s.%d%d.gif", p, getpid(), gif++);
	fd = create(name, OWRITE, 0664);
	if(fd &lt; 0){
		fprint(2, "ms2html: can't create %s: %r\n", name);
		return;
	}

	switch(rfork(RFFDG|RFPROC)){
	case -1:
		fprint(2, "ms2html: can't fork: %r\n");
		close(fd);
		return;
	case 0:
		dup(fd, 1);
		close(fd);
		execl("/bin/ps2gif", "ps2gif", argv[1], nil);
		fprint(2, "ms2html: couldn't exec ps2gif: %r\n");
		_exits(nil);
	default:
		close(fd);
		waitpid();
		d = dirstat(name);
		if(d == nil)
			break;
		if(d-&gt;length == 0){
			remove(name);
			free(d);
			break;
		}
		free(d);
		fprint(2, "ms2html: created auxiliary file %s\n", name);
		Bprint(&amp;bout, "&lt;br&gt;&lt;img src=\"%s\"&gt;&lt;br&gt;\n", name);
		break;
	}
}

/* insert straight HTML into output */
void
g__H(int argc, char **argv)
{
	int i;

	for(i = 1; i &lt; argc; i++)
		Bprint(&amp;bout, "%s ", argv[i]);
	Bprint(&amp;bout, "\n");
}

/* HTML page title */
void
g__T(int argc, char **argv)
{
	if(titleseen)
		return;

	Bprint(&amp;bout, "&lt;title&gt;\n");
	printargs(argc, argv);
	Bprint(&amp;bout, "&lt;/title&gt;&lt;/head&gt;&lt;body&gt;\n");
	titleseen = 1;
}

void
g_nr(int argc, char **argv)
{
	char *val;

	if (argc &gt; 1) {
		if (argc == 2)
			val = "0";
		else
			val = argv[2];
		dsnr(argv[1], val, &amp;numregs);
	}
}

void
zerodivide(void)
{
	fprint(2, "stdin %d(%s:%d): division by 0\n",
		ssp-&gt;lno, ssp-&gt;filename, ssp-&gt;rlno);
}

int
numval(char **pline, int recur)
{
	char *p;
	int neg, x, y;

	x = neg = 0;
	p = *pline;
	while(*p == '-') {
		neg = 1 - neg;
		p++;
	}
	if (*p == '(') {
		p++;
		x = numval(&amp;p, 1);
		if (*p != ')')
			goto done;
		p++;
	}
	else while(*p &gt;= '0' &amp;&amp; *p &lt;= '9')
		x = 10*x + *p++ - '0';
	if (neg)
		x = -x;
	if (recur)
	    for(;;) {
		switch(*p++) {
		case '+':
			x += numval(&amp;p, 0);
			continue;
		case '-':
			x -= numval(&amp;p, 0);
			continue;
		case '*':
			x *= numval(&amp;p, 0);
			continue;
		case '/':
			y = numval(&amp;p, 0);
			if (y == 0) {
				zerodivide();
				x = 0;
				goto done;
			}
			x /= y;
			continue;
		case '&lt;':
			if (*p == '=') {
				p++;
				x = x &lt;= numval(&amp;p, 0);
				continue;
			}
			x = x &lt; numval(&amp;p, 0);
			continue;
		case '&gt;':
			if (*p == '=') {
				p++;
				x = x &gt;= numval(&amp;p, 0);
				continue;
			}
			x = x &gt; numval(&amp;p, 0);
			continue;
		case '=':
			if (*p == '=')
				p++;
			x = x == numval(&amp;p, 0);
			continue;
		case '&amp;':
			x &amp;= numval(&amp;p, 0);
			continue;
		case ':':
			x |= numval(&amp;p, 0);
			continue;
		case '%':
			y = numval(&amp;p, 0);
			if (!y) {
				zerodivide();
				goto done;
			}
			x %= y;
			continue;
		}
		--p;
		break;
	}
 done:
	*pline = p;
	return x;
}

int
iftest(char *p, char **bp)
{
	char *p1;
	int c, neg, rv;

	rv = neg = 0;
	if (*p == '!') {
		neg = 1;
		p++;
	}
	c = *p;
	if (c &gt;= '0' &amp;&amp; c &lt;= '9' || c == '+' || c == '-' || c == '('/*)*/) {
		if (numval(&amp;p,1) &gt;= 1)
			rv = 1;
		goto done;
	}
	switch(c) {
	case 't':
	case 'o':
		rv = 1;
	case 'n':
	case 'e':
		p++;
		goto done;
	}
	for(p1 = ++p; *p != c; p++)
		if (!*p)
			goto done;
	for(p++;;) {
		if (*p != *p1++) {
			while(*p &amp;&amp; *p++ != c);
			goto done;
		}
		if (*p++ == c)
			break;
	}
	rv = 1;
 done:
	if (neg)
		rv = 1 - rv;
	while(*p == ' ' || *p == '\t')
		p++;
	*bp = p;
	return rv;
}

void
scanline(char *p, char *e, int wantnl)
{
	int c;
	Rune r;

	while((c = getrune()) == ' ' || c == '\t') ;
	while(p &lt; e) {
		if (c &lt; 0)
			break;
		if (c &lt; Runeself) {
			if (c == '\n') {
				if (wantnl)
					*p++ = c;
				break;
			}
			*p++ = c;
		}
		else {
			r = c;
			p += runetochar(p, &amp;r);
		}
		c = getrune();
	}
	*p = 0;
}

void
pushbody(char *line)
{
	char *b;

	if (line[0] == '\\' &amp;&amp; line[1] == '{' /*}*/ )
		line += 2;
	if (strsp &lt; Maxmstack - 1) {
		pushstr(b = strdup(line));
		mustfree[strsp] = b;
	}
}

void
skipbody(char *line)
{
	int c, n;

	if (line[0] != '\\' || line[1] != '{' /*}*/ )
		return;
	for(n = 1;;) {
		while((c = getrune()) != '\\')
			if (c &lt; 0)
				return;
		c = getrune();
		if (c == '{')
			n++;
		else if ((c == '}' &amp;&amp; (c = getrune()) == '\n' &amp;&amp; !--n)
			|| c &lt; 0)
			return;
	}
}

int
ifstart(char *line, char *e, char **bp)
{
	int it;
	char *b;

	b = copyline(line, e, 1);
	ungetrune();
	b[-1] = getrune();
	scanline(b, e, 1);
	it = iftest(line, bp);
	return it;
}

void
g_ie(char *line, char *e)
{
	char *b;

	if (elsetop &gt;= Maxif-1) {
		fprint(2, "ms2html: .ie's too deep\n");
		return;
	}
	if (ifwastrue[++elsetop] = ifstart(line, e, &amp;b))
		pushbody(b);
	else
		skipbody(b);
}

void
g_if(char *line, char *e)
{
	char *b;

	if (ifstart(line, e, &amp;b))
		pushbody(b);
	else
		skipbody(b);
}

void
g_el(char *line, char *e)
{
	if (elsetop &lt; 0)
		return;
	scanline(line, e, 1);
	if (ifwastrue[elsetop--])
		skipbody(line);
	else
		pushbody(line);
}

void
g_ig(int argc, char **argv)
{
	char *p, *s;

	s = "..";
	if (argc &gt; 1)
		s = argv[1];
	for(;;) {
		p = Brdline(&amp;ssp-&gt;in, '\n');
		if(p == nil)
			break;
		p[Blinelen(&amp;ssp-&gt;in)-1] = 0;
		if(strcmp(p, s) == 0)
			break;
	}
}

void
g_ds(char *line, char *e)
{
	char *b;

	b = copyline(line, e, 1);
	if (b &gt; line) {
		copyline(b, e, 0);
		if (*b == '"')
			b++;
		ds(line, b);
	}
}

void
g_as(char *line, char *e)
{
	String *s;
	char *b;

	b = copyline(line, e, 1);
	if (b == line)
		return;
	copyline(b, e, 0);
	if (*b == '"')
		b++;
	for(s = strings; s != nil; s = s-&gt;next)
		if(strcmp(line, s-&gt;name) == 0)
			break;

	if(s == nil){
		ds(line, b);
		return;
	}

	s-&gt;val = realloc(s-&gt;val, strlen(s-&gt;val) + strlen(b) + 1);
	strcat(s-&gt;val, b);
}

void
g_BS(int argc, char **argv)
{
	int i;

	if (argc &gt; 1 &amp;&amp; !weBref) {
		Bprint(&amp;bout, "&lt;a href=\"%s\"", argv[1]);
		for(i = 2; i &lt; argc; i++)
			Bprint(&amp;bout, " %s", argv[i]);
		Bprint(&amp;bout, "&gt;");
		weBref = 1;
	}
}

void
g_BE(int, char**)
{
	if (weBref) {
		Bprint(&amp;bout, "&lt;/a&gt;");
		weBref = 0;
	}
}

void
g_LB(int argc, char **argv)
{
	if (argc &gt; 1) {
		if (weBref)
			g_BE(0,nil);
		Bprint(&amp;bout, "&lt;a name=\"%s\"&gt;&lt;/a&gt;", argv[1]);
	}
}

void
g_RT(int, char**)
{
	g_BE(0,nil);
	dohanginghead();
	closel();
	closefont();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

