<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/convM2DNS.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/convM2DNS.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

typedef struct Scan	Scan;
struct Scan
{
	uchar	*base;		/* input buffer */
	uchar	*p;		/* current position */
	uchar	*ep;		/* byte after the end */

	char	*err;
	char	errbuf[256];	/* hold a formatted error sometimes */
	int	rcode;		/* outgoing response codes (reply flags) */
	int	stop;		/* flag: stop processing */
	int	trunc;		/* flag: input truncated */
};

static int
errneg(RR *rp, Scan *sp, int actual)
{
	snprint(sp-&gt;errbuf, sizeof sp-&gt;errbuf, "negative len %d: %R",
		actual, rp);
	sp-&gt;err = sp-&gt;errbuf;
	return 0;
}

static int
errtoolong(RR *rp, Scan *sp, int remain, int need, char *where)
{
	char *p, *ep;
	char ptype[64];

	p =  sp-&gt;errbuf;
	ep = sp-&gt;errbuf + sizeof sp-&gt;errbuf - 1;
	if (where)
		p = seprint(p, ep, "%s: ", where);
	if (rp)
		p = seprint(p, ep, "type %s RR: ",
			rrname(rp-&gt;type, ptype, sizeof ptype));
	p = seprint(p, ep, "%d bytes needed; %d remain", need, remain);
	if (rp)
		p = seprint(p, ep, ": %R", rp);
	/*
	 * hack to cope with servers that don't set Ftrunc when they should:
	 * if the (udp) packet is full-sized, if must be truncated because
	 * it is incomplete.  otherwise, it's just garbled.
	 */
	if (sp-&gt;ep - sp-&gt;base &gt;= Maxpayload) {
		sp-&gt;trunc = 1;
		seprint(p, ep, " (truncated)");
	}
	if (debug &amp;&amp; rp)
		dnslog("malformed rr: %R", rp);
	sp-&gt;err = sp-&gt;errbuf;
	return 0;
}

/*
 *  get a ushort/ulong
 */
static ushort
gchar(RR *rp, Scan *sp)
{
	ushort x;

	if(sp-&gt;err)
		return 0;
	if(sp-&gt;ep - sp-&gt;p &lt; 1)
		return errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, 1, "gchar");
	x = sp-&gt;p[0];
	sp-&gt;p += 1;
	return x;
}
static ushort
gshort(RR *rp, Scan *sp)
{
	ushort x;

	if(sp-&gt;err)
		return 0;
	if(sp-&gt;ep - sp-&gt;p &lt; 2)
		return errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, 2, "gshort");
	x = sp-&gt;p[0]&lt;&lt;8 | sp-&gt;p[1];
	sp-&gt;p += 2;
	return x;
}
static ulong
glong(RR *rp, Scan *sp)
{
	ulong x;

	if(sp-&gt;err)
		return 0;
	if(sp-&gt;ep - sp-&gt;p &lt; 4)
		return errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, 4, "glong");
	x = sp-&gt;p[0]&lt;&lt;24 | sp-&gt;p[1]&lt;&lt;16 | sp-&gt;p[2]&lt;&lt;8 | sp-&gt;p[3];
	sp-&gt;p += 4;
	return x;
}

/*
 *  get an ip address
 */
static DN*
gv4addr(RR *rp, Scan *sp)
{
	char addr[32];

	if(sp-&gt;err)
		return 0;
	if(sp-&gt;ep - sp-&gt;p &lt; 4)
		return (DN*)errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, 4, "gv4addr");
	snprint(addr, sizeof addr, "%V", sp-&gt;p);
	sp-&gt;p += 4;

	return dnlookup(addr, Cin, 1);
}
static DN*
gv6addr(RR *rp, Scan *sp)
{
	char addr[64];

	if(sp-&gt;err)
		return 0;
	if(sp-&gt;ep - sp-&gt;p &lt; IPaddrlen)
		return (DN*)errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, IPaddrlen,
			"gv6addr");
	snprint(addr, sizeof addr, "%I", sp-&gt;p);
	sp-&gt;p += IPaddrlen;

	return dnlookup(addr, Cin, 1);
}

/*
 *  get a string.  make it an internal symbol.
 */
static DN*
gsym(RR *rp, Scan *sp)
{
	int n;
	char sym[Strlen+1];

	if(sp-&gt;err)
		return 0;
	n = 0;
	if (sp-&gt;p &lt; sp-&gt;ep)
		n = *(sp-&gt;p++);
	if(sp-&gt;ep - sp-&gt;p &lt; n)
		return (DN*)errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, n, "gsym");

	if(n &gt; Strlen){
		sp-&gt;err = "illegal string (symbol)";
		return 0;
	}
	strncpy(sym, (char*)sp-&gt;p, n);
	sym[n] = 0;
	if (strlen(sym) != n)
		sp-&gt;err = "symbol shorter than declared length";
	sp-&gt;p += n;

	return dnlookup(sym, Csym, 1);
}

/*
 *  get a string.  don't make it an internal symbol.
 */
static Txt*
gstr(RR *rp, Scan *sp)
{
	int n;
	char sym[Strlen+1];
	Txt *t;

	if(sp-&gt;err)
		return 0;
	n = 0;
	if (sp-&gt;p &lt; sp-&gt;ep)
		n = *(sp-&gt;p++);
	if(sp-&gt;ep - sp-&gt;p &lt; n)
		return (Txt*)errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, n, "gstr");

	if(n &gt; Strlen){
		sp-&gt;err = "illegal string";
		return 0;
	}
	strncpy(sym, (char*)sp-&gt;p, n);
	sym[n] = 0;
	if (strlen(sym) != n)
		sp-&gt;err = "string shorter than declared length";
	sp-&gt;p += n;

	t = emalloc(sizeof(*t));
	t-&gt;next = nil;
	t-&gt;p = estrdup(sym);
	return t;
}

/*
 *  get a sequence of bytes
 */
static int
gbytes(RR *rp, Scan *sp, uchar **p, int n)
{
	*p = nil;			/* i think this is a good idea */
	if(sp-&gt;err)
		return 0;
	if(n &lt; 0)
		return errneg(rp, sp, n);
	if(sp-&gt;ep - sp-&gt;p &lt; n)
		return errtoolong(rp, sp, sp-&gt;ep - sp-&gt;p, n, "gbytes");
	*p = emalloc(n);
	memmove(*p, sp-&gt;p, n);
	sp-&gt;p += n;

	return n;
}

/*
 *  get a domain name.  'to' must point to a buffer at least Domlen+1 long.
 */
static char*
gname(char *to, RR *rp, Scan *sp)
{
	int len, off, pointer, n;
	char *tostart, *toend;
	uchar *p;

	tostart = to;
	if(sp-&gt;err || sp-&gt;stop)
		goto err;
	pointer = 0;
	p = sp-&gt;p;
	if (p == nil) {
		dnslog("gname: %R: nil sp-&gt;p", rp);
		goto err;
	}
	toend = to + Domlen;
	for(len = 0; *p &amp;&amp; p &lt; sp-&gt;ep; len += (pointer? 0: n+1)) {
		n = 0;
		switch (*p &amp; 0300) {
		case 0:			/* normal label */
			if (p &lt; sp-&gt;ep)
				n = *p++ &amp; 077;		/* pick up length */
			if(len + n &lt; Domlen - 1){
				if(n &gt; toend - to){
					errtoolong(rp, sp, toend - to, n,
						"name too long");
					goto err;
				}
				memmove(to, p, n);
				to += n;
			}
			p += n;
			if(*p){
				if(to &gt;= toend){
					errtoolong(rp, sp, toend - to, 2,
				     "more name components but no bytes left");
					goto err;
				}
				*to++ = '.';
			}
			break;
		case 0100:		/* edns extended label type, rfc 6891 */
			/*
			 * treat it like an EOF for now; it seems to be at
			 * the end of a long tcp reply.
			 */
			dnslog("edns label; first byte 0%o = '%c'", *p, *p);
			sp-&gt;stop = 1;
			goto err;
		case 0200:		/* reserved */
			sp-&gt;err = "reserved-use label present";
			goto err;
		case 0300:		/* pointer to other spot in message */
			if(pointer++ &gt; 10){
				sp-&gt;err = "pointer loop";
				goto err;
			}
			off = (p[0] &amp; 077)&lt;&lt;8 | p[1];
			p = sp-&gt;base + off;
			if(p &gt;= sp-&gt;ep){
				sp-&gt;err = "bad pointer";
				goto err;
			}
			n = 0;
			break;
		}
	}
	*to = 0;
	if(pointer)
		sp-&gt;p += len + 2;	/* + 2 for pointer */
	else
		sp-&gt;p += len + 1;	/* + 1 for the null domain */
	return tostart;
err:
	*tostart = 0;
	return tostart;
}

/*
 * ms windows 2000 seems to get the bytes backward in the type field
 * of ptr records, so return a format error as feedback.
 */
static ushort
mstypehack(Scan *sp, ushort type, char *where)
{
	if ((uchar)type == 0 &amp;&amp; (type&gt;&gt;8) != 0) {
		USED(where);
//		dnslog("%s: byte-swapped type field in ptr rr from win2k",
//			where);
		if (sp-&gt;rcode == Rok)
			sp-&gt;rcode = Rformat;
		type &gt;&gt;= 8;
	}
	return type;
}

#define NAME(x)		gname(x, rp, sp)
#define SYMBOL(x)	((x) = gsym(rp, sp))
#define STRING(x)	((x) = gstr(rp, sp))
#define USHORT(x)	((x) = gshort(rp, sp))
#define ULONG(x)	((x) = glong(rp, sp))
#define UCHAR(x)	((x) = gchar(rp, sp))
#define V4ADDR(x)	((x) = gv4addr(rp, sp))
#define V6ADDR(x)	((x) = gv6addr(rp, sp))
#define BYTES(x, y)	((y) = gbytes(rp, sp, &amp;(x), len - (sp-&gt;p - data)))

/*
 *  convert the next RR from a message
 */
static RR*
convM2RR(Scan *sp, char *what)
{
	int type, class, len, left;
	char *dn;
	char dname[Domlen+1];
	uchar *data;
	RR *rp;
	Txt *t, **l;

retry:
	rp = nil;
	NAME(dname);
	USHORT(type);
	USHORT(class);

	type = mstypehack(sp, type, "convM2RR");
	rp = rralloc(type);
	rp-&gt;owner = dnlookup(dname, class, 1);
	rp-&gt;type = type;

	ULONG(rp-&gt;ttl);
	rp-&gt;ttl += now;
	USHORT(len);			/* length of data following */
	data = sp-&gt;p;
	assert(data != nil);
	left = sp-&gt;ep - sp-&gt;p;

	/*
	 * ms windows generates a lot of badly-formatted hints.
	 * hints are only advisory, so don't log complaints about them.
	 * it also generates answers in which p overshoots ep by exactly
	 * one byte; this seems to be harmless, so don't log them either.
	 */
	if (len &gt; left &amp;&amp;
	   !(strcmp(what, "hints") == 0 ||
	     sp-&gt;p == sp-&gt;ep + 1 &amp;&amp; strcmp(what, "answers") == 0))
		errtoolong(rp, sp, left, len, "convM2RR");
	if(sp-&gt;err || sp-&gt;rcode || sp-&gt;stop){
		rrfree(rp);
		return nil;
	}
	/* even if we don't log an error message, truncate length to fit data */
	if (len &gt; left)
		len = left;

	switch(type){
	default:
		/* unknown type, just ignore it */
		sp-&gt;p = data + len;
		rrfree(rp);
		goto retry;
	case Thinfo:
		SYMBOL(rp-&gt;cpu);
		SYMBOL(rp-&gt;os);
		break;
	case Tcname:
	case Tmb:
	case Tmd:
	case Tmf:
	case Tns:
		rp-&gt;host = dnlookup(NAME(dname), Cin, 1);
		break;
	case Tmg:
	case Tmr:
		rp-&gt;mb  = dnlookup(NAME(dname), Cin, 1);
		break;
	case Tminfo:
		rp-&gt;rmb = dnlookup(NAME(dname), Cin, 1);
		rp-&gt;mb  = dnlookup(NAME(dname), Cin, 1);
		break;
	case Tmx:
		USHORT(rp-&gt;pref);
		dn = NAME(dname);
		rp-&gt;host = dnlookup(dn, Cin, 1);
		if(strchr((char *)rp-&gt;host, '\n') != nil) {
			dnslog("newline in mx text for %s", dn);
			sp-&gt;trunc = 1;		/* try again via tcp */
		}
		break;
	case Ta:
		V4ADDR(rp-&gt;ip);
		break;
	case Taaaa:
		V6ADDR(rp-&gt;ip);
		break;
	case Tptr:
		rp-&gt;ptr = dnlookup(NAME(dname), Cin, 1);
		break;
	case Tsoa:
		rp-&gt;host = dnlookup(NAME(dname), Cin, 1);
		rp-&gt;rmb  = dnlookup(NAME(dname), Cin, 1);
		ULONG(rp-&gt;soa-&gt;serial);
		ULONG(rp-&gt;soa-&gt;refresh);
		ULONG(rp-&gt;soa-&gt;retry);
		ULONG(rp-&gt;soa-&gt;expire);
		ULONG(rp-&gt;soa-&gt;minttl);
		break;
	case Tsrv:
		USHORT(rp-&gt;srv-&gt;pri);
		USHORT(rp-&gt;srv-&gt;weight);
		USHORT(rp-&gt;port);
		/*
		 * rfc2782 sez no name compression but to be
		 * backward-compatible with rfc2052, we try to expand the name. 
		 * if the length is under 64 bytes, either interpretation is
		 * fine; if it's longer, we'll assume it's compressed,
		 * as recommended by rfc3597.
		 */
		rp-&gt;host = dnlookup(NAME(dname), Cin, 1);
		break;
	case Ttxt:
		l = &amp;rp-&gt;txt;
		*l = nil;
		while(sp-&gt;p - data &lt; len){
			STRING(t);
			*l = t;
			l = &amp;t-&gt;next;
		}
		break;
	case Tnull:
		BYTES(rp-&gt;null-&gt;data, rp-&gt;null-&gt;dlen);
		break;
	case Trp:
		rp-&gt;rmb = dnlookup(NAME(dname), Cin, 1);
		rp-&gt;rp  = dnlookup(NAME(dname), Cin, 1);
		break;
	case Tkey:
		USHORT(rp-&gt;key-&gt;flags);
		UCHAR(rp-&gt;key-&gt;proto);
		UCHAR(rp-&gt;key-&gt;alg);
		BYTES(rp-&gt;key-&gt;data, rp-&gt;key-&gt;dlen);
		break;
	case Tsig:
		USHORT(rp-&gt;sig-&gt;type);
		UCHAR(rp-&gt;sig-&gt;alg);
		UCHAR(rp-&gt;sig-&gt;labels);
		ULONG(rp-&gt;sig-&gt;ttl);
		ULONG(rp-&gt;sig-&gt;exp);
		ULONG(rp-&gt;sig-&gt;incep);
		USHORT(rp-&gt;sig-&gt;tag);
		rp-&gt;sig-&gt;signer = dnlookup(NAME(dname), Cin, 1);
		BYTES(rp-&gt;sig-&gt;data, rp-&gt;sig-&gt;dlen);
		break;
	case Tcert:
		USHORT(rp-&gt;cert-&gt;type);
		USHORT(rp-&gt;cert-&gt;tag);
		UCHAR(rp-&gt;cert-&gt;alg);
		BYTES(rp-&gt;cert-&gt;data, rp-&gt;cert-&gt;dlen);
		break;
	}
	if(sp-&gt;p - data != len) {
		char ptype[64];

		/*
		 * ms windows 2000 generates cname queries for reverse lookups
		 * with this particular error.  don't bother logging it.
		 *
		 * server: input error: bad cname RR len (actual 2 != len 0):
		 * 235.9.104.135.in-addr.arpa cname
		 *	235.9.104.135.in-addr.arpa from 135.104.9.235
		 */
		if (type == Tcname &amp;&amp; sp-&gt;p - data == 2 &amp;&amp; len == 0)
			return rp;
		if (len &gt; sp-&gt;p - data){
			dnslog("bad %s RR len (%d bytes nominal, %lud actual): %R",
				rrname(type, ptype, sizeof ptype), len,
				sp-&gt;p - data, rp);
			rrfree(rp);
			rp = nil;
		}
	}
	// if(rp) dnslog("convM2RR: got %R", rp);
	return rp;
}

/*
 *  convert the next question from a message
 */
static RR*
convM2Q(Scan *sp)
{
	char dname[Domlen+1];
	int type, class;
	RR *rp;

	rp = nil;
	NAME(dname);
	USHORT(type);
	USHORT(class);
	if(sp-&gt;err || sp-&gt;rcode || sp-&gt;stop)
		return nil;

	type = mstypehack(sp, type, "convM2Q");
	rp = rralloc(type);
	rp-&gt;owner = dnlookup(dname, class, 1);

	return rp;
}

static RR*
rrloop(Scan *sp, char *what, int count, int quest)
{
	int i;
	RR *first, *rp, **l;

	if(sp-&gt;err || sp-&gt;rcode || sp-&gt;stop)
		return nil;
	l = &amp;first;
	first = nil;
	for(i = 0; i &lt; count; i++){
		rp = quest? convM2Q(sp): convM2RR(sp, what);
		if(rp == nil)
			break;
		setmalloctag(rp, getcallerpc(&amp;sp));
		/*
		 * it might be better to ignore the bad rr, possibly break out,
		 * but return the previous rrs, if any.  that way our callers
		 * would know that they had got a response, however ill-formed.
		 */
		if(sp-&gt;err || sp-&gt;rcode || sp-&gt;stop){
			rrfree(rp);
			break;
		}
		*l = rp;
		l = &amp;rp-&gt;next;
	}
//	if(first)
//		setmalloctag(first, getcallerpc(&amp;sp));
	return first;
}

/*
 *  convert the next DNS from a message stream.
 *  if there are formatting errors or the like during parsing of the message,
 *  set *codep to the outgoing response code (e.g., Rformat), which will
 *  abort processing and reply immediately with the outgoing response code.
 *
 *  ideally would note if len == Maxpayload &amp;&amp; query was via UDP, for errtoolong.
 */
char*
convM2DNS(uchar *buf, int len, DNSmsg *m, int *codep)
{
	char *err = nil;
	RR *rp = nil;
	Scan scan;
	Scan *sp;

	assert(len &gt;= 0);
	assert(buf != nil);
	sp = &amp;scan;
	memset(sp, 0, sizeof *sp);
	sp-&gt;base = sp-&gt;p = buf;
	sp-&gt;ep = buf + len;
	sp-&gt;err = nil;
	sp-&gt;errbuf[0] = '\0';
	sp-&gt;rcode = Rok;

	memset(m, 0, sizeof *m);
	USHORT(m-&gt;id);
	USHORT(m-&gt;flags);
	USHORT(m-&gt;qdcount);
	USHORT(m-&gt;ancount);
	USHORT(m-&gt;nscount);
	USHORT(m-&gt;arcount);

	m-&gt;qd = rrloop(sp, "questions",	m-&gt;qdcount, 1);
	m-&gt;an = rrloop(sp, "answers",	m-&gt;ancount, 0);
	m-&gt;ns = rrloop(sp, "nameservers",m-&gt;nscount, 0);
	if (sp-&gt;stop)
		sp-&gt;err = nil;
	if (sp-&gt;err)
		err = strdup(sp-&gt;err);		/* live with bad ar's */
	m-&gt;ar = rrloop(sp, "hints",	m-&gt;arcount, 0);
	if (sp-&gt;trunc)
		m-&gt;flags |= Ftrunc;
	if (sp-&gt;stop)
		sp-&gt;rcode = Rok;
	if (codep)
		*codep = sp-&gt;rcode;
	return err;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

