<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/cs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/cs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;ndb.h&gt;
#include &lt;ip.h&gt;
#include &lt;String.h&gt;

enum
{
	Nreply=			20,
	Maxreply=		256,
	Maxrequest=		128,
	Maxpath=		128,
	Maxfdata=		8192,
	Maxhost=		64,		/* maximum host name size */
	Maxservice=		64,		/* maximum service name size */

	Qdir=			0,
	Qcs=			1,
};

typedef struct Mfile	Mfile;
typedef struct Mlist	Mlist;
typedef struct Network	Network;
typedef struct Flushreq	Flushreq;
typedef struct Job	Job;

int vers;		/* incremented each clone/attach */

struct Mfile
{
	int		busy;

	char		*user;
	Qid		qid;
	int		fid;

	/*
	 *  current request
	 */
	char		*net;
	char		*host;
	char		*serv;
	char		*rem;

	/*
	 *  result of the last lookup
	 */
	Network		*nextnet;
	int		nreply;
	char		*reply[Nreply];
	int		replylen[Nreply];
};

struct Mlist
{
	Mlist	*next;
	Mfile	mf;
};


/*
 *  active requests
 */
struct Job
{
	Job	*next;
	int	flushed;
	Fcall	request;
	Fcall	reply;
};
Lock	joblock;
Job	*joblist;

Mlist	*mlist;
int	mfd[2];
int	debug;
int	paranoia;
int	ipv6lookups = 1;
jmp_buf	masterjmp;	/* return through here after a slave process has been created */
int	*isslave;	/* *isslave non-zero means this is a slave process */
char	*dbfile;
Ndb	*db, *netdb;

void	rversion(Job*);
void	rflush(Job*);
void	rattach(Job*, Mfile*);
char*	rwalk(Job*, Mfile*);
void	ropen(Job*, Mfile*);
void	rcreate(Job*, Mfile*);
void	rread(Job*, Mfile*);
void	rwrite(Job*, Mfile*);
void	rclunk(Job*, Mfile*);
void	rremove(Job*, Mfile*);
void	rstat(Job*, Mfile*);
void	rwstat(Job*, Mfile*);
void	rauth(Job*);
void	sendmsg(Job*, char*);
void	error(char*);
void	mountinit(char*, char*);
void	io(void);
void	ndbinit(void);
void	netinit(int);
void	netadd(char*);
char	*genquery(Mfile*, char*);
char*	ipinfoquery(Mfile*, char**, int);
int	needproto(Network*, Ndbtuple*);
int	lookup(Mfile*);
Ndbtuple*	reorder(Ndbtuple*, Ndbtuple*);
void	ipid(void);
void	readipinterfaces(void);
void*	emalloc(int);
char*	estrdup(char*);
Job*	newjob(void);
void	freejob(Job*);
void	setext(char*, int, char*);
void	cleanmf(Mfile*);

extern void	paralloc(void);

Lock	dblock;		/* mutex on database operations */
Lock	netlock;	/* mutex for netinit() */

char	*logfile = "cs";
char	*paranoiafile = "cs.paranoia";

char	mntpt[Maxpath];
char	netndb[Maxpath];

/*
 *  Network specific translators
 */
Ndbtuple*	iplookup(Network*, char*, char*, int);
char*		iptrans(Ndbtuple*, Network*, char*, char*, int);
Ndbtuple*	telcolookup(Network*, char*, char*, int);
char*		telcotrans(Ndbtuple*, Network*, char*, char*, int);
Ndbtuple*	dnsiplookup(char*, Ndbs*);

struct Network
{
	char		*net;
	Ndbtuple	*(*lookup)(Network*, char*, char*, int);
	char		*(*trans)(Ndbtuple*, Network*, char*, char*, int);
	int		considered;		/* flag: ignored for "net!"? */
	int		fasttimeouthack;	/* flag. was for IL */
	Network		*next;
};

enum
{
	Ntcp = 0,
};

/*
 *  net doesn't apply to (r)udp, icmp(v6), or telco (for speed).
 */
Network network[] = {
[Ntcp]	{ "tcp",	iplookup,	iptrans,	0 },
	{ "udp",	iplookup,	iptrans,	1 },
	{ "icmp",	iplookup,	iptrans,	1 },
	{ "icmpv6",	iplookup,	iptrans,	1 },
	{ "rudp",	iplookup,	iptrans,	1 },
	{ "ssh",	iplookup,	iptrans,	1 },
	{ "telco",	telcolookup,	telcotrans,	1 },
	{ 0 },
};

Lock ipifclock;
Ipifc *ipifcs;

char	eaddr[16];		/* ascii ethernet address */
char	ipaddr[64];		/* ascii internet address */
uchar	ipa[IPaddrlen];		/* binary internet address */
char	*mysysname;

Network *netlist;		/* networks ordered by preference */
Network *last;

static void
nstrcpy(char *to, char *from, int len)
{
	strncpy(to, from, len);
	to[len-1] = 0;
}

void
usage(void)
{
	fprint(2, "usage: %s [-dn] [-f ndb-file] [-x netmtpt]\n", argv0);
	exits("usage");
}

/*
 * based on libthread's threadsetname, but drags in less library code.
 * actually just sets the arguments displayed.
 */
void
procsetname(char *fmt, ...)
{
	int fd;
	char *cmdname;
	char buf[128];
	va_list arg;

	va_start(arg, fmt);
	cmdname = vsmprint(fmt, arg);
	va_end(arg);
	if (cmdname == nil)
		return;
	snprint(buf, sizeof buf, "#p/%d/args", getpid());
	if((fd = open(buf, OWRITE)) &gt;= 0){
		write(fd, cmdname, strlen(cmdname)+1);
		close(fd);
	}
	free(cmdname);
}

void
main(int argc, char *argv[])
{
	int justsetname;
	char ext[Maxpath], servefile[Maxpath];

	justsetname = 0;
	setnetmtpt(mntpt, sizeof(mntpt), nil);
	ext[0] = 0;
	ARGBEGIN{
	case '4':
		ipv6lookups = 0;
		break;
	case 'd':
		debug = 1;
		break;
	case 'f':
		dbfile = EARGF(usage());
		break;
	case 'n':
		justsetname = 1;
		break;
	case 'x':
		setnetmtpt(mntpt, sizeof(mntpt), EARGF(usage()));
		setext(ext, sizeof(ext), mntpt);
		break;
	}ARGEND
	USED(argc);
	USED(argv);

	rfork(RFREND|RFNOTEG);

	snprint(servefile, sizeof(servefile), "#s/cs%s", ext);
	snprint(netndb, sizeof(netndb), "%s/ndb", mntpt);
	unmount(servefile, mntpt);
	remove(servefile);

	fmtinstall('E', eipfmt);
	fmtinstall('I', eipfmt);
	fmtinstall('M', eipfmt);
	fmtinstall('F', fcallfmt);

	ndbinit();
	netinit(0);

	if(!justsetname){
		mountinit(servefile, mntpt);
		io();
	}
	exits(0);
}

/*
 *  if a mount point is specified, set the cs extention to be the mount point
 *  with '_'s replacing '/'s
 */
void
setext(char *ext, int n, char *p)
{
	int i, c;

	n--;
	for(i = 0; i &lt; n; i++){
		c = p[i];
		if(c == 0)
			break;
		if(c == '/')
			c = '_';
		ext[i] = c;
	}
	ext[i] = 0;
}

void
mountinit(char *service, char *mntpt)
{
	int f;
	int p[2];
	char buf[32];

	if(pipe(p) &lt; 0)
		error("pipe failed");

	/*
	 *  make a /srv/cs
	 */
	f = create(service, OWRITE|ORCLOSE, 0666);
	if(f &lt; 0)
		error(service);
	snprint(buf, sizeof(buf), "%d", p[1]);
	if(write(f, buf, strlen(buf)) != strlen(buf))
		error("write /srv/cs");

	switch(rfork(RFFDG|RFPROC|RFNAMEG)){
	case 0:
		close(p[1]);
		procsetname("%s", mntpt);
		break;
	case -1:
		error("fork failed\n");
	default:
		/*
		 *  put ourselves into the file system
		 */
		close(p[0]);
		if(mount(p[1], -1, mntpt, MAFTER, "") &lt; 0)
			error("mount failed\n");
		_exits(0);
	}
	mfd[0] = mfd[1] = p[0];
}

void
ndbinit(void)
{
	db = ndbopen(dbfile);
	if(db == nil)
		error("can't open network database");

	netdb = ndbopen(netndb);
	if(netdb != nil){
		netdb-&gt;nohash = 1;
		db = ndbcat(netdb, db);
	}
}

Mfile*
newfid(int fid)
{
	Mlist *f, *ff;
	Mfile *mf;

	ff = 0;
	for(f = mlist; f; f = f-&gt;next)
		if(f-&gt;mf.busy &amp;&amp; f-&gt;mf.fid == fid)
			return &amp;f-&gt;mf;
		else if(!ff &amp;&amp; !f-&gt;mf.busy)
			ff = f;
	if(ff == 0){
		ff = emalloc(sizeof *f);
		ff-&gt;next = mlist;
		mlist = ff;
	}
	mf = &amp;ff-&gt;mf;
	memset(mf, 0, sizeof *mf);
	mf-&gt;fid = fid;
	return mf;
}

Job*
newjob(void)
{
	Job *job;

	job = mallocz(sizeof(Job), 1);
	lock(&amp;joblock);
	job-&gt;next = joblist;
	joblist = job;
	job-&gt;request.tag = -1;
	unlock(&amp;joblock);
	return job;
}

void
freejob(Job *job)
{
	Job **l;

	lock(&amp;joblock);
	for(l = &amp;joblist; *l; l = &amp;(*l)-&gt;next){
		if((*l) == job){
			*l = job-&gt;next;
			free(job);
			break;
		}
	}
	unlock(&amp;joblock);
}

void
flushjob(int tag)
{
	Job *job;

	lock(&amp;joblock);
	for(job = joblist; job; job = job-&gt;next){
		if(job-&gt;request.tag == tag &amp;&amp; job-&gt;request.type != Tflush){
			job-&gt;flushed = 1;
			break;
		}
	}
	unlock(&amp;joblock);
}

void
io(void)
{
	long n;
	Mfile *mf;
	int slaveflag;
	uchar mdata[IOHDRSZ + Maxfdata];
	Job *job;

	/*
	 *  if we ask dns to fulfill requests,
	 *  a slave process is created to wait for replies.  The
	 *  master process returns immediately via a longjmp
	 *  through 'masterjmp'.
	 *
	 *  *isslave is a pointer into the call stack to a variable
	 *  that tells whether or not the current process is a slave.
	 */
	slaveflag = 0;		/* init slave variable */
	isslave = &amp;slaveflag;
	setjmp(masterjmp);

	for(;;){
		n = read9pmsg(mfd[0], mdata, sizeof mdata);
		if(n&lt;=0)
			error("mount read");
		job = newjob();
		if(convM2S(mdata, n, &amp;job-&gt;request) != n){
			syslog(1, logfile, "format error %ux %ux %ux %ux %ux",
				mdata[0], mdata[1], mdata[2], mdata[3], mdata[4]);
			freejob(job);
			continue;
		}
		lock(&amp;dblock);
		mf = newfid(job-&gt;request.fid);
		if(debug)
			syslog(0, logfile, "%F", &amp;job-&gt;request);


		switch(job-&gt;request.type){
		default:
			syslog(1, logfile, "unknown request type %d", job-&gt;request.type);
			break;
		case Tversion:
			rversion(job);
			break;
		case Tauth:
			rauth(job);
			break;
		case Tflush:
			rflush(job);
			break;
		case Tattach:
			rattach(job, mf);
			break;
		case Twalk:
			rwalk(job, mf);
			break;
		case Topen:
			ropen(job, mf);
			break;
		case Tcreate:
			rcreate(job, mf);
			break;
		case Tread:
			rread(job, mf);
			break;
		case Twrite:
			rwrite(job, mf);
			break;
		case Tclunk:
			rclunk(job, mf);
			break;
		case Tremove:
			rremove(job, mf);
			break;
		case Tstat:
			rstat(job, mf);
			break;
		case Twstat:
			rwstat(job, mf);
			break;
		}
		unlock(&amp;dblock);

		freejob(job);

		/*
		 *  slave processes die after replying
		 */
		if(*isslave){
			if(debug)
				syslog(0, logfile, "slave death %d", getpid());
			_exits(0);
		}
	}
}

void
rversion(Job *job)
{
	if(job-&gt;request.msize &gt; IOHDRSZ + Maxfdata)
		job-&gt;reply.msize = IOHDRSZ + Maxfdata;
	else
		job-&gt;reply.msize = job-&gt;request.msize;
	if(strncmp(job-&gt;request.version, "9P2000", 6) != 0)
		sendmsg(job, "unknown 9P version");
	else{
		job-&gt;reply.version = "9P2000";
		sendmsg(job, 0);
	}
}

void
rauth(Job *job)
{
	sendmsg(job, "cs: authentication not required");
}

/*
 *  don't flush till all the slaves are done
 */
void
rflush(Job *job)
{
	flushjob(job-&gt;request.oldtag);
	sendmsg(job, 0);
}

void
rattach(Job *job, Mfile *mf)
{
	if(mf-&gt;busy == 0){
		mf-&gt;busy = 1;
		mf-&gt;user = estrdup(job-&gt;request.uname);
	}
	mf-&gt;qid.vers = vers++;
	mf-&gt;qid.type = QTDIR;
	mf-&gt;qid.path = 0LL;
	job-&gt;reply.qid = mf-&gt;qid;
	sendmsg(job, 0);
}


char*
rwalk(Job *job, Mfile *mf)
{
	char *err;
	char **elems;
	int nelems;
	int i;
	Mfile *nmf;
	Qid qid;

	err = 0;
	nmf = nil;
	elems = job-&gt;request.wname;
	nelems = job-&gt;request.nwname;
	job-&gt;reply.nwqid = 0;

	if(job-&gt;request.newfid != job-&gt;request.fid){
		/* clone fid */
		nmf = newfid(job-&gt;request.newfid);
		if(nmf-&gt;busy){
			nmf = nil;
			err = "clone to used channel";
			goto send;
		}
		*nmf = *mf;
		nmf-&gt;user = estrdup(mf-&gt;user);
		nmf-&gt;fid = job-&gt;request.newfid;
		nmf-&gt;qid.vers = vers++;
		mf = nmf;
	}
	/* else nmf will be nil */

	qid = mf-&gt;qid;
	if(nelems &gt; 0){
		/* walk fid */
		for(i=0; i&lt;nelems &amp;&amp; i&lt;MAXWELEM; i++){
			if((qid.type &amp; QTDIR) == 0){
				err = "not a directory";
				break;
			}
			if(strcmp(elems[i], "..") == 0 || strcmp(elems[i], ".") == 0){
				qid.type = QTDIR;
				qid.path = Qdir;
    Found:
				job-&gt;reply.wqid[i] = qid;
				job-&gt;reply.nwqid++;
				continue;
			}
			if(strcmp(elems[i], "cs") == 0){
				qid.type = QTFILE;
				qid.path = Qcs;
				goto Found;
			}
			err = "file does not exist";
			break;
		}
	}

    send:
	if(nmf != nil &amp;&amp; (err!=nil || job-&gt;reply.nwqid&lt;nelems)){
		cleanmf(nmf);
		free(nmf-&gt;user);
		nmf-&gt;user = 0;
		nmf-&gt;busy = 0;
		nmf-&gt;fid = 0;
	}
	if(err == nil)
		mf-&gt;qid = qid;
	sendmsg(job, err);
	return err;
}

void
ropen(Job *job, Mfile *mf)
{
	int mode;
	char *err;

	err = 0;
	mode = job-&gt;request.mode;
	if(mf-&gt;qid.type &amp; QTDIR){
		if(mode)
			err = "permission denied";
	}
	job-&gt;reply.qid = mf-&gt;qid;
	job-&gt;reply.iounit = 0;
	sendmsg(job, err);
}

void
rcreate(Job *job, Mfile *mf)
{
	USED(mf);
	sendmsg(job, "creation permission denied");
}

void
rread(Job *job, Mfile *mf)
{
	int i, n, cnt;
	long off, toff, clock;
	Dir dir;
	uchar buf[Maxfdata];
	char *err;

	n = 0;
	err = 0;
	off = job-&gt;request.offset;
	cnt = job-&gt;request.count;
	if(mf-&gt;qid.type &amp; QTDIR){
		clock = time(0);
		if(off == 0){
			memset(&amp;dir, 0, sizeof dir);
			dir.name = "cs";
			dir.qid.type = QTFILE;
			dir.qid.vers = vers;
			dir.qid.path = Qcs;
			dir.mode = 0666;
			dir.length = 0;
			dir.uid = mf-&gt;user;
			dir.gid = mf-&gt;user;
			dir.muid = mf-&gt;user;
			dir.atime = clock;	/* wrong */
			dir.mtime = clock;	/* wrong */
			n = convD2M(&amp;dir, buf, sizeof buf);
		}
		job-&gt;reply.data = (char*)buf;
	} else {
		for(;;){
			/* look for an answer at the right offset */
			toff = 0;
			for(i = 0; mf-&gt;reply[i] &amp;&amp; i &lt; mf-&gt;nreply; i++){
				n = mf-&gt;replylen[i];
				if(off &lt; toff + n)
					break;
				toff += n;
			}
			if(i &lt; mf-&gt;nreply)
				break;		/* got something to return */

			/* try looking up more answers */
			if(lookup(mf) == 0){
				/* no more */
				n = 0;
				goto send;
			}
		}

		/* give back a single reply (or part of one) */
		job-&gt;reply.data = mf-&gt;reply[i] + (off - toff);
		if(cnt &gt; toff - off + n)
			n = toff - off + n;
		else
			n = cnt;
	}
send:
	job-&gt;reply.count = n;
	sendmsg(job, err);
}
void
cleanmf(Mfile *mf)
{
	int i;

	if(mf-&gt;net != nil){
		free(mf-&gt;net);
		mf-&gt;net = nil;
	}
	if(mf-&gt;host != nil){
		free(mf-&gt;host);
		mf-&gt;host = nil;
	}
	if(mf-&gt;serv != nil){
		free(mf-&gt;serv);
		mf-&gt;serv = nil;
	}
	if(mf-&gt;rem != nil){
		free(mf-&gt;rem);
		mf-&gt;rem = nil;
	}
	for(i = 0; i &lt; mf-&gt;nreply; i++){
		free(mf-&gt;reply[i]);
		mf-&gt;reply[i] = nil;
		mf-&gt;replylen[i] = 0;
	}
	mf-&gt;nreply = 0;
	mf-&gt;nextnet = netlist;
}

void
rwrite(Job *job, Mfile *mf)
{
	int cnt, n;
	char *err;
	char *field[4];
	char curerr[64];

	err = 0;
	cnt = job-&gt;request.count;
	if(mf-&gt;qid.type &amp; QTDIR){
		err = "can't write directory";
		goto send;
	}
	if(cnt &gt;= Maxrequest){
		err = "request too long";
		goto send;
	}
	job-&gt;request.data[cnt] = 0;

	/*
	 *  toggle debugging
	 */
	if(strncmp(job-&gt;request.data, "debug", 5)==0){
		debug ^= 1;
		syslog(1, logfile, "debug %d", debug);
		goto send;
	}

	/*
	 *  toggle ipv6 lookups
	 */
	if(strncmp(job-&gt;request.data, "ipv6", 4)==0){
		ipv6lookups ^= 1;
		syslog(1, logfile, "ipv6lookups %d", ipv6lookups);
		goto send;
	}

	/*
	 *  toggle debugging
	 */
	if(strncmp(job-&gt;request.data, "paranoia", 8)==0){
		paranoia ^= 1;
		syslog(1, logfile, "paranoia %d", paranoia);
		goto send;
	}

	/*
	 *  add networks to the default list
	 */
	if(strncmp(job-&gt;request.data, "add ", 4)==0){
		if(job-&gt;request.data[cnt-1] == '\n')
			job-&gt;request.data[cnt-1] = 0;
		netadd(job-&gt;request.data+4);
		readipinterfaces();
		goto send;
	}

	/*
	 *  refresh all state
	 */
	if(strncmp(job-&gt;request.data, "refresh", 7)==0){
		netinit(1);
		goto send;
	}

	/* start transaction with a clean slate */
	cleanmf(mf);

	/*
	 *  look for a general query
	 */
	if(*job-&gt;request.data == '!'){
		err = genquery(mf, job-&gt;request.data+1);
		goto send;
	}

	if(debug)
		syslog(0, logfile, "write %s", job-&gt;request.data);
	if(paranoia)
		syslog(0, paranoiafile, "write %s by %s", job-&gt;request.data, mf-&gt;user);

	/*
	 *  break up name
	 */
	n = getfields(job-&gt;request.data, field, 4, 1, "!");
	switch(n){
	case 1:
		mf-&gt;net = strdup("net");
		mf-&gt;host = strdup(field[0]);
		break;
	case 4:
		mf-&gt;rem = strdup(field[3]);
		/* fall through */
	case 3:
		mf-&gt;serv = strdup(field[2]);
		/* fall through */
	case 2:
		mf-&gt;host = strdup(field[1]);
		mf-&gt;net = strdup(field[0]);
		break;
	}

	/*
	 *  do the first net worth of lookup
	 */
	if(lookup(mf) == 0){
		rerrstr(curerr, sizeof curerr);
		err = curerr;
	}
send:
	job-&gt;reply.count = cnt;
	sendmsg(job, err);
}

void
rclunk(Job *job, Mfile *mf)
{
	cleanmf(mf);
	free(mf-&gt;user);
	mf-&gt;user = 0;
	mf-&gt;busy = 0;
	mf-&gt;fid = 0;
	sendmsg(job, 0);
}

void
rremove(Job *job, Mfile *mf)
{
	USED(mf);
	sendmsg(job, "remove permission denied");
}

void
rstat(Job *job, Mfile *mf)
{
	Dir dir;
	uchar buf[IOHDRSZ+Maxfdata];

	memset(&amp;dir, 0, sizeof dir);
	if(mf-&gt;qid.type &amp; QTDIR){
		dir.name = ".";
		dir.mode = DMDIR|0555;
	} else {
		dir.name = "cs";
		dir.mode = 0666;
	}
	dir.qid = mf-&gt;qid;
	dir.length = 0;
	dir.uid = mf-&gt;user;
	dir.gid = mf-&gt;user;
	dir.muid = mf-&gt;user;
	dir.atime = dir.mtime = time(0);
	job-&gt;reply.nstat = convD2M(&amp;dir, buf, sizeof buf);
	job-&gt;reply.stat = buf;
	sendmsg(job, 0);
}

void
rwstat(Job *job, Mfile *mf)
{
	USED(mf);
	sendmsg(job, "wstat permission denied");
}

void
sendmsg(Job *job, char *err)
{
	int n;
	uchar mdata[IOHDRSZ + Maxfdata];
	char ename[ERRMAX];

	if(err){
		job-&gt;reply.type = Rerror;
		snprint(ename, sizeof(ename), "cs: %s", err);
		job-&gt;reply.ename = ename;
	}else{
		job-&gt;reply.type = job-&gt;request.type+1;
	}
	job-&gt;reply.tag = job-&gt;request.tag;
	n = convS2M(&amp;job-&gt;reply, mdata, sizeof mdata);
	if(n == 0){
		syslog(1, logfile, "sendmsg convS2M of %F returns 0", &amp;job-&gt;reply);
		abort();
	}
	lock(&amp;joblock);
	if(job-&gt;flushed == 0)
		if(write(mfd[1], mdata, n)!=n)
			error("mount write");
	unlock(&amp;joblock);
	if(debug)
		syslog(0, logfile, "%F %d", &amp;job-&gt;reply, n);
}

void
error(char *s)
{
	syslog(1, "cs", "%s: %r", s);
	_exits(0);
}

static int
isvalidip(uchar *ip)
{
	return ipcmp(ip, IPnoaddr) != 0 &amp;&amp; ipcmp(ip, v4prefix) != 0;
}

static uchar loopbacknet[IPaddrlen] = {
	0, 0, 0, 0,
	0, 0, 0, 0,
	0, 0, 0xff, 0xff,
	127, 0, 0, 0
};
static uchar loopbackmask[IPaddrlen] = {
	0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff,
	0xff, 0, 0, 0
};

void
readipinterfaces(void)
{
	if(myipaddr(ipa, mntpt) != 0)
		ipmove(ipa, IPnoaddr);
	sprint(ipaddr, "%I", ipa);
	if (debug)
		syslog(0, "dns", "ipaddr is %s\n", ipaddr);
}

/*
 *  get the system name
 */
void
ipid(void)
{
	uchar addr[6];
	Ndbtuple *t, *tt;
	char *p, *attr;
	Ndbs s;
	int f;
	char buf[Maxpath];

	/* use environment, ether addr, or ipaddr to get system name */
	if(mysysname == 0){
		/*
		 *  environment has priority.
		 *
		 *  on the sgi power the default system name
		 *  is the ip address.  ignore that.
		 *
		 */
		p = getenv("sysname");
		if(p &amp;&amp; *p){
			attr = ipattr(p);
			if(strcmp(attr, "ip") != 0)
				mysysname = strdup(p);
		}

		/*
		 *  the /net/ndb contains what the network
		 *  figured out from DHCP.  use that name if
		 *  there is one.
		 */
		if(mysysname == 0 &amp;&amp; netdb != nil){
			ndbreopen(netdb);
			for(tt = t = ndbparse(netdb); t != nil; t = t-&gt;entry){
				if(strcmp(t-&gt;attr, "sys") == 0){
					mysysname = strdup(t-&gt;val);
					break;
				}
			}
			ndbfree(tt);
		}

		/* next network database, ip address, and ether address to find a name */
		if(mysysname == 0){
			t = nil;
			if(isvalidip(ipa))
				free(ndbgetvalue(db, &amp;s, "ip", ipaddr, "sys", &amp;t));
			if(t == nil){
				for(f = 0; f &lt; 3; f++){
					snprint(buf, sizeof buf, "%s/ether%d", mntpt, f);
					if(myetheraddr(addr, buf) &gt;= 0){
						snprint(eaddr, sizeof(eaddr), "%E", addr);
						free(ndbgetvalue(db, &amp;s, "ether", eaddr, "sys", &amp;t));
						if(t != nil)
							break;
					}
				}
			}
			for(tt = t; tt != nil; tt = tt-&gt;entry){
				if(strcmp(tt-&gt;attr, "sys") == 0){
					mysysname = strdup(tt-&gt;val);
					break;
				}
			}
			ndbfree(t);
		}

		/* nothing else worked, use the ip address */
		if(mysysname == 0 &amp;&amp; isvalidip(ipa))
			mysysname = strdup(ipaddr);


		/* set /dev/sysname if we now know it */
		if(mysysname){
			f = open("/dev/sysname", OWRITE);
			if(f &gt;= 0){
				write(f, mysysname, strlen(mysysname));
				close(f);
			}
		}
	}
}

/*
 *  Set up a list of default networks by looking for
 *  /net/^*^/clone.
 */
void
netinit(int background)
{
	char clone[Maxpath];
	Network *np;
	static int working;

	if(background){
		switch(rfork(RFPROC|RFNOTEG|RFMEM|RFNOWAIT)){
		case 0:
			break;
		default:
			return;
		}
		lock(&amp;netlock);
	}

	/* add the mounted networks to the default list */
	for(np = network; np-&gt;net; np++){
		if(np-&gt;considered)
			continue;
		snprint(clone, sizeof(clone), "%s/%s/clone", mntpt, np-&gt;net);
		if(access(clone, AEXIST) &lt; 0)
			continue;
		if(netlist)
			last-&gt;next = np;
		else
			netlist = np;
		last = np;
		np-&gt;next = 0;
		np-&gt;considered = 1;
	}

	/* find out what our ip address is */
	readipinterfaces();

	/* set the system name if we need to, these days ip is all we have */
	ipid();

	if(debug)
		syslog(0, logfile, "mysysname %s eaddr %s ipaddr %s ipa %I\n",
			mysysname?mysysname:"???", eaddr, ipaddr, ipa);

	if(background){
		unlock(&amp;netlock);
		_exits(0);
	}
}

/*
 *  add networks to the standard list
 */
void
netadd(char *p)
{
	Network *np;
	char *field[12];
	int i, n;

	n = getfields(p, field, 12, 1, " ");
	for(i = 0; i &lt; n; i++){
		for(np = network; np-&gt;net; np++){
			if(strcmp(field[i], np-&gt;net) != 0)
				continue;
			if(np-&gt;considered)
				break;
			if(netlist)
				last-&gt;next = np;
			else
				netlist = np;
			last = np;
			np-&gt;next = 0;
			np-&gt;considered = 1;
		}
	}
}

int
lookforproto(Ndbtuple *t, char *proto)
{
	for(; t != nil; t = t-&gt;entry)
		if(strcmp(t-&gt;attr, "proto") == 0 &amp;&amp; strcmp(t-&gt;val, proto) == 0)
			return 1;
	return 0;
}

/*
 *  lookup a request.  the network "net" means we should pick the
 *  best network to get there.
 */
int
lookup(Mfile *mf)
{
	Network *np;
	char *cp;
	Ndbtuple *nt, *t;
	char reply[Maxreply];
	int i, rv;
	int hack;

	/* open up the standard db files */
	if(db == 0)
		ndbinit();
	if(db == 0)
		error("can't open mf-&gt;network database\n");

	rv = 0;

	if(mf-&gt;net == nil)
		return 0;	/* must have been a genquery */

	if(strcmp(mf-&gt;net, "net") == 0){
		/*
		 *  go through set of default nets
		 */
		for(np = mf-&gt;nextnet; np; np = np-&gt;next){
			nt = (*np-&gt;lookup)(np, mf-&gt;host, mf-&gt;serv, 1);
			if(nt == nil)
				continue;
			hack = np-&gt;fasttimeouthack &amp;&amp; !lookforproto(nt, np-&gt;net);
			for(t = nt; mf-&gt;nreply &lt; Nreply &amp;&amp; t; t = t-&gt;entry){
				cp = (*np-&gt;trans)(t, np, mf-&gt;serv, mf-&gt;rem, hack);
				if(cp){
					/* avoid duplicates */
					for(i = 0; i &lt; mf-&gt;nreply; i++)
						if(strcmp(mf-&gt;reply[i], cp) == 0)
							break;
					if(i == mf-&gt;nreply){
						/* save the reply */
						mf-&gt;replylen[mf-&gt;nreply] = strlen(cp);
						mf-&gt;reply[mf-&gt;nreply++] = cp;
						rv++;
					}
				}
			}
			ndbfree(nt);
			np = np-&gt;next;
			break;
		}
		mf-&gt;nextnet = np;
		return rv;
	}

	/*
	 *  if not /net, we only get one lookup
	 */
	if(mf-&gt;nreply != 0)
		return 0;
	/*
	 *  look for a specific network
	 */
	for(np = netlist; np &amp;&amp; np-&gt;net != nil; np++){
		if(np-&gt;fasttimeouthack)
			continue;
		if(strcmp(np-&gt;net, mf-&gt;net) == 0)
			break;
	}

	if(np &amp;&amp; np-&gt;net != nil){
		/*
		 *  known network
		 */
		nt = (*np-&gt;lookup)(np, mf-&gt;host, mf-&gt;serv, 1);
		for(t = nt; mf-&gt;nreply &lt; Nreply &amp;&amp; t; t = t-&gt;entry){
			cp = (*np-&gt;trans)(t, np, mf-&gt;serv, mf-&gt;rem, 0);
			if(cp){
				mf-&gt;replylen[mf-&gt;nreply] = strlen(cp);
				mf-&gt;reply[mf-&gt;nreply++] = cp;
				rv++;
			}
		}
		ndbfree(nt);
		return rv;
	} else {
		/*
		 *  not a known network, don't translate host or service
		 */
		if(mf-&gt;serv)
			snprint(reply, sizeof(reply), "%s/%s/clone %s!%s",
				mntpt, mf-&gt;net, mf-&gt;host, mf-&gt;serv);
		else
			snprint(reply, sizeof(reply), "%s/%s/clone %s",
				mntpt, mf-&gt;net, mf-&gt;host);
		mf-&gt;reply[0] = strdup(reply);
		mf-&gt;replylen[0] = strlen(reply);
		mf-&gt;nreply = 1;
		return 1;
	}
}

/*
 *  translate an ip service name into a port number.  If it's a numeric port
 *  number, look for restricted access.
 *
 *  the service '*' needs no translation.
 */
char*
ipserv(Network *np, char *name, char *buf, int blen)
{
	char *p;
	int alpha = 0;
	int restr = 0;
	char port[10];
	Ndbtuple *t, *nt;
	Ndbs s;

	/* '*' means any service */
	if(strcmp(name, "*")==0){
		strcpy(buf, name);
		return buf;
	}

	/*  see if it's numeric or symbolic */
	port[0] = 0;
	for(p = name; *p; p++){
		if(isdigit(*p))
			{}
		else if(isalpha(*p) || *p == '-' || *p == '$')
			alpha = 1;
		else
			return 0;
	}
	t = nil;
	p = nil;
	if(alpha){
		p = ndbgetvalue(db, &amp;s, np-&gt;net, name, "port", &amp;t);
		if(p == nil)
			return 0;
	} else {
		/* look up only for tcp ports &lt; 1024 to get the restricted
		 * attribute
		 */
		if(atoi(name) &lt; 1024 &amp;&amp; strcmp(np-&gt;net, "tcp") == 0)
			p = ndbgetvalue(db, &amp;s, "port", name, "port", &amp;t);
		if(p == nil)
			p = strdup(name);
	}

	if(t){
		for(nt = t; nt; nt = nt-&gt;entry)
			if(strcmp(nt-&gt;attr, "restricted") == 0)
				restr = 1;
		ndbfree(t);
	}
	snprint(buf, blen, "%s%s", p, restr ? "!r" : "");
	free(p);

	return buf;
}

/*
 *  lookup an ip attribute
 */
int
ipattrlookup(Ndb *db, char *ipa, char *attr, char *val, int vlen)
{

	Ndbtuple *t, *nt;
	char *alist[2];

	alist[0] = attr;
	t = ndbipinfo(db, "ip", ipa, alist, 1);
	if(t == nil)
		return 0;
	for(nt = t; nt != nil; nt = nt-&gt;entry){
		if(strcmp(nt-&gt;attr, attr) == 0){
			nstrcpy(val, nt-&gt;val, vlen);
			ndbfree(t);
			return 1;
		}
	}

	/* we shouldn't get here */
	ndbfree(t);
	return 0;
}

/*
 *  lookup (and translate) an ip destination
 */
Ndbtuple*
iplookup(Network *np, char *host, char *serv, int nolookup)
{
	char *attr, *dnsname;
	Ndbtuple *t, *nt;
	Ndbs s;
	char ts[Maxservice];
	char dollar[Maxhost];
	uchar ip[IPaddrlen];
	uchar net[IPaddrlen];
	uchar tnet[IPaddrlen];
	Ipifc *ifc;
	Iplifc *lifc;

	USED(nolookup);

	/*
	 *  start with the service since it's the most likely to fail
	 *  and costs the least
	 */
	werrstr("can't translate address");
	if(serv==0 || ipserv(np, serv, ts, sizeof ts) == 0){
		werrstr("can't translate service");
		return 0;
	}

	/* for dial strings with no host */
	if(strcmp(host, "*") == 0)
		return ndbnew("ip", "*");

	/*
	 *  hack till we go v6 :: = 0.0.0.0
	 */
	if(strcmp("::", host) == 0)
		return ndbnew("ip", "*");

	/*
	 *  '$' means the rest of the name is an attribute that we
	 *  need to search for
	 */
	if(*host == '$'){
		if(ipattrlookup(db, ipaddr, host+1, dollar, sizeof dollar))
			host = dollar;
	}

	/*
	 *  turn '[ip address]' into just 'ip address'
	 */
	if(*host == '[' &amp;&amp; host[strlen(host)-1] == ']'){
		host++;
		host[strlen(host)-1] = 0;
	}

	/*
	 *  just accept addresses
	 */
	attr = ipattr(host);
	if(strcmp(attr, "ip") == 0)
		return ndbnew("ip", host);

	/*
	 *  give the domain name server the first opportunity to
	 *  resolve domain names.  if that fails try the database.
	 */
	t = 0;
	werrstr("can't translate address");
	if(strcmp(attr, "dom") == 0)
		t = dnsiplookup(host, &amp;s);
	if(t == 0)
		free(ndbgetvalue(db, &amp;s, attr, host, "ip", &amp;t));
	if(t == 0){
		dnsname = ndbgetvalue(db, &amp;s, attr, host, "dom", nil);
		if(dnsname){
			t = dnsiplookup(dnsname, &amp;s);
			free(dnsname);
		}
	}
	if(t == 0)
		t = dnsiplookup(host, &amp;s);
	if(t == 0)
		return 0;

	/*
	 *  reorder the tuple to have the matched line first and
	 *  save that in the request structure.
	 */
	t = reorder(t, s.t);

	/*
	 * reorder according to our interfaces
	 */
	lock(&amp;ipifclock);
	for(ifc = ipifcs; ifc != nil; ifc = ifc-&gt;next){
		for(lifc = ifc-&gt;lifc; lifc != nil; lifc = lifc-&gt;next){
			maskip(lifc-&gt;ip, lifc-&gt;mask, net);
			for(nt = t; nt; nt = nt-&gt;entry){
				if(strcmp(nt-&gt;attr, "ip") != 0)
					continue;
				parseip(ip, nt-&gt;val);
				maskip(ip, lifc-&gt;mask, tnet);
				if(memcmp(net, tnet, IPaddrlen) == 0){
					t = reorder(t, nt);
					unlock(&amp;ipifclock);
					return t;
				}
			}
		}
	}
	unlock(&amp;ipifclock);

	return t;
}

/*
 *  translate an ip address
 */
char*
iptrans(Ndbtuple *t, Network *np, char *serv, char *rem, int hack)
{
	char ts[Maxservice];
	char reply[Maxreply];
	char x[Maxservice];

	if(strcmp(t-&gt;attr, "ip") != 0)
		return 0;

	if(serv == 0 || ipserv(np, serv, ts, sizeof ts) == 0){
		werrstr("can't translate service");
		return 0;
	}
	if(rem != nil)
		snprint(x, sizeof(x), "!%s", rem);
	else
		*x = 0;

	if(*t-&gt;val == '*')
		snprint(reply, sizeof(reply), "%s/%s/clone %s%s",
			mntpt, np-&gt;net, ts, x);
	else
		snprint(reply, sizeof(reply), "%s/%s/clone %s!%s%s%s",
			mntpt, np-&gt;net, t-&gt;val, ts, x, hack? "!fasttimeout": "");

	return strdup(reply);
}

/*
 *  lookup a telephone number
 */
Ndbtuple*
telcolookup(Network *np, char *host, char *serv, int nolookup)
{
	Ndbtuple *t;
	Ndbs s;

	USED(np, nolookup, serv);

	werrstr("can't translate address");
	free(ndbgetvalue(db, &amp;s, "sys", host, "telco", &amp;t));
	if(t == 0)
		return ndbnew("telco", host);

	return reorder(t, s.t);
}

/*
 *  translate a telephone address
 */
char*
telcotrans(Ndbtuple *t, Network *np, char *serv, char *rem, int)
{
	char reply[Maxreply];
	char x[Maxservice];

	if(strcmp(t-&gt;attr, "telco") != 0)
		return 0;

	if(rem != nil)
		snprint(x, sizeof(x), "!%s", rem);
	else
		*x = 0;
	if(serv)
		snprint(reply, sizeof(reply), "%s/%s/clone %s!%s%s", mntpt, np-&gt;net,
			t-&gt;val, serv, x);
	else
		snprint(reply, sizeof(reply), "%s/%s/clone %s%s", mntpt, np-&gt;net,
			t-&gt;val, x);
	return strdup(reply);
}

/*
 *  reorder the tuple to put x's line first in the entry
 */
Ndbtuple*
reorder(Ndbtuple *t, Ndbtuple *x)
{
	Ndbtuple *nt;
	Ndbtuple *line;

	/* find start of this entry's line */
	for(line = x; line-&gt;entry == line-&gt;line; line = line-&gt;line)
		;
	line = line-&gt;line;
	if(line == t)
		return t;	/* already the first line */

	/* remove this line and everything after it from the entry */
	for(nt = t; nt-&gt;entry != line; nt = nt-&gt;entry)
		;
	nt-&gt;entry = 0;

	/* make that the start of the entry */
	for(nt = line; nt-&gt;entry; nt = nt-&gt;entry)
		;
	nt-&gt;entry = t;
	return line;
}

/*
 *  create a slave process to handle a request to avoid one request blocking
 *  another.  parent returns to job loop.
 */
void
slave(char *host)
{
	if(*isslave)
		return;		/* we're already a slave process */

	switch(rfork(RFPROC|RFNOTEG|RFMEM|RFNOWAIT)){
	case -1:
		break;
	case 0:
		if(debug)
			syslog(0, logfile, "slave %d", getpid());
		procsetname("%s", host);
		*isslave = 1;
		break;
	default:
		longjmp(masterjmp, 1);
	}

}

static Ndbtuple*
dnsip6lookup(char *mntpt, char *buf, Ndbtuple *t)
{
	Ndbtuple *t6, *tt;

	t6 = dnsquery(mntpt, buf, "ipv6");	/* lookup AAAA dns RRs */
	if (t6 == nil)
		return t;

	/* convert ipv6 attr to ip */
	for (tt = t6; tt != nil; tt = tt-&gt;entry)
		if (strcmp(tt-&gt;attr, "ipv6") == 0)
			strncpy(tt-&gt;attr, "ip", sizeof tt-&gt;attr - 1);

	if (t == nil)
		return t6;

	/* append t6 list to t list */
	for (tt = t; tt-&gt;entry != nil; tt = tt-&gt;entry)
		;
	tt-&gt;entry = t6;
	return t;
}

/*
 *  call the dns process and have it try to translate a name
 */
Ndbtuple*
dnsiplookup(char *host, Ndbs *s)
{
	char buf[Maxreply];
	Ndbtuple *t;

	unlock(&amp;dblock);

	/* save the name before starting a slave */
	snprint(buf, sizeof(buf), "%s", host);

	slave(host);

	if(strcmp(ipattr(buf), "ip") == 0)
		t = dnsquery(mntpt, buf, "ptr");
	else {
		t = dnsquery(mntpt, buf, "ip");
		/* special case: query ipv6 (AAAA dns RR) too */
		if (ipv6lookups)
			t = dnsip6lookup(mntpt, buf, t);
	}
	s-&gt;t = t;

	if(t == nil){
		rerrstr(buf, sizeof buf);
		if(strstr(buf, "exist"))
			werrstr("can't translate address: %s", buf);
		else if(strstr(buf, "dns failure"))
			werrstr("temporary problem: %s", buf);
	}

	lock(&amp;dblock);
	return t;
}

int
qmatch(Ndbtuple *t, char **attr, char **val, int n)
{
	int i, found;
	Ndbtuple *nt;

	for(i = 1; i &lt; n; i++){
		found = 0;
		for(nt = t; nt; nt = nt-&gt;entry)
			if(strcmp(attr[i], nt-&gt;attr) == 0)
				if(strcmp(val[i], "*") == 0
				|| strcmp(val[i], nt-&gt;val) == 0){
					found = 1;
					break;
				}
		if(found == 0)
			break;
	}
	return i == n;
}

void
qreply(Mfile *mf, Ndbtuple *t)
{
	Ndbtuple *nt;
	String *s;

	s = s_new();
	for(nt = t; mf-&gt;nreply &lt; Nreply &amp;&amp; nt; nt = nt-&gt;entry){
		s_append(s, nt-&gt;attr);
		s_append(s, "=");
		s_append(s, nt-&gt;val);

		if(nt-&gt;line != nt-&gt;entry){
			mf-&gt;replylen[mf-&gt;nreply] = s_len(s);
			mf-&gt;reply[mf-&gt;nreply++] = strdup(s_to_c(s));
			s_restart(s);
		} else
			s_append(s, " ");
	}
	s_free(s);
}

enum
{
	Maxattr=	32,
};

/*
 *  generic query lookup.  The query is of one of the following
 *  forms:
 *
 *  attr1=val1 attr2=val2 attr3=val3 ...
 *
 *  returns the matching tuple
 *
 *  ipinfo attr=val attr1 attr2 attr3 ...
 *
 *  is like ipinfo and returns the attr{1-n}
 *  associated with the ip address.
 */
char*
genquery(Mfile *mf, char *query)
{
	int i, n;
	char *p;
	char *attr[Maxattr];
	char *val[Maxattr];
	Ndbtuple *t;
	Ndbs s;

	n = getfields(query, attr, nelem(attr), 1, " ");
	if(n == 0)
		return "bad query";

	if(strcmp(attr[0], "ipinfo") == 0)
		return ipinfoquery(mf, attr, n);

	/* parse pairs */
	for(i = 0; i &lt; n; i++){
		p = strchr(attr[i], '=');
		if(p == 0)
			return "bad query";
		*p++ = 0;
		val[i] = p;
	}

	/* give dns a chance */
	if((strcmp(attr[0], "dom") == 0 || strcmp(attr[0], "ip") == 0) &amp;&amp; val[0]){
		t = dnsiplookup(val[0], &amp;s);
		if(t){
			if(qmatch(t, attr, val, n)){
				qreply(mf, t);
				ndbfree(t);
				return 0;
			}
			ndbfree(t);
		}
	}

	/* first pair is always the key.  It can't be a '*' */
	t = ndbsearch(db, &amp;s, attr[0], val[0]);

	/* search is the and of all the pairs */
	while(t){
		if(qmatch(t, attr, val, n)){
			qreply(mf, t);
			ndbfree(t);
			return 0;
		}

		ndbfree(t);
		t = ndbsnext(&amp;s, attr[0], val[0]);
	}

	return "no match";
}

/*
 *  resolve an ip address
 */
static Ndbtuple*
ipresolve(char *attr, char *host)
{
	Ndbtuple *t, *nt, **l;

	t = iplookup(&amp;network[Ntcp], host, "*", 0);
	for(l = &amp;t; *l != nil; ){
		nt = *l;
		if(strcmp(nt-&gt;attr, "ip") != 0){
			*l = nt-&gt;entry;
			nt-&gt;entry = nil;
			ndbfree(nt);
			continue;
		}
		strcpy(nt-&gt;attr, attr);
		l = &amp;nt-&gt;entry;
	}
	return t;
}

char*
ipinfoquery(Mfile *mf, char **list, int n)
{
	int i, nresolve;
	int resolve[Maxattr];
	Ndbtuple *t, *nt, **l;
	char *attr, *val;

	/* skip 'ipinfo' */
	list++; n--;

	if(n &lt; 1)
		return "bad query";

	/* get search attribute=value, or assume ip=myipaddr */
	attr = *list;
	if((val = strchr(attr, '=')) != nil){
		*val++ = 0;
		list++;
		n--;
	}else{
		attr = "ip";
		val = ipaddr;
	}

	if(n &lt; 1)
		return "bad query";

	/*
	 *  don't let ndbipinfo resolve the addresses, we're
	 *  better at it.
	 */
	nresolve = 0;
	for(i = 0; i &lt; n; i++)
		if(*list[i] == '@'){		/* @attr=val ? */
			list[i]++;
			resolve[i] = 1;		/* we'll resolve it */
			nresolve++;
		} else
			resolve[i] = 0;

	t = ndbipinfo(db, attr, val, list, n);
	if(t == nil)
		return "no match";

	if(nresolve != 0){
		for(l = &amp;t; *l != nil;){
			nt = *l;

			/* already an address? */
			if(strcmp(ipattr(nt-&gt;val), "ip") == 0){
				l = &amp;(*l)-&gt;entry;
				continue;
			}

			/* user wants it resolved? */
			for(i = 0; i &lt; n; i++)
				if(strcmp(list[i], nt-&gt;attr) == 0)
					break;
			if(i &gt;= n || resolve[i] == 0){
				l = &amp;(*l)-&gt;entry;
				continue;
			}

			/* resolve address and replace entry */
			*l = ipresolve(nt-&gt;attr, nt-&gt;val);
			while(*l != nil)
				l = &amp;(*l)-&gt;entry;
			*l = nt-&gt;entry;

			nt-&gt;entry = nil;
			ndbfree(nt);
		}
	}

	/* make it all one line */
	for(nt = t; nt != nil; nt = nt-&gt;entry){
		if(nt-&gt;entry == nil)
			nt-&gt;line = t;
		else
			nt-&gt;line = nt-&gt;entry;
	}

	qreply(mf, t);

	return nil;
}

void*
emalloc(int size)
{
	void *x;

	x = malloc(size);
	if(x == nil)
		abort();
	memset(x, 0, size);
	return x;
}

char*
estrdup(char *s)
{
	int size;
	char *p;

	size = strlen(s)+1;
	p = malloc(size);
	if(p == nil)
		abort();
	memmove(p, s, size);
	return p;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

