<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnarea.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnarea.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

Area *owned, *delegated;

/*
 *  true if a name is in our area
 */
Area*
inmyarea(char *name)
{
	int len;
	Area *s, *d;

	len = strlen(name);
	for(s = owned; s; s = s-&gt;next){
		if(s-&gt;len &gt; len)
			continue;
		if(cistrcmp(s-&gt;soarr-&gt;owner-&gt;name, name + len - s-&gt;len) == 0)
			if(len == s-&gt;len || name[len - s-&gt;len - 1] == '.')
				break;
	}
	if(s == nil)
		return nil;

	/* name is in area `s' */
	for(d = delegated; d; d = d-&gt;next){
		if(d-&gt;len &gt; len)
			continue;
		if(cistrcmp(d-&gt;soarr-&gt;owner-&gt;name, name + len - d-&gt;len) == 0)
			if(len == d-&gt;len || name[len - d-&gt;len - 1] == '.')
				return nil; /* name is in a delegated subarea */
	}

	return s;	/* name is in area `s' and not in a delegated subarea */
}

/*
 *  our area is the part of the domain tree that
 *  we serve
 */
void
addarea(DN *dp, RR *rp, Ndbtuple *t)
{
	Area *s;
	Area **l;

	lock(&amp;dnlock);
	if(t-&gt;val[0])
		l = &amp;delegated;
	else
		l = &amp;owned;

	for (s = *l; s != nil; s = s-&gt;next)
		if (strcmp(dp-&gt;name, s-&gt;soarr-&gt;owner-&gt;name) == 0) {
			unlock(&amp;dnlock);
			return;		/* we've already got one */
		}

	/*
	 *  The area contains a copy of the soa rr that created it.
	 *  The owner of the the soa rr should stick around as long
	 *  as the area does.
	 */
	s = emalloc(sizeof(*s));
	s-&gt;len = strlen(dp-&gt;name);
	rrcopy(rp, &amp;s-&gt;soarr);
	s-&gt;soarr-&gt;owner = dp;
	s-&gt;soarr-&gt;db = 1;
	s-&gt;soarr-&gt;ttl = Hour;
	s-&gt;neednotify = 1;
	s-&gt;needrefresh = 0;

	if (debug)
		dnslog("new area %s %s", dp-&gt;name,
			l == &amp;delegated? "delegated": "owned");

	s-&gt;next = *l;
	*l = s;
	unlock(&amp;dnlock);
}

void
freearea(Area **l)
{
	Area *s;

	while(s = *l){
		*l = s-&gt;next;
		lock(&amp;dnlock);
		rrfree(s-&gt;soarr);
		memset(s, 0, sizeof *s);	/* cause trouble */
		unlock(&amp;dnlock);
		free(s);
	}
}

/*
 * refresh all areas that need it
 *  this entails running a command 'zonerefreshprogram'.  This could
 *  copy over databases from elsewhere or just do a zone transfer.
 */
void
refresh_areas(Area *s)
{
	int pid;
	Waitmsg *w;

	for(; s != nil; s = s-&gt;next){
		if(!s-&gt;needrefresh)
			continue;

		if(zonerefreshprogram == nil){
			s-&gt;needrefresh = 0;
			continue;
		}

		pid = fork();
		if (pid == -1) {
			sleep(1000);	/* don't fork again immediately */
			continue;
		}
		if (pid == 0){
			execl(zonerefreshprogram, "zonerefresh",
				s-&gt;soarr-&gt;owner-&gt;name, nil);
			exits("exec zonerefresh failed");
		}
		while ((w = wait()) != nil &amp;&amp; w-&gt;pid != pid)
			free(w);
		if (w &amp;&amp; w-&gt;pid == pid)
			if(w-&gt;msg == nil || *w-&gt;msg == '\0')
				s-&gt;needrefresh = 0;
		free(w);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

