<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnresolve.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnresolve.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * domain name resolvers, see rfcs 1035 and 1123
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include "dns.h"

typedef struct Dest Dest;
typedef struct Ipaddr Ipaddr;
typedef struct Query Query;

enum
{
	Udp, Tcp,

	Answerr=	-1,
	Answnone,

	Maxdest=	24,	/* maximum destinations for a request message */
	Maxoutstanding=	15,	/* max. outstanding queries per domain name */
	Remntretry=	15,	/* min. sec.s between /net.alt remount tries */

	/*
	 * these are the old values; we're trying longer timeouts now
	 * primarily for the benefit of remote nameservers querying us
	 * during times of bad connectivity.
	 */
//	Maxtrans=	3,	/* maximum transmissions to a server */
//	Maxretries=	3, /* cname+actual resends: was 32; have pity on user */
//	Maxwaitms=	1000,	/* wait no longer for a remote dns query */
//	Minwaitms=	100,	/* willing to wait for a remote dns query */

	Maxtrans=	5,	/* maximum transmissions to a server */
	Maxretries=	5, /* cname+actual resends: was 32; have pity on user */
	Maxwaitms=	5000,	/* wait no longer for a remote dns query */
	Minwaitms=	500,	/* willing to wait for a remote dns query */

	Destmagic=	0xcafebabe,
	Querymagic=	0xdeadbeef,
};
enum { Hurry, Patient, };
enum { Outns, Inns, };

struct Ipaddr {
	Ipaddr *next;
	uchar	ip[IPaddrlen];
};

struct Dest
{
	uchar	a[IPaddrlen];	/* ip address */
	DN	*s;		/* name server */
	int	nx;		/* number of transmissions */
	int	code;		/* response code; used to clear dp-&gt;respcode */

	ulong	magic;
};

/*
 * Query has a QLock in it, thus it can't be an automatic
 * variable, since each process would see a separate copy
 * of the lock on its stack.
 */
struct Query {
	DN	*dp;		/* domain */
	ushort	type;		/* and type to look up */
	Request *req;
	RR	*nsrp;		/* name servers to consult */

	/* dest must not be on the stack due to forking in slave() */
	Dest	*dest;		/* array of destinations */
	Dest	*curdest;	/* pointer to next to fill */
	int	ndest;		/* transmit to this many on this round */

	int	udpfd;

	QLock	tcplock;	/* only one tcp call at a time per query */
	int	tcpset;
	int	tcpfd;		/* if Tcp, read replies from here */
	int	tcpctlfd;
	uchar	tcpip[IPaddrlen];

	ulong	magic;
};

/* estimated % probability of such a record existing at all */
int likely[] = {
	[Ta]		95,
	[Taaaa]		10,
	[Tcname]	15,
	[Tmx]		60,
	[Tns]		90,
	[Tnull]		5,
	[Tptr]		35,
	[Tsoa]		90,
	[Tsrv]		60,
	[Ttxt]		15,
	[Tall]		95,
};

static RR*	dnresolve1(char*, int, int, Request*, int, int);
static int	netquery(Query *, int);

/*
 * reading /proc/pid/args yields either "name args" or "name [display args]",
 * so return only display args, if any.
 */
static char *
procgetname(void)
{
	int fd, n;
	char *lp, *rp;
	char buf[256];

	snprint(buf, sizeof buf, "#p/%d/args", getpid());
	if((fd = open(buf, OREAD)) &lt; 0)
		return strdup("");
	*buf = '\0';
	n = read(fd, buf, sizeof buf-1);
	close(fd);
	if (n &gt;= 0)
		buf[n] = '\0';
	if ((lp = strchr(buf, '[')) == nil ||
	    (rp = strrchr(buf, ']')) == nil)
		return strdup("");
	*rp = '\0';
	return strdup(lp+1);
}

void
rrfreelistptr(RR **rpp)
{
	RR *rp;

	if (rpp == nil || *rpp == nil)
		return;
	rp = *rpp;
	*rpp = nil;	/* update pointer in memory before freeing list */
	rrfreelist(rp);
}

/*
 *  lookup 'type' info for domain name 'name'.  If it doesn't exist, try
 *  looking it up as a canonical name.
 *
 *  this process can be quite slow if time-outs are set too high when querying
 *  nameservers that just don't respond to certain query types.  in that case,
 *  there will be multiple udp retries, multiple nameservers will be queried,
 *  and this will be repeated for a cname query.  the whole thing will be
 *  retried several times until we get an answer or a time-out.
 */
RR*
dnresolve(char *name, int class, int type, Request *req, RR **cn, int depth,
	int recurse, int rooted, int *status)
{
	RR *rp, *nrp, *drp;
	DN *dp;
	int loops;
	char *procname;
	char nname[Domlen];

	if(status)
		*status = 0;

	if(depth &gt; 12)			/* in a recursive loop? */
		return nil;

	procname = procgetname();
	/*
	 *  hack for systems that don't have resolve search
	 *  lists.  Just look up the simple name in the database.
	 */
	if(!rooted &amp;&amp; strchr(name, '.') == nil){
		rp = nil;
		drp = domainlist(class);
		for(nrp = drp; rp == nil &amp;&amp; nrp != nil; nrp = nrp-&gt;next){
			snprint(nname, sizeof nname, "%s.%s", name,
				nrp-&gt;ptr-&gt;name);
			rp = dnresolve(nname, class, type, req, cn, depth+1,
				recurse, rooted, status);
			lock(&amp;dnlock);
			rrfreelist(rrremneg(&amp;rp));
			unlock(&amp;dnlock);
		}
		if(drp != nil)
			rrfreelist(drp);
		procsetname(procname);
		free(procname);
		return rp;
	}

	/*
	 *  try the name directly
	 */
	rp = dnresolve1(name, class, type, req, depth, recurse);
	if(rp == nil) {
		/*
		 * try it as a canonical name if we weren't told
		 * that the name didn't exist
		 */
		dp = dnlookup(name, class, 0);
		if(type != Tptr &amp;&amp; dp-&gt;respcode != Rname)
			for(loops = 0; rp == nil &amp;&amp; loops &lt; Maxretries; loops++){
				/* retry cname, then the actual type */
				rp = dnresolve1(name, class, Tcname, req,
					depth, recurse);
				if(rp == nil)
					break;

				/* rp-&gt;host == nil shouldn't happen, but does */
				if(rp-&gt;negative || rp-&gt;host == nil){
					rrfreelist(rp);
					rp = nil;
					break;
				}

				name = rp-&gt;host-&gt;name;
				lock(&amp;dnlock);
				if(cn)
					rrcat(cn, rp);
				else
					rrfreelist(rp);
				unlock(&amp;dnlock);

				rp = dnresolve1(name, class, type, req,
					depth, recurse);
			}

		/* distinction between not found and not good */
		if(rp == nil &amp;&amp; status != nil &amp;&amp; dp-&gt;respcode != Rok)
			*status = dp-&gt;respcode;
	}
	procsetname(procname);
	free(procname);
	return randomize(rp);
}

static void
queryinit(Query *qp, DN *dp, int type, Request *req)
{
	memset(qp, 0, sizeof *qp);
	qp-&gt;udpfd = qp-&gt;tcpfd = qp-&gt;tcpctlfd = -1;
	qp-&gt;dp = dp;
	qp-&gt;type = type;
	if (qp-&gt;type != type)
		dnslog("queryinit: bogus type %d", type);
	qp-&gt;req = req;
	qp-&gt;nsrp = nil;
	qp-&gt;dest = qp-&gt;curdest = nil;
	qp-&gt;magic = Querymagic;
}

static void
queryck(Query *qp)
{
	assert(qp);
	assert(qp-&gt;magic == Querymagic);
}

static void
querydestroy(Query *qp)
{
	queryck(qp);
	/* leave udpfd open */
	if (qp-&gt;tcpfd &gt; 0)
		close(qp-&gt;tcpfd);
	if (qp-&gt;tcpctlfd &gt; 0) {
		hangup(qp-&gt;tcpctlfd);
		close(qp-&gt;tcpctlfd);
	}
	free(qp-&gt;dest);
	memset(qp, 0, sizeof *qp);	/* prevent accidents */
	qp-&gt;udpfd = qp-&gt;tcpfd = qp-&gt;tcpctlfd = -1;
}

static void
destinit(Dest *p)
{
	memset(p, 0, sizeof *p);
	p-&gt;magic = Destmagic;
}

static void
destck(Dest *p)
{
	assert(p);
	assert(p-&gt;magic == Destmagic);
}

/*
 * if the response to a query hasn't arrived within 100 ms.,
 * it's unlikely to arrive at all.  after 1 s., it's really unlikely.
 * queries for missing RRs are likely to produce time-outs rather than
 * negative responses, so cname and aaaa queries are likely to time out,
 * thus we don't wait very long for them.
 */
static void
notestats(vlong start, int tmout, int type)
{
	qlock(&amp;stats);
	if (tmout) {
		stats.tmout++;
		if (type == Taaaa)
			stats.tmoutv6++;
		else if (type == Tcname)
			stats.tmoutcname++;
	} else {
		long wait10ths = NS2MS(nsec() - start) / 100;

		if (wait10ths &lt;= 0)
			stats.under10ths[0]++;
		else if (wait10ths &gt;= nelem(stats.under10ths))
			stats.under10ths[nelem(stats.under10ths) - 1]++;
		else
			stats.under10ths[wait10ths]++;
	}
	qunlock(&amp;stats);
}

static void
noteinmem(void)
{
	qlock(&amp;stats);
	stats.answinmem++;
	qunlock(&amp;stats);
}

/* netquery with given name servers, free ns rrs when done */
static int
netqueryns(Query *qp, int depth, RR *nsrp)
{
	int rv;

	qp-&gt;nsrp = nsrp;
	rv = netquery(qp, depth);
	lock(&amp;dnlock);
	rrfreelist(nsrp);
	unlock(&amp;dnlock);
	return rv;
}

static RR*
issuequery(Query *qp, char *name, int class, int depth, int recurse)
{
	char *cp;
	DN *nsdp;
	RR *rp, *nsrp, *dbnsrp;

	/*
	 *  if we're running as just a resolver, query our
	 *  designated name servers
	 */
	if(cfg.resolver){
		nsrp = randomize(getdnsservers(class));
		if(nsrp != nil)
			if(netqueryns(qp, depth+1, nsrp) &gt; Answnone)
				return rrlookup(qp-&gt;dp, qp-&gt;type, OKneg);
	}

	/*
 	 *  walk up the domain name looking for
	 *  a name server for the domain.
	 */
	for(cp = name; cp; cp = walkup(cp)){
		/*
		 *  if this is a local (served by us) domain,
		 *  return answer
		 */
		dbnsrp = randomize(dblookup(cp, class, Tns, 0, 0));
		if(dbnsrp &amp;&amp; dbnsrp-&gt;local){
			rp = dblookup(name, class, qp-&gt;type, 1, dbnsrp-&gt;ttl);
			lock(&amp;dnlock);
			rrfreelist(dbnsrp);
			unlock(&amp;dnlock);
			return rp;
		}

		/*
		 *  if recursion isn't set, just accept local
		 *  entries
		 */
		if(recurse == Dontrecurse){
			if(dbnsrp) {
				lock(&amp;dnlock);
				rrfreelist(dbnsrp);
				unlock(&amp;dnlock);
			}
			continue;
		}

		/* look for ns in cache */
		nsdp = dnlookup(cp, class, 0);
		nsrp = nil;
		if(nsdp)
			nsrp = randomize(rrlookup(nsdp, Tns, NOneg));

		/* if the entry timed out, ignore it */
		if(nsrp &amp;&amp; nsrp-&gt;ttl &lt; now){
			lock(&amp;dnlock);
			rrfreelistptr(&amp;nsrp);
			unlock(&amp;dnlock);
		}

		if(nsrp){
			lock(&amp;dnlock);
			rrfreelistptr(&amp;dbnsrp);
			unlock(&amp;dnlock);

			/* query the name servers found in cache */
			if(netqueryns(qp, depth+1, nsrp) &gt; Answnone)
				return rrlookup(qp-&gt;dp, qp-&gt;type, OKneg);
		} else if(dbnsrp)
			/* try the name servers found in db */
			if(netqueryns(qp, depth+1, dbnsrp) &gt; Answnone)
				return rrlookup(qp-&gt;dp, qp-&gt;type, NOneg);
	}
	return nil;
}

static RR*
dnresolve1(char *name, int class, int type, Request *req, int depth,
	int recurse)
{
	Area *area;
	DN *dp;
	RR *rp;
	Query *qp;

	if(debug)
		dnslog("[%d] dnresolve1 %s %d %d", getpid(), name, type, class);

	/* only class Cin implemented so far */
	if(class != Cin)
		return nil;

	dp = dnlookup(name, class, 1);

	/*
	 *  Try the cache first
	 */
	rp = rrlookup(dp, type, OKneg);
	if(rp)
		if(rp-&gt;db){
			/* unauthoritative db entries are hints */
			if(rp-&gt;auth) {
				noteinmem();
				if(debug)
					dnslog("[%d] dnresolve1 %s %d %d: auth rr in db",
						getpid(), name, type, class);
				return rp;
			}
		} else
			/* cached entry must still be valid */
			if(rp-&gt;ttl &gt; now)
				/* but Tall entries are special */
				if(type != Tall || rp-&gt;query == Tall) {
					noteinmem();
					if(debug)
						dnslog("[%d] dnresolve1 %s %d %d: rr not in db",
							getpid(), name, type, class);
					return rp;
				}
	lock(&amp;dnlock);
	rrfreelist(rp);
	unlock(&amp;dnlock);
	rp = nil;		/* accident prevention */
	USED(rp);

	/*
	 * try the cache for a canonical name. if found punt
	 * since we'll find it during the canonical name search
	 * in dnresolve().
	 */
	if(type != Tcname){
		rp = rrlookup(dp, Tcname, NOneg);
		lock(&amp;dnlock);
		rrfreelist(rp);
		unlock(&amp;dnlock);
		if(rp){
			if(debug)
				dnslog("[%d] dnresolve1 %s %d %d: rr from rrlookup for non-cname",
					getpid(), name, type, class);
			return nil;
		}
	}

	/*
	 * if the domain name is within an area of ours,
	 * we should have found its data in memory by now.
	 */
	area = inmyarea(dp-&gt;name);
	if (area || strncmp(dp-&gt;name, "local#", 6) == 0) {
//		char buf[32];

//		dnslog("%s %s: no data in area %s", dp-&gt;name,
//			rrname(type, buf, sizeof buf), area-&gt;soarr-&gt;owner-&gt;name);
		return nil;
	}

	qp = emalloc(sizeof *qp);
	queryinit(qp, dp, type, req);
	rp = issuequery(qp, name, class, depth, recurse);
	querydestroy(qp);
	free(qp);
	if(rp){
		if(debug)
			dnslog("[%d] dnresolve1 %s %d %d: rr from query",
				getpid(), name, type, class);
		return rp;
	}

	/* settle for a non-authoritative answer */
	rp = rrlookup(dp, type, OKneg);
	if(rp){
		if(debug)
			dnslog("[%d] dnresolve1 %s %d %d: rr from rrlookup",
				getpid(), name, type, class);
		return rp;
	}

	/* noone answered.  try the database, we might have a chance. */
	rp = dblookup(name, class, type, 0, 0);
	if (rp) {
		if(debug)
			dnslog("[%d] dnresolve1 %s %d %d: rr from dblookup",
				getpid(), name, type, class);
	}else{
		if(debug)
			dnslog("[%d] dnresolve1 %s %d %d: no rr from dblookup; crapped out",
				getpid(), name, type, class);
	}
	return rp;
}

/*
 *  walk a domain name one element to the right.
 *  return a pointer to that element.
 *  in other words, return a pointer to the parent domain name.
 */
char*
walkup(char *name)
{
	char *cp;

	cp = strchr(name, '.');
	if(cp)
		return cp+1;
	else if(*name)
		return "";
	else
		return 0;
}

/*
 *  Get a udp port for sending requests and reading replies.  Put the port
 *  into "headers" mode.
 */
static char *hmsg = "headers";

int
udpport(char *mtpt)
{
	int fd, ctl;
	char ds[64], adir[64];

	/* get a udp port */
	snprint(ds, sizeof ds, "%s/udp!*!0", (mtpt? mtpt: "/net"));
	ctl = announce(ds, adir);
	if(ctl &lt; 0){
		/* warning("can't get udp port"); */
		return -1;
	}

	/* turn on header style interface */
	if(write(ctl, hmsg, strlen(hmsg)) != strlen(hmsg)){
		close(ctl);
		warning(hmsg);
		return -1;
	}

	/* grab the data file */
	snprint(ds, sizeof ds, "%s/data", adir);
	fd = open(ds, ORDWR);
	close(ctl);
	if(fd &lt; 0)
		warning("can't open udp port %s: %r", ds);
	return fd;
}

void
initdnsmsg(DNSmsg *mp, RR *rp, int flags, ushort reqno)
{
	mp-&gt;flags = flags;
	mp-&gt;id = reqno;
	mp-&gt;qd = rp;
	if(rp != nil)
		mp-&gt;qdcount = 1;
}

DNSmsg *
newdnsmsg(RR *rp, int flags, ushort reqno)
{
	DNSmsg *mp;

	mp = emalloc(sizeof *mp);
	initdnsmsg(mp, rp, flags, reqno);
	return mp;
}

/* generate a DNS UDP query packet */
int
mkreq(DN *dp, int type, uchar *buf, int flags, ushort reqno)
{
	DNSmsg m;
	int len;
	Udphdr *uh = (Udphdr*)buf;
	RR *rp;

	/* stuff port number into output buffer */
	memset(uh, 0, sizeof *uh);
	hnputs(uh-&gt;rport, Dnsport);

	/* make request and convert it to output format */
	memset(&amp;m, 0, sizeof m);
	rp = rralloc(type);
	rp-&gt;owner = dp;
	initdnsmsg(&amp;m, rp, flags, reqno);
	len = convDNS2M(&amp;m, &amp;buf[Udphdrsize], Maxdnspayload);
	rrfreelistptr(&amp;m.qd);
	memset(&amp;m, 0, sizeof m);		/* cause trouble */
	return len;
}

void
freeanswers(DNSmsg *mp)
{
	lock(&amp;dnlock);
	rrfreelistptr(&amp;mp-&gt;qd);
	rrfreelistptr(&amp;mp-&gt;an);
	rrfreelistptr(&amp;mp-&gt;ns);
	rrfreelistptr(&amp;mp-&gt;ar);
	unlock(&amp;dnlock);
	mp-&gt;qdcount = mp-&gt;ancount = mp-&gt;nscount = mp-&gt;arcount = 0;
}

/* timed read of reply.  sets srcip.  ibuf must be 64K to handle tcp answers. */
static int
readnet(Query *qp, int medium, uchar *ibuf, uvlong endms, uchar **replyp,
	uchar *srcip)
{
	int len, fd;
	long ms;
	vlong startns = nsec();
	uchar *reply;
	uchar lenbuf[2];

	len = -1;			/* pessimism */
	ms = endms - NS2MS(startns);
	if (ms &lt;= 0)
		return -1;		/* taking too long */

	reply = ibuf;
	memset(srcip, 0, IPaddrlen);
	alarm(ms);
	if (medium == Udp)
		if (qp-&gt;udpfd &lt;= 0)
			dnslog("readnet: qp-&gt;udpfd closed");
		else {
			len = read(qp-&gt;udpfd, ibuf, Udphdrsize+Maxpayload);
			alarm(0);
			notestats(startns, len &lt; 0, qp-&gt;type);
			if (len &gt;= IPaddrlen)
				memmove(srcip, ibuf, IPaddrlen);
			if (len &gt;= Udphdrsize) {
				len   -= Udphdrsize;
				reply += Udphdrsize;
			}
		}
	else {
		if (!qp-&gt;tcpset)
			dnslog("readnet: tcp params not set");
		fd = qp-&gt;tcpfd;
		if (fd &lt;= 0)
			dnslog("readnet: %s: tcp fd unset for dest %I",
				qp-&gt;dp-&gt;name, qp-&gt;tcpip);
		else if (readn(fd, lenbuf, 2) != 2) {
			dnslog("readnet: short read of 2-byte tcp msg size from %I",
				qp-&gt;tcpip);
			/* probably a time-out */
			notestats(startns, 1, qp-&gt;type);
		} else {
			len = lenbuf[0]&lt;&lt;8 | lenbuf[1];
			if (readn(fd, ibuf, len) != len) {
				dnslog("readnet: short read of tcp data from %I",
					qp-&gt;tcpip);
				/* probably a time-out */
				notestats(startns, 1, qp-&gt;type);
				len = -1;
			}
		}
		memmove(srcip, qp-&gt;tcpip, IPaddrlen);
	}
	alarm(0);
	*replyp = reply;
	return len;
}

/*
 *  read replies to a request and remember the rrs in the answer(s).
 *  ignore any of the wrong type.
 *  wait at most until endms.
 */
static int
readreply(Query *qp, int medium, ushort req, uchar *ibuf, DNSmsg *mp,
	uvlong endms)
{
	int len;
	char *err;
	char tbuf[32];
	uchar *reply;
	uchar srcip[IPaddrlen];
	RR *rp;

	queryck(qp);
	memset(mp, 0, sizeof *mp);
	memset(srcip, 0, sizeof srcip);
	if (0)
		len = -1;
	for (; timems() &lt; endms &amp;&amp;
	    (len = readnet(qp, medium, ibuf, endms, &amp;reply, srcip)) &gt;= 0;
	    freeanswers(mp)){
		/* convert into internal format  */
		memset(mp, 0, sizeof *mp);
		err = convM2DNS(reply, len, mp, nil);
		if (mp-&gt;flags &amp; Ftrunc) {
			free(err);
			freeanswers(mp);
			/* notify our caller to retry the query via tcp. */
			return -1;
		} else if(err){
			dnslog("readreply: %s: input err, len %d: %s: %I",
				qp-&gt;dp-&gt;name, len, err, srcip);
			free(err);
			continue;
		}
		if(debug)
			logreply(qp-&gt;req-&gt;id, srcip, mp);

		/* answering the right question? */
		if(mp-&gt;id != req)
			dnslog("%d: id %d instead of %d: %I", qp-&gt;req-&gt;id,
				mp-&gt;id, req, srcip);
		else if(mp-&gt;qd == 0)
			dnslog("%d: no question RR: %I", qp-&gt;req-&gt;id, srcip);
		else if(mp-&gt;qd-&gt;owner != qp-&gt;dp)
			dnslog("%d: owner %s instead of %s: %I", qp-&gt;req-&gt;id,
				mp-&gt;qd-&gt;owner-&gt;name, qp-&gt;dp-&gt;name, srcip);
		else if(mp-&gt;qd-&gt;type != qp-&gt;type)
			dnslog("%d: qp-&gt;type %d instead of %d: %I",
				qp-&gt;req-&gt;id, mp-&gt;qd-&gt;type, qp-&gt;type, srcip);
		else {
			/* remember what request this is in answer to */
			for(rp = mp-&gt;an; rp; rp = rp-&gt;next)
				rp-&gt;query = qp-&gt;type;
			return 0;
		}
	}
	if (timems() &gt;= endms) {
		;				/* query expired */
	} else if (0) {
		/* this happens routinely when a read times out */
		dnslog("readreply: %s type %s: ns %I read error or eof "
			"(returned %d): %r", qp-&gt;dp-&gt;name, rrname(qp-&gt;type,
			tbuf, sizeof tbuf), srcip, len);
		if (medium == Udp)
			for (rp = qp-&gt;nsrp; rp != nil; rp = rp-&gt;next)
				if (rp-&gt;type == Tns)
					dnslog("readreply: %s: query sent to "
						"ns %s", qp-&gt;dp-&gt;name,
						rp-&gt;host-&gt;name);
	}
	return -1;
}

/*
 *	return non-0 if first list includes second list
 */
int
contains(RR *rp1, RR *rp2)
{
	RR *trp1, *trp2;

	for(trp2 = rp2; trp2; trp2 = trp2-&gt;next){
		for(trp1 = rp1; trp1; trp1 = trp1-&gt;next)
			if(trp1-&gt;type == trp2-&gt;type)
			if(trp1-&gt;host == trp2-&gt;host)
			if(trp1-&gt;owner == trp2-&gt;owner)
				break;
		if(trp1 == nil)
			return 0;
	}
	return 1;
}


/*
 *  return multicast version if any
 */
int
ipisbm(uchar *ip)
{
	if(isv4(ip)){
		if (ip[IPv4off] &gt;= 0xe0 &amp;&amp; ip[IPv4off] &lt; 0xf0 ||
		    ipcmp(ip, IPv4bcast) == 0)
			return 4;
	} else
		if(ip[0] == 0xff)
			return 6;
	return 0;
}

/*
 *  Get next server address(es) into qp-&gt;dest[nd] and beyond
 */
static int
serveraddrs(Query *qp, int nd, int depth)
{
	RR *rp, *arp, *trp;
	Dest *cur;

	if(nd &gt;= Maxdest)		/* dest array is full? */
		return Maxdest - 1;

	/*
	 *  look for a server whose address we already know.
	 *  if we find one, mark it so we ignore this on
	 *  subsequent passes.
	 */
	arp = 0;
	for(rp = qp-&gt;nsrp; rp; rp = rp-&gt;next){
		assert(rp-&gt;magic == RRmagic);
		if(rp-&gt;marker)
			continue;
		arp = rrlookup(rp-&gt;host, Ta, NOneg);
		if(arp == nil)
			arp = rrlookup(rp-&gt;host, Taaaa, NOneg);
		if(arp){
			rp-&gt;marker = 1;
			break;
		}
		arp = dblookup(rp-&gt;host-&gt;name, Cin, Ta, 0, 0);
		if(arp == nil)
			arp = dblookup(rp-&gt;host-&gt;name, Cin, Taaaa, 0, 0);
		if(arp){
			rp-&gt;marker = 1;
			break;
		}
	}

	/*
	 *  if the cache and database lookup didn't find any new
	 *  server addresses, try resolving one via the network.
	 *  Mark any we try to resolve so we don't try a second time.
	 */
	if(arp == 0)
		for(rp = qp-&gt;nsrp; rp; rp = rp-&gt;next){
			if(rp-&gt;marker)
				continue;
			rp-&gt;marker = 1;

			/*
			 *  avoid loops looking up a server under itself
			 */
			if(subsume(rp-&gt;owner-&gt;name, rp-&gt;host-&gt;name))
				continue;

			arp = dnresolve(rp-&gt;host-&gt;name, Cin, Ta, qp-&gt;req, 0,
				depth+1, Recurse, 1, 0);
			if(arp == nil)
				arp = dnresolve(rp-&gt;host-&gt;name, Cin, Taaaa,
					qp-&gt;req, 0, depth+1, Recurse, 1, 0);
			lock(&amp;dnlock);
			rrfreelist(rrremneg(&amp;arp));
			unlock(&amp;dnlock);
			if(arp)
				break;
		}

	/* use any addresses that we found */
	for(trp = arp; trp &amp;&amp; nd &lt; Maxdest; trp = trp-&gt;next){
		cur = &amp;qp-&gt;dest[nd];
		parseip(cur-&gt;a, trp-&gt;ip-&gt;name);
		/*
		 * straddling servers can reject all nameservers if they are all
		 * inside, so be sure to list at least one outside ns at
		 * the end of the ns list in /lib/ndb for `dom='.
		 */
		if (ipisbm(cur-&gt;a) ||
		    cfg.straddle &amp;&amp; !insideaddr(qp-&gt;dp-&gt;name) &amp;&amp; insidens(cur-&gt;a))
			continue;
		cur-&gt;nx = 0;
		cur-&gt;s = trp-&gt;owner;
		cur-&gt;code = Rtimeout;
		nd++;
	}
	lock(&amp;dnlock);
	rrfreelist(arp);
	unlock(&amp;dnlock);
	if(nd &gt;= Maxdest)		/* dest array is full? */
		return Maxdest - 1;
	return nd;
}

/*
 *  cache negative responses
 */
static void
cacheneg(DN *dp, int type, int rcode, RR *soarr)
{
	RR *rp;
	DN *soaowner;
	ulong ttl;

	stats.negcached++;

	/* no cache time specified, don't make anything up */
	if(soarr != nil){
		lock(&amp;dnlock);
		if(soarr-&gt;next != nil)
			rrfreelistptr(&amp;soarr-&gt;next);
		unlock(&amp;dnlock);
		soaowner = soarr-&gt;owner;
	} else
		soaowner = nil;

	/* the attach can cause soarr to be freed so mine it now */
	if(soarr != nil &amp;&amp; soarr-&gt;soa != nil)
		ttl = soarr-&gt;soa-&gt;minttl+now;
	else
		ttl = 5*Min;

	/* add soa and negative RR to the database */
	rrattach(soarr, Authoritative);

	rp = rralloc(type);
	rp-&gt;owner = dp;
	rp-&gt;negative = 1;
	rp-&gt;negsoaowner = soaowner;
	rp-&gt;negrcode = rcode;
	rp-&gt;ttl = ttl;
	rrattach(rp, Authoritative);
}

static int
setdestoutns(Dest *p, int n)
{
	uchar *outns = outsidens(n);

	destck(p);
	destinit(p);
	if (outns == nil) {
		if (n == 0)
			dnslog("[%d] no outside-ns in ndb", getpid());
		return -1;
	}
	memmove(p-&gt;a, outns, sizeof p-&gt;a);
	p-&gt;s = dnlookup("outside-ns-ips", Cin, 1);
	return 0;
}

/*
 * issue query via UDP or TCP as appropriate.
 * for TCP, returns with qp-&gt;tcpip set from udppkt header.
 */
static int
mydnsquery(Query *qp, int medium, uchar *udppkt, int len)
{
	int rv = -1, nfd;
	char *domain;
	char conndir[NETPATHLEN], net[NETPATHLEN];
	uchar belen[2];
	NetConnInfo *nci;

	queryck(qp);
	domain = smprint("%I", udppkt);
	if (myaddr(domain)) {
		dnslog("mydnsquery: trying to send to myself (%s); bzzzt",
			domain);
		free(domain);
		return rv;
	}

	switch (medium) {
	case Udp:
		free(domain);
		nfd = dup(qp-&gt;udpfd, -1);
		if (nfd &lt; 0) {
			warning("mydnsquery: qp-&gt;udpfd %d: %r", qp-&gt;udpfd);
			close(qp-&gt;udpfd);	/* ensure it's closed */
			qp-&gt;udpfd = -1;		/* poison it */
			return rv;
		}
		close(nfd);

		if (qp-&gt;udpfd &lt;= 0)
			dnslog("mydnsquery: qp-&gt;udpfd %d closed", qp-&gt;udpfd);
		else {
			if (write(qp-&gt;udpfd, udppkt, len+Udphdrsize) !=
			    len+Udphdrsize)
				warning("sending udp msg: %r");
			else {
				stats.qsent++;
				rv = 0;
			}
		}
		break;
	case Tcp:
		/* send via TCP &amp; keep fd around for reply */
		snprint(net, sizeof net, "%s/tcp",
			(mntpt[0] != '\0'? mntpt: "/net"));
		alarm(10*1000);
		qp-&gt;tcpfd = rv = dial(netmkaddr(domain, net, "dns"), nil,
			conndir, &amp;qp-&gt;tcpctlfd);
		alarm(0);
		if (qp-&gt;tcpfd &lt; 0) {
			dnslog("can't dial tcp!%s!dns: %r", domain);
			free(domain);
			break;
		}
		free(domain);
		nci = getnetconninfo(conndir, qp-&gt;tcpfd);
		if (nci) {
			parseip(qp-&gt;tcpip, nci-&gt;rsys);
			freenetconninfo(nci);
		} else
			dnslog("mydnsquery: getnetconninfo failed");
		qp-&gt;tcpset = 1;

		belen[0] = len &gt;&gt; 8;
		belen[1] = len;
		if (write(qp-&gt;tcpfd, belen, 2) != 2 ||
		    write(qp-&gt;tcpfd, udppkt + Udphdrsize, len) != len)
			warning("sending tcp msg: %r");
		break;
	default:
		sysfatal("mydnsquery: bad medium");
	}
	return rv;
}

/*
 * send query to all UDP destinations or one TCP destination,
 * taken from obuf (udp packet) header
 */
static int
xmitquery(Query *qp, int medium, int depth, uchar *obuf, int inns, int len)
{
	int j, n;
	char buf[32];
	Dest *p;

	queryck(qp);
	if(timems() &gt;= qp-&gt;req-&gt;aborttime)
		return -1;

	/*
	 * get a nameserver address if we need one.
	 * serveraddrs populates qp-&gt;dest.
	 */
	p = qp-&gt;dest;
	destck(p);
	if (qp-&gt;ndest &lt; 0 || qp-&gt;ndest &gt; Maxdest) {
		dnslog("qp-&gt;ndest %d out of range", qp-&gt;ndest);
		abort();
	}
	/*
	 * we're to transmit to more destinations than we currently have,
	 * so get another.
	 */
	if (qp-&gt;ndest &gt; qp-&gt;curdest - p) {
		j = serveraddrs(qp, qp-&gt;curdest - p, depth);
		if (j &lt; 0 || j &gt;= Maxdest) {
			dnslog("serveraddrs() result %d out of range", j);
			abort();
		}
		qp-&gt;curdest = &amp;qp-&gt;dest[j];
	}
	destck(qp-&gt;curdest);

	/* no servers, punt */
	if (qp-&gt;ndest == 0)
		if (cfg.straddle &amp;&amp; cfg.inside) {
			/* get ips of "outside-ns-ips" */
			qp-&gt;curdest = qp-&gt;dest;
			for(n = 0; n &lt; Maxdest; n++, qp-&gt;curdest++)
				if (setdestoutns(qp-&gt;curdest, n) &lt; 0)
					break;
			if(n == 0)
				dnslog("xmitquery: %s: no outside-ns nameservers",
					qp-&gt;dp-&gt;name);
		} else
			/* it's probably just a bogus domain, don't log it */
			return -1;

	/* send to first 'qp-&gt;ndest' destinations */
	j = 0;
	if (medium == Tcp) {
		j++;
		queryck(qp);
		assert(qp-&gt;dp);
		procsetname("tcp %sside query for %s %s", (inns? "in": "out"),
			qp-&gt;dp-&gt;name, rrname(qp-&gt;type, buf, sizeof buf));
		mydnsquery(qp, medium, obuf, len); /* sets qp-&gt;tcpip from obuf */
		if(debug)
			logsend(qp-&gt;req-&gt;id, depth, qp-&gt;tcpip, "", qp-&gt;dp-&gt;name,
				qp-&gt;type);
	} else
		for(; p &lt; &amp;qp-&gt;dest[qp-&gt;ndest] &amp;&amp; p &lt; qp-&gt;curdest; p++){
			/* skip destinations we've finished with */
			if(p-&gt;nx &gt;= Maxtrans)
				continue;

			j++;

			/* exponential backoff of requests */
			if((1&lt;&lt;p-&gt;nx) &gt; qp-&gt;ndest)
				continue;

			if(memcmp(p-&gt;a, IPnoaddr, sizeof IPnoaddr) == 0)
				continue;		/* mistake */

			procsetname("udp %sside query to %I/%s %s %s",
				(inns? "in": "out"), p-&gt;a, p-&gt;s-&gt;name,
				qp-&gt;dp-&gt;name, rrname(qp-&gt;type, buf, sizeof buf));
			if(debug)
				logsend(qp-&gt;req-&gt;id, depth, p-&gt;a, p-&gt;s-&gt;name,
					qp-&gt;dp-&gt;name, qp-&gt;type);

			/* fill in UDP destination addr &amp; send it */
			memmove(obuf, p-&gt;a, sizeof p-&gt;a);
			mydnsquery(qp, medium, obuf, len);
			p-&gt;nx++;
		}
	if(j == 0) {
		return -1;
	}
	return 0;
}

static int lckindex[Maxlcks] = {
	0,			/* all others map here */
	Ta,
	Tns,
	Tcname,
	Tsoa,
	Tptr,
	Tmx,
	Ttxt,
	Taaaa,
};

static int
qtype2lck(int qtype)		/* map query type to querylck index */
{
	int i;

	for (i = 1; i &lt; nelem(lckindex); i++)
		if (lckindex[i] == qtype)
			return i;
	return 0;
}

/* is mp a cachable negative response (with Rname set)? */
static int
isnegrname(DNSmsg *mp)
{
	/* TODO: could add || cfg.justforw to RHS of &amp;&amp; */
	return mp-&gt;an == nil &amp;&amp; (mp-&gt;flags &amp; Rmask) == Rname;
}

/* returns Answerr (-1) on errors, else number of answers, which can be zero. */
static int
procansw(Query *qp, DNSmsg *mp, uchar *srcip, int depth, Dest *p)
{
	int rv;
//	int lcktype;
	char buf[32];
	DN *ndp;
	Query *nqp;
	RR *tp, *soarr;

	if (mp-&gt;an == nil)
		stats.negans++;

	/* ignore any error replies */
	if((mp-&gt;flags &amp; Rmask) == Rserver){
		stats.negserver++;
		freeanswers(mp);
		if(p != qp-&gt;curdest)
			p-&gt;code = Rserver;
		return Answerr;
	}

	/* ignore any bad delegations */
	if(mp-&gt;ns &amp;&amp; baddelegation(mp-&gt;ns, qp-&gt;nsrp, srcip)){
		stats.negbaddeleg++;
		if(mp-&gt;an == nil){
			stats.negbdnoans++;
			freeanswers(mp);
			if(p != qp-&gt;curdest)
				p-&gt;code = Rserver;
			dnslog(" and no answers");
			return Answerr;
		}
		dnslog(" but has answers; ignoring ns");
		lock(&amp;dnlock);
		rrfreelistptr(&amp;mp-&gt;ns);
		unlock(&amp;dnlock);
		mp-&gt;nscount = 0;
	}

	/* remove any soa's from the authority section */
	lock(&amp;dnlock);
	soarr = rrremtype(&amp;mp-&gt;ns, Tsoa);

	/* incorporate answers */
	unique(mp-&gt;an);
	unique(mp-&gt;ns);
	unique(mp-&gt;ar);
	unlock(&amp;dnlock);

	if(mp-&gt;an)
		rrattach(mp-&gt;an, (mp-&gt;flags &amp; Fauth) != 0);
	if(mp-&gt;ar)
		rrattach(mp-&gt;ar, Notauthoritative);
	if(mp-&gt;ns &amp;&amp; !cfg.justforw){
		ndp = mp-&gt;ns-&gt;owner;
		rrattach(mp-&gt;ns, Notauthoritative);
	} else {
		ndp = nil;
		lock(&amp;dnlock);
		rrfreelistptr(&amp;mp-&gt;ns);
		unlock(&amp;dnlock);
		mp-&gt;nscount = 0;
	}

	/* free the question */
	if(mp-&gt;qd) {
		lock(&amp;dnlock);
		rrfreelistptr(&amp;mp-&gt;qd);
		unlock(&amp;dnlock);
		mp-&gt;qdcount = 0;
	}

	/*
	 *  Any reply from an authoritative server,
	 *  or a positive reply terminates the search.
	 *  A negative response now also terminates the search.
	 */
	if(mp-&gt;an != nil || (mp-&gt;flags &amp; Fauth)){
		if(isnegrname(mp))
			qp-&gt;dp-&gt;respcode = Rname;
		else
			qp-&gt;dp-&gt;respcode = Rok;

		/*
		 *  cache any negative responses, free soarr.
		 *  negative responses need not be authoritative:
		 *  they can legitimately come from a cache.
		 */
		if( /* (mp-&gt;flags &amp; Fauth) &amp;&amp; */ mp-&gt;an == nil)
			cacheneg(qp-&gt;dp, qp-&gt;type, (mp-&gt;flags &amp; Rmask), soarr);
		else {
			lock(&amp;dnlock);
			rrfreelist(soarr);
			unlock(&amp;dnlock);
		}
		return 1;
	} else if (isnegrname(mp)) {
		qp-&gt;dp-&gt;respcode = Rname;
		/*
		 *  cache negative response.
		 *  negative responses need not be authoritative:
		 *  they can legitimately come from a cache.
		 */
		cacheneg(qp-&gt;dp, qp-&gt;type, (mp-&gt;flags &amp; Rmask), soarr);
		return 1;
	}
	stats.negnorname++;
	lock(&amp;dnlock);
	rrfreelist(soarr);
	unlock(&amp;dnlock);

	/*
	 *  if we've been given better name servers, recurse.
	 *  if we're a pure resolver, don't recurse, we have
	 *  to forward to a fixed set of named servers.
	 */
	if(!mp-&gt;ns || cfg.resolver &amp;&amp; cfg.justforw)
		return Answnone;
	tp = rrlookup(ndp, Tns, NOneg);
	if(contains(qp-&gt;nsrp, tp)){
		lock(&amp;dnlock);
		rrfreelist(tp);
		unlock(&amp;dnlock);
		return Answnone;
	}
	procsetname("recursive query for %s %s", qp-&gt;dp-&gt;name,
		rrname(qp-&gt;type, buf, sizeof buf));
	/*
	 *  we're called from udpquery, called from
	 *  netquery, which current holds qp-&gt;dp-&gt;querylck,
	 *  so release it now and acquire it upon return.
	 */
//	lcktype = qtype2lck(qp-&gt;type);		/* someday try this again */
//	qunlock(&amp;qp-&gt;dp-&gt;querylck[lcktype]);

	nqp = emalloc(sizeof *nqp);
	queryinit(nqp, qp-&gt;dp, qp-&gt;type, qp-&gt;req);
	nqp-&gt;nsrp = tp;
	rv = netquery(nqp, depth+1);

//	qlock(&amp;qp-&gt;dp-&gt;querylck[lcktype]);
	rrfreelist(nqp-&gt;nsrp);
	querydestroy(nqp);
	free(nqp);
	return rv;
}

/*
 * send a query via tcp to a single address (from ibuf's udp header)
 * and read the answer(s) into mp-&gt;an.
 */
static int
tcpquery(Query *qp, DNSmsg *mp, int depth, uchar *ibuf, uchar *obuf, int len,
	ulong waitms, int inns, ushort req)
{
	int rv = 0;
	uvlong endms;

	endms = timems() + waitms;
	if(endms &gt; qp-&gt;req-&gt;aborttime)
		endms = qp-&gt;req-&gt;aborttime;

	if (0)
		dnslog("%s: udp reply truncated; retrying query via tcp to %I",
			qp-&gt;dp-&gt;name, qp-&gt;tcpip);

	qlock(&amp;qp-&gt;tcplock);
	memmove(obuf, ibuf, IPaddrlen);		/* send back to respondent */
	/* sets qp-&gt;tcpip from obuf's udp header */
	if (xmitquery(qp, Tcp, depth, obuf, inns, len) &lt; 0 ||
	    readreply(qp, Tcp, req, ibuf, mp, endms) &lt; 0)
		rv = -1;
	if (qp-&gt;tcpfd &gt; 0) {
		hangup(qp-&gt;tcpctlfd);
		close(qp-&gt;tcpctlfd);
		close(qp-&gt;tcpfd);
	}
	qp-&gt;tcpfd = qp-&gt;tcpctlfd = -1;
	qunlock(&amp;qp-&gt;tcplock);
	return rv;
}

/*
 *  query name servers.  fill in obuf with on-the-wire representation of a
 *  DNSmsg derived from qp.  if the name server returns a pointer to another
 *  name server, recurse.
 */
static int
queryns(Query *qp, int depth, uchar *ibuf, uchar *obuf, ulong waitms, int inns)
{
	int ndest, len, replywaits, rv;
	ushort req;
	uvlong endms;
	char buf[12];
	uchar srcip[IPaddrlen];
	Dest *p, *np, *dest;

	/* pack request into a udp message */
	req = rand();
	len = mkreq(qp-&gt;dp, qp-&gt;type, obuf, Frecurse|Oquery, req);

	/* no server addresses yet */
	queryck(qp);
	dest = emalloc(Maxdest * sizeof *dest);	/* dest can't be on stack */
	for (p = dest; p &lt; dest + Maxdest; p++)
		destinit(p);
	/* this dest array is local to this call of queryns() */
	free(qp-&gt;dest);
	qp-&gt;curdest = qp-&gt;dest = dest;

	/*
	 *  transmit udp requests and wait for answers.
	 *  at most Maxtrans attempts to each address.
	 *  each cycle send one more message than the previous.
	 *  retry a query via tcp if its response is truncated.
	 */
	for(ndest = 1; ndest &lt; Maxdest; ndest++){
		qp-&gt;ndest = ndest;
		qp-&gt;tcpset = 0;
		if (xmitquery(qp, Udp, depth, obuf, inns, len) &lt; 0)
			break;

		endms = timems() + waitms;
		if(endms &gt; qp-&gt;req-&gt;aborttime)
			endms = qp-&gt;req-&gt;aborttime;

		for(replywaits = 0; replywaits &lt; ndest; replywaits++){
			DNSmsg m;

			procsetname("reading %sside reply from %I: %s %s from %s",
				(inns? "in": "out"), obuf, qp-&gt;dp-&gt;name,
				rrname(qp-&gt;type, buf, sizeof buf), qp-&gt;req-&gt;from);

			/* read udp answer into m */
			if (readreply(qp, Udp, req, ibuf, &amp;m, endms) &gt;= 0)
				memmove(srcip, ibuf, IPaddrlen);
			else if (!(m.flags &amp; Ftrunc)) {
				freeanswers(&amp;m);
				break;		/* timed out on this dest */
			} else {
				/* whoops, it was truncated! ask again via tcp */
				freeanswers(&amp;m);
				rv = tcpquery(qp, &amp;m, depth, ibuf, obuf, len,
					waitms, inns, req);  /* answer in m */
				if (rv &lt; 0) {
					freeanswers(&amp;m);
					break;		/* failed via tcp too */
				}
				memmove(srcip, qp-&gt;tcpip, IPaddrlen);
			}

			/* find responder */
			// dnslog("queryns got reply from %I", srcip);
			for(p = qp-&gt;dest; p &lt; qp-&gt;curdest; p++)
				if(memcmp(p-&gt;a, srcip, sizeof p-&gt;a) == 0)
					break;

			/* remove all addrs of responding server from list */
			for(np = qp-&gt;dest; np &lt; qp-&gt;curdest; np++)
				if(np-&gt;s == p-&gt;s)
					np-&gt;nx = Maxtrans;

			/* free or incorporate RRs in m */
			rv = procansw(qp, &amp;m, srcip, depth, p);
			if (rv &gt; Answnone) {
				free(qp-&gt;dest);
				qp-&gt;dest = qp-&gt;curdest = nil; /* prevent accidents */
				return rv;
			}
		}
	}

	/* if all servers returned failure, propagate it */
	qp-&gt;dp-&gt;respcode = Rserver;
	for(p = dest; p &lt; qp-&gt;curdest; p++) {
		destck(p);
		if(p-&gt;code != Rserver)
			qp-&gt;dp-&gt;respcode = Rok;
		p-&gt;magic = 0;			/* prevent accidents */
	}

//	if (qp-&gt;dp-&gt;respcode)
//		dnslog("queryns setting Rserver for %s", qp-&gt;dp-&gt;name);

	free(qp-&gt;dest);
	qp-&gt;dest = qp-&gt;curdest = nil;		/* prevent accidents */
	return Answnone;
}

/*
 *  run a command with a supplied fd as standard input
 */
char *
system(int fd, char *cmd)
{
	int pid, p, i;
	static Waitmsg msg;

	if((pid = fork()) == -1)
		sysfatal("fork failed: %r");
	else if(pid == 0){
		dup(fd, 0);
		close(fd);
		for (i = 3; i &lt; 200; i++)
			close(i);		/* don't leak fds */
		execl("/bin/rc", "rc", "-c", cmd, nil);
		sysfatal("exec rc: %r");
	}
	for(p = waitpid(); p &gt;= 0; p = waitpid())
		if(p == pid)
			return msg.msg;
	return "lost child";
}

/* compute wait, weighted by probability of success, with bounds */
static ulong
weight(ulong ms, unsigned pcntprob)
{
	ulong wait;

	wait = (ms * pcntprob) / 100;
	if (wait &lt; Minwaitms)
		wait = Minwaitms;
	if (wait &gt; Maxwaitms)
		wait = Maxwaitms;
	return wait;
}

/*
 * in principle we could use a single descriptor for a udp port
 * to send all queries and receive all the answers to them,
 * but we'd have to sort out the answers by dns-query id.
 */
static int
udpquery(Query *qp, char *mntpt, int depth, int patient, int inns)
{
	int fd, rv;
	ulong now, pcntprob;
	uvlong wait, reqtm;
	char *msg;
	uchar *obuf, *ibuf;
	static QLock mntlck;
	static ulong lastmount;

	/* use alloced buffers rather than ones from the stack */
	ibuf = emalloc(64*1024);		/* max. tcp reply size */
	obuf = emalloc(Maxpayload+Udphdrsize);

	fd = udpport(mntpt);
	while (fd &lt; 0 &amp;&amp; cfg.straddle &amp;&amp; strcmp(mntpt, "/net.alt") == 0) {
		/* HACK: remount /net.alt */
		now = time(nil);
		if (now &lt; lastmount + Remntretry)
			sleep(S2MS(lastmount + Remntretry - now));
		qlock(&amp;mntlck);
		fd = udpport(mntpt);	/* try again under lock */
		if (fd &lt; 0) {
			dnslog("[%d] remounting /net.alt", getpid());
			unmount(nil, "/net.alt");

			msg = system(open("/dev/null", ORDWR), "outside");

			lastmount = time(nil);
			if (msg &amp;&amp; *msg) {
				dnslog("[%d] can't remount /net.alt: %s",
					getpid(), msg);
				sleep(10*1000);	/* don't spin remounting */
			} else
				fd = udpport(mntpt);
		}
		qunlock(&amp;mntlck);
	}
	if (fd &lt; 0) {
		dnslog("can't get udpport for %s query of name %s: %r",
			mntpt, qp-&gt;dp-&gt;name);
		sysfatal("out of udp conversations");	/* we're buggered */
	}

	/*
	 * Our QIP servers are busted and respond to AAAA and CNAME queries
	 * with (sometimes malformed [too short] packets and) no answers and
	 * just NS RRs but not Rname errors.  so make time-to-wait
	 * proportional to estimated probability of an RR of that type existing.
	 */
	if (qp-&gt;type &gt;= nelem(likely))
		pcntprob = 35;			/* unpopular query type */
	else
		pcntprob = likely[qp-&gt;type];
	reqtm = (patient? 2 * Maxreqtm: Maxreqtm);
	wait = weight(reqtm / 3, pcntprob);	/* time for one udp query */
	qp-&gt;req-&gt;aborttime = timems() + 3*wait; /* for all udp queries */

	qp-&gt;udpfd = fd;
	rv = queryns(qp, depth, ibuf, obuf, wait, inns);
	close(fd);
	qp-&gt;udpfd = -1;

	free(obuf);
	free(ibuf);
	return rv;
}

/*
 * look up (qp-&gt;dp-&gt;name, qp-&gt;type) rr in dns,
 * using nameservers in qp-&gt;nsrp.
 */
static int
netquery(Query *qp, int depth)
{
	int lock, rv, triedin, inname;
	char buf[32];
	RR *rp;
	DN *dp;
	Querylck *qlp;
	static int whined;

	rv = Answnone;			/* pessimism */
	if(depth &gt; 12)			/* in a recursive loop? */
		return Answnone;

	slave(qp-&gt;req);
	/*
	 * slave might have forked.  if so, the parent process longjmped to
	 * req-&gt;mret; we're usually the child slave, but if there are too
	 * many children already, we're still the same process.
	 */

	/*
	 * don't lock before call to slave so only children can block.
	 * just lock at top-level invocation.
	 */
	lock = depth &lt;= 1 &amp;&amp; qp-&gt;req-&gt;isslave;
	dp = qp-&gt;dp;		/* ensure that it doesn't change underfoot */
	qlp = nil;
	if(lock) {
		procsetname("query lock wait: %s %s from %s", dp-&gt;name,
			rrname(qp-&gt;type, buf, sizeof buf), qp-&gt;req-&gt;from);
		/*
		 * don't make concurrent queries for this name.
		 * dozens of processes blocking here probably indicates
		 * an error in our dns data that causes us to not
		 * recognise a zone (area) as one of our own, thus
		 * causing us to query other nameservers.
		 */
		qlp = &amp;dp-&gt;querylck[qtype2lck(qp-&gt;type)];
		qlock(qlp);
		if (qlp-&gt;Ref.ref &gt; Maxoutstanding) {
			qunlock(qlp);
			if (!whined) {
				whined = 1;
				dnslog("too many outstanding queries for %s;"
					" dropping this one; no further logging"
					" of drops", dp-&gt;name);
			}
			return 0;
		}
		++qlp-&gt;Ref.ref;
		qunlock(qlp);
	}
	procsetname("netquery: %s", dp-&gt;name);

	/* prepare server RR's for incremental lookup */
	for(rp = qp-&gt;nsrp; rp; rp = rp-&gt;next)
		rp-&gt;marker = 0;

	triedin = 0;

	/*
	 * normal resolvers and servers will just use mntpt for all addresses,
	 * even on the outside.  straddling servers will use mntpt (/net)
	 * for inside addresses and /net.alt for outside addresses,
	 * thus bypassing other inside nameservers.
	 */
	inname = insideaddr(dp-&gt;name);
	if (!cfg.straddle || inname) {
		rv = udpquery(qp, mntpt, depth, Hurry, (cfg.inside? Inns: Outns));
		triedin = 1;
	}

	/*
	 * if we're still looking, are inside, and have an outside domain,
	 * try it on our outside interface, if any.
	 */
	if (rv == Answnone &amp;&amp; cfg.inside &amp;&amp; !inname) {
		if (triedin)
			dnslog(
	   "[%d] netquery: internal nameservers failed for %s; trying external",
				getpid(), dp-&gt;name);

		/* prepare server RR's for incremental lookup */
		for(rp = qp-&gt;nsrp; rp; rp = rp-&gt;next)
			rp-&gt;marker = 0;

		rv = udpquery(qp, "/net.alt", depth, Patient, Outns);
	}
//	if (rv == Answnone)		/* could ask /net.alt/dns directly */
//		askoutdns(dp, qp-&gt;type);

	if(lock &amp;&amp; qlp) {
		qlock(qlp);
		assert(qlp-&gt;Ref.ref &gt; 0);
		qunlock(qlp);
		decref(qlp);
	}
	return rv;
}

int
seerootns(void)
{
	int rv;
	char root[] = "";
	Request req;
	RR *rr;
	Query *qp;

	memset(&amp;req, 0, sizeof req);
	req.isslave = 1;
	req.aborttime = timems() + Maxreqtm;
	req.from = "internal";

	qp = emalloc(sizeof *qp);
	queryinit(qp, dnlookup(root, Cin, 1), Tns, &amp;req);
	qp-&gt;nsrp = dblookup(root, Cin, Tns, 0, 0);
	for (rr = qp-&gt;nsrp; rr != nil; rr = rr-&gt;next)	/* DEBUG */
		dnslog("seerootns query nsrp: %R", rr);

	rv = netquery(qp, 0);		/* lookup ". ns" using qp-&gt;nsrp */

	rrfreelist(qp-&gt;nsrp);
	querydestroy(qp);
	free(qp);
	return rv;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

