<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dns.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dns.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;ip.h&gt;
#include &lt;pool.h&gt;
#include "dns.h"

enum
{
	Maxrequest=		1024,
	Maxreply=		8192,		/* was 512 */
	Maxrrr=			32,		/* was 16 */
	Maxfdata=		8192,

	Defmaxage=		60*60,	/* default domain name max. age */

	Qdir=			0,
	Qdns=			1,
};

typedef struct Mfile	Mfile;
typedef struct Job	Job;
typedef struct Network	Network;

extern	ulong	start;

int vers;		/* incremented each clone/attach */

static volatile int stop;

/* holds data to be returned via read of /net/dns, perhaps multiple reads */
struct Mfile
{
	Mfile		*next;		/* next free mfile */
	int		ref;

	char		*user;
	Qid		qid;
	int		fid;

	int		type;		/* reply type */
	char		reply[Maxreply];
	ushort		rr[Maxrrr];	/* offset of rr's */
	ushort		nrr;		/* number of rr's */
};

/*
 *  active local requests
 */
struct Job
{
	Job	*next;
	int	flushed;
	Fcall	request;
	Fcall	reply;
};
Lock	joblock;
Job	*joblist;

struct {
	Lock;
	Mfile	*inuse;		/* active mfile's */
} mfalloc;

Cfg	cfg;
int	debug;
uchar	ipaddr[IPaddrlen];	/* my ip address */
int	maxage = Defmaxage;
int	mfd[2];
int	needrefresh;
ulong	now;
vlong	nowns;
int	sendnotifies;
int	testing;
char	*trace;
int	traceactivity;
char	*zonerefreshprogram;

char	*logfile = "dns";	/* or "dns.test" */
char	*dbfile;
char	mntpt[Maxpath];

int	addforwtarg(char *);
int	fillreply(Mfile*, int);
void	freejob(Job*);
void	io(void);
void	mountinit(char*, char*);
Job*	newjob(void);
void	rattach(Job*, Mfile*);
void	rauth(Job*);
void	rclunk(Job*, Mfile*);
void	rcreate(Job*, Mfile*);
void	rflush(Job*);
void	ropen(Job*, Mfile*);
void	rread(Job*, Mfile*);
void	rremove(Job*, Mfile*);
void	rstat(Job*, Mfile*);
void	rversion(Job*);
char*	rwalk(Job*, Mfile*);
void	rwrite(Job*, Mfile*, Request*);
void	rwstat(Job*, Mfile*);
void	sendmsg(Job*, char*);
void	setext(char*, int, char*);

static char *lookupqueryold(Job*, Mfile*, Request*, char*, char*, int, int);
static char *lookupquerynew(Job*, Mfile*, Request*, char*, char*, int, int);
static char *respond(Job*, Mfile*, RR*, char*, int, int);

void
usage(void)
{
	fprint(2, "usage: %s [-FnorRst] [-a maxage] [-f ndb-file] [-N target] "
		"[-T forwip] [-x netmtpt] [-z refreshprog]\n", argv0);
	exits("usage");
}

void
justremount(char *service, char *mntpt)
{
	int f;

	f = open(service, ORDWR);
	if(f &lt; 0)
		abort(); 	/* service */;
	while (mount(f, -1, mntpt, MAFTER, "") &lt; 0) {
		dnslog("dns mount -a on %s failed: %r", mntpt);
		sleep(5000);
	}
}

void
main(int argc, char *argv[])
{
	int kid, pid;
	char servefile[Maxpath], ext[Maxpath];
	Dir *dir;

	setnetmtpt(mntpt, sizeof mntpt, nil);
	ext[0] = 0;
	ARGBEGIN{
	case 'a':
		maxage = atol(EARGF(usage()));
		if (maxage &lt;= 0)
			maxage = Defmaxage;
		break;
	case 'd':
		debug = 1;
		traceactivity = 1;
		break;
	case 'f':
		dbfile = EARGF(usage());
		break;
	case 'F':
		cfg.justforw = cfg.resolver = 1;
		break;
	case 'n':
		sendnotifies = 1;
		break;
	case 'N':
		target = atol(EARGF(usage()));
		if (target &lt; 1000)
			target = 1000;
		break;
	case 'o':
		cfg.straddle = 1;	/* straddle inside &amp; outside networks */
		break;
	case 'r':
		cfg.resolver = 1;
		break;
	case 'R':
		norecursion = 1;
		break;
	case 's':
		cfg.serve = 1;		/* serve network */
		cfg.cachedb = 1;
		break;
	case 't':
		testing = 1;
		break;
	case 'T':
		addforwtarg(EARGF(usage()));
		break;
	case 'x':
		setnetmtpt(mntpt, sizeof mntpt, EARGF(usage()));
		setext(ext, sizeof ext, mntpt);
		break;
	case 'z':
		zonerefreshprogram = EARGF(usage());
		break;
	default:
		usage();
		break;
	}ARGEND
	if(argc != 0)
		usage();

	if(testing)
		mainmem-&gt;flags |= POOL_NOREUSE | POOL_ANTAGONISM;
	mainmem-&gt;flags |= POOL_ANTAGONISM;
	rfork(RFREND|RFNOTEG);

	cfg.inside = (*mntpt == '\0' || strcmp(mntpt, "/net") == 0);

	/* start syslog before we fork */
	fmtinstall('F', fcallfmt);
	dninit();
	/* this really shouldn't be fatal */
	if(myipaddr(ipaddr, mntpt) &lt; 0)
		sysfatal("can't read my ip address");
	dnslog("starting %s%sdns %s%s%son %I's %s",
		(cfg.straddle? "straddling ": ""),
		(cfg.cachedb? "caching ": ""),
		(cfg.serve?   "udp server ": ""),
		(cfg.justforw? "forwarding-only ": ""),
		(cfg.resolver? "resolver ": ""), ipaddr, mntpt);

	opendatabase();
	now = time(nil);		/* open time files before we fork */
	nowns = nsec();

	snprint(servefile, sizeof servefile, "#s/dns%s", ext);
	dir = dirstat(servefile);
	if (dir)
		sysfatal("%s exists; another dns instance is running",
			servefile);
	free(dir);

	/* don't unmount here; could deadlock */
//	while (unmount(servefile, mntpt) &gt;= 0)
//		;
	mountinit(servefile, mntpt);	/* forks, parent exits */

	srand(now*getpid());
	db2cache(1);
//	dnageallnever();

	if (cfg.straddle &amp;&amp; !seerootns())
		dnslog("straddle server misconfigured; can't resolve root name servers");
	/*
	 * fork without sharing heap.
	 * parent waits around for child to die, then forks &amp; restarts.
	 * child may spawn udp server, notify procs, etc.; when it gets too
	 * big or too old, it kills itself and any children.
	 *
	 * /srv/dns remains open and valid, but /net/dns was only mounted in
	 * a child's separate namespace from 9p service, to avoid a deadlock
	 * from serving our own namespace, so we must remount it upon restart,
	 * in a separate process and namespace.
	 */
	for (;;) {
		start = time(nil);
		/* don't unmount here; could deadlock */
//		unmount(servefile, mntpt);
		kid = rfork(RFPROC|RFFDG|RFNOTEG|RFNAMEG);
		switch (kid) {
		case -1:
			sysfatal("fork failed: %r");
		case 0:
			if(cfg.serve)
				dnudpserver(mntpt);
			if(sendnotifies)
				notifyproc();
			io();		/* serve 9p; return implies restart */
			_exits("restart");
		}
		sleep(1000);	/* wait for 9p service to start */
		justremount(servefile, mntpt);
		while ((pid = waitpid()) != kid &amp;&amp; pid != -1)
			continue;
		dnslog("restarting");
	}
}

/*
 *  if a mount point is specified, set the cs extension to be the mount point
 *  with '_'s replacing '/'s
 */
void
setext(char *ext, int n, char *p)
{
	int i, c;

	n--;
	for(i = 0; i &lt; n; i++){
		c = p[i];
		if(c == 0)
			break;
		if(c == '/')
			c = '_';
		ext[i] = c;
	}
	ext[i] = 0;
}

void
mountinit(char *service, char *mntpt)
{
	int f;
	int p[2];
	char buf[32];

	if(pipe(p) &lt; 0)
		abort(); /* "pipe failed" */;
	switch(rfork(RFFDG|RFPROC)){
	case 0:			/* child: hang around and (re)start main proc */
		close(p[1]);
		procsetname("%s restarter", mntpt);
		mfd[0] = mfd[1] = p[0];
		break;
	case -1:
		abort(); /* "fork failed\n" */;
	default:		/* parent: make /srv/dns, mount it, exit */
		close(p[0]);

		/*
		 *  make a /srv/dns
		 */
		f = create(service, 1, 0666);
		if(f &lt; 0)
			abort(); /* service */;
		snprint(buf, sizeof buf, "%d", p[1]);
		if(write(f, buf, strlen(buf)) != strlen(buf))
			abort(); /* "write %s", service */;
		close(f);

		/*
		 *  put ourselves into the file system
		 *  it's too soon; we need 9p service running.
		 */
//		if(mount(p[1], -1, mntpt, MAFTER, "") &lt; 0)
//			dnslog("dns mount -a on %s failed: %r", mntpt);
		close(p[1]);
		_exits(0);
	}
}

Mfile*
newfid(int fid, int needunused)
{
	Mfile *mf;

	lock(&amp;mfalloc);
	for(mf = mfalloc.inuse; mf != nil; mf = mf-&gt;next)
		if(mf-&gt;fid == fid){
			unlock(&amp;mfalloc);
			if(needunused)
				return nil;
			return mf;
		}
	mf = emalloc(sizeof(*mf));
	mf-&gt;fid = fid;
	mf-&gt;user = estrdup("dummy");
	mf-&gt;next = mfalloc.inuse;
	mfalloc.inuse = mf;
	unlock(&amp;mfalloc);
	return mf;
}

void
freefid(Mfile *mf)
{
	Mfile **l;

	lock(&amp;mfalloc);
	for(l = &amp;mfalloc.inuse; *l != nil; l = &amp;(*l)-&gt;next)
		if(*l == mf){
			*l = mf-&gt;next;
			if(mf-&gt;user)
				free(mf-&gt;user);
			memset(mf, 0, sizeof *mf);	/* cause trouble */
			free(mf);
			unlock(&amp;mfalloc);
			return;
		}
	unlock(&amp;mfalloc);
	sysfatal("freeing unused fid");
}

Mfile*
copyfid(Mfile *mf, int fid)
{
	Mfile *nmf;

	nmf = newfid(fid, 1);
	if(nmf == nil)
		return nil;
	nmf-&gt;fid = fid;
	free(nmf-&gt;user);			/* estrdup("dummy") */
	nmf-&gt;user = estrdup(mf-&gt;user);
	nmf-&gt;qid.type = mf-&gt;qid.type;
	nmf-&gt;qid.path = mf-&gt;qid.path;
	nmf-&gt;qid.vers = vers++;
	return nmf;
}

Job*
newjob(void)
{
	Job *job;

	job = emalloc(sizeof *job);
	lock(&amp;joblock);
	job-&gt;next = joblist;
	joblist = job;
	job-&gt;request.tag = -1;
	unlock(&amp;joblock);
	return job;
}

void
freejob(Job *job)
{
	Job **l;

	lock(&amp;joblock);
	for(l = &amp;joblist; *l; l = &amp;(*l)-&gt;next)
		if(*l == job){
			*l = job-&gt;next;
			memset(job, 0, sizeof *job);	/* cause trouble */
			free(job);
			break;
		}
	unlock(&amp;joblock);
}

void
flushjob(int tag)
{
	Job *job;

	lock(&amp;joblock);
	for(job = joblist; job; job = job-&gt;next)
		if(job-&gt;request.tag == tag &amp;&amp; job-&gt;request.type != Tflush){
			job-&gt;flushed = 1;
			break;
		}
	unlock(&amp;joblock);
}

void
io(void)
{
	volatile long n;
	volatile uchar mdata[IOHDRSZ + Maxfdata];
	Job *volatile job;
	Mfile *volatile mf;
	volatile Request req;

	memset(&amp;req, 0, sizeof req);
	/*
	 *  a slave process is sometimes forked to wait for replies from other
	 *  servers.  The master process returns immediately via a longjmp
	 *  through 'mret'.
	 */
	if(setjmp(req.mret))
		putactivity(0);
	req.isslave = 0;
	stop = 0;
	while(!stop){
		procsetname("%d %s/dns Twrites of %d 9p rpcs read; %d alarms",
			stats.qrecvd9p, mntpt, stats.qrecvd9prpc, stats.alarms);
		n = read9pmsg(mfd[0], mdata, sizeof mdata);
		if(n&lt;=0){
			dnslog("error reading 9P from %s: %r", mntpt);
			sleep(2000);	/* don't thrash after read error */
			return;
		}

		stats.qrecvd9prpc++;
		job = newjob();
		if(convM2S(mdata, n, &amp;job-&gt;request) != n){
			freejob(job);
			continue;
		}
		mf = newfid(job-&gt;request.fid, 0);
		if(debug)
			dnslog("%F", &amp;job-&gt;request);

		getactivity(&amp;req, 0);
		req.aborttime = timems() + Maxreqtm;
		req.from = "9p";

		switch(job-&gt;request.type){
		default:
			warning("unknown request type %d", job-&gt;request.type);
			break;
		case Tversion:
			rversion(job);
			break;
		case Tauth:
			rauth(job);
			break;
		case Tflush:
			rflush(job);
			break;
		case Tattach:
			rattach(job, mf);
			break;
		case Twalk:
			rwalk(job, mf);
			break;
		case Topen:
			ropen(job, mf);
			break;
		case Tcreate:
			rcreate(job, mf);
			break;
		case Tread:
			rread(job, mf);
			break;
		case Twrite:
			/* &amp;req is handed to dnresolve() */
			rwrite(job, mf, &amp;req);
			break;
		case Tclunk:
			rclunk(job, mf);
			break;
		case Tremove:
			rremove(job, mf);
			break;
		case Tstat:
			rstat(job, mf);
			break;
		case Twstat:
			rwstat(job, mf);
			break;
		}

		freejob(job);

		/*
		 *  slave processes die after replying
		 */
		if(req.isslave){
			putactivity(0);
			_exits(0);
		}

		putactivity(0);
	}
	/* kill any udp server, notifier, etc. processes */
	postnote(PNGROUP, getpid(), "die");
	sleep(1000);
}

void
rversion(Job *job)
{
	if(job-&gt;request.msize &gt; IOHDRSZ + Maxfdata)
		job-&gt;reply.msize = IOHDRSZ + Maxfdata;
	else
		job-&gt;reply.msize = job-&gt;request.msize;
	if(strncmp(job-&gt;request.version, "9P2000", 6) != 0)
		sendmsg(job, "unknown 9P version");
	else{
		job-&gt;reply.version = "9P2000";
		sendmsg(job, 0);
	}
}

void
rauth(Job *job)
{
	sendmsg(job, "dns: authentication not required");
}

/*
 *  don't flush till all the slaves are done
 */
void
rflush(Job *job)
{
	flushjob(job-&gt;request.oldtag);
	sendmsg(job, 0);
}

void
rattach(Job *job, Mfile *mf)
{
	if(mf-&gt;user != nil)
		free(mf-&gt;user);
	mf-&gt;user = estrdup(job-&gt;request.uname);
	mf-&gt;qid.vers = vers++;
	mf-&gt;qid.type = QTDIR;
	mf-&gt;qid.path = 0LL;
	job-&gt;reply.qid = mf-&gt;qid;
	sendmsg(job, 0);
}

char*
rwalk(Job *job, Mfile *mf)
{
	int i, nelems;
	char *err;
	char **elems;
	Mfile *nmf;
	Qid qid;

	err = 0;
	nmf = nil;
	elems  = job-&gt;request.wname;
	nelems = job-&gt;request.nwname;
	job-&gt;reply.nwqid = 0;

	if(job-&gt;request.newfid != job-&gt;request.fid){
		/* clone fid */
		nmf = copyfid(mf, job-&gt;request.newfid);
		if(nmf == nil){
			err = "clone bad newfid";
			goto send;
		}
		mf = nmf;
	}
	/* else nmf will be nil */

	qid = mf-&gt;qid;
	if(nelems &gt; 0)
		/* walk fid */
		for(i=0; i&lt;nelems &amp;&amp; i&lt;MAXWELEM; i++){
			if((qid.type &amp; QTDIR) == 0){
				err = "not a directory";
				break;
			}
			if (strcmp(elems[i], "..") == 0 ||
			    strcmp(elems[i], ".") == 0){
				qid.type = QTDIR;
				qid.path = Qdir;
Found:
				job-&gt;reply.wqid[i] = qid;
				job-&gt;reply.nwqid++;
				continue;
			}
			if(strcmp(elems[i], "dns") == 0){
				qid.type = QTFILE;
				qid.path = Qdns;
				goto Found;
			}
			err = "file does not exist";
			break;
		}

send:
	if(nmf != nil &amp;&amp; (err!=nil || job-&gt;reply.nwqid&lt;nelems))
		freefid(nmf);
	if(err == nil)
		mf-&gt;qid = qid;
	sendmsg(job, err);
	return err;
}

void
ropen(Job *job, Mfile *mf)
{
	int mode;
	char *err;

	err = 0;
	mode = job-&gt;request.mode;
	if(mf-&gt;qid.type &amp; QTDIR)
		if(mode)
			err = "permission denied";
	job-&gt;reply.qid = mf-&gt;qid;
	job-&gt;reply.iounit = 0;
	sendmsg(job, err);
}

void
rcreate(Job *job, Mfile *mf)
{
	USED(mf);
	sendmsg(job, "creation permission denied");
}

void
rread(Job *job, Mfile *mf)
{
	int i, n;
	long clock;
	ulong cnt;
	vlong off;
	char *err;
	uchar buf[Maxfdata];
	Dir dir;

	n = 0;
	err = nil;
	off = job-&gt;request.offset;
	cnt = job-&gt;request.count;
	*buf = '\0';
	job-&gt;reply.data = (char*)buf;
	if(mf-&gt;qid.type &amp; QTDIR){
		clock = time(nil);
		if(off == 0){
			memset(&amp;dir, 0, sizeof dir);
			dir.name = "dns";
			dir.qid.type = QTFILE;
			dir.qid.vers = vers;
			dir.qid.path = Qdns;
			dir.mode = 0666;
			dir.length = 0;
			dir.uid = dir.gid = dir.muid = mf-&gt;user;
			dir.atime = dir.mtime = clock;		/* wrong */
			n = convD2M(&amp;dir, buf, sizeof buf);
		}
	} else if (off &lt; 0)
		err = "negative read offset";
	else {
		/* first offset will always be zero */
		for(i = 1; i &lt;= mf-&gt;nrr; i++)
			if(mf-&gt;rr[i] &gt; off)
				break;
		if(i &lt;= mf-&gt;nrr) {
			if(off + cnt &gt; mf-&gt;rr[i])
				n = mf-&gt;rr[i] - off;
			else
				n = cnt;
			assert(n &gt;= 0);
			job-&gt;reply.data = mf-&gt;reply + off;
		}
	}
	job-&gt;reply.count = n;
	sendmsg(job, err);
}

void
rwrite(Job *job, Mfile *mf, Request *req)
{
	int rooted, wantsav, send;
	ulong cnt;
	char *err, *p, *atype;
	char errbuf[ERRMAX];

	err = nil;
	cnt = job-&gt;request.count;
	send = 1;
	if(mf-&gt;qid.type &amp; QTDIR)
		err = "can't write directory";
	else if (job-&gt;request.offset != 0)
		err = "writing at non-zero offset";
	else if(cnt &gt;= Maxrequest)
		err = "request too long";
	else
		send = 0;
	if (send)
		goto send;

	job-&gt;request.data[cnt] = 0;
	if(cnt &gt; 0 &amp;&amp; job-&gt;request.data[cnt-1] == '\n')
		job-&gt;request.data[cnt-1] = 0;

	/*
	 *  special commands
	 */
//	dnslog("rwrite got: %s", job-&gt;request.data);
	send = 1;
	if(strcmp(job-&gt;request.data, "age")==0){
		dnslog("dump, age &amp; dump forced");
		dndump("/lib/ndb/dnsdump1");
		dnforceage();
		dndump("/lib/ndb/dnsdump2");
	} else if(strcmp(job-&gt;request.data, "debug")==0)
		debug ^= 1;
	else if(strcmp(job-&gt;request.data, "dump")==0)
		dndump("/lib/ndb/dnsdump");
	else if(strcmp(job-&gt;request.data, "poolcheck")==0)
		poolcheck(mainmem);
	else if(strcmp(job-&gt;request.data, "refresh")==0)
		needrefresh = 1;
	else if(strcmp(job-&gt;request.data, "restart")==0)
		stop = 1;
	else if(strcmp(job-&gt;request.data, "stats")==0)
		dnstats("/lib/ndb/dnsstats");
	else if(strncmp(job-&gt;request.data, "target ", 7)==0){
		target = atol(job-&gt;request.data + 7);
		dnslog("target set to %ld", target);
	} else
		send = 0;
	if (send)
		goto send;

	/*
	 *  kill previous reply
	 */
	mf-&gt;nrr = 0;
	mf-&gt;rr[0] = 0;

	/*
	 *  break up request (into a name and a type)
	 */
	atype = strchr(job-&gt;request.data, ' ');
	if(atype == 0){
		snprint(errbuf, sizeof errbuf, "illegal request %s",
			job-&gt;request.data);
		err = errbuf;
		goto send;
	} else
		*atype++ = 0;

	/*
	 *  tracing request
	 */
	if(strcmp(atype, "trace") == 0){
		if(trace)
			free(trace);
		if(*job-&gt;request.data)
			trace = estrdup(job-&gt;request.data);
		else
			trace = 0;
		goto send;
	}

	/* normal request: domain [type] */
	stats.qrecvd9p++;
	mf-&gt;type = rrtype(atype);
	if(mf-&gt;type &lt; 0){
		snprint(errbuf, sizeof errbuf, "unknown type %s", atype);
		err = errbuf;
		goto send;
	}

	p = atype - 2;
	if(p &gt;= job-&gt;request.data &amp;&amp; *p == '.'){
		rooted = 1;
		*p = 0;
	} else
		rooted = 0;

	p = job-&gt;request.data;
	if(*p == '!'){
		wantsav = 1;
		p++;
	} else
		wantsav = 0;

	err = lookupqueryold(job, mf, req, errbuf, p, wantsav, rooted);
send:
	dncheck(0, 1);
	job-&gt;reply.count = cnt;
	sendmsg(job, err);
}

/*
 * dnsdebug calls
 *	rr = dnresolve(buf, Cin, type, &amp;req, 0, 0, Recurse, rooted, 0);
 * which generates a UDP query, which eventually calls
 *	dnserver(&amp;reqmsg, &amp;repmsg, &amp;req, buf, rcode);
 * which calls
 *	rp = dnresolve(name, Cin, type, req, &amp;mp-&gt;an, 0, recurse, 1, 0);
 *
 * but here we just call dnresolve directly.
 */
static char *
lookupqueryold(Job *job, Mfile *mf, Request *req, char *errbuf, char *p,
	int wantsav, int rooted)
{
	int status;
	RR *rp, *neg;

	dncheck(0, 1);
	status = Rok;
	rp = dnresolve(p, Cin, mf-&gt;type, req, 0, 0, Recurse, rooted, &amp;status);

	dncheck(0, 1);
	lock(&amp;dnlock);
	neg = rrremneg(&amp;rp);
	if(neg){
		status = neg-&gt;negrcode;
		rrfreelist(neg);
	}
	unlock(&amp;dnlock);

	return respond(job, mf, rp, errbuf, status, wantsav);
}

static char *
respond(Job *job, Mfile *mf, RR *rp, char *errbuf, int status, int wantsav)
{
	long n;
	RR *tp;

	if(rp == nil)
		switch(status){
		case Rname:
			return "name does not exist";
		case Rserver:
			return "dns failure";
		case Rok:
		default:
			snprint(errbuf, ERRMAX,
				"resource does not exist; negrcode %d", status);
			return errbuf;
		}

	lock(&amp;joblock);
	if(!job-&gt;flushed){
		/* format data to be read later */
		n = 0;
		mf-&gt;nrr = 0;
		for(tp = rp; mf-&gt;nrr &lt; Maxrrr-1 &amp;&amp; n &lt; Maxreply &amp;&amp; tp &amp;&amp;
		    tsame(mf-&gt;type, tp-&gt;type); tp = tp-&gt;next){
			mf-&gt;rr[mf-&gt;nrr++] = n;
			if(wantsav)
				n += snprint(mf-&gt;reply+n, Maxreply-n, "%Q", tp);
			else
				n += snprint(mf-&gt;reply+n, Maxreply-n, "%R", tp);
		}
		mf-&gt;rr[mf-&gt;nrr] = n;
	}
	unlock(&amp;joblock);
	rrfreelist(rp);
	return nil;
}

#ifdef notused
/* simulate what dnsudpserver does */
static char *
lookupquerynew(Job *job, Mfile *mf, Request *req, char *errbuf, char *p,
	int wantsav, int)
{
	char *err;
	uchar buf[Udphdrsize + Maxpayload];
	DNSmsg *mp;
	DNSmsg repmsg;
	RR *rp;

	dncheck(0, 1);

	memset(&amp;repmsg, 0, sizeof repmsg);
	rp = rralloc(mf-&gt;type);
	rp-&gt;owner = dnlookup(p, Cin, 1);
	mp = newdnsmsg(rp, Frecurse|Oquery, (ushort)rand());

	/* BUG: buf is srcip, yet it's uninitialised */
	dnserver(mp, &amp;repmsg, req, buf, Rok);

	freeanswers(mp);
	err = respond(job, mf, repmsg.an, errbuf, Rok, wantsav);
	repmsg.an = nil;		/* freed above */
	freeanswers(&amp;repmsg);
	return err;
}
#endif

void
rclunk(Job *job, Mfile *mf)
{
	freefid(mf);
	sendmsg(job, 0);
}

void
rremove(Job *job, Mfile *mf)
{
	USED(mf);
	sendmsg(job, "remove permission denied");
}

void
rstat(Job *job, Mfile *mf)
{
	Dir dir;
	uchar buf[IOHDRSZ+Maxfdata];

	memset(&amp;dir, 0, sizeof dir);
	if(mf-&gt;qid.type &amp; QTDIR){
		dir.name = ".";
		dir.mode = DMDIR|0555;
	} else {
		dir.name = "dns";
		dir.mode = 0666;
	}
	dir.qid = mf-&gt;qid;
	dir.length = 0;
	dir.uid = dir.gid = dir.muid = mf-&gt;user;
	dir.atime = dir.mtime = time(nil);
	job-&gt;reply.nstat = convD2M(&amp;dir, buf, sizeof buf);
	job-&gt;reply.stat = buf;
	sendmsg(job, 0);
}

void
rwstat(Job *job, Mfile *mf)
{
	USED(mf);
	sendmsg(job, "wstat permission denied");
}

void
sendmsg(Job *job, char *err)
{
	int n;
	uchar mdata[IOHDRSZ + Maxfdata];
	char ename[ERRMAX];

	if(err){
		job-&gt;reply.type = Rerror;
		snprint(ename, sizeof ename, "dns: %s", err);
		job-&gt;reply.ename = ename;
	}else
		job-&gt;reply.type = job-&gt;request.type+1;
	job-&gt;reply.tag = job-&gt;request.tag;
	n = convS2M(&amp;job-&gt;reply, mdata, sizeof mdata);
	if(n == 0){
		warning("sendmsg convS2M of %F returns 0", &amp;job-&gt;reply);
		abort();
	}
	lock(&amp;joblock);
	if(job-&gt;flushed == 0)
		if(write(mfd[1], mdata, n)!=n)
			sysfatal("mount write");
	unlock(&amp;joblock);
	if(debug)
		dnslog("%F %d", &amp;job-&gt;reply, n);
}

/*
 *  the following varies between dnsdebug and dns
 */
void
logreply(int id, uchar *addr, DNSmsg *mp)
{
	RR *rp;

	dnslog("%d: rcvd %I flags:%s%s%s%s%s", id, addr,
		mp-&gt;flags &amp; Fauth? " auth": "",
		mp-&gt;flags &amp; Ftrunc? " trunc": "",
		mp-&gt;flags &amp; Frecurse? " rd": "",
		mp-&gt;flags &amp; Fcanrec? " ra": "",
		(mp-&gt;flags &amp; (Fauth|Rmask)) == (Fauth|Rname)? " nx": "");
	for(rp = mp-&gt;qd; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I qd %s", id, addr, rp-&gt;owner-&gt;name);
	for(rp = mp-&gt;an; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I an %R", id, addr, rp);
	for(rp = mp-&gt;ns; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I ns %R", id, addr, rp);
	for(rp = mp-&gt;ar; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I ar %R", id, addr, rp);
}

void
logsend(int id, int subid, uchar *addr, char *sname, char *rname, int type)
{
	char buf[12];

	dnslog("[%d] %d.%d: sending to %I/%s %s %s",
		getpid(), id, subid, addr, sname, rname,
		rrname(type, buf, sizeof buf));
}

RR*
getdnsservers(int class)
{
	return dnsservers(class);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

