<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnstcp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnstcp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * dnstcp - serve dns via tcp
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

Cfg cfg;

char	*caller = "";
char	*dbfile;
int	debug;
uchar	ipaddr[IPaddrlen];	/* my ip address */
char	*logfile = "dns";
int	maxage = 60*60;
char	mntpt[Maxpath];
int	needrefresh;
ulong	now;
vlong	nowns;
int	testing;
int	traceactivity;
char	*zonerefreshprogram;

static int	readmsg(int, uchar*, int);
static void	reply(int, DNSmsg*, Request*);
static void	dnzone(DNSmsg*, DNSmsg*, Request*);
static void	getcaller(char*);
static void	refreshmain(char*);

void
usage(void)
{
	fprint(2, "usage: %s [-rR] [-f ndb-file] [-x netmtpt] [conndir]\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	volatile int len, rcode;
	volatile char tname[32];
	char *volatile err, *volatile ext = "";
	volatile uchar buf[64*1024], callip[IPaddrlen];
	volatile DNSmsg reqmsg, repmsg;
	volatile Request req;

	alarm(2*60*1000);
	cfg.cachedb = 1;
	ARGBEGIN{
	case 'd':
		debug++;
		break;
	case 'f':
		dbfile = EARGF(usage());
		break;
	case 'r':
		cfg.resolver = 1;
		break;
	case 'R':
		norecursion = 1;
		break;
	case 'x':
		ext = EARGF(usage());
		break;
	default:
		usage();
		break;
	}ARGEND

	if(debug &lt; 2)
		debug = 0;

	if(argc &gt; 0)
		getcaller(argv[0]);

	cfg.inside = 1;
	dninit();

	snprint(mntpt, sizeof mntpt, "/net%s", ext);
	if(myipaddr(ipaddr, mntpt) &lt; 0)
		sysfatal("can't read my ip address");
	dnslog("dnstcp call from %s to %I", caller, ipaddr);
	memset(callip, 0, sizeof callip);
	parseip(callip, caller);

	db2cache(1);

	memset(&amp;req, 0, sizeof req);
	setjmp(req.mret);
	req.isslave = 0;
	procsetname("main loop");

	/* loop on requests */
	for(;; putactivity(0)){
		now = time(nil);
		memset(&amp;repmsg, 0, sizeof repmsg);
		len = readmsg(0, buf, sizeof buf);
		if(len &lt;= 0)
			break;

		getactivity(&amp;req, 0);
		req.aborttime = timems() + S2MS(15*Min);
		rcode = 0;
		memset(&amp;reqmsg, 0, sizeof reqmsg);
		err = convM2DNS(buf, len, &amp;reqmsg, &amp;rcode);
		if(err){
			dnslog("server: input error: %s from %s", err, caller);
			free(err);
			break;
		}
		if (rcode == 0)
			if(reqmsg.qdcount &lt; 1){
				dnslog("server: no questions from %s", caller);
				break;
			} else if(reqmsg.flags &amp; Fresp){
				dnslog("server: reply not request from %s",
					caller);
				break;
			} else if((reqmsg.flags &amp; Omask) != Oquery){
				dnslog("server: op %d from %s",
					reqmsg.flags &amp; Omask, caller);
				break;
			}
		if(debug)
			dnslog("[%d] %d: serve (%s) %d %s %s",
				getpid(), req.id, caller,
				reqmsg.id, reqmsg.qd-&gt;owner-&gt;name,
				rrname(reqmsg.qd-&gt;type, tname, sizeof tname));

		/* loop through each question */
		while(reqmsg.qd)
			if(reqmsg.qd-&gt;type == Taxfr)
				dnzone(&amp;reqmsg, &amp;repmsg, &amp;req);
			else {
				dnserver(&amp;reqmsg, &amp;repmsg, &amp;req, callip, rcode);
				reply(1, &amp;repmsg, &amp;req);
				rrfreelist(repmsg.qd);
				rrfreelist(repmsg.an);
				rrfreelist(repmsg.ns);
				rrfreelist(repmsg.ar);
			}
		rrfreelist(reqmsg.qd);		/* qd will be nil */
		rrfreelist(reqmsg.an);
		rrfreelist(reqmsg.ns);
		rrfreelist(reqmsg.ar);

		if(req.isslave){
			putactivity(0);
			_exits(0);
		}
	}
	refreshmain(mntpt);
}

static int
readmsg(int fd, uchar *buf, int max)
{
	int n;
	uchar x[2];

	if(readn(fd, x, 2) != 2)
		return -1;
	n = x[0]&lt;&lt;8 | x[1];
	if(n &gt; max)
		return -1;
	if(readn(fd, buf, n) != n)
		return -1;
	return n;
}

static void
reply(int fd, DNSmsg *rep, Request *req)
{
	int len, rv;
	char tname[32];
	uchar buf[64*1024];
	RR *rp;

	if(debug){
		dnslog("%d: reply (%s) %s %s %ux",
			req-&gt;id, caller,
			rep-&gt;qd-&gt;owner-&gt;name,
			rrname(rep-&gt;qd-&gt;type, tname, sizeof tname),
			rep-&gt;flags);
		for(rp = rep-&gt;an; rp; rp = rp-&gt;next)
			dnslog("an %R", rp);
		for(rp = rep-&gt;ns; rp; rp = rp-&gt;next)
			dnslog("ns %R", rp);
		for(rp = rep-&gt;ar; rp; rp = rp-&gt;next)
			dnslog("ar %R", rp);
	}


	len = convDNS2M(rep, buf+2, sizeof(buf) - 2);
	buf[0] = len&gt;&gt;8;
	buf[1] = len;
	rv = write(fd, buf, len+2);
	if(rv != len+2){
		dnslog("[%d] sending reply: %d instead of %d", getpid(), rv,
			len+2);
		exits(0);
	}
}

/*
 *  Hash table for domain names.  The hash is based only on the
 *  first element of the domain name.
 */
extern DN	*ht[HTLEN];

static int
numelem(char *name)
{
	int i;

	i = 1;
	for(; *name; name++)
		if(*name == '.')
			i++;
	return i;
}

int
inzone(DN *dp, char *name, int namelen, int depth)
{
	int n;

	if(dp-&gt;name == nil)
		return 0;
	if(numelem(dp-&gt;name) != depth)
		return 0;
	n = strlen(dp-&gt;name);
	if(n &lt; namelen)
		return 0;
	if(strcmp(name, dp-&gt;name + n - namelen) != 0)
		return 0;
	if(n &gt; namelen &amp;&amp; dp-&gt;name[n - namelen - 1] != '.')
		return 0;
	return 1;
}

static void
dnzone(DNSmsg *reqp, DNSmsg *repp, Request *req)
{
	DN *dp, *ndp;
	RR r, *rp;
	int h, depth, found, nlen;

	memset(repp, 0, sizeof(*repp));
	repp-&gt;id = reqp-&gt;id;
	repp-&gt;qd = reqp-&gt;qd;
	reqp-&gt;qd = reqp-&gt;qd-&gt;next;
	repp-&gt;qd-&gt;next = 0;
	repp-&gt;flags = Fauth | Fresp | Oquery;
	if(!norecursion)
		repp-&gt;flags |= Fcanrec;
	dp = repp-&gt;qd-&gt;owner;

	/* send the soa */
	repp-&gt;an = rrlookup(dp, Tsoa, NOneg);
	reply(1, repp, req);
	if(repp-&gt;an == 0)
		goto out;
	rrfreelist(repp-&gt;an);
	repp-&gt;an = nil;

	nlen = strlen(dp-&gt;name);

	/* construct a breadth-first search of the name space (hard with a hash) */
	repp-&gt;an = &amp;r;
	for(depth = numelem(dp-&gt;name); ; depth++){
		found = 0;
		for(h = 0; h &lt; HTLEN; h++)
			for(ndp = ht[h]; ndp; ndp = ndp-&gt;next)
				if(inzone(ndp, dp-&gt;name, nlen, depth)){
					for(rp = ndp-&gt;rr; rp; rp = rp-&gt;next){
						/*
						 * there shouldn't be negatives,
						 * but just in case.
						 * don't send any soa's,
						 * ns's are enough.
						 */
						if (rp-&gt;negative ||
						    rp-&gt;type == Tsoa)
							continue;
						r = *rp;
						r.next = 0;
						reply(1, repp, req);
					}
					found = 1;
				}
		if(!found)
			break;
	}

	/* resend the soa */
	repp-&gt;an = rrlookup(dp, Tsoa, NOneg);
	reply(1, repp, req);
	rrfreelist(repp-&gt;an);
	repp-&gt;an = nil;
out:
	rrfree(repp-&gt;qd);
	repp-&gt;qd = nil;
}

static void
getcaller(char *dir)
{
	int fd, n;
	static char remote[128];

	snprint(remote, sizeof(remote), "%s/remote", dir);
	fd = open(remote, OREAD);
	if(fd &lt; 0)
		return;
	n = read(fd, remote, sizeof remote - 1);
	close(fd);
	if(n &lt;= 0)
		return;
	if(remote[n-1] == '\n')
		n--;
	remote[n] = 0;
	caller = remote;
}

static void
refreshmain(char *net)
{
	int fd;
	char file[128];

	snprint(file, sizeof(file), "%s/dns", net);
	if(debug)
		dnslog("refreshing %s", file);
	fd = open(file, ORDWR);
	if(fd &lt; 0)
		dnslog("can't refresh %s", file);
	else {
		fprint(fd, "refresh");
		close(fd);
	}
}

/*
 *  the following varies between dnsdebug and dns
 */
void
logreply(int id, uchar *addr, DNSmsg *mp)
{
	RR *rp;

	dnslog("%d: rcvd %I flags:%s%s%s%s%s", id, addr,
		mp-&gt;flags &amp; Fauth? " auth": "",
		mp-&gt;flags &amp; Ftrunc? " trunc": "",
		mp-&gt;flags &amp; Frecurse? " rd": "",
		mp-&gt;flags &amp; Fcanrec? " ra": "",
		(mp-&gt;flags &amp; (Fauth|Rmask)) == (Fauth|Rname)? " nx": "");
	for(rp = mp-&gt;qd; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I qd %s", id, addr, rp-&gt;owner-&gt;name);
	for(rp = mp-&gt;an; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I an %R", id, addr, rp);
	for(rp = mp-&gt;ns; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I ns %R", id, addr, rp);
	for(rp = mp-&gt;ar; rp != nil; rp = rp-&gt;next)
		dnslog("%d: rcvd %I ar %R", id, addr, rp);
}

void
logsend(int id, int subid, uchar *addr, char *sname, char *rname, int type)
{
	char buf[12];

	dnslog("%d.%d: sending to %I/%s %s %s",
		id, subid, addr, sname, rname, rrname(type, buf, sizeof buf));
}

RR*
getdnsservers(int class)
{
	return dnsservers(class);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

