<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ns.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ns.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;

#pragma	varargck	type	"P"	char*

int	nsrv;
Dir	*srv;
Biobuf	stdout;

typedef struct Mount Mount;

struct Mount
{
	char	*cmd;
	char	*flag;
	char	*new;
	char	*old;
	char	*spec;
};

void	xlatemnt(Mount*);
char	*quote(char*);

int	rflag;

void
usage(void)
{
	fprint(2, "usage: ns [-r] [pid]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	Mount *m;
	int line, fd, n, pid;
	char buf[1024], *av[5];

	ARGBEGIN{
	case 'r':
		rflag++;
		break;
	default:
		usage();
	}ARGEND

	if(argc &gt; 1)
		usage();
	if(argc == 1){
		pid = atoi(argv[0]);
		if(pid == 0)
			usage();
	}else
		pid = getpid();

	Binit(&amp;stdout, 1, OWRITE);

	sprint(buf, "/proc/%d/ns", pid);
	fd = open(buf, OREAD);
	if(fd &lt; 0) {
		fprint(2, "ns: open %s: %r\n", buf);
		exits("open ns");
	}

	for(line=1; ; line++) {
		n = read(fd, buf, sizeof(buf));
		if(n == sizeof(buf)) {
			fprint(2, "ns: ns string too long\n");
			exits("read ns");
		}
		if(n &lt; 0) {
			fprint(2, "ns: read %r\n");
			exits("read ns");
		}
		if(n == 0)
			break;
		buf[n] = '\0';

		m = mallocz(sizeof(Mount), 1);
		if(m == nil) {
			fprint(2, "ns: no memory: %r\n");
			exits("no memory");
		}

		n = tokenize(buf, av, 5);
		switch(n){
		case 2:
			if(strcmp(av[0], "cd") == 0){
				Bprint(&amp;stdout, "%s %s\n", av[0], av[1]);
				continue;
			}
			/* fall through */
		default:
			fprint(2, "ns: unrecognized format of ns file: %d elements on line %d\n", n, line);
			exits("format");
		case 5:
			m-&gt;cmd = strdup(av[0]);
			m-&gt;flag = strdup(av[1]);
			m-&gt;new = strdup(av[2]);
			m-&gt;old = strdup(av[3]);
			m-&gt;spec = strdup(av[4]);
			break;
		case 4:
			if(av[1][0] == '-'){
				m-&gt;cmd = strdup(av[0]);
				m-&gt;flag = strdup(av[1]);
				m-&gt;new = strdup(av[2]);
				m-&gt;old = strdup(av[3]);
				m-&gt;spec = strdup("");
			}else{
				m-&gt;cmd = strdup(av[0]);
				m-&gt;flag = strdup("");
				m-&gt;new = strdup(av[1]);
				m-&gt;old = strdup(av[2]);
				m-&gt;spec = strdup(av[3]);
			}
			break;
		case 3:
			m-&gt;cmd = strdup(av[0]);
			m-&gt;flag = strdup("");
			m-&gt;new = strdup(av[1]);
			m-&gt;old = strdup(av[2]);
			m-&gt;spec = strdup("");
			break;
		}

		if(!rflag &amp;&amp; strcmp(m-&gt;cmd, "mount")==0)
			xlatemnt(m);

		Bprint(&amp;stdout, "%s %s %s %s %s\n", m-&gt;cmd, m-&gt;flag,
			quote(m-&gt;new), quote(m-&gt;old), quote(m-&gt;spec));

		free(m-&gt;cmd);
		free(m-&gt;flag);
		free(m-&gt;new);
		free(m-&gt;old);
		free(m-&gt;spec);
		free(m);
	}

	exits(nil);
}

void
xlatemnt(Mount *m)
{
	int n, fd;
	char *s, *t, *net, *port;
	char buf[256];

	if(strncmp(m-&gt;new, "/net/", 5) != 0)
		return;

	s = strdup(m-&gt;new);
	net = s+5;
	for(t=net; *t!='/'; t++)
		if(*t == '\0')
			goto Return;
	*t = '\0';
	port = t+1;
	for(t=port; *t!='/'; t++)
		if(*t == '\0')
			goto Return;
	*t = '\0';
	if(strcmp(t+1, "data") != 0)
		goto Return;
	snprint(buf, sizeof buf, "/net/%s/%s/remote", net, port);
	fd = open(buf, OREAD);
	if(fd &lt; 0)
		goto Return;
	n = read(fd, buf, sizeof buf);
	close(fd);
	if(n&lt;=1 || n&gt;sizeof buf)
		goto Return;
	if(buf[n-1] == '\n')
		--n;
	buf[n] = '\0';
	t = malloc(strlen(net)+1+n+1);
	if(t == nil)
		goto Return;
	sprint(t, "%s!%s", net, buf);
	free(m-&gt;new);
	m-&gt;new = t;

Return:	
	free(s);
}

char*
quote(char *s)
{
	static char buf[3][1024];
	static int i;
	char *p, *ep;

	if(strpbrk(s, " '\\\t#$") == nil)
		return s;
	i = (i+1)%3;
	p = &amp;buf[i][0];
	ep = &amp;buf[i][1024];
	*p++ = '\'';
	while(p &lt; ep-5){
		switch(*s){
		case '\0':
			goto out;
		case '\'':
			*p++ = '\'';
			break;
		}
		*p++ = *s++;
	}
    out:
	*p++ = '\'';
	*p = '\0';
	return buf[i];
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

