<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pcc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pcc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;


typedef struct Objtype {
	char	*name;
	char	*cc;
	char	*ld;
	char	*o;
	char	*oname;
} Objtype;

/* sync with /sys/src/ape/cmd/cc.c */
Objtype objtype[] = {
	{"spim",	"0c", "0l", "0", "0.out"},
	{"arm",		"5c", "5l", "5", "5.out"},
	{"amd64",	"6c", "6l", "6", "6.out"},
	{"386",		"8c", "8l", "8", "8.out"},
	{"power64",	"9c", "9l", "9", "9.out"},
	{"sparc",	"kc", "kl", "k", "k.out"},
	{"power",	"qc", "ql", "q", "q.out"},
	{"mips",	"vc", "vl", "v", "v.out"},
};
char	*allos = "05689kqv";

enum {
	Nobjs = (sizeof objtype)/(sizeof objtype[0]),
	Maxlist = 2000,
};

typedef struct List {
	char	*strings[Maxlist];
	int	n;
} List;

List	srcs, objs, cpp, cc, ld, ldargs;
int	cflag, vflag, Eflag, Pflag;

void	append(List *, char *);
char	*changeext(char *, char *);
void	doexec(char *, List *);
void	dopipe(char *, List *, char *, List *);
void	fatal(char *);
Objtype	*findoty(void);
void	printlist(List *);

void
main(int argc, char *argv[])
{
	Objtype *ot;
	char *s, *suf, *ccpath;
	char *oname;
	int i, cppn, ccn, oflag;

	oflag = 0;
	ot = findoty();
	oname = ot-&gt;oname;
	append(&amp;cpp, "cpp");
	append(&amp;cpp, "-D__STDC__=1");	/* ANSI says so */
	append(&amp;cpp, "-N");		/* turn off standard includes */
	append(&amp;cc, ot-&gt;cc);
	append(&amp;ld, ot-&gt;ld);
	while(argc &gt; 0) {
		ARGBEGIN {
		case '+':
			append(&amp;cpp, smprint("-%c", ARGC()));
			break;
		case 'c':
			cflag = 1;
			break;
		case 'l':
			append(&amp;objs, smprint("/%s/lib/ape/lib%s.a", ot-&gt;name, ARGF()));
			break;
		case 'o':
			oflag = 1;
			oname = ARGF();
			if(!oname)
				fatal("no -o argument");
			break;
		case 'w':
		case 'B':
		case 'F':
		case 'N':
		case 'S':
		case 'T':
		case 'V':
		case 'W':
			append(&amp;cc, smprint("-%c", ARGC()));
			break;
		case 's':
			append(&amp;cc, smprint("-s%s", ARGF()));
			break;
		case 'D':
		case 'I':
		case 'U':
			append(&amp;cpp, smprint("-%c%s", ARGC(), ARGF()));
			break;
		case 'v':
			vflag = 1;
			append(&amp;ldargs, "-v");
			break;
		case 'P':
			Pflag = 1;
			cflag = 1;
			break;
		case 'E':
			Eflag = 1;
			cflag = 1;
			break;
		case 'p':
			append(&amp;ldargs, "-p");
			break;
		case 'f':
			if(strcmp(ot-&gt;name, "arm") == 0)
				append(&amp;ldargs, "-f");
			break;
		case 'x':
			s = ARGF();
			if(s == nil || *s == '-')
				fatal("no -x argument");
			append(&amp;ldargs, smprint("-x %s", s));
			break;
		case 'a':
			/* hacky look inside ARGBEGIN insides, to see if we have -aa */
			if(*_args == 'a') {
				append(&amp;cc, "-aa");
				_args++;
			} else
				append(&amp;cc, "-a");
			cflag = 1;
			break;
		default:
			fprint(2, "pcc: flag -%c ignored\n", ARGC());
			break;
		} ARGEND
		if(argc &gt; 0) {
			s = argv[0];
			suf = utfrrune(s, '.');
			if(suf) {
				suf++;
				if(strcmp(suf, "c") == 0) {
					append(&amp;srcs, s);
					append(&amp;objs, changeext(s, ot-&gt;o));
				} else if(strcmp(suf, ot-&gt;o) == 0 ||
					  strcmp(suf, "a") == 0 ||
					  (suf[0] == 'a' &amp;&amp; strcmp(suf+1, ot-&gt;o) == 0)) {
					append(&amp;objs, s);
				} else if(utfrune(allos, suf[0]) != 0) {
					fprint(2, "pcc: argument %s ignored: wrong architecture\n",
						s);
				}
			}
		}
	}
	if(objs.n == 0)
		fatal("no files to compile or load");
	ccpath = smprint("/bin/%s", ot-&gt;cc);
	append(&amp;cpp, smprint("-I/%s/include/ape", ot-&gt;name));
	append(&amp;cpp, "-I/sys/include/ape");
	cppn = cpp.n;
	ccn = cc.n;
	for(i = 0; i &lt; srcs.n; i++) {
		append(&amp;cpp, srcs.strings[i]);
		if(Pflag)
			append(&amp;cpp, changeext(objs.strings[i], "i"));
		if(Eflag || Pflag)
			doexec("/bin/cpp", &amp;cpp);
		else {
			append(&amp;cc, "-o");
			if(oflag &amp;&amp; cflag)
				append(&amp;cc, oname);
			else
				append(&amp;cc, changeext(srcs.strings[i], ot-&gt;o));
			dopipe("/bin/cpp", &amp;cpp, ccpath, &amp;cc);
		}
		cpp.n = cppn;
		cc.n = ccn;
	}
	if(!cflag) {
		append(&amp;ld, "-o");
		append(&amp;ld, oname);
		for(i = 0; i &lt; ldargs.n; i++)
			append(&amp;ld, ldargs.strings[i]);
		for(i = 0; i &lt; objs.n; i++)
			append(&amp;ld, objs.strings[i]);
		append(&amp;ld, smprint("/%s/lib/ape/libap.a", ot-&gt;name));
		doexec(smprint("/bin/%s", ot-&gt;ld), &amp;ld);
		if(objs.n == 1){
			/* prevent removal of a library */
			if(strstr(objs.strings[0], ".a") == 0)
				remove(objs.strings[0]);
		}
	}

	exits(0);
}

void
append(List *l, char *s)
{
	if(l-&gt;n &gt;= Maxlist-1)
		fatal("too many arguments");
	l-&gt;strings[l-&gt;n++] = s;
	l-&gt;strings[l-&gt;n] = 0;
}

void
doexec(char *c, List *a)
{
	Waitmsg *w;

	if(vflag) {
		printlist(a);
		fprint(2, "\n");
	}
	switch(fork()) {
	case -1:
		fatal("fork failed");
	case 0:
		exec(c, a-&gt;strings);
		fatal("exec failed");
	}
	w = wait();
	if(w == nil)
		fatal("wait failed");
	if(w-&gt;msg[0])
		fatal(smprint("%s: %s", a-&gt;strings[0], w-&gt;msg));
	free(w);
}

void
dopipe(char *c1, List *a1, char *c2, List *a2)
{
	Waitmsg *w;
	int pid1, got;
	int fd[2];

	if(vflag) {
		printlist(a1);
		fprint(2, " | ");
		printlist(a2);
		fprint(2, "\n");
	}
	if(pipe(fd) &lt; 0)
		fatal("pipe failed");
	switch((pid1 = fork())) {
	case -1:
		fatal("fork failed");
	case 0:
		dup(fd[0], 0);
		close(fd[0]);
		close(fd[1]);
		exec(c2, a2-&gt;strings);
		fatal("exec failed");
	}
	switch(fork()) {
	case -1:
		fatal("fork failed");
	case 0:
		close(0);
		dup(fd[1], 1);
		close(fd[0]);
		close(fd[1]);
		exec(c1, a1-&gt;strings);
		fatal("exec failed");
	}
	close(fd[0]);
	close(fd[1]);
	for(got = 0; got &lt; 2; got++) {
		w = wait();
		if(w == nil)
			fatal("wait failed");
		if(w-&gt;msg[0])
			fatal(smprint("%s: %s",
			   (w-&gt;pid == pid1) ? a1-&gt;strings[0] : a2-&gt;strings[0], w-&gt;msg));
		free(w);
	}
}

Objtype *
findoty(void)
{
	char *o;
	Objtype *oty;

	o = getenv("objtype");
	if(!o)
		fatal("no $objtype in environment");
	for(oty = objtype; oty &lt; &amp;objtype[Nobjs]; oty++)
		if(strcmp(o, oty-&gt;name) == 0)
			return oty;
	fatal("unknown $objtype");
	return 0;			/* shut compiler up */
}

void
fatal(char *msg)
{
	fprint(2, "pcc: %s\n", msg);
	exits(msg);
}

/* src ends in .something; return copy of basename with .ext added */
char *
changeext(char *src, char *ext)
{
	char *b, *e, *ans;

	b = utfrrune(src, '/');
	if(b)
		b++;
	else
		b = src;
	e = utfrrune(src, '.');
	if(!e)
		return 0;
	*e = 0;
	ans = smprint("%s.%s", b, ext);
	*e = '.';
	return ans;
}

void
printlist(List *l)
{
	int i;

	for(i = 0; i &lt; l-&gt;n; i++) {
		fprint(2, "%s", l-&gt;strings[i]);
		if(i &lt; l-&gt;n - 1)
			fprint(2, " ");
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

