<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pic/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pic/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;stdio.h&gt;
#include	&lt;signal.h&gt;
#include	&lt;stdlib.h&gt;
#include	&lt;string.h&gt;
#include	"pic.h"
#include	"y.tab.h"

char	*version = "version July 5, 1993";

obj	**objlist = 0;		/* store the elements here */
int	nobjlist = 0;		/* size of objlist array */
int	nobj	= 0;

Attr	*attr;	/* attributes stored here as collected */
int	nattrlist = 0;
int	nattr	= 0;	/* number of entries in attr_list */

Text	*text	= 0;	/* text strings stored here as collected */
int	ntextlist = 0;		/* size of text[] array */
int	ntext	= 0;
int	ntext1	= 0;	/* record ntext here on entry to each figure */

double	curx	= 0;
double	cury	= 0;

int	hvmode	= R_DIR;	/* R =&gt; join left to right, D =&gt; top to bottom, etc. */

int	codegen	= 0;	/* 1=&gt;output for this picture; 0=&gt;no output */
char	*PEstring;	/* "PS" or "PE" picked up by lexer */

double	deltx	= 6;	/* max x value in output, for scaling */
double	delty	= 6;	/* max y value in output, for scaling */
int	dbg	= 0;
int	lineno	= 0;
char	*filename	= "-";
int	synerr	= 0;
int	anyerr	= 0;	/* becomes 1 if synerr ever 1 */
char	*cmdname;

double	xmin	= 30000;	/* min values found in actual data */
double	ymin	= 30000;
double	xmax	= -30000;	/* max */
double	ymax	= -30000;

void	fpecatch(int);
void	getdata(void), setdefaults(void);
void	setfval(char *, double);
int	getpid(void);

main(int argc, char *argv[])
{
	char buf[20];

	signal(SIGFPE, fpecatch);
	cmdname = argv[0];
	while (argc &gt; 1 &amp;&amp; *argv[1] == '-') {
		switch (argv[1][1]) {
		case 'd':
			dbg = atoi(&amp;argv[1][2]);
			if (dbg == 0)
				dbg = 1;
			fprintf(stderr, "%s\n", version);
			break;
		case 'V':
			fprintf(stderr, "%s\n", version);
			return 0;
		}
		argc--;
		argv++;
	}
	setdefaults();
	objlist = (obj **) grow((char *)objlist, "objlist", nobjlist += 1000, sizeof(obj *));
	text = (Text *) grow((char *)text, "text", ntextlist += 1000, sizeof(Text));
	attr = (Attr *) grow((char *)attr, "attr", nattrlist += 100, sizeof(Attr));

	sprintf(buf, "/%d/", getpid());
	pushsrc(String, buf);
	definition("pid");

	curfile = infile;
	pushsrc(File, curfile-&gt;fname);
	if (argc &lt;= 1) {
		curfile-&gt;fin = stdin;
		curfile-&gt;fname = tostring("-");
		getdata();
	} else
		while (argc-- &gt; 1) {
			if ((curfile-&gt;fin = fopen(*++argv, "r")) == NULL) {
				fprintf(stderr, "%s: can't open %s\n", cmdname, *argv);
				exit(1);
			}
			curfile-&gt;fname = tostring(*argv);
			getdata();
			fclose(curfile-&gt;fin);
			free(curfile-&gt;fname);
		}
	return anyerr;
}

void fpecatch(int n)
{
	ERROR "floating point exception %d", n FATAL;
}

char *grow(char *ptr, char *name, int num, int size)	/* make array bigger */
{
	char *p;

	if (ptr == NULL)
		p = malloc(num * size);
	else
		p = realloc(ptr, num * size);
	if (p == NULL)
		ERROR "can't grow %s to %d", name, num * size FATAL;
	return p;
}

static struct {
	char *name;
	double val;
	short scalable;		/* 1 =&gt; adjust when "scale" changes */
} defaults[] ={
	"scale", SCALE, 1,
	"lineht", HT, 1,
	"linewid", HT, 1,
	"moveht", HT, 1,
	"movewid", HT, 1,
	"dashwid", HT10, 1,
	"boxht", HT, 1,
	"boxwid", WID, 1,
	"circlerad", HT2, 1,
	"arcrad", HT2, 1,
	"ellipseht", HT, 1,
	"ellipsewid", WID, 1,
	"arrowht", HT5, 1,
	"arrowwid", HT10, 1,
	"arrowhead", 2, 0,		/* arrowhead style */
	"textht", 0.0, 1,		/* 6 lines/inch is also a useful value */
	"textwid", 0.0, 1,
	"maxpsht", MAXHT, 0,
	"maxpswid", MAXWID, 0,
	"fillval", 0.7, 0,		/* gray value for filling boxes */
	NULL, 0, 0
};

void setdefaults(void)	/* set default sizes for variables like boxht */
{
	int i;
	YYSTYPE v;

	for (i = 0; defaults[i].name != NULL; i++) {
		v.f = defaults[i].val;
		makevar(tostring(defaults[i].name), VARNAME, v);
	}
}

void resetvar(void)	/* reset variables listed */
{
	int i, j;

	if (nattr == 0) {	/* none listed, so do all */
		setdefaults();
		return;
	}
	for (i = 0; i &lt; nattr; i++) {
		for (j = 0; defaults[j].name != NULL; j++)
			if (strcmp(defaults[j].name, attr[i].a_val.p) == 0) {
				setfval(defaults[j].name, defaults[j].val);
				free(attr[i].a_val.p);
				break;
			}
	}
}

void checkscale(char *s)	/* if s is "scale", adjust default variables */
{
	int i;
	double scale;

	if (strcmp(s, "scale") == 0) {
		scale = getfval("scale");
		for (i = 1; defaults[i].name != NULL; i++)
			if (defaults[i].scalable)
				setfval(defaults[i].name, defaults[i].val * scale);
	}
}

void getdata(void)
{
	char *p, buf[1000], buf1[100];
	int ln;
	void reset(void), openpl(char *), closepl(char *), print(void);
	int yyparse(void);

	curfile-&gt;lineno = 0;
	printlf(1, curfile-&gt;fname);
	while (fgets(buf, sizeof buf, curfile-&gt;fin) != NULL) {
		curfile-&gt;lineno++;
		if (*buf == '.' &amp;&amp; *(buf+1) == 'P' &amp;&amp; *(buf+2) == 'S') {
			for (p = &amp;buf[3]; *p == ' '; p++)
				;
			if (*p++ == '&lt;') {
				Infile svfile;
				svfile = *curfile;
				sscanf(p, "%s", buf1);
				if ((curfile-&gt;fin=fopen(buf1, "r")) == NULL)
					ERROR "can't open %s", buf1 FATAL;
				curfile-&gt;fname = tostring(buf1);
				getdata();
				fclose(curfile-&gt;fin);
				free(curfile-&gt;fname);
				*curfile = svfile;
				printlf(curfile-&gt;lineno, curfile-&gt;fname);
				continue;
			}
			reset();
			yyparse();
			anyerr += synerr;
			deltx = (xmax - xmin) / getfval("scale");
			delty = (ymax - ymin) / getfval("scale");
			if (buf[3] == ' ') {	/* next things are wid &amp; ht */
				if (sscanf(&amp;buf[4],"%lf %lf", &amp;deltx, &amp;delty) &lt; 2)
					delty = deltx * (ymax-ymin) / (xmax-xmin);
				/* else {
				/*	double xfac, yfac; */
				/*	xfac = deltx / (xmax-xmin);
				/*	yfac = delty / (ymax-ymin);
				/*	if (xfac &lt;= yfac)
				/*		delty = xfac * (ymax-ymin);
				/*	else
				/*		deltx = yfac * (xmax-xmin);
				/*}
				*/
			}
			dprintf("deltx = %g, delty = %g\n", deltx, delty);
			if (codegen &amp;&amp; !synerr) {
				openpl(&amp;buf[3]);	/* puts out .PS, with ht &amp; wid stuck in */
				printlf(curfile-&gt;lineno+1, NULL);
				print();	/* assumes \n at end */
				closepl(PEstring);	/* does the .PE/F */
				free(PEstring);
			}
			printlf(curfile-&gt;lineno+1, NULL);
			fflush(stdout);
		} else if (buf[0] == '.' &amp;&amp; buf[1] == 'l' &amp;&amp; buf[2] == 'f') {
			if (sscanf(buf+3, "%d %s", &amp;ln, buf1) == 2) {
				free(curfile-&gt;fname);
				printlf(curfile-&gt;lineno = ln, curfile-&gt;fname = tostring(buf1));
			} else
				printlf(curfile-&gt;lineno = ln, NULL);
		} else
			fputs(buf, stdout);
	}
}

void reset(void)
{
	obj *op;
	int i;
	extern int nstack;
	extern	void freesymtab(struct symtab *);

	for (i = 0; i &lt; nobj; i++) {
		op = objlist[i];
		if (op-&gt;o_type == BLOCK)
			freesymtab(op-&gt;o_symtab);
		free((char *)objlist[i]);
	}
	nobj = 0;
	nattr = 0;
	for (i = 0; i &lt; ntext; i++)
		if (text[i].t_val)
			free(text[i].t_val);
	ntext = ntext1 = 0;
	codegen = synerr = 0;
	nstack = 0;
	curx = cury = 0;
	PEstring = 0;
	hvmode = R_DIR;
	xmin = ymin = 30000;
	xmax = ymax = -30000;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

