<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pic/misc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pic/misc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdio.h&gt;
#include &lt;string.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;math.h&gt;
#include "pic.h"
#include "y.tab.h"

int whatpos(obj *p, int corner, double *px, double *py);
void makeattr(int type, int sub, YYSTYPE val);
YYSTYPE getblk(obj *, char *);

setdir(int n)	/* set direction (hvmode) from LEFT, RIGHT, etc. */
{
	switch (n) {
	case UP:	hvmode = U_DIR; break;
	case DOWN:	hvmode = D_DIR; break;
	case LEFT:	hvmode = L_DIR; break;
	case RIGHT:	hvmode = R_DIR; break;
	}
 	return(hvmode);
}

curdir(void)	/* convert current dir (hvmode) to RIGHT, LEFT, etc. */
{
	switch (hvmode) {
	case R_DIR:	return RIGHT;
	case L_DIR:	return LEFT;
	case U_DIR:	return UP;
	case D_DIR:	return DOWN;
	}
	ERROR "can't happen curdir" FATAL;
	return 0;
}

double getcomp(obj *p, int t)	/* return component of a position */
{
	switch (t) {
	case DOTX:
		return p-&gt;o_x;
	case DOTY:
		return p-&gt;o_y;
	case DOTWID:
		switch (p-&gt;o_type) {
		case BOX:
		case BLOCK:
		case TEXT:
			return p-&gt;o_val[0];
		case CIRCLE:
		case ELLIPSE:
			return 2 * p-&gt;o_val[0];
		case LINE:
		case ARROW:
			return p-&gt;o_val[0] - p-&gt;o_x;
		case PLACE:
			return 0;
		}
	case DOTHT:
		switch (p-&gt;o_type) {
		case BOX:
		case BLOCK:
		case TEXT:
			return p-&gt;o_val[1];
		case CIRCLE:
		case ELLIPSE:
			return 2 * p-&gt;o_val[1];
		case LINE:
		case ARROW:
			return p-&gt;o_val[1] - p-&gt;o_y;
		case PLACE:
			return 0;
		}
	case DOTRAD:
		switch (p-&gt;o_type) {
		case CIRCLE:
		case ELLIPSE:
			return p-&gt;o_val[0];
		}
	}
	ERROR "you asked for a weird dimension or position" WARNING;
	return 0;
}

double	exprlist[100];
int	nexpr	= 0;

void exprsave(double f)
{
	exprlist[nexpr++] = f;
}

char *sprintgen(char *fmt)
{
	char buf[1000];

	sprintf(buf, fmt, exprlist[0], exprlist[1], exprlist[2], exprlist[3], exprlist[4]);
	nexpr = 0;
	free(fmt);
	return tostring(buf);
}

void makefattr(int type, int sub, double f)	/* double attr */
{
	YYSTYPE val;
	val.f = f;
	makeattr(type, sub, val);
}

void makeoattr(int type, obj *o)	/* obj* attr */
{
	YYSTYPE val;
	val.o = o;
	makeattr(type, 0, val);
}

void makeiattr(int type, int i)	/* int attr */
{
	YYSTYPE val;
	val.i = i;
	makeattr(type, 0, val);
}

void maketattr(int sub, char *p)	/* text attribute: takes two */
{
	YYSTYPE val;
	val.p = p;
	makeattr(TEXTATTR, sub, val);
}

void addtattr(int sub)		/* add text attrib to existing item */
{
	attr[nattr-1].a_sub |= sub;
}

void makevattr(char *p)	/* varname attribute */
{
	YYSTYPE val;
	val.p = p;
	makeattr(VARNAME, 0, val);
}

void makeattr(int type, int sub, YYSTYPE val)	/* add attribute type and val */
{
	if (type == 0 &amp;&amp; val.i == 0) {	/* clear table for next stat */
		nattr = 0;
		return;
	}
	if (nattr &gt;= nattrlist)
		attr = (Attr *) grow((char *)attr, "attr", nattrlist += 100, sizeof(Attr));
	dprintf("attr %d:  %d %d %d\n", nattr, type, sub, val.i);
	attr[nattr].a_type = type;
	attr[nattr].a_sub = sub;
	attr[nattr].a_val = val;
	nattr++;
}

void printexpr(double f)	/* print expression for debugging */
{
	printf("%g\n", f);
}

void printpos(obj *p)	/* print position for debugging */
{
	printf("%g, %g\n", p-&gt;o_x, p-&gt;o_y);
}

char *tostring(char *s)
{
	register char *p;

	p = malloc(strlen(s)+1);
	if (p == NULL)
		ERROR "out of space in tostring on %s", s FATAL;
	strcpy(p, s);
	return(p);
}

obj *makepos(double x, double y)	/* make a position cell */
{
	obj *p;

	p = makenode(PLACE, 0);
	p-&gt;o_x = x;
	p-&gt;o_y = y;
	return(p);
}

obj *makebetween(double f, obj *p1, obj *p2)	/* make position between p1 and p2 */
{
	obj *p;

	dprintf("fraction = %.2f\n", f);
	p = makenode(PLACE, 0);
	p-&gt;o_x = p1-&gt;o_x + f * (p2-&gt;o_x - p1-&gt;o_x);
	p-&gt;o_y = p1-&gt;o_y + f * (p2-&gt;o_y - p1-&gt;o_y);
	return(p);
}

obj *getpos(obj *p, int corner)	/* find position of point */
{
	double x, y;

	whatpos(p, corner, &amp;x, &amp;y);
	return makepos(x, y);
}

int whatpos(obj *p, int corner, double *px, double *py)	/* what is the position (no side effect) */
{
	double x, y, x1, y1;

	if (p == NULL)
		ERROR "null object" FATAL;
	dprintf("whatpos %o %d %d\n", p, p-&gt;o_type, corner);
	x = p-&gt;o_x;
	y = p-&gt;o_y;
	if (p-&gt;o_type != PLACE &amp;&amp; p-&gt;o_type != MOVE) {
		x1 = p-&gt;o_val[0];
		y1 = p-&gt;o_val[1];
	}
	switch (p-&gt;o_type) {
	case PLACE:
		break;
	case BOX:
	case BLOCK:
	case TEXT:
		switch (corner) {
		case NORTH:	y += y1 / 2; break;
		case SOUTH:	y -= y1 / 2; break;
		case EAST:	x += x1 / 2; break;
		case WEST:	x -= x1 / 2; break;
		case NE:	x += x1 / 2; y += y1 / 2; break;
		case SW:	x -= x1 / 2; y -= y1 / 2; break;
		case SE:	x += x1 / 2; y -= y1 / 2; break;
		case NW:	x -= x1 / 2; y += y1 / 2; break;
		case START:
			if (p-&gt;o_type == BLOCK)
				return whatpos(objlist[(int)p-&gt;o_val[2]], START, px, py);
		case END:
			if (p-&gt;o_type == BLOCK)
				return whatpos(objlist[(int)p-&gt;o_val[3]], END, px, py);
		}
		break;
	case ARC:
		switch (corner) {
		case START:
			if (p-&gt;o_attr &amp; CW_ARC) {
				x = p-&gt;o_val[2]; y = p-&gt;o_val[3];
			} else {
				x = x1; y = y1;
			}
			break;
		case END:
			if (p-&gt;o_attr &amp; CW_ARC) {
				x = x1; y = y1;
			} else {
				x = p-&gt;o_val[2]; y = p-&gt;o_val[3];
			}
			break;
		}
		if (corner == START || corner == END)
			break;
		x1 = y1 = sqrt((x1-x)*(x1-x) + (y1-y)*(y1-y));
		/* Fall Through! */
	case CIRCLE:
	case ELLIPSE:
		switch (corner) {
		case NORTH:	y += y1; break;
		case SOUTH:	y -= y1; break;
		case EAST:	x += x1; break;
		case WEST:	x -= x1; break;
		case NE:	x += 0.707 * x1; y += 0.707 * y1; break;
		case SE:	x += 0.707 * x1; y -= 0.707 * y1; break;
		case NW:	x -= 0.707 * x1; y += 0.707 * y1; break;
		case SW:	x -= 0.707 * x1; y -= 0.707 * y1; break;
		}
		break;
	case LINE:
	case SPLINE:
	case ARROW:
		switch (corner) {
		case START:	break;	/* already in place */
		case END:	x = x1; y = y1; break;
		default: /* change! */
		case CENTER:	x = (x+x1)/2; y = (y+y1)/2; break;
		case NORTH:	if (y1 &gt; y) { x = x1; y = y1; } break;
		case SOUTH:	if (y1 &lt; y) { x = x1; y = y1; } break;
		case EAST:	if (x1 &gt; x) { x = x1; y = y1; } break;
		case WEST:	if (x1 &lt; x) { x = x1; y = y1; } break;
		}
		break;
	case MOVE:
		/* really ought to be same as line... */
		break;
	}
	dprintf("whatpos returns %g %g\n", x, y);
	*px = x;
	*py = y;
	return 1;
}

obj *gethere(void)	/* make a place for curx,cury */
{
	dprintf("gethere %g %g\n", curx, cury);
	return(makepos(curx, cury));
}

obj *getlast(int n, int t)	/* find n-th previous occurrence of type t */
{
	int i, k;
	obj *p;

	k = n;
	for (i = nobj-1; i &gt;= 0; i--) {
		p = objlist[i];
		if (p-&gt;o_type == BLOCKEND) {
			i = p-&gt;o_val[4];
			continue;
		}
		if (p-&gt;o_type != t)
			continue;
		if (--k &gt; 0)
			continue;	/* not there yet */
		dprintf("got a last of x,y= %g,%g\n", p-&gt;o_x, p-&gt;o_y);
		return(p);
	}
	ERROR "there is no %dth last", n FATAL;
	return(NULL);
}

obj *getfirst(int n, int t)	/* find n-th occurrence of type t */
{
	int i, k;
	obj *p;

	k = n;
	for (i = 0; i &lt; nobj; i++) {
		p = objlist[i];
		if (p-&gt;o_type == BLOCK &amp;&amp; t != BLOCK) {	/* skip whole block */
			i = p-&gt;o_val[5] + 1;
			continue;
		}
		if (p-&gt;o_type != t)
			continue;
		if (--k &gt; 0)
			continue;	/* not there yet */
		dprintf("got a first of x,y= %g,%g\n", p-&gt;o_x, p-&gt;o_y);
		return(p);
	}
	ERROR "there is no %dth ", n FATAL;
	return(NULL);
}

double getblkvar(obj *p, char *s)	/* find variable s2 in block p */
{
	YYSTYPE y;

	y = getblk(p, s);
	return y.f;
}

obj *getblock(obj *p, char *s)	/* find variable s in block p */
{
	YYSTYPE y;

	y = getblk(p, s);
	return y.o;
}

YYSTYPE getblk(obj *p, char *s)	/* find union type for s in p */
{
	static YYSTYPE bug;
	struct symtab *stp;

	if (p-&gt;o_type != BLOCK) {
		ERROR ".%s is not in that block", s WARNING;
		return(bug);
	}
	for (stp = p-&gt;o_symtab; stp != NULL; stp = stp-&gt;s_next)
		if (strcmp(s, stp-&gt;s_name) == 0) {
			dprintf("getblk %s found x,y= %g,%g\n",
				s, (stp-&gt;s_val.o)-&gt;o_x, (stp-&gt;s_val.o)-&gt;o_y);
			return(stp-&gt;s_val);
		}
	ERROR "there is no .%s in that []", s WARNING;
	return(bug);
}

obj *fixpos(obj *p, double x, double y)
{
	dprintf("fixpos returns %g %g\n", p-&gt;o_x + x, p-&gt;o_y + y);
	return makepos(p-&gt;o_x + x, p-&gt;o_y + y);
}

obj *addpos(obj *p, obj *q)
{
	dprintf("addpos returns %g %g\n", p-&gt;o_x+q-&gt;o_x, p-&gt;o_y+q-&gt;o_y);
	return makepos(p-&gt;o_x+q-&gt;o_x, p-&gt;o_y+q-&gt;o_y);
}

obj *subpos(obj *p, obj *q)
{
	dprintf("subpos returns %g %g\n", p-&gt;o_x-q-&gt;o_x, p-&gt;o_y-q-&gt;o_y);
	return makepos(p-&gt;o_x-q-&gt;o_x, p-&gt;o_y-q-&gt;o_y);
}

obj *makenode(int type, int n)
{
	obj *p;

	p = (obj *) calloc(1, sizeof(obj) + (n-1)*sizeof(ofloat));
	if (p == NULL)
		ERROR "out of space in makenode" FATAL;
	p-&gt;o_type = type;
	p-&gt;o_count = n;
	p-&gt;o_nobj = nobj;
	p-&gt;o_mode = hvmode;
	p-&gt;o_x = curx;
	p-&gt;o_y = cury;
	p-&gt;o_nt1 = ntext1;
	p-&gt;o_nt2 = ntext;
	ntext1 = ntext;	/* ready for next caller */
	if (nobj &gt;= nobjlist)
		objlist = (obj **) grow((char *) objlist, "objlist",
			nobjlist *= 2, sizeof(obj *));
	objlist[nobj++] = p;
	return(p);
}

void extreme(double x, double y)	/* record max and min x and y values */
{
	if (x &gt; xmax)
		xmax = x;
	if (y &gt; ymax)
		ymax = y;
	if (x &lt; xmin)
		xmin = x;
	if (y &lt; ymin)
		ymin = y;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

