<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pic/print.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pic/print.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdio.h&gt;
#include &lt;math.h&gt;
#include "pic.h"
#include "y.tab.h"

void dotext(obj *);
void dotline(double, double, double, double, int, double);
void dotbox(double, double, double, double, int, double);
void ellipse(double, double, double, double);
void circle(double, double, double);
void arc(double, double, double, double, double, double);
void arrow(double, double, double, double, double, double, double, int);
void line(double, double, double, double);
void box(double, double, double, double);
void spline(double x, double y, double n, ofloat *p, int dashed, double ddval);
void move(double, double);
void troff(char *);
void dot(void);
void fillstart(double), fillend(int vis, int noedge);

void print(void)
{
	obj *p;
	int i, j, k, m;
	int fill, vis, invis;
	double x0, y0, x1, y1, ox, oy, dx, dy, ndx, ndy;

	for (i = 0; i &lt; nobj; i++) {
		p = objlist[i];
		ox = p-&gt;o_x;
		oy = p-&gt;o_y;
		if (p-&gt;o_count &gt;= 1)
			x1 = p-&gt;o_val[0];
		if (p-&gt;o_count &gt;= 2)
			y1 = p-&gt;o_val[1];
		m = p-&gt;o_mode;
		fill = p-&gt;o_attr &amp; FILLBIT;
		invis = p-&gt;o_attr &amp; INVIS;
		vis = !invis;
		switch (p-&gt;o_type) {
		case TROFF:
			troff(text[p-&gt;o_nt1].t_val);
			break;
		case BOX:
		case BLOCK:
			x0 = ox - x1 / 2;
			y0 = oy - y1 / 2;
			x1 = ox + x1 / 2;
			y1 = oy + y1 / 2;
			if (fill) {
				move(x0, y0);
				fillstart(p-&gt;o_fillval);
			}
			if (p-&gt;o_type == BLOCK){
				;	/* nothing at all */
			}else if (invis &amp;&amp; !fill){
				;	/* nothing at all */
			}else if (p-&gt;o_attr &amp; (DOTBIT|DASHBIT))
				dotbox(x0, y0, x1, y1, p-&gt;o_attr, p-&gt;o_ddval);
			else
				box(x0, y0, x1, y1);
			if (fill)
				fillend(vis, fill);
			move(ox, oy);
			dotext(p);	/* if there are any text strings */
			if (ishor(m))
				move(isright(m) ? x1 : x0, oy);	/* right side */
			else
				move(ox, isdown(m) ? y0 : y1);	/* bottom */
			break;
		case BLOCKEND:
			break;
		case CIRCLE:
			if (fill)
				fillstart(p-&gt;o_fillval);
			if (vis || fill)
				circle(ox, oy, x1);
			if (fill)
				fillend(vis, fill);
			move(ox, oy);
			dotext(p);
			if (ishor(m))
				move(ox + isright(m) ? x1 : -x1, oy);
			else
				move(ox, oy + isup(m) ? x1 : -x1);
			break;
		case ELLIPSE:
			if (fill)
				fillstart(p-&gt;o_fillval);
			if (vis || fill)
				ellipse(ox, oy, x1, y1);
			if (fill)
				fillend(vis, fill);
			move(ox, oy);
			dotext(p);
			if (ishor(m))
				move(ox + isright(m) ? x1 : -x1, oy);
			else
				move(ox, oy - isdown(m) ? y1 : -y1);
			break;
		case ARC:
			if (fill) {
				move(ox, oy);
				fillstart(p-&gt;o_fillval);
			}
			if (p-&gt;o_attr &amp; HEAD1)
				arrow(x1 - (y1 - oy), y1 + (x1 - ox),
				      x1, y1, p-&gt;o_val[4], p-&gt;o_val[5], p-&gt;o_val[5]/p-&gt;o_val[6]/2, p-&gt;o_nhead);
                        if (invis &amp;&amp; !fill)
                                /* probably wrong when it's cw */
                                move(x1, y1);
                        else
				arc(ox, oy, x1, y1, p-&gt;o_val[2], p-&gt;o_val[3]);
			if (p-&gt;o_attr &amp; HEAD2)
				arrow(p-&gt;o_val[2] + p-&gt;o_val[3] - oy, p-&gt;o_val[3] - (p-&gt;o_val[2] - ox),
				      p-&gt;o_val[2], p-&gt;o_val[3], p-&gt;o_val[4], p-&gt;o_val[5], -p-&gt;o_val[5]/p-&gt;o_val[6]/2, p-&gt;o_nhead);
			if (fill)
				fillend(vis, fill);
			if (p-&gt;o_attr &amp; CW_ARC)
				move(x1, y1);	/* because drawn backwards */
			move(ox, oy);
			dotext(p);
			break;
		case LINE:
		case ARROW:
		case SPLINE:
			if (fill) {
				move(ox, oy);
				fillstart(p-&gt;o_fillval);
			}
			if (vis &amp;&amp; p-&gt;o_attr &amp; HEAD1)
				arrow(ox + p-&gt;o_val[5], oy + p-&gt;o_val[6], ox, oy, p-&gt;o_val[2], p-&gt;o_val[3], 0.0, p-&gt;o_nhead);
                        if (invis &amp;&amp; !fill)
                                move(x1, y1);
			else if (p-&gt;o_type == SPLINE)
				spline(ox, oy, p-&gt;o_val[4], &amp;p-&gt;o_val[5], p-&gt;o_attr &amp; (DOTBIT|DASHBIT), p-&gt;o_ddval);
			else {
				dx = ox;
				dy = oy;
				for (k=0, j=5; k &lt; p-&gt;o_val[4]; k++, j += 2) {
					ndx = dx + p-&gt;o_val[j];
					ndy = dy + p-&gt;o_val[j+1];
					if (p-&gt;o_attr &amp; (DOTBIT|DASHBIT))
						dotline(dx, dy, ndx, ndy, p-&gt;o_attr, p-&gt;o_ddval);
					else
						line(dx, dy, ndx, ndy);
					dx = ndx;
					dy = ndy;
				}
			}
			if (vis &amp;&amp; p-&gt;o_attr &amp; HEAD2) {
				dx = ox;
				dy = oy;
				for (k = 0, j = 5; k &lt; p-&gt;o_val[4] - 1; k++, j += 2) {
					dx += p-&gt;o_val[j];
					dy += p-&gt;o_val[j+1];
				}
				arrow(dx, dy, x1, y1, p-&gt;o_val[2], p-&gt;o_val[3], 0.0, p-&gt;o_nhead);
			}
			if (fill)
				fillend(vis, fill);
			move((ox + x1)/2, (oy + y1)/2);	/* center */
			dotext(p);
			break;
		case MOVE:
			move(ox, oy);
			break;
		case TEXT:
			move(ox, oy);
                        if (vis)
				dotext(p);
			break;
		}
	}
}

void dotline(double x0, double y0, double x1, double y1, int ddtype, double ddval) /* dotted line */
{
	static double prevval = 0.05;	/* 20 per inch by default */
	int i, numdots;
	double a, b, dx, dy;

	if (ddval == 0)
		ddval = prevval;
	prevval = ddval;
	/* don't save dot/dash value */
	dx = x1 - x0;
	dy = y1 - y0;
	if (ddtype &amp; DOTBIT) {
		numdots = sqrt(dx*dx + dy*dy) / prevval + 0.5;
		if (numdots &gt; 0)
			for (i = 0; i &lt;= numdots; i++) {
				a = (double) i / (double) numdots;
				move(x0 + (a * dx), y0 + (a * dy));
				dot();
			}
	} else if (ddtype &amp; DASHBIT) {
		double d, dashsize, spacesize;
		d = sqrt(dx*dx + dy*dy);
		if (d &lt;= 2 * prevval) {
			line(x0, y0, x1, y1);
			return;
		}
		numdots = d / (2 * prevval) + 1;	/* ceiling */
		dashsize = prevval;
		spacesize = (d - numdots * dashsize) / (numdots - 1);
		for (i = 0; i &lt; numdots-1; i++) {
			a = i * (dashsize + spacesize) / d;
			b = a + dashsize / d;
			line(x0 + (a*dx), y0 + (a*dy), x0 + (b*dx), y0 + (b*dy));
			a = b;
			b = a + spacesize / d;
			move(x0 + (a*dx), y0 + (a*dy));
		}
		line(x0 + (b * dx), y0 + (b * dy), x1, y1);
	}
	prevval = 0.05;
}

void dotbox(double x0, double y0, double x1, double y1, int ddtype, double ddval)	/* dotted or dashed box */
{
	dotline(x0, y0, x1, y0, ddtype, ddval);
	dotline(x1, y0, x1, y1, ddtype, ddval);
	dotline(x1, y1, x0, y1, ddtype, ddval);
	dotline(x0, y1, x0, y0, ddtype, ddval);
}

void dotext(obj *p)	/* print text strings of p in proper vertical spacing */
{
	int i, nhalf;
	void label(char *, int, int);

	nhalf = p-&gt;o_nt2 - p-&gt;o_nt1 - 1;
	for (i = p-&gt;o_nt1; i &lt; p-&gt;o_nt2; i++) {
		label(text[i].t_val, text[i].t_type, nhalf);
		nhalf -= 2;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

