<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pic/symtab.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pic/symtab.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;ctype.h&gt;
#include &lt;string.h&gt;
#include "pic.h"
#include "y.tab.h"

YYSTYPE getvar(char *s)	/* return value of variable s (usually pointer) */
{
	struct symtab *p;
	static YYSTYPE bug;

	p = lookup(s);
	if (p == NULL) {
		if (islower(s[0]))
			ERROR "no such variable as %s", s WARNING;
		else
			ERROR "no such place as %s", s WARNING;
		return(bug);
	}
	return(p-&gt;s_val);
}

double getfval(char *s)	/* return float value of variable s */
{
	YYSTYPE y;

	y = getvar(s);
	return y.f;
}

void setfval(char *s, double f)	/* set variable s to f */
{
	struct symtab *p;

	if ((p = lookup(s)) != NULL)
		p-&gt;s_val.f = f;
}

struct symtab *makevar(char *s, int t, YYSTYPE v)	/* make variable named s in table */
		/* assumes s is static or from tostring */
{
	struct symtab *p;

	for (p = stack[nstack].p_symtab; p != NULL; p = p-&gt;s_next)
		if (strcmp(s, p-&gt;s_name) == 0)
			break;
	if (p == NULL) {	/* it's a new one */
		p = (struct symtab *) malloc(sizeof(struct symtab));
		if (p == NULL)
			ERROR "out of symtab space with %s", s FATAL;
		p-&gt;s_next = stack[nstack].p_symtab;
		stack[nstack].p_symtab = p;	/* stick it at front */
	}
	p-&gt;s_name = s;
	p-&gt;s_type = t;
	p-&gt;s_val = v;
	return(p);
}

struct symtab *lookup(char *s)	/* find s in symtab */
{
	int i;
	struct symtab *p;

	for (i = nstack; i &gt;= 0; i--)	/* look in each active symtab */
		for (p = stack[i].p_symtab; p != NULL; p = p-&gt;s_next)
			if (strcmp(s, p-&gt;s_name) == 0)
				return(p);
	return(NULL);
}

void freesymtab(struct symtab *p)	/* free space used by symtab at p */
{
	struct symtab *q;

	for ( ; p != NULL; p = q) {
		q = p-&gt;s_next;
		free(p-&gt;s_name);	/* assumes done with tostring */
		free((char *)p);
	}
}

void freedef(char *s)	/* free definition for string s */
{
	struct symtab *p, *q, *op;

	for (p = op = q = stack[nstack].p_symtab; p != NULL; p = p-&gt;s_next) {
		if (strcmp(s, p-&gt;s_name) == 0) { 	/* got it */
			if (p-&gt;s_type != DEFNAME)
				break;
			if (p == op)	/* 1st elem */
				stack[nstack].p_symtab = p-&gt;s_next;
			else
				q-&gt;s_next = p-&gt;s_next;
			free(p-&gt;s_name);
			free(p-&gt;s_val.p);
			free((char *)p);
			return;
		}
		q = p;
	}
	/* ERROR "%s is not defined at this point", s WARNING; */
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

