<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/plumb/rules.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/plumb/rules.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;regexp.h&gt;
#include &lt;thread.h&gt;
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;
#include "plumber.h"

typedef struct Input Input;
typedef struct Var Var;

struct Input
{
	char		*file;		/* name of file */
	Biobuf	*fd;		/* input buffer, if from real file */
	uchar	*s;		/* input string, if from /mnt/plumb/rules */
	uchar	*end;	/* end of input string */
	int		lineno;
	Input	*next;	/* file to read after EOF on this one */
};

struct Var
{
	char	*name;
	char	*value;
	char *qvalue;
};

static int		parsing;
static int		nvars;
static Var		*vars;
static Input	*input;

static char 	ebuf[4096];

char *badports[] =
{
	".",
	"..",
	"send",
	nil
};

char *objects[] =
{
	"arg",
	"attr",
	"data",
	"dst",
	"plumb",
	"src",
	"type",
	"wdir",
	nil
};

char *verbs[] =
{
	"add",
	"client",
	"delete",
	"is",
	"isdir",
	"isfile",
	"matches",
	"set",
	"start",
	"to",
	nil
};

static void
printinputstackrev(Input *in)
{
	if(in == nil)
		return;
	printinputstackrev(in-&gt;next);
	fprint(2, "%s:%d: ", in-&gt;file, in-&gt;lineno);
}

void
printinputstack(void)
{
	printinputstackrev(input);
}

static void
pushinput(char *name, int fd, uchar *str)
{
	Input *in;
	int depth;

	depth = 0;
	for(in=input; in; in=in-&gt;next)
		if(depth++ &gt;= 10)	/* prevent deep C stack in plumber and bad include structure */
			parseerror("include stack too deep; max 10");

	in = emalloc(sizeof(Input));
	in-&gt;file = estrdup(name);
	in-&gt;next = input;
	input = in;
	if(str)
		in-&gt;s = str;
	else{
		in-&gt;fd = emalloc(sizeof(Biobuf));
		if(Binit(in-&gt;fd, fd, OREAD) &lt; 0)
			parseerror("can't initialize Bio for rules file: %r");
	}

}

int
popinput(void)
{
	Input *in;

	in = input;
	if(in == nil)
		return 0;
	input = in-&gt;next;
	if(in-&gt;fd){
		Bterm(in-&gt;fd);
		free(in-&gt;fd);
	}
	free(in-&gt;file);
	free(in);
	return 1;
}

int
getc(void)
{
	if(input == nil)
		return Beof;
	if(input-&gt;fd)
		return Bgetc(input-&gt;fd);
	if(input-&gt;s &lt; input-&gt;end)
		return *(input-&gt;s)++;
	return -1;
}

char*
getline(void)
{
	static int n = 0;
	static char *s, *incl;
	int c, i;

	i = 0;
	for(;;){
		c = getc();
		if(c &lt; 0)
			return nil;
		if(i == n){
			n += 100;
			s = erealloc(s, n);
		}
		if(c&lt;0 || c=='\0' || c=='\n')
			break;
		s[i++] = c;
	}
	s[i] = '\0';
	return s;
}

int
lookup(char *s, char *tab[])
{
	int i;

	for(i=0; tab[i]!=nil; i++)
		if(strcmp(s, tab[i])==0)
			return i;
	return -1;
}

Var*
lookupvariable(char *s, int n)
{
	int i;

	for(i=0; i&lt;nvars; i++)
		if(n==strlen(vars[i].name) &amp;&amp; memcmp(s, vars[i].name, n)==0)
			return vars+i;
	return nil;
}

char*
variable(char *s, int n)
{
	Var *var;

	var = lookupvariable(s, n);
	if(var)
		return var-&gt;qvalue;
	return nil;
}

void
setvariable(char  *s, int n, char *val, char *qval)
{
	Var *var;

	var = lookupvariable(s, n);
	if(var){
		free(var-&gt;value);
		free(var-&gt;qvalue);
	}else{
		vars = erealloc(vars, (nvars+1)*sizeof(Var));
		var = vars+nvars++;
		var-&gt;name = emalloc(n+1);
		memmove(var-&gt;name, s, n);
	}
	var-&gt;value = estrdup(val);
	var-&gt;qvalue = estrdup(qval);
}

static char*
nonnil(char *s)
{
	if(s == nil)
		return "";
	return s;
}

static char*
filename(Exec *e, char *name)
{
	static char *buf;	/* rock to hold value so we don't leak the strings */

	free(buf);
	/* if name is defined, used it */
	if(name!=nil &amp;&amp; name[0]!='\0'){
		buf = estrdup(name);
		return cleanname(buf);
	}
	/* if data is an absolute file name, or wdir is empty, use it */
	if(e-&gt;msg-&gt;data[0]=='/' || e-&gt;msg-&gt;wdir==nil || e-&gt;msg-&gt;wdir[0]=='\0'){
		buf = estrdup(e-&gt;msg-&gt;data);
		return cleanname(buf);
	}
	buf = emalloc(strlen(e-&gt;msg-&gt;wdir)+1+strlen(e-&gt;msg-&gt;data)+1);
	sprint(buf, "%s/%s", e-&gt;msg-&gt;wdir, e-&gt;msg-&gt;data);
	return cleanname(buf);
}

char*
dollar(Exec *e, char *s, int *namelen)
{
	int n;
	static char *abuf;
	char *t;

	*namelen = 1;
	if(e!=nil &amp;&amp; '0'&lt;=s[0] &amp;&amp; s[0]&lt;='9')
		return nonnil(e-&gt;match[s[0]-'0']);

	for(t=s; isalnum(*t); t++)
		;
	n = t-s;
	*namelen = n;

	if(e != nil){
		if(n == 3){
			if(memcmp(s, "src", 3) == 0)
				return nonnil(e-&gt;msg-&gt;src);
			if(memcmp(s, "dst", 3) == 0)
				return nonnil(e-&gt;msg-&gt;dst);
			if(memcmp(s, "dir", 3) == 0)
				return filename(e, e-&gt;dir);
		}
		if(n == 4){
			if(memcmp(s, "attr", 4) == 0){
				free(abuf);
				abuf = plumbpackattr(e-&gt;msg-&gt;attr);
				return nonnil(abuf);
			}
			if(memcmp(s, "data", 4) == 0)
				return nonnil(e-&gt;msg-&gt;data);
			if(memcmp(s, "file", 4) == 0)
				return filename(e, e-&gt;file);
			if(memcmp(s, "type", 4) == 0)
				return nonnil(e-&gt;msg-&gt;type);
			if(memcmp(s, "wdir", 3) == 0)
				return nonnil(e-&gt;msg-&gt;wdir);
		}
	}

	return variable(s, n);
}

/* expand one blank-terminated string, processing quotes and $ signs */
char*
expand(Exec *e, char *s, char **ends)
{
	char *p, *ep, *val;
	int namelen, quoting;

	p = ebuf;
	ep = ebuf+sizeof ebuf-1;
	quoting = 0;
	while(p&lt;ep &amp;&amp; *s!='\0' &amp;&amp; (quoting || (*s!=' ' &amp;&amp; *s!='\t'))){
		if(*s == '\''){
			s++;
			if(!quoting)
				quoting = 1;
			else  if(*s == '\''){
				*p++ = '\'';
				s++;
			}else
				quoting = 0;
			continue;
		}
		if(quoting || *s!='$'){
			*p++ = *s++;
			continue;
		}
		s++;
		val = dollar(e, s, &amp;namelen);
		if(val == nil){
			*p++ = '$';
			continue;
		}
		if(ep-p &lt; strlen(val))
			return "string-too-long";
		strcpy(p, val);
		p += strlen(val);
		s += namelen;
	}
	if(ends)
		*ends = s;
	*p = '\0';
	return ebuf;
}

void
regerror(char *msg)
{
	if(parsing){
		parsing = 0;
		parseerror("%s", msg);
	}
	error("%s", msg);
}

void
parserule(Rule *r)
{
	r-&gt;qarg = estrdup(expand(nil, r-&gt;arg, nil));
	switch(r-&gt;obj){
	case OArg:
	case OAttr:
	case OData:
	case ODst:
	case OType:
	case OWdir:
	case OSrc:
		if(r-&gt;verb==VClient || r-&gt;verb==VStart || r-&gt;verb==VTo)
			parseerror("%s not valid verb for object %s", verbs[r-&gt;verb], objects[r-&gt;obj]);
		if(r-&gt;obj!=OAttr &amp;&amp; (r-&gt;verb==VAdd || r-&gt;verb==VDelete))
			parseerror("%s not valid verb for object %s", verbs[r-&gt;verb], objects[r-&gt;obj]);
		if(r-&gt;verb == VMatches){
			r-&gt;regex = regcomp(r-&gt;qarg);
			return;
		}
		break;
	case OPlumb:
		if(r-&gt;verb!=VClient &amp;&amp; r-&gt;verb!=VStart &amp;&amp; r-&gt;verb!=VTo)
			parseerror("%s not valid verb for object %s", verbs[r-&gt;verb], objects[r-&gt;obj]);
		break;
	}
}

int
assignment(char *p)
{
	char *var, *qval;
	int n;

	if(!isalpha(p[0]))
		return 0;
	for(var=p; isalnum(*p); p++)
		;
	n = p-var;
	while(*p==' ' || *p=='\t')
			p++;
	if(*p++ != '=')
		return 0;
	while(*p==' ' || *p=='\t')
			p++;
	qval = expand(nil, p, nil);
	setvariable(var, n, p, qval);
	return 1;
}

int
include(char *s)
{
	char *t, *args[3], buf[128];
	int n, fd;

	if(strncmp(s, "include", 7) != 0)
		return 0;
	/* either an include or an error */
	n = tokenize(s, args, nelem(args));
	if(n &lt; 2)
		goto Err;
	if(strcmp(args[0], "include") != 0)
		goto Err;
	if(args[1][0] == '#')
		goto Err;
	if(n&gt;2 &amp;&amp; args[2][0] != '#')
		goto Err;
	t = args[1];
	fd = open(t, OREAD);
	if(fd&lt;0 &amp;&amp; t[0]!='/' &amp;&amp; strncmp(t, "./", 2)!=0 &amp;&amp; strncmp(t, "../", 3)!=0){
		snprint(buf, sizeof buf, "/sys/lib/plumb/%s", t);
		t = buf;
		fd = open(t, OREAD);
	}
	if(fd &lt; 0)
		parseerror("can't open %s for inclusion", t);
	pushinput(t, fd, nil);
	return 1;

    Err:
	parseerror("malformed include statement");
	return 0;
}

Rule*
readrule(int *eof)
{
	Rule *rp;
	char *line, *p;
	char *word;

Top:
	line = getline();
	if(line == nil){
		/*
		 * if input is from string, and bytes remain (input-&gt;end is within string),
		 * morerules() will pop input and save remaining data.  otherwise pop
		 * the stack here, and if there's more input, keep reading.
		 */
		if((input!=nil &amp;&amp; input-&gt;end==nil) &amp;&amp; popinput())
			goto Top;
		*eof = 1;
		return nil;
	}
	input-&gt;lineno++;

	for(p=line; *p==' ' || *p=='\t'; p++)
		;
	if(*p=='\0' || *p=='#')	/* empty or comment line */
		return nil;

	if(include(p))
		goto Top;

	if(assignment(p))
		return nil;

	rp = emalloc(sizeof(Rule));

	/* object */
	for(word=p; *p!=' ' &amp;&amp; *p!='\t'; p++)
		if(*p == '\0')
			parseerror("malformed rule");
	*p++ = '\0';
	rp-&gt;obj = lookup(word, objects);
	if(rp-&gt;obj &lt; 0){
		if(strcmp(word, "kind") == 0)	/* backwards compatibility */
			rp-&gt;obj = OType;
		else
			parseerror("unknown object %s", word);
	}

	/* verb */
	while(*p==' ' || *p=='\t')
		p++;
	for(word=p; *p!=' ' &amp;&amp; *p!='\t'; p++)
		if(*p == '\0')
			parseerror("malformed rule");
	*p++ = '\0';
	rp-&gt;verb = lookup(word, verbs);
	if(rp-&gt;verb &lt; 0)
		parseerror("unknown verb %s", word);

	/* argument */
	while(*p==' ' || *p=='\t')
		p++;
	if(*p == '\0')
		parseerror("malformed rule");
	rp-&gt;arg = estrdup(p);

	parserule(rp);

	return rp;
}

void
freerule(Rule *r)
{
	free(r-&gt;arg);
	free(r-&gt;qarg);
	free(r-&gt;regex);
}

void
freerules(Rule **r)
{
	while(*r)
		freerule(*r++);
}

void
freeruleset(Ruleset *rs)
{
	freerules(rs-&gt;pat);
	free(rs-&gt;pat);
	freerules(rs-&gt;act);
	free(rs-&gt;act);
	free(rs-&gt;port);
	free(rs);
}

Ruleset*
readruleset(void)
{
	Ruleset *rs;
	Rule *r;
	int eof, inrule, i, ncmd;

   Again:
	eof = 0;
	rs = emalloc(sizeof(Ruleset));
	rs-&gt;pat = emalloc(sizeof(Rule*));
	rs-&gt;act = emalloc(sizeof(Rule*));
	inrule = 0;
	ncmd = 0;
	for(;;){
		r = readrule(&amp;eof);
		if(eof)
			break;
		if(r==nil){
			if(inrule)
				break;
			continue;
		}
		inrule = 1;
		switch(r-&gt;obj){
		case OArg:
		case OAttr:
		case OData:
		case ODst:
		case OType:
		case OWdir:
		case OSrc:
			rs-&gt;npat++;
			rs-&gt;pat = erealloc(rs-&gt;pat, (rs-&gt;npat+1)*sizeof(Rule*));
			rs-&gt;pat[rs-&gt;npat-1] = r;
			rs-&gt;pat[rs-&gt;npat] = nil;
			break;
		case OPlumb:
			rs-&gt;nact++;
			rs-&gt;act = erealloc(rs-&gt;act, (rs-&gt;nact+1)*sizeof(Rule*));
			rs-&gt;act[rs-&gt;nact-1] = r;
			rs-&gt;act[rs-&gt;nact] = nil;
			if(r-&gt;verb == VTo){
				if(rs-&gt;npat&gt;0 &amp;&amp; rs-&gt;port != nil)	/* npat==0 implies port declaration */
					parseerror("too many ports");
				if(lookup(r-&gt;qarg, badports) &gt;= 0)
					parseerror("illegal port name %s", r-&gt;qarg);
				if(rs-&gt;port)
					free(rs-&gt;port);
				rs-&gt;port = estrdup(r-&gt;qarg);
			}else
				ncmd++;	/* start or client rule */
			break;
		}
	}
	if(ncmd &gt; 1){
		freeruleset(rs);
		parseerror("ruleset has more than one client or start action");
	}
	if(rs-&gt;npat&gt;0 &amp;&amp; rs-&gt;nact&gt;0)
		return rs;
	if(rs-&gt;npat==0 &amp;&amp; rs-&gt;nact==0){
		freeruleset(rs);
		return nil;
	}
	if(rs-&gt;nact==0 || rs-&gt;port==nil){
		freeruleset(rs);
		parseerror("ruleset must have patterns and actions");
		return nil;
	}

	/* declare ports */
	for(i=0; i&lt;rs-&gt;nact; i++)
		if(rs-&gt;act[i]-&gt;verb != VTo){
			freeruleset(rs);
			parseerror("ruleset must have actions");
			return nil;
		}
	for(i=0; i&lt;rs-&gt;nact; i++)
		addport(rs-&gt;act[i]-&gt;qarg);
	freeruleset(rs);
	goto Again;
}

Ruleset**
readrules(char *name, int fd)
{
	Ruleset *rs, **rules;
	int n;

	parsing = 1;
	pushinput(name, fd, nil);
	rules = emalloc(sizeof(Ruleset*));
	for(n=0; (rs=readruleset())!=nil; n++){
		rules = erealloc(rules, (n+2)*sizeof(Ruleset*));
		rules[n] = rs;
		rules[n+1] = nil;
	}
	popinput();
	parsing = 0;
	return rules;
}

char*
concat(char *s, char *t)
{
	if(t == nil)
		return s;
	if(s == nil)
		s = estrdup(t);
	else{
		s = erealloc(s, strlen(s)+strlen(t)+1);
		strcat(s, t);
	}
	return s;
}

char*
printpat(Rule *r)
{
	char *s;

	s = emalloc(strlen(objects[r-&gt;obj])+1+strlen(verbs[r-&gt;verb])+1+strlen(r-&gt;arg)+1+1);
	sprint(s, "%s\t%s\t%s\n", objects[r-&gt;obj], verbs[r-&gt;verb], r-&gt;arg);
	return s;
}

char*
printvar(Var *v)
{
	char *s;

	s = emalloc(strlen(v-&gt;name)+1+strlen(v-&gt;value)+2+1);
	sprint(s, "%s=%s\n\n", v-&gt;name, v-&gt;value);
	return s;
}

char*
printrule(Ruleset *r)
{
	int i;
	char *s;

	s = nil;
	for(i=0; i&lt;r-&gt;npat; i++)
		s = concat(s, printpat(r-&gt;pat[i]));
	for(i=0; i&lt;r-&gt;nact; i++)
		s = concat(s, printpat(r-&gt;act[i]));
	s = concat(s, "\n");
	return s;
}

char*
printport(char *port)
{
	char *s;

	s = nil;
	s = concat(s, "plumb to ");
	s = concat(s, port);
	s = concat(s, "\n");
	return s;
}

char*
printrules(void)
{
	int i;
	char *s;

	s = nil;
	for(i=0; i&lt;nvars; i++)
		s = concat(s, printvar(&amp;vars[i]));
	for(i=0; i&lt;nports; i++)
		s = concat(s, printport(ports[i]));
	s = concat(s, "\n");
	for(i=0; rules[i]; i++)
		s = concat(s, printrule(rules[i]));
	return s;
}

char*
stringof(char *s, int n)
{
	char *t;

	t = emalloc(n+1);
	memmove(t, s, n);
	return t;
}

uchar*
morerules(uchar *text, int done)
{
	int n;
	Ruleset *rs;
	uchar *otext, *s, *endofrule;

	pushinput("&lt;rules input&gt;", -1, text);
	if(done)
		input-&gt;end = text+strlen((char*)text);
	else{
		/*
		 * Help user by sending any full rules to parser so any parse errors will
		 * occur on write rather than close. A heuristic will do: blank line ends rule.
		 */
		endofrule = nil;
		for(s=text; *s!='\0'; s++)
			if(*s=='\n' &amp;&amp; *++s=='\n')
				endofrule = s+1;
		if(endofrule == nil)
			return text;
		input-&gt;end = endofrule;
	}
	for(n=0; rules[n]; n++)
		;
	while((rs=readruleset()) != nil){
		rules = erealloc(rules, (n+2)*sizeof(Ruleset*));
		rules[n++] = rs;
		rules[n] = nil;
	}
	otext =text;
	if(input == nil)
		text = (uchar*)estrdup("");
	else
		text = (uchar*)estrdup((char*)input-&gt;end);
	popinput();
	free(otext);
	return text;
}

char*
writerules(char *s, int n)
{
	static uchar *text;
	char *tmp;

	free(lasterror);
	lasterror = nil;
	parsing = 1;
	if(setjmp(parsejmp) == 0){
		tmp = stringof(s, n);
		text = (uchar*)concat((char*)text, tmp);
		free(tmp);
		text = morerules(text, s==nil);
	}
	if(s == nil){
		free(text);
		text = nil;
	}
	parsing = 0;
	makeports(rules);
	return lasterror;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

