<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/common/misc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/common/misc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * General purpose routines.
 */

#define _BSD_EXTENSION

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;unistd.h&gt;
#include &lt;ctype.h&gt;
#include &lt;sys/types.h&gt;
#include &lt;fcntl.h&gt;

#include "gen.h"
#include "ext.h"
#include "path.h"

int	nolist = 0;			/* number of specified ranges */
int	olist[50];			/* processing range pairs */

int
out_list(str)
    char	*str;
{
    int		start, stop;

/*
 * Grab page ranges from str, save them in olist[], and update the nolist
 * count. Range syntax matches nroff/troff syntax.
 */

    while ( *str &amp;&amp; nolist &lt; sizeof(olist) - 2 ) {
	start = stop = str_convert(&amp;str, 0);

	if ( *str == '-' &amp;&amp; *str++ )
	    stop = str_convert(&amp;str, 9999);

	if ( start &gt; stop )
	    error(FATAL, "illegal range %d-%d", start, stop, 0);

	olist[nolist++] = start;
	olist[nolist++] = stop;

	if ( *str != '\0' ) str++;
    }
    olist[nolist] = 0;
    return 0;
}

in_olist(num)
    int		num;
{
    int		i;

/*
 * Return ON if num is in the current page range list. Print everything if
 * there's no list.
 */
    if ( nolist == 0 )
	return(ON);

    for ( i = 0; i &lt; nolist; i += 2 )
	if ( num &gt;= olist[i] &amp;&amp; num &lt;= olist[i+1] )
	    return(ON);
    return(OFF);
}

int
setencoding(name)
    char	*name;
{
    char	path[150];

/*
 * Include the font encoding file selected by name. It's a full pathname if
 * it begins with /, otherwise append suffix ".enc" and look for the file in
 * ENCODINGDIR. Missing files are silently ignored.
 */

    if ( name == NULL )
	name = "Default";

    if ( *name == '/' )
	strcpy(path, name);
    else sprintf(path, "%s/%s.enc", ENCODINGDIR, name);

    if ( cat(path) == TRUE )
	writing = strncmp(name, "UTF", 3) == 0;
    return 0;
}

cat(file)
    char	*file;
{
    int		fd_in;
    int		fd_out;
    char	buf[512];
    int		count;

/*
 * Copy *file to stdout. Return FALSE is there was a problem.
 */

    fflush(stdout);
    if ( (fd_in = open(file, O_RDONLY)) == -1 )
	return(FALSE);
    fd_out = fileno(stdout);
    while ( (count = read(fd_in, buf, sizeof(buf))) &gt; 0 )
	write(fd_out, buf, count);
    close(fd_in);
    return(TRUE);
}

str_convert(str, err)
    char	**str;
    int		err;
{
    int		i;

/*
 *
 * Grab the next integer from **str and return its value or err if *str
 * isn't an integer. *str is modified after each digit is read.
 *
 */

    if ( ! isdigit(**str) )
	return(err);

    for ( i = 0; isdigit(**str); *str += 1 )
	i = 10 * i + **str - '0';

    return(i);
}

void
error(int kind, char *fmt, ...)
{
	char buf[256];
	va_list arg;

	if (fmt) {
		va_start(arg, fmt);
		vsnprintf(buf, sizeof buf, fmt, arg);
		va_end(arg);
		fprintf(stderr, "%s: %s", prog_name, buf);
		if (lineno &gt; 0)
			fprintf(stderr, " (line %d)", lineno);
		if (position &gt; 0)
			fprintf(stderr, " (near byte %d)", position);
		putc('\n', stderr);
	}
	if (kind == FATAL &amp;&amp; ignore == OFF) {
		if (temp_file != NULL)
			unlink(temp_file);
		exit(x_stat | 01);
	}
}

/*
 * Signal handler for translators.
 */
void
interrupt(int sig)
{
    USED(sig);
    if ( temp_file != NULL )
	unlink(temp_file);
    exit(1);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

