<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/g3p9bit/g3p9bit.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/g3p9bit/g3p9bit.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

enum
{
	ERR,
	EOL,
	MAKE,
	TERM,
};

enum
{
	White,
	Black,
};

typedef struct Tab
{
	ushort	run;
	ushort	bits;
	int		code;
} Tab;

Tab	wtab[8192];
Tab	btab[8192];
uchar	bitrev[256];
uchar	bitnonrev[256];

int	readrow(uchar *rev, int*);
void	initwbtab(void);
void	sync(uchar*);
int	readfile(int, char*, char*);

int		nbytes;
uchar	*bytes;
uchar	*pixels;
uchar	*buf;
int		y;
uint		bitoffset;
uint		word24;

enum
{
	Bytes	= 1024*1024,
	Lines	= 1410,	/* 1100 for A4, 1410 for B4 */
	Dots		= 1728,
};

void
error(char *fmt, ...)
{
	char buf[256];
	va_list arg;

	if(fmt){
		va_start(arg, fmt);
		vseprint(buf, buf+sizeof buf, fmt, arg);
		va_end(arg);
		fprint(2, "g3: %s\n", buf);
	}
	exits(fmt);
}

void
usage(void)
{
	fprint(2, "usage: g3p9bit [-gy] file\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int y, fd, n, m;
	char *t;
	char *file, err[ERRMAX], tbuf[5*12+1];
	int gray=0;
	int yscale=1;

	ARGBEGIN{
	case 'g':
		/* do simulated 2bit gray to compress x */
		gray++;
		break;
	case 'y':
		/* double each scan line to double the y resolution */
		yscale=2;
		break;
	default:
		usage();
	}ARGEND

	if(argc &gt; 1)
		usage();

	initwbtab();
	buf = malloc(1024*1024);
	t = malloc((Dots/8)*Lines);
	if(buf==nil || t==nil)
		error("malloc failed: %r\n");
	pixels = (uchar*)t;

	file = "&lt;stdin&gt;";
	fd = 0;
	if(argc &gt; 0){
		file = argv[0];
		fd = open(file, OREAD);
		if(fd &lt; 0)
			error("can't open %s", file);
	}
	y = readfile(fd, file, err);
	if(y &lt; 0)
		error(err);
	sprint(tbuf, "%11d %11d %11d %11d %11d ", gray, 0, 0, Dots/(gray+1), y*yscale);
	write(1, tbuf, 5*12);
	n = (Dots/8)*y*yscale;
	/* write in pieces; brazil pipes work badly with huge counts */
	while(n &gt; 0){
		if(yscale &gt; 1)	/* write one scan line */
			m = Dots/8;
		else{	/* write lots */
			m = n;
			if(m &gt; 8192)
				m = 8192;
		}
		for(y=0; y&lt;yscale; y++){
			if(write(1, t, m) != m)
				error("write error");
			n -= m;
		}
		t += m;
	}
	if(err[0])
		error(err);
	error(nil);
}

enum{
	Hvres,
	Hbaud,
	Hwidth,
	Hlength,
	Hcomp,
	HenabECM,
	HenabBFT,
	Hmsperscan,
};

int	defhdr[8] = {
	0,		/* 98 lpi */
	0,		/* 2400 baud */
	0,		/* 1728 pixels in 215mm */
	0,		/* A4, 297mm */
	0,		/* 1-D modified huffman */
	0,		/* disable ECM */
	0,		/* disable BFT */
	3,		/* 10 ms per scan */
};

int
crackhdr(uchar *ap, int *hdr)
{
	char *p, *q;
	int i;

	p = (char*)ap;
	q = p;
	for(i=0; i&lt;8; i++){
		if(*p&lt;'0' || '9'&lt;*p)
			return -1;
		hdr[i] = strtol(p, &amp;q, 0);
		p = q+1;
	}
	return p-(char*)ap;
}

int
readfile(int f, char *file, char *err)
{
	int i, r, lines;
	uchar *rev;
	int hdr[8];

	err[0] = 0;
	memset(pixels, 0, (Dots/8) * Lines);
	nbytes = readn(f, buf, 1024*1024);
	if(nbytes==1024*1024 || nbytes&lt;=100){
    bad:
		sprint(err, "g3: file improper size or format: %s", file);
		return -1;
	}
	bytes = buf;
	if(bytes[0]=='I' &amp;&amp; bytes[1]=='I' &amp;&amp; bytes[2]=='*'){	/* dumb PC format */
		bytes += 0xf3;
		nbytes -= 0xf3;
		rev = bitrev;
		memmove(hdr, defhdr, sizeof defhdr);
	}else if(bytes[0] == 0 &amp;&amp; strcmp((char*)bytes+1, "PC Research, Inc") == 0){	/* digifax format */
		memmove(hdr, defhdr, sizeof defhdr);
		if(bytes[45] == 0x40 &amp;&amp; bytes[29] == 1)	/* high resolution */
			hdr[Hvres] = 1;
		else
			hdr[Hvres] = 0;
		/* hdr[26] | (hdr[27]&lt;&lt;8) is page number */

		bytes += 64;
		nbytes -= 64;
		rev = bitnonrev;
	}else{
		while(nbytes &gt; 2){
			if(bytes[0]=='\n'){
				if(strncmp((char*)bytes+1, "FDCS=", 5) == 0){
					i = crackhdr(bytes+6, hdr);
					if(i &lt; 0){
						sprint(err, "g3: bad FDCS in header: %s", file);
						return -1;
					}
					if(hdr[Hwidth] != 0){
						sprint(err, "g3: unsupported width: %s", file);
						return -1;
					}
					if(hdr[Hcomp] != 0){
						sprint(err, "g3: unsupported compression: %s", file);
						return -1;
					}
					bytes += i+1;
					nbytes -= i+1;
					continue;
				}
				if(bytes[1] == '\n'){
					bytes += 2;
					nbytes -= 2;
					break;
				}
			}
			bytes++;
			nbytes--;
		}
		if(nbytes &lt; 2)
			goto bad;
		rev = bitnonrev;
	}
	bitoffset = 24;
	word24 = 0;
	sync(rev);
	lines = Lines;
	if(hdr[Hvres] == 1)
		lines *= 2;
	for(y=0; y&lt;lines; y++){
		r = readrow(rev, hdr);
		if(r &lt; 0)
			break;
		if(r == 0)
			sync(rev);
	}
	if(hdr[Hvres] == 1)
		y /= 2;
//	if(y &lt; 100)
//		goto bad;
	return y;
}

int
readrow(uchar *rev, int *hdr)
{
	int bo, state;
	Tab *tab, *t;
	int x, oldx, x2, oldx2, dx, xx;
	uint w24;
	uchar *p, *q;

	state = White;
	oldx = 0;
	bo = bitoffset;
	w24 = word24;
	x = y;
	if(hdr[Hvres] == 1)	/* high resolution */
		x /= 2;
	p = pixels + x*Dots/8;
	x = 0;

loop:
	if(x &gt; Dots)
		return 0;
	if(state == White)
		tab = wtab;
	else
		tab = btab;
	if(bo &gt; (24-13)) {
		do {
			if(nbytes &lt;= 0)
				return -1;
			w24 = (w24&lt;&lt;8) | rev[*bytes];
			bo -= 8;
			bytes++;
			nbytes--;
		} while(bo &gt;= 8);
	}

	t = tab + ((w24 &gt;&gt; (24-13-bo)) &amp; 8191);
	x += t-&gt;run;
	bo += t-&gt;bits;
	if(t-&gt;code == TERM){
		if(state == White)
			oldx = x;
		else{
			oldx2 = oldx;
			x2 = x;
			xx = oldx2&amp;7;
			q = p+oldx2/8;
			if(x2/8 == oldx2/8)	/* all in one byte, but if((x2&amp;7)==0), do harder case */
				*q |= (0xFF&gt;&gt;xx) &amp; (0xFF&lt;&lt;(8-(x2&amp;7)));
			else{
				dx = x2 - oldx2;
				/* leading edge */
				if(xx){
					*q++ |= 0xFF&gt;&gt;xx;
					dx -= 8-xx;
				}
				/* middle */
				while(dx &gt;= 8){
					*q++ = 0xFF;
					dx -= 8;
				}
				/* trailing edge */
				if(dx)
					*q |= 0xFF&lt;&lt;(8-dx);
			}
		}
		state ^= White^Black;
		goto loop;
	}
	if(t-&gt;code == ERR){
		bitoffset = bo;
		word24 = w24;
		return 0;
	}
	if(t-&gt;code == EOL){
		bitoffset = bo;
		word24 = w24;
		return 1;
	}
	goto loop;
}


void
sync(uchar *rev)
{
	Tab *t;
	int c;

	c = 0;
loop:
	if(bitoffset &gt; (24-13)) {
		do {
			if(nbytes &lt;= 0)
				return;
			word24 = (word24&lt;&lt;8) | rev[*bytes];
			bitoffset -= 8;
			bytes++;
			nbytes--;
		} while(bitoffset &gt;= 8);
	}
	t = wtab + ((word24 &gt;&gt; (24-13-bitoffset)) &amp; 8191);
	if(t-&gt;code != EOL) {
		bitoffset++;
		c++;
		goto loop;
	}
	bitoffset += t-&gt;bits;
}

typedef struct File
{
	char	*val;
	int	code;
}File;

File ibtab[] = {
#include "btab"
{nil, 0}
};

File iwtab[] = {
#include "wtab"
{nil, 0}
};

int
binary(char *s)
{
	int n;

	n = 0;
	while(*s)
		n = n*2 + *s++-'0';
	return n;
}

void
tabinit(File *file, Tab *tab)
{
	int i, j, v, r, l;
	char *b;

	for(v=0; v&lt;8192; v++) {
		tab[v].run = 0;
		tab[v].bits = 1;
		tab[v].code = ERR;
	}
	for(i=0; b=file[i].val; i++){
		l = strlen(b);
		v = binary(b);
		r = file[i].code;
		if(l &gt; 13)
			fprint(2, "g3: oops1 l = %d %s\n", l, b);

		v = v&lt;&lt;(13-l);
		for(j=0; j&lt;(1&lt;&lt;((13-l))); j++) {
			if(tab[v].code != ERR)
				fprint(2, "g3: oops2 %d %s\n", r, b);
			tab[v].run = r;
			tab[v].bits = l;
			tab[v].code = TERM;
			if(r &lt; 0) {
				tab[v].run = 0;
				tab[v].code = EOL;
				if(r &lt; -1) {
					tab[v].bits = 1;
					tab[v].code = MAKE;
				}
			}
			if(r &gt;= 64) {
				tab[v].code = MAKE;
			}
			v++;
		}
	}

	for(i=0; i&lt;256; i++)
		for(j=0; j&lt;8; j++)
			if(i &amp; (1&lt;&lt;j))
				bitrev[i] |= 0x80 &gt;&gt; j;
	for(i=0; i&lt;256; i++)
		bitnonrev[i] = i;
}

void
initwbtab(void)
{
	tabinit(iwtab, wtab);
	tabinit(ibtab, btab);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

