<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/postgif/postgif.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/postgif/postgif.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->

#include &lt;stdio.h&gt;
#include &lt;string.h&gt;
#include &lt;signal.h&gt;
#include &lt;ctype.h&gt;
#ifdef plan9
#define	isascii(c)	((unsigned char)(c)&lt;=0177)
#endif
#include &lt;sys/types.h&gt;
#include &lt;fcntl.h&gt;

#include "comments.h"
#include "gen.h"
#include "path.h"
#include "ext.h"

#define dbprt	if (debug) fprintf

char	*optnames = "a:c:fglm:n:o:p:x:y:C:E:DG:IL:P:";
char    *prologue = POSTGIF;		/* default PostScript prologue */
char    *formfile = FORMFILE;           /* stuff for multiple pages per sheet */
int     formsperpage = 1;               /* page images on each piece of paper */
int	copies = 1;                     /* and this many copies of each sheet */
int     page = 0;                       /* last page we worked on */
int     printed = 0;                    /* and the number of pages printed */

extern char *malloc();
extern void free();
extern double atof(), pow();

unsigned char ibuf[BUFSIZ];
unsigned char *cmap, *gcmap, *lcmap;
unsigned char *gmap, *ggmap, *lgmap;
unsigned char *pmap;
double gamma;
float cr = 0.3, cg = 0.59, cb = 0.11;
int maplength, gmaplength, lmaplength;
int scrwidth, scrheight;
int gcolormap, lcolormap;
int bitperpixel, background;
int imageleft, imagetop;
int imagewidth, imageheight;
int interlaced, lbitperpixel;
int gray = 0;
int gammaflag = 0;
int negative = 0;
int terminate = 0;
int codesize, clearcode, endcode, curstblsize, pmindex, byteinibuf, bitsleft;
int prefix[4096], suffix[4096], cstbl[4096];
int bburx = -32767, bbury = -32767;
FILE *fp_in = NULL;
FILE *fp_out = stdout;

char *
allocate(size)
    int size;
{
    char *p;

    if ((p = malloc(size)) == NULL) error(FATAL, "not enough memory");
    return(p);
}

void
puthex(c, fp)
    unsigned char c;
    FILE *fp;
{
    static char hextbl[16] = {
	'0', '1', '2', '3', '4', '5', '6', '7',
	'8', '9', 'a', 'b', 'c', 'd', 'e', 'f',
    };

    putc(hextbl[(c &gt;&gt; 4) &amp; 017], fp);
    putc(hextbl[c &amp; 017], fp);
}

void
setcolormap(bp)
    int bp;
{
    int i, entries = 1, scale = 1;
    unsigned char *p, *q;

    for (i = 0; i &lt; bp; i++) entries *= 2;
    for (i = 0; i &lt; 8 - bp; i++) scale *= 2;
    gcmap = (unsigned char *) allocate(entries*3);
    ggmap = (unsigned char *) allocate(entries);
    gmaplength = entries;
    for (i = 0, p = gcmap, q = ggmap; i &lt; 256; i += scale, p += 3, q++) {
	if (negative) {
	    *p = 255 - i; p[1] = *p; p[2] = *p;
	    *q = *p;
	}
	else {
	    *p = i; p[1] = i; p[2] = i;
	    *q = i;
	}
    }
    if (gammaflag)
    	for (i = 0, p = gcmap; i &lt; 256; i += scale, p += 3) {
	    *p = (unsigned char) (pow((double) *p/256.0, gamma)*256);
	    p[1] = *p; p[2] = *p;
	}
dbprt(stderr,"default color map:\n");
for (i = 0; i &lt; entries*3; i += 3)
dbprt(stderr, "%d, %d, %d\n", gcmap[i], gcmap[i+1], gcmap[i+2]);
}

void
readgcolormap(bp)
    int bp;
{
    int i, entries = 1;
    unsigned char *p, *q;

    for (i = 0; i &lt; bp; i++) entries *= 2;
    gcmap = (unsigned char *) allocate(entries*3);
    ggmap = (unsigned char *) allocate(entries);
    gmaplength = entries;
    fread(gcmap, sizeof(*gcmap), entries*3, fp_in);
    if (negative)
	for (i = 0, p = gcmap; i &lt; entries*3; i++, p++) *p = 255 - *p;
    for (i = 0, p = gcmap, q = ggmap; i &lt; entries; i++, p += 3, q++)
	*q = cr*(int)p[0] + cg*(int)p[1] + cb*(int)p[2] + 0.5;
    if (gammaflag)
    	for (i = 0, p = gcmap; i &lt; entries*3; i++, p++)
	    *p = (unsigned char) (pow((double) *p/256.0, gamma)*256);
dbprt(stderr,"global color map:\n");
for (i = 0; i &lt; entries*3; i += 3)
dbprt(stderr, "%d, %d, %d\n", gcmap[i], gcmap[i+1], gcmap[i+2]);
}

void
readlcolormap(bp)
    int bp;
{
    int i, entries = 1;
    unsigned char *p, *q;

    for (i = 0; i &lt; bp; i++) entries *= 2;
    lcmap = (unsigned char *) allocate(entries*3);
    lgmap = (unsigned char *) allocate(entries);
    lmaplength = entries;
    fread(lcmap, sizeof(*lcmap), entries*3, fp_in);
    if (negative)
	for (i = 0, p = lcmap; i &lt; entries*3; i++, p++) *p = 255 - *p;
    for (i = 0, p = lcmap, q = lgmap; i &lt; entries; i++, p += 3, q++)
	*q = cr*(int)p[0] + cg*(int)p[1] + cb*(int)p[2] + 0.5;
    if (gammaflag)
    	for (i = 0, p = lcmap; i &lt; entries*3; i++, p++)
	    *p = (unsigned char) (pow((double) *p/256.0, gamma)*256);
dbprt(stderr,"local color map:\n");
for (i = 0; i &lt; entries*3; i += 3)
dbprt(stderr, "%d, %d, %d\n", lcmap[i], lcmap[i+1], lcmap[i+2]);
}

void
initstbl()
{
    int i, entries = 1, *p, *s;

    for (i = 0; i &lt; codesize; i++) entries *= 2;
    clearcode = entries;
    endcode = clearcode + 1;
    for (i = 0, p = prefix, s = suffix; i &lt;= endcode; i++, p++, s++) {
	*p = endcode;
	*s = i;
    }
    curstblsize = endcode + 1;
    pmindex = 0;
    byteinibuf = 0;
    bitsleft = 0;
}

int
nextbyte()
{
    static ibufindex;

    if (byteinibuf) {
	byteinibuf--;
	ibufindex++;
    }
    else {
    	fread(ibuf, sizeof(*ibuf), 1, fp_in);
    	byteinibuf = ibuf[0];
dbprt(stderr, "byte count: %d\n", byteinibuf);
	if (byteinibuf) fread(ibuf, sizeof(*ibuf), byteinibuf, fp_in);
	else error(FATAL, "encounter zero byte count block before end code");
	ibufindex = 0;
	byteinibuf--;
	ibufindex++;
    }
    return(ibuf[ibufindex-1]);
}

int masktbl[25] = {
    0, 01, 03, 07, 017, 037, 077, 0177, 0377, 0777, 01777, 03777, 07777,
    017777, 037777, 077777, 0177777, 0377777, 0777777, 01777777, 03777777,
    07777777, 017777777, 037777777, 077777777
};

int
getcode()
{
    int cs, c;
    static int oldc;

    if (curstblsize &lt; 4096) cs = cstbl[curstblsize];
    else cs = 12;
    while (bitsleft &lt; cs) {
	oldc = (oldc &amp; masktbl[bitsleft]) | ((nextbyte() &amp; 0377) &lt;&lt; bitsleft);
	bitsleft += 8;
    }
    c = oldc &amp; masktbl[cs];
    oldc = oldc &gt;&gt; cs;
    bitsleft -= cs;
/* dbprt(stderr, "code: %d %d %d\n", curstblsize, cs, c); */
    return(c);
}

void
putcode(c)
    int c;
{
    if (prefix[c] != endcode) {
	putcode(prefix[c]);
	pmap[pmindex] = suffix[c];
	pmindex++;
    }
    else {
   	pmap[pmindex] = suffix[c];
	pmindex++;
    }
}

int
firstof(c)
    int c;
{
    while (prefix[c] != endcode) c = prefix[c];
    return(suffix[c]);
}

void
writeimage()
{
    int i, j, k;

dbprt(stderr, "pmindex: %d\n", pmindex);
    fputs("save\n", fp_out);
    fprintf(fp_out, "/codestr %d string def\n", imagewidth);
    if (!gray) {
    	fprintf(fp_out, "/colortbl currentfile %d string readhexstring\n",
	    maplength*3);
        for (i = 0; i &lt; maplength; i++) puthex(cmap[i], fp_out);
        fputs("\n", fp_out);
        for (i = maplength ; i &lt; maplength*2; i++) puthex(cmap[i], fp_out);
        fputs("\n", fp_out);
        for (i = maplength*2 ; i &lt; maplength*3; i++) puthex(cmap[i], fp_out);
        fputs("\npop def\n", fp_out);
    	fprintf(fp_out, "/graytbl currentfile %d string readhexstring\n",
	    maplength);
        for (i = 0; i &lt; maplength; i++) puthex(gmap[i], fp_out);
        fputs("\npop def\n", fp_out);
    }
    fprintf(fp_out, "%s %d %d %d %d gifimage\n",
	gray ? "true" : "false", imagewidth, imageheight,
	scrwidth - imageleft - imagewidth, scrheight - imagetop - imageheight);
    if (gray) {
	if (interlaced) {
	    int *iltbl;

	    iltbl = (int *) allocate(imageheight*sizeof(int));
	    j = 0;
	    for (i = 0; i &lt; imageheight; i += 8) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass1: %d\n", j);
	    for (i = 4; i &lt; imageheight; i += 8) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass2: %d\n", j);
	    for (i = 2; i &lt; imageheight; i += 4) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass3: %d\n", j);
	    for (i = 1; i &lt; imageheight; i += 2) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass4: %d\n", j);

    	    for (i = 0; i &lt; imageheight; i++) {
		k = iltbl[i];
	        for (j = 0; j &lt; imagewidth; j++, k++)
		    puthex(gmap[pmap[k]], fp_out);
	        fputs("\n", fp_out);
	    }
	}
	else {
    	    for (i = 0, k = 0; i &lt; imageheight; i++) {
	        for (j = 0; j &lt; imagewidth; j++, k++)
		    puthex(gmap[pmap[k]], fp_out);
	        fputs("\n", fp_out);
	    }
    	}
    }
    else {
	if (interlaced) {
	    int *iltbl;

	    iltbl = (int *) allocate(imageheight*sizeof(int));
	    j = 0;
	    for (i = 0; i &lt; imageheight; i += 8) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass1: %d\n", j);
	    for (i = 4; i &lt; imageheight; i += 8) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass2: %d\n", j);
	    for (i = 2; i &lt; imageheight; i += 4) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass3: %d\n", j);
	    for (i = 1; i &lt; imageheight; i += 2) {
		iltbl[i] = j;
		j += imagewidth;
	    }
dbprt(stderr, "pass4: %d\n", j);

    	    for (i = 0; i &lt; imageheight; i++) {
		k = iltbl[i];
	        for (j = 0; j &lt; imagewidth; j++, k++) puthex(pmap[k], fp_out);
	        fputs("\n", fp_out);
    	    }
	}
	else {
    	    for (i = 0, k = 0; i &lt; imageheight; i++) {
	        for (j = 0; j &lt; imagewidth; j++, k++) puthex(pmap[k], fp_out);
	        fputs("\n", fp_out);
    	    }
	}
    }
    fputs("restore\n", fp_out);
}

void
readimage()
{
    int bytecount, zerobytecount = 0;
    int code, oldcode;

    fread(ibuf, sizeof(*ibuf), 9, fp_in);
    imageleft = ibuf[0] + 256*ibuf[1];
    imagetop = ibuf[2] + 256*ibuf[3];
    imagewidth = ibuf[4] + 256*ibuf[5];
    imageheight = ibuf[6] + 256*ibuf[7];
    lcolormap = ibuf[8] &amp; 0200;
    interlaced = ibuf[8] &amp; 0100;
    lbitperpixel = (ibuf[8] &amp; 07) + 1;
dbprt(stderr, "imageleft: %d\n", imageleft);
dbprt(stderr, "imagetop: %d\n", imagetop);
dbprt(stderr, "imagewidth: %d\n", imagewidth);
dbprt(stderr, "imgaeheight: %d\n", imageheight);
dbprt(stderr, "lcolormap: %d\n", lcolormap ? 1 : 0);
dbprt(stderr, "interlaced: %d\n", interlaced ? 1 : 0);
dbprt(stderr, "lbitperpixel: %d\n", lbitperpixel);
    if (lcolormap) {
	readlcolormap(lbitperpixel);
	cmap = lcmap;
	gmap = lgmap;
	maplength = lmaplength;
    }

dbprt(stderr, "start reading raster data\n");
    fread(ibuf, sizeof(*ibuf), 1, fp_in);
    codesize = ibuf[0];
dbprt(stderr, "codesize: %d\n", codesize);
    pmap = (unsigned char *) allocate(imagewidth*imageheight);
    initstbl();
    while ((code = getcode()) != endcode) {
	if (code == clearcode) {
	    curstblsize = endcode + 1;
    	    code = getcode();
    	    putcode(code);
    	    oldcode = code;
	}
	else if (code &lt; curstblsize) {
	    putcode(code);
	    prefix[curstblsize] = oldcode;
	    suffix[curstblsize] = firstof(code);
	    curstblsize++;
	    oldcode = code;
	}
	else {
	   if (code != curstblsize) error(FATAL, "code out of order");
	   prefix[curstblsize] = oldcode;
	   suffix[curstblsize] = firstof(oldcode);
	   curstblsize++;
	   putcode(curstblsize-1);
	   oldcode = code;
	}
    }
dbprt(stderr, "finish reading raster data\n");

    /* read the rest of the raster data */
    do {
    	fread(ibuf, sizeof(*ibuf), 1, fp_in);
    	bytecount = ibuf[0];
dbprt(stderr, "byte count: %d\n", bytecount);
	if (bytecount) fread(ibuf, sizeof(*ibuf), bytecount, fp_in);
	else zerobytecount = 1;
    } while (!zerobytecount);

    writeimage();

    if (lcolormap) {
	cmap = gcmap;
	gmap = ggmap;
	maplength = gmaplength;
	free(lcmap);
	free(lgmap);
    }
}

void
readextensionblock()
{
    int functioncode, bytecount, zerobytecount = 0;

    fread(ibuf, sizeof(*ibuf), 1, fp_in);
    functioncode = ibuf[0];
dbprt(stderr, "function code: %d\n", functioncode);
    do {
    	fread(ibuf, sizeof(*ibuf), 1, fp_in);
    	bytecount = ibuf[0];
dbprt(stderr, "byte count: %d\n", bytecount);
	if (bytecount) fread(ibuf, sizeof(*ibuf), bytecount, fp_in);
	else zerobytecount = 1;
    } while (!zerobytecount);
}

void
writebgscr()
{
    fprintf(fp_out, "%s %d %d\n", PAGE, page, printed+1);
    fputs("/saveobj save def\n", fp_out);
    fprintf(fp_out, "%s: %d %d %d %d\n",
	"%%PageBoundingBox", 0, 0, scrwidth, scrheight);
    if (scrwidth &gt; bburx) bburx = scrwidth;
    if (scrheight &gt; bbury) bbury = scrheight;
    fprintf(fp_out, "%d %d gifscreen\n", scrwidth, scrheight);
}

void
writeendscr()
{
    if ( fp_out == stdout ) printed++;
    fputs("showpage\n", fp_out);
    fputs("saveobj restore\n", fp_out);
    fprintf(fp_out, "%s %d %d\n", ENDPAGE, page, printed);
}

void
redirect(pg)
    int		pg;			/* next page we're printing */
{
    static FILE	*fp_null = NULL;	/* if output is turned off */

    if ( pg &gt;= 0 &amp;&amp; in_olist(pg) == ON )
	fp_out = stdout;
    else if ( (fp_out = fp_null) == NULL )
	fp_out = fp_null = fopen("/dev/null", "w");

}

void
readgif()
{
    int i, j, k;

    for (i = 0, j = 1, k = 0; i &lt; 13; i++) {
	for (; k &lt; j; k++) cstbl[k] = i;
	j *= 2;
    }

    fread(ibuf, sizeof(*ibuf), 6, fp_in);
dbprt(stderr, "%.6s\n", ibuf);
    if (strncmp((char *)ibuf, "GIF87a", 6) != 0) {
    	fread(ibuf, sizeof(*ibuf), 122, fp_in);
    	fread(ibuf, sizeof(*ibuf), 6, fp_in);
dbprt(stderr, "%.6s\n", ibuf);
    	if (strncmp((char *)ibuf, "GIF87a", 6) != 0)
		 error(FATAL, "wrong GIF signature");
    }
    fread(ibuf, sizeof(*ibuf), 7, fp_in);
    scrwidth = ibuf[0] + 256*ibuf[1];
    scrheight = ibuf[2] + 256*ibuf[3];
    gcolormap = ibuf[4] &amp; 0200;
    bitperpixel = (ibuf[4] &amp; 07) + 1;
    background = ibuf[5];
dbprt(stderr, "scrwidth: %d\n", scrwidth);
dbprt(stderr, "scrheight: %d\n", scrheight);
dbprt(stderr, "gcolormap: %d\n", gcolormap ? 1 : 0);
dbprt(stderr, "bitperpixel: %d\n", bitperpixel);
dbprt(stderr, "background: %d\n", background);
    if (ibuf[6] != 0) error(FATAL, "wrong screen descriptor");
    if (gcolormap) readgcolormap(bitperpixel);
    else setcolormap(bitperpixel);

    redirect(++page);
    writebgscr();

    cmap = gcmap;
    gmap = ggmap;
    maplength = gmaplength;

    do {
	fread(ibuf, sizeof(*ibuf), 1, fp_in);
	if (ibuf[0] == ',') readimage();
	else if (ibuf[0] == ';') terminate = 1;
	else if (ibuf[0] == '!') readextensionblock();
	else
	error(FATAL, "wrong image separator character or wrong GIF terminator");
    } while (!terminate);

    writeendscr();

    free(gcmap);
    free(ggmap);
}

void
init_signals()
{

    if ( signal(SIGINT, interrupt) == SIG_IGN )  {
        signal(SIGINT, SIG_IGN);
        signal(SIGQUIT, SIG_IGN);
        signal(SIGHUP, SIG_IGN);
    }
    else {
        signal(SIGHUP, interrupt);
        signal(SIGQUIT, interrupt);
    }

    signal(SIGTERM, interrupt);
}

void
header()
{
    int         ch;                     /* return value from getopt() */
    int         old_optind = optind;    /* for restoring optind - should be 1 */

    while ( (ch = getopt(argc, argv, optnames)) != EOF )
        if ( ch == 'L' )
            prologue = optarg;
        else if ( ch == '?' )
            error(FATAL, "");

    optind = old_optind;                /* get ready for option scanning */

    fprintf(stdout, "%s", CONFORMING);
    fprintf(stdout, "%s %s\n", VERSION, PROGRAMVERSION);
    fprintf(stdout, "%s %s\n", BOUNDINGBOX, ATEND);
    fprintf(stdout, "%s %s\n", PAGES, ATEND);
    fprintf(stdout, "%s", ENDCOMMENTS);

    if ( cat(prologue) == FALSE )
        error(FATAL, "can't read %s", prologue);

    fprintf(stdout, "%s", ENDPROLOG);
    fprintf(stdout, "%s", BEGINSETUP);
    fprintf(stdout, "mark\n");

}

void
options()
{
    int		ch;			/* return value from getopt() */

    while ( (ch = getopt(argc, argv, optnames)) != EOF )  {
	switch ( ch )  {

	    case 'a':			/* aspect ratio */
		    fprintf(stdout, "/aspectratio %s def\n", optarg);
		    break;

	    case 'c':			/* copies */
		    copies = atoi(optarg);
		    fprintf(stdout, "/#copies %s store\n", optarg);
		    break;

	    case 'f':
		    negative = TRUE;
		    break;

	    case 'g':
		    gray = TRUE;
		    break;

	    case 'l':
		    fprintf(stdout, "/alignment true def\n");
		    break;

	    case 'm':			/* magnification */
		    fprintf(stdout, "/magnification %s def\n", optarg);
		    break;

	    case 'n':			/* forms per page */
		    formsperpage = atoi(optarg);
		    fprintf(stdout, "%s %s\n", FORMSPERPAGE, optarg);
		    fprintf(stdout, "/formsperpage %s def\n", optarg);
		    break;

	    case 'o':			/* output page list */
		    out_list(optarg);
		    break;

	    case 'p':			/* landscape or portrait mode */
		    if ( *optarg == 'l' )
			fprintf(stdout, "/landscape true def\n");
		    else fprintf(stdout, "/landscape false def\n");
		    break;

	    case 'x':			/* shift things horizontally */
		    fprintf(stdout, "/xoffset %s def\n", optarg);
		    break;

	    case 'y':			/* and vertically on the page */
		    fprintf(stdout, "/yoffset %s def\n", optarg);
		    break;

	    case 'C':			/* copy file straight to output */
		    if ( cat(optarg) == FALSE )
			error(FATAL, "can't read %s", optarg);
		    break;

	    case 'E':			/* text font encoding - unnecessary */
		    fontencoding = optarg;
		    break;

	    case 'D':			/* debug flag */
		    debug = ON;
		    break;

	    case 'G':
		    gammaflag = ON;
		    gamma = atof(optarg);
		    break;

	    case 'I':			/* ignore FATAL errors */
		    ignore = ON;
		    break;

	    case 'L':			/* PostScript prologue file */
		    prologue = optarg;
		    break;

	    case 'P':			/* PostScript pass through */
		    fprintf(stdout, "%s\n", optarg);
		    break;

	    case '?':			/* don't understand the option */
		    error(FATAL, "");
		    break;

	    default:			/* don't know what to do for ch */
		    error(FATAL, "missing case for option %c\n", ch);
		    break;

	}
    }

    argc -= optind;			/* get ready for non-option args */
    argv += optind;
}

void
setup()
{
    /*setencoding(fontencoding);*/
    fprintf(stdout, "setup\n");

    if ( formsperpage &gt; 1 )  {          /* followed by stuff for multiple pages
*/
        if ( cat(formfile) == FALSE )
            error(FATAL, "can't read %s", formfile);
        fprintf(stdout, "%d setupforms\n", formsperpage);
    }   /* End if */

    fprintf(stdout, "%s", ENDSETUP);

}

void
arguments()
{
    if ( argc &lt; 1 ) {
	fp_in = stdin;
	readgif();
    }
    else  {				/* at least one argument is left */
	while ( argc &gt; 0 )  {
	    if ( strcmp(*argv, "-") == 0 )
		fp_in = stdin;
	    else if ( (fp_in = fopen(*argv, "r")) == NULL )
		error(FATAL, "can't open %s", *argv);
	    readgif();
	    if ( fp_in != stdin )
		fclose(fp_in);
	    argc--;
	    argv++;
	}
    }
}

void
done()
{
    fprintf(stdout, "%s", TRAILER);
    fprintf(stdout, "done\n");
    fprintf(stdout, "%s 0 0 %d %d\n", BOUNDINGBOX, bburx, bbury);
    fprintf(stdout, "%s %d\n", PAGES, printed); 
}

main(agc, agv)
    int agc;
    char *agv[];
{
    argc = agc;
    argv = agv;
    prog_name = argv[0];

    init_signals();
    header();
    options();
    setup();
    arguments();
    done();

    exit(0);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

