<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/tr2post/Bgetfield.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/tr2post/Bgetfield.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "../common/common.h"
#include "tr2post.h"

int
isspace(Rune r)
{
 	return r==' ' || r=='\t' || r=='\n' || r=='\r' || r=='\f';
}

int
Bskipws(Biobufhdr *bp) {
	int r, sindex = 0;

	/* skip over initial white space */
	do {
		r = Bgetrune(bp);
		if (r == '\n')
			inputlineno++;
		sindex++;
	} while (r&gt;=0 &amp;&amp; isspace(r));
	if (r&lt;0)
		return(-1);
	else if (!isspace(r)) {
		Bungetrune(bp);
		--sindex;
	}
	return sindex;
}

int
asc2dig(char c, int base) {
	if (c &gt;= '0' &amp;&amp; c &lt;= '9')
		if (base == 8 &amp;&amp; c &gt; '7')
			return(-1);
		else
			return(c - '0');
	if (base == 16)
		if (c &gt;= 'a' &amp;&amp; c &lt;= 'f')
			return(10 + c - 'a');
		else if (c &gt;= 'A' &amp;&amp; c &lt;= 'F')
			return(10 + c - 'A');
	return(-1);
}

/*
 * get a string of type: "d" for decimal integer, "u" for unsigned,
 * "s" for string", "c" for char,
 * return the number of characters gotten for the field.  If nothing
 * was gotten and the end of file was reached, a negative value
 * from the Bgetrune is returned.
 */

int
Bgetfield(Biobufhdr *bp, int type, void *thing, int size) {
	int base = 10;
	int dig;
	int negate = 0;
	int sindex = 0, i, j, n = 0;
	long r;
	Rune R;
	unsigned u = 0;
	BOOLEAN bailout = FALSE;
	char c[UTFmax];

	/* skip over initial white space */
	if (Bskipws(bp) &lt; 0)
		return(-1);

	r = 0;
	switch (type) {
	case 'd':
		while (!bailout &amp;&amp; (r = Bgetrune(bp))&gt;=0) {
			switch (sindex++) {
			case 0:
				switch (r) {
				case '-':
					negate = 1;
					continue;
				case '+':
					continue;
				case '0':
					base = 8;
					continue;
				default:
					break;
				}
				break;
			case 1:
				if ((r == 'x' || r == 'X') &amp;&amp; base == 8) {
					base = 16;
					continue;
				}
				break;
			}
			if ((dig = asc2dig(r, base)) == -1)
				bailout = TRUE;
			else
				n = dig + (n * base);
		}
		if (r &lt; 0)
			return(-1);
		*(int *)thing = (negate)?-n:n;
		Bungetrune(bp);
		break;
	case 'u':
		while (!bailout &amp;&amp; (r = Bgetrune(bp))&gt;=0) {
			switch (sindex++) {
			case 0:
				if (*c == '0') {
					base = 8;
					continue;
				}
				break;
			case 1:
				if ((r == 'x' || r == 'X') &amp;&amp; base == 8) {
					base = 16;
					continue;
				}
				break;
			}
			if ((dig = asc2dig(r, base)) == -1)
				bailout = TRUE;
			else
				u = dig + (n * base);
		}
		*(int *)thing = u;
		if (r &lt; 0)
			return(-1);
		Bungetrune(bp);
		break;
	case 's':
		j = 0;
		while (size &gt; j+UTFmax &amp;&amp; (r = Bgetrune(bp)) &gt;= 0 &amp;&amp;
		    !isspace(r)) {
			R = r;
			i = runetochar(&amp;(((char *)thing)[j]), &amp;R);
			j += i;
			sindex++;
		}
		((char *)thing)[j] = '\0';
		if (r &lt; 0)
			return(-1);
		Bungetrune(bp);
		break;
	case 'r':
		if ((r = Bgetrune(bp))&gt;=0) {
			*(Rune *)thing = r;
			sindex++;
			return(sindex);
		}
		if (r &lt;= 0)
			return(-1);
		Bungetrune(bp);
		break;
	default:
		return(-2);
	}
	if (r &lt; 0 &amp;&amp; sindex == 0)
		return(r);
	else if (bailout &amp;&amp; sindex == 1) {
		return(0);
	} else
		return(sindex);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

