<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/tr2post/chartab.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/tr2post/chartab.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*    Unicode   |     PostScript
 *  start  end  | offset  font name
 * 0x0000 0x00ff  0x00   LucidaSansUnicode00
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "common.h"
#include "tr2post.h"
#include "comments.h"
#include "path.h"

/* Postscript font names, e.g., `LucidaSansUnicode00'
 * names may only be added because reference to the
 * names is made by indexing into this table.
 */
static struct pfnament *pfnafontmtab = 0;
static int pfnamcnt = 0;
int curpostfontid = -1;
int curfontsize = -1;
int curtrofffontid = -1;
static int curfontpos = -1;
static int fontheight = 0;
static int fontslant = 0;

/* This is troffs mounted font table.  It is an anachronism resulting
 * from the design of the APS typesetter.  fontmnt is the
 * number of positions available.  fontmnt is really 11, but
 * should not be limited.
 */
int fontmnt = 0;
char **fontmtab;

struct troffont *troffontab = 0;

int troffontcnt = 0;

void
mountfont(int pos, char *fontname) {
	int i;

	if (debug) fprint(2, "mountfont(%d, %s)\n", pos, fontname);
	if (pos &lt; 0 || pos &gt;= fontmnt)
		error(FATAL, "cannot mount a font at position %d,\n  can only mount into postions 0-%d\n",
			pos, fontmnt-1);

	i = strlen(fontname);
	fontmtab[pos] = galloc(fontmtab[pos], i+1, "mountfont():fontmtab");
	strcpy(fontmtab[pos], fontname);
	if (curfontpos == pos)	curfontpos = -1;
}

void
settrfont(void) {
	if (curfontpos == fontpos) return;

	if (fontmtab[fontpos] == 0)
		error(FATAL, "Font at position %d was not initialized, botch!\n", fontpos);

	curtrofffontid = findtfn(fontmtab[fontpos], 1);
	if (debug) fprint(2, "settrfont()-&gt; curtrofffontid=%d\n", curtrofffontid);
	curfontpos = fontpos;
	if (curtrofffontid &lt; 0) {
		int i;

		error(WARNING, "fontpos=%d\n", fontpos);
		for (i=0; i&lt;fontmnt; i++)
			if (fontmtab[i] == 0)
				error(WARNING, "fontmtab[%d]=0x0\n", i);
			else
				error(WARNING, "fontmtab[%d]=%s\n", i, fontmtab[i]);
		exits("settrfont()");
	}
}

void
setpsfont(int psftid, int fontsize) {
	if (psftid == curpostfontid &amp;&amp; fontsize == curfontsize) return;
	if (psftid &gt;= pfnamcnt)
		error(FATAL, "Postscript font index=%d used but not defined, there are only %d fonts\n",
			psftid, pfnamcnt);

	endstring();
	if (pageon()) {
		Bprint(Bstdout, "%d /%s f\n", fontsize, pfnafontmtab[psftid].str);
		if ( fontheight != 0 || fontslant != 0 )
			Bprint(Bstdout, "%d %d changefont\n", fontslant, (fontheight != 0) ? fontheight : fontsize);
		pfnafontmtab[psftid].used = 1;
		curpostfontid = psftid;
		curfontsize = fontsize;
	}
}

/* find index of PostScript font name in table
 * returns -1 if name is not in table
 * If insflg is not zero
 * and the name is not found in the table, insert it.
 */
int
findpfn(char *fontname, int insflg) {
	char *tp;
	int i;

	for (i=0; i&lt;pfnamcnt; i++) {
		if (strcmp(pfnafontmtab[i].str, fontname) == 0)
			return(i);
	}
	if (insflg) {
		tp = galloc(pfnafontmtab, sizeof(struct pfnament)*(pfnamcnt+1), "findpfn():pfnafontmtab");
		if (tp == 0)
			return(-2);
		pfnafontmtab = (struct pfnament *)tp;
		i = strlen(fontname);
		pfnafontmtab[pfnamcnt].str = galloc(0, i+1, "findpfn():pfnafontmtab[].str");
		strncpy(pfnafontmtab[pfnamcnt].str, fontname, i);
		pfnafontmtab[pfnamcnt].str[i] = '\0';
		pfnafontmtab[pfnamcnt].used = 0;
		return(pfnamcnt++);
	}
	return(-1);
}

char postroffdirname[] = "/sys/lib/postscript/troff"; /* "/sys/lib/postscript/troff/"; */
char troffmetricdirname[] = "/sys/lib/troff/font"; /* "/sys/lib/troff/font/devutf/"; */

int
readpsfontdesc(char *fontname, int trindex) {
	int errorflg = 0, line = 1, rv, start, end, offset;
	int startfont, endfont, startchar, endchar, i, pfid;
	char psfontnam[128];
	struct troffont *tp;
	Biobuf *bfd;
	Biobufhdr *Bfd;
	static char *filename = 0;

	if (debug)
		fprint(2, "readpsfontdesc(%s,%d)\n", fontname, trindex);
	filename = galloc(filename, strlen(postroffdirname)+1+strlen(fontname)+1,
		"readpsfontdesc: cannot allocate memory\n");
	sprint(filename, "%s/%s", postroffdirname, fontname);

	bfd = Bopen(filename, OREAD);
	if (bfd == 0) {
		error(WARNING, "cannot open file %s\n", filename);
		return(0);
	}
	Bfd = &amp;bfd-&gt;Biobufhdr;

	do {
		offset = 0;
		if ((rv=Bgetfield(Bfd, 'd', &amp;start, 0)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal start value\n", filename, line);
		} else if (rv &lt; 0) break;
		if ((rv=Bgetfield(Bfd, 'd', &amp;end, 0)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal end value\n", filename, line);
		} else if (rv &lt; 0) break;
		if (Bgetfield(Bfd, 'd', &amp;offset, 0) &lt; 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal offset value\n", filename, line);
		}
		if ((rv=Bgetfield(Bfd, 's', psfontnam, 128)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal fontname value\n", filename, line);
		} else if (rv &lt; 0)
			break;
		Brdline(Bfd, '\n');
		if (!errorflg) {
			struct psfent *psfentp;
			startfont = RUNEGETGROUP(start);
			startchar = RUNEGETCHAR(start);
			endfont = RUNEGETGROUP(end);
			endchar = RUNEGETCHAR(end);
			pfid = findpfn(psfontnam, 1);
			if (startfont != endfont) {
				error(WARNING, "font descriptions must not cross 256 glyph block boundary\n");
				break;
			}
			tp = &amp;troffontab[trindex];
			tp-&gt;psfmap = galloc(tp-&gt;psfmap, ++tp-&gt;psfmapsize *
				sizeof(struct psfent),
				"readpsfontdesc():psfmap");
			psfentp = &amp;(tp-&gt;psfmap[tp-&gt;psfmapsize-1]);
			psfentp-&gt;start = start;
			psfentp-&gt;end = end;
			psfentp-&gt;offset = offset;
			psfentp-&gt;psftid = pfid;
			if (debug) {
				fprint(2, "\tpsfmap-&gt;start=0x%x\n", start);
				fprint(2, "\tpsfmap-&gt;end=0x%x\n", end);
				fprint(2, "\tpsfmap-&gt;offset=0x%x\n", offset);
				fprint(2, "\tpsfmap-&gt;pfid=0x%x\n", pfid);
			}
			SET(i);
			USED(i, startchar, endchar);
/*
			for (i=startchar; i&lt;=endchar; i++) {
				tp-&gt;charent[startfont][i].postfontid = pfid;
				tp-&gt;charent[startfont][i].postcharid = i + offset - startchar;
			}
 */
			if (debug) {
				fprint(2, "%x %x ", start, end);
				if (offset)
					fprint(2, "%x ", offset);
				fprint(2, "%s\n", psfontnam);
			}
			line++;
		}
	} while(errorflg != 1);
	Bterm(Bfd);
	return(1);
}

int
readtroffmetric(char *fontname, int trindex) {
	int ntoken, errorflg = 0, line = 1, rv;
	int width, flag, charnum, thisfont, thischar;
	char stoken[128], *str;
	struct charent **cp;
	BOOLEAN specharflag;
	Biobuf *bfd;
	Biobufhdr *Bfd;
	Rune troffchar, quote;
	static char *filename = 0;

	if (debug)
		fprint(2, "readtroffmetric(%s,%d)\n", fontname, trindex);
	filename = galloc(filename, strlen(troffmetricdirname) + 4 +
		strlen(devname) + 1 + strlen(fontname) + 1,
		"readtroffmetric():filename");
	sprint(filename, "%s/dev%s/%s", troffmetricdirname, devname, fontname);

	bfd = Bopen(filename, OREAD);
	if (bfd == 0) {
		error(WARNING, "cannot open file %s\n", filename);
		return(0);
	}
	Bfd = &amp;bfd-&gt;Biobufhdr;
	do {
		/*
		 * deal with the few lines at the beginning of the
		 * troff font metric files.
		 */
		if ((rv=Bgetfield(Bfd, 's', stoken, 128)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal token\n", filename, line);
		} else if (rv &lt; 0)
			break;
		if (debug)
			fprint(2, "%s\n", stoken);

		if (strcmp(stoken, "name") == 0) {
			if ((rv=Bgetfield(Bfd, 's', stoken, 128)) == 0) {
				errorflg = 1;
				error(WARNING, "file %s:%d illegal token\n", filename, line);
			} else if (rv &lt; 0) break;
		} else if (strcmp(stoken, "named") == 0) {
			Brdline(Bfd, '\n');
		} else if (strcmp(stoken, "fontname") == 0) {
			if ((rv=Bgetfield(Bfd, 's', stoken, 128)) == 0) {
				errorflg = 1;
				error(WARNING, "file %s:%d illegal token\n", filename, line);
			} else if (rv &lt; 0) break;
		} else if (strcmp(stoken, "spacewidth") == 0) {
			if ((rv=Bgetfield(Bfd, 'd', &amp;ntoken, 0)) == 0) {
				errorflg = 1;
				error(WARNING, "file %s:%d illegal token\n", filename, line);
			} else if (rv &lt; 0) break;
			troffontab[trindex].spacewidth = ntoken;
			thisfont = RUNEGETGROUP(' ');
			thischar = RUNEGETCHAR(' ');
			for (cp = &amp;(troffontab[trindex].charent[thisfont][thischar]); *cp != 0; cp = &amp;((*cp)-&gt;next))
				if ((*cp)-&gt;name)
					if  (strcmp((*cp)-&gt;name, " ") == 0)
						break;

			if (*cp == 0) *cp = galloc(0, sizeof(struct charent), "readtroffmetric:charent");
			(*cp)-&gt;postfontid = thisfont;
			(*cp)-&gt;postcharid = thischar;
			(*cp)-&gt;troffcharwidth = ntoken;
			(*cp)-&gt;name = galloc(0, 2, "readtroffmetric: char name");
			(*cp)-&gt;next = 0;
			strcpy((*cp)-&gt;name, " ");
		} else if (strcmp(stoken, "special") == 0) {
			troffontab[trindex].special = TRUE;
		} else if (strcmp(stoken, "charset") == 0) {
			line++;
			break;
		}
		if (!errorflg) {
			line++;
		}
	} while(!errorflg &amp;&amp; rv&gt;=0);
	while(!errorflg &amp;&amp; rv&gt;=0) {
		if ((rv=Bgetfield(Bfd, 's', stoken, 128)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal rune token &lt;0x%x&gt; rv=%d\n", filename, line, troffchar, rv);
		} else if (rv &lt; 0) break;
		if (utflen(stoken) &gt; 1) specharflag = TRUE;
		else specharflag = FALSE;
		/* if this character is a quote we have to use the previous characters info */
		if ((rv=Bgetfield(Bfd, 'r', &amp;quote, 0)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal width or quote token &lt;0x%x&gt; rv=%d\n",
				filename, line, quote, rv);
		} else if (rv &lt; 0) break;
		if (quote == '"') {
			/* need some code here */
			goto flush;
		} else
			Bungetrune(Bfd);

		if ((rv=Bgetfield(Bfd, 'd', &amp;width, 0)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal width token &lt;0x%x&gt; rv=%d\n", filename, line, troffchar, rv);
		} else if (rv &lt; 0) break;
		if ((rv=Bgetfield(Bfd, 'd', &amp;flag, 0)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal flag token &lt;0x%x&gt; rv=%d\n", filename, line, troffchar, rv);
		} else if (rv &lt; 0) break;
		if ((rv=Bgetfield(Bfd, 'd', &amp;charnum, 0)) == 0) {
			errorflg = 1;
			error(WARNING, "file %s:%d illegal character number token &lt;0x%x&gt; rv=%d\n", filename, line, troffchar, rv);
		} else if (rv &lt; 0)
			break;
flush:
		str = Brdline(Bfd, '\n');
		/* stash the crap from the end of the line for debugging */
		if (debug) {
			if (str == 0) {
				fprint(2, "premature EOF\n");
				return(0);
			}
			str[Blinelen(Bfd)-1] = '\0';
		}
		line++;
		chartorune(&amp;troffchar, stoken);
		if (specharflag)
			if (debug)
				fprint(2, "%s %d  %d 0x%x %s # special\n",
					stoken, width, flag, charnum, str);
		if (strcmp(stoken, "---") == 0) {
			thisfont = RUNEGETGROUP(charnum);
			thischar = RUNEGETCHAR(charnum);
			stoken[0] = '\0';
		} else {
			thisfont = RUNEGETGROUP(troffchar);
			thischar = RUNEGETCHAR(troffchar);
		}
		for (cp = &amp;troffontab[trindex].charent[thisfont][thischar];
		    *cp != 0; cp = &amp;(*cp)-&gt;next)
			if ((*cp)-&gt;name) {
				if (debug)
					fprint(2, "installing &lt;%s&gt;, found &lt;%s&gt;\n",
						stoken, (*cp)-&gt;name);
				if  (strcmp((*cp)-&gt;name, stoken) == 0)
					break;
			}
		if (*cp == 0)
			*cp = galloc(0, sizeof(struct charent),
				"readtroffmetric:charent");
		(*cp)-&gt;postfontid = RUNEGETGROUP(charnum);
		(*cp)-&gt;postcharid = RUNEGETCHAR(charnum);
		(*cp)-&gt;troffcharwidth = width;
		(*cp)-&gt;name = galloc(0, strlen(stoken)+1, "readtroffmetric: char name");
		(*cp)-&gt;next = 0;
		strcpy((*cp)-&gt;name, stoken);
		if (debug) {
			if (specharflag)
				fprint(2, "%s", stoken);
			else
				fprint(2, "%C", troffchar);
			fprint(2, " %d  %d 0x%x %s # psfontid=0x%x pscharid=0x%x thisfont=0x%x thischar=0x%x\n",
				width, flag, charnum, str,
				(*cp)-&gt;postfontid,
				(*cp)-&gt;postcharid,
				thisfont, thischar);
		}
	}
	Bterm(Bfd);
	Bflush(Bstderr);
	return(1);
}

/* find index of troff font name in table
 * returns -1 if name is not in table
 * returns -2 if it cannot allocate memory
 * returns -3 if there is a font mapping problem
 * If insflg is not zero
 * and the name is not found in the table, insert it.
 */
int
findtfn(char *fontname, BOOLEAN insflg) {
	struct troffont *tp;
	int i, j;

	if (debug)
		fprint(2, "findtfn(%s,%d)\n", fontname, insflg);
	for (i=0; i&lt;troffontcnt; i++) {
		if (troffontab[i].trfontid==0) {
			error(WARNING, "findtfn:troffontab[%d].trfontid=0x%x, botch!\n",
				i, troffontab[i].trfontid);
			continue;
		}
		if (strcmp(troffontab[i].trfontid, fontname) == 0)
			return(i);
	}
	if (insflg) {
		tp = (struct troffont *)galloc(troffontab,
			sizeof(struct troffont)*(troffontcnt+1),
			"findtfn: struct troffont:");
		if (tp == 0)
			return(-2);
		troffontab = tp;
		tp = &amp;(troffontab[troffontcnt]);
		i = strlen(fontname);
		tp-&gt;trfontid = galloc(0, i+1, "findtfn: trfontid:");

		/* initialize new troff font entry with name and numeric fields to 0 */
		strncpy(tp-&gt;trfontid, fontname, i);
		tp-&gt;trfontid[i] = '\0';
		tp-&gt;special = FALSE;
		tp-&gt;spacewidth = 0;
		tp-&gt;psfmapsize = 0;
		tp-&gt;psfmap = 0;
		for (i=0; i&lt;NUMOFONTS; i++)
			for (j=0; j&lt;FONTSIZE; j++)
				tp-&gt;charent[i][j] = 0;
		troffontcnt++;
		if (!readtroffmetric(fontname, troffontcnt-1))
			return(-3);
		if (!readpsfontdesc(fontname, troffontcnt-1))
			return(-3);
		return(troffontcnt-1);
	}
	return(-1);
}

void
finish(void) {
	int i;

	Bprint(Bstdout, "%s", TRAILER);
	Bprint(Bstdout, "done\n");
	Bprint(Bstdout, "%s", DOCUMENTFONTS);

	for (i=0; i&lt;pfnamcnt; i++)
		if (pfnafontmtab[i].used)
			Bprint(Bstdout, " %s", pfnafontmtab[i].str);
	Bprint(Bstdout, "\n");

	Bprint(Bstdout, "%s %d\n", PAGES, pages_printed);

}

/* Set slant to n degrees. Disable slanting if n is 0. */
void
t_slant(int n) {
	fontslant = n;
	curpostfontid = -1;
}

/* Set character height to n points. Disabled if n is 0 or the current size. */

void
t_charht(int n) {
	fontheight = (n == fontsize) ? 0 : n;
	curpostfontid = -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

