<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/tr2post/ps_include.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/tr2post/ps_include.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;stdio.h&gt;
#include "../common/common.h"
#include "ps_include.h"

extern int curpostfontid;
extern int curfontsize;

typedef struct {long start, end;} Section;
static char *buf;

static void
copy(Biobufhdr *fin, Biobufhdr *fout, Section *s) {
	if (s-&gt;end &lt;= s-&gt;start)
		return;
	Bseek(fin, s-&gt;start, 0);
	while (Bseek(fin, 0L, 1) &lt; s-&gt;end &amp;&amp; (buf=Brdline(fin, '\n')) != NULL){
		/*
		 * We have to be careful here, because % can legitimately appear
		 * in Ascii85 encodings, and must not be elided.
		 * The goal here is to make any DSC comments impotent without
		 * actually changing the behavior of the Postscript.
		 * Since stripping ``comments'' breaks Ascii85, we can instead just
		 * indent comments a space, which turns DSC comments into non-DSC comments
		 * and has no effect on binary encodings, which are whitespace-blind.
		 */
		if(buf[0] == '%')
			Bputc(fout, ' ');
		Bwrite(fout, buf, Blinelen(fin));
	}
}

/*
 * Reads a PostScript file (*fin), and uses structuring comments to locate the
 * prologue, trailer, global definitions, and the requested page. After the whole
 * file is scanned, the  special ps_include PostScript definitions are copied to
 * *fout, followed by the prologue, global definitions, the requested page, and
 * the trailer. Before returning the initial environment (saved in PS_head) is
 * restored.
 *
 * By default we assume the picture is 8.5 by 11 inches, but the BoundingBox
 * comment, if found, takes precedence.
 */
/*	*fin, *fout;		/* input and output files */
/*	page_no;		/* physical page number from *fin */
/*	whiteout;		/* erase picture area */
/*	outline;		/* draw a box around it and */
/*	scaleboth;		/* scale both dimensions - if not zero */
/*	cx, cy;			/* center of the picture and */
/*	sx, sy;			/* its size - in current coordinates */
/*	ax, ay;			/* left-right, up-down adjustment */
/*	rot;			/* rotation - in clockwise degrees */

void
ps_include(Biobufhdr *fin, Biobufhdr *fout, int page_no, int whiteout,
	int outline, int scaleboth, double cx, double cy, double sx, double sy,
	double ax, double ay, double rot) {
	int foundpage = 0;		/* found the page when non zero */
	int foundpbox = 0;		/* found the page bounding box */
	int i;
	int maxglobal = 0;		/* the number we've got room for */
	int nglobal = 0;		/* number of global defs so far */
	char **strp;
	double llx, lly;		/* lower left and */
	double o = outline != 0;
	double s = scaleboth != 0;
	double urx, ury;		/* upper right corners - default coords */
	double w = whiteout != 0;	/* mostly for the var() macro */
	Section *global;		/* offsets for all global definitions */
	Section prolog, page, trailer;	/* prologue, page, and trailer offsets */

#define has(word)	(strncmp(buf, word, strlen(word)) == 0)
#define grab(n)		((Section *)(nglobal \
			? realloc((char *)global, n*sizeof(Section)) \
			: calloc(n, sizeof(Section))))
	global = nil;
	llx = lly = 0;		/* default BoundingBox - 8.5x11 inches */
	urx = 72 * 8.5;
	ury = 72 * 11.0;

	/* section boundaries and bounding box */

	prolog.start = prolog.end = 0;
	page.start = page.end = 0;
	trailer.start = 0;
	Bseek(fin, 0L, 0);

	while ((buf=Brdline(fin, '\n')) != NULL) {
		buf[Blinelen(fin)-1] = '\0';
		if (!has("%%"))
			continue;
		else if (has("%%Page: ")) {
			if (!foundpage)
				page.start = Bseek(fin, 0L, 1);
			sscanf(buf, "%*s %*s %d", &amp;i);
			if (i == page_no)
				foundpage = 1;
			else if (foundpage &amp;&amp; page.end &lt;= page.start)
				page.end = Bseek(fin, 0L, 1);
		} else if (has("%%EndPage: ")) {
			sscanf(buf, "%*s %*s %d", &amp;i);
			if (i == page_no) {
				foundpage = 1;
				page.end = Bseek(fin, 0L, 1);
			}
			if (!foundpage)
				page.start = Bseek(fin, 0L, 1);
		} else if (has("%%PageBoundingBox: ")) {
			if (i == page_no) {
				foundpbox = 1;
				sscanf(buf, "%*s %lf %lf %lf %lf",
						&amp;llx, &amp;lly, &amp;urx, &amp;ury);
			}
		} else if (has("%%BoundingBox: ")) {
			if (!foundpbox)
				sscanf(buf,"%*s %lf %lf %lf %lf",
						&amp;llx, &amp;lly, &amp;urx, &amp;ury);
		} else if (has("%%EndProlog") || has("%%EndSetup") || has("%%EndDocumentSetup"))
			prolog.end = page.start = Bseek(fin, 0L, 1);
		else if (has("%%Trailer"))
			trailer.start = Bseek(fin, 0L, 1);
		else if (has("%%BeginGlobal")) {
			if (page.end &lt;= page.start) {
				if (nglobal &gt;= maxglobal) {
					maxglobal += 20;
					global = grab(maxglobal);
				}
				global[nglobal].start = Bseek(fin, 0L, 1);
			}
		} else if (has("%%EndGlobal"))
			if (page.end &lt;= page.start)
				global[nglobal++].end = Bseek(fin, 0L, 1);
	}
	Bseek(fin, 0L, 2);
	if (trailer.start == 0)
		trailer.start = Bseek(fin, 0L, 1);
	trailer.end = Bseek(fin, 0L, 1);

	if (page.end &lt;= page.start)
		page.end = trailer.start;

/*
fprint(2, "prolog=(%d,%d)\n", prolog.start, prolog.end);
fprint(2, "page=(%d,%d)\n", page.start, page.end);
for(i = 0; i &lt; nglobal; i++)
	fprint(2, "global[%d]=(%d,%d)\n", i, global[i].start, global[i].end);
fprint(2, "trailer=(%d,%d)\n", trailer.start, trailer.end);
*/

	/* all output here */
	for (strp = PS_head; *strp != NULL; strp++)
		Bwrite(fout, *strp, strlen(*strp));

	Bprint(fout, "/llx %g def\n", llx);
	Bprint(fout, "/lly %g def\n", lly);
	Bprint(fout, "/urx %g def\n", urx);
	Bprint(fout, "/ury %g def\n", ury);
	Bprint(fout, "/w %g def\n", w);
	Bprint(fout, "/o %g def\n", o);
	Bprint(fout, "/s %g def\n", s);
	Bprint(fout, "/cx %g def\n", cx);
	Bprint(fout, "/cy %g def\n", cy);
	Bprint(fout, "/sx %g def\n", sx);
	Bprint(fout, "/sy %g def\n", sy);
	Bprint(fout, "/ax %g def\n", ax);
	Bprint(fout, "/ay %g def\n", ay);
	Bprint(fout, "/rot %g def\n", rot);

	for (strp = PS_setup; *strp != NULL; strp++)
		Bwrite(fout, *strp, strlen(*strp));

	copy(fin, fout, &amp;prolog);
	for(i = 0; i &lt; nglobal; i++)
		copy(fin, fout, &amp;global[i]);
	copy(fin, fout, &amp;page);
	copy(fin, fout, &amp;trailer);
	for (strp = PS_tail; *strp != NULL; strp++)
		Bwrite(fout, *strp, strlen(*strp));

	if(nglobal)
		free(global);

	/* force the program to reestablish its state */
	curpostfontid = -1;
	curfontsize = -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

