<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/tr2post/tr2post.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/tr2post/tr2post.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;stdio.h&gt;
#include "common.h"
#include "tr2post.h"
#include "comments.h"
#include "path.h"

int formsperpage = 1;
int picflag = 1;
double aspectratio = 1.0;
int copies = 1;
int landscape = 0;
double magnification = 1.0;
int linesperpage = 66;
int pointsize = 10;
double xoffset = .25;
double yoffset = .25;
char *passthrough = 0;

Biobuf binp, *bstdout, bstderr;
Biobufhdr *Bstdin, *Bstdout, *Bstderr;
int debug = 0;

char tmpfilename[MAXTOKENSIZE];
char copybuf[BUFSIZ];

struct charent **build_char_list = 0;
int build_char_cnt = 0;

void
prologues(void) {
	int i;
	char charlibname[MAXTOKENSIZE];

	Bprint(Bstdout, "%s", CONFORMING);
	Bprint(Bstdout, "%s %s\n", VERSION, PROGRAMVERSION);
	Bprint(Bstdout, "%s %s\n", CREATOR, PROGRAMNAME);
	Bprint(Bstdout, "%s %s\n", DOCUMENTFONTS, ATEND);
	Bprint(Bstdout, "%s %s\n", PAGES, ATEND);
	Bprint(Bstdout, "%s", ENDCOMMENTS);

	if (cat(DPOST)) {
		fprint(2, "can't read %s\n", DPOST);
		exits("dpost prologue");
	}

	if (drawflag) {
		if (cat(DRAW)) {
			fprint(2, "can't read %s\n", DRAW);
			exits("draw prologue");
		}
	}

	if (DOROUND)
		cat(ROUNDPAGE);

	Bprint(Bstdout, "%s", ENDPROLOG);
	Bprint(Bstdout, "%s", BEGINSETUP);
	Bprint(Bstdout, "mark\n");
	if (formsperpage &gt; 1) {
		Bprint(Bstdout, "%s %d\n", FORMSPERPAGE, formsperpage);
		Bprint(Bstdout, "/formsperpage %d def\n", formsperpage);
	}
	if (aspectratio != 1) Bprint(Bstdout, "/aspectratio %g def\n", aspectratio);
	if (copies != 1) Bprint(Bstdout, "/#copies %d store\n", copies);
	if (landscape) Bprint(Bstdout, "/landscape true def\n");
	if (magnification != 1) Bprint(Bstdout, "/magnification %g def\n", magnification);
	if (pointsize != 10) Bprint(Bstdout, "/pointsize %d def\n", pointsize);
	if (xoffset != .25) Bprint(Bstdout, "/xoffset %g def\n", xoffset);
	if (yoffset != .25) Bprint(Bstdout, "/yoffset %g def\n", yoffset);
	cat(ENCODINGDIR"/Latin1.enc");
	if (passthrough != 0) Bprint(Bstdout, "%s\n", passthrough);

	Bprint(Bstdout, "setup\n");
	if (formsperpage &gt; 1) {
		cat(FORMFILE);
		Bprint(Bstdout, "%d setupforms \n", formsperpage);
	}
/* output Build character info from charlib if necessary. */

	for (i=0; i&lt;build_char_cnt; i++) {
		sprint(charlibname, "%s/%s", CHARLIB, build_char_list[i]-&gt;name);
		if (cat(charlibname))
		fprint(2, "cannot open %s\n", charlibname);
	}

	Bprint(Bstdout, "%s", ENDSETUP);
}

void
cleanup(void) {
	remove(tmpfilename);
}

void
main(int argc, char *argv[]) {
	Biobuf *binp;
	Biobufhdr *Binp;
	int i, tot, ifd;
	char *t;

	programname = argv[0];
	if (Binit(&amp;bstderr, 2, OWRITE) == Beof)
		sysfatal("Binit");
	Bstderr = &amp;bstderr.Biobufhdr;

	tmpnam(tmpfilename);
	if ((bstdout=Bopen(tmpfilename, OWRITE)) == 0)
		sysfatal("cannot open temporary file %s: %r", tmpfilename);
	atexit(cleanup);
	Bstdout = &amp;bstdout-&gt;Biobufhdr;

	ARGBEGIN{
	case 'a':			/* aspect ratio */
		aspectratio = atof(ARGF());
		break;
	case 'c':			/* copies */
		copies = atoi(ARGF());
		break;
	case 'd':
		debug = 1;
		break;
	case 'm':			/* magnification */
		magnification = atof(ARGF());
		break;
	case 'n':			/* forms per page */
		formsperpage = atoi(ARGF());
		break;
	case 'o':			/* output page list */
		pagelist(ARGF());
		break;
	case 'p':			/* landscape or portrait mode */
		if ( ARGF()[0] == 'l' )
			landscape = 1;
		else
			landscape = 0;
		break;
	case 'x':			/* shift things horizontally */
		xoffset = atof(ARGF());
		break;
	case 'y':			/* and vertically on the page */
		yoffset = atof(ARGF());
		break;
	case 'P':			/* PostScript pass through */
		t = ARGF();
		i = strlen(t) + 1;
		passthrough = malloc(i);
		if (passthrough == 0)
			sysfatal("malloc");
		strncpy(passthrough, t, i);
		break;
	default:			/* don't know what to do for ch */
		fprint(2, "unknown option %C\n", ARGC());
		break;
	}ARGEND;

	readDESC();
	if (argc == 0) {
		if ((binp = (Biobuf *)malloc(sizeof(Biobuf))) == nil)
			sysfatal("malloc");
		if (Binit(binp, 0, OREAD) == Beof)
			sysfatal("Binit of &lt;stdin&gt; failed.");
		Binp = &amp;binp-&gt;Biobufhdr;
		if (debug) fprint(2, "using standard input\n");
		conv(Binp);
		Bterm(Binp);
	}
	for (i=0; i&lt;argc; i++) {
		if ((binp=Bopen(argv[i], OREAD)) == 0) {
			fprint(2, "cannot open file %s\n", argv[i]);
			continue;
		}
		Binp = &amp;binp-&gt;Biobufhdr;
		inputfilename = argv[i];
		conv(Binp);
		Bterm(Binp);
	}
	Bterm(Bstdout);

	if ((ifd=open(tmpfilename, OREAD)) &lt; 0)
		sysfatal("open of %s failed: %r", tmpfilename);

	bstdout = galloc(0, sizeof(Biobuf), "bstdout");
	if (Binit(bstdout, 1, OWRITE) == Beof)
		sysfatal("Binit of &lt;stdout&gt; failed.");
	Bstdout = &amp;(bstdout-&gt;Biobufhdr);
	prologues();
	Bflush(Bstdout);
	tot = 0;
	while ((i=read(ifd, copybuf, BUFSIZ)) &gt; 0) {
		if (write(1, copybuf, i) != i) {
			fprint(2, "write error on copying from temp file.\n");
			exits("write");
		}
		tot += i;
	}
	if (debug) fprint(2, "copied %d bytes to final output i=%d\n", tot, i);
	if (i &lt; 0)
		sysfatal("read error copying from temp file: %r");
	finish();
	exits("");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

