<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/primes.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/primes.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

double big = 9.007199254740992e15;

int pt[] =
{
	  2,  3,  5,  7, 11, 13, 17, 19, 23, 29,
	 31, 37, 41, 43, 47, 53, 59, 61, 67, 71,
	 73, 79, 83, 89, 97,101,103,107,109,113,
	127,131,137,139,149,151,157,163,167,173,
	179,181,191,193,197,199,211,223,227,229,
};
double wheel[] =
{
	10, 2, 4, 2, 4, 6, 2, 6, 4, 2,
	 4, 6, 6, 2, 6, 4, 2, 6, 4, 6,
	 8, 4, 2, 4, 2, 4, 8, 6, 4, 6,
	 2, 4, 6, 2, 6, 6, 4, 2, 4, 6,
	 2, 6, 4, 2, 4, 2,10, 2,
};
uchar table[1000];
uchar bittab[] =
{
	1, 2, 4, 8, 16, 32, 64, 128,
};

enum {
	ptsiz	= nelem(pt),
	whsiz	= nelem(wheel),
	tabsiz	= nelem(table),
	tsiz8	= tabsiz*8,
};

void	mark(double nn, long k);

void
usage(void)
{
	fprint(2, "usage: %s [start [finish]]\n", argv0);
	exits("limits");
}

void
ouch(void)
{
	fprint(2, "limits exceeded\n");
	exits("limits");
}

void
main(int argc, char *argv[])
{
	int i;
	double k, temp, v, limit, nn;
	char *l;
	Biobuf bin;

	ARGBEGIN{
	default:
		usage();
		break;
	}ARGEND;

	nn = 0;
	limit = big;
	switch (argc) {
	case 0:
		Binit(&amp;bin, 0, OREAD);
		while ((l = Brdline(&amp;bin, '\n')) != nil) {
			if (*l == '\n')
				continue;
			nn = atof(l);
			if(nn &lt; 0)
				sysfatal("negative start");
			break;
		}
		Bterm(&amp;bin);
		break;
	case 2:
		limit = atof(argv[1]);
		if(limit &lt; nn)
			exits(0);
		if(limit &gt; big)
			ouch();
		/* fallthrough */
	case 1:
		nn = atof(argv[0]);
		break;
	default:
		usage();
		break;
	}

	if(nn &lt; 0 || nn &gt; big)
		ouch();
	if(nn == 0)
		nn = 1;

	if(nn &lt; 230) {
		for(i=0; i&lt;ptsiz; i++) {
			if(pt[i] &lt; nn)
				continue;
			if(pt[i] &gt; limit)
				exits(0);
			print("%d\n", pt[i]);
//			if(limit &gt;= big)
//				exits(0);
		}
		nn = 230;
	}

	modf(nn/2, &amp;temp);
	nn = 2*temp + 1;
/*
 *	clear the sieve table.
 */
	for(;;) {
		for(i = 0; i &lt; tabsiz; i++)
			table[i] = 0;
/*
 *	run the sieve.
 */
		v = sqrt(nn+tsiz8);
		mark(nn, 3);
		mark(nn, 5);
		mark(nn, 7);
		for(i = 0, k = 11; k &lt;= v; k += wheel[i]) {
			mark(nn, k);
			i++;
			if(i &gt;= whsiz)
				i = 0;
		}
/*
 *	now get the primes from the table
 *	and print them.
 */
		for(i = 0; i &lt; tsiz8; i += 2) {
			if(table[i&gt;&gt;3] &amp; bittab[i&amp;07])
				continue;
			temp = nn + i;
			if(temp &gt; limit)
				exits(0);
			print("%.0f\n", temp);
//			if(limit &gt;= big)
//				exits(0);
		}
		nn += tsiz8;
	}
}

void
mark(double nn, long k)
{
	double t1;
	long j;

	modf(nn/k, &amp;t1);
	j = k*t1 - nn;
	if(j &lt; 0)
		j += k;
	for(; j &lt; tsiz8; j += k)
		table[j&gt;&gt;3] |= bittab[j&amp;07];
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

