<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/qi/branch.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/qi/branch.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "power.h"

void	mcrf(ulong);
void	bclr(ulong);
void	crop(ulong);
void	bcctr(ulong);
void	call(ulong);
void	ret(ulong);
void isync(ulong);

Inst	op19[] = {
[0] {mcrf, "mcrf", Ibranch},
[16] {bclr, "bclr", Ibranch},
[33] {crop, "crnor", Ibranch},
[15] {0, "rfi", Ibranch},
[129] {crop, "crandc", Ibranch},
[150] {isync, "isync", Ibranch},
[193] {crop, "crxor", Ibranch},
[225] {crop, "crnand", Ibranch},
[257] {crop, "crand", Ibranch},
[289] {crop, "creqv", Ibranch},
[417] {crop, "crorc", Ibranch},
[449] {crop, "cror", Ibranch},
[528] {bcctr, "bcctr", Ibranch},
	{0, 0, 0}
};

Inset	ops19 = {op19, nelem(op19)-1};

static char *
boname(int bo)
{
	static char buf[8];

	switch(bo&gt;&gt;1){
	case 0:	return "dnzf";
	case 1:	return "dzf";
	case 2:	return "f";
	case 4:	return "dnzt";
	case 5:	return "dzt";
	case 6:	return "t";
	case 8:	return "dnz";
	case 9:	return "dz";
	case 10:	return "a";
	default:
		sprint(buf, "%d?", bo);
		return buf;
	}
}

static char *
cname(int bo, int bi)
{
	int f;
	char *p;
	static char buf[20];
	static char *f0[] = {"lt", "gt", "eq", "so/un"};

	if(bo == 0x14){	/* branch always */
		sprint(buf,"%d", bi);
		return buf;
	}
	for(f = 0; bi &gt;= 4; bi -= 4)
		f++;
	p = buf;
	p += sprint(buf, "%d[", bi);
	if(f)
		p += sprint(buf, "cr%d+", f);
	strcpy(p, f0[bi&amp;3]);
	strcat(p, "]");
	return buf;
}

static int
condok(ulong ir, int ctr)
{
	int bo, bi, xx;

	getbobi(ir);
	if(xx)
		undef(ir);
	if((bo &amp; 0x4) == 0) {
		if(!ctr)
			undef(ir);
		reg.ctr--;
	}
	if(bo &amp; 0x4 || (reg.ctr!=0)^((bo&gt;&gt;1)&amp;1)) {
		if(bo &amp; 0x10 || (((reg.cr &amp; bits[bi])!=0)==((bo&gt;&gt;3)&amp;1)))
			return 1;
	}
	return 0;
}

static void
dobranch(ulong ir, ulong *r, int ctr)
{
	int bo, bi, xx;
	ulong nia;

	getbobi(ir);
	USED(xx);
	if(condok(ir, ctr)) {
		ci-&gt;taken++;
		nia = *r &amp; ~3;
		if(bo &amp; 4)	/* assume counting branches aren't returns */
			ret(nia);
	} else
		nia = reg.pc + 4;
	if(trace)
		itrace("%s%s\t%s,%s,#%.8lux", ci-&gt;name, ir&amp;1? "l": "", boname(bo), cname(bo, bi), nia);
	if(ir &amp; 1) {
		call(nia);
		reg.lr = reg.pc + 4;
	}
	reg.pc = nia-4;
	/* branch delays? */
}

void
bcctr(ulong ir)
{
	dobranch(ir, &amp;reg.ctr, 1);
}

void
bclr(ulong ir)
{
	dobranch(ir, &amp;reg.lr, 0);
}

void
bcx(ulong ir)
{
	int bo, bi, xx;
	ulong ea;
	long imm;
	static char *opc[] = {"bc", "bcl", "bca", "bcla"};

	getbobi(ir);
	USED(xx);
	imm = ir &amp; 0xFFFC;
	if(ir &amp; 0x08000)
		imm |= 0xFFFF0000;
	if((ir &amp; 2) == 0) {	/* not absolute address */
		ea = reg.pc + imm;
		if(trace)
			itrace("%s\t%s,%s,.%s%ld\tea = #%.8lux", opc[ir&amp;3], boname(bo), cname(bo, bi), imm&lt;0?"":"+", imm, ea);
	} else {
		ea = imm;
		if(trace)
			itrace("%s\t%s,%s,#%.8lux", opc[ir&amp;3], boname(bo), cname(bo, bi), ea);
	}
	if(condok(ir&amp;0xFFFF0000, 1))
		ci-&gt;taken++;
	else
		ea = reg.pc + 4;
	if(ir &amp; 1) {
		call(ea);
		reg.lr = reg.pc+4;
	}
	reg.pc = ea-4;
	/* branch delay? */
}

void
crop(ulong ir)
{
	int rd, ra, rb, d;

	getarrr(ir);
	if(trace)
		itrace("%s\tcrb%d,crb%d,crb%d", ci-&gt;name, rd, ra, rb);
	ra = (reg.cr &amp; bits[ra]) != 0;
	rb = (reg.cr &amp; bits[rb]) != 0;
	d = 0;
	switch(getxo(ir)) {
	case 257:	d = ra &amp; rb; break;
	case 129:	d = ra &amp; !rb; break;
	case 289:	d = ra == rb; break;
	case 225:	d = !(ra &amp; rb); break;
	case 33:	d = !(ra | rb); break;
	case 449:	d = ra | rb; break;
	case 417:	d = ra | !rb; break;
	case 193:	d = ra ^ rb; break;
	default:	undef(ir); break;
	}
	if(d)
		reg.cr |= bits[rd];
}

void
mcrf(ulong ir)
{
	int rd, ra, rb;

	getarrr(ir);
	if(ir &amp; 1 || rd &amp; 3 || ra &amp; 3 || rb)
		undef(ir);
	ra &gt;&gt;= 2;
	rd &gt;&gt;= 2;
	reg.cr = (reg.cr &amp; ~mkCR(rd, 0xF)) | mkCR(rd, getCR(ra, reg.cr));
	if(trace)
		itrace("mcrf\tcrf%d,crf%d", rd, ra);
}

void
call(ulong npc)
{
	Symbol s;

	if(calltree) {
		findsym(npc, CTEXT, &amp;s);
		Bprint(bioout, "%8lux %s(", reg.pc, s.name);
		printparams(&amp;s, reg.r[1]);
		Bprint(bioout, "from ");
		printsource(reg.pc);
		Bputc(bioout, '\n');
	}
}

void
ret(ulong npc)
{
	Symbol s;

	if(calltree) {
		findsym(npc, CTEXT, &amp;s);
		Bprint(bioout, "%8lux return to #%lux %s r3=#%lux (%ld)\n",
					reg.pc, npc, s.name, reg.r[3], reg.r[3]);
	}
}

void
bx(ulong ir)
{
	ulong ea;
	long imm;
	static char *opc[] = {"b", "bl", "ba", "bla"};

	imm = ir &amp; 0x03FFFFFC;
	if(ir &amp; 0x02000000)
		imm |= 0xFC000000;
	if((ir &amp; 2) == 0) {	/* not absolute address */
		ea = reg.pc + imm;
		if(trace)
			itrace("%s\t.%s%ld\tea = #%.8lux", opc[ir&amp;3], imm&lt;0?"":"+", imm, ea);
	} else {
		ea = imm;
		if(trace)
			itrace("%s\t#%.8lux", opc[ir&amp;3], ea);
	}
	ci-&gt;taken++;
	if(ir &amp; 1) {
		call(ea);
		reg.lr = reg.pc+4;
	}
	reg.pc = ea-4;
	/* branch delay? */
}

void
isync(ulong ir)
{
	USED(ir);
	if(trace)
		itrace("isync");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

