<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/qi/power.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/qi/power.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * power sim.h
 *
 * The integer instruction side of this emulator is portable if sizeof(long) &gt;= 4
 * Floating point emulation assumes:
 *	sizeof(ulong) == sizeof(float)
 *	sizeof(ulong)*2 == sizeof(double) &lt;= sizeof(vlong)
 *	unions of double &amp; vlong have no padding
 *	vlongs provide at least 64 bits precision
 */
#include "/power/include/ureg.h"
#define	USERADDR	0xC0000000
#define	UREGADDR	(USERADDR+BY2PG-4-0xA0)
#define USER_REG(x)	(UREGADDR+(ulong)(x))
#define	REGOFF(x)	(USER_REG(&amp;((struct Ureg *) 0)-&gt;x))

typedef struct Registers Registers;
typedef struct Segment Segment;
typedef struct Memory Memory;
typedef struct Inset Inset;
typedef struct Inst Inst;
typedef struct Icache Icache;
typedef struct Breakpoint Breakpoint;

enum
{
	Instruction	= 1,
	Read		= 2,
	Write		= 4,
	Access		= 2|4,
	Equal		= 4|8,
};

struct Breakpoint
{
	int		type;		/* Instruction/Read/Access/Write/Equal */
	ulong		addr;		/* Place at address */
	int		count;		/* To execute count times or value */
	int		done;		/* How many times passed through */
	Breakpoint	*next;		/* Link to next one */
};

enum
{
	Iload,
	Istore,
	Iarith,
	Ilog,
	Ibranch,
	Ireg,
	Isyscall,
	Ifloat,
	Inop,
	Icontrol,
};

struct Icache
{
	int	on;			/* Turned on */
	int	linesize;		/* Line size in bytes */
	int	stall;			/* Cache stalls */
	int	*lines;			/* Tag array */
	int*	(*hash)(ulong);		/* Hash function */
	char	*hashtext;		/* What the function looks like */
};

struct Inset
{
	Inst	*tab;		/* indexed by extended opcode */
	int	nel;
};

struct Inst
{
	void 	(*func)(ulong);
	char	*name;
	int	type;
	int	count;
	int	taken;
};

struct Registers
{
	ulong	pc;
	ulong	ir;
	Inst	*ip;
	long	r[32];
	ulong	ctr;
	ulong	cr;
	ulong	xer;
	ulong	lr;
	ulong	fpscr;
	ulong	dec;
	ulong	tbl;
	ulong	tbu;
	double	fd[32];
};

enum
{
	MemRead,
	MemReadstring,
	MemWrite,
};

enum
{
	Stack,
	Text,
	Data,
	Bss,
	Nseg,
};

struct Segment
{
	short	type;
	ulong	base;
	ulong	end;
	ulong	fileoff;
	ulong	fileend;
	int	rss;
	int	refs;
	uchar	**table;
};

struct Memory
{
	Segment	seg[Nseg];
};

void		fatal(int, char*, ...);
void		fpreginit(void);
void		run(void);
void		undef(ulong);
void		unimp(ulong);
void		dumpreg(void);
void		dumpfreg(void);
void		dumpdreg(void);
void*		emalloc(ulong);
void*		erealloc(void*, ulong, ulong);
void*		vaddr(ulong);
void		itrace(char *, ...);
void		segsum(void);
void		sc(ulong);
char*		memio(char*, ulong, int, int);
ulong		getmem_w(ulong);
ulong		ifetch(ulong);
ushort		getmem_h(ulong);
void		putmem_w(ulong, ulong);
uchar		getmem_b(ulong);
void		putmem_b(ulong, uchar);
uvlong	getmem_v(ulong);
ulong		getmem_4(ulong);
ulong		getmem_2(ulong);
void	putmem_v(ulong, uvlong);
void		putmem_h(ulong, short);
void		isum(void);
void		initicache(void);
void		updateicache(ulong addr);
long		lnrand(long);
void		randseed(long, long);
void		cmd(void);
void		brkchk(ulong, int);
void		delbpt(char*);
void		breakpoint(char*, char*);
char*		nextc(char*);
ulong		expr(char*);
void		initstk(int, char**);
void		initmap(void);
void		inithdr(int);
void		reset(void);
void		dobplist(void);
void		procinit(int);
void		printsource(long);
void		printparams(Symbol *, ulong);
void		printlocals(Symbol *, ulong);
void		stktrace(int);
void		iprofile(void);

/* Globals */
Extern 		Registers reg;
Extern 		Memory memory;
Extern		int text;
Extern		int trace;
Extern 		int sysdbg;
Extern 		int calltree;
Extern		Icache icache;
Extern		int count;
Extern		jmp_buf errjmp;
Extern		Breakpoint *bplist;
Extern		int atbpt;
Extern		int membpt;
Extern		int cmdcount;
Extern		int nopcount;
Extern		ulong dot;
extern		char *file;
Extern		Biobuf *bioout;
Extern		Biobuf *bin;
Extern		Inst *ci;
Extern		ulong *iprof;
Extern		ulong	iprofsize;
Extern		ulong loadlock;
extern		int datasize;		
extern		int printcol;
Extern		Map *symmap;
extern		ulong bits[];

extern		Inset ops0, ops19, ops31, ops59, ops63a, ops63b;

/* Plan9 Kernel constants */
#define	BY2PG		4096
#define BY2WD		4
#define UTZERO		0x1000
#define TSTKSIZ		32
#define TSTACKTOP	0x20000000
#define STACKTOP	(TSTACKTOP-TSTKSIZ*BY2PG)
#define STACKSIZE	(4*1024*1024)

#define PROFGRAN	4
#define NOP		0x80300000
#define SIGNBIT		0x80000000


enum {
	CRLT = 1&lt;&lt;31,
	CRGT = 1&lt;&lt;30,
	CREQ = 1&lt;&lt;29,
	CRSO = 1&lt;&lt;28,
	CRFU = CRSO,

	CRFX = 1&lt;&lt;27,
	CRFEX = 1&lt;&lt;26,
	CRVX = 1&lt;&lt;25,
	CROX = 1&lt;&lt;24,
};

#define getCR(x,w) (((w)&gt;&gt;(28-(x*4)))&amp;0xF)
#define mkCR(x,v) (((v)&amp;0xF)&lt;&lt;(28-(x*4)))

#define simm(xx, ii)	xx = (short)(ii&amp;0xFFFF);
#define uimm(xx, ii)	xx = ii&amp;0xFFFF;
#define imms(xx, ii) xx = ii&lt;&lt;16;
#define getairr(i)	rd = (i&gt;&gt;21)&amp;0x1f; ra = (i&gt;&gt;16)&amp;0x1f; simm(imm,i)
#define getarrr(i)	rd = (i&gt;&gt;21)&amp;0x1f; ra = (i&gt;&gt;16)&amp;0x1f; rb = (i&gt;&gt;11)&amp;0x1f;
#define getbobi(i)	bo = (i&gt;&gt;21)&amp;0x1f; bi = (i&gt;&gt;16)&amp;0x1f; xx = (i&gt;&gt;11)&amp;0x1f;
#define getlirr(i)	rs = (i&gt;&gt;21)&amp;0x1f; ra = (i&gt;&gt;16)&amp;0x1f; uimm(imm,i)
#define getlrrr(i)	rs = (i&gt;&gt;21)&amp;0x1f; ra = (i&gt;&gt;16)&amp;0x1f; rb = (i&gt;&gt;11)&amp;0x1f;

#define OP(o,xo) ((o&lt;&lt;26)|(xo&lt;&lt;1))	/* build an operation */
#define xop(a,b) ((b&lt;&lt;6)|a)	/* compact form for use in a decoding switch on op/xo */
#define getop(i) ((i&gt;&gt;26)&amp;0x3F)
#define getxo(i) ((i&gt;&gt;1)&amp;0x3FF)

#define	FPS_FX	(1&lt;&lt;31)	/* exception summary (sticky) */
#define	FPS_EX	(1&lt;&lt;30)	/* enabled exception summary */
#define	FPS_VX	(1&lt;&lt;29)	/* invalid operation exception summary */
#define	FPS_OX	(1&lt;&lt;28)	/* overflow exception OX (sticky) */
#define	FPS_UX	(1&lt;&lt;27)	/* underflow exception UX (sticky) */
#define	FPS_ZX	(1&lt;&lt;26)	/* zero divide exception ZX (sticky) */
#define	FPS_XX	(1&lt;&lt;25)	/* inexact exception XX (sticky) */
#define	FPS_VXSNAN (1&lt;&lt;24)	/* invalid operation exception for SNaN (sticky) */
#define	FPS_VXISI	(1&lt;&lt;23)	/* invalid operation exception for ∞-∞ (sticky) */
#define	FPS_VXIDI	(1&lt;&lt;22)	/* invalid operation exception for ∞/∞ (sticky) */
#define	FPS_VXZDZ (1&lt;&lt;21)	/* invalid operation exception for 0/0 (sticky) */
#define	FPS_VXIMZ	(1&lt;&lt;20)	/* invalid operation exception for ∞*0 (sticky) */
#define	FPS_VXVC	(1&lt;&lt;19)	/* invalid operation exception for invalid compare (sticky) */
#define	FPS_FR	(1&lt;&lt;18)	/* fraction rounded */
#define	FPS_FI	(1&lt;&lt;17)	/* fraction inexact */
#define	FPS_FPRF	(1&lt;&lt;16)	/* floating point result class */
#define	FPS_FPCC	(0xF&lt;&lt;12)	/* &lt;, &gt;, =, unordered */
#define	FPS_VXCVI	(1&lt;&lt;8)	/* enable exception for invalid integer convert (sticky) */
#define	FPS_VE	(1&lt;&lt;7)	/* invalid operation exception enable */
#define	FPS_OE	(1&lt;&lt;6)	/* enable overflow exceptions */
#define	FPS_UE	(1&lt;&lt;5)	/* enable underflow */
#define	FPS_ZE	(1&lt;&lt;4)	/* enable zero divide */
#define	FPS_XE	(1&lt;&lt;3)	/* enable inexact exceptions */
#define	FPS_RN	(3&lt;&lt;0)	/* rounding mode */

#define	XER_SO	(1&lt;&lt;31)
#define	XER_OV	(1&lt;&lt;30)
#define	XER_CA	(1&lt;&lt;29)

#define	Rc	1
#define	OE	0x400
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

