<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ql/sched.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ql/sched.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

enum
{
	E_ICC	= 1&lt;&lt;0,
	E_FCC	= 1&lt;&lt;1,
	E_MEM	= 1&lt;&lt;2,
	E_MEMSP	= 1&lt;&lt;3,	/* uses offset and size */
	E_MEMSB	= 1&lt;&lt;4,	/* uses offset and size */
	E_LR	= 1&lt;&lt;5,
	E_CR = 1&lt;&lt;6,
	E_CTR = 1&lt;&lt;7,
	E_XER = 1&lt;&lt;8,

	E_CR0 = 0xF&lt;&lt;0,
	E_CR1 = 0xF&lt;&lt;4,

	ANYMEM	= E_MEM|E_MEMSP|E_MEMSB,
	ALL	= ~0,
};

typedef	struct	Sch	Sch;
typedef	struct	Dep	Dep;

struct	Dep
{
	ulong	ireg;
	ulong	freg;
	ulong	cc;
	ulong	cr;
};
struct	Sch
{
	Prog	p;
	Dep	set;
	Dep	used;
	long	soffset;
	char	size;
	char	comp;
};

void	regused(Sch*, Prog*);
int	depend(Sch*, Sch*);
int	conflict(Sch*, Sch*);
int	offoverlap(Sch*, Sch*);
void	dumpbits(Sch*, Dep*);

void
sched(Prog *p0, Prog *pe)
{
	Prog *p, *q;
	Sch sch[NSCHED], *s, *t, *u, *se, stmp;

	if(!debug['Q'])
		return;
	/*
	 * build side structure
	 */
	s = sch;
	for(p=p0;; p=p-&gt;link) {
		memset(s, 0, sizeof(*s));
		s-&gt;p = *p;
		regused(s, p);
		if(debug['X']) {
			Bprint(&amp;bso, "%P\tset", &amp;s-&gt;p);
			dumpbits(s, &amp;s-&gt;set);
			Bprint(&amp;bso, "; used");
			dumpbits(s, &amp;s-&gt;used);
			if(s-&gt;comp)
				Bprint(&amp;bso, "; compound");
			if(s-&gt;p.mark &amp; LOAD)
				Bprint(&amp;bso, "; load");
			if(s-&gt;p.mark &amp; BRANCH)
				Bprint(&amp;bso, "; branch");
			if(s-&gt;p.mark &amp; FCMP)
				Bprint(&amp;bso, "; fcmp");
			Bprint(&amp;bso, "\n");
		}
		s++;
		if(p == pe)
			break;
	}
	se = s;

	for(s=se-1; s&gt;=sch; s--) {

		/*
		 * load delay. interlocked.
		 */
		if(s-&gt;p.mark &amp; LOAD) {
			if(s &gt;= se-1)
				continue;
			if(!conflict(s, (s+1)))
				continue;
			/*
			 * s is load, s+1 is immediate use of result
			 * t is the trial instruction to insert between s and s+1
			 */
			for(t=s-1; t&gt;=sch; t--) {
				if(t-&gt;p.mark &amp; BRANCH)
					goto no2;
				if(t-&gt;p.mark &amp; FCMP)
					if((s+1)-&gt;p.mark &amp; BRANCH)
						goto no2;
				if(t-&gt;p.mark &amp; LOAD)
					if(conflict(t, (s+1)))
						goto no2;
				for(u=t+1; u&lt;=s; u++)
					if(depend(u, t))
						goto no2;
				goto out2;
			no2:;
			}
			if(debug['X'])
				Bprint(&amp;bso, "?l%P\n", &amp;s-&gt;p);
			continue;
		out2:
			if(debug['X']) {
				Bprint(&amp;bso, "!l%P\n", &amp;t-&gt;p);
				Bprint(&amp;bso, "%P\n", &amp;s-&gt;p);
			}
			stmp = *t;
			memmove(t, t+1, (uchar*)s - (uchar*)t);
			*s = stmp;
			s--;
			continue;
		}

		/*
		 * fop2 delay.
		 */
		if(s-&gt;p.mark &amp; FCMP) {
			if(s &gt;= se-1)
				continue;
			if(!((s+1)-&gt;p.mark &amp; BRANCH))
				continue;
			/* t is the trial instruction to use */
			for(t=s-1; t&gt;=sch; t--) {
				for(u=t+1; u&lt;=s; u++)
					if(depend(u, t))
						goto no3;
				goto out3;
			no3:;
			}
			if(debug['X'])
				Bprint(&amp;bso, "?f%P\n", &amp;s-&gt;p);
			continue;
		out3:
			if(debug['X']) {
				Bprint(&amp;bso, "!f%P\n", &amp;t-&gt;p);
				Bprint(&amp;bso, "%P\n", &amp;s-&gt;p);
			}
			stmp = *t;
			memmove(t, t+1, (uchar*)s - (uchar*)t);
			*s = stmp;
			s--;
			continue;
		}
	}

	/*
	 * put it all back
	 */
	for(s=sch, p=p0; s&lt;se; s++, p=q) {
		q = p-&gt;link;
		if(q != s-&gt;p.link) {
			*p = s-&gt;p;
			p-&gt;link = q;
		}
	}
	if(debug['X'])
		Bprint(&amp;bso, "\n");
}

void
regused(Sch *s, Prog *realp)
{
	int c, ar, ad, ld, sz, nr, upd;
	ulong m;
	Prog *p;

	p = &amp;s-&gt;p;
	s-&gt;comp = compound(p);
	if(s-&gt;comp) {
		s-&gt;set.ireg |= 1&lt;&lt;REGTMP;
		s-&gt;used.ireg |= 1&lt;&lt;REGTMP;
	}
	ar = 0;		/* dest is really reference */
	ad = 0;		/* source/dest is really address */
	ld = 0;		/* opcode is load instruction */
	sz = 32*4;		/* size of load/store for overlap computation */
	nr = 0;	/* source/dest is not really reg */
	upd = 0;	/* move with update; changes reg */

/*
 * flags based on opcode
 */
	switch(p-&gt;as) {
	case ATEXT:
		curtext = realp;
		autosize = p-&gt;to.offset + 4;
		ad = 1;
		break;
	case ABL:
		s-&gt;set.cc |= E_LR;
		ar = 1;
		ad = 1;
		break;
	case ABR:
		ar = 1;
		ad = 1;
		break;
	case ACMP:
		s-&gt;set.cc |= E_ICC;
		if(p-&gt;reg == 0)
			s-&gt;set.cr |= E_CR0;
		else
			s-&gt;set.cr |= (0xF&lt;&lt;((p-&gt;reg&amp;7)*4));
		ar = 1;
		break;
	case AFCMPO:
	case AFCMPU:
		s-&gt;set.cc |= E_FCC;
		if(p-&gt;reg == 0)
			s-&gt;set.cr |= E_CR0;
		else
			s-&gt;set.cr |= (0xF&lt;&lt;((p-&gt;reg&amp;7)*4));
		ar = 1;
		break;
	case ACRAND:
	case ACRANDN:
	case ACREQV:
	case ACRNAND:
	case ACRNOR:
	case ACROR:
	case ACRORN:
	case ACRXOR:
		s-&gt;used.cr |= 1&lt;&lt;p-&gt;from.reg;
		s-&gt;set.cr |= 1&lt;&lt;p-&gt;to.reg;
		nr = 1;
		break;
	case ABCL:	/* tricky */
		s-&gt;used.cc |= E_FCC|E_ICC;
		s-&gt;used.cr = ALL;
		s-&gt;set.cc |= E_LR;
		ar = 1;
		break;
	case ABC:		/* tricky */
		s-&gt;used.cc |= E_FCC|E_ICC;
		s-&gt;used.cr = ALL;
		ar = 1;
		break;
	case ABEQ:
	case ABGE:
	case ABGT:
	case ABLE:
	case ABLT:
	case ABNE:
	case ABVC:
	case ABVS:
		s-&gt;used.cc |= E_ICC;
		s-&gt;used.cr |= E_CR0;
		ar = 1;
		break;
	case ALSW:
	case AMOVMW:
		/* could do better */
		sz = 32*4;
		ld = 1;
		break;
	case AMOVBU:
	case AMOVBZU:
		upd = 1;
		sz = 1;
		ld = 1;
		break;
	case AMOVB:
	case AMOVBZ:
		sz = 1;
		ld = 1;
		break;
	case AMOVHU:
	case AMOVHZU:
		upd = 1;
		sz = 2;
		ld = 1;
		break;
	case AMOVH:
	case AMOVHBR:
	case AMOVHZ:
		sz = 2;
		ld = 1;
		break;
	case AFMOVSU:
	case AMOVWU:
		upd = 1;
		sz = 4;
		ld = 1;
		break;
	case AFMOVS:
	case AMOVW:
	case AMOVWBR:
	case ALWAR:
		sz = 4;
		ld = 1;
		break;
	case AFMOVDU:
		upd = 1;
		sz = 8;
		ld = 1;
		break;
	case AFMOVD:
		sz = 8;
		ld = 1;
		break;
	case AFMOVDCC:
		sz = 8;
		ld = 1;
		s-&gt;set.cc |= E_FCC;
		s-&gt;set.cr |= E_CR1;
		break;
	case AMOVFL:
	case AMOVCRFS:
	case AMTFSB0:
	case AMTFSB0CC:
	case AMTFSB1:
	case AMTFSB1CC:
		s-&gt;set.ireg = ALL;
		s-&gt;set.freg = ALL;
		s-&gt;set.cc = ALL;
		s-&gt;set.cr = ALL;
		break;
	case AADDCC:
	case AADDVCC:
	case AADDCCC:
	case AADDCVCC:
	case AADDMECC:
	case AADDMEVCC:
	case AADDECC:
	case AADDEVCC:
	case AADDZECC:
	case AADDZEVCC:
	case AANDCC:
	case AANDNCC:
	case ACNTLZWCC:
	case ADIVWCC:
	case ADIVWVCC:
	case ADIVWUCC:
	case ADIVWUVCC:
	case AEQVCC:
	case AEXTSBCC:
	case AEXTSHCC:
	case AMULHWCC:
	case AMULHWUCC:
	case AMULLWCC:
	case AMULLWVCC:
	case ANANDCC:
	case ANEGCC:
	case ANEGVCC:
	case ANORCC:
	case AORCC:
	case AORNCC:
	case AREMCC:
	case AREMVCC:
	case AREMUCC:
	case AREMUVCC:
	case ARLWMICC:
	case ARLWNMCC:
	case ASLWCC:
	case ASRAWCC:
	case ASRWCC:
	case ASTWCCC:
	case ASUBCC:
	case ASUBVCC:
	case ASUBCCC:
	case ASUBCVCC:
	case ASUBMECC:
	case ASUBMEVCC:
	case ASUBECC:
	case ASUBEVCC:
	case ASUBZECC:
	case ASUBZEVCC:
	case AXORCC:
		s-&gt;set.cc |= E_ICC;
		s-&gt;set.cr |= E_CR0;
		break;
	case AFABSCC:
	case AFADDCC:
	case AFADDSCC:
	case AFCTIWCC:
	case AFCTIWZCC:
	case AFDIVCC:
	case AFDIVSCC:
	case AFMADDCC:
	case AFMADDSCC:
	case AFMSUBCC:
	case AFMSUBSCC:
	case AFMULCC:
	case AFMULSCC:
	case AFNABSCC:
	case AFNEGCC:
	case AFNMADDCC:
	case AFNMADDSCC:
	case AFNMSUBCC:
	case AFNMSUBSCC:
	case AFRSPCC:
	case AFSUBCC:
	case AFSUBSCC:
		s-&gt;set.cc |= E_FCC;
		s-&gt;set.cr |= E_CR1;
		break;
	}

/*
 * flags based on 'to' field
 */
	c = p-&gt;to.class;
	if(c == 0) {
		c = aclass(&amp;p-&gt;to) + 1;
		p-&gt;to.class = c;
	}
	c--;
	switch(c) {
	default:
		print("unknown class %d %D\n", c, &amp;p-&gt;to);

	case C_NONE:
	case C_ZCON:
	case C_SCON:
	case C_UCON:
	case C_LCON:
	case C_ADDCON:
	case C_ANDCON:
	case C_SBRA:
	case C_LBRA:
		break;
	case C_CREG:
		c = p-&gt;to.reg;
		if(c == NREG)
			s-&gt;set.cr = ALL;
		else
			s-&gt;set.cr |= (0xF &lt;&lt; ((p-&gt;from.reg&amp;7)*4));
		s-&gt;set.cc = ALL;
		break;
	case C_SPR:
	case C_SREG:
	case C_FPSCR:
	case C_MSR:
	case C_XER:
		s-&gt;set.ireg = ALL;
		s-&gt;set.freg = ALL;
		s-&gt;set.cc = ALL;
		s-&gt;set.cr = ALL;
		break;
	case C_LR:
		s-&gt;set.cc |= E_LR;
		break;
	case C_CTR:
		s-&gt;set.cc |= E_CTR;
		break;
	case C_ZOREG:
	case C_SOREG:
	case C_LOREG:
		c = p-&gt;to.reg;
		s-&gt;used.ireg |= 1&lt;&lt;c;
		if(upd)
			s-&gt;set.ireg |= 1&lt;&lt;c;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;to);

		m = ANYMEM;
		if(c == REGSB)
			m = E_MEMSB;
		if(c == REGSP)
			m = E_MEMSP;

		if(ar)
			s-&gt;used.cc |= m;
		else
			s-&gt;set.cc |= m;
		break;
	case C_SACON:
	case C_LACON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		if(upd)
			s-&gt;set.ireg |= 1&lt;&lt;c;
		break;
	case C_SECON:
	case C_LECON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		if(upd)
			s-&gt;set.ireg |= 1&lt;&lt;c;
		break;
	case C_REG:
		if(nr)
			break;
		if(ar)
			s-&gt;used.ireg |= 1&lt;&lt;p-&gt;to.reg;
		else
			s-&gt;set.ireg |= 1&lt;&lt;p-&gt;to.reg;
		break;
	case C_FREG:
		if(ar)
			s-&gt;used.freg |= 1&lt;&lt;p-&gt;to.reg;
		else
			s-&gt;set.freg |= 1&lt;&lt;p-&gt;to.reg;
		break;
	case C_SAUTO:
	case C_LAUTO:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		if(upd)
			s-&gt;set.ireg |= 1&lt;&lt;c;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;to);

		if(ar)
			s-&gt;used.cc |= E_MEMSP;
		else
			s-&gt;set.cc |= E_MEMSP;
		break;
	case C_SEXT:
	case C_LEXT:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		if(upd)
			s-&gt;set.ireg |= 1&lt;&lt;c;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;to);

		if(ar)
			s-&gt;used.cc |= E_MEMSB;
		else
			s-&gt;set.cc |= E_MEMSB;
		break;
	}

/*
 * flags based on 'from' field
 */
	c = p-&gt;from.class;
	if(c == 0) {
		c = aclass(&amp;p-&gt;from) + 1;
		p-&gt;from.class = c;
	}
	c--;
	switch(c) {
	default:
		print("unknown class %d %D\n", c, &amp;p-&gt;from);

	case C_NONE:
	case C_ZCON:
	case C_SCON:
	case C_UCON:
	case C_LCON:
	case C_ADDCON:
	case C_ANDCON:
	case C_SBRA:
	case C_LBRA:
		c = p-&gt;from.reg;
		if(c != NREG)
			s-&gt;used.ireg |= 1&lt;&lt;c;
		break;
	case C_CREG:
		c = p-&gt;from.reg;
		if(c == NREG)
			s-&gt;used.cr = ALL;
		else
			s-&gt;used.cr |= (0xF &lt;&lt; ((p-&gt;from.reg&amp;7)*4));
		s-&gt;used.cc = ALL;
		break;
	case C_SPR:
	case C_SREG:
	case C_FPSCR:
	case C_MSR:
	case C_XER:
		s-&gt;set.ireg = ALL;
		s-&gt;set.freg = ALL;
		s-&gt;set.cc = ALL;
		s-&gt;set.cr = ALL;
		break;
	case C_LR:
		s-&gt;used.cc |= E_LR;
		break;
	case C_CTR:
		s-&gt;used.cc |= E_CTR;
		break;
	case C_ZOREG:
	case C_SOREG:
	case C_LOREG:
		c = p-&gt;from.reg;
		s-&gt;used.ireg |= 1&lt;&lt;c;
		if(ld)
			p-&gt;mark |= LOAD;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;from);

		m = ANYMEM;
		if(c == REGSB)
			m = E_MEMSB;
		if(c == REGSP)
			m = E_MEMSP;

		s-&gt;used.cc |= m;
		break;
	case C_SACON:
	case C_LACON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		break;
	case C_SECON:
	case C_LECON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		break;
	case C_REG:
		if(nr)
			break;
		s-&gt;used.ireg |= 1&lt;&lt;p-&gt;from.reg;
		break;
	case C_FREG:
		s-&gt;used.freg |= 1&lt;&lt;p-&gt;from.reg;
		break;
	case C_SAUTO:
	case C_LAUTO:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		if(ld)
			p-&gt;mark |= LOAD;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;from);

		s-&gt;used.cc |= E_MEMSP;
		break;
	case C_SEXT:
	case C_LEXT:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		if(ld)
			p-&gt;mark |= LOAD;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;from);

		s-&gt;used.cc |= E_MEMSB;
		break;
	}
	
	c = p-&gt;reg;
	if(c != NREG) {
		if(p-&gt;from.type == D_FREG || p-&gt;to.type == D_FREG)
			s-&gt;used.freg |= 1&lt;&lt;c;
		else
			s-&gt;used.ireg |= 1&lt;&lt;c;
	}
}

/*
 * test to see if 2 instrictions can be
 * interchanged without changing semantics
 */
int
depend(Sch *sa, Sch *sb)
{
	ulong x;

	if(sa-&gt;set.ireg &amp; (sb-&gt;set.ireg|sb-&gt;used.ireg))
		return 1;
	if(sb-&gt;set.ireg &amp; sa-&gt;used.ireg)
		return 1;

	if(sa-&gt;set.freg &amp; (sb-&gt;set.freg|sb-&gt;used.freg))
		return 1;
	if(sb-&gt;set.freg &amp; sa-&gt;used.freg)
		return 1;

	if(sa-&gt;set.cr &amp; (sb-&gt;set.cr|sb-&gt;used.cr))
		return 1;
	if(sb-&gt;set.cr &amp; sa-&gt;used.cr)
		return 1;


	x = (sa-&gt;set.cc &amp; (sb-&gt;set.cc|sb-&gt;used.cc)) |
		(sb-&gt;set.cc &amp; sa-&gt;used.cc);
	if(x) {
		/*
		 * allow SB and SP to pass each other.
		 * allow SB to pass SB iff doffsets are ok
		 * anything else conflicts
		 */
		if(x != E_MEMSP &amp;&amp; x != E_MEMSB)
			return 1;
		x = sa-&gt;set.cc | sb-&gt;set.cc |
			sa-&gt;used.cc | sb-&gt;used.cc;
		if(x &amp; E_MEM)
			return 1;
		if(offoverlap(sa, sb))
			return 1;
	}

	return 0; 
}

int
offoverlap(Sch *sa, Sch *sb)
{

	if(sa-&gt;soffset &lt; sb-&gt;soffset) {
		if(sa-&gt;soffset+sa-&gt;size &gt; sb-&gt;soffset)
			return 1;
		return 0;
	}
	if(sb-&gt;soffset+sb-&gt;size &gt; sa-&gt;soffset)
		return 1;
	return 0;
}

/*
 * test 2 adjacent instructions
 * and find out if inserted instructions
 * are desired to prevent stalls.
 * first instruction is a load instruction.
 */
int
conflict(Sch *sa, Sch *sb)
{

	if(sa-&gt;set.ireg &amp; sb-&gt;used.ireg)
		return 1;
	if(sa-&gt;set.freg &amp; sb-&gt;used.freg)
		return 1;
	if(sa-&gt;set.cr &amp; sb-&gt;used.cr)
		return 1;
	return 0;
}

int
compound(Prog *p)
{
	Optab *o;

	o = oplook(p);
	if(o-&gt;size != 4)
		return 1;
	if(p-&gt;to.type == D_REG &amp;&amp; p-&gt;to.reg == REGSB)
		return 1;
	return 0;
}

void
dumpbits(Sch *s, Dep *d)
{
	int i;

	for(i=0; i&lt;32; i++)
		if(d-&gt;ireg &amp; (1&lt;&lt;i))
			Bprint(&amp;bso, " R%d", i);
	for(i=0; i&lt;32; i++)
		if(d-&gt;freg &amp; (1&lt;&lt;i))
			Bprint(&amp;bso, " F%d", i);
	for(i=0; i&lt;32; i++)
		if(d-&gt;cr &amp; (1&lt;&lt;i))
			Bprint(&amp;bso, " C%d", i);
	for(i=0; i&lt;32; i++)
		switch(d-&gt;cc &amp; (1&lt;&lt;i)) {
		default:
			break;
		case E_ICC:
			Bprint(&amp;bso, " ICC");
			break;
		case E_FCC:
			Bprint(&amp;bso, " FCC");
			break;
		case E_LR:
			Bprint(&amp;bso, " LR");
			break;
		case E_CR:
			Bprint(&amp;bso, " CR");
			break;
		case E_CTR:
			Bprint(&amp;bso, " CTR");
			break;
		case E_XER:
			Bprint(&amp;bso, " XER");
			break;
		case E_MEM:
			Bprint(&amp;bso, " MEM%d", s-&gt;size);
			break;
		case E_MEMSB:
			Bprint(&amp;bso, " SB%d", s-&gt;size);
			break;
		case E_MEMSP:
			Bprint(&amp;bso, " SP%d", s-&gt;size);
			break;
		}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

