<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ratfs/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ratfs/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "ratfs.h"

#define	SRVFILE		"/srv/ratify"
#define MOUNTPOINT	"/mail/ratify"
#define	CTLFILE		"/mail/lib/blocked"
#define	CONFFILE	"/mail/lib/smtpd.conf.ext"

typedef struct Filetree	Filetree;

	/* prototype file tree */
struct	Filetree
{
	int	level;
	char	*name;
	ushort	type;
	int	mode;
	ulong	qid;
};

	/* names of first-level directories - must be in order of level*/
Filetree	filetree[] =
{
	0,	"/",		Directory,	0555|DMDIR,	Qroot,
	1,	"allow",	Addrdir,	0555|DMDIR,	Qallow,
	1,	"delay",	Addrdir,	0555|DMDIR,	Qdelay,
	1,	"block",	Addrdir,	0555|DMDIR,	Qblock,
	1,	"dial",		Addrdir,	0555|DMDIR,	Qdial,
	1,	"deny",		Addrdir,	0555|DMDIR,	Qdeny,
	1,	"trusted",	Trusted,	0777|DMDIR,	Qtrusted,	/* creation allowed */
	1,	"ctl",		Ctlfile,	0222,		Qctl,
	2,	"ip",		IPaddr,		0555|DMDIR,	Qaddr,
	2,	"account",	Acctaddr,	0555|DMDIR,	Qaddr,
	0,	0,		0,		0,		0,
	
};

int	debugfd = -1;
int	trustedqid = Qtrustedfile;
char	*ctlfile =	CTLFILE;
char	*conffile =	CONFFILE;

#pragma	varargck	type	"I"	Cidraddr*

static	int	ipconv(Fmt*);
static	void	post(int, char*);
static	void	setroot(void);

void
usage(void)
{
	fprint(2, "ratfs [-d] [-c conffile] [-f ctlfile] [-m mountpoint]\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	char *mountpoint = MOUNTPOINT;
	int p[2];

	ARGBEGIN {
	case 'c':
		conffile = ARGF();
		break;
	case 'd':
		debugfd = 2;		/* stderr*/
		break;
	case 'f':
		ctlfile = ARGF();
		break;
	case 'm':
		mountpoint = ARGF();
		break;
	} ARGEND
	if(argc != 0)
		usage();

	fmtinstall('I', ipconv);
	setroot();
	getconf();
	reload();

	/* get a pipe and mount it in /srv */
	if(pipe(p) &lt; 0)
		fatal("pipe failed: %r");
	srvfd = p[0];
	post(p[1], mountpoint);

	/* start the 9fs protocol */
	switch(rfork(RFPROC|RFNAMEG|RFENVG|RFFDG|RFNOTEG|RFREND)){
	case -1:
		fatal("fork: %r");
	case 0:
		/* seal off standard input/output */
		close(0);
		open("/dev/null", OREAD);
		close(1);
		open("/dev/null", OWRITE);

		close(p[1]);
		fmtinstall('F', fcallfmt); /* debugging */
		io();
		fprint(2, "ratfs dying\n");
		break;
	default:
		close(p[0]);
		if(mount(p[1], -1, mountpoint, MREPL|MCREATE, "") &lt; 0)
			fatal("mount failed: %r");
	}
	exits(0);
}

static void
setroot(void)
{
	Filetree *fp;
	Node *np;
	int qid;

	root = 0;
	qid = Qaddr;
	for(fp = filetree; fp-&gt;name; fp++) {
		switch(fp-&gt;level) {
		case 0:		/* root */
		case 1:		/* second level directory */
			newnode(root, fp-&gt;name, fp-&gt;type, fp-&gt;mode, fp-&gt;qid);
			break;
		case 2:		/* lay down the Ipaddr and Acctaddr subdirectories */
			for (np = root-&gt;children; np; np = np-&gt;sibs){
				if(np-&gt;d.type == Addrdir)
					newnode(np, fp-&gt;name, fp-&gt;type, fp-&gt;mode, qid++);
			}
			break;
		default:
			fatal("bad filetree");
		}
	}
	dummy.d.type = Dummynode;
	dummy.d.mode = 0444;
	dummy.d.uid = "upas";
	dummy.d.gid = "upas";
	dummy.d.atime = dummy.d.mtime = time(0);
	dummy.d.qid.path = Qdummy;				/* for now */
}

static void
post(int fd, char *mountpoint)
{

	int f;
	char buf[128];

	if(access(SRVFILE,0) &gt;= 0){
		/*
		 * If we can open and mount the /srv node,
		 * another server is already running, so just exit.
		 */
		f = open(SRVFILE, ORDWR);
		if(f &gt;= 0 &amp;&amp; mount(f, -1, mountpoint, MREPL|MCREATE, "") &gt;= 0){
				unmount(0, mountpoint);
				close(f);
				exits(0);
		}
		remove(SRVFILE);
	}

	/*
	 * create the server node and post our pipe to it
	 */
	f = create(SRVFILE, OWRITE, 0666);
	if(f &lt; 0)
		fatal("can't create %s", SRVFILE);

	sprint(buf, "%d", fd);
	if(write(f, buf, strlen(buf)) != strlen(buf))
		fatal("can't write %s", SRVFILE);

	close(f);
}

/*
 *  print message and die
 */
void
fatal(char *fmt, ...)
{
	va_list arg;
	char buf[8*1024];

	va_start(arg, fmt);
	vseprint(buf, buf + (sizeof(buf)-1) / sizeof(*buf), fmt, arg);
	va_end(arg);

	fprint(2, "%s: %s\n", argv0, buf);
	exits(buf);
}

/*
 *  create a new directory node
 */
Node*
newnode(Node *parent, char *name, ushort type, int mode, ulong qid)
{
	Node *np;

	np = mallocz(sizeof(Node), 1);
	if(np == 0)
		fatal("out of memory");
	np-&gt;d.name = atom(name);
	np-&gt;d.type = type;
	np-&gt;d.mode = mode;
	np-&gt;d.mtime = np-&gt;d.atime = time(0);
	np-&gt;d.uid = atom("upas");
	np-&gt;d.gid = atom("upas");
	np-&gt;d.muid = atom("upas");
	if(np-&gt;d.mode&amp;DMDIR)
		np-&gt;d.qid.type = QTDIR;
	np-&gt;d.qid.path = qid;
	np-&gt;d.qid.vers = 0;
	if(parent){
		np-&gt;parent = parent;
		np-&gt;sibs = parent-&gt;children;
		parent-&gt;children = np;
		parent-&gt;count++;
	} else {
		/* the root node */
		root = np;
		np-&gt;parent = np;
		np-&gt;children = 0;
		np-&gt;sibs = 0;
	}
	return np;
}

void
printnode(Node *np)
{
	fprint(debugfd, "Node at %p: %s (%s %s)", np, np-&gt;d.name, np-&gt;d.uid, np-&gt;d.gid);
	if(np-&gt;d.qid.type&amp;QTDIR)
		fprint(debugfd, " QTDIR");
	fprint(debugfd, "\n");
	fprint(debugfd,"\tQID: %llud.%lud Mode: %lo Type: %d\n", np-&gt;d.qid.path,
			np-&gt;d.qid.vers, np-&gt;d.mode, np-&gt;d.type);
	fprint(debugfd, "\tMod: %.15s  Acc: %.15s Count: %d\n", ctime(np-&gt;d.mtime)+4,
			ctime(np-&gt;d.atime)+4, np-&gt;count);
	switch(np-&gt;d.type)
	{
	case Directory:
		fprint(debugfd, "\tDirectory Child: %p", np-&gt;children);
		break;
	case Addrdir:
		fprint(debugfd, "\tAddrdir Child: %p", np-&gt;children);
		break;
	case IPaddr:
		fprint(debugfd, "\tIPaddr Base: %p Alloc: %d BaseQid %lud", np-&gt;addrs,
			np-&gt;allocated, np-&gt;baseqid);
		break;
	case Acctaddr:
		fprint(debugfd, "\tAcctaddr Base: %p Alloc: %d BaseQid %lud", np-&gt;addrs,
			np-&gt;allocated, np-&gt;baseqid);
		break;
	case Trusted:
		fprint(debugfd, "\tTrusted Child: %p", np-&gt;children);
		break;
	case Trustedperm:
		fprint(debugfd, "\tPerm Trustedfile: %I", &amp;np-&gt;ip);
		break;
	case Trustedtemp:
		fprint(debugfd, "\tTemp Trustedfile: %I", &amp;np-&gt;ip);
		break;
	case Ctlfile:
		fprint(debugfd, "\tCtlfile");
		break;
	case Dummynode:
		fprint(debugfd, "\tDummynode");
		break;
	default:
		fprint(debugfd, "\tUnknown Node Type\n\n");
		return;
	}
	fprint(debugfd, " Parent %p Sib: %p\n\n", np-&gt;parent, np-&gt;sibs);
}

void
printfid(Fid *fp)
{
	fprint(debugfd, "FID: %d (%s %s) Busy: %d Open: %d\n", fp-&gt;fid, fp-&gt;name,
		fp-&gt;uid, fp-&gt;busy, fp-&gt;open);
	printnode(fp-&gt;node);
}

void
printtree(Node *np)
{
	printnode(np);
	if(np-&gt;d.type == IPaddr
		|| np-&gt;d.type == Acctaddr
		|| np-&gt;d.type == Trustedperm
		|| np-&gt;d.type == Trustedtemp)
			return;
	for (np = np-&gt;children; np; np = np-&gt;sibs)
		printtree(np);
}

static int
ipconv(Fmt *f)
{
	Cidraddr *ip;
	int i, j;
	char *p;

	ip = va_arg(f-&gt;args, Cidraddr*);
	p = (char*)&amp;ip-&gt;ipaddr;
	i = 0;
	for (j = ip-&gt;mask; j; j &lt;&lt;= 1)
		i++;
	return fmtprint(f, "%d.%d.%d.%d/%d", p[3]&amp;0xff, p[2]&amp;0xff, p[1]&amp;0xff, p[0]&amp;0xff, i);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

