<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ratfs/misc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ratfs/misc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "ratfs.h"
#include &lt;ip.h&gt;

enum {
	Maxdoms	=	10,		/* max domains in a path */
	Timeout =	2*60*60,	/* seconds until temporarily trusted addr times out */
};

static	int	accountmatch(char*, char**, int, char*);
static	Node*	acctwalk(char*,  Node*);
static	int	dommatch(char*, char*);
static	Address* ipsearch(ulong, Address*, int);
static	Node*	ipwalk(char*,  Node*);
static	Node*	trwalk(char*, Node*);
static	int	usermatch(char*, char*);

/*
 *	Do a walk
 */
char*
walk(char *name, Fid *fidp)
{
	Node *np;

	if((fidp-&gt;node-&gt;d.mode &amp; DMDIR) == 0)
		return "not a directory";

	if(strcmp(name, ".") == 0)
		return 0;
	if(strcmp(name, "..") == 0){
		fidp-&gt;node = fidp-&gt;node-&gt;parent;
		fidp-&gt;name = 0;
		return 0;
	}

	switch(fidp-&gt;node-&gt;d.type){
	case Directory:
	case Addrdir:
		np = dirwalk(name, fidp-&gt;node);
		break;
	case Trusted:
		np = trwalk(name, fidp-&gt;node);
		break;
	case IPaddr:
		np = ipwalk(name, fidp-&gt;node);
		break;
	case Acctaddr:
		np = acctwalk(name, fidp-&gt;node);
		break;
	default:
		return "directory botch in walk";
	}
	if(np) {
		fidp-&gt;node = np;
		fidp-&gt;name = np-&gt;d.name;
		return 0;
	}
	return "file does not exist";
}

/*
 *	Walk to a subdirectory
 */
Node*
dirwalk(char *name, Node *np)
{
	Node *p;

	for(p = np-&gt;children; p; p = p-&gt;sibs)
		if(strcmp(name, p-&gt;d.name) == 0)
			break;
	return p;
}

/*
 *	Walk the directory of trusted files
 */
static Node*
trwalk(char *name, Node *np)
{
	Node *p;
	ulong peerip;
	uchar addr[IPv4addrlen];

	v4parseip(addr, name);
	peerip = nhgetl(addr);

	for(p = np-&gt;children; p; p = p-&gt;sibs)
		if((peerip&amp;p-&gt;ip.mask) == p-&gt;ip.ipaddr)
			break;
	return p;
}

/*
 *	Walk a directory of IP addresses
 */
static Node*
ipwalk(char *name,  Node *np)
{
	Address *ap;
	ulong peerip;
	uchar addr[IPv4addrlen];

	v4parseip(addr, name);
	peerip = nhgetl(addr);

	if(debugfd &gt;= 0)
		fprint(debugfd, "%d.%d.%d.%d - ", addr[0]&amp;0xff, addr[1]&amp;0xff,
				addr[2]&amp;0xff, addr[3]&amp;0xff);
	ap = ipsearch(peerip, np-&gt;addrs, np-&gt;count);
	if(ap == 0)
		return 0;

	dummy.d.name = ap-&gt;name;
	return &amp;dummy;
}

/*
 *	Walk a directory of account names
 */
static Node*
acctwalk(char *name, Node *np)
{
	int i, n;
	Address *ap;
	char *p, *cp, *user;
	char buf[512];
	char *doms[Maxdoms];

	strecpy(buf, buf+sizeof buf, name);
	subslash(buf);

	p = buf;
	for(n = 0; n &lt; Maxdoms; n++) {
		cp = strchr(p, '!');
		if(cp == 0)
			break;
		*cp = 0;
		doms[n] = p;
		p = cp+1;
	}
	user = p;

	for(i = 0; i &lt; np-&gt;count; i++){
		ap = &amp;np-&gt;addrs[i];
		if (accountmatch(ap-&gt;name, doms, n, user)) {
			dummy.d.name = ap-&gt;name;
			return &amp;dummy;
		}
	}
	return 0;
}

/*
 * binary search sorted IP address list
 */

static Address*
ipsearch(ulong addr, Address *base, int n)
{
	ulong top, bot, mid;
	Address *ap;

	bot = 0;
	top = n;
	for (mid = (bot+top)/2; mid &lt; top; mid = (bot+top)/2) {
		ap = &amp;base[mid];
		if((addr&amp;ap-&gt;ip.mask) == ap-&gt;ip.ipaddr)
			return ap;
		if(addr &lt; ap-&gt;ip.ipaddr)
			top = mid;
		else if(mid != n-1 &amp;&amp; addr &gt;= base[mid+1].ip.ipaddr)
			bot = mid;
		else
			break;
	}
	return 0;
}

/*
 *	Read a directory
 */
int
dread(Fid *fidp, int cnt)
{
	uchar *q, *eq, *oq;
	int n, skip;
	Node *np;

	if(debugfd &gt;= 0)
		fprint(debugfd, "dread %d\n", cnt);

	np = fidp-&gt;node;
	oq = q = rbuf+IOHDRSZ;
	eq = q+cnt;
	if(fidp-&gt;dirindex &gt;= np-&gt;count)
		return 0;

	skip = fidp-&gt;dirindex;
	for(np = np-&gt;children; skip &gt; 0 &amp;&amp; np; np = np-&gt;sibs)
		skip--;
	if(np == 0)
		return 0;

	for(; q &lt; eq &amp;&amp; np; np = np-&gt;sibs){
		if(debugfd &gt;= 0)
			printnode(np);
		if((n=convD2M(&amp;np-&gt;d, q, eq-q)) &lt;= BIT16SZ)
			break;
		q += n;
		fidp-&gt;dirindex++;
	}
	return q - oq;
}

/*
 *	Read a directory of IP addresses or account names
 */
int
hread(Fid *fidp, int cnt)
{
	uchar *q, *eq, *oq;
	int i, n, path;
	Address *p;
	Node *np;

	if(debugfd &gt;= 0)
		fprint(debugfd, "hread %d\n", cnt);

	np = fidp-&gt;node;
	oq = q = rbuf+IOHDRSZ;
	eq = q+cnt;
	if(fidp-&gt;dirindex &gt;= np-&gt;count)
		return 0;

	path = np-&gt;baseqid;
	for(i = fidp-&gt;dirindex; q &lt; eq &amp;&amp; i &lt; np-&gt;count; i++){
		p = &amp;np-&gt;addrs[i];
		dummy.d.name = p-&gt;name;
		dummy.d.qid.path = path++;
		if((n=convD2M(&amp;dummy.d, q, eq-q)) &lt;= BIT16SZ)
			break;
		q += n;
	}
	fidp-&gt;dirindex = i;
	return q - oq;
}

/*
 *	Find a directory node by type
 */
Node*
finddir(int type)
{
	Node *np;

	for(np = root-&gt;children; np; np = np-&gt;sibs)
		if (np-&gt;d.type == type)
			return np;
	return 0;
}

/*
 *	Remove temporary pseudo-files that have timed-out
 *	from the trusted directory
 */
void
cleantrusted(void)
{
	Node *np, **l;
	ulong t;

	np = finddir(Trusted);
	if (np == 0)
		return;

	t = time(0)-Timeout;
	l = &amp;np-&gt;children;
	for (np = np-&gt;children; np; np = *l) {
		if(np-&gt;d.type == Trustedtemp &amp;&amp; t &gt;= np-&gt;d.mtime) {
			*l = np-&gt;sibs;
			if(debugfd &gt;= 0)
				fprint(debugfd, "Deleting %s\n", np-&gt;d.name);
			np-&gt;parent-&gt;count--;
			free(np);
		} else
			l = &amp;np-&gt;sibs;
	}
}

/*
 * match path components to prohibited domain &amp; user specifications.  patterns include:
 *	domain, domain! or domain!*	  - all users in domain
 *	*.domain, *.domain! or *.domain!* - all users in domain and its subdomains
 *	!user or *!user			  - user in all domains
 *	domain!user			  - user in domain
 *	*.domain!user			  - user in domain and its subdomains
 *
 *	if "user" has a trailing '*', it matches all user names beginning with "user"
 *
 * there are special semantics for the "domain, domain! or domain!*" specifications:
 * the first two forms match when the domain is anywhere in at list of source-routed
 * domains while the latter matches only when the domain is the last hop.  the same is
 * true for the *.domain!* form of the pattern.
 */
static int
accountmatch(char *spec, char **doms, int ndoms, char *user)
{
	char *cp, *userp;
	int i, ret;

	userp = 0;
	ret = 0;
	cp = strchr(spec, '!');
	if(cp){
		*cp++ = 0;		/* restored below */
		if(*cp)
		if(strcmp(cp, "*"))	/* "!*" is the same as no user field */
			userp = cp;	/* there is a user name */
	}

	if(userp == 0){			/* no user field - domain match only */
		for(i = 0; i &lt; ndoms &amp;&amp; doms[i]; i++)
			if(dommatch(doms[i], spec) == 0)
				ret = 1;
	} else {
		/* check for "!user", "*!user" or "domain!user" */
		if(usermatch(user, userp) == 0){
			if(*spec == 0 || strcmp(spec, "*") == 0)
				ret = 1;
			else if(ndoms &gt; 0  &amp;&amp; dommatch(doms[ndoms-1], spec) == 0)
				ret = 1;
		}
	}
	if(cp)
		cp[-1] = '!';
	return ret;
}

/*
 *	match a user name.  the only meta-char is '*' which matches all
 *	characters.  we only allow it as "*", which matches anything or
 *	an * at the end of the name (e.g., "username*") which matches
 *	trailing characters.
 */
static int
usermatch(char *pathuser, char *specuser)
{
	int n;

	n = strlen(specuser)-1;
	if(specuser[n] == '*'){
		if(n == 0)		/* match everything */
			return 0;
		return strncmp(pathuser, specuser, n);
	}
	return strcmp(pathuser, specuser);
}

/*
 *	Match a domain specification
 */
static int
dommatch(char *pathdom, char *specdom)
{
	int n;

	if (*specdom == '*'){
		if (specdom[1] == '.' &amp;&amp; specdom[2]){
			specdom += 2;
			n = strlen(pathdom)-strlen(specdom);
			if(n == 0 || (n &gt; 0 &amp;&amp; pathdom[n-1] == '.'))
				return strcmp(pathdom+n, specdom);
			return n;
		}
	}
	return strcmp(pathdom, specdom);
}

/*
 *	Custom allocators to avoid malloc overheads on small objects.
 * 	We never free these.  (See below.)
 */
typedef struct Stringtab	Stringtab;
struct Stringtab {
	Stringtab *link;
	char *str;
};
static Stringtab*
taballoc(void)
{
	static Stringtab *t;
	static uint nt;

	if(nt == 0){
		t = malloc(64*sizeof(Stringtab));
		if(t == 0)
			fatal("out of memory");
		nt = 64;
	}
	nt--;
	return t++;
}

static char*
xstrdup(char *s)
{
	char *r;
	int len;
	static char *t;
	static int nt;

	len = strlen(s)+1;
	if(len &gt;= 8192)
		fatal("strdup big string");

	if(nt &lt; len){
		t = malloc(8192);
		if(t == 0)
			fatal("out of memory");
		nt = 8192;
	}
	r = t;
	t += len;
	nt -= len;
	strcpy(r, s);
	return r;
}

/*
 *	Return a uniquely allocated copy of a string.
 *	Don't free these -- they stay in the table for the 
 *	next caller who wants that particular string.
 *	String comparison can be done with pointer comparison 
 *	if you know both strings are atoms.
 */
static Stringtab *stab[1024];

static uint
hash(char *s)
{
	uint h;
	uchar *p;

	h = 0;
	for(p=(uchar*)s; *p; p++)
		h = h*37 + *p;
	return h;
}

char*
atom(char *str)
{
	uint h;
	Stringtab *tab;
	
	h = hash(str) % nelem(stab);
	for(tab=stab[h]; tab; tab=tab-&gt;link)
		if(strcmp(str, tab-&gt;str) == 0)
			return tab-&gt;str;

	tab = taballoc();
	tab-&gt;str = xstrdup(str);
	tab-&gt;link = stab[h];
	stab[h] = tab;
	return tab-&gt;str;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

