<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ratfs/ratfs.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ratfs/ratfs.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;

enum {
	MAXRPC = 8192,

	Qroot = 1,		/* fixed QID's */
	Qallow,
	Qdelay,
	Qblock,
	Qdial,
	Qdeny,
	Qtrusted,
	Qctl,
	Qdummy,
	Qaddr,			/* Qid's for "ip" &amp; "account" subdirs (Qaddr-99) */

	Qtrustedfile = 100,	/* Qid's for trusted files (100-999)*/
	Qaddrfile   = 1000,	/* Qid's for address files (&gt; 1000) */

				/* type codes in node.d.type */
	Directory =	0,	/* normal directory */
	Addrdir,		/* contains "ip" and "account" directories */
	IPaddr,			/* contains IP address "files" */
	Acctaddr,		/* contains Account address "files" */
	Trusted,		/* contains trusted IP files */
	Trustedperm,		/* permanently trusted IP pseudo-file */
	Trustedtemp,		/* temporarily trusted IP pseudo-file */
	Ctlfile,		/* ctl file under root */
	Dummynode,		/* place holder for Address pseudo-files */
};

typedef struct Fid	Fid;
typedef struct Node	Node;
typedef	struct Address	Address;
typedef struct Cidraddr	Cidraddr;
typedef struct Keyword	Keyword;

	/* an active fid */
struct Fid
{
	int	fid;
	int	dirindex;
	Node	*node;		/* current position in path */
	int	busy;
	int	open;		/* directories only */
	char	*name;
	char *uid;
	Fid	*next;
};

struct	Cidraddr
{
	ulong	ipaddr;		/* CIDR base addr */
	ulong	mask;		/* CIDR mask */
};

	/* an address is either an account name (domain!user) or Ip address */
struct	Address
{
	char	*name;		/* from the control file */
	Cidraddr ip;		/* CIDR Address */
};

/* Fids point to either a directory or pseudo-file */
struct Node
{
	Dir	d;		/* d.name, d.uid, d.gid, d.muid are atoms */
	int	count;
	int	allocated;	/* number of Address structs allocated */
	ulong	baseqid;	/* base of Qid's in this set */
	Node	*parent;	/* points to self in root node*/
	Node	*sibs;		/* 0 in Ipaddr and Acctaddr dirs */
	union {
		Node	*children;	/* type == Directory || Addrdir || Trusted */
		Address	*addrs;		/* type == Ipaddr || Acctaddr */
		Cidraddr ip;		/* type == Trustedfile */
	};
};

struct Keyword {
	char	*name;
	int	code;
};

Node	*root;			/* root of directory tree */
Node	dummy;			/* dummy node for fid's pointing to an Address */
int	srvfd;			/* fd for 9fs */
uchar rbuf[IOHDRSZ+MAXRPC+1];
int	debugfd;
char	*ctlfile;
char	*conffile;
long	lastconftime;
long	lastctltime;
int	trustedqid;

char*	atom(char*);
void	cidrparse(Cidraddr*, char*);
void	cleantrusted(void);
Node*	dirwalk(char*, Node*);
int	dread(Fid*, int);
void	fatal(char*, ...);
Node*	finddir(int);
int	findkey(char*, Keyword*);
void	getconf(void);
int	hread(Fid*, int);
void	io(void);
Node*	newnode(Node*, char*, ushort, int, ulong);
void	printfid(Fid*);
void	printnode(Node*);
void	printtree(Node*);
void	reload(void);
char*	subslash(char*);
char*	walk(char*, Fid*);

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

