<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rc/io.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rc/io.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "rc.h"
#include "exec.h"
#include "io.h"
#include "fns.h"

enum { Stralloc = 100, };

int pfmtnest = 0;

void
pfmt(io *f, char *fmt, ...)
{
	va_list ap;
	char err[ERRMAX];

	va_start(ap, fmt);
	pfmtnest++;
	for(;*fmt;fmt++) {
		if(*fmt!='%') {
			pchr(f, *fmt);
			continue;
		}
		if(*++fmt == '\0')		/* "blah%"? */
			break;
		switch(*fmt){
		case 'c':
			pchr(f, va_arg(ap, int));
			break;
		case 'd':
			pdec(f, va_arg(ap, int));
			break;
		case 'o':
			poct(f, va_arg(ap, unsigned));
			break;
		case 'p':
			pptr(f, va_arg(ap, void*));
			break;
		case 'Q':
			pquo(f, va_arg(ap, char *));
			break;
		case 'q':
			pwrd(f, va_arg(ap, char *));
			break;
		case 'r':
			errstr(err, sizeof err); pstr(f, err);
			break;
		case 's':
			pstr(f, va_arg(ap, char *));
			break;
		case 't':
			pcmd(f, va_arg(ap, struct tree *));
			break;
		case 'v':
			pval(f, va_arg(ap, struct word *));
			break;
		default:
			pchr(f, *fmt);
			break;
		}
	}
	va_end(ap);
	if(--pfmtnest==0)
		flush(f);
}

void
pchr(io *b, int c)
{
	if(b-&gt;bufp==b-&gt;ebuf)
		fullbuf(b, c);
	else *b-&gt;bufp++=c;
}

int
rchr(io *b)
{
	if(b-&gt;bufp==b-&gt;ebuf)
		return emptybuf(b);
	return *b-&gt;bufp++;
}

int
rutf(io *b, char *buf, Rune *r)
{
	int n, i, c;

	c = rchr(b);
	if(c == EOF)
		return EOF;
	*buf = c;
	if(c &lt; Runesync){
		*r = c;
		return 1;
	}
	for(i = 1; (c = rchr(b)) != EOF; ){
		buf[i++] = c;
		buf[i] = 0;
		if(fullrune(buf, i)){
			n = chartorune(r, buf);
			b-&gt;bufp -= i - n;	/* push back unconsumed bytes */
			assert(b-&gt;fd == -1 || b-&gt;bufp &gt; b-&gt;buf);
			return n;
		}
	}
	/* at eof */
	b-&gt;bufp -= i - 1;			/* consume 1 byte */
	*r = Runeerror;
	return runetochar(buf, r);
}

void
pquo(io *f, char *s)
{
	pchr(f, '\'');
	for(;*s;s++)
		if(*s=='\'')
			pfmt(f, "''");
		else pchr(f, *s);
	pchr(f, '\'');
}

void
pwrd(io *f, char *s)
{
	char *t;
	for(t = s;*t;t++) if(*t &gt;= 0 &amp;&amp; needsrcquote(*t)) break;
	if(t==s || *t)
		pquo(f, s);
	else pstr(f, s);
}

void
pptr(io *f, void *v)
{
	int n;
	uintptr p;

	p = (uintptr)v;
	if(sizeof(uintptr) == sizeof(uvlong) &amp;&amp; p&gt;&gt;32)
		for(n = 60;n&gt;=32;n-=4) pchr(f, "0123456789ABCDEF"[(p&gt;&gt;n)&amp;0xF]);

	for(n = 28;n&gt;=0;n-=4) pchr(f, "0123456789ABCDEF"[(p&gt;&gt;n)&amp;0xF]);
}

void
pstr(io *f, char *s)
{
	if(s==0)
		s="(null)";
	while(*s) pchr(f, *s++);
}

void
pdec(io *f, int n)
{
	if(n&lt;0){
		n=-n;
		if(n&gt;=0){
			pchr(f, '-');
			pdec(f, n);
			return;
		}
		/* n is two's complement minimum integer */
		n = 1-n;
		pchr(f, '-');
		pdec(f, n/10);
		pchr(f, n%10+'1');
		return;
	}
	if(n&gt;9)
		pdec(f, n/10);
	pchr(f, n%10+'0');
}

void
poct(io *f, unsigned n)
{
	if(n&gt;7)
		poct(f, n&gt;&gt;3);
	pchr(f, (n&amp;7)+'0');
}

void
pval(io *f, word *a)
{
	if(a){
		while(a-&gt;next &amp;&amp; a-&gt;next-&gt;word){
			pwrd(f, (char *)a-&gt;word);
			pchr(f, ' ');
			a = a-&gt;next;
		}
		pwrd(f, (char *)a-&gt;word);
	}
}

int
fullbuf(io *f, int c)
{
	flush(f);
	return *f-&gt;bufp++=c;
}

void
flush(io *f)
{
	int n;

	if(f-&gt;strp){
		n = f-&gt;ebuf - f-&gt;strp;
		f-&gt;strp = realloc(f-&gt;strp, n+Stralloc+1);
		if(f-&gt;strp==0)
			panic("Can't realloc %d bytes in flush!", n+Stralloc+1);
		f-&gt;bufp = f-&gt;strp + n;
		f-&gt;ebuf = f-&gt;bufp + Stralloc;
		memset(f-&gt;bufp, '\0', Stralloc+1);
	}
	else{
		n = f-&gt;bufp-f-&gt;buf;
		if(n &amp;&amp; Write(f-&gt;fd, f-&gt;buf, n) != n){
			Write(2, "Write error\n", 12);
			if(ntrap)
				dotrap();
		}
		f-&gt;bufp = f-&gt;buf;
		f-&gt;ebuf = f-&gt;buf+NBUF;
	}
}

io*
openfd(int fd)
{
	io *f = new(struct io);
	f-&gt;fd = fd;
	f-&gt;bufp = f-&gt;ebuf = f-&gt;buf;
	f-&gt;strp = 0;
	return f;
}

io*
openstr(void)
{
	io *f = new(struct io);

	f-&gt;fd = -1;
	f-&gt;bufp = f-&gt;strp = emalloc(Stralloc+1);
	f-&gt;ebuf = f-&gt;bufp + Stralloc;
	memset(f-&gt;bufp, '\0', Stralloc+1);
	return f;
}
/*
 * Open a corebuffer to read.  EOF occurs after reading len
 * characters from buf.
 */

io*
opencore(char *s, int len)
{
	io *f = new(struct io);
	uchar *buf = emalloc(len);

	f-&gt;fd = -1 /*open("/dev/null", 0)*/;
	f-&gt;bufp = f-&gt;strp = buf;
	f-&gt;ebuf = buf+len;
	Memcpy(buf, s, len);
	return f;
}

void
rewind(io *io)
{
	if(io-&gt;fd==-1)
		io-&gt;bufp = io-&gt;strp;
	else{
		io-&gt;bufp = io-&gt;ebuf = io-&gt;buf;
		Seek(io-&gt;fd, 0L, 0);
	}
}

void
closeio(io *io)
{
	if(io-&gt;fd&gt;=0)
		close(io-&gt;fd);
	if(io-&gt;strp)
		efree(io-&gt;strp);
	efree(io);
}

int
emptybuf(io *f)
{
	int n;
	if(f-&gt;fd==-1 || (n = Read(f-&gt;fd, f-&gt;buf, NBUF))&lt;=0) return EOF;
	f-&gt;bufp = f-&gt;buf;
	f-&gt;ebuf = f-&gt;buf + n;
	return *f-&gt;bufp++;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

