<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rdbfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rdbfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Remote debugging file system
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

int dbg = 0;
#define DBG	if(dbg)fprint

enum {
	NHASH = 4096,
	Readlen = 4,
	Pagequantum = 1024,
};

/* caching memory pages: a lot of space to avoid serial communications */
Lock pglock;
typedef struct	Page	Page;
struct Page {	/* cached memory contents */
	Page *link;
	ulong len;
	ulong addr;
	int count;
	uchar val[Readlen];
};

Page *pgtab[NHASH];

Page *freelist;

/* called with pglock locked */
Page*
newpg(void)
{
	int i;
	Page *p, *q;

	if(freelist == nil){
		p = malloc(sizeof(Page)*Pagequantum);
		if(p == nil)
			sysfatal("out of memory");

		for(i=0, q=p; i&lt;Pagequantum-1; i++, q++)
			q-&gt;link = q+1;
		q-&gt;link = nil;

		freelist = p;
	}
	p = freelist;
	freelist = freelist-&gt;link;
	return p;
}

#define PHIINV 0.61803398874989484820
uint
ahash(ulong addr)
{
	return (uint)floor(NHASH*fmod(addr*PHIINV, 1.0));
}

int
lookup(ulong addr, uchar *val, ulong count)
{
	Page *p;

	lock(&amp;pglock);
	for(p=pgtab[ahash(addr)]; p; p=p-&gt;link){
		if(p-&gt;addr == addr &amp;&amp; p-&gt;count == count){
			memmove(val, p-&gt;val, count);
			unlock(&amp;pglock);
			return 1;
		}
	}
	unlock(&amp;pglock);
	return 0;
}

void
insert(ulong addr, uchar *val, int count)
{
	Page *p;
	uint h;

	lock(&amp;pglock);
	p = newpg();
	p-&gt;addr = addr;
	p-&gt;count = count;
	memmove(p-&gt;val, val, count);
	h = ahash(addr);
	p-&gt;link = pgtab[h];
	p-&gt;len = pgtab[h] ? pgtab[h]-&gt;len+1 : 1;
	pgtab[h] = p;
	unlock(&amp;pglock);
}

void
flushcache(void)
{
	int i;
	Page *p;

	lock(&amp;pglock);
	for(i=0; i&lt;NHASH; i++){
		if(p=pgtab[i]){
			for(;p-&gt;link; p=p-&gt;link)
				;
			p-&gt;link = freelist;
			freelist = p;
		}
		pgtab[i] = nil;
	}
	unlock(&amp;pglock);
}

enum
{
	Xctl	= 1,
	Xfpregs,
	Xkregs,
	Xmem,
	Xproc,
	Xregs,
	Xtext,
	Xstatus,

};

int	textfd;
int	rfd;
Biobuf	rfb;
char*	portname = "/dev/eia0";
char*	textfile = "/386/9pc";
char*	procname = "1";
char*	srvname;
Channel* rchan;

void
usage(void)
{
	fprint(2, "usage: rdbfs [-p procnum] [-s srvname] [-t textfile] [serialport]\n");
	exits("usage");
}

void
noalarm(void*, char *msg)
{
	if(strstr(msg, "alarm"))
		noted(NCONT);
	noted(NDFLT);
}

/*
 * 	send and receive responses on the serial line
 */
void
eiaread(void*)
{
	Req *r;
	char *p;
	uchar *data;
	char err[ERRMAX];
	char buf[1000];
	int i, tries;

	notify(noalarm);
	while(r = recvp(rchan)){
		DBG(2, "got %F: here goes...", &amp;r-&gt;ifcall);
		if(r-&gt;ifcall.count &gt; Readlen)
			r-&gt;ifcall.count = Readlen;
		r-&gt;ofcall.count = r-&gt;ifcall.count;
		if(r-&gt;type == Tread &amp;&amp; lookup(r-&gt;ifcall.offset, (uchar*)r-&gt;ofcall.data, r-&gt;ofcall.count)){
			respond(r, nil);
			continue;
		}
		for(tries=0; tries&lt;5; tries++){
			if(r-&gt;type == Twrite){
				DBG(2, "w%.8lux %.8lux...", (ulong)r-&gt;ifcall.offset, *(ulong*)r-&gt;ifcall.data);
				fprint(rfd, "w%.8lux %.8lux\n", (ulong)r-&gt;ifcall.offset, *(ulong*)r-&gt;ifcall.data);
			}else if(r-&gt;type == Tread){
				DBG(2, "r%.8lux...", (ulong)r-&gt;ifcall.offset);
				fprint(rfd, "r%.8lux\n", (ulong)r-&gt;ifcall.offset);
			}else{
				respond(r, "oops");
				break;
			}
			for(;;){
				werrstr("");
				alarm(500);
				p=Brdline(&amp;rfb, '\n');
				alarm(0);
				if(p == nil){
					rerrstr(err, sizeof err);
					DBG(2, "error %s\n", err);
					if(strstr(err, "alarm") || strstr(err, "interrupted"))
						break;
					if(Blinelen(&amp;rfb) == 0) // true eof
						sysfatal("eof on serial line?");
					Bread(&amp;rfb, buf, Blinelen(&amp;rfb)&lt;sizeof buf ? Blinelen(&amp;rfb) : sizeof buf);
					continue;
				}
				p[Blinelen(&amp;rfb)-1] = 0;
				if(p[0] == '\r')
					p++;
				DBG(2, "serial %s\n", p);
				if(p[0] == 'R'){
					if(strtoul(p+1, 0, 16) == (ulong)r-&gt;ifcall.offset){
						/* we know that data can handle Readlen bytes */
						data = (uchar*)r-&gt;ofcall.data;
						for(i=0; i&lt;r-&gt;ifcall.count; i++)
							data[i] = strtol(p+1+8+1+3*i, 0, 16);
						insert(r-&gt;ifcall.offset, data, r-&gt;ifcall.count);
						respond(r, nil);
						goto Break2;
					}else
						DBG(2, "%.8lux ≠ %.8lux\n", strtoul(p+1, 0, 16), (ulong)r-&gt;ifcall.offset);
				}else if(p[0] == 'W'){
					respond(r, nil);
					goto Break2;
				}else{
					DBG(2, "unknown message\n");
				}
			}
		}
	Break2:;
	}
}

void
attachremote(char* name)
{
	int fd;
	char buf[128];

	print("attach %s\n", name);
	rfd = open(name, ORDWR);
	if(rfd &lt; 0)
		sysfatal("can't open remote %s", name);

	sprint(buf, "%sctl", name);
	fd = open(buf, OWRITE);
	if(fd &lt; 0)
		sysfatal("can't set baud rate on %s", buf);
	write(fd, "B9600", 6);
	close(fd);
	Binit(&amp;rfb, rfd, OREAD);
}

void
fsopen(Req *r)
{
	char buf[ERRMAX];

	switch((uintptr)r-&gt;fid-&gt;file-&gt;aux){
	case Xtext:
		close(textfd);
		textfd = open(textfile, OREAD);
		if(textfd &lt; 0) {
			snprint(buf, sizeof buf, "text: %r");
			respond(r, buf);
			return;
		}
		break;
	}		
	respond(r, nil);
}

void
fsread(Req *r)
{
	int i, n;
	char buf[512];

	switch((uintptr)r-&gt;fid-&gt;file-&gt;aux) {
	case Xfpregs:
	case Xproc:
	case Xregs:
		respond(r, "Egreg");
		break;
	case Xkregs:
	case Xmem:
		if(sendp(rchan, r) != 1){
			snprint(buf, sizeof buf, "rdbfs sendp: %r");
			respond(r, buf);
			return;
		}
		break;
	case Xtext:
		n = pread(textfd, r-&gt;ofcall.data, r-&gt;ifcall.count, r-&gt;ifcall.offset);
		if(n &lt; 0) {
			rerrstr(buf, sizeof buf);
			respond(r, buf);
			break;
		}
		r-&gt;ofcall.count = n;
		respond(r, nil);
		break;
	case Xstatus:
		n = sprint(buf, "%-28s%-28s%-28s", "remote", "system", "New");
		for(i = 0; i &lt; 9; i++)
			n += sprint(buf+n, "%-12d", 0);
		readstr(r, buf);
		respond(r, nil);
		break;
	default:
		respond(r, "unknown read");
	}
}

void
fswrite(Req *r)
{
	char buf[ERRMAX];

	switch((uintptr)r-&gt;fid-&gt;file-&gt;aux) {
	case Xctl:
		if(strncmp(r-&gt;ifcall.data, "kill", 4) == 0 ||
		   strncmp(r-&gt;ifcall.data, "exit", 4) == 0) {
			respond(r, nil);
			postnote(PNGROUP, getpid(), "umount");
			exits(nil);
		}else if(strncmp(r-&gt;ifcall.data, "refresh", 7) == 0){
			flushcache();
			respond(r, nil);
		}else if(strncmp(r-&gt;ifcall.data, "hashstats", 9) == 0){
			int i;
			lock(&amp;pglock);
			for(i=0; i&lt;NHASH; i++)
				if(pgtab[i])
					print("%lud ", pgtab[i]-&gt;len);
			print("\n");
			unlock(&amp;pglock);
			respond(r, nil);
		}else
			respond(r, "permission denied");
		break;
	case Xkregs:
	case Xmem:
		if(sendp(rchan, r) != 1) {
			snprint(buf, sizeof buf, "rdbfs sendp: %r");
			respond(r, buf);
			return;
		}
		break;
	default:
		respond(r, "Egreg");
		break;
	}
}

struct {
	char *s;
	int id;
	int mode;
} tab[] = {
	"ctl",		Xctl,		0222,
	"fpregs",	Xfpregs,	0666,
	"kregs",	Xkregs,		0666,
	"mem",		Xmem,		0666,
	"proc",		Xproc,		0444,
	"regs",		Xregs,		0666,
	"text",		Xtext,		0444,
	"status",	Xstatus,	0444,
};

void
killall(Srv*)
{
	postnote(PNGROUP, getpid(), "kill");
}

Srv fs = {
.open=	fsopen,
.read=	fsread,
.write=	fswrite,
.end=	killall,
};

void
threadmain(int argc, char **argv)
{
	int i, p[2];
	File *dir;

	rfork(RFNOTEG);
	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'd':
		dbg = 1;
		break;
	case 'p':
		procname = EARGF(usage());
		break;
	case 's':
		srvname = EARGF(usage());
		break;
	case 't':
		textfile = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND;

	switch(argc){
	case 0:
		break;
	case 1:
		portname = argv[0];
		break;
	default:
		usage();
	}

	rchan = chancreate(sizeof(Req*), 10);
	attachremote(portname);
	if(pipe(p) &lt; 0)
		sysfatal("pipe: %r");

	fmtinstall('F', fcallfmt);
	proccreate(eiaread, nil, 8192);

	fs.tree = alloctree("rdbfs", "rdbfs", DMDIR|0555, nil);
	dir = createfile(fs.tree-&gt;root, procname, "rdbfs", DMDIR|0555, 0);
	for(i=0; i&lt;nelem(tab); i++)
		closefile(createfile(dir, tab[i].s, "rdbfs", tab[i].mode, (void*)tab[i].id));
	closefile(dir);
	threadpostmountsrv(&amp;fs, srvname, "/proc", MBEFORE);
	exits(0);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

