<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rio/fsys.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rio/fsys.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include "dat.h"
#include "fns.h"

char Eperm[] = "permission denied";
char Eexist[] = "file does not exist";
char Enotdir[] = "not a directory";
char	Ebadfcall[] = "bad fcall type";
char	Eoffset[] = "illegal offset";

int	messagesize = 8192+IOHDRSZ;	/* good start */

enum{
	DEBUG = 0
};

Dirtab dirtab[]=
{
	{ ".",			QTDIR,	Qdir,			0500|DMDIR },
	{ "cons",		QTFILE,	Qcons,		0600 },
	{ "cursor",		QTFILE,	Qcursor,		0600 },
	{ "consctl",	QTFILE,	Qconsctl,		0200 },
	{ "winid",		QTFILE,	Qwinid,		0400 },
	{ "winname",	QTFILE,	Qwinname,	0400 },
	{ "kbdin",		QTFILE,	Qkbdin,		0200 },
	{ "label",		QTFILE,	Qlabel,		0600 },
	{ "mouse",	QTFILE,	Qmouse,		0600 },
	{ "screen",		QTFILE,	Qscreen,		0400 },
	{ "snarf",		QTFILE,	Qsnarf,		0600 },
	{ "text",		QTFILE,	Qtext,		0400 },
	{ "wdir",		QTFILE,	Qwdir,		0600 },
	{ "wctl",		QTFILE,	Qwctl,		0600 },
	{ "window",	QTFILE,	Qwindow,		0400 },
	{ "wsys",		QTDIR,	Qwsys,		0500|DMDIR },
	{ nil, }
};

static uint		getclock(void);
static void		filsysproc(void*);
static Fid*		newfid(Filsys*, int);
static int		dostat(Filsys*, int, Dirtab*, uchar*, int, uint);

int	clockfd;
int	firstmessage = 1;

char	srvpipe[64];
char	srvwctl[64];

static	Xfid*	filsysflush(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysversion(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysauth(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysnop(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysattach(Filsys*, Xfid*, Fid*);
static	Xfid*	filsyswalk(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysopen(Filsys*, Xfid*, Fid*);
static	Xfid*	filsyscreate(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysread(Filsys*, Xfid*, Fid*);
static	Xfid*	filsyswrite(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysclunk(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysremove(Filsys*, Xfid*, Fid*);
static	Xfid*	filsysstat(Filsys*, Xfid*, Fid*);
static	Xfid*	filsyswstat(Filsys*, Xfid*, Fid*);

Xfid* 	(*fcall[Tmax])(Filsys*, Xfid*, Fid*) =
{
	[Tflush]	= filsysflush,
	[Tversion]	= filsysversion,
	[Tauth]	= filsysauth,
	[Tattach]	= filsysattach,
	[Twalk]	= filsyswalk,
	[Topen]	= filsysopen,
	[Tcreate]	= filsyscreate,
	[Tread]	= filsysread,
	[Twrite]	= filsyswrite,
	[Tclunk]	= filsysclunk,
	[Tremove]= filsysremove,
	[Tstat]	= filsysstat,
	[Twstat]	= filsyswstat,
};

void
post(char *name, char *envname, int srvfd)
{
	int fd;
	char buf[32];

	fd = create(name, OWRITE|ORCLOSE|OCEXEC, 0600);
	if(fd &lt; 0)
		error(name);
	sprint(buf, "%d",srvfd);
	if(write(fd, buf, strlen(buf)) != strlen(buf))
		error("srv write");
	putenv(envname, name);
}

/*
 * Build pipe with OCEXEC set on second fd.
 * Can't put it on both because we want to post one in /srv.
 */
int
cexecpipe(int *p0, int *p1)
{
	/* pipe the hard way to get close on exec */
	if(bind("#|", "/mnt/temp", MREPL) &lt; 0)
		return -1;
	*p0 = open("/mnt/temp/data", ORDWR);
	*p1 = open("/mnt/temp/data1", ORDWR|OCEXEC);
	unmount(nil, "/mnt/temp");
	if(*p0&lt;0 || *p1&lt;0)
		return -1;
	return 0;
}

Filsys*
filsysinit(Channel *cxfidalloc)
{
	int n, fd, pid, p0;
	Filsys *fs;
	Channel *c;
	char buf[128];

	fs = emalloc(sizeof(Filsys));
	if(cexecpipe(&amp;fs-&gt;cfd, &amp;fs-&gt;sfd) &lt; 0)
		goto Rescue;
	fmtinstall('F', fcallfmt);
	clockfd = open("/dev/time", OREAD|OCEXEC);
	fd = open("/dev/user", OREAD);
	strcpy(buf, "Jean-Paul_Belmondo");
	if(fd &gt;= 0){
		n = read(fd, buf, sizeof buf-1);
		if(n &gt; 0)
			buf[n] = 0;
		close(fd);
	}
	fs-&gt;user = estrdup(buf);
	fs-&gt;cxfidalloc = cxfidalloc;
	pid = getpid();

	/*
	 * Create and post wctl pipe
	 */
	if(cexecpipe(&amp;p0, &amp;wctlfd) &lt; 0)
		goto Rescue;
	sprint(srvwctl, "/srv/riowctl.%s.%d", fs-&gt;user, pid);
	post(srvwctl, "wctl", p0);
	close(p0);

	/*
	 * Start server processes
	 */
	c = chancreate(sizeof(char*), 0);
	if(c == nil)
		error("wctl channel");
	proccreate(wctlproc, c, 4096);
	threadcreate(wctlthread, c, 4096);
	proccreate(filsysproc, fs, 10000);

	/*
	 * Post srv pipe
	 */
	sprint(srvpipe, "/srv/rio.%s.%d", fs-&gt;user, pid);
	post(srvpipe, "wsys", fs-&gt;cfd);

	return fs;

Rescue:
	free(fs);
	return nil;
}

static
void
filsysproc(void *arg)
{
	int n;
	Xfid *x;
	Fid *f;
	Fcall t;
	uchar *buf;
	Filsys *fs;

	threadsetname("FILSYSPROC");
	fs = arg;
	fs-&gt;pid = getpid();
	x = nil;
	for(;;){
		buf = emalloc(messagesize+UTFmax);	/* UTFmax for appending partial rune in xfidwrite */
		n = read9pmsg(fs-&gt;sfd, buf, messagesize);
		if(n &lt;= 0){
			yield();	/* if threadexitsall'ing, will not return */
			fprint(2, "rio: %d: read9pmsg: %d %r\n", getpid(), n);
			errorshouldabort = 0;
			error("eof or i/o error on server channel");
		}
		if(x == nil){
			send(fs-&gt;cxfidalloc, nil);
			recv(fs-&gt;cxfidalloc, &amp;x);
			x-&gt;fs = fs;
		}
		x-&gt;buf = buf;
		if(convM2S(buf, n, x) != n)
			error("convert error in convM2S");
		if(DEBUG)
			fprint(2, "rio:&lt;-%F\n", &amp;x-&gt;Fcall);
		if(fcall[x-&gt;type] == nil)
			x = filsysrespond(fs, x, &amp;t, Ebadfcall);
		else{
			if(x-&gt;type==Tversion || x-&gt;type==Tauth)
				f = nil;
			else
				f = newfid(fs, x-&gt;fid);
			x-&gt;f = f;
			x  = (*fcall[x-&gt;type])(fs, x, f);
		}
		firstmessage = 0;
	}
}

/*
 * Called only from a different FD group
 */
int
filsysmount(Filsys *fs, int id)
{
	char buf[32];

	close(fs-&gt;sfd);	/* close server end so mount won't hang if exiting */
	sprint(buf, "%d", id);
	if(mount(fs-&gt;cfd, -1, "/mnt/wsys", MREPL, buf) &lt; 0){
		fprint(2, "mount failed: %r\n");
		return -1;
	}
	if(bind("/mnt/wsys", "/dev", MBEFORE) &lt; 0){
		fprint(2, "bind failed: %r\n");
		return -1;
	}
	return 0;
}

Xfid*
filsysrespond(Filsys *fs, Xfid *x, Fcall *t, char *err)
{
	int n;

	if(err){
		t-&gt;type = Rerror;
		t-&gt;ename = err;
	}else
		t-&gt;type = x-&gt;type+1;
	t-&gt;fid = x-&gt;fid;
	t-&gt;tag = x-&gt;tag;
	if(x-&gt;buf == nil)
		x-&gt;buf = malloc(messagesize);
	n = convS2M(t, x-&gt;buf, messagesize);
	if(n &lt;= 0)
		error("convert error in convS2M");
	if(write(fs-&gt;sfd, x-&gt;buf, n) != n)
		error("write error in respond");
	if(DEBUG)
		fprint(2, "rio:-&gt;%F\n", t);
	free(x-&gt;buf);
	x-&gt;buf = nil;
	return x;
}

void
filsyscancel(Xfid *x)
{
	if(x-&gt;buf){
		free(x-&gt;buf);
		x-&gt;buf = nil;
	}
}

static
Xfid*
filsysversion(Filsys *fs, Xfid *x, Fid*)
{
	Fcall t;

	if(!firstmessage)
		return filsysrespond(x-&gt;fs, x, &amp;t, "version request not first message");
	if(x-&gt;msize &lt; 256)
		return filsysrespond(x-&gt;fs, x, &amp;t, "version: message size too small");
	messagesize = x-&gt;msize;
	t.msize = messagesize;
	if(strncmp(x-&gt;version, "9P2000", 6) != 0)
		return filsysrespond(x-&gt;fs, x, &amp;t, "unrecognized 9P version");
	t.version = "9P2000";
	return filsysrespond(fs, x, &amp;t, nil);
}

static
Xfid*
filsysauth(Filsys *fs, Xfid *x, Fid*)
{
	Fcall t;

		return filsysrespond(fs, x, &amp;t, "rio: authentication not required");
}

static
Xfid*
filsysflush(Filsys*, Xfid *x, Fid*)
{
	sendp(x-&gt;c, xfidflush);
	return nil;
}

static
Xfid*
filsysattach(Filsys *, Xfid *x, Fid *f)
{
	Fcall t;

	if(strcmp(x-&gt;uname, x-&gt;fs-&gt;user) != 0)
		return filsysrespond(x-&gt;fs, x, &amp;t, Eperm);
	f-&gt;busy = TRUE;
	f-&gt;open = FALSE;
	f-&gt;qid.path = Qdir;
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.vers = 0;
	f-&gt;dir = dirtab;
	f-&gt;nrpart = 0;
	sendp(x-&gt;c, xfidattach);
	return nil;
}

static
int
numeric(char *s)
{
	for(; *s!='\0'; s++)
		if(*s&lt;'0' || '9'&lt;*s)
			return 0;
	return 1;
}

static
Xfid*
filsyswalk(Filsys *fs, Xfid *x, Fid *f)
{
	Fcall t;
	Fid *nf;
	int i, id;
	uchar type;
	ulong path;
	Dirtab *d, *dir;
	Window *w;
	char *err;
	Qid qid;

	if(f-&gt;open)
		return filsysrespond(fs, x, &amp;t, "walk of open file");
	nf = nil;
	if(x-&gt;fid  != x-&gt;newfid){
		/* BUG: check exists */
		nf = newfid(fs, x-&gt;newfid);
		if(nf-&gt;busy)
			return filsysrespond(fs, x, &amp;t, "clone to busy fid");
		nf-&gt;busy = TRUE;
		nf-&gt;open = FALSE;
		nf-&gt;dir = f-&gt;dir;
		nf-&gt;qid = f-&gt;qid;
		nf-&gt;w = f-&gt;w;
		incref(f-&gt;w);
		nf-&gt;nrpart = 0;	/* not open, so must be zero */
		f = nf;	/* walk f */
	}

	t.nwqid = 0;
	err = nil;

	/* update f-&gt;qid, f-&gt;dir only if walk completes */
	qid = f-&gt;qid;
	dir = f-&gt;dir;

	if(x-&gt;nwname &gt; 0){
		for(i=0; i&lt;x-&gt;nwname; i++){
			if((qid.type &amp; QTDIR) == 0){
				err = Enotdir;
				break;
			}
			if(strcmp(x-&gt;wname[i], "..") == 0){
				type = QTDIR;
				path = Qdir;
				dir = dirtab;
				if(FILE(qid) == Qwsysdir)
					path = Qwsys;
				id = 0;
    Accept:
				if(i == MAXWELEM){
					err = "name too long";
					break;
				}
				qid.type = type;
				qid.vers = 0;
				qid.path = QID(id, path);
				t.wqid[t.nwqid++] = qid;
				continue;
			}

			if(qid.path == Qwsys){
				/* is it a numeric name? */
				if(!numeric(x-&gt;wname[i]))
					break;
				/* yes: it's a directory */
				id = atoi(x-&gt;wname[i]);
				qlock(&amp;all);
				w = wlookid(id);
				if(w == nil){
					qunlock(&amp;all);
					break;
				}
				path = Qwsysdir;
				type = QTDIR;
				qunlock(&amp;all);
				incref(w);
				sendp(winclosechan, f-&gt;w);
				f-&gt;w = w;
				dir = dirtab;
				goto Accept;
			}
		
			if(snarffd&gt;=0 &amp;&amp; strcmp(x-&gt;wname[i], "snarf")==0)
				break;	/* don't serve /dev/snarf if it's provided in the environment */
			id = WIN(f-&gt;qid);
			d = dirtab;
			d++;	/* skip '.' */
			for(; d-&gt;name; d++)
				if(strcmp(x-&gt;wname[i], d-&gt;name) == 0){
					path = d-&gt;qid;
					type = d-&gt;type;
					dir = d;
					goto Accept;
				}

			break;	/* file not found */
		}

		if(i==0 &amp;&amp; err==nil)
			err = Eexist;
	}

	if(err!=nil || t.nwqid&lt;x-&gt;nwname){
		if(nf){
			if(nf-&gt;w)
				sendp(winclosechan, nf-&gt;w);
			nf-&gt;open = FALSE;
			nf-&gt;busy = FALSE;
		}
	}else if(t.nwqid == x-&gt;nwname){
		f-&gt;dir = dir;
		f-&gt;qid = qid;
	}

	return filsysrespond(fs, x, &amp;t, err);
}

static
Xfid*
filsysopen(Filsys *fs, Xfid *x, Fid *f)
{
	Fcall t;
	int m;

	/* can't truncate anything, so just disregard */
	x-&gt;mode &amp;= ~(OTRUNC|OCEXEC);
	/* can't execute or remove anything */
	if(x-&gt;mode==OEXEC || (x-&gt;mode&amp;ORCLOSE))
		goto Deny;
	switch(x-&gt;mode){
	default:
		goto Deny;
	case OREAD:
		m = 0400;
		break;
	case OWRITE:
		m = 0200;
		break;
	case ORDWR:
		m = 0600;
		break;
	}
	if(((f-&gt;dir-&gt;perm&amp;~(DMDIR|DMAPPEND))&amp;m) != m)
		goto Deny;
		
	sendp(x-&gt;c, xfidopen);
	return nil;

    Deny:
	return filsysrespond(fs, x, &amp;t, Eperm);
}

static
Xfid*
filsyscreate(Filsys *fs, Xfid *x, Fid*)
{
	Fcall t;

	return filsysrespond(fs, x, &amp;t, Eperm);
}

static
int
idcmp(void *a, void *b)
{
	return *(int*)a - *(int*)b;
}

static
Xfid*
filsysread(Filsys *fs, Xfid *x, Fid *f)
{
	Fcall t;
	uchar *b;
	int i, n, o, e, len, j, k, *ids;
	Dirtab *d, dt;
	uint clock;
	char buf[16];

	if((f-&gt;qid.type &amp; QTDIR) == 0){
		sendp(x-&gt;c, xfidread);
		return nil;
	}
	o = x-&gt;offset;
	e = x-&gt;offset+x-&gt;count;
	clock = getclock();
	b = malloc(messagesize-IOHDRSZ);	/* avoid memset of emalloc */
	if(b == nil)
		return filsysrespond(fs, x, &amp;t, "out of memory");
	n = 0;
	switch(FILE(f-&gt;qid)){
	case Qdir:
	case Qwsysdir:
		d = dirtab;
		d++;	/* first entry is '.' */
		for(i=0; d-&gt;name!=nil &amp;&amp; i&lt;e; i+=len){
			len = dostat(fs, WIN(x-&gt;f-&gt;qid), d, b+n, x-&gt;count-n, clock);
			if(len &lt;= BIT16SZ)
				break;
			if(i &gt;= o)
				n += len;
			d++;
		}
		break;
	case Qwsys:
		qlock(&amp;all);
		ids = emalloc(nwindow*sizeof(int));
		for(j=0; j&lt;nwindow; j++)
			ids[j] = window[j]-&gt;id;
		qunlock(&amp;all);
		qsort(ids, nwindow, sizeof ids[0], idcmp);
		dt.name = buf;
		for(i=0, j=0; j&lt;nwindow &amp;&amp; i&lt;e; i+=len){
			k = ids[j];
			sprint(dt.name, "%d", k);
			dt.qid = QID(k, Qdir);
			dt.type = QTDIR;
			dt.perm = DMDIR|0700;
			len = dostat(fs, k, &amp;dt, b+n, x-&gt;count-n, clock);
			if(len == 0)
				break;
			if(i &gt;= o)
				n += len;
			j++;
		}
		free(ids);
		break;
	}
	t.data = (char*)b;
	t.count = n;
	filsysrespond(fs, x, &amp;t, nil);
	free(b);
	return x;
}

static
Xfid*
filsyswrite(Filsys*, Xfid *x, Fid*)
{
	sendp(x-&gt;c, xfidwrite);
	return nil;
}

static
Xfid*
filsysclunk(Filsys *fs, Xfid *x, Fid *f)
{
	Fcall t;

	if(f-&gt;open){
		f-&gt;busy = FALSE;
		f-&gt;open = FALSE;
		sendp(x-&gt;c, xfidclose);
		return nil;
	}
	if(f-&gt;w)
		sendp(winclosechan, f-&gt;w);
	f-&gt;busy = FALSE;
	f-&gt;open = FALSE;
	return filsysrespond(fs, x, &amp;t, nil);
}

static
Xfid*
filsysremove(Filsys *fs, Xfid *x, Fid*)
{
	Fcall t;

	return filsysrespond(fs, x, &amp;t, Eperm);
}

static
Xfid*
filsysstat(Filsys *fs, Xfid *x, Fid *f)
{
	Fcall t;

	t.stat = emalloc(messagesize-IOHDRSZ);
	t.nstat = dostat(fs, WIN(x-&gt;f-&gt;qid), f-&gt;dir, t.stat, messagesize-IOHDRSZ, getclock());
	x = filsysrespond(fs, x, &amp;t, nil);
	free(t.stat);
	return x;
}

static
Xfid*
filsyswstat(Filsys *fs, Xfid *x, Fid*)
{
	Fcall t;

	return filsysrespond(fs, x, &amp;t, Eperm);
}

static
Fid*
newfid(Filsys *fs, int fid)
{
	Fid *f, *ff, **fh;

	ff = nil;
	fh = &amp;fs-&gt;fids[fid&amp;(Nhash-1)];
	for(f=*fh; f; f=f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(ff==nil &amp;&amp; f-&gt;busy==FALSE)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = *fh;
	*fh = f;
	return f;
}

static
uint
getclock(void)
{
	char buf[32];

	seek(clockfd, 0, 0);
	read(clockfd, buf, sizeof buf);
	return atoi(buf);
}

static
int
dostat(Filsys *fs, int id, Dirtab *dir, uchar *buf, int nbuf, uint clock)
{
	Dir d;

	d.qid.path = QID(id, dir-&gt;qid);
	if(dir-&gt;qid == Qsnarf)
		d.qid.vers = snarfversion;
	else
		d.qid.vers = 0;
	d.qid.type = dir-&gt;type;
	d.mode = dir-&gt;perm;
	d.length = 0;	/* would be nice to do better */
	d.name = dir-&gt;name;
	d.uid = fs-&gt;user;
	d.gid = fs-&gt;user;
	d.muid = fs-&gt;user;
	d.atime = clock;
	d.mtime = clock;
	return convD2M(&amp;d, buf, nbuf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

