<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rio/scrl.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rio/scrl.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include "dat.h"
#include "fns.h"

static Image *scrtmp;

static
void
scrtemps(void)
{
	int h;

	if(scrtmp)
		return;
	h = BIG*Dy(screen-&gt;r);
	scrtmp = allocimage(display, Rect(0, 0, 32, h), screen-&gt;chan, 0, DWhite);
	if(scrtmp == nil)
		error("scrtemps");
}

void
freescrtemps(void)
{
	freeimage(scrtmp);
	scrtmp = nil;
}

static
Rectangle
scrpos(Rectangle r, uint p0, uint p1, uint tot)
{
	Rectangle q;
	int h;

	q = r;
	h = q.max.y-q.min.y;
	if(tot == 0)
		return q;
	if(tot &gt; 1024*1024){
		tot&gt;&gt;=10;
		p0&gt;&gt;=10;
		p1&gt;&gt;=10;
	}
	if(p0 &gt; 0)
		q.min.y += h*p0/tot;
	if(p1 &lt; tot)
		q.max.y -= h*(tot-p1)/tot;
	if(q.max.y &lt; q.min.y+2){
		if(q.min.y+2 &lt;= r.max.y)
			q.max.y = q.min.y+2;
		else
			q.min.y = q.max.y-2;
	}
	return q;
}

void
wscrdraw(Window *w)
{
	Rectangle r, r1, r2;
	Image *b;

	scrtemps();
	if(w-&gt;i == nil)
		error("scrdraw");
	r = w-&gt;scrollr;
	b = scrtmp;
	r1 = r;
	r1.min.x = 0;
	r1.max.x = Dx(r);
	r2 = scrpos(r1, w-&gt;org, w-&gt;org+w-&gt;nchars, w-&gt;nr);
	if(!eqrect(r2, w-&gt;lastsr)){
		w-&gt;lastsr = r2;
		/* move r1, r2 to (0,0) to avoid clipping */
		r2 = rectsubpt(r2, r1.min);
		r1 = rectsubpt(r1, r1.min);
		draw(b, r1, w-&gt;cols[BORD], nil, ZP);
		draw(b, r2, w-&gt;cols[BACK], nil, ZP);
		r2.min.x = r2.max.x-1;
		draw(b, r2, w-&gt;cols[BORD], nil, ZP);
		draw(w-&gt;i, r, b, nil, Pt(0, r1.min.y));
	}
}

void
wscrsleep(Window *w, uint dt)
{
	Timer	*timer;
	int y, b;
	static Alt alts[3];

	timer = timerstart(dt);
	y = w-&gt;mc.xy.y;
	b = w-&gt;mc.buttons;
	alts[0].c = timer-&gt;c;
	alts[0].v = nil;
	alts[0].op = CHANRCV;
	alts[1].c = w-&gt;mc.c;
	alts[1].v = &amp;w-&gt;mc.Mouse;
	alts[1].op = CHANRCV;
	alts[2].op = CHANEND;
	for(;;)
		switch(alt(alts)){
		case 0:
			timerstop(timer);
			return;
		case 1:
			if(abs(w-&gt;mc.xy.y-y)&gt;2 || w-&gt;mc.buttons!=b){
				timercancel(timer);
				return;
			}
			break;
		}
}

void
wscroll(Window *w, int but)
{
	uint p0, oldp0;
	Rectangle s;
	int x, y, my, h, first;

	s = insetrect(w-&gt;scrollr, 1);
	h = s.max.y-s.min.y;
	x = (s.min.x+s.max.x)/2;
	oldp0 = ~0;
	first = TRUE;
	do{
		flushimage(display, 1);
		if(w-&gt;mc.xy.x&lt;s.min.x || s.max.x&lt;=w-&gt;mc.xy.x){
			readmouse(&amp;w-&gt;mc);
		}else{
			my = w-&gt;mc.xy.y;
			if(my &lt; s.min.y)
				my = s.min.y;
			if(my &gt;= s.max.y)
				my = s.max.y;
			if(!eqpt(w-&gt;mc.xy, Pt(x, my))){
				wmovemouse(w, Pt(x, my));
				readmouse(&amp;w-&gt;mc);		/* absorb event generated by moveto() */
			}
			if(but == 2){
				y = my;
				if(y &gt; s.max.y-2)
					y = s.max.y-2;
				if(w-&gt;nr &gt; 1024*1024)
					p0 = ((w-&gt;nr&gt;&gt;10)*(y-s.min.y)/h)&lt;&lt;10;
				else
					p0 = w-&gt;nr*(y-s.min.y)/h;
				if(oldp0 != p0)
					wsetorigin(w, p0, FALSE);
				oldp0 = p0;
				readmouse(&amp;w-&gt;mc);
				continue;
			}
			if(but == 1)
				p0 = wbacknl(w, w-&gt;org, (my-s.min.y)/w-&gt;font-&gt;height);
			else
				p0 = w-&gt;org+frcharofpt(w, Pt(s.max.x, my));
			if(oldp0 != p0)
				wsetorigin(w, p0, TRUE);
			oldp0 = p0;
			/* debounce */
			if(first){
				flushimage(display, 1);
				sleep(200);
				nbrecv(w-&gt;mc.c, &amp;w-&gt;mc.Mouse);
				first = FALSE;
			}
			wscrsleep(w, 100);
		}
	}while(w-&gt;mc.buttons &amp; (1&lt;&lt;(but-1)));
	while(w-&gt;mc.buttons)
		readmouse(&amp;w-&gt;mc);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

