<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rio/wind.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rio/wind.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include &lt;complete.h&gt;
#include "dat.h"
#include "fns.h"

#define MOVEIT if(0)

enum
{
	HiWater	= 640000,	/* max size of history */
	LoWater	= 400000,	/* min size of history after max'ed */
	MinWater	= 20000,	/* room to leave available when reallocating */
};

static	int		topped;
static	int		id;

static	Image	*cols[NCOL];
static	Image	*grey;
static	Image	*darkgrey;
static	Cursor	*lastcursor;
static	Image	*titlecol;
static	Image	*lighttitlecol;
static	Image	*holdcol;
static	Image	*lightholdcol;
static	Image	*paleholdcol;

Window*
wmk(Image *i, Mousectl *mc, Channel *ck, Channel *cctl, int scrolling)
{
	Window *w;
	Rectangle r;

	if(cols[0] == nil){
		/* greys are multiples of 0x11111100+0xFF, 14* being palest */
		grey = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0xEEEEEEFF);
		darkgrey = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0x666666FF);
		cols[BACK] = display-&gt;white;
		cols[HIGH] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0xCCCCCCFF);
		cols[BORD] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0x999999FF);
		cols[TEXT] = display-&gt;black;
		cols[HTEXT] = display-&gt;black;
		titlecol = allocimage(display, Rect(0,0,1,1), CMAP8, 1, DGreygreen);
		lighttitlecol = allocimage(display, Rect(0,0,1,1), CMAP8, 1, DPalegreygreen);
		holdcol = allocimage(display, Rect(0,0,1,1), CMAP8, 1, DMedblue);
		lightholdcol = allocimage(display, Rect(0,0,1,1), CMAP8, 1, DGreyblue);
		paleholdcol = allocimage(display, Rect(0,0,1,1), CMAP8, 1, DPalegreyblue);
	}
	w = emalloc(sizeof(Window));
	w-&gt;screenr = i-&gt;r;
	r = insetrect(i-&gt;r, Selborder+1);
	w-&gt;i = i;
	w-&gt;mc = *mc;
	w-&gt;ck = ck;
	w-&gt;cctl = cctl;
	w-&gt;cursorp = nil;
	w-&gt;conswrite = chancreate(sizeof(Conswritemesg), 0);
	w-&gt;consread =  chancreate(sizeof(Consreadmesg), 0);
	w-&gt;mouseread =  chancreate(sizeof(Mousereadmesg), 0);
	w-&gt;wctlread =  chancreate(sizeof(Consreadmesg), 0);
	w-&gt;scrollr = r;
	w-&gt;scrollr.max.x = r.min.x+Scrollwid;
	w-&gt;lastsr = ZR;
	r.min.x += Scrollwid+Scrollgap;
	frinit(w, r, font, i, cols);
	w-&gt;maxtab = maxtab*stringwidth(font, "0");
	w-&gt;topped = ++topped;
	w-&gt;id = ++id;
	w-&gt;notefd = -1;
	w-&gt;scrolling = scrolling;
	w-&gt;dir = estrdup(startdir);
	w-&gt;label = estrdup("&lt;unnamed&gt;");
	r = insetrect(w-&gt;i-&gt;r, Selborder);
	draw(w-&gt;i, r, cols[BACK], nil, w-&gt;entire.min);
	wborder(w, Selborder);
	wscrdraw(w);
	incref(w);	/* ref will be removed after mounting; avoids delete before ready to be deleted */
	return w;
}

void
wsetname(Window *w)
{
	int i, n;
	char err[ERRMAX];
	
	n = sprint(w-&gt;name, "window.%d.%d", w-&gt;id, w-&gt;namecount++);
	for(i='A'; i&lt;='Z'; i++){
		if(nameimage(w-&gt;i, w-&gt;name, 1) &gt; 0)
			return;
		errstr(err, sizeof err);
		if(strcmp(err, "image name in use") != 0)
			break;
		w-&gt;name[n] = i;
		w-&gt;name[n+1] = 0;
	}
	w-&gt;name[0] = 0;
	fprint(2, "rio: setname failed: %s\n", err);
}

void
wresize(Window *w, Image *i, int move)
{
	Rectangle r, or;

	or = w-&gt;i-&gt;r;
	if(move || (Dx(or)==Dx(i-&gt;r) &amp;&amp; Dy(or)==Dy(i-&gt;r)))
		draw(i, i-&gt;r, w-&gt;i, nil, w-&gt;i-&gt;r.min);
	freeimage(w-&gt;i);
	w-&gt;i = i;
	wsetname(w);
	w-&gt;mc.image = i;
	r = insetrect(i-&gt;r, Selborder+1);
	w-&gt;scrollr = r;
	w-&gt;scrollr.max.x = r.min.x+Scrollwid;
	w-&gt;lastsr = ZR;
	r.min.x += Scrollwid+Scrollgap;
	if(move)
		frsetrects(w, r, w-&gt;i);
	else{
		frclear(w, FALSE);
		frinit(w, r, w-&gt;font, w-&gt;i, cols);
		wsetcols(w);
		w-&gt;maxtab = maxtab*stringwidth(w-&gt;font, "0");
		r = insetrect(w-&gt;i-&gt;r, Selborder);
		draw(w-&gt;i, r, cols[BACK], nil, w-&gt;entire.min);
		wfill(w);
		wsetselect(w, w-&gt;q0, w-&gt;q1);
		wscrdraw(w);
	}
	wborder(w, Selborder);
	w-&gt;topped = ++topped;
	w-&gt;resized = TRUE;
	w-&gt;mouse.counter++;
}

void
wrefresh(Window *w, Rectangle)
{
	/* BUG: rectangle is ignored */
	if(w == input)
		wborder(w, Selborder);
	else
		wborder(w, Unselborder);
	if(w-&gt;mouseopen)
		return;
	draw(w-&gt;i, insetrect(w-&gt;i-&gt;r, Borderwidth), w-&gt;cols[BACK], nil, w-&gt;i-&gt;r.min);
	w-&gt;ticked = 0;
	if(w-&gt;p0 &gt; 0)
		frdrawsel(w, frptofchar(w, 0), 0, w-&gt;p0, 0);
	if(w-&gt;p1 &lt; w-&gt;nchars)
		frdrawsel(w, frptofchar(w, w-&gt;p1), w-&gt;p1, w-&gt;nchars, 0);
	frdrawsel(w, frptofchar(w, w-&gt;p0), w-&gt;p0, w-&gt;p1, 1);
	w-&gt;lastsr = ZR;
	wscrdraw(w);
}

int
wclose(Window *w)
{
	int i;

	i = decref(w);
	if(i &gt; 0)
		return 0;
	if(i &lt; 0)
		error("negative ref count");
	if(!w-&gt;deleted)
		wclosewin(w);
	wsendctlmesg(w, Exited, ZR, nil);
	return 1;
}


void
winctl(void *arg)
{
	Rune *rp, *bp, *tp, *up, *kbdr;
	uint qh;
	int nr, nb, c, wid, i, npart, initial, lastb;
	char *s, *t, part[3];
	Window *w;
	Mousestate *mp, m;
	enum { WKey, WMouse, WMouseread, WCtl, WCwrite, WCread, WWread, NWALT };
	Alt alts[NWALT+1];
	Mousereadmesg mrm;
	Conswritemesg cwm;
	Consreadmesg crm;
	Consreadmesg cwrm;
	Stringpair pair;
	Wctlmesg wcm;
	char buf[4*12+1];

	w = arg;
	snprint(buf, sizeof buf, "winctl-id%d", w-&gt;id);
	threadsetname(buf);

	mrm.cm = chancreate(sizeof(Mouse), 0);
	cwm.cw = chancreate(sizeof(Stringpair), 0);
	crm.c1 = chancreate(sizeof(Stringpair), 0);
	crm.c2 = chancreate(sizeof(Stringpair), 0);
	cwrm.c1 = chancreate(sizeof(Stringpair), 0);
	cwrm.c2 = chancreate(sizeof(Stringpair), 0);
	

	alts[WKey].c = w-&gt;ck;
	alts[WKey].v = &amp;kbdr;
	alts[WKey].op = CHANRCV;
	alts[WMouse].c = w-&gt;mc.c;
	alts[WMouse].v = &amp;w-&gt;mc.Mouse;
	alts[WMouse].op = CHANRCV;
	alts[WMouseread].c = w-&gt;mouseread;
	alts[WMouseread].v = &amp;mrm;
	alts[WMouseread].op = CHANSND;
	alts[WCtl].c = w-&gt;cctl;
	alts[WCtl].v = &amp;wcm;
	alts[WCtl].op = CHANRCV;
	alts[WCwrite].c = w-&gt;conswrite;
	alts[WCwrite].v = &amp;cwm;
	alts[WCwrite].op = CHANSND;
	alts[WCread].c = w-&gt;consread;
	alts[WCread].v = &amp;crm;
	alts[WCread].op = CHANSND;
	alts[WWread].c = w-&gt;wctlread;
	alts[WWread].v = &amp;cwrm;
	alts[WWread].op = CHANSND;
	alts[NWALT].op = CHANEND;

	npart = 0;
	lastb = -1;
	for(;;){
		if(w-&gt;mouseopen &amp;&amp; w-&gt;mouse.counter != w-&gt;mouse.lastcounter)
			alts[WMouseread].op = CHANSND;
		else
			alts[WMouseread].op = CHANNOP;
		if(!w-&gt;scrolling &amp;&amp; !w-&gt;mouseopen &amp;&amp; w-&gt;qh&gt;w-&gt;org+w-&gt;nchars)
			alts[WCwrite].op = CHANNOP;
		else
			alts[WCwrite].op = CHANSND;
		if(w-&gt;deleted || !w-&gt;wctlready)
			alts[WWread].op = CHANNOP;
		else
			alts[WWread].op = CHANSND;
		/* this code depends on NL and EOT fitting in a single byte */
		/* kind of expensive for each loop; worth precomputing? */
		if(w-&gt;holding)
			alts[WCread].op = CHANNOP;
		else if(npart || (w-&gt;rawing &amp;&amp; w-&gt;nraw&gt;0))
			alts[WCread].op = CHANSND;
		else{
			alts[WCread].op = CHANNOP;
			for(i=w-&gt;qh; i&lt;w-&gt;nr; i++){
				c = w-&gt;r[i];
				if(c=='\n' || c=='\004'){
					alts[WCread].op = CHANSND;
					break;
				}
			}
		}
		switch(alt(alts)){
		case WKey:
			for(i=0; kbdr[i]!=L'\0'; i++)
				wkeyctl(w, kbdr[i]);
//			wkeyctl(w, r);
///			while(nbrecv(w-&gt;ck, &amp;r))
//				wkeyctl(w, r);
			break;
		case WMouse:
			if(w-&gt;mouseopen) {
				w-&gt;mouse.counter++;

				/* queue click events */
				if(!w-&gt;mouse.qfull &amp;&amp; lastb != w-&gt;mc.buttons) {	/* add to ring */
					mp = &amp;w-&gt;mouse.queue[w-&gt;mouse.wi];
					if(++w-&gt;mouse.wi == nelem(w-&gt;mouse.queue))
						w-&gt;mouse.wi = 0;
					if(w-&gt;mouse.wi == w-&gt;mouse.ri)
						w-&gt;mouse.qfull = TRUE;
					mp-&gt;Mouse = w-&gt;mc;
					mp-&gt;counter = w-&gt;mouse.counter;
					lastb = w-&gt;mc.buttons;
				}
			} else
				wmousectl(w);
			break;
		case WMouseread:
			/* send a queued event or, if the queue is empty, the current state */
			/* if the queue has filled, we discard all the events it contained. */
			/* the intent is to discard frantic clicking by the user during long latencies. */
			w-&gt;mouse.qfull = FALSE;
			if(w-&gt;mouse.wi != w-&gt;mouse.ri) {
				m = w-&gt;mouse.queue[w-&gt;mouse.ri];
				if(++w-&gt;mouse.ri == nelem(w-&gt;mouse.queue))
					w-&gt;mouse.ri = 0;
			} else
				m = (Mousestate){w-&gt;mc.Mouse, w-&gt;mouse.counter};

			w-&gt;mouse.lastcounter = m.counter;
			send(mrm.cm, &amp;m.Mouse);
			continue;
		case WCtl:
			if(wctlmesg(w, wcm.type, wcm.r, wcm.image) == Exited){
				chanfree(crm.c1);
				chanfree(crm.c2);
				chanfree(mrm.cm);
				chanfree(cwm.cw);
				chanfree(cwrm.c1);
				chanfree(cwrm.c2);
				threadexits(nil);
			}
			continue;
		case WCwrite:
			recv(cwm.cw, &amp;pair);
			rp = pair.s;
			nr = pair.ns;
			bp = rp;
			for(i=0; i&lt;nr; i++)
				if(*bp++ == '\b'){
					--bp;
					initial = 0;
					tp = runemalloc(nr);
					runemove(tp, rp, i);
					up = tp+i;
					for(; i&lt;nr; i++){
						*up = *bp++;
						if(*up == '\b')
							if(up == tp)
								initial++;
							else
								--up;
						else
							up++;
					}
					if(initial){
						if(initial &gt; w-&gt;qh)
							initial = w-&gt;qh;
						qh = w-&gt;qh-initial;
						wdelete(w, qh, qh+initial);
						w-&gt;qh = qh;
					}
					free(rp);
					rp = tp;
					nr = up-tp;
					rp[nr] = 0;
					break;
				}
			w-&gt;qh = winsert(w, rp, nr, w-&gt;qh)+nr;
			if(w-&gt;scrolling || w-&gt;mouseopen)
				wshow(w, w-&gt;qh);
			wsetselect(w, w-&gt;q0, w-&gt;q1);
			wscrdraw(w);
			free(rp);
			break;
		case WCread:
			recv(crm.c1, &amp;pair);
			t = pair.s;
			nb = pair.ns;
			i = npart;
			npart = 0;
			if(i)
				memmove(t, part, i);
			while(i&lt;nb &amp;&amp; (w-&gt;qh&lt;w-&gt;nr || w-&gt;nraw&gt;0)){
				if(w-&gt;qh == w-&gt;nr){
					wid = runetochar(t+i, &amp;w-&gt;raw[0]);
					w-&gt;nraw--;
					runemove(w-&gt;raw, w-&gt;raw+1, w-&gt;nraw);
				}else
					wid = runetochar(t+i, &amp;w-&gt;r[w-&gt;qh++]);
				c = t[i];	/* knows break characters fit in a byte */
				i += wid;
				if(!w-&gt;rawing &amp;&amp; (c == '\n' || c=='\004')){
					if(c == '\004')
						i--;
					break;
				}
			}
			if(i==nb &amp;&amp; w-&gt;qh&lt;w-&gt;nr &amp;&amp; w-&gt;r[w-&gt;qh]=='\004')
				w-&gt;qh++;
			if(i &gt; nb){
				npart = i-nb;
				memmove(part, t+nb, npart);
				i = nb;
			}
			pair.s = t;
			pair.ns = i;
			send(crm.c2, &amp;pair);
			continue;
		case WWread:
			w-&gt;wctlready = 0;
			recv(cwrm.c1, &amp;pair);
			if(w-&gt;deleted || w-&gt;i==nil)
				pair.ns = sprint(pair.s, "");
			else{
				s = "visible";
				for(i=0; i&lt;nhidden; i++)
					if(hidden[i] == w){
						s = "hidden";
						break;
					}
				t = "notcurrent";
				if(w == input)
					t = "current";
				pair.ns = snprint(pair.s, pair.ns, "%11d %11d %11d %11d %s %s ",
					w-&gt;i-&gt;r.min.x, w-&gt;i-&gt;r.min.y, w-&gt;i-&gt;r.max.x, w-&gt;i-&gt;r.max.y, t, s);
			}
			send(cwrm.c2, &amp;pair);
			continue;
		}
		if(!w-&gt;deleted)
			flushimage(display, 1);
	}
}

void
waddraw(Window *w, Rune *r, int nr)
{
	w-&gt;raw = runerealloc(w-&gt;raw, w-&gt;nraw+nr);
	runemove(w-&gt;raw+w-&gt;nraw, r, nr);
	w-&gt;nraw += nr;
}

/*
 * Need to do this in a separate proc because if process we're interrupting
 * is dying and trying to print tombstone, kernel is blocked holding p-&gt;debug lock.
 */
void
interruptproc(void *v)
{
	int *notefd;

	notefd = v;
	write(*notefd, "interrupt", 9);
	free(notefd);
}

int
windfilewidth(Window *w, uint q0, int oneelement)
{
	uint q;
	Rune r;

	q = q0;
	while(q &gt; 0){
		r = w-&gt;r[q-1];
		if(r&lt;=' ')
			break;
		if(oneelement &amp;&amp; r=='/')
			break;
		--q;
	}
	return q0-q;
}

void
showcandidates(Window *w, Completion *c)
{
	int i;
	Fmt f;
	Rune *rp;
	uint nr, qline, q0;
	char *s;

	runefmtstrinit(&amp;f);
	if (c-&gt;nmatch == 0)
		s = "[no matches in ";
	else
		s = "[";
	if(c-&gt;nfile &gt; 32)
		fmtprint(&amp;f, "%s%d files]\n", s, c-&gt;nfile);
	else{
		fmtprint(&amp;f, "%s", s);
		for(i=0; i&lt;c-&gt;nfile; i++){
			if(i &gt; 0)
				fmtprint(&amp;f, " ");
			fmtprint(&amp;f, "%s", c-&gt;filename[i]);
		}
		fmtprint(&amp;f, "]\n");
	}
	/* place text at beginning of line before host point */
	qline = w-&gt;qh;
	while(qline&gt;0 &amp;&amp; w-&gt;r[qline-1] != '\n')
		qline--;

	rp = runefmtstrflush(&amp;f);
	nr = runestrlen(rp);

	q0 = w-&gt;q0;
	q0 += winsert(w, rp, runestrlen(rp), qline) - qline;
	free(rp);
	wsetselect(w, q0+nr, q0+nr);
}

Rune*
namecomplete(Window *w)
{
	int nstr, npath;
	Rune *rp, *path, *str;
	Completion *c;
	char *s, *dir, *root;

	/* control-f: filename completion; works back to white space or / */
	if(w-&gt;q0&lt;w-&gt;nr &amp;&amp; w-&gt;r[w-&gt;q0]&gt;' ')	/* must be at end of word */
		return nil;
	nstr = windfilewidth(w, w-&gt;q0, TRUE);
	str = runemalloc(nstr);
	runemove(str, w-&gt;r+(w-&gt;q0-nstr), nstr);
	npath = windfilewidth(w, w-&gt;q0-nstr, FALSE);
	path = runemalloc(npath);
	runemove(path, w-&gt;r+(w-&gt;q0-nstr-npath), npath);
	rp = nil;

	/* is path rooted? if not, we need to make it relative to window path */
	if(npath&gt;0 &amp;&amp; path[0]=='/'){
		dir = malloc(UTFmax*npath+1);
		sprint(dir, "%.*S", npath, path);
	}else{
		if(strcmp(w-&gt;dir, "") == 0)
			root = ".";
		else
			root = w-&gt;dir;
		dir = malloc(strlen(root)+1+UTFmax*npath+1);
		sprint(dir, "%s/%.*S", root, npath, path);
	}
	dir = cleanname(dir);

	s = smprint("%.*S", nstr, str);
	c = complete(dir, s);
	free(s);
	if(c == nil)
		goto Return;

	if(!c-&gt;advance)
		showcandidates(w, c);

	if(c-&gt;advance)
		rp = runesmprint("%s", c-&gt;string);

  Return:
	freecompletion(c);
	free(dir);
	free(path);
	free(str);
	return rp;
}

void
wkeyctl(Window *w, Rune r)
{
	uint q0 ,q1;
	int n, nb, nr;
	Rune *rp;
	int *notefd;

	if(r == 0)
		return;
	if(w-&gt;deleted)
		return;
	/* navigation keys work only when mouse is not open */
	if(!w-&gt;mouseopen)
		switch(r){
		case Kdown:
			n = w-&gt;maxlines/3;
			goto case_Down;
		case Kscrollonedown:
			n = mousescrollsize(w-&gt;maxlines);
			if(n &lt;= 0)
				n = 1;
			goto case_Down;
		case Kpgdown:
			n = 2*w-&gt;maxlines/3;
		case_Down:
			q0 = w-&gt;org+frcharofpt(w, Pt(w-&gt;Frame.r.min.x, w-&gt;Frame.r.min.y+n*w-&gt;font-&gt;height));
			wsetorigin(w, q0, TRUE);
			return;
		case Kup:
			n = w-&gt;maxlines/3;
			goto case_Up;
		case Kscrolloneup:
			n = mousescrollsize(w-&gt;maxlines);
			if(n &lt;= 0)
				n = 1;
			goto case_Up;
		case Kpgup:
			n = 2*w-&gt;maxlines/3;
		case_Up:
			q0 = wbacknl(w, w-&gt;org, n);
			wsetorigin(w, q0, TRUE);
			return;
		case Kleft:
			if(w-&gt;q0 &gt; 0){
				q0 = w-&gt;q0-1;
				wsetselect(w, q0, q0);
				wshow(w, q0);
			}
			return;
		case Kright:
			if(w-&gt;q1 &lt; w-&gt;nr){
				q1 = w-&gt;q1+1;
				wsetselect(w, q1, q1);
				wshow(w, q1);
			}
			return;
		case Khome:
			wshow(w, 0);
			return;
		case Kend:
			wshow(w, w-&gt;nr);
			return;
		case 0x01:	/* ^A: beginning of line */
			if(w-&gt;q0==0 || w-&gt;q0==w-&gt;qh || w-&gt;r[w-&gt;q0-1]=='\n')
				return;
			nb = wbswidth(w, 0x15 /* ^U */);
			wsetselect(w, w-&gt;q0-nb, w-&gt;q0-nb);
			wshow(w, w-&gt;q0);
			return;
		case 0x05:	/* ^E: end of line */
			q0 = w-&gt;q0;
			while(q0 &lt; w-&gt;nr &amp;&amp; w-&gt;r[q0]!='\n')
				q0++;
			wsetselect(w, q0, q0);
			wshow(w, w-&gt;q0);
			return;
		}
	if(w-&gt;rawing &amp;&amp; (w-&gt;q0==w-&gt;nr || w-&gt;mouseopen)){
		waddraw(w, &amp;r, 1);
		return;
	}
	if(r==0x1B || (w-&gt;holding &amp;&amp; r==0x7F)){	/* toggle hold */
		if(w-&gt;holding)
			--w-&gt;holding;
		else
			w-&gt;holding++;
		wrepaint(w);
		if(r == 0x1B)
			return;
	}
	if(r != 0x7F){
		wsnarf(w);
		wcut(w);
	}
	switch(r){
	case 0x7F:		/* send interrupt */
		w-&gt;qh = w-&gt;nr;
		wshow(w, w-&gt;qh);
		notefd = emalloc(sizeof(int));
		*notefd = w-&gt;notefd;
		proccreate(interruptproc, notefd, 4096);
		return;
	case 0x06:	/* ^F: file name completion */
	case Kins:		/* Insert: file name completion */
		rp = namecomplete(w);
		if(rp == nil)
			return;
		nr = runestrlen(rp);
		q0 = w-&gt;q0;
		q0 = winsert(w, rp, nr, q0);
		wshow(w, q0+nr);
		free(rp);
		return;
	case 0x08:	/* ^H: erase character */
	case 0x15:	/* ^U: erase line */
	case 0x17:	/* ^W: erase word */
		if(w-&gt;q0==0 || w-&gt;q0==w-&gt;qh)
			return;
		nb = wbswidth(w, r);
		q1 = w-&gt;q0;
		q0 = q1-nb;
		if(q0 &lt; w-&gt;org){
			q0 = w-&gt;org;
			nb = q1-q0;
		}
		if(nb &gt; 0){
			wdelete(w, q0, q0+nb);
			wsetselect(w, q0, q0);
		}
		return;
	}
	/* otherwise ordinary character; just insert */
	q0 = w-&gt;q0;
	q0 = winsert(w, &amp;r, 1, q0);
	wshow(w, q0+1);
}

void
wsetcols(Window *w)
{
	if(w-&gt;holding)
		if(w == input)
			w-&gt;cols[TEXT] = w-&gt;cols[HTEXT] = holdcol;
		else
			w-&gt;cols[TEXT] = w-&gt;cols[HTEXT] = lightholdcol;
	else
		if(w == input)
			w-&gt;cols[TEXT] = w-&gt;cols[HTEXT] = display-&gt;black;
		else
			w-&gt;cols[TEXT] = w-&gt;cols[HTEXT] = darkgrey;
}

void
wrepaint(Window *w)
{
	wsetcols(w);
	if(!w-&gt;mouseopen)
		frredraw(w);
	if(w == input){
		wborder(w, Selborder);
		wsetcursor(w, 0);
	}else
		wborder(w, Unselborder);
}

int
wbswidth(Window *w, Rune c)
{
	uint q, eq, stop;
	Rune r;
	int skipping;

	/* there is known to be at least one character to erase */
	if(c == 0x08)	/* ^H: erase character */
		return 1;
	q = w-&gt;q0;
	stop = 0;
	if(q &gt; w-&gt;qh)
		stop = w-&gt;qh;
	skipping = TRUE;
	while(q &gt; stop){
		r = w-&gt;r[q-1];
		if(r == '\n'){		/* eat at most one more character */
			if(q == w-&gt;q0)	/* eat the newline */
				--q;
			break; 
		}
		if(c == 0x17){
			eq = isalnum(r);
			if(eq &amp;&amp; skipping)	/* found one; stop skipping */
				skipping = FALSE;
			else if(!eq &amp;&amp; !skipping)
				break;
		}
		--q;
	}
	return w-&gt;q0-q;
}

void
wsnarf(Window *w)
{
	if(w-&gt;q1 == w-&gt;q0)
		return;
	nsnarf = w-&gt;q1-w-&gt;q0;
	snarf = runerealloc(snarf, nsnarf);
	snarfversion++;	/* maybe modified by parent */
	runemove(snarf, w-&gt;r+w-&gt;q0, nsnarf);
	putsnarf();
}

void
wcut(Window *w)
{
	if(w-&gt;q1 == w-&gt;q0)
		return;
	wdelete(w, w-&gt;q0, w-&gt;q1);
	wsetselect(w, w-&gt;q0, w-&gt;q0);
}

void
wpaste(Window *w)
{
	uint q0;

	if(nsnarf == 0)
		return;
	wcut(w);
	q0 = w-&gt;q0;
	if(w-&gt;rawing &amp;&amp; q0==w-&gt;nr){
		waddraw(w, snarf, nsnarf);
		wsetselect(w, q0, q0);
	}else{
		q0 = winsert(w, snarf, nsnarf, w-&gt;q0);
		wsetselect(w, q0, q0+nsnarf);
	}
}

void
wplumb(Window *w)
{
	Plumbmsg *m;
	static int fd = -2;
	char buf[32];
	uint p0, p1;
	Cursor *c;

	if(fd == -2)
		fd = plumbopen("send", OWRITE|OCEXEC);
	if(fd &lt; 0)
		return;
	m = emalloc(sizeof(Plumbmsg));
	m-&gt;src = estrdup("rio");
	m-&gt;dst = nil;
	m-&gt;wdir = estrdup(w-&gt;dir);
	m-&gt;type = estrdup("text");
	p0 = w-&gt;q0;
	p1 = w-&gt;q1;
	if(w-&gt;q1 &gt; w-&gt;q0)
		m-&gt;attr = nil;
	else{
		while(p0&gt;0 &amp;&amp; w-&gt;r[p0-1]!=' ' &amp;&amp; w-&gt;r[p0-1]!='\t' &amp;&amp; w-&gt;r[p0-1]!='\n')
			p0--;
		while(p1&lt;w-&gt;nr &amp;&amp; w-&gt;r[p1]!=' ' &amp;&amp; w-&gt;r[p1]!='\t' &amp;&amp; w-&gt;r[p1]!='\n')
			p1++;
		sprint(buf, "click=%d", w-&gt;q0-p0);
		m-&gt;attr = plumbunpackattr(buf);
	}
	if(p1-p0 &gt; messagesize-1024){
		plumbfree(m);
		return;	/* too large for 9P */
	}
	m-&gt;data = runetobyte(w-&gt;r+p0, p1-p0, &amp;m-&gt;ndata);
	if(plumbsend(fd, m) &lt; 0){
		c = lastcursor;
		riosetcursor(&amp;query, 1);
		sleep(300);
		riosetcursor(c, 1);
	}
	plumbfree(m);
}

int
winborder(Window *w, Point xy)
{
	return ptinrect(xy, w-&gt;screenr) &amp;&amp; !ptinrect(xy, insetrect(w-&gt;screenr, Selborder));
}

void
wmousectl(Window *w)
{
	int but;

	if(w-&gt;mc.buttons == 1)
		but = 1;
	else if(w-&gt;mc.buttons == 2)
		but = 2;
	else if(w-&gt;mc.buttons == 4)
		but = 3;
	else{
		if(w-&gt;mc.buttons == 8)
			wkeyctl(w, Kscrolloneup);
		if(w-&gt;mc.buttons == 16)
			wkeyctl(w, Kscrollonedown);
		return;
	}

	incref(w);		/* hold up window while we track */
	if(w-&gt;deleted)
		goto Return;
	if(ptinrect(w-&gt;mc.xy, w-&gt;scrollr)){
		if(but)
			wscroll(w, but);
		goto Return;
	}
	if(but == 1)
		wselect(w);
	/* else all is handled by main process */
   Return:
	wclose(w);
}

void
wdelete(Window *w, uint q0, uint q1)
{
	uint n, p0, p1;

	n = q1-q0;
	if(n == 0)
		return;
	runemove(w-&gt;r+q0, w-&gt;r+q1, w-&gt;nr-q1);
	w-&gt;nr -= n;
	if(q0 &lt; w-&gt;q0)
		w-&gt;q0 -= min(n, w-&gt;q0-q0);
	if(q0 &lt; w-&gt;q1)
		w-&gt;q1 -= min(n, w-&gt;q1-q0);
	if(q1 &lt; w-&gt;qh)
		w-&gt;qh -= n;
	else if(q0 &lt; w-&gt;qh)
		w-&gt;qh = q0;
	if(q1 &lt;= w-&gt;org)
		w-&gt;org -= n;
	else if(q0 &lt; w-&gt;org+w-&gt;nchars){
		p1 = q1 - w-&gt;org;
		if(p1 &gt; w-&gt;nchars)
			p1 = w-&gt;nchars;
		if(q0 &lt; w-&gt;org){
			w-&gt;org = q0;
			p0 = 0;
		}else
			p0 = q0 - w-&gt;org;
		frdelete(w, p0, p1);
		wfill(w);
	}
}


static Window	*clickwin;
static uint	clickmsec;
static Window	*selectwin;
static uint	selectq;

/*
 * called from frame library
 */
void
framescroll(Frame *f, int dl)
{
	if(f != &amp;selectwin-&gt;Frame)
		error("frameselect not right frame");
	wframescroll(selectwin, dl);
}

void
wframescroll(Window *w, int dl)
{
	uint q0;

	if(dl == 0){
		wscrsleep(w, 100);
		return;
	}
	if(dl &lt; 0){
		q0 = wbacknl(w, w-&gt;org, -dl);
		if(selectq &gt; w-&gt;org+w-&gt;p0)
			wsetselect(w, w-&gt;org+w-&gt;p0, selectq);
		else
			wsetselect(w, selectq, w-&gt;org+w-&gt;p0);
	}else{
		if(w-&gt;org+w-&gt;nchars == w-&gt;nr)
			return;
		q0 = w-&gt;org+frcharofpt(w, Pt(w-&gt;Frame.r.min.x, w-&gt;Frame.r.min.y+dl*w-&gt;font-&gt;height));
		if(selectq &gt;= w-&gt;org+w-&gt;p1)
			wsetselect(w, w-&gt;org+w-&gt;p1, selectq);
		else
			wsetselect(w, selectq, w-&gt;org+w-&gt;p1);
	}
	wsetorigin(w, q0, TRUE);
}

void
wselect(Window *w)
{
	uint q0, q1;
	int b, x, y, first;

	first = 1;
	selectwin = w;
	/*
	 * Double-click immediately if it might make sense.
	 */
	b = w-&gt;mc.buttons;
	q0 = w-&gt;q0;
	q1 = w-&gt;q1;
	selectq = w-&gt;org+frcharofpt(w, w-&gt;mc.xy);
	if(clickwin==w &amp;&amp; w-&gt;mc.msec-clickmsec&lt;500)
	if(q0==q1 &amp;&amp; selectq==w-&gt;q0){
		wdoubleclick(w, &amp;q0, &amp;q1);
		wsetselect(w, q0, q1);
		flushimage(display, 1);
		x = w-&gt;mc.xy.x;
		y = w-&gt;mc.xy.y;
		/* stay here until something interesting happens */
		do
			readmouse(&amp;w-&gt;mc);
		while(w-&gt;mc.buttons==b &amp;&amp; abs(w-&gt;mc.xy.x-x)&lt;3 &amp;&amp; abs(w-&gt;mc.xy.y-y)&lt;3);
		w-&gt;mc.xy.x = x;	/* in case we're calling frselect */
		w-&gt;mc.xy.y = y;
		q0 = w-&gt;q0;	/* may have changed */
		q1 = w-&gt;q1;
		selectq = q0;
	}
	if(w-&gt;mc.buttons == b){
		w-&gt;scroll = framescroll;
		frselect(w, &amp;w-&gt;mc);
		/* horrible botch: while asleep, may have lost selection altogether */
		if(selectq &gt; w-&gt;nr)
			selectq = w-&gt;org + w-&gt;p0;
		w-&gt;Frame.scroll = nil;
		if(selectq &lt; w-&gt;org)
			q0 = selectq;
		else
			q0 = w-&gt;org + w-&gt;p0;
		if(selectq &gt; w-&gt;org+w-&gt;nchars)
			q1 = selectq;
		else
			q1 = w-&gt;org+w-&gt;p1;
	}
	if(q0 == q1){
		if(q0==w-&gt;q0 &amp;&amp; clickwin==w &amp;&amp; w-&gt;mc.msec-clickmsec&lt;500){
			wdoubleclick(w, &amp;q0, &amp;q1);
			clickwin = nil;
		}else{
			clickwin = w;
			clickmsec = w-&gt;mc.msec;
		}
	}else
		clickwin = nil;
	wsetselect(w, q0, q1);
	flushimage(display, 1);
	while(w-&gt;mc.buttons){
		w-&gt;mc.msec = 0;
		b = w-&gt;mc.buttons;
		if(b &amp; 6){
			if(b &amp; 2){
				wsnarf(w);
				wcut(w);
			}else{
				if(first){
					first = 0;
					getsnarf();
				}
				wpaste(w);
			}
		}
		wscrdraw(w);
		flushimage(display, 1);
		while(w-&gt;mc.buttons == b)
			readmouse(&amp;w-&gt;mc);
		clickwin = nil;
	}
}

void
wsendctlmesg(Window *w, int type, Rectangle r, Image *image)
{
	Wctlmesg wcm;

	wcm.type = type;
	wcm.r = r;
	wcm.image = image;
	send(w-&gt;cctl, &amp;wcm);
}

int
wctlmesg(Window *w, int m, Rectangle r, Image *i)
{
	char buf[64];

	switch(m){
	default:
		error("unknown control message");
		break;
	case Wakeup:
		break;
	case Moved:
	case Reshaped:
		if(w-&gt;deleted){
			freeimage(i);
			break;
		}
		w-&gt;screenr = r;
		strcpy(buf, w-&gt;name);
		wresize(w, i, m==Moved);
		w-&gt;wctlready = 1;
		proccreate(deletetimeoutproc, estrdup(buf), 4096);
		if(Dx(r) &gt; 0){
			if(w != input)
				wcurrent(w);
		}else if(w == input)
			wcurrent(nil);
		flushimage(display, 1);
		break;
	case Refresh:
		if(w-&gt;deleted || Dx(w-&gt;screenr)&lt;=0 || !rectclip(&amp;r, w-&gt;i-&gt;r))
			break;
		if(!w-&gt;mouseopen)
			wrefresh(w, r);
		flushimage(display, 1);
		break;
	case Movemouse:
		if(sweeping || !ptinrect(r.min, w-&gt;i-&gt;r))
			break;
		wmovemouse(w, r.min);
	case Rawon:
		break;
	case Rawoff:
		if(w-&gt;deleted)
			break;
		while(w-&gt;nraw &gt; 0){
			wkeyctl(w, w-&gt;raw[0]);
			--w-&gt;nraw;
			runemove(w-&gt;raw, w-&gt;raw+1, w-&gt;nraw);
		}
		break;
	case Holdon:
	case Holdoff:
		if(w-&gt;deleted)
			break;
		wrepaint(w);
		flushimage(display, 1);
		break;
	case Deleted:
		if(w-&gt;deleted)
			break;
		write(w-&gt;notefd, "hangup", 6);
		proccreate(deletetimeoutproc, estrdup(w-&gt;name), 4096);
		wclosewin(w);
		break;
	case Exited:
		frclear(w, TRUE);
		close(w-&gt;notefd);
		chanfree(w-&gt;mc.c);
		chanfree(w-&gt;ck);
		chanfree(w-&gt;cctl);
		chanfree(w-&gt;conswrite);
		chanfree(w-&gt;consread);
		chanfree(w-&gt;mouseread);
		chanfree(w-&gt;wctlread);
		free(w-&gt;raw);
		free(w-&gt;r);
		free(w-&gt;dir);
		free(w-&gt;label);
		free(w);
		break;
	}
	return m;
}

/*
 * Convert back to physical coordinates
 */
void
wmovemouse(Window *w, Point p)
{
	p.x += w-&gt;screenr.min.x-w-&gt;i-&gt;r.min.x;
	p.y += w-&gt;screenr.min.y-w-&gt;i-&gt;r.min.y;
	moveto(mousectl, p);
}

void
wborder(Window *w, int type)
{
	Image *col;

	if(w-&gt;i == nil)
		return;
	if(w-&gt;holding){
		if(type == Selborder)
			col = holdcol;
		else
			col = paleholdcol;
	}else{
		if(type == Selborder)
			col = titlecol;
		else
			col = lighttitlecol;
	}

	border(w-&gt;i, w-&gt;i-&gt;r, Selborder, col, ZP);
}

Window*
wpointto(Point pt)
{
	int i;
	Window *v, *w;

	w = nil;
	for(i=0; i&lt;nwindow; i++){
		v = window[i];
		if(ptinrect(pt, v-&gt;screenr))
		if(!v-&gt;deleted)
		if(w==nil || v-&gt;topped&gt;w-&gt;topped)
			w = v;
	}
	return w;
}

void
wcurrent(Window *w)
{
	Window *oi;

	if(wkeyboard!=nil &amp;&amp; w==wkeyboard)
		return;
	oi = input;
	input = w;
	if(oi!=w &amp;&amp; oi!=nil)
		wrepaint(oi);
	if(w !=nil){
		wrepaint(w);
		wsetcursor(w, 0);
	}
	if(w != oi){
		if(oi){
			oi-&gt;wctlready = 1;
			wsendctlmesg(oi, Wakeup, ZR, nil);
		}
		if(w){
			w-&gt;wctlready = 1;
			wsendctlmesg(w, Wakeup, ZR, nil);
		}
	}
}

void
wsetcursor(Window *w, int force)
{
	Cursor *p;

	if(w==nil || /*w!=input || */ w-&gt;i==nil || Dx(w-&gt;screenr)&lt;=0)
		p = nil;
	else if(wpointto(mouse-&gt;xy) == w){
		p = w-&gt;cursorp;
		if(p==nil &amp;&amp; w-&gt;holding)
			p = &amp;whitearrow;
	}else
		p = nil;
	if(!menuing)
		riosetcursor(p, force &amp;&amp; !menuing);
}

void
riosetcursor(Cursor *p, int force)
{
	if(!force &amp;&amp; p==lastcursor)
		return;
	setcursor(mousectl, p);
	lastcursor = p;
}

Window*
wtop(Point pt)
{
	Window *w;

	w = wpointto(pt);
	if(w){
		if(w-&gt;topped == topped)
			return nil;
		topwindow(w-&gt;i);
		wcurrent(w);
		flushimage(display, 1);
		w-&gt;topped = ++topped;
	}
	return w;
}

void
wtopme(Window *w)
{
	if(w!=nil &amp;&amp; w-&gt;i!=nil &amp;&amp; !w-&gt;deleted &amp;&amp; w-&gt;topped!=topped){
		topwindow(w-&gt;i);
		flushimage(display, 1);
		w-&gt;topped = ++ topped;
	}
}

void
wbottomme(Window *w)
{
	if(w!=nil &amp;&amp; w-&gt;i!=nil &amp;&amp; !w-&gt;deleted){
		bottomwindow(w-&gt;i);
		flushimage(display, 1);
		w-&gt;topped = - ++topped;
	}
}

Window*
wlookid(int id)
{
	int i;

	for(i=0; i&lt;nwindow; i++)
		if(window[i]-&gt;id == id)
			return window[i];
	return nil;
}

void
wclosewin(Window *w)
{
	Rectangle r;
	int i;

	w-&gt;deleted = TRUE;
	if(w == input){
		input = nil;
		wsetcursor(w, 0);
	}
	if(w == wkeyboard)
		wkeyboard = nil;
	for(i=0; i&lt;nhidden; i++)
		if(hidden[i] == w){
			--nhidden;
			memmove(hidden+i, hidden+i+1, (nhidden-i)*sizeof(hidden[0]));
			hidden[nhidden] = nil;
			break;
		}
	for(i=0; i&lt;nwindow; i++)
		if(window[i] == w){
			--nwindow;
			memmove(window+i, window+i+1, (nwindow-i)*sizeof(Window*));
			w-&gt;deleted = TRUE;
			r = w-&gt;i-&gt;r;
			/* move it off-screen to hide it, in case client is slow in letting it go */
			MOVEIT originwindow(w-&gt;i, r.min, view-&gt;r.max);
			freeimage(w-&gt;i);
			w-&gt;i = nil;
			return;
		}
	error("unknown window in closewin");
}

void
wsetpid(Window *w, int pid, int dolabel)
{
	char buf[128];
	int fd;

	w-&gt;pid = pid;
	if(dolabel){
		sprint(buf, "rc %d", pid);
		free(w-&gt;label);
		w-&gt;label = estrdup(buf);
	}
	sprint(buf, "/proc/%d/notepg", pid);
	fd = open(buf, OWRITE|OCEXEC);
	if(w-&gt;notefd &gt; 0)
		close(w-&gt;notefd);
	w-&gt;notefd = fd;
}

void
winshell(void *args)
{
	Window *w;
	Channel *pidc;
	void **arg;
	char *cmd, *dir;
	char **argv;

	arg = args;
	w = arg[0];
	pidc = arg[1];
	cmd = arg[2];
	argv = arg[3];
	dir = arg[4];
	rfork(RFNAMEG|RFFDG|RFENVG);
	if(filsysmount(filsys, w-&gt;id) &lt; 0){
		fprint(2, "mount failed: %r\n");
		sendul(pidc, 0);
		threadexits("mount failed");
	}
	close(0);
	if(open("/dev/cons", OREAD) &lt; 0){
		fprint(2, "can't open /dev/cons: %r\n");
		sendul(pidc, 0);
		threadexits("/dev/cons");
	}
	close(1);
	if(open("/dev/cons", OWRITE) &lt; 0){
		fprint(2, "can't open /dev/cons: %r\n");
		sendul(pidc, 0);
		threadexits("open");	/* BUG? was terminate() */
	}
	if(wclose(w) == 0){	/* remove extra ref hanging from creation */
		notify(nil);
		dup(1, 2);
		if(dir)
			chdir(dir);
		procexec(pidc, cmd, argv);
		_exits("exec failed");
	}
}

static Rune left1[] =  { L'{', L'[', L'(', L'&lt;', L'«', 0 };
static Rune right1[] = { L'}', L']', L')', L'&gt;', L'»', 0 };
static Rune left2[] =  { L'\n', 0 };
static Rune left3[] =  { L'\'', L'"', L'`', 0 };

Rune *left[] = {
	left1,
	left2,
	left3,
	nil
};
Rune *right[] = {
	right1,
	left2,
	left3,
	nil
};

void
wdoubleclick(Window *w, uint *q0, uint *q1)
{
	int c, i;
	Rune *r, *l, *p;
	uint q;

	for(i=0; left[i]!=nil; i++){
		q = *q0;
		l = left[i];
		r = right[i];
		/* try matching character to left, looking right */
		if(q == 0)
			c = '\n';
		else
			c = w-&gt;r[q-1];
		p = strrune(l, c);
		if(p != nil){
			if(wclickmatch(w, c, r[p-l], 1, &amp;q))
				*q1 = q-(c!='\n');
			return;
		}
		/* try matching character to right, looking left */
		if(q == w-&gt;nr)
			c = '\n';
		else
			c = w-&gt;r[q];
		p = strrune(r, c);
		if(p != nil){
			if(wclickmatch(w, c, l[p-r], -1, &amp;q)){
				*q1 = *q0+(*q0&lt;w-&gt;nr &amp;&amp; c=='\n');
				*q0 = q;
				if(c!='\n' || q!=0 || w-&gt;r[0]=='\n')
					(*q0)++;
			}
			return;
		}
	}
	/* try filling out word to right */
	while(*q1&lt;w-&gt;nr &amp;&amp; isalnum(w-&gt;r[*q1]))
		(*q1)++;
	/* try filling out word to left */
	while(*q0&gt;0 &amp;&amp; isalnum(w-&gt;r[*q0-1]))
		(*q0)--;
}

int
wclickmatch(Window *w, int cl, int cr, int dir, uint *q)
{
	Rune c;
	int nest;

	nest = 1;
	for(;;){
		if(dir &gt; 0){
			if(*q == w-&gt;nr)
				break;
			c = w-&gt;r[*q];
			(*q)++;
		}else{
			if(*q == 0)
				break;
			(*q)--;
			c = w-&gt;r[*q];
		}
		if(c == cr){
			if(--nest==0)
				return 1;
		}else if(c == cl)
			nest++;
	}
	return cl=='\n' &amp;&amp; nest==1;
}


uint
wbacknl(Window *w, uint p, uint n)
{
	int i, j;

	/* look for start of this line if n==0 */
	if(n==0 &amp;&amp; p&gt;0 &amp;&amp; w-&gt;r[p-1]!='\n')
		n = 1;
	i = n;
	while(i--&gt;0 &amp;&amp; p&gt;0){
		--p;	/* it's at a newline now; back over it */
		if(p == 0)
			break;
		/* at 128 chars, call it a line anyway */
		for(j=128; --j&gt;0 &amp;&amp; p&gt;0; p--)
			if(w-&gt;r[p-1]=='\n')
				break;
	}
	return p;
}

void
wshow(Window *w, uint q0)
{
	int qe;
	int nl;
	uint q;

	qe = w-&gt;org+w-&gt;nchars;
	if(w-&gt;org&lt;=q0 &amp;&amp; (q0&lt;qe || (q0==qe &amp;&amp; qe==w-&gt;nr)))
		wscrdraw(w);
	else{
		nl = 4*w-&gt;maxlines/5;
		q = wbacknl(w, q0, nl);
		/* avoid going backwards if trying to go forwards - long lines! */
		if(!(q0&gt;w-&gt;org &amp;&amp; q&lt;w-&gt;org))
			wsetorigin(w, q, TRUE);
		while(q0 &gt; w-&gt;org+w-&gt;nchars)
			wsetorigin(w, w-&gt;org+1, FALSE);
	}
}

void
wsetorigin(Window *w, uint org, int exact)
{
	int i, a, fixup;
	Rune *r;
	uint n;

	if(org&gt;0 &amp;&amp; !exact){
		/* org is an estimate of the char posn; find a newline */
		/* don't try harder than 256 chars */
		for(i=0; i&lt;256 &amp;&amp; org&lt;w-&gt;nr; i++){
			if(w-&gt;r[org] == '\n'){
				org++;
				break;
			}
			org++;
		}
	}
	a = org-w-&gt;org;
	fixup = 0;
	if(a&gt;=0 &amp;&amp; a&lt;w-&gt;nchars){
		frdelete(w, 0, a);
		fixup = 1;	/* frdelete can leave end of last line in wrong selection mode; it doesn't know what follows */
	}else if(a&lt;0 &amp;&amp; -a&lt;w-&gt;nchars){
		n = w-&gt;org - org;
		r = runemalloc(n);
		runemove(r, w-&gt;r+org, n);
		frinsert(w, r, r+n, 0);
		free(r);
	}else
		frdelete(w, 0, w-&gt;nchars);
	w-&gt;org = org;
	wfill(w);
	wscrdraw(w);
	wsetselect(w, w-&gt;q0, w-&gt;q1);
	if(fixup &amp;&amp; w-&gt;p1 &gt; w-&gt;p0)
		frdrawsel(w, frptofchar(w, w-&gt;p1-1), w-&gt;p1-1, w-&gt;p1, 1);
}

void
wsetselect(Window *w, uint q0, uint q1)
{
	int p0, p1;

	/* w-&gt;p0 and w-&gt;p1 are always right; w-&gt;q0 and w-&gt;q1 may be off */
	w-&gt;q0 = q0;
	w-&gt;q1 = q1;
	/* compute desired p0,p1 from q0,q1 */
	p0 = q0-w-&gt;org;
	p1 = q1-w-&gt;org;
	if(p0 &lt; 0)
		p0 = 0;
	if(p1 &lt; 0)
		p1 = 0;
	if(p0 &gt; w-&gt;nchars)
		p0 = w-&gt;nchars;
	if(p1 &gt; w-&gt;nchars)
		p1 = w-&gt;nchars;
	if(p0==w-&gt;p0 &amp;&amp; p1==w-&gt;p1)
		return;
	/* screen disagrees with desired selection */
	if(w-&gt;p1&lt;=p0 || p1&lt;=w-&gt;p0 || p0==p1 || w-&gt;p1==w-&gt;p0){
		/* no overlap or too easy to bother trying */
		frdrawsel(w, frptofchar(w, w-&gt;p0), w-&gt;p0, w-&gt;p1, 0);
		frdrawsel(w, frptofchar(w, p0), p0, p1, 1);
		goto Return;
	}
	/* overlap; avoid unnecessary painting */
	if(p0 &lt; w-&gt;p0){
		/* extend selection backwards */
		frdrawsel(w, frptofchar(w, p0), p0, w-&gt;p0, 1);
	}else if(p0 &gt; w-&gt;p0){
		/* trim first part of selection */
		frdrawsel(w, frptofchar(w, w-&gt;p0), w-&gt;p0, p0, 0);
	}
	if(p1 &gt; w-&gt;p1){
		/* extend selection forwards */
		frdrawsel(w, frptofchar(w, w-&gt;p1), w-&gt;p1, p1, 1);
	}else if(p1 &lt; w-&gt;p1){
		/* trim last part of selection */
		frdrawsel(w, frptofchar(w, p1), p1, w-&gt;p1, 0);
	}

    Return:
	w-&gt;p0 = p0;
	w-&gt;p1 = p1;
}

uint
winsert(Window *w, Rune *r, int n, uint q0)
{
	uint m;

	if(n == 0)
		return q0;
	if(w-&gt;nr+n&gt;HiWater &amp;&amp; q0&gt;=w-&gt;org &amp;&amp; q0&gt;=w-&gt;qh){
		m = min(HiWater-LoWater, min(w-&gt;org, w-&gt;qh));
		w-&gt;org -= m;
		w-&gt;qh -= m;
		if(w-&gt;q0 &gt; m)
			w-&gt;q0 -= m;
		else
			w-&gt;q0 = 0;
		if(w-&gt;q1 &gt; m)
			w-&gt;q1 -= m;
		else
			w-&gt;q1 = 0;
		w-&gt;nr -= m;
		runemove(w-&gt;r, w-&gt;r+m, w-&gt;nr);
		q0 -= m;
	}
	if(w-&gt;nr+n &gt; w-&gt;maxr){
		/*
		 * Minimize realloc breakage:
		 *	Allocate at least MinWater
		 * 	Double allocation size each time
		 *	But don't go much above HiWater
		 */
		m = max(min(2*(w-&gt;nr+n), HiWater), w-&gt;nr+n)+MinWater;
		if(m &gt; HiWater)
			m = max(HiWater+MinWater, w-&gt;nr+n);
		if(m &gt; w-&gt;maxr){
			w-&gt;r = runerealloc(w-&gt;r, m);
			w-&gt;maxr = m;
		}
	}
	runemove(w-&gt;r+q0+n, w-&gt;r+q0, w-&gt;nr-q0);
	runemove(w-&gt;r+q0, r, n);
	w-&gt;nr += n;
	/* if output touches, advance selection, not qh; works best for keyboard and output */
	if(q0 &lt;= w-&gt;q1)
		w-&gt;q1 += n;
	if(q0 &lt;= w-&gt;q0)
		w-&gt;q0 += n;
	if(q0 &lt; w-&gt;qh)
		w-&gt;qh += n;
	if(q0 &lt; w-&gt;org)
		w-&gt;org += n;
	else if(q0 &lt;= w-&gt;org+w-&gt;nchars)
		frinsert(w, r, r+n, q0-w-&gt;org);
	return q0;
}

void
wfill(Window *w)
{
	Rune *rp;
	int i, n, m, nl;

	if(w-&gt;lastlinefull)
		return;
	rp = malloc(messagesize);
	do{
		n = w-&gt;nr-(w-&gt;org+w-&gt;nchars);
		if(n == 0)
			break;
		if(n &gt; 2000)	/* educated guess at reasonable amount */
			n = 2000;
		runemove(rp, w-&gt;r+(w-&gt;org+w-&gt;nchars), n);
		/*
		 * it's expensive to frinsert more than we need, so
		 * count newlines.
		 */
		nl = w-&gt;maxlines-w-&gt;nlines;
		m = 0;
		for(i=0; i&lt;n; ){
			if(rp[i++] == '\n'){
				m++;
				if(m &gt;= nl)
					break;
			}
		}
		frinsert(w, rp, rp+i, w-&gt;nchars);
	}while(w-&gt;lastlinefull == FALSE);
	free(rp);
}

char*
wcontents(Window *w, int *ip)
{
	return runetobyte(w-&gt;r, w-&gt;nr, ip);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

