<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/address.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/address.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"
#include "parse.h"

Address	addr;
String	lastpat;
int	patset;
File	*menu;

File	*matchfile(String*);
Address	charaddr(Posn, Address, int);

Address
address(Addr *ap, Address a, int sign)
{
	File *f = a.f;
	Address a1, a2;

	do{
		switch(ap-&gt;type){
		case 'l':
		case '#':
			a = (*(ap-&gt;type=='#'?charaddr:lineaddr))(ap-&gt;num, a, sign);
			break;

		case '.':
			a = f-&gt;dot;
			break;

		case '$':
			a.r.p1 = a.r.p2 = f-&gt;nc;
			break;

		case '\'':
			a.r = f-&gt;mark;
			break;

		case '?':
			sign = -sign;
			if(sign == 0)
				sign = -1;
			/* fall through */
		case '/':
			nextmatch(f, ap-&gt;are, sign&gt;=0? a.r.p2 : a.r.p1, sign);
			a.r = sel.p[0];
			break;

		case '"':
			a = matchfile(ap-&gt;are)-&gt;dot;
			f = a.f;
			if(f-&gt;unread)
				load(f);
			break;

		case '*':
			a.r.p1 = 0, a.r.p2 = f-&gt;nc;
			return a;

		case ',':
		case ';':
			if(ap-&gt;left)
				a1 = address(ap-&gt;left, a, 0);
			else
				a1.f = a.f, a1.r.p1 = a1.r.p2 = 0;
			if(ap-&gt;type == ';'){
				f = a1.f;
				a = a1;
				f-&gt;dot = a1;
			}
			if(ap-&gt;next)
				a2 = address(ap-&gt;next, a, 0);
			else
				a2.f = a.f, a2.r.p1 = a2.r.p2 = f-&gt;nc;
			if(a1.f != a2.f)
				error(Eorder);
			a.f = a1.f, a.r.p1 = a1.r.p1, a.r.p2 = a2.r.p2;
			if(a.r.p2 &lt; a.r.p1)
				error(Eorder);
			return a;

		case '+':
		case '-':
			sign = 1;
			if(ap-&gt;type == '-')
				sign = -1;
			if(ap-&gt;next==0 || ap-&gt;next-&gt;type=='+' || ap-&gt;next-&gt;type=='-')
				a = lineaddr(1L, a, sign);
			break;
		default:
			panic("address");
			return a;
		}
	}while(ap = ap-&gt;next);	/* assign = */
	return a;
}

void
nextmatch(File *f, String *r, Posn p, int sign)
{
	compile(r);
	if(sign &gt;= 0){
		if(!execute(f, p, INFINITY))
			error(Esearch);
		if(sel.p[0].p1==sel.p[0].p2 &amp;&amp; sel.p[0].p1==p){
			if(++p&gt;f-&gt;nc)
				p = 0;
			if(!execute(f, p, INFINITY))
				panic("address");
		}
	}else{
		if(!bexecute(f, p))
			error(Esearch);
		if(sel.p[0].p1==sel.p[0].p2 &amp;&amp; sel.p[0].p2==p){
			if(--p&lt;0)
				p = f-&gt;nc;
			if(!bexecute(f, p))
				panic("address");
		}
	}
}

File *
matchfile(String *r)
{
	File *f;
	File *match = 0;
	int i;

	for(i = 0; i&lt;file.nused; i++){
		f = file.filepptr[i];
		if(f == cmd)
			continue;
		if(filematch(f, r)){
			if(match)
				error(Emanyfiles);
			match = f;
		}
	}
	if(!match)
		error(Efsearch);
	return match;
}

int
filematch(File *f, String *r)
{
	char *c, buf[STRSIZE+100];
	String *t;

	c = Strtoc(&amp;f-&gt;name);
	sprint(buf, "%c%c%c %s\n", " '"[f-&gt;mod],
		"-+"[f-&gt;rasp!=0], " ."[f==curfile], c);
	free(c);
	t = tmpcstr(buf);
	Strduplstr(&amp;genstr, t);
	freetmpstr(t);
	/* A little dirty... */
	if(menu == 0)
		menu = fileopen();
	bufreset(menu);
	bufinsert(menu, 0, genstr.s, genstr.n);
	compile(r);
	return execute(menu, 0, menu-&gt;nc);
}

Address
charaddr(Posn l, Address addr, int sign)
{
	if(sign == 0)
		addr.r.p1 = addr.r.p2 = l;
	else if(sign &lt; 0)
		addr.r.p2 = addr.r.p1-=l;
	else if(sign &gt; 0)
		addr.r.p1 = addr.r.p2+=l;
	if(addr.r.p1&lt;0 || addr.r.p2&gt;addr.f-&gt;nc)
		error(Erange);
	return addr;
}

Address
lineaddr(Posn l, Address addr, int sign)
{
	int n;
	int c;
	File *f = addr.f;
	Address a;
	Posn p;

	a.f = f;
	if(sign &gt;= 0){
		if(l == 0){
			if(sign==0 || addr.r.p2==0){
				a.r.p1 = a.r.p2 = 0;
				return a;
			}
			a.r.p1 = addr.r.p2;
			p = addr.r.p2-1;
		}else{
			if(sign==0 || addr.r.p2==0){
				p = (Posn)0;
				n = 1;
			}else{
				p = addr.r.p2-1;
				n = filereadc(f, p++)=='\n';
			}
			while(n &lt; l){
				if(p &gt;= f-&gt;nc)
					error(Erange);
				if(filereadc(f, p++) == '\n')
					n++;
			}
			a.r.p1 = p;
		}
		while(p &lt; f-&gt;nc &amp;&amp; filereadc(f, p++)!='\n')
			;
		a.r.p2 = p;
	}else{
		p = addr.r.p1;
		if(l == 0)
			a.r.p2 = addr.r.p1;
		else{
			for(n = 0; n&lt;l; ){	/* always runs once */
				if(p == 0){
					if(++n != l)
						error(Erange);
				}else{
					c = filereadc(f, p-1);
					if(c != '\n' || ++n != l)
						p--;
				}
			}
			a.r.p2 = p;
			if(p &gt; 0)
				p--;
		}
		while(p &gt; 0 &amp;&amp; filereadc(f, p-1)!='\n')	/* lines start after a newline */
			p--;
		a.r.p1 = p;
	}
	return a;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

