<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/rasp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/rasp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"
/*
 * GROWDATASIZE must be big enough that all errors go out as Hgrowdata's,
 * so they will be scrolled into visibility in the ~~sam~~ window (yuck!).
 */
#define	GROWDATASIZE	50	/* if size is &gt; this, send data with grow */

void	rcut(List*, Posn, Posn);
int	rterm(List*, Posn);
void	rgrow(List*, Posn, Posn);

static	Posn	growpos;
static	Posn	grown;
static	Posn	shrinkpos;
static	Posn	shrunk;

/*
 * rasp routines inform the terminal of changes to the file.
 *
 * a rasp is a list of spans within the file, and an indication
 * of whether the terminal knows about the span.
 *
 * optimize by coalescing multiple updates to the same span
 * if it is not known by the terminal.
 *
 * other possible optimizations: flush terminal's rasp by cut everything,
 * insert everything if rasp gets too large.
 */

/*
 * only called for initial load of file
 */
void
raspload(File *f)
{
	if(f-&gt;rasp == nil)
		return;
	grown = f-&gt;nc;
	growpos = 0;
	if(f-&gt;nc)
		rgrow(f-&gt;rasp, 0, f-&gt;nc);
	raspdone(f, 1);
}

void
raspstart(File *f)
{
	if(f-&gt;rasp == nil)
		return;
	grown = 0;
	shrunk = 0;
	outbuffered = 1;
}

void
raspdone(File *f, int toterm)
{
	if(f-&gt;dot.r.p1 &gt; f-&gt;nc)
		f-&gt;dot.r.p1 = f-&gt;nc;
	if(f-&gt;dot.r.p2 &gt; f-&gt;nc)
		f-&gt;dot.r.p2 = f-&gt;nc;
	if(f-&gt;mark.p1 &gt; f-&gt;nc)
		f-&gt;mark.p1 = f-&gt;nc;
	if(f-&gt;mark.p2 &gt; f-&gt;nc)
		f-&gt;mark.p2 = f-&gt;nc;
	if(f-&gt;rasp == nil)
		return;
	if(grown)
		outTsll(Hgrow, f-&gt;tag, growpos, grown);
	else if(shrunk)
		outTsll(Hcut, f-&gt;tag, shrinkpos, shrunk);
	if(toterm)
		outTs(Hcheck0, f-&gt;tag);
	outflush();
	outbuffered = 0;
	if(f == cmd){
		cmdpt += cmdptadv;
		cmdptadv = 0;
	}
}

void
raspflush(File *f)
{
	if(grown){
		outTsll(Hgrow, f-&gt;tag, growpos, grown);
		grown = 0;
	}
	else if(shrunk){
		outTsll(Hcut, f-&gt;tag, shrinkpos, shrunk);
		shrunk = 0;
	}
	outflush();
}

void
raspdelete(File *f, uint p1, uint p2, int toterm)
{
	long n;

	n = p2 - p1;
	if(n == 0)
		return;

	if(p2 &lt;= f-&gt;dot.r.p1){
		f-&gt;dot.r.p1 -= n;
		f-&gt;dot.r.p2 -= n;
	}
	if(p2 &lt;= f-&gt;mark.p1){
		f-&gt;mark.p1 -= n;
		f-&gt;mark.p2 -= n;
	}

	if(f-&gt;rasp == nil)
		return;

	if(f==cmd &amp;&amp; p1&lt;cmdpt){
		if(p2 &lt;= cmdpt)
			cmdpt -= n;
		else
			cmdpt = p1;
	}
	if(toterm){
		if(grown){
			outTsll(Hgrow, f-&gt;tag, growpos, grown);
			grown = 0;
		}else if(shrunk &amp;&amp; shrinkpos!=p1 &amp;&amp; shrinkpos!=p2){
			outTsll(Hcut, f-&gt;tag, shrinkpos, shrunk);
			shrunk = 0;
		}
		if(!shrunk || shrinkpos==p2)
			shrinkpos = p1;
		shrunk += n;
	}
	rcut(f-&gt;rasp, p1, p2);
}

void
raspinsert(File *f, uint p1, Rune *buf, uint n, int toterm)
{
	Range r;

	if(n == 0)
		return;

	if(p1 &lt; f-&gt;dot.r.p1){
		f-&gt;dot.r.p1 += n;
		f-&gt;dot.r.p2 += n;
	}
	if(p1 &lt; f-&gt;mark.p1){
		f-&gt;mark.p1 += n;
		f-&gt;mark.p2 += n;
	}


	if(f-&gt;rasp == nil)
		return;
	if(f==cmd &amp;&amp; p1&lt;cmdpt)
		cmdpt += n;
	if(toterm){
		if(shrunk){
			outTsll(Hcut, f-&gt;tag, shrinkpos, shrunk);
			shrunk = 0;
		}
		if(n&gt;GROWDATASIZE || !rterm(f-&gt;rasp, p1)){
			rgrow(f-&gt;rasp, p1, n);
			if(grown &amp;&amp; growpos+grown!=p1 &amp;&amp; growpos!=p1){
				outTsll(Hgrow, f-&gt;tag, growpos, grown);
				grown = 0;
			}
			if(!grown)
				growpos = p1;
			grown += n;
		}else{
			if(grown){
				outTsll(Hgrow, f-&gt;tag, growpos, grown);
				grown = 0;
			}
			rgrow(f-&gt;rasp, p1, n);
			r = rdata(f-&gt;rasp, p1, n);
			if(r.p1!=p1 || r.p2!=p1+n)
				panic("rdata in toterminal");
			outTsllS(Hgrowdata, f-&gt;tag, p1, n, tmprstr(buf, n));
		}
	}else{
		rgrow(f-&gt;rasp, p1, n);
		r = rdata(f-&gt;rasp, p1, n);
		if(r.p1!=p1 || r.p2!=p1+n)
			panic("rdata in toterminal");
	}
}

#define	M	0x80000000L
#define	P(i)	r-&gt;posnptr[i]
#define	T(i)	(P(i)&amp;M)	/* in terminal */
#define	L(i)	(P(i)&amp;~M)	/* length of this piece */

void
rcut(List *r, Posn p1, Posn p2)
{
	Posn p, x;
	int i;

	if(p1 == p2)
		panic("rcut 0");
	for(p=0,i=0; i&lt;r-&gt;nused &amp;&amp; p+L(i)&lt;=p1; p+=L(i++))
		;
	if(i == r-&gt;nused)
		panic("rcut 1");
	if(p &lt; p1){	/* chop this piece */
		if(p+L(i) &lt; p2){
			x = p1-p;
			p += L(i);
		}else{
			x = L(i)-(p2-p1);
			p = p2;
		}
		if(T(i))
			P(i) = x|M;
		else
			P(i) = x;
		i++;
	}
	while(i&lt;r-&gt;nused &amp;&amp; p+L(i)&lt;=p2){
		p += L(i);
		dellist(r, i);
	}
	if(p &lt; p2){
		if(i == r-&gt;nused)
			panic("rcut 2");
		x = L(i)-(p2-p);
		if(T(i))
			P(i) = x|M;
		else
			P(i) = x;
	}
	/* can we merge i and i-1 ? */
	if(i&gt;0 &amp;&amp; i&lt;r-&gt;nused &amp;&amp; T(i-1)==T(i)){
		x = L(i-1)+L(i);
		dellist(r, i--);
		if(T(i))
			P(i)=x|M;
		else
			P(i)=x;
	}
}

void
rgrow(List *r, Posn p1, Posn n)
{
	Posn p;
	int i;

	if(n == 0)
		panic("rgrow 0");
	for(p=0,i=0; i&lt;r-&gt;nused &amp;&amp; p+L(i)&lt;=p1; p+=L(i++))
		;
	if(i == r-&gt;nused){	/* stick on end of file */
		if(p!=p1)
			panic("rgrow 1");
		if(i&gt;0 &amp;&amp; !T(i-1))
			P(i-1)+=n;
		else
			inslist(r, i, n);
	}else if(!T(i))		/* goes in this empty piece */
		P(i)+=n;
	else if(p==p1 &amp;&amp; i&gt;0 &amp;&amp; !T(i-1))	/* special case; simplifies life */
		P(i-1)+=n;
	else if(p==p1)
		inslist(r, i, n);
	else{			/* must break piece in terminal */
		inslist(r, i+1, (L(i)-(p1-p))|M);
		inslist(r, i+1, n);
		P(i) = (p1-p)|M;
	}
}

int
rterm(List *r, Posn p1)
{
	Posn p;
	int i;

	for(p = 0,i = 0; i&lt;r-&gt;nused &amp;&amp; p+L(i)&lt;=p1; p+=L(i++))
		;
	if(i==r-&gt;nused &amp;&amp; (i==0 || !T(i-1)))
		return 0;
	return T(i);
}

Range
rdata(List *r, Posn p1, Posn n)
{
	Posn p;
	int i;
	Range rg;

	if(n==0)
		panic("rdata 0");
	for(p = 0,i = 0; i&lt;r-&gt;nused &amp;&amp; p+L(i)&lt;=p1; p+=L(i++))
		;
	if(i==r-&gt;nused)
		panic("rdata 1");
	if(T(i)){
		n-=L(i)-(p1-p);
		if(n&lt;=0){
			rg.p1 = rg.p2 = p1;
			return rg;
		}
		p+=L(i++);
		p1 = p;
	}
	if(T(i) || i==r-&gt;nused)
		panic("rdata 2");
	if(p+L(i)&lt;p1+n)
		n = L(i)-(p1-p);
	rg.p1 = p1;
	rg.p2 = p1+n;
	if(p!=p1){
		inslist(r, i+1, L(i)-(p1-p));
		P(i)=p1-p;
		i++;
	}
	if(L(i)!=n){
		inslist(r, i+1, L(i)-n);
		P(i)=n;
	}
	P(i)|=M;
	/* now i is set; can we merge? */
	if(i&lt;r-&gt;nused-1 &amp;&amp; T(i+1)){
		P(i)=(n+=L(i+1))|M;
		dellist(r, i+1);
	}
	if(i&gt;0 &amp;&amp; T(i-1)){
		P(i)=(n+L(i-1))|M;
		dellist(r, i-1);
	}
	return rg;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

