<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/regexp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/regexp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"

Rangeset	sel;
String		lastregexp;
/*
 * Machine Information
 */
typedef struct Inst Inst;

struct Inst
{
	long	type;	/* &lt;= Runemax ==&gt; literal, otherwise action */
	union {
		int rsid;
		int rsubid;
		int class;
		struct Inst *rother;
		struct Inst *rright;
	} r;
	union{
		struct Inst *lleft;
		struct Inst *lnext;
	} l;
};
#define	sid	r.rsid
#define	subid	r.rsubid
#define	rclass	r.class
#define	other	r.rother
#define	right	r.rright
#define	left	l.lleft
#define	next	l.lnext

#define	NPROG	1024
Inst	program[NPROG];
Inst	*progp;
Inst	*startinst;	/* First inst. of program; might not be program[0] */
Inst	*bstartinst;	/* same for backwards machine */

typedef struct Ilist Ilist;
struct Ilist
{
	Inst	*inst;		/* Instruction of the thread */
	Rangeset se;
	Posn	startp;		/* first char of match */
};

#define	NLIST	127

Ilist	*tl, *nl;		/* This list, next list */
Ilist	list[2][NLIST+1];	/* +1 for trailing null */
static	Rangeset sempty;

/*
 * Actions and Tokens
 *
 *	0x100xx are operators, value == precedence
 *	0x200xx are tokens, i.e. operands for operators
 */
enum {
	OPERATOR = Runemask+1,	/* Bitmask of all operators */
	START	= OPERATOR,	/* Start, used for marker on stack */
	RBRA,			/* Right bracket, ) */
	LBRA,			/* Left bracket, ( */
	OR,			/* Alternation, | */
	CAT,			/* Concatentation, implicit operator */
	STAR,			/* Closure, * */
	PLUS,			/* a+ == aa* */
	QUEST,			/* a? == a|nothing, i.e. 0 or 1 a's */

	ANY	= OPERATOR&lt;&lt;1,	/* Any character but newline, . */
	NOP,			/* No operation, internal use only */
	BOL,			/* Beginning of line, ^ */
	EOL,			/* End of line, $ */
	CCLASS,			/* Character class, [] */
	NCCLASS,		/* Negated character class, [^] */
	END,			/* Terminate: match found */

	ISATOR	= OPERATOR,
	ISAND	= OPERATOR&lt;&lt;1,
};

/*
 * Parser Information
 */
typedef struct Node Node;
struct Node
{
	Inst	*first;
	Inst	*last;
};

#define	NSTACK	20
Node	andstack[NSTACK];
Node	*andp;
int	atorstack[NSTACK];
int	*atorp;
int	lastwasand;	/* Last token was operand */
int	cursubid;
int	subidstack[NSTACK];
int	*subidp;
int	backwards;
int	nbra;
Rune	*exprp;		/* pointer to next character in source expression */
#define	DCLASS	10	/* allocation increment */
int	nclass;		/* number active */
int	Nclass;		/* high water mark */
Rune	**class;
int	negateclass;

int	addinst(Ilist *l, Inst *inst, Rangeset *sep);
void	newmatch(Rangeset*);
void	bnewmatch(Rangeset*);
void	pushand(Inst*, Inst*);
void	pushator(int);
Node	*popand(int);
int	popator(void);
void	startlex(Rune*);
int	lex(void);
void	operator(int);
void	operand(int);
void	evaluntil(int);
void	optimize(Inst*);
void	bldcclass(void);

void
regerror(Err e)
{
	Strzero(&amp;lastregexp);
	error(e);
}

void
regerror_c(Err e, int c)
{
	Strzero(&amp;lastregexp);
	error_c(e, c);
}

Inst *
newinst(int t)
{
	if(progp &gt;= &amp;program[NPROG])
		regerror(Etoolong);
	progp-&gt;type = t;
	progp-&gt;left = 0;
	progp-&gt;right = 0;
	return progp++;
}

Inst *
realcompile(Rune *s)
{
	int token;

	startlex(s);
	atorp = atorstack;
	andp = andstack;
	subidp = subidstack;
	cursubid = 0;
	lastwasand = FALSE;
	/* Start with a low priority operator to prime parser */
	pushator(START-1);
	while((token=lex()) != END){
		if((token&amp;ISATOR) == OPERATOR)
			operator(token);
		else
			operand(token);
	}
	/* Close with a low priority operator */
	evaluntil(START);
	/* Force END */
	operand(END);
	evaluntil(START);
	if(nbra)
		regerror(Eleftpar);
	--andp;	/* points to first and only operand */
	return andp-&gt;first;
}

void
compile(String *s)
{
	int i;
	Inst *oprogp;

	if(Strcmp(s, &amp;lastregexp)==0)
		return;
	for(i=0; i&lt;nclass; i++)
		free(class[i]);
	nclass = 0;
	progp = program;
	backwards = FALSE;
	startinst = realcompile(s-&gt;s);
	optimize(program);
	oprogp = progp;
	backwards = TRUE;
	bstartinst = realcompile(s-&gt;s);
	optimize(oprogp);
	Strduplstr(&amp;lastregexp, s);
}

void
operand(int t)
{
	Inst *i;
	if(lastwasand)
		operator(CAT);	/* catenate is implicit */
	i = newinst(t);
	if(t == CCLASS){
		if(negateclass)
			i-&gt;type = NCCLASS;	/* UGH */
		i-&gt;rclass = nclass-1;		/* UGH */
	}
	pushand(i, i);
	lastwasand = TRUE;
}

void
operator(int t)
{
	if(t==RBRA &amp;&amp; --nbra&lt;0)
		regerror(Erightpar);
	if(t==LBRA){
/*
 *		if(++cursubid &gt;= NSUBEXP)
 *			regerror(Esubexp);
 */
		cursubid++;	/* silently ignored */
		nbra++;
		if(lastwasand)
			operator(CAT);
	}else
		evaluntil(t);
	if(t!=RBRA)
		pushator(t);
	lastwasand = FALSE;
	if(t==STAR || t==QUEST || t==PLUS || t==RBRA)
		lastwasand = TRUE;	/* these look like operands */
}

void
cant(char *s)
{
	char buf[100];

	sprint(buf, "regexp: can't happen: %s", s);
	panic(buf);
}

void
pushand(Inst *f, Inst *l)
{
	if(andp &gt;= &amp;andstack[NSTACK])
		cant("operand stack overflow");
	andp-&gt;first = f;
	andp-&gt;last = l;
	andp++;
}

void
pushator(int t)
{
	if(atorp &gt;= &amp;atorstack[NSTACK])
		cant("operator stack overflow");
	*atorp++=t;
	if(cursubid &gt;= NSUBEXP)
		*subidp++= -1;
	else
		*subidp++=cursubid;
}

Node *
popand(int op)
{
	if(andp &lt;= &amp;andstack[0])
		if(op)
			regerror_c(Emissop, op);
		else
			regerror(Ebadregexp);
	return --andp;
}

int
popator(void)
{
	if(atorp &lt;= &amp;atorstack[0])
		cant("operator stack underflow");
	--subidp;
	return *--atorp;
}

void
evaluntil(int pri)
{
	Node *op1, *op2, *t;
	Inst *inst1, *inst2;

	while(pri==RBRA || atorp[-1]&gt;=pri){
		switch(popator()){
		case LBRA:
			op1 = popand('(');
			inst2 = newinst(RBRA);
			inst2-&gt;subid = *subidp;
			op1-&gt;last-&gt;next = inst2;
			inst1 = newinst(LBRA);
			inst1-&gt;subid = *subidp;
			inst1-&gt;next = op1-&gt;first;
			pushand(inst1, inst2);
			return;		/* must have been RBRA */
		default:
			panic("unknown regexp operator");
			break;
		case OR:
			op2 = popand('|');
			op1 = popand('|');
			inst2 = newinst(NOP);
			op2-&gt;last-&gt;next = inst2;
			op1-&gt;last-&gt;next = inst2;
			inst1 = newinst(OR);
			inst1-&gt;right = op1-&gt;first;
			inst1-&gt;left = op2-&gt;first;
			pushand(inst1, inst2);
			break;
		case CAT:
			op2 = popand(0);
			op1 = popand(0);
			if(backwards &amp;&amp; op2-&gt;first-&gt;type!=END)
				t = op1, op1 = op2, op2 = t;
			op1-&gt;last-&gt;next = op2-&gt;first;
			pushand(op1-&gt;first, op2-&gt;last);
			break;
		case STAR:
			op2 = popand('*');
			inst1 = newinst(OR);
			op2-&gt;last-&gt;next = inst1;
			inst1-&gt;right = op2-&gt;first;
			pushand(inst1, inst1);
			break;
		case PLUS:
			op2 = popand('+');
			inst1 = newinst(OR);
			op2-&gt;last-&gt;next = inst1;
			inst1-&gt;right = op2-&gt;first;
			pushand(op2-&gt;first, inst1);
			break;
		case QUEST:
			op2 = popand('?');
			inst1 = newinst(OR);
			inst2 = newinst(NOP);
			inst1-&gt;left = inst2;
			inst1-&gt;right = op2-&gt;first;
			op2-&gt;last-&gt;next = inst2;
			pushand(inst1, inst2);
			break;
		}
	}
}


void
optimize(Inst *start)
{
	Inst *inst, *target;

	for(inst=start; inst-&gt;type!=END; inst++){
		target = inst-&gt;next;
		while(target-&gt;type == NOP)
			target = target-&gt;next;
		inst-&gt;next = target;
	}
}

#ifdef	DEBUG
void
dumpstack(void){
	Node *stk;
	int *ip;

	dprint("operators\n");
	for(ip = atorstack; ip&lt;atorp; ip++)
		dprint("0%o\n", *ip);
	dprint("operands\n");
	for(stk = andstack; stk&lt;andp; stk++)
		dprint("0%o\t0%o\n", stk-&gt;first-&gt;type, stk-&gt;last-&gt;type);
}
void
dump(void){
	Inst *l;

	l = program;
	do{
		dprint("%d:\t0%o\t%d\t%d\n", l-program, l-&gt;type,
			l-&gt;left-program, l-&gt;right-program);
	}while(l++-&gt;type);
}
#endif

void
startlex(Rune *s)
{
	exprp = s;
	nbra = 0;
}


int
lex(void){
	int c= *exprp++;

	switch(c){
	case '\\':
		if(*exprp)
			if((c= *exprp++)=='n')
				c='\n';
		break;
	case 0:
		c = END;
		--exprp;	/* In case we come here again */
		break;
	case '*':
		c = STAR;
		break;
	case '?':
		c = QUEST;
		break;
	case '+':
		c = PLUS;
		break;
	case '|':
		c = OR;
		break;
	case '.':
		c = ANY;
		break;
	case '(':
		c = LBRA;
		break;
	case ')':
		c = RBRA;
		break;
	case '^':
		c = BOL;
		break;
	case '$':
		c = EOL;
		break;
	case '[':
		c = CCLASS;
		bldcclass();
		break;
	}
	return c;
}

long
nextrec(void){
	if(exprp[0]==0 || (exprp[0]=='\\' &amp;&amp; exprp[1]==0))
		regerror(Ebadclass);
	if(exprp[0] == '\\'){
		exprp++;
		if(*exprp=='n'){
			exprp++;
			return '\n';
		}
		return *exprp++|(Runemax+1);
	}
	return *exprp++;
}

void
bldcclass(void)
{
	long c1, c2, n, na;
	Rune *classp;

	classp = emalloc(DCLASS*RUNESIZE);
	n = 0;
	na = DCLASS;
	/* we have already seen the '[' */
	if(*exprp == '^'){
		classp[n++] = '\n';	/* don't match newline in negate case */
		negateclass = TRUE;
		exprp++;
	}else
		negateclass = FALSE;
	while((c1 = nextrec()) != ']'){
		if(c1 == '-'){
    Error:
			free(classp);
			regerror(Ebadclass);
		}
		if(n+4 &gt;= na){		/* 3 runes plus NUL */
			na += DCLASS;
			classp = erealloc(classp, na*RUNESIZE);
		}
		if(*exprp == '-'){
			exprp++;	/* eat '-' */
			if((c2 = nextrec()) == ']')
				goto Error;
			classp[n+0] = Runemax;
			classp[n+1] = c1;
			classp[n+2] = c2;
			n += 3;
		}else
			classp[n++] = c1;
	}
	classp[n] = 0;
	if(nclass == Nclass){
		Nclass += DCLASS;
		class = erealloc(class, Nclass*sizeof(Rune*));
	}
	class[nclass++] = classp;
}

int
classmatch(int classno, int c, int negate)
{
	Rune *p;

	p = class[classno];
	while(*p){
		if(*p == Runemax){
			if(p[1]&lt;=c &amp;&amp; c&lt;=p[2])
				return !negate;
			p += 3;
		}else if(*p++ == c)
			return !negate;
	}
	return negate;
}

/*
 * Note optimization in addinst:
 * 	*l must be pending when addinst called; if *l has been looked
 *		at already, the optimization is a bug.
 */
int
addinst(Ilist *l, Inst *inst, Rangeset *sep)
{
	Ilist *p;

	for(p = l; p-&gt;inst; p++){
		if(p-&gt;inst==inst){
			if((sep)-&gt;p[0].p1 &lt; p-&gt;se.p[0].p1)
				p-&gt;se= *sep;	/* this would be bug */
			return 0;	/* It's already there */
		}
	}
	p-&gt;inst = inst;
	p-&gt;se= *sep;
	(p+1)-&gt;inst = 0;
	return 1;
}

int
execute(File *f, Posn startp, Posn eof)
{
	int flag = 0;
	Inst *inst;
	Ilist *tlp;
	Posn p = startp;
	int nnl = 0, ntl;
	int c;
	int wrapped = 0;
	int startchar = startinst-&gt;type&lt;OPERATOR? startinst-&gt;type : 0;

	list[0][0].inst = list[1][0].inst = 0;
	sel.p[0].p1 = -1;
	/* Execute machine once for each character */
	for(;;p++){
	doloop:
		c = filereadc(f, p);
		if(p&gt;=eof || c&lt;0){
			switch(wrapped++){
			case 0:		/* let loop run one more click */
			case 2:
				break;
			case 1:		/* expired; wrap to beginning */
				if(sel.p[0].p1&gt;=0 || eof!=INFINITY)
					goto Return;
				list[0][0].inst = list[1][0].inst = 0;
				p = 0;
				goto doloop;
			default:
				goto Return;
			}
		}else if(((wrapped &amp;&amp; p&gt;=startp) || sel.p[0].p1&gt;0) &amp;&amp; nnl==0)
			break;
		/* fast check for first char */
		if(startchar &amp;&amp; nnl==0 &amp;&amp; c!=startchar)
			continue;
		tl = list[flag];
		nl = list[flag^=1];
		nl-&gt;inst = 0;
		ntl = nnl;
		nnl = 0;
		if(sel.p[0].p1&lt;0 &amp;&amp; (!wrapped || p&lt;startp || startp==eof)){
			/* Add first instruction to this list */
			sempty.p[0].p1 = p;
			if(addinst(tl, startinst, &amp;sempty))
			if(++ntl &gt;= NLIST)
	Overflow:
				error(Eoverflow);
		}
		/* Execute machine until this list is empty */
		for(tlp = tl; inst = tlp-&gt;inst; tlp++){	/* assignment = */
	Switchstmt:
			switch(inst-&gt;type){
			default:	/* regular character */
				if(inst-&gt;type==c){
	Addinst:
					if(addinst(nl, inst-&gt;next, &amp;tlp-&gt;se))
					if(++nnl &gt;= NLIST)
						goto Overflow;
				}
				break;
			case LBRA:
				if(inst-&gt;subid&gt;=0)
					tlp-&gt;se.p[inst-&gt;subid].p1 = p;
				inst = inst-&gt;next;
				goto Switchstmt;
			case RBRA:
				if(inst-&gt;subid&gt;=0)
					tlp-&gt;se.p[inst-&gt;subid].p2 = p;
				inst = inst-&gt;next;
				goto Switchstmt;
			case ANY:
				if(c!='\n')
					goto Addinst;
				break;
			case BOL:
				if(p==0 || filereadc(f, p - 1)=='\n'){
	Step:
					inst = inst-&gt;next;
					goto Switchstmt;
				}
				break;
			case EOL:
				if(c == '\n')
					goto Step;
				break;
			case CCLASS:
				if(c&gt;=0 &amp;&amp; classmatch(inst-&gt;rclass, c, 0))
					goto Addinst;
				break;
			case NCCLASS:
				if(c&gt;=0 &amp;&amp; classmatch(inst-&gt;rclass, c, 1))
					goto Addinst;
				break;
			case OR:
				/* evaluate right choice later */
				if(addinst(tlp, inst-&gt;right, &amp;tlp-&gt;se))
				if(++ntl &gt;= NLIST)
					goto Overflow;
				/* efficiency: advance and re-evaluate */
				inst = inst-&gt;left;
				goto Switchstmt;
			case END:	/* Match! */
				tlp-&gt;se.p[0].p2 = p;
				newmatch(&amp;tlp-&gt;se);
				break;
			}
		}
	}
    Return:
	return sel.p[0].p1&gt;=0;
}

void
newmatch(Rangeset *sp)
{
	int i;

	if(sel.p[0].p1&lt;0 || sp-&gt;p[0].p1&lt;sel.p[0].p1 ||
	   (sp-&gt;p[0].p1==sel.p[0].p1 &amp;&amp; sp-&gt;p[0].p2&gt;sel.p[0].p2))
		for(i = 0; i&lt;NSUBEXP; i++)
			sel.p[i] = sp-&gt;p[i];
}

int
bexecute(File *f, Posn startp)
{
	int flag = 0;
	Inst *inst;
	Ilist *tlp;
	Posn p = startp;
	int nnl = 0, ntl;
	int c;
	int wrapped = 0;
	int startchar = bstartinst-&gt;type&lt;OPERATOR? bstartinst-&gt;type : 0;

	list[0][0].inst = list[1][0].inst = 0;
	sel.p[0].p1= -1;
	/* Execute machine once for each character, including terminal NUL */
	for(;;--p){
	doloop:
		if((c = filereadc(f, p - 1))==-1){
			switch(wrapped++){
			case 0:		/* let loop run one more click */
			case 2:
				break;
			case 1:		/* expired; wrap to end */
				if(sel.p[0].p1&gt;=0)
			case 3:
					goto Return;
				list[0][0].inst = list[1][0].inst = 0;
				p = f-&gt;nc;
				goto doloop;
			default:
				goto Return;
			}
		}else if(((wrapped &amp;&amp; p&lt;=startp) || sel.p[0].p1&gt;0) &amp;&amp; nnl==0)
			break;
		/* fast check for first char */
		if(startchar &amp;&amp; nnl==0 &amp;&amp; c!=startchar)
			continue;
		tl = list[flag];
		nl = list[flag^=1];
		nl-&gt;inst = 0;
		ntl = nnl;
		nnl = 0;
		if(sel.p[0].p1&lt;0 &amp;&amp; (!wrapped || p&gt;startp)){
			/* Add first instruction to this list */
			/* the minus is so the optimizations in addinst work */
			sempty.p[0].p1 = -p;
			if(addinst(tl, bstartinst, &amp;sempty))
			if(++ntl &gt;= NLIST)
	Overflow:
				error(Eoverflow);
		}
		/* Execute machine until this list is empty */
		for(tlp = tl; inst = tlp-&gt;inst; tlp++){	/* assignment = */
	Switchstmt:
			switch(inst-&gt;type){
			default:	/* regular character */
				if(inst-&gt;type == c){
	Addinst:
					if(addinst(nl, inst-&gt;next, &amp;tlp-&gt;se))
					if(++nnl &gt;= NLIST)
						goto Overflow;
				}
				break;
			case LBRA:
				if(inst-&gt;subid&gt;=0)
					tlp-&gt;se.p[inst-&gt;subid].p1 = p;
				inst = inst-&gt;next;
				goto Switchstmt;
			case RBRA:
				if(inst-&gt;subid &gt;= 0)
					tlp-&gt;se.p[inst-&gt;subid].p2 = p;
				inst = inst-&gt;next;
				goto Switchstmt;
			case ANY:
				if(c != '\n')
					goto Addinst;
				break;
			case BOL:
				if(c=='\n' || p==0){
	Step:
					inst = inst-&gt;next;
					goto Switchstmt;
				}
				break;
			case EOL:
				if(p==f-&gt;nc || filereadc(f, p)=='\n')
					goto Step;
				break;
			case CCLASS:
				if(c&gt;=0 &amp;&amp; classmatch(inst-&gt;rclass, c, 0))
					goto Addinst;
				break;
			case NCCLASS:
				if(c&gt;=0 &amp;&amp; classmatch(inst-&gt;rclass, c, 1))
					goto Addinst;
				break;
			case OR:
				/* evaluate right choice later */
				if(addinst(tl, inst-&gt;right, &amp;tlp-&gt;se))
				if(++ntl &gt;= NLIST)
					goto Overflow;
				/* efficiency: advance and re-evaluate */
				inst = inst-&gt;left;
				goto Switchstmt;
			case END:	/* Match! */
				tlp-&gt;se.p[0].p1 = -tlp-&gt;se.p[0].p1; /* minus sign */
				tlp-&gt;se.p[0].p2 = p;
				bnewmatch(&amp;tlp-&gt;se);
				break;
			}
		}
	}
    Return:
	return sel.p[0].p1&gt;=0;
}

void
bnewmatch(Rangeset *sp)
{
        int  i;
        if(sel.p[0].p1&lt;0 || sp-&gt;p[0].p1&gt;sel.p[0].p2 || (sp-&gt;p[0].p1==sel.p[0].p2 &amp;&amp; sp-&gt;p[0].p2&lt;sel.p[0].p1))
                for(i = 0; i&lt;NSUBEXP; i++){       /* note the reversal; p1&lt;=p2 */
                        sel.p[i].p1 = sp-&gt;p[i].p2;
                        sel.p[i].p2 = sp-&gt;p[i].p1;
                }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

