<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/sam.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/sam.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"

Rune	genbuf[BLOCKSIZE];
int	io;
int	panicking;
int	rescuing;
String	genstr;
String	rhs;
String	curwd;
String	cmdstr;
Rune	empty[] = { 0 };
char	*genc;
File	*curfile;
File	*flist;
File	*cmd;
jmp_buf	mainloop;
List	tempfile = { 'p' };
int	quitok = TRUE;
int	downloaded;
int	dflag;
int	Rflag;
char	*machine;
char	*home;
int	bpipeok;
int	termlocked;
char	*samterm = SAMTERM;
char	*rsamname = RSAM;
File	*lastfile;
Disk	*disk;
long	seq;

Rune	baddir[] = { '&lt;', 'b', 'a', 'd', 'd', 'i', 'r', '&gt;', '\n'};

void	usage(void);

void main(int argc, char *argv[])
{
	int i;
	String *t;
	char *termargs[10], **ap;
	
	ap = termargs;
	*ap++ = "samterm";
	ARGBEGIN{
	case 'd':
		dflag++;
		break;
	case 'r':
		machine = EARGF(usage());
		break;
	case 'R':
		Rflag++;
		break;
	case 't':
		samterm = EARGF(usage());
		break;
	case 's':
		rsamname = EARGF(usage());
		break;
	default:
		dprint("sam: unknown flag %c\n", ARGC());
		usage();
	/* options for samterm */
	case 'a':
		*ap++ = "-a";
		break;
	}ARGEND
	*ap = nil;
	
	Strinit(&amp;cmdstr);
	Strinit0(&amp;lastpat);
	Strinit0(&amp;lastregexp);
	Strinit0(&amp;genstr);
	Strinit0(&amp;rhs);
	Strinit0(&amp;curwd);
	Strinit0(&amp;plan9cmd);
	home = getenv(HOME);
	disk = diskinit();
	if(home == 0)
		home = "/";
	if(!dflag)
		startup(machine, Rflag, termargs, argv);
	notify(notifyf);
	getcurwd();
	if(argc&gt;0){
		for(i=0; i&lt;argc; i++){
			if(!setjmp(mainloop)){
				t = tmpcstr(argv[i]);
				Straddc(t, '\0');
				Strduplstr(&amp;genstr, t);
				freetmpstr(t);
				fixname(&amp;genstr);
				logsetname(newfile(), &amp;genstr);
			}
		}
	}else if(!downloaded)
		newfile();
	seq++;
	if(file.nused)
		current(file.filepptr[0]);
	setjmp(mainloop);
	cmdloop();
	trytoquit();	/* if we already q'ed, quitok will be TRUE */
	exits(0);
}

void
usage(void)
{
	dprint("usage: sam [-d] [-t samterm] [-s sam name] -r machine\n");
	exits("usage");
}

void
rescue(void)
{
	int i, nblank = 0;
	File *f;
	char *c;
	char buf[256];

	if(rescuing++)
		return;
	io = -1;
	for(i=0; i&lt;file.nused; i++){
		f = file.filepptr[i];
		if(f==cmd || f-&gt;nc==0 || !fileisdirty(f))
			continue;
		if(io == -1){
			sprint(buf, "%s/sam.save", home);
			io = create(buf, 1, 0777);
			if(io&lt;0)
				return;
		}
		if(f-&gt;name.s[0]){
			c = Strtoc(&amp;f-&gt;name);
			strncpy(buf, c, sizeof buf-1);
			buf[sizeof buf-1] = 0;
			free(c);
		}else
			sprint(buf, "nameless.%d", nblank++);
		fprint(io, "#!%s '%s' $* &lt;&lt;'---%s'\n", SAMSAVECMD, buf, buf);
		addr.r.p1 = 0, addr.r.p2 = f-&gt;nc;
		writeio(f);
		fprint(io, "\n---%s\n", (char *)buf);
	}
}

void
panic(char *s)
{
	int wasd;

	if(!panicking++ &amp;&amp; !setjmp(mainloop)){
		wasd = downloaded;
		downloaded = 0;
		dprint("sam: panic: %s: %r\n", s);
		if(wasd)
			fprint(2, "sam: panic: %s: %r\n", s);
		rescue();
		abort();
	}
}

void
hiccough(char *s)
{
	File *f;
	int i;

	if(rescuing)
		exits("rescue");
	if(s)
		dprint("%s\n", s);
	resetcmd();
	resetxec();
	resetsys();
	if(io &gt; 0)
		close(io);

	/*
	 * back out any logged changes &amp; restore old sequences
	 */
	for(i=0; i&lt;file.nused; i++){
		f = file.filepptr[i];
		if(f==cmd)
			continue;
		if(f-&gt;seq==seq){
			bufdelete(&amp;f-&gt;epsilon, 0, f-&gt;epsilon.nc);
			f-&gt;seq = f-&gt;prevseq;
			f-&gt;dot.r = f-&gt;prevdot;
			f-&gt;mark = f-&gt;prevmark;
			state(f, f-&gt;prevmod ? Dirty: Clean);
		}
	}

	update();
	if (curfile) {
		if (curfile-&gt;unread)
			curfile-&gt;unread = FALSE;
		else if (downloaded)
			outTs(Hcurrent, curfile-&gt;tag);
	}
	longjmp(mainloop, 1);
}

void
intr(void)
{
	error(Eintr);
}

void
trytoclose(File *f)
{
	char *t;
	char buf[256];

	if(f == cmd)	/* possible? */
		return;
	if(f-&gt;deleted)
		return;
	if(fileisdirty(f) &amp;&amp; !f-&gt;closeok){
		f-&gt;closeok = TRUE;
		if(f-&gt;name.s[0]){
			t = Strtoc(&amp;f-&gt;name);
			strncpy(buf, t, sizeof buf-1);
			free(t);
		}else
			strcpy(buf, "nameless file");
		error_s(Emodified, buf);
	}
	f-&gt;deleted = TRUE;
}

void
trytoquit(void)
{
	int c;
	File *f;

	if(!quitok){
		for(c = 0; c&lt;file.nused; c++){
			f = file.filepptr[c];
			if(f!=cmd &amp;&amp; fileisdirty(f)){
				quitok = TRUE;
				eof = FALSE;
				error(Echanges);
			}
		}
	}
}

void
load(File *f)
{
	Address saveaddr;

	Strduplstr(&amp;genstr, &amp;f-&gt;name);
	filename(f);
	if(f-&gt;name.s[0]){
		saveaddr = addr;
		edit(f, 'I');
		addr = saveaddr;
	}else{
		f-&gt;unread = 0;
		f-&gt;cleanseq = f-&gt;seq;
	}

	fileupdate(f, TRUE, TRUE);
}

void
cmdupdate(void)
{
	if(cmd &amp;&amp; cmd-&gt;seq!=0){
		fileupdate(cmd, FALSE, downloaded);
		cmd-&gt;dot.r.p1 = cmd-&gt;dot.r.p2 = cmd-&gt;nc;
		telldot(cmd);
	}
}

void
delete(File *f)
{
	if(downloaded &amp;&amp; f-&gt;rasp)
		outTs(Hclose, f-&gt;tag);
	delfile(f);
	if(f == curfile)
		current(0);
}

void
update(void)
{
	int i, anymod;
	File *f;

	settempfile();
	for(anymod = i=0; i&lt;tempfile.nused; i++){
		f = tempfile.filepptr[i];
		if(f==cmd)	/* cmd gets done in main() */
			continue;
		if(f-&gt;deleted) {
			delete(f);
			continue;
		}
		if(f-&gt;seq==seq &amp;&amp; fileupdate(f, FALSE, downloaded))
			anymod++;
		if(f-&gt;rasp)
			telldot(f);
	}
	if(anymod)
		seq++;
}

File *
current(File *f)
{
	return curfile = f;
}

void
edit(File *f, int cmd)
{
	int empty = TRUE;
	Posn p;
	int nulls;

	if(cmd == 'r')
		logdelete(f, addr.r.p1, addr.r.p2);
	if(cmd=='e' || cmd=='I'){
		logdelete(f, (Posn)0, f-&gt;nc);
		addr.r.p2 = f-&gt;nc;
	}else if(f-&gt;nc!=0 || (f-&gt;name.s[0] &amp;&amp; Strcmp(&amp;genstr, &amp;f-&gt;name)!=0))
		empty = FALSE;
	if((io = open(genc, OREAD))&lt;0) {
		if (curfile &amp;&amp; curfile-&gt;unread)
			curfile-&gt;unread = FALSE;
		error_r(Eopen, genc);
	}
	p = readio(f, &amp;nulls, empty, TRUE);
	closeio((cmd=='e' || cmd=='I')? -1 : p);
	if(cmd == 'r')
		f-&gt;ndot.r.p1 = addr.r.p2, f-&gt;ndot.r.p2 = addr.r.p2+p;
	else
		f-&gt;ndot.r.p1 = f-&gt;ndot.r.p2 = 0;
	f-&gt;closeok = empty;
	if (quitok)
		quitok = empty;
	else
		quitok = FALSE;
	state(f, empty &amp;&amp; !nulls? Clean : Dirty);
	if(empty &amp;&amp; !nulls)
		f-&gt;cleanseq = f-&gt;seq;
	if(cmd == 'e')
		filename(f);
}

int
getname(File *f, String *s, int save)
{
	int c, i;

	Strzero(&amp;genstr);
	if(genc){
		free(genc);
		genc = 0;
	}
	if(s==0 || (c = s-&gt;s[0])==0){		/* no name provided */
		if(f)
			Strduplstr(&amp;genstr, &amp;f-&gt;name);
		goto Return;
	}
	if(c!=' ' &amp;&amp; c!='\t')
		error(Eblank);
	for(i=0; (c=s-&gt;s[i])==' ' || c=='\t'; i++)
		;
	while(s-&gt;s[i] &gt; ' ')
		Straddc(&amp;genstr, s-&gt;s[i++]);
	if(s-&gt;s[i])
		error(Enewline);
	fixname(&amp;genstr);
	if(f &amp;&amp; (save || f-&gt;name.s[0]==0)){
		logsetname(f, &amp;genstr);
		if(Strcmp(&amp;f-&gt;name, &amp;genstr)){
			quitok = f-&gt;closeok = FALSE;
			f-&gt;qidpath = 0;
			f-&gt;mtime = 0;
			state(f, Dirty); /* if it's 'e', fix later */
		}
	}
    Return:
	genc = Strtoc(&amp;genstr);
	i = genstr.n;
	if(i &amp;&amp; genstr.s[i-1]==0)
		i--;
	return i;	/* strlen(name) */
}

void
filename(File *f)
{
	if(genc)
		free(genc);
	genc = Strtoc(&amp;genstr);
	dprint("%c%c%c %s\n", " '"[f-&gt;mod],
		"-+"[f-&gt;rasp!=0], " ."[f==curfile], genc);
}

void
undostep(File *f, int isundo)
{
	uint p1, p2;
	int mod;

	mod = f-&gt;mod;
	fileundo(f, isundo, 1, &amp;p1, &amp;p2, TRUE);
	f-&gt;ndot = f-&gt;dot;
	if(f-&gt;mod){
		f-&gt;closeok = 0;
		quitok = 0;
	}else
		f-&gt;closeok = 1;

	if(f-&gt;mod != mod){
		f-&gt;mod = mod;
		if(mod)
			mod = Clean;
		else
			mod = Dirty;
		state(f, mod);
	}
}

int
undo(int isundo)
{
	File *f;
	int i;
	Mod max;

	max = undoseq(curfile, isundo);
	if(max == 0)
		return 0;
	settempfile();
	for(i = 0; i&lt;tempfile.nused; i++){
		f = tempfile.filepptr[i];
		if(f!=cmd &amp;&amp; undoseq(f, isundo)==max)
			undostep(f, isundo);
	}
	return 1;
}

int
readcmd(String *s)
{
	int retcode;

	if(flist != 0)
		fileclose(flist);
	flist = fileopen();

	addr.r.p1 = 0, addr.r.p2 = flist-&gt;nc;
	retcode = plan9(flist, '&lt;', s, FALSE);
	fileupdate(flist, FALSE, FALSE);
	flist-&gt;seq = 0;
	if (flist-&gt;nc &gt; BLOCKSIZE)
		error(Etoolong);
	Strzero(&amp;genstr);
	Strinsure(&amp;genstr, flist-&gt;nc);
	bufread(flist, (Posn)0, genbuf, flist-&gt;nc);
	memmove(genstr.s, genbuf, flist-&gt;nc*RUNESIZE);
	genstr.n = flist-&gt;nc;
	Straddc(&amp;genstr, '\0');
	return retcode;
}

void
getcurwd(void)
{
	String *t;
	char buf[256];

	buf[0] = 0;
	getwd(buf, sizeof(buf));
	t = tmpcstr(buf);
	Strduplstr(&amp;curwd, t);
	freetmpstr(t);
	if(curwd.n == 0)
		warn(Wpwd);
	else if(curwd.s[curwd.n-1] != '/')
		Straddc(&amp;curwd, '/');
}

void
cd(String *str)
{
	int i, fd;
	char *s;
	File *f;
	String owd;

	getcurwd();
	if(getname((File *)0, str, FALSE))
		s = genc;
	else
		s = home;
	if(chdir(s))
		syserror("chdir");
	fd = open("/dev/wdir", OWRITE);
	if(fd &gt; 0)
		write(fd, s, strlen(s));
	dprint("!\n");
	Strinit(&amp;owd);
	Strduplstr(&amp;owd, &amp;curwd);
	getcurwd();
	settempfile();
	for(i=0; i&lt;tempfile.nused; i++){
		f = tempfile.filepptr[i];
		if(f!=cmd &amp;&amp; f-&gt;name.s[0]!='/' &amp;&amp; f-&gt;name.s[0]!=0){
			Strinsert(&amp;f-&gt;name, &amp;owd, (Posn)0);
			fixname(&amp;f-&gt;name);
			sortname(f);
		}else if(f != cmd &amp;&amp; Strispre(&amp;curwd, &amp;f-&gt;name)){
			fixname(&amp;f-&gt;name);
			sortname(f);
		}
	}
	Strclose(&amp;owd);
}

int
loadflist(String *s)
{
	int c, i;

	c = s-&gt;s[0];
	for(i = 0; s-&gt;s[i]==' ' || s-&gt;s[i]=='\t'; i++)
		;
	if((c==' ' || c=='\t') &amp;&amp; s-&gt;s[i]!='\n'){
		if(s-&gt;s[i]=='&lt;'){
			Strdelete(s, 0L, (long)i+1);
			readcmd(s);
		}else{
			Strzero(&amp;genstr);
			while((c = s-&gt;s[i++]) &amp;&amp; c!='\n')
				Straddc(&amp;genstr, c);
			Straddc(&amp;genstr, '\0');
		}
	}else{
		if(c != '\n')
			error(Eblank);
		Strdupl(&amp;genstr, empty);
	}
	if(genc)
		free(genc);
	genc = Strtoc(&amp;genstr);
	return genstr.s[0];
}

File *
readflist(int readall, int delete)
{
	Posn i;
	int c;
	File *f;
	String t;

	Strinit(&amp;t);
	for(i=0,f=0; f==0 || readall || delete; i++){	/* ++ skips blank */
		Strdelete(&amp;genstr, (Posn)0, i);
		for(i=0; (c = genstr.s[i])==' ' || c=='\t' || c=='\n'; i++)
			;
		if(i &gt;= genstr.n)
			break;
		Strdelete(&amp;genstr, (Posn)0, i);
		for(i=0; (c=genstr.s[i]) &amp;&amp; c!=' ' &amp;&amp; c!='\t' &amp;&amp; c!='\n'; i++)
			;

		if(i == 0)
			break;
		genstr.s[i] = 0;
		Strduplstr(&amp;t, tmprstr(genstr.s, i+1));
		fixname(&amp;t);
		f = lookfile(&amp;t);
		if(delete){
			if(f == 0)
				warn_S(Wfile, &amp;t);
			else
				trytoclose(f);
		}else if(f==0 &amp;&amp; readall)
			logsetname(f = newfile(), &amp;t);
	}
	Strclose(&amp;t);
	return f;
}

File *
tofile(String *s)
{
	File *f;

	if(s-&gt;s[0] != ' ')
		error(Eblank);
	if(loadflist(s) == 0){
		f = lookfile(&amp;genstr);	/* empty string ==&gt; nameless file */
		if(f == 0)
			error_s(Emenu, genc);
	}else if((f=readflist(FALSE, FALSE)) == 0)
		error_s(Emenu, genc);
	return current(f);
}

File *
getfile(String *s)
{
	File *f;

	if(loadflist(s) == 0)
		logsetname(f = newfile(), &amp;genstr);
	else if((f=readflist(TRUE, FALSE)) == 0)
		error(Eblank);
	return current(f);
}

void
closefiles(File *f, String *s)
{
	if(s-&gt;s[0] == 0){
		if(f == 0)
			error(Enofile);
		trytoclose(f);
		return;
	}
	if(s-&gt;s[0] != ' ')
		error(Eblank);
	if(loadflist(s) == 0)
		error(Enewline);
	readflist(FALSE, TRUE);
}

void
copy(File *f, Address addr2)
{
	Posn p;
	int ni;
	for(p=addr.r.p1; p&lt;addr.r.p2; p+=ni){
		ni = addr.r.p2-p;
		if(ni &gt; BLOCKSIZE)
			ni = BLOCKSIZE;
		bufread(f, p, genbuf, ni);
		loginsert(addr2.f, addr2.r.p2, tmprstr(genbuf, ni)-&gt;s, ni);
	}
	addr2.f-&gt;ndot.r.p2 = addr2.r.p2+(f-&gt;dot.r.p2-f-&gt;dot.r.p1);
	addr2.f-&gt;ndot.r.p1 = addr2.r.p2;
}

void
move(File *f, Address addr2)
{
	if(addr.r.p2 &lt;= addr2.r.p2){
		logdelete(f, addr.r.p1, addr.r.p2);
		copy(f, addr2);
	}else if(addr.r.p1 &gt;= addr2.r.p2){
		copy(f, addr2);
		logdelete(f, addr.r.p1, addr.r.p2);
	}else
		error(Eoverlap);
}

Posn
nlcount(File *f, Posn p0, Posn p1)
{
	Posn nl = 0;

	while(p0 &lt; p1)
		if(filereadc(f, p0++)=='\n')
			nl++;
	return nl;
}

void
printposn(File *f, int charsonly)
{
	Posn l1, l2;

	if(!charsonly){
		l1 = 1+nlcount(f, (Posn)0, addr.r.p1);
		l2 = l1+nlcount(f, addr.r.p1, addr.r.p2);
		/* check if addr ends with '\n' */
		if(addr.r.p2&gt;0 &amp;&amp; addr.r.p2&gt;addr.r.p1 &amp;&amp; filereadc(f, addr.r.p2-1)=='\n')
			--l2;
		dprint("%lud", l1);
		if(l2 != l1)
			dprint(",%lud", l2);
		dprint("; ");
	}
	dprint("#%lud", addr.r.p1);
	if(addr.r.p2 != addr.r.p1)
		dprint(",#%lud", addr.r.p2);
	dprint("\n");
}

void
settempfile(void)
{
	if(tempfile.nalloc &lt; file.nused){
		if(tempfile.filepptr)
			free(tempfile.filepptr);
		tempfile.filepptr = emalloc(sizeof(File*)*file.nused);
		tempfile.nalloc = file.nused;
	}
	memmove(tempfile.filepptr, file.filepptr, sizeof(File*)*file.nused);
	tempfile.nused = file.nused;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

