<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/samterm/flayer.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/samterm/flayer.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include "flayer.h"
#include "samterm.h"

#define	DELTA	10

static Flayer	**llist;	/* front to back */
static int	nllist;
static int	nlalloc;
static Rectangle lDrect;

Vis		visibility(Flayer *);
void		newvisibilities(int);
void		llinsert(Flayer*);
void		lldelete(Flayer*);

Image	*maincols[NCOL];
Image	*cmdcols[NCOL];

void
flstart(Rectangle r)
{
	lDrect = r;

	/* Main text is yellowish */
	maincols[BACK] = allocimagemix(display, DPaleyellow, DWhite);
	maincols[HIGH] = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, DDarkyellow);
	maincols[BORD] = allocimage(display, Rect(0,0,2,2), screen-&gt;chan, 1, DYellowgreen);
	maincols[TEXT] = display-&gt;black;
	maincols[HTEXT] = display-&gt;black;

	/* Command text is blueish */
	cmdcols[BACK] = allocimagemix(display, DPalebluegreen, DWhite);
	cmdcols[HIGH] = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, DPalegreygreen);
	cmdcols[BORD] = allocimage(display, Rect(0,0,2,2), screen-&gt;chan, 1, DPurpleblue);
	cmdcols[TEXT] = display-&gt;black;
	cmdcols[HTEXT] = display-&gt;black;
}

void
flnew(Flayer *l, Rune *(*fn)(Flayer*, long, ulong*), int u0, void *u1)
{
	if(nllist == nlalloc){
		nlalloc += DELTA;
		llist = realloc(llist, nlalloc*sizeof(Flayer**));
		if(llist == 0)
			panic("flnew");
	}
	l-&gt;textfn = fn;
	l-&gt;user0 = u0;
	l-&gt;user1 = u1;
	l-&gt;lastsr = ZR;
	llinsert(l);
}

Rectangle
flrect(Flayer *l, Rectangle r)
{
	rectclip(&amp;r, lDrect);
	l-&gt;entire = r;
	l-&gt;scroll = insetrect(r, FLMARGIN);
	r.min.x =
	 l-&gt;scroll.max.x = r.min.x+FLMARGIN+FLSCROLLWID+(FLGAP-FLMARGIN);
	return r;
}

static void
fontbuggered(char *name)
{
	fprint(2, "samterm: font %s has zero-width \"0\" character\n", name);
	threadexits("font zero-width");
}

void
flinit(Flayer *l, Rectangle r, Font *ft, Image **cols)
{
	lldelete(l);
	llinsert(l);
	l-&gt;visible = All;
	l-&gt;origin = l-&gt;p0 = l-&gt;p1 = 0;
	frinit(&amp;l-&gt;f, insetrect(flrect(l, r), FLMARGIN), ft, screen, cols);
	l-&gt;f.maxtab = maxtab*stringwidth(ft, "0");
	if(l-&gt;f.maxtab == 0)
		fontbuggered(ft-&gt;name);
	newvisibilities(1);
	draw(screen, l-&gt;entire, l-&gt;f.cols[BACK], nil, ZP);
	scrdraw(l, 0L);
	flborder(l, 0);
}

void
flclose(Flayer *l)
{
	if(l-&gt;visible == All)
		draw(screen, l-&gt;entire, display-&gt;white, nil, ZP);
	else if(l-&gt;visible == Some){
		if(l-&gt;f.b == 0)
			l-&gt;f.b = allocimage(display, l-&gt;entire, screen-&gt;chan, 0, DNofill);
		if(l-&gt;f.b){
			draw(l-&gt;f.b, l-&gt;entire, display-&gt;white, nil, ZP);
			flrefresh(l, l-&gt;entire, 0);
		}
	}
	frclear(&amp;l-&gt;f, 1);
	lldelete(l);
	if(l-&gt;f.b &amp;&amp; l-&gt;visible!=All)
		freeimage(l-&gt;f.b);
	l-&gt;textfn = 0;
	newvisibilities(1);
}

void
flborder(Flayer *l, int wide)
{
	if(flprepare(l)){
		border(l-&gt;f.b, l-&gt;entire, FLMARGIN, l-&gt;f.cols[BACK], ZP);
		border(l-&gt;f.b, l-&gt;entire, wide? FLMARGIN : 1, l-&gt;f.cols[BORD], ZP);
		if(l-&gt;visible==Some)
			flrefresh(l, l-&gt;entire, 0);
	}
}

Flayer *
flwhich(Point p)
{
	int i;

	if(p.x==0 &amp;&amp; p.y==0)
		return nllist? llist[0] : 0;
	for(i=0; i&lt;nllist; i++)
		if(ptinrect(p, llist[i]-&gt;entire))
			return llist[i];
	return 0;
}

void
flupfront(Flayer *l)
{
	int v = l-&gt;visible;

	lldelete(l);
	llinsert(l);
	if(v!=All)
		newvisibilities(0);
}

void
newvisibilities(int redraw)
	/* if redraw false, we know it's a flupfront, and needn't
	 * redraw anyone becoming partially covered */
{
	int i;
	Vis ov;
	Flayer *l;

	for(i = 0; i&lt;nllist; i++){
		l = llist[i];
		l-&gt;lastsr = ZR;	/* make sure scroll bar gets redrawn */
		ov = l-&gt;visible;
		l-&gt;visible = visibility(l);
#define	V(a, b)	(((a)&lt;&lt;2)|((b)))
		switch(V(ov, l-&gt;visible)){
		case V(Some, None):
			if(l-&gt;f.b)
				freeimage(l-&gt;f.b);
		case V(All, None):
		case V(All, Some):
			l-&gt;f.b = 0;
			frclear(&amp;l-&gt;f, 0);
			break;

		case V(Some, Some):
			if(l-&gt;f.b==0 &amp;&amp; redraw)
		case V(None, Some):
				flprepare(l);
			if(l-&gt;f.b &amp;&amp; redraw){
				flrefresh(l, l-&gt;entire, 0);
				freeimage(l-&gt;f.b);
				l-&gt;f.b = 0;
				frclear(&amp;l-&gt;f, 0);
			}
		case V(None, None):
		case V(All, All):
			break;

		case V(Some, All):
			if(l-&gt;f.b){
				draw(screen, l-&gt;entire, l-&gt;f.b, nil, l-&gt;entire.min);
				freeimage(l-&gt;f.b);
				l-&gt;f.b = screen;
				break;
			}
		case V(None, All):
			flprepare(l);
			break;
		}
		if(ov==None &amp;&amp; l-&gt;visible!=None)
			flnewlyvisible(l);
	}
}

void
llinsert(Flayer *l)
{
	int i;
	for(i=nllist; i&gt;0; --i)
		llist[i]=llist[i-1];
	llist[0]=l;
	nllist++;
}

void
lldelete(Flayer *l)
{
	int i;

	for(i=0; i&lt;nllist; i++)
		if(llist[i]==l){
			--nllist;
			for(; i&lt;nllist; i++)
				llist[i] = llist[i+1];
			return;
		}
	panic("lldelete");
}

void
flinsert(Flayer *l, Rune *sp, Rune *ep, long p0)
{
	if(flprepare(l)){
		frinsert(&amp;l-&gt;f, sp, ep, p0-l-&gt;origin);
		scrdraw(l, scrtotal(l));
		if(l-&gt;visible==Some)
			flrefresh(l, l-&gt;entire, 0);
	}
}

void
fldelete(Flayer *l, long p0, long p1)
{
	if(flprepare(l)){
		p0 -= l-&gt;origin;
		if(p0 &lt; 0)
			p0 = 0;
		p1 -= l-&gt;origin;
		if(p1&lt;0)
			p1 = 0;
		frdelete(&amp;l-&gt;f, p0, p1);
		scrdraw(l, scrtotal(l));
		if(l-&gt;visible==Some)
			flrefresh(l, l-&gt;entire, 0);
	}
}

int
flselect(Flayer *l)
{
	int ret;
	if(l-&gt;visible!=All)
		flupfront(l);
	frselect(&amp;l-&gt;f, mousectl);
	ret = 0;
	if(l-&gt;f.p0==l-&gt;f.p1){
		if(mousep-&gt;msec-l-&gt;click&lt;Clicktime &amp;&amp; l-&gt;f.p0+l-&gt;origin==l-&gt;p0){
			ret = 1;
			l-&gt;click = 0;
		}else
			l-&gt;click = mousep-&gt;msec;
	}else
		l-&gt;click = 0;
	l-&gt;p0 = l-&gt;f.p0+l-&gt;origin, l-&gt;p1 = l-&gt;f.p1+l-&gt;origin;
	return ret;
}

void
flsetselect(Flayer *l, long p0, long p1)
{
	ulong fp0, fp1;

	l-&gt;click = 0;
	if(l-&gt;visible==None || !flprepare(l)){
		l-&gt;p0 = p0, l-&gt;p1 = p1;
		return;
	}
	l-&gt;p0 = p0, l-&gt;p1 = p1;
	flfp0p1(l, &amp;fp0, &amp;fp1);
	if(fp0==l-&gt;f.p0 &amp;&amp; fp1==l-&gt;f.p1)
		return;

	if(fp1&lt;=l-&gt;f.p0 || fp0&gt;=l-&gt;f.p1 || l-&gt;f.p0==l-&gt;f.p1 || fp0==fp1){
		/* no overlap or trivial repainting */
		frdrawsel(&amp;l-&gt;f, frptofchar(&amp;l-&gt;f, l-&gt;f.p0), l-&gt;f.p0, l-&gt;f.p1, 0);
		frdrawsel(&amp;l-&gt;f, frptofchar(&amp;l-&gt;f, fp0), fp0, fp1, 1);
		goto Refresh;
	}
	/* the current selection and the desired selection overlap and are both non-empty */
	if(fp0 &lt; l-&gt;f.p0){
		/* extend selection backwards */
		frdrawsel(&amp;l-&gt;f, frptofchar(&amp;l-&gt;f, fp0), fp0, l-&gt;f.p0, 1);
	}else if(fp0 &gt; l-&gt;f.p0){
		/* trim first part of selection */
		frdrawsel(&amp;l-&gt;f, frptofchar(&amp;l-&gt;f, l-&gt;f.p0), l-&gt;f.p0, fp0, 0);
	}
	if(fp1 &gt; l-&gt;f.p1){
		/* extend selection forwards */
		frdrawsel(&amp;l-&gt;f, frptofchar(&amp;l-&gt;f, l-&gt;f.p1), l-&gt;f.p1, fp1, 1);
	}else if(fp1 &lt; l-&gt;f.p1){
		/* trim last part of selection */
		frdrawsel(&amp;l-&gt;f, frptofchar(&amp;l-&gt;f, fp1), fp1, l-&gt;f.p1, 0);
	}

    Refresh:
	l-&gt;f.p0 = fp0;
	l-&gt;f.p1 = fp1;
	if(l-&gt;visible==Some)
		flrefresh(l, l-&gt;entire, 0);
}

void
flfp0p1(Flayer *l, ulong *pp0, ulong *pp1)
{
	long p0 = l-&gt;p0-l-&gt;origin, p1 = l-&gt;p1-l-&gt;origin;

	if(p0 &lt; 0)
		p0 = 0;
	if(p1 &lt; 0)
		p1 = 0;
	if(p0 &gt; l-&gt;f.nchars)
		p0 = l-&gt;f.nchars;
	if(p1 &gt; l-&gt;f.nchars)
		p1 = l-&gt;f.nchars;
	*pp0 = p0;
	*pp1 = p1;
}

Rectangle
rscale(Rectangle r, Point old, Point new)
{
	r.min.x = r.min.x*new.x/old.x;
	r.min.y = r.min.y*new.y/old.y;
	r.max.x = r.max.x*new.x/old.x;
	r.max.y = r.max.y*new.y/old.y;
	return r;
}

void
flresize(Rectangle dr)
{
	int i;
	Flayer *l;
	Frame *f;
	Rectangle r, olDrect;
	int move;

	olDrect = lDrect;
	lDrect = dr;
	move = 0;
	/* no moving on rio; must repaint */
	if(0 &amp;&amp; Dx(dr)==Dx(olDrect) &amp;&amp; Dy(dr)==Dy(olDrect))
		move = 1;
	else
		draw(screen, lDrect, display-&gt;white, nil, ZP);
	for(i=0; i&lt;nllist; i++){
		l = llist[i];
		l-&gt;lastsr = ZR;
		f = &amp;l-&gt;f;
		if(move)
			r = rectaddpt(rectsubpt(l-&gt;entire, olDrect.min), dr.min);
		else{
			r = rectaddpt(rscale(rectsubpt(l-&gt;entire, olDrect.min),
				subpt(olDrect.max, olDrect.min),
				subpt(dr.max, dr.min)), dr.min);
			if(l-&gt;visible==Some &amp;&amp; f-&gt;b){
				freeimage(f-&gt;b);
				frclear(f, 0);
			}
			f-&gt;b = 0;
			if(l-&gt;visible!=None)
				frclear(f, 0);
		}
		if(!rectclip(&amp;r, dr))
			panic("flresize");
		if(r.max.x-r.min.x&lt;100)
			r.min.x = dr.min.x;
		if(r.max.x-r.min.x&lt;100)
			r.max.x = dr.max.x;
		if(r.max.y-r.min.y&lt;2*FLMARGIN+f-&gt;font-&gt;height)
			r.min.y = dr.min.y;
		if(r.max.y-r.min.y&lt;2*FLMARGIN+f-&gt;font-&gt;height)
			r.max.y = dr.max.y;
		if(!move)
			l-&gt;visible = None;
		frsetrects(f, insetrect(flrect(l, r), FLMARGIN), f-&gt;b);
		if(!move &amp;&amp; f-&gt;b)
			scrdraw(l, scrtotal(l));
	}
	newvisibilities(1);
}

int
flprepare(Flayer *l)
{
	Frame *f;
	ulong n;
	Rune *r;

	if(l-&gt;visible == None)
		return 0;
	f = &amp;l-&gt;f;
	if(f-&gt;b == 0){
		if(l-&gt;visible == All)
			f-&gt;b = screen;
		else if((f-&gt;b = allocimage(display, l-&gt;entire, screen-&gt;chan, 0, 0))==0)
			return 0;
		draw(f-&gt;b, l-&gt;entire, f-&gt;cols[BACK], nil, ZP);
		border(f-&gt;b, l-&gt;entire, l==llist[0]? FLMARGIN : 1, f-&gt;cols[BORD], ZP);
		n = f-&gt;nchars;
		frinit(f, f-&gt;entire, f-&gt;font, f-&gt;b, 0);
		f-&gt;maxtab = maxtab*stringwidth(f-&gt;font, "0");
		if(f-&gt;maxtab == 0)
			fontbuggered(f-&gt;font-&gt;name);
		r = (*l-&gt;textfn)(l, n, &amp;n);
		frinsert(f, r, r+n, (ulong)0);
		frdrawsel(f, frptofchar(f, f-&gt;p0), f-&gt;p0, f-&gt;p1, 0);
		flfp0p1(l, &amp;f-&gt;p0, &amp;f-&gt;p1);
		frdrawsel(f, frptofchar(f, f-&gt;p0), f-&gt;p0, f-&gt;p1, 1);
		l-&gt;lastsr = ZR;
		scrdraw(l, scrtotal(l));
	}
	return 1;
}

static	int	somevis, someinvis, justvis;

Vis
visibility(Flayer *l)
{
	somevis = someinvis = 0;
	justvis = 1;
	flrefresh(l, l-&gt;entire, 0);
	justvis = 0;
	if(somevis==0)
		return None;
	if(someinvis==0)
		return All;
	return Some;
}

void
flrefresh(Flayer *l, Rectangle r, int i)
{
	Flayer *t;
	Rectangle s;

    Top:
	if((t=llist[i++]) == l){
		if(!justvis)
			draw(screen, r, l-&gt;f.b, nil, r.min);
		somevis = 1;
	}else{
		if(!rectXrect(t-&gt;entire, r))
			goto Top;	/* avoid stacking unnecessarily */
		if(t-&gt;entire.min.x&gt;r.min.x){
			s = r;
			s.max.x = t-&gt;entire.min.x;
			flrefresh(l, s, i);
			r.min.x = t-&gt;entire.min.x;
		}
		if(t-&gt;entire.min.y&gt;r.min.y){
			s = r;
			s.max.y = t-&gt;entire.min.y;
			flrefresh(l, s, i);
			r.min.y = t-&gt;entire.min.y;
		}
		if(t-&gt;entire.max.x&lt;r.max.x){
			s = r;
			s.min.x = t-&gt;entire.max.x;
			flrefresh(l, s, i);
			r.max.x = t-&gt;entire.max.x;
		}
		if(t-&gt;entire.max.y&lt;r.max.y){
			s = r;
			s.min.y = t-&gt;entire.max.y;
			flrefresh(l, s, i);
			r.max.y = t-&gt;entire.max.y;
		}
		/* remaining piece of r is blocked by t; forget about it */
		someinvis = 1;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

