<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/samterm/rasp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/samterm/rasp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include "flayer.h"
#include "samterm.h"

void
rinit(Rasp *r)
{
	r-&gt;nrunes=0;
	r-&gt;sect=0;
}

void
rclear(Rasp *r)
{
	Section *s, *ns;

	for(s=r-&gt;sect; s; s=ns){
		ns = s-&gt;next;
		free(s-&gt;text);
		free(s);
	}
	r-&gt;sect = 0;
}

Section*
rsinsert(Rasp *r, Section *s)	/* insert before s */
{
	Section *t;
	Section *u;

	t = alloc(sizeof(Section));
	if(r-&gt;sect == s){	/* includes empty list case: r-&gt;sect==s==0 */
		r-&gt;sect = t;
		t-&gt;next = s;
	}else{
		u = r-&gt;sect;
		if(u == 0)
			panic("rsinsert 1");
		do{
			if(u-&gt;next == s){
				t-&gt;next = s;
				u-&gt;next = t;
				goto Return;
			}
			u=u-&gt;next;
		}while(u);
		panic("rsinsert 2");
	}
    Return:
	return t;
}

void
rsdelete(Rasp *r, Section *s)
{
	Section *t;

	if(s == 0)
		panic("rsdelete");
	if(r-&gt;sect == s){
		r-&gt;sect = s-&gt;next;
		goto Free;
	}
	for(t=r-&gt;sect; t; t=t-&gt;next)
		if(t-&gt;next == s){
			t-&gt;next = s-&gt;next;
	Free:
			if(s-&gt;text)
				free(s-&gt;text);
			free(s);
			return;
		}
	panic("rsdelete 2");
}

void
splitsect(Rasp *r, Section *s, long n0)
{
	if(s == 0)
		panic("splitsect");
	rsinsert(r, s-&gt;next);
	if(s-&gt;text == 0)
		s-&gt;next-&gt;text = 0;
	else{
		s-&gt;next-&gt;text = alloc(RUNESIZE*(TBLOCKSIZE+1));
		Strcpy(s-&gt;next-&gt;text, s-&gt;text+n0);
		s-&gt;text[n0] = 0;
	}
	s-&gt;next-&gt;nrunes = s-&gt;nrunes-n0;
	s-&gt;nrunes = n0;
}

Section *
findsect(Rasp *r, Section *s, long p, long q)	/* find sect containing q and put q on a sect boundary */
{
	if(s==0 &amp;&amp; p!=q)
		panic("findsect");
	for(; s &amp;&amp; p+s-&gt;nrunes&lt;=q; s=s-&gt;next)
		p += s-&gt;nrunes;
	if(p != q){
		splitsect(r, s, q-p);
		s = s-&gt;next;
	}
	return s;
}

void
rresize(Rasp *r, long a, long old, long new)
{
	Section *s, *t, *ns;

	s = findsect(r, r-&gt;sect, 0L, a);
	t = findsect(r, s, a, a+old);
	for(; s!=t; s=ns){
		ns=s-&gt;next;
		rsdelete(r, s);
	}
	/* now insert the new piece before t */
	if(new &gt; 0){
		ns=rsinsert(r, t);
		ns-&gt;nrunes=new;
		ns-&gt;text=0;
	}
	r-&gt;nrunes += new-old;
}

void
rdata(Rasp *r, long p0, long p1, Rune *cp)
{
	Section *s, *t, *ns;

	s = findsect(r, r-&gt;sect, 0L, p0);
	t = findsect(r, s, p0, p1);
	for(; s!=t; s=ns){
		ns=s-&gt;next;
		if(s-&gt;text)
			panic("rdata");
		rsdelete(r, s);
	}
	p1 -= p0;
	s = rsinsert(r, t);
	s-&gt;text = alloc(RUNESIZE*(TBLOCKSIZE+1));
	memmove(s-&gt;text, cp, RUNESIZE*p1);
	s-&gt;text[p1] = 0;
	s-&gt;nrunes = p1;
}

void
rclean(Rasp *r)
{
	Section *s;

	for(s=r-&gt;sect; s; s=s-&gt;next)
		while(s-&gt;next &amp;&amp; (s-&gt;text!=0)==(s-&gt;next-&gt;text!=0)){
			if(s-&gt;text){
				if(s-&gt;nrunes+s-&gt;next-&gt;nrunes&gt;TBLOCKSIZE)
					break;
				Strcpy(s-&gt;text+s-&gt;nrunes, s-&gt;next-&gt;text);
			}
			s-&gt;nrunes += s-&gt;next-&gt;nrunes;
			rsdelete(r, s-&gt;next);
		}
}

void
Strcpy(Rune *to, Rune *from)
{
	do; while(*to++ = *from++);
}

Rune*
rload(Rasp *r, ulong p0, ulong p1, ulong *nrp)
{
	Section *s;
	long p;
	int n, nb;

	nb = 0;
	Strgrow(&amp;scratch, &amp;nscralloc, p1-p0+1);
	scratch[0] = 0;
	for(p=0,s=r-&gt;sect; s &amp;&amp; p+s-&gt;nrunes&lt;=p0; s=s-&gt;next)
		p += s-&gt;nrunes;
	while(p&lt;p1 &amp;&amp; s){
		/*
		 * Subtle and important.  If we are preparing to handle an 'rdata'
		 * call, it's because we have an 'rresize' hole here, so the
		 * screen doesn't have data for that space anyway (it got cut
		 * first).  So pretend it isn't there.
		 */
		if(s-&gt;text){
			n = s-&gt;nrunes-(p0-p);
			if(n&gt;p1-p0)	/* all in this section */
				n = p1-p0;
			memmove(scratch+nb, s-&gt;text+(p0-p), n*RUNESIZE);
			nb += n;
			scratch[nb] = 0;
		}
		p += s-&gt;nrunes;
		p0 = p;
		s = s-&gt;next;
	}
	if(nrp)
		*nrp = nb;
	return scratch;
}

int
rmissing(Rasp *r, ulong p0, ulong p1)
{
	Section *s;
	long p;
	int n, nm=0;

	for(p=0,s=r-&gt;sect; s &amp;&amp; p+s-&gt;nrunes&lt;=p0; s=s-&gt;next)
		p += s-&gt;nrunes;
	while(p&lt;p1 &amp;&amp; s){
		if(s-&gt;text == 0){
			n = s-&gt;nrunes-(p0-p);
			if(n &gt; p1-p0)	/* all in this section */
				n = p1-p0;
			nm += n;
		}
		p += s-&gt;nrunes;
		p0 = p;
		s = s-&gt;next;
	}
	return nm;
}

int
rcontig(Rasp *r, ulong p0, ulong p1, int text)
{
	Section *s;
	long p, n;
	int np=0;

	for(p=0,s=r-&gt;sect; s &amp;&amp; p+s-&gt;nrunes&lt;=p0; s=s-&gt;next)
		p += s-&gt;nrunes;
	while(p&lt;p1 &amp;&amp; s &amp;&amp; (text? (s-&gt;text!=0) : (s-&gt;text==0))){
		n = s-&gt;nrunes-(p0-p);
		if(n &gt; p1-p0)	/* all in this section */
			n = p1-p0;
		np += n;
		p += s-&gt;nrunes;
		p0 = p;
		s = s-&gt;next;
	}
	return np;
}

void
Strgrow(Rune **s, long *n, int want)	/* can always toss the old data when called */
{
	if(*n &gt;= want)
		return;
	free(*s);
	*s = alloc(RUNESIZE*want);
	*n = want;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

