<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/samterm/scroll.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/samterm/scroll.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include "flayer.h"
#include "samterm.h"

static Image *scrtmp;
static Image *scrback;

void
scrtemps(void)
{
	int h;

	if(scrtmp)
		return;
	if(screensize(0, &amp;h) == 0)
		h = 2048;
	scrtmp = allocimage(display, Rect(0, 0, 32, h), screen-&gt;chan, 0, 0);
	scrback = allocimage(display, Rect(0, 0, 32, h), screen-&gt;chan, 0, 0);
	if(scrtmp==0 || scrback==0)
		panic("scrtemps");
}

Rectangle
scrpos(Rectangle r, long p0, long p1, long tot)
{
	Rectangle q;
	int h;

	q = r;
	h = q.max.y-q.min.y;
	if(tot == 0)
		return q;
	if(tot &gt; 1024L*1024L)
		tot&gt;&gt;=10, p0&gt;&gt;=10, p1&gt;&gt;=10;
	if(p0 &gt; 0)
		q.min.y += h*p0/tot;
	if(p1 &lt; tot)
		q.max.y -= h*(tot-p1)/tot;
	if(q.max.y &lt; q.min.y+2){
		if(q.min.y+2 &lt;= r.max.y)
			q.max.y = q.min.y+2;
		else
			q.min.y = q.max.y-2;
	}
	return q;
}

void
scrmark(Flayer *l, Rectangle r)
{
	r.max.x--;
	if(rectclip(&amp;r, l-&gt;scroll)) {
		if (l-&gt;f.b == nil)
			panic("scrmark: nil l-&gt;f.b");
		draw(l-&gt;f.b, r, l-&gt;f.cols[HIGH], nil, ZP);
	}
}

void
scrunmark(Flayer *l, Rectangle r)
{
	if(rectclip(&amp;r, l-&gt;scroll)) {
		if (l-&gt;f.b == nil)
			panic("scrunmark: nil l-&gt;f.b");
		draw(l-&gt;f.b, r, scrback, nil, Pt(0, r.min.y-l-&gt;scroll.min.y));
	}
}

void
scrdraw(Flayer *l, long tot)
{
	Rectangle r, r1, r2;
	Image *b;

	scrtemps();
	if(l-&gt;f.b == 0)
		panic("scrdraw");
	r = l-&gt;scroll;
	r1 = r;
	if(l-&gt;visible == All){
		b = scrtmp;
		r1.min.x = 0;
		r1.max.x = Dx(r);
	}else
		b = l-&gt;f.b;
	r2 = scrpos(r1, l-&gt;origin, l-&gt;origin+l-&gt;f.nchars, tot);
	if(!eqrect(r2, l-&gt;lastsr)){
		l-&gt;lastsr = r2;
		draw(b, r1, l-&gt;f.cols[BORD], nil, ZP);
		draw(b, r2, l-&gt;f.cols[BACK], nil, r2.min);
		r2 = r1;
		r2.min.x = r2.max.x-1;
		draw(b, r2, l-&gt;f.cols[BORD], nil, ZP);
		if(b!=l-&gt;f.b)
			draw(l-&gt;f.b, r, b, nil, r1.min);
	}
}

void
scroll(Flayer *l, int but)
{
	int in = 0, oin;
	long tot = scrtotal(l);
	Rectangle scr, r, s, rt;
	int x, y, my, oy, h;
	long p0;

	s = l-&gt;scroll;
	x = s.min.x+FLSCROLLWID/2;
	scr = scrpos(l-&gt;scroll, l-&gt;origin, l-&gt;origin+l-&gt;f.nchars, tot);
	r = scr;
	y = scr.min.y;
	my = mousep-&gt;xy.y;
	draw(scrback, Rect(0,0,Dx(l-&gt;scroll), Dy(l-&gt;scroll)), l-&gt;f.b, nil, l-&gt;scroll.min);
	do{
		oin = in;
		in = abs(x-mousep-&gt;xy.x)&lt;=FLSCROLLWID/2;
		if(oin &amp;&amp; !in)
			scrunmark(l, r);
		if(in){
			scrmark(l, r);
			oy = y;
			my = mousep-&gt;xy.y;
			if(my &lt; s.min.y)
				my = s.min.y;
			if(my &gt;= s.max.y)
				my = s.max.y;
			if(!eqpt(mousep-&gt;xy, Pt(x, my)))
				moveto(mousectl, Pt(x, my));
			if(but == 1){
				p0 = l-&gt;origin-frcharofpt(&amp;l-&gt;f, Pt(s.max.x, my));
				rt = scrpos(l-&gt;scroll, p0, p0+l-&gt;f.nchars, tot);
				y = rt.min.y;
			}else if(but == 2){
				y = my;
				if(y &gt; s.max.y-2)
					y = s.max.y-2;
			}else if(but == 3){
				p0 = l-&gt;origin+frcharofpt(&amp;l-&gt;f, Pt(s.max.x, my));
				rt = scrpos(l-&gt;scroll, p0, p0+l-&gt;f.nchars, tot);
				y = rt.min.y;
			}
			if(y != oy){
				scrunmark(l, r);
				r = rectaddpt(scr, Pt(0, y-scr.min.y));
				scrmark(l, r);
			}
		}
	}while(button(but));
	if(in){
		h = s.max.y-s.min.y;
		scrunmark(l, r);
		p0 = 0;
		if(but == 1)
			p0 = (long)(my-s.min.y)/l-&gt;f.font-&gt;height+1;
		else if(but == 2){
			if(tot &gt; 1024L*1024L)
				p0 = ((tot&gt;&gt;10)*(y-s.min.y)/h)&lt;&lt;10;
			else
				p0 = tot*(y-s.min.y)/h;
		}else if(but == 3){
			p0 = l-&gt;origin+frcharofpt(&amp;l-&gt;f, Pt(s.max.x, my));
			if(p0 &gt; tot)
				p0 = tot;
		}
		scrorigin(l, but, p0);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

