<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scat/prose.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scat/prose.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "sky.h"

extern	Biobuf	bout;

char*
append(char *p, char *s)
{
	while(*s)
		*p++ = *s++;
	return p;
}

int
matchlen(char *a, char *b)
{
	int n;

	for(n=0; *a==*b; a++, b++, n++)
		if(*a == 0)
			return n;
	if(*a == 0)
		return n;
	return 0;
}

char*
prose(char *s, char *desc[][2], short index[])
{
	static char buf[512];
	char *p=buf;
	int i, j, k, max;

	j = 0;
	while(*s){
		if(p &gt;= buf+sizeof buf)
			abort();
		if(*s == ' '){
			if(p&gt;buf &amp;&amp; p[-1]!=' ')
				*p++ = ' ';
			s++;
			continue;
		}
		if(*s == ','){
			*p++ = ';', s++;
			continue;
		}
		if(s[0]=='M' &amp;&amp; '0'&lt;=s[1] &amp;&amp; s[1]&lt;='9'){	/* Messier tag */
			*p++ = *s++;
			continue;	/* below will copy the number */
		}
		if((i=index[*s]) == -1){
	Dup:
			switch(*s){
			default:
				while(*s &amp;&amp; *s!=',' &amp;&amp; *s!=' ')
					*p++=*s++;
				break;

			case '0': case '1': case '2': case '3': case '4':
			case '5': case '6': case '7': case '8': case '9':
				while('0'&lt;=*s &amp;&amp; *s&lt;='9')
					*p++ = *s++;
				if(*s=='\'' || *s=='s')
					*p++ = *s++;
				break;

			case '(': case ')':
			case '\'': case '"':
			case '&amp;': case '-': case '+':
				*p++ = *s++;
				break;

			case '*':
				if('0'&lt;=s[1] &amp;&amp; s[1]&lt;='9'){
					int flag=0;
					s++;
				Pnumber:
					while('0'&lt;=*s &amp;&amp; *s&lt;='9')
						*p++=*s++;
					if(s[0] == '-'){
						*p++ = *s++;
						flag++;
						goto Pnumber;
					}
					if(s[0]==',' &amp;&amp; s[1]==' ' &amp;&amp; '0'&lt;=s[2] &amp;&amp; s[2]&lt;='9'){
						*p++ = *s++;
						s++;	/* skip blank */
						flag++;
						goto Pnumber;
					}
					if(s[0] == '.'){
						if(s[1]=='.' &amp;&amp; s[2]=='.'){
							*p++ = '-';
							s += 3;
							flag++;
							goto Pnumber;
						}
						*p++ = *s++;
						goto Pnumber;
					}
					p = append(p, "m star");
					if(flag)
						*p++ = 's';
					*p++ = ' ';
					break;
				}
				if(s[1] == '*'){
					if(s[2] == '*'){
						p = append(p, "triple star ");
						s += 3;
					}else{
						p = append(p, "double star ");
						s += 2;
					}
					break;
				}
				p = append(p, "star ");
				s++;
				break;
			}
			continue;
		}
		for(max=-1; desc[i][0] &amp;&amp; desc[i][0][0]==*s; i++){
			k = matchlen(desc[i][0], s);
			if(k &gt; max)
				max = k, j = i;
		}
		if(max == 0)
			goto Dup;
		s += max;
		for(k=0; desc[j][1][k]; k++)
			*p++=desc[j][1][k];
		if(*s == ' ')
			*p++ = *s++;
		else if(*s == ',')
			*p++ = ';', s++;
		else
			*p++ = ' ';
	}
	*p = 0;
	return buf;
}

void
prdesc(char *s, char *desc[][2], short index[])
{
	int c, j;

	if(index[0] == 0){
		index[0] = 1;
		for(c=1, j=0; c&lt;128; c++)
			if(desc[j][0]==0 || desc[j][0][0]&gt;c)
				index[c] = -1;
			else if(desc[j][0][0] == c){
				index[c] = j;
				while(desc[j][0] &amp;&amp; desc[j][0][0] == c)
					j++;
				if(j &gt;= NINDEX){
					fprint(2, "scat: internal error: too many prose entries\n");
					exits("NINDEX");
				}
			}
	}
	Bprint(&amp;bout, "\t%s [%s]\n", prose(s, desc, index), s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

