<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scuzz/cdr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scuzz/cdr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;disk.h&gt;
#include "scsireq.h"

long
SRblank(ScsiReq *rp, uchar type, uchar track)
{
	uchar cmd[12];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdBlank;
	cmd[1] = type;
	cmd[2] = track&gt;&gt;24;
	cmd[3] = track&gt;&gt;16;
	cmd[4] = track&gt;&gt;8;
	cmd[5] = track;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRsynccache(ScsiReq *rp)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdSynccache;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRTOC(ScsiReq *rp, void *data, int nbytes, uchar format, uchar track)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdRTOC;
	cmd[2] = format;
	cmd[6] = track;
	cmd[7] = nbytes&gt;&gt;8;
	cmd[8] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = data;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRrdiscinfo(ScsiReq *rp, void *data, int nbytes)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdRdiscinfo;
	cmd[7] = nbytes&gt;&gt;8;
	cmd[8] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = data;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRrtrackinfo(ScsiReq *rp, void *data, int nbytes, int track)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdRtrackinfo;
	cmd[1] = 0x01;
	cmd[2] = track&gt;&gt;24;
	cmd[3] = track&gt;&gt;16;
	cmd[4] = track&gt;&gt;8;
	cmd[5] = track;
	cmd[7] = nbytes&gt;&gt;8;
	cmd[8] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = data;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRfwaddr(ScsiReq *rp, uchar track, uchar mode, uchar npa, uchar *data)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdFwaddr;
	cmd[2] = track;
	cmd[3] = mode;
	cmd[7] = npa;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = data;
	rp-&gt;data.count = MaxDirData;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRtreserve(ScsiReq *rp, long nbytes)
{
	uchar cmd[10];
	long n;

	if((nbytes % rp-&gt;lbsize)){
		rp-&gt;status = Status_BADARG;
		return -1;
	}
	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdTreserve;
	n = nbytes/rp-&gt;lbsize;
	cmd[5] = n&gt;&gt;24;
	cmd[6] = n&gt;&gt;16;
	cmd[7] = n&gt;&gt;8;
	cmd[8] = n;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRtinfo(ScsiReq *rp, uchar track, uchar *data)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdTinfo;
	cmd[5] = track;
	cmd[8] = MaxDirData;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = data;
	rp-&gt;data.count = MaxDirData;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRwtrack(ScsiReq *rp, void *buf, long nbytes, uchar track, uchar mode)
{
	uchar cmd[10];
	long m, n;

	if((nbytes % rp-&gt;lbsize) || nbytes &gt; maxiosize){
		rp-&gt;status = Status_BADARG;
		return -1;
	}
	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdTwrite;
	cmd[5] = track;
	cmd[6] = mode;
	n = nbytes/rp-&gt;lbsize;
	cmd[7] = n&gt;&gt;8;
	cmd[8] = n;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = buf;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 1;
	m = SRrequest(rp);
	if(m &lt; 0)
		return -1;
	rp-&gt;offset += n;
	return m;
}

long
SRmload(ScsiReq *rp, uchar code)
{
	uchar cmd[12];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdMload;
	cmd[8] = code;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRfixation(ScsiReq *rp, uchar type)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdFixation;
	cmd[8] = type;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

