<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sort.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sort.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;bio.h&gt;

/*
bugs:
	00/ff for end of file can conflict with 00/ff characters
*/

enum
{
	Nline	= 100000,		/* default max number of lines saved in memory */
	Nmerge	= 10,			/* max number of temporary files merged */
	Nfield	= 20,			/* max number of argument fields */

	Bflag	= 1&lt;&lt;0,			/* flags per field */
	B1flag	= 1&lt;&lt;1,

	Dflag	= 1&lt;&lt;2,
	Fflag	= 1&lt;&lt;3,
	Gflag	= 1&lt;&lt;4,
	Iflag	= 1&lt;&lt;5,
	Mflag	= 1&lt;&lt;6,
	Nflag	= 1&lt;&lt;7,
	Rflag	= 1&lt;&lt;8,
	Wflag	= 1&lt;&lt;9,

	NSstart	= 0,			/* states for number to key decoding */
	NSsign,
	NSzero,
	NSdigit,
	NSpoint,
	NSfract,
	NSzerofract,
	NSexp,
	NSexpsign,
	NSexpdigit,
};

typedef	struct	Line	Line;
typedef	struct	Key	Key;
typedef	struct	Merge	Merge;
typedef	struct	Field	Field;

struct	Line
{
	Key*	key;
	int	llen;		/* always &gt;= 1 */
	uchar	line[1];	/* always ends in '\n' */
};

struct	Merge
{
	Key*	key;		/* copy of line-&gt;key so (Line*) looks like (Merge*) */
	Line*	line;		/* line at the head of a merged temp file */
	int	fd;		/* file descriptor */
	Biobuf	b;		/* iobuf for reading a temp file */
};

struct	Key
{
	int	klen;
	uchar	key[1];
};

struct	Field
{
	int	beg1;
	int	beg2;
	int	end1;
	int	end2;

	long	flags;
	uchar	mapto[1+255];

	void	(*dokey)(Key*, uchar*, uchar*, Field*);
};

struct args
{
	char*	ofile;
	char*	tname;
	Rune	tabchar;
	char	cflag;
	char	uflag;
	char	vflag;
	int	nfield;
	int	nfile;
	Field	field[Nfield];

	Line**	linep;
	long	nline;			/* number of lines in this temp file */
	long	lineno;			/* overall ordinal for -s option */
	int	ntemp;
	long	mline;			/* max lines per file */
} args;

extern	Rune*	month[12];

void	buildkey(Line*);
void	doargs(int, char*[]);
void	dofield(char*, int*, int*, int, int);
void	dofile(Biobuf*);
void	dokey_(Key*, uchar*, uchar*, Field*);
void	dokey_dfi(Key*, uchar*, uchar*, Field*);
void	dokey_gn(Key*, uchar*, uchar*, Field*);
void	dokey_m(Key*, uchar*, uchar*, Field*);
void	dokey_r(Key*, uchar*, uchar*, Field*);
void	done(char*);
int	kcmp(Key*, Key*);
void	makemapd(Field*);
void	makemapm(Field*);
void	mergefiles(int, int, Biobuf*);
void	mergeout(Biobuf*);
void	newfield(void);
Line*	newline(Biobuf*);
void	nomem(void);
void	notifyf(void*, char*);
void	printargs(void);
void	printout(Biobuf*);
void	setfield(int, int);
uchar*	skip(uchar*, int, int, int, int);
void	sort4(void*, ulong);
char*	tempfile(int);
void	tempout(void);
void	lineout(Biobuf*, Line*);

void
main(int argc, char *argv[])
{
	int i, f;
	char *s;
	Biobuf bbuf;

	notify(notifyf);	/**/
	doargs(argc, argv);
	if(args.vflag)
		printargs();

	for(i=1; i&lt;argc; i++) {
		s = argv[i];
		if(s == 0)
			continue;
		if(strcmp(s, "-") == 0) {
			Binit(&amp;bbuf, 0, OREAD);
			dofile(&amp;bbuf);
			Bterm(&amp;bbuf);
			continue;
		}
		f = open(s, OREAD);
		if(f &lt; 0) {
			fprint(2, "sort: open %s: %r\n", s);
			done("open");
		}
		Binit(&amp;bbuf, f, OREAD);
		dofile(&amp;bbuf);
		Bterm(&amp;bbuf);
		close(f);
	}
	if(args.nfile == 0) {
		Binit(&amp;bbuf, 0, OREAD);
		dofile(&amp;bbuf);
		Bterm(&amp;bbuf);
	}
	if(args.cflag)
		done(0);
	if(args.vflag)
		fprint(2, "=========\n");

	f = 1;
	if(args.ofile) {
		f = create(args.ofile, OWRITE, 0666);
		if(f &lt; 0) {
			fprint(2, "sort: create %s: %r\n", args.ofile);
			done("create");
		}
	}

	Binit(&amp;bbuf, f, OWRITE);
	if(args.ntemp) {
		tempout();
		mergeout(&amp;bbuf);
	} else {
		printout(&amp;bbuf);
	}
	Bterm(&amp;bbuf);
	done(0);
}

void
dofile(Biobuf *b)
{
	Line *l, *ol;
	int n;

	if(args.cflag) {
		ol = newline(b);
		if(ol == 0)
			return;
		for(;;) {
			l = newline(b);
			if(l == 0)
				break;
			n = kcmp(ol-&gt;key, l-&gt;key);
			if(n &gt; 0 || (n == 0 &amp;&amp; args.uflag)) {
				fprint(2, "sort: -c file not in sort\n"); /**/
				done("order");
			}
			free(ol-&gt;key);
			free(ol);
			ol = l;
		}
		return;
	}

	if(args.linep == 0) {
		args.linep = malloc(args.mline * sizeof(args.linep));
		if(args.linep == 0)
			nomem();
	}
	for(;;) {
		l = newline(b);
		if(l == 0)
			break;
		if(args.nline &gt;= args.mline)
			tempout();
		args.linep[args.nline] = l;
		args.nline++;
		args.lineno++;
	}
}

void
notifyf(void*, char *s)
{

	if(strcmp(s, "interrupt") == 0)
		done(0);
	if(strcmp(s, "hangup") == 0)
		done(0);
	if(strcmp(s, "kill") == 0)
		done(0);
	if(strncmp(s, "sys: write on closed pipe", 25) == 0)
		done(0);
	fprint(2, "sort: note: %s\n", s);
	abort();
}

Line*
newline(Biobuf *b)
{
	Line *l;
	char *p;
	int n, c;

	p = Brdline(b, '\n');
	n = Blinelen(b);
	if(p == 0) {
		if(n == 0)
			return 0;
		l = 0;
		for(n=0;;) {
			if((n &amp; 31) == 0) {
				l = realloc(l, sizeof(Line) +
					(n+31)*sizeof(l-&gt;line[0]));
				if(l == 0)
					nomem();
			}
			c = Bgetc(b);
			if(c &lt; 0) {
				fprint(2, "sort: newline added\n");
				c = '\n';
			}
			l-&gt;line[n++] = c;
			if(c == '\n')
				break;
		}
		l-&gt;llen = n;
		buildkey(l);
		return l;
	}
	l = malloc(sizeof(Line) +
		(n-1)*sizeof(l-&gt;line[0]));
	if(l == 0)
		nomem();
	l-&gt;llen = n;
	memmove(l-&gt;line, p, n);
	buildkey(l);
	return l;
}

void
lineout(Biobuf *b, Line *l)
{
	int n, m;

	n = l-&gt;llen;
	m = Bwrite(b, l-&gt;line, n);
	if(n != m)
		exits("write");
}

void
tempout(void)
{
	long n;
	Line **lp, *l;
	char *tf;
	int f;
	Biobuf tb;

	sort4(args.linep, args.nline);
	tf = tempfile(args.ntemp);
	args.ntemp++;
	f = create(tf, OWRITE, 0666);
	if(f &lt; 0) {
		fprint(2, "sort: create %s: %r\n", tf);
		done("create");
	}

	Binit(&amp;tb, f, OWRITE);
	lp = args.linep;
	for(n=args.nline; n&gt;0; n--) {
		l = *lp++;
		lineout(&amp;tb, l);
		free(l-&gt;key);
		free(l);
	}
	args.nline = 0;
	Bterm(&amp;tb);
	close(f);
}

void
done(char *xs)
{
	int i;

	for(i=0; i&lt;args.ntemp; i++)
		remove(tempfile(i));
	exits(xs);
}

void
nomem(void)
{
	fprint(2, "sort: out of memory\n");
	done("mem");
}

char*
tempfile(int n)
{
	static char file[100];
	static uint pid;
	char *dir;

	dir = "/tmp";
	if(args.tname)
		dir = args.tname;
	if(strlen(dir) &gt;= nelem(file)-20) {
		fprint(2, "temp file directory name is too long: %s\n", dir);
		done("tdir");
	}

	if(pid == 0) {
		pid = getpid();
		if(pid == 0) {
			pid = time(0);
			if(pid == 0)
				pid = 1;
		}
	}

	sprint(file, "%s/sort.%.4d.%.4d", dir, pid%10000, n);
	return file;
}

void
mergeout(Biobuf *b)
{
	int n, i, f;
	char *tf;
	Biobuf tb;

	for(i=0; i&lt;args.ntemp; i+=n) {
		n = args.ntemp - i;
		if(n &gt; Nmerge) {
			tf = tempfile(args.ntemp);
			args.ntemp++;
			f = create(tf, OWRITE, 0666);
			if(f &lt; 0) {
				fprint(2, "sort: create %s: %r\n", tf);
				done("create");
			}
			Binit(&amp;tb, f, OWRITE);

			n = Nmerge;
			mergefiles(i, n, &amp;tb);

			Bterm(&amp;tb);
			close(f);
		} else
			mergefiles(i, n, b);
	}
}

void
mergefiles(int t, int n, Biobuf *b)
{
	Merge *m, *mp, **mmp;
	Key *ok;
	Line *l;
	char *tf;
	int i, f, nn;

	mmp = malloc(n*sizeof(*mmp));
	mp = malloc(n*sizeof(*mp));
	if(mmp == 0 || mp == 0)
		nomem();

	nn = 0;
	m = mp;
	for(i=0; i&lt;n; i++,m++) {
		tf = tempfile(t+i);
		f = open(tf, OREAD);
		if(f &lt; 0) {
			fprint(2, "sort: reopen %s: %r\n", tf);
			done("open");
		}
		m-&gt;fd = f;
		Binit(&amp;m-&gt;b, f, OREAD);
		mmp[nn] = m;

		l = newline(&amp;m-&gt;b);
		if(l == 0)
			continue;
		nn++;
		m-&gt;line = l;
		m-&gt;key = l-&gt;key;
	}

	ok = 0;
	for(;;) {
		sort4(mmp, nn);
		m = *mmp;
		if(nn == 0)
			break;
		for(;;) {
			l = m-&gt;line;
			if(args.uflag &amp;&amp; ok &amp;&amp; kcmp(ok, l-&gt;key) == 0) {
				free(l-&gt;key);
				free(l);
			} else {
				lineout(b, l);
				if(ok)
					free(ok);
				ok = l-&gt;key;
				free(l);
			}

			l = newline(&amp;m-&gt;b);
			if(l == 0) {
				nn--;
				mmp[0] = mmp[nn];
				break;
			}
			m-&gt;line = l;
			m-&gt;key = l-&gt;key;
			if(nn &gt; 1 &amp;&amp; kcmp(mmp[0]-&gt;key, mmp[1]-&gt;key) &gt; 0)
				break;
		}
	}
	if(ok)
		free(ok);

	m = mp;
	for(i=0; i&lt;n; i++,m++) {
		Bterm(&amp;m-&gt;b);
		close(m-&gt;fd);
	}

	free(mp);
	free(mmp);
}

int
kcmp(Key *ka, Key *kb)
{
	int n, m;

	/*
	 * set n to length of smaller key
	 */
	n = ka-&gt;klen;
	m = kb-&gt;klen;
	if(n &gt; m)
		n = m;
	return memcmp(ka-&gt;key, kb-&gt;key, n);
}

void
printout(Biobuf *b)
{
	long n;
	Line **lp, *l;
	Key *ok;

	sort4(args.linep, args.nline);
	lp = args.linep;
	ok = 0;
	for(n=args.nline; n&gt;0; n--) {
		l = *lp++;
		if(args.uflag &amp;&amp; ok &amp;&amp; kcmp(ok, l-&gt;key) == 0)
			continue;
		lineout(b, l);
		ok = l-&gt;key;
	}
}

void
setfield(int n, int c)
{
	Field *f;

	f = &amp;args.field[n];
	switch(c) {
	default:
		fprint(2, "sort: unknown option: field.%C\n", c);
		done("option");
	case 'b':	/* skip blanks */
		f-&gt;flags |= Bflag;
		break;
	case 'd':	/* directory order */
		f-&gt;flags |= Dflag;
		break;
	case 'f':	/* fold case */
		f-&gt;flags |= Fflag;
		break;
	case 'g':	/* floating point -n case */
		f-&gt;flags |= Gflag;
		break;
	case 'i':	/* ignore non-ascii */
		f-&gt;flags |= Iflag;
		break;
	case 'M':	/* month */
		f-&gt;flags |= Mflag;
		break;
	case 'n':	/* numbers */
		f-&gt;flags |= Nflag;
		break;
	case 'r':	/* reverse */
		f-&gt;flags |= Rflag;
		break;
	case 'w':	/* ignore white */
		f-&gt;flags |= Wflag;
		break;
	}
}

void
dofield(char *s, int *n1, int *n2, int off1, int off2)
{
	int c, n;

	c = *s++;
	if(c &gt;= '0' &amp;&amp; c &lt;= '9') {
		n = 0;
		while(c &gt;= '0' &amp;&amp; c &lt;= '9') {
			n = n*10 + (c-'0');
			c = *s++;
		}
		n -= off1;	/* posix committee: rot in hell */
		if(n &lt; 0) {
			fprint(2, "sort: field offset must be positive\n");
			done("option");
		}
		*n1 = n;
	}
	if(c == '.') {
		c = *s++;
		if(c &gt;= '0' &amp;&amp; c &lt;= '9') {
			n = 0;
			while(c &gt;= '0' &amp;&amp; c &lt;= '9') {
				n = n*10 + (c-'0');
				c = *s++;
			}
			n -= off2;
			if(n &lt; 0) {
				fprint(2, "sort: character offset must be positive\n");
				done("option");
			}
			*n2 = n;
		}
	}
	while(c != 0) {
		setfield(args.nfield, c);
		c = *s++;
	}
}

void
printargs(void)
{
	int i, n;
	Field *f;
	char *prefix;

	fprint(2, "sort");
	for(i=0; i&lt;=args.nfield; i++) {
		f = &amp;args.field[i];
		prefix = " -";
		if(i) {
			n = f-&gt;beg1;
			if(n &gt;= 0)
				fprint(2, " +%d", n);
			else
				fprint(2, " +*");
			n = f-&gt;beg2;
			if(n &gt;= 0)
				fprint(2, ".%d", n);
			else
				fprint(2, ".*");

			if(f-&gt;flags &amp; B1flag)
				fprint(2, "b");

			n = f-&gt;end1;
			if(n &gt;= 0)
				fprint(2, " -%d", n);
			else
				fprint(2, " -*");
			n = f-&gt;end2;
			if(n &gt;= 0)
				fprint(2, ".%d", n);
			else
				fprint(2, ".*");
			prefix = "";
		}
		if(f-&gt;flags &amp; Bflag)
			fprint(2, "%sb", prefix);
		if(f-&gt;flags &amp; Dflag)
			fprint(2, "%sd", prefix);
		if(f-&gt;flags &amp; Fflag)
			fprint(2, "%sf", prefix);
		if(f-&gt;flags &amp; Gflag)
			fprint(2, "%sg", prefix);
		if(f-&gt;flags &amp; Iflag)
			fprint(2, "%si", prefix);
		if(f-&gt;flags &amp; Mflag)
			fprint(2, "%sM", prefix);
		if(f-&gt;flags &amp; Nflag)
			fprint(2, "%sn", prefix);
		if(f-&gt;flags &amp; Rflag)
			fprint(2, "%sr", prefix);
		if(f-&gt;flags &amp; Wflag)
			fprint(2, "%sw", prefix);
	}
	if(args.cflag)
		fprint(2, " -c");
	if(args.uflag)
		fprint(2, " -u");
	if(args.ofile)
		fprint(2, " -o %s", args.ofile);
	if(args.mline != Nline)
		fprint(2, " -l %ld", args.mline);
	fprint(2, "\n");
}

void
newfield(void)
{
	int n;
	Field *f;

	n = args.nfield + 1;
	if(n &gt;= Nfield) {
		fprint(2, "sort: too many fields specified\n");
		done("option");
	}
	args.nfield = n;
	f = &amp;args.field[n];
	f-&gt;beg1 = -1;
	f-&gt;beg2 = -1;
	f-&gt;end1 = -1;
	f-&gt;end2 = -1;
}

void
doargs(int argc, char *argv[])
{
	int i, c, hadplus;
	char *s, *p, *q;
	Field *f;

	hadplus = 0;
	args.mline = Nline;
	for(i=1; i&lt;argc; i++) {
		s = argv[i];
		c = *s++;
		if(c == '-') {
			c = *s;
			if(c == 0)		/* forced end of arg marker */
				break;
			argv[i] = 0;		/* clobber args processed */
			if(c == '.' || (c &gt;= '0' &amp;&amp; c &lt;= '9')) {
				if(!hadplus)
					newfield();
				f = &amp;args.field[args.nfield];
				dofield(s, &amp;f-&gt;end1, &amp;f-&gt;end2, 0, 0);
				hadplus = 0;
				continue;
			}

			while(c = *s++)
			switch(c) {
			case '-':	/* end of options */
				i = argc;
				continue;
			case 'T':	/* temp directory */
				if(*s == 0) {
					i++;
					if(i &lt; argc) {
						args.tname = argv[i];
						argv[i] = 0;
					}
				} else
					args.tname = s;
				s = strchr(s, 0);
				break;
			case 'o':	/* output file */
				if(*s == 0) {
					i++;
					if(i &lt; argc) {
						args.ofile = argv[i];
						argv[i] = 0;
					}
				} else
					args.ofile = s;
				s = strchr(s, 0);
				break;
			case 'k':	/* posix key (what were they thinking?) */
				p = 0;
				if(*s == 0) {
					i++;
					if(i &lt; argc) {
						p = argv[i];
						argv[i] = 0;
					}
				} else
					p = s;
				s = strchr(s, 0);
				if(p == 0)
					break;

				newfield();
				q = strchr(p, ',');
				if(q)
					*q++ = 0;
				f = &amp;args.field[args.nfield];
				dofield(p, &amp;f-&gt;beg1, &amp;f-&gt;beg2, 1, 1);
				if(f-&gt;flags &amp; Bflag) {
					f-&gt;flags |= B1flag;
					f-&gt;flags &amp;= ~Bflag;
				}
				if(q) {
					dofield(q, &amp;f-&gt;end1, &amp;f-&gt;end2, 1, 0);
					if(f-&gt;end2 &lt;= 0)
						f-&gt;end1++;
				}
				hadplus = 0;
				break;
			case 't':	/* tab character */
				if(*s == 0) {
					i++;
					if(i &lt; argc) {
						chartorune(&amp;args.tabchar, argv[i]);
						argv[i] = 0;
					}
				} else
					s += chartorune(&amp;args.tabchar, s);
				if(args.tabchar == '\n') {
					fprint(2, "aw come on, rob\n");
					done("rob");
				}
				break;
			case 'c':	/* check order */
				args.cflag = 1;
				break;
			case 'u':	/* unique */
				args.uflag = 1;
				break;
			case 'v':	/* debugging noise */
				args.vflag = 1;
				break;
			case 'l':
				if(*s == 0) {
					i++;
					if(i &lt; argc) {
						args.mline = atol(argv[i]);
						argv[i] = 0;
					}
				} else
					args.mline = atol(s);
				s = strchr(s, 0);
				break;

			case 'M':	/* month */
			case 'b':	/* skip blanks */
			case 'd':	/* directory order */
			case 'f':	/* fold case */
			case 'g':	/* floating numbers */
			case 'i':	/* ignore non-ascii */
			case 'n':	/* numbers */
			case 'r':	/* reverse */
			case 'w':	/* ignore white */
				if(args.nfield &gt; 0)
					fprint(2, "sort: global field set after -k\n");
				setfield(0, c);
				break;
			case 'm':
				/* option m silently ignored but required by posix */
				break;
			default:
				fprint(2, "sort: unknown option: -%C\n", c);
				done("option");
			}
			continue;
		}
		if(c == '+') {
			argv[i] = 0;		/* clobber args processed */
			c = *s;
			if(c == '.' || (c &gt;= '0' &amp;&amp; c &lt;= '9')) {
				newfield();
				f = &amp;args.field[args.nfield];
				dofield(s, &amp;f-&gt;beg1, &amp;f-&gt;beg2, 0, 0);
				if(f-&gt;flags &amp; Bflag) {
					f-&gt;flags |= B1flag;
					f-&gt;flags &amp;= ~Bflag;
				}
				hadplus = 1;
				continue;
			}
			fprint(2, "sort: unknown option: +%C\n", c);
			done("option");
		}
		args.nfile++;
	}

	for(i=0; i&lt;=args.nfield; i++) {
		f = &amp;args.field[i];

		/*
		 * global options apply to fields that
		 * specify no options
		 */
		if(f-&gt;flags == 0) {
			f-&gt;flags = args.field[0].flags;
			if(args.field[0].flags &amp; Bflag)
				f-&gt;flags |= B1flag;
		}


		/*
		 * build buildkey specification
		 */
		switch(f-&gt;flags &amp; ~(Bflag|B1flag)) {
		default:
			fprint(2, "sort: illegal combination of flags: %lx\n", f-&gt;flags);
			done("option");
		case 0:
			f-&gt;dokey = dokey_;
			break;
		case Rflag:
			f-&gt;dokey = dokey_r;
			break;
		case Gflag:
		case Nflag:
		case Gflag|Nflag:
		case Gflag|Rflag:
		case Nflag|Rflag:
		case Gflag|Nflag|Rflag:
			f-&gt;dokey = dokey_gn;
			break;
		case Mflag:
		case Mflag|Rflag:
			f-&gt;dokey = dokey_m;
			makemapm(f);
			break;
		case Dflag:
		case Dflag|Fflag:
		case Dflag|Fflag|Iflag:
		case Dflag|Fflag|Iflag|Rflag:
		case Dflag|Fflag|Iflag|Rflag|Wflag:
		case Dflag|Fflag|Iflag|Wflag:
		case Dflag|Fflag|Rflag:
		case Dflag|Fflag|Rflag|Wflag:
		case Dflag|Fflag|Wflag:
		case Dflag|Iflag:
		case Dflag|Iflag|Rflag:
		case Dflag|Iflag|Rflag|Wflag:
		case Dflag|Iflag|Wflag:
		case Dflag|Rflag:
		case Dflag|Rflag|Wflag:
		case Dflag|Wflag:
		case Fflag:
		case Fflag|Iflag:
		case Fflag|Iflag|Rflag:
		case Fflag|Iflag|Rflag|Wflag:
		case Fflag|Iflag|Wflag:
		case Fflag|Rflag:
		case Fflag|Rflag|Wflag:
		case Fflag|Wflag:
		case Iflag:
		case Iflag|Rflag:
		case Iflag|Rflag|Wflag:
		case Iflag|Wflag:
		case Wflag:
			f-&gt;dokey = dokey_dfi;
			makemapd(f);
			break;
		}
	}

	/*
	 * random spot checks
	 */
	if(args.nfile &gt; 1 &amp;&amp; args.cflag) {
		fprint(2, "sort: -c can have at most one input file\n");
		done("option");
	}
	return;
}

uchar*
skip(uchar *l, int n1, int n2, int bflag, int endfield)
{
	int i, c, tc;
	Rune r;

	if(endfield &amp;&amp; n1 &lt; 0)
		return 0;

	c = *l++;
	tc = args.tabchar;
	if(tc) {
		if(tc &lt; Runeself) {
			for(i=n1; i&gt;0; i--) {
				while(c != tc) {
					if(c == '\n')
						return 0;
					c = *l++;
				}
				if(!(endfield &amp;&amp; i == 1))
					c = *l++;
			}
		} else {
			l--;
			l += chartorune(&amp;r, (char*)l);
			for(i=n1; i&gt;0; i--) {
				while(r != tc) {
					if(r == '\n')
						return 0;
					l += chartorune(&amp;r, (char*)l);
				}
				if(!(endfield &amp;&amp; i == 1))
					l += chartorune(&amp;r, (char*)l);
			}
			c = r;
		}
	} else {
		for(i=n1; i&gt;0; i--) {
			while(c == ' ' || c == '\t')
				c = *l++;
			while(c != ' ' &amp;&amp; c != '\t') {
				if(c == '\n')
					return 0;
				c = *l++;
			}
		}
	}

	if(bflag)
		while(c == ' ' || c == '\t')
			c = *l++;

	l--;
	for(i=n2; i&gt;0; i--) {
		c = *l;
		if(c &lt; Runeself) {
			if(c == '\n')
				return 0;
			l++;
			continue;
		}
		l += chartorune(&amp;r, (char*)l);
	}
	return l;
}

void
dokey_gn(Key *k, uchar *lp, uchar *lpe, Field *f)
{
	uchar *kp;
	int c, cl, dp;
	int state, nzero, exp, expsign, rflag;

	cl = k-&gt;klen + 3;
	kp = k-&gt;key + cl;	/* skip place for sign, exponent[2] */

	nzero = 0;		/* number of trailing zeros */
	exp = 0;		/* value of the exponent */
	expsign = 0;		/* sign of the exponent */
	dp = 0x4040;		/* location of decimal point */
	rflag = f-&gt;flags&amp;Rflag;	/* xor of rflag and - sign */
	state = NSstart;

	for(;; lp++) {
		if(lp &gt;= lpe)
			break;
		c = *lp;

		if(c == ' ' || c == '\t') {
			switch(state) {
			case NSstart:
			case NSsign:
				continue;
			}
			break;
		}
		if(c == '+' || c == '-') {
			switch(state) {
			case NSstart:
				state = NSsign;
				if(c == '-')
					rflag = !rflag;
				continue;
			case NSexp:
				state = NSexpsign;
				if(c == '-')
					expsign = 1;
				continue;
			}
			break;
		}
		if(c == '0') {
			switch(state) {
			case NSdigit:
				if(rflag)
					c = ~c;
				*kp++ = c;
				cl++;
				nzero++;
				dp++;
				state = NSdigit;
				continue;
			case NSfract:
				if(rflag)
					c = ~c;
				*kp++ = c;
				cl++;
				nzero++;
				state = NSfract;
				continue;
			case NSstart:
			case NSsign:
			case NSzero:
				state = NSzero;
				continue;
			case NSzerofract:
			case NSpoint:
				dp--;
				state = NSzerofract;
				continue;
			case NSexpsign:
			case NSexp:
			case NSexpdigit:
				exp = exp*10 + (c - '0');
				state = NSexpdigit;
				continue;
			}
			break;
		}
		if(c &gt;= '1' &amp;&amp; c &lt;= '9') {
			switch(state) {
			case NSzero:
			case NSstart:
			case NSsign:
			case NSdigit:
				if(rflag)
					c = ~c;
				*kp++ = c;
				cl++;
				nzero = 0;
				dp++;
				state = NSdigit;
				continue;
			case NSzerofract:
			case NSpoint:
			case NSfract:
				if(rflag)
					c = ~c;
				*kp++ = c;
				cl++;
				nzero = 0;
				state = NSfract;
				continue;
			case NSexpsign:
			case NSexp:
			case NSexpdigit:
				exp = exp*10 + (c - '0');
				state = NSexpdigit;
				continue;
			}
			break;
		}
		if(c == '.') {
			switch(state) {
			case NSstart:
			case NSsign:
				state = NSpoint;
				continue;
			case NSzero:
				state = NSzerofract;
				continue;
			case NSdigit:
				state = NSfract;
				continue;
			}
			break;
		}
		if((f-&gt;flags &amp; Gflag) &amp;&amp; (c == 'e' || c == 'E')) {
			switch(state) {
			case NSdigit:
			case NSfract:
				state = NSexp;
				continue;
			}
			break;
		}
		break;
	}

	switch(state) {
	/*
	 * result is zero
	 */
	case NSstart:
	case NSsign:
	case NSzero:
	case NSzerofract:
	case NSpoint:
		kp = k-&gt;key + k-&gt;klen;
		k-&gt;klen += 2;
		kp[0] = 0x20;	/* between + and - */
		kp[1] = 0;
		return;
	/*
	 * result has exponent
	 */
	case NSexpsign:
	case NSexp:
	case NSexpdigit:
		if(expsign)
			exp = -exp;
		dp += exp;

	/*
	 * result is fixed point number
	 */
	case NSdigit:
	case NSfract:
		kp -= nzero;
		cl -= nzero;
		break;
	}

	/*
	 * end of number
	 */
	c = 0;
	if(rflag)
		c = ~c;
	*kp = c;

	/*
	 * sign and exponent
	 */
	c = 0x30;
	if(rflag) {
		c = 0x10;
		dp = ~dp;
	}
	kp = k-&gt;key + k-&gt;klen;
	kp[0] = c;
	kp[1] = (dp &gt;&gt; 8);
	kp[2] = dp;
	k-&gt;klen = cl+1;
}

void
dokey_m(Key *k, uchar *lp, uchar *lpe, Field *f)
{
	uchar *kp;
	Rune r, place[3];
	int c, cl, pc;
	int rflag;

	rflag = f-&gt;flags&amp;Rflag;
	pc = 0;

	cl = k-&gt;klen;
	kp = k-&gt;key + cl;

	for(;;) {
		/*
		 * get the character
		 */
		if(lp &gt;= lpe)
			break;
		c = *lp;
		if(c &gt;= Runeself) {
			lp += chartorune(&amp;r, (char*)lp);
			c = r;
		} else
			lp++;

		if(c &lt; nelem(f-&gt;mapto)) {
			c = f-&gt;mapto[c];
			if(c == 0)
				continue;
		}
		place[pc++] = c;
		if(pc &lt; 3)
			continue;
		for(c=11; c&gt;=0; c--)
			if(memcmp(month[c], place, sizeof(place)) == 0)
				break;
		c += 10;
		if(rflag)
			c = ~c;
		*kp++ = c;
		cl++;
		break;
	}

	c = 0;
	if(rflag)
		c = ~c;
	*kp = c;
	k-&gt;klen = cl+1;
}

void
dokey_dfi(Key *k, uchar *lp, uchar *lpe, Field *f)
{
	uchar *kp;
	Rune r;
	int c, cl, n, rflag;

	cl = k-&gt;klen;
	kp = k-&gt;key + cl;
	rflag = f-&gt;flags &amp; Rflag;

	for(;;) {
		/*
		 * get the character
		 */
		if(lp &gt;= lpe)
			break;
		c = *lp;
		if(c &gt;= Runeself) {
			lp += chartorune(&amp;r, (char*)lp);
			c = r;
		} else
			lp++;

		/*
		 * do the various mappings.
		 * the common case is handled
		 * completely by the table.
		 */
		if(c != 0 &amp;&amp; c &lt; Runeself) {
			c = f-&gt;mapto[c];
			if(c) {
				*kp++ = c;
				cl++;
			}
			continue;
		}

		/*
		 * for characters out of range,
		 * the table does not do Rflag.
		 * ignore is based on mapto[nelem(f-&gt;mapto)-1]
		 */
		if(c != 0 &amp;&amp; c &lt; nelem(f-&gt;mapto)) {
			c = f-&gt;mapto[c];
			if(c == 0)
				continue;
		} else {
			if(f-&gt;mapto[nelem(f-&gt;mapto)-1] == 0)
				continue;
			/*
			 * consider building maps as necessary
			 */
			if(f-&gt;flags &amp; Fflag)
				c = tolowerrune(tobaserune(c));
			if(f-&gt;flags &amp; Dflag &amp;&amp; !isalpharune(c) &amp;&amp;
			    !isdigitrune(c) &amp;&amp; !isspacerune(c))
				continue;
			if((f-&gt;flags &amp; Wflag) &amp;&amp; isspacerune(c))
				continue;
		}

		/*
		 * put it in the key
		 */
		r = c;
		n = runetochar((char*)kp, &amp;r);
		kp += n;
		cl += n;
		if(rflag)
			while(n &gt; 0) {
				kp[-n] = ~kp[-n];
				n--;
			}
	}

	/*
	 * end of key
	 */
	k-&gt;klen = cl+1;
	if(rflag) {
		*kp = ~0;
		return;
	}
	*kp = 0;
}

void
dokey_r(Key *k, uchar *lp, uchar *lpe, Field*)
{
	int cl, n;
	uchar *kp;

	n = lpe - lp;
	if(n &lt; 0)
		n = 0;
	cl = k-&gt;klen;
	kp = k-&gt;key + cl;
	k-&gt;klen = cl+n+1;

	lpe -= 3;
	while(lp &lt; lpe) {
		kp[0] = ~lp[0];
		kp[1] = ~lp[1];
		kp[2] = ~lp[2];
		kp[3] = ~lp[3];
		kp += 4;
		lp += 4;
	}

	lpe += 3;
	while(lp &lt; lpe)
		*kp++ = ~*lp++;
	*kp = ~0;
}

void
dokey_(Key *k, uchar *lp, uchar *lpe, Field*)
{
	int n, cl;
	uchar *kp;

	n = lpe - lp;
	if(n &lt; 0)
		n = 0;
	cl = k-&gt;klen;
	kp = k-&gt;key + cl;
	k-&gt;klen = cl+n+1;
	memmove(kp, lp, n);
	kp[n] = 0;
}

void
buildkey(Line *l)
{
	Key *k;
	uchar *lp, *lpe;
	int ll, kl, cl, i, n;
	Field *f;

	ll = l-&gt;llen - 1;
	kl = 0;			/* allocated length */
	cl = 0;			/* current length */
	k = 0;

	for(i=1; i&lt;=args.nfield; i++) {
		f = &amp;args.field[i];
		lp = skip(l-&gt;line, f-&gt;beg1, f-&gt;beg2, f-&gt;flags&amp;B1flag, 0);
		if(lp == 0)
			lp = l-&gt;line + ll;
		lpe = skip(l-&gt;line, f-&gt;end1, f-&gt;end2, f-&gt;flags&amp;Bflag, 1);
		if(lpe == 0)
			lpe = l-&gt;line + ll;
		n = (lpe - lp) + 1;
		if(n &lt;= 0)
			n = 1;
		if(cl+(n+4) &gt; kl) {
			kl = cl+(n+4);
			k = realloc(k, sizeof(Key) +
				(kl-1)*sizeof(k-&gt;key[0]));
			if(k == 0)
				nomem();
		}
		k-&gt;klen = cl;
		(*f-&gt;dokey)(k, lp, lpe, f);
		cl = k-&gt;klen;
	}

	/*
	 * global comparisons
	 */
	if(!(args.uflag &amp;&amp; cl &gt; 0)) {
		f = &amp;args.field[0];
		if(cl+(ll+4) &gt; kl) {
			kl = cl+(ll+4);
			k = realloc(k, sizeof(Key) +
				(kl-1)*sizeof(k-&gt;key[0]));
			if(k == 0)
				nomem();
		}
		k-&gt;klen = cl;
		(*f-&gt;dokey)(k, l-&gt;line, l-&gt;line+ll, f);
		cl = k-&gt;klen;
	}

	l-&gt;key = k;
	k-&gt;klen = cl;

	if(args.vflag) {
		if(write(2, l-&gt;line, l-&gt;llen) != l-&gt;llen)
			exits("write");
		for(i=0; i&lt;k-&gt;klen; i++) {
			fprint(2, " %.2x", k-&gt;key[i]);
			if(k-&gt;key[i] == 0x00 || k-&gt;key[i] == 0xff)
				fprint(2, "\n");
		}
	}
}

void
makemapm(Field *f)
{
	int i, c;

	for(i=0; i&lt;nelem(f-&gt;mapto); i++) {
		c = 1;
		if(i == ' ' || i == '\t')
			c = 0;
		if(i &gt;= 'a' &amp;&amp; i &lt;= 'z')
			c = i + ('A' - 'a');
		if(i &gt;= 'A' &amp;&amp; i &lt;= 'Z')
			c = i;
		f-&gt;mapto[i] = c;
		if(args.vflag) {
			if((i &amp; 15) == 0)
				fprint(2, "	");
			fprint(2, " %.2x", c);
			if((i &amp; 15) == 15)
				fprint(2, "\n");
		}
	}
}

void
makemapd(Field *f)
{
	int i, c;

	for(i=0; i&lt;nelem(f-&gt;mapto); i++) {
		c = i;
		if(f-&gt;flags &amp; Iflag)
			if(c &lt; 040 || c &gt; 0176)
				c = -1;
		if((f-&gt;flags &amp; Wflag) &amp;&amp; c &gt;= 0)
			if(c == ' ' || c == '\t')
				c = -1;
		if((f-&gt;flags &amp; Dflag) &amp;&amp; c &gt;= 0)
			if(!(c == ' ' || c == '\t' ||
			    (c &gt;= 'a' &amp;&amp; c &lt;= 'z') ||
			    (c &gt;= 'A' &amp;&amp; c &lt;= 'Z') ||
			    (c &gt;= '0' &amp;&amp; c &lt;= '9'))){
				if(!isupperrune(c = toupperrune(c)))
					c = -1;
			}
		if((f-&gt;flags &amp; Fflag) &amp;&amp; c &gt;= 0)
			c = toupperrune(tobaserune(c));
		if((f-&gt;flags &amp; Rflag) &amp;&amp; c &gt;= 0 &amp;&amp; i &gt; 0 &amp;&amp; i &lt; Runeself)
			c = ~c &amp; 0xff;
		if(c &lt; 0)
			c = 0;
		f-&gt;mapto[i] = c;
		if(args.vflag) {
			if((i &amp; 15) == 0)
				fprint(2, "	");
			fprint(2, " %.2x", c);
			if((i &amp; 15) == 15)
				fprint(2, "\n");
		}
	}
}

Rune*	month[12] =
{
	L"JAN",
	L"FEB",
	L"MAR",
	L"APR",
	L"MAY",
	L"JUN",
	L"JUL",
	L"AUG",
	L"SEP",
	L"OCT",
	L"NOV",
	L"DEC",
};

/************** radix sort ***********/

enum
{
	Threshold	= 14,
};

void	rsort4(Key***, ulong, int);
void	bsort4(Key***, ulong, int);

void
sort4(void *a, ulong n)
{
	if(n &gt; Threshold)
		rsort4((Key***)a, n, 0);
	else
		bsort4((Key***)a, n, 0);
}

void
rsort4(Key ***a, ulong n, int b)
{
	Key ***ea, ***t, ***u, **t1, **u1, *k;
	Key ***part[257];
	static long count[257];
	long clist[257+257], *cp, *cp1;
	int c, lowc, higc;

	/*
	 * pass 1 over all keys,
	 * count the number of each key[b].
	 * find low count and high count.
	 */
	lowc = 256;
	higc = 0;
	ea = a+n;
	for(t=a; t&lt;ea; t++) {
		k = **t;
		n = k-&gt;klen;
		if(b &gt;= n) {
			count[256]++;
			continue;
		}
		c = k-&gt;key[b];
		n = count[c]++;
		if(n == 0) {
			if(c &lt; lowc)
				lowc = c;
			if(c &gt; higc)
				higc = c;
		}
	}

	/*
	 * pass 2 over all counts,
	 * put partition pointers in part[c].
	 * save compacted indexes and counts
	 * in clist[].
	 */
	t = a;
	n = count[256];
	clist[0] = n;
	part[256] = t;
	t += n;

	cp1 = clist+1;
	cp = count+lowc;
	for(c=lowc; c&lt;=higc; c++,cp++) {
		n = *cp;
		if(n) {
			cp1[0] = n;
			cp1[1] = c;
			cp1 += 2;
			part[c] = t;
			t += n;
		}
	}
	*cp1 = 0;

	/*
	 * pass 3 over all counts.
	 * chase lowest pointer in each partition
	 * around a permutation until it comes
	 * back and is stored where it started.
	 * static array, count[], should be
	 * reduced to zero entries except maybe
	 * count[256].
	 */
	for(cp1=clist+1; cp1[0]; cp1+=2) {
		c = cp1[1];
		cp = count+c;
		while(*cp) {
			t1 = *part[c];
			for(;;) {
				k = *t1;
				n = 256;
				if(b &lt; k-&gt;klen)
					n = k-&gt;key[b];
				u = part[n]++;
				count[n]--;
				u1 = *u;
				*u = t1;
				if(n == c)
					break;
				t1 = u1;
			}
		}
	}

	/*
	 * pass 4 over all partitions.
	 * call recursively.
	 */
	b++;
	t = a + clist[0];
	count[256] = 0;
	for(cp1=clist+1; n=cp1[0]; cp1+=2) {
		if(n &gt; Threshold)
			rsort4(t, n, b);
		else
		if(n &gt; 1)
			bsort4(t, n, b);
		t += n;
	}
}

/*
 * bubble sort to pick up
 * the pieces.
 */
void
bsort4(Key ***a, ulong n, int b)
{
	Key ***i, ***j, ***k, ***l, **t;
	Key *ka, *kb;
	int n1, n2;

	l = a+n;
	j = a;

loop:
	i = j;
	j++;
	if(j &gt;= l)
		return;

	ka = **i;
	kb = **j;
	n1 = ka-&gt;klen - b;
	n2 = kb-&gt;klen - b;
	if(n1 &gt; n2)
		n1 = n2;
	if(n1 &lt;= 0)
		goto loop;
	n2 = ka-&gt;key[b] - kb-&gt;key[b];
	if(n2 == 0)
		n2 = memcmp(ka-&gt;key+b, kb-&gt;key+b, n1);
	if(n2 &lt;= 0)
		goto loop;

	for(;;) {
		k = i+1;

		t = *k;
		*k = *i;
		*i = t;

		if(i &lt;= a)
			goto loop;

		i--;
		ka = **i;
		kb = *t;
		n1 = ka-&gt;klen - b;
		n2 = kb-&gt;klen - b;
		if(n1 &gt; n2)
			n1 = n2;
		if(n1 &lt;= 0)
			goto loop;
		n2 = ka-&gt;key[b] - kb-&gt;key[b];
		if(n2 == 0)
			n2 = memcmp(ka-&gt;key+b, kb-&gt;key+b, n1);
		if(n2 &lt;= 0)
			goto loop;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

