<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/dstep.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/dstep.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: dstep.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

#define MAXDSTEP	2048	/* was 512 */

char	*NextLab[64];
int	Level=0, GenCode=0, IsGuard=0, TestOnly=0;

static int	Tj=0, Jt=0, LastGoto=0;
static int	Tojump[MAXDSTEP], Jumpto[MAXDSTEP], Special[MAXDSTEP];
static void	putCode(FILE *, Element *, Element *, Element *, int);

extern int	Pid, separate, OkBreak;

static void
Sourced(int n, int special)
{	int i;
	for (i = 0; i &lt; Tj; i++)
		if (Tojump[i] == n)
			return;
	if (Tj &gt;= MAXDSTEP)
		fatal("d_step sequence too long", (char *)0);
	Special[Tj] = special;
	Tojump[Tj++] = n;
}

static void
Dested(int n)
{	int i;
	for (i = 0; i &lt; Tj; i++)
		if (Tojump[i] == n)
			return;
	for (i = 0; i &lt; Jt; i++)
		if (Jumpto[i] == n)
			return;
	if (Jt &gt;= MAXDSTEP)
		fatal("d_step sequence too long", (char *)0);
	Jumpto[Jt++] = n;
	LastGoto = 1;
}

static void
Mopup(FILE *fd)
{	int i, j;

	for (i = 0; i &lt; Jt; i++)
	{	for (j = 0; j &lt; Tj; j++)
			if (Tojump[j] == Jumpto[i])
				break;
		if (j == Tj)
		{	char buf[16];
			if (Jumpto[i] == OkBreak)
			{	if (!LastGoto)
				fprintf(fd, "S_%.3d_0:	/* break-dest */\n",
					OkBreak);
			} else {
				sprintf(buf, "S_%.3d_0", Jumpto[i]);
				non_fatal("goto %s breaks from d_step seq", buf);
	}	}	}
	for (j = 0; j &lt; Tj; j++)
	{	for (i = 0; i &lt; Jt; i++)
			if (Tojump[j] == Jumpto[i])
				break;
#ifdef DEBUG
		if (i == Jt &amp;&amp; !Special[i])
			fprintf(fd, "\t\t/* no goto's to S_%.3d_0 */\n",
			Tojump[j]);
#endif
	}
	for (j = i = 0; j &lt; Tj; j++)
		if (Special[j])
		{	Tojump[i] = Tojump[j];
			Special[i] = 2;
			if (i &gt;= MAXDSTEP)
			fatal("cannot happen (dstep.c)", (char *)0);
			i++;
		}
	Tj = i;	/* keep only the global exit-labels */
	Jt = 0;
}

static int
FirstTime(int n)
{	int i;
	for (i = 0; i &lt; Tj; i++)
		if (Tojump[i] == n)
			return (Special[i] &lt;= 1);
	return 1;
}

static void
illegal(Element *e, char *str)
{
	printf("illegal operator in 'd_step:' '");
	comment(stdout, e-&gt;n, 0);
	printf("'\n");
	fatal("'%s'", str);
}

static void
filterbad(Element *e)
{
	switch (e-&gt;n-&gt;ntyp) {
	case ASSERT:
	case PRINT:
	case 'c':
		/* run cannot be completely undone
		 * with sv_save-sv_restor
		 */
		if (any_oper(e-&gt;n-&gt;lft, RUN))
			illegal(e, "run operator in d_step");

		/* remote refs inside d_step sequences
		 * would be okay, but they cannot always
		 * be interpreted by the simulator the
		 * same as by the verifier (e.g., for an
		 * error trail)
		 */
		if (any_oper(e-&gt;n-&gt;lft, 'p'))
			illegal(e, "remote reference in d_step");
		break;
	case '@':
		illegal(e, "process termination");
		break;
	case D_STEP:
		illegal(e, "nested d_step sequence");
		break;
	case ATOMIC:
		illegal(e, "nested atomic sequence");
		break;
	default:
		break;
	}
}

static int
CollectGuards(FILE *fd, Element *e, int inh)
{	SeqList *h; Element *ee;

	for (h = e-&gt;sub; h; h = h-&gt;nxt)
	{	ee = huntstart(h-&gt;this-&gt;frst);
		filterbad(ee);
		switch (ee-&gt;n-&gt;ntyp) {
		case NON_ATOMIC:
			inh += CollectGuards(fd, ee-&gt;n-&gt;sl-&gt;this-&gt;frst, inh);
			break;
		case  IF:
			inh += CollectGuards(fd, ee, inh);
			break;
		case '.':
			if (ee-&gt;nxt-&gt;n-&gt;ntyp == DO)
				inh += CollectGuards(fd, ee-&gt;nxt, inh);
			break;
		case ELSE:
			if (inh++ &gt; 0) fprintf(fd, " || ");
/* 4.2.5 */		if (!pid_is_claim(Pid))
				fprintf(fd, "(boq == -1 /* else */)");
			else
				fprintf(fd, "(1 /* else */)");
			break;
		case 'R':
			if (inh++ &gt; 0) fprintf(fd, " || ");
			fprintf(fd, "("); TestOnly=1;
			putstmnt(fd, ee-&gt;n, ee-&gt;seqno);
			fprintf(fd, ")"); TestOnly=0;
			break;
		case 'r':
			if (inh++ &gt; 0) fprintf(fd, " || ");
			fprintf(fd, "("); TestOnly=1;
			putstmnt(fd, ee-&gt;n, ee-&gt;seqno);
			fprintf(fd, ")"); TestOnly=0;
			break;
		case 's':
			if (inh++ &gt; 0) fprintf(fd, " || ");
			fprintf(fd, "("); TestOnly=1;
/* 4.2.1 */		if (!pid_is_claim(Pid)) fprintf(fd, "(boq == -1) &amp;&amp; ");
			putstmnt(fd, ee-&gt;n, ee-&gt;seqno);
			fprintf(fd, ")"); TestOnly=0;
			break;
		case 'c':
			if (inh++ &gt; 0) fprintf(fd, " || ");
			fprintf(fd, "("); TestOnly=1;
			if (!pid_is_claim(Pid))
				fprintf(fd, "(boq == -1 &amp;&amp; ");
			putstmnt(fd, ee-&gt;n-&gt;lft, e-&gt;seqno);
			if (!pid_is_claim(Pid))
				fprintf(fd, ")");
			fprintf(fd, ")"); TestOnly=0;
			break;
	}	}
	return inh;
}

int
putcode(FILE *fd, Sequence *s, Element *nxt, int justguards, int ln, int seqno)
{	int isg=0; char buf[64];

	NextLab[0] = "continue";
	filterbad(s-&gt;frst);

	switch (s-&gt;frst-&gt;n-&gt;ntyp) {
	case UNLESS:
		non_fatal("'unless' inside d_step - ignored", (char *) 0);
		return putcode(fd, s-&gt;frst-&gt;n-&gt;sl-&gt;this, nxt, 0, ln, seqno);
	case NON_ATOMIC:
		(void) putcode(fd, s-&gt;frst-&gt;n-&gt;sl-&gt;this, ZE, 1, ln, seqno);
		break;
	case IF:
		fprintf(fd, "if (!(");
		if (!CollectGuards(fd, s-&gt;frst, 0))	/* what about boq? */
			fprintf(fd, "1");
		fprintf(fd, "))\n\t\t\tcontinue;");
		isg = 1;
		break;
	case '.':
		if (s-&gt;frst-&gt;nxt-&gt;n-&gt;ntyp == DO)
		{	fprintf(fd, "if (!(");
			if (!CollectGuards(fd, s-&gt;frst-&gt;nxt, 0))
				fprintf(fd, "1");
			fprintf(fd, "))\n\t\t\tcontinue;");
			isg = 1;
		}
		break;
	case 'R': /* &lt;- can't really happen (it's part of a 'c') */
		fprintf(fd, "if (!("); TestOnly=1;
		putstmnt(fd, s-&gt;frst-&gt;n, s-&gt;frst-&gt;seqno);
		fprintf(fd, "))\n\t\t\tcontinue;"); TestOnly=0;
		break;
	case 'r':
		fprintf(fd, "if (!("); TestOnly=1;
		putstmnt(fd, s-&gt;frst-&gt;n, s-&gt;frst-&gt;seqno);
		fprintf(fd, "))\n\t\t\tcontinue;"); TestOnly=0;
		break;
	case 's':
		fprintf(fd, "if (");
#if 1
/* 4.2.1 */	if (!pid_is_claim(Pid)) fprintf(fd, "(boq != -1) || ");
#endif
		fprintf(fd, "!("); TestOnly=1;
		putstmnt(fd, s-&gt;frst-&gt;n, s-&gt;frst-&gt;seqno);
		fprintf(fd, "))\n\t\t\tcontinue;"); TestOnly=0;
		break;
	case 'c':
		fprintf(fd, "if (!(");
		if (!pid_is_claim(Pid)) fprintf(fd, "boq == -1 &amp;&amp; ");
		TestOnly=1;
		putstmnt(fd, s-&gt;frst-&gt;n-&gt;lft, s-&gt;frst-&gt;seqno);
		fprintf(fd, "))\n\t\t\tcontinue;"); TestOnly=0;
		break;
	case ELSE:
		fprintf(fd, "if (boq != -1 || (");
		if (separate != 2) fprintf(fd, "trpt-&gt;");
		fprintf(fd, "o_pm&amp;1))\n\t\t\tcontinue;");
		break;
	case ASGN:	/* new 3.0.8 */
		fprintf(fd, "IfNotBlocked");
		break;
	}
	if (justguards) return 0;

	fprintf(fd, "\n\t\tsv_save();\n\t\t");
#if 1
	fprintf(fd, "reached[%d][%d] = 1;\n\t\t", Pid, seqno);
	fprintf(fd, "reached[%d][t-&gt;st] = 1;\n\t\t", Pid);	/* true next state */
	fprintf(fd, "reached[%d][tt] = 1;\n", Pid);		/* true current state */
#endif
	sprintf(buf, "Uerror(\"block in d_step seq, line %d\")", ln);
	NextLab[0] = buf;
	putCode(fd, s-&gt;frst, s-&gt;extent, nxt, isg);

	if (nxt)
	{	extern Symbol *Fname;
		extern int lineno;

		if (FirstTime(nxt-&gt;Seqno)
		&amp;&amp; (!(nxt-&gt;status &amp; DONE2) || !(nxt-&gt;status &amp; D_ATOM)))
		{	fprintf(fd, "S_%.3d_0: /* 1 */\n", nxt-&gt;Seqno);
			nxt-&gt;status |= DONE2;
			LastGoto = 0;
		}
		Sourced(nxt-&gt;Seqno, 1);
		lineno = ln;
		Fname = nxt-&gt;n-&gt;fn;	
		Mopup(fd);
	}
	unskip(s-&gt;frst-&gt;seqno);
	return LastGoto;
}

static void
putCode(FILE *fd, Element *f, Element *last, Element *next, int isguard)
{	Element *e, *N;
	SeqList *h; int i;
	char NextOpt[64];
	static int bno = 0;

	for (e = f; e; e = e-&gt;nxt)
	{	if (e-&gt;status &amp; DONE2)
			continue;
		e-&gt;status |= DONE2;

		if (!(e-&gt;status &amp; D_ATOM))
		{	if (!LastGoto)
			{	fprintf(fd, "\t\tgoto S_%.3d_0;\n",
					e-&gt;Seqno);
				Dested(e-&gt;Seqno);
			}
			break;
		}
		fprintf(fd, "S_%.3d_0: /* 2 */\n", e-&gt;Seqno);
		LastGoto = 0;
		Sourced(e-&gt;Seqno, 0);

		if (!e-&gt;sub)
		{	filterbad(e);
			switch (e-&gt;n-&gt;ntyp) {
			case NON_ATOMIC:
				h = e-&gt;n-&gt;sl;
				putCode(fd, h-&gt;this-&gt;frst,
					h-&gt;this-&gt;extent, e-&gt;nxt, 0);
				break;
			case BREAK:
				if (LastGoto) break;
				if (e-&gt;nxt)
				{	i = target( huntele(e-&gt;nxt,
						e-&gt;status, -1))-&gt;Seqno;
					fprintf(fd, "\t\tgoto S_%.3d_0;	", i);
					fprintf(fd, "/* 'break' */\n");
					Dested(i);
				} else
				{	if (next)
					{	fprintf(fd, "\t\tgoto S_%.3d_0;",
							next-&gt;Seqno);
						fprintf(fd, " /* NEXT */\n");
						Dested(next-&gt;Seqno);
					} else
					fatal("cannot interpret d_step", 0);
				}
				break;
			case GOTO:
				if (LastGoto) break;
				i = huntele( get_lab(e-&gt;n,1),
					e-&gt;status, -1)-&gt;Seqno;
				fprintf(fd, "\t\tgoto S_%.3d_0;	", i);
				fprintf(fd, "/* 'goto' */\n");
				Dested(i);
				break;
			case '.':
				if (LastGoto) break;
				if (e-&gt;nxt &amp;&amp; (e-&gt;nxt-&gt;status &amp; DONE2))
				{	i = e-&gt;nxt?e-&gt;nxt-&gt;Seqno:0;
					fprintf(fd, "\t\tgoto S_%.3d_0;", i);
					fprintf(fd, " /* '.' */\n");
					Dested(i);
				}
				break;
			default:
				putskip(e-&gt;seqno);
				GenCode = 1; IsGuard = isguard;
				fprintf(fd, "\t\t");
				putstmnt(fd, e-&gt;n, e-&gt;seqno);
				fprintf(fd, ";\n");
				GenCode = IsGuard = isguard = LastGoto = 0;
				break;
			}
			i = e-&gt;nxt?e-&gt;nxt-&gt;Seqno:0;
			if (e-&gt;nxt &amp;&amp; e-&gt;nxt-&gt;status &amp; DONE2 &amp;&amp; !LastGoto)
			{	fprintf(fd, "\t\tgoto S_%.3d_0; ", i);
				fprintf(fd, "/* ';' */\n");
				Dested(i);
				break;
			}
		} else
		{	for (h = e-&gt;sub, i=1; h; h = h-&gt;nxt, i++)
			{	sprintf(NextOpt, "goto S_%.3d_%d",
					e-&gt;Seqno, i);
				NextLab[++Level] = NextOpt;
				N = (e-&gt;n &amp;&amp; e-&gt;n-&gt;ntyp == DO) ? e : e-&gt;nxt;
				putCode(fd, h-&gt;this-&gt;frst,
					h-&gt;this-&gt;extent, N, 1);
				Level--;
				fprintf(fd, "%s: /* 3 */\n", &amp;NextOpt[5]);
				LastGoto = 0;
			}
			if (!LastGoto)
			{	fprintf(fd, "\t\tUerror(\"blocking sel ");
				fprintf(fd, "in d_step (nr.%d, near line %d)\");\n",
				bno++, (e-&gt;n)?e-&gt;n-&gt;ln:0);
				LastGoto = 0;
			}
		}
		if (e == last)
		{	if (!LastGoto &amp;&amp; next)
			{	fprintf(fd, "\t\tgoto S_%.3d_0;\n",
					next-&gt;Seqno);
				Dested(next-&gt;Seqno);
			}
			break;
	}	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

