<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/flow.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/flow.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: flow.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

extern Symbol	*Fname;
extern int	nr_errs, lineno, verbose, in_for;
extern short	has_unless, has_badelse, has_xu;
extern char CurScope[MAXSCOPESZ];

Element *Al_El = ZE;
Label	*labtab = (Label *) 0;
int	Unique = 0, Elcnt = 0, DstepStart = -1;
int	initialization_ok = 1;

static Lbreak	*breakstack = (Lbreak *) 0;
static Lextok	*innermost;
static SeqList	*cur_s = (SeqList *) 0;
static int	break_id=0;

static Element	*if_seq(Lextok *);
static Element	*new_el(Lextok *);
static Element	*unless_seq(Lextok *);
static void	add_el(Element *, Sequence *);
static void	attach_escape(Sequence *, Sequence *);
static void	mov_lab(Symbol *, Element *, Element *);
static void	walk_atomic(Element *, Element *, int);

void
open_seq(int top)
{	SeqList *t;
	Sequence *s = (Sequence *) emalloc(sizeof(Sequence));

	t = seqlist(s, cur_s);
	cur_s = t;
	if (top)
	{	Elcnt = 1;
		initialization_ok = 1;
	}
}

void
rem_Seq(void)
{
	DstepStart = Unique;
}

void
unrem_Seq(void)
{
	DstepStart = -1;
}

static int
Rjumpslocal(Element *q, Element *stop)
{	Element *lb, *f;
	SeqList *h;

	/* allow no jumps out of a d_step sequence */
	for (f = q; f &amp;&amp; f != stop; f = f-&gt;nxt)
	{	if (f &amp;&amp; f-&gt;n &amp;&amp; f-&gt;n-&gt;ntyp == GOTO)
		{	lb = get_lab(f-&gt;n, 0);
			if (!lb || lb-&gt;Seqno &lt; DstepStart)
			{	lineno = f-&gt;n-&gt;ln;
				Fname = f-&gt;n-&gt;fn;
				return 0;
		}	}
		for (h = f-&gt;sub; h; h = h-&gt;nxt)
		{	if (!Rjumpslocal(h-&gt;this-&gt;frst, h-&gt;this-&gt;last))
				return 0;
	
	}	}
	return 1;
}

void
cross_dsteps(Lextok *a, Lextok *b)
{
	if (a &amp;&amp; b
	&amp;&amp;  a-&gt;indstep != b-&gt;indstep)
	{	lineno = a-&gt;ln;
		Fname  = a-&gt;fn;
		fatal("jump into d_step sequence", (char *) 0);
	}
}

int
is_skip(Lextok *n)
{
	return (n-&gt;ntyp == PRINT
	||	n-&gt;ntyp == PRINTM
	||	(n-&gt;ntyp == 'c'
		&amp;&amp; n-&gt;lft
		&amp;&amp; n-&gt;lft-&gt;ntyp == CONST
		&amp;&amp; n-&gt;lft-&gt;val  == 1));
}

void
check_sequence(Sequence *s)
{	Element *e, *le = ZE;
	Lextok *n;
	int cnt = 0;

	for (e = s-&gt;frst; e; le = e, e = e-&gt;nxt)
	{	n = e-&gt;n;
		if (is_skip(n) &amp;&amp; !has_lab(e, 0))
		{	cnt++;
			if (cnt &gt; 1
			&amp;&amp;  n-&gt;ntyp != PRINT
			&amp;&amp;  n-&gt;ntyp != PRINTM)
			{	if (verbose&amp;32)
					printf("spin: %s:%d, redundant skip\n",
						n-&gt;fn-&gt;name, n-&gt;ln);
				if (e != s-&gt;frst
				&amp;&amp;  e != s-&gt;last
				&amp;&amp;  e != s-&gt;extent)
				{	e-&gt;status |= DONE;	/* not unreachable */
					le-&gt;nxt = e-&gt;nxt;	/* remove it */
					e = le;
				}
			}
		} else
			cnt = 0;
	}
}

void
prune_opts(Lextok *n)
{	SeqList *l;
	extern Symbol *context;
	extern char *claimproc;

	if (!n
	|| (context &amp;&amp; claimproc &amp;&amp; strcmp(context-&gt;name, claimproc) == 0))
		return;

	for (l = n-&gt;sl; l; l = l-&gt;nxt)	/* find sequences of unlabeled skips */
		check_sequence(l-&gt;this);
}

Sequence *
close_seq(int nottop)
{	Sequence *s = cur_s-&gt;this;
	Symbol *z;

	if (nottop == 0)	/* end of proctype body */
	{	initialization_ok = 1;
	}

	if (nottop &gt; 0 &amp;&amp; (z = has_lab(s-&gt;frst, 0)))
	{	printf("error: (%s:%d) label %s placed incorrectly\n",
			(s-&gt;frst-&gt;n)?s-&gt;frst-&gt;n-&gt;fn-&gt;name:"-",
			(s-&gt;frst-&gt;n)?s-&gt;frst-&gt;n-&gt;ln:0,
			z-&gt;name);
		switch (nottop) {
		case 1:
			printf("=====&gt; stmnt unless Label: stmnt\n");
			printf("sorry, cannot jump to the guard of an\n");
			printf("escape (it is not a unique state)\n");
			break;
		case 2:
			printf("=====&gt; instead of  ");
			printf("\"Label: stmnt unless stmnt\"\n");
			printf("=====&gt; always use  ");
			printf("\"Label: { stmnt unless stmnt }\"\n");
			break;
		case 3:
			printf("=====&gt; instead of  ");
			printf("\"atomic { Label: statement ... }\"\n");
			printf("=====&gt; always use  ");
			printf("\"Label: atomic { statement ... }\"\n");
			break;
		case 4:
			printf("=====&gt; instead of  ");
			printf("\"d_step { Label: statement ... }\"\n");
			printf("=====&gt; always use  ");
			printf("\"Label: d_step { statement ... }\"\n");
			break;
		case 5:
			printf("=====&gt; instead of  ");
			printf("\"{ Label: statement ... }\"\n");
			printf("=====&gt; always use  ");
			printf("\"Label: { statement ... }\"\n");
			break;
		case 6:
			printf("=====&gt;instead of\n");
			printf("	do (or if)\n");
			printf("	:: ...\n");
			printf("	:: Label: statement\n");
			printf("	od (of fi)\n");
			printf("=====&gt;always use\n");
			printf("Label:	do (or if)\n");
			printf("	:: ...\n");
			printf("	:: statement\n");
			printf("	od (or fi)\n");
			break;
		case 7:
			printf("cannot happen - labels\n");
			break;
		}
		alldone(1);
	}

	if (nottop == 4
	&amp;&amp; !Rjumpslocal(s-&gt;frst, s-&gt;last))
		fatal("non_local jump in d_step sequence", (char *) 0);

	cur_s = cur_s-&gt;nxt;
	s-&gt;maxel = Elcnt;
	s-&gt;extent = s-&gt;last;
	if (!s-&gt;last)
		fatal("sequence must have at least one statement", (char *) 0);
	return s;
}

Lextok *
do_unless(Lextok *No, Lextok *Es)
{	SeqList *Sl;
	Lextok *Re = nn(ZN, UNLESS, ZN, ZN);
	Re-&gt;ln = No-&gt;ln;
	Re-&gt;fn = No-&gt;fn;

	has_unless++;
	if (Es-&gt;ntyp == NON_ATOMIC)
		Sl = Es-&gt;sl;
	else
	{	open_seq(0); add_seq(Es);
		Sl = seqlist(close_seq(1), 0);
	}

	if (No-&gt;ntyp == NON_ATOMIC)
	{	No-&gt;sl-&gt;nxt = Sl;
		Sl = No-&gt;sl;
	} else	if (No-&gt;ntyp == ':'
		&amp;&amp; (No-&gt;lft-&gt;ntyp == NON_ATOMIC
		||  No-&gt;lft-&gt;ntyp == ATOMIC
		||  No-&gt;lft-&gt;ntyp == D_STEP))
	{
		int tok = No-&gt;lft-&gt;ntyp;

		No-&gt;lft-&gt;sl-&gt;nxt = Sl;
		Re-&gt;sl = No-&gt;lft-&gt;sl;

		open_seq(0); add_seq(Re);
		Re = nn(ZN, tok, ZN, ZN);
		Re-&gt;sl = seqlist(close_seq(7), 0);
		Re-&gt;ln = No-&gt;ln;
		Re-&gt;fn = No-&gt;fn;

		Re = nn(No, ':', Re, ZN);	/* lift label */
		Re-&gt;ln = No-&gt;ln;
		Re-&gt;fn = No-&gt;fn;
		return Re;
	} else
	{	open_seq(0); add_seq(No);
		Sl = seqlist(close_seq(2), Sl);
	}

	Re-&gt;sl = Sl;
	return Re;
}

SeqList *
seqlist(Sequence *s, SeqList *r)
{	SeqList *t = (SeqList *) emalloc(sizeof(SeqList));

	t-&gt;this = s;
	t-&gt;nxt = r;
	return t;
}

static Element *
new_el(Lextok *n)
{	Element *m;

	if (n)
	{	if (n-&gt;ntyp == IF || n-&gt;ntyp == DO)
			return if_seq(n);
		if (n-&gt;ntyp == UNLESS)
			return unless_seq(n);
	}
	m = (Element *) emalloc(sizeof(Element));
	m-&gt;n = n;
	m-&gt;seqno = Elcnt++;
	m-&gt;Seqno = Unique++;
	m-&gt;Nxt = Al_El; Al_El = m;
	return m;
}

static int
has_chanref(Lextok *n)
{
	if (!n) return 0;

	switch (n-&gt;ntyp) {
	case 's':	case 'r':
#if 0
	case 'R':	case LEN:
#endif
	case FULL:	case NFULL:
	case EMPTY:	case NEMPTY:
		return 1;
	default:
		break;
	}
	if (has_chanref(n-&gt;lft))
		return 1;

	return has_chanref(n-&gt;rgt);
}

void
loose_ends(void)	/* properly tie-up ends of sub-sequences */
{	Element *e, *f;

	for (e = Al_El; e; e = e-&gt;Nxt)
	{	if (!e-&gt;n
		||  !e-&gt;nxt)
			continue;
		switch (e-&gt;n-&gt;ntyp) {
		case ATOMIC:
		case NON_ATOMIC:
		case D_STEP:
			f = e-&gt;nxt;
			while (f &amp;&amp; f-&gt;n-&gt;ntyp == '.')
				f = f-&gt;nxt;
			if (0) printf("link %d, {%d .. %d} -&gt; %d (ntyp=%d) was %d\n",
				e-&gt;seqno,
				e-&gt;n-&gt;sl-&gt;this-&gt;frst-&gt;seqno,
				e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;seqno,
				f?f-&gt;seqno:-1, f?f-&gt;n-&gt;ntyp:-1,
				e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt?e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt-&gt;seqno:-1);
			if (!e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt)
				e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt = f;
			else
			{	if (e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt-&gt;n-&gt;ntyp != GOTO)
				{	if (!f || e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt-&gt;seqno != f-&gt;seqno)
					non_fatal("unexpected: loose ends", (char *)0);
				} else
					e-&gt;n-&gt;sl-&gt;this-&gt;last = e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt;
				/*
				 * fix_dest can push a goto into the nxt position
				 * in that case the goto wins and f is not needed
				 * but the last fields needs adjusting
				 */
			}
			break;
	}	}
}

static Element *
if_seq(Lextok *n)
{	int	tok = n-&gt;ntyp;
	SeqList	*s  = n-&gt;sl;
	Element	*e  = new_el(ZN);
	Element	*t  = new_el(nn(ZN,'.',ZN,ZN)); /* target */
	SeqList	*z, *prev_z = (SeqList *) 0;
	SeqList *move_else  = (SeqList *) 0;	/* to end of optionlist */
	int	ref_chans = 0;

	for (z = s; z; z = z-&gt;nxt)
	{	if (!z-&gt;this-&gt;frst)
			continue;
		if (z-&gt;this-&gt;frst-&gt;n-&gt;ntyp == ELSE)
		{	if (move_else)
				fatal("duplicate `else'", (char *) 0);
			if (z-&gt;nxt)	/* is not already at the end */
			{	move_else = z;
				if (prev_z)
					prev_z-&gt;nxt = z-&gt;nxt;
				else
					s = n-&gt;sl = z-&gt;nxt;
				continue;
			}
		} else
			ref_chans |= has_chanref(z-&gt;this-&gt;frst-&gt;n);
		prev_z = z;
	}
	if (move_else)
	{	move_else-&gt;nxt = (SeqList *) 0;
		/* if there is no prev, then else was at the end */
		if (!prev_z) fatal("cannot happen - if_seq", (char *) 0);
		prev_z-&gt;nxt = move_else;
		prev_z = move_else;
	}
	if (prev_z
	&amp;&amp;  ref_chans
	&amp;&amp;  prev_z-&gt;this-&gt;frst-&gt;n-&gt;ntyp == ELSE)
	{	prev_z-&gt;this-&gt;frst-&gt;n-&gt;val = 1;
		has_badelse++;
		if (has_xu)
		{	fatal("invalid use of 'else' combined with i/o and xr/xs assertions,",
				(char *)0);
		} else
		{	non_fatal("dubious use of 'else' combined with i/o,",
				(char *)0);
		}
		nr_errs--;
	}

	e-&gt;n = nn(n, tok, ZN, ZN);
	e-&gt;n-&gt;sl = s;			/* preserve as info only */
	e-&gt;sub = s;
	for (z = s; z; prev_z = z, z = z-&gt;nxt)
		add_el(t, z-&gt;this);	/* append target */
	if (tok == DO)
	{	add_el(t, cur_s-&gt;this); /* target upfront */
		t = new_el(nn(n, BREAK, ZN, ZN)); /* break target */
		set_lab(break_dest(), t);	/* new exit  */
		breakstack = breakstack-&gt;nxt;	/* pop stack */
	}
	add_el(e, cur_s-&gt;this);
	add_el(t, cur_s-&gt;this);
	return e;			/* destination node for label */
}

static void
escape_el(Element *f, Sequence *e)
{	SeqList *z;

	for (z = f-&gt;esc; z; z = z-&gt;nxt)
		if (z-&gt;this == e)
			return;	/* already there */

	/* cover the lower-level escapes of this state */
	for (z = f-&gt;esc; z; z = z-&gt;nxt)
		attach_escape(z-&gt;this, e);

	/* now attach escape to the state itself */

	f-&gt;esc = seqlist(e, f-&gt;esc);	/* in lifo order... */
#ifdef DEBUG
	printf("attach %d (", e-&gt;frst-&gt;Seqno);
	comment(stdout, e-&gt;frst-&gt;n, 0);
	printf(")	to %d (", f-&gt;Seqno);
	comment(stdout, f-&gt;n, 0);
	printf(")\n");
#endif
	switch (f-&gt;n-&gt;ntyp) {
	case UNLESS:
		attach_escape(f-&gt;sub-&gt;this, e);
		break;
	case IF:
	case DO:
		for (z = f-&gt;sub; z; z = z-&gt;nxt)
			attach_escape(z-&gt;this, e);
		break;
	case D_STEP:
		/* attach only to the guard stmnt */
		escape_el(f-&gt;n-&gt;sl-&gt;this-&gt;frst, e);
		break;
	case ATOMIC:
	case NON_ATOMIC:
		/* attach to all stmnts */
		attach_escape(f-&gt;n-&gt;sl-&gt;this, e);
		break;
	}
}

static void
attach_escape(Sequence *n, Sequence *e)
{	Element *f;

	for (f = n-&gt;frst; f; f = f-&gt;nxt)
	{	escape_el(f, e);
		if (f == n-&gt;extent)
			break;
	}
}

static Element *
unless_seq(Lextok *n)
{	SeqList	*s  = n-&gt;sl;
	Element	*e  = new_el(ZN);
	Element	*t  = new_el(nn(ZN,'.',ZN,ZN)); /* target */
	SeqList	*z;

	e-&gt;n = nn(n, UNLESS, ZN, ZN);
	e-&gt;n-&gt;sl = s;			/* info only */
	e-&gt;sub = s;

	/* need 2 sequences: normal execution and escape */
	if (!s || !s-&gt;nxt || s-&gt;nxt-&gt;nxt)
		fatal("unexpected unless structure", (char *)0);

	/* append the target state to both */
	for (z = s; z; z = z-&gt;nxt)
		add_el(t, z-&gt;this);

	/* attach escapes to all states in normal sequence */
	attach_escape(s-&gt;this, s-&gt;nxt-&gt;this);

	add_el(e, cur_s-&gt;this);
	add_el(t, cur_s-&gt;this);
#ifdef DEBUG
	printf("unless element (%d,%d):\n", e-&gt;Seqno, t-&gt;Seqno);
	for (z = s; z; z = z-&gt;nxt)
	{	Element *x; printf("\t%d,%d,%d :: ",
		z-&gt;this-&gt;frst-&gt;Seqno,
		z-&gt;this-&gt;extent-&gt;Seqno,
		z-&gt;this-&gt;last-&gt;Seqno);
		for (x = z-&gt;this-&gt;frst; x; x = x-&gt;nxt)
			printf("(%d)", x-&gt;Seqno);
		printf("\n");
	}
#endif
	return e;
}

Element *
mk_skip(void)
{	Lextok  *t = nn(ZN, CONST, ZN, ZN);
	t-&gt;val = 1;
	return new_el(nn(ZN, 'c', t, ZN));
}

static void
add_el(Element *e, Sequence *s)
{
	if (e-&gt;n-&gt;ntyp == GOTO)
	{	Symbol *z = has_lab(e, (1|2|4));
		if (z)
		{	Element *y; /* insert a skip */
			y = mk_skip();
			mov_lab(z, e, y); /* inherit label */
			add_el(y, s);
	}	}
#ifdef DEBUG
	printf("add_el %d after %d -- ",
	e-&gt;Seqno, (s-&gt;last)?s-&gt;last-&gt;Seqno:-1);
	comment(stdout, e-&gt;n, 0);
	printf("\n");
#endif
	if (!s-&gt;frst)
		s-&gt;frst = e;
	else
		s-&gt;last-&gt;nxt = e;
	s-&gt;last = e;
}

static Element *
colons(Lextok *n)
{
	if (!n)
		return ZE;
	if (n-&gt;ntyp == ':')
	{	Element *e = colons(n-&gt;lft);
		set_lab(n-&gt;sym, e);
		return e;
	}
	innermost = n;
	return new_el(n);
}

void
add_seq(Lextok *n)
{	Element *e;

	if (!n) return;
	innermost = n;
	e = colons(n);
	if (innermost-&gt;ntyp != IF
	&amp;&amp;  innermost-&gt;ntyp != DO
	&amp;&amp;  innermost-&gt;ntyp != UNLESS)
		add_el(e, cur_s-&gt;this);
}

void
show_lab(void)
{	Label *l;
	for (l = labtab; l; l = l-&gt;nxt)
		printf("label %s\n", l-&gt;s-&gt;name);
}

void
set_lab(Symbol *s, Element *e)
{	Label *l; extern Symbol *context;
	int cur_uiid = is_inline();

	if (!s) return;

	for (l = labtab; l; l = l-&gt;nxt)
	{	if (strcmp(l-&gt;s-&gt;name, s-&gt;name) == 0
		&amp;&amp;  l-&gt;c == context
		&amp;&amp;  l-&gt;uiid == cur_uiid)
		{	non_fatal("label %s redeclared", s-&gt;name);
			break;
	}	}

	l = (Label *) emalloc(sizeof(Label));
	l-&gt;s = s;
	l-&gt;c = context;
	l-&gt;e = e;
	l-&gt;uiid = cur_uiid;
	l-&gt;nxt = labtab;
	labtab = l;
}

static Label *
get_labspec(Lextok *n)
{	Symbol *s = n-&gt;sym;
	Label *l, *anymatch = (Label *) 0;
	int cur_uiid = n-&gt;uiid;
	/*
	 * try to find a label with the same uiid
	 * but if it doesn't exist, return any other
	 * that is defined within the same scope
	 */
	for (l = labtab; l; l = l-&gt;nxt)
	{	if (strcmp(s-&gt;name, l-&gt;s-&gt;name) == 0
		&amp;&amp;  s-&gt;context == l-&gt;s-&gt;context)
		{	anymatch = l;
			if (cur_uiid == l-&gt;uiid) /* best match */
			{	return l;
	}	}	}

	return anymatch; /* likely to be 0 */
}

Element *
get_lab(Lextok *n, int md)
{	Label *l = get_labspec(n);

	if (l != (Label *) 0)
	{	return (l-&gt;e);
	}

	if (md)
	{	lineno = n-&gt;ln;
		Fname  = n-&gt;fn;
		fatal("undefined label %s", n-&gt;sym-&gt;name);
	}

	return ZE;
}

Symbol *
has_lab(Element *e, int special)
{	Label *l;

	for (l = labtab; l; l = l-&gt;nxt)
	{	if (e != l-&gt;e)
			continue;
		if (special == 0
		||  ((special&amp;1) &amp;&amp; !strncmp(l-&gt;s-&gt;name, "accept", 6))
		||  ((special&amp;2) &amp;&amp; !strncmp(l-&gt;s-&gt;name, "end", 3))
		||  ((special&amp;4) &amp;&amp; !strncmp(l-&gt;s-&gt;name, "progress", 8)))
			return (l-&gt;s);
	}
	return ZS;
}

static void
mov_lab(Symbol *z, Element *e, Element *y)
{	Label *l;

	for (l = labtab; l; l = l-&gt;nxt)
		if (e == l-&gt;e)
		{	l-&gt;e = y;
			return;
		}
	if (e-&gt;n)
	{	lineno = e-&gt;n-&gt;ln;
		Fname  = e-&gt;n-&gt;fn;
	}
	fatal("cannot happen - mov_lab %s", z-&gt;name);
}

void
fix_dest(Symbol *c, Symbol *a)		/* c:label name, a:proctype name */
{	Label *l; extern Symbol *context;

#if 0
	printf("ref to label '%s' in proctype '%s', search:\n",
		c-&gt;name, a-&gt;name);
	for (l = labtab; l; l = l-&gt;nxt)
		printf("	%s in	%s\n", l-&gt;s-&gt;name, l-&gt;c-&gt;name);
#endif

	for (l = labtab; l; l = l-&gt;nxt)
	{	if (strcmp(c-&gt;name, l-&gt;s-&gt;name) == 0
		&amp;&amp;  strcmp(a-&gt;name, l-&gt;c-&gt;name) == 0)	/* ? */
			break;
	}
	if (!l)
	{	printf("spin: label '%s' (proctype %s)\n", c-&gt;name, a-&gt;name);
		non_fatal("unknown label '%s'", c-&gt;name);
		if (context == a)
		printf("spin: cannot remote ref a label inside the same proctype\n");
		return;
	}
	if (!l-&gt;e || !l-&gt;e-&gt;n)
		fatal("fix_dest error (%s)", c-&gt;name);
	if (l-&gt;e-&gt;n-&gt;ntyp == GOTO)
	{	Element	*y = (Element *) emalloc(sizeof(Element));
		int	keep_ln = l-&gt;e-&gt;n-&gt;ln;
		Symbol	*keep_fn = l-&gt;e-&gt;n-&gt;fn;

		/* insert skip - or target is optimized away */
		y-&gt;n = l-&gt;e-&gt;n;		  /* copy of the goto   */
		y-&gt;seqno = find_maxel(a); /* unique seqno within proc */
		y-&gt;nxt = l-&gt;e-&gt;nxt;
		y-&gt;Seqno = Unique++; y-&gt;Nxt = Al_El; Al_El = y;

		/* turn the original element+seqno into a skip */
		l-&gt;e-&gt;n = nn(ZN, 'c', nn(ZN, CONST, ZN, ZN), ZN);
		l-&gt;e-&gt;n-&gt;ln = l-&gt;e-&gt;n-&gt;lft-&gt;ln = keep_ln;
		l-&gt;e-&gt;n-&gt;fn = l-&gt;e-&gt;n-&gt;lft-&gt;fn = keep_fn;
		l-&gt;e-&gt;n-&gt;lft-&gt;val = 1;
		l-&gt;e-&gt;nxt = y;		/* append the goto  */
	}
	l-&gt;e-&gt;status |= CHECK2;	/* treat as if global */
	if (l-&gt;e-&gt;status &amp; (ATOM | L_ATOM | D_ATOM))
	{	non_fatal("cannot reference label inside atomic or d_step (%s)",
			c-&gt;name);
	}
}

int
find_lab(Symbol *s, Symbol *c, int markit)
{	Label *l;

	for (l = labtab; l; l = l-&gt;nxt)
	{	if (strcmp(s-&gt;name, l-&gt;s-&gt;name) == 0
		&amp;&amp;  strcmp(c-&gt;name, l-&gt;c-&gt;name) == 0)
		{	l-&gt;visible |= markit;
			return (l-&gt;e-&gt;seqno);
	}	}
	return 0;
}

void
pushbreak(void)
{	Lbreak *r = (Lbreak *) emalloc(sizeof(Lbreak));
	Symbol *l;
	char buf[64];

	sprintf(buf, ":b%d", break_id++);
	l = lookup(buf);
	r-&gt;l = l;
	r-&gt;nxt = breakstack;
	breakstack = r;
}

Symbol *
break_dest(void)
{
	if (!breakstack)
		fatal("misplaced break statement", (char *)0);
	return breakstack-&gt;l;
}

void
make_atomic(Sequence *s, int added)
{	Element *f;

	walk_atomic(s-&gt;frst, s-&gt;last, added);

	f = s-&gt;last;
	switch (f-&gt;n-&gt;ntyp) {	/* is last step basic stmnt or sequence ? */
	case NON_ATOMIC:
	case ATOMIC:
		/* redo and search for the last step of that sequence */
		make_atomic(f-&gt;n-&gt;sl-&gt;this, added);
		break;

	case UNLESS:
		/* escapes are folded into main sequence */
		make_atomic(f-&gt;sub-&gt;this, added);
		break;

	default:
		f-&gt;status &amp;= ~ATOM;
		f-&gt;status |= L_ATOM;
		break;
	}
}

#if 0
static int depth = 0;
void dump_sym(Symbol *, char *);

void
dump_lex(Lextok *t, char *s)
{	int i;

	depth++;
	printf(s);
	for (i = 0; i &lt; depth; i++)
		printf("\t");
	explain(t-&gt;ntyp);
	if (t-&gt;ntyp == NAME) printf(" %s ", t-&gt;sym-&gt;name);
	if (t-&gt;ntyp == CONST) printf(" %d ", t-&gt;val);
	if (t-&gt;ntyp == STRUCT)
	{	dump_sym(t-&gt;sym, "\n:Z:");
	}
	if (t-&gt;lft)
	{	dump_lex(t-&gt;lft, "\nL");
	}
	if (t-&gt;rgt)
	{	dump_lex(t-&gt;rgt, "\nR");
	}	
	depth--;
}
void
dump_sym(Symbol *z, char *s)
{	int i;
	char txt[64];
	depth++;
	printf(s);
	for (i = 0; i &lt; depth; i++)
		printf("\t");

	if (z-&gt;type == CHAN)
	{	if (z-&gt;ini &amp;&amp; z-&gt;ini-&gt;rgt &amp;&amp; z-&gt;ini-&gt;rgt-&gt;sym)
		{	// dump_sym(z-&gt;ini-&gt;rgt-&gt;sym, "\n:I:"); /* could also be longer list */
			if (z-&gt;ini-&gt;rgt-&gt;rgt
			|| !z-&gt;ini-&gt;rgt-&gt;sym)
			fatal("chan %s in for should have only one field (a typedef)", z-&gt;name);
			printf(" -- %s %p -- ", z-&gt;ini-&gt;rgt-&gt;sym-&gt;name, z-&gt;ini-&gt;rgt-&gt;sym);
		}
	} else if (z-&gt;type == STRUCT)
	{	if (z-&gt;Snm)
			printf(" == %s %p == ", z-&gt;Snm-&gt;name, z-&gt;Snm);
		else
		{	if (z-&gt;Slst)
				dump_lex(z-&gt;Slst, "\n:X:");
			if (z-&gt;ini)
				dump_lex(z-&gt;ini, "\n:I:");
		}
	}
	depth--;

}
#endif

int
match_struct(Symbol *s, Symbol *t)
{
	if (!t
	||  !t-&gt;ini
	||  !t-&gt;ini-&gt;rgt
	||  !t-&gt;ini-&gt;rgt-&gt;sym
	||   t-&gt;ini-&gt;rgt-&gt;rgt)
	{	fatal("chan %s in for should have only one field (a typedef)", t-&gt;name);
	}
	/* we already know that s is a STRUCT */
	if (0)
	{	printf("index type %s %p ==\n", s-&gt;Snm-&gt;name, s-&gt;Snm);
		printf("chan type  %s %p --\n\n", t-&gt;ini-&gt;rgt-&gt;sym-&gt;name, t-&gt;ini-&gt;rgt-&gt;sym);
	}

	return (s-&gt;Snm == t-&gt;ini-&gt;rgt-&gt;sym);
}

void
valid_name(Lextok *a3, Lextok *a5, Lextok *a8, char *tp)
{
	if (a3-&gt;ntyp != NAME)
	{	fatal("%s ( .name : from .. to ) { ... }", tp);
	}
	if (a3-&gt;sym-&gt;type == CHAN
	||  a3-&gt;sym-&gt;type == STRUCT
	||  a3-&gt;sym-&gt;isarray != 0)
	{	fatal("bad index in for-construct %s", a3-&gt;sym-&gt;name);
	}
	if (a5-&gt;ntyp == CONST &amp;&amp; a8-&gt;ntyp == CONST &amp;&amp; a5-&gt;val &gt; a8-&gt;val)
	{	non_fatal("start value for %s exceeds end-value", a3-&gt;sym-&gt;name);
	}
}

void
for_setup(Lextok *a3, Lextok *a5, Lextok *a8)
{	/* for ( a3 : a5 .. a8 ) */

	valid_name(a3, a5, a8, "for");
	/* a5-&gt;ntyp = a8-&gt;ntyp = CONST; */
	add_seq(nn(a3, ASGN, a3, a5));	/* start value */
	open_seq(0);
	add_seq(nn(ZN, 'c', nn(a3, LE, a3, a8), ZN));	/* condition */
}

Lextok *
for_index(Lextok *a3, Lextok *a5)
{	Lextok *z0, *z1, *z2, *z3;
	Symbol *tmp_cnt;
	char tmp_nm[MAXSCOPESZ];
	/* for ( a3 in a5 ) { ... } */

	if (a3-&gt;ntyp != NAME)
	{	fatal("for ( .name in name ) { ... }", (char *) 0);
	}

	if (a5-&gt;ntyp != NAME)
	{	fatal("for ( %s in .name ) { ... }", a3-&gt;sym-&gt;name);
	}

	if (a3-&gt;sym-&gt;type == STRUCT)
	{	if (a5-&gt;sym-&gt;type != CHAN)
		{	fatal("for ( %s in .channel_name ) { ... }",
				a3-&gt;sym-&gt;name);
		}
		z0 = a5-&gt;sym-&gt;ini;
		if (!z0
		|| z0-&gt;val &lt;= 0
		|| z0-&gt;rgt-&gt;ntyp != STRUCT
		|| z0-&gt;rgt-&gt;rgt != NULL)
		{	fatal("bad channel type %s in for", a5-&gt;sym-&gt;name);
		}

		if (!match_struct(a3-&gt;sym, a5-&gt;sym))
		{	fatal("type of %s does not match chan", a3-&gt;sym-&gt;name);
		}

		z1 = nn(ZN, CONST, ZN, ZN); z1-&gt;val = 0;
		z2 = nn(a5, LEN, a5, ZN);

		sprintf(tmp_nm, "_f0r_t3mp%s", CurScope); /* make sure it's unique */
		tmp_cnt = lookup(tmp_nm);
		if (z0-&gt;val &gt; 255)			/* check nr of slots, i.e. max length */
		{	tmp_cnt-&gt;type = SHORT;	/* should be rare */
		} else
		{	tmp_cnt-&gt;type = BYTE;
		}
		z3 = nn(ZN, NAME, ZN, ZN);
		z3-&gt;sym = tmp_cnt;

		add_seq(nn(z3, ASGN, z3, z1));	/* start value 0 */

		open_seq(0);

		add_seq(nn(ZN, 'c', nn(z3, LT, z3, z2), ZN));	/* condition */

		/* retrieve  message from the right slot -- for now: rotate contents */
		in_for = 0;
		add_seq(nn(a5, 'r', a5, expand(a3, 1)));	/* receive */
		add_seq(nn(a5, 's', a5, expand(a3, 1)));	/* put back in to rotate */
		in_for = 1;
		return z3;
	} else
	{	if (a5-&gt;sym-&gt;isarray == 0
		||  a5-&gt;sym-&gt;nel &lt;= 0)
		{	fatal("bad arrayname %s", a5-&gt;sym-&gt;name);
		}
		z1 = nn(ZN, CONST, ZN, ZN); z1-&gt;val = 0;
		z2 = nn(ZN, CONST, ZN, ZN); z2-&gt;val = a5-&gt;sym-&gt;nel - 1;
		for_setup(a3, z1, z2);
		return a3;
	}
}

Lextok *
for_body(Lextok *a3, int with_else)
{	Lextok *t1, *t2, *t0, *rv;

	rv = nn(ZN, CONST, ZN, ZN); rv-&gt;val = 1;
	rv = nn(ZN,  '+', a3, rv);
	rv = nn(a3, ASGN, a3, rv);
	add_seq(rv);	/* initial increment */

	pushbreak();

	/* completed loop body, main sequence */
	t1 = nn(ZN, 0, ZN, ZN);
	t1-&gt;sq = close_seq(8);

	open_seq(0);		/* add else -&gt; break sequence */
	if (with_else)
	{	add_seq(nn(ZN, ELSE, ZN, ZN));
	}
	t2 = nn(ZN, GOTO, ZN, ZN);
	t2-&gt;sym = break_dest();
	add_seq(t2);
	t2 = nn(ZN, 0, ZN, ZN);
	t2-&gt;sq = close_seq(9);

	t0 = nn(ZN, 0, ZN, ZN);
	t0-&gt;sl = seqlist(t2-&gt;sq, seqlist(t1-&gt;sq, 0));

	rv = nn(ZN, DO, ZN, ZN);
	rv-&gt;sl = t0-&gt;sl;
	return rv;
}

Lextok *
sel_index(Lextok *a3, Lextok *a5, Lextok *a7)
{	/* select ( a3 : a5 .. a7 ) */

	valid_name(a3, a5, a7, "select");
	/* a5-&gt;ntyp = a7-&gt;ntyp = CONST; */

	add_seq(nn(a3, ASGN, a3, a5));	/* start value */
	open_seq(0);
	add_seq(nn(ZN, 'c', nn(a3, LT, a3, a7), ZN));	/* condition */

	return for_body(a3, 0);	/* no else, just a non-deterministic break */
}

static void
walk_atomic(Element *a, Element *b, int added)
{	Element *f; Symbol *ofn; int oln;
	SeqList *h;

	ofn = Fname;
	oln = lineno;
	for (f = a; ; f = f-&gt;nxt)
	{	f-&gt;status |= (ATOM|added);
		switch (f-&gt;n-&gt;ntyp) {
		case ATOMIC:
			if (verbose&amp;32)
			  printf("spin: warning, %s:%d, atomic inside %s (ignored)\n",
			  f-&gt;n-&gt;fn-&gt;name, f-&gt;n-&gt;ln, (added)?"d_step":"atomic");
			goto mknonat;
		case D_STEP:
			if (!(verbose&amp;32))
			{	if (added) goto mknonat;
				break;
			}
			printf("spin: warning, %s:%d, d_step inside ",
			 f-&gt;n-&gt;fn-&gt;name, f-&gt;n-&gt;ln);
			if (added)
			{	printf("d_step (ignored)\n");
				goto mknonat;
			}
			printf("atomic\n");
			break;
		case NON_ATOMIC:
mknonat:		f-&gt;n-&gt;ntyp = NON_ATOMIC; /* can jump here */
			h = f-&gt;n-&gt;sl;
			walk_atomic(h-&gt;this-&gt;frst, h-&gt;this-&gt;last, added);
			break;
		case UNLESS:
			if (added)
			{ printf("spin: error, %s:%d, unless in d_step (ignored)\n",
			 	 f-&gt;n-&gt;fn-&gt;name, f-&gt;n-&gt;ln);
			}
		}
		for (h = f-&gt;sub; h; h = h-&gt;nxt)
			walk_atomic(h-&gt;this-&gt;frst, h-&gt;this-&gt;last, added);
		if (f == b)
			break;
	}
	Fname = ofn;
	lineno = oln;
}

void
dumplabels(void)
{	Label *l;

	for (l = labtab; l; l = l-&gt;nxt)
		if (l-&gt;c != 0 &amp;&amp; l-&gt;s-&gt;name[0] != ':')
		{	printf("label	%s	%d	",
				l-&gt;s-&gt;name, l-&gt;e-&gt;seqno);
			if (l-&gt;uiid == 0)
				printf("&lt;%s&gt;\n", l-&gt;c-&gt;name);
			else
				printf("&lt;%s i%d&gt;\n", l-&gt;c-&gt;name, l-&gt;uiid);
		}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

