<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/guided.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/guided.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: guided.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include &lt;sys/types.h&gt;
#include &lt;sys/stat.h&gt;
#include "y.tab.h"

extern RunList	*run, *X;
extern Element	*Al_El;
extern Symbol	*Fname, *oFname;
extern int	verbose, lineno, xspin, jumpsteps, depth, merger, cutoff;
extern int	nproc, nstop, Tval, ntrail, columns;
extern short	Have_claim, Skip_claim;
extern void ana_src(int, int);
extern char	**trailfilename;

int	TstOnly = 0, pno;

static int	lastclaim = -1;
static FILE	*fd;
static void	lost_trail(void);

static void
whichproc(int p)
{	RunList *oX;

	for (oX = run; oX; oX = oX-&gt;nxt)
		if (oX-&gt;pid == p)
		{	printf("(%s) ", oX-&gt;n-&gt;name);
			break;
		}
}

static int
newer(char *f1, char *f2)
{
#if defined(WIN32) || defined(WIN64)
	struct _stat x, y;
#else
	struct stat x, y;
#endif

	if (stat(f1, (struct stat *)&amp;x) &lt; 0) return 0;
	if (stat(f2, (struct stat *)&amp;y) &lt; 0) return 1;
	if (x.st_mtime &lt; y.st_mtime) return 0;
	
	return 1;
}

void
hookup(void)
{	Element *e;

	for (e = Al_El; e; e = e-&gt;Nxt)
		if (e-&gt;n
		&amp;&amp; (e-&gt;n-&gt;ntyp == ATOMIC
		||  e-&gt;n-&gt;ntyp == NON_ATOMIC
		||  e-&gt;n-&gt;ntyp == D_STEP))
			(void) huntstart(e);
}

int
not_claim(void)
{
	return (!Have_claim || !X || X-&gt;pid != 0);
}

void
match_trail(void)
{	int i, a, nst;
	Element *dothis;
	char snap[512], *q;

	/*
	 * if source model name is leader.pml
	 * look for the trail file under these names:
	 *	leader.pml.trail
	 *	leader.pml.tra
	 *	leader.trail
	 *	leader.tra
	 */

	if (trailfilename)
	{	if (strlen(*trailfilename) &lt; sizeof(snap))
		{	strcpy(snap, (const char *) *trailfilename);
		} else
		{	fatal("filename %s too long", *trailfilename);
		}
	} else
	{	if (ntrail)
			sprintf(snap, "%s%d.trail", oFname-&gt;name, ntrail);
		else
			sprintf(snap, "%s.trail", oFname-&gt;name);
	}

	if ((fd = fopen(snap, "r")) == NULL)
	{	snap[strlen(snap)-2] = '\0';	/* .tra */
		if ((fd = fopen(snap, "r")) == NULL)
		{	if ((q = strchr(oFname-&gt;name, '.')) != NULL)
			{	*q = '\0';
				if (ntrail)
					sprintf(snap, "%s%d.trail",
						oFname-&gt;name, ntrail);
				else
					sprintf(snap, "%s.trail",
						oFname-&gt;name);
				*q = '.';

				if ((fd = fopen(snap, "r")) != NULL)
					goto okay;

				snap[strlen(snap)-2] = '\0';	/* last try */
				if ((fd = fopen(snap, "r")) != NULL)
					goto okay;
			}
			printf("spin: cannot find trail file\n");
			alldone(1);
	}	}
okay:		
	if (xspin == 0 &amp;&amp; newer(oFname-&gt;name, snap))
	printf("spin: warning, \"%s\" is newer than %s\n",
		oFname-&gt;name, snap);

	Tval = 1;

	/*
	 * sets Tval because timeouts may be part of trail
	 * this used to also set m_loss to 1, but that is
	 * better handled with the runtime -m flag
	 */

	hookup();

	while (fscanf(fd, "%d:%d:%d\n", &amp;depth, &amp;pno, &amp;nst) == 3)
	{	if (depth == -2) { start_claim(pno); continue; }
		if (depth == -4) { merger = 1; ana_src(0, 1); continue; }
		if (depth == -1)
		{	if (verbose)
			{	if (columns == 2)
				dotag(stdout, " CYCLE&gt;\n");
				else
				dotag(stdout, "&lt;&lt;&lt;&lt;&lt;START OF CYCLE&gt;&gt;&gt;&gt;&gt;\n");
			}
			continue;
		}

		if (cutoff &gt; 0 &amp;&amp; depth &gt;= cutoff)
		{	printf("-------------\n");
			printf("depth-limit (-u%d steps) reached\n", cutoff);
			break;
		}

		if (Skip_claim &amp;&amp; pno == 0) continue;

		for (dothis = Al_El; dothis; dothis = dothis-&gt;Nxt)
		{	if (dothis-&gt;Seqno == nst)
				break;
		}
		if (!dothis)
		{	printf("%3d: proc %d, no matching stmnt %d\n",
				depth, pno - Have_claim, nst);
			lost_trail();
		}

		i = nproc - nstop + Skip_claim;

		if (dothis-&gt;n-&gt;ntyp == '@')
		{	if (pno == i-1)
			{	run = run-&gt;nxt;
				nstop++;
				if (verbose&amp;4)
				{	if (columns == 2)
					{	dotag(stdout, "&lt;end&gt;\n");
						continue;
					}
					if (Have_claim &amp;&amp; pno == 0)
					printf("%3d: claim terminates\n",
						depth);
					else
					printf("%3d: proc %d terminates\n",
						depth, pno - Have_claim);
				}
				continue;
			}
			if (pno &lt;= 1) continue;	/* init dies before never */
			printf("%3d: stop error, ", depth);
			printf("proc %d (i=%d) trans %d, %c\n",
				pno - Have_claim, i, nst, dothis-&gt;n-&gt;ntyp);
			lost_trail();
		}

		if (!xspin &amp;&amp; (verbose&amp;32))
		{	printf("i=%d pno %d\n", i, pno);
		}

		for (X = run; X; X = X-&gt;nxt)
		{	if (--i == pno)
				break;
		}

		if (!X)
		{	if (verbose&amp;32)
			{	printf("%3d: no process %d (step %d)\n", depth, pno - Have_claim, nst);
				printf(" max %d (%d - %d + %d) claim %d",
					nproc - nstop + Skip_claim,
					nproc, nstop, Skip_claim, Have_claim);
				printf("active processes:\n");
				for (X = run; X; X = X-&gt;nxt)
				{	printf("\tpid %d\tproctype %s\n", X-&gt;pid, X-&gt;n-&gt;name);
				}
				printf("\n");
				continue;	
			} else
			{	printf("%3d:\tproc  %d (?) ", depth, pno);
				lost_trail();
			}
		} else
		{	X-&gt;pc  = dothis;
		}

		lineno = dothis-&gt;n-&gt;ln;
		Fname  = dothis-&gt;n-&gt;fn;

		if (dothis-&gt;n-&gt;ntyp == D_STEP)
		{	Element *g, *og = dothis;
			do {
				g = eval_sub(og);
				if (g &amp;&amp; depth &gt;= jumpsteps
				&amp;&amp; ((verbose&amp;32) || ((verbose&amp;4) &amp;&amp; not_claim())))
				{	if (columns != 2)
					{	p_talk(og, 1);
		
						if (og-&gt;n-&gt;ntyp == D_STEP)
						og = og-&gt;n-&gt;sl-&gt;this-&gt;frst;
		
						printf("\t[");
						comment(stdout, og-&gt;n, 0);
						printf("]\n");
					}
					if (verbose&amp;1) dumpglobals();
					if (verbose&amp;2) dumplocal(X);
					if (xspin) printf("\n");
				}
				og = g;
			} while (g &amp;&amp; g != dothis-&gt;nxt);
			if (X != NULL)
			{	X-&gt;pc = g?huntele(g, 0, -1):g;
			}
		} else
		{
keepgoing:		if (dothis-&gt;merge_start)
				a = dothis-&gt;merge_start;
			else
				a = dothis-&gt;merge;

			if (X != NULL)
			{	X-&gt;pc = eval_sub(dothis);
				if (X-&gt;pc) X-&gt;pc = huntele(X-&gt;pc, 0, a);
			}

			if (depth &gt;= jumpsteps
			&amp;&amp; ((verbose&amp;32) || ((verbose&amp;4) &amp;&amp; not_claim())))	/* -v or -p */
			{	if (columns != 2)
				{	p_talk(dothis, 1);
	
					if (dothis-&gt;n-&gt;ntyp == D_STEP)
					dothis = dothis-&gt;n-&gt;sl-&gt;this-&gt;frst;
		
					printf("\t[");
					comment(stdout, dothis-&gt;n, 0);
					printf("]");
					if (a &amp;&amp; (verbose&amp;32))
					printf("\t&lt;merge %d now @%d&gt;",
						dothis-&gt;merge,
						(X &amp;&amp; X-&gt;pc)?X-&gt;pc-&gt;seqno:-1);
					printf("\n");
				}
				if (verbose&amp;1) dumpglobals();
				if (verbose&amp;2) dumplocal(X);
				if (xspin) printf("\n");

				if (X &amp;&amp; !X-&gt;pc)
				{	X-&gt;pc = dothis;
					printf("\ttransition failed\n");
					a = 0;	/* avoid inf loop */
				}
			}
			if (a &amp;&amp; X &amp;&amp; X-&gt;pc &amp;&amp; X-&gt;pc-&gt;seqno != a)
			{	dothis = X-&gt;pc;
				goto keepgoing;
		}	}

		if (Have_claim &amp;&amp; X &amp;&amp; X-&gt;pid == 0
		&amp;&amp;  dothis-&gt;n
		&amp;&amp;  lastclaim != dothis-&gt;n-&gt;ln)
		{	lastclaim = dothis-&gt;n-&gt;ln;
			if (columns == 2)
			{	char t[128];
				sprintf(t, "#%d", lastclaim);
				pstext(0, t);
			} else
			{
				printf("Never claim moves to line %d\t[", lastclaim);
				comment(stdout, dothis-&gt;n, 0);
				printf("]\n");
	}	}	}
	printf("spin: trail ends after %d steps\n", depth);
	wrapup(0);
}

static void
lost_trail(void)
{	int d, p, n, l;

	while (fscanf(fd, "%d:%d:%d:%d\n", &amp;d, &amp;p, &amp;n, &amp;l) == 4)
	{	printf("step %d: proc  %d ", d, p); whichproc(p);
		printf("(state %d) - d %d\n", n, l);
	}
	wrapup(1);	/* no return */
}

int
pc_value(Lextok *n)
{	int i = nproc - nstop;
	int pid = eval(n);
	RunList *Y;

	for (Y = run; Y; Y = Y-&gt;nxt)
	{	if (--i == pid)
			return Y-&gt;pc-&gt;seqno;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

