<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/pangen5.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/pangen5.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: pangen5.c *****/

/* Copyright (c) 1999-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

typedef struct BuildStack {
	FSM_trans *t;
	struct BuildStack *nxt;
} BuildStack;

extern ProcList	*rdy;
extern int verbose, eventmapnr, claimnr, rvopt, export_ast, u_sync;
extern Element *Al_El;

static FSM_state *fsm_free;
static FSM_trans *trans_free;
static BuildStack *bs, *bf;
static int max_st_id;
static int cur_st_id;
int o_max;
FSM_state *fsm;
FSM_state **fsm_tbl;
FSM_use   *use_free;

static void ana_seq(Sequence *);
static void ana_stmnt(FSM_trans *, Lextok *, int);

extern void AST_slice(void);
extern void AST_store(ProcList *, int);
extern int  has_global(Lextok *);
extern void exit(int);

static void
fsm_table(void)
{	FSM_state *f;
	max_st_id += 2;
	/* fprintf(stderr, "omax %d, max=%d\n", o_max, max_st_id); */
	if (o_max &lt; max_st_id)
	{	o_max = max_st_id;
		fsm_tbl = (FSM_state **) emalloc(max_st_id * sizeof(FSM_state *));
	} else
		memset((char *)fsm_tbl, 0, max_st_id * sizeof(FSM_state *));
	cur_st_id = max_st_id;
	max_st_id = 0;

	for (f = fsm; f; f = f-&gt;nxt)
		fsm_tbl[f-&gt;from] = f;
}

static int
FSM_DFS(int from, FSM_use *u)
{	FSM_state *f;
	FSM_trans *t;
	FSM_use *v;
	int n;

	if (from == 0)
		return 1;

	f = fsm_tbl[from];

	if (!f)
	{	printf("cannot find state %d\n", from);
		fatal("fsm_dfs: cannot happen\n", (char *) 0);
	}

	if (f-&gt;seen)
		return 1;
	f-&gt;seen = 1;

	for (t = f-&gt;t; t; t = t-&gt;nxt)
	{
		for (n = 0; n &lt; 2; n++)
		for (v = t-&gt;Val[n]; v; v = v-&gt;nxt)
			if (u-&gt;var == v-&gt;var)
				return n;	/* a read or write */

		if (!FSM_DFS(t-&gt;to, u))
			return 0;
	}
	return 1;
}

static void
new_dfs(void)
{	int i;

	for (i = 0; i &lt; cur_st_id; i++)
		if (fsm_tbl[i])
			fsm_tbl[i]-&gt;seen = 0;
}

static int
good_dead(Element *e, FSM_use *u)
{
	switch (u-&gt;special) {
	case 2:	/* ok if it's a receive */
		if (e-&gt;n-&gt;ntyp == ASGN
		&amp;&amp;  e-&gt;n-&gt;rgt-&gt;ntyp == CONST
		&amp;&amp;  e-&gt;n-&gt;rgt-&gt;val == 0)
			return 0;
		break;
	case 1:	/* must be able to use oval */
		if (e-&gt;n-&gt;ntyp != 'c'
		&amp;&amp;  e-&gt;n-&gt;ntyp != 'r')
			return 0;	/* can't really happen */
		break;
	}
	return 1;
}

#if 0
static int howdeep = 0;
#endif

static int
eligible(FSM_trans *v)
{	Element	*el = ZE;
	Lextok	*lt = ZN;

	if (v) el = v-&gt;step;
	if (el) lt = v-&gt;step-&gt;n;

	if (!lt				/* dead end */
	||  v-&gt;nxt			/* has alternatives */
	||  el-&gt;esc			/* has an escape */
	||  (el-&gt;status&amp;CHECK2)		/* remotely referenced */
	||  lt-&gt;ntyp == ATOMIC
	||  lt-&gt;ntyp == NON_ATOMIC	/* used for inlines -- should be able to handle this */
	||  lt-&gt;ntyp == IF
	||  lt-&gt;ntyp == C_CODE
	||  lt-&gt;ntyp == C_EXPR
	||  has_lab(el, 0)		/* any label at all */

	||  lt-&gt;ntyp == DO
	||  lt-&gt;ntyp == UNLESS
	||  lt-&gt;ntyp == D_STEP
	||  lt-&gt;ntyp == ELSE
	||  lt-&gt;ntyp == '@'
	||  lt-&gt;ntyp == 'c'
	||  lt-&gt;ntyp == 'r'
	||  lt-&gt;ntyp == 's')
		return 0;

	if (!(el-&gt;status&amp;(2|4)))	/* not atomic */
	{	int unsafe = (el-&gt;status&amp;I_GLOB)?1:has_global(el-&gt;n);
		if (unsafe)
			return 0;
	}

	return 1;
}

static int
canfill_in(FSM_trans *v)
{	Element	*el = v-&gt;step;
	Lextok	*lt = v-&gt;step-&gt;n;

	if (!lt				/* dead end */
	||  v-&gt;nxt			/* has alternatives */
	||  el-&gt;esc			/* has an escape */
	||  (el-&gt;status&amp;CHECK2))	/* remotely referenced */
		return 0;

	if (!(el-&gt;status&amp;(2|4))		/* not atomic */
	&amp;&amp;  ((el-&gt;status&amp;I_GLOB)
	||   has_global(el-&gt;n)))	/* and not safe */
		return 0;

	return 1;
}

static int
pushbuild(FSM_trans *v)
{	BuildStack *b;

	for (b = bs; b; b = b-&gt;nxt)
		if (b-&gt;t == v)
			return 0;
	if (bf)
	{	b = bf;
		bf = bf-&gt;nxt;
	} else
		b = (BuildStack *) emalloc(sizeof(BuildStack));
	b-&gt;t = v;
	b-&gt;nxt = bs;
	bs = b;
	return 1;
}

static void
popbuild(void)
{	BuildStack *f;
	if (!bs)
		fatal("cannot happen, popbuild", (char *) 0);
	f = bs;
	bs = bs-&gt;nxt;
	f-&gt;nxt = bf;
	bf = f;				/* freelist */
}

static int
build_step(FSM_trans *v)
{	FSM_state *f;
	Element	*el;
#if 0
	Lextok	*lt = ZN;
#endif
	int	st;
	int	r;

	if (!v) return -1;

	el = v-&gt;step;
	st = v-&gt;to;

	if (!el) return -1;

	if (v-&gt;step-&gt;merge)
		return v-&gt;step-&gt;merge;	/* already done */

	if (!eligible(v))		/* non-blocking */
		return -1;

	if (!pushbuild(v))		/* cycle detected */
		return -1;		/* break cycle */

	f = fsm_tbl[st];
#if 0
	lt = v-&gt;step-&gt;n;
	if (verbose&amp;32)
	{	if (++howdeep == 1)
			printf("spin: %s:%d, merge:\n", lt-&gt;fn-&gt;name, lt-&gt;ln);
		printf("\t[%d] &lt;seqno %d&gt;\t", howdeep, el-&gt;seqno);
		comment(stdout, lt, 0);
		printf(";\n");
	}
#endif
	r = build_step(f-&gt;t);
	v-&gt;step-&gt;merge = (r == -1) ? st : r;
#if 0
	if (verbose&amp;32)
	{	printf("	merge value: %d (st=%d,r=%d, line %d)\n",
			v-&gt;step-&gt;merge, st, r, el-&gt;n-&gt;ln);
		howdeep--;
	}
#endif
	popbuild();

	return v-&gt;step-&gt;merge;
}

static void
FSM_MERGER(/* char *pname */ void)	/* find candidates for safely merging steps */
{	FSM_state *f, *g;
	FSM_trans *t;
	Lextok	*lt;

	for (f = fsm; f; f = f-&gt;nxt)		/* all states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* all edges */
	{	if (!t-&gt;step) continue;		/* happens with 'unless' */

		t-&gt;step-&gt;merge_in = f-&gt;in;	/* ?? */

		if (t-&gt;step-&gt;merge)
			continue;
		lt = t-&gt;step-&gt;n;

		if (lt-&gt;ntyp == 'c'
		||  lt-&gt;ntyp == 'r'
		||  lt-&gt;ntyp == 's')	/* blocking stmnts */
			continue;	/* handled in 2nd scan */

		if (!eligible(t))
			continue;

		g = fsm_tbl[t-&gt;to];
		if (!g || !eligible(g-&gt;t))
		{
#define SINGLES
#ifdef SINGLES
			t-&gt;step-&gt;merge_single = t-&gt;to;
#if 0
			if ((verbose&amp;32))
			{	printf("spin: %s:%d, merge_single:\n\t&lt;seqno %d&gt;\t",
					t-&gt;step-&gt;n-&gt;fn-&gt;name,
					t-&gt;step-&gt;n-&gt;ln,
					t-&gt;step-&gt;seqno);
				comment(stdout, t-&gt;step-&gt;n, 0);
				printf(";\n");
			}
#endif
#endif
			/* t is an isolated eligible step:
			 *
			 * a merge_start can connect to a proper
			 * merge chain or to a merge_single
			 * a merge chain can be preceded by
			 * a merge_start, but not by a merge_single
			 */

			continue;
		}

		(void) build_step(t);
	}

	/* 2nd scan -- find possible merge_starts */

	for (f = fsm; f; f = f-&gt;nxt)		/* all states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* all edges */
	{	if (!t-&gt;step || t-&gt;step-&gt;merge)
			continue;

		lt = t-&gt;step-&gt;n;
#if 0
	4.1.3:
	an rv send operation inside an atomic, *loses* atomicity
	when executed
	and should therefore never be merged with a subsequent
	statement within the atomic sequence
	the same is not true for non-rv send operations
#endif

		if (lt-&gt;ntyp == 'c'	/* potentially blocking stmnts */
		||  lt-&gt;ntyp == 'r'
		||  (lt-&gt;ntyp == 's' &amp;&amp; u_sync == 0))	/* added !u_sync in 4.1.3 */
		{	if (!canfill_in(t))		/* atomic, non-global, etc. */
				continue;

			g = fsm_tbl[t-&gt;to];
			if (!g || !g-&gt;t || !g-&gt;t-&gt;step)
				continue;
			if (g-&gt;t-&gt;step-&gt;merge)
				t-&gt;step-&gt;merge_start = g-&gt;t-&gt;step-&gt;merge;
#ifdef SINGLES
			else if (g-&gt;t-&gt;step-&gt;merge_single)
				t-&gt;step-&gt;merge_start = g-&gt;t-&gt;step-&gt;merge_single;
#endif
#if 0
			if ((verbose&amp;32)
			&amp;&amp; t-&gt;step-&gt;merge_start)
			{	printf("spin: %s:%d, merge_START:\n\t&lt;seqno %d&gt;\t",
						lt-&gt;fn-&gt;name, lt-&gt;ln,
						t-&gt;step-&gt;seqno);
				comment(stdout, lt, 0);
				printf(";\n");
			}
#endif
		}
	}
}

static void
FSM_ANA(void)
{	FSM_state *f;
	FSM_trans *t;
	FSM_use *u, *v, *w;
	int n;

	for (f = fsm; f; f = f-&gt;nxt)		/* all states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* all edges */
	for (n = 0; n &lt; 2; n++)			/* reads and writes */
	for (u = t-&gt;Val[n]; u; u = u-&gt;nxt)
	{	if (!u-&gt;var-&gt;context	/* global */
		||   u-&gt;var-&gt;type == CHAN
		||   u-&gt;var-&gt;type == STRUCT)
			continue;
		new_dfs();
		if (FSM_DFS(t-&gt;to, u))	/* cannot hit read before hitting write */
			u-&gt;special = n+1;	/* means, reset to 0 after use */
	}

	if (!export_ast)
	for (f = fsm; f; f = f-&gt;nxt)
	for (t = f-&gt;t; t; t = t-&gt;nxt)
	for (n = 0; n &lt; 2; n++)
	for (u = t-&gt;Val[n], w = (FSM_use *) 0; u; )
	{	if (u-&gt;special)
		{	v = u-&gt;nxt;
			if (!w)			/* remove from list */
				t-&gt;Val[n] = v;
			else
				w-&gt;nxt = v;
#if q
			if (verbose&amp;32)
			{	printf("%s : %3d:  %d -&gt; %d \t",
					t-&gt;step-&gt;n-&gt;fn-&gt;name,
					t-&gt;step-&gt;n-&gt;ln,
					f-&gt;from,
					t-&gt;to);
				comment(stdout, t-&gt;step-&gt;n, 0);
				printf("\t%c%d: %s\n", n==0?'R':'L',
					u-&gt;special, u-&gt;var-&gt;name);
			}
#endif
			if (good_dead(t-&gt;step, u))
			{	u-&gt;nxt = t-&gt;step-&gt;dead;	/* insert into dead */
				t-&gt;step-&gt;dead = u;
			}
			u = v;
		} else
		{	w = u;
			u = u-&gt;nxt;
	}	}
}

void
rel_use(FSM_use *u)
{
	if (!u) return;
	rel_use(u-&gt;nxt);
	u-&gt;var = (Symbol *) 0;
	u-&gt;special = 0;
	u-&gt;nxt = use_free;
	use_free = u;
}

static void
rel_trans(FSM_trans *t)
{
	if (!t) return;
	rel_trans(t-&gt;nxt);
	rel_use(t-&gt;Val[0]);
	rel_use(t-&gt;Val[1]);
	t-&gt;Val[0] = t-&gt;Val[1] = (FSM_use *) 0;
	t-&gt;nxt = trans_free;
	trans_free = t;
}

static void
rel_state(FSM_state *f)
{
	if (!f) return;
	rel_state(f-&gt;nxt);
	rel_trans(f-&gt;t);
	f-&gt;t = (FSM_trans *) 0;
	f-&gt;nxt = fsm_free;
	fsm_free = f;
}

static void
FSM_DEL(void)
{
	rel_state(fsm);
	fsm = (FSM_state *) 0;
}

static FSM_state *
mkstate(int s)
{	FSM_state *f;

	/* fsm_tbl isn't allocated yet */
	for (f = fsm; f; f = f-&gt;nxt)
		if (f-&gt;from == s)
			break;
	if (!f)
	{	if (fsm_free)
		{	f = fsm_free;
			memset(f, 0, sizeof(FSM_state));
			fsm_free = fsm_free-&gt;nxt;
		} else
			f = (FSM_state *) emalloc(sizeof(FSM_state));
		f-&gt;from = s;
		f-&gt;t = (FSM_trans *) 0;
		f-&gt;nxt = fsm;
		fsm = f;
		if (s &gt; max_st_id)
			max_st_id = s;
	}
	return f;
}

static FSM_trans *
get_trans(int to)
{	FSM_trans *t;

	if (trans_free)
	{	t = trans_free;
		memset(t, 0, sizeof(FSM_trans));
		trans_free = trans_free-&gt;nxt;
	} else
		t = (FSM_trans *) emalloc(sizeof(FSM_trans));

	t-&gt;to = to;
	return t;
}

static void
FSM_EDGE(int from, int to, Element *e)
{	FSM_state *f;
	FSM_trans *t;

	f = mkstate(from);	/* find it or else make it */
	t = get_trans(to);

	t-&gt;step = e;
	t-&gt;nxt = f-&gt;t;
	f-&gt;t = t;

	f = mkstate(to);
	f-&gt;in++;

	if (export_ast)
	{	t = get_trans(from);
		t-&gt;step = e;
		t-&gt;nxt = f-&gt;p;	/* from is a predecessor of to */
		f-&gt;p = t;
	}

	if (t-&gt;step)
		ana_stmnt(t, t-&gt;step-&gt;n, 0);
}

#define LVAL	1
#define RVAL	0

static void
ana_var(FSM_trans *t, Lextok *now, int usage)
{	FSM_use *u, *v;

	if (!t || !now || !now-&gt;sym)
		return;

	if (now-&gt;sym-&gt;name[0] == '_'
	&amp;&amp;  (strcmp(now-&gt;sym-&gt;name, "_") == 0
	||   strcmp(now-&gt;sym-&gt;name, "_pid") == 0
	||   strcmp(now-&gt;sym-&gt;name, "_last") == 0))
		return;

	v = t-&gt;Val[usage];
	for (u = v; u; u = u-&gt;nxt)
		if (u-&gt;var == now-&gt;sym)
			return;	/* it's already there */

	if (!now-&gt;lft)
	{	/* not for array vars -- it's hard to tell statically
		   if the index would, at runtime, evaluate to the
		   same values at lval and rval references
		*/
		if (use_free)
		{	u = use_free;
			use_free = use_free-&gt;nxt;
		} else
			u = (FSM_use *) emalloc(sizeof(FSM_use));
	
		u-&gt;var = now-&gt;sym;
		u-&gt;nxt = t-&gt;Val[usage];
		t-&gt;Val[usage] = u;
	} else
		 ana_stmnt(t, now-&gt;lft, RVAL);	/* index */

	if (now-&gt;sym-&gt;type == STRUCT
	&amp;&amp;  now-&gt;rgt
	&amp;&amp;  now-&gt;rgt-&gt;lft)
		ana_var(t, now-&gt;rgt-&gt;lft, usage);
}

static void
ana_stmnt(FSM_trans *t, Lextok *now, int usage)
{	Lextok *v;

	if (!t || !now) return;

	switch (now-&gt;ntyp) {
	case '.':
	case BREAK:
	case GOTO:
	case CONST:
	case TIMEOUT:
	case NONPROGRESS:
	case  ELSE:
	case '@':
	case 'q':
	case IF:
	case DO:
	case ATOMIC:
	case NON_ATOMIC:
	case D_STEP:
	case C_CODE:
	case C_EXPR:
		break;

	case '!':	
	case UMIN:
	case '~':
	case ENABLED:
	case PC_VAL:
	case LEN:
	case FULL:
	case EMPTY:
	case NFULL:
	case NEMPTY:
	case ASSERT:
	case 'c':
		ana_stmnt(t, now-&gt;lft, RVAL);
		break;

	case '/':
	case '*':
	case '-':
	case '+':
	case '%':
	case '&amp;':
	case '^':
	case '|':
	case LT:
	case GT:
	case LE:
	case GE:
	case NE:
	case EQ:
	case OR:
	case AND:
	case LSHIFT:
	case RSHIFT:
		ana_stmnt(t, now-&gt;lft, RVAL);
		ana_stmnt(t, now-&gt;rgt, RVAL);
		break;

	case ASGN:
		ana_stmnt(t, now-&gt;lft, LVAL);
		ana_stmnt(t, now-&gt;rgt, RVAL);
		break;

	case PRINT:
	case RUN:
		for (v = now-&gt;lft; v; v = v-&gt;rgt)
			ana_stmnt(t, v-&gt;lft, RVAL);
		break;

	case PRINTM:
		if (now-&gt;lft &amp;&amp; !now-&gt;lft-&gt;ismtyp)
			ana_stmnt(t, now-&gt;lft, RVAL);
		break;

	case 's':
		ana_stmnt(t, now-&gt;lft, RVAL);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
			ana_stmnt(t, v-&gt;lft, RVAL);
		break;

	case 'R':
	case 'r':
		ana_stmnt(t, now-&gt;lft, RVAL);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
		{	if (v-&gt;lft-&gt;ntyp == EVAL)
				ana_stmnt(t, v-&gt;lft-&gt;lft, RVAL);
			else
			if (v-&gt;lft-&gt;ntyp != CONST
			&amp;&amp;  now-&gt;ntyp != 'R')		/* was v-&gt;lft-&gt;ntyp */
				ana_stmnt(t, v-&gt;lft, LVAL);
		}
		break;

	case '?':
		ana_stmnt(t, now-&gt;lft, RVAL);
		if (now-&gt;rgt)
		{	ana_stmnt(t, now-&gt;rgt-&gt;lft, RVAL);
			ana_stmnt(t, now-&gt;rgt-&gt;rgt, RVAL);
		}
		break;

	case NAME:
		ana_var(t, now, usage);
		break;

	case   'p':	/* remote ref */
		ana_stmnt(t, now-&gt;lft-&gt;lft, RVAL);	/* process id */
		ana_var(t, now, RVAL);
		ana_var(t, now-&gt;rgt, RVAL);
		break;

	default:
		printf("spin: %s:%d, bad node type %d (ana_stmnt)\n",
			now-&gt;fn-&gt;name, now-&gt;ln, now-&gt;ntyp);
		fatal("aborting", (char *) 0);
	}
}

void
ana_src(int dataflow, int merger)	/* called from main.c and guided.c */
{	ProcList *p;
	Element *e;
#if 0
	int counter = 1;
#endif
	for (p = rdy; p; p = p-&gt;nxt)
	{
		ana_seq(p-&gt;s);
		fsm_table();

		e = p-&gt;s-&gt;frst;
#if 0
		if (dataflow || merger)
		{	printf("spin: %d, optimizing '%s'",
				counter++, p-&gt;n-&gt;name);
			fflush(stdout);
		}
#endif
		if (dataflow)
		{	FSM_ANA();
		}
		if (merger)
		{	FSM_MERGER(/* p-&gt;n-&gt;name */);
			huntele(e, e-&gt;status, -1)-&gt;merge_in = 1; /* start-state */
#if 0
			printf("\n");
#endif
		}
		if (export_ast)
			AST_store(p, huntele(e, e-&gt;status, -1)-&gt;seqno);

		FSM_DEL();
	}
	for (e = Al_El; e; e = e-&gt;Nxt)
	{
		if (!(e-&gt;status&amp;DONE) &amp;&amp; (verbose&amp;32))
		{	printf("unreachable code: ");
			printf("%s:%3d  ", e-&gt;n-&gt;fn-&gt;name, e-&gt;n-&gt;ln);
			comment(stdout, e-&gt;n, 0);
			printf("\n");
		}
		e-&gt;status &amp;= ~DONE;
	}
	if (export_ast)
	{	AST_slice();
		alldone(0);	/* changed in 5.3.0: was exit(0) */
	}
}

void
spit_recvs(FILE *f1, FILE *f2)	/* called from pangen2.c */
{	Element *e;
	Sequence *s;
	extern int Unique;

	fprintf(f1, "unsigned char Is_Recv[%d];\n", Unique);

	fprintf(f2, "void\nset_recvs(void)\n{\n");
	for (e = Al_El; e; e = e-&gt;Nxt)
	{	if (!e-&gt;n) continue;

		switch (e-&gt;n-&gt;ntyp) {
		case 'r':
markit:			fprintf(f2, "\tIs_Recv[%d] = 1;\n", e-&gt;Seqno);
			break;
		case D_STEP:
			s = e-&gt;n-&gt;sl-&gt;this;
			switch (s-&gt;frst-&gt;n-&gt;ntyp) {
			case DO:
				fatal("unexpected: do at start of d_step", (char *) 0);
			case IF: /* conservative: fall through */
			case 'r': goto markit;
			}
			break;
		}
	}
	fprintf(f2, "}\n");

	if (rvopt)
	{
	fprintf(f2, "int\nno_recvs(int me)\n{\n");
	fprintf(f2, "	int h; uchar ot; short tt;\n");
	fprintf(f2, "	Trans *t;\n");
	fprintf(f2, "	for (h = BASE; h &lt; (int) now._nr_pr; h++)\n");
	fprintf(f2, "	{	if (h == me) continue;\n");
	fprintf(f2, "		tt = (short) ((P0 *)pptr(h))-&gt;_p;\n");
	fprintf(f2, "		ot = (uchar) ((P0 *)pptr(h))-&gt;_t;\n");
	fprintf(f2, "		for (t = trans[ot][tt]; t; t = t-&gt;nxt)\n");
	fprintf(f2, "			if (Is_Recv[t-&gt;t_id]) return 0;\n");
	fprintf(f2, "	}\n");
	fprintf(f2, "	return 1;\n");
	fprintf(f2, "}\n");
	}
}

static void
ana_seq(Sequence *s)
{	SeqList *h;
	Sequence *t;
	Element *e, *g;
	int From, To;

	for (e = s-&gt;frst; e; e = e-&gt;nxt)
	{	if (e-&gt;status &amp; DONE)
			goto checklast;

		e-&gt;status |= DONE;

		From = e-&gt;seqno;

		if (e-&gt;n-&gt;ntyp == UNLESS)
			ana_seq(e-&gt;sub-&gt;this);
		else if (e-&gt;sub)
		{	for (h = e-&gt;sub; h; h = h-&gt;nxt)
			{	g = huntstart(h-&gt;this-&gt;frst);
				To = g-&gt;seqno;

				if (g-&gt;n-&gt;ntyp != 'c'
				||  g-&gt;n-&gt;lft-&gt;ntyp != CONST
				||  g-&gt;n-&gt;lft-&gt;val != 0
				||  g-&gt;esc)
					FSM_EDGE(From, To, e);
				/* else it's a dead link */
			}
			for (h = e-&gt;sub; h; h = h-&gt;nxt)
				ana_seq(h-&gt;this);
		} else if (e-&gt;n-&gt;ntyp == ATOMIC
			||  e-&gt;n-&gt;ntyp == D_STEP
			||  e-&gt;n-&gt;ntyp == NON_ATOMIC)
		{
			t = e-&gt;n-&gt;sl-&gt;this;
			g = huntstart(t-&gt;frst);
			t-&gt;last-&gt;nxt = e-&gt;nxt;
			To = g-&gt;seqno;
			FSM_EDGE(From, To, e);

			ana_seq(t);
		} else 
		{	if (e-&gt;n-&gt;ntyp == GOTO)
			{	g = get_lab(e-&gt;n, 1);
				g = huntele(g, e-&gt;status, -1);
				To = g-&gt;seqno;
			} else if (e-&gt;nxt)
			{	g = huntele(e-&gt;nxt, e-&gt;status, -1);
				To = g-&gt;seqno;
			} else
				To = 0;

			FSM_EDGE(From, To, e);

			if (e-&gt;esc
			&amp;&amp;  e-&gt;n-&gt;ntyp != GOTO
			&amp;&amp;  e-&gt;n-&gt;ntyp != '.')
			for (h = e-&gt;esc; h; h = h-&gt;nxt)
			{	g = huntstart(h-&gt;this-&gt;frst);
				To = g-&gt;seqno;
				FSM_EDGE(From, To, ZE);
				ana_seq(h-&gt;this);
			}
		}

checklast:	if (e == s-&gt;last)
			break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

