<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/pangen6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/pangen6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: pangen6.c *****/

/* Copyright (c) 2000-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

/* Abstract syntax tree analysis / slicing (spin option -A) */
/* AST_store stores the fsms's for each proctype            */
/* AST_track keeps track of variables used in properties    */
/* AST_slice starts the slicing algorithm                   */
/*      it first collects more info and then calls          */
/*      AST_criteria to process the slice criteria          */

#include "spin.h"
#include "y.tab.h"

extern Ordered	 *all_names;
extern FSM_use   *use_free;
extern FSM_state **fsm_tbl;
extern FSM_state *fsm;
extern int	 verbose, o_max;

static FSM_trans *cur_t;
static FSM_trans *expl_par;
static FSM_trans *expl_var;
static FSM_trans *explicit;

extern void rel_use(FSM_use *);

#define ulong	unsigned long

typedef struct Pair {
	FSM_state	*h;
	int		b;
	struct Pair	*nxt;
} Pair;

typedef struct AST {
	ProcList *p;		/* proctype decl */
	int	i_st;		/* start state */
	int	nstates, nwords;
	int	relevant;
	Pair	*pairs;		/* entry and exit nodes of proper subgraphs */
	FSM_state *fsm;		/* proctype body */
	struct AST *nxt;	/* linked list */
} AST;

typedef struct RPN {		/* relevant proctype names */
	Symbol	*rn;
	struct RPN *nxt;
} RPN;

typedef struct ALIAS {		/* channel aliasing info */
	Lextok	*cnm;		/* this chan */
	int	origin;		/* debugging - origin of the alias */
	struct ALIAS	*alias;	/* can be an alias for these other chans */
	struct ALIAS	*nxt;	/* linked list */
} ALIAS;

typedef struct ChanList {
	Lextok *s;		/* containing stmnt */
	Lextok *n;		/* point of reference - could be struct */
	struct ChanList *nxt;	/* linked list */
} ChanList;

/* a chan alias can be created in one of three ways:
	assignement to chan name
		a = b -- a is now an alias for b
	passing chan name as parameter in run
		run x(b) -- proctype x(chan a)
	passing chan name through channel
		x!b -- x?a
 */

#define USE		1
#define DEF		2
#define DEREF_DEF	4
#define DEREF_USE	8

static AST	*ast;
static ALIAS	*chalcur;
static ALIAS	*chalias;
static ChanList	*chanlist;
static Slicer	*slicer;
static Slicer	*rel_vars;	/* all relevant variables */
static int	AST_Changes;
static int	AST_Round;
static RPN	*rpn;
static int	in_recv = 0;

static int	AST_mutual(Lextok *, Lextok *, int);
static void	AST_dominant(void);
static void	AST_hidden(void);
static void	AST_setcur(Lextok *);
static void	check_slice(Lextok *, int);
static void	curtail(AST *);
static void	def_use(Lextok *, int);
static void	name_AST_track(Lextok *, int);
static void	show_expl(void);

static int
AST_isini(Lextok *n)	/* is this an initialized channel */
{	Symbol *s;

	if (!n || !n-&gt;sym) return 0;

	s = n-&gt;sym;

	if (s-&gt;type == CHAN)
		return (s-&gt;ini-&gt;ntyp == CHAN); /* freshly instantiated */

	if (s-&gt;type == STRUCT &amp;&amp; n-&gt;rgt)
		return AST_isini(n-&gt;rgt-&gt;lft);

	return 0;
}

static void
AST_var(Lextok *n, Symbol *s, int toplevel)
{
	if (!s) return;

	if (toplevel)
	{	if (s-&gt;context &amp;&amp; s-&gt;type)
			printf(":%s:L:", s-&gt;context-&gt;name);
		else
			printf("G:");
	}
	printf("%s", s-&gt;name); /* array indices ignored */

	if (s-&gt;type == STRUCT &amp;&amp; n &amp;&amp; n-&gt;rgt &amp;&amp; n-&gt;rgt-&gt;lft)
	{	printf(":");
		AST_var(n-&gt;rgt-&gt;lft, n-&gt;rgt-&gt;lft-&gt;sym, 0);
	}
}

static void
name_def_indices(Lextok *n, int code)
{
	if (!n || !n-&gt;sym) return;

	if (n-&gt;sym-&gt;nel &gt; 1 || n-&gt;sym-&gt;isarray)
		def_use(n-&gt;lft, code);		/* process the index */

	if (n-&gt;sym-&gt;type == STRUCT		/* and possible deeper ones */
	&amp;&amp;  n-&gt;rgt)
		name_def_indices(n-&gt;rgt-&gt;lft, code);
}

static void
name_def_use(Lextok *n, int code)
{	FSM_use *u;

	if (!n) return;

	if ((code&amp;USE)
	&amp;&amp;  cur_t-&gt;step
	&amp;&amp;  cur_t-&gt;step-&gt;n)
	{	switch (cur_t-&gt;step-&gt;n-&gt;ntyp) {
		case 'c': /* possible predicate abstraction? */
			n-&gt;sym-&gt;colnr |= 2; /* yes */
			break;
		default:
			n-&gt;sym-&gt;colnr |= 1; /* no  */
			break;
		}
	}

	for (u = cur_t-&gt;Val[0]; u; u = u-&gt;nxt)
		if (AST_mutual(n, u-&gt;n, 1)
		&amp;&amp;  u-&gt;special == code)
			return;

	if (use_free)
	{	u = use_free;
		use_free = use_free-&gt;nxt;
	} else
		u = (FSM_use *) emalloc(sizeof(FSM_use));
	
	u-&gt;n = n;
	u-&gt;special = code;
	u-&gt;nxt = cur_t-&gt;Val[0];
	cur_t-&gt;Val[0] = u;

	name_def_indices(n, USE|(code&amp;(~DEF)));	/* not def, but perhaps deref */
}

static void
def_use(Lextok *now, int code)
{	Lextok *v;

	if (now)
	switch (now-&gt;ntyp) {
	case '!':	
	case UMIN:	
	case '~':
	case 'c':
	case ENABLED:
	case ASSERT:
	case EVAL:
		def_use(now-&gt;lft, USE|code);
		break;

	case LEN:
	case FULL:
	case EMPTY:
	case NFULL:
	case NEMPTY:
		def_use(now-&gt;lft, DEREF_USE|USE|code);
		break;

	case '/':
	case '*':
	case '-':
	case '+':
	case '%':
	case '&amp;':
	case '^':
	case '|':
	case LE:
	case GE:
	case GT:
	case LT:
	case NE:
	case EQ:
	case OR:
	case AND:
	case LSHIFT:
	case RSHIFT:
		def_use(now-&gt;lft, USE|code);
		def_use(now-&gt;rgt, USE|code); 
		break;

	case ASGN:
		def_use(now-&gt;lft, DEF|code);
		def_use(now-&gt;rgt, USE|code);
		break;

	case TYPE:	/* name in parameter list */
		name_def_use(now, code);
		break;

	case NAME:
		name_def_use(now, code);
		break;

	case RUN:
		name_def_use(now, USE);			/* procname - not really needed */
		for (v = now-&gt;lft; v; v = v-&gt;rgt)
			def_use(v-&gt;lft, USE);		/* params */
		break;

	case 's':
		def_use(now-&gt;lft, DEREF_DEF|DEREF_USE|USE|code);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
			def_use(v-&gt;lft, USE|code);
		break;

	case 'r':
		def_use(now-&gt;lft, DEREF_DEF|DEREF_USE|USE|code);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
		{	if (v-&gt;lft-&gt;ntyp == EVAL)
				def_use(v-&gt;lft, code);	/* will add USE */
			else if (v-&gt;lft-&gt;ntyp != CONST)
				def_use(v-&gt;lft, DEF|code);
		}
		break;

	case 'R':
		def_use(now-&gt;lft, DEREF_USE|USE|code);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
		{	if (v-&gt;lft-&gt;ntyp == EVAL)
				def_use(v-&gt;lft, code); /* will add USE */
		}
		break;

	case '?':
		def_use(now-&gt;lft, USE|code);
		if (now-&gt;rgt)
		{	def_use(now-&gt;rgt-&gt;lft, code);
			def_use(now-&gt;rgt-&gt;rgt, code);
		}
		break;	

	case PRINT:
		for (v = now-&gt;lft; v; v = v-&gt;rgt)
			def_use(v-&gt;lft, USE|code);
		break;

	case PRINTM:
		def_use(now-&gt;lft, USE);
		break;

	case CONST:
	case ELSE:	/* ? */
	case NONPROGRESS:
	case PC_VAL:
	case   'p':
	case   'q':
		break;

	case   '.':
	case  GOTO:
	case BREAK:
	case   '@':
	case D_STEP:
	case ATOMIC:
	case NON_ATOMIC:
	case IF:
	case DO:
	case UNLESS:
	case TIMEOUT:
	case C_CODE:
	case C_EXPR:
	default:
		break;
	}
}

static int
AST_add_alias(Lextok *n, int nr)
{	ALIAS *ca;
	int res;

	for (ca = chalcur-&gt;alias; ca; ca = ca-&gt;nxt)
		if (AST_mutual(ca-&gt;cnm, n, 1))
		{	res = (ca-&gt;origin&amp;nr);
			ca-&gt;origin |= nr;	/* 1, 2, or 4 - run, asgn, or rcv */
			return (res == 0);	/* 0 if already there with same origin */
		}

	ca = (ALIAS *) emalloc(sizeof(ALIAS));
	ca-&gt;cnm = n;
	ca-&gt;origin = nr;
	ca-&gt;nxt = chalcur-&gt;alias;
	chalcur-&gt;alias = ca;
	return 1;
}

static void
AST_run_alias(char *pn, char *s, Lextok *t, int parno)
{	Lextok *v;
	int cnt;

	if (!t) return;

	if (t-&gt;ntyp == RUN)
	{	if (strcmp(t-&gt;sym-&gt;name, s) == 0)
		for (v = t-&gt;lft, cnt = 1; v; v = v-&gt;rgt, cnt++)
			if (cnt == parno)
			{	AST_add_alias(v-&gt;lft, 1); /* RUN */
				break;
			}
	} else
	{	AST_run_alias(pn, s, t-&gt;lft, parno);
		AST_run_alias(pn, s, t-&gt;rgt, parno);
	}
}

static void
AST_findrun(char *s, int parno)
{	FSM_state *f;
	FSM_trans *t;
	AST *a;

	for (a = ast; a; a = a-&gt;nxt)		/* automata       */
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)		/* control states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* transitions    */
	{	if (t-&gt;step)
		AST_run_alias(a-&gt;p-&gt;n-&gt;name, s, t-&gt;step-&gt;n, parno);
	}
}

static void
AST_par_chans(ProcList *p)	/* find local chan's init'd to chan passed as param */
{	Ordered	*walk;
	Symbol	*sp;

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (sp
		&amp;&amp;  sp-&gt;context
		&amp;&amp;  strcmp(sp-&gt;context-&gt;name, p-&gt;n-&gt;name) == 0
		&amp;&amp;  sp-&gt;Nid &gt;= 0	/* not itself a param */
		&amp;&amp;  sp-&gt;type == CHAN
		&amp;&amp;  sp-&gt;ini-&gt;ntyp == NAME)	/* != CONST and != CHAN */
		{	Lextok *x = nn(ZN, 0, ZN, ZN);
			x-&gt;sym = sp;
			AST_setcur(x);
			AST_add_alias(sp-&gt;ini, 2);	/* ASGN */
	}	}
}

static void
AST_para(ProcList *p)
{	Lextok *f, *t, *c;
	int cnt = 0;

	AST_par_chans(p);

	for (f = p-&gt;p; f; f = f-&gt;rgt) 		/* list of types */
	for (t = f-&gt;lft; t; t = t-&gt;rgt)
	{	if (t-&gt;ntyp != ',')
			c = t;
		else
			c = t-&gt;lft;	/* expanded struct */

		cnt++;
		if (Sym_typ(c) == CHAN)
		{	ALIAS *na = (ALIAS *) emalloc(sizeof(ALIAS));

			na-&gt;cnm = c;
			na-&gt;nxt = chalias;
			chalcur = chalias = na;
#if 0
			printf("%s -- (par) -- ", p-&gt;n-&gt;name);
			AST_var(c, c-&gt;sym, 1);
			printf(" =&gt; &lt;&lt;");
#endif
			AST_findrun(p-&gt;n-&gt;name, cnt);
#if 0
			printf("&gt;&gt;\n");
#endif
		}
	}
}

static void
AST_haschan(Lextok *c)
{
	if (!c) return;
	if (Sym_typ(c) == CHAN)
	{	AST_add_alias(c, 2);	/* ASGN */
#if 0
		printf("&lt;&lt;");
		AST_var(c, c-&gt;sym, 1);
		printf("&gt;&gt;\n");
#endif
	} else
	{	AST_haschan(c-&gt;rgt);
		AST_haschan(c-&gt;lft);
	}
}

static int
AST_nrpar(Lextok *n) /* 's' or 'r' */
{	Lextok *m;
	int j = 0;

	for (m = n-&gt;rgt; m; m = m-&gt;rgt)
		j++;
	return j;
}

static int
AST_ord(Lextok *n, Lextok *s)
{	Lextok *m;
	int j = 0;

	for (m = n-&gt;rgt; m; m = m-&gt;rgt)
	{	j++;
		if (s-&gt;sym == m-&gt;lft-&gt;sym)
			return j;
	}
	return 0;
}

#if 0
static void
AST_ownership(Symbol *s)
{
	if (!s) return;
	printf("%s:", s-&gt;name);
	AST_ownership(s-&gt;owner);
}
#endif

static int
AST_mutual(Lextok *a, Lextok *b, int toplevel)
{	Symbol *as, *bs;

	if (!a &amp;&amp; !b) return 1;

	if (!a || !b) return 0;

	as = a-&gt;sym;
	bs = b-&gt;sym;

	if (!as || !bs) return 0;

	if (toplevel &amp;&amp; as-&gt;context != bs-&gt;context)
		return 0;

	if (as-&gt;type != bs-&gt;type)
		return 0;

	if (strcmp(as-&gt;name, bs-&gt;name) != 0)
		return 0;

	if (as-&gt;type == STRUCT &amp;&amp; a-&gt;rgt &amp;&amp; b-&gt;rgt)	/* we know that a and b are not null */
		return AST_mutual(a-&gt;rgt-&gt;lft, b-&gt;rgt-&gt;lft, 0);

	return 1;
}

static void
AST_setcur(Lextok *n)	/* set chalcur */
{	ALIAS *ca;

	for (ca = chalias; ca; ca = ca-&gt;nxt)
		if (AST_mutual(ca-&gt;cnm, n, 1))	/* if same chan */
		{	chalcur = ca;
			return;
		}

	ca = (ALIAS *) emalloc(sizeof(ALIAS));
	ca-&gt;cnm = n;
	ca-&gt;nxt = chalias;
	chalcur = chalias = ca;
}

static void
AST_other(AST *a)	/* check chan params in asgns and recvs */
{	FSM_state *f;
	FSM_trans *t;
	FSM_use *u;
	ChanList *cl;

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)		/* control states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* transitions    */
	for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)	/* def/use info   */
		if (Sym_typ(u-&gt;n) == CHAN
		&amp;&amp;  (u-&gt;special&amp;DEF))		/* def of chan-name  */
		{	AST_setcur(u-&gt;n);
			switch (t-&gt;step-&gt;n-&gt;ntyp) {
			case ASGN:
				AST_haschan(t-&gt;step-&gt;n-&gt;rgt);
				break;
			case 'r':
				/* guess sends where name may originate */
				for (cl = chanlist; cl; cl = cl-&gt;nxt)	/* all sends */
				{	int aa = AST_nrpar(cl-&gt;s);
					int bb = AST_nrpar(t-&gt;step-&gt;n);
					if (aa != bb)	/* matching nrs of params */
						continue;

					aa = AST_ord(cl-&gt;s, cl-&gt;n);
					bb = AST_ord(t-&gt;step-&gt;n, u-&gt;n);
					if (aa != bb)	/* same position in parlist */
						continue;

					AST_add_alias(cl-&gt;n, 4); /* RCV assume possible match */
				}
				break;
			default:
				printf("type = %d\n", t-&gt;step-&gt;n-&gt;ntyp);
				non_fatal("unexpected chan def type", (char *) 0);
				break;
		}	}
}

static void
AST_aliases(void)
{	ALIAS *na, *ca;

	for (na = chalias; na; na = na-&gt;nxt)
	{	printf("\npossible aliases of ");
		AST_var(na-&gt;cnm, na-&gt;cnm-&gt;sym, 1);
		printf("\n\t");
		for (ca = na-&gt;alias; ca; ca = ca-&gt;nxt)
		{	if (!ca-&gt;cnm-&gt;sym)
				printf("no valid name ");
			else
				AST_var(ca-&gt;cnm, ca-&gt;cnm-&gt;sym, 1);
			printf("&lt;");
			if (ca-&gt;origin &amp; 1) printf("RUN ");
			if (ca-&gt;origin &amp; 2) printf("ASGN ");
			if (ca-&gt;origin &amp; 4) printf("RCV ");
			printf("[%s]", AST_isini(ca-&gt;cnm)?"Initzd":"Name");
			printf("&gt;");
			if (ca-&gt;nxt) printf(", ");
		}
		printf("\n");
	}
	printf("\n");
}

static void
AST_indirect(FSM_use *uin, FSM_trans *t, char *cause, char *pn)
{	FSM_use *u;

	/* this is a newly discovered relevant statement */
	/* all vars it uses to contribute to its DEF are new criteria */

	if (!(t-&gt;relevant&amp;1)) AST_Changes++;

	t-&gt;round = AST_Round;
	t-&gt;relevant = 1;

	if ((verbose&amp;32) &amp;&amp; t-&gt;step)
	{	printf("\tDR %s [[ ", pn);
		comment(stdout, t-&gt;step-&gt;n, 0);
		printf("]]\n\t\tfully relevant %s", cause);
		if (uin) { printf(" due to "); AST_var(uin-&gt;n, uin-&gt;n-&gt;sym, 1); }
		printf("\n");
	}
	for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
		if (u != uin
		&amp;&amp; (u-&gt;special&amp;(USE|DEREF_USE)))
		{	if (verbose&amp;32)
			{	printf("\t\t\tuses(%d): ", u-&gt;special);
				AST_var(u-&gt;n, u-&gt;n-&gt;sym, 1);
				printf("\n");
			}
			name_AST_track(u-&gt;n, u-&gt;special);	/* add to slice criteria */
		}
}

static void
def_relevant(char *pn, FSM_trans *t, Lextok *n, int ischan)
{	FSM_use *u;
	ALIAS *na, *ca;
	int chanref;

	/* look for all DEF's of n
	 *	mark those stmnts relevant
	 *	mark all var USEs in those stmnts as criteria
	 */

	if (n-&gt;ntyp != ELSE)
	for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
	{	chanref = (Sym_typ(u-&gt;n) == CHAN);

		if (ischan != chanref			/* no possible match  */
		|| !(u-&gt;special&amp;(DEF|DEREF_DEF)))	/* not a def */
			continue;

		if (AST_mutual(u-&gt;n, n, 1))
		{	AST_indirect(u, t, "(exact match)", pn);
			continue;
		}

		if (chanref)
		for (na = chalias; na; na = na-&gt;nxt)
		{	if (!AST_mutual(u-&gt;n, na-&gt;cnm, 1))
				continue;
			for (ca = na-&gt;alias; ca; ca = ca-&gt;nxt)
				if (AST_mutual(ca-&gt;cnm, n, 1)
				&amp;&amp;  AST_isini(ca-&gt;cnm))	
				{	AST_indirect(u, t, "(alias match)", pn);
					break;
				}
			if (ca) break;
	}	}	
}

static void
AST_relevant(Lextok *n)
{	AST *a;
	FSM_state *f;
	FSM_trans *t;
	int ischan;

	/* look for all DEF's of n
	 *	mark those stmnts relevant
	 *	mark all var USEs in those stmnts as criteria
	 */

	if (!n) return;
	ischan = (Sym_typ(n) == CHAN);

	if (verbose&amp;32)
	{	printf("&lt;&lt;ast_relevant (ntyp=%d) ", n-&gt;ntyp);
		AST_var(n, n-&gt;sym, 1);
		printf("&gt;&gt;\n");
	}

	for (t = expl_par; t; t = t-&gt;nxt)	/* param assignments */
	{	if (!(t-&gt;relevant&amp;1))
		def_relevant(":params:", t, n, ischan);
	}

	for (t = expl_var; t; t = t-&gt;nxt)
	{	if (!(t-&gt;relevant&amp;1))		/* var inits */
		def_relevant(":vars:", t, n, ischan);
	}

	for (a = ast; a; a = a-&gt;nxt)		/* all other stmnts */
	{	if (a-&gt;p-&gt;b != N_CLAIM &amp;&amp; a-&gt;p-&gt;b != E_TRACE &amp;&amp; a-&gt;p-&gt;b != N_TRACE)
		for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		for (t = f-&gt;t; t; t = t-&gt;nxt)
		{	if (!(t-&gt;relevant&amp;1))
			def_relevant(a-&gt;p-&gt;n-&gt;name, t, n, ischan);
	}	}
}

static int
AST_relpar(char *s)
{	FSM_trans *t, *T;
	FSM_use *u;

	for (T = expl_par; T; T = (T == expl_par)?expl_var: (FSM_trans *) 0)
	for (t = T; t; t = t-&gt;nxt)
	{	if (t-&gt;relevant&amp;1)
		for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
		{	if (u-&gt;n-&gt;sym-&gt;type
			&amp;&amp;  u-&gt;n-&gt;sym-&gt;context
			&amp;&amp;  strcmp(u-&gt;n-&gt;sym-&gt;context-&gt;name, s) == 0)
			{
				if (verbose&amp;32)
				{	printf("proctype %s relevant, due to symbol ", s);
					AST_var(u-&gt;n, u-&gt;n-&gt;sym, 1);
					printf("\n");
				}
				return 1;
	}	}	}
	return 0;
}

static void
AST_dorelevant(void)
{	AST *a;
	RPN *r;

	for (r = rpn; r; r = r-&gt;nxt)
	{	for (a = ast; a; a = a-&gt;nxt)
			if (strcmp(a-&gt;p-&gt;n-&gt;name, r-&gt;rn-&gt;name) == 0)
			{	a-&gt;relevant |= 1;
				break;
			}
		if (!a)
		fatal("cannot find proctype %s", r-&gt;rn-&gt;name);
	}		
}

static void
AST_procisrelevant(Symbol *s)
{	RPN *r;
	for (r = rpn; r; r = r-&gt;nxt)
		if (strcmp(r-&gt;rn-&gt;name, s-&gt;name) == 0)
			return;
	r = (RPN *) emalloc(sizeof(RPN));
	r-&gt;rn = s;
	r-&gt;nxt = rpn;
	rpn = r;
}

static int
AST_proc_isrel(char *s)
{	AST *a;

	for (a = ast; a; a = a-&gt;nxt)
		if (strcmp(a-&gt;p-&gt;n-&gt;name, s) == 0)
			return (a-&gt;relevant&amp;1);
	non_fatal("cannot happen, missing proc in ast", (char *) 0);
	return 0;
}

static int
AST_scoutrun(Lextok *t)
{
	if (!t) return 0;

	if (t-&gt;ntyp == RUN)
		return AST_proc_isrel(t-&gt;sym-&gt;name);
	return (AST_scoutrun(t-&gt;lft) || AST_scoutrun(t-&gt;rgt));
}

static void
AST_tagruns(void)
{	AST *a;
	FSM_state *f;
	FSM_trans *t;

	/* if any stmnt inside a proctype is relevant
	 * or any parameter passed in a run
	 * then so are all the run statements on that proctype
	 */

	for (a = ast; a; a = a-&gt;nxt)
	{	if (a-&gt;p-&gt;b == N_CLAIM || a-&gt;p-&gt;b == I_PROC
		||  a-&gt;p-&gt;b == E_TRACE || a-&gt;p-&gt;b == N_TRACE)
		{	a-&gt;relevant |= 1;	/* the proctype is relevant */
			continue;
		}
		if (AST_relpar(a-&gt;p-&gt;n-&gt;name))
			a-&gt;relevant |= 1;
		else
		{	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
			for (t = f-&gt;t; t; t = t-&gt;nxt)
				if (t-&gt;relevant)
					goto yes;
yes:			if (f)
				a-&gt;relevant |= 1;
		}
	}

	for (a = ast; a; a = a-&gt;nxt)
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	for (t = f-&gt;t; t; t = t-&gt;nxt)
		if (t-&gt;step
		&amp;&amp;  AST_scoutrun(t-&gt;step-&gt;n))
		{	AST_indirect((FSM_use *)0, t, ":run:", a-&gt;p-&gt;n-&gt;name);
			/* BUT, not all actual params are relevant */
		}
}

static void
AST_report(AST *a, Element *e)	/* ALSO deduce irrelevant vars */
{
	if (!(a-&gt;relevant&amp;2))
	{	a-&gt;relevant |= 2;
		printf("spin: redundant in proctype %s (for given property):\n",
			a-&gt;p-&gt;n-&gt;name);
	}
	printf("      %s:%d (state %d)",
		e-&gt;n?e-&gt;n-&gt;fn-&gt;name:"-",
		e-&gt;n?e-&gt;n-&gt;ln:-1,
		e-&gt;seqno);
	printf("	[");
	comment(stdout, e-&gt;n, 0);
	printf("]\n");
}

static int
AST_always(Lextok *n)
{
	if (!n) return 0;

	if (n-&gt;ntyp == '@'	/* -end */
	||  n-&gt;ntyp == 'p')	/* remote reference */
		return 1;
	return AST_always(n-&gt;lft) || AST_always(n-&gt;rgt);
}

static void
AST_edge_dump(AST *a, FSM_state *f)
{	FSM_trans *t;
	FSM_use *u;

	for (t = f-&gt;t; t; t = t-&gt;nxt)	/* edges */
	{
		if (t-&gt;step &amp;&amp; AST_always(t-&gt;step-&gt;n))
			t-&gt;relevant |= 1;	/* always relevant */

		if (verbose&amp;32)
		{	switch (t-&gt;relevant) {
			case  0: printf("     "); break;
			case  1: printf("*%3d ", t-&gt;round); break;
			case  2: printf("+%3d ", t-&gt;round); break;
			case  3: printf("#%3d ", t-&gt;round); break;
			default: printf("? "); break;
			}
	
			printf("%d\t-&gt;\t%d\t", f-&gt;from, t-&gt;to);
			if (t-&gt;step)
				comment(stdout, t-&gt;step-&gt;n, 0);
			else
				printf("Unless");
	
			for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
			{	printf(" &lt;");
				AST_var(u-&gt;n, u-&gt;n-&gt;sym, 1);
				printf(":%d&gt;", u-&gt;special);
			}
			printf("\n");
		} else
		{	if (t-&gt;relevant)
				continue;

			if (t-&gt;step)
			switch(t-&gt;step-&gt;n-&gt;ntyp) {
			case ASGN:
			case 's':
			case 'r':
			case 'c':
				if (t-&gt;step-&gt;n-&gt;lft-&gt;ntyp != CONST)
					AST_report(a, t-&gt;step);
				break;

			case PRINT:	/* don't report */
			case PRINTM:
			case ASSERT:
			case C_CODE:
			case C_EXPR:
			default:
				break;
	}	}	}
}

static void
AST_dfs(AST *a, int s, int vis)
{	FSM_state *f;
	FSM_trans *t;

	f = fsm_tbl[s];
	if (f-&gt;seen) return;

	f-&gt;seen = 1;
	if (vis) AST_edge_dump(a, f);

	for (t = f-&gt;t; t; t = t-&gt;nxt)
		AST_dfs(a, t-&gt;to, vis);
}

static void
AST_dump(AST *a)
{	FSM_state *f;

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	f-&gt;seen = 0;
		fsm_tbl[f-&gt;from] = f;
	}

	if (verbose&amp;32)
		printf("AST_START %s from %d\n", a-&gt;p-&gt;n-&gt;name, a-&gt;i_st);

	AST_dfs(a, a-&gt;i_st, 1);
}

static void
AST_sends(AST *a)
{	FSM_state *f;
	FSM_trans *t;
	FSM_use *u;
	ChanList *cl;

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)		/* control states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* transitions    */
	{	if (t-&gt;step
		&amp;&amp;  t-&gt;step-&gt;n
		&amp;&amp;  t-&gt;step-&gt;n-&gt;ntyp == 's')
		for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
		{	if (Sym_typ(u-&gt;n) == CHAN
			&amp;&amp;  ((u-&gt;special&amp;USE) &amp;&amp; !(u-&gt;special&amp;DEREF_USE)))
			{
#if 0
				printf("%s -- (%d-&gt;%d) -- ",
					a-&gt;p-&gt;n-&gt;name, f-&gt;from, t-&gt;to);
				AST_var(u-&gt;n, u-&gt;n-&gt;sym, 1);
				printf(" -&gt; chanlist\n");
#endif
				cl = (ChanList *) emalloc(sizeof(ChanList));
				cl-&gt;s = t-&gt;step-&gt;n;
				cl-&gt;n = u-&gt;n;
				cl-&gt;nxt = chanlist;
				chanlist = cl;
}	}	}	}

static ALIAS *
AST_alfind(Lextok *n)
{	ALIAS *na;

	for (na = chalias; na; na = na-&gt;nxt)
		if (AST_mutual(na-&gt;cnm, n, 1))
			return na;
	return (ALIAS *) 0;
}

static void
AST_trans(void)
{	ALIAS *na, *ca, *da, *ea;
	int nchanges;

	do {
		nchanges = 0;
		for (na = chalias; na; na = na-&gt;nxt)
		{	chalcur = na;
			for (ca = na-&gt;alias; ca; ca = ca-&gt;nxt)
			{	da = AST_alfind(ca-&gt;cnm);
				if (da)
				for (ea = da-&gt;alias; ea; ea = ea-&gt;nxt)
				{	nchanges += AST_add_alias(ea-&gt;cnm,
							ea-&gt;origin|ca-&gt;origin);
		}	}	}
	} while (nchanges &gt; 0);

	chalcur = (ALIAS *) 0;
}

static void
AST_def_use(AST *a)
{	FSM_state *f;
	FSM_trans *t;

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)		/* control states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* all edges */
	{	cur_t = t;
		rel_use(t-&gt;Val[0]);		/* redo Val; doesn't cover structs */
		rel_use(t-&gt;Val[1]);
		t-&gt;Val[0] = t-&gt;Val[1] = (FSM_use *) 0;

		if (!t-&gt;step) continue;

		def_use(t-&gt;step-&gt;n, 0);		/* def/use info, including structs */
	}
	cur_t = (FSM_trans *) 0;
}

static void
name_AST_track(Lextok *n, int code)
{	extern int nr_errs;
#if 0
	printf("AST_name: ");
	AST_var(n, n-&gt;sym, 1);
	printf(" -- %d\n", code);
#endif
	if (in_recv &amp;&amp; (code&amp;DEF) &amp;&amp; (code&amp;USE))
	{	printf("spin: error: DEF and USE of same var in rcv stmnt: ");
		AST_var(n, n-&gt;sym, 1);
		printf(" -- %d\n", code);
		nr_errs++;
	}
	check_slice(n, code);
}

void
AST_track(Lextok *now, int code)	/* called from main.c */
{	Lextok *v; extern int export_ast;

	if (!export_ast) return;

	if (now)
	switch (now-&gt;ntyp) {
	case LEN:
	case FULL:
	case EMPTY:
	case NFULL:
	case NEMPTY:
		AST_track(now-&gt;lft, DEREF_USE|USE|code);
		break;

	case '/':
	case '*':
	case '-':
	case '+':
	case '%':
	case '&amp;':
	case '^':
	case '|':
	case LE:
	case GE:
	case GT:
	case LT:
	case NE:
	case EQ:
	case OR:
	case AND:
	case LSHIFT:
	case RSHIFT:
		AST_track(now-&gt;rgt, USE|code);
		/* fall through */
	case '!':	
	case UMIN:	
	case '~':
	case 'c':
	case ENABLED:
	case ASSERT:
		AST_track(now-&gt;lft, USE|code);
		break;

	case EVAL:
		AST_track(now-&gt;lft, USE|(code&amp;(~DEF)));
		break;

	case NAME:
		name_AST_track(now, code);
		if (now-&gt;sym-&gt;nel &gt; 1 || now-&gt;sym-&gt;isarray)
			AST_track(now-&gt;lft, USE|code);	/* index */
		break;

	case 'R':
		AST_track(now-&gt;lft, DEREF_USE|USE|code);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
			AST_track(v-&gt;lft, code); /* a deeper eval can add USE */
		break;

	case '?':
		AST_track(now-&gt;lft, USE|code);
		if (now-&gt;rgt)
		{	AST_track(now-&gt;rgt-&gt;lft, code);
			AST_track(now-&gt;rgt-&gt;rgt, code);
		}
		break;

/* added for control deps: */
	case TYPE:	
		name_AST_track(now, code);
		break;
	case ASGN:
		AST_track(now-&gt;lft, DEF|code);
		AST_track(now-&gt;rgt, USE|code);
		break;
	case RUN:
		name_AST_track(now, USE);
		for (v = now-&gt;lft; v; v = v-&gt;rgt)
			AST_track(v-&gt;lft, USE|code);
		break;
	case 's':
		AST_track(now-&gt;lft, DEREF_DEF|DEREF_USE|USE|code);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
			AST_track(v-&gt;lft, USE|code);
		break;
	case 'r':
		AST_track(now-&gt;lft, DEREF_DEF|DEREF_USE|USE|code);
		for (v = now-&gt;rgt; v; v = v-&gt;rgt)
		{	in_recv++;
			AST_track(v-&gt;lft, DEF|code);
			in_recv--;
		}
		break;
	case PRINT:
		for (v = now-&gt;lft; v; v = v-&gt;rgt)
			AST_track(v-&gt;lft, USE|code);
		break;
	case PRINTM:
		AST_track(now-&gt;lft, USE);
		break;
/* end add */
	case   'p':
#if 0
			   'p' -sym-&gt; _p
			   /
			 '?' -sym-&gt; a (proctype)
			 /
			b (pid expr)
#endif
		AST_track(now-&gt;lft-&gt;lft, USE|code);
		AST_procisrelevant(now-&gt;lft-&gt;sym);
		break;

	case CONST:
	case ELSE:
	case NONPROGRESS:
	case PC_VAL:
	case   'q':
		break;

	case   '.':
	case  GOTO:
	case BREAK:
	case   '@':
	case D_STEP:
	case ATOMIC:
	case NON_ATOMIC:
	case IF:
	case DO:
	case UNLESS:
	case TIMEOUT:
	case C_CODE:
	case C_EXPR:
		break;

	default:
		printf("AST_track, NOT EXPECTED ntyp: %d\n", now-&gt;ntyp);
		break;
	}
}

static int
AST_dump_rel(void)
{	Slicer *rv;
	Ordered *walk;
	char buf[64];
	int banner=0;

	if (verbose&amp;32)
	{	printf("Relevant variables:\n");
		for (rv = rel_vars; rv; rv = rv-&gt;nxt)
		{	printf("\t");
			AST_var(rv-&gt;n, rv-&gt;n-&gt;sym, 1);
			printf("\n");
		}
		return 1;
	}
	for (rv = rel_vars; rv; rv = rv-&gt;nxt)
		rv-&gt;n-&gt;sym-&gt;setat = 1;	/* mark it */

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	Symbol *s;
		s = walk-&gt;entry;
		if (!s-&gt;setat
		&amp;&amp;  (s-&gt;type != MTYPE || s-&gt;ini-&gt;ntyp != CONST)
		&amp;&amp;  s-&gt;type != STRUCT	/* report only fields */
		&amp;&amp;  s-&gt;type != PROCTYPE
		&amp;&amp;  !s-&gt;owner
		&amp;&amp;  sputtype(buf, s-&gt;type))
		{	if (!banner)
			{	banner = 1;
				printf("spin: redundant vars (for given property):\n");
			}
			printf("\t");
			symvar(s);
	}	}
	return banner;
}

static void
AST_suggestions(void)
{	Symbol *s;
	Ordered *walk;
	FSM_state *f;
	FSM_trans *t;
	AST *a;
	int banner=0;
	int talked=0;

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	s = walk-&gt;entry;
		if (s-&gt;colnr == 2	/* only used in conditionals */
		&amp;&amp;  (s-&gt;type == BYTE
		||   s-&gt;type == SHORT
		||   s-&gt;type == INT
		||   s-&gt;type == MTYPE))
		{	if (!banner)
			{	banner = 1;
				printf("spin: consider using predicate");
				printf(" abstraction to replace:\n");
			}
			printf("\t");
			symvar(s);
	}	}

	/* look for source and sink processes */

	for (a = ast; a; a = a-&gt;nxt)		/* automata       */
	{	banner = 0;
		for (f = a-&gt;fsm; f; f = f-&gt;nxt)	/* control states */
		for (t = f-&gt;t; t; t = t-&gt;nxt)	/* transitions    */
		{	if (t-&gt;step)
			switch (t-&gt;step-&gt;n-&gt;ntyp) {
			case 's':
				banner |= 1;
				break;
			case 'r':
				banner |= 2;
				break;
			case '.':
			case D_STEP:
			case ATOMIC:
			case NON_ATOMIC:
			case IF:
			case DO:
			case UNLESS:
			case '@':
			case GOTO:
			case BREAK:
			case PRINT:
			case PRINTM:
			case ASSERT:
			case C_CODE:
			case C_EXPR:
				break;
			default:
				banner |= 4;
				goto no_good;
			}
		}
no_good:	if (banner == 1 || banner == 2)
		{	printf("spin: proctype %s defines a %s process\n",
				a-&gt;p-&gt;n-&gt;name,
				banner==1?"source":"sink");
			talked |= banner;
		} else if (banner == 3)
		{	printf("spin: proctype %s mimics a buffer\n",
				a-&gt;p-&gt;n-&gt;name);
			talked |= 4;
		}
	}
	if (talked&amp;1)
	{	printf("\tto reduce complexity, consider merging the code of\n");
		printf("\teach source process into the code of its target\n");
	}
	if (talked&amp;2)
	{	printf("\tto reduce complexity, consider merging the code of\n");
		printf("\teach sink process into the code of its source\n");
	}
	if (talked&amp;4)
		printf("\tto reduce complexity, avoid buffer processes\n");
}

static void
AST_preserve(void)
{	Slicer *sc, *nx, *rv;

	for (sc = slicer; sc; sc = nx)
	{	if (!sc-&gt;used)
			break;	/* done */

		nx = sc-&gt;nxt;

		for (rv = rel_vars; rv; rv = rv-&gt;nxt)
			if (AST_mutual(sc-&gt;n, rv-&gt;n, 1))
				break;

		if (!rv) /* not already there */
		{	sc-&gt;nxt = rel_vars;
			rel_vars = sc;
	}	}
	slicer = sc;
}

static void
check_slice(Lextok *n, int code)
{	Slicer *sc;

	for (sc = slicer; sc; sc = sc-&gt;nxt)
		if (AST_mutual(sc-&gt;n, n, 1)
		&amp;&amp;  sc-&gt;code == code)
			return;	/* already there */

	sc = (Slicer *) emalloc(sizeof(Slicer));
	sc-&gt;n = n;

	sc-&gt;code = code;
	sc-&gt;used = 0;
	sc-&gt;nxt = slicer;
	slicer = sc;
}

static void
AST_data_dep(void)
{	Slicer *sc;

	/* mark all def-relevant transitions */
	for (sc = slicer; sc; sc = sc-&gt;nxt)
	{	sc-&gt;used = 1;
		if (verbose&amp;32)
		{	printf("spin: slice criterion ");
			AST_var(sc-&gt;n, sc-&gt;n-&gt;sym, 1);
			printf(" type=%d\n", Sym_typ(sc-&gt;n));
		}
		AST_relevant(sc-&gt;n);
	}
	AST_tagruns();	/* mark 'run's relevant if target proctype is relevant */
}

static int
AST_blockable(AST *a, int s)
{	FSM_state *f;
	FSM_trans *t;

	f = fsm_tbl[s];

	for (t = f-&gt;t; t; t = t-&gt;nxt)
	{	if (t-&gt;relevant&amp;2)
			return 1;

		if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
		switch (t-&gt;step-&gt;n-&gt;ntyp) {
		case IF:
		case DO:
		case ATOMIC:
		case NON_ATOMIC:
		case D_STEP:
			if (AST_blockable(a, t-&gt;to))
			{	t-&gt;round = AST_Round;
				t-&gt;relevant |= 2;
				return 1;
			}
			/* else fall through */
		default:
			break;
		}
		else if (AST_blockable(a, t-&gt;to))	/* Unless */
		{	t-&gt;round = AST_Round;
			t-&gt;relevant |= 2;
			return 1;
		}
	}
	return 0;
}

static void
AST_spread(AST *a, int s)
{	FSM_state *f;
	FSM_trans *t;

	f = fsm_tbl[s];

	for (t = f-&gt;t; t; t = t-&gt;nxt)
	{	if (t-&gt;relevant&amp;2)
			continue;

		if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
			switch (t-&gt;step-&gt;n-&gt;ntyp) {
			case IF:
			case DO:
			case ATOMIC:
			case NON_ATOMIC:
			case D_STEP:
				AST_spread(a, t-&gt;to);
				/* fall thru */
			default:
				t-&gt;round = AST_Round;
				t-&gt;relevant |= 2;
				break;
			}
		else	/* Unless */
		{	AST_spread(a, t-&gt;to);
			t-&gt;round = AST_Round;
			t-&gt;relevant |= 2;
		}
	}
}

static int
AST_notrelevant(Lextok *n)
{	Slicer *s;

	for (s = rel_vars; s; s = s-&gt;nxt)
		if (AST_mutual(s-&gt;n, n, 1))
			return 0;
	for (s = slicer; s; s = s-&gt;nxt)
		if (AST_mutual(s-&gt;n, n, 1))
			return 0;
	return 1;
}

static int
AST_withchan(Lextok *n)
{
	if (!n) return 0;
	if (Sym_typ(n) == CHAN)
		return 1;
	return AST_withchan(n-&gt;lft) || AST_withchan(n-&gt;rgt);
}

static int
AST_suspect(FSM_trans *t)
{	FSM_use *u;
	/* check for possible overkill */
	if (!t || !t-&gt;step || !AST_withchan(t-&gt;step-&gt;n))
		return 0;
	for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
		if (AST_notrelevant(u-&gt;n))
			return 1;
	return 0;
}

static void
AST_shouldconsider(AST *a, int s)
{	FSM_state *f;
	FSM_trans *t;

	f = fsm_tbl[s];
	for (t = f-&gt;t; t; t = t-&gt;nxt)
	{	if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
			switch (t-&gt;step-&gt;n-&gt;ntyp) {
			case IF:
			case DO:
			case ATOMIC:
			case NON_ATOMIC:
			case D_STEP:
				AST_shouldconsider(a, t-&gt;to);
				break;
			default:
				AST_track(t-&gt;step-&gt;n, 0);
/*
	AST_track is called here for a blockable stmnt from which
	a relevant stmnmt was shown to be reachable
	for a condition this makes all USEs relevant
	but for a channel operation it only makes the executability
	relevant -- in those cases, parameters that aren't already
	relevant may be replaceable with arbitrary tokens
 */
				if (AST_suspect(t))
				{	printf("spin: possibly redundant parameters in: ");
					comment(stdout, t-&gt;step-&gt;n, 0);
					printf("\n");
				}
				break;
			}
		else	/* an Unless */
			AST_shouldconsider(a, t-&gt;to);
	}
}

static int
FSM_critical(AST *a, int s)
{	FSM_state *f;
	FSM_trans *t;

	/* is a 1-relevant stmnt reachable from this state? */

	f = fsm_tbl[s];
	if (f-&gt;seen)
		goto done;
	f-&gt;seen = 1;
	f-&gt;cr   = 0;
	for (t = f-&gt;t; t; t = t-&gt;nxt)
		if ((t-&gt;relevant&amp;1)
		||  FSM_critical(a, t-&gt;to))
		{	f-&gt;cr = 1;

			if (verbose&amp;32)
			{	printf("\t\t\t\tcritical(%d) ", t-&gt;relevant);
				comment(stdout, t-&gt;step-&gt;n, 0);
				printf("\n");
			}
			break;
		}
#if 0
	else {
		if (verbose&amp;32)
		{ printf("\t\t\t\tnot-crit ");
		  comment(stdout, t-&gt;step-&gt;n, 0);
	 	  printf("\n");
		}
	}
#endif
done:
	return f-&gt;cr;
}

static void
AST_ctrl(AST *a)
{	FSM_state *f;
	FSM_trans *t;
	int hit;

	/* add all blockable transitions
	 * from which relevant transitions can be reached
	 */
	if (verbose&amp;32)
		printf("CTL -- %s\n", a-&gt;p-&gt;n-&gt;name);

	/* 1 : mark all blockable edges */
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	if (!(f-&gt;scratch&amp;2))		/* not part of irrelevant subgraph */
		for (t = f-&gt;t; t; t = t-&gt;nxt)
		{	if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
			switch (t-&gt;step-&gt;n-&gt;ntyp) {
			case 'r':
			case 's':
			case 'c':
			case ELSE:
				t-&gt;round = AST_Round;
				t-&gt;relevant |= 2;	/* mark for next phases */
				if (verbose&amp;32)
				{	printf("\tpremark ");
					comment(stdout, t-&gt;step-&gt;n, 0);
					printf("\n");
				}
				break;
			default:
				break;
	}	}	}

	/* 2: keep only 2-marked stmnts from which 1-marked stmnts can be reached */
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	fsm_tbl[f-&gt;from] = f;
		f-&gt;seen = 0;	/* used in dfs from FSM_critical */
	}
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	if (!FSM_critical(a, f-&gt;from))
		for (t = f-&gt;t; t; t = t-&gt;nxt)
			if (t-&gt;relevant&amp;2)
			{	t-&gt;relevant &amp;= ~2;	/* clear mark */
				if (verbose&amp;32)
				{	printf("\t\tnomark ");
					if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
						comment(stdout, t-&gt;step-&gt;n, 0);
					printf("\n");
	}		}	}

	/* 3 : lift marks across IF/DO etc. */
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	hit = 0;
		for (t = f-&gt;t; t; t = t-&gt;nxt)
		{	if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
			switch (t-&gt;step-&gt;n-&gt;ntyp) {
			case IF:
			case DO:
			case ATOMIC:
			case NON_ATOMIC:
			case D_STEP:
				if (AST_blockable(a, t-&gt;to))
					hit = 1;
				break;
			default:
				break;
			}
			else if (AST_blockable(a, t-&gt;to))	/* Unless */
				hit = 1;

			if (hit) break;
		}
		if (hit)	/* at least one outgoing trans can block */
		for (t = f-&gt;t; t; t = t-&gt;nxt)
		{	t-&gt;round = AST_Round;
			t-&gt;relevant |= 2;	/* lift */
			if (verbose&amp;32)
			{	printf("\t\t\tliftmark ");
				if (t-&gt;step &amp;&amp; t-&gt;step-&gt;n)
					comment(stdout, t-&gt;step-&gt;n, 0);
				printf("\n");
			}
			AST_spread(a, t-&gt;to);	/* and spread to all guards */
	}	}

	/* 4: nodes with 2-marked out-edges contribute new slice criteria */
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	for (t = f-&gt;t; t; t = t-&gt;nxt)
		if (t-&gt;relevant&amp;2)
		{	AST_shouldconsider(a, f-&gt;from);
			break;	/* inner loop */
		}
}

static void
AST_control_dep(void)
{	AST *a;

	for (a = ast; a; a = a-&gt;nxt)
	{	if (a-&gt;p-&gt;b != N_CLAIM &amp;&amp; a-&gt;p-&gt;b != E_TRACE &amp;&amp; a-&gt;p-&gt;b != N_TRACE)
		{	AST_ctrl(a);
	}	}
}

static void
AST_prelabel(void)
{	AST *a;
	FSM_state *f;
	FSM_trans *t;

	for (a = ast; a; a = a-&gt;nxt)
	{	if (a-&gt;p-&gt;b != N_CLAIM &amp;&amp; a-&gt;p-&gt;b != E_TRACE &amp;&amp; a-&gt;p-&gt;b != N_TRACE)
		for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		for (t = f-&gt;t; t; t = t-&gt;nxt)
		{	if (t-&gt;step
			&amp;&amp;  t-&gt;step-&gt;n
			&amp;&amp;  t-&gt;step-&gt;n-&gt;ntyp == ASSERT
			)
			{	t-&gt;relevant |= 1;
	}	}	}
}

static void
AST_criteria(void)
{	/*
	 * remote labels are handled separately -- by making
	 * sure they are not pruned away during optimization
	 */
	AST_Changes = 1;	/* to get started */
	for (AST_Round = 1; slicer &amp;&amp; AST_Changes; AST_Round++)
	{	AST_Changes = 0;
		AST_data_dep();
		AST_preserve();		/* moves processed vars from slicer to rel_vars */
		AST_dominant();		/* mark data-irrelevant subgraphs */
		AST_control_dep();	/* can add data deps, which add control deps */

		if (verbose&amp;32)
			printf("\n\nROUND %d -- changes %d\n",
				AST_Round, AST_Changes);
	}
}

static void
AST_alias_analysis(void)		/* aliasing of promela channels */
{	AST *a;

	for (a = ast; a; a = a-&gt;nxt)
		AST_sends(a);		/* collect chan-names that are send across chans */

	for (a = ast; a; a = a-&gt;nxt)
		AST_para(a-&gt;p);		/* aliasing of chans thru proctype parameters */

	for (a = ast; a; a = a-&gt;nxt)
		AST_other(a);		/* chan params in asgns and recvs */

	AST_trans();			/* transitive closure of alias table */

	if (verbose&amp;32)
		AST_aliases();		/* show channel aliasing info */
}

void
AST_slice(void)
{	AST *a;
	int spurious = 0;

	if (!slicer)
	{	printf("spin: warning: no slice criteria found (no assertions and no claim)\n");
		spurious = 1;
	}
	AST_dorelevant();		/* mark procs refered to in remote refs */

	for (a = ast; a; a = a-&gt;nxt)
		AST_def_use(a);		/* compute standard def/use information */

	AST_hidden();			/* parameter passing and local var inits */

	AST_alias_analysis();		/* channel alias analysis */

	AST_prelabel();			/* mark all 'assert(...)' stmnts as relevant */
	AST_criteria();			/* process the slice criteria from
					 * asserts and from the never claim
					 */
	if (!spurious || (verbose&amp;32))
	{	spurious = 1;
		for (a = ast; a; a = a-&gt;nxt)
		{	AST_dump(a);		/* marked up result */
			if (a-&gt;relevant&amp;2)	/* it printed something */
				spurious = 0;
		}
		if (!AST_dump_rel()		/* relevant variables */
		&amp;&amp;  spurious)
			printf("spin: no redundancies found (for given property)\n");
	}
	AST_suggestions();

	if (verbose&amp;32)
		show_expl();
}

void
AST_store(ProcList *p, int start_state)
{	AST *n_ast;

	if (p-&gt;b != N_CLAIM &amp;&amp; p-&gt;b != E_TRACE &amp;&amp; p-&gt;b != N_TRACE)
	{	n_ast = (AST *) emalloc(sizeof(AST));
		n_ast-&gt;p = p;
		n_ast-&gt;i_st = start_state;
		n_ast-&gt;relevant = 0;
		n_ast-&gt;fsm = fsm;
		n_ast-&gt;nxt = ast;
		ast = n_ast;
	}
	fsm = (FSM_state *) 0;	/* hide it from FSM_DEL */
}

static void
AST_add_explicit(Lextok *d, Lextok *u)
{	FSM_trans *e = (FSM_trans *) emalloc(sizeof(FSM_trans));

	e-&gt;to = 0;			/* or start_state ? */
	e-&gt;relevant = 0;		/* to be determined */
	e-&gt;step = (Element *) 0;	/* left blank */
	e-&gt;Val[0] = e-&gt;Val[1] = (FSM_use *) 0;

	cur_t = e;

	def_use(u, USE);
	def_use(d, DEF);

	cur_t = (FSM_trans *) 0;

	e-&gt;nxt = explicit;
	explicit = e;
}

static void
AST_fp1(char *s, Lextok *t, Lextok *f, int parno)
{	Lextok *v;
	int cnt;

	if (!t) return;

	if (t-&gt;ntyp == RUN)
	{	if (strcmp(t-&gt;sym-&gt;name, s) == 0)
		for (v = t-&gt;lft, cnt = 1; v; v = v-&gt;rgt, cnt++)
			if (cnt == parno)
			{	AST_add_explicit(f, v-&gt;lft);
				break;
			}
	} else
	{	AST_fp1(s, t-&gt;lft, f, parno);
		AST_fp1(s, t-&gt;rgt, f, parno);
	}
}

static void
AST_mk1(char *s, Lextok *c, int parno)
{	AST *a;
	FSM_state *f;
	FSM_trans *t;

	/* concoct an extra FSM_trans *t with the asgn of
	 * formal par c to matching actual pars made explicit
	 */

	for (a = ast; a; a = a-&gt;nxt)		/* automata       */
	for (f = a-&gt;fsm; f; f = f-&gt;nxt)		/* control states */
	for (t = f-&gt;t; t; t = t-&gt;nxt)		/* transitions    */
	{	if (t-&gt;step)
		AST_fp1(s, t-&gt;step-&gt;n, c, parno);
	}
}

static void
AST_par_init(void)	/* parameter passing -- hidden assignments */
{	AST *a;
	Lextok *f, *t, *c;
	int cnt;

	for (a = ast; a; a = a-&gt;nxt)
	{	if (a-&gt;p-&gt;b == N_CLAIM || a-&gt;p-&gt;b == I_PROC
		||  a-&gt;p-&gt;b == E_TRACE || a-&gt;p-&gt;b == N_TRACE)
		{	continue;			/* has no params */
		}
		cnt = 0;
		for (f = a-&gt;p-&gt;p; f; f = f-&gt;rgt)	/* types */
		for (t = f-&gt;lft; t; t = t-&gt;rgt)		/* formals */
		{	cnt++;				/* formal par count */
			c = (t-&gt;ntyp != ',')? t : t-&gt;lft;	/* the formal parameter */
			AST_mk1(a-&gt;p-&gt;n-&gt;name, c, cnt);		/* all matching run statements */
	}	}
}

static void
AST_var_init(void)		/* initialized vars (not chans) - hidden assignments */
{	Ordered	*walk;
	Lextok *x;
	Symbol	*sp;
	AST *a;

	for (walk = all_names; walk; walk = walk-&gt;next)	
	{	sp = walk-&gt;entry;
		if (sp
		&amp;&amp;  !sp-&gt;context		/* globals */
		&amp;&amp;  sp-&gt;type != PROCTYPE
		&amp;&amp;  sp-&gt;ini
		&amp;&amp; (sp-&gt;type != MTYPE || sp-&gt;ini-&gt;ntyp != CONST) /* not mtype defs */
		&amp;&amp;  sp-&gt;ini-&gt;ntyp != CHAN)
		{	x = nn(ZN, TYPE, ZN, ZN);
			x-&gt;sym = sp;
			AST_add_explicit(x, sp-&gt;ini);
	}	}

	for (a = ast; a; a = a-&gt;nxt)
	{	if (a-&gt;p-&gt;b != N_CLAIM
		&amp;&amp;  a-&gt;p-&gt;b != E_TRACE &amp;&amp; a-&gt;p-&gt;b != N_TRACE)	/* has no locals */
		for (walk = all_names; walk; walk = walk-&gt;next)	
		{	sp = walk-&gt;entry;
			if (sp
			&amp;&amp;  sp-&gt;context
			&amp;&amp;  strcmp(sp-&gt;context-&gt;name, a-&gt;p-&gt;n-&gt;name) == 0
			&amp;&amp;  sp-&gt;Nid &gt;= 0	/* not a param */
			&amp;&amp;  sp-&gt;type != LABEL
			&amp;&amp;  sp-&gt;ini
			&amp;&amp;  sp-&gt;ini-&gt;ntyp != CHAN)
			{	x = nn(ZN, TYPE, ZN, ZN);
				x-&gt;sym = sp;
				AST_add_explicit(x, sp-&gt;ini);
	}	}	}
}

static void
show_expl(void)
{	FSM_trans *t, *T;
	FSM_use *u;

	printf("\nExplicit List:\n");
	for (T = expl_par; T; T = (T == expl_par)?expl_var: (FSM_trans *) 0)
	{	for (t = T; t; t = t-&gt;nxt)
		{	if (!t-&gt;Val[0]) continue;
			printf("%s", t-&gt;relevant?"*":" ");
			printf("%3d", t-&gt;round);
			for (u = t-&gt;Val[0]; u; u = u-&gt;nxt)
			{	printf("\t&lt;");
				AST_var(u-&gt;n, u-&gt;n-&gt;sym, 1);
				printf(":%d&gt;, ", u-&gt;special);
			}
			printf("\n");
		}
		printf("==\n");
	}
	printf("End\n");
}

static void
AST_hidden(void)			/* reveal all hidden assignments */
{
	AST_par_init();
	expl_par = explicit;
	explicit = (FSM_trans *) 0;

	AST_var_init();
	expl_var = explicit;
	explicit = (FSM_trans *) 0;
}

#define BPW	(8*sizeof(ulong))			/* bits per word */

static int
bad_scratch(FSM_state *f, int upto)
{	FSM_trans *t;
#if 0
	1. all internal branch-points have else-s
	2. all non-branchpoints have non-blocking out-edge
	3. all internal edges are non-relevant
	subgraphs like this need NOT contribute control-dependencies
#endif

	if (!f-&gt;seen
	||  (f-&gt;scratch&amp;4))
		return 0;

	if (f-&gt;scratch&amp;8)
		return 1;

	f-&gt;scratch |= 4;

	if (verbose&amp;32) printf("X[%d:%d:%d] ", f-&gt;from, upto, f-&gt;scratch);

	if (f-&gt;scratch&amp;1)
	{	if (verbose&amp;32)
			printf("\tbad scratch: %d\n", f-&gt;from);
bad:		f-&gt;scratch &amp;= ~4;
	/*	f-&gt;scratch |=  8;	 wrong */
		return 1;
	}

	if (f-&gt;from != upto)
	for (t = f-&gt;t; t; t = t-&gt;nxt)
		if (bad_scratch(fsm_tbl[t-&gt;to], upto))
			goto bad;

	return 0;
}

static void
mark_subgraph(FSM_state *f, int upto)
{	FSM_trans *t;

	if (f-&gt;from == upto
	||  !f-&gt;seen
	||  (f-&gt;scratch&amp;2))
		return;

	f-&gt;scratch |= 2;

	for (t = f-&gt;t; t; t = t-&gt;nxt)
		mark_subgraph(fsm_tbl[t-&gt;to], upto);
}

static void
AST_pair(AST *a, FSM_state *h, int y)
{	Pair *p;

	for (p = a-&gt;pairs; p; p = p-&gt;nxt)
		if (p-&gt;h == h
		&amp;&amp;  p-&gt;b == y)
			return;

	p = (Pair *) emalloc(sizeof(Pair));
	p-&gt;h = h;
	p-&gt;b = y;
	p-&gt;nxt = a-&gt;pairs;
	a-&gt;pairs = p;
}

static void
AST_checkpairs(AST *a)
{	Pair *p;

	for (p = a-&gt;pairs; p; p = p-&gt;nxt)
	{	if (verbose&amp;32)
			printf("	inspect pair %d %d\n", p-&gt;b, p-&gt;h-&gt;from);
		if (!bad_scratch(p-&gt;h, p-&gt;b))	/* subgraph is clean */
		{	if (verbose&amp;32)
				printf("subgraph: %d .. %d\n", p-&gt;b, p-&gt;h-&gt;from);
			mark_subgraph(p-&gt;h, p-&gt;b);
		}
	}
}

static void
subgraph(AST *a, FSM_state *f, int out)
{	FSM_state *h;
	int i, j;
	ulong *g;
#if 0
	reverse dominance suggests that this is a possible
	entry and exit node for a proper subgraph
#endif
	h = fsm_tbl[out];

	i = f-&gt;from / BPW;
	j = f-&gt;from % BPW;
	g = h-&gt;mod;

	if (verbose&amp;32)
		printf("possible pair %d %d -- %d\n",
			f-&gt;from, h-&gt;from, (g[i]&amp;(1&lt;&lt;j))?1:0);
	
	if (g[i]&amp;(1&lt;&lt;j))		/* also a forward dominance pair */
		AST_pair(a, h, f-&gt;from);	/* record this pair */
}

static void
act_dom(AST *a)
{	FSM_state *f;
	FSM_trans *t;
	int i, j, cnt;

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	if (!f-&gt;seen) continue;
#if 0
		f-&gt;from is the exit-node of a proper subgraph, with
		the dominator its entry-node, if:
		a. this node has more than 1 reachable predecessor
		b. the dominator has more than 1 reachable successor
		   (need reachability - in case of reverse dominance)
		d. the dominator is reachable, and not equal to this node
#endif
		for (t = f-&gt;p, i = 0; t; t = t-&gt;nxt)
			i += fsm_tbl[t-&gt;to]-&gt;seen;
		if (i &lt;= 1) continue;					/* a. */

		for (cnt = 1; cnt &lt; a-&gt;nstates; cnt++)	/* 0 is endstate */
		{	if (cnt == f-&gt;from
			||  !fsm_tbl[cnt]-&gt;seen)
				continue;				/* c. */

			i = cnt / BPW;
			j = cnt % BPW;
			if (!(f-&gt;dom[i]&amp;(1&lt;&lt;j)))
				continue;

			for (t = fsm_tbl[cnt]-&gt;t, i = 0; t; t = t-&gt;nxt)
				i += fsm_tbl[t-&gt;to]-&gt;seen;
			if (i &lt;= 1)
				continue;				/* b. */

			if (f-&gt;mod)			/* final check in 2nd phase */
				subgraph(a, f, cnt);	/* possible entry-exit pair */
		}
	}
}

static void
reachability(AST *a)
{	FSM_state *f;

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		f-&gt;seen = 0;		/* clear */
	AST_dfs(a, a-&gt;i_st, 0);		/* mark 'seen' */
}

static int
see_else(FSM_state *f)
{	FSM_trans *t;

	for (t = f-&gt;t; t; t = t-&gt;nxt)
	{	if (t-&gt;step
		&amp;&amp;  t-&gt;step-&gt;n)
		switch (t-&gt;step-&gt;n-&gt;ntyp) {
		case ELSE:
			return 1;
		case IF:
		case DO:
		case ATOMIC:
		case NON_ATOMIC:
		case D_STEP:
			if (see_else(fsm_tbl[t-&gt;to]))
				return 1;
		default:
			break;
		}
	}
	return 0;
}

static int
is_guard(FSM_state *f)
{	FSM_state *g;
	FSM_trans *t;

	for (t = f-&gt;p; t; t = t-&gt;nxt)
	{	g = fsm_tbl[t-&gt;to];
		if (!g-&gt;seen)
			continue;

		if (t-&gt;step
		&amp;&amp;  t-&gt;step-&gt;n)
		switch(t-&gt;step-&gt;n-&gt;ntyp) {
		case IF:
		case DO:
			return 1;
		case ATOMIC:
		case NON_ATOMIC:
		case D_STEP:
			if (is_guard(g))
				return 1;
		default:
			break;
		}
	}
	return 0;
}

static void
curtail(AST *a)
{	FSM_state *f, *g;
	FSM_trans *t;
	int i, haselse, isrel, blocking;
#if 0
	mark nodes that do not satisfy these requirements:
	1. all internal branch-points have else-s
	2. all non-branchpoints have non-blocking out-edge
	3. all internal edges are non-data-relevant
#endif
	if (verbose&amp;32)
		printf("Curtail %s:\n", a-&gt;p-&gt;n-&gt;name);

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	if (!f-&gt;seen
		||  (f-&gt;scratch&amp;(1|2)))
			continue;

		isrel = haselse = i = blocking = 0;

		for (t = f-&gt;t; t; t = t-&gt;nxt)
		{	g = fsm_tbl[t-&gt;to];

			isrel |= (t-&gt;relevant&amp;1);	/* data relevant */
			i += g-&gt;seen;

			if (t-&gt;step
			&amp;&amp;  t-&gt;step-&gt;n)
			{	switch (t-&gt;step-&gt;n-&gt;ntyp) {
				case IF:
				case DO:
					haselse |= see_else(g);
					break;
				case 'c':
				case 's':
				case 'r':
					blocking = 1;
					break;
		}	}	}
#if 0
		if (verbose&amp;32)
			printf("prescratch %d -- %d %d %d %d -- %d\n",
				f-&gt;from, i, isrel, blocking, haselse, is_guard(f));
#endif
		if (isrel			/* 3. */		
		||  (i == 1 &amp;&amp; blocking)	/* 2. */
		||  (i &gt;  1 &amp;&amp; !haselse))	/* 1. */
		{	if (!is_guard(f))
			{	f-&gt;scratch |= 1;
				if (verbose&amp;32)
				printf("scratch %d -- %d %d %d %d\n",
					f-&gt;from, i, isrel, blocking, haselse);
			}
		}
	}
}

static void
init_dom(AST *a)
{	FSM_state *f;
	int i, j, cnt;
#if 0
	(1)  D(s0) = {s0}
	(2)  for s in S - {s0} do D(s) = S
#endif

	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
	{	if (!f-&gt;seen) continue;

		f-&gt;dom = (ulong *)
			emalloc(a-&gt;nwords * sizeof(ulong));

		if (f-&gt;from == a-&gt;i_st)
		{	i = a-&gt;i_st / BPW;
			j = a-&gt;i_st % BPW;
			f-&gt;dom[i] = (1&lt;&lt;j);			/* (1) */
		} else						/* (2) */
		{	for (i = 0; i &lt; a-&gt;nwords; i++)
				f-&gt;dom[i] = (ulong) ~0;			/* all 1's */

			if (a-&gt;nstates % BPW)
			for (i = (a-&gt;nstates % BPW); i &lt; (int) BPW; i++)
				f-&gt;dom[a-&gt;nwords-1] &amp;= ~(1&lt;&lt;i);	/* clear tail */

			for (cnt = 0; cnt &lt; a-&gt;nstates; cnt++)
				if (!fsm_tbl[cnt]-&gt;seen)
				{	i = cnt / BPW;
					j = cnt % BPW;
					f-&gt;dom[i] &amp;= ~(1&lt;&lt;j);
	}	}		}
}

static int
dom_perculate(AST *a, FSM_state *f)
{	static ulong *ndom = (ulong *) 0;
	static int on = 0;
	int i, j, cnt = 0;
	FSM_state *g;
	FSM_trans *t;

	if (on &lt; a-&gt;nwords)
	{	on = a-&gt;nwords;
		ndom = (ulong *)
			emalloc(on * sizeof(ulong));
	}

	for (i = 0; i &lt; a-&gt;nwords; i++)
		ndom[i] = (ulong) ~0;

	for (t = f-&gt;p; t; t = t-&gt;nxt)	/* all reachable predecessors */
	{	g = fsm_tbl[t-&gt;to];
		if (g-&gt;seen)
		for (i = 0; i &lt; a-&gt;nwords; i++)
			ndom[i] &amp;= g-&gt;dom[i];	/* (5b) */
	}

	i = f-&gt;from / BPW;
	j = f-&gt;from % BPW;
	ndom[i] |= (1&lt;&lt;j);			/* (5a) */

	for (i = 0; i &lt; a-&gt;nwords; i++)
		if (f-&gt;dom[i] != ndom[i])
		{	cnt++;
			f-&gt;dom[i] = ndom[i];
		}

	return cnt;
}

static void
dom_forward(AST *a)
{	FSM_state *f;
	int cnt;

	init_dom(a);						/* (1,2) */
	do {
		cnt = 0;
		for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		{	if (f-&gt;seen
			&amp;&amp;  f-&gt;from != a-&gt;i_st)			/* (4) */
				cnt += dom_perculate(a, f);	/* (5) */
		}
	} while (cnt);						/* (3) */
	dom_perculate(a, fsm_tbl[a-&gt;i_st]);
}

static void
AST_dominant(void)
{	FSM_state *f;
	FSM_trans *t;
	AST *a;
	int oi;
	static FSM_state no_state;
#if 0
	find dominators
	Aho, Sethi, &amp; Ullman, Compilers - principles, techniques, and tools
	Addison-Wesley, 1986, p.671.

	(1)  D(s0) = {s0}
	(2)  for s in S - {s0} do D(s) = S

	(3)  while any D(s) changes do
	(4)    for s in S - {s0} do
	(5)	D(s) = {s} union  with intersection of all D(p)
		where p are the immediate predecessors of s

	the purpose is to find proper subgraphs
	(one entry node, one exit node)
#endif
	if (AST_Round == 1)	/* computed once, reused in every round */
	for (a = ast; a; a = a-&gt;nxt)
	{	a-&gt;nstates = 0;
		for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		{	a-&gt;nstates++;				/* count */
			fsm_tbl[f-&gt;from] = f;			/* fast lookup */
			f-&gt;scratch = 0;				/* clear scratch marks */
		}
		for (oi = 0; oi &lt; a-&gt;nstates; oi++)
			if (!fsm_tbl[oi])
				fsm_tbl[oi] = &amp;no_state;

		a-&gt;nwords = (a-&gt;nstates + BPW - 1) / BPW;	/* round up */

		if (verbose&amp;32)
		{	printf("%s (%d): ", a-&gt;p-&gt;n-&gt;name, a-&gt;i_st);
			printf("states=%d (max %d), words = %d, bpw %d, overflow %d\n",
				a-&gt;nstates, o_max, a-&gt;nwords,
				(int) BPW, (int) (a-&gt;nstates % BPW));
		}

		reachability(a);
		dom_forward(a);		/* forward dominance relation */

		curtail(a);		/* mark ineligible edges */
		for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		{	t = f-&gt;p;
			f-&gt;p = f-&gt;t;
			f-&gt;t = t;	/* invert edges */

			f-&gt;mod = f-&gt;dom;
			f-&gt;dom = (ulong *) 0;
		}
		oi = a-&gt;i_st;
		if (fsm_tbl[0]-&gt;seen)	/* end-state reachable - else leave it */
			a-&gt;i_st = 0;	/* becomes initial state */
	
		dom_forward(a);		/* reverse dominance -- don't redo reachability! */
		act_dom(a);		/* mark proper subgraphs, if any */
		AST_checkpairs(a);	/* selectively place 2 scratch-marks */

		for (f = a-&gt;fsm; f; f = f-&gt;nxt)
		{	t = f-&gt;p;
			f-&gt;p = f-&gt;t;
			f-&gt;t = t;	/* restore */
		}
		a-&gt;i_st = oi;	/* restore */
	} else
		for (a = ast; a; a = a-&gt;nxt)
		{	for (f = a-&gt;fsm; f; f = f-&gt;nxt)
			{	fsm_tbl[f-&gt;from] = f;
				f-&gt;scratch &amp;= 1; /* preserve 1-marks */
			}
			for (oi = 0; oi &lt; a-&gt;nstates; oi++)
				if (!fsm_tbl[oi])
					fsm_tbl[oi] = &amp;no_state;

			curtail(a);		/* mark ineligible edges */

			for (f = a-&gt;fsm; f; f = f-&gt;nxt)
			{	t = f-&gt;p;
				f-&gt;p = f-&gt;t;
				f-&gt;t = t;	/* invert edges */
			}
	
			AST_checkpairs(a);	/* recompute 2-marks */

			for (f = a-&gt;fsm; f; f = f-&gt;nxt)
			{	t = f-&gt;p;
				f-&gt;p = f-&gt;t;
				f-&gt;t = t;	/* restore */
		}	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

