<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/sched.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/sched.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: sched.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include &lt;stdlib.h&gt;
#include "spin.h"
#include "y.tab.h"

extern int	verbose, s_trail, analyze, no_wrapup;
extern char	*claimproc, *eventmap, Buf[];
extern Ordered	*all_names;
extern Symbol	*Fname, *context;
extern int	lineno, nr_errs, dumptab, xspin, jumpsteps, columns;
extern int	u_sync, Elcnt, interactive, TstOnly, cutoff;
extern short	has_enabled;
extern int	limited_vis, old_scope_rules, product, nclaims;

RunList		*X   = (RunList  *) 0;
RunList		*run = (RunList  *) 0;
RunList		*LastX  = (RunList  *) 0; /* previous executing proc */
ProcList	*rdy = (ProcList *) 0;
Element		*LastStep = ZE;
int		nproc=0, nstop=0, Tval=0;
int		Rvous=0, depth=0, nrRdy=0, MadeChoice;
short		Have_claim=0, Skip_claim=0;

static int	Priority_Sum = 0;
static void	setlocals(RunList *);
static void	setparams(RunList *, ProcList *, Lextok *);
static void	talk(RunList *);

void
runnable(ProcList *p, int weight, int noparams)
{	RunList *r = (RunList *) emalloc(sizeof(RunList));

	r-&gt;n  = p-&gt;n;
	r-&gt;tn = p-&gt;tn;
	r-&gt;b  = p-&gt;b;
	r-&gt;pid = nproc++ - nstop + Skip_claim;

	if (!noparams &amp;&amp; ((verbose&amp;4) || (verbose&amp;32)))
		printf("Starting %s with pid %d\n",
			p-&gt;n?p-&gt;n-&gt;name:"--", r-&gt;pid);

	if (!p-&gt;s)
		fatal("parsing error, no sequence %s",
			p-&gt;n?p-&gt;n-&gt;name:"--");

	r-&gt;pc = huntele(p-&gt;s-&gt;frst, p-&gt;s-&gt;frst-&gt;status, -1);
	r-&gt;ps = p-&gt;s;

	if (p-&gt;s-&gt;last)
		p-&gt;s-&gt;last-&gt;status |= ENDSTATE; /* normal end state */

	r-&gt;nxt = run;
	r-&gt;prov = p-&gt;prov;
	r-&gt;priority = weight;

	if (noparams) setlocals(r);
	Priority_Sum += weight;

	run = r;
}

ProcList *
ready(Symbol *n, Lextok *p, Sequence *s, int det, Lextok *prov, enum btypes b)
	/* n=name, p=formals, s=body det=deterministic prov=provided */
{	ProcList *r = (ProcList *) emalloc(sizeof(ProcList));
	Lextok *fp, *fpt; int j; extern int Npars;

	r-&gt;n = n;
	r-&gt;p = p;
	r-&gt;s = s;
	r-&gt;b = b;
	r-&gt;prov = prov;
	r-&gt;tn = nrRdy++;
	if (det != 0 &amp;&amp; det != 1)
	{	fprintf(stderr, "spin: bad value for det (cannot happen)\n");
	}
	r-&gt;det = (short) det;
	r-&gt;nxt = rdy;
	rdy = r;

	for (fp  = p, j = 0;  fp;  fp = fp-&gt;rgt)
	for (fpt = fp-&gt;lft;  fpt; fpt = fpt-&gt;rgt)
		j++;	/* count # of parameters */
	Npars = max(Npars, j);

	return rdy;
}

int
find_maxel(Symbol *s)
{	ProcList *p;

	for (p = rdy; p; p = p-&gt;nxt)
		if (p-&gt;n == s)
			return p-&gt;s-&gt;maxel++;
	return Elcnt++;
}

static void
formdump(void)
{	ProcList *p;
	Lextok *f, *t;
	int cnt;

	for (p = rdy; p; p = p-&gt;nxt)
	{	if (!p-&gt;p) continue;
		cnt = -1;
		for (f = p-&gt;p; f; f = f-&gt;rgt)	/* types */
		for (t = f-&gt;lft; t; t = t-&gt;rgt)	/* formals */
		{	if (t-&gt;ntyp != ',')
				t-&gt;sym-&gt;Nid = cnt--;	/* overload Nid */
			else
				t-&gt;lft-&gt;sym-&gt;Nid = cnt--;
		}
	}
}

void
announce(char *w)
{
	if (columns)
	{	extern char Buf[];
		extern int firstrow;
		firstrow = 1;
		if (columns == 2)
		{	sprintf(Buf, "%d:%s",
			run-&gt;pid - Have_claim, run-&gt;n-&gt;name);
			pstext(run-&gt;pid - Have_claim, Buf);
		} else
			printf("proc %d = %s\n",
			run-&gt;pid - Have_claim, run-&gt;n-&gt;name);
		return;
	}

	if (dumptab
	||  analyze
	||  product
	||  s_trail
	|| !(verbose&amp;4))
		return;

	if (w)
		printf("  0:	proc  - (%s) ", w);
	else
		whoruns(1);
	printf("creates proc %2d (%s)",
		run-&gt;pid - Have_claim,
		run-&gt;n-&gt;name);
	if (run-&gt;priority &gt; 1)
		printf(" priority %d", run-&gt;priority);
	printf("\n");
}

#ifndef MAXP
#define MAXP	255	/* matches max nr of processes in verifier */
#endif

int
enable(Lextok *m)
{	ProcList *p;
	Symbol *s = m-&gt;sym;	/* proctype name */
	Lextok *n = m-&gt;lft;	/* actual parameters */

	if (m-&gt;val &lt; 1) m-&gt;val = 1;	/* minimum priority */
	for (p = rdy; p; p = p-&gt;nxt)
		if (strcmp(s-&gt;name, p-&gt;n-&gt;name) == 0)
		{	if (nproc-nstop &gt;= MAXP)
			{	printf("spin: too many processes (%d max)\n", MAXP);
				break;
			}
			runnable(p, m-&gt;val, 0);
			announce((char *) 0);
			setparams(run, p, n);
			setlocals(run); /* after setparams */
			return run-&gt;pid - Have_claim + Skip_claim; /* effective simu pid */
		}
	return 0; /* process not found */
}

void
check_param_count(int i, Lextok *m)
{	ProcList *p;
	Symbol *s = m-&gt;sym;	/* proctype name */
	Lextok *f, *t;		/* formal pars */
	int cnt = 0;

	for (p = rdy; p; p = p-&gt;nxt)
	{	if (strcmp(s-&gt;name, p-&gt;n-&gt;name) == 0)
		{	if (m-&gt;lft)	/* actual param list */
			{	lineno = m-&gt;lft-&gt;ln;
				Fname  = m-&gt;lft-&gt;fn;
			}
			for (f = p-&gt;p;   f; f = f-&gt;rgt) /* one type at a time */
			for (t = f-&gt;lft; t; t = t-&gt;rgt)	/* count formal params */
			{	cnt++;
			}
			if (i != cnt)
			{	printf("spin: saw %d parameters, expected %d\n", i, cnt);
				non_fatal("wrong number of parameters", "");
			}
			break;
	}	}
}

void
start_claim(int n)
{	ProcList *p;
	RunList  *r, *q = (RunList *) 0;

	for (p = rdy; p; p = p-&gt;nxt)
		if (p-&gt;tn == n &amp;&amp; p-&gt;b == N_CLAIM)
		{	runnable(p, 1, 1);
			goto found;
		}
	printf("spin: couldn't find claim %d (ignored)\n", n);
	if (verbose&amp;32)
	for (p = rdy; p; p = p-&gt;nxt)
		printf("\t%d = %s\n", p-&gt;tn, p-&gt;n-&gt;name);

	Skip_claim = 1;
	goto done;
found:
	/* move claim to far end of runlist, and reassign it pid 0 */
	if (columns == 2)
	{	extern char Buf[];
		depth = 0;
		sprintf(Buf, "%d:%s", 0, p-&gt;n-&gt;name);
		pstext(0, Buf);
		for (r = run; r; r = r-&gt;nxt)
		{	if (r-&gt;b != N_CLAIM)
			{	sprintf(Buf, "%d:%s", r-&gt;pid+1, r-&gt;n-&gt;name);
				pstext(r-&gt;pid+1, Buf);
	}	}	}

	if (run-&gt;pid == 0) return; /* it is the first process started */

	q = run; run = run-&gt;nxt;
	q-&gt;pid = 0; q-&gt;nxt = (RunList *) 0;	/* remove */
done:
	Have_claim = 1;
	for (r = run; r; r = r-&gt;nxt)
	{	r-&gt;pid = r-&gt;pid+Have_claim;	/* adjust */
		if (!r-&gt;nxt)
		{	r-&gt;nxt = q;
			break;
	}	}
}

int
f_pid(char *n)
{	RunList *r;
	int rval = -1;

	for (r = run; r; r = r-&gt;nxt)
		if (strcmp(n, r-&gt;n-&gt;name) == 0)
		{	if (rval &gt;= 0)
			{	printf("spin: remote ref to proctype %s, ", n);
				printf("has more than one match: %d and %d\n",
					rval, r-&gt;pid);
			} else
				rval = r-&gt;pid;
		}
	return rval;
}

void
wrapup(int fini)
{
	limited_vis = 0;
	if (columns)
	{	extern void putpostlude(void);
		if (columns == 2) putpostlude();
		if (!no_wrapup)
		printf("-------------\nfinal state:\n-------------\n");
	}
	if (no_wrapup)
		goto short_cut;
	if (nproc != nstop)
	{	int ov = verbose;
		printf("#processes: %d\n", nproc-nstop - Have_claim + Skip_claim);
		verbose &amp;= ~4;
		dumpglobals();
		verbose = ov;
		verbose &amp;= ~1;	/* no more globals */
		verbose |= 32;	/* add process states */
		for (X = run; X; X = X-&gt;nxt)
			talk(X);
		verbose = ov;	/* restore */
	}
	printf("%d process%s created\n",
		nproc - Have_claim + Skip_claim,
		(xspin || nproc!=1)?"es":"");
short_cut:
	if (xspin) alldone(0);	/* avoid an abort from xspin */
	if (fini)  alldone(1);
}

static char is_blocked[256];

static int
p_blocked(int p)
{	int i, j;

	is_blocked[p%256] = 1;
	for (i = j = 0; i &lt; nproc - nstop; i++)
		j += is_blocked[i];
	if (j &gt;= nproc - nstop)
	{	memset(is_blocked, 0, 256);
		return 1;
	}
	return 0;
}

static Element *
silent_moves(Element *e)
{	Element *f;

	if (e-&gt;n)
	switch (e-&gt;n-&gt;ntyp) {
	case GOTO:
		if (Rvous) break;
		f = get_lab(e-&gt;n, 1);
		cross_dsteps(e-&gt;n, f-&gt;n);
		return f; /* guard against goto cycles */
	case UNLESS:
		return silent_moves(e-&gt;sub-&gt;this-&gt;frst);
	case NON_ATOMIC:
	case ATOMIC:
	case D_STEP:
		e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt = e-&gt;nxt;
		return silent_moves(e-&gt;n-&gt;sl-&gt;this-&gt;frst);
	case '.':
		return silent_moves(e-&gt;nxt);
	}
	return e;
}

static RunList *
pickproc(RunList *Y)
{	SeqList *z; Element *has_else;
	short Choices[256];
	int j, k, nr_else = 0;

	if (nproc &lt;= nstop+1)
	{	X = run;
		return NULL;
	}
	if (!interactive || depth &lt; jumpsteps)
	{	/* was: j = (int) Rand()%(nproc-nstop); */
		if (Priority_Sum &lt; nproc-nstop)
			fatal("cannot happen - weights", (char *)0);
		j = (int) Rand()%Priority_Sum;

		while (j - X-&gt;priority &gt;= 0)
		{	j -= X-&gt;priority;
			Y = X;
			X = X-&gt;nxt;
			if (!X) { Y = NULL; X = run; }
		}
	} else
	{	int only_choice = -1;
		int no_choice = 0, proc_no_ch, proc_k;

		Tval = 0;	/* new 4.2.6 */
try_again:	printf("Select a statement\n");
try_more:	for (X = run, k = 1; X; X = X-&gt;nxt)
		{	if (X-&gt;pid &gt; 255) break;

			Choices[X-&gt;pid] = (short) k;

			if (!X-&gt;pc
			||  (X-&gt;prov &amp;&amp; !eval(X-&gt;prov)))
			{	if (X == run)
					Choices[X-&gt;pid] = 0;
				continue;
			}
			X-&gt;pc = silent_moves(X-&gt;pc);
			if (!X-&gt;pc-&gt;sub &amp;&amp; X-&gt;pc-&gt;n)
			{	int unex;
				unex = !Enabled0(X-&gt;pc);
				if (unex)
					no_choice++;
				else
					only_choice = k;
				if (!xspin &amp;&amp; unex &amp;&amp; !(verbose&amp;32))
				{	k++;
					continue;
				}
				printf("\tchoice %d: ", k++);
				p_talk(X-&gt;pc, 0);
				if (unex)
					printf(" unexecutable,");
				printf(" [");
				comment(stdout, X-&gt;pc-&gt;n, 0);
				if (X-&gt;pc-&gt;esc) printf(" + Escape");
				printf("]\n");
			} else {
			has_else = ZE;
			proc_no_ch = no_choice;
			proc_k = k;
			for (z = X-&gt;pc-&gt;sub, j=0; z; z = z-&gt;nxt)
			{	Element *y = silent_moves(z-&gt;this-&gt;frst);
				int unex;
				if (!y) continue;

				if (y-&gt;n-&gt;ntyp == ELSE)
				{	has_else = (Rvous)?ZE:y;
					nr_else = k++;
					continue;
				}

				unex = !Enabled0(y);
				if (unex)
					no_choice++;
				else
					only_choice = k;
				if (!xspin &amp;&amp; unex &amp;&amp; !(verbose&amp;32))
				{	k++;
					continue;
				}
				printf("\tchoice %d: ", k++);
				p_talk(X-&gt;pc, 0);
				if (unex)
					printf(" unexecutable,");
				printf(" [");
				comment(stdout, y-&gt;n, 0);
				printf("]\n");
			}
			if (has_else)
			{	if (no_choice-proc_no_ch &gt;= (k-proc_k)-1)
				{	only_choice = nr_else;
					printf("\tchoice %d: ", nr_else);
					p_talk(X-&gt;pc, 0);
					printf(" [else]\n");
				} else
				{	no_choice++;
					printf("\tchoice %d: ", nr_else);
					p_talk(X-&gt;pc, 0);
					printf(" unexecutable, [else]\n");
			}	}
		}	}
		X = run;
		if (k - no_choice &lt; 2 &amp;&amp; Tval == 0)
		{	Tval = 1;
			no_choice = 0; only_choice = -1;
			goto try_more;
		}
		if (xspin)
			printf("Make Selection %d\n\n", k-1);
		else
		{	if (k - no_choice &lt; 2)
			{	printf("no executable choices\n");
				alldone(0);
			}
			printf("Select [1-%d]: ", k-1);
		}
		if (!xspin &amp;&amp; k - no_choice == 2)
		{	printf("%d\n", only_choice);
			j = only_choice;
		} else
		{	char buf[256];
			fflush(stdout);
			if (scanf("%64s", buf) == 0)
			{	printf("\tno input\n");
				goto try_again;
			}
			j = -1;
			if (isdigit((int) buf[0]))
				j = atoi(buf);
			else
			{	if (buf[0] == 'q')
					alldone(0);
			}
			if (j &lt; 1 || j &gt;= k)
			{	printf("\tchoice is outside range\n");
				goto try_again;
		}	}
		MadeChoice = 0;
		Y = NULL;
		for (X = run; X; Y = X, X = X-&gt;nxt)
		{	if (!X-&gt;nxt
			||   X-&gt;nxt-&gt;pid &gt; 255
			||   j &lt; Choices[X-&gt;nxt-&gt;pid])
			{
				MadeChoice = 1+j-Choices[X-&gt;pid];
				break;
		}	}
	}
	return Y;
}

void
multi_claims(void)
{	ProcList *p, *q = NULL;

	if (nclaims &gt; 1)
	{	printf("  the model contains %d never claims:", nclaims);
		for (p = rdy; p; p = p-&gt;nxt)
		{	if (p-&gt;b == N_CLAIM)
			{	printf("%s%s", q?", ":" ", p-&gt;n-&gt;name);
				q = p;
		}	}
		printf("\n");
		printf("  only one claim is used in a verification run\n");
		printf("  choose which one with ./pan -N name (defaults to -N %s)\n",
			q?q-&gt;n-&gt;name:"--");
	}
}

void
sched(void)
{	Element *e;
	RunList *Y = NULL;	/* previous process in run queue */
	RunList *oX;
	int go, notbeyond = 0;
#ifdef PC
	int bufmax = 100;
#endif
	if (dumptab)
	{	formdump();
		symdump();
		dumplabels();
		return;
	}

	if (has_enabled &amp;&amp; u_sync &gt; 0)
	{	printf("spin: error, cannot use 'enabled()' in ");
		printf("models with synchronous channels.\n");
		nr_errs++;
	}
	if (product)
	{	sync_product();
		alldone(0);
	}
	if (analyze)
	{	gensrc();
		multi_claims();
		return;
	}
	if (s_trail)
	{	match_trail();
		return;
	}
	if (claimproc)
	printf("warning: never claim not used in random simulation\n");
	if (eventmap)
	printf("warning: trace assertion not used in random simulation\n");

	X = run;
	Y = pickproc(Y);

	while (X)
	{	context = X-&gt;n;
		if (X-&gt;pc &amp;&amp; X-&gt;pc-&gt;n)
		{	lineno = X-&gt;pc-&gt;n-&gt;ln;
			Fname  = X-&gt;pc-&gt;n-&gt;fn;
		}
		if (cutoff &gt; 0 &amp;&amp; depth &gt;= cutoff)
		{	printf("-------------\n");
			printf("depth-limit (-u%d steps) reached\n", cutoff);
			break;
		}
#ifdef PC
		if (xspin &amp;&amp; !interactive &amp;&amp; --bufmax &lt;= 0)
		{	int c; /* avoid buffer overflow on pc's */
			printf("spin: type return to proceed\n");
			fflush(stdout);
			c = getc(stdin);
			if (c == 'q') wrapup(0);
			bufmax = 100;
		}
#endif
		depth++; LastStep = ZE;
		oX = X;	/* a rendezvous could change it */
		go = 1;
		if (X-&gt;prov &amp;&amp; X-&gt;pc
		&amp;&amp; !(X-&gt;pc-&gt;status &amp; D_ATOM)
		&amp;&amp; !eval(X-&gt;prov))
		{	if (!xspin &amp;&amp; ((verbose&amp;32) || (verbose&amp;4)))
			{	p_talk(X-&gt;pc, 1);
				printf("\t&lt;&lt;Not Enabled&gt;&gt;\n");
			}
			go = 0;
		}
		if (go &amp;&amp; (e = eval_sub(X-&gt;pc)))
		{	if (depth &gt;= jumpsteps
			&amp;&amp; ((verbose&amp;32) || (verbose&amp;4)))
			{	if (X == oX)
				if (!(e-&gt;status &amp; D_ATOM) || (verbose&amp;32)) /* no talking in d_steps */
				{	p_talk(X-&gt;pc, 1);
					printf("	[");
					if (!LastStep) LastStep = X-&gt;pc;
					comment(stdout, LastStep-&gt;n, 0);
					printf("]\n");
				}
				if (verbose&amp;1) dumpglobals();
				if (verbose&amp;2) dumplocal(X);

				if (!(e-&gt;status &amp; D_ATOM))
				if (xspin)
					printf("\n");
			}
			if (oX != X
			||  (X-&gt;pc-&gt;status &amp; (ATOM|D_ATOM)))		/* new 5.0 */
			{	e = silent_moves(e);
				notbeyond = 0;
			}
			oX-&gt;pc = e; LastX = X;

			if (!interactive) Tval = 0;
			memset(is_blocked, 0, 256);

			if (X-&gt;pc &amp;&amp; (X-&gt;pc-&gt;status &amp; (ATOM|L_ATOM))
			&amp;&amp;  (notbeyond == 0 || oX != X))
			{	if ((X-&gt;pc-&gt;status &amp; L_ATOM))
					notbeyond = 1;
				continue; /* no process switch */
			}
		} else
		{	depth--;
			if (oX-&gt;pc &amp;&amp; (oX-&gt;pc-&gt;status &amp; D_ATOM))
			{	non_fatal("stmnt in d_step blocks", (char *)0);
			}
			if (X-&gt;pc
			&amp;&amp;  X-&gt;pc-&gt;n
			&amp;&amp;  X-&gt;pc-&gt;n-&gt;ntyp == '@'
			&amp;&amp;  X-&gt;pid == (nproc-nstop-1))
			{	if (X != run &amp;&amp; Y != NULL)
					Y-&gt;nxt = X-&gt;nxt;
				else
					run = X-&gt;nxt;
				nstop++;
				Priority_Sum -= X-&gt;priority;
				if (verbose&amp;4)
				{	whoruns(1);
					dotag(stdout, "terminates\n");
				}
				LastX = X;
				if (!interactive) Tval = 0;
				if (nproc == nstop) break;
				memset(is_blocked, 0, 256);
				/* proc X is no longer in runlist */
				X = (X-&gt;nxt) ? X-&gt;nxt : run;
			} else
			{	if (p_blocked(X-&gt;pid))
				{	if (Tval) break;
					Tval = 1;
					if (depth &gt;= jumpsteps)
					{	oX = X;
						X = (RunList *) 0; /* to suppress indent */
						dotag(stdout, "timeout\n");
						X = oX;
		}	}	}	}

		if (!run || !X) break;	/* new 5.0 */

		Y = pickproc(X);
		notbeyond = 0;
	}
	context = ZS;
	wrapup(0);
}

int
complete_rendez(void)
{	RunList *orun = X, *tmp;
	Element  *s_was = LastStep;
	Element *e;
	int j, ointer = interactive;

	if (s_trail)
		return 1;
	if (orun-&gt;pc-&gt;status &amp; D_ATOM)
		fatal("rv-attempt in d_step sequence", (char *)0);
	Rvous = 1;
	interactive = 0;

	j = (int) Rand()%Priority_Sum;	/* randomize start point */
	X = run;
	while (j - X-&gt;priority &gt;= 0)
	{	j -= X-&gt;priority;
		X = X-&gt;nxt;
		if (!X) X = run;
	}
	for (j = nproc - nstop; j &gt; 0; j--)
	{	if (X != orun
		&amp;&amp; (!X-&gt;prov || eval(X-&gt;prov))
		&amp;&amp; (e = eval_sub(X-&gt;pc)))
		{	if (TstOnly)
			{	X = orun;
				Rvous = 0;
				goto out;
			}
			if ((verbose&amp;32) || (verbose&amp;4))
			{	tmp = orun; orun = X; X = tmp;
				if (!s_was) s_was = X-&gt;pc;
				p_talk(s_was, 1);
				printf("	[");
				comment(stdout, s_was-&gt;n, 0);
				printf("]\n");
				tmp = orun; orun = X; X = tmp;
				if (!LastStep) LastStep = X-&gt;pc;
				p_talk(LastStep, 1);
				printf("	[");
				comment(stdout, LastStep-&gt;n, 0);
				printf("]\n");
			}
			Rvous = 0; /* before silent_moves */
			X-&gt;pc = silent_moves(e);
out:				interactive = ointer;
			return 1;
		}

		X = X-&gt;nxt;
		if (!X) X = run;
	}
	Rvous = 0;
	X = orun;
	interactive = ointer;
	return 0;
}

/***** Runtime - Local Variables *****/

static void
addsymbol(RunList *r, Symbol  *s)
{	Symbol *t;
	int i;

	for (t = r-&gt;symtab; t; t = t-&gt;next)
		if (strcmp(t-&gt;name, s-&gt;name) == 0
		&amp;&amp; (old_scope_rules
		 || strcmp((const char *)t-&gt;bscp, (const char *)s-&gt;bscp) == 0))
			return;		/* it's already there */

	t = (Symbol *) emalloc(sizeof(Symbol));
	t-&gt;name = s-&gt;name;
	t-&gt;type = s-&gt;type;
	t-&gt;hidden = s-&gt;hidden;
	t-&gt;nbits  = s-&gt;nbits;
	t-&gt;nel  = s-&gt;nel;
	t-&gt;ini  = s-&gt;ini;
	t-&gt;setat = depth;
	t-&gt;context = r-&gt;n;

	t-&gt;bscp  = (unsigned char *) emalloc(strlen((const char *)s-&gt;bscp)+1);
	strcpy((char *)t-&gt;bscp, (const char *)s-&gt;bscp);

	if (s-&gt;type != STRUCT)
	{	if (s-&gt;val)	/* if already initialized, copy info */
		{	t-&gt;val = (int *) emalloc(s-&gt;nel*sizeof(int));
			for (i = 0; i &lt; s-&gt;nel; i++)
				t-&gt;val[i] = s-&gt;val[i];
		} else
		{	(void) checkvar(t, 0);	/* initialize it */
		}
	} else
	{	if (s-&gt;Sval)
			fatal("saw preinitialized struct %s", s-&gt;name);
		t-&gt;Slst = s-&gt;Slst;
		t-&gt;Snm  = s-&gt;Snm;
		t-&gt;owner = s-&gt;owner;
	/*	t-&gt;context = r-&gt;n; */
	}
	t-&gt;next = r-&gt;symtab;	/* add it */
	r-&gt;symtab = t;
}

static void
setlocals(RunList *r)
{	Ordered	*walk;
	Symbol	*sp;
	RunList	*oX = X;

	X = r;
	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (sp
		&amp;&amp;  sp-&gt;context
		&amp;&amp;  strcmp(sp-&gt;context-&gt;name, r-&gt;n-&gt;name) == 0
		&amp;&amp;  sp-&gt;Nid &gt;= 0
		&amp;&amp; (sp-&gt;type == UNSIGNED
		||  sp-&gt;type == BIT
		||  sp-&gt;type == MTYPE
		||  sp-&gt;type == BYTE
		||  sp-&gt;type == CHAN
		||  sp-&gt;type == SHORT
		||  sp-&gt;type == INT
		||  sp-&gt;type == STRUCT))
		{	if (!findloc(sp))
			non_fatal("setlocals: cannot happen '%s'",
				sp-&gt;name);
		}
	}
	X = oX;
}

static void
oneparam(RunList *r, Lextok *t, Lextok *a, ProcList *p)
{	int k; int at, ft;
	RunList *oX = X;

	if (!a)
		fatal("missing actual parameters: '%s'", p-&gt;n-&gt;name);
	if (t-&gt;sym-&gt;nel &gt; 1 || t-&gt;sym-&gt;isarray)
		fatal("array in parameter list, %s", t-&gt;sym-&gt;name);
	k = eval(a-&gt;lft);

	at = Sym_typ(a-&gt;lft);
	X = r;	/* switch context */
	ft = Sym_typ(t);

	if (at != ft &amp;&amp; (at == CHAN || ft == CHAN))
	{	char buf[256], tag1[64], tag2[64];
		(void) sputtype(tag1, ft);
		(void) sputtype(tag2, at);
		sprintf(buf, "type-clash in params of %s(..), (%s&lt;-&gt; %s)",
			p-&gt;n-&gt;name, tag1, tag2);
		non_fatal("%s", buf);
	}
	t-&gt;ntyp = NAME;
	addsymbol(r, t-&gt;sym);
	(void) setval(t, k);
	
	X = oX;
}

static void
setparams(RunList *r, ProcList *p, Lextok *q)
{	Lextok *f, *a;	/* formal and actual pars */
	Lextok *t;	/* list of pars of 1 type */

	if (q)
	{	lineno = q-&gt;ln;
		Fname  = q-&gt;fn;
	}
	for (f = p-&gt;p, a = q; f; f = f-&gt;rgt) /* one type at a time */
	for (t = f-&gt;lft; t; t = t-&gt;rgt, a = (a)?a-&gt;rgt:a)
	{	if (t-&gt;ntyp != ',')
			oneparam(r, t, a, p);	/* plain var */
		else
			oneparam(r, t-&gt;lft, a, p); /* expanded struct */
	}
}

Symbol *
findloc(Symbol *s)
{	Symbol *r;

	if (!X)
	{	/* fatal("error, cannot eval '%s' (no proc)", s-&gt;name); */
		return ZS;
	}
	for (r = X-&gt;symtab; r; r = r-&gt;next)
		if (strcmp(r-&gt;name, s-&gt;name) == 0
		&amp;&amp; (old_scope_rules || strcmp((const char *)r-&gt;bscp, (const char *)s-&gt;bscp) == 0))
			break;
	if (!r)
	{	addsymbol(X, s);
		r = X-&gt;symtab;
	}
	return r;
}

int
in_bound(Symbol *r, int n)
{
	if (!r)	return 0;

	if (n &gt;= r-&gt;nel || n &lt; 0)
	{	printf("spin: indexing %s[%d] - size is %d\n",
			r-&gt;name, n, r-&gt;nel);
		non_fatal("indexing array \'%s\'", r-&gt;name);
		return 0;
	}
	return 1;
}

int
getlocal(Lextok *sn)
{	Symbol *r, *s = sn-&gt;sym;
	int n = eval(sn-&gt;lft);

	r = findloc(s);
	if (r &amp;&amp; r-&gt;type == STRUCT)
		return Rval_struct(sn, r, 1); /* 1 = check init */
	if (in_bound(r, n))
		return cast_val(r-&gt;type, r-&gt;val[n], r-&gt;nbits);
	return 0;
}

int
setlocal(Lextok *p, int m)
{	Symbol *r = findloc(p-&gt;sym);
	int n = eval(p-&gt;lft);

	if (in_bound(r, n))
	{	if (r-&gt;type == STRUCT)
			(void) Lval_struct(p, r, 1, m); /* 1 = check init */
		else
		{
#if 0
			if (r-&gt;nbits &gt; 0)
				m = (m &amp; ((1&lt;&lt;r-&gt;nbits)-1));
			r-&gt;val[n] = m;
#else
			r-&gt;val[n] = cast_val(r-&gt;type, m, r-&gt;nbits);
#endif
			r-&gt;setat = depth;
	}	}

	return 1;
}

void
whoruns(int lnr)
{	if (!X) return;

	if (lnr) printf("%3d:	", depth);
	printf("proc ");
	if (Have_claim &amp;&amp; X-&gt;pid == 0)
		printf(" -");
	else
		printf("%2d", X-&gt;pid - Have_claim);
	printf(" (%s) ", X-&gt;n-&gt;name);
}

static void
talk(RunList *r)
{
	if ((verbose&amp;32) || (verbose&amp;4))
	{	p_talk(r-&gt;pc, 1);
		printf("\n");
		if (verbose&amp;1) dumpglobals();
		if (verbose&amp;2) dumplocal(r);
	}
}

void
p_talk(Element *e, int lnr)
{	static int lastnever = -1;
	static char nbuf[128];
	int newnever = -1;

	if (e &amp;&amp; e-&gt;n)
		newnever = e-&gt;n-&gt;ln;

	if (Have_claim &amp;&amp; X &amp;&amp; X-&gt;pid == 0
	&amp;&amp;  lastnever != newnever &amp;&amp; e)
	{	if (xspin)
		{	printf("MSC: ~G line %d\n", newnever);
#if 0
			printf("%3d:	proc  - (NEVER) line   %d \"never\" ",
				depth, newnever);
			printf("(state 0)\t[printf('MSC: never\\\\n')]\n");
		} else
		{	printf("%3d:	proc  - (NEVER) line   %d \"never\"\n",
				depth, newnever);
#endif
		}
		lastnever = newnever;
	}

	whoruns(lnr);
	if (e)
	{	if (e-&gt;n)
		{	char *ptr = e-&gt;n-&gt;fn-&gt;name;
			char *qtr = nbuf;
			while (*ptr != '\0')
			{	if (*ptr != '"')
				{	*qtr++ = *ptr;
				}
				ptr++;
			}
			*qtr = '\0';
		} else
		{	strcpy(nbuf, "-");
		}
		printf("%s:%d (state %d)",
			nbuf,
			e-&gt;n?e-&gt;n-&gt;ln:-1,
			e-&gt;seqno);
		if (!xspin
		&amp;&amp;  ((e-&gt;status&amp;ENDSTATE) || has_lab(e, 2)))	/* 2=end */
		{	printf(" &lt;valid end state&gt;");
		}
	}
}

int
remotelab(Lextok *n)
{	int i;

	lineno = n-&gt;ln;
	Fname  = n-&gt;fn;
	if (n-&gt;sym-&gt;type != 0 &amp;&amp; n-&gt;sym-&gt;type != LABEL)
	{	printf("spin: error, type: %d\n", n-&gt;sym-&gt;type);
		fatal("not a labelname: '%s'", n-&gt;sym-&gt;name);
	}
	if (n-&gt;indstep &gt;= 0)
	{	fatal("remote ref to label '%s' inside d_step",
			n-&gt;sym-&gt;name);
	}
	if ((i = find_lab(n-&gt;sym, n-&gt;lft-&gt;sym, 1)) == 0)
		fatal("unknown labelname: %s", n-&gt;sym-&gt;name);
	return i;
}

int
remotevar(Lextok *n)
{	int prno, i, added=0;
	RunList *Y, *oX;
	Lextok *onl;
	Symbol *os;

	lineno = n-&gt;ln;
	Fname  = n-&gt;fn;

	if (!n-&gt;lft-&gt;lft)
		prno = f_pid(n-&gt;lft-&gt;sym-&gt;name);
	else
	{	prno = eval(n-&gt;lft-&gt;lft); /* pid - can cause recursive call */
#if 0
		if (n-&gt;lft-&gt;lft-&gt;ntyp == CONST)	/* user-guessed pid */
#endif
		{	prno += Have_claim;
			added = Have_claim;
	}	}

	if (prno &lt; 0)
		return 0;	/* non-existing process */
#if 0
	i = nproc - nstop;
	for (Y = run; Y; Y = Y-&gt;nxt)
	{	--i;
		printf("	%s: i=%d, prno=%d, -&gt;pid=%d\n", Y-&gt;n-&gt;name, i, prno, Y-&gt;pid);
	}
#endif
	i = nproc - nstop + Skip_claim;	/* 6.0: added Skip_claim */
	for (Y = run; Y; Y = Y-&gt;nxt)
	if (--i == prno)
	{	if (strcmp(Y-&gt;n-&gt;name, n-&gt;lft-&gt;sym-&gt;name) != 0)
		{	printf("spin: remote reference error on '%s[%d]'\n",
				n-&gt;lft-&gt;sym-&gt;name, prno-added);
			non_fatal("refers to wrong proctype '%s'", Y-&gt;n-&gt;name);
		}
		if (strcmp(n-&gt;sym-&gt;name, "_p") == 0)
		{	if (Y-&gt;pc)
				return Y-&gt;pc-&gt;seqno;
			/* harmless, can only happen with -t */
			return 0;
		}
#if 1
		/* new 4.0 allow remote variables */
		oX = X;
		X = Y;

		onl = n-&gt;lft;
		n-&gt;lft = n-&gt;rgt;

		os = n-&gt;sym;
		n-&gt;sym = findloc(n-&gt;sym);

		i = getval(n);

		n-&gt;sym = os;
		n-&gt;lft = onl;
		X = oX;
		return i;
#else
		break;
#endif
	}
	printf("remote ref: %s[%d] ", n-&gt;lft-&gt;sym-&gt;name, prno-added);
	non_fatal("%s not found", n-&gt;sym-&gt;name);
	printf("have only:\n");
	i = nproc - nstop - 1;
	for (Y = run; Y; Y = Y-&gt;nxt, i--)
		if (!strcmp(Y-&gt;n-&gt;name, n-&gt;lft-&gt;sym-&gt;name))
		printf("\t%d\t%s\n", i, Y-&gt;n-&gt;name);

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

