<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/structs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/structs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: structs.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

typedef struct UType {
	Symbol *nm;	/* name of the type */
	Lextok *cn;	/* contents */
	struct UType *nxt;	/* linked list */
} UType;

extern	Symbol	*Fname;
extern	int	lineno, depth, Expand_Ok, has_hidden, in_for;

Symbol	*owner;

static UType *Unames = 0;
static UType *Pnames = 0;

static Lextok	*cpnn(Lextok *, int, int, int);
extern void	sr_mesg(FILE *, int, int);

void
setuname(Lextok *n)
{	UType *tmp;

	if (!owner)
		fatal("illegal reference inside typedef", (char *) 0);

	for (tmp = Unames; tmp; tmp = tmp-&gt;nxt)
		if (!strcmp(owner-&gt;name, tmp-&gt;nm-&gt;name))
		{	non_fatal("typename %s was defined before",
				tmp-&gt;nm-&gt;name);
			return;
		}

	tmp = (UType *) emalloc(sizeof(UType));
	tmp-&gt;nm = owner;
	tmp-&gt;cn = n;
	tmp-&gt;nxt = Unames;
	Unames = tmp;
}

static void
putUname(FILE *fd, UType *tmp)
{	Lextok *fp, *tl;

	if (!tmp) return;
	putUname(fd, tmp-&gt;nxt); /* postorder */
	fprintf(fd, "struct %s { /* user defined type */\n",
		tmp-&gt;nm-&gt;name);
	for (fp = tmp-&gt;cn; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
		typ2c(tl-&gt;sym);
	fprintf(fd, "};\n");
}

void
putunames(FILE *fd)
{
	putUname(fd, Unames);
}

int
isutype(char *t)
{	UType *tmp;

	for (tmp = Unames; tmp; tmp = tmp-&gt;nxt)
	{	if (!strcmp(t, tmp-&gt;nm-&gt;name))
			return 1;
	}
	return 0;
}

Lextok *
getuname(Symbol *t)
{	UType *tmp;

	for (tmp = Unames; tmp; tmp = tmp-&gt;nxt)
	{	if (!strcmp(t-&gt;name, tmp-&gt;nm-&gt;name))
			return tmp-&gt;cn;
	}
	fatal("%s is not a typename", t-&gt;name);
	return (Lextok *)0;
}

void
setutype(Lextok *p, Symbol *t, Lextok *vis)	/* user-defined types */
{	int oln = lineno;
	Symbol *ofn = Fname;
	Lextok *m, *n;

	m = getuname(t);
	for (n = p; n; n = n-&gt;rgt)
	{	lineno = n-&gt;ln;
		Fname = n-&gt;fn;
		if (n-&gt;sym-&gt;type)
			fatal("redeclaration of '%s'", n-&gt;sym-&gt;name);

		if (n-&gt;sym-&gt;nbits &gt; 0)
			non_fatal("(%s) only an unsigned can have width-field",
				n-&gt;sym-&gt;name);

		if (Expand_Ok)
			n-&gt;sym-&gt;hidden |= (4|8|16); /* formal par */

		if (vis)
		{	if (strncmp(vis-&gt;sym-&gt;name, ":hide:", (size_t) 6) == 0)
			{	n-&gt;sym-&gt;hidden |= 1;
				has_hidden++;
			} else if (strncmp(vis-&gt;sym-&gt;name, ":show:", (size_t) 6) == 0)
				n-&gt;sym-&gt;hidden |= 2;
			else if (strncmp(vis-&gt;sym-&gt;name, ":local:", (size_t) 7) == 0)
				n-&gt;sym-&gt;hidden |= 64;
		}
		n-&gt;sym-&gt;type = STRUCT;	/* classification   */
		n-&gt;sym-&gt;Slst = m;	/* structure itself */
		n-&gt;sym-&gt;Snm  = t;	/* name of typedef  */
		n-&gt;sym-&gt;Nid  = 0;	/* this is no chan  */
		n-&gt;sym-&gt;hidden |= 4;
		if (n-&gt;sym-&gt;nel &lt;= 0)
		non_fatal("bad array size for '%s'", n-&gt;sym-&gt;name);
	}
	lineno = oln;
	Fname = ofn;
}

static Symbol *
do_same(Lextok *n, Symbol *v, int xinit)
{	Lextok *tmp, *fp, *tl;
	int ix = eval(n-&gt;lft);
	int oln = lineno;
	Symbol *ofn = Fname;

	lineno = n-&gt;ln;
	Fname = n-&gt;fn;
	
	/* n-&gt;sym-&gt;type == STRUCT
	 * index:		n-&gt;lft
	 * subfields:		n-&gt;rgt
	 * structure template:	n-&gt;sym-&gt;Slst
	 * runtime values:	n-&gt;sym-&gt;Sval
	 */
	if (xinit) ini_struct(v);	/* once, at top level */

	if (ix &gt;= v-&gt;nel || ix &lt; 0)
	{	printf("spin: indexing %s[%d] - size is %d\n",
				v-&gt;name, ix, v-&gt;nel);
		fatal("indexing error \'%s\'", v-&gt;name);
	}
	if (!n-&gt;rgt || !n-&gt;rgt-&gt;lft)
	{	non_fatal("no subfields %s", v-&gt;name);	/* i.e., wants all */
		lineno = oln; Fname = ofn;
		return ZS;
	}

	if (n-&gt;rgt-&gt;ntyp != '.')
	{	printf("bad subfield type %d\n", n-&gt;rgt-&gt;ntyp);
		alldone(1);
	}

	tmp = n-&gt;rgt-&gt;lft;
	if (tmp-&gt;ntyp != NAME &amp;&amp; tmp-&gt;ntyp != TYPE)
	{	printf("bad subfield entry %d\n", tmp-&gt;ntyp);
		alldone(1);
	}
	for (fp = v-&gt;Sval[ix]; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
		if (!strcmp(tl-&gt;sym-&gt;name, tmp-&gt;sym-&gt;name))
		{	lineno = oln; Fname = ofn;
			return tl-&gt;sym;
		}
	fatal("cannot locate subfield %s", tmp-&gt;sym-&gt;name);
	return ZS;
}

int
Rval_struct(Lextok *n, Symbol *v, int xinit)	/* n varref, v valref */
{	Symbol *tl;
	Lextok *tmp;
	int ix;

	if (!n || !(tl = do_same(n, v, xinit)))
		return 0;

	tmp = n-&gt;rgt-&gt;lft;
	if (tmp-&gt;sym-&gt;type == STRUCT)
	{	return Rval_struct(tmp, tl, 0);
	} else if (tmp-&gt;rgt)
		fatal("non-zero 'rgt' on non-structure", 0);

	ix = eval(tmp-&gt;lft);
/*	printf("%d: ix: %d (%d) %d\n", depth, ix, tl-&gt;nel, tl-&gt;val[ix]); */
	if (ix &gt;= tl-&gt;nel || ix &lt; 0)
		fatal("indexing error \'%s\'", tl-&gt;name);

	return cast_val(tl-&gt;type, tl-&gt;val[ix], tl-&gt;nbits);
}

int
Lval_struct(Lextok *n, Symbol *v, int xinit, int a)  /* a = assigned value */
{	Symbol *tl;
	Lextok *tmp;
	int ix;

	if (!(tl = do_same(n, v, xinit)))
		return 1;

	tmp = n-&gt;rgt-&gt;lft;
	if (tmp-&gt;sym-&gt;type == STRUCT)
		return Lval_struct(tmp, tl, 0, a);
	else if (tmp-&gt;rgt)
		fatal("non-zero 'rgt' on non-structure", 0);

	ix = eval(tmp-&gt;lft);
	if (ix &gt;= tl-&gt;nel || ix &lt; 0)
		fatal("indexing error \'%s\'", tl-&gt;name);

	if (tl-&gt;nbits &gt; 0)
		a = (a &amp; ((1&lt;&lt;tl-&gt;nbits)-1));

	if (a != tl-&gt;val[ix])
	{	tl-&gt;val[ix] = a;
		tl-&gt;setat = depth;
	}
	return 1;
}

int
Cnt_flds(Lextok *m)
{	Lextok *fp, *tl, *n;
	int cnt = 0;

	if (m-&gt;ntyp == ',')
	{	n = m;
		goto is_lst;
	}
	if (!m-&gt;sym || m-&gt;ntyp != STRUCT)
		return 1;

	n = getuname(m-&gt;sym);
is_lst:
	for (fp = n; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
	{	if (tl-&gt;sym-&gt;type == STRUCT)
		{	if (tl-&gt;sym-&gt;nel &gt; 1 || tl-&gt;sym-&gt;isarray)
				fatal("array of structures in param list, %s",
					tl-&gt;sym-&gt;name);
			cnt += Cnt_flds(tl-&gt;sym-&gt;Slst);
		}  else
			cnt += tl-&gt;sym-&gt;nel;
	}
	return cnt;
}

int
Sym_typ(Lextok *t)
{	Symbol *s = t-&gt;sym;

	if (!s) return 0;

	if (s-&gt;type != STRUCT)
		return s-&gt;type;

	if (!t-&gt;rgt
	||   t-&gt;rgt-&gt;ntyp != '.'	/* gh: had ! in wrong place */
	||  !t-&gt;rgt-&gt;lft)
		return STRUCT;		/* not a field reference */

	return Sym_typ(t-&gt;rgt-&gt;lft);
}

int
Width_set(int *wdth, int i, Lextok *n)
{	Lextok *fp, *tl;
	int j = i, k;

	for (fp = n; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
	{	if (tl-&gt;sym-&gt;type == STRUCT)
			j = Width_set(wdth, j, tl-&gt;sym-&gt;Slst);
		else
		{	for (k = 0; k &lt; tl-&gt;sym-&gt;nel; k++, j++)
				wdth[j] = tl-&gt;sym-&gt;type;
	}	}
	return j;
}

void
ini_struct(Symbol *s)
{	int i; Lextok *fp, *tl;

	if (s-&gt;type != STRUCT)	/* last step */
	{	(void) checkvar(s, 0);
		return;
	}
	if (s-&gt;Sval == (Lextok **) 0)
	{	s-&gt;Sval = (Lextok **) emalloc(s-&gt;nel * sizeof(Lextok *));
		for (i = 0; i &lt; s-&gt;nel; i++)
		{	s-&gt;Sval[i] = cpnn(s-&gt;Slst, 1, 1, 1);

			for (fp = s-&gt;Sval[i]; fp; fp = fp-&gt;rgt)
			for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
				ini_struct(tl-&gt;sym);
	}	}
}

static Lextok *
cpnn(Lextok *s, int L, int R, int S)
{	Lextok *d; extern int Nid;

	if (!s) return ZN;

	d = (Lextok *) emalloc(sizeof(Lextok));
	d-&gt;uiid = s-&gt;uiid;
	d-&gt;ntyp = s-&gt;ntyp;
	d-&gt;val  = s-&gt;val;
	d-&gt;ln   = s-&gt;ln;
	d-&gt;fn   = s-&gt;fn;
	d-&gt;sym  = s-&gt;sym;
	if (L) d-&gt;lft = cpnn(s-&gt;lft, 1, 1, S);
	if (R) d-&gt;rgt = cpnn(s-&gt;rgt, 1, 1, S);

	if (S &amp;&amp; s-&gt;sym)
	{	d-&gt;sym = (Symbol *) emalloc(sizeof(Symbol));
		memcpy(d-&gt;sym, s-&gt;sym, sizeof(Symbol));
		if (d-&gt;sym-&gt;type == CHAN)
			d-&gt;sym-&gt;Nid = ++Nid;
	}
	if (s-&gt;sq || s-&gt;sl)
		fatal("cannot happen cpnn", (char *) 0);

	return d;
}

int
full_name(FILE *fd, Lextok *n, Symbol *v, int xinit)
{	Symbol *tl;
	Lextok *tmp;
	int hiddenarrays = 0;

	fprintf(fd, "%s", v-&gt;name);

	if (!n || !(tl = do_same(n, v, xinit)))
		return 0;
	tmp = n-&gt;rgt-&gt;lft;

	if (tmp-&gt;sym-&gt;type == STRUCT)
	{	fprintf(fd, ".");
		hiddenarrays = full_name(fd, tmp, tl, 0);
		goto out;
	}
	fprintf(fd, ".%s", tl-&gt;name);
out:	if (tmp-&gt;sym-&gt;nel &gt; 1 || tmp-&gt;sym-&gt;isarray == 1)
	{	fprintf(fd, "[%d]", eval(tmp-&gt;lft));
		hiddenarrays = 1;
	}
	return hiddenarrays;
}

void
validref(Lextok *p, Lextok *c)
{	Lextok *fp, *tl;
	char lbuf[512];

	for (fp = p-&gt;sym-&gt;Slst; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
		if (strcmp(tl-&gt;sym-&gt;name, c-&gt;sym-&gt;name) == 0)
			return;

	sprintf(lbuf, "no field '%s' defined in structure '%s'\n",
		c-&gt;sym-&gt;name, p-&gt;sym-&gt;name);
	non_fatal(lbuf, (char *) 0);
}

void
struct_name(Lextok *n, Symbol *v, int xinit, char *buf)
{	Symbol *tl;
	Lextok *tmp;
	char lbuf[512];

	if (!n || !(tl = do_same(n, v, xinit)))
		return;
	tmp = n-&gt;rgt-&gt;lft;
	if (tmp-&gt;sym-&gt;type == STRUCT)
	{	strcat(buf, ".");
		struct_name(tmp, tl, 0, buf);
		return;
	}
	sprintf(lbuf, ".%s", tl-&gt;name);
	strcat(buf, lbuf);
	if (tmp-&gt;sym-&gt;nel &gt; 1 || tmp-&gt;sym-&gt;isarray == 1)
	{	sprintf(lbuf, "[%d]", eval(tmp-&gt;lft));
		strcat(buf, lbuf);
	}
}

void
walk2_struct(char *s, Symbol *z)
{	Lextok *fp, *tl;
	char eprefix[128];
	int ix;
	extern void Done_case(char *, Symbol *);

	ini_struct(z);
	if (z-&gt;nel == 1 &amp;&amp; z-&gt;isarray == 0)
		sprintf(eprefix, "%s%s.", s, z-&gt;name);
	for (ix = 0; ix &lt; z-&gt;nel; ix++)
	{	if (z-&gt;nel &gt; 1 || z-&gt;isarray == 1)
			sprintf(eprefix, "%s%s[%d].", s, z-&gt;name, ix);
		for (fp = z-&gt;Sval[ix]; fp; fp = fp-&gt;rgt)
		for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
		{	if (tl-&gt;sym-&gt;type == STRUCT)
				walk2_struct(eprefix, tl-&gt;sym);
			else if (tl-&gt;sym-&gt;type == CHAN)
				Done_case(eprefix, tl-&gt;sym);
	}	}
}

void
walk_struct(FILE *ofd, int dowhat, char *s, Symbol *z, char *a, char *b, char *c)
{	Lextok *fp, *tl;
	char eprefix[128];
	int ix;

	ini_struct(z);
	if (z-&gt;nel == 1 &amp;&amp; z-&gt;isarray == 0)
		sprintf(eprefix, "%s%s.", s, z-&gt;name);
	for (ix = 0; ix &lt; z-&gt;nel; ix++)
	{	if (z-&gt;nel &gt; 1 || z-&gt;isarray == 1)
			sprintf(eprefix, "%s%s[%d].", s, z-&gt;name, ix);
		for (fp = z-&gt;Sval[ix]; fp; fp = fp-&gt;rgt)
		for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
		{	if (tl-&gt;sym-&gt;type == STRUCT)
			 walk_struct(ofd, dowhat, eprefix, tl-&gt;sym, a,b,c);
			else
			 do_var(ofd, dowhat, eprefix, tl-&gt;sym, a,b,c);
	}	}
}

void
c_struct(FILE *fd, char *ipref, Symbol *z)
{	Lextok *fp, *tl;
	char pref[256], eprefix[300];
	int ix;

	ini_struct(z);

	for (ix = 0; ix &lt; z-&gt;nel; ix++)
	for (fp = z-&gt;Sval[ix]; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
	{	strcpy(eprefix, ipref);
		if (z-&gt;nel &gt; 1 || z-&gt;isarray == 1)
		{	/* insert index before last '.' */
			eprefix[strlen(eprefix)-1] = '\0';
			sprintf(pref, "[ %d ].", ix);
			strcat(eprefix, pref);
		}
		if (tl-&gt;sym-&gt;type == STRUCT)
		{	strcat(eprefix, tl-&gt;sym-&gt;name);
			strcat(eprefix, ".");
			c_struct(fd, eprefix, tl-&gt;sym);
		} else
			c_var(fd, eprefix, tl-&gt;sym);
	}
}

void
dump_struct(Symbol *z, char *prefix, RunList *r)
{	Lextok *fp, *tl;
	char eprefix[256];
	int ix, jx;

	ini_struct(z);

	for (ix = 0; ix &lt; z-&gt;nel; ix++)
	{	if (z-&gt;nel &gt; 1 || z-&gt;isarray == 1)
			sprintf(eprefix, "%s[%d]", prefix, ix);
		else
			strcpy(eprefix, prefix);
		
		for (fp = z-&gt;Sval[ix]; fp; fp = fp-&gt;rgt)
		for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
		{	if (tl-&gt;sym-&gt;type == STRUCT)
			{	char pref[300];
				strcpy(pref, eprefix);
				strcat(pref, ".");
				strcat(pref, tl-&gt;sym-&gt;name);
				dump_struct(tl-&gt;sym, pref, r);
			} else
			for (jx = 0; jx &lt; tl-&gt;sym-&gt;nel; jx++)
			{	if (tl-&gt;sym-&gt;type == CHAN)
					doq(tl-&gt;sym, jx, r);
				else
				{	printf("\t\t");
					if (r)
					printf("%s(%d):", r-&gt;n-&gt;name, r-&gt;pid);
					printf("%s.%s", eprefix, tl-&gt;sym-&gt;name);
					if (tl-&gt;sym-&gt;nel &gt; 1 || tl-&gt;sym-&gt;isarray == 1)
						printf("[%d]", jx);
					printf(" = ");
					sr_mesg(stdout, tl-&gt;sym-&gt;val[jx],
						tl-&gt;sym-&gt;type == MTYPE);
					printf("\n");
		}	}	}
	}
}

static int
retrieve(Lextok **targ, int i, int want, Lextok *n, int Ntyp)
{	Lextok *fp, *tl;
	int j = i, k;

	for (fp = n; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
	{	if (tl-&gt;sym-&gt;type == STRUCT)
		{	j = retrieve(targ, j, want, tl-&gt;sym-&gt;Slst, Ntyp);
			if (j &lt; 0)
			{	Lextok *x = cpnn(tl, 1, 0, 0);
				x-&gt;rgt = nn(ZN, '.', (*targ), ZN);
				(*targ) = x;
				return -1;
			}
		} else
		{	for (k = 0; k &lt; tl-&gt;sym-&gt;nel; k++, j++)
			{	if (j == want)
				{	*targ = cpnn(tl, 1, 0, 0);
					(*targ)-&gt;lft = nn(ZN, CONST, ZN, ZN);
					(*targ)-&gt;lft-&gt;val = k;
					if (Ntyp)
					(*targ)-&gt;ntyp = (short) Ntyp;
					return -1;
				}
	}	}	}
	return j;
}

static int
is_explicit(Lextok *n)
{
	if (!n) return 0;
	if (!n-&gt;sym) fatal("unexpected - no symbol", 0);
	if (n-&gt;sym-&gt;type != STRUCT) return 1;
	if (!n-&gt;rgt) return 0;
	if (n-&gt;rgt-&gt;ntyp != '.')
	{	lineno = n-&gt;ln;
		Fname  = n-&gt;fn;
		printf("ntyp %d\n", n-&gt;rgt-&gt;ntyp);
		fatal("unexpected %s, no '.'", n-&gt;sym-&gt;name);
	}
	return is_explicit(n-&gt;rgt-&gt;lft);
}

Lextok *
expand(Lextok *n, int Ok)
	/* turn rgt-lnked list of struct nms, into ',' list of flds */
{	Lextok *x = ZN, *y;

	if (!Ok) return n;

	while (n)
	{	y = mk_explicit(n, 1, 0);
		if (x)
			(void) tail_add(x, y);
		else
			x = y;

		n = n-&gt;rgt;
	}
	return x;
}

Lextok *
mk_explicit(Lextok *n, int Ok, int Ntyp)
	/* produce a single ',' list of fields */
{	Lextok *bld = ZN, *x;
	int i, cnt; extern int IArgs;

	if (n-&gt;sym-&gt;type != STRUCT
	||  in_for
	||  is_explicit(n))
		return n;


	if (n-&gt;rgt
	&amp;&amp;  n-&gt;rgt-&gt;ntyp == '.'
	&amp;&amp;  n-&gt;rgt-&gt;lft
	&amp;&amp;  n-&gt;rgt-&gt;lft-&gt;sym
	&amp;&amp;  n-&gt;rgt-&gt;lft-&gt;sym-&gt;type == STRUCT)
	{	Lextok *y;
		bld = mk_explicit(n-&gt;rgt-&gt;lft, Ok, Ntyp);
		for (x = bld; x; x = x-&gt;rgt)
		{	y = cpnn(n, 1, 0, 0);
			y-&gt;rgt = nn(ZN, '.', x-&gt;lft, ZN);
			x-&gt;lft = y;
		}

		return bld;
	}

	if (!Ok || !n-&gt;sym-&gt;Slst)
	{	if (IArgs) return n;
		printf("spin: saw '");
		comment(stdout, n, 0);
		printf("'\n");
		fatal("incomplete structure ref '%s'", n-&gt;sym-&gt;name);
	}

	cnt = Cnt_flds(n-&gt;sym-&gt;Slst);
	for (i = cnt-1; i &gt;= 0; i--)
	{	bld = nn(ZN, ',', ZN, bld);
		if (retrieve(&amp;(bld-&gt;lft), 0, i, n-&gt;sym-&gt;Slst, Ntyp) &gt;= 0)
		{	printf("cannot retrieve field %d\n", i);
			fatal("bad structure %s", n-&gt;sym-&gt;name);
		}
		x = cpnn(n, 1, 0, 0);
		x-&gt;rgt = nn(ZN, '.', bld-&gt;lft, ZN);
		bld-&gt;lft = x;
	}
	return bld;
}

Lextok *
tail_add(Lextok *a, Lextok *b)
{	Lextok *t;

	for (t = a; t-&gt;rgt; t = t-&gt;rgt)
		if (t-&gt;ntyp != ',')
		fatal("unexpected type - tail_add", 0);
	t-&gt;rgt = b;
	return a;
}

void
setpname(Lextok *n)
{	UType *tmp;

	for (tmp = Pnames; tmp; tmp = tmp-&gt;nxt)
		if (!strcmp(n-&gt;sym-&gt;name, tmp-&gt;nm-&gt;name))
		{	non_fatal("proctype %s redefined",
				n-&gt;sym-&gt;name);
			return;
		}
	tmp = (UType *) emalloc(sizeof(UType));
	tmp-&gt;nm = n-&gt;sym;
	tmp-&gt;nxt = Pnames;
	Pnames = tmp;
}

int
isproctype(char *t)
{	UType *tmp;

	for (tmp = Pnames; tmp; tmp = tmp-&gt;nxt)
	{	if (!strcmp(t, tmp-&gt;nm-&gt;name))
			return 1;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

