<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/tl_rewrt.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/tl_rewrt.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** tl_spin: tl_rewrt.c *****/

/* Copyright (c) 1995-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

/* Based on the translation algorithm by Gerth, Peled, Vardi, and Wolper, */
/* presented at the PSTV Conference, held in 1995, Warsaw, Poland 1995.   */

#include "tl.h"

extern int	tl_verbose;

static Node	*can = ZN;

void
ini_rewrt(void)
{
	can = ZN;
}

Node *
right_linked(Node *n)
{
	if (!n) return n;

	if (n-&gt;ntyp == AND || n-&gt;ntyp == OR)
		while (n-&gt;lft &amp;&amp; n-&gt;lft-&gt;ntyp == n-&gt;ntyp)
		{	Node *tmp = n-&gt;lft;
			n-&gt;lft = tmp-&gt;rgt;
			tmp-&gt;rgt = n;
			n = tmp;
		}

	n-&gt;lft = right_linked(n-&gt;lft);
	n-&gt;rgt = right_linked(n-&gt;rgt);

	return n;
}

Node *
canonical(Node *n)
{	Node *m;	/* assumes input is right_linked */

	if (!n) return n;
	if ((m = in_cache(n)) != ZN)
		return m;

	n-&gt;rgt = canonical(n-&gt;rgt);
	n-&gt;lft = canonical(n-&gt;lft);

	return cached(n);
}

Node *
push_negation(Node *n)
{	Node *m;

	Assert(n-&gt;ntyp == NOT, n-&gt;ntyp);

	switch (n-&gt;lft-&gt;ntyp) {
	case TRUE:
		Debug("!true =&gt; false\n");
		releasenode(0, n-&gt;lft);
		n-&gt;lft = ZN;
		n-&gt;ntyp = FALSE;
		break;
	case FALSE:
		Debug("!false =&gt; true\n");
		releasenode(0, n-&gt;lft);
		n-&gt;lft = ZN;
		n-&gt;ntyp = TRUE;
		break;
	case NOT:
		Debug("!!p =&gt; p\n");
		m = n-&gt;lft-&gt;lft;
		releasenode(0, n-&gt;lft);
		n-&gt;lft = ZN;
		releasenode(0, n);
		n = m;
		break;
	case V_OPER:
		Debug("!(p V q) =&gt; (!p U !q)\n");
		n-&gt;ntyp = U_OPER;
		goto same;
	case U_OPER:
		Debug("!(p U q) =&gt; (!p V !q)\n");
		n-&gt;ntyp = V_OPER;
		goto same;
#ifdef NXT
	case NEXT:
		Debug("!X -&gt; X!\n");
		n-&gt;ntyp = NEXT;
		n-&gt;lft-&gt;ntyp = NOT;
		n-&gt;lft = push_negation(n-&gt;lft);
		break;
#endif
	case  AND:
		Debug("!(p &amp;&amp; q) =&gt; !p || !q\n"); 
		n-&gt;ntyp = OR;
		goto same;
	case  OR:
		Debug("!(p || q) =&gt; !p &amp;&amp; !q\n");
		n-&gt;ntyp = AND;

same:		m = n-&gt;lft-&gt;rgt;
		n-&gt;lft-&gt;rgt = ZN;

		n-&gt;rgt = Not(m);
		n-&gt;lft-&gt;ntyp = NOT;
		m = n-&gt;lft;
		n-&gt;lft = push_negation(m);
		break;
	}

	return rewrite(n);
}

static void
addcan(int tok, Node *n)
{	Node	*m, *prev = ZN;
	Node	**ptr;
	Node	*N;
	Symbol	*s, *t; int cmp;

	if (!n) return;

	if (n-&gt;ntyp == tok)
	{	addcan(tok, n-&gt;rgt);
		addcan(tok, n-&gt;lft);
		return;
	}

	N = dupnode(n);
	if (!can)	
	{	can = N;
		return;
	}

	s = DoDump(N);
	if (can-&gt;ntyp != tok)	/* only one element in list so far */
	{	ptr = &amp;can;
		goto insert;
	}

	/* there are at least 2 elements in list */
	prev = ZN;
	for (m = can; m-&gt;ntyp == tok &amp;&amp; m-&gt;rgt; prev = m, m = m-&gt;rgt)
	{	t = DoDump(m-&gt;lft);
		if (t != ZS)
			cmp = strcmp(s-&gt;name, t-&gt;name);
		else
			cmp = 0;
		if (cmp == 0)	/* duplicate */
			return;
		if (cmp &lt; 0)
		{	if (!prev)
			{	can = tl_nn(tok, N, can);
				return;
			} else
			{	ptr = &amp;(prev-&gt;rgt);
				goto insert;
	}	}	}

	/* new entry goes at the end of the list */
	ptr = &amp;(prev-&gt;rgt);
insert:
	t = DoDump(*ptr);
	cmp = strcmp(s-&gt;name, t-&gt;name);
	if (cmp == 0)	/* duplicate */
		return;
	if (cmp &lt; 0)
		*ptr = tl_nn(tok, N, *ptr);
	else
		*ptr = tl_nn(tok, *ptr, N);
}

static void
marknode(int tok, Node *m)
{
	if (m-&gt;ntyp != tok)
	{	releasenode(0, m-&gt;rgt);
		m-&gt;rgt = ZN;
	}
	m-&gt;ntyp = -1;
}

Node *
Canonical(Node *n)
{	Node *m, *p, *k1, *k2, *prev, *dflt = ZN;
	int tok;

	if (!n) return n;

	tok = n-&gt;ntyp;
	if (tok != AND &amp;&amp; tok != OR)
		return n;

	can = ZN;
	addcan(tok, n);
#if 0
	Debug("\nA0: "); Dump(can); 
	Debug("\nA1: "); Dump(n); Debug("\n");
#endif
	releasenode(1, n);

	/* mark redundant nodes */
	if (tok == AND)
	{	for (m = can; m; m = (m-&gt;ntyp == AND) ? m-&gt;rgt : ZN)
		{	k1 = (m-&gt;ntyp == AND) ? m-&gt;lft : m;
			if (k1-&gt;ntyp == TRUE)
			{	marknode(AND, m);
				dflt = True;
				continue;
			}
			if (k1-&gt;ntyp == FALSE)
			{	releasenode(1, can);
				can = False;
				goto out;
		}	}
		for (m = can; m; m = (m-&gt;ntyp == AND) ? m-&gt;rgt : ZN)
		for (p = can; p; p = (p-&gt;ntyp == AND) ? p-&gt;rgt : ZN)
		{	if (p == m
			||  p-&gt;ntyp == -1
			||  m-&gt;ntyp == -1)
				continue;
			k1 = (m-&gt;ntyp == AND) ? m-&gt;lft : m;
			k2 = (p-&gt;ntyp == AND) ? p-&gt;lft : p;

			if (isequal(k1, k2))
			{	marknode(AND, p);
				continue;
			}
			if (anywhere(OR, k1, k2))
			{	marknode(AND, p);
				continue;
			}
	}	}
	if (tok == OR)
	{	for (m = can; m; m = (m-&gt;ntyp == OR) ? m-&gt;rgt : ZN)
		{	k1 = (m-&gt;ntyp == OR) ? m-&gt;lft : m;
			if (k1-&gt;ntyp == FALSE)
			{	marknode(OR, m);
				dflt = False;
				continue;
			}
			if (k1-&gt;ntyp == TRUE)
			{	releasenode(1, can);
				can = True;
				goto out;
		}	}
		for (m = can; m; m = (m-&gt;ntyp == OR) ? m-&gt;rgt : ZN)
		for (p = can; p; p = (p-&gt;ntyp == OR) ? p-&gt;rgt : ZN)
		{	if (p == m
			||  p-&gt;ntyp == -1
			||  m-&gt;ntyp == -1)
				continue;
			k1 = (m-&gt;ntyp == OR) ? m-&gt;lft : m;
			k2 = (p-&gt;ntyp == OR) ? p-&gt;lft : p;

			if (isequal(k1, k2))
			{	marknode(OR, p);
				continue;
			}
			if (anywhere(AND, k1, k2))
			{	marknode(OR, p);
				continue;
			}
	}	}
	for (m = can, prev = ZN; m; )	/* remove marked nodes */
	{	if (m-&gt;ntyp == -1)
		{	k2 = m-&gt;rgt;
			releasenode(0, m);
			if (!prev)
			{	m = can = can-&gt;rgt;
			} else
			{	m = prev-&gt;rgt = k2;
				/* if deleted the last node in a chain */
				if (!prev-&gt;rgt &amp;&amp; prev-&gt;lft
				&amp;&amp;  (prev-&gt;ntyp == AND || prev-&gt;ntyp == OR))
				{	k1 = prev-&gt;lft;
					prev-&gt;ntyp = prev-&gt;lft-&gt;ntyp;
					prev-&gt;sym = prev-&gt;lft-&gt;sym;
					prev-&gt;rgt = prev-&gt;lft-&gt;rgt;
					prev-&gt;lft = prev-&gt;lft-&gt;lft;
					releasenode(0, k1);
				}
			}
			continue;
		}
		prev = m;
		m = m-&gt;rgt;
	}
out:
#if 0
	Debug("A2: "); Dump(can); Debug("\n");
#endif
	if (!can)
	{	if (!dflt)
			fatal("cannot happen, Canonical", (char *) 0);
		return dflt;
	}

	return can;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

