<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/srvold9p/fcall.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/srvold9p/fcall.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "9p1.h"

#define	MAXFDATA	(8*1024)
#define	MAXRPC		(MAXFDATA+160)

/*
 * reassemble 9P messages for stream based protocols
 * interposed between devmnt and the network by srv for tcp connections
 * fcall expects devmnt on fd0, network fd1
 */
uchar msglen[256] =
{
	[Tnop9p1]		3,
	[Rnop9p1]		3,
	[Tsession9p1]	3+CHALLEN,
	[Rsession9p1]	3+NAMEREC+DOMLEN+CHALLEN,
	[Terror9p1]	0,
	[Rerror9p1]	67,
	[Tflush9p1]	5,
	[Rflush9p1]	3,
	[Tattach9p1]	5+2*NAMEREC+TICKETLEN+AUTHENTLEN,
	[Rattach9p1]	13+AUTHENTLEN,
	[Tclone9p1]	7,
	[Rclone9p1]	5,
	[Twalk9p1]		33,
	[Rwalk9p1]		13,
	[Topen9p1]		6,
	[Ropen9p1]		13,
	[Tcreate9p1]	38,
	[Rcreate9p1]	13,
	[Tread9p1]		15,
	[Rread9p1]		8,
	[Twrite9p1]	16,
	[Rwrite9p1]	7,
	[Tclunk9p1]	5,
	[Rclunk9p1]	5,
	[Tremove9p1]	5,
	[Rremove9p1]	5,
	[Tstat9p1]		5,
	[Rstat9p1]		121,
	[Twstat9p1]	121,
	[Rwstat9p1]	5,
	[Tclwalk9p1]	35,
	[Rclwalk9p1]	13,
};

enum
{
	Twritehdr	= 16,	/* Min bytes for Twrite */
	Rreadhdr	= 8,	/* Min bytes for Rread */
	Twritecnt	= 13,	/* Offset in byte stream of write count */
	Rreadcnt	= 5,	/* Offset for Readcnt */
};

int
mntrpclen(uchar *d, int n)
{
	uchar t;
	int len, off;

	if(n &lt; 1)
		return 0;

	t = d[0];
	switch(t) {			/* This is the type */
	default:
		len = msglen[t];
		if(len == 0)		/* Illegal type so consume */
			return n;
		if(n &lt; len)
			return 0;
		return len;
	case Twrite9p1:			/* Fmt: TGGFFOOOOOOOOCC */
		len = Twritehdr;	/* T = type, G = tag, F = fid */
		off = Twritecnt;	/* O = offset, C = count */
		break;
	case Rread9p1:			/* Fmt: TGGFFCC */
		len = Rreadhdr;
		off = Rreadcnt;
		break;
	}
	if(n &lt; off+2)
		return 0;

	len += d[off]|(d[off+1]&lt;&lt;8);
	if(n &lt; len)
		return 0;

	return len;
}

int
fcall(int fd)
{
	int i, r, n, l;
	uchar *p, *buf;
	int pipefd[2];

	if(pipe(pipefd) &lt; 0)
		fatal("fcall pipe: %r");

	buf = malloc(MAXRPC);
	if(buf == nil)
		fatal("fcall malloc");

	switch(rfork(RFPROC|RFMEM|RFFDG|RFCNAMEG)){
	default:
		return pipefd[0];	/* parent returns fd */	
	case 0:
		break;	/* child builds buffers */
	case -1:
		fatal("fcall fork: %r");
	}

	/* close file descriptors */
	for(i=0; i&lt;20; i++)
		if(i!=fd &amp;&amp; i!=pipefd[1])
			close(i);

	l = MAXRPC;
	p = buf;
	for(;;) {
		n = read(fd, p, l);
		if(n &lt; 0)
			break;
		p += n;
		l -= n;

		for(;;) {
			r = mntrpclen(buf, p - buf);
			if(r == 0)
				break;

			if(write(pipefd[1], buf, r) &lt; 0)
				break;

			n = (p - buf) - r;
			memmove(buf, buf+r, n);
			p = buf+n;
			l = MAXRPC - n;
		}
	}
	close(pipefd[1]);
	fatal(nil);
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

