<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ssh1/msg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ssh1/msg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "ssh.h"

static ulong sum32(ulong, void*, int);

char *msgnames[] =
{
/* 0 */
	"SSH_MSG_NONE",
	"SSH_MSG_DISCONNECT",
	"SSH_SMSG_PUBLIC_KEY",
	"SSH_CMSG_SESSION_KEY",
	"SSH_CMSG_USER",
	"SSH_CMSG_AUTH_RHOSTS",
	"SSH_CMSG_AUTH_RSA",
	"SSH_SMSG_AUTH_RSA_CHALLENGE",
	"SSH_CMSG_AUTH_RSA_RESPONSE",
	"SSH_CMSG_AUTH_PASSWORD",

/* 10 */
	"SSH_CMSG_REQUEST_PTY",
	"SSH_CMSG_WINDOW_SIZE",
	"SSH_CMSG_EXEC_SHELL",
	"SSH_CMSG_EXEC_CMD",
	"SSH_SMSG_SUCCESS",
	"SSH_SMSG_FAILURE",
	"SSH_CMSG_STDIN_DATA",
	"SSH_SMSG_STDOUT_DATA",
	"SSH_SMSG_STDERR_DATA",
	"SSH_CMSG_EOF",

/* 20 */
	"SSH_SMSG_EXITSTATUS",
	"SSH_MSG_CHANNEL_OPEN_CONFIRMATION",
	"SSH_MSG_CHANNEL_OPEN_FAILURE",
	"SSH_MSG_CHANNEL_DATA",
	"SSH_MSG_CHANNEL_INPUT_EOF",
	"SSH_MSG_CHANNEL_OUTPUT_CLOSED",
	"SSH_MSG_UNIX_DOMAIN_X11_FORWARDING (obsolete)",
	"SSH_SMSG_X11_OPEN",
	"SSH_CMSG_PORT_FORWARD_REQUEST",
	"SSH_MSG_PORT_OPEN",

/* 30 */
	"SSH_CMSG_AGENT_REQUEST_FORWARDING",
	"SSH_SMSG_AGENT_OPEN",
	"SSH_MSG_IGNORE",
	"SSH_CMSG_EXIT_CONFIRMATION",
	"SSH_CMSG_X11_REQUEST_FORWARDING",
	"SSH_CMSG_AUTH_RHOSTS_RSA",
	"SSH_MSG_DEBUG",
	"SSH_CMSG_REQUEST_COMPRESSION",
	"SSH_CMSG_MAX_PACKET_SIZE",
	"SSH_CMSG_AUTH_TIS",

/* 40 */
	"SSH_SMSG_AUTH_TIS_CHALLENGE",
	"SSH_CMSG_AUTH_TIS_RESPONSE",
	"SSH_CMSG_AUTH_KERBEROS",
	"SSH_SMSG_AUTH_KERBEROS_RESPONSE",
	"SSH_CMSG_HAVE_KERBEROS_TGT"
};

void
badmsg(Msg *m, int want)
{
	char *s, buf[20+ERRMAX];

	if(m==nil){
		snprint(buf, sizeof buf, "&lt;early eof: %r&gt;");
		s = buf;
	}else{
		snprint(buf, sizeof buf, "&lt;unknown type %d&gt;", m-&gt;type);
		s = buf;
		if(0 &lt;= m-&gt;type &amp;&amp; m-&gt;type &lt; nelem(msgnames))
			s = msgnames[m-&gt;type];
	}
	if(want)
		error("got %s message expecting %s", s, msgnames[want]);
	error("got unexpected %s message", s);
}

Msg*
allocmsg(Conn *c, int type, int len)
{
	uchar *p;
	Msg *m;

	if(len &gt; 256*1024)
		abort();

	m = (Msg*)emalloc(sizeof(Msg)+4+8+1+len+4);
	setmalloctag(m, getcallerpc(&amp;c));
	p = (uchar*)&amp;m[1];
	m-&gt;c = c;
	m-&gt;bp = p;
	m-&gt;ep = p+len;
	m-&gt;wp = p;
	m-&gt;type = type;
	return m;
}

void
unrecvmsg(Conn *c, Msg *m)
{
	debug(DBG_PROTO, "unreceived %s len %ld\n", msgnames[m-&gt;type], m-&gt;ep - m-&gt;rp);
	free(c-&gt;unget);
	c-&gt;unget = m;
}

static Msg*
recvmsg0(Conn *c)
{
	int pad;
	uchar *p, buf[4];
	ulong crc, crc0, len;
	Msg *m;

	if(c-&gt;unget){
		m = c-&gt;unget;
		c-&gt;unget = nil;
		return m;
	}

	if(readn(c-&gt;fd[0], buf, 4) != 4){
		werrstr("short net read: %r");
		return nil;
	}

	len = LONG(buf);
	if(len &gt; 256*1024){
		werrstr("packet size far too big: %.8lux", len);
		return nil;
	}

	pad = 8 - len%8;

	m = (Msg*)emalloc(sizeof(Msg)+pad+len);
	setmalloctag(m, getcallerpc(&amp;c));
	m-&gt;c = c;
	m-&gt;bp = (uchar*)&amp;m[1];
	m-&gt;ep = m-&gt;bp + pad+len-4;	/* -4: don't include crc */
	m-&gt;rp = m-&gt;bp;

	if(readn(c-&gt;fd[0], m-&gt;bp, pad+len) != pad+len){
		werrstr("short net read: %r");
		free(m);
		return nil;
	}

	if(c-&gt;cipher)
		c-&gt;cipher-&gt;decrypt(c-&gt;cstate, m-&gt;bp, len+pad);

	crc = sum32(0, m-&gt;bp, pad+len-4);
	p = m-&gt;bp + pad+len-4;
	crc0 = LONG(p);
	if(crc != crc0){
		werrstr("bad crc %#lux != %#lux (packet length %lud)", crc, crc0, len);
		free(m);
		return nil;
	}

	m-&gt;rp += pad;
	m-&gt;type = *m-&gt;rp++;

	return m;
}

Msg*
recvmsg(Conn *c, int type)
{
	Msg *m;

	while((m = recvmsg0(c)) != nil){
		debug(DBG_PROTO, "received %s len %ld\n", msgnames[m-&gt;type], m-&gt;ep - m-&gt;rp);
		if(m-&gt;type != SSH_MSG_DEBUG &amp;&amp; m-&gt;type != SSH_MSG_IGNORE)
			break;
		if(m-&gt;type == SSH_MSG_DEBUG)
			debug(DBG_PROTO, "remote DEBUG: %s\n", getstring(m));
		free(m);
	}
	if(type == 0){
		/* no checking */
	}else if(type == -1){
		/* must not be nil */
		if(m == nil)
			error(Ehangup);
	}else{
		/* must be given type */
		if(m==nil || m-&gt;type!=type)
			badmsg(m, type);
	}
	setmalloctag(m, getcallerpc(&amp;c));
	return m;
}

int
sendmsg(Msg *m)
{
	int i, pad;
	uchar *p;
	ulong datalen, len, crc;
	Conn *c;

	datalen = m-&gt;wp - m-&gt;bp;
	len = datalen + 5;
	pad = 8 - len%8;

	debug(DBG_PROTO, "sending %s len %lud\n", msgnames[m-&gt;type], datalen);

	p = m-&gt;bp;
	memmove(m-&gt;bp+4+pad+1, m-&gt;bp, datalen);	/* slide data to correct position */

	PLONG(p, len);
	p += 4;

	if(m-&gt;c-&gt;cstate){
		for(i=0; i&lt;pad; i++)
			*p++ = fastrand();
	}else{
		memset(p, 0, pad);
		p += pad;
	}

	*p++ = m-&gt;type;

	/* data already in position */
	p += datalen;

	crc = sum32(0, m-&gt;bp+4, pad+1+datalen);
	PLONG(p, crc);
	p += 4;

	c = m-&gt;c;
	qlock(c);
	if(c-&gt;cstate)
		c-&gt;cipher-&gt;encrypt(c-&gt;cstate, m-&gt;bp+4, len+pad);

	if(write(c-&gt;fd[1], m-&gt;bp, p - m-&gt;bp) != p-m-&gt;bp){
		qunlock(c);
		free(m);
		return -1;
	}
	qunlock(c);
	free(m);
	return 0;
}

uchar
getbyte(Msg *m)
{
	if(m-&gt;rp &gt;= m-&gt;ep)
		error(Edecode);
	return *m-&gt;rp++;
}

ushort
getshort(Msg *m)
{
	ushort x;

	if(m-&gt;rp+2 &gt; m-&gt;ep)
		error(Edecode);

	x = SHORT(m-&gt;rp);
	m-&gt;rp += 2;
	return x;
}

ulong
getlong(Msg *m)
{
	ulong x;

	if(m-&gt;rp+4 &gt; m-&gt;ep)
		error(Edecode);

	x = LONG(m-&gt;rp);
	m-&gt;rp += 4;
	return x;
}

char*
getstring(Msg *m)
{
	char *p;
	ulong len;

	/* overwrites length to make room for NUL */
	len = getlong(m);
	if(m-&gt;rp+len &gt; m-&gt;ep)
		error(Edecode);
	p = (char*)m-&gt;rp-1;
	memmove(p, m-&gt;rp, len);
	p[len] = '\0';
	return p;
}

void*
getbytes(Msg *m, int n)
{
	uchar *p;

	if(m-&gt;rp+n &gt; m-&gt;ep)
		error(Edecode);
	p = m-&gt;rp;
	m-&gt;rp += n;
	return p;
}

mpint*
getmpint(Msg *m)
{
	int n;

	n = (getshort(m)+7)/8;	/* getshort returns # bits */
	return betomp(getbytes(m, n), n, nil);
}

RSApub*
getRSApub(Msg *m)
{
	RSApub *key;

	getlong(m);
	key = rsapuballoc();
	if(key == nil)
		error(Ememory);
	key-&gt;ek = getmpint(m);
	key-&gt;n = getmpint(m);
	setmalloctag(key, getcallerpc(&amp;m));
	return key;
}

void
putbyte(Msg *m, uchar x)
{
	if(m-&gt;wp &gt;= m-&gt;ep)
		error(Eencode);
	*m-&gt;wp++ = x;
}

void
putshort(Msg *m, ushort x)
{
	if(m-&gt;wp+2 &gt; m-&gt;ep)
		error(Eencode);
	PSHORT(m-&gt;wp, x);
	m-&gt;wp += 2;
}

void
putlong(Msg *m, ulong x)
{
	if(m-&gt;wp+4 &gt; m-&gt;ep)
		error(Eencode);
	PLONG(m-&gt;wp, x);
	m-&gt;wp += 4;
}

void
putstring(Msg *m, char *s)
{
	int len;

	len = strlen(s);
	putlong(m, len);
	putbytes(m, s, len);
}

void
putbytes(Msg *m, void *a, long n)
{
	if(m-&gt;wp+n &gt; m-&gt;ep)
		error(Eencode);
	memmove(m-&gt;wp, a, n);
	m-&gt;wp += n;
}

void
putmpint(Msg *m, mpint *b)
{
	int bits, n;

	bits = mpsignif(b);
	putshort(m, bits);
	n = (bits+7)/8;
	if(m-&gt;wp+n &gt; m-&gt;ep)
		error(Eencode);
	mptobe(b, m-&gt;wp, n, nil);
	m-&gt;wp += n;
}

void
putRSApub(Msg *m, RSApub *key)
{
	putlong(m, mpsignif(key-&gt;n));
	putmpint(m, key-&gt;ek);
	putmpint(m, key-&gt;n);
}

static ulong crctab[256];

static void
initsum32(void)
{
	ulong crc, poly;
	int i, j;

	poly = 0xEDB88320;
	for(i = 0; i &lt; 256; i++){
		crc = i;
		for(j = 0; j &lt; 8; j++){
			if(crc &amp; 1)
				crc = (crc &gt;&gt; 1) ^ poly;
			else
				crc &gt;&gt;= 1;
		}
		crctab[i] = crc;
	}
}

static ulong
sum32(ulong lcrc, void *buf, int n)
{
	static int first=1;
	uchar *s = buf;
	ulong crc = lcrc;

	if(first){
		first=0;
		initsum32();
	}
	while(n-- &gt; 0)
		crc = crctab[(crc^*s++)&amp;0xff] ^ (crc&gt;&gt;8);
	return crc;
}

mpint*
rsapad(mpint *b, int n)
{
	int i, pad, nbuf;
	uchar buf[2560];
	mpint *c;

	if(n &gt; sizeof buf)
		error("buffer too small in rsapad");

	nbuf = (mpsignif(b)+7)/8;
	pad = n - nbuf;
	assert(pad &gt;= 3);
	mptobe(b, buf, nbuf, nil);
	memmove(buf+pad, buf, nbuf);

	buf[0] = 0;
	buf[1] = 2;
	for(i=2; i&lt;pad-1; i++)
		buf[i]=1+fastrand()%255;
	buf[pad-1] = 0;
	c = betomp(buf, n, nil);
	memset(buf, 0, sizeof buf);
	return c;
}

mpint*
rsaunpad(mpint *b)
{
	int i, n;
	uchar buf[2560];

	n = (mpsignif(b)+7)/8;
	if(n &gt; sizeof buf)
		error("buffer too small in rsaunpad");
	mptobe(b, buf, n, nil);

	/* the initial zero has been eaten by the betomp -&gt; mptobe sequence */
	if(buf[0] != 2)
		error("bad data in rsaunpad");
	for(i=1; i&lt;n; i++)
		if(buf[i]==0)
			break;
	return betomp(buf+i, n-i, nil);
}

void
mptoberjust(mpint *b, uchar *buf, int len)
{
	int n;

	n = mptobe(b, buf, len, nil);
	assert(n &gt;= 0);
	if(n &lt; len){
		len -= n;
		memmove(buf+len, buf, n);
		memset(buf, 0, len);
	}
}

mpint*
rsaencryptbuf(RSApub *key, uchar *buf, int nbuf)
{
	int n;
	mpint *a, *b, *c;

	n = (mpsignif(key-&gt;n)+7)/8;
	a = betomp(buf, nbuf, nil);
	b = rsapad(a, n);
	mpfree(a);
	c = rsaencrypt(key, b, nil);
	mpfree(b);
	return c;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

