<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ssh2/dial.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ssh2/dial.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * dial - connect to a service (parallel version)
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;

typedef struct Conn Conn;
typedef struct Dest Dest;
typedef struct DS DS;

enum
{
	Maxstring	= 128,
	Maxpath		= 256,

	Maxcsreply	= 64*80,	/* this is probably overly generous */
	/*
	 * this should be a plausible slight overestimate for non-interactive
	 * use even if it's ridiculously long for interactive use.
	 */
	Maxconnms	= 2*60*1000,	/* 2 minutes */
};

struct DS {
	/* dist string */
	char	buf[Maxstring];
	char	*netdir;		/* e.g., /net.alt */
	char	*proto;			/* e.g., tcp */
	char	*rem;			/* e.g., host!service */

	/* other args */
	char	*local;
	char	*dir;
	int	*cfdp;
};

/*
 * malloc these; they need to be writable by this proc &amp; all children.
 * the stack is private to each proc, and static allocation in the data
 * segment would not permit concurrent dials within a multi-process program.
 */
struct Conn {
	int	pid;
	int	dead;

	int	dfd;
	int	cfd;
	char	dir[NETPATHLEN+1];
	char	err[ERRMAX];
};
struct Dest {
	Conn	*conn;			/* allocated array */
	Conn	*connend;
	int	nkid;

	long	oalarm;
	int	naddrs;

	QLock	winlck;
	int	winner;			/* index into conn[] */

	char	*nextaddr;
	char	addrlist[Maxcsreply];
};

static int	call(char*, char*, DS*, Dest*, Conn*);
static int	csdial(DS*);
static void	_dial_string_parse(char*, DS*);


/*
 *  the dialstring is of the form '[/net/]proto!dest'
 */
static int
dialimpl(char *dest, char *local, char *dir, int *cfdp)
{
	DS ds;
	int rv;
	char err[ERRMAX], alterr[ERRMAX];

	ds.local = local;
	ds.dir = dir;
	ds.cfdp = cfdp;

	_dial_string_parse(dest, &amp;ds);
	if(ds.netdir)
		return csdial(&amp;ds);

	ds.netdir = "/net";
	rv = csdial(&amp;ds);
	if(rv &gt;= 0)
		return rv;
	err[0] = '\0';
	errstr(err, sizeof err);
	if(strstr(err, "refused") != 0){
		werrstr("%s", err);
		return rv;
	}
	ds.netdir = "/net.alt";
	rv = csdial(&amp;ds);
	if(rv &gt;= 0)
		return rv;

	alterr[0] = 0;
	errstr(alterr, sizeof alterr);
	if(strstr(alterr, "translate") || strstr(alterr, "does not exist"))
		werrstr("%s", err);
	else
		werrstr("%s", alterr);
	return rv;
}

/*
 * the thread library can't cope with rfork(RFMEM|RFPROC),
 * so it must override this with a private version of dial.
 */
int (*_dial)(char *, char *, char *, int *) = dialimpl;

int
dial(char *dest, char *local, char *dir, int *cfdp)
{
	return (*_dial)(dest, local, dir, cfdp);
}

static int
connsalloc(Dest *dp, int addrs)
{
	Conn *conn;

	free(dp-&gt;conn);
	dp-&gt;connend = nil;
	assert(addrs &gt; 0);

	dp-&gt;conn = mallocz(addrs * sizeof *dp-&gt;conn, 1);
	if(dp-&gt;conn == nil)
		return -1;
	dp-&gt;connend = dp-&gt;conn + addrs;
	for(conn = dp-&gt;conn; conn &lt; dp-&gt;connend; conn++)
		conn-&gt;cfd = conn-&gt;dfd = -1;
	return 0;
}

static void
freedest(Dest *dp)
{
	long oalarm;

	if (dp == nil)
		return;
	oalarm = dp-&gt;oalarm;
	free(dp-&gt;conn);
	free(dp);
	if (oalarm &gt;= 0)
		alarm(oalarm);
}

static void
closeopenfd(int *fdp)
{
	if (*fdp &gt;= 0) {
		close(*fdp);
		*fdp = -1;
	}
}

static void
notedeath(Dest *dp, char *exitsts)
{
	int i, n, pid;
	char *fields[5];			/* pid + 3 times + error */
	Conn *conn;

	for (i = 0; i &lt; nelem(fields); i++)
		fields[i] = "";
	n = tokenize(exitsts, fields, nelem(fields));
	if (n &lt; 4)
		return;
	pid = atoi(fields[0]);
	if (pid &lt;= 0)
		return;
	for (conn = dp-&gt;conn; conn &lt; dp-&gt;connend; conn++)
		if (conn-&gt;pid == pid &amp;&amp; !conn-&gt;dead) {  /* it's one we know? */
			if (conn - dp-&gt;conn != dp-&gt;winner) {
				closeopenfd(&amp;conn-&gt;dfd);
				closeopenfd(&amp;conn-&gt;cfd);
			}
			strncpy(conn-&gt;err, fields[4], sizeof conn-&gt;err - 1);
			conn-&gt;err[sizeof conn-&gt;err - 1] = '\0';
			conn-&gt;dead = 1;
			return;
		}
	/* not a proc that we forked */
}

static int
outstandingprocs(Dest *dp)
{
	Conn *conn;

	for (conn = dp-&gt;conn; conn &lt; dp-&gt;connend; conn++)
		if (!conn-&gt;dead)
			return 1;
	return 0;
}

static int
reap(Dest *dp)
{
	char exitsts[2*ERRMAX];

	if (outstandingprocs(dp) &amp;&amp; await(exitsts, sizeof exitsts) &gt;= 0) {
		notedeath(dp, exitsts);
		return 0;
	}
	return -1;
}

static int
fillinds(DS *ds, Dest *dp)
{
	Conn *conn;

	if (dp-&gt;winner &lt; 0)
		return -1;
	conn = &amp;dp-&gt;conn[dp-&gt;winner];
	if (ds-&gt;cfdp)
		*ds-&gt;cfdp = conn-&gt;cfd;
	if (ds-&gt;dir) {
		strncpy(ds-&gt;dir, conn-&gt;dir, NETPATHLEN);
		ds-&gt;dir[NETPATHLEN-1] = '\0';
	}
	return conn-&gt;dfd;
}

static int
connectwait(Dest *dp, char *besterr)
{
	Conn *conn;

	/* wait for a winner or all attempts to time out */
	while (dp-&gt;winner &lt; 0 &amp;&amp; reap(dp) &gt;= 0)
		;

	/* kill all of our still-live kids &amp; reap them */
	for (conn = dp-&gt;conn; conn &lt; dp-&gt;connend; conn++)
		if (!conn-&gt;dead)
			postnote(PNPROC, conn-&gt;pid, "alarm");
	while (reap(dp) &gt;= 0)
		;

	/* rummage about and report some error string */
	for (conn = dp-&gt;conn; conn &lt; dp-&gt;connend; conn++)
		if (conn - dp-&gt;conn != dp-&gt;winner &amp;&amp; conn-&gt;dead &amp;&amp;
		    conn-&gt;err[0]) {
			strncpy(besterr, conn-&gt;err, ERRMAX-1);
			conn-&gt;err[ERRMAX-1] = '\0';
			break;
		}
	return dp-&gt;winner;
}

static int
parsecs(Dest *dp, char **clonep, char **destp)
{
	char *dest, *p;

	dest = strchr(dp-&gt;nextaddr, ' ');
	if(dest == nil)
		return -1;
	*dest++ = '\0';
	p = strchr(dest, '\n');
	if(p == nil)
		return -1;
	*p++ = '\0';
	*clonep = dp-&gt;nextaddr;
	*destp = dest;
	dp-&gt;nextaddr = p;		/* advance to next line */
	return 0;
}

static void
pickuperr(char *besterr, char *err)
{
	err[0] = '\0';
	errstr(err, ERRMAX);
	if(strstr(err, "does not exist") == 0)
		strcpy(besterr, err);
}

static int
catcher(void *, char *s)
{
	return strstr(s, "alarm") != nil;
}

/*
 * try all addresses in parallel and take the first one that answers;
 * this helps when systems have ip v4 and v6 addresses but are
 * only reachable from here on one (or some) of them.
 */
static int
dialmulti(DS *ds, Dest *dp)
{
	int rv, kid, kidme;
	char *clone, *dest;
	char err[ERRMAX], besterr[ERRMAX];

	dp-&gt;winner = -1;
	dp-&gt;nkid = 0;
	while(dp-&gt;winner &lt; 0 &amp;&amp; *dp-&gt;nextaddr != '\0' &amp;&amp;
	    parsecs(dp, &amp;clone, &amp;dest) &gt;= 0) {
		kidme = dp-&gt;nkid++;		/* make private copy on stack */
		kid = rfork(RFPROC|RFMEM);	/* spin off a call attempt */
		if (kid &lt; 0)
			--dp-&gt;nkid;
		else if (kid == 0) {
			/* only in kid, to avoid atnotify callbacks in parent */
			atnotify(catcher, 1);

			*besterr = '\0';
			rv = call(clone, dest, ds, dp, &amp;dp-&gt;conn[kidme]);
			if(rv &lt; 0)
				pickuperr(besterr, err);
			_exits(besterr);	/* avoid atexit callbacks */
		}
	}
	rv = connectwait(dp, besterr);
	if(rv &lt; 0 &amp;&amp; *besterr)
		werrstr("%s", besterr);
	else
		werrstr("%s", err);
	return rv;
}

static int
csdial(DS *ds)
{
	int n, fd, rv, addrs, bleft;
	char c;
	char *addrp, *clone2, *dest;
	char buf[Maxstring], clone[Maxpath], err[ERRMAX], besterr[ERRMAX];
	Dest *dp;

	dp = mallocz(sizeof *dp, 1);
	if(dp == nil)
		return -1;
	dp-&gt;winner = -1;
	dp-&gt;oalarm = alarm(0);
	if (connsalloc(dp, 1) &lt; 0) {		/* room for a single conn. */
		freedest(dp);
		return -1;
	}

	/*
	 *  open connection server
	 */
	snprint(buf, sizeof(buf), "%s/cs", ds-&gt;netdir);
	fd = open(buf, ORDWR);
	if(fd &lt; 0){
		/* no connection server, don't translate */
		snprint(clone, sizeof(clone), "%s/%s/clone", ds-&gt;netdir, ds-&gt;proto);
		rv = call(clone, ds-&gt;rem, ds, dp, &amp;dp-&gt;conn[0]);
		fillinds(ds, dp);
		freedest(dp);
		return rv;
	}

	/*
	 *  ask connection server to translate
	 */
	snprint(buf, sizeof(buf), "%s!%s", ds-&gt;proto, ds-&gt;rem);
	if(write(fd, buf, strlen(buf)) &lt; 0){
		close(fd);
		freedest(dp);
		return -1;
	}

	/*
	 *  read all addresses from the connection server.
	 */
	seek(fd, 0, 0);
	addrs = 0;
	addrp = dp-&gt;nextaddr = dp-&gt;addrlist;
	bleft = sizeof dp-&gt;addrlist - 2;	/* 2 is room for \n\0 */
	while(bleft &gt; 0 &amp;&amp; (n = read(fd, addrp, bleft)) &gt; 0) {
		if (addrp[n-1] != '\n')
			addrp[n++] = '\n';
		addrs++;
		addrp += n;
		bleft -= n;
	}
	/*
	 * if we haven't read all of cs's output, assume the last line might
	 * have been truncated and ignore it.  we really don't expect this
	 * to happen.
	 */
	if (addrs &gt; 0 &amp;&amp; bleft &lt;= 0 &amp;&amp; read(fd, &amp;c, 1) == 1)
		addrs--;
	close(fd);

	*besterr = 0;
	rv = -1;				/* pessimistic default */
	dp-&gt;naddrs = addrs;
	if (addrs == 0)
		werrstr("no address to dial");
	else if (addrs == 1) {
		/* common case: dial one address without forking */
		if (parsecs(dp, &amp;clone2, &amp;dest) &gt;= 0 &amp;&amp;
		    (rv = call(clone2, dest, ds, dp, &amp;dp-&gt;conn[0])) &lt; 0) {
			pickuperr(besterr, err);
			werrstr("%s", besterr);
		}
	} else if (connsalloc(dp, addrs) &gt;= 0)
		rv = dialmulti(ds, dp);

	/* fill in results */
	if (rv &gt;= 0 &amp;&amp; dp-&gt;winner &gt;= 0)
		rv = fillinds(ds, dp);

	freedest(dp);
	return rv;
}

static int
call(char *clone, char *dest, DS *ds, Dest *dp, Conn *conn)
{
	int fd, cfd, n, calleralarm, oalarm;
	char cname[Maxpath], name[Maxpath], data[Maxpath], *p;

	/* because cs is in a different name space, replace the mount point */
	if(*clone == '/'){
		p = strchr(clone+1, '/');
		if(p == nil)
			p = clone;
		else 
			p++;
	} else
		p = clone;
	snprint(cname, sizeof cname, "%s/%s", ds-&gt;netdir, p);

	conn-&gt;pid = getpid();
	conn-&gt;cfd = cfd = open(cname, ORDWR);
	if(cfd &lt; 0)
		return -1;

	/* get directory name */
	n = read(cfd, name, sizeof(name)-1);
	if(n &lt; 0){
		closeopenfd(&amp;conn-&gt;cfd);
		return -1;
	}
	name[n] = 0;
	for(p = name; *p == ' '; p++)
		;
	snprint(name, sizeof(name), "%ld", strtoul(p, 0, 0));
	p = strrchr(cname, '/');
	*p = 0;
	if(ds-&gt;dir)
		snprint(conn-&gt;dir, NETPATHLEN, "%s/%s", cname, name);
	snprint(data, sizeof(data), "%s/%s/data", cname, name);

	/* should be no alarm pending now; re-instate caller's alarm, if any */
	calleralarm = dp-&gt;oalarm &gt; 0;
	if (calleralarm)
		alarm(dp-&gt;oalarm);
	else if (dp-&gt;naddrs &gt; 1)	/* in a sub-process? */
		alarm(Maxconnms);

	/* connect */
	if(ds-&gt;local)
		snprint(name, sizeof(name), "connect %s %s", dest, ds-&gt;local);
	else
		snprint(name, sizeof(name), "connect %s", dest);
	if(write(cfd, name, strlen(name)) &lt; 0){
		closeopenfd(&amp;conn-&gt;cfd);
		return -1;
	}

	oalarm = alarm(0);	/* don't let alarm interrupt critical section */
	if (calleralarm)
		dp-&gt;oalarm = oalarm;	/* time has passed, so update user's */

	/* open data connection */
	conn-&gt;dfd = fd = open(data, ORDWR);
	if(fd &lt; 0){
		closeopenfd(&amp;conn-&gt;cfd);
		alarm(dp-&gt;oalarm);
		return -1;
	}
	if(ds-&gt;cfdp == nil)
		closeopenfd(&amp;conn-&gt;cfd);

	n = conn - dp-&gt;conn;
	if (dp-&gt;winner &lt; 0) {
		qlock(&amp;dp-&gt;winlck);
		if (dp-&gt;winner &lt; 0 &amp;&amp; conn &lt; dp-&gt;connend)
			dp-&gt;winner = n;
		qunlock(&amp;dp-&gt;winlck);
	}
	alarm(calleralarm? dp-&gt;oalarm: 0);
	return fd;
}

/*
 * assume p points at first '!' in dial string.  st is start of dial string.
 * there could be subdirs of the conn dirs (e.g., ssh/0) that must count as
 * part of the proto string, so skip numeric components.
 * returns pointer to delimiter after right-most non-numeric component.
 */
static char *
backoverchans(char *st, char *p)
{
	char *sl;

	for (sl = p; --p &gt;= st &amp;&amp; isascii(*p) &amp;&amp; isdigit(*p); sl = p) {
		while (--p &gt;= st &amp;&amp; isascii(*p) &amp;&amp; isdigit(*p))
			;
		if (p &lt; st || *p != '/')
			break;			/* "net.alt2" or ran off start */
		while (p &gt; st &amp;&amp; p[-1] == '/')	/* skip runs of slashes */
			p--;
	}
	return sl;
}

/*
 *  parse a dial string
 */
static void
_dial_string_parse(char *str, DS *ds)
{
	char *p, *p2;

	strncpy(ds-&gt;buf, str, Maxstring);
	ds-&gt;buf[Maxstring-1] = 0;

	p = strchr(ds-&gt;buf, '!');
	if(p == 0) {
		ds-&gt;netdir = 0;
		ds-&gt;proto = "net";
		ds-&gt;rem = ds-&gt;buf;
	} else {
		if(*ds-&gt;buf != '/' &amp;&amp; *ds-&gt;buf != '#'){
			ds-&gt;netdir = 0;
			ds-&gt;proto = ds-&gt;buf;
		} else {
			p2 = backoverchans(ds-&gt;buf, p);

			/* back over last component of netdir (proto) */
			while (--p2 &gt; ds-&gt;buf &amp;&amp; *p2 != '/')
				;
			*p2++ = 0;
			ds-&gt;netdir = ds-&gt;buf;
			ds-&gt;proto = p2;
		}
		*p = 0;
		ds-&gt;rem = p + 1;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

