<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ssh2/netssh.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ssh2/netssh.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *  /net/ssh
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include &lt;mp.h&gt;
#include &lt;auth.h&gt;
#include &lt;authsrv.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ip.h&gt;
#include "netssh.h"

extern int nokeyverify;

void stclunk(Fid *);
void stend(Srv *);
void stflush(Req *);
void stopen(Req *);
void stread(Req *);
void stwrite(Req *);

Srv netsshsrv = {
	.open = stopen,
	.read = stread,
	.write = stwrite,
	.flush = stflush,
	.destroyfid = stclunk,
	.end = stend,
};

Cipher *cryptos[] = {
	&amp;cipheraes128,
	&amp;cipheraes192,
	&amp;cipheraes256,
//	&amp;cipherblowfish,
	&amp;cipher3des,
	&amp;cipherrc4,
};

Kex *kexes[] = {
	&amp;dh1sha1,
	&amp;dh14sha1,
};

PKA *pkas[3];

char *macnames[] = {
	"hmac-sha1",
};

char *st_names[] = {
[Empty]		"Empty",
[Allocated]	"Allocated",
[Initting]	"Initting",
[Listening]	"Listening",
[Opening]	"Opening",
[Negotiating]	"Negotiating",
[Authing]	"Authing",
[Established]	"Established",
[Eof]		"Eof",
[Closing]	"Closing",
[Closed]	"Closed",
};

int debug;
int kflag;
char *mntpt = "/net";
char uid[32];
Conn *connections[MAXCONN];
File *rootfile, *clonefile, *ctlfile, *keysfile;
Ioproc *io9p;
MBox keymbox;
QLock availlck;
Rendez availrend;

SSHChan *alloc_chan(Conn *);
Conn *alloc_conn(void);
int auth_req(Packet *, Conn *);
int client_auth(Conn *, Ioproc *);
int dohandshake(Conn *, char *);
char *factlookup(int, int, char *[]);
void filedup(Req *, File *);
void readdata(void *);
void reader(void *);
void readreqrem(void *);
void send_kexinit(Conn *);
void server(char *, char *);
void shutdown(Conn *);
void stlisconn(void *);
void stlischan(void *);
int validatekex(Conn *, Packet *);
int validatekexc(Packet *);
int validatekexs(Packet *);
void writectlproc(void *);
void writedataproc(void *);
void writereqremproc(void *);

static int deferredinit(Conn *c);

static void
sshlogint(Conn *c, char *file, char *p)
{
	char *role, *id;

	if (c == nil)
		role = "";
	else if (c-&gt;role == Server)
		role = "server ";
	else
		role = "client ";
	if (c == nil)
		id = strdup("");
	else if (c-&gt;user || c-&gt;remote)
		id = smprint("user %s@%s id %d ", c-&gt;user, c-&gt;remote, c-&gt;id);
	else
		id = smprint("id %d ", c-&gt;id);

	syslog(0, file, "%s: %s%s%s", argv0, role, id, p);
	free(id);
}

void
sshlog(Conn *c, char *fmt, ...)
{
	va_list args;
	char *p;

	/* do this first in case fmt contains "%r" */
	va_start(args, fmt);
	p = vsmprint(fmt, args);
	va_end(args);

	sshlogint(c, "ssh", p);
	sshlogint(c, "sshdebug", p);	/* log in both places */
	free(p);
}

void
sshdebug(Conn *c, char *fmt, ...)
{
	va_list args;
	char *p;

	if (!debug)
		return;

	/* do this first in case fmt contains "%r" */
	va_start(args, fmt);
	p = vsmprint(fmt, args);
	va_end(args);

	sshlogint(c, "sshdebug", p);
	free(p);
}

void
usage(void)
{
	fprint(2, "usage: %s [-dkv] [-m mntpt] [-s srvpt]\n", argv0);
	exits("usage");
}

void
threadmain(int argc, char *argv[])
{
	char *p, *srvpt = nil;

	quotefmtinstall();
	threadsetname("main");
	nokeyverify = 1;	/* temporary until verification is fixed */
	ARGBEGIN {
	case '9':
		chatty9p = 1;
		break;
	case 'd':
		debug++;
		break;
	case 'k':
		kflag = 1;
		break;
	case 'm':
		mntpt = EARGF(usage());
		break;
	case 's':
		srvpt = EARGF(usage());
		break;
	case 'v':
		nokeyverify = 1;
		break;
	case 'V':
		nokeyverify = 0;
		break;
	default:
		usage();
		break;
	} ARGEND;

	p = getenv("nosshkeyverify");
	if (p &amp;&amp; p[0] != '\0')
		nokeyverify = 1;
	free(p);

	if (readfile("/dev/user", uid, sizeof uid) &lt;= 0)
		strcpy(uid, "none");

	keymbox.mchan = chancreate(4, 0);
	availrend.l = &amp;availlck;
	dh_init(pkas);

	/* become a daemon */
	if (rfork(RFNOTEG) &lt; 0)
		fprint(2, "%s: rfork(NOTEG) failed: %r\n", argv0);
	server(mntpt, srvpt);
	threadexits(nil);
}

int
readio(Ioproc *io, int fd, void *buf, int n)
{
	if (io)
		return ioread(io, fd, buf, n);
	else
		return read(fd, buf, n);
}

int
writeio(Ioproc *io, int fd, void *buf, int n)
{
	if (io)
		return iowrite(io, fd, buf, n);
	else
		return write(fd, buf, n);
}

int
read9pmsg(int fd, void *abuf, uint n)
{
	int m, len;
	uchar *buf;

	if (io9p == nil)
		io9p = ioproc();

	buf = abuf;

	/* read count */
	m = ioreadn(io9p, fd, buf, BIT32SZ);
	if(m != BIT32SZ){
		if(m &lt; 0)
			return -1;
		return 0;
	}

	len = GBIT32(buf);
	if(len &lt;= BIT32SZ || len &gt; n){
		werrstr("bad length in 9P2000 message header");
		return -1;
	}
	len -= BIT32SZ;
	m = ioreadn(io9p, fd, buf+BIT32SZ, len);
	if(m &lt; len)
		return 0;
	return BIT32SZ+m;
}

void
stend(Srv *)
{
	closeioproc(io9p);
	threadkillgrp(threadgetgrp());
}

void
server(char *mntpt, char *srvpt)
{
	Dir d;
	char *p;
	int fd;

	netsshsrv.tree = alloctree(uid, uid, 0777, nil);
	rootfile = createfile(netsshsrv.tree-&gt;root, "ssh", uid, 0555|DMDIR,
		(void*)Qroot);
	clonefile = createfile(rootfile, "clone", uid, 0666, (void*)Qclone);
	ctlfile = createfile(rootfile, "ctl", uid, 0666, (void*)Qctl);
	keysfile = createfile(rootfile, "keys", uid, 0600, (void *)Qreqrem);

	/*
	 * needs to be MBEFORE in case there are previous, now defunct,
	 * netssh processes mounted in mntpt.
	 */
	threadpostmountsrv(&amp;netsshsrv, srvpt, mntpt, MBEFORE);

	p = esmprint("%s/cs", mntpt);
	fd = open(p, OWRITE);
	free(p);
	if (fd &gt;= 0) {
		fprint(fd, "add ssh");
		close(fd);
	}
	if (srvpt) {
		nulldir(&amp;d);
		d.mode = 0666;
		p = esmprint("/srv/%s", srvpt);
		dirwstat(p, &amp;d);
		free(p);
	}
	sshdebug(nil, "server started for %s", getuser());
}

static void
respexit(Conn *c, Req *r, void *freeme, char *msg)
{
	if (msg)
		sshdebug(c, "%s", msg);
	r-&gt;aux = 0;
	respond(r, msg);
	free(freeme);
	threadexits(nil);	/* maybe use msg here */
}

void
stopen(Req *r)
{
	int lev, xconn, fd;
	uvlong qidpath;
	char *p;
	char buf[32];
	Conn *c;
	SSHChan *sc;

	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	switch ((ulong)(qidpath &amp; Qtypemask)) {
	default:
		respond(r, nil);
		break;
	case Qlisten:
		r-&gt;aux = (void *)threadcreate((lev == Connection?
			stlisconn: stlischan), r, Defstk);
		break;
	case Qclone:
		switch (lev) {
		case Top:
			/* should use dial(2) instead of diddling /net/tcp */
			p = esmprint("%s/tcp/clone", mntpt);
			fd = open(p, ORDWR);
			if (fd &lt; 0) {
				sshdebug(nil, "stopen: open %s failed: %r", p);
				free(p);
				responderror(r);
				return;
			}
			free(p);

			c = alloc_conn();
			if (c == nil) {
				close(fd);
				respond(r, "no more connections");
				return;
			}
			c-&gt;ctlfd = fd;
			c-&gt;poisoned = 0;
			filedup(r, c-&gt;ctlfile);
			sshlog(c, "new connection on fd %d", fd);
			break;
		case Connection:
			xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
			c = connections[xconn];
			if (c == nil) {
				respond(r, "bad connection");
				return;
			}
			sc = alloc_chan(c);
			if (sc == nil) {
				respond(r, "no more channels");
				return;
			}
			filedup(r, sc-&gt;ctl);
			break;
		default:
			snprint(buf, sizeof buf, "bad level %d", lev);
			readstr(r, buf);
			break;
		}
		respond(r, nil);
		break;
	}
}

static void
listerrexit(Req *r, Ioproc *io, Conn *cl)
{
	r-&gt;aux = 0;
	responderror(r);
	closeioproc(io);
	shutdown(cl);
	threadexits(nil);
}

void
stlisconn(void *a)
{
	int xconn, fd, n;
	uvlong qidpath;
	char *msg;
	char buf[Numbsz], path[NETPATHLEN];
	Conn *c, *cl;
	Ioproc *io;
	Req *r;

	threadsetname("stlisconn");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;

	cl = connections[xconn];
	if (cl == nil) {
		sshlog(cl, "bad connection");
		respond(r, "bad connection");
		threadexits("bad connection");
	}
	if (cl-&gt;poisoned) {
		sshdebug(cl, "stlisconn conn %d poisoned", xconn);
		r-&gt;aux = 0;
		respond(r, "top level listen conn poisoned");
		threadexits("top level listen conn poisoned");
	}
	if (cl-&gt;ctlfd &lt; 0) {
		sshdebug(cl, "stlisconn conn %d ctlfd &lt; 0; poisoned", xconn);
		r-&gt;aux = 0;
		respond(r, "top level listen with closed fd");
		shutdown(cl);
		cl-&gt;poisoned = 1;	/* no more use until ctlfd is set */
		threadexits("top level listen with closed fd");
	}

	io = ioproc();

	/* read xconn's tcp conn's ctl file */
	seek(cl-&gt;ctlfd, 0, 0);
	n = ioread(io, cl-&gt;ctlfd, buf, sizeof buf - 1);
	if (n == 0) {
		sshlog(cl, "stlisconn read eof on fd %d", cl-&gt;ctlfd);
		listerrexit(r, io, cl);
	} else if (n &lt; 0) {
		sshlog(cl, "stlisconn read failed on fd %d: %r", cl-&gt;ctlfd);
		listerrexit(r, io, cl);
	}
	buf[n] = '\0';

	cl-&gt;state = Listening;
	/* should use dial(2) instead of diddling /net/tcp */
	snprint(path, sizeof path, "%s/tcp/%s/listen", mntpt, buf);
	for(;;) {
		fd = ioopen(io, path, ORDWR);
		if (fd &lt; 0) 
			listerrexit(r, io, cl);
		c = alloc_conn();
		if (c)
			break;
		n = ioread(io, fd, buf, sizeof buf - 1);
		if (n &lt;= 0)
			listerrexit(r, io, cl);
		buf[n] = '\0';
		msg = smprint("reject %s no available connections", buf);
		iowrite(io, fd, msg, strlen(msg));
		free(msg);
		close(fd);			/* surely ioclose? */
	}
	c-&gt;ctlfd = fd;
	if (c-&gt;ctlfd &lt; 0) {
		sshlog(cl, "stlisconn c-&gt;ctlfd &lt; 0 for conn %d", xconn);
		threadexitsall("stlisconn c-&gt;ctlfd &lt; 0");
	}
	c-&gt;poisoned = 0;
	c-&gt;stifle = 1;			/* defer server; was for coexistence */
	filedup(r, c-&gt;ctlfile);
	sshdebug(c, "responding to listen open");
	r-&gt;aux = 0;
	respond(r, nil);
	closeioproc(io);
	threadexits(nil);
}

void
stlischan(void *a)
{
	Req *r;
	Packet *p2;
	Ioproc *io;
	Conn *c;
	SSHChan *sc;
	int i, n, xconn;
	uvlong qidpath;

	threadsetname("stlischan");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		respond(r, "bad channel");
		sshlog(c, "bad channel");
		threadexits(nil);
	}
	if (c-&gt;state == Closed || c-&gt;state == Closing)
		respexit(c, r, nil, "channel listen on closed connection");
	sc = c-&gt;chans[qidpath &amp; Chanmask];

	qlock(&amp;c-&gt;l);
	sc-&gt;lreq = r;
	for (i = 0; i &lt; c-&gt;nchan; ++i)
		if (c-&gt;chans[i] &amp;&amp; c-&gt;chans[i]-&gt;state == Opening &amp;&amp;
		    c-&gt;chans[i]-&gt;ann &amp;&amp; strcmp(c-&gt;chans[i]-&gt;ann, sc-&gt;ann) == 0)
			break;
	if (i &gt;= c-&gt;nchan) {
		sc-&gt;state = Listening;
		rsleep(&amp;sc-&gt;r);
		i = sc-&gt;waker;
		if (i &lt; 0) {
			qunlock(&amp;c-&gt;l);
			r-&gt;aux = 0;
			responderror(r);
			threadexits(nil);
		}
	} else
		rwakeup(&amp;c-&gt;chans[i]-&gt;r);
	qunlock(&amp;c-&gt;l);

	if (c-&gt;state == Closed || c-&gt;state == Closing || c-&gt;state == Eof)
		respexit(c, r, nil, "channel listen on closed connection");
	c-&gt;chans[i]-&gt;state = Established;

	p2 = new_packet(c);
	c-&gt;chans[i]-&gt;rwindow = Maxpayload;
	add_byte(p2, SSH_MSG_CHANNEL_OPEN_CONFIRMATION);
	hnputl(p2-&gt;payload + 1, c-&gt;chans[i]-&gt;otherid);
	hnputl(p2-&gt;payload + 5, c-&gt;chans[i]-&gt;id);
	hnputl(p2-&gt;payload + 9, Maxpayload);
	hnputl(p2-&gt;payload + 13, Maxrpcbuf);
	p2-&gt;rlength = 18;
	n = finish_packet(p2);
	filedup(r, c-&gt;chans[i]-&gt;ctl);

	io = ioproc();
	n = iowrite(io, c-&gt;datafd, p2-&gt;nlength, n);
	closeioproc(io);

	free(p2);

	sshdebug(c, "responding to chan listen open");
	r-&gt;aux = 0;
	if (n &lt; 0)
		responderror(r);
	else
		respond(r, nil);
	threadexits(nil);
}

void
getdata(Conn *c, SSHChan *sc, Req *r)
{
	Packet *p;
	Plist *d;
	int n;

	n = r-&gt;ifcall.count;
	if (sc-&gt;dataq-&gt;rem &lt; n)
		n = sc-&gt;dataq-&gt;rem;
	if (n &gt; Maxrpcbuf)
		n = Maxrpcbuf;
	r-&gt;ifcall.offset = 0;

	readbuf(r, sc-&gt;dataq-&gt;st, n);
	sc-&gt;dataq-&gt;st += n;
	sc-&gt;dataq-&gt;rem -= n;
	sc-&gt;inrqueue -= n;
	if (sc-&gt;dataq-&gt;rem &lt;= 0) {
		d = sc-&gt;dataq;
		sc-&gt;dataq = sc-&gt;dataq-&gt;next;
		if (d-&gt;pack-&gt;tlength &gt; sc-&gt;rwindow)
			sc-&gt;rwindow = 0;
		else
			sc-&gt;rwindow -= d-&gt;pack-&gt;tlength;
		free(d-&gt;pack);
		free(d);
	}
	if (sc-&gt;rwindow &lt; 16*1024) {		/* magic.  half-way, maybe? */
		sc-&gt;rwindow += Maxpayload;
		sshdebug(c, "increasing receive window to %lud, inq %lud\n",
			argv0, sc-&gt;rwindow, sc-&gt;inrqueue);
		p = new_packet(c);
		add_byte(p, SSH_MSG_CHANNEL_WINDOW_ADJUST);
		hnputl(p-&gt;payload+1, sc-&gt;otherid);
		hnputl(p-&gt;payload+5, Maxpayload);
		p-&gt;rlength += 8;
		n = finish_packet(p);
		iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
		free(p);
	}
	r-&gt;aux = 0;
	respond(r, nil);
}

void
stread(Req *r)
{
	Conn *c;
	SSHChan *sc;
	int n, lev, cnum, xconn;
	uvlong qidpath;
	char buf[Arbbufsz], path[NETPATHLEN];

	threadsetname("stread");
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		if (lev != Top || (qidpath &amp; Qtypemask) != Qreqrem) {
			respond(r, "Invalid connection");
			return;
		}
		cnum = 0;
		sc = nil;
	} else {
		cnum = qidpath &amp; Chanmask;
		sc = c-&gt;chans[cnum];
	}
	switch ((ulong)(qidpath &amp; Qtypemask)) {
	case Qctl:
	case Qlisten:
		if (r-&gt;ifcall.offset != 0) {
			respond(r, nil);
			break;
		}
		switch (lev) {
		case Top:
			readstr(r, st_names[c-&gt;state]);
			break;
		case Connection:
		case Subchannel:
			snprint(buf, sizeof buf, "%d", lev == Connection?
				xconn: cnum);
			readstr(r, buf);
			break;
		default:
			snprint(buf, sizeof buf, "stread error, level %d", lev);
			respond(r, buf);
			return;
		}
		respond(r, nil);
		break;
	case Qclone:
		if (r-&gt;ifcall.offset != 0) {
			respond(r, nil);
			break;
		}
		readstr(r, "Congratulations, you've achieved the impossible\n");
		respond(r, nil);
		break;
	case Qdata:
		if (lev == Top) {
			respond(r, nil);
			break;
		}
		if (lev == Connection) {
			if (0 &amp;&amp; c-&gt;stifle) {	/* was for coexistence */
				c-&gt;stifle = 0;
				if (deferredinit(c) &lt; 0) {
					respond(r, "deferredinit failed");
					break;
				}
			}
			if (c-&gt;cap)			/* auth capability? */
				readstr(r, c-&gt;cap);
			respond(r, nil);
			break;
		}

		r-&gt;aux = (void *)threadcreate(readdata, r, Defstk);
		break;
	case Qlocal:
		if (lev == Connection)
			if (c-&gt;ctlfd &lt; 0)
				readstr(r, "::!0\n");
			else {
				n = pread(c-&gt;ctlfd, buf, 10, 0); // magic 10
				buf[n &gt;= 0? n: 0] = '\0';
				snprint(path, sizeof path, "%s/tcp/%s/local",
					mntpt, buf);
				readfile(path, buf, sizeof buf);
				readstr(r, buf);
			}
		respond(r, nil);
		break;
	case Qreqrem:
		r-&gt;aux = (void *)threadcreate(readreqrem, r, Defstk);
		break;
	case Qstatus:
		switch (lev) {
		case Top:
			readstr(r, "Impossible");
			break;
		case Connection:
			readstr(r, (uint)c-&gt;state &gt; Closed?
				"Unknown": st_names[c-&gt;state]);
			break;
		case Subchannel:
			readstr(r, (uint)sc-&gt;state &gt; Closed?
				"Unknown": st_names[sc-&gt;state]);
			break;
		}
		respond(r, nil);
		break;
	case Qtcp:
		/* connection number of underlying tcp connection */
		if (lev == Connection)
			if (c-&gt;ctlfd &lt; 0)
				readstr(r, "-1\n");
			else {
				n = pread(c-&gt;ctlfd, buf, 10, 0); /* magic 10 */
				buf[n &gt;= 0? n: 0] = '\0';
				readstr(r, buf);
			}
		respond(r, nil);
		break;
	default:
		respond(r, nil);
		break;
	}
}

void
readreqrem(void *a)
{
	Ioproc *io;
	Req *r;
	Conn *c;
	SSHChan *sc;
	int fd, n, lev, cnum, xconn;
	uvlong qidpath;
	char buf[Arbbufsz], path[NETPATHLEN];

	threadsetname("readreqrem");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		if (lev != Top) {
			respond(r, "Invalid connection");
			return;
		}
		sc = nil;
	} else {
		cnum = qidpath &amp; Chanmask;
		sc = c-&gt;chans[cnum];
	}
	switch (lev) {
	case Top:
		if (r-&gt;ifcall.offset == 0 &amp;&amp; keymbox.state != Empty) {
			r-&gt;aux = 0;
			respond(r, "Key file collision");	/* WTF? */
			break;
		}
		if (r-&gt;ifcall.offset != 0) {
			readstr(r, keymbox.msg);
			r-&gt;aux = 0;
			respond(r, nil);
			if (r-&gt;ifcall.offset + r-&gt;ifcall.count &gt;=
			    strlen(keymbox.msg))
				keymbox.state = Empty;
			else
				keymbox.state = Allocated;
			break;
		}
		keymbox.state = Allocated;
		for(;;) {
			if (keymbox.msg == nil)
				if (recv(keymbox.mchan, nil) &lt; 0) {
					r-&gt;aux = 0;
					responderror(r);
					keymbox.state = Empty;
					threadexits(nil);
				}
			if (keymbox.state == Empty)
				break;
			else if (keymbox.state == Allocated) {
				if (keymbox.msg) {
					readstr(r, keymbox.msg);
					if (r-&gt;ifcall.offset + r-&gt;ifcall.count
					    &gt;= strlen(keymbox.msg)) {
						free(keymbox.msg);
						keymbox.msg = nil;
						keymbox.state = Empty;
					}
				}
				break;
			}
		}
		r-&gt;aux = 0;
		respond(r, nil);
		break;
	case Connection:
		if (c-&gt;ctlfd &gt;= 0) {
			io = ioproc();
			seek(c-&gt;ctlfd, 0, 0);
			n = ioread(io, c-&gt;ctlfd, buf, 10); /* magic 10 */
			if (n &lt; 0) {
				r-&gt;aux = 0;
				responderror(r);
				closeioproc(io);
				break;
			}
			buf[n] = '\0';
			snprint(path, NETPATHLEN, "%s/tcp/%s/remote", mntpt, buf);
			if ((fd = ioopen(io, path, OREAD)) &lt; 0 ||
			    (n = ioread(io, fd, buf, Arbbufsz - 1)) &lt; 0) {
				r-&gt;aux = 0;
				responderror(r);
				if (fd &gt;= 0)
					ioclose(io, fd);
				closeioproc(io);
				break;
			}
			ioclose(io, fd);
			closeioproc(io);
			buf[n] = '\0';
			readstr(r, buf);
		} else
			readstr(r, "::!0\n");
		r-&gt;aux = 0;
		respond(r, nil);
		break;
	case Subchannel:
		if ((sc-&gt;state == Closed || sc-&gt;state == Closing ||
		    sc-&gt;state == Eof) &amp;&amp; sc-&gt;reqq == nil &amp;&amp; sc-&gt;dataq == nil) {
			sshdebug(c, "sending EOF1 to channel request listener");
			r-&gt;aux = 0;
			respond(r, nil);
			break;
		}
		while (sc-&gt;reqq == nil) {
			if (recv(sc-&gt;reqchan, nil) &lt; 0) {
				r-&gt;aux = 0;
				responderror(r);
				threadexits(nil);
			}
			if ((sc-&gt;state == Closed || sc-&gt;state == Closing ||
			    sc-&gt;state == Eof) &amp;&amp; sc-&gt;reqq == nil &amp;&amp;
			    sc-&gt;dataq == nil) {
				sshdebug(c, "sending EOF2 to channel request "
					"listener");
				respexit(c, r, nil, nil);
			}
		}
		n = r-&gt;ifcall.count;
		if (sc-&gt;reqq-&gt;rem &lt; n)
			n = sc-&gt;reqq-&gt;rem;
		if (n &gt; Maxrpcbuf)
			n = Maxrpcbuf;
		r-&gt;ifcall.offset = 0;
		readbuf(r, sc-&gt;reqq-&gt;st, n);
		sc-&gt;reqq-&gt;st += n;
		sc-&gt;reqq-&gt;rem -= n;
		if (sc-&gt;reqq-&gt;rem &lt;= 0) {
			Plist *d = sc-&gt;reqq;
			sc-&gt;reqq = sc-&gt;reqq-&gt;next;
			free(d-&gt;pack);
			free(d);
		}
		r-&gt;aux = 0;
		respond(r, nil);
		break;
	}
	threadexits(nil);
}

void
readdata(void *a)
{
	Req *r;
	Conn *c;
	SSHChan *sc;
	int cnum, xconn;
	uvlong qidpath;

	threadsetname("readdata");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		respond(r, "bad connection");
		sshlog(c, "bad connection");
		threadexits(nil);
	}
	cnum = qidpath &amp; Chanmask;
	sc = c-&gt;chans[cnum];
	if (sc-&gt;dataq == nil &amp;&amp; (sc-&gt;state == Closed || sc-&gt;state == Closing ||
	    sc-&gt;state == Eof)) {
		sshdebug(c, "sending EOF1 to channel listener");
		r-&gt;aux = 0;
		respond(r, nil);
		threadexits(nil);
	}
	if (sc-&gt;dataq != nil) {
		getdata(c, sc, r);
		threadexits(nil);
	}
	while (sc-&gt;dataq == nil) {
		if (recv(sc-&gt;inchan, nil) &lt; 0) {
			sshdebug(c, "got interrupt/error in readdata %r");
			r-&gt;aux = 0;
			responderror(r);
			threadexits(nil);
		}
		if (sc-&gt;dataq == nil &amp;&amp; (sc-&gt;state == Closed ||
		    sc-&gt;state == Closing || sc-&gt;state == Eof)) {
			sshdebug(c, "sending EOF2 to channel listener");
			r-&gt;aux = 0;
			respond(r, nil);
			threadexits(nil);
		}
	}
	getdata(c, sc, r);
	threadexits(nil);
}

void
stwrite(Req *r)
{
	Conn *c;
	SSHChan *ch;
	int lev, xconn;
	uvlong qidpath;

	threadsetname("stwrite");
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		respond(r, "invalid connection");
		return;
	}
	ch = c-&gt;chans[qidpath &amp; Chanmask];
	switch ((ulong)(qidpath &amp; Qtypemask)) {
	case Qclone:
	case Qctl:
		r-&gt;aux = (void *)threadcreate(writectlproc, r, Defstk);
		break;
	case Qdata:
		r-&gt;ofcall.count = r-&gt;ifcall.count;
		if (lev == Top || lev == Connection ||
		    c-&gt;state == Closed || c-&gt;state == Closing ||
		    ch-&gt;state == Closed || ch-&gt;state == Closing) {
			respond(r, nil);
			break;
		}
		if (0 &amp;&amp; c-&gt;stifle) {		/* was for coexistence */
			c-&gt;stifle = 0;
			if (deferredinit(c) &lt; 0) {
				respond(r, "deferredinit failed");
				break;
			}
		}
		r-&gt;aux = (void *)threadcreate(writedataproc, r, Defstk);
		break;
	case Qreqrem:
		r-&gt;aux = (void *)threadcreate(writereqremproc, r, Defstk);
		break;
	default:
		respond(r, nil);
		break;
	}
}

static int
dialbyhand(Conn *c, int ntok, char *toks[])
{
	/*
	 * this uses /net/tcp to connect directly.
	 * should use dial(2) instead of doing it by hand.
	 */
	sshdebug(c, "tcp connect %s %s", toks[1], ntok &gt; 3? toks[2]: "");
	return fprint(c-&gt;ctlfd, "connect %s %s", toks[1], ntok &gt; 3? toks[2]: "");
}

static void
userauth(Conn *c, Req *r, char *buf, int ntok, char *toks[])
{
	int n;
	char *attrs[5];
	Packet *p;

	if (ntok &lt; 3 || ntok &gt; 4)
		respexit(c, r, buf, "bad connect command");
	if (!c-&gt;service)
		c-&gt;service = estrdup9p(toks[0]);
	if (c-&gt;user)
		free(c-&gt;user);
	c-&gt;user = estrdup9p(toks[2]);
	sshdebug(c, "userauth for user %s", c-&gt;user);

	if (ntok == 4 &amp;&amp; strcmp(toks[1], "k") == 0) {
		if (c-&gt;authkey) {
			free(c-&gt;authkey);
			c-&gt;authkey = nil;
		}
		if (c-&gt;password)
			free(c-&gt;password);
		c-&gt;password = estrdup9p(toks[3]);
		sshdebug(c, "userauth got password");
	} else {
		if (c-&gt;password) {
			free(c-&gt;password);
			c-&gt;password = nil;
		}
		memset(attrs, 0, sizeof attrs);
		attrs[0] = "proto=rsa";
		attrs[1] = "!dk?";
		attrs[2] = smprint("user=%s", c-&gt;user);
		attrs[3] = smprint("sys=%s", c-&gt;remote);
		if (c-&gt;authkey)
			free(c-&gt;authkey);
		sshdebug(c, "userauth trying rsa");
		if (ntok == 3)
			c-&gt;authkey = factlookup(4, 2, attrs);
		else {
			attrs[4] = toks[3];
			c-&gt;authkey = factlookup(5, 2, attrs);
		}
		free(attrs[2]);
		free(attrs[3]);
	}

	if (!c-&gt;password &amp;&amp; !c-&gt;authkey)
		respexit(c, r, buf, "no auth info");
	else if (c-&gt;state != Authing) {
		p = new_packet(c);
		add_byte(p, SSH_MSG_SERVICE_REQUEST);
		add_string(p, c-&gt;service);
		n = finish_packet(p);
		sshdebug(c, "sending msg svc req for %s", c-&gt;service);
		if (writeio(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n) != n) {
			sshdebug(c, "authing write failed: %r");
			free(p);
			r-&gt;aux = 0;
			responderror(r);
			free(buf);
			threadexits(nil);
		}
		free(p);
	} else
		if (client_auth(c, c-&gt;dio) &lt; 0)
			respexit(c, r, buf, "ssh-userauth client auth failed");
	qlock(&amp;c-&gt;l);
	if (c-&gt;state != Established) {
		sshdebug(c, "sleeping for auth");
		rsleep(&amp;c-&gt;r);
	}
	qunlock(&amp;c-&gt;l);
	if (c-&gt;state != Established)
		respexit(c, r, buf, "ssh-userath auth failed (not Established)");
}

void
writectlproc(void *a)
{
	Req *r;
	Packet *p;
	Conn *c;
	SSHChan *ch;
	char *tcpconn2, *buf, *toks[4];
	int n, ntok, lev, xconn;
	uvlong qidpath;
	char path[NETPATHLEN], tcpconn[Numbsz];

	threadsetname("writectlproc");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;

	c = connections[xconn];
	if (c == nil) {
		respond(r, "bad connection");
		sshlog(c, "bad connection");
		threadexits(nil);
	}
	ch = c-&gt;chans[qidpath &amp; Chanmask];

	if (r-&gt;ifcall.count &lt;= Numbsz)
		buf = emalloc9p(Numbsz + 1);
	else
		buf = emalloc9p(r-&gt;ifcall.count + 1);
	memmove(buf, r-&gt;ifcall.data, r-&gt;ifcall.count);
	buf[r-&gt;ifcall.count] = '\0';

	sshdebug(c, "level %d writectl: %s", lev, buf);
	ntok = tokenize(buf, toks, nelem(toks));
	switch (lev) {
	case Connection:
		if (strcmp(toks[0], "id") == 0) {	/* was for sshswitch */
			if (ntok &lt; 2)
				respexit(c, r, buf, "bad id request");
			strncpy(c-&gt;idstring, toks[1], sizeof c-&gt;idstring);
			sshdebug(c, "id %s", toks[1]);
			break;
		}
		if (strcmp(toks[0], "connect") == 0) {
			if (ntok &lt; 2)
				respexit(c, r, buf, "bad connect request");
			/*
			 * should use dial(2) instead of doing it by hand.
			 */
			memset(tcpconn, '\0', sizeof(tcpconn));
			pread(c-&gt;ctlfd, tcpconn, sizeof tcpconn, 0);
			dialbyhand(c, ntok, toks);

			c-&gt;role = Client;
			/* Override the PKA list; we can take any in */
			pkas[0] = &amp;rsa_pka;
			pkas[1] = &amp;dss_pka;
			pkas[2] = nil;
			tcpconn2 = estrdup9p(tcpconn);

			/* swap id strings, negotiate crypto */
			if (dohandshake(c, tcpconn2) &lt; 0) {
				sshlog(c, "connect handshake failed: "
					"tcp conn %s", tcpconn2);
				free(tcpconn2);
				respexit(c, r, buf, "connect handshake failed");
			}
			free(tcpconn2);
			keymbox.state = Empty;
			nbsendul(keymbox.mchan, 1);
			break;
		}

		if (c-&gt;state == Closed || c-&gt;state == Closing)
			respexit(c, r, buf, "connection closed");
		if (strcmp(toks[0], "ssh-userauth") == 0)
			userauth(c, r, buf, ntok, toks);
		else if (strcmp(toks[0], "ssh-connection") == 0) {
			/* your ad here */
		} else if (strcmp(toks[0], "hangup") == 0) {
			if (c-&gt;rpid &gt;= 0)
				threadint(c-&gt;rpid);
			shutdown(c);
		} else if (strcmp(toks[0], "announce") == 0) {
			sshdebug(c, "got %s argument for announce", toks[1]);
			write(c-&gt;ctlfd, r-&gt;ifcall.data, r-&gt;ifcall.count);
		} else if (strcmp(toks[0], "accept") == 0) {
			/* should use dial(2) instead of diddling /net/tcp */
			memset(tcpconn, '\0', sizeof(tcpconn));
			pread(c-&gt;ctlfd, tcpconn, sizeof tcpconn, 0);
			fprint(c-&gt;ctlfd, "accept %s", tcpconn);

			c-&gt;role = Server;
			tcpconn2 = estrdup9p(tcpconn);
			/* swap id strings, negotiate crypto */
			if (dohandshake(c, tcpconn2) &lt; 0) {
				sshlog(c, "accept handshake failed: "
					"tcp conn %s", tcpconn2);
				free(tcpconn2);
				shutdown(c);
				respexit(c, r, buf, "accept handshake failed");
			}
			free(tcpconn2);
		} else if (strcmp(toks[0], "reject") == 0) {
			memset(tcpconn, '\0', sizeof(tcpconn));
			pread(c-&gt;ctlfd, tcpconn, sizeof tcpconn, 0);

			snprint(path, NETPATHLEN, "%s/tcp/%s/data", mntpt, tcpconn);
			c-&gt;datafd = open(path, ORDWR);

			p = new_packet(c);
			add_byte(p, SSH_MSG_DISCONNECT);
			add_byte(p, SSH_DISCONNECT_HOST_NOT_ALLOWED_TO_CONNECT);
			add_string(p, toks[2]);
			add_string(p, "EN");
			n = finish_packet(p);
			if (c-&gt;dio &amp;&amp; c-&gt;datafd &gt;= 0)
				iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
			free(p);
			if (c-&gt;ctlfd &gt;= 0)
				fprint(c-&gt;ctlfd, "reject %s %s", buf, toks[2]);
			if (c-&gt;rpid &gt;= 0)
				threadint(c-&gt;rpid);
			shutdown(c);
		}
		break;
	case Subchannel:
		if (c-&gt;state == Closed || c-&gt;state == Closing)
			respexit(c, r, buf, "channel closed");
		if (strcmp(toks[0], "connect") == 0) {
			p = new_packet(c);
			add_byte(p, SSH_MSG_CHANNEL_OPEN);
			sshdebug(c, "chan writectl: connect %s",
				ntok &gt; 1? toks[1]: "session");
			add_string(p, ntok &gt; 1? toks[1]: "session");
			add_uint32(p, ch-&gt;id);
			add_uint32(p, Maxpayload);
			add_uint32(p, Maxrpcbuf);
			/* more stuff if it's an x11 session */
			n = finish_packet(p);
			iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
			free(p);
			qlock(&amp;c-&gt;l);
			if (ch-&gt;otherid == -1)
				rsleep(&amp;ch-&gt;r);
			qunlock(&amp;c-&gt;l);
		} else if (strcmp(toks[0], "global") == 0) {
			/* your ad here */
		} else if (strcmp(toks[0], "hangup") == 0) {
			if (ch-&gt;state != Closed &amp;&amp; ch-&gt;state != Closing) {
				ch-&gt;state = Closing;
				if (ch-&gt;otherid != -1) {
					p = new_packet(c);
					add_byte(p, SSH_MSG_CHANNEL_CLOSE);
					add_uint32(p, ch-&gt;otherid);
					n = finish_packet(p);
					iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
					free(p);
				}
				qlock(&amp;c-&gt;l);
				rwakeup(&amp;ch-&gt;r);
				qunlock(&amp;c-&gt;l);
				nbsendul(ch-&gt;inchan, 1);
				nbsendul(ch-&gt;reqchan, 1);
			}
			for (n = 0; n &lt; MAXCONN &amp;&amp; (c-&gt;chans[n] == nil ||
			    c-&gt;chans[n]-&gt;state == Empty ||
			    c-&gt;chans[n]-&gt;state == Closing ||
			    c-&gt;chans[n]-&gt;state == Closed); ++n)
				;
			if (n &gt;= MAXCONN) {
				if (c-&gt;rpid &gt;= 0)
					threadint(c-&gt;rpid);
				shutdown(c);
			}
		} else if (strcmp(toks[0], "announce") == 0) {
			sshdebug(c, "got argument `%s' for chan announce",
				toks[1]);
			free(ch-&gt;ann);
			ch-&gt;ann = estrdup9p(toks[1]);
		}
		break;
	}
	r-&gt;ofcall.count = r-&gt;ifcall.count;
	r-&gt;aux = 0;
	respond(r, nil);
	free(buf);
	threadexits(nil);
}

void
writereqremproc(void *a)
{
	Req *r;
	Packet *p;
	Conn *c;
	SSHChan *ch;
	char *cmd, *q, *buf, *toks[4];
	int n, ntok, lev, xconn;
	uvlong qidpath;

	threadsetname("writereqremproc");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		respond(r, "Invalid connection");
		threadexits(nil);
	}
	ch = c-&gt;chans[qidpath &amp; Chanmask];
	if (r-&gt;ifcall.count &lt;= 10)
		buf = emalloc9p(10 + 1);
	else
		buf = emalloc9p(r-&gt;ifcall.count + 1);
	memmove(buf, r-&gt;ifcall.data, r-&gt;ifcall.count);
	buf[r-&gt;ifcall.count] = '\0';
	sshdebug(c, "writereqrem: %s", buf);
	ntok = tokenize(buf, toks, nelem(toks));

	if (lev == Top) {
		free(keymbox.msg);
		keymbox.msg = buf;
		nbsendul(keymbox.mchan, 1);
		r-&gt;ofcall.count = r-&gt;ifcall.count;
		respexit(c, r, nil, nil);
	}

	r-&gt;ofcall.count = r-&gt;ifcall.count;
	if (c-&gt;state == Closed  || c-&gt;state == Closing ||
	    ch-&gt;state == Closed || ch-&gt;state == Closing)
		respexit(c, r, buf, nil);

	p = new_packet(c);
	if (strcmp(toks[0], "success") == 0) {
		add_byte(p, SSH_MSG_CHANNEL_SUCCESS);
		add_uint32(p, ch-&gt;otherid);
	} else if (strcmp(toks[0], "failure") == 0) {
		add_byte(p, SSH_MSG_CHANNEL_FAILURE);
		add_uint32(p, ch-&gt;otherid);
	} else if (strcmp(toks[0], "close") == 0) {
		ch-&gt;state = Closing;
		add_byte(p, SSH_MSG_CHANNEL_CLOSE);
		add_uint32(p, ch-&gt;otherid);
	} else if (strcmp(toks[0], "shell") == 0) {
		ch-&gt;state = Established;
		/*
		 * Some servers *cough*OpenSSH*cough* don't seem to be able
		 * to intelligently handle a shell with no pty.
		 */
		add_byte(p, SSH_MSG_CHANNEL_REQUEST);
		add_uint32(p, ch-&gt;otherid);
		add_string(p, "pty-req");
		add_byte(p, 0);
		if (ntok == 1)
			add_string(p, "dumb");
		else
			add_string(p, toks[1]);
		add_uint32(p, 0);
		add_uint32(p, 0);
		add_uint32(p, 0);
		add_uint32(p, 0);
		add_string(p, "");
		n = finish_packet(p);
		iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
		init_packet(p);
		p-&gt;c = c;
		add_byte(p, SSH_MSG_CHANNEL_REQUEST);
		add_uint32(p, ch-&gt;otherid);
		add_string(p, "shell");
		add_byte(p, 0);
		sshdebug(c, "sending shell request: rlength=%lud twindow=%lud",
			p-&gt;rlength, ch-&gt;twindow);
	} else if (strcmp(toks[0], "exec") == 0) {
		ch-&gt;state = Established;
		add_byte(p, SSH_MSG_CHANNEL_REQUEST);
		add_uint32(p, ch-&gt;otherid);
		add_string(p, "exec");
		add_byte(p, 0);

		cmd = emalloc9p(Bigbufsz);
		q = seprint(cmd, cmd+Bigbufsz, "%s", toks[1]);
		for (n = 2; n &lt; ntok; ++n) {
			q = seprint(q, cmd+Bigbufsz, " %q", toks[n]);
			if (q == nil)
				break;
		}
		add_string(p, cmd);
		free(cmd);
	} else
		respexit(c, r, buf, "bad request command");
	n = finish_packet(p);
	iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
	free(p);
	respexit(c, r, buf, nil);
}

void
writedataproc(void *a)
{
	Req *r;
	Packet *p;
	Conn *c;
	SSHChan *ch;
	int n, xconn;
	uvlong qidpath;

	threadsetname("writedataproc");
	r = a;
	qidpath = (uvlong)r-&gt;fid-&gt;file-&gt;aux;
	xconn = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	c = connections[xconn];
	if (c == nil) {
		respond(r, "Invalid connection");
		threadexits(nil);
	}
	ch = c-&gt;chans[qidpath &amp; Chanmask];

	p = new_packet(c);
	add_byte(p, SSH_MSG_CHANNEL_DATA);
	hnputl(p-&gt;payload+1, ch-&gt;otherid);
	p-&gt;rlength += 4;
	add_block(p, r-&gt;ifcall.data, r-&gt;ifcall.count);
	n = finish_packet(p);

	if (ch-&gt;sent + p-&gt;rlength &gt; ch-&gt;twindow) {
		qlock(&amp;ch-&gt;xmtlock);
		while (ch-&gt;sent + p-&gt;rlength &gt; ch-&gt;twindow)
			rsleep(&amp;ch-&gt;xmtrendez);
		qunlock(&amp;ch-&gt;xmtlock);
	}
	iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
	respexit(c, r, p, nil);
}

/*
 * Although this is named stclunk, it's attached to the destroyfid
 * member of the Srv struct.  It turns out there's no member
 * called clunk.  But if there are no other references, a 9P Tclunk
 * will end up calling destroyfid.
 */
void
stclunk(Fid *f)
{
	Packet *p;
	Conn *c;
	SSHChan *sc;
	int n, lev, cnum, chnum;
	uvlong qidpath;

	threadsetname("stclunk");
	if (f == nil || f-&gt;file == nil)
		return;
	qidpath = (uvlong)f-&gt;file-&gt;aux;
	lev = qidpath &gt;&gt; Levshift;
	cnum = (qidpath &gt;&gt; Connshift) &amp; Connmask;
	chnum = qidpath &amp; Chanmask;
	c = connections[cnum];
	sshdebug(c, "got clunk on file: %#llux %d %d %d: %s",
		qidpath, lev, cnum, chnum, f-&gt;file-&gt;name);
	/* qidpath test implies conn 0, chan 0 */
	if (lev == Top &amp;&amp; qidpath == Qreqrem) {
		if (keymbox.state != Empty) {
			keymbox.state = Empty;
			// nbsendul(keymbox.mchan, 1);
		}
		keymbox.msg = nil;
		return;
	}

	if (c == nil)
		return;
	if (lev == Connection &amp;&amp; (qidpath &amp; Qtypemask) == Qctl &amp;&amp;
	    (c-&gt;state == Opening || c-&gt;state == Negotiating ||
	     c-&gt;state == Authing)) {
		for (n = 0; n &lt; MAXCONN &amp;&amp; (!c-&gt;chans[n] ||
		    c-&gt;chans[n]-&gt;state == Empty ||
		    c-&gt;chans[n]-&gt;state == Closed ||
		    c-&gt;chans[n]-&gt;state == Closing); ++n)
			;
		if (n &gt;= MAXCONN) {
			if (c-&gt;rpid &gt;= 0)
				threadint(c-&gt;rpid);
			shutdown(c);
		}
		return;
	}

	sc = c-&gt;chans[chnum];
	if (lev != Subchannel)
		return;
	if ((qidpath &amp; Qtypemask) == Qlisten &amp;&amp; sc-&gt;state == Listening) {
		qlock(&amp;c-&gt;l);
		if (sc-&gt;state != Closed) {
			sc-&gt;state = Closed;
			chanclose(sc-&gt;inchan);
			chanclose(sc-&gt;reqchan);
		}
		qunlock(&amp;c-&gt;l);
	} else if ((qidpath &amp; Qtypemask) == Qdata &amp;&amp; sc-&gt;state != Empty &amp;&amp;
	    sc-&gt;state != Closed &amp;&amp; sc-&gt;state != Closing) {
		if (f-&gt;file != sc-&gt;data &amp;&amp; f-&gt;file != sc-&gt;request) {
			sshlog(c, "great evil is upon us; destroying a fid "
				"we didn't create");
			return;
		}

		p = new_packet(c);
		add_byte(p, SSH_MSG_CHANNEL_CLOSE);
		hnputl(p-&gt;payload+1, sc-&gt;otherid);
		p-&gt;rlength += 4;
		n = finish_packet(p);
		sc-&gt;state = Closing;
		iowrite(c-&gt;dio, c-&gt;datafd, p-&gt;nlength, n);
		free(p);

		qlock(&amp;c-&gt;l);
		rwakeup(&amp;sc-&gt;r);
		qunlock(&amp;c-&gt;l);
		nbsendul(sc-&gt;inchan, 1);
		nbsendul(sc-&gt;reqchan, 1);
	}
	for (n = 0; n &lt; MAXCONN &amp;&amp; (!c-&gt;chans[n] ||
	    c-&gt;chans[n]-&gt;state == Empty || c-&gt;chans[n]-&gt;state == Closed ||
	    c-&gt;chans[n]-&gt;state == Closing); ++n)
		;
	if (n &gt;= MAXCONN) {
		if (c-&gt;rpid &gt;= 0)
			threadint(c-&gt;rpid);
		shutdown(c);
	}
}

void
stflush(Req *r)
{
	Req *or;
	uvlong qidpath;

	threadsetname("stflush");
	or = r-&gt;oldreq;
	qidpath = (uvlong)or-&gt;fid-&gt;file-&gt;aux;
	sshdebug(nil, "got flush on file %#llux %lld %lld %lld: %s %#p",
		argv0, qidpath, qidpath &gt;&gt; Levshift,
		(qidpath &gt;&gt; Connshift) &amp; Connmask, qidpath &amp; Chanmask,
		or-&gt;fid-&gt;file-&gt;name, or-&gt;aux);
	if (!or-&gt;aux)
		respond(or, "interrupted");
	else if (or-&gt;ifcall.type == Topen &amp;&amp; (qidpath &amp; Qtypemask) == Qlisten ||
	    or-&gt;ifcall.type == Tread &amp;&amp; (qidpath &amp; Qtypemask) == Qdata &amp;&amp;
	    (qidpath &gt;&gt; Levshift) == Subchannel ||
	    or-&gt;ifcall.type == Tread &amp;&amp; (qidpath &amp; Qtypemask) == Qreqrem)
		threadint((uintptr)or-&gt;aux);
	else {
		threadkill((uintptr)or-&gt;aux);
		or-&gt;aux = 0;
		respond(or, "interrupted");
	}
	respond(r, nil);
}

void
filedup(Req *r, File *src)
{
	r-&gt;ofcall.qid = src-&gt;qid;
	closefile(r-&gt;fid-&gt;file);
	r-&gt;fid-&gt;file = src;
	incref(src);
}

Conn *
alloc_conn(void)
{
	int slevconn, i, s, firstnil;
	char buf[Numbsz];
	Conn *c;
	static QLock aclock;

	qlock(&amp;aclock);
	firstnil = -1;
	for (i = 0; i &lt; MAXCONN; ++i) {
		if (connections[i] == nil) {
			if (firstnil == -1)
				firstnil = i;
			continue;
		}
		s = connections[i]-&gt;state;
		if (s == Empty || s == Closed)
			break;
	}
	if (i &gt;= MAXCONN) {
		if (firstnil == -1) {		/* all slots in use? */
			qunlock(&amp;aclock);
			return nil;
		}
		/* no reusable slots, allocate a new Conn */
		connections[firstnil] = emalloc9p(sizeof(Conn));
		memset(connections[firstnil], 0, sizeof(Conn));
		i = firstnil;
	}

	c = connections[i];
	memset(&amp;c-&gt;r, '\0', sizeof(Rendez));
	c-&gt;r.l = &amp;c-&gt;l;
	c-&gt;dio = ioproc();
	c-&gt;rio = nil;
	c-&gt;state = Allocated;
	c-&gt;role = Server;
	c-&gt;id = i;
	c-&gt;stifle = c-&gt;poisoned = 0;
	c-&gt;user = c-&gt;service = nil;
	c-&gt;inseq = c-&gt;nchan = c-&gt;outseq = 0;
	c-&gt;cscrypt = c-&gt;csmac = c-&gt;ctlfd = c-&gt;datafd = c-&gt;decrypt =
		c-&gt;encrypt = c-&gt;inmac = c-&gt;ncscrypt = c-&gt;ncsmac =
		c-&gt;nsccrypt = c-&gt;nscmac = c-&gt;outmac = c-&gt;rpid = c-&gt;sccrypt =
		c-&gt;scmac = c-&gt;tcpconn = -1;
	if (c-&gt;e) {
		mpfree(c-&gt;e);
		c-&gt;e = nil;
	}
	if (c-&gt;x) {
		mpfree(c-&gt;x);
		c-&gt;x = nil;
	}

	snprint(buf, sizeof buf, "%d", i);
	if (c-&gt;dir == nil) {
		slevconn = Connection &lt;&lt; Levshift | i &lt;&lt; Connshift;
		c-&gt;dir = createfile(rootfile, buf, uid, 0555|DMDIR,
			(void *)(slevconn | Qroot));
		c-&gt;clonefile = createfile(c-&gt;dir, "clone", uid, 0666,
			(void *)(slevconn | Qclone));
		c-&gt;ctlfile = createfile(c-&gt;dir, "ctl", uid, 0666,
			(void *)(slevconn | Qctl));
		c-&gt;datafile = createfile(c-&gt;dir, "data", uid, 0666,
			(void *)(slevconn | Qdata));
		c-&gt;listenfile = createfile(c-&gt;dir, "listen", uid, 0666,
			(void *)(slevconn | Qlisten));
		c-&gt;localfile = createfile(c-&gt;dir, "local", uid, 0444,
			(void *)(slevconn | Qlocal));
		c-&gt;remotefile = createfile(c-&gt;dir, "remote", uid, 0444,
			(void *)(slevconn | Qreqrem));
		c-&gt;statusfile = createfile(c-&gt;dir, "status", uid, 0444,
			(void *)(slevconn | Qstatus));
		c-&gt;tcpfile = createfile(c-&gt;dir, "tcp", uid, 0444,
			(void *)(slevconn | Qtcp));
	}
//	c-&gt;skexinit = c-&gt;rkexinit = nil;
	c-&gt;got_sessid = 0;
	c-&gt;otherid = nil;
	c-&gt;inik = c-&gt;outik = nil;
	c-&gt;s2ccs = c-&gt;c2scs = c-&gt;enccs = c-&gt;deccs = nil;
	qunlock(&amp;aclock);
	return c;
}

SSHChan *
alloc_chan(Conn *c)
{
	int cnum, slcn;
	char buf[Numbsz];
	Plist *p, *next;
	SSHChan *sc;

	if (c-&gt;nchan &gt;= MAXCONN)
		return nil;
	qlock(&amp;c-&gt;l);
	cnum = c-&gt;nchan;
	if (c-&gt;chans[cnum] == nil) {
		c-&gt;chans[cnum] = emalloc9p(sizeof(SSHChan));
		memset(c-&gt;chans[cnum], 0, sizeof(SSHChan));
	}
	sc = c-&gt;chans[cnum];
	snprint(buf, sizeof buf, "%d", cnum);
	memset(&amp;sc-&gt;r, '\0', sizeof(Rendez));
	sc-&gt;r.l = &amp;c-&gt;l;
	sc-&gt;id = cnum;
	sc-&gt;state = Empty;
	sc-&gt;conn = c-&gt;id;
	sc-&gt;otherid = sc-&gt;waker = -1;
	sc-&gt;sent = sc-&gt;twindow = sc-&gt;rwindow = sc-&gt;inrqueue = 0;
	sc-&gt;ann = nil;
	sc-&gt;lreq = nil;

	if (sc-&gt;dir == nil) {
		slcn = Subchannel &lt;&lt; Levshift | c-&gt;id &lt;&lt; Connshift | cnum;
		sc-&gt;dir = createfile(c-&gt;dir, buf, uid, 0555|DMDIR,
			(void *)(slcn | Qroot));
		sc-&gt;ctl = createfile(sc-&gt;dir, "ctl", uid, 0666,
			(void *)(slcn | Qctl));
		sc-&gt;data = createfile(sc-&gt;dir, "data", uid, 0666,
			(void *)(slcn | Qdata));
		sc-&gt;listen = createfile(sc-&gt;dir, "listen", uid, 0666,
			(void *)(slcn | Qlisten));
		sc-&gt;request = createfile(sc-&gt;dir, "request", uid, 0666,
			(void *)(slcn | Qreqrem));
		sc-&gt;status = createfile(sc-&gt;dir, "status", uid, 0444,
			(void *)(slcn | Qstatus));
		sc-&gt;tcp = createfile(sc-&gt;dir, "tcp", uid, 0444,
			(void *)(slcn | Qtcp));
	}
	c-&gt;nchan++;

	for (; sc-&gt;reqq != nil; sc-&gt;reqq = next) {
		p = sc-&gt;reqq;
		next = p-&gt;next;
		free(p-&gt;pack);
		free(p);
	}
	sc-&gt;dataq = sc-&gt;datatl = sc-&gt;reqtl = nil;

	if (sc-&gt;inchan)
		chanfree(sc-&gt;inchan);
	sc-&gt;inchan = chancreate(4, 0);

	if (sc-&gt;reqchan)
		chanfree(sc-&gt;reqchan);
	sc-&gt;reqchan = chancreate(4, 0);

	memset(&amp;sc-&gt;xmtrendez, '\0', sizeof(Rendez));
	sc-&gt;xmtrendez.l = &amp;sc-&gt;xmtlock;
	qunlock(&amp;c-&gt;l);
	return sc;
}

static int
readlineio(Conn *, Ioproc *io, int fd, char *buf, int size)
{
	int n;
	char *p;

	for (p = buf; p &lt; buf + size - 1; p++) {
		n = ioread(io, fd, p, 1);
		if (n != 1 || *p == '\n') {
			*p = '\0';
			break;
		}
	}
	return p - buf;
}

static char *
readremote(Conn *c, Ioproc *io, char *tcpconn)
{
	int n, remfd;
	char *p, *remote;
	char path[Arbbufsz], buf[NETPATHLEN];

	remote = nil;
	snprint(path, sizeof path, "%s/tcp/%s/remote", mntpt, tcpconn);
	remfd = ioopen(io, path, OREAD);
	if (remfd &lt; 0) {
		sshlog(c, "readremote: can't open %s: %r", path);
		return nil;
	}
	n = ioread(io, remfd, buf, sizeof buf - 1);
	if (n &gt; 0) {
		buf[n] = 0;
		p = strchr(buf, '!');
		if (p)
			*p = 0;
		remote = estrdup9p(buf);
	}
	ioclose(io, remfd);
	return remote;
}

static void
sendmyid(Conn *c, Ioproc *io)
{
	char path[Arbbufsz];

	snprint(path, sizeof path, "%s\r\n", MYID);
	iowrite(io, c-&gt;datafd, path, strlen(path));
}

/* save and tidy up the remote id */
static void
stashremid(Conn *c, char *remid)
{
	char *nl;

	if (c-&gt;otherid)
		free(c-&gt;otherid);
	c-&gt;otherid = estrdup9p(remid);

	nl = strchr(c-&gt;otherid, '\n');
	if (nl)
		*nl = '\0';
	nl = strchr(c-&gt;otherid, '\r');
	if (nl)
		*nl = '\0';
}

static void
hangupconn(Conn *c)
{
	hangup(c-&gt;ctlfd);
	close(c-&gt;ctlfd);
	close(c-&gt;datafd);
	c-&gt;ctlfd = c-&gt;datafd = -1;
}

#ifdef COEXIST
static int
exchids(Conn *c, Ioproc *io, char *remid, int remsz)
{
	int n;

	/*
	 * exchange versions.  server writes id, then reads;
	 * client reads id then writes (in theory).
	 */
	if (c-&gt;role == Server) {
		sendmyid(c, io);

		n = readlineio(c, io, c-&gt;datafd, remid, remsz);
		if (n &lt; 5)		/* can't be a valid SSH id string */
			return -1;
		sshdebug(c, "dohandshake: server, got `%s', sent `%s'", remid,
			MYID);
	} else {
		/* client: read server's id */
		n = readlineio(c, io, c-&gt;datafd, remid, remsz);
		if (n &lt; 5)		/* can't be a valid SSH id string */
			return -1;

		sendmyid(c, io);
		sshdebug(c, "dohandshake: client, got `%s' sent `%s'", remid, MYID);
		if (remid[0] == '\0') {
			sshlog(c, "dohandshake: client, empty remote id string;"
				" out of sync");
			return -1;
		}
	}
	sshdebug(c, "remote id string `%s'", remid);
	return 0;
}

/*
 * negotiate the protocols.
 * We don't do the full negotiation here, because we also have
 * to handle a re-negotiation request from the other end.
 * So we just kick it off and let the receiver process take it from there.
 */
static int
negotiate(Conn *c)
{
	send_kexinit(c);

	qlock(&amp;c-&gt;l);
	if ((c-&gt;role == Client &amp;&amp; c-&gt;state != Negotiating) ||
	    (c-&gt;role == Server &amp;&amp; c-&gt;state != Established)) {
		sshdebug(c, "awaiting establishment");
		rsleep(&amp;c-&gt;r);
	}
	qunlock(&amp;c-&gt;l);

	if (c-&gt;role == Server &amp;&amp; c-&gt;state != Established ||
	    c-&gt;role == Client &amp;&amp; c-&gt;state != Negotiating) {
		sshdebug(c, "failed to establish");
		return -1;
	}
	sshdebug(c, "established; crypto now on");
	return 0;
}

/* this was deferred when trying to make coexistence with v1 work */
static int
deferredinit(Conn *c)
{
	char remid[Arbbufsz];
	Ioproc *io;

	io = ioproc();
	/*
	 * don't bother checking the remote's id string.
	 * as a client, we can cope with v1 if we don't verify the host key.
	 */
	if (exchids(c, io, remid, sizeof remid) &lt; 0 ||
	    0 &amp;&amp; c-&gt;role == Client &amp;&amp; strncmp(remid, "SSH-2", 5) != 0 &amp;&amp;
	    strncmp(remid, "SSH-1.99", 8) != 0) {
		/* not a protocol version we know; give up */
		closeioproc(io);
		hangupconn(c);
		return -1;
	}
	closeioproc(io);
	stashremid(c, remid);

	c-&gt;state = Initting;

	/* start the reader thread */
	if (c-&gt;rpid &lt; 0)
		c-&gt;rpid = threadcreate(reader, c, Defstk);

	return negotiate(c);
}

int
dohandshake(Conn *c, char *tcpconn)
{
	int tcpdfd;
	char *remote;
	char path[Arbbufsz];
	Ioproc *io;

	io = ioproc();

	/* read tcp conn's remote address into c-&gt;remote */
	remote = readremote(c, io, tcpconn);
	if (remote) {
		free(c-&gt;remote);
		c-&gt;remote = remote;
	}

	/* open tcp conn's data file */
	c-&gt;tcpconn = atoi(tcpconn);
	snprint(path, sizeof path, "%s/tcp/%s/data", mntpt, tcpconn);
	tcpdfd = ioopen(io, path, ORDWR);
	closeioproc(io);
	if (tcpdfd &lt; 0) {
		sshlog(c, "dohandshake: can't open %s: %r", path);
		return -1;
	}
	c-&gt;datafd = tcpdfd;		/* underlying tcp data descriptor */

	return deferredinit(c);
}
#endif					/* COEXIST */

int
dohandshake(Conn *c, char *tcpconn)
{
	int fd, n;
	char *p, *othid;
	char path[Arbbufsz], buf[NETPATHLEN];
	Ioproc *io;

	io = ioproc();
	snprint(path, sizeof path, "%s/tcp/%s/remote", mntpt, tcpconn);
	fd = ioopen(io, path, OREAD);
	n = ioread(io, fd, buf, sizeof buf - 1);
	if (n &gt; 0) {
		buf[n] = 0;
		p = strchr(buf, '!');
		if (p)
			*p = 0;
		free(c-&gt;remote);
		c-&gt;remote = estrdup9p(buf);
	}
	ioclose(io, fd);

	snprint(path, sizeof path, "%s/tcp/%s/data", mntpt, tcpconn);
	fd = ioopen(io, path, ORDWR);
	if (fd &lt; 0) {
		closeioproc(io);
		return -1;
	}
	c-&gt;datafd = fd;

	/* exchange versions--we're only doing SSH2, unfortunately */

	snprint(path, sizeof path, "%s\r\n", MYID);
	if (c-&gt;idstring &amp;&amp; c-&gt;idstring[0])
		strncpy(path, c-&gt;idstring, sizeof path);
	else {
		iowrite(io, fd, path, strlen(path));
		p = path;
		n = 0;
		do {
			if (ioread(io, fd, p, 1) &lt; 0) {
				fprint(2, "%s: short read in ID exchange: %r\n",
					argv0);
				break;
			}
			++n;
		} while (*p++ != '\n');
		if (n &lt; 5) {		/* can't be a valid SSH id string */
			close(fd);
			goto err;
		}
		*p = 0;
	}
	sshdebug(c, "id string `%s'", path);
	if (c-&gt;idstring[0] == '\0' &amp;&amp;
	    strncmp(path, "SSH-2", 5) != 0 &amp;&amp;
	    strncmp(path, "SSH-1.99", 8) != 0) {
		/* not a protocol version we know; give up */
		ioclose(io, fd);
		goto err;
	}
	closeioproc(io);

	if (c-&gt;otherid)
		free(c-&gt;otherid);
	c-&gt;otherid = othid = estrdup9p(path);
	for (n = strlen(othid) - 1; othid[n] == '\r' || othid[n] == '\n'; --n)
		othid[n] = '\0';
	c-&gt;state = Initting;

	/* start the reader thread */
	if (c-&gt;rpid &lt; 0)
		c-&gt;rpid = threadcreate(reader, c, Defstk);

	/*
	 * negotiate the protocols
	 * We don't do the full negotiation here, because we also have
	 * to handle a re-negotiation request from the other end.  So
	 * we just kick it off and let the receiver process take it from there.
	 */

	send_kexinit(c);

	qlock(&amp;c-&gt;l);
	if ((c-&gt;role == Client &amp;&amp; c-&gt;state != Negotiating) ||
	    (c-&gt;role == Server &amp;&amp; c-&gt;state != Established))
		rsleep(&amp;c-&gt;r);
	qunlock(&amp;c-&gt;l);
	if (c-&gt;role == Server &amp;&amp; c-&gt;state != Established ||
	    c-&gt;role == Client &amp;&amp; c-&gt;state != Negotiating)
		return -1;
	return 0;
err:
	/* should use hangup in dial(2) instead of diddling /net/tcp */
	snprint(path, sizeof path, "%s/tcp/%s/ctl", mntpt, tcpconn);
	fd = ioopen(io, path, OWRITE);
	iowrite(io, fd, "hangup", 6);
	ioclose(io, fd);
	closeioproc(io);
	return -1;
}

void
send_kexinit(Conn *c)
{
	Packet *ptmp;
	char *buf, *p, *e;
	int i, msglen;

	sshdebug(c, "initializing kexinit packet");
	if (c-&gt;skexinit != nil)
		free(c-&gt;skexinit);
	c-&gt;skexinit = new_packet(c);

	buf = emalloc9p(Bigbufsz);
	buf[0] = (uchar)SSH_MSG_KEXINIT;

	add_packet(c-&gt;skexinit, buf, 1);
	for (i = 0; i &lt; 16; ++i)
		buf[i] = fastrand();

	add_packet(c-&gt;skexinit, buf, 16);		/* cookie */
	e = buf + Bigbufsz - 1;
	p = seprint(buf, e, "%s", kexes[0]-&gt;name);
	for (i = 1; i &lt; nelem(kexes); ++i)
		p = seprint(p, e, ",%s", kexes[i]-&gt;name);
	sshdebug(c, "sent KEX algs: %s", buf);

	add_string(c-&gt;skexinit, buf);		/* Key exchange */
	if (pkas[0] == nil)
		add_string(c-&gt;skexinit, "");
	else{
		p = seprint(buf, e, "%s", pkas[0]-&gt;name);
		for (i = 1; i &lt; nelem(pkas) &amp;&amp; pkas[i] != nil; ++i)
			p = seprint(p, e, ",%s", pkas[i]-&gt;name);
		sshdebug(c, "sent host key algs: %s", buf);
		add_string(c-&gt;skexinit, buf);		/* server's key algs */
	}

	p = seprint(buf, e, "%s", cryptos[0]-&gt;name);
	for (i = 1; i &lt; nelem(cryptos); ++i)
		p = seprint(p, e, ",%s", cryptos[i]-&gt;name);
	sshdebug(c, "sent crypto algs: %s", buf);

	add_string(c-&gt;skexinit, buf);		/* c-&gt;s crypto */
	add_string(c-&gt;skexinit, buf);		/* s-&gt;c crypto */
	p = seprint(buf, e, "%s", macnames[0]);
	for (i = 1; i &lt; nelem(macnames); ++i)
		p = seprint(p, e, ",%s", macnames[i]);
	sshdebug(c, "sent MAC algs: %s", buf);

	add_string(c-&gt;skexinit, buf);		/* c-&gt;s mac */
	add_string(c-&gt;skexinit, buf);		/* s-&gt;c mac */
	add_string(c-&gt;skexinit, "none");	/* c-&gt;s compression */
	add_string(c-&gt;skexinit, "none");	/* s-&gt;c compression */
	add_string(c-&gt;skexinit, "");		/* c-&gt;s languages */
	add_string(c-&gt;skexinit, "");		/* s-&gt;c languages */
	memset(buf, 0, 5);
	add_packet(c-&gt;skexinit, buf, 5);

	ptmp = new_packet(c);
	memmove(ptmp, c-&gt;skexinit, sizeof(Packet));
	msglen = finish_packet(ptmp);

	if (c-&gt;dio &amp;&amp; c-&gt;datafd &gt;= 0)
		iowrite(c-&gt;dio, c-&gt;datafd, ptmp-&gt;nlength, msglen);
	free(ptmp);
	free(buf);
}

static void
establish(Conn *c)
{
	qlock(&amp;c-&gt;l);
	c-&gt;state = Established;
	rwakeup(&amp;c-&gt;r);
	qunlock(&amp;c-&gt;l);
}

static int
negotiating(Conn *c, Packet *p, Packet *p2, char *buf, int size)
{
	int i, n;

	USED(size);
	switch (p-&gt;payload[0]) {
	case SSH_MSG_DISCONNECT:
		if (debug) {
			get_string(p, p-&gt;payload + 5, buf, Arbbufsz, nil);
			sshdebug(c, "got disconnect: %s", buf);
		}
		return -1;
	case SSH_MSG_NEWKEYS:
		/*
		 * If we're just updating, go straight to
		 * established, otherwise wait for auth'n.
		 */
		i = c-&gt;encrypt;
		memmove(c-&gt;c2siv, c-&gt;nc2siv, SHA1dlen*2);
		memmove(c-&gt;s2civ, c-&gt;ns2civ, SHA1dlen*2);
		memmove(c-&gt;c2sek, c-&gt;nc2sek, SHA1dlen*2);
		memmove(c-&gt;s2cek, c-&gt;ns2cek, SHA1dlen*2);
		memmove(c-&gt;c2sik, c-&gt;nc2sik, SHA1dlen*2);
		memmove(c-&gt;s2cik, c-&gt;ns2cik, SHA1dlen*2);
		c-&gt;cscrypt = c-&gt;ncscrypt;
		c-&gt;sccrypt = c-&gt;nsccrypt;
		c-&gt;csmac = c-&gt;ncsmac;
		c-&gt;scmac = c-&gt;nscmac;
		c-&gt;c2scs = cryptos[c-&gt;cscrypt]-&gt;init(c, 0);
		c-&gt;s2ccs = cryptos[c-&gt;sccrypt]-&gt;init(c, 1);
		if (c-&gt;role == Server) {
			c-&gt;encrypt = c-&gt;sccrypt;
			c-&gt;decrypt = c-&gt;cscrypt;
			c-&gt;outmac = c-&gt;scmac;
			c-&gt;inmac = c-&gt;csmac;
			c-&gt;enccs = c-&gt;s2ccs;
			c-&gt;deccs = c-&gt;c2scs;
			c-&gt;outik = c-&gt;s2cik;
			c-&gt;inik = c-&gt;c2sik;
		} else{
			c-&gt;encrypt = c-&gt;cscrypt;
			c-&gt;decrypt = c-&gt;sccrypt;
			c-&gt;outmac = c-&gt;csmac;
			c-&gt;inmac = c-&gt;scmac;
			c-&gt;enccs = c-&gt;c2scs;
			c-&gt;deccs = c-&gt;s2ccs;
			c-&gt;outik = c-&gt;c2sik;
			c-&gt;inik = c-&gt;s2cik;
		}
		sshdebug(c, "using %s for encryption and %s for decryption",
			cryptos[c-&gt;encrypt]-&gt;name, cryptos[c-&gt;decrypt]-&gt;name);
		qlock(&amp;c-&gt;l);
		if (i != -1)
			c-&gt;state = Established;
		if (c-&gt;role == Client)
			rwakeup(&amp;c-&gt;r);
		qunlock(&amp;c-&gt;l);
		break;
	case SSH_MSG_KEXDH_INIT:
		kexes[c-&gt;kexalg]-&gt;serverkex(c, p);
		break;
	case SSH_MSG_KEXDH_REPLY:
		init_packet(p2);
		p2-&gt;c = c;
		if (kexes[c-&gt;kexalg]-&gt;clientkex2(c, p) &lt; 0) {
			add_byte(p2, SSH_MSG_DISCONNECT);
			add_byte(p2, SSH_DISCONNECT_KEY_EXCHANGE_FAILED);
			add_string(p2, "Key exchange failure");
			add_string(p2, "");
			n = finish_packet(p2);
			iowrite(c-&gt;rio, c-&gt;datafd, p2-&gt;nlength, n);
			shutdown(c);
			free(p);
			free(p2);
			closeioproc(c-&gt;rio);
			c-&gt;rio = nil;
			c-&gt;rpid = -1;

			qlock(&amp;c-&gt;l);
			rwakeup(&amp;c-&gt;r);
			qunlock(&amp;c-&gt;l);

			sshlog(c, "key exchange failure");
			threadexits(nil);
		}
		add_byte(p2, SSH_MSG_NEWKEYS);
		n = finish_packet(p2);
		iowrite(c-&gt;rio, c-&gt;datafd, p2-&gt;nlength, n);
		qlock(&amp;c-&gt;l);
		rwakeup(&amp;c-&gt;r);
		qunlock(&amp;c-&gt;l);
		break;
	case SSH_MSG_SERVICE_REQUEST:
		get_string(p, p-&gt;payload + 1, buf, Arbbufsz, nil);
		sshdebug(c, "got service request: %s", buf);
		if (strcmp(buf, "ssh-userauth") == 0 ||
		    strcmp(buf, "ssh-connection") == 0) {
			init_packet(p2);
			p2-&gt;c = c;
			sshdebug(c, "connection");
			add_byte(p2, SSH_MSG_SERVICE_ACCEPT);
			add_string(p2, buf);
			n = finish_packet(p2);
			iowrite(c-&gt;rio, c-&gt;datafd, p2-&gt;nlength, n);
			c-&gt;state = Authing;
		} else{
			init_packet(p2);
			p2-&gt;c = c;
			add_byte(p2, SSH_MSG_DISCONNECT);
			add_byte(p2, SSH_DISCONNECT_SERVICE_NOT_AVAILABLE);
			add_string(p2, "Unknown service type");
			add_string(p2, "");
			n = finish_packet(p2);
			iowrite(c-&gt;rio, c-&gt;datafd, p2-&gt;nlength, n);
			return -1;
		}
		break;
	case SSH_MSG_SERVICE_ACCEPT:
		get_string(p, p-&gt;payload + 1, buf, Arbbufsz, nil);
		if (c-&gt;service &amp;&amp; strcmp(c-&gt;service, "ssh-userauth") == 0) {
			free(c-&gt;service);
			c-&gt;service = estrdup9p("ssh-connection");
		}
		sshdebug(c, "got service accept: %s: responding with %s %s",
			buf, c-&gt;user, c-&gt;service);
		n = client_auth(c, c-&gt;rio);
		c-&gt;state = Authing;
		if (n &lt; 0) {
			qlock(&amp;c-&gt;l);
			rwakeup(&amp;c-&gt;r);
			qunlock(&amp;c-&gt;l);
		}
		break;
	}
	return 0;
}

static void
nochans(Conn *c, Packet *p, Packet *p2)
{
	int n;

	init_packet(p2);
	p2-&gt;c = c;
	add_byte(p2, SSH_MSG_CHANNEL_OPEN_FAILURE);
	add_block(p2, p-&gt;payload + 5, 4);
	hnputl(p2-&gt;payload + p2-&gt;rlength - 1, 4);
	p2-&gt;rlength += 4;
	add_string(p2, "No available channels");
	add_string(p2, "EN");
	n = finish_packet(p2);
	iowrite(c-&gt;rio, c-&gt;datafd, p2-&gt;nlength, n);
}

static int
established(Conn *c, Packet *p, Packet *p2, char *buf, int size)
{
	int i, n, cnum;
	uchar *q;
	Plist *pl;
	SSHChan *ch;

	USED(size);
	if (debug &gt; 1) {
		sshdebug(c, "in Established state, got:");
		dump_packet(p);
	}
	switch (p-&gt;payload[0]) {
	case SSH_MSG_DISCONNECT:
		if (debug) {
			get_string(p, p-&gt;payload + 5, buf, Arbbufsz, nil);
			sshdebug(c, "got disconnect: %s", buf);
		}
		return -1;
	case SSH_MSG_IGNORE:
	case SSH_MSG_UNIMPLEMENTED:
		break;
	case SSH_MSG_DEBUG:
		if (debug || p-&gt;payload[1]) {
			get_string(p, p-&gt;payload + 2, buf, Arbbufsz, nil);
			sshdebug(c, "got debug message: %s", buf);
		}
		break;
	case SSH_MSG_KEXINIT:
		send_kexinit(c);
		if (c-&gt;rkexinit)
			free(c-&gt;rkexinit);
		c-&gt;rkexinit = new_packet(c);
		memmove(c-&gt;rkexinit, p, sizeof(Packet));
		if (validatekex(c, p) &lt; 0) {
			sshdebug(c, "kex crypto algorithm mismatch (Established)");
			return -1;
		}
		sshdebug(c, "using %s Kex algorithm and %s PKA",
			kexes[c-&gt;kexalg]-&gt;name, pkas[c-&gt;pkalg]-&gt;name);
		c-&gt;state = Negotiating;
		break;
	case SSH_MSG_GLOBAL_REQUEST:
	case SSH_MSG_REQUEST_SUCCESS:
	case SSH_MSG_REQUEST_FAILURE:
		break;
	case SSH_MSG_CHANNEL_OPEN:
		q = get_string(p, p-&gt;payload + 1, buf, Arbbufsz, nil);
		sshdebug(c, "searching for a listener for channel type %s", buf);
		ch = alloc_chan(c);
		if (ch == nil) {
			nochans(c, p, p2);
			break;
		}

		sshdebug(c, "alloced channel %d for listener", ch-&gt;id);
		qlock(&amp;c-&gt;l);
		ch-&gt;otherid = nhgetl(q);
		ch-&gt;twindow = nhgetl(q+4);
		sshdebug(c, "got lock in channel open");
		for (i = 0; i &lt; c-&gt;nchan; ++i)
			if (c-&gt;chans[i] &amp;&amp; c-&gt;chans[i]-&gt;state == Listening &amp;&amp;
			    c-&gt;chans[i]-&gt;ann &amp;&amp;
			    strcmp(c-&gt;chans[i]-&gt;ann, buf) == 0)
				break;
		if (i &gt;= c-&gt;nchan) {
			sshdebug(c, "no listener: sleeping");
			ch-&gt;state = Opening;
			if (ch-&gt;ann)
				free(ch-&gt;ann);
			ch-&gt;ann = estrdup9p(buf);
			sshdebug(c, "waiting for someone to announce %s", ch-&gt;ann);
			rsleep(&amp;ch-&gt;r);
		} else{
			sshdebug(c, "found listener on channel %d", ch-&gt;id);
			c-&gt;chans[i]-&gt;waker = ch-&gt;id;
			rwakeup(&amp;c-&gt;chans[i]-&gt;r);
		}
		qunlock(&amp;c-&gt;l);
		break;
	case SSH_MSG_CHANNEL_OPEN_CONFIRMATION:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		qlock(&amp;c-&gt;l);
		ch-&gt;otherid = nhgetl(p-&gt;payload+5);
		ch-&gt;twindow = nhgetl(p-&gt;payload+9);
		rwakeup(&amp;ch-&gt;r);
		qunlock(&amp;c-&gt;l);
		break;
	case SSH_MSG_CHANNEL_OPEN_FAILURE:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		qlock(&amp;c-&gt;l);
		rwakeup(&amp;ch-&gt;r);
		qunlock(&amp;c-&gt;l);
		return -1;
	case SSH_MSG_CHANNEL_WINDOW_ADJUST:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		ch-&gt;twindow += nhgetl(p-&gt;payload + 5);
		sshdebug(c, "new twindow for channel: %d: %lud", cnum, ch-&gt;twindow);
		qlock(&amp;ch-&gt;xmtlock);
		rwakeup(&amp;ch-&gt;xmtrendez);
		qunlock(&amp;ch-&gt;xmtlock);
		break;
	case SSH_MSG_CHANNEL_DATA:
	case SSH_MSG_CHANNEL_EXTENDED_DATA:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		pl = emalloc9p(sizeof(Plist));
		pl-&gt;pack = emalloc9p(sizeof(Packet));
		memmove(pl-&gt;pack, p, sizeof(Packet));
		if (p-&gt;payload[0] == SSH_MSG_CHANNEL_DATA) {
			pl-&gt;rem = nhgetl(p-&gt;payload + 5);
			pl-&gt;st = pl-&gt;pack-&gt;payload + 9;
		} else {
			pl-&gt;rem = nhgetl(p-&gt;payload + 9);
			pl-&gt;st = pl-&gt;pack-&gt;payload + 13;
		}
		pl-&gt;next = nil;
		if (ch-&gt;dataq == nil)
			ch-&gt;dataq = pl;
		else
			ch-&gt;datatl-&gt;next = pl;
		ch-&gt;datatl = pl;
		ch-&gt;inrqueue += pl-&gt;rem;
		nbsendul(ch-&gt;inchan, 1);
		break;
	case SSH_MSG_CHANNEL_EOF:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		if (ch-&gt;state != Closed &amp;&amp; ch-&gt;state != Closing) {
			ch-&gt;state = Eof;
			nbsendul(ch-&gt;inchan, 1);
			nbsendul(ch-&gt;reqchan, 1);
		}
		break;
	case SSH_MSG_CHANNEL_CLOSE:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		if (ch-&gt;state != Closed &amp;&amp; ch-&gt;state != Closing) {
			init_packet(p2);
			p2-&gt;c = c;
			add_byte(p2, SSH_MSG_CHANNEL_CLOSE);
			hnputl(p2-&gt;payload + 1, ch-&gt;otherid);
			p2-&gt;rlength += 4;
			n = finish_packet(p2);
			iowrite(c-&gt;rio, c-&gt;datafd, p2-&gt;nlength, n);
		}
		qlock(&amp;c-&gt;l);
		if (ch-&gt;state != Closed) {
			ch-&gt;state = Closed;
			rwakeup(&amp;ch-&gt;r);
			nbsendul(ch-&gt;inchan, 1);
			nbsendul(ch-&gt;reqchan, 1);
			chanclose(ch-&gt;inchan);
			chanclose(ch-&gt;reqchan);
		}
		qunlock(&amp;c-&gt;l);
		for (i = 0; i &lt; MAXCONN &amp;&amp; (!c-&gt;chans[i] ||
		    c-&gt;chans[i]-&gt;state == Empty || c-&gt;chans[i]-&gt;state == Closed);
		    ++i)
			;
		if (i &gt;= MAXCONN)
			return -1;
		break;
	case SSH_MSG_CHANNEL_REQUEST:
		cnum = nhgetl(p-&gt;payload + 1);
		ch = c-&gt;chans[cnum];
		sshdebug(c, "queueing channel request for channel: %d", cnum);
		q = get_string(p, p-&gt;payload+5, buf, Arbbufsz, nil);
		pl = emalloc9p(sizeof(Plist));
		pl-&gt;pack = emalloc9p(sizeof(Packet));
		n = snprint((char *)pl-&gt;pack-&gt;payload,
			Maxpayload, "%s %c", buf, *q? 't': 'f');
		sshdebug(c, "request message begins: %s",
			(char *)pl-&gt;pack-&gt;payload);
		memmove(pl-&gt;pack-&gt;payload + n, q + 1, p-&gt;rlength - (11 + n-2));
		pl-&gt;rem = p-&gt;rlength - 11 + 2;
		pl-&gt;st = pl-&gt;pack-&gt;payload;
		pl-&gt;next = nil;
		if (ch-&gt;reqq == nil)
			ch-&gt;reqq = pl;
		else
			ch-&gt;reqtl-&gt;next = pl;
		ch-&gt;reqtl = pl;
		nbsendul(ch-&gt;reqchan, 1);
		break;
	case SSH_MSG_CHANNEL_SUCCESS:
	case SSH_MSG_CHANNEL_FAILURE:
	default:
		break;
	}
	return 0;
}

static void
bail(Conn *c, Packet *p, Packet *p2, char *sts)
{
	shutdown(c);
	free(p);
	free(p2);
	if (c-&gt;rio) {
		closeioproc(c-&gt;rio);
		c-&gt;rio = nil;
	}
	c-&gt;rpid = -1;
	threadexits(sts);
}

static void
reader0(Conn *c, Packet *p, Packet *p2)
{
	int i, n, nl, np, nm, nb;
	char buf[Arbbufsz];

	nm = 0;
	nb = 4;
	if (c-&gt;decrypt != -1)
		nb = cryptos[c-&gt;decrypt]-&gt;blklen;
	sshdebug(c, "calling read for connection %d, state %d, nb %d, dc %d",
		c-&gt;id, c-&gt;state, nb, c-&gt;decrypt);
	if ((nl = ioreadn(c-&gt;rio, c-&gt;datafd, p-&gt;nlength, nb)) != nb) {
		sshdebug(c, "reader for connection %d exiting, got %d: %r",
			c-&gt;id, nl);
		bail(c, p, p2, "reader exiting");
	}
	if (c-&gt;decrypt != -1)
		cryptos[c-&gt;decrypt]-&gt;decrypt(c-&gt;deccs, p-&gt;nlength, nb);
	p-&gt;rlength = nhgetl(p-&gt;nlength);
	sshdebug(c, "got message length: %ld", p-&gt;rlength);
	if (p-&gt;rlength &gt; Maxpktpay) {
		sshdebug(c, "absurd packet length: %ld, unrecoverable decrypt failure",
			p-&gt;rlength);
		bail(c, p, p2, "absurd packet length");
	}
	np = ioreadn(c-&gt;rio, c-&gt;datafd, p-&gt;nlength + nb, p-&gt;rlength + 4 - nb);
	if (c-&gt;inmac != -1)
		nm = ioreadn(c-&gt;rio, c-&gt;datafd, p-&gt;nlength + p-&gt;rlength + 4,
			SHA1dlen);		/* SHA1dlen was magic 20 */
	n = nl + np + nm;
	if (debug) {
		sshdebug(c, "got message of %d bytes %d padding", n, p-&gt;pad_len);
		if (p-&gt;payload[0] &gt; SSH_MSG_CHANNEL_OPEN) {
			i = nhgetl(p-&gt;payload+1);
			if (c-&gt;chans[i])
				sshdebug(c, " for channel %d win %lud",
					i, c-&gt;chans[i]-&gt;rwindow);
			else
				sshdebug(c, " for invalid channel %d", i);
		}
		sshdebug(c, " first byte: %d", p-&gt;payload[0]);
	}
	/* SHA1dlen was magic 20 */
	if (np != p-&gt;rlength + 4 - nb || c-&gt;inmac != -1 &amp;&amp; nm != SHA1dlen) {
		sshdebug(c, "got EOF/error on connection read: %d %d %r", np, nm);
		bail(c, p, p2, "error or eof");
	}
	p-&gt;tlength = n;
	p-&gt;rlength = n - 4;
	if (undo_packet(p) &lt; 0) {
		sshdebug(c, "bad packet in connection %d: exiting", c-&gt;id);
		bail(c, p, p2, "bad packet");
	}

	if (c-&gt;state == Initting) {
		if (p-&gt;payload[0] != SSH_MSG_KEXINIT) {
			sshdebug(c, "missing KEX init packet: %d", p-&gt;payload[0]);
			bail(c, p, p2, "bad kex");
		}
		if (c-&gt;rkexinit)
			free(c-&gt;rkexinit);
		c-&gt;rkexinit = new_packet(c);
		memmove(c-&gt;rkexinit, p, sizeof(Packet));
		if (validatekex(c, p) &lt; 0) {
			sshdebug(c, "kex crypto algorithm mismatch (Initting)");
			bail(c, p, p2, "bad kex");
		}
		sshdebug(c, "using %s Kex algorithm and %s PKA",
			kexes[c-&gt;kexalg]-&gt;name, pkas[c-&gt;pkalg]-&gt;name);
		if (c-&gt;role == Client)
			kexes[c-&gt;kexalg]-&gt;clientkex1(c, p);
		c-&gt;state = Negotiating;
	} else if (c-&gt;state == Negotiating) {
		if (negotiating(c, p, p2, buf, sizeof buf) &lt; 0)
			bail(c, p, p2, "negotiating");
	} else if (c-&gt;state == Authing) {
		switch (p-&gt;payload[0]) {
		case SSH_MSG_DISCONNECT:
			if (debug) {
				get_string(p, p-&gt;payload + 5, buf, Arbbufsz, nil);
				sshdebug(c, "got disconnect: %s", buf);
			}
			bail(c, p, p2, "msg disconnect");
		case SSH_MSG_USERAUTH_REQUEST:
			switch (auth_req(p, c)) {
			case 0:			/* success */
				establish(c);
				break;
			case 1:			/* ok to try again */
			case -1:		/* failure */
				break;
			case -2:		/* can't happen, now at least */
				bail(c, p, p2, "in userauth request");
			}
			break;
		case SSH_MSG_USERAUTH_FAILURE:
			qlock(&amp;c-&gt;l);
			rwakeup(&amp;c-&gt;r);
			qunlock(&amp;c-&gt;l);
			break;
		case SSH_MSG_USERAUTH_SUCCESS:
			establish(c);
			break;
		case SSH_MSG_USERAUTH_BANNER:
			break;
		}
	} else if (c-&gt;state == Established) {
		if (established(c, p, p2, buf, sizeof buf) &lt; 0)
			bail(c, p, p2, "from established state");
	} else {
		sshdebug(c, "connection %d in bad state, reader exiting", c-&gt;id);
		bail(c, p, p2, "bad conn state");
	}
}

void
reader(void *a)
{
	Conn *c;
	Packet *p, *p2;

	threadsetname("reader");
	c = a;
	c-&gt;rpid = threadid();
	sshdebug(c, "starting reader for connection %d, pid %d", c-&gt;id, c-&gt;rpid);
	threadsetname("reader");
	p = new_packet(c);
	p2 = new_packet(c);
	c-&gt;rio = ioproc();
	for(;;)
		reader0(c, p, p2);
}

int
validatekex(Conn *c, Packet *p)
{
	if (c-&gt;role == Server)
		return validatekexs(p);
	else
		return validatekexc(p);
}

int
validatekexs(Packet *p)
{
	uchar *q;
	char *toks[Maxtoks];
	int i, j, n;
	char *buf;

	buf = emalloc9p(Bigbufsz);
	q = p-&gt;payload + 17;

	q = get_string(p, q, buf, Bigbufsz, nil);
	sshdebug(nil, "received KEX algs: %s", buf);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (i = 0; i &lt; n; ++i)
		for (j = 0; j &lt; nelem(kexes); ++j)
			if (strcmp(toks[i], kexes[j]-&gt;name) == 0)
				goto foundk;
	sshdebug(nil, "kex algs not in kexes");
	free(buf);
	return -1;
foundk:
	p-&gt;c-&gt;kexalg = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	sshdebug(nil, "received host key algs: %s", buf);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (i = 0; i &lt; n; ++i)
		for (j = 0; j &lt; nelem(pkas) &amp;&amp; pkas[j] != nil; ++j)
			if (strcmp(toks[i], pkas[j]-&gt;name) == 0)
				goto foundpka;
	sshdebug(nil, "host key algs not in pkas");
	free(buf);
	return -1;
foundpka:
	p-&gt;c-&gt;pkalg = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	sshdebug(nil, "received C2S crypto algs: %s", buf);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (i = 0; i &lt; n; ++i)
		for (j = 0; j &lt; nelem(cryptos); ++j)
			if (strcmp(toks[i], cryptos[j]-&gt;name) == 0)
				goto foundc1;
	sshdebug(nil, "c2s crypto algs not in cryptos");
	free(buf);
	return -1;
foundc1:
	p-&gt;c-&gt;ncscrypt = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	sshdebug(nil, "received S2C crypto algs: %s", buf);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (i = 0; i &lt; n; ++i)
		for (j = 0; j &lt; nelem(cryptos); ++j)
			if (strcmp(toks[i], cryptos[j]-&gt;name) == 0)
				goto foundc2;
	sshdebug(nil, "s2c crypto algs not in cryptos");
	free(buf);
	return -1;
foundc2:
	p-&gt;c-&gt;nsccrypt = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	sshdebug(nil, "received C2S MAC algs: %s", buf);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (i = 0; i &lt; n; ++i)
		for (j = 0; j &lt; nelem(macnames); ++j)
			if (strcmp(toks[i], macnames[j]) == 0)
				goto foundm1;
	sshdebug(nil, "c2s mac algs not in cryptos");
	free(buf);
	return -1;
foundm1:
	p-&gt;c-&gt;ncsmac = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	sshdebug(nil, "received S2C MAC algs: %s", buf);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (i = 0; i &lt; n; ++i)
		for (j = 0; j &lt; nelem(macnames); ++j)
			if (strcmp(toks[i], macnames[j]) == 0)
				goto foundm2;
	sshdebug(nil, "s2c mac algs not in cryptos");
	free(buf);
	return -1;
foundm2:
	p-&gt;c-&gt;nscmac = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	q = get_string(p, q, buf, Bigbufsz, nil);
	q = get_string(p, q, buf, Bigbufsz, nil);
	q = get_string(p, q, buf, Bigbufsz, nil);
	free(buf);
	if (*q)
		return 1;
	return 0;
}

int
validatekexc(Packet *p)
{
	uchar *q;
	char *toks[Maxtoks];
	int i, j, n;
	char *buf;

	buf = emalloc9p(Bigbufsz);
	q = p-&gt;payload + 17;
	q = get_string(p, q, buf, Bigbufsz, nil);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (j = 0; j &lt; nelem(kexes); ++j)
		for (i = 0; i &lt; n; ++i)
			if (strcmp(toks[i], kexes[j]-&gt;name) == 0)
				goto foundk;
	free(buf);
	return -1;
foundk:
	p-&gt;c-&gt;kexalg = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (j = 0; j &lt; nelem(pkas) &amp;&amp; pkas[j] != nil; ++j)
		for (i = 0; i &lt; n; ++i)
			if (strcmp(toks[i], pkas[j]-&gt;name) == 0)
				goto foundpka;
	free(buf);
	return -1;
foundpka:
	p-&gt;c-&gt;pkalg = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (j = 0; j &lt; nelem(cryptos); ++j)
		for (i = 0; i &lt; n; ++i)
			if (strcmp(toks[i], cryptos[j]-&gt;name) == 0)
				goto foundc1;
	free(buf);
	return -1;
foundc1:
	p-&gt;c-&gt;ncscrypt = j;
	q = get_string(p, q, buf, Bigbufsz, nil);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (j = 0; j &lt; nelem(cryptos); ++j)
		for (i = 0; i &lt; n; ++i)
			if (strcmp(toks[i], cryptos[j]-&gt;name) == 0)
				goto foundc2;
	free(buf);
	return -1;
foundc2:
	p-&gt;c-&gt;nsccrypt = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (j = 0; j &lt; nelem(macnames); ++j)
		for (i = 0; i &lt; n; ++i)
			if (strcmp(toks[i], macnames[j]) == 0)
				goto foundm1;
	free(buf);
	return -1;
foundm1:
	p-&gt;c-&gt;ncsmac = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	n = gettokens(buf, toks, nelem(toks), ",");
	for (j = 0; j &lt; nelem(macnames); ++j)
		for (i = 0; i &lt; n; ++i)
			if (strcmp(toks[i], macnames[j]) == 0)
				goto foundm2;
	free(buf);
	return -1;
foundm2:
	p-&gt;c-&gt;nscmac = j;

	q = get_string(p, q, buf, Bigbufsz, nil);
	q = get_string(p, q, buf, Bigbufsz, nil);
	q = get_string(p, q, buf, Bigbufsz, nil);
	q = get_string(p, q, buf, Bigbufsz, nil);
	free(buf);
	return *q != 0;
}

int
memrandom(void *p, int n)
{
	uchar *cp;

	for (cp = (uchar*)p; n &gt; 0; n--)
		*cp++ = fastrand();
	return 0;
}

/*
 *  create a change uid capability
 */
char*
mkcap(char *from, char *to)
{
	int fd, fromtosz;
	char *cap, *key;
	uchar rand[SHA1dlen], hash[SHA1dlen];

	fd = open("#¤/caphash", OWRITE);
	if (fd &lt; 0)
		sshlog(nil, "can't open #¤/caphash: %r");

	/* create the capability */
	fromtosz = strlen(from) + 1 + strlen(to) + 1;
	cap = emalloc9p(fromtosz + sizeof(rand)*3 + 1);
	snprint(cap, fromtosz + sizeof(rand)*3 + 1, "%s@%s", from, to);
	memrandom(rand, sizeof(rand));
	key = cap + fromtosz;
	enc64(key, sizeof(rand)*3, rand, sizeof(rand));

	/* hash the capability */
	hmac_sha1((uchar*)cap, strlen(cap), (uchar*)key, strlen(key), hash, nil);

	/* give the kernel the hash */
	key[-1] = '@';
	sshdebug(nil, "writing `%.*s' to caphash", SHA1dlen, hash);
	if (write(fd, hash, SHA1dlen) != SHA1dlen) {
		close(fd);
		free(cap);
		return nil;
	}
	close(fd);
	return cap;
}

/*
 * ask keyfs (assumes we are on an auth server)
 */
static AuthInfo *
keyfsauth(char *me, char *user, char *pw, char *key1, char *key2)
{
	int fd;
	char path[Arbpathlen];
	AuthInfo *ai;

	if (passtokey(key1, pw) == 0)
		return nil;

	snprint(path, Arbpathlen, "/mnt/keys/%s/key", user);
	if ((fd = open(path, OREAD)) &lt; 0) {
		werrstr("Invalid user %s", user);
		return nil;
	}
	if (read(fd, key2, DESKEYLEN) != DESKEYLEN) {
		close(fd);
		werrstr("Password mismatch 1");
		return nil;
	}
	close(fd);

	if (memcmp(key1, key2, DESKEYLEN) != 0) {
		werrstr("Password mismatch 2");
		return nil;
	}

	ai = emalloc9p(sizeof(AuthInfo));
	ai-&gt;cuid = estrdup9p(user);
	ai-&gt;suid = estrdup9p(me);
	ai-&gt;cap = mkcap(me, user);
	ai-&gt;nsecret = 0;
	ai-&gt;secret = (uchar *)estrdup9p("");
	return ai;
}

static void
userauthfailed(Packet *p2)
{
	add_byte(p2, SSH_MSG_USERAUTH_FAILURE);
	add_string(p2, "password,publickey");
	add_byte(p2, 0);
}

static int
authreqpk(Packet *p, Packet *p2, Conn *c, char *user, uchar *q,
	char *alg, char *blob, char *sig, char *service, char *me)
{
	int n, thisway, nblob, nsig;
	char method[32];

	sshdebug(c, "auth_req publickey for user %s", user);
	thisway = *q == '\0';
	q = get_string(p, q+1, alg, Arbpathlen, nil);
	q = get_string(p, q, blob, Blobsz, &amp;nblob);
	if (thisway) {
		/*
		 * Should really check to see if this user can
		 * be authed this way.
		 */
		for (n = 0; n &lt; nelem(pkas) &amp;&amp; pkas[n] != nil &amp;&amp;
		    strcmp(pkas[n]-&gt;name, alg) != 0; ++n)
			;
		if (n &gt;= nelem(pkas) || pkas[n] == nil) {
			userauthfailed(p2);
			return -1;
		}
		add_byte(p2, SSH_MSG_USERAUTH_PK_OK);
		add_string(p2, alg);
		add_block(p2, blob, nblob);
		return 1;
	}

	get_string(p, q, sig, Blobsz, &amp;nsig);
	for (n = 0; n &lt; nelem(pkas) &amp;&amp; pkas[n] != nil &amp;&amp;
	    strcmp(pkas[n]-&gt;name, alg) != 0; ++n)
		;
	if (n &gt;= nelem(pkas) || pkas[n] == nil) {
		userauthfailed(p2);
		return -1;
	}

	add_block(p2, c-&gt;sessid, SHA1dlen);
	add_byte(p2, SSH_MSG_USERAUTH_REQUEST);
	add_string(p2, user);
	add_string(p2, service);
	add_string(p2, method);
	add_byte(p2, 1);
	add_string(p2, alg);
	add_block(p2, blob, nblob);
	if (pkas[n]-&gt;verify(c, p2-&gt;payload, p2-&gt;rlength - 1, user, sig, nsig)
	    == 0) {
		init_packet(p2);
		p2-&gt;c = c;
		sshlog(c, "public key login failed");
		userauthfailed(p2);
		return -1;
	}
	free(c-&gt;cap);
	c-&gt;cap = mkcap(me, user);
	init_packet(p2);
	p2-&gt;c = c;
	sshlog(c, "logged in by public key");
	add_byte(p2, SSH_MSG_USERAUTH_SUCCESS);
	return 0;
}

int
auth_req(Packet *p, Conn *c)
{
	int n, ret;
	char *alg, *blob, *sig, *service, *me, *user, *pw, *path;
	char key1[DESKEYLEN], key2[DESKEYLEN], method[32];
	uchar *q;
	AuthInfo *ai;
	Packet *p2;

	service = emalloc9p(Arbpathlen);
	me = emalloc9p(Arbpathlen);
	user = emalloc9p(Arbpathlen);
	pw = emalloc9p(Arbpathlen);
	alg = emalloc9p(Arbpathlen);
	path = emalloc9p(Arbpathlen);
	blob = emalloc9p(Blobsz);
	sig = emalloc9p(Blobsz);
	ret = -1;				/* failure is default */

	q = get_string(p, p-&gt;payload + 1, user, Arbpathlen, nil);
	free(c-&gt;user);
	c-&gt;user = estrdup9p(user);
	q = get_string(p, q, service, Arbpathlen, nil);
	q = get_string(p, q, method, sizeof method, nil);
	sshdebug(c, "got userauth request: %s %s %s", user, service, method);

	readfile("/dev/user", me, Arbpathlen);

	p2 = new_packet(c);
	if (strcmp(method, "publickey") == 0)
		ret = authreqpk(p, p2, c, user, q, alg, blob, sig, service, me);
	else if (strcmp(method, "password") == 0) {
		get_string(p, q + 1, pw, Arbpathlen, nil);
		// sshdebug(c, "%s", pw);	/* bad idea to log passwords */
		sshdebug(c, "auth_req password");
		if (kflag)
			ai = keyfsauth(me, user, pw, key1, key2);
		else
			ai = auth_userpasswd(user, pw);
		if (ai == nil) {
			sshlog(c, "login failed: %r");
			userauthfailed(p2);
		} else {
			sshdebug(c, "auth successful: cuid %s suid %s cap %s",
				ai-&gt;cuid, ai-&gt;suid, ai-&gt;cap);
			free(c-&gt;cap);
			if (strcmp(user, me) == 0)
				c-&gt;cap = estrdup9p("n/a");
			else
				c-&gt;cap = estrdup9p(ai-&gt;cap);
			sshlog(c, "logged in by password");
			add_byte(p2, SSH_MSG_USERAUTH_SUCCESS);
			auth_freeAI(ai);
			ret = 0;
		}
	} else
		userauthfailed(p2);

	n = finish_packet(p2);
	iowrite(c-&gt;dio, c-&gt;datafd, p2-&gt;nlength, n);

	free(service);
	free(me);
	free(user);
	free(pw);
	free(alg);
	free(blob);
	free(sig);
	free(path);
	free(p2);
	return ret;
}

int
client_auth(Conn *c, Ioproc *io)
{
	Packet *p2, *p3, *p4;
	char *r, *s;
	mpint *ek, *nk;
	int i, n;

	sshdebug(c, "client_auth");
	if (!c-&gt;password &amp;&amp; !c-&gt;authkey)
		return -1;

	p2 = new_packet(c);
	add_byte(p2, SSH_MSG_USERAUTH_REQUEST);
	add_string(p2, c-&gt;user);
	add_string(p2, c-&gt;service);
	if (c-&gt;password) {
		add_string(p2, "password");
		add_byte(p2, 0);
		add_string(p2, c-&gt;password);
		sshdebug(c, "client_auth using password for svc %s", c-&gt;service);
	} else {
		sshdebug(c, "client_auth trying rsa public key");
		add_string(p2, "publickey");
		add_byte(p2, 1);
		add_string(p2, "ssh-rsa");

		r = strstr(c-&gt;authkey, " ek=");
		s = strstr(c-&gt;authkey, " n=");
		if (!r || !s) {
			shutdown(c);
			free(p2);
			sshdebug(c, "client_auth no rsa key");
			return -1;
		}
		ek = strtomp(r+4, nil, 16, nil);
		nk = strtomp(s+3, nil, 16, nil);

		p3 = new_packet(c);
		add_string(p3, "ssh-rsa");
		add_mp(p3, ek);
		add_mp(p3, nk);
		add_block(p2, p3-&gt;payload, p3-&gt;rlength-1);

		p4 = new_packet(c);
		add_block(p4, c-&gt;sessid, SHA1dlen);
		add_byte(p4, SSH_MSG_USERAUTH_REQUEST);
		add_string(p4, c-&gt;user);
		add_string(p4, c-&gt;service);
		add_string(p4, "publickey");
		add_byte(p4, 1);
		add_string(p4, "ssh-rsa");
		add_block(p4, p3-&gt;payload, p3-&gt;rlength-1);
		mpfree(ek);
		mpfree(nk);
		free(p3);

		for (i = 0; pkas[i] &amp;&amp; strcmp("ssh-rsa", pkas[i]-&gt;name) != 0;
		    ++i)
			;
		sshdebug(c, "client_auth rsa signing alg %d: %r",  i);
		if ((p3 = pkas[i]-&gt;sign(c, p4-&gt;payload, p4-&gt;rlength-1)) == nil) {
			sshdebug(c, "client_auth rsa signing failed: %r");
			free(p4);
			free(p2);
			return -1;
		}
		add_block(p2, p3-&gt;payload, p3-&gt;rlength-1);
		free(p3);
		free(p4);
	}

	n = finish_packet(p2);
	if (writeio(io, c-&gt;datafd, p2-&gt;nlength, n) != n)
		sshdebug(c, "client_auth write failed: %r");
	free(p2);
	return 0;
}

/* should use auth_getkey or something similar */
char *
factlookup(int nattr, int nreq, char *attrs[])
{
	Biobuf *bp;
	char *buf, *toks[Maxtoks], *res, *q;
	int ntok, nmatch, maxmatch;
	int i, j;

	res = nil;
	bp = Bopen("/mnt/factotum/ctl", OREAD);
	if (bp == nil)
		return nil;
	maxmatch = 0;
	while (buf = Brdstr(bp, '\n', 1)) {
		q = estrdup9p(buf);
		ntok = gettokens(buf, toks, nelem(toks), " ");
		nmatch = 0;
		for (i = 0; i &lt; nattr; ++i) {
			for (j = 0; j &lt; ntok; ++j)
				if (strcmp(attrs[i], toks[j]) == 0) {
					++nmatch;
					break;
				}
			if (i &lt; nreq &amp;&amp; j &gt;= ntok)
				break;
		}
		if (i &gt;= nattr &amp;&amp; nmatch &gt; maxmatch) {
			free(res);
			res = q;
			maxmatch = nmatch;
		} else
			free(q);
		free(buf);
	}
	Bterm(bp);
	return res;
}

void
shutdown(Conn *c)
{
	Plist *p;
	SSHChan *sc;
	int i, ostate;

	sshdebug(c, "shutting down connection %d", c-&gt;id);
	ostate = c-&gt;state;
	if (c-&gt;clonefile-&gt;ref &lt;= 2 &amp;&amp; c-&gt;ctlfile-&gt;ref &lt;= 2 &amp;&amp;
	    c-&gt;datafile-&gt;ref &lt;= 2 &amp;&amp; c-&gt;listenfile-&gt;ref &lt;= 2 &amp;&amp;
	    c-&gt;localfile-&gt;ref &lt;= 2 &amp;&amp; c-&gt;remotefile-&gt;ref &lt;= 2 &amp;&amp;
	    c-&gt;statusfile-&gt;ref &lt;= 2)
		c-&gt;state = Closed;
	else {
		if (c-&gt;state != Closed)
			c-&gt;state = Closing;
		sshdebug(c, "clone %ld ctl %ld data %ld listen %ld "
			"local %ld remote %ld status %ld",
			c-&gt;clonefile-&gt;ref, c-&gt;ctlfile-&gt;ref, c-&gt;datafile-&gt;ref,
			c-&gt;listenfile-&gt;ref, c-&gt;localfile-&gt;ref, c-&gt;remotefile-&gt;ref,
			c-&gt;statusfile-&gt;ref);
	}
	if (ostate == Closed || ostate == Closing) {
		c-&gt;state = Closed;
		return;
	}
	if (c-&gt;role == Server &amp;&amp; c-&gt;remote)
		sshlog(c, "closing connection");
	hangupconn(c);
	if (c-&gt;dio) {
		closeioproc(c-&gt;dio);
		c-&gt;dio = nil;
	}

	c-&gt;decrypt = -1;
	c-&gt;inmac = -1;
	c-&gt;nchan = 0;
	free(c-&gt;otherid);
	free(c-&gt;s2ccs);
	c-&gt;s2ccs = nil;
	free(c-&gt;c2scs);
	c-&gt;c2scs = nil;
	free(c-&gt;remote);
	c-&gt;remote = nil;
	if (c-&gt;x) {
		mpfree(c-&gt;x);
		c-&gt;x = nil;
	}
	if (c-&gt;e) {
		mpfree(c-&gt;e);
		c-&gt;e = nil;
	}
	free(c-&gt;user);
	c-&gt;user = nil;
	free(c-&gt;service);
	c-&gt;service = nil;
	c-&gt;otherid = nil;
	qlock(&amp;c-&gt;l);
	rwakeupall(&amp;c-&gt;r);
	qunlock(&amp;c-&gt;l);
	for (i = 0; i &lt; MAXCONN; ++i) {
		sc = c-&gt;chans[i];
		if (sc == nil)
			continue;
		free(sc-&gt;ann);
		sc-&gt;ann = nil;
		if (sc-&gt;state != Empty &amp;&amp; sc-&gt;state != Closed) {
			sc-&gt;state = Closed;
			sc-&gt;lreq = nil;
			while (sc-&gt;dataq != nil) {
				p = sc-&gt;dataq;
				sc-&gt;dataq = p-&gt;next;
				free(p-&gt;pack);
				free(p);
			}
			while (sc-&gt;reqq != nil) {
				p = sc-&gt;reqq;
				sc-&gt;reqq = p-&gt;next;
				free(p-&gt;pack);
				free(p);
			}
			qlock(&amp;c-&gt;l);
			rwakeupall(&amp;sc-&gt;r);
			nbsendul(sc-&gt;inchan, 1);
			nbsendul(sc-&gt;reqchan, 1);
			chanclose(sc-&gt;inchan);
			chanclose(sc-&gt;reqchan);
			qunlock(&amp;c-&gt;l);
		}
	}
	qlock(&amp;availlck);
	rwakeup(&amp;availrend);
	qunlock(&amp;availlck);
	sshdebug(c, "done processing shutdown of connection %d", c-&gt;id);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

