<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tapefs/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tapefs/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;authsrv.h&gt;
#include &lt;fcall.h&gt;
#include "tapefs.h"

Fid	*fids;
Ram	*ram;
int	mfd[2];
char	*user;
uchar	mdata[Maxbuf+IOHDRSZ];
int	messagesize = Maxbuf+IOHDRSZ;
Fcall	rhdr;
Fcall	thdr;
ulong	path;
Idmap	*uidmap;
Idmap	*gidmap;
int	replete;
int	blocksize;		/* for 32v */
int	verbose;
int	newtap;		/* tap with time in sec */
int	blocksize;

Fid *	newfid(int);
int	ramstat(Ram*, uchar*, int);
void	io(void);
void	usage(void);
int	perm(int);

char	*rflush(Fid*), *rversion(Fid*), *rauth(Fid*),
	*rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]		rversion,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"tapefs: authentication not required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";

void
notifyf(void *a, char *s)
{
	USED(a);
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

void
main(int argc, char *argv[])
{
	Ram *r;
	char *defmnt;
	int p[2];
	char buf[TICKREQLEN];

	fmtinstall('F', fcallfmt);

	defmnt = "/n/tapefs";
	ARGBEGIN{
	case 'm':
		defmnt = EARGF(usage());
		break;
	case 'p':			/* password file */
		uidmap = getpass(EARGF(usage()));
		break;
	case 'g':			/* group file */
		gidmap = getpass(EARGF(usage()));
		break;
	case 'v':
		verbose++;
		break;
	case 'n':
		newtap++;
		break;
	case 'b':
		blocksize = atoi(EARGF(usage()));
		break;
	default:
		usage();
	}ARGEND

	if(argc==0)
		error("no file to mount");
	user = getuser();
	if(user == nil)
		user = "dmr";
	ram = r = (Ram *)emalloc(sizeof(Ram));
	r-&gt;busy = 1;
	r-&gt;data = 0;
	r-&gt;ndata = 0;
	r-&gt;perm = DMDIR | 0775;
	r-&gt;qid.path = 0;
	r-&gt;qid.vers = 0;
	r-&gt;qid.type = QTDIR;
	r-&gt;parent = 0;
	r-&gt;child = 0;
	r-&gt;next = 0;
	r-&gt;user = user;
	r-&gt;group = user;
	r-&gt;atime = time(0);
	r-&gt;mtime = r-&gt;atime;
	r-&gt;replete = 0;
	r-&gt;name = estrdup(".");
	populate(argv[0]);
	r-&gt;replete |= replete;
	if(pipe(p) &lt; 0)
		error("pipe failed");
	mfd[0] = mfd[1] = p[0];
	notify(notifyf);

	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFNOTEG)){
	case -1:
		error("fork");
	case 0:
		close(p[1]);
		notify(notifyf);
		io();
		break;
	default:
		close(p[0]);	/* don't deadlock if child fails */
		if(mount(p[1], -1, defmnt, MREPL|MCREATE, "") &lt; 0) {
			sprint(buf, "mount on `%s' failed", defmnt);
			error(buf);
		}
	}
	exits(0);
}

char*
rversion(Fid *unused)
{
	Fid *f;

	USED(unused);

	if(rhdr.msize &lt; 256)
		return "version: message too small";
	if(rhdr.msize &gt; messagesize)
		rhdr.msize = messagesize;
	else
		messagesize = rhdr.msize;
	thdr.msize = messagesize;
	if(strncmp(rhdr.version, "9P2000", 6) != 0)
		return "unrecognized 9P version";
	thdr.version = "9P2000";

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);
	return 0;
}

char*
rauth(Fid *unused)
{
	USED(unused);

	return Enoauth;
}

char*
rflush(Fid *f)
{
	USED(f);
	return 0;
}

char*
rattach(Fid *f)
{
	/* no authentication! */
	f-&gt;busy = 1;
	f-&gt;rclose = 0;
	f-&gt;ram = ram;
	thdr.qid = f-&gt;ram-&gt;qid;
	if(rhdr.uname[0])
		f-&gt;user = strdup(rhdr.uname);
	else
		f-&gt;user = "none";
	return 0;
}

char*
rwalk(Fid *f)
{
	Fid *nf;
	Ram *r;
	char *err;
	char *name;
	Ram *dir;
	int i;

	nf = nil;
	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	if(f-&gt;open)
		return Eisopen;
	if(rhdr.newfid != rhdr.fid){
		nf = newfid(rhdr.newfid);
		nf-&gt;busy = 1;
		nf-&gt;open = 0;
		nf-&gt;rclose = 0;
		nf-&gt;ram = f-&gt;ram;
		nf-&gt;user = f-&gt;user;	/* no ref count; the leakage is minor */
		f = nf;
	}

	thdr.nwqid = 0;
	err = nil;
	r = f-&gt;ram;

	if(rhdr.nwname &gt; 0){
		for(i=0; i&lt;rhdr.nwname; i++){
			if((r-&gt;qid.type &amp; QTDIR) == 0){
				err = Enotdir;
				break;
			}
			if(r-&gt;busy == 0){
				err = Enotexist;
				break;
			}
			r-&gt;atime = time(0);
			name = rhdr.wname[i];
			dir = r;
			if(!perm(Pexec)){
				err = Eperm;
				break;
			}
			if(strcmp(name, "..") == 0){
				r = dir-&gt;parent;
   Accept:
				if(i == MAXWELEM){
					err = "name too long";
					break;
				}
 				thdr.wqid[thdr.nwqid++] = r-&gt;qid;
				continue;
			}
			if(!dir-&gt;replete)
				popdir(dir);
			for(r=dir-&gt;child; r; r=r-&gt;next)
				if(r-&gt;busy &amp;&amp; strcmp(name, r-&gt;name)==0)
					goto Accept;
			break;	/* file not found */
		}

		if(i==0 &amp;&amp; err == nil)
			err = Enotexist;
	}

	if(err!=nil || thdr.nwqid&lt;rhdr.nwname){
		if(nf){
			nf-&gt;busy = 0;
			nf-&gt;open = 0;
			nf-&gt;ram = 0;
		}
	}else if(thdr.nwqid  == rhdr.nwname)
		f-&gt;ram = r;

	return err;

}

char *
ropen(Fid *f)
{
	Ram *r;
	int mode, trunc;

	if(f-&gt;open)
		return Eisopen;
	r = f-&gt;ram;
	if(r-&gt;busy == 0)
		return Enotexist;
	if(r-&gt;perm &amp; DMEXCL)
		if(r-&gt;open)
			return Excl;
	mode = rhdr.mode;
	if(r-&gt;qid.type &amp; QTDIR){
		if(mode != OREAD)
			return Eperm;
		thdr.qid = r-&gt;qid;
		return 0;
	}
	if(mode &amp; ORCLOSE)
		return Eperm;
	trunc = mode &amp; OTRUNC;
	mode &amp;= OPERM;
	if(mode==OWRITE || mode==ORDWR || trunc)
		if(!perm(Pwrite))
			return Eperm;
	if(mode==OREAD || mode==ORDWR)
		if(!perm(Pread))
			return Eperm;
	if(mode==OEXEC)
		if(!perm(Pexec))
			return Eperm;
	if(trunc &amp;&amp; (r-&gt;perm&amp;DMAPPEND)==0){
		r-&gt;ndata = 0;
		dotrunc(r);
		r-&gt;qid.vers++;
	}
	thdr.qid = r-&gt;qid;
	thdr.iounit = messagesize-IOHDRSZ;
	f-&gt;open = 1;
	r-&gt;open++;
	return 0;
}

char *
rcreate(Fid *f)
{
	USED(f);

	return Eperm;
}

char*
rread(Fid *f)
{
	int i, len;
	Ram *r;
	char *buf;
	uvlong off, end;
	int n, cnt;

	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	n = 0;
	thdr.count = 0;
	off = rhdr.offset;
	end = rhdr.offset + rhdr.count;
	cnt = rhdr.count;
	if(cnt &gt; messagesize-IOHDRSZ)
		cnt = messagesize-IOHDRSZ;
	buf = thdr.data;
	if(f-&gt;ram-&gt;qid.type &amp; QTDIR){
		if(!f-&gt;ram-&gt;replete)
			popdir(f-&gt;ram);
		for(i=0,r=f-&gt;ram-&gt;child; r!=nil &amp;&amp; i&lt;end; r=r-&gt;next){
			if(!r-&gt;busy)
				continue;
			len = ramstat(r, (uchar*)buf+n, cnt-n);
			if(len &lt;= BIT16SZ)
				break;
			if(i &gt;= off)
				n += len;
			i += len;
		}
		thdr.count = n;
		return 0;
	}
	r = f-&gt;ram;
	if(off &gt;= r-&gt;ndata)
		return 0;
	r-&gt;atime = time(0);
	n = cnt;
	if(off+n &gt; r-&gt;ndata)
		n = r-&gt;ndata - off;
	thdr.data = doread(r, off, n);
	thdr.count = n;
	return 0;
}

char*
rwrite(Fid *f)
{
	Ram *r;
	ulong off;
	int cnt;

	r = f-&gt;ram;
	if(dopermw(f-&gt;ram)==0)
		return Eperm;
	if(r-&gt;busy == 0)
		return Enotexist;
	off = rhdr.offset;
	if(r-&gt;perm &amp; DMAPPEND)
		off = r-&gt;ndata;
	cnt = rhdr.count;
	if(r-&gt;qid.type &amp; QTDIR)
		return "file is a directory";
	if(off &gt; 100*1024*1024)		/* sanity check */
		return "write too big";
	dowrite(r, rhdr.data, off, cnt);
	r-&gt;qid.vers++;
	r-&gt;mtime = time(0);
	thdr.count = cnt;
	return 0;
}

char *
rclunk(Fid *f)
{
	if(f-&gt;open)
		f-&gt;ram-&gt;open--;
	f-&gt;busy = 0;
	f-&gt;open = 0;
	f-&gt;ram = 0;
	return 0;
}

char *
rremove(Fid *f)
{
	USED(f);
	return Eperm;
}

char *
rstat(Fid *f)
{
	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	thdr.nstat = ramstat(f-&gt;ram, thdr.stat, messagesize-IOHDRSZ);
	return 0;
}

char *
rwstat(Fid *f)
{
	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	return Eperm;
}

int
ramstat(Ram *r, uchar *buf, int nbuf)
{
	Dir dir;

	dir.name = r-&gt;name;
	dir.qid = r-&gt;qid;
	dir.mode = r-&gt;perm;
	dir.length = r-&gt;ndata;
	dir.uid = r-&gt;user;
	dir.gid = r-&gt;group;
	dir.muid = r-&gt;user;
	dir.atime = r-&gt;atime;
	dir.mtime = r-&gt;mtime;
	return convD2M(&amp;dir, buf, nbuf);
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		ff-&gt;open = 0;
		ff-&gt;busy = 1;
	}
	f = emalloc(sizeof *f);
	f-&gt;ram = 0;
	f-&gt;fid = fid;
	f-&gt;busy = 1;
	f-&gt;open = 0;
	f-&gt;next = fids;
	fids = f;
	return f;
}

void
io(void)
{
	char *err;
	int n, nerr;
	char buf[ERRMAX];

	errstr(buf, sizeof buf);
	for(nerr=0, buf[0]='\0'; nerr&lt;100; nerr++){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		n = read9pmsg(mfd[0], mdata, sizeof mdata);
		if(n==0)
			continue;
		if(n &lt; 0){
			if(buf[0]=='\0')
				errstr(buf, sizeof buf);
			continue;
		}
		nerr = 0;
		buf[0] = '\0';
		if(convM2S(mdata, n, &amp;rhdr) != n)
			error("convert error in convM2S");

		if(verbose)
			fprint(2, "tapefs: &lt;=%F\n", &amp;rhdr);/**/

		thdr.data = (char*)mdata + IOHDRSZ;
		thdr.stat = mdata + IOHDRSZ;
		if(!fcalls[rhdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[rhdr.type])(newfid(rhdr.fid));
		if(err){
			thdr.type = Rerror;
			thdr.ename = err;
		}else{
			thdr.type = rhdr.type + 1;
			thdr.fid = rhdr.fid;
		}
		thdr.tag = rhdr.tag;
		n = convS2M(&amp;thdr, mdata, messagesize);
		if(n &lt;= 0)
			error("convert error in convS2M");
		if(verbose)
			fprint(2, "tapefs: =&gt;%F\n", &amp;thdr);/**/
		if(write(mfd[1], mdata, n) != n)
			error("mount write");
	}
	if(buf[0]=='\0' || strstr(buf, "hungup"))
		exits("");
	fprint(2, "%s: mount read: %s\n", argv0, buf);
	exits(buf);
}

int
perm(int p)
{
	if(p==Pwrite)
		return 0;
	return 1;
}

void
error(char *s)
{
	fprint(2, "%s: %s: ", argv0, s);
	perror("");
	exits(s);
}

char*
estrdup(char *s)
{
	char *t;

	t = emalloc(strlen(s)+1);
	strcpy(t, s);
	return t;
}

void *
emalloc(ulong n)
{
	void *p;
	p = mallocz(n, 1);
	if(!p)
		error("out of memory");
	return p;
}

void *
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(!p)
		error("out of memory");
	return p;
}

void
usage(void)
{
	fprint(2, "usage: %s [-s] [-m mountpoint]\n", argv0);
	exits("usage");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

