<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tapefs/zipfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tapefs/zipfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;flate.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;ctype.h&gt;
#include "tapefs.h"
#include "zip.h"

#define FORCE_LOWER	1	/* force filenames to lower case */
#define MUNGE_CR	1	/* replace '\r\n' with ' \n' */
#define High64 (1LL&lt;&lt;63)

/*
 * File system for zip archives (read-only)
 */

enum {
	IS_MSDOS = 0,	/* creator OS (interpretation of external flags) */
	IS_RDONLY = 1,	/* file was readonly (external flags) */
	IS_TEXT = 1,	/* file was text  (internal flags) */
};

typedef struct Block Block;
struct Block{
	uchar *pos;
	uchar *limit;
};

static Biobuf *bin;
static ulong *crctab;
static ulong crc;

static int findCDir(Biobuf *);
static int header(Biobuf *, ZipHead *);
static int cheader(Biobuf *, ZipHead *);
static void trailer(Biobuf *, ZipHead *);
static char *getname(Biobuf *, int);
static int blwrite(void *, void *, int);
static ulong get4(Biobuf *);
static int get2(Biobuf *);
static int get1(Biobuf *);
static long msdos2time(int, int);

void
populate(char *name)
{
	char *p;
	Fileinf f;
	ZipHead zh;
	int ok, entries;

	crctab = mkcrctab(ZCrcPoly);
	ok = inflateinit();
	if(ok != FlateOk)
		sysfatal("inflateinit failed: %s", flateerr(ok));

	bin = Bopen(name, OREAD);
	if (bin == nil)
		error("Can't open argument file");

	entries = findCDir(bin);
	if(entries &lt; 0)
		sysfatal("empty file");

	while(entries-- &gt; 0){
		memset(&amp;zh, 0, sizeof(zh));
		if(!cheader(bin, &amp;zh))
			break;
		f.addr = zh.off;
		if(zh.iattr &amp; IS_TEXT)
			f.addr |= High64;
		f.mode = (zh.madevers == IS_MSDOS &amp;&amp; zh.eattr &amp; IS_RDONLY)? 0444: 0644;
		if (zh.meth == 0 &amp;&amp; zh.uncsize == 0){
			p = strchr(zh.file, '\0');
			if(p &gt; zh.file &amp;&amp; p[-1] == '/')
				f.mode |= (DMDIR | 0111);
		}
		f.uid = 0;
		f.gid = 0;
		f.size = zh.uncsize;
		f.mdate = msdos2time(zh.modtime, zh.moddate);
		f.name = zh.file + ((zh.file[0] == '/')? 1: 0);
		poppath(f, 1);
		free(zh.file);
	}
	return ;
}

void
dotrunc(Ram *r)
{
	USED(r);
}

void
docreate(Ram *r)
{
	USED(r);
}

char *
doread(Ram *r, vlong off, long cnt)
{
	int i, err;
	Block bs;
	ZipHead zh;
	static Qid oqid;
	static char buf[Maxbuf];
	static uchar *cache = nil;

	if (cnt &gt; Maxbuf)
		sysfatal("file too big (&gt;%d)", Maxbuf);

	if (Bseek(bin, r-&gt;addr &amp; 0x7FFFFFFFFFFFFFFFLL, 0) &lt; 0)
		sysfatal("seek failed");

	memset(&amp;zh, 0, sizeof(zh));
	if (!header(bin, &amp;zh))
		sysfatal("cannot get local header");

	switch(zh.meth){
	case 0:
		if (Bseek(bin, off, 1) &lt; 0)
			sysfatal("seek failed");
		if (Bread(bin, buf, cnt) != cnt)
			sysfatal("read failed");
		break;
	case 8:
		if (r-&gt;qid.path != oqid.path){
			oqid = r-&gt;qid;
			if (cache)
				free(cache);
			cache = emalloc(r-&gt;ndata);

			bs.pos = cache;
			bs.limit = cache+r-&gt;ndata;
			if ((err = inflate(&amp;bs, blwrite, bin, (int(*)(void*))Bgetc)) != FlateOk)
				sysfatal("inflate failed - %s", flateerr(err));

			if (blockcrc(crctab, crc, cache, r-&gt;ndata) != zh.crc)
				fprint(2, "%s - crc failed", r-&gt;name);

			if ((r-&gt;addr &amp; High64) &amp;&amp; MUNGE_CR){
				for (i = 0; i &lt; r-&gt;ndata -1; i++)
					if (cache[i] == '\r' &amp;&amp; cache[i +1] == '\n')
						cache[i] = ' ';
			}
		}
		memcpy(buf, cache+off, cnt);
		break;
	default:
		sysfatal("%d - unsupported compression method", zh.meth);
		break;
	}
	
	return buf;
}

void
popdir(Ram *r)
{
	USED(r);
}

void
dowrite(Ram *r, char *buf, long off, long cnt)
{
	USED(r); USED(buf); USED(off); USED(cnt);
}

int
dopermw(Ram *r)
{
	USED(r);
	return 0;
}

/*************************************************/

static int
findCDir(Biobuf *bin)
{
	vlong ecoff;
	long off;
	int entries, zclen;

	ecoff = Bseek(bin, -ZECHeadSize, 2);
	if(ecoff &lt; 0)
		sysfatal("can't seek to header");

	if(get4(bin) != ZECHeader)
		sysfatal("bad magic number on directory");

	get2(bin);
	get2(bin);
	get2(bin);
	entries = get2(bin);
	get4(bin);
	off = get4(bin);
	zclen = get2(bin);
	while(zclen-- &gt; 0)
		get1(bin);

	if(Bseek(bin, off, 0) != off)
		sysfatal("can't seek to contents");

	return entries;
}


static int
header(Biobuf *bin, ZipHead *zh)
{
	ulong v;
	int flen, xlen;

	v = get4(bin);
	if(v != ZHeader){
		if(v == ZCHeader)
			return 0;
		sysfatal("bad magic on local header");
	}
	zh-&gt;extvers = get1(bin);
	zh-&gt;extos = get1(bin);
	zh-&gt;flags = get2(bin);
	zh-&gt;meth = get2(bin);
	zh-&gt;modtime = get2(bin);
	zh-&gt;moddate = get2(bin);
	zh-&gt;crc = get4(bin);
	zh-&gt;csize = get4(bin);
	zh-&gt;uncsize = get4(bin);
	flen = get2(bin);
	xlen = get2(bin);

	zh-&gt;file = getname(bin, flen);

	while(xlen-- &gt; 0)
		get1(bin);
	return 1;
}

static int
cheader(Biobuf *bin, ZipHead *zh)
{
	ulong v;
	int flen, xlen, fclen;

	v = get4(bin);
	if(v != ZCHeader){
		if(v == ZECHeader)
			return 0;
		sysfatal("bad magic number in file");
	}
	zh-&gt;madevers = get1(bin);
	zh-&gt;madeos = get1(bin);
	zh-&gt;extvers = get1(bin);
	zh-&gt;extos = get1(bin);
	zh-&gt;flags = get2(bin);
	zh-&gt;meth = get2(bin);
	zh-&gt;modtime = get2(bin);
	zh-&gt;moddate = get2(bin);
	zh-&gt;crc = get4(bin);
	zh-&gt;csize = get4(bin);
	zh-&gt;uncsize = get4(bin);
	flen = get2(bin);
	xlen = get2(bin);
	fclen = get2(bin);
	get2(bin);		/* disk number start */
	zh-&gt;iattr = get2(bin);	/* 1 == is-text-file */
	zh-&gt;eattr = get4(bin);	/* 1 == readonly-file */
	zh-&gt;off = get4(bin);

	zh-&gt;file = getname(bin, flen);

	while(xlen-- &gt; 0)
		get1(bin);

	while(fclen-- &gt; 0)
		get1(bin);

	return 1;
}

static int
blwrite(void *vb, void *buf, int n)
{
	Block *b = vb;
	if(n &gt; b-&gt;limit - b-&gt;pos)
		n = b-&gt;limit - b-&gt;pos;
	memmove(b-&gt;pos, buf, n);
	b-&gt;pos += n;
	return n;
}


static void
trailer(Biobuf *bin, ZipHead *zh)
{
	if(zh-&gt;flags &amp; ZTrailInfo){
		zh-&gt;crc = get4(bin);
		zh-&gt;csize = get4(bin);
		zh-&gt;uncsize = get4(bin);
	}
}

static char*
getname(Biobuf *bin, int len)
{
	char *s;
	int i, c;

	s = emalloc(len + 1);
	for(i = 0; i &lt; len; i++){
		c = get1(bin);
		if(FORCE_LOWER)
			c = tolower(c);
		s[i] = c;
	}
	s[i] = '\0';
	return s;
}


static ulong
get4(Biobuf *b)
{
	ulong v;
	int i, c;

	v = 0;
	for(i = 0; i &lt; 4; i++){
		c = Bgetc(b);
		if(c &lt; 0)
			sysfatal("unexpected eof");
		v |= c &lt;&lt; (i * 8);
	}
	return v;
}

static int
get2(Biobuf *b)
{
	int i, c, v;

	v = 0;
	for(i = 0; i &lt; 2; i++){
		c = Bgetc(b);
		if(c &lt; 0)
			sysfatal("unexpected eof");
		v |= c &lt;&lt; (i * 8);
	}
	return v;
}

static int
get1(Biobuf *b)
{
	int c;

	c = Bgetc(b);
	if(c &lt; 0)
		sysfatal("unexpected eof");
	return c;
}

static long
msdos2time(int time, int date)
{
	Tm tm;

	tm.hour = time &gt;&gt; 11;
	tm.min = (time &gt;&gt; 5) &amp; 63;
	tm.sec = (time &amp; 31) &lt;&lt; 1;
	tm.year = 80 + (date &gt;&gt; 9);
	tm.mon = ((date &gt;&gt; 5) &amp; 15) - 1;
	tm.mday = date &amp; 31;
	tm.zone[0] = '\0';
	tm.yday = 0;

	return tm2sec(&amp;tm);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

