<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tcs/conv_ksc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tcs/conv_ksc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#ifdef	PLAN9
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;bio.h&gt;
#else
#include	&lt;stdio.h&gt;
#include	&lt;unistd.h&gt;
#include	"plan9.h"
#endif
#include	"hdr.h"
#include	"conv.h"
#include	"ksc.h"

/*
	contributed by kuro@vodka.Eng.Sun.COM (Teruhiko Kurosaka)
*/

/*
	a state machine for interpreting shift-ksc.
*/

#define	SS2	0x8e
#define	SS3	0x8f
/*
 * Convert EUC in Koran locale to Unicode.
 * Only codeset 0 and 1 are used.
 */
void
ukscproc(int c, Rune **r, long input_loc)
{
	static enum { init, cs1last /*, cs2, cs3first, cs3last*/} state = init;
	static int korean646 = 1; /* fixed to 1 for now. */
	static int lastc;
	int n;
	long l;

	switch(state)
	{
	case init:
		if (c &lt; 0){
			return;
		}else if (c &lt; 128){
			if(korean646 &amp;&amp; (c=='\\')){
				emit(0x20A9);
			} else {
				emit(c);
			}
/*		}else if (c==SS2){
			state = cs2;
		}else if (c==SS3){
			state = cs3first;
 */		}else{
			lastc = c;
			state = cs1last;
		}
		return;

	case cs1last: /* 2nd byte of codeset 1 (KSC 5601) */
		if(c &lt; 0){
			if(squawk)
				EPR "%s: unexpected EOF in %s\n", argv0, file);
			c = 0x21 | (lastc&amp;0x80);
		}
		n = ((lastc&amp;0x7f)-33)*94 + (c&amp;0x7f)-33;
 		if((n &gt;= ksc5601max) || ((l = tabksc5601[n]) &lt; 0)){
			nerrors++;
			if(squawk)
				EPR "%s: unknown ksc5601 %d (from 0x%x,0x%x) near byte %ld in %s\n", argv0, n, lastc, c, input_loc, file);
			if(!clean)
				emit(BADMAP);
		} else {
			emit(l);
		}
		state = init;
		return;
	default:
		if(squawk)
			EPR "%s: ukscproc: unknown state %d\n",
				argv0, init);
	}
}

void
uksc_in(int fd, long *notused, struct convert *out)
{
	Rune ob[N];
	Rune *r, *re;
	uchar ibuf[N];
	int n, i;
	long nin;

	USED(notused);
	r = ob;
	re = ob+N-3;
	nin = 0;
	while((n = read(fd, ibuf, sizeof ibuf)) &gt; 0){
		for(i = 0; i &lt; n; i++){
			ukscproc(ibuf[i], &amp;r, nin++);
			if(r &gt;= re){
				OUT(out, ob, r-ob);
				r = ob;
			}
		}
		if(r &gt; ob){
			OUT(out, ob, r-ob);
			r = ob;
		}
	}
	ukscproc(-1, &amp;r, nin);
	if(r &gt; ob)
		OUT(out, ob, r-ob);
	OUT(out, ob, 0);
}

void
uksc_out(Rune *base, int n, long *notused)
{
	char *p;
	int i;
	Rune r;
	long l;
	static int first = 1;

	USED(notused);
	if(first){
		first = 0;
		for(i = 0; i &lt; NRUNE; i++)
			tab[i] = -1;
		for(i = 0; i &lt; ksc5601max; i++)
			if((l = tabksc5601[i]) != -1){
				if(l &lt; 0)
					tab[-l] = i;
				else
					tab[l] = i;
			}
	}
	nrunes += n;
	p = obuf;
	for(i = 0; i &lt; n; i++){
		r = base[i];
		if(r &lt; 128)
			*p++ = r;
		else {
			if(tab[r] != -1){
				*p++ = 0x80 | (tab[r]/94 + 0x21);
				*p++ = 0x80 | (tab[r]%94 + 0x21);
				continue;
			}
			if(squawk)
				EPR "%s: rune 0x%x not in output cs\n", argv0, r);
			nerrors++;
			if(clean)
				continue;
			*p++ = BYTEBADMAP;
		}
	}
	noutput += p-obuf;
	if(p &gt; obuf)
		write(1, obuf, p-obuf);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

