<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tcs/utf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tcs/utf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#ifdef PLAN9
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;bio.h&gt;
#else
#include	&lt;sys/types.h&gt;
#include	&lt;stdio.h&gt;
#include	&lt;stdlib.h&gt;
#include	&lt;string.h&gt;
#include	&lt;unistd.h&gt;
#include	&lt;errno.h&gt;
#include	"plan9.h"
#endif
#include	"hdr.h"

/*
	the our_* routines are implementations for the corresponding library
	routines. for a while, i tried to actually name them wctomb etc
	but stopped that after i found a system which made wchar_t an
	unsigned char.
*/

int our_wctomb(char *s, unsigned long wc);
int our_mbtowc(unsigned long *p, char *s, unsigned n);
int runetoisoutf(char *str, Rune *rune);
int fullisorune(char *str, int n);
int isochartorune(Rune *rune, char *str);

void
utf_in(int fd, long *notused, struct convert *out)
{
	char buf[N];
	int i, j, c, n, tot;
	ulong l;

	USED(notused);
	tot = 0;
	while((n = read(fd, buf+tot, N-tot)) &gt;= 0){
		tot += n;
		for(i=j=0; i&lt;=tot-UTFmax || (i&lt;tot &amp;&amp; (n==0 || fullrune(buf+i, tot-i))); ){
			c = our_mbtowc(&amp;l, buf+i, tot-i);
			if(c == -1){
				if(squawk)
					EPR "%s: bad UTF sequence near byte %ld in input\n", argv0, ninput+i);
				if(clean){
					i++;
					continue;
				}
				nerrors++;
				l = Runeerror;
				c = 1;
			}
			runes[j++] = l;
			i += c;
		}
		OUT(out, runes, j);
		tot -= i;
		ninput += i;
		if(tot)
			memmove(buf, buf+i, tot);
		if(n == 0)
			break;
	}
	OUT(out, runes, 0);
}

void
utf_out(Rune *base, int n, long *notused)
{
	char *p;
	Rune *r;

	USED(notused);
	nrunes += n;
	for(r = base, p = obuf; n-- &gt; 0; r++){
		p += our_wctomb(p, *r);
	}
	noutput += p-obuf;
	write(1, obuf, p-obuf);
}

void
isoutf_in(int fd, long *notused, struct convert *out)
{
	char buf[N];
	int i, j, c, n, tot;

	USED(notused);
	tot = 0;
	while((n = read(fd, buf+tot, N-tot)) &gt;= 0){
		tot += n;
		for(i=j=0; i&lt;tot; ){
			if(!fullisorune(buf+i, tot-i))
				break;
			c = isochartorune(&amp;runes[j], buf+i);
			if(runes[j] == Runeerror &amp;&amp; c == 1){
				if(squawk)
					EPR "%s: bad UTF sequence near byte %ld in input\n", argv0, ninput+i);
				if(clean){
					i++;
					continue;
				}
				nerrors++;
			}
			j++;
			i += c;
		}
		OUT(out, runes, j);
		tot -= i;
		ninput += i;
		if(tot)
			memmove(buf, buf+i, tot);
		if(n == 0)
			break;
	}
	OUT(out, runes, 0);
}

void
isoutf_out(Rune *base, int n, long *notused)
{
	char *p;
	Rune *r;

	USED(notused);
	nrunes += n;
	for(r = base, p = obuf; n-- &gt; 0; r++)
		p += runetoisoutf(p, r);
	noutput += p-obuf;
	write(1, obuf, p-obuf);
}


enum
{
	Char1	= Runeself,	Rune1	= Runeself,
	Char21	= 0xA1,		Rune21	= 0x0100,
	Char22	= 0xF6,		Rune22	= 0x4016,
	Char3	= 0xFC,		Rune3	= 0x10000,	/* really 0x38E2E */
	Esc	= 0xBE,		Bad	= Runeerror
};

static	uchar	U[256];
static	uchar	T[256];

static
void
mktable(void)
{
	int i, u;

	for(i=0; i&lt;256; i++) {
		u = i + (0x5E - 0xA0);
		if(i &lt; 0xA0)
			u = i + (0xDF - 0x7F);
		if(i &lt; 0x7F)
			u = i + (0x00 - 0x21);
		if(i &lt; 0x21)
			u = i + (0xBE - 0x00);
		U[i] = u;
		T[u] = i;
	}
}

int
isochartorune(Rune *rune, char *str)
{
	int c, c1, c2;
	long l;

	if(U[0] == 0)
		mktable();

	/*
	 * one character sequence
	 *	00000-0009F =&gt; 00-9F
	 */
	c = *(uchar*)str;
	if(c &lt; Char1) {
		*rune = c;
		return 1;
	}

	/*
	 * two character sequence
	 *	000A0-000FF =&gt; A0; A0-FF
	 */
	c1 = *(uchar*)(str+1);
	if(c &lt; Char21) {
		if(c1 &gt;= Rune1 &amp;&amp; c1 &lt; Rune21) {
			*rune = c1;
			return 2;
		}
		goto bad;
	}

	/*
	 * two character sequence
	 *	00100-04015 =&gt; A1-F5; 21-7E/A0-FF
	 */
	c1 = U[c1];
	if(c1 &gt;= Esc)
		goto bad;
	if(c &lt; Char22) {
		*rune =  (c-Char21)*Esc + c1 + Rune21;
		return 2;
	}

	/*
	 * three character sequence
	 *	04016-38E2D =&gt; A6-FB; 21-7E/A0-FF
	 */
	c2 = U[*(uchar*)(str+2)];
	if(c2 &gt;= Esc)
		goto bad;
	if(c &lt; Char3) {
		l = (c-Char22)*Esc*Esc + c1*Esc + c2 + Rune22;
		if(l &gt;= Rune3)
			goto bad;
		*rune = l;
		return 3;
	}

	/*
	 * bad decoding
	 */
bad:
	*rune = Bad;
	return 1;
}

int
runetoisoutf(char *str, Rune *rune)
{
	long c;

	if(T[0] == 0)
		mktable();

	/*
	 * one character sequence
	 *	00000-0009F =&gt; 00-9F
	 */
	c = *rune;
	if(c &lt; Rune1) {
		str[0] = c;
		return 1;
	}

	/*
	 * two character sequence
	 *	000A0-000FF =&gt; A0; A0-FF
	 */
	if(c &lt; Rune21) {
		str[0] = Char1;
		str[1] = c;
		return 2;
	}

	/*
	 * two character sequence
	 *	00100-04015 =&gt; A1-F5; 21-7E/A0-FF
	 */
	if(c &lt; Rune22) {
		c -= Rune21;
		str[0] = c/Esc + Char21;
		str[1] = T[c%Esc];
		return 2;
	}

	/*
	 * three character sequence
	 *	04016-38E2D =&gt; A6-FB; 21-7E/A0-FF
	 */
	c -= Rune22;
	str[0] = c/(Esc*Esc) + Char22;
	str[1] = T[c/Esc%Esc];
	str[2] = T[c%Esc];
	return 3;
}

int
fullisorune(char *str, int n)
{
	int c;

	if(n &gt; 0) {
		c = *(uchar*)str;
		if(c &lt; Char1)
			return 1;
		if(n &gt; 1)
			if(c &lt; Char22 || n &gt; 2)
				return 1;
	}
	return 0;
}

#ifdef PLAN9
int	errno;
#endif

enum
{
	T1	= 0x00,
	Tx	= 0x80,
	T2	= 0xC0,
	T3	= 0xE0,
	T4	= 0xF0,
	T5	= 0xF8,
	T6	= 0xFC,

	Bit1	= 7,
	Bitx	= 6,
	Bit2	= 5,
	Bit3	= 4,
	Bit4	= 3,
	Bit5	= 2,
	Bit6	= 2,

	Mask1	= (1&lt;&lt;Bit1)-1,
	Maskx	= (1&lt;&lt;Bitx)-1,
	Mask2	= (1&lt;&lt;Bit2)-1,
	Mask3	= (1&lt;&lt;Bit3)-1,
	Mask4	= (1&lt;&lt;Bit4)-1,
	Mask5	= (1&lt;&lt;Bit5)-1,
	Mask6	= (1&lt;&lt;Bit6)-1,

	Wchar1	= (1UL&lt;&lt;Bit1)-1,
	Wchar2	= (1UL&lt;&lt;(Bit2+Bitx))-1,
	Wchar3	= (1UL&lt;&lt;(Bit3+2*Bitx))-1,
	Wchar4	= (1UL&lt;&lt;(Bit4+3*Bitx))-1,
	Wchar5	= (1UL&lt;&lt;(Bit5+4*Bitx))-1,

#ifndef	EILSEQ
	EILSEQ	= 123,
#endif /* EILSEQ */
};

int
our_wctomb(char *s, unsigned long wc)
{
	if(s == 0)
		return 0;		/* no shift states */
	if(wc &amp; ~Wchar2) {
		if(wc &amp; ~Wchar4) {
			if(wc &amp; ~Wchar5) {
				/* 6 bytes */
				s[0] = T6 | ((wc &gt;&gt; 5*Bitx) &amp; Mask6);
				s[1] = Tx | ((wc &gt;&gt; 4*Bitx) &amp; Maskx);
				s[2] = Tx | ((wc &gt;&gt; 3*Bitx) &amp; Maskx);
				s[3] = Tx | ((wc &gt;&gt; 2*Bitx) &amp; Maskx);
				s[4] = Tx | ((wc &gt;&gt; 1*Bitx) &amp; Maskx);
				s[5] = Tx |  (wc &amp; Maskx);
				return 6;
			}
			/* 5 bytes */
			s[0] = T5 |  (wc &gt;&gt; 4*Bitx);
			s[1] = Tx | ((wc &gt;&gt; 3*Bitx) &amp; Maskx);
			s[2] = Tx | ((wc &gt;&gt; 2*Bitx) &amp; Maskx);
			s[3] = Tx | ((wc &gt;&gt; 1*Bitx) &amp; Maskx);
			s[4] = Tx |  (wc &amp; Maskx);
			return 5;
		}
		if(wc &amp; ~Wchar3) {
			/* 4 bytes */
			s[0] = T4 |  (wc &gt;&gt; 3*Bitx);
			s[1] = Tx | ((wc &gt;&gt; 2*Bitx) &amp; Maskx);
			s[2] = Tx | ((wc &gt;&gt; 1*Bitx) &amp; Maskx);
			s[3] = Tx |  (wc &amp; Maskx);
			return 4;
		}
		/* 3 bytes */
		s[0] = T3 |  (wc &gt;&gt; 2*Bitx);
		s[1] = Tx | ((wc &gt;&gt; 1*Bitx) &amp; Maskx);
		s[2] = Tx |  (wc &amp; Maskx);
		return 3;
	}
	if(wc &amp; ~Wchar1) {
		/* 2 bytes */
		s[0] = T2 | (wc &gt;&gt; 1*Bitx);
		s[1] = Tx | (wc &amp; Maskx);
		return 2;
	}
	/* 1 byte */
	s[0] = T1 | wc;
	return 1;
}

int
our_mbtowc(unsigned long *p, char *s, unsigned n)
{
	uchar *us;
	int c0, c1, c2, c3, c4, c5;
	unsigned long wc;

	if(s == 0)
		return 0;		/* no shift states */

	if(n &lt; 1)
		goto bad;
	us = (uchar*)s;
	c0 = us[0];
	if(c0 &gt;= T3) {
		if(n &lt; 3)
			goto bad;
		c1 = us[1] ^ Tx;
		c2 = us[2] ^ Tx;
		if((c1|c2) &amp; T2)
			goto bad;
		if(c0 &gt;= T5) {
			if(n &lt; 5)
				goto bad;
			c3 = us[3] ^ Tx;
			c4 = us[4] ^ Tx;
			if((c3|c4) &amp; T2)
				goto bad;
			if(c0 &gt;= T6) {
				/* 6 bytes */
				if(n &lt; 6)
					goto bad;
				c5 = us[5] ^ Tx;
				if(c5 &amp; T2)
					goto bad;
				wc = ((((((((((c0 &amp; Mask6) &lt;&lt; Bitx) |
					c1) &lt;&lt; Bitx) | c2) &lt;&lt; Bitx) |
					c3) &lt;&lt; Bitx) | c4) &lt;&lt; Bitx) | c5;
				if(wc &lt;= Wchar5)
					goto bad;
				*p = wc;
				return 6;
			}
			/* 5 bytes */
			wc = ((((((((c0 &amp; Mask5) &lt;&lt; Bitx) |
				c1) &lt;&lt; Bitx) | c2) &lt;&lt; Bitx) |
				c3) &lt;&lt; Bitx) | c4;
			if(wc &lt;= Wchar4)
				goto bad;
			*p = wc;
			return 5;
		}
		if(c0 &gt;= T4) {
			/* 4 bytes */
			if(n &lt; 4)
				goto bad;
			c3 = us[3] ^ Tx;
			if(c3 &amp; T2)
				goto bad;
			wc = ((((((c0 &amp; Mask4) &lt;&lt; Bitx) |
				c1) &lt;&lt; Bitx) | c2) &lt;&lt; Bitx) |
				c3;
			if(wc &lt;= Wchar3)
				goto bad;
			*p = wc;
			return 4;
		}
		/* 3 bytes */
		wc = ((((c0 &amp; Mask3) &lt;&lt; Bitx) |
			c1) &lt;&lt; Bitx) | c2;
		if(wc &lt;= Wchar2)
			goto bad;
		*p = wc;
		return 3;
	}
	if(c0 &gt;= T2) {
		/* 2 bytes */
		if(n &lt; 2)
			goto bad;
		c1 = us[1] ^ Tx;
		if(c1 &amp; T2)
			goto bad;
		wc = ((c0 &amp; Mask2) &lt;&lt; Bitx) |
			c1;
		if(wc &lt;= Wchar1)
			goto bad;
		*p = wc;
		return 2;
	}
	/* 1 byte */
	if(c0 &gt;= Tx)
		goto bad;
	*p = c0;
	return 1;

bad:
	errno = EILSEQ;
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

