<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/troff2html/troff2html.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/troff2html/troff2html.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

enum{
	Nfont = 11,
	Wid = 20,	/* tmac.anhtml sets page width to 20" so we can recognize .nf text */
};

typedef uintptr Char;
typedef struct Troffchar Troffchar;
typedef struct Htmlchar Htmlchar;
typedef struct Font Font;
typedef struct HTMLfont HTMLfont;

/*
 * a Char is &gt;= 32 bits. low 16 bits are the rune. higher are attributes.
 * must be able to hold a pointer.
 */
enum
{
	Italic	=	16,
	Bold,
	CW,
	Indent1,
	Indent2,
	Indent3,
	Heading =	25,
	Anchor =	26,	/* must be last */
};

enum	/* magic emissions */
{
	Estring = 0,
	Epp = 1&lt;&lt;16,
};

int attrorder[] = { Indent1, Indent2, Indent3, Heading, Anchor, Italic, Bold, CW };

int nest[10];
int nnest;

struct Troffchar
{
	char *name;
	char *value;
};

struct Htmlchar
{
	char *utf;
	char *name;
	int value;
};

#include "chars.h"

struct Font{
	char		*name;
	HTMLfont	*htmlfont;
};

struct HTMLfont{
	char	*name;
	char	*htmlname;
	int	bit;
};

/* R must be first; it's the default representation for fonts we don't recognize */
HTMLfont htmlfonts[] =
{
	"R",		nil,	0,
	"LucidaSans",	nil,	0,
	"I",		"i",	Italic,
	"LucidaSansI",	"i",	Italic,
	"CW",		"tt",	CW,
	"LucidaCW",	"tt",	CW,
	nil,	nil,
};

#define TABLE "&lt;table border=0 cellpadding=0 cellspacing=0&gt;"

char*
onattr[8*sizeof(int)] =
{
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	"&lt;i&gt;",			/* italic */
	"&lt;b&gt;",			/* bold */
	"&lt;tt&gt;&lt;font size=+1&gt;",	/* cw */
	"&lt;+table border=0 cellpadding=0 cellspacing=0&gt;&lt;tr height=2&gt;&lt;td&gt;&lt;tr&gt;&lt;td width=20&gt;&lt;td&gt;\n",		/* indent1 */
	"&lt;+table border=0 cellpadding=0 cellspacing=0&gt;&lt;tr height=2&gt;&lt;td&gt;&lt;tr&gt;&lt;td width=20&gt;&lt;td&gt;\n",		/* indent2 */
	"&lt;+table border=0 cellpadding=0 cellspacing=0&gt;&lt;tr height=2&gt;&lt;td&gt;&lt;tr&gt;&lt;td width=20&gt;&lt;td&gt;\n",		/* indent3 */
	0,
	0,
	0,
	"&lt;p&gt;&lt;font size=+1&gt;&lt;b&gt;",	/* heading 25 */
	"&lt;unused&gt;",		/* anchor 26 */
};

char*
offattr[8*sizeof(int)] =
{
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	"&lt;/i&gt;",			/* italic */
	"&lt;/b&gt;",			/* bold */
	"&lt;/font&gt;&lt;/tt&gt;",		/* cw */
	"&lt;-/table&gt;",		/* indent1 */
	"&lt;-/table&gt;",		/* indent2 */
	"&lt;-/table&gt;",		/* indent3 */
	0,
	0,
	0,
	"&lt;/b&gt;&lt;/font&gt;",		/* heading 25 */
	"&lt;/a&gt;",			/* anchor 26 */
};

Font	*font[Nfont];

Biobuf	bout;
int	debug = 0;

/* troff state */
int	page = 1;
int	ft = 1;
int	vp = 0;
int	hp = 0;
int	ps = 1;
int	res = 720;

int	didP = 0;
int	atnewline = 1;
int	prevlineH = 0;
Char	attr = 0;	/* or'ed into each Char */

Char	*chars;
int	nchars;
int	nalloc;
char**	anchors;	/* allocated in order */
int	nanchors;

char	*filename;
int	cno;
char	buf[8192];
char	*title = "Plan 9 man page";

void	process(Biobuf*, char*);
void	mountfont(int, char*);
void	switchfont(int);
void	header(char*);
void	flush(void);
void	trailer(void);

void*
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		sysfatal("malloc failed: %r");
	return p;
}

void*
erealloc(void *p, ulong n)
{

	p = realloc(p, n);
	if(p == nil)
		sysfatal("realloc failed: %r");
	return p;
}

char*
estrdup(char *s)
{
	char *t;

	t = strdup(s);
	if(t == nil)
		sysfatal("strdup failed: %r");
	return t;
}

void
usage(void)
{
	fprint(2, "usage: troff2html [-d] [-t title] [file ...]\n");
	exits("usage");
}

int
hccmp(const void *va, const void *vb)
{
	Htmlchar *a, *b;

	a = (Htmlchar*)va;
	b = (Htmlchar*)vb;
	return a-&gt;value - b-&gt;value;
}

void
main(int argc, char *argv[])
{
	int i;
	Biobuf in, *inp;
	Rune r;

	for(i=0; i&lt;nelem(htmlchars); i++){
		chartorune(&amp;r, htmlchars[i].utf);
		htmlchars[i].value = r;
	}
	qsort(htmlchars, nelem(htmlchars), sizeof(htmlchars[0]), hccmp);

	ARGBEGIN{
	case 't':
		title = ARGF();
		if(title == nil)
			usage();
		break;
	case 'd':
		debug++;
		break;
	default:
		usage();
	}ARGEND

	Binit(&amp;bout, 1, OWRITE);
	if(argc == 0){
		header(title);
		Binit(&amp;in, 0, OREAD);
		process(&amp;in, "&lt;stdin&gt;");
	}else{
		header(title);
		for(i=0; i&lt;argc; i++){
			inp = Bopen(argv[i], OREAD);
			if(inp == nil)
				sysfatal("can't open %s: %r", argv[i]);
			process(inp, argv[i]);
			Bterm(inp);
		}
	}
	flush();
	trailer();
	exits(nil);
}

void
emitchar(Char c)
{
	if(nalloc == nchars){
		nalloc += 10000;
		chars = realloc(chars, nalloc*sizeof(chars[0]));
		if(chars == nil)
			sysfatal("malloc failed: %r");
	}
	chars[nchars++] = c;
}

void
emit(Rune r)
{
	emitchar(r | attr);
	/*
	 * Close man page references early, so that 
	 * .IR proof (1),
	 * doesn't make the comma part of the link.
	 */
	if(r == ')')
		attr &amp;= ~(1&lt;&lt;Anchor);
}

void
emitstr(char *s)
{
	emitchar(Estring);
	emitchar((Char)s);
}

int indentlevel;
int linelen;

void
iputrune(Biobuf *b, Rune r)
{
	int i;

	if(linelen++ &gt; 60 &amp;&amp; r == ' ')
		r = '\n';
	Bputrune(b, r);
	if(r == '\n'){
		for(i=0; i&lt;indentlevel; i++)
			Bprint(b, "    ");
		linelen = 0;
	}
}

void
iputs(Biobuf *b, char *s)
{
	if(s[0]=='&lt;' &amp;&amp; s[1]=='+'){
		iputrune(b, '\n');
		Bprint(b, "&lt;%s", s+2);
		indentlevel++;
		iputrune(b, '\n');
	}else if(s[0]=='&lt;' &amp;&amp; s[1]=='-'){
		indentlevel--;
		iputrune(b, '\n');
		Bprint(b, "&lt;%s", s+2);
		iputrune(b, '\n');
	}else
		Bprint(b, "%s", s);
}

void
setattr(Char a)
{
	Char on, off;
	int i, j;

	on = a &amp; ~attr;
	off = attr &amp; ~a;

	/* walk up the nest stack until we reach something we need to turn off. */
	for(i=0; i&lt;nnest; i++)
		if(off&amp;(1&lt;&lt;nest[i]))
			break;

	/* turn off everything above that */
	for(j=nnest-1; j&gt;=i; j--)
		iputs(&amp;bout, offattr[nest[j]]);

	/* turn on everything we just turned off but didn't want to */
	for(j=i; j&lt;nnest; j++)
		if(a&amp;(1&lt;&lt;nest[j]))
			iputs(&amp;bout, onattr[nest[j]]);
		else
			nest[j] = 0;

	/* shift the zeros (turned off things) up */
	for(i=j=0; i&lt;nnest; i++)
		if(nest[i] != 0)
			nest[j++] = nest[i];
	nnest = j;

	/* now turn on the new attributes */
	for(i=0; i&lt;nelem(attrorder); i++){
		j = attrorder[i];
		if(on&amp;(1&lt;&lt;j)){
			if(j == Anchor)
				onattr[j] = anchors[nanchors++];
			iputs(&amp;bout, onattr[j]);
			if(nnest &gt;= nelem(nest))
				sysfatal("nesting too deep");
			nest[nnest++] = j;
		}
	}
	attr = a;
}

void
flush(void)
{
	int i;
	Char c, a;

	nanchors = 0;
	for(i=0; i&lt;nchars; i++){
		c = chars[i];
		if(c == Estring){
			/* next word is string to print */
			iputs(&amp;bout, (char*)chars[++i]);
			continue;
		}
		if(c == Epp){
			iputrune(&amp;bout, '\n');
			iputs(&amp;bout, TABLE "&lt;tr height=5&gt;&lt;td&gt;&lt;/table&gt;");
			iputrune(&amp;bout, '\n');
			continue;
		}
		a = c &amp; ~0xFFFF;
		c &amp;= 0xFFFF;
		/*
		 * If we're going to something off after a space,
		 * let's just turn it off before.
		 */
		if(c == ' ' &amp;&amp; i&lt;nchars-1 &amp;&amp; (chars[i+1]&amp;0xFFFF) &gt;= 32)
			a ^= a &amp; ~chars[i+1];
		setattr(a);
		iputrune(&amp;bout, c &amp; 0xFFFF);
	}
}

void
header(char *s)
{
	Bprint(&amp;bout, "&lt;head&gt;\n");
	Bprint(&amp;bout, "&lt;title&gt;%s&lt;/title&gt;\n", s);
	Bprint(&amp;bout, "&lt;meta content=\"text/html; charset=utf-8\" http-equiv=Content-Type&gt;\n");
	Bprint(&amp;bout, "&lt;/head&gt;\n");
	Bprint(&amp;bout, "&lt;body bgcolor=#ffffff&gt;\n");
}

void
trailer(void)
{

#ifdef LUCENT
	Tm *t;
	t = localtime(time(nil));
	Bprint(&amp;bout, TABLE "&lt;tr height=20&gt;&lt;td&gt;&lt;/table&gt;\n");
	Bprint(&amp;bout, "&lt;font size=-1&gt;&lt;a href=\"http://www.lucent.com/copyright.html\"&gt;\n");
	Bprint(&amp;bout, "Copyright&lt;/A&gt; &amp;#169; %d Alcatel-Lucent.  All rights reserved.&lt;/font&gt;\n", t-&gt;year+1900);
#endif
	Bprint(&amp;bout, "&lt;/body&gt;&lt;/html&gt;\n");
}

int
getc(Biobuf *b)
{
	cno++;
	return Bgetrune(b);
}

void
ungetc(Biobuf *b)
{
	cno--;
	Bungetrune(b);
}

char*
getline(Biobuf *b)
{
	int i, c;

	for(i=0; i&lt;sizeof buf; i++){
		c = getc(b);
		if(c == Beof)
			return nil;
		buf[i] = c;
		if(c == '\n'){
			buf[i] = '\0';
			break;
		}
	}
	return buf;
}

int
getnum(Biobuf *b)
{
	int i, c;

	i = 0;
	for(;;){
		c = getc(b);
		if(c&lt;'0' || '9'&lt;c){
			ungetc(b);
			break;
		}
		i = i*10 + (c-'0');
	}
	return i;
}

char*
getstr(Biobuf *b)
{
	int i, c;

	for(i=0; i&lt;sizeof buf; i++){
		/* must get bytes not runes */
		cno++;
		c = Bgetc(b);
		if(c == Beof)
			return nil;
		buf[i] = c;
		if(c == '\n' || c==' ' || c=='\t'){
			ungetc(b);
			buf[i] = '\0';
			break;
		}
	}
	return buf;
}

int
setnum(Biobuf *b, char *name, int min, int max)
{
	int i;

	i = getnum(b);
	if(debug &gt; 2)
		fprint(2, "set %s = %d\n", name, i);
	if(min&lt;=i &amp;&amp; i&lt;max)
		return i;
	sysfatal("value of %s is %d; min %d max %d at %s:#%d", name, i, min, max, filename, cno);
	return i;
}

void
xcmd(Biobuf *b)
{
	char *p, *fld[16], buf[1024];

	int i, nfld;

	p = getline(b);
	if(p == nil)
		sysfatal("xcmd error: %r");
	if(debug)
		fprint(2, "x command '%s'\n", p);
	nfld = tokenize(p, fld, nelem(fld));
	if(nfld == 0)
		return;
	switch(fld[0][0]){
	case 'f':
		/* mount font */
		if(nfld != 3)
			break;
		i = atoi(fld[1]);
		if(i&lt;0 || Nfont&lt;=i)
			sysfatal("font %d out of range at %s:#%d", i, filename, cno);
		mountfont(i, fld[2]);
		return;
	case 'i':
		/* init */
		return;
	case 'r':
		if(nfld&lt;2 || atoi(fld[1])!=res)
			sysfatal("typesetter has unexpected resolution %s", fld[1]? fld[1] : "&lt;unspecified&gt;");
		return;
	case 's':
		/* stop */
		return;
	case 't':
		/* trailer */
		return;
	case 'T':
		if(nfld!=2 || strcmp(fld[1], "utf")!=0)
			sysfatal("output for unknown typesetter type %s", fld[1]);
		return;
	case 'X':
		if(nfld&lt;3 || strcmp(fld[1], "html")!=0)
			break;
		/* is it a man reference of the form cp(1)? */
		/* X manref start/end cp (1) */
		if(nfld==6 &amp;&amp; strcmp(fld[2], "manref")==0){
			/* was the right macro; is it the right form? */
			if(strlen(fld[5])&gt;=3 &amp;&amp;
			   fld[5][0]=='(' &amp;&amp; fld[5][2]==')' &amp;&amp;
			   '0'&lt;=fld[5][1] &amp;&amp; fld[5][1]&lt;='9'){
				if(strcmp(fld[3], "start") == 0){
					/* set anchor attribute and remember string */
					attr |= (1&lt;&lt;Anchor);
					snprint(buf, sizeof buf,
						"&lt;a href=\"/magic/man2html/%c/%s\"&gt;",
						fld[5][1], fld[4]);
					nanchors++;
					anchors = erealloc(anchors, nanchors*sizeof(char*));
					anchors[nanchors-1] = estrdup(buf);
				}else if(strcmp(fld[3], "end") == 0)
					attr &amp;= ~(1&lt;&lt;Anchor);
			}
		}else if(strcmp(fld[2], "manPP") == 0){
			didP = 1;
			emitchar(Epp);
		}else if(nfld&lt;4 || strcmp(fld[2], "manref")!=0){
			if(nfld&gt;2 &amp;&amp; strcmp(fld[2], "&lt;P&gt;")==0){	/* avoid triggering extra &lt;br&gt; */
				didP = 1;
				/* clear all font attributes before paragraph */
				emitchar(' ' | (attr &amp; ~(0xFFFF|((1&lt;&lt;Italic)|(1&lt;&lt;Bold)|(1&lt;&lt;CW)))));
				emitstr("&lt;P&gt;");
				/* next emittec char will turn font attributes back on */
			}else if(nfld&gt;2 &amp;&amp; strcmp(fld[2], "&lt;H4&gt;")==0)
				attr |= (1&lt;&lt;Heading);
			else if(nfld&gt;2 &amp;&amp; strcmp(fld[2], "&lt;/H4&gt;")==0)
				attr &amp;= ~(1&lt;&lt;Heading);
			else if(debug)
				fprint(2, "unknown in-line html %s... at %s:%#d\n",
					fld[2], filename, cno);
		}
		return;
	}
	if(debug)
		fprint(2, "unknown or badly formatted x command %s\n", fld[0]);
}

int
lookup(int c, Htmlchar tab[], int ntab)
{
	int low, high, mid;

	low = 0;
	high = ntab - 1;
	while(low &lt;= high){
		mid = (low+high)/2;
		if(c &lt; tab[mid].value)
			high = mid - 1;
		else if(c &gt; tab[mid].value)
			low = mid + 1;
		else
			return mid;
	}
	return -1;	/* no match */
}

void
emithtmlchar(int r)
{
	static char buf[10];
	int i;

	i = lookup(r, htmlchars, nelem(htmlchars));
	if(i &gt;= 0)
		emitstr(htmlchars[i].name);
	else
		emit(r);
}

char*
troffchar(char *s)
{
	int i;

	for(i=0; troffchars[i].name!=nil; i++)
		if(strcmp(s, troffchars[i].name) == 0)
			return troffchars[i].value;
	return "??";
}

void
indent(void)
{
	int nind;

	didP = 0;
	if(atnewline){
		if(hp != prevlineH){
			prevlineH = hp;
			/* these most peculiar numbers appear in the troff -man output */
			nind = ((prevlineH-1*res)+323)/324;
			attr &amp;= ~((1&lt;&lt;Indent1)|(1&lt;&lt;Indent2)|(1&lt;&lt;Indent3));
			if(nind &gt;= 1)
				attr |= (1&lt;&lt;Indent1);
			if(nind &gt;= 2)
				attr |= (1&lt;&lt;Indent2);
			if(nind &gt;= 3)
				attr |= (1&lt;&lt;Indent3);
		}
		atnewline = 0;
	}
}

void
process(Biobuf *b, char *name)
{
	int c, r, v, i;
	char *p;

	cno = 0;
	prevlineH = res;
	filename = name;
	for(;;){
		c = getc(b);
		switch(c){
		case Beof:
			/* go to ground state */
			attr = 0;
			emit('\n');
			return;
		case '\n':
			break;
		case '0': case '1': case '2': case '3': case '4':
		case '5': case '6': case '7': case '8': case '9':
			v = c-'0';
			c = getc(b);
			if(c&lt;'0' || '9'&lt;c)
				sysfatal("illegal character motion at %s:#%d", filename, cno);
			v = v*10 + (c-'0');
			hp += v;
			/* fall through to character case */
		case 'c':
			indent();
			r = getc(b);
			emithtmlchar(r);
			break;
		case 'D':
			/* draw line; ignore */
			do
				c = getc(b);
			while(c!='\n' &amp;&amp; c!= Beof);
			break;
		case 'f':
			v = setnum(b, "font", 0, Nfont);
			switchfont(v);
			break;
		case 'h':
			v = setnum(b, "hpos", -20000, 20000);
			/* generate spaces if motion is large and within a line */
			if(!atnewline &amp;&amp; v&gt;2*72)
				for(i=0; i&lt;v; i+=72)
					emitstr("&amp;nbsp;");
			hp += v;
			break;
		case 'n':
			setnum(b, "n1", -10000, 10000);
			//Bprint(&amp;bout, " N1=%d", v);
			getc(b);	/* space separates */
			setnum(b, "n2", -10000, 10000);
			atnewline = 1;
			if(!didP &amp;&amp; hp &lt; (Wid-1)*res)	/* if line is less than 19" long, probably need a line break */
				emitstr("&lt;br&gt;");
			emit('\n');
			break;
		case 'p':
			page = setnum(b, "ps", -10000, 10000);
			break;
		case 's':
			ps = setnum(b, "ps", 1, 1000);
			break;
		case 'v':
			vp += setnum(b, "vpos", -10000, 10000);
			/* BUG: ignore motion */
			break;
		case 'x':
			xcmd(b);
			break;
		case 'w':
			emit(' ');
			break;
		case 'C':
			indent();
			p = getstr(b);
			emitstr(troffchar(p));
			break;
		case 'H':
			hp = setnum(b, "hpos", 0, 20000);
			//Bprint(&amp;bout, " H=%d ", hp);
			break;
		case 'V':
			vp = setnum(b, "vpos", 0, 10000);
			break;
		default:
			fprint(2, "dhtml: unknown directive %c(0x%.2ux) at %s:#%d\n", c, c, filename, cno);
			return;
		}
	}
}

HTMLfont*
htmlfont(char *name)
{
	int i;

	for(i=0; htmlfonts[i].name!=nil; i++)
		if(strcmp(name, htmlfonts[i].name) == 0)
			return &amp;htmlfonts[i];
	return &amp;htmlfonts[0];
}

void
mountfont(int pos, char *name)
{
	if(debug)
		fprint(2, "mount font %s on %d\n", name, pos);
	if(font[pos] != nil){
		free(font[pos]-&gt;name);
		free(font[pos]);
	}
	font[pos] = emalloc(sizeof(Font));
	font[pos]-&gt;name = estrdup(name);
	font[pos]-&gt;htmlfont = htmlfont(name);
}

void
switchfont(int pos)
{
	HTMLfont *hf;

	if(debug)
		fprint(2, "font change from %d (%s) to %d (%s)\n", ft, font[ft]-&gt;name, pos, font[pos]-&gt;name);
	if(pos == ft)
		return;
	hf = font[ft]-&gt;htmlfont;
	if(hf-&gt;bit != 0)
		attr &amp;= ~(1&lt;&lt;hf-&gt;bit);
	ft = pos;
	hf = font[ft]-&gt;htmlfont;
	if(hf-&gt;bit != 0)
		attr |= (1&lt;&lt;hf-&gt;bit);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

