<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tweak.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tweak.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;cursor.h&gt;
#include &lt;event.h&gt;
#include &lt;bio.h&gt;

typedef struct	Thing	Thing;

struct Thing
{
	Image	*b;
	Subfont 	*s;
	char		*name;	/* file name */
	int		face;		/* is 48x48 face file or cursor file*/
	Rectangle r;		/* drawing region */
	Rectangle tr;		/* text region */
	Rectangle er;		/* entire region */
	long		c;		/* character number in subfont */
	int		mod;	/* modified */
	int		mag;		/* magnification */
	Rune		off;		/* offset for subfont indices */
	Thing	*parent;	/* thing of which i'm an edit */
	Thing	*next;
};

enum
{
	Border	= 1,
	Up		= 1,
	Down	= 0,
	Mag		= 4,
	Maxmag	= 10,
};

enum
{
	NORMAL	=0,
	FACE	=1,
	CURSOR	=2
};

enum
{
	Mopen,
	Mread,
	Mwrite,
	Mcopy,
	Mchar,
	Mpixels,
	Mclose,
	Mexit,
};

enum
{
	Blue	= 54,
};

char	*menu3str[] = {
	[Mopen]	"open",
	[Mread]	"read",
	[Mwrite]	"write",
	[Mcopy]	"copy",
	[Mchar]	"char",
	[Mpixels]	"pixels",
	[Mclose]	"close",
	[Mexit]	"exit",
	0,
};

Menu	menu3 = {
	menu3str
};

Cursor sweep0 = {
	{-7, -7},
	{0x03, 0xC0, 0x03, 0xC0, 0x03, 0xC0, 0x03, 0xC0,
	 0x03, 0xC0, 0x03, 0xC0, 0xFF, 0xFF, 0xFF, 0xFF,
	 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0xC0, 0x03, 0xC0,
	 0x03, 0xC0, 0x03, 0xC0, 0x03, 0xC0, 0x03, 0xC0},
	{0x00, 0x00, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80,
	 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x7F, 0xFE,
	 0x7F, 0xFE, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80,
	 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x00, 0x00}
};

Cursor box = {
	{-7, -7},
	{0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	 0xFF, 0xFF, 0xF8, 0x1F, 0xF8, 0x1F, 0xF8, 0x1F,
	 0xF8, 0x1F, 0xF8, 0x1F, 0xF8, 0x1F, 0xFF, 0xFF,
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
	{0x00, 0x00, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE,
	 0x70, 0x0E, 0x70, 0x0E, 0x70, 0x0E, 0x70, 0x0E,
	 0x70, 0x0E, 0x70, 0x0E, 0x70, 0x0E, 0x70, 0x0E,
	 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x00, 0x00}
};

Cursor sight = {
	{-7, -7},
	{0x1F, 0xF8, 0x3F, 0xFC, 0x7F, 0xFE, 0xFB, 0xDF,
	 0xF3, 0xCF, 0xE3, 0xC7, 0xFF, 0xFF, 0xFF, 0xFF,
	 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0xC7, 0xF3, 0xCF,
	 0x7B, 0xDF, 0x7F, 0xFE, 0x3F, 0xFC, 0x1F, 0xF8,},
	{0x00, 0x00, 0x0F, 0xF0, 0x31, 0x8C, 0x21, 0x84,
	 0x41, 0x82, 0x41, 0x82, 0x41, 0x82, 0x7F, 0xFE,
	 0x7F, 0xFE, 0x41, 0x82, 0x41, 0x82, 0x41, 0x82,
	 0x21, 0x84, 0x31, 0x8C, 0x0F, 0xF0, 0x00, 0x00,}
};

Cursor pixel = {
	{-7, -7},
	{0x1f, 0xf8, 0x3f, 0xfc,  0x7f, 0xfe,  0xf8, 0x1f,
	0xf0, 0x0f,  0xe0, 0x07, 0xe0, 0x07, 0xfe, 0x7f, 
	0xfe, 0x7f, 0xe0, 0x07, 0xe0, 0x07, 0xf0, 0x0f, 
	0x78, 0x1f, 0x7f, 0xfe, 0x3f, 0xfc, 0x1f, 0xf8, },
	{0x00, 0x00, 0x0f, 0xf0, 0x31, 0x8c, 0x21, 0x84, 
	0x41, 0x82, 0x41, 0x82, 0x41, 0x82, 0x40, 0x02, 
	0x40, 0x02, 0x41, 0x82, 0x41, 0x82, 0x41, 0x82, 
	0x21, 0x84, 0x31, 0x8c, 0x0f, 0xf0, 0x00, 0x00, }
};

Cursor busy = {
	{-7, -7},
	{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	 0x00, 0x00, 0x00, 0x0c, 0x00, 0x8e, 0x1d, 0xc7,
	 0xff, 0xe3, 0xff, 0xf3, 0xff, 0xff, 0x7f, 0xfe, 
	 0x3f, 0xf8, 0x17, 0xf0, 0x03, 0xe0, 0x00, 0x00,},
	{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	 0x00, 0x00, 0x00, 0x08, 0x00, 0x04, 0x00, 0x82,
	 0x04, 0x41, 0xff, 0xe1, 0x5f, 0xf1, 0x3f, 0xfe, 
	 0x17, 0xf0, 0x03, 0xe0, 0x00, 0x00, 0x00, 0x00,}
};

Cursor skull = {
	{-7,-7},
	{0x00, 0x00, 0x00, 0x00, 0xc0, 0x03, 0xe7, 0xe7, 
	 0xff, 0xff, 0xff, 0xff, 0x3f, 0xfc, 0x1f, 0xf8, 
	 0x0f, 0xf0, 0x3f, 0xfc, 0xff, 0xff, 0xff, 0xff, 
	 0xef, 0xf7, 0xc7, 0xe3, 0x00, 0x00, 0x00, 0x00,},
	{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x03,
	 0xE7, 0xE7, 0x3F, 0xFC, 0x0F, 0xF0, 0x0D, 0xB0,
	 0x07, 0xE0, 0x06, 0x60, 0x37, 0xEC, 0xE4, 0x27,
	 0xC3, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,}
};

Rectangle	cntlr;		/* control region */
Rectangle	editr;		/* editing region */
Rectangle	textr;		/* text region */
Thing		*thing;
Mouse		mouse;
char		hex[] = "0123456789abcdefABCDEF";
jmp_buf		err;
char		*file;
int		mag;
int		but1val = 0;
int		but2val = 255;
int		invert = 0;
Image		*values[256];
Image		*greyvalues[256];
uchar		data[8192];

Thing*	tget(char*);
void	mesg(char*, ...);
void	drawthing(Thing*, int);
void	select(void);
void	menu(void);
void	error(Display*, char*);
void	buttons(int);
void	drawall(void);
void	tclose1(Thing*);

void
main(int argc, char *argv[])
{
	int i;
	Event e;
	Thing *t;

	mag = Mag;
	if(initdraw(error, 0, "tweak") &lt; 0){
		fprint(2, "tweak: initdraw failed: %r\n");
		exits("initdraw");
	}
	for(i=0; i&lt;256; i++){
		values[i] = allocimage(display, Rect(0, 0, 1, 1), screen-&gt;chan, 1, cmap2rgba(i));
		greyvalues[i] = allocimage(display, Rect(0, 0, 1, 1), screen-&gt;chan, 1, (i&lt;&lt;24)|(i&lt;&lt;16)|(i&lt;&lt;8)|0xFF);
		if(values[i] == 0 || greyvalues[i] == 0)
			drawerror(display, "can't allocate image");
	}
	einit(Emouse|Ekeyboard);
	eresized(0);
	i = 1;
	setjmp(err);
	for(; i&lt;argc; i++){
		file = argv[i];
		t = tget(argv[i]);
		if(t)
			drawthing(t, 1);
		flushimage(display, 1);
	}
	file = 0;
	setjmp(err);
	for(;;)
		switch(event(&amp;e)){
		case Ekeyboard:
			break;
		case Emouse:
			mouse = e.mouse;
			if(mouse.buttons &amp; 3){
				select();
				break;
			}
			if(mouse.buttons &amp; 4)
				menu();
		}
}

void
error(Display*, char *s)
{
	if(file)
		mesg("can't read %s: %s: %r", file, s);
	else
		mesg("/dev/bitblt error: %s", s);
	if(err[0])
		longjmp(err, 1);
	exits(s);
}

void
redraw(Thing *t)
{
	Thing *nt;
	Point p;

	if(thing==0 || thing==t)
		draw(screen, editr, display-&gt;white, nil, ZP);
	if(thing == 0)
		return;
	if(thing != t){
		for(nt=thing; nt-&gt;next!=t; nt=nt-&gt;next)
			;
		draw(screen, Rect(screen-&gt;r.min.x, nt-&gt;er.max.y, editr.max.x, editr.max.y),
			display-&gt;white, nil, ZP);
	}
	for(nt=t; nt; nt=nt-&gt;next){
		drawthing(nt, 0);
		if(nt-&gt;next == 0){
			p = Pt(editr.min.x, nt-&gt;er.max.y);
			draw(screen, Rpt(p, editr.max), display-&gt;white, nil, ZP);
		}
	}
	mesg("");
}

void
eresized(int new)
{
	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0)
		error(display, "can't reattach to window");
	cntlr = insetrect(screen-&gt;clipr, 1);
	editr = cntlr;
	textr = editr;
	textr.min.y = textr.max.y - font-&gt;height;
	cntlr.max.y = cntlr.min.y + font-&gt;height;
	editr.min.y = cntlr.max.y+1;
	editr.max.y = textr.min.y-1;
	draw(screen, screen-&gt;clipr, display-&gt;white, nil, ZP);
	draw(screen, Rect(editr.min.x, editr.max.y, editr.max.x+1, editr.max.y+1), display-&gt;black, nil, ZP);
	replclipr(screen, 0, editr);
	drawall();
}

void
mesgstr(Point p, int line, char *s)
{
	Rectangle c, r;

	r.min = p;
	r.min.y += line*font-&gt;height;
	r.max.y = r.min.y+font-&gt;height;
	r.max.x = editr.max.x;
	c = screen-&gt;clipr;
	replclipr(screen, 0, r);
	draw(screen, r, values[0xDD], nil, ZP);
	r.min.x++;
	string(screen, r.min, display-&gt;black, ZP, font, s);
	replclipr(screen, 0, c);
	flushimage(display, 1);
}

void
mesg(char *fmt, ...)
{
	char buf[1024];
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	mesgstr(textr.min, 0, buf);
}

void
tmesg(Thing *t, int line, char *fmt, ...)
{
	char buf[1024];
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	mesgstr(t-&gt;tr.min, line, buf);
}


void
scntl(char *l)
{
	sprint(l, "mag: %d  but1: %d  but2: %d  invert-on-copy: %c", mag, but1val, but2val, "ny"[invert]);
}

void
cntl(void)
{
	char buf[256];

	scntl(buf);
	mesgstr(cntlr.min, 0, buf);
}

void
stext(Thing *t, char *l0, char *l1)
{
	Fontchar *fc;
	char buf[256];

	l1[0] = 0;
	sprint(buf, "depth:%d r:%d %d  %d %d ", 
		t-&gt;b-&gt;depth, t-&gt;b-&gt;r.min.x, t-&gt;b-&gt;r.min.y,
		t-&gt;b-&gt;r.max.x, t-&gt;b-&gt;r.max.y);
	if(t-&gt;parent)
		sprint(buf+strlen(buf), "mag: %d ", t-&gt;mag);
	sprint(l0, "%s file: %s", buf, t-&gt;name);
	if(t-&gt;c &gt;= 0){
		fc = &amp;t-&gt;parent-&gt;s-&gt;info[t-&gt;c];
		sprint(l1, "c(hex): %x c(char): %C x: %d "
			   "top: %d bottom: %d left: %d width: %d iwidth: %d",
			(int)(t-&gt;c+t-&gt;parent-&gt;off), (int)(t-&gt;c+t-&gt;parent-&gt;off),
			fc-&gt;x, fc-&gt;top, fc-&gt;bottom, fc-&gt;left,
			fc-&gt;width, Dx(t-&gt;b-&gt;r));
	}else if(t-&gt;s)
		sprint(l1, "offset(hex): %ux n:%d  height:%d  ascent:%d",
			t-&gt;off, t-&gt;s-&gt;n, t-&gt;s-&gt;height, t-&gt;s-&gt;ascent);
}

void
text(Thing *t)
{
	char l0[256], l1[256];

	stext(t, l0, l1);
	tmesg(t, 0, l0);
	if(l1[0])
		tmesg(t, 1, l1);
}

void
drawall(void)
{
	Thing *t;

	cntl();
	for(t=thing; t; t=t-&gt;next)
		drawthing(t, 0);
}

/* imported from libdraw/arith.c to permit an extern log2 function */
static int log2[] = {
	-1, 0, 1, -1, 2, -1, -1, -1, 3, -1, -1, -1, -1, -1, -1, -1, 4,
	-1, -1, -1, -1, -1, -1, -1, 4 /* BUG */, -1, -1, -1, -1, -1, -1, -1, 5
};

int
value(Image *b, int x)
{
	int v, l, w;
	uchar mask;

	w = b-&gt;depth;
	if(w &gt; 8){
		mesg("ldepth too large");
		return 0;
	}
	l = log2[w];
	mask = (1&lt;&lt;w)-1;		/* ones at right end of word */
	x -= b-&gt;r.min.x&amp;~(7&gt;&gt;l);	/* adjust x relative to first pixel */
	v = data[x&gt;&gt;(3-l)];
	v &gt;&gt;= ((7&gt;&gt;l)&lt;&lt;l) - ((x&amp;(7&gt;&gt;l))&lt;&lt;l);	/* pixel at right end of word */
	v &amp;= mask;			/* pixel at right end of word */
	return v;
}

int
bvalue(int v, int d)
{
	v &amp;= (1&lt;&lt;d)-1;
	if(d &gt; screen-&gt;depth)
		v &gt;&gt;= d - screen-&gt;depth;
	else
		while(d &lt; screen-&gt;depth &amp;&amp; d &lt; 8){
			v |= v &lt;&lt; d;
			d &lt;&lt;= 1;
		}
	if(v&lt;0 || v&gt;255){
		mesg("internal error: bad color");
		return Blue;
	}
	return v;
}

void
drawthing(Thing *nt, int link)
{
	int nl, nf, i, x, y, sx, sy, fdx, dx, dy, v;
	Thing *t;
	Subfont *s;
	Image *b, *col;
	Point p, p1, p2;

	if(link){
		nt-&gt;next = 0;
		if(thing == 0){
			thing = nt;
			y = editr.min.y;
		}else{
			for(t=thing; t-&gt;next; t=t-&gt;next)
				;
			t-&gt;next = nt;
			y = t-&gt;er.max.y;
		}
	}else{
		if(thing == nt)
			y = editr.min.y;
		else{
			for(t=thing; t-&gt;next!=nt; t=t-&gt;next)
				;
			y = t-&gt;er.max.y;
		}
	}
	s = nt-&gt;s;
	b = nt-&gt;b;
	nl = font-&gt;height;
	if(s || nt-&gt;c&gt;=0)
		nl += font-&gt;height;
	fdx = Dx(editr) - 2*Border;
	dx = Dx(b-&gt;r);
	dy = Dy(b-&gt;r);
	if(nt-&gt;mag &gt; 1){
		dx *= nt-&gt;mag;
		dy *= nt-&gt;mag;
		fdx -= fdx%nt-&gt;mag;
	}
	nf = 1 + dx/fdx;
	nt-&gt;er.min.y = y;
	nt-&gt;er.min.x = editr.min.x;
	nt-&gt;er.max.x = nt-&gt;er.min.x + Border + dx + Border;
	if(nt-&gt;er.max.x &gt; editr.max.x)
		nt-&gt;er.max.x = editr.max.x;
	nt-&gt;er.max.y = nt-&gt;er.min.y + Border + nf*(dy+Border);
	nt-&gt;r = insetrect(nt-&gt;er, Border);
	nt-&gt;er.max.x = editr.max.x;
	draw(screen, nt-&gt;er, display-&gt;white, nil, ZP);
	for(i=0; i&lt;nf; i++){
		p1 = Pt(nt-&gt;r.min.x-1, nt-&gt;r.min.y+i*(Border+dy));
		/* draw portion of bitmap */
		p = Pt(p1.x+1, p1.y);
		if(nt-&gt;mag == 1)
			draw(screen, Rect(p.x, p.y, p.x+fdx+Dx(b-&gt;r), p.y+Dy(b-&gt;r)),
				b, nil, Pt(b-&gt;r.min.x+i*fdx, b-&gt;r.min.y));
		else{
			for(y=b-&gt;r.min.y; y&lt;b-&gt;r.max.y; y++){
				sy = p.y+(y-b-&gt;r.min.y)*nt-&gt;mag;
				unloadimage(b, Rect(b-&gt;r.min.x, y, b-&gt;r.max.x, y+1), data, sizeof data);
				for(x=b-&gt;r.min.x+i*(fdx/nt-&gt;mag); x&lt;b-&gt;r.max.x; x++){
					sx = p.x+(x-i*(fdx/nt-&gt;mag)-b-&gt;r.min.x)*nt-&gt;mag;
					if(sx &gt;= nt-&gt;r.max.x)
						break;
					v = bvalue(value(b, x), b-&gt;depth);
					if(v == 255)
						continue;
					if(b-&gt;chan == GREY8)
						draw(screen, Rect(sx, sy, sx+nt-&gt;mag, sy+nt-&gt;mag),
							greyvalues[v], nil, ZP);
					else
						draw(screen, Rect(sx, sy, sx+nt-&gt;mag, sy+nt-&gt;mag),
							values[v], nil, ZP);
				}

			}
		}
		/* line down left */
		if(i == 0)
			col = display-&gt;black;
		else
			col = display-&gt;white;
		draw(screen, Rect(p1.x, p1.y, p1.x+1, p1.y+dy+Border), col, nil, ZP);
		/* line across top */
		draw(screen, Rect(p1.x, p1.y-1, nt-&gt;r.max.x+Border, p1.y), display-&gt;black, nil, ZP);
		p2 = p1;
		if(i == nf-1){
			p2.x += 1 + dx%fdx;
			col = display-&gt;black;
		}else{
			p2.x = nt-&gt;r.max.x;
			col = display-&gt;white;
		}
		/* line down right */
		draw(screen, Rect(p2.x, p2.y, p2.x+1, p2.y+dy+Border), col, nil, ZP);
		/* line across bottom */
		if(i == nf-1){
			p1.y += Border+dy;
			draw(screen, Rect(p1.x, p1.y-1, p2.x,p1.y), display-&gt;black, nil, ZP);
		}
	}
	nt-&gt;tr.min.x = editr.min.x;
	nt-&gt;tr.max.x = editr.max.x;
	nt-&gt;tr.min.y = nt-&gt;er.max.y + Border;
	nt-&gt;tr.max.y = nt-&gt;tr.min.y + nl;
	nt-&gt;er.max.y = nt-&gt;tr.max.y + Border;
	text(nt);
}

int
tohex(int c)
{
	if('0'&lt;=c &amp;&amp; c&lt;='9')
		return c - '0';
	if('a'&lt;=c &amp;&amp; c&lt;='f')
		return 10 + (c - 'a');
	if('A'&lt;=c &amp;&amp; c&lt;='F')
		return 10 + (c - 'A');
	return 0;
}

Thing*
tget(char *file)
{
	int i, j, fd, face, x, y, c, chan;
	Image *b;
	Subfont *s;
	Thing *t;
	Dir *d;
	jmp_buf oerr;
	uchar buf[256];
	char *data;

	buf[0] = '\0';
	errstr((char*)buf, sizeof buf);	/* flush pending error message */
	memmove(oerr, err, sizeof err);
	d = nil;
	if(setjmp(err)){
   Err:
		free(d);
		memmove(err, oerr, sizeof err);
		return 0;
	}
	fd = open(file, OREAD);
	if(fd &lt; 0){
		mesg("can't open %s: %r", file);
		goto Err;
	}
	d = dirfstat(fd);
	if(d == nil){
		mesg("can't stat bitmap file %s: %r", file);
		close(fd);
		goto Err;
	}
	if(read(fd, buf, 11) != 11){
		mesg("can't read %s: %r", file);
		close(fd);
		goto Err;
	}
	seek(fd, 0, 0);
	data = (char*)buf;
	if(*data == '{')
		data++;
	if(memcmp(data, "0x", 2)==0 &amp;&amp; data[4]==','){
		/*
		 * cursor file
		 */
		face = CURSOR;
		s = 0;
		data = malloc(d-&gt;length+1);
		if(data == 0){
			mesg("can't malloc buffer: %r");
			close(fd);
			goto Err;
		}
		data[d-&gt;length] = 0;
		if(read(fd, data, d-&gt;length) != d-&gt;length){
			mesg("can't read cursor file %s: %r", file);
			close(fd);
			goto Err;
		}
		b = allocimage(display, Rect(0, 0, 16, 32), GREY1, 0, DNofill);
		if(b == 0){
			mesg("image alloc failed file %s: %r", file);
			free(data);
			close(fd);
			goto Err;
		}
		i = 0;
		for(x=0;x&lt;64; ){
			if((c=data[i]) == '\0')
				goto ill;
			if(c=='0' &amp;&amp; data[i+1] == 'x'){
				i += 2;
				continue;
			}
			if(strchr(hex, c)){
				buf[x++] = (tohex(c)&lt;&lt;4) | tohex(data[i+1]);
				i += 2;
				continue;
			}
			i++;
		}
		loadimage(b, Rect(0, 0, 16, 32), buf, sizeof buf);
		free(data);
	}else if(memcmp(buf, "0x", 2)==0){
		/*
		 * face file
		 */
		face = FACE;
		s = 0;
		data = malloc(d-&gt;length+1);
		if(data == 0){
			mesg("can't malloc buffer: %r");
			close(fd);
			goto Err;
		}
		data[d-&gt;length] = 0;
		if(read(fd, data, d-&gt;length) != d-&gt;length){
			mesg("can't read bitmap file %s: %r", file);
			close(fd);
			goto Err;
		}
		for(y=0,i=0; i&lt;d-&gt;length; i++)
			if(data[i] == '\n')
				y++;
		if(y == 0){
	ill:
			mesg("ill-formed face file %s", file);
			close(fd);
			free(data);
			goto Err;
		}
		for(x=0,i=0; (c=data[i])!='\n'; ){
			if(c==',' || c==' ' || c=='\t'){
				i++;
				continue;
			}
			if(c=='0' &amp;&amp; data[i+1] == 'x'){
				i += 2;
				continue;
			}
			if(strchr(hex, c)){
				x += 4;
				i++;
				continue;
			}
			goto ill;
		}
		if(x % y)
			goto ill;
		switch(x / y){
		default:
			goto ill;
		case 1:
			chan = GREY1;
			break;
		case 2:
			chan = GREY2;
			break;
		case 4:
			chan = GREY4;
			break;
		case 8:
			chan = CMAP8;
			break;
		}
		b = allocimage(display, Rect(0, 0, y, y), chan, 0, -1);
		if(b == 0){
			mesg("image alloc failed file %s: %r", file);
			free(data);
			close(fd);
			goto Err;
		}
		i = 0;
		for(j=0; j&lt;y; j++){
			for(x=0; (c=data[i])!='\n'; ){
				if(c=='0' &amp;&amp; data[i+1] == 'x'){
					i += 2;
					continue;
				}
				if(strchr(hex, c)){
					buf[x++] = ~((tohex(c)&lt;&lt;4) | tohex(data[i+1]));
					i += 2;
					continue;
				}
				i++;
			}
			i++;
			loadimage(b, Rect(0, j, y, j+1), buf, sizeof buf);
		}
		free(data);
	}else{
		face = NORMAL;
		s = 0;
		b = readimage(display, fd, 0);
		if(b == 0){
			mesg("can't read bitmap file %s: %r", file);
			close(fd);
			goto Err;
		}
		if(seek(fd, 0, 1) &lt; d-&gt;length)
			s = readsubfonti(display, file, fd, b, 0);
	}
	close(fd);
	t = malloc(sizeof(Thing));
	if(t == 0){
   nomem:
		mesg("malloc failed: %r");
		if(s)
			freesubfont(s);
		else
			freeimage(b);
		goto Err;
	}
	t-&gt;name = strdup(file);
	if(t-&gt;name == 0){
		free(t);
		goto nomem;
	}
	t-&gt;b = b;
	t-&gt;s = s;
	t-&gt;face = face;
	t-&gt;mod = 0;
	t-&gt;parent = 0;
	t-&gt;c = -1;
	t-&gt;mag = 1;
	t-&gt;off = 0;
	memmove(err, oerr, sizeof err);
	return t;
}

int
atline(int x, Point p, char *line, char *buf)
{
	char *s, *c, *word, *hit;
	int w, wasblank;
	Rune r;

	wasblank = 1;
	hit = 0;
	word = 0;
	for(s=line; *s; s+=w){
		w = chartorune(&amp;r, s);
		x += runestringnwidth(font, &amp;r, 1);
		if(wasblank &amp;&amp; r!=' ')
			word = s;
		wasblank = 0;
		if(r == ' '){
			if(x &gt;= p.x)
				break;
			wasblank = 1;
		}
		if(r == ':')
			hit = word;
	}
	if(x &lt; p.x)
		return 0;
	c = utfrune(hit, ':');
	strncpy(buf, hit, c-hit);
	buf[c-hit] = 0;
	return 1;
}

int
attext(Thing *t, Point p, char *buf)
{
	char l0[256], l1[256];

	if(!ptinrect(p, t-&gt;tr))
		return 0;
	stext(t, l0, l1);
	if(p.y &lt; t-&gt;tr.min.y+font-&gt;height)
		return atline(t-&gt;r.min.x, p, l0, buf);
	else
		return atline(t-&gt;r.min.x, p, l1, buf);
}

int
type(char *buf, char *tag)
{
	Rune r;
	char *p;

	esetcursor(&amp;busy);
	p = buf;
	for(;;){
		*p = 0;
		mesg("%s: %s", tag, buf);
		r = ekbd();
		switch(r){
		case '\n':
			mesg("");
			esetcursor(0);
			return p-buf;
		case 0x15:	/* control-U */
			p = buf;
			break;
		case '\b':
			if(p &gt; buf)
				--p;
			break;
		default:
			p += runetochar(p, &amp;r);
		}
	}
}

void
textedit(Thing *t, char *tag)
{
	char buf[256];
	char *s;
	Image *b;
	Subfont *f;
	Fontchar *fc, *nfc;
	Rectangle r;
	ulong chan;
	int i, ld, d, w, c, doredraw, fdx, x;
	Thing *nt;

	buttons(Up);
	if(type(buf, tag) == 0)
		return;
	if(strcmp(tag, "file") == 0){
		for(s=buf; *s; s++)
			if(*s &lt;= ' '){
				mesg("illegal file name");
				return;
			}
		if(strcmp(t-&gt;name, buf) != 0){
			if(t-&gt;parent)
				t-&gt;parent-&gt;mod = 1;
			else
				t-&gt;mod = 1;
		}
		for(nt=thing; nt; nt=nt-&gt;next)
			if(t==nt || t-&gt;parent==nt || nt-&gt;parent==t){
				free(nt-&gt;name);
				nt-&gt;name = strdup(buf);
				if(nt-&gt;name == 0){
					mesg("malloc failed: %r");
					return;
				}
				text(nt);
			}
		return;
	}
	if(strcmp(tag, "depth") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (d=atoi(buf))&lt;0 || d&gt;8 || log2[d]&lt;0){
			mesg("illegal ldepth");
			return;
		}
		if(d == t-&gt;b-&gt;depth)
			return;
		if(t-&gt;parent)
			t-&gt;parent-&gt;mod = 1;
		else
			t-&gt;mod = 1;
		if(d == 8)
			chan = CMAP8;
		else
			chan = CHAN1(CGrey, d);
		for(nt=thing; nt; nt=nt-&gt;next){
			if(nt!=t &amp;&amp; nt!=t-&gt;parent &amp;&amp; nt-&gt;parent!=t)
				continue;
			b = allocimage(display, nt-&gt;b-&gt;r, chan, 0, 0);
			if(b == 0){
	nobmem:
				mesg("image alloc failed: %r");
				return;
			}
			draw(b, b-&gt;r, nt-&gt;b, nil, nt-&gt;b-&gt;r.min);
			freeimage(nt-&gt;b);
			nt-&gt;b = b;
			if(nt-&gt;s){
				b = allocimage(display, nt-&gt;b-&gt;r, chan, 0, -1);
				if(b == 0)
					goto nobmem;
				draw(b, b-&gt;r, nt-&gt;b, nil, nt-&gt;b-&gt;r.min);
				f = allocsubfont(t-&gt;name, nt-&gt;s-&gt;n, nt-&gt;s-&gt;height, nt-&gt;s-&gt;ascent, nt-&gt;s-&gt;info, b);
				if(f == 0){
	nofmem:
					freeimage(b);
					mesg("can't make subfont: %r");
					return;
				}
				nt-&gt;s-&gt;info = 0;	/* prevent it being freed */
				nt-&gt;s-&gt;bits = 0;
				freesubfont(nt-&gt;s);
				nt-&gt;s = f;
			}
			drawthing(nt, 0);
		}
		return;
	}
	if(strcmp(tag, "mag") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (ld=atoi(buf))&lt;=0 || ld&gt;Maxmag){
			mesg("illegal magnification");
			return;
		}
		if(t-&gt;mag == ld)
			return;
		t-&gt;mag = ld;
		redraw(t);
		return;
	}
	if(strcmp(tag, "r") == 0){
		if(t-&gt;s){
			mesg("can't change rectangle of subfont\n");
			return;
		}
		s = buf;
		r.min.x = strtoul(s, &amp;s, 0);
		r.min.y = strtoul(s, &amp;s, 0);
		r.max.x = strtoul(s, &amp;s, 0);
		r.max.y = strtoul(s, &amp;s, 0);
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0){
			mesg("illegal rectangle");
			return;
		}
		if(t-&gt;parent)
			t = t-&gt;parent;
		for(nt=thing; nt; nt=nt-&gt;next){
			if(nt-&gt;parent==t &amp;&amp; !rectinrect(nt-&gt;b-&gt;r, r))
				tclose1(nt);
		}
		b = allocimage(display, r, t-&gt;b-&gt;chan, 0, 0);
		if(b == 0)
			goto nobmem;
		draw(b, r, t-&gt;b, nil, r.min);
		freeimage(t-&gt;b);
		t-&gt;b = b;
		b = allocimage(display, r, t-&gt;b-&gt;chan, 0, 0);
		if(b == 0)
			goto nobmem;
		redraw(t);
		t-&gt;mod = 1;
		return;
	}
	if(strcmp(tag, "ascent") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (ld=atoi(buf))&lt;0 || ld&gt;t-&gt;s-&gt;height){
			mesg("illegal ascent");
			return;
		}
		if(t-&gt;s-&gt;ascent == ld)
			return;
		t-&gt;s-&gt;ascent = ld;
		text(t);
		t-&gt;mod = 1;
		return;
	}
	if(strcmp(tag, "height") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (ld=atoi(buf))&lt;0){
			mesg("illegal height");
			return;
		}
		if(t-&gt;s-&gt;height == ld)
			return;
		t-&gt;s-&gt;height = ld;
		text(t);
		t-&gt;mod = 1;
		return;
	}
	if(strcmp(tag, "left")==0 || strcmp(tag, "width") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (ld=atoi(buf))&lt;0){
			mesg("illegal value");
			return;
		}
		fc = &amp;t-&gt;parent-&gt;s-&gt;info[t-&gt;c];
		if(strcmp(tag, "left")==0){
			if(fc-&gt;left == ld)
				return;
			fc-&gt;left = ld;
		}else{
			if(fc-&gt;width == ld)
				return;
			fc-&gt;width = ld;
		}
		text(t);
		t-&gt;parent-&gt;mod = 1;
		return;
	}
	if(strcmp(tag, "offset(hex)") == 0){
		if(!strchr(hex, buf[0])){
	illoff:
			mesg("illegal offset");
			return;
		}
		s = 0;
		ld = strtoul(buf, &amp;s, 16);
		if(*s)
			goto illoff;
		t-&gt;off = ld;
		text(t);
		for(nt=thing; nt; nt=nt-&gt;next)
			if(nt-&gt;parent == t)
				text(nt);
		return;
	}
	if(strcmp(tag, "n") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (w=atoi(buf))&lt;=0){
			mesg("illegal n");
			return;
		}
		f = t-&gt;s;
		if(w == f-&gt;n)
			return;
		doredraw = 0;
	again:
		for(nt=thing; nt; nt=nt-&gt;next)
			if(nt-&gt;parent == t){
				doredraw = 1;
				tclose1(nt);
				goto again;
			}
		r = t-&gt;b-&gt;r;
		if(w &lt; f-&gt;n)
			r.max.x = f-&gt;info[w].x;
		b = allocimage(display, r, t-&gt;b-&gt;chan, 0, 0);
		if(b == 0)
			goto nobmem;
		draw(b, b-&gt;r, t-&gt;b, nil, r.min);
		fdx = Dx(editr) - 2*Border;
		if(Dx(t-&gt;b-&gt;r)/fdx != Dx(b-&gt;r)/fdx)
			doredraw = 1;
		freeimage(t-&gt;b);
		t-&gt;b = b;
		b = allocimage(display, r, t-&gt;b-&gt;chan, 0, 0);
		if(b == 0)
			goto nobmem;
		draw(b, b-&gt;r, t-&gt;b, nil, r.min);
		nfc = malloc((w+1)*sizeof(Fontchar));
		if(nfc == 0){
			mesg("malloc failed");
			freeimage(b);
			return;
		}
		fc = f-&gt;info;
		for(i=0; i&lt;=w &amp;&amp; i&lt;=f-&gt;n; i++)
			nfc[i] = fc[i];
		if(w+1 &lt; i)
			memset(nfc+i, 0, ((w+1)-i)*sizeof(Fontchar));
		x = fc[f-&gt;n].x;
		for(; i&lt;=w; i++)
			nfc[i].x = x;
		f = allocsubfont(t-&gt;name, w, f-&gt;height, f-&gt;ascent, nfc, b);
		if(f == 0)
			goto nofmem;
		t-&gt;s-&gt;bits = nil;	/* don't free it */
		freesubfont(t-&gt;s);
		f-&gt;info = nfc;
		t-&gt;s = f;
		if(doredraw)
			redraw(thing);
		else
			drawthing(t, 0);
		t-&gt;mod = 1;
		return;
	}
	if(strcmp(tag, "iwidth") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (w=atoi(buf))&lt;0){
			mesg("illegal iwidth");
			return;
		}
		w -= Dx(t-&gt;b-&gt;r);
		if(w == 0)
			return;
		r = t-&gt;parent-&gt;b-&gt;r;
		r.max.x += w;
		c = t-&gt;c;
		t = t-&gt;parent;
		f = t-&gt;s;
		b = allocimage(display, r, t-&gt;b-&gt;chan, 0, 0);
		if(b == 0)
			goto nobmem;
		fc = &amp;f-&gt;info[c];
		draw(b, Rect(b-&gt;r.min.x, b-&gt;r.min.y,
				b-&gt;r.min.x+(fc[1].x-t-&gt;b-&gt;r.min.x), b-&gt;r.min.y+Dy(t-&gt;b-&gt;r)),
				t-&gt;b, nil, t-&gt;b-&gt;r.min);
		draw(b, Rect(fc[1].x+w, b-&gt;r.min.y, w+t-&gt;b-&gt;r.max.x, b-&gt;r.min.y+Dy(t-&gt;b-&gt;r)),
			t-&gt;b, nil, Pt(fc[1].x, t-&gt;b-&gt;r.min.y));
		fdx = Dx(editr) - 2*Border;
		doredraw = 0;
		if(Dx(t-&gt;b-&gt;r)/fdx != Dx(b-&gt;r)/fdx)
			doredraw = 1;
		freeimage(t-&gt;b);
		t-&gt;b = b;
		b = allocimage(display, r, t-&gt;b-&gt;chan, 0, 0);
		if(b == 0)
			goto nobmem;
		draw(b, b-&gt;r, t-&gt;b, nil, t-&gt;b-&gt;r.min);
		fc = &amp;f-&gt;info[c+1];
		for(i=c+1; i&lt;=f-&gt;n; i++, fc++)
			fc-&gt;x += w;
		f = allocsubfont(t-&gt;name, f-&gt;n, f-&gt;height, f-&gt;ascent,
			f-&gt;info, b);
		if(f == 0)
			goto nofmem;
		/* t-&gt;s and f share info; free carefully */
		fc = f-&gt;info;
		t-&gt;s-&gt;bits = nil;
		t-&gt;s-&gt;info = 0;
		freesubfont(t-&gt;s);
		f-&gt;info = fc;
		t-&gt;s = f;
		if(doredraw)
			redraw(t);
		else
			drawthing(t, 0);
		/* redraw all affected chars */
		for(nt=thing; nt; nt=nt-&gt;next){
			if(nt-&gt;parent!=t || nt-&gt;c&lt;c)
				continue;
			fc = &amp;f-&gt;info[nt-&gt;c];
			r.min.x = fc[0].x;
			r.min.y = nt-&gt;b-&gt;r.min.y;
			r.max.x = fc[1].x;
			r.max.y = nt-&gt;b-&gt;r.max.y;
			b = allocimage(display, r, nt-&gt;b-&gt;chan, 0, 0);
			if(b == 0)
				goto nobmem;
			draw(b, r, t-&gt;b, nil, r.min);
			doredraw = 0;
			if(Dx(nt-&gt;b-&gt;r)/fdx != Dx(b-&gt;r)/fdx)
				doredraw = 1;
			freeimage(nt-&gt;b);
			nt-&gt;b = b;
			if(c != nt-&gt;c)
				text(nt);
			else{
				if(doredraw)
					redraw(nt);
				else
					drawthing(nt, 0);
			}
		}
		t-&gt;mod = 1;
		return;
	}
	mesg("cannot edit %s in file %s", tag, t-&gt;name);
}

void
cntledit(char *tag)
{
	char buf[256];
	long l;

	buttons(Up);
	if(type(buf, tag) == 0)
		return;
	if(strcmp(tag, "mag") == 0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (l=atoi(buf))&lt;=0 || l&gt;Maxmag){
			mesg("illegal magnification");
			return;
		}
		mag = l;
		cntl();
		return;
	}
	if(strcmp(tag, "but1")==0
	|| strcmp(tag, "but2")==0){
		if(buf[0]&lt;'0' || '9'&lt;buf[0] || (l=atoi(buf))&lt;0 || l&gt;255){
			mesg("illegal value");
			return;
		}
		if(strcmp(tag, "but1") == 0)
			but1val = l;
		else if(strcmp(tag, "but2") == 0)
			but2val = l;
		cntl();
		return;
	}
	if(strcmp(tag, "invert-on-copy")==0){
		if(buf[0]=='y' || buf[0]=='1')
			invert = 1;
		else if(buf[0]=='n' || buf[0]=='0')
			invert = 0;
		else{
			mesg("illegal value");
			return;
		}
		cntl();
		return;
	}
	mesg("cannot edit %s", tag);
}

void
buttons(int ud)
{
	while((mouse.buttons==0) != ud)
		mouse = emouse();
}

Point
screenpt(Thing *t, Point realp)
{
	int fdx, n;
	Point p;

	fdx = Dx(editr)-2*Border;
	if(t-&gt;mag &gt; 1)
		fdx -= fdx%t-&gt;mag;
	p = mulpt(subpt(realp, t-&gt;b-&gt;r.min), t-&gt;mag);
	if(fdx &lt; Dx(t-&gt;b-&gt;r)*t-&gt;mag){
		n = p.x/fdx;
		p.y += n * (Dy(t-&gt;b-&gt;r)*t-&gt;mag+Border);
		p.x -= n * fdx;
	}
	p = addpt(p, t-&gt;r.min);
	return p;
}

Point
realpt(Thing *t, Point screenp)
{
	int fdx, n, dy;
	Point p;

	fdx = (Dx(editr)-2*Border);
	if(t-&gt;mag &gt; 1)
		fdx -= fdx%t-&gt;mag;
	p.y = screenp.y-t-&gt;r.min.y;
	p.x = 0;
	if(fdx &lt; Dx(t-&gt;b-&gt;r)*t-&gt;mag){
		dy = Dy(t-&gt;b-&gt;r)*t-&gt;mag+Border;
		n = (p.y/dy);
		p.x = n * fdx;
		p.y -= n * dy;
	}
	p.x += screenp.x-t-&gt;r.min.x;
	p = addpt(divpt(p, t-&gt;mag), t-&gt;b-&gt;r.min);
	return p;
}

int
sweep(int but, Rectangle *r)
{
	Thing *t;
	Point p, q, lastq;

	esetcursor(&amp;sweep0);
	buttons(Down);
	if(mouse.buttons != (1&lt;&lt;(but-1))){
		buttons(Up);
		esetcursor(0);
		return 0;
	}
	p = mouse.xy;
	for(t=thing; t; t=t-&gt;next)
		if(ptinrect(p, t-&gt;r))
			break;
	if(t)
		p = screenpt(t, realpt(t, p));
	r-&gt;min = p;
	r-&gt;max = p;
	esetcursor(&amp;box);
	lastq = ZP;
	while(mouse.buttons == (1&lt;&lt;(but-1))){
		edrawgetrect(insetrect(*r, -Borderwidth), 1);
		mouse = emouse();
		edrawgetrect(insetrect(*r, -Borderwidth), 0);
		q = mouse.xy;
		if(t)
			q = screenpt(t, realpt(t, q));
		if(eqpt(q, lastq))
			continue;
		*r = canonrect(Rpt(p, q));
		lastq = q;
	}
	esetcursor(0);
	if(mouse.buttons){
		buttons(Up);
		return 0;
	}
	return 1;
}

void
openedit(Thing *t, Point pt, int c)
{
	int x, y;
	Point p;
	Rectangle r;
	Rectangle br;
	Fontchar *fc;
	Thing *nt;

	if(t-&gt;b-&gt;depth &gt; 8){
		mesg("image has depth %d; can't handle &gt;8", t-&gt;b-&gt;depth);
		return;
	}
	br = t-&gt;b-&gt;r;
	if(t-&gt;s == 0){
		c = -1; 
		/* if big enough to bother, sweep box */
		if(Dx(br)&lt;=16 &amp;&amp; Dy(br)&lt;=16)
			r = br;
		else{
			if(!sweep(1, &amp;r))
				return;
			r = rectaddpt(r, subpt(br.min, t-&gt;r.min));
			if(!rectclip(&amp;r, br))
				return;
			if(Dx(br) &lt;= 8){
				r.min.x = br.min.x;
				r.max.x = br.max.x;
			}else if(Dx(r) &lt; 4){
	    toosmall:
				mesg("rectangle too small");
				return;
			}
			if(Dy(br) &lt;= 8){
				r.min.y = br.min.y;
				r.max.y = br.max.y;
			}else if(Dy(r) &lt; 4)
				goto toosmall;
		}
	}else if(c &gt;= 0){
		fc = &amp;t-&gt;s-&gt;info[c];
		r.min.x = fc[0].x;
		r.min.y = br.min.y;
		r.max.x = fc[1].x;
		r.max.y = br.min.y + Dy(br);
	}else{
		/* just point at character */
		fc = t-&gt;s-&gt;info;
		p = addpt(pt, subpt(br.min, t-&gt;r.min));
		x = br.min.x;
		y = br.min.y;
		for(c=0; c&lt;t-&gt;s-&gt;n; c++,fc++){
	    again:
			r.min.x = x;
			r.min.y = y;
			r.max.x = x + fc[1].x - fc[0].x;
			r.max.y = y + Dy(br);
			if(ptinrect(p, r))
				goto found;
			if(r.max.x &gt;= br.min.x+Dx(t-&gt;r)){
				x -= Dx(t-&gt;r);
				y += t-&gt;s-&gt;height;
				if(fc[1].x &gt; fc[0].x)
					goto again;
			}
			x += fc[1].x - fc[0].x;
		}
		return;
	   found:
		r = br;
		r.min.x = fc[0].x;
		r.max.x = fc[1].x;
	}
	nt = malloc(sizeof(Thing));
	if(nt == 0){
   nomem:
		mesg("can't allocate: %r");
		return;
	}
	memset(nt, 0, sizeof(Thing));
	nt-&gt;c = c;
	nt-&gt;b = allocimage(display, r, t-&gt;b-&gt;chan, 0, DNofill);
	if(nt-&gt;b == 0){
		free(nt);
		goto nomem;
	}
	draw(nt-&gt;b, r, t-&gt;b, nil, r.min);
	nt-&gt;name = strdup(t-&gt;name);
	if(nt-&gt;name == 0){
		freeimage(nt-&gt;b);
		free(nt);
		goto nomem;
	}
	nt-&gt;parent = t;
	nt-&gt;mag = mag;
	drawthing(nt, 1);
}

void
ckinfo(Thing *t, Rectangle mod)
{
	int i, j, k, top, bot, n, zero;
	Fontchar *fc;
	Rectangle r;
	Image *b;
	Thing *nt;

	if(t-&gt;parent)
		t = t-&gt;parent;
	if(t-&gt;s==0 || Dy(t-&gt;b-&gt;r)==0)
		return;
	b = 0;
	/* check bounding boxes */
	fc = &amp;t-&gt;s-&gt;info[0];
	r.min.y = t-&gt;b-&gt;r.min.y;
	r.max.y = t-&gt;b-&gt;r.max.y;
	for(i=0; i&lt;t-&gt;s-&gt;n; i++, fc++){
		r.min.x = fc[0].x;
		r.max.x = fc[1].x;
		if(!rectXrect(mod, r))
			continue;
		if(b==0 || Dx(b-&gt;r)&lt;Dx(r)){
			if(b)
				freeimage(b);
			b = allocimage(display, rectsubpt(r, r.min), t-&gt;b-&gt;chan, 0, 0);
			if(b == 0){
				mesg("can't alloc image");
				break;
			}
		}
		draw(b, b-&gt;r, display-&gt;white, nil, ZP);
		draw(b, b-&gt;r, t-&gt;b, nil, r.min);
		top = 100000;
		bot = 0;
		n = 2+((Dx(r)/8)*t-&gt;b-&gt;depth);
		for(j=0; j&lt;b-&gt;r.max.y; j++){
			memset(data, 0, n);
			unloadimage(b, Rect(b-&gt;r.min.x, j, b-&gt;r.max.x, j+1), data, sizeof data);
			zero = 1;
			for(k=0; k&lt;n; k++)
				if(data[k]){
					zero = 0;
					break;
				}
			if(!zero){
				if(top &gt; j)
					top = j;
				bot = j+1;
			}
		}
		if(top &gt; j)
			top = 0;
		if(top!=fc-&gt;top || bot!=fc-&gt;bottom){
			fc-&gt;top = top;
			fc-&gt;bottom = bot;
			for(nt=thing; nt; nt=nt-&gt;next)
				if(nt-&gt;parent==t &amp;&amp; nt-&gt;c==i)
					text(nt);
		}
	}
	if(b)
		freeimage(b);
}

void
twidpix(Thing *t, Point p, int set)
{
	Image *b, *v;
	int c;

	b = t-&gt;b;
	if(!ptinrect(p, b-&gt;r))
		return;
	if(set)
		c = but1val;
	else
		c = but2val;
	if(b-&gt;chan == GREY8)
		v = greyvalues[c];
	else
		v = values[c];
	draw(b, Rect(p.x, p.y, p.x+1, p.y+1), v, nil, ZP);
	p = screenpt(t, p);
	draw(screen, Rect(p.x, p.y, p.x+t-&gt;mag, p.y+t-&gt;mag), v, nil, ZP);
}

void
twiddle(Thing *t)
{
	int set;
	Point p, lastp;
	Image *b;
	Thing *nt;
	Rectangle mod;

	if(mouse.buttons!=1 &amp;&amp; mouse.buttons!=2){
		buttons(Up);
		return;
	}
	set = mouse.buttons==1;
	b = t-&gt;b;
	lastp = addpt(b-&gt;r.min, Pt(-1, -1));
	mod = Rpt(addpt(b-&gt;r.max, Pt(1, 1)), lastp);
	while(mouse.buttons){
		p = realpt(t, mouse.xy);
		if(!eqpt(p, lastp)){
			lastp = p;
			if(ptinrect(p, b-&gt;r)){
				for(nt=thing; nt; nt=nt-&gt;next)
					if(nt-&gt;parent==t-&gt;parent || nt==t-&gt;parent)
						twidpix(nt, p, set);
				if(t-&gt;parent)
					t-&gt;parent-&gt;mod = 1;
				else
					t-&gt;mod = 1;
				if(p.x &lt; mod.min.x)
					mod.min.x = p.x;
				if(p.y &lt; mod.min.y)
					mod.min.y = p.y;
				if(p.x &gt;= mod.max.x)
					mod.max.x = p.x+1;
				if(p.y &gt;= mod.max.y)
					mod.max.y = p.y+1;
			}
		}
		mouse = emouse();
	}
	ckinfo(t, mod);
}

void
select(void)
{
	Thing *t;
	char line[128], buf[128];
	Point p;

	if(ptinrect(mouse.xy, cntlr)){
		scntl(line);
		if(atline(cntlr.min.x, mouse.xy, line, buf)){
			if(mouse.buttons == 1)
				cntledit(buf);
			else
				buttons(Up);
			return;
		}
		return;
	}
	for(t=thing; t; t=t-&gt;next){
		if(attext(t, mouse.xy, buf)){
			if(mouse.buttons == 1)
				textedit(t, buf);
			else
				buttons(Up);
			return;
		}
		if(ptinrect(mouse.xy, t-&gt;r)){
			if(t-&gt;parent == 0){
				if(mouse.buttons == 1){
					p = mouse.xy;
					buttons(Up);
					openedit(t, p, -1);
				}else
					buttons(Up);
				return;
			}
			twiddle(t);
			return;
		}
	}
}

void
twrite(Thing *t)
{
	int i, j, x, y, fd, ws, ld;
	Biobuf buf;
	Rectangle r;

	if(t-&gt;parent)
		t = t-&gt;parent;
	esetcursor(&amp;busy);
	fd = create(t-&gt;name, OWRITE, 0666);
	if(fd &lt; 0){
		mesg("can't write %s: %r", t-&gt;name);
		return;
	}
	if(t-&gt;face &amp;&amp; t-&gt;b-&gt;depth &lt;= 4){
		r = t-&gt;b-&gt;r;
		ld = log2[t-&gt;b-&gt;depth];
		/* This heuristic reflects peculiarly different formats */
		ws = 4;
		if(t-&gt;face == 2)	/* cursor file */
			ws = 1;
		else if(Dx(r)&lt;32 || ld==0)
			ws = 2;
		Binit(&amp;buf, fd, OWRITE);
		if(t-&gt;face == CURSOR)
			Bprint(&amp;buf, "{");
		for(y=r.min.y; y&lt;r.max.y; y++){
			unloadimage(t-&gt;b, Rect(r.min.x, y, r.max.x, y+1), data, sizeof data);
			j = 0;
			for(x=r.min.x; x&lt;r.max.x; j+=ws,x+=ws*8&gt;&gt;ld){
				Bprint(&amp;buf, "0x");
				for(i=0; i&lt;ws; i++)
					Bprint(&amp;buf, "%.2x", data[i+j]);
				Bprint(&amp;buf, ", ");
			}
			if(t-&gt;face == CURSOR){
				switch(y){
				case 3: case 7: case 11: case 19: case 23: case 27:
					Bprint(&amp;buf, "\n ");
					break;
				case 15:
					Bprint(&amp;buf, "},\n{");
					break;
				case 31:
					Bprint(&amp;buf, "}\n");
					break;
				}
			}else
				Bprint(&amp;buf, "\n");
		}
		Bterm(&amp;buf);
	}else
		if(writeimage(fd, t-&gt;b, 0)&lt;0 || (t-&gt;s &amp;&amp; writesubfont(fd, t-&gt;s)&lt;0)){
			close(fd);
			mesg("can't write %s: %r", t-&gt;name);
		}
	t-&gt;mod = 0;
	close(fd);
	mesg("wrote %s", t-&gt;name);
}

void
tpixels(void)
{
	Thing *t;
	Point p, lastp;

	esetcursor(&amp;pixel);
	for(;;){
		buttons(Down);
		if(mouse.buttons != 4)
			break;
		for(t=thing; t; t=t-&gt;next){
			lastp = Pt(-1, -1);
			if(ptinrect(mouse.xy, t-&gt;r)){
				while(ptinrect(mouse.xy, t-&gt;r) &amp;&amp; mouse.buttons==4){
					p = realpt(t, mouse.xy);
					if(!eqpt(p, lastp)){
						if(p.y != lastp.y)
							unloadimage(t-&gt;b, Rect(t-&gt;b-&gt;r.min.x, p.y, t-&gt;b-&gt;r.max.x, p.y+1), data, sizeof data);
						mesg("[%d,%d] = %d=0x%ux", p.x, p.y, value(t-&gt;b, p.x), value(t-&gt;b, p.x));
						lastp = p;
					}
					mouse = emouse();
				}
				goto Continue;
			}
		}
		mouse = emouse();
    Continue:;
	}
	buttons(Up);
	esetcursor(0);
}

void
tclose1(Thing *t)
{
	Thing *nt;

	if(t == thing)
		thing = t-&gt;next;
	else{
		for(nt=thing; nt-&gt;next!=t; nt=nt-&gt;next)
			;
		nt-&gt;next = t-&gt;next;
	}
	do
		for(nt=thing; nt; nt=nt-&gt;next)
			if(nt-&gt;parent == t){
				tclose1(nt);
				break;
			}
	while(nt);
	if(t-&gt;s)
		freesubfont(t-&gt;s);
	else
		freeimage(t-&gt;b);
	free(t-&gt;name);
	free(t);
}

void
tclose(Thing *t)
{
	Thing *ct;

	if(t-&gt;mod){
		mesg("%s modified", t-&gt;name);
		t-&gt;mod = 0;
		return;
	}
	/* fiddle to save redrawing unmoved things */
	if(t == thing)
		ct = 0;
	else
		for(ct=thing; ct; ct=ct-&gt;next)
			if(ct-&gt;next==t || ct-&gt;next-&gt;parent==t)
				break;
	tclose1(t);
	if(ct)
		ct = ct-&gt;next;
	else
		ct = thing;
	redraw(ct);
}

void
tread(Thing *t)
{
	Thing *nt, *new;
	Fontchar *i;
	Rectangle r;
	int nclosed;

	if(t-&gt;parent)
		t = t-&gt;parent;
	new = tget(t-&gt;name);
	if(new == 0)
		return;
	nclosed = 0;
    again:
	for(nt=thing; nt; nt=nt-&gt;next)
		if(nt-&gt;parent == t){
			if(!rectinrect(nt-&gt;b-&gt;r, new-&gt;b-&gt;r)
			|| new-&gt;b-&gt;depth!=nt-&gt;b-&gt;depth){
    closeit:
				nclosed++;
				nt-&gt;parent = 0;
				tclose1(nt);
				goto again;
			}
			if((t-&gt;s==0) != (new-&gt;s==0))
				goto closeit;
			if((t-&gt;face==0) != (new-&gt;face==0))
				goto closeit;
			if(t-&gt;s){	/* check same char */
				if(nt-&gt;c &gt;= new-&gt;s-&gt;n)
					goto closeit;
				i = &amp;new-&gt;s-&gt;info[nt-&gt;c];
				r.min.x = i[0].x;
				r.max.x = i[1].x;
				r.min.y = new-&gt;b-&gt;r.min.y;
				r.max.y = new-&gt;b-&gt;r.max.y;
				if(!eqrect(r, nt-&gt;b-&gt;r))
					goto closeit;
			}
			nt-&gt;parent = new;
			draw(nt-&gt;b, nt-&gt;b-&gt;r, new-&gt;b, nil, nt-&gt;b-&gt;r.min);
		}
	new-&gt;next = t-&gt;next;
	if(t == thing)
		thing = new;
	else{
		for(nt=thing; nt-&gt;next!=t; nt=nt-&gt;next)
			;
		nt-&gt;next = new;
	}
	if(t-&gt;s)
		freesubfont(t-&gt;s);
	else
		freeimage(t-&gt;b);
	free(t-&gt;name);
	free(t);
	for(nt=thing; nt; nt=nt-&gt;next)
		if(nt==new || nt-&gt;parent==new)
			if(nclosed == 0)
				drawthing(nt, 0);	/* can draw in place */
			else{
				redraw(nt);	/* must redraw all below */
				break;
			}
}

void
tchar(Thing *t)
{
	char buf[256], *p;
	Rune r;
	ulong c, d;

	if(t-&gt;s == 0){
		t = t-&gt;parent;
		if(t==0 || t-&gt;s==0){
			mesg("not a subfont");
			return;
		}
	}
	if(type(buf, "char (hex or character or hex-hex)") == 0)
		return;
	if(utflen(buf) == 1){
		chartorune(&amp;r, buf);
		c = r;
		d = r;
	}else{
		if(!strchr(hex, buf[0])){
			mesg("illegal hex character");
			return;
		}
		c = strtoul(buf, 0, 16);
		d = c;
		p = utfrune(buf, '-');
		if(p){
			d = strtoul(p+1, 0, 16);
			if(d &lt; c){
				mesg("invalid range");
				return;
			}
		}
	}
	c -= t-&gt;off;
	d -= t-&gt;off;
	while(c &lt;= d){
		if(c&gt;=t-&gt;s-&gt;n){
			mesg("0x%lux not in font %s", c+t-&gt;off, t-&gt;name);
			return;
		}
		openedit(t, Pt(0, 0), c);
		c++;
	}
}

void
apply(void (*f)(Thing*))
{
	Thing *t;

	esetcursor(&amp;sight);
	buttons(Down);
	if(mouse.buttons == 4)
		for(t=thing; t; t=t-&gt;next)
			if(ptinrect(mouse.xy, t-&gt;er)){
				buttons(Up);
				f(t);
				break;
			}
	buttons(Up);
	esetcursor(0);
}

int
complement(Image *t)
{
	int i, n;
	uchar *buf;

	n = Dy(t-&gt;r)*bytesperline(t-&gt;r, t-&gt;depth);
	buf = malloc(n);
	if(buf == 0)
		return 0;
	unloadimage(t, t-&gt;r, buf, n);
	for(i=0; i&lt;n; i++)
		buf[i] = ~buf[i];
	loadimage(t, t-&gt;r, buf, n);
	free(buf);
	return 1;
}

void
copy(void)
{
	Thing *st, *dt, *nt;
	Rectangle sr, dr, fr;
	Image *tmp;
	Point p1, p2;
	int but, up;

	if(!sweep(3, &amp;sr))
		return;
	for(st=thing; st; st=st-&gt;next)
		if(rectXrect(sr, st-&gt;r))
			break;
	if(st == 0)
		return;
	/* click gives full rectangle */
	if(Dx(sr)&lt;4 &amp;&amp; Dy(sr)&lt;4)
		sr = st-&gt;r;
	rectclip(&amp;sr, st-&gt;r);
	p1 = realpt(st, sr.min);
	p2 = realpt(st, Pt(sr.min.x, sr.max.y));
	up = 0;
	if(p1.x != p2.x){	/* swept across a fold */
   onafold:
		mesg("sweep spans a fold");
		goto Return;
	}
	p2 = realpt(st, sr.max);
	sr.min = p1;
	sr.max = p2;
	fr.min = screenpt(st, sr.min);
	fr.max = screenpt(st, sr.max);
	p1 = subpt(p2, p1);	/* diagonal */
	if(p1.x==0 || p1.y==0)
		return;
	border(screen, fr, -1, values[Blue], ZP);
	esetcursor(&amp;box);
	for(; mouse.buttons==0; mouse=emouse()){
		for(dt=thing; dt; dt=dt-&gt;next)
			if(ptinrect(mouse.xy, dt-&gt;er))
				break;
		if(up)
			edrawgetrect(insetrect(dr, -Borderwidth), 0);
		up = 0;
		if(dt == 0)
			continue;
		dr.max = screenpt(dt, realpt(dt, mouse.xy));
		dr.min = subpt(dr.max, mulpt(p1, dt-&gt;mag));
		if(!rectXrect(dr, dt-&gt;r))
			continue;
		edrawgetrect(insetrect(dr, -Borderwidth), 1);
		up = 1;
	}
	/* if up==1, we had a hit */
	esetcursor(0);
	if(up)
		edrawgetrect(insetrect(dr, -Borderwidth), 0);
	but = mouse.buttons;
	buttons(Up);
	if(!up || but!=4)
		goto Return;
	dt = 0;
	for(nt=thing; nt; nt=nt-&gt;next)
		if(rectXrect(dr, nt-&gt;r)){
			if(dt){
				mesg("ambiguous sweep");
				return;
			}
			dt = nt;
		}
	if(dt == 0)
		goto Return;
	p1 = realpt(dt, dr.min);
	p2 = realpt(dt, Pt(dr.min.x, dr.max.y));
	if(p1.x != p2.x)
		goto onafold;
	p2 = realpt(dt, dr.max);
	dr.min = p1;
	dr.max = p2;

	if(invert){
		tmp = allocimage(display, dr, dt-&gt;b-&gt;chan, 0, 255);
		if(tmp == 0){
    nomem:
			mesg("can't allocate temporary");
			goto Return;
		}
		draw(tmp, dr, st-&gt;b, nil, sr.min);
		if(!complement(tmp))
			goto nomem;
		draw(dt-&gt;b, dr, tmp, nil, dr.min);
		freeimage(tmp);
	}else
		draw(dt-&gt;b, dr, st-&gt;b, nil, sr.min);
	if(dt-&gt;parent){
		draw(dt-&gt;parent-&gt;b, dr, dt-&gt;b, nil, dr.min);
		dt = dt-&gt;parent;
	}
	drawthing(dt, 0);
	for(nt=thing; nt; nt=nt-&gt;next)
		if(nt-&gt;parent==dt &amp;&amp; rectXrect(dr, nt-&gt;b-&gt;r)){
			draw(nt-&gt;b, dr, dt-&gt;b, nil, dr.min);
			drawthing(nt, 0);
		}
	ckinfo(dt, dr);
	dt-&gt;mod = 1;

Return:
	/* clear blue box */
	drawthing(st, 0);
}

void
menu(void)
{
	Thing *t;
	char *mod;
	int sel;
	char buf[256];

	sel = emenuhit(3, &amp;mouse, &amp;menu3);
	switch(sel){
	case Mopen:
		if(type(buf, "file")){
			t = tget(buf);
			if(t)
				drawthing(t, 1);
		}
		break;
	case Mwrite:
		apply(twrite);
		break;
	case Mread:
		apply(tread);
		break;
	case Mchar:
		apply(tchar);
		break;
	case Mcopy:
		copy();
		break;
	case Mpixels:
		tpixels();
		break;
	case Mclose:
		apply(tclose);
		break;
	case Mexit:
		mod = 0;
		for(t=thing; t; t=t-&gt;next)
			if(t-&gt;mod){
				mod = t-&gt;name;
				t-&gt;mod = 0;
			}
		if(mod){
			mesg("%s modified", mod);
			break;
		}
		esetcursor(&amp;skull);
		buttons(Down);
		if(mouse.buttons == 4){
			buttons(Up);
			exits(0);
		}
		buttons(Up);
		esetcursor(0);
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

