<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devroot.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devroot.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

enum
{
	Qdir = 0,
	Qboot = 0x1000,
	Qmnt = 0x2000,
	Qfactotum,

	Nrootfiles = 32,
	Nbootfiles = 32,
	Nmntfiles = 2,
};

typedef struct Dirlist Dirlist;
struct Dirlist
{
	uint base;
	Dirtab *dir;
	uchar **data;
	int ndir;
	int mdir;
};

static Dirtab rootdir[Nrootfiles] = {
	"#/",		{Qdir, 0, QTDIR},	0,		DMDIR|0555,
	"boot",	{Qboot, 0, QTDIR},	0,		DMDIR|0555,
	"mnt",	{Qmnt, 0, QTDIR},	0,		DMDIR|0555,
};
static uchar *rootdata[Nrootfiles];
static Dirlist rootlist = 
{
	0,
	rootdir,
	rootdata,
	3,
	Nrootfiles
};

static Dirtab bootdir[Nbootfiles] = {
	"boot",	{Qboot, 0, QTDIR},	0,		DMDIR|0555,
};
static uchar *bootdata[Nbootfiles];
static Dirlist bootlist =
{
	Qboot,
	bootdir,
	bootdata,
	1,
	Nbootfiles
};

static uchar *mntdata[Nmntfiles];
static Dirtab mntdir[Nmntfiles] = {
	"mnt",	{Qmnt, 0, QTDIR},	0,		DMDIR|0555,
	"factotum",	{Qfactotum, 0, QTDIR},	0,	DMDIR|0555,
};
static Dirlist mntlist =
{
	Qmnt,
	mntdir,
	mntdata,
	2,
	Nmntfiles
};

/*
 *  add a file to the list
 */
static void
addlist(Dirlist *l, char *name, uchar *contents, ulong len, int perm)
{
	Dirtab *d;

	if(l-&gt;ndir &gt;= l-&gt;mdir)
		panic("too many root files");
	l-&gt;data[l-&gt;ndir] = contents;
	d = &amp;l-&gt;dir[l-&gt;ndir];
	strcpy(d-&gt;name, name);
	d-&gt;length = len;
	d-&gt;perm = perm;
	d-&gt;qid.type = 0;
	d-&gt;qid.vers = 0;
	d-&gt;qid.path = ++l-&gt;ndir + l-&gt;base;
	if(perm &amp; DMDIR)
		d-&gt;qid.type |= QTDIR;
}

/*
 *  add a root file
 */
void
addbootfile(char *name, uchar *contents, ulong len)
{
	addlist(&amp;bootlist, name, contents, len, 0555);
}

/*
 *  add a root directory
 */
static void
addrootdir(char *name)
{
	addlist(&amp;rootlist, name, nil, 0, DMDIR|0555);
}

static void
rootreset(void)
{
	addrootdir("bin");
	addrootdir("dev");
	addrootdir("env");
	addrootdir("fd");
	addrootdir("net");
	addrootdir("net.alt");
	addrootdir("proc");
	addrootdir("root");
	addrootdir("srv");
}

static Chan*
rootattach(char *spec)
{
	return devattach('/', spec);
}

static int
rootgen(Chan *c, char *name, Dirtab *dirt, int ndirt, int s, Dir *dp)
{
	int t;
	Dirtab *d;
	Dirlist *l;

	USED(dirt);
	USED(ndirt);

	switch((int)c-&gt;qid.path){
	case Qdir:
		if(s == DEVDOTDOT){
			Qid tqiddir = {Qdir, 0, QTDIR};
			devdir(c, tqiddir, "#/", 0, eve, 0555, dp);
			return 1;
		}
		return devgen(c, name, rootlist.dir, rootlist.ndir, s, dp);
	case Qmnt:
		if(s == DEVDOTDOT){
			Qid tqiddir = {Qdir, 0, QTDIR};
			devdir(c, tqiddir, "#/", 0, eve, 0555, dp);
			return 1;
		}
		return devgen(c, name, mntlist.dir, mntlist.ndir, s, dp);
	case Qboot:
		if(s == DEVDOTDOT){
			Qid tqiddir = {Qdir, 0, QTDIR};
			devdir(c, tqiddir, "#/", 0, eve, 0555, dp);
			return 1;
		}
		return devgen(c, name, bootlist.dir, bootlist.ndir, s, dp);
	default:
		if(s == DEVDOTDOT){
			Qid tqiddir = {Qdir, 0, QTDIR};
			tqiddir.path = c-&gt;qid.path&amp;0xF000;
			devdir(c, tqiddir, "#/", 0, eve, 0555, dp);
			return 1;
		}
		if(s != 0)
			return -1;
		switch((int)c-&gt;qid.path &amp; 0xF000){
		case Qdir:
			t = c-&gt;qid.path-1;
			l = &amp;rootlist;
			break;
		case Qboot:
			t = c-&gt;qid.path - Qboot - 1;
			l = &amp;bootlist;
			break;
		case Qmnt:
			t = c-&gt;qid.path - Qmnt - 1;
			l = &amp;mntlist;
			break;
		default:
			return -1;
		}
		if(t &gt;= l-&gt;ndir)
			return -1;
if(t &lt; 0){
print("rootgen %llud %d %d\n", c-&gt;qid.path, s, t);
panic("whoops");
}
		d = &amp;l-&gt;dir[t];
		devdir(c, d-&gt;qid, d-&gt;name, d-&gt;length, eve, d-&gt;perm, dp);
		return 1;
	}
	return -1;
}

static Walkqid*
rootwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c,  nc, name, nname, nil, 0, rootgen);
}

static int
rootstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, nil, 0, rootgen);
}

static Chan*
rootopen(Chan *c, int omode)
{
	return devopen(c, omode, nil, 0, devgen);
}

/*
 * sysremove() knows this is a nop
 */
static void
rootclose(Chan *c)
{
	USED(c);
}

static long
rootread(Chan *c, void *buf, long n, vlong off)
{
	ulong t;
	Dirtab *d;
	Dirlist *l;
	uchar *data;
	ulong offset = off;

	t = c-&gt;qid.path;
	switch(t){
	case Qdir:
	case Qboot:
	case Qmnt:
		return devdirread(c, buf, n, nil, 0, rootgen);
	}

	if(t&amp;Qboot)
		l = &amp;bootlist;
	else if(t&amp;Qmnt)
		l = &amp;mntlist;
	else
		l = &amp;bootlist;
	t &amp;= 0xFFF;
	t--;

	if(t &gt;= l-&gt;ndir)
		error(Egreg);

	d = &amp;l-&gt;dir[t];
	data = l-&gt;data[t];
	if(offset &gt;= d-&gt;length)
		return 0;
	if(offset+n &gt; d-&gt;length)
		n = d-&gt;length - offset;
	memmove(buf, data+offset, n);
	return n;
}

static long
rootwrite(Chan *c, void *v, long n, vlong o)
{
	USED(c);
	USED(v);
	USED(n);
	USED(o);

	error(Egreg);
	return 0;
}

Dev rootdevtab = {
	'/',
	"root",

	rootreset,
	devinit,
	devshutdown,
	rootattach,
	rootwalk,
	rootstat,
	rootopen,
	devcreate,
	rootclose,
	rootread,
	devbread,
	rootwrite,
	devbwrite,
	devremove,
	devwstat,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

