<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devssl.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devssl.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *  devssl - secure sockets layer
 */
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

#include	"libsec.h"

#define NOSPOOKS 1

typedef struct OneWay OneWay;
struct OneWay
{
	QLock	q;
	QLock	ctlq;

	void	*state;		/* encryption state */
	int	slen;		/* hash data length */
	uchar	*secret;	/* secret */
	ulong	mid;		/* message id */
};

enum
{
	/* connection states */
	Sincomplete=	0,
	Sclear=		1,
	Sencrypting=	2,
	Sdigesting=	4,
	Sdigenc=	Sencrypting|Sdigesting,

	/* encryption algorithms */
	Noencryption=	0,
	DESCBC=		1,
	DESECB=		2,
	RC4=		3
};

typedef struct Dstate Dstate;
struct Dstate
{
	Chan	*c;		/* io channel */
	uchar	state;		/* state of connection */
	int	ref;		/* serialized by dslock for atomic destroy */

	uchar	encryptalg;	/* encryption algorithm */
	ushort	blocklen;	/* blocking length */

	ushort	diglen;		/* length of digest */
	DigestState *(*hf)(uchar*, ulong, uchar*, DigestState*);	/* hash func */

	/* for SSL format */
	int	max;		/* maximum unpadded data per msg */
	int	maxpad;		/* maximum padded data per msg */

	/* input side */
	OneWay	in;
	Block	*processed;
	Block	*unprocessed;

	/* output side */
	OneWay	out;

	/* protections */
	char	*user;
	int	perm;
};

enum
{
	Maxdmsg=	1&lt;&lt;16,
	Maxdstate=	128,	/* must be a power of 2 */
};

Lock	dslock;
int	dshiwat;
char	*dsname[Maxdstate];
Dstate	*dstate[Maxdstate];
char	*encalgs;
char	*hashalgs;

enum{
	Qtopdir		= 1,	/* top level directory */
	Qprotodir,
	Qclonus,
	Qconvdir,		/* directory for a conversation */
	Qdata,
	Qctl,
	Qsecretin,
	Qsecretout,
	Qencalgs,
	Qhashalgs,
};

#define TYPE(x) 	((x).path &amp; 0xf)
#define CONV(x) 	(((x).path &gt;&gt; 5)&amp;(Maxdstate-1))
#define QID(c, y) 	(((c)&lt;&lt;5) | (y))

static void	ensure(Dstate*, Block**, int);
static void	consume(Block**, uchar*, int);
static void	setsecret(OneWay*, uchar*, int);
static Block*	encryptb(Dstate*, Block*, int);
static Block*	decryptb(Dstate*, Block*);
static Block*	digestb(Dstate*, Block*, int);
static void	checkdigestb(Dstate*, Block*);
static Chan*	buftochan(char*);
static void	sslhangup(Dstate*);
static Dstate*	dsclone(Chan *c);
static void	dsnew(Chan *c, Dstate **);
static long	sslput(Dstate *s, Block * volatile b);

char *sslnames[] = {
	/* unused */ 0,
	/* topdir */ 0,
	/* protodir */ 0,
	"clone",
	/* convdir */ 0,
	"data",
	"ctl",
	"secretin",
	"secretout",
	"encalgs",
	"hashalgs",
};

static int
sslgen(Chan *c, char *n, Dirtab *d, int nd, int s, Dir *dp)
{
	Qid q;
	Dstate *ds;
	char name[16], *p, *nm;
	int ft;

	USED(n);
	USED(nd);
	USED(d);

	q.type = QTFILE;
	q.vers = 0;

	ft = TYPE(c-&gt;qid);
	switch(ft) {
	case Qtopdir:
		if(s == DEVDOTDOT){
			q.path = QID(0, Qtopdir);
			q.type = QTDIR;
			devdir(c, q, "#D", 0, eve, 0555, dp);
			return 1;
		}
		if(s &gt; 0)
			return -1;
		q.path = QID(0, Qprotodir);
		q.type = QTDIR;
		devdir(c, q, "ssl", 0, eve, 0555, dp);
		return 1;
	case Qprotodir:
		if(s == DEVDOTDOT){
			q.path = QID(0, Qtopdir);
			q.type = QTDIR;
			devdir(c, q, ".", 0, eve, 0555, dp);
			return 1;
		}
		if(s &lt; dshiwat) {
			q.path = QID(s, Qconvdir);
			q.type = QTDIR;
			ds = dstate[s];
			if(ds != 0)
				nm = ds-&gt;user;
			else
				nm = eve;
			if(dsname[s] == nil){
				sprint(name, "%d", s);
				kstrdup(&amp;dsname[s], name);
			}
			devdir(c, q, dsname[s], 0, nm, 0555, dp);
			return 1;
		}
		if(s &gt; dshiwat)
			return -1;
		q.path = QID(0, Qclonus);
		devdir(c, q, "clone", 0, eve, 0555, dp);
		return 1;
	case Qconvdir:
		if(s == DEVDOTDOT){
			q.path = QID(0, Qprotodir);
			q.type = QTDIR;
			devdir(c, q, "ssl", 0, eve, 0555, dp);
			return 1;
		}
		ds = dstate[CONV(c-&gt;qid)];
		if(ds != 0)
			nm = ds-&gt;user;
		else
			nm = eve;
		switch(s) {
		default:
			return -1;
		case 0:
			q.path = QID(CONV(c-&gt;qid), Qctl);
			p = "ctl";
			break;
		case 1:
			q.path = QID(CONV(c-&gt;qid), Qdata);
			p = "data";
			break;
		case 2:
			q.path = QID(CONV(c-&gt;qid), Qsecretin);
			p = "secretin";
			break;
		case 3:
			q.path = QID(CONV(c-&gt;qid), Qsecretout);
			p = "secretout";
			break;
		case 4:
			q.path = QID(CONV(c-&gt;qid), Qencalgs);
			p = "encalgs";
			break;
		case 5:
			q.path = QID(CONV(c-&gt;qid), Qhashalgs);
			p = "hashalgs";
			break;
		}
		devdir(c, q, p, 0, nm, 0660, dp);
		return 1;
	case Qclonus:
		devdir(c, c-&gt;qid, sslnames[TYPE(c-&gt;qid)], 0, eve, 0555, dp);
		return 1;
	default:
		ds = dstate[CONV(c-&gt;qid)];
		if(ds != 0)
			nm = ds-&gt;user;
		else
			nm = eve;
		devdir(c, c-&gt;qid, sslnames[TYPE(c-&gt;qid)], 0, nm, 0660, dp);
		return 1;
	}
	return -1;
}

static Chan*
sslattach(char *spec)
{
	Chan *c;

	c = devattach('D', spec);
	c-&gt;qid.path = QID(0, Qtopdir);
	c-&gt;qid.vers = 0;
	c-&gt;qid.type = QTDIR;
	return c;
}

static Walkqid*
sslwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, nil, 0, sslgen);
}

static int
sslstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, nil, 0, sslgen);
}

static Chan*
sslopen(Chan *c, int omode)
{
	Dstate *s, **pp;
	int perm;
	int ft;

	perm = 0;
	omode &amp;= 3;
	switch(omode) {
	case OREAD:
		perm = 4;
		break;
	case OWRITE:
		perm = 2;
		break;
	case ORDWR:
		perm = 6;
		break;
	}

	ft = TYPE(c-&gt;qid);
	switch(ft) {
	default:
		panic("sslopen");
	case Qtopdir:
	case Qprotodir:
	case Qconvdir:
		if(omode != OREAD)
			error(Eperm);
		break;
	case Qclonus:
		s = dsclone(c);
		if(s == 0)
			error(Enodev);
		break;
	case Qctl:
	case Qdata:
	case Qsecretin:
	case Qsecretout:
		if(waserror()) {
			unlock(&amp;dslock);
			nexterror();
		}
		lock(&amp;dslock);
		pp = &amp;dstate[CONV(c-&gt;qid)];
		s = *pp;
		if(s == 0)
			dsnew(c, pp);
		else {
			if((perm &amp; (s-&gt;perm&gt;&gt;6)) != perm
			   &amp;&amp; (strcmp(up-&gt;user, s-&gt;user) != 0
			     || (perm &amp; s-&gt;perm) != perm))
				error(Eperm);

			s-&gt;ref++;
		}
		unlock(&amp;dslock);
		poperror();
		break;
	case Qencalgs:
	case Qhashalgs:
		if(omode != OREAD)
			error(Eperm);
		break;
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static int
sslwstat(Chan *c, uchar *db, int n)
{
	Dir *dir;
	Dstate *s;
	int m;

	s = dstate[CONV(c-&gt;qid)];
	if(s == 0)
		error(Ebadusefd);
	if(strcmp(s-&gt;user, up-&gt;user) != 0)
		error(Eperm);

	dir = smalloc(sizeof(Dir)+n);
	m = convM2D(db, n, &amp;dir[0], (char*)&amp;dir[1]);
	if(m == 0){
		free(dir);
		error(Eshortstat);
	}

	if(!emptystr(dir-&gt;uid))
		kstrdup(&amp;s-&gt;user, dir-&gt;uid);
	if(dir-&gt;mode != ~0)
		s-&gt;perm = dir-&gt;mode;

	free(dir);
	return m;
}

static void
sslclose(Chan *c)
{
	Dstate *s;
	int ft;

	ft = TYPE(c-&gt;qid);
	switch(ft) {
	case Qctl:
	case Qdata:
	case Qsecretin:
	case Qsecretout:
		if((c-&gt;flag &amp; COPEN) == 0)
			break;

		s = dstate[CONV(c-&gt;qid)];
		if(s == 0)
			break;

		lock(&amp;dslock);
		if(--s-&gt;ref &gt; 0) {
			unlock(&amp;dslock);
			break;
		}
		dstate[CONV(c-&gt;qid)] = 0;
		unlock(&amp;dslock);

		if(s-&gt;user != nil)
			free(s-&gt;user);
		sslhangup(s);
		if(s-&gt;c)
			cclose(s-&gt;c);
		if(s-&gt;in.secret)
			free(s-&gt;in.secret);
		if(s-&gt;out.secret)
			free(s-&gt;out.secret);
		if(s-&gt;in.state)
			free(s-&gt;in.state);
		if(s-&gt;out.state)
			free(s-&gt;out.state);
		free(s);

	}
}

/*
 *  make sure we have at least 'n' bytes in list 'l'
 */
static void
ensure(Dstate *s, Block **l, int n)
{
	int sofar, i;
	Block *b, *bl;

	sofar = 0;
	for(b = *l; b; b = b-&gt;next){
		sofar += BLEN(b);
		if(sofar &gt;= n)
			return;
		l = &amp;b-&gt;next;
	}

	while(sofar &lt; n){
		bl = devtab[s-&gt;c-&gt;type]-&gt;bread(s-&gt;c, Maxdmsg, 0);
		if(bl == 0)
			nexterror();
		*l = bl;
		i = 0;
		for(b = bl; b; b = b-&gt;next){
			i += BLEN(b);
			l = &amp;b-&gt;next;
		}
		if(i == 0)
			error(Ehungup);
		sofar += i;
	}
}

/*
 *  copy 'n' bytes from 'l' into 'p' and free
 *  the bytes in 'l'
 */
static void
consume(Block **l, uchar *p, int n)
{
	Block *b;
	int i;

	for(; *l &amp;&amp; n &gt; 0; n -= i){
		b = *l;
		i = BLEN(b);
		if(i &gt; n)
			i = n;
		memmove(p, b-&gt;rp, i);
		b-&gt;rp += i;
		p += i;
		if(BLEN(b) &lt; 0)
			panic("consume");
		if(BLEN(b))
			break;
		*l = b-&gt;next;
		freeb(b);
	}
}

/*
 *  give back n bytes
static void
regurgitate(Dstate *s, uchar *p, int n)
{
	Block *b;

	if(n &lt;= 0)
		return;
	b = s-&gt;unprocessed;
	if(s-&gt;unprocessed == nil || b-&gt;rp - b-&gt;base &lt; n) {
		b = allocb(n);
		memmove(b-&gt;wp, p, n);
		b-&gt;wp += n;
		b-&gt;next = s-&gt;unprocessed;
		s-&gt;unprocessed = b;
	} else {
		b-&gt;rp -= n;
		memmove(b-&gt;rp, p, n);
	}
}
 */

/*
 *  remove at most n bytes from the queue, if discard is set
 *  dump the remainder
 */
static Block*
qtake(Block **l, int n, int discard)
{
	Block *nb, *b, *first;
	int i;

	first = *l;
	for(b = first; b; b = b-&gt;next){
		i = BLEN(b);
		if(i == n){
			if(discard){
				freeblist(b-&gt;next);
				*l = 0;
			} else
				*l = b-&gt;next;
			b-&gt;next = 0;
			return first;
		} else if(i &gt; n){
			i -= n;
			if(discard){
				freeblist(b-&gt;next);
				b-&gt;wp -= i;
				*l = 0;
			} else {
				nb = allocb(i);
				memmove(nb-&gt;wp, b-&gt;rp+n, i);
				nb-&gt;wp += i;
				b-&gt;wp -= i;
				nb-&gt;next = b-&gt;next;
				*l = nb;
			}
			b-&gt;next = 0;
			if(BLEN(b) &lt; 0)
				panic("qtake");
			return first;
		} else
			n -= i;
		if(BLEN(b) &lt; 0)
			panic("qtake");
	}
	*l = 0;
	return first;
}

/*
 *  We can't let Eintr's lose data since the program
 *  doing the read may be able to handle it.  The only
 *  places Eintr is possible is during the read's in consume.
 *  Therefore, we make sure we can always put back the bytes
 *  consumed before the last ensure.
 */
static Block*
sslbread(Chan *c, long n, ulong o)
{
	Dstate * volatile s;
	Block *b;
	uchar consumed[3], *p;
	int toconsume;
	int len, pad;

	USED(o);
	s = dstate[CONV(c-&gt;qid)];
	if(s == 0)
		panic("sslbread");
	if(s-&gt;state == Sincomplete)
		error(Ebadusefd);

	qlock(&amp;s-&gt;in.q);
	if(waserror()){
		qunlock(&amp;s-&gt;in.q);
		nexterror();
	}

	if(s-&gt;processed == 0){
		/*
		 * Read in the whole message.  Until we've got it all,
		 * it stays on s-&gt;unprocessed, so that if we get Eintr,
		 * we'll pick up where we left off.
		 */
		ensure(s, &amp;s-&gt;unprocessed, 3);
		s-&gt;unprocessed = pullupblock(s-&gt;unprocessed, 2);
		p = s-&gt;unprocessed-&gt;rp;
		if(p[0] &amp; 0x80){
			len = ((p[0] &amp; 0x7f)&lt;&lt;8) | p[1];
			ensure(s, &amp;s-&gt;unprocessed, len);
			pad = 0;
			toconsume = 2;
		} else {
			s-&gt;unprocessed = pullupblock(s-&gt;unprocessed, 3);
			len = ((p[0] &amp; 0x3f)&lt;&lt;8) | p[1];
			pad = p[2];
			if(pad &gt; len){
				print("pad %d buf len %d\n", pad, len);
				error("bad pad in ssl message");
			}
			toconsume = 3;
		}
		ensure(s, &amp;s-&gt;unprocessed, toconsume+len);

		/* skip header */
		consume(&amp;s-&gt;unprocessed, consumed, toconsume);

		/* grab the next message and decode/decrypt it */
		b = qtake(&amp;s-&gt;unprocessed, len, 0);

		if(blocklen(b) != len)
			print("devssl: sslbread got wrong count %d != %d", blocklen(b), len);

		if(waserror()){
			qunlock(&amp;s-&gt;in.ctlq);
			if(b != nil)
				freeb(b);
			nexterror();
		}
		qlock(&amp;s-&gt;in.ctlq);
		switch(s-&gt;state){
		case Sencrypting:
			if(b == nil)
				error("ssl message too short (encrypting)");
			b = decryptb(s, b);
			break;
		case Sdigesting:
			b = pullupblock(b, s-&gt;diglen);
			if(b == nil)
				error("ssl message too short (digesting)");
			checkdigestb(s, b);
			pullblock(&amp;b, s-&gt;diglen);
			len -= s-&gt;diglen;
			break;
		case Sdigenc:
			b = decryptb(s, b);
			b = pullupblock(b, s-&gt;diglen);
			if(b == nil)
				error("ssl message too short (dig+enc)");
			checkdigestb(s, b);
			pullblock(&amp;b, s-&gt;diglen);
			len -= s-&gt;diglen;
			break;
		}

		/* remove pad */
		if(pad)
			s-&gt;processed = qtake(&amp;b, len - pad, 1);
		else
			s-&gt;processed = b;
		b = nil;
		s-&gt;in.mid++;
		qunlock(&amp;s-&gt;in.ctlq);
		poperror();
	}

	/* return at most what was asked for */
	b = qtake(&amp;s-&gt;processed, n, 0);

	qunlock(&amp;s-&gt;in.q);
	poperror();

	return b;
}

static long
sslread(Chan *c, void *a, long n, vlong off)
{
	Block * volatile b;
	Block *nb;
	uchar *va;
	int i;
	char buf[128];
	ulong offset = off;
	int ft;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, a, n, 0, 0, sslgen);

	ft = TYPE(c-&gt;qid);
	switch(ft) {
	default:
		error(Ebadusefd);
	case Qctl:
		ft = CONV(c-&gt;qid);
		sprint(buf, "%d", ft);
		return readstr(offset, a, n, buf);
	case Qdata:
		b = sslbread(c, n, offset);
		break;
	case Qencalgs:
		return readstr(offset, a, n, encalgs);
		break;
	case Qhashalgs:
		return readstr(offset, a, n, hashalgs);
		break;
	}

	if(waserror()){
		freeblist(b);
		nexterror();
	}

	n = 0;
	va = a;
	for(nb = b; nb; nb = nb-&gt;next){
		i = BLEN(nb);
		memmove(va+n, nb-&gt;rp, i);
		n += i;
	}

	freeblist(b);
	poperror();

	return n;
}

/*
 *  this algorithm doesn't have to be great since we're just
 *  trying to obscure the block fill
 */
static void
randfill(uchar *buf, int len)
{
	while(len-- &gt; 0)
		*buf++ = fastrand();
}

static long
sslbwrite(Chan *c, Block *b, ulong o)
{
	Dstate * volatile s;
	long rv;

	USED(o);
	s = dstate[CONV(c-&gt;qid)];
	if(s == nil)
		panic("sslbwrite");

	if(s-&gt;state == Sincomplete){
		freeb(b);
		error(Ebadusefd);
	}

	/* lock so split writes won't interleave */
	if(waserror()){
		qunlock(&amp;s-&gt;out.q);
		nexterror();
	}
	qlock(&amp;s-&gt;out.q);

	rv = sslput(s, b);

	poperror();
	qunlock(&amp;s-&gt;out.q);

	return rv;
}

/*
 *  use SSL record format, add in count, digest and/or encrypt.
 *  the write is interruptable.  if it is interrupted, we'll
 *  get out of sync with the far side.  not much we can do about
 *  it since we don't know if any bytes have been written.
 */
static long
sslput(Dstate *s, Block * volatile b)
{
	Block *nb;
	int h, n, m, pad, rv;
	uchar *p;
	int offset;

	if(waserror()){
iprint("error: %s\n", up-&gt;errstr);
		if(b != nil)
			free(b);
		nexterror();
	}

	rv = 0;
	while(b != nil){
		m = n = BLEN(b);
		h = s-&gt;diglen + 2;

		/* trim to maximum block size */
		pad = 0;
		if(m &gt; s-&gt;max){
			m = s-&gt;max;
		} else if(s-&gt;blocklen != 1){
			pad = (m + s-&gt;diglen)%s-&gt;blocklen;
			if(pad){
				if(m &gt; s-&gt;maxpad){
					pad = 0;
					m = s-&gt;maxpad;
				} else {
					pad = s-&gt;blocklen - pad;
					h++;
				}
			}
		}

		rv += m;
		if(m != n){
			nb = allocb(m + h + pad);
			memmove(nb-&gt;wp + h, b-&gt;rp, m);
			nb-&gt;wp += m + h;
			b-&gt;rp += m;
		} else {
			/* add header space */
			nb = padblock(b, h);
			b = 0;
		}
		m += s-&gt;diglen;

		/* SSL style count */
		if(pad){
			nb = padblock(nb, -pad);
			randfill(nb-&gt;wp, pad);
			nb-&gt;wp += pad;
			m += pad;

			p = nb-&gt;rp;
			p[0] = (m&gt;&gt;8);
			p[1] = m;
			p[2] = pad;
			offset = 3;
		} else {
			p = nb-&gt;rp;
			p[0] = (m&gt;&gt;8) | 0x80;
			p[1] = m;
			offset = 2;
		}

		switch(s-&gt;state){
		case Sencrypting:
			nb = encryptb(s, nb, offset);
			break;
		case Sdigesting:
			nb = digestb(s, nb, offset);
			break;
		case Sdigenc:
			nb = digestb(s, nb, offset);
			nb = encryptb(s, nb, offset);
			break;
		}

		s-&gt;out.mid++;

		m = BLEN(nb);
		devtab[s-&gt;c-&gt;type]-&gt;bwrite(s-&gt;c, nb, s-&gt;c-&gt;offset);
		s-&gt;c-&gt;offset += m;
	}

	poperror();
	return rv;
}

static void
setsecret(OneWay *w, uchar *secret, int n)
{
	if(w-&gt;secret)
		free(w-&gt;secret);

	w-&gt;secret = smalloc(n);
	memmove(w-&gt;secret, secret, n);
	w-&gt;slen = n;
}

static void
initDESkey(OneWay *w)
{
	if(w-&gt;state){
		free(w-&gt;state);
		w-&gt;state = 0;
	}

	w-&gt;state = smalloc(sizeof(DESstate));
	if(w-&gt;slen &gt;= 16)
		setupDESstate(w-&gt;state, w-&gt;secret, w-&gt;secret+8);
	else if(w-&gt;slen &gt;= 8)
		setupDESstate(w-&gt;state, w-&gt;secret, 0);
	else
		error("secret too short");
}

/*
 *  40 bit DES is the same as 56 bit DES.  However,
 *  16 bits of the key are masked to zero.
 */
static void
initDESkey_40(OneWay *w)
{
	uchar key[8];

	if(w-&gt;state){
		free(w-&gt;state);
		w-&gt;state = 0;
	}

	if(w-&gt;slen &gt;= 8){
		memmove(key, w-&gt;secret, 8);
		key[0] &amp;= 0x0f;
		key[2] &amp;= 0x0f;
		key[4] &amp;= 0x0f;
		key[6] &amp;= 0x0f;
	}

	w-&gt;state = malloc(sizeof(DESstate));
	if(w-&gt;slen &gt;= 16)
		setupDESstate(w-&gt;state, key, w-&gt;secret+8);
	else if(w-&gt;slen &gt;= 8)
		setupDESstate(w-&gt;state, key, 0);
	else
		error("secret too short");
}

static void
initRC4key(OneWay *w)
{
	if(w-&gt;state){
		free(w-&gt;state);
		w-&gt;state = 0;
	}

	w-&gt;state = smalloc(sizeof(RC4state));
	setupRC4state(w-&gt;state, w-&gt;secret, w-&gt;slen);
}

/*
 *  40 bit RC4 is the same as n-bit RC4.  However,
 *  we ignore all but the first 40 bits of the key.
 */
static void
initRC4key_40(OneWay *w)
{
	if(w-&gt;state){
		free(w-&gt;state);
		w-&gt;state = 0;
	}

	if(w-&gt;slen &gt; 5)
		w-&gt;slen = 5;

	w-&gt;state = malloc(sizeof(RC4state));
	setupRC4state(w-&gt;state, w-&gt;secret, w-&gt;slen);
}

/*
 *  128 bit RC4 is the same as n-bit RC4.  However,
 *  we ignore all but the first 128 bits of the key.
 */
static void
initRC4key_128(OneWay *w)
{
	if(w-&gt;state){
		free(w-&gt;state);
		w-&gt;state = 0;
	}

	if(w-&gt;slen &gt; 16)
		w-&gt;slen = 16;

	w-&gt;state = malloc(sizeof(RC4state));
	setupRC4state(w-&gt;state, w-&gt;secret, w-&gt;slen);
}


typedef struct Hashalg Hashalg;
struct Hashalg
{
	char	*name;
	int	diglen;
	DigestState *(*hf)(uchar*, ulong, uchar*, DigestState*);
};

Hashalg hashtab[] =
{
	{ "md4", MD4dlen, md4, },
	{ "md5", MD5dlen, md5, },
	{ "sha1", SHA1dlen, sha1, },
	{ "sha", SHA1dlen, sha1, },
	{ 0 }
};

static int
parsehashalg(char *p, Dstate *s)
{
	Hashalg *ha;

	for(ha = hashtab; ha-&gt;name; ha++){
		if(strcmp(p, ha-&gt;name) == 0){
			s-&gt;hf = ha-&gt;hf;
			s-&gt;diglen = ha-&gt;diglen;
			s-&gt;state &amp;= ~Sclear;
			s-&gt;state |= Sdigesting;
			return 0;
		}
	}
	return -1;
}

typedef struct Encalg Encalg;
struct Encalg
{
	char	*name;
	int	blocklen;
	int	alg;
	void	(*keyinit)(OneWay*);
};

#ifdef NOSPOOKS
Encalg encrypttab[] =
{
	{ "descbc", 8, DESCBC, initDESkey, },           /* DEPRECATED -- use des_56_cbc */
	{ "desecb", 8, DESECB, initDESkey, },           /* DEPRECATED -- use des_56_ecb */
	{ "des_56_cbc", 8, DESCBC, initDESkey, },
	{ "des_56_ecb", 8, DESECB, initDESkey, },
	{ "des_40_cbc", 8, DESCBC, initDESkey_40, },
	{ "des_40_ecb", 8, DESECB, initDESkey_40, },
	{ "rc4", 1, RC4, initRC4key_40, },              /* DEPRECATED -- use rc4_X      */
	{ "rc4_256", 1, RC4, initRC4key, },
	{ "rc4_128", 1, RC4, initRC4key_128, },
	{ "rc4_40", 1, RC4, initRC4key_40, },
	{ 0 }
};
#else
Encalg encrypttab[] =
{
	{ "des_40_cbc", 8, DESCBC, initDESkey_40, },
	{ "des_40_ecb", 8, DESECB, initDESkey_40, },
	{ "rc4", 1, RC4, initRC4key_40, },              /* DEPRECATED -- use rc4_X      */
	{ "rc4_40", 1, RC4, initRC4key_40, },
	{ 0 }
};
#endif /* NOSPOOKS */

static int
parseencryptalg(char *p, Dstate *s)
{
	Encalg *ea;

	for(ea = encrypttab; ea-&gt;name; ea++){
		if(strcmp(p, ea-&gt;name) == 0){
			s-&gt;encryptalg = ea-&gt;alg;
			s-&gt;blocklen = ea-&gt;blocklen;
			(*ea-&gt;keyinit)(&amp;s-&gt;in);
			(*ea-&gt;keyinit)(&amp;s-&gt;out);
			s-&gt;state &amp;= ~Sclear;
			s-&gt;state |= Sencrypting;
			return 0;
		}
	}
	return -1;
}

static long
sslwrite(Chan *c, void *a, long n, vlong o)
{
	Dstate * volatile s;
	Block * volatile b;
	int m, t;
	char *p, *np, *e, buf[128];
	uchar *x;

	USED(o);
	s = dstate[CONV(c-&gt;qid)];
	if(s == 0)
		panic("sslwrite");

	t = TYPE(c-&gt;qid);
	if(t == Qdata){
		if(s-&gt;state == Sincomplete)
			error(Ebadusefd);

		/* lock should a write gets split over multiple records */
		if(waserror()){
			qunlock(&amp;s-&gt;out.q);
			nexterror();
		}
		qlock(&amp;s-&gt;out.q);
		p = a;
if(0) iprint("write %d %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux\n",
	n, p[0], p[1], p[2], p[3], p[4], p[5], p[6], p[7]);
		e = p + n;
		do {
			m = e - p;
			if(m &gt; s-&gt;max)
				m = s-&gt;max;

			b = allocb(m);
			if(waserror()){
				freeb(b);
				nexterror();
			}
			memmove(b-&gt;wp, p, m);
			poperror();
			b-&gt;wp += m;

			sslput(s, b);

			p += m;
		} while(p &lt; e);
		p = a;
if(0) iprint("wrote %d %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux %.2ux\n",
	n, p[0], p[1], p[2], p[3], p[4], p[5], p[6], p[7]);
		poperror();
		qunlock(&amp;s-&gt;out.q);
		return n;
	}

	/* mutex with operations using what we're about to change */
	if(waserror()){
		qunlock(&amp;s-&gt;in.ctlq);
		qunlock(&amp;s-&gt;out.q);
		nexterror();
	}
	qlock(&amp;s-&gt;in.ctlq);
	qlock(&amp;s-&gt;out.q);

	switch(t){
	default:
		panic("sslwrite");
	case Qsecretin:
		setsecret(&amp;s-&gt;in, a, n);
		goto out;
	case Qsecretout:
		setsecret(&amp;s-&gt;out, a, n);
		goto out;
	case Qctl:
		break;
	}

	if(n &gt;= sizeof(buf))
		error("arg too long");
	strncpy(buf, a, n);
	buf[n] = 0;
	p = strchr(buf, '\n');
	if(p)
		*p = 0;
	p = strchr(buf, ' ');
	if(p)
		*p++ = 0;

	if(strcmp(buf, "fd") == 0){
		s-&gt;c = buftochan(p);

		/* default is clear (msg delimiters only) */
		s-&gt;state = Sclear;
		s-&gt;blocklen = 1;
		s-&gt;diglen = 0;
		s-&gt;maxpad = s-&gt;max = (1&lt;&lt;15) - s-&gt;diglen - 1;
		s-&gt;in.mid = 0;
		s-&gt;out.mid = 0;
	} else if(strcmp(buf, "alg") == 0 &amp;&amp; p != 0){
		s-&gt;blocklen = 1;
		s-&gt;diglen = 0;

		if(s-&gt;c == 0)
			error("must set fd before algorithm");

		s-&gt;state = Sclear;
		s-&gt;maxpad = s-&gt;max = (1&lt;&lt;15) - s-&gt;diglen - 1;
		if(strcmp(p, "clear") == 0){
			goto out;
		}

		if(s-&gt;in.secret &amp;&amp; s-&gt;out.secret == 0)
			setsecret(&amp;s-&gt;out, s-&gt;in.secret, s-&gt;in.slen);
		if(s-&gt;out.secret &amp;&amp; s-&gt;in.secret == 0)
			setsecret(&amp;s-&gt;in, s-&gt;out.secret, s-&gt;out.slen);
		if(s-&gt;in.secret == 0 || s-&gt;out.secret == 0)
			error("algorithm but no secret");

		s-&gt;hf = 0;
		s-&gt;encryptalg = Noencryption;
		s-&gt;blocklen = 1;

		for(;;){
			np = strchr(p, ' ');
			if(np)
				*np++ = 0;

			if(parsehashalg(p, s) &lt; 0)
			if(parseencryptalg(p, s) &lt; 0)
				error("bad algorithm");

			if(np == 0)
				break;
			p = np;
		}

		if(s-&gt;hf == 0 &amp;&amp; s-&gt;encryptalg == Noencryption)
			error("bad algorithm");

		if(s-&gt;blocklen != 1){
			s-&gt;max = (1&lt;&lt;15) - s-&gt;diglen - 1;
			s-&gt;max -= s-&gt;max % s-&gt;blocklen;
			s-&gt;maxpad = (1&lt;&lt;14) - s-&gt;diglen - 1;
			s-&gt;maxpad -= s-&gt;maxpad % s-&gt;blocklen;
		} else
			s-&gt;maxpad = s-&gt;max = (1&lt;&lt;15) - s-&gt;diglen - 1;
	} else if(strcmp(buf, "secretin") == 0 &amp;&amp; p != 0) {
		m = (strlen(p)*3)/2;
		x = smalloc(m);
		t = dec64(x, m, p, strlen(p));
		setsecret(&amp;s-&gt;in, x, t);
		free(x);
	} else if(strcmp(buf, "secretout") == 0 &amp;&amp; p != 0) {
		m = (strlen(p)*3)/2 + 1;
		x = smalloc(m);
		t = dec64(x, m, p, strlen(p));
		setsecret(&amp;s-&gt;out, x, t);
		free(x);
	} else
		error(Ebadarg);

out:
	qunlock(&amp;s-&gt;in.ctlq);
	qunlock(&amp;s-&gt;out.q);
	poperror();
	return n;
}

static void
sslinit(void)
{
	struct Encalg *e;
	struct Hashalg *h;
	int n;
	char *cp;

	n = 1;
	for(e = encrypttab; e-&gt;name != nil; e++)
		n += strlen(e-&gt;name) + 1;
	cp = encalgs = smalloc(n);
	for(e = encrypttab;;){
		strcpy(cp, e-&gt;name);
		cp += strlen(e-&gt;name);
		e++;
		if(e-&gt;name == nil)
			break;
		*cp++ = ' ';
	}
	*cp = 0;

	n = 1;
	for(h = hashtab; h-&gt;name != nil; h++)
		n += strlen(h-&gt;name) + 1;
	cp = hashalgs = smalloc(n);
	for(h = hashtab;;){
		strcpy(cp, h-&gt;name);
		cp += strlen(h-&gt;name);
		h++;
		if(h-&gt;name == nil)
			break;
		*cp++ = ' ';
	}
	*cp = 0;
}

Dev ssldevtab = {
	'D',
	"ssl",

	devreset,
	sslinit,
	devshutdown,
	sslattach,
	sslwalk,
	sslstat,
	sslopen,
	devcreate,
	sslclose,
	sslread,
	sslbread,
	sslwrite,
	sslbwrite,
	devremove,
	sslwstat,
};

static Block*
encryptb(Dstate *s, Block *b, int offset)
{
	uchar *p, *ep, *p2, *ip, *eip;
	DESstate *ds;

	switch(s-&gt;encryptalg){
	case DESECB:
		ds = s-&gt;out.state;
		ep = b-&gt;rp + BLEN(b);
		for(p = b-&gt;rp + offset; p &lt; ep; p += 8)
			block_cipher(ds-&gt;expanded, p, 0);
		break;
	case DESCBC:
		ds = s-&gt;out.state;
		ep = b-&gt;rp + BLEN(b);
		for(p = b-&gt;rp + offset; p &lt; ep; p += 8){
			p2 = p;
			ip = ds-&gt;ivec;
			for(eip = ip+8; ip &lt; eip; )
				*p2++ ^= *ip++;
			block_cipher(ds-&gt;expanded, p, 0);
			memmove(ds-&gt;ivec, p, 8);
		}
		break;
	case RC4:
		rc4(s-&gt;out.state, b-&gt;rp + offset, BLEN(b) - offset);
		break;
	}
	return b;
}

static Block*
decryptb(Dstate *s, Block *bin)
{
	Block *b, **l;
	uchar *p, *ep, *tp, *ip, *eip;
	DESstate *ds;
	uchar tmp[8];
	int i;

	l = &amp;bin;
	for(b = bin; b; b = b-&gt;next){
		/* make sure we have a multiple of s-&gt;blocklen */
		if(s-&gt;blocklen &gt; 1){
			i = BLEN(b);
			if(i % s-&gt;blocklen){
				*l = b = pullupblock(b, i + s-&gt;blocklen - (i%s-&gt;blocklen));
				if(b == 0)
					error("ssl encrypted message too short");
			}
		}
		l = &amp;b-&gt;next;

		/* decrypt */
		switch(s-&gt;encryptalg){
		case DESECB:
			ds = s-&gt;in.state;
			ep = b-&gt;rp + BLEN(b);
			for(p = b-&gt;rp; p &lt; ep; p += 8)
				block_cipher(ds-&gt;expanded, p, 1);
			break;
		case DESCBC:
			ds = s-&gt;in.state;
			ep = b-&gt;rp + BLEN(b);
			for(p = b-&gt;rp; p &lt; ep;){
				memmove(tmp, p, 8);
				block_cipher(ds-&gt;expanded, p, 1);
				tp = tmp;
				ip = ds-&gt;ivec;
				for(eip = ip+8; ip &lt; eip; ){
					*p++ ^= *ip;
					*ip++ = *tp++;
				}
			}
			break;
		case RC4:
			rc4(s-&gt;in.state, b-&gt;rp, BLEN(b));
			break;
		}
	}
	return bin;
}

static Block*
digestb(Dstate *s, Block *b, int offset)
{
	uchar *p;
	DigestState ss;
	uchar msgid[4];
	ulong n, h;
	OneWay *w;

	w = &amp;s-&gt;out;

	memset(&amp;ss, 0, sizeof(ss));
	h = s-&gt;diglen + offset;
	n = BLEN(b) - h;

	/* hash secret + message */
	(*s-&gt;hf)(w-&gt;secret, w-&gt;slen, 0, &amp;ss);
	(*s-&gt;hf)(b-&gt;rp + h, n, 0, &amp;ss);

	/* hash message id */
	p = msgid;
	n = w-&gt;mid;
	*p++ = n&gt;&gt;24;
	*p++ = n&gt;&gt;16;
	*p++ = n&gt;&gt;8;
	*p = n;
	(*s-&gt;hf)(msgid, 4, b-&gt;rp + offset, &amp;ss);

	return b;
}

static void
checkdigestb(Dstate *s, Block *bin)
{
	uchar *p;
	DigestState ss;
	uchar msgid[4];
	int n, h;
	OneWay *w;
	uchar digest[128];
	Block *b;

	w = &amp;s-&gt;in;

	memset(&amp;ss, 0, sizeof(ss));

	/* hash secret */
	(*s-&gt;hf)(w-&gt;secret, w-&gt;slen, 0, &amp;ss);

	/* hash message */
	h = s-&gt;diglen;
	for(b = bin; b; b = b-&gt;next){
		n = BLEN(b) - h;
		if(n &lt; 0)
			panic("checkdigestb");
		(*s-&gt;hf)(b-&gt;rp + h, n, 0, &amp;ss);
		h = 0;
	}

	/* hash message id */
	p = msgid;
	n = w-&gt;mid;
	*p++ = n&gt;&gt;24;
	*p++ = n&gt;&gt;16;
	*p++ = n&gt;&gt;8;
	*p = n;
	(*s-&gt;hf)(msgid, 4, digest, &amp;ss);

	if(memcmp(digest, bin-&gt;rp, s-&gt;diglen) != 0)
		error("bad digest");
}

/* get channel associated with an fd */
static Chan*
buftochan(char *p)
{
	Chan *c;
	int fd;

	if(p == 0)
		error(Ebadarg);
	fd = strtoul(p, 0, 0);
	if(fd &lt; 0)
		error(Ebadarg);
	c = fdtochan(fd, -1, 0, 1);	/* error check and inc ref */
	if(devtab[c-&gt;type] == &amp;ssldevtab){
		cclose(c);
		error("cannot ssl encrypt devssl files");
	}
	return c;
}

/* hand up a digest connection */
static void
sslhangup(Dstate *s)
{
	Block *b;

	qlock(&amp;s-&gt;in.q);
	for(b = s-&gt;processed; b; b = s-&gt;processed){
		s-&gt;processed = b-&gt;next;
		freeb(b);
	}
	if(s-&gt;unprocessed){
		freeb(s-&gt;unprocessed);
		s-&gt;unprocessed = 0;
	}
	s-&gt;state = Sincomplete;
	qunlock(&amp;s-&gt;in.q);
}

static Dstate*
dsclone(Chan *ch)
{
	int i;
	Dstate *ret;

	if(waserror()) {
		unlock(&amp;dslock);
		nexterror();
	}
	lock(&amp;dslock);
	ret = nil;
	for(i=0; i&lt;Maxdstate; i++){
		if(dstate[i] == nil){
			dsnew(ch, &amp;dstate[i]);
			ret = dstate[i];
			break;
		}
	}
	unlock(&amp;dslock);
	poperror();
	return ret;
}

static void
dsnew(Chan *ch, Dstate **pp)
{
	Dstate *s;
	int t;

	*pp = s = malloc(sizeof(*s));
	if(!s)
		error(Enomem);
	if(pp - dstate &gt;= dshiwat)
		dshiwat++;
	memset(s, 0, sizeof(*s));
	s-&gt;state = Sincomplete;
	s-&gt;ref = 1;
	kstrdup(&amp;s-&gt;user, up-&gt;user);
	s-&gt;perm = 0660;
	t = TYPE(ch-&gt;qid);
	if(t == Qclonus)
		t = Qctl;
	ch-&gt;qid.path = QID(pp - dstate, t);
	ch-&gt;qid.vers = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

