<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/exportfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/exportfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

typedef	struct Fid	Fid;
typedef	struct Export	Export;
typedef	struct Exq	Exq;

#define	nil	((void*)0)

enum
{
	Nfidhash	= 1,
	MAXRPC		= MAXMSG+MAXFDATA,
	MAXDIRREAD	= (MAXFDATA/DIRLEN)*DIRLEN
};

struct Export
{
	Ref	r;
	Exq*	work;
	Lock	fidlock;
	Fid*	fid[Nfidhash];
	Chan*	root;
	Chan*	io;
	Pgrp*	pgrp;
	int	npart;
	char	part[MAXRPC];
};

struct Fid
{
	Fid*	next;
	Fid**	last;
	Chan*	chan;
	long	offset;
	int	fid;
	int	ref;		/* fcalls using the fid; locked by Export.Lock */
	int	attached;	/* fid attached or cloned but not clunked */
};

struct Exq
{
	Lock	lk;
	int	nointr;
	int	noresponse;	/* don't respond to this one */
	Exq*	next;
	int	shut;		/* has been noted for shutdown */
	Export*	export;
	void*	slave;
	Fcall	rpc;
	char	buf[MAXRPC];
};

struct
{
	Lock	l;
	Qlock	qwait;
	Rendez	rwait;
	Exq	*head;		/* work waiting for a slave */
	Exq	*tail;
}exq;

static void	exshutdown(Export*);
static void	exflush(Export*, int, int);
static void	exslave(void*);
static void	exfree(Export*);
static void	exportproc(Export*);

static char*	Exauth(Export*, Fcall*);
static char*	Exattach(Export*, Fcall*);
static char*	Exclunk(Export*, Fcall*);
static char*	Excreate(Export*, Fcall*);
static char*	Exopen(Export*, Fcall*);
static char*	Exread(Export*, Fcall*);
static char*	Exremove(Export*, Fcall*);
static char*	Exstat(Export*, Fcall*);
static char*	Exwalk(Export*, Fcall*);
static char*	Exwrite(Export*, Fcall*);
static char*	Exwstat(Export*, Fcall*);
static char*	Exversion(Export*, Fcall*);

static char	*(*fcalls[Tmax])(Export*, Fcall*);

static char	Enofid[]   = "no such fid";
static char	Eseekdir[] = "can't seek on a directory";
static char	Ereaddir[] = "unaligned read of a directory";
static int	exdebug = 0;

int
sysexport(int fd)
{
	Chan *c;
	Export *fs;

	if(waserror())
		return -1;

	c = fdtochan(fd, ORDWR, 1, 1);
	poperror();
	c-&gt;flag |= CMSG;

	fs = mallocz(sizeof(Export));
	fs-&gt;r.ref = 1;
	fs-&gt;pgrp = up-&gt;pgrp;
	refinc(&amp;fs-&gt;pgrp-&gt;r);
	refinc(&amp;up-&gt;slash-&gt;r);
	fs-&gt;root = up-&gt;slash;
	refinc(&amp;fs-&gt;root-&gt;r);
	fs-&gt;root = domount(fs-&gt;root);
	fs-&gt;io = c;

	exportproc(fs);

	return 0;
}

static void
exportinit(void)
{
	lock(&amp;exq.l);
	if(fcalls[Tversion] != nil) {
		unlock(&amp;exq.l);
		return;
	}

	fmtinstall('F', fcallfmt);
	fmtinstall('D', dirfmt);
	fmtinstall('M', dirmodefmt);
	fcalls[Tversion] = Exversion;
	fcalls[Tauth] = Exauth;
	fcalls[Tattach] = Exattach;
	fcalls[Twalk] = Exwalk;
	fcalls[Topen] = Exopen;
	fcalls[Tcreate] = Excreate;
	fcalls[Tread] = Exread;
	fcalls[Twrite] = Exwrite;
	fcalls[Tclunk] = Exclunk;
	fcalls[Tremove] = Exremove;
	fcalls[Tstat] = Exstat;
	fcalls[Twstat] = Exwstat;
	unlock(&amp;exq.l);
}

void
exportproc(Export *fs)
{
	Exq *q;
	char *buf;
	int n, cn, len;

	exportinit();

	for(;;){
		q = mallocz(sizeof(Exq));
		if(q == 0)
			panic("no memory");

		q-&gt;rpc.data = q-&gt;buf + MAXMSG;

		buf = q-&gt;buf;
		len = MAXRPC;
		if(fs-&gt;npart) {
			memmove(buf, fs-&gt;part, fs-&gt;npart);
			buf += fs-&gt;npart;
			len -= fs-&gt;npart;
			goto chk;
		}
		for(;;) {
			if(waserror())
				goto bad;

			n = (*devtab[fs-&gt;io-&gt;type].read)(fs-&gt;io, buf, len, 0);
			poperror();

			if(n &lt;= 0)
				goto bad;

			buf += n;
			len -= n;
	chk:
			n = buf - q-&gt;buf;

			/* convM2S returns size of correctly decoded message */
			cn = convM2S(q-&gt;buf, &amp;q-&gt;rpc, n);
			if(cn &lt; 0){
				iprint("bad message type in devmnt\n");
				goto bad;
			}
			if(cn &gt; 0) {
				n -= cn;
				if(n &lt; 0){
					iprint("negative size in devmnt");
					goto bad;
				}
				fs-&gt;npart = n;
				if(n != 0)
					memmove(fs-&gt;part, q-&gt;buf+cn, n);
				break;
			}
		}
		if(exdebug)
			iprint("export %d &lt;- %F\n", getpid(), &amp;q-&gt;rpc);

		if(q-&gt;rpc.type == Tflush){
			exflush(fs, q-&gt;rpc.tag, q-&gt;rpc.oldtag);
			free(q);
			continue;
		}

		q-&gt;export = fs;
		refinc(&amp;fs-&gt;r);

		lock(&amp;exq.l);
		if(exq.head == nil)
			exq.head = q;
		else
			exq.tail-&gt;next = q;
		q-&gt;next = nil;
		exq.tail = q;
		unlock(&amp;exq.l);
		if(exq.qwait.first == nil) {
			n = thread("exportfs", exslave, nil);
/* iprint("launch export (pid=%ux)\n", n); */
		}
		rendwakeup(&amp;exq.rwait);
	}
bad:
	free(q);
	exshutdown(fs);
	exfree(fs);
}

void
exflush(Export *fs, int flushtag, int tag)
{
	Exq *q, **last;
	int n;
	Fcall fc;
	char buf[MAXMSG];

	/* hasn't been started? */
	lock(&amp;exq.l);
	last = &amp;exq.head;
	for(q = exq.head; q != nil; q = q-&gt;next){
		if(q-&gt;export == fs &amp;&amp; q-&gt;rpc.tag == tag){
			*last = q-&gt;next;
			unlock(&amp;exq.l);
			exfree(fs);
			free(q);
			goto Respond;
		}
		last = &amp;q-&gt;next;
	}
	unlock(&amp;exq.l);

	/* in progress? */
	lock(&amp;fs-&gt;r.l);
	for(q = fs-&gt;work; q != nil; q = q-&gt;next){
		if(q-&gt;rpc.tag == tag &amp;&amp; !q-&gt;noresponse){
			lock(&amp;q-&gt;lk);
			q-&gt;noresponse = 1;
			if(!q-&gt;nointr)
				intr(q-&gt;slave);
			unlock(&amp;q-&gt;lk);
			unlock(&amp;fs-&gt;r.l);
			goto Respond;
			return;
		}
	}
	unlock(&amp;fs-&gt;r.l);

if(exdebug) iprint("exflush: did not find rpc: %d\n", tag);

Respond:
	fc.type = Rflush;
	fc.tag = flushtag;
	n = convS2M(&amp;fc, buf);
if(exdebug) iprint("exflush -&gt; %F\n", &amp;fc);
	if(!waserror()){
		(*devtab[fs-&gt;io-&gt;type].write)(fs-&gt;io, buf, n, 0);
		poperror();
	}
}

void
exshutdown(Export *fs)
{
	Exq *q, **last;

	lock(&amp;exq.l);
	last = &amp;exq.head;
	for(q = exq.head; q != nil; q = *last){
		if(q-&gt;export == fs){
			*last = q-&gt;next;
			exfree(fs);
			free(q);
			continue;
		}
		last = &amp;q-&gt;next;
	}
	unlock(&amp;exq.l);

	lock(&amp;fs-&gt;r.l);
	q = fs-&gt;work;
	while(q != nil){
		if(q-&gt;shut){
			q = q-&gt;next;
			continue;
		}
		q-&gt;shut = 1;
		unlock(&amp;fs-&gt;r.l);
	/*	postnote(q-&gt;slave, 1, "interrupted", NUser);	*/
		iprint("postnote 2!\n");
		lock(&amp;fs-&gt;r.l);
		q = fs-&gt;work;
	}
	unlock(&amp;fs-&gt;r.l);
}

void
exfree(Export *fs)
{
	Fid *f, *n;
	int i;

	if(refdec(&amp;fs-&gt;r) != 0)
		return;
	closepgrp(fs-&gt;pgrp);
	cclose(fs-&gt;root);
	cclose(fs-&gt;io);
	for(i = 0; i &lt; Nfidhash; i++){
		for(f = fs-&gt;fid[i]; f != nil; f = n){
			if(f-&gt;chan != nil)
				cclose(f-&gt;chan);
			n = f-&gt;next;
			free(f);
		}
	}
	free(fs);
}

int
exwork(void *a)
{
	return exq.head != nil;
}

void
exslave(void *a)
{
	Export *fs;
	Exq *q, *t, **last;
	char *err;
	int n;
/*
	closepgrp(up-&gt;pgrp);
	up-&gt;pgrp = nil;
*/
	for(;;){
		qlock(&amp;exq.qwait);
		rendsleep(&amp;exq.rwait, exwork, nil);

		lock(&amp;exq.l);
		q = exq.head;
		if(q == nil) {
			unlock(&amp;exq.l);
			qunlock(&amp;exq.qwait);
			continue;
		}
		exq.head = q-&gt;next;
		q-&gt;slave = curthread();
		unlock(&amp;exq.l);

		qunlock(&amp;exq.qwait);

		q-&gt;noresponse = 0;
		q-&gt;nointr = 0;
		fs = q-&gt;export;
		lock(&amp;fs-&gt;r.l);
		q-&gt;next = fs-&gt;work;
		fs-&gt;work = q;
		unlock(&amp;fs-&gt;r.l);

		up-&gt;pgrp = q-&gt;export-&gt;pgrp;

		if(exdebug &gt; 1)
			iprint("exslave dispatch %d %F\n", getpid(), &amp;q-&gt;rpc);

		if(waserror()){
			iprint("exslave err %r\n");
			err = up-&gt;errstr;
			goto Err;
		}
		if(q-&gt;rpc.type &gt;= Tmax || !fcalls[q-&gt;rpc.type])
			err = "bad fcall type";
		else
			err = (*fcalls[q-&gt;rpc.type])(fs, &amp;q-&gt;rpc);

		poperror();
		Err:;
		q-&gt;rpc.type++;
		if(err){
			q-&gt;rpc.type = Rerror;
			strncpy(q-&gt;rpc.ename, err, ERRLEN);
		}
		n = convS2M(&amp;q-&gt;rpc, q-&gt;buf);

		if(exdebug)
			iprint("exslve %d -&gt; %F\n", getpid(), &amp;q-&gt;rpc);

		lock(&amp;q-&gt;lk);
		if(q-&gt;noresponse == 0){
			q-&gt;nointr = 1;
			clearintr();
			if(!waserror()){
				(*devtab[fs-&gt;io-&gt;type].write)(fs-&gt;io, q-&gt;buf, n, 0);
				poperror();
			}
		}
		unlock(&amp;q-&gt;lk);

		/*
		 * exflush might set noresponse at this point, but
		 * setting noresponse means don't send a response now;
		 * it's okay that we sent a response already.
		 */
		if(exdebug &gt; 1)
			iprint("exslave %d written %d\n", getpid(), q-&gt;rpc.tag);

		lock(&amp;fs-&gt;r.l);
		last = &amp;fs-&gt;work;
		for(t = fs-&gt;work; t != nil; t = t-&gt;next){
			if(t == q){
				*last = q-&gt;next;
				break;
			}
			last = &amp;t-&gt;next;
		}
		unlock(&amp;fs-&gt;r.l);

		exfree(q-&gt;export);
		free(q);
	}
	iprint("exslave shut down");
	threadexit();
}

Fid*
Exmkfid(Export *fs, int fid)
{
	ulong h;
	Fid *f, *nf;

	nf = mallocz(sizeof(Fid));
	if(nf == nil)
		return nil;
	lock(&amp;fs-&gt;fidlock);
	h = fid % Nfidhash;
	for(f = fs-&gt;fid[h]; f != nil; f = f-&gt;next){
		if(f-&gt;fid == fid){
			unlock(&amp;fs-&gt;fidlock);
			free(nf);
			return nil;
		}
	}

	nf-&gt;next = fs-&gt;fid[h];
	if(nf-&gt;next != nil)
		nf-&gt;next-&gt;last = &amp;nf-&gt;next;
	nf-&gt;last = &amp;fs-&gt;fid[h];
	fs-&gt;fid[h] = nf;

	nf-&gt;fid = fid;
	nf-&gt;ref = 1;
	nf-&gt;attached = 1;
	nf-&gt;offset = 0;
	nf-&gt;chan = nil;
	unlock(&amp;fs-&gt;fidlock);
	return nf;
}

Fid*
Exgetfid(Export *fs, int fid)
{
	Fid *f;
	ulong h;

	lock(&amp;fs-&gt;fidlock);
	h = fid % Nfidhash;
	for(f = fs-&gt;fid[h]; f; f = f-&gt;next) {
		if(f-&gt;fid == fid){
			if(f-&gt;attached == 0)
				break;
			f-&gt;ref++;
			unlock(&amp;fs-&gt;fidlock);
			return f;
		}
	}
	unlock(&amp;fs-&gt;fidlock);
	return nil;
}

void
Exputfid(Export *fs, Fid *f)
{
	lock(&amp;fs-&gt;fidlock);
	f-&gt;ref--;
	if(f-&gt;ref == 0 &amp;&amp; f-&gt;attached == 0){
		if(f-&gt;chan != nil)
			cclose(f-&gt;chan);
		f-&gt;chan = nil;
		*f-&gt;last = f-&gt;next;
		if(f-&gt;next != nil)
			f-&gt;next-&gt;last = f-&gt;last;
		unlock(&amp;fs-&gt;fidlock);
		free(f);
		return;
	}
	unlock(&amp;fs-&gt;fidlock);
}

char*
Exsession(Export *e, Fcall *rpc)
{
	memset(rpc-&gt;authid, 0, sizeof(rpc-&gt;authid));
	memset(rpc-&gt;authdom, 0, sizeof(rpc-&gt;authdom));
	memset(rpc-&gt;chal, 0, sizeof(rpc-&gt;chal));
	return nil;
}

char*
Exauth(Export *e, Fcall *f)
{
	return "authentication not required";
}

char*
Exattach(Export *fs, Fcall *rpc)
{
	Fid *f;

	f = Exmkfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Einuse;
	if(waserror()){
		f-&gt;attached = 0;
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	f-&gt;chan = clone(fs-&gt;root, nil);
	poperror();
	rpc-&gt;qid = f-&gt;chan-&gt;qid;
	Exputfid(fs, f);
	return nil;
}

char*
Exclone(Export *fs, Fcall *rpc)
{
	Fid *f, *nf;

	if(rpc-&gt;fid == rpc-&gt;newfid)
		return Einuse;
	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	nf = Exmkfid(fs, rpc-&gt;newfid);
	if(nf == nil){
		Exputfid(fs, f);
		return Einuse;
	}
	if(waserror()){
		Exputfid(fs, f);
		Exputfid(fs, nf);
		return up-&gt;errstr;
	}
	nf-&gt;chan = clone(f-&gt;chan, nil);
	poperror();
	Exputfid(fs, f);
	Exputfid(fs, nf);
	return nil;
}

char*
Exclunk(Export *fs, Fcall *rpc)
{
	Fid *f;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f != nil){
		f-&gt;attached = 0;
		Exputfid(fs, f);
	}
	return nil;
}

char*
Exwalk(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = walk(f-&gt;chan, rpc-&gt;name, 1);
	if(c == nil)
		error(Enonexist);
	poperror();

	f-&gt;chan = c;
	rpc-&gt;qid = c-&gt;qid;
	Exputfid(fs, f);
	return nil;
}

char*
Exopen(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = f-&gt;chan;
	c = (*devtab[c-&gt;type].open)(c, rpc-&gt;mode);
	poperror();

	f-&gt;chan = c;
	f-&gt;offset = 0;
	rpc-&gt;qid = f-&gt;chan-&gt;qid;
	Exputfid(fs, f);
	return nil;
}

char*
Excreate(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = f-&gt;chan;
	if(c-&gt;mnt &amp;&amp; !(c-&gt;flag&amp;CCREATE))
		c = createdir(c);
	(*devtab[c-&gt;type].create)(c, rpc-&gt;name, rpc-&gt;mode, rpc-&gt;perm);
	poperror();

	f-&gt;chan = c;
	rpc-&gt;qid = f-&gt;chan-&gt;qid;
	Exputfid(fs, f);
	return nil;
}

char*
Exread(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;
	long off;
	int dir, n, seek;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;

	c = f-&gt;chan;
	dir = c-&gt;qid.path &amp; CHDIR;
	if(dir){
		rpc-&gt;count -= rpc-&gt;count%DIRLEN;
		if(rpc-&gt;offset%DIRLEN || rpc-&gt;count==0){
			Exputfid(fs, f);
			return Ereaddir;
		}
		if(f-&gt;offset &gt; rpc-&gt;offset){
			Exputfid(fs, f);
			return Eseekdir;
		}
	}

	if(waserror()) {
		Exputfid(fs, f);
		return up-&gt;errstr;
	}

	for(;;){
		n = rpc-&gt;count;
		seek = 0;
		off = rpc-&gt;offset;
		if(dir &amp;&amp; f-&gt;offset != off){
			off = f-&gt;offset;
			n = rpc-&gt;offset - off;
			if(n &gt; MAXDIRREAD)
				n = MAXDIRREAD;
			seek = 1;
		}
		if(dir &amp;&amp; c-&gt;mnt != nil)
			n = unionread(c, rpc-&gt;data, n);
		else{
			c-&gt;offset = off;
			n = (*devtab[c-&gt;type].read)(c, rpc-&gt;data, n, off);
		}
		if(n == 0 || !seek)
			break;
		f-&gt;offset = off + n;
		c-&gt;offset += n;
	}
	rpc-&gt;count = n;
	poperror();
	Exputfid(fs, f);
	return nil;
}

char*
Exwrite(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = f-&gt;chan;
	if(c-&gt;qid.path &amp; CHDIR)
		error(Eisdir);
	rpc-&gt;count = (*devtab[c-&gt;type].write)(c, rpc-&gt;data, rpc-&gt;count, rpc-&gt;offset);
	poperror();
	Exputfid(fs, f);
	return nil;
}

char*
Exstat(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = f-&gt;chan;
	(*devtab[c-&gt;type].stat)(c, rpc-&gt;stat);
	poperror();
	Exputfid(fs, f);
	return nil;
}

char*
Exwstat(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = f-&gt;chan;
	(*devtab[c-&gt;type].wstat)(c, rpc-&gt;stat);
	poperror();
	Exputfid(fs, f);
	return nil;
}

char*
Exremove(Export *fs, Fcall *rpc)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;errstr;
	}
	c = f-&gt;chan;
	(*devtab[c-&gt;type].remove)(c);
	poperror();

	/*
	 * chan is already clunked by remove.
	 * however, we need to recover the chan,
	 * and follow sysremove's lead in making to point to root.
	 */
	c-&gt;type = 0;

	f-&gt;attached = 0;
	Exputfid(fs, f);
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

