<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/libc/dofmt.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/libc/dofmt.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "fmtdef.h"

/* format the output into f-&gt;to and return the number of characters fmted  */
int
dofmt(Fmt *f, char *fmt)
{
	Rune rune, *rt, *rs;
	int r;
	char *t, *s;
	int n, nfmt;

	nfmt = f-&gt;nfmt;
	for(;;){
		if(f-&gt;runes){
			rt = (Rune*)f-&gt;to;
			rs = (Rune*)f-&gt;stop;
			while((r = *(uchar*)fmt) &amp;&amp; r != '%'){
				if(r &lt; Runeself)
					fmt++;
				else{
					fmt += chartorune(&amp;rune, fmt);
					r = rune;
				}
				FMTRCHAR(f, rt, rs, r);
			}
			fmt++;
			f-&gt;nfmt += rt - (Rune *)f-&gt;to;
			f-&gt;to = rt;
			if(!r)
				return f-&gt;nfmt - nfmt;
			f-&gt;stop = rs;
		}else{
			t = (char*)f-&gt;to;
			s = (char*)f-&gt;stop;
			while((r = *(uchar*)fmt) &amp;&amp; r != '%'){
				if(r &lt; Runeself){
					FMTCHAR(f, t, s, r);
					fmt++;
				}else{
					n = chartorune(&amp;rune, fmt);
					if(t + n &gt; s){
						t = (char*)__fmtflush(f, t, n);
						if(t != nil)
							s = (char*)f-&gt;stop;
						else
							return -1;
					}
					while(n--)
						*t++ = *fmt++;
				}
			}
			fmt++;
			f-&gt;nfmt += t - (char *)f-&gt;to;
			f-&gt;to = t;
			if(!r)
				return f-&gt;nfmt - nfmt;
			f-&gt;stop = s;
		}

		fmt = (char*)__fmtdispatch(f, fmt, 0);
		if(fmt == nil)
			return -1;
	}
}

void *
__fmtflush(Fmt *f, void *t, int len)
{
	if(f-&gt;runes)
		f-&gt;nfmt += (Rune*)t - (Rune*)f-&gt;to;
	else
		f-&gt;nfmt += (char*)t - (char *)f-&gt;to;
	f-&gt;to = t;
	if(f-&gt;flush == 0 || (*f-&gt;flush)(f) == 0 || (char*)f-&gt;to + len &gt; (char*)f-&gt;stop){
		f-&gt;stop = f-&gt;to;
		return nil;
	}
	return f-&gt;to;
}

/*
 * put a formatted block of memory sz bytes long of n runes into the output buffer,
 * left/right justified in a field of at least f-&gt;width charactes
 */
int
__fmtpad(Fmt *f, int n)
{
	char *t, *s;
	int i;

	t = (char*)f-&gt;to;
	s = (char*)f-&gt;stop;
	for(i = 0; i &lt; n; i++)
		FMTCHAR(f, t, s, ' ');
	f-&gt;nfmt += t - (char *)f-&gt;to;
	f-&gt;to = t;
	return 0;
}

int
__rfmtpad(Fmt *f, int n)
{
	Rune *t, *s;
	int i;

	t = (Rune*)f-&gt;to;
	s = (Rune*)f-&gt;stop;
	for(i = 0; i &lt; n; i++)
		FMTRCHAR(f, t, s, ' ');
	f-&gt;nfmt += t - (Rune *)f-&gt;to;
	f-&gt;to = t;
	return 0;
}

int
__fmtcpy(Fmt *f, const void *vm, int n, int sz)
{
	Rune *rt, *rs, r;
	char *t, *s, *m, *me;
	ulong fl;
	int nc, w;

	m = (char*)vm;
	me = m + sz;
	w = f-&gt;width;
	fl = f-&gt;flags;
	if((fl &amp; FmtPrec) &amp;&amp; n &gt; f-&gt;prec)
		n = f-&gt;prec;
	if(f-&gt;runes){
		if(!(fl &amp; FmtLeft) &amp;&amp; __rfmtpad(f, w - n) &lt; 0)
			return -1;
		rt = (Rune*)f-&gt;to;
		rs = (Rune*)f-&gt;stop;
		for(nc = n; nc &gt; 0; nc--){
			r = *(uchar*)m;
			if(r &lt; Runeself)
				m++;
			else if((me - m) &gt;= UTFmax || fullrune(m, me-m))
				m += chartorune(&amp;r, m);
			else
				break;
			FMTRCHAR(f, rt, rs, r);
		}
		f-&gt;nfmt += rt - (Rune *)f-&gt;to;
		f-&gt;to = rt;
		if(fl &amp; FmtLeft &amp;&amp; __rfmtpad(f, w - n) &lt; 0)
			return -1;
	}else{
		if(!(fl &amp; FmtLeft) &amp;&amp; __fmtpad(f, w - n) &lt; 0)
			return -1;
		t = (char*)f-&gt;to;
		s = (char*)f-&gt;stop;
		for(nc = n; nc &gt; 0; nc--){
			r = *(uchar*)m;
			if(r &lt; Runeself)
				m++;
			else if((me - m) &gt;= UTFmax || fullrune(m, me-m))
				m += chartorune(&amp;r, m);
			else
				break;
			FMTRUNE(f, t, s, r);
		}
		f-&gt;nfmt += t - (char *)f-&gt;to;
		f-&gt;to = t;
		if(fl &amp; FmtLeft &amp;&amp; __fmtpad(f, w - n) &lt; 0)
			return -1;
	}
	return 0;
}

int
__fmtrcpy(Fmt *f, const void *vm, int n)
{
	Rune r, *m, *me, *rt, *rs;
	char *t, *s;
	ulong fl;
	int w;

	m = (Rune*)vm;
	w = f-&gt;width;
	fl = f-&gt;flags;
	if((fl &amp; FmtPrec) &amp;&amp; n &gt; f-&gt;prec)
		n = f-&gt;prec;
	if(f-&gt;runes){
		if(!(fl &amp; FmtLeft) &amp;&amp; __rfmtpad(f, w - n) &lt; 0)
			return -1;
		rt = (Rune*)f-&gt;to;
		rs = (Rune*)f-&gt;stop;
		for(me = m + n; m &lt; me; m++)
			FMTRCHAR(f, rt, rs, *m);
		f-&gt;nfmt += rt - (Rune *)f-&gt;to;
		f-&gt;to = rt;
		if(fl &amp; FmtLeft &amp;&amp; __rfmtpad(f, w - n) &lt; 0)
			return -1;
	}else{
		if(!(fl &amp; FmtLeft) &amp;&amp; __fmtpad(f, w - n) &lt; 0)
			return -1;
		t = (char*)f-&gt;to;
		s = (char*)f-&gt;stop;
		for(me = m + n; m &lt; me; m++){
			r = *m;
			FMTRUNE(f, t, s, r);
		}
		f-&gt;nfmt += t - (char *)f-&gt;to;
		f-&gt;to = t;
		if(fl &amp; FmtLeft &amp;&amp; __fmtpad(f, w - n) &lt; 0)
			return -1;
	}
	return 0;
}

/* fmt out one character */
int
__charfmt(Fmt *f)
{
	char x[1];

	x[0] = va_arg(f-&gt;args, int);
	f-&gt;prec = 1;
	return __fmtcpy(f, (const char*)x, 1, 1);
}

/* fmt out one rune */
int
__runefmt(Fmt *f)
{
	Rune x[1];

	x[0] = va_arg(f-&gt;args, int);
	return __fmtrcpy(f, (const void*)x, 1);
}

/* public helper routine: fmt out a null terminated string already in hand */
int
fmtstrcpy(Fmt *f, char *s)
{
	int i, j;
	Rune r;

	if(!s)
		return __fmtcpy(f, "&lt;nil&gt;", 5, 5);
	/* if precision is specified, make sure we don't wander off the end */
	if(f-&gt;flags &amp; FmtPrec){
		i = 0;
		for(j=0; j&lt;f-&gt;prec &amp;&amp; s[i]; j++)
			i += chartorune(&amp;r, s+i);
		return __fmtcpy(f, s, j, i);
	}
	return __fmtcpy(f, s, utflen(s), strlen(s));
}

/* fmt out a null terminated utf string */
int
__strfmt(Fmt *f)
{
	char *s;

	s = va_arg(f-&gt;args, char *);
	return fmtstrcpy(f, s);
}

/* public helper routine: fmt out a null terminated rune string already in hand */
int
fmtrunestrcpy(Fmt *f, Rune *s)
{
	Rune *e;
	int n, p;

	if(!s)
		return __fmtcpy(f, "&lt;nil&gt;", 5, 5);
	/* if precision is specified, make sure we don't wander off the end */
	if(f-&gt;flags &amp; FmtPrec){
		p = f-&gt;prec;
		for(n = 0; n &lt; p; n++)
			if(s[n] == 0)
				break;
	}else{
		for(e = s; *e; e++)
			;
		n = e - s;
	}
	return __fmtrcpy(f, s, n);
}

/* fmt out a null terminated rune string */
int
__runesfmt(Fmt *f)
{
	Rune *s;

	s = va_arg(f-&gt;args, Rune *);
	return fmtrunestrcpy(f, s);
}

/* fmt a % */
int
__percentfmt(Fmt *f)
{
	Rune x[1];

	x[0] = f-&gt;r;
	f-&gt;prec = 1;
	return __fmtrcpy(f, (const void*)x, 1);
}

/* fmt an integer */
int
__ifmt(Fmt *f)
{
	char buf[70], *p, *conv;
	uvlong vu;
	ulong u;
	int neg, base, i, n, fl, w, isv;

	neg = 0;
	fl = f-&gt;flags;
	isv = 0;
	vu = 0;
	u = 0;
	/*
	 * Unsigned verbs for ANSI C
	 */
	switch(f-&gt;r){
	case 'x':
	case 'X':
	case 'o':
	case 'u':
	case 'p':
		fl |= FmtUnsigned;
		fl &amp;= ~(FmtSign|FmtSpace);
		break;
	}
	if(f-&gt;r == 'p'){
		if(sizeof(void*) == sizeof(uvlong)){
			isv = 1;
			vu = (uvlong)va_arg(f-&gt;args, uvlong);
		}else
			u = (ulong)va_arg(f-&gt;args, ulong);
		f-&gt;r = 'x';
		fl |= FmtUnsigned;
	}else if(fl &amp; FmtVLong){
		isv = 1;
		if(fl &amp; FmtUnsigned)
			vu = va_arg(f-&gt;args, uvlong);
		else
			vu = va_arg(f-&gt;args, vlong);
	}else if(fl &amp; FmtLong){
		if(fl &amp; FmtUnsigned)
			u = va_arg(f-&gt;args, ulong);
		else
			u = va_arg(f-&gt;args, long);
	}else if(fl &amp; FmtByte){
		if(fl &amp; FmtUnsigned)
			u = (uchar)va_arg(f-&gt;args, int);
		else
			u = (char)va_arg(f-&gt;args, int);
	}else if(fl &amp; FmtShort){
		if(fl &amp; FmtUnsigned)
			u = (ushort)va_arg(f-&gt;args, int);
		else
			u = (short)va_arg(f-&gt;args, int);
	}else{
		if(fl &amp; FmtUnsigned)
			u = va_arg(f-&gt;args, uint);
		else
			u = va_arg(f-&gt;args, int);
	}
	conv = "0123456789abcdef";
	switch(f-&gt;r){
	case 'd':
	case 'i':
	case 'u':
		base = 10;
		break;
	case 'x':
		base = 16;
		break;
	case 'X':
		base = 16;
		conv = "0123456789ABCDEF";
		break;
	case 'b':
		base = 2;
		break;
	case 'o':
		base = 8;
		break;
	default:
		return -1;
	}
	if(!(fl &amp; FmtUnsigned)){
		if(isv &amp;&amp; (vlong)vu &lt; 0){
			vu = -(vlong)vu;
			neg = 1;
		}else if(!isv &amp;&amp; (long)u &lt; 0){
			u = -(long)u;
			neg = 1;
		}
	}
	p = buf + sizeof buf - 1;
	n = 0;
	if(isv){
		while(vu){
			i = vu % base;
			vu /= base;
			if((fl &amp; FmtComma) &amp;&amp; n % 4 == 3){
				*p-- = ',';
				n++;
			}
			*p-- = conv[i];
			n++;
		}
	}else{
		while(u){
			i = u % base;
			u /= base;
			if((fl &amp; FmtComma) &amp;&amp; n % 4 == 3){
				*p-- = ',';
				n++;
			}
			*p-- = conv[i];
			n++;
		}
	}
	if(n == 0){
		*p-- = '0';
		n = 1;
	}
	for(w = f-&gt;prec; n &lt; w &amp;&amp; p &gt; buf+3; n++)
		*p-- = '0';
	if(neg || (fl &amp; (FmtSign|FmtSpace)))
		n++;
	if(fl &amp; FmtSharp){
		if(base == 16)
			n += 2;
		else if(base == 8){
			if(p[1] == '0')
				fl &amp;= ~FmtSharp;
			else
				n++;
		}
	}
	if((fl &amp; FmtZero) &amp;&amp; !(fl &amp; (FmtLeft|FmtPrec))){
		for(w = f-&gt;width; n &lt; w &amp;&amp; p &gt; buf+3; n++)
			*p-- = '0';
		f-&gt;width = 0;
	}
	if(fl &amp; FmtSharp){
		if(base == 16)
			*p-- = f-&gt;r;
		if(base == 16 || base == 8)
			*p-- = '0';
	}
	if(neg)
		*p-- = '-';
	else if(fl &amp; FmtSign)
		*p-- = '+';
	else if(fl &amp; FmtSpace)
		*p-- = ' ';
	f-&gt;flags &amp;= ~FmtPrec;
	return __fmtcpy(f, p + 1, n, n);
}

int
__countfmt(Fmt *f)
{
	void *p;
	ulong fl;

	fl = f-&gt;flags;
	p = va_arg(f-&gt;args, void*);
	if(fl &amp; FmtVLong){
		*(vlong*)p = f-&gt;nfmt;
	}else if(fl &amp; FmtLong){
		*(long*)p = f-&gt;nfmt;
	}else if(fl &amp; FmtByte){
		*(char*)p = f-&gt;nfmt;
	}else if(fl &amp; FmtShort){
		*(short*)p = f-&gt;nfmt;
	}else{
		*(int*)p = f-&gt;nfmt;
	}
	return 0;
}

int
__flagfmt(Fmt *f)
{
	switch(f-&gt;r){
	case ',':
		f-&gt;flags |= FmtComma;
		break;
	case '-':
		f-&gt;flags |= FmtLeft;
		break;
	case '+':
		f-&gt;flags |= FmtSign;
		break;
	case '#':
		f-&gt;flags |= FmtSharp;
		break;
	case ' ':
		f-&gt;flags |= FmtSpace;
		break;
	case 'u':
		f-&gt;flags |= FmtUnsigned;
		break;
	case 'h':
		if(f-&gt;flags &amp; FmtShort)
			f-&gt;flags |= FmtByte;
		f-&gt;flags |= FmtShort;
		break;
	case 'L':
		f-&gt;flags |= FmtLDouble;
		break;
	case 'l':
		if(f-&gt;flags &amp; FmtLong)
			f-&gt;flags |= FmtVLong;
		f-&gt;flags |= FmtLong;
		break;
	}
	return 1;
}

/* default error format */
int
__badfmt(Fmt *f)
{
	char x[3];

	x[0] = '%';
	x[1] = f-&gt;r;
	x[2] = '%';
	f-&gt;prec = 3;
	__fmtcpy(f, (const void*)x, 3, 3);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

