<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/libc/lock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/libc/lock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

#ifdef PTHREAD

static pthread_mutex_t initmutex = PTHREAD_MUTEX_INITIALIZER;

static void
lockinit(Lock *lk)
{
	pthread_mutexattr_t attr;

	pthread_mutex_lock(&amp;initmutex);
	if(lk-&gt;init == 0){
		pthread_mutexattr_init(&amp;attr);
		pthread_mutexattr_settype(&amp;attr, PTHREAD_MUTEX_NORMAL);
		pthread_mutex_init(&amp;lk-&gt;mutex, &amp;attr);
		pthread_mutexattr_destroy(&amp;attr);
		lk-&gt;init = 1;
	}
	pthread_mutex_unlock(&amp;initmutex);
}

void
lock(Lock *lk)
{
	if(!lk-&gt;init)
		lockinit(lk);
	if(pthread_mutex_lock(&amp;lk-&gt;mutex) != 0)
		abort();
}

int
canlock(Lock *lk)
{
	int r;

	if(!lk-&gt;init)
		lockinit(lk);
	r = pthread_mutex_trylock(&amp;lk-&gt;mutex);
	if(r == 0)
		return 1;
	if(r == EBUSY)
		return 0;
	abort();
}

void
unlock(Lock *lk)
{
	if(pthread_mutex_unlock(&amp;lk-&gt;mutex) != 0)
		abort();
}

#else 

/* old, non-pthread systems */

int
canlock(Lock *lk)
{
	return !tas(&amp;lk-&gt;key);
}

void
lock(Lock *lk)
{
	int i;

	/* easy case */
	if(canlock(lk))
		return;

	/* for multi processor machines */
	for(i=0; i&lt;100; i++)
		if(canlock(lk))
			return;

	for(i=0; i&lt;100; i++) {
		osyield();
		if(canlock(lk))
			return;
	}

	/* looking bad - make sure it is not a priority problem */
	for(i=0; i&lt;12; i++) {
		osmsleep(1&lt;&lt;i);
		if(canlock(lk))
			return;
	}

	/* we are in trouble */
	for(;;) {
		if(canlock(lk))
			return;
		iprint("lock loop %ld: val=%d &amp;lock=%ux pc=%p\n", getpid(), lk-&gt;key, lk, getcallerpc(&amp;lk));
		osmsleep(1000);
	}
}

void
unlock(Lock *lk)
{
	assert(lk-&gt;key);
	lk-&gt;key = 0;
}

#endif

void
ilock(Lock *lk)
{
	lock(lk);
}

void
iunlock(Lock *lk)
{
	unlock(lk);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

