<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/libmemdraw/line.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/libmemdraw/line.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;memlayer.h&gt;

enum
{
	Arrow1 = 8,
	Arrow2 = 10,
	Arrow3 = 3,
};

#ifdef NOT
static
int
lmin(int a, int b)
{
	if(a &lt; b)
		return a;
	return b;
}
#endif

static
int
lmax(int a, int b)
{
	if(a &gt; b)
		return a;
	return b;
}

#ifdef NOTUSED
/*
 * Rather than line clip, we run the Bresenham loop over the full line,
 * and clip on each pixel.  This is more expensive but means that
 * lines look the same regardless of how the windowing has tiled them.
 * For speed, we check for clipping outside the loop and make the
 * test easy when possible.
 */

static
void
horline1(Memimage *dst, Point p0, Point p1, int srcval, Rectangle clipr)
{
	int x, y, dy, deltay, deltax, maxx;
	int dd, easy, e, bpp, m, m0;
	uchar *d;

	deltax = p1.x - p0.x;
	deltay = p1.y - p0.y;
	dd = dst-&gt;width*sizeof(ulong);
	dy = 1;
	if(deltay &lt; 0){
		dd = -dd;
		deltay = -deltay;
		dy = -1;
	}
	maxx = lmin(p1.x, clipr.max.x-1);
	bpp = dst-&gt;depth;
	m0 = 0xFF^(0xFF&gt;&gt;bpp);
	m = m0 &gt;&gt; (p0.x&amp;(7/dst-&gt;depth))*bpp;
	easy = ptinrect(p0, clipr) &amp;&amp; ptinrect(p1, clipr);
	e = 2*deltay - deltax;
	y = p0.y;
	d = byteaddr(dst, p0);
	deltay *= 2;
	deltax = deltay - 2*deltax;
	for(x=p0.x; x&lt;=maxx; x++){
		if(easy || (clipr.min.x&lt;=x &amp;&amp; clipr.min.y&lt;=y &amp;&amp; y&lt;clipr.max.y))
			*d ^= (*d^srcval) &amp; m;
		if(e &gt; 0){
			y += dy;
			d += dd;
			e += deltax;
		}else
			e += deltay;
		d++;
		m &gt;&gt;= bpp;
		if(m == 0)
			m = m0;
	}
}

static
void
verline1(Memimage *dst, Point p0, Point p1, int srcval, Rectangle clipr)
{
	int x, y, deltay, deltax, maxy;
	int easy, e, bpp, m, m0, dd;
	uchar *d;

	deltax = p1.x - p0.x;
	deltay = p1.y - p0.y;
	dd = 1;
	if(deltax &lt; 0){
		dd = -1;
		deltax = -deltax;
	}
	maxy = lmin(p1.y, clipr.max.y-1);
	bpp = dst-&gt;depth;
	m0 = 0xFF^(0xFF&gt;&gt;bpp);
	m = m0 &gt;&gt; (p0.x&amp;(7/dst-&gt;depth))*bpp;
	easy = ptinrect(p0, clipr) &amp;&amp; ptinrect(p1, clipr);
	e = 2*deltax - deltay;
	x = p0.x;
	d = byteaddr(dst, p0);
	deltax *= 2;
	deltay = deltax - 2*deltay;
	for(y=p0.y; y&lt;=maxy; y++){
		if(easy || (clipr.min.y&lt;=y &amp;&amp; clipr.min.x&lt;=x &amp;&amp; x&lt;clipr.max.x))
			*d ^= (*d^srcval) &amp; m;
		if(e &gt; 0){
			x += dd;
			d += dd;
			e += deltay;
		}else
			e += deltax;
		d += dst-&gt;width*sizeof(ulong);
		m &gt;&gt;= bpp;
		if(m == 0)
			m = m0;
	}
}

static
void
horliner(Memimage *dst, Point p0, Point p1, Memimage *src, Point dsrc, Rectangle clipr)
{
	int x, y, sx, sy, deltay, deltax, minx, maxx;
	int bpp, m, m0;
	uchar *d, *s;

	deltax = p1.x - p0.x;
	deltay = p1.y - p0.y;
	sx = drawreplxy(src-&gt;r.min.x, src-&gt;r.max.x, p0.x+dsrc.x);
	minx = lmax(p0.x, clipr.min.x);
	maxx = lmin(p1.x, clipr.max.x-1);
	bpp = dst-&gt;depth;
	m0 = 0xFF^(0xFF&gt;&gt;bpp);
	m = m0 &gt;&gt; (minx&amp;(7/dst-&gt;depth))*bpp;
	for(x=minx; x&lt;=maxx; x++){
		y = p0.y + (deltay*(x-p0.x)+deltax/2)/deltax;
		if(clipr.min.y&lt;=y &amp;&amp; y&lt;clipr.max.y){
			d = byteaddr(dst, Pt(x, y));
			sy = drawreplxy(src-&gt;r.min.y, src-&gt;r.max.y, y+dsrc.y);
			s = byteaddr(src, Pt(sx, sy));
			*d ^= (*d^*s) &amp; m;
		}
		if(++sx &gt;= src-&gt;r.max.x)
			sx = src-&gt;r.min.x;
		m &gt;&gt;= bpp;
		if(m == 0)
			m = m0;
	}
}

static
void
verliner(Memimage *dst, Point p0, Point p1, Memimage *src, Point dsrc, Rectangle clipr)
{
	int x, y, sx, sy, deltay, deltax, miny, maxy;
	int bpp, m, m0;
	uchar *d, *s;

	deltax = p1.x - p0.x;
	deltay = p1.y - p0.y;
	sy = drawreplxy(src-&gt;r.min.y, src-&gt;r.max.y, p0.y+dsrc.y);
	miny = lmax(p0.y, clipr.min.y);
	maxy = lmin(p1.y, clipr.max.y-1);
	bpp = dst-&gt;depth;
	m0 = 0xFF^(0xFF&gt;&gt;bpp);
	for(y=miny; y&lt;=maxy; y++){
		if(deltay == 0)	/* degenerate line */
			x = p0.x;
		else
			x = p0.x + (deltax*(y-p0.y)+deltay/2)/deltay;
		if(clipr.min.x&lt;=x &amp;&amp; x&lt;clipr.max.x){
			m = m0 &gt;&gt; (x&amp;(7/dst-&gt;depth))*bpp;
			d = byteaddr(dst, Pt(x, y));
			sx = drawreplxy(src-&gt;r.min.x, src-&gt;r.max.x, x+dsrc.x);
			s = byteaddr(src, Pt(sx, sy));
			*d ^= (*d^*s) &amp; m;
		}
		if(++sy &gt;= src-&gt;r.max.y)
			sy = src-&gt;r.min.y;
	}
}

static
void
horline(Memimage *dst, Point p0, Point p1, Memimage *src, Point dsrc, Rectangle clipr)
{
	int x, y, deltay, deltax, minx, maxx;
	int bpp, m, m0;
	uchar *d, *s;

	deltax = p1.x - p0.x;
	deltay = p1.y - p0.y;
	minx = lmax(p0.x, clipr.min.x);
	maxx = lmin(p1.x, clipr.max.x-1);
	bpp = dst-&gt;depth;
	m0 = 0xFF^(0xFF&gt;&gt;bpp);
	m = m0 &gt;&gt; (minx&amp;(7/dst-&gt;depth))*bpp;
	for(x=minx; x&lt;=maxx; x++){
		y = p0.y + (deltay*(x-p0.x)+deltay/2)/deltax;
		if(clipr.min.y&lt;=y &amp;&amp; y&lt;clipr.max.y){
			d = byteaddr(dst, Pt(x, y));
			s = byteaddr(src, addpt(dsrc, Pt(x, y)));
			*d ^= (*d^*s) &amp; m;
		}
		m &gt;&gt;= bpp;
		if(m == 0)
			m = m0;
	}
}

static
void
verline(Memimage *dst, Point p0, Point p1, Memimage *src, Point dsrc, Rectangle clipr)
{
	int x, y, deltay, deltax, miny, maxy;
	int bpp, m, m0;
	uchar *d, *s;

	deltax = p1.x - p0.x;
	deltay = p1.y - p0.y;
	miny = lmax(p0.y, clipr.min.y);
	maxy = lmin(p1.y, clipr.max.y-1);
	bpp = dst-&gt;depth;
	m0 = 0xFF^(0xFF&gt;&gt;bpp);
	for(y=miny; y&lt;=maxy; y++){
		if(deltay == 0)	/* degenerate line */
			x = p0.x;
		else
			x = p0.x + deltax*(y-p0.y)/deltay;
		if(clipr.min.x&lt;=x &amp;&amp; x&lt;clipr.max.x){
			m = m0 &gt;&gt; (x&amp;(7/dst-&gt;depth))*bpp;
			d = byteaddr(dst, Pt(x, y));
			s = byteaddr(src, addpt(dsrc, Pt(x, y)));
			*d ^= (*d^*s) &amp; m;
		}
	}
}
#endif /* NOTUSED */

static Memimage*
membrush(int radius)
{
	static Memimage *brush;
	static int brushradius;

	if(brush==nil || brushradius!=radius){
		freememimage(brush);
		brush = allocmemimage(Rect(0, 0, 2*radius+1, 2*radius+1), memopaque-&gt;chan);
		if(brush != nil){
			memfillcolor(brush, DTransparent);	/* zeros */
			memellipse(brush, Pt(radius, radius), radius, radius, -1, memopaque, Pt(radius, radius), S);
		}
		brushradius = radius;
	}
	return brush;
}

static
void
discend(Point p, int radius, Memimage *dst, Memimage *src, Point dsrc, int op)
{
	Memimage *disc;
	Rectangle r;

	disc = membrush(radius);
	if(disc != nil){
		r.min.x = p.x - radius;
		r.min.y = p.y - radius;
		r.max.x = p.x + radius+1;
		r.max.y = p.y + radius+1;
		memdraw(dst, r, src, addpt(r.min, dsrc), disc, Pt(0,0), op);
	}
}

static
void
arrowend(Point tip, Point *pp, int end, int sin, int cos, int radius)
{
	int x1, x2, x3;

	/* before rotation */
	if(end == Endarrow){
		x1 = Arrow1;
		x2 = Arrow2;
		x3 = Arrow3;
	}else{
		x1 = (end&gt;&gt;5) &amp; 0x1FF;	/* distance along line from end of line to tip */
		x2 = (end&gt;&gt;14) &amp; 0x1FF;	/* distance along line from barb to tip */
		x3 = (end&gt;&gt;23) &amp; 0x1FF;	/* distance perpendicular from edge of line to barb */
	}

	/* comments follow track of right-facing arrowhead */
	pp-&gt;x = tip.x+((2*radius+1)*sin/2-x1*cos);		/* upper side of shaft */
	pp-&gt;y = tip.y-((2*radius+1)*cos/2+x1*sin);
	pp++;
	pp-&gt;x = tip.x+((2*radius+2*x3+1)*sin/2-x2*cos);		/* upper barb */
	pp-&gt;y = tip.y-((2*radius+2*x3+1)*cos/2+x2*sin);
	pp++;
	pp-&gt;x = tip.x;
	pp-&gt;y = tip.y;
	pp++;
	pp-&gt;x = tip.x+(-(2*radius+2*x3+1)*sin/2-x2*cos);	/* lower barb */
	pp-&gt;y = tip.y-(-(2*radius+2*x3+1)*cos/2+x2*sin);
	pp++;
	pp-&gt;x = tip.x+(-(2*radius+1)*sin/2-x1*cos);		/* lower side of shaft */
	pp-&gt;y = tip.y+((2*radius+1)*cos/2-x1*sin);
}

void
_memimageline(Memimage *dst, Point p0, Point p1, int end0, int end1, int radius, Memimage *src, Point sp, Rectangle clipr, int op)
{
	/*
	 * BUG: We should really really pick off purely horizontal and purely
	 * vertical lines and handle them separately with calls to memimagedraw
	 * on rectangles.
	 */

	int hor;
	int sin, cos, dx, dy, t;
	Rectangle oclipr, r;
	Point q, pts[10], *pp, d;

	if(radius &lt; 0)
		return;
	if(rectclip(&amp;clipr, dst-&gt;r) == 0)
		return;
	if(rectclip(&amp;clipr, dst-&gt;clipr) == 0)
		return;
	d = subpt(sp, p0);
	if(rectclip(&amp;clipr, rectsubpt(src-&gt;clipr, d)) == 0)
		return;
	if((src-&gt;flags&amp;Frepl)==0 &amp;&amp; rectclip(&amp;clipr, rectsubpt(src-&gt;r, d))==0)
		return;
	/* this means that only verline() handles degenerate lines (p0==p1) */
	hor = (abs(p1.x-p0.x) &gt; abs(p1.y-p0.y));
	/*
	 * Clipping is a little peculiar.  We can't use Sutherland-Cohen
	 * clipping because lines are wide.  But this is probably just fine:
	 * we do all math with the original p0 and p1, but clip when deciding
	 * what pixels to draw.  This means the layer code can call this routine,
	 * using clipr to define the region being written, and get the same set
	 * of pixels regardless of the dicing.
	 */
	if((hor &amp;&amp; p0.x&gt;p1.x) || (!hor &amp;&amp; p0.y&gt;p1.y)){
		q = p0;
		p0 = p1;
		p1 = q;
		t = end0;
		end0 = end1;
		end1 = t;
	}

	if((p0.x == p1.x || p0.y == p1.y) &amp;&amp; (end0&amp;0x1F) == Endsquare &amp;&amp; (end1&amp;0x1F) == Endsquare){
		r.min = p0;
		r.max = p1;
		if(p0.x == p1.x){
			r.min.x -= radius;
			r.max.x += radius+1;
		}
		else{
			r.min.y -= radius;
			r.max.y += radius+1;
		}
		oclipr = dst-&gt;clipr;
		dst-&gt;clipr = clipr;
		memimagedraw(dst, r, src, sp, memopaque, sp, op);
		dst-&gt;clipr = oclipr;
		return;
	}

/*    Hard: */
	/* draw thick line using polygon fill */
	icossin2(p1.x-p0.x, p1.y-p0.y, &amp;cos, &amp;sin);
	dx = (sin*(2*radius+1))/2;
	dy = (cos*(2*radius+1))/2;
	pp = pts;
	oclipr = dst-&gt;clipr;
	dst-&gt;clipr = clipr;
	q.x = ICOSSCALE*p0.x+ICOSSCALE/2-cos/2;
	q.y = ICOSSCALE*p0.y+ICOSSCALE/2-sin/2;
	switch(end0 &amp; 0x1F){
	case Enddisc:
		discend(p0, radius, dst, src, d, op);
		/* fall through */
	case Endsquare:
	default:
		pp-&gt;x = q.x-dx;
		pp-&gt;y = q.y+dy;
		pp++;
		pp-&gt;x = q.x+dx;
		pp-&gt;y = q.y-dy;
		pp++;
		break;
	case Endarrow:
		arrowend(q, pp, end0, -sin, -cos, radius);
		_memfillpolysc(dst, pts, 5, ~0, src, addpt(pts[0], mulpt(d, ICOSSCALE)), 1, 10, 1, op);
		pp[1] = pp[4];
		pp += 2;
	}
	q.x = ICOSSCALE*p1.x+ICOSSCALE/2+cos/2;
	q.y = ICOSSCALE*p1.y+ICOSSCALE/2+sin/2;
	switch(end1 &amp; 0x1F){
	case Enddisc:
		discend(p1, radius, dst, src, d, op);
		/* fall through */
	case Endsquare:
	default:
		pp-&gt;x = q.x+dx;
		pp-&gt;y = q.y-dy;
		pp++;
		pp-&gt;x = q.x-dx;
		pp-&gt;y = q.y+dy;
		pp++;
		break;
	case Endarrow:
		arrowend(q, pp, end1, sin, cos, radius);
		_memfillpolysc(dst, pp, 5, ~0, src, addpt(pts[0], mulpt(d, ICOSSCALE)), 1, 10, 1, op);
		pp[1] = pp[4];
		pp += 2;
	}
	_memfillpolysc(dst, pts, pp-pts, ~0, src, addpt(pts[0], mulpt(d, ICOSSCALE)), 0, 10, 1, op);
	dst-&gt;clipr = oclipr;
	return;
}

void
memimageline(Memimage *dst, Point p0, Point p1, int end0, int end1, int radius, Memimage *src, Point sp, int op)
{
	_memimageline(dst, p0, p1, end0, end1, radius, src, sp, dst-&gt;clipr, op);
}

/*
 * Simple-minded conservative code to compute bounding box of line.
 * Result is probably a little larger than it needs to be.
 */
static
void
addbbox(Rectangle *r, Point p)
{
	if(r-&gt;min.x &gt; p.x)
		r-&gt;min.x = p.x;
	if(r-&gt;min.y &gt; p.y)
		r-&gt;min.y = p.y;
	if(r-&gt;max.x &lt; p.x+1)
		r-&gt;max.x = p.x+1;
	if(r-&gt;max.y &lt; p.y+1)
		r-&gt;max.y = p.y+1;
}

int
memlineendsize(int end)
{
	int x3;

	if((end&amp;0x3F) != Endarrow)
		return 0;
	if(end == Endarrow)
		x3 = Arrow3;
	else
		x3 = (end&gt;&gt;23) &amp; 0x1FF;
	return x3;
}

Rectangle
memlinebbox(Point p0, Point p1, int end0, int end1, int radius)
{
	Rectangle r, r1;
	int extra;

	r.min.x = 10000000;
	r.min.y = 10000000;
	r.max.x = -10000000;
	r.max.y = -10000000;
	extra = lmax(memlineendsize(end0), memlineendsize(end1));
	r1 = insetrect(canonrect(Rpt(p0, p1)), -(radius+extra));
	addbbox(&amp;r, r1.min);
	addbbox(&amp;r, r1.max);
	return r;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

