<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/libmemlayer/draw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/libmemlayer/draw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;memlayer.h&gt;

struct Draw
{
	Point	deltas;
	Point	deltam;
	Memlayer		*dstlayer;
	Memimage	*src;
	Memimage	*mask;
	int	op;
};

static
void
ldrawop(Memimage *dst, Rectangle screenr, Rectangle clipr, void *etc, int insave)
{
	struct Draw *d;
	Point p0, p1;
	Rectangle oclipr, srcr, r, mr;
	int ok;

	d = etc;
	if(insave &amp;&amp; d-&gt;dstlayer-&gt;save==nil)
		return;

	p0 = addpt(screenr.min, d-&gt;deltas);
	p1 = addpt(screenr.min, d-&gt;deltam);

	if(insave){
		r = rectsubpt(screenr, d-&gt;dstlayer-&gt;delta);
		clipr = rectsubpt(clipr, d-&gt;dstlayer-&gt;delta);
	}else
		r = screenr;

	/* now in logical coordinates */

	/* clipr may have narrowed what we should draw on, so clip if necessary */
	if(!rectinrect(r, clipr)){
		oclipr = dst-&gt;clipr;
		dst-&gt;clipr = clipr;
		ok = drawclip(dst, &amp;r, d-&gt;src, &amp;p0, d-&gt;mask, &amp;p1, &amp;srcr, &amp;mr);
		dst-&gt;clipr = oclipr;
		if(!ok)
			return;
	}
	memdraw(dst, r, d-&gt;src, p0, d-&gt;mask, p1, d-&gt;op);
}

void
memdraw(Memimage *dst, Rectangle r, Memimage *src, Point p0, Memimage *mask, Point p1, int op)
{
	struct Draw d;
	Rectangle srcr, tr, mr;
	Memlayer *dl, *sl;

	if(drawdebug)
		iprint("memdraw %p %R %p %P %p %P\n", dst, r, src, p0, mask, p1);

	if(mask == nil)
		mask = memopaque;

	if(mask-&gt;layer){
if(drawdebug)	iprint("mask-&gt;layer != nil\n");
		return;	/* too hard, at least for now */
	}

    Top:
	if(dst-&gt;layer==nil &amp;&amp; src-&gt;layer==nil){
		memimagedraw(dst, r, src, p0, mask, p1, op);
		return;
	}

	if(drawclip(dst, &amp;r, src, &amp;p0, mask, &amp;p1, &amp;srcr, &amp;mr) == 0){
if(drawdebug)	iprint("drawclip dstcr %R srccr %R maskcr %R\n", dst-&gt;clipr, src-&gt;clipr, mask-&gt;clipr);
		return;
	}

	/*
 	 * Convert to screen coordinates.
	 */
	dl = dst-&gt;layer;
	if(dl != nil){
		r.min.x += dl-&gt;delta.x;
		r.min.y += dl-&gt;delta.y;
		r.max.x += dl-&gt;delta.x;
		r.max.y += dl-&gt;delta.y;
	}
    Clearlayer:
	if(dl!=nil &amp;&amp; dl-&gt;clear){
		if(src == dst){
			p0.x += dl-&gt;delta.x;
			p0.y += dl-&gt;delta.y;
			src = dl-&gt;screen-&gt;image;
		}
		dst = dl-&gt;screen-&gt;image;
		goto Top;
	}

	sl = src-&gt;layer;
	if(sl != nil){
		p0.x += sl-&gt;delta.x;
		p0.y += sl-&gt;delta.y;
		srcr.min.x += sl-&gt;delta.x;
		srcr.min.y += sl-&gt;delta.y;
		srcr.max.x += sl-&gt;delta.x;
		srcr.max.y += sl-&gt;delta.y;
	}

	/*
	 * Now everything is in screen coordinates.
	 * mask is an image.  dst and src are images or obscured layers.
	 */

	/*
	 * if dst and src are the same layer, just draw in save area and expose.
	 */
	if(dl!=nil &amp;&amp; dst==src){
		if(dl-&gt;save == nil)
			return;	/* refresh function makes this case unworkable */
		if(rectXrect(r, srcr)){
			tr = r;
			if(srcr.min.x &lt; tr.min.x){
				p1.x += tr.min.x - srcr.min.x;
				tr.min.x = srcr.min.x;
			}
			if(srcr.min.y &lt; tr.min.y){
				p1.y += tr.min.x - srcr.min.x;
				tr.min.y = srcr.min.y;
			}
			if(srcr.max.x &gt; tr.max.x)
				tr.max.x = srcr.max.x;
			if(srcr.max.y &gt; tr.max.y)
				tr.max.y = srcr.max.y;
			memlhide(dst, tr);
		}else{
			memlhide(dst, r);
			memlhide(dst, srcr);
		}
		memdraw(dl-&gt;save, rectsubpt(r, dl-&gt;delta), dl-&gt;save,
			subpt(srcr.min, src-&gt;layer-&gt;delta), mask, p1, op);
		memlexpose(dst, r);
		return;
	}

	if(sl){
		if(sl-&gt;clear){
			src = sl-&gt;screen-&gt;image;
			if(dl != nil){
				r.min.x -= dl-&gt;delta.x;
				r.min.y -= dl-&gt;delta.y;
				r.max.x -= dl-&gt;delta.x;
				r.max.y -= dl-&gt;delta.y;
			}
			goto Top;
		}
		/* relatively rare case; use save area */
		if(sl-&gt;save == nil)
			return;	/* refresh function makes this case unworkable */
		memlhide(src, srcr);
		/* convert back to logical coordinates */
		p0.x -= sl-&gt;delta.x;
		p0.y -= sl-&gt;delta.y;
		srcr.min.x -= sl-&gt;delta.x;
		srcr.min.y -= sl-&gt;delta.y;
		srcr.max.x -= sl-&gt;delta.x;
		srcr.max.y -= sl-&gt;delta.y;
		src = src-&gt;layer-&gt;save;
	}

	/*
	 * src is now an image.  dst may be an image or a clear layer
	 */
	if(dst-&gt;layer==nil)
		goto Top;
	if(dst-&gt;layer-&gt;clear)
		goto Clearlayer;

	/*
	 * dst is an obscured layer
	 */
	d.deltas = subpt(p0, r.min);
	d.deltam = subpt(p1, r.min);
	d.dstlayer = dl;
	d.src = src;
	d.op = op;
	d.mask = mask;
	_memlayerop(ldrawop, dst, r, r, &amp;d);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

