<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/u9fs/fcallconv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/u9fs/fcallconv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;plan9.h&gt;
#include &lt;fcall.h&gt;
#include &lt;oldfcall.h&gt;

extern int old9p;

static uint dumpsome(char*, char*, long);
static void fdirconv(char*, Dir*);
static char *qidtype(char*, uchar);

#define	QIDFMT	"(%.16llux %lud %s)"

int
fcallconv(va_list *arg, Fconv *f1)
{
	Fcall *f;
	int fid, type, tag, n, i;
	char buf[512], tmp[200];
	Dir *d;
	Qid *q;

	f = va_arg(*arg, Fcall*);
	type = f-&gt;type;
	fid = f-&gt;fid;
	tag = f-&gt;tag;
	switch(type){
	case Tversion:	/* 100 */
		sprint(buf, "Tversion tag %ud msize %ud version '%s'", tag, f-&gt;msize, f-&gt;version);
		break;
	case Rversion:
		sprint(buf, "Rversion tag %ud msize %ud version '%s'", tag, f-&gt;msize, f-&gt;version);
		break;
	case Tauth:	/* 102 */
		sprint(buf, "Tauth tag %ud afid %d uname %s aname %s", tag,
			f-&gt;afid, f-&gt;uname, f-&gt;aname);
		break;
	case Rauth:
		sprint(buf, "Rauth tag %ud qid " QIDFMT, tag,
			f-&gt;aqid.path, f-&gt;aqid.vers, qidtype(tmp, f-&gt;aqid.type));
		break;
	case Tattach:	/* 104 */
		sprint(buf, "Tattach tag %ud fid %d afid %d uname %s aname %s", tag,
			fid, f-&gt;afid, f-&gt;uname, f-&gt;aname);
		break;
	case Rattach:
		sprint(buf, "Rattach tag %ud qid " QIDFMT, tag,
			f-&gt;qid.path, f-&gt;qid.vers, qidtype(tmp, f-&gt;qid.type));
		break;
	case Rerror:	/* 107; 106 (Terror) illegal */
		sprint(buf, "Rerror tag %ud ename %s", tag, f-&gt;ename);
		break;
	case Tflush:	/* 108 */
		sprint(buf, "Tflush tag %ud oldtag %ud", tag, f-&gt;oldtag);
		break;
	case Rflush:
		sprint(buf, "Rflush tag %ud", tag);
		break;
	case Twalk:	/* 110 */
		n = sprint(buf, "Twalk tag %ud fid %d newfid %d nwname %d ", tag, fid, f-&gt;newfid, f-&gt;nwname);
			for(i=0; i&lt;f-&gt;nwname; i++)
				n += sprint(buf+n, "%d:%s ", i, f-&gt;wname[i]);
		break;
	case Rwalk:
		n = sprint(buf, "Rwalk tag %ud nwqid %ud ", tag, f-&gt;nwqid);
		for(i=0; i&lt;f-&gt;nwqid; i++){
			q = &amp;f-&gt;wqid[i];
			n += sprint(buf+n, "%d:" QIDFMT " ", i,
				q-&gt;path, q-&gt;vers, qidtype(tmp, q-&gt;type));
		}
		break;
	case Topen:	/* 112 */
		sprint(buf, "Topen tag %ud fid %ud mode %d", tag, fid, f-&gt;mode);
		break;
	case Ropen:
		sprint(buf, "Ropen tag %ud qid " QIDFMT " iounit %ud ", tag,
			f-&gt;qid.path, f-&gt;qid.vers, qidtype(tmp, f-&gt;qid.type), f-&gt;iounit);
		break;
	case Tcreate:	/* 114 */
		sprint(buf, "Tcreate tag %ud fid %ud name %s perm %M mode %d",
			tag, fid, f-&gt;name, (ulong)f-&gt;perm, f-&gt;mode);
		break;
	case Rcreate:
		sprint(buf, "Rcreate tag %ud qid " QIDFMT " iounit %ud ", tag,
			f-&gt;qid.path, f-&gt;qid.vers, qidtype(tmp, f-&gt;qid.type), f-&gt;iounit);
		break;
	case Tread:	/* 116 */
		sprint(buf, "Tread tag %ud fid %d offset %lld count %ud",
			tag, fid, f-&gt;offset, f-&gt;count);
		break;
	case Rread:
		n = sprint(buf, "Rread tag %ud count %ud ", tag, f-&gt;count);
			dumpsome(buf+n, f-&gt;data, f-&gt;count);
		break;
	case Twrite:	/* 118 */
		n = sprint(buf, "Twrite tag %ud fid %d offset %lld count %ud ",
			tag, fid, f-&gt;offset, f-&gt;count);
		dumpsome(buf+n, f-&gt;data, f-&gt;count);
		break;
	case Rwrite:
		sprint(buf, "Rwrite tag %ud count %ud", tag, f-&gt;count);
		break;
	case Tclunk:	/* 120 */
		sprint(buf, "Tclunk tag %ud fid %ud", tag, fid);
		break;
	case Rclunk:
		sprint(buf, "Rclunk tag %ud", tag);
		break;
	case Tremove:	/* 122 */
		sprint(buf, "Tremove tag %ud fid %ud", tag, fid);
		break;
	case Rremove:
		sprint(buf, "Rremove tag %ud", tag);
		break;
	case Tstat:	/* 124 */
		sprint(buf, "Tstat tag %ud fid %ud", tag, fid);
		break;
	case Rstat:
		n = sprint(buf, "Rstat tag %ud ", tag);
		if(f-&gt;nstat &gt; sizeof tmp)
			sprint(buf+n, " stat(%d bytes)", f-&gt;nstat);
		else{
			d = (Dir*)tmp;
			(old9p?convM2Dold:convM2D)(f-&gt;stat, f-&gt;nstat, d, (char*)(d+1));
			sprint(buf+n, " stat ");
			fdirconv(buf+n+6, d);
		}
		break;
	case Twstat:	/* 126 */
		n = sprint(buf, "Twstat tag %ud fid %ud", tag, fid);
		if(f-&gt;nstat &gt; sizeof tmp)
			sprint(buf+n, " stat(%d bytes)", f-&gt;nstat);
		else{
			d = (Dir*)tmp;
			(old9p?convM2Dold:convM2D)(f-&gt;stat, f-&gt;nstat, d, (char*)(d+1));
			sprint(buf+n, " stat ");
			fdirconv(buf+n+6, d);
		}
		break;
	case Rwstat:
		sprint(buf, "Rwstat tag %ud", tag);
		break;
	default:
		sprint(buf,  "unknown type %d", type);
	}
	strconv(buf, f1);
	return(sizeof(Fcall*));
}

static char*
qidtype(char *s, uchar t)
{
	char *p;

	p = s;
	if(t &amp; QTDIR)
		*p++ = 'd';
	if(t &amp; QTAPPEND)
		*p++ = 'a';
	if(t &amp; QTEXCL)
		*p++ = 'l';
	if(t &amp; QTMOUNT)
		*p++ = 'm';
	if(t &amp; QTAUTH)
		*p++ = 'A';
	*p = '\0';
	return s;
}

int
dirconv(va_list *arg, Fconv *f)
{
	char buf[160];

	fdirconv(buf, va_arg(*arg, Dir*));
	strconv(buf, f);
	return(sizeof(Dir*));
}

static void
fdirconv(char *buf, Dir *d)
{
	char tmp[16];

	sprint(buf, "'%s' '%s' '%s' '%s' "
		"q " QIDFMT " m %#luo "
		"at %ld mt %ld l %lld "
		"t %d d %d",
			d-&gt;name, d-&gt;uid, d-&gt;gid, d-&gt;muid,
			d-&gt;qid.path, d-&gt;qid.vers, qidtype(tmp, d-&gt;qid.type), d-&gt;mode,
			d-&gt;atime, d-&gt;mtime, d-&gt;length,
			d-&gt;type, d-&gt;dev);
}

/*
 * dump out count (or DUMPL, if count is bigger) bytes from
 * buf to ans, as a string if they are all printable,
 * else as a series of hex bytes
 */
#define DUMPL 64

static uint
dumpsome(char *ans, char *buf, long count)
{
	int i, printable;
	char *p;

	printable = 1;
	if(count &gt; DUMPL)
		count = DUMPL;
	for(i=0; i&lt;count &amp;&amp; printable; i++)
		if((buf[i]&lt;32 &amp;&amp; buf[i] !='\n' &amp;&amp; buf[i] !='\t') || (uchar)buf[i]&gt;127)
			printable = 0;
	p = ans;
	*p++ = '\'';
	if(printable){
		memmove(p, buf, count);
		p += count;
	}else{
		for(i=0; i&lt;count; i++){
			if(i&gt;0 &amp;&amp; i%4==0)
				*p++ = ' ';
			sprint(p, "%2.2ux", (uchar)buf[i]);
			p += 2;
		}
	}
	*p++ = '\'';
	*p = 0;
	return p - ans;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

