<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/u9fs/oldfcall.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/u9fs/oldfcall.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;plan9.h&gt;
#include &lt;fcall.h&gt;
#include &lt;oldfcall.h&gt;

/*
 * routines to package the old protocol in the new structures.
 */

#define	SHORT(x)	p[0]=f-&gt;x; p[1]=f-&gt;x&gt;&gt;8; p += 2
#define	LONG(x)		p[0]=f-&gt;x; p[1]=f-&gt;x&gt;&gt;8; p[2]=f-&gt;x&gt;&gt;16; p[3]=f-&gt;x&gt;&gt;24; p += 4
#define	VLONG(x)	p[0]=f-&gt;x;	p[1]=f-&gt;x&gt;&gt;8;\
			p[2]=f-&gt;x&gt;&gt;16;	p[3]=f-&gt;x&gt;&gt;24;\
			p[4]=f-&gt;x&gt;&gt;32;	p[5]=f-&gt;x&gt;&gt;40;\
			p[6]=f-&gt;x&gt;&gt;48;	p[7]=f-&gt;x&gt;&gt;56;\
			p += 8
#define	STRING(x,n)	strecpy((char*)p, (char*)p+n, f-&gt;x); p += n;
#define	FIXQID(q)		q.path ^= (q.path&gt;&gt;33); q.path &amp;= 0x7FFFFFFF; q.path |= (q.type&amp;0x80)&lt;&lt;24

uint
oldhdrsize(uchar type)
{
	switch(type){
	default:
		return 0;
	case oldTnop:
		return 3;
	case oldTflush:
		return 3+2;
	case oldTclone:
		return 3+2+2;
	case oldTwalk:
		return 3+2+28;
	case oldTopen:
		return 3+2+1;
	case oldTcreate:
		return 3+2+28+4+1;
	case oldTread:
		return 3+2+8+2;
	case oldTwrite:
		return 3+2+8+2+1;
	case oldTclunk:
		return 3+2;
	case oldTremove:
		return 3+2;
	case oldTstat:
		return 3+2;
	case oldTwstat:
		return 3+2+116;
	case oldTsession:
		return 3+8;
	case oldTattach:
		return 3+2+28+28+72+13;
	}
}

uint
iosize(uchar *p)
{
	if(p[0] != oldTwrite)
		return 0;
	return p[3+2+8] | (p[3+2+8+1]&lt;&lt;8);
}

uint
sizeS2M(Fcall *f)
{
	switch(f-&gt;type)
	{
	default:
		abort();
		return 0;

	/* no T messages */

/*
 */
	case Rversion:
		return 1+2;

/*
	case Rsession:
		return 1+2+8+28+48;
*/

	case Rattach:
		return 1+2+2+4+4+13;

	case Rerror:
		return 1+2+64;

	case Rflush:
		if(f-&gt;tag&amp;0x8000)
			return 1+2+8+28+48;	/* session */
		return 1+2;

	/* assumes we don't ever see Tclwalk requests ... */
	case Rwalk:
		if(f-&gt;nwqid == 0)
			return 1+2+2;
		else
			return 1+2+2+4+4;

	case Ropen:
		return 1+2+2+4+4;

	case Rcreate:
		return 1+2+2+4+4;

	case Rread:
		return 1+2+2+2+1+f-&gt;count;

	case Rwrite:
		return 1+2+2+2;

	case Rclunk:
		return 1+2+2;

	case Rremove:
		return 1+2+2;

	case Rstat:
		return 1+2+2+116;

	case Rwstat:
		return 1+2+2;
	}
}

uint
convS2Mold(Fcall *f, uchar *ap, uint nap)
{
	uchar *p;

	if(nap &lt; sizeS2M(f))
		return 0;

	p = ap;
	switch(f-&gt;type)
	{
	default:
		abort();
		return 0;

	/* no T messages */

/*
 */
	case Rversion:
		*p++ = oldRnop;
		SHORT(tag);
		break;

/*
	case Rsession:
		*p++ = oldRsession;
		SHORT(tag);

		if(f-&gt;nchal &gt; 8)
			f-&gt;nchal = 8;
		memmove(p, f-&gt;chal, f-&gt;nchal);
		p += f-&gt;nchal;
		if(f-&gt;nchal &lt; 8){
			memset(p, 0, 8 - f-&gt;nchal);
			p += 8 - f-&gt;nchal;
		}

		STRING(authid, 28);
		STRING(authdom, 48);
		break;
*/

	case Rattach:
		*p++ = oldRattach;
		SHORT(tag);
		SHORT(fid);
		FIXQID(f-&gt;qid);
		LONG(qid.path);
		LONG(qid.vers);
		memset(p, 0, 13);
		p += 13;
		break;

	case Rerror:
		*p++ = oldRerror;
		SHORT(tag);
		STRING(ename, 64);
		break;

	case Rflush:
		if(f-&gt;tag&amp;0x8000){
			*p++ = oldRsession;
			f-&gt;tag &amp;= ~0x8000;
			SHORT(tag);
			memset(p, 0, 8+28+48);
			p += 8+28+48;
		}else{
			*p++ = oldRflush;
			SHORT(tag);
		}
		break;

	/* assumes we don't ever see Tclwalk requests ... */
	case Rwalk:
		if(f-&gt;nwqid == 0){	/* successful clone */
			*p++ = oldRclone;
			SHORT(tag);
			SHORT(fid);
		}else{			/* successful 1-element walk */
			*p++ = oldRwalk;
			SHORT(tag);
			SHORT(fid);
			FIXQID(f-&gt;wqid[0]);
			LONG(wqid[0].path);
			LONG(wqid[0].vers);
		}
		break;

	case Ropen:
		*p++ = oldRopen;
		SHORT(tag);
		SHORT(fid);
		FIXQID(f-&gt;qid);
		LONG(qid.path);
		LONG(qid.vers);
		break;

	case Rcreate:
		*p++ = oldRcreate;
		SHORT(tag);
		SHORT(fid);
		FIXQID(f-&gt;qid);
		LONG(qid.path);
		LONG(qid.vers);
		break;

	case Rread:
		*p++ = oldRread;
		SHORT(tag);
		SHORT(fid);
		SHORT(count);
		p++;	/* pad(1) */
		memmove(p, f-&gt;data, f-&gt;count);
		p += f-&gt;count;
		break;

	case Rwrite:
		*p++ = oldRwrite;
		SHORT(tag);
		SHORT(fid);
		SHORT(count);
		break;

	case Rclunk:
		*p++ = oldRclunk;
		SHORT(tag);
		SHORT(fid);
		break;

	case Rremove:
		*p++ = oldRremove;
		SHORT(tag);
		SHORT(fid);
		break;

	case Rstat:
		*p++ = oldRstat;
		SHORT(tag);
		SHORT(fid);
		memmove(p, f-&gt;stat, 116);
		p += 116;
		break;

	case Rwstat:
		*p++ = oldRwstat;
		SHORT(tag);
		SHORT(fid);
		break;
	}
	return p - ap;
}

uint
sizeD2Mold(Dir *d)
{
	return 116;
}

uint
convD2Mold(Dir *f, uchar *ap, uint nap)
{
	uchar *p;

	if(nap &lt; 116)
		return 0;

	p = ap;
	STRING(name, 28);
	STRING(uid, 28);
	STRING(gid, 28);
	FIXQID(f-&gt;qid);
	LONG(qid.path);
	LONG(qid.vers);
	LONG(mode);
	LONG(atime);
	LONG(mtime);
	VLONG(length);
	SHORT(type);
	SHORT(dev);

	return p - ap;
}

#undef SHORT
#undef LONG
#undef VLONG
#undef STRING
#define	CHAR(x)	f-&gt;x = *p++
#define	SHORT(x)	f-&gt;x = (p[0] | (p[1]&lt;&lt;8)); p += 2
#define	LONG(x)		f-&gt;x = (p[0] | (p[1]&lt;&lt;8) |\
				(p[2]&lt;&lt;16) | (p[3]&lt;&lt;24)); p += 4
#define	VLONG(x)	f-&gt;x = (ulong)(p[0] | (p[1]&lt;&lt;8) |\
					(p[2]&lt;&lt;16) | (p[3]&lt;&lt;24)) |\
				((vlong)(p[4] | (p[5]&lt;&lt;8) |\
					(p[6]&lt;&lt;16) | (p[7]&lt;&lt;24)) &lt;&lt; 32); p += 8
#define	STRING(x,n)	f-&gt;x = (char*)p; p += n

uint
convM2Sold(uchar *ap, uint nap, Fcall *f)
{
	uchar *p, *q, *ep;

	p = ap;
	ep = p + nap;

	if(p+3 &gt; ep)
		return 0;

	switch(*p++){
	case oldTnop:
		f-&gt;type = Tversion;
		SHORT(tag);
		f-&gt;msize = 0;
		f-&gt;version = "9P1";
		break;

	case oldTflush:
		f-&gt;type = Tflush;
		SHORT(tag);
		if(p+2 &gt; ep)
			return 0;
		SHORT(oldtag);
		break;

	case oldTclone:
		f-&gt;type = Twalk;
		SHORT(tag);
		if(p+2+2 &gt; ep)
			return 0;
		SHORT(fid);
		SHORT(newfid);
		f-&gt;nwname = 0;
		break;

	case oldTwalk:
		f-&gt;type = Twalk;
		SHORT(tag);
		if(p+2+28 &gt; ep)
			return 0;
		SHORT(fid);
		f-&gt;newfid = f-&gt;fid;
		f-&gt;nwname = 1;
		f-&gt;wname[0] = (char*)p;
		p += 28;
		break;

	case oldTopen:
		f-&gt;type = Topen;
		SHORT(tag);
		if(p+2+1 &gt; ep)
			return 0;
		SHORT(fid);
		CHAR(mode);
		break;

	case oldTcreate:
		f-&gt;type = Tcreate;
		SHORT(tag);
		if(p+2+28+4+1 &gt; ep)
			return 0;
		SHORT(fid);
		f-&gt;name = (char*)p;
		p += 28;
		LONG(perm);
		CHAR(mode);
		break;

	case oldTread:
		f-&gt;type = Tread;
		SHORT(tag);
		if(p+2+8+2 &gt; ep)
			return 0;
		SHORT(fid);
		VLONG(offset);
		SHORT(count);
		break;

	case oldTwrite:
		f-&gt;type = Twrite;
		SHORT(tag);
		if(p+2+8+2+1 &gt; ep)
			return 0;
		SHORT(fid);
		VLONG(offset);
		SHORT(count);
		p++;	/* pad(1) */
		if(p+f-&gt;count &gt; ep)
			return 0;
		f-&gt;data = (char*)p;
		p += f-&gt;count;
		break;

	case oldTclunk:
		f-&gt;type = Tclunk;
		SHORT(tag);
		if(p+2 &gt; ep)
			return 0;
		SHORT(fid);
		break;

	case oldTremove:
		f-&gt;type = Tremove;
		SHORT(tag);
		if(p+2 &gt; ep)
			return 0;
		SHORT(fid);
		break;

	case oldTstat:
		f-&gt;type = Tstat;
		f-&gt;nstat = 116;
		SHORT(tag);
		if(p+2 &gt; ep)
			return 0;
		SHORT(fid);
		break;

	case oldTwstat:
		f-&gt;type = Twstat;
		SHORT(tag);
		if(p+2+116 &gt; ep)
			return 0;
		SHORT(fid);
		f-&gt;stat = p;
		q = p+28*3+5*4;
		memset(q, 0xFF, 8);	/* clear length to ``don't care'' */
		p += 116;
		break;

/*
	case oldTsession:
		f-&gt;type = Tsession;
		SHORT(tag);
		if(p+8 &gt; ep)
			return 0;
		f-&gt;chal = p;
		p += 8;
		f-&gt;nchal = 8;
		break;
*/
	case oldTsession:
		f-&gt;type = Tflush;
		SHORT(tag);
		f-&gt;tag |= 0x8000;
		f-&gt;oldtag = f-&gt;tag;
		p += 8;
		break;

	case oldTattach:
		f-&gt;type = Tattach;
		SHORT(tag);
		if(p+2+28+28+72+13 &gt; ep)
			return 0;
		SHORT(fid);
		STRING(uname, 28);
		STRING(aname, 28);
		p += 72+13;
		f-&gt;afid = NOFID;
		break;

	default:
		return 0;
	}

	return p-ap;
}

uint
convM2Dold(uchar *ap, uint nap, Dir *f, char *strs)
{
	uchar *p;

	USED(strs);

	if(nap &lt; 116)
		return 0;

	p = (uchar*)ap;
	STRING(name, 28);
	STRING(uid, 28);
	STRING(gid, 28);
	LONG(qid.path);
	LONG(qid.vers);
	LONG(mode);
	LONG(atime);
	LONG(mtime);
	VLONG(length);
	SHORT(type);
	SHORT(dev);
	f-&gt;qid.type = (f-&gt;mode&gt;&gt;24)&amp;0xF0;
	return p - (uchar*)ap;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

