<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/winplumb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/winplumb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;windows.h&gt;
#include &lt;stdio.h&gt;

#pragma comment(lib, "wsock32.lib")
#pragma comment(lib, "shell32.lib")

char	*argv0 = "winplumb";
char errbuf[256];
unsigned long parseip(char*, char*);
typedef unsigned long ulong;
void oserror(void);

void
hnputl(void *p, unsigned long v)
{
	unsigned char *a;

	a = p;
	a[0] = v&gt;&gt;24;
	a[1] = v&gt;&gt;16;
	a[2] = v&gt;&gt;8;
	a[3] = v;
}

void
hnputs(void *p, unsigned short v)
{
	unsigned char *a;

	a = p;
	a[0] = v&gt;&gt;8;
	a[1] = v;
}

unsigned long
nhgetl(void *p)
{
	unsigned char *a;
	a = p;
	return (a[0]&lt;&lt;24)|(a[1]&lt;&lt;16)|(a[2]&lt;&lt;8)|(a[3]&lt;&lt;0);
}

unsigned short
nhgets(void *p)
{
	unsigned char *a;
	a = p;
	return (a[0]&lt;&lt;8)|(a[1]&lt;&lt;0);
}


int
main(int argc, char **argv)
{
	char *addr, *p, *q, to[4];
	char buf[2048];
	int port, fd, nfd, one, len, n, tot;
	ulong ip;
	struct sockaddr_in sin;
	WSADATA wasdat;

	if(argc != 1 &amp;&amp; argc != 2){
	usage:
		fprintf(stderr, "usage: winplumb [tcp!ipaddr!port]\n");
		ExitThread(1);
	}

	if(argc == 1)
		addr = "tcp!*!17890";
	else
		addr = argv[1];

	strcpy(buf, addr);
	p = strchr(buf, '!');
	if(p == 0)
		goto usage;
	q = strchr(p+1, '!');
	if(q == 0)
		goto usage;
	*p++ = 0;
	*q++ = 0;

	if(strcmp(buf, "tcp") != 0)
		goto usage;

	port = atoi(q);
	if(strcmp(p, "*") == 0)
		ip = 0;
	else
		ip = parseip(to, p);

	WSAStartup(MAKEWORD(1, 1), &amp;wasdat);


	fd = socket(AF_INET, SOCK_STREAM, 0);
	if(fd &lt; 0){
		oserror();
		fprintf(stderr, "socket: %s\n", errbuf);
		ExitThread(1);
	}

	one = 1;
	if(setsockopt(fd, IPPROTO_TCP, TCP_NODELAY, (char*)&amp;one, sizeof one) != 0){
		oserror();
		fprintf(stderr, "setsockopt nodelay: %s\n", errbuf);
	}

	if(setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char*)&amp;one, sizeof one) != 0){
		oserror();
		fprintf(stderr, "setsockopt reuse: %s\n", errbuf);
	}
	memset(&amp;sin, 0, sizeof sin);
	sin.sin_family = AF_INET;
	hnputs(&amp;sin.sin_port, port);
	hnputl(&amp;sin.sin_addr, ip);
	if(bind(fd, (struct sockaddr*)&amp;sin, sizeof sin) &lt; 0){
		oserror();
		fprintf(stderr, "bind: %s\n", errbuf);
		ExitThread(1);
	}

	if(listen(fd, 5) &lt; 0){
		oserror();
		fprintf(stderr, "listen: %s\n", errbuf);
		ExitThread(1);
	}

	for(;;){
		len = sizeof sin;
		nfd = accept(fd, (struct sockaddr*)&amp;sin, &amp;len);
		if(nfd &lt; 0){
			oserror();
			fprintf(stderr, "accept: %s\n", errbuf);
			continue;
		}
		tot = 0;
		while(tot == 0 || buf[tot-1] != '\n'){
			n = recv(nfd, buf+tot, sizeof buf-tot, 0);
			if(n &lt; 0)
				break;
			tot += n;
		}
		if(buf[tot-1] == '\n'){
			buf[tot-1] = 0;
			p = strchr(buf, ' ');
			if(p)
				*p++ = 0;
			ShellExecute(0, 0, buf, p, 0, SW_SHOWNORMAL);
		}
		closesocket(nfd);
	}
}


#define CLASS(p) ((*(unsigned char*)(p))&gt;&gt;6)


unsigned long
parseip(char *to, char *from)
{
	int i;
	char *p;

	p = from;
	memset(to, 0, 4);
	for(i = 0; i &lt; 4 &amp;&amp; *p; i++){
		to[i] = strtoul(p, &amp;p, 0);
		if(*p == '.')
			p++;
	}
	switch(CLASS(to)){
	case 0:	/* class A - 1 byte net */
	case 1:
		if(i == 3){
			to[3] = to[2];
			to[2] = to[1];
			to[1] = 0;
		} else if (i == 2){
			to[3] = to[1];
			to[1] = 0;
		}
		break;
	case 2:	/* class B - 2 byte net */
		if(i == 3){
			to[3] = to[2];
			to[2] = 0;
		}
		break;
	}
	return nhgetl(to);
}

void
oserror(void)
{
	int e, r, i;
	char buf[200];

	e = GetLastError();
	
	r = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,
		0, e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		buf, sizeof(buf), 0);

	if(r == 0)
		sprintf(buf, "windows error %d", e);


	for(i = strlen(buf)-1; i&gt;=0 &amp;&amp; buf[i] == '\n' || buf[i] == '\r'; i--)
		buf[i] = 0;

	strcpy(errbuf, buf);
}

extern int	main(int, char*[]);
static int	args(char *argv[], int n, char *p);

int PASCAL
WinMain(HANDLE hInst, HANDLE hPrev, LPSTR arg, int nshow)
{
	int argc, n;
	char *p, **argv;

	/* conservative guess at the number of args */
	for(argc=5,p=arg; *p; p++)
		if(*p == ' ' || *p == '\t')
			argc++;

	argv = malloc(argc*sizeof(char*));
	argc = args(argv+1, argc, arg);
	argc++;
	argv[0] = argv0;
	main(argc, argv);
	ExitThread(0);
	return 0;
}

/*
 * Break the command line into arguments
 * The rules for this are not documented but appear to be the following
 * according to the source for the microsoft C library.
 * Words are seperated by space or tab
 * Words containing a space or tab can be quoted using "
 * 2N backslashes + " ==&gt; N backslashes and end quote
 * 2N+1 backslashes + " ==&gt; N backslashes + literal "
 * N backslashes not followed by " ==&gt; N backslashes
 */
static int
args(char *argv[], int n, char *p)
{
	char *p2;
	int i, j, quote, nbs;

	for(i=0; *p &amp;&amp; i&lt;n-1; i++) {
		while(*p == ' ' || *p == '\t')
			p++;
		quote = 0;
		argv[i] = p2 = p;
		for(;*p; p++) {
			if(!quote &amp;&amp; (*p == ' ' || *p == '\t'))
				break;
			for(nbs=0; *p == '\\'; p++,nbs++)
				;
			if(*p == '"') {
				for(j=0; j&lt;(nbs&gt;&gt;1); j++)
					*p2++ = '\\';
				if(nbs&amp;1)
					*p2++ = *p;
				else
					quote = !quote;
			} else {
				for(j=0; j&lt;nbs; j++)
					*p2++ = '\\';
				*p2++ = *p;
			}
		}
		/* move p up one to avoid pointing to null at end of p2 */
		if(*p)
			p++;
		*p2 = 0;	
	}
	argv[i] = 0;

	return i;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

