<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/bayes/dfa.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/bayes/dfa.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bin.h&gt;
#include &lt;bio.h&gt;
#include &lt;regexp.h&gt;
#include "/sys/src/libregexp/regcomp.h"
#include "dfa.h"

void rdump(Reprog*);
void dump(Dreprog*);

/*
 * Standard NFA determinization and DFA minimization.
 */
typedef struct Deter Deter;
typedef struct Reiset Reiset;

void ddump(Deter*);

/* state of determinization */
struct Deter
{
	jmp_buf kaboom;	/* jmp on error */

	Bin *bin;		/* bin for temporary allocations */

	Reprog *p;	/* program being determinized */
	uint ninst;		/* number of instructions in program */

	Reiset *alloc;	/* chain of all Reisets */
	Reiset **last;

	Reiset **hash;	/* hash of all Reisets */
	uint nhash;

	Reiset *tmp;	/* temporaries for walk */
	uchar *bits;

	Rune *c;		/* ``interesting'' characters */
	uint nc;
};

/* set of Reinsts: perhaps we should use a bit list instead of the indices? */
struct Reiset
{
	uint *inst;		/* indices of instructions in set */
	uint ninst;		/* size of set */

	Reiset *next;	/* d.alloc chain */
	Reiset *hash;	/* d.hash chain */
	Reiset **delta;	/* where to go on each interesting char */
	uint id;		/* assigned id during minimization */
	uint isfinal;	/* is an accepting (final) state */
};

static Reiset*
ralloc(Deter *d, int ninst)
{
	Reiset *t;

	t = binalloc(&amp;d-&gt;bin, sizeof(Reiset)+2*d-&gt;nc*sizeof(Reiset*)+sizeof(uint)*ninst, 0);
	if(t == nil)
		longjmp(d-&gt;kaboom, 1);
	t-&gt;delta = (Reiset**)&amp;t[1];
	t-&gt;inst = (uint*)&amp;t-&gt;delta[2*d-&gt;nc];
	return t;
}

/* find the canonical form a given Reiset */
static Reiset*
findreiset(Deter *d, Reiset *s)
{
	int i, szinst;
	uint h;
	Reiset *t;

	h = 0;
	for(i=0; i&lt;s-&gt;ninst; i++)
		h = h*1000003 + s-&gt;inst[i];
	h %= d-&gt;nhash;

	szinst = s-&gt;ninst*sizeof(s-&gt;inst[0]);
	for(t=d-&gt;hash[h]; t; t=t-&gt;hash)
		if(t-&gt;ninst==s-&gt;ninst &amp;&amp; memcmp(t-&gt;inst, s-&gt;inst, szinst)==0)
			return t;

	t = ralloc(d, s-&gt;ninst);
	t-&gt;hash = d-&gt;hash[h];
	d-&gt;hash[h] = t;

	*d-&gt;last = t;
	d-&gt;last = &amp;t-&gt;next;
	t-&gt;next = 0;

	t-&gt;ninst = s-&gt;ninst;
	memmove(t-&gt;inst, s-&gt;inst, szinst);

	/* delta is filled in later */

	return t;
}

/* convert bits to a real reiset */
static Reiset*
bits2reiset(Deter *d, uchar *bits)
{
	int k;
	Reiset *s;

	s = d-&gt;tmp;
	s-&gt;ninst = 0;
	for(k=0; k&lt;d-&gt;ninst; k++)
		if(bits[k])
			s-&gt;inst[s-&gt;ninst++] = k;
	return findreiset(d, s);
}

/* add n to state set; if n &lt; k, need to go around again */
static int
add(int n, uchar *bits, int k)
{
	if(bits[n])
		return 0;
	bits[n] = 1;
	return n &lt; k;
}

/* update bits to follow all the empty (non-character-related) transitions possible */
static void
followempty(Deter *d, uchar *bits, int bol, int eol)
{
	int again, k;
	Reinst *i;

	do{
		again = 0;
		for(i=d-&gt;p-&gt;firstinst, k=0; k &lt; d-&gt;ninst; i++, k++){
			if(!bits[k])
				continue;
			switch(i-&gt;type){
			case RBRA:
			case LBRA:
				again |= add(i-&gt;next - d-&gt;p-&gt;firstinst, bits, k);
				break;
			case OR:
				again |= add(i-&gt;left - d-&gt;p-&gt;firstinst, bits, k);
				again |= add(i-&gt;right - d-&gt;p-&gt;firstinst, bits, k);
				break;
			case BOL:
				if(bol)
					again |= add(i-&gt;next - d-&gt;p-&gt;firstinst, bits, k);
				break;
			case EOL:
				if(eol)
					again |= add(i-&gt;next - d-&gt;p-&gt;firstinst, bits, k);
				break;
			}
		}
	}while(again);

	/*
	 * Clear bits for useless transitions.  We could do this during
	 * the switch above, but then we have no guarantee of termination
	 * if we get a loop in the regexp.
	 */
	for(i=d-&gt;p-&gt;firstinst, k=0; k &lt; d-&gt;ninst; i++, k++){
		if(!bits[k])
			continue;
		switch(i-&gt;type){
		case RBRA:
		case LBRA:
		case OR:
		case BOL:
		case EOL:
			bits[k] = 0;
			break;
		}
	}
}

/*
 * Where does s go if it sees rune r?
 * Eol is true if a $ matches the string at the position just after r.
 */
static Reiset*
transition(Deter *d, Reiset *s, Rune r, uint eol)
{
	int k;
	uchar *bits;
	Reinst *i, *inst0;
	Rune *rp, *ep;

	bits = d-&gt;bits;
	memset(bits, 0, d-&gt;ninst);

	inst0 = d-&gt;p-&gt;firstinst;
	for(k=0; k &lt; s-&gt;ninst; k++){
		i = inst0 + s-&gt;inst[k];
		switch(i-&gt;type){
		default:
			werrstr("bad reprog: got type %d", i-&gt;type);
			longjmp(d-&gt;kaboom, 1);
		case RBRA:
		case LBRA:
		case OR:
		case BOL:
		case EOL:
			werrstr("internal error: got type %d", i-&gt;type);
			longjmp(d-&gt;kaboom, 1);

		case RUNE:
			if(r == i-&gt;r)
				bits[i-&gt;next - inst0] = 1;
			break;
		case ANY:
			if(r != L'\n')
				bits[i-&gt;next - inst0] = 1;
			break;
		case ANYNL:
			bits[i-&gt;next - inst0] = 1;
			break;
		case NCCLASS:
			if(r == L'\n')
				break;
			/* fall through */
		case CCLASS:
			ep = i-&gt;cp-&gt;end;
			for(rp = i-&gt;cp-&gt;spans; rp &lt; ep; rp += 2)
				if(rp[0] &lt;= r &amp;&amp; r &lt;= rp[1])
					break;
			if((rp &lt; ep) ^! (i-&gt;type == CCLASS))
				bits[i-&gt;next - inst0] = 1;
			break;
		case END:
			break;
		}
	}

	followempty(d, bits, r=='\n', eol);
	return bits2reiset(d, bits);
}

static int
countinst(Reprog *pp)
{
	int n;
	Reinst *l;

	n = 0;
	l = pp-&gt;firstinst;
	while(l++-&gt;type)
		n++;
	return n;
}

static void
set(Deter *d, u32int **tab, Rune r)
{
	u32int *u;

	if((u = tab[r/4096]) == nil){
		u = binalloc(&amp;d-&gt;bin, 4096/8, 1);
		if(u == nil)
			longjmp(d-&gt;kaboom, 1);
		tab[r/4096] = u;
	}
	u[(r%4096)/32] |= 1&lt;&lt;(r%32);
}

/*
 * Compute the list of important characters. 
 * Other characters behave like the ones that surround them.
 */
static void
findchars(Deter *d, Reprog *p)
{
	u32int *tab[65536/4096], *u, x;
	Reinst *i;
	Rune *rp, *ep;
	int k, m, n, a;

	memset(tab, 0, sizeof tab);
	set(d, tab, 0);
	set(d, tab, 0xFFFF);
	for(i=p-&gt;firstinst; i-&gt;type; i++){
		switch(i-&gt;type){
		case ANY:
			set(d, tab, L'\n'-1);
			set(d, tab, L'\n');
			set(d, tab, L'\n'+1);
			break;
		case RUNE:
			set(d, tab, i-&gt;r-1);
			set(d, tab, i-&gt;r);
			set(d, tab, i-&gt;r+1);
			break;
		case NCCLASS:
			set(d, tab, L'\n'-1);
			set(d, tab, L'\n');
			set(d, tab, L'\n'+1);
			/* fall through */
		case CCLASS:
			ep = i-&gt;cp-&gt;end;
			for(rp = i-&gt;cp-&gt;spans; rp &lt; ep; rp += 2){
				set(d, tab, rp[0]-1);
				set(d, tab, rp[0]);
				set(d, tab, rp[1]);
				set(d, tab, rp[1]+1);
			}
			break;
		}
	}

	n = 0;
	for(k=0; k&lt;nelem(tab); k++){
		if((u = tab[k]) == nil)
			continue;
		for(m=0; m&lt;4096/32; m++){
			if((x = u[m]) == 0)
				continue;
			for(a=0; a&lt;32; a++)
				if(x&amp;(1&lt;&lt;a))
					n++;
		}
	}

	d-&gt;c = binalloc(&amp;d-&gt;bin, (n+1)*sizeof(Rune), 0);
	if(d-&gt;c == 0)
		longjmp(d-&gt;kaboom, 1);
	d-&gt;nc = n;

	n = 0;
	for(k=0; k&lt;nelem(tab); k++){
		if((u = tab[k]) == nil)
			continue;
		for(m=0; m&lt;4096/32; m++){
			if((x = u[m]) == 0)
				continue;
			for(a=0; a&lt;32; a++)
				if(x&amp;(1&lt;&lt;a))
					d-&gt;c[n++] = k*4096+m*32+a;
		}
	}

	d-&gt;c[n] = 0;
	if(n != d-&gt;nc)
		abort();
}

/*
 * convert the Deter and Reisets into a Dreprog.
 * if dp and c are nil, just return the count of Drecases needed.
 */
static int
buildprog(Deter *d, Reiset **id2set, int nid, Dreprog *dp, Drecase *c)
{
	int i, j, id, n, nn;
	Dreinst *di;
	Reiset *s;

	nn = 0;
	di = 0;
	for(i=0; i&lt;nid; i++){
		s = id2set[i];
		if(c){
			di = &amp;dp-&gt;inst[i];
			di-&gt;isfinal = s-&gt;isfinal;
		}
		n = 0;
		id = -1;
		for(j=0; j&lt;2*d-&gt;nc; j++){
			if(s-&gt;delta[j]-&gt;id != id){
				id = s-&gt;delta[j]-&gt;id;
				if(c){
					c[n].start = ((j/d-&gt;nc)&lt;&lt;16) | d-&gt;c[j%d-&gt;nc];
					c[n].next = &amp;dp-&gt;inst[id];
				}
				n++;
			}
		}
		if(c){
			if(n == 1 &amp;&amp; c[0].next == di)
				di-&gt;isloop = 1;
			di-&gt;c = c;
			di-&gt;nc = n;
			c += n;
		}
		nn += n;
	}
	return nn;
}

Dreprog*
dregcvt(Reprog *p)
{
	uchar *bits;
	uint again, n, nid, id;
	Deter d;
	Reiset **id2set, *s, *t, *start[4];
	Dreprog *dp;
	Drecase *c;

	memset(&amp;d, 0, sizeof d);

	if(setjmp(d.kaboom)){
		binfree(&amp;d.bin);
		return nil;
	}

	d.p = p;
	d.ninst = countinst(p);

	d.last = &amp;d.alloc;

	n = d.ninst;
	/* round up to power of two; this loop is the least of our efficiency problems */
	while(n&amp;(n-1))
		n++;
	d.nhash = n;
	d.hash = binalloc(&amp;d.bin, d.nhash*sizeof(Reinst*), 1);

	/* get list of important runes */
	findchars(&amp;d, p);

#ifdef DUMP
	print("relevant chars are: «%S»\n", d.c+1);
#endif

	d.bits = bits = binalloc(&amp;d.bin, d.ninst, 0);
	d.tmp = ralloc(&amp;d, d.ninst);

	/*
	 * Convert to DFA
	 */

	/* 4 start states, depending on initial bol, eol */
	for(n=0; n&lt;4; n++){
		memset(bits, 0, d.ninst);
		bits[p-&gt;startinst - p-&gt;firstinst] = 1;
		followempty(&amp;d, bits, n&amp;1, n&amp;2);
		start[n] = bits2reiset(&amp;d, bits);
	}

	/* explore the reiset space */
	for(s=d.alloc; s; s=s-&gt;next)
		for(n=0; n&lt;2*d.nc; n++)
			s-&gt;delta[n] = transition(&amp;d, s, d.c[n%d.nc], n/d.nc);

#ifdef DUMP
	nid = 0;
	for(s=d.alloc; s; s=s-&gt;next)
		s-&gt;id = nid++;
	ddump(&amp;d);
#endif

	/*
	 * Minimize.
	 */

	/* first class division is final or not */
	for(s=d.alloc; s; s=s-&gt;next){
		s-&gt;isfinal = 0;
		for(n=0; n&lt;s-&gt;ninst; n++)
			if(p-&gt;firstinst[s-&gt;inst[n]].type == END)
				s-&gt;isfinal = 1;
		s-&gt;id = s-&gt;isfinal;
	}

	/* divide states with different transition tables in id space */
	nid = 2;
	do{
		again = 0;
		for(s=d.alloc; s; s=s-&gt;next){
			id = -1;
			for(t=s-&gt;next; t; t=t-&gt;next){
				if(s-&gt;id != t-&gt;id)
					continue;
				for(n=0; n&lt;2*d.nc; n++){
					/* until we finish the for(t) loop, s-&gt;id and id are same */
					if((s-&gt;delta[n]-&gt;id == t-&gt;delta[n]-&gt;id)
					|| (s-&gt;delta[n]-&gt;id == s-&gt;id &amp;&amp; t-&gt;delta[n]-&gt;id == id)
					|| (s-&gt;delta[n]-&gt;id == id &amp;&amp; t-&gt;delta[n]-&gt;id == s-&gt;id))
						continue;
					break;
				}
				if(n == 2*d.nc)
					continue;
				if(id == -1)
					id = nid++;
				t-&gt;id = id;
				again = 1;
			}
		}
	}while(again);

#ifdef DUMP
	ddump(&amp;d);
#endif

	/* build dreprog */
	id2set = binalloc(&amp;d.bin, nid*sizeof(Reiset*), 1);
	if(id2set == nil)
		longjmp(d.kaboom, 1);
	for(s=d.alloc; s; s=s-&gt;next)
		id2set[s-&gt;id] = s;

	n = buildprog(&amp;d, id2set, nid, nil, nil);
	dp = mallocz(sizeof(Dreprog)+nid*sizeof(Dreinst)+n*sizeof(Drecase), 1);
	if(dp == nil)
		longjmp(d.kaboom, 1);
	c = (Drecase*)&amp;dp-&gt;inst[nid];
	buildprog(&amp;d, id2set, nid, dp, c);

	for(n=0; n&lt;4; n++)
		dp-&gt;start[n] = &amp;dp-&gt;inst[start[n]-&gt;id];
	dp-&gt;ninst = nid;

	binfree(&amp;d.bin);
	return dp;
}

int
dregexec(Dreprog *p, char *s, int bol)
{
	Rune r;
	ulong rr;
	Dreinst *i;
	Drecase *c, *ec;
	int best, n;
	char *os;

	i = p-&gt;start[(bol ? 1 : 0) | (s[1]=='\n' ? 2 : 0)];
	best = -1;
	os = s;
	for(; *s; s+=n){
		if(i-&gt;isfinal)
			best = s - os;
		if(i-&gt;isloop){
			if(i-&gt;isfinal)
				return strlen(os);
			else
				return best;
		}
		if((*s&amp;0xFF) &lt; Runeself){
			r = *s;
			n = 1;
		}else
			n = chartorune(&amp;r, s);
		c = i-&gt;c;
		ec = c+i-&gt;nc;
		rr = r;
		if(s[n] == '\n' || s[n] == '\0')
			rr |= 0x10000;
		for(; c&lt;ec; c++){
			if(c-&gt;start &gt; rr){
				i = c[-1].next;
				goto Out;
			}
		}
		i = ec[-1].next;
	Out:;
	}
	if(i-&gt;isfinal)
		best = s - os;
	return best;
}


#ifdef DUMP
void
ddump(Deter *d)
{
	int i, id;
	Reiset *s;

	for(s=d-&gt;alloc; s; s=s-&gt;next){
		print("%d ", s-&gt;id);
		id = -1;
		for(i=0; i&lt;2*d-&gt;nc; i++){
			if(id != s-&gt;delta[i]-&gt;id){
				if(i==0)
					print(" [");
				else if(i/d-&gt;nc)
					print(" [%C$", d-&gt;c[i%d-&gt;nc]);
				else
					print(" [%C", d-&gt;c[i%d-&gt;nc]);
				print(" %d]", s-&gt;delta[i]-&gt;id);
				id = s-&gt;delta[i]-&gt;id;
			}
		}
		print("\n");
	}
}

void
rdump(Reprog *pp)
{
	Reinst *l;
	Rune *p;

	l = pp-&gt;firstinst;
	do{
		print("%ld:\t0%o\t%ld\t%ld", l-pp-&gt;firstinst, l-&gt;type,
			l-&gt;left-pp-&gt;firstinst, l-&gt;right-pp-&gt;firstinst);
		if(l-&gt;type == RUNE)
			print("\t%C\n", l-&gt;r);
		else if(l-&gt;type == CCLASS || l-&gt;type == NCCLASS){
			print("\t[");
			if(l-&gt;type == NCCLASS)
				print("^");
			for(p = l-&gt;cp-&gt;spans; p &lt; l-&gt;cp-&gt;end; p += 2)
				if(p[0] == p[1])
					print("%C", p[0]);
				else
					print("%C-%C", p[0], p[1]);
			print("]\n");
		} else
			print("\n");
	}while(l++-&gt;type);
}

void
dump(Dreprog *pp)
{
	int i, j;
	Dreinst *l;

	print("start %ld %ld %ld %ld\n",
		pp-&gt;start[0]-pp-&gt;inst,
		pp-&gt;start[1]-pp-&gt;inst,
		pp-&gt;start[2]-pp-&gt;inst,
		pp-&gt;start[3]-pp-&gt;inst);

	for(i=0; i&lt;pp-&gt;ninst; i++){
		l = &amp;pp-&gt;inst[i];
		print("%d:", i);
		for(j=0; j&lt;l-&gt;nc; j++){
			print(" [");
			if(j == 0)
				if(l-&gt;c[j].start != 1)
					abort();
			if(j != 0)
				print("%C%s", l-&gt;c[j].start&amp;0xFFFF, (l-&gt;c[j].start&amp;0x10000) ? "$" : "");
			print("-");
			if(j != l-&gt;nc-1)
				print("%C%s", (l-&gt;c[j+1].start&amp;0xFFFF)-1, (l-&gt;c[j+1].start&amp;0x10000) ? "$" : "");
			print("] %ld", l-&gt;c[j].next - pp-&gt;inst);
		}
		if(l-&gt;isfinal)
			print(" final");
		if(l-&gt;isloop)
			print(" loop");
		print("\n");
	}
}


void
main(int argc, char **argv)
{
	int i;
	Reprog *p;
	Dreprog *dp;

	i = 1;
		p = regcomp(argv[i]);
		if(p == 0){
			print("=== %s: bad regexp\n", argv[i]);
		}
	//	print("=== %s\n", argv[i]);
	//	rdump(p);
		dp = dregcvt(p);
		print("=== dfa\n");
		dump(dp);
	
	for(i=2; i&lt;argc; i++)
		print("match %d\n", dregexec(dp, argv[i], 0));
	exits(0);
}
#endif

void
Bprintdfa(Biobuf *b, Dreprog *p)
{
	int i, j, nc;

	Bprint(b, "# dreprog\n");
	nc = 0;
	for(i=0; i&lt;p-&gt;ninst; i++)
		nc += p-&gt;inst[i].nc;
	Bprint(b, "%d %d %ld %ld %ld %ld\n", p-&gt;ninst, nc,
		p-&gt;start[0]-p-&gt;inst, p-&gt;start[1]-p-&gt;inst,
		p-&gt;start[2]-p-&gt;inst, p-&gt;start[3]-p-&gt;inst);
	for(i=0; i&lt;p-&gt;ninst; i++){
		Bprint(b, "%d %d %d", p-&gt;inst[i].isfinal, p-&gt;inst[i].isloop, p-&gt;inst[i].nc);
		for(j=0; j&lt;p-&gt;inst[i].nc; j++)
			Bprint(b, " %d %ld", p-&gt;inst[i].c[j].start, p-&gt;inst[i].c[j].next-p-&gt;inst);
		Bprint(b, "\n");
	}
}

static char*
egetline(Biobuf *b, int c, jmp_buf jb)
{
	char *p;

	p = Brdline(b, c);
	if(p == nil)
		longjmp(jb, 1);
	p[Blinelen(b)-1] = '\0';
	return p;
}

static void
egetc(Biobuf *b, int c, jmp_buf jb)
{
	if(Bgetc(b) != c)
		longjmp(jb, 1);
}

static int
egetnum(Biobuf *b, int want, jmp_buf jb)
{
	int c;
	int n, first;

	n = 0;
	first = 1;
	while((c = Bgetc(b)) != Beof){
		if(c &lt; '0' || c &gt; '9'){
			if(want == 0){
				Bungetc(b);
				c = 0;
			}
			if(first || c != want){
				werrstr("format error");
				longjmp(jb, 1);
			}
			return n;
		}
		n = n*10 + c - '0';
		first = 0;
	}
	werrstr("unexpected eof");
	longjmp(jb, 1);
	return -1;
}

Dreprog*
Breaddfa(Biobuf *b)
{
	char *s;
	int ninst, nc;
	jmp_buf jb;
	Dreprog *p;
	Drecase *c;
	Dreinst *l;
	int j, k;

	p = nil;
	if(setjmp(jb)){
		free(p);
		return nil;
	}

	s = egetline(b, '\n', jb);
	if(strcmp(s, "# dreprog") != 0){
		werrstr("format error");
		longjmp(jb, 1);
	}

	ninst = egetnum(b, ' ', jb);
	nc = egetnum(b, ' ', jb);

	p = mallocz(sizeof(Dreprog)+ninst*sizeof(Dreinst)+nc*sizeof(Drecase), 1);
	if(p == nil)
		longjmp(jb, 1);
	c = (Drecase*)&amp;p-&gt;inst[ninst];

	p-&gt;start[0] = &amp;p-&gt;inst[egetnum(b, ' ', jb)];
	p-&gt;start[1] = &amp;p-&gt;inst[egetnum(b, ' ', jb)];
	p-&gt;start[2] = &amp;p-&gt;inst[egetnum(b, ' ', jb)];
	p-&gt;start[3] = &amp;p-&gt;inst[egetnum(b, '\n', jb)];

	for(j=0; j&lt;ninst; j++){
		l = &amp;p-&gt;inst[j];
		l-&gt;isfinal = egetnum(b, ' ', jb);
		l-&gt;isloop = egetnum(b, ' ', jb);
		l-&gt;nc = egetnum(b, 0, jb);
		l-&gt;c = c;
		for(k=0; k&lt;l-&gt;nc; k++){
			egetc(b, ' ', jb);
			c-&gt;start = egetnum(b, ' ', jb);
			c-&gt;next = &amp;p-&gt;inst[egetnum(b, 0, jb)];
			c++;
		}
		egetc(b, '\n', jb);
	}
	return p;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

