<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/common/process.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/common/process.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"

/* make a stream to a child process */
extern stream *
instream(void)
{
	stream *rv;
	int pfd[2];

	if ((rv = (stream *)malloc(sizeof(stream))) == 0)
		return 0;
	memset(rv, 0, sizeof(stream));
	if (pipe(pfd) &lt; 0)
		return 0;
	if(Binit(&amp;rv-&gt;bb, pfd[1], OWRITE) &lt; 0){
		close(pfd[0]);
		close(pfd[1]);
		return 0;
	}
	rv-&gt;fp = &amp;rv-&gt;bb;
	rv-&gt;fd = pfd[0];	
	return rv;
}

/* make a stream from a child process */
extern stream *
outstream(void)
{
	stream *rv;
	int pfd[2];

	if ((rv = (stream *)malloc(sizeof(stream))) == 0)
		return 0;
	memset(rv, 0, sizeof(stream));
	if (pipe(pfd) &lt; 0)
		return 0;
	if (Binit(&amp;rv-&gt;bb, pfd[0], OREAD) &lt; 0){
		close(pfd[0]);
		close(pfd[1]);
		return 0;
	}
	rv-&gt;fp = &amp;rv-&gt;bb;
	rv-&gt;fd = pfd[1];
	return rv;
}

extern void
stream_free(stream *sp)
{
	int fd;

	close(sp-&gt;fd);
	fd = Bfildes(sp-&gt;fp);
	Bterm(sp-&gt;fp);
	close(fd);
	free((char *)sp);
}

/* start a new process */
extern process *
noshell_proc_start(char **av, stream *inp, stream *outp, stream *errp, int newpg, char *who)
{
	process *pp;
	int i, n;

	if ((pp = (process *)malloc(sizeof(process))) == 0) {
		if (inp != 0)
			stream_free(inp);
		if (outp != 0)
			stream_free(outp);
		if (errp != 0)
			stream_free(errp);
		return 0;
	}
	pp-&gt;std[0] = inp;
	pp-&gt;std[1] = outp;
	pp-&gt;std[2] = errp;
	switch (pp-&gt;pid = fork()) {
	case -1:
		proc_free(pp);
		return 0;
	case 0:
		if(newpg)
			sysdetach();
		for (i=0; i&lt;3; i++)
			if (pp-&gt;std[i] != 0){
				close(Bfildes(pp-&gt;std[i]-&gt;fp));
				while(pp-&gt;std[i]-&gt;fd &lt; 3)
					pp-&gt;std[i]-&gt;fd = dup(pp-&gt;std[i]-&gt;fd, -1);
			}
		for (i=0; i&lt;3; i++)
			if (pp-&gt;std[i] != 0)
				dup(pp-&gt;std[i]-&gt;fd, i);
		for (n = sysfiles(); i &lt; n; i++)
			close(i);
		if(who)
			become(av, who);
		exec(av[0], av);
		perror("proc_start");
		exits("proc_start");
	default:
		for (i=0; i&lt;3; i++)
			if (pp-&gt;std[i] != 0) {
				close(pp-&gt;std[i]-&gt;fd);
				pp-&gt;std[i]-&gt;fd = -1;
			}
		return pp;
	}
}

/* start a new process under a shell */
extern process *
proc_start(char *cmd, stream *inp, stream *outp, stream *errp, int newpg, char *who)
{
	char *av[4];

	av[0] = SHELL;
	av[1] = "-c";
	av[2] = cmd;
	av[3] = 0;
	return noshell_proc_start(av, inp, outp, errp, newpg, who);
}

/* wait for a process to stop */
extern int
proc_wait(process *pp)
{
	Waitmsg *status;
	char err[Errlen];

	for(;;){
		status = wait();
		if(status == nil){
			rerrstr(err, sizeof(err));
			if(strstr(err, "interrupt") == 0)
				break;
		}
		if (status-&gt;pid==pp-&gt;pid)
			break;
	}
	pp-&gt;pid = -1;
	if(status == nil)
		pp-&gt;status = -1;
	else
		pp-&gt;status = status-&gt;msg[0];
	pp-&gt;waitmsg = status;
	return pp-&gt;status;
}

/* free a process */
extern int
proc_free(process *pp)
{
	int i;

	if(pp-&gt;std[1] == pp-&gt;std[2])
		pp-&gt;std[2] = 0;		/* avoid freeing it twice */
	for (i = 0; i &lt; 3; i++)
		if (pp-&gt;std[i])
			stream_free(pp-&gt;std[i]);
	if (pp-&gt;pid &gt;= 0)
		proc_wait(pp);
	free(pp-&gt;waitmsg);
	free((char *)pp);
	return 0;
}

/* kill a process */
extern int
proc_kill(process *pp)
{
	return syskill(pp-&gt;pid);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

