<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/fs/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/fs/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ctype.h&gt;
#include "dat.h"

enum
{
	OPERM	= 0x3,		// mask of all permission types in open mode
};

typedef struct Fid Fid;

struct Fid
{
	Qid	qid;
	short	busy;
	short	open;
	int	fid;
	Fid	*next;
	Mailbox	*mb;
	Message	*m;
	Message *mtop;		// top level message

	//finger pointers to speed up reads of large directories
	long	foff;	// offset/DIRLEN of finger
	Message	*fptr;	// pointer to message at off
	int	fvers;	// mailbox version when finger was saved
};

ulong	path;		// incremented for each new file
Fid	*fids;
int	mfd[2];
char	user[Elemlen];
int	messagesize = 4*1024+IOHDRSZ;
uchar	mdata[8*1024+IOHDRSZ];
uchar	mbuf[8*1024+IOHDRSZ];
Fcall	thdr;
Fcall	rhdr;
int	fflg;
char	*mntpt;
int	biffing;
int	plumbing = 1;

QLock	mbllock;
Mailbox	*mbl;

Fid		*newfid(int);
void		error(char*);
void		io(void);
void		*erealloc(void*, ulong);
void		*emalloc(ulong);
void		usage(void);
void		reader(void);
int		readheader(Message*, char*, int, int);
int		cistrncmp(char*, char*, int);
int		tokenconvert(String*, char*, int);
String*		stringconvert(String*, char*, int);
void		post(char*, char*, int);

char	*rflush(Fid*), *rauth(Fid*),
	*rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*),
	*rversion(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"upas/fs: authentication not required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Ebadctl[] =	"unknown control message";

char *dirtab[] =
{
[Qdir]		".",
[Qbody]		"body",
[Qbcc]		"bcc",
[Qcc]		"cc",
[Qdate]		"date",
[Qdigest]	"digest",
[Qdisposition]	"disposition",
[Qfilename]	"filename",
[Qfrom]		"from",
[Qheader]	"header",
[Qinfo]		"info",
[Qinreplyto]	"inreplyto",
[Qlines]	"lines",
[Qmimeheader]	"mimeheader",
[Qmessageid]	"messageid",
[Qraw]		"raw",
[Qrawunix]	"rawunix",
[Qrawbody]	"rawbody",
[Qrawheader]	"rawheader",
[Qreplyto]	"replyto",
[Qsender]	"sender",
[Qsubject]	"subject",
[Qto]		"to",
[Qtype]		"type",
[Qunixdate]	"unixdate",
[Qunixheader]	"unixheader",
[Qctl]		"ctl",
[Qmboxctl]	"ctl",
};

enum
{
	Hsize=	1277,
};

Hash	*htab[Hsize];

int	debug;
int	fflag;
int	logging;

void
usage(void)
{
	fprint(2, "usage: upas/fs [-bdlnps] [-f mboxfile] [-m mountpoint]\n");
	exits("usage");
}

void
notifyf(void *a, char *s)
{
	USED(a);
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

void
main(int argc, char *argv[])
{
	int p[2], std, nodflt;
	char maildir[128];
	char mbox[128];
	char *mboxfile, *err;
	char srvfile[64];
	int srvpost;

	rfork(RFNOTEG);
	mntpt = nil;
	fflag = 0;
	mboxfile = nil;
	std = 0;
	nodflt = 0;
	srvpost = 0;

	ARGBEGIN{
	case 'b':
		biffing = 1;
		break;
	case 'f':
		fflag = 1;
		mboxfile = EARGF(usage());
		break;
	case 'm':
		mntpt = EARGF(usage());
		break;
	case 'd':
		debug = 1;
		break;
	case 'p':
		plumbing = 0;
		break;
	case 's':
		srvpost = 1;
		break;
	case 'l':
		logging = 1;
		break;
	case 'n':
		nodflt = 1;
		break;
	default:
		usage();
	}ARGEND

	if(argc)
		usage();
	if(pipe(p) &lt; 0)
		error("pipe failed");
	mfd[0] = p[0];
	mfd[1] = p[0];

	notify(notifyf);
	strcpy(user, getuser());
	if(mntpt == nil){
		snprint(maildir, sizeof(maildir), "/mail/fs");
		mntpt = maildir;
	}
	if(mboxfile == nil &amp;&amp; !nodflt){
		snprint(mbox, sizeof(mbox), "/mail/box/%s/mbox", user);
		mboxfile = mbox;
		std = 1;
	}

	if(debug)
		fmtinstall('F', fcallfmt);

	if(mboxfile != nil){
		err = newmbox(mboxfile, "mbox", std);
		if(err != nil)
			sysfatal("opening %s: %s", mboxfile, err);
	}

	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFNOTEG|RFREND)){
	case -1:
		error("fork");
	case 0:
		henter(PATH(0, Qtop), dirtab[Qctl],
			(Qid){PATH(0, Qctl), 0, QTFILE}, nil, nil);
		close(p[1]);
		io();
		postnote(PNGROUP, getpid(), "die yankee pig dog");
		break;
	default:
		close(p[0]);	/* don't deadlock if child fails */
		if(srvpost){
			sprint(srvfile, "/srv/upasfs.%s", user);
			post(srvfile, "upasfs", p[1]);
		} else {
			if(mount(p[1], -1, mntpt, MREPL, "") &lt; 0)
				error("mount failed");
		}
	}
	exits(0);
}

static int
fileinfo(Message *m, int t, char **pp)
{
	char *p;
	int len;

	p = "";
	len = 0;
	switch(t){
	case Qbody:
		p = m-&gt;body;
		len = m-&gt;bend - m-&gt;body;
		break;
	case Qbcc:
		if(m-&gt;bcc822){
			p = s_to_c(m-&gt;bcc822);
			len = strlen(p);
		}
		break;
	case Qcc:
		if(m-&gt;cc822){
			p = s_to_c(m-&gt;cc822);
			len = strlen(p);
		}
		break;
	case Qdisposition:
		switch(m-&gt;disposition){
		case Dinline:
			p = "inline";
			break;
		case Dfile:
			p = "file";
			break;
		}
		len = strlen(p);
		break;
	case Qdate:
		if(m-&gt;date822){
			p = s_to_c(m-&gt;date822);
			len = strlen(p);
		} else if(m-&gt;unixdate != nil){
			p = s_to_c(m-&gt;unixdate);
			len = strlen(p);
		}
		break;
	case Qfilename:
		if(m-&gt;filename){
			p = s_to_c(m-&gt;filename);
			len = strlen(p);
		}
		break;
	case Qinreplyto:
		if(m-&gt;inreplyto822){
			p = s_to_c(m-&gt;inreplyto822);
			len = strlen(p);
		}
		break;
	case Qmessageid:
		if(m-&gt;messageid822){
			p = s_to_c(m-&gt;messageid822);
			len = strlen(p);
		}
		break;
	case Qfrom:
		if(m-&gt;from822){
			p = s_to_c(m-&gt;from822);
			len = strlen(p);
		} else if(m-&gt;unixfrom != nil){
			p = s_to_c(m-&gt;unixfrom);
			len = strlen(p);
		}
		break;
	case Qheader:
		p = m-&gt;header;
		len = headerlen(m);
		break;
	case Qlines:
		p = m-&gt;lines;
		if(*p == 0)
			countlines(m);
		len = strlen(m-&gt;lines);
		break;
	case Qraw:
		p = m-&gt;start;
		if(strncmp(m-&gt;start, "From ", 5) == 0){
			p = strchr(p, '\n');
			if(p == nil)
				p = m-&gt;start;
			else
				p++;
		}
		len = m-&gt;end - p;
		break;
	case Qrawunix:
		p = m-&gt;start;
		len = m-&gt;end - p;
		break;
	case Qrawbody:
		p = m-&gt;rbody;
		len = m-&gt;rbend - p;
		break;
	case Qrawheader:
		p = m-&gt;header;
		len = m-&gt;hend - p;
		break;
	case Qmimeheader:
		p = m-&gt;mheader;
		len = m-&gt;mhend - p;
		break;
	case Qreplyto:
		p = nil;
		if(m-&gt;replyto822 != nil){
			p = s_to_c(m-&gt;replyto822);
			len = strlen(p);
		} else if(m-&gt;from822 != nil){
			p = s_to_c(m-&gt;from822);
			len = strlen(p);
		} else if(m-&gt;sender822 != nil){
			p = s_to_c(m-&gt;sender822);
			len = strlen(p);
		} else if(m-&gt;unixfrom != nil){
			p = s_to_c(m-&gt;unixfrom);
			len = strlen(p);
		}
		break;
	case Qsender:
		if(m-&gt;sender822){
			p = s_to_c(m-&gt;sender822);
			len = strlen(p);
		}
		break;
	case Qsubject:
		p = nil;
		if(m-&gt;subject822){
			p = s_to_c(m-&gt;subject822);
			len = strlen(p);
		}
		break;
	case Qto:
		if(m-&gt;to822){
			p = s_to_c(m-&gt;to822);
			len = strlen(p);
		}
		break;
	case Qtype:
		if(m-&gt;type){
			p = s_to_c(m-&gt;type);
			len = strlen(p);
		}
		break;
	case Qunixdate:
		if(m-&gt;unixdate){
			p = s_to_c(m-&gt;unixdate);
			len = strlen(p);
		}
		break;
	case Qunixheader:
		if(m-&gt;unixheader){
			p = s_to_c(m-&gt;unixheader);
			len = s_len(m-&gt;unixheader);
		}
		break;
	case Qdigest:
		if(m-&gt;sdigest){
			p = s_to_c(m-&gt;sdigest);
			len = strlen(p);
		}
		break;
	}
	*pp = p;
	return len;
}

int infofields[] = {
	Qfrom,
	Qto,
	Qcc,
	Qreplyto,
	Qunixdate,
	Qsubject,
	Qtype,
	Qdisposition,
	Qfilename,
	Qdigest,
	Qbcc,
	Qinreplyto,
	Qdate,
	Qsender,
	Qmessageid,
	Qlines,
	-1,
};

static int
readinfo(Message *m, char *buf, long off, int count)
{
	char *p;
	int len, i, n;
	String *s;

	s = s_new();
	len = 0;
	for(i = 0; len &lt; count &amp;&amp; infofields[i] &gt;= 0; i++){
		n = fileinfo(m, infofields[i], &amp;p);
		s = stringconvert(s, p, n);
		s_append(s, "\n");
		p = s_to_c(s);
		n = strlen(p);
		if(off &gt; 0){
			if(off &gt;= n){
				off -= n;
				continue;
			}
			p += off;
			n -= off;
			off = 0;
		}
		if(n &gt; count - len)
			n = count - len;
		if(buf)
			memmove(buf+len, p, n);
		len += n;
	}
	s_free(s);
	return len;
}

static void
mkstat(Dir *d, Mailbox *mb, Message *m, int t)
{
	char *p;

	d-&gt;uid = user;
	d-&gt;gid = user;
	d-&gt;muid = user;
	d-&gt;mode = 0444;
	d-&gt;qid.vers = 0;
	d-&gt;qid.type = QTFILE;
	d-&gt;type = 0;
	d-&gt;dev = 0;
	if(mb != nil &amp;&amp; mb-&gt;d != nil){
		d-&gt;atime = mb-&gt;d-&gt;atime;
		d-&gt;mtime = mb-&gt;d-&gt;mtime;
	} else {
		d-&gt;atime = time(0);
		d-&gt;mtime = d-&gt;atime;
	}

	switch(t){
	case Qtop:
		d-&gt;name = ".";
		d-&gt;mode = DMDIR|0555;
		d-&gt;atime = d-&gt;mtime = time(0);
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qtop);
		d-&gt;qid.type = QTDIR;
		break;
	case Qmbox:
		d-&gt;name = mb-&gt;name;
		d-&gt;mode = DMDIR|0555;
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(mb-&gt;id, Qmbox);
		d-&gt;qid.type = QTDIR;
		d-&gt;qid.vers = mb-&gt;vers;
		break;
	case Qdir:
		d-&gt;name = m-&gt;name;
		d-&gt;mode = DMDIR|0555;
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(m-&gt;id, Qdir);
		d-&gt;qid.type = QTDIR;
		break;
	case Qctl:
		d-&gt;name = dirtab[t];
		d-&gt;mode = 0666;
		d-&gt;atime = d-&gt;mtime = time(0);
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qctl);
		break;
	case Qmboxctl:
		d-&gt;name = dirtab[t];
		d-&gt;mode = 0222;
		d-&gt;atime = d-&gt;mtime = time(0);
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(mb-&gt;id, Qmboxctl);
		break;
	case Qinfo:
		d-&gt;name = dirtab[t];
		d-&gt;length = readinfo(m, nil, 0, 1&lt;&lt;30);
		d-&gt;qid.path = PATH(m-&gt;id, t);
		break;
	default:
		d-&gt;name = dirtab[t];
		d-&gt;length = fileinfo(m, t, &amp;p);
		d-&gt;qid.path = PATH(m-&gt;id, t);
		break;
	}
}

char*
rversion(Fid*)
{
	Fid *f;

	if(thdr.msize &lt; 256)
		return "max messagesize too small";
	if(thdr.msize &lt; messagesize)
		messagesize = thdr.msize;
	rhdr.msize = messagesize;
	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return "unknown 9P version";
	else
		rhdr.version = "9P2000";
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);
	return nil;
}

char*
rauth(Fid*)
{
	return Enoauth;
}

char*
rflush(Fid *f)
{
	USED(f);
	return 0;
}

char*
rattach(Fid *f)
{
	f-&gt;busy = 1;
	f-&gt;m = nil;
	f-&gt;mb = nil;
	f-&gt;qid.path = PATH(0, Qtop);
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.vers = 0;
	rhdr.qid = f-&gt;qid;
	if(strcmp(thdr.uname, user) != 0)
		return Eperm;
	return 0;
}

static Fid*
doclone(Fid *f, int nfid)
{
	Fid *nf;

	nf = newfid(nfid);
	if(nf-&gt;busy)
		return nil;
	nf-&gt;busy = 1;
	nf-&gt;open = 0;
	nf-&gt;m = f-&gt;m;
	nf-&gt;mtop = f-&gt;mtop;
	nf-&gt;mb = f-&gt;mb;
	if(f-&gt;mb != nil)
		mboxincref(f-&gt;mb);
	if(f-&gt;mtop != nil){
		qlock(f-&gt;mb);
		msgincref(f-&gt;mtop);
		qunlock(f-&gt;mb);
	}
	nf-&gt;qid = f-&gt;qid;
	return nf;
}

char*
dowalk(Fid *f, char *name)
{
	int t;
	Mailbox *omb, *mb;
	char *rv, *p;
	Hash *h;

	t = FILE(f-&gt;qid.path);

	rv = Enotexist;

	omb = f-&gt;mb;
	if(omb)
		qlock(omb);
	else
		qlock(&amp;mbllock);

	// this must catch everything except . and ..
retry:
	h = hlook(f-&gt;qid.path, name);
	if(h != nil){
		f-&gt;mb = h-&gt;mb;
		f-&gt;m = h-&gt;m;
		switch(t){
		case Qtop:
			if(f-&gt;mb != nil)
				mboxincref(f-&gt;mb);
			break;
		case Qmbox:
			if(f-&gt;m){
				msgincref(f-&gt;m);
				f-&gt;mtop = f-&gt;m;
			}
			break;
		}
		f-&gt;qid = h-&gt;qid;
		rv = nil;
	} else if((p = strchr(name, '.')) != nil &amp;&amp; *name != '.'){
		*p = 0;
		goto retry;
	}

	if(omb)
		qunlock(omb);
	else
		qunlock(&amp;mbllock);
	if(rv == nil)
		return rv;

	if(strcmp(name, ".") == 0)
		return nil;

	if(f-&gt;qid.type != QTDIR)
		return Enotdir;

	if(strcmp(name, "..") == 0){
		switch(t){
		case Qtop:
			f-&gt;qid.path = PATH(0, Qtop);
			f-&gt;qid.type = QTDIR;
			f-&gt;qid.vers = 0;
			break;
		case Qmbox:
			f-&gt;qid.path = PATH(0, Qtop);
			f-&gt;qid.type = QTDIR;
			f-&gt;qid.vers = 0;
			qlock(&amp;mbllock);
			mb = f-&gt;mb;
			f-&gt;mb = nil;
			mboxdecref(mb);
			qunlock(&amp;mbllock);
			break;
		case Qdir:
			qlock(f-&gt;mb);
			if(f-&gt;m-&gt;whole == f-&gt;mb-&gt;root){
				f-&gt;qid.path = PATH(f-&gt;mb-&gt;id, Qmbox);
				f-&gt;qid.type = QTDIR;
				f-&gt;qid.vers = f-&gt;mb-&gt;d-&gt;qid.vers;
				msgdecref(f-&gt;mb, f-&gt;mtop);
				f-&gt;m = f-&gt;mtop = nil;
			} else {
				f-&gt;m = f-&gt;m-&gt;whole;
				f-&gt;qid.path = PATH(f-&gt;m-&gt;id, Qdir);
				f-&gt;qid.type = QTDIR;
			}
			qunlock(f-&gt;mb);
			break;
		}
		rv = nil;
	}
	return rv;
}

char*
rwalk(Fid *f)
{
	Fid *nf;
	char *rv;
	int i;

	if(f-&gt;open)
		return Eisopen;

	rhdr.nwqid = 0;
	nf = nil;

	/* clone if requested */
	if(thdr.newfid != thdr.fid){
		nf = doclone(f, thdr.newfid);
		if(nf == nil)
			return "new fid in use";
		f = nf;
	}

	/* if it's just a clone, return */
	if(thdr.nwname == 0 &amp;&amp; nf != nil)
		return nil;

	/* walk each element */
	rv = nil;
	for(i = 0; i &lt; thdr.nwname; i++){
		rv = dowalk(f, thdr.wname[i]);
		if(rv != nil){
			if(nf != nil)	
				rclunk(nf);
			break;
		}
		rhdr.wqid[i] = f-&gt;qid;
	}
	rhdr.nwqid = i;

	/* we only error out if no walk  */
	if(i &gt; 0)
		rv = nil;

	return rv;
}

char *
ropen(Fid *f)
{
	int file;

	if(f-&gt;open)
		return Eisopen;

	file = FILE(f-&gt;qid.path);
	if(thdr.mode != OREAD)
		if(file != Qctl &amp;&amp; file != Qmboxctl)
			return Eperm;

	// make sure we've decoded
	if(file == Qbody){
		if(f-&gt;m-&gt;decoded == 0)
			decode(f-&gt;m);
		if(f-&gt;m-&gt;converted == 0)
			convert(f-&gt;m);
	}

	rhdr.iounit = 0;
	rhdr.qid = f-&gt;qid;
	f-&gt;open = 1;
	return 0;
}

char *
rcreate(Fid*)
{
	return Eperm;
}

int
readtopdir(Fid*, uchar *buf, long off, int cnt, int blen)
{
	Dir d;
	int m, n;
	long pos;
	Mailbox *mb;

	n = 0;
	pos = 0;
	mkstat(&amp;d, nil, nil, Qctl);
	m = convD2M(&amp;d, &amp;buf[n], blen);
	if(off &lt;= pos){
		if(m &lt;= BIT16SZ || m &gt; cnt)
			return 0;
		n += m;
		cnt -= m;
	}
	pos += m;
		
	for(mb = mbl; mb != nil; mb = mb-&gt;next){
		mkstat(&amp;d, mb, nil, Qmbox);
		m = convD2M(&amp;d, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}
	return n;
}

int
readmboxdir(Fid *f, uchar *buf, long off, int cnt, int blen)
{
	Dir d;
	int n, m;
	long pos;
	Message *msg;

	n = 0;
	if(f-&gt;mb-&gt;ctl){
		mkstat(&amp;d, f-&gt;mb, nil, Qmboxctl);
		m = convD2M(&amp;d, &amp;buf[n], blen);
		if(off == 0){
			if(m &lt;= BIT16SZ || m &gt; cnt){
				f-&gt;fptr = nil;
				return 0;
			}
			n += m;
			cnt -= m;
		} else
			off -= m;
	}

	// to avoid n**2 reads of the directory, use a saved finger pointer
	if(f-&gt;mb-&gt;vers == f-&gt;fvers &amp;&amp; off &gt;= f-&gt;foff &amp;&amp; f-&gt;fptr != nil){
		msg = f-&gt;fptr;
		pos = f-&gt;foff;
	} else {
		msg = f-&gt;mb-&gt;root-&gt;part;
		pos = 0;
	} 

	for(; cnt &gt; 0 &amp;&amp; msg != nil; msg = msg-&gt;next){
		// act like deleted files aren't there
		if(msg-&gt;deleted)
			continue;

		mkstat(&amp;d, f-&gt;mb, msg, Qdir);
		m = convD2M(&amp;d, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}

	// save a finger pointer for next read of the mbox directory
	f-&gt;foff = pos;
	f-&gt;fptr = msg;
	f-&gt;fvers = f-&gt;mb-&gt;vers;

	return n;
}

int
readmsgdir(Fid *f, uchar *buf, long off, int cnt, int blen)
{
	Dir d;
	int i, n, m;
	long pos;
	Message *msg;

	n = 0;
	pos = 0;
	for(i = 0; i &lt; Qmax; i++){
		mkstat(&amp;d, f-&gt;mb, f-&gt;m, i);
		m = convD2M(&amp;d, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				return n;
			n += m;
			cnt -= m;
		}
		pos += m;
	}
	for(msg = f-&gt;m-&gt;part; msg != nil; msg = msg-&gt;next){
		mkstat(&amp;d, f-&gt;mb, msg, Qdir);
		m = convD2M(&amp;d, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}

	return n;
}

char*
rread(Fid *f)
{
	long off;
	int t, i, n, cnt;
	char *p;

	rhdr.count = 0;
	off = thdr.offset;
	cnt = thdr.count;

	if(cnt &gt; messagesize - IOHDRSZ)
		cnt = messagesize - IOHDRSZ;

	rhdr.data = (char*)mbuf;

	t = FILE(f-&gt;qid.path);
	if(f-&gt;qid.type &amp; QTDIR){
		if(t == Qtop) {
			qlock(&amp;mbllock);
			n = readtopdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
			qunlock(&amp;mbllock);
		} else if(t == Qmbox) {
			qlock(f-&gt;mb);
			if(off == 0)
				syncmbox(f-&gt;mb, 1);
			n = readmboxdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
			qunlock(f-&gt;mb);
		} else if(t == Qmboxctl) {
			n = 0;
		} else {
			n = readmsgdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
		}

		rhdr.count = n;
		return nil;
	}

	if(FILE(f-&gt;qid.path) == Qheader){
		rhdr.count = readheader(f-&gt;m, (char*)mbuf, off, cnt);
		return nil;
	}

	if(FILE(f-&gt;qid.path) == Qinfo){
		rhdr.count = readinfo(f-&gt;m, (char*)mbuf, off, cnt);
		return nil;
	}

	i = fileinfo(f-&gt;m, FILE(f-&gt;qid.path), &amp;p);
	if(off &lt; i){
		if((off + cnt) &gt; i)
			cnt = i - off;
		memmove(mbuf, p + off, cnt);
		rhdr.count = cnt;
	}
	return nil;
}

char*
rwrite(Fid *f)
{
	char *err;
	char *token[1024];
	int t, n;
	String *file;

	t = FILE(f-&gt;qid.path);
	rhdr.count = thdr.count;
	switch(t){
	case Qctl:
		if(thdr.count == 0)
			return Ebadctl;
		if(thdr.data[thdr.count-1] == '\n')
			thdr.data[thdr.count-1] = 0;
		else
			thdr.data[thdr.count] = 0;
		n = tokenize(thdr.data, token, nelem(token));
		if(n == 0)
			return Ebadctl;
		if(strcmp(token[0], "open") == 0){
			file = s_new();
			switch(n){
			case 1:
				err = Ebadctl;
				break;
			case 2:
				mboxpath(token[1], getlog(), file, 0);
				err = newmbox(s_to_c(file), nil, 0);
				break;
			default:
				mboxpath(token[1], getlog(), file, 0);
				if(strchr(token[2], '/') != nil)
					err = "/ not allowed in mailbox name";
				else
					err = newmbox(s_to_c(file), token[2], 0);
				break;
			}
			s_free(file);
			return err;
		}
		if(strcmp(token[0], "close") == 0){
			if(n &lt; 2)
				return nil;
			freembox(token[1]);
			return nil;
		}
		if(strcmp(token[0], "delete") == 0){
			if(n &lt; 3)
				return nil;
			delmessages(n-1, &amp;token[1]);
			return nil;
		}
		return Ebadctl;
	case Qmboxctl:
		if(f-&gt;mb &amp;&amp; f-&gt;mb-&gt;ctl){
			if(thdr.count == 0)
				return Ebadctl;
			if(thdr.data[thdr.count-1] == '\n')
				thdr.data[thdr.count-1] = 0;
			else
				thdr.data[thdr.count] = 0;
			n = tokenize(thdr.data, token, nelem(token));
			if(n == 0)
				return Ebadctl;
			return (*f-&gt;mb-&gt;ctl)(f-&gt;mb, n, token);
		}
	}
	return Eperm;
}

char *
rclunk(Fid *f)
{
	Mailbox *mb;

	f-&gt;busy = 0;
	f-&gt;open = 0;
	if(f-&gt;mtop != nil){
		qlock(f-&gt;mb);
		msgdecref(f-&gt;mb, f-&gt;mtop);
		qunlock(f-&gt;mb);
	}
	f-&gt;m = f-&gt;mtop = nil;
	mb = f-&gt;mb;
	if(mb != nil){
		f-&gt;mb = nil;
		assert(mb-&gt;refs &gt; 0);
		qlock(&amp;mbllock);
		mboxdecref(mb);
		qunlock(&amp;mbllock);
	}
	f-&gt;fid = -1;
	return 0;
}

char *
rremove(Fid *f)
{
	if(f-&gt;m != nil){
		if(f-&gt;m-&gt;deleted == 0)
			mailplumb(f-&gt;mb, f-&gt;m, 1);
		f-&gt;m-&gt;deleted = 1;
	}
	return rclunk(f);
}

char *
rstat(Fid *f)
{
	Dir d;

	if(FILE(f-&gt;qid.path) == Qmbox){
		qlock(f-&gt;mb);
		syncmbox(f-&gt;mb, 1);
		qunlock(f-&gt;mb);
	}
	mkstat(&amp;d, f-&gt;mb, f-&gt;m, FILE(f-&gt;qid.path));
	rhdr.nstat = convD2M(&amp;d, mbuf, messagesize - IOHDRSZ);
	rhdr.stat = mbuf;
	return 0;
}

char *
rwstat(Fid*)
{
	return Eperm;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		ff-&gt;fptr = nil;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;fptr = nil;
	f-&gt;next = fids;
	fids = f;
	return f;
}

int
fidmboxrefs(Mailbox *mb)
{
	Fid *f;
	int refs = 0;

	for(f = fids; f; f = f-&gt;next){
		if(f-&gt;mb == mb)
			refs++;
	}
	return refs;
}

void
io(void)
{
	char *err;
	int n;

	/* start a process to watch the mailboxes*/
	if(plumbing){
		switch(rfork(RFPROC|RFMEM)){
		case -1:
			/* oh well */
			break;
		case 0:
			reader();
			exits(nil);
		default:
			break;
		}
	}

	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		checkmboxrefs();
		n = read9pmsg(mfd[0], mdata, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0)
			return;
		if(convM2S(mdata, n, &amp;thdr) == 0)
			continue;

		if(debug)
			fprint(2, "%s:&lt;-%F\n", argv0, &amp;thdr);

		rhdr.data = (char*)mdata + messagesize;
		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[thdr.type])(newfid(thdr.fid));
		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		if(debug)
			fprint(2, "%s:-&gt;%F\n", argv0, &amp;rhdr);/**/
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(write(mfd[1], mdata, n) != n)
			error("mount write");
	}
}

void
reader(void)
{
	ulong t;
	Dir *d;
	Mailbox *mb;

	sleep(15*1000);
	for(;;){
		t = time(0);
		qlock(&amp;mbllock);
		for(mb = mbl; mb != nil; mb = mb-&gt;next){
			assert(mb-&gt;refs &gt; 0);
			if(mb-&gt;waketime != 0 &amp;&amp; t &gt; mb-&gt;waketime){
				qlock(mb);
				mb-&gt;waketime = 0;
				break;
			}

			d = dirstat(mb-&gt;path);
			if(d == nil)
				continue;

			qlock(mb);
			if(mb-&gt;d)
			if(d-&gt;qid.path != mb-&gt;d-&gt;qid.path
			   || d-&gt;qid.vers != mb-&gt;d-&gt;qid.vers){
				free(d);
				break;
			}
			qunlock(mb);
			free(d);
		}
		qunlock(&amp;mbllock);
		if(mb != nil){
			syncmbox(mb, 1);
			qunlock(mb);
		} else
			sleep(15*1000);
	}
}

int
newid(void)
{
	int rv;
	static int id;
	static Lock idlock;

	lock(&amp;idlock);
	rv = ++id;
	unlock(&amp;idlock);

	return rv;
}

void
error(char *s)
{
	postnote(PNGROUP, getpid(), "die yankee pig dog");
	fprint(2, "%s: %s: %r\n", argv0, s);
	exits(s);
}


typedef struct Ignorance Ignorance;
struct Ignorance
{
	Ignorance *next;
	char	*str;		/* string */
	int	partial;	/* true if not exact match */
};
Ignorance *ignorance;

/*
 *  read the file of headers to ignore 
 */
void
readignore(void)
{
	char *p;
	Ignorance *i;
	Biobuf *b;

	if(ignorance != nil)
		return;

	b = Bopen("/mail/lib/ignore", OREAD);
	if(b == 0)
		return;
	while(p = Brdline(b, '\n')){
		p[Blinelen(b)-1] = 0;
		while(*p &amp;&amp; (*p == ' ' || *p == '\t'))
			p++;
		if(*p == '#')
			continue;
		i = malloc(sizeof(Ignorance));
		if(i == 0)
			break;
		i-&gt;partial = strlen(p);
		i-&gt;str = strdup(p);
		if(i-&gt;str == 0){
			free(i);
			break;
		}
		i-&gt;next = ignorance;
		ignorance = i;
	}
	Bterm(b);
}

int
ignore(char *p)
{
	Ignorance *i;

	readignore();
	for(i = ignorance; i != nil; i = i-&gt;next)
		if(cistrncmp(i-&gt;str, p, i-&gt;partial) == 0)
			return 1;
	return 0;
}

int
hdrlen(char *p, char *e)
{
	char *ep;

	ep = p;
	do {
		ep = strchr(ep, '\n');
		if(ep == nil){
			ep = e;
			break;
		}
		ep++;
		if(ep &gt;= e){
			ep = e;
			break;
		}
	} while(*ep == ' ' || *ep == '\t');
	return ep - p;
}

// rfc2047 non-ascii: =?charset?q?encoded-text?=
int
rfc2047convert(String *s, char *token, int len)
{
	char charset[100], decoded[1024], *e, *x;
	int l;

	if(len == 0)
		return -1;

	e = token+len-2;
	token += 2;

	x = memchr(token, '?', e-token);
	if(x == nil || (l=x-token) &gt;= sizeof charset)
		return -1;
	memmove(charset, token, l);
	charset[l] = 0;

	token = x+1;

	// bail if it doesn't fit 
	if(e-token &gt; sizeof(decoded)-1)
		return -1;

	// bail if we don't understand the encoding
	if(cistrncmp(token, "b?", 2) == 0){
		token += 2;
		len = dec64((uchar*)decoded, sizeof(decoded), token, e-token);
		decoded[len] = 0;
	} else if(cistrncmp(token, "q?", 2) == 0){
		token += 2;
		len = decquoted(decoded, token, e, 1);
		if(len &gt; 0 &amp;&amp; decoded[len-1] == '\n')
			len--;
		decoded[len] = 0;
	} else
		return -1;

	if(xtoutf(charset, &amp;x, decoded, decoded+len) &lt;= 0)
		s_append(s, decoded);
	else {
		s_append(s, x);
		free(x);
	}
	return 0;
}

char*
rfc2047start(char *start, char *end)
{
	int quests;

	if(*--end != '=')
		return nil;
	if(*--end != '?')
		return nil;

	quests = 0;
	for(end--; end &gt;= start; end--){
		switch(*end){
		case '=':
			if(quests == 3 &amp;&amp; *(end+1) == '?')
				return end;
			break;
		case '?':
			++quests;
			break;
		case ' ':
		case '\t':
		case '\n':
		case '\r':
			/* can't have white space in a token */
			return nil;
		}
	}
	return nil;
}

// convert a header line
String*
stringconvert(String *s, char *uneaten, int len)
{
	char *token, *p, *e;

	s = s_reset(s);
	p = uneaten;
	for(e = p+len; p &lt; e; ){
		while(*p++ == '=' &amp;&amp; (token = rfc2047start(uneaten, p))){
			s_nappend(s, uneaten, token-uneaten);
			if(rfc2047convert(s, token, p - token) &lt; 0)
				s_nappend(s, token, p - token);
			uneaten = p;
			for(; p&lt;e &amp;&amp; isspace(*p);)
				p++;
			if(p+2 &lt; e &amp;&amp; p[0] == '=' &amp;&amp; p[1] == '?')
				uneaten = p;	// paste
		}
	}
	if(p &gt; uneaten)
		s_nappend(s, uneaten, p-uneaten);
	return s;
}

int
readheader(Message *m, char *buf, int off, int cnt)
{
	char *p, *e;
	int n, ns;
	char *to = buf;
	String *s;

	p = m-&gt;header;
	e = m-&gt;hend;
	s = nil;

	// copy in good headers
	while(cnt &gt; 0 &amp;&amp; p &lt; e){
		n = hdrlen(p, e);
		if(ignore(p)){
			p += n;
			continue;
		}

		// rfc2047 processing
		s = stringconvert(s, p, n);
		ns = s_len(s);
		if(off &gt; 0){
			if(ns &lt;= off){
				off -= ns;
				p += n;
				continue;
			}
			ns -= off;
		}
		if(ns &gt; cnt)
			ns = cnt;
		memmove(to, s_to_c(s)+off, ns);
		to += ns;
		p += n;
		cnt -= ns;
		off = 0;
	}

	s_free(s);
	return to - buf;
}

int
headerlen(Message *m)
{
	char buf[1024];
	int i, n;

	if(m-&gt;hlen &gt;= 0)
		return m-&gt;hlen;
	for(n = 0; ; n += i){
		i = readheader(m, buf, n, sizeof(buf));
		if(i &lt;= 0)
			break;
	}
	m-&gt;hlen = n;
	return n;
}

QLock hashlock;

uint
hash(ulong ppath, char *name)
{
	uchar *p;
	uint h;

	h = 0;
	for(p = (uchar*)name; *p; p++)
		h = h*7 + *p;
	h += ppath;

	return h % Hsize;
}

Hash*
hlook(ulong ppath, char *name)
{
	int h;
	Hash *hp;

	qlock(&amp;hashlock);
	h = hash(ppath, name);
	for(hp = htab[h]; hp != nil; hp = hp-&gt;next)
		if(ppath == hp-&gt;ppath &amp;&amp; strcmp(name, hp-&gt;name) == 0){
			qunlock(&amp;hashlock);
			return hp;
		}
	qunlock(&amp;hashlock);
	return nil;
}

void
henter(ulong ppath, char *name, Qid qid, Message *m, Mailbox *mb)
{
	int h;
	Hash *hp, **l;

	qlock(&amp;hashlock);
	h = hash(ppath, name);
	for(l = &amp;htab[h]; *l != nil; l = &amp;(*l)-&gt;next){
		hp = *l;
		if(ppath == hp-&gt;ppath &amp;&amp; strcmp(name, hp-&gt;name) == 0){
			hp-&gt;m = m;
			hp-&gt;mb = mb;
			hp-&gt;qid = qid;
			qunlock(&amp;hashlock);
			return;
		}
	}

	*l = hp = emalloc(sizeof(*hp));
	hp-&gt;m = m;
	hp-&gt;mb = mb;
	hp-&gt;qid = qid;
	hp-&gt;name = name;
	hp-&gt;ppath = ppath;
	qunlock(&amp;hashlock);
}

void
hfree(ulong ppath, char *name)
{
	int h;
	Hash *hp, **l;

	qlock(&amp;hashlock);
	h = hash(ppath, name);
	for(l = &amp;htab[h]; *l != nil; l = &amp;(*l)-&gt;next){
		hp = *l;
		if(ppath == hp-&gt;ppath &amp;&amp; strcmp(name, hp-&gt;name) == 0){
			hp-&gt;mb = nil;
			*l = hp-&gt;next;
			free(hp);
			break;
		}
	}
	qunlock(&amp;hashlock);
}

int
hashmboxrefs(Mailbox *mb)
{
	int h;
	Hash *hp;
	int refs = 0;

	qlock(&amp;hashlock);
	for(h = 0; h &lt; Hsize; h++){
		for(hp = htab[h]; hp != nil; hp = hp-&gt;next)
			if(hp-&gt;mb == mb)
				refs++;
	}
	qunlock(&amp;hashlock);
	return refs;
}

void
checkmboxrefs(void)
{
	int f, refs;
	Mailbox *mb;

	qlock(&amp;mbllock);
	for(mb=mbl; mb; mb=mb-&gt;next){
		qlock(mb);
		refs = (f=fidmboxrefs(mb))+1;
		if(refs != mb-&gt;refs){
			fprint(2, "mbox %s %s ref mismatch actual %d (%d+1) expected %d\n", mb-&gt;name, mb-&gt;path, refs, f, mb-&gt;refs);
			abort();
		}
		qunlock(mb);
	}
	qunlock(&amp;mbllock);
}

void
post(char *name, char *envname, int srvfd)
{
	int fd;
	char buf[32];

	fd = create(name, OWRITE, 0600);
	if(fd &lt; 0)
		error("post failed");
	sprint(buf, "%d",srvfd);
	if(write(fd, buf, strlen(buf)) != strlen(buf))
		error("srv write");
	close(fd);
	putenv(envname, name);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

