<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/fs/plan9.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/fs/plan9.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;
#include &lt;libsec.h&gt;
#include "dat.h"

enum {
	Buffersize = 64*1024,
};

typedef struct Inbuf Inbuf;
struct Inbuf
{
	int	fd;
	uchar	*lim;
	uchar	*rptr;
	uchar	*wptr;
	uchar	data[Buffersize+7];
};

static void
addtomessage(Message *m, uchar *p, int n, int done)
{
	int i, len;

	// add to message (+1 in malloc is for a trailing NUL)
	if(m-&gt;lim - m-&gt;end &lt; n){
		if(m-&gt;start != nil){
			i = m-&gt;end-m-&gt;start;
			if(done)
				len = i + n;
			else
				len = (4*(i+n))/3;
			m-&gt;start = erealloc(m-&gt;start, len + 1);
			m-&gt;end = m-&gt;start + i;
		} else {
			if(done)
				len = n;
			else
				len = 2*n;
			m-&gt;start = emalloc(len + 1);
			m-&gt;end = m-&gt;start;
		}
		m-&gt;lim = m-&gt;start + len;
		*m-&gt;lim = '\0';
	}

	memmove(m-&gt;end, p, n);
	m-&gt;end += n;
	*m-&gt;end = '\0';
}

//
//  read in a single message
//
static int
readmessage(Message *m, Inbuf *inb)
{
	int i, n, done;
	uchar *p, *np;
	char sdigest[SHA1dlen*2+1];
	char tmp[64];

	for(done = 0; !done;){
		n = inb-&gt;wptr - inb-&gt;rptr;
		if(n &lt; 6){
			if(n)
				memmove(inb-&gt;data, inb-&gt;rptr, n);
			inb-&gt;rptr = inb-&gt;data;
			inb-&gt;wptr = inb-&gt;rptr + n;
			i = read(inb-&gt;fd, inb-&gt;wptr, Buffersize);
			if(i &lt; 0){
				if(fd2path(inb-&gt;fd, tmp, sizeof tmp) &lt; 0)
					strcpy(tmp, "unknown mailbox");
				fprint(2, "error reading '%s': %r\n", tmp);
				return -1;
			}
			if(i == 0){
				if(n != 0)
					addtomessage(m, inb-&gt;rptr, n, 1);
				if(m-&gt;end == m-&gt;start)
					return -1;
				break;
			}
			inb-&gt;wptr += i;
		}

		// look for end of message
		for(p = inb-&gt;rptr; p &lt; inb-&gt;wptr; p = np+1){
			// first part of search for '\nFrom '
			np = memchr(p, '\n', inb-&gt;wptr - p);
			if(np == nil){
				p = inb-&gt;wptr;
				break;
			}

			/*
			 *  if we've found a \n but there's
			 *  not enough room for '\nFrom ', don't do
			 *  the comparison till we've read in more.
			 */
			if(inb-&gt;wptr - np &lt; 6){
				p = np;
				break;
			}

			if(strncmp((char*)np, "\nFrom ", 6) == 0){
				done = 1;
				p = np+1;
				break;
			}
		}

		// add to message (+ 1 in malloc is for a trailing null)
		n = p - inb-&gt;rptr;
		addtomessage(m, inb-&gt;rptr, n, done);
		inb-&gt;rptr += n;
	}

	// if it doesn't start with a 'From ', this ain't a mailbox
	if(strncmp(m-&gt;start, "From ", 5) != 0)
		return -1;

	// dump trailing newline, make sure there's a trailing null
	// (helps in body searches)
	if(*(m-&gt;end-1) == '\n')
		m-&gt;end--;
	*m-&gt;end = 0;
	m-&gt;bend = m-&gt;rbend = m-&gt;end;

	// digest message
	sha1((uchar*)m-&gt;start, m-&gt;end - m-&gt;start, m-&gt;digest, nil);
	for(i = 0; i &lt; SHA1dlen; i++)
		sprint(sdigest+2*i, "%2.2ux", m-&gt;digest[i]);
	m-&gt;sdigest = s_copy(sdigest);

	return 0;
}


// throw out deleted messages.  return number of freshly deleted messages
int
purgedeleted(Mailbox *mb)
{
	Message *m, *next;
	int newdels;

	// forget about what's no longer in the mailbox
	newdels = 0;
	for(m = mb-&gt;root-&gt;part; m != nil; m = next){
		next = m-&gt;next;
		if(m-&gt;deleted &amp;&amp; m-&gt;refs == 0){
			if(m-&gt;inmbox)
				newdels++;
			delmessage(mb, m);
		}
	}
	return newdels;
}

//
//  read in the mailbox and parse into messages.
//
static char*
_readmbox(Mailbox *mb, int doplumb, Mlock *lk)
{
	int fd, n;
	String *tmp;
	Dir *d;
	static char err[Errlen];
	Message *m, **l;
	Inbuf *inb;
	char *x;

	l = &amp;mb-&gt;root-&gt;part;

	/*
	 *  open the mailbox.  If it doesn't exist, try the temporary one.
	 */
	n = 0;
retry:
	fd = open(mb-&gt;path, OREAD);
	if(fd &lt; 0){
		rerrstr(err, sizeof(err));
		if(strstr(err, "exclusive lock") != 0 &amp;&amp; n++ &lt; 20){
			sleep(500);	/* wait for lock to go away */
			goto retry;
		}
		if(strstr(err, "exist") != 0){
			tmp = s_copy(mb-&gt;path);
			s_append(tmp, ".tmp");
			if(sysrename(s_to_c(tmp), mb-&gt;path) == 0){
				s_free(tmp);
				goto retry;
			}
			s_free(tmp);
		}
		return err;
	}

	/*
	 *  a new qid.path means reread the mailbox, while
	 *  a new qid.vers means read any new messages
	 */
	d = dirfstat(fd);
	if(d == nil){
		close(fd);
		errstr(err, sizeof(err));
		return err;
	}
	if(mb-&gt;d != nil){
		if(d-&gt;qid.path == mb-&gt;d-&gt;qid.path &amp;&amp; d-&gt;qid.vers == mb-&gt;d-&gt;qid.vers){
			close(fd);
			free(d);
			return nil;
		}
		if(d-&gt;qid.path == mb-&gt;d-&gt;qid.path){
			while(*l != nil)
				l = &amp;(*l)-&gt;next;
			seek(fd, mb-&gt;d-&gt;length, 0);
		}
		free(mb-&gt;d);
	}
	mb-&gt;d = d;
	mb-&gt;vers++;
	henter(PATH(0, Qtop), mb-&gt;name,
		(Qid){PATH(mb-&gt;id, Qmbox), mb-&gt;vers, QTDIR}, nil, mb);

	inb = emalloc(sizeof(Inbuf));
	inb-&gt;rptr = inb-&gt;wptr = inb-&gt;data;
	inb-&gt;fd = fd;

	//  read new messages
	snprint(err, sizeof err, "reading '%s'", mb-&gt;path);
	logmsg(err, nil);
	for(;;){
		if(lk != nil)
			syslockrefresh(lk);
		m = newmessage(mb-&gt;root);
		m-&gt;mallocd = 1;
		m-&gt;inmbox = 1;
		if(readmessage(m, inb) &lt; 0){
			delmessage(mb, m);
			mb-&gt;root-&gt;subname--;
			break;
		}

		// merge mailbox versions
		while(*l != nil){
			if(memcmp((*l)-&gt;digest, m-&gt;digest, SHA1dlen) == 0){
				// matches mail we already read, discard
				logmsg("duplicate", *l);
				delmessage(mb, m);
				mb-&gt;root-&gt;subname--;
				m = nil;
				l = &amp;(*l)-&gt;next;
				break;
			} else {
				// old mail no longer in box, mark deleted
				logmsg("disappeared", *l);
				if(doplumb)
					mailplumb(mb, *l, 1);
				(*l)-&gt;inmbox = 0;
				(*l)-&gt;deleted = 1;
				l = &amp;(*l)-&gt;next;
			}
		}
		if(m == nil)
			continue;

		x = strchr(m-&gt;start, '\n');
		if(x == nil)
			m-&gt;header = m-&gt;end;
		else
			m-&gt;header = x + 1;
		m-&gt;mheader = m-&gt;mhend = m-&gt;header;
		parseunix(m);
		parse(m, 0, mb, 0);
		logmsg("new", m);

		/* chain in */
		*l = m;
		l = &amp;m-&gt;next;
		if(doplumb)
			mailplumb(mb, m, 0);

	}
	logmsg("mbox read", nil);

	// whatever is left has been removed from the mbox, mark deleted
	while(*l != nil){
		if(doplumb)
			mailplumb(mb, *l, 1);
		(*l)-&gt;inmbox = 0;
		(*l)-&gt;deleted = 1;
		l = &amp;(*l)-&gt;next;
	}

	close(fd);
	free(inb);
	return nil;
}

static void
_writembox(Mailbox *mb, Mlock *lk)
{
	Dir *d;
	Message *m;
	String *tmp;
	int mode, errs;
	Biobuf *b;

	tmp = s_copy(mb-&gt;path);
	s_append(tmp, ".tmp");

	/*
	 * preserve old files permissions, if possible
	 */
	d = dirstat(mb-&gt;path);
	if(d != nil){
		mode = d-&gt;mode&amp;0777;
		free(d);
	} else
		mode = MBOXMODE;

	sysremove(s_to_c(tmp));
	b = sysopen(s_to_c(tmp), "alc", mode);
	if(b == 0){
		fprint(2, "can't write temporary mailbox %s: %r\n", s_to_c(tmp));
		return;
	}

	logmsg("writing new mbox", nil);
	errs = 0;
	for(m = mb-&gt;root-&gt;part; m != nil; m = m-&gt;next){
		if(lk != nil)
			syslockrefresh(lk);
		if(m-&gt;deleted)
			continue;
		logmsg("writing", m);
		if(Bwrite(b, m-&gt;start, m-&gt;end - m-&gt;start) &lt; 0)
			errs = 1;
		if(Bwrite(b, "\n", 1) &lt; 0)
			errs = 1;
	}
	logmsg("wrote new mbox", nil);

	if(sysclose(b) &lt; 0)
		errs = 1;

	if(errs){
		fprint(2, "error writing temporary mail file\n");
		s_free(tmp);
		return;
	}

	sysremove(mb-&gt;path);
	if(sysrename(s_to_c(tmp), mb-&gt;path) &lt; 0)
		fprint(2, "%s: can't rename %s to %s: %r\n", argv0,
			s_to_c(tmp), mb-&gt;path);
	s_free(tmp);
	if(mb-&gt;d != nil)
		free(mb-&gt;d);
	mb-&gt;d = dirstat(mb-&gt;path);
}

char*
plan9syncmbox(Mailbox *mb, int doplumb)
{
	Mlock *lk;
	char *rv;

	lk = nil;
	if(mb-&gt;dolock){
		lk = syslock(mb-&gt;path);
		if(lk == nil)
			return "can't lock mailbox";
	}

	rv = _readmbox(mb, doplumb, lk);		/* interpolate */
	if(purgedeleted(mb) &gt; 0)
		_writembox(mb, lk);

	if(lk != nil)
		sysunlock(lk);

	return rv;
}

//
//  look to see if we can open this mail box
//
char*
plan9mbox(Mailbox *mb, char *path)
{
	static char err[Errlen];
	String *tmp;

	if(access(path, AEXIST) &lt; 0){
		errstr(err, sizeof(err));
		tmp = s_copy(path);
		s_append(tmp, ".tmp");
		if(access(s_to_c(tmp), AEXIST) &lt; 0){
			s_free(tmp);
			return err;
		}
		s_free(tmp);
	}

	mb-&gt;sync = plan9syncmbox;
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

