<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/fs/pop3.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/fs/pop3.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;
#include &lt;libsec.h&gt;
#include &lt;auth.h&gt;
#include "dat.h"

#pragma varargck type "M" uchar*
#pragma varargck argpos pop3cmd 2

typedef struct Pop Pop;
struct Pop {
	char *freep;	// free this to free the strings below

	char *host;
	char *user;
	char *port;

	int ppop;
	int refreshtime;
	int debug;
	int pipeline;
	int encrypted;
	int needtls;
	int notls;
	int needssl;

	// open network connection
	Biobuf bin;
	Biobuf bout;
	int fd;
	char *lastline;	// from Brdstr

	Thumbprint *thumb;
};

char*
geterrstr(void)
{
	static char err[Errlen];

	err[0] = '\0';
	errstr(err, sizeof(err));
	return err;
}

//
// get pop3 response line , without worrying
// about multiline responses; the clients
// will deal with that.
//
static int
isokay(char *s)
{
	return s!=nil &amp;&amp; strncmp(s, "+OK", 3)==0;
}

static void
pop3cmd(Pop *pop, char *fmt, ...)
{
	char buf[128], *p;
	va_list va;

	va_start(va, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, va);
	va_end(va);

	p = buf+strlen(buf);
	if(p &gt; (buf+sizeof(buf)-3))
		sysfatal("pop3 command too long");

	if(pop-&gt;debug)
		fprint(2, "&lt;- %s\n", buf);
	strcpy(p, "\r\n");
	Bwrite(&amp;pop-&gt;bout, buf, strlen(buf));
	Bflush(&amp;pop-&gt;bout);
}

static char*
pop3resp(Pop *pop)
{
	char *s;
	char *p;

	alarm(60*1000);
	if((s = Brdstr(&amp;pop-&gt;bin, '\n', 0)) == nil){
		close(pop-&gt;fd);
		pop-&gt;fd = -1;
		alarm(0);
		return "unexpected eof";
	}
	alarm(0);

	p = s+strlen(s)-1;
	while(p &gt;= s &amp;&amp; (*p == '\r' || *p == '\n'))
		*p-- = '\0';

	if(pop-&gt;debug)
		fprint(2, "-&gt; %s\n", s);
	free(pop-&gt;lastline);
	pop-&gt;lastline = s;
	return s;
}

static int
pop3log(char *fmt, ...)
{
	va_list ap;

	va_start(ap,fmt);
	syslog(0, "/sys/log/pop3", fmt, ap);
	va_end(ap);
	return 0;
}

static char*
pop3pushtls(Pop *pop)
{
	int fd;
	uchar digest[SHA1dlen];
	TLSconn conn;

	memset(&amp;conn, 0, sizeof conn);
	// conn.trace = pop3log;
	fd = tlsClient(pop-&gt;fd, &amp;conn);
	if(fd &lt; 0)
		return "tls error";
	if(conn.cert==nil || conn.certlen &lt;= 0){
		close(fd);
		return "server did not provide TLS certificate";
	}
	sha1(conn.cert, conn.certlen, digest, nil);
	/*
	 * don't do this any more.  our local it people are rotating their
	 * certificates faster than we can keep up.
	 */
	if(0 &amp;&amp; (!pop-&gt;thumb || !okThumbprint(digest, pop-&gt;thumb))){
		fmtinstall('H', encodefmt);
		close(fd);
		free(conn.cert);
		fprint(2, "upas/fs pop3: server certificate %.*H not recognized\n", SHA1dlen, digest);
		return "bad server certificate";
	}
	free(conn.cert);
	close(pop-&gt;fd);
	pop-&gt;fd = fd;
	pop-&gt;encrypted = 1;
	Binit(&amp;pop-&gt;bin, pop-&gt;fd, OREAD);
	Binit(&amp;pop-&gt;bout, pop-&gt;fd, OWRITE);
	return nil;
}

//
// get capability list, possibly start tls
//
static char*
pop3capa(Pop *pop)
{
	char *s;
	int hastls;

	pop3cmd(pop, "CAPA");
	if(!isokay(pop3resp(pop)))
		return nil;

	hastls = 0;
	for(;;){
		s = pop3resp(pop);
		if(strcmp(s, ".") == 0 || strcmp(s, "unexpected eof") == 0)
			break;
		if(strcmp(s, "STLS") == 0)
			hastls = 1;
		if(strcmp(s, "PIPELINING") == 0)
			pop-&gt;pipeline = 1;
		if(strcmp(s, "EXPIRE 0") == 0)
			return "server does not allow mail to be left on server";
	}

	if(hastls &amp;&amp; !pop-&gt;notls){
		pop3cmd(pop, "STLS");
		if(!isokay(s = pop3resp(pop)))
			return s;
		if((s = pop3pushtls(pop)) != nil)
			return s;
	}
	return nil;
}

//
// log in using APOP if possible, password if allowed by user
//
static char*
pop3login(Pop *pop)
{
	int n;
	char *s, *p, *q;
	char ubuf[128], user[128];
	char buf[500];
	UserPasswd *up;

	s = pop3resp(pop);
	if(!isokay(s))
		return "error in initial handshake";

	if(pop-&gt;user)
		snprint(ubuf, sizeof ubuf, " user=%q", pop-&gt;user);
	else
		ubuf[0] = '\0';

	// look for apop banner
	if(pop-&gt;ppop==0 &amp;&amp; (p = strchr(s, '&lt;')) &amp;&amp; (q = strchr(p+1, '&gt;'))) {
		*++q = '\0';
		if((n=auth_respond(p, q-p, user, sizeof user, buf, sizeof buf, auth_getkey, "proto=apop role=client server=%q%s",
			pop-&gt;host, ubuf)) &lt; 0)
			return "factotum failed";
		if(user[0]=='\0')
			return "factotum did not return a user name";

		if(s = pop3capa(pop))
			return s;

		pop3cmd(pop, "APOP %s %.*s", user, n, buf);
		if(!isokay(s = pop3resp(pop)))
			return s;

		return nil;
	} else {
		if(pop-&gt;ppop == 0)
			return "no APOP hdr from server";

		if(s = pop3capa(pop))
			return s;

		if(pop-&gt;needtls &amp;&amp; !pop-&gt;encrypted)
			return "could not negotiate TLS";

		up = auth_getuserpasswd(auth_getkey, "proto=pass service=pop dom=%q%s",
			pop-&gt;host, ubuf);
		if(up == nil)
			return "no usable keys found";

		pop3cmd(pop, "USER %s", up-&gt;user);
		if(!isokay(s = pop3resp(pop))){
			free(up);
			return s;
		}
		pop3cmd(pop, "PASS %s", up-&gt;passwd);
		free(up);
		if(!isokay(s = pop3resp(pop)))
			return s;

		return nil;
	}
}

//
// dial and handshake with pop server
//
static char*
pop3dial(Pop *pop)
{
	char *err;

	if((pop-&gt;fd = dial(netmkaddr(pop-&gt;host, "net", pop-&gt;needssl ? "pop3s" : "pop3"), 0, 0, 0)) &lt; 0)
		return geterrstr();

	if(pop-&gt;needssl){
		if((err = pop3pushtls(pop)) != nil)
			return err;
	}else{
		Binit(&amp;pop-&gt;bin, pop-&gt;fd, OREAD);
		Binit(&amp;pop-&gt;bout, pop-&gt;fd, OWRITE);
	}

	if(err = pop3login(pop)) {
		close(pop-&gt;fd);
		return err;
	}

	return nil;
}

//
// close connection
//
static void
pop3hangup(Pop *pop)
{
	pop3cmd(pop, "QUIT");
	pop3resp(pop);
	close(pop-&gt;fd);
}

//
// download a single message
//
static char*
pop3download(Pop *pop, Message *m)
{
	char *s, *f[3], *wp, *ep;
	char sdigest[SHA1dlen*2+1];
	int i, l, sz;

	if(!pop-&gt;pipeline)
		pop3cmd(pop, "LIST %d", m-&gt;mesgno);
	if(!isokay(s = pop3resp(pop)))
		return s;

	if(tokenize(s, f, 3) != 3)
		return "syntax error in LIST response";

	if(atoi(f[1]) != m-&gt;mesgno)
		return "out of sync with pop3 server";

	sz = atoi(f[2])+200;	/* 200 because the plan9 pop3 server lies */
	if(sz == 0)
		return "invalid size in LIST response";

	m-&gt;start = wp = emalloc(sz+1);
	ep = wp+sz;

	if(!pop-&gt;pipeline)
		pop3cmd(pop, "RETR %d", m-&gt;mesgno);
	if(!isokay(s = pop3resp(pop))) {
		m-&gt;start = nil;
		free(wp);
		return s;
	}

	s = nil;
	while(wp &lt;= ep) {
		s = pop3resp(pop);
		if(strcmp(s, "unexpected eof") == 0) {
			free(m-&gt;start);
			m-&gt;start = nil;
			return "unexpected end of conversation";
		}
		if(strcmp(s, ".") == 0)
			break;

		l = strlen(s)+1;
		if(s[0] == '.') {
			s++;
			l--;
		}
		/*
		 * grow by 10%/200bytes - some servers
		 *  lie about message sizes
		 */
		if(wp+l &gt; ep) {
			int pos = wp - m-&gt;start;
			sz += ((sz / 10) &lt; 200)? 200: sz/10;
			m-&gt;start = erealloc(m-&gt;start, sz+1);
			wp = m-&gt;start+pos;
			ep = m-&gt;start+sz;
		}
		memmove(wp, s, l-1);
		wp[l-1] = '\n';
		wp += l;
	}

	if(s == nil || strcmp(s, ".") != 0)
		return "out of sync with pop3 server";

	m-&gt;end = wp;

	// make sure there's a trailing null
	// (helps in body searches)
	*m-&gt;end = 0;
	m-&gt;bend = m-&gt;rbend = m-&gt;end;
	m-&gt;header = m-&gt;start;

	// digest message
	sha1((uchar*)m-&gt;start, m-&gt;end - m-&gt;start, m-&gt;digest, nil);
	for(i = 0; i &lt; SHA1dlen; i++)
		sprint(sdigest+2*i, "%2.2ux", m-&gt;digest[i]);
	m-&gt;sdigest = s_copy(sdigest);

	return nil;
}

//
// check for new messages on pop server
// UIDL is not required by RFC 1939, but 
// netscape requires it, so almost every server supports it.
// we'll use it to make our lives easier.
//
static char*
pop3read(Pop *pop, Mailbox *mb, int doplumb)
{
	char *s, *p, *uidl, *f[2];
	int mesgno, ignore, nnew;
	Message *m, *next, **l;

	// Some POP servers disallow UIDL if the maildrop is empty.
	pop3cmd(pop, "STAT");
	if(!isokay(s = pop3resp(pop)))
		return s;

	// fetch message listing; note messages to grab
	l = &amp;mb-&gt;root-&gt;part;
	if(strncmp(s, "+OK 0 ", 6) != 0) {
		pop3cmd(pop, "UIDL");
		if(!isokay(s = pop3resp(pop)))
			return s;

		for(;;){
			p = pop3resp(pop);
			if(strcmp(p, ".") == 0 || strcmp(p, "unexpected eof") == 0)
				break;

			if(tokenize(p, f, 2) != 2)
				continue;

			mesgno = atoi(f[0]);
			uidl = f[1];
			if(strlen(uidl) &gt; 75)	// RFC 1939 says 70 characters max
				continue;

			ignore = 0;
			while(*l != nil) {
				if(strcmp((*l)-&gt;uidl, uidl) == 0) {
					// matches mail we already have, note mesgno for deletion
					(*l)-&gt;mesgno = mesgno;
					ignore = 1;
					l = &amp;(*l)-&gt;next;
					break;
				} else {
					// old mail no longer in box mark deleted
					if(doplumb)
						mailplumb(mb, *l, 1);
					(*l)-&gt;inmbox = 0;
					(*l)-&gt;deleted = 1;
					l = &amp;(*l)-&gt;next;
				}
			}
			if(ignore)
				continue;

			m = newmessage(mb-&gt;root);
			m-&gt;mallocd = 1;
			m-&gt;inmbox = 1;
			m-&gt;mesgno = mesgno;
			strcpy(m-&gt;uidl, uidl);

			// chain in; will fill in message later
			*l = m;
			l = &amp;m-&gt;next;
		}
	}

	// whatever is left has been removed from the mbox, mark as deleted
	while(*l != nil) {
		if(doplumb)
			mailplumb(mb, *l, 1);
		(*l)-&gt;inmbox = 0;
		(*l)-&gt;deleted = 1;
		l = &amp;(*l)-&gt;next;
	}

	// download new messages
	nnew = 0;
	if(pop-&gt;pipeline){
		switch(rfork(RFPROC|RFMEM)){
		case -1:
			fprint(2, "rfork: %r\n");
			pop-&gt;pipeline = 0;

		default:
			break;

		case 0:
			for(m = mb-&gt;root-&gt;part; m != nil; m = m-&gt;next){
				if(m-&gt;start != nil)
					continue;
				Bprint(&amp;pop-&gt;bout, "LIST %d\r\nRETR %d\r\n", m-&gt;mesgno, m-&gt;mesgno);
			}
			Bflush(&amp;pop-&gt;bout);
			_exits(nil);
		}
	}

	for(m = mb-&gt;root-&gt;part; m != nil; m = next) {
		next = m-&gt;next;

		if(m-&gt;start != nil)
			continue;

		if(s = pop3download(pop, m)) {
			// message disappeared? unchain
			fprint(2, "download %d: %s\n", m-&gt;mesgno, s);
			delmessage(mb, m);
			mb-&gt;root-&gt;subname--;
			continue;
		}
		nnew++;
		parse(m, 0, mb, 1);

		if(doplumb)
			mailplumb(mb, m, 0);
	}
	if(pop-&gt;pipeline)
		waitpid();

	if(nnew || mb-&gt;vers == 0) {
		mb-&gt;vers++;
		henter(PATH(0, Qtop), mb-&gt;name,
			(Qid){PATH(mb-&gt;id, Qmbox), mb-&gt;vers, QTDIR}, nil, mb);
	}

	return nil;	
}

//
// delete marked messages
//
static void
pop3purge(Pop *pop, Mailbox *mb)
{
	Message *m, *next;

	if(pop-&gt;pipeline){
		switch(rfork(RFPROC|RFMEM)){
		case -1:
			fprint(2, "rfork: %r\n");
			pop-&gt;pipeline = 0;

		default:
			break;

		case 0:
			for(m = mb-&gt;root-&gt;part; m != nil; m = next){
				next = m-&gt;next;
				if(m-&gt;deleted &amp;&amp; m-&gt;refs == 0){
					if(m-&gt;inmbox)
						Bprint(&amp;pop-&gt;bout, "DELE %d\r\n", m-&gt;mesgno);
				}
			}
			Bflush(&amp;pop-&gt;bout);
			_exits(nil);
		}
	}
	for(m = mb-&gt;root-&gt;part; m != nil; m = next) {
		next = m-&gt;next;
		if(m-&gt;deleted &amp;&amp; m-&gt;refs == 0) {
			if(m-&gt;inmbox) {
				if(!pop-&gt;pipeline)
					pop3cmd(pop, "DELE %d", m-&gt;mesgno);
				if(isokay(pop3resp(pop)))
					delmessage(mb, m);
			} else
				delmessage(mb, m);
		}
	}
}


// connect to pop3 server, sync mailbox
static char*
pop3sync(Mailbox *mb, int doplumb)
{
	char *err;
	Pop *pop;

	pop = mb-&gt;aux;

	if(err = pop3dial(pop)) {
		mb-&gt;waketime = time(0) + pop-&gt;refreshtime;
		return err;
	}

	if((err = pop3read(pop, mb, doplumb)) == nil){
		pop3purge(pop, mb);
		mb-&gt;d-&gt;atime = mb-&gt;d-&gt;mtime = time(0);
	}
	pop3hangup(pop);
	mb-&gt;waketime = time(0) + pop-&gt;refreshtime;
	return err;
}

static char Epop3ctl[] = "bad pop3 control message";

static char*
pop3ctl(Mailbox *mb, int argc, char **argv)
{
	int n;
	Pop *pop;

	pop = mb-&gt;aux;
	if(argc &lt; 1)
		return Epop3ctl;

	if(argc==1 &amp;&amp; strcmp(argv[0], "debug")==0){
		pop-&gt;debug = 1;
		return nil;
	}

	if(argc==1 &amp;&amp; strcmp(argv[0], "nodebug")==0){
		pop-&gt;debug = 0;
		return nil;
	}

	if(argc==1 &amp;&amp; strcmp(argv[0], "thumbprint")==0){
		if(pop-&gt;thumb)
			freeThumbprints(pop-&gt;thumb);
		pop-&gt;thumb = initThumbprints("/sys/lib/tls/mail", "/sys/lib/tls/mail.exclude");
	}
	if(strcmp(argv[0], "refresh")==0){
		if(argc==1){
			pop-&gt;refreshtime = 60;
			return nil;
		}
		if(argc==2){
			n = atoi(argv[1]);
			if(n &lt; 15)
				return Epop3ctl;
			pop-&gt;refreshtime = n;
			return nil;
		}
	}

	return Epop3ctl;
}

// free extra memory associated with mb
static void
pop3close(Mailbox *mb)
{
	Pop *pop;

	pop = mb-&gt;aux;
	free(pop-&gt;freep);
	free(pop);
}

//
// open mailboxes of the form /pop/host/user or /apop/host/user
//
char*
pop3mbox(Mailbox *mb, char *path)
{
	char *f[10];
	int nf, apop, ppop, popssl, apopssl, apoptls, popnotls, apopnotls, poptls;
	Pop *pop;

	quotefmtinstall();
	popssl = strncmp(path, "/pops/", 6) == 0;
	apopssl = strncmp(path, "/apops/", 7) == 0;
	poptls = strncmp(path, "/poptls/", 8) == 0;
	popnotls = strncmp(path, "/popnotls/", 10) == 0;
	ppop = popssl || poptls || popnotls || strncmp(path, "/pop/", 5) == 0;
	apoptls = strncmp(path, "/apoptls/", 9) == 0;
	apopnotls = strncmp(path, "/apopnotls/", 11) == 0;
	apop = apopssl || apoptls || apopnotls || strncmp(path, "/apop/", 6) == 0;

	if(!ppop &amp;&amp; !apop)
		return Enotme;

	path = strdup(path);
	if(path == nil)
		return "out of memory";

	nf = getfields(path, f, nelem(f), 0, "/");
	if(nf != 3 &amp;&amp; nf != 4) {
		free(path);
		return "bad pop3 path syntax /[a]pop[tls|ssl]/system[/user]";
	}

	pop = emalloc(sizeof(*pop));
	pop-&gt;freep = path;
	pop-&gt;host = f[2];
	if(nf &lt; 4)
		pop-&gt;user = nil;
	else
		pop-&gt;user = f[3];
	pop-&gt;ppop = ppop;
	pop-&gt;needssl = popssl || apopssl;
	pop-&gt;needtls = poptls || apoptls;
	pop-&gt;refreshtime = 60;
	pop-&gt;notls = popnotls || apopnotls;
	pop-&gt;thumb = initThumbprints("/sys/lib/tls/mail", "/sys/lib/tls/mail.exclude");

	mb-&gt;aux = pop;
	mb-&gt;sync = pop3sync;
	mb-&gt;close = pop3close;
	mb-&gt;ctl = pop3ctl;
	mb-&gt;d = emalloc(sizeof(*mb-&gt;d));

	return nil;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

