<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/ml/common.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/ml/common.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "dat.h"

String*
getaddr(Node *p)
{
	for(; p; p = p-&gt;next){
		if(p-&gt;s &amp;&amp; p-&gt;addr)
			return p-&gt;s;
	}
	return nil;
}

/* send message adding our own reply-to and precedence */
void
getaddrs(void)
{
	Field *f;

	for(f = firstfield; f; f = f-&gt;next){
		if(f-&gt;node-&gt;c == FROM &amp;&amp; from == nil)
			from = getaddr(f-&gt;node);
		if(f-&gt;node-&gt;c == SENDER &amp;&amp; sender == nil)
			sender = getaddr(f-&gt;node);
	}
}

/* write address file, should be append only */
void
writeaddr(char *file, char *addr, int rem, char *listname)
{
	int fd;
	Dir nd;

	fd = open(file, OWRITE);
	if(fd &lt; 0){
		fd = create(file, OWRITE, DMAPPEND|0666);
		if(fd &lt; 0)
			sysfatal("creating address list %s: %r", file);
		nulldir(&amp;nd);
		nd.mode = DMAPPEND|0666;
		dirwstat(file, &amp;nd);
	} else
		seek(fd, 0, 2);
	if(rem)
		fprint(fd, "!%s\n", addr);
	else
		fprint(fd, "%s\n", addr);
	close(fd);

	if(*addr != '#')
		sendnotification(addr, listname, rem);
}

void
remaddr(char *addr)
{
	Addr **l;
	Addr *a;

	for(l = &amp;al; *l; l = &amp;(*l)-&gt;next){
		a = *l;
		if(strcmp(addr, a-&gt;addr) == 0){
			(*l) = a-&gt;next;
			free(a);
			na--;
			break;
		}
	}
}

int
addaddr(char *addr)
{
	Addr **l;
	Addr *a;

	for(l = &amp;al; *l; l = &amp;(*l)-&gt;next){
		if(strcmp(addr, (*l)-&gt;addr) == 0)
			return 0;
	}
	na++;
	*l = a = malloc(sizeof(*a)+strlen(addr)+1);
	if(a == nil)
		sysfatal("allocating: %r");
	a-&gt;addr = (char*)&amp;a[1];
	strcpy(a-&gt;addr, addr);
	a-&gt;next = nil;
	*l = a;
	return 1;
}

/* read address file */
void
readaddrs(char *file)
{
	Biobuf *b;
	char *p;

	b = Bopen(file, OREAD);
	if(b == nil)
		return;

	while((p = Brdline(b, '\n')) != nil){
		p[Blinelen(b)-1] = 0;
		if(*p == '#')
			continue;
		if(*p == '!')
			remaddr(p+1);
		else
			addaddr(p);
	}
	Bterm(b);
}

/* start a mailer sending to all the receivers for list `name' */
int
startmailer(char *name)
{
	int pfd[2];
	char **av;
	int ac;
	Addr *a;

	/*
	 * we used to send mail to the list from /dev/null,
	 * which is equivalent to an smtp return address of &lt;&gt;,
	 * but such a return address should only be used when
	 * sending a bounce to a single address.  our smtpd lets
	 * such mail through, but refuses mail from &lt;&gt; to multiple
	 * addresses, since that's not allowed and is likely spam.
	 * thus mailing list mail to another upas system with
	 * multiple addressees was being rejected.
	 */
	putenv("upasname", smprint("%s-owner", name));

	if(pipe(pfd) &lt; 0)
		sysfatal("creating pipe: %r");
	switch(fork()){
	case -1:
		sysfatal("starting mailer: %r");
	case 0:
		close(pfd[1]);
		break;
	default:
		close(pfd[0]);
		return pfd[1];
	}

	dup(pfd[0], 0);
	close(pfd[0]);

	av = malloc(sizeof(char*)*(na+2));
	if(av == nil)
		sysfatal("starting mailer: %r");
	ac = 0;
	av[ac++] = name;
	for(a = al; a != nil; a = a-&gt;next)
		av[ac++] = a-&gt;addr;
	av[ac] = 0;
	exec("/bin/upas/send", av);
	sysfatal("execing mailer: %r");

	/* not reached */
	return -1;
}

void
sendnotification(char *addr, char *listname, int rem)
{
	int pfd[2];
	Waitmsg *w;

	putenv("upasname", smprint("%s-owner", listname));
	if(pipe(pfd) &lt; 0)
		sysfatal("creating pipe: %r");
	switch(fork()){
	case -1:
		sysfatal("starting mailer: %r");
	case 0:
		close(pfd[1]);
		dup(pfd[0], 0);
		close(pfd[0]);
		execl("/bin/upas/send", "mlnotify", addr, nil);
		sysfatal("execing mailer: %r");
		break;
	default:
		close(pfd[0]);
		fprint(pfd[1], "From: %s-owner\n\n", listname);
		if(rem)
			fprint(pfd[1], "You have been removed from the %s mailing list\n", listname);
		else{
			fprint(pfd[1], "You have been added to the %s mailing list\n", listname);
			fprint(pfd[1], "To be removed, send an email to %s-owner containing\n",
				listname);
			fprint(pfd[1], "the word 'remove' in the subject or body.\n");
		}
		close(pfd[1]);
	
		/* wait for mailer to end */
		while(w = wait()){
			if(w-&gt;msg != nil &amp;&amp; w-&gt;msg[0])
				sysfatal("%s", w-&gt;msg);
			free(w);
		}
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

