<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/ned/nedmail.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/ned/nedmail.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;

typedef struct Message Message;
typedef struct Ctype Ctype;
typedef struct Cmd Cmd;

char	root[Pathlen];
char	mbname[Elemlen];
int	rootlen;
int	didopen;
char	*user;
char	wd[2048];
String	*mbpath;
int	natural;
int	doflush;

int interrupted;

struct Message {
	Message	*next;
	Message	*prev;
	Message	*cmd;
	Message	*child;
	Message	*parent;
	String	*path;
	int	id;
	int	len;
	int	fileno;	// number of directory
	String	*info;
	char	*from;
	char	*to;
	char	*cc;
	char	*replyto;
	char	*date;
	char	*subject;
	char	*type;
	char	*disposition;
	char	*filename;
	char	deleted;
	char	stored;
};

Message top;

struct Ctype {
	char	*type;
	char 	*ext;
	int	display;
	char	*plumbdest;
	Ctype	*next;
};

Ctype ctype[] = {
	{ "text/plain",			"txt",	1,	0	},
	{ "text/html",			"htm",	1,	0	},
	{ "text/html",			"html",	1,	0	},
	{ "text/tab-separated-values",	"tsv",	1,	0	},
	{ "text/richtext",		"rtx",	1,	0	},
	{ "text/rtf",			"rtf",	1,	0	},
	{ "text/calendar",		"ics",	1,	0	},
	{ "text",			"txt",	1,	0	},
	{ "message/rfc822",		"msg",	0,	0	},
	{ "image/bmp",			"bmp",	0,	"image"	},
	{ "image/jpeg",			"jpg",	0,	"image"	},
	{ "image/gif",			"gif",	0,	"image"	},
	{ "image/png",			"png",	0,	"image"	},
	{ "application/pdf",		"pdf",	0,	"postscript"	},
	{ "application/postscript",	"ps",	0,	"postscript"	},
	{ "application/",		0,	0,	0	},
	{ "image/",			0,	0,	0	},
	{ "multipart/",			"mul",	0,	0	},

};

Message*	acmd(Cmd*, Message*);
Message*	bcmd(Cmd*, Message*);
Message*	dcmd(Cmd*, Message*);
Message*	eqcmd(Cmd*, Message*);
Message*	hcmd(Cmd*, Message*);
Message*	Hcmd(Cmd*, Message*);
Message*	helpcmd(Cmd*, Message*);
Message*	icmd(Cmd*, Message*);
Message*	pcmd(Cmd*, Message*);
Message*	qcmd(Cmd*, Message*);
Message*	rcmd(Cmd*, Message*);
Message*	scmd(Cmd*, Message*);
Message*	ucmd(Cmd*, Message*);
Message*	wcmd(Cmd*, Message*);
Message*	xcmd(Cmd*, Message*);
Message*	ycmd(Cmd*, Message*);
Message*	pipecmd(Cmd*, Message*);
Message*	rpipecmd(Cmd*, Message*);
Message*	bangcmd(Cmd*, Message*);
Message*	Pcmd(Cmd*, Message*);
Message*	mcmd(Cmd*, Message*);
Message*	fcmd(Cmd*, Message*);
Message*	quotecmd(Cmd*, Message*);

struct {
	char		*cmd;
	int		args;
	Message*	(*f)(Cmd*, Message*);
	char		*help;
} cmdtab[] = {
	{ "a",	1,	acmd,	"a        reply to sender and recipients" },
	{ "A",	1,	acmd,	"A        reply to sender and recipients with copy" },
	{ "b",	0,	bcmd,	"b        print the next 10 headers" },
	{ "d",	0,	dcmd,	"d        mark for deletion" },
	{ "f",	0,	fcmd,	"f        file message by from address" },
	{ "h",	0,	hcmd,	"h        print elided message summary (,h for all)" },
	{ "help", 0,	helpcmd, "help     print this info" },
	{ "H",	0,	Hcmd,	"H        print message's MIME structure " },
	{ "i",	0,	icmd,	"i        incorporate new mail" },
	{ "m",	1,	mcmd,	"m addr   forward mail" },
	{ "M",	1,	mcmd,	"M addr   forward mail with message" },
	{ "p",	0,	pcmd,	"p        print the processed message" },
	{ "P",	0,	Pcmd,	"P        print the raw message" },
	{ "\"",	0,	quotecmd, "\"        print a quoted version of msg" },
	{ "q",	0,	qcmd,	"q        exit and remove all deleted mail" },
	{ "r",	1,	rcmd,	"r [addr] reply to sender plus any addrs specified" },
	{ "rf",	1,	rcmd,	"rf [addr]file message and reply" },
	{ "R",	1,	rcmd,	"R [addr] reply including copy of message" },
	{ "Rf",	1,	rcmd,	"Rf [addr]file message and reply with copy" },
	{ "s",	1,	scmd,	"s file   append raw message to file" },
	{ "u",	0,	ucmd,	"u        remove deletion mark" },
	{ "w",	1,	wcmd,	"w file   store message contents as file" },
	{ "x",	0,	xcmd,	"x        exit without flushing deleted messages" },
	{ "y",	0,	ycmd,	"y        synchronize with mail box" },
	{ "=",	1,	eqcmd,	"=        print current message number" },
	{ "|",	1,	pipecmd, "|cmd     pipe message body to a command" },
	{ "||",	1,	rpipecmd, "||cmd     pipe raw message to a command" },
	{ "!",	1,	bangcmd, "!cmd     run a command" },
	{ nil,	0,	nil, 	nil },
};

enum
{
	NARG=	32,
};

struct Cmd {
	Message	*msgs;
	Message	*(*f)(Cmd*, Message*);
	int	an;
	char	*av[NARG];
	int	delete;
};

Biobuf out;
int startedfs;
int reverse;
int longestfrom = 12;

String*		file2string(String*, char*);
int		dir2message(Message*, int);
int		filelen(String*, char*);
String*		extendpath(String*, char*);
void		snprintheader(char*, int, Message*);
void		cracktime(char*, char*, int);
int		cistrncmp(char*, char*, int);
int		cistrcmp(char*, char*);
Reprog*		parsesearch(char**);
char*		parseaddr(char**, Message*, Message*, Message*, Message**);
char*		parsecmd(char*, Cmd*, Message*, Message*);
char*		readline(char*, char*, int);
void		messagecount(Message*);
void		system(char*, char**, int);
void		mkid(String*, Message*);
int		switchmb(char*, char*);
void		closemb(void);
int		lineize(char*, char**, int);
int		rawsearch(Message*, Reprog*);
Message*	dosingleton(Message*, char*);
String*		rooted(String*);
int		plumb(Message*, Ctype*);
String*		addrecolon(char*);
void		exitfs(char*);
Message*	flushdeleted(Message*);

void
usage(void)
{
	fprint(2, "usage: %s [-nr] [-f mailfile] [-s mailfile]\n", argv0);
	fprint(2, "       %s -c dir\n", argv0);
	exits("usage");
}

void
catchnote(void*, char *note)
{
	if(strstr(note, "interrupt") != nil){
		interrupted = 1;
		noted(NCONT);
	}
	noted(NDFLT);
}

char *
plural(int n)
{
	if (n == 1)
		return "";

	return "s";		
}

void
main(int argc, char **argv)
{
	Message *cur, *m, *x;
	char cmdline[4*1024];
	Cmd cmd;
	Ctype *cp;
	int n, cflag;
	char *av[4];
	String *prompt;
	char *err, *file, *singleton;

	quotefmtinstall();
	Binit(&amp;out, 1, OWRITE);

	file = nil;
	singleton = nil;
	reverse = 1;
	cflag = 0;
	ARGBEGIN {
	case 'c':
		cflag = 1;
		break;
	case 'f':
		file = EARGF(usage());
		break;
	case 's':
		singleton = EARGF(usage());
		break;
	case 'r':
		reverse = 0;
		break;
	case 'n':
		natural = 1;
		reverse = 0;
		break;
	default:
		usage();
		break;
	} ARGEND;

	user = getlog();
	if(user == nil || *user == 0)
		sysfatal("can't read user name");

	if(cflag){
		if(argc &gt; 0)
			creatembox(user, argv[0]);
		else
			creatembox(user, nil);
		exits(0);
	}

	if(argc)
		usage();

	if(access("/mail/fs/ctl", 0) &lt; 0){
		startedfs = 1;
		av[0] = "fs";
		av[1] = "-p";
		av[2] = 0;
		system("/bin/upas/fs", av, -1);
	}

	switchmb(file, singleton);

	top.path = s_copy(root);

	for(cp = ctype; cp &lt; ctype+nelem(ctype)-1; cp++)
		cp-&gt;next = cp+1;

	if(singleton != nil){
		cur = dosingleton(&amp;top, singleton);
		if(cur == nil){
			Bprint(&amp;out, "no message\n");
			exitfs(0);
		}
		pcmd(nil, cur);
	} else {
		cur = &amp;top;
		n = dir2message(&amp;top, reverse);
		if(n &lt; 0)
			sysfatal("can't read %s", s_to_c(top.path));
		Bprint(&amp;out, "%d message%s\n", n, plural(n));
	}


	notify(catchnote);
	prompt = s_new();
	for(;;){
		s_reset(prompt);
		if(cur == &amp;top)
			s_append(prompt, ": ");
		else {
			mkid(prompt, cur);
			s_append(prompt, ": ");
		}

		// leave space at the end of cmd line in case parsecmd needs to
		// add a space after a '|' or '!'
		if(readline(s_to_c(prompt), cmdline, sizeof(cmdline)-1) == nil)
			break;
		err = parsecmd(cmdline, &amp;cmd, top.child, cur);
		if(err != nil){
			Bprint(&amp;out, "!%s\n", err);
			continue;
		}
		if(singleton != nil &amp;&amp; cmd.f == icmd){
			Bprint(&amp;out, "!illegal command\n");
			continue;
		}
		interrupted = 0;
		if(cmd.msgs == nil || cmd.msgs == &amp;top){
			x = (*cmd.f)(&amp;cmd, &amp;top);
			if(x != nil)
				cur = x;
		} else for(m = cmd.msgs; m != nil; m = m-&gt;cmd){
			x = m;
			if(cmd.delete){
				dcmd(&amp;cmd, x);

				// dp acts differently than all other commands
				// since its an old lesk idiom that people love.
				// it deletes the current message, moves the current
				// pointer ahead one and prints.
				if(cmd.f == pcmd){
					if(x-&gt;next == nil){
						Bprint(&amp;out, "!address\n");
						cur = x;
						break;
					} else
						x = x-&gt;next;
				}
			}
			x = (*cmd.f)(&amp;cmd, x);
			if(x != nil)
				cur = x;
			if(interrupted)
				break;
			if(singleton != nil &amp;&amp; (cmd.delete || cmd.f == dcmd))
				qcmd(nil, nil);
		}
		if(doflush)
			cur = flushdeleted(cur);
	}
	qcmd(nil, nil);
}

//
// read the message info
//
Message*
file2message(Message *parent, char *name)
{
	Message *m;
	String *path;
	char *f[10];

	m = mallocz(sizeof(Message), 1);
	if(m == nil)
		return nil;
	m-&gt;path = path = extendpath(parent-&gt;path, name);
	m-&gt;fileno = atoi(name);
	m-&gt;info = file2string(path, "info");
	lineize(s_to_c(m-&gt;info), f, nelem(f));
	m-&gt;from = f[0];
	m-&gt;to = f[1];
	m-&gt;cc = f[2];
	m-&gt;replyto = f[3];
	m-&gt;date = f[4];
	m-&gt;subject = f[5];
	m-&gt;type = f[6];
	m-&gt;disposition = f[7];
	m-&gt;filename = f[8];
	m-&gt;len = filelen(path, "raw");
	if(strstr(m-&gt;type, "multipart") != nil || strcmp(m-&gt;type, "message/rfc822") == 0)
		dir2message(m, 0);
	m-&gt;parent = parent;

	return m;
}

void
freemessage(Message *m)
{
	Message *nm, *next;

	for(nm = m-&gt;child; nm != nil; nm = next){
		next = nm-&gt;next;
		freemessage(nm);
	}
	s_free(m-&gt;path);
	s_free(m-&gt;info);
	free(m);
}

//
//  read a directory into a list of messages
//
int
dir2message(Message *parent, int reverse)
{
	int i, n, fd, highest, newmsgs;
	Dir *d;
	Message *first, *last, *m;

	fd = open(s_to_c(parent-&gt;path), OREAD);
	if(fd &lt; 0)
		return -1;

	// count current entries
	first = parent-&gt;child;
	highest = newmsgs = 0;
	for(last = parent-&gt;child; last != nil &amp;&amp; last-&gt;next != nil; last = last-&gt;next)
		if(last-&gt;fileno &gt; highest)
			highest = last-&gt;fileno;
	if(last != nil)
		if(last-&gt;fileno &gt; highest)
			highest = last-&gt;fileno;

	n = dirreadall(fd, &amp;d);
	for(i = 0; i &lt; n; i++){
		if((d[i].qid.type &amp; QTDIR) == 0)
			continue;
		if(atoi(d[i].name) &lt;= highest)
			continue;
		m = file2message(parent, d[i].name);
		if(m == nil)
			break;
		newmsgs++;
		if(reverse){
			m-&gt;next = first;
			if(first != nil)
				first-&gt;prev = m;
			first = m;
		} else {
			if(first == nil)
				first = m;
			else
				last-&gt;next = m;
			m-&gt;prev = last;
			last = m;
		}
	}
	free(d);
	close(fd);
	parent-&gt;child = first;

	// renumber and file longest from
	i = 1;
	longestfrom = 12;
	for(m = first; m != nil; m = m-&gt;next){
		m-&gt;id = natural ? m-&gt;fileno : i++;
		n = strlen(m-&gt;from);
		if(n &gt; longestfrom)
			longestfrom = n;
	}

	return newmsgs;
}

//
//  point directly to a message
//
Message*
dosingleton(Message *parent, char *path)
{
	char *p, *np;
	Message *m;

	// walk down to message and read it
	if(strlen(path) &lt; rootlen)
		return nil;
	if(path[rootlen] != '/')
		return nil;
	p = path+rootlen+1;
	np = strchr(p, '/');
	if(np != nil)
		*np = 0;
	m = file2message(parent, p);
	if(m == nil)
		return nil;
	parent-&gt;child = m;
	m-&gt;id = 1;

	// walk down to requested component
	while(np != nil){
		*np = '/';
		np = strchr(np+1, '/');
		if(np != nil)
			*np = 0;
		for(m = m-&gt;child; m != nil; m = m-&gt;next)
			if(strcmp(path, s_to_c(m-&gt;path)) == 0)
				return m;
		if(m == nil)
			return nil;
	}
	return m;
}

//
//  read a file into a string
//
String*
file2string(String *dir, char *file)
{
	String *s;
	int fd, n, m;

	s = extendpath(dir, file);
	fd = open(s_to_c(s), OREAD);
	s_grow(s, 512);			/* avoid multiple reads on info files */
	s_reset(s);
	if(fd &lt; 0)
		return s;

	for(;;){
		n = s-&gt;end - s-&gt;ptr;
		if(n == 0){
			s_grow(s, 128);
			continue;
		}
		m = read(fd, s-&gt;ptr, n);
		if(m &lt;= 0)
			break;
		s-&gt;ptr += m;
		if(m &lt; n)
			break;
	}
	s_terminate(s);
	close(fd);

	return s;
}

//
//  get the length of a file
//
int
filelen(String *dir, char *file)
{
	String *path;
	Dir *d;
	int rv;

	path = extendpath(dir, file);
	d = dirstat(s_to_c(path));
	if(d == nil){
		s_free(path);
		return -1;
	}
	s_free(path);
	rv = d-&gt;length;
	free(d);
	return rv;
}

//
//  walk the path name an element
//
String*
extendpath(String *dir, char *name)
{
	String *path;

	if(strcmp(s_to_c(dir), ".") == 0)
		path = s_new();
	else {
		path = s_copy(s_to_c(dir));
		s_append(path, "/");
	}
	s_append(path, name);
	return path;
}

int
cistrncmp(char *a, char *b, int n)
{
	while(n-- &gt; 0){
		if(tolower(*a++) != tolower(*b++))
			return -1;
	}
	return 0;
}

int
cistrcmp(char *a, char *b)
{
	for(;;){
		if(tolower(*a) != tolower(*b++))
			return -1;
		if(*a++ == 0)
			break;
	}
	return 0;
}

char*
nosecs(char *t)
{
	char *p;

	p = strchr(t, ':');
	if(p == nil)
		return t;
	p = strchr(p+1, ':');
	if(p != nil)
		*p = 0;
	return t;
}

char *months[12] =
{
	"jan", "feb", "mar", "apr", "may", "jun",
	"jul", "aug", "sep", "oct", "nov", "dec"
};

int
month(char *m)
{
	int i;

	for(i = 0; i &lt; 12; i++)
		if(cistrcmp(m, months[i]) == 0)
			return i+1;
	return 1;
}

enum
{
	Yearsecs= 365*24*60*60
};

void
cracktime(char *d, char *out, int len)
{
	char in[64];
	char *f[6];
	int n;
	Tm tm;
	long now, then;
	char *dtime;

	*out = 0;
	if(d == nil)
		return;
	strncpy(in, d, sizeof(in));
	in[sizeof(in)-1] = 0;
	n = getfields(in, f, 6, 1, " \t\r\n");
	if(n != 6){
		// unknown style
		snprint(out, 16, "%10.10s", d);
		return;
	}
	now = time(0);
	memset(&amp;tm, 0, sizeof tm);
	if(strchr(f[0], ',') != nil &amp;&amp; strchr(f[4], ':') != nil){
		// 822 style
		tm.year = atoi(f[3])-1900;
		tm.mon = month(f[2]);
		tm.mday = atoi(f[1]);
		dtime = nosecs(f[4]);
		then = tm2sec(&amp;tm);
	} else if(strchr(f[3], ':') != nil){
		// unix style
		tm.year = atoi(f[5])-1900;
		tm.mon = month(f[1]);
		tm.mday = atoi(f[2]);
		dtime = nosecs(f[3]);
		then = tm2sec(&amp;tm);
	} else {
		then = now;
		tm = *localtime(now);
		dtime = "";
	}

	if(now - then &lt; Yearsecs/2)
		snprint(out, len, "%2d/%2.2d %s", tm.mon, tm.mday, dtime);
	else
		snprint(out, len, "%2d/%2.2d  %4d", tm.mon, tm.mday, tm.year+1900);
}

Ctype*
findctype(Message *m)
{
	char *p;
	char ftype[128];
	int n, pfd[2];
	Ctype *a, *cp;
	static Ctype nulltype	= { "", 0, 0, 0 };
	static Ctype bintype 	= { "application/octet-stream", "bin", 0, 0 };

	for(cp = ctype; cp; cp = cp-&gt;next)
		if(strncmp(cp-&gt;type, m-&gt;type, strlen(cp-&gt;type)) == 0)
			return cp;

/*	use file(1) for any unknown mimetypes
 *
 *	if (strcmp(m-&gt;type, bintype.type) != 0)
 *		return &amp;nulltype;
 */
	if(pipe(pfd) &lt; 0)
		return &amp;bintype;

	*ftype = 0;
	switch(fork()){
	case -1:
		break;
	case 0:
		close(pfd[1]);
		close(0);
		dup(pfd[0], 0);
		close(1);
		dup(pfd[0], 1);
		execl("/bin/file", "file", "-m", s_to_c(extendpath(m-&gt;path, "body")), nil);
		exits(0);
	default:
		close(pfd[0]);
		n = read(pfd[1], ftype, sizeof(ftype));
		if(n &gt; 0)
			ftype[n] = 0;
		close(pfd[1]);
		waitpid();
		break;
	}

	if (*ftype=='\0' || (p = strchr(ftype, '/')) == nil)
		return &amp;bintype;
	*p++ = 0;

	a = mallocz(sizeof(Ctype), 1);
	a-&gt;type = strdup(ftype);
	a-&gt;ext = strdup(p);
	a-&gt;display = 0;
	a-&gt;plumbdest = strdup(ftype);
	for(cp = ctype; cp-&gt;next; cp = cp-&gt;next)
		continue;
	cp-&gt;next = a;
	a-&gt;next = nil;
	return a;
}

void
mkid(String *s, Message *m)
{
	char buf[32];

	if(m-&gt;parent != &amp;top){
		mkid(s, m-&gt;parent);
		s_append(s, ".");
	}
	sprint(buf, "%d", m-&gt;id);
	s_append(s, buf);
}

void
snprintheader(char *buf, int len, Message *m)
{
	char timebuf[32];
	String *id;
	char *p, *q;

	// create id
	id = s_new();
	mkid(id, m);

	if(*m-&gt;from == 0){
		// no from
		snprint(buf, len, "%-3s    %s %6d  %s",
			s_to_c(id),
			m-&gt;type,
			m-&gt;len,
			m-&gt;filename);
	} else if(*m-&gt;subject){
		q = p = strdup(m-&gt;subject);
		while(*p == ' ')
			p++;
		if(strlen(p) &gt; 50)
			p[50] = 0;
		cracktime(m-&gt;date, timebuf, sizeof(timebuf));
		snprint(buf, len, "%-3s %c%c%c %6d  %11.11s %-*.*s %s",
			s_to_c(id),
			m-&gt;child ? 'H' : ' ',
			m-&gt;deleted ? 'd' : ' ',
			m-&gt;stored ? 's' : ' ',
			m-&gt;len,
			timebuf,
			longestfrom, longestfrom, m-&gt;from,
			p);
		free(q);
	} else {
		cracktime(m-&gt;date, timebuf, sizeof(timebuf));
		snprint(buf, len, "%-3s %c%c%c %6d  %11.11s %s",
			s_to_c(id),
			m-&gt;child ? 'H' : ' ',
			m-&gt;deleted ? 'd' : ' ',
			m-&gt;stored ? 's' : ' ',
			m-&gt;len,
			timebuf,
			m-&gt;from);
	}
	s_free(id);
}

char *spaces = "                                                                    ";

void
snprintHeader(char *buf, int len, int indent, Message *m)
{
	String *id;
	char typeid[64];
	char *p, *e;

	// create id
	id = s_new();
	mkid(id, m);

	e = buf + len;

	snprint(typeid, sizeof typeid, "%s    %s", s_to_c(id), m-&gt;type);
	if(indent &lt; 6)
		p = seprint(buf, e, "%-32s %-6d ", typeid, m-&gt;len);
	else
		p = seprint(buf, e, "%-64s %-6d ", typeid, m-&gt;len);
	if(m-&gt;filename &amp;&amp; *m-&gt;filename)
		p = seprint(p, e, "(file,%s)", m-&gt;filename);
	if(m-&gt;from &amp;&amp; *m-&gt;from)
		p = seprint(p, e, "(from,%s)", m-&gt;from);
	if(m-&gt;subject &amp;&amp; *m-&gt;subject)
		seprint(p, e, "(subj,%s)", m-&gt;subject);

	s_free(id);
}

char sstring[256];

//	cmd := range cmd ' ' arg-list ; 
//	range := address
//		| address ',' address
//		| 'g' search ;
//	address := msgno
//		| search ;
//	msgno := number
//		| number '/' msgno ;
//	search := '/' string '/'
//		| '%' string '%' ;
//
Reprog*
parsesearch(char **pp)
{
	char *p, *np;
	int c, n;

	p = *pp;
	c = *p++;
	np = strchr(p, c);
	if(np != nil){
		*np++ = 0;
		*pp = np;
	} else {
		n = strlen(p);
		*pp = p + n;
	}
	if(*p == 0)
		p = sstring;
	else{
		strncpy(sstring, p, sizeof(sstring));
		sstring[sizeof(sstring)-1] = 0;
	}
	return regcomp(p);
}

static char *
num2msg(Message **mp, int sign, int n, Message *first, Message *cur)
{
	Message *m;

	m = nil;
	switch(sign){
	case 0:
		for(m = first; m != nil; m = m-&gt;next)
			if(m-&gt;id == n)
				break;
		break;
	case -1:
		if(cur != &amp;top)
			for(m = cur; m != nil &amp;&amp; n &gt; 0; n--)
				m = m-&gt;prev;
		break;
	case 1:
		if(cur == &amp;top){
			n--;
			cur = first;
		}
		for(m = cur; m != nil &amp;&amp; n &gt; 0; n--)
			m = m-&gt;next;
		break;
	}
	if(m == nil)
		return "address";
	*mp = m;
	return nil;
}

char*
parseaddr(char **pp, Message *first, Message *cur, Message *unspec, Message **mp)
{
	int n;
	Message *m;
	char *p, *err;
	Reprog *prog;
	int c, sign;
	char buf[256];

	*mp = nil;
	p = *pp;

	if(*p == '+'){
		sign = 1;
		p++;
		*pp = p;
	} else if(*p == '-'){
		sign = -1;
		p++;
		*pp = p;
	} else
		sign = 0;

	/*
	 * TODO: verify &amp; install this.
	 * make + and - mean +1 and -1, as in ed.  then -,.d won't
	 * delete all messages up to the current one.  - geoff
	 */
	if(sign &amp;&amp; (!isascii(*p) || !isdigit(*p))) {
		err = num2msg(mp, sign, 1, first, cur);
		if (err != nil)
			return err;
	}

	switch(*p){
	default:
		if(sign){
			n = 1;
			goto number;
		}
		*mp = unspec;
		break;	
	case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
		n = strtoul(p, pp, 10);
		if(n == 0){
			if(sign)
				*mp = cur;
			else
				*mp = &amp;top;
			break;
		}
		/* fall through */
	number:
		err = num2msg(mp, sign, n, first, cur);
		if (err != nil)
			return err;
		break;
	case '%':
	case '/':
	case '?':
		c = *p;
		prog = parsesearch(pp);
		if(prog == nil)
			return "badly formed regular expression";
		m = nil;
		switch(c){
		case '%':
			for(m = cur == &amp;top ? first : cur-&gt;next; m != nil; m = m-&gt;next){
				if(rawsearch(m, prog))
					break;
			}
			break;
		case '/':
			for(m = cur == &amp;top ? first : cur-&gt;next; m != nil; m = m-&gt;next){
				snprintheader(buf, sizeof(buf), m);
				if(regexec(prog, buf, nil, 0))
					break;
			}
			break;
		case '?':
			for(m = cur == &amp;top ? nil : cur-&gt;prev; m != nil; m = m-&gt;prev){
				snprintheader(buf, sizeof(buf), m);
				if(regexec(prog, buf, nil, 0))
					break;
			}
			break;
		}
		if(m == nil)
			return "search";
		*mp = m;
		free(prog);
		break;
	case '$':
		for(m = first; m != nil &amp;&amp; m-&gt;next != nil; m = m-&gt;next)
			;
		*mp = m;
		*pp = p+1;
		break;
	case '.':
		*mp = cur;
		*pp = p+1;
		break;
	case ',':
		if (*mp == nil)
			*mp = first;
		*pp = p;
		break;
	}

	if(*mp != nil &amp;&amp; **pp == '.'){
		(*pp)++;
		if((*mp)-&gt;child == nil)
			return "no sub parts";
		return parseaddr(pp, (*mp)-&gt;child, (*mp)-&gt;child, (*mp)-&gt;child, mp);
	}
	if(**pp == '+' || **pp == '-' || **pp == '/' || **pp == '%')
		return parseaddr(pp, first, *mp, *mp, mp);

	return nil;
}

//
//  search a message for a regular expression match
//
int
rawsearch(Message *m, Reprog *prog)
{
	char buf[4096+1];
	int i, fd, rv;
	String *path;

	path = extendpath(m-&gt;path, "raw");
	fd = open(s_to_c(path), OREAD);
	if(fd &lt; 0)
		return 0;

	// march through raw message 4096 bytes at a time
	// with a 128 byte overlap to chain the re search.
	rv = 0;
	for(;;){
		i = read(fd, buf, sizeof(buf)-1);
		if(i &lt;= 0)
			break;
		buf[i] = 0;
		if(regexec(prog, buf, nil, 0)){
			rv = 1;
			break;
		}
		if(i &lt; sizeof(buf)-1)
			break;
		if(seek(fd, -128LL, 1) &lt; 0)
			break;
	}

	close(fd);
	s_free(path);
	return rv;
}


char*
parsecmd(char *p, Cmd *cmd, Message *first, Message *cur)
{
	Reprog *prog;
	Message *m, *s, *e, **l, *last;
	char buf[256];
	char *err;
	int i, c;
	char *q;
	static char errbuf[Errlen];

	cmd-&gt;delete = 0;
	l = &amp;cmd-&gt;msgs;
	*l = nil;

	// eat white space
	while(*p == ' ')
		p++;

	// null command is a special case (advance and print)
	if(*p == 0){
		if(cur == &amp;top){
			// special case
			m = first;
		} else {
			// walk to the next message even if we have to go up
			m = cur-&gt;next;
			while(m == nil &amp;&amp; cur-&gt;parent != nil){
				cur = cur-&gt;parent;
				m = cur-&gt;next;
			}
		}
		if(m == nil)
			return "address";
		*l = m;
		m-&gt;cmd = nil;
		cmd-&gt;an = 0;
		cmd-&gt;f = pcmd;
		return nil;
	}

	// global search ?
	if(*p == 'g'){
		p++;

		// no search string means all messages
		if(*p != '/' &amp;&amp; *p != '%'){
			for(m = first; m != nil; m = m-&gt;next){
				*l = m;
				l = &amp;m-&gt;cmd;
				*l = nil;
			}
		} else {
			// mark all messages matching this search string
			c = *p;
			prog = parsesearch(&amp;p);
			if(prog == nil)
				return "badly formed regular expression";
			if(c == '%'){
				for(m = first; m != nil; m = m-&gt;next){
					if(rawsearch(m, prog)){
						*l = m;
						l = &amp;m-&gt;cmd;
						*l = nil;
					}
				}
			} else {
				for(m = first; m != nil; m = m-&gt;next){
					snprintheader(buf, sizeof(buf), m);
					if(regexec(prog, buf, nil, 0)){
						*l = m;
						l = &amp;m-&gt;cmd;
						*l = nil;
					}
				}
			}
			free(prog);
		}
	} else {
	
		// parse an address
		s = e = nil;
		err = parseaddr(&amp;p, first, cur, cur, &amp;s);
		if(err != nil)
			return err;
		if(*p == ','){
			// this is an address range
			if(s == &amp;top)
				s = first;
			p++;
			for(last = s; last != nil &amp;&amp; last-&gt;next != nil; last = last-&gt;next)
				;
			err = parseaddr(&amp;p, first, cur, last, &amp;e);
			if(err != nil)
				return err;

			// select all messages in the range
			for(; s != nil; s = s-&gt;next){
				*l = s;
				l = &amp;s-&gt;cmd;
				*l = nil;
				if(s == e)
					break;
			}
			if(s == nil)
				return "null address range";
		} else {
			// single address
			if(s != &amp;top){
				*l = s;
				s-&gt;cmd = nil;
			}
		}
	}

	// insert a space after '!'s and '|'s
	for(q = p; *q; q++)
		if(*q != '!' &amp;&amp; *q != '|')
			break;
	if(q != p &amp;&amp; *q != ' '){
		memmove(q+1, q, strlen(q)+1);
		*q = ' ';
	}

	cmd-&gt;an = getfields(p, cmd-&gt;av, nelem(cmd-&gt;av) - 1, 1, " \t\r\n");
	if(cmd-&gt;an == 0 || *cmd-&gt;av[0] == 0)
		cmd-&gt;f = pcmd;
	else {
		// hack to allow all messages to start with 'd'
		if(*(cmd-&gt;av[0]) == 'd' &amp;&amp; *(cmd-&gt;av[0]+1) != 0){
			cmd-&gt;delete = 1;
			cmd-&gt;av[0]++;
		}

		// search command table
		for(i = 0; cmdtab[i].cmd != nil; i++)
			if(strcmp(cmd-&gt;av[0], cmdtab[i].cmd) == 0)
				break;
		if(cmdtab[i].cmd == nil)
			return "illegal command";
		if(cmdtab[i].args == 0 &amp;&amp; cmd-&gt;an &gt; 1){
			snprint(errbuf, sizeof(errbuf), "%s doesn't take an argument", cmdtab[i].cmd);
			return errbuf;
		}
		cmd-&gt;f = cmdtab[i].f;
	}
	return nil; 
}

// inefficient read from standard input
char*
readline(char *prompt, char *line, int len)
{
	char *p, *e;
	int n;

retry:
	interrupted = 0;
	Bprint(&amp;out, "%s", prompt);
	Bflush(&amp;out);
	e = line + len;
	for(p = line; p &lt; e; p++){
		n = read(0, p, 1);
		if(n &lt; 0){
			if(interrupted)
				goto retry;
			return nil;
		}
		if(n == 0)
			return nil;
		if(*p == '\n')
			break;
	}
	*p = 0;
	return line;
}

void
messagecount(Message *m)
{
	int i;

	i = 0;
	for(; m != nil; m = m-&gt;next)
		i++;
	Bprint(&amp;out, "%d message%s\n", i, plural(i));
}

Message*
aichcmd(Message *m, int indent)
{
	char	hdr[256];

	if(m == &amp;top)
		return nil;

	snprintHeader(hdr, sizeof(hdr), indent, m);
	Bprint(&amp;out, "%s\n", hdr);
	for(m = m-&gt;child; m != nil; m = m-&gt;next)
		aichcmd(m, indent+1);
	return nil;
}

Message*
Hcmd(Cmd*, Message *m)
{
	if(m == &amp;top)
		return nil;
	aichcmd(m, 0);
	return nil;
}

Message*
hcmd(Cmd*, Message *m)
{
	char	hdr[256];

	if(m == &amp;top)
		return nil;

	snprintheader(hdr, sizeof(hdr), m);
	Bprint(&amp;out, "%s\n", hdr);
	return nil;
}

Message*
bcmd(Cmd*, Message *m)
{
	int i;
	Message *om = m;

	if(m == &amp;top)
		m = top.child;
	for(i = 0; i &lt; 10 &amp;&amp; m != nil; i++){
		hcmd(nil, m);
		om = m;
		m = m-&gt;next;
	}

	return om;
}

Message*
ncmd(Cmd*, Message *m)
{
	if(m == &amp;top)
		return m-&gt;child;
	return m-&gt;next;
}

/* turn crlfs into newlines */
int
decrlf(char *buf, int n)
{
	char *nl;
	int left;

	for(nl = buf, left = n;
	    left &gt;= 2 &amp;&amp; (nl = memchr(nl, '\r', left)) != nil;
	    left = n - (nl - buf))
		if(nl[1] == '\n'){	/* newline? delete the cr */
			--n;	/* portion left is about to get smaller */
			memmove(nl, nl+1, n - (nl - buf));
		}else
			nl++;
	return n;
}

int
printpart(String *s, char *part)
{
	char buf[4096];
	int n, fd, tot;
	String *path;

	path = extendpath(s, part);
	fd = open(s_to_c(path), OREAD);
	s_free(path);
	if(fd &lt; 0){
		fprint(2, "!message disappeared\n");
		return 0;
	}
	tot = 0;
	while((n = read(fd, buf, sizeof(buf))) &gt; 0){
		if(interrupted)
			break;
		n = decrlf(buf, n);
		if(n &gt; 0 &amp;&amp; Bwrite(&amp;out, buf, n) &lt;= 0)
			break;
		tot += n;
	}
	close(fd);
	return tot;
}

int
printhtml(Message *m)
{
	Cmd c;

	c.an = 3;
	c.av[1] = "/bin/htmlfmt";
	c.av[2] = "-l 40 -cutf-8";
	Bprint(&amp;out, "!%s\n", c.av[1]);
	Bflush(&amp;out);
	pipecmd(&amp;c, m);
	return 0;
}

Message*
Pcmd(Cmd*, Message *m)
{
	if(m == &amp;top)
		return &amp;top;
	if(m-&gt;parent == &amp;top)
		printpart(m-&gt;path, "unixheader");
	printpart(m-&gt;path, "raw");
	return m;
}

void
compress(char *p)
{
	char *np;
	int last;

	last = ' ';
	for(np = p; *p; p++){
		if(*p != ' ' || last != ' '){
			last = *p;
			*np++ = last;
		}
	}
	*np = 0;
}

/*
 * find the best alternative part.
 *
 * turkeys have started emitting empty text/plain parts,
 * with the actual content in a text/html part, which complicates the choice.
 *
 * bigger turkeys emit a tiny base64-encoded text/plain part,
 * a small base64-encoded text/html part, and the real content is in
 * a text/calendar part.
 *
 * the magic lengths are empirically derived.
 * as turkeys devolve and mutate, this will only get worse.
 */
static Message*
bestalt(Message *m)
{
	Message *nm, *realplain, *realhtml, *realcal;
	Ctype *cp;

	realplain = realhtml = realcal = nil;
	for(nm = m-&gt;child; nm != nil; nm = nm-&gt;next){
		cp = findctype(nm);
		if(cp-&gt;ext != nil)
			if(strncmp(cp-&gt;ext, "txt", 3) == 0 &amp;&amp; nm-&gt;len &gt;= 88)
				realplain = nm;
			else if(strncmp(cp-&gt;ext, "html", 3) == 0 &amp;&amp;
			    nm-&gt;len &gt;= 670)
				realhtml = nm;
			else if(strncmp(cp-&gt;ext, "ics", 3) == 0)
				realcal = nm;
	}
	if(realplain == nil &amp;&amp; realhtml == nil &amp;&amp; realcal)
		return realcal;			/* super-turkey */
	else if(realplain == nil &amp;&amp; realhtml)
		return realhtml;		/* regular turkey */
	else
		return realplain;
}

static void
pralt(Message *m)
{
	Message *nm;
	Ctype *cp;

	nm = bestalt(m);
	if(nm == nil)
		/* no winner.  print the first displayable part. */
		for(nm = m-&gt;child; nm != nil; nm = nm-&gt;next){
			cp = findctype(nm);
			if(cp-&gt;display)
				break;
		}
	if(nm != nil)
		pcmd(nil, nm);
	else
		hcmd(nil, m);
}

Message*
pcmd(Cmd*, Message *m)
{
	Message *nm;
	Ctype *cp;
	String *s;
	char buf[128];

	if(m == nil)
		return m;
	if(m == &amp;top)
		return &amp;top;
	if(m-&gt;parent == &amp;top)
		printpart(m-&gt;path, "unixheader");
	if(printpart(m-&gt;path, "header") &gt; 0)
		Bprint(&amp;out, "\n");
	cp = findctype(m);
	if(cp-&gt;display){
		if(strcmp(m-&gt;type, "text/html") == 0)
			printhtml(m);
		else
			printpart(m-&gt;path, "body");
	} else if(strcmp(m-&gt;type, "multipart/alternative") == 0)
		pralt(m);
	else if(strncmp(m-&gt;type, "multipart/", 10) == 0){
		nm = m-&gt;child;
		if(nm != nil){
			// always print first part
			pcmd(nil, nm);

			for(nm = nm-&gt;next; nm != nil; nm = nm-&gt;next){
				s = rooted(s_clone(nm-&gt;path));
				cp = findctype(nm);
				snprintHeader(buf, sizeof buf, -1, nm);
				compress(buf);
				if(strcmp(nm-&gt;disposition, "inline") == 0){
					if(cp-&gt;ext != nil)
						Bprint(&amp;out, "\n--- %s %s/body.%s\n\n",
							buf, s_to_c(s), cp-&gt;ext);
					else
						Bprint(&amp;out, "\n--- %s %s/body\n\n",
							buf, s_to_c(s));
					pcmd(nil, nm);
				} else {
					if(cp-&gt;ext != nil)
						Bprint(&amp;out, "\n!--- %s %s/body.%s\n",
							buf, s_to_c(s), cp-&gt;ext);
					else
						Bprint(&amp;out, "\n!--- %s %s/body\n",
							buf, s_to_c(s));
				}
				s_free(s);
			}
		} else {
			hcmd(nil, m);
		}
	} else if(strcmp(m-&gt;type, "message/rfc822") == 0){
		pcmd(nil, m-&gt;child);
	} else if(plumb(m, cp) &gt;= 0)
		Bprint(&amp;out, "\n!--- using plumber to display message of type %s\n", m-&gt;type);
	else
		Bprint(&amp;out, "\n!--- cannot display messages of type %s\n", m-&gt;type);
	return m;
}

void
printpartindented(String *s, char *part, char *indent)
{
	char *p;
	String *path;
	Biobuf *b;

	path = extendpath(s, part);
	b = Bopen(s_to_c(path), OREAD);
	s_free(path);
	if(b == nil){
		fprint(2, "!message disappeared\n");
		return;
	}
	while((p = Brdline(b, '\n')) != nil){
		if(interrupted)
			break;
		p[Blinelen(b)-1] = 0;
		if(Bprint(&amp;out, "%s%s\n", indent, p) &lt; 0)
			break;
	}
	Bprint(&amp;out, "\n");
	Bterm(b);
}

Message*
quotecmd(Cmd*, Message *m)
{
	Message *nm;
	Ctype *cp;

	if(m == &amp;top)
		return &amp;top;
	Bprint(&amp;out, "\n");
	if(m-&gt;from != nil &amp;&amp; *m-&gt;from)
		Bprint(&amp;out, "On %s, %s wrote:\n", m-&gt;date, m-&gt;from);
	cp = findctype(m);
	if(cp-&gt;display){
		printpartindented(m-&gt;path, "body", "&gt; ");
	} else if(strcmp(m-&gt;type, "multipart/alternative") == 0){
		for(nm = m-&gt;child; nm != nil; nm = nm-&gt;next){
			cp = findctype(nm);
			if(cp-&gt;ext != nil &amp;&amp; strncmp(cp-&gt;ext, "txt", 3) == 0)
				break;
		}
		if(nm == nil)
			for(nm = m-&gt;child; nm != nil; nm = nm-&gt;next){
				cp = findctype(nm);
				if(cp-&gt;display)
					break;
			}
		if(nm != nil)
			quotecmd(nil, nm);
	} else if(strncmp(m-&gt;type, "multipart/", 10) == 0){
		nm = m-&gt;child;
		if(nm != nil){
			cp = findctype(nm);
			if(cp-&gt;display || strncmp(m-&gt;type, "multipart/", 10) == 0)
				quotecmd(nil, nm);
		}
	}
	return m;
}

// really delete messages
Message*
flushdeleted(Message *cur)
{
	Message *m, **l;
	char buf[1024], *p, *e, *msg;
	int deld, n, fd;
	int i;

	doflush = 0;
	deld = 0;

	fd = open("/mail/fs/ctl", ORDWR);
	if(fd &lt; 0){
		fprint(2, "!can't delete mail, opening /mail/fs/ctl: %r\n");
		exitfs(0);
	}
	e = &amp;buf[sizeof(buf)];
	p = seprint(buf, e, "delete %s", mbname);
	n = 0;
	for(l = &amp;top.child; *l != nil;){
		m = *l;
		if(!m-&gt;deleted){
			l = &amp;(*l)-&gt;next;
			continue;
		}

		// don't return a pointer to a deleted message
		if(m == cur)
			cur = m-&gt;next;

		deld++;
		msg = strrchr(s_to_c(m-&gt;path), '/');
		if(msg == nil)
			msg = s_to_c(m-&gt;path);
		else
			msg++;
		if(e-p &lt; 10){
			write(fd, buf, p-buf);
			n = 0;
			p = seprint(buf, e, "delete %s", mbname);
		}
		p = seprint(p, e, " %s", msg);
		n++;

		// unchain and free
		*l = m-&gt;next;
		if(m-&gt;next)
			m-&gt;next-&gt;prev = m-&gt;prev;
		freemessage(m);
	}
	if(n)
		write(fd, buf, p-buf);

	close(fd);

	if(deld)
		Bprint(&amp;out, "!%d message%s deleted\n", deld, plural(deld));

	// renumber
	i = 1;
	for(m = top.child; m != nil; m = m-&gt;next)
		m-&gt;id = natural ? m-&gt;fileno : i++;

	// if we're out of messages, go back to first
	// if no first, return the fake first
	if(cur == nil){
		if(top.child)
			return top.child;
		else
			return &amp;top;
	}
	return cur;
}

Message*
qcmd(Cmd*, Message*)
{
	flushdeleted(nil);

	if(didopen)
		closemb();
	Bflush(&amp;out);

	exitfs(0);
	return nil;	// not reached
}

Message*
ycmd(Cmd*, Message *m)
{
	doflush = 1;

	return icmd(nil, m);
}

Message*
xcmd(Cmd*, Message*)
{
	exitfs(0);
	return nil;	// not reached
}

Message*
eqcmd(Cmd*, Message *m)
{
	if(m == &amp;top)
		Bprint(&amp;out, "0\n");
	else
		Bprint(&amp;out, "%d\n", m-&gt;id);
	return nil;
}

Message*
dcmd(Cmd*, Message *m)
{
	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}
	while(m-&gt;parent != &amp;top)
		m = m-&gt;parent;
	m-&gt;deleted = 1;
	return m;
}

Message*
ucmd(Cmd*, Message *m)
{
	if(m == &amp;top)
		return nil;
	while(m-&gt;parent != &amp;top)
		m = m-&gt;parent;
	if(m-&gt;deleted &lt; 0)
		Bprint(&amp;out, "!can't undelete, already flushed\n");
	m-&gt;deleted = 0;
	return m;
}


Message*
icmd(Cmd*, Message *m)
{
	int n;

	n = dir2message(&amp;top, reverse);
	if(n &gt; 0)
		Bprint(&amp;out, "%d new message%s\n", n, plural(n));
	return m;
}

Message*
helpcmd(Cmd*, Message *m)
{
	int i;

	Bprint(&amp;out, "Commands are of the form [&lt;range&gt;] &lt;command&gt; [args]\n");
	Bprint(&amp;out, "&lt;range&gt; := &lt;addr&gt; | &lt;addr&gt;','&lt;addr&gt;| 'g'&lt;search&gt;\n");
	Bprint(&amp;out, "&lt;addr&gt; := '.' | '$' | '^' | &lt;number&gt; | &lt;search&gt; | &lt;addr&gt;'+'&lt;addr&gt; | &lt;addr&gt;'-'&lt;addr&gt;\n");
	Bprint(&amp;out, "&lt;search&gt; := '/'&lt;regexp&gt;'/' | '?'&lt;regexp&gt;'?' | '%%'&lt;regexp&gt;'%%'\n");
	Bprint(&amp;out, "&lt;command&gt; :=\n");
	for(i = 0; cmdtab[i].cmd != nil; i++)
		Bprint(&amp;out, "%s\n", cmdtab[i].help);
	return m;
}

int
tomailer(char **av)
{
	Waitmsg *w;
	int pid, i;

	// start the mailer and get out of the way
	switch(pid = fork()){
	case -1:
		fprint(2, "can't fork: %r\n");
		return -1;
	case 0:
		Bprint(&amp;out, "!/bin/upas/marshal");
		for(i = 1; av[i]; i++)
			Bprint(&amp;out, " %q", av[i]);
		Bprint(&amp;out, "\n");
		Bflush(&amp;out);
		av[0] = "marshal";
		chdir(wd);
		exec("/bin/upas/marshal", av);
		fprint(2, "couldn't exec /bin/upas/marshal\n");
		exits(0);
	default:
		w = wait();
		if(w == nil){
			if(interrupted)
				postnote(PNPROC, pid, "die");
			waitpid();
			return -1;
		}
		if(w-&gt;msg[0]){
			fprint(2, "mailer failed: %s\n", w-&gt;msg);
			free(w);
			return -1;
		}
		free(w);
		Bprint(&amp;out, "!\n");
		break;
	}
	return 0;
}

//
// like tokenize but obey "" quoting
//
int
tokenize822(char *str, char **args, int max)
{
	int na;
	int intok = 0, inquote = 0;

	if(max &lt;= 0)
		return 0;	
	for(na=0; ;str++)
		switch(*str) {
		case ' ':
		case '\t':
			if(inquote)
				goto Default;
			/* fall through */
		case '\n':
			*str = 0;
			if(!intok)
				continue;
			intok = 0;
			if(na &lt; max)
				continue;
			/* fall through */
		case 0:
			return na;
		case '"':
			inquote ^= 1;
			/* fall through */
		Default:
		default:
			if(intok)
				continue;
			args[na++] = str;
			intok = 1;
		}
}

/* return reply-to address &amp; set *nmp to corresponding Message */
static char *
getreplyto(Message *m, Message **nmp)
{
	Message *nm;

	for(nm = m; nm != &amp;top; nm = nm-&gt;parent)
 		if(*nm-&gt;replyto != 0)
			break;
	*nmp = nm;
	return nm? nm-&gt;replyto: nil;
}

Message*
rcmd(Cmd *c, Message *m)
{
	char *addr;
	char *av[128];
	int i, ai = 1;
	String *from, *rpath, *path = nil, *subject = nil;
	Message *nm;

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	addr = getreplyto(m, &amp;nm);
	if(addr == nil){
		Bprint(&amp;out, "!no reply address\n");
		return nil;
	}
	if(nm == &amp;top){
		print("!noone to reply to\n");
		return nil;
	}

	for(nm = m; nm != &amp;top; nm = nm-&gt;parent){
		if(*nm-&gt;subject){
			av[ai++] = "-s";
			subject = addrecolon(nm-&gt;subject);
			av[ai++] = s_to_c(subject);
			break;
		}
	}

	av[ai++] = "-R";
	rpath = rooted(s_clone(m-&gt;path));
	av[ai++] = s_to_c(rpath);

	if(strchr(c-&gt;av[0], 'f') != nil){
		fcmd(c, m);
		av[ai++] = "-F";
	}

	if(strchr(c-&gt;av[0], 'R') != nil){
		av[ai++] = "-t";
		av[ai++] = "message/rfc822";
		av[ai++] = "-A";
		path = rooted(extendpath(m-&gt;path, "raw"));
		av[ai++] = s_to_c(path);
	}

	for(i = 1; i &lt; c-&gt;an &amp;&amp; ai &lt; nelem(av)-1; i++)
		av[ai++] = c-&gt;av[i];
	from = s_copy(addr);
	ai += tokenize822(s_to_c(from), &amp;av[ai], nelem(av) - ai);
	av[ai] = 0;
	if(tomailer(av) &lt; 0)
		m = nil;
	s_free(path);
	s_free(rpath);
	s_free(subject);
	s_free(from);
	return m;
}

Message*
mcmd(Cmd *c, Message *m)
{
	char **av;
	int i, ai;
	String *path;

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	if(c-&gt;an &lt; 2){
		fprint(2, "!usage: M list-of addresses\n");
		return nil;
	}

	ai = 1;
	av = malloc(sizeof(char*)*(c-&gt;an + 8));

	av[ai++] = "-t";
	if(m-&gt;parent == &amp;top)
		av[ai++] = "message/rfc822";
	else
		av[ai++] = "mime";

	av[ai++] = "-A";
	path = rooted(extendpath(m-&gt;path, "raw"));
	av[ai++] = s_to_c(path);

	if(strchr(c-&gt;av[0], 'M') == nil)
		av[ai++] = "-n";

	for(i = 1; i &lt; c-&gt;an; i++)
		av[ai++] = c-&gt;av[i];
	av[ai] = 0;

	if(tomailer(av) &lt; 0)
		m = nil;
	if(path != nil)
		s_free(path);
	free(av);
	return m;
}

Message*
acmd(Cmd *c, Message *m)
{
	char *av[128];
	int i, ai = 1;
	String *from, *rpath, *path = nil, *subject = nil;
	String *to, *cc;

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	if(*m-&gt;subject){
		av[ai++] = "-s";
		subject = addrecolon(m-&gt;subject);
		av[ai++] = s_to_c(subject);
	}

	av[ai++] = "-R";
	rpath = rooted(s_clone(m-&gt;path));
	av[ai++] = s_to_c(rpath);

	if(strchr(c-&gt;av[0], 'A') != nil){
		av[ai++] = "-t";
		av[ai++] = "message/rfc822";
		av[ai++] = "-A";
		path = rooted(extendpath(m-&gt;path, "raw"));
		av[ai++] = s_to_c(path);
	}

	for(i = 1; i &lt; c-&gt;an &amp;&amp; ai &lt; nelem(av)-1; i++)
		av[ai++] = c-&gt;av[i];
	from = s_copy(m-&gt;from);
	ai += tokenize822(s_to_c(from), &amp;av[ai], nelem(av) - ai);
	to = s_copy(m-&gt;to);
	ai += tokenize822(s_to_c(to), &amp;av[ai], nelem(av) - ai);
	cc = s_copy(m-&gt;cc);
	ai += tokenize822(s_to_c(cc), &amp;av[ai], nelem(av) - ai);
	av[ai] = 0;
	if(tomailer(av) &lt; 0)
		m = nil;
	s_free(path);
	s_free(rpath);
	s_free(subject);
	s_free(from);
	s_free(to);
	s_free(cc);
	return m;
}

String *
relpath(char *path, String *to)
{
	if (*path=='/' || strncmp(path, "./", 2) == 0
			      || strncmp(path, "../", 3) == 0) {
		to = s_append(to, path);
	} else if(mbpath) {
		to = s_append(to, s_to_c(mbpath));
		to-&gt;ptr = strrchr(to-&gt;base, '/')+1;
		s_append(to, path);
	}
	return to;
}

int
appendtofile(Message *m, char *part, char *base, int mbox)
{
	String *file, *h;
	int in, out, rv;

	file = extendpath(m-&gt;path, part);
	in = open(s_to_c(file), OREAD);
	if(in &lt; 0){
		fprint(2, "!message disappeared\n");
		return -1;
	}

	s_reset(file);

	relpath(base, file);
	if(sysisdir(s_to_c(file))){
		s_append(file, "/");
		if(m-&gt;filename &amp;&amp; strchr(m-&gt;filename, '/') == nil)
			s_append(file, m-&gt;filename);
		else {
			s_append(file, "att.XXXXXXXXXXX");
			mktemp(s_to_c(file));
		}
	}
	if(mbox)
		out = open(s_to_c(file), OWRITE);
	else
		out = open(s_to_c(file), OWRITE|OTRUNC);
	if(out &lt; 0){
		out = create(s_to_c(file), OWRITE, 0666);
		if(out &lt; 0){
			fprint(2, "!can't open %s: %r\n", s_to_c(file));
			close(in);
			s_free(file);
			return -1;
		}
	}
	if(mbox)
		seek(out, 0, 2);

	// put on a 'From ' line
	if(mbox){
		while(m-&gt;parent != &amp;top)
			m = m-&gt;parent;
		h = file2string(m-&gt;path, "unixheader");
		fprint(out, "%s", s_to_c(h));
		s_free(h);
	}

	// copy the message escaping what we have to ad adding newlines if we have to
	if(mbox)
		rv = appendfiletombox(in, out);
	else
		rv = appendfiletofile(in, out);

	close(in);
	close(out);

	if(rv &gt;= 0)
		print("!saved in %s\n", s_to_c(file));
	s_free(file);
	return rv;
}

Message*
scmd(Cmd *c, Message *m)
{
	char *file;

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	switch(c-&gt;an){
	case 1:
		file = "stored";
		break;
	case 2:
		file = c-&gt;av[1];
		break;
	default:
		fprint(2, "!usage: s filename\n");
		return nil;
	}

	if(appendtofile(m, "raw", file, 1) &lt; 0)
		return nil;

	m-&gt;stored = 1;
	return m;
}

Message*
wcmd(Cmd *c, Message *m)
{
	char *file;

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	switch(c-&gt;an){
	case 2:
		file = c-&gt;av[1];
		break;
	case 1:
		if(*m-&gt;filename == 0){
			fprint(2, "!usage: w filename\n");
			return nil;
		}
		file = strrchr(m-&gt;filename, '/');
		if(file != nil)
			file++;
		else
			file = m-&gt;filename;
		break;
	default:
		fprint(2, "!usage: w filename\n");
		return nil;
	}

	if(appendtofile(m, "body", file, 0) &lt; 0)
		return nil;
	m-&gt;stored = 1;
	return m;
}

char *specialfile[] =
{
	"pipeto",
	"pipefrom",
	"L.mbox",
	"forward",
	"names"
};

// return 1 if this is a special file
static int
special(String *s)
{
	char *p;
	int i;

	p = strrchr(s_to_c(s), '/');
	if(p == nil)
		p = s_to_c(s);
	else
		p++;
	for(i = 0; i &lt; nelem(specialfile); i++)
		if(strcmp(p, specialfile[i]) == 0)
			return 1;
	return 0;
}

// open the folder using the recipients account name
static String*
foldername(char *rcvr)
{
	char *p;
	int c;
	String *file;
	Dir *d;
	int scarey;

	file = s_new();
	mboxpath("f", user, file, 0);
	d = dirstat(s_to_c(file));

	// if $mail/f exists, store there, otherwise in $mail
	s_restart(file);
	if(d &amp;&amp; d-&gt;qid.type == QTDIR){
		scarey = 0;
		s_append(file, "f/");
	} else {
		scarey = 1;
	}
	free(d);

	p = strrchr(rcvr, '!');
	if(p != nil)
		rcvr = p+1;

	while(*rcvr &amp;&amp; *rcvr != '@'){
		c = *rcvr++;
		if(c == '/')
			c = '_';
		s_putc(file, c);
	}
	s_terminate(file);

	if(scarey &amp;&amp; special(file)){
		fprint(2, "!won't overwrite %s\n", s_to_c(file));
		s_free(file);
		return nil;
	}

	return file;
}

Message*
fcmd(Cmd *c, Message *m)
{
	String *folder;

	if(c-&gt;an &gt; 1){
		fprint(2, "!usage: f takes no arguments\n");
		return nil;
	}

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	folder = foldername(m-&gt;from);
	if(folder == nil)
		return nil;

	if(appendtofile(m, "raw", s_to_c(folder), 1) &lt; 0){
		s_free(folder);
		return nil;
	}
	s_free(folder);

	m-&gt;stored = 1;
	return m;
}

void
system(char *cmd, char **av, int in)
{
	int pid;

	switch(pid=fork()){
	case -1:
		return;
	case 0:
		if(in &gt;= 0){
			close(0);
			dup(in, 0);
			close(in);
		}
		if(wd[0] != 0)
			chdir(wd);
		exec(cmd, av);
		fprint(2, "!couldn't exec %s\n", cmd);
		exits(0);
	default:
		if(in &gt;= 0)
			close(in);
		while(waitpid() &lt; 0){
			if(!interrupted)
				break;
			postnote(PNPROC, pid, "die");
			continue;
		}
		break;
	}
}

Message*
bangcmd(Cmd *c, Message *m)
{
	char cmd[4*1024];
	char *p, *e;
	char *av[4];
	int i;

	cmd[0] = 0;
	p = cmd;
	e = cmd+sizeof(cmd);
	for(i = 1; i &lt; c-&gt;an; i++)
		p = seprint(p, e, "%s ", c-&gt;av[i]);
	av[0] = "rc";
	av[1] = "-c";
	av[2] = cmd;
	av[3] = 0;
	system("/bin/rc", av, -1);
	Bprint(&amp;out, "!\n");
	return m;
}

Message*
xpipecmd(Cmd *c, Message *m, char *part)
{
	char cmd[128];
	char *p, *e;
	char *av[4];
	String *path;
	int i, fd;

	if(c-&gt;an &lt; 2){
		Bprint(&amp;out, "!usage: | cmd\n");
		return nil;
	}

	if(m == &amp;top){
		Bprint(&amp;out, "!address\n");
		return nil;
	}

	path = extendpath(m-&gt;path, part);
	fd = open(s_to_c(path), OREAD);
	s_free(path);
	if(fd &lt; 0){	// compatibility with older upas/fs
		path = extendpath(m-&gt;path, "raw");
		fd = open(s_to_c(path), OREAD);
		s_free(path);
	}
	if(fd &lt; 0){
		fprint(2, "!message disappeared\n");
		return nil;
	}

	p = cmd;
	e = cmd+sizeof(cmd);
	cmd[0] = 0;
	for(i = 1; i &lt; c-&gt;an; i++)
		p = seprint(p, e, "%s ", c-&gt;av[i]);
	av[0] = "rc";
	av[1] = "-c";
	av[2] = cmd;
	av[3] = 0;
	system("/bin/rc", av, fd);	/* system closes fd */
	Bprint(&amp;out, "!\n");
	return m;
}

Message*
pipecmd(Cmd *c, Message *m)
{
	return xpipecmd(c, m, "body");
}

Message*
rpipecmd(Cmd *c, Message *m)
{
	return xpipecmd(c, m, "rawunix");
}

void
closemb(void)
{
	int fd;

	fd = open("/mail/fs/ctl", ORDWR);
	if(fd &lt; 0)
		sysfatal("can't open /mail/fs/ctl: %r");

	// close current mailbox
	if(*mbname &amp;&amp; strcmp(mbname, "mbox") != 0)
		fprint(fd, "close %s", mbname);

	close(fd);
}

int
switchmb(char *file, char *singleton)
{
	char *p;
	int n, fd;
	String *path;
	char buf[256];

	// if the user didn't say anything and there
	// is an mbox mounted already, use that one
	// so that the upas/fs -fdefault default is honored.
	if(file 
	|| (singleton &amp;&amp; access(singleton, 0)&lt;0)
	|| (!singleton &amp;&amp; access("/mail/fs/mbox", 0)&lt;0)){
		if(file == nil)
			file = "mbox";

		// close current mailbox
		closemb();
		didopen = 1;

		fd = open("/mail/fs/ctl", ORDWR);
		if(fd &lt; 0)
			sysfatal("can't open /mail/fs/ctl: %r");
	
		path = s_new();
	
		// get an absolute path to the mail box
		if(strncmp(file, "./", 2) == 0){
			// resolve path here since upas/fs doesn't know
			// our working directory
			if(getwd(buf, sizeof(buf)-strlen(file)) == nil){
				fprint(2, "!can't get working directory: %s\n", buf);
				return -1;
			}
			s_append(path, buf);
			s_append(path, file+1);
		} else {
			mboxpath(file, user, path, 0);
		}
	
		// make up a handle to use when talking to fs
		p = strrchr(file, '/');
		if(p == nil){
			// if its in the mailbox directory, just use the name
			strncpy(mbname, file, sizeof(mbname));
			mbname[sizeof(mbname)-1] = 0;
		} else {
			// make up a mailbox name
			p = strrchr(s_to_c(path), '/');
			p++;
			if(*p == 0){
				fprint(2, "!bad mbox name");
				return -1;
			}
			strncpy(mbname, p, sizeof(mbname));
			mbname[sizeof(mbname)-1] = 0;
			n = strlen(mbname);
			if(n &gt; Elemlen-12)
				n = Elemlen-12;
			sprint(mbname+n, "%ld", time(0));
		}

		if(fprint(fd, "open %s %s", s_to_c(path), mbname) &lt; 0){
			fprint(2, "!can't 'open %s %s': %r\n", file, mbname);
			s_free(path);
			return -1;
		}
		close(fd);
	}else
	if (singleton &amp;&amp; access(singleton, 0)==0
	    &amp;&amp; strncmp(singleton, "/mail/fs/", 9) == 0){
		if ((p = strchr(singleton +10, '/')) == nil){
			fprint(2, "!bad mbox name");
			return -1;
		}
		n = p-(singleton+9);
		strncpy(mbname, singleton+9, n);
		mbname[n+1] = 0;
		path = s_reset(nil);
		mboxpath(mbname, user, path, 0);
	}else{
		path = s_reset(nil);
		mboxpath("mbox", user, path, 0);
		strcpy(mbname, "mbox");
	}

	snprint(root, sizeof root, "/mail/fs/%s", mbname);
	if(getwd(wd, sizeof(wd)) == 0)
		wd[0] = 0;
	if(singleton == nil &amp;&amp; chdir(root) &gt;= 0)
		strcpy(root, ".");
	rootlen = strlen(root);

	if(mbpath != nil)
		s_free(mbpath);
	mbpath = path;
	return 0;
}

// like tokenize but for into lines
int
lineize(char *s, char **f, int n)
{
	int i;

	for(i = 0; *s &amp;&amp; i &lt; n; i++){
		f[i] = s;
		s = strchr(s, '\n');
		if(s == nil)
			break;
		*s++ = 0;
	}
	return i;
}



String*
rooted(String *s)
{
	static char buf[256];

	if(strcmp(root, ".") != 0)
		return s;
	snprint(buf, sizeof(buf), "/mail/fs/%s/%s", mbname, s_to_c(s));
	s_free(s);
	return s_copy(buf);
}

int
plumb(Message *m, Ctype *cp)
{
	String *s;
	Plumbmsg *pm;
	static int fd = -2;

	if(cp-&gt;plumbdest == nil)
		return -1;

	if(fd &lt; -1)
		fd = plumbopen("send", OWRITE);
	if(fd &lt; 0)
		return -1;

	pm = mallocz(sizeof(Plumbmsg), 1);
	pm-&gt;src = strdup("mail");
	if(*cp-&gt;plumbdest)
		pm-&gt;dst = strdup(cp-&gt;plumbdest);
	pm-&gt;wdir = nil;
	pm-&gt;type = strdup("text");
	pm-&gt;ndata = -1;
	s = rooted(extendpath(m-&gt;path, "body"));
	if(cp-&gt;ext != nil){
		s_append(s, ".");
		s_append(s, cp-&gt;ext);
	}
	pm-&gt;data = strdup(s_to_c(s));
	s_free(s);
	plumbsend(fd, pm);
	plumbfree(pm);
	return 0;
}

void
regerror(char*)
{
}

String*
addrecolon(char *s)
{
	String *str;

	if(cistrncmp(s, "re:", 3) != 0){
		str = s_copy("Re: ");
		s_append(str, s);
	} else
		str = s_copy(s);
	return str;
}

void
exitfs(char *rv)
{
	if(startedfs)
		unmount(nil, "/mail/fs");
	chdir("/sys/src/cmd/upas/ned");		/* for profiling? */
	exits(rv);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

