<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/q/qer.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/q/qer.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"

typedef struct Qfile Qfile;
struct Qfile
{
	Qfile	*next;
	char	*name;
	char	*tname;
} *files;

char *user;
int isnone;

int	copy(Qfile*);

void
usage(void)
{
	fprint(2, "usage: qer [-f file] [-q dir] q-root description reply-to arg-list\n");
	exits("usage");
}

void
error(char *f, char *a)
{
	char err[Errlen+1];
	char buf[256];

	rerrstr(err, sizeof(err));
	snprint(buf, sizeof(buf),  f, a);
	fprint(2, "qer: %s: %s\n", buf, err);
	exits(buf);
}

void
main(int argc, char**argv)
{
	Dir	*dir;
	String	*f, *c;
	int	fd;
	char	file[1024];
	char	buf[1024];
	long	n;
	char	*cp, *qdir;
	int	i;
	Qfile	*q, **l;

	l = &amp;files;
	qdir = 0;

	ARGBEGIN {
	case 'f':
		q = malloc(sizeof(Qfile));
		q-&gt;name = ARGF();
		q-&gt;next = *l;
		*l = q;
		break;
	case 'q':
		qdir = ARGF();
		if(qdir == 0)
			usage();
		break;
	default:
		usage();
	} ARGEND;

	if(argc &lt; 3)
		usage();
	user = getuser();
	isnone = (qdir != 0) || (strcmp(user, "none") == 0);

	if(qdir == 0) {
		qdir = user;
		if(qdir == 0)
			error("unknown user", 0);
	}
	snprint(file, sizeof(file), "%s/%s", argv[0], qdir);

	/*
	 *  data file name
	 */
	f = s_copy(file);
	s_append(f, "/D.XXXXXX");
	mktemp(s_to_c(f));
	cp = utfrrune(s_to_c(f), '/');
	cp++;

	/*
	 *  create directory and data file.  once the data file
	 *  exists, runq won't remove the directory
	 */
	fd = -1;
	for(i = 0; i &lt; 10; i++){
		int perm;

		dir = dirstat(file);
		if(dir == nil){
			perm = isnone?0777:0775;
			if(sysmkdir(file, perm) &lt; 0)
				continue;
		} else {
			if((dir-&gt;qid.type&amp;QTDIR)==0)
				error("not a directory %s", file);
		}
		perm = isnone?0664:0660;
		fd = create(s_to_c(f), OWRITE, perm);
		if(fd &gt;= 0)
			break;
		sleep(250);
	}
	if(fd &lt; 0)
		error("creating data file %s", s_to_c(f));

	/*
	 *  copy over associated files
	 */
	if(files){
		*cp = 'F';
		for(q = files; q; q = q-&gt;next){
			q-&gt;tname = strdup(s_to_c(f));
			if(copy(q) &lt; 0)
				error("copying %s to queue", q-&gt;name);
			(*cp)++;
		}
	}

	/*
	 *  copy in the data file
	 */
	i = 0;
	while((n = read(0, buf, sizeof(buf)-1)) &gt; 0){
		if(i++ == 0 &amp;&amp; strncmp(buf, "From", 4) != 0){
			buf[n] = 0;
			syslog(0, "smtp", "qer usys data starts with %-40.40s\n", buf);
		}
		if(write(fd, buf, n) != n)
			error("writing data file %s", s_to_c(f));
	}
/*	if(n &lt; 0)
		error("reading input"); */
	close(fd);

	/*
	 *  create control file
	 */
	*cp = 'C';
	fd = syscreatelocked(s_to_c(f), OWRITE, 0664);
	if(fd &lt; 0)
		error("creating control file %s", s_to_c(f));
	c = s_new();
	for(i = 1; i &lt; argc; i++){
		s_append(c, argv[i]);
		s_append(c, " ");
	}
	for(q = files; q; q = q-&gt;next){
		s_append(c, q-&gt;tname);
		s_append(c, " ");
	}
	s_append(c, "\n");
	if(write(fd, s_to_c(c), strlen(s_to_c(c))) &lt; 0) {
		sysunlockfile(fd);
		error("writing control file %s", s_to_c(f));
	}
	sysunlockfile(fd);
	exits(0);
}

int
copy(Qfile *q)
{
	int from, to, n;
	char buf[4096];

	from = open(q-&gt;name, OREAD);
	if(from &lt; 0)
		return -1;
	to = create(q-&gt;tname, OWRITE, 0660);
	if(to &lt; 0){
		close(from);
		return -1;
	}
	for(;;){
		n = read(from, buf, sizeof(buf));
		if(n &lt;= 0)
			break;
		n = write(to, buf, n);
		if(n &lt; 0)
			break;
	}
	close(to);
	close(from);
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

