<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/dest.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/dest.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

static String* s_parseq(String*, String*);

/* exports */
dest *dlist;

extern dest*
d_new(String *addr)
{
	dest *dp;

	dp = (dest *)mallocz(sizeof(dest), 1);
	if (dp == 0) {
		perror("d_new");
		exit(1);
	}
	dp-&gt;same = dp;
	dp-&gt;nsame = 1;
	dp-&gt;nchar = 0;
	dp-&gt;next = dp;
	dp-&gt;addr = escapespecial(addr);
	dp-&gt;parent = 0;
	dp-&gt;repl1 = dp-&gt;repl2 = 0;
	dp-&gt;status = d_undefined;
	return dp;
}

extern void
d_free(dest *dp)
{
	if (dp != 0) {
		s_free(dp-&gt;addr);
		s_free(dp-&gt;repl1);
		s_free(dp-&gt;repl2);
		free((char *)dp);
	}
}

/* The following routines manipulate an ordered list of items.  Insertions
 * are always to the end of the list.  Deletions are from the beginning.
 *
 * The list are circular witht the `head' of the list being the last item
 * added.
 */

/*  Get first element from a circular list linked via 'next'. */
extern dest *
d_rm(dest **listp)
{
	dest *dp;

	if (*listp == 0)
		return 0;
	dp = (*listp)-&gt;next;
	if (dp == *listp)
		*listp = 0;
	else
		(*listp)-&gt;next = dp-&gt;next;
	dp-&gt;next = dp;
	return dp;
}

/*  Insert a new entry at the end of the list linked via 'next'. */
extern void
d_insert(dest **listp, dest *new)
{
	dest *head;

	if (*listp == 0) {
		*listp = new;
		return;
	}
	if (new == 0)
		return;
	head = new-&gt;next;
	new-&gt;next = (*listp)-&gt;next;
	(*listp)-&gt;next = head;
	*listp = new;
	return;
}

/*  Get first element from a circular list linked via 'same'. */
extern dest *
d_rm_same(dest **listp)
{
	dest *dp;

	if (*listp == 0)
		return 0;
	dp = (*listp)-&gt;same;
	if (dp == *listp)
		*listp = 0;
	else
		(*listp)-&gt;same = dp-&gt;same;
	dp-&gt;same = dp;
	return dp;
}

/* Look for a duplicate on the same list */
int
d_same_dup(dest *dp, dest *new)
{
	dest *first = dp;

	if(new-&gt;repl2 == 0)
		return 1;
	do {
		if(strcmp(s_to_c(dp-&gt;repl2), s_to_c(new-&gt;repl2))==0)
			return 1;
		dp = dp-&gt;same;
	} while(dp != first);
	return 0;
}

/* Insert an entry into the corresponding list linked by 'same'.  Note that
 * the basic structure is a list of lists.
 */
extern void
d_same_insert(dest **listp, dest *new)
{
	dest *dp;
	int len;

	if(new-&gt;status == d_pipe || new-&gt;status == d_cat) {
		len = new-&gt;repl2 ? strlen(s_to_c(new-&gt;repl2)) : 0;
		if(*listp != 0){
			dp = (*listp)-&gt;next;
			do {
				if(dp-&gt;status == new-&gt;status
				&amp;&amp; strcmp(s_to_c(dp-&gt;repl1), s_to_c(new-&gt;repl1))==0){
					/* remove duplicates */
					if(d_same_dup(dp, new))
						return;
					/* add to chain if chain small enough */
					if(dp-&gt;nsame &lt; MAXSAME
					&amp;&amp; dp-&gt;nchar + len &lt; MAXSAMECHAR){
						new-&gt;same = dp-&gt;same;
						dp-&gt;same = new;
						dp-&gt;nchar += len + 1;
						dp-&gt;nsame++;
						return;
					}
				}
				dp = dp-&gt;next;
			} while (dp != (*listp)-&gt;next);
		}
		new-&gt;nchar = strlen(s_to_c(new-&gt;repl1)) + len + 1;
	}
	new-&gt;next = new;
	d_insert(listp, new);
}

/*
 *  Form a To: if multiple destinations.
 *  The local! and !local! checks are artificial intelligence,
 *  there should be a better way.
 */
extern String*
d_to(dest *list)
{
	dest *np, *sp;
	String *s;
	int i, n;
	char *cp;

	s = s_new();
	s_append(s, "To: ");
	np = list;
	i = n = 0;
	do {
		np = np-&gt;next;
		sp = np;
		do {
			sp = sp-&gt;same;
			cp = s_to_c(sp-&gt;addr);

			/* hack to get local! out of the names */
			if(strncmp(cp, "local!", 6) == 0)
				cp += 6;

			if(n &gt; 20){	/* 20 to appease mailers complaining about long lines */
				s_append(s, "\n\t");
				n = 0;
			}
			if(i != 0){
				s_append(s, ", ");
				n += 2;
			}
			s_append(s, cp);
			n += strlen(cp);
			i++;
		} while(sp != np);
	} while(np != list);

	return unescapespecial(s);
}

/* expand a String of destinations into a linked list of destiniations */
extern dest *
s_to_dest(String *sp, dest *parent)
{
	String *addr;
	dest *list=0;
	dest *new;

	if (sp == 0)
		return 0;
	addr = s_new();
	while (s_parseq(sp, addr)!=0) {
		addr = escapespecial(addr);
		if(shellchars(s_to_c(addr))){
			while(new = d_rm(&amp;list))
				d_free(new);
			break;
		}
		new = d_new(addr);
		new-&gt;parent = parent;
		new-&gt;authorized = parent-&gt;authorized;
		d_insert(&amp;list, new);
		addr = s_new();
	}
	s_free(addr);
	return list;
}

#define isspace(c) ((c)==' ' || (c)=='\t' || (c)=='\n')

/*  Get the next field from a String.  The field is delimited by white space.
 *  Anything delimited by double quotes is included in the string.
 */
static String*
s_parseq(String *from, String *to)
{
	int c;

	if (*from-&gt;ptr == '\0')
		return 0;
	if (to == 0)
		to = s_new();
	for (c = *from-&gt;ptr;!isspace(c) &amp;&amp; c != 0; c = *(++from-&gt;ptr)){
		s_putc(to, c);
		if(c == '"'){
			for (c = *(++from-&gt;ptr); c &amp;&amp; c != '"'; c = *(++from-&gt;ptr))
				s_putc(to, *from-&gt;ptr);
			s_putc(to, '"');
			if(c == 0)
				break;
		}
	}
	s_terminate(to);

	/* crunch trailing white */
	while(isspace(*from-&gt;ptr))
		from-&gt;ptr++;

	return to;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

