<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/local.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/local.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

static void
mboxfile(dest *dp, String *user, String *path, char *file)
{
	char *cp;

	mboxpath(s_to_c(user), s_to_c(dp-&gt;addr), path, 0);
	cp = strrchr(s_to_c(path), '/');
	if(cp)
		path-&gt;ptr = cp+1;
	else
		path-&gt;ptr = path-&gt;base;
	s_append(path, file);
}

/*
 *  Check forwarding requests
 */
extern dest*
expand_local(dest *dp)
{
	Biobuf *fp;
	String *file, *line, *s;
	dest *rv;
	int forwardok;
	char *user;

	/* short circuit obvious security problems */
	if(strstr(s_to_c(dp-&gt;addr), "/../")){
		dp-&gt;status = d_unknown;
		return 0;
	}

	/* isolate user's name if part of a path */
	user = strrchr(s_to_c(dp-&gt;addr), '!');
	if(user)
		user++;
	else
		user = s_to_c(dp-&gt;addr);

	/* if no replacement string, plug in user's name */
	if(dp-&gt;repl1 == 0){
		dp-&gt;repl1 = s_new();
		mboxname(user, dp-&gt;repl1);
	}

	s = unescapespecial(s_clone(dp-&gt;repl1));

	/*
	 *  if this is the descendant of a `forward' file, don't
	 *  look for a forward.
	 */
	forwardok = 1;
	for(rv = dp-&gt;parent; rv; rv = rv-&gt;parent)
		if(rv-&gt;status == d_cat){
			forwardok = 0;
			break;
		}
	file = s_new();
	if(forwardok){
		/*
		 *  look for `forward' file for forwarding address(es)
		 */
		mboxfile(dp, s, file, "forward");
		fp = sysopen(s_to_c(file), "r", 0);
		if (fp != 0) {
			line = s_new();
			for(;;){
				if(s_read_line(fp, line) == nil)
					break;
				if(*(line-&gt;ptr - 1) != '\n')
					break;
				if(*(line-&gt;ptr - 2) == '\\')
					*(line-&gt;ptr-2) = ' ';
				*(line-&gt;ptr-1) = ' ';
			}
			sysclose(fp);
			if(debug)
				fprint(2, "forward = %s\n", s_to_c(line));
			rv = s_to_dest(s_restart(line), dp);
			s_free(line);
			if(rv){
				s_free(file);
				s_free(s);
				return rv;
			}
		}
	}

	/*
	 *  look for a 'pipe' file.  This won't work if there are
	 *  special characters in the account name since the file
	 *  name passes through a shell.  tdb.
	 */
	mboxfile(dp, dp-&gt;repl1, s_reset(file), "pipeto");
	if(sysexist(s_to_c(file))){
		if(debug)
			fprint(2, "found a pipeto file\n");
		dp-&gt;status = d_pipeto;
		line = s_new();
		s_append(line, "upasname='");
		s_append(line, user);
		s_append(line, "' ");
		s_append(line, s_to_c(file));
		s_append(line, " ");
		s_append(line, s_to_c(dp-&gt;addr));
		s_append(line, " ");
		s_append(line, s_to_c(dp-&gt;repl1));
		s_free(dp-&gt;repl1);
		dp-&gt;repl1 = line;
		s_free(file);
		s_free(s);
		return dp;
	}

	/*
	 *  see if the mailbox directory exists
	 */
	mboxfile(dp, s, s_reset(file), ".");
	if(sysexist(s_to_c(file)))
		dp-&gt;status = d_cat;
	else
		dp-&gt;status = d_unknown;
	s_free(file);
	s_free(s);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

