<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/log.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/log.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

/* configuration */
#define LOGBiobuf "log/status"

/* log mail delivery */
extern void
logdelivery(dest *list, char *rcvr, message *mp)
{
	dest *parent;
	String *srcvr, *sender;

	srcvr = unescapespecial(s_copy(rcvr));
	sender = unescapespecial(s_clone(mp-&gt;sender));

	for(parent=list; parent-&gt;parent!=0; parent=parent-&gt;parent)
		;
	if(parent!=list &amp;&amp; strcmp(s_to_c(parent-&gt;addr), s_to_c(srcvr))!=0)
		syslog(0, "mail", "delivered %s From %.256s %.256s (%.256s) %d",
			rcvr,
			s_to_c(sender), s_to_c(mp-&gt;date),
			s_to_c(parent-&gt;addr), mp-&gt;size);
	else
		syslog(0, "mail", "delivered %s From %.256s %.256s %d", s_to_c(srcvr),
			s_to_c(sender), s_to_c(mp-&gt;date), mp-&gt;size);
	s_free(srcvr);
	s_free(sender);
}

/* log mail forwarding */
extern void
loglist(dest *list, message *mp, char *tag)
{
	dest *next;
	dest *parent;
	String *srcvr, *sender;

	sender = unescapespecial(s_clone(mp-&gt;sender));

	for(next=d_rm(&amp;list); next != 0; next = d_rm(&amp;list)) {
		for(parent=next; parent-&gt;parent!=0; parent=parent-&gt;parent)
			;
		srcvr = unescapespecial(s_clone(next-&gt;addr));
		if(parent!=next)
			syslog(0, "mail", "%s %.256s From %.256s %.256s (%.256s) %d",
				tag,
				s_to_c(srcvr), s_to_c(sender),
				s_to_c(mp-&gt;date), s_to_c(parent-&gt;addr), mp-&gt;size);
		else
			syslog(0, "mail", "%s %.256s From %.256s %.256s %d", tag,
				s_to_c(srcvr), s_to_c(sender),
				s_to_c(mp-&gt;date), mp-&gt;size);
		s_free(srcvr);
	}
	s_free(sender);
}

/* log a mail refusal */
extern void
logrefusal(dest *dp, message *mp, char *msg)
{
	char buf[2048];
	char *cp, *ep;
	String *sender, *srcvr;

	srcvr = unescapespecial(s_clone(dp-&gt;addr));
	sender = unescapespecial(s_clone(mp-&gt;sender));

	sprint(buf, "error %.256s From %.256s %.256s\nerror+ ", s_to_c(srcvr),
		s_to_c(sender), s_to_c(mp-&gt;date));
	s_free(srcvr);
	s_free(sender);
	cp = buf + strlen(buf);
	ep = buf + sizeof(buf) - sizeof("error + ");
	while(*msg &amp;&amp; cp&lt;ep) {
		*cp++ = *msg;
		if (*msg++ == '\n') {
			strcpy(cp, "error+ ");
			cp += sizeof("error+ ") - 1;
		}
	}
	*cp = 0;
	syslog(0, "mail", "%s", buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

