<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/rewrite.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/rewrite.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

extern int debug;

/* 
 *	Routines for dealing with the rewrite rules.
 */

/* globals */
typedef struct rule rule;

#define NSUBEXP 10
struct rule {
	String *matchre;	/* address match */
	String *repl1;		/* first replacement String */
	String *repl2;		/* second replacement String */
	d_status type;		/* type of rule */
	Reprog *program;
	Resub subexp[NSUBEXP];
	rule *next;
};
static rule *rulep;
static rule *rlastp;

/* predeclared */
static String *substitute(String *, Resub *, message *);
static rule *findrule(String *, int);


/*
 *  Get the next token from `line'.  The symbol `\l' is replaced by
 *  the name of the local system.
 */
extern String *
rule_parse(String *line, char *system, int *backl)
{
	String *token;
	String *expanded;
	char *cp;

	token = s_parse(line, 0);
	if(token == 0)
		return(token);
	if(strchr(s_to_c(token), '\\')==0)
		return(token);
	expanded = s_new();
	for(cp = s_to_c(token); *cp; cp++) {
		if(*cp == '\\') switch(*++cp) {
		case 'l':
			s_append(expanded, system);
			*backl = 1;
			break;
		case '\\':
			s_putc(expanded, '\\');
			break;
		default:
			s_putc(expanded, '\\');
			s_putc(expanded, *cp);
			break;
		} else
			s_putc(expanded, *cp);
	}
	s_free(token);
	s_terminate(expanded);
	return(expanded);
}

static int
getrule(String *line, String *type, char *system)
{
	rule	*rp;
	String	*re;
	int	backl;

	backl = 0;

	/* get a rule */
	re = rule_parse(s_restart(line), system, &amp;backl);
	if(re == 0)
		return 0;
	rp = (rule *)malloc(sizeof(rule));
	if(rp == 0) {
		perror("getrules:");
		exit(1);
	}
	rp-&gt;next = 0;
	s_tolower(re);
	rp-&gt;matchre = s_new();
	s_append(rp-&gt;matchre, s_to_c(re));
	s_restart(rp-&gt;matchre);
	s_free(re);
	s_parse(line, s_restart(type));
	rp-&gt;repl1 = rule_parse(line, system, &amp;backl);
	rp-&gt;repl2 = rule_parse(line, system, &amp;backl);
	rp-&gt;program = 0;
	if(strcmp(s_to_c(type), "|") == 0)
		rp-&gt;type = d_pipe;
	else if(strcmp(s_to_c(type), "&gt;&gt;") == 0)
		rp-&gt;type = d_cat;
	else if(strcmp(s_to_c(type), "alias") == 0)
		rp-&gt;type = d_alias;
	else if(strcmp(s_to_c(type), "translate") == 0)
		rp-&gt;type = d_translate;
	else if(strcmp(s_to_c(type), "auth") == 0)
		rp-&gt;type = d_auth;
	else {
		s_free(rp-&gt;matchre);
		s_free(rp-&gt;repl1);
		s_free(rp-&gt;repl2);
		free((char *)rp);
		fprint(2,"illegal rewrite rule: %s\n", s_to_c(line));
		return 0;
	}
	if(rulep == 0)
		rulep = rlastp = rp;
	else
		rlastp = rlastp-&gt;next = rp;
	return backl;
}

/*
 *  rules are of the form:
 *	&lt;reg exp&gt; &lt;String&gt; &lt;repl exp&gt; [&lt;repl exp&gt;]
 */
extern int
getrules(void)
{
	Biobuf	*rfp;
	String	*line;
	String	*type;
	String	*file;

	file = abspath("rewrite", UPASLIB, (String *)0);
	rfp = sysopen(s_to_c(file), "r", 0);
	if(rfp == 0) {
		rulep = 0;
		return -1;
	}
	rlastp = 0;
	line = s_new();
	type = s_new();
	while(s_getline(rfp, s_restart(line)))
		if(getrule(line, type, thissys) &amp;&amp; altthissys)
			getrule(s_restart(line), type, altthissys);
	s_free(type);
	s_free(line);
	s_free(file);
	sysclose(rfp);
	return 0;
}

/* look up a matching rule */
static rule *
findrule(String *addrp, int authorized)
{
	rule *rp;
	static rule defaultrule;

	if(rulep == 0)
		return &amp;defaultrule;
	for (rp = rulep; rp != 0; rp = rp-&gt;next) {
		if(rp-&gt;type==d_auth &amp;&amp; authorized)
			continue;
		if(rp-&gt;program == 0)
			rp-&gt;program = regcomp(rp-&gt;matchre-&gt;base);
		if(rp-&gt;program == 0)
			continue;
		memset(rp-&gt;subexp, 0, sizeof(rp-&gt;subexp));
		if(debug)
			fprint(2, "matching %s against %s\n", s_to_c(addrp),
				rp-&gt;matchre-&gt;base);
		if(regexec(rp-&gt;program, s_to_c(addrp), rp-&gt;subexp, NSUBEXP))
		if(s_to_c(addrp) == rp-&gt;subexp[0].sp)
		if((s_to_c(addrp) + strlen(s_to_c(addrp))) == rp-&gt;subexp[0].ep)
			return rp;
	}
	return 0;
}

/*  Transforms the address into a command.
 *  Returns:	-1 ifaddress not matched by reules
 *		 0 ifaddress matched and ok to forward
 *		 1 ifaddress matched and not ok to forward
 */
extern int
rewrite(dest *dp, message *mp)
{
	rule *rp;		/* rewriting rule */
	String *lower;		/* lower case version of destination */

	/*
	 *  Rewrite the address.  Matching is case insensitive.
	 */
	lower = s_clone(dp-&gt;addr);
	s_tolower(s_restart(lower));
	rp = findrule(lower, dp-&gt;authorized);
	if(rp == 0){
		s_free(lower);
		return -1;
	}
	strcpy(s_to_c(lower), s_to_c(dp-&gt;addr));
	dp-&gt;repl1 = substitute(rp-&gt;repl1, rp-&gt;subexp, mp);
	dp-&gt;repl2 = substitute(rp-&gt;repl2, rp-&gt;subexp, mp);
	dp-&gt;status = rp-&gt;type;
	if(debug){
		fprint(2, "\t-&gt;");
		if(dp-&gt;repl1)
			fprint(2, "%s", s_to_c(dp-&gt;repl1));
		if(dp-&gt;repl2)
			fprint(2, "%s", s_to_c(dp-&gt;repl2));
		fprint(2, "\n");
	}
	s_free(lower);
	return 0;
}

static String *
substitute(String *source, Resub *subexp, message *mp)
{
	int i;
	char *s;
	char *sp;
	String *stp;
	
	if(source == 0)
		return 0;
	sp = s_to_c(source);

	/* someplace to put it */
	stp = s_new();

	/* do the substitution */
	while (*sp != '\0') {
		if(*sp == '\\') {
			switch (*++sp) {
			case '0': case '1': case '2': case '3': case '4':
			case '5': case '6': case '7': case '8': case '9':
				i = *sp-'0';
				if(subexp[i].sp != 0)
					for (s = subexp[i].sp;
					     s &lt; subexp[i].ep;
					     s++)
						s_putc(stp, *s);
				break;
			case '\\':
				s_putc(stp, '\\');
				break;
			case '\0':
				sp--;
				break;
			case 's':
				for(s = s_to_c(mp-&gt;replyaddr); *s; s++)
					s_putc(stp, *s);
				break;
			case 'p':
				if(mp-&gt;bulk)
					s = "bulk";
				else
					s = "normal";
				for(;*s; s++)
					s_putc(stp, *s);
				break;
			default:
				s_putc(stp, *sp);
				break;
			}
		} else if(*sp == '&amp;') {				
			if(subexp[0].sp != 0)
				for (s = subexp[0].sp;
				     s &lt; subexp[0].ep; s++)
					s_putc(stp, *s);
		} else
			s_putc(stp, *sp);
		sp++;
	}
	s_terminate(stp);

	return s_restart(stp);
}

extern void
regerror(char* s)
{
	fprint(2, "rewrite: %s\n", s);
	/* make sure the message is seen locally */
	syslog(0, "mail", "regexp error in rewrite: %s", s);
}

extern void
dumprules(void)
{
	rule *rp;

	for (rp = rulep; rp != 0; rp = rp-&gt;next) {
		fprint(2, "'%s'", rp-&gt;matchre-&gt;base);
		switch (rp-&gt;type) {
		case d_pipe:
			fprint(2, " |");
			break;
		case d_cat:
			fprint(2, " &gt;&gt;");
			break;
		case d_alias:
			fprint(2, " alias");
			break;
		case d_translate:
			fprint(2, " translate");
			break;
		default:
			fprint(2, " UNKNOWN");
			break;
		}
		fprint(2, " '%s'", rp-&gt;repl1 ? rp-&gt;repl1-&gt;base:"...");
		fprint(2, " '%s'\n", rp-&gt;repl2 ? rp-&gt;repl2-&gt;base:"...");
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

