<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/smtp/mxdial.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/smtp/mxdial.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;ndb.h&gt;
#include &lt;smtp.h&gt;	/* to publish dial_string_parse */

enum
{
	Nmx=		16,
	Maxstring=	256,
	Maxipstr=	8*5,		/* ipv6 */
};

typedef struct Mx	Mx;
struct Mx
{
	char	host[Maxstring];
	char	ip[Maxipstr];		/* this is just the first ip */
	int	pref;
};

char	*bustedmxs[Maxbustedmx];
Ndb *db;

static Mx mx[Nmx];

static int	callmx(DS*, char*, char*);
static int	compar(void*, void*);
static void	expand_meta(DS *ds);
static int	mxlookup(DS*, char*);
static int	mxlookup1(DS*, char*);

int
mxdial(char *addr, char *ddomain, char *gdomain)
{
	int fd;
	DS ds;
	char err[Errlen];

	addr = netmkaddr(addr, 0, "smtp");
	dial_string_parse(addr, &amp;ds);

	/* try connecting to destination or any of it's mail routers */
	fd = callmx(&amp;ds, addr, ddomain);

	/* try our mail gateway */
	rerrstr(err, sizeof(err));
	if(fd &lt; 0 &amp;&amp; gdomain &amp;&amp; strstr(err, "can't translate") != 0)
		fd = dial(netmkaddr(gdomain, 0, "smtp"), 0, 0, 0);

	return fd;
}

static int
busted(char *mx)
{
	char **bmp;

	for (bmp = bustedmxs; *bmp != nil; bmp++)
		if (strcmp(mx, *bmp) == 0)
			return 1;
	return 0;
}

static int
timeout(void*, char *msg)
{
	if(strstr(msg, "alarm"))
		return 1;
	return 0;
}

long
timedwrite(int fd, void *buf, long len, long ms)
{
	long n, oalarm;

	atnotify(timeout, 1);
	oalarm = alarm(ms);
	n = write(fd, buf, len);
	alarm(oalarm);
	atnotify(timeout, 0);
	return n;
}

static int
isloopback(char *ip)
{
	return strcmp(ip, "127.0.0.1") == 0 || strcmp(ip, "::1") == 0;
}

/*
 *  take an address and return all the mx entries for it,
 *  most preferred first
 */
static int
callmx(DS *ds, char *dest, char *domain)
{
	int fd, i, nmx;
	char *ip;
	char addr[Maxstring];

	/* get a list of mx entries */
	nmx = mxlookup(ds, domain);
	if(nmx &lt; 0){
		/* dns isn't working, don't just dial */
		return -1;
	}
	if(nmx == 0){
		if(debug)
			fprint(2, "mxlookup returns nothing\n");
		return dial(dest, 0, 0, 0);
	}

	/* refuse to honor loopback addresses given by dns.  catch \n too. */
	for(i = 0; i &lt; nmx; i++) {
		ip = mx[i].ip;
		if(strchr(ip, '\n') != nil){
			if(debug)
				fprint(2, "mxlookup ip contains newline\n");
			werrstr("illegal: newline in mail server ip");
			return -1;
		}else if(isloopback(ip)){
			if(debug)
				fprint(2, "mxlookup returns loopback\n");
			werrstr("illegal: domain lists %s as mail server", ip);
			return -1;
		}
	}

	/* sort by preference */
	if(nmx &gt; 1)
		qsort(mx, nmx, sizeof(Mx), compar);

	/* dial each one in turn by name, not ip */
	for(i = 0; i &lt; nmx; i++){
		if (busted(mx[i].host)) {
			if (debug)
				fprint(2, "mxdial skipping busted mx %s\n",
					mx[i].host);
			continue;
		}
		snprint(addr, sizeof(addr), "%s/%s!%s!%s", ds-&gt;netdir, ds-&gt;proto,
			mx[i].host, ds-&gt;service);
		if(debug)
			fprint(2, "mxdial trying %s\n", addr);
		atnotify(timeout, 1);
		/* this was 10 seconds, but oclsc.org at least needs more. */
		alarm(60*1000);
		fd = dial(addr, 0, 0, 0);
		if (debug &amp;&amp; fd &lt; 0)
			fprint(2, "dial: %r\n");
		alarm(0);
		atnotify(timeout, 0);
		if(fd &gt;= 0)
			return fd;
	}
	return -1;
}

/*
 *  call the dns process and have it try to resolve the mx request
 *
 *  this routine knows about the firewall and tries inside and outside
 *  dns's seperately.
 */
static int
mxlookup(DS *ds, char *domain)
{
	int n;

	/* just in case we find no domain name */
	strcpy(domain, ds-&gt;host);

	if(ds-&gt;netdir)
		n = mxlookup1(ds, domain);
	else {
		ds-&gt;netdir = "/net";
		n = mxlookup1(ds, domain);
		if(n == 0) {
			ds-&gt;netdir = "/net.alt";
			n = mxlookup1(ds, domain);
		}
	}

	return n;
}

static int
mxlookup1(DS *ds, char *domain)
{
	int i, n, fd, nmx;
	char buf[Maxdomain], dnsname[Maxstring];
	char *fields[4];
	Mx *mxp;

	snprint(dnsname, sizeof dnsname, "%s/dns", ds-&gt;netdir);

	fd = open(dnsname, ORDWR);
	if(fd &lt; 0)
		return 0;

	nmx = 0;
	snprint(buf, sizeof buf, "%s mx", ds-&gt;host);
	if(debug)
		fprint(2, "sending %s '%s'\n", dnsname, buf);
	/*
	 * don't hang indefinitely in the write to /net/dns.
	 */
	n = timedwrite(fd, buf, strlen(buf), 60*1000);
	if(n &lt; 0){
		rerrstr(buf, sizeof buf);
		if(debug)
			fprint(2, "dns: %s\n", buf);
		if(strstr(buf, "dns failure")){
			/* if dns fails for the mx lookup, we have to stop */
			close(fd);
			return -1;
		}
	} else {
		/*
		 *  get any mx entries
		 *  assumes one record per read
		 */
		seek(fd, 0, 0);
		while(nmx &lt; Nmx &amp;&amp; (n = read(fd, buf, sizeof buf-1)) &gt; 0){
			mxp = &amp;mx[nmx];
			buf[n] = 0;
			if(debug)
				fprint(2, "dns mx: %s\n", buf);
			n = getfields(buf, fields, 4, 1, " \t");
			if(n &lt; 4)
				continue;

			if(strchr(domain, '.') == 0)
				strcpy(domain, fields[0]);

			strncpy(mxp-&gt;host, fields[3], sizeof mxp-&gt;host - 1);
			mxp-&gt;host[sizeof mxp-&gt;host - 1] = '\0';
			mxp-&gt;pref = atoi(fields[2]);
			nmx++;
		}
		if(debug)
			fprint(2, "dns mx: got %d mx servers\n", nmx);
	}

	/*
	 * no mx record? try name itself.
	 *
	 * BUG? If domain has no dots, then we used to look up ds-&gt;host
	 * but return domain instead of ds-&gt;host in the list.  Now we return
	 * ds-&gt;host.  What will this break?
	 */
	if(nmx == 0){
		mx[0].pref = 1;
		strncpy(mx[0].host, ds-&gt;host, sizeof(mx[0].host));
		nmx++;
	}

	/*
	 * look up first ip address of each mx name.
	 * should really look at all addresses.
	 * assumes one record per read.
	 */
	for(i = 0; i &lt; nmx; i++){
		mxp = &amp;mx[i];
		seek(fd, 0, 0);
		snprint(buf, sizeof buf, "%s ip", mxp-&gt;host);
		mxp-&gt;ip[0] = 0;
		/*
		 * don't hang indefinitely in the write to /net/dns.
		 */
		if(timedwrite(fd, buf, strlen(buf), 60*1000) &lt; 0)
			goto no;
		seek(fd, 0, 0);
		if((n = read(fd, buf, sizeof buf-1)) &lt; 0)
			goto no;
		buf[n] = 0;
		if(getfields(buf, fields, 4, 1, " \t") &lt; 3)
			goto no;
		strncpy(mxp-&gt;ip, fields[2], sizeof mxp-&gt;ip - 1);
		mxp-&gt;ip[sizeof mxp-&gt;ip - 1] = '\0';
		continue;

	no:
		/* remove mx[i] and go around again */
		nmx--;
		*mxp = mx[nmx];
		i--;
	}
	close(fd);
	return nmx;
}

static int
compar(void *a, void *b)
{
	return ((Mx*)a)-&gt;pref - ((Mx*)b)-&gt;pref;
}

/* break up an address to its component parts */
void
dial_string_parse(char *str, DS *ds)
{
	char *p, *p2;

	strncpy(ds-&gt;buf, str, sizeof(ds-&gt;buf));
	ds-&gt;buf[sizeof(ds-&gt;buf)-1] = 0;

	p = strchr(ds-&gt;buf, '!');
	if(p == 0) {
		ds-&gt;netdir = 0;
		ds-&gt;proto = "net";
		ds-&gt;host = ds-&gt;buf;
	} else {
		if(*ds-&gt;buf != '/'){
			ds-&gt;netdir = 0;
			ds-&gt;proto = ds-&gt;buf;
		} else {
			for(p2 = p; *p2 != '/'; p2--)
				;
			*p2++ = 0;
			ds-&gt;netdir = ds-&gt;buf;
			ds-&gt;proto = p2;
		}
		*p = 0;
		ds-&gt;host = p + 1;
	}
	ds-&gt;service = strchr(ds-&gt;host, '!');
	if(ds-&gt;service)
		*ds-&gt;service++ = 0;
	if(*ds-&gt;host == '$')
		expand_meta(ds);
}

static void
expand_meta(DS *ds)
{
	char buf[128], cs[128], *net, *p;
	int fd, n;

	net = ds-&gt;netdir;
	if(!net)
		net = "/net";

	if(debug)
		fprint(2, "expanding %s!%s\n", net, ds-&gt;host);
	snprint(cs, sizeof(cs), "%s/cs", net);
	if((fd = open(cs, ORDWR)) == -1){
		if(debug)
			fprint(2, "open %s: %r\n", cs);
		syslog(0, "smtp", "cannot open %s: %r", cs);
		return;
	}

	snprint(buf, sizeof buf, "!ipinfo %s", ds-&gt;host+1);	// +1 to skip $
	if(write(fd, buf, strlen(buf)) &lt;= 0){
		if(debug)
			fprint(2, "write %s: %r\n", cs);
		syslog(0, "smtp", "%s to %s - write failed: %r", buf, cs);
		close(fd);
		return;
	}

	seek(fd, 0, 0);
	if((n = read(fd, ds-&gt;expand, sizeof(ds-&gt;expand)-1)) &lt; 0){
		if(debug)
			fprint(2, "read %s: %r\n", cs);
		syslog(0, "smtp", "%s - read failed: %r", cs);
		close(fd);
		return;
	}
	close(fd);

	ds-&gt;expand[n] = 0;
	if((p = strchr(ds-&gt;expand, '=')) == nil){
		if(debug)
			fprint(2, "response %s: %s\n", cs, ds-&gt;expand);
		syslog(0, "smtp", "%q from %s - bad response: %r", ds-&gt;expand, cs);
		return;
	}
	ds-&gt;host = p+1;

	/* take only first one returned (quasi-bug) */
	if((p = strchr(ds-&gt;host, ' ')) != nil)
		*p = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

