<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/audio/audiofs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/audio/audiofs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;libsec.h&gt;
#include "usb.h"
#include "audio.h"
#include "audioctl.h"

int attachok;

#define STACKSIZE 16*1024

enum
{
	OPERM	= 0x3,	/* mask of all permission types in open mode */
};

typedef struct Fid Fid;
typedef struct Audioctldata Audioctldata;
typedef struct Worker Worker;

struct Audioctldata
{
	long	offoff;			/* offset of the offset for audioctl */
	long	values[2][Ncontrol][8];	/* last values transmitted */
	char	*s;
	int	ns;
};

enum {
	Busy =	0x01,
	Open =	0x02,
	Eof =	0x04,
};

struct Fid
{
	QLock;
	int	fid;
	Dir	*dir;
	ushort	flags;
	short	readers;
	void	*fiddata;  /* file specific per-fid data (used for audioctl) */
	Fid	*next;
};

struct Worker
{
	Fid	*fid;
	ushort	tag;
	Fcall	*rhdr;
	Dir	*dir;
	Channel	*eventc;
	Worker	*next;
};

enum {
	/* Event channel messages for worker */
	Work =	0x01,
	Check =	0x02,
	Flush =	0x03,
};

enum {
	Qdir,
	Qvolume,
	Qaudioctl,
	Qaudiostat,
	Nqid,
};

Dir dirs[] = {
[Qdir] =		{0,0,{Qdir,      0,QTDIR},0555|DMDIR,0,0,0, ".",  nil,nil,nil},
[Qvolume] =	{0,0,{Qvolume,   0,QTFILE},0666,0,0,0,	"volume", nil,nil,nil},
[Qaudioctl] =	{0,0,{Qaudioctl, 0,QTFILE},0666,0,0,0,	"audioctl",nil,nil,nil},
[Qaudiostat] =	{0,0,{Qaudiostat,0,QTFILE},0666,0,0,0,	"audiostat",nil,nil,nil},
};

int	messagesize = 4*1024+IOHDRSZ;
uchar	mdata[8*1024+IOHDRSZ];
uchar	mbuf[8*1024+IOHDRSZ];

Fcall	thdr;
Fcall	rhdr;
Worker *workers;

char srvfile[64], mntdir[64], epdata[64], audiofile[64];
int mfd[2], p[2];
char user[32];
char *srvpost;

Channel *procchan;
Channel *replchan;

Fid *fids;

Fid*		newfid(int);
void		io(void *);
void		usage(void);

extern char *mntpt;

char	*rflush(Fid*), *rauth(Fid*),
	*rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*),
	*rversion(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tauth]		rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"no authentication in ramfs";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Ebadctl[] =	"unknown control message";

int
notifyf(void *, char *s)
{
	if(strncmp(s, "interrupt", 9) == 0)
		return 1;
	return 0;
}

void
post(char *name, char *envname, int srvfd)
{
	int fd;
	char buf[32];

	fd = create(name, OWRITE, attachok?0666:0600);
	if(fd &lt; 0)
		return;
	snprint(buf, sizeof buf, "%d", srvfd);
	if(write(fd, buf, strlen(buf)) != strlen(buf))
		sysfatal("srv write");
	close(fd);
	putenv(envname, name);
}

/*
 * BUG: If audio is later used on a different name space, the
 * audio/audioin files are not there because of the bind trick.
 * We should actually implement those files despite the binds.
 * If audio is used from within the same ns nothing would change,
 * otherwise, whoever would mount the audio files could still
 * play/record audio (unlike now).
 */
void
serve(void *)
{
	int i;
	ulong t;

	if(pipe(p) &lt; 0)
		sysfatal("pipe failed");
	mfd[0] = p[0];
	mfd[1] = p[0];

	atnotify(notifyf, 1);
	strcpy(user, getuser());
	t = time(nil);
	for(i = 0; i &lt; Nqid; i++){
		dirs[i].uid = user;
		dirs[i].gid = user;
		dirs[i].muid = user;
		dirs[i].atime = t;
		dirs[i].mtime = t;
	}
	if(mntpt == nil){
		snprint(mntdir, sizeof(mntdir), "/dev");
		mntpt = mntdir;
	}

	if(usbdebug)
		fmtinstall('F', fcallfmt);

	procrfork(io, nil, STACKSIZE, RFFDG|RFNAMEG);

	close(p[0]);	/* don't deadlock if child fails */
	if(srvpost){
		snprint(srvfile, sizeof srvfile, "/srv/%s", srvpost);
		remove(srvfile);
		post(srvfile, "usbaudio", p[1]);
	}
	if(mount(p[1], -1, mntpt, MBEFORE, "") &lt; 0)
		sysfatal("mount failed");
	if(endpt[Play] &gt;= 0 &amp;&amp; devctl(epdev[Play], "name audio") &lt; 0)
		fprint(2, "audio: name audio: %r\n");
	if(endpt[Record] &gt;= 0 &amp;&amp; devctl(epdev[Record], "name audioin") &lt; 0)
		fprint(2, "audio: name audioin: %r\n");
	threadexits(nil);
}

char*
rversion(Fid*)
{
	Fid *f;

	if(thdr.msize &lt; 256)
		return "max messagesize too small";
	if(thdr.msize &lt; messagesize)
		messagesize = thdr.msize;
	rhdr.msize = messagesize;
	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return "unknown 9P version";
	else
		rhdr.version = "9P2000";
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;flags &amp; Busy)
			rclunk(f);
	return nil;
}

char*
rauth(Fid*)
{
	return "usbaudio: no authentication required";
}

char*
rflush(Fid *)
{
	Worker *w;
	int waitflush;

	do {
		waitflush = 0;
		for(w = workers; w; w = w-&gt;next)
			if(w-&gt;tag == thdr.oldtag){
				waitflush++;
				nbsendul(w-&gt;eventc, thdr.oldtag &lt;&lt; 16 | Flush);
			}
		if(waitflush)
			sleep(50);
	} while(waitflush);
	dprint(2, "flush done on tag %d\n", thdr.oldtag);
	return 0;
}

char*
rattach(Fid *f)
{
	f-&gt;flags |= Busy;
	f-&gt;dir = &amp;dirs[Qdir];
	rhdr.qid = f-&gt;dir-&gt;qid;
	if(attachok == 0 &amp;&amp; strcmp(thdr.uname, user) != 0)
		return Eperm;
	return 0;
}

static Fid*
doclone(Fid *f, int nfid)
{
	Fid *nf;

	nf = newfid(nfid);
	if(nf-&gt;flags &amp; Busy)
		return nil;
	nf-&gt;flags |= Busy;
	nf-&gt;flags &amp;= ~Open;
	nf-&gt;dir = f-&gt;dir;
	return nf;
}

char*
dowalk(Fid *f, char *name)
{
	int t;

	if(strcmp(name, ".") == 0)
		return nil;
	if(strcmp(name, "..") == 0){
		f-&gt;dir = &amp;dirs[Qdir];
		return nil;
	}
	if(f-&gt;dir != &amp;dirs[Qdir])
		return Enotexist;
	for(t = 1; t &lt; Nqid; t++){
		if(strcmp(name, dirs[t].name) == 0){
			f-&gt;dir = &amp;dirs[t];
			return nil;
		}
	}
	return Enotexist;
}

char*
rwalk(Fid *f)
{
	Fid *nf;
	char *rv;
	int i;
	Dir *savedir;

	if(f-&gt;flags &amp; Open)
		return Eisopen;

	rhdr.nwqid = 0;
	nf = nil;
	savedir = f-&gt;dir;
	/* clone if requested */
	if(thdr.newfid != thdr.fid){
		nf = doclone(f, thdr.newfid);
		if(nf == nil)
			return "new fid in use";
		f = nf;
	}

	/* if it's just a clone, return */
	if(thdr.nwname == 0 &amp;&amp; nf != nil)
		return nil;

	/* walk each element */
	rv = nil;
	for(i = 0; i &lt; thdr.nwname; i++){
		rv = dowalk(f, thdr.wname[i]);
		if(rv != nil){
			if(nf != nil)
				rclunk(nf);
			else
				f-&gt;dir = savedir;
			break;
		}
		rhdr.wqid[i] = f-&gt;dir-&gt;qid;
	}
	rhdr.nwqid = i;

	/* we only error out if no walk  */
	if(i &gt; 0)
		rv = nil;

	return rv;
}

Audioctldata *
allocaudioctldata(void)
{
	int i, j, k;
	Audioctldata *a;

	a = emallocz(sizeof(Audioctldata), 1);
	for(i = 0; i &lt; 2; i++)
		for(j=0; j &lt; Ncontrol; j++)
			for(k=0; k &lt; 8; k++)
				a-&gt;values[i][j][k] = Undef;
	return a;
}

char *
ropen(Fid *f)
{
	if(f-&gt;flags &amp; Open)
		return Eisopen;

	if(thdr.mode != OREAD &amp;&amp; (f-&gt;dir-&gt;mode &amp; 0x2) == 0)
		return Eperm;
	qlock(f);
	if(f-&gt;dir == &amp;dirs[Qaudioctl] &amp;&amp; f-&gt;fiddata == nil)
		f-&gt;fiddata = allocaudioctldata();
	qunlock(f);
	rhdr.iounit = 0;
	rhdr.qid = f-&gt;dir-&gt;qid;
	f-&gt;flags |= Open;
	return nil;
}

char *
rcreate(Fid*)
{
	return Eperm;
}

int
readtopdir(Fid*, uchar *buf, long off, int cnt, int blen)
{
	int i, m, n;
	long pos;

	n = 0;
	pos = 0;
	for(i = 1; i &lt; Nqid; i++){
		m = convD2M(&amp;dirs[i], &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}
	return n;
}

enum { Chunk = 1024, };

int
makeaudioctldata(Fid *f)
{
	int rec, ctl, i, diff;
	long *actls;		/* 8 of them */
	char *p, *e;
	Audiocontrol *c;
	Audioctldata *a;

	if((a = f-&gt;fiddata) == nil)
		sysfatal("fiddata");
	if((p = a-&gt;s) == nil)
		a-&gt;s = p = emallocz(Chunk, 0);
	e = p + Chunk - 1;	/* e must point *at* last byte, not *after* */
	for(rec = 0; rec &lt; 2; rec++)
		for(ctl = 0; ctl &lt; Ncontrol; ctl++){
			c = &amp;controls[rec][ctl];
			actls = a-&gt;values[rec][ctl];
			diff = 0;
			if(c-&gt;chans){
				for(i = 1; i &lt; 8; i++)
					if((c-&gt;chans &amp; 1&lt;&lt;i) &amp;&amp;
					    c-&gt;value[i] != actls[i])
						diff = 1;
			}else
				if(c-&gt;value[0] != actls[0])
					diff = 1;
			if(diff){
				p = seprint(p, e, "%s %s %A", c-&gt;name,
					rec? "in": "out", c);
				memmove(actls, c-&gt;value, sizeof c-&gt;value);
				if(c-&gt;min != Undef){
					p = seprint(p, e, " %ld %ld", c-&gt;min,
						c-&gt;max);
					if(c-&gt;step != Undef)
						p = seprint(p, e, " %ld",
							c-&gt;step);
				}
				p = seprint(p, e, "\n");
			}
		}
	assert(strlen(a-&gt;s) &lt; Chunk);
	a-&gt;ns = p - a-&gt;s;
	return a-&gt;ns;
}

void
readproc(void *x)
{
	int n, cnt;
	ulong event;
	vlong off;
	uchar *mdata;
	Audioctldata *a;
	Fcall *rhdr;
	Fid *f;
	Worker *w;

	w = x;
	mdata = emallocz(8*1024+IOHDRSZ, 0);
	while(event = recvul(w-&gt;eventc)){
		if(event != Work)
			continue;
		f = w-&gt;fid;
		rhdr = w-&gt;rhdr;
		a = f-&gt;fiddata;
		off = rhdr-&gt;offset;
		cnt = rhdr-&gt;count;
		assert(a-&gt;offoff == off);
		/* f is already locked */
		for(;;){
			qunlock(f);
			event = recvul(w-&gt;eventc);
			qlock(f);
			ddprint(2, "readproc unblocked fid %d %lld\n",
					f-&gt;fid, f-&gt;dir-&gt;qid.path);
			switch (event &amp; 0xffff){
			case Work:
				sysfatal("readproc phase error");
			case Check:
				if(f-&gt;fiddata &amp;&amp; makeaudioctldata(f) == 0)
					continue;
				break;
			case Flush:
				if((event &gt;&gt; 16) == rhdr-&gt;tag){
					ddprint(2, "readproc flushing fid %d, tag %d\n",
						f-&gt;fid, rhdr-&gt;tag);
					goto flush;
				}
				continue;
			}
			if(f-&gt;fiddata){
				rhdr-&gt;data = a-&gt;s;
				rhdr-&gt;count = a-&gt;ns;
				break;
			}
			yield();
		}
		if(rhdr-&gt;count &gt; cnt)
			rhdr-&gt;count = cnt;
		if(rhdr-&gt;count)
			f-&gt;flags &amp;= ~Eof;
		ddprint(2, "readproc:-&gt;%F\n", rhdr);
		n = convS2M(rhdr, mdata, messagesize);
		if(write(mfd[1], mdata, n) != n)
			sysfatal("mount write");
flush:
		w-&gt;tag = NOTAG;
		f-&gt;readers--;
		assert(f-&gt;readers == 0);
		free(rhdr);
		w-&gt;rhdr = nil;
		qunlock(f);
		sendp(procchan, w);
	}
	threadexits(nil);
}

char*
rread(Fid *f)
{
	int i, n, cnt, rec, div;
	vlong off;
	char *p;
	Audiocontrol *c;
	Audioctldata *a;
	Worker *w;
	static char buf[1024];

	rhdr.count = 0;
	off = thdr.offset;
	cnt = thdr.count;

	if(cnt &gt; messagesize - IOHDRSZ)
		cnt = messagesize - IOHDRSZ;

	rhdr.data = (char*)mbuf;

	if(f-&gt;dir == &amp;dirs[Qdir]){
		n = readtopdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
		rhdr.count = n;
		return nil;
	}

	if(f-&gt;dir == &amp;dirs[Qvolume]){
		p = buf;
		n = sizeof buf;
		for(rec = 0; rec &lt; 2; rec++){
			c = &amp;controls[rec][Volume_control];
			if(c-&gt;readable){
				div = c-&gt;max - c-&gt;min;
				i = snprint(p, n, "audio %s %ld\n",
					rec? "in": "out", (c-&gt;min != Undef?
					100*(c-&gt;value[0]-c-&gt;min)/(div? div: 1):
					c-&gt;value[0]));
				p += i;
				n -= i;
			}
			c = &amp;controls[rec][Treble_control];
			if(c-&gt;readable){
				div = c-&gt;max - c-&gt;min;
				i = snprint(p, n, "treb %s %ld\n",
					rec? "in": "out", (c-&gt;min != Undef?
					100*(c-&gt;value[0]-c-&gt;min)/(div? div: 1):
					c-&gt;value[0]));
				p += i;
				n -= i;
			}
			c = &amp;controls[rec][Bass_control];
			if(c-&gt;readable){
				div = c-&gt;max - c-&gt;min;
				i = snprint(p, n, "bass %s %ld\n",
					rec? "in": "out", (c-&gt;min != Undef?
					100*(c-&gt;value[0]-c-&gt;min)/(div? div: 1):
					c-&gt;value[0]));
				p += i;
				n -= i;
			}
			c = &amp;controls[rec][Speed_control];
			if(c-&gt;readable){
				i = snprint(p, n, "speed %s %ld\n",
					rec? "in": "out", c-&gt;value[0]);
				p += i;
				n -= i;
			}
		}
		n = sizeof buf - n;
		if(off &gt; n)
			rhdr.count = 0;
		else{
			rhdr.data = buf + off;
			rhdr.count = n - off;
			if(rhdr.count &gt; cnt)
				rhdr.count = cnt;
		}
		return nil;
	}

	if(f-&gt;dir == &amp;dirs[Qaudioctl]){
		Fcall *hdr;

		qlock(f);
		a = f-&gt;fiddata;
		if(off - a-&gt;offoff &lt; 0){
			/* there was a seek */
			a-&gt;offoff = off;
			a-&gt;ns = 0;
		}
		do {
			if(off - a-&gt;offoff &lt; a-&gt;ns){
				rhdr.data = a-&gt;s + (off - a-&gt;offoff);
				rhdr.count = a-&gt;ns - (off - a-&gt;offoff);
				if(rhdr.count &gt; cnt)
					rhdr.count = cnt;
				qunlock(f);
				return nil;
			}
			if(a-&gt;offoff != off){
				a-&gt;ns = 0;
				a-&gt;offoff = off;
				rhdr.count = 0;
				qunlock(f);
				return nil;
			}
		} while(makeaudioctldata(f) != 0);

		assert(a-&gt;offoff == off);
		/* Wait for data off line */
		f-&gt;readers++;
		w = nbrecvp(procchan);
		if(w == nil){
			w = emallocz(sizeof(Worker), 1);
			w-&gt;eventc = chancreate(sizeof(ulong), 1);
			w-&gt;next = workers;
			workers = w;
			proccreate(readproc, w, 4096);
		}
		hdr = emallocz(sizeof(Fcall), 0);
		w-&gt;fid = f;
		w-&gt;tag = thdr.tag;
		assert(w-&gt;rhdr == nil);
		w-&gt;rhdr = hdr;
		hdr-&gt;count = cnt;
		hdr-&gt;offset = off;
		hdr-&gt;type = thdr.type+1;
		hdr-&gt;fid = thdr.fid;
		hdr-&gt;tag = thdr.tag;
		sendul(w-&gt;eventc, Work);
		return (char*)~0;
	}

	return Eperm;
}

char*
rwrite(Fid *f)
{
	long cnt, value;
	char *lines[2*Ncontrol], *fields[4], *subfields[9], *err, *p;
	int nlines, i, nf, nnf, rec, ctl;
	Audiocontrol *c;
	Worker *w;
	static char buf[256];

	rhdr.count = 0;
	cnt = thdr.count;

	if(cnt &gt; messagesize - IOHDRSZ)
		cnt = messagesize - IOHDRSZ;

	err = nil;
	if(f-&gt;dir == &amp;dirs[Qvolume] || f-&gt;dir == &amp;dirs[Qaudioctl]){
		thdr.data[cnt] = '\0';
		nlines = getfields(thdr.data, lines, 2*Ncontrol, 1, "\n");
		for(i = 0; i &lt; nlines; i++){
			dprint(2, "line: %s\n", lines[i]);
			nf = tokenize(lines[i], fields, 4);
			if(nf == 0)
				continue;
			if(nf == 3)
				if(strcmp(fields[1], "in") == 0 ||
				    strcmp(fields[1], "record") == 0)
					rec = 1;
				else if(strcmp(fields[1], "out") == 0 ||
				    strcmp(fields[1], "playback") == 0)
					rec = 0;
				else{
					dprint(2, "bad1\n");
					return Ebadctl;
				}
			else if(nf == 2)
				rec = 0;
			else{
				dprint(2, "bad2 %d\n", nf);
				return Ebadctl;
			}
			c = nil;
			if(strcmp(fields[0], "audio") == 0) /* special case */
				fields[0] = "volume";
			for(ctl = 0; ctl &lt; Ncontrol; ctl++){
				c = &amp;controls[rec][ctl];
				if(strcmp(fields[0], c-&gt;name) == 0)
					break;
			}
			if(ctl == Ncontrol){
				dprint(2, "bad3\n");
				return Ebadctl;
			}
			if(f-&gt;dir == &amp;dirs[Qvolume] &amp;&amp; ctl != Speed_control &amp;&amp;
			    c-&gt;min != Undef &amp;&amp; c-&gt;max != Undef){
				nnf = tokenize(fields[nf-1], subfields,
					nelem(subfields));
				if(nnf &lt;= 0 || nnf &gt; 8){
					dprint(2, "bad4\n");
					return Ebadctl;
				}
				p = buf;
				for(i = 0; i &lt; nnf; i++){
					value = strtol(subfields[i], nil, 0);
					value = ((100 - value)*c-&gt;min +
						value*c-&gt;max) / 100;
					if(p == buf){
						dprint(2, "rwrite: %s %s '%ld",
								c-&gt;name, rec?
								"record":
								"playback",
								value);
					}else
						dprint(2, " %ld", value);
					if(p == buf)
						p = seprint(p, buf+sizeof buf,
							"0x%p %s %s '%ld",
							replchan, c-&gt;name, rec?
							"record": "playback",
							value);
					else
						p = seprint(p, buf+sizeof buf,
							" %ld", value);
				}
				dprint(2, "'\n");
				seprint(p, buf+sizeof buf-1, "'");
				chanprint(controlchan, buf);
			}else{
				dprint(2, "rwrite: %s %s %q", c-&gt;name,
						rec? "record": "playback",
						fields[nf-1]);
				chanprint(controlchan, "0x%p %s %s %q",
					replchan, c-&gt;name, rec? "record":
					"playback", fields[nf-1]);
			}
			p = recvp(replchan);
			if(p){
				if(strcmp(p, "ok") == 0){
					free(p);
					p = nil;
				}
				if(err == nil)
					err = p;
			}
		}
		for(w = workers; w; w = w-&gt;next)
			nbsendul(w-&gt;eventc, Qaudioctl &lt;&lt; 16 | Check);
		rhdr.count = thdr.count;
		return err;
	}
	return Eperm;
}

char *
rclunk(Fid *f)
{
	Audioctldata *a;

	qlock(f);
	f-&gt;flags &amp;= ~(Open|Busy);
	assert(f-&gt;readers ==0);
	if(f-&gt;fiddata){
		a = f-&gt;fiddata;
		if(a-&gt;s)
			free(a-&gt;s);
		free(a);
		f-&gt;fiddata = nil;
	}
	qunlock(f);
	return 0;
}

char *
rremove(Fid *)
{
	return Eperm;
}

char *
rstat(Fid *f)
{
	Audioctldata *a;

	if(f-&gt;dir == &amp;dirs[Qaudioctl]){
		qlock(f);
		if(f-&gt;fiddata == nil)
			f-&gt;fiddata = allocaudioctldata();
		a = f-&gt;fiddata;
		if(a-&gt;ns == 0)
			makeaudioctldata(f);
		f-&gt;dir-&gt;length = a-&gt;offoff + a-&gt;ns;
		qunlock(f);
	}
	rhdr.nstat = convD2M(f-&gt;dir, mbuf, messagesize - IOHDRSZ);
	rhdr.stat = mbuf;
	return 0;
}

char *
rwstat(Fid*)
{
	return Eperm;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = nil;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(ff == nil &amp;&amp; (f-&gt;flags &amp; Busy) == 0)
			ff = f;
	if(ff == nil){
		ff = emallocz(sizeof *ff, 1);
		ff-&gt;next = fids;
		fids = ff;
	}
	ff-&gt;fid = fid;
	ff-&gt;flags &amp;= ~(Busy|Open);
	ff-&gt;dir = nil;
	return ff;
}

void
io(void *)
{
	char *err, e[32];
	int n;

	close(p[1]);

	procchan = chancreate(sizeof(Channel*), 8);
	replchan = chancreate(sizeof(char*), 0);
	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		n = read9pmsg(mfd[0], mdata, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0){
			rerrstr(e, sizeof e);
			if(strcmp(e, "interrupted") == 0){
				dprint(2, "read9pmsg interrupted\n");
				continue;
			}
			return;
		}
		if(convM2S(mdata, n, &amp;thdr) == 0)
			continue;

		ddprint(2, "io:&lt;-%F\n", &amp;thdr);

		rhdr.data = (char*)mdata + messagesize;
		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[thdr.type])(newfid(thdr.fid));
		if(err == (char*)~0)
			continue;	/* handled off line */
		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		ddprint(2, "io:-&gt;%F\n", &amp;rhdr);
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(write(mfd[1], mdata, n) != n)
			sysfatal("mount write");
	}
}

int
newid(void)
{
	int rv;
	static int id;
	static Lock idlock;

	lock(&amp;idlock);
	rv = ++id;
	unlock(&amp;idlock);

	return rv;
}

void
ctlevent(void)
{
	Worker *w;

	for(w = workers; w; w = w-&gt;next)
		nbsendul(w-&gt;eventc, Qaudioctl &lt;&lt; 16 | Check);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

