<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/audio/audiosub.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/audio/audiosub.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "audio.h"
#include "audioctl.h"

typedef struct Namelist Namelist;

struct Namelist
{
	short	index;
	char		*name;
};

Namelist terminal_types[] = {
	{	0x100, "USB Terminal, undefined type"},
	{	0x101, "USB Streaming"},
	{	0x201, "Microphone"},
	{	0x301, "Speaker"},
	{	0x603, "Line connector"},
	{	0x605, "S/PDIF"},
	{	0, nil }
};

units[2][8];	/* rec and play units */
nunits[2];		/* number in use */

char *
namefor(Namelist *list, int item)
{
	while(list-&gt;name){
		if(list-&gt;index == item)
			return list-&gt;name;
		list++;
	}
	return "&lt;unnamed&gt;";
}

static int
findunit(int nr)
{
	int rec, i;
	for(rec = 0; rec &lt; 2; rec++)
		for(i = 0; i &lt; nunits[rec]; i++)
			if(units[rec][i] == nr)
				return rec;
	return -1;
}

void
audio_interface(Dev *, Desc *dd)
{
	byte *b = (uchar*)&amp;dd-&gt;data;
	byte *bb = b;
	int nb = dd-&gt;data.bLength;
	int ctl, ch, u, x;
	byte *p;
	int class, subclass;
	Audioalt *aa;
	char *hd;

	class = Class(dd-&gt;iface-&gt;csp);
	subclass = Subclass(dd-&gt;iface-&gt;csp);

	dprint(2, "%d.%d: ", class, subclass);
	switch (subclass){
	case 1:	// control
		switch (b[2]){
		case 0x01:
			dprint(2, "Class-Specific AC Interface Header Descriptor\n");
			dprint(2, "\tAudioDevClass release (bcd)%c%c%c%c, "
				"TotalLength %d, InCollection %d aInterfaceNr %d\n",
					'0'+((b[4]&gt;&gt;4)&amp;0xf), '0'+(b[4]&amp;0xf),
					'0'+((b[3]&gt;&gt;4)&amp;0xf), '0'+(b[3]&amp;0xf),
					b[5]|(b[6]&lt;&lt;8), b[7], b[8]);
			break;
		case 0x02:	// input
			dprint(2, "Audio Input Terminal Descriptor\n");
			dprint(2, "\tbTerminalId %d, wTerminalType "
				"0x%x (%s), bAssocTerminal %d bNrChannels %d, "
				"wChannelConfig %d, iChannelNames %d iTerminal %d\n",
					b[3], b[4]|(b[5]&lt;&lt;8),
					namefor(terminal_types, b[4]|(b[5]&lt;&lt;8)),
					b[6], b[7], b[8]|(b[9]&lt;&lt;8), b[10], b[11]);
			if((b[4]|b[5]&lt;&lt;8) == 0x101){
				if(verbose)
					fprint(2, "Audio output unit %d\n", b[3]);
				/* USB streaming input: play interface */
				units[Play][nunits[Play]++] = b[3];
			}else{
				if(verbose)
					fprint(2, "Dev can record from %s\n",
						namefor(terminal_types, b[4]|(b[5]&lt;&lt;8)));
				/* Non-USB input: record interface */
				units[Record][nunits[Record]++] = b[3];
			}
			break;
		case 0x03:	// output
			if(usbdebug){
				fprint(2, "Audio Output Terminal Descriptor\n");
				fprint(2, "\tbTerminalId %d, wTerminalType 0x%x (%s), bAssocTerminal %d bSourceId %d, iTerminal %d\n",
					b[3], b[4]|(b[5]&lt;&lt;8),
					namefor(terminal_types, b[4]|(b[5]&lt;&lt;8)),
					b[6], b[7], b[8]);
			}
			if((b[4]|b[5]&lt;&lt;8) == 0x101){
				if(verbose)
					fprint(2, "Audio input unit %d\n", b[3]);
				/* USB streaming output: record interface */
				units[Record][nunits[Record]++] = b[3];
				if(verbose)
					fprint(2, "Dev can play to %s\n",
						namefor(terminal_types, b[4]|(b[5]&lt;&lt;8)));
				/* Non-USB output: play interface */
				units[Play][nunits[Play]++] = b[3];
			}
			break;
		case 0x04:
			if(verbose)
				fprint(2, "Audio Mixer Unit %d\n", b[3]);
			if(usbdebug){
				fprint(2, "\t%d bytes:", nb);
				for(ctl = 0; ctl &lt; nb; ctl++)
					fprint(2, " 0x%2.2x", b[ctl]);
				fprint(2, "\n\tbUnitId %d, bNrInPins %d", b[3], b[4]);
			}
			if(b[4]){
				dprint(2, ", baSourceIDs: [%d", b[5]);
				u = findunit(b[5]);
				for(ctl = 1; ctl &lt; b[4]; ctl++){
					if(u &lt; 0)
						u = findunit(b[5+ctl]);
					else if((x = findunit(b[5+ctl])) &gt;= 0 &amp;&amp; u != x &amp;&amp; verbose)
						fprint(2, "\tMixer %d for I &amp; O \n", b[3]);
					dprint(2, ", %d", b[5+ctl]);
				}
				dprint(2, "]\n");
				if(u &gt;= 0){
					units[u][nunits[u]++] = b[3];
					if(mixerid[u] &gt;= 0)
						fprint(2, "Second mixer (%d, %d) on %s\n",
						 mixerid[u], b[3], u?"record":"playback");
					mixerid[u] = b[3];
				}
				if(usbdebug){
					fprint(2, "Channels %d, config %d, ",
						b[ctl+5], b[ctl+5+1] | b[ctl+5+2] &lt;&lt; 8);
					x = b[ctl+5] * b[4];
					fprint(2, "programmable: %d bits, 0x", x);
					x = (x + 7) &gt;&gt; 3;
					while(x--)
						fprint(2, "%2.2x", b[ctl+x+5+4]);
				}
			}
			break;
		case 0x05:
			if(verbose)
				fprint(2, "Audio Selector Unit %d\n", b[3]);
			dprint(2, "\tbUnitId %d, bNrInPins %d", b[3], b[4]);
			if(b[4]){
				u = findunit(b[5]);
				dprint(2, ", baSourceIDs: %s [%d",
					u?"record":"playback", b[5]);
				for(ctl = 1; ctl &lt; b[4]; ctl++){
					if(u &lt; 0)
						u = findunit(b[5+ctl]);
					else if((x = findunit(b[5+ctl])) &gt;= 0 &amp;&amp;
						u != x &amp;&amp; verbose)
						fprint(2, "\tSelector %d for I &amp; O\n", b[3]);
					dprint(2, ", %d", b[5+ctl]);
				}
				dprint(2, "]\n");
				if(u &gt;= 0){
					units[u][nunits[u]++] = b[3];
					if(selectorid[u] &gt;= 0)
						fprint(2, "Second selector (%d, %d) on %s\n", selectorid[u], b[3], u?"record":"playback");
					selectorid[u] = b[3];
					controls[u][Selector_control].readable = 1;
					controls[u][Selector_control].settable = 1;
					controls[u][Selector_control].chans = 0;
				}
			}
			break;
		case 0x06:	// feature
			if(verbose) fprint(2, "Audio Feature Unit %d", b[3]);
			dprint(2, "\tbUnitId %d, bSourceId %d, bControlSize %d\n",
				b[3], b[4], b[5]);
			u = findunit(b[4]);
			if(u &gt;= 0){
				if(verbose) fprint(2, " for %s\n", u?"Record":"Playback");
				units[u][nunits[u]++] = b[3];
				if(featureid[u] &gt;= 0)
					if(verbose)
						fprint(2, "Second feature unit (%d, %d)"
							" on %s\n", featureid[u], b[3],
							u?"record":"playback");
				featureid[u] = b[3];
			}else
				if(verbose) fprint(2, ", not known what for\n");
			p = b + 6;
			for(ctl = 1; ctl &lt; 0x0b; ctl++)
				if((1&lt;&lt;(ctl-1)) &amp; (b[6] | ((b[5]&gt;1)?(b[7]&lt;&lt;8):0))){
					if(verbose)
						fprint(2, "\t%s control on master channel\n",
							controls[0][ctl].name);
					if(u &gt;= 0){
						controls[u][ctl].readable = 1;
						controls[u][ctl].settable = 1;
						controls[u][ctl].chans = 0;
					}
				}
			p += (b[5]&gt;1)?2:1;
			for(ch = 0; ch &lt; (nb - 8)/b[5]; ch++){
				for(ctl = 1; ctl &lt; 0x0b; ctl++)
					if((1&lt;&lt;(ctl-1)) &amp; (p[0] | ((b[5]&gt;1)?(p[1]&lt;&lt;8):0))){
						if(verbose)
						  fprint(2, "\t%s control on channel %d\n",
							controls[0][ctl].name, ch+1);
						if(u &gt;= 0){
							controls[u][ctl].readable = 1;
							controls[u][ctl].settable = 1;
							controls[u][ctl].chans |= 1 &lt;&lt;(ch+1);
						}
					}
				p += (b[5]&gt;1)?2:1;
			}
			break;
		default:
			hd = hexstr(bb, nb);
			fprint(2, "audio control unknown: %s\n", hd);
			free(hd);
		}
		break;
	case 2: // stream
		switch (b[2]){
		case 0x01:
			dprint(2, "Audio stream for TerminalID %d, delay %d, format_tag %#ux\n",
				b[3], b[4], b[5] | (b[6]&lt;&lt;8));
			break;
		case 0x02:
			aa = (Audioalt *)dd-&gt;altc-&gt;aux;
			if(aa == nil){
				aa = mallocz(sizeof(Audioalt), 1);
				dd-&gt;altc-&gt;aux = aa;
			}
			if(verbose){
				if(b[4] &lt;= 2)
					fprint(2, "Interface %d: %s, %d bits, ",
						dd-&gt;iface-&gt;id, (b[4] == 1)?"mono":"stereo", b[6]);
				else
					fprint(2, "Interface %d, %d channels, %d bits, ",
						dd-&gt;iface-&gt;id, b[4], b[6]);
			}
			if(b[7] == 0){
				if(verbose)
					fprint(2, "frequency variable between %d and %d\n",
						b[8] | b[9]&lt;&lt;8 | b[10]&lt;&lt;16, b[11] | b[12]&lt;&lt;8 | b[13]&lt;&lt;16);
				aa-&gt;minfreq = b[8] | b[9]&lt;&lt;8 | b[10]&lt;&lt;16;
				aa-&gt;maxfreq = b[11] | b[12]&lt;&lt;8 | b[13]&lt;&lt;16;
				aa-&gt;caps |= has_contfreq;
			}else{
				if(verbose)
					fprint(2, "discrete frequencies are:");
				for(ch = 0; ch &lt; b[7] &amp;&amp; ch &lt; 8; ch++){
					aa-&gt;freqs[ch] = b[8+3*ch] | b[9+3*ch]&lt;&lt;8 | b[10+3*ch]&lt;&lt;16;
					if(verbose)
						fprint(2, " %d", b[8+3*ch] | b[9+3*ch]&lt;&lt;8 | b[10+3*ch]&lt;&lt;16);
				}
				if(ch &lt; 8)
					aa-&gt;freqs[ch] = -1;
				if(verbose)
					fprint(2, "\n");
				if(ch &gt; 1)
					aa-&gt;caps |= has_discfreq;	/* more than one frequency */
				else
					aa-&gt;caps |= onefreq;		/* only one frequency */
			}
			aa-&gt;nchan = b[4];
			aa-&gt;res = b[6];
			aa-&gt;subframesize = b[5];
			break;
		default:
			if(usbdebug){
				hd = hexstr(bb, nb);
				fprint(2, "audio stream unknown: %s\n", hd);
				free(hd);
			}
		}
		break;
	case 3: // midi
	default:
		if(usbdebug){
			hd = hexstr(bb, nb);
			fprint(2, "Unknown audio stream type: CS_INTERFACE: %s\n", hd);
			free(hd);
		}
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

