<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/ether/ether.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/ether/ether.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * usb/ether - usb ethernet adapter.
 * BUG: This should use /dev/etherfile to
 * use the kernel ether device code.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "usbfs.h"
#include "ether.h"

typedef struct Dirtab Dirtab;

enum
{
	/* Qids. Maintain order (relative to dirtabs structs) */
	Qroot	= 0,
	Qclone,
	Qaddr,
	Qifstats,
	Qstats,
	Qndir,
	Qndata,
	Qnctl,
	Qnifstats,
	Qnstats,
	Qntype,
	Qmax,
};

struct Dirtab
{
	char	*name;
	int	qid;
	int	mode;
};

typedef int (*Resetf)(Ether*);

/*
 * Controllers by vid/vid. Used to locate
 * specific adapters that do not implement cdc ethernet
 * Keep null terminated.
 */
Cinfo cinfo[] =
{
	/* Asix controllers.
	 * Only A88178 and A88772 are implemented.
	 * Others are easy to add by borrowing code
	 * from other systems.
	 */
	{0x0411, 0x003d, A8817x},	/* buffalo */
	{0x0411, 0x006e, A88178},
	{0x04f1, 0x3008, A8817x},
	{0x050d, 0x5055, A88178},
	{0x0557, 0x2009, A8817x},
	{0x05ac, 0x1402, A88772},	/* Apple */
	{0x077b, 0x2226, A8817x},
	{0x07aa, 0x0017, A8817x},
	{0x07d1, 0x3c05, A88772},
	{0x0b95, 0x1720, A8817x},	/* asix */
	{0x0b95, 0x1780, A88178},	/* Geoff */
	{0x0b95, 0x7720, A88772},
	{0x0b95, 0x772a, A88772},
	{0x0db0, 0xa877, A88772},
	{0x1189, 0x0893, A8817x},
	{0x13b1, 0x0018, A88772},
	{0x14ea, 0xab11, A88178},
	{0x1557, 0x7720, A88772},
	{0x1631, 0x6200, A8817x},
	{0x1737, 0x0039, A88178},
	{0x2001, 0x3c05, A88772},
	{0x6189, 0x182d, A8817x},

	/* SMSC controllers.
	 * LAN95xx family
	 */
	{0x0424, 0xec00, S95xx},	/* LAN9512 (as in raspberry pi) */
	{0x0424, 0x9500, S95xx},
	{0x0424, 0x9505, S95xx},
	{0x0424, 0x9E00, S95xx},
	{0x0424, 0x9E01, S95xx},
	{0, 0, 0},
};

/*
 * Each etherU%d is the root of our file system,
 * which is added to the usb root directory. We only
 * have to concern ourselfs with each /etherU%d subtree.
 *
 * NB: Maintain order in dirtabs, relative to the Qids enum.
 */

static Dirtab rootdirtab[] =
{
	"/",		Qroot,		DMDIR|0555,	/* etherU%d */
	"clone",	Qclone,		0666,
	"addr",		Qaddr,		0444,
	"ifstats",	Qifstats,	0444,
	"stats",	Qstats,		0444,
	/* one dir per connection here */
	nil, 0, 0,
};

static Dirtab conndirtab[] =
{
	"%d",		Qndir,		DMDIR|0555,
	"data",		Qndata,		0666,
	"ctl",		Qnctl,		0666,
	"ifstats",	Qnifstats,	0444,
	"stats",	Qnstats,	0444,
	"type",		Qntype,		0444,
	nil, 0,
};

int etherdebug;

Resetf ethers[] =
{
	asixreset,
	smscreset,
	cdcreset,	/* keep last */
};

static int
qtype(vlong q)
{
	return q&amp;0xFF;
}

static int
qnum(vlong q)
{
	return (q &gt;&gt; 8) &amp; 0xFFFFFF;
}

static uvlong
mkqid(int n, int t)
{
	uvlong q;

	q = (n&amp;0xFFFFFF) &lt;&lt; 8 | t&amp;0xFF;
	return q;
}

static void
freebuf(Ether *e, Buf *bp)
{
	if(0)deprint(2, "%s: freebuf %#p\n", argv0, bp);
	if(bp != nil){
		qlock(e);
		e-&gt;nbufs--;
		qunlock(e);
		sendp(e-&gt;bc, bp);
	}
}

static Buf*
allocbuf(Ether *e)
{
	Buf *bp;

	bp = nbrecvp(e-&gt;bc);
	if(bp == nil){
		qlock(e);
		if(e-&gt;nabufs &lt; Nbufs){
			bp = emallocz(sizeof(Buf), 1);
			e-&gt;nabufs++;
			setmalloctag(bp, getcallerpc(&amp;e));
			deprint(2, "%s: %d buffers\n", argv0, e-&gt;nabufs);
		}
		qunlock(e);
	}
	if(bp == nil){
		deprint(2, "%s: blocked waiting for allocbuf\n", argv0);
		bp = recvp(e-&gt;bc);
	}
	bp-&gt;rp = bp-&gt;data + Hdrsize;
	bp-&gt;ndata = 0;
	if(0)deprint(2, "%s: allocbuf %#p\n", argv0, bp);
	qlock(e);
	e-&gt;nbufs++;
	qunlock(e);
	return bp;
}

static Conn*
newconn(Ether *e)
{
	int i;
	Conn *c;

	qlock(e);
	for(i = 0; i &lt; nelem(e-&gt;conns); i++){
		c = e-&gt;conns[i];
		if(c == nil || c-&gt;ref == 0){
			if(c == nil){
				c = emallocz(sizeof(Conn), 1);
				c-&gt;rc = chancreate(sizeof(Buf*), 16);
				c-&gt;nb = i;
			}
			c-&gt;ref = 1;
			if(i == e-&gt;nconns)
				e-&gt;nconns++;
			e-&gt;conns[i] = c;
			deprint(2, "%s: newconn %d\n", argv0, i);
			qunlock(e);
			return c;
		}
	}
	qunlock(e);
	return nil;
}

static char*
seprintaddr(char *s, char *se, uchar *addr)
{
	int i;

	for(i = 0; i &lt; Eaddrlen; i++)
		s = seprint(s, se, "%02x", addr[i]);
	return s;
}

void
dumpframe(char *tag, void *p, int n)
{
	Etherpkt *ep;
	char buf[128];
	char *s, *se;
	int i;

	ep = p;
	if(n &lt; Eaddrlen * 2 + 2){
		fprint(2, "short packet (%d bytes)\n", n);
		return;
	}
	se = buf+sizeof(buf);
	s = seprint(buf, se, "%s [%d]: ", tag, n);
	s = seprintaddr(s, se, ep-&gt;s);
	s = seprint(s, se, " -&gt; ");
	s = seprintaddr(s, se, ep-&gt;d);
	s = seprint(s, se, " type 0x%02ux%02ux ", ep-&gt;type[0], ep-&gt;type[1]);
	n -= Eaddrlen * 2 + 2;
	for(i = 0; i &lt; n &amp;&amp; i &lt; 16; i++)
		s = seprint(s, se, "%02x", ep-&gt;data[i]);
	if(n &gt;= 16)
		fprint(2, "%s...\n", buf);
	else
		fprint(2, "%s\n", buf);
}

static char*
seprintstats(char *s, char *se, Ether *e)
{
	qlock(e);
	s = seprint(s, se, "in: %ld\n", e-&gt;nin);
	s = seprint(s, se, "out: %ld\n", e-&gt;nout);
	s = seprint(s, se, "input errs: %ld\n", e-&gt;nierrs);
	s = seprint(s, se, "output errs: %ld\n", e-&gt;noerrs);
	s = seprint(s, se, "mbps: %d\n", e-&gt;mbps);
	s = seprint(s, se, "prom: %ld\n", e-&gt;prom.ref);
	s = seprint(s, se, "addr: ");
	s = seprintaddr(s, se, e-&gt;addr);
	s = seprint(s, se, "\n");
	qunlock(e);
	return s;
}

static char*
seprintifstats(char *s, char *se, Ether *e)
{
	int i;
	Conn *c;

	qlock(e);
	s = seprint(s, se, "ctlr id: %#x\n", e-&gt;cid);
	s = seprint(s, se, "phy: %#x\n", e-&gt;phy);
	s = seprint(s, se, "exiting: %s\n", e-&gt;exiting ? "y" : "n");
	s = seprint(s, se, "conns: %d\n", e-&gt;nconns);
	s = seprint(s, se, "allocated bufs: %d\n", e-&gt;nabufs);
	s = seprint(s, se, "used bufs: %d\n", e-&gt;nbufs);
	for(i = 0; i &lt; nelem(e-&gt;conns); i++){
		c = e-&gt;conns[i];
		if(c == nil)
			continue;
		if(c-&gt;ref == 0)
			s = seprint(s, se, "c[%d]: free\n", i);
		else{
			s = seprint(s, se, "c[%d]: refs %ld t %#x h %d p %d\n",
				c-&gt;nb, c-&gt;ref, c-&gt;type, c-&gt;headersonly, c-&gt;prom);
		}
	}
	qunlock(e);
	return s;
}

static void
etherdump(Ether *e)
{
	char buf[256];

	if(etherdebug == 0)
		return;
	seprintifstats(buf, buf+sizeof(buf), e);
	fprint(2, "%s: ether %#p:\n%s\n", argv0, e, buf);
}

static Conn*
getconn(Ether *e, int i, int idleok)
{
	Conn *c;

	qlock(e);
	if(i &lt; 0 || i &gt;= e-&gt;nconns)
		c = nil;
	else{
		c = e-&gt;conns[i];
		if(idleok == 0 &amp;&amp; c != nil &amp;&amp; c-&gt;ref == 0)
			c = nil;
	}
	qunlock(e);
	return c;
}

static void
filldir(Usbfs *fs, Dir *d, Dirtab *tab, int cn)
{
	d-&gt;qid.path = mkqid(cn, tab-&gt;qid);
	d-&gt;qid.path |= fs-&gt;qid;
	d-&gt;mode = tab-&gt;mode;
	if((d-&gt;mode &amp; DMDIR) != 0)
		d-&gt;qid.type = QTDIR;
	else
		d-&gt;qid.type = QTFILE;
	if(tab-&gt;qid == Qndir)
		snprint(d-&gt;name, Namesz, "%d", cn);
	else
		d-&gt;name = tab-&gt;name;
}

static int
rootdirgen(Usbfs *fs, Qid, int i, Dir *d, void *)
{
	Ether *e;
	Dirtab *tab;
	int cn;

	e = fs-&gt;aux;
	i++;				/* skip root */
	cn = 0;
	if(i &lt; nelem(rootdirtab) - 1)	/* null terminated */
		tab = &amp;rootdirtab[i];
	else{
		cn = i - nelem(rootdirtab) + 1;
		if(cn &lt; e-&gt;nconns)
			tab = &amp;conndirtab[0];
		else
			return -1;
	}
	filldir(fs, d, tab, cn);
	return 0;
}

static int
conndirgen(Usbfs *fs, Qid q, int i, Dir *d, void *)
{
	Dirtab *tab;

	i++;				/* skip root */
	if(i &lt; nelem(conndirtab) - 1)	/* null terminated */
		tab = &amp;conndirtab[i];
	else
		return -1;
	filldir(fs, d, tab, qnum(q.path));
	return 0;
}

static int
fswalk(Usbfs *fs, Fid *fid, char *name)
{
	int cn, i;
	char *es;
	Dirtab *tab;
	Ether *e;
	Qid qid;

	e = fs-&gt;aux;
	qid = fid-&gt;qid;
	qid.path &amp;= ~fs-&gt;qid;
	if((qid.type &amp; QTDIR) == 0){
		werrstr("walk in non-directory");
		return -1;
	}

	if(strcmp(name, "..") == 0){
		/* must be /etherU%d; i.e. our root dir. */
		fid-&gt;qid.path = mkqid(0, Qroot) | fs-&gt;qid;
		fid-&gt;qid.vers = 0;
		fid-&gt;qid.type = QTDIR;
		return 0;
	}
	switch(qtype(qid.path)){
	case Qroot:
		if(name[0] &gt;= '0' &amp;&amp; name[0] &lt;= '9'){
			es = name;
			cn = strtoul(name, &amp;es, 10);
			if(cn &gt;= e-&gt;nconns || *es != 0){
				werrstr(Enotfound);
				return -1;
			}
			fid-&gt;qid.path = mkqid(cn, Qndir) | fs-&gt;qid;
			fid-&gt;qid.vers = 0;
			return 0;
		}
		/* fall */
	case Qndir:
		if(qtype(qid.path) == Qroot)
			tab = rootdirtab;
		else
			tab = conndirtab;
		cn = qnum(qid.path);
		for(i = 0; tab[i].name != nil; tab++)
			if(strcmp(tab[i].name, name) == 0){
				fid-&gt;qid.path = mkqid(cn, tab[i].qid)|fs-&gt;qid;
				fid-&gt;qid.vers = 0;
				if((tab[i].mode &amp; DMDIR) != 0)
					fid-&gt;qid.type = QTDIR;
				else
					fid-&gt;qid.type = QTFILE;
				return 0;
			}
		break;
	default:
		sysfatal("usb: ether: fswalk bug");
	}
	return -1;
}

static Dirtab*
qdirtab(vlong q)
{
	int i, qt;
	Dirtab *tab;

	qt = qtype(q);
	if(qt &lt; nelem(rootdirtab) - 1){	/* null terminated */
		tab = rootdirtab;
		i = qt;
	}else{
		tab = conndirtab;
		i = qt - (nelem(rootdirtab) - 1);
		assert(i &lt; nelem(conndirtab) - 1);
	}
	return &amp;tab[i];
}

static int
fsstat(Usbfs *fs, Qid qid, Dir *d)
{
	filldir(fs, d, qdirtab(qid.path), qnum(qid.path));
	return 0;
}

static int
fsopen(Usbfs *fs, Fid *fid, int omode)
{
	int qt;
	vlong qid;
	Conn *c;
	Dirtab *tab;
	Ether *e;

	qid = fid-&gt;qid.path &amp; ~fs-&gt;qid;
	e = fs-&gt;aux;
	qt = qtype(qid);
	tab = qdirtab(qid);
	omode &amp;= 3;
	if(omode != OREAD &amp;&amp; (tab-&gt;mode&amp;0222) == 0){
		werrstr(Eperm);
		return -1;
	}
	switch(qt){
	case Qclone:
		c = newconn(e);
		if(c == nil){
			werrstr("no more connections");
			return -1;
		}
		fid-&gt;qid.type = QTFILE;
		fid-&gt;qid.path = mkqid(c-&gt;nb, Qnctl)|fs-&gt;qid;
		fid-&gt;qid.vers = 0;
		break;
	case Qndata:
	case Qnctl:
	case Qnifstats:
	case Qnstats:
	case Qntype:
		c = getconn(e, qnum(qid), 1);
		if(c == nil)
			sysfatal("usb: ether: fsopen bug");
		incref(c);
		break;
	}
	etherdump(e);
	return 0;
}

static int
prom(Ether *e, int set)
{
	if(e-&gt;promiscuous != nil)
		return e-&gt;promiscuous(e, set);
	return 0;
}

static void
fsclunk(Usbfs *fs, Fid *fid)
{
	int qt;
	vlong qid;
	Buf *bp;
	Conn *c;
	Ether *e;

	e = fs-&gt;aux;
	qid = fid-&gt;qid.path &amp; ~fs-&gt;qid;
	qt = qtype(qid);
	switch(qt){
	case Qndata:
	case Qnctl:
	case Qnifstats:
	case Qnstats:
	case Qntype:
		if(fid-&gt;omode != ONONE){
			c = getconn(e, qnum(qid), 0);
			if(c == nil)
				sysfatal("usb: ether: fsopen bug");
			if(decref(c) == 0){
				while((bp = nbrecvp(c-&gt;rc)) != nil)
					freebuf(e, bp);
				qlock(e);
				if(c-&gt;prom != 0)
					if(decref(&amp;e-&gt;prom) == 0)
						prom(e, 0);
				c-&gt;prom = c-&gt;type = 0;
				qunlock(e);
			}
		}
		break;
	}
	etherdump(e);
}

int
parseaddr(uchar *m, char *s)
{
	int i, n;
	uchar v;

	if(strlen(s) &lt; 12)
		return -1;
	if(strlen(s) &gt; 12 &amp;&amp; strlen(s) &lt; 17)
		return -1;
	for(i = n = 0; i &lt; strlen(s); i++){
		if(s[i] == ':')
			continue;
		if(s[i] &gt;= 'A' &amp;&amp; s[i] &lt;= 'F')
			v = 10 + s[i] - 'A';
		else if(s[i] &gt;= 'a' &amp;&amp; s[i] &lt;= 'f')
			v = 10 + s[i] - 'a';
		else if(s[i] &gt;= '0' &amp;&amp; s[i] &lt;= '9')
			v = s[i] - '0';
		else
			return -1;
		if(n&amp;1)
			m[n/2] |= v;
		else
			m[n/2] = v&lt;&lt;4;
		n++;
	}
	return 0;
}

static long
fsread(Usbfs *fs, Fid *fid, void *data, long count, vlong offset)
{
	int cn, qt;
	char *s, *se;
	char buf[2048];		/* keep this large for ifstats */
	Buf *bp;
	Conn *c;
	Ether *e;
	Qid q;

	q = fid-&gt;qid;
	q.path &amp;= ~fs-&gt;qid;
	e = fs-&gt;aux;
	s = buf;
	se = buf+sizeof(buf);
	qt = qtype(q.path);
	cn = qnum(q.path);
	switch(qt){
	case Qroot:
		count = usbdirread(fs, q, data, count, offset, rootdirgen, nil);
		break;
	case Qaddr:
		s = seprintaddr(s, se, e-&gt;addr);
		count = usbreadbuf(data, count, offset, buf, s - buf);
		break;
	case Qnifstats:
		/* BUG */
	case Qifstats:
		s = seprintifstats(s, se, e);
		if(e-&gt;seprintstats != nil)
			s = e-&gt;seprintstats(s, se, e);
		count = usbreadbuf(data, count, offset, buf, s - buf);
		break;
	case Qnstats:
		/* BUG */
	case Qstats:
		s = seprintstats(s, se, e);
		count = usbreadbuf(data, count, offset, buf, s - buf);
		break;

	case Qndir:
		count = usbdirread(fs, q, data, count, offset, conndirgen, nil);
		break;
	case Qndata:
		c = getconn(e, cn, 0);
		if(c == nil){
			werrstr(Eio);
			return -1;
		}
		bp = recvp(c-&gt;rc);
		if(bp == nil)
			return -1;
		if(etherdebug &gt; 1)
			dumpframe("etherin", bp-&gt;rp, bp-&gt;ndata);
		count = usbreadbuf(data, count, 0LL, bp-&gt;rp, bp-&gt;ndata);
		freebuf(e, bp);
		break;
	case Qnctl:
		s = seprint(s, se, "%11d ", cn);
		count = usbreadbuf(data, count, offset, buf, s - buf);
		break;
	case Qntype:
		c = getconn(e, cn, 0);
		if(c == nil)
			s = seprint(s, se, "%11d ", 0);
		else
			s = seprint(s, se, "%11d ", c-&gt;type);
		count = usbreadbuf(data, count, offset, buf, s - buf);
		break;
	default:
		sysfatal("usb: ether: fsread bug");
	}
	return count;
}

static int
typeinuse(Ether *e, int t)
{
	int i;

	for(i = 0; i &lt; e-&gt;nconns; i++)
		if(e-&gt;conns[i]-&gt;ref &gt; 0 &amp;&amp; e-&gt;conns[i]-&gt;type == t)
			return 1;
	return 0;
}

static int
isloopback(Ether *e, Buf *)
{
	return e-&gt;prom.ref &gt; 0; /* BUG: also loopbacks and broadcasts */
}

static int
etherctl(Ether *e, Conn *c, char *buf)
{
	uchar addr[Eaddrlen];
	int t;

	deprint(2, "%s: etherctl: %s\n", argv0, buf);
	if(strncmp(buf, "connect ", 8) == 0){
		t = atoi(buf+8);
		qlock(e);
		if(typeinuse(e, t)){
			werrstr("type already in use");
			qunlock(e);
			return -1;
		}
		c-&gt;type = atoi(buf+8);
		qunlock(e);
		return 0;
	}
	if(strncmp(buf, "nonblocking", 11) == 0){
		if(buf[11] == '\n' || buf[11] == 0)
			e-&gt;nblock = 1;
		else
			e-&gt;nblock = atoi(buf + 12);
		deprint(2, "%s: nblock %d\n", argv0, e-&gt;nblock);
		return 0;
	}
	if(strncmp(buf, "promiscuous", 11) == 0){
		if(c-&gt;prom == 0)
			incref(&amp;e-&gt;prom);
		c-&gt;prom = 1;
		return prom(e, 1);
	}
	if(strncmp(buf, "headersonly", 11) == 0){
		c-&gt;headersonly = 1;
		return 0;
	}
	if(strncmp(buf, "addmulti ", 9) == 0 || strncmp(buf, "remmulti ", 9) == 0){
		if(parseaddr(addr, buf+9) &lt; 0){
			werrstr("bad address");
			return -1;
		}
		if(e-&gt;multicast == nil)
			return 0;
		if(strncmp(buf, "add", 3) == 0){
			e-&gt;nmcasts++;
			return e-&gt;multicast(e, addr, 1);
		}else{
			e-&gt;nmcasts--;
			return e-&gt;multicast(e, addr, 0);
		}
	}

	if(e-&gt;ctl != nil)
		return e-&gt;ctl(e, buf);
	werrstr(Ebadctl);
	return -1;
}

static long
etherbread(Ether *e, Buf *bp)
{
	deprint(2, "%s: etherbread\n", argv0);
	bp-&gt;rp = bp-&gt;data + Hdrsize;
	bp-&gt;ndata = -1;
	bp-&gt;ndata = read(e-&gt;epin-&gt;dfd, bp-&gt;rp, sizeof(bp-&gt;data)-Hdrsize);
	if(bp-&gt;ndata &lt; 0){
		deprint(2, "%s: etherbread: %r\n", argv0);	/* keep { and }  */
	}else
		deprint(2, "%s: etherbread: got %d bytes\n", argv0, bp-&gt;ndata);
	return bp-&gt;ndata;
}

static long
etherbwrite(Ether *e, Buf *bp)
{
	long n;

	deprint(2, "%s: etherbwrite %d bytes\n", argv0, bp-&gt;ndata);
	n = write(e-&gt;epout-&gt;dfd, bp-&gt;rp, bp-&gt;ndata);
	if(n &lt; 0){
		deprint(2, "%s: etherbwrite: %r\n", argv0);	/* keep { and }  */
	}else
		deprint(2, "%s: etherbwrite wrote %ld bytes\n", argv0, n);
	if(n &lt;= 0)
		return n;
	if((bp-&gt;ndata % e-&gt;epout-&gt;maxpkt) == 0){
		deprint(2, "%s: short pkt write\n", argv0);
		write(e-&gt;epout-&gt;dfd, "", 1);
	}
	return n;
}

static long
fswrite(Usbfs *fs, Fid *fid, void *data, long count, vlong)
{
	int cn, qt;
	char buf[128];
	Buf *bp;
	Conn *c;
	Ether *e;
	Qid q;

	q = fid-&gt;qid;
	q.path &amp;= ~fs-&gt;qid;
	e = fs-&gt;aux;
	qt = qtype(q.path);
	cn = qnum(q.path);
	switch(qt){
	case Qndata:
		c = getconn(e, cn, 0);
		if(c == nil){
			werrstr(Eio);
			return -1;
		}
		bp = allocbuf(e);
		if(count &gt; sizeof(bp-&gt;data)-Hdrsize)
			count = sizeof(bp-&gt;data)-Hdrsize;
		memmove(bp-&gt;rp, data, count);
		bp-&gt;ndata = count;
		if(etherdebug &gt; 1)
			dumpframe("etherout", bp-&gt;rp, bp-&gt;ndata);
		if(e-&gt;nblock == 0)
			sendp(e-&gt;wc, bp);
		else if(nbsendp(e-&gt;wc, bp) == 0){
			deprint(2, "%s: (out) packet lost\n", argv0);
			e-&gt;noerrs++;
			freebuf(e, bp);
		}
		break;
	case Qnctl:
		c = getconn(e, cn, 0);
		if(c == nil){
			werrstr(Eio);
			return -1;
		}
		if(count &gt; sizeof(buf) - 1)
			count = sizeof(buf) - 1;
		memmove(buf, data, count);
		buf[count] = 0;
		if(etherctl(e, c, buf) &lt; 0)
			return -1;
		break;
	default:
		sysfatal("usb: ether: fsread bug");
	}
	return count;
}

static int
openeps(Ether *e, int epin, int epout)
{
	e-&gt;epin = openep(e-&gt;dev, epin);
	if(e-&gt;epin == nil){
		fprint(2, "ether: in: openep %d: %r\n", epin);
		return -1;
	}
	if(epout == epin){
		incref(e-&gt;epin);
		e-&gt;epout = e-&gt;epin;
	}else
		e-&gt;epout = openep(e-&gt;dev, epout);
	if(e-&gt;epout == nil){
		fprint(2, "ether: out: openep %d: %r\n", epout);
		closedev(e-&gt;epin);
		return -1;
	}
	if(e-&gt;epin == e-&gt;epout)
		opendevdata(e-&gt;epin, ORDWR);
	else{
		opendevdata(e-&gt;epin, OREAD);
		opendevdata(e-&gt;epout, OWRITE);
	}
	if(e-&gt;epin-&gt;dfd &lt; 0 || e-&gt;epout-&gt;dfd &lt; 0){
		fprint(2, "ether: open i/o ep data: %r\n");
		closedev(e-&gt;epin);
		closedev(e-&gt;epout);
		return -1;
	}
	dprint(2, "ether: ep in %s maxpkt %d; ep out %s maxpkt %d\n",
		e-&gt;epin-&gt;dir, e-&gt;epin-&gt;maxpkt, e-&gt;epout-&gt;dir, e-&gt;epout-&gt;maxpkt);

	/* time outs are not activated for I/O endpoints */

	if(usbdebug &gt; 2 || etherdebug &gt; 2){
		devctl(e-&gt;epin, "debug 1");
		devctl(e-&gt;epout, "debug 1");
		devctl(e-&gt;dev, "debug 1");
	}

	return 0;
}

static int
usage(void)
{
	werrstr("usage: usb/ether [-a addr] [-d] [-N nb]");
	return -1;
}

static Usbfs etherfs = {
	.walk = fswalk,
	.open =	 fsopen,
	.read =	 fsread,
	.write = fswrite,
	.stat =	 fsstat,
	.clunk = fsclunk,
};

static void
shutdownchan(Channel *c)
{
	Buf *bp;

	while((bp=nbrecvp(c)) != nil)
		free(bp);
	chanfree(c);
}

static void
etherfree(Ether *e)
{
	int i;
	Buf *bp;

	if(e-&gt;free != nil)
		e-&gt;free(e);
	closedev(e-&gt;epin);
	closedev(e-&gt;epout);
	if(e-&gt;rc == nil){	/* not really started */
		free(e);
		return;
	}
	for(i = 0; i &lt; e-&gt;nconns; i++)
		if(e-&gt;conns[i] != nil){
			while((bp = nbrecvp(e-&gt;conns[i]-&gt;rc)) != nil)
				free(bp);
			chanfree(e-&gt;conns[i]-&gt;rc);
			free(e-&gt;conns[i]);
		}
	shutdownchan(e-&gt;bc);
	shutdownchan(e-&gt;rc);
	shutdownchan(e-&gt;wc);
	e-&gt;epin = e-&gt;epout = nil;
	devctl(e-&gt;dev, "detach");
	free(e);
}

static void
etherdevfree(void *a)
{
	Ether *e = a;

	if(e != nil)
		etherfree(e);
}

/* must return 1 if c wants bp; 0 if not */
static int
cwantsbp(Conn *c, Buf *bp)
{
	if(c-&gt;ref != 0 &amp;&amp; (c-&gt;prom != 0 || c-&gt;type &lt; 0 || c-&gt;type == bp-&gt;type))
		return 1;
	return 0;
}

static void
etherwriteproc(void *a)
{
	Ether *e = a;
	Buf *bp;
	Channel *wc;

	threadsetname("etherwrite");
	wc = e-&gt;wc;
	while(e-&gt;exiting == 0){
		bp = recvp(wc);
		if(bp == nil || e-&gt;exiting != 0){
			free(bp);
			break;
		}
		e-&gt;nout++;
		if(e-&gt;bwrite(e, bp) &lt; 0)
			e-&gt;noerrs++;
		if(isloopback(e, bp) &amp;&amp; e-&gt;exiting == 0)
			sendp(e-&gt;rc, bp); /* send to input queue */
		else
			freebuf(e, bp);
	}
	deprint(2, "%s: writeproc exiting\n", argv0);
	closedev(e-&gt;dev);
}

static void
setbuftype(Buf *bp)
{
	uchar *p;

	bp-&gt;type = 0;
	if(bp-&gt;ndata &gt;= Ehdrsize){
		p = bp-&gt;rp + Eaddrlen*2;
		bp-&gt;type = p[0]&lt;&lt;8 | p[1];
	}
}

static void
etherexiting(Ether *e)
{
	devctl(e-&gt;dev, "detach");
	e-&gt;exiting = 1;
	close(e-&gt;epin-&gt;dfd);
	e-&gt;epin-&gt;dfd = -1;
	close(e-&gt;epout-&gt;dfd);
	e-&gt;epout-&gt;dfd = -1;
	nbsend(e-&gt;wc, nil);
}

static void
etherreadproc(void *a)
{
	int i, n, nwants;
	Buf *bp, *dbp;
	Ether *e = a;

	threadsetname("etherread");
	while(e-&gt;exiting == 0){
		bp = nbrecvp(e-&gt;rc);
		if(bp == nil){
			bp = allocbuf(e);	/* leak() may think we leak */
			if(e-&gt;bread(e, bp) &lt; 0){
				freebuf(e, bp);
				break;
			}
			if(bp-&gt;ndata == 0){
				/* may be a short packet; continue */
				if(0)dprint(2, "%s: read: short\n", argv0);
				freebuf(e, bp);
				continue;
			}else
				setbuftype(bp);
		}
		e-&gt;nin++;
		nwants = 0;
		for(i = 0; i &lt; e-&gt;nconns; i++)
			nwants += cwantsbp(e-&gt;conns[i], bp);
		for(i = 0; nwants &gt; 0 &amp;&amp; i &lt; e-&gt;nconns; i++)
			if(cwantsbp(e-&gt;conns[i], bp)){
				n = bp-&gt;ndata;
				if(e-&gt;conns[i]-&gt;type == -2 &amp;&amp; n &gt; 64)
					n = 64;
				if(nwants-- == 1){
					bp-&gt;ndata = n;
					dbp = bp;
					bp = nil;
				}else{
					dbp = allocbuf(e);
					memmove(dbp-&gt;rp, bp-&gt;rp, n);
					dbp-&gt;ndata = n;
					dbp-&gt;type = bp-&gt;type;
				}
				if(nbsendp(e-&gt;conns[i]-&gt;rc, dbp) == 0){
					deprint(2, "%s: (in) packet lost\n", argv0);
					e-&gt;nierrs++;
					freebuf(e, dbp);
				}
			}
		freebuf(e, bp);
	}
	deprint(2, "%s: writeproc exiting\n", argv0);
	etherexiting(e);
	closedev(e-&gt;dev);
	usbfsdel(&amp;e-&gt;fs);
}

static void
setalt(Dev *d, int ifcid, int altid)
{
	if(usbcmd(d, Rh2d|Rstd|Riface, Rsetiface, altid, ifcid, nil, 0) &lt; 0)
		dprint(2, "%s: setalt ifc %d alt %d: %r\n", argv0, ifcid, altid);
}

static int
ifaceinit(Ether *e, Iface *ifc, int *ei, int *eo)
{
	Ep *ep;
	int epin, epout, i;

	if(ifc == nil)
		return -1;

	epin = epout = -1;
	for(i = 0; (epin &lt; 0 || epout &lt; 0) &amp;&amp; i &lt; nelem(ifc-&gt;ep); i++)
		if((ep = ifc-&gt;ep[i]) != nil &amp;&amp; ep-&gt;type == Ebulk){
			if(ep-&gt;dir == Eboth || ep-&gt;dir == Ein)
				if(epin == -1)
					epin =  ep-&gt;id;
			if(ep-&gt;dir == Eboth || ep-&gt;dir == Eout)
				if(epout == -1)
					epout = ep-&gt;id;
		}
	if(epin == -1 || epout == -1)
		return -1;

	dprint(2, "ether: ep ids: in %d out %d\n", epin, epout);
	for(i = 0; i &lt; nelem(ifc-&gt;altc); i++)
		if(ifc-&gt;altc[i] != nil)
			setalt(e-&gt;dev, ifc-&gt;id, i);

	*ei = epin;
	*eo = epout;
	return 0;
}

static int
etherinit(Ether *e, int *ei, int *eo)
{
	int ctlid, datid, i, j;
	Conf *c;
	Desc *desc;
	Iface *ctlif, *datif;
	Usbdev *ud;

	*ei = *eo = -1;
	ud = e-&gt;dev-&gt;usb;

	/* look for union descriptor with ethernet ctrl interface */
	for(i = 0; i &lt; nelem(ud-&gt;ddesc); i++){
		if((desc = ud-&gt;ddesc[i]) == nil)
			continue;
		if(desc-&gt;data.bLength &lt; 5 || desc-&gt;data.bbytes[0] != Cdcunion)
			continue;

		ctlid = desc-&gt;data.bbytes[1];
		datid = desc-&gt;data.bbytes[2];

		if((c = desc-&gt;conf) == nil)
			continue;

		ctlif = datif = nil;
		for(j = 0; j &lt; nelem(c-&gt;iface); j++){
			if(c-&gt;iface[j] == nil)
				continue;
			if(c-&gt;iface[j]-&gt;id == ctlid)
				ctlif = c-&gt;iface[j];
			if(c-&gt;iface[j]-&gt;id == datid)
				datif = c-&gt;iface[j];

			if(datif != nil &amp;&amp; ctlif != nil){
				if(Subclass(ctlif-&gt;csp) == Scether &amp;&amp;
				    ifaceinit(e, datif, ei, eo) != -1)
					return 0;
				break;
			}
		}
	}
	/* try any other one that seems to be ok */
	for(i = 0; i &lt; nelem(ud-&gt;conf); i++)
		if((c = ud-&gt;conf[i]) != nil)
			for(j = 0; j &lt; nelem(c-&gt;iface); j++)
				if(ifaceinit(e, c-&gt;iface[j], ei, eo) != -1)
					return 0;
	dprint(2, "%s: no valid endpoints", argv0);
	return -1;
}

static int
kernelproxy(Ether *e)
{
	int ctlfd, n;
	char eaddr[13];

	ctlfd = open("#l0/ether0/clone", ORDWR);
	if(ctlfd &lt; 0){
		deprint(2, "%s: etherusb bind #l0: %r\n", argv0);
		return -1;
	}
	close(e-&gt;epin-&gt;dfd);
	close(e-&gt;epout-&gt;dfd);
	seprintaddr(eaddr, eaddr+sizeof(eaddr), e-&gt;addr);
	n = fprint(ctlfd, "bind %s #u/usb/ep%d.%d/data #u/usb/ep%d.%d/data %s %d %d",
		e-&gt;name, e-&gt;dev-&gt;id, e-&gt;epin-&gt;id, e-&gt;dev-&gt;id, e-&gt;epout-&gt;id,
		eaddr, e-&gt;bufsize, e-&gt;epout-&gt;maxpkt);
	if(n &lt; 0){
		deprint(2, "%s: etherusb bind #l0: %r\n", argv0);
		opendevdata(e-&gt;epin, OREAD);
		opendevdata(e-&gt;epout, OWRITE);
		close(ctlfd);
		return -1;
	}
	close(ctlfd);
	return 0;
}

int
ethermain(Dev *dev, int argc, char **argv)
{
	int epin, epout, i, devid;
	Ether *e;
	uchar ea[Eaddrlen];

	devid = dev-&gt;id;
	memset(ea, 0, Eaddrlen);
	ARGBEGIN{
	case 'a':
		if(parseaddr(ea, EARGF(usage())) &lt; 0)
			return usage();
		break;
	case 'd':
		if(etherdebug == 0)
			fprint(2, "ether debug on\n");
		etherdebug++;
		break;
	case 'N':
		devid = atoi(EARGF(usage()));
		break;
	default:
		return usage();
	}ARGEND
	if(argc != 0) {
		return usage();
	}
	e = dev-&gt;aux = emallocz(sizeof(Ether), 1);
	e-&gt;dev = dev;
	dev-&gt;free = etherdevfree;
	memmove(e-&gt;addr, ea, Eaddrlen);
	e-&gt;name = "cdc";

	for(i = 0; i &lt; nelem(ethers); i++)
		if(ethers[i](e) == 0)
			break;
	if(i == nelem(ethers))
		return -1;
	if(e-&gt;init == nil)
		e-&gt;init = etherinit;
	if(e-&gt;init(e, &amp;epin, &amp;epout) &lt; 0)
		return -1;
	if(e-&gt;bwrite == nil)
		e-&gt;bwrite = etherbwrite;
	if(e-&gt;bread == nil)
		e-&gt;bread = etherbread;
	if(e-&gt;bufsize == 0)
		e-&gt;bufsize = Maxpkt;

	if(openeps(e, epin, epout) &lt; 0)
		return -1;
	if(kernelproxy(e) == 0)
		return 0;
	e-&gt;fs = etherfs;
	snprint(e-&gt;fs.name, sizeof(e-&gt;fs.name), "etherU%d", devid);
	e-&gt;fs.dev = dev;
	e-&gt;fs.aux = e;
	e-&gt;bc = chancreate(sizeof(Buf*), Nbufs);
	e-&gt;rc = chancreate(sizeof(Buf*), Nconns/2);
	e-&gt;wc = chancreate(sizeof(Buf*), Nconns*2);
	incref(e-&gt;dev);
	proccreate(etherwriteproc, e, 16*1024);
	incref(e-&gt;dev);
	proccreate(etherreadproc, e, 16*1024);
	deprint(2, "%s: dev ref %ld\n", argv0, dev-&gt;ref);
	incref(e-&gt;dev);
	usbfsadd(&amp;e-&gt;fs);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

