<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/kb/hid.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/kb/hid.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "hid.h"

/*
 * Rough hid descriptor parsing and interpretation for mice
 *
 * Chain and its operations build the infrastructure needed
 * to manipulate non-aligned fields, which do appear (sigh!).
 */

/* Get, at most, 8 bits*/
static uchar
get8bits(Chain *ch, int nbits)
{
	int b, nbyb, nbib, nlb;
	uchar low, high;

	b = ch-&gt;b + nbits - 1;
	nbib = ch-&gt;b % 8;
	nbyb = ch-&gt;b / 8;
	nlb = 8 - nbib;
	if(nlb &gt; nbits)
		nlb = nbits;

	low = MSK(nlb) &amp; (ch-&gt;buf[nbyb] &gt;&gt; nbib);
	if(IsCut(ch-&gt;b, b))
		high = (ch-&gt;buf[nbyb + 1] &amp; MSK(nbib)) &lt;&lt; nlb;
	else
		high = 0;
	ch-&gt;b += nbits;
	return MSK(nbits)&amp;(high | low);
}

static void
getbits(void *p, Chain *ch, int nbits)
{
	int nby, nbi, i;
	uchar *vp;

	assert(ch-&gt;e &gt;= ch-&gt;b);
	nby = nbits / 8;
	nbi = nbits % 8;

	vp = p;
	for(i = 0; i &lt; nby; i++)
		*vp++ = get8bits(ch, 8);

	if(nbi != 0)
		*vp = get8bits(ch, nbi);
}

int
parsereportdesc(HidRepTempl *temp, uchar *repdesc, int repsz)
{
	int i, j, l, n, isptr, hasxy, hasbut, nk, ncoll, dsize;
	uchar ks[MaxVals+1];
	HidInterface *ifs;

	ifs = temp-&gt;ifcs;
	isptr = 0;
	hasxy = hasbut = 0;
	ncoll = 0;
	n = 0;
	nk = 0;
	memset(ifs, 0, sizeof *ifs * MaxIfc);
	for(i = 0; i &lt; repsz; i += dsize+1){
		dsize = (1 &lt;&lt; (repdesc[i] &amp; 03)) &gt;&gt; 1;
		if(nk &gt; MaxVals){
			fprint(2, "bad report: too many input types\n");
			return -1;
		}
		if(n == MaxIfc)
			break;
		if(repdesc[i] == HidEnd){
			ncoll--;
			if(ncoll == 0)
				break;
		}

		switch(repdesc[i]){
		case HidReportId:
			switch(repdesc[i+1]){
			case HidReportIdPtr:
				temp-&gt;id = repdesc[i+1];
				break;
			default:
				fprint(2, "report type %#ux bad\n",
					repdesc[i+1]);
				return -1;
			}
			break;
		case HidTypeUsg:
			switch(repdesc[i+1]){
			case HidX:
				hasxy++;
				ks[nk++] = KindX;
				break;
			case HidY:
				hasxy++;
				ks[nk++] = KindY;
				break;
			case HidZ:
				ks[nk++] = KindPad;
				break;
			case HidWheel:
				ks[nk++] = KindWheel;
				break;
			case HidPtr:
				isptr++;
				break;
			}
			break;
		case HidTypeUsgPg:
			switch(repdesc[i+1]){
			case HidPgButts:
				hasbut++;
				ks[nk++] = KindButtons;
				break;
			}
			break;
		case HidTypeRepSz:
			ifs[n].nbits = repdesc[i+1];
			break;
		case HidTypeCnt:
			ifs[n].count = repdesc[i+1];
			break;
		case HidInput:
			if(ifs[n].count &gt; MaxVals){
				fprint(2, "bad report: input count too big\n");
				return -1;
			}
			for(j = 0; j &lt;nk; j++)
				ifs[n].kind[j] = ks[j];
			if(nk != 0 &amp;&amp; nk &lt; ifs[n].count)
				for(l = j; l &lt;ifs[n].count; l++)
					ifs[n].kind[l] = ks[j-1];
			n++;
			if(n &lt; MaxIfc){
				ifs[n].count = ifs[n-1].count;	/* inherit values */
				ifs[n].nbits = ifs[n-1].nbits;
				if(ifs[n].nbits == 0)
					ifs[n].nbits = 1;
			}
			nk = 0;
			break;
		case HidCollection:
			ncoll++;
			break;
		}
	}
	temp-&gt;nifcs = n;
	for(i = 0; i &lt; n; i++)
		temp-&gt;sz += temp-&gt;ifcs[i].nbits * temp-&gt;ifcs[i].count;
	temp-&gt;sz = (temp-&gt;sz + 7) / 8;
	
	if(isptr &amp;&amp; hasxy &amp;&amp; hasbut)
		return 0;
	fprint(2, "bad report: isptr %d, hasxy %d, hasbut %d\n",
		isptr, hasxy, hasbut);
	return -1;
}

int
parsereport(HidRepTempl *templ, Chain *rep)
{
	int i, j, k, ifssz;
	ulong u;
	uchar *p;
	HidInterface *ifs;

	ifssz = templ-&gt;nifcs;
	ifs = templ-&gt;ifcs;
	for(i = 0; i &lt; ifssz; i++)
		for(j = 0; j &lt; ifs[i].count; j++){
			if(ifs[i].nbits &gt; 8 * sizeof ifs[i].v[0]){
				fprint(2, "ptr: bad bits in parsereport");
				return -1;
			}
			u =0;
			getbits(&amp;u, rep, ifs[i].nbits);
			p = (uchar *)&amp;u;
			/* le to host */
			ifs[i].v[j] = p[3]&lt;&lt;24 | p[2]&lt;&lt;16 | p[1]&lt;&lt;8 | p[0]&lt;&lt;0;
			k = ifs[i].kind[j];
			if(k == KindX || k == KindY || k == KindWheel){
				/* propagate sign */
				if(ifs[i].v[j] &amp; (1 &lt;&lt; (ifs[i].nbits - 1)))
					ifs[i].v[j] |= ~MSK(ifs[i].nbits);
			}
		}
	return 0;
}

/* TODO: fmt representation */
void
dumpreport(HidRepTempl *templ)
{
	int i, j, ifssz;
	HidInterface *ifs;

	ifssz = templ-&gt;nifcs;
	ifs = templ-&gt;ifcs;
	for(i = 0; i &lt; ifssz; i++){
		fprint(2, "\tcount %#ux", ifs[i].count);
		fprint(2, " nbits %d ", ifs[i].nbits);
		fprint(2, "\n");
		for(j = 0; j &lt; ifs[i].count; j++){
			fprint(2, "\t\tkind %#ux ", ifs[i].kind[j]);
			fprint(2, "v %#lux\n", ifs[i].v[j]);
		}
		fprint(2, "\n");
	}
	fprint(2, "\n");
}

/* could precalculate indices after parsing the descriptor */
int
hidifcval(HidRepTempl *templ, int kind, int n)
{
	int i, j, ifssz;
	HidInterface *ifs;

	ifssz = templ-&gt;nifcs;
	ifs = templ-&gt;ifcs;
	assert(n &lt;= nelem(ifs[i].v));
	for(i = 0; i &lt; ifssz; i++)
		for(j = 0; j &lt; ifs[i].count; j++)
			if(ifs[i].kind[j] == kind &amp;&amp; n-- == 0)
				return (int)ifs[i].v[j];
	return 0;		/* least damage (no buttons, no movement) */
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

