<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/kb/hid.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/kb/hid.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB keyboard/mouse constants
 */

typedef struct Chain Chain;
typedef struct HidInterface HidInterface;
typedef struct HidRepTempl HidRepTempl;

enum {
	Stack = 32 * 1024,

	/* HID class subclass protocol ids */
	PtrCSP		= 0x020103,	/* mouse.boot.hid */
	KbdCSP		= 0x010103,	/* keyboard.boot.hid */

	/* Requests */
	Getproto	= 0x03,
	Setidle		= 0x0a,
	Setproto	= 0x0b,

	/* protocols for SET_PROTO request */
	Bootproto	= 0,
	Reportproto	= 1,
};

enum {
	/* keyboard modifier bits */
	Mlctrl		= 0,
	Mlshift		= 1,
	Mlalt		= 2,
	Mlgui		= 3,
	Mrctrl		= 4,
	Mrshift		= 5,
	Mralt		= 6,
	Mrgui		= 7,

	/* masks for byte[0] */
	Mctrl		= 1&lt;&lt;Mlctrl | 1&lt;&lt;Mrctrl,
	Mshift		= 1&lt;&lt;Mlshift | 1&lt;&lt;Mrshift,
	Malt		= 1&lt;&lt;Mlalt | 1&lt;&lt;Mralt,
	Mcompose	= 1&lt;&lt;Mlalt,
	Maltgr		= 1&lt;&lt;Mralt,
	Mgui		= 1&lt;&lt;Mlgui | 1&lt;&lt;Mrgui,

	MaxAcc = 3,			/* max. ptr acceleration */
	PtrMask= 0xf,			/* 4 buttons: should allow for more. */
};

/*
 * Plan 9 keyboard driver constants.
 */
enum {
	/* Scan codes (see kbd.c) */
	SCesc1		= 0xe0,		/* first of a 2-character sequence */
	SCesc2		= 0xe1,
	SClshift	= 0x2a,
	SCrshift	= 0x36,
	SCctrl		= 0x1d,
	SCcompose	= 0x38,
	Keyup		= 0x80,		/* flag bit */
	Keymask		= 0x7f,		/* regular scan code bits */
};

int kbmain(Dev *d, int argc, char*argv[]);

enum{
	MaxChLen	= 64,	/* bytes */
};

struct Chain {
	int	b;			/* offset start in bits, (first full) */
	int	e;			/* offset end in bits (first empty) */
	uchar	buf[MaxChLen];
};

#define MSK(nbits)		((1UL &lt;&lt; (nbits)) - 1)
#define IsCut(bbits, ebits)	(((ebits)/8 - (bbits)/8) &gt; 0)

enum {
	KindPad = 0,
	KindButtons,
	KindX,
	KindY,
	KindWheel,

	MaxVals	= 16,
	MaxIfc	= 8,
};

struct HidInterface {
	ulong	v[MaxVals];	/* one ulong per val should be enough */
	uchar	kind[MaxVals];
	int	nbits;
	int	count;
};

struct HidRepTempl{
	int	id;				/* id which may not be present */
	uint	sz;				/* in bytes */
	int	nifcs;
	HidInterface ifcs[MaxIfc];
};

enum {
	/* report types */

	HidReportApp	= 0x01,
	HidTypeUsgPg	= 0x05,
	HidPgButts	= 0x09,

	HidTypeRepSz	= 0x75,
	HidTypeCnt	= 0x95,
	HidCollection	= 0xa1,

	HidTypeUsg	= 0x09,
	HidPtr		= 0x01,
	HidX		= 0x30,
	HidY		= 0x31,
	HidZ		= 0x32,
	HidWheel	= 0x38,

	HidInput	= 0x81,
	HidReportId	= 0x85,
	HidReportIdPtr	= 0x01,

	HidEnd		= 0xc0,
};

void	dumpreport(HidRepTempl *templ);
int	hidifcval(HidRepTempl *templ, int kind, int n);
int	parsereport(HidRepTempl *templ, Chain *rep);
int	parsereportdesc(HidRepTempl *temp, uchar *repdesc, int repsz);
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

