<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/kb/kb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/kb/kb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB Human Interaction Device: keyboard and mouse.
 *
 * If there's no usb keyboard, it tries to setup the mouse, if any.
 * It should be started at boot time.
 *
 * Mouse events are converted to the format of mouse(3)'s mousein file.
 * Keyboard keycodes are translated to scan codes and sent to kbin(3).
 *
 * If there is no keyboard, it tries to setup the mouse properly, else it falls
 * back to boot protocol.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "hid.h"

enum
{
	Awakemsg= 0xdeaddead,
	Diemsg	= 0xbeefbeef,
	Dwcidle	= 8,
};

typedef struct KDev KDev;
typedef struct Kin Kin;

struct KDev
{
	Dev*	dev;		/* usb device*/
	Dev*	ep;		/* endpoint to get events */
	Kin*	in;		/* used to send events to kernel */
	int	idle;		/* min time between reports (× 4ms) */
	Channel*repeatc;	/* only for keyboard */
	int	accel;		/* only for mouse */
	int	bootp;		/* has associated keyboard */
	int	debug;
	HidRepTempl templ;
	int	(*ptrvals)(KDev *kd, Chain *ch, int *px, int *py, int *pb);
};

/*
 * Kbdin and mousein files must be shared among all instances.
 */
struct Kin
{
	int	ref;
	int	fd;
	char*	name;
};

/*
 * Map for the logitech bluetooth mouse with 8 buttons and wheels.
 *	{ ptr -&gt;mouse}
 *	{ 0x01, 0x01 },	// left
 *	{ 0x04, 0x02 },	// middle
 *	{ 0x02, 0x04 },	// right
 *	{ 0x40, 0x08 },	// up
 *	{ 0x80, 0x10 },	// down
 *	{ 0x10, 0x08 },	// side up
 *	{ 0x08, 0x10 },	// side down
 *	{ 0x20, 0x02 }, // page
 * besides wheel and regular up/down report the 4th byte as 1/-1
 */

/*
 * key code to scan code; for the page table used by
 * the logitech bluetooth keyboard.
 */
static char sctab[256] =
{
[0x00]	0x0,	0x0,	0x0,	0x0,	0x1e,	0x30,	0x2e,	0x20,
[0x08]	0x12,	0x21,	0x22,	0x23,	0x17,	0x24,	0x25,	0x26,
[0x10]	0x32,	0x31,	0x18,	0x19,	0x10,	0x13,	0x1f,	0x14,
[0x18]	0x16,	0x2f,	0x11,	0x2d,	0x15,	0x2c,	0x2,	0x3,
[0x20]	0x4,	0x5,	0x6,	0x7,	0x8,	0x9,	0xa,	0xb,
[0x28]	0x1c,	0x1,	0xe,	0xf,	0x39,	0xc,	0xd,	0x1a,
[0x30]	0x1b,	0x2b,	0x2b,	0x27,	0x28,	0x29,	0x33,	0x34,
[0x38]	0x35,	0x3a,	0x3b,	0x3c,	0x3d,	0x3e,	0x3f,	0x40,
[0x40]	0x41,	0x42,	0x43,	0x44,	0x57,	0x58,	0x63,	0x46,
[0x48]	0x77,	0x52,	0x47,	0x49,	0x53,	0x4f,	0x51,	0x4d,
[0x50]	0x4b,	0x50,	0x48,	0x45,	0x35,	0x37,	0x4a,	0x4e,
[0x58]	0x1c,	0x4f,	0x50,	0x51,	0x4b,	0x4c,	0x4d,	0x47,
[0x60]	0x48,	0x49,	0x52,	0x53,	0x56,	0x7f,	0x74,	0x75,
[0x68]	0x55,	0x59,	0x5a,	0x5b,	0x5c,	0x5d,	0x5e,	0x5f,
[0x70]	0x78,	0x79,	0x7a,	0x7b,	0x0,	0x0,	0x0,	0x0,
[0x78]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x71,
[0x80]	0x73,	0x72,	0x0,	0x0,	0x0,	0x7c,	0x0,	0x0,
[0x88]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0x90]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0x98]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xa0]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xa8]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xb0]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xb8]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xc0]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xc8]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xd0]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xd8]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xe0]	0x1d,	0x2a,	0x38,	0x7d,	0x61,	0x36,	0x64,	0x7e,
[0xe8]	0x0,	0x0,	0x0,	0x0,	0x0,	0x73,	0x72,	0x71,
[0xf0]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
[0xf8]	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
};

static QLock inlck;
static Kin kbdin =
{
	.ref = 0,
	.name = "#Ι/kbin",
	.fd = -1,
};
static Kin ptrin =
{
	.ref = 0,
	.name = "#m/mousein",
	.fd = -1,
};

static int ptrbootpvals(KDev *kd, Chain *ch, int *px, int *py, int *pb);
static int ptrrepvals(KDev *kd, Chain *ch, int *px, int *py, int *pb);

static int
setbootproto(KDev* f, int eid, uchar *, int)
{
	int nr, r, id;

	f-&gt;ptrvals = ptrbootpvals;
	r = Rh2d|Rclass|Riface;
	dprint(2, "setting boot protocol\n");
	id = f-&gt;dev-&gt;usb-&gt;ep[eid]-&gt;iface-&gt;id;
	nr = usbcmd(f-&gt;dev, r, Setproto, Bootproto, id, nil, 0);
	if(nr &lt; 0)
		return -1;
	usbcmd(f-&gt;dev, r, Setidle, f-&gt;idle&lt;&lt;8, id, nil, 0);
	return nr;
}

static uchar ignoredesc[128];

static int
setfirstconfig(KDev* f, int eid, uchar *desc, int descsz)
{
	int nr, r, id, i;

	dprint(2, "setting first config\n");
	if(desc == nil){
		descsz = sizeof ignoredesc;
		desc = ignoredesc;
	}
	id = f-&gt;dev-&gt;usb-&gt;ep[eid]-&gt;iface-&gt;id;
	r = Rh2d | Rstd | Rdev;
	nr = usbcmd(f-&gt;dev,  r, Rsetconf, 1, 0, nil, 0);
	if(nr &lt; 0)
		return -1;
	r = Rh2d | Rclass | Riface;
	nr = usbcmd(f-&gt;dev, r, Setidle, f-&gt;idle&lt;&lt;8, id, nil, 0);
	if(nr &lt; 0)
		return -1;
	r = Rd2h | Rstd | Riface;
	nr=usbcmd(f-&gt;dev,  r, Rgetdesc, Dreport&lt;&lt;8, id, desc, descsz);
	if(nr &lt;= 0)
		return -1;
	if(f-&gt;debug){
		fprint(2, "report descriptor:");
		for(i = 0; i &lt; nr; i++){
			if(i%8 == 0)
				fprint(2, "\n\t");
			fprint(2, "%#2.2ux ", desc[i]);
		}
		fprint(2, "\n");
	}
	f-&gt;ptrvals = ptrrepvals;
	return nr;
}

/*
 * Try to recover from a babble error. A port reset is the only way out.
 * BUG: we should be careful not to reset a bundle with several devices.
 */
static void
recoverkb(KDev *f)
{
	int i;

	close(f-&gt;dev-&gt;dfd);		/* it's for usbd now */
	devctl(f-&gt;dev, "reset");
	for(i = 0; i &lt; 10; i++){
		if(i == 5)
			f-&gt;bootp++;
		sleep(500);
		if(opendevdata(f-&gt;dev, ORDWR) &gt;= 0){
			if(f-&gt;bootp)
				/* TODO func pointer */
				setbootproto(f, f-&gt;ep-&gt;id, nil, 0);
			else
				setfirstconfig(f, f-&gt;ep-&gt;id, nil, 0);
			break;
		}
		/* else usbd still working... */
	}
}

static void
kbfatal(KDev *kd, char *sts)
{
	Dev *dev;

	if(sts != nil)
		fprint(2, "kb: fatal: %s\n", sts);
	else
		fprint(2, "kb: exiting\n");
	if(kd-&gt;repeatc != nil)
		nbsendul(kd-&gt;repeatc, Diemsg);
	dev = kd-&gt;dev;
	kd-&gt;dev = nil;
	if(kd-&gt;ep != nil)
		closedev(kd-&gt;ep);
	kd-&gt;ep = nil;
	devctl(dev, "detach");
	closedev(dev);
	/*
	 * free(kd); done by closedev.
	 */
	threadexits(sts);
}

static int
scale(KDev *f, int x)
{
	int sign = 1;

	if(x &lt; 0){
		sign = -1;
		x = -x;
	}
	switch(x){
	case 0:
	case 1:
	case 2:
	case 3:
		break;
	case 4:
		x = 6 + (f-&gt;accel&gt;&gt;2);
		break;
	case 5:
		x = 9 + (f-&gt;accel&gt;&gt;1);
		break;
	default:
		x *= MaxAcc;
		break;
	}
	return sign*x;
}

/*
 * ps2 mouse is processed mostly at interrupt time.
 * for usb we do what we can.
 */
static void
sethipri(void)
{
	char fn[30];
	int fd;

	snprint(fn, sizeof fn, "/proc/%d/ctl", getpid());
	fd = open(fn, OWRITE);
	if(fd &gt;= 0) {
		fprint(fd, "pri 13");
		close(fd);
	}
}

static int
ptrrepvals(KDev *kd, Chain *ch, int *px, int *py, int *pb)
{
	int i, x, y, b, c;
	static char buts[] = {0x0, 0x2, 0x1};

	c = ch-&gt;e / 8;

	/* sometimes there is a report id, sometimes not */
	if(c == kd-&gt;templ.sz + 1)
		if(ch-&gt;buf[0] == kd-&gt;templ.id)
			ch-&gt;b += 8;
		else
			return -1;
	parsereport(&amp;kd-&gt;templ, ch);

	if(kd-&gt;debug &gt; 1)
		dumpreport(&amp;kd-&gt;templ);
	if(c &lt; 3)
		return -1;
	x = hidifcval(&amp;kd-&gt;templ, KindX, 0);
	y = hidifcval(&amp;kd-&gt;templ, KindY, 0);
	b = 0;
	for(i = 0; i&lt;sizeof buts; i++)
		b |= (hidifcval(&amp;kd-&gt;templ, KindButtons, i) &amp; 1) &lt;&lt; buts[i];
	if(c &gt; 3 &amp;&amp; hidifcval(&amp;kd-&gt;templ, KindWheel, 0) &gt; 0)	/* up */
		b |= 0x08;
	if(c &gt; 3 &amp;&amp; hidifcval(&amp;kd-&gt;templ, KindWheel, 0) &lt; 0)	/* down */
		b |= 0x10;

	*px = x;
	*py = y;
	*pb = b;
	return 0;
}

static int
ptrbootpvals(KDev *kd, Chain *ch, int *px, int *py, int *pb)
{
	int b, c;
	char x, y;
	static char maptab[] = {0x0, 0x1, 0x4, 0x5, 0x2, 0x3, 0x6, 0x7};

	c = ch-&gt;e / 8;
	if(c &lt; 3)
		return -1;
	if(kd-&gt;templ.nifcs){
		x = hidifcval(&amp;kd-&gt;templ, KindX, 0);
		y = hidifcval(&amp;kd-&gt;templ, KindY, 0);
	}else{
		/* no report descriptor for boot protocol */
		x = ((signed char*)ch-&gt;buf)[1];
		y = ((signed char*)ch-&gt;buf)[2];
	}

	b = maptab[ch-&gt;buf[0] &amp; 0x7];
	if(c &gt; 3 &amp;&amp; ch-&gt;buf[3] == 1)		/* up */
		b |= 0x08;
	if(c &gt; 3 &amp;&amp; ch-&gt;buf[3] == 0xff)		/* down */
		b |= 0x10;
	*px = x;
	*py = y;
	*pb = b;
	return 0;
}

static void
ptrwork(void* a)
{
	int hipri, mfd, nerrs, x, y, b, c, ptrfd;
	char mbuf[80];
	Chain ch;
	KDev* f = a;

	threadsetname("ptr %s", f-&gt;ep-&gt;dir);
	hipri = nerrs = 0;
	ptrfd = f-&gt;ep-&gt;dfd;
	mfd = f-&gt;in-&gt;fd;
	if(f-&gt;ep-&gt;maxpkt &lt; 3 || f-&gt;ep-&gt;maxpkt &gt; MaxChLen)
		kbfatal(f, "weird mouse maxpkt");
	for(;;){
		memset(ch.buf, 0, MaxChLen);
		if(f-&gt;ep == nil)
			kbfatal(f, nil);
		c = read(ptrfd, ch.buf, f-&gt;ep-&gt;maxpkt);
		assert(f-&gt;dev != nil);
		assert(f-&gt;ep != nil);
		if(c &lt; 0){
			dprint(2, "kb: mouse: %s: read: %r\n", f-&gt;ep-&gt;dir);
			if(++nerrs &lt; 3){
				recoverkb(f);
				continue;
			}
		}
		if(c &lt;= 0)
			kbfatal(f, nil);
		ch.b = 0;
		ch.e = 8 * c;
		if(f-&gt;ptrvals(f, &amp;ch, &amp;x, &amp;y, &amp;b) &lt; 0)
			continue;
		if(f-&gt;accel){
			x = scale(f, x);
			y = scale(f, y);
		}
		if(f-&gt;debug &gt; 1)
			fprint(2, "kb: m%11d %11d %11d\n", x, y, b);
		seprint(mbuf, mbuf+sizeof(mbuf), "m%11d %11d %11d", x, y,b);
		if(write(mfd, mbuf, strlen(mbuf)) &lt; 0)
			kbfatal(f, "mousein i/o");
		if(hipri == 0){
			sethipri();
			hipri = 1;
		}
	}
}

static void
stoprepeat(KDev *f)
{
	sendul(f-&gt;repeatc, Awakemsg);
}

static void
startrepeat(KDev *f, uchar esc1, uchar sc)
{
	ulong c;

	if(esc1)
		c = SCesc1 &lt;&lt; 8 | (sc &amp; 0xff);
	else
		c = sc;
	sendul(f-&gt;repeatc, c);
}

static void
putscan(KDev *f, uchar esc, uchar sc)
{
	int kbinfd;
	uchar s[2] = {SCesc1, 0};

	kbinfd = f-&gt;in-&gt;fd;
	if(sc == 0x41){
		f-&gt;debug += 2;
		return;
	}
	if(sc == 0x42){
		f-&gt;debug = 0;
		return;
	}
	if(f-&gt;debug &gt; 1)
		fprint(2, "sc: %x %x\n", (esc? SCesc1: 0), sc);
	s[1] = sc;
	if(esc &amp;&amp; sc != 0)
		write(kbinfd, s, 2);
	else if(sc != 0)
		write(kbinfd, s+1, 1);
}

static void
repeatproc(void* a)
{
	KDev *f;
	Channel *repeatc;
	ulong l, t, i;
	uchar esc1, sc;

	threadsetname("kbd repeat");
	/*
	 * too many jumps here.
	 * Rewrite instead of debug, if needed.
	 */
	f = a;
	repeatc = f-&gt;repeatc;
	l = Awakemsg;
Repeat:
	if(l == Diemsg)
		goto Abort;
	while(l == Awakemsg)
		l = recvul(repeatc);
	if(l == Diemsg)
		goto Abort;
	esc1 = l &gt;&gt; 8;
	sc = l;
	t = 160;
	for(;;){
		for(i = 0; i &lt; t; i += 5){
			if(l = nbrecvul(repeatc))
				goto Repeat;
			sleep(5);
		}
		putscan(f, esc1, sc);
		t = 30;
	}
Abort:
	chanfree(repeatc);
	threadexits("aborted");

}


#define hasesc1(sc)	((sc) &gt;= 0x47 || (sc) == 0x38)

static void
putmod(KDev *f, uchar mods, uchar omods, uchar mask, uchar esc, uchar sc)
{
	/* BUG: Should be a single write */
	if((mods&amp;mask) &amp;&amp; !(omods&amp;mask))
		putscan(f, esc, sc);
	if(!(mods&amp;mask) &amp;&amp; (omods&amp;mask))
		putscan(f, esc, Keyup|sc);
}

/*
 * This routine diffs the state with the last known state
 * and invents the scan codes that would have been sent
 * by a non-usb keyboard in that case. This also requires supplying
 * the extra esc1 byte as well as keyup flags.
 * The aim is to allow future addition of other keycode pages
 * for other keyboards.
 */
static uchar
putkeys(KDev *f, uchar buf[], uchar obuf[], int n, uchar dk)
{
	int i, j;
	uchar uk;

	putmod(f, buf[0], obuf[0], Mctrl, 0, SCctrl);
	putmod(f, buf[0], obuf[0], (1&lt;&lt;Mlshift), 0, SClshift);
	putmod(f, buf[0], obuf[0], (1&lt;&lt;Mrshift), 0, SCrshift);
	putmod(f, buf[0], obuf[0], Mcompose, 0, SCcompose);
	putmod(f, buf[0], obuf[0], Maltgr, 1, SCcompose);

	/* Report key downs */
	for(i = 2; i &lt; n; i++){
		for(j = 2; j &lt; n; j++)
			if(buf[i] == obuf[j])
			 	break;
		if(j == n &amp;&amp; buf[i] != 0){
			dk = sctab[buf[i]];
			putscan(f, hasesc1(dk), dk);
			startrepeat(f, hasesc1(dk), dk);
		}
	}

	/* Report key ups */
	uk = 0;
	for(i = 2; i &lt; n; i++){
		for(j = 2; j &lt; n; j++)
			if(obuf[i] == buf[j])
				break;
		if(j == n &amp;&amp; obuf[i] != 0){
			uk = sctab[obuf[i]];
			putscan(f, hasesc1(uk), uk|Keyup);
		}
	}
	if(uk &amp;&amp; (dk == 0 || dk == uk)){
		stoprepeat(f);
		dk = 0;
	}
	return dk;
}

static int
kbdbusy(uchar* buf, int n)
{
	int i;

	for(i = 1; i &lt; n; i++)
		if(buf[i] == 0 || buf[i] != buf[0])
			return 0;
	return 1;
}

static void
kbdwork(void *a)
{
	int c, i, kbdfd, nerrs;
	uchar dk, buf[64], lbuf[64];
	char err[128];
	KDev *f = a;

	threadsetname("kbd %s", f-&gt;ep-&gt;dir);
	kbdfd = f-&gt;ep-&gt;dfd;

	if(f-&gt;ep-&gt;maxpkt &lt; 3 || f-&gt;ep-&gt;maxpkt &gt; sizeof buf)
		kbfatal(f, "weird maxpkt");

	f-&gt;repeatc = chancreate(sizeof(ulong), 0);
	if(f-&gt;repeatc == nil)
		kbfatal(f, "chancreate failed");

	proccreate(repeatproc, f, Stack);
	memset(lbuf, 0, sizeof lbuf);
	dk = nerrs = 0;
	for(;;){
		memset(buf, 0, sizeof buf);
		c = read(kbdfd, buf, f-&gt;ep-&gt;maxpkt);
		assert(f-&gt;dev != nil);
		assert(f-&gt;ep != nil);
		if(c &lt; 0){
			rerrstr(err, sizeof(err));
			fprint(2, "kb: %s: read: %s\n", f-&gt;ep-&gt;dir, err);
			if(strstr(err, "babble") != 0 &amp;&amp; ++nerrs &lt; 3){
				recoverkb(f);
				continue;
			}
		}
		if(c &lt;= 0)
			kbfatal(f, nil);
		if(c &lt; 3)
			continue;
		if(kbdbusy(buf + 2, c - 2))
			continue;
		if(usbdebug &gt; 2 || f-&gt;debug &gt; 1){
			fprint(2, "kbd mod %x: ", buf[0]);
			for(i = 2; i &lt; c; i++)
				fprint(2, "kc %x ", buf[i]);
			fprint(2, "\n");
		}
		dk = putkeys(f, buf, lbuf, f-&gt;ep-&gt;maxpkt, dk);
		memmove(lbuf, buf, c);
		nerrs = 0;
	}
}

static void
freekdev(void *a)
{
	KDev *kd;

	kd = a;
	if(kd-&gt;in != nil){
		qlock(&amp;inlck);
		if(--kd-&gt;in-&gt;ref == 0){
			close(kd-&gt;in-&gt;fd);
			kd-&gt;in-&gt;fd = -1;
		}
		qunlock(&amp;inlck);
	}
	dprint(2, "freekdev\n");
	free(kd);
}

static void
kbstart(Dev *d, Ep *ep, Kin *in, void (*f)(void*), KDev *kd)
{
	uchar desc[512];
	int n, res;

	qlock(&amp;inlck);
	if(in-&gt;fd &lt; 0){
		in-&gt;fd = open(in-&gt;name, OWRITE);
		if(in-&gt;fd &lt; 0){
			fprint(2, "kb: %s: %r\n", in-&gt;name);
			qunlock(&amp;inlck);
			return;
		}
	}
	in-&gt;ref++;	/* for kd-&gt;in = in */
	qunlock(&amp;inlck);
	d-&gt;free = freekdev;
	kd-&gt;in = in;
	kd-&gt;dev = d;
	res = -1;
	kd-&gt;ep = openep(d, ep-&gt;id);
	if(kd-&gt;ep == nil){
		fprint(2, "kb: %s: openep %d: %r\n", d-&gt;dir, ep-&gt;id);
		return;
	}
	if(in == &amp;kbdin){
		/*
		 * DWC OTG controller misses some split transaction inputs.
		 * Set nonzero idle time to return more frequent reports
		 * of keyboard state, to avoid losing key up/down events.
		 */
		n = read(d-&gt;cfd, desc, sizeof desc - 1);
		if(n &gt; 0){
			desc[n] = 0;
			if(strstr((char*)desc, "dwcotg") != nil)
				kd-&gt;idle = Dwcidle;
		}
	}
	if(!kd-&gt;bootp)
		res= setfirstconfig(kd, ep-&gt;id, desc, sizeof desc);
	if(res &gt; 0)
		res = parsereportdesc(&amp;kd-&gt;templ, desc, sizeof desc);
	/* if we could not set the first config, we give up */
	if(kd-&gt;bootp || res &lt; 0){
		kd-&gt;bootp = 1;
		if(setbootproto(kd, ep-&gt;id, nil, 0) &lt; 0){
			fprint(2, "kb: %s: bootproto: %r\n", d-&gt;dir);
			return;
		}
	}else if(kd-&gt;debug)
		dumpreport(&amp;kd-&gt;templ);
	if(opendevdata(kd-&gt;ep, OREAD) &lt; 0){
		fprint(2, "kb: %s: opendevdata: %r\n", kd-&gt;ep-&gt;dir);
		closedev(kd-&gt;ep);
		kd-&gt;ep = nil;
		return;
	}

	incref(d);
	proccreate(f, kd, Stack);
}

static int
usage(void)
{
	werrstr("usage: usb/kb [-bdkm] [-a n] [-N nb]");
	return -1;
}

int
kbmain(Dev *d, int argc, char* argv[])
{
	int bootp, i, kena, pena, accel, devid, debug;
	Ep *ep;
	KDev *kd;
	Usbdev *ud;

	kena = pena = 1;
	bootp = 0;
	accel = 0;
	debug = 0;
	devid = d-&gt;id;
	ARGBEGIN{
	case 'a':
		accel = strtol(EARGF(usage()), nil, 0);
		break;
	case 'd':
		debug++;
		break;
	case 'k':
		kena = 1;
		pena = 0;
		break;
	case 'm':
		kena = 0;
		pena = 1;
		break;
	case 'N':
		devid = atoi(EARGF(usage()));		/* ignore dev number */
		break;
	case 'b':
		bootp++;
		break;
	default:
		return usage();
	}ARGEND;
	if(argc != 0)
		return usage();
	USED(devid);
	ud = d-&gt;usb;
	d-&gt;aux = nil;
	dprint(2, "kb: main: dev %s ref %ld\n", d-&gt;dir, d-&gt;ref);

	if(kena)
		for(i = 0; i &lt; nelem(ud-&gt;ep); i++)
			if((ep = ud-&gt;ep[i]) == nil)
				break;
			else if(ep-&gt;iface-&gt;csp == KbdCSP)
				bootp = 1;

	for(i = 0; i &lt; nelem(ud-&gt;ep); i++){
		if((ep = ud-&gt;ep[i]) == nil)
			continue;
		if(kena &amp;&amp; ep-&gt;type == Eintr &amp;&amp; ep-&gt;dir == Ein &amp;&amp;
		    ep-&gt;iface-&gt;csp == KbdCSP){
			kd = d-&gt;aux = emallocz(sizeof(KDev), 1);
			kd-&gt;accel = 0;
			kd-&gt;bootp = 1;
			kd-&gt;debug = debug;
			kbstart(d, ep, &amp;kbdin, kbdwork, kd);
		}
		if(pena &amp;&amp; ep-&gt;type == Eintr &amp;&amp; ep-&gt;dir == Ein &amp;&amp;
		    ep-&gt;iface-&gt;csp == PtrCSP){
			kd = d-&gt;aux = emallocz(sizeof(KDev), 1);
			kd-&gt;accel = accel;
			kd-&gt;bootp = bootp;
			kd-&gt;debug = debug;
			kbstart(d, ep, &amp;ptrin, ptrwork, kd);
		}
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

