<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/lib/dev.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/lib/dev.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"

/*
 * epN.M -&gt; N
 */
static int
nameid(char *s)
{
	char *r;
	char nm[20];

	r = strrchr(s, 'p');
	if(r == nil)
		return -1;
	strecpy(nm, nm+sizeof(nm), r+1);
	r = strchr(nm, '.');
	if(r == nil)
		return -1;
	*r = 0;
	return atoi(nm);
}

Dev*
openep(Dev *d, int id)
{
	char *mode;	/* How many modes? */
	Ep *ep;
	Altc *ac;
	Dev *epd;
	Usbdev *ud;
	char name[40];

	if(access("/dev/usb", AEXIST) &lt; 0 &amp;&amp; bind("#u", "/dev", MBEFORE) &lt; 0)
		return nil;
	if(d-&gt;cfd &lt; 0 || d-&gt;usb == nil){
		werrstr("device not configured");
		return nil;
	}
	ud = d-&gt;usb;
	if(id &lt; 0 || id &gt;= nelem(ud-&gt;ep) || ud-&gt;ep[id] == nil){
		werrstr("bad enpoint number");
		return nil;
	}
	ep = ud-&gt;ep[id];
	mode = "rw";
	if(ep-&gt;dir == Ein)
		mode = "r";
	if(ep-&gt;dir == Eout)
		mode = "w";
	snprint(name, sizeof(name), "/dev/usb/ep%d.%d", d-&gt;id, id);
	if(access(name, AEXIST) == 0){
		dprint(2, "%s: %s already exists; trying to open\n", argv0, name);
		epd = opendev(name);
		if(epd != nil)
			epd-&gt;maxpkt = ep-&gt;maxpkt;	/* guess */
		return epd;
	}
	if(devctl(d, "new %d %d %s", id, ep-&gt;type, mode) &lt; 0){
		dprint(2, "%s: %s: new: %r\n", argv0, d-&gt;dir);
		return nil;
	}
	epd = opendev(name);
	if(epd == nil)
		return nil;
	epd-&gt;id = id;
	if(devctl(epd, "maxpkt %d", ep-&gt;maxpkt) &lt; 0)
		fprint(2, "%s: %s: openep: maxpkt: %r\n", argv0, epd-&gt;dir);
	else
		dprint(2, "%s: %s: maxpkt %d\n", argv0, epd-&gt;dir, ep-&gt;maxpkt);
	epd-&gt;maxpkt = ep-&gt;maxpkt;
	ac = ep-&gt;iface-&gt;altc[0];
	if(ep-&gt;ntds &gt; 1 &amp;&amp; devctl(epd, "ntds %d", ep-&gt;ntds) &lt; 0)
		fprint(2, "%s: %s: openep: ntds: %r\n", argv0, epd-&gt;dir);
	else
		dprint(2, "%s: %s: ntds %d\n", argv0, epd-&gt;dir, ep-&gt;ntds);

	/*
	 * For iso endpoints and high speed interrupt endpoints the pollival is
	 * actually 2ⁿ and not n.
	 * The kernel usb driver must take that into account.
	 * It's simpler this way.
	 */

	if(ac != nil &amp;&amp; (ep-&gt;type == Eintr || ep-&gt;type == Eiso) &amp;&amp; ac-&gt;interval != 0)
		if(devctl(epd, "pollival %d", ac-&gt;interval) &lt; 0)
			fprint(2, "%s: %s: openep: pollival: %r\n", argv0, epd-&gt;dir);
	return epd;
}

Dev*
opendev(char *fn)
{
	Dev *d;
	int l;

	if(access("/dev/usb", AEXIST) &lt; 0 &amp;&amp; bind("#u", "/dev", MBEFORE) &lt; 0)
		return nil;
	d = emallocz(sizeof(Dev), 1);
	incref(d);

	l = strlen(fn);
	d-&gt;dfd = -1;
	/*
	 * +30 to allocate extra size to concat "/&lt;epfilename&gt;"
	 * we should probably remove that feature from the manual
	 * and from the code after checking out that nobody relies on
	 * that.
	 */
	d-&gt;dir = emallocz(l + 30, 0);
	strcpy(d-&gt;dir, fn);
	strcpy(d-&gt;dir+l, "/ctl");
	d-&gt;cfd = open(d-&gt;dir, ORDWR|OCEXEC);
	d-&gt;dir[l] = 0;
	d-&gt;id = nameid(fn);
	if(d-&gt;cfd &lt; 0){
		werrstr("can't open endpoint %s: %r", d-&gt;dir);
		free(d-&gt;dir);
		free(d);
		return nil;
	}
	dprint(2, "%s: opendev %#p %s\n", argv0, d, fn);
	return d;
}

int
opendevdata(Dev *d, int mode)
{
	char buf[80]; /* more than enough for a usb path */

	seprint(buf, buf+sizeof(buf), "%s/data", d-&gt;dir);
	d-&gt;dfd = open(buf, mode|OCEXEC);
	return d-&gt;dfd;
}

enum
{
	/*
	 * Max device conf is also limited by max control request size as
	 * limited by Maxctllen in the kernel usb.h (both limits are arbitrary).
	 */
	Maxdevconf = 4 * 1024,	/* asking for 16K kills Newsham's disk */
};

int
loaddevconf(Dev *d, int n)
{
	uchar *buf;
	int nr;
	int type;

	if(n &gt;= nelem(d-&gt;usb-&gt;conf)){
		werrstr("loaddevconf: bug: out of configurations in device");
		fprint(2, "%s: %r\n", argv0);
		return -1;
	}
	buf = emallocz(Maxdevconf, 0);
	type = Rd2h|Rstd|Rdev;
	nr = usbcmd(d, type, Rgetdesc, Dconf&lt;&lt;8|n, 0, buf, Maxdevconf);
	if(nr &lt; Dconflen){
		free(buf);
		return -1;
	}
	if(d-&gt;usb-&gt;conf[n] == nil)
		d-&gt;usb-&gt;conf[n] = emallocz(sizeof(Conf), 1);
	nr = parseconf(d-&gt;usb, d-&gt;usb-&gt;conf[n], buf, nr);
	free(buf);
	return nr;
}

Ep*
mkep(Usbdev *d, int id)
{
	Ep *ep;

	d-&gt;ep[id] = ep = emallocz(sizeof(Ep), 1);
	ep-&gt;id = id;
	return ep;
}

static char*
mkstr(uchar *b, int n)
{
	Rune r;
	char *us;
	char *s;
	char *e;

	if(n &lt;= 2 || (n &amp; 1) != 0)
		return strdup("none");
	n = (n - 2)/2;
	b += 2;
	us = s = emallocz(n*UTFmax+1, 0);
	e = s + n*UTFmax+1;
	for(; --n &gt;= 0; b += 2){
		r = GET2(b);
		s = seprint(s, e, "%C", r);
	}
	return us;
}

char*
loaddevstr(Dev *d, int sid)
{
	uchar buf[128];
	int type;
	int nr;

	if(sid == 0)
		return estrdup("none");
	type = Rd2h|Rstd|Rdev;
	nr=usbcmd(d, type, Rgetdesc, Dstr&lt;&lt;8|sid, 0, buf, sizeof(buf));
	return mkstr(buf, nr);
}

int
loaddevdesc(Dev *d)
{
	uchar buf[Ddevlen+255];
	int nr;
	int type;
	Ep *ep0;

	type = Rd2h|Rstd|Rdev;
	nr = sizeof(buf);
	memset(buf, 0, Ddevlen);
	if((nr=usbcmd(d, type, Rgetdesc, Ddev&lt;&lt;8|0, 0, buf, nr)) &lt; 0)
		return -1;
	/*
	 * Several hubs are returning descriptors of 17 bytes, not 18.
	 * We accept them and leave number of configurations as zero.
	 * (a get configuration descriptor also fails for them!)
	 */
	if(nr &lt; Ddevlen){
		print("%s: %s: warning: device with short descriptor\n",
			argv0, d-&gt;dir);
		if(nr &lt; Ddevlen-1){
			werrstr("short device descriptor (%d bytes)", nr);
			return -1;
		}
	}
	d-&gt;usb = emallocz(sizeof(Usbdev), 1);
	ep0 = mkep(d-&gt;usb, 0);
	ep0-&gt;dir = Eboth;
	ep0-&gt;type = Econtrol;
	ep0-&gt;maxpkt = d-&gt;maxpkt = 8;		/* a default */
	nr = parsedev(d, buf, nr);
	if(nr &gt;= 0){
		d-&gt;usb-&gt;vendor = loaddevstr(d, d-&gt;usb-&gt;vsid);
		if(strcmp(d-&gt;usb-&gt;vendor, "none") != 0){
			d-&gt;usb-&gt;product = loaddevstr(d, d-&gt;usb-&gt;psid);
			d-&gt;usb-&gt;serial = loaddevstr(d, d-&gt;usb-&gt;ssid);
		}
	}
	return nr;
}

int
configdev(Dev *d)
{
	int i;

	if(d-&gt;dfd &lt; 0)
		opendevdata(d, ORDWR);
	if(loaddevdesc(d) &lt; 0)
		return -1;
	for(i = 0; i &lt; d-&gt;usb-&gt;nconf; i++)
		if(loaddevconf(d, i) &lt; 0)
			return -1;
	return 0;
}

static void
closeconf(Conf *c)
{
	int i;
	int a;

	if(c == nil)
		return;
	for(i = 0; i &lt; nelem(c-&gt;iface); i++)
		if(c-&gt;iface[i] != nil){
			for(a = 0; a &lt; nelem(c-&gt;iface[i]-&gt;altc); a++)
				free(c-&gt;iface[i]-&gt;altc[a]);
			free(c-&gt;iface[i]);
		}
	free(c);
}

void
closedev(Dev *d)
{
	int i;
	Usbdev *ud;

	if(d==nil || decref(d) != 0)
		return;
	dprint(2, "%s: closedev %#p %s\n", argv0, d, d-&gt;dir);
	if(d-&gt;free != nil)
		d-&gt;free(d-&gt;aux);
	if(d-&gt;cfd &gt;= 0)
		close(d-&gt;cfd);
	if(d-&gt;dfd &gt;= 0)
		close(d-&gt;dfd);
	d-&gt;cfd = d-&gt;dfd = -1;
	free(d-&gt;dir);
	d-&gt;dir = nil;
	ud = d-&gt;usb;
	d-&gt;usb = nil;
	if(ud != nil){
		free(ud-&gt;vendor);
		free(ud-&gt;product);
		free(ud-&gt;serial);
		for(i = 0; i &lt; nelem(ud-&gt;ep); i++)
			free(ud-&gt;ep[i]);
		for(i = 0; i &lt; nelem(ud-&gt;ddesc); i++)
			free(ud-&gt;ddesc[i]);

		for(i = 0; i &lt; nelem(ud-&gt;conf); i++)
			closeconf(ud-&gt;conf[i]);
		free(ud);
	}
	free(d);
}

static char*
reqstr(int type, int req)
{
	char *s;
	static char* ds[] = { "dev", "if", "ep", "oth" };
	static char buf[40];

	if(type&amp;Rd2h)
		s = seprint(buf, buf+sizeof(buf), "d2h");
	else
		s = seprint(buf, buf+sizeof(buf), "h2d");
	if(type&amp;Rclass)
		s = seprint(s, buf+sizeof(buf), "|cls");
	else if(type&amp;Rvendor)
		s = seprint(s, buf+sizeof(buf), "|vnd");
	else
		s = seprint(s, buf+sizeof(buf), "|std");
	s = seprint(s, buf+sizeof(buf), "|%s", ds[type&amp;3]);

	switch(req){
	case Rgetstatus: s = seprint(s, buf+sizeof(buf), " getsts"); break;
	case Rclearfeature: s = seprint(s, buf+sizeof(buf), " clrfeat"); break;
	case Rsetfeature: s = seprint(s, buf+sizeof(buf), " setfeat"); break;
	case Rsetaddress: s = seprint(s, buf+sizeof(buf), " setaddr"); break;
	case Rgetdesc: s = seprint(s, buf+sizeof(buf), " getdesc"); break;
	case Rsetdesc: s = seprint(s, buf+sizeof(buf), " setdesc"); break;
	case Rgetconf: s = seprint(s, buf+sizeof(buf), " getcnf"); break;
	case Rsetconf: s = seprint(s, buf+sizeof(buf), " setcnf"); break;
	case Rgetiface: s = seprint(s, buf+sizeof(buf), " getif"); break;
	case Rsetiface: s = seprint(s, buf+sizeof(buf), " setif"); break;
	}
	USED(s);
	return buf;
}

static int
cmdreq(Dev *d, int type, int req, int value, int index, uchar *data, int count)
{
	int ndata, n;
	uchar *wp;
	uchar buf[8];
	char *hd, *rs;

	assert(d != nil);
	if(data == nil){
		wp = buf;
		ndata = 0;
	}else{
		ndata = count;
		wp = emallocz(8+ndata, 0);
	}
	wp[0] = type;
	wp[1] = req;
	PUT2(wp+2, value);
	PUT2(wp+4, index);
	PUT2(wp+6, count);
	if(data != nil)
		memmove(wp+8, data, ndata);
	if(usbdebug&gt;2){
		hd = hexstr(wp, ndata+8);
		rs = reqstr(type, req);
		fprint(2, "%s: %s val %d|%d idx %d cnt %d out[%d] %s\n",
			d-&gt;dir, rs, value&gt;&gt;8, value&amp;0xFF,
			index, count, ndata+8, hd);
		free(hd);
	}
	n = write(d-&gt;dfd, wp, 8+ndata);
	if(wp != buf)
		free(wp);
	if(n &lt; 0)
		return -1;
	if(n != 8+ndata){
		dprint(2, "%s: cmd: short write: %d\n", argv0, n);
		return -1;
	}
	return n;
}

static int
cmdrep(Dev *d, void *buf, int nb)
{
	char *hd;

	nb = read(d-&gt;dfd, buf, nb);
	if(nb &gt;0 &amp;&amp; usbdebug &gt; 2){
		hd = hexstr(buf, nb);
		fprint(2, "%s: in[%d] %s\n", d-&gt;dir, nb, hd);
		free(hd);
	}
	return nb;
}

int
usbcmd(Dev *d, int type, int req, int value, int index, uchar *data, int count)
{
	int i, r, nerr;
	char err[64];

	/*
	 * Some devices do not respond to commands some times.
	 * Others even report errors but later work just fine. Retry.
	 */
	r = -1;
	*err = 0;
	for(i = nerr = 0; i &lt; Uctries; i++){
		if(type &amp; Rd2h)
			r = cmdreq(d, type, req, value, index, nil, count);
		else
			r = cmdreq(d, type, req, value, index, data, count);
		if(r &gt; 0){
			if((type &amp; Rd2h) == 0)
				break;
			r = cmdrep(d, data, count);
			if(r &gt; 0)
				break;
			if(r == 0)
				werrstr("no data from device");
		}
		nerr++;
		if(*err == 0)
			rerrstr(err, sizeof(err));
		sleep(Ucdelay);
	}
	if(r &gt; 0 &amp;&amp; i &gt;= 2)
		/* let the user know the device is not in good shape */
		fprint(2, "%s: usbcmd: %s: required %d attempts (%s)\n",
			argv0, d-&gt;dir, i, err);
	return r;
}

int
unstall(Dev *dev, Dev *ep, int dir)
{
	int r;

	if(dir == Ein)
		dir = 0x80;
	else
		dir = 0;
	r = Rh2d|Rstd|Rep;
	if(usbcmd(dev, r, Rclearfeature, Fhalt, ep-&gt;id|dir, nil, 0)&lt;0){
		werrstr("unstall: %s: %r", ep-&gt;dir);
		return -1;
	}
	if(devctl(ep, "clrhalt") &lt; 0){
		werrstr("clrhalt: %s: %r", ep-&gt;dir);
		return -1;
	}
	return 0;
}

/*
 * To be sure it uses a single write.
 */
int
devctl(Dev *dev, char *fmt, ...)
{
	char buf[128];
	va_list arg;
	char *e;

	va_start(arg, fmt);
	e = vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	return write(dev-&gt;cfd, buf, e-buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

