<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/lib/dump.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/lib/dump.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;bio.h&gt;
#include "usb.h"

int usbdebug;

static char *edir[] = {"in", "out", "inout"};
static char *etype[] = {"ctl", "iso", "bulk", "intr"};
static char* cnames[] =
{
	"none", "audio", "comms", "hid", "",
	"", "", "printer", "storage", "hub", "data"
};
static char* devstates[] =
{
	"detached", "attached", "enabled", "assigned", "configured"
};

char*
classname(int c)
{
	static char buf[30];

	if(c &gt;= 0 &amp;&amp; c &lt; nelem(cnames))
		return cnames[c];
	else{
		seprint(buf, buf+30, "%d", c);
		return buf;
	}
}

char *
hexstr(void *a, int n)
{
	int i;
	char *dbuff, *s, *e;
	uchar *b;

	b = a;
	dbuff = s = emallocz(1024, 0);
	*s = 0;
	e = s + 1024;
	for(i = 0; i &lt; n; i++)
		s = seprint(s, e, " %.2ux", b[i]);
	if(s == e)
		fprint(2, "%s: usb/lib: hexdump: bug: small buffer\n", argv0);
	return dbuff;
}

static char *
seprintiface(char *s, char *e, Iface *i)
{
	int	j;
	Altc	*a;
	Ep	*ep;
	char	*eds, *ets;

	s = seprint(s, e, "\t\tiface csp %s.%uld.%uld\n",
		classname(Class(i-&gt;csp)), Subclass(i-&gt;csp), Proto(i-&gt;csp));
	for(j = 0; j &lt; Naltc; j++){
		a=i-&gt;altc[j];
		if(a == nil)
			break;
		s = seprint(s, e, "\t\t  alt %d attr %d ival %d",
			j, a-&gt;attrib, a-&gt;interval);
		if(a-&gt;aux != nil)
			s = seprint(s, e, " devspec %p\n", a-&gt;aux);
		else
			s = seprint(s, e, "\n");
	}
	for(j = 0; j &lt; Nep; j++){
		ep = i-&gt;ep[j];
		if(ep == nil)
			break;
		eds = ets = "";
		if(ep-&gt;dir &lt;= nelem(edir))
			eds = edir[ep-&gt;dir];
		if(ep-&gt;type &lt;= nelem(etype))
			ets = etype[ep-&gt;type];
		s = seprint(s, e, "\t\t  ep id %d addr %d dir %s type %s"
			" itype %d maxpkt %d ntds %d\n",
			ep-&gt;id, ep-&gt;addr, eds, ets, ep-&gt;isotype,
			ep-&gt;maxpkt, ep-&gt;ntds);
	}
	return s;
}

static char*
seprintconf(char *s, char *e, Usbdev *d, int ci)
{
	int i;
	Conf *c;
	char *hd;

	c = d-&gt;conf[ci];
	s = seprint(s, e, "\tconf: cval %d attrib %x %d mA\n",
		c-&gt;cval, c-&gt;attrib, c-&gt;milliamps);
	for(i = 0; i &lt; Niface; i++)
		if(c-&gt;iface[i] == nil)
			break;
		else
			s = seprintiface(s, e, c-&gt;iface[i]);
	for(i = 0; i &lt; Nddesc; i++)
		if(d-&gt;ddesc[i] == nil)
			break;
		else if(d-&gt;ddesc[i]-&gt;conf == c){
			hd = hexstr((uchar*)&amp;d-&gt;ddesc[i]-&gt;data,
				d-&gt;ddesc[i]-&gt;data.bLength);
			s = seprint(s, e, "\t\tdev desc %x[%d]: %s\n",
				d-&gt;ddesc[i]-&gt;data.bDescriptorType,
				d-&gt;ddesc[i]-&gt;data.bLength, hd);
			free(hd);
		}
	return s;
}

int
Ufmt(Fmt *f)
{
	int i;
	Dev *d;
	Usbdev *ud;
	char buf[1024];
	char *s, *e;

	s = buf;
	e = buf+sizeof(buf);
	d = va_arg(f-&gt;args, Dev*);
	if(d == nil)
		return fmtprint(f, "&lt;nildev&gt;\n");
	s = seprint(s, e, "%s", d-&gt;dir);
	ud = d-&gt;usb;
	if(ud == nil)
		return fmtprint(f, "%s %ld refs\n", buf, d-&gt;ref);
	s = seprint(s, e, " csp %s.%uld.%uld",
		classname(Class(ud-&gt;csp)), Subclass(ud-&gt;csp), Proto(ud-&gt;csp));
	s = seprint(s, e, " vid %#ux did %#ux", ud-&gt;vid, ud-&gt;did);
	s = seprint(s, e, " refs %ld\n", d-&gt;ref);
	s = seprint(s, e, "\t%s %s %s\n", ud-&gt;vendor, ud-&gt;product, ud-&gt;serial);
	for(i = 0; i &lt; Nconf; i++){
		if(ud-&gt;conf[i] == nil)
			break;
		else
			s = seprintconf(s, e, ud, i);
	}
	return fmtprint(f, "%s", buf);
}

char*
estrdup(char *s)
{
	char *d;

	d = strdup(s);
	if(d == nil)
		sysfatal("strdup: %r");
	setmalloctag(d, getcallerpc(&amp;s));
	return d;
}

void*
emallocz(ulong size, int zero)
{
	void *x;

	x = malloc(size);
	if(x == nil)
		sysfatal("malloc: %r");
	if(zero)
		memset(x, 0, size);
	setmalloctag(x, getcallerpc(&amp;size));
	return x;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

