<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vac/glob.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vac/glob.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "vac.h"
#include "dat.h"
#include "fns.h"
#include "error.h"

// Convert globbish pattern to regular expression
// The wildcards are
//
//	*	any non-slash characters
//	...	any characters including /
//	?	any single character except /
//	[a-z]	character class
//	[~a-z]	negated character class
//

Reprog*
glob2regexp(char *glob)
{
	char *s, *p, *w;
	Reprog *re;
	int boe;	// beginning of path element

	s = malloc(20*(strlen(glob)+1));
	if(s == nil)
		return nil;
	w = s;
	boe = 1;
	*w++ = '^';
	*w++ = '(';
	for(p=glob; *p; p++){
		if(p[0] == '.' &amp;&amp; p[1] == '.' &amp;&amp; p[2] == '.'){
			strcpy(w, ".*");
			w += strlen(w);
			p += 3-1;
			boe = 0;
			continue;
		}
		if(p[0] == '*'){
			if(boe)
				strcpy(w, "([^./][^/]*)?");
			else
				strcpy(w, "[^/]*");
			w += strlen(w);
			boe = 0;
			continue;
		}
		if(p[0] == '?'){
			if(boe)
				strcpy(w, "[^./]");
			else
				strcpy(w, "[^/]");
			w += strlen(w);
			boe = 0;
			continue;
		}
		if(p[0] == '['){
			*w++ = '[';
			if(*++p == '~'){
				*w++ = '^';
				p++;
			}
			while(*p != ']'){
				if(*p == '/')
					goto syntax;
				if(*p == '^' || *p == '\\')
					*w++ = '\\';
				*w++ = *p++;
			}
			*w++ = ']';
			boe = 0;
			continue;
		}
		if(strchr("()|^$[]*?+\\.", *p)){
			*w++ = '\\';
			*w++ = *p;
			boe = 0;
			continue;
		}
		if(*p == '/'){
			*w++ = '/';
			boe = 1;
			continue;
		}
		*w++ = *p;
		boe = 0;
		continue;
	}
	*w++ = ')';
	*w++ = '$';
	*w = 0;
	
	re = regcomp(s);
	if(re == nil){
	syntax:
		free(s);
		werrstr("glob syntax error");
		return nil;
	}
	free(s);
	return re;
}

typedef struct Pattern Pattern;
struct Pattern
{
	Reprog *re;
	int include;
};

Pattern *pattern;
int npattern;

void
loadexcludefile(char *file)
{
	Biobuf *b;
	char *p, *q;
	int n, inc;
	Reprog *re;

	if((b = Bopen(file, OREAD)) == nil)
		sysfatal("open %s: %r", file);
	for(n=1; (p=Brdstr(b, '\n', 1)) != nil; free(p), n++){
		q = p+strlen(p);
		while(q &gt; p &amp;&amp; isspace((uchar)*(q-1)))
			*--q = 0;
		switch(p[0]){
		case '\0':
		case '#':
			continue;
		}
		
		inc = 0;
		if(strncmp(p, "include ", 8) == 0){
			inc = 1;
		}else if(strncmp(p, "exclude ", 8) == 0){
			inc = 0;
		}else
			sysfatal("%s:%d: line does not begin with include or exclude", file, n);

		if(strchr(p+8, ' '))
			fprint(2, "%s:%d: warning: space in pattern\n", file, n);

		if((re = glob2regexp(p+8)) == nil)
			sysfatal("%s:%d: bad glob pattern", file, n);

		pattern = vtrealloc(pattern, (npattern+1)*sizeof pattern[0]);
		pattern[npattern].re = re;
		pattern[npattern].include = inc;
		npattern++;
	}
	Bterm(b);
}

void
excludepattern(char *p)
{
	Reprog *re;
	
	if((re = glob2regexp(p)) == nil)
		sysfatal("bad glob pattern %s", p);

	pattern = vtrealloc(pattern, (npattern+1)*sizeof pattern[0]);
	pattern[npattern].re = re;
	pattern[npattern].include = 0;
	npattern++;
}

int
includefile(char *file)
{
	Pattern *p, *ep;
	
	for(p=pattern, ep=p+npattern; p&lt;ep; p++)
		if(regexec(p-&gt;re, file, nil, 0))
			return p-&gt;include;
	return 1;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

