<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vac/vacfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vac/vacfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include &lt;fcall.h&gt;
#include "vac.h"

#define convM2Su(a, b, c, d) convM2S(a, b, c)
#define convS2Mu(a, b, c, d) convS2M(a, b, c)
#define convM2Du(a, b, c, d) convM2D(a, b, c)
#define convD2Mu(a, b, c, d) convD2M(a, b, c)

typedef struct Fid Fid;

enum
{
	Stacksize = 320 * 1024,	/* was 32K */
	OPERM	= 0x3		/* mask of all permission types in open mode */
};

struct Fid
{
	short busy;
	short open;
	int fid;
	char *user;
	Qid qid;
	VacFile *file;
	VacDirEnum *vde;
	Fid	*next;
};

enum
{
	Pexec =		1,
	Pwrite = 	2,
	Pread = 	4,
	Pother = 	1,
	Pgroup = 	8,
	Powner =	64
};

Fid	*fids;
uchar	*data;
int	mfd[2];
int	srvfd = -1;
char	*user;
uchar	mdata[8192+IOHDRSZ];
int messagesize = sizeof mdata;
Fcall	rhdr;
Fcall	thdr;
VacFs	*fs;
VtConn  *conn;
int	noperm;
int	dotu;
char *defmnt;

Fid *	newfid(int);
void	error(char*);
void	io(void);
void	vacshutdown(void);
void	usage(void);
int	perm(Fid*, int);
int	permf(VacFile*, char*, int);
ulong	getl(void *p);
void	init(char*, char*, long, int);
int	vacdirread(Fid *f, char *p, long off, long cnt);
int	vacstat(VacFile *parent, VacDir *vd, uchar *p, int np);
void 	srv(void* a);


char	*rflush(Fid*), *rversion(Fid*),
	*rauth(Fid*), *rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*);

char 	*(*fcalls[Tmax])(Fid*);

void
initfcalls(void)
{
	fcalls[Tflush]=	rflush;
	fcalls[Tversion]=	rversion;
	fcalls[Tattach]=	rattach;
	fcalls[Tauth]=		rauth;
	fcalls[Twalk]=		rwalk;
	fcalls[Topen]=		ropen;
	fcalls[Tcreate]=	rcreate;
	fcalls[Tread]=		rread;
	fcalls[Twrite]=	rwrite;
	fcalls[Tclunk]=	rclunk;
	fcalls[Tremove]=	rremove;
	fcalls[Tstat]=		rstat;
	fcalls[Twstat]=	rwstat;
}

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Erdonly[] = 	"read only file system";
char	Eio[] = 	"i/o error";
char	Eempty[] = 	"directory is not empty";
char	Emode[] =	"illegal mode";

int dflag;

void
notifyf(void *a, char *s)
{
	USED(a);
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

void
threadmain(int argc, char *argv[])
{
	char *defsrv, *srvname;
	int p[2], fd;
	int stdio;
	char *host = nil;
	long ncache;

	stdio = 0;
	ncache = 256;
	fmtinstall('H', encodefmt);
	fmtinstall('V', vtscorefmt);
	fmtinstall('F', vtfcallfmt);
	
	defmnt = nil;
	defsrv = nil;
	ARGBEGIN{
	case 'd':
		fmtinstall('F', fcallfmt);
		dflag = 1;
		break;
	case 'c':
		ncache = atoi(EARGF(usage()));
		break;
	case 'i':
		defmnt = nil;
		stdio = 1;
		mfd[0] = 0;
		mfd[1] = 1;
		break;
	case 'h':
		host = EARGF(usage());
		break;
	case 'S':
		defsrv = EARGF(usage());
		break;
	case 's':
		defsrv = "vacfs";
		break;
	case 'm':
		defmnt = EARGF(usage());
		break;
	case 'p':
		noperm = 1;
		break;
	case 'V':
		chattyventi = 1;
		break;
	default:
		usage();
	}ARGEND

	if(argc != 1)
		usage();

	if(defsrv == nil &amp;&amp; defmnt == nil &amp;&amp; !stdio)
		defmnt = "/n/vac";
	if(stdio &amp;&amp; defmnt)
		sysfatal("cannot use -m with -i");

	initfcalls();

	notify(notifyf);
	user = getuser();

	conn = vtdial(host);
	if(conn == nil)
		sysfatal("could not connect to server: %r");

	if(vtconnect(conn) &lt; 0)
		sysfatal("vtconnect: %r");

	fs = vacfsopen(conn, argv[0], VtOREAD, ncache);
	if(fs == nil)
		sysfatal("vacfsopen: %r");

	if(!stdio){
		if(pipe(p) &lt; 0)
			sysfatal("pipe failed: %r");
		mfd[0] = p[0];
		mfd[1] = p[0];
		srvfd = p[1];
		if(defsrv){
			srvname = smprint("/srv/%s", defsrv);
			fd = create(srvname, OWRITE|ORCLOSE, 0666);
			if(fd &lt; 0)
				sysfatal("create %s: %r", srvname);
			if(fprint(fd, "%d", srvfd) &lt; 0)
				sysfatal("write %s: %r", srvname);
			free(srvname);
		}
	}

	procrfork(srv, 0, Stacksize, RFFDG|RFNAMEG|RFNOTEG);

	if(!stdio){
		close(p[0]);
		if(defmnt){
			if(mount(srvfd, -1, defmnt, MREPL|MCREATE, "") &lt; 0)
				sysfatal("mount %s: %r", defmnt);
		}
	}
	threadexits(0);
}

void
srv(void *a)
{
	USED(a);
	io();
	vacshutdown();
}

void
usage(void)
{
	fprint(2, "usage: %s [-sd] [-h host] [-c ncache] [-m mountpoint] vacfile\n", argv0);
	threadexitsall("usage");
}

char*
rversion(Fid *unused)
{
	Fid *f;

	USED(unused);

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);

	if(rhdr.msize &lt; 256)
		return vtstrdup("version: message size too small");
	messagesize = rhdr.msize;
	if(messagesize &gt; sizeof mdata)
		messagesize = sizeof mdata;
	thdr.msize = messagesize;
	if(strncmp(rhdr.version, "9P2000", 6) != 0)
		return vtstrdup("unrecognized 9P version");
	thdr.version = "9P2000";
	if(strncmp(rhdr.version, "9P2000.u", 8) == 0){
		dotu = 1;
		thdr.version = "9P2000.u";
	}
	return nil;
}

char*
rflush(Fid *f)
{
	USED(f);
	return 0;
}

char*
rauth(Fid *f)
{
	USED(f);
	return vtstrdup("vacfs: authentication not required");
}

char*
rattach(Fid *f)
{
	/* no authentication for the momment */
	VacFile *file;
	char err[80];

	file = vacfsgetroot(fs);
	if(file == nil) {
		rerrstr(err, sizeof err);
		return vtstrdup(err);
	}

	f-&gt;busy = 1;
	f-&gt;file = file;
	f-&gt;qid.path = vacfilegetid(f-&gt;file);
	f-&gt;qid.vers = 0;
	f-&gt;qid.type = QTDIR;
	thdr.qid = f-&gt;qid;
	if(rhdr.uname[0])
		f-&gt;user = vtstrdup(rhdr.uname);
	else
		f-&gt;user = "none";
	return 0;
}

char*
rwalk(Fid *f)
{
	VacFile *file, *nfile;
	Fid *nf;
	int nqid, nwname;
	Qid qid;
	char *err = nil;

	if(f-&gt;busy == 0)
		return Enotexist;
	nf = nil;
	if(rhdr.fid != rhdr.newfid){
		if(f-&gt;open)
			return vtstrdup(Eisopen);
		if(f-&gt;busy == 0)
			return vtstrdup(Enotexist);
		nf = newfid(rhdr.newfid);
		if(nf-&gt;busy)
			return vtstrdup(Eisopen);
		nf-&gt;busy = 1;
		nf-&gt;open = 0;
		nf-&gt;qid = f-&gt;qid;
		nf-&gt;file = vacfileincref(f-&gt;file);
		nf-&gt;user = vtstrdup(f-&gt;user);
		f = nf;
	}

	nwname = rhdr.nwname;

	/* easy case */
	if(nwname == 0) {
		thdr.nwqid = 0;
		return 0;
	}

	file = f-&gt;file;
	vacfileincref(file);
	qid = f-&gt;qid;

	for(nqid = 0; nqid &lt; nwname; nqid++){
		if((qid.type &amp; QTDIR) == 0){
			err = Enotdir;
			break;
		}
		if(!permf(file, f-&gt;user, Pexec)) {
			err = Eperm;
			break;
		}
		nfile = vacfilewalk(file, rhdr.wname[nqid]);
		if(nfile == nil)
			break;
		vacfiledecref(file);
		file = nfile;
		qid.type = QTFILE;
		if(vacfileisdir(file))
			qid.type = QTDIR;
		qid.vers = vacfilegetmcount(file);
		qid.path = vacfilegetid(file);
		thdr.wqid[nqid] = qid;
	}

	thdr.nwqid = nqid;

	if(nqid == nwname){
		/* success */
		f-&gt;qid = thdr.wqid[nqid-1];
		vacfiledecref(f-&gt;file);
		f-&gt;file = file;
		return 0;
	}

	vacfiledecref(file);
	if(nf != nil)
		rclunk(nf);

	/* only error on the first element */
	if(nqid == 0)
		return vtstrdup(err);

	return 0;
}

char *
ropen(Fid *f)
{
	int mode, trunc;

	if(f-&gt;open)
		return vtstrdup(Eisopen);
	if(!f-&gt;busy)
		return vtstrdup(Enotexist);

	mode = rhdr.mode;
	thdr.iounit = messagesize - IOHDRSZ;
	if(f-&gt;qid.type &amp; QTDIR){
		if(mode != OREAD)
			return vtstrdup(Eperm);
		if(!perm(f, Pread))
			return vtstrdup(Eperm);
		thdr.qid = f-&gt;qid;
		f-&gt;vde = nil;
		f-&gt;open = 1;
		return 0;
	}
	if(mode &amp; ORCLOSE)
		return vtstrdup(Erdonly);
	trunc = mode &amp; OTRUNC;
	mode &amp;= OPERM;
	if(mode==OWRITE || mode==ORDWR || trunc)
		if(!perm(f, Pwrite))
			return vtstrdup(Eperm);
	if(mode==OREAD || mode==ORDWR)
		if(!perm(f, Pread))
			return vtstrdup(Eperm);
	if(mode==OEXEC)
		if(!perm(f, Pexec))
			return vtstrdup(Eperm);
	thdr.qid = f-&gt;qid;
	thdr.iounit = messagesize - IOHDRSZ;
	f-&gt;open = 1;
	return 0;
}

char*
rcreate(Fid* fid)
{
	VacFile *vf;
	ulong mode;

	if(fid-&gt;open)
		return vtstrdup(Eisopen);
	if(!fid-&gt;busy)
		return vtstrdup(Enotexist);
	if(fs-&gt;mode &amp; ModeSnapshot)
		return vtstrdup(Erdonly);
	vf = fid-&gt;file;
	if(!vacfileisdir(vf))
		return vtstrdup(Enotdir);
	if(!permf(vf, fid-&gt;user, Pwrite))
		return vtstrdup(Eperm);

	mode = rhdr.perm &amp; 0777;

	if(rhdr.perm &amp; DMDIR){
		if((rhdr.mode &amp; OTRUNC) || (rhdr.perm &amp; DMAPPEND))
			return vtstrdup(Emode);
		switch(rhdr.mode &amp; OPERM){
		default:
			return vtstrdup(Emode);
		case OEXEC:
		case OREAD:
			break;
		case OWRITE:
		case ORDWR:
			return vtstrdup(Eperm);
		}
		mode |= ModeDir;
	}
	vf = vacfilecreate(vf, rhdr.name, mode);
	if(vf == nil) {
		char err[80];
		rerrstr(err, sizeof err);

		return vtstrdup(err);
	}

	vacfiledecref(fid-&gt;file);

	fid-&gt;file = vf;
	fid-&gt;qid.type = QTFILE;
	if(vacfileisdir(vf))
		fid-&gt;qid.type = QTDIR;
	fid-&gt;qid.vers = vacfilegetmcount(vf);
	fid-&gt;qid.path = vacfilegetid(vf);

	thdr.qid = fid-&gt;qid;
	thdr.iounit = messagesize - IOHDRSZ;

	return 0;
}

char*
rread(Fid *f)
{
	char *buf;
	vlong off;
	int cnt;
	VacFile *vf;
	char err[80];
	int n;

	if(!f-&gt;busy)
		return vtstrdup(Enotexist);
	vf = f-&gt;file;
	thdr.count = 0;
	off = rhdr.offset;
	buf = thdr.data;
	cnt = rhdr.count;
	if(f-&gt;qid.type &amp; QTDIR)
		n = vacdirread(f, buf, off, cnt);
	else if(vacfilegetmode(f-&gt;file)&amp;ModeDevice)
		return vtstrdup("device");
	else if(vacfilegetmode(f-&gt;file)&amp;ModeLink)
		return vtstrdup("symbolic link");
	else if(vacfilegetmode(f-&gt;file)&amp;ModeNamedPipe)
		return vtstrdup("named pipe");
	else
		n = vacfileread(vf, buf, cnt, off);
	if(n &lt; 0) {
		rerrstr(err, sizeof err);
		return vtstrdup(err);
	}
	thdr.count = n;
	return 0;
}

char*
rwrite(Fid *f)
{
	USED(f);
	return vtstrdup(Erdonly);
}

char *
rclunk(Fid *f)
{
	f-&gt;busy = 0;
	f-&gt;open = 0;
	vtfree(f-&gt;user);
	f-&gt;user = nil;
	if(f-&gt;file)
		vacfiledecref(f-&gt;file);
	f-&gt;file = nil;
	vdeclose(f-&gt;vde);
	f-&gt;vde = nil;
	return 0;
}

char *
rremove(Fid *f)
{
	VacFile *vf, *vfp;
	char errbuf[80];
	char *err = nil;

	if(!f-&gt;busy)
		return vtstrdup(Enotexist);
	vf = f-&gt;file;
	vfp = vacfilegetparent(vf);

	if(!permf(vfp, f-&gt;user, Pwrite)) {
		err = Eperm;
		goto Exit;
	}

	if(!vacfileremove(vf)) {
		rerrstr(errbuf, sizeof errbuf);
		err = errbuf;
	}

Exit:
	vacfiledecref(vfp);
	rclunk(f);
	return vtstrdup(err);
}

char *
rstat(Fid *f)
{
	VacDir dir;
	static uchar statbuf[1024];
	VacFile *parent;
	
	if(!f-&gt;busy)
		return vtstrdup(Enotexist);
	parent = vacfilegetparent(f-&gt;file);
	vacfilegetdir(f-&gt;file, &amp;dir);
	thdr.stat = statbuf;
	thdr.nstat = vacstat(parent, &amp;dir, thdr.stat, sizeof statbuf);
	vdcleanup(&amp;dir);
	vacfiledecref(parent);
	return 0;
}

char *
rwstat(Fid *f)
{
	if(!f-&gt;busy)
		return vtstrdup(Enotexist);
	return vtstrdup(Erdonly);
}

int
vacstat(VacFile *parent, VacDir *vd, uchar *p, int np)
{
	int ret;
	Dir dir;

	memset(&amp;dir, 0, sizeof(dir));

	dir.qid.path = vd-&gt;qid + vacfilegetqidoffset(parent);
	if(vd-&gt;qidspace)
		dir.qid.path += vd-&gt;qidoffset;
	dir.qid.vers = vd-&gt;mcount;
	dir.mode = vd-&gt;mode &amp; 0777;
	if(vd-&gt;mode &amp; ModeAppend){
		dir.qid.type |= QTAPPEND;
		dir.mode |= DMAPPEND;
	}
	if(vd-&gt;mode &amp; ModeExclusive){
		dir.qid.type |= QTEXCL;
		dir.mode |= DMEXCL;
	}
	if(vd-&gt;mode &amp; ModeDir){
		dir.qid.type |= QTDIR;
		dir.mode |= DMDIR;
	}
	
	
	dir.atime = vd-&gt;atime;
	dir.mtime = vd-&gt;mtime;
	dir.length = vd-&gt;size;

	dir.name = vd-&gt;elem;
	dir.uid = vd-&gt;uid;
	dir.gid = vd-&gt;gid;
	dir.muid = vd-&gt;mid;

	ret = convD2Mu(&amp;dir, p, np, dotu);
	return ret;
}

int
vacdirread(Fid *f, char *p, long off, long cnt)
{
	int i, n, nb;
	VacDir vd;

	/*
	 * special case of rewinding a directory
	 * otherwise ignore the offset
	 */
	if(off == 0 &amp;&amp; f-&gt;vde){
		vdeclose(f-&gt;vde);
		f-&gt;vde = nil;
	}

	if(f-&gt;vde == nil){
		f-&gt;vde = vdeopen(f-&gt;file);
		if(f-&gt;vde == nil)
			return -1;
	}

	for(nb = 0; nb &lt; cnt; nb += n) {
		i = vderead(f-&gt;vde, &amp;vd);
		if(i &lt; 0)
			return -1;
		if(i == 0)
			break;
		n = vacstat(f-&gt;file, &amp;vd, (uchar*)p, cnt-nb);
		if(n &lt;= BIT16SZ) {
			vdeunread(f-&gt;vde);
			break;
		}
		vdcleanup(&amp;vd);
		p += n;
	}
	return nb;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = vtmallocz(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = fids;
	fids = f;
	return f;
}

void
io(void)
{
	char *err;
	int n;

	for(;;){
		n = read9pmsg(mfd[0], mdata, sizeof mdata);
		if(n &lt;= 0)
			break;
		if(convM2Su(mdata, n, &amp;rhdr, dotu) != n)
			sysfatal("convM2S conversion error");

		if(dflag)
			fprint(2, "vacfs:&lt;-%F\n", &amp;rhdr);

		thdr.data = (char*)mdata + IOHDRSZ;
		if(!fcalls[rhdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[rhdr.type])(newfid(rhdr.fid));
		if(err){
			thdr.type = Rerror;
			thdr.ename = err;
		}else{
			thdr.type = rhdr.type + 1;
			thdr.fid = rhdr.fid;
		}
		thdr.tag = rhdr.tag;
		if(dflag)
			fprint(2, "vacfs:-&gt;%F\n", &amp;thdr);
		n = convS2Mu(&amp;thdr, mdata, messagesize, dotu);
		if(n &lt;= BIT16SZ)
			sysfatal("convS2Mu conversion error");
		if(err)
			vtfree(err);

		if(write(mfd[1], mdata, n) != n)
			sysfatal("mount write: %r");
	}
}

int
permf(VacFile *vf, char *user, int p)
{
	VacDir dir;
	ulong perm;

	if(vacfilegetdir(vf, &amp;dir))
		return 0;
	perm = dir.mode &amp; 0777;

	if(noperm)
		goto Good;
	if((p*Pother) &amp; perm)
		goto Good;
	if(strcmp(user, dir.gid)==0 &amp;&amp; ((p*Pgroup) &amp; perm))
		goto Good;
	if(strcmp(user, dir.uid)==0 &amp;&amp; ((p*Powner) &amp; perm))
		goto Good;
	vdcleanup(&amp;dir);
	return 0;
Good:
	vdcleanup(&amp;dir);
	return 1;
}

int
perm(Fid *f, int p)
{
	return permf(f-&gt;file, f-&gt;user, p);
}

void
vacshutdown(void)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next) {
		if(!f-&gt;busy)
			continue;
		rclunk(f);
	}

	vacfsclose(fs);
	vthangup(conn);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

