<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/arena.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/arena.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

typedef struct ASum ASum;

struct ASum
{
	Arena	*arena;
	ASum	*next;
};

static void	sealarena(Arena *arena);
static int	okarena(Arena *arena);
static int	loadarena(Arena *arena);
static CIBlock	*getcib(Arena *arena, int clump, int writing, CIBlock *rock);
static void	putcib(Arena *arena, CIBlock *cib);
static void	sumproc(void *);
static void loadcig(Arena *arena);

static QLock	sumlock;
static Rendez	sumwait;
static ASum	*sumq;
static ASum	*sumqtail;
static uchar zero[8192];

int	arenasumsleeptime;

int
initarenasum(void)
{
	needzeroscore();  /* OS X */

	sumwait.l = &amp;sumlock;

	if(vtproc(sumproc, nil) &lt; 0){
		seterr(EOk, "can't start arena checksum slave: %r");
		return -1;
	}
	return 0;
}

/*
 * make an Arena, and initialize it based upon the disk header and trailer.
 */
Arena*
initarena(Part *part, u64int base, u64int size, u32int blocksize)
{
	Arena *arena;

	arena = MKZ(Arena);
	arena-&gt;part = part;
	arena-&gt;blocksize = blocksize;
	arena-&gt;clumpmax = arena-&gt;blocksize / ClumpInfoSize;
	arena-&gt;base = base + blocksize;
	arena-&gt;size = size - 2 * blocksize;

	if(loadarena(arena) &lt; 0){
		seterr(ECorrupt, "arena header or trailer corrupted");
		freearena(arena);
		return nil;
	}
	if(okarena(arena) &lt; 0){
		freearena(arena);
		return nil;
	}

	if(arena-&gt;diskstats.sealed &amp;&amp; scorecmp(zeroscore, arena-&gt;score)==0)
		sealarena(arena);

	return arena;
}

void
freearena(Arena *arena)
{
	if(arena == nil)
		return;
	free(arena);
}

Arena*
newarena(Part *part, u32int vers, char *name, u64int base, u64int size, u32int blocksize)
{
	int bsize;
	Arena *arena;

	if(nameok(name) &lt; 0){
		seterr(EOk, "illegal arena name", name);
		return nil;
	}
	arena = MKZ(Arena);
	arena-&gt;part = part;
	arena-&gt;version = vers;
	if(vers == ArenaVersion4)
		arena-&gt;clumpmagic = _ClumpMagic;
	else{
		do
			arena-&gt;clumpmagic = fastrand();
		while(arena-&gt;clumpmagic==_ClumpMagic || arena-&gt;clumpmagic==0);
	}
	arena-&gt;blocksize = blocksize;
	arena-&gt;clumpmax = arena-&gt;blocksize / ClumpInfoSize;
	arena-&gt;base = base + blocksize;
	arena-&gt;size = size - 2 * blocksize;

	namecp(arena-&gt;name, name);

	bsize = sizeof zero;
	if(bsize &gt; arena-&gt;blocksize)
		bsize = arena-&gt;blocksize;

	if(wbarena(arena)&lt;0 || wbarenahead(arena)&lt;0
	|| writepart(arena-&gt;part, arena-&gt;base, zero, bsize)&lt;0){
		freearena(arena);
		return nil;
	}

	return arena;
}

int
readclumpinfo(Arena *arena, int clump, ClumpInfo *ci)
{
	CIBlock *cib, r;

	cib = getcib(arena, clump, 0, &amp;r);
	if(cib == nil)
		return -1;
	unpackclumpinfo(ci, &amp;cib-&gt;data-&gt;data[cib-&gt;offset]);
	putcib(arena, cib);
	return 0;
}

int
readclumpinfos(Arena *arena, int clump, ClumpInfo *cis, int n)
{
	CIBlock *cib, r;
	int i;

	/*
	 * because the clump blocks are laid out
	 * in reverse order at the end of the arena,
	 * it can be a few percent faster to read
	 * the clumps backwards, which reads the
	 * disk blocks forwards.
	 */
	for(i = n-1; i &gt;= 0; i--){
		cib = getcib(arena, clump + i, 0, &amp;r);
		if(cib == nil){
			n = i;
			continue;
		}
		unpackclumpinfo(&amp;cis[i], &amp;cib-&gt;data-&gt;data[cib-&gt;offset]);
		putcib(arena, cib);
	}
	return n;
}

/*
 * write directory information for one clump
 * must be called the arena locked
 */
int
writeclumpinfo(Arena *arena, int clump, ClumpInfo *ci)
{
	CIBlock *cib, r;

	cib = getcib(arena, clump, 1, &amp;r);
	if(cib == nil)
		return -1;
	dirtydblock(cib-&gt;data, DirtyArenaCib);
	packclumpinfo(ci, &amp;cib-&gt;data-&gt;data[cib-&gt;offset]);
	putcib(arena, cib);
	return 0;
}

u64int
arenadirsize(Arena *arena, u32int clumps)
{
	return ((clumps / arena-&gt;clumpmax) + 1) * arena-&gt;blocksize;
}

/*
 * read a clump of data
 * n is a hint of the size of the data, not including the header
 * make sure it won't run off the end, then return the number of bytes actually read
 */
u32int
readarena(Arena *arena, u64int aa, u8int *buf, long n)
{
	DBlock *b;
	u64int a;
	u32int blocksize, off, m;
	long nn;

	if(n == 0)
		return -1;

	qlock(&amp;arena-&gt;lock);
	a = arena-&gt;size - arenadirsize(arena, arena-&gt;memstats.clumps);
	qunlock(&amp;arena-&gt;lock);
	if(aa &gt;= a){
		seterr(EOk, "reading beyond arena clump storage: clumps=%d aa=%lld a=%lld -1 clumps=%lld\n", arena-&gt;memstats.clumps, aa, a, arena-&gt;size - arenadirsize(arena, arena-&gt;memstats.clumps - 1));
		return -1;
	}
	if(aa + n &gt; a)
		n = a - aa;

	blocksize = arena-&gt;blocksize;
	a = arena-&gt;base + aa;
	off = a &amp; (blocksize - 1);
	a -= off;
	nn = 0;
	for(;;){
		b = getdblock(arena-&gt;part, a, OREAD);
		if(b == nil)
			return -1;
		m = blocksize - off;
		if(m &gt; n - nn)
			m = n - nn;
		memmove(&amp;buf[nn], &amp;b-&gt;data[off], m);
		putdblock(b);
		nn += m;
		if(nn == n)
			break;
		off = 0;
		a += blocksize;
	}
	return n;
}

/*
 * write some data to the clump section at a given offset
 * used to fix up corrupted arenas.
 */
u32int
writearena(Arena *arena, u64int aa, u8int *clbuf, u32int n)
{
	DBlock *b;
	u64int a;
	u32int blocksize, off, m;
	long nn;
	int ok;

	if(n == 0)
		return -1;

	qlock(&amp;arena-&gt;lock);
	a = arena-&gt;size - arenadirsize(arena, arena-&gt;memstats.clumps);
	if(aa &gt;= a || aa + n &gt; a){
		qunlock(&amp;arena-&gt;lock);
		seterr(EOk, "writing beyond arena clump storage");
		return -1;
	}

	blocksize = arena-&gt;blocksize;
	a = arena-&gt;base + aa;
	off = a &amp; (blocksize - 1);
	a -= off;
	nn = 0;
	for(;;){
		b = getdblock(arena-&gt;part, a, off != 0 || off + n &lt; blocksize ? ORDWR : OWRITE);
		if(b == nil){
			qunlock(&amp;arena-&gt;lock);
			return -1;
		}
		dirtydblock(b, DirtyArena);
		m = blocksize - off;
		if(m &gt; n - nn)
			m = n - nn;
		memmove(&amp;b-&gt;data[off], &amp;clbuf[nn], m);
		ok = 0;
		putdblock(b);
		if(ok &lt; 0){
			qunlock(&amp;arena-&gt;lock);
			return -1;
		}
		nn += m;
		if(nn == n)
			break;
		off = 0;
		a += blocksize;
	}
	qunlock(&amp;arena-&gt;lock);
	return n;
}

/*
 * allocate space for the clump and write it,
 * updating the arena directory
ZZZ question: should this distinguish between an arena
filling up and real errors writing the clump?
 */
u64int
writeaclump(Arena *arena, Clump *c, u8int *clbuf)
{
	DBlock *b;
	u64int a, aa;
	u32int clump, n, nn, m, off, blocksize;
	int ok;

	n = c-&gt;info.size + ClumpSize + U32Size;
	qlock(&amp;arena-&gt;lock);
	aa = arena-&gt;memstats.used;
	if(arena-&gt;memstats.sealed
	|| aa + n + U32Size + arenadirsize(arena, arena-&gt;memstats.clumps + 1) &gt; arena-&gt;size){
		if(!arena-&gt;memstats.sealed){
			logerr(EOk, "seal memstats %s", arena-&gt;name);
			arena-&gt;memstats.sealed = 1;
			wbarena(arena);
		}
		qunlock(&amp;arena-&gt;lock);
		return TWID64;
	}
	if(packclump(c, &amp;clbuf[0], arena-&gt;clumpmagic) &lt; 0){
		qunlock(&amp;arena-&gt;lock);
		return TWID64;
	}

	/*
	 * write the data out one block at a time
	 */
	blocksize = arena-&gt;blocksize;
	a = arena-&gt;base + aa;
	off = a &amp; (blocksize - 1);
	a -= off;
	nn = 0;
	for(;;){
		b = getdblock(arena-&gt;part, a, off != 0 ? ORDWR : OWRITE);
		if(b == nil){
			qunlock(&amp;arena-&gt;lock);
			return TWID64;
		}
		dirtydblock(b, DirtyArena);
		m = blocksize - off;
		if(m &gt; n - nn)
			m = n - nn;
		memmove(&amp;b-&gt;data[off], &amp;clbuf[nn], m);
		ok = 0;
		putdblock(b);
		if(ok &lt; 0){
			qunlock(&amp;arena-&gt;lock);
			return TWID64;
		}
		nn += m;
		if(nn == n)
			break;
		off = 0;
		a += blocksize;
	}

	arena-&gt;memstats.used += c-&gt;info.size + ClumpSize;
	arena-&gt;memstats.uncsize += c-&gt;info.uncsize;
	if(c-&gt;info.size &lt; c-&gt;info.uncsize)
		arena-&gt;memstats.cclumps++;

	clump = arena-&gt;memstats.clumps;
	if(clump % ArenaCIGSize == 0){
		if(arena-&gt;cig == nil){
			loadcig(arena);
			if(arena-&gt;cig == nil)
				goto NoCIG;
		}
		/* add aa as start of next cig */
		if(clump/ArenaCIGSize != arena-&gt;ncig){
			fprint(2, "bad arena cig computation %s: writing clump %d but %d cigs\n",
				arena-&gt;name, clump, arena-&gt;ncig);
			arena-&gt;ncig = -1;
			vtfree(arena-&gt;cig);
			arena-&gt;cig = nil;
			goto NoCIG;
		}
		arena-&gt;cig = vtrealloc(arena-&gt;cig, (arena-&gt;ncig+1)*sizeof arena-&gt;cig[0]);
		arena-&gt;cig[arena-&gt;ncig++].offset = aa;
	}
NoCIG:
	arena-&gt;memstats.clumps++;

	if(arena-&gt;memstats.clumps == 0)
		sysfatal("clumps wrapped");
	arena-&gt;wtime = now();
	if(arena-&gt;ctime == 0)
		arena-&gt;ctime = arena-&gt;wtime;

	writeclumpinfo(arena, clump, &amp;c-&gt;info);
	wbarena(arena);

	qunlock(&amp;arena-&gt;lock);

	return aa;
}

int
atailcmp(ATailStats *a, ATailStats *b)
{
	/* good test */
	if(a-&gt;used &lt; b-&gt;used)
		return -1;
	if(a-&gt;used &gt; b-&gt;used)
		return 1;
		
	/* suspect tests - why order this way? (no one cares) */
	if(a-&gt;clumps &lt; b-&gt;clumps)
		return -1;
	if(a-&gt;clumps &gt; b-&gt;clumps)
		return 1;
	if(a-&gt;cclumps &lt; b-&gt;cclumps)
		return -1;
	if(a-&gt;cclumps &gt; b-&gt;cclumps)
		return 1;
	if(a-&gt;uncsize &lt; b-&gt;uncsize)
		return -1;
	if(a-&gt;uncsize &gt; b-&gt;uncsize)
		return 1;
	if(a-&gt;sealed &lt; b-&gt;sealed)
		return -1;
	if(a-&gt;sealed &gt; b-&gt;sealed)
		return 1;
		
	/* everything matches */
	return 0;
}

void
setatailstate(AState *as)
{
	int i, j, osealed;
	Arena *a;
	Index *ix;

	trace(0, "setatailstate %s 0x%llux clumps %d", as-&gt;arena-&gt;name, as-&gt;aa, as-&gt;stats.clumps);

	/*
	 * Look up as-&gt;arena to find index.
	 */
	needmainindex();	/* OS X linker */
	ix = mainindex;
	for(i=0; i&lt;ix-&gt;narenas; i++)
		if(ix-&gt;arenas[i] == as-&gt;arena)
			break;
	if(i==ix-&gt;narenas || as-&gt;aa &lt; ix-&gt;amap[i].start || as-&gt;aa &gt;= ix-&gt;amap[i].stop || as-&gt;arena != ix-&gt;arenas[i]){
		fprint(2, "funny settailstate 0x%llux\n", as-&gt;aa);
		return;
	}

	for(j=0; j&lt;=i; j++){
		a = ix-&gt;arenas[j];
		if(atailcmp(&amp;a-&gt;diskstats, &amp;a-&gt;memstats) == 0)
			continue;
		qlock(&amp;a-&gt;lock);
		osealed = a-&gt;diskstats.sealed;
		if(j == i)
			a-&gt;diskstats = as-&gt;stats;
		else
			a-&gt;diskstats = a-&gt;memstats;
		wbarena(a);
		if(a-&gt;diskstats.sealed != osealed &amp;&amp; !a-&gt;inqueue)
			sealarena(a);
		qunlock(&amp;a-&gt;lock);
	}
}

/*
 * once sealed, an arena never has any data added to it.
 * it should only be changed to fix errors.
 * this also syncs the clump directory.
 */
static void
sealarena(Arena *arena)
{
	arena-&gt;inqueue = 1;
	backsumarena(arena);
}

void
backsumarena(Arena *arena)
{
	ASum *as;

	if(sumwait.l == nil)
		return;

	as = MK(ASum);
	if(as == nil)
		return;
	qlock(&amp;sumlock);
	as-&gt;arena = arena;
	as-&gt;next = nil;
	if(sumq)
		sumqtail-&gt;next = as;
	else
		sumq = as;
	sumqtail = as;
	rwakeup(&amp;sumwait);
	qunlock(&amp;sumlock);
}

static void
sumproc(void *unused)
{
	ASum *as;
	Arena *arena;

	USED(unused);

	for(;;){
		qlock(&amp;sumlock);
		while(sumq == nil)
			rsleep(&amp;sumwait);
		as = sumq;
		sumq = as-&gt;next;
		qunlock(&amp;sumlock);
		arena = as-&gt;arena;
		free(as);

		sumarena(arena);
	}
}

void
sumarena(Arena *arena)
{
	ZBlock *b;
	DigestState s;
	u64int a, e;
	u32int bs;
	int t;
	u8int score[VtScoreSize];

	bs = MaxIoSize;
	if(bs &lt; arena-&gt;blocksize)
		bs = arena-&gt;blocksize;

	/*
	 * read &amp; sum all blocks except the last one
	 */
	flushdcache();
	memset(&amp;s, 0, sizeof s);
	b = alloczblock(bs, 0, arena-&gt;part-&gt;blocksize);
	e = arena-&gt;base + arena-&gt;size;
	for(a = arena-&gt;base - arena-&gt;blocksize; a + arena-&gt;blocksize &lt;= e; a += bs){
		disksched();
		while((t=arenasumsleeptime) == SleepForever){
			sleep(1000);
			disksched();
		}
		sleep(t);
		if(a + bs &gt; e)
			bs = arena-&gt;blocksize;
		if(readpart(arena-&gt;part, a, b-&gt;data, bs) &lt; 0)
			goto ReadErr;
		addstat(StatSumRead, 1);
		addstat(StatSumReadBytes, bs);
		sha1(b-&gt;data, bs, nil, &amp;s);
	}

	/*
	 * the last one is special, since it may already have the checksum included
	 */
	bs = arena-&gt;blocksize;
	if(readpart(arena-&gt;part, e, b-&gt;data, bs) &lt; 0){
ReadErr:
		logerr(EOk, "sumarena can't sum %s, read at %lld failed: %r", arena-&gt;name, a);
		freezblock(b);
		return;
	}
	addstat(StatSumRead, 1);
	addstat(StatSumReadBytes, bs);

	sha1(b-&gt;data, bs-VtScoreSize, nil, &amp;s);
	sha1(zeroscore, VtScoreSize, nil, &amp;s);
	sha1(nil, 0, score, &amp;s);
	
	/*
	 * check for no checksum or the same
	 */
	if(scorecmp(score, &amp;b-&gt;data[bs - VtScoreSize]) != 0
	&amp;&amp; scorecmp(zeroscore, &amp;b-&gt;data[bs - VtScoreSize]) != 0)
		logerr(EOk, "overwriting mismatched checksums for arena=%s, found=%V calculated=%V",
			arena-&gt;name, &amp;b-&gt;data[bs - VtScoreSize], score);
	freezblock(b);

	qlock(&amp;arena-&gt;lock);
	scorecp(arena-&gt;score, score);
	wbarena(arena);
	qunlock(&amp;arena-&gt;lock);
}

/*
 * write the arena trailer block to the partition
 */
int
wbarena(Arena *arena)
{
	DBlock *b;
	int bad;

	if((b = getdblock(arena-&gt;part, arena-&gt;base + arena-&gt;size, OWRITE)) == nil){
		logerr(EAdmin, "can't write arena trailer: %r");
		return -1;
	}
	dirtydblock(b, DirtyArenaTrailer);
	bad = okarena(arena)&lt;0 || packarena(arena, b-&gt;data)&lt;0;
	scorecp(b-&gt;data + arena-&gt;blocksize - VtScoreSize, arena-&gt;score);
	putdblock(b);
	if(bad)
		return -1;
	return 0;
}

int
wbarenahead(Arena *arena)
{
	ZBlock *b;
	ArenaHead head;
	int bad;

	namecp(head.name, arena-&gt;name);
	head.version = arena-&gt;version;
	head.size = arena-&gt;size + 2 * arena-&gt;blocksize;
	head.blocksize = arena-&gt;blocksize;
	head.clumpmagic = arena-&gt;clumpmagic;
	b = alloczblock(arena-&gt;blocksize, 1, arena-&gt;part-&gt;blocksize);
	if(b == nil){
		logerr(EAdmin, "can't write arena header: %r");
/* ZZZ add error message? */
		return -1;
	}
	/*
	 * this writepart is okay because it only happens
	 * during initialization.
	 */
	bad = packarenahead(&amp;head, b-&gt;data)&lt;0 ||
	      writepart(arena-&gt;part, arena-&gt;base - arena-&gt;blocksize, b-&gt;data, arena-&gt;blocksize)&lt;0 ||
	      flushpart(arena-&gt;part)&lt;0;
	freezblock(b);
	if(bad)
		return -1;
	return 0;
}

/*
 * read the arena header and trailer blocks from disk
 */
static int
loadarena(Arena *arena)
{
	ArenaHead head;
	ZBlock *b;

	b = alloczblock(arena-&gt;blocksize, 0, arena-&gt;part-&gt;blocksize);
	if(b == nil)
		return -1;
	if(readpart(arena-&gt;part, arena-&gt;base + arena-&gt;size, b-&gt;data, arena-&gt;blocksize) &lt; 0){
		freezblock(b);
		return -1;
	}
	if(unpackarena(arena, b-&gt;data) &lt; 0){
		freezblock(b);
		return -1;
	}
	if(arena-&gt;version != ArenaVersion4 &amp;&amp; arena-&gt;version != ArenaVersion5){
		seterr(EAdmin, "unknown arena version %d", arena-&gt;version);
		freezblock(b);
		return -1;
	}
	scorecp(arena-&gt;score, &amp;b-&gt;data[arena-&gt;blocksize - VtScoreSize]);

	if(readpart(arena-&gt;part, arena-&gt;base - arena-&gt;blocksize, b-&gt;data, arena-&gt;blocksize) &lt; 0){
		logerr(EAdmin, "can't read arena header: %r");
		freezblock(b);
		return 0;
	}
	if(unpackarenahead(&amp;head, b-&gt;data) &lt; 0)
		logerr(ECorrupt, "corrupted arena header: %r");
	else if(namecmp(arena-&gt;name, head.name)!=0
	     || arena-&gt;clumpmagic != head.clumpmagic
	     || arena-&gt;version != head.version
	     || arena-&gt;blocksize != head.blocksize
	     || arena-&gt;size + 2 * arena-&gt;blocksize != head.size){
		if(namecmp(arena-&gt;name, head.name)!=0)
			logerr(ECorrupt, "arena tail name %s head %s", 
				arena-&gt;name, head.name);
		else if(arena-&gt;clumpmagic != head.clumpmagic)
			logerr(ECorrupt, "arena %d tail clumpmagic 0x%lux head 0x%lux",
				debugarena, (ulong)arena-&gt;clumpmagic,
				(ulong)head.clumpmagic);
		else if(arena-&gt;version != head.version)
			logerr(ECorrupt, "arena tail version %d head version %d",
				arena-&gt;version, head.version);
		else if(arena-&gt;blocksize != head.blocksize)
			logerr(ECorrupt, "arena tail block size %d head %d",
				arena-&gt;blocksize, head.blocksize);
		else if(arena-&gt;size+2*arena-&gt;blocksize != head.size)
			logerr(ECorrupt, "arena tail size %lud head %lud",
				(ulong)arena-&gt;size+2*arena-&gt;blocksize, head.size);
		else
			logerr(ECorrupt, "arena header inconsistent with arena data");
	}
	freezblock(b);

	return 0;
}

static int
okarena(Arena *arena)
{
	u64int dsize;
	int ok;

	ok = 0;
	dsize = arenadirsize(arena, arena-&gt;diskstats.clumps);
	if(arena-&gt;diskstats.used + dsize &gt; arena-&gt;size){
		seterr(ECorrupt, "arena %s used &gt; size", arena-&gt;name);
		ok = -1;
	}

	if(arena-&gt;diskstats.cclumps &gt; arena-&gt;diskstats.clumps)
		logerr(ECorrupt, "arena %s has more compressed clumps than total clumps", arena-&gt;name);

	/*
	 * This need not be true if some of the disk is corrupted.
	 *
	if(arena-&gt;diskstats.uncsize + arena-&gt;diskstats.clumps * ClumpSize + arena-&gt;blocksize &lt; arena-&gt;diskstats.used)
		logerr(ECorrupt, "arena %s uncompressed size inconsistent with used space %lld %d %lld", arena-&gt;name, arena-&gt;diskstats.uncsize, arena-&gt;diskstats.clumps, arena-&gt;diskstats.used);
	 */

	/*
	 * this happens; it's harmless.
	 *
	if(arena-&gt;ctime &gt; arena-&gt;wtime)
		logerr(ECorrupt, "arena %s creation time after last write time", arena-&gt;name);
	 */
	return ok;
}

static CIBlock*
getcib(Arena *arena, int clump, int writing, CIBlock *rock)
{
	int mode;
	CIBlock *cib;
	u32int block, off;

	if(clump &gt;= arena-&gt;memstats.clumps){
		seterr(EOk, "clump directory access out of range");
		return nil;
	}
	block = clump / arena-&gt;clumpmax;
	off = (clump - block * arena-&gt;clumpmax) * ClumpInfoSize;
	cib = rock;
	cib-&gt;block = block;
	cib-&gt;offset = off;

	if(writing){
		if(off == 0 &amp;&amp; clump == arena-&gt;memstats.clumps-1)
			mode = OWRITE;
		else
			mode = ORDWR;
	}else
		mode = OREAD;

	cib-&gt;data = getdblock(arena-&gt;part,
		arena-&gt;base + arena-&gt;size - (block + 1) * arena-&gt;blocksize, mode);
	if(cib-&gt;data == nil)
		return nil;
	return cib;
}

static void
putcib(Arena *arena, CIBlock *cib)
{
	USED(arena);

	putdblock(cib-&gt;data);
	cib-&gt;data = nil;
}


/*
 * For index entry readahead purposes, the arenas are 
 * broken into smaller subpieces, called clump info groups
 * or cigs.  Each cig has ArenaCIGSize clumps (ArenaCIGSize
 * is chosen to make the index entries take up about half
 * a megabyte).  The index entries do not contain enough
 * information to determine what the clump index is for
 * a given address in an arena.  That info is needed both for
 * figuring out which clump group an address belongs to 
 * and for prefetching a clump group's index entries from
 * the arena table of contents.  The first time clump groups
 * are accessed, we scan the entire arena table of contents
 * (which might be 10s of megabytes), recording the data 
 * offset of each clump group.
 */

/* 
 * load clump info group information by scanning entire toc.
 */
static void
loadcig(Arena *arena)
{
	u32int i, j, ncig, nci;
	ArenaCIG *cig;
	ClumpInfo *ci;
	u64int offset;
	int ms;

	if(arena-&gt;cig || arena-&gt;ncig &lt; 0)
		return;

//	fprint(2, "loadcig %s\n", arena-&gt;name);
	
	ncig = (arena-&gt;memstats.clumps+ArenaCIGSize-1) / ArenaCIGSize;
	if(ncig == 0){
		arena-&gt;cig = vtmalloc(1);
		arena-&gt;ncig = 0;
		return;
	}

	ms = msec();
	cig = vtmalloc(ncig*sizeof cig[0]);
	ci = vtmalloc(ArenaCIGSize*sizeof ci[0]);
	offset = 0;
	for(i=0; i&lt;ncig; i++){
		nci = readclumpinfos(arena, i*ArenaCIGSize, ci, ArenaCIGSize);
		cig[i].offset = offset;
		for(j=0; j&lt;nci; j++)
			offset += ClumpSize + ci[j].size;
		if(nci &lt; ArenaCIGSize){
			if(i != ncig-1){
				vtfree(ci);
				vtfree(cig);
				arena-&gt;ncig = -1;
				fprint(2, "loadcig %s: got %ud cigs, expected %ud\n", arena-&gt;name, i+1, ncig);
				goto out;
			}
		}
	}
	vtfree(ci);
	
	arena-&gt;ncig = ncig;
	arena-&gt;cig = cig;

out:
	ms = msec() - ms;
	addstat2(StatCigLoad, 1, StatCigLoadTime, ms);
}

/*
 * convert arena address into arena group + data boundaries.
 */
int
arenatog(Arena *arena, u64int addr, u64int *gstart, u64int *glimit, int *g)
{
	int r, l, m;

	qlock(&amp;arena-&gt;lock);
	if(arena-&gt;cig == nil)
		loadcig(arena);
	if(arena-&gt;cig == nil || arena-&gt;ncig == 0){
		qunlock(&amp;arena-&gt;lock);
		return -1;
	}

	l = 1;
	r = arena-&gt;ncig - 1;
	while(l &lt;= r){
		m = (r + l) / 2;
		if(arena-&gt;cig[m].offset &lt;= addr)
			l = m + 1;
		else
			r = m - 1;
	}
	l--;

	*g = l;
	*gstart = arena-&gt;cig[l].offset;
	if(l+1 &lt; arena-&gt;ncig)
		*glimit = arena-&gt;cig[l+1].offset;
	else
		*glimit = arena-&gt;memstats.used;
	qunlock(&amp;arena-&gt;lock);
	return 0;
}

/*
 * load the clump info for group g into the index entries.
 */
int
asumload(Arena *arena, int g, IEntry *entries, int nentries)
{
	int i, base, limit;
	u64int addr;
	ClumpInfo ci;
	IEntry *ie;

	if(nentries &lt; ArenaCIGSize){
		fprint(2, "asking for too few entries\n");
		return -1;
	}
	
	qlock(&amp;arena-&gt;lock);
	if(arena-&gt;cig == nil)
		loadcig(arena);
	if(arena-&gt;cig == nil || arena-&gt;ncig == 0 || g &gt;= arena-&gt;ncig){
		qunlock(&amp;arena-&gt;lock);
		return -1;
	}
	
	addr = 0;
	base = g*ArenaCIGSize;
	limit = base + ArenaCIGSize;
	if(base &gt; arena-&gt;memstats.clumps)
		base = arena-&gt;memstats.clumps;
	ie = entries;
	for(i=base; i&lt;limit; i++){
		if(readclumpinfo(arena, i, &amp;ci) &lt; 0)
			break;
		if(ci.type != VtCorruptType){
			scorecp(ie-&gt;score, ci.score);
			ie-&gt;ia.type = ci.type;
			ie-&gt;ia.size = ci.uncsize;
			ie-&gt;ia.blocks = (ci.size + ClumpSize + (1&lt;&lt;ABlockLog) - 1) &gt;&gt; ABlockLog;
			ie-&gt;ia.addr = addr;
			ie++;
		}
		addr += ClumpSize + ci.size;
	}
	qunlock(&amp;arena-&gt;lock);
	return ie - entries;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

