<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/arenas.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/arenas.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

typedef struct AHash	AHash;

/*
 * hash table for finding arena's based on their names.
 */
struct AHash
{
	AHash	*next;
	Arena	*arena;
};

enum
{
	AHashSize	= 512,
	Emergency	= 0,		/* flag: performing emergency surgery */
};

static AHash	*ahash[AHashSize];

static u32int
hashstr(char *s)
{
	u32int h;
	int c;

	h = 0;
	for(; c = *s; s++){
		c ^= c &lt;&lt; 6;
		h += (c &lt;&lt; 11) ^ (c &gt;&gt; 1);
		c = *s;
		h ^= (c &lt;&lt; 14) + (c &lt;&lt; 7) + (c &lt;&lt; 4) + c;
	}
	return h;
}

int
addarena(Arena *arena)
{
	AHash *a;
	u32int h;

	h = hashstr(arena-&gt;name) &amp; (AHashSize - 1);
	a = MK(AHash);
	if(a == nil)
		return -1;
	a-&gt;arena = arena;
	a-&gt;next = ahash[h];
	ahash[h] = a;
	return 0;
}

Arena*
findarena(char *name)
{
	AHash *a;
	u32int h;

	h = hashstr(name) &amp; (AHashSize - 1);
	for(a = ahash[h]; a != nil; a = a-&gt;next)
		if(strcmp(a-&gt;arena-&gt;name, name) == 0)
			return a-&gt;arena;
	return nil;
}

int
delarena(Arena *arena)
{
	AHash *a, *last;
	u32int h;

	h = hashstr(arena-&gt;name) &amp; (AHashSize - 1);
	last = nil;
	for(a = ahash[h]; a != nil; a = a-&gt;next){
		if(a-&gt;arena == arena){
			if(last != nil)
				last-&gt;next = a-&gt;next;
			else
				ahash[h] = a-&gt;next;
			free(a);
			return 0;
		}
		last = a;
	}
	return -1;
}

ArenaPart*
initarenapart(Part *part)
{
	AMapN amn;
	ArenaPart *ap;
	ZBlock *b;
	u32int i;
	int ok;

	b = alloczblock(HeadSize, 0, 0);
	if(b == nil || readpart(part, PartBlank, b-&gt;data, HeadSize) &lt; 0){
		seterr(EAdmin, "can't read arena partition header: %r");
		return nil;
	}

	ap = MKZ(ArenaPart);
	if(ap == nil){
		freezblock(b);
		return nil;
	}
	ap-&gt;part = part;
	ok = unpackarenapart(ap, b-&gt;data);
	freezblock(b);
	if(ok &lt; 0){
		freearenapart(ap, 0);
		return nil;
	}

	ap-&gt;tabbase = (PartBlank + HeadSize + ap-&gt;blocksize - 1) &amp; ~(ap-&gt;blocksize - 1);
	if(ap-&gt;version != ArenaPartVersion){
		seterr(ECorrupt, "unknown arena partition version %d", ap-&gt;version);
		freearenapart(ap, 0);
		return nil;
	}
	if(ap-&gt;blocksize &amp; (ap-&gt;blocksize - 1)){
		seterr(ECorrupt, "illegal non-power-of-2 block size %d\n", ap-&gt;blocksize);
		freearenapart(ap, 0);
		return nil;
	}
	if(ap-&gt;tabbase &gt;= ap-&gt;arenabase){
		seterr(ECorrupt, "arena partition table overlaps with arena storage");
		freearenapart(ap, 0);
		return nil;
	}
	ap-&gt;tabsize = ap-&gt;arenabase - ap-&gt;tabbase;
	partblocksize(part, ap-&gt;blocksize);
	ap-&gt;size = ap-&gt;part-&gt;size &amp; ~(u64int)(ap-&gt;blocksize - 1);

	if(readarenamap(&amp;amn, part, ap-&gt;tabbase, ap-&gt;tabsize) &lt; 0){
		freearenapart(ap, 0);
		return nil;
	}
	ap-&gt;narenas = amn.n;
	ap-&gt;map = amn.map;
	if(okamap(ap-&gt;map, ap-&gt;narenas, ap-&gt;arenabase, ap-&gt;size, "arena table") &lt; 0){
		if(!Emergency){
			freearenapart(ap, 0);
			return nil;
		}
		/* else keep on, for emergency use */
	}

	ap-&gt;arenas = MKNZ(Arena*, ap-&gt;narenas);
	for(i = 0; i &lt; ap-&gt;narenas; i++){
		debugarena = i;
		ap-&gt;arenas[i] = initarena(part, ap-&gt;map[i].start, ap-&gt;map[i].stop - ap-&gt;map[i].start, ap-&gt;blocksize);
		if(ap-&gt;arenas[i] == nil){
			seterr(ECorrupt, "%s: %r", ap-&gt;map[i].name);
			if(!Emergency){
				freearenapart(ap, 1);
				return nil;
			}else{
				/* keep on, for emergency use */
				ap-&gt;narenas = i;
				break;
			}
		}
		if(namecmp(ap-&gt;map[i].name, ap-&gt;arenas[i]-&gt;name) != 0){
			seterr(ECorrupt, "arena name mismatches with expected name: %s vs. %s",
				ap-&gt;map[i].name, ap-&gt;arenas[i]-&gt;name);
			freearenapart(ap, 1);
			return nil;
		}
		if(findarena(ap-&gt;arenas[i]-&gt;name)){
			seterr(ECorrupt, "duplicate arena name %s in %s",
				ap-&gt;map[i].name, ap-&gt;part-&gt;name);
			freearenapart(ap, 1);
			return nil;
		}
	}

	for(i = 0; i &lt; ap-&gt;narenas; i++) {
		debugarena = i;
		addarena(ap-&gt;arenas[i]);
	}
	debugarena = -1;

	return ap;
}

ArenaPart*
newarenapart(Part *part, u32int blocksize, u32int tabsize)
{
	ArenaPart *ap;

	if(blocksize &amp; (blocksize - 1)){
		seterr(ECorrupt, "illegal non-power-of-2 block size %d\n", blocksize);
		return nil;
	}
	ap = MKZ(ArenaPart);
	if(ap == nil)
		return nil;

	ap-&gt;version = ArenaPartVersion;
	ap-&gt;part = part;
	ap-&gt;blocksize = blocksize;
	partblocksize(part, blocksize);
	ap-&gt;size = part-&gt;size &amp; ~(u64int)(blocksize - 1);
	ap-&gt;tabbase = (PartBlank + HeadSize + blocksize - 1) &amp; ~(blocksize - 1);
	ap-&gt;arenabase = (ap-&gt;tabbase + tabsize + blocksize - 1) &amp; ~(blocksize - 1);
	ap-&gt;tabsize = ap-&gt;arenabase - ap-&gt;tabbase;
	ap-&gt;narenas = 0;

	if(wbarenapart(ap) &lt; 0){
		freearenapart(ap, 0);
		return nil;
	}

	return ap;
}

int
wbarenapart(ArenaPart *ap)
{
	ZBlock *b;

	if(okamap(ap-&gt;map, ap-&gt;narenas, ap-&gt;arenabase, ap-&gt;size, "arena table") &lt; 0)
		return -1;
	b = alloczblock(HeadSize, 1, 0);
	if(b == nil)
/* ZZZ set error message? */
		return -1;

	if(packarenapart(ap, b-&gt;data) &lt; 0){
		seterr(ECorrupt, "can't make arena partition header: %r");
		freezblock(b);
		return -1;
	}
	if(writepart(ap-&gt;part, PartBlank, b-&gt;data, HeadSize) &lt; 0 ||
	   flushpart(ap-&gt;part) &lt; 0){
		seterr(EAdmin, "can't write arena partition header: %r");
		freezblock(b);
		return -1;
	}
	freezblock(b);

	return wbarenamap(ap-&gt;map, ap-&gt;narenas, ap-&gt;part, ap-&gt;tabbase, ap-&gt;tabsize);
}

void
freearenapart(ArenaPart *ap, int freearenas)
{
	int i;

	if(ap == nil)
		return;
	if(freearenas){
		for(i = 0; i &lt; ap-&gt;narenas; i++){
			if(ap-&gt;arenas[i] == nil)
				continue;
			delarena(ap-&gt;arenas[i]);
			freearena(ap-&gt;arenas[i]);
		}
	}
	free(ap-&gt;map);
	free(ap-&gt;arenas);
	free(ap);
}

int
okamap(AMap *am, int n, u64int start, u64int stop, char *what)
{
	u64int last;
	u32int i;

	last = start;
	for(i = 0; i &lt; n; i++){
		if(am[i].start &lt; last){
			if(i == 0)
				seterr(ECorrupt, "invalid start address in %s", what);
			else
				seterr(ECorrupt, "overlapping ranges in %s", what);
			return -1;
		}
		if(am[i].stop &lt; am[i].start){
			seterr(ECorrupt, "invalid range in %s", what);
			return -1;
		}
		last = am[i].stop;
	}
	if(last &gt; stop){
		seterr(ECorrupt, "invalid ending address in %s", what);
		return -1;
	}
	return 0;
}

int
maparenas(AMap *am, Arena **arenas, int n, char *what)
{
	u32int i;

	for(i = 0; i &lt; n; i++){
		arenas[i] = findarena(am[i].name);
		if(arenas[i] == nil){
			seterr(EAdmin, "can't find arena '%s' for '%s'\n", am[i].name, what);
			return -1;
		}
	}
	return 0;
}

int
readarenamap(AMapN *amn, Part *part, u64int base, u32int size)
{
	IFile f;
	u32int ok;

	if(partifile(&amp;f, part, base, size) &lt; 0)
		return -1;
	ok = parseamap(&amp;f, amn);
	freeifile(&amp;f);
	return ok;
}

int
wbarenamap(AMap *am, int n, Part *part, u64int base, u64int size)
{
	Fmt f;
	ZBlock *b;

	b = alloczblock(size, 1, part-&gt;blocksize);
	if(b == nil)
		return -1;

	fmtzbinit(&amp;f, b);

	if(outputamap(&amp;f, am, n) &lt; 0){
		seterr(ECorrupt, "arena set size too small");
		freezblock(b);
		return -1;
	}
	if(writepart(part, base, b-&gt;data, size) &lt; 0 || flushpart(part) &lt; 0){
		seterr(EAdmin, "can't write arena set: %r");
		freezblock(b);
		return -1;
	}
	freezblock(b);
	return 0;
}

/*
 * amap: n '\n' amapelem * n
 * n: u32int
 * amapelem: name '\t' astart '\t' astop '\n'
 * astart, astop: u64int
 */
int
parseamap(IFile *f, AMapN *amn)
{
	AMap *am;
	u64int v64;
	u32int v;
	char *s, *t, *flds[4];
	int i, n;

	/*
	 * arenas
	 */
	if(ifileu32int(f, &amp;v) &lt; 0){
		seterr(ECorrupt, "syntax error: bad number of elements in %s", f-&gt;name);
		return -1;
	}
	n = v;
	if(n &gt; MaxAMap){
		seterr(ECorrupt, "illegal number of elements %d in %s",
			n, f-&gt;name);
		return -1;
	}
	am = MKNZ(AMap, n);
	if(am == nil){
		fprint(2, "out of memory\n");
		return -1;
	}
	for(i = 0; i &lt; n; i++){
		s = ifileline(f);
		if(s)
			t = estrdup(s);
		else
			t = nil;
		if(s == nil || getfields(s, flds, 4, 0, "\t") != 3){
			fprint(2, "early eof after %d of %d, %s:#%d: %s\n", i, n, f-&gt;name, f-&gt;pos, t);
			free(t);
			return -1;
		}
		free(t);
		if(nameok(flds[0]) &lt; 0)
			return -1;
		namecp(am[i].name, flds[0]);
		if(stru64int(flds[1], &amp;v64) &lt; 0){
			seterr(ECorrupt, "syntax error: bad arena base address in %s", f-&gt;name);
			free(am);
			return -1;
		}
		am[i].start = v64;
		if(stru64int(flds[2], &amp;v64) &lt; 0){
			seterr(ECorrupt, "syntax error: bad arena size in %s", f-&gt;name);
			free(am);
			return -1;
		}
		am[i].stop = v64;
	}

	amn-&gt;map = am;
	amn-&gt;n = n;
	return 0;
}

int
outputamap(Fmt *f, AMap *am, int n)
{
	int i;

	if(fmtprint(f, "%ud\n", n) &lt; 0)
		return -1;
	for(i = 0; i &lt; n; i++)
		if(fmtprint(f, "%s\t%llud\t%llud\n", am[i].name, am[i].start, am[i].stop) &lt; 0)
			return -1;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

