<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/buildindex.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/buildindex.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Rebuild the index from scratch, in place.
 */
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

enum
{
	MinBufSize = 64*1024,
	MaxBufSize = 4*1024*1024,
};

int		dumb;
int		errors;
char		**isect;
int		nisect;
int		bloom;
int		zero;

u32int	isectmem;
u64int	totalbuckets;
u64int	totalclumps;
Channel	*arenadonechan;
Channel	*isectdonechan;
Index	*ix;

u64int	arenaentries;
u64int	skipentries;
u64int	indexentries;

static int shouldprocess(ISect*);
static void	isectproc(void*);
static void	arenapartproc(void*);

void
usage(void)
{
	fprint(2, "usage: buildindex [-b] [-i isect]... [-M imem] venti.conf\n");
	threadexitsall("usage");
}

void
threadmain(int argc, char *argv[])
{
	int fd, i, napart, nfinish, maxdisks;
	u32int bcmem, imem;
	Config conf;
	Part *p;
	
	maxdisks = 100000;
	ventifmtinstall();
	imem = 256*1024*1024;
	ARGBEGIN{
	case 'b':
		bloom = 1;
		break;
	case 'd':	/* debugging - make sure to run all 3 passes */
		dumb = 1;
		break;
	case 'i':
		isect = vtrealloc(isect, (nisect+1)*sizeof(isect[0]));
		isect[nisect++] = EARGF(usage());
		break;
	case 'M':
		imem = unittoull(EARGF(usage()));
		break;
	case 'm':	/* temporary - might go away */
		maxdisks = atoi(EARGF(usage()));
		break;
	default:
		usage();
		break;
	}ARGEND

	if(argc != 1)
		usage();

	if(initventi(argv[0], &amp;conf) &lt; 0)
		sysfatal("can't init venti: %r");
	ix = mainindex;
	if(nisect == 0 &amp;&amp; ix-&gt;bloom)
		bloom = 1;
	if(bloom &amp;&amp; ix-&gt;bloom &amp;&amp; resetbloom(ix-&gt;bloom) &lt; 0)
		sysfatal("loadbloom: %r");
	if(bloom &amp;&amp; !ix-&gt;bloom)
		sysfatal("-b specified but no bloom filter");
	if(!bloom)
		ix-&gt;bloom = nil;
	isectmem = imem/ix-&gt;nsects;

	/*
	 * safety first - only need read access to arenas
	 */
	p = nil;
	for(i=0; i&lt;ix-&gt;narenas; i++){
		if(ix-&gt;arenas[i]-&gt;part != p){
			p = ix-&gt;arenas[i]-&gt;part;
			if((fd = open(p-&gt;filename, OREAD)) &lt; 0)
				sysfatal("cannot reopen %s: %r", p-&gt;filename);
			dup(fd, p-&gt;fd);
			close(fd);
		}
	}
	
	/*
	 * need a block for every arena
	 */
	bcmem = maxblocksize * (mainindex-&gt;narenas + 16);
	if(0) fprint(2, "initialize %d bytes of disk block cache\n", bcmem);
	initdcache(bcmem);
	
	totalclumps = 0;
	for(i=0; i&lt;ix-&gt;narenas; i++)
		totalclumps += ix-&gt;arenas[i]-&gt;diskstats.clumps;
	
	totalbuckets = 0;
	for(i=0; i&lt;ix-&gt;nsects; i++)
		totalbuckets += ix-&gt;sects[i]-&gt;blocks;
	fprint(2, "%,lld clumps, %,lld buckets\n", totalclumps, totalbuckets);

	/* start index procs */
	fprint(2, "%T read index\n");
	isectdonechan = chancreate(sizeof(void*), 0);
	for(i=0; i&lt;ix-&gt;nsects; i++){
		if(shouldprocess(ix-&gt;sects[i])){
			ix-&gt;sects[i]-&gt;writechan = chancreate(sizeof(IEntry), 0);
			vtproc(isectproc, ix-&gt;sects[i]);
		}
	}
	
	for(i=0; i&lt;nisect; i++)
		if(isect[i])
			fprint(2, "warning: did not find index section %s\n", isect[i]);

	/* start arena procs */
	p = nil;
	napart = 0;
	nfinish = 0;
	arenadonechan = chancreate(sizeof(void*), 0);
	for(i=0; i&lt;ix-&gt;narenas; i++){
		if(ix-&gt;arenas[i]-&gt;part != p){
			p = ix-&gt;arenas[i]-&gt;part;
			vtproc(arenapartproc, p);
			if(++napart &gt;= maxdisks){
				recvp(arenadonechan);
				nfinish++;
			}
		}
	}

	/* wait for arena procs to finish */
	for(nfinish=0; nfinish&lt;napart; nfinish++)
		recvp(arenadonechan);

	/* tell index procs to finish */
	for(i=0; i&lt;ix-&gt;nsects; i++)
		if(ix-&gt;sects[i]-&gt;writechan)
			send(ix-&gt;sects[i]-&gt;writechan, nil);

	/* wait for index procs to finish */
	for(i=0; i&lt;ix-&gt;nsects; i++)
		if(ix-&gt;sects[i]-&gt;writechan)
			recvp(isectdonechan);

	if(ix-&gt;bloom &amp;&amp; writebloom(ix-&gt;bloom) &lt; 0)
		fprint(2, "writing bloom filter: %r\n");

	fprint(2, "%T done arenaentries=%,lld indexed=%,lld (nskip=%,lld)\n", 
		arenaentries, indexentries, skipentries);
	threadexitsall(nil);
}

static int
shouldprocess(ISect *is)
{
	int i;
	
	if(nisect == 0)
		return 1;

	for(i=0; i&lt;nisect; i++)
		if(isect[i] &amp;&amp; strcmp(isect[i], is-&gt;name) == 0){
			isect[i] = nil;
			return 1;
		}
	return 0;
}

static void
add(u64int *a, u64int n)
{
	static Lock l;
	
	lock(&amp;l);
	*a += n;
	unlock(&amp;l);
}

/*
 * Read through an arena partition and send each of its IEntries
 * to the appropriate index section.  When finished, send on
 * arenadonechan.
 */
enum
{
	ClumpChunks = 32*1024,
};
static void
arenapartproc(void *v)
{
	int i, j, n, nskip, x;
	u32int clump;
	u64int addr, tot;
	Arena *a;
	ClumpInfo *ci, *cis;
	IEntry ie;
	Part *p;
	
	p = v;
	threadsetname("arenaproc %s", p-&gt;name);

	nskip = 0;
	tot = 0;
	cis = MKN(ClumpInfo, ClumpChunks);
	for(i=0; i&lt;ix-&gt;narenas; i++){
		a = ix-&gt;arenas[i];
		if(a-&gt;part != p)
			continue;
		if(a-&gt;memstats.clumps)
			fprint(2, "%T arena %s: %d entries\n", 
				a-&gt;name, a-&gt;memstats.clumps);
		/*
		 * Running the loop backwards accesses the 
		 * clump info blocks forwards, since they are
		 * stored in reverse order at the end of the arena.
		 * This speeds things slightly.
		 */
		addr = ix-&gt;amap[i].start + a-&gt;memstats.used;
		for(clump=a-&gt;memstats.clumps; clump &gt; 0; clump-=n){
			n = ClumpChunks;
			if(n &gt; clump)
				n = clump;
			if(readclumpinfos(a, clump-n, cis, n) != n){
				fprint(2, "%T arena %s: directory read: %r\n", a-&gt;name);
				errors = 1;
				break;
			}
			for(j=n-1; j&gt;=0; j--){
				ci = &amp;cis[j];
				ie.ia.type = ci-&gt;type;
				ie.ia.size = ci-&gt;uncsize;
				addr -= ci-&gt;size + ClumpSize;
				ie.ia.addr = addr;
				ie.ia.blocks = (ci-&gt;size + ClumpSize + (1&lt;&lt;ABlockLog)-1) &gt;&gt; ABlockLog;
				scorecp(ie.score, ci-&gt;score);
				if(ci-&gt;type == VtCorruptType)
					nskip++;
				else{
					tot++;
					x = indexsect(ix, ie.score);
					assert(0 &lt;= x &amp;&amp; x &lt; ix-&gt;nsects);
					if(ix-&gt;sects[x]-&gt;writechan)
						send(ix-&gt;sects[x]-&gt;writechan, &amp;ie);
					if(ix-&gt;bloom)
						markbloomfilter(ix-&gt;bloom, ie.score);
				}
			}
		}
		if(addr != ix-&gt;amap[i].start)
			fprint(2, "%T arena %s: clump miscalculation %lld != %lld\n", a-&gt;name, addr, ix-&gt;amap[i].start);
	}
	add(&amp;arenaentries, tot);
	add(&amp;skipentries, nskip);
	sendp(arenadonechan, p);
}

/*
 * Convert score into relative bucket number in isect.
 * Can pass a packed ientry instead of score - score is first.
 */
static u32int
score2bucket(ISect *is, uchar *score)
{
	u32int b;
	
	b = hashbits(score, 32)/ix-&gt;div;
	if(b &lt; is-&gt;start || b &gt;= is-&gt;stop){
		fprint(2, "score2bucket: score=%V div=%d b=%ud start=%ud stop=%ud\n",
			score, ix-&gt;div, b, is-&gt;start, is-&gt;stop);
	}
	assert(is-&gt;start &lt;= b &amp;&amp; b &lt; is-&gt;stop);
	return b - is-&gt;start;
}

/*
 * Convert offset in index section to bucket number.
 */
static u32int
offset2bucket(ISect *is, u64int offset)
{
	u32int b;
	
	assert(is-&gt;blockbase &lt;= offset);
	offset -= is-&gt;blockbase;
	b = offset/is-&gt;blocksize;
	assert(b &lt; is-&gt;stop-is-&gt;start);
	return b;
}

/*
 * Convert bucket number to offset.
 */
static u64int
bucket2offset(ISect *is, u32int b)
{
	assert(b &lt;= is-&gt;stop-is-&gt;start);
	return is-&gt;blockbase + (u64int)b*is-&gt;blocksize;
}

/* 
 * IEntry buffers to hold initial round of spraying.
 */
typedef struct Buf Buf;
struct Buf
{
	Part *part;			/* partition being written */
	uchar *bp;		/* current block */
	uchar *ep;		/* end of block */
	uchar *wp;		/* write position in block */
	u64int boffset;		/* start offset */
	u64int woffset;		/* next write offset */
	u64int eoffset;		/* end offset */
	u32int nentry;		/* number of entries written */
};

static void
bflush(Buf *buf)
{
	u32int bufsize;
	
	if(buf-&gt;woffset &gt;= buf-&gt;eoffset)
		sysfatal("buf index chunk overflow - need bigger index");
	bufsize = buf-&gt;ep - buf-&gt;bp;
	if(writepart(buf-&gt;part, buf-&gt;woffset, buf-&gt;bp, bufsize) &lt; 0){
		fprint(2, "write %s: %r\n", buf-&gt;part-&gt;name);
		errors = 1;
	}
	buf-&gt;woffset += bufsize;
	memset(buf-&gt;bp, 0, bufsize);
	buf-&gt;wp = buf-&gt;bp;
}

static void
bwrite(Buf *buf, IEntry *ie)
{
	if(buf-&gt;wp+IEntrySize &gt; buf-&gt;ep)
		bflush(buf);
	assert(buf-&gt;bp &lt;= buf-&gt;wp &amp;&amp; buf-&gt;wp &lt; buf-&gt;ep);
	packientry(ie, buf-&gt;wp);
	buf-&gt;wp += IEntrySize;
	assert(buf-&gt;bp &lt;= buf-&gt;wp &amp;&amp; buf-&gt;wp &lt;= buf-&gt;ep);
	buf-&gt;nentry++;
}

/*
 * Minibuffer.  In-memory data structure holds our place
 * in the buffer but has no block data.  We are writing and
 * reading the minibuffers at the same time.  (Careful!)
 */
typedef struct Minibuf Minibuf;
struct Minibuf
{
	u64int boffset;		/* start offset */
	u64int roffset;		/* read offset */
	u64int woffset;		/* write offset */
	u64int eoffset;		/* end offset */
	u32int nentry;		/* # entries left to read */
	u32int nwentry;	/* # entries written */
};

/*
 * Index entry pool.  Used when trying to shuffle around 
 * the entries in a big buffer into the corresponding M minibuffers.
 * Sized to hold M*EntriesPerBlock entries, so that there will always
 * either be room in the pool for another block worth of entries
 * or there will be an entire block worth of sorted entries to 
 * write out.
 */
typedef struct IEntryLink IEntryLink;
typedef struct IPool IPool;

struct IEntryLink
{
	uchar ie[IEntrySize];		/* raw IEntry */
	IEntryLink *next;		/* next in chain */
};

struct IPool
{
	ISect *isect;
	u32int buck0;			/* first bucket in pool */
	u32int mbufbuckets;	/* buckets per minibuf */
	IEntryLink *entry;		/* all IEntryLinks */
	u32int nentry;			/* # of IEntryLinks */
	IEntryLink *free;		/* free list */
	u32int nfree;			/* # on free list */
	Minibuf *mbuf;			/* all minibufs */
	u32int nmbuf;			/* # of minibufs */
	IEntryLink **mlist;		/* lists for each minibuf */
	u32int *mcount;		/* # on each mlist[i] */
	u32int bufsize;			/* block buffer size */
	uchar *rbuf;			/* read buffer */
	uchar *wbuf;			/* write buffer */
	u32int epbuf;			/* entries per block buffer */
};

/*
static int
countsokay(IPool *p)
{
	int i;
	u64int n;
	
	n = 0;
	for(i=0; i&lt;p-&gt;nmbuf; i++)
		n += p-&gt;mcount[i];
	n += p-&gt;nfree;
	if(n != p-&gt;nentry){
		print("free %ud:", p-&gt;nfree);
		for(i=0; i&lt;p-&gt;nmbuf; i++)
			print(" %ud", p-&gt;mcount[i]);
		print(" = %lld nentry: %ud\n", n, p-&gt;nentry);
	}
	return n == p-&gt;nentry;
}
*/

static IPool*
mkipool(ISect *isect, Minibuf *mbuf, u32int nmbuf, 
	u32int mbufbuckets, u32int bufsize)
{
	u32int i, nentry;
	uchar *data;
	IPool *p;
	IEntryLink *l;
	
	nentry = (nmbuf+1)*bufsize / IEntrySize;
	p = ezmalloc(sizeof(IPool)
		+nentry*sizeof(IEntry)
		+nmbuf*sizeof(IEntryLink*)
		+nmbuf*sizeof(u32int)
		+3*bufsize);
	
	p-&gt;isect = isect;
	p-&gt;mbufbuckets = mbufbuckets;
	p-&gt;bufsize = bufsize;
	p-&gt;entry = (IEntryLink*)(p+1);
	p-&gt;nentry = nentry;
	p-&gt;mlist = (IEntryLink**)(p-&gt;entry+nentry);
	p-&gt;mcount = (u32int*)(p-&gt;mlist+nmbuf);
	p-&gt;nmbuf = nmbuf;
	p-&gt;mbuf = mbuf;
	data = (uchar*)(p-&gt;mcount+nmbuf);
	data += bufsize - (uintptr)data%bufsize;
	p-&gt;rbuf = data;
	p-&gt;wbuf = data+bufsize;
	p-&gt;epbuf = bufsize/IEntrySize;

	for(i=0; i&lt;p-&gt;nentry; i++){
		l = &amp;p-&gt;entry[i];
		l-&gt;next = p-&gt;free;
		p-&gt;free = l;
		p-&gt;nfree++;
	}
	return p;
}

/* 
 * Add the index entry ie to the pool p.
 * Caller must know there is room.
 */
static void
ipoolinsert(IPool *p, uchar *ie)
{
	u32int buck, x;
	IEntryLink *l;

	assert(p-&gt;free != nil);

	buck = score2bucket(p-&gt;isect, ie);
	x = (buck-p-&gt;buck0) / p-&gt;mbufbuckets;
	if(x &gt;= p-&gt;nmbuf){
		fprint(2, "buck=%ud mbufbucket=%ud x=%ud\n",
			buck, p-&gt;mbufbuckets, x);
	}
	assert(x &lt; p-&gt;nmbuf);

	l = p-&gt;free;
	p-&gt;free = l-&gt;next;
	p-&gt;nfree--;
	memmove(l-&gt;ie, ie, IEntrySize);
	l-&gt;next = p-&gt;mlist[x];
	p-&gt;mlist[x] = l;
	p-&gt;mcount[x]++;
}	

/*
 * Pull out a block containing as many
 * entries as possible for minibuffer x.
 */
static u32int
ipoolgetbuf(IPool *p, u32int x)
{
	uchar *bp, *ep, *wp;
	IEntryLink *l;
	u32int n;
	
	bp = p-&gt;wbuf;
	ep = p-&gt;wbuf + p-&gt;bufsize;
	n = 0;
	assert(x &lt; p-&gt;nmbuf);
	for(wp=bp; wp+IEntrySize&lt;=ep &amp;&amp; p-&gt;mlist[x]; wp+=IEntrySize){
		l = p-&gt;mlist[x];
		p-&gt;mlist[x] = l-&gt;next;
		p-&gt;mcount[x]--;
		memmove(wp, l-&gt;ie, IEntrySize);
		l-&gt;next = p-&gt;free;
		p-&gt;free = l;
		p-&gt;nfree++;
		n++;
	}
	memset(wp, 0, ep-wp);
	return n;
}

/*
 * Read a block worth of entries from the minibuf
 * into the pool.  Caller must know there is room.
 */
static void
ipoolloadblock(IPool *p, Minibuf *mb)
{
	u32int i, n;
	
	assert(mb-&gt;nentry &gt; 0);
	assert(mb-&gt;roffset &gt;= mb-&gt;woffset);
	assert(mb-&gt;roffset &lt; mb-&gt;eoffset);

	n = p-&gt;bufsize/IEntrySize;
	if(n &gt; mb-&gt;nentry)
		n = mb-&gt;nentry;
	if(readpart(p-&gt;isect-&gt;part, mb-&gt;roffset, p-&gt;rbuf, p-&gt;bufsize) &lt; 0)
		fprint(2, "readpart %s: %r\n", p-&gt;isect-&gt;part-&gt;name);
	else{
		for(i=0; i&lt;n; i++)
			ipoolinsert(p, p-&gt;rbuf+i*IEntrySize);
	}
	mb-&gt;nentry -= n;
	mb-&gt;roffset += p-&gt;bufsize;
}

/*
 * Write out a block worth of entries to minibuffer x.
 * If necessary, pick up the data there before overwriting it.
 */
static void
ipoolflush0(IPool *pool, u32int x)
{
	u32int bufsize;
	Minibuf *mb;
	
	mb = pool-&gt;mbuf+x;
	bufsize = pool-&gt;bufsize;
	mb-&gt;nwentry += ipoolgetbuf(pool, x);
	if(mb-&gt;nentry &gt; 0 &amp;&amp; mb-&gt;roffset == mb-&gt;woffset){
		assert(pool-&gt;nfree &gt;= pool-&gt;bufsize/IEntrySize);
		/*
		 * There will be room in the pool -- we just 
		 * removed a block worth.
		 */
		ipoolloadblock(pool, mb);
	}
	if(writepart(pool-&gt;isect-&gt;part, mb-&gt;woffset, pool-&gt;wbuf, bufsize) &lt; 0)
		fprint(2, "writepart %s: %r\n", pool-&gt;isect-&gt;part-&gt;name);
	mb-&gt;woffset += bufsize;
}

/*
 * Write out some full block of entries.
 * (There must be one -- the pool is almost full!)
 */
static void
ipoolflush1(IPool *pool)
{
	u32int i;

	assert(pool-&gt;nfree &lt;= pool-&gt;epbuf);

	for(i=0; i&lt;pool-&gt;nmbuf; i++){
		if(pool-&gt;mcount[i] &gt;= pool-&gt;epbuf){
			ipoolflush0(pool, i);
			return;
		}
	}
	/* can't be reached - someone must be full */
	sysfatal("ipoolflush1");
}

/*
 * Flush all the entries in the pool out to disk.
 * Nothing more to read from disk.
 */
static void
ipoolflush(IPool *pool)
{
	u32int i;
	
	for(i=0; i&lt;pool-&gt;nmbuf; i++)
		while(pool-&gt;mlist[i])
			ipoolflush0(pool, i);
	assert(pool-&gt;nfree == pool-&gt;nentry);
}

/*
 * Third pass.  Pick up each minibuffer from disk into
 * memory and then write out the buckets.
 */

/*
 * Compare two packed index entries.  
 * Usual ordering except break ties by putting higher
 * index addresses first (assumes have duplicates
 * due to corruption in the lower addresses).
 */
static int
ientrycmpaddr(const void *va, const void *vb)
{
	int i;
	uchar *a, *b;
	
	a = (uchar*)va;
	b = (uchar*)vb;
	i = ientrycmp(a, b);
	if(i)
		return i;
	return -memcmp(a+IEntryAddrOff, b+IEntryAddrOff, 8);
}

static void
zerorange(Part *p, u64int o, u64int e)
{
	static uchar zero[MaxIoSize];
	u32int n;
	
	for(; o&lt;e; o+=n){
		n = sizeof zero;
		if(o+n &gt; e)
			n = e-o;
		if(writepart(p, o, zero, n) &lt; 0)
			fprint(2, "writepart %s: %r\n", p-&gt;name);
	}
}

/*
 * Load a minibuffer into memory and write out the 
 * corresponding buckets.
 */
static void
sortminibuffer(ISect *is, Minibuf *mb, uchar *buf, u32int nbuf, u32int bufsize)
{
	uchar *buckdata, *p, *q, *ep;
	u32int b, lastb, memsize, n;
	u64int o;
	IBucket ib;
	Part *part;
	
	part = is-&gt;part;
	buckdata = emalloc(is-&gt;blocksize);
	
	if(mb-&gt;nwentry == 0)
		return;

	/*
	 * read entire buffer.
	 */
	assert(mb-&gt;nwentry*IEntrySize &lt;= mb-&gt;woffset-mb-&gt;boffset);
	assert(mb-&gt;woffset-mb-&gt;boffset &lt;= nbuf);
	if(readpart(part, mb-&gt;boffset, buf, mb-&gt;woffset-mb-&gt;boffset) &lt; 0){
		fprint(2, "readpart %s: %r\n", part-&gt;name);
		errors = 1;
		return;
	}
	assert(*(uint*)buf != 0xa5a5a5a5);
	
	/*
	 * remove fragmentation due to IEntrySize
	 * not evenly dividing Bufsize
	 */
	memsize = (bufsize/IEntrySize)*IEntrySize;
	for(o=mb-&gt;boffset, p=q=buf; o&lt;mb-&gt;woffset; o+=bufsize){
		memmove(p, q, memsize);
		p += memsize;
		q += bufsize;
	}
	ep = buf + mb-&gt;nwentry*IEntrySize;
	assert(ep &lt;= buf+nbuf);

	/* 
	 * sort entries
	 */
	qsort(buf, mb-&gt;nwentry, IEntrySize, ientrycmpaddr);

	/*
	 * write buckets out
	 */
	n = 0;
	lastb = offset2bucket(is, mb-&gt;boffset);
	for(p=buf; p&lt;ep; p=q){
		b = score2bucket(is, p);
		for(q=p; q&lt;ep &amp;&amp; score2bucket(is, q)==b; q+=IEntrySize)
			;
		if(lastb+1 &lt; b &amp;&amp; zero)
			zerorange(part, bucket2offset(is, lastb+1), bucket2offset(is, b));
		if(IBucketSize+(q-p) &gt; is-&gt;blocksize)
			sysfatal("bucket overflow - make index bigger");
		memmove(buckdata+IBucketSize, p, q-p);
		ib.n = (q-p)/IEntrySize;
		n += ib.n;
		packibucket(&amp;ib, buckdata, is-&gt;bucketmagic);
		if(writepart(part, bucket2offset(is, b), buckdata, is-&gt;blocksize) &lt; 0)
			fprint(2, "write %s: %r\n", part-&gt;name);
		lastb = b;
	}
	if(lastb+1 &lt; is-&gt;stop-is-&gt;start &amp;&amp; zero)
		zerorange(part, bucket2offset(is, lastb+1), bucket2offset(is, is-&gt;stop - is-&gt;start));

	if(n != mb-&gt;nwentry)
		fprint(2, "sortminibuffer bug: n=%ud nwentry=%ud have=%ld\n", n, mb-&gt;nwentry, (ep-buf)/IEntrySize);

	free(buckdata);
}

static void
isectproc(void *v)
{
	u32int buck, bufbuckets, bufsize, epbuf, i, j;
	u32int mbufbuckets, n, nbucket, nn, space;
	u32int nbuf, nminibuf, xminiclump, prod;
	u64int blocksize, offset, xclump;
	uchar *data, *p;
	Buf *buf;
	IEntry ie;
	IPool *ipool;
	ISect *is;
	Minibuf *mbuf, *mb;
	
	is = v;
	blocksize = is-&gt;blocksize;
	nbucket = is-&gt;stop - is-&gt;start;

	/*
	 * Three passes:
	 *	pass 1 - write index entries from arenas into 
	 *		large sequential sections on index disk.
	 *		requires nbuf * bufsize memory.
	 *
	 *	pass 2 - split each section into minibufs.
	 *		requires nminibuf * bufsize memory.
	 *
	 *	pass 3 - read each minibuf into memory and
	 *		write buckets out. 
	 *		requires entries/minibuf * IEntrySize memory.
	 * 
	 * The larger we set bufsize the less seeking hurts us.
	 * 
	 * The fewer sections and minibufs we have, the less
	 * seeking hurts us.
	 * 
	 * The fewer sections and minibufs we have, the 
	 * more entries we end up with in each minibuf
	 * at the end.  
	 *
	 * Shoot for using half our memory to hold each
	 * minibuf.  The chance of a random distribution 
	 * getting off by 2x is quite low.  
	 *
	 * Once that is decided, figure out the smallest 
	 * nminibuf and nsection/biggest bufsize we can use
	 * and still fit in the memory constraints.
	 */
	
	/* expected number of clump index entries we'll see */
	xclump = nbucket * (double)totalclumps/totalbuckets;
	
	/* number of clumps we want to see in a minibuf */
	xminiclump = isectmem/2/IEntrySize;
	
	/* total number of minibufs we need */
	prod = (xclump+xminiclump-1) / xminiclump;
	
	/* if possible, skip second pass */
	if(!dumb &amp;&amp; prod*MinBufSize &lt; isectmem){
		nbuf = prod;
		nminibuf = 1;
	}else{
		/* otherwise use nsection = sqrt(nmini) */
		for(nbuf=1; nbuf*nbuf&lt;prod; nbuf++)
			;
		if(nbuf*MinBufSize &gt; isectmem)
			sysfatal("not enough memory");
		nminibuf = nbuf;
	}
	if (nbuf == 0) {
		fprint(2, "%s: brand-new index, no work to do\n", argv0);
		threadexitsall(0);
	}

	/* size buffer to use extra memory */
	bufsize = MinBufSize;
	while(bufsize*2*nbuf &lt;= isectmem &amp;&amp; bufsize &lt; MaxBufSize)
		bufsize *= 2;
	data = emalloc(nbuf*bufsize);
	epbuf = bufsize/IEntrySize;
	fprint(2, "%T %s: %,ud buckets, %,ud groups, %,ud minigroups, %,ud buffer\n",
		is-&gt;part-&gt;name, nbucket, nbuf, nminibuf, bufsize);
	/*
	 * Accept index entries from arena procs.
	 */
	buf = MKNZ(Buf, nbuf);
	p = data;
	offset = is-&gt;blockbase;
	bufbuckets = (nbucket+nbuf-1)/nbuf;
	for(i=0; i&lt;nbuf; i++){
		buf[i].part = is-&gt;part;
		buf[i].bp = p;
		buf[i].wp = p;
		p += bufsize;
		buf[i].ep = p;
		buf[i].boffset = offset;
		buf[i].woffset = offset;
		if(i &lt; nbuf-1){
			offset += bufbuckets*blocksize;
			buf[i].eoffset = offset;
		}else{
			offset = is-&gt;blockbase + nbucket*blocksize;
			buf[i].eoffset = offset;
		}
	}
	assert(p == data+nbuf*bufsize);

	n = 0;
	while(recv(is-&gt;writechan, &amp;ie) == 1){
		if(ie.ia.addr == 0)
			break;
		buck = score2bucket(is, ie.score);
		i = buck/bufbuckets;
		assert(i &lt; nbuf);
		bwrite(&amp;buf[i], &amp;ie);
		n++;
	}
	add(&amp;indexentries, n);
	
	nn = 0;
	for(i=0; i&lt;nbuf; i++){
		bflush(&amp;buf[i]);
		buf[i].bp = nil;
		buf[i].ep = nil;
		buf[i].wp = nil;
		nn += buf[i].nentry;
	}
	if(n != nn)
		fprint(2, "isectproc bug: n=%ud nn=%ud\n", n, nn);
		
	free(data);

	fprint(2, "%T %s: reordering\n", is-&gt;part-&gt;name);
	
	/*
	 * Rearrange entries into minibuffers and then
	 * split each minibuffer into buckets.
	 * The minibuffer must be sized so that it is 
	 * a multiple of blocksize -- ipoolloadblock assumes
	 * that each minibuf starts aligned on a blocksize
	 * boundary.
	 */
	mbuf = MKN(Minibuf, nminibuf);
	mbufbuckets = (bufbuckets+nminibuf-1)/nminibuf;
	while(mbufbuckets*blocksize % bufsize)
		mbufbuckets++;
	for(i=0; i&lt;nbuf; i++){
		/*
		 * Set up descriptors.
		 */
		n = buf[i].nentry;
		nn = 0;
		offset = buf[i].boffset;
		memset(mbuf, 0, nminibuf*sizeof(mbuf[0]));
		for(j=0; j&lt;nminibuf; j++){
			mb = &amp;mbuf[j];
			mb-&gt;boffset = offset;
			offset += mbufbuckets*blocksize;
			if(offset &gt; buf[i].eoffset)
				offset = buf[i].eoffset;
			mb-&gt;eoffset = offset;
			mb-&gt;roffset = mb-&gt;boffset;
			mb-&gt;woffset = mb-&gt;boffset;
			mb-&gt;nentry = epbuf * (mb-&gt;eoffset - mb-&gt;boffset)/bufsize;
			if(mb-&gt;nentry &gt; buf[i].nentry)
				mb-&gt;nentry = buf[i].nentry;
			buf[i].nentry -= mb-&gt;nentry;
			nn += mb-&gt;nentry;
		}
		if(n != nn)
			fprint(2, "isectproc bug2: n=%ud nn=%ud (i=%d)\n", n, nn, i);;
		/*
		 * Rearrange.
		 */
		if(!dumb &amp;&amp; nminibuf == 1){
			mbuf[0].nwentry = mbuf[0].nentry;
			mbuf[0].woffset = buf[i].woffset;
		}else{
			ipool = mkipool(is, mbuf, nminibuf, mbufbuckets, bufsize);
			ipool-&gt;buck0 = bufbuckets*i;
			for(j=0; j&lt;nminibuf; j++){
				mb = &amp;mbuf[j];
				while(mb-&gt;nentry &gt; 0){
					if(ipool-&gt;nfree &lt; epbuf){
						ipoolflush1(ipool);
						/* ipoolflush1 might change mb-&gt;nentry */	
						continue;
					}
					assert(ipool-&gt;nfree &gt;= epbuf);
					ipoolloadblock(ipool, mb);
				}
			}
			ipoolflush(ipool);
			nn = 0;
			for(j=0; j&lt;nminibuf; j++)
				nn += mbuf[j].nwentry;
			if(n != nn)
				fprint(2, "isectproc bug3: n=%ud nn=%ud (i=%d)\n", n, nn, i);
			free(ipool);
		}

		/*
		 * Make buckets.
		 */
		space = 0;
		for(j=0; j&lt;nminibuf; j++)
			if(space &lt; mbuf[j].woffset - mbuf[j].boffset)
				space = mbuf[j].woffset - mbuf[j].boffset;

		data = emalloc(space);
		for(j=0; j&lt;nminibuf; j++){
			mb = &amp;mbuf[j];
			sortminibuffer(is, mb, data, space, bufsize);
		}
		free(data);
	}
		
	sendp(isectdonechan, is);
}



<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

