<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/checkarenas.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/checkarenas.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static int	verbose;

static void
checkarena(Arena *arena, int scan, int fix)
{
	ATailStats old;
	int err, e;

	if(verbose &amp;&amp; arena-&gt;memstats.clumps)
		printarena(2, arena);

	old = arena-&gt;memstats;

	if(scan){
		arena-&gt;memstats.used = 0;
		arena-&gt;memstats.clumps = 0;
		arena-&gt;memstats.cclumps = 0;
		arena-&gt;memstats.uncsize = 0;
	}

	err = 0;
	for(;;){
		e = syncarena(arena, 1000, 0, fix);
		err |= e;
		if(!(e &amp; SyncHeader))
			break;
		if(verbose &amp;&amp; arena-&gt;memstats.clumps)
			fprint(2, ".");
	}
	if(verbose &amp;&amp; arena-&gt;memstats.clumps)
		fprint(2, "\n");

	err &amp;= ~SyncHeader;
	if(arena-&gt;memstats.used != old.used
	|| arena-&gt;memstats.clumps != old.clumps
	|| arena-&gt;memstats.cclumps != old.cclumps
	|| arena-&gt;memstats.uncsize != old.uncsize){
		fprint(2, "%s: incorrect arena header fields\n", arena-&gt;name);
		printarena(2, arena);
		err |= SyncHeader;
	}

	if(!err || !fix)
		return;

	fprint(2, "%s: writing fixed arena header fields\n", arena-&gt;name);
	arena-&gt;diskstats = arena-&gt;memstats;
	if(wbarena(arena) &lt; 0)
		fprint(2, "arena header write failed: %r\n");
	flushdcache();
}

void
usage(void)
{
	fprint(2, "usage: checkarenas [-afv] file [arenaname...]\n");
	threadexitsall(0);
}

int
should(char *name, int argc, char **argv)
{
	int i;

	if(argc == 0)
		return 1;
	for(i=0; i&lt;argc; i++)
		if(strcmp(name, argv[i]) == 0)
			return 1;
	return 0;
}

void
threadmain(int argc, char *argv[])
{
	ArenaPart *ap;
	Part *part;
	char *file;
	int i, fix, scan;

	ventifmtinstall();
	statsinit();

	fix = 0;
	scan = 0;
	ARGBEGIN{
	case 'f':
		fix++;
		break;
	case 'a':
		scan = 1;
		break;
	case 'v':
		verbose++;
		break;
	default:
		usage();
		break;
	}ARGEND

	if(!fix)
		readonly = 1;

	if(argc &lt; 1)
		usage();

	file = argv[0];
	argc--;
	argv++;

	part = initpart(file, (fix ? ORDWR : OREAD)|ODIRECT);
	if(part == nil)
		sysfatal("can't open partition %s: %r", file);

	ap = initarenapart(part);
	if(ap == nil)
		sysfatal("can't initialize arena partition in %s: %r", file);

	if(verbose &gt; 1){
		printarenapart(2, ap);
		fprint(2, "\n");
	}

	initdcache(8 * MaxDiskBlock);

	for(i = 0; i &lt; ap-&gt;narenas; i++)
		if(should(ap-&gt;arenas[i]-&gt;name, argc, argv)) {
			debugarena = i;
			checkarena(ap-&gt;arenas[i], scan, fix);
		}

	if(verbose &gt; 1)
		printstats();
	threadexitsall(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

