<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/conv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/conv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

/*
 * disk structure conversion routines
 */
#define	U8GET(p)	((p)[0])
#define	U16GET(p)	(((p)[0]&lt;&lt;8)|(p)[1])
#define	U32GET(p)	((u32int)(((p)[0]&lt;&lt;24)|((p)[1]&lt;&lt;16)|((p)[2]&lt;&lt;8)|(p)[3]))
#define	U64GET(p)	(((u64int)U32GET(p)&lt;&lt;32)|(u64int)U32GET((p)+4))

#define	U8PUT(p,v)	(p)[0]=(v)&amp;0xFF
#define	U16PUT(p,v)	(p)[0]=((v)&gt;&gt;8)&amp;0xFF;(p)[1]=(v)&amp;0xFF
#define	U32PUT(p,v)	(p)[0]=((v)&gt;&gt;24)&amp;0xFF;(p)[1]=((v)&gt;&gt;16)&amp;0xFF;(p)[2]=((v)&gt;&gt;8)&amp;0xFF;(p)[3]=(v)&amp;0xFF
#define	U64PUT(p,v,t32)	t32=(v)&gt;&gt;32;U32PUT(p,t32);t32=(v);U32PUT((p)+4,t32)

int debugarena = -1;		/* hack to improve error reporting */

static struct {
	u32int m;
	char *s;
} magics[] = {
	ArenaPartMagic, "ArenaPartMagic",
	ArenaHeadMagic, "ArenaHeadMagic",
	ArenaMagic, "ArenaMagic",
	ISectMagic, "ISectMagic",
	BloomMagic, "BloomMagic",
};

static char*
fmtmagic(char *s, u32int m)
{
	int i;

	for(i=0; i&lt;nelem(magics); i++)
		if(magics[i].m == m)
			return magics[i].s;
	sprint(s, "%#08ux", m);
	return s;
}

u32int
unpackmagic(u8int *buf)
{
	return U32GET(buf);
}

void
packmagic(u32int magic, u8int *buf)
{
	U32PUT(buf, magic);
}

int
unpackarenapart(ArenaPart *ap, u8int *buf)
{
	u8int *p;
	u32int m;
	char fbuf[20];

	p = buf;

	m = U32GET(p);
	if(m != ArenaPartMagic){
		seterr(ECorrupt, "arena set has wrong magic number: %s expected ArenaPartMagic (%#lux)", fmtmagic(fbuf, m), ArenaPartMagic);
		return -1;
	}
	p += U32Size;
	ap-&gt;version = U32GET(p);
	p += U32Size;
	ap-&gt;blocksize = U32GET(p);
	p += U32Size;
	ap-&gt;arenabase = U32GET(p);
	p += U32Size;

	if(buf + ArenaPartSize != p)
		sysfatal("unpackarenapart unpacked wrong amount");

	return 0;
}

int
packarenapart(ArenaPart *ap, u8int *buf)
{
	u8int *p;

	p = buf;

	U32PUT(p, ArenaPartMagic);
	p += U32Size;
	U32PUT(p, ap-&gt;version);
	p += U32Size;
	U32PUT(p, ap-&gt;blocksize);
	p += U32Size;
	U32PUT(p, ap-&gt;arenabase);
	p += U32Size;

	if(buf + ArenaPartSize != p)
		sysfatal("packarenapart packed wrong amount");

	return 0;
}

int
unpackarena(Arena *arena, u8int *buf)
{
	int sz;
	u8int *p;
	u32int m;
	char fbuf[20];

	p = buf;

	m = U32GET(p);
	if(m != ArenaMagic){
		seterr(ECorrupt, "arena %d has wrong magic number: %s "
			"expected ArenaMagic (%#lux)", debugarena,
			fmtmagic(fbuf, m), ArenaMagic);
		return -1;
	}
	p += U32Size;
	arena-&gt;version = U32GET(p);
	p += U32Size;
	namecp(arena-&gt;name, (char*)p);
	p += ANameSize;
	arena-&gt;diskstats.clumps = U32GET(p);
	p += U32Size;
	arena-&gt;diskstats.cclumps = U32GET(p);
	p += U32Size;
	arena-&gt;ctime = U32GET(p);
	p += U32Size;
	arena-&gt;wtime = U32GET(p);
	p += U32Size;
	if(arena-&gt;version == ArenaVersion5){
		arena-&gt;clumpmagic = U32GET(p);
		p += U32Size;
	}
	arena-&gt;diskstats.used = U64GET(p);
	p += U64Size;
	arena-&gt;diskstats.uncsize = U64GET(p);
	p += U64Size;
	arena-&gt;diskstats.sealed = U8GET(p);
	p += U8Size;
	switch(arena-&gt;version){
	case ArenaVersion4:
		sz = ArenaSize4;
		arena-&gt;clumpmagic = _ClumpMagic;
		break;
	case ArenaVersion5:
		sz = ArenaSize5;
		break;
	default:
		seterr(ECorrupt, "arena has bad version number %d", arena-&gt;version);
		return -1;
	}
	/*
	 * Additional fields for the memstats version of the stats.
	 * Diskstats reflects what is committed to the index.
	 * Memstats reflects what is in the arena.  Originally intended
	 * this to be a version 5 extension, but might as well use for
	 * all the existing version 4 arenas too.
	 *
	 * To maintain backwards compatibility with existing venti
	 * installations using the older format, we define that if 
	 * memstats == diskstats, then the extension fields are not
	 * included (see packarena below).  That is, only partially
	 * indexed arenas have these fields.  Fully indexed arenas
	 * (in particular, sealed arenas) do not.
	 */
	if(U8GET(p) == 1){
		sz += ArenaSize5a-ArenaSize5;
		p += U8Size;
		arena-&gt;memstats.clumps = U32GET(p);
		p += U32Size;
		arena-&gt;memstats.cclumps = U32GET(p);
		p += U32Size;
		arena-&gt;memstats.used = U64GET(p);
		p += U64Size;
		arena-&gt;memstats.uncsize = U64GET(p);
		p += U64Size;
		arena-&gt;memstats.sealed = U8GET(p);
		p += U8Size;
		
		/*
		 * 2008/4/2
		 * Packarena (below) used to have a bug in which it would
		 * not zero out any existing extension fields when writing
		 * the arena metadata.  This would manifest itself as arenas
		 * with arena-&gt;diskstats.sealed == 1 but arena-&gt;memstats.sealed == 0
		 * after a server restart.  Because arena-&gt;memstats.sealed wouldn't
		 * be set, the server might try to fit another block into the arena
		 * (and succeed), violating the append-only structure of the log
		 * and invalidating any already-computed seal on the arena.
		 *
		 * It might end up that other fields in arena-&gt;memstats end up
		 * behind arena-&gt;diskstats too, but that would be considerably
		 * more rare, and the bug is fixed now.  The case we need to
		 * handle is just the sealed mismatch.
		 *
		 * If we encounter such a bogus arena, fix the sealed field.
		 */
		if(arena-&gt;diskstats.sealed)
			arena-&gt;memstats.sealed = 1;
	}else
		arena-&gt;memstats = arena-&gt;diskstats;
	if(buf + sz != p)
		sysfatal("unpackarena unpacked wrong amount");

	return 0;
}

int
packarena(Arena *arena, u8int *buf)
{
	return _packarena(arena, buf, 0);
}

int
_packarena(Arena *arena, u8int *buf, int forceext)
{
	int sz;
	u8int *p;
	u32int t32;

	switch(arena-&gt;version){
	case ArenaVersion4:
		sz = ArenaSize4;
		if(arena-&gt;clumpmagic != _ClumpMagic)
			fprint(2, "warning: writing old arena tail loses clump magic 0x%lux != 0x%lux\n",
				(ulong)arena-&gt;clumpmagic, (ulong)_ClumpMagic);
		break;
	case ArenaVersion5:
		sz = ArenaSize5;
		break;
	default:
		sysfatal("packarena unknown version %d", arena-&gt;version);
		return -1;
	}

	p = buf;

	U32PUT(p, ArenaMagic);
	p += U32Size;
	U32PUT(p, arena-&gt;version);
	p += U32Size;
	namecp((char*)p, arena-&gt;name);
	p += ANameSize;
	U32PUT(p, arena-&gt;diskstats.clumps);
	p += U32Size;
	U32PUT(p, arena-&gt;diskstats.cclumps);
	p += U32Size;
	U32PUT(p, arena-&gt;ctime);
	p += U32Size;
	U32PUT(p, arena-&gt;wtime);
	p += U32Size;
	if(arena-&gt;version == ArenaVersion5){
		U32PUT(p, arena-&gt;clumpmagic);
		p += U32Size;
	}
	U64PUT(p, arena-&gt;diskstats.used, t32);
	p += U64Size;
	U64PUT(p, arena-&gt;diskstats.uncsize, t32);
	p += U64Size;
	U8PUT(p, arena-&gt;diskstats.sealed);
	p += U8Size;
	
	/*
	 * Extension fields; see above.
	 */
	if(forceext
	|| arena-&gt;memstats.clumps != arena-&gt;diskstats.clumps
	|| arena-&gt;memstats.cclumps != arena-&gt;diskstats.cclumps
	|| arena-&gt;memstats.used != arena-&gt;diskstats.used
	|| arena-&gt;memstats.uncsize != arena-&gt;diskstats.uncsize
	|| arena-&gt;memstats.sealed != arena-&gt;diskstats.sealed){
		sz += ArenaSize5a - ArenaSize5;
		U8PUT(p, 1);
		p += U8Size;
		U32PUT(p, arena-&gt;memstats.clumps);
		p += U32Size;
		U32PUT(p, arena-&gt;memstats.cclumps);
		p += U32Size;
		U64PUT(p, arena-&gt;memstats.used, t32);	
		p += U64Size;
		U64PUT(p, arena-&gt;memstats.uncsize, t32);
		p += U64Size;
		U8PUT(p, arena-&gt;memstats.sealed);
		p += U8Size;
	}else{
		/* Clear any extension fields already on disk. */
		memset(p, 0, ArenaSize5a - ArenaSize5);
		p += ArenaSize5a - ArenaSize5;
		sz += ArenaSize5a - ArenaSize5;
	}

	if(buf + sz != p)
		sysfatal("packarena packed wrong amount");

	return 0;
}

int
unpackarenahead(ArenaHead *head, u8int *buf)
{
	u8int *p;
	u32int m;
	int sz;
	char fbuf[20];

	p = buf;

	m = U32GET(p);
	if(m != ArenaHeadMagic){
		seterr(ECorrupt, "arena %d head has wrong magic number: %s "
			"expected ArenaHeadMagic (%#lux)", debugarena,
			fmtmagic(fbuf, m), ArenaHeadMagic);
		return -1;
	}

	p += U32Size;
	head-&gt;version = U32GET(p);
	p += U32Size;
	namecp(head-&gt;name, (char*)p);
	p += ANameSize;
	head-&gt;blocksize = U32GET(p);
	p += U32Size;
	head-&gt;size = U64GET(p);
	p += U64Size;
	if(head-&gt;version == ArenaVersion5){
		head-&gt;clumpmagic = U32GET(p);
		p += U32Size;
	}

	switch(head-&gt;version){
	case ArenaVersion4:
		sz = ArenaHeadSize4;
		head-&gt;clumpmagic = _ClumpMagic;
		break;
	case ArenaVersion5:
		sz = ArenaHeadSize5;
		break;
	default:
		seterr(ECorrupt, "arena head has unexpected version %d", head-&gt;version);
		return -1;
	}

	if(buf + sz != p)
		sysfatal("unpackarenahead unpacked wrong amount");

	return 0;
}

int
packarenahead(ArenaHead *head, u8int *buf)
{
	u8int *p;
	int sz;
	u32int t32;

	switch(head-&gt;version){
	case ArenaVersion4:
		sz = ArenaHeadSize4;
		if(head-&gt;clumpmagic != _ClumpMagic)
			fprint(2, "warning: writing old arena header loses clump magic 0x%lux != 0x%lux\n",
				(ulong)head-&gt;clumpmagic, (ulong)_ClumpMagic);
		break;
	case ArenaVersion5:
		sz = ArenaHeadSize5;
		break;
	default:
		sysfatal("packarenahead unknown version %d", head-&gt;version);
		return -1;
	}

	p = buf;

	U32PUT(p, ArenaHeadMagic);
	p += U32Size;
	U32PUT(p, head-&gt;version);
	p += U32Size;
	namecp((char*)p, head-&gt;name);
	p += ANameSize;
	U32PUT(p, head-&gt;blocksize);
	p += U32Size;
	U64PUT(p, head-&gt;size, t32);
	p += U64Size;
	if(head-&gt;version == ArenaVersion5){
		U32PUT(p, head-&gt;clumpmagic);
		p += U32Size;
	}
	if(buf + sz != p)
		sysfatal("packarenahead packed wrong amount");

	return 0;
}

static int
checkclump(Clump *w)
{
	if(w-&gt;encoding == ClumpENone){
		if(w-&gt;info.size != w-&gt;info.uncsize){
			seterr(ECorrupt, "uncompressed wad size mismatch");
			return -1;
		}
	}else if(w-&gt;encoding == ClumpECompress){
		if(w-&gt;info.size &gt;= w-&gt;info.uncsize){
			seterr(ECorrupt, "compressed lump has inconsistent block sizes %d %d", w-&gt;info.size, w-&gt;info.uncsize);
			return -1;
		}
	}else{
		seterr(ECorrupt, "clump has illegal encoding");
		return -1;
	}

	return 0;
}

int
unpackclump(Clump *c, u8int *buf, u32int cmagic)
{
	u8int *p;
	u32int magic;

	p = buf;
	magic = U32GET(p);
	if(magic != cmagic){
		seterr(ECorrupt, "clump has bad magic number=%#8.8ux != %#8.8ux", magic, cmagic);
		return -1;
	}
	p += U32Size;

	c-&gt;info.type = vtfromdisktype(U8GET(p));
	p += U8Size;
	c-&gt;info.size = U16GET(p);
	p += U16Size;
	c-&gt;info.uncsize = U16GET(p);
	p += U16Size;
	scorecp(c-&gt;info.score, p);
	p += VtScoreSize;

	c-&gt;encoding = U8GET(p);
	p += U8Size;
	c-&gt;creator = U32GET(p);
	p += U32Size;
	c-&gt;time = U32GET(p);
	p += U32Size;

	if(buf + ClumpSize != p)
		sysfatal("unpackclump unpacked wrong amount");

	return checkclump(c);
}

int
packclump(Clump *c, u8int *buf, u32int magic)
{
	u8int *p;

	p = buf;
	U32PUT(p, magic);
	p += U32Size;

	U8PUT(p, vttodisktype(c-&gt;info.type));
	p += U8Size;
	U16PUT(p, c-&gt;info.size);
	p += U16Size;
	U16PUT(p, c-&gt;info.uncsize);
	p += U16Size;
	scorecp(p, c-&gt;info.score);
	p += VtScoreSize;

	U8PUT(p, c-&gt;encoding);
	p += U8Size;
	U32PUT(p, c-&gt;creator);
	p += U32Size;
	U32PUT(p, c-&gt;time);
	p += U32Size;

	if(buf + ClumpSize != p)
		sysfatal("packclump packed wrong amount");

	return checkclump(c);
}

void
unpackclumpinfo(ClumpInfo *ci, u8int *buf)
{
	u8int *p;

	p = buf;
	ci-&gt;type = vtfromdisktype(U8GET(p));
	p += U8Size;
	ci-&gt;size = U16GET(p);
	p += U16Size;
	ci-&gt;uncsize = U16GET(p);
	p += U16Size;
	scorecp(ci-&gt;score, p);
	p += VtScoreSize;

	if(buf + ClumpInfoSize != p)
		sysfatal("unpackclumpinfo unpacked wrong amount");
}

void
packclumpinfo(ClumpInfo *ci, u8int *buf)
{
	u8int *p;

	p = buf;
	U8PUT(p, vttodisktype(ci-&gt;type));
	p += U8Size;
	U16PUT(p, ci-&gt;size);
	p += U16Size;
	U16PUT(p, ci-&gt;uncsize);
	p += U16Size;
	scorecp(p, ci-&gt;score);
	p += VtScoreSize;

	if(buf + ClumpInfoSize != p)
		sysfatal("packclumpinfo packed wrong amount");
}

int
unpackisect(ISect *is, u8int *buf)
{
	u8int *p;
	u32int m;
	char fbuf[20];

	p = buf;


	m = U32GET(p);
	if(m != ISectMagic){
		seterr(ECorrupt, "index section has wrong magic number: %s expected ISectMagic (%#lux)",
			fmtmagic(fbuf, m), ISectMagic);
		return -1;
	}
	p += U32Size;
	is-&gt;version = U32GET(p);
	p += U32Size;
	namecp(is-&gt;name, (char*)p);
	p += ANameSize;
	namecp(is-&gt;index, (char*)p);
	p += ANameSize;
	is-&gt;blocksize = U32GET(p);
	p += U32Size;
	is-&gt;blockbase = U32GET(p);
	p += U32Size;
	is-&gt;blocks = U32GET(p);
	p += U32Size;
	is-&gt;start = U32GET(p);
	p += U32Size;
	is-&gt;stop = U32GET(p);
	p += U32Size;
	if(buf + ISectSize1 != p)
		sysfatal("unpackisect unpacked wrong amount");
	is-&gt;bucketmagic = 0;
	if(is-&gt;version == ISectVersion2){
		is-&gt;bucketmagic = U32GET(p);
		p += U32Size;
		if(buf + ISectSize2 != p)
			sysfatal("unpackisect unpacked wrong amount");
	}

	return 0;
}

int
packisect(ISect *is, u8int *buf)
{
	u8int *p;

	p = buf;

	U32PUT(p, ISectMagic);
	p += U32Size;
	U32PUT(p, is-&gt;version);
	p += U32Size;
	namecp((char*)p, is-&gt;name);
	p += ANameSize;
	namecp((char*)p, is-&gt;index);
	p += ANameSize;
	U32PUT(p, is-&gt;blocksize);
	p += U32Size;
	U32PUT(p, is-&gt;blockbase);
	p += U32Size;
	U32PUT(p, is-&gt;blocks);
	p += U32Size;
	U32PUT(p, is-&gt;start);
	p += U32Size;
	U32PUT(p, is-&gt;stop);
	p += U32Size;
	if(buf + ISectSize1 != p)
		sysfatal("packisect packed wrong amount");
	if(is-&gt;version == ISectVersion2){
		U32PUT(p, is-&gt;bucketmagic);
		p += U32Size;
		if(buf + ISectSize2 != p)
			sysfatal("packisect packed wrong amount");
	}

	return 0;
}

void
unpackientry(IEntry *ie, u8int *buf)
{
	u8int *p;

	p = buf;

	scorecp(ie-&gt;score, p);
	p += VtScoreSize;
	/* ie-&gt;wtime = U32GET(p); */
	p += U32Size;
	/* ie-&gt;train = U16GET(p); */
	p += U16Size;
	if(p - buf != IEntryAddrOff)
		sysfatal("unpackentry bad IEntryAddrOff amount");
	ie-&gt;ia.addr = U64GET(p);
if(ie-&gt;ia.addr&gt;&gt;56) print("%.8H =&gt; %llux\n", p, ie-&gt;ia.addr);
	p += U64Size;
	ie-&gt;ia.size = U16GET(p);
	p += U16Size;
	if(p - buf != IEntryTypeOff)
		sysfatal("unpackientry bad IEntryTypeOff amount");
	ie-&gt;ia.type = vtfromdisktype(U8GET(p));
	p += U8Size;
	ie-&gt;ia.blocks = U8GET(p);
	p += U8Size;

	if(p - buf != IEntrySize)
		sysfatal("unpackientry unpacked wrong amount");
}

void
packientry(IEntry *ie, u8int *buf)
{
	u32int t32;
	u8int *p;

	p = buf;

	scorecp(p, ie-&gt;score);
	p += VtScoreSize;
	U32PUT(p, 0); /* wtime */
	p += U32Size;
	U16PUT(p, 0); /* train */
	p += U16Size;
	U64PUT(p, ie-&gt;ia.addr, t32);
	p += U64Size;
	U16PUT(p, ie-&gt;ia.size);
	p += U16Size;
	U8PUT(p, vttodisktype(ie-&gt;ia.type));
	p += U8Size;
	U8PUT(p, ie-&gt;ia.blocks);
	p += U8Size;

	if(p - buf != IEntrySize)
		sysfatal("packientry packed wrong amount");
}

void
unpackibucket(IBucket *b, u8int *buf, u32int magic)
{
	b-&gt;n = U16GET(buf);
	b-&gt;data = buf + IBucketSize;
	if(magic &amp;&amp; magic != U32GET(buf+U16Size))
		b-&gt;n = 0;
}		

void
packibucket(IBucket *b, u8int *buf, u32int magic)
{
	U16PUT(buf, b-&gt;n);
	U32PUT(buf+U16Size, magic);
}

void
packbloomhead(Bloom *b, u8int *buf)
{
	u8int *p;

	p = buf;
	U32PUT(p, BloomMagic);
	U32PUT(p+4, BloomVersion);
	U32PUT(p+8, b-&gt;nhash);
	U32PUT(p+12, b-&gt;size);
}

int
unpackbloomhead(Bloom *b, u8int *buf)
{
	u8int *p;
	u32int m;
	char fbuf[20];

	p = buf;

	m = U32GET(p);
	if(m != BloomMagic){
		seterr(ECorrupt, "bloom filter has wrong magic number: %s expected BloomMagic (%#lux)", fmtmagic(fbuf, m), (ulong)BloomMagic);
		return -1;
	}
	p += U32Size;
	
	m = U32GET(p);
	if(m != BloomVersion){
		seterr(ECorrupt, "bloom filter has wrong version %ud expected %ud", (uint)m, (uint)BloomVersion);
		return -1;
	}
	p += U32Size;

	b-&gt;nhash = U32GET(p);
	p += U32Size;

	b-&gt;size = U32GET(p);
	p += U32Size;
	if(b-&gt;size &lt; BloomHeadSize || b-&gt;size &gt; MaxBloomSize || (b-&gt;size&amp;(b-&gt;size-1))){
		seterr(ECorrupt, "bloom filter has invalid size %#lux", b-&gt;size);
		return -1;
	}

	if(buf + BloomHeadSize != p)
		sysfatal("unpackarena unpacked wrong amount");

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

