<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/fixarenas.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/fixarenas.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Check and fix an arena partition.
 *
 * This is a lot grittier than the rest of Venti because
 * it can't just give up if a byte here or there is wrong.
 *
 * The rule here (hopefully followed!) is that block corruption
 * only ever has a local effect -- there are no blocks that you
 * can wipe out that will cause large portions of 
 * uncorrupted data blocks to be useless.
 */

#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "whack.h"

#define ROUNDUP(x,n)		(((x)+(n)-1)&amp;~((n)-1))

#pragma varargck type "z" uvlong
#pragma varargck type "z" vlong
#pragma varargck type "t" uint

enum
{
	K = 1024,
	M = 1024*1024,
	G = 1024*1024*1024,
	
	Block = 4096,
};

int debugsha1;

int verbose;
Part *part;
char *file;
char *basename;
char *dumpbase;
int fix;
int badreads;
int unseal;
uchar zero[MaxDiskBlock];

Arena lastarena;
ArenaPart ap;
uvlong arenasize;
int nbadread;
int nbad;
uvlong partend;
void checkarena(vlong, int);

void
usage(void)
{
	fprint(2, "usage: fixarenas [-fv] [-a arenasize] [-b blocksize] file [ranges]\n");
	threadexitsall(0);
}

/*
 * Format number in simplest way that is okay with unittoull.
 */
static int
zfmt(Fmt *fmt)
{
	vlong x;
	
	x = va_arg(fmt-&gt;args, vlong);
	if(x == 0)
		return fmtstrcpy(fmt, "0");
	if(x%G == 0)
		return fmtprint(fmt, "%lldG", x/G);
	if(x%M == 0)
		return fmtprint(fmt, "%lldM", x/M);
	if(x%K == 0)
		return fmtprint(fmt, "%lldK", x/K);
	return fmtprint(fmt, "%lld", x);
}

/*
 * Format time like ctime without newline.
 */
static int
tfmt(Fmt *fmt)
{
	uint t;
	char buf[30];
	
	t = va_arg(fmt-&gt;args, uint);
	strcpy(buf, ctime(t));
	buf[28] = 0;
	return fmtstrcpy(fmt, buf);
}

/*
 * Coalesce messages about unreadable sectors into larger ranges.
 * bad(0, 0) flushes the buffer.
 */
static void
bad(char *msg, vlong o, int len)
{
	static vlong lb0, lb1;
	static char *lmsg;

	if(msg == nil)
		msg = lmsg;
	if(o == -1){
		lmsg = nil;
		lb0 = 0;
		lb1 = 0;
		return;
	}
	if(lb1 != o || (msg &amp;&amp; lmsg &amp;&amp; strcmp(msg, lmsg) != 0)){
		if(lb0 != lb1)
			print("%s %#llux+%#llux (%,lld+%,lld)\n",
				lmsg, lb0, lb1-lb0, lb0, lb1-lb0);
		lb0 = o;
	}
	lmsg = msg;
	lb1 = o+len;
}

/*
 * Read in the len bytes of data at the offset.  If can't for whatever reason,
 * fill it with garbage but print an error.
 */
static uchar*
readdisk(uchar *buf, vlong offset, int len)
{
	int i, j, k, n;

	if(offset &gt;= partend){
		memset(buf, 0xFB, len);
		return buf;
	}
	
	if(offset+len &gt; partend){
		memset(buf, 0xFB, len);
		len = partend - offset;
	}

	if(readpart(part, offset, buf, len) &gt;= 0)
		return buf;
	
	/*
	 * The read failed.  Clear the buffer to nonsense, and
	 * then try reading in smaller pieces.  If that fails,
	 * read in even smaller pieces.  And so on down to sectors.
	 */
	memset(buf, 0xFD, len);
	for(i=0; i&lt;len; i+=64*K){
		n = 64*K;
		if(i+n &gt; len)
			n = len-i;
		if(readpart(part, offset+i, buf+i, n) &gt;= 0)
			continue;
		for(j=i; j&lt;len &amp;&amp; j&lt;i+64*K; j+=4*K){
			n = 4*K;
			if(j+n &gt; len)
				n = len-j;
			if(readpart(part, offset+j, buf+j, n) &gt;= 0)
				continue;
			for(k=j; k&lt;len &amp;&amp; k&lt;j+4*K; k+=512){
				if(readpart(part, offset+k, buf+k, 512) &gt;= 0)
					continue;
				bad("disk read failed at", k, 512);
				badreads++;
			}
		}
	}
	bad(nil, 0, 0);
	return buf;
}

/*
 * Buffer to support running SHA1 hash of the disk.
 */
typedef struct Shabuf Shabuf;
struct Shabuf
{
	int fd;
	vlong offset;
	DigestState state;
	int rollback;
	vlong r0;
	DigestState *hist;
	int nhist;
};

void
sbdebug(Shabuf *sb, char *file)
{
	int fd;
	
	if(sb-&gt;fd &gt; 0){
		close(sb-&gt;fd);
		sb-&gt;fd = 0;
	}
	if((fd = create(file, OWRITE, 0666)) &lt; 0)
		return;
	if(fd == 0){
		fd = dup(fd, -1);
		close(0);
	}
	sb-&gt;fd = fd;
}

void
sbupdate(Shabuf *sb, uchar *p, vlong offset, int len)
{
	int n, x;
	vlong o;

	if(sb-&gt;rollback &amp;&amp; !sb-&gt;hist){
		sb-&gt;r0 = offset;
		sb-&gt;nhist = 1;
		sb-&gt;hist = vtmalloc(sb-&gt;nhist*sizeof *sb-&gt;hist);
		memset(sb-&gt;hist, 0, sizeof sb-&gt;hist[0]);
	}
	if(sb-&gt;r0 == 0)
		sb-&gt;r0 = offset;

	if(sb-&gt;offset &lt; offset || sb-&gt;offset &gt;= offset+len){
		if(0) print("sbupdate %p %#llux+%d but offset=%#llux\n",
			p, offset, len, sb-&gt;offset);
		return;
	}
	x = sb-&gt;offset - offset;
	if(0) print("sbupdate %p %#llux+%d skip %d\n",
		sb, offset, len, x);
	if(x){
		p += x;
		offset += x;
		len -= x;
	}
	assert(sb-&gt;offset == offset);
	
	if(sb-&gt;fd &gt; 0)
		pwrite(sb-&gt;fd, p, len, offset - sb-&gt;r0);

	if(!sb-&gt;rollback){
		sha1(p, len, nil, &amp;sb-&gt;state);
		sb-&gt;offset += len;
		return;
	}
	
	/* save state every 4M so we can roll back quickly */
	o = offset - sb-&gt;r0;
	while(len &gt; 0){
		n = 4*M - o%(4*M);
		if(n &gt; len)
			n = len;
		sha1(p, n, nil, &amp;sb-&gt;state);
		sb-&gt;offset += n;
		o += n;
		p += n;
		len -= n;
		if(o%(4*M) == 0){
			x = o/(4*M);
			if(x &gt;= sb-&gt;nhist){
				if(x != sb-&gt;nhist)
					print("oops! x=%d nhist=%d\n", x, sb-&gt;nhist);
				sb-&gt;nhist += 32;
				sb-&gt;hist = vtrealloc(sb-&gt;hist, sb-&gt;nhist*sizeof *sb-&gt;hist);
			}
			sb-&gt;hist[x] = sb-&gt;state;
		}
	}		
}

void
sbdiskhash(Shabuf *sb, vlong eoffset)
{
	static uchar dbuf[4*M];
	int n;
	
	while(sb-&gt;offset &lt; eoffset){
		n = sizeof dbuf;
		if(sb-&gt;offset+n &gt; eoffset)
			n = eoffset - sb-&gt;offset;
		readdisk(dbuf, sb-&gt;offset, n);
		sbupdate(sb, dbuf, sb-&gt;offset, n);
	}
}

void
sbrollback(Shabuf *sb, vlong offset)
{
	int x;
	vlong o;
	Dir d;
	
	if(!sb-&gt;rollback || !sb-&gt;r0){
		print("cannot rollback sha\n");
		return;
	}
	if(offset &gt;= sb-&gt;offset)
		return;
	o = offset - sb-&gt;r0;
	x = o/(4*M);
	if(x &gt;= sb-&gt;nhist){
		print("cannot rollback sha\n");
		return;
	}
	sb-&gt;state = sb-&gt;hist[x];
	sb-&gt;offset = sb-&gt;r0 + x*4*M;
	assert(sb-&gt;offset &lt;= offset);
	
	if(sb-&gt;fd &gt; 0){
		nulldir(&amp;d);
		d.length = sb-&gt;offset - sb-&gt;r0;
		dirfwstat(sb-&gt;fd, &amp;d);
	}
}

void
sbscore(Shabuf *sb, uchar *score)
{
	if(sb-&gt;hist){
		free(sb-&gt;hist);
		sb-&gt;hist = nil;
	}
	sha1(nil, 0, score, &amp;sb-&gt;state);
}

/*
 * If we're fixing arenas, then editing this memory edits the disk!
 * It will be written back out as new data is paged in. 
 */
uchar buf[4*M];
uchar sbuf[4*M];
vlong bufoffset;
int buflen;

static void pageout(void);
static uchar*
pagein(vlong offset, int len)
{
	pageout();
	if(offset &gt;= partend){
		memset(buf, 0xFB, sizeof buf);
		return buf;
	}
	
	if(offset+len &gt; partend){
		memset(buf, 0xFB, sizeof buf);
		len = partend - offset;
	}
	bufoffset = offset;
	buflen = len;
	readdisk(buf, offset, len);
	memmove(sbuf, buf, len);
	return buf;
}

static void
pageout(void)
{
	if(buflen==0 || !fix || memcmp(buf, sbuf, buflen) == 0){
		buflen = 0;
		return;
	}
	if(writepart(part, bufoffset, buf, buflen) &lt; 0)
		print("disk write failed at %#llux+%#ux (%,lld+%,d)\n",
			bufoffset, buflen, bufoffset, buflen);
	buflen = 0;
}

static void
zerorange(vlong offset, int len)
{
	int i;
	vlong ooff;
	int olen;
	enum { MinBlock = 4*K, MaxBlock = 8*K };
	
	if(0)
	if(bufoffset &lt;= offset &amp;&amp; offset+len &lt;= bufoffset+buflen){
		memset(buf+(offset-bufoffset), 0, len);
		return;
	}
	
	ooff = bufoffset;
	olen = buflen;
	
	i = offset%MinBlock;
	if(i+len &lt; MaxBlock){
		pagein(offset-i, (len+MinBlock-1)&amp;~(MinBlock-1));
		memset(buf+i, 0, len);
	}else{
		pagein(offset-i, MaxBlock);
		memset(buf+i, 0, MaxBlock-i);
		offset += MaxBlock-i;
		len -= MaxBlock-i;
		while(len &gt;= MaxBlock){
			pagein(offset, MaxBlock);
			memset(buf, 0, MaxBlock);
			offset += MaxBlock;
			len -= MaxBlock;
		}
		pagein(offset, (len+MinBlock-1)&amp;~(MinBlock-1));
		memset(buf, 0, len);
	}
	pagein(ooff, olen);
}

/*
 * read/write integers
 *
static void
p16(uchar *p, u16int u)
{
	p[0] = (u&gt;&gt;8) &amp; 0xFF;
	p[1] = u &amp; 0xFF;
}
*/

static u16int
u16(uchar *p)
{
	return (p[0]&lt;&lt;8)|p[1];
}

static void
p32(uchar *p, u32int u)
{
	p[0] = (u&gt;&gt;24) &amp; 0xFF;
	p[1] = (u&gt;&gt;16) &amp; 0xFF;
	p[2] = (u&gt;&gt;8) &amp; 0xFF;
	p[3] = u &amp; 0xFF;
}

static u32int
u32(uchar *p)
{
	return (p[0]&lt;&lt;24)|(p[1]&lt;&lt;16)|(p[2]&lt;&lt;8)|p[3];
}

/*
static void
p64(uchar *p, u64int u)
{
	p32(p, u&gt;&gt;32);
	p32(p, u);
}
*/

static u64int
u64(uchar *p)
{
	return ((u64int)u32(p)&lt;&lt;32) | u32(p+4);
}

static int
vlongcmp(const void *va, const void *vb)
{
	vlong a, b;
	
	a = *(vlong*)va;
	b = *(vlong*)vb;
	if(a &lt; b)
		return -1;
	if(b &gt; a)
		return 1;
	return 0;
}

/* D and S are in draw.h */
#define D VD
#define S VS

enum
{
	D = 0x10000,
	Z = 0x20000,
	S = 0x30000,
	T = 0x40000,
	N = 0xFFFF
};
typedef struct Info Info;
struct Info
{
	int len;
	char *name;
};

Info partinfo[] = {
	4,	"magic",
	D|4,	"version",
	Z|4,	"blocksize",
	4,	"arenabase",
	0
};

Info headinfo4[] = {
	4,	"magic",
	D|4,	"version",
	S|ANameSize,	"name",
	Z|4,	"blocksize",
	Z|8,	"size",
	0
};

Info headinfo5[] = {
	4,	"magic",
	D|4,	"version",
	S|ANameSize,	"name",
	Z|4,	"blocksize",
	Z|8,	"size",
	4,	"clumpmagic",
	0
};

Info tailinfo4[] = {
	4,	"magic",
	D|4,	"version",
	S|ANameSize,	"name",
	D|4,	"clumps",
	D|4,	"cclumps",
	T|4,	"ctime",
	T|4,	"wtime",
	D|8,	"used",
	D|8,	"uncsize",
	1,	"sealed",
	0
};
	
Info tailinfo4a[] = {
	/* tailinfo 4 */
	4,	"magic",
	D|4,	"version",
	S|ANameSize,	"name",
	D|4,	"clumps",
	D|4,	"cclumps",
	T|4,	"ctime",
	T|4,	"wtime",
	D|8,	"used",
	D|8,	"uncsize",
	1,	"sealed",

	/* mem stats */
	1,	"extension",
	D|4,	"mem.clumps",
	D|4,	"mem.cclumps",
	D|8,	"mem.used",
	D|8,	"mem.uncsize",
	1,	"mem.sealed",
	0
};
	
Info tailinfo5[] = {
	4,	"magic",
	D|4,	"version",
	S|ANameSize,	"name",
	D|4,	"clumps",
	D|4,	"cclumps",
	T|4,	"ctime",
	T|4,	"wtime",
	4,	"clumpmagic",
	D|8,	"used",
	D|8,	"uncsize",
	1,	"sealed",
	0
};

Info tailinfo5a[] = {
	/* tailinfo 5 */
	4,	"magic",
	D|4,	"version",
	S|ANameSize,	"name",
	D|4,	"clumps",
	D|4,	"cclumps",
	T|4,	"ctime",
	T|4,	"wtime",
	4,	"clumpmagic",
	D|8,	"used",
	D|8,	"uncsize",
	1,	"sealed",

	/* mem stats */
	1,	"extension",
	D|4,	"mem.clumps",
	D|4,	"mem.cclumps",
	D|8,	"mem.used",
	D|8,	"mem.uncsize",
	1,	"mem.sealed",
	0
};
	
void
showdiffs(uchar *want, uchar *have, int len, Info *info)
{
	int n;
	
	while(len &gt; 0 &amp;&amp; (n=info-&gt;len&amp;N) &gt; 0){
		if(memcmp(have, want, n) != 0){
			switch(info-&gt;len){
			case 1:
				print("\t%s: correct=%d disk=%d\n",
					info-&gt;name, *want, *have);
				break;
			case 4:
				print("\t%s: correct=%#ux disk=%#ux\n",
					info-&gt;name, u32(want), u32(have));
				break;
			case D|4:
				print("\t%s: correct=%,ud disk=%,ud\n",
					info-&gt;name, u32(want), u32(have));
				break;
			case T|4:
				print("\t%s: correct=%t\n\t\tdisk=%t\n",
					info-&gt;name, u32(want), u32(have));
				break;
			case Z|4:
				print("\t%s: correct=%z disk=%z\n",
					info-&gt;name, (uvlong)u32(want), (uvlong)u32(have));
				break;
			case D|8:
				print("\t%s: correct=%,lld disk=%,lld\n",
					info-&gt;name, u64(want), u64(have));
				break;
			case Z|8:
				print("\t%s: correct=%z disk=%z\n",
					info-&gt;name, u64(want), u64(have));
				break;
			case S|ANameSize:
				print("\t%s: correct=%s disk=%.*s\n",
					info-&gt;name, (char*)want, 
					utfnlen((char*)have, ANameSize-1),
					(char*)have);
				break;
			default:
				print("\t%s: correct=%.*H disk=%.*H\n",
					info-&gt;name, n, want, n, have);
				break;
			}
		}
		have += n;
		want += n;
		len -= n;
		info++;
	}
	if(len &gt; 0 &amp;&amp; memcmp(have, want, len) != 0){
		if(memcmp(want, zero, len) != 0)
			print("!!\textra want data in showdiffs (bug in fixarenas)\n");
		else
			print("\tnon-zero data on disk after structure\n");
		if(verbose &gt; 1){
			print("want: %.*H\n", len, want);
			print("have: %.*H\n", len, have);
		}
	}
}

/*
 * Does part begin with an arena?
 */
int
isonearena(void)
{
	return u32(pagein(0, Block)) == ArenaHeadMagic;
}

static int tabsizes[] = { 16*1024, 64*1024, 512*1024, 768*1024, };
/*
 * Poke around on the disk to guess what the ArenaPart numbers are.
 */
void
guessgeometry(void)
{
	int i, j, n, bestn, ndiff, nhead, ntail;
	uchar *p, *ep, *sp;
	u64int diff[100], head[20], tail[20];
	u64int offset, bestdiff;
	
	ap.version = ArenaPartVersion;

	if(arenasize == 0 || ap.blocksize == 0){
		/*
		 * The ArenaPart block at offset PartBlank may be corrupt or just wrong.
		 * Instead, look for the individual arena headers and tails, which there
		 * are many of, and once we've seen enough, infer the spacing.
		 *
		 * Of course, nothing in the file format requires that arenas be evenly
		 * spaced, but fmtarenas always does that for us.
		 */
		nhead = 0;
		ntail = 0;
		for(offset=PartBlank; offset&lt;partend; offset+=4*M){
			p = pagein(offset, 4*M);
			for(sp=p, ep=p+4*M; p&lt;ep; p+=K){
				if(u32(p) == ArenaHeadMagic &amp;&amp; nhead &lt; nelem(head)){
					if(verbose)
						print("arena head at %#llx\n", offset+(p-sp));
					head[nhead++] = offset+(p-sp);
				}
				if(u32(p) == ArenaMagic &amp;&amp; ntail &lt; nelem(tail)){
					tail[ntail++] = offset+(p-sp);
					if(verbose)
						print("arena tail at %#llx\n", offset+(p-sp));
				}
			}
			if(nhead == nelem(head) &amp;&amp; ntail == nelem(tail))
				break;
		}
		if(nhead &lt; 3 &amp;&amp; ntail &lt; 3)
			sysfatal("too few intact arenas: %d heads, %d tails", nhead, ntail);
	
		/* 
		 * Arena size is likely the most common
		 * inter-head or inter-tail spacing.
		 */
		ndiff = 0;
		for(i=1; i&lt;nhead; i++)
			diff[ndiff++] = head[i] - head[i-1];
		for(i=1; i&lt;ntail; i++)
			diff[ndiff++] = tail[i] - tail[i-1];
		qsort(diff, ndiff, sizeof diff[0], vlongcmp);
		bestn = 0;
		bestdiff = 0;
		for(i=1, n=1; i&lt;=ndiff; i++, n++){
			if(i==ndiff || diff[i] != diff[i-1]){
				if(n &gt; bestn){
					bestn = n;
					bestdiff = diff[i-1];
				}
				n = 0;
			}
		}
		print("arena size likely %z (%d of %d)\n", bestdiff, bestn, ndiff);
		if(arenasize != 0 &amp;&amp; arenasize != bestdiff)
			print("using user-specified size %z instead\n", arenasize);
		else
			arenasize = bestdiff;

		/*
		 * The arena tail for an arena is arenasize-blocksize from the head.
		 */
		ndiff = 0;
		for(i=j=0; i&lt;nhead &amp;&amp; j&lt;ntail; ){
			if(tail[j] &lt; head[i]){
				j++;
				continue;
			}
			if(tail[j] &lt; head[i]+arenasize){
				diff[ndiff++] = head[i]+arenasize - tail[j];
				j++;
				continue;
			}
			i++;
		}
		if(ndiff &lt; 3)
			sysfatal("too few intact arenas: %d head, tail pairs", ndiff);
		qsort(diff, ndiff, sizeof diff[0], vlongcmp);
		bestn = 0;
		bestdiff = 0;
		for(i=1, n=1; i&lt;=ndiff; i++, n++){
			if(i==ndiff || diff[i] != diff[i-1]){
				if(n &gt; bestn){
					bestn = n;
					bestdiff = diff[i-1];
				}
				n = 0;
			}
		}
		print("block size likely %z (%d of %d)\n", bestdiff, bestn, ndiff);
		if(ap.blocksize != 0 &amp;&amp; ap.blocksize != bestdiff)
			print("using user-specified size %z instead\n", (vlong)ap.blocksize);
		else
			ap.blocksize = bestdiff;
		if(ap.blocksize == 0 || ap.blocksize&amp;(ap.blocksize-1))
			sysfatal("block size not a power of two");
		if(ap.blocksize &gt; MaxDiskBlock)
			sysfatal("block size too big (max=%d)", MaxDiskBlock);

		/*
		 * Use head/tail information to deduce arena base.
		 */
		ndiff = 0;
		for(i=0; i&lt;nhead; i++)
			diff[ndiff++] = head[i]%arenasize;
		for(i=0; i&lt;ntail; i++)
			diff[ndiff++] = (tail[i]+ap.blocksize)%arenasize;
		qsort(diff, ndiff, sizeof diff[0], vlongcmp);
		bestn = 0;
		bestdiff = 0;
		for(i=1, n=1; i&lt;=ndiff; i++, n++){
			if(i==ndiff || diff[i] != diff[i-1]){
				if(n &gt; bestn){
					bestn = n;
					bestdiff = diff[i-1];
				}
				n = 0;
			}
		}
		ap.arenabase = bestdiff;
	}

	ap.tabbase = ROUNDUP(PartBlank+HeadSize, ap.blocksize);
	/*
	 * XXX pick up table, check arenabase.
	 * XXX pick up table, record base name.
	 */

	/*
	 * Somewhat standard computation.
	 * Fmtarenas used to use 64k tab, now uses 512k tab.
	 */
	if(ap.arenabase == 0){
		print("trying standard arena bases...\n");
		for(i=0; i&lt;nelem(tabsizes); i++){
			ap.arenabase = ROUNDUP(PartBlank+HeadSize+tabsizes[i], ap.blocksize);
			p = pagein(ap.arenabase, Block);
			if(u32(p) == ArenaHeadMagic)
				break;
		}
	}
	p = pagein(ap.arenabase, Block);
	print("arena base likely %z%s\n", (vlong)ap.arenabase, 
		u32(p)!=ArenaHeadMagic ? " (but no arena head there)" : "");

	ap.tabsize = ap.arenabase - ap.tabbase;
}

/*
 * Check the arena partition blocks and then the arenas listed in range.
 */
void
checkarenas(char *range)
{
	char *s, *t;
	int i, lo, hi, narena;
	uchar dbuf[HeadSize];
	uchar *p;

	guessgeometry();

	partend -= partend%ap.blocksize;

	memset(dbuf, 0, sizeof dbuf);
	packarenapart(&amp;ap, dbuf);
	p = pagein(PartBlank, Block);
	if(memcmp(p, dbuf, HeadSize) != 0){
		print("on-disk arena part superblock incorrect\n");
		showdiffs(dbuf, p, HeadSize, partinfo);
	}
	memmove(p, dbuf, HeadSize);

	narena = (partend-ap.arenabase + arenasize-1)/arenasize;
	if(range == nil){
		for(i=0; i&lt;narena; i++)
			checkarena(ap.arenabase+(vlong)i*arenasize, i);
	}else if(strcmp(range, "none") == 0){
		/* nothing */
	}else{
		/* parse, e.g., -4,8-9,10- */
		for(s=range; *s; s=t){
			t = strchr(s, ',');
			if(t)
				*t++ = 0;
			else
				t = s+strlen(s);
			if(*s == '-')
				lo = 0;
			else
				lo = strtol(s, &amp;s, 0);
			hi = lo;
			if(*s == '-'){
				s++;
				if(*s == 0)
					hi = narena-1;
				else
					hi = strtol(s, &amp;s, 0);
			}
			if(*s != 0){
				print("bad arena range: %s\n", s);
				continue;
			}
			for(i=lo; i&lt;=hi; i++)
				checkarena(ap.arenabase+(vlong)i*arenasize, i);
		}
	}
}

/*
 * Is there a clump here at p?
 */
static int
isclump(uchar *p, Clump *cl, u32int *pmagic)
{
	int n;
	u32int magic;
	uchar score[VtScoreSize], *bp;
	Unwhack uw;
	uchar ubuf[70*1024];
	
	bp = p;
	magic = u32(p);
	if(magic == 0)
		return 0;
	p += U32Size;

	cl-&gt;info.type = vtfromdisktype(*p);
	if(cl-&gt;info.type == 0xFF)
		return 0;
	p++;
	cl-&gt;info.size = u16(p);
	p += U16Size;
	cl-&gt;info.uncsize = u16(p);
	if(cl-&gt;info.size &gt; cl-&gt;info.uncsize)
		return 0;
	p += U16Size;
	scorecp(cl-&gt;info.score, p);
	p += VtScoreSize;
	cl-&gt;encoding = *p;
	p++;
	cl-&gt;creator = u32(p);
	p += U32Size;
	cl-&gt;time = u32(p);
	p += U32Size;

	switch(cl-&gt;encoding){
	case ClumpENone:
		if(cl-&gt;info.size != cl-&gt;info.uncsize)
			return 0;
		scoremem(score, p, cl-&gt;info.size);
		if(scorecmp(score, cl-&gt;info.score) != 0)
			return 0;
		break;
	case ClumpECompress:
		if(cl-&gt;info.size &gt;= cl-&gt;info.uncsize)
			return 0;
		unwhackinit(&amp;uw);
		n = unwhack(&amp;uw, ubuf, cl-&gt;info.uncsize, p, cl-&gt;info.size);
		if(n != cl-&gt;info.uncsize)
			return 0;
		scoremem(score, ubuf, cl-&gt;info.uncsize);
		if(scorecmp(score, cl-&gt;info.score) != 0)
			return 0;
		break;
	default:
		return 0;
	}
	p += cl-&gt;info.size;
	
	/* it all worked out in the end */
	*pmagic = magic;
	return p - bp;
}

/*
 * All ClumpInfos seen in this arena.
 * Kept in binary tree so we can look up by score.
 */
typedef struct Cit Cit;
struct Cit
{
	int left;
	int right;
	vlong corrupt;
	ClumpInfo ci;
};
Cit *cibuf;
int ciroot;
int ncibuf, mcibuf;

void
resetcibuf(void)
{
	ncibuf = 0;
	ciroot = -1;
}

int*
ltreewalk(int *p, uchar *score)
{
	int i;
	
	for(;;){
		if(*p == -1)
			return p;
		i = scorecmp(cibuf[*p].ci.score, score);
		if(i == 0)
			return p;
		if(i &lt; 0)
			p = &amp;cibuf[*p].right;
		else
			p = &amp;cibuf[*p].left;
	}
}

void
addcibuf(ClumpInfo *ci, vlong corrupt)
{
	Cit *cit;
	
	if(ncibuf == mcibuf){
		mcibuf += 131072;
		cibuf = vtrealloc(cibuf, mcibuf*sizeof cibuf[0]);
	}
	cit = &amp;cibuf[ncibuf];
	cit-&gt;ci = *ci;
	cit-&gt;left = -1;
	cit-&gt;right = -1;
	cit-&gt;corrupt = corrupt;
	if(!corrupt)
		*ltreewalk(&amp;ciroot, ci-&gt;score) = ncibuf;
	ncibuf++;
}

void
addcicorrupt(vlong len)
{
	static ClumpInfo zci;
	
	addcibuf(&amp;zci, len);
}

int
haveclump(uchar *score)
{
	int i;
	int p;
	
	p = ciroot;
	for(;;){
		if(p == -1)
			return 0;
		i = scorecmp(cibuf[p].ci.score, score);
		if(i == 0)
			return 1;
		if(i &lt; 0)
			p = cibuf[p].right;
		else
			p = cibuf[p].left;
	}
}

int
matchci(ClumpInfo *ci, uchar *p)
{
	if(ci-&gt;type != vtfromdisktype(p[0]))
		return 0;
	if(ci-&gt;size != u16(p+1))
		return 0;
	if(ci-&gt;uncsize != u16(p+3))
		return 0;
	if(scorecmp(ci-&gt;score, p+5) != 0)
		return 0;
	return 1;
}

int
sealedarena(uchar *p, int blocksize)
{
	int v, n;
	
	v = u32(p+4);
	switch(v){
	default:
		return 0;
	case ArenaVersion4:
		n = ArenaSize4;
		break;
	case ArenaVersion5:
		n = ArenaSize5;
		break;
	}
	if(p[n-1] != 1){
		print("arena tail says not sealed\n");
		return 0;
	}
	if(memcmp(p+n, zero, blocksize-VtScoreSize-n) != 0){
		print("arena tail followed by non-zero data\n");
		return 0;
	}
	if(memcmp(p+blocksize-VtScoreSize, zero, VtScoreSize) == 0){
		print("arena score zero\n");
		return 0;
	}
	return 1;
}

int
okayname(char *name, int n)
{
	char buf[20];
	
	if(nameok(name) &lt; 0)
		return 0;
	sprint(buf, "%d", n);
	if(n == 0)
		buf[0] = 0;
	if(strlen(name) &lt; strlen(buf) 
	|| strcmp(name+strlen(name)-strlen(buf), buf) != 0)
		return 0;
	return 1;
}

int
clumpinfocmp(ClumpInfo *a, ClumpInfo *b)
{
	if(a-&gt;type != b-&gt;type)
		return a-&gt;type - b-&gt;type;
	if(a-&gt;size != b-&gt;size)
		return a-&gt;size - b-&gt;size;
	if(a-&gt;uncsize != b-&gt;uncsize)
		return a-&gt;uncsize - b-&gt;uncsize;
	return scorecmp(a-&gt;score, b-&gt;score);
}

ClumpInfo*
loadci(vlong offset, Arena *arena, int nci)
{
	int i, j, per;
	uchar *p, *sp;
	ClumpInfo *bci, *ci;
	
	per = arena-&gt;blocksize/ClumpInfoSize;
	bci = vtmalloc(nci*sizeof bci[0]);
	ci = bci;
	offset += arena-&gt;size - arena-&gt;blocksize;
	p = sp = nil;
	for(i=0; i&lt;nci; i+=per){
		if(p == sp){
			sp = pagein(offset-4*M, 4*M);
			p = sp+4*M;
		}
		p -= arena-&gt;blocksize;
		offset -= arena-&gt;blocksize;
		for(j=0; j&lt;per &amp;&amp; i+j&lt;nci; j++)
			unpackclumpinfo(ci++, p+j*ClumpInfoSize);
	}
	return bci;
}

vlong
writeci(vlong offset, Arena *arena, ClumpInfo *ci, int nci)
{
	int i, j, per;
	uchar *p, *sp;
	
	per = arena-&gt;blocksize/ClumpInfoSize;
	offset += arena-&gt;size - arena-&gt;blocksize;
	p = sp = nil;
	for(i=0; i&lt;nci; i+=per){
		if(p == sp){
			sp = pagein(offset-4*M, 4*M);
			p = sp+4*M;
		}
		p -= arena-&gt;blocksize;
		offset -= arena-&gt;blocksize;
		memset(p, 0, arena-&gt;blocksize);
		for(j=0; j&lt;per &amp;&amp; i+j&lt;nci; j++)
			packclumpinfo(ci++, p+j*ClumpInfoSize);
	}
	pageout();
	return offset;
}

void
loadarenabasics(vlong offset0, int anum, ArenaHead *head, Arena *arena)
{
	char dname[ANameSize];
	static char lastbase[ANameSize];
	uchar *p;
	Arena oarena;
	ArenaHead ohead;

	/*
	 * Fmtarenas makes all arenas the same size
	 * except the last, which may be smaller.
	 * It uses the same block size for arenas as for
	 * the arena partition blocks.
	 */
	arena-&gt;size = arenasize;
	if(offset0+arena-&gt;size &gt; partend)
		arena-&gt;size = partend - offset0;
	head-&gt;size = arena-&gt;size;
	
	arena-&gt;blocksize = ap.blocksize;
	head-&gt;blocksize = arena-&gt;blocksize;
	
	/* 
	 * Look for clump magic and name in head/tail blocks.
	 * All the other info we will reconstruct just in case.
	 */
	p = pagein(offset0, arena-&gt;blocksize);
	memset(&amp;ohead, 0, sizeof ohead);
	if(unpackarenahead(&amp;ohead, p) &gt;= 0){
		head-&gt;version = ohead.version;
		head-&gt;clumpmagic = ohead.clumpmagic;
		if(okayname(ohead.name, anum))
			strcpy(head-&gt;name, ohead.name);
	}

	p = pagein(offset0+arena-&gt;size-arena-&gt;blocksize, 
		arena-&gt;blocksize);
	memset(&amp;oarena, 0, sizeof oarena);
	if(unpackarena(&amp;oarena, p) &gt;= 0){
		arena-&gt;version = oarena.version;
		arena-&gt;clumpmagic = oarena.clumpmagic;
		if(okayname(oarena.name, anum))
			strcpy(arena-&gt;name, oarena.name);
		arena-&gt;diskstats.clumps = oarena.diskstats.clumps;
print("old arena: sealed=%d\n", oarena.diskstats.sealed);
		arena-&gt;diskstats.sealed = oarena.diskstats.sealed;
	}

	/* Head trumps arena. */
	if(head-&gt;version){
		arena-&gt;version = head-&gt;version;
		arena-&gt;clumpmagic = head-&gt;clumpmagic;
	}
	if(arena-&gt;version == 0)
		arena-&gt;version = ArenaVersion5;
	if(basename){
		if(anum == -1)
			snprint(arena-&gt;name, ANameSize, "%s", basename);
		else
			snprint(arena-&gt;name, ANameSize, "%s%d", basename, anum);
	}else if(lastbase[0])
		snprint(arena-&gt;name, ANameSize, "%s%d", lastbase, anum);
	else if(head-&gt;name[0])
		strcpy(arena-&gt;name, head-&gt;name);
	else if(arena-&gt;name[0] == 0)
		sysfatal("cannot determine base name for arena; use -n");
	strcpy(lastbase, arena-&gt;name);
	sprint(dname, "%d", anum);
	lastbase[strlen(lastbase)-strlen(dname)] = 0;
	
	/* Was working in arena, now copy to head. */
	head-&gt;version = arena-&gt;version;
	memmove(head-&gt;name, arena-&gt;name, sizeof head-&gt;name);
	head-&gt;blocksize = arena-&gt;blocksize;
	head-&gt;size = arena-&gt;size;
}

void
shahead(Shabuf *sb, vlong offset0, ArenaHead *head)
{
	uchar headbuf[MaxDiskBlock];
	
	sb-&gt;offset = offset0;
	memset(headbuf, 0, sizeof headbuf);
	packarenahead(head, headbuf);
	sbupdate(sb, headbuf, offset0, head-&gt;blocksize);
}

u32int
newclumpmagic(int version)
{
	u32int m;
	
	if(version == ArenaVersion4)
		return _ClumpMagic;
	do{
		m = fastrand();
	}while(m==0 || m == _ClumpMagic);
	return m;
}

/*
 * Poke around in the arena to find the clump data
 * and compute the relevant statistics.
 */
void
guessarena(vlong offset0, int anum, ArenaHead *head, Arena *arena,
	uchar *oldscore, uchar *score)
{
	uchar dbuf[MaxDiskBlock];
	int needtozero, clumps, nb1, nb2, minclumps;
	int inbad, n, ncib, printed, sealing, smart;
	u32int magic;
	uchar *sp, *ep, *p;
	vlong boffset, eoffset, lastclumpend, leaked;
	vlong offset, toffset, totalcorrupt, v;
	Clump cl;
	ClumpInfo *bci, *ci, *eci, *xci;
	Cit *bcit, *cit, *ecit;
	Shabuf oldsha, newsha;
	
	/*
	 * We expect to find an arena, with data, between offset
	 * and offset+arenasize.  With any luck, the data starts at
	 * offset+ap.blocksize.  The blocks have variable size and
	 * aren't padded at all, which doesn't give us any alignment
	 * constraints.  The blocks are compressed or high entropy,
	 * but the headers are pretty low entropy (except the score):
	 *
	 *	type[1] (range 0 thru 9, 13)
	 *	size[2]
	 *	uncsize[2] (&lt;= size)
	 *
	 * so we can look for these.  We check the scores as we go,
	 * so we can't make any wrong turns.  If we find ourselves
	 * in a dead end, scan forward looking for a new start.
	 */

	resetcibuf();
	memset(head, 0, sizeof *head);
	memset(arena, 0, sizeof *arena);
	memset(oldscore, 0, VtScoreSize);
	memset(score, 0, VtScoreSize);
	memset(&amp;oldsha, 0, sizeof oldsha);
	memset(&amp;newsha, 0, sizeof newsha);
	newsha.rollback = 1;

	if(0){
		sbdebug(&amp;oldsha, "old.sha");
		sbdebug(&amp;newsha, "new.sha");
	}

	loadarenabasics(offset0, anum, head, arena);

	/* start the clump hunt */
	
	clumps = 0;
	totalcorrupt = 0;
	sealing = 1;
	boffset = offset0 + arena-&gt;blocksize;
	offset = boffset;
	eoffset = offset0+arena-&gt;size - arena-&gt;blocksize;
	toffset = eoffset;
	sp = pagein(offset0, 4*M);

	if(arena-&gt;diskstats.sealed){
		oldsha.offset = offset0;
		sbupdate(&amp;oldsha, sp, offset0, 4*M);
	}
	ep = sp+4*M;
	p = sp + (boffset - offset0);
	ncib = arena-&gt;blocksize / ClumpInfoSize;	/* ci per block in index */
	lastclumpend = offset;
	nbad = 0;
	inbad = 0;
	needtozero = 0;
	minclumps = 0;
	while(offset &lt; eoffset){
		/*
		 * Shift buffer if we're running out of room.
		 */
		if(p+70*K &gt;= ep){
			/*
			 * Start the post SHA1 buffer.   By now we should know the
			 * clumpmagic and arena version, so we can create a
			 * correct head block to get things going.
			 */
			if(sealing &amp;&amp; fix &amp;&amp; newsha.offset == 0){
				newsha.offset = offset0;
				if(arena-&gt;clumpmagic == 0){
					if(arena-&gt;version == 0)
						arena-&gt;version = ArenaVersion5;
					arena-&gt;clumpmagic = newclumpmagic(arena-&gt;version);
				}
				head-&gt;clumpmagic = arena-&gt;clumpmagic;
				shahead(&amp;newsha, offset0, head);
			}
			n = 4*M-256*K;
			if(sealing &amp;&amp; fix){
				sbdiskhash(&amp;newsha, bufoffset);
				sbupdate(&amp;newsha, buf, bufoffset, 4*M-256*K);
			}
			pagein(bufoffset+n, 4*M);
			p -= n;
			if(arena-&gt;diskstats.sealed)
				sbupdate(&amp;oldsha, buf, bufoffset, 4*M);
		}

		/*
		 * Check for a clump at p, which is at offset in the disk.
		 * Duplicate clumps happen in corrupted disks
		 * (the same pattern gets written many times in a row)
		 * and should never happen during regular use.
		 */
		magic = 0;
		if((n = isclump(p, &amp;cl, &amp;magic)) &gt; 0){
			/*
			 * If we were in the middle of some corrupted data,
			 * flush a warning about it and then add any clump
			 * info blocks as necessary.
			 */
			if(inbad){
				inbad = 0;
				v = offset-lastclumpend;
				if(needtozero){
					zerorange(lastclumpend, v);
					sbrollback(&amp;newsha, lastclumpend);
					print("corrupt clump data - %#llux+%#llux (%,llud bytes)\n",
						lastclumpend, v, v);
				}
				addcicorrupt(v);
				totalcorrupt += v;
				nb1 = (minclumps+ncib-1)/ncib;
				minclumps += (v+ClumpSize+VtMaxLumpSize-1)/(ClumpSize+VtMaxLumpSize);
				nb2 = (minclumps+ncib-1)/ncib;
				eoffset -= (nb2-nb1)*arena-&gt;blocksize;
			}

			if(haveclump(cl.info.score))
				print("warning: duplicate clump %d %V at %#llux+%#d\n", cl.info.type, cl.info.score, offset, n);

			/*
			 * If clumps use different magic numbers, we don't care.
			 * We'll just use the first one we find and make the others
			 * follow suit.
			 */
			if(arena-&gt;clumpmagic == 0){
				print("clump type %d size %d score %V magic %x\n",
					cl.info.type, cl.info.size, cl.info.score, magic);
				arena-&gt;clumpmagic = magic;
				if(magic == _ClumpMagic)
					arena-&gt;version = ArenaVersion4;
				else
					arena-&gt;version = ArenaVersion5;
			}
			if(magic != arena-&gt;clumpmagic)
				p32(p, arena-&gt;clumpmagic);
			if(clumps == 0)
				arena-&gt;ctime = cl.time;

			/*
			 * Record the clump, update arena stats,
			 * grow clump info blocks if needed.
			 */
			if(verbose &gt; 1)
				print("\tclump %d: %d %V at %#llux+%#ux (%d)\n", 
					clumps, cl.info.type, cl.info.score, offset, n, n);
			addcibuf(&amp;cl.info, 0);
			if(minclumps%ncib == 0)
				eoffset -= arena-&gt;blocksize;
			minclumps++;
			clumps++;
			if(cl.encoding != ClumpENone)
				arena-&gt;diskstats.cclumps++;
			arena-&gt;diskstats.uncsize += cl.info.uncsize;
			arena-&gt;wtime = cl.time;
			
			/*
			 * Move to next clump.
			 */
			offset += n;
			p += n;
			lastclumpend = offset;
		}else{
			/*
			 * Overwrite malformed clump data with zeros later.
			 * For now, just record whether it needs to be overwritten.
			 * Bad regions must be of size at least ClumpSize.
			 * Postponing the overwriting keeps us from writing past
			 * the end of the arena data (which might be directory data)
			 * with zeros.
			 */
			if(!inbad){
				inbad = 1;
				needtozero = 0;
				if(memcmp(p, zero, ClumpSize) != 0)
					needtozero = 1;
				p += ClumpSize;
				offset += ClumpSize;
				nbad++;
			}else{
				if(*p != 0)
					needtozero = 1;
				p++;
				offset++;
			}
		}
	}
	pageout();

	if(verbose)
		print("readable clumps: %d; min. directory entries: %d\n", 
			clumps, minclumps);
	arena-&gt;diskstats.used = lastclumpend - boffset;
	leaked = eoffset - lastclumpend;
	if(verbose)
		print("used from %#llux to %#llux = %,lld (%,lld unused)\n",
			boffset, lastclumpend, arena-&gt;diskstats.used, leaked);

	/*
	 * Finish the SHA1 of the old data.
	 */
	if(arena-&gt;diskstats.sealed){
		sbdiskhash(&amp;oldsha, toffset);
		readdisk(dbuf, toffset, arena-&gt;blocksize);
		scorecp(dbuf+arena-&gt;blocksize-VtScoreSize, zero);
		sbupdate(&amp;oldsha, dbuf, toffset, arena-&gt;blocksize);
		sbscore(&amp;oldsha, oldscore);
	}
	
	/*
	 * If we still don't know the clump magic, the arena
	 * must be empty.  It still needs a value, so make 
	 * something up.
	 */
	if(arena-&gt;version == 0)
		arena-&gt;version = ArenaVersion5;
	if(arena-&gt;clumpmagic == 0){
		if(arena-&gt;version == ArenaVersion4)
			arena-&gt;clumpmagic = _ClumpMagic;
		else{
			do
				arena-&gt;clumpmagic = fastrand();
			while(arena-&gt;clumpmagic==_ClumpMagic
				||arena-&gt;clumpmagic==0);
		}
		head-&gt;clumpmagic = arena-&gt;clumpmagic;
	}

	/*
	 * Guess at number of clumpinfo blocks to load.
	 * If we guess high, it's no big deal.  If we guess low,
	 * we'll be forced into rewriting the whole directory.
	 * Still not such a big deal.
	 */
	if(clumps == 0 || arena-&gt;diskstats.used == totalcorrupt)
		goto Nocib;
	if(clumps &lt; arena-&gt;diskstats.clumps)
		clumps = arena-&gt;diskstats.clumps;
	if(clumps &lt; ncibuf)
		clumps = ncibuf;
	clumps += totalcorrupt/
		((arena-&gt;diskstats.used - totalcorrupt)/clumps);
	clumps += totalcorrupt/2000;
	if(clumps &lt; minclumps)
		clumps = minclumps;
	clumps += ncib-1;
	clumps -= clumps%ncib;

	/*
	 * Can't write into the actual data.
	 */
	v = offset0 + arena-&gt;size - arena-&gt;blocksize;
	v -= (clumps+ncib-1)/ncib * arena-&gt;blocksize;
	if(v &lt; lastclumpend){
		v = offset0 + arena-&gt;size - arena-&gt;blocksize;
		clumps = (v-lastclumpend)/arena-&gt;blocksize * ncib;
	}
	
	if(clumps &lt; minclumps)
		print("cannot happen?\n");

	/*
	 * Check clumpinfo blocks against directory we created.
	 * The tricky part is handling the corrupt sections of arena.
	 * If possible, we remark just the affected directory entries
	 * rather than slide everything down.
	 * 
	 * Allocate clumps+1 blocks and check that we don't need
	 * the last one at the end.
	 */
	bci = loadci(offset0, arena, clumps+1);
	eci = bci+clumps+1;
	bcit = cibuf;
	ecit = cibuf+ncibuf;
	
	smart = 0;	/* Somehow the smart code doesn't do corrupt clumps right. */
Again:
	nbad = 0;
	ci = bci;
	for(cit=bcit; cit&lt;ecit &amp;&amp; ci&lt;eci; cit++){
		if(cit-&gt;corrupt){
			vlong n, m;
			if(smart){
				/*
				 * If we can, just mark existing entries as corrupt.
				 */
				n = cit-&gt;corrupt;
				for(xci=ci; n&gt;0 &amp;&amp; xci&lt;eci; xci++)
					n -= ClumpSize+xci-&gt;size;
				if(n &gt; 0 || xci &gt;= eci)
					goto Dumb;
				printed = 0;
				for(; ci&lt;xci; ci++){
					if(verbose &amp;&amp; ci-&gt;type != VtCorruptType){
						if(!printed){
							print("marking directory %d-%d as corrupt\n",
								(int)(ci-bci), (int)(xci-bci));
							printed = 1;
						}
						print("\ttype=%d size=%d uncsize=%d score=%V\n",
							ci-&gt;type, ci-&gt;size, ci-&gt;uncsize, ci-&gt;score);
					}
					ci-&gt;type = VtCorruptType;
				}
			}else{
			Dumb:
				print("\trewriting clump directory\n");
				/*
				 * Otherwise, blaze a new trail.
				 */
				n = cit-&gt;corrupt;
				while(n &gt; 0 &amp;&amp; ci &lt; eci){
					if(n &lt; ClumpSize)
						sysfatal("bad math in clump corrupt");
					if(n &lt;= VtMaxLumpSize+ClumpSize)
						m = n;
					else{
						m = VtMaxLumpSize+ClumpSize;
						if(n-m &lt; ClumpSize)
							m -= ClumpSize;
					}
					ci-&gt;type = VtCorruptType;
					ci-&gt;size = m-ClumpSize;
					ci-&gt;uncsize = m-ClumpSize;
					memset(ci-&gt;score, 0, VtScoreSize);
					ci++;
					n -= m;
				}
			}
			continue;
		}
		if(clumpinfocmp(&amp;cit-&gt;ci, ci) != 0){
			if(verbose &amp;&amp; (smart || verbose&gt;1)){
				print("clumpinfo %d\n", (int)(ci-bci));
				print("\twant: %d %d %d %V\n", 
					cit-&gt;ci.type, cit-&gt;ci.size,
					cit-&gt;ci.uncsize, cit-&gt;ci.score);
				print("\thave: %d %d %d %V\n", 
					ci-&gt;type, ci-&gt;size, 
					ci-&gt;uncsize, ci-&gt;score);
			}
			*ci = cit-&gt;ci;
			nbad++;
		}
		ci++;
	}
	if(ci &gt;= eci || cit &lt; ecit){
		print("ran out of space editing existing directory; rewriting\n");
		print("# eci %ld ci %ld ecit %ld cit %ld\n", eci-bci, ci-bci, ecit-bcit, cit-bcit);
		assert(smart);	/* can't happen second time thru */
		smart = 0;
		goto Again;
	}
	
	assert(ci &lt;= eci);
	arena-&gt;diskstats.clumps = ci-bci;
	eoffset = writeci(offset0, arena, bci, ci-bci);
	if(sealing &amp;&amp; fix)
		sbrollback(&amp;newsha, v);
print("eoffset=%lld lastclumpend=%lld diff=%lld unseal=%d\n", eoffset, lastclumpend, eoffset-lastclumpend, unseal);
	if(lastclumpend &gt; eoffset)
		print("arena directory overwrote blocks!  cannot happen!\n");
	free(bci);
	if(smart &amp;&amp; nbad)
		print("arena directory has %d bad or missing entries\n", nbad);
Nocib:
	if(eoffset - lastclumpend &gt; 64*1024 &amp;&amp; (!arena-&gt;diskstats.sealed || unseal)){
		if(arena-&gt;diskstats.sealed)
			print("unsealing arena\n");
		sealing = 0;
		memset(oldscore, 0, VtScoreSize);
	}

	/*
	 * Finish the SHA1 of the new data - only meaningful
	 * if we've been writing to disk (`fix').
	 */
	arena-&gt;diskstats.sealed = sealing;
	arena-&gt;memstats = arena-&gt;diskstats;
	if(sealing &amp;&amp; fix){
		uchar tbuf[MaxDiskBlock];
		
		sbdiskhash(&amp;newsha, toffset);
		memset(tbuf, 0, sizeof tbuf);
		packarena(arena, tbuf);
		sbupdate(&amp;newsha, tbuf, toffset, arena-&gt;blocksize);
		sbscore(&amp;newsha, score);
	}
}

void
dumparena(vlong offset, int anum, Arena *arena)
{
	char buf[1000];
	vlong o, e;
	int fd, n;
	
	snprint(buf, sizeof buf, "%s.%d", dumpbase, anum);
	if((fd = create(buf, OWRITE, 0666)) &lt; 0){
		fprint(2, "create %s: %r\n", buf);
		return;
	}
	e = offset+arena-&gt;size;
	for(o=offset; o&lt;e; o+=n){
		n = 4*M;
		if(o+n &gt; e)
			n = e-o;
		if(pwrite(fd, pagein(o, n), n, o-offset) != n){
			fprint(2, "write %s at %#llux: %r\n", buf, o-offset);
			return;
		}
	}
}

void
checkarena(vlong offset, int anum)
{
	uchar dbuf[MaxDiskBlock];
	uchar *p, oldscore[VtScoreSize], score[VtScoreSize];
	Arena arena, oarena;
	ArenaHead head;
	Info *fmt, *fmta;
	int sz;
	
	print("# arena %d: offset %#llux\n", anum, offset);

	if(offset &gt;= partend){
		print("arena offset out of bounds\n");
		return;
	}

	guessarena(offset, anum, &amp;head, &amp;arena, oldscore, score);

	if(verbose){
		print("#\tversion=%d name=%s blocksize=%d size=%z",
			head.version, head.name, head.blocksize, head.size);
		if(head.clumpmagic)
			print(" clumpmagic=%#.8ux", head.clumpmagic);
		print("\n#\tclumps=%d cclumps=%d used=%,lld uncsize=%,lld\n",
			arena.diskstats.clumps, arena.diskstats.cclumps,
			arena.diskstats.used, arena.diskstats.uncsize);
		print("#\tctime=%t\n", arena.ctime);
		print("#\twtime=%t\n", arena.wtime);
		if(arena.diskstats.sealed)
			print("#\tsealed score=%V\n", score);
	}

	if(dumpbase){
		dumparena(offset, anum, &amp;arena);
		return;
	}

	memset(dbuf, 0, sizeof dbuf);
	packarenahead(&amp;head, dbuf);
	p = pagein(offset, arena.blocksize);
	if(memcmp(dbuf, p, arena.blocksize) != 0){
		print("on-disk arena header incorrect\n");
		showdiffs(dbuf, p, arena.blocksize, 
			arena.version==ArenaVersion4 ? headinfo4 : headinfo5);
	}
	memmove(p, dbuf, arena.blocksize);
	
	memset(dbuf, 0, sizeof dbuf);
	packarena(&amp;arena, dbuf);
	if(arena.diskstats.sealed)
		scorecp(dbuf+arena.blocksize-VtScoreSize, score);
	p = pagein(offset+arena.size-arena.blocksize, arena.blocksize);
	memset(&amp;oarena, 0, sizeof oarena);
	unpackarena(&amp;oarena, p);
	if(arena.version == ArenaVersion4){
		sz = ArenaSize4;
		fmt = tailinfo4;
		fmta = tailinfo4a;
	}else{
		sz = ArenaSize5;
		fmt = tailinfo5;
		fmta = tailinfo5a;
	}
	if(p[sz] == 1){
		fmt = fmta;
		if(oarena.diskstats.sealed){
			/*
			 * some arenas were sealed with the extension
			 * before we adopted the convention that if it didn't
			 * add new information it gets dropped.
			 */
			_packarena(&amp;arena, dbuf, 1);
		}
	}
	if(memcmp(dbuf, p, arena.blocksize-VtScoreSize) != 0){
		print("on-disk arena tail incorrect\n");
		showdiffs(dbuf, p, arena.blocksize-VtScoreSize, fmt);
	}
	if(arena.diskstats.sealed){
		if(oarena.diskstats.sealed)
		if(scorecmp(p+arena.blocksize-VtScoreSize, oldscore) != 0){
			print("on-disk arena seal score incorrect\n");
			print("\tcorrect=%V\n", oldscore);
			print("\t   disk=%V\n", p+arena.blocksize-VtScoreSize);
		}
		if(fix &amp;&amp; scorecmp(p+arena.blocksize-VtScoreSize, score) != 0){
			print("%ssealing arena%s: %V\n", 
				oarena.diskstats.sealed ? "re" : "",
				scorecmp(oldscore, score) == 0 ? 
					"" : " after changes", score);
		}
	}
	memmove(p, dbuf, arena.blocksize);
	
	pageout();
}

AMapN*
buildamap(void)
{
	uchar *p;
	vlong o;
	ArenaHead h;
	AMapN *an;
	AMap *m;
	
	an = vtmallocz(sizeof *an);
	for(o=ap.arenabase; o&lt;partend; o+=arenasize){
		p = pagein(o, Block);
		if(unpackarenahead(&amp;h, p) &gt;= 0){
			an-&gt;map = vtrealloc(an-&gt;map, (an-&gt;n+1)*sizeof an-&gt;map[0]);
			m = &amp;an-&gt;map[an-&gt;n++];
			m-&gt;start = o;
			m-&gt;stop = o+h.size;
			strcpy(m-&gt;name, h.name);
		}
	}
	return an;	
}

void
checkmap(void)
{
	char *s;
	uchar *p;
	int i, len;
	AMapN *an;
	Fmt fmt;
	
	an = buildamap();
	fmtstrinit(&amp;fmt);
	fmtprint(&amp;fmt, "%ud\n", an-&gt;n);
	for(i=0; i&lt;an-&gt;n; i++)
		fmtprint(&amp;fmt, "%s\t%lld\t%lld\n",
			an-&gt;map[i].name, an-&gt;map[i].start, an-&gt;map[i].stop);
	s = fmtstrflush(&amp;fmt);
	len = strlen(s);
	if(len &gt; ap.tabsize){
		print("arena partition map too long: need %z bytes have %z\n",
			(vlong)len, (vlong)ap.tabsize);
		len = ap.tabsize;
	}
	
	if(ap.tabsize &gt;= 4*M){	/* can't happen - max arenas is 2000 */
		print("arena partition map *way* too long\n");
		return;
	}

	p = pagein(ap.tabbase, ap.tabsize);
	if(memcmp(p, s, len) != 0){
		print("arena partition map incorrect; rewriting.\n");
		memmove(p, s, len);
	}
	pageout();
}

int mainstacksize = 512*1024;

void
threadmain(int argc, char **argv)
{
	int mode;
	
	mode = OREAD;
	readonly = 1;	
	ARGBEGIN{
	case 'U':
		unseal = 1;
		break;
	case 'a':
		arenasize = unittoull(EARGF(usage()));
		break;
	case 'b':
		ap.blocksize = unittoull(EARGF(usage()));
		break;
	case 'f':
		fix = 1;
		mode = ORDWR;
		readonly = 0;
		break;
	case 'n':
		basename = EARGF(usage());
		break;
	case 'v':
		verbose++;
		break;
	case 'x':
		dumpbase = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND
	
	if(argc != 1 &amp;&amp; argc != 2)
		usage();

	file = argv[0];
	
	ventifmtinstall();
	fmtinstall('z', zfmt);
	fmtinstall('t', tfmt);
	quotefmtinstall();
	
	part = initpart(file, mode|ODIRECT);
	if(part == nil)
		sysfatal("can't open %s: %r", file);
	partend = part-&gt;size;
	
	if(isonearena()){
		checkarena(0, -1);
		threadexitsall(nil);
	}
	checkarenas(argc &gt; 1 ? argv[1] : nil);
	checkmap();
	threadexitsall(nil);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

