<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/hproc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/hproc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#include &lt;ureg.h&gt;
#include "/sys/src/libthread/threadimpl.h"
#include "dat.h"
#include "fns.h"

typedef struct Ureg Ureg;
typedef struct Debug Debug;

struct Debug
{
	int textfd;
	QLock lock;
	Fhdr fhdr;
	Map *map;
	Fmt *fmt;
	int pid;
	char *stkprefix;
	int pcoff;
	int spoff;
};

static Debug debug = { -1 };

static int
text(int pid)
{
	int fd;
	char buf[100];

	if(debug.textfd &gt;= 0){
		close(debug.textfd);
		debug.textfd = -1;
	}
	memset(&amp;debug.fhdr, 0, sizeof debug.fhdr);
	
	snprint(buf, sizeof buf, "#p/%d/text", pid);
	fd = open(buf, OREAD);
	if(fd &lt; 0)
		return -1;
	if(crackhdr(fd, &amp;debug.fhdr) &lt; 0){
		close(fd);
		return -1;
	}
	if(syminit(fd, &amp;debug.fhdr) &lt; 0){
		memset(&amp;debug.fhdr, 0, sizeof debug.fhdr);
		close(fd);
		return -1;
	}
	debug.textfd = fd;
	machbytype(debug.fhdr.type);
	return 0;
}

static void
unmap(Map *m)
{
	int i;
	
	for(i=0; i&lt;m-&gt;nsegs; i++)
		if(m-&gt;seg[i].inuse)
			close(m-&gt;seg[i].fd);
	free(m);
}

static Map*
map(int pid)
{
	int mem;
	char buf[100];
	Map *m;
	
	snprint(buf, sizeof buf, "#p/%d/mem", pid);
	mem = open(buf, OREAD);
	if(mem &lt; 0)
		return nil;

	m = attachproc(pid, 0, mem, &amp;debug.fhdr);
	if(m == 0){
		close(mem);
		return nil;
	}
	
	if(debug.map)
		unmap(debug.map);
	debug.map = m;
	debug.pid = pid;
	return m;
}

static void
dprint(char *fmt, ...)
{
	va_list arg;
	
	va_start(arg, fmt);
	fmtvprint(debug.fmt, fmt, arg);
	va_end(arg);
}

static void
openfiles(void)
{
	char buf[4096];
	int fd, n;
	
	snprint(buf, sizeof buf, "#p/%d/fd", getpid());
	if((fd = open(buf, OREAD)) &lt; 0){
		dprint("open %s: %r\n", buf);
		return;
	}
	n = readn(fd, buf, sizeof buf-1);
	close(fd);
	if(n &gt;= 0){
		buf[n] = 0;
		fmtstrcpy(debug.fmt, buf);
	}
}

/*
 *	dump the raw symbol table
 */
static void
printsym(void)
{
	int i;
	Sym *sp;

	for (i = 0; sp = getsym(i); i++) {
		switch(sp-&gt;type) {
		case 't':
		case 'l':
			dprint("%16#llux t %s\n", sp-&gt;value, sp-&gt;name);
			break;
		case 'T':
		case 'L':
			dprint("%16#llux T %s\n", sp-&gt;value, sp-&gt;name);
			break;
		case 'D':
		case 'd':
		case 'B':
		case 'b':
		case 'a':
		case 'p':
		case 'm':
			dprint("%16#llux %c %s\n", sp-&gt;value, sp-&gt;type, sp-&gt;name);
			break;
		default:
			break;
		}
	}
}

static void
printmap(char *s, Map *map)
{
	int i;

	if (!map)
		return;
	dprint("%s\n", s);
	for (i = 0; i &lt; map-&gt;nsegs; i++) {
		if (map-&gt;seg[i].inuse)
			dprint("%-16s %-16#llux %-16#llux %-16#llux\n",
				map-&gt;seg[i].name, map-&gt;seg[i].b,
				map-&gt;seg[i].e, map-&gt;seg[i].f);
	}
}

static void
printlocals(Map *map, Symbol *fn, uintptr fp)
{
	int i;
	uintptr w;
	Symbol s;
	char buf[100];

	s = *fn;
	for (i = 0; localsym(&amp;s, i); i++) {
		if (s.class != CAUTO)
			continue;
		snprint(buf, sizeof buf, "%s%s/", debug.stkprefix, s.name);
		if (geta(map, fp - s.value, (uvlong*)&amp;w) &gt; 0)
			dprint("\t%-10s %10#p %ld\n", buf, w, w);
		else
			dprint("\t%-10s ?\n", buf);
	}
}

static void
printparams(Map *map, Symbol *fn, uintptr fp)
{
	int i;
	Symbol s;
	uintptr w;
	int first = 0;

	fp += mach-&gt;szaddr;			/* skip saved pc */
	s = *fn;
	for (i = 0; localsym(&amp;s, i); i++) {
		if (s.class != CPARAM)
			continue;
		if (first++)
			dprint(", ");
		if (geta(map, fp + s.value, (uvlong *)&amp;w) &gt; 0)
			dprint("%s=%#p", s.name, w);
	}
}

static void
printsource(uintptr dot)
{
	char str[100];

	if (fileline(str, sizeof str, dot))
		dprint("%s", str);
}


/*
 *	callback on stack trace
 */
static uintptr nextpc;

static void
ptrace(Map *map, uvlong pc, uvlong sp, Symbol *sym)
{
	if(nextpc == 0)
		nextpc = sym-&gt;value;
	if(debug.stkprefix == nil)
		debug.stkprefix = "";
	dprint("%s%s(", debug.stkprefix, sym-&gt;name);
	printparams(map, sym, sp);
	dprint(")");
	if(nextpc != sym-&gt;value)
		dprint("+%#llux ", nextpc - sym-&gt;value);
	printsource(nextpc);
	dprint("\n");
	printlocals(map, sym, sp);
	nextpc = pc;
}

static void
stacktracepcsp(Map *m, uintptr pc, uintptr sp)
{
	nextpc = 0;
	if(machdata-&gt;ctrace==nil)
		dprint("no machdata-&gt;ctrace\n");
	else if(machdata-&gt;ctrace(m, pc, sp, 0, ptrace) &lt;= 0)
		dprint("no stack frame: pc=%#p sp=%#p\n", pc, sp);
}

static void
ureginit(void)
{
	Reglist *r;

	for(r = mach-&gt;reglist; r-&gt;rname; r++)
		if (strcmp(r-&gt;rname, "PC") == 0)
			debug.pcoff = r-&gt;roffs;
		else if (strcmp(r-&gt;rname, "SP") == 0)
			debug.spoff = r-&gt;roffs;
}

static void
stacktrace(Map *m)
{
	uintptr pc, sp;
	
	if(geta(m, debug.pcoff, (uvlong *)&amp;pc) &lt; 0){
		dprint("geta pc: %r");
		return;
	}
	if(geta(m, debug.spoff, (uvlong *)&amp;sp) &lt; 0){
		dprint("geta sp: %r");
		return;
	}
	stacktracepcsp(m, pc, sp);
}

static uintptr
star(uintptr addr)
{
	uintptr x;
	static int warned;

	if(addr == 0)
		return 0;

	if(debug.map == nil){
		if(!warned++)
			dprint("no debug.map\n");
		return 0;
	}
	if(geta(debug.map, addr, (uvlong *)&amp;x) &lt; 0){
		dprint("geta %#p (pid=%d): %r\n", addr, debug.pid);
		return 0;
	}
	return x;
}

static uintptr
resolvev(char *name)
{
	Symbol s;

	if(lookup(nil, name, &amp;s) == 0)
		return 0;
	return s.value;
}

static uintptr
resolvef(char *name)
{
	Symbol s;

	if(lookup(name, nil, &amp;s) == 0)
		return 0;
	return s.value;
}

#define FADDR(type, p, name) ((p) + offsetof(type, name))
#define FIELD(type, p, name) star(FADDR(type, p, name))

static uintptr threadpc;

static int
strprefix(char *big, char *pre)
{
	return strncmp(big, pre, strlen(pre));
}
static void
tptrace(Map *map, uvlong pc, uvlong sp, Symbol *sym)
{
	char buf[512];

	USED(map);
	USED(sym);
	USED(sp);

	if(threadpc != 0)
		return;
	if(!fileline(buf, sizeof buf, pc))
		return;
	if(strprefix(buf, "/sys/src/libc/") == 0)
		return;
	if(strprefix(buf, "/sys/src/libthread/") == 0)
		return;
	threadpc = pc;
}

static char*
threadstkline(uintptr t)
{
	uintptr pc, sp;
	static char buf[500];

	if(FIELD(Thread, t, state) == Running){
		geta(debug.map, debug.pcoff, (uvlong *)&amp;pc);
		geta(debug.map, debug.spoff, (uvlong *)&amp;sp);
	}else{
		// pc = FIELD(Thread, t, sched[JMPBUFPC]);
		pc = resolvef("longjmp");
		sp = FIELD(Thread, t, sched[JMPBUFSP]);
	}
	if(machdata-&gt;ctrace == nil)
		return "";
	threadpc = 0;
	machdata-&gt;ctrace(debug.map, pc, sp, 0, tptrace);
	if(!fileline(buf, sizeof buf, threadpc))
		buf[0] = 0;
	return buf;
}

static void
proc(uintptr p)
{
	dprint("p=(Proc)%#p pid %d ", p, FIELD(Proc, p, pid));
	if(FIELD(Proc, p, thread) == 0)
		dprint(" Sched\n");
	else
		dprint(" Running\n");
}

static void
fmtbufinit(Fmt *f, char *buf, int len)
{
	memset(f, 0, sizeof *f);
	f-&gt;runes = 0;
	f-&gt;start = buf;
	f-&gt;to = buf;
	f-&gt;stop = buf + len - 1;
	f-&gt;flush = nil;
	f-&gt;farg = nil;
	f-&gt;nfmt = 0;
}

static char*
fmtbufflush(Fmt *f)
{
	*(char*)f-&gt;to = 0;
	return (char*)f-&gt;start;
}

static char*
debugstr(uintptr s)
{
	static char buf[4096];
	char *p, *e;
	
	p = buf;
	e = buf+sizeof buf - 1;
	while(p &lt; e){
		if(get1(debug.map, s++, (uchar*)p, 1) &lt; 0)
			break;
		if(*p == 0)
			break;
		p++;
	}
	*p = 0;
	return buf;
}

static char*
threadfmt(uintptr t)
{
	static char buf[4096];
	Fmt fmt;
	int s;

	fmtbufinit(&amp;fmt, buf, sizeof buf);
	
	fmtprint(&amp;fmt, "t=(Thread)%#p ", t);
	switch(s = FIELD(Thread, t, state)){
	case Running:
		fmtprint(&amp;fmt, " Running   ");
		break;
	case Ready:
		fmtprint(&amp;fmt, " Ready     ");
		break;
	case Rendezvous:
		fmtprint(&amp;fmt, " Rendez    ");
		break;
	default:
		fmtprint(&amp;fmt, " bad state %d ", s);
		break;
	}
	
	fmtprint(&amp;fmt, "%s", threadstkline(t));
	
	if(FIELD(Thread, t, moribund) == 1)
		fmtprint(&amp;fmt, " Moribund");
	if(s = FIELD(Thread, t, cmdname)){
		fmtprint(&amp;fmt, " [%s]", debugstr(s));
	}

	fmtbufflush(&amp;fmt);
	return buf;
}


static void
thread(uintptr t)
{
	dprint("%s\n", threadfmt(t));
}

static void
threadapply(uintptr p, void (*fn)(uintptr))
{
	int oldpid, pid;
	uintptr tq, t;
	
	oldpid = debug.pid;
	pid = FIELD(Proc, p, pid);
	if(map(pid) == nil)
		return;
	tq = FADDR(Proc, p, threads);
	t = FIELD(Tqueue, tq, head);
	while(t != 0){
		fn(t);
		t = FIELD(Thread, t, nextt);
	}
	map(oldpid);
}

static void
pthreads1(uintptr t)
{
	dprint("\t");
	thread(t);
}

static void
pthreads(uintptr p)
{
	threadapply(p, pthreads1);
}

static void
lproc(uintptr p)
{
	proc(p);
	pthreads(p);
}

static void
procapply(void (*fn)(uintptr))
{
	uintptr proc, pq;
	
	pq = resolvev("_threadpq");
	if(pq == 0){
		dprint("no thread run queue\n");
		return;
	}

	proc = FIELD(Pqueue, pq, head);
	while(proc){
		fn(proc);
		proc = FIELD(Proc, proc, next);
	}
}

static void
threads(HConnect *c)
{
	USED(c);
	procapply(lproc);
}

static void
procs(HConnect *c)
{
	USED(c);
	procapply(proc);
}

static void
threadstack(uintptr t)
{
	uintptr pc, sp;

	if(FIELD(Thread, t, state) == Running){
		stacktrace(debug.map);
	}else{
		// pc = FIELD(Thread, t, sched[JMPBUFPC]);
		pc = resolvef("longjmp");
		sp = FIELD(Thread, t, sched[JMPBUFSP]);
		stacktracepcsp(debug.map, pc, sp);
	}
}


static void
tstacks(uintptr t)
{
	dprint("\t");
	thread(t);
	threadstack(t);
	dprint("\n");
}

static void
pstacks(uintptr p)
{
	proc(p);
	threadapply(p, tstacks);
}

static void
stacks(HConnect *c)
{
	USED(c);
	debug.stkprefix = "\t\t";
	procapply(pstacks);
	debug.stkprefix = "";
}

static void
symbols(HConnect *c)
{
	USED(c);
	printsym();
}

static void
segments(HConnect *c)
{
	USED(c);
	printmap("segments", debug.map);
}

static void
fds(HConnect *c)
{
	USED(c);
	openfiles();
}

static void
all(HConnect *c)
{
	dprint("/proc/segment\n");
	segments(c);
	dprint("\n/proc/fd\n");
	fds(c);
	dprint("\n/proc/procs\n");
	procs(c);
	dprint("\n/proc/threads\n");
	threads(c);
	dprint("\n/proc/stacks\n");
	stacks(c);
	dprint("\n# /proc/symbols\n");
	// symbols(c);
}

int
hproc(HConnect *c)
{
	void (*fn)(HConnect*);
	Fmt fmt;
	static int beenhere;
	static char buf[65536];

	if (!beenhere) {
		beenhere = 1;
		ureginit();
	}
	if(strcmp(c-&gt;req.uri, "/proc/all") == 0)
		fn = all;
	else if(strcmp(c-&gt;req.uri, "/proc/segment") == 0)
		fn = segments;
	else if(strcmp(c-&gt;req.uri, "/proc/fd") == 0)
		fn = fds;
	else if(strcmp(c-&gt;req.uri, "/proc/procs") == 0)
		fn = procs;
	else if(strcmp(c-&gt;req.uri, "/proc/threads") == 0)
		fn = threads;
	else if(strcmp(c-&gt;req.uri, "/proc/stacks") == 0)
		fn = stacks;
	else if(strcmp(c-&gt;req.uri, "/proc/symbols") == 0)
		fn = symbols;
	else
		return hnotfound(c);

	if(hsettext(c) &lt; 0)
		return -1;
	if(!canqlock(&amp;debug.lock)){
		hprint(&amp;c-&gt;hout, "debugger is busy\n");
		return 0;
	}
	if(debug.textfd &lt; 0){
		if(text(getpid()) &lt; 0){
			hprint(&amp;c-&gt;hout, "cannot attach self text: %r\n");
			goto out;
		}
	}
	if(map(getpid()) == nil){
		hprint(&amp;c-&gt;hout, "cannot map self: %r\n");
		goto out;
	}

	fmtbufinit(&amp;fmt, buf, sizeof buf);
	debug.fmt = &amp;fmt;
	fn(c);
	hprint(&amp;c-&gt;hout, "%s\n", fmtbufflush(&amp;fmt));
	debug.fmt = nil;
out:
	qunlock(&amp;debug.lock);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

