<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/icache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/icache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

int icacheprefetch = 1;

typedef struct ICache ICache;
typedef struct IHash IHash;
typedef struct ISum ISum;

struct ICache
{
	QLock	lock;
	Rendez	full;
	IHash	*hash;
	IEntry	*entries;
	int		nentries;
	IEntry	free;
	IEntry	clean;
	IEntry	dirty;
	u32int	maxdirty;
	u32int	ndirty;
	AState	as;

	ISum	**sum;
	int		nsum;
	IHash	*shash;
	IEntry	*sentries;
	int		nsentries;
};

static ICache icache;

/*
 * Hash table of IEntries
 */

struct IHash
{
	int bits;
	u32int size;
	IEntry **table;
};

static IHash*
mkihash(int size1)
{
	u32int size;
	int bits;
	IHash *ih;
	
	bits = 0;
	size = 1;
	while(size &lt; size1){
		bits++;
		size &lt;&lt;= 1;
	}
	
	ih = vtmallocz(sizeof(IHash)+size*sizeof(ih-&gt;table[0]));
	ih-&gt;table = (IEntry**)(ih+1);
	ih-&gt;bits = bits;
	ih-&gt;size = size;
	return ih;
}

static IEntry*
ihashlookup(IHash *ih, u8int score[VtScoreSize], int type)
{
	u32int h;
	IEntry *ie;
	
	h = hashbits(score, ih-&gt;bits);
	for(ie=ih-&gt;table[h]; ie; ie=ie-&gt;nexthash)
		if((type == -1 || type == ie-&gt;ia.type) &amp;&amp; scorecmp(score, ie-&gt;score) == 0)
			return ie;
	return nil;
}

static void
ihashdelete(IHash *ih, IEntry *ie, char *what)
{
	u32int h;
	IEntry **l;
	
	h = hashbits(ie-&gt;score, ih-&gt;bits);
	for(l=&amp;ih-&gt;table[h]; *l; l=&amp;(*l)-&gt;nexthash)
		if(*l == ie){
			*l = ie-&gt;nexthash;
			return;
		}
	fprint(2, "warning: %s %V not found in ihashdelete\n", what, ie-&gt;score);
}

static void
ihashinsert(IHash *ih, IEntry *ie)
{
	u32int h;
	
	h = hashbits(ie-&gt;score, ih-&gt;bits);
	ie-&gt;nexthash = ih-&gt;table[h];
	ih-&gt;table[h] = ie;
}


/*
 * IEntry lists.
 */

static IEntry*
popout(IEntry *ie)
{
	if(ie-&gt;prev == nil &amp;&amp; ie-&gt;next == nil)
		return ie;
	ie-&gt;prev-&gt;next = ie-&gt;next;
	ie-&gt;next-&gt;prev = ie-&gt;prev;
	ie-&gt;next = nil;
	ie-&gt;prev = nil;
	return ie;
}

static IEntry*
poplast(IEntry *list)
{
	if(list-&gt;prev == list)
		return nil;
	return popout(list-&gt;prev);
}

static IEntry*
pushfirst(IEntry *list, IEntry *ie)
{
	popout(ie);
	ie-&gt;prev = list;
	ie-&gt;next = list-&gt;next;
	ie-&gt;prev-&gt;next = ie;
	ie-&gt;next-&gt;prev = ie;
	return ie;
}

/*
 * Arena summary cache.
 */
struct ISum
{
	QLock	lock;
	IEntry	*entries;
	int	nentries;
	int	loaded;
	u64int addr;
	u64int limit;
	Arena *arena;
	int g;
};

static ISum*
scachelookup(u64int addr)
{
	int i;
	ISum *s;

	for(i=0; i&lt;icache.nsum; i++){
		s = icache.sum[i];
		if(s-&gt;addr &lt;= addr &amp;&amp; addr &lt; s-&gt;limit){
			if(i &gt; 0){
				memmove(icache.sum+1, icache.sum, i*sizeof icache.sum[0]);
				icache.sum[0] = s;
			}
			return s;
		}
	}
	return nil;
}

static void
sumclear(ISum *s)
{
	int i;

	for(i=0; i&lt;s-&gt;nentries; i++)
		ihashdelete(icache.shash, &amp;s-&gt;entries[i], "scache");
	s-&gt;nentries = 0;
	s-&gt;loaded = 0;
	s-&gt;addr = 0;
	s-&gt;limit = 0;
	s-&gt;arena = nil;
	s-&gt;g = 0;
}

static ISum*
scacheevict(void)
{
	ISum *s;
	int i;
	
	for(i=icache.nsum-1; i&gt;=0; i--){
		s = icache.sum[i];
		if(canqlock(&amp;s-&gt;lock)){
			if(i &gt; 0){
				memmove(icache.sum+1, icache.sum, i*sizeof icache.sum[0]);
				icache.sum[0] = s;
			}
			sumclear(s);
			return s;
		}
	}
	return nil;
}

static void
scachehit(u64int addr)
{
	scachelookup(addr);	/* for move-to-front */
}

static void
scachesetup(ISum *s, u64int addr)
{
	u64int addr0, limit;
	int g;

	s-&gt;arena = amapitoag(mainindex, addr, &amp;addr0, &amp;limit, &amp;g);
	s-&gt;addr = addr0;
	s-&gt;limit = limit;
	s-&gt;g = g;
}

static void
scacheload(ISum *s)
{
	int i, n;

	s-&gt;loaded = 1;
	n = asumload(s-&gt;arena, s-&gt;g, s-&gt;entries, ArenaCIGSize);
	/*
	 * n can be less then ArenaCIGSize, either if the clump group
	 * is the last in the arena and is only partially filled, or if there
	 * are corrupt clumps in the group -- those are not returned.
	 */
	for(i=0; i&lt;n; i++){
		s-&gt;entries[i].ia.addr += s-&gt;addr;
		ihashinsert(icache.shash, &amp;s-&gt;entries[i]);
	}
//fprint(2, "%T scacheload %s %d - %d entries\n", s-&gt;arena-&gt;name, s-&gt;g, n);
	addstat(StatScachePrefetch, n);
	s-&gt;nentries = n;
}

static ISum*
scachemiss(u64int addr)
{
	ISum *s;

	if(!icacheprefetch)
		return nil;
	s = scachelookup(addr);
	if(s == nil){
		/* first time: make an entry in the cache but don't populate it yet */
		s = scacheevict();
		if(s == nil)
			return nil;
		scachesetup(s, addr);
		qunlock(&amp;s-&gt;lock);
		return nil;
	}

	/* second time: load from disk */
	qlock(&amp;s-&gt;lock);
	if(s-&gt;loaded || !icacheprefetch){
		qunlock(&amp;s-&gt;lock);
		return nil;
	}
	
	return s;	/* locked */
}

/*
 * Index cache.
 */

void
initicache(u32int mem0)
{
	u32int mem;
	int i, entries, scache;
	
	icache.full.l = &amp;icache.lock;

	mem = mem0;
	entries = mem / (sizeof(IEntry)+sizeof(IEntry*));
	scache = (entries/8) / ArenaCIGSize;
	entries -= entries/8;
	if(scache &lt; 4)
		scache = 4;
	if(scache &gt; 16)
		scache = 16;
	if(entries &lt; 1000)
		entries = 1000;
fprint(2, "icache %,d bytes = %,d entries; %d scache\n", mem0, entries, scache);

	icache.clean.prev = icache.clean.next = &amp;icache.clean;
	icache.dirty.prev = icache.dirty.next = &amp;icache.dirty;
	icache.free.prev = icache.free.next = &amp;icache.free;
	
	icache.hash = mkihash(entries);
	icache.nentries = entries;
	setstat(StatIcacheSize, entries);
	icache.entries = vtmallocz(entries*sizeof icache.entries[0]);
	icache.maxdirty = entries / 2;
	for(i=0; i&lt;entries; i++)
		pushfirst(&amp;icache.free, &amp;icache.entries[i]);

	icache.nsum = scache;
	icache.sum = vtmallocz(scache*sizeof icache.sum[0]);
	icache.sum[0] = vtmallocz(scache*sizeof icache.sum[0][0]);
	icache.nsentries = scache * ArenaCIGSize;
	icache.sentries = vtmallocz(scache*ArenaCIGSize*sizeof icache.sentries[0]);
	icache.shash = mkihash(scache*ArenaCIGSize);
	for(i=0; i&lt;scache; i++){
		icache.sum[i] = icache.sum[0] + i;
		icache.sum[i]-&gt;entries = icache.sentries + i*ArenaCIGSize;
	}
}


static IEntry*
evictlru(void)
{
	IEntry *ie;
	
	ie = poplast(&amp;icache.clean);
	if(ie == nil)
		return nil;
	ihashdelete(icache.hash, ie, "evictlru");
	return ie;
}

static void
icacheinsert(u8int score[VtScoreSize], IAddr *ia, int state)
{
	IEntry *ie;

	if((ie = poplast(&amp;icache.free)) == nil &amp;&amp; (ie = evictlru()) == nil){
		addstat(StatIcacheStall, 1);
		while((ie = poplast(&amp;icache.free)) == nil &amp;&amp; (ie = evictlru()) == nil){
			// Could safely return here if state == IEClean.
			// But if state == IEDirty, have to wait to make
			// sure we don't lose an index write.  
			// Let's wait all the time.
			flushdcache();
			kickicache();
			rsleep(&amp;icache.full);
		}
		addstat(StatIcacheStall, -1);
	}

	memmove(ie-&gt;score, score, VtScoreSize);
	ie-&gt;state = state;
	ie-&gt;ia = *ia;
	if(state == IEClean){
		addstat(StatIcachePrefetch, 1);
		pushfirst(&amp;icache.clean, ie);
	}else{
		addstat(StatIcacheWrite, 1);
		assert(state == IEDirty);
		icache.ndirty++;
		setstat(StatIcacheDirty, icache.ndirty);
		delaykickicache();
		pushfirst(&amp;icache.dirty, ie);
	}
	ihashinsert(icache.hash, ie);
}

int
icachelookup(u8int score[VtScoreSize], int type, IAddr *ia)
{
	IEntry *ie;

	qlock(&amp;icache.lock);
	addstat(StatIcacheLookup, 1);
	if((ie = ihashlookup(icache.hash, score, type)) != nil){
		*ia = ie-&gt;ia;
		if(ie-&gt;state == IEClean)
			pushfirst(&amp;icache.clean, ie);
		addstat(StatIcacheHit, 1);
		qunlock(&amp;icache.lock);
		return 0;
	}

	if((ie = ihashlookup(icache.shash, score, type)) != nil){
		*ia = ie-&gt;ia;
		icacheinsert(score, &amp;ie-&gt;ia, IEClean);
		scachehit(ie-&gt;ia.addr);
		addstat(StatScacheHit, 1);
		qunlock(&amp;icache.lock);
		return 0;
	}
	addstat(StatIcacheMiss, 1);
	qunlock(&amp;icache.lock);

	return -1;
}

int
insertscore(u8int score[VtScoreSize], IAddr *ia, int state, AState *as)
{
	ISum *toload;

	qlock(&amp;icache.lock);
	icacheinsert(score, ia, state);
	if(state == IEClean)
		toload = scachemiss(ia-&gt;addr);
	else{
		assert(state == IEDirty);
		toload = nil;
		if(as == nil)
			fprint(2, "%T insertscore IEDirty without as; called from %#p\n",
				getcallerpc(&amp;score));
		else{
			if(icache.as.aa &gt; as-&gt;aa)
				fprint(2, "%T insertscore: aa moving backward: %#llux -&gt; %#llux\n", icache.as.aa, as-&gt;aa);
			icache.as = *as;
		}
	}
	qunlock(&amp;icache.lock);
	if(toload){
		scacheload(toload);
		qunlock(&amp;toload-&gt;lock);
	}
	
	if(icache.ndirty &gt;= icache.maxdirty)
		kickicache();

	/*
	 * It's okay not to do this under icache.lock.
	 * Calling insertscore only happens when we hold
	 * the lump, meaning any searches for this block
	 * will hit in the lump cache until after we return.
	 */
	if(state == IEDirty)
		markbloomfilter(mainindex-&gt;bloom, score);

	return 0;
}

int
lookupscore(u8int score[VtScoreSize], int type, IAddr *ia)
{
	int ms, ret;
	IEntry d;

	if(icachelookup(score, type, ia) &gt;= 0){
		addstat(StatIcacheRead, 1);
		return 0;
	}

	ms = msec();
	addstat(StatIcacheFill, 1);
	if(loadientry(mainindex, score, type, &amp;d) &lt; 0)
		ret = -1;
	else{
		ret = 0;
		insertscore(score, &amp;d.ia, IEClean, nil);
		*ia = d.ia;
	}
	addstat2(StatIcacheRead, 1, StatIcacheReadTime, msec() - ms);
	return ret;
}
	
u32int
hashbits(u8int *sc, int bits)
{
	u32int v;

	v = (sc[0] &lt;&lt; 24) | (sc[1] &lt;&lt; 16) | (sc[2] &lt;&lt; 8) | sc[3];
	if(bits &lt; 32)
		 v &gt;&gt;= (32 - bits);
	return v;
}

ulong
icachedirtyfrac(void)
{
	return (vlong)icache.ndirty*IcacheFrac / icache.nentries;
}

/*
 * Return a singly-linked list of dirty index entries.
 * with 32-bit hash numbers between lo and hi
 * and address &lt; limit.
 */
IEntry*
icachedirty(u32int lo, u32int hi, u64int limit)
{
	u32int h;
	IEntry *ie, *dirty;

	dirty = nil;
	trace(TraceProc, "icachedirty enter");
	qlock(&amp;icache.lock);
	for(ie = icache.dirty.next; ie != &amp;icache.dirty; ie=ie-&gt;next){
		if(ie-&gt;state == IEDirty &amp;&amp; ie-&gt;ia.addr &lt;= limit){
			h = hashbits(ie-&gt;score, 32);
			if(lo &lt;= h &amp;&amp; h &lt;= hi){
				ie-&gt;nextdirty = dirty;
				dirty = ie;
			}
		}
	}
	qunlock(&amp;icache.lock);
	trace(TraceProc, "icachedirty exit");
	if(dirty == nil)
		flushdcache();
	return dirty;
}

AState
icachestate(void)
{
	AState as;

	qlock(&amp;icache.lock);
	as = icache.as;
	qunlock(&amp;icache.lock);
	return as;
}

/*
 * The singly-linked non-circular list of index entries ie
 * has been written to disk.  Move them to the clean list.
 */
void
icacheclean(IEntry *ie)
{
	IEntry *next;
	
	trace(TraceProc, "icacheclean enter");
	qlock(&amp;icache.lock);
	for(; ie; ie=next){
		assert(ie-&gt;state == IEDirty);
		next = ie-&gt;nextdirty;
		ie-&gt;nextdirty = nil;
		popout(ie); /* from icache.dirty */
		icache.ndirty--;
		ie-&gt;state = IEClean;
		pushfirst(&amp;icache.clean, ie);
	}
	setstat(StatIcacheDirty, icache.ndirty);
	rwakeupall(&amp;icache.full);
	qunlock(&amp;icache.lock);
	trace(TraceProc, "icacheclean exit");
}

void
emptyicache(void)
{
	int i;
	IEntry *ie;
	ISum *s;
	
	qlock(&amp;icache.lock);
	while((ie = evictlru()) != nil)
		pushfirst(&amp;icache.free, ie);
	for(i=0; i&lt;icache.nsum; i++){
		s = icache.sum[i];
		qlock(&amp;s-&gt;lock);
		sumclear(s);
		qunlock(&amp;s-&gt;lock);
	}
	qunlock(&amp;icache.lock);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

