<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/sortientry.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/sortientry.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include &lt;bio.h&gt;

typedef struct IEBuck	IEBuck;
typedef struct IEBucks	IEBucks;

enum
{
	ClumpChunks	= 32*1024
};

struct IEBuck
{
	u32int	head;		/* head of chain of chunks on the disk */
	u32int	used;		/* usage of the last chunk */
	u64int	total;		/* total number of bytes in this bucket */
	u8int	*buf;		/* chunk of entries for this bucket */
};

struct IEBucks
{
	Part	*part;
	u64int	off;		/* offset for writing data in the partition */
	u32int	chunks;		/* total chunks written to fd */
	u64int	max;		/* max bytes entered in any one bucket */
	int	bits;		/* number of bits in initial bucket sort */
	int	nbucks;		/* 1 &lt;&lt; bits, the number of buckets */
	u32int	size;		/* bytes in each of the buckets chunks */
	u32int	usable;		/* amount usable for IEntry data */
	u8int	*buf;		/* buffer for all chunks */
	u8int	*xbuf;
	IEBuck	*bucks;
};

#define	U32GET(p)	(((p)[0]&lt;&lt;24)|((p)[1]&lt;&lt;16)|((p)[2]&lt;&lt;8)|(p)[3])
#define	U32PUT(p,v)	(p)[0]=(v)&gt;&gt;24;(p)[1]=(v)&gt;&gt;16;(p)[2]=(v)&gt;&gt;8;(p)[3]=(v)

static IEBucks	*initiebucks(Part *part, int bits, u32int size);
static int	flushiebuck(IEBucks *ib, int b, int reset);
static int	flushiebucks(IEBucks *ib);
static u32int	sortiebuck(IEBucks *ib, int b);
static u64int	sortiebucks(IEBucks *ib);
static int	sprayientry(IEBucks *ib, IEntry *ie);
static u32int	readarenainfo(IEBucks *ib, Arena *arena, u64int a, Bloom *b);
static u32int	readiebuck(IEBucks *ib, int b);
static void	freeiebucks(IEBucks *ib);

/*
 * build a sorted file with all IEntries which should be in ix.
 * assumes the arenas' directories are up to date.
 * reads each, converts the entries to index entries,
 * and sorts them.
 */
u64int
sortrawientries(Index *ix, Part *tmp, u64int *base, Bloom *bloom)
{
	IEBucks *ib;
	u64int clumps, sorted;
	u32int n;
	int i, ok;

/* ZZZ should allow configuration of bits, bucket size */
	ib = initiebucks(tmp, 8, 64*1024);
	if(ib == nil){
		seterr(EOk, "can't create sorting buckets: %r");
		return TWID64;
	}
	ok = 0;
	clumps = 0;
	fprint(2, "constructing entry list\n");
	for(i = 0; i &lt; ix-&gt;narenas; i++){
		n = readarenainfo(ib, ix-&gt;arenas[i], ix-&gt;amap[i].start, bloom);
		if(n == TWID32){
			ok = -1;
			break;
		}
		clumps += n;
	}
	fprint(2, "sorting %lld entries\n", clumps);
	if(ok == 0){
		sorted = sortiebucks(ib);
		*base = (u64int)ib-&gt;chunks * ib-&gt;size;
		if(sorted != clumps){
			fprint(2, "sorting messed up: clumps=%lld sorted=%lld\n", clumps, sorted);
			ok = -1;
		}
	}
	freeiebucks(ib);
	if(ok &lt; 0)
		return TWID64;
	return clumps;
}

#define CHECK(cis)	if(((ulong*)cis)[-4] != 0xA110C09) xabort();

void
xabort(void)
{
	int *x;

	x = 0;
	*x = 0;
}

/*
 * read in all of the arena's clump directory,
 * convert to IEntry format, and bucket sort based
 * on the first few bits.
 */
static u32int
readarenainfo(IEBucks *ib, Arena *arena, u64int a, Bloom *b)
{
	IEntry ie;
	ClumpInfo *ci, *cis;
	u32int clump;
	int i, n, ok, nskip;

	if(arena-&gt;memstats.clumps)
		fprint(2, "\tarena %s: %d entries\n", arena-&gt;name, arena-&gt;memstats.clumps);
	else
		fprint(2, "[%s] ", arena-&gt;name);

	cis = MKN(ClumpInfo, ClumpChunks);
	ok = 0;
	nskip = 0;
	memset(&amp;ie, 0, sizeof(IEntry));
	for(clump = 0; clump &lt; arena-&gt;memstats.clumps; clump += n){
		n = ClumpChunks;
		if(n &gt; arena-&gt;memstats.clumps - clump)
			n = arena-&gt;memstats.clumps - clump;
		if(readclumpinfos(arena, clump, cis, n) != n){
			seterr(EOk, "arena directory read failed: %r");
			ok = -1;
			break;
		}

		for(i = 0; i &lt; n; i++){
			ci = &amp;cis[i];
			ie.ia.type = ci-&gt;type;
			ie.ia.size = ci-&gt;uncsize;
			ie.ia.addr = a;
			a += ci-&gt;size + ClumpSize;
			ie.ia.blocks = (ci-&gt;size + ClumpSize + (1 &lt;&lt; ABlockLog) - 1) &gt;&gt; ABlockLog;
			scorecp(ie.score, ci-&gt;score);
			if(ci-&gt;type == VtCorruptType){
				if(0) print("! %V %22lld %3d %5d %3d\n",
					ie.score, ie.ia.addr, ie.ia.type, ie.ia.size, ie.ia.blocks);
				nskip++;
			}else
				sprayientry(ib, &amp;ie);
			markbloomfilter(b, ie.score);
		}
	}
	free(cis);
	if(ok &lt; 0)
		return TWID32;
	return clump - nskip;
}

/*
 * initialize the external bucket sorting data structures
 */
static IEBucks*
initiebucks(Part *part, int bits, u32int size)
{
	IEBucks *ib;
	int i;

	ib = MKZ(IEBucks);
	if(ib == nil){
		seterr(EOk, "out of memory");
		return nil;
	}
	ib-&gt;bits = bits;
	ib-&gt;nbucks = 1 &lt;&lt; bits;
	ib-&gt;size = size;
	ib-&gt;usable = (size - U32Size) / IEntrySize * IEntrySize;
	ib-&gt;bucks = MKNZ(IEBuck, ib-&gt;nbucks);
	if(ib-&gt;bucks == nil){
		seterr(EOk, "out of memory allocation sorting buckets");
		freeiebucks(ib);
		return nil;
	}
	ib-&gt;xbuf = MKN(u8int, size * ((1 &lt;&lt; bits)+1));
	ib-&gt;buf = (u8int*)(((uintptr)ib-&gt;xbuf+size-1)&amp;~(uintptr)(size-1));
	if(ib-&gt;buf == nil){
		seterr(EOk, "out of memory allocating sorting buckets' buffers");
		freeiebucks(ib);
		return nil;
	}
	for(i = 0; i &lt; ib-&gt;nbucks; i++){
		ib-&gt;bucks[i].head = TWID32;
		ib-&gt;bucks[i].buf = &amp;ib-&gt;buf[i * size];
	}
	ib-&gt;part = part;
	return ib;
}

static void
freeiebucks(IEBucks *ib)
{
	if(ib == nil)
		return;
	free(ib-&gt;bucks);
	free(ib-&gt;buf);
	free(ib);
}

/*
 * initial sort: put the entry into the correct bucket
 */
static int
sprayientry(IEBucks *ib, IEntry *ie)
{
	u32int n;
	int b;

	b = hashbits(ie-&gt;score, ib-&gt;bits);
	n = ib-&gt;bucks[b].used;
	if(n + IEntrySize &gt; ib-&gt;usable){
		/* should be flushed below, but if flush fails, this can happen */
		seterr(EOk, "out of space in bucket");
		return -1;
	}
	packientry(ie, &amp;ib-&gt;bucks[b].buf[n]);
	n += IEntrySize;
	ib-&gt;bucks[b].used = n;
	if(n + IEntrySize &lt;= ib-&gt;usable)
		return 0;
	return flushiebuck(ib, b, 1);
}

/*
 * finish sorting:
 * for each bucket, read it in and sort it
 * write out the the final file
 */
static u64int
sortiebucks(IEBucks *ib)
{
	u64int tot;
	u32int n;
	int i;

	if(flushiebucks(ib) &lt; 0)
		return TWID64;
	for(i = 0; i &lt; ib-&gt;nbucks; i++)
		ib-&gt;bucks[i].buf = nil;
	ib-&gt;off = (u64int)ib-&gt;chunks * ib-&gt;size;
	free(ib-&gt;xbuf);

	ib-&gt;buf = MKN(u8int, ib-&gt;max + U32Size);
	if(ib-&gt;buf == nil){
		seterr(EOk, "out of memory allocating final sorting buffer; try more buckets");
		return TWID64;
	}
	tot = 0;
	for(i = 0; i &lt; ib-&gt;nbucks; i++){
		n = sortiebuck(ib, i);
		if(n == TWID32)
			return TWID64;
		if(n != ib-&gt;bucks[i].total/IEntrySize)
			fprint(2, "bucket %d changed count %d =&gt; %d\n", 
				i, (int)(ib-&gt;bucks[i].total/IEntrySize), n);
		tot += n;
	}
	return tot;
}

/*
 * sort from bucket b of ib into the output file to
 */
static u32int
sortiebuck(IEBucks *ib, int b)
{
	u32int n;

	n = readiebuck(ib, b);
	if(n == TWID32)
		return TWID32;
	qsort(ib-&gt;buf, n, IEntrySize, ientrycmp);
	if(writepart(ib-&gt;part, ib-&gt;off, ib-&gt;buf, n*IEntrySize) &lt; 0){
		seterr(EOk, "can't write sorted bucket: %r");
		return TWID32;
	}
	ib-&gt;off += n * IEntrySize;
	return n;
}

/*
 * write out a single bucket
 */
static int
flushiebuck(IEBucks *ib, int b, int reset)
{
	u32int n;

	if(ib-&gt;bucks[b].used == 0)
		return 0;
	n = ib-&gt;bucks[b].used;
	U32PUT(&amp;ib-&gt;bucks[b].buf[n], ib-&gt;bucks[b].head);
	n += U32Size;
	USED(n);
	if(writepart(ib-&gt;part, (u64int)ib-&gt;chunks * ib-&gt;size, ib-&gt;bucks[b].buf, ib-&gt;size) &lt; 0){
		seterr(EOk, "can't write sorting bucket to file: %r");
xabort();
		return -1;
	}
	ib-&gt;bucks[b].head = ib-&gt;chunks++;
	ib-&gt;bucks[b].total += ib-&gt;bucks[b].used;
	if(reset)
		ib-&gt;bucks[b].used = 0;
	return 0;
}

/*
 * write out all of the buckets, and compute
 * the maximum size of any bucket
 */
static int
flushiebucks(IEBucks *ib)
{
	int i;

	for(i = 0; i &lt; ib-&gt;nbucks; i++){
		if(flushiebuck(ib, i, 0) &lt; 0)
			return -1;
		if(ib-&gt;bucks[i].total &gt; ib-&gt;max)
			ib-&gt;max = ib-&gt;bucks[i].total;
	}
	return 0;
}

/*
 * read in the chained buffers for bucket b,
 * and return it's total number of IEntries
 */
static u32int
readiebuck(IEBucks *ib, int b)
{
	u32int head, m, n;

	head = ib-&gt;bucks[b].head;
	n = 0;
	m = ib-&gt;bucks[b].used;
	if(m == 0)
		m = ib-&gt;usable;
	if(0) if(ib-&gt;bucks[b].total)
		fprint(2, "\tbucket %d: %lld entries\n", b, ib-&gt;bucks[b].total/IEntrySize);
	while(head != TWID32){
		if(readpart(ib-&gt;part, (u64int)head * ib-&gt;size, &amp;ib-&gt;buf[n], m+U32Size) &lt; 0){
			seterr(EOk, "can't read index sort bucket: %r");
			return TWID32;
		}
		n += m;
		head = U32GET(&amp;ib-&gt;buf[n]);
		m = ib-&gt;usable;
	}
	if(n != ib-&gt;bucks[b].total)
		fprint(2, "\tbucket %d: expected %d entries, got %d\n",
			b, (int)ib-&gt;bucks[b].total/IEntrySize, n/IEntrySize);
	return n / IEntrySize;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

