<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/whack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/whack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "whack.h"

typedef struct Huff	Huff;
int compressblocks = 1;

enum
{
	MaxFastLen	= 9,
	BigLenCode	= 0x1f4,	/* minimum code for large lenth encoding */
	BigLenBits	= 9,
	BigLenBase	= 4,		/* starting items to encode for big lens */

	MinOffBits	= 6,
	MaxOffBits	= MinOffBits + 8,

	MaxLen		= 2051		/* max. length encodable in 24 bits */
};

enum
{
	StatBytes,
	StatOutBytes,
	StatLits,
	StatMatches,
	StatLitBits,
	StatOffBits,
	StatLenBits,

	MaxStat
};

struct Huff
{
	short	bits;				/* length of the code */
	ulong	encode;				/* the code */
};

static	Huff	lentab[MaxFastLen] =
{
	{2,	0x2},		/* 10 */
	{3,	0x6},		/* 110 */
	{5,	0x1c},		/* 11100 */
	{5,	0x1d},		/* 11101 */
	{6,	0x3c},		/* 111100 */
	{7,	0x7a},		/* 1111010 */
	{7,	0x7b},		/* 1111011 */
	{8,	0xf8},		/* 11111000 */
	{8,	0xf9},		/* 11111001 */
};

static int	thwmaxcheck;

void
whackinit(Whack *tw, int level)
{
	thwmaxcheck = (1 &lt;&lt; level);
	thwmaxcheck -= thwmaxcheck &gt;&gt; 2;
	if(thwmaxcheck &lt; 2)
		thwmaxcheck = 2;
	else if(thwmaxcheck &gt; 1024)
		thwmaxcheck = 1024;
	memset(tw, 0, sizeof *tw);
	tw-&gt;begin = 2 * WhackMaxOff;
}

/*
 * find a string in the dictionary
 */
static int
whackmatch(Whack *b, uchar **ss, uchar *esrc, ulong h, ulong now)
{
	ushort then, off, last;
	int bestoff, bestlen, check;
	uchar *s, *t;

	s = *ss;
	if(esrc &lt; s + MinMatch)
		return -1;
	if(s + MaxLen &lt; esrc)
		esrc = s + MaxLen;

	bestoff = 0;
	bestlen = 0;
	check = thwmaxcheck;
	last = 0;
	for(then = b-&gt;hash[h]; check-- &gt; 0; then = b-&gt;next[then &amp; (WhackMaxOff - 1)]){
		off = now - then;
		if(off &lt;= last || off &gt; WhackMaxOff)
			break;

		/*
		 * don't need to check for the end because
		 * 1) s too close check above
		 */
		t = s - off;
		if(s[0] == t[0] &amp;&amp; s[1] == t[1] &amp;&amp; s[2] == t[2]){
			if(!bestlen || esrc - s &gt; bestlen &amp;&amp; s[bestlen] == t[bestlen]){
				t += 3;
				for(s += 3; s &lt; esrc; s++){
					if(*s != *t)
						break;
					t++;
				}
				if(s - *ss &gt; bestlen){
					bestlen = s - *ss;
					bestoff = off;
					if(bestlen &gt; thwmaxcheck)
						break;
				}
			}
		}
		s = *ss;
		last = off;
	}
	*ss += bestlen;
	return bestoff;
}

/*
 * knuth vol. 3 multiplicative hashing
 * each byte x chosen according to rules
 * 1/4 &lt; x &lt; 3/10, 1/3 x &lt; &lt; 3/7, 4/7 &lt; x &lt; 2/3, 7/10 &lt; x &lt; 3/4
 * with reasonable spread between the bytes &amp; their complements
 *
 * the 3 byte value appears to be as almost good as the 4 byte value,
 * and might be faster on some machines
 */
/*
#define hashit(c)	((((ulong)(c) * 0x6b43a9) &gt;&gt; (24 - HashLog)) &amp; HashMask)
*/
#define hashit(c)	(((((ulong)(c) &amp; 0xffffff) * 0x6b43a9b5) &gt;&gt; (32 - HashLog)) &amp; HashMask)

/*
 * lz77 compression with single lookup in a hash table for each block
 */
int
whack(Whack *w, uchar *dst, uchar *src, int n, ulong stats[WhackStats])
{
	uchar *s, *ss, *sss, *esrc, *half, *wdst, *wdmax;
	ulong cont, code, wbits;
	ushort now;
	int toff, lithist, h, len, bits, use, wnbits, lits, matches, offbits, lenbits;

	if(!compressblocks || n &lt; MinMatch)
		return -1;

	wdst = dst;
	wdmax = dst + n;

	now = w-&gt;begin;
	s = src;
	w-&gt;data = s;

	cont = (s[0] &lt;&lt; 16) | (s[1] &lt;&lt; 8) | s[2];

	esrc = s + n;
	half = s + (n &gt;&gt; 1);
	wnbits = 0;
	wbits = 0;
	lits = 0;
	matches = 0;
	offbits = 0;
	lenbits = 0;
	lithist = ~0;
	while(s &lt; esrc){
		h = hashit(cont);

		sss = s;
		toff = whackmatch(w, &amp;sss, esrc, h, now);
		ss = sss;

		len = ss - s;
		for(; wnbits &gt;= 8; wnbits -= 8){
			if(wdst &gt;= wdmax){
				w-&gt;begin = now;
				return -1;
			}
			*wdst++ = wbits &gt;&gt; (wnbits - 8);
		}
		if(len &lt; MinMatch){
			toff = *s;
			lithist = (lithist &lt;&lt; 1) | toff &lt; 32 | toff &gt; 127;
			if(lithist &amp; 0x1e){
				wbits = (wbits &lt;&lt; 9) | toff;
				wnbits += 9;
			}else if(lithist &amp; 1){
				toff = (toff + 64) &amp; 0xff;
				if(toff &lt; 96){
					wbits = (wbits &lt;&lt; 10) | toff;
					wnbits += 10;
				}else{
					wbits = (wbits &lt;&lt; 11) | toff;
					wnbits += 11;
				}
			}else{
				wbits = (wbits &lt;&lt; 8) | toff;
				wnbits += 8;
			}
			lits++;

			/*
			 * speed hack
			 * check for compression progress, bail if none achieved
			 */
			if(s &gt; half){
				if(4 * (s - src) &lt; 5 * lits){
					w-&gt;begin = now;
					return -1;
				}
				half = esrc;
			}

			if(s + MinMatch &lt;= esrc){
				w-&gt;next[now &amp; (WhackMaxOff - 1)] = w-&gt;hash[h];
				w-&gt;hash[h] = now;
				if(s + MinMatch &lt; esrc)
					cont = (cont &lt;&lt; 8) | s[MinMatch];
			}
			now++;
			s++;
			continue;
		}

		matches++;

		/*
		 * length of match
		 */
		if(len &gt; MaxLen){
			len = MaxLen;
			ss = s + len;
		}
		len -= MinMatch;
		if(len &lt; MaxFastLen){
			bits = lentab[len].bits;
			wbits = (wbits &lt;&lt; bits) | lentab[len].encode;
			wnbits += bits;
			lenbits += bits;
		}else{
			code = BigLenCode;
			bits = BigLenBits;
			use = BigLenBase;
			len -= MaxFastLen;
			while(len &gt;= use){
				len -= use;
				code = (code + use) &lt;&lt; 1;
				use &lt;&lt;= (bits &amp; 1) ^ 1;
				bits++;
			}

			wbits = (wbits &lt;&lt; bits) | (code + len);
			wnbits += bits;
			lenbits += bits;

			for(; wnbits &gt;= 8; wnbits -= 8){
				if(wdst &gt;= wdmax){
					w-&gt;begin = now;
					return -1;
				}
				*wdst++ = wbits &gt;&gt; (wnbits - 8);
			}
		}

		/*
		 * offset in history
		 */
		toff--;
		for(bits = MinOffBits; toff &gt;= (1 &lt;&lt; bits); bits++)
			;
		if(bits &lt; MaxOffBits-1){
			wbits = (wbits &lt;&lt; 3) | (bits - MinOffBits);
			if(bits != MinOffBits)
				bits--;
			wnbits += bits + 3;
			offbits += bits + 3;
		}else{
			wbits = (wbits &lt;&lt; 4) | 0xe | (bits - (MaxOffBits-1));
			bits--;
			wnbits += bits + 4;
			offbits += bits + 4;
		}
		wbits = (wbits &lt;&lt; bits) | toff &amp; ((1 &lt;&lt; bits) - 1);

		for(; s != ss; s++){
			if(s + MinMatch &lt;= esrc){
				h = hashit(cont);
				w-&gt;next[now &amp; (WhackMaxOff - 1)] = w-&gt;hash[h];
				w-&gt;hash[h] = now;
				if(s + MinMatch &lt; esrc)
					cont = (cont &lt;&lt; 8) | s[MinMatch];
			}
			now++;
		}
	}

	w-&gt;begin = now;

	stats[StatBytes] += esrc - src;
	stats[StatLits] += lits;
	stats[StatMatches] += matches;
	stats[StatLitBits] += (wdst - (dst + 2)) * 8 + wnbits - offbits - lenbits;
	stats[StatOffBits] += offbits;
	stats[StatLenBits] += lenbits;

	if(wnbits &amp; 7){
		wbits &lt;&lt;= 8 - (wnbits &amp; 7);
		wnbits += 8 - (wnbits &amp; 7);
	}
	for(; wnbits &gt;= 8; wnbits -= 8){
		if(wdst &gt;= wdmax)
			return -1;
		*wdst++ = wbits &gt;&gt; (wnbits - 8);
	}

	stats[StatOutBytes] += wdst - dst;

	return wdst - dst;
}

int
whackblock(uchar *dst, uchar *src, int ssize)
{
	Whack w;
	ulong stats[MaxStat];
	int r;

	whackinit(&amp;w, 6);
	r = whack(&amp;w, dst, src, ssize, stats);
	return r;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

