<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vl/noop.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vl/noop.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

/*
 * flag: insert nops to prevent three consecutive stores.
 * workaround for 24k erratum #48, costs about 10% in text space,
 * so only enable this if you need it.  test cases are "hoc -e '7^6'"
 * and "{ echo moon; echo plot } | scat".
 */
enum {
	Mips24k	= 0,
};

static int
isdblwrdmov(Prog *p)
{
	if(p == nil)
		return 0;
	switch(p-&gt;as){
	case AMOVD:
	case AMOVDF:
	case AMOVDW:
	case AMOVFD:
	case AMOVWD:
	case AMOVV:
	case AMOVVL:
	case AMOVVR:
	case AMOVFV:
	case AMOVDV:
	case AMOVVF:
	case AMOVVD:
		return 1;
	}
	return 0;
}

static int
ismove(Prog *p)
{
	if(p == nil)
		return 0;
	switch(p-&gt;as){
	case AMOVB:
	case AMOVBU:
	case AMOVF:
	case AMOVFW:
	case AMOVH:
	case AMOVHU:
	case AMOVW:
	case AMOVWF:
	case AMOVWL:
	case AMOVWR:
	case AMOVWU:
		return 1;
	}
	if(isdblwrdmov(p))
		return 1;
	return 0;
}

static int
isstore(Prog *p)
{
	if(p == nil)
		return 0;
	if(ismove(p))
		switch(p-&gt;to.type) {
		case D_OREG:
		case D_EXTERN:
		case D_STATIC:
		case D_AUTO:
		case D_PARAM:
			return 1;
		}
	return 0;
}

static int
iscondbranch(Prog *p)
{
	if(p == nil)
		return 0;
	switch(p-&gt;as){
	case ABEQ:
	case ABFPF:
	case ABFPT:
	case ABGEZ:
	case ABGEZAL:
	case ABGTZ:
	case ABLEZ:
	case ABLTZ:
	case ABLTZAL:
	case ABNE:
		return 1;
	}
	return 0;
}

static int
isbranch(Prog *p)
{
	if(p == nil)
		return 0;
	switch(p-&gt;as){
	case AJAL:
	case AJMP:
	case ARET:
	case ARFE:
		return 1;
	}
	if(iscondbranch(p))
		return 1;
	return 0;
}

static void
nopafter(Prog *p)
{
	p-&gt;mark |= LABEL|SYNC;
	addnop(p);
}

/*
 * workaround for 24k erratum #48, costs about 0.5% in space.
 * inserts a NOP before the last of 3 consecutive stores.
 * double-word stores complicate things.
 */
static int
no3stores(Prog *p)
{
	Prog *p1;

	if(!isstore(p))
		return 0;
	p1 = p-&gt;link;
	if(!isstore(p1))
		return 0;
	if(isdblwrdmov(p) || isdblwrdmov(p1)) {
		nopafter(p);
		nop.store.count++;
		nop.store.outof++;
		return 1;
	}
	if(isstore(p1-&gt;link)) {
		nopafter(p1);
		nop.store.count++;
		nop.store.outof++;
		return 1;
	}
	return 0;
}

/*
 * keep stores out of branch delay slots.
 * this is costly in space (the other 9.5%), but makes no3stores effective.
 * there is undoubtedly a better way to do this.
 */
void
storesnosched(void)
{
	Prog *p;

	for(p = firstp; p != P; p = p-&gt;link)
		if(isstore(p))
			p-&gt;mark |= NOSCHED;
}

int
triplestorenops(void)
{
	int r;
	Prog *p, *p1;

	r = 0;
	for(p = firstp; p != P; p = p1) {
		p1 = p-&gt;link;
//		if (p-&gt;mark &amp; NOSCHED)
//			continue;
		if(ismove(p) &amp;&amp; isstore(p)) {
			if (no3stores(p))
				r++;
			/*
			 * given storenosched, the next two
			 * checks shouldn't be necessary.
			 */
			/*
			 * add nop after first MOV in `MOV; Bcond; MOV'.
			 */
			else if(isbranch(p1) &amp;&amp; isstore(p1-&gt;link)) {
				nopafter(p);
				nop.branch.count++;
				nop.branch.outof++;
				r++;
			}
			/*
			 * this may be a branch target, so insert a nop after,
			 * in case a branch leading here has a store in its
			 * delay slot and we have consecutive stores here.
			 */
			if(p-&gt;mark &amp; (LABEL|SYNC) &amp;&amp; !isnop(p1)) {
				nopafter(p);
				nop.branch.count++;
				nop.branch.outof++;
				r++;
			}
		} else if (isbranch(p))
			/*
			 * can't ignore delay slot of a conditional branch;
			 * the branch could fail and fall through.
			 */
			if (!iscondbranch(p) &amp;&amp; p1)
				p1 = p1-&gt;link;	/* skip its delay slot */
	}
	return r;
}

void
noops(void)
{
	Prog *p, *p1, *q, *q1;
	int o, curframe, curbecome, maxbecome;

	/*
	 * find leaf subroutines
	 * become sizes
	 * frame sizes
	 * strip NOPs
	 * expand RET
	 * expand BECOME pseudo
	 */

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f noops\n", cputime());
	Bflush(&amp;bso);

	curframe = 0;
	curbecome = 0;
	maxbecome = 0;
	curtext = 0;

	q = P;
	for(p = firstp; p != P; p = p-&gt;link) {

		/* find out how much arg space is used in this TEXT */
		if(p-&gt;to.type == D_OREG &amp;&amp; p-&gt;to.reg == REGSP)
			if(p-&gt;to.offset &gt; curframe)
				curframe = p-&gt;to.offset;

		switch(p-&gt;as) {
		case ATEXT:
			if(curtext &amp;&amp; curtext-&gt;from.sym) {
				curtext-&gt;from.sym-&gt;frame = curframe;
				curtext-&gt;from.sym-&gt;become = curbecome;
				if(curbecome &gt; maxbecome)
					maxbecome = curbecome;
			}
			curframe = 0;
			curbecome = 0;

			p-&gt;mark |= LABEL|LEAF|SYNC;
			if(p-&gt;link)
				p-&gt;link-&gt;mark |= LABEL;
			curtext = p;
			break;

		/* too hard, just leave alone */
		case AMOVW:
			if(p-&gt;to.type == D_FCREG ||
			   p-&gt;to.type == D_MREG) {
				p-&gt;mark |= LABEL|SYNC;
				break;
			}
			if(p-&gt;from.type == D_FCREG ||
			   p-&gt;from.type == D_MREG) {
				p-&gt;mark |= LABEL|SYNC;
				addnop(p);
				addnop(p);
				nop.mfrom.count += 2;
				nop.mfrom.outof += 2;
				break;
			}
			break;

		/* too hard, just leave alone */
		case ACASE:
		case ASYSCALL:
		case AWORD:
		case ATLBWR:
		case ATLBWI:
		case ATLBP:
		case ATLBR:
			p-&gt;mark |= LABEL|SYNC;
			break;

		case ANOR:
			if(p-&gt;to.type == D_REG &amp;&amp; p-&gt;to.reg == REGZERO)
				p-&gt;mark |= LABEL|SYNC;
			break;

		case ARET:
			/* special form of RET is BECOME */
			if(p-&gt;from.type == D_CONST)
				if(p-&gt;from.offset &gt; curbecome)
					curbecome = p-&gt;from.offset;

			if(p-&gt;link != P)
				p-&gt;link-&gt;mark |= LABEL;
			break;

		case ANOP:
			q1 = p-&gt;link;
			q-&gt;link = q1;		/* q is non-nop */
			q1-&gt;mark |= p-&gt;mark;
			continue;

		case ABCASE:
			p-&gt;mark |= LABEL|SYNC;
			goto dstlab;

		case ABGEZAL:
		case ABLTZAL:
		case AJAL:
			if(curtext != P)
				curtext-&gt;mark &amp;= ~LEAF;

		case AJMP:
		case ABEQ:
		case ABGEZ:
		case ABGTZ:
		case ABLEZ:
		case ABLTZ:
		case ABNE:
		case ABFPT:
		case ABFPF:
			p-&gt;mark |= BRANCH;

		dstlab:
			q1 = p-&gt;cond;
			if(q1 != P) {
				while(q1-&gt;as == ANOP) {
					q1 = q1-&gt;link;
					p-&gt;cond = q1;
				}
				if(!(q1-&gt;mark &amp; LEAF))
					q1-&gt;mark |= LABEL;
			} else
				p-&gt;mark |= LABEL;
			q1 = p-&gt;link;
			if(q1 != P)
				q1-&gt;mark |= LABEL;
			break;
		}
		q = p;
	}

	if(curtext &amp;&amp; curtext-&gt;from.sym) {
		curtext-&gt;from.sym-&gt;frame = curframe;
		curtext-&gt;from.sym-&gt;become = curbecome;
		if(curbecome &gt; maxbecome)
			maxbecome = curbecome;
	}

	if(debug['b'])
		print("max become = %d\n", maxbecome);
	xdefine("ALEFbecome", STEXT, maxbecome);

	curtext = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		switch(p-&gt;as) {
		case ATEXT:
			curtext = p;
			break;
		case AJAL:
			if(curtext != P &amp;&amp; curtext-&gt;from.sym != S &amp;&amp; curtext-&gt;to.offset &gt;= 0) {
				o = maxbecome - curtext-&gt;from.sym-&gt;frame;
				if(o &lt;= 0)
					break;
				/* calling a become or calling a variable */
				if(p-&gt;to.sym == S || p-&gt;to.sym-&gt;become) {
					curtext-&gt;to.offset += o;
					if(debug['b']) {
						curp = p;
						print("%D calling %D increase %d\n",
							&amp;curtext-&gt;from, &amp;p-&gt;to, o);
					}
				}
			}
			break;
		}
	}

	for(p = firstp; p != P; p = p-&gt;link) {
		o = p-&gt;as;
		switch(o) {
		case ATEXT:
			curtext = p;
			autosize = p-&gt;to.offset + 4;
			if(autosize &lt;= 4)
			if(curtext-&gt;mark &amp; LEAF) {
				p-&gt;to.offset = -4;
				autosize = 0;
			}

			q = p;
			if(autosize) {
				q = prg();
				q-&gt;as = AADD;
				q-&gt;line = p-&gt;line;
				q-&gt;from.type = D_CONST;
				q-&gt;from.offset = -autosize;
				q-&gt;to.type = D_REG;
				q-&gt;to.reg = REGSP;

				q-&gt;link = p-&gt;link;
				p-&gt;link = q;
			} else
			if(!(curtext-&gt;mark &amp; LEAF)) {
				if(debug['v'])
					Bprint(&amp;bso, "save suppressed in: %s\n",
						curtext-&gt;from.sym-&gt;name);
				Bflush(&amp;bso);
				curtext-&gt;mark |= LEAF;
			}

			if(curtext-&gt;mark &amp; LEAF) {
				if(curtext-&gt;from.sym)
					curtext-&gt;from.sym-&gt;type = SLEAF;
				break;
			}

			q1 = prg();
			q1-&gt;as = AMOVW;
			q1-&gt;line = p-&gt;line;
			q1-&gt;from.type = D_REG;
			q1-&gt;from.reg = REGLINK;
			q1-&gt;to.type = D_OREG;
			q1-&gt;from.offset = 0;
			q1-&gt;to.reg = REGSP;

			q1-&gt;link = q-&gt;link;
			q-&gt;link = q1;
			break;

		case ARET:
			nocache(p);
			if(p-&gt;from.type == D_CONST)
				goto become;
			if(curtext-&gt;mark &amp; LEAF) {
				if(!autosize) {
					p-&gt;as = AJMP;
					p-&gt;from = zprg.from;
					p-&gt;to.type = D_OREG;
					p-&gt;to.offset = 0;
					p-&gt;to.reg = REGLINK;
					p-&gt;mark |= BRANCH;
					break;
				}

				p-&gt;as = AADD;
				p-&gt;from.type = D_CONST;
				p-&gt;from.offset = autosize;
				p-&gt;to.type = D_REG;
				p-&gt;to.reg = REGSP;

				q = prg();
				q-&gt;as = AJMP;
				q-&gt;line = p-&gt;line;
				q-&gt;to.type = D_OREG;
				q-&gt;to.offset = 0;
				q-&gt;to.reg = REGLINK;
				q-&gt;mark |= BRANCH;

				q-&gt;link = p-&gt;link;
				p-&gt;link = q;
				break;
			}
			p-&gt;as = AMOVW;
			p-&gt;from.type = D_OREG;
			p-&gt;from.offset = 0;
			p-&gt;from.reg = REGSP;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = 2;

			q = p;
			if(autosize) {
				q = prg();
				q-&gt;as = AADD;
				q-&gt;line = p-&gt;line;
				q-&gt;from.type = D_CONST;
				q-&gt;from.offset = autosize;
				q-&gt;to.type = D_REG;
				q-&gt;to.reg = REGSP;

				q-&gt;link = p-&gt;link;
				p-&gt;link = q;
			}

			q1 = prg();
			q1-&gt;as = AJMP;
			q1-&gt;line = p-&gt;line;
			q1-&gt;to.type = D_OREG;
			q1-&gt;to.offset = 0;
			q1-&gt;to.reg = 2;
			q1-&gt;mark |= BRANCH;

			q1-&gt;link = q-&gt;link;
			q-&gt;link = q1;
			break;

		become:
			if(curtext-&gt;mark &amp; LEAF) {

				q = prg();
				q-&gt;line = p-&gt;line;
				q-&gt;as = AJMP;
				q-&gt;from = zprg.from;
				q-&gt;to = p-&gt;to;
				q-&gt;cond = p-&gt;cond;
				q-&gt;link = p-&gt;link;
				q-&gt;mark |= BRANCH;
				p-&gt;link = q;

				p-&gt;as = AADD;
				p-&gt;from = zprg.from;
				p-&gt;from.type = D_CONST;
				p-&gt;from.offset = autosize;
				p-&gt;to = zprg.to;
				p-&gt;to.type = D_REG;
				p-&gt;to.reg = REGSP;

				break;
			}
			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;as = AJMP;
			q-&gt;from = zprg.from;
			q-&gt;to = p-&gt;to;
			q-&gt;cond = p-&gt;cond;
			q-&gt;link = p-&gt;link;
			q-&gt;mark |= BRANCH;
			p-&gt;link = q;

			q = prg();
			q-&gt;line = p-&gt;line;
			q-&gt;as = AADD;
			q-&gt;from.type = D_CONST;
			q-&gt;from.offset = autosize;
			q-&gt;to.type = D_REG;
			q-&gt;to.reg = REGSP;
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;

			p-&gt;as = AMOVW;
			p-&gt;from = zprg.from;
			p-&gt;from.type = D_OREG;
			p-&gt;from.offset = 0;
			p-&gt;from.reg = REGSP;
			p-&gt;to = zprg.to;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGLINK;

			break;
		}
	}
	if (Mips24k)
		storesnosched();

	curtext = P;
	q = P;		/* p - 1 */
	q1 = firstp;	/* top of block */
	o = 0;		/* count of instructions */
	for(p = firstp; p != P; p = p1) {
		p1 = p-&gt;link;
		o++;
		if(p-&gt;mark &amp; NOSCHED){
			if(q1 != p){
				sched(q1, q);
			}
			for(; p != P; p = p-&gt;link){
				if(!(p-&gt;mark &amp; NOSCHED))
					break;
				q = p;
			}
			p1 = p;
			q1 = p;
			o = 0;
			continue;
		}
		if(p-&gt;mark &amp; (LABEL|SYNC)) {
			if(q1 != p)
				sched(q1, q);
			q1 = p;
			o = 1;
		}
		if(p-&gt;mark &amp; (BRANCH|SYNC)) {
			sched(q1, p);
			q1 = p1;
			o = 0;
		}
		if(o &gt;= NSCHED) {
			sched(q1, p);
			q1 = p1;
			o = 0;
		}
		q = p;
	}

	if (Mips24k)
		triplestorenops();
}

void
addnop(Prog *p)
{
	Prog *q;

	q = prg();
	q-&gt;as = ANOR;
	q-&gt;line = p-&gt;line;
	q-&gt;from.type = D_REG;
	q-&gt;from.reg = REGZERO;
	q-&gt;to.type = D_REG;
	q-&gt;to.reg = REGZERO;

	q-&gt;link = p-&gt;link;
	p-&gt;link = q;
}

void
nocache(Prog *p)
{
	p-&gt;optab = 0;
	p-&gt;from.class = 0;
	p-&gt;to.class = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

