<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vl/pass.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vl/pass.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

void
dodata(void)
{
	int i, t;
	Sym *s;
	Prog *p, *p1;
	long orig, orig1, v;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f dodata\n", cputime());
	Bflush(&amp;bso);
	for(p = datap; p != P; p = p-&gt;link) {
		s = p-&gt;from.sym;
		if(p-&gt;as == ADYNT || p-&gt;as == AINIT)
			s-&gt;value = dtype;
		if(s-&gt;type == SBSS)
			s-&gt;type = SDATA;
		if(s-&gt;type != SDATA)
			diag("initialize non-data (%d): %s\n%P",
				s-&gt;type, s-&gt;name, p);
		v = p-&gt;from.offset + p-&gt;reg;
		if(v &gt; s-&gt;value)
			diag("initialize bounds (%lld): %s\n%P",
				s-&gt;value, s-&gt;name, p);
	}

	if(debug['t']) {
		/*
		 * pull out string constants
		 */
		for(p = datap; p != P; p = p-&gt;link) {
			s = p-&gt;from.sym;
			if(p-&gt;to.type == D_SCONST)
				s-&gt;type = SSTRING;
		}
	}

	/*
	 * pass 1
	 *	assign 'small' variables to data segment
	 *	(rational is that data segment is more easily
	 *	 addressed through offset on R30)
	 */
	orig = 0;
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		t = s-&gt;type;
		if(t != SDATA &amp;&amp; t != SBSS)
			continue;
		v = s-&gt;value;
		if(v == 0) {
			diag("%s: no size", s-&gt;name);
			v = 1;
		}
		while(v &amp; 3)
			v++;
		s-&gt;value = v;
		if(v &gt; MINSIZ)
			continue;
		s-&gt;value = orig;
		orig += v;
		s-&gt;type = SDATA1;
	}
	orig1 = orig;

	/*
	 * pass 2
	 *	assign 'data' variables to data segment
	 */
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		t = s-&gt;type;
		if(t != SDATA) {
			if(t == SDATA1)
				s-&gt;type = SDATA;
			continue;
		}
		v = s-&gt;value;
		s-&gt;value = orig;
		orig += v;
		s-&gt;type = SDATA1;
	}

	while(orig &amp; 7)
		orig++;
	datsize = orig;

	/*
	 * pass 3
	 *	everything else to bss segment
	 */
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		if(s-&gt;type != SBSS)
			continue;
		v = s-&gt;value;
		s-&gt;value = orig;
		orig += v;
	}
	while(orig &amp; 7)
		orig++;
	bsssize = orig-datsize;

	/*
	 * pass 4
	 *	add literals to all large values.
	 *	at this time:
	 *		small data is allocated DATA
	 *		large data is allocated DATA1
	 *		large bss is allocated BSS
	 *	the new literals are loaded between
	 *	small data and large data.
	 */
	orig = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as != AMOVW)
			continue;
		if(p-&gt;from.type != D_CONST)
			continue;
		if(s = p-&gt;from.sym) {
			t = s-&gt;type;
			if(t != SDATA &amp;&amp; t != SDATA1 &amp;&amp; t != SBSS)
				continue;
			t = p-&gt;from.name;
			if(t != D_EXTERN &amp;&amp; t != D_STATIC)
				continue;
			v = s-&gt;value + p-&gt;from.offset;
			if(v &gt;= 0 &amp;&amp; v &lt;= 0xffff)
				continue;
			if(!strcmp(s-&gt;name, "setR30"))
				continue;
			/* size should be 19 max */
			if(strlen(s-&gt;name) &gt;= 10)	/* has loader address */ 
				sprint(literal, "$%p.%lux", s, p-&gt;from.offset);
			else
				sprint(literal, "$%s.%d.%lux", s-&gt;name,
					s-&gt;version, p-&gt;from.offset);
		} else {
			if(p-&gt;from.name != D_NONE)
				continue;
			if(p-&gt;from.reg != NREG)
				continue;
			v = p-&gt;from.offset;
			if(v &gt;= -0x7fff &amp;&amp; v &lt;= 0xffff)
				continue;
			if(!(v &amp; 0xffff))
				continue;
			/* size should be 9 max */
			sprint(literal, "$%lux", v);
		}
		s = lookup(literal, 0);
		if(s-&gt;type == 0) {
			s-&gt;type = SDATA;
			s-&gt;value = orig1+orig;
			orig += 4;
			p1 = prg();
			p1-&gt;line = p-&gt;line;
			p1-&gt;as = ADATA;
			p1-&gt;from.type = D_OREG;
			p1-&gt;from.sym = s;
			p1-&gt;from.name = D_EXTERN;
			p1-&gt;reg = 4;
			p1-&gt;to = p-&gt;from;
			p1-&gt;link = datap;
			datap = p1;
		}
		if(s-&gt;type != SDATA)
			diag("literal not data: %s", s-&gt;name);
		p-&gt;from.type = D_OREG;
		p-&gt;from.sym = s;
		p-&gt;from.name = D_EXTERN;
		p-&gt;from.offset = 0;
		nocache(p);
		continue;
	}
	while(orig &amp; 7)
		orig++;
	/*
	 * pass 5
	 *	re-adjust offsets
	 */
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		t = s-&gt;type;
		if(t == SBSS) {
			s-&gt;value += orig;
			continue;
		}
		if(t == SDATA1) {
			s-&gt;type = SDATA;
			s-&gt;value += orig;
			continue;
		}
	}
	datsize += orig;
	xdefine("setR30", SDATA, 0L+BIG);
	xdefine("bdata", SDATA, 0L);
	xdefine("edata", SDATA, datsize);
	xdefine("end", SBSS, datsize+bsssize);
	xdefine("etext", STEXT, 0L);
}

void
undef(void)
{
	int i;
	Sym *s;

	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link)
		if(s-&gt;type == SXREF)
			diag("%s: not defined", s-&gt;name);
}

void
follow(void)
{
	if(debug['v'])
		Bprint(&amp;bso, "%5.2f follow\n", cputime());
	Bflush(&amp;bso);

	firstp = prg();
	lastp = firstp;
	xfol(textp);

	firstp = firstp-&gt;link;
	lastp-&gt;link = P;
}

void
xfol(Prog *p)
{
	Prog *q, *r;
	int a, i;

loop:
	if(p == P)
		return;
	a = p-&gt;as;
	if(a == ATEXT)
		curtext = p;
	if(a == AJMP) {
		q = p-&gt;cond;
		if((p-&gt;mark&amp;NOSCHED) || q &amp;&amp; (q-&gt;mark&amp;NOSCHED)){
			p-&gt;mark |= FOLL;
			lastp-&gt;link = p;
			lastp = p;
			p = p-&gt;link;
			xfol(p);
			p = q;
			if(p &amp;&amp; !(p-&gt;mark &amp; FOLL))
				goto loop;
			return;
		}
		if(q != P) {
			p-&gt;mark |= FOLL;
			p = q;
			if(!(p-&gt;mark &amp; FOLL))
				goto loop;
		}
	}
	if(p-&gt;mark &amp; FOLL) {
		for(i=0,q=p; i&lt;4; i++,q=q-&gt;link) {
			if(q == lastp || (q-&gt;mark&amp;NOSCHED))
				break;
			a = q-&gt;as;
			if(a == ANOP) {
				i--;
				continue;
			}
			if(a == AJMP || a == ARET || a == ARFE)
				goto copy;
			if(!q-&gt;cond || (q-&gt;cond-&gt;mark&amp;FOLL))
				continue;
			if(a != ABEQ &amp;&amp; a != ABNE)
				continue;
		copy:
			for(;;) {
				r = prg();
				*r = *p;
				if(!(r-&gt;mark&amp;FOLL))
					print("cant happen 1\n");
				r-&gt;mark |= FOLL;
				if(p != q) {
					p = p-&gt;link;
					lastp-&gt;link = r;
					lastp = r;
					continue;
				}
				lastp-&gt;link = r;
				lastp = r;
				if(a == AJMP || a == ARET || a == ARFE)
					return;
				r-&gt;as = ABNE;
				if(a == ABNE)
					r-&gt;as = ABEQ;
				r-&gt;cond = p-&gt;link;
				r-&gt;link = p-&gt;cond;
				if(!(r-&gt;link-&gt;mark&amp;FOLL))
					xfol(r-&gt;link);
				if(!(r-&gt;cond-&gt;mark&amp;FOLL))
					print("cant happen 2\n");
				return;
			}
		}
		a = AJMP;
		q = prg();
		q-&gt;as = a;
		q-&gt;line = p-&gt;line;
		q-&gt;to.type = D_BRANCH;
		q-&gt;to.offset = p-&gt;pc;
		q-&gt;cond = p;
		p = q;
	}
	p-&gt;mark |= FOLL;
	lastp-&gt;link = p;
	lastp = p;
	if(a == AJMP || a == ARET || a == ARFE){
		if(p-&gt;mark &amp; NOSCHED){
			p = p-&gt;link;
			goto loop;
		}
		return;
	}
	if(p-&gt;cond != P)
	if(a != AJAL &amp;&amp; p-&gt;link != P) {
		xfol(p-&gt;link);
		p = p-&gt;cond;
		if(p == P || (p-&gt;mark&amp;FOLL))
			return;
		goto loop;
	}
	p = p-&gt;link;
	goto loop;
}

void
patch(void)
{
	vlong c, vexit;
	Prog *p, *q;
	Sym *s;
	int a;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f patch\n", cputime());
	Bflush(&amp;bso);
	mkfwd();
	s = lookup("exit", 0);
	vexit = s-&gt;value;
	for(p = firstp; p != P; p = p-&gt;link) {
		a = p-&gt;as;
		if(a == ATEXT)
			curtext = p;
		if((a == AJAL || a == AJMP || a == ARET) &amp;&amp;
		   p-&gt;to.type != D_BRANCH &amp;&amp; p-&gt;to.sym != S) {
			s = p-&gt;to.sym;
			if(s-&gt;type != STEXT) {
				diag("undefined: %s\n%P", s-&gt;name, p);
				s-&gt;type = STEXT;
				s-&gt;value = vexit;
			}
			p-&gt;to.offset = s-&gt;value;
			p-&gt;to.type = D_BRANCH;
		}
		if(p-&gt;to.type != D_BRANCH)
			continue;
		c = p-&gt;to.offset;
		for(q = firstp; q != P;) {
			if(q-&gt;forwd != P)
			if(c &gt;= q-&gt;forwd-&gt;pc) {
				q = q-&gt;forwd;
				continue;
			}
			if(c == q-&gt;pc)
				break;
			q = q-&gt;link;
		}
		if(q == P) {
			diag("branch out of range %lld\n%P", c, p);
			p-&gt;to.type = D_NONE;
		}
		p-&gt;cond = q;
	}

	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		if(p-&gt;cond != P) {
			p-&gt;cond = brloop(p-&gt;cond);
			if(p-&gt;cond != P)
			if(p-&gt;to.type == D_BRANCH)
				p-&gt;to.offset = p-&gt;cond-&gt;pc;
		}
	}
}

#define	LOG	5
void
mkfwd(void)
{
	Prog *p;
	long dwn[LOG], cnt[LOG], i;
	Prog *lst[LOG];

	for(i=0; i&lt;LOG; i++) {
		if(i == 0)
			cnt[i] = 1; else
			cnt[i] = LOG * cnt[i-1];
		dwn[i] = 1;
		lst[i] = P;
	}
	i = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		i--;
		if(i &lt; 0)
			i = LOG-1;
		p-&gt;forwd = P;
		dwn[i]--;
		if(dwn[i] &lt;= 0) {
			dwn[i] = cnt[i];
			if(lst[i] != P)
				lst[i]-&gt;forwd = p;
			lst[i] = p;
		}
	}
}

Prog*
brloop(Prog *p)
{
	Prog *q;
	int c;

	for(c=0; p!=P;) {
		if(p-&gt;as != AJMP || (p-&gt;mark&amp;NOSCHED))
			return p;
		q = p-&gt;cond;
		if(q &lt;= p) {
			c++;
			if(q == p || c &gt; 5000)
				break;
		}
		p = q;
	}
	return P;
}

vlong
atolwhex(char *s)
{
	vlong n;
	int f;

	n = 0;
	f = 0;
	while(*s == ' ' || *s == '\t')
		s++;
	if(*s == '-' || *s == '+') {
		if(*s++ == '-')
			f = 1;
		while(*s == ' ' || *s == '\t')
			s++;
	}
	if(s[0]=='0' &amp;&amp; s[1]){
		if(s[1]=='x' || s[1]=='X'){
			s += 2;
			for(;;){
				if(*s &gt;= '0' &amp;&amp; *s &lt;= '9')
					n = n*16 + *s++ - '0';
				else if(*s &gt;= 'a' &amp;&amp; *s &lt;= 'f')
					n = n*16 + *s++ - 'a' + 10;
				else if(*s &gt;= 'A' &amp;&amp; *s &lt;= 'F')
					n = n*16 + *s++ - 'A' + 10;
				else
					break;
			}
		} else
			while(*s &gt;= '0' &amp;&amp; *s &lt;= '7')
				n = n*8 + *s++ - '0';
	} else
		while(*s &gt;= '0' &amp;&amp; *s &lt;= '9')
			n = n*10 + *s++ - '0';
	if(f)
		n = -n;
	return n;
}

vlong
rnd(vlong v, long r)
{
	long c;

	if(r &lt;= 0)
		return v;
	v += r - 1;
	c = v % r;
	if(c &lt; 0)
		c += r;
	v -= c;
	return v;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

