<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vl/span.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vl/span.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

void
pagebug(Prog *p)
{
	Prog *q;

	switch(p-&gt;as) {
	case ABGEZAL:
	case ABLTZAL:
	case AJAL:
	case ABEQ:
	case ABGEZ:
	case ABGTZ:
	case ABLEZ:
	case ABLTZ:
	case ABNE:
	case ABFPT:
	case ABFPF:
	case AJMP:
		q = prg();
		*q = *p;
		p-&gt;link = q;
		p-&gt;as = ANOR;
		p-&gt;optab = 0;
		p-&gt;from = zprg.from;
		p-&gt;from.type = D_REG;
		p-&gt;from.reg = REGZERO;
		p-&gt;to = p-&gt;from;
	}
}

void
span(void)
{
	Prog *p, *q;
	Sym *setext, *s;
	Optab *o;
	int m, bflag, i;
	vlong c, otxt, v;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f span\n", cputime());
	Bflush(&amp;bso);

	bflag = 0;
	c = INITTEXT;
	otxt = c;
	for(p = firstp; p != P; p = p-&gt;link) {
		/* bug in early 4000 chips delayslot on page boundary */
		if((c&amp;(0x1000-1)) == 0xffc)
			pagebug(p);
		p-&gt;pc = c;
		o = oplook(p);
		m = o-&gt;size;
		if(m == 0) {
			if(p-&gt;as == ATEXT) {
				curtext = p;
				autosize = p-&gt;to.offset + 4;
				if(p-&gt;from.sym != S)
					p-&gt;from.sym-&gt;value = c;
				/* need passes to resolve branches */
				if(c-otxt &gt;= 1L&lt;&lt;17)
					bflag = 1;
				otxt = c;
				continue;
			}
			diag("zero-width instruction\n%P", p);
			continue;
		}
		c += m;
	}

	/*
	 * if any procedure is large enough to
	 * generate a large SBRA branch, then
	 * generate extra passes putting branches
	 * around jmps to fix. this is rare.
	 */
	while(bflag) {
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f span1\n", cputime());
		bflag = 0;
		c = INITTEXT;
		for(p = firstp; p != P; p = p-&gt;link) {
			/* bug in early 4000 chips delayslot on page boundary */
			if((c&amp;(0x1000-1)) == 0xffc)
				pagebug(p);
			p-&gt;pc = c;
			o = oplook(p);
			if(o-&gt;type == 6 &amp;&amp; p-&gt;cond) {
				otxt = p-&gt;cond-&gt;pc - c;
				if(otxt &lt; 0)
					otxt = -otxt;
				if(otxt &gt;= (1L&lt;&lt;17) - 10) {
					q = prg();
					q-&gt;link = p-&gt;link;
					p-&gt;link = q;
					q-&gt;as = AJMP;
					q-&gt;to.type = D_BRANCH;
					q-&gt;cond = p-&gt;cond;
					p-&gt;cond = q;
					q = prg();
					q-&gt;link = p-&gt;link;
					p-&gt;link = q;
					q-&gt;as = AJMP;
					q-&gt;to.type = D_BRANCH;
					q-&gt;cond = q-&gt;link-&gt;link;
					addnop(p-&gt;link);
					addnop(p);
					bflag = 1;
				}
			}
			m = o-&gt;size;
			if(m == 0) {
				if(p-&gt;as == ATEXT) {
					curtext = p;
					autosize = p-&gt;to.offset + 4;
					if(p-&gt;from.sym != S)
						p-&gt;from.sym-&gt;value = c;
					continue;
				}
				diag("zero-width instruction\n%P", p);
				continue;
			}
			c += m;
		}
	}

	if(debug['t']) {
		/* 
		 * add strings to text segment
		 */
		c = rnd(c, 8);
		for(i=0; i&lt;NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link) {
			if(s-&gt;type != SSTRING)
				continue;
			v = s-&gt;value;
			while(v &amp; 3)
				v++;
			s-&gt;value = c;
			c += v;
		}
	}

	c = rnd(c, 8);

	setext = lookup("etext", 0);
	if(setext != S) {
		setext-&gt;value = c;
		textsize = c - INITTEXT;
	}
	if(INITRND)
		INITDAT = rnd(c, INITRND);
	if(debug['v'])
		Bprint(&amp;bso, "tsize = %llux\n", textsize);
	Bflush(&amp;bso);
}
		
void
xdefine(char *p, int t, long v)
{
	Sym *s;

	s = lookup(p, 0);
	if(s-&gt;type == 0 || s-&gt;type == SXREF) {
		s-&gt;type = t;
		s-&gt;value = v;
	}
}

long
regoff(Adr *a)
{

	instoffset = 0;
	aclass(a);
	return instoffset;
}

aclass(Adr *a)
{
	Sym *s;
	int t;

	switch(a-&gt;type) {
	case D_NONE:
		return C_NONE;

	case D_REG:
		return C_REG;

	case D_FREG:
		return C_FREG;

	case D_FCREG:
		return C_FCREG;

	case D_MREG:
		return C_MREG;

	case D_OREG:
		switch(a-&gt;name) {
		case D_EXTERN:
		case D_STATIC:
			if(a-&gt;sym == 0 || a-&gt;sym-&gt;name == 0) {
				print("null sym external\n");
				print("%D\n", a);
				return C_GOK;
			}
			t = a-&gt;sym-&gt;type;
			if(t == 0 || t == SXREF) {
				diag("undefined external: %s in %s",
					a-&gt;sym-&gt;name, TNAME);
				a-&gt;sym-&gt;type = SDATA;
			}
			instoffset = a-&gt;sym-&gt;value + a-&gt;offset - BIG;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SEXT;
			return C_LEXT;
		case D_AUTO:
			instoffset = autosize + a-&gt;offset;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SAUTO;
			return C_LAUTO;

		case D_PARAM:
			instoffset = autosize + a-&gt;offset + 4L;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SAUTO;
			return C_LAUTO;
		case D_NONE:
			instoffset = a-&gt;offset;
			if(instoffset == 0)
				return C_ZOREG;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SOREG;
			return C_LOREG;
		}
		return C_GOK;

	case D_HI:
		return C_LO;
	case D_LO:
		return C_HI;

	case D_OCONST:
		switch(a-&gt;name) {
		case D_EXTERN:
		case D_STATIC:
			s = a-&gt;sym;
			t = s-&gt;type;
			if(t == 0 || t == SXREF) {
				diag("undefined external: %s in %s",
					s-&gt;name, TNAME);
				s-&gt;type = SDATA;
			}
			instoffset = s-&gt;value + a-&gt;offset + INITDAT;
			if(s-&gt;type == STEXT || s-&gt;type == SLEAF)
				instoffset = s-&gt;value + a-&gt;offset;
			return C_LCON;
		}
		return C_GOK;

	case D_CONST:
		switch(a-&gt;name) {

		case D_NONE:
			instoffset = a-&gt;offset;
		consize:
			if(instoffset &gt; 0) {
				if(instoffset &lt;= 0x7fff)
					return C_SCON;
				if(instoffset &lt;= 0xffff)
					return C_ANDCON;
				if((instoffset &amp; 0xffff) == 0)
					return C_UCON;
				return C_LCON;
			}
			if(instoffset == 0)
				return C_ZCON;
			if(instoffset &gt;= -0x8000)
				return C_ADDCON;
			if((instoffset &amp; 0xffff) == 0)
				return C_UCON;
			return C_LCON;

		case D_EXTERN:
		case D_STATIC:
			s = a-&gt;sym;
			if(s == S)
				break;
			t = s-&gt;type;
			switch(t) {
			case 0:
			case SXREF:
				diag("undefined external: %s in %s",
					s-&gt;name, TNAME);
				s-&gt;type = SDATA;
				break;
			case SCONST:
				instoffset = s-&gt;value + a-&gt;offset;
				goto consize;
			case STEXT:
			case SLEAF:
			case SSTRING:
				instoffset = s-&gt;value + a-&gt;offset;
				return C_LCON;
			}
			instoffset = s-&gt;value + a-&gt;offset - BIG;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG &amp;&amp; instoffset != 0L)
				return C_SECON;
			instoffset = s-&gt;value + a-&gt;offset + INITDAT;
			return C_LCON;

		case D_AUTO:
			instoffset = autosize + a-&gt;offset;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SACON;
			return C_LACON;

		case D_PARAM:
			instoffset = autosize + a-&gt;offset + 4L;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SACON;
			return C_LACON;
		}
		return C_GOK;

	case D_BRANCH:
		return C_SBRA;
	}
	return C_GOK;
}

Optab*
oplook(Prog *p)
{
	int a1, a2, a3, r;
	char *c1, *c3;
	Optab *o, *e;

	a1 = p-&gt;optab;
	if(a1)
		return optab+(a1-1);
	a1 = p-&gt;from.class;
	if(a1 == 0) {
		a1 = aclass(&amp;p-&gt;from) + 1;
		p-&gt;from.class = a1;
	}
	a1--;
	a3 = p-&gt;to.class;
	if(a3 == 0) {
		a3 = aclass(&amp;p-&gt;to) + 1;
		p-&gt;to.class = a3;
	}
	a3--;
	a2 = C_NONE;
	if(p-&gt;reg != NREG)
		a2 = C_REG;
	r = p-&gt;as;
	o = oprange[r].start;
	if(o == 0) {
		a1 = opcross[repop[r]][a1][a2][a3];
		if(a1) {
			p-&gt;optab = a1+1;
			return optab+a1;
		}
		o = oprange[r].stop; /* just generate an error */
	}
	e = oprange[r].stop;
	c1 = xcmp[a1];
	c3 = xcmp[a3];
	for(; o&lt;e; o++)
		if(o-&gt;a2 == a2)
		if(c1[o-&gt;a1])
		if(c3[o-&gt;a3]) {
			p-&gt;optab = (o-optab)+1;
			return o;
		}
	diag("illegal combination %A %d %d %d",
		p-&gt;as, a1, a2, a3);
	if(!debug['a'])
		prasm(p);
	o = optab;
	p-&gt;optab = (o-optab)+1;
	return o;
}

int
cmp(int a, int b)
{

	if(a == b)
		return 1;
	switch(a) {
	case C_LCON:
		if(b == C_ZCON || b == C_SCON || b == C_UCON ||
		   b == C_ADDCON || b == C_ANDCON)
			return 1;
		break;
	case C_ADD0CON:
		if(b == C_ADDCON)
			return 1;
	case C_ADDCON:
		if(b == C_ZCON || b == C_SCON)
			return 1;
		break;
	case C_AND0CON:
		if(b == C_ANDCON)
			return 1;
	case C_ANDCON:
		if(b == C_ZCON || b == C_SCON)
			return 1;
		break;
	case C_UCON:
		if(b == C_ZCON)
			return 1;
		break;
	case C_SCON:
		if(b == C_ZCON)
			return 1;
		break;
	case C_LACON:
		if(b == C_SACON)
			return 1;
		break;
	case C_LBRA:
		if(b == C_SBRA)
			return 1;
		break;
	case C_LEXT:
		if(b == C_SEXT)
			return 1;
		break;
	case C_LAUTO:
		if(b == C_SAUTO)
			return 1;
		break;
	case C_REG:
		if(b == C_ZCON)
			return 1;
		break;
	case C_LOREG:
		if(b == C_ZOREG || b == C_SOREG)
			return 1;
		break;
	case C_SOREG:
		if(b == C_ZOREG)
			return 1;
		break;
	}
	return 0;
}

int
ocmp(const void *a1, const void *a2)
{
	Optab *p1, *p2;
	int n;

	p1 = (Optab*)a1;
	p2 = (Optab*)a2;
	n = p1-&gt;as - p2-&gt;as;
	if(n)
		return n;
	n = p1-&gt;a1 - p2-&gt;a1;
	if(n)
		return n;
	n = p1-&gt;a2 - p2-&gt;a2;
	if(n)
		return n;
	n = p1-&gt;a3 - p2-&gt;a3;
	if(n)
		return n;
	return 0;
}

void
buildop(void)
{
	int i, n, r;

	for(i=0; i&lt;32; i++)
		for(n=0; n&lt;32; n++)
			xcmp[i][n] = cmp(n, i);
	for(n=0; optab[n].as != AXXX; n++)
		;
	qsort(optab, n, sizeof(optab[0]), ocmp);
	for(i=0; i&lt;n; i++) {
		r = optab[i].as;
		oprange[r].start = optab+i;
		while(optab[i].as == r)
			i++;
		oprange[r].stop = optab+i;
		i--;
		
		switch(r)
		{
		default:
			diag("unknown op in build: %A", r);
			errorexit();
		case AABSF:
			oprange[AMOVFD] = oprange[r];
			oprange[AMOVDF] = oprange[r];
			oprange[AMOVWF] = oprange[r];
			oprange[AMOVFW] = oprange[r];
			oprange[AMOVWD] = oprange[r];
			oprange[AMOVDW] = oprange[r];
			oprange[ANEGF] = oprange[r];
			oprange[ANEGD] = oprange[r];
			oprange[AABSD] = oprange[r];
			break;
		case AADD:
			buildrep(1, AADD);
			oprange[ASGT] = oprange[r];
			repop[ASGT] = 1;
			oprange[ASGTU] = oprange[r];
			repop[ASGTU] = 1;
			oprange[AADDU] = oprange[r];
			repop[AADDU] = 1;
			oprange[AADDVU] = oprange[r];
			repop[AADDVU] = 1;
			break;
		case AADDF:
			oprange[ADIVF] = oprange[r];
			oprange[ADIVD] = oprange[r];
			oprange[AMULF] = oprange[r];
			oprange[AMULD] = oprange[r];
			oprange[ASUBF] = oprange[r];
			oprange[ASUBD] = oprange[r];
			oprange[AADDD] = oprange[r];
			break;
		case AAND:
			buildrep(2, AAND);
			oprange[AXOR] = oprange[r];
			repop[AXOR] = 2;
			oprange[AOR] = oprange[r];
			repop[AOR] = 2;
			break;
		case ABEQ:
			oprange[ABNE] = oprange[r];
			break;
		case ABLEZ:
			oprange[ABGEZ] = oprange[r];
			oprange[ABGEZAL] = oprange[r];
			oprange[ABLTZ] = oprange[r];
			oprange[ABLTZAL] = oprange[r];
			oprange[ABGTZ] = oprange[r];
			break;
		case AMOVB:
			buildrep(3, AMOVB);
			oprange[AMOVH] = oprange[r];
			repop[AMOVH] = 3;
			break;
		case AMOVBU:
			buildrep(4, AMOVBU);
			oprange[AMOVHU] = oprange[r];
			repop[AMOVHU] = 4;
			break;
		case AMUL:
			oprange[AREM] = oprange[r];
			oprange[AREMU] = oprange[r];
			oprange[ADIVU] = oprange[r];
			oprange[AMULU] = oprange[r];
			oprange[ADIV] = oprange[r];
			oprange[ADIVVU] = oprange[r];
			oprange[ADIVV] = oprange[r];
			break;
		case ASLL:
			oprange[ASRL] = oprange[r];
			oprange[ASRA] = oprange[r];
			oprange[ASLLV] = oprange[r];
			oprange[ASRAV] = oprange[r];
			oprange[ASRLV] = oprange[r];
			break;
		case ASUB:
			oprange[ASUBU] = oprange[r];
			oprange[ANOR] = oprange[r];
			break;
		case ASYSCALL:
			oprange[ATLBP] = oprange[r];
			oprange[ATLBR] = oprange[r];
			oprange[ATLBWI] = oprange[r];
			oprange[ATLBWR] = oprange[r];
			break;
		case ACMPEQF:
			oprange[ACMPGTF] = oprange[r];
			oprange[ACMPGTD] = oprange[r];
			oprange[ACMPGEF] = oprange[r];
			oprange[ACMPGED] = oprange[r];
			oprange[ACMPEQD] = oprange[r];
			break;
		case ABFPT:
			oprange[ABFPF] = oprange[r];
			break;
		case AMOVWL:
			oprange[AMOVWR] = oprange[r];
			oprange[AMOVVR] = oprange[r];
			oprange[AMOVVL] = oprange[r];
			break;
		case AMOVW:
			buildrep(5, AMOVW);
			break;
		case AMOVD:
			buildrep(6, AMOVD);
			break;
		case AMOVF:
			buildrep(7, AMOVF);
			break;
		case AMOVV:
			buildrep(8, AMOVV);
			break;
		case ABREAK:
		case AWORD:
		case ARFE:
		case AJAL:
		case AJMP:
		case ATEXT:
		case ACASE:
		case ABCASE:
			break;
		}
	}
}

void
buildrep(int x, int as)
{
	Opcross *p;
	Optab *e, *s, *o;
	int a1, a2, a3, n;

	if(C_NONE != 0 || C_REG != 1 || C_GOK &gt;= 32 || x &gt;= nelem(opcross)) {
		diag("assumptions fail in buildrep");
		errorexit();
	}
	repop[as] = x;
	p = (opcross + x);
	s = oprange[as].start;
	e = oprange[as].stop;
	for(o=e-1; o&gt;=s; o--) {
		n = o-optab;
		for(a2=0; a2&lt;2; a2++) {
			if(a2) {
				if(o-&gt;a2 == C_NONE)
					continue;
			} else
				if(o-&gt;a2 != C_NONE)
					continue;
			for(a1=0; a1&lt;32; a1++) {
				if(!xcmp[a1][o-&gt;a1])
					continue;
				for(a3=0; a3&lt;32; a3++)
					if(xcmp[a3][o-&gt;a3])
						(*p)[a1][a2][a3] = n;
			}
		}
	}
	oprange[as].start = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

