<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/chan.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/chan.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	"compat.h"
#include	"error.h"

Chan*
newchan(void)
{
	Chan *c;

	c = smalloc(sizeof(Chan));

	/* if you get an error before associating with a dev,
	   close calls rootclose, a nop */
	c-&gt;type = 0;
	c-&gt;flag = 0;
	c-&gt;ref = 1;
	c-&gt;dev = 0;
	c-&gt;offset = 0;
	c-&gt;iounit = 0;
	c-&gt;aux = 0;
	c-&gt;name = 0;
	return c;
}

void
chanfree(Chan *c)
{
	c-&gt;flag = CFREE;

	cnameclose(c-&gt;name);
	free(c);
}

void
cclose(Chan *c)
{
	if(c-&gt;flag&amp;CFREE)
		panic("cclose %#p", getcallerpc(&amp;c));
	if(decref(c))
		return;

	if(!waserror()){
		devtab[c-&gt;type]-&gt;close(c);
		poperror();
	}

	chanfree(c);
}

Chan*
cclone(Chan *c)
{
	Chan *nc;
	Walkqid *wq;

	wq = devtab[c-&gt;type]-&gt;walk(c, nil, nil, 0);
	if(wq == nil)
		error("clone failed");
	nc = wq-&gt;clone;
	free(wq);
	nc-&gt;name = c-&gt;name;
	if(c-&gt;name)
		incref(c-&gt;name);
	return nc;
}

enum
{
	CNAMESLOP	= 20
};

static Ref ncname;

void cleancname(Cname*);

int
isdotdot(char *p)
{
	return p[0]=='.' &amp;&amp; p[1]=='.' &amp;&amp; p[2]=='\0';
}

int
incref(Ref *r)
{
	int x;

	lock(r);
	x = ++r-&gt;ref;
	unlock(r);
	return x;
}

int
decref(Ref *r)
{
	int x;

	lock(r);
	x = --r-&gt;ref;
	unlock(r);
	if(x &lt; 0)
		panic("decref");

	return x;
}

Cname*
newcname(char *s)
{
	Cname *n;
	int i;

	n = smalloc(sizeof(Cname));
	i = strlen(s);
	n-&gt;len = i;
	n-&gt;alen = i+CNAMESLOP;
	n-&gt;s = smalloc(n-&gt;alen);
	memmove(n-&gt;s, s, i+1);
	n-&gt;ref = 1;
	incref(&amp;ncname);
	return n;
}

void
cnameclose(Cname *n)
{
	if(n == nil)
		return;
	if(decref(n))
		return;
	decref(&amp;ncname);
	free(n-&gt;s);
	free(n);
}

Cname*
addelem(Cname *n, char *s)
{
	int i, a;
	char *t;
	Cname *new;

	if(s[0]=='.' &amp;&amp; s[1]=='\0')
		return n;

	if(n-&gt;ref &gt; 1){
		/* copy on write */
		new = newcname(n-&gt;s);
		cnameclose(n);
		n = new;
	}

	i = strlen(s);
	if(n-&gt;len+1+i+1 &gt; n-&gt;alen){
		a = n-&gt;len+1+i+1 + CNAMESLOP;
		t = smalloc(a);
		memmove(t, n-&gt;s, n-&gt;len+1);
		free(n-&gt;s);
		n-&gt;s = t;
		n-&gt;alen = a;
	}
	if(n-&gt;len&gt;0 &amp;&amp; n-&gt;s[n-&gt;len-1]!='/' &amp;&amp; s[0]!='/')	/* don't insert extra slash if one is present */
		n-&gt;s[n-&gt;len++] = '/';
	memmove(n-&gt;s+n-&gt;len, s, i+1);
	n-&gt;len += i;
	if(isdotdot(s))
		cleancname(n);
	return n;
}

/*
 * In place, rewrite name to compress multiple /, eliminate ., and process ..
 */
void
cleancname(Cname *n)
{
	char *p;

	if(n-&gt;s[0] == '#'){
		p = strchr(n-&gt;s, '/');
		if(p == nil)
			return;
		cleanname(p);

		/*
		 * The correct name is #i rather than #i/,
		 * but the correct name of #/ is #/.
		 */
		if(strcmp(p, "/")==0 &amp;&amp; n-&gt;s[1] != '/')
			*p = '\0';
	}else
		cleanname(n-&gt;s);
	n-&gt;len = strlen(n-&gt;s);
}

void
isdir(Chan *c)
{
	if(c-&gt;qid.type &amp; QTDIR)
		return;
	error(Enotdir);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

