<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/compat.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/compat.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	"compat.h"
#include	"error.h"

#include	"errstr.h"

ulong	kerndate;
Proc	**privup;
char	*eve;
extern void *mainmem;

void
_assert(char *fmt)
{
	panic("assert failed: %s", fmt);
}

int
errdepth(int ed)
{
	if(ed &gt;= 0 &amp;&amp; up-&gt;nerrlab != ed)
		panic("unbalanced error depth: expected %d got %d\n", ed, up-&gt;nerrlab);
	return up-&gt;nerrlab;
}

void
newup(char *name)
{
	up = smalloc(sizeof(Proc));
	up-&gt;user = eve;
	strncpy(up-&gt;name, name, KNAMELEN-1);
	up-&gt;name[KNAMELEN-1] = '\0';
}

void
kproc(char *name, void (*f)(void *), void *a)
{
	int pid;

	pid = rfork(RFPROC|RFMEM|RFNOWAIT);
	switch(pid){
	case -1:
		panic("can't make new thread: %r");
	case 0:
		break;
	default:
		return;
	}

	newup(name);
	if(!waserror())
		(*f)(a);
	_exits(nil);
}

void
kexit(void)
{
	_exits(nil);
}

void
initcompat(void)
{
	rfork(RFREND);
	privup = privalloc();
	kerndate = seconds();
	eve = getuser();
	newup("main");
}

int
openmode(ulong o)
{
	o &amp;= ~(OTRUNC|OCEXEC|ORCLOSE);
	if(o &gt; OEXEC)
		error(Ebadarg);
	if(o == OEXEC)
		return OREAD;
	return o;
}

void
panic(char *fmt, ...)
{
	char buf[512];
	char buf2[512];
	va_list va;

	va_start(va, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, va);
	va_end(va);
	sprint(buf2, "panic: %s\n", buf);
	write(2, buf2, strlen(buf2));

	exits("error");
}

void*
smalloc(ulong n)
{
	void *p;

	p = mallocz(n, 1);
	if(p == nil)
		panic("out of memory");
	setmalloctag(p, getcallerpc(&amp;n));
	return p;
}

long
seconds(void)
{
	return time(nil);
}

void
error(char *err)
{
	strncpy(up-&gt;error, err, ERRMAX);
	nexterror();
}

void
nexterror(void)
{
	longjmp(up-&gt;errlab[--up-&gt;nerrlab], 1);
}

int
readstr(ulong off, char *buf, ulong n, char *str)
{
	int size;

	size = strlen(str);
	if(off &gt;= size)
		return 0;
	if(off+n &gt; size)
		n = size-off;
	memmove(buf, str+off, n);
	return n;
}

void
_rendsleep(void* tag)
{
	void *value;

	for(;;){
		value = rendezvous(tag, (void*)0x22a891b8);
		if(value == (void*)0x7f7713f9)
			break;
		if(tag != (void*)~0)
			panic("_rendsleep: rendezvous mismatch");
	}
}

void
_rendwakeup(void* tag)
{
	void *value;

	for(;;){
		value = rendezvous(tag, (void*)0x7f7713f9);
		if(value == (void*)0x22a891b8)
			break;
		if(tag != (void*)~0)
			panic("_rendwakeup: rendezvous mismatch");
	}
}

void
rendsleep(Rendez *r, int (*f)(void*), void *arg)
{
	lock(&amp;up-&gt;rlock);
	up-&gt;r = r;
	unlock(&amp;up-&gt;rlock);

	lock(r);

	/*
	 * if condition happened, never mind
	 */
	if(up-&gt;intr || f(arg)){
		unlock(r);
		goto Done;
	}

	/*
	 * now we are committed to
	 * change state and call scheduler
	 */
	if(r-&gt;p)
		panic("double sleep");
	r-&gt;p = up;
	unlock(r);

	_rendsleep(r);

Done:
	lock(&amp;up-&gt;rlock);
	up-&gt;r = 0;
	if(up-&gt;intr){
		up-&gt;intr = 0;
		unlock(&amp;up-&gt;rlock);
		error(Eintr);
	}
	unlock(&amp;up-&gt;rlock);
}

int
rendwakeup(Rendez *r)
{
	Proc *p;
	int rv;

	lock(r);
	p = r-&gt;p;
	rv = 0;
	if(p){
		r-&gt;p = nil;
		_rendwakeup(r);
		rv = 1;
	}
	unlock(r);
	return rv;
}

void
rendintr(void *v)
{
	Proc *p;

	p = v;
	lock(&amp;p-&gt;rlock);
	p-&gt;intr = 1;
	if(p-&gt;r)
		rendwakeup(p-&gt;r);
	unlock(&amp;p-&gt;rlock);
}

void
rendclearintr(void)
{
	lock(&amp;up-&gt;rlock);
	up-&gt;intr = 0;
	unlock(&amp;up-&gt;rlock);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

