<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/kbds.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/kbds.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	"compat.h"
#include	"kbd.h"
#include   "ksym2utf.h"

enum
{
	VKSpecial = 0xff00,

	/*
	 * plan 9 key mappings
	 */
	Spec=		0xF800,

	PF=		Spec|0x20,	/* num pad function key */
	View=		Spec|0x00,	/* view (shift window up) */
	KF=		0xF000,	/* function key (begin Unicode private space) */
	Shift=		Spec|0x60,
	Break=		Spec|0x61,
	Ctrl=		Spec|0x62,
	Latin=		Spec|0x63,
	Caps=		Spec|0x64,
	Num=		Spec|0x65,
	Middle=		Spec|0x66,
	No=		0x00,		/* peter */

	Home=		KF|13,
	Up=		KF|14,
	Pgup=		KF|15,
	Print=		KF|16,
	Left=		KF|17,
	Right=		KF|18,
	End=		'\r',
	Down=		View,
	Pgdown=		KF|19,
	Ins=		KF|20,
	Del=		0x7F,
	Scroll=		KF|21,

	Esc = 0x1b,
	Delete = 0x7f,
};

static Rune vnckeys[] =
{
[0x00]	No,	No,	No,	No,	No,	No,	No,	No,
[0x08]	'\b',	'\t',	'\r',	No,	No,	'\n',	No,	No,
[0x10]	No,	No,	No,	No,	Scroll,	No,	No,	No,
[0x18]	No,	No,	No,	Esc,	No,	No,	No,	No,
[0x20]	No,	No,	No,	No,	No,	No,	No,	No,
[0x28]	No,	No,	No,	No,	No,	No,	No,	No,
[0x30]	No,	No,	No,	No,	No,	No,	No,	No,
[0x38]	No,	No,	No,	No,	No,	No,	No,	No,
[0x40]	No,	No,	No,	No,	No,	No,	No,	No,
[0x48]	No,	No,	No,	No,	No,	No,	No,	No,
[0x50]	Home,	Left,	Up,	Right,	Down,	Pgup,	Pgdown,	No,
[0x58]	No,	No,	No,	No,	No,	No,	No,	No,
[0x60]	No,	Print,	No,	Ins,	No,	No,	No,	No,
[0x68]	No,	No,	No,	Break,	No,	No,	No,	No,
[0x70]	No,	No,	No,	No,	No,	No,	No,	No,
[0x78]	No,	No,	No,	No,	No,	No,	No,	Num,
[0x80]	No,	No,	No,	No,	No,	No,	No,	No,
[0x88]	No,	No,	No,	No,	No,	No,	No,	No,
[0x90]	No,	No,	No,	No,	No,	No,	No,	No,
[0x98]	No,	No,	No,	No,	No,	No,	No,	No,
[0xa0]	No,	No,	No,	No,	No,	No,	No,	No,
[0xa8]	No,	No,	'*',	'+',	No,	'-',	'.',	'/',
[0xb0]	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
[0xb8]	'8',	'9',	No,	No,	No,	'=',	No,	No,
[0xc0]	No,	No,	No,	No,	No,	No,	No,	No,
[0xc8]	No,	No,	No,	No,	No,	No,	No,	No,
[0xd0]	No,	No,	No,	No,	No,	No,	No,	No,
[0xd8]	No,	No,	No,	No,	No,	No,	No,	No,
[0xe0]	No,	Shift,	Shift,	Ctrl,	Ctrl,	Caps,	Caps,	No,
[0xe8]	No,	Latin,	Latin,	No,	No,	No,	No,	No,
[0xf0]	No,	No,	No,	No,	No,	No,	No,	No,
[0xf8]	No,	No,	No,	No,	No,	No,	No,	Delete,
};

/*
 *  keyboard interrupt
 */
void
vncputc(int keyup, int c)
{
	int i;
	static int esc1, esc2;
	static int alt, caps, ctl, num, shift;
	static int collecting, nk;
	static Rune kc[5];

	if(caps &amp;&amp; c&lt;='z' &amp;&amp; c&gt;='a')
		c += 'A' - 'a';

	/*
 	 *  character mapping
	 */
	if((c &amp; VKSpecial) == VKSpecial){
		c = vnckeys[c &amp; 0xff];
		if(c == No)
			return;
	}
	/*
	 * map an xkeysym onto a utf-8 char
	 */
	if((c &amp; 0xff00) &amp;&amp; c &lt; nelem(ksym2utf) &amp;&amp; ksym2utf[c] != 0)
			c = ksym2utf[c];

	/*
	 *  keyup only important for shifts
	 */
	if(keyup){
		switch(c){
		case Latin:
			alt = 0;
			break;
		case Shift:
			shift = 0;
			break;
		case Ctrl:
			ctl = 0;
			break;
		}
		return;
	}

	/*
 	 *  normal character
	 */
	if(!(c &amp; (Spec|KF))){
		if(ctl){
			c &amp;= 0x1f;
		}
		if(!collecting){
			kbdputc(c);
			return;
		}
		kc[nk++] = c;
		c = latin1(kc, nk);
		if(c &lt; -1)	/* need more keystrokes */
			return;
		if(c != -1)	/* valid sequence */
			kbdputc(c);
		else	/* dump characters */
			for(i=0; i&lt;nk; i++)
				kbdputc(kc[i]);
		nk = 0;
		collecting = 0;
		return;
	}else{
		switch(c){
		case Caps:
			caps ^= 1;
			return;
		case Num:
			num ^= 1;
			return;
		case Shift:
			shift = 1;
			return;
		case Latin:
			alt = 1;
			collecting = 1;
			nk = 0;
			return;
		case Ctrl:
			ctl = 1;
			return;
		}
	}
	kbdputc(c);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

