<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/kbdv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/kbdv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "vnc.h"
#include &lt;keyboard.h&gt;
#include "utf2ksym.h"

enum {
	Xshift = 0xFFE1,
	Xctl = 0xFFE3,
	Xmeta = 0xFFE7,
	Xalt = 0xFFE9
};

static struct {
	Rune kbdc;
	ulong keysym;
} ktab[] = {
	{'\b',		0xff08},
	{'\t',		0xff09},
	{'\n',		0xff0d},
	/* {0x0b, 0xff0b}, */
	{'\r',		0xff0d},
	{0x1b,	0xff1b},	/* escape */
	{Kins,	0xff63},
	{0x7F,	0xffff},
	{Khome,	0xff50},
	{Kend,	0xff57},
	{Kpgup,	0xff55},
	{Kpgdown,	0xff56},
	{Kleft,	0xff51},
	{Kup,	0xff52},
	{Kright,	0xff53},
	{Kdown,	0xff54},
	{KF|1,	0xffbe},
	{KF|2,	0xffbf},
	{KF|3,	0xffc0},
	{KF|4,	0xffc1},
	{KF|5,	0xffc2},
	{KF|6,	0xffc3},
	{KF|7,	0xffc4},
	{KF|8,	0xffc5},
	{KF|9,	0xffc6},
	{KF|10,	0xffc7},
	{KF|11,	0xffc8},
	{KF|12,	0xffc9},
};

static char shiftkey[128] = {
	0, 0, 0, 0, 0, 0, 0, 0, /* nul soh stx etx eot enq ack bel */
	0, 0, 0, 0, 0, 0, 0, 0, /* bs ht nl vt np cr so si */
	0, 0, 0, 0, 0, 0, 0, 0, /* dle dc1 dc2 dc3 dc4 nak syn etb */
	0, 0, 0, 0, 0, 0, 0, 0, /* can em sub esc fs gs rs us */
	0, 1, 1, 1, 1, 1, 1, 0, /* sp ! " # $ % &amp; ' */
	1, 1, 1, 1, 0, 0, 0, 0, /* ( ) * + , - . / */
	0, 0, 0, 0, 0, 0, 0, 0, /* 0 1 2 3 4 5 6 7 */
	0, 0, 1, 0, 1, 0, 1, 1, /* 8 9 : ; &lt; = &gt; ? */
	1, 1, 1, 1, 1, 1, 1, 1, /* @ A B C D E F G */
	1, 1, 1, 1, 1, 1, 1, 1, /* H I J K L M N O */
	1, 1, 1, 1, 1, 1, 1, 1, /* P Q R S T U V W */
	1, 1, 1, 0, 0, 0, 1, 1, /* X Y Z [ \ ] ^ _ */
	0, 0, 0, 0, 0, 0, 0, 0, /* ` a b c d e f g */
	0, 0, 0, 0, 0, 0, 0, 0, /* h i j k l m n o */
	0, 0, 0, 0, 0, 0, 0, 0, /* p q r s t u v w */
	0, 0, 0, 1, 1, 1, 1, 0, /* x y z { | } ~ del  */
};

ulong
runetoksym(Rune r)
{
	int i;

	for(i=0; i&lt;nelem(ktab); i++)
		if(ktab[i].kbdc == r)
			return ktab[i].keysym;
	return r;
}

static void
keyevent(Vnc *v, ulong ksym, int down)
{
	vnclock(v);
	vncwrchar(v, MKey);
	vncwrchar(v, down);
	vncwrshort(v, 0);
	vncwrlong(v, ksym);
	vncflush(v);
	vncunlock(v);
}

void
readkbd(Vnc *v)
{
	char buf[256], k[10];
	ulong ks;
	int ctlfd, fd, kr, kn, w, shift, ctl, alt;
	Rune r;

	snprint(buf, sizeof buf, "%s/cons", display-&gt;devdir);
	if((fd = open(buf, OREAD)) &lt; 0)
		sysfatal("open %s: %r", buf);

	snprint(buf, sizeof buf, "%s/consctl", display-&gt;devdir);
	if((ctlfd = open(buf, OWRITE)) &lt; 0)
		sysfatal("open %s: %r", buf);
	write(ctlfd, "rawon", 5);

	kn = 0;
	shift = alt = ctl = 0;
	for(;;){
		while(!fullrune(k, kn)){
			kr = read(fd, k+kn, sizeof k - kn);
			if(kr &lt;= 0)
				sysfatal("bad read from kbd");
			kn += kr;
		}
		w = chartorune(&amp;r, k);
		kn -= w;
		memmove(k, &amp;k[w], kn);
		ks = runetoksym(r);

		switch(r){
		case Kalt:
			alt = !alt;
			keyevent(v, Xalt, alt);
			break;
		case Kctl:
			ctl = !ctl;
			keyevent(v, Xctl, ctl);
			break;
		case Kshift:
			shift = !shift;
			keyevent(v, Xshift, shift);
			break;
		default:
			if(r == ks &amp;&amp; r &lt; 0x1A){	/* control key */
				keyevent(v, Xctl, 1);
				keyevent(v, r+0x60, 1);	/* 0x60: make capital letter */
				keyevent(v, r+0x60, 0);
				keyevent(v, Xctl, 0);
			}else{
				/*
				 * to send an upper case letter or shifted
				 * punctuation, mac os x vnc server,
				 * at least, needs a `shift' sent first.
				 */
				if(!shift &amp;&amp; r == ks &amp;&amp; r &lt; sizeof shiftkey &amp;&amp; shiftkey[r]){
					shift = 1;
					keyevent(v, Xshift, 1);
				}
				/*
				 * map an xkeysym onto a utf-8 char.
				 * allows Xvnc to read us, see utf2ksym.h
				 */
				if((ks &amp; 0xff00) &amp;&amp; ks &lt; nelem(utf2ksym) &amp;&amp; utf2ksym[ks] != 0)
					ks = utf2ksym[ks];
				keyevent(v, ks, 1);
				/*
				 * up event needed by vmware inside linux vnc server,
				 * perhaps others.
				 */
				keyevent(v, ks, 0);
			}

			if(alt){
				keyevent(v, Xalt, 0);
				alt = 0;
			}
			if(ctl){
				keyevent(v, Xctl, 0);
				ctl = 0;
			}
			if(shift){
				keyevent(v, Xshift, 0);
				shift = 0;
			}
			break;
		}
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

