<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/rlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/rlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "vnc.h"
#include "vncs.h"

static int tot;
static void rprint(Rlist*);

static void
growrlist(Rlist *rlist, int n)
{
	int old;

	if(rlist-&gt;nrect+n &lt;= rlist-&gt;maxrect)
		return;

	old = rlist-&gt;maxrect;
	while(rlist-&gt;nrect+n &gt; rlist-&gt;maxrect){
		if(rlist-&gt;maxrect == 0)
			rlist-&gt;maxrect = 16;
		else
			rlist-&gt;maxrect *= 2;
	}

	tot += rlist-&gt;maxrect - old;
	if(tot &gt; 10000)
		sysfatal("too many rectangles");

	rlist-&gt;rect = realloc(rlist-&gt;rect, rlist-&gt;maxrect*sizeof(rlist-&gt;rect[0]));
	if(rlist-&gt;rect == nil)
		sysfatal("realloc failed in growrlist");
}

static void
rappend(Rlist *rl, Rectangle r)
{
	growrlist(rl, 1);
	rl-&gt;rect[rl-&gt;nrect++] = r;
}

/* remove rectangle i from the list */
static int
rtrim(Rlist *r, int i)
{
	if(i &lt; 0 || i &gt;= r-&gt;nrect)
		return 0;
	if(i == r-&gt;nrect-1){
		r-&gt;nrect--;
		return 1;
	}
	r-&gt;rect[i] = r-&gt;rect[--r-&gt;nrect];
	return 1;
}

static int
rectadjacent(Rectangle r, Rectangle s)
{
	return r.min.x&lt;=s.max.x &amp;&amp; s.min.x&lt;=r.max.x &amp;&amp;
	       r.min.y&lt;=s.max.y &amp;&amp; s.min.y&lt;=r.max.y;
}

/*
 * If s shares three edges with r, compute the
 * rectangle r - s and return 1.
 * Else return 0.
 */
static int
rectubr(Rectangle *r, Rectangle s)
{
	if(r-&gt;min.y==s.min.y &amp;&amp; r-&gt;max.y==s.max.y){
		if(r-&gt;min.x == s.min.x){
			r-&gt;min.x = s.max.x;
			assert(r-&gt;max.x &gt; r-&gt;min.x);
			return 1;
		}
		if(r-&gt;max.x == s.max.x){
			r-&gt;max.x = s.min.x;
			assert(r-&gt;max.x &gt; r-&gt;min.x);
			return 1;
		}
	}
	if(r-&gt;min.x==s.min.x &amp;&amp; r-&gt;max.x==s.max.x){
		if(r-&gt;min.y == s.min.y){
			r-&gt;min.y = s.max.y;
			assert(r-&gt;max.y &gt; r-&gt;min.y);
			return 1;
		}
		if(r-&gt;max.y == s.max.y){
			r-&gt;max.y = s.min.y;
			assert(r-&gt;max.y &gt; r-&gt;min.y);
			return 1;
		}
	}
	return 0;
}

/*
 * If s is a corner of r, remove s from r, yielding
 * two rectangles r and rr.  R holds the part with
 * smaller coordinates.
 */
static int
rectcornersubr(Rectangle *r, Rectangle s, Rectangle *rr)
{
#	define UPRIGHT(r) Pt((r).max.x, (r).min.y)
#	define LOWLEFT(r) Pt((r).min.x, (r).max.y)

	*rr = *r;

	if(s.min.x == r-&gt;min.x){  
		if(s.min.y == r-&gt;min.y){  // upper left
			*rr = Rpt(UPRIGHT(s), r-&gt;max);
			*r = Rpt(LOWLEFT(s), LOWLEFT(*rr));
			return 1;
		}
		if(s.max.y == r-&gt;max.y){ // lower left
			*rr = Rpt(Pt(s.max.x, r-&gt;min.y), r-&gt;max);
			*r = Rpt(r-&gt;min, UPRIGHT(s));
			return 1;
		}
	}
	if(s.max.x == r-&gt;max.x){
		if(s.max.y == r-&gt;max.y){ // lower right
			*rr = Rpt(Pt(s.min.x, r-&gt;min.y), UPRIGHT(s));
			*r = Rpt(r-&gt;min, LOWLEFT(s));
			return 1;
		}
		if(s.min.y == r-&gt;min.y){ // upper right
			*rr = Rpt(LOWLEFT(s), r-&gt;max);
			*r = Rpt(r-&gt;min, LOWLEFT(*rr));
			return 1;
		}
	}
	return 0;
}

/*
 * If s is a band cutting r into two pieces, set r to one piece
 * and rr to the other.
 */
static int
recttridesubr(Rectangle *nr, Rectangle s, Rectangle *rr)
{
	*rr = *nr;
	if((nr-&gt;min.x == s.min.x &amp;&amp; nr-&gt;max.x == s.max.x) &amp;&amp;
	    (nr-&gt;min.y &lt; s.min.y &amp;&amp; s.max.y &lt; nr-&gt;max.y)){
		nr-&gt;max.y = s.min.y;
		rr-&gt;min.y = s.max.y;
		return 1;
	}

	if((nr-&gt;min.y == s.min.y &amp;&amp; nr-&gt;max.y == s.max.y) &amp;&amp;
	    (nr-&gt;min.x &lt; s.min.x &amp;&amp; s.max.x &lt; nr-&gt;max.x)){
		nr-&gt;max.x = s.min.x;
		rr-&gt;min.x = s.max.x;
		return 1;
	}
	return 0;
}

void
addtorlist(Rlist *rlist, Rectangle r)
{
	int i, j;
	Rectangle ir, cr, rr;
	Rlist tmp;

	if(r.min.x &gt;= r.max.x || r.min.y &gt;= r.max.y)
		return;

	memset(&amp;tmp, 0, sizeof tmp);
	rappend(&amp;tmp, r);
	
	if(verbose &gt; 5)
		fprint(2, "region union add %R:\n", r);

	combinerect(&amp;rlist-&gt;bbox, r); // must do this first
	for(j = 0; j &lt; tmp.nrect; j++){
		r = tmp.rect[j];

		for(i=0; i &lt; rlist-&gt;nrect; i++){
			ir = rlist-&gt;rect[i];

			if(verbose &gt; 5)
				fprint(2, "checking %R against %R\n", r, ir);
			if(!rectadjacent(ir, r))
				continue;

			/* r is covered by ir? */
			if(rectinrect(r, ir))
				break;

			/* r covers ir? */
 			if(rectinrect(ir, r)){
				rtrim(rlist, i);
				i--;
				continue;
			}

			/* aligned and overlapping? */
			if((ir.min.y == r.min.y &amp;&amp; ir.max.y == r.max.y) ||
		    	(ir.min.x == r.min.x &amp;&amp; ir.max.x == r.max.x)){
				combinerect(&amp;r, ir);
				rtrim(rlist, i);
				i--;
				continue;
			}

			/* not aligned */ 
			if(verbose &gt; 5)
				fprint(2, "break up rect %R and %R\n", ir, r);
			/* 2-&gt;2 breakup */
			cr = ir;
			if (!rectclip(&amp;cr, r))	/* share only one point */
				continue;

			if(rectubr(&amp;r, cr))
				continue;

			if(rectubr(&amp;rlist-&gt;rect[i], cr))
				continue;

			/* 2 -&gt; 3 breakup */
			/* stride across */
			if(recttridesubr(&amp;r, cr, &amp;rr)){
				rappend(&amp;tmp, rr);
				continue;
			}

			/* corner overlap */
			if(rectcornersubr(&amp;r, cr, &amp;rr)){
				rappend(&amp;tmp, rr);
				continue;
			}
			abort();
		}
		if(i == rlist-&gt;nrect)
			rappend(rlist, r);
	}
	freerlist(&amp;tmp);
	if(verbose &gt; 5)
		rprint(rlist);
}

void
freerlist(Rlist *r)
{
	free(r-&gt;rect);
	tot -= r-&gt;maxrect;
	r-&gt;nrect = 0;
	r-&gt;maxrect = 0;
	r-&gt;rect = nil;
}

static void
rprint(Rlist *r)
{
	int i;

	fprint(2, "rlist %p:", r);
	for(i=0; i&lt;r-&gt;nrect; i++)
		fprint(2, " %R", r-&gt;rect[i]);
	fprint(2, "\n");
}


#ifdef REGION_DEBUG

int verbose = 10;

void main(int argc, char * argv[])
{
	Rectangle r1 = Rect(0, 0, 300, 200);
	Rectangle r2 = Rect(100, 100, 400, 300);
	Rectangle r3 = Rect(200, 100, 500, 300);
	Region reg;

	initdraw(0, 0, "vncviewer");
	region_init(&amp;reg);
	region_union(&amp;reg, r1, r1);
	region_union(&amp;reg, r2, r2);
	region_union(&amp;reg, r3, r3);
}

#endif
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

