<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/webfs/client.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/webfs/client.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ip.h&gt;
#include &lt;plumb.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"
#include "fns.h"

int nclient;
Client **client;

static void clientthread(void*);
int
newclient(int plumbed)
{
	int i;
	Client *c;

	for(i=0; i&lt;nclient; i++)
		if(client[i]-&gt;ref==0)
			return i;

	c = emalloc(sizeof(Client));
	c-&gt;plumbed = plumbed;
	c-&gt;creq = chancreate(sizeof(Req*), 8);
	threadcreate(clientthread, c, STACK);

	c-&gt;io = ioproc();
	c-&gt;num = nclient;
	c-&gt;ctl = globalctl;
	clonectl(&amp;c-&gt;ctl);
	if(nclient%16 == 0)
		client = erealloc(client, (nclient+16)*sizeof(client[0]));
	client[nclient++] = c;
	return nclient-1;
}

void
closeclient(Client *c)
{
	if(--c-&gt;ref == 0){
		if(c-&gt;bodyopened){
			if(c-&gt;url &amp;&amp; c-&gt;url-&gt;close)
				(*c-&gt;url-&gt;close)(c);
			c-&gt;bodyopened = 0;
		}
		free(c-&gt;contenttype);
		c-&gt;contenttype = nil;
		free(c-&gt;postbody);
		c-&gt;postbody = nil;
		freeurl(c-&gt;url);
		c-&gt;url = nil;
		free(c-&gt;redirect);
		c-&gt;redirect = nil;
		free(c-&gt;authenticate);
		c-&gt;authenticate = nil;
		c-&gt;npostbody = 0;
		c-&gt;havepostbody = 0;
		c-&gt;bodyopened = 0;
	}
}

void
clonectl(Ctl *c)
{
	if(c-&gt;useragent)
		c-&gt;useragent = estrdup(c-&gt;useragent);
}

void
clientbodyopen(Client *c, Req *r)
{
	char e[ERRMAX], *next;
	int i, nauth;
	Url *u;

	nauth = 0;
	next = nil;
	for(i=0; i&lt;=c-&gt;ctl.redirectlimit; i++){
		if(c-&gt;url == nil){
			werrstr("nil url");
			goto Error;
		}
		if(c-&gt;url-&gt;open == nil){
			werrstr("unsupported url type");
			goto Error;
		}
		if(fsdebug)
			fprint(2, "try %s\n", c-&gt;url-&gt;url);
		if(c-&gt;url-&gt;open(c, c-&gt;url) &lt; 0){
		Error:
			if(next)
				fprint(2, "next %s (but for error)\n", next);
			free(next);
			rerrstr(e, sizeof e);
			c-&gt;iobusy = 0;
			if(r != nil)
				r-&gt;fid-&gt;omode = -1;
			closeclient(c);	/* not opening */
			if(r != nil)
				respond(r, e);
			return;
		}
		if (c-&gt;authenticate &amp;&amp; nauth++ &lt; 1)
				continue;
		if(!c-&gt;redirect)
			break;
		next = c-&gt;redirect;
		c-&gt;redirect = nil;
		if(i==c-&gt;ctl.redirectlimit){
			werrstr("redirect limit reached");
			goto Error;
		}
		if((u = parseurl(next, c-&gt;url)) == nil)
			goto Error;
		if(urldebug)
			fprint(2, "parseurl %s got scheme %d\n", next, u-&gt;ischeme);
		if(u-&gt;ischeme == USunknown){
			werrstr("redirect with unknown URL scheme");
			goto Error;
		}
		if(u-&gt;ischeme == UScurrent){
			werrstr("redirect to URL relative to current document");
			goto Error;
		}
		freeurl(c-&gt;url);
		c-&gt;url = u;
	}
	free(next);
	c-&gt;iobusy = 0;
	if(r != nil)
		respond(r, nil);
}

void
plumburl(char *url, char *base)
{
	int i;
	Client *c;
	Url *ubase, *uurl;

	ubase = nil;
	if(base){
		ubase = parseurl(base, nil);
		if(ubase == nil)
			return;
	}
	uurl = parseurl(url, ubase);
	if(uurl == nil){
		freeurl(ubase);
		return;
	}
	i = newclient(1);
	c = client[i];
	c-&gt;ref++;
	c-&gt;baseurl = ubase;
	c-&gt;url = uurl;
	sendp(c-&gt;creq, nil);
}

void
clientbodyread(Client *c, Req *r)
{
	char e[ERRMAX];

	if(c-&gt;url-&gt;read == nil){
		respond(r, "unsupported url type");
		return;
	}
	if(c-&gt;url-&gt;read(c, r) &lt; 0){
		rerrstr(e, sizeof e);
		c-&gt;iobusy = 0;
		respond(r, e);
		return;
	}
	c-&gt;iobusy = 0;
	respond(r, nil);
}

static void
clientthread(void *a)
{
	Client *c;
	Req *r;

	c = a;
	if(c-&gt;plumbed) {
		recvp(c-&gt;creq);
		if(c-&gt;url == nil){
			fprint(2, "bad url got plumbed\n");
			return;
		}
		clientbodyopen(c, nil);
		replumb(c);
	}
	while((r = recvp(c-&gt;creq)) != nil){
		if(fsdebug)
			fprint(2, "clientthread %F\n", &amp;r-&gt;ifcall);
		switch(r-&gt;ifcall.type){
		case Topen:
			if(c-&gt;plumbed) {
				c-&gt;plumbed = 0;
				c-&gt;ref--;			/* from plumburl() */
				respond(r, nil);
			}
			else
				clientbodyopen(c, r);
			break;
		case Tread:
			clientbodyread(c, r);
			break;
		case Tflush:
			respond(r, nil);
		}
		if(fsdebug)
			fprint(2, "clientthread finished req\n");
	}
}
	
enum
{
	Bool,
	Int,
	String,
	XUrl,
	Fn,
};

typedef struct Ctab Ctab;
struct Ctab {
	char *name;
	int type;
	void *offset;
};

Ctab ctltab[] = {
	"acceptcookies",	Bool,		(void*)offsetof(Ctl, acceptcookies),
	"sendcookies",		Bool,		(void*)offsetof(Ctl, sendcookies),
	"redirectlimit",		Int,		(void*)offsetof(Ctl, redirectlimit),
	"useragent",		String,	(void*)offsetof(Ctl, useragent),
};

Ctab globaltab[] = {
	"chatty9p",		Int,		&amp;chatty9p,
	"fsdebug",		Int,		&amp;fsdebug,
	"cookiedebug",		Int,		&amp;cookiedebug,
	"urldebug",		Int,		&amp;urldebug,
	"httpdebug",		Int,		&amp;httpdebug,
};

Ctab clienttab[] = {
	"baseurl",			XUrl,		(void*)offsetof(Client, baseurl),
	"url",				XUrl,		(void*)offsetof(Client, url),
};

static Ctab*
findcmd(char *cmd, Ctab *tab, int ntab)
{
	int i;

	for(i=0; i&lt;ntab; i++)
		if(strcmp(tab[i].name, cmd) == 0)
			return &amp;tab[i];
	return nil;
}

static void
parseas(Req *r, char *arg, int type, void *a)
{
	Url *u;
	char e[ERRMAX];

	switch(type){
	case Bool:
		if(strcmp(arg, "on")==0 || strcmp(arg, "1")==0)
			*(int*)a = 1;
		else
			*(int*)a = 0;
		break;
	case String:
		free(*(char**)a);
		*(char**)a = estrdup(arg);
		break;
	case XUrl:
		u = parseurl(arg, nil);
		if(u == nil){
			snprint(e, sizeof e, "parseurl: %r");
			respond(r, e);
			return;
		}
		freeurl(*(Url**)a);
		*(Url**)a = u;
		break;
	case Int:
		if(strcmp(arg, "on")==0)
			*(int*)a = 1;
		else
			*(int*)a = atoi(arg);
		break;
	}
	respond(r, nil);
}

int
ctlwrite(Req *r, Ctl *ctl, char *cmd, char *arg)
{
	void *a;
	Ctab *t;

	if((t = findcmd(cmd, ctltab, nelem(ctltab))) == nil)
		return 0;
	a = (void*)((uintptr)ctl+(uintptr)t-&gt;offset);
	parseas(r, arg, t-&gt;type, a);
	return 1;
}

int
clientctlwrite(Req *r, Client *c, char *cmd, char *arg)
{
	void *a;
	Ctab *t;

	if((t = findcmd(cmd, clienttab, nelem(clienttab))) == nil)
		return 0;
	a = (void*)((uintptr)c+(uintptr)t-&gt;offset);
	parseas(r, arg, t-&gt;type, a);
	return 1;
}

int
globalctlwrite(Req *r, char *cmd, char *arg)
{
	void *a;
	Ctab *t;

	if((t = findcmd(cmd, globaltab, nelem(globaltab))) == nil)
		return 0;
	a = t-&gt;offset;
	parseas(r, arg, t-&gt;type, a);
	return 1;
}

static void
ctlfmt(Ctl *c, char *s)
{
	int i;
	void *a;
	char *t;

	for(i=0; i&lt;nelem(ctltab); i++){
		a = (void*)((uintptr)c+(uintptr)ctltab[i].offset);
		switch(ctltab[i].type){
		case Bool:
			s += sprint(s, "%s %s\n", ctltab[i].name, *(int*)a ? "on" : "off");
			break;
		case Int:
			s += sprint(s, "%s %d\n", ctltab[i].name, *(int*)a);
			break;
		case String:
			t = *(char**)a;
			if(t != nil)
				s += sprint(s, "%s %.*s%s\n", ctltab[i].name, utfnlen(t, 100), t, strlen(t)&gt;100 ? "..." : "");
			break;
		}
	}
}

void
ctlread(Req *r, Client *c)
{
	char buf[1024];

	sprint(buf, "%11d \n", c-&gt;num);
	ctlfmt(&amp;c-&gt;ctl, buf+strlen(buf));
	readstr(r, buf);
	respond(r, nil);
}

void
globalctlread(Req *r)
{
	char buf[1024], *s;
	int i;

	s = buf;
	for(i=0; i&lt;nelem(globaltab); i++)
		s += sprint(s, "%s %d\n", globaltab[i].name, *(int*)globaltab[i].offset);
	ctlfmt(&amp;globalctl, s);
	readstr(r, buf);
	respond(r, nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

