<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/webfs/http.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/webfs/http.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ip.h&gt;
#include &lt;plumb.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include &lt;9p.h&gt;
#include &lt;libsec.h&gt;
#include &lt;auth.h&gt;
#include "dat.h"
#include "fns.h"

char PostContentType[] = "application/x-www-form-urlencoded";
int httpdebug;

typedef struct HttpState HttpState;
struct HttpState
{
	int fd;
	Client *c;
	char *location;
	char *setcookie;
	char *netaddr;
	char *credentials;
	char autherror[ERRMAX];
	Ibuf	b;
};

static void
location(HttpState *hs, char *value)
{
	if(hs-&gt;location == nil)
		hs-&gt;location = estrdup(value);
}

static void
contenttype(HttpState *hs, char *value)
{
	if(hs-&gt;c-&gt;contenttype != nil)
		free(hs-&gt;c-&gt;contenttype);
	hs-&gt;c-&gt;contenttype = estrdup(value);
}

static void
setcookie(HttpState *hs, char *value)
{
	char *s, *t;
	Fmt f;

	s = hs-&gt;setcookie;
	fmtstrinit(&amp;f);
	if(s)
		fmtprint(&amp;f, "%s", s);
	fmtprint(&amp;f, "set-cookie: ");
	fmtprint(&amp;f, "%s", value);
	fmtprint(&amp;f, "\n");
	t = fmtstrflush(&amp;f);
	if(t){
		free(s);
		hs-&gt;setcookie = t;
	}
}

static char*
unquote(char *s, char **ps)
{
	char *p;

	if(*s != '"'){
		p = strpbrk(s, " \t\r\n");
		*p++ = 0;
		*ps = p;
		return s;
	}
	for(p=s+1; *p; p++){
		if(*p == '\"'){
			*p++ = 0;
			break;
		}
		if(*p == '\\' &amp;&amp; *(p+1)){
			p++;
			continue;
		}
	}
	memmove(s, s+1, p-(s+1));
	s[p-(s+1)] = 0;
	*ps = p;
	return s;
}

static char*
servername(char *addr)
{
	char *p;

	if(strncmp(addr, "tcp!", 4) == 0
	|| strncmp(addr, "net!", 4) == 0)
		addr += 4;
	addr = estrdup(addr);
	p = addr+strlen(addr);
	if(p&gt;addr &amp;&amp; *(p-1) == 's')
		p--;
	if(p&gt;addr+5 &amp;&amp; strcmp(p-5, "!http") == 0)
		p[-5] = 0;
	return addr;
}

void
wwwauthenticate(HttpState *hs, char *line)
{
	char cred[64], *user, *pass, *realm, *s, *spec, *name;
	Fmt fmt;
	UserPasswd *up;

	spec = nil;
	up = nil;
	cred[0] = 0;
	hs-&gt;autherror[0] = 0;
	if(cistrncmp(line, "basic ", 6) != 0){
		werrstr("unknown auth: %s", line);
		goto error;
	}
	line += 6;
	if(cistrncmp(line, "realm=", 6) != 0){
		werrstr("missing realm: %s", line);
		goto error;
	}
	line += 6;
	user = hs-&gt;c-&gt;url-&gt;user;
	pass = hs-&gt;c-&gt;url-&gt;passwd;
	if(user==nil || pass==nil){
		realm = unquote(line, &amp;line);
		fmtstrinit(&amp;fmt);
		name = servername(hs-&gt;netaddr);
		fmtprint(&amp;fmt, "proto=pass service=http server=%q realm=%q", name, realm);
		free(name);
		if(hs-&gt;c-&gt;url-&gt;user)
			fmtprint(&amp;fmt, " user=%q", hs-&gt;c-&gt;url-&gt;user);
		spec = fmtstrflush(&amp;fmt);
		if(spec == nil)
			goto error;
		if((up = auth_getuserpasswd(nil, "%s", spec)) == nil)
			goto error;
		user = up-&gt;user;
		pass = up-&gt;passwd;
	}
	if((s = smprint("%s:%s", user, pass)) == nil)
		goto error;
	free(up);
	enc64(cred, sizeof(cred), (uchar*)s, strlen(s));
	memset(s, 0, strlen(s));
	free(s);
	hs-&gt;credentials = smprint("Basic %s", cred);
	if(hs-&gt;credentials == nil)
		goto error;
	return;

error:
	free(up);
	free(spec);
	snprint(hs-&gt;autherror, sizeof hs-&gt;autherror, "%r");
	fprint(2, "%s: Authentication failed: %r\n", argv0);
}

struct {
	char *name;									/* Case-insensitive */
	void (*fn)(HttpState *hs, char *value);
} hdrtab[] = {
	{ "location:", location },
	{ "content-type:", contenttype },
	{ "set-cookie:", setcookie },
	{ "www-authenticate:", wwwauthenticate },
};

static int
httprcode(HttpState *hs)
{
	int n;
	char *p;
	char buf[256];

	n = readline(&amp;hs-&gt;b, buf, sizeof(buf)-1);
	if(n &lt;= 0)
		return n;
	if(httpdebug)
		fprint(2, "-&gt; %s\n", buf);
	p = strchr(buf, ' ');
	if(memcmp(buf, "HTTP/", 5) != 0 || p == nil){
		werrstr("bad response from server");
		return -1;
	}
	buf[n] = 0;
	return atoi(p+1);
}
 
/*
 *  read a single mime header, collect continuations.
 *
 *  this routine assumes that there is a blank line twixt
 *  the header and the message body, otherwise bytes will
 *  be lost.
 */
static int
getheader(HttpState *hs, char *buf, int n)
{
	char *p, *e;
	int i;

	n--;
	p = buf;
	for(e = p + n; ; p += i){
		i = readline(&amp;hs-&gt;b, p, e-p);
		if(i &lt; 0)
			return i;

		if(p == buf){
			/* first line */
			if(strchr(buf, ':') == nil)
				break;		/* end of headers */
		} else {
			/* continuation line */
			if(*p != ' ' &amp;&amp; *p != '\t'){
				unreadline(&amp;hs-&gt;b, p);
				*p = 0;
				break;		/* end of this header */
			}
		}
	}

	if(httpdebug)
		fprint(2, "-&gt; %s\n", buf);
	return p-buf;
}

static int
httpheaders(HttpState *hs)
{
	char buf[2048];
	char *p;
	int i, n;

	for(;;){
		n = getheader(hs, buf, sizeof(buf));
		if(n &lt; 0)
			return -1;
		if(n == 0)
			return 0;
		//	print("http header: '%.*s'\n", n, buf);
		for(i = 0; i &lt; nelem(hdrtab); i++){
			n = strlen(hdrtab[i].name);
			if(cistrncmp(buf, hdrtab[i].name, n) == 0){
				/* skip field name and leading white */
				p = buf + n;
				while(*p == ' ' || *p == '\t')
					p++;
				(*hdrtab[i].fn)(hs, p);
				break;
			}
		}
	}
}

int
httpopen(Client *c, Url *url)
{
	int fd, code, redirect, authenticate;
	char *cookies;
	Ioproc *io;
	HttpState *hs;
	char *service;

	if(httpdebug)
		fprint(2, "httpopen\n");
	io = c-&gt;io;
	hs = emalloc(sizeof(*hs));
	hs-&gt;c = c;

	if(url-&gt;port)
		service = url-&gt;port;
	else
		service = url-&gt;scheme;
	hs-&gt;netaddr = estrdup(netmkaddr(url-&gt;host, 0, service));
	c-&gt;aux = hs;
	if(httpdebug){
		fprint(2, "dial %s\n", hs-&gt;netaddr);
		fprint(2, "dial port: %s\n", url-&gt;port);
	}
	fd = iotlsdial(io, hs-&gt;netaddr, 0, 0, 0, url-&gt;ischeme==UShttps);
	if(fd &lt; 0){
	Error:
		if(httpdebug)
			fprint(2, "iodial: %r\n");
		free(hs-&gt;location);
		free(hs-&gt;setcookie);
		free(hs-&gt;netaddr);
		free(hs-&gt;credentials);
		if(fd &gt;= 0)
			ioclose(io, hs-&gt;fd);
		hs-&gt;fd = -1;
		free(hs);
		c-&gt;aux = nil;
		return -1;
	}
	hs-&gt;fd = fd;
	if(httpdebug)
		fprint(2, "&lt;- %s %s HTTP/1.0\n&lt;- Host: %s\n",
			c-&gt;havepostbody? "POST": "GET", url-&gt;http.page_spec, url-&gt;host);
	ioprint(io, fd, "%s %s HTTP/1.0\r\nHost: %s\r\n",
		c-&gt;havepostbody? "POST" : "GET", url-&gt;http.page_spec, url-&gt;host);
	if(httpdebug)
		fprint(2, "&lt;- User-Agent: %s\n", c-&gt;ctl.useragent);
	if(c-&gt;ctl.useragent)
		ioprint(io, fd, "User-Agent: %s\r\n", c-&gt;ctl.useragent);
	if(c-&gt;ctl.sendcookies){
		/* should we use url-&gt;page here?  sometimes it is nil. */
		cookies = httpcookies(url-&gt;host, url-&gt;http.page_spec,
			url-&gt;ischeme == UShttps);
		if(cookies &amp;&amp; cookies[0])
			ioprint(io, fd, "%s", cookies);
		if(httpdebug)
			fprint(2, "&lt;- %s", cookies);
		free(cookies);
	}
	if(c-&gt;havepostbody){
		ioprint(io, fd, "Content-type: %s\r\n", PostContentType);
		ioprint(io, fd, "Content-length: %ud\r\n", c-&gt;npostbody);
		if(httpdebug){
			fprint(2, "&lt;- Content-type: %s\n", PostContentType);
			fprint(2, "&lt;- Content-length: %ud\n", c-&gt;npostbody);
		}
	}
	if(c-&gt;authenticate){
		ioprint(io, fd, "Authorization: %s\r\n", c-&gt;authenticate);
		if(httpdebug)
			fprint(2, "&lt;- Authorization: %s\n", c-&gt;authenticate);
	}
	ioprint(io, fd, "\r\n");
	if(c-&gt;havepostbody)
		if(iowrite(io, fd, c-&gt;postbody, c-&gt;npostbody) != c-&gt;npostbody)
			goto Error;

	redirect = 0;
	authenticate = 0;
	initibuf(&amp;hs-&gt;b, io, fd);
	code = httprcode(hs);

	switch(code){
	case -1:	/* connection timed out */
		goto Error;

/*
	case Eof:
		werrstr("EOF from HTTP server");
		goto Error;
*/

	case 200:	/* OK */
	case 201:	/* Created */
	case 202:	/* Accepted */
	case 204:	/* No Content */
	case 205: /* Reset Content */
#ifdef NOT_DEFINED
		if(ofile == nil &amp;&amp; r-&gt;start != 0)
			sysfatal("page changed underfoot");
#endif
		break;

	case 206:	/* Partial Content */
		werrstr("Partial Content (206)");
		goto Error;

	case 301:	/* Moved Permanently */
	case 302:	/* Moved Temporarily */
	case 303:	/* See Other */
	case 307: /* Temporary Redirect  */
		redirect = 1;
		break;

	case 304:	/* Not Modified */
		break;

	case 400:	/* Bad Request */
		werrstr("Bad Request (400)");
		goto Error;

	case 401:	/* Unauthorized */
		if(c-&gt;authenticate){
			werrstr("Authentication failed (401)");
			goto Error;
		}
		authenticate = 1;
		break;
	case 402:	/* Payment Required */
		werrstr("Payment Required (402)");
		goto Error;

	case 403:	/* Forbidden */
		werrstr("Forbidden by server (403)");
		goto Error;

	case 404:	/* Not Found */
		werrstr("Not found on server (404)");
		goto Error;

	case 405:	/* Method Not Allowed  */
		werrstr("Method not allowed (405)");
		goto Error;

	case 406: /* Not Acceptable */
		werrstr("Not Acceptable (406)");
		goto Error;

	case 407:	/* Proxy auth */
		werrstr("Proxy authentication required (407)");
		goto Error;

	case 408: /* Request Timeout */
		werrstr("Request Timeout (408)");
		goto Error;

	case 409: /* Conflict */
		werrstr("Conflict  (409)");
		goto Error;
	
	case 410: /* Gone */
		werrstr("Gone  (410)");
		goto Error;
	
	case 411: /* Length Required */
		werrstr("Length Required  (411)");
		goto Error;
	
	case 412: /* Precondition Failed */
		werrstr("Precondition Failed  (412)");
		goto Error;
	
	case 413: /* Request Entity Too Large */
		werrstr("Request Entity Too Large  (413)");
		goto Error;
	
	case 414: /* Request-URI Too Long */
		werrstr("Request-URI Too Long  (414)");
		goto Error;
	
	case 415: /* Unsupported Media Type */
		werrstr("Unsupported Media Type  (415)");
		goto Error;
	
	case 416: /* Requested Range Not Satisfiable */
		werrstr("Requested Range Not Satisfiable  (416)");
		goto Error;
	
	case 417: /* Expectation Failed */
		werrstr("Expectation Failed  (417)");
		goto Error;

	case 500:	/* Internal server error */
		werrstr("Server choked (500)");
		goto Error;

	case 501:	/* Not implemented */
		werrstr("Server can't do it (501)");
		goto Error;

	case 502:	/* Bad gateway */
		werrstr("Bad gateway (502)");
		goto Error;

	case 503:	/* Service unavailable */
		werrstr("Service unavailable (503)");
		goto Error;
	
	default:
		/* Bogus: we should treat unknown code XYZ as code X00 */
		werrstr("Unknown response code %d", code);
		goto Error;
	}

	if(httpheaders(hs) &lt; 0)
		goto Error;
	if(c-&gt;ctl.acceptcookies &amp;&amp; hs-&gt;setcookie)
		httpsetcookie(hs-&gt;setcookie, url-&gt;host, url-&gt;path);
	if(authenticate){
		if(!hs-&gt;credentials){
			if(hs-&gt;autherror[0])
				werrstr("%s", hs-&gt;autherror);
			else
				werrstr("unauthorized; no www-authenticate: header");
			goto Error;
		}
		c-&gt;authenticate = hs-&gt;credentials;
		hs-&gt;credentials = nil;
	}else if(c-&gt;authenticate)
		c-&gt;authenticate = 0;
	if(redirect){
		if(!hs-&gt;location){
			werrstr("redirection without Location: header");
			goto Error;
		}
		c-&gt;redirect = hs-&gt;location;
		hs-&gt;location = nil;
	}
	return 0;
}

int
httpread(Client *c, Req *r)
{
	HttpState *hs;
	long n;

	hs = c-&gt;aux;
	n = readibuf(&amp;hs-&gt;b, r-&gt;ofcall.data, r-&gt;ifcall.count);
	if(n &lt; 0)
		return -1;

	r-&gt;ofcall.count = n;
	return 0;
}

void
httpclose(Client *c)
{
	HttpState *hs;

	hs = c-&gt;aux;
	if(hs == nil)
		return;
	if(hs-&gt;fd &gt;= 0)
		ioclose(c-&gt;io, hs-&gt;fd);
	hs-&gt;fd = -1;
	free(hs-&gt;location);
	free(hs-&gt;setcookie);
	free(hs-&gt;netaddr);
	free(hs-&gt;credentials);
	free(hs);
	c-&gt;aux = nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

