<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/wikifs/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/wikifs/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;String.h&gt;
#include &lt;thread.h&gt;
#include "wiki.h"

#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;9p.h&gt;

enum {
	Qindexhtml,
	Qindextxt,
	Qraw,
	Qhistoryhtml,
	Qhistorytxt,
	Qdiffhtml,
	Qedithtml,
	Qwerrorhtml,
	Qwerrortxt,
	Qhttplogin,
	Nfile,
};

static char *filelist[] = {
	"index.html",
	"index.txt",
	"current",
	"history.html",
	"history.txt",
	"diff.html",
	"edit.html",
	"werror.html",
	"werror.txt",
	".httplogin",
};

static int needhist[Nfile] = {
[Qhistoryhtml] 1,
[Qhistorytxt] 1,
[Qdiffhtml] 1,
};

/*
 * The qids are &lt;8-bit type&gt;&lt;16-bit page number&gt;&lt;16-bit page version&gt;&lt;8-bit file index&gt;.
 */
enum {		/* &lt;8-bit type&gt; */
	Droot = 1,
	D1st,
	D2nd,
	Fnew,
	Fmap,
	F1st,
	F2nd,
};

uvlong
mkqid(int type, int num, int vers, int file)
{
	return ((uvlong)type&lt;&lt;40) | ((uvlong)num&lt;&lt;24) | (vers&lt;&lt;8) | file;
}

int
qidtype(uvlong path)
{
	return (path&gt;&gt;40)&amp;0xFF;
}

int
qidnum(uvlong path)
{
	return (path&gt;&gt;24)&amp;0xFFFF;
}

int
qidvers(uvlong path)
{
	return (path&gt;&gt;8)&amp;0xFFFF;
}

int
qidfile(uvlong path)
{
	return path&amp;0xFF;
}

typedef struct Aux Aux;
struct Aux {
	String *name;
	Whist *w;
	int n;
	ulong t;
	String *s;
	Map *map;
};

static void
fsattach(Req *r)
{
	Aux *a;

	if(r-&gt;ifcall.aname &amp;&amp; r-&gt;ifcall.aname[0]){
		respond(r, "invalid attach specifier");
		return;
	}

	a = emalloc(sizeof(Aux));
	r-&gt;fid-&gt;aux = a;
	a-&gt;name = s_copy(r-&gt;ifcall.uname);

	r-&gt;ofcall.qid = (Qid){mkqid(Droot, 0, 0, 0), 0, QTDIR};
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	respond(r, nil);
}

static String *
httplogin(void)
{
	String *s=s_new();
	Biobuf *b;

	if((b = wBopen(".httplogin", OREAD)) == nil)
		goto Return;

	while(s_read(b, s, Bsize) &gt; 0)
		;
	Bterm(b);

Return:
	return s;
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	char *q;
	int i, isdotdot, n, t;
	uvlong path;
	Aux *a;
	Whist *wh;
	String *s;

	isdotdot = strcmp(name, "..")==0;
	n = strtoul(name, &amp;q, 10);
	path = fid-&gt;qid.path;
	a = fid-&gt;aux;

	switch(qidtype(path)){
	case 0:
		return "wikifs: bad path in server (bug)";

	case Droot:
		if(isdotdot){
			*qid = fid-&gt;qid;
			return nil;
		}
		if(strcmp(name, "new")==0){
			*qid = (Qid){mkqid(Fnew, 0, 0, 0), 0, 0};
			return nil;
		}
		if(strcmp(name, "map")==0){
			*qid = (Qid){mkqid(Fmap, 0, 0, 0), 0, 0};
			return nil;
		}
		if((*q!='\0' || (wh=getcurrent(n))==nil)
		&amp;&amp; (wh=getcurrentbyname(name))==nil)
			return "file does not exist";
		*qid = (Qid){mkqid(D1st, wh-&gt;n, 0, 0), wh-&gt;doc-&gt;time, QTDIR};
		a-&gt;w = wh;
		return nil;

	case D1st:
		if(isdotdot){
			*qid = (Qid){mkqid(Droot, 0, 0, 0), 0, QTDIR};
			return nil;
		}

		/* handle history directories */
		if(*q == '\0'){
			if((wh = gethistory(qidnum(path))) == nil)
				return "file does not exist";
			for(i=0; i&lt;wh-&gt;ndoc; i++)
				if(wh-&gt;doc[i].time == n)
					break;
			if(i==wh-&gt;ndoc){
				closewhist(wh);
				return "file does not exist";
			}
			closewhist(a-&gt;w);
			a-&gt;w = wh;
			a-&gt;n = i;
			*qid = (Qid){mkqid(D2nd, qidnum(path), i, 0), wh-&gt;doc[i].time, QTDIR};
			return nil;
		}

		/* handle files other than index */
		for(i=0; i&lt;nelem(filelist); i++){
			if(strcmp(name, filelist[i])==0){
				if(needhist[i]){
					if((wh = gethistory(qidnum(path))) == nil)
						return "file does not exist";
					closewhist(a-&gt;w);
					a-&gt;w = wh;
				}
				*qid = (Qid){mkqid(F1st, qidnum(path), 0, i), a-&gt;w-&gt;doc-&gt;time, 0};
				goto Gotfile;
			}
		}
		return "file does not exist";

	case D2nd:
		if(isdotdot){
			/*
			 * Can't use a-&gt;w[a-&gt;ndoc-1] because that
			 * might be a failed write rather than the real one.
			 */
			*qid = (Qid){mkqid(D1st, qidnum(path), 0, 0), 0, QTDIR};
			if((wh = getcurrent(qidnum(path))) == nil)
				return "file does not exist";
			closewhist(a-&gt;w);
			a-&gt;w = wh;
			a-&gt;n = 0;
			return nil;
		}
		for(i=0; i&lt;=Qraw; i++){
			if(strcmp(name, filelist[i])==0){
				*qid = (Qid){mkqid(F2nd, qidnum(path), qidvers(path), i), a-&gt;w-&gt;doc-&gt;time, 0};
				goto Gotfile;
			}
		}
		return "file does not exist";

	default:
		return "bad programming";
	}
	/* not reached */

Gotfile:
	t = qidtype(qid-&gt;path);
	switch(qidfile(qid-&gt;path)){
	case Qindexhtml:
		s = tohtml(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n,
			t==F1st? Tpage : Toldpage);
		break;
	case Qindextxt:
		s = totext(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n,
			t==F1st? Tpage : Toldpage);
		break;
	case Qraw:
		s = s_copy(a-&gt;w-&gt;title);
		s = s_append(s, "\n");
		s = doctext(s, &amp;a-&gt;w-&gt;doc[a-&gt;n]);
		break;
	case Qhistoryhtml:
		s = tohtml(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n, Thistory);
		break;
	case Qhistorytxt:
		s = totext(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n, Thistory);
		break;
	case Qdiffhtml:
		s = tohtml(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n, Tdiff);
		break;
	case Qedithtml:
		s = tohtml(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n, Tedit);
		break;
	case Qwerrorhtml:
		s = tohtml(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n, Twerror);
		break;
	case Qwerrortxt:
		s = totext(a-&gt;w, a-&gt;w-&gt;doc+a-&gt;n, Twerror);
		break;
	case Qhttplogin:
		s = httplogin();
		break;
	default:
		return "internal error";
	}
	a-&gt;s = s;
	return nil;
}

static void
fsopen(Req *r)
{
	int t;
	uvlong path;
	Aux *a;
	Fid *fid;
	Whist *wh;

	fid = r-&gt;fid;
	path = fid-&gt;qid.path;
	t = qidtype(fid-&gt;qid.path);
	if((r-&gt;ifcall.mode != OREAD &amp;&amp; t != Fnew &amp;&amp; t != Fmap)
	|| (r-&gt;ifcall.mode&amp;ORCLOSE)){
		respond(r, "permission denied");
		return;
	}

	a = fid-&gt;aux;
	switch(t){
	case Droot:
		currentmap(0);
		rlock(&amp;maplock);
		a-&gt;map = map;
		incref(map);
		runlock(&amp;maplock);
		respond(r, nil);
		break;
		
	case D1st:
		if((wh = gethistory(qidnum(path))) == nil){
			respond(r, "file does not exist");
			return;
		}
		closewhist(a-&gt;w);
		a-&gt;w = wh;
		a-&gt;n = a-&gt;w-&gt;ndoc-1;
		r-&gt;ofcall.qid.vers = wh-&gt;doc[a-&gt;n].time;
		r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
		respond(r, nil);
		break;
		
	case D2nd:
		respond(r, nil);
		break;

	case Fnew:
		a-&gt;s = s_copy("");
		respond(r, nil);
		break;

	case Fmap:
	case F1st:
	case F2nd:
		respond(r, nil);
		break;

	default:
		respond(r, "programmer error");
		break;
	}
}

static char*
fsclone(Fid *old, Fid *new)
{
	Aux *a;

	a = emalloc(sizeof(*a));
	*a = *(Aux*)old-&gt;aux;
	if(a-&gt;s)
		s_incref(a-&gt;s);
	if(a-&gt;w)
		incref(a-&gt;w);
	if(a-&gt;map)
		incref(a-&gt;map);
	if(a-&gt;name)
		s_incref(a-&gt;name);
	new-&gt;aux = a;
	new-&gt;qid = old-&gt;qid;

	return nil;
}

static void
fsdestroyfid(Fid *fid)
{
	Aux *a;

	a = fid-&gt;aux;
	if(a==nil)
		return;

	if(a-&gt;name)
		s_free(a-&gt;name);
	if(a-&gt;map)
		closemap(a-&gt;map);
	if(a-&gt;s)
		s_free(a-&gt;s);
	if(a-&gt;w)
		closewhist(a-&gt;w);
	free(a);
	fid-&gt;aux = nil;
}

static void
fillstat(Dir *d, uvlong path, ulong tm, ulong length)
{
	char tmp[32], *p;
	int type;

	memset(d, 0, sizeof(Dir));
	d-&gt;uid = estrdup9p("wiki");
	d-&gt;gid = estrdup9p("wiki");

	switch(qidtype(path)){
	case Droot:
	case D1st:
	case D2nd:
		type = QTDIR;
		break;
	default:
		type = 0;
		break;
	}
	d-&gt;qid = (Qid){path, tm, type};

	d-&gt;atime = d-&gt;mtime = tm;
	d-&gt;length = length;
	if(qidfile(path) == Qedithtml)
		d-&gt;atime = d-&gt;mtime = time(0);

	switch(qidtype(path)){
	case Droot:
		d-&gt;name = estrdup("/");
		d-&gt;mode = DMDIR|0555;
		break;

	case D1st:
		d-&gt;name = numtoname(qidnum(path));
		if(d-&gt;name == nil)
			d-&gt;name = estrdup("&lt;dead&gt;");
		for(p=d-&gt;name; *p; p++)
			if(*p==' ')
				*p = '_';
		d-&gt;mode = DMDIR|0555;
		break;

	case D2nd:
		snprint(tmp, sizeof tmp, "%lud", tm);
		d-&gt;name = estrdup(tmp);
		d-&gt;mode = DMDIR|0555;
		break;

	case Fmap:
		d-&gt;name = estrdup("map");
		d-&gt;mode = 0666;
		break;

	case Fnew:
		d-&gt;name = estrdup("new");
		d-&gt;mode = 0666;
		break;

	case F1st:
		d-&gt;name = estrdup(filelist[qidfile(path)]);
		d-&gt;mode = 0444;
		break;

	case F2nd:
		d-&gt;name = estrdup(filelist[qidfile(path)]);
		d-&gt;mode = 0444;
		break;

	default:
		print("bad qid path 0x%.8llux\n", path);
		break;
	}
}

static void
fsstat(Req *r)
{
	Aux *a;
	Fid *fid;
	ulong t;

	t = 0;
	fid = r-&gt;fid;
	if((a = fid-&gt;aux) &amp;&amp; a-&gt;w)
		t = a-&gt;w-&gt;doc[a-&gt;n].time;

	fillstat(&amp;r-&gt;d, fid-&gt;qid.path, t, a-&gt;s ? s_len(a-&gt;s) : 0);
	respond(r, nil);
}

typedef struct Bogus Bogus;
struct Bogus {
	uvlong path;
	Aux *a;
};

static int
rootgen(int i, Dir *d, void *aux)
{
	Aux *a;
	Bogus *b;

	b = aux;
	a = b-&gt;a;
	switch(i){
	case 0:	/* new */
		fillstat(d, mkqid(Fnew, 0, 0, 0), a-&gt;map-&gt;t, 0);
		return 0;
	case 1:	/* map */
		fillstat(d, mkqid(Fmap, 0, 0, 0), a-&gt;map-&gt;t, 0);
		return 0;
	default:	/* first-level directory */
		i -= 2;
		if(i &gt;= a-&gt;map-&gt;nel)
			return -1;
		fillstat(d, mkqid(D1st, a-&gt;map-&gt;el[i].n, 0, 0), a-&gt;map-&gt;t, 0);
		return 0;
	}
}

static int
firstgen(int i, Dir *d, void *aux)
{
	ulong t;
	Bogus *b;
	int num;
	Aux *a;

	b = aux;
	num = qidnum(b-&gt;path);
	a = b-&gt;a;
	t = a-&gt;w-&gt;doc[a-&gt;n].time;

	if(i &lt; Nfile){	/* file in first-level directory */
		fillstat(d, mkqid(F1st, num, 0, i), t, 0);
		return 0;
	}
	i -= Nfile;

	if(i &lt; a-&gt;w-&gt;ndoc){	/* second-level (history) directory */
		fillstat(d, mkqid(D2nd, num, i, 0), a-&gt;w-&gt;doc[i].time, 0);
		return 0;
	}
	//i -= a-&gt;w-&gt;ndoc;

	return -1;
}

static int
secondgen(int i, Dir *d, void *aux)
{
	Bogus *b;
	uvlong path;
	Aux *a;

	b = aux;
	path = b-&gt;path;
	a = b-&gt;a;

	if(i &lt;= Qraw){	/* index.html, index.txt, raw */
		fillstat(d, mkqid(F2nd, qidnum(path), qidvers(path), i), a-&gt;w-&gt;doc[a-&gt;n].time, 0);
		return 0;
	}
	//i -= Qraw;

	return -1;
}

static void
fsread(Req *r)
{
	char *t, *s;
	uvlong path;
	Aux *a;
	Bogus b;

	a = r-&gt;fid-&gt;aux;
	path = r-&gt;fid-&gt;qid.path;
	b.a = a;
	b.path = path;
	switch(qidtype(path)){
	default:
		respond(r, "cannot happen (bad qid)");
		return;

	case Droot:
		if(a == nil || a-&gt;map == nil){
			respond(r, "cannot happen (no map)");
			return;
		}
		dirread9p(r, rootgen, &amp;b);
		respond(r, nil);
		return;
		
	case D1st:
		if(a == nil || a-&gt;w == nil){
			respond(r, "cannot happen (no wh)");
			return;
		}
		dirread9p(r, firstgen, &amp;b);
		respond(r, nil);
		return;
		
	case D2nd:
		dirread9p(r, secondgen, &amp;b);
		respond(r, nil);
		return;

	case Fnew:
		if(a-&gt;s){
			respond(r, "protocol botch");
			return;
		}
		/* fall through */
	case Fmap:
		t = numtoname(a-&gt;n);
		if(t == nil){
			respond(r, "unknown name");
			return;
		}
		for(s=t; *s; s++)
			if(*s == ' ')
				*s = '_';
		readstr(r, t);
		free(t);
		respond(r, nil);
		return;

	case F1st:
	case F2nd:
		if(a == nil || a-&gt;s == nil){
			respond(r, "cannot happen (no s)");
			return;
		}
		readbuf(r, s_to_c(a-&gt;s), s_len(a-&gt;s));
		respond(r, nil);
		return;
	}
}

typedef struct Sread Sread;
struct Sread {
	char *rp;
};

static char*
Srdline(void *v, int c)
{
	char *p, *rv;
	Sread *s;

	s = v;
	if(s-&gt;rp == nil)
		rv = nil;
	else if(p = strchr(s-&gt;rp, c)){
		*p = '\0';
		rv = s-&gt;rp;
		s-&gt;rp = p+1;
	}else{
		rv = s-&gt;rp;
		s-&gt;rp = nil;
	}
	return rv;
}

static void
responderrstr(Req *r)
{
	char buf[ERRMAX];

	rerrstr(buf, sizeof buf);
	if(buf[0] == '\0')
		strcpy(buf, "unknown error");
	respond(r, buf);
}

static void
fswrite(Req *r)
{
	char *author, *comment, *net, *err, *p, *title, tmp[40];
	int rv, n;
	ulong t;
	Aux *a;
	Fid *fid;
	Sread s;
	String *stmp;
	Whist *w;

	fid = r-&gt;fid;
	a = fid-&gt;aux;
	switch(qidtype(fid-&gt;qid.path)){
	case Fmap:
		stmp = s_nappend(s_reset(nil), r-&gt;ifcall.data, r-&gt;ifcall.count);
		a-&gt;n = nametonum(s_to_c(stmp));
		s_free(stmp);
		if(a-&gt;n &lt; 0)
			respond(r, "name not found");
		else
			respond(r, nil);
		return;
	case Fnew:
		break;
	default:
		respond(r, "cannot happen");
		return;
	}

	if(a-&gt;s == nil){
		respond(r, "protocol botch");
		return;
	}
	if(r-&gt;ifcall.count==0){	/* do final processing */
		s.rp = s_to_c(a-&gt;s);
		w = nil;
		err = "bad format";
		if((title = Srdline(&amp;s, '\n')) == nil){
		Error:
			if(w)
				closewhist(w);
			s_free(a-&gt;s);
			a-&gt;s = nil;
			respond(r, err);
			return;
		}

		w = emalloc(sizeof(*w));
		incref(w);
		w-&gt;title = estrdup(title);

		t = 0;
		author = estrdup(s_to_c(a-&gt;name));

		comment = nil;
		while(s.rp &amp;&amp; *s.rp &amp;&amp; *s.rp != '\n'){
			p = Srdline(&amp;s, '\n');
			assert(p != nil);
			switch(p[0]){
			case 'A':
				free(author);
				author = estrdup(p+1);
				break;
			case 'D':
				t = strtoul(p+1, &amp;p, 10);
				if(*p != '\0')
					goto Error;
				break;
			case 'C':
				free(comment);
				comment = estrdup(p+1);
				break;
			}
		}

		w-&gt;doc = emalloc(sizeof(w-&gt;doc[0]));
		w-&gt;doc-&gt;time = time(0);
		w-&gt;doc-&gt;comment = comment;

		if(net = r-&gt;pool-&gt;srv-&gt;aux){
			p = emalloc(strlen(author)+10+strlen(net));
			strcpy(p, author);
			strcat(p, " (");
			strcat(p, net);
			strcat(p, ")");
			free(author);
			author = p;
		}
		w-&gt;doc-&gt;author = author;

		if((w-&gt;doc-&gt;wtxt = Brdpage(Srdline, &amp;s)) == nil){
			err = "empty document";
			goto Error;
		}

		w-&gt;ndoc = 1;
		if((n = allocnum(w-&gt;title, 0)) &lt; 0)
			goto Error;
		sprint(tmp, "D%lud\n", w-&gt;doc-&gt;time);
		a-&gt;s = s_reset(a-&gt;s);
		a-&gt;s = doctext(a-&gt;s, w-&gt;doc);
		rv = writepage(n, t, a-&gt;s, w-&gt;title);
		s_free(a-&gt;s);
		a-&gt;s = nil;
		a-&gt;n = n;
		closewhist(w);
		if(rv &lt; 0)
			responderrstr(r);
		else
			respond(r, nil);
		return;
	}

	if(s_len(a-&gt;s)+r-&gt;ifcall.count &gt; Maxfile){
		respond(r, "file too large");
		s_free(a-&gt;s);
		a-&gt;s = nil;
		return;
	}
	a-&gt;s = s_nappend(a-&gt;s, r-&gt;ifcall.data, r-&gt;ifcall.count);
	r-&gt;ofcall.count = r-&gt;ifcall.count;
	respond(r, nil);
}

Srv wikisrv = {
.attach=	fsattach,
.destroyfid=	fsdestroyfid,
.clone=	fsclone,
.walk1=	fswalk1,
.open=	fsopen,
.read=	fsread,
.write=	fswrite,
.stat=	fsstat,
};

void
usage(void)
{
	fprint(2, "usage: wikifs [-D] [-a addr]... [-m mtpt] [-p perm] [-s service] dir\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	char **addr;
	int i, naddr;
	char *buf;
	char *service, *mtpt;
	ulong perm;
	Dir d, *dp;
	Srv *s;

	naddr = 0;
	addr = nil;
	perm = 0;
	service = nil;
	mtpt = "/mnt/wiki";
	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'a':
		if(naddr%8 == 0)
			addr = erealloc(addr, (naddr+8)*sizeof(addr[0]));
		addr[naddr++] = EARGF(usage());
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	case 'M':
		mtpt = nil;
		break;
	case 'p':
		perm = strtoul(EARGF(usage()), nil, 8);
		break;
	case 's':
		service = EARGF(usage());
		break;
	default:
		usage();
		break;
	}ARGEND

	if(argc != 1)
		usage();

	if((dp = dirstat(argv[0])) == nil)
		sysfatal("dirstat %s: %r", argv[0]);
	if((dp-&gt;mode&amp;DMDIR) == 0)
		sysfatal("%s: not a directory", argv[0]);
	free(dp);
	wikidir = argv[0];

	currentmap(0);

	for(i=0; i&lt;naddr; i++)
		listensrv(&amp;wikisrv, addr[i]);

	s = emalloc(sizeof *s);
	*s = wikisrv;
	postmountsrv(s, service, mtpt, MREPL|MCREATE);
	if(perm){
		buf = emalloc9p(5+strlen(service)+1);
		strcpy(buf, "/srv/");
		strcat(buf, service);
		nulldir(&amp;d);
		d.mode = perm;
		if(dirwstat(buf, &amp;d) &lt; 0)
			fprint(2, "wstat: %r\n");
		free(buf);
	}
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

