<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/wikifs/parse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/wikifs/parse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;String.h&gt;
#include &lt;ctype.h&gt;
#include &lt;thread.h&gt;
#include "wiki.h"

static Wpage*
mkwtxt(int type, char *text)
{
	Wpage *w;

	w = emalloc(sizeof(*w));
	w-&gt;type = type;
	w-&gt;text = text;
	setmalloctag(w, getcallerpc(&amp;type));
	return w;
}

/*
 * turn runs of whitespace into single spaces,
 * eliminate whitespace at beginning and end.
 */
char*
strcondense(char *s, int cutbegin)
{
	char *r, *w, *es;
	int inspace;

	es = s+strlen(s);
	inspace = cutbegin;
	for(r=w=s; *r; r++){
		if(isspace(*r)){
			if(!inspace){
				inspace=1;
				*w++ = ' ';
			}
		}else{
			inspace=0;
			*w++ = *r;
		}
	}
	assert(w &lt;= es);
	if(inspace &amp;&amp; w&gt;s){
		--w;
		*w = '\0';
	}
	else
		*w = '\0';
	return s;
}

/*
 * turn runs of Wplain into single Wplain.
 */
static Wpage*
wcondense(Wpage *wtxt)
{
	Wpage *ow, *w;

	for(w=wtxt; w; ){
		if(w-&gt;type == Wplain)
			strcondense(w-&gt;text, 1);

		if(w-&gt;type != Wplain || w-&gt;next==nil
		|| w-&gt;next-&gt;type != Wplain){
			w=w-&gt;next;
			continue;
		}

		w-&gt;text = erealloc(w-&gt;text, strlen(w-&gt;text)+1+strlen(w-&gt;next-&gt;text)+1);
		strcat(w-&gt;text, " ");
		strcat(w-&gt;text, w-&gt;next-&gt;text);
		
		ow = w-&gt;next;
		w-&gt;next = ow-&gt;next;
		ow-&gt;next = nil;
		freepage(ow);
	}
	return wtxt;
}

/*
 * Parse a link, without the brackets.
 */
static Wpage*
mklink(char *s)
{
	char *q;
	Wpage *w;

	for(q=s; *q &amp;&amp; *q != '|'; q++)
		;

	if(*q == '\0'){
		w = mkwtxt(Wlink, estrdup(strcondense(s, 1)));
		w-&gt;url = nil;
	}else{
		*q = '\0';
		w = mkwtxt(Wlink, estrdup(strcondense(s, 1)));
		w-&gt;url = estrdup(strcondense(q+1, 1));
	}
	setmalloctag(w, getcallerpc(&amp;s));
	return w;
}

/*
 * Parse Wplains, inserting Wlink nodes where appropriate.
 */
static Wpage*
wlink(Wpage *wtxt)
{
	char *p, *q, *r, *s;
	Wpage *w, *nw;

	for(w=wtxt; w; w=nw){
		nw = w-&gt;next;
		if(w-&gt;type != Wplain)
			continue;
		while(w-&gt;text[0]){
			p = w-&gt;text;
			for(q=p; *q &amp;&amp; *q != '['; q++)
				;
			if(*q == '\0')
				break;
			for(r=q; *r &amp;&amp; *r != ']'; r++)
				;
			if(*r == '\0')
				break;
			*q = '\0';
			*r = '\0';
			s = w-&gt;text;
			w-&gt;text = estrdup(w-&gt;text);
			w-&gt;next = mklink(q+1);
			w = w-&gt;next;
			w-&gt;next = mkwtxt(Wplain, estrdup(r+1));
			free(s);
			w = w-&gt;next;
			w-&gt;next = nw;
		}
		assert(w-&gt;next == nw);
	}
	return wtxt;	
}

static int
ismanchar(int c)
{
	return ('a' &lt;= c &amp;&amp; c &lt;= 'z')
		|| ('A' &lt;= c &amp;&amp; c &lt;= 'Z')
		|| ('0' &lt;= c &amp;&amp; c &lt;= '9')
		|| c=='_' || c=='-' || c=='.' || c=='/'
		|| (c &lt; 0);	/* UTF */
}

static Wpage*
findmanref(char *p, char **beginp, char **endp)
{
	char *q, *r;
	Wpage *w;

	q=p;
	for(;;){
		for(; q[0] &amp;&amp; (q[0] != '(' || !isdigit(q[1]) || q[2] != ')'); q++)
			;
		if(*q == '\0')
			break;
		for(r=q; r&gt;p &amp;&amp; ismanchar(r[-1]); r--)
			;
		if(r==q){
			q += 3;
			continue;
		}
		*q = '\0';
		w = mkwtxt(Wman, estrdup(r));
		*beginp = r;
		*q = '(';
		w-&gt;section = q[1]-'0';
		*endp = q+3;
		setmalloctag(w, getcallerpc(&amp;p));
		return w;
	}
	return nil;
}

/*
 * Parse Wplains, looking for man page references.
 * This should be done by using a plumb(6)-style 
 * control file rather than hard-coding things here.
 */
static Wpage*
wman(Wpage *wtxt)
{
	char *q, *r;
	Wpage *w, *mw, *nw;

	for(w=wtxt; w; w=nw){
		nw = w-&gt;next;
		if(w-&gt;type != Wplain)
			continue;
		while(w-&gt;text[0]){
			if((mw = findmanref(w-&gt;text, &amp;q, &amp;r)) == nil)
				break;
			*q = '\0';
			w-&gt;next = mw;
			w = w-&gt;next;
			w-&gt;next = mkwtxt(Wplain, estrdup(r));
			w = w-&gt;next;
			w-&gt;next = nw;
		}
		assert(w-&gt;next == nw);
	}
	return wtxt;	
}

static int isheading(char *p) {
	Rune r;
	int hasupper=0;
	while(*p) {
		p+=chartorune(&amp;r,p);
		if(isupperrune(r))
			hasupper=1;
		else if(islowerrune(r))
			return 0;
	}
	return hasupper;
}

Wpage*
Brdpage(char *(*rdline)(void*,int), void *b)
{
	char *p, *c;
	int waspara;
	Wpage *w, **pw;

	w = nil;
	pw = &amp;w;
	waspara = 1;
	while((p = rdline(b, '\n')) != nil){
		if(p[0] != '!')
			p = strcondense(p, 1);
		if(p[0] == '\0'){
			if(waspara==0){
				waspara=1;
				*pw = mkwtxt(Wpara, nil);
				pw = &amp;(*pw)-&gt;next;
			}
			continue;
		}
		waspara = 0;
		switch(p[0]){
		case '*':
			*pw = mkwtxt(Wbullet, nil);
			pw = &amp;(*pw)-&gt;next;
			*pw = mkwtxt(Wplain, estrdup(p+1));
			pw = &amp;(*pw)-&gt;next;
			break;
		case '!':
			*pw = mkwtxt(Wpre, estrdup(p[1]==' '?p+2:p+1));
			pw = &amp;(*pw)-&gt;next;
			break;
		case '-':
			for(c = p; *c != '\0'; c++) {
				if(*c != '-') {
					c = p;
					break;
				}
			}

			if( (c-p) &gt; 4) {
				*pw = mkwtxt(Whr, nil);
				pw = &amp;(*pw)-&gt;next;
				break;
			}
			/* else fall thru */
		default:
			if(isheading(p)){
				*pw = mkwtxt(Wheading, estrdup(p));
				pw = &amp;(*pw)-&gt;next;
				continue;
			}
			*pw = mkwtxt(Wplain, estrdup(p));
			pw = &amp;(*pw)-&gt;next;
			break;
		}
	}
	if(w == nil)
		werrstr("empty page");
	
	*pw = nil;
	w = wcondense(w);
	w = wlink(w);
	w = wman(w);
	setmalloctag(w, getcallerpc(&amp;rdline));

	return w;		
}

void
printpage(Wpage *w)
{
	for(; w; w=w-&gt;next){
		switch(w-&gt;type){
		case Wpara:
			print("para\n");
			break;
		case Wheading:
			print("heading '%s'\n", w-&gt;text);
			break;
		case Wbullet:
			print("bullet\n");
			break;
		case Wlink:
			print("link '%s' '%s'\n", w-&gt;text, w-&gt;url);
			break;
		case Wman:
			print("man %d %s\n", w-&gt;section, w-&gt;text);
			break;
		case Wplain:
			print("plain '%s'\n", w-&gt;text);
			break;
		case Whr:
			print("hr\n");
			break;
		case Wpre:
			print("pre '%s'\n", w-&gt;text);
			break;
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

