<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/wikifs/parsehist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/wikifs/parsehist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Read a Wiki history file.
 * It's a title line then a sequence of Wiki files separated by headers.
 *
 * Ddate/time
 * #body
 * #...
 * #...
 * #...
 * etc.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;String.h&gt;
#include &lt;thread.h&gt;
#include "wiki.h"

static char*
Brdwline(void *vb, int sep)
{
	Biobufhdr *b;
	char *p;

	b = vb;
	if(Bgetc(b) == '#'){
		if(p = Brdline(b, sep))
			p[Blinelen(b)-1] = '\0';
		return p;
	}else{
		Bungetc(b);
		return nil;	
	}
}

Whist*
Brdwhist(Biobuf *b)
{
	int i, current, conflict, c, n;
	char *author, *comment, *p, *title;
	ulong t;
	Wdoc *w;
	Whist *h;

	if((p = Brdline(b, '\n')) == nil){
		werrstr("short read: %r");
		return nil;
	}

	p[Blinelen(b)-1] = '\0';
	p = strcondense(p, 1);
	title = estrdup(p);

	w = nil;
	n = 0;
	t = -1;
	author = nil;
	comment = nil;
	conflict = 0;
	current = 0;
	while((c = Bgetc(b)) != Beof){
		if(c != '#'){
			p = Brdline(b, '\n');
			if(p == nil)
				break;
			p[Blinelen(b)-1] = '\0';

			switch(c){
			case 'D':
				t = strtoul(p, 0, 10);
				break;
			case 'A':
				free(author);
				author = estrdup(p);
				break;
			case 'C':
				free(comment);
				comment = estrdup(p);
				break;
			case 'X':
				conflict = 1;
			}
		} else {	/* c=='#' */
			Bungetc(b);
			if(n%8 == 0)
				w = erealloc(w, (n+8)*sizeof(w[0]));
			w[n].time = t;
			w[n].author = author;
			w[n].comment = comment;
			comment = nil;
			author = nil;
			w[n].wtxt = Brdpage(Brdwline, b);
			w[n].conflict = conflict;
			if(w[n].wtxt == nil)
				goto Error;
			if(!conflict)
				current = n;
			n++;
			conflict = 0;
			t = -1;
		}
	}
	if(w==nil)
		goto Error;

	free(comment);
	free(author);
	h = emalloc(sizeof *h);
	h-&gt;title = title;
	h-&gt;doc = w;
	h-&gt;ndoc = n;
	h-&gt;current = current;
	incref(h);
	setmalloctag(h, getcallerpc(&amp;b));
	return h;

Error:
	free(title);
	free(author);
	free(comment);
	for(i=0; i&lt;n; i++){
		free(w[i].author);
		free(w[i].comment);
		freepage(w[i].wtxt);
	}
	free(w);
	return nil;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

