<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/wikifs/tohtml.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/wikifs/tohtml.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;String.h&gt;
#include &lt;thread.h&gt;
#include "wiki.h"

/*
 * Get HTML and text templates from underlying file system.
 * Caches them, which means changes don't take effect for
 * up to Tcache seconds after they are made.
 * 
 * If the files are deleted, we keep returning the last
 * known copy.
 */
enum {
	WAIT = 60
};

static char *name[2*Ntemplate] = {
 [Tpage]		"page.html",
 [Tedit]		"edit.html",
 [Tdiff]		"diff.html",
 [Thistory]		"history.html",
 [Tnew]		"new.html",
 [Toldpage]	"oldpage.html",
 [Twerror]		"werror.html",
 [Ntemplate+Tpage]	"page.txt",
 [Ntemplate+Tdiff]	"diff.txt",
 [Ntemplate+Thistory]	"history.txt",
 [Ntemplate+Toldpage]	"oldpage.txt",
 [Ntemplate+Twerror]	"werror.txt",
};

static struct {
	RWLock;
	String *s;
	ulong t;
	Qid qid;
} cache[2*Ntemplate];

static void
cacheinit(void)
{
	int i;
	static int x;
	static Lock l;

	if(x)
		return;
	lock(&amp;l);
	if(x){
		unlock(&amp;l);
		return;
	}

	for(i=0; i&lt;2*Ntemplate; i++)
		if(name[i])
			cache[i].s = s_copy("");
	x = 1;
	unlock(&amp;l);
}

static String*
gettemplate(int type)
{
	int n;
	Biobuf *b;
	Dir *d;
	String *s, *ns;

	if(name[type]==nil)
		return nil;

	cacheinit();

	rlock(&amp;cache[type]);
	if(0 &amp;&amp; cache[type].t+Tcache &gt;= time(0)){
		s = s_incref(cache[type].s);
		runlock(&amp;cache[type]);
		return s;
	}
	runlock(&amp;cache[type]);

//	d = nil;
	wlock(&amp;cache[type]);
	if(0 &amp;&amp; cache[type].t+Tcache &gt;= time(0) || (d = wdirstat(name[type])) == nil)
		goto Return;

	if(0 &amp;&amp; d-&gt;qid.vers == cache[type].qid.vers &amp;&amp; d-&gt;qid.path == cache[type].qid.path){
		cache[type].t = time(0);
		goto Return;
	}

	if((b = wBopen(name[type], OREAD)) == nil)
		goto Return;

	ns = s_reset(nil);
	do
		n = s_read(b, ns, Bsize);
	while(n &gt; 0);
	Bterm(b);
	if(n &lt; 0) {
		s_free(ns);
		goto Return;
	}

	s_free(cache[type].s);
	cache[type].s = ns;
	cache[type].qid = d-&gt;qid;
	cache[type].t = time(0);

Return:
	free(d);
	s = s_incref(cache[type].s);
	wunlock(&amp;cache[type]);
	return s;
}

	
/*
 * Write wiki document in HTML.
 */
static String*
s_escappend(String *s, char *p, int pre)
{
	char *q;

	while(q = strpbrk(p, pre ? "&lt;&gt;&amp;" : " &lt;&gt;&amp;")){
		s = s_nappend(s, p, q-p);
		switch(*q){
		case '&lt;':
			s = s_append(s, "&amp;lt;");
			break;
		case '&gt;':
			s = s_append(s, "&amp;gt;");
			break;
		case '&amp;':
			s = s_append(s, "&amp;amp;");
			break;
		case ' ':
			s = s_append(s, "\n");
		}
		p = q+1;
	}
	s = s_append(s, p);
	return s;
}

static char*
mkurl(char *s, int ty)
{
	char *p, *q;

	if(strncmp(s, "http:", 5)==0
	|| strncmp(s, "https:", 6)==0
	|| strncmp(s, "#", 1)==0
	|| strncmp(s, "ftp:", 4)==0
	|| strncmp(s, "mailto:", 7)==0
	|| strncmp(s, "telnet:", 7)==0
	|| strncmp(s, "file:", 5)==0)
		return estrdup(s);

	if(strchr(s, ' ')==nil &amp;&amp; strchr(s, '@')!=nil){
		p = emalloc(strlen(s)+8);
		strcpy(p, "mailto:");
		strcat(p, s);
		return p;
	}

	if(ty == Toldpage)
		p = smprint("../../%s", s);
	else
		p = smprint("../%s", s);

	for(q=p; *q; q++)
		if(*q==' ')
			*q = '_';
	return p;
}

int okayinlist[Nwtxt] =
{
	[Wbullet]	1,
	[Wlink]	1,
	[Wman]	1,
	[Wplain]	1,
};

int okayinpre[Nwtxt] =
{
	[Wlink]	1,
	[Wman]	1,
	[Wpre]	1,
};

int okayinpara[Nwtxt] =
{
	[Wpara]	1,
	[Wlink]	1,
	[Wman]	1,
	[Wplain]	1,
};

char*
nospaces(char *s)
{
	char *q;
	s = strdup(s);
	if(s == nil)
		return nil;
	for(q=s; *q; q++)
		if(*q == ' ')
			*q = '_';
	return s;
}
	
String*
pagehtml(String *s, Wpage *wtxt, int ty)
{
	char *p, tmp[40];
	int inlist, inpara, inpre, t, tnext;
	Wpage *w;

	inlist = 0;
	inpre = 0;
	inpara = 0;

	for(w=wtxt; w; w=w-&gt;next){
		t = w-&gt;type;
		tnext = Whr;
		if(w-&gt;next)
			tnext = w-&gt;next-&gt;type;

		if(inlist &amp;&amp; !okayinlist[t]){
			inlist = 0;
			s = s_append(s, "\n&lt;/li&gt;\n&lt;/ul&gt;\n");
		}
		if(inpre &amp;&amp; !okayinpre[t]){
			inpre = 0;
			s = s_append(s, "&lt;/pre&gt;\n");
		}

		switch(t){
		case Wheading:
			p = nospaces(w-&gt;text);
			s = s_appendlist(s, 
				"\n&lt;a name=\"", p, "\" /&gt;&lt;h3&gt;", 
				w-&gt;text, "&lt;/h3&gt;\n", nil);
			free(p);
			break;

		case Wpara:
			if(inpara){
				s = s_append(s, "\n&lt;/p&gt;\n");
				inpara = 0;
			}
			if(okayinpara[tnext]){
				s = s_append(s, "\n&lt;p class='para'&gt;\n");
				inpara = 1;
			}
			break;

		case Wbullet:
			if(!inlist){
				inlist = 1;
				s = s_append(s, "\n&lt;ul&gt;\n");
			}else
				s = s_append(s, "\n&lt;/li&gt;\n");
			s = s_append(s, "\n&lt;li&gt;\n");
			break;

		case Wlink:
			if(w-&gt;url == nil)
				p = mkurl(w-&gt;text, ty);
			else
				p = w-&gt;url;
			s = s_appendlist(s, "&lt;a href=\"", p, "\"&gt;", nil);
			s = s_escappend(s, w-&gt;text, 0);
			s = s_append(s, "&lt;/a&gt;");
			if(w-&gt;url == nil)
				free(p);
			break;

		case Wman:
			sprint(tmp, "%d", w-&gt;section);
			s = s_appendlist(s, 
				"&lt;a href=\"http://plan9.bell-labs.com/magic/man2html/",
				tmp, "/", w-&gt;text, "\"&gt;&lt;i&gt;", w-&gt;text, "&lt;/i&gt;(",
				tmp, ")&lt;/a&gt;", nil);
			break;
			
		case Wpre:
			if(!inpre){
				inpre = 1;
				s = s_append(s, "\n&lt;pre&gt;\n");
			}
			s = s_escappend(s, w-&gt;text, 1);
			s = s_append(s, "\n");
			break;
		
		case Whr:
			s = s_append(s, "&lt;hr /&gt;");
			break;

		case Wplain:
			s = s_escappend(s, w-&gt;text, 0);
			break;
		}
	}
	if(inlist)
		s = s_append(s, "\n&lt;/li&gt;\n&lt;/ul&gt;\n");
	if(inpre)
		s = s_append(s, "&lt;/pre&gt;\n");
	if(inpara)
		s = s_append(s, "\n&lt;/p&gt;\n");
	return s;
}

static String*
copythru(String *s, char **newp, int *nlinep, int l)
{
	char *oq, *q, *r;
	int ol;

	q = *newp;
	oq = q;
	ol = *nlinep;
	while(ol &lt; l){
		if(r = strchr(q, '\n'))
			q = r+1;
		else{
			q += strlen(q);
			break;
		}
		ol++;
	}
	if(*nlinep &lt; l)
		*nlinep = l;
	*newp = q;
	return s_nappend(s, oq, q-oq);
}

static int
dodiff(char *f1, char *f2)
{
	int p[2];

	if(pipe(p) &lt; 0){
		return -1;
	}

	switch(fork()){
	case -1:
		return -1;

	case 0:
		close(p[0]);
		dup(p[1], 1);
		execl("/bin/diff", "diff", f1, f2, nil);
		_exits(nil);
	}
	close(p[1]);
	return p[0];
}


/* print document i grayed out, with only diffs relative to j in black */
static String*
s_diff(String *s, Whist *h, int i, int j)
{
	char *p, *q, *pnew;
	int fdiff, fd1, fd2, n1, n2;
	Biobuf b;
	char fn1[40], fn2[40];
	String *new, *old;
	int nline;

	if(j &lt; 0)
		return pagehtml(s, h-&gt;doc[i].wtxt, Tpage);

	strcpy(fn1, "/tmp/wiki.XXXXXX");
	strcpy(fn2, "/tmp/wiki.XXXXXX");
	if((fd1 = opentemp(fn1)) &lt; 0 || (fd2 = opentemp(fn2)) &lt; 0){
		close(fd1);
		s = s_append(s, "\nopentemp failed; sorry\n");
		return s;
	}

	new = pagehtml(s_reset(nil), h-&gt;doc[i].wtxt, Tpage);
	old = pagehtml(s_reset(nil), h-&gt;doc[j].wtxt, Tpage);
	write(fd1, s_to_c(new), s_len(new));
	write(fd2, s_to_c(old), s_len(old));

	fdiff = dodiff(fn2, fn1);
	if(fdiff &lt; 0)
		s = s_append(s, "\ndiff failed; sorry\n");
	else{
		nline = 0;
		pnew = s_to_c(new);
		Binit(&amp;b, fdiff, OREAD);
		while(p = Brdline(&amp;b, '\n')){
			if(p[0]=='&lt;' || p[0]=='&gt;' || p[0]=='-')
				continue;
			p[Blinelen(&amp;b)-1] = '\0';
			if((p = strpbrk(p, "acd")) == nil)
				continue;
			n1 = atoi(p+1);
			if(q = strchr(p, ','))
				n2 = atoi(q+1);
			else
				n2 = n1;
			switch(*p){
			case 'a':
			case 'c':
				s = s_append(s, "&lt;span class='old_text'&gt;");
				s = copythru(s, &amp;pnew, &amp;nline, n1-1);
				s = s_append(s, "&lt;/span&gt;&lt;span class='new_text'&gt;");
				s = copythru(s, &amp;pnew, &amp;nline, n2);
				s = s_append(s, "&lt;/span&gt;");
				break;
			}
		}
		close(fdiff);
		s = s_append(s, "&lt;span class='old_text'&gt;");
		s = s_append(s, pnew);
		s = s_append(s, "&lt;/span&gt;");

	}
	s_free(new);
	s_free(old);
	close(fd1);
	close(fd2);
	return s;
}

static String*
diffhtml(String *s, Whist *h)
{
	int i;
	char tmp[50];
	char *atime;

	for(i=h-&gt;ndoc-1; i&gt;=0; i--){
		s = s_append(s, "&lt;hr /&gt;&lt;div class='diff_head'&gt;\n");
		if(i==h-&gt;current)
			sprint(tmp, "index.html");
		else
			sprint(tmp, "%lud", h-&gt;doc[i].time);
		atime = ctime(h-&gt;doc[i].time);
		atime[strlen(atime)-1] = '\0';
		s = s_appendlist(s, 
			"&lt;a href=\"", tmp, "\"&gt;",
			atime, "&lt;/a&gt;", nil);
		if(h-&gt;doc[i].author)
			s = s_appendlist(s, ", ", h-&gt;doc[i].author, nil);
		if(h-&gt;doc[i].conflict)
			s = s_append(s, ", conflicting write");
		s = s_append(s, "\n");
		if(h-&gt;doc[i].comment)
			s = s_appendlist(s, "&lt;br /&gt;&lt;i&gt;", h-&gt;doc[i].comment, "&lt;/i&gt;\n", nil);
		s = s_append(s, "&lt;/div&gt;&lt;hr /&gt;");
		s = s_diff(s, h, i, i-1);
	}
	s = s_append(s, "&lt;hr&gt;");
	return s;
}

static String*
historyhtml(String *s, Whist *h)
{
	int i;
	char tmp[40];
	char *atime;

	s = s_append(s, "&lt;ul&gt;\n");
	for(i=h-&gt;ndoc-1; i&gt;=0; i--){
		if(i==h-&gt;current)
			sprint(tmp, "index.html");
		else
			sprint(tmp, "%lud", h-&gt;doc[i].time);
		atime = ctime(h-&gt;doc[i].time);
		atime[strlen(atime)-1] = '\0';
		s = s_appendlist(s, 
			"&lt;li&gt;&lt;a href=\"", tmp, "\"&gt;",
			atime, "&lt;/a&gt;", nil);
		if(h-&gt;doc[i].author)
			s = s_appendlist(s, ", ", h-&gt;doc[i].author, nil);
		if(h-&gt;doc[i].conflict)
			s = s_append(s, ", conflicting write");
		s = s_append(s, "\n");
		if(h-&gt;doc[i].comment)
			s = s_appendlist(s, "&lt;br&gt;&lt;i&gt;", h-&gt;doc[i].comment, "&lt;/i&gt;\n", nil);
	}
	s = s_append(s, "&lt;/ul&gt;");
	return s;		
}

String*
tohtml(Whist *h, Wdoc *d, int ty)
{
	char *atime;
	char *p, *q, ver[40];
	int nsub;
	Sub sub[3];
	String *s, *t;

	t = gettemplate(ty);
	if(p = strstr(s_to_c(t), "PAGE"))
		q = p+4;
	else{
		p = s_to_c(t)+s_len(t);
		q = nil;
	}

	nsub = 0;
	if(h){
		sub[nsub] = (Sub){ "TITLE", h-&gt;title };
		nsub++;
	}
	if(d){
		sprint(ver, "%lud", d-&gt;time);
		sub[nsub] = (Sub){ "VERSION", ver };
		nsub++;
		atime = ctime(d-&gt;time);
		atime[strlen(atime)-1] = '\0';
		sub[nsub] = (Sub){ "DATE", atime };
		nsub++;
	}

	s = s_reset(nil);
	s = s_appendsub(s, s_to_c(t), p-s_to_c(t), sub, nsub);
	switch(ty){
	case Tpage:
	case Toldpage:
		s = pagehtml(s, d-&gt;wtxt, ty);
		break;
	case Tedit:
		s = pagetext(s, d-&gt;wtxt, 0);
		break;
	case Tdiff:
		s = diffhtml(s, h);
		break;
	case Thistory:
		s = historyhtml(s, h);
		break;
	case Tnew:
	case Twerror:
		break;
	}
	if(q)
		s = s_appendsub(s, q, strlen(q), sub, nsub);
	s_free(t);
	return s;
}

enum {
	LINELEN = 70,
};

static String*
s_appendbrk(String *s, char *p, char *prefix, int dosharp)
{
	char *e, *w, *x;
	int first, l;
	Rune r;

	first = 1;
	while(*p){
		s = s_append(s, p);
		e = strrchr(s_to_c(s), '\n');
		if(e == nil)
			e = s_to_c(s);
		else
			e++;
		if(utflen(e) &lt;= LINELEN)
			break;
		x = e; l=LINELEN;
		while(l--)
			x+=chartorune(&amp;r, x);
		x = strchr(x, ' ');
		if(x){
			*x = '\0';
			w = strrchr(e, ' ');
			*x = ' ';
		}else
			w = strrchr(e, ' ');
	
		if(w-s_to_c(s) &lt; strlen(prefix))
			break;
		
		x = estrdup(w+1);
		*w = '\0';
		s-&gt;ptr = w;
		s_append(s, "\n");
		if(dosharp)
			s_append(s, "#");
		s_append(s, prefix);
		if(!first)
			free(p);
		first = 0;
		p = x;
	}
	if(!first)
		free(p);
	return s;
}

static void
s_endline(String *s, int dosharp)
{
	if(dosharp){
		if(s-&gt;ptr == s-&gt;base+1 &amp;&amp; s-&gt;ptr[-1] == '#')
			return;

		if(s-&gt;ptr &gt; s-&gt;base+1 &amp;&amp; s-&gt;ptr[-1] == '#' &amp;&amp; s-&gt;ptr[-2] == '\n')
			return;
		s_append(s, "\n#");
	}else{
		if(s-&gt;ptr &gt; s-&gt;base+1 &amp;&amp; s-&gt;ptr[-1] == '\n')
			return;
		s_append(s, "\n");
	}
}

String*
pagetext(String *s, Wpage *page, int dosharp)
{
	int inlist, inpara;
	char *prefix, *sharp, tmp[40];
	String *t;
	Wpage *w;

	inlist = 0;
	inpara = 0;
	prefix = "";
	sharp = dosharp ? "#" : "";
	s = s_append(s, sharp);
	for(w=page; w; w=w-&gt;next){
		switch(w-&gt;type){
		case Wheading:
			if(inlist){
				prefix = "";
				inlist = 0;
			}
			s_endline(s, dosharp);
			if(!inpara){
				inpara = 1;
				s = s_appendlist(s, "\n", sharp, nil);
			}
			s = s_appendlist(s, w-&gt;text, "\n", sharp, "\n", sharp, nil);
			break;

		case Wpara:
			s_endline(s, dosharp);
			if(inlist){
				prefix = "";
				inlist = 0;
			}
			if(!inpara){
				inpara = 1;
				s = s_appendlist(s, "\n", sharp, nil);
			}
			break;

		case Wbullet:
			s_endline(s, dosharp);
			if(!inlist)
				inlist = 1;
			if(inpara)
				inpara = 0;
			s = s_append(s, " *\t");
			prefix = "\t";
			break;

		case Wlink:
			if(inpara)
				inpara = 0;
			t = s_append(s_copy("["), w-&gt;text);
			if(w-&gt;url == nil)
				t = s_append(t, "]");
			else{
				t = s_append(t, " | ");
				t = s_append(t, w-&gt;url);
				t = s_append(t, "]");
			}
			s = s_appendbrk(s, s_to_c(t), prefix, dosharp);
			s_free(t);
			break;

		case Wman:
			if(inpara)
				inpara = 0;
			s = s_appendbrk(s, w-&gt;text, prefix, dosharp);
			sprint(tmp, "(%d)", w-&gt;section);
			s = s_appendbrk(s, tmp, prefix, dosharp);
			break;
			
		case Wpre:
			if(inlist){
				prefix = "";
				inlist = 0;
			}
			if(inpara)
				inpara = 0;
			s_endline(s, dosharp);
			s = s_appendlist(s, "! ", w-&gt;text, "\n", sharp, nil);
			break;
		case Whr:
			s_endline(s, dosharp);
			s = s_appendlist(s, "------------------------------------------------------ \n", sharp, nil);
			break;

		case Wplain:
			if(inpara)
				inpara = 0;
			s = s_appendbrk(s, w-&gt;text, prefix, dosharp);
			break;
		}
	}
	s_endline(s, dosharp);
	s-&gt;ptr--;
	*s-&gt;ptr = '\0';
	return s;
}

static String*
historytext(String *s, Whist *h)
{
	int i;
	char tmp[40];
	char *atime;

	for(i=h-&gt;ndoc-1; i&gt;=0; i--){
		if(i==h-&gt;current)
			sprint(tmp, "[current]");
		else
			sprint(tmp, "[%lud/]", h-&gt;doc[i].time);
		atime = ctime(h-&gt;doc[i].time);
		atime[strlen(atime)-1] = '\0';
		s = s_appendlist(s, " * ", tmp, " ", atime, nil);
		if(h-&gt;doc[i].author)
			s = s_appendlist(s, ", ", h-&gt;doc[i].author, nil);
		if(h-&gt;doc[i].conflict)
			s = s_append(s, ", conflicting write");
		s = s_append(s, "\n");
		if(h-&gt;doc[i].comment)
			s = s_appendlist(s, "&lt;i&gt;", h-&gt;doc[i].comment, "&lt;/i&gt;\n", nil);
	}
	return s;		
}

String*
totext(Whist *h, Wdoc *d, int ty)
{
	char *atime;
	char *p, *q, ver[40];
	int nsub;
	Sub sub[3];
	String *s, *t;

	t = gettemplate(Ntemplate+ty);
	if(p = strstr(s_to_c(t), "PAGE"))
		q = p+4;
	else{
		p = s_to_c(t)+s_len(t);
		q = nil;
	}

	nsub = 0;
	if(h){
		sub[nsub] = (Sub){ "TITLE", h-&gt;title };
		nsub++;
	}
	if(d){
		sprint(ver, "%lud", d-&gt;time);
		sub[nsub] = (Sub){ "VERSION", ver };
		nsub++;
		atime = ctime(d-&gt;time);
		atime[strlen(atime)-1] = '\0';
		sub[nsub] = (Sub){ "DATE", atime };
		nsub++;
	}
	
	s = s_reset(nil);
	s = s_appendsub(s, s_to_c(t), p-s_to_c(t), sub, nsub);
	switch(ty){
	case Tpage:
	case Toldpage:
		s = pagetext(s, d-&gt;wtxt, 0);
		break;
	case Thistory:
		s = historytext(s, h);
		break;
	case Tnew:
	case Twerror:
		break;
	}
	if(q)
		s = s_appendsub(s, q, strlen(q), sub, nsub);
	s_free(t);
	return s;
}

String*
doctext(String *s, Wdoc *d)
{
	char tmp[40];

	sprint(tmp, "D%lud", d-&gt;time);
	s = s_append(s, tmp);
	if(d-&gt;comment){
		s = s_append(s, "\nC");
		s = s_append(s, d-&gt;comment);
	}
	if(d-&gt;author){
		s = s_append(s, "\nA");
		s = s_append(s, d-&gt;author);
	}
	if(d-&gt;conflict)
		s = s_append(s, "\nX");
	s = s_append(s, "\n");
	s = pagetext(s, d-&gt;wtxt, 1);
	return s;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

