<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/blabs/blabs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/blabs/blabs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;draw.h&gt;

#define	NPJW		48
#define	NSPLIT		6
#define	NDOT		14
#define	MAXTRACKS	128
#define	MINV		6
#define	PDUP		1		/* useful for debugging */

#define	nels(a)		(sizeof(a) / sizeof(a[0]))
#define	imin(a,b)	(((a) &lt;= (b)) ? (a) : (b))
#define	imax(a,b)	(((a) &gt;= (b)) ? (a) : (b))
#define	sqr(x)		((x) * (x))

typedef struct vector	vector;
struct vector
{
	double	x;
	double	y;
};

typedef struct dot	Dot;
struct dot
{
	Point	pos;
	Point	ivel;
	vector	vel;
	double	mass;
	int	charge;
	int	height;	/* precalculated for speed */
	int	width;	/* precalculated for speed */
	int	facei;
	int	spin;
	Image	*face;
	Image	*faces[4];
	Image	*mask;
	Image	*masks[4];
	Image	*save;
	int	ntracks;
	Point	track[MAXTRACKS];
	int	next_clear;
	int	next_write;
};

Dot	dot[NDOT];
Dot	*edot		= &amp;dot[NDOT];
int	total_spin	= 3;
vector	no_gravity;
vector	gravity		=
{
	0.0,
	1.0,
};

/* static Image	*track; */
static Image	*im;
static int	track_length;
static int	track_width;
static int	iflag;
static double	k_floor		= 0.9;
Image *screen;

#include "andrew.bits"
#include "bart.bits"
#include "bwk.bits"
#include "dmr.bits"
#include "doug.bits"
#include "gerard.bits"
#include "howard.bits"
#include "ken.bits"
#include "philw.bits"
#include "pjw.bits"
#include "presotto.bits"
#include "rob.bits"
#include "sean.bits"
#include "td.bits"

Image*
eallocimage(Display *d, Rectangle r, ulong chan, int repl, int col)
{
	Image *i;
	i = allocimage(d, r, chan, repl, col);
	if(i == nil) {
		fprint(2, "cannot allocate image\n");
		exits("allocimage");
	}
	return i;
}

/*
 * p1 dot p2
 *	inner product
 */
static
double
dotprod(vector *p1, vector *p2)
{
	return p1-&gt;x * p2-&gt;x + p1-&gt;y * p2-&gt;y;
}

/*
 * r = p1 + p2
 */
static
void
vecaddpt(vector *r, vector *p1, vector *p2)
{
	r-&gt;x = p1-&gt;x + p2-&gt;x;
	r-&gt;y = p1-&gt;y + p2-&gt;y;
}

/*
 * r = p1 - p2
 */
static
void
vecsub(vector *r, vector *p1, vector *p2)
{
	r-&gt;x = p1-&gt;x - p2-&gt;x;
	r-&gt;y = p1-&gt;y - p2-&gt;y;
}

/*
 * r = v * s
 *	multiplication of a vector by a scalar
 */
static
void
scalmult(vector *r, vector *v, double s)
{
	r-&gt;x = v-&gt;x * s;
	r-&gt;y = v-&gt;y * s;
}

static
double
separation(Dot *p, Dot *q)
{
	return sqrt((double)(sqr(q-&gt;pos.x - p-&gt;pos.x) + sqr(q-&gt;pos.y - p-&gt;pos.y)));
}

static
int
close_enough(Dot *p, Dot *q, double *s)
{
	int	sepx;
	int	width;
	int	sepy;

	sepx = p-&gt;pos.x - q-&gt;pos.x;
	width = p-&gt;width;

	if (sepx &lt; -width || sepx &gt; width)
		return 0;

	sepy = p-&gt;pos.y - q-&gt;pos.y;

	if (sepy &lt; -width || sepy &gt; width)
		return 0;

	if ((*s = separation(p, q)) &gt; (double)width)
		return 0;

	return 1;
}

static
void
ptov(vector *v, Point *p)
{
	v-&gt;x = (double)p-&gt;x;
	v-&gt;y = (double)p-&gt;y;
}

static
void
vtop(Point *p, vector *v)
{
	p-&gt;x = (int)(v-&gt;x + 0.5);
	p-&gt;y = (int)(v-&gt;y + 0.5);
}

static
void
exchange_spin(Dot *p, Dot *q)
{
	int	tspin;

	if (p-&gt;spin == 0 &amp;&amp; q-&gt;spin == 0)
		return;

	tspin = p-&gt;spin + q-&gt;spin;

	p-&gt;spin = imax(nrand(imin(3, tspin + 1)), tspin + 1 - 3);

	if (p-&gt;spin == 0)
	{
		p-&gt;face = p-&gt;faces[0];
		p-&gt;mask = p-&gt;masks[0];
	}

	q-&gt;spin = tspin - p-&gt;spin;

	if (q-&gt;spin == 0)
	{
		q-&gt;face = q-&gt;faces[0];
		q-&gt;mask = q-&gt;masks[0];
	}
}

static
void
exchange_charge(Dot *p, Dot *q)
{
	if (p-&gt;charge == 0 &amp;&amp; q-&gt;charge == 0)
	{
		switch (nrand(16))
		{
		case 0:
			p-&gt;charge = 1;
			q-&gt;charge = -1;
			break;

		case 1:
			p-&gt;charge = -1;
			q-&gt;charge = 1;
			break;
		}
	}
}

/*
 * The aim is to completely determine the final
 * velocities of the two interacting particles as
 * a function of their initial velocities, masses
 * and point of collision.  We start with the two
 * quantities that we know are conserved in
 * elastic collisions -- momentum and kinetic energy.
 * 
 * Let the masses of the particles be m1 and m2;
 * their initial velocities V1 and V2 (vector quantities
 * represented by upper case variables, scalars lower
 * case); their final velocities V1' and V2'.
 * 
 * Conservation of momentum gives us:
 * 
 * 	(1)	m1 * V1 + m2 * V2	= m1 * V1' + m2 * V2'
 * 
 * and conservation of kinetic energy gives:
 * 
 * 	(2)	1/2 * m1 * |V1| * |V1| + 1/2 * m2 * |V2| * |V2|	=
 * 			1/2 * m1 * |V1'| * |V1'| + 1/2 * m2 * |V2'| * |V2'|
 * 
 * Then, decomposing (1) into its 2D scalar components:
 * 
 * 	(1a)	m1 * v1x + m2 * v2x	= m1 * v1x' + m2 * v2x'
 * 	(1b)	m1 * v1y + m2 * v2y	= m1 * v1y' + m2 * v2y'
 * 
 * and simplifying and expanding (2):
 * 
 * 	(2a)	m1 * (v1x * v1x + v1y * v1y) +
 * 		m2 * (v2x * v2x + v2y * v2y)
 * 					=
 * 		m1 * (v1x' * v1x' + v1y' * v1y') +
 * 		m2 * (v2x' * v2x' + v2y' * v2y')
 * 
 * We know m1, m2, V1 and V2 which leaves four unknowns:
 * 
 * 	v1x', v1y', v2x' and v2y'
 * 
 * but we have just three equations:
 * 
 * 	(1a), (1b) and (2a)
 * 
 * To remove this extra degree of freedom we add the assumption that
 * the forces during the collision act instantaneously and exactly
 * along the (displacement) vector joining the centres of the two objects.
 * 
 * And unfortunately, I've forgotten the extra equation that this
 * adds to the system(!), but it turns out that this extra constraint
 * does allow us to solve the augmented system of equations.
 * (I guess I could reverse engineer it from the code ...)
 */
static
void
rebound(Dot *p, Dot *q, double s)
{
	vector	pposn;
	vector	qposn;
	vector	pvel;
	vector	qvel;
	vector	newqp;	/* vector difference of the positions */
	vector	newqpu;	/* unit vector parallel to newqp */
	vector	newqv;	/*   "        "      "  "   velocities */
	double	projp;	/* projection of p's velocity in newqp direction */
	double	projq;	/*     "       " q's velocity in newqp direction */
	double	pmass;	/* mass of p */
	double	qmass;	/* mass of q */
	double	tmass;	/* sum of mass of p and q */
	double	dmass;	/* difference of mass of p and q */
	double	newp;
	double	newq;

	if (s == 0.0)
		return;

	ptov(&amp;pposn, &amp;p-&gt;pos);
	ptov(&amp;qposn, &amp;q-&gt;pos);
	pvel = p-&gt;vel;
	qvel = q-&gt;vel;

	/*
	 * Transform so that p is stationary at (0,0,0);
	 */
	vecsub(&amp;newqp, &amp;qposn, &amp;pposn);
	vecsub(&amp;newqv, &amp;qvel, &amp;pvel);

	scalmult(&amp;newqpu, &amp;newqp, -1.0 / s);

	if (dotprod(&amp;newqv, &amp;newqpu) &lt;= 0.0)
		return;

	projp = dotprod(&amp;pvel, &amp;newqpu);
	projq = dotprod(&amp;qvel, &amp;newqpu);
	pmass = p-&gt;mass;
	qmass = q-&gt;mass;
	tmass = pmass + qmass;
	dmass = pmass - qmass;
	newp = (2.0 * qmass * projq + dmass * projp) / tmass;
	newq = (2.0 * pmass * projp - dmass * projq) / tmass;
	scalmult(&amp;newqp, &amp;newqpu, projp - newp);
	scalmult(&amp;newqv, &amp;newqpu, projq - newq);
	vecsub(&amp;pvel, &amp;pvel, &amp;newqp);
	vecsub(&amp;qvel, &amp;qvel, &amp;newqv);

	p-&gt;vel = pvel;
	vtop(&amp;p-&gt;ivel, &amp;p-&gt;vel);
	q-&gt;vel = qvel;
	vtop(&amp;q-&gt;ivel, &amp;q-&gt;vel);

	exchange_spin(p, q);

	if (iflag)
		exchange_charge(p, q);
}

static
int
rrand(int lo, int hi)
{
	return lo + nrand(hi + 1 - lo);
}

static
void
drawdot(Dot *d)
{
	Rectangle r;
	char buf[10];

	r = d-&gt;face-&gt;r;
	r = rectsubpt(r, d-&gt;face-&gt;r.min);
	r = rectaddpt(r, d-&gt;pos);
	r = rectaddpt(r, screen-&gt;r.min);
	
	draw(screen, r, d-&gt;face, d-&gt;mask, d-&gt;face-&gt;r.min);

	if(PDUP &gt; 1) {	/* assume debugging */
		sprint(buf, "(%d,%d)", d-&gt;pos.x, d-&gt;pos.y);
		string(screen, r.min, display-&gt;black, ZP, font, buf);
	}
}

static
void
undraw(Dot *d)
{
	Rectangle r;
	r = d-&gt;face-&gt;r;
	r = rectsubpt(r, d-&gt;face-&gt;r.min);
	r = rectaddpt(r, d-&gt;pos);
	r = rectaddpt(r, screen-&gt;r.min);
	
	draw(screen, r, display-&gt;black, d-&gt;mask, d-&gt;face-&gt;r.min);

/*
	if (track_width &gt; 0)
	{
		if (d-&gt;ntracks &gt;= track_length)
		{
			bitblt(&amp;screen, d-&gt;track[d-&gt;next_clear], track, track-&gt;r, D ^ ~S);
			d-&gt;next_clear = (d-&gt;next_clear + 1) % track_length;
			d-&gt;ntracks--;
		}

		d-&gt;track[d-&gt;next_write] = Pt(d-&gt;pos.x + d-&gt;width / 2 - track_width / 2, d-&gt;pos.y + d-&gt;height / 2 - track_width / 2);
		bitblt(&amp;screen, d-&gt;track[d-&gt;next_write], track, track-&gt;r, D ^ ~S);
		d-&gt;next_write = (d-&gt;next_write + 1) % track_length;
		d-&gt;ntracks++;
	}
*/
}

static void
copy(Image *a, Image *b)
{
	if(PDUP==1 || eqrect(a-&gt;r, b-&gt;r))
		draw(a, a-&gt;r, b, nil, b-&gt;r.min);
	else {
		int x, y;
		for(x = a-&gt;r.min.x; x &lt; a-&gt;r.max.x; x++)
			for(y = a-&gt;r.min.y; y &lt; a-&gt;r.max.y; y++)
				draw(a, Rect(x,y,x+1,y+1), b, nil, Pt(x/PDUP,y/PDUP));
	}
}

static void
transpose(Image *b)
{
	int x, y;

	for(x = b-&gt;r.min.x; x &lt; b-&gt;r.max.x; x++)
		for(y = b-&gt;r.min.y; y &lt; b-&gt;r.max.y; y++)
			draw(im, Rect(y,x,y+1,x+1), b, nil, Pt(x,y));

	draw(b, b-&gt;r, im, nil, ZP);
}

static void
reflect1_lr(Image *b)
{
	int x;
	for(x = 0; x &lt; PDUP*NPJW; x++)
		draw(im, Rect(x, 0, x, PDUP*NPJW), b, nil, Pt(b-&gt;r.max.x-x,0));
	draw(b, b-&gt;r, im, nil, ZP);
}

static void
reflect1_ud(Image *b)
{
	int y;
	for(y = 0; y &lt; PDUP*NPJW; y++)
		draw(im, Rect(0, y, PDUP*NPJW, y), b, nil, Pt(0,b-&gt;r.max.y-y));
	draw(b, b-&gt;r, im, nil, ZP);
}

static
void
rotate_clockwise(Image *b)
{
	transpose(b);
	reflect1_lr(b);
}

static
void
spin(Dot *d)
{
	int	i;

	if (d-&gt;spin &gt; 0)
	{
		i = (d-&gt;facei + d-&gt;spin) % nels(d-&gt;faces);
		d-&gt;face = d-&gt;faces[i];
		d-&gt;mask = d-&gt;masks[i];
		d-&gt;facei = i;
	}
	sleep(0);
}

static
void
restart(Dot *d)
{
	static int	beam;

	d-&gt;charge = 0;

	d-&gt;pos.x = 0;
	d-&gt;vel.x = 20.0 + (double)rrand(-2, 2);

	if (beam ^= 1)
	{
		d-&gt;pos.y = screen-&gt;r.max.y - d-&gt;height;
		d-&gt;vel.y = -20.0 + (double)rrand(-2, 2);
	}
	else
	{
		d-&gt;pos.y = 0;
		d-&gt;vel.y = 20.0 + (double)rrand(-2, 2);
	}

	vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
}

static
void
upd(Dot *d)
{
	Dot	*dd;

	spin(d);

	/*
	 * Bounce off others?
	 */
	for (dd = d + 1; dd != edot; dd++)
	{
		double	s;

		if (close_enough(d, dd, &amp;s))
			rebound(d, dd, s);
	}

	if (iflag)
	{
		/*
		 * Going off-screen?
		 */
		if
		(
			d-&gt;pos.x + d-&gt;width &lt; 0
			||
			d-&gt;pos.x &gt;= Dx(screen-&gt;r)
			||
			d-&gt;pos.y + d-&gt;height &lt; 0
			||
			d-&gt;pos.y &gt;= Dy(screen-&gt;r)
		)
			restart(d);

		/*
		 * Charge.
		 */
		if (d-&gt;charge != 0)
		{
			/*
			 * TODO: This is wrong -- should
			 * generate closed paths.  Can't
			 * simulate effect of B field just
			 * by adding in an orthogonal
			 * velocity component... (sigh)
			 */
			vector	f;
			double	s;

			f.x = -d-&gt;vel.y;
			f.y = d-&gt;vel.x;

			if ((s = sqrt(sqr(f.x) + sqr(f.y))) != 0.0)
			{
				scalmult(&amp;f, &amp;f, -((double)d-&gt;charge) / s);

				vecaddpt(&amp;d-&gt;vel, &amp;f, &amp;d-&gt;vel);
				vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
			}
		}
	}
	else
	{
		/*
		 * Bounce off left or right border?
		 */
		if (d-&gt;pos.x &lt; 0)
		{
			d-&gt;vel.x = fabs(d-&gt;vel.x);
			vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
		}
		else if (d-&gt;pos.x + d-&gt;width &gt;= Dx(screen-&gt;r))
		{
			d-&gt;vel.x = -fabs(d-&gt;vel.x);
			vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
		}

		/*
		 * Bounce off top or bottom border?
		 * (bottom is slightly inelastic)
		 */
		if (d-&gt;pos.y &lt; 0)
		{
			d-&gt;vel.y = fabs(d-&gt;vel.y);
			vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
		}
		else if (d-&gt;pos.y + d-&gt;height &gt;= Dy(screen-&gt;r))
		{
			if (gravity.y == 0.0)
				d-&gt;vel.y = -fabs(d-&gt;vel.y);
			else if (d-&gt;ivel.y &gt;= -MINV &amp;&amp; d-&gt;ivel.y &lt;= MINV)
			{
				/*
				 * y-velocity is too small --
				 * give it a random kick.
				 */
				d-&gt;vel.y = (double)-rrand(30, 40);
				d-&gt;vel.x = (double)rrand(-10, 10);
			}
			else
				d-&gt;vel.y = -fabs(d-&gt;vel.y) * k_floor;
			vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
		}
	}

	if (gravity.x != 0.0 || gravity.y != 0.0)
	{
		vecaddpt(&amp;d-&gt;vel, &amp;gravity, &amp;d-&gt;vel);
		vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);
	}

	d-&gt;pos = addpt(d-&gt;pos, d-&gt;ivel);

	drawdot(d);
}

static
void
setup(Dot *d, char *who, uchar *face, int n_els)
{
	int	i, j, k, n;
	int	repl;
	uchar	mask;
	int 	nbits, bits;
	uchar	tmpface[NPJW*NPJW];
	uchar	tmpmask[NPJW*NPJW];
	static	Image	*im;	/* not the global */
	static	Image	*imask;

	if(im == nil)
	{
		im = eallocimage(display, Rect(0,0,NPJW,NPJW), CMAP8, 0, DNofill);
		imask = eallocimage(display, Rect(0,0,NPJW,NPJW), CMAP8, 0, DNofill);
	}

	repl = (NPJW*NPJW)/n_els;
	if(repl &gt; 8) {
		fprint(2, "can't happen --rsc\n");
		exits("repl");
	}
	nbits = 8/repl;
	mask = (1&lt;&lt;(nbits))-1;

	if(0) print("converting %s... n_els=%d repl=%d mask=%x nbits=%d...\n", 
		who, n_els, repl, mask, nbits);
	n = 0;
	for (i = 0; i &lt; n_els; i++)
	{
		for(j = repl; j--; ) {
			bits = (face[i] &gt;&gt; (j*nbits)) &amp; mask;
			tmpface[n] = 0;
			tmpmask[n] = 0;
			for(k = 0; k &lt; repl; k++)
			{
				tmpface[n] |= (mask-bits) &lt;&lt; (k*nbits);
				tmpmask[n] |= (bits==mask ? 0 : mask) &lt;&lt; (k*nbits);
			}
			n++;
		}

	}

	if(n != sizeof tmpface) {
		fprint(2, "can't happen2 --rsc\n");
		exits("n!=tmpface");
	}

	loadimage(im, im-&gt;r, tmpface, n);
	loadimage(imask, imask-&gt;r, tmpmask, n);

	for (i = 0; i &lt; nels(d-&gt;faces); i++)
	{
		d-&gt;faces[i] = eallocimage(display, Rect(0,0,PDUP*NPJW, PDUP*NPJW),
			screen-&gt;chan, 0, DNofill);
		d-&gt;masks[i] = eallocimage(display, Rect(0,0,PDUP*NPJW, PDUP*NPJW),
			GREY1, 0, DNofill);

		switch (i) {
		case 0:
			copy(d-&gt;faces[i], im);
			copy(d-&gt;masks[i], imask);
			break;

		case 1:
			copy(d-&gt;faces[i], im);
			copy(d-&gt;masks[i], imask);
			rotate_clockwise(d-&gt;faces[i]);
			rotate_clockwise(d-&gt;masks[i]);
			break;

		default:
			copy(d-&gt;faces[i], d-&gt;faces[i-2]);
			copy(d-&gt;masks[i], d-&gt;masks[i-2]);
			reflect1_lr(d-&gt;faces[i]);
			reflect1_ud(d-&gt;faces[i]);
			reflect1_lr(d-&gt;masks[i]);
			reflect1_ud(d-&gt;masks[i]);
			break;
		}
	}
	d-&gt;face = d-&gt;faces[0];
	d-&gt;mask = d-&gt;masks[0];

	d-&gt;height = Dy(im-&gt;r);
	d-&gt;width = Dx(im-&gt;r);

	d-&gt;mass = 1.0;

	d-&gt;spin = nrand(imin(3, total_spin + 1));
	total_spin -= d-&gt;spin;

	d-&gt;pos.x = nrand(screen-&gt;r.max.x - d-&gt;width);
	d-&gt;pos.y = nrand(screen-&gt;r.max.y - d-&gt;height);

	d-&gt;vel.x = (double)rrand(-20, 20);
	d-&gt;vel.y = (double)rrand(-20, 20);
	vtop(&amp;d-&gt;ivel, &amp;d-&gt;vel);

	drawdot(d);
}

int
msec(void)
{
	static int fd;
	int n;
	char buf[64];

	if(fd &lt;= 0)
		fd = open("/dev/msec", OREAD);
	if(fd &lt; 0)
		return 0;
	if(seek(fd, 0, 0) &lt; 0)
		return 0;
	if((n=read(fd, buf, sizeof(buf)-1)) &lt; 0)
		return 0;
	buf[n] = 0;
	return atoi(buf);
}

/*
 * debugging: make del pause so that we can
 * inspect window.
 */
jmp_buf j;
static void
myhandler(void *v, char *s)
{
	if(strcmp(s, "interrupt") == 0)
		notejmp(v, j, -1);
	noted(NDFLT);
}

void
main(int argc, char *argv[])
{
	int c;
	long now, then;

	ARGBEGIN
	{
	case 'i':
		iflag = 1;
		gravity = no_gravity;
		track_length = 64;
		track_width = 2;
		break;

	case 'k':
		k_floor = atof(ARGF());
		break;

	case 'n':
		track_length = atoi(ARGF());
		break;

	case 'w':
		track_width = atoi(ARGF());
		break;

	case 'x':
		gravity.x = atof(ARGF());
		break;

	case 'y':
		gravity.y = atof(ARGF());
		break;

	default:
		fprint(2, "Usage: %s [-i] [-k k_floor] [-n track_length] [-w track_width] [-x gravityx] [-y gravityy]\n", argv0);
		exits("usage");
	} ARGEND

	if (track_length &gt; MAXTRACKS)
		track_length = MAXTRACKS;

	if (track_length == 0)
		track_width = 0;

	srand(time(0));

	initdraw(0,0,0);
	im = eallocimage(display, Rect(0, 0, PDUP*NPJW, PDUP*NPJW), CMAP8, 0, DNofill);

	draw(screen, screen-&gt;r, display-&gt;black, nil, ZP);
	
/*	track = balloc(Rect(0, 0, track_width, track_width), 0); */

	edot = &amp;dot[0];

	setup(edot++, "andrew", andrewbits, nels(andrewbits));
	setup(edot++, "bart", bartbits, nels(bartbits));
	setup(edot++, "bwk", bwkbits, nels(bwkbits));
	setup(edot++, "dmr", dmrbits, nels(dmrbits));
	setup(edot++, "doug", dougbits, nels(dougbits));
	setup(edot++, "gerard", gerardbits, nels(gerardbits));
	setup(edot++, "howard", howardbits, nels(howardbits));
	setup(edot++, "ken", kenbits, nels(kenbits));
	setup(edot++, "philw", philwbits, nels(philwbits));
	setup(edot++, "pjw", pjwbits, nels(pjwbits));
	setup(edot++, "presotto", presottobits, nels(presottobits));
	setup(edot++, "rob", robbits, nels(robbits));
	setup(edot++, "sean", seanbits, nels(seanbits));
	setup(edot++, "td", tdbits, nels(tdbits));

	if(PDUP &gt; 1) {	/* assume debugging */
		setjmp(j);
		read(0, &amp;c, 1);

		/* make DEL pause so that we can inspect window */
		notify(myhandler);
	}
	SET(c);
	USED(c);

#define DELAY 100
	for (then = msec();; then = msec())
	{
		Dot	*d;

		for (d = dot; d != edot; d++)
			undraw(d);
		for (d = dot; d != edot; d++)
			upd(d);
		draw(screen, screen-&gt;r, screen, nil, screen-&gt;r.min);
		flushimage(display, 1);
		now = msec();
		if(now - then &lt; DELAY)
			sleep(DELAY - (now - then));
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

