<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/juggle.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/juggle.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

enum
{
	NSTEP		= 10,		/* number of steps between throws */
	RBALL		= 10,		/* radius of ball images */
	Nball		= 100,
};

Image *image, **disk;
int ndisk=0;
int nhand=2;
int delay=20;			/* ms delay between steps */
int nball;
int maxhgt;
Rectangle win;


#define add addpt
#define sub subpt
#define inset insetrect


/*
 * pattern lists the heights of a repeating sequence of throws.
 * At time t, hand t%nhand throws.  At that time, it must
 * hold exactly one ball, unless it executes a 0 throw,
 * in which case it must hold no ball.  A throw of height h
 * at time t lands at time t+h in hand (t+h)%nhand.
 */
typedef struct Ball Ball;
struct Ball{
	int oldhand;	/* hand that previously held the ball */
	int hgt;	/* how high the throw from oldhand was */
	int time;	/* time at which ball will arrive */
	int hand;	/* hand in which ball will rest on arrival */
};
Ball ball[Nball];
void throw(int t, int hgt){
	int hand=t%nhand;
	int i, b, n;
	b=n=0;
	for(i=0;i!=nball;i++) if(ball[i].hand==hand &amp;&amp; ball[i].time&lt;=t){
		n++;
		b=i;
	}
	if(hgt==0){
		if(n!=0){
			print("bad zero throw at t=%d, nball=%d\n", t, n);
			exits("bad");
		}
	}
	else if(n!=1){
		print("bad ball count at t=%d, nball=%d\n", t, n);
		exits("bad");
	}
	else{
		ball[b].oldhand=hand;
		ball[b].hgt=hgt;
		ball[b].time=t+hgt;
		ball[b].hand=(hand+hgt)%nhand;
	}
}
Point bpos(int b, int step, int t){
	Ball *bp=&amp;ball[b];
	double dt=t-1+(step+1.)/NSTEP-(bp-&gt;time-bp-&gt;hgt);
	double hgt=(bp-&gt;hgt*dt-dt*dt)*4./(maxhgt*maxhgt);
	double alpha=(bp-&gt;oldhand+(bp-&gt;hand-bp-&gt;oldhand)*dt/bp-&gt;hgt)/(nhand-1);
	return (Point){win.min.x+(win.max.x-win.min.x)*alpha,
		       win.max.y-1+(win.min.y-win.max.y)*hgt};
}

void move(int t){
	int i, j;
	for(i=0;i!=NSTEP;i++){
		if(ecanmouse()) emouse();
		draw(image, inset(image-&gt;r, 3), display-&gt;white, nil, ZP);
		for(j=0;j!=nball;j++)
			fillellipse(image, bpos(j, i, t), RBALL, RBALL, disk[j%ndisk], ZP);
		draw(screen, screen-&gt;r, image, nil, image-&gt;r.min);
		flushimage(display, 1);
		if(delay&gt;0)
			sleep(delay);
	}
}

void
adddisk(int c)
{
	Image *col;
	disk = realloc(disk, (ndisk+1)*sizeof(Image*));
	col=allocimage(display, Rect(0,0,1,1), CMAP8, 1, c);
	disk[ndisk]=col;
	ndisk++;
}

void
diskinit(void)
{
	/* colors taken from /sys/src/cmd/stats.c */

	adddisk(0xFFAAAAFF);
	adddisk(DPalegreygreen);
	adddisk(DDarkyellow);
	adddisk(DMedgreen);
	adddisk(0x00AAFFFF);
	adddisk(0xCCCCCCFF);

	adddisk(0xBB5D5DFF);
	adddisk(DPurpleblue);
	adddisk(DYellowgreen);
	adddisk(DDarkgreen);
	adddisk(0x0088CCFF);
	adddisk(0x888888FF);
}

void
usage(char *name)
{
	fprint(2, "usage: %s [start] pattern\n", name);
	exits("usage");
}

void 
eresized(int new){
	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0) {
		sysfatal("can't reattach to window");
	}
	if(image) freeimage(image);
	image=allocimage(display, screen-&gt;r, screen-&gt;chan, 0, DNofill);
	draw(image, image-&gt;r, display-&gt;black, nil, ZP);
	win=inset(screen-&gt;r, 4+2*RBALL);
}
void
main(int argc, char *argv[]){
	int sum, i, t, hgt, nstart, npattern;
	char *s, *start = nil, *pattern = nil;

	ARGBEGIN{
	default:
		usage(argv0);
	case 'd':
		s = ARGF();
		if(s == nil)
			usage(argv0);
		delay = strtol(argv[0], &amp;s, 0);
		if(delay &lt; 0 || s == argv[0] || *s != '\0')
			usage(argv0);
		break;
	case 'h':
		s = ARGF();
		if(s == nil)
			usage(argv0);
		nhand = strtol(argv[0], &amp;s, 0);
		if(nhand &lt;= 0 || s == argv[0] || *s != '\0')
			usage(argv0);
		break;
	}ARGEND
	
	switch(argc) {
	case 1: 
			start=""; 
			pattern=argv[0]; 
			break;
	case 2: 
			start=argv[0]; 
			pattern=argv[1]; 
			break;
	default: 
			usage(argv0);
	}
	sum=0;
	maxhgt=0;
	for(s=pattern;*s;s++){
		hgt=*s-'0';
		sum+=hgt;
		if(maxhgt&lt;hgt) maxhgt=hgt;
	}
	npattern=s-pattern;
	for(s=start;*s;s++){
		hgt=*s-'0';
		if(maxhgt&lt;hgt) maxhgt=hgt;
	}
	if(sum%npattern){
		print("%s: non-integral ball count\n",argv[0]);
		exits("partial ball");
	}
	nball=sum/npattern;
	for(i=0;i!=nball;i++){
		ball[i].oldhand=(i-nball)%nhand;
		if(ball[i].oldhand&lt;0) ball[i].oldhand+=nhand;
		ball[i].hgt=nball;
		ball[i].time=i;
		ball[i].hand=i%nhand;
	}
	if(initdraw(nil, nil, "juggle") &lt; 0)
		sysfatal("initdraw failed: %r");
	einit(Emouse);
	diskinit();
	eresized(0);
	if(image==0){
		print("can't allocate bitmap");
		exits("no space");
	}
	for(t=0;start[t];t++){
		move(t);
		throw(t, start[t]-'0');
	}
	nstart=t;
	for(;;t++){
		move(t);
		throw(t, pattern[(t-nstart)%npattern]-'0');
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

