<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3dec/frame.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3dec/frame.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * libmad - MPEG audio decoder library
 * Copyright (C) 2000-2004 Underbit Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: frame.c,v 1.29 2004/02/04 22:59:19 rob Exp $
 */

# ifdef HAVE_CONFIG_H
#  include "config.h"
# endif

# include "global.h"

# include "bit.h"
# include "stream.h"
# include "frame.h"
# include "layer12.h"
# include "layer3.h"

static
unsigned long const bitrate_table[5][15] = {
  /* MPEG-1 */
  { 0,  32000,  64000,  96000, 128000, 160000, 192000, 224000,  /* Layer I   */
       256000, 288000, 320000, 352000, 384000, 416000, 448000 },
  { 0,  32000,  48000,  56000,  64000,  80000,  96000, 112000,  /* Layer II  */
       128000, 160000, 192000, 224000, 256000, 320000, 384000 },
  { 0,  32000,  40000,  48000,  56000,  64000,  80000,  96000,  /* Layer III */
       112000, 128000, 160000, 192000, 224000, 256000, 320000 },

  /* MPEG-2 LSF */
  { 0,  32000,  48000,  56000,  64000,  80000,  96000, 112000,  /* Layer I   */
       128000, 144000, 160000, 176000, 192000, 224000, 256000 },
  { 0,   8000,  16000,  24000,  32000,  40000,  48000,  56000,  /* Layers    */
        64000,  80000,  96000, 112000, 128000, 144000, 160000 } /* II &amp; III  */
};

static
unsigned int const samplerate_table[3] = { 44100, 48000, 32000 };

static
int (*const decoder_table[3])(struct mad_stream *, struct mad_frame *) = {
  mad_layer_I,
  mad_layer_II,
  mad_layer_III
};

/*
 * NAME:	header-&gt;init()
 * DESCRIPTION:	initialize header struct
 */
void mad_header_init(struct mad_header *header)
{
  header-&gt;layer          = 0;
  header-&gt;mode           = 0;
  header-&gt;mode_extension = 0;
  header-&gt;emphasis       = 0;

  header-&gt;bitrate        = 0;
  header-&gt;samplerate     = 0;

  header-&gt;crc_check      = 0;
  header-&gt;crc_target     = 0;

  header-&gt;flags          = 0;
  header-&gt;private_bits   = 0;
}

/*
 * NAME:	frame-&gt;init()
 * DESCRIPTION:	initialize frame struct
 */
void mad_frame_init(struct mad_frame *frame)
{
  mad_header_init(&amp;frame-&gt;header);

  frame-&gt;options = 0;

  frame-&gt;overlap = 0;
  mad_frame_mute(frame);
}

/*
 * NAME:	frame-&gt;finish()
 * DESCRIPTION:	deallocate any dynamic memory associated with frame
 */
void mad_frame_finish(struct mad_frame *frame)
{
  mad_header_finish(&amp;frame-&gt;header);

  if (frame-&gt;overlap) {
    free(frame-&gt;overlap);
    frame-&gt;overlap = 0;
  }
}

/*
 * NAME:	decode_header()
 * DESCRIPTION:	read header data and following CRC word
 */
static
int decode_header(struct mad_header *header, struct mad_stream *stream)
{
  unsigned int index;

  header-&gt;flags        = 0;
  header-&gt;private_bits = 0;

  /* header() */

  /* syncword */
  mad_bit_skip(&amp;stream-&gt;ptr, 11);

  /* MPEG 2.5 indicator (really part of syncword) */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1) == 0)
    header-&gt;flags |= MAD_FLAG_MPEG_2_5_EXT;

  /* ID */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1) == 0)
    header-&gt;flags |= MAD_FLAG_LSF_EXT;
  else if (header-&gt;flags &amp; MAD_FLAG_MPEG_2_5_EXT) {
    stream-&gt;error = MAD_ERROR_LOSTSYNC;
    return -1;
  }

  /* layer */
  header-&gt;layer = 4 - mad_bit_read(&amp;stream-&gt;ptr, 2);

  if (header-&gt;layer == 4) {
    stream-&gt;error = MAD_ERROR_BADLAYER;
    return -1;
  }

  /* protection_bit */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1) == 0) {
    header-&gt;flags    |= MAD_FLAG_PROTECTION;
    header-&gt;crc_check = mad_bit_crc(stream-&gt;ptr, 16, 0xffff);
  }

  /* bitrate_index */
  index = mad_bit_read(&amp;stream-&gt;ptr, 4);

  if (index == 15) {
    stream-&gt;error = MAD_ERROR_BADBITRATE;
    return -1;
  }

  if (header-&gt;flags &amp; MAD_FLAG_LSF_EXT)
    header-&gt;bitrate = bitrate_table[3 + (header-&gt;layer &gt;&gt; 1)][index];
  else
    header-&gt;bitrate = bitrate_table[header-&gt;layer - 1][index];

  /* sampling_frequency */
  index = mad_bit_read(&amp;stream-&gt;ptr, 2);

  if (index == 3) {
    stream-&gt;error = MAD_ERROR_BADSAMPLERATE;
    return -1;
  }

  header-&gt;samplerate = samplerate_table[index];

  if (header-&gt;flags &amp; MAD_FLAG_LSF_EXT) {
    header-&gt;samplerate /= 2;

    if (header-&gt;flags &amp; MAD_FLAG_MPEG_2_5_EXT)
      header-&gt;samplerate /= 2;
  }

  /* padding_bit */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1))
    header-&gt;flags |= MAD_FLAG_PADDING;

  /* private_bit */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1))
    header-&gt;private_bits |= MAD_PRIVATE_HEADER;

  /* mode */
  header-&gt;mode = 3 - mad_bit_read(&amp;stream-&gt;ptr, 2);

  /* mode_extension */
  header-&gt;mode_extension = mad_bit_read(&amp;stream-&gt;ptr, 2);

  /* copyright */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1))
    header-&gt;flags |= MAD_FLAG_COPYRIGHT;

  /* original/copy */
  if (mad_bit_read(&amp;stream-&gt;ptr, 1))
    header-&gt;flags |= MAD_FLAG_ORIGINAL;

  /* emphasis */
  header-&gt;emphasis = mad_bit_read(&amp;stream-&gt;ptr, 2);

# if defined(OPT_STRICT)
  /*
   * ISO/IEC 11172-3 says this is a reserved emphasis value, but
   * streams exist which use it anyway. Since the value is not important
   * to the decoder proper, we allow it unless OPT_STRICT is defined.
   */
  if (header-&gt;emphasis == MAD_EMPHASIS_RESERVED) {
    stream-&gt;error = MAD_ERROR_BADEMPHASIS;
    return -1;
  }
# endif

  /* error_check() */

  /* crc_check */
  if (header-&gt;flags &amp; MAD_FLAG_PROTECTION)
    header-&gt;crc_target = mad_bit_read(&amp;stream-&gt;ptr, 16);

  return 0;
}

/*
 * NAME:	free_bitrate()
 * DESCRIPTION:	attempt to discover the bitstream's free bitrate
 */
static
int free_bitrate(struct mad_stream *stream, struct mad_header const *header)
{
  struct mad_bitptr keep_ptr;
  unsigned long rate = 0;
  unsigned int pad_slot, slots_per_frame;
  unsigned char const *ptr = 0;

  keep_ptr = stream-&gt;ptr;

  pad_slot = (header-&gt;flags &amp; MAD_FLAG_PADDING) ? 1 : 0;
  slots_per_frame = (header-&gt;layer == MAD_LAYER_III &amp;&amp;
		     (header-&gt;flags &amp; MAD_FLAG_LSF_EXT)) ? 72 : 144;

  while (mad_stream_sync(stream) == 0) {
    struct mad_stream peek_stream;
    struct mad_header peek_header;

    peek_stream = *stream;
    peek_header = *header;

    if (decode_header(&amp;peek_header, &amp;peek_stream) == 0 &amp;&amp;
	peek_header.layer == header-&gt;layer &amp;&amp;
	peek_header.samplerate == header-&gt;samplerate) {
      unsigned int N;

      ptr = mad_bit_nextbyte(&amp;stream-&gt;ptr);

      N = ptr - stream-&gt;this_frame;

      if (header-&gt;layer == MAD_LAYER_I) {
	rate = (unsigned long) header-&gt;samplerate *
	  (N - 4 * pad_slot + 4) / 48 / 1000;
      }
      else {
	rate = (unsigned long) header-&gt;samplerate *
	  (N - pad_slot + 1) / slots_per_frame / 1000;
      }

      if (rate &gt;= 8)
	break;
    }

    mad_bit_skip(&amp;stream-&gt;ptr, 8);
  }

  stream-&gt;ptr = keep_ptr;

  if (rate &lt; 8 || (header-&gt;layer == MAD_LAYER_III &amp;&amp; rate &gt; 640)) {
    stream-&gt;error = MAD_ERROR_LOSTSYNC;
    return -1;
  }

  stream-&gt;freerate = rate * 1000;

  return 0;
}

/*
 * NAME:	header-&gt;decode()
 * DESCRIPTION:	read the next frame header from the stream
 */
int mad_header_decode(struct mad_header *header, struct mad_stream *stream)
{
  register unsigned char const *ptr, *end;
  unsigned int pad_slot, N;

  ptr = stream-&gt;next_frame;
  end = stream-&gt;bufend;

  if (ptr == 0) {
    stream-&gt;error = MAD_ERROR_BUFPTR;
    goto fail;
  }

  /* stream skip */
  if (stream-&gt;skiplen) {
    if (!stream-&gt;sync)
      ptr = stream-&gt;this_frame;

    if (end - ptr &lt; stream-&gt;skiplen) {
      stream-&gt;skiplen   -= end - ptr;
      stream-&gt;next_frame = end;

      stream-&gt;error = MAD_ERROR_BUFLEN;
      goto fail;
    }

    ptr += stream-&gt;skiplen;
    stream-&gt;skiplen = 0;

    stream-&gt;sync = 1;
  }

 sync:
  /* synchronize */
  if (stream-&gt;sync) {
    if (end - ptr &lt; MAD_BUFFER_GUARD) {
      stream-&gt;next_frame = ptr;

      stream-&gt;error = MAD_ERROR_BUFLEN;
      goto fail;
    }
    else if (!(ptr[0] == 0xff &amp;&amp; (ptr[1] &amp; 0xe0) == 0xe0)) {
      /* mark point where frame sync word was expected */
      stream-&gt;this_frame = ptr;
      stream-&gt;next_frame = ptr + 1;

      stream-&gt;error = MAD_ERROR_LOSTSYNC;
      goto fail;
    }
  }
  else {
    mad_bit_init(&amp;stream-&gt;ptr, ptr);

    if (mad_stream_sync(stream) == -1) {
      if (end - stream-&gt;next_frame &gt;= MAD_BUFFER_GUARD)
	stream-&gt;next_frame = end - MAD_BUFFER_GUARD;

      stream-&gt;error = MAD_ERROR_BUFLEN;
      goto fail;
    }

    ptr = mad_bit_nextbyte(&amp;stream-&gt;ptr);
  }

  /* begin processing */
  stream-&gt;this_frame = ptr;
  stream-&gt;next_frame = ptr + 1;  /* possibly bogus sync word */

  mad_bit_init(&amp;stream-&gt;ptr, stream-&gt;this_frame);

  if (decode_header(header, stream) == -1)
    goto fail;

  /* calculate free bit rate */
  if (header-&gt;bitrate == 0) {
    if ((stream-&gt;freerate == 0 || !stream-&gt;sync ||
	 (header-&gt;layer == MAD_LAYER_III &amp;&amp; stream-&gt;freerate &gt; 640000)) &amp;&amp;
	free_bitrate(stream, header) == -1)
      goto fail;

    header-&gt;bitrate = stream-&gt;freerate;
    header-&gt;flags  |= MAD_FLAG_FREEFORMAT;
  }

  /* calculate beginning of next frame */
  pad_slot = (header-&gt;flags &amp; MAD_FLAG_PADDING) ? 1 : 0;

  if (header-&gt;layer == MAD_LAYER_I)
    N = ((12 * header-&gt;bitrate / header-&gt;samplerate) + pad_slot) * 4;
  else {
    unsigned int slots_per_frame;

    slots_per_frame = (header-&gt;layer == MAD_LAYER_III &amp;&amp;
		       (header-&gt;flags &amp; MAD_FLAG_LSF_EXT)) ? 72 : 144;

    N = (slots_per_frame * header-&gt;bitrate / header-&gt;samplerate) + pad_slot;
  }

  /* verify there is enough data left in buffer to decode this frame */
  if (N + MAD_BUFFER_GUARD &gt; end - stream-&gt;this_frame) {
    stream-&gt;next_frame = stream-&gt;this_frame;

    stream-&gt;error = MAD_ERROR_BUFLEN;
    goto fail;
  }

  stream-&gt;next_frame = stream-&gt;this_frame + N;

  if (!stream-&gt;sync) {
    /* check that a valid frame header follows this frame */

    ptr = stream-&gt;next_frame;
    if (!(ptr[0] == 0xff &amp;&amp; (ptr[1] &amp; 0xe0) == 0xe0)) {
      ptr = stream-&gt;next_frame = stream-&gt;this_frame + 1;
      goto sync;
    }

    stream-&gt;sync = 1;
  }

  header-&gt;flags |= MAD_FLAG_INCOMPLETE;

  return 0;

 fail:
  stream-&gt;sync = 0;

  return -1;
}

/*
 * NAME:	frame-&gt;decode()
 * DESCRIPTION:	decode a single frame from a bitstream
 */
int mad_frame_decode(struct mad_frame *frame, struct mad_stream *stream)
{
  frame-&gt;options = stream-&gt;options;

  /* header() */
  /* error_check() */

  if (!(frame-&gt;header.flags &amp; MAD_FLAG_INCOMPLETE) &amp;&amp;
      mad_header_decode(&amp;frame-&gt;header, stream) == -1)
    goto fail;

  /* audio_data() */

  frame-&gt;header.flags &amp;= ~MAD_FLAG_INCOMPLETE;

  if (decoder_table[frame-&gt;header.layer - 1](stream, frame) == -1) {
    if (!MAD_RECOVERABLE(stream-&gt;error))
      stream-&gt;next_frame = stream-&gt;this_frame;

    goto fail;
  }

  /* ancillary_data() */

  if (frame-&gt;header.layer != MAD_LAYER_III) {
    struct mad_bitptr next_frame;

    mad_bit_init(&amp;next_frame, stream-&gt;next_frame);

    stream-&gt;anc_ptr    = stream-&gt;ptr;
    stream-&gt;anc_bitlen = mad_bit_length(&amp;stream-&gt;ptr, &amp;next_frame);

    mad_bit_finish(&amp;next_frame);
  }

  return 0;

 fail:
  stream-&gt;anc_bitlen = 0;
  return -1;
}

/*
 * NAME:	frame-&gt;mute()
 * DESCRIPTION:	zero all subband values so the frame becomes silent
 */
void mad_frame_mute(struct mad_frame *frame)
{
  unsigned int s, sb;

  for (s = 0; s &lt; 36; ++s) {
    for (sb = 0; sb &lt; 32; ++sb) {
      frame-&gt;sbsample[0][s][sb] =
      frame-&gt;sbsample[1][s][sb] = 0;
    }
  }

  if (frame-&gt;overlap) {
    for (s = 0; s &lt; 18; ++s) {
      for (sb = 0; sb &lt; 32; ++sb) {
	(*frame-&gt;overlap)[0][sb][s] =
	(*frame-&gt;overlap)[1][sb][s] = 0;
      }
    }
  }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

