<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3enc/VbrTag.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3enc/VbrTag.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *	Xing VBR tagging for LAME.
 *
 *	Copyright (c) 1999 A.L. Faber
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* $Id: VbrTag.c,v 1.20 2001/02/27 09:59:16 robert Exp $ */

#ifdef HAVE_CONFIG_H
# include &lt;config.h&gt;
#endif

#include "machine.h"
#if defined(__riscos__) &amp;&amp; defined(FPA10)
#include	"ymath.h"
#else
#include	&lt;math.h&gt;
#endif
#include "VbrTag.h"
#include "version.h"
#include "bitstream.h"
#include "VbrTag.h"
#include	&lt;assert.h&gt;

#ifdef WITH_DMALLOC
#include &lt;dmalloc.h&gt;
#endif


#ifdef _DEBUG
/*  #define DEBUG_VBRTAG */
#endif

/*
//    4 bytes for Header Tag
//    4 bytes for Header Flags
//  100 bytes for entry (NUMTOCENTRIES)
//    4 bytes for FRAME SIZE
//    4 bytes for STREAM_SIZE
//    4 bytes for VBR SCALE. a VBR quality indicator: 0=best 100=worst
//   20 bytes for LAME tag.  for example, "LAME3.12 (beta 6)"
// ___________
//  140 bytes
*/
#define VBRHEADERSIZE (NUMTOCENTRIES+4+4+4+4+4)

/* the size of the Xing header (MPEG1 and MPEG2) in kbps */
#define XING_BITRATE1 128
#define XING_BITRATE2  64
#define XING_BITRATE25 32



const static char	VBRTag[]={"Xing"};
const int SizeOfEmptyFrame[2][2]=
{
	{17,9},
	{32,17},
};


/***********************************************************************
 *  Robert Hegemann 2001-01-17
 ***********************************************************************/

void addVbr(VBR_seek_info_t * v, int bitrate)
{
    int i;

    v-&gt;sum += bitrate;
    v-&gt;seen ++;
    
    if (v-&gt;seen &lt; v-&gt;want) {
        return;
    }

    if (v-&gt;pos &lt; v-&gt;size) {
        v-&gt;bag[v-&gt;pos] = v-&gt;sum;
        v-&gt;pos ++;
        v-&gt;seen = 0;
    }
    if (v-&gt;pos == v-&gt;size) {
        for (i = 1; i &lt; v-&gt;size; i += 2) {
            v-&gt;bag[i/2] = v-&gt;bag[i]; 
        }
        v-&gt;want *= 2;
        v-&gt;pos  /= 2;
    }
}

void Xing_seek_table(VBR_seek_info_t * v, unsigned char *t)
{
    int i, index;
    int seek_point;
    
    if (v-&gt;pos &lt;= 0)
        return;
        
    for (i = 1; i &lt; NUMTOCENTRIES; ++i) {
        float j = i/(float)NUMTOCENTRIES, act, sum;
        index = (int)(floor(j * v-&gt;pos));
        if (index &gt; v-&gt;pos-1)
            index = v-&gt;pos-1;
        act = v-&gt;bag[index];
        sum = v-&gt;sum;
        seek_point = (int)(256. * act / sum);
        if (seek_point &gt; 255)
            seek_point = 255;
        t[i] = seek_point;
    }
}

#if 0
void print_seeking(unsigned char *t)
{
    int i;
    
    printf("seeking table ");
    for (i = 0; i &lt; NUMTOCENTRIES; ++i) {
        printf(" %d ", t[i]);
    }
    printf("\n");
}
#endif



/****************************************************************************
 * AddVbrFrame: Add VBR entry, used to fill the VBR the TOC entries
 * Paramters:
 *	nStreamPos: how many bytes did we write to the bitstream so far
 *				(in Bytes NOT Bits)
 ****************************************************************************
*/
void AddVbrFrame(lame_global_flags *gfp)
{
    lame_internal_flags *gfc = gfp-&gt;internal_flags;

    int kbps = bitrate_table[gfp-&gt;version][gfc-&gt;bitrate_index];
    
    if (gfc-&gt;VBR_seek_table.bag == NULL) {
        gfc-&gt;VBR_seek_table.sum  = 0;
        gfc-&gt;VBR_seek_table.seen = 0;
        gfc-&gt;VBR_seek_table.want = 1;
        gfc-&gt;VBR_seek_table.pos  = 0;
        gfc-&gt;VBR_seek_table.bag  = malloc (400*sizeof(int));
        if (gfc-&gt;VBR_seek_table.bag != NULL) {
            gfc-&gt;VBR_seek_table.size = 400;
        }
        else {
            gfc-&gt;VBR_seek_table.size = 0;
            ERRORF (gfc,"Error: can't allocate VbrFrames buffer\n");
            return;
        }   
    }
    addVbr(&amp;gfc-&gt;VBR_seek_table, kbps);
    gfp-&gt;nVbrNumFrames++;
}


/*-------------------------------------------------------------*/
static int ExtractI4(unsigned char *buf)
{
	int x;
	/* big endian extract */
	x = buf[0];
	x &lt;&lt;= 8;
	x |= buf[1];
	x &lt;&lt;= 8;
	x |= buf[2];
	x &lt;&lt;= 8;
	x |= buf[3];
	return x;
}

void CreateI4(unsigned char *buf, int nValue)
{
        /* big endian create */
	buf[0]=(nValue&gt;&gt;24)&amp;0xff;
	buf[1]=(nValue&gt;&gt;16)&amp;0xff;
	buf[2]=(nValue&gt;&gt; 8)&amp;0xff;
	buf[3]=(nValue    )&amp;0xff;
}


/*-------------------------------------------------------------*/
/* Same as GetVbrTag below, but only checks for the Xing tag.
   requires buf to contain only 40 bytes */
/*-------------------------------------------------------------*/
int CheckVbrTag(unsigned char *buf)
{
	int			h_id, h_mode, h_sr_index;

	/* get selected MPEG header data */
	h_id       = (buf[1] &gt;&gt; 3) &amp; 1;
	h_sr_index = (buf[2] &gt;&gt; 2) &amp; 3;
	h_mode     = (buf[3] &gt;&gt; 6) &amp; 3;

	/*  determine offset of header */
	if( h_id )
	{
                /* mpeg1 */
		if( h_mode != 3 )	buf+=(32+4);
		else				buf+=(17+4);
	}
	else
	{
                /* mpeg2 */
		if( h_mode != 3 ) buf+=(17+4);
		else              buf+=(9+4);
	}

	if( buf[0] != VBRTag[0] ) return 0;    /* fail */
	if( buf[1] != VBRTag[1] ) return 0;    /* header not found*/
	if( buf[2] != VBRTag[2] ) return 0;
	if( buf[3] != VBRTag[3] ) return 0;
	return 1;
}

int GetVbrTag(VBRTAGDATA *pTagData,  unsigned char *buf)
{
	int			i, head_flags;
	int			h_bitrate,h_id, h_mode, h_sr_index;

	/* get Vbr header data */
	pTagData-&gt;flags = 0;

	/* get selected MPEG header data */
	h_id       = (buf[1] &gt;&gt; 3) &amp; 1;
	h_sr_index = (buf[2] &gt;&gt; 2) &amp; 3;
	h_mode     = (buf[3] &gt;&gt; 6) &amp; 3;
        h_bitrate  = ((buf[2]&gt;&gt;4)&amp;0xf);
	h_bitrate = bitrate_table[h_id][h_bitrate];


	/*  determine offset of header */
	if( h_id )
	{
                /* mpeg1 */
		if( h_mode != 3 )	buf+=(32+4);
		else				buf+=(17+4);
	}
	else
	{
                /* mpeg2 */
		if( h_mode != 3 ) buf+=(17+4);
		else              buf+=(9+4);
	}

	if( buf[0] != VBRTag[0] ) return 0;    /* fail */
	if( buf[1] != VBRTag[1] ) return 0;    /* header not found*/
	if( buf[2] != VBRTag[2] ) return 0;
	if( buf[3] != VBRTag[3] ) return 0;

	buf+=4;

	pTagData-&gt;h_id = h_id;
	pTagData-&gt;samprate = samplerate_table[h_id][h_sr_index];

	if( h_id == 0 )
		pTagData-&gt;samprate &gt;&gt;= 1;

	head_flags = pTagData-&gt;flags = ExtractI4(buf); buf+=4;      /* get flags */

	if( head_flags &amp; FRAMES_FLAG )
	{
		pTagData-&gt;frames   = ExtractI4(buf); buf+=4;
	}

	if( head_flags &amp; BYTES_FLAG )
	{
		pTagData-&gt;bytes = ExtractI4(buf); buf+=4;
	}

	if( head_flags &amp; TOC_FLAG )
	{
		if( pTagData-&gt;toc != NULL )
		{
			for(i=0;i&lt;NUMTOCENTRIES;i++)
				pTagData-&gt;toc[i] = buf[i];
		}
		buf+=NUMTOCENTRIES;
	}

	pTagData-&gt;vbr_scale = -1;

	if( head_flags &amp; VBR_SCALE_FLAG )
	{
		pTagData-&gt;vbr_scale = ExtractI4(buf); buf+=4;
	}

	pTagData-&gt;headersize = 
	  ((h_id+1)*72000*h_bitrate) / pTagData-&gt;samprate;


#ifdef DEBUG_VBRTAG
	DEBUGF("\n\n********************* VBR TAG INFO *****************\n");
	DEBUGF("tag         :%s\n",VBRTag);
	DEBUGF("head_flags  :%d\n",head_flags);
	DEBUGF("bytes       :%d\n",pTagData-&gt;bytes);
	DEBUGF("frames      :%d\n",pTagData-&gt;frames);
	DEBUGF("VBR Scale   :%d\n",pTagData-&gt;vbr_scale);
	DEBUGF("toc:\n");
	if( pTagData-&gt;toc != NULL )
	{
		for(i=0;i&lt;NUMTOCENTRIES;i++)
		{
			if( (i%10) == 0 ) DEBUGF("\n");
			DEBUGF(" %3d", (int)(pTagData-&gt;toc[i]));
		}
	}
	DEBUGF("\n***************** END OF VBR TAG INFO ***************\n");
#endif
	return 1;       /* success */
}


/****************************************************************************
 * InitVbrTag: Initializes the header, and write empty frame to stream
 * Paramters:
 *				fpStream: pointer to output file stream
 *				nMode	: Channel Mode: 0=STEREO 1=JS 2=DS 3=MONO
 ****************************************************************************
*/
int InitVbrTag(lame_global_flags *gfp)
{
	int nMode,SampIndex;
	lame_internal_flags *gfc = gfp-&gt;internal_flags;
#define MAXFRAMESIZE 576
	//	u_char pbtStreamBuffer[MAXFRAMESIZE];
	nMode = gfp-&gt;mode;
	SampIndex = gfc-&gt;samplerate_index;


	/* Clear Frame position array variables */
	gfp-&gt;pVbrFrames=NULL;
	gfp-&gt;nVbrNumFrames=0;
	gfp-&gt;nVbrFrameBufferSize=0;


	/* Clear stream buffer */
	//	memset(pbtStreamBuffer,0x00,sizeof(pbtStreamBuffer));



	/* Reserve the proper amount of bytes */
	if (nMode==3)
	{
		gfp-&gt;nZeroStreamSize=SizeOfEmptyFrame[gfp-&gt;version][1]+4;
	}
	else
	{
		gfp-&gt;nZeroStreamSize=SizeOfEmptyFrame[gfp-&gt;version][0]+4;
	}

	/*
	// Xing VBR pretends to be a 48kbs layer III frame.  (at 44.1kHz).
        // (at 48kHz they use 56kbs since 48kbs frame not big enough for
        // table of contents)
	// let's always embed Xing header inside a 64kbs layer III frame.
	// this gives us enough room for a LAME version string too.
	// size determined by sampling frequency (MPEG1)
	// 32kHz:    216 bytes@48kbs    288bytes@ 64kbs
	// 44.1kHz:  156 bytes          208bytes@64kbs     (+1 if padding = 1)
	// 48kHz:    144 bytes          192
	//
	// MPEG 2 values are the same since the framesize and samplerate
        // are each reduced by a factor of 2.
	*/
	{
	int i,bitrate,tot;
	if (1==gfp-&gt;version) {
	  bitrate = XING_BITRATE1;
	} else {
	  if (gfp-&gt;out_samplerate &lt; 16000 )
	    bitrate = XING_BITRATE25;
	  else
	    bitrate = XING_BITRATE2;
	}
	gfp-&gt;TotalFrameSize= 
	  ((gfp-&gt;version+1)*72000*bitrate) / gfp-&gt;out_samplerate;
	tot = (gfp-&gt;nZeroStreamSize+VBRHEADERSIZE);
	tot += 20;  /* extra 20 bytes for LAME &amp; version string */

	assert(gfp-&gt;TotalFrameSize &gt;= tot );
	assert(gfp-&gt;TotalFrameSize &lt;= MAXFRAMESIZE );

	for (i=0; i&lt;gfp-&gt;TotalFrameSize; ++i)
	  add_dummy_byte(gfp,0);
	}

	/* Success */
	return 0;
}



/****************************************************************************
 * PutVbrTag: Write final VBR tag to the file
 * Paramters:
 *				lpszFileName: filename of MP3 bit stream
 *				nVbrScale	: encoder quality indicator (0..100)
 ****************************************************************************
*/
int PutVbrTag(lame_global_flags *gfp,FILE *fpStream,int nVbrScale)
{
        lame_internal_flags * gfc = gfp-&gt;internal_flags;

	long lFileSize;
	int nStreamIndex;
	char abyte,bbyte;
	u_char		btToc[NUMTOCENTRIES];
	u_char pbtStreamBuffer[MAXFRAMESIZE];
	char str1[80];
        unsigned char id3v2Header[10];
        size_t id3v2TagSize;

        if (gfc-&gt;VBR_seek_table.pos &lt;= 0)
		return -1;


	/* Clear stream buffer */
	memset(pbtStreamBuffer,0x00,sizeof(pbtStreamBuffer));

	/* Seek to end of file*/
	fseek(fpStream,0,SEEK_END);

	/* Get file size */
	lFileSize=ftell(fpStream);

	/* Abort if file has zero length. Yes, it can happen :) */
	if (lFileSize==0)
		return -1;

        /*
         * The VBR tag may NOT be located at the beginning of the stream.
         * If an ID3 version 2 tag was added, then it must be skipped to write
         * the VBR tag data.
         */

        /* seek to the beginning of the stream */
	fseek(fpStream,0,SEEK_SET);
        /* read 10 bytes in case there's an ID3 version 2 header here */
        fread(id3v2Header,1,sizeof id3v2Header,fpStream);
        /* does the stream begin with the ID3 version 2 file identifier? */
        if (!strncmp((char *)id3v2Header,"ID3",3)) {
          /* the tag size (minus the 10-byte header) is encoded into four
           * bytes where the most significant bit is clear in each byte */
          id3v2TagSize=(((id3v2Header[6] &amp; 0x7f)&lt;&lt;21)
            | ((id3v2Header[7] &amp; 0x7f)&lt;&lt;14)
            | ((id3v2Header[8] &amp; 0x7f)&lt;&lt;7)
            | (id3v2Header[9] &amp; 0x7f))
            + sizeof id3v2Header;
        } else {
          /* no ID3 version 2 tag in this stream */
          id3v2TagSize=0;
        }

	/* Seek to first real frame */
	fseek(fpStream,id3v2TagSize+gfp-&gt;TotalFrameSize,SEEK_SET);

	/* Read the header (first valid frame) */
	fread(pbtStreamBuffer,4,1,fpStream);

	/* the default VBR header. 48 kbps layer III, no padding, no crc */
	/* but sampling freq, mode andy copyright/copy protection taken */
	/* from first valid frame */
	pbtStreamBuffer[0]=(u_char) 0xff;
	abyte = (pbtStreamBuffer[1] &amp; (char) 0xf1);
	{ int bitrate;
	if (1==gfp-&gt;version) {
	  bitrate = XING_BITRATE1;
	} else {
	  if (gfp-&gt;out_samplerate &lt; 16000 )
	    bitrate = XING_BITRATE25;
	  else
	    bitrate = XING_BITRATE2;
	}
	  bbyte = 16*BitrateIndex(bitrate,gfp-&gt;version,gfp-&gt;out_samplerate);
	}

	/* Use as much of the info from the real frames in the
	 * Xing header:  samplerate, channels, crc, etc...
	 */ 
	if (gfp-&gt;version==1) {
	  /* MPEG1 */
	  pbtStreamBuffer[1]=abyte | (char) 0x0a;     /* was 0x0b; */
	  abyte = pbtStreamBuffer[2] &amp; (char) 0x0d;   /* AF keep also private bit */
	  pbtStreamBuffer[2]=(char) bbyte | abyte;     /* 64kbs MPEG1 frame */
	}else{
	  /* MPEG2 */
	  pbtStreamBuffer[1]=abyte | (char) 0x02;     /* was 0x03; */
	  abyte = pbtStreamBuffer[2] &amp; (char) 0x0d;   /* AF keep also private bit */
	  pbtStreamBuffer[2]=(char) bbyte | abyte;     /* 64kbs MPEG2 frame */
	}


	/*Seek to the beginning of the stream */
	fseek(fpStream,id3v2TagSize,SEEK_SET);

	/* Clear all TOC entries */
	memset(btToc,0,sizeof(btToc));

        Xing_seek_table (&amp;gfc-&gt;VBR_seek_table, btToc);
        /* print_seeking (btToc); */

	/* Start writing the tag after the zero frame */
	nStreamIndex=gfp-&gt;nZeroStreamSize;

	/* Put Vbr tag */
	pbtStreamBuffer[nStreamIndex++]=VBRTag[0];
	pbtStreamBuffer[nStreamIndex++]=VBRTag[1];
	pbtStreamBuffer[nStreamIndex++]=VBRTag[2];
	pbtStreamBuffer[nStreamIndex++]=VBRTag[3];

	/* Put header flags */
	CreateI4(&amp;pbtStreamBuffer[nStreamIndex],FRAMES_FLAG+BYTES_FLAG+TOC_FLAG+VBR_SCALE_FLAG);
	nStreamIndex+=4;

	/* Put Total Number of frames */
	CreateI4(&amp;pbtStreamBuffer[nStreamIndex],gfp-&gt;nVbrNumFrames);
	nStreamIndex+=4;

	/* Put Total file size */
	CreateI4(&amp;pbtStreamBuffer[nStreamIndex],(int)lFileSize);
	nStreamIndex+=4;

	/* Put TOC */
	memcpy(&amp;pbtStreamBuffer[nStreamIndex],btToc,sizeof(btToc));
	nStreamIndex+=sizeof(btToc);

	/* Put VBR SCALE */
	CreateI4(&amp;pbtStreamBuffer[nStreamIndex],nVbrScale);
	nStreamIndex+=4;

	/* Put LAME ID */
        sprintf ( str1, "LAME%s", get_lame_short_version () );
        strncpy ( (char*)pbtStreamBuffer + nStreamIndex, str1, 20 );
        nStreamIndex += 20;


#ifdef DEBUG_VBRTAG
{
	VBRTAGDATA TestHeader;
	GetVbrTag(&amp;TestHeader,pbtStreamBuffer);
}
#endif

        /* Put it all to disk again */
	if (fwrite(pbtStreamBuffer,(unsigned int)gfp-&gt;TotalFrameSize,1,fpStream)!=1)
	{
		return -1;
	}
	/* Save to delete the frame buffer */
	free(gfp-&gt;pVbrFrames);
	gfp-&gt;pVbrFrames=NULL;

	return 0;       /* success */
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

