<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3enc/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3enc/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* mp3enc - encode audio files in MP3 format */

/*
 *	Command line frontend program
 *
 *	Copyright (c) 1999 Mark Taylor
 *                    2000 Takehiro TOMIANGA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* $Id: main.c,v 1.46 2001/03/11 11:24:25 aleidinger Exp $ */

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;unistd.h&gt;
#include &lt;fcntl.h&gt;
#include &lt;assert.h&gt;
#include &lt;memory.h&gt;
#ifdef HAVE_CONFIG_H
# include &lt;config.h&gt;
#endif

/*
 main.c is example code for how to use libmp3lame.a.  To use this library,
 you only need the library and lame.h.  All other .h files are private
 to the library.
*/
#include "lame.h"

#include "brhist.h"
#include "parse.h"
#include "main.h"
#include "get_audio.h"
#include "timestatus.h"

/*
*
* main
*
* PURPOSE:  MPEG-1,2 Layer III encoder with GPSYCHO
* psychoacoustic model.
*
*/

int
parse_args_from_string(lame_global_flags *const gfp, const char *p)
{
	/* Quick &amp; very Dirty */
	int c = 0, ret;
	char *f, *q, *r[128];

	if (p == NULL || *p == '\0')
		return 0;

	f = q = malloc(strlen(p) + 1);
	strcpy (q, p);

	r[c++] = "lhama";
	for (;;) {
		r[c++] = q;
		while (*q != ' ' &amp;&amp; *q != '\0')
			q++;
		if (*q == '\0')
			break;
		*q++ = '\0';
	}
	r[c] = NULL;

	ret = parse_args(gfp, c, r);
	free(f);
	return ret;
}

int
main(int argc, char **argv)
{
	int i, iread, imp3, ret;
	short Buffer[2][1152];
	unsigned char mp3buffer[LAME_MAXMP3BUFFER];
	FILE *outf;
	lame_global_flags *gf;
	static char inPath[]  = "-";
	static char outPath[] = "-";
	static const char *mode_names[2][4] = {
		{ "stereo", "j-stereo", "dual-ch", "single-ch" },
		{ "stereo", "force-ms", "dual-ch", "single-ch" }
	};

	/* initialize libmp3lame */
	input_format = sf_unknown;
	if (NULL == (gf = lame_init()) ) {
		fprintf(stderr, "mp3enc: fatal error during initialization\n");
		return 1;
	}
	/*
	 * parse the command line arguments, setting various flags in the
	 * struct 'gf'.  If you want to parse your own arguments,
	 * or call libmp3lame from a program which uses a GUI to set arguments,
	 * skip this call and set the values of interest in the gf struct.
	 * (see the file API &amp; lame.h for documentation about these parameters)
	 */
	parse_args_from_string(gf, getenv("LAMEOPT"));
	ret = parse_args(gf, argc, argv);
	if (ret &lt; 0)
		return ret == -2? 0: 1;
	if (update_interval &lt; 0.)
		update_interval = 2.;

	/*
	 * open the wav/aiff/raw pcm or mp3 input file.  This call will
	 * open the file, try to parse the headers and
	 * set gf.samplerate, gf.num_channels, gf.num_samples.
	 * if you want to do your own file input, skip this call and set
	 * samplerate, num_channels and num_samples yourself.
	 */
	init_infile(gf, inPath);
	if ((outf = init_outfile(outPath, lame_get_decode_only(gf))) == NULL) {
		fprintf(stderr, "Can't init outfile '%s'\n", outPath);
		return -42;
	}

	/*
	 * Now that all the options are set, lame needs to analyze them and
	 * set some more internal options and check for problems
	 */
	i = lame_init_params(gf);
	if (i &lt; 0) {
		if (i == -1)
			display_bitrates(stderr);
		fprintf(stderr, "fatal error during initialization\n");
		return 1;
	}

	if (silent || gf-&gt;VBR == vbr_off)
		brhist = 0;			/* turn off VBR histogram */

#ifdef BRHIST
	if (brhist) {
		if (brhist_init(gf, gf-&gt;VBR_min_bitrate_kbps,
		    gf-&gt;VBR_max_bitrate_kbps))
			/* fail to initialize */
			brhist = 0;
	} else
		brhist_init(gf, 128, 128);	/* Dirty hack */
#endif


#ifdef HAVE_VORBIS
	if (lame_get_ogg( gf ) ) {
		lame_encode_ogg_init(gf);
		gf-&gt;VBR = vbr_off;	/* ignore lame's various VBR modes */
	}
#endif
	if (0 == lame_get_decode_only( gf ) &amp;&amp; silent &lt; 10 ) {
		if (0)
			fprintf(stderr, "Encoding as %g kHz ",
				1.e-3 * lame_get_out_samplerate( gf ) );

		if (lame_get_ogg(gf)) {
			if (0)
				fprintf(stderr, "VBR Ogg Vorbis\n" );
		} else {
			const char *appendix = "";

			switch (gf-&gt;VBR ) {
			case vbr_mt:
			case vbr_rh:
			case vbr_mtrh:
				appendix = "ca. ";
				if (0)
					fprintf(stderr, "VBR(q=%i)", gf-&gt;VBR_q );
				break;
			case vbr_abr:
				if (0)
					fprintf(stderr, "average %d kbps",
						gf-&gt;VBR_mean_bitrate_kbps);
				break;
			default:
				if (0)
					fprintf(stderr, "%3d Kb/s", gf-&gt;brate);
				break;
			}
			if (0)
				fprintf(stderr, " %s MPEG-%u%s Layer III (%s%gx) qval=%i\n",
					mode_names[gf-&gt;force_ms][gf-&gt;mode],
					2 - gf-&gt;version,
					lame_get_out_samplerate(gf) &lt; 16000?
					".5": "", appendix,
					0.1 * (int)(10.*gf-&gt;compression_ratio + 0.5),
					lame_get_quality(gf));
		}
		fflush(stderr);
	}

	if (lame_get_decode_only(gf))
		/* decode an mp3 file to a .wav */
		if (mp3_delay_set)
			lame_decoder(gf, outf, mp3_delay, inPath, outPath);
		else
			lame_decoder(gf, outf, gf-&gt;encoder_delay, inPath, outPath);
	else {
		/* encode until we hit eof */
		do {
			/* read in 'iread' samples */
			iread = get_audio(gf, Buffer);

			/* status display  */
			if (!silent)
				if (update_interval &gt; 0)
					timestatus_klemm(gf);
				else {
					if (0 == gf-&gt;frameNum % 50) {
#ifdef BRHIST
						brhist_jump_back();
#endif
						timestatus(lame_get_out_samplerate(gf),
							gf-&gt;frameNum,
							gf-&gt;totalframes,
							gf-&gt;framesize );
#ifdef BRHIST
						if (brhist)
							brhist_disp(gf);
#endif
					}
				}

			/* encode */
			imp3 = lame_encode_buffer(gf, Buffer[0], Buffer[1], iread,
				mp3buffer, sizeof(mp3buffer));

			/* was our output buffer big enough? */
			if (imp3 &lt; 0) {
				if (imp3 == -1)
					fprintf(stderr, "mp3 buffer is not big enough... \n");
				else
					fprintf(stderr, "mp3 internal error:  error code=%i\n", imp3);
				return 1;
			}

			if (fwrite(mp3buffer, 1, imp3, outf) != imp3) {
				fprintf(stderr, "Error writing mp3 output \n");
				return 1;
			}
		} while (iread);
		/* may return one more mp3 frame */
		imp3 = lame_encode_flush(gf, mp3buffer, sizeof(mp3buffer));
		if (imp3 &lt; 0) {
			if (imp3 == -1)
				fprintf(stderr, "mp3 buffer is not big enough... \n");
			else
				fprintf(stderr, "mp3 internal error:  error code=%i\n", imp3);
			return 1;

		}
		if (!silent) {
#ifdef BRHIST
			brhist_jump_back();
#endif
			timestatus(lame_get_out_samplerate(gf),
				gf-&gt;frameNum,
				gf-&gt;totalframes,
				gf-&gt;framesize);
#ifdef BRHIST
			if (brhist)
				brhist_disp(gf);
			brhist_disp_total(gf);
#endif
			timestatus_finish();
		}

		fwrite(mp3buffer, 1, imp3, outf);
		lame_mp3_tags_fid(gf, outf);	/* add VBR tags to mp3 file */
		lame_close(gf);
		fclose(outf);
	}
	close_infile();
	exit(0);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

