<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3enc/mpglib_interface.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3enc/mpglib_interface.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* $Id: mpglib_interface.c,v 1.18 2001/01/06 01:00:33 markt Exp $ */

#ifdef HAVE_CONFIG_H
# include &lt;config.h&gt;
#endif

#ifdef HAVE_MPGLIB

#include &lt;limits.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;assert.h&gt;

#include "interface.h"
#include "lame.h"

#ifdef WITH_DMALLOC
#include &lt;dmalloc.h&gt;
#endif


MPSTR           mp;
plotting_data*  mpg123_pinfo = NULL;


int lame_decode_init( void )
{
    InitMP3 ( &amp;mp );
    return 0;
}

/*
 * For lame_decode:  return code
 * -1     error
 *  0     ok, but need more data before outputing any samples
 *  n     number of samples output.  either 576 or 1152 depending on MP3 file.
 */
 
int lame_decode1_headers(
        unsigned char*   buffer,
        int              len,
        short            pcm_l [],
        short            pcm_r [],
        mp3data_struct*  mp3data )
{
    static const int smpls [2] [4] = {
    /* Layer   I    II   III */
        { 0, 384, 1152, 1152 }, /* MPEG-1     */
        { 0, 384, 1152,  576 }  /* MPEG-2(.5) */
    };
    static char        out  [8192];
    signed short int*  p = (signed short int*) out;
    int                processed_bytes;
    int                processed_samples;  // processed samples per channel
    int                ret;
    int                i;

    mp3data-&gt;header_parsed = 0;
  
    ret = decodeMP3 ( &amp;mp, buffer, len, (char*)p, sizeof(out), &amp;processed_bytes );

    if ( mp.header_parsed ) {
        mp3data-&gt;header_parsed = 1;
        mp3data-&gt;stereo        = mp.fr.stereo;
        mp3data-&gt;samplerate    = freqs [mp.fr.sampling_frequency];
        mp3data-&gt;mode          = mp.fr.mode;
        mp3data-&gt;mode_ext      = mp.fr.mode_ext;
        mp3data-&gt;framesize     = smpls [mp.fr.lsf] [mp.fr.lay];
	
        if (mp.fsizeold &gt; 0)      /* works for free format and fixed, no overrun, temporal results are &lt; 400.e6 */
            mp3data-&gt;bitrate   = 8 * (4 + mp.fsizeold) * mp3data-&gt;samplerate /
	                         ( 1.e3 * mp3data-&gt;framesize ) + 0.5;
        else
            mp3data-&gt;bitrate   = tabsel_123 [mp.fr.lsf] [mp.fr.lay-1] [mp.fr.bitrate_index];

        if (mp.num_frames&gt;0) {
	  /* Xing VBR header found and num_frames was set */
	  mp3data-&gt;totalframes = mp.num_frames;
          mp3data-&gt;nsamp=mp3data-&gt;framesize * mp.num_frames;  
	}
    }

    switch ( ret ) {
    case MP3_OK:
        switch ( mp.fr.stereo ) {
	case 1:
            processed_samples = processed_bytes &gt;&gt; 1;
            for ( i = 0; i &lt; processed_samples; i++ ) 
	        pcm_l [i] = *p++;
	    break;
	case 2:
            processed_samples = processed_bytes &gt;&gt; 2;
            for ( i = 0; i &lt; processed_samples; i++ ) {
	        pcm_l [i] = *p++;
		pcm_r [i] = *p++;
	    }
	    break;
	default:
            processed_samples = -1;
	    assert (0);
	    break;
        }    
	break;
	
    case MP3_NEED_MORE:
        processed_samples = 0;
	break;
	
    default:
        assert (0);
    case MP3_ERR: 
        processed_samples = -1;
	break;
	
    }
  
    //  printf ( "ok, more, err:  %i %i %i\n", MP3_OK, MP3_NEED_MORE, MP3_ERR );
    //  printf ( "ret = %i out=%i\n", ret, totsize );
    return processed_samples;
}


/*
 * For lame_decode:  return code
 *  -1     error
 *   0     ok, but need more data before outputing any samples
 *   n     number of samples output.  Will be at most one frame of
 *         MPEG data.  
 */
 
int lame_decode1( 
        unsigned char*  buffer,
	int    len,
	short  pcm_l [],
	short  pcm_r [] )
{
  mp3data_struct mp3data;
  
  return lame_decode1_headers ( buffer, len, pcm_l, pcm_r, &amp;mp3data );
}


/*
 * For lame_decode:  return code
 *  -1     error
 *   0     ok, but need more data before outputing any samples
 *   n     number of samples output.  a multiple of 576 or 1152 depending on MP3 file.
 */
 
int lame_decode_headers( 
        unsigned char*   buffer,
	int              len,
	short            pcm_l [],
	short            pcm_r [],
        mp3data_struct*  mp3data )
{
    int  ret;
    int  totsize = 0;   // number of decoded samples per channel

    while (1) {
        switch ( ret = lame_decode1_headers ( buffer, len, pcm_l+totsize, pcm_r+totsize, mp3data ) ) {
        case -1: return ret;
        case  0: return totsize;
        default: totsize += ret;
                 len      = 0;  /* future calls to decodeMP3 are just to flush buffers */
                 break;
        }
    }
}


int lame_decode(
        unsigned char*  buffer,
	int    len,
	short  pcm_l [],
	short  pcm_r [] )
{
    mp3data_struct  mp3data;
    
    return lame_decode_headers ( buffer, len, pcm_l, pcm_r, &amp;mp3data );
}


#endif

/* end of mpglib_interface.c */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

