<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3enc/portableio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3enc/portableio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1988-1991 Apple Computer, Inc.
 * All Rights Reserved.
 *
 * Warranty Information
 * Even though Apple has reviewed this software, Apple makes no warranty
 * or representation, either express or implied, with respect to this
 * software, its quality, accuracy, merchantability, or fitness for a
 * particular purpose.  As a result, this software is provided "as is,"
 * and you, its user, are assuming the entire risk as to its quality
 * and accuracy.
 *
 * This code may be used and freely distributed as long as it includes
 * this copyright notice and the warranty information.
 *
 *
 * Motorola processors (Macintosh, Sun, Sparc, MIPS, etc)
 * pack bytes from high to low (they are big-endian).
 * Use the HighLow routines to match the native format
 * of these machines.
 *
 * Intel-like machines (PCs, Sequent)
 * pack bytes from low to high (the are little-endian).
 * Use the LowHigh routines to match the native format
 * of these machines.
 *
 * These routines have been tested on the following machines:
 *	Apple Macintosh, MPW 3.1 C compiler
 *	Apple Macintosh, THINK C compiler
 *	Silicon Graphics IRIS, MIPS compiler
 *	Cray X/MP and Y/MP
 *	Digital Equipment VAX
 *
 *
 * Implemented by Malcolm Slaney and Ken Turkowski.
 *
 * Malcolm Slaney contributions during 1988-1990 include big- and little-
 * endian file I/O, conversion to and from Motorola's extended 80-bit
 * floating-point format, and conversions to and from IEEE single-
 * precision floating-point format.
 *
 * In 1991, Ken Turkowski implemented the conversions to and from
 * IEEE double-precision format, added more precision to the extended
 * conversions, and accommodated conversions involving +/- infinity,
 * NaN's, and denormalized numbers.
 *
 * $Id: portableio.c,v 1.11 2001/01/07 23:47:38 markt Exp $
 */

#ifdef HAVE_CONFIG_H
# include &lt;config.h&gt;
#endif

#include	&lt;stdio.h&gt;
#if defined(__riscos__) &amp;&amp; defined(FPA10)
#include	"ymath.h"
#else
#include	&lt;math.h&gt;
#endif
#include	"portableio.h"

#ifdef WITH_DMALLOC
#include &lt;dmalloc.h&gt;
#endif

/****************************************************************
 * Big/little-endian independent I/O routines.
 ****************************************************************/

/*
 * It is a hoax to call this code portable-IO:
 * 
 *   - It doesn't work on machines with CHAR_BIT != 8
 *   - it also don't test this error condition
 *   - otherwise it tries to handle CHAR_BIT != 8 by things like 
 *     masking 'putc(i&amp;0xff,fp)'
 *   - It doesn't handle EOF in any way
 *   - it only works with ints with 32 or more bits
 *   - It is a collection of initial buggy code with patching the known errors
 *     instead of CORRECTING them! 
 *     For that see comments on the old Read16BitsHighLow()
 */

#ifdef KLEMM_36

signed int    ReadByte ( FILE* fp )
{
    int  result = getc (fp);
    return result == EOF  ?  0  :  (signed char) (result &amp; 0xFF);
}

unsigned int  ReadByteUnsigned ( FILE* fp )
{
    int  result = getc (fp);
    return result == EOF  ?  0  :  (unsigned char) (result &amp; 0xFF);
}

#else

int
ReadByte(FILE *fp)
{
	int	result;

	result = getc(fp) &amp; 0xff;
	if (result &amp; 0x80)
		result = result - 0x100;
	return result;
}

#endif

#ifdef KLEMM_36

int  Read16BitsLowHigh ( FILE* fp )
{
    int  low  = ReadByteUnsigned (fp);
    int  high = ReadByte         (fp);
    
    return (high &lt;&lt; 8) | low;
}

#else
int
Read16BitsLowHigh(FILE *fp)
{
	int	first, second, result;

	first = 0xff &amp; getc(fp);
	second = 0xff &amp; getc(fp);

	result = (second &lt;&lt; 8) + first;
#ifndef	THINK_C42
	if (result &amp; 0x8000)
		result = result - 0x10000;
#endif	/* THINK_C */
	return(result);
}
#endif


#ifdef KLEMM_36

int  Read16BitsHighLow ( FILE* fp )
{
    int  high = ReadByte         (fp);
    int  low  = ReadByteUnsigned (fp);
    
    return (high &lt;&lt; 8) | low;
}

#else
int
Read16BitsHighLow(FILE *fp)
{
	int	first, second, result;
     
        /* Reads the High bits, the value is -128...127 
	 * (which gave after upscaling the -32768...+32512
	 * Why this value is not converted to signed char?
	 */
        first = 0xff &amp; getc(fp);
        /* Reads the Lows bits, the value is 0...255 
	 * This is correct. This value gives an additional offset
	 * for the High bits
	 */
	second = 0xff &amp; getc(fp);

        /* This is right */
	result = (first &lt;&lt; 8) + second;
    
        /* Now we are starting to correct the nasty bug of the first instruction
	 * The value of the high bits is wrong. Always. So we must correct this
	 * value. This seems to be not necessary for THINK_C42. This is either
	 * a 16 bit compiler with 16 bit ints (where this bug is hidden and 0x10000
	 * is not in the scope of an int) or it is not a C compiler, but only a
	 * C like compiler. In the first case the '#ifndef THINK_C42' is wrong
	 * because it's not a property of the THINK_C42 compiler, but of all compilers
	 * with sizeof(int)*CHAR_BIT &lt; 18.
	 * Another nasty thing is that the rest of the code doesn't work for 16 bit ints,
	 * so this patch don't solve the 16 bit problem.
         */
#ifndef	THINK_C42
	if (result &amp; 0x8000)
		result = result - 0x10000;
#endif	/* THINK_C */
	return(result);
}
#endif

void
Write8Bits(FILE *fp, int i)
{
	putc(i&amp;0xff,fp);
}


void
Write16BitsLowHigh(FILE *fp, int i)
{
	putc(i&amp;0xff,fp);
	putc((i&gt;&gt;8)&amp;0xff,fp);
}


void
Write16BitsHighLow(FILE *fp, int i)
{
	putc((i&gt;&gt;8)&amp;0xff,fp);
	putc(i&amp;0xff,fp);
}

#ifdef KLEMM_36

int  Read24BitsHighLow ( FILE* fp )
{
    int  high = ReadByte         (fp);
    int  med  = ReadByteUnsigned (fp);
    int  low  = ReadByteUnsigned (fp);
    
    return (high &lt;&lt; 16) | (med &lt;&lt; 8) | low;
}

#else
int
Read24BitsHighLow(FILE *fp)
{
	int	first, second, third;
	int	result;

	first = 0xff &amp; getc(fp);
	second = 0xff &amp; getc(fp);
	third = 0xff &amp; getc(fp);

	result = (first &lt;&lt; 16) + (second &lt;&lt; 8) + third;
	if (result &amp; 0x800000)
		result = result - 0x1000000;
	return(result);
}
#endif

#define	Read32BitsLowHigh(f)	Read32Bits(f)

#ifdef KLEMM_36

int  Read32Bits ( FILE* fp )
{
    int  low  = ReadByteUnsigned (fp);
    int  medl = ReadByteUnsigned (fp);
    int  medh = ReadByteUnsigned (fp);
    int  high = ReadByte         (fp);

    return (high &lt;&lt; 24) | (medh &lt;&lt; 16) | (medl &lt;&lt; 8) | low;
}

#else

int
Read32Bits(FILE *fp)
{
	int	first, second, result;

	first = 0xffff &amp; Read16BitsLowHigh(fp);
	second = 0xffff &amp; Read16BitsLowHigh(fp);

	result = (second &lt;&lt; 16) + first;
#ifdef	CRAY
	if (result &amp; 0x80000000)
		result = result - 0x100000000;
#endif	/* CRAY */
	return(result);
}
#endif


#ifdef KLEMM_36

int  Read32BitsHighLow ( FILE* fp )
{
    int  high = ReadByte         (fp);
    int  medh = ReadByteUnsigned (fp);
    int  medl = ReadByteUnsigned (fp);
    int  low  = ReadByteUnsigned (fp);
    
    return (high &lt;&lt; 24) | (medh &lt;&lt; 16) | (medl &lt;&lt; 8) | low;
}

#else

int
Read32BitsHighLow(FILE *fp)
{
	int	first, second, result;

	first = 0xffff &amp; Read16BitsHighLow(fp);
	second = 0xffff &amp; Read16BitsHighLow(fp);

	result = (first &lt;&lt; 16) + second;
#ifdef	CRAY
	if (result &amp; 0x80000000)
		result = result - 0x100000000;
#endif
	return(result);
}

#endif

void
Write32Bits(FILE *fp, int i)
{
	Write16BitsLowHigh(fp,(int)(i&amp;0xffffL));
	Write16BitsLowHigh(fp,(int)((i&gt;&gt;16)&amp;0xffffL));
}


void
Write32BitsLowHigh(FILE *fp, int i)
{
	Write16BitsLowHigh(fp,(int)(i&amp;0xffffL));
	Write16BitsLowHigh(fp,(int)((i&gt;&gt;16)&amp;0xffffL));
}


void
Write32BitsHighLow(FILE *fp, int i)
{
	Write16BitsHighLow(fp,(int)((i&gt;&gt;16)&amp;0xffffL));
	Write16BitsHighLow(fp,(int)(i&amp;0xffffL));
}

#ifdef KLEMM_36
void ReadBytes (FILE     *fp, char *p, int n) 
{
    memset ( p, 0, n );
    fread  ( p, 1, n, fp );
}
#else
void ReadBytes(FILE	*fp, char *p, int n)
{
	/* What about fread? */
	 
	while (!feof(fp) &amp; (n-- &gt; 0))
		*p++ = getc(fp);
}
#endif

void ReadBytesSwapped(FILE *fp, char *p, int n)
{
	register char	*q = p;

	/* What about fread? */
	  
	while (!feof(fp) &amp; (n-- &gt; 0))
		*q++ = getc(fp);

        /* If not all bytes could be read, the resorting is different
	 * from the normal resorting. Is this intention or another bug?
	 */
	for (q--; p &lt; q; p++, q--){
		n = *p;
		*p = *q;
		*q = n;
	}
}

#ifdef KLEMM_36
void WriteBytes(FILE *fp, char *p, int n)
{
    /* return n == */
    fwrite ( p, 1, n, fp );
}
#else
void WriteBytes(FILE *fp, char *p, int n)
{
        /* No error condition checking */
        while (n-- &gt; 0)
		putc(*p++, fp);
}
#endif
#ifdef KLEMM_36
void WriteBytesSwapped(FILE *fp, char *p, int n)
{
    p += n;
    while ( n-- &gt; 0 )
	putc ( *--p, fp );
}
#else
void WriteBytesSwapped(FILE *fp, char *p, int n)
{
	p += n-1;
	while (n-- &gt; 0)
		putc(*p--, fp);
}
#endif



/****************************************************************
 * The following two routines make up for deficiencies in many
 * compilers to convert properly between unsigned integers and
 * floating-point.  Some compilers which have this bug are the
 * THINK_C compiler for the Macintosh and the C compiler for the
 * Silicon Graphics MIPS-based Iris.
 ****************************************************************/

#ifdef applec	/* The Apple C compiler works */
# define FloatToUnsigned(f)	((unsigned long)(f))
# define UnsignedToFloat(u)	((double)(u))
#else /* applec */
# define FloatToUnsigned(f)	((unsigned long)(((long)((f) - 2147483648.0)) + 2147483647L + 1))
# define UnsignedToFloat(u)	(((double)((long)((u) - 2147483647L - 1))) + 2147483648.0)
#endif /* applec */
/****************************************************************
 * Extended precision IEEE floating-point conversion routines
 ****************************************************************/

double
ConvertFromIeeeExtended(char* bytes)
{
	double	f;
	long	expon;
	unsigned long hiMant, loMant;

#ifdef	TEST
printf("ConvertFromIEEEExtended(%lx,%lx,%lx,%lx,%lx,%lx,%lx,%lx,%lx,%lx\r",
	(long)bytes[0], (long)bytes[1], (long)bytes[2], (long)bytes[3],
	(long)bytes[4], (long)bytes[5], (long)bytes[6],
	(long)bytes[7], (long)bytes[8], (long)bytes[9]);
#endif

	expon = ((bytes[0] &amp; 0x7F) &lt;&lt; 8) | (bytes[1] &amp; 0xFF);
	hiMant	=	((unsigned long)(bytes[2] &amp; 0xFF) &lt;&lt; 24)
			|	((unsigned long)(bytes[3] &amp; 0xFF) &lt;&lt; 16)
			|	((unsigned long)(bytes[4] &amp; 0xFF) &lt;&lt; 8)
			|	((unsigned long)(bytes[5] &amp; 0xFF));
	loMant	=	((unsigned long)(bytes[6] &amp; 0xFF) &lt;&lt; 24)
			|	((unsigned long)(bytes[7] &amp; 0xFF) &lt;&lt; 16)
			|	((unsigned long)(bytes[8] &amp; 0xFF) &lt;&lt; 8)
			|	((unsigned long)(bytes[9] &amp; 0xFF));

        /* This case should also be called if the number is below the smallest
	 * positive double variable */
	if (expon == 0 &amp;&amp; hiMant == 0 &amp;&amp; loMant == 0) {
		f = 0;
	}
	else {
	        /* This case should also be called if the number is too large to fit into 
		 * a double variable */
	    
		if (expon == 0x7FFF) {	/* Infinity or NaN */
			f = HUGE_VAL;
		}
		else {
			expon -= 16383;
			f  = ldexp(UnsignedToFloat(hiMant), (int) (expon -= 31));
			f += ldexp(UnsignedToFloat(loMant), (int) (expon -= 32));
		}
	}

	if (bytes[0] &amp; 0x80)
		return -f;
	else
		return f;
}





double
ReadIeeeExtendedHighLow(FILE *fp)
{
	char	bytes [10];

	ReadBytes ( fp, bytes, 10 );
	return ConvertFromIeeeExtended ( bytes );
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

