<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/jukebox/playlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/jukebox/playlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;draw.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;mouse.h&gt;
#include &lt;control.h&gt;
#include "playlist.h"
#include "../debug.h"

char *playlistfile = "/mnt/playlist";
char *playctlfile = "/mnt/playctl";
char *playvolfile = "/mnt/playvol";
char *volumefile = "/dev/audioctl";

Playlist	playlist;
int		playctlfd;

void
playlistproc(void*)
{
	int fd, m, n, nf;
	static char buf[8192+1];
	char *p, *q, *fields[4];

	threadsetname("playlistproc");
	fd = open(playlistfile, OREAD);
	if(fd &lt; 0)
		sysfatal("%s: %r", playlistfile);
	p = buf;
	n = 0;
	if(debug &amp; DBGPLAY)
		fprint(2, "playlistproc: starting\n");
	for(;;){
		m = read(fd, buf+n, sizeof buf - 1 - n);
		if(m == 0){
			if(debug &amp; DBGPLAY)
				fprint(2, "playlistproc: empty read\n");
			continue;
		}
		if(m &lt; 0){
			rerrstr(buf, sizeof(buf));
			if(strcmp(buf, "reading past eof"))
				sysfatal("%s: %r", playlistfile);
			for(n = 0; n &lt; playlist.nentries; n++){
				free(playlist.entry[n].file);
				free(playlist.entry[n].onum);
			}
			if(debug &amp; DBGPLAY)
				fprint(2, "playlistproc: trunc\n");
			playlist.nentries = 0;
			free(playlist.entry);
			playlist.entry = nil;
			updateplaylist(1);
			seek(fd, 0, 0);
			p = buf;
			n = 0;
			continue;
		}
		if(debug &amp; DBGPLAY)
			fprint(2, "playlistproc: read %d bytes\n", m);
		n += m;
		p[n] = '\0';
		while(q = strchr(p, '\n')){
			*q = 0;
			nf = tokenize(p, fields, nelem(fields));
			if(nf){
				playlist.entry = realloc(playlist.entry, (playlist.nentries+1)*sizeof playlist.entry[0]);
				if(playlist.entry == nil)
					sysfatal("realloc %r");
				playlist.entry[playlist.nentries].file = strdup(fields[0]);
				if(nf &gt; 1){
					playlist.entry[playlist.nentries].onum = strdup(fields[1]);
					if(debug &amp; DBGPLAY)
						fprint(2, "playlistproc: [%d]: %q %q\n", playlist.nentries,
							playlist.entry[playlist.nentries].file,
							playlist.entry[playlist.nentries].onum);
				}else{
					playlist.entry[playlist.nentries].onum = nil;
					if(debug &amp; DBGPLAY)
						fprint(2, "playlistproc: [%d]: %q nil\n", playlist.nentries,
							playlist.entry[playlist.nentries].file);
				}
				updateplaylist(0);	// this will also update nentries
			}
			q++;
			n -= q-p;
			p = q;
		}
		if(n)
			memmove(buf, p, n);
		p = buf;
	}
}

void
sendplaylist(char *file, char *onum)
{
	static int fd = -1;
	char *b;

	if(file == nil){
		if(fd &gt;= 0)
			close(fd);
		fd = open(playlistfile, OWRITE|OTRUNC);
		if(fd &lt; 0)
			sysfatal("%s: truncate: %r", playlistfile);
		return;
	}
	if(fd &lt; 0){
		fd = open(playlistfile, OWRITE);
		if(fd &lt; 0)
			sysfatal("%s: %r", playlistfile);
	}
	b = smprint("%q	%q\n", file, onum);
	if(debug &amp; DBGPLAY)
		fprint(2, "sendplaylist @%s@\n", b);
	if(write(fd , b, strlen(b)) != strlen(b))
		sysfatal("sendplaylist: %r");
}

void
playctlproc(void*a)
{
	int fd, n, nf;
	static char buf[512+1];
	char *fields[4];
	Channel *chan;

	threadsetname("playctlproc");
	chan = a;
	fd = open(playctlfile, OREAD);
	if(fd &lt; 0)
		sysfatal("%s: %r", playctlfile);
	for(;;){
		n = read(fd, buf, sizeof buf -1);
		if(n == 0)
			continue;
		if(n &lt; 0)
			sysfatal("%s: %r", playctlfile);
		buf[n] = '\0';
		nf = tokenize(buf, fields, nelem(fields));
		if(nf == 0)
			continue;
		switch (nf){
		default:
			sysfatal("playctlproc: [%d]: %s", nf, fields[0]);
		case 3:
			chanprint(chan, "playctlproc: error %lud %q", strtoul(fields[1], nil, 0), fields[2]);
			if(strcmp(fields[0], "error") == 0)
				break;
			// fall through
		case 2:
			chanprint(chan, "playctlproc: %s %lud", fields[0], strtoul(fields[1], nil, 0));
		}
	}
}

void
sendplayctl(char *fmt, ...)
{
	va_list arg;
	static int fd = -1;

	va_start(arg, fmt);
	if(debug &amp; DBGPLAY){
		fprint(2, "sendplayctl: fmt=%s: ", fmt);
		fprint(2, fmt, arg);
		fprint(2, "\n");
	}
	fprint(fd, fmt, arg);
	va_end(arg);
}

void
setvolume(char *volume)
{
	static int fd;

	if(fd == 0){
		fd = open(playvolfile, OWRITE);
		if(fd &lt; 0){
			fprint(2, "can't open %s, (%r) opening %s instead\n", playvolfile, "/dev/volume");
			if((fd = open("/dev/volume", OWRITE)) &lt; 0){
				fprint(2, "setvolume: open: %r\n");
				return;
			}
		}
	}
	if(fd &lt; 0)
		return;
	fprint(fd, "volume %s", volume);
}

void
volumeproc(void *arg)
{
	int fd, n, nf, nnf, i, nlines;
	static char buf[1024];
	char *lines[32];
	char *fields[8];
	char *subfields[8];
	Channel *ctl;
	int volume, minvolume, maxvolume, nvolume;

	ctl = arg;
	threadsetname("volumeproc");
	fd = open(volumefile, OREAD);
	if(fd &lt; 0){
		fprint(2, "%s: %r\n", volumefile);
		threadexits(nil);
	}
	for(;;){
		n = read(fd, buf, sizeof buf -1);
		if(n == 0)
			continue;
		if(n &lt; 0){
			fprint(2, "volumeproc: read: %r\n");
			threadexits("volumeproc");
		}
		buf[n] = '\0';
		nlines = getfields(buf, lines, nelem(lines), 1, "\n");
		for(i = 0; i &lt; nlines; i++){
			nf = tokenize(lines[i], fields, nelem(fields));
			if(nf == 0)
				continue;
			if(nf != 6 || strcmp(fields[0], "volume") || strcmp(fields[1], "out"))
				continue;
			minvolume = strtol(fields[3], nil, 0);
			maxvolume = strtol(fields[4], nil, 0);
			if(minvolume &gt;= maxvolume)
				continue;
			nnf = tokenize(fields[2], subfields, nelem(subfields));
			if(nnf &lt;= 0 || nnf &gt; 8){
				fprint(2, "volume format error\n");
				threadexits(nil);
			}
			volume = 0;
			nvolume = 0;
			for(i = 0; i &lt; nnf; i++){
				volume += strtol(subfields[i], nil, 0);
				nvolume++;
			}
			volume /= nvolume;
			volume = 100*(volume - minvolume)/(maxvolume-minvolume);
			chanprint(ctl, "volume value %d", volume);
		}
	}
}

void
playvolproc(void*a)
{
	int fd, n, nf, volume, nvolume, i;
	static char buf[256+1];
	static errors;
	char *fields[3], *subfields[9];
	Channel *chan;

	threadsetname("playvolproc");
	chan = a;
	fd = open(playvolfile, OREAD);
	if(fd &lt; 0)
		sysfatal("%s: %r", playvolfile);
	for(;;){
		n = read(fd, buf, sizeof buf -1);
		if(n == 0)
			continue;
		if(n &lt; 0){
			fprint(2, "%s: %r\n", playvolfile);
			threadexits("playvolproc");
		}
		buf[n] = '\0';
		if(debug) fprint(2, "volumestring: %s\n", buf);
		nf = tokenize(buf, fields, nelem(fields));
		if(nf == 0)
			continue;
		if(nf != 2 || strcmp(fields[0], "volume")){
			fprint(2, "playvolproc: [%d]: %s\n", nf, fields[0]);
			if(errors++ &gt; 32)
				threadexits("playvolproc");
			continue;
		}
		nvolume = tokenize(fields[1], subfields, nelem(subfields));
		if(nvolume &lt;= 0 || nvolume &gt; 8){
			fprint(2, "volume format error\n");
			if(errors++ &gt; 32)
				threadexits("playvolproc");
			continue;
		}
		volume = 0;
		for(i = 0; i &lt; nvolume; i++)
			volume += strtol(subfields[i], nil, 0);
		volume /= nvolume;
		chanprint(chan, "volume value %d", volume);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

