<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/jukefs/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/jukefs/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;bio.h&gt;
#include &lt;fcall.h&gt;
#include "object.h"

extern int debug;

extern int mfd[];

enum {
	DbgFs = 0x1000
};

typedef struct Fid Fid;

enum {
	Busy =	0x01,
	Open =	0x02,
	Endf =	0x04,
};

struct Fid
{
	QLock;
	Qid	qid;
	int	fid;
	ushort	flags;
	vlong	offset;		// offset of data[0]
	Fid	*next;
};

Fcall	thdr;
Fcall	rhdr;

enum {
	/* Files making up an object */
	Qchildren,		/* Each of these must be in dirtab */
	Qdigest,
	Qfiles,
	Qfulltext,
	Qkey,
	Qminiparentage,
	Qparent,
	Qparentage,
	Qtext,
	Qtype,

	/* Other files */
	Qtop,	/* Must follow Qtype */
	Qclassical,
	Qdir,
	Qroot,
	Qctl,
};

#define PATH(id, f)	(((id)&lt;&lt;8) | (f))
#define FILE(p)		((p) &amp; 0xff)
#define NUM(p)		((p) &gt;&gt; 8)

char *dirtab[] =
{
[Qchildren]	"children",
[Qdigest]	"digest",
[Qdir]		".",
[Qfiles]	"files",
[Qfulltext]	"fulltext",
[Qkey]		"key",
[Qminiparentage]"miniparentage",
[Qparent]	"parent",
[Qparentage]	"parentage",
[Qtext]		"text",
[Qtype]		"type",
[Qtop]		nil,
};

char	*rflush(Fid*), *rauth(Fid*),
	*rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*),
	*rversion(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tauth]		rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

int	messagesize = 8*1024+IOHDRSZ;
uchar	mdata[8*1024+IOHDRSZ];
uchar	mbuf[8*1024+IOHDRSZ];
char	bigbuf[1&lt;&lt;23];	/* 8 megabytes */
Fid	*fids;

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"no authentication required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Ebadctl[] =	"unknown control message";

Fid *newfid(int fid);

static int
lookup(char *cmd, char *list[])
{
	int i;

	for (i = 0; list[i] != nil; i++)
		if (strcmp(cmd, list[i]) == 0)
			return i;
	return -1;
}

char*
rversion(Fid *)
{
	Fid *f;

	if(thdr.msize &lt; 256)
		return "max messagesize too small";
	if(thdr.msize &lt; messagesize)
		messagesize = thdr.msize;
	rhdr.msize = messagesize;
	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return "unknown 9P version";
	else
		rhdr.version = "9P2000";
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;flags &amp; Busy)
			rclunk(f);
	return nil;
}

char*
rauth(Fid*)
{
	return Enoauth;
}

char*
rflush(Fid *)
{
	return 0;
}

char*
rattach(Fid *f)
{
	f-&gt;flags |= Busy;
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.vers = 0;
	f-&gt;qid.path = PATH(0, Qtop);
	rhdr.qid = f-&gt;qid;
	return 0;
}

static Fid*
doclone(Fid *f, int nfid)
{
	Fid *nf;

	nf = newfid(nfid);
	nf-&gt;qid = f-&gt;qid;
	if(nf-&gt;flags &amp; Busy)
		return nil;
	nf-&gt;flags |= Busy;
	nf-&gt;flags &amp;= ~Open;
	return nf;
}

char*
dowalk(Fid *f, char *name)
{
	int t, n, m;
	char *rv, *p;

	t = FILE(f-&gt;qid.path);	/* Type */

	rv = Enotexist;

	if(strcmp(name, ".") == 0 &amp;&amp; f-&gt;qid.type == QTDIR)
		return nil;
	if(strcmp(name, "..") == 0){
		switch(t){
		case Qtop:
		case Qclassical:
			f-&gt;qid.path = PATH(0, Qtop);
			f-&gt;qid.type = QTDIR;
			f-&gt;qid.vers = 0;
			rv = nil;
			break;
		case Qdir:
		case Qroot:
			f-&gt;qid.path = PATH(0, Qclassical);
			f-&gt;qid.type = QTDIR;
			f-&gt;qid.vers = 0;
			rv = nil;
			break;
		}
		return rv;
	}
	switch(t){
	case Qtop:
		/* Contains classical */
		if(strcmp(name, "juke") == 0){
			f-&gt;qid.path = PATH(root-&gt;tabno, Qclassical);
			f-&gt;qid.type = QTDIR;
			f-&gt;qid.vers = 0;
			rv = nil;
			break;
		}
		break;
	case Qclassical:
		/* main dir, contains `root' and object dirs */
		if(strcmp(name, "root") == 0){
			f-&gt;qid.path = PATH(root-&gt;tabno, Qroot);
			f-&gt;qid.type = QTDIR;
			f-&gt;qid.vers = 0;
			rv = nil;
			break;
		}
		if(strcmp(name, "ctl") == 0){
			f-&gt;qid.path = PATH(root-&gt;tabno, Qctl);
			f-&gt;qid.type = QTFILE;
			f-&gt;qid.vers = 0;
			rv = nil;
			break;
		}
		n = strtol(name, &amp;p, 0);
		if(*p)
			break;	/* Not a number */
		if(n &lt; 0 || n &gt;= notab)
			break;	/* Outside range */
		if(otab[n] == nil)
			break;	/* Not in object table */
		f-&gt;qid.path = PATH(n, Qdir);
		f-&gt;qid.type = QTDIR;
		f-&gt;qid.vers = 0;
		rv = nil;
		break;
	case Qroot:	/* Root of the object hierarchy */
	case Qdir:	/* Object directory */
		if((m = lookup(name, dirtab)) &lt; 0)
			break;
		n = NUM(f-&gt;qid.path);
		f-&gt;qid.path = PATH(n, m);
		f-&gt;qid.type = QTFILE;
		f-&gt;qid.vers = 0;
		rv = nil;
		break;
	}
	return rv;
}

char*
rwalk(Fid *f)
{
	Fid *nf;
	char *rv;
	int i;

	if(f-&gt;flags &amp; Open)
		return Eisopen;

	rhdr.nwqid = 0;
	nf = nil;

	/* clone if requested */
	if(thdr.newfid != thdr.fid){
		nf = doclone(f, thdr.newfid);
		if(nf == nil)
			return "new fid in use";
		f = nf;
	}

	/* if it's just a clone, return */
	if(thdr.nwname == 0 &amp;&amp; nf != nil)
		return nil;

	/* walk each element */
	rv = nil;
	for(i = 0; i &lt; thdr.nwname; i++){
		rv = dowalk(f, thdr.wname[i]);
		if(rv != nil){
			if(nf != nil)	
				rclunk(nf);
			break;
		}
		rhdr.wqid[i] = f-&gt;qid;
	}
	rhdr.nwqid = i;

	/* we only error out if no walk  */
	if(i &gt; 0)
		rv = nil;

	return rv;
}

char *
ropen(Fid *f)
{
	if(f-&gt;flags &amp; Open)
		return Eisopen;

	if(thdr.mode != OREAD &amp;&amp; FILE(f-&gt;qid.path) != Qctl)
		return Eperm;
	rhdr.iounit = 0;
	rhdr.qid = f-&gt;qid;
	f-&gt;flags |= Open;
	f-&gt;flags &amp;= ~Endf;
	return nil;
}

char *
rcreate(Fid*)
{
	return Eperm;
}

static long
fileinfo(char *buf, int bufsize, int onum, int t)
{
	long n;

	n = 0;
	switch(t){
	case Qchildren:
		n = printchildren(buf, bufsize, otab[onum]);
		break;
	case Qdigest:
		n = printdigest(buf, bufsize, otab[onum]);
		break;
	case Qfulltext:
		n = printfulltext(buf, bufsize, otab[onum]);
		break;
	case Qkey:
		n = printkey(buf, bufsize, otab[onum]);
		break;
	case Qparent:
		n = printparent(buf, bufsize, otab[onum]);
		break;
	case Qtext:
		n = printtext(buf, bufsize, otab[onum]);
		break;
	case Qtype:
		n = printtype(buf, bufsize, otab[onum]);
		break;
	case Qfiles:
		n = printfiles(buf, bufsize, otab[onum]);
		break;
	case Qparentage:
		n = printparentage(buf, bufsize, otab[onum]);
		break;
	case Qminiparentage:
		n = printminiparentage(buf, bufsize, otab[onum]);
		break;
	default:
		sysfatal("rread: %d", t);
	}
	return n;
}

static void
mkstat(Dir *d, int n, int t)
{
	static char buf[16];

	d-&gt;uid = user;
	d-&gt;gid = user;
	d-&gt;muid = user;
	d-&gt;qid.vers = 0;
	d-&gt;qid.type = QTFILE;
	d-&gt;type = 0;
	d-&gt;dev = 0;
	d-&gt;atime = time(0);
	d-&gt;mtime = d-&gt;atime;
	switch(t){
	case Qtop:
		d-&gt;name = ".";
		d-&gt;mode = DMDIR|0555;
		d-&gt;atime = d-&gt;mtime = time(0);
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qtop);
		d-&gt;qid.type = QTDIR;
		break;
	case Qclassical:
		d-&gt;name = "juke";
		d-&gt;mode = DMDIR|0555;
		d-&gt;atime = d-&gt;mtime = time(0);
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qclassical);
		d-&gt;qid.type = QTDIR;
		break;
	case Qdir:
		snprint(buf, sizeof buf, "%d", n);
		d-&gt;name = buf;
		d-&gt;mode = DMDIR|0555;
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(n, Qdir);
		d-&gt;qid.type = QTDIR;
		break;
	case Qroot:
		d-&gt;name = "root";
		d-&gt;mode = DMDIR|0555;
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qroot);
		d-&gt;qid.type = QTDIR;
		break;
	case Qctl:
		d-&gt;name = "ctl";
		d-&gt;mode = 0666;
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qctl);
		break;
		d-&gt;name = "ctl";
		d-&gt;mode = 0666;
		d-&gt;length = 0;
		d-&gt;qid.path = PATH(0, Qctl);
		break;
	case Qchildren:
	case Qdigest:
	case Qfiles:
	case Qfulltext:
	case Qkey:
	case Qminiparentage:
	case Qparent:
	case Qparentage:
	case Qtext:
	case Qtype:
		d-&gt;name = dirtab[t];
		d-&gt;mode = 0444;
		d-&gt;length = fileinfo(bigbuf, sizeof bigbuf, n, t);
		d-&gt;qid.path = PATH(n, t);
		break;
	default:
		sysfatal("mkstat: %d", t);
	}
}

int
readtopdir(Fid*, uchar *buf, long off, int cnt, int blen)
{
	int m, n;
	Dir d;

	n = 0;
	mkstat(&amp;d, 0, Qclassical);
	m = convD2M(&amp;d, &amp;buf[n], blen);
	if(off &lt;= 0){
		if(m &lt;= BIT16SZ || m &gt; cnt)
			return n;
		n += m;
	}
	return n;
}

int
readclasdir(Fid*, uchar *buf, long off, int cnt, int blen)
{
	int m, n;
	long pos;
	Dir d;
	Fid *fid;

	n = 0;
	pos = 0;
	mkstat(&amp;d, 0, Qctl);
	m = convD2M(&amp;d, &amp;buf[n], blen);
	if(off &lt;= pos){
		if(m &lt;= BIT16SZ || m &gt; cnt)
			return 0;
		n += m;
		cnt -= m;
	}
	pos += m;
	mkstat(&amp;d, 0, Qroot);
	m = convD2M(&amp;d, &amp;buf[n], blen);
	if(off &lt;= pos){
		if(m &lt;= BIT16SZ || m &gt; cnt)
			return n;
		n += m;
		cnt -= m;
	}
	pos += m;
	for (fid = fids; fid; fid = fid-&gt;next){
		if(FILE(fid-&gt;qid.path) != Qdir)
			continue;
		mkstat(&amp;d, NUM(fid-&gt;qid.path), Qdir);
		m = convD2M(&amp;d, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}
	return n;
}

int
readdir(Fid *f, uchar *buf, long off, int cnt, int blen)
{
	int i, m, n;
	long pos;
	Dir d;

	n = 0;
	pos = 0;
	for (i = 0; i &lt; Qtop; i++){
		mkstat(&amp;d, NUM(f-&gt;qid.path), i);
		m = convD2M(&amp;d, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}
	return n;
}

void
readbuf(char *s, long n)
{
	rhdr.count = thdr.count;
	if(thdr.offset &gt;= n){
		rhdr.count = 0;
		return;
	}
	if(thdr.offset+rhdr.count &gt; n)
		rhdr.count = n - thdr.offset;
	rhdr.data = s + thdr.offset;
}

char*
rread(Fid *f)
{
	long off;
	int n, cnt, t;

	rhdr.count = 0;
	off = thdr.offset;
	cnt = thdr.count;

	if(cnt &gt; messagesize - IOHDRSZ)
		cnt = messagesize - IOHDRSZ;

	rhdr.data = (char*)mbuf;

	n = 0;
	t = FILE(f-&gt;qid.path);
	switch(t){
	case Qtop:
		n = readtopdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
		rhdr.count = n;
		return nil;
	case Qclassical:
		n = readclasdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
		rhdr.count = n;
		return nil;
	case Qdir:
	case Qroot:
		n = readdir(f, mbuf, off, cnt, messagesize - IOHDRSZ);
		rhdr.count = n;
		return nil;
	case Qctl:
		snprint(bigbuf, sizeof bigbuf, "%d objects in tree (%d holes)\n", notab, hotab);
		break;
	case Qchildren:
	case Qdigest:
	case Qfiles:
	case Qfulltext:
	case Qkey:
	case Qminiparentage:
	case Qparent:
	case Qparentage:
	case Qtext:
	case Qtype:
		n = fileinfo(bigbuf, sizeof bigbuf, NUM(f-&gt;qid.path), t);
		break;
	default:
		sysfatal("rread: %d", t);
	}
	readbuf(bigbuf, n);
	return nil;
}

char*
rwrite(Fid *f)
{
	long cnt;
	char *p;

	if(FILE(f-&gt;qid.path) != Qctl)
		return Eperm;
	rhdr.count = 0;
	cnt = thdr.count;
	if(p = strchr(thdr.data, '\n'))
		*p = '\0';
	if(strncmp(thdr.data, "quit", cnt) == 0)
		threadexitsall(nil);
	else if(strncmp(thdr.data, "reread", cnt) == 0)
		reread();
	else
		return "illegal command";
	rhdr.count = thdr.count;
	return nil;
}

char *
rclunk(Fid *f)
{
	f-&gt;flags &amp;= ~(Open|Busy);
	return 0;
}

char *
rremove(Fid *)
{
	return Eperm;
}

char *
rstat(Fid *f)
{
	Dir d;

	mkstat(&amp;d, NUM(f-&gt;qid.path), FILE(f-&gt;qid.path));
	rhdr.nstat = convD2M(&amp;d, mbuf, messagesize - IOHDRSZ);
	rhdr.stat = mbuf;
	return 0;
}

char *
rwstat(Fid*)
{
	return Eperm;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = nil;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid){
			return f;
		}else if(ff == nil &amp;&amp; (f-&gt;flags &amp; Busy) == 0)
			ff = f;
	if(ff == nil){
		ff = malloc(sizeof *ff);
		if (ff == nil)
			sysfatal("malloc: %r");
		memset(ff, 0, sizeof *ff);
		ff-&gt;next = fids;
		fids = ff;
	}
	ff-&gt;fid = fid;
	return ff;
}

void
io(void *)
{
	char *err, e[32];
	int n;
	extern int p[];
	Fid *f;

	threadsetname("file server");
	close(p[1]);
	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		n = read9pmsg(mfd[0], mdata, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0){
			rerrstr(e, sizeof e);
			if (strcmp(e, "interrupted") == 0){
				if (debug &amp; DbgFs) fprint(2, "read9pmsg interrupted\n");
				continue;
			}
			return;
		}
		if(convM2S(mdata, n, &amp;thdr) == 0)
			continue;

		if(debug &amp; DbgFs)
			fprint(2, "io:&lt;-%F\n", &amp;thdr);

		rhdr.data = (char*)mbuf;

		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else {
			f = newfid(thdr.fid);
			err = (*fcalls[thdr.type])(f);
		}
		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		if(debug &amp; DbgFs)
			fprint(2, "io:-&gt;%F\n", &amp;rhdr);/**/
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(write(mfd[1], mdata, n) != n)
			sysfatal("mount write");
	}
	threadexitsall("die yankee pig dog");
}

int
newid(void)
{
	int rv;
	static int id;
	static Lock idlock;

	lock(&amp;idlock);
	rv = ++id;
	unlock(&amp;idlock);

	return rv;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

