<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/playlistfs/playlist.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/playlistfs/playlist.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
typedef struct Worker Worker;
typedef struct Req Req;
typedef struct Fid Fid;
typedef struct File File;
typedef struct Playlist Playlist;
typedef struct Wmsg Wmsg;
typedef union Pmsg Pmsg;
typedef struct Pacbuf Pacbuf;

enum {
	Qdir,
	Qplayctl,
	Qplaylist,
	Qplayvol,
	Qplaystat,
	Nqid,
};

enum {
	DbgPcm		= 0x01000,
	DbgPac		= 0x02000,
	DbgFs		= 0x10000,
	DbgWorker	= 0x20000,
	DbgPlayer	= 0x40000,
	DbgError	= 0x80000,
};

enum {
	STACKSIZE = 2048*sizeof(void*),
	Messagesize = 8*1024+IOHDRSZ,
	Undef = 0x80000000,
	/* 256 buffers of 4096 bytes represents 5.9 seconds
	 * of playout at 44100 Hz (2*16bit samples)
	 */
	NPacbuf = 256,
	Pacbufsize = 4096,
	NSparebuf = 16,	/* For in-line commands (Pause, Resume, Error) */
};

enum {
	/* Named commands (see fs.c): */
	Nostate,	// can't use zero for state
	Error,
	Stop,
	Pause,
	Play,
	Resume,
	Skip,
	/* Unnamed commands */
	Work,
	Check,
	Flush,
	Prep,
	Preq,
};

union Pmsg {
	ulong m;
	struct{
		ushort cmd;
		ushort off;
	};
};

struct Wmsg {
	Pmsg;
	void	*arg;	/* if(cmd != Work) mallocated by sender, freed by receiver */
};

struct Playlist {
	/* The play list consists of a sequence of {objectref, filename}
	 * entries.  Object ref and file name are separated by a tab.
	 * An object ref may not contain a tab.  Entries are seperated
	 * by newline characters.  Neither file names, nor object refs
	 * may contain newlines.
	 */
	ulong	*lines;
	ulong	nlines;
	char	*data;
	ulong	ndata;
};

struct File {
	Dir	dir;
	Channel	*workers;
};

struct Worker
{
	Req	*r;
	Channel	*eventc;
};

struct Fid
{
	int	fid;
	File	*file;
	ushort	flags;
	short	readers;
	ulong	vers;	/* set to file's version when completely read */
	Fid	*next;
};

struct Req
{
	uchar	indata[Messagesize];
	uchar	outdata[Messagesize];
	Fcall	ifcall;
	Fcall	ofcall;
	Fid*	fid;
};

struct Pacbuf {
	Pmsg;
	int len;
	char data[Pacbufsize];
};

void	allocwork(Req*);
Wmsg	waitmsg(Worker*, Channel*);
int	sendmsg(Channel*, Wmsg*);
void	bcastmsg(Channel*, Wmsg*);
void	reqfree(Req*);
Req	*reqalloc(void);
void	readbuf(Req*, void*, long);
void	readstr(Req*, char*);
void	volumeset(int *v);
void	playupdate(Pmsg, char*);
void	playinit(void);
void	volumeproc(void*);
void	srv(void *);
long	robustread(int, void*, long);
void	volumeupdate(int*);
char	*getplaylist(int);
char	*getplaystat(char*, char*);

extern int		debug, aflag;
extern char	*user;
extern Channel	*playc;
extern char	*statetxt[];
extern int		volume[8];
extern Playlist	playlist;
extern Channel	*workers;
extern Channel	*volumechan;
extern Channel	*playchan;
extern Channel	*playlistreq;
extern File	files[];
extern int		srvfd[];
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

