<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/playlistfs/volume.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/playlistfs/volume.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include "pool.h"
#include "playlist.h"

int	minvolume, maxvolume;

void
volumeproc(void *)
{
	int fd, n, nf, i, nlines;
	static char buf[1024];
	char *lines[32];
	char *fields[8];
	char *subfields[9];
	int volume[8], nvolumes;

	threadsetname("volumeproc");
	close(srvfd[1]);
	fd = open("/dev/audioctl", OREAD);
	if (fd &lt; 0)
		threadexits(nil);
	for(;;){
		n = read(fd, buf, sizeof buf -1);
		if (n == 0)
			continue;
		if (n &lt; 0){
			fprint(2, "volumeproc: read: %r\n");
			threadexits("volumeproc");
		}
		buf[n] = '\0';
		nlines = getfields(buf, lines, nelem(lines), 1, "\n");
		for(i = 0; i &lt; nlines; i++){
			nf = tokenize(lines[i], fields, nelem(fields));
			if (nf == 0)
				continue;
			if (nf != 6 || strcmp(fields[0], "volume") || strcmp(fields[1], "out"))
				continue;
			minvolume = strtol(fields[3], nil, 0);
			maxvolume = strtol(fields[4], nil, 0);
			if (minvolume &gt;= maxvolume)
				continue;
			nvolumes = tokenize(fields[2], subfields, nelem(subfields));
			if (nvolumes &lt;= 0 || nvolumes &gt; 8)
				sysfatal("bad volume data");
			if (debug)
				fprint(2, "volume changed to '");
			for (i = 0; i &lt; nvolumes; i++){
				volume[i] = strtol(subfields[i], nil, 0);
				volume[i]= 100*(volume[i]- minvolume)/(maxvolume-minvolume);
				if (debug)
					fprint(2, " %d", volume[i]);
			}
			if (debug)
				fprint(2, "'\n");
			while (i &lt; 8)
				volume[i++] = Undef;
			send(volumechan, volume);
		}
	}
}

void
volumeset(int *v)
{
	int fd, i;
	char buf[256], *p;

	fd = open("/dev/audioctl", OWRITE);
	if (fd &lt; 0){
		fd = open("/dev/volume", OWRITE);
		if (fd &lt; 0){
			fprint(2, "Can't set volume: %r");
			return;
		}
		fprint(fd, "audio out %d",  v[0]);
		send(volumechan, v);
	} else {
		p = buf;
		for (i = 0; i &lt; 8; i++){
			if (v[i] == Undef) break;
			p = seprint(p, buf+sizeof buf, (p==buf)?"volume out '%d":" %d",
				minvolume + v[i] * (maxvolume-minvolume) / 100);
		}
		p = seprint(p, buf+sizeof buf, "'\n");
		write(fd, buf, p-buf);
	}
	close(fd);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

