<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/sudoku/sudoku.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/sudoku/sudoku.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* code from mark huckvale: http://www.phon.ucl.ac.uk/home/mark/sudoku/ */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

#include "sudoku.h"

char *imgdir = "/sys/games/lib/sudoku/images";
char *lvldir = "/sys/games/lib/sudoku/boards";	/* level library dir */

int selected;	/* which digit do we have selected? */

Image *background;	/* DPaleyellow */
Image *backselect;	/* DPalebluegreen */
Image *blink;		/* DDarkyellow */
Image *brdr;		/* 0x55555555 */
Image *fixed;		/* DBlue */
Image *wrong;		/* DRed */
Image *dig[10];		/* digit masks */

Dir *dir;
int numlevels;
int curlevel;

char *buttons[] = 
{
	"new",
	"check",
	"solve",
	"clear",
	"save",
	"load",
	"print",
	"offline",
	"exit",
	0
};

Menu menu = 
{
	buttons
};

Menu lmenu =
{
	nil,
	genlevels,
	0,
};

int
readlevels(char *leveldir)
{
	int fd, n;

	if((fd = open(leveldir, OREAD)) &lt; 0)
		return -1;

	n = dirreadall(fd, &amp;dir);
	close(fd);

	return n;	
}

char *
genlevels(int i)
{
	if(numlevels == 0)
		numlevels = readlevels(lvldir);
	
	if(numlevels &gt; 0 &amp;&amp; i &lt; numlevels)
		return (dir+i)-&gt;name;

	return nil;
}

void
convert(Cell *brd, int *board)
{
	int i;
	
	for(i = 0; i &lt; Psize; i++) {
		brd[i].digit = board[i] &amp; Digit;
		if(brd[i].digit &lt; 0 || brd[i].digit &gt; 9)
			brd[i].digit = -1;
		brd[i].solve = (board[i] &amp; Solve) &gt;&gt; 4;
		brd[i].locked = board[i] &amp; MLock;
	}
	memcpy(obrd, brd, Psize * sizeof(Cell));
}

Image *
eallocimage(Rectangle r, int repl, uint color)
{
	Image *tmp;

	tmp = allocimage(display, r, screen-&gt;chan, repl, color);
	if(tmp == nil)
		sysfatal("cannot allocate buffer image: %r");

	return tmp;
}

Image *
eloadfile(char *path)
{
	Image *img;
	int fd;

	fd = open(path, OREAD);
	if(fd &lt; 0) {
		fprint(2, "cannot open image file %s: %r\n", path);
		exits("image");
	}
	img = readimage(display, fd, 0);
	if(img == nil)
		sysfatal("cannot load image: %r");
	close(fd);
	
	return img;
}


void
clearboard(Cell *board)
{
	int i;
	
	for(i = 0; i &lt; Psize; i++) {
		board[i].digit = -1;
		board[i].solve = 0;
		board[i].locked = 0;
	}
}

void
solveboard(Cell *board)
{
	int i;

	for(i = 0; i &lt; Psize; i++) {
		board[i].digit = board[i].solve;
	}
}


int
checkpossible(Cell *board, int x, int y, int num)
{
	int i, j;

	for(i = 0; i &lt; Brdsize; i++) {
		if(board[i*Brdsize + y].digit == num &amp;&amp; i != x)
			return 0;
		if(board[x*Brdsize + i].digit == num &amp;&amp; i != y)	
			return 0;
	}

	for(i = x - (x%3); i &lt; x - (x%3) + 3; i++)
		for(j = y - (y%3); j &lt; y - (y%3) + 3; j++)
			if((i != x &amp;&amp; j != y) &amp;&amp; board[i*Brdsize + j].digit == num)
				return 0;

	return 1;
}

void
resize(void)
{
	int fd;

	fd = open("/dev/wctl", OWRITE);
	if(fd &gt;= 0){
		fprint(fd, "resize -dx %d -dy %d", Maxx, Maxy);
		close(fd);
	}

}

void
drawcell(int x, int y, int num, Image *col)
{
	Rectangle r = Rect(x*Square, y*Square, (x+1)*Square, (y+1)*Square);

	if(num &lt; 0 || num &gt; 9)
		return;

	r = insetrect(r, Border);
	r = rectaddpt(r, Pt(0, Square));
	r.max = addpt(r.max, Pt(2, 2));
	
	draw(screen, rectaddpt(r, screen-&gt;r.min), col, dig[num], ZP);
}

void
drawboard(void)
{
	int i;

	for(i = 0; i &lt; Psize; i++) {
		drawcell(i / Brdsize, i % Brdsize, brd[i].digit, brd[i].locked ? fixed : display-&gt;black);
	}
}

void
drawchecked(Cell *brd)
{
	int i;

	for(i = 0; i &lt; Psize; i++) {
		if(brd[i].locked)
			drawcell(i / Brdsize, i % Brdsize, brd[i].digit, fixed);
		else 
			drawcell(i / Brdsize, i % Brdsize, brd[i].digit, 
					checkpossible(brd, i / Brdsize, i % Brdsize, brd[i].digit) ? display-&gt;black : wrong);
	}
}

void
drawscreen(void)
{
	Point l1, l2;
	int i;

	draw(screen, screen-&gt;r, brdr, nil, ZP);
	draw(screen, insetrect(screen-&gt;r, Border), background, nil, ZP);
	for(i = 0; i &lt; Brdsize; i++) {
		l1 = addpt(screen-&gt;r.min, Pt(i*Square, Square));
		l2 = addpt(screen-&gt;r.min, Pt(i*Square, Maxy));
		line(screen, l1, l2, Endsquare, Endsquare, (i%3) == 0 ? Thickline : Line, brdr, ZP); 
		l1 = addpt(screen-&gt;r.min, Pt(0, (i+1)*Square));
		l2 = addpt(screen-&gt;r.min, Pt(Maxx, (i+1)*Square));
		line(screen, l1, l2, Endsquare, Endsquare, (i%3) == 0 ? Thickline : Line, brdr, ZP); 
	}
	for(i = 1; i &lt; 10; i++) {
		drawbar(i, (selected == i) ? 1 : 0);
	}
	drawboard();
	flushimage(display, 1);
}


void
drawbar(int digit, int selected)
{
	Rectangle r = Rect((digit - 1)*Square, 0, digit*Square, Square);

	if(digit &lt; 1 || digit &gt; 9)
		return;

	r = insetrect(r, Border);
	r.max = addpt(r.max, Pt(2, 2));
	draw(screen, rectaddpt(r, screen-&gt;r.min), selected ? backselect : background, nil, ZP);
	draw(screen, rectaddpt(r, screen-&gt;r.min), display-&gt;black, dig[digit-1], ZP);
}

void
eresized(int new)
{
	Point p;
	char path[256];
	int i;

	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0)
		sysfatal("can't reattach to window");
	
	if(background == nil) 
		background = eallocimage(Rect(0, 0, 1, 1), 1, DPaleyellow);
	if(backselect == nil) 
		backselect = eallocimage(Rect(0, 0, 1, 1), 1, DPalebluegreen);
	if(blink == nil) 
		blink = eallocimage(Rect(0, 0, 1, 1), 1, DDarkyellow);
	if(brdr == nil)
		brdr = eallocimage(Rect(0, 0, 1, 1), 1, 0x55555555);
	if(fixed == nil)
		fixed = eallocimage(Rect(0, 0, 1, 1), 1, DBlue);
	if(wrong == nil)
		wrong = eallocimage(Rect(0, 0, 1, 1), 1, DRed);
	if(dig[0] == nil) {
		for(i = 0; i &lt; 9; i++) {
			snprint(path, 256, "%s/%d.bit", imgdir, i+1);
			dig[i] = eloadfile(path);
		}
	}

	p = Pt(Dx(screen-&gt;r), Dy(screen-&gt;r));
	if(!new || !eqpt(p, Pt(Maxx - 8, Maxy - 8)))
		resize();

	drawscreen();
}

void
main(int argc, char *argv[])
{
	Mouse m;
	Event e;
	Point p;
	int last1 = 0;	/* was the button clicked last time? */

	USED(argc, argv);

	if(initdraw(nil, nil, "sudoku") &lt; 0)
		sysfatal("initdraw failed: %r");

	einit(Emouse|Ekeyboard);


	clearboard(brd);
	eresized(0);

	srand(time(0)*getpid());
	makep();
	convert(brd, board);

	drawscreen();
	for(;;) {
		switch(event(&amp;e)) {
		case Emouse:
			m = e.mouse;
			if(m.buttons&amp;1) {
				if(last1 == 0) {
					last1 = 1;
					p = subpt(m.xy, screen-&gt;r.min);
					if(ptinrect(p, Rect(0, 0, Maxx, Square+Border))) {
						if(p.x/Square == selected - 1) {
							drawbar(selected, 0);
							selected = 0;
						} else {
							selected = p.x/Square + 1;
						}
					} else {
						Point lp = divpt(p, Square);
						lp.y--;

						if(brd[lp.x * Brdsize + lp.y].locked)
							break;

						if(selected) {
							brd[lp.x * Brdsize + lp.y].digit = selected - 1;
						} else {
							brd[lp.x * Brdsize + lp.y].digit = -1;
						}			
					}
					drawscreen();
				}
			} else {
				last1 = 0;
			}

			if(m.buttons&amp;2) {
				char *str;
				int l;
				/* levels start from 1 */
				lmenu.lasthit = curlevel;
				l = emenuhit(2, &amp;m, &amp;lmenu);
				if(l &gt;= 0){
					curlevel = l;
					str = smprint("%s/%s", lvldir, (dir+curlevel)-&gt;name);
					if(loadlevel(str, brd) &lt; 0)
						clearboard(brd);
					memcpy(obrd, brd, Psize * sizeof(Cell));
					free(str);
				}
				drawscreen();
			}
			if(m.buttons&amp;4) {
				switch(emenuhit(3, &amp;m, &amp;menu)) {
				case 0: 	/* new */
					makep();
					convert(brd, board);
					drawscreen();
					break;
				case 1:		/* solve */
					drawchecked(brd);
					break;
				case 2:		/* solve */
					solveboard(brd);
					drawscreen();
					break;
				case 3:		/* clear */
					memcpy(brd, obrd, Psize * sizeof(Cell));
					drawscreen();
					break;
				case 4:		/* save */
					savegame(brd);
					drawscreen();
					break;
				case 5:		/* load */
					if(loadgame(brd) &lt; 0) {
						clearboard(brd);
					}
					memcpy(obrd, brd, Psize * sizeof(Cell));
					drawscreen();
					break;
				case 6:		/* print */
					printboard(brd);
					break;
				case 7:		/* offline */
					fprettyprintbrd(brd);
					break;
				case 8:		/* exit */
					exits(nil);
				}
			}
			break;

		case Ekeyboard:
			switch(e.kbdc) {
			case 127:
			case 'q':
			case 'Q':
				exits(nil);
			default:
				break;
			}
			break;
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

