<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/lib9p/srv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/lib9p/srv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

void (*_forker)(void(*)(void*), void*, int);

static char Ebadattach[] = "unknown specifier in attach";
static char Ebadoffset[] = "bad offset";
static char Ebadcount[] = "bad count";
static char Ebotch[] = "9P protocol botch";
static char Ecreatenondir[] = "create in non-directory";
static char Edupfid[] = "duplicate fid";
static char Eduptag[] = "duplicate tag";
static char Eisdir[] = "is a directory";
static char Enocreate[] = "create prohibited";
static char Enomem[] = "out of memory";
static char Enoremove[] = "remove prohibited";
static char Enostat[] = "stat prohibited";
static char Enotfound[] = "file not found";
static char Enowrite[] = "write prohibited";
static char Enowstat[] = "wstat prohibited";
static char Eperm[] = "permission denied";
static char Eunknownfid[] = "unknown fid";
static char Ebaddir[] = "bad directory in wstat";
static char Ewalknodir[] = "walk in non-directory";

static void
setfcallerror(Fcall *f, char *err)
{
	f-&gt;ename = err;
	f-&gt;type = Rerror;
}

static void
changemsize(Srv *srv, int msize)
{
	if(srv-&gt;rbuf &amp;&amp; srv-&gt;wbuf &amp;&amp; srv-&gt;msize == msize)
		return;
	qlock(&amp;srv-&gt;rlock);
	qlock(&amp;srv-&gt;wlock);
	srv-&gt;msize = msize;
	free(srv-&gt;rbuf);
	free(srv-&gt;wbuf);
	srv-&gt;rbuf = emalloc9p(msize);
	srv-&gt;wbuf = emalloc9p(msize);
	qunlock(&amp;srv-&gt;rlock);
	qunlock(&amp;srv-&gt;wlock);
}

static Req*
getreq(Srv *s)
{
	long n;
	uchar *buf;
	Fcall f;
	Req *r;

	qlock(&amp;s-&gt;rlock);
	if((n = read9pmsg(s-&gt;infd, s-&gt;rbuf, s-&gt;msize)) &lt;= 0){
		qunlock(&amp;s-&gt;rlock);
		return nil;
	}

	buf = emalloc9p(n);
	memmove(buf, s-&gt;rbuf, n);
	qunlock(&amp;s-&gt;rlock);

	if(convM2S(buf, n, &amp;f) != n){
		free(buf);
		return nil;
	}

	if((r=allocreq(s-&gt;rpool, f.tag)) == nil){	/* duplicate tag: cons up a fake Req */
		r = emalloc9p(sizeof *r);
		incref(&amp;r-&gt;ref);
		r-&gt;tag = f.tag;
		r-&gt;ifcall = f;
		r-&gt;error = Eduptag;
		r-&gt;buf = buf;
		r-&gt;responded = 0;
		r-&gt;type = 0;
		r-&gt;srv = s;
		r-&gt;pool = nil;
if(chatty9p)
	fprint(2, "&lt;-%d- %F: dup tag\n", s-&gt;infd, &amp;f);
		return r;
	}

	r-&gt;srv = s;
	r-&gt;responded = 0;
	r-&gt;buf = buf;
	r-&gt;ifcall = f;
	memset(&amp;r-&gt;ofcall, 0, sizeof r-&gt;ofcall);
	r-&gt;type = r-&gt;ifcall.type;

if(chatty9p)
	if(r-&gt;error)
		fprint(2, "&lt;-%d- %F: %s\n", s-&gt;infd, &amp;r-&gt;ifcall, r-&gt;error);
	else	
		fprint(2, "&lt;-%d- %F\n", s-&gt;infd, &amp;r-&gt;ifcall);

	return r;
}

static void
filewalk(Req *r)
{
	int i;
	File *f;

	f = r-&gt;fid-&gt;file;
	assert(f != nil);

	incref(f);
	for(i=0; i&lt;r-&gt;ifcall.nwname; i++)
		if(f = walkfile(f, r-&gt;ifcall.wname[i]))
			r-&gt;ofcall.wqid[i] = f-&gt;qid;
		else
			break;

	r-&gt;ofcall.nwqid = i;
	if(f){
		r-&gt;newfid-&gt;file = f;
		r-&gt;newfid-&gt;qid = r-&gt;newfid-&gt;file-&gt;qid;
	}
	respond(r, nil);
}

void
walkandclone(Req *r, char *(*walk1)(Fid*, char*, void*), char *(*clone)(Fid*, Fid*, void*), void *arg)
{
	int i;
	char *e;

	if(r-&gt;fid == r-&gt;newfid &amp;&amp; r-&gt;ifcall.nwname &gt; 1){
		respond(r, "lib9p: unused documented feature not implemented");
		return;
	}

	if(r-&gt;fid != r-&gt;newfid){
		r-&gt;newfid-&gt;qid = r-&gt;fid-&gt;qid;
		if(clone &amp;&amp; (e = clone(r-&gt;fid, r-&gt;newfid, arg))){
			respond(r, e);
			return;
		}
	}

	e = nil;
	for(i=0; i&lt;r-&gt;ifcall.nwname; i++){
		if(e = walk1(r-&gt;newfid, r-&gt;ifcall.wname[i], arg))
			break;
		r-&gt;ofcall.wqid[i] = r-&gt;newfid-&gt;qid;
	}

	r-&gt;ofcall.nwqid = i;
	if(e &amp;&amp; i==0)
		respond(r, e);
	else
		respond(r, nil);
}

static void
sversion(Srv*, Req *r)
{
	if(strncmp(r-&gt;ifcall.version, "9P", 2) != 0){
		r-&gt;ofcall.version = "unknown";
		respond(r, nil);
		return;
	}

	r-&gt;ofcall.version = "9P2000";
	r-&gt;ofcall.msize = r-&gt;ifcall.msize;
	respond(r, nil);
}
static void
rversion(Req *r, char *error)
{
	assert(error == nil);
	changemsize(r-&gt;srv, r-&gt;ofcall.msize);
}

static void
sauth(Srv *srv, Req *r)
{
	char e[ERRMAX];

	if((r-&gt;afid = allocfid(srv-&gt;fpool, r-&gt;ifcall.afid)) == nil){
		respond(r, Edupfid);
		return;
	}
	if(srv-&gt;auth)
		srv-&gt;auth(r);
	else{
		snprint(e, sizeof e, "%s: authentication not required", argv0);
		respond(r, e);
	}
}
static void
rauth(Req *r, char *error)
{
	if(error &amp;&amp; r-&gt;afid)
		closefid(removefid(r-&gt;srv-&gt;fpool, r-&gt;afid-&gt;fid));
}

static void
sattach(Srv *srv, Req *r)
{
	if((r-&gt;fid = allocfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Edupfid);
		return;
	}
	r-&gt;afid = nil;
	if(r-&gt;ifcall.afid != NOFID &amp;&amp; (r-&gt;afid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.afid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	r-&gt;fid-&gt;uid = estrdup9p(r-&gt;ifcall.uname);
	if(srv-&gt;tree){
		r-&gt;fid-&gt;file = srv-&gt;tree-&gt;root;
		incref(r-&gt;fid-&gt;file);
		r-&gt;ofcall.qid = r-&gt;fid-&gt;file-&gt;qid;
		r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	}
	if(srv-&gt;attach)
		srv-&gt;attach(r);
	else
		respond(r, nil);
	return;
}
static void
rattach(Req *r, char *error)
{
	if(error &amp;&amp; r-&gt;fid)
		closefid(removefid(r-&gt;srv-&gt;fpool, r-&gt;fid-&gt;fid));
}

static void
sflush(Srv *srv, Req *r)
{
	r-&gt;oldreq = lookupreq(srv-&gt;rpool, r-&gt;ifcall.oldtag);
	if(r-&gt;oldreq == nil || r-&gt;oldreq == r)
		respond(r, nil);
	else if(srv-&gt;flush)
		srv-&gt;flush(r);
	else
		respond(r, nil);
}
static int
rflush(Req *r, char *error)
{
	Req *or;

	assert(error == nil);
	or = r-&gt;oldreq;
	if(or){
		qlock(&amp;or-&gt;lk);
		if(or-&gt;responded == 0){
			or-&gt;flush = erealloc9p(or-&gt;flush, (or-&gt;nflush+1)*sizeof(or-&gt;flush[0]));
			or-&gt;flush[or-&gt;nflush++] = r;
			qunlock(&amp;or-&gt;lk);
			return -1;		/* delay response until or is responded */
		}
		qunlock(&amp;or-&gt;lk);
		closereq(or);
	}
	r-&gt;oldreq = nil;
	return 0;
}

static char*
oldwalk1(Fid *fid, char *name, void *arg)
{
	char *e;
	Qid qid;
	Srv *srv;

	srv = arg;
	e = srv-&gt;walk1(fid, name, &amp;qid);
	if(e)
		return e;
	fid-&gt;qid = qid;
	return nil;
}

static char*
oldclone(Fid *fid, Fid *newfid, void *arg)
{
	Srv *srv;

	srv = arg;
	if(srv-&gt;clone == nil)
		return nil;
	return srv-&gt;clone(fid, newfid);
}

static void
swalk(Srv *srv, Req *r)
{
	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	if(r-&gt;fid-&gt;omode != -1){
		respond(r, "cannot clone open fid");
		return;
	}
	if(r-&gt;ifcall.nwname &amp;&amp; !(r-&gt;fid-&gt;qid.type&amp;QTDIR)){
		respond(r, Ewalknodir);
		return;
	}
	if(r-&gt;ifcall.fid != r-&gt;ifcall.newfid){
		if((r-&gt;newfid = allocfid(srv-&gt;fpool, r-&gt;ifcall.newfid)) == nil){
			respond(r, Edupfid);
			return;
		}
		r-&gt;newfid-&gt;uid = estrdup9p(r-&gt;fid-&gt;uid);
	}else{
		incref(&amp;r-&gt;fid-&gt;ref);
		r-&gt;newfid = r-&gt;fid;
	}
	if(r-&gt;fid-&gt;file){
		filewalk(r);
	}else if(srv-&gt;walk1)
		walkandclone(r, oldwalk1, oldclone, srv);
	else if(srv-&gt;walk)
		srv-&gt;walk(r);
	else
		sysfatal("no walk function, no file trees");
}
static void
rwalk(Req *r, char *error)
{
	if(error || r-&gt;ofcall.nwqid &lt; r-&gt;ifcall.nwname){
		if(r-&gt;ifcall.fid != r-&gt;ifcall.newfid &amp;&amp; r-&gt;newfid)
			closefid(removefid(r-&gt;srv-&gt;fpool, r-&gt;newfid-&gt;fid));
		if (r-&gt;ofcall.nwqid==0){
			if(error==nil &amp;&amp; r-&gt;ifcall.nwname!=0)
				r-&gt;error = Enotfound;
		}else
			r-&gt;error = nil;	// No error on partial walks
	}else{
		if(r-&gt;ofcall.nwqid == 0){
			/* Just a clone */
			r-&gt;newfid-&gt;qid = r-&gt;fid-&gt;qid;
		}else{
			/* if file trees are in use, filewalk took care of the rest */
			r-&gt;newfid-&gt;qid = r-&gt;ofcall.wqid[r-&gt;ofcall.nwqid-1];
		}
	}
}

static void
sopen(Srv *srv, Req *r)
{
	int p;

	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	if(r-&gt;fid-&gt;omode != -1){
		respond(r, Ebotch);
		return;
	}
	if((r-&gt;fid-&gt;qid.type&amp;QTDIR) &amp;&amp; (r-&gt;ifcall.mode&amp;~ORCLOSE) != OREAD){
		respond(r, Eisdir);
		return;
	}
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	switch(r-&gt;ifcall.mode&amp;3){
	default:
		assert(0);
	case OREAD:
		p = AREAD;	
		break;
	case OWRITE:
		p = AWRITE;
		break;
	case ORDWR:
		p = AREAD|AWRITE;
		break;
	case OEXEC:
		p = AEXEC;	
		break;
	}
	if(r-&gt;ifcall.mode&amp;OTRUNC)
		p |= AWRITE;
	if((r-&gt;fid-&gt;qid.type&amp;QTDIR) &amp;&amp; p!=AREAD){
		respond(r, Eperm);
		return;
	}
	if(r-&gt;fid-&gt;file){
		if(!hasperm(r-&gt;fid-&gt;file, r-&gt;fid-&gt;uid, p)){
			respond(r, Eperm);
			return;
		}
	/* BUG RACE */
		if((r-&gt;ifcall.mode&amp;ORCLOSE)
		&amp;&amp; !hasperm(r-&gt;fid-&gt;file-&gt;parent, r-&gt;fid-&gt;uid, AWRITE)){
			respond(r, Eperm);
			return;
		}
		r-&gt;ofcall.qid = r-&gt;fid-&gt;file-&gt;qid;
		if((r-&gt;ofcall.qid.type&amp;QTDIR)
		&amp;&amp; (r-&gt;fid-&gt;rdir = opendirfile(r-&gt;fid-&gt;file)) == nil){
			respond(r, "opendirfile failed");
			return;
		}
	}
	if(srv-&gt;open)
		srv-&gt;open(r);
	else
		respond(r, nil);
}
static void
ropen(Req *r, char *error)
{
	char errbuf[ERRMAX];
	if(error)
		return;
	if(chatty9p){
		snprint(errbuf, sizeof errbuf, "fid mode is 0x%ux\n", r-&gt;ifcall.mode);
		write(2, errbuf, strlen(errbuf));
	}
	r-&gt;fid-&gt;omode = r-&gt;ifcall.mode;
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	if(r-&gt;ofcall.qid.type&amp;QTDIR)
		r-&gt;fid-&gt;diroffset = 0;
}

static void
screate(Srv *srv, Req *r)
{
	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil)
		respond(r, Eunknownfid);
	else if(r-&gt;fid-&gt;omode != -1)
		respond(r, Ebotch);
	else if(!(r-&gt;fid-&gt;qid.type&amp;QTDIR))
		respond(r, Ecreatenondir);
	else if(r-&gt;fid-&gt;file &amp;&amp; !hasperm(r-&gt;fid-&gt;file, r-&gt;fid-&gt;uid, AWRITE))
		respond(r, Eperm);
	else if(srv-&gt;create)
		srv-&gt;create(r);
	else
		respond(r, Enocreate);
}
static void
rcreate(Req *r, char *error)
{
	if(error)
		return;
	r-&gt;fid-&gt;omode = r-&gt;ifcall.mode;
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
}

static void
sread(Srv *srv, Req *r)
{
	int o;

	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	if((int)r-&gt;ifcall.count &lt; 0){
		respond(r, Ebotch);
		return;
	}
	if(r-&gt;ifcall.offset &lt; 0
	|| ((r-&gt;fid-&gt;qid.type&amp;QTDIR) &amp;&amp; r-&gt;ifcall.offset != 0 &amp;&amp; r-&gt;ifcall.offset != r-&gt;fid-&gt;diroffset)){
		respond(r, Ebadoffset);
		return;
	}

	if(r-&gt;ifcall.count &gt; srv-&gt;msize - IOHDRSZ)
		r-&gt;ifcall.count = srv-&gt;msize - IOHDRSZ;
	r-&gt;rbuf = emalloc9p(r-&gt;ifcall.count);
	r-&gt;ofcall.data = r-&gt;rbuf;
	o = r-&gt;fid-&gt;omode &amp; 3;
	if(o != OREAD &amp;&amp; o != ORDWR &amp;&amp; o != OEXEC){
		respond(r, Ebotch);
		return;
	}
	if((r-&gt;fid-&gt;qid.type&amp;QTDIR) &amp;&amp; r-&gt;fid-&gt;file){
		r-&gt;ofcall.count = readdirfile(r-&gt;fid-&gt;rdir, r-&gt;rbuf, r-&gt;ifcall.count);
		respond(r, nil);
		return;
	}
	if(srv-&gt;read)
		srv-&gt;read(r);
	else
		respond(r, "no srv-&gt;read");
}
static void
rread(Req *r, char *error)
{
	if(error==nil &amp;&amp; (r-&gt;fid-&gt;qid.type&amp;QTDIR))
		r-&gt;fid-&gt;diroffset += r-&gt;ofcall.count;
}

static void
swrite(Srv *srv, Req *r)
{
	int o;
	char e[ERRMAX];

	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	if((int)r-&gt;ifcall.count &lt; 0){
		respond(r, Ebotch);
		return;
	}
	if(r-&gt;ifcall.offset &lt; 0){
		respond(r, Ebotch);
		return;
	}
	if(r-&gt;ifcall.count &gt; srv-&gt;msize - IOHDRSZ)
		r-&gt;ifcall.count = srv-&gt;msize - IOHDRSZ;
	o = r-&gt;fid-&gt;omode &amp; 3;
	if(o != OWRITE &amp;&amp; o != ORDWR){
		snprint(e, sizeof e, "write on fid with open mode 0x%ux", r-&gt;fid-&gt;omode);
		respond(r, e);
		return;
	}
	if(srv-&gt;write)
		srv-&gt;write(r);
	else
		respond(r, "no srv-&gt;write");
}
static void
rwrite(Req *r, char *error)
{
	if(error)
		return;
	if(r-&gt;fid-&gt;file)
		r-&gt;fid-&gt;file-&gt;qid.vers++;
}

static void
sclunk(Srv *srv, Req *r)
{
	if((r-&gt;fid = removefid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil)
		respond(r, Eunknownfid);
	else
		respond(r, nil);
}
static void
rclunk(Req*, char*)
{
}

static void
sremove(Srv *srv, Req *r)
{
	if((r-&gt;fid = removefid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	/* BUG RACE */
	if(r-&gt;fid-&gt;file &amp;&amp; !hasperm(r-&gt;fid-&gt;file-&gt;parent, r-&gt;fid-&gt;uid, AWRITE)){
		respond(r, Eperm);
		return;
	}
	if(srv-&gt;remove)
		srv-&gt;remove(r);
	else
		respond(r, r-&gt;fid-&gt;file ? nil : Enoremove);
}
static void
rremove(Req *r, char *error, char *errbuf)
{
	if(error)
		return;
	if(r-&gt;fid-&gt;file){
		if(removefile(r-&gt;fid-&gt;file) &lt; 0){
			snprint(errbuf, ERRMAX, "remove %s: %r", 
				r-&gt;fid-&gt;file-&gt;name);
			r-&gt;error = errbuf;
		}
		r-&gt;fid-&gt;file = nil;
	}
}

static void
sstat(Srv *srv, Req *r)
{
	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	if(r-&gt;fid-&gt;file){
		/* should we rlock the file? */
		r-&gt;d = r-&gt;fid-&gt;file-&gt;Dir;
		if(r-&gt;d.name)
			r-&gt;d.name = estrdup9p(r-&gt;d.name);
		if(r-&gt;d.uid)
			r-&gt;d.uid = estrdup9p(r-&gt;d.uid);
		if(r-&gt;d.gid)
			r-&gt;d.gid = estrdup9p(r-&gt;d.gid);
		if(r-&gt;d.muid)
			r-&gt;d.muid = estrdup9p(r-&gt;d.muid);
	}
	if(srv-&gt;stat)	
		srv-&gt;stat(r);	
	else if(r-&gt;fid-&gt;file)
		respond(r, nil);
	else
		respond(r, Enostat);
}
static void
rstat(Req *r, char *error)
{
	int n;
	uchar *statbuf;
	uchar tmp[BIT16SZ];

	if(error)
		return;
	if(convD2M(&amp;r-&gt;d, tmp, BIT16SZ) != BIT16SZ){
		r-&gt;error = "convD2M(_,_,BIT16SZ) did not return BIT16SZ";
		return;
	}
	n = GBIT16(tmp)+BIT16SZ;
	statbuf = emalloc9p(n);
	if(statbuf == nil){
		r-&gt;error = "out of memory";
		return;
	}
	r-&gt;ofcall.nstat = convD2M(&amp;r-&gt;d, statbuf, n);
	r-&gt;ofcall.stat = statbuf;	/* freed in closereq */
	if(r-&gt;ofcall.nstat &lt;= BIT16SZ){
		r-&gt;error = "convD2M fails";
		free(statbuf);
		return;
	}
}

static void
swstat(Srv *srv, Req *r)
{
	if((r-&gt;fid = lookupfid(srv-&gt;fpool, r-&gt;ifcall.fid)) == nil){
		respond(r, Eunknownfid);
		return;
	}
	if(srv-&gt;wstat == nil){
		respond(r, Enowstat);
		return;
	}
	if(convM2D(r-&gt;ifcall.stat, r-&gt;ifcall.nstat, &amp;r-&gt;d, (char*)r-&gt;ifcall.stat) != r-&gt;ifcall.nstat){
		respond(r, Ebaddir);
		return;
	}
	if((ushort)~r-&gt;d.type){
		respond(r, "wstat -- attempt to change type");
		return;
	}
	if((uint)~r-&gt;d.dev){
		respond(r, "wstat -- attempt to change dev");
		return;
	}
	if((uchar)~r-&gt;d.qid.type || (ulong)~r-&gt;d.qid.vers || (uvlong)~r-&gt;d.qid.path){
		respond(r, "wstat -- attempt to change qid");
		return;
	}
	if(r-&gt;d.muid &amp;&amp; r-&gt;d.muid[0]){
		respond(r, "wstat -- attempt to change muid");
		return;
	}
	if((ulong)~r-&gt;d.mode &amp;&amp; ((r-&gt;d.mode&amp;DMDIR)&gt;&gt;24) != (r-&gt;fid-&gt;qid.type&amp;QTDIR)){
		respond(r, "wstat -- attempt to change DMDIR bit");
		return;
	}
	srv-&gt;wstat(r);
}
static void
rwstat(Req*, char*)
{
}

void
srv(Srv *srv)
{
	Req *r;

	fmtinstall('D', dirfmt);
	fmtinstall('F', fcallfmt);

	if(srv-&gt;fpool == nil)
		srv-&gt;fpool = allocfidpool(srv-&gt;destroyfid);
	if(srv-&gt;rpool == nil)
		srv-&gt;rpool = allocreqpool(srv-&gt;destroyreq);
	if(srv-&gt;msize == 0)
		srv-&gt;msize = 8192+IOHDRSZ;

	changemsize(srv, srv-&gt;msize);

	srv-&gt;fpool-&gt;srv = srv;
	srv-&gt;rpool-&gt;srv = srv;

	while(r = getreq(srv)){
		if(r-&gt;error){
			respond(r, r-&gt;error);
			continue;	
		}
		switch(r-&gt;ifcall.type){
		default:
			respond(r, "unknown message");
			break;
		case Tversion:	sversion(srv, r);	break;
		case Tauth:	sauth(srv, r);	break;
		case Tattach:	sattach(srv, r);	break;
		case Tflush:	sflush(srv, r);	break;
		case Twalk:	swalk(srv, r);	break;
		case Topen:	sopen(srv, r);	break;
		case Tcreate:	screate(srv, r);	break;
		case Tread:	sread(srv, r);	break;
		case Twrite:	swrite(srv, r);	break;
		case Tclunk:	sclunk(srv, r);	break;
		case Tremove:	sremove(srv, r);	break;
		case Tstat:	sstat(srv, r);	break;
		case Twstat:	swstat(srv, r);	break;
		}
	}

	free(srv-&gt;rbuf);
	srv-&gt;rbuf = nil;
	free(srv-&gt;wbuf);
	srv-&gt;wbuf = nil;
	srv-&gt;msize = 0;
	freefidpool(srv-&gt;fpool);
	srv-&gt;fpool = nil;
	freereqpool(srv-&gt;rpool);
	srv-&gt;rpool = nil;

	if(srv-&gt;end)
		srv-&gt;end(srv);
}

void
respond(Req *r, char *error)
{
	int i, m, n;
	char errbuf[ERRMAX];
	Srv *srv;

	srv = r-&gt;srv;
	assert(srv != nil);

	assert(r-&gt;responded == 0);
	r-&gt;error = error;

	switch(r-&gt;ifcall.type){
	default:
		assert(0);
	/*
	 * Flush is special.  If the handler says so, we return
	 * without further processing.  Respond will be called
	 * again once it is safe.
	 */
	case Tflush:
		if(rflush(r, error)&lt;0)
			return;
		break;
	case Tversion:	rversion(r, error);	break;
	case Tauth:	rauth(r, error);	break;
	case Tattach:	rattach(r, error);	break;
	case Twalk:	rwalk(r, error);	break;
	case Topen:	ropen(r, error);	break;
	case Tcreate:	rcreate(r, error);	break;
	case Tread:	rread(r, error);	break;
	case Twrite:	rwrite(r, error);	break;
	case Tclunk:	rclunk(r, error);	break;
	case Tremove:	rremove(r, error, errbuf);	break;
	case Tstat:	rstat(r, error);	break;
	case Twstat:	rwstat(r, error);	break;
	}

	r-&gt;ofcall.tag = r-&gt;ifcall.tag;
	r-&gt;ofcall.type = r-&gt;ifcall.type+1;
	if(r-&gt;error)
		setfcallerror(&amp;r-&gt;ofcall, r-&gt;error);

if(chatty9p)
	fprint(2, "-%d-&gt; %F\n", srv-&gt;outfd, &amp;r-&gt;ofcall);

	qlock(&amp;srv-&gt;wlock);
	n = convS2M(&amp;r-&gt;ofcall, srv-&gt;wbuf, srv-&gt;msize);
	if(n &lt;= 0){
		fprint(2, "n = %d %F\n", n, &amp;r-&gt;ofcall);
		abort();
	}
	assert(n &gt; 2);
	if(r-&gt;pool)	/* not a fake */
		closereq(removereq(r-&gt;pool, r-&gt;ifcall.tag));
	m = write(srv-&gt;outfd, srv-&gt;wbuf, n);
	if(m != n)
		sysfatal("lib9p srv: write %d returned %d on fd %d: %r", n, m, srv-&gt;outfd);
	qunlock(&amp;srv-&gt;wlock);

	qlock(&amp;r-&gt;lk);	/* no one will add flushes now */
	r-&gt;responded = 1;
	qunlock(&amp;r-&gt;lk);

	for(i=0; i&lt;r-&gt;nflush; i++)
		respond(r-&gt;flush[i], nil);
	free(r-&gt;flush);
	r-&gt;flush = nil;
	r-&gt;nflush = 0;

	if(r-&gt;pool)
		closereq(r);
	else
		free(r);
}

void
responderror(Req *r)
{
	char errbuf[ERRMAX];
	
	rerrstr(errbuf, sizeof errbuf);
	respond(r, errbuf);
}

int
postfd(char *name, int pfd)
{
	int fd;
	char buf[80];

	snprint(buf, sizeof buf, "/srv/%s", name);
	if(chatty9p)
		fprint(2, "postfd %s\n", buf);
	fd = create(buf, OWRITE|ORCLOSE|OCEXEC, 0600);
	if(fd &lt; 0){
		if(chatty9p)
			fprint(2, "create fails: %r\n");
		return -1;
	}
	if(fprint(fd, "%d", pfd) &lt; 0){
		if(chatty9p)
			fprint(2, "write fails: %r\n");
		close(fd);
		return -1;
	}
	if(chatty9p)
		fprint(2, "postfd successful\n");
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

