<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libavl/avl.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libavl/avl.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;avl.h&gt;

/*
 * In-memory database stored as self-balancing AVL tree.
 * See Lewis &amp; Denenberg, Data Structures and Their Algorithms.
 */

static void
singleleft(Avl **tp, Avl *p)
{
	int l, r2;
	Avl *a, *c;

	a = *tp;
	c = a-&gt;n[1];

	r2 = c-&gt;bal;
	l = (r2 &gt; 0? r2: 0)+1 - a-&gt;bal;

	if((a-&gt;n[1] = c-&gt;n[0]) != nil)
		a-&gt;n[1]-&gt;p = a;

	if((c-&gt;n[0] = a) != nil)
		c-&gt;n[0]-&gt;p = c;

	if((*tp = c) != nil)
		(*tp)-&gt;p = p;

	a-&gt;bal = -l;
	c-&gt;bal = r2 - ((l &gt; 0? l: 0)+1);

}

static void
singleright(Avl **tp, Avl *p)
{
	int l2, r;
	Avl *a, *c;

	a = *tp;
	c = a-&gt;n[0];
	l2 = - c-&gt;bal;
	r = a-&gt;bal + ((l2 &gt; 0? l2: 0)+1);

	if((a-&gt;n[0] = c-&gt;n[1]) != nil)
		a-&gt;n[0]-&gt;p = a;

	if((c-&gt;n[1] = a) != nil)
		c-&gt;n[1]-&gt;p = c;

	if((*tp = c) != nil)
		(*tp)-&gt;p = p;

	a-&gt;bal = r;
	c-&gt;bal = ((r &gt; 0? r: 0)+1) - l2;
}

static void
doublerightleft(Avl **tp, Avl *p)
{
	singleright(&amp;(*tp)-&gt;n[1], *tp);
	singleleft(tp, p);
}

static void
doubleleftright(Avl **tp, Avl *p)
{
	singleleft(&amp;(*tp)-&gt;n[0], *tp);
	singleright(tp, p);
}

static void
balance(Avl **tp, Avl *p)
{
	switch((*tp)-&gt;bal){
	case -2:
		if((*tp)-&gt;n[0]-&gt;bal &lt;= 0)
			singleright(tp, p);
		else if((*tp)-&gt;n[0]-&gt;bal == 1)
			doubleleftright(tp, p);
		else
			assert(0);
		break;

	case 2:
		if((*tp)-&gt;n[1]-&gt;bal &gt;= 0)
			singleleft(tp, p);
		else if((*tp)-&gt;n[1]-&gt;bal == -1)
			doublerightleft(tp, p);
		else
			assert(0);
		break;
	}
}

static int
canoncmp(int cmp)
{
	if(cmp &lt; 0)
		return -1;
	else if(cmp &gt; 0)
		return 1;
	return 0;
}

static int
_insertavl(Avl **tp, Avl *p, Avl *r, int (*cmp)(Avl*,Avl*), Avl **rfree)
{
	int i, ob;

	if(*tp == nil){
		r-&gt;bal = 0;
		r-&gt;n[0] = nil;
		r-&gt;n[1] = nil;
		r-&gt;p = p;
		*tp = r;
		return 1;
	}
	ob = (*tp)-&gt;bal;
	if((i = canoncmp(cmp(r, *tp))) != 0){
		(*tp)-&gt;bal += i * _insertavl(&amp;(*tp)-&gt;n[(i+1)/2], *tp, r, cmp,
			rfree);
		balance(tp, p);
		return ob == 0 &amp;&amp; (*tp)-&gt;bal != 0;
	}

	/* install new entry */
	*rfree = *tp;		/* save old node for freeing */
	*tp = r;		/* insert new node */
	**tp = **rfree;		/* copy old node's Avl contents */
	if(r-&gt;n[0])		/* fix node's children's parent pointers */
		r-&gt;n[0]-&gt;p = r;
	if(r-&gt;n[1])
		r-&gt;n[1]-&gt;p = r;

	return 0;
}

static int
successor(Avl **tp, Avl *p, Avl **r)
{
	int ob;

	if((*tp)-&gt;n[0] == nil){
		*r = *tp;
		*tp = (*r)-&gt;n[1];
		if(*tp)
			(*tp)-&gt;p = p;
		return -1;
	}
	ob = (*tp)-&gt;bal;
	(*tp)-&gt;bal -= successor(&amp;(*tp)-&gt;n[0], *tp, r);
	balance(tp, p);
	return -(ob != 0 &amp;&amp; (*tp)-&gt;bal == 0);
}

static int
_deleteavl(Avl **tp, Avl *p, Avl *rx, int(*cmp)(Avl*,Avl*), Avl **del,
	void (*predel)(Avl*, void*), void *arg)
{
	int i, ob;
	Avl *r, *or;

	if(*tp == nil)
		return 0;

	ob = (*tp)-&gt;bal;
	if((i=canoncmp(cmp(rx, *tp))) != 0){
		(*tp)-&gt;bal += i * _deleteavl(&amp;(*tp)-&gt;n[(i+1)/2], *tp, rx, cmp,
			del, predel, arg);
		balance(tp, p);
		return -(ob != 0 &amp;&amp; (*tp)-&gt;bal == 0);
	}

	if(predel)
		(*predel)(*tp, arg);

	or = *tp;
	if(or-&gt;n[i=0] == nil || or-&gt;n[i=1] == nil){
		*tp = or-&gt;n[1-i];
		if(*tp)
			(*tp)-&gt;p = p;
		*del = or;
		return -1;
	}

	/* deleting node with two kids, find successor */
	or-&gt;bal += successor(&amp;or-&gt;n[1], or, &amp;r);
	r-&gt;bal = or-&gt;bal;
	r-&gt;n[0] = or-&gt;n[0];
	r-&gt;n[1] = or-&gt;n[1];
	*tp = r;
	(*tp)-&gt;p = p;
	/* node has changed; fix children's parent pointers */
	if(r-&gt;n[0])
		r-&gt;n[0]-&gt;p = r;
	if(r-&gt;n[1])
		r-&gt;n[1]-&gt;p = r;
	*del = or;
	balance(tp, p);
	return -(ob != 0 &amp;&amp; (*tp)-&gt;bal == 0);
}

static void
checkparents(Avl *a, Avl *p)
{
	if(a == nil)
		return;
	if(a-&gt;p != p)
		print("bad parent\n");
	checkparents(a-&gt;n[0], a);
	checkparents(a-&gt;n[1], a);
}

struct Avltree
{
	Avl	*root;
	int	(*cmp)(Avl*, Avl*);
	Avlwalk	*walks;
};
struct Avlwalk
{
	int	started;
	int	moved;
	Avlwalk	*next;
	Avltree	*tree;
	Avl	*node;
};

Avltree*
mkavltree(int (*cmp)(Avl*, Avl*))
{
	Avltree *t;

	t = malloc(sizeof *t);
	if(t == nil)
		return nil;
	memset(t, 0, sizeof *t);
	t-&gt;cmp = cmp;
	return t;
}

void
insertavl(Avltree *t, Avl *new, Avl **oldp)
{
	*oldp = nil;
	_insertavl(&amp;t-&gt;root, nil, new, t-&gt;cmp, oldp);
}

static Avl*
findpredecessor(Avl *a)
{
	if(a == nil)
		return nil;

	if(a-&gt;n[0] != nil){
		/* predecessor is rightmost descendant of left child */
		for(a = a-&gt;n[0]; a-&gt;n[1]; a = a-&gt;n[1])
			;
		return a;
	}else{
		/* we're at a leaf, successor is a parent we enter from the right */
		while(a-&gt;p &amp;&amp; a-&gt;p-&gt;n[0] == a)
			a = a-&gt;p;
		return a-&gt;p;
	}
}

static Avl*
findsuccessor(Avl *a)
{
	if(a == nil)
		return nil;

	if(a-&gt;n[1] != nil){
		/* successor is leftmost descendant of right child */
		for(a = a-&gt;n[1]; a-&gt;n[0]; a = a-&gt;n[0])
			;
		return a;
	}else{
		/* we're at a leaf, successor is a parent we enter from the left going up */
		while(a-&gt;p &amp;&amp; a-&gt;p-&gt;n[1] == a)
			a = a-&gt;p;
		return a-&gt;p;
	}
}

static Avl*
_lookupavl(Avl *t, Avl *r, int (*cmp)(Avl*,Avl*), int neighbor)
{
	int i;
	Avl *p;

	p = nil;
	if(t == nil)
		return nil;
	do{
		assert(t-&gt;p == p);
		if((i = canoncmp(cmp(r, t))) == 0)
			return t;
		p = t;
		t = t-&gt;n[(i+1)/2];
	}while(t);
	if(neighbor == 0)
		return nil;
	if(neighbor &lt; 0)
		return i &gt; 0 ? p : findpredecessor(p);
	return i &lt; 0 ? p : findsuccessor(p);
}

Avl*
searchavl(Avltree *t, Avl *key, int neighbor)
{
	return _lookupavl(t-&gt;root, key, t-&gt;cmp, neighbor);
}

Avl*
lookupavl(Avltree *t, Avl *key)
{
	return _lookupavl(t-&gt;root, key, t-&gt;cmp, 0);
}

static void
walkdel(Avl *a, void *v)
{
	Avl *p;
	Avlwalk *w;
	Avltree *t;

	if(a == nil)
		return;

	p = findpredecessor(a);
	t = v;
	for(w = t-&gt;walks; w; w = w-&gt;next){
		if(w-&gt;node == a){
			/* back pointer to predecessor; not perfect but adequate */
			w-&gt;moved = 1;
			w-&gt;node = p;
			if(p == nil)
				w-&gt;started = 0;
		}
	}
}

void
deleteavl(Avltree *t, Avl *key, Avl **oldp)
{
	*oldp = nil;
	_deleteavl(&amp;t-&gt;root, nil, key, t-&gt;cmp, oldp, walkdel, t);
}

Avlwalk*
avlwalk(Avltree *t)
{
	Avlwalk *w;

	w = malloc(sizeof *w);
	if(w == nil)
		return nil;
	memset(w, 0, sizeof *w);
	w-&gt;tree = t;
	w-&gt;next = t-&gt;walks;
	t-&gt;walks = w;
	return w;
}

Avl*
avlnext(Avlwalk *w)
{
	Avl *a;

	if(w-&gt;started==0){
		for(a = w-&gt;tree-&gt;root; a &amp;&amp; a-&gt;n[0]; a = a-&gt;n[0])
			;
		w-&gt;node = a;
		w-&gt;started = 1;
	}else{
		a = findsuccessor(w-&gt;node);
		if(a == w-&gt;node)
			abort();
		w-&gt;node = a;
	}
	return w-&gt;node;
}

Avl*
avlprev(Avlwalk *w)
{
	Avl *a;

	if(w-&gt;started == 0){
		for(a = w-&gt;tree-&gt;root; a &amp;&amp; a-&gt;n[1]; a = a-&gt;n[1])
			;
		w-&gt;node = a;
		w-&gt;started = 1;
	}else if(w-&gt;moved){
		w-&gt;moved = 0;
		return w-&gt;node;
	}else{
		a = findpredecessor(w-&gt;node);
		if(a == w-&gt;node)
			abort();
		w-&gt;node = a;
	}
	return w-&gt;node;
}

void
endwalk(Avlwalk *w)
{
	Avltree *t;
	Avlwalk **l;

	t = w-&gt;tree;
	for(l = &amp;t-&gt;walks; *l; l = &amp;(*l)-&gt;next){
		if(*l == w){
			*l = w-&gt;next;
			break;
		}
	}
	free(w);
}

static void
walkavl(Avl *t, void (*f)(Avl*, void*), void *v)
{
	if(t == nil)
		return;
	walkavl(t-&gt;n[0], f, v);
	f(t, v);
	walkavl(t-&gt;n[1], f, v);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

