<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libc/fmt/fmtquote.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libc/fmt/fmtquote.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "fmtdef.h"

/*
 * How many bytes of output UTF will be produced by quoting (if necessary) this string?
 * How many runes? How much of the input will be consumed?
 * The parameter q is filled in by _quotesetup.
 * The string may be UTF or Runes (s or r).
 * Return count does not include NUL.
 * Terminate the scan at the first of:
 *	NUL in input
 *	count exceeded in input
 *	count exceeded on output
 * *ninp is set to number of input bytes accepted.
 * nin may be &lt;0 initially, to avoid checking input by count.
 */
void
_quotesetup(char *s, Rune *r, int nin, int nout, Quoteinfo *q, int sharp, int runesout)
{
	int w;
	Rune c;

	q-&gt;quoted = 0;
	q-&gt;nbytesout = 0;
	q-&gt;nrunesout = 0;
	q-&gt;nbytesin = 0;
	q-&gt;nrunesin = 0;
	if(sharp || nin==0 || (s &amp;&amp; *s=='\0') || (r &amp;&amp; *r=='\0')){
		if(nout &lt; 2)
			return;
		q-&gt;quoted = 1;
		q-&gt;nbytesout = 2;
		q-&gt;nrunesout = 2;
	}
	for(; nin!=0; nin--){
		if(s)
			w = chartorune(&amp;c, s);
		else{
			c = *r;
			w = runelen(c);
		}

		if(c == '\0')
			break;
		if(runesout){
			if(q-&gt;nrunesout+1 &gt; nout)
				break;
		}else{
			if(q-&gt;nbytesout+w &gt; nout)
				break;
		}

		if((c &lt;= L' ') || (c == L'\'') || (doquote!=nil &amp;&amp; doquote(c))){
			if(!q-&gt;quoted){
				if(runesout){
					if(1+q-&gt;nrunesout+1+1 &gt; nout)	/* no room for quotes */
						break;
				}else{
					if(1+q-&gt;nbytesout+w+1 &gt; nout)	/* no room for quotes */
						break;
				}
				q-&gt;nrunesout += 2;	/* include quotes */
				q-&gt;nbytesout += 2;	/* include quotes */
				q-&gt;quoted = 1;
			}
			if(c == '\'')	{
				if(runesout){
					if(1+q-&gt;nrunesout+1 &gt; nout)	/* no room for quotes */
						break;
				}else{
					if(1+q-&gt;nbytesout+w &gt; nout)	/* no room for quotes */
						break;
				}
				q-&gt;nbytesout++;
				q-&gt;nrunesout++;	/* quotes reproduce as two characters */
			}
		}

		/* advance input */
		if(s)
			s += w;
		else
			r++;
		q-&gt;nbytesin += w;
		q-&gt;nrunesin++;

		/* advance output */
		q-&gt;nbytesout += w;
		q-&gt;nrunesout++;
	}
}

static int
qstrfmt(char *sin, Rune *rin, Quoteinfo *q, Fmt *f)
{
	Rune r, *rm, *rme;
	char *t, *s, *m, *me;
	Rune *rt, *rs;
	ulong fl;
	int nc, w;

	m = sin;
	me = m + q-&gt;nbytesin;
	rm = rin;
	rme = rm + q-&gt;nrunesin;

	w = f-&gt;width;
	fl = f-&gt;flags;
	if(f-&gt;runes){
		if(!(fl &amp; FmtLeft) &amp;&amp; _rfmtpad(f, w - q-&gt;nrunesout) &lt; 0)
			return -1;
	}else{
		if(!(fl &amp; FmtLeft) &amp;&amp; _fmtpad(f, w - q-&gt;nbytesout) &lt; 0)
			return -1;
	}
	t = f-&gt;to;
	s = f-&gt;stop;
	rt = f-&gt;to;
	rs = f-&gt;stop;
	if(f-&gt;runes)
		FMTRCHAR(f, rt, rs, '\'');
	else
		FMTRUNE(f, t, s, '\'');
	for(nc = q-&gt;nrunesin; nc &gt; 0; nc--){
		if(sin){
			r = *(uchar*)m;
			if(r &lt; Runeself)
				m++;
			else if((me - m) &gt;= UTFmax || fullrune(m, me-m))
				m += chartorune(&amp;r, m);
			else
				break;
		}else{
			if(rm &gt;= rme)
				break;
			r = *(uchar*)rm++;
		}
		if(f-&gt;runes){
			FMTRCHAR(f, rt, rs, r);
			if(r == '\'')
				FMTRCHAR(f, rt, rs, r);
		}else{
			FMTRUNE(f, t, s, r);
			if(r == '\'')
				FMTRUNE(f, t, s, r);
		}
	}

	if(f-&gt;runes){
		FMTRCHAR(f, rt, rs, '\'');
		USED(rs);
		f-&gt;nfmt += rt - (Rune *)f-&gt;to;
		f-&gt;to = rt;
		if(fl &amp; FmtLeft &amp;&amp; _rfmtpad(f, w - q-&gt;nrunesout) &lt; 0)
			return -1;
	}else{
		FMTRUNE(f, t, s, '\'');
		USED(s);
		f-&gt;nfmt += t - (char *)f-&gt;to;
		f-&gt;to = t;
		if(fl &amp; FmtLeft &amp;&amp; _fmtpad(f, w - q-&gt;nbytesout) &lt; 0)
			return -1;
	}
	return 0;
}

int
_quotestrfmt(int runesin, Fmt *f)
{
	int nin, outlen;
	Rune *r;
	char *s;
	Quoteinfo q;

	nin = -1;
	if(f-&gt;flags&amp;FmtPrec)
		nin = f-&gt;prec;
	if(runesin){
		r = va_arg(f-&gt;args, Rune *);
		s = nil;
	}else{
		s = va_arg(f-&gt;args, char *);
		r = nil;
	}
	if(!s &amp;&amp; !r)
		return _fmtcpy(f, "&lt;nil&gt;", 5, 5);

	if(f-&gt;flush)
		outlen = 0x7FFFFFFF;	/* if we can flush, no output limit */
	else if(f-&gt;runes)
		outlen = (Rune*)f-&gt;stop - (Rune*)f-&gt;to;
	else
		outlen = (char*)f-&gt;stop - (char*)f-&gt;to;

	_quotesetup(s, r, nin, outlen, &amp;q, f-&gt;flags&amp;FmtSharp, f-&gt;runes);
//print("bytes in %d bytes out %d runes in %d runesout %d\n", q.nbytesin, q.nbytesout, q.nrunesin, q.nrunesout);

	if(runesin){
		if(!q.quoted)
			return _fmtrcpy(f, r, q.nrunesin);
		return qstrfmt(nil, r, &amp;q, f);
	}

	if(!q.quoted)
		return _fmtcpy(f, s, q.nrunesin, q.nbytesin);
	return qstrfmt(s, nil, &amp;q, f);
}

int
quotestrfmt(Fmt *f)
{
	return _quotestrfmt(0, f);
}

int
quoterunestrfmt(Fmt *f)
{
	return _quotestrfmt(1, f);
}

void
quotefmtinstall(void)
{
	fmtinstall('q', quotestrfmt);
	fmtinstall('Q', quoterunestrfmt);
}

int
_needsquotes(char *s, int *quotelenp)
{
	Quoteinfo q;

	_quotesetup(s, nil, -1, 0x7FFFFFFF, &amp;q, 0, 0);
	*quotelenp = q.nbytesout;

	return q.quoted;
}

int
_runeneedsquotes(Rune *r, int *quotelenp)
{
	Quoteinfo q;

	_quotesetup(nil, r, -1, 0x7FFFFFFF, &amp;q, 0, 0);
	*quotelenp = q.nrunesout;

	return q.quoted;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

