<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/group.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/group.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;draw.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;
#include "group.h"

static int debug = 0;
static int debugm = 0;
static int debugr = 0;

enum{
	EAdd,
	EBorder,
	EBordercolor,
	EFocus,
	EHide,
	EImage,
	ERect,
	ERemove,
	EReveal,
	ESeparation,
	EShow,
	ESize,
};

static char *cmds[] = {
	[EAdd] =			"add",
	[EBorder] =		"border",
	[EBordercolor] =	"bordercolor",
	[EFocus] = 		"focus",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ERect] =			"rect",
	[ERemove] =		"remove",
	[EReveal] =		"reveal",
	[ESeparation] =		"separation",
	[EShow] =			"show",
	[ESize] =			"size",
};

static void		boxboxresize(Group*, Rectangle);
static void		columnresize(Group*, Rectangle);
static void		groupctl(Control *c, CParse *cp);
static void		groupfree(Control*);
static void		groupmouse(Control *, Mouse *);
static void		groupsize(Control *c);
static void		removegroup(Group*, int);
static void		rowresize(Group*, Rectangle);
static void		stackresize(Group*, Rectangle);

static void
groupinit(Group *g)
{
	g-&gt;bordercolor = _getctlimage("black");
	g-&gt;image = _getctlimage("white");
	g-&gt;border = 0;
	g-&gt;mansize = 0;
	g-&gt;separation = 0;
	g-&gt;selected = -1;
	g-&gt;lastkid = -1;
	g-&gt;kids = nil;
	g-&gt;separators = nil;
	g-&gt;nkids = 0;
	g-&gt;nseparators = 0;
	g-&gt;ctl = groupctl;
	g-&gt;mouse = groupmouse;
	g-&gt;exit = groupfree;
}

static void
groupctl(Control *c, CParse *cp)
{
	int cmd, i, n;
	
	Rectangle r;
	Group *g;

	g = (Group*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	case EAdd:
		for (i = 1; i &lt; cp-&gt;nargs; i++){
			c = controlcalled(cp-&gt;args[i]);
			if (c == nil)
				ctlerror("%q: no such control: %s", g-&gt;name, cp-&gt;args[i]);
			_ctladdgroup(g, c);
		}
		if (g-&gt;setsize)
			g-&gt;setsize((Control*)g);
		break;
	case EBorder:
		_ctlargcount(g, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", g-&gt;name, cp-&gt;str);
		g-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(g, cp, 2);
		_setctlimage(g, &amp;g-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case EHide:
		_ctlargcount(g, cp, 1);
		for (i = 0; i &lt; g-&gt;nkids; i++)
			if (g-&gt;kids[i]-&gt;ctl)
				_ctlprint(g-&gt;kids[i], "hide");
		g-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(g, cp, 2);
		_setctlimage(g, &amp;g-&gt;image, cp-&gt;args[1]);
		break;
	case ERect:
		_ctlargcount(g, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", g-&gt;name, cp-&gt;str);
		g-&gt;rect = r;
		r = insetrect(r, g-&gt;border);
		if (g-&gt;nkids == 0)
			return;
		switch(g-&gt;type){
		case Ctlboxbox:
			boxboxresize(g, r);
			break;
		case Ctlcolumn:
			columnresize(g, r);
			break;
		case Ctlrow:
			rowresize(g, r);
			break;
		case Ctlstack:
			stackresize(g, r);
			break;
		}
		break;
	case ERemove:
		_ctlargcount(g, cp, 2);
		for (n = 0; n &lt; g-&gt;nkids; n++)
			if (strcmp(cp-&gt;args[1], g-&gt;kids[n]-&gt;name) == 0)
				break;
		if (n == g-&gt;nkids)
			ctlerror("%s: remove nonexistent control: %q", g-&gt;name, cp-&gt;args[1]);
		removegroup(g, n);
		if (g-&gt;setsize)
			g-&gt;setsize((Control*)g);
		break;
	case EReveal:
		g-&gt;hidden = 0;
		if (debugr) fprint(2, "reveal %s\n", g-&gt;name);
		if (g-&gt;type == Ctlstack){
			if (cp-&gt;nargs == 2){
				if (cp-&gt;iargs[1] &lt; 0 || cp-&gt;iargs[1] &gt;= g-&gt;nkids)
					ctlerror("%s: control out of range: %q", g-&gt;name, cp-&gt;str);
				g-&gt;selected = cp-&gt;iargs[1];
			}else
				_ctlargcount(g, cp, 1);
			for (i = 0; i &lt; g-&gt;nkids; i++)
				if (g-&gt;kids[i]-&gt;ctl){
					if (g-&gt;selected == i){
						if (debugr) fprint(2, "reveal %s: reveal kid %s\n", g-&gt;name, g-&gt;kids[i]-&gt;name);
						_ctlprint(g-&gt;kids[i], "reveal");
					}else{
						if (debugr) fprint(2, "reveal %s: hide kid %s\n", g-&gt;name, g-&gt;kids[i]-&gt;name);
						_ctlprint(g-&gt;kids[i], "hide");
					}
				}
			break;
		}
		_ctlargcount(g, cp, 1);
		if (debug) fprint(2, "reveal %s: border %R/%d\n", g-&gt;name, g-&gt;rect, g-&gt;border);
		border(g-&gt;screen, g-&gt;rect, g-&gt;border, g-&gt;bordercolor-&gt;image, g-&gt;bordercolor-&gt;image-&gt;r.min);
		r = insetrect(g-&gt;rect, g-&gt;border);
		if (debug) fprint(2, "reveal %s: draw %R\n", g-&gt;name, r);
		draw(g-&gt;screen, r, g-&gt;image-&gt;image, nil, g-&gt;image-&gt;image-&gt;r.min);
		for (i = 0; i &lt; g-&gt;nkids; i++)
			if (g-&gt;kids[i]-&gt;ctl)
				_ctlprint(g-&gt;kids[i], "reveal");
		break;
	case EShow:
		_ctlargcount(g, cp, 1);
		if (g-&gt;hidden)
			break;
		// pass it on to the kiddies
		if (debug) fprint(2, "show %s: border %R/%d\n", g-&gt;name, g-&gt;rect, g-&gt;border);
		border(g-&gt;screen, g-&gt;rect, g-&gt;border, g-&gt;bordercolor-&gt;image, g-&gt;bordercolor-&gt;image-&gt;r.min);
		r = insetrect(g-&gt;rect, g-&gt;border);
		if (debug) fprint(2, "show %s: draw %R\n", g-&gt;name, r);
		draw(g-&gt;screen, r, g-&gt;image-&gt;image, nil, g-&gt;image-&gt;image-&gt;r.min);
		for (i = 0; i &lt; g-&gt;nkids; i++)
			if (g-&gt;kids[i]-&gt;ctl){
				if (debug) fprint(2, "show %s: kid %s: %q\n", g-&gt;name, g-&gt;kids[i]-&gt;name, cp-&gt;str);
				_ctlprint(g-&gt;kids[i], "show");
			}
		flushimage(display, 1);
		break;
	case ESize:
		r.max = Pt(_Ctlmaxsize, _Ctlmaxsize);
		if (g-&gt;type == Ctlboxbox)
			_ctlargcount(g, cp, 5);
		switch(cp-&gt;nargs){
		default:
			ctlerror("%s: args of %q", g-&gt;name, cp-&gt;str);
		case 1:
			/* recursively set size */
			g-&gt;mansize = 0;
			if (g-&gt;setsize)
				g-&gt;setsize((Control*)g);
			break;
		case 5:
			_ctlargcount(g, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
			/* fall through */
		case 3:
			r.min.x = cp-&gt;iargs[1];
			r.min.y = cp-&gt;iargs[2];
			if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", g-&gt;name, cp-&gt;str);
			g-&gt;size = r;
			g-&gt;mansize = 1;
			break;
		}
		break;
	case ESeparation:
		if (g-&gt;type != Ctlstack){
			_ctlargcount(g, cp, 2);
			if(cp-&gt;iargs[1] &lt; 0)
				ctlerror("%q: illegal value: %c", g-&gt;name, cp-&gt;str);
			g-&gt;separation = cp-&gt;iargs[1];
			break;
		}
		// fall through for Ctlstack
	default:
		ctlerror("%q: unrecognized message '%s'", g-&gt;name, cp-&gt;str);
		break;
	}
}

static void
groupfree(Control *c)
{
	Group *g;

	g = (Group*)c;
	_putctlimage(g-&gt;bordercolor);
	free(g-&gt;kids);
}

static void
groupmouse(Control *c, Mouse *m)
{
	Group *g;
	int i, lastkid;

	g = (Group*)c;
	if (g-&gt;type == Ctlstack){
		i = g-&gt;selected;
		if (i &gt;= 0 &amp;&amp; g-&gt;kids[i]-&gt;mouse &amp;&amp;
                        ( ( ((m-&gt;buttons == 0) || (g-&gt;lastbut == 0)) &amp;&amp;
                           ptinrect(m-&gt;xy, g-&gt;kids[i]-&gt;rect) ) ||
                         ( ((m-&gt;buttons != 0) || (g-&gt;lastbut != 0)) &amp;&amp;
		         (g-&gt;lastkid == i) ) ) ) {
			if (debugm) fprint(2, "groupmouse %s mouse kid %s i=%d lastkid=%d buttons=%d lastbut=%d inrect=%d\n",
						g-&gt;name, g-&gt;kids[i]-&gt;name, i, g-&gt;lastkid, m-&gt;buttons, g-&gt;lastbut,
						ptinrect(m-&gt;xy, g-&gt;kids[i]-&gt;rect) ? 1 : 0);
			(g-&gt;kids[i]-&gt;mouse)(g-&gt;kids[i], m);
			g-&gt;lastkid = i;
			g-&gt;lastbut = m-&gt;buttons;
		} else {
			if (debugm) fprint(2, "groupmouse %s skip kid %s i=%d lastkid=%d buttons=%d lastbut=%d inrect=%d\n",
						g-&gt;name, g-&gt;kids[i]-&gt;name, i, g-&gt;lastkid, m-&gt;buttons, g-&gt;lastbut,
						ptinrect(m-&gt;xy, g-&gt;kids[i]-&gt;rect) ? 1 : 0);
		}
		return;
	}

	lastkid = -1;
	for(i=0; i&lt;g-&gt;nkids; i++) {
		if(g-&gt;kids[i]-&gt;mouse &amp;&amp;
                      ( ( ((m-&gt;buttons == 0) || (g-&gt;lastbut == 0)) &amp;&amp;
                           ptinrect(m-&gt;xy, g-&gt;kids[i]-&gt;rect) ) ||
                        ( ((m-&gt;buttons != 0) || (g-&gt;lastbut != 0)) &amp;&amp;
		         (g-&gt;lastkid == i) ) ) ) {
			if (debugm) fprint(2, "groupmouse %s mouse kid %s i=%d lastkid=%d buttons=%d lastbut=%d inrect=%d\n",
						g-&gt;name, g-&gt;kids[i]-&gt;name, i, g-&gt;lastkid, m-&gt;buttons, g-&gt;lastbut,
						ptinrect(m-&gt;xy, g-&gt;kids[i]-&gt;rect) ? 1 : 0);
			(g-&gt;kids[i]-&gt;mouse)(g-&gt;kids[i], m);
			lastkid = i;
		} else {
			if (debugm) fprint(2, "groupmouse %s skip kid %s i=%d lastkid=%d buttons=%d lastbut=%d inrect=%d\n",
						g-&gt;name, g-&gt;kids[i]-&gt;name, i, g-&gt;lastkid, m-&gt;buttons, g-&gt;lastbut,
						ptinrect(m-&gt;xy, g-&gt;kids[i]-&gt;rect) ? 1 : 0);
		}
	}
	g-&gt;lastkid = lastkid;
	g-&gt;lastbut = m-&gt;buttons;

#ifdef notdef
	if(m-&gt;buttons == 0){
		/* buttons now up */
		g-&gt;lastbut = 0;
		return;
	}
	if(g-&gt;lastbut == 0 &amp;&amp; m-&gt;buttons != 0){
		/* button went down, start tracking border */
		switch(g-&gt;stacking){
		default:
			return;
		case Vertical:
			p = Pt(m-&gt;xy.x, middle_of_border.y);
			p0 = Pt(g-&gt;r.min.x, m-&gt;xy.y);
			p1 = Pt(g-&gt;r.max.x, m-&gt;xy.y);
			break;
		case Horizontal:
			p = Pt(middle_of_border.x, m-&gt;xy.y);
			p0 = Pt(m-&gt;xy.x, g-&gt;r.min.y);
			p1 = Pt(m-&gt;xy.x, g-&gt;r.max.y);
			break;
		}
	//	setcursor();
		oi = nil;
	} else if (g-&gt;lastbut != 0 &amp;&amp; s-&gt;m.buttons != 0){
		/* button is down, keep tracking border */
		if(!eqpt(s-&gt;m.xy, p)){
			p = onscreen(s-&gt;m.xy);
			r = canonrect(Rpt(p0, p));
			if(Dx(r)&gt;5 &amp;&amp; Dy(r)&gt;5){
				i = allocwindow(wscreen, r, Refnone, 0xEEEEEEFF); /* grey */
				freeimage(oi);
				if(i == nil)
					goto Rescue;
				oi = i;
				border(i, r, Selborder, red, ZP);
				flushimage(display, 1);
			}
		}
	} else if (g-&gt;lastbut != 0 &amp;&amp; s-&gt;m.buttons == 0){
		/* button went up, resize kiddies */
	}
	g-&gt;lastbut = s-&gt;m.buttons;
#endif
}

static void
activategroup(Control *c, int act)
{
	int i;
	Group *g;

	g = (Group*)c;
	for (i = 0; i &lt; g-&gt;nkids; i++)
		if (act)
			activate(g-&gt;kids[i]);
		else
			deactivate(g-&gt;kids[i]);
}

Control *
createrow(Controlset *cs, char *name)
{
	Control *c;
	c = _createctl(cs, "row", sizeof(Group), name);
	groupinit((Group*)c);
	c-&gt;setsize = groupsize;
	c-&gt;activate = activategroup;
	return c;
}

Control *
createcolumn(Controlset *cs, char *name)
{
	Control *c;
	c = _createctl(cs, "column", sizeof(Group), name);
	groupinit((Group*)c);
	c-&gt;setsize = groupsize;
	c-&gt;activate = activategroup;
	return c;
}

Control *
createboxbox(Controlset *cs, char *name)
{
	Control *c;
	c = _createctl(cs, "boxbox", sizeof(Group), name);
	groupinit((Group*)c);
	c-&gt;activate = activategroup;
	return c;
}

Control *
createstack(Controlset *cs, char *name)
{
	Control *c;
	c = _createctl(cs, "stack", sizeof(Group), name);
	groupinit((Group*)c);
	c-&gt;setsize = groupsize;
	return c;
}

void
_ctladdgroup(Control *c, Control *q)
{
	Group *g = (Group*)c;

	g-&gt;kids = ctlrealloc(g-&gt;kids, sizeof(Group*)*(g-&gt;nkids+1));
	g-&gt;kids[g-&gt;nkids++] = q;
}

static void
removegroup(Group *g, int n)
{
	int i;

	if (g-&gt;selected == n)
		g-&gt;selected = -1;
	else if (g-&gt;selected &gt; n)
		g-&gt;selected--;

	for (i = n+1; i &lt; g-&gt;nkids; i++)
		g-&gt;kids[i-1] = g-&gt;kids[i];
	g-&gt;nkids--;
}

static void
groupsize(Control *c)
{
	Rectangle r;
	int i;
	Control *q;
	Group *g;

	g = (Group*)c;
	assert(g-&gt;type == Ctlcolumn || g-&gt;type == Ctlrow || g-&gt;type == Ctlstack);
	if (g-&gt;mansize) return;
	r = Rect(1, 1, 1, 1);
	if (debug) fprint(2, "groupsize %q\n", g-&gt;name);
	for (i = 0; i &lt; g-&gt;nkids; i++){
		q = g-&gt;kids[i];
		if (q-&gt;setsize)
			q-&gt;setsize(q);
		if (q-&gt;size.min.x == 0 || q-&gt;size.min.y == 0 || q-&gt;size.max.x == 0 || q-&gt;size.max.y == 0)
			ctlerror("%q: bad size %R", q-&gt;name, q-&gt;size);
		if (debug) fprint(2, "groupsize %q: [%d %q]: %R\n", g-&gt;name, i, q-&gt;name, q-&gt;size);
		switch(g-&gt;type){
		case Ctlrow:
			if (i)
				r.min.x += q-&gt;size.min.x + g-&gt;border;
			else
				r.min.x = q-&gt;size.min.x;
			if (i)
				r.max.x += q-&gt;size.max.x + g-&gt;border;
			else
				r.max.x = q-&gt;size.max.x;
			if (r.min.y &lt; q-&gt;size.min.y) r.min.y = q-&gt;size.min.y;
			if (r.max.y &lt; q-&gt;size.max.y) r.max.y = q-&gt;size.max.y;
			break;
		case Ctlcolumn:
			if (r.min.x &lt; q-&gt;size.min.x) r.min.x = q-&gt;size.min.x;
			if (r.max.x &lt; q-&gt;size.max.x) r.max.x = q-&gt;size.max.x;
			if (i)
				r.min.y += q-&gt;size.min.y + g-&gt;border;
			else
				r.min.y = q-&gt;size.min.y;
			if (i)
				r.max.y += q-&gt;size.max.y + g-&gt;border;
			else
				r.max.y = q-&gt;size.max.y;
			break;
		case Ctlstack:
			if (r.min.x &lt; q-&gt;size.min.x) r.min.x = q-&gt;size.min.x;
			if (r.max.x &lt; q-&gt;size.max.x) r.max.x = q-&gt;size.max.x;
			if (r.min.y &lt; q-&gt;size.min.y) r.min.y = q-&gt;size.min.y;
			if (r.max.y &lt; q-&gt;size.max.y) r.max.y = q-&gt;size.max.y;
			break;
		}
	}
	g-&gt;size = rectaddpt(r, Pt(g-&gt;border, g-&gt;border));
	if (debug) fprint(2, "groupsize %q: %R\n", g-&gt;name, g-&gt;size);
}

static void
boxboxresize(Group *g, Rectangle r)
{
	int rows, cols, ht, wid, i, hpad, wpad;
	Rectangle rr;

	if(debug) fprint(2, "boxboxresize %q %R (%d×%d) min/max %R separation %d\n", g-&gt;name, r, Dx(r), Dy(r), g-&gt;size, g-&gt;separation);
	ht = 0;
	for(i=0; i&lt;g-&gt;nkids; i++){
		if (g-&gt;kids[i]-&gt;size.min.y &gt; ht)
			ht = g-&gt;kids[i]-&gt;size.min.y;
	}
	if (ht == 0)
		ctlerror("boxboxresize: height");
	rows = Dy(r) / (ht+g-&gt;separation);
	hpad = (Dy(r) % (ht+g-&gt;separation)) / g-&gt;nkids;
	cols = (g-&gt;nkids+rows-1)/rows;
	wid = Dx(r) / cols - g-&gt;separation;
	for(i=0; i&lt;g-&gt;nkids; i++){
		if (g-&gt;kids[i]-&gt;size.max.x &lt; wid)
			wid = g-&gt;kids[i]-&gt;size.max.x;
	}
	for(i=0; i&lt;g-&gt;nkids; i++){
		if (g-&gt;kids[i]-&gt;size.min.x &gt; wid)
			wid = g-&gt;kids[i]-&gt;size.min.x;
	}
	if (wid &gt; Dx(r) / cols)
		ctlerror("can't fit controls in boxbox");
	wpad = (Dx(r) % (wid+g-&gt;separation)) / g-&gt;nkids;
	rr = rectaddpt(Rect(0,0,wid, ht), addpt(r.min, Pt(g-&gt;separation/2, g-&gt;separation/2)));
	if(debug) fprint(2, "boxboxresize rows %d, cols %d, wid %d, ht %d, wpad %d, hpad %d\n", rows, cols, wid, ht, wpad, hpad);
	for(i=0; i&lt;g-&gt;nkids; i++){
		if(debug) fprint(2, "	%d %q: %R (%d×%d)\n", i, g-&gt;kids[i]-&gt;name, rr, Dx(rr), Dy(rr));
		_ctlprint(g-&gt;kids[i], "rect %R",
			rectaddpt(rr, Pt((wpad+wid+g-&gt;separation)*(i/rows), (hpad+ht+g-&gt;separation)*(i%rows))));
	}
	g-&gt;nseparators = rows + cols - 2;
	g-&gt;separators = realloc(g-&gt;separators, g-&gt;nseparators*sizeof(Rectangle));
	rr = r;
	rr.max.y = rr.min.y + g-&gt;separation+hpad;
	for (i = 1; i &lt; rows; i++){
		g-&gt;separators[i-1] = rectaddpt(rr, Pt(0, (hpad+ht+g-&gt;separation)*i-g-&gt;separation-hpad));
		if(debug) fprint(2, "row separation %d [%d]: %R\n", i, i-1, rectaddpt(rr, Pt(0, (hpad+ht+g-&gt;separation)*i-g-&gt;separation)));
	}
	rr = r;
	rr.max.x = rr.min.x + g-&gt;separation+wpad;
	for (i = 1; i &lt; cols; i++){
		g-&gt;separators[i+rows-2] = rectaddpt(rr, Pt((wpad+wid+g-&gt;separation)*i-g-&gt;separation-wpad, 0));
		if(debug) fprint(2, "col separation %d [%d]: %R\n", i, i+rows-2, rectaddpt(rr, Pt((wpad+wid+g-&gt;separation)*i-g-&gt;separation, 0)));
	}
}

static void
columnresize(Group *g, Rectangle r)
{
	int x, y, *d, *p, i, j, t;
	Rectangle rr;
	Control *q;

	x = Dx(r);
	y = Dy(r);
	if(debug) fprint(2, "columnresize %q %R (%d×%d) min/max %R separation %d\n", g-&gt;name, r, Dx(r), Dy(r), g-&gt;size, g-&gt;separation);
	if (x &lt; g-&gt;size.min.x) {
		werrstr("resize %s: too narrow: need %d, have %d", g-&gt;name, g-&gt;size.min.x, x);
		r.max.x = r.min.x + g-&gt;size.min.x;
	}
	if (y &lt; g-&gt;size.min.y) {
		werrstr("resize %s: too short: need %d, have %d", g-&gt;name, g-&gt;size.min.y, y);
		r.max.y = r.min.y + g-&gt;size.min.y;
		y = Dy(r);
	}
	d = ctlmalloc(g-&gt;nkids*sizeof(int));
	p = ctlmalloc(g-&gt;nkids*sizeof(int));
	if(debug) fprint(2, "kiddies: ");
	for (i = 0; i &lt; g-&gt;nkids; i++) {
		q = g-&gt;kids[i];
		if(debug) fprint(2, "[%q]: %d⋯%d\t", q-&gt;name, q-&gt;size.min.y, q-&gt;size.max.y);
		d[i] = q-&gt;size.min.y;
		y -= d[i];
		p[i] = q-&gt;size.max.y - q-&gt;size.min.y;
	}
	if(debug) fprint(2, "\n");
	y -= (g-&gt;nkids-1) * g-&gt;separation;
	if(y &lt; 0){
		if (debug) fprint(2, "columnresize: y == %d\n", y);
		y = 0;
	}
	if (y &gt;= g-&gt;size.max.y - g-&gt;size.min.y) {
		// all rects can be maximum width
		for (i = 0; i &lt; g-&gt;nkids; i++)
			d[i] += p[i];
		y -= g-&gt;size.max.y - g-&gt;size.min.y;
	} else {
		// rects can't be max width, divide up the rest
		j = y;
		for (i = 0; i &lt; g-&gt;nkids; i++) {
			t = p[i] * y/(g-&gt;size.max.y - g-&gt;size.min.y);
			d[i] += t;
			j -= t;
		}
		d[0] += j;
		y = 0;
	}
	g-&gt;nseparators = g-&gt;nkids-1;
	g-&gt;separators = realloc(g-&gt;separators, g-&gt;nseparators*sizeof(Rectangle));
	j = 0;
	rr = r;
	for (i = 0; i &lt; g-&gt;nkids; i++) {
		q = g-&gt;kids[i];
		if (i &lt; g-&gt;nkids - 1){
			g-&gt;separators[i].min.x = r.min.x;
			g-&gt;separators[i].max.x = r.max.x;
		}
		t = y / (g-&gt;nkids - i);
		y -= t;
		j += t/2;
		rr.min.y = r.min.y + j;
		if (i)
			g-&gt;separators[i-1].max.y = rr.min.y;
		j += d[i];
		rr.max.y = r.min.y + j;
		if (i &lt; g-&gt;nkids - 1)
			g-&gt;separators[i].min.y = rr.max.y;
		j += g-&gt;separation + t - t/2;
		_ctlprint(q, "rect %R", rr);
		if(debug) fprint(2, "	%d %q: %R (%d×%d)\n", i, q-&gt;name, rr, Dx(rr), Dy(rr));
	}
	free(d);
	free(p);
}

static void
rowresize(Group *g, Rectangle r)
{
	int x, y, *d, *p, i, j, t;
	Rectangle rr;
	Control *q;

	x = Dx(r);
	y = Dy(r);
	if(debug) fprint(2, "rowresize %q %R (%d×%d), separation %d\n", g-&gt;name, r, Dx(r), Dy(r), g-&gt;separation);
	if (x &lt; g-&gt;size.min.x) {
		werrstr("resize %s: too narrow: need %d, have %d", g-&gt;name, g-&gt;size.min.x, x);
		r.max.x = r.min.x + g-&gt;size.min.x;
		x = Dx(r);
	}
	if (y &lt; g-&gt;size.min.y) {
		werrstr("resize %s: too short: need %d, have %d", g-&gt;name, g-&gt;size.min.y, y);
		r.max.y = r.min.y + g-&gt;size.min.y;
	}
	d = ctlmalloc(g-&gt;nkids*sizeof(int));
	p = ctlmalloc(g-&gt;nkids*sizeof(int));
	if(debug) fprint(2, "kiddies: ");
	for (i = 0; i &lt; g-&gt;nkids; i++) {
		q = g-&gt;kids[i];
		if(debug) fprint(2, "[%q]: %d⋯%d\t", q-&gt;name, q-&gt;size.min.x, q-&gt;size.max.x);
		d[i] = q-&gt;size.min.x;
		x -= d[i];
		p[i] = q-&gt;size.max.x - q-&gt;size.min.x;
	}
	if(debug) fprint(2, "\n");
	x -= (g-&gt;nkids-1) * g-&gt;separation;
	if(x &lt; 0){
		if (debug) fprint(2, "rowresize: x == %d\n", x);
		x = 0;
	}
	if (x &gt;= g-&gt;size.max.x - g-&gt;size.min.x) {
		if (debug) fprint(2, "max: %d &gt; %d - %d", x, g-&gt;size.max.x, g-&gt;size.min.x);
		// all rects can be maximum width
		for (i = 0; i &lt; g-&gt;nkids; i++)
			d[i] += p[i];
		x -= g-&gt;size.max.x - g-&gt;size.min.x;
	} else {
		if (debug) fprint(2, "divvie up: %d &lt; %d - %d", x, g-&gt;size.max.x, g-&gt;size.min.x);
		// rects can't be max width, divide up the rest
		j = x;
		for (i = 0; i &lt; g-&gt;nkids; i++) {
			t = p[i] * x/(g-&gt;size.max.x - g-&gt;size.min.x);
			d[i] += t;
			j -= t;
		}
		d[0] += j;
		x = 0;
	}
	j = 0;
	g-&gt;nseparators = g-&gt;nkids-1;
	g-&gt;separators = realloc(g-&gt;separators, g-&gt;nseparators*sizeof(Rectangle));
	rr = r;
	for (i = 0; i &lt; g-&gt;nkids; i++) {
		q = g-&gt;kids[i];
		if (i &lt; g-&gt;nkids - 1){
			g-&gt;separators[i].min.y = r.min.y;
			g-&gt;separators[i].max.y = r.max.y;
		}
		t = x / (g-&gt;nkids - i);
		x -= t;
		j += t/2;
		rr.min.x = r.min.x + j;
		if (i)
			g-&gt;separators[i-1].max.x = rr.min.x;
		j += d[i];
		rr.max.x = r.min.x + j;
		if (i &lt; g-&gt;nkids - 1)
			g-&gt;separators[i].min.x = rr.max.x;
		j += g-&gt;separation + t - t/2;
		_ctlprint(q, "rect %R", rr);
		if(debug) fprint(2, "	%d %q: %R (%d×%d)\n", i, q-&gt;name, rr, Dx(rr), Dy(rr));
	}
	free(d);
	free(p);
}

static void
stackresize(Group *g, Rectangle r)
{
	int x, y, i;
	Control *q;

	x = Dx(r);
	y = Dy(r);
	if(debug) fprint(2, "stackresize %q %R (%d×%d)\n", g-&gt;name, r, Dx(r), Dy(r));
	if (x &lt; g-&gt;size.min.x){
		werrstr("resize %s: too narrow: need %d, have %d", g-&gt;name, g-&gt;size.min.x, x);
		return;
	}
	if (y &lt; g-&gt;size.min.y){
		werrstr("resize %s: too short: need %d, have %d", g-&gt;name, g-&gt;size.min.y, y);
		return;
	}
	if (x &gt; g-&gt;size.max.x) {
		x = (x - g-&gt;size.max.x)/2;
		r.min.x += x;
		r.max.x -= x;
	}
	if (y &gt; g-&gt;size.max.y) {
		y = (y - g-&gt;size.max.y)/2;
		r.min.y += y;
		r.max.y -= y;
	}
	for (i = 0; i &lt; g-&gt;nkids; i++){
		q = g-&gt;kids[i];
		if(debug) fprint(2, "	%d %q: %R (%d×%d)\n", i, q-&gt;name, r, Dx(r), Dy(r));
	}
	for (i = 0; i &lt; g-&gt;nkids; i++){
		q = g-&gt;kids[i];
		_ctlprint(q, "rect %R", r);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

