<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/label.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/label.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Label Label;

struct Label
{
	Control;
	int		border;
	CFont	*font;
	CImage	*image;
	CImage	*textcolor;
	CImage	*bordercolor;
	char		*text;
	int		align;
};

enum{
	EAlign,
	EBorder,
	EBordercolor,
	EFocus,
	EFont,
	EHide,
	EImage,
	ERect,
	EReveal,
	EShow,
	ESize,
	ETextcolor,
	EValue,
};

static char *cmds[] = {
	[EAlign] =			"align",
	[EBorder] =		"border",
	[EBordercolor] =	"bordercolor",
	[EFocus] = 		"focus",
	[EFont] =			"font",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ERect] =			"rect",
	[EReveal] =		"reveal",
	[EShow] =			"show",
	[ESize] =			"size",
	[ETextcolor] =		"textcolor",
	[EValue] =			"value",
	nil
};

static void	labelshow(Label*);

static void
labelfree(Control *c)
{
	Label *l;

	l = (Label*)c;
	_putctlfont(l-&gt;font);
	_putctlimage(l-&gt;image);
	_putctlimage(l-&gt;textcolor);
	_putctlimage(l-&gt;bordercolor);
}


static void
labelshow(Label *l)
{
	Rectangle r;
	Point p;

	if (l-&gt;hidden)
		return;
	r = l-&gt;rect;
	draw(l-&gt;screen, r, l-&gt;image-&gt;image, nil, l-&gt;image-&gt;image-&gt;r.min);
	if(l-&gt;border &gt; 0){
		border(l-&gt;screen, r, l-&gt;border, l-&gt;bordercolor-&gt;image, l-&gt;bordercolor-&gt;image-&gt;r.min);
		r = insetrect(r, l-&gt;border);
	}
	p = _ctlalignpoint(r,
		stringwidth(l-&gt;font-&gt;font, l-&gt;text),
		l-&gt;font-&gt;font-&gt;height, l-&gt;align);
	_string(l-&gt;screen, p, l-&gt;textcolor-&gt;image,
		ZP, l-&gt;font-&gt;font, l-&gt;text, nil, strlen(l-&gt;text),
		r, nil, ZP, SoverD);
	flushimage(display, 1);
}

static void
labelctl(Control *c, CParse *cp)
{
	int cmd;
	Rectangle r;
	Label *l;

	l = (Label*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", l-&gt;name, cp-&gt;str);
		break;
	case EAlign:
		_ctlargcount(l, cp, 2);
		l-&gt;align = _ctlalignment(cp-&gt;args[1]);
		break;
	case EBorder:
		_ctlargcount(l, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", l-&gt;name, cp-&gt;str);
		l-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(l, cp, 2);
		_setctlimage(l, &amp;l-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case EFont:
		_ctlargcount(l, cp, 2);
		_setctlfont(l, &amp;l-&gt;font, cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(l, cp, 1);
		l-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(l, cp, 2);
		_setctlimage(l, &amp;l-&gt;image, cp-&gt;args[1]);
		break;
	case ERect:
		_ctlargcount(l, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", l-&gt;name, cp-&gt;str);
		l-&gt;rect = r;
		break;
	case EReveal:
		_ctlargcount(l, cp, 1);
		l-&gt;hidden = 0;
		labelshow(l);
		break;
	case EShow:
		_ctlargcount(l, cp, 1);
		labelshow(l);
		/*
		_ctlargcount(l, cp, 2);
		_setctlimage(l, &amp;l-&gt;textcolor, cp-&gt;args[1]);
		*/
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(l, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", l-&gt;name, cp-&gt;str);
		l-&gt;size.min = r.min;
		l-&gt;size.max = r.max;
		break;
	case ETextcolor:
		_ctlargcount(l, cp, 2);
		_setctlimage(l, &amp;l-&gt;textcolor, cp-&gt;args[1]);
		break;
	case EValue:
		_ctlargcount(l, cp, 2);
		if(strcmp(cp-&gt;args[1], l-&gt;text) != 0){
			free(l-&gt;text);
			l-&gt;text = ctlstrdup(cp-&gt;args[1]);
			labelshow(l);
		}
		break;
	}
}

Control*
createlabel(Controlset *cs, char *name)
{
	Label *l;

	l = (Label*)_createctl(cs, "label", sizeof(Label), name);
	l-&gt;text = ctlstrdup("");
	l-&gt;image = _getctlimage("white");
	l-&gt;textcolor = _getctlimage("black");
	l-&gt;bordercolor = _getctlimage("black");
	l-&gt;font = _getctlfont("font");
	l-&gt;border = 0;
	l-&gt;ctl = labelctl;
	l-&gt;exit = labelfree;
	return (Control *)l;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

