<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/menu.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/menu.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Menu0 Menu0;	/* Menu is taken by mouse.h */

struct Menu0
{
	Control;
	CImage	*image;
	CImage	*bordercolor;
	CImage	*textcolor;
	CImage	*selectcolor;
	CImage	*selecttextcolor;
	CFont	*font;
	char		**line;
	int		nline;
	int		border;
	int		align;
	Image	*window;
	int		visible;	/* state of menu */
	int		selection;		/* currently selected line; -1 == none */
	int		prevsel;	/* previous selection */
	int		lastbut;	/* previous state of mouse button */
};

enum{
	EAdd,
	EAlign,
	EBorder,
	EBordercolor,
	EFocus,
	EFont,
	EFormat,
	EHide,
	EImage,
	ERect,
	EReveal,
	ESelectcolor,
	ESelecttextcolor,
	EShow,
	ESize,
	ETextcolor,
	EWindow,
};

static char *cmds[] = {
	[EAdd] = 			"add",
	[EAlign] = 			"align",
	[EBorder] = 		"border",
	[EBordercolor] =	"bordercolor",
	[EFocus] = 		"focus",
	[EFont] =			"font",
	[EFormat] = 		"format",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ERect] =			"rect",
	[EReveal] =		"reveal",
	[ESelectcolor] =	"selectcolor",
	[ESelecttextcolor] =	"selecttextcolor",
	[EShow] =			"show",
	[ESize] =			"size",
	[ETextcolor] =		"textcolor",
	[EWindow] =		"window",
	nil
};

static void	menushow(Menu0*);
static void menuhide(Menu0*);

static void
menufree(Control *c)
{
	Menu0 *m;

	m = (Menu0*)c;
	_putctlfont(m-&gt;font);
	_putctlimage(m-&gt;image);
	_putctlimage(m-&gt;textcolor);
	_putctlimage(m-&gt;bordercolor);
	_putctlimage(m-&gt;selectcolor);
	_putctlimage(m-&gt;selecttextcolor);
}

static void
menushow(Menu0 *m)
{
	Rectangle r, clipr;
	int i, dx, dy, w;
	Font *f;
	Point p, q;
	Image *im, *c;

	if(m-&gt;hidden || m-&gt;window == nil)
		return;

	m-&gt;visible = 1;
	f = m-&gt;font-&gt;font;
	draw(m-&gt;window, m-&gt;rect, m-&gt;image-&gt;image, nil, m-&gt;image-&gt;image-&gt;r.min);
	if(m-&gt;border &gt; 0)
		border(m-&gt;window, m-&gt;rect, m-&gt;border, m-&gt;bordercolor-&gt;image, ZP);
	/* text goes here */
	dx = 0;
	for(i=0; i&lt;m-&gt;nline; i++){
		w = stringwidth(f, m-&gt;line[i]);
		if(dx &lt; w)
			dx = w;
	}
	dy = m-&gt;nline*f-&gt;height;
	clipr = insetrect(m-&gt;rect, m-&gt;border);
	p = _ctlalignpoint(clipr, dx, dy, m-&gt;align);
	im = m-&gt;textcolor-&gt;image;
//	if(m-&gt;pressed)
//		im = m-&gt;pressedtextcolor-&gt;image;
	for(i=0; i&lt;m-&gt;nline; i++){
		r.min = p;
		r.max.x = p.x+dx;
		r.max.y = p.y+f-&gt;height;
		c = im;
		if(i == m-&gt;selection){
			draw(m-&gt;window, r, m-&gt;selectcolor-&gt;image, nil, ZP);
			c = m-&gt;selecttextcolor-&gt;image;
		}
		q = _ctlalignpoint(r, stringwidth(f, m-&gt;line[i]), f-&gt;height, m-&gt;align%3);
		_string(m-&gt;window, q, c,
			ZP, f, m-&gt;line[i], nil, strlen(m-&gt;line[i]),
			clipr, nil, ZP, SoverD);
		p.y += f-&gt;height;
	}
//	if(m-&gt;pressed)
//		draw(m-&gt;screen, m-&gt;rect, m-&gt;lighm-&gt;image, m-&gt;mask-&gt;image, m-&gt;mask-&gt;image-&gt;r.min);
	flushimage(display, 1);
}

static Point
menusize(Menu0 *m)
{
	int x, y;
	int i;
	Point p;
	Font *f;

	x = 0;
	y = 0;
	f = m-&gt;font-&gt;font;
	for(i=0; i&lt;m-&gt;nline; i++){
		p = stringsize(f, m-&gt;line[i]);
		if(p.x &gt; x)
			x = p.x;
		y += f-&gt;height;
	}

	return Pt(x+2*m-&gt;border, y+2*m-&gt;border);
}

static void
menuhide(Menu0 *m)
{
	freeimage(m-&gt;window);
	m-&gt;window = nil;
	m-&gt;rect.max.y = m-&gt;rect.min.y;	/* go to zero size */
	m-&gt;lastbut = 0;
	m-&gt;visible = 0;
	if(m-&gt;selection &gt;= 0)
		m-&gt;prevsel = m-&gt;selection;
	m-&gt;selection = -1;
	_ctlfocus(m, 0);
}

static void
menutrack(Control *c, Mouse *ms)
{
	Rectangle r;
	int s;
	Menu0 *m;

	m = (Menu0*)c;
	if(m-&gt;window == nil)
		return;
	if(m-&gt;lastbut &amp;&amp; ms-&gt;buttons==0){	/* menu was released */
		chanprint(m-&gt;event, "%q: value %d", m-&gt;name, m-&gt;selection);
		menuhide(m);
		return;
	}
	m-&gt;lastbut = ms-&gt;buttons;
	r = insetrect(m-&gt;rect, m-&gt;border);
	if(!ptinrect(ms-&gt;xy, r))
		s = -1;
	else{
		s = (ms-&gt;xy.y - r.min.y)/m-&gt;font-&gt;font-&gt;height;
		if(s &lt; 0 || s &gt;= m-&gt;nline)
			s = -1;
	}
	if(m-&gt;visible== 0 || s!=m-&gt;selection){
		m-&gt;selection = s;
		menushow(m);
	}
}

static void
menuctl(Control *c, CParse *cp)
{
	int up, cmd, h;
	Rectangle r;
	Menu0 *m;
	Point diag;

	m = (Menu0*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", m-&gt;name, cp-&gt;str);
		break;
	case EAdd:
		_ctlargcount(m, cp, 2);
		m-&gt;line = ctlrealloc(m-&gt;line, (m-&gt;nline+1)*sizeof(char*));
		m-&gt;line[m-&gt;nline++] = ctlstrdup(cp-&gt;args[1]);
		menushow(m);
		break;
	case EAlign:
		_ctlargcount(m, cp, 2);
		m-&gt;align = _ctlalignment(cp-&gt;args[1]);
		menushow(m);
		break;
	case EBorder:
		_ctlargcount(m, cp, 2);
		m-&gt;border = cp-&gt;iargs[1];
		menushow(m);
		break;
	case EBordercolor:
		_ctlargcount(m, cp, 2);
		_setctlimage(m, &amp;m-&gt;bordercolor, cp-&gt;args[1]);
		menushow(m);
		break;
	case EFocus:
		_ctlargcount(m, cp, 2);
		if(atoi(cp-&gt;args[1]) == 0)
			menuhide(m);
		break;
	case EFont:
		_ctlargcount(m, cp, 2);
		_setctlfont(m, &amp;m-&gt;font, cp-&gt;args[1]);
		break;
	case EFormat:
		_ctlargcount(m, cp, 2);
		m-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(m, cp, 1);
		m-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(m, cp, 2);
		_setctlimage(m, &amp;m-&gt;image, cp-&gt;args[1]);
		menushow(m);
		break;
	case ERect:
		_ctlargcount(m, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;0 || Dy(r)&lt;0)
			ctlerror("%q: bad rectangle: %s", m-&gt;name, cp-&gt;str);
		m-&gt;rect = r;
		menushow(m);
		break;
	case EReveal:
		_ctlargcount(m, cp, 1);
		m-&gt;hidden = 0;
		menushow(m);
		break;
	case ESelectcolor:
		_ctlargcount(m, cp, 2);
		_setctlimage(m, &amp;m-&gt;selectcolor, cp-&gt;args[1]);
		menushow(m);
		break;
	case ESelecttextcolor:
		_ctlargcount(m, cp, 2);
		_setctlimage(m, &amp;m-&gt;selecttextcolor, cp-&gt;args[1]);
		menushow(m);
		break;
	case EShow:
		_ctlargcount(m, cp, 1);
		menushow(m);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(m, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", m-&gt;name, cp-&gt;str);
		m-&gt;size.min = r.min;
		m-&gt;size.max = r.max;
		break;
	case ETextcolor:
		_ctlargcount(m, cp, 2);
		_setctlimage(m, &amp;m-&gt;textcolor, cp-&gt;args[1]);
		menushow(m);
		break;
	case EWindow:
		/* no args == toggle; otherwise 0 or 1 for state of window */
		if(cp-&gt;nargs &gt;= 2)
			up = cp-&gt;iargs[1];
		else
			up = (m-&gt;window == nil);
		if(!up){	/* take window down */
			if(m-&gt;window)
				menuhide(m);
			break;
		}
		if(m-&gt;window != nil)
			break;
		diag = menusize(m);
		m-&gt;rect.max.x = m-&gt;rect.min.x + diag.x;
		m-&gt;rect.max.y = m-&gt;rect.min.y + diag.y;
		m-&gt;window = allocwindow(_screen, m-&gt;rect, Refbackup, DWhite);
		if(m-&gt;window == nil)
			m-&gt;window = m-&gt;screen;
		up = m-&gt;prevsel;
		if(up&lt;0 || up&gt;=m-&gt;nline)
			up = 0;
		m-&gt;selection = up;
		menushow(m);
		h = m-&gt;font-&gt;font-&gt;height;
		moveto(m-&gt;controlset-&gt;mousectl,
			Pt(m-&gt;rect.min.x+Dx(m-&gt;rect)/2, m-&gt;rect.min.y+up*h+h/2));
//		_ctlfocus(m, 1);
		break;
	}
}

Control*
createmenu(Controlset *cs, char *name)
{
	Menu0 *m;

	m = (Menu0*)_createctl(cs, "menu", sizeof(Menu0), name);
	m-&gt;font = _getctlfont("font");
	m-&gt;image = _getctlimage("white");
	m-&gt;textcolor = _getctlimage("black");
	m-&gt;selectcolor = _getctlimage("yellow");
	m-&gt;selecttextcolor = _getctlimage("black");
	m-&gt;bordercolor = _getctlimage("black");
	m-&gt;format = ctlstrdup("%q: value %d");
	m-&gt;border = 0;
	m-&gt;align = Aupperleft;
	m-&gt;visible = 0;
	m-&gt;window = nil;
	m-&gt;lastbut = 0;
	m-&gt;selection = -1;
	m-&gt;mouse = menutrack;
	m-&gt;ctl = menuctl;
	m-&gt;exit = menufree;
	return (Control *)m;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

