<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/radiobutton.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/radiobutton.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Radio Radio;

struct Radio
{
	Control;
	int		value;
	int		lastbut;
	Control	**buttons;
	int		nbuttons;
	char		*eventstr;
};

enum{
	EAdd,
	EButton,
	EFocus,
	EFormat,
	EHide,
	ERect,
	EReveal,
	EShow,
	ESize,
	EValue,
};

static char *cmds[] = {
	[EAdd] =		"add",
	[EButton] =	"button",
	[EFocus] = 	"focus",
	[EFormat] = 	"format",
	[EHide] =		"hide",
	[ERect] =		"rect",
	[EReveal] =	"reveal",
	[EShow] =		"show",
	[ESize] =		"size",
	[EValue] =		"value",
	nil
};

static void	radioshow(Radio*);
static void	radiofree(Radio*);

static void
radiomouse(Control *c, Mouse *m)
{
	Radio *r;
	int i;

	r = (Radio*)c;
	for(i=0; i&lt;r-&gt;nbuttons; i++)
		if(ptinrect(m-&gt;xy, r-&gt;buttons[i]-&gt;rect) &amp;&amp; r-&gt;buttons[i]-&gt;mouse){
			(r-&gt;buttons[i]-&gt;mouse)(r-&gt;buttons[i], m);
			break;
		}
}

static void
radiofree(Radio*)
{
}

static void
radioshow(Radio *r)
{
	int i;

	if (r-&gt;hidden)
		return;
	for(i=0; i&lt;r-&gt;nbuttons; i++){
		_ctlprint(r-&gt;buttons[i], "value %d", (r-&gt;value==i));
		_ctlprint(r-&gt;buttons[i], "show");
	}
}

static void
radioctl(Control *c, CParse *cp)
{
	int cmd, i;
	Rectangle rect;
	Radio *r;
	char fmt[256];

	r = (Radio*)c;

	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", r-&gt;name, cp-&gt;str);
		break;
	case EAdd:
		_ctlargcount(r, cp, 2);
		c = controlcalled(cp-&gt;args[1]);
		if(c == nil)
			ctlerror("%q: can't add %s: %r", r-&gt;name, cp-&gt;args[1]);
		snprint(fmt, sizeof fmt, "%%q: %q button %%d", r-&gt;name);
		_ctlprint(c, "format %q", fmt);
		controlwire(c, "event", c-&gt;controlset-&gt;ctl);
		r-&gt;buttons = ctlrealloc(r-&gt;buttons, (r-&gt;nbuttons+1)*sizeof(Control*));
		r-&gt;buttons[r-&gt;nbuttons] = c;
		r-&gt;nbuttons++;
		r-&gt;value = -1;
		radioshow(r);
		break;
	case EButton:
		if (cp-&gt;sender == nil)
			ctlerror("%q: senderless buttonevent: %q", r-&gt;name, cp-&gt;str);
		c = controlcalled(cp-&gt;sender);
		for(i=0; i&lt;r-&gt;nbuttons; i++)
			if (c == r-&gt;buttons[i])
				break;
		if (i == r-&gt;nbuttons)
			ctlerror("%q: not my event: %q", r-&gt;name, cp-&gt;str);
		if(cp-&gt;iargs[1] == 0){
			/* button was turned off; turn it back on */
			_ctlprint(c, "value 1");
		}else{
			r-&gt;value = i;
			chanprint(r-&gt;event, r-&gt;format, r-&gt;name, i);
			radioshow(r);
		}
		break;
	case EFormat:
		_ctlargcount(r, cp, 2);
		r-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(r, cp, 1);
		r-&gt;hidden = 1;
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case ERect:
		_ctlargcount(r, cp, 5);
		rect.min.x = cp-&gt;iargs[1];
		rect.min.y = cp-&gt;iargs[2];
		rect.max.x = cp-&gt;iargs[3];
		rect.max.y = cp-&gt;iargs[4];
		r-&gt;rect = rect;
		break;
	case EReveal:
		_ctlargcount(r, cp, 1);
		r-&gt;hidden = 0;
		radioshow(r);
		break;
	case EShow:
		_ctlargcount(r, cp, 1);
		radioshow(r);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			rect.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(r, cp, 5);
			rect.max.x = cp-&gt;iargs[3];
			rect.max.y = cp-&gt;iargs[4];
		}
		rect.min.x = cp-&gt;iargs[1];
		rect.min.y = cp-&gt;iargs[2];
		if(rect.min.x&lt;=0 || rect.min.y&lt;=0 || rect.max.x&lt;=0 || rect.max.y&lt;=0 || rect.max.x &lt; rect.min.x || rect.max.y &lt; rect.min.y)
			ctlerror("%q: bad sizes: %s", r-&gt;name, cp-&gt;str);
		r-&gt;size.min = rect.min;
		r-&gt;size.max = rect.max;
		break;
	case EValue:
		_ctlargcount(r, cp, 2);
		r-&gt;value = cp-&gt;iargs[1];
		radioshow(r);
		break;
	}
}

Control*
createradiobutton(Controlset *cs, char *name)
{
	Radio *r;

	r = (Radio*)_createctl(cs, "label", sizeof(Radio), name);
	r-&gt;format = ctlstrdup("%q: value %d");
	r-&gt;value = -1;	/* nobody set at first */
	r-&gt;mouse = radiomouse;
	r-&gt;ctl = radioctl;
	return (Control*)r;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

