<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/slider.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/slider.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Slider Slider;

struct Slider
{
	Control;
	int		border;
	CImage	*image;
	CImage	*textcolor;
	CImage	*bordercolor;
	CImage	*indicatorcolor;
	int		absolute;
	int		max;
	int		vis;
	int		value;
	int		clamphigh;
	int		clamplow;
	int		horizontal;
	int		lastbut;
};

enum{
	EAbsolute,
	EBorder,
	EBordercolor,
	EClamp,
	EFocus,
	EFormat,
	EHide,
	EImage,
	EIndicatorcolor,
	EMax,
	EOrient,
	ERect,
	EReveal,
	EShow,
	ESize,
	EValue,
	EVis,
};

static char *cmds[] = {
	[EAbsolute] =		"absolute",
	[EBorder] =		"border",
	[EBordercolor] =	"bordercolor",
	[EClamp] =		"clamp",
	[EFocus] = 		"focus",
	[EFormat] = 		"format",
	[EHide] =			"hide",
	[EImage] =		"image",
	[EIndicatorcolor] =	"indicatorcolor",
	[EMax] =			"max",
	[EOrient] =		"orient",
	[ERect] =			"rect",
	[EReveal] =		"reveal",
	[EShow] =			"show",
	[ESize] =			"size",
	[EValue] =			"value",
	[EVis] =			"vis",
};

static void
sliderfree(Control *c)
{
	Slider *s;

	s = (Slider*)c;
	_putctlimage(s-&gt;image);
	_putctlimage(s-&gt;textcolor);
	_putctlimage(s-&gt;bordercolor);
	_putctlimage(s-&gt;indicatorcolor);
}

static void
slidershow(Slider *s)
{
	Rectangle r, t;
	int l, h, d;

	if (s-&gt;hidden)
		return;
	r = s-&gt;rect;
	draw(s-&gt;screen, r, s-&gt;image-&gt;image, nil, s-&gt;image-&gt;image-&gt;r.min);
	if(s-&gt;border &gt; 0){
		border(s-&gt;screen, r, s-&gt;border, s-&gt;bordercolor-&gt;image, s-&gt;bordercolor-&gt;image-&gt;r.min);
		r = insetrect(r, s-&gt;border);
	}
	if(s-&gt;max &lt;= 0)
		return;
	if(s-&gt;horizontal)
		d = Dx(r);
	else
		d = Dy(r);
	l = muldiv(s-&gt;value, d, s-&gt;max);
	h = muldiv(s-&gt;value+s-&gt;vis, d, s-&gt;max);
	if(s-&gt;clamplow &amp;&amp; s-&gt;clamphigh){
		l = 0;
		h = d;
	}else if(s-&gt;clamplow){
		h = l;
		l = 0;
	}else if(s-&gt;clamphigh)
		h = d;
	t = r;
	if(s-&gt;horizontal){
		r.max.x = r.min.x+h;
		r.min.x += l;
	}else{
		r.max.y = r.min.y+h;
		r.min.y += l;
	}
	if(rectclip(&amp;r, t))
		draw(s-&gt;screen, r, s-&gt;indicatorcolor-&gt;image, nil, s-&gt;indicatorcolor-&gt;image-&gt;r.min);
	flushimage(display, 1);
}

static void
sliderctl(Control *c, CParse *cp)
{
	int cmd, prev;
	Rectangle r;
	Slider *s;

	s = (Slider*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", s-&gt;name, cp-&gt;str);
		break;
	case EAbsolute:
		_ctlargcount(s, cp, 2);
		s-&gt;absolute = cp-&gt;iargs[1];
		break;
	case EBorder:
		_ctlargcount(s, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", s-&gt;name, cp-&gt;str);
		s-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(s, cp, 2);
		_setctlimage(s, &amp;s-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EClamp:
		_ctlargcount(s, cp, 3);
		if(strcmp(cp-&gt;args[1], "high") == 0)
			s-&gt;clamphigh = cp-&gt;iargs[2];
		else if(strcmp(cp-&gt;args[1], "low") == 0)
			s-&gt;clamplow = cp-&gt;iargs[2];
		else
			ctlerror("%q: unrecognized clamp: %s", s-&gt;name, cp-&gt;str);
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case EFormat:
		_ctlargcount(s, cp, 2);
		s-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(s, cp, 1);
		s-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(s, cp, 2);
		_setctlimage(s, &amp;s-&gt;image, cp-&gt;args[1]);
		break;
	case EIndicatorcolor:
		_ctlargcount(s, cp, 2);
		_setctlimage(s, &amp;s-&gt;indicatorcolor, cp-&gt;args[1]);
		break;
	case EMax:
		_ctlargcount(s, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: negative max value: %s", s-&gt;name, cp-&gt;str);
		if(s-&gt;max != cp-&gt;iargs[1]){
			s-&gt;max = cp-&gt;iargs[1];
			slidershow(s);
		}
		break;
	case EOrient:
		_ctlargcount(s, cp, 2);
		prev = s-&gt;horizontal;
		if(strncmp(cp-&gt;args[1], "hor", 3) == 0)
			s-&gt;horizontal = 1;
		else if(strncmp(cp-&gt;args[1], "ver", 3) == 0)
			s-&gt;horizontal = 0;
		else
			ctlerror("%q: unrecognized orientation: %s", s-&gt;name, cp-&gt;str);
		if(s-&gt;horizontal != prev)
			slidershow(s);
		break;
	case ERect:
		_ctlargcount(s, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", s-&gt;name, cp-&gt;str);
		s-&gt;rect = r;
		break;
	case EReveal:
		_ctlargcount(s, cp, 1);
		s-&gt;hidden = 0;
		slidershow(s);
		break;
	case EShow:
		_ctlargcount(s, cp, 1);
		slidershow(s);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(s, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", s-&gt;name, cp-&gt;str);
		s-&gt;size.min = r.min;
		s-&gt;size.max = r.max;
		break;
	case EValue:
		_ctlargcount(s, cp, 2);
		if(s-&gt;value != cp-&gt;iargs[1]){
			s-&gt;value = cp-&gt;iargs[1];
			slidershow(s);
		}
		break;
	case EVis:
		_ctlargcount(s, cp, 2);
		if(s-&gt;vis != cp-&gt;iargs[1]){
			s-&gt;vis = cp-&gt;iargs[1];
			slidershow(s);
		}
		break;
	}
}

static void
slidermouse(Control *c, Mouse *m)
{
	Rectangle r;
	int v, l, d, b;
	Slider *s;

	s =(Slider*)c;
	if(m-&gt;buttons == 0){
		/* buttons now up */
		s-&gt;lastbut = 0;
		return;
	}
	if(!s-&gt;absolute &amp;&amp; s-&gt;lastbut==m-&gt;buttons &amp;&amp; s-&gt;lastbut!=2){
		/* clicks only on buttons 1 &amp; 3; continuous motion on 2 (or when absolute) */
		return;
	}
	if(s-&gt;lastbut!=0 &amp;&amp; m-&gt;buttons!=s-&gt;lastbut){
		/* buttons down have changed; wait for button up */
		return;
	}
	s-&gt;lastbut = m-&gt;buttons;

	r = insetrect(s-&gt;rect, s-&gt;border);
	if(s-&gt;horizontal){
		v = m-&gt;xy.x - r.min.x;
		d = Dx(r);
	}else{
		v = m-&gt;xy.y - r.min.y;
		d = Dy(r);
	}
	if(s-&gt;absolute)
		b = 2;
	else
		b = m-&gt;buttons;
	switch(b){
	default:
		return;
	case 1:
		l = s-&gt;value - muldiv(v, s-&gt;vis, d);
		break;
	case 2:
		l = muldiv(v, s-&gt;max, d);
		break;
	case 4:
		l = s-&gt;value + muldiv(v, s-&gt;vis, d);
		break;
	}
	if(l &lt; 0)
		l = 0;
	if(l &gt; s-&gt;max)
		l = s-&gt;max;
	if(l != s-&gt;value){
		s-&gt;value = l;
		chanprint(s-&gt;event, s-&gt;format, s-&gt;name, s-&gt;value);
		slidershow(s);
	}
}

Control*
createslider(Controlset *cs, char *name)
{
	Slider *s;

	s = (Slider*)_createctl(cs, "slider", sizeof(Slider), name);
	s-&gt;image = _getctlimage("white");
	s-&gt;textcolor = _getctlimage("black");
	s-&gt;bordercolor = _getctlimage("black");
	s-&gt;indicatorcolor = _getctlimage("black");
	s-&gt;format = ctlstrdup("%q: value %d");
	s-&gt;border = 0;
	s-&gt;mouse = slidermouse;
	s-&gt;ctl = sliderctl;
	s-&gt;exit = sliderfree;
	return (Control*)s;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

