<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/text.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/text.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

static int debug = 0;

typedef struct Text Text;

struct Text
{
	Control;
	int		border;
	int		topline;
	int		scroll;
	int		nvis;
	int		lastbut;
	CFont	*font;
	CImage	*image;
	CImage	*textcolor;
	CImage	*bordercolor;
	CImage	*selectcolor;
	CImage	*selectingcolor;
	Rune		**line;
	int		selectmode;	// Selsingle, Selmulti
	int		selectstyle;	// Seldown, Selup (use Selup only with Selsingle)
	uchar	*selected;
	int		nline;
	int		warp;
	int		align;
	int		sel;		// line nr of selection made by last button down
	int		but;		// last button down (still being hold)
	int		offsel;	// we are on selection
};

enum
{
	Selsingle,
	Selmulti,
	Seldown,
	Selup,
};

enum{
	EAccumulate,
	EAdd,
	EAlign,
	EBorder,
	EBordercolor,
	EClear,
	EDelete,
	EFocus,
	EFont,
	EHide,
	EImage,
	ERect,
	EReplace,
	EReveal,
	EScroll,
	ESelect,
	ESelectcolor,
	ESelectingcolor,
	ESelectmode,
	ESelectstyle,
	EShow,
	ESize,
	ETextcolor,
	ETopline,
	EValue,
	EWarp,
};

static char *cmds[] = {
	[EAccumulate] =	"accumulate",
	[EAdd] =			"add",
	[EAlign] =			"align",
	[EBorder] =		"border",
	[EBordercolor] =	"bordercolor",
	[EClear] =			"clear",
	[EDelete] =		"delete",
	[EFocus] = 		"focus",
	[EFont] =			"font",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ERect] =			"rect",
	[EReplace] =		"replace",
	[EReveal] =		"reveal",
	[EScroll] =			"scroll",
	[ESelect] =		"select",
	[ESelectcolor] =	"selectcolor",
	[ESelectingcolor] =	"selectingcolor",
	[ESelectmode] =	"selectmode",
	[ESelectstyle] =		"selectstyle",
	[EShow] =			"show",
	[ESize] =			"size",
	[ETextcolor] =		"textcolor",
	[ETopline] =		"topline",
	[EValue] =			"value",
	[EWarp] =			"warp",
	nil
};

static void	textshow(Text*);
static void	texttogglei(Text*, int);
static int	textline(Text*, Point);
static int	texttoggle(Text*, Point);

static void
textmouse(Control *c, Mouse *m)
{
	Text *t;
	int sel;

	t = (Text*)c;
	if (debug) fprint(2, "textmouse %s t-&gt;lastbut %d; m-&gt;buttons %d\n", t-&gt;name, t-&gt;lastbut, m-&gt;buttons);
	if (t-&gt;warp &gt;= 0)
		return;
	if ((t-&gt;selectstyle == Selup) &amp;&amp; (m-&gt;buttons&amp;7)) {
		sel = textline(t, m-&gt;xy);
		if (t-&gt;sel &gt;= 0) {
//			if (debug) fprint(2, "textmouse Selup %q sel=%d t-&gt;sel=%d t-&gt;but=%d\n",
//						t-&gt;name, sel, t-&gt;sel, t-&gt;but);
			t-&gt;offsel = (sel == t-&gt;sel) ? 0 : 1;
			if ((sel == t-&gt;sel &amp;&amp;
				    ((t-&gt;selected[t-&gt;sel] &amp;&amp; !t-&gt;but) ||
				     ((!t-&gt;selected[t-&gt;sel]) &amp;&amp; t-&gt;but))) ||
			    (sel != t-&gt;sel &amp;&amp;
				     ((t-&gt;selected[t-&gt;sel] &amp;&amp; t-&gt;but) ||
                                         ((!t-&gt;selected[t-&gt;sel]) &amp;&amp; (!t-&gt;but))))) {
				texttogglei(t, t-&gt;sel);
			}
		}
	}
	if(t-&gt;lastbut != (m-&gt;buttons&amp;7)){
		if(m-&gt;buttons &amp; 7){
			sel = texttoggle(t, m-&gt;xy);
			if(sel &gt;= 0) {
				if (t-&gt;selectstyle == Seldown) {
					chanprint(t-&gt;event, "%q: select %d %d",
						t-&gt;name, sel, t-&gt;selected[sel] ? (m-&gt;buttons &amp; 7) : 0);
					if (debug) fprint(2, "textmouse Seldown event %q: select %d %d\n",
						t-&gt;name, sel, t-&gt;selected[sel] ? (m-&gt;buttons &amp; 7) : 0);
				} else {
					if (debug) fprint(2, "textmouse Selup no event yet %q: select %d %d\n",
						t-&gt;name, sel, t-&gt;selected[sel] ? (m-&gt;buttons &amp; 7) : 0);
					t-&gt;sel = sel;
					t-&gt;but =  t-&gt;selected[sel] ? (m-&gt;buttons &amp; 7) : 0;
				}
			}
		} else if (t-&gt;selectstyle == Selup) {
			sel = textline(t, m-&gt;xy);
			t-&gt;offsel = 0;
			if ((sel &gt;= 0) &amp;&amp; (sel == t-&gt;sel)) {
				chanprint(t-&gt;event, "%q: select %d %d",
					t-&gt;name, sel, t-&gt;but);
				if (debug) fprint(2, "textmouse Selup event %q: select %d %d\n",
					t-&gt;name, sel, t-&gt;but);
			} else if (sel != t-&gt;sel) {
				if  ((t-&gt;selected[t-&gt;sel] &amp;&amp; t-&gt;but) ||
                                         ((!t-&gt;selected[t-&gt;sel]) &amp;&amp; (!t-&gt;but))) {
					texttogglei(t, t-&gt;sel);
				} else {
					textshow(t);
				}
				if (debug) fprint(2, "textmouse Selup cancel %q: select %d %d\n",
					t-&gt;name, sel, t-&gt;but);
			}
			t-&gt;sel = -1;
			t-&gt;but = 0;
		}
		t-&gt;lastbut = m-&gt;buttons &amp; 7;
	}
}

static void
textfree(Control *c)
{
	int i;
	Text *t;

	t = (Text*)c;
	_putctlfont(t-&gt;font);
	_putctlimage(t-&gt;image);
	_putctlimage(t-&gt;textcolor);
	_putctlimage(t-&gt;bordercolor);
	_putctlimage(t-&gt;selectcolor);
	_putctlimage(t-&gt;selectingcolor);
	for(i=0; i&lt;t-&gt;nline; i++)
		free(t-&gt;line[i]);
	free(t-&gt;line);
	free(t-&gt;selected);
}

static void
textshow(Text *t)
{
	Rectangle r, tr;
	Point p;
	int i, ntext;
	Font *f;
	Rune *text;

	if (t-&gt;hidden)
		return;
	r = t-&gt;rect;
	f = t-&gt;font-&gt;font;
	draw(t-&gt;screen, r, t-&gt;image-&gt;image, nil, t-&gt;image-&gt;image-&gt;r.min);
	if(t-&gt;border &gt; 0){
		border(t-&gt;screen, r, t-&gt;border, t-&gt;bordercolor-&gt;image, t-&gt;bordercolor-&gt;image-&gt;r.min);
		r = insetrect(r, t-&gt;border);
	}
	tr = r;
	t-&gt;nvis = Dy(r)/f-&gt;height;
	for(i=t-&gt;topline; i&lt;t-&gt;nline &amp;&amp; i&lt;t-&gt;topline+t-&gt;nvis; i++){
		text = t-&gt;line[i];
		ntext = runestrlen(text);
		r.max.y = r.min.y+f-&gt;height;
		if(t-&gt;sel == i &amp;&amp; t-&gt;offsel)
			draw(t-&gt;screen, r, t-&gt;selectingcolor-&gt;image, nil, ZP);
		else if(t-&gt;selected[i])
			draw(t-&gt;screen, r, t-&gt;selectcolor-&gt;image, nil, ZP);
		p = _ctlalignpoint(r,
			runestringnwidth(f, text, ntext),
			f-&gt;height, t-&gt;align);
		if(t-&gt;warp == i) {
			Point p2;
			 p2.x = p.x + 0.5*runestringnwidth(f, text, ntext);
			 p2.y = p.y + 0.5*f-&gt;height;
			moveto(t-&gt;controlset-&gt;mousectl, p2);
			t-&gt;warp = -1;
		}
		_string(t-&gt;screen, p, t-&gt;textcolor-&gt;image,
			ZP, f, nil, text, ntext, tr,
			nil, ZP, SoverD);
		r.min.y += f-&gt;height;
	}
	flushimage(display, 1);
}

static void
textctl(Control *c, CParse *cp)
{
	int cmd, i, n;
	Rectangle r;
	Text *t;
	Rune *rp;

	t = (Text*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", t-&gt;name, cp-&gt;str);
		break;
	case EAlign:
		_ctlargcount(t, cp, 2);
		t-&gt;align = _ctlalignment(cp-&gt;args[1]);
		break;
	case EBorder:
		_ctlargcount(t, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", t-&gt;name, cp-&gt;str);
		t-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EClear:
		_ctlargcount(t, cp, 1);
		for(i=0; i&lt;t-&gt;nline; i++)
			free(t-&gt;line[i]);
		free(t-&gt;line);
		free(t-&gt;selected);
		t-&gt;line = ctlmalloc(sizeof(Rune*));
		t-&gt;selected = ctlmalloc(1);
		t-&gt;nline = 0;
		textshow(t);
		break;
	case EDelete:
		_ctlargcount(t, cp, 2);
		i = cp-&gt;iargs[1];
		if(i&lt;0 || i&gt;=t-&gt;nline)
			ctlerror("%q: line number out of range: %s", t-&gt;name, cp-&gt;str);
		free(t-&gt;line[i]);
		memmove(t-&gt;line+i, t-&gt;line+i+1, (t-&gt;nline-(i+1))*sizeof(Rune*));
		memmove(t-&gt;selected+i, t-&gt;selected+i+1, t-&gt;nline-(i+1));
		t-&gt;nline--;
		textshow(t);
		break;
	case EFocus:
		break;
	case EFont:
		_ctlargcount(t, cp, 2);
		_setctlfont(t, &amp;t-&gt;font, cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(t, cp, 1);
		t-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;image, cp-&gt;args[1]);
		break;
	case ERect:
		_ctlargcount(t, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", t-&gt;name, cp-&gt;str);
		t-&gt;rect = r;
		t-&gt;nvis = (Dy(r)-2*t-&gt;border)/t-&gt;font-&gt;font-&gt;height;
		break;
	case EReplace:
		_ctlargcount(t, cp, 3);
		i = cp-&gt;iargs[1];
		if(i&lt;0 || i&gt;=t-&gt;nline)
			ctlerror("%q: line number out of range: %s", t-&gt;name, cp-&gt;str);
		free(t-&gt;line[i]);
		t-&gt;line[i] = _ctlrunestr(cp-&gt;args[2]);
		textshow(t);
		break;
	case EReveal:
		_ctlargcount(t, cp, 1);
		t-&gt;hidden = 0;
		textshow(t);
		break;
	case EScroll:
		_ctlargcount(t, cp, 2);
		t-&gt;scroll = cp-&gt;iargs[1];
		break;
	case ESelect:
		if(cp-&gt;nargs!=2 &amp;&amp; cp-&gt;nargs!=3)
	badselect:
			ctlerror("%q: bad select message: %s", t-&gt;name, cp-&gt;str);
		if(cp-&gt;nargs == 2){
			if(strcmp(cp-&gt;args[1], "all") == 0){
				memset(t-&gt;selected, 1, t-&gt;nline);
				break;
			}
			if(strcmp(cp-&gt;args[1], "none") == 0){
				memset(t-&gt;selected, 0, t-&gt;nline);
				break;
			}
			if(cp-&gt;args[1][0]&lt;'0' &amp;&amp; '9'&lt;cp-&gt;args[1][0])
				goto badselect;
			texttogglei(t, cp-&gt;iargs[1]);
			break;
		}
		if(cp-&gt;iargs[1]&lt;0 || cp-&gt;iargs[1]&gt;=t-&gt;nline)
			ctlerror("%q: selection index out of range (nline %d): %s", t-&gt;name, t-&gt;nline, cp-&gt;str);
		if(t-&gt;selected[cp-&gt;iargs[1]] != (cp-&gt;iargs[2]!=0))
			texttogglei(t, cp-&gt;iargs[1]);
		break;
	case ESelectcolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;selectcolor, cp-&gt;args[1]);
		break;
	case ESelectmode:
		_ctlargcount(t, cp, 2);
		if(strcmp(cp-&gt;args[1], "single") == 0)
			t-&gt;selectmode = Selsingle;
		else if(strncmp(cp-&gt;args[1], "multi", 5) == 0)
			t-&gt;selectmode = Selmulti;
		break;
	case ESelectstyle:
		_ctlargcount(t, cp, 2);
		 if(strcmp(cp-&gt;args[1], "down") == 0)
			t-&gt;selectstyle = Seldown;
		else if(strcmp(cp-&gt;args[1], "up") == 0)
			t-&gt;selectstyle = Selup;
		break;
	case EShow:
		_ctlargcount(t, cp, 1);
		textshow(t);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(10000, 10000);
		else{
			_ctlargcount(t, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", t-&gt;name, cp-&gt;str);
		t-&gt;size.min = r.min;
		t-&gt;size.max = r.max;
		break;
	case ETextcolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;textcolor, cp-&gt;args[1]);
		break;
	case ETopline:
		_ctlargcount(t, cp, 2);
		i = cp-&gt;iargs[1];
		if(i &lt; 0)
			i = 0;
		if(i &gt; t-&gt;nline)
			i = t-&gt;nline;
		if(t-&gt;topline != i){
			t-&gt;topline = i;
			textshow(t);
		}
		break;
	case EValue:
		/* set contents to single line */
		/* free existing text and fall through to add */
		for(i=0; i&lt;t-&gt;nline; i++){
			free(t-&gt;line[i]);
			t-&gt;line[i] = nil;
		}
		t-&gt;nline = 0;
		t-&gt;topline = 0;
		/* fall through */
	case EAccumulate:
	case EAdd:
		switch (cp-&gt;nargs) {
		default:
			ctlerror("%q: wrong argument count in '%s'", t-&gt;name, cp-&gt;str);
		case 2:
			n = t-&gt;nline;
			break;
		case 3:
			n = cp-&gt;iargs[1];
			if(n&lt;0 || n&gt;t-&gt;nline)
				ctlerror("%q: line number out of range: %s", t-&gt;name, cp-&gt;str);
			break;
		}
		rp = _ctlrunestr(cp-&gt;args[cp-&gt;nargs-1]);
		t-&gt;line = ctlrealloc(t-&gt;line, (t-&gt;nline+1)*sizeof(Rune*));
		memmove(t-&gt;line+n+1, t-&gt;line+n, (t-&gt;nline-n)*sizeof(Rune*));
		t-&gt;line[n] = rp;
		t-&gt;selected = ctlrealloc(t-&gt;selected, t-&gt;nline+1);
		memmove(t-&gt;selected+n+1, t-&gt;selected+n, t-&gt;nline-n);
		t-&gt;selected[n] = (t-&gt;selectmode==Selmulti &amp;&amp; cmd!=EAccumulate);
		t-&gt;nline++;
		if(t-&gt;scroll) {
			if(n &gt; t-&gt;topline + (t-&gt;nvis - 1)){
				t-&gt;topline = n - (t-&gt;nvis - 1);
				if(t-&gt;topline &lt; 0)
					t-&gt;topline = 0;
			}
			if(n &lt; t-&gt;topline)
				t-&gt;topline = n;
		}
		if(cmd != EAccumulate)
			if(t-&gt;scroll || t-&gt;nline&lt;=t-&gt;topline+t-&gt;nvis)
				textshow(t);
		break;
	case EWarp:
		_ctlargcount(t, cp, 2);
		i = cp-&gt;iargs[1];
		if(i &lt;0 || i&gt;=t-&gt;nline)
			ctlerror("%q: selection index out of range (nline %d): %s", t-&gt;name, t-&gt;nline, cp-&gt;str);
		if(i &lt; t-&gt;topline || i &gt;=  t-&gt;topline+t-&gt;nvis){
			t-&gt;topline = i;
		}
		t-&gt;warp = cp-&gt;iargs[1];
		textshow(t);
		t-&gt;warp = -1;
		break;
	}
}

static void
texttogglei(Text *t, int i)
{
	int prev;

	if(t-&gt;selectmode == Selsingle){
		/* clear the others */
		prev = t-&gt;selected[i];
		memset(t-&gt;selected, 0, t-&gt;nline);
		t-&gt;selected[i] = prev;
	}
	t-&gt;selected[i] ^= 1;
	textshow(t);
}

static int
textline(Text *t, Point p)
{
	Rectangle r;
	int i;

	r = t-&gt;rect;
	if(t-&gt;border &gt; 0)
		r = insetrect(r, t-&gt;border);
	if(!ptinrect(p, r))
		return -1;
	i = (p.y-r.min.y)/t-&gt;font-&gt;font-&gt;height;
	i += t-&gt;topline;
	if(i &gt;= t-&gt;nline)
		return -1;
	return i;
}

static int
texttoggle(Text *t, Point p)
{
	int i;

	i = textline(t, p);
	if (i &gt;= 0)
		texttogglei(t, i);
	return i;
}

Control*
createtext(Controlset *cs, char *name)
{
	Text *t;

	t = (Text*)_createctl(cs, "text", sizeof(Text), name);
	t-&gt;line = ctlmalloc(sizeof(Rune*));
	t-&gt;selected = ctlmalloc(1);
	t-&gt;nline = 0;
	t-&gt;image = _getctlimage("white");
	t-&gt;textcolor = _getctlimage("black");
	t-&gt;bordercolor = _getctlimage("black");
	t-&gt;selectcolor = _getctlimage("yellow");
	t-&gt;selectingcolor = _getctlimage("paleyellow");
	t-&gt;font = _getctlfont("font");
	t-&gt;selectmode = Selsingle;
	t-&gt;selectstyle = Selup; // Seldown;
	t-&gt;lastbut = 0;
	t-&gt;mouse = textmouse;
	t-&gt;ctl = textctl;
	t-&gt;exit = textfree;
	t-&gt;warp = -1;
	t-&gt;sel = -1;
	t-&gt;offsel = 0;
	t-&gt;but = 0;
	return (Control *)t;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

