<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdisk/disk.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdisk/disk.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;disk.h&gt;

static Disk*
mkwidth(Disk *disk)
{
	char buf[40];

	snprint(buf, sizeof buf, "%lld", disk-&gt;size);
	disk-&gt;width = strlen(buf);
	return disk;
}

/*
 * Discover the disk geometry by various sleazeful means.
 * 
 * First, if there is a partition table in sector 0,
 * see if all the partitions have the same end head
 * and sector; if so, we'll assume that that's the 
 * right count.
 * 
 * If that fails, we'll try looking at the geometry that the ATA
 * driver supplied, if any, and translate that as a
 * BIOS might. 
 * 
 * If that too fails, which should only happen on a SCSI
 * disk with no currently defined partitions, we'll try
 * various common (h, s) pairs used by BIOSes when faking
 * the geometries.
 */
typedef struct Table  Table;
typedef struct Tentry Tentry;
struct Tentry {
	uchar	active;			/* active flag */
	uchar	starth;			/* starting head */
	uchar	starts;			/* starting sector */
	uchar	startc;			/* starting cylinder */
	uchar	type;			/* partition type */
	uchar	endh;			/* ending head */
	uchar	ends;			/* ending sector */
	uchar	endc;			/* ending cylinder */
	uchar	xlba[4];			/* starting LBA from beginning of disc */
	uchar	xsize[4];		/* size in sectors */
};
enum {
	Toffset		= 446,		/* offset of partition table in sector */
	Magic0		= 0x55,
	Magic1		= 0xAA,
	NTentry		= 4,
};
struct Table {
	Tentry	entry[NTentry];
	uchar	magic[2];
};
static int
partitiongeometry(Disk *disk)
{
	char *rawname;
	int i, h, rawfd, s;
	uchar buf[512];
	Table *t;

	if(disk-&gt;c == 0 || disk-&gt;h == 0 || disk-&gt;s == 0)
		return -1;

	t = (Table*)(buf + Toffset);

	/*
	 * look for an MBR first in the /dev/sdXX/data partition, otherwise
	 * attempt to fall back on the current partition.
	 */
	rawname = malloc(strlen(disk-&gt;prefix) + 5);	/* prefix + "data" + nul */
	if(rawname == nil)
		return -1;

	strcpy(rawname, disk-&gt;prefix);
	strcat(rawname, "data");
	rawfd = open(rawname, OREAD);
	free(rawname);
	if(rawfd &gt;= 0
	&amp;&amp; seek(rawfd, 0, 0) &gt;= 0
	&amp;&amp; readn(rawfd, buf, 512) == 512
	&amp;&amp; t-&gt;magic[0] == Magic0
	&amp;&amp; t-&gt;magic[1] == Magic1) {
		close(rawfd);
	} else {
		if(rawfd &gt;= 0)
			close(rawfd);
		if(seek(disk-&gt;fd, 0, 0) &lt; 0
		|| readn(disk-&gt;fd, buf, 512) != 512
		|| t-&gt;magic[0] != Magic0
		|| t-&gt;magic[1] != Magic1) {
			return -1;
		}
	}

	h = s = -1;
	for(i=0; i&lt;NTentry; i++) {
		if(t-&gt;entry[i].type == 0)
			continue;

		t-&gt;entry[i].ends &amp;= 63;
		if(h == -1) {
			h = t-&gt;entry[i].endh;
			s = t-&gt;entry[i].ends;
		} else {
			/*
			 * Only accept the partition info if every
			 * partition is consistent.
			 */
			if(h != t-&gt;entry[i].endh || s != t-&gt;entry[i].ends)
				return -1;
		}
	}

	if(h == -1)
		return -1;

	disk-&gt;h = h+1;	/* heads count from 0 */
	disk-&gt;s = s;	/* sectors count from 1 */
	disk-&gt;c = disk-&gt;secs / (disk-&gt;h*disk-&gt;s);
	disk-&gt;chssrc = Gpart;
	return 0;
}

/*
 * If there is ATA geometry, use it, perhaps massaged.
 */
static int
drivergeometry(Disk *disk)
{
	int m;

	if(disk-&gt;c == 0 || disk-&gt;h == 0 || disk-&gt;s == 0)
		return -1;

	disk-&gt;chssrc = Gdisk;
	if(disk-&gt;c &lt; 1024)
		return 0;

	switch(disk-&gt;h) {
	case 15:
		disk-&gt;h = 255;
		disk-&gt;c /= 17;
		return 0;

	default:
		for(m = 2; m*disk-&gt;h &lt; 256; m *= 2) {
			if(disk-&gt;c/m &lt; 1024) {
				disk-&gt;c /= m;
				disk-&gt;h *= m;
				return 0;
			}
		}

		/* set to 255, 63 and be done with it */
		disk-&gt;h = 255;
		disk-&gt;s = 63;
		disk-&gt;c = disk-&gt;secs / (disk-&gt;h * disk-&gt;s);
		return 0;
	}
}

/*
 * There's no ATA geometry and no partitions.
 * Our guess is as good as anyone's.
 */
static struct {
	int h;
	int s;
} guess[] = {
	64, 32,
	64, 63,
	128, 63,
	255, 63,
};
static int
guessgeometry(Disk *disk)
{
	int i;
	long c;

	disk-&gt;chssrc = Gguess;
	c = 1024;
	for(i=0; i&lt;nelem(guess); i++)
		if(c*guess[i].h*guess[i].s &gt;= disk-&gt;secs) {
			disk-&gt;h = guess[i].h;
			disk-&gt;s = guess[i].s;
			disk-&gt;c = disk-&gt;secs / (disk-&gt;h * disk-&gt;s);
			return 0;
		}

	/* use maximum values */
	disk-&gt;h = 255;
	disk-&gt;s = 63;
	disk-&gt;c = disk-&gt;secs / (disk-&gt;h * disk-&gt;s);
	return 0;
}

static void
findgeometry(Disk *disk)
{
	if(partitiongeometry(disk) &lt; 0
	&amp;&amp; drivergeometry(disk) &lt; 0
	&amp;&amp; guessgeometry(disk) &lt; 0) {	/* can't happen */
		print("we're completely confused about your disk; sorry\n");
		assert(0);
	}
}

static Disk*
openfile(Disk *disk)
{
	Dir *d;

	if((d = dirfstat(disk-&gt;fd)) == nil){
		free(disk);
		return nil;
	}

	disk-&gt;secsize = 512;
	disk-&gt;size = d-&gt;length;
	disk-&gt;secs = disk-&gt;size / disk-&gt;secsize;
	disk-&gt;offset = 0;
	free(d);

	findgeometry(disk);
	return mkwidth(disk);
}

static Disk*
opensd(Disk *disk)
{
	Biobuf b;
	char *p, *f[10];
	int nf;

	Binit(&amp;b, disk-&gt;ctlfd, OREAD);
	while(p = Brdline(&amp;b, '\n')) {
		p[Blinelen(&amp;b)-1] = '\0';
		nf = tokenize(p, f, nelem(f));
		if(nf &gt;= 3 &amp;&amp; strcmp(f[0], "geometry") == 0) {
			disk-&gt;secsize = strtoll(f[2], 0, 0);
			if(nf &gt;= 6) {
				disk-&gt;c = strtol(f[3], 0, 0);
				disk-&gt;h = strtol(f[4], 0, 0);
				disk-&gt;s = strtol(f[5], 0, 0);
			}
		}
		if(nf &gt;= 4 &amp;&amp; strcmp(f[0], "part") == 0 &amp;&amp; strcmp(f[1], disk-&gt;part) == 0) {
			disk-&gt;offset = strtoll(f[2], 0, 0);
			disk-&gt;secs = strtoll(f[3], 0, 0) - disk-&gt;offset;
		}
	}

	
	disk-&gt;size = disk-&gt;secs * disk-&gt;secsize;
	if(disk-&gt;size &lt;= 0) {
		strcpy(disk-&gt;part, "");
		disk-&gt;type = Tfile;
		return openfile(disk);
	}

	findgeometry(disk);
	return mkwidth(disk);
}

Disk*
opendisk(char *disk, int rdonly, int noctl)
{
	char *p, *q;
	Disk *d;

	d = mallocz(sizeof(*d), 1);
	if(d == nil)
		return nil;

	d-&gt;fd = d-&gt;wfd = d-&gt;ctlfd = -1;
	d-&gt;rdonly = rdonly;

	d-&gt;fd = open(disk, OREAD);
	if(d-&gt;fd &lt; 0) {
		werrstr("cannot open disk file");
		free(d);
		return nil;
	}

	if(rdonly == 0) {
		d-&gt;wfd = open(disk, OWRITE);
		if(d-&gt;wfd &lt; 0)
			d-&gt;rdonly = 1;
	}

	if(noctl)
		return openfile(d);

	p = malloc(strlen(disk) + 4);	/* 4: slop for "ctl\0" */
	if(p == nil) {
		close(d-&gt;wfd);
		close(d-&gt;fd);
		free(d);
		return nil;
	}
	strcpy(p, disk);

	/* check for floppy(3) disk */
	if(strlen(p) &gt;= 7) {
		q = p+strlen(p)-7;
		if(q[0] == 'f' &amp;&amp; q[1] == 'd' &amp;&amp; isdigit(q[2]) &amp;&amp; strcmp(q+3, "disk") == 0) {
			strcpy(q+3, "ctl");
			if((d-&gt;ctlfd = open(p, ORDWR)) &gt;= 0) {
				*q = '\0';
				d-&gt;prefix = p;
				d-&gt;type = Tfloppy;
				return openfile(d);
			}
		}
	}

	/* attempt to find sd(3) disk or partition */
	if(q = strrchr(p, '/'))
		q++;
	else
		q = p;

	strcpy(q, "ctl");
	if((d-&gt;ctlfd = open(p, ORDWR)) &gt;= 0) {
		*q = '\0';
		d-&gt;prefix = p;
		d-&gt;type = Tsd;
		d-&gt;part = strdup(disk+(q-p));
		if(d-&gt;part == nil){
			close(d-&gt;ctlfd);
			close(d-&gt;wfd);
			close(d-&gt;fd);
			free(p);
			free(d);
			return nil;
		}
		return opensd(d);
	}

	*q = '\0';
	d-&gt;prefix = p;
	/* assume we just have a normal file */
	d-&gt;type = Tfile;
	return openfile(d);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

