<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/font.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/font.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;

static int	fontresize(Font*, int, int, int);
static int	freeup(Font*);

#define	PJW	0	/* use NUL==pjw for invisible characters */

int
cachechars(Font *f, char **ss, Rune **rr, ushort *cp, int max, int *wp, char **subfontname)
{
	int i, th, sh, h, ld, w, rw, wid, nc;
	char *sp;
	Rune r, *rp, vr;
	ulong a;
	Cacheinfo *c, *tc, *ec;

	if(ss){
		sp = *ss;
		rp = L"";
	}else{
		sp = "";
		rp = *rr;
	}
	wid = 0;
	*subfontname = 0;
	for(i=0; i&lt;max &amp;&amp; (*sp || *rp); sp+=w, rp+=rw){
		if(ss){
			r = *(uchar*)sp;
			if(r &lt; Runeself)
				w = 1;
			else{
				w = chartorune(&amp;vr, sp);
				r = vr;
			}
			rw = 0;
		}else{
			r = *rp;
			w = 0;
			rw = 1;
		}

		sh = (17 * (uint)r) &amp; (f-&gt;ncache-NFLOOK-1);
		c = &amp;f-&gt;cache[sh];
		ec = c+NFLOOK;
		h = sh;
		while(c &lt; ec){
			if(c-&gt;value==r &amp;&amp; c-&gt;age)
				goto Found;
			c++;
			h++;
		}
	
		/*
		 * Not found; toss out oldest entry
		 */
		a = ~0;
		th = sh;
		tc = &amp;f-&gt;cache[th];
		while(tc &lt; ec){
			if(tc-&gt;age &lt; a){
				a = tc-&gt;age;
				h = th;
				c = tc;
			}
			tc++;
			th++;
		}

		if(a &amp;&amp; (f-&gt;age-a)&lt;500){	/* kicking out too recent; resize */
			nc = 2*(f-&gt;ncache-NFLOOK) + NFLOOK;
			if(nc &lt;= MAXFCACHE){
				if(i == 0)
					fontresize(f, f-&gt;width, nc, f-&gt;maxdepth);
				/* else flush first; retry will resize */
				break;
			}
		}

		if(c-&gt;age == f-&gt;age)	/* flush pending string output */
			break;

		ld = loadchar(f, r, c, h, i, subfontname);
		if(ld &lt;= 0){
			if(ld == 0)
				continue;
			break;
		}
		c = &amp;f-&gt;cache[h];	/* may have reallocated f-&gt;cache */
	
	    Found:
		wid += c-&gt;width;
		c-&gt;age = f-&gt;age;
		cp[i] = h;
		i++;
	}
	if(ss)
		*ss = sp;
	else
		*rr = rp;
	*wp = wid;
	return i;
}

void
agefont(Font *f)
{
	Cacheinfo *c, *ec;
	Cachesubf *s, *es;

	f-&gt;age++;
	if(f-&gt;age == 65536){
		/*
		 * Renormalize ages
		 */
		c = f-&gt;cache;
		ec = c+f-&gt;ncache;
		while(c &lt; ec){
			if(c-&gt;age){
				c-&gt;age &gt;&gt;= 2;
				c-&gt;age++;
			}
			c++;
		}
		s = f-&gt;subf;
		es = s+f-&gt;nsubf;
		while(s &lt; es){
			if(s-&gt;age){
				if(s-&gt;age&lt;SUBFAGE &amp;&amp; s-&gt;cf-&gt;name != nil){
					/* clean up */
					if(display &amp;&amp;
					    s-&gt;f != display-&gt;defaultsubfont)
						freesubfont(s-&gt;f);
					s-&gt;cf = nil;
					s-&gt;f = nil;
					s-&gt;age = 0;
				}else{
					s-&gt;age &gt;&gt;= 2;
					s-&gt;age++;
				}
			}
			s++;
		}
		f-&gt;age = (65536&gt;&gt;2) + 1;
	}
}

static Subfont*
cf2subfont(Cachefont *cf, Font *f)
{
	int depth;
	char *name;
	Subfont *sf;

	name = cf-&gt;subfontname;
	if(name == nil){
		if(f-&gt;display &amp;&amp; f-&gt;display-&gt;screenimage)
			depth = f-&gt;display-&gt;screenimage-&gt;depth;
		else
			depth = 8;
		name = subfontname(cf-&gt;name, f-&gt;name, depth);
		if(name == nil)
			return nil;
		cf-&gt;subfontname = name;
	}
	sf = lookupsubfont(f-&gt;display, name);
	return sf;
}

/* return 1 if load succeeded, 0 if failed, -1 if must retry */
int
loadchar(Font *f, Rune r, Cacheinfo *c, int h, int noflush, char **subfontname)
{
	int i, oi, wid, top, bottom;
	Rune pic;
	Fontchar *fi;
	Cachefont *cf;
	Cachesubf *subf, *of;
	uchar *b;

	pic = r;
    Again:
	for(i=0; i&lt;f-&gt;nsub; i++){
		cf = f-&gt;sub[i];
		if(cf-&gt;min&lt;=pic &amp;&amp; pic&lt;=cf-&gt;max)
			goto Found;
	}
    TryPJW:
	if(pic != PJW){
		pic = PJW;
		goto Again;
	}
	return 0;

    Found:
	/*
	 * Choose exact or oldest
	 */
	oi = 0;
	subf = &amp;f-&gt;subf[0];
	for(i=0; i&lt;f-&gt;nsubf; i++){
		if(cf == subf-&gt;cf)
			goto Found2;
		if(subf-&gt;age &lt; f-&gt;subf[oi].age)
			oi = i;
		subf++;
	}
	subf = &amp;f-&gt;subf[oi];

	if(subf-&gt;f){
		if(f-&gt;age-subf-&gt;age&gt;SUBFAGE || f-&gt;nsubf&gt;MAXSUBF){
    Toss:
			/* ancient data; toss */
			freesubfont(subf-&gt;f);
			subf-&gt;cf = nil;
			subf-&gt;f = nil;
			subf-&gt;age = 0;
		}else{				/* too recent; grow instead */
			of = f-&gt;subf;
			f-&gt;subf = malloc((f-&gt;nsubf+DSUBF)*sizeof *subf);
			if(f-&gt;subf == nil){
				f-&gt;subf = of;
				goto Toss;
			}
			memmove(f-&gt;subf, of, (f-&gt;nsubf+DSUBF)*sizeof *subf);
			memset(f-&gt;subf+f-&gt;nsubf, 0, DSUBF*sizeof *subf);
			subf = &amp;f-&gt;subf[f-&gt;nsubf];
			f-&gt;nsubf += DSUBF;
			free(of);
		}
	}
	subf-&gt;age = 0;
	subf-&gt;cf = nil;
	subf-&gt;f = cf2subfont(cf, f);
	if(subf-&gt;f == nil){
		if(cf-&gt;subfontname == nil)
			goto TryPJW;
		*subfontname = cf-&gt;subfontname;
		return -1;
	}

	subf-&gt;cf = cf;
	if(subf-&gt;f-&gt;ascent &gt; f-&gt;ascent &amp;&amp; f-&gt;display){
		/* should print something? this is a mistake in the font file */
		/* must prevent c-&gt;top from going negative when loading cache */
		Image *b;
		int d, t;
		d = subf-&gt;f-&gt;ascent - f-&gt;ascent;
		b = subf-&gt;f-&gt;bits;
		draw(b, b-&gt;r, b, nil, addpt(b-&gt;r.min, Pt(0, d)));
		draw(b, Rect(b-&gt;r.min.x, b-&gt;r.max.y-d, b-&gt;r.max.x, b-&gt;r.max.y), f-&gt;display-&gt;black, nil, b-&gt;r.min);
		for(i=0; i&lt;subf-&gt;f-&gt;n; i++){
			t = subf-&gt;f-&gt;info[i].top-d;
			if(t &lt; 0)
				t = 0;
			subf-&gt;f-&gt;info[i].top = t;
			t = subf-&gt;f-&gt;info[i].bottom-d;
			if(t &lt; 0)
				t = 0;
			subf-&gt;f-&gt;info[i].bottom = t;
		}
		subf-&gt;f-&gt;ascent = f-&gt;ascent;
	}

    Found2:
	subf-&gt;age = f-&gt;age;

	/* possible overflow here, but works out okay */
	pic += cf-&gt;offset;
	pic -= cf-&gt;min;
	if(pic &gt;= subf-&gt;f-&gt;n)
		goto TryPJW;
	fi = &amp;subf-&gt;f-&gt;info[pic];
	if(fi-&gt;width == 0)
		goto TryPJW;
	wid = (fi+1)-&gt;x - fi-&gt;x;
	if(f-&gt;width &lt; wid || f-&gt;width == 0 || f-&gt;maxdepth &lt; subf-&gt;f-&gt;bits-&gt;depth){
		/*
		 * Flush, free, reload (easier than reformatting f-&gt;b)
		 */
		if(noflush)
			return -1;
		if(f-&gt;width &lt; wid)
			f-&gt;width = wid;
		if(f-&gt;maxdepth &lt; subf-&gt;f-&gt;bits-&gt;depth)
			f-&gt;maxdepth = subf-&gt;f-&gt;bits-&gt;depth;
		i = fontresize(f, f-&gt;width, f-&gt;ncache, f-&gt;maxdepth);
		if(i &lt;= 0)
			return i;
		/* c is still valid as didn't reallocate f-&gt;cache */
	}
	c-&gt;value = r;
	top = fi-&gt;top + (f-&gt;ascent-subf-&gt;f-&gt;ascent);
	bottom = fi-&gt;bottom + (f-&gt;ascent-subf-&gt;f-&gt;ascent);
	c-&gt;width = fi-&gt;width;
	c-&gt;x = h*f-&gt;width;
	c-&gt;left = fi-&gt;left;
	if(f-&gt;display == nil)
		return 1;
	flushimage(f-&gt;display, 0);	/* flush any pending errors */
	b = bufimage(f-&gt;display, 37);
	if(b == 0)
		return 0;
	b[0] = 'l';
	BPLONG(b+1, f-&gt;cacheimage-&gt;id);
	BPLONG(b+5, subf-&gt;f-&gt;bits-&gt;id);
	BPSHORT(b+9, c-f-&gt;cache);
	BPLONG(b+11, c-&gt;x);
	BPLONG(b+15, top);
	BPLONG(b+19, c-&gt;x+((fi+1)-&gt;x-fi-&gt;x));
	BPLONG(b+23, bottom);
	BPLONG(b+27, fi-&gt;x);
	BPLONG(b+31, fi-&gt;top);
	b[35] = fi-&gt;left;
	b[36] = fi-&gt;width;
	return 1;
}

/* release all subfonts, return number freed */
static
int
freeup(Font *f)
{
	Cachesubf *s, *es;
	int nf;

	if(f-&gt;sub[0]-&gt;name == nil)	/* font from mkfont; don't free */
		return 0;
	s = f-&gt;subf;
	es = s+f-&gt;nsubf;
	nf = 0;
	while(s &lt; es){
		if(s-&gt;age){
			freesubfont(s-&gt;f);
			s-&gt;cf = nil;
			s-&gt;f = nil;
			s-&gt;age = 0;
			nf++;
		}
		s++;
	}
	return nf;
}

/* return whether resize succeeded &amp;&amp; f-&gt;cache is unchanged */
static int
fontresize(Font *f, int wid, int ncache, int depth)
{
	Cacheinfo *i;
	int ret;
	Image *new;
	uchar *b;
	Display *d;

	ret = 0;
	if(depth &lt;= 0)
		depth = 1;
	if(wid &lt;= 0)
		wid = 1;

	d = f-&gt;display;
	if(d == nil)
		goto Nodisplay;

	new = allocimage(d, Rect(0, 0, ncache*wid, f-&gt;height), CHAN1(CGrey, depth), 0, 0);
	if(new == nil){
		fprint(2, "font cache resize failed: %r\n");
		abort();
		goto Return;
	}
	flushimage(d, 0);	/* flush any pending errors */
	b = bufimage(d, 1+4+4+1);
	if(b == 0){
		freeimage(new);
		goto Return;
	}
	b[0] = 'i';
	BPLONG(b+1, new-&gt;id);
	BPLONG(b+5, ncache);
	b[9] = f-&gt;ascent;
	if(flushimage(d, 0) &lt; 0){
		fprint(2, "resize: init failed: %r\n");
		freeimage(new);
		goto Return;
	}
	freeimage(f-&gt;cacheimage);
	f-&gt;cacheimage = new;
    Nodisplay:
	f-&gt;width = wid;
	f-&gt;maxdepth = depth;
	ret = 1;
	if(f-&gt;ncache != ncache){
		i = malloc(ncache*sizeof f-&gt;cache[0]);
		if(i != nil){
			ret = 0;
			free(f-&gt;cache);
			f-&gt;ncache = ncache;
			f-&gt;cache = i;
		}
		/* else just wipe the cache clean and things will be ok */
	}
    Return:
	memset(f-&gt;cache, 0, f-&gt;ncache*sizeof f-&gt;cache[0]);
	return ret;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

