<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/icossin.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/icossin.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;draw.h&gt;

/*
 * Integer sine and cosine for integral degree argument.
 * Tables computed by (sin,cos)(PI*d/180).
 */
static short sinus[91] = {
	0,	/* 0 */
	18,	/* 1 */
	36,	/* 2 */
	54,	/* 3 */
	71,	/* 4 */
	89,	/* 5 */
	107,	/* 6 */
	125,	/* 7 */
	143,	/* 8 */
	160,	/* 9 */
	178,	/* 10 */
	195,	/* 11 */
	213,	/* 12 */
	230,	/* 13 */
	248,	/* 14 */
	265,	/* 15 */
	282,	/* 16 */
	299,	/* 17 */
	316,	/* 18 */
	333,	/* 19 */
	350,	/* 20 */
	367,	/* 21 */
	384,	/* 22 */
	400,	/* 23 */
	416,	/* 24 */
	433,	/* 25 */
	449,	/* 26 */
	465,	/* 27 */
	481,	/* 28 */
	496,	/* 29 */
	512,	/* 30 */
	527,	/* 31 */
	543,	/* 32 */
	558,	/* 33 */
	573,	/* 34 */
	587,	/* 35 */
	602,	/* 36 */
	616,	/* 37 */
	630,	/* 38 */
	644,	/* 39 */
	658,	/* 40 */
	672,	/* 41 */
	685,	/* 42 */
	698,	/* 43 */
	711,	/* 44 */
	724,	/* 45 */
	737,	/* 46 */
	749,	/* 47 */
	761,	/* 48 */
	773,	/* 49 */
	784,	/* 50 */
	796,	/* 51 */
	807,	/* 52 */
	818,	/* 53 */
	828,	/* 54 */
	839,	/* 55 */
	849,	/* 56 */
	859,	/* 57 */
	868,	/* 58 */
	878,	/* 59 */
	887,	/* 60 */
	896,	/* 61 */
	904,	/* 62 */
	912,	/* 63 */
	920,	/* 64 */
	928,	/* 65 */
	935,	/* 66 */
	943,	/* 67 */
	949,	/* 68 */
	956,	/* 69 */
	962,	/* 70 */
	968,	/* 71 */
	974,	/* 72 */
	979,	/* 73 */
	984,	/* 74 */
	989,	/* 75 */
	994,	/* 76 */
	998,	/* 77 */
	1002,	/* 78 */
	1005,	/* 79 */
	1008,	/* 80 */
	1011,	/* 81 */
	1014,	/* 82 */
	1016,	/* 83 */
	1018,	/* 84 */
	1020,	/* 85 */
	1022,	/* 86 */
	1023,	/* 87 */
	1023,	/* 88 */
	1024,	/* 89 */
	1024,	/* 90 */
};

void
icossin(int deg, int *cosp, int *sinp)
{
	int sinsign, cossign;
	short *stp, *ctp;

	deg %= 360;
	if(deg &lt; 0)
		deg += 360;
	sinsign = 1;
	cossign = 1;
	stp = 0;
	ctp = 0;
	switch(deg/90){
	case 2:
		sinsign = -1;
		cossign = -1;
		deg -= 180;
		/* fall through */
	case 0:
		stp = &amp;sinus[deg];
		ctp = &amp;sinus[90-deg];
		break;
	case 3:
		sinsign = -1;
		cossign = -1;
		deg -= 180;
		/* fall through */
	case 1:
		deg = 180-deg;
		cossign = -cossign;
		stp = &amp;sinus[deg];
		ctp = &amp;sinus[90-deg];
		break;
	}
	*sinp = sinsign*stp[0];
	*cosp = cossign*ctp[0];
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

