<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/init.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/init.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;

Display	*display;
Font	*font;
Image	*screen;
int	_drawdebug = 0;

static char deffontname[] = "*default*";
Screen	*_screen;

int		debuglockdisplay = 0;

static void _closedisplay(Display*, int);

/* note handler */
static void
drawshutdown(void)
{
	Display *d;

	d = display;
	if(d){
		display = nil;
		_closedisplay(d, 1);
	}
}

int
geninitdraw(char *devdir, void(*error)(Display*, char*), char *fontname, char *label, char *windir, int ref)
{
	int fd, n;
	Subfont *df;
	char buf[128];

	display = initdisplay(devdir, windir, error);
	if(display == nil)
		return -1;

	/*
	 * Set up default font
	 */
	df = getdefont(display);
	display-&gt;defaultsubfont = df;
	if(df == nil){
		fprint(2, "imageinit: can't open default subfont: %r\n");
    Error:
		closedisplay(display);
		display = nil;
		return -1;
	}
	if(fontname == nil){
		fd = open("/env/font", OREAD);
		if(fd &gt;= 0){
			n = read(fd, buf, sizeof(buf));
			if(n&gt;0 &amp;&amp; n&lt;sizeof buf-1){
				buf[n] = 0;
				fontname = buf;
			}
			close(fd);
		}
	}
	/*
	 * Build fonts with caches==depth of screen, for speed.
	 * If conversion were faster, we'd use 0 and save memory.
	 */
	if(fontname == nil){
		snprint(buf, sizeof buf, "%d %d\n0 %d\t%s\n", df-&gt;height, df-&gt;ascent,
			df-&gt;n-1, deffontname);
//BUG: Need something better for this	installsubfont("*default*", df);
		font = buildfont(display, buf, deffontname);
		if(font == nil){
			fprint(2, "imageinit: can't open default font: %r\n");
			goto Error;
		}
	}else{
		font = openfont(display, fontname);	/* BUG: grey fonts */
		if(font == nil){
			fprint(2, "imageinit: can't open font %s: %r\n", fontname);
			goto Error;
		}
	}
	display-&gt;defaultfont = font;

	/*
	 * Write label; ignore errors (we might not be running under rio)
	 */
	if(label){
		snprint(buf, sizeof buf, "%s/label", display-&gt;windir);
		fd = open(buf, OREAD);
		if(fd &gt;= 0){
			read(fd, display-&gt;oldlabel, (sizeof display-&gt;oldlabel)-1);
			close(fd);
			fd = create(buf, OWRITE, 0666);
			if(fd &gt;= 0){
				write(fd, label, strlen(label));
				close(fd);
			}
		}
	}

	snprint(buf, sizeof buf, "%s/winname", display-&gt;windir);
	if(gengetwindow(display, buf, &amp;screen, &amp;_screen, ref) &lt; 0)
		goto Error;

	atexit(drawshutdown);

	return 1;
}

int
initdraw(void(*error)(Display*, char*), char *fontname , char *label)
{
	char *dev = "/dev";

	if(access("/dev/draw/new", AEXIST)&lt;0 &amp;&amp; bind("#i", "/dev", MAFTER)&lt;0){
		fprint(2, "imageinit: can't bind /dev/draw: %r\n");
		return -1;
	}
	return geninitdraw(dev, error, fontname, label, dev, Refnone);
}

/*
 * Attach, or possibly reattach, to window.
 * If reattaching, maintain value of screen pointer.
 */
int
gengetwindow(Display *d, char *winname, Image **winp, Screen **scrp, int ref)
{
	int n, fd;
	char buf[64+1];
	Image *image;
	Rectangle r;

	fd = open(winname, OREAD);
	if(fd&lt;0 || (n=read(fd, buf, sizeof buf-1))&lt;=0){
		if((image=d-&gt;image) == nil){
			fprint(2, "gengetwindow: %r\n");
			*winp = nil;
			d-&gt;screenimage = nil;
			return -1;
		}
		strcpy(buf, "noborder");
	}else{
		close(fd);
		buf[n] = '\0';
		if(*winp != nil){
			_freeimage1(*winp);
			freeimage((*scrp)-&gt;image);
			freescreen(*scrp);
			*scrp = nil;
		}
		image = namedimage(d, buf);
		if(image == 0){
			fprint(2, "namedimage %s failed: %r\n", buf);
			*winp = nil;
			d-&gt;screenimage = nil;
			return -1;
		}
		assert(image-&gt;chan != 0);
	}

	d-&gt;screenimage = image;
	*scrp = allocscreen(image, d-&gt;white, 0);
	if(*scrp == nil){
		freeimage(d-&gt;screenimage);
		*winp = nil;
		d-&gt;screenimage = nil;
		return -1;
	}

	r = image-&gt;r;
	if(strncmp(buf, "noborder", 8) != 0)
		r = insetrect(image-&gt;r, Borderwidth);
	*winp = _allocwindow(*winp, *scrp, r, ref, DWhite);
	if(*winp == nil){
		freescreen(*scrp);
		*scrp = nil;
		freeimage(image);
		d-&gt;screenimage = nil;
		return -1;
	}
	d-&gt;screenimage = *winp;
	assert((*winp)-&gt;chan != 0);
	return 1;
}

int
getwindow(Display *d, int ref)
{
	char winname[128];

	snprint(winname, sizeof winname, "%s/winname", d-&gt;windir);
	return gengetwindow(d, winname, &amp;screen, &amp;_screen, ref);
}

#define	NINFO	12*12

Display*
initdisplay(char *dev, char *win, void(*error)(Display*, char*))
{
	char buf[128], info[NINFO+1], *t, isnew;
	int n, datafd, ctlfd, reffd;
	Display *disp;
	Dir *dir;
	Image *image;

	fmtinstall('P', Pfmt);
	fmtinstall('R', Rfmt);
	if(dev == 0)
		dev = "/dev";
	if(win == 0)
		win = "/dev";
	if(strlen(dev)&gt;sizeof buf-25 || strlen(win)&gt;sizeof buf-25){
		werrstr("initdisplay: directory name too long");
		return nil;
	}
	t = strdup(win);
	if(t == nil)
		return nil;

	sprint(buf, "%s/draw/new", dev);
	ctlfd = open(buf, ORDWR|OCEXEC);
	if(ctlfd &lt; 0){
		if(bind("#i", dev, MAFTER) &lt; 0){
    Error1:
			free(t);
			werrstr("initdisplay: %s: %r", buf);
			return 0;
		}
		ctlfd = open(buf, ORDWR|OCEXEC);
	}
	if(ctlfd &lt; 0)
		goto Error1;
	if((n=read(ctlfd, info, sizeof info)) &lt; 12){
    Error2:
		close(ctlfd);
		goto Error1;
	}
	if(n==NINFO+1)
		n = NINFO;
	info[n] = '\0';
	isnew = 0;
	if(n &lt; NINFO)	/* this will do for now, we need something better here */
		isnew = 1;
	sprint(buf, "%s/draw/%d/data", dev, atoi(info+0*12));
	datafd = open(buf, ORDWR|OCEXEC);
	if(datafd &lt; 0)
		goto Error2;
	sprint(buf, "%s/draw/%d/refresh", dev, atoi(info+0*12));
	reffd = open(buf, OREAD|OCEXEC);
	if(reffd &lt; 0){
    Error3:
		close(datafd);
		goto Error2;
	}
	disp = mallocz(sizeof(Display), 1);
	if(disp == 0){
    Error4:
		close(reffd);
		goto Error3;
	}
	image = nil;
	if(0){
    Error5:
		free(image);
		free(disp);
		goto Error4;
	}
	if(n &gt;= NINFO){
		image = mallocz(sizeof(Image), 1);
		if(image == nil)
			goto Error5;
		image-&gt;display = disp;
		image-&gt;id = 0;
		image-&gt;chan = strtochan(info+2*12);
		image-&gt;depth = chantodepth(image-&gt;chan);
		image-&gt;repl = atoi(info+3*12);
		image-&gt;r.min.x = atoi(info+4*12);
		image-&gt;r.min.y = atoi(info+5*12);
		image-&gt;r.max.x = atoi(info+6*12);
		image-&gt;r.max.y = atoi(info+7*12);
		image-&gt;clipr.min.x = atoi(info+8*12);
		image-&gt;clipr.min.y = atoi(info+9*12);
		image-&gt;clipr.max.x = atoi(info+10*12);
		image-&gt;clipr.max.y = atoi(info+11*12);
	}

	disp-&gt;_isnewdisplay = isnew;
	disp-&gt;bufsize = iounit(datafd);
	if(disp-&gt;bufsize &lt;= 0)
		disp-&gt;bufsize = 8000;
	if(disp-&gt;bufsize &lt; 512){
		werrstr("iounit %d too small", disp-&gt;bufsize);
		goto Error5;
	}
	disp-&gt;buf = malloc(disp-&gt;bufsize+5);	/* +5 for flush message */
	if(disp-&gt;buf == nil)
		goto Error5;

	disp-&gt;image = image;
	disp-&gt;dirno = atoi(info+0*12);
	disp-&gt;fd = datafd;
	disp-&gt;ctlfd = ctlfd;
	disp-&gt;reffd = reffd;
	disp-&gt;bufp = disp-&gt;buf;
	disp-&gt;error = error;
	disp-&gt;windir = t;
	disp-&gt;devdir = strdup(dev);
	qlock(&amp;disp-&gt;qlock);
	disp-&gt;white = allocimage(disp, Rect(0, 0, 1, 1), GREY1, 1, DWhite);
	disp-&gt;black = allocimage(disp, Rect(0, 0, 1, 1), GREY1, 1, DBlack);
	if(disp-&gt;white == nil || disp-&gt;black == nil){
		free(disp-&gt;devdir);
		free(disp-&gt;white);
		free(disp-&gt;black);
		goto Error5;
	}
	disp-&gt;opaque = disp-&gt;white;
	disp-&gt;transparent = disp-&gt;black;
	dir = dirfstat(ctlfd);
	if(dir!=nil &amp;&amp; dir-&gt;type=='i'){
		disp-&gt;local = 1;
		disp-&gt;dataqid = dir-&gt;qid.path;
	}
	if(dir!=nil &amp;&amp; dir-&gt;qid.vers==1)	/* other way to tell */
		disp-&gt;_isnewdisplay = 1;
	free(dir);

	return disp;
}

/*
 * Call with d unlocked.
 * Note that disp-&gt;defaultfont and defaultsubfont are not freed here.
 */
void
closedisplay(Display *disp)
{
	_closedisplay(disp, 0);
}

static void
_closedisplay(Display *disp, int isshutdown)
{
	int fd;
	char buf[128];

	if(disp == nil)
		return;
	if(disp == display)
		display = nil;
	if(disp-&gt;oldlabel[0]){
		snprint(buf, sizeof buf, "%s/label", disp-&gt;windir);
		fd = open(buf, OWRITE);
		if(fd &gt;= 0){
			write(fd, disp-&gt;oldlabel, strlen(disp-&gt;oldlabel));
			close(fd);
		}
	}

	/*
	 * if we're shutting down, don't free all the resources.
	 * if other procs are getting shot down by notes too,
	 * one might get shot down while holding the malloc lock.
	 * just let the kernel clean things up when we exit.
	 */
	if(isshutdown)
		return;

	free(disp-&gt;devdir);
	free(disp-&gt;windir);
	freeimage(disp-&gt;white);
	freeimage(disp-&gt;black);
	close(disp-&gt;fd);
	close(disp-&gt;ctlfd);
	/* should cause refresh slave to shut down */
	close(disp-&gt;reffd);
	qunlock(&amp;disp-&gt;qlock);
	free(disp);
}

void
lockdisplay(Display *disp)
{
	if(debuglockdisplay){
		/* avoid busy looping; it's rare we collide anyway */
		while(!canqlock(&amp;disp-&gt;qlock)){
			fprint(1, "proc %d waiting for display lock...\n", getpid());
			sleep(1000);
		}
	}else
		qlock(&amp;disp-&gt;qlock);
}

void
unlockdisplay(Display *disp)
{
	qunlock(&amp;disp-&gt;qlock);
}

void
drawerror(Display *d, char *s)
{
	char err[ERRMAX];

	if(d &amp;&amp; d-&gt;error)
		d-&gt;error(d, s);
	else{
		errstr(err, sizeof err);
		fprint(2, "draw: %s: %s\n", s, err);
		exits(s);
	}
}

static
int
doflush(Display *d)
{
	int n, nn;

	n = d-&gt;bufp-d-&gt;buf;
	if(n &lt;= 0)
		return 1;

	if((nn=write(d-&gt;fd, d-&gt;buf, n)) != n){
		if(_drawdebug)
			fprint(2, "flushimage fail: d=%p: n=%d nn=%d %r\n", d, n, nn); /**/
		d-&gt;bufp = d-&gt;buf;	/* might as well; chance of continuing */
		return -1;
	}
	d-&gt;bufp = d-&gt;buf;
	return 1;
}

int
flushimage(Display *d, int visible)
{
	if(d == nil)
		return 0;
	if(visible){
		*d-&gt;bufp++ = 'v';	/* five bytes always reserved for this */
		if(d-&gt;_isnewdisplay){
			BPLONG(d-&gt;bufp, d-&gt;screenimage-&gt;id);
			d-&gt;bufp += 4;
		}
	}
	return doflush(d);
}

uchar*
bufimage(Display *d, int n)
{
	uchar *p;

	if(n&lt;0 || n&gt;d-&gt;bufsize){
		werrstr("bad count in bufimage");
		return 0;
	}
	if(d-&gt;bufp+n &gt; d-&gt;buf+d-&gt;bufsize)
		if(doflush(d) &lt; 0)
			return 0;
	p = d-&gt;bufp;
	d-&gt;bufp += n;
	return p;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

