<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/menuhit.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/menuhit.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;

enum
{
	Margin = 4,		/* outside to text */
	Border = 2,		/* outside to selection boxes */
	Blackborder = 2,	/* width of outlining border */
	Vspacing = 2,		/* extra spacing between lines of text */
	Maxunscroll = 25,	/* maximum #entries before scrolling turns on */
	Nscroll = 20,		/* number entries in scrolling part */
	Scrollwid = 14,		/* width of scroll bar */
	Gap = 4,			/* between text and scroll bar */
};

static	Image	*menutxt;
static	Image	*back;
static	Image	*high;
static	Image	*bord;
static	Image	*text;
static	Image	*htext;

static
void
menucolors(void)
{
	/* Main tone is greenish, with negative selection */
	back = allocimagemix(display, DPalegreen, DWhite);
	high = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, DDarkgreen);	/* dark green */
	bord = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, DMedgreen);	/* not as dark green */
	if(back==nil || high==nil || bord==nil)
		goto Error;
	text = display-&gt;black;
	htext = back;
	return;

    Error:
	freeimage(back);
	freeimage(high);
	freeimage(bord);
	back = display-&gt;white;
	high = display-&gt;black;
	bord = display-&gt;black;
	text = display-&gt;black;
	htext = display-&gt;white;
}

/*
 * r is a rectangle holding the text elements.
 * return the rectangle, including its black edge, holding element i.
 */
static Rectangle
menurect(Rectangle r, int i)
{
	if(i &lt; 0)
		return Rect(0, 0, 0, 0);
	r.min.y += (font-&gt;height+Vspacing)*i;
	r.max.y = r.min.y+font-&gt;height+Vspacing;
	return insetrect(r, Border-Margin);
}

/*
 * r is a rectangle holding the text elements.
 * return the element number containing p.
 */
static int
menusel(Rectangle r, Point p)
{
	r = insetrect(r, Margin);
	if(!ptinrect(p, r))
		return -1;
	return (p.y-r.min.y)/(font-&gt;height+Vspacing);
}

static
void
paintitem(Image *m, Menu *menu, Rectangle textr, int off, int i, int highlight, Image *save, Image *restore)
{
	char *item;
	Rectangle r;
	Point pt;

	if(i &lt; 0)
		return;
	r = menurect(textr, i);
	if(restore){
		draw(m, r, restore, nil, restore-&gt;r.min);
		return;
	}
	if(save)
		draw(save, save-&gt;r, m, nil, r.min);
	item = menu-&gt;item? menu-&gt;item[i+off] : (*menu-&gt;gen)(i+off);
	pt.x = (textr.min.x+textr.max.x-stringwidth(font, item))/2;
	pt.y = textr.min.y+i*(font-&gt;height+Vspacing);
	draw(m, r, highlight? high : back, nil, pt);
	string(m, pt, highlight? htext : text, pt, font, item);
}

/*
 * menur is a rectangle holding all the highlightable text elements.
 * track mouse while inside the box, return what's selected when button
 * is raised, -1 as soon as it leaves box.
 * invariant: nothing is highlighted on entry or exit.
 */
static int
menuscan(Image *m, Menu *menu, int but, Mousectl *mc, Rectangle textr, int off, int lasti, Image *save)
{
	int i;

	paintitem(m, menu, textr, off, lasti, 1, save, nil);
	for(readmouse(mc); mc-&gt;buttons &amp; (1&lt;&lt;(but-1)); readmouse(mc)){
		i = menusel(textr, mc-&gt;xy);
		if(i != -1 &amp;&amp; i == lasti)
			continue;
		paintitem(m, menu, textr, off, lasti, 0, nil, save);
		if(i == -1)
			return i;
		lasti = i;
		paintitem(m, menu, textr, off, lasti, 1, save, nil);
	}
	return lasti;
}

static void
menupaint(Image *m, Menu *menu, Rectangle textr, int off, int nitemdrawn)
{
	int i;

	draw(m, insetrect(textr, Border-Margin), back, nil, ZP);
	for(i = 0; i&lt;nitemdrawn; i++)
		paintitem(m, menu, textr, off, i, 0, nil, nil);
}

static void
menuscrollpaint(Image *m, Rectangle scrollr, int off, int nitem, int nitemdrawn)
{
	Rectangle r;

	draw(m, scrollr, back, nil, ZP);
	r.min.x = scrollr.min.x;
	r.max.x = scrollr.max.x;
	r.min.y = scrollr.min.y + (Dy(scrollr)*off)/nitem;
	r.max.y = scrollr.min.y + (Dy(scrollr)*(off+nitemdrawn))/nitem;
	if(r.max.y &lt; r.min.y+2)
		r.max.y = r.min.y+2;
	border(m, r, 1, bord, ZP);
	if(menutxt == 0)
		menutxt = allocimage(display, Rect(0, 0, 1, 1), screen-&gt;chan, 1, DDarkgreen);	/* border color; BUG? */
	if(menutxt)
		draw(m, insetrect(r, 1), menutxt, nil, ZP);
}

int
menuhit(int but, Mousectl *mc, Menu *menu, Screen *scr)
{
	int i, nitem, nitemdrawn, maxwid, lasti, off, noff, wid, screenitem;
	int scrolling;
	Rectangle r, menur, sc, textr, scrollr;
	Image *b, *save, *backup;
	Point pt;
	char *item;

	if(back == nil)
		menucolors();
	sc = screen-&gt;clipr;
	replclipr(screen, 0, screen-&gt;r);
	maxwid = 0;
	for(nitem = 0;
	    item = menu-&gt;item? menu-&gt;item[nitem] : (*menu-&gt;gen)(nitem);
	    nitem++){
		i = stringwidth(font, item);
		if(i &gt; maxwid)
			maxwid = i;
	}
	if(menu-&gt;lasthit&lt;0 || menu-&gt;lasthit&gt;=nitem)
		menu-&gt;lasthit = 0;
	screenitem = (Dy(screen-&gt;r)-10)/(font-&gt;height+Vspacing);
	if(nitem&gt;Maxunscroll || nitem&gt;screenitem){
		scrolling = 1;
		nitemdrawn = Nscroll;
		if(nitemdrawn &gt; screenitem)
			nitemdrawn = screenitem;
		wid = maxwid + Gap + Scrollwid;
		off = menu-&gt;lasthit - nitemdrawn/2;
		if(off &lt; 0)
			off = 0;
		if(off &gt; nitem-nitemdrawn)
			off = nitem-nitemdrawn;
		lasti = menu-&gt;lasthit-off;
	}else{
		scrolling = 0;
		nitemdrawn = nitem;
		wid = maxwid;
		off = 0;
		lasti = menu-&gt;lasthit;
	}
	r = insetrect(Rect(0, 0, wid, nitemdrawn*(font-&gt;height+Vspacing)), -Margin);
	r = rectsubpt(r, Pt(wid/2, lasti*(font-&gt;height+Vspacing)+font-&gt;height/2));
	r = rectaddpt(r, mc-&gt;xy);
	pt = ZP;
	if(r.max.x&gt;screen-&gt;r.max.x)
		pt.x = screen-&gt;r.max.x-r.max.x;
	if(r.max.y&gt;screen-&gt;r.max.y)
		pt.y = screen-&gt;r.max.y-r.max.y;
	if(r.min.x&lt;screen-&gt;r.min.x)
		pt.x = screen-&gt;r.min.x-r.min.x;
	if(r.min.y&lt;screen-&gt;r.min.y)
		pt.y = screen-&gt;r.min.y-r.min.y;
	menur = rectaddpt(r, pt);
	textr.max.x = menur.max.x-Margin;
	textr.min.x = textr.max.x-maxwid;
	textr.min.y = menur.min.y+Margin;
	textr.max.y = textr.min.y + nitemdrawn*(font-&gt;height+Vspacing);
	if(scrolling){
		scrollr = insetrect(menur, Border);
		scrollr.max.x = scrollr.min.x+Scrollwid;
	}else
		scrollr = Rect(0, 0, 0, 0);

	if(scr){
		b = allocwindow(scr, menur, Refbackup, DWhite);
		if(b == nil)
			b = screen;
		backup = nil;
	}else{
		b = screen;
		backup = allocimage(display, menur, screen-&gt;chan, 0, -1);
		if(backup)
			draw(backup, menur, screen, nil, menur.min);
	}
	draw(b, menur, back, nil, ZP);
	border(b, menur, Blackborder, bord, ZP);
	save = allocimage(display, menurect(textr, 0), screen-&gt;chan, 0, -1);
	r = menurect(textr, lasti);
	moveto(mc, divpt(addpt(r.min, r.max), 2));
	menupaint(b, menu, textr, off, nitemdrawn);
	if(scrolling)
		menuscrollpaint(b, scrollr, off, nitem, nitemdrawn);
	while(mc-&gt;buttons &amp; (1&lt;&lt;(but-1))){
		lasti = menuscan(b, menu, but, mc, textr, off, lasti, save);
		if(lasti &gt;= 0)
			break;
		while(!ptinrect(mc-&gt;xy, textr) &amp;&amp; (mc-&gt;buttons &amp; (1&lt;&lt;(but-1)))){
			if(scrolling &amp;&amp; ptinrect(mc-&gt;xy, scrollr)){
				noff = ((mc-&gt;xy.y-scrollr.min.y)*nitem)/Dy(scrollr);
				noff -= nitemdrawn/2;
				if(noff &lt; 0)
					noff = 0;
				if(noff &gt; nitem-nitemdrawn)
					noff = nitem-nitemdrawn;
				if(noff != off){
					off = noff;
					menupaint(b, menu, textr, off, nitemdrawn);
					menuscrollpaint(b, scrollr, off, nitem, nitemdrawn);
				}
			}
			readmouse(mc);
		}
	}
	if(b != screen)
		freeimage(b);
	if(backup){
		draw(screen, menur, backup, nil, menur.min);
		freeimage(backup);
	}
	freeimage(save);
	replclipr(screen, 0, sc);
	flushimage(display, 1);
	if(lasti &gt;= 0){
		menu-&gt;lasthit = lasti+off;
		return menu-&gt;lasthit;
	}
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

