<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libflate/inflate.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libflate/inflate.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;flate.h&gt;

enum {
	HistorySize=	32*1024,
	BufSize=	4*1024,
	MaxHuffBits=	17,	/* maximum bits in a encoded code */
	Nlitlen=	288,	/* number of litlen codes */
	Noff=		32,	/* number of offset codes */
	Nclen=		19,	/* number of codelen codes */
	LenShift=	10,	/* code = len&lt;&lt;LenShift|code */
	LitlenBits=	7,	/* number of bits in litlen decode table */
	OffBits=	6,	/* number of bits in offset decode table */
	ClenBits=	6,	/* number of bits in code len decode table */
	MaxFlatBits=	LitlenBits,
	MaxLeaf=	Nlitlen
};

typedef struct Input	Input;
typedef struct History	History;
typedef struct Huff	Huff;

struct Input
{
	int	error;		/* first error encountered, or FlateOk */
	void	*wr;
	int	(*w)(void*, void*, int);
	void	*getr;
	int	(*get)(void*);
	ulong	sreg;
	int	nbits;
};

struct History
{
	uchar	his[HistorySize];
	uchar	*cp;		/* current pointer in history */
	int	full;		/* his has been filled up at least once */
};

struct Huff
{
	int	maxbits;	/* max bits for any code */
	int	minbits;	/* min bits to get before looking in flat */
	int	flatmask;	/* bits used in "flat" fast decoding table */
	ulong	flat[1&lt;&lt;MaxFlatBits];
	ulong	maxcode[MaxHuffBits];
	ulong	last[MaxHuffBits];
	ulong	decode[MaxLeaf];
};

/* litlen code words 257-285 extra bits */
static int litlenextra[Nlitlen-257] =
{
/* 257 */	0, 0, 0,
/* 260 */	0, 0, 0, 0, 0, 1, 1, 1, 1, 2,
/* 270 */	2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
/* 280 */	4, 5, 5, 5, 5, 0, 0, 0
};

static int litlenbase[Nlitlen-257];

/* offset code word extra bits */
static int offextra[Noff] =
{
	0,  0,  0,  0,  1,  1,  2,  2,  3,  3,
	4,  4,  5,  5,  6,  6,  7,  7,  8,  8,
	9,  9,  10, 10, 11, 11, 12, 12, 13, 13,
	0,  0,
};
static int offbase[Noff];

/* order code lengths */
static int clenorder[Nclen] =
{
        16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15
};

/* for static huffman tables */
static	Huff	litlentab;
static	Huff	offtab;
static	uchar	revtab[256];

static int	uncblock(Input *in, History*);
static int	fixedblock(Input *in, History*);
static int	dynamicblock(Input *in, History*);
static int	sregfill(Input *in, int n);
static int	sregunget(Input *in);
static int	decode(Input*, History*, Huff*, Huff*);
static int	hufftab(Huff*, char*, int, int);
static int	hdecsym(Input *in, Huff *h, int b);

int
inflateinit(void)
{
	char *len;
	int i, j, base;

	/* byte reverse table */
	for(i=0; i&lt;256; i++)
		for(j=0; j&lt;8; j++)
			if(i &amp; (1&lt;&lt;j))
				revtab[i] |= 0x80 &gt;&gt; j;

	for(i=257,base=3; i&lt;Nlitlen; i++) {
		litlenbase[i-257] = base;
		base += 1&lt;&lt;litlenextra[i-257];
	}
	/* strange table entry in spec... */
	litlenbase[285-257]--;

	for(i=0,base=1; i&lt;Noff; i++) {
		offbase[i] = base;
		base += 1&lt;&lt;offextra[i];
	}

	len = malloc(MaxLeaf);
	if(len == nil)
		return FlateNoMem;

	/* static Litlen bit lengths */
	for(i=0; i&lt;144; i++)
		len[i] = 8;
	for(i=144; i&lt;256; i++)
		len[i] = 9;
	for(i=256; i&lt;280; i++)
		len[i] = 7;
	for(i=280; i&lt;Nlitlen; i++)
		len[i] = 8;

	if(!hufftab(&amp;litlentab, len, Nlitlen, MaxFlatBits))
		return FlateInternal;

	/* static Offset bit lengths */
	for(i=0; i&lt;Noff; i++)
		len[i] = 5;

	if(!hufftab(&amp;offtab, len, Noff, MaxFlatBits))
		return FlateInternal;
	free(len);

	return FlateOk;
}

int
inflate(void *wr, int (*w)(void*, void*, int), void *getr, int (*get)(void*))
{
	History *his;
	Input in;
	int final, type;

	his = malloc(sizeof(History));
	if(his == nil)
		return FlateNoMem;
	his-&gt;cp = his-&gt;his;
	his-&gt;full = 0;
	in.getr = getr;
	in.get = get;
	in.wr = wr;
	in.w = w;
	in.nbits = 0;
	in.sreg = 0;
	in.error = FlateOk;

	do {
		if(!sregfill(&amp;in, 3))
			goto bad;
		final = in.sreg &amp; 0x1;
		type = (in.sreg&gt;&gt;1) &amp; 0x3;
		in.sreg &gt;&gt;= 3;
		in.nbits -= 3;
		switch(type) {
		default:
			in.error = FlateCorrupted;
			goto bad;
		case 0:
			/* uncompressed */
			if(!uncblock(&amp;in, his))
				goto bad;
			break;
		case 1:
			/* fixed huffman */
			if(!fixedblock(&amp;in, his))
				goto bad;
			break;
		case 2:
			/* dynamic huffman */
			if(!dynamicblock(&amp;in, his))
				goto bad;
			break;
		}
	} while(!final);

	if(his-&gt;cp != his-&gt;his &amp;&amp; (*w)(wr, his-&gt;his, his-&gt;cp - his-&gt;his) != his-&gt;cp - his-&gt;his) {
		in.error = FlateOutputFail;
		goto bad;
	}

	if(!sregunget(&amp;in))
		goto bad;

	free(his);
	if(in.error != FlateOk)
		return FlateInternal;
	return FlateOk;

bad:
	free(his);
	if(in.error == FlateOk)
		return FlateInternal;
	return in.error;
}

static int
uncblock(Input *in, History *his)
{
	int len, nlen, c;
	uchar *hs, *hp, *he;

	if(!sregunget(in))
		return 0;
	len = (*in-&gt;get)(in-&gt;getr);
	len |= (*in-&gt;get)(in-&gt;getr)&lt;&lt;8;
	nlen = (*in-&gt;get)(in-&gt;getr);
	nlen |= (*in-&gt;get)(in-&gt;getr)&lt;&lt;8;
	if(len != (~nlen&amp;0xffff)) {
		in-&gt;error = FlateCorrupted;
		return 0;
	}

	hp = his-&gt;cp;
	hs = his-&gt;his;
	he = hs + HistorySize;

	while(len &gt; 0) {
		c = (*in-&gt;get)(in-&gt;getr);
		if(c &lt; 0)
			return 0;
		*hp++ = c;
		if(hp == he) {
			his-&gt;full = 1;
			if((*in-&gt;w)(in-&gt;wr, hs, HistorySize) != HistorySize) {
				in-&gt;error = FlateOutputFail;
				return 0;
			}
			hp = hs;
		}
		len--;
	}

	his-&gt;cp = hp;

	return 1;
}

static int
fixedblock(Input *in, History *his)
{
	return decode(in, his, &amp;litlentab, &amp;offtab);
}

static int
dynamicblock(Input *in, History *his)
{
	Huff *lentab, *offtab;
	char *len;
	int i, j, n, c, nlit, ndist, nclen, res, nb;

	if(!sregfill(in, 14))
		return 0;
	nlit = (in-&gt;sreg&amp;0x1f) + 257;
	ndist = ((in-&gt;sreg&gt;&gt;5) &amp; 0x1f) + 1;
	nclen = ((in-&gt;sreg&gt;&gt;10) &amp; 0xf) + 4;
	in-&gt;sreg &gt;&gt;= 14;
	in-&gt;nbits -= 14;

	if(nlit &gt; Nlitlen || ndist &gt; Noff || nlit &lt; 257) {
		in-&gt;error = FlateCorrupted;
		return 0;
	}

	/* huff table header */
	len = malloc(Nlitlen+Noff);
	lentab = malloc(sizeof(Huff));
	offtab = malloc(sizeof(Huff));
	if(len == nil || lentab == nil || offtab == nil){
		in-&gt;error = FlateNoMem;
		goto bad;
	}
	for(i=0; i &lt; Nclen; i++)
		len[i] = 0;
	for(i=0; i&lt;nclen; i++) {
		if(!sregfill(in, 3))
			goto bad;
		len[clenorder[i]] = in-&gt;sreg &amp; 0x7;
		in-&gt;sreg &gt;&gt;= 3;
		in-&gt;nbits -= 3;
	}

	if(!hufftab(lentab, len, Nclen, ClenBits)){
		in-&gt;error = FlateCorrupted;
		goto bad;
	}

	n = nlit+ndist;
	for(i=0; i&lt;n;) {
		nb = lentab-&gt;minbits;
		for(;;){
			if(in-&gt;nbits&lt;nb &amp;&amp; !sregfill(in, nb))
				goto bad;
			c = lentab-&gt;flat[in-&gt;sreg &amp; lentab-&gt;flatmask];
			nb = c &amp; 0xff;
			if(nb &gt; in-&gt;nbits){
				if(nb != 0xff)
					continue;
				c = hdecsym(in, lentab, c);
				if(c &lt; 0)
					goto bad;
			}else{
				c &gt;&gt;= 8;
				in-&gt;sreg &gt;&gt;= nb;
				in-&gt;nbits -= nb;
			}
			break;
		}

		if(c &lt; 16) {
			j = 1;
		} else if(c == 16) {
			if(in-&gt;nbits&lt;2 &amp;&amp; !sregfill(in, 2))
				goto bad;
			j = (in-&gt;sreg&amp;0x3)+3;
			in-&gt;sreg &gt;&gt;= 2;
			in-&gt;nbits -= 2;
			if(i == 0) {
				in-&gt;error = FlateCorrupted;
				goto bad;
			}
			c = len[i-1];
		} else if(c == 17) {
			if(in-&gt;nbits&lt;3 &amp;&amp; !sregfill(in, 3))
				goto bad;
			j = (in-&gt;sreg&amp;0x7)+3;
			in-&gt;sreg &gt;&gt;= 3;
			in-&gt;nbits -= 3;
			c = 0;
		} else if(c == 18) {
			if(in-&gt;nbits&lt;7 &amp;&amp; !sregfill(in, 7))
				goto bad;
			j = (in-&gt;sreg&amp;0x7f)+11;
			in-&gt;sreg &gt;&gt;= 7;
			in-&gt;nbits -= 7;
			c = 0;
		} else {
			in-&gt;error = FlateCorrupted;
			goto bad;
		}

		if(i+j &gt; n) {
			in-&gt;error = FlateCorrupted;
			goto bad;
		}

		while(j) {
			len[i] = c;
			i++;
			j--;
		}
	}

	if(!hufftab(lentab, len, nlit, LitlenBits)
	|| !hufftab(offtab, &amp;len[nlit], ndist, OffBits)){
		in-&gt;error = FlateCorrupted;
		goto bad;
	}

	res = decode(in, his, lentab, offtab);

	free(len);
	free(lentab);
	free(offtab);

	return res;

bad:
	free(len);
	free(lentab);
	free(offtab);
	return 0;
}

static int
decode(Input *in, History *his, Huff *litlentab, Huff *offtab)
{
	int len, off;
	uchar *hs, *hp, *hq, *he;
	int c;
	int nb;

	hs = his-&gt;his;
	he = hs + HistorySize;
	hp = his-&gt;cp;

	for(;;) {
		nb = litlentab-&gt;minbits;
		for(;;){
			if(in-&gt;nbits&lt;nb &amp;&amp; !sregfill(in, nb))
				return 0;
			c = litlentab-&gt;flat[in-&gt;sreg &amp; litlentab-&gt;flatmask];
			nb = c &amp; 0xff;
			if(nb &gt; in-&gt;nbits){
				if(nb != 0xff)
					continue;
				c = hdecsym(in, litlentab, c);
				if(c &lt; 0)
					return 0;
			}else{
				c &gt;&gt;= 8;
				in-&gt;sreg &gt;&gt;= nb;
				in-&gt;nbits -= nb;
			}
			break;
		}

		if(c &lt; 256) {
			/* literal */
			*hp++ = c;
			if(hp == he) {
				his-&gt;full = 1;
				if((*in-&gt;w)(in-&gt;wr, hs, HistorySize) != HistorySize) {
					in-&gt;error = FlateOutputFail;
					return 0;
				}
				hp = hs;
			}
			continue;
		}

		if(c == 256)
			break;

		if(c &gt; 285) {
			in-&gt;error = FlateCorrupted;
			return 0;
		}

		c -= 257;
		nb = litlenextra[c];
		if(in-&gt;nbits &lt; nb &amp;&amp; !sregfill(in, nb))
			return 0;
		len = litlenbase[c] + (in-&gt;sreg &amp; ((1&lt;&lt;nb)-1));
		in-&gt;sreg &gt;&gt;= nb;
		in-&gt;nbits -= nb;

		/* get offset */
		nb = offtab-&gt;minbits;
		for(;;){
			if(in-&gt;nbits&lt;nb &amp;&amp; !sregfill(in, nb))
				return 0;
			c = offtab-&gt;flat[in-&gt;sreg &amp; offtab-&gt;flatmask];
			nb = c &amp; 0xff;
			if(nb &gt; in-&gt;nbits){
				if(nb != 0xff)
					continue;
				c = hdecsym(in, offtab, c);
				if(c &lt; 0)
					return 0;
			}else{
				c &gt;&gt;= 8;
				in-&gt;sreg &gt;&gt;= nb;
				in-&gt;nbits -= nb;
			}
			break;
		}

		if(c &gt; 29) {
			in-&gt;error = FlateCorrupted;
			return 0;
		}

		nb = offextra[c];
		if(in-&gt;nbits &lt; nb &amp;&amp; !sregfill(in, nb))
			return 0;

		off = offbase[c] + (in-&gt;sreg &amp; ((1&lt;&lt;nb)-1));
		in-&gt;sreg &gt;&gt;= nb;
		in-&gt;nbits -= nb;

		hq = hp - off;
		if(hq &lt; hs) {
			if(!his-&gt;full) {
				in-&gt;error = FlateCorrupted;
				return 0;
			}
			hq += HistorySize;
		}

		/* slow but correct */
		while(len) {
			*hp = *hq;
			hq++;
			hp++;
			if(hq &gt;= he)
				hq = hs;
			if(hp == he) {
				his-&gt;full = 1;
				if((*in-&gt;w)(in-&gt;wr, hs, HistorySize) != HistorySize) {
					in-&gt;error = FlateOutputFail;
					return 0;
				}
				hp = hs;
			}
			len--;
		}

	}

	his-&gt;cp = hp;

	return 1;
}

static int
revcode(int c, int b)
{
	/* shift encode up so it starts on bit 15 then reverse */
	c &lt;&lt;= (16-b);
	c = revtab[c&gt;&gt;8] | (revtab[c&amp;0xff]&lt;&lt;8);
	return c;
}

/*
 * construct the huffman decoding arrays and a fast lookup table.
 * the fast lookup is a table indexed by the next flatbits bits,
 * which returns the symbol matched and the number of bits consumed,
 * or the minimum number of bits needed and 0xff if more than flatbits
 * bits are needed.
 *
 * flatbits can be longer than the smallest huffman code,
 * because shorter codes are assigned smaller lexical prefixes.
 * this means assuming zeros for the next few bits will give a
 * conservative answer, in the sense that it will either give the
 * correct answer, or return the minimum number of bits which
 * are needed for an answer.
 */
static int
hufftab(Huff *h, char *hb, int maxleaf, int flatbits)
{
	ulong bitcount[MaxHuffBits];
	ulong c, fc, ec, mincode, code, nc[MaxHuffBits];
	int i, b, minbits, maxbits;

	for(i = 0; i &lt; MaxHuffBits; i++)
		bitcount[i] = 0;
	maxbits = -1;
	minbits = MaxHuffBits + 1;
	for(i=0; i &lt; maxleaf; i++){
		b = hb[i];
		if(b){
			bitcount[b]++;
			if(b &lt; minbits)
				minbits = b;
			if(b &gt; maxbits)
				maxbits = b;
		}
	}

	h-&gt;maxbits = maxbits;
	if(maxbits &lt;= 0){
		h-&gt;maxbits = 0;
		h-&gt;minbits = 0;
		h-&gt;flatmask = 0;
		return 1;
	}
	code = 0;
	c = 0;
	for(b = 0; b &lt;= maxbits; b++){
		h-&gt;last[b] = c;
		c += bitcount[b];
		mincode = code &lt;&lt; 1;
		nc[b] = mincode;
		code = mincode + bitcount[b];
		if(code &gt; (1 &lt;&lt; b))
			return 0;
		h-&gt;maxcode[b] = code - 1;
		h-&gt;last[b] += code - 1;
	}

	if(flatbits &gt; maxbits)
		flatbits = maxbits;
	h-&gt;flatmask = (1 &lt;&lt; flatbits) - 1;
	if(minbits &gt; flatbits)
		minbits = flatbits;
	h-&gt;minbits = minbits;

	b = 1 &lt;&lt; flatbits;
	for(i = 0; i &lt; b; i++)
		h-&gt;flat[i] = ~0;

	/*
	 * initialize the flat table to include the minimum possible
	 * bit length for each code prefix
	 */
	for(b = maxbits; b &gt; flatbits; b--){
		code = h-&gt;maxcode[b];
		if(code == -1)
			break;
		mincode = code + 1 - bitcount[b];
		mincode &gt;&gt;= b - flatbits;
		code &gt;&gt;= b - flatbits;
		for(; mincode &lt;= code; mincode++)
			h-&gt;flat[revcode(mincode, flatbits)] = (b &lt;&lt; 8) | 0xff;
	}

	for(i = 0; i &lt; maxleaf; i++){
		b = hb[i];
		if(b &lt;= 0)
			continue;
		c = nc[b]++;
		if(b &lt;= flatbits){
			code = (i &lt;&lt; 8) | b;
			ec = (c + 1) &lt;&lt; (flatbits - b);
			if(ec &gt; (1&lt;&lt;flatbits))
				return 0;	/* this is actually an internal error */
			for(fc = c &lt;&lt; (flatbits - b); fc &lt; ec; fc++)
				h-&gt;flat[revcode(fc, flatbits)] = code;
		}
		if(b &gt; minbits){
			c = h-&gt;last[b] - c;
			if(c &gt;= maxleaf)
				return 0;
			h-&gt;decode[c] = i;
		}
	}
	return 1;
}

static int
hdecsym(Input *in, Huff *h, int nb)
{
	long c;

	if((nb &amp; 0xff) == 0xff)
		nb = nb &gt;&gt; 8;
	else
		nb = nb &amp; 0xff;
	for(; nb &lt;= h-&gt;maxbits; nb++){
		if(in-&gt;nbits&lt;nb &amp;&amp; !sregfill(in, nb))
			return -1;
		c = revtab[in-&gt;sreg&amp;0xff]&lt;&lt;8;
		c |= revtab[(in-&gt;sreg&gt;&gt;8)&amp;0xff];
		c &gt;&gt;= (16-nb);
		if(c &lt;= h-&gt;maxcode[nb]){
			in-&gt;sreg &gt;&gt;= nb;
			in-&gt;nbits -= nb;
			return h-&gt;decode[h-&gt;last[nb] - c];
		}
	}
	in-&gt;error = FlateCorrupted;
	return -1;
}

static int
sregfill(Input *in, int n)
{
	int c;

	while(n &gt; in-&gt;nbits) {
		c = (*in-&gt;get)(in-&gt;getr);
		if(c &lt; 0){
			in-&gt;error = FlateInputFail;
			return 0;
		}
		in-&gt;sreg |= c&lt;&lt;in-&gt;nbits;
		in-&gt;nbits += 8;
	}
	return 1;
}

static int
sregunget(Input *in)
{
	if(in-&gt;nbits &gt;= 8) {
		in-&gt;error = FlateInternal;
		return 0;
	}

	/* throw other bits on the floor */
	in-&gt;nbits = 0;
	in-&gt;sreg = 0;
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

