<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libframe/frbox.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libframe/frbox.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;frame.h&gt;

#define	SLOP	25

void
_fraddbox(Frame *f, int bn, int n)	/* add n boxes after bn, shift the rest up,
				 * box[bn+n]==box[bn] */
{
	int i;

	if(bn &gt; f-&gt;nbox)
		drawerror(f-&gt;display, "_fraddbox");
	if(f-&gt;nbox+n &gt; f-&gt;nalloc)
		_frgrowbox(f, n+SLOP);
	for(i=f-&gt;nbox; --i&gt;=bn; )
		f-&gt;box[i+n] = f-&gt;box[i];
	f-&gt;nbox+=n;
}

void
_frclosebox(Frame *f, int n0, int n1)	/* inclusive */
{
	int i;

	if(n0&gt;=f-&gt;nbox || n1&gt;=f-&gt;nbox || n1&lt;n0)
		drawerror(f-&gt;display, "_frclosebox");
	n1++;
	for(i=n1; i&lt;f-&gt;nbox; i++)
		f-&gt;box[i-(n1-n0)] = f-&gt;box[i];
	f-&gt;nbox -= n1-n0;
}

void
_frdelbox(Frame *f, int n0, int n1)	/* inclusive */
{
	if(n0&gt;=f-&gt;nbox || n1&gt;=f-&gt;nbox || n1&lt;n0)
		drawerror(f-&gt;display, "_frdelbox");
	_frfreebox(f, n0, n1);
	_frclosebox(f, n0, n1);
}

void
_frfreebox(Frame *f, int n0, int n1)	/* inclusive */
{
	int i;

	if(n1&lt;n0)
		return;
	if(n0&gt;=f-&gt;nbox || n1&gt;=f-&gt;nbox)
		drawerror(f-&gt;display, "_frfreebox");
	n1++;
	for(i=n0; i&lt;n1; i++)
		if(f-&gt;box[i].nrune &gt;= 0)
			free(f-&gt;box[i].ptr);
}

void
_frgrowbox(Frame *f, int delta)
{
	f-&gt;nalloc += delta;
	f-&gt;box = realloc(f-&gt;box, f-&gt;nalloc*sizeof(Frbox));
	if(f-&gt;box == 0)
		drawerror(f-&gt;display, "_frgrowbox");
}

static
void
dupbox(Frame *f, int bn)
{
	uchar *p;

	if(f-&gt;box[bn].nrune &lt; 0)
		drawerror(f-&gt;display, "dupbox");
	_fraddbox(f, bn, 1);
	if(f-&gt;box[bn].nrune &gt;= 0){
		p = _frallocstr(f, NBYTE(&amp;f-&gt;box[bn])+1);
		strcpy((char*)p, (char*)f-&gt;box[bn].ptr);
		f-&gt;box[bn+1].ptr = p;
	}
}

static
uchar*
runeindex(uchar *p, int n)
{
	int i, w;
	Rune rune;

	for(i=0; i&lt;n; i++,p+=w)
		if(*p &lt; Runeself)
			w = 1;
		else{
			w = chartorune(&amp;rune, (char*)p);
			USED(rune);
		}
	return p;
}

static
void
truncatebox(Frame *f, Frbox *b, int n)	/* drop last n chars; no allocation done */
{
	if(b-&gt;nrune&lt;0 || b-&gt;nrune&lt;n)
		drawerror(f-&gt;display, "truncatebox");
	b-&gt;nrune -= n;
	runeindex(b-&gt;ptr, b-&gt;nrune)[0] = 0;
	b-&gt;wid = stringwidth(f-&gt;font, (char *)b-&gt;ptr);
}

static
void
chopbox(Frame *f, Frbox *b, int n)	/* drop first n chars; no allocation done */
{
	char *p;

	if(b-&gt;nrune&lt;0 || b-&gt;nrune&lt;n)
		drawerror(f-&gt;display, "chopbox");
	p = (char*)runeindex(b-&gt;ptr, n);
	memmove((char*)b-&gt;ptr, p, strlen(p)+1);
	b-&gt;nrune -= n;
	b-&gt;wid = stringwidth(f-&gt;font, (char *)b-&gt;ptr);
}

void
_frsplitbox(Frame *f, int bn, int n)
{
	dupbox(f, bn);
	truncatebox(f, &amp;f-&gt;box[bn], f-&gt;box[bn].nrune-n);
	chopbox(f, &amp;f-&gt;box[bn+1], n);
}

void
_frmergebox(Frame *f, int bn)		/* merge bn and bn+1 */
{
	Frbox *b;

	b = &amp;f-&gt;box[bn];
	_frinsure(f, bn, NBYTE(&amp;b[0])+NBYTE(&amp;b[1])+1);
	strcpy((char*)runeindex(b[0].ptr, b[0].nrune), (char*)b[1].ptr);
	b[0].wid += b[1].wid;
	b[0].nrune += b[1].nrune;
	_frdelbox(f, bn+1, bn+1);
}

int
_frfindbox(Frame *f, int bn, ulong p, ulong q)	/* find box containing q and put q on a box boundary */
{
	Frbox *b;

	for(b = &amp;f-&gt;box[bn]; bn&lt;f-&gt;nbox &amp;&amp; p+NRUNE(b)&lt;=q; bn++, b++)
		p += NRUNE(b);
	if(p != q)
		_frsplitbox(f, bn++, (int)(q-p));
	return bn;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

