<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libframe/frinsert.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libframe/frinsert.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;frame.h&gt;

#define	DELTA	25
#define	TMPSIZE	256
static Frame		frame;

static
Point
bxscan(Frame *f, Rune *sp, Rune *ep, Point *ppt)
{
	int w, c, nb, delta, nl, nr, rw;
	Frbox *b;
	char *s, tmp[TMPSIZE+3];	/* +3 for rune overflow */
	uchar *p;

	frame.r = f-&gt;r;
	frame.b = f-&gt;b;
	frame.font = f-&gt;font;
	frame.maxtab = f-&gt;maxtab;
	frame.nbox = 0;
	frame.nchars = 0;
	memmove(frame.cols, f-&gt;cols, sizeof frame.cols);
	delta = DELTA;
	nl = 0;
	for(nb=0; sp&lt;ep &amp;&amp; nl&lt;=f-&gt;maxlines; nb++,frame.nbox++){
		if(nb == frame.nalloc){
			_frgrowbox(&amp;frame, delta);
			if(delta &lt; 10000)
				delta *= 2;
		}
		b = &amp;frame.box[nb];
		c = *sp;
		if(c=='\t' || c=='\n'){
			b-&gt;bc = c;
			b-&gt;wid = 5000;
			b-&gt;minwid = (c=='\n')? 0 : stringwidth(frame.font, " ");
			b-&gt;nrune = -1;
			if(c=='\n')
				nl++;
			frame.nchars++;
			sp++;
		}else{
			s = tmp;
			nr = 0;
			w = 0;
			while(sp &lt; ep){
				c = *sp;
				if(c=='\t' || c=='\n')
					break;
				rw = runetochar(s, sp);
				if(s+rw &gt;= tmp+TMPSIZE)
					break;
				w += runestringnwidth(frame.font, sp, 1);
				sp++;
				s += rw;
				nr++;
			}
			*s++ = 0;
			p = _frallocstr(f, s-tmp);
			b = &amp;frame.box[nb];
			b-&gt;ptr = p;
			memmove(p, tmp, s-tmp);
			b-&gt;wid = w;
			b-&gt;nrune = nr;
			frame.nchars += nr;
		}
	}
	_frcklinewrap0(f, ppt, &amp;frame.box[0]);
	return _frdraw(&amp;frame, *ppt);
}

static
void
chopframe(Frame *f, Point pt, ulong p, int bn)
{
	Frbox *b;

	for(b = &amp;f-&gt;box[bn]; ; b++){
		if(b &gt;= &amp;f-&gt;box[f-&gt;nbox])
			drawerror(f-&gt;display, "endofframe");
		_frcklinewrap(f, &amp;pt, b);
		if(pt.y &gt;= f-&gt;r.max.y)
			break;
		p += NRUNE(b);
		_fradvance(f, &amp;pt, b);
	}
	f-&gt;nchars = p;
	f-&gt;nlines = f-&gt;maxlines;
	if(b&lt;&amp;f-&gt;box[f-&gt;nbox])				/* BUG */
		_frdelbox(f, (int)(b-f-&gt;box), f-&gt;nbox-1);
}

void
frinsert(Frame *f, Rune *sp, Rune *ep, ulong p0)
{
	Point pt0, pt1, opt0, ppt0, ppt1, pt;
	Frbox *b;
	int n, n0, nn0, y;
	ulong cn0;
	Image *col;
	Rectangle r;
	static struct{
		Point pt0, pt1;
	}*pts;
	static int nalloc=0;
	int npts;

	if(p0&gt;f-&gt;nchars || sp==ep || f-&gt;b==nil)
		return;
	n0 = _frfindbox(f, 0, 0, p0);
	cn0 = p0;
	nn0 = n0;
	pt0 = _frptofcharnb(f, p0, n0);
	ppt0 = pt0;
	opt0 = pt0;
	pt1 = bxscan(f, sp, ep, &amp;ppt0);
	ppt1 = pt1;
	if(n0 &lt; f-&gt;nbox){
		_frcklinewrap(f, &amp;pt0, b = &amp;f-&gt;box[n0]);	/* for frdrawsel() */
		_frcklinewrap0(f, &amp;ppt1, b);
	}
	f-&gt;modified = 1;
	/*
	 * ppt0 and ppt1 are start and end of insertion as they will appear when
	 * insertion is complete. pt0 is current location of insertion position
	 * (p0); pt1 is terminal point (without line wrap) of insertion.
	 */
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 0);

	/*
	 * Find point where old and new x's line up
	 * Invariants:
	 *	pt0 is where the next box (b, n0) is now
	 *	pt1 is where it will be after the insertion
	 * If pt1 goes off the rectangle, we can toss everything from there on
	 */
	for(b = &amp;f-&gt;box[n0],npts=0;
	     pt1.x!=pt0.x &amp;&amp; pt1.y!=f-&gt;r.max.y &amp;&amp; n0&lt;f-&gt;nbox; b++,n0++,npts++){
		_frcklinewrap(f, &amp;pt0, b);
		_frcklinewrap0(f, &amp;pt1, b);
		if(b-&gt;nrune &gt; 0){
			n = _frcanfit(f, pt1, b);
			if(n == 0)
				drawerror(f-&gt;display, "_frcanfit==0");
			if(n != b-&gt;nrune){
				_frsplitbox(f, n0, n);
				b = &amp;f-&gt;box[n0];
			}
		}
		if(npts == nalloc){
			pts = realloc(pts, (npts+DELTA)*sizeof(pts[0]));
			nalloc += DELTA;
			b = &amp;f-&gt;box[n0];
		}
		pts[npts].pt0 = pt0;
		pts[npts].pt1 = pt1;
		/* has a text box overflowed off the frame? */
		if(pt1.y == f-&gt;r.max.y)
			break;
		_fradvance(f, &amp;pt0, b);
		pt1.x += _frnewwid(f, pt1, b);
		cn0 += NRUNE(b);
	}
	if(pt1.y &gt; f-&gt;r.max.y)
		drawerror(f-&gt;display, "frinsert pt1 too far");
	if(pt1.y==f-&gt;r.max.y &amp;&amp; n0&lt;f-&gt;nbox){
		f-&gt;nchars -= _frstrlen(f, n0);
		_frdelbox(f, n0, f-&gt;nbox-1);
	}
	if(n0 == f-&gt;nbox)
		f-&gt;nlines = (pt1.y-f-&gt;r.min.y)/f-&gt;font-&gt;height+(pt1.x&gt;f-&gt;r.min.x);
	else if(pt1.y!=pt0.y){
		int q0, q1;

		y = f-&gt;r.max.y;
		q0 = pt0.y+f-&gt;font-&gt;height;
		q1 = pt1.y+f-&gt;font-&gt;height;
		f-&gt;nlines += (q1-q0)/f-&gt;font-&gt;height;
		if(f-&gt;nlines &gt; f-&gt;maxlines)
			chopframe(f, ppt1, p0, nn0);
		if(pt1.y &lt; y){
			r = f-&gt;r;
			r.min.y = q1;
			r.max.y = y;
			if(q1 &lt; y)
				draw(f-&gt;b, r, f-&gt;b, nil, Pt(f-&gt;r.min.x, q0));
			r.min = pt1;
			r.max.x = pt1.x+(f-&gt;r.max.x-pt0.x);
			r.max.y = q1;
			draw(f-&gt;b, r, f-&gt;b, nil, pt0);
		}
	}
	/*
	 * Move the old stuff down to make room.  The loop will move the stuff
	 * between the insertion and the point where the x's lined up.
	 * The draw()s above moved everything down after the point they lined up.
	 */
	for((y=pt1.y==f-&gt;r.max.y?pt1.y:0),b = &amp;f-&gt;box[n0-1]; --npts&gt;=0; --b){
		pt = pts[npts].pt1;
		if(b-&gt;nrune &gt; 0){
			r.min = pt;
			r.max = r.min;
			r.max.x += b-&gt;wid;
			r.max.y += f-&gt;font-&gt;height;
			draw(f-&gt;b, r, f-&gt;b, nil, pts[npts].pt0);
			/* clear bit hanging off right */
			if(npts==0 &amp;&amp; pt.y&gt;pt0.y){
				/*
				 * first new char is bigger than first char we're
				 * displacing, causing line wrap. ugly special case.
				 */
				r.min = opt0;
				r.max = opt0;
				r.max.x = f-&gt;r.max.x;
				r.max.y += f-&gt;font-&gt;height;
				if(f-&gt;p0&lt;=cn0 &amp;&amp; cn0&lt;f-&gt;p1)	/* b+1 is inside selection */
					col = f-&gt;cols[HIGH];
				else
					col = f-&gt;cols[BACK];
				draw(f-&gt;b, r, col, nil, r.min);
			}else if(pt.y &lt; y){
				r.min = pt;
				r.max = pt;
				r.min.x += b-&gt;wid;
				r.max.x = f-&gt;r.max.x;
				r.max.y += f-&gt;font-&gt;height;
				if(f-&gt;p0&lt;=cn0 &amp;&amp; cn0&lt;f-&gt;p1)	/* b+1 is inside selection */
					col = f-&gt;cols[HIGH];
				else
					col = f-&gt;cols[BACK];
				draw(f-&gt;b, r, col, nil, r.min);
			}
			y = pt.y;
			cn0 -= b-&gt;nrune;
		}else{
			r.min = pt;
			r.max = pt;
			r.max.x += b-&gt;wid;
			r.max.y += f-&gt;font-&gt;height;
			if(r.max.x &gt;= f-&gt;r.max.x)
				r.max.x = f-&gt;r.max.x;
			cn0--;
			if(f-&gt;p0&lt;=cn0 &amp;&amp; cn0&lt;f-&gt;p1)	/* b is inside selection */
				col = f-&gt;cols[HIGH];
			else
				col = f-&gt;cols[BACK];
			draw(f-&gt;b, r, col, nil, r.min);
			y = 0;
			if(pt.x == f-&gt;r.min.x)
				y = pt.y;
		}
	}
	/* insertion can extend the selection, so the condition here is different */
	if(f-&gt;p0&lt;p0 &amp;&amp; p0&lt;=f-&gt;p1)
		col = f-&gt;cols[HIGH];
	else
		col = f-&gt;cols[BACK];
	frselectpaint(f, ppt0, ppt1, col);
	_frdrawtext(&amp;frame, ppt0, f-&gt;cols[TEXT], col);
	_fraddbox(f, nn0, frame.nbox);
	for(n=0; n&lt;frame.nbox; n++)
		f-&gt;box[nn0+n] = frame.box[n];
	if(nn0&gt;0 &amp;&amp; f-&gt;box[nn0-1].nrune&gt;=0 &amp;&amp; ppt0.x-f-&gt;box[nn0-1].wid&gt;=f-&gt;r.min.x){
		--nn0;
		ppt0.x -= f-&gt;box[nn0].wid;
	}
	n0 += frame.nbox;
	_frclean(f, ppt0, nn0, n0&lt;f-&gt;nbox-1? n0+1 : n0);
	f-&gt;nchars += frame.nchars;
	if(f-&gt;p0 &gt;= p0)
		f-&gt;p0 += frame.nchars;
	if(f-&gt;p0 &gt; f-&gt;nchars)
		f-&gt;p0 = f-&gt;nchars;
	if(f-&gt;p1 &gt;= p0)
		f-&gt;p1 += frame.nchars;
	if(f-&gt;p1 &gt; f-&gt;nchars)
		f-&gt;p1 = f-&gt;nchars;
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 1);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

