<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libgeometry/matrix.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libgeometry/matrix.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ident(m)		store identity matrix in m
 * matmul(a, b)		matrix multiply a*=b
 * matmulr(a, b)	matrix multiply a=b*a
 * determinant(m)	returns det(m)
 * adjoint(m, minv)	minv=adj(m)
 * invertmat(m, minv)	invert matrix m, result in minv, returns det(m)
 *			if m is singular, minv=adj(m)
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;geometry.h&gt;
void ident(Matrix m){
	register double *s=&amp;m[0][0];
	*s++=1;*s++=0;*s++=0;*s++=0;
	*s++=0;*s++=1;*s++=0;*s++=0;
	*s++=0;*s++=0;*s++=1;*s++=0;
	*s++=0;*s++=0;*s++=0;*s=1;
}
void matmul(Matrix a, Matrix b){
	register i, j, k;
	double sum;
	Matrix tmp;
	for(i=0;i!=4;i++) for(j=0;j!=4;j++){
		sum=0;
		for(k=0;k!=4;k++)
			sum+=a[i][k]*b[k][j];
		tmp[i][j]=sum;
	}
	for(i=0;i!=4;i++) for(j=0;j!=4;j++)
		a[i][j]=tmp[i][j];
}
void matmulr(Matrix a, Matrix b){
	register i, j, k;
	double sum;
	Matrix tmp;
	for(i=0;i!=4;i++) for(j=0;j!=4;j++){
		sum=0;
		for(k=0;k!=4;k++)
			sum+=b[i][k]*a[k][j];
		tmp[i][j]=sum;
	}
	for(i=0;i!=4;i++) for(j=0;j!=4;j++)
		a[i][j]=tmp[i][j];
}
/*
 * Return det(m)
 */
double determinant(Matrix m){
	return m[0][0]*(m[1][1]*(m[2][2]*m[3][3]-m[2][3]*m[3][2])+
			m[1][2]*(m[2][3]*m[3][1]-m[2][1]*m[3][3])+
			m[1][3]*(m[2][1]*m[3][2]-m[2][2]*m[3][1]))
	      -m[0][1]*(m[1][0]*(m[2][2]*m[3][3]-m[2][3]*m[3][2])+
			m[1][2]*(m[2][3]*m[3][0]-m[2][0]*m[3][3])+
			m[1][3]*(m[2][0]*m[3][2]-m[2][2]*m[3][0]))
	      +m[0][2]*(m[1][0]*(m[2][1]*m[3][3]-m[2][3]*m[3][1])+
			m[1][1]*(m[2][3]*m[3][0]-m[2][0]*m[3][3])+
			m[1][3]*(m[2][0]*m[3][1]-m[2][1]*m[3][0]))
	      -m[0][3]*(m[1][0]*(m[2][1]*m[3][2]-m[2][2]*m[3][1])+
			m[1][1]*(m[2][2]*m[3][0]-m[2][0]*m[3][2])+
			m[1][2]*(m[2][0]*m[3][1]-m[2][1]*m[3][0]));
}
/*
 * Store the adjoint (matrix of cofactors) of m in madj.
 * Works fine even if m and madj are the same matrix.
 */
void adjoint(Matrix m, Matrix madj){
	double m00=m[0][0], m01=m[0][1], m02=m[0][2], m03=m[0][3];
	double m10=m[1][0], m11=m[1][1], m12=m[1][2], m13=m[1][3];
	double m20=m[2][0], m21=m[2][1], m22=m[2][2], m23=m[2][3];
	double m30=m[3][0], m31=m[3][1], m32=m[3][2], m33=m[3][3];
	madj[0][0]=m11*(m22*m33-m23*m32)+m21*(m13*m32-m12*m33)+m31*(m12*m23-m13*m22);
	madj[0][1]=m01*(m23*m32-m22*m33)+m21*(m02*m33-m03*m32)+m31*(m03*m22-m02*m23);
	madj[0][2]=m01*(m12*m33-m13*m32)+m11*(m03*m32-m02*m33)+m31*(m02*m13-m03*m12);
	madj[0][3]=m01*(m13*m22-m12*m23)+m11*(m02*m23-m03*m22)+m21*(m03*m12-m02*m13);
	madj[1][0]=m10*(m23*m32-m22*m33)+m20*(m12*m33-m13*m32)+m30*(m13*m22-m12*m23);
	madj[1][1]=m00*(m22*m33-m23*m32)+m20*(m03*m32-m02*m33)+m30*(m02*m23-m03*m22);
	madj[1][2]=m00*(m13*m32-m12*m33)+m10*(m02*m33-m03*m32)+m30*(m03*m12-m02*m13);
	madj[1][3]=m00*(m12*m23-m13*m22)+m10*(m03*m22-m02*m23)+m20*(m02*m13-m03*m12);
	madj[2][0]=m10*(m21*m33-m23*m31)+m20*(m13*m31-m11*m33)+m30*(m11*m23-m13*m21);
	madj[2][1]=m00*(m23*m31-m21*m33)+m20*(m01*m33-m03*m31)+m30*(m03*m21-m01*m23);
	madj[2][2]=m00*(m11*m33-m13*m31)+m10*(m03*m31-m01*m33)+m30*(m01*m13-m03*m11);
	madj[2][3]=m00*(m13*m21-m11*m23)+m10*(m01*m23-m03*m21)+m20*(m03*m11-m01*m13);
	madj[3][0]=m10*(m22*m31-m21*m32)+m20*(m11*m32-m12*m31)+m30*(m12*m21-m11*m22);
	madj[3][1]=m00*(m21*m32-m22*m31)+m20*(m02*m31-m01*m32)+m30*(m01*m22-m02*m21);
	madj[3][2]=m00*(m12*m31-m11*m32)+m10*(m01*m32-m02*m31)+m30*(m02*m11-m01*m12);
	madj[3][3]=m00*(m11*m22-m12*m21)+m10*(m02*m21-m01*m22)+m20*(m01*m12-m02*m11);
}
/*
 * Store the inverse of m in minv.
 * If m is singular, minv is instead its adjoint.
 * Returns det(m).
 * Works fine even if m and minv are the same matrix.
 */
double invertmat(Matrix m, Matrix minv){
	double d, dinv;
	int i, j;
	d=determinant(m);
	adjoint(m, minv);
	if(d!=0.){
		dinv=1./d;
		for(i=0;i!=4;i++) for(j=0;j!=4;j++) minv[i][j]*=dinv;
	}
	return d;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

