<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libhtml/build.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libhtml/build.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;ctype.h&gt;
#include &lt;html.h&gt;
#include "impl.h"

// A stack for holding integer values
enum {
	Nestmax = 40	// max nesting level of lists, font styles, etc.
};

struct Stack {
	int		n;				// next available slot (top of stack is stack[n-1])
	int		slots[Nestmax];	// stack entries
};

// Parsing state
struct Pstate
{
	Pstate*	next;			// in stack of Pstates
	int		skipping;		// true when we shouldn't add items
	int		skipwhite;		// true when we should strip leading space
	int		curfont;		// font index for current font
	int		curfg;		// current foreground color
	Background	curbg;	// current background
	int		curvoff;		// current baseline offset
	uchar	curul;		// current underline/strike state
	uchar	curjust;		// current justify state
	int		curanchor;	// current (href) anchor id (if in one), or 0
	int		curstate;		// current value of item state
	int		literal;		// current literal state
	int		inpar;		// true when in a paragraph-like construct
	int		adjsize;		// current font size adjustment
	Item*	items;		// dummy head of item list we're building
	Item*	lastit;		// tail of item list we're building
	Item*	prelastit;		// item before lastit
	Stack	fntstylestk;	// style stack
	Stack	fntsizestk;		// size stack
	Stack	fgstk;		// text color stack
	Stack	ulstk;		// underline stack
	Stack	voffstk;		// vertical offset stack
	Stack	listtypestk;	// list type stack
	Stack	listcntstk;		// list counter stack
	Stack	juststk;		// justification stack
	Stack	hangstk;		// hanging stack
};

struct ItemSource
{
	Docinfo*		doc;
	Pstate*		psstk;
	int			nforms;
	int			ntables;
	int			nanchors;
	int			nframes;
	Form*		curform;
	Map*		curmap;
	Table*		tabstk;
	Kidinfo*		kidstk;
};

// Some layout parameters
enum {
	FRKIDMARGIN = 6,	// default margin around kid frames
	IMGHSPACE = 0,	// default hspace for images (0 matches IE, Netscape)
	IMGVSPACE = 0,	// default vspace for images
	FLTIMGHSPACE = 2,	// default hspace for float images
	TABSP = 5,		// default cellspacing for tables
	TABPAD = 1,		// default cell padding for tables
	LISTTAB = 1,		// number of tabs to indent lists
	BQTAB = 1,		// number of tabs to indent blockquotes
	HRSZ = 2,			// thickness of horizontal rules
	SUBOFF = 4,		// vertical offset for subscripts
	SUPOFF = 6,		// vertical offset for superscripts
	NBSP = 160		// non-breaking space character
};

// These tables must be sorted
static StringInt align_tab[] = {
	{L"baseline",	ALbaseline},
	{L"bottom",	ALbottom},
	{L"center",	ALcenter},
	{L"char",		ALchar},
	{L"justify",	ALjustify},
	{L"left",		ALleft},
	{L"middle",	ALmiddle},
	{L"right",		ALright},
	{L"top",		ALtop}
};
#define NALIGNTAB (sizeof(align_tab)/sizeof(StringInt))

static StringInt input_tab[] = {
	{L"button",	Fbutton},
	{L"checkbox",	Fcheckbox},
	{L"file",		Ffile},
	{L"hidden",	Fhidden},
	{L"image",	Fimage},
	{L"password",	Fpassword},
	{L"radio",		Fradio},
	{L"reset",		Freset},
	{L"submit",	Fsubmit},
	{L"text",		Ftext}
};
#define NINPUTTAB (sizeof(input_tab)/sizeof(StringInt))

static StringInt clear_tab[] = {
	{L"all",	IFcleft|IFcright},
	{L"left",	IFcleft},
	{L"right",	IFcright}
};
#define NCLEARTAB (sizeof(clear_tab)/sizeof(StringInt))

static StringInt fscroll_tab[] = {
	{L"auto",	FRhscrollauto|FRvscrollauto},
	{L"no",	FRnoscroll},
	{L"yes",	FRhscroll|FRvscroll},
};
#define NFSCROLLTAB (sizeof(fscroll_tab)/sizeof(StringInt))

static StringInt shape_tab[] = {
	{L"circ",		SHcircle},
	{L"circle",		SHcircle},
	{L"poly",		SHpoly},
	{L"polygon",	SHpoly},
	{L"rect",		SHrect},
	{L"rectangle",	SHrect}
};
#define NSHAPETAB (sizeof(shape_tab)/sizeof(StringInt))

static StringInt method_tab[] = {
	{L"get",		HGet},
	{L"post",		HPost}
};
#define NMETHODTAB (sizeof(method_tab)/sizeof(StringInt))

static Rune* roman[15]= {
	L"I", L"II", L"III", L"IV", L"V", L"VI", L"VII", L"VIII", L"IX", L"X",
	L"XI", L"XII", L"XIII", L"XIV", L"XV"
};
#define NROMAN 15

// List number types
enum {
	LTdisc, LTsquare, LTcircle, LT1, LTa, LTA, LTi, LTI
};

enum {
	SPBefore = 2,
	SPAfter = 4,
	BL = 1,
	BLBA = (BL|SPBefore|SPAfter)
};

// blockbrk[tag] is break info for a block level element, or one
// of a few others that get the same treatment re ending open paragraphs
// and requiring a line break / vertical space before them.
// If we want a line of space before the given element, SPBefore is OR'd in.
// If we want a line of space after the given element, SPAfter is OR'd in.

static uchar blockbrk[Numtags]= {
	[Taddress] BLBA, [Tblockquote] BLBA, [Tcenter] BL,
	[Tdir] BLBA, [Tdiv] BL, [Tdd] BL, [Tdl] BLBA,
	[Tdt] BL, [Tform] BLBA,
	// headings and tables get breaks added manually
	[Th1] BL, [Th2] BL, [Th3] BL,
	[Th4] BL, [Th5] BL, [Th6] BL,
	[Thr] BL, [Tisindex] BLBA, [Tli] BL, [Tmenu] BLBA,
	[Tol] BLBA, [Tp] BLBA, [Tpre] BLBA,
	[Tul] BLBA
};

enum {
	AGEN = 1
};

// attrinfo is information about attributes.
// The AGEN value means that the attribute is generic (applies to almost all elements)
static uchar attrinfo[Numattrs]= {
	[Aid] AGEN, [Aclass] AGEN, [Astyle] AGEN, [Atitle] AGEN,
	[Aonblur] AGEN, [Aonchange] AGEN, [Aonclick] AGEN,
	[Aondblclick] AGEN, [Aonfocus] AGEN, [Aonkeypress] AGEN,
	[Aonkeyup] AGEN, [Aonload] AGEN, [Aonmousedown] AGEN,
	[Aonmousemove] AGEN, [Aonmouseout] AGEN, [Aonmouseover] AGEN,
	[Aonmouseup] AGEN, [Aonreset] AGEN, [Aonselect] AGEN,
	[Aonsubmit] AGEN, [Aonunload] AGEN
};

static uchar scriptev[Numattrs]= {
	[Aonblur] SEonblur, [Aonchange] SEonchange, [Aonclick] SEonclick,
	[Aondblclick] SEondblclick, [Aonfocus] SEonfocus, [Aonkeypress] SEonkeypress,
	[Aonkeyup] SEonkeyup, [Aonload] SEonload, [Aonmousedown] SEonmousedown,
	[Aonmousemove] SEonmousemove, [Aonmouseout] SEonmouseout, [Aonmouseover] SEonmouseover,
	[Aonmouseup] SEonmouseup, [Aonreset] SEonreset, [Aonselect] SEonselect,
	[Aonsubmit] SEonsubmit, [Aonunload] SEonunload
};

// Color lookup table
static StringInt color_tab[] = {
	{L"aqua", 0x00FFFF},
	{L"black",  0x000000},
	{L"blue", 0x0000CC},
	{L"fuchsia", 0xFF00FF},
	{L"gray", 0x808080},
	{L"green", 0x008000},
	{L"lime", 0x00FF00},
	{L"maroon", 0x800000},
	{L"navy", 0x000080,},
	{L"olive", 0x808000},
	{L"purple", 0x800080},
	{L"red", 0xFF0000},
	{L"silver", 0xC0C0C0},
	{L"teal", 0x008080},
	{L"white", 0xFFFFFF},
	{L"yellow", 0xFFFF00}
};
#define NCOLORS (sizeof(color_tab)/sizeof(StringInt))

static StringInt 		*targetmap;
static int			targetmapsize;
static int			ntargets;

static int buildinited = 0;

#define SMALLBUFSIZE 240
#define BIGBUFSIZE 2000

int	dbgbuild = 0;
int	warn = 0;

static Align		aalign(Token* tok);
static int			acolorval(Token* tok, int attid, int dflt);
static void			addbrk(Pstate* ps, int sp, int clr);
static void			additem(Pstate* ps, Item* it, Token* tok);
static void			addlinebrk(Pstate* ps, int clr);
static void			addnbsp(Pstate* ps);
static void			addtext(Pstate* ps, Rune* s);
static Dimen		adimen(Token* tok, int attid);
static int			aflagval(Token* tok, int attid);
static int			aintval(Token* tok, int attid, int dflt);
static Rune*		astrval(Token* tok, int attid, Rune* dflt);
static int			atabval(Token* tok, int attid, StringInt* tab, int ntab, int dflt);
static int			atargval(Token* tok, int dflt);
static int			auintval(Token* tok, int attid, int dflt);
static Rune*		aurlval(Token* tok, int attid, Rune* dflt, Rune* base);
static Rune*		aval(Token* tok, int attid);
static void			buildinit(void);
static Pstate*		cell_pstate(Pstate* oldps, int ishead);
static void			changehang(Pstate* ps, int delta);
static void			changeindent(Pstate* ps, int delta);
static int			color(Rune* s, int dflt);
static void			copystack(Stack* tostk, Stack* fromstk);
static int			dimprint(char* buf, int nbuf, Dimen d);
static Pstate*		finishcell(Table* curtab, Pstate* psstk);
static void			finish_table(Table* t);
static void			freeanchor(Anchor* a);
static void			freedestanchor(DestAnchor* da);
static void			freeform(Form* f);
static void			freeformfield(Formfield* ff);
static void			freeitem(Item* it);
static void			freepstate(Pstate* p);
static void			freepstatestack(Pstate* pshead);
static void			freescriptevents(SEvent* ehead);
static void			freetable(Table* t);
static Map*		getmap(Docinfo* di, Rune* name);
static Rune*		getpcdata(Token* toks, int tokslen, int* ptoki);
static Pstate*		lastps(Pstate* psl);
static Rune*		listmark(uchar ty, int n);
static int			listtyval(Token* tok, int dflt);
static Align		makealign(int halign, int valign);
static Background	makebackground(Rune* imgurl, int color);
static Dimen		makedimen(int kind, int spec);
static Anchor*		newanchor(int index, Rune* name, Rune* href, int target, Anchor* link);
static Area*		newarea(int shape, Rune* href, int target, Area* link);
static DestAnchor*	newdestanchor(int index, Rune* name, Item* item, DestAnchor* link);
static Docinfo*		newdocinfo(void);
static Genattr*		newgenattr(Rune* id, Rune* class, Rune* style, Rune* title, Attr* events);
static Form*		newform(int formid, Rune* name, Rune* action,
					int target, int method, Form* link);
static Formfield*	newformfield(int ftype, int fieldid, Form* form, Rune* name,
					Rune* value, int size, int maxlength, Formfield* link);
static Item*		newifloat(Item* it, int side);
static Item*		newiformfield(Formfield* ff);
static Item*		newiimage(Rune* src, Rune* altrep, int align, int width, int height,
					int hspace, int vspace, int border, int ismap, Map* map);
static Item*		newirule(int align, int size, int noshade, int color, Dimen wspec);
static Item*		newispacer(int spkind);
static Item*		newitable(Table* t);
static ItemSource*	newitemsource(Docinfo* di);
static Item*		newitext(Rune* s, int fnt, int fg, int voff, int ul);
static Kidinfo*		newkidinfo(int isframeset, Kidinfo* link);
static Option*		newoption(int selected, Rune* value, Rune* display, Option* link);
static Pstate*		newpstate(Pstate* link);
static SEvent*		newscriptevent(int type, Rune* script, SEvent* link);
static Table*		newtable(int tableid, Align align, Dimen width, int border,
					int cellspacing, int cellpadding, Background bg, Token* tok, Table* link);
static Tablecell*	newtablecell(int cellid, int rowspan, int colspan, Align align, Dimen wspec,
					int hspec, Background bg, int flags, Tablecell* link);
static Tablerow*	newtablerow(Align align, Background bg, int flags, Tablerow* link);
static Dimen		parsedim(Rune* s, int ns);
static void			pop(Stack* stk);
static void			popfontsize(Pstate* ps);
static void			popfontstyle(Pstate* ps);
static void			popjust(Pstate* ps);
static int			popretnewtop(Stack* stk, int dflt);
static int			push(Stack* stk, int val);
static void			pushfontsize(Pstate* ps, int sz);
static void			pushfontstyle(Pstate* ps, int sty);
static void			pushjust(Pstate* ps, int j);
static Item*		textit(Pstate* ps, Rune* s);
static Rune*		removeallwhite(Rune* s);
static void			resetdocinfo(Docinfo* d);
static void			setcurfont(Pstate* ps);
static void			setcurjust(Pstate* ps);
static void			setdimarray(Token* tok, int attid, Dimen** pans, int* panslen);
static Rune*		stringalign(int a);
static void			targetmapinit(void);
static int			toint(Rune* s);
static int			top(Stack* stk, int dflt);
static void			trim_cell(Tablecell* c);
static int			validalign(Align a);
static int			validdimen(Dimen d);
static int			validformfield(Formfield* f);
static int			validhalign(int a);
static int			validptr(void* p);
static int			validStr(Rune* s);
static int			validtable(Table* t);
static int			validtablerow(Tablerow* r);
static int			validtablecol(Tablecol* c);
static int			validtablecell(Tablecell* c);
static int			validvalign(int a);
static int			Iconv(Fmt *f);

static void
buildinit(void)
{
	fmtinstall('I', Iconv);
	targetmapinit();
	buildinited = 1;
}

static ItemSource*
newitemsource(Docinfo* di)
{
	ItemSource*	is;
	Pstate*	ps;

	ps = newpstate(nil);
	if(di-&gt;mediatype != TextHtml) {
		ps-&gt;curstate &amp;= ~IFwrap;
		ps-&gt;literal = 1;
		pushfontstyle(ps, FntT);
	}
	is = (ItemSource*)emalloc(sizeof(ItemSource));
	is-&gt;doc = di;
	is-&gt;psstk = ps;
	is-&gt;nforms = 0;
	is-&gt;ntables = 0;
	is-&gt;nanchors = 0;
	is-&gt;nframes = 0;
	is-&gt;curform = nil;
	is-&gt;curmap = nil;
	is-&gt;tabstk = nil;
	is-&gt;kidstk = nil;
	return is;
}

static Item *getitems(ItemSource* is, uchar* data, int datalen);

// Parse an html document and create a list of layout items.
// Allocate and return document info in *pdi.
// When caller is done with the items, it should call
// freeitems on the returned result, and then
// freedocinfo(*pdi).
Item*
parsehtml(uchar* data, int datalen, Rune* pagesrc, int mtype, int chset, Docinfo** pdi)
{
	Item *it;
	Docinfo*	di;
	ItemSource*	is;

	di = newdocinfo();
	di-&gt;src = _Strdup(pagesrc);
	di-&gt;base = _Strdup(pagesrc);
	di-&gt;mediatype = mtype;
	di-&gt;chset = chset;
	*pdi = di;
	is = newitemsource(di);
	it = getitems(is, data, datalen);
	freepstatestack(is-&gt;psstk);
	free(is);
	return it;
}

// Get a group of tokens for lexer, parse them, and create
// a list of layout items.
// When caller is done with the items, it should call
// freeitems on the returned result.
static Item*
getitems(ItemSource* is, uchar* data, int datalen)
{
	int	i;
	int	j;
	int	nt;
	int	pt;
	int	doscripts;
	int	tokslen;
	int	toki;
	int	h;
	int	sz;
	int	method;
	int	n;
	int	nblank;
	int	norsz;
	int	bramt;
	int	sty;
	int	nosh;
	int	color;
	int	oldcuranchor;
	int	dfltbd;
	int	v;
	int	hang;
	int	isempty;
	int	tag;
	int	brksp;
	int	target;
	uchar	brk;
	uchar	flags;
	uchar	align;
	uchar	al;
	uchar	ty;
	uchar	ty2;
	Pstate*	ps;
	Pstate*	nextps;
	Pstate*	outerps;
	Table*	curtab;
	Token*	tok;
	Token*	toks;
	Docinfo*	di;
	Item*	ans;
	Item*	img;
	Item*	ffit;
	Item*	tabitem;
	Rune*	s;
	Rune*	t;
	Rune*	name;
	Rune*	enctype;
	Rune*	usemap;
	Rune*	prompt;
	Rune*	equiv;
	Rune*	val;
	Rune*	nsz;
	Rune*	script;
	Map*	map;
	Form*	frm;
	Iimage*	ii;
	Kidinfo*	kd;
	Kidinfo*	ks;
	Kidinfo*	pks;
	Dimen	wd;
	Option*	option;
	Table*	tab;
	Tablecell*	c;
	Tablerow*	tr;
	Formfield*	field;
	Formfield*	ff;
	Rune*	href;
	Rune*	src;
	Rune*	scriptsrc;
	Rune*	bgurl;
	Rune*	action;
	Background	bg;

	if(!buildinited)
		buildinit();
	doscripts = 0;	// for now
	ps = is-&gt;psstk;
	curtab = is-&gt;tabstk;
	di = is-&gt;doc;
	toks = _gettoks(data, datalen, di-&gt;chset, di-&gt;mediatype, &amp;tokslen);
	toki = 0;
	for(; toki &lt; tokslen; toki++) {
		tok = &amp;toks[toki];
		if(dbgbuild &gt; 1)
			fprint(2, "build: curstate %ux, token %T\n", ps-&gt;curstate, tok);
		tag = tok-&gt;tag;
		brk = 0;
		brksp = 0;
		if(tag &lt; Numtags) {
			brk = blockbrk[tag];
			if(brk&amp;SPBefore)
				brksp = 1;
		}
		else if(tag &lt; Numtags + RBRA) {
			brk = blockbrk[tag - RBRA];
			if(brk&amp;SPAfter)
				brksp = 1;
		}
		if(brk) {
			addbrk(ps, brksp, 0);
			if(ps-&gt;inpar) {
				popjust(ps);
				ps-&gt;inpar = 0;
			}
		}
		// check common case first (Data), then switch statement on tag
		if(tag == Data) {
			// Lexing didn't pay attention to SGML record boundary rules:
			// \n after start tag or before end tag to be discarded.
			// (Lex has already discarded all \r's).
			// Some pages assume this doesn't happen in &lt;PRE&gt; text,
			// so we won't do it if literal is true.
			// BUG: won't discard \n before a start tag that begins
			// the next bufferful of tokens.
			s = tok-&gt;text;
			n = _Strlen(s);
			if(!ps-&gt;literal) {
				i = 0;
				j = n;
				if(toki &gt; 0) {
					pt = toks[toki - 1].tag;
					// IE and Netscape both ignore this rule (contrary to spec)
					// if previous tag was img
					if(pt &lt; Numtags &amp;&amp; pt != Timg &amp;&amp; j &gt; 0 &amp;&amp; s[0] == '\n')
						i++;
				}
				if(toki &lt; tokslen - 1) {
					nt = toks[toki + 1].tag;
					if(nt &gt;= RBRA &amp;&amp; nt &lt; Numtags + RBRA &amp;&amp; j &gt; i &amp;&amp; s[j - 1] == '\n')
						j--;
				}
				if(i &gt; 0 || j &lt; n) {
					t = s;
					s = _Strsubstr(s, i, j);
					free(t);
					n = j-i;
				}
			}
			if(ps-&gt;skipwhite) {
				_trimwhite(s, n, &amp;t, &amp;nt);
				if(t == nil) {
					free(s);
					s = nil;
				}
				else if(t != s) {
					t = _Strndup(t, nt);
					free(s);
					s = t;
				}
				if(s != nil)
					ps-&gt;skipwhite = 0;
			}
			tok-&gt;text = nil;		// token doesn't own string anymore
			if(s != nil)
				addtext(ps, s);
		}
		else
			switch(tag) {
			// Some abbrevs used in following DTD comments
			// %text = 	#PCDATA
			//		| TT | I | B | U | STRIKE | BIG | SMALL | SUB | SUP
			//		| EM | STRONG | DFN | CODE | SAMP | KBD | VAR | CITE
			//		| A | IMG | APPLET | FONT | BASEFONT | BR | SCRIPT | MAP
			//		| INPUT | SELECT | TEXTAREA
			// %block = P | UL | OL | DIR | MENU | DL | PRE | DL | DIV | CENTER
			//		| BLOCKQUOTE | FORM | ISINDEX | HR | TABLE
			// %flow = (%text | %block)*
			// %body.content = (%heading | %text | %block | ADDRESS)*

			// &lt;!ELEMENT A - - (%text) -(A)&gt;
			// Anchors are not supposed to be nested, but you sometimes see
			// href anchors inside destination anchors.
			case Ta:
				if(ps-&gt;curanchor != 0) {
					if(warn)
						fprint(2, "warning: nested &lt;A&gt; or missing &lt;/A&gt;\n");
					ps-&gt;curanchor = 0;
				}
				name = aval(tok, Aname);
				href = aurlval(tok, Ahref, nil, di-&gt;base);
				// ignore rel, rev, and title attrs
				if(href != nil) {
					target = atargval(tok, di-&gt;target);
					di-&gt;anchors = newanchor(++is-&gt;nanchors, name, href, target, di-&gt;anchors);
					if(name != nil)
						name = _Strdup(name);	// for DestAnchor construction, below
					ps-&gt;curanchor = is-&gt;nanchors;
					ps-&gt;curfg = push(&amp;ps-&gt;fgstk, di-&gt;link);
					ps-&gt;curul = push(&amp;ps-&gt;ulstk, ULunder);
				}
				if(name != nil) {
					// add a null item to be destination
					additem(ps, newispacer(ISPnull), tok);
					di-&gt;dests = newdestanchor(++is-&gt;nanchors, name, ps-&gt;lastit, di-&gt;dests);
				}
				break;

			case Ta+RBRA :
				if(ps-&gt;curanchor != 0) {
					ps-&gt;curfg = popretnewtop(&amp;ps-&gt;fgstk, di-&gt;text);
					ps-&gt;curul = popretnewtop(&amp;ps-&gt;ulstk, ULnone);
					ps-&gt;curanchor = 0;
				}
				break;

			// &lt;!ELEMENT APPLET - - (PARAM | %text)* &gt;
			// We can't do applets, so ignore PARAMS, and let
			// the %text contents appear for the alternative rep
			case Tapplet:
			case Tapplet+RBRA:
				if(warn &amp;&amp; tag == Tapplet)
					fprint(2, "warning: &lt;APPLET&gt; ignored\n");
				break;

			// &lt;!ELEMENT AREA - O EMPTY&gt;
			case Tarea:
				map = di-&gt;maps;
				if(map == nil) {
					if(warn)
						fprint(2, "warning: &lt;AREA&gt; not inside &lt;MAP&gt;\n");
					continue;
				}
				map-&gt;areas = newarea(atabval(tok, Ashape, shape_tab, NSHAPETAB, SHrect),
					aurlval(tok, Ahref, nil, di-&gt;base),
					atargval(tok, di-&gt;target),
					map-&gt;areas);
				setdimarray(tok, Acoords, &amp;map-&gt;areas-&gt;coords, &amp;map-&gt;areas-&gt;ncoords);
				break;

			// &lt;!ELEMENT (B|STRONG) - - (%text)*&gt;
			case Tb:
			case Tstrong:
				pushfontstyle(ps, FntB);
				break;

			case Tb+RBRA:
			case Tcite+RBRA:
			case Tcode+RBRA:
			case Tdfn+RBRA:
			case Tem+RBRA:
			case Tkbd+RBRA:
			case Ti+RBRA:
			case Tsamp+RBRA:
			case Tstrong+RBRA:
			case Ttt+RBRA:
			case Tvar+RBRA :
			case Taddress+RBRA:
				popfontstyle(ps);
				break;

			// &lt;!ELEMENT BASE - O EMPTY&gt;
			case Tbase:
				t = di-&gt;base;
				di-&gt;base = aurlval(tok, Ahref, di-&gt;base, di-&gt;base);
				if(t != nil)
					free(t);
				di-&gt;target = atargval(tok, di-&gt;target);
				break;

			// &lt;!ELEMENT BASEFONT - O EMPTY&gt;
			case Tbasefont:
				ps-&gt;adjsize = aintval(tok, Asize, 3) - 3;
				break;

			// &lt;!ELEMENT (BIG|SMALL) - - (%text)*&gt;
			case Tbig:
			case Tsmall:
				sz = ps-&gt;adjsize;
				if(tag == Tbig)
					sz += Large;
				else
					sz += Small;
				pushfontsize(ps, sz);
				break;

			case Tbig+RBRA:
			case Tsmall+RBRA:
				popfontsize(ps);
				break;

			// &lt;!ELEMENT BLOCKQUOTE - - %body.content&gt;
			case Tblockquote:
				changeindent(ps, BQTAB);
				break;

			case Tblockquote+RBRA:
				changeindent(ps, -BQTAB);
				break;

			// &lt;!ELEMENT BODY O O %body.content&gt;
			case Tbody:
				ps-&gt;skipping = 0;
				bg = makebackground(nil, acolorval(tok, Abgcolor, di-&gt;background.color));
				bgurl = aurlval(tok, Abackground, nil, di-&gt;base);
				if(bgurl != nil) {
					if(di-&gt;backgrounditem != nil)
						freeitem((Item*)di-&gt;backgrounditem);
						// really should remove old item from di-&gt;images list,
						// but there should only be one BODY element ...
					di-&gt;backgrounditem = (Iimage*)newiimage(bgurl, nil, ALnone, 0, 0, 0, 0, 0, 0, nil);
					di-&gt;backgrounditem-&gt;nextimage = di-&gt;images;
					di-&gt;images = di-&gt;backgrounditem;
				}
				ps-&gt;curbg = bg;
				di-&gt;background = bg;
				di-&gt;text = acolorval(tok, Atext, di-&gt;text);
				di-&gt;link = acolorval(tok, Alink, di-&gt;link);
				di-&gt;vlink = acolorval(tok, Avlink, di-&gt;vlink);
				di-&gt;alink = acolorval(tok, Aalink, di-&gt;alink);
				if(di-&gt;text != ps-&gt;curfg) {
					ps-&gt;curfg = di-&gt;text;
					ps-&gt;fgstk.n = 0;
				}
				break;

			case Tbody+RBRA:
				// HTML spec says ignore things after &lt;/body&gt;,
				// but IE and Netscape don't
				// ps.skipping = 1;
				break;

			// &lt;!ELEMENT BR - O EMPTY&gt;
			case Tbr:
				addlinebrk(ps, atabval(tok, Aclear, clear_tab, NCLEARTAB, 0));
				break;

			// &lt;!ELEMENT CAPTION - - (%text;)*&gt;
			case Tcaption:
				if(curtab == nil) {
					if(warn)
						fprint(2, "warning: &lt;CAPTION&gt; outside &lt;TABLE&gt;\n");
					continue;
				}
				if(curtab-&gt;caption != nil) {
					if(warn)
						fprint(2, "warning: more than one &lt;CAPTION&gt; in &lt;TABLE&gt;\n");
					continue;
				}
				ps = newpstate(ps);
				curtab-&gt;caption_place = atabval(tok, Aalign, align_tab, NALIGNTAB, ALtop);
				break;

			case Tcaption+RBRA:
				nextps = ps-&gt;next;
				if(curtab == nil || nextps == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/CAPTION&gt;\n");
					continue;
				}
				curtab-&gt;caption = ps-&gt;items-&gt;next;
				free(ps);
				ps = nextps;
				break;

			case Tcenter:
			case Tdiv:
				if(tag == Tcenter)
					al = ALcenter;
				else
					al = atabval(tok, Aalign, align_tab, NALIGNTAB, ps-&gt;curjust);
				pushjust(ps, al);
				break;

			case Tcenter+RBRA:
			case Tdiv+RBRA:
				popjust(ps);
				break;

			// &lt;!ELEMENT DD - O  %flow &gt;
			case Tdd:
				if(ps-&gt;hangstk.n == 0) {
					if(warn)
						fprint(2, "warning: &lt;DD&gt; not inside &lt;DL\n");
					continue;
				}
				h = top(&amp;ps-&gt;hangstk, 0);
				if(h != 0)
					changehang(ps, -10*LISTTAB);
				else
					addbrk(ps, 0, 0);
				push(&amp;ps-&gt;hangstk, 0);
				break;

			//&lt;!ELEMENT (DIR|MENU) - - (LI)+ -(%block) &gt;
			//&lt;!ELEMENT (OL|UL) - - (LI)+&gt;
			case Tdir:
			case Tmenu:
			case Tol:
			case Tul:
				changeindent(ps, LISTTAB);
				push(&amp;ps-&gt;listtypestk, listtyval(tok, (tag==Tol)? LT1 : LTdisc));
				push(&amp;ps-&gt;listcntstk, aintval(tok, Astart, 1));
				break;

			case Tdir+RBRA:
			case Tmenu+RBRA:
			case Tol+RBRA:
			case Tul+RBRA:
				if(ps-&gt;listtypestk.n == 0) {
					if(warn)
						fprint(2, "warning: %T ended no list\n", tok);
					continue;
				}
				addbrk(ps, 0, 0);
				pop(&amp;ps-&gt;listtypestk);
				pop(&amp;ps-&gt;listcntstk);
				changeindent(ps, -LISTTAB);
				break;

			// &lt;!ELEMENT DL - - (DT|DD)+ &gt;
			case Tdl:
				changeindent(ps, LISTTAB);
				push(&amp;ps-&gt;hangstk, 0);
				break;

			case Tdl+RBRA:
				if(ps-&gt;hangstk.n == 0) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/DL&gt;\n");
					continue;
				}
				changeindent(ps, -LISTTAB);
				if(top(&amp;ps-&gt;hangstk, 0) != 0)
					changehang(ps, -10*LISTTAB);
				pop(&amp;ps-&gt;hangstk);
				break;

			// &lt;!ELEMENT DT - O (%text)* &gt;
			case Tdt:
				if(ps-&gt;hangstk.n == 0) {
					if(warn)
						fprint(2, "warning: &lt;DT&gt; not inside &lt;DL&gt;\n");
					continue;
				}
				h = top(&amp;ps-&gt;hangstk, 0);
				pop(&amp;ps-&gt;hangstk);
				if(h != 0)
					changehang(ps, -10*LISTTAB);
				changehang(ps, 10*LISTTAB);
				push(&amp;ps-&gt;hangstk, 1);
				break;

			// &lt;!ELEMENT FONT - - (%text)*&gt;
			case Tfont:
				sz = top(&amp;ps-&gt;fntsizestk, Normal);
				if(_tokaval(tok, Asize, &amp;nsz, 0)) {
					if(_prefix(L"+", nsz))
						sz = Normal + _Strtol(nsz+1, nil, 10) + ps-&gt;adjsize;
					else if(_prefix(L"-", nsz))
						sz = Normal - _Strtol(nsz+1, nil, 10) + ps-&gt;adjsize;
					else if(nsz != nil)
						sz = Normal + (_Strtol(nsz, nil, 10) - 3);
				}
				ps-&gt;curfg = push(&amp;ps-&gt;fgstk, acolorval(tok, Acolor, ps-&gt;curfg));
				pushfontsize(ps, sz);
				break;

			case Tfont+RBRA:
				if(ps-&gt;fgstk.n == 0) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/FONT&gt;\n");
					continue;
				}
				ps-&gt;curfg = popretnewtop(&amp;ps-&gt;fgstk, di-&gt;text);
				popfontsize(ps);
				break;

			// &lt;!ELEMENT FORM - - %body.content -(FORM) &gt;
			case Tform:
				if(is-&gt;curform != nil) {
					if(warn)
						fprint(2, "warning: &lt;FORM&gt; nested inside another\n");
					continue;
				}
				action = aurlval(tok, Aaction, di-&gt;base, di-&gt;base);
				s = aval(tok, Aid);
				name = astrval(tok, Aname, s);
				if(s)
					free(s);
				target = atargval(tok, di-&gt;target);
				method = atabval(tok, Amethod, method_tab, NMETHODTAB, HGet);
				if(warn &amp;&amp; _tokaval(tok, Aenctype, &amp;enctype, 0) &amp;&amp;
						_Strcmp(enctype, L"application/x-www-form-urlencoded"))
					fprint(2, "form enctype %S not handled\n", enctype);
				frm = newform(++is-&gt;nforms, name, action, target, method, di-&gt;forms);
				di-&gt;forms = frm;
				is-&gt;curform = frm;
				break;

			case Tform+RBRA:
				if(is-&gt;curform == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/FORM&gt;\n");
					continue;
				}
				// put fields back in input order
				is-&gt;curform-&gt;fields = (Formfield*)_revlist((List*)is-&gt;curform-&gt;fields);
				is-&gt;curform = nil;
				break;

			// &lt;!ELEMENT FRAME - O EMPTY&gt;
			case Tframe:
				ks = is-&gt;kidstk;
				if(ks == nil) {
					if(warn)
						fprint(2, "warning: &lt;FRAME&gt; not in &lt;FRAMESET&gt;\n");
					continue;
				}
				ks-&gt;kidinfos = kd = newkidinfo(0, ks-&gt;kidinfos);
				kd-&gt;src = aurlval(tok, Asrc, nil, di-&gt;base);
				kd-&gt;name = aval(tok, Aname);
				if(kd-&gt;name == nil)
					kd-&gt;name = runesmprint("_fr%d", ++is-&gt;nframes);
				kd-&gt;marginw = auintval(tok, Amarginwidth, 0);
				kd-&gt;marginh = auintval(tok, Amarginheight, 0);
				kd-&gt;framebd = auintval(tok, Aframeborder, 1);
				kd-&gt;flags = atabval(tok, Ascrolling, fscroll_tab, NFSCROLLTAB, kd-&gt;flags);
				norsz = aflagval(tok, Anoresize);
				if(norsz)
					kd-&gt;flags |= FRnoresize;
				break;

			// &lt;!ELEMENT FRAMESET - - (FRAME|FRAMESET)+&gt;
			case Tframeset:
				ks = newkidinfo(1, nil);
				pks = is-&gt;kidstk;
				if(pks == nil)
					di-&gt;kidinfo = ks;
				else  {
					ks-&gt;next = pks-&gt;kidinfos;
					pks-&gt;kidinfos = ks;
				}
				ks-&gt;nextframeset = pks;
				is-&gt;kidstk = ks;
				setdimarray(tok, Arows, &amp;ks-&gt;rows, &amp;ks-&gt;nrows);
				if(ks-&gt;nrows == 0) {
					ks-&gt;rows = (Dimen*)emalloc(sizeof(Dimen));
					ks-&gt;nrows = 1;
					ks-&gt;rows[0] = makedimen(Dpercent, 100);
				}
				setdimarray(tok, Acols, &amp;ks-&gt;cols, &amp;ks-&gt;ncols);
				if(ks-&gt;ncols == 0) {
					ks-&gt;cols = (Dimen*)emalloc(sizeof(Dimen));
					ks-&gt;ncols = 1;
					ks-&gt;cols[0] = makedimen(Dpercent, 100);
				}
				break;

			case Tframeset+RBRA:
				if(is-&gt;kidstk == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/FRAMESET&gt;\n");
					continue;
				}
				ks = is-&gt;kidstk;
				// put kids back in original order
				// and add blank frames to fill out cells
				n = ks-&gt;nrows*ks-&gt;ncols;
				nblank = n - _listlen((List*)ks-&gt;kidinfos);
				while(nblank-- &gt; 0)
					ks-&gt;kidinfos = newkidinfo(0, ks-&gt;kidinfos);
				ks-&gt;kidinfos = (Kidinfo*)_revlist((List*)ks-&gt;kidinfos);
				is-&gt;kidstk = is-&gt;kidstk-&gt;nextframeset;
				if(is-&gt;kidstk == nil) {
					// end input
					ans = nil;
					goto return_ans;
				}
				break;

			// &lt;!ELEMENT H1 - - (%text;)*&gt;, etc.
			case Th1:
			case Th2:
			case Th3:
			case Th4:
			case Th5:
			case Th6:
				bramt = 1;
				if(ps-&gt;items == ps-&gt;lastit)
					bramt = 0;
				addbrk(ps, bramt, IFcleft|IFcright);
				sz = Verylarge - (tag - Th1);
				if(sz &lt; Tiny)
					sz = Tiny;
				pushfontsize(ps, sz);
				sty = top(&amp;ps-&gt;fntstylestk, FntR);
				if(tag == Th1)
					sty = FntB;
				pushfontstyle(ps, sty);
				pushjust(ps, atabval(tok, Aalign, align_tab, NALIGNTAB, ps-&gt;curjust));
				ps-&gt;skipwhite = 1;
				break;

			case Th1+RBRA:
			case Th2+RBRA:
			case Th3+RBRA:
			case Th4+RBRA:
			case Th5+RBRA:
			case Th6+RBRA:
				addbrk(ps, 1, IFcleft|IFcright);
				popfontsize(ps);
				popfontstyle(ps);
				popjust(ps);
				break;

			case Thead:
				// HTML spec says ignore regular markup in head,
				// but Netscape and IE don't
				// ps.skipping = 1;
				break;

			case Thead+RBRA:
				ps-&gt;skipping = 0;
				break;

			// &lt;!ELEMENT HR - O EMPTY&gt;
			case Thr:
				al = atabval(tok, Aalign, align_tab, NALIGNTAB, ALcenter);
				sz = auintval(tok, Asize, HRSZ);
				wd = adimen(tok, Awidth);
				if(dimenkind(wd) == Dnone)
					wd = makedimen(Dpercent, 100);
				nosh = aflagval(tok, Anoshade);
				color = acolorval(tok, Acolor, 0);
				additem(ps, newirule(al, sz, nosh, color, wd), tok);
				addbrk(ps, 0, 0);
				break;

			case Ti:
			case Tcite:
			case Tdfn:
			case Tem:
			case Tvar:
			case Taddress:
				pushfontstyle(ps, FntI);
				break;

			// &lt;!ELEMENT IMG - O EMPTY&gt;
			case Timg:
				map = nil;
				oldcuranchor = ps-&gt;curanchor;
				if(_tokaval(tok, Ausemap, &amp;usemap, 0)) {
					if(!_prefix(L"#", usemap)) {
						if(warn)
							fprint(2, "warning: can't handle non-local map %S\n", usemap);
					}
					else {
						map = getmap(di, usemap+1);
						if(ps-&gt;curanchor == 0) {
							di-&gt;anchors = newanchor(++is-&gt;nanchors, nil, nil, di-&gt;target, di-&gt;anchors);
							ps-&gt;curanchor = is-&gt;nanchors;
						}
					}
				}
				align = atabval(tok, Aalign, align_tab, NALIGNTAB, ALbottom);
				dfltbd = 0;
				if(ps-&gt;curanchor != 0)
					dfltbd = 2;
				src = aurlval(tok, Asrc, nil, di-&gt;base);
				if(src == nil) {
					if(warn)
						fprint(2, "warning: &lt;img&gt; has no src attribute\n");
					ps-&gt;curanchor = oldcuranchor;
					continue;
				}
				img = newiimage(src,
						aval(tok, Aalt),
						align,
						auintval(tok, Awidth, 0),
						auintval(tok, Aheight, 0),
						auintval(tok, Ahspace, IMGHSPACE),
						auintval(tok, Avspace, IMGVSPACE),
						auintval(tok, Aborder, dfltbd),
						aflagval(tok, Aismap),
						map);
				if(align == ALleft || align == ALright) {
					additem(ps, newifloat(img, align), tok);
					// if no hspace specified, use FLTIMGHSPACE
					if(!_tokaval(tok, Ahspace, &amp;val, 0))
						((Iimage*)img)-&gt;hspace = FLTIMGHSPACE;
				}
				else {
					ps-&gt;skipwhite = 0;
					additem(ps, img, tok);
				}
				if(!ps-&gt;skipping) {
					((Iimage*)img)-&gt;nextimage = di-&gt;images;
					di-&gt;images = (Iimage*)img;
				}
				ps-&gt;curanchor = oldcuranchor;
				break;

			// &lt;!ELEMENT INPUT - O EMPTY&gt;
			case Tinput:
				ps-&gt;skipwhite = 0;
				if(is-&gt;curform == nil) {
					if(warn)
						fprint(2, "&lt;INPUT&gt; not inside &lt;FORM&gt;\n");
					continue;
				}
				is-&gt;curform-&gt;fields = field = newformfield(
						atabval(tok, Atype, input_tab, NINPUTTAB, Ftext),
						++is-&gt;curform-&gt;nfields,
						is-&gt;curform,
						aval(tok, Aname),
						aval(tok, Avalue),
						auintval(tok, Asize, 0),
						auintval(tok, Amaxlength, 1000),
						is-&gt;curform-&gt;fields);
				if(aflagval(tok, Achecked))
					field-&gt;flags = FFchecked;

				switch(field-&gt;ftype) {
				case Ftext:
				case Fpassword:
				case Ffile:
					if(field-&gt;size == 0)
						field-&gt;size = 20;
					break;

				case Fcheckbox:
					if(field-&gt;name == nil) {
						if(warn)
							fprint(2, "warning: checkbox form field missing name\n");
						continue;
					}
					if(field-&gt;value == nil)
						field-&gt;value = _Strdup(L"1");
					break;

				case Fradio:
					if(field-&gt;name == nil || field-&gt;value == nil) {
						if(warn)
							fprint(2, "warning: radio form field missing name or value\n");
						continue;
					}
					break;

				case Fsubmit:
					if(field-&gt;value == nil)
						field-&gt;value = _Strdup(L"Submit");
					if(field-&gt;name == nil)
						field-&gt;name = _Strdup(L"_no_name_submit_");
					break;

				case Fimage:
					src = aurlval(tok, Asrc, nil, di-&gt;base);
					if(src == nil) {
						if(warn)
							fprint(2, "warning: image form field missing src\n");
						continue;
					}
					// width and height attrs aren't specified in HTML 3.2,
					// but some people provide them and they help avoid
					// a relayout
					field-&gt;image = newiimage(src,
						astrval(tok, Aalt, L"Submit"),
						atabval(tok, Aalign, align_tab, NALIGNTAB, ALbottom),
						auintval(tok, Awidth, 0), auintval(tok, Aheight, 0),
						0, 0, 0, 0, nil);
					ii = (Iimage*)field-&gt;image;
					ii-&gt;nextimage = di-&gt;images;
					di-&gt;images = ii;
					break;

				case Freset:
					if(field-&gt;value == nil)
						field-&gt;value = _Strdup(L"Reset");
					break;

				case Fbutton:
					if(field-&gt;value == nil)
						field-&gt;value = _Strdup(L" ");
					break;
				}
				ffit = newiformfield(field);
				additem(ps, ffit, tok);
				if(ffit-&gt;genattr != nil)
					field-&gt;events = ffit-&gt;genattr-&gt;events;
				break;

			// &lt;!ENTITY ISINDEX - O EMPTY&gt;
			case Tisindex:
				ps-&gt;skipwhite = 0;
				prompt = astrval(tok, Aprompt, L"Index search terms:");
				target = atargval(tok, di-&gt;target);
				additem(ps, textit(ps, prompt), tok);
				frm = newform(++is-&gt;nforms,
						nil,
						di-&gt;base,
						target,
						HGet,
						di-&gt;forms);
				di-&gt;forms = frm;
				ff = newformfield(Ftext,
						1,
						frm,
						_Strdup(L"_ISINDEX_"),
						nil,
						50,
						1000,
						nil);
				frm-&gt;fields = ff;
				frm-&gt;nfields = 1;
				additem(ps, newiformfield(ff), tok);
				addbrk(ps, 1, 0);
				break;

			// &lt;!ELEMENT LI - O %flow&gt;
			case Tli:
				if(ps-&gt;listtypestk.n == 0) {
					if(warn)
						fprint(2, "&lt;LI&gt; not in list\n");
					continue;
				}
				ty = top(&amp;ps-&gt;listtypestk, 0);
				ty2 = listtyval(tok, ty);
				if(ty != ty2) {
					ty = ty2;
					push(&amp;ps-&gt;listtypestk, ty2);
				}
				v = aintval(tok, Avalue, top(&amp;ps-&gt;listcntstk, 1));
				if(ty == LTdisc || ty == LTsquare || ty == LTcircle)
					hang = 10*LISTTAB - 3;
				else
					hang = 10*LISTTAB - 1;
				changehang(ps, hang);
				addtext(ps, listmark(ty, v));
				push(&amp;ps-&gt;listcntstk, v + 1);
				changehang(ps, -hang);
				ps-&gt;skipwhite = 1;
				break;

			// &lt;!ELEMENT MAP - - (AREA)+&gt;
			case Tmap:
				if(_tokaval(tok, Aname, &amp;name, 0))
					is-&gt;curmap = getmap(di, name);
				break;

			case Tmap+RBRA:
				map = is-&gt;curmap;
				if(map == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/MAP&gt;\n");
					continue;
				}
				map-&gt;areas = (Area*)_revlist((List*)map-&gt;areas);
				break;

			case Tmeta:
				if(ps-&gt;skipping)
					continue;
				if(_tokaval(tok, Ahttp_equiv, &amp;equiv, 0)) {
					val = aval(tok, Acontent);
					n = _Strlen(equiv);
					if(!_Strncmpci(equiv, n, L"refresh"))
						di-&gt;refresh = val;
					else if(!_Strncmpci(equiv, n, L"content-script-type")) {
						n = _Strlen(val);
						if(!_Strncmpci(val, n, L"javascript")
						   || !_Strncmpci(val, n, L"jscript1.1")
						   || !_Strncmpci(val, n, L"jscript"))
							di-&gt;scripttype = TextJavascript;
						else {
							if(warn)
								fprint(2, "unimplemented script type %S\n", val);
							di-&gt;scripttype = UnknownType;
						}
					}
				}
				break;

			// Nobr is NOT in HMTL 4.0, but it is ubiquitous on the web
			case Tnobr:
				ps-&gt;skipwhite = 0;
				ps-&gt;curstate &amp;= ~IFwrap;
				break;

			case Tnobr+RBRA:
				ps-&gt;curstate |= IFwrap;
				break;

			// We do frames, so skip stuff in noframes
			case Tnoframes:
				ps-&gt;skipping = 1;
				break;

			case Tnoframes+RBRA:
				ps-&gt;skipping = 0;
				break;

			// We do scripts (if enabled), so skip stuff in noscripts
			case Tnoscript:
				if(doscripts)
					ps-&gt;skipping = 1;
				break;

			case Tnoscript+RBRA:
				if(doscripts)
					ps-&gt;skipping = 0;
				break;

			// &lt;!ELEMENT OPTION - O (	//PCDATA)&gt;
			case Toption:
				if(is-&gt;curform == nil || is-&gt;curform-&gt;fields == nil) {
					if(warn)
						fprint(2, "warning: &lt;OPTION&gt; not in &lt;SELECT&gt;\n");
					continue;
				}
				field = is-&gt;curform-&gt;fields;
				if(field-&gt;ftype != Fselect) {
					if(warn)
						fprint(2, "warning: &lt;OPTION&gt; not in &lt;SELECT&gt;\n");
					continue;
				}
				val = aval(tok, Avalue);
				option = newoption(aflagval(tok, Aselected), val, nil, field-&gt;options);
				field-&gt;options = option;
				option-&gt;display =  getpcdata(toks, tokslen, &amp;toki);
				if(val == nil)
					option-&gt;value = _Strdup(option-&gt;display);
				break;

			// &lt;!ELEMENT P - O (%text)* &gt;
			case Tp:
				pushjust(ps, atabval(tok, Aalign, align_tab, NALIGNTAB, ps-&gt;curjust));
				ps-&gt;inpar = 1;
				ps-&gt;skipwhite = 1;
				break;

			case Tp+RBRA:
				break;

			// &lt;!ELEMENT PARAM - O EMPTY&gt;
			// Do something when we do applets...
			case Tparam:
				break;

			// &lt;!ELEMENT PRE - - (%text)* -(IMG|BIG|SMALL|SUB|SUP|FONT) &gt;
			case Tpre:
				ps-&gt;curstate &amp;= ~IFwrap;
				ps-&gt;literal = 1;
				ps-&gt;skipwhite = 0;
				pushfontstyle(ps, FntT);
				break;

			case Tpre+RBRA:
				ps-&gt;curstate |= IFwrap;
				if(ps-&gt;literal) {
					popfontstyle(ps);
					ps-&gt;literal = 0;
				}
				break;

			// &lt;!ELEMENT SCRIPT - - CDATA&gt;
			case Tscript:
				if(doscripts) {
					if(!di-&gt;hasscripts) {
						if(di-&gt;scripttype == TextJavascript) {
							// TODO: initialize script if nec.
							// initjscript(di);
							di-&gt;hasscripts = 1;
						}
					}
				}
				if(!di-&gt;hasscripts) {
					if(warn)
						fprint(2, "warning: &lt;SCRIPT&gt; ignored\n");
					ps-&gt;skipping = 1;
				}
				else {
					scriptsrc = aurlval(tok, Asrc, nil, di-&gt;base);
					script = nil;
					if(scriptsrc != nil) {
						if(warn)
							fprint(2, "warning: non-local &lt;SCRIPT&gt; ignored\n");
						free(scriptsrc);
					}
					else {
						script = getpcdata(toks, tokslen, &amp;toki);
					}
					if(script != nil) {
						if(warn)
							fprint(2, "script ignored\n");
						free(script);
					}
				}
				break;

			case Tscript+RBRA:
				ps-&gt;skipping = 0;
				break;

			// &lt;!ELEMENT SELECT - - (OPTION+)&gt;
			case Tselect:
				if(is-&gt;curform == nil) {
					if(warn)
						fprint(2, "&lt;SELECT&gt; not inside &lt;FORM&gt;\n");
					continue;
				}
				field = newformfield(Fselect,
					++is-&gt;curform-&gt;nfields,
					is-&gt;curform,
					aval(tok, Aname),
					nil,
					auintval(tok, Asize, 0),
					0,
					is-&gt;curform-&gt;fields);
				is-&gt;curform-&gt;fields = field;
				if(aflagval(tok, Amultiple))
					field-&gt;flags = FFmultiple;
				ffit = newiformfield(field);
				additem(ps, ffit, tok);
				if(ffit-&gt;genattr != nil)
					field-&gt;events = ffit-&gt;genattr-&gt;events;
				// throw away stuff until next tag (should be &lt;OPTION&gt;)
				s = getpcdata(toks, tokslen, &amp;toki);
				if(s != nil)
					free(s);
				break;

			case Tselect+RBRA:
				if(is-&gt;curform == nil || is-&gt;curform-&gt;fields == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/SELECT&gt;\n");
					continue;
				}
				field = is-&gt;curform-&gt;fields;
				if(field-&gt;ftype != Fselect)
					continue;
				// put options back in input order
				field-&gt;options = (Option*)_revlist((List*)field-&gt;options);
				break;

			// &lt;!ELEMENT (STRIKE|U) - - (%text)*&gt;
			case Tstrike:
			case Tu:
				ps-&gt;curul = push(&amp;ps-&gt;ulstk, (tag==Tstrike)? ULmid : ULunder);
				break;

			case Tstrike+RBRA:
			case Tu+RBRA:
				if(ps-&gt;ulstk.n == 0) {
					if(warn)
						fprint(2, "warning: unexpected %T\n", tok);
					continue;
				}
				ps-&gt;curul = popretnewtop(&amp;ps-&gt;ulstk, ULnone);
				break;

			// &lt;!ELEMENT STYLE - - CDATA&gt;
			case Tstyle:
				if(warn)
					fprint(2, "warning: unimplemented &lt;STYLE&gt;\n");
				ps-&gt;skipping = 1;
				break;

			case Tstyle+RBRA:
				ps-&gt;skipping = 0;
				break;

			// &lt;!ELEMENT (SUB|SUP) - - (%text)*&gt;
			case Tsub:
			case Tsup:
				if(tag == Tsub)
					ps-&gt;curvoff += SUBOFF;
				else
					ps-&gt;curvoff -= SUPOFF;
				push(&amp;ps-&gt;voffstk, ps-&gt;curvoff);
				sz = top(&amp;ps-&gt;fntsizestk, Normal);
				pushfontsize(ps, sz - 1);
				break;

			case Tsub+RBRA:
			case Tsup+RBRA:
				if(ps-&gt;voffstk.n == 0) {
					if(warn)
						fprint(2, "warning: unexpected %T\n", tok);
					continue;
				}
				ps-&gt;curvoff = popretnewtop(&amp;ps-&gt;voffstk, 0);
				popfontsize(ps);
				break;

			// &lt;!ELEMENT TABLE - - (CAPTION?, TR+)&gt;
			case Ttable:
				ps-&gt;skipwhite = 0;
				tab = newtable(++is-&gt;ntables,
						aalign(tok),
						adimen(tok, Awidth),
						aflagval(tok, Aborder), 
						auintval(tok, Acellspacing, TABSP),
						auintval(tok, Acellpadding, TABPAD),
						makebackground(nil, acolorval(tok, Abgcolor, ps-&gt;curbg.color)),
						tok,
						is-&gt;tabstk);
				is-&gt;tabstk = tab;
				curtab = tab;
				break;

			case Ttable+RBRA:
				if(curtab == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/TABLE&gt;\n");
					continue;
				}
				isempty = (curtab-&gt;cells == nil);
				if(isempty) {
					if(warn)
						fprint(2, "warning: &lt;TABLE&gt; has no cells\n");
				}
				else {
					ps = finishcell(curtab, ps);
					if(curtab-&gt;rows != nil)
						curtab-&gt;rows-&gt;flags = 0;
					finish_table(curtab);
				}
				ps-&gt;skipping = 0;
				if(!isempty) {
					tabitem = newitable(curtab);
					al = curtab-&gt;align.halign;
					switch(al) {
					case ALleft:
					case ALright:
						additem(ps, newifloat(tabitem, al), tok);
						break;
					default:
						if(al == ALcenter)
							pushjust(ps, ALcenter);
						addbrk(ps, 0, 0);
						if(ps-&gt;inpar) {
							popjust(ps);
							ps-&gt;inpar = 0;
						}
						additem(ps, tabitem, curtab-&gt;tabletok);
						if(al == ALcenter)
							popjust(ps);
						break;
					}
				}
				if(is-&gt;tabstk == nil) {
					if(warn)
						fprint(2, "warning: table stack is wrong\n");
				}
				else
					is-&gt;tabstk = is-&gt;tabstk-&gt;next;
				curtab-&gt;next = di-&gt;tables;
				di-&gt;tables = curtab;
				curtab = is-&gt;tabstk;
				if(!isempty)
					addbrk(ps, 0, 0);
				break;

			// &lt;!ELEMENT (TH|TD) - O %body.content&gt;
			// Cells for a row are accumulated in reverse order.
			// We push ps on a stack, and use a new one to accumulate
			// the contents of the cell.
			case Ttd:
			case Tth:
				if(curtab == nil) {
					if(warn)
						fprint(2, "%T outside &lt;TABLE&gt;\n", tok);
					continue;
				}
				if(ps-&gt;inpar) {
					popjust(ps);
					ps-&gt;inpar = 0;
				}
				ps = finishcell(curtab, ps);
				tr = nil;
				if(curtab-&gt;rows != nil)
					tr = curtab-&gt;rows;
				if(tr == nil || !tr-&gt;flags) {
					if(warn)
						fprint(2, "%T outside row\n", tok);
					tr = newtablerow(makealign(ALnone, ALnone),
							makebackground(nil, curtab-&gt;background.color),
							TFparsing,
							curtab-&gt;rows);
					curtab-&gt;rows = tr;
				}
				ps = cell_pstate(ps, tag == Tth);
				flags = TFparsing;
				if(aflagval(tok, Anowrap)) {
					flags |= TFnowrap;
					ps-&gt;curstate &amp;= ~IFwrap;
				}
				if(tag == Tth)
					flags |= TFisth;
				c = newtablecell(curtab-&gt;cells==nil? 1 : curtab-&gt;cells-&gt;cellid+1,
						auintval(tok, Arowspan, 1),
						auintval(tok, Acolspan, 1), 
						aalign(tok), 
						adimen(tok, Awidth),
						auintval(tok, Aheight, 0),
						makebackground(nil, acolorval(tok, Abgcolor, tr-&gt;background.color)),
						flags,
						curtab-&gt;cells);
				curtab-&gt;cells = c;
				ps-&gt;curbg = c-&gt;background;
				if(c-&gt;align.halign == ALnone) {
					if(tr-&gt;align.halign != ALnone)
						c-&gt;align.halign = tr-&gt;align.halign;
					else if(tag == Tth)
						c-&gt;align.halign = ALcenter;
					else
						c-&gt;align.halign = ALleft;
				}
				if(c-&gt;align.valign == ALnone) {
					if(tr-&gt;align.valign != ALnone)
						c-&gt;align.valign = tr-&gt;align.valign;
					else
						c-&gt;align.valign = ALmiddle;
				}
				c-&gt;nextinrow = tr-&gt;cells;
				tr-&gt;cells = c;
				break;

			case Ttd+RBRA:
			case Tth+RBRA:
				if(curtab == nil || curtab-&gt;cells == nil) {
					if(warn)
						fprint(2, "unexpected %T\n", tok);
					continue;
				}
				ps = finishcell(curtab, ps);
				break;

			// &lt;!ELEMENT TEXTAREA - - (	//PCDATA)&gt;
			case Ttextarea:
				if(is-&gt;curform == nil) {
					if(warn)
						fprint(2, "&lt;TEXTAREA&gt; not inside &lt;FORM&gt;\n");
					continue;
				}
				field = newformfield(Ftextarea,
					++is-&gt;curform-&gt;nfields,
					is-&gt;curform,
					aval(tok, Aname),
					nil,
					0,
					0,
					is-&gt;curform-&gt;fields);
				is-&gt;curform-&gt;fields = field;
				field-&gt;rows = auintval(tok, Arows, 3);
				field-&gt;cols = auintval(tok, Acols, 50);
				field-&gt;value = getpcdata(toks, tokslen, &amp;toki);
				if(warn &amp;&amp; toki &lt; tokslen - 1 &amp;&amp; toks[toki + 1].tag != Ttextarea + RBRA)
					fprint(2, "warning: &lt;TEXTAREA&gt; data ended by %T\n", &amp;toks[toki + 1]);
				ffit = newiformfield(field);
				additem(ps, ffit, tok);
				if(ffit-&gt;genattr != nil)
					field-&gt;events = ffit-&gt;genattr-&gt;events;
				break;

			// &lt;!ELEMENT TITLE - - (	//PCDATA)* -(%head.misc)&gt;
			case Ttitle:
				di-&gt;doctitle = getpcdata(toks, tokslen, &amp;toki);
				if(warn &amp;&amp; toki &lt; tokslen - 1 &amp;&amp; toks[toki + 1].tag != Ttitle + RBRA)
					fprint(2, "warning: &lt;TITLE&gt; data ended by %T\n", &amp;toks[toki + 1]);
				break;

			// &lt;!ELEMENT TR - O (TH|TD)+&gt;
			// rows are accumulated in reverse order in curtab-&gt;rows
			case Ttr:
				if(curtab == nil) {
					if(warn)
						fprint(2, "warning: &lt;TR&gt; outside &lt;TABLE&gt;\n");
					continue;
				}
				if(ps-&gt;inpar) {
					popjust(ps);
					ps-&gt;inpar = 0;
				}
				ps = finishcell(curtab, ps);
				if(curtab-&gt;rows != nil)
					curtab-&gt;rows-&gt;flags = 0;
				curtab-&gt;rows = newtablerow(aalign(tok),
					makebackground(nil, acolorval(tok, Abgcolor, curtab-&gt;background.color)),
					TFparsing,
					curtab-&gt;rows);
				break;

			case Ttr+RBRA:
				if(curtab == nil || curtab-&gt;rows == nil) {
					if(warn)
						fprint(2, "warning: unexpected &lt;/TR&gt;\n");
					continue;
				}
				ps = finishcell(curtab, ps);
				tr = curtab-&gt;rows;
				if(tr-&gt;cells == nil) {
					if(warn)
						fprint(2, "warning: empty row\n");
					curtab-&gt;rows = tr-&gt;next;
					tr-&gt;next = nil;
				}
				else
					tr-&gt;flags = 0;
				break;

			// &lt;!ELEMENT (TT|CODE|KBD|SAMP) - - (%text)*&gt;
			case Ttt:
			case Tcode:
			case Tkbd:
			case Tsamp:
				pushfontstyle(ps, FntT);
				break;

			// Tags that have empty action
			case Tabbr:
			case Tabbr+RBRA:
			case Tacronym:
			case Tacronym+RBRA:
			case Tarea+RBRA:
			case Tbase+RBRA:
			case Tbasefont+RBRA:
			case Tbr+RBRA:
			case Tdd+RBRA:
			case Tdt+RBRA:
			case Tframe+RBRA:
			case Thr+RBRA:
			case Thtml:
			case Thtml+RBRA:
			case Timg+RBRA:
			case Tinput+RBRA:
			case Tisindex+RBRA:
			case Tli+RBRA:
			case Tlink:
			case Tlink+RBRA:
			case Tmeta+RBRA:
			case Toption+RBRA:
			case Tparam+RBRA:
			case Ttextarea+RBRA:
			case Ttitle+RBRA:
				break;


			// Tags not implemented
			case Tbdo:
			case Tbdo+RBRA:
			case Tbutton:
			case Tbutton+RBRA:
			case Tdel:
			case Tdel+RBRA:
			case Tfieldset:
			case Tfieldset+RBRA:
			case Tiframe:
			case Tiframe+RBRA:
			case Tins:
			case Tins+RBRA:
			case Tlabel:
			case Tlabel+RBRA:
			case Tlegend:
			case Tlegend+RBRA:
			case Tobject:
			case Tobject+RBRA:
			case Toptgroup:
			case Toptgroup+RBRA:
			case Tspan:
			case Tspan+RBRA:
				if(warn) {
					if(tag &gt; RBRA)
						tag -= RBRA;
					fprint(2, "warning: unimplemented HTML tag: %S\n", tagnames[tag]);
				}
				break;

			default:
				if(warn)
					fprint(2, "warning: unknown HTML tag: %S\n", tok-&gt;text);
				break;
			}
	}
	// some pages omit trailing &lt;/table&gt;
	while(curtab != nil) {
		if(warn)
			fprint(2, "warning: &lt;TABLE&gt; not closed\n");
		if(curtab-&gt;cells != nil) {
			ps = finishcell(curtab, ps);
			if(curtab-&gt;cells == nil) {
				if(warn)
					fprint(2, "warning: empty table\n");
			}
			else {
				if(curtab-&gt;rows != nil)
					curtab-&gt;rows-&gt;flags = 0;
				finish_table(curtab);
				ps-&gt;skipping = 0;
				additem(ps, newitable(curtab), curtab-&gt;tabletok);
				addbrk(ps, 0, 0);
			}
		}
		if(is-&gt;tabstk != nil)
			is-&gt;tabstk = is-&gt;tabstk-&gt;next;
		curtab-&gt;next = di-&gt;tables;
		di-&gt;tables = curtab;
		curtab = is-&gt;tabstk;
	}
	outerps = lastps(ps);
	ans = outerps-&gt;items-&gt;next;
	freeitem(outerps-&gt;items);
	// note: ans may be nil and di-&gt;kids not nil, if there's a frameset!
	outerps-&gt;items = newispacer(ISPnull);
	outerps-&gt;lastit = outerps-&gt;items;
	is-&gt;psstk = ps;
	if(ans != nil &amp;&amp; di-&gt;hasscripts) {
		// TODO evalscript(nil);
		;
	}

return_ans:
	if(dbgbuild) {
		assert(validitems(ans));
		if(ans == nil)
			fprint(2, "getitems returning nil\n");
		else
			printitems(ans, "getitems returning:");
	}
	return ans;
}

// Concatenate together maximal set of Data tokens, starting at toks[toki+1].
// Lexer has ensured that there will either be a following non-data token or
// we will be at eof.
// Return emallocd trimmed concatenation, and update *ptoki to last used toki
static Rune*
getpcdata(Token* toks, int tokslen, int* ptoki)
{
	Rune*	ans;
	Rune*	p;
	Rune*	trimans;
	int	anslen;
	int	trimanslen;
	int	toki;
	Token*	tok;

	ans = nil;
	anslen = 0;
	// first find length of answer
	toki = (*ptoki) + 1;
	while(toki &lt; tokslen) {
		tok = &amp;toks[toki];
		if(tok-&gt;tag == Data) {
			toki++;
			anslen += _Strlen(tok-&gt;text);
		}
		else
			break;
	}
	// now make up the initial answer
	if(anslen &gt; 0) {
		ans = _newstr(anslen);
		p = ans;
		toki = (*ptoki) + 1;
		while(toki &lt; tokslen) {
			tok = &amp;toks[toki];
			if(tok-&gt;tag == Data) {
				toki++;
				p = _Stradd(p, tok-&gt;text, _Strlen(tok-&gt;text));
			}
			else
				break;
		}
		*p = 0;
		_trimwhite(ans, anslen, &amp;trimans, &amp;trimanslen);
		if(trimanslen != anslen) {
			p = ans;
			ans = _Strndup(trimans, trimanslen);
			free(p);
		}
	}
	*ptoki = toki-1;
	return ans;
}

// If still parsing head of curtab-&gt;cells list, finish it off
// by transferring the items on the head of psstk to the cell.
// Then pop the psstk and return the new psstk.
static Pstate*
finishcell(Table* curtab, Pstate* psstk)
{
	Tablecell*	c;
	Pstate* psstknext;

	c = curtab-&gt;cells;
	if(c != nil) {
		if((c-&gt;flags&amp;TFparsing)) {
			psstknext = psstk-&gt;next;
			if(psstknext == nil) {
				if(warn)
					fprint(2, "warning: parse state stack is wrong\n");
			}
			else {
				c-&gt;content = psstk-&gt;items-&gt;next;
				c-&gt;flags &amp;= ~TFparsing;
				freepstate(psstk);
				psstk = psstknext;
			}
		}
	}
	return psstk;
}

// Make a new Pstate for a cell, based on the old pstate, oldps.
// Also, put the new ps on the head of the oldps stack.
static Pstate*
cell_pstate(Pstate* oldps, int ishead)
{
	Pstate*	ps;
	int	sty;

	ps = newpstate(oldps);
	ps-&gt;skipwhite = 1;
	ps-&gt;curanchor = oldps-&gt;curanchor;
	copystack(&amp;ps-&gt;fntstylestk, &amp;oldps-&gt;fntstylestk);
	copystack(&amp;ps-&gt;fntsizestk, &amp;oldps-&gt;fntsizestk);
	ps-&gt;curfont = oldps-&gt;curfont;
	ps-&gt;curfg = oldps-&gt;curfg;
	ps-&gt;curbg = oldps-&gt;curbg;
	copystack(&amp;ps-&gt;fgstk, &amp;oldps-&gt;fgstk);
	ps-&gt;adjsize = oldps-&gt;adjsize;
	if(ishead) {
		sty = ps-&gt;curfont%NumSize;
		ps-&gt;curfont = FntB*NumSize + sty;
	}
	return ps;
}

// Return a new Pstate with default starting state.
// Use link to add it to head of a list, if any.
static Pstate*
newpstate(Pstate* link)
{
	Pstate*	ps;

	ps = (Pstate*)emalloc(sizeof(Pstate));
	ps-&gt;curfont = DefFnt;
	ps-&gt;curfg = Black;
	ps-&gt;curbg.image = nil;
	ps-&gt;curbg.color = White;
	ps-&gt;curul = ULnone;
	ps-&gt;curjust = ALleft;
	ps-&gt;curstate = IFwrap;
	ps-&gt;items = newispacer(ISPnull);
	ps-&gt;lastit = ps-&gt;items;
	ps-&gt;prelastit = nil;
	ps-&gt;next = link;
	return ps;
}

// Return last Pstate on psl list
static Pstate*
lastps(Pstate* psl)
{
	assert(psl != nil);
	while(psl-&gt;next != nil)
		psl = psl-&gt;next;
	return psl;
}

// Add it to end of ps item chain, adding in current state from ps.
// Also, if tok is not nil, scan it for generic attributes and assign
// the genattr field of the item accordingly.
static void
additem(Pstate* ps, Item* it, Token* tok)
{
	int	aid;
	int	any;
	Rune*	i;
	Rune*	c;
	Rune*	s;
	Rune*	t;
	Attr*	a;
	SEvent*	e;

	if(ps-&gt;skipping) {
		if(warn)
			fprint(2, "warning: skipping item: %I\n", it);
		return;
	}
	it-&gt;anchorid = ps-&gt;curanchor;
	it-&gt;state |= ps-&gt;curstate;
	if(tok != nil) {
		any = 0;
		i = nil;
		c = nil;
		s = nil;
		t = nil;
		e = nil;
		for(a = tok-&gt;attr; a != nil; a = a-&gt;next) {
			aid = a-&gt;attid;
			if(!attrinfo[aid])
				continue;
			switch(aid) {
			case Aid:
				i = a-&gt;value;
				break;

			case Aclass:
				c = a-&gt;value;
				break;

			case Astyle:
				s = a-&gt;value;
				break;

			case Atitle:
				t = a-&gt;value;
				break;

			default:
				assert(aid &gt;= Aonblur &amp;&amp; aid &lt;= Aonunload);
				e = newscriptevent(scriptev[a-&gt;attid], a-&gt;value, e);
				break;
			}
			a-&gt;value = nil;
			any = 1;
		}
		if(any)
			it-&gt;genattr = newgenattr(i, c, s, t, e);
	}
	ps-&gt;curstate &amp;= ~(IFbrk|IFbrksp|IFnobrk|IFcleft|IFcright);
	ps-&gt;prelastit = ps-&gt;lastit;
	ps-&gt;lastit-&gt;next = it;
	ps-&gt;lastit = it;
}

// Make a text item out of s,
// using current font, foreground, vertical offset and underline state.
static Item*
textit(Pstate* ps, Rune* s)
{
	assert(s != nil);
	return newitext(s, ps-&gt;curfont, ps-&gt;curfg, ps-&gt;curvoff + Voffbias, ps-&gt;curul);
}

// Add text item or items for s, paying attention to
// current font, foreground, baseline offset, underline state,
// and literal mode.  Unless we're in literal mode, compress
// whitespace to single blank, and, if curstate has a break,
// trim any leading whitespace.  Whether in literal mode or not,
// turn nonbreaking spaces into spacer items with IFnobrk set.
//
// In literal mode, break up s at newlines and add breaks instead.
// Also replace tabs appropriate number of spaces.
// In nonliteral mode, break up the items every 100 or so characters
// just to make the layout algorithm not go quadratic.
//
// addtext assumes ownership of s.
static void
addtext(Pstate* ps, Rune* s)
{
	int	n;
	int	i;
	int	j;
	int	k;
	int	col;
	int	c;
	int	nsp;
	Item*	it;
	Rune*	ss;
	Rune*	p;
	Rune	buf[SMALLBUFSIZE];

	assert(s != nil);
	n = runestrlen(s);
	i = 0;
	j = 0;
	if(ps-&gt;literal) {
		col = 0;
		while(i &lt; n) {
			if(s[i] == '\n') {
				if(i &gt; j) {
					// trim trailing blanks from line
					for(k = i; k &gt; j; k--)
						if(s[k - 1] != ' ')
							break;
					if(k &gt; j)
						additem(ps, textit(ps, _Strndup(s+j, k-j)), nil);
				}
				addlinebrk(ps, 0);
				j = i + 1;
				col = 0;
			}
			else {
				if(s[i] == '\t') {
					col += i - j;
					nsp = 8 - (col%8);
					// make ss = s[j:i] + nsp spaces
					ss = _newstr(i-j+nsp);
					p = _Stradd(ss, s+j, i-j);
					p = _Stradd(p, L"        ", nsp);
					*p = 0;
					additem(ps, textit(ps, ss), nil);
					col += nsp;
					j = i + 1;
				}
				else if(s[i] == NBSP) {
					if(i &gt; j)
						additem(ps, textit(ps, _Strndup(s+j, i-j)), nil);
					addnbsp(ps);
					col += (i - j) + 1;
					j = i + 1;
				}
			}
			i++;
		}
		if(i &gt; j) {
			if(j == 0 &amp;&amp; i == n) {
				// just transfer s over
				additem(ps, textit(ps, s), nil);
			}
			else {
				additem(ps, textit(ps, _Strndup(s+j, i-j)), nil);
				free(s);
			}
		}
	}
	else {	// not literal mode
		if((ps-&gt;curstate&amp;IFbrk) || ps-&gt;lastit == ps-&gt;items)
			while(i &lt; n) {
				c = s[i];
				if(c &gt;= 256 || !isspace(c))
					break;
				i++;
			}
		p = buf;
		for(j = i; i &lt; n; i++) {
			assert(p+i-j &lt; buf+SMALLBUFSIZE-1);
			c = s[i];
			if(c == NBSP) {
				if(i &gt; j)
					p = _Stradd(p, s+j, i-j);
				if(p &gt; buf)
					additem(ps, textit(ps, _Strndup(buf, p-buf)), nil);
				p = buf;
				addnbsp(ps);
				j = i + 1;
				continue;
			}
			if(c &lt; 256 &amp;&amp; isspace(c)) {
				if(i &gt; j)
					p = _Stradd(p, s+j, i-j);
				*p++ = ' ';
				while(i &lt; n - 1) {
					c = s[i + 1];
					if(c &gt;= 256 || !isspace(c))
						break;
					i++;
				}
				j = i + 1;
			}
			if(i - j &gt;= 100) {
				p = _Stradd(p, s+j, i+1-j);
				j = i + 1;
			}
			if(p-buf &gt;= 100) {
				additem(ps, textit(ps, _Strndup(buf, p-buf)), nil);
				p = buf;
			}
		}
		if(i &gt; j &amp;&amp; j &lt; n) {
			assert(p+i-j &lt; buf+SMALLBUFSIZE-1);
			p = _Stradd(p, s+j, i-j);
		}
		// don't add a space if previous item ended in a space
		if(p-buf == 1 &amp;&amp; buf[0] == ' ' &amp;&amp; ps-&gt;lastit != nil) {
			it = ps-&gt;lastit;
			if(it-&gt;tag == Itexttag) {
				ss = ((Itext*)it)-&gt;s;
				k = _Strlen(ss);
				if(k &gt; 0 &amp;&amp; ss[k] == ' ')
					p = buf;
			}
		}
		if(p &gt; buf)
			additem(ps, textit(ps, _Strndup(buf, p-buf)), nil);
		free(s);
	}
}

// Add a break to ps-&gt;curstate, with extra space if sp is true.
// If there was a previous break, combine this one's parameters
// with that to make the amt be the max of the two and the clr
// be the most general. (amt will be 0 or 1)
// Also, if the immediately preceding item was a text item,
// trim any whitespace from the end of it, if not in literal mode.
// Finally, if this is at the very beginning of the item list
// (the only thing there is a null spacer), then don't add the space.
static void
addbrk(Pstate* ps, int sp, int clr)
{
	int	state;
	Rune*	l;
	int		nl;
	Rune*	r;
	int		nr;
	Itext*	t;
	Rune*	s;

	state = ps-&gt;curstate;
	clr = clr|(state&amp;(IFcleft|IFcright));
	if(sp &amp;&amp; !(ps-&gt;lastit == ps-&gt;items))
		sp = IFbrksp;
	else
		sp = 0;
	ps-&gt;curstate = IFbrk|sp|(state&amp;~(IFcleft|IFcright))|clr;
	if(ps-&gt;lastit != ps-&gt;items) {
		if(!ps-&gt;literal &amp;&amp; ps-&gt;lastit-&gt;tag == Itexttag) {
			t = (Itext*)ps-&gt;lastit;
			_splitr(t-&gt;s, _Strlen(t-&gt;s), notwhitespace, &amp;l, &amp;nl, &amp;r, &amp;nr);
			// try to avoid making empty items
			// but not crucial f the occasional one gets through
			if(nl == 0 &amp;&amp; ps-&gt;prelastit != nil) {
				ps-&gt;lastit = ps-&gt;prelastit;
				ps-&gt;lastit-&gt;next = nil;
				ps-&gt;prelastit = nil;
			}
			else {
				s = t-&gt;s;
				if(nl == 0) {
					// need a non-nil pointer to empty string
					// (_Strdup(L"") returns nil)
					t-&gt;s = emalloc(sizeof(Rune));
					t-&gt;s[0] = 0;
				}
				else
					t-&gt;s = _Strndup(l, nl);
				if(s)
					free(s);
			}
		}
	}
}

// Add break due to a &lt;br&gt; or a newline within a preformatted section.
// We add a null item first, with current font's height and ascent, to make
// sure that the current line takes up at least that amount of vertical space.
// This ensures that &lt;br&gt;s on empty lines cause blank lines, and that
// multiple &lt;br&gt;s in a row give multiple blank lines.
// However don't add the spacer if the previous item was something that
// takes up space itself.
static void
addlinebrk(Pstate* ps, int clr)
{
	int	obrkstate;
	int	b;

	// don't want break before our null item unless the previous item
	// was also a null item for the purposes of line breaking
	obrkstate = ps-&gt;curstate&amp;(IFbrk|IFbrksp);
	b = IFnobrk;
	if(ps-&gt;lastit != nil) {
		if(ps-&gt;lastit-&gt;tag == Ispacertag) {
			if(((Ispacer*)ps-&gt;lastit)-&gt;spkind == ISPvline)
				b = IFbrk;
		}
	}
	ps-&gt;curstate = (ps-&gt;curstate&amp;~(IFbrk|IFbrksp))|b;
	additem(ps, newispacer(ISPvline), nil);
	ps-&gt;curstate = (ps-&gt;curstate&amp;~(IFbrk|IFbrksp))|obrkstate;
	addbrk(ps, 0, clr);
}

// Add a nonbreakable space
static void
addnbsp(Pstate* ps)
{
	// if nbsp comes right where a break was specified,
	// do the break anyway (nbsp is being used to generate undiscardable
	// space rather than to prevent a break)
	if((ps-&gt;curstate&amp;IFbrk) == 0)
		ps-&gt;curstate |= IFnobrk;
	additem(ps, newispacer(ISPhspace), nil);
	// but definitely no break on next item
	ps-&gt;curstate |= IFnobrk;
}

// Change hang in ps.curstate by delta.
// The amount is in 1/10ths of tabs, and is the amount that
// the current contiguous set of items with a hang value set
// is to be shifted left from its normal (indented) place.
static void
changehang(Pstate* ps, int delta)
{
	int	amt;

	amt = (ps-&gt;curstate&amp;IFhangmask) + delta;
	if(amt &lt; 0) {
		if(warn)
			fprint(2, "warning: hang went negative\n");
		amt = 0;
	}
	ps-&gt;curstate = (ps-&gt;curstate&amp;~IFhangmask)|amt;
}

// Change indent in ps.curstate by delta.
static void
changeindent(Pstate* ps, int delta)
{
	int	amt;

	amt = ((ps-&gt;curstate&amp;IFindentmask) &gt;&gt; IFindentshift) + delta;
	if(amt &lt; 0) {
		if(warn)
			fprint(2, "warning: indent went negative\n");
		amt = 0;
	}
	ps-&gt;curstate = (ps-&gt;curstate&amp;~IFindentmask)|(amt &lt;&lt; IFindentshift);
}

// Push val on top of stack, and also return value pushed
static int
push(Stack* stk, int val)
{
	if(stk-&gt;n == Nestmax) {
		if(warn)
			fprint(2, "warning: build stack overflow\n");
	}
	else
		stk-&gt;slots[stk-&gt;n++] = val;
	return val;
}

// Pop top of stack
static void
pop(Stack* stk)
{
	if(stk-&gt;n &gt; 0)
		--stk-&gt;n;
}

//Return top of stack, using dflt if stack is empty
static int
top(Stack* stk, int dflt)
{
	if(stk-&gt;n == 0)
		return dflt;
	return stk-&gt;slots[stk-&gt;n-1];
}

// pop, then return new top, with dflt if empty
static int
popretnewtop(Stack* stk, int dflt)
{
	if(stk-&gt;n == 0)
		return dflt;
	stk-&gt;n--;
	if(stk-&gt;n == 0)
		return dflt;
	return stk-&gt;slots[stk-&gt;n-1];
}

// Copy fromstk entries into tostk
static void
copystack(Stack* tostk, Stack* fromstk)
{
	int n;

	n = fromstk-&gt;n;
	tostk-&gt;n = n;
	memmove(tostk-&gt;slots, fromstk-&gt;slots, n*sizeof(int));
}

static void
popfontstyle(Pstate* ps)
{
	pop(&amp;ps-&gt;fntstylestk);
	setcurfont(ps);
}

static void
pushfontstyle(Pstate* ps, int sty)
{
	push(&amp;ps-&gt;fntstylestk, sty);
	setcurfont(ps);
}

static void
popfontsize(Pstate* ps)
{
	pop(&amp;ps-&gt;fntsizestk);
	setcurfont(ps);
}

static void
pushfontsize(Pstate* ps, int sz)
{
	push(&amp;ps-&gt;fntsizestk, sz);
	setcurfont(ps);
}

static void
setcurfont(Pstate* ps)
{
	int	sty;
	int	sz;

	sty = top(&amp;ps-&gt;fntstylestk, FntR);
	sz = top(&amp;ps-&gt;fntsizestk, Normal);
	if(sz &lt; Tiny)
		sz = Tiny;
	if(sz &gt; Verylarge)
		sz = Verylarge;
	ps-&gt;curfont = sty*NumSize + sz;
}

static void
popjust(Pstate* ps)
{
	pop(&amp;ps-&gt;juststk);
	setcurjust(ps);
}

static void
pushjust(Pstate* ps, int j)
{
	push(&amp;ps-&gt;juststk, j);
	setcurjust(ps);
}

static void
setcurjust(Pstate* ps)
{
	int	j;
	int	state;

	j = top(&amp;ps-&gt;juststk, ALleft);
	if(j != ps-&gt;curjust) {
		ps-&gt;curjust = j;
		state = ps-&gt;curstate;
		state &amp;= ~(IFrjust|IFcjust);
		if(j == ALcenter)
			state |= IFcjust;
		else if(j == ALright)
			state |= IFrjust;
		ps-&gt;curstate = state;
	}
}

// Do final rearrangement after table parsing is finished
// and assign cells to grid points
static void
finish_table(Table* t)
{
	int	ncol;
	int	nrow;
	int	r;
	Tablerow*	rl;
	Tablecell*	cl;
	int*	rowspancnt;
	Tablecell**	rowspancell;
	int	ri;
	int	ci;
	Tablecell*	c;
	Tablecell*	cnext;
	Tablerow*	row;
	Tablerow*	rownext;
	int	rcols;
	int	newncol;
	int	k;
	int	j;
	int	cspan;
	int	rspan;
	int	i;

	rl = t-&gt;rows;
	t-&gt;nrow = nrow = _listlen((List*)rl);
	t-&gt;rows = (Tablerow*)emalloc(nrow * sizeof(Tablerow));
	ncol = 0;
	r = nrow - 1;
	for(row = rl; row != nil; row = rownext) {
		// copy the data from the allocated Tablerow into the array slot
		t-&gt;rows[r] = *row;
		rownext = row-&gt;next;
		row = &amp;t-&gt;rows[r];
		r--;
		rcols = 0;
		c = row-&gt;cells;

		// If rowspan is &gt; 1 but this is the last row,
		// reset the rowspan
		if(c != nil &amp;&amp; c-&gt;rowspan &gt; 1 &amp;&amp; r == nrow-2)
				c-&gt;rowspan = 1;

		// reverse row-&gt;cells list (along nextinrow pointers)
		row-&gt;cells = nil;
		while(c != nil) {
			cnext = c-&gt;nextinrow;
			c-&gt;nextinrow = row-&gt;cells;
			row-&gt;cells = c;
			rcols += c-&gt;colspan;
			c = cnext;
		}
		if(rcols &gt; ncol)
			ncol = rcols;
	}
	t-&gt;ncol = ncol;
	t-&gt;cols = (Tablecol*)emalloc(ncol * sizeof(Tablecol));

	// Reverse cells just so they are drawn in source order.
	// Also, trim their contents so they don't end in whitespace.
	t-&gt;cells = (Tablecell*)_revlist((List*)t-&gt;cells);
	for(c = t-&gt;cells; c != nil; c= c-&gt;next)
		trim_cell(c);
	t-&gt;grid = (Tablecell***)emalloc(nrow * sizeof(Tablecell**));
	for(i = 0; i &lt; nrow; i++)
		t-&gt;grid[i] = (Tablecell**)emalloc(ncol * sizeof(Tablecell*));

	// The following arrays keep track of cells that are spanning
	// multiple rows;  rowspancnt[i] is the number of rows left
	// to be spanned in column i.
	// When done, cell's (row,col) is upper left grid point.
	rowspancnt = (int*)emalloc(ncol * sizeof(int));
	rowspancell = (Tablecell**)emalloc(ncol * sizeof(Tablecell*));
	for(ri = 0; ri &lt; nrow; ri++) {
		row = &amp;t-&gt;rows[ri];
		cl = row-&gt;cells;
		ci = 0;
		while(ci &lt; ncol || cl != nil) {
			if(ci &lt; ncol &amp;&amp; rowspancnt[ci] &gt; 0) {
				t-&gt;grid[ri][ci] = rowspancell[ci];
				rowspancnt[ci]--;
				ci++;
			}
			else {
				if(cl == nil) {
					ci++;
					continue;
				}
				c = cl;
				cl = cl-&gt;nextinrow;
				cspan = c-&gt;colspan;
				rspan = c-&gt;rowspan;
				if(ci + cspan &gt; ncol) {
					// because of row spanning, we calculated
					// ncol incorrectly; adjust it
					newncol = ci + cspan;
					t-&gt;cols = (Tablecol*)erealloc(t-&gt;cols, newncol * sizeof(Tablecol));
					rowspancnt = (int*)erealloc(rowspancnt, newncol * sizeof(int));
					rowspancell = (Tablecell**)erealloc(rowspancell, newncol * sizeof(Tablecell*));
					k = newncol-ncol;
					memset(t-&gt;cols+ncol, 0, k*sizeof(Tablecol));
					memset(rowspancnt+ncol, 0, k*sizeof(int));
					memset(rowspancell+ncol, 0, k*sizeof(Tablecell*));
					for(j = 0; j &lt; nrow; j++) {
						t-&gt;grid[j] = (Tablecell**)erealloc(t-&gt;grid[j], newncol * sizeof(Tablecell*));
						memset(t-&gt;grid[j], 0, k*sizeof(Tablecell*));
					}
					t-&gt;ncol = ncol = newncol;
				}
				c-&gt;row = ri;
				c-&gt;col = ci;
				for(i = 0; i &lt; cspan; i++) {
					t-&gt;grid[ri][ci] = c;
					if(rspan &gt; 1) {
						rowspancnt[ci] = rspan - 1;
						rowspancell[ci] = c;
					}
					ci++;
				}
			}
		}
	}
	free(rowspancnt);
	free(rowspancell);
}

// Remove tail of cell content until it isn't whitespace.
static void
trim_cell(Tablecell* c)
{
	int	dropping;
	Rune*	s;
	Rune*	x;
	Rune*	y;
	int		nx;
	int		ny;
	Item*	p;
	Itext*	q;
	Item*	pprev;

	dropping = 1;
	while(c-&gt;content != nil &amp;&amp; dropping) {
		p = c-&gt;content;
		pprev = nil;
		while(p-&gt;next != nil) {
			pprev = p;
			p = p-&gt;next;
		}
		dropping = 0;
		if(!(p-&gt;state&amp;IFnobrk)) {
			if(p-&gt;tag == Itexttag) {
				q = (Itext*)p;
				s = q-&gt;s;
				_splitr(s, _Strlen(s), notwhitespace, &amp;x, &amp;nx, &amp;y, &amp;ny);
				if(nx != 0 &amp;&amp; ny != 0) {
					q-&gt;s = _Strndup(x, nx);
					free(s);
				}
				break;
			}
		}
		if(dropping) {
			if(pprev == nil)
				c-&gt;content = nil;
			else
				pprev-&gt;next = nil;
			freeitem(p);
		}
	}
}

// Caller must free answer (eventually).
static Rune*
listmark(uchar ty, int n)
{
	Rune*	s;
	Rune*	t;
	int	n2;
	int	i;

	s = nil;
	switch(ty) {
	case LTdisc:
	case LTsquare:
	case LTcircle:
		s = _newstr(1);
		s[0] = (ty == LTdisc)? 0x2022		// bullet
			: ((ty == LTsquare)? 0x220e	// filled square
			    : 0x2218);				// degree
		s[1] = 0;
		break;

	case LT1:
		s = runesmprint("%d.", n);
		break;

	case LTa:
	case LTA:
		n--;
		i = 0;
		if(n &lt; 0)
			n = 0;
		s = _newstr((n &lt;= 25)? 2 : 3);
		if(n &gt; 25) {
			n2 = n%26;
			n /= 26;
			if(n2 &gt; 25)
				n2 = 25;
			s[i++] = n2 + (ty == LTa)? 'a' : 'A';
		}
		s[i++] = n + (ty == LTa)? 'a' : 'A';
		s[i++] = '.';
		s[i] = 0;
		break;

	case LTi:
	case LTI:
		if(n &gt;= NROMAN) {
			if(warn)
				fprint(2, "warning: unimplemented roman number &gt; %d\n", NROMAN);
			n = NROMAN;
		}
		t = roman[n - 1];
		n2 = _Strlen(t);
		s = _newstr(n2+1);
		for(i = 0; i &lt; n2; i++)
			s[i] = (ty == LTi)? tolower(t[i]) : t[i];
		s[i++] = '.';
		s[i] = 0;
		break;
	}
	return s;
}

// Find map with given name in di.maps.
// If not there, add one, copying name.
// Ownership of map remains with di-&gt;maps list.
static Map*
getmap(Docinfo* di, Rune* name)
{
	Map*	m;

	for(m = di-&gt;maps; m != nil; m = m-&gt;next) {
		if(!_Strcmp(name, m-&gt;name))
			return m;
	}
	m = (Map*)emalloc(sizeof(Map));
	m-&gt;name = _Strdup(name);
	m-&gt;areas = nil;
	m-&gt;next = di-&gt;maps;
	di-&gt;maps = m;
	return m;
}

// Transfers ownership of href to Area
static Area*
newarea(int shape, Rune* href, int target, Area* link)
{
	Area* a;

	a = (Area*)emalloc(sizeof(Area));
	a-&gt;shape = shape;
	a-&gt;href = href;
	a-&gt;target = target;
	a-&gt;next = link;
	return a;
}

// Return string value associated with attid in tok, nil if none.
// Caller must free the result (eventually).
static Rune*
aval(Token* tok, int attid)
{
	Rune*	ans;

	_tokaval(tok, attid, &amp;ans, 1);	// transfers string ownership from token to ans
	return ans;
}

// Like aval, but use dflt if there was no such attribute in tok.
// Caller must free the result (eventually).
static Rune*
astrval(Token* tok, int attid, Rune* dflt)
{
	Rune*	ans;

	if(_tokaval(tok, attid, &amp;ans, 1))
		return ans;	// transfers string ownership from token to ans
	else
		return _Strdup(dflt);
}

// Here we're supposed to convert to an int,
// and have a default when not found
static int
aintval(Token* tok, int attid, int dflt)
{
	Rune*	ans;

	if(!_tokaval(tok, attid, &amp;ans, 0) || ans == nil)
		return dflt;
	else
		return toint(ans);
}

// Like aintval, but result should be &gt;= 0
static int
auintval(Token* tok, int attid, int dflt)
{
	Rune* ans;
	int v;

	if(!_tokaval(tok, attid, &amp;ans, 0) || ans == nil)
		return dflt;
	else {
		v = toint(ans);
		return v &gt;= 0? v : 0;
	}
}

// int conversion, but with possible error check (if warning)
static int
toint(Rune* s)
{
	int ans;
	Rune* eptr;

	ans = _Strtol(s, &amp;eptr, 10);
	if(warn) {
		if(*eptr != 0) {
			eptr = _Strclass(eptr, notwhitespace);
			if(eptr != nil)
				fprint(2, "warning: expected integer, got %S\n", s);
		}
	}
	return ans;
}

// Attribute value when need a table to convert strings to ints
static int
atabval(Token* tok, int attid, StringInt* tab, int ntab, int dflt)
{
	Rune*	aval;
	int	ans;

	ans = dflt;
	if(_tokaval(tok, attid, &amp;aval, 0)) {
		if(!_lookup(tab, ntab, aval, _Strlen(aval), &amp;ans)) {
			ans = dflt;
			if(warn)
				fprint(2, "warning: name not found in table lookup: %S\n", aval);
		}
	}
	return ans;
}

// Attribute value when supposed to be a color
static int
acolorval(Token* tok, int attid, int dflt)
{
	Rune*	aval;
	int	ans;

	ans = dflt;
	if(_tokaval(tok, attid, &amp;aval, 0))
		ans = color(aval, dflt);
	return ans;
}

// Attribute value when supposed to be a target frame name
static int
atargval(Token* tok, int dflt)
{
	int	ans;
	Rune*	aval;

	ans = dflt;
	if(_tokaval(tok, Atarget, &amp;aval, 0)){
		ans = targetid(aval);
	}
	return ans;
}

// special for list types, where "i" and "I" are different,
// but "square" and "SQUARE" are the same
static int
listtyval(Token* tok, int dflt)
{
	Rune*	aval;
	int	ans;
	int	n;

	ans = dflt;
	if(_tokaval(tok, Atype, &amp;aval, 0)) {
		n = _Strlen(aval);
		if(n == 1) {
			switch(aval[0]) {
			case '1':
				ans = LT1;
				break;
			case 'A':
				ans = LTA;
				break;
			case 'I':
				ans = LTI;
				break;
			case 'a':
				ans = LTa;
				break;
			case 'i':
				ans = LTi;
			default:
				if(warn)
					fprint(2, "warning: unknown list element type %c\n", aval[0]);
			}
		}
		else {
			if(!_Strncmpci(aval, n, L"circle"))
				ans = LTcircle;
			else if(!_Strncmpci(aval, n, L"disc"))
				ans = LTdisc;
			else if(!_Strncmpci(aval, n, L"square"))
				ans = LTsquare;
			else {
				if(warn)
					fprint(2, "warning: unknown list element type %S\n", aval);
			}
		}
	}
	return ans;
}

// Attribute value when value is a URL, possibly relative to base.
// FOR NOW: leave the url relative.
// Caller must free the result (eventually).
static Rune*
aurlval(Token* tok, int attid, Rune* dflt, Rune* base)
{
	Rune*	ans;
	Rune*	url;

	USED(base);
	ans = nil;
	if(_tokaval(tok, attid, &amp;url, 0) &amp;&amp; url != nil)
		ans = removeallwhite(url);
	if(ans == nil)
		ans = _Strdup(dflt);
	return ans;
}

// Return copy of s but with all whitespace (even internal) removed.
// This fixes some buggy URL specification strings.
static Rune*
removeallwhite(Rune* s)
{
	int	j;
	int	n;
	int	i;
	int	c;
	Rune*	ans;

	j = 0;
	n = _Strlen(s);
	for(i = 0; i &lt; n; i++) {
		c = s[i];
		if(c &gt;= 256 || !isspace(c))
			j++;
	}
	if(j &lt; n) {
		ans = _newstr(j);
		j = 0;
		for(i = 0; i &lt; n; i++) {
			c = s[i];
			if(c &gt;= 256 || !isspace(c))
				ans[j++] = c;
		}
		ans[j] = 0;
	}
	else
		ans = _Strdup(s);
	return ans;
}

// Attribute value when mere presence of attr implies value of 1,
// but if there is an integer there, return it as the value.
static int
aflagval(Token* tok, int attid)
{
	int	val;
	Rune*	sval;

	val = 0;
	if(_tokaval(tok, attid, &amp;sval, 0)) {
		val = 1;
		if(sval != nil)
			val = toint(sval);
	}
	return val;
}

static Align
makealign(int halign, int valign)
{
	Align	al;

	al.halign = halign;
	al.valign = valign;
	return al;
}

// Make an Align (two alignments, horizontal and vertical)
static Align
aalign(Token* tok)
{
	return makealign(
		atabval(tok, Aalign, align_tab, NALIGNTAB, ALnone),
		atabval(tok, Avalign, align_tab, NALIGNTAB, ALnone));
}

// Make a Dimen, based on value of attid attr
static Dimen
adimen(Token* tok, int attid)
{
	Rune*	wd;

	if(_tokaval(tok, attid, &amp;wd, 0))
		return parsedim(wd, _Strlen(wd));
	else
		return makedimen(Dnone, 0);
}

// Parse s[0:n] as num[.[num]][unit][%|*]
static Dimen
parsedim(Rune* s, int ns)
{
	int	kind;
	int	spec;
	Rune*	l;
	int	nl;
	Rune*	r;
	int	nr;
	int	mul;
	int	i;
	Rune*	f;
	int	nf;
	int	Tkdpi;
	Rune*	units;

	kind = Dnone;
	spec = 0;
	_splitl(s, ns, L"^0-9", &amp;l, &amp;nl, &amp;r, &amp;nr);
	if(nl != 0) {
		spec = 1000*_Strtol(l, nil, 10);
		if(nr &gt; 0 &amp;&amp; r[0] == '.') {
			_splitl(r+1, nr-1, L"^0-9", &amp;f, &amp;nf, &amp;r, &amp;nr);
			if(nf != 0) {
				mul = 100;
				for(i = 0; i &lt; nf; i++) {
					spec = spec + mul*(f[i]-'0');
					mul = mul/10;
				}
			}
		}
		kind = Dpixels;
		if(nr != 0) {
			if(nr &gt;= 2) {
				Tkdpi = 100;
				units = r;
				r = r+2;
				nr -= 2;
				if(!_Strncmpci(units, 2, L"pt"))
					spec = (spec*Tkdpi)/72;
				else if(!_Strncmpci(units, 2, L"pi"))
					spec = (spec*12*Tkdpi)/72;
				else if(!_Strncmpci(units, 2, L"in"))
					spec = spec*Tkdpi;
				else if(!_Strncmpci(units, 2, L"cm"))
					spec = (spec*100*Tkdpi)/254;
				else if(!_Strncmpci(units, 2, L"mm"))
					spec = (spec*10*Tkdpi)/254;
				else if(!_Strncmpci(units, 2, L"em"))
					spec = spec*15;
				else {
					if(warn)
						fprint(2, "warning: unknown units %C%Cs\n", units[0], units[1]);
				}
			}
			if(nr &gt;= 1) {
				if(r[0] == '%')
					kind = Dpercent;
				else if(r[0] == '*')
					kind = Drelative;
			}
		}
		spec = spec/1000;
	}
	else if(nr == 1 &amp;&amp; r[0] == '*') {
		spec = 1;
		kind = Drelative;
	}
	return makedimen(kind, spec);
}

static void
setdimarray(Token* tok, int attid, Dimen** pans, int* panslen)
{
	Rune*	s;
	Dimen*	d;
	int	k;
	int	nc;
	Rune* a[SMALLBUFSIZE];
	int	an[SMALLBUFSIZE];

	if(_tokaval(tok, attid, &amp;s, 0)) {
		nc = _splitall(s, _Strlen(s), L", ", a, an, SMALLBUFSIZE);
		if(nc &gt; 0) {
			d = (Dimen*)emalloc(nc * sizeof(Dimen));
			for(k = 0; k &lt; nc; k++) {
				d[k] = parsedim(a[k], an[k]);
			}
			*pans = d;
			*panslen = nc;
			return;
		}
	}
	*pans = nil;
	*panslen = 0;
}

static Background
makebackground(Rune* imageurl, int color)
{
	Background bg;

	bg.image = imageurl;
	bg.color = color;
	return bg;
}

static Item*
newitext(Rune* s, int fnt, int fg, int voff, int ul)
{
	Itext* t;

	assert(s != nil);
	t = (Itext*)emalloc(sizeof(Itext));
	t-&gt;tag = Itexttag;
	t-&gt;s = s;
	t-&gt;fnt = fnt;
	t-&gt;fg = fg;
	t-&gt;voff = voff;
	t-&gt;ul = ul;
	return (Item*)t;
}

static Item*
newirule(int align, int size, int noshade, int color, Dimen wspec)
{
	Irule* r;

	r = (Irule*)emalloc(sizeof(Irule));
	r-&gt;tag = Iruletag;
	r-&gt;align = align;
	r-&gt;size = size;
	r-&gt;noshade = noshade;
	r-&gt;color = color;
	r-&gt;wspec = wspec;
	return (Item*)r;
}

// Map is owned elsewhere.
static Item*
newiimage(Rune* src, Rune* altrep, int align, int width, int height,
		int hspace, int vspace, int border, int ismap, Map* map)
{
	Iimage* i;
	int	state;

	state = 0;
	if(ismap)
		state = IFsmap;
	i = (Iimage*)emalloc(sizeof(Iimage));
	i-&gt;tag = Iimagetag;
	i-&gt;state = state;
	i-&gt;imsrc = src;
	i-&gt;altrep = altrep;
	i-&gt;align = align;
	i-&gt;imwidth = width;
	i-&gt;imheight = height;
	i-&gt;hspace = hspace;
	i-&gt;vspace = vspace;
	i-&gt;border = border;
	i-&gt;map = map;
	i-&gt;ctlid = -1;
	return (Item*)i;
}

static Item*
newiformfield(Formfield* ff)
{
	Iformfield* f;

	f = (Iformfield*)emalloc(sizeof(Iformfield));
	f-&gt;tag = Iformfieldtag;
	f-&gt;formfield = ff;
	return (Item*)f;
}

static Item*
newitable(Table* tab)
{
	Itable* t;

	t = (Itable*)emalloc(sizeof(Itable));
	t-&gt;tag = Itabletag;
	t-&gt;table = tab;
	return (Item*)t;
}

static Item*
newifloat(Item* it, int side)
{
	Ifloat* f;

	f = (Ifloat*)emalloc(sizeof(Ifloat));
	f-&gt;tag = Ifloattag;
	f-&gt;state = IFwrap;
	f-&gt;item = it;
	f-&gt;side = side;
	return (Item*)f;
}

static Item*
newispacer(int spkind)
{
	Ispacer* s;

	s = (Ispacer*)emalloc(sizeof(Ispacer));
	s-&gt;tag = Ispacertag;
	s-&gt;spkind = spkind;
	return (Item*)s;
}

// Free one item (caller must deal with next pointer)
static void
freeitem(Item* it)
{
	Iimage* ii;
	Genattr* ga;

	if(it == nil)
		return;

	switch(it-&gt;tag) {
	case Itexttag:
		free(((Itext*)it)-&gt;s);
		break;
	case Iimagetag:
		ii = (Iimage*)it;
		free(ii-&gt;imsrc);
		free(ii-&gt;altrep);
		break;
	case Iformfieldtag:
		freeformfield(((Iformfield*)it)-&gt;formfield);
		break;
	case Itabletag:
		freetable(((Itable*)it)-&gt;table);
		break;
	case Ifloattag:
		freeitem(((Ifloat*)it)-&gt;item);
		break;
	}
	ga = it-&gt;genattr;
	if(ga != nil) {
		free(ga-&gt;id);
		free(ga-&gt;class);
		free(ga-&gt;style);
		free(ga-&gt;title);
		freescriptevents(ga-&gt;events);
	}
	free(it);
}

// Free list of items chained through next pointer
void
freeitems(Item* ithead)
{
	Item* it;
	Item* itnext;

	it = ithead;
	while(it != nil) {
		itnext = it-&gt;next;
		freeitem(it);
		it = itnext;
	}
}

static void
freeformfield(Formfield* ff)
{
	Option* o;
	Option* onext;

	if(ff == nil)
		return;

	free(ff-&gt;name);
	free(ff-&gt;value);
	for(o = ff-&gt;options; o != nil; o = onext) {
		onext = o-&gt;next;
		free(o-&gt;value);
		free(o-&gt;display);
	}
	free(ff);
}

static void
freetable(Table* t)
{
	int i;
	Tablecell* c;
	Tablecell* cnext;

	if(t == nil)
		return;

	// We'll find all the unique cells via t-&gt;cells and next pointers.
	// (Other pointers to cells in the table are duplicates of these)
	for(c = t-&gt;cells; c != nil; c = cnext) {
		cnext = c-&gt;next;
		freeitems(c-&gt;content);
	}
	if(t-&gt;grid != nil) {
		for(i = 0; i &lt; t-&gt;nrow; i++)
			free(t-&gt;grid[i]);
		free(t-&gt;grid);
	}
	free(t-&gt;rows);
	free(t-&gt;cols);
	freeitems(t-&gt;caption);
	free(t);
}

static void
freeform(Form* f)
{
	if(f == nil)
		return;

	free(f-&gt;name);
	free(f-&gt;action);
	// Form doesn't own its fields (Iformfield items do)
	free(f);
}

static void
freeforms(Form* fhead)
{
	Form* f;
	Form* fnext;

	for(f = fhead; f != nil; f = fnext) {
		fnext = f-&gt;next;
		freeform(f);
	}
}

static void
freeanchor(Anchor* a)
{
	if(a == nil)
		return;

	free(a-&gt;name);
	free(a-&gt;href);
	free(a);
}

static void
freeanchors(Anchor* ahead)
{
	Anchor* a;
	Anchor* anext;

	for(a = ahead; a != nil; a = anext) {
		anext = a-&gt;next;
		freeanchor(a);
	}
}

static void
freedestanchor(DestAnchor* da)
{
	if(da == nil)
		return;

	free(da-&gt;name);
	free(da);
}

static void
freedestanchors(DestAnchor* dahead)
{
	DestAnchor* da;
	DestAnchor* danext;

	for(da = dahead; da != nil; da = danext) {
		danext = da-&gt;next;
		freedestanchor(da);
	}
}

static void
freearea(Area* a)
{
	if(a == nil)
		return;
	free(a-&gt;href);
	free(a-&gt;coords);
}

static void freekidinfos(Kidinfo* khead);

static void
freekidinfo(Kidinfo* k)
{
	if(k-&gt;isframeset) {
		free(k-&gt;rows);
		free(k-&gt;cols);
		freekidinfos(k-&gt;kidinfos);
	}
	else {
		free(k-&gt;src);
		free(k-&gt;name);
	}
	free(k);
}

static void
freekidinfos(Kidinfo* khead)
{
	Kidinfo* k;
	Kidinfo* knext;

	for(k = khead; k != nil; k = knext) {
		knext = k-&gt;next;
		freekidinfo(k);
	}
}

static void
freemap(Map* m)
{
	Area* a;
	Area* anext;

	if(m == nil)
		return;

	free(m-&gt;name);
	for(a = m-&gt;areas; a != nil; a = anext) {
		anext = a-&gt;next;
		freearea(a);
	}
	free(m);
}

static void
freemaps(Map* mhead)
{
	Map* m;
	Map* mnext;

	for(m = mhead; m != nil; m = mnext) {
		mnext = m-&gt;next;
		freemap(m);
	}
}

void
freedocinfo(Docinfo* d)
{
	if(d == nil)
		return;
	free(d-&gt;src);
	free(d-&gt;base);
	freeitem((Item*)d-&gt;backgrounditem);
	free(d-&gt;refresh);
	freekidinfos(d-&gt;kidinfo);
	freeanchors(d-&gt;anchors);
	freedestanchors(d-&gt;dests);
	freeforms(d-&gt;forms);
	freemaps(d-&gt;maps);
	// tables, images, and formfields are freed when
	// the items pointing at them are freed
	free(d);
}

// Currently, someone else owns all the memory
// pointed to by things in a Pstate.
static void
freepstate(Pstate* p)
{
	free(p);
}

static void
freepstatestack(Pstate* pshead)
{
	Pstate* p;
	Pstate* pnext;

	for(p = pshead; p != nil; p = pnext) {
		pnext = p-&gt;next;
		free(p);
	}
}

static int
Iconv(Fmt *f)
{
	Item*	it;
	Itext*	t;
	Irule*	r;
	Iimage*	i;
	Ifloat*	fl;
	int	state;
	Formfield*	ff;
	Rune*	ty;
	Tablecell*	c;
	Table*	tab;
	char*	p;
	int	cl;
	int	hang;
	int	indent;
	int	bi;
	int	nbuf;
	char	buf[BIGBUFSIZE];

	it = va_arg(f-&gt;args, Item*);
	bi = 0;
	nbuf = sizeof(buf);
	state = it-&gt;state;
	nbuf = nbuf-1;
	if(state&amp;IFbrk) {
		cl = state&amp;(IFcleft|IFcright);
		p = "";
		if(cl) {
			if(cl == (IFcleft|IFcright))
				p = " both";
			else if(cl == IFcleft)
				p = " left";
			else
				p = " right";
		}
		bi = snprint(buf, nbuf, "brk(%d%s)", (state&amp;IFbrksp)? 1 : 0, p);
	}
	if(state&amp;IFnobrk)
		bi += snprint(buf+bi, nbuf-bi, " nobrk");
	if(!(state&amp;IFwrap))
		bi += snprint(buf+bi, nbuf-bi, " nowrap");
	if(state&amp;IFrjust)
		bi += snprint(buf+bi, nbuf-bi, " rjust");
	if(state&amp;IFcjust)
		bi += snprint(buf+bi, nbuf-bi, " cjust");
	if(state&amp;IFsmap)
		bi += snprint(buf+bi, nbuf-bi, " smap");
	indent = (state&amp;IFindentmask) &gt;&gt; IFindentshift;
	if(indent &gt; 0)
		bi += snprint(buf+bi, nbuf-bi, " indent=%d", indent);
	hang = state&amp;IFhangmask;
	if(hang &gt; 0)
		bi += snprint(buf+bi, nbuf-bi, " hang=%d", hang);

	switch(it-&gt;tag) {
	case Itexttag:
		t = (Itext*)it;
		bi += snprint(buf+bi, nbuf-bi, " Text '%S', fnt=%d, fg=%x", t-&gt;s, t-&gt;fnt, t-&gt;fg);
		break;

	case Iruletag:
		r = (Irule*)it;
		bi += snprint(buf+bi, nbuf-bi, "Rule size=%d, al=%S, wspec=", r-&gt;size, stringalign(r-&gt;align));
		bi += dimprint(buf+bi, nbuf-bi, r-&gt;wspec);
		break;

	case Iimagetag:
		i = (Iimage*)it;
		bi += snprint(buf+bi, nbuf-bi,
			"Image src=%S, alt=%S, al=%S, w=%d, h=%d hsp=%d, vsp=%d, bd=%d, map=%S",
			i-&gt;imsrc, i-&gt;altrep? i-&gt;altrep : L"", stringalign(i-&gt;align), i-&gt;imwidth, i-&gt;imheight,
			i-&gt;hspace, i-&gt;vspace, i-&gt;border, i-&gt;map? i-&gt;map-&gt;name : L"");
		break;

	case Iformfieldtag:
		ff = ((Iformfield*)it)-&gt;formfield;
		if(ff-&gt;ftype == Ftextarea)
			ty = L"textarea";
		else if(ff-&gt;ftype == Fselect)
			ty = L"select";
		else {
			ty = _revlookup(input_tab, NINPUTTAB, ff-&gt;ftype);
			if(ty == nil)
				ty = L"none";
		}
		bi += snprint(buf+bi, nbuf-bi, "Formfield %S, fieldid=%d, formid=%d, name=%S, value=%S",
			ty, ff-&gt;fieldid, ff-&gt;form-&gt;formid, ff-&gt;name? ff-&gt;name : L"",
			ff-&gt;value? ff-&gt;value : L"");
		break;

	case Itabletag:
		tab = ((Itable*)it)-&gt;table;
		bi += snprint(buf+bi, nbuf-bi, "Table tableid=%d, width=", tab-&gt;tableid);
		bi += dimprint(buf+bi, nbuf-bi, tab-&gt;width);
		bi += snprint(buf+bi, nbuf-bi, ", nrow=%d, ncol=%d, ncell=%d, totw=%d, toth=%d\n",
			tab-&gt;nrow, tab-&gt;ncol, tab-&gt;ncell, tab-&gt;totw, tab-&gt;toth);
		for(c = tab-&gt;cells; c != nil; c = c-&gt;next)
			bi += snprint(buf+bi, nbuf-bi, "Cell %d.%d, at (%d,%d) ",
					tab-&gt;tableid, c-&gt;cellid, c-&gt;row, c-&gt;col);
		bi += snprint(buf+bi, nbuf-bi, "End of Table %d", tab-&gt;tableid);
		break;

	case Ifloattag:
		fl = (Ifloat*)it;
		bi += snprint(buf+bi, nbuf-bi, "Float, x=%d y=%d, side=%S, it=%I",
			fl-&gt;x, fl-&gt;y, stringalign(fl-&gt;side), fl-&gt;item);
		bi += snprint(buf+bi, nbuf-bi, "\n\t");
		break;

	case Ispacertag:
		p = "";
		switch(((Ispacer*)it)-&gt;spkind) {
		case ISPnull:
			p = "null";
			break;
		case ISPvline:
			p = "vline";
			break;
		case ISPhspace:
			p = "hspace";
			break;
		}
		bi += snprint(buf+bi, nbuf-bi, "Spacer %s ", p);
		break;
	}
	bi += snprint(buf+bi, nbuf-bi, " w=%d, h=%d, a=%d, anchor=%d\n",
			it-&gt;width, it-&gt;height, it-&gt;ascent, it-&gt;anchorid);
	buf[bi] = 0;
	return fmtstrcpy(f, buf);
}

// String version of alignment 'a'
static Rune*
stringalign(int a)
{
	Rune*	s;

	s = _revlookup(align_tab, NALIGNTAB, a);
	if(s == nil)
		s = L"none";
	return s;
}

// Put at most nbuf chars of representation of d into buf,
// and return number of characters put
static int
dimprint(char* buf, int nbuf, Dimen d)
{
	int	n;
	int	k;

	n = 0;
	n += snprint(buf, nbuf, "%d", dimenspec(d));
	k = dimenkind(d);
	if(k == Dpercent)
		buf[n++] = '%';
	if(k == Drelative)
		buf[n++] = '*';
	return n;
}

void
printitems(Item* items, char* msg)
{
	Item*	il;

	fprint(2, "%s\n", msg);
	il = items;
	while(il != nil) {
		fprint(2, "%I", il);
		il = il-&gt;next;
	}
}

static Genattr*
newgenattr(Rune* id, Rune* class, Rune* style, Rune* title, SEvent* events)
{
	Genattr* g;

	g = (Genattr*)emalloc(sizeof(Genattr));
	g-&gt;id = id;
	g-&gt;class = class;
	g-&gt;style = style;
	g-&gt;title = title;
	g-&gt;events = events;
	return g;
}

static Formfield*
newformfield(int ftype, int fieldid, Form* form, Rune* name,
		Rune* value, int size, int maxlength, Formfield* link)
{
	Formfield* ff;

	ff = (Formfield*)emalloc(sizeof(Formfield));
	ff-&gt;ftype = ftype;
	ff-&gt;fieldid = fieldid;
	ff-&gt;form = form;
	ff-&gt;name = name;
	ff-&gt;value = value;
	ff-&gt;size = size;
	ff-&gt;maxlength = maxlength;
	ff-&gt;ctlid = -1;
	ff-&gt;next = link;
	return ff;
}

// Transfers ownership of value and display to Option.
static Option*
newoption(int selected, Rune* value, Rune* display, Option* link)
{
	Option *o;

	o = (Option*)emalloc(sizeof(Option));
	o-&gt;selected = selected;
	o-&gt;value = value;
	o-&gt;display = display;
	o-&gt;next = link;
	return o;
}

static Form*
newform(int formid, Rune* name, Rune* action, int target, int method, Form* link)
{
	Form* f;

	f = (Form*)emalloc(sizeof(Form));
	f-&gt;formid = formid;
	f-&gt;name = name;
	f-&gt;action = action;
	f-&gt;target = target;
	f-&gt;method = method;
	f-&gt;nfields = 0;
	f-&gt;fields = nil;
	f-&gt;next = link;
	return f;
}

static Table*
newtable(int tableid, Align align, Dimen width, int border,
	int cellspacing, int cellpadding, Background bg, Token* tok, Table* link)
{
	Table* t;

	t = (Table*)emalloc(sizeof(Table));
	t-&gt;tableid = tableid;
	t-&gt;align = align;
	t-&gt;width = width;
	t-&gt;border = border;
	t-&gt;cellspacing = cellspacing;
	t-&gt;cellpadding = cellpadding;
	t-&gt;background = bg;
	t-&gt;caption_place = ALbottom;
	t-&gt;caption_lay = nil;
	t-&gt;tabletok = tok;
	t-&gt;tabletok = nil;
	t-&gt;next = link;
	return t;
}

static Tablerow*
newtablerow(Align align, Background bg, int flags, Tablerow* link)
{
	Tablerow* tr;

	tr = (Tablerow*)emalloc(sizeof(Tablerow));
	tr-&gt;align = align;
	tr-&gt;background = bg;
	tr-&gt;flags = flags;
	tr-&gt;next = link;
	return tr;
}

static Tablecell*
newtablecell(int cellid, int rowspan, int colspan, Align align, Dimen wspec, int hspec,
		Background bg, int flags, Tablecell* link)
{
	Tablecell* c;

	c = (Tablecell*)emalloc(sizeof(Tablecell));
	c-&gt;cellid = cellid;
	c-&gt;lay = nil;
	c-&gt;rowspan = rowspan;
	c-&gt;colspan = colspan;
	c-&gt;align = align;
	c-&gt;flags = flags;
	c-&gt;wspec = wspec;
	c-&gt;hspec = hspec;
	c-&gt;background = bg;
	c-&gt;next = link;
	return c;
}

static Anchor*
newanchor(int index, Rune* name, Rune* href, int target, Anchor* link)
{
	Anchor* a;

	a = (Anchor*)emalloc(sizeof(Anchor));
	a-&gt;index = index;
	a-&gt;name = name;
	a-&gt;href = href;
	a-&gt;target = target;
	a-&gt;next = link;
	return a;
}

static DestAnchor*
newdestanchor(int index, Rune* name, Item* item, DestAnchor* link)
{
	DestAnchor* d;

	d = (DestAnchor*)emalloc(sizeof(DestAnchor));
	d-&gt;index = index;
	d-&gt;name = name;
	d-&gt;item = item;
	d-&gt;next = link;
	return d;
}

static SEvent*
newscriptevent(int type, Rune* script, SEvent* link)
{
	SEvent* ans;

	ans = (SEvent*)emalloc(sizeof(SEvent));
	ans-&gt;type = type;
	ans-&gt;script = script;
	ans-&gt;next = link;
	return ans;
}

static void
freescriptevents(SEvent* ehead)
{
	SEvent* e;
	SEvent* nexte;

	e = ehead;
	while(e != nil) {
		nexte = e-&gt;next;
		free(e-&gt;script);
		free(e);
		e = nexte;
	}
}

static Dimen
makedimen(int kind, int spec)
{
	Dimen d;

	if(spec&amp;Dkindmask) {
		if(warn)
			fprint(2, "warning: dimension spec too big: %d\n", spec);
		spec = 0;
	}
	d.kindspec = kind|spec;
	return d;
}

int
dimenkind(Dimen d)
{
	return (d.kindspec&amp;Dkindmask);
}

int
dimenspec(Dimen d)
{
	return (d.kindspec&amp;Dspecmask);
}

static Kidinfo*
newkidinfo(int isframeset, Kidinfo* link)
{
	Kidinfo*	ki;

	ki = (Kidinfo*)emalloc(sizeof(Kidinfo));
	ki-&gt;isframeset = isframeset;
	if(!isframeset) {
		ki-&gt;flags = FRhscrollauto|FRvscrollauto;
		ki-&gt;marginw = FRKIDMARGIN;
		ki-&gt;marginh = FRKIDMARGIN;
		ki-&gt;framebd = 1;
	}
	ki-&gt;next = link;
	return ki;
}

static Docinfo*
newdocinfo(void)
{
	Docinfo*	d;

	d = (Docinfo*)emalloc(sizeof(Docinfo));
	resetdocinfo(d);
	return d;
}

static void
resetdocinfo(Docinfo* d)
{
	memset(d, 0, sizeof(Docinfo));
	d-&gt;background = makebackground(nil, White);
	d-&gt;text = Black;
	d-&gt;link = Blue;
	d-&gt;vlink = Blue;
	d-&gt;alink = Blue;
	d-&gt;target = FTself;
	d-&gt;chset = ISO_8859_1;
	d-&gt;scripttype = TextJavascript;
	d-&gt;frameid = -1;
}

// Use targetmap array to keep track of name &lt;-&gt; targetid mapping.
// Use real malloc(), and never free
static void
targetmapinit(void)
{
	int l;

	targetmapsize = 10;
	l = targetmapsize*sizeof *targetmap;
	targetmap = emalloc(l);
	memset(targetmap, 0, l);
	targetmap[0].key = _Strdup(L"_top");
	targetmap[0].val = FTtop;
	targetmap[1].key = _Strdup(L"_self");
	targetmap[1].val = FTself;
	targetmap[2].key = _Strdup(L"_parent");
	targetmap[2].val = FTparent;
	targetmap[3].key = _Strdup(L"_blank");
	targetmap[3].val = FTblank;
	ntargets = 4;
}

int
targetid(Rune* s)
{
	int i;
	int n;

	n = _Strlen(s);
	if(n == 0)
		return FTself;
	for(i = 0; i &lt; ntargets; i++)
		if(_Strcmp(s, targetmap[i].key) == 0)
			return targetmap[i].val;
	if(i == targetmapsize) {
		targetmapsize += 10;
		targetmap = erealloc(targetmap, targetmapsize*sizeof(StringInt));
	}
	targetmap[i].key = _Strdup(s);
	targetmap[i].val = i;
	ntargets++;
	return i;
}

Rune*
targetname(int targid)
{
	int i;

	for(i = 0; i &lt; ntargets; i++)
		if(targetmap[i].val == targid)
			return targetmap[i].key;
	return L"?";
}

// Convert HTML color spec to RGB value, returning dflt if can't.
// Argument is supposed to be a valid HTML color, or "".
// Return the RGB value of the color, using dflt if s
// is nil or an invalid color.
static int
color(Rune* s, int dflt)
{
	int v;
	Rune* rest;

	if(s == nil)
		return dflt;
	if(_lookup(color_tab, NCOLORS, s, _Strlen(s), &amp;v))
		return v;
	if(s[0] == '#')
		s++;
	v = _Strtol(s, &amp;rest, 16);
	if(*rest == 0)
		return v;
	return dflt;
}

// Debugging

#define HUGEPIX 10000

// A "shallow" validitem, that doesn't follow next links
// or descend into tables.
static int
validitem(Item* i)
{
	int ok;
	Itext* ti;
	Irule* ri;
	Iimage* ii;
	Ifloat* fi;
	int a;

	ok = (i-&gt;tag &gt;= Itexttag &amp;&amp; i-&gt;tag &lt;= Ispacertag) &amp;&amp;
		(i-&gt;next == nil || validptr(i-&gt;next)) &amp;&amp;
		(i-&gt;width &gt;= 0 &amp;&amp; i-&gt;width &lt; HUGEPIX) &amp;&amp;
		(i-&gt;height &gt;= 0 &amp;&amp; i-&gt;height &lt; HUGEPIX) &amp;&amp;
		(i-&gt;ascent &gt; -HUGEPIX &amp;&amp; i-&gt;ascent &lt; HUGEPIX) &amp;&amp;
		(i-&gt;anchorid &gt;= 0) &amp;&amp;
		(i-&gt;genattr == nil || validptr(i-&gt;genattr));
	// also, could check state for ridiculous combinations
	// also, could check anchorid for within-doc-range
	if(ok)
		switch(i-&gt;tag) {
		case Itexttag:
			ti = (Itext*)i;
			ok = validStr(ti-&gt;s) &amp;&amp;
				(ti-&gt;fnt &gt;= 0 &amp;&amp; ti-&gt;fnt &lt; NumStyle*NumSize) &amp;&amp;
				(ti-&gt;ul == ULnone || ti-&gt;ul == ULunder || ti-&gt;ul == ULmid);
			break;
		case Iruletag:
			ri = (Irule*)i;
			ok = (validvalign(ri-&gt;align) || validhalign(ri-&gt;align)) &amp;&amp;
				(ri-&gt;size &gt;=0 &amp;&amp; ri-&gt;size &lt; HUGEPIX);
			break;
		case Iimagetag:
			ii = (Iimage*)i;
			ok = (ii-&gt;imsrc == nil || validptr(ii-&gt;imsrc)) &amp;&amp;
				(ii-&gt;width &gt;= 0 &amp;&amp; ii-&gt;width &lt; HUGEPIX) &amp;&amp;
				(ii-&gt;height &gt;= 0 &amp;&amp; ii-&gt;height &lt; HUGEPIX) &amp;&amp;
				(ii-&gt;imwidth &gt;= 0 &amp;&amp; ii-&gt;imwidth &lt; HUGEPIX) &amp;&amp;
				(ii-&gt;imheight &gt;= 0 &amp;&amp; ii-&gt;imheight &lt; HUGEPIX) &amp;&amp;
				(ii-&gt;altrep == nil || validStr(ii-&gt;altrep)) &amp;&amp;
				(ii-&gt;map == nil || validptr(ii-&gt;map)) &amp;&amp;
				(validvalign(ii-&gt;align) || validhalign(ii-&gt;align)) &amp;&amp;
				(ii-&gt;nextimage == nil || validptr(ii-&gt;nextimage));
			break;
		case Iformfieldtag:
			ok = validformfield(((Iformfield*)i)-&gt;formfield);
			break;
		case Itabletag:
			ok = validptr((Itable*)i);
			break;
		case Ifloattag:
			fi = (Ifloat*)i;
			ok = (fi-&gt;side == ALleft || fi-&gt;side == ALright) &amp;&amp;
				validitem(fi-&gt;item) &amp;&amp;
				(fi-&gt;item-&gt;tag == Iimagetag || fi-&gt;item-&gt;tag == Itabletag);
			break;
		case Ispacertag:
			a = ((Ispacer*)i)-&gt;spkind;
			ok = a==ISPnull || a==ISPvline || a==ISPhspace || a==ISPgeneral;
			break;
		default:
			ok = 0;
		}
	return ok;
}

// "deep" validation, that checks whole list of items,
// and descends into tables and floated tables.
// nil is ok for argument.
int
validitems(Item* i)
{
	int ok;
	Item* ii;

	ok = 1;
	while(i != nil &amp;&amp; ok) {
		ok = validitem(i);
		if(ok) {
			if(i-&gt;tag == Itabletag) {
				ok = validtable(((Itable*)i)-&gt;table);
			}
			else if(i-&gt;tag == Ifloattag) {
				ii = ((Ifloat*)i)-&gt;item;
				if(ii-&gt;tag == Itabletag)
					ok = validtable(((Itable*)ii)-&gt;table);
			}
		}
		if(!ok) {
			fprint(2, "invalid item: %I\n", i);
		}
		i = i-&gt;next;
	}
	return ok;
}

static int
validformfield(Formfield* f)
{
	int ok;

	ok = (f-&gt;next == nil || validptr(f-&gt;next)) &amp;&amp;
		(f-&gt;ftype &gt;= 0 &amp;&amp; f-&gt;ftype &lt;= Ftextarea) &amp;&amp;
		f-&gt;fieldid &gt;= 0 &amp;&amp;
		(f-&gt;form == nil || validptr(f-&gt;form)) &amp;&amp;
		(f-&gt;name == nil || validStr(f-&gt;name)) &amp;&amp;
		(f-&gt;value == nil || validStr(f-&gt;value)) &amp;&amp;
		(f-&gt;options == nil || validptr(f-&gt;options)) &amp;&amp;
		(f-&gt;image == nil || validitem(f-&gt;image)) &amp;&amp;
		(f-&gt;events == nil || validptr(f-&gt;events));
	// when all built, should have f-&gt;fieldid &lt; f-&gt;form-&gt;nfields,
	// but this may be called during build...
	return ok;
}

// "deep" validation -- checks cell contents too
static int
validtable(Table* t)
{
	int ok;
	int i, j;
	Tablecell* c;

	ok = (t-&gt;next == nil || validptr(t-&gt;next)) &amp;&amp;
		t-&gt;nrow &gt;= 0 &amp;&amp;
		t-&gt;ncol &gt;= 0 &amp;&amp;
		t-&gt;ncell &gt;= 0 &amp;&amp;
		validalign(t-&gt;align) &amp;&amp;
		validdimen(t-&gt;width) &amp;&amp;
		(t-&gt;border &gt;= 0 &amp;&amp; t-&gt;border &lt; HUGEPIX) &amp;&amp;
		(t-&gt;cellspacing &gt;= 0 &amp;&amp; t-&gt;cellspacing &lt; HUGEPIX) &amp;&amp;
		(t-&gt;cellpadding &gt;= 0 &amp;&amp; t-&gt;cellpadding &lt; HUGEPIX) &amp;&amp;
		validitems(t-&gt;caption) &amp;&amp;
		(t-&gt;caption_place == ALtop || t-&gt;caption_place == ALbottom) &amp;&amp;
		(t-&gt;totw &gt;= 0 &amp;&amp; t-&gt;totw &lt; HUGEPIX) &amp;&amp;
		(t-&gt;toth &gt;= 0 &amp;&amp; t-&gt;toth &lt; HUGEPIX) &amp;&amp;
		(t-&gt;tabletok == nil || validptr(t-&gt;tabletok));
	// during parsing, t-&gt;rows has list;
	// only when parsing is done is t-&gt;nrow set &gt; 0
	if(ok &amp;&amp; t-&gt;nrow &gt; 0 &amp;&amp; t-&gt;ncol &gt; 0) {
		// table is "finished"
		for(i = 0; i &lt; t-&gt;nrow &amp;&amp; ok; i++) 
			ok = validtablerow(t-&gt;rows+i);
		for(j = 0; j &lt; t-&gt;ncol &amp;&amp; ok; j++)
			ok = validtablecol(t-&gt;cols+j);
		for(c = t-&gt;cells; c != nil &amp;&amp; ok; c = c-&gt;next)
			ok = validtablecell(c);
		for(i = 0; i &lt; t-&gt;nrow &amp;&amp; ok; i++)
			for(j = 0; j &lt; t-&gt;ncol &amp;&amp; ok; j++)
				ok = validptr(t-&gt;grid[i][j]);
	}
	return ok;
}

static int
validvalign(int a)
{
	return a == ALnone || a == ALmiddle || a == ALbottom || a == ALtop || a == ALbaseline;
}

static int
validhalign(int a)
{
	return a == ALnone || a == ALleft || a == ALcenter || a == ALright ||
			a == ALjustify || a == ALchar;
}

static int
validalign(Align a)
{
	return validhalign(a.halign) &amp;&amp; validvalign(a.valign);
}

static int
validdimen(Dimen d)
{
	int ok;
	int s;

	ok = 0;
	s = d.kindspec&amp;Dspecmask;
	switch(d.kindspec&amp;Dkindmask) {
	case Dnone:
		ok = s==0;
		break;
	case Dpixels:
		ok = s &lt; HUGEPIX;
		break;
	case Dpercent:
	case Drelative:
		ok = 1;
		break;
	}
	return ok;
}

static int
validtablerow(Tablerow* r)
{
	return (r-&gt;cells == nil || validptr(r-&gt;cells)) &amp;&amp;
		(r-&gt;height &gt;= 0 &amp;&amp; r-&gt;height &lt; HUGEPIX) &amp;&amp;
		(r-&gt;ascent &gt; -HUGEPIX &amp;&amp; r-&gt;ascent &lt; HUGEPIX) &amp;&amp;
		validalign(r-&gt;align);
}

static int
validtablecol(Tablecol* c)
{
	return c-&gt;width &gt;= 0 &amp;&amp; c-&gt;width &lt; HUGEPIX
		&amp;&amp; validalign(c-&gt;align);
}

static int
validtablecell(Tablecell* c)
{
	int ok;

	ok = (c-&gt;next == nil || validptr(c-&gt;next)) &amp;&amp;
		(c-&gt;nextinrow == nil || validptr(c-&gt;nextinrow)) &amp;&amp;
		(c-&gt;content == nil || validptr(c-&gt;content)) &amp;&amp;
		(c-&gt;lay == nil || validptr(c-&gt;lay)) &amp;&amp;
		c-&gt;rowspan &gt;= 0 &amp;&amp;
		c-&gt;colspan &gt;= 0 &amp;&amp;
		validalign(c-&gt;align) &amp;&amp;
		validdimen(c-&gt;wspec) &amp;&amp;
		c-&gt;row &gt;= 0 &amp;&amp;
		c-&gt;col &gt;= 0;
	if(ok) {
		if(c-&gt;content != nil)
			ok = validitems(c-&gt;content);
	}
	return ok;
}

static int
validptr(void* p)
{
	// TODO: a better job of this.
	// For now, just dereference, which cause a bomb
	// if not valid
	static char c;

	c = *((char*)p);
	return 1;
}

static int
validStr(Rune* s)
{
	return s != nil &amp;&amp; validptr(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

