<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libip/readipifc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libip/readipifc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;ip.h&gt;

static Ipifc**
_readoldipifc(char *buf, Ipifc **l, int index)
{
	char *f[200];
	int i, n;
	Ipifc *ifc;
	Iplifc *lifc, **ll;

	/* allocate new interface */
	*l = ifc = mallocz(sizeof(Ipifc), 1);
	if(ifc == nil)
		return l;
	l = &amp;ifc-&gt;next;
	ifc-&gt;index = index;

	n = tokenize(buf, f, nelem(f));
	if(n &lt; 2)
		return l;

	strncpy(ifc-&gt;dev, f[0], sizeof ifc-&gt;dev);
	ifc-&gt;dev[sizeof(ifc-&gt;dev) - 1] = 0;
	ifc-&gt;mtu = strtoul(f[1], nil, 10);

	ll = &amp;ifc-&gt;lifc;
	for(i = 2; n-i &gt;= 7; i += 7){
		/* allocate new local address */
		*ll = lifc = mallocz(sizeof(Iplifc), 1);
		ll = &amp;lifc-&gt;next;

		parseip(lifc-&gt;ip, f[i]);
		parseipmask(lifc-&gt;mask, f[i+1]);
		parseip(lifc-&gt;net, f[i+2]);
		ifc-&gt;pktin = strtoul(f[i+3], nil, 10);
		ifc-&gt;pktout = strtoul(f[i+4], nil, 10);
		ifc-&gt;errin = strtoul(f[i+5], nil, 10);
		ifc-&gt;errout = strtoul(f[i+6], nil, 10);
	}
	return l;
}

static char*
findfield(char *name, char **f, int n)
{
	int i;

	for(i = 0; i &lt; n-1; i++)
		if(strcmp(f[i], name) == 0)
			return f[i+1];
	return "";
}

static Ipifc**
_readipifc(char *file, Ipifc **l, int index)
{
	int i, n, fd, lines;
	char buf[4*1024];
	char *line[32];
	char *f[64];
	Ipifc *ifc, **l0;
	Iplifc *lifc, **ll;

	/* read the file */
	fd = open(file, OREAD);
	if(fd &lt; 0)
		return l;
	n = 0;
	while((i = read(fd, buf+n, sizeof(buf)-1-n)) &gt; 0 &amp;&amp; n &lt; sizeof(buf) - 1)
		n += i;
	buf[n] = 0;
	close(fd);

	if(strncmp(buf, "device", 6) != 0)
		return _readoldipifc(buf, l, index);
	/* ignore ifcs with no associated device */
	if(strncmp(buf+6, "  ", 2) == 0)
		return l;
	/* allocate new interface */
	*l = ifc = mallocz(sizeof(Ipifc), 1);
	if(ifc == nil)
		return l;
	l0 = l;
	l = &amp;ifc-&gt;next;
	ifc-&gt;index = index;

	lines = getfields(buf, line, nelem(line), 1, "\n");

	/* pick off device specific info(first line) */
	n = tokenize(line[0], f, nelem(f));
	if(n%2 != 0)
		goto lose;
	strncpy(ifc-&gt;dev, findfield("device", f, n), sizeof(ifc-&gt;dev));
	ifc-&gt;dev[sizeof(ifc-&gt;dev)-1] = 0;
	if(ifc-&gt;dev[0] == 0){
lose:
		free(ifc);
		*l0 = nil;
		return l;
	}
	ifc-&gt;mtu = strtoul(findfield("maxtu", f, n), nil, 10);
	ifc-&gt;sendra6 = atoi(findfield("sendra", f, n));
	ifc-&gt;recvra6 = atoi(findfield("recvra", f, n));
	ifc-&gt;rp.mflag = atoi(findfield("mflag", f, n));
	ifc-&gt;rp.oflag = atoi(findfield("oflag", f, n));
	ifc-&gt;rp.maxraint = atoi(findfield("maxraint", f, n));
	ifc-&gt;rp.minraint = atoi(findfield("minraint", f, n));
	ifc-&gt;rp.linkmtu = atoi(findfield("linkmtu", f, n));
	ifc-&gt;rp.reachtime = atoi(findfield("reachtime", f, n));
	ifc-&gt;rp.rxmitra = atoi(findfield("rxmitra", f, n));
	ifc-&gt;rp.ttl = atoi(findfield("ttl", f, n));
	ifc-&gt;rp.routerlt = atoi(findfield("routerlt", f, n));
	ifc-&gt;pktin = strtoul(findfield("pktin", f, n), nil, 10);
	ifc-&gt;pktout = strtoul(findfield("pktout", f, n), nil, 10);
	ifc-&gt;errin = strtoul(findfield("errin", f, n), nil, 10);
	ifc-&gt;errout = strtoul(findfield("errout", f, n), nil, 10);

	/* now read the addresses */
	ll = &amp;ifc-&gt;lifc;
	for(i = 1; i &lt; lines; i++){
		n = tokenize(line[i], f, nelem(f));
		if(n &lt; 5)
			break;

		/* allocate new local address */
		*ll = lifc = mallocz(sizeof(Iplifc), 1);
		ll = &amp;lifc-&gt;next;

		parseip(lifc-&gt;ip, f[0]);
		parseipmask(lifc-&gt;mask, f[1]);
		parseip(lifc-&gt;net, f[2]);

		lifc-&gt;validlt = strtoul(f[3], nil, 10);
		lifc-&gt;preflt = strtoul(f[4], nil, 10);
	}

	return l;
}

static void
_freeifc(Ipifc *ifc)
{
	Ipifc *next;
	Iplifc *lnext, *lifc;

	if(ifc == nil)
		return;
	for(; ifc; ifc = next){
		next = ifc-&gt;next;
		for(lifc = ifc-&gt;lifc; lifc; lifc = lnext){
			lnext = lifc-&gt;next;
			free(lifc);
		}
		free(ifc);
	}
}

Ipifc*
readipifc(char *net, Ipifc *ifc, int index)
{
	int fd, i, n;
	Dir *dir;
	char directory[128];
	char buf[128];
	Ipifc **l;

	_freeifc(ifc);

	l = &amp;ifc;
	ifc = nil;

	if(net == 0)
		net = "/net";
	snprint(directory, sizeof(directory), "%s/ipifc", net);

	if(index &gt;= 0){
		snprint(buf, sizeof(buf), "%s/%d/status", directory, index);
		_readipifc(buf, l, index);
	} else {
		fd = open(directory, OREAD);
		if(fd &lt; 0)
			return nil;
		n = dirreadall(fd, &amp;dir);
		close(fd);

		for(i = 0; i &lt; n; i++){
			if(strcmp(dir[i].name, "clone") == 0)
				continue;
			if(strcmp(dir[i].name, "stats") == 0)
				continue;
			snprint(buf, sizeof(buf), "%s/%s/status", directory, dir[i].name);
			l = _readipifc(buf, l, atoi(dir[i].name));
		}
		free(dir);
	}

	return ifc;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

