<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/6obj.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/6obj.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * 6obj.c - identify and parse an amd64 object file
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#include "6c/6.out.h"
#include "obj.h"

typedef struct Addr	Addr;
struct Addr
{
	char	sym;
	char	flags;
};
static	Addr	addr(Biobuf*);
static	char	type2char(int);
static	void	skip(Biobuf*, int);

int
_is6(char *t)
{
	uchar *s = (uchar*)t;

	return  s[0] == (ANAME&amp;0xff)			/* aslo = ANAME */
		&amp;&amp; s[1] == ((ANAME&gt;&gt;8)&amp;0xff)
		&amp;&amp; s[2] == D_FILE			/* type */
		&amp;&amp; s[3] == 1				/* sym */
		&amp;&amp; s[4] == '&lt;';				/* name of file */
}

int
_read6(Biobuf *bp, Prog* p)
{
	int as, n, c;
	Addr a;

	as = Bgetc(bp);		/* as(low) */
	if(as &lt; 0)
		return 0;
	c = Bgetc(bp);		/* as(high) */
	if(c &lt; 0)
		return 0;
	as |= ((c &amp; 0xff) &lt;&lt; 8);
	p-&gt;kind = aNone;
	p-&gt;sig = 0;
	if(as == ANAME || as == ASIGNAME){
		if(as == ASIGNAME){
			Bread(bp, &amp;p-&gt;sig, 4);
			p-&gt;sig = leswal(p-&gt;sig);
		}
		p-&gt;kind = aName;
		p-&gt;type = type2char(Bgetc(bp));		/* type */
		p-&gt;sym = Bgetc(bp);			/* sym */
		n = 0;
		for(;;) {
			as = Bgetc(bp);
			if(as &lt; 0)
				return 0;
			n++;
			if(as == 0)
				break;
		}
		p-&gt;id = malloc(n);
		if(p-&gt;id == 0)
			return 0;
		Bseek(bp, -n, 1);
		if(Bread(bp, p-&gt;id, n) != n)
			return 0;
		return 1;
	}
	if(as == ATEXT)
		p-&gt;kind = aText;
	if(as == AGLOBL)
		p-&gt;kind = aData;
	skip(bp, 4);		/* lineno(4) */
	a = addr(bp);
	addr(bp);
	if(!(a.flags &amp; T_SYM))
		p-&gt;kind = aNone;
	p-&gt;sym = a.sym;
	return 1;
}

static Addr
addr(Biobuf *bp)
{
	Addr a;
	int t;
	long l;
	vlong off;

	off = 0;
	a.sym = -1;
	a.flags = Bgetc(bp);			/* flags */
	if(a.flags &amp; T_INDEX)
		skip(bp, 2);
	if(a.flags &amp; T_OFFSET){
		l = Bgetc(bp);
		l |= Bgetc(bp) &lt;&lt; 8;
		l |= Bgetc(bp) &lt;&lt; 16;
		l |= Bgetc(bp) &lt;&lt; 24;
		off = l;
		if(a.flags &amp; T_64){
			l = Bgetc(bp);
			l |= Bgetc(bp) &lt;&lt; 8;
			l |= Bgetc(bp) &lt;&lt; 16;
			l |= Bgetc(bp) &lt;&lt; 24;
			off = ((vlong)l &lt;&lt; 32) | (off &amp; 0xFFFFFFFF);
		}
		if(off &lt; 0)
			off = -off;
	}
	if(a.flags &amp; T_SYM)
		a.sym = Bgetc(bp);
	if(a.flags &amp; T_FCONST)
		skip(bp, 8);
	else
	if(a.flags &amp; T_SCONST)
		skip(bp, NSNAME);
	if(a.flags &amp; T_TYPE) {
		t = Bgetc(bp);
		if(a.sym &gt; 0 &amp;&amp; (t==D_PARAM || t==D_AUTO))
			_offset(a.sym, off);
	}
	return a;
}

static char
type2char(int t)
{
	switch(t){
	case D_EXTERN:		return 'U';
	case D_STATIC:		return 'b';
	case D_AUTO:		return 'a';
	case D_PARAM:		return 'p';
	default:		return UNKNOWN;
	}
}

static void
skip(Biobuf *bp, int n)
{
	while (n-- &gt; 0)
		Bgetc(bp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

