<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/access.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/access.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * functions to read and write an executable or file image
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

static	int	mget(Map*, uvlong, void*, int);
static	int	mput(Map*, uvlong, void*, int);
static	struct	segment*	reloc(Map*, uvlong, vlong*);

/*
 * routines to get/put various types
 */
int
geta(Map *map, uvlong addr, uvlong *x)
{
	ulong l;
	uvlong vl;

	if (mach-&gt;szaddr == 8){
		if (get8(map, addr, &amp;vl) &lt; 0)
			return -1;
		*x = vl;
		return 1;
	}

	if (get4(map, addr, &amp;l) &lt; 0)
		return -1;
	*x = l;

	return 1;
}

int
get8(Map *map, uvlong addr, uvlong *x)
{
	if (!map) {
		werrstr("get8: invalid map");
		return -1;
	}

	if (map-&gt;nsegs == 1 &amp;&amp; map-&gt;seg[0].fd &lt; 0) {
		*x = addr;
		return 1;
	}
	if (mget(map, addr, x, 8) &lt; 0)
		return -1;
	*x = machdata-&gt;swav(*x);
	return 1;
}

int
get4(Map *map, uvlong addr, ulong *x)
{
	if (!map) {
		werrstr("get4: invalid map");
		return -1;
	}

	if (map-&gt;nsegs == 1 &amp;&amp; map-&gt;seg[0].fd &lt; 0) {
		*x = addr;
		return 1;
	}
	if (mget(map, addr, x, 4) &lt; 0)
		return -1;
	*x = machdata-&gt;swal(*x);
	return 1;
}

int
get2(Map *map, uvlong addr, ushort *x)
{
	if (!map) {
		werrstr("get2: invalid map");
		return -1;
	}

	if (map-&gt;nsegs == 1 &amp;&amp; map-&gt;seg[0].fd &lt; 0) {
		*x = addr;
		return 1;
	}
	if (mget(map, addr, x, 2) &lt; 0)
		return -1;
	*x = machdata-&gt;swab(*x);
	return 1;
}

int
get1(Map *map, uvlong addr, uchar *x, int size)
{
	uchar *cp;

	if (!map) {
		werrstr("get1: invalid map");
		return -1;
	}

	if (map-&gt;nsegs == 1 &amp;&amp; map-&gt;seg[0].fd &lt; 0) {
		cp = (uchar*)&amp;addr;
		while (cp &lt; (uchar*)(&amp;addr+1) &amp;&amp; size-- &gt; 0)
			*x++ = *cp++;
		while (size-- &gt; 0)
			*x++ = 0;
	} else
		return mget(map, addr, x, size);
	return 1;
}

int
puta(Map *map, uvlong addr, uvlong v)
{
	if (mach-&gt;szaddr == 8)
		return put8(map, addr, v);

	return put4(map, addr, v);
}

int
put8(Map *map, uvlong addr, uvlong v)
{
	if (!map) {
		werrstr("put8: invalid map");
		return -1;
	}
	v = machdata-&gt;swav(v);
	return mput(map, addr, &amp;v, 8);
}

int
put4(Map *map, uvlong addr, ulong v)
{
	if (!map) {
		werrstr("put4: invalid map");
		return -1;
	}
	v = machdata-&gt;swal(v);
	return mput(map, addr, &amp;v, 4);
}

int
put2(Map *map, uvlong addr, ushort v)
{
	if (!map) {
		werrstr("put2: invalid map");
		return -1;
	}
	v = machdata-&gt;swab(v);
	return mput(map, addr, &amp;v, 2);
}

int
put1(Map *map, uvlong addr, uchar *v, int size)
{
	if (!map) {
		werrstr("put1: invalid map");
		return -1;
	}
	return mput(map, addr, v, size);
}

static int
spread(struct segment *s, void *buf, int n, uvlong off)
{
	uvlong base;

	static struct {
		struct segment *s;
		char a[8192];
		uvlong off;
	} cache;

	if(s-&gt;cache){
		base = off&amp;~(sizeof cache.a-1);
		if(cache.s != s || cache.off != base){
			cache.off = ~0;
			if(seek(s-&gt;fd, base, 0) &gt;= 0
			&amp;&amp; readn(s-&gt;fd, cache.a, sizeof cache.a) == sizeof cache.a){
				cache.s = s;
				cache.off = base;
			}
		}
		if(cache.s == s &amp;&amp; cache.off == base){
			off &amp;= sizeof cache.a-1;
			if(off+n &gt; sizeof cache.a)
				n = sizeof cache.a - off;
			memmove(buf, cache.a+off, n);
			return n;
		}
	}

	return pread(s-&gt;fd, buf, n, off);
}

static int
mget(Map *map, uvlong addr, void *buf, int size)
{
	uvlong off;
	int i, j, k;
	struct segment *s;

	s = reloc(map, addr, (vlong*)&amp;off);
	if (!s)
		return -1;
	if (s-&gt;fd &lt; 0) {
		werrstr("unreadable map");
		return -1;
	}
	for (i = j = 0; i &lt; 2; i++) {	/* in case read crosses page */
		k = spread(s, (void*)((uchar *)buf+j), size-j, off+j);
		if (k &lt; 0) {
			werrstr("can't read address %llux: %r", addr);
			return -1;
		}
		j += k;
		if (j == size)
			return j;
	}
	werrstr("partial read at address %llux (size %d j %d)", addr, size, j);
	return -1;
}

static int
mput(Map *map, uvlong addr, void *buf, int size)
{
	vlong off;
	int i, j, k;
	struct segment *s;

	s = reloc(map, addr, &amp;off);
	if (!s)
		return -1;
	if (s-&gt;fd &lt; 0) {
		werrstr("unwritable map");
		return -1;
	}

	seek(s-&gt;fd, off, 0);
	for (i = j = 0; i &lt; 2; i++) {	/* in case read crosses page */
		k = write(s-&gt;fd, buf, size-j);
		if (k &lt; 0) {
			werrstr("can't write address %llux: %r", addr);
			return -1;
		}
		j += k;
		if (j == size)
			return j;
	}
	werrstr("partial write at address %llux", addr);
	return -1;
}

/*
 *	convert address to file offset; returns nonzero if ok
 */
static struct segment*
reloc(Map *map, uvlong addr, vlong *offp)
{
	int i;

	for (i = 0; i &lt; map-&gt;nsegs; i++) {
		if (map-&gt;seg[i].inuse)
		if (map-&gt;seg[i].b &lt;= addr &amp;&amp; addr &lt; map-&gt;seg[i].e) {
			*offp = addr + map-&gt;seg[i].f - map-&gt;seg[i].b;
			return &amp;map-&gt;seg[i];
		}
	}
	werrstr("can't translate address %llux", addr);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

