<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/executable.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/executable.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;bio.h&gt;
#include	&lt;bootexec.h&gt;
#include	&lt;mach.h&gt;
#include	"elf.h"

/*
 *	All a.out header types.  The dummy entry allows canonical
 *	processing of the union as a sequence of longs
 */

typedef struct {
	union{
		struct {
			Exec;		/* a.out.h */
			uvlong hdr[1];
		};
		Ehdr;			/* elf.h */
		E64hdr;
		struct mipsexec;	/* bootexec.h */
		struct mips4kexec;	/* bootexec.h */
		struct sparcexec;	/* bootexec.h */
		struct nextexec;	/* bootexec.h */
	} e;
	long dummy;			/* padding to ensure extra long */
} ExecHdr;

static	int	nextboot(int, Fhdr*, ExecHdr*);
static	int	sparcboot(int, Fhdr*, ExecHdr*);
static	int	mipsboot(int, Fhdr*, ExecHdr*);
static	int	mips4kboot(int, Fhdr*, ExecHdr*);
static	int	common(int, Fhdr*, ExecHdr*);
static	int	commonllp64(int, Fhdr*, ExecHdr*);
static	int	adotout(int, Fhdr*, ExecHdr*);
static	int	elfdotout(int, Fhdr*, ExecHdr*);
static	int	armdotout(int, Fhdr*, ExecHdr*);
static	void	setsym(Fhdr*, long, long, long, vlong);
static	void	setdata(Fhdr*, uvlong, long, vlong, long);
static	void	settext(Fhdr*, uvlong, uvlong, long, vlong);
static	void	hswal(void*, int, ulong(*)(ulong));
static	uvlong	_round(uvlong, ulong);

/*
 *	definition of per-executable file type structures
 */

typedef struct Exectable{
	long	magic;			/* big-endian magic number of file */
	char	*name;			/* executable identifier */
	char	*dlmname;		/* dynamically loadable module identifier */
	uchar	type;			/* Internal code */
	uchar	_magic;			/* _MAGIC() magic */
	Mach	*mach;			/* Per-machine data */
	long	hsize;			/* header size */
	ulong	(*swal)(ulong);		/* beswal or leswal */
	int	(*hparse)(int, Fhdr*, ExecHdr*);
} ExecTable;

extern	Mach	mmips;
extern	Mach	mmips2le;
extern	Mach	mmips2be;
extern	Mach	msparc;
extern	Mach	msparc64;
extern	Mach	m68020;
extern	Mach	mi386;
extern	Mach	mamd64;
extern	Mach	marm;
extern	Mach	mpower;
extern	Mach	mpower64;
extern	Mach	malpha;

ExecTable exectab[] =
{
	{ V_MAGIC,			/* Mips v.out */
		"mips plan 9 executable BE",
		"mips plan 9 dlm BE",
		FMIPS,
		1,
		&amp;mmips,
		sizeof(Exec),
		beswal,
		adotout },
	{ P_MAGIC,			/* Mips 0.out (r3k le) */
		"mips plan 9 executable LE",
		"mips plan 9 dlm LE",
		FMIPSLE,
		1,
		&amp;mmips,
		sizeof(Exec),
		beswal,
		adotout },
	{ M_MAGIC,			/* Mips 4.out */
		"mips 4k plan 9 executable BE",
		"mips 4k plan 9 dlm BE",
		FMIPS2BE,
		1,
		&amp;mmips2be,
		sizeof(Exec),
		beswal,
		adotout },
	{ N_MAGIC,			/* Mips 0.out */
		"mips 4k plan 9 executable LE",
		"mips 4k plan 9 dlm LE",
		FMIPS2LE,
		1,
		&amp;mmips2le,
		sizeof(Exec),
		beswal,
		adotout },
	{ 0x160&lt;&lt;16,			/* Mips boot image */
		"mips plan 9 boot image",
		nil,
		FMIPSB,
		0,
		&amp;mmips,
		sizeof(struct mipsexec),
		beswal,
		mipsboot },
	{ (0x160&lt;&lt;16)|3,		/* Mips boot image */
		"mips 4k plan 9 boot image",
		nil,
		FMIPSB,
		0,
		&amp;mmips2be,
		sizeof(struct mips4kexec),
		beswal,
		mips4kboot },
	{ K_MAGIC,			/* Sparc k.out */
		"sparc plan 9 executable",
		"sparc plan 9 dlm",
		FSPARC,
		1,
		&amp;msparc,
		sizeof(Exec),
		beswal,
		adotout },
	{ 0x01030107, 			/* Sparc boot image */
		"sparc plan 9 boot image",
		nil,
		FSPARCB,
		0,
		&amp;msparc,
		sizeof(struct sparcexec),
		beswal,
		sparcboot },
	{ U_MAGIC,			/* Sparc64 u.out */
		"sparc64 plan 9 executable",
		"sparc64 plan 9 dlm",
		FSPARC64,
		1,
		&amp;msparc64,
		sizeof(Exec),
		beswal,
		adotout },
	{ A_MAGIC,			/* 68020 2.out &amp; boot image */
		"68020 plan 9 executable",
		"68020 plan 9 dlm",
		F68020,
		1,
		&amp;m68020,
		sizeof(Exec),
		beswal,
		common },
	{ 0xFEEDFACE,			/* Next boot image */
		"next plan 9 boot image",
		nil,
		FNEXTB,
		0,
		&amp;m68020,
		sizeof(struct nextexec),
		beswal,
		nextboot },
	{ I_MAGIC,			/* I386 8.out &amp; boot image */
		"386 plan 9 executable",
		"386 plan 9 dlm",
		FI386,
		1,
		&amp;mi386,
		sizeof(Exec),
		beswal,
		common },
	{ S_MAGIC,			/* amd64 6.out &amp; boot image */
		"amd64 plan 9 executable",
		"amd64 plan 9 dlm",
		FAMD64,
		1,
		&amp;mamd64,
		sizeof(Exec)+8,
		nil,
		commonllp64 },
	{ Q_MAGIC,			/* PowerPC q.out &amp; boot image */
		"power plan 9 executable",
		"power plan 9 dlm",
		FPOWER,
		1,
		&amp;mpower,
		sizeof(Exec),
		beswal,
		common },
	{ T_MAGIC,			/* power64 9.out &amp; boot image */
		"power64 plan 9 executable",
		"power64 plan 9 dlm",
		FPOWER64,
		1,
		&amp;mpower64,
		sizeof(Exec)+8,
		nil,
		commonllp64 },
	{ ELF_MAG,			/* any ELF */
		"elf executable",
		nil,
		FNONE,
		0,
		&amp;mi386,
		sizeof(Ehdr),
		nil,
		elfdotout },
	{ E_MAGIC,			/* Arm 5.out and boot image */
		"arm plan 9 executable",
		"arm plan 9 dlm",
		FARM,
		1,
		&amp;marm,
		sizeof(Exec),
		beswal,
		common },
	{ (143&lt;&lt;16)|0413,		/* (Free|Net)BSD Arm */
		"arm *bsd executable",
		nil,
		FARM,
		0,
		&amp;marm,
		sizeof(Exec),
		leswal,
		armdotout },
	{ L_MAGIC,			/* alpha 7.out */
		"alpha plan 9 executable",
		"alpha plan 9 dlm",
		FALPHA,
		1,
		&amp;malpha,
		sizeof(Exec),
		beswal,
		common },
	{ 0x0700e0c3,			/* alpha boot image */
		"alpha plan 9 boot image",
		nil,
		FALPHA,
		0,
		&amp;malpha,
		sizeof(Exec),
		beswal,
		common },
	{ 0 },
};

Mach	*mach = &amp;mi386;			/* Global current machine table */

static ExecTable*
couldbe4k(ExecTable *mp)
{
	Dir *d;
	ExecTable *f;

	if((d=dirstat("/proc/1/regs")) == nil)
		return mp;
	if(d-&gt;length &lt; 32*8){		/* R3000 */
		free(d);
		return mp;
	}
	free(d);
	for (f = exectab; f-&gt;magic; f++)
		if(f-&gt;magic == M_MAGIC) {
			f-&gt;name = "mips plan 9 executable on mips2 kernel";
			return f;
		}
	return mp;
}

int
crackhdr(int fd, Fhdr *fp)
{
	ExecTable *mp;
	ExecHdr d;
	int nb, ret;
	ulong magic;

	fp-&gt;type = FNONE;
	nb = read(fd, (char *)&amp;d.e, sizeof(d.e));
	if (nb &lt;= 0)
		return 0;

	ret = 0;
	magic = beswal(d.e.magic);		/* big-endian */
	for (mp = exectab; mp-&gt;magic; mp++) {
		if (nb &lt; mp-&gt;hsize)
			continue;

		/*
		 * The magic number has morphed into something
		 * with fields (the straw was DYN_MAGIC) so now
		 * a flag is needed in Fhdr to distinguish _MAGIC()
		 * magic numbers from foreign magic numbers.
		 *
		 * This code is creaking a bit and if it has to
		 * be modified/extended much more it's probably
		 * time to step back and redo it all.
		 */
		if(mp-&gt;_magic){
			if(mp-&gt;magic != (magic &amp; ~DYN_MAGIC))
				continue;

			if(mp-&gt;magic == V_MAGIC)
				mp = couldbe4k(mp);

			if ((magic &amp; DYN_MAGIC) &amp;&amp; mp-&gt;dlmname != nil)
				fp-&gt;name = mp-&gt;dlmname;
			else
				fp-&gt;name = mp-&gt;name;
		}
		else{
			if(mp-&gt;magic != magic)
				continue;
			fp-&gt;name = mp-&gt;name;
		}
		fp-&gt;type = mp-&gt;type;
		fp-&gt;hdrsz = mp-&gt;hsize;		/* will be zero on bootables */
		fp-&gt;_magic = mp-&gt;_magic;
		fp-&gt;magic = magic;

		mach = mp-&gt;mach;
		if(mp-&gt;swal != nil)
			hswal(&amp;d, sizeof(d.e)/sizeof(ulong), mp-&gt;swal);
		ret = mp-&gt;hparse(fd, fp, &amp;d);
		seek(fd, mp-&gt;hsize, 0);		/* seek to end of header */
		break;
	}
	if(mp-&gt;magic == 0)
		werrstr("unknown header type");
	return ret;
}

/*
 * Convert header to canonical form
 */
static void
hswal(void *v, int n, ulong (*swap)(ulong))
{
	ulong *ulp;

	for(ulp = v; n--; ulp++)
		*ulp = (*swap)(*ulp);
}

/*
 *	Crack a normal a.out-type header
 */
static int
adotout(int fd, Fhdr *fp, ExecHdr *hp)
{
	long pgsize;

	USED(fd);
	pgsize = mach-&gt;pgsize;
	settext(fp, hp-&gt;e.entry, pgsize+sizeof(Exec),
			hp-&gt;e.text, sizeof(Exec));
	setdata(fp, _round(pgsize+fp-&gt;txtsz+sizeof(Exec), pgsize),
		hp-&gt;e.data, fp-&gt;txtsz+sizeof(Exec), hp-&gt;e.bss);
	setsym(fp, hp-&gt;e.syms, hp-&gt;e.spsz, hp-&gt;e.pcsz, fp-&gt;datoff+fp-&gt;datsz);
	return 1;
}

static void
commonboot(Fhdr *fp)
{
	if (!(fp-&gt;entry &amp; mach-&gt;ktmask))
		return;

	switch(fp-&gt;type) {				/* boot image */
	case F68020:
		fp-&gt;type = F68020B;
		fp-&gt;name = "68020 plan 9 boot image";
		break;
	case FI386:
		fp-&gt;type = FI386B;
		fp-&gt;txtaddr = (u32int)fp-&gt;entry;
		fp-&gt;name = "386 plan 9 boot image";
		fp-&gt;dataddr = _round(fp-&gt;txtaddr+fp-&gt;txtsz, mach-&gt;pgsize);
		break;
	case FARM:
		fp-&gt;type = FARMB;
		fp-&gt;txtaddr = (u32int)fp-&gt;entry;
		fp-&gt;name = "ARM plan 9 boot image";
		fp-&gt;dataddr = _round(fp-&gt;txtaddr+fp-&gt;txtsz, mach-&gt;pgsize);
		return;
	case FALPHA:
		fp-&gt;type = FALPHAB;
		fp-&gt;txtaddr = (u32int)fp-&gt;entry;
		fp-&gt;name = "alpha plan 9 boot image";
		fp-&gt;dataddr = fp-&gt;txtaddr+fp-&gt;txtsz;
		break;
	case FPOWER:
		fp-&gt;type = FPOWERB;
		fp-&gt;txtaddr = (u32int)fp-&gt;entry;
		fp-&gt;name = "power plan 9 boot image";
		fp-&gt;dataddr = fp-&gt;txtaddr+fp-&gt;txtsz;
		break;
	case FAMD64:
		fp-&gt;type = FAMD64B;
		fp-&gt;txtaddr = fp-&gt;entry;
		fp-&gt;name = "amd64 plan 9 boot image";
		fp-&gt;dataddr = _round(fp-&gt;txtaddr+fp-&gt;txtsz, 4096);
		break;
	case FPOWER64:
		fp-&gt;type = FPOWER64B;
		fp-&gt;txtaddr = fp-&gt;entry;
		fp-&gt;name = "power64 plan 9 boot image";
		fp-&gt;dataddr = fp-&gt;txtaddr+fp-&gt;txtsz;
		break;
	default:
		return;
	}
	fp-&gt;hdrsz = 0;			/* header stripped */
}

/*
 *	_MAGIC() style headers and
 *	alpha plan9-style bootable images for axp "headerless" boot
 *
 */
static int
common(int fd, Fhdr *fp, ExecHdr *hp)
{
	adotout(fd, fp, hp);
	if(hp-&gt;e.magic &amp; DYN_MAGIC) {
		fp-&gt;txtaddr = 0;
		fp-&gt;dataddr = fp-&gt;txtsz;
		return 1;
	}
	commonboot(fp);
	return 1;
}

static int
commonllp64(int, Fhdr *fp, ExecHdr *hp)
{
	long pgsize;
	uvlong entry;

	hswal(&amp;hp-&gt;e, sizeof(Exec)/sizeof(long), beswal);
	if(!(hp-&gt;e.magic &amp; HDR_MAGIC))
		return 0;

	/*
	 * There can be more magic here if the
	 * header ever needs more expansion.
	 * For now just catch use of any of the
	 * unused bits.
	 */
	if((hp-&gt;e.magic &amp; ~DYN_MAGIC)&gt;&gt;16)
		return 0;
	entry = beswav(hp-&gt;e.hdr[0]);

	pgsize = mach-&gt;pgsize;
	settext(fp, entry, pgsize+fp-&gt;hdrsz, hp-&gt;e.text, fp-&gt;hdrsz);
	setdata(fp, _round(pgsize+fp-&gt;txtsz+fp-&gt;hdrsz, pgsize),
		hp-&gt;e.data, fp-&gt;txtsz+fp-&gt;hdrsz, hp-&gt;e.bss);
	setsym(fp, hp-&gt;e.syms, hp-&gt;e.spsz, hp-&gt;e.pcsz, fp-&gt;datoff+fp-&gt;datsz);

	if(hp-&gt;e.magic &amp; DYN_MAGIC) {
		fp-&gt;txtaddr = 0;
		fp-&gt;dataddr = fp-&gt;txtsz;
		return 1;
	}
	commonboot(fp);
	return 1;
}

/*
 *	mips bootable image.
 */
static int
mipsboot(int fd, Fhdr *fp, ExecHdr *hp)
{
	USED(fd);
	fp-&gt;type = FMIPSB;
	switch(hp-&gt;e.amagic) {
	default:
	case 0407:	/* some kind of mips */
		settext(fp, (u32int)hp-&gt;e.mentry, (u32int)hp-&gt;e.text_start,
			hp-&gt;e.tsize, sizeof(struct mipsexec)+4);
		setdata(fp, (u32int)hp-&gt;e.data_start, hp-&gt;e.dsize,
			fp-&gt;txtoff+hp-&gt;e.tsize, hp-&gt;e.bsize);
		break;
	case 0413:	/* some kind of mips */
		settext(fp, (u32int)hp-&gt;e.mentry, (u32int)hp-&gt;e.text_start,
			hp-&gt;e.tsize, 0);
		setdata(fp, (u32int)hp-&gt;e.data_start, hp-&gt;e.dsize,
			hp-&gt;e.tsize, hp-&gt;e.bsize);
		break;
	}
	setsym(fp, hp-&gt;e.nsyms, 0, hp-&gt;e.pcsize, hp-&gt;e.symptr);
	fp-&gt;hdrsz = 0;			/* header stripped */
	return 1;
}

/*
 *	mips4k bootable image.
 */
static int
mips4kboot(int fd, Fhdr *fp, ExecHdr *hp)
{
	USED(fd);
	fp-&gt;type = FMIPSB;
	switch(hp-&gt;e.h.amagic) {
	default:
	case 0407:	/* some kind of mips */
		settext(fp, (u32int)hp-&gt;e.h.mentry, (u32int)hp-&gt;e.h.text_start,
			hp-&gt;e.h.tsize, sizeof(struct mips4kexec));
		setdata(fp, (u32int)hp-&gt;e.h.data_start, hp-&gt;e.h.dsize,
			fp-&gt;txtoff+hp-&gt;e.h.tsize, hp-&gt;e.h.bsize);
		break;
	case 0413:	/* some kind of mips */
		settext(fp, (u32int)hp-&gt;e.h.mentry, (u32int)hp-&gt;e.h.text_start,
			hp-&gt;e.h.tsize, 0);
		setdata(fp, (u32int)hp-&gt;e.h.data_start, hp-&gt;e.h.dsize,
			hp-&gt;e.h.tsize, hp-&gt;e.h.bsize);
		break;
	}
	setsym(fp, hp-&gt;e.h.nsyms, 0, hp-&gt;e.h.pcsize, hp-&gt;e.h.symptr);
	fp-&gt;hdrsz = 0;			/* header stripped */
	return 1;
}

/*
 *	sparc bootable image
 */
static int
sparcboot(int fd, Fhdr *fp, ExecHdr *hp)
{
	USED(fd);
	fp-&gt;type = FSPARCB;
	settext(fp, hp-&gt;e.sentry, hp-&gt;e.sentry, hp-&gt;e.stext,
		sizeof(struct sparcexec));
	setdata(fp, hp-&gt;e.sentry+hp-&gt;e.stext, hp-&gt;e.sdata,
		fp-&gt;txtoff+hp-&gt;e.stext, hp-&gt;e.sbss);
	setsym(fp, hp-&gt;e.ssyms, 0, hp-&gt;e.sdrsize, fp-&gt;datoff+hp-&gt;e.sdata);
	fp-&gt;hdrsz = 0;			/* header stripped */
	return 1;
}

/*
 *	next bootable image
 */
static int
nextboot(int fd, Fhdr *fp, ExecHdr *hp)
{
	USED(fd);
	fp-&gt;type = FNEXTB;
	settext(fp, hp-&gt;e.textc.vmaddr, hp-&gt;e.textc.vmaddr,
		hp-&gt;e.texts.size, hp-&gt;e.texts.offset);
	setdata(fp, hp-&gt;e.datac.vmaddr, hp-&gt;e.datas.size,
		hp-&gt;e.datas.offset, hp-&gt;e.bsss.size);
	setsym(fp, hp-&gt;e.symc.nsyms, hp-&gt;e.symc.spoff, hp-&gt;e.symc.pcoff,
		hp-&gt;e.symc.symoff);
	fp-&gt;hdrsz = 0;			/* header stripped */
	return 1;
}

/*
 * ELF64 binaries.
 */
static int
elf64dotout(int fd, Fhdr *fp, ExecHdr *hp)
{
	E64hdr *ep;
	P64hdr *ph;
	ushort (*swab)(ushort);
	ulong (*swal)(ulong);
	uvlong (*swav)(uvlong);
	int i, it, id, is, phsz;
	uvlong uvl;

	ep = &amp;hp-&gt;e;
	if(ep-&gt;ident[DATA] == ELFDATA2LSB) {
		swab = leswab;
		swal = leswal;
		swav = leswav;
	} else if(ep-&gt;ident[DATA] == ELFDATA2MSB) {
		swab = beswab;
		swal = beswal;
		swav = beswav;
	} else {
		werrstr("bad ELF64 encoding - not big or little endian");
		return 0;
	}

	ep-&gt;type = swab(ep-&gt;type);
	ep-&gt;machine = swab(ep-&gt;machine);
	ep-&gt;version = swal(ep-&gt;version);
	if(ep-&gt;type != EXEC || ep-&gt;version != CURRENT)
		return 0;
	ep-&gt;elfentry = swav(ep-&gt;elfentry);
	ep-&gt;phoff = swav(ep-&gt;phoff);
	ep-&gt;shoff = swav(ep-&gt;shoff);
	ep-&gt;flags = swal(ep-&gt;flags);
	ep-&gt;ehsize = swab(ep-&gt;ehsize);
	ep-&gt;phentsize = swab(ep-&gt;phentsize);
	ep-&gt;phnum = swab(ep-&gt;phnum);
	ep-&gt;shentsize = swab(ep-&gt;shentsize);
	ep-&gt;shnum = swab(ep-&gt;shnum);
	ep-&gt;shstrndx = swab(ep-&gt;shstrndx);

	fp-&gt;magic = ELF_MAG;
	fp-&gt;hdrsz = (ep-&gt;ehsize+ep-&gt;phnum*ep-&gt;phentsize+16)&amp;~15;
	switch(ep-&gt;machine) {
	default:
		return 0;
	case AMD64:
		mach = &amp;mamd64;
		fp-&gt;type = FAMD64;
		fp-&gt;name = "amd64 ELF64 executable";
		break;
	case POWER64:
		mach = &amp;mpower64;
		fp-&gt;type = FPOWER64;
		fp-&gt;name = "power64 ELF64 executable";
		break;
	}

	if(ep-&gt;phentsize != sizeof(P64hdr)) {
		werrstr("bad ELF64 header size");
		return 0;
	}
	phsz = sizeof(P64hdr)*ep-&gt;phnum;
	ph = malloc(phsz);
	if(!ph)
		return 0;
	seek(fd, ep-&gt;phoff, 0);
	if(read(fd, ph, phsz) &lt; 0) {
		free(ph);
		return 0;
	}
	for(i = 0; i &lt; ep-&gt;phnum; i++) {
		ph[i].type = swal(ph[i].type);
		ph[i].flags = swal(ph[i].flags);
		ph[i].offset = swav(ph[i].offset);
		ph[i].vaddr = swav(ph[i].vaddr);
		ph[i].paddr = swav(ph[i].paddr);
		ph[i].filesz = swav(ph[i].filesz);
		ph[i].memsz = swav(ph[i].memsz);
		ph[i].align = swav(ph[i].align);
	}

	/* find text, data and symbols and install them */
	it = id = is = -1;
	for(i = 0; i &lt; ep-&gt;phnum; i++) {
		if(ph[i].type == LOAD
		&amp;&amp; (ph[i].flags &amp; (R|X)) == (R|X) &amp;&amp; it == -1)
			it = i;
		else if(ph[i].type == LOAD
		&amp;&amp; (ph[i].flags &amp; (R|W)) == (R|W) &amp;&amp; id == -1)
			id = i;
		else if(ph[i].type == NOPTYPE &amp;&amp; is == -1)
			is = i;
	}
	if(it == -1 || id == -1) {
		werrstr("No ELF64 TEXT or DATA sections");
		free(ph);
		return 0;
	}

	settext(fp, ep-&gt;elfentry, ph[it].vaddr, ph[it].memsz, ph[it].offset);
	/* 8c: out of fixed registers */
	uvl = ph[id].memsz - ph[id].filesz;
	setdata(fp, ph[id].vaddr, ph[id].filesz, ph[id].offset, uvl);
	if(is != -1)
		setsym(fp, ph[is].filesz, 0, ph[is].memsz, ph[is].offset);
	free(ph);
	return 1;
}

/*
 * ELF32 binaries.
 */
static int
elf32dotout(int fd, Fhdr *fp, ExecHdr *hp)
{
	ulong (*swal)(ulong);
	ushort (*swab)(ushort);
	Ehdr *ep;
	Phdr *ph;
	int i, it, id, is, phsz;

	/* bitswap the header according to the DATA format */
	ep = &amp;hp-&gt;e;
	if(ep-&gt;ident[DATA] == ELFDATA2LSB) {
		swab = leswab;
		swal = leswal;
	} else if(ep-&gt;ident[DATA] == ELFDATA2MSB) {
		swab = beswab;
		swal = beswal;
	} else {
		werrstr("bad ELF32 encoding - not big or little endian");
		return 0;
	}

	ep-&gt;type = swab(ep-&gt;type);
	ep-&gt;machine = swab(ep-&gt;machine);
	ep-&gt;version = swal(ep-&gt;version);
	ep-&gt;elfentry = swal(ep-&gt;elfentry);
	ep-&gt;phoff = swal(ep-&gt;phoff);
	ep-&gt;shoff = swal(ep-&gt;shoff);
	ep-&gt;flags = swal(ep-&gt;flags);
	ep-&gt;ehsize = swab(ep-&gt;ehsize);
	ep-&gt;phentsize = swab(ep-&gt;phentsize);
	ep-&gt;phnum = swab(ep-&gt;phnum);
	ep-&gt;shentsize = swab(ep-&gt;shentsize);
	ep-&gt;shnum = swab(ep-&gt;shnum);
	ep-&gt;shstrndx = swab(ep-&gt;shstrndx);
	if(ep-&gt;type != EXEC || ep-&gt;version != CURRENT)
		return 0;

	/* we could definitely support a lot more machines here */
	fp-&gt;magic = ELF_MAG;
	fp-&gt;hdrsz = (ep-&gt;ehsize+ep-&gt;phnum*ep-&gt;phentsize+16)&amp;~15;
	switch(ep-&gt;machine) {
	case I386:
		mach = &amp;mi386;
		fp-&gt;type = FI386;
		fp-&gt;name = "386 ELF32 executable";
		break;
	case MIPS:
		mach = &amp;mmips;
		fp-&gt;type = FMIPS;
		fp-&gt;name = "mips ELF32 executable";
		break;
	case SPARC64:
		mach = &amp;msparc64;
		fp-&gt;type = FSPARC64;
		fp-&gt;name = "sparc64 ELF32 executable";
		break;
	case POWER:
		mach = &amp;mpower;
		fp-&gt;type = FPOWER;
		fp-&gt;name = "power ELF32 executable";
		break;
	case POWER64:
		mach = &amp;mpower64;
		fp-&gt;type = FPOWER64;
		fp-&gt;name = "power64 ELF32 executable";
		break;
	case AMD64:
		mach = &amp;mamd64;
		fp-&gt;type = FAMD64;
		fp-&gt;name = "amd64 ELF32 executable";
		break;
	case ARM:
		mach = &amp;marm;
		fp-&gt;type = FARM;
		fp-&gt;name = "arm ELF32 executable";
		break;
	default:
		return 0;
	}

	if(ep-&gt;phentsize != sizeof(Phdr)) {
		werrstr("bad ELF32 header size");
		return 0;
	}
	phsz = sizeof(Phdr)*ep-&gt;phnum;
	ph = malloc(phsz);
	if(!ph)
		return 0;
	seek(fd, ep-&gt;phoff, 0);
	if(read(fd, ph, phsz) &lt; 0) {
		free(ph);
		return 0;
	}
	hswal(ph, phsz/sizeof(ulong), swal);

	/* find text, data and symbols and install them */
	it = id = is = -1;
	for(i = 0; i &lt; ep-&gt;phnum; i++) {
		if(ph[i].type == LOAD
		&amp;&amp; (ph[i].flags &amp; (R|X)) == (R|X) &amp;&amp; it == -1)
			it = i;
		else if(ph[i].type == LOAD
		&amp;&amp; (ph[i].flags &amp; (R|W)) == (R|W) &amp;&amp; id == -1)
			id = i;
		else if(ph[i].type == NOPTYPE &amp;&amp; is == -1)
			is = i;
	}
	if(it == -1 || id == -1) {
		/*
		 * The SPARC64 boot image is something of an ELF hack.
		 * Text+Data+BSS are represented by ph[0].  Symbols
		 * are represented by ph[1]:
		 *
		 *		filesz, memsz, vaddr, paddr, off
		 * ph[0] : txtsz+datsz, txtsz+datsz+bsssz, txtaddr-KZERO, datasize, txtoff
		 * ph[1] : symsz, lcsz, 0, 0, symoff
		 */
		if(ep-&gt;machine == SPARC64 &amp;&amp; ep-&gt;phnum == 2) {
			ulong txtaddr, txtsz, dataddr, bsssz;

			txtaddr = ph[0].vaddr | 0x80000000;
			txtsz = ph[0].filesz - ph[0].paddr;
			dataddr = txtaddr + txtsz;
			bsssz = ph[0].memsz - ph[0].filesz;
			settext(fp, ep-&gt;elfentry | 0x80000000, txtaddr, txtsz, ph[0].offset);
			setdata(fp, dataddr, ph[0].paddr, ph[0].offset + txtsz, bsssz);
			setsym(fp, ph[1].filesz, 0, ph[1].memsz, ph[1].offset);
			free(ph);
			return 1;
		}

		werrstr("No ELF32 TEXT or DATA sections");
		free(ph);
		return 0;
	}

	settext(fp, ep-&gt;elfentry, ph[it].vaddr, ph[it].memsz, ph[it].offset);
	setdata(fp, ph[id].vaddr, ph[id].filesz, ph[id].offset, ph[id].memsz - ph[id].filesz);
	if(is != -1)
		setsym(fp, ph[is].filesz, 0, ph[is].memsz, ph[is].offset);
	free(ph);
	return 1;
}

/*
 * Elf binaries.
 */
static int
elfdotout(int fd, Fhdr *fp, ExecHdr *hp)
{
	Ehdr *ep;

	/* bitswap the header according to the DATA format */
	ep = &amp;hp-&gt;e;
	if(ep-&gt;ident[CLASS] == ELFCLASS32)
		return elf32dotout(fd, fp, hp);
	else if(ep-&gt;ident[CLASS] == ELFCLASS64)
		return elf64dotout(fd, fp, hp);

	werrstr("bad ELF class - not 32- nor 64-bit");
	return 0;
}

/*
 * (Free|Net)BSD ARM header.
 */
static int
armdotout(int fd, Fhdr *fp, ExecHdr *hp)
{
	uvlong kbase;

	USED(fd);
	settext(fp, hp-&gt;e.entry, sizeof(Exec), hp-&gt;e.text, sizeof(Exec));
	setdata(fp, fp-&gt;txtsz, hp-&gt;e.data, fp-&gt;txtsz, hp-&gt;e.bss);
	setsym(fp, hp-&gt;e.syms, hp-&gt;e.spsz, hp-&gt;e.pcsz, fp-&gt;datoff+fp-&gt;datsz);

	kbase = 0xF0000000;
	if ((fp-&gt;entry &amp; kbase) == kbase) {		/* Boot image */
		fp-&gt;txtaddr = kbase+sizeof(Exec);
		fp-&gt;name = "ARM *BSD boot image";
		fp-&gt;hdrsz = 0;		/* header stripped */
		fp-&gt;dataddr = kbase+fp-&gt;txtsz;
	}
	return 1;
}

static void
settext(Fhdr *fp, uvlong e, uvlong a, long s, vlong off)
{
	fp-&gt;txtaddr = a;
	fp-&gt;entry = e;
	fp-&gt;txtsz = s;
	fp-&gt;txtoff = off;
}

static void
setdata(Fhdr *fp, uvlong a, long s, vlong off, long bss)
{
	fp-&gt;dataddr = a;
	fp-&gt;datsz = s;
	fp-&gt;datoff = off;
	fp-&gt;bsssz = bss;
}

static void
setsym(Fhdr *fp, long symsz, long sppcsz, long lnpcsz, vlong symoff)
{
	fp-&gt;symsz = symsz;
	fp-&gt;symoff = symoff;
	fp-&gt;sppcsz = sppcsz;
	fp-&gt;sppcoff = fp-&gt;symoff+fp-&gt;symsz;
	fp-&gt;lnpcsz = lnpcsz;
	fp-&gt;lnpcoff = fp-&gt;sppcoff+fp-&gt;sppcsz;
}


static uvlong
_round(uvlong a, ulong b)
{
	uvlong w;

	w = (a/b)*b;
	if (a!=w)
		w += b;
	return(w);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

