<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/qdb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/qdb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

/*
 * PowerPC-specific debugger interface,
 * including 64-bit modes
 *	forsyth@terzarima.net
 */

static	char	*powerexcep(Map*, Rgetter);
static	int	powerfoll(Map*, uvlong, Rgetter, uvlong*);
static	int	powerinst(Map*, uvlong, char, char*, int);
static	int	powerinstlen(Map*, uvlong);
static	int	powerdas(Map*, uvlong, char*, int);

/*
 *	Machine description
 */
Machdata powermach =
{
	{0x02, 0x8f, 0xff, 0xff},		/* break point */	/* BUG */
	4,			/* break point size */

	beswab,			/* short to local byte order */
	beswal,			/* long to local byte order */
	beswav,			/* vlong to local byte order */
	risctrace,		/* print C traceback */
	riscframe,		/* frame finder */
	powerexcep,		/* print exception */
	0,			/* breakpoint fixup */
	beieeesftos,		/* single precision float printer */
	beieeedftos,		/* double precisioin float printer */
	powerfoll,		/* following addresses */
	powerinst,		/* print instruction */
	powerdas,		/* dissembler */
	powerinstlen,		/* instruction size */
};

static char *excname[] =
{
	"reserved 0",
	"system reset",
	"machine check",
	"data access",
	"instruction access",
	"external interrupt",
	"alignment",
	"program exception",
	"floating-point unavailable",
	"decrementer",
	"i/o controller interface error",
	"reserved B",
	"system call",
	"trace trap",
	"floating point assist",
	"reserved",
	"ITLB miss",
	"DTLB load miss",
	"DTLB store miss",
	"instruction address breakpoint"
	"SMI interrupt"
	"reserved 15",
	"reserved 16",
	"reserved 17",
	"reserved 18",
	"reserved 19",
	"reserved 1A",
	/* the following are made up on a program exception */
	"floating point exception",		/* FPEXC */
	"illegal instruction",
	"privileged instruction",
	"trap",
	"illegal operation",
};

static char*
powerexcep(Map *map, Rgetter rget)
{
	long c;
	static char buf[32];

	c = (*rget)(map, "CAUSE") &gt;&gt; 8;
	if(c &lt; nelem(excname))
		return excname[c];
	sprint(buf, "unknown trap #%lx", c);
	return buf;
}

/*
 * disassemble PowerPC opcodes
 */

#define	REGSP	1	/* should come from q.out.h, but there's a clash */
#define	REGSB	2

static	char FRAMENAME[] = ".frame";

static Map *mymap;

/*
 * ibm conventions for these: bit 0 is top bit
 *	from table 10-1
 */
typedef struct {
	uchar	aa;		/* bit 30 */
	uchar	crba;		/* bits 11-15 */
	uchar	crbb;		/* bits 16-20 */
	long	bd;		/* bits 16-29 */
	uchar	crfd;		/* bits 6-8 */
	uchar	crfs;		/* bits 11-13 */
	uchar	bi;		/* bits 11-15 */
	uchar	bo;		/* bits 6-10 */
	uchar	crbd;		/* bits 6-10 */
	union {
		short	d;	/* bits 16-31 */
		short	simm;
		ushort	uimm;
	};
	uchar	fm;		/* bits 7-14 */
	uchar	fra;		/* bits 11-15 */
	uchar	frb;		/* bits 16-20 */
	uchar	frc;		/* bits 21-25 */
	uchar	frs;		/* bits 6-10 */
	uchar	frd;		/* bits 6-10 */
	uchar	crm;		/* bits 12-19 */
	long	li;		/* bits 6-29 || b'00' */
	uchar	lk;		/* bit 31 */
	uchar	mb;		/* bits 21-25 */
	uchar	me;		/* bits 26-30 */
	uchar	xmbe;		/* bits 26,21-25: mb[5] || mb[0:4], also xme */
	uchar	xsh;		/* bits 30,16-20: sh[5] || sh[0:4] */
	uchar	nb;		/* bits 16-20 */
	uchar	op;		/* bits 0-5 */
	uchar	oe;		/* bit 21 */
	uchar	ra;		/* bits 11-15 */
	uchar	rb;		/* bits 16-20 */
	uchar	rc;		/* bit 31 */
	union {
		uchar	rs;	/* bits 6-10 */
		uchar	rd;
	};
	uchar	sh;		/* bits 16-20 */
	ushort	spr;		/* bits 11-20 */
	uchar	to;		/* bits 6-10 */
	uchar	imm;		/* bits 16-19 */
	ushort	xo;		/* bits 21-30, 22-30, 26-30, or 30 (beware) */
	uvlong	imm64;
	long w0;
	long w1;
	uvlong	addr;		/* pc of instruction */
	short	target;
	short	m64;		/* 64-bit mode */
	char	*curr;		/* current fill level in output buffer */
	char	*end;		/* end of buffer */
	int 	size;		/* number of longs in instr */
	char	*err;		/* errmsg */
} Instr;

#define	IBF(v,a,b) (((ulong)(v)&gt;&gt;(32-(b)-1)) &amp; ~(~0L&lt;&lt;(((b)-(a)+1))))
#define	IB(v,b) IBF((v),(b),(b))

#pragma	varargck	argpos	bprint		2

static void
bprint(Instr *i, char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	i-&gt;curr = vseprint(i-&gt;curr, i-&gt;end, fmt, arg);
	va_end(arg);
}

static int
decode(uvlong pc, Instr *i)
{
	ulong w;

	if (get4(mymap, pc, &amp;w) &lt; 0) {
		werrstr("can't read instruction: %r");
		return -1;
	}
	i-&gt;m64 = asstype == APOWER64;
	i-&gt;aa = IB(w, 30);
	i-&gt;crba = IBF(w, 11, 15);
	i-&gt;crbb = IBF(w, 16, 20);
	i-&gt;bd = IBF(w, 16, 29)&lt;&lt;2;
	if(i-&gt;bd &amp; 0x8000)
		i-&gt;bd |= ~0L&lt;&lt;16;
	i-&gt;crfd = IBF(w, 6, 8);
	i-&gt;crfs = IBF(w, 11, 13);
	i-&gt;bi = IBF(w, 11, 15);
	i-&gt;bo = IBF(w, 6, 10);
	i-&gt;crbd = IBF(w, 6, 10);
	i-&gt;uimm = IBF(w, 16, 31);	/* also d, simm */
	i-&gt;fm = IBF(w, 7, 14);
	i-&gt;fra = IBF(w, 11, 15);
	i-&gt;frb = IBF(w, 16, 20);
	i-&gt;frc = IBF(w, 21, 25);
	i-&gt;frs = IBF(w, 6, 10);
	i-&gt;frd = IBF(w, 6, 10);
	i-&gt;crm = IBF(w, 12, 19);
	i-&gt;li = IBF(w, 6, 29)&lt;&lt;2;
	if(IB(w, 6))
		i-&gt;li |= ~0&lt;&lt;25;
	i-&gt;lk = IB(w, 31);
	i-&gt;mb = IBF(w, 21, 25);
	i-&gt;me = IBF(w, 26, 30);
	i-&gt;xmbe = (IB(w,26)&lt;&lt;5) | i-&gt;mb;
	i-&gt;nb = IBF(w, 16, 20);
	i-&gt;op = IBF(w, 0, 5);
	i-&gt;oe = IB(w, 21);
	i-&gt;ra = IBF(w, 11, 15);
	i-&gt;rb = IBF(w, 16, 20);
	i-&gt;rc = IB(w, 31);
	i-&gt;rs = IBF(w, 6, 10);	/* also rd */
	i-&gt;sh = IBF(w, 16, 20);
	i-&gt;xsh = (IB(w, 30)&lt;&lt;5) | i-&gt;sh;
	i-&gt;spr = IBF(w, 11, 20);
	i-&gt;to = IBF(w, 6, 10);
	i-&gt;imm = IBF(w, 16, 19);
	i-&gt;xo = IBF(w, 21, 30);		/* bits 21-30, 22-30, 26-30, or 30 (beware) */
	if(i-&gt;op == 58){	/* class of 64-bit loads */
		i-&gt;xo = i-&gt;simm &amp; 3;
		i-&gt;simm &amp;= ~3;
	}
	i-&gt;imm64 = i-&gt;simm;
	if(i-&gt;op == 15)
		i-&gt;imm64 &lt;&lt;= 16;
	else if(i-&gt;op == 25 || i-&gt;op == 27 || i-&gt;op == 29)
		i-&gt;imm64 = (uvlong)(i-&gt;uimm&lt;&lt;16);
	i-&gt;w0 = w;
	i-&gt;target = -1;
	i-&gt;addr = pc;
	i-&gt;size = 1;
	return 1;
}

static int
mkinstr(uvlong pc, Instr *i)
{
	Instr x;

	if(decode(pc, i) &lt; 0)
		return -1;
	/*
	 * combine ADDIS/ORI (CAU/ORIL) into MOVW
	 * also ORIS/ORIL for unsigned in 64-bit mode
	 */
	if ((i-&gt;op == 15 || i-&gt;op == 25) &amp;&amp; i-&gt;ra==0) {
		if(decode(pc+4, &amp;x) &lt; 0)
			return -1;
		if (x.op == 24 &amp;&amp; x.rs == x.ra &amp;&amp; x.ra == i-&gt;rd) {
			i-&gt;imm64 |= (x.imm64 &amp; 0xFFFF);
			if(i-&gt;op != 15)
				i-&gt;imm64 &amp;= 0xFFFFFFFFUL;
			i-&gt;w1 = x.w0;
			i-&gt;target = x.rd;
			i-&gt;size++;
			return 1;
		}
	}
	return 1;
}

static int
plocal(Instr *i)
{
	long offset;
	Symbol s;

	if (!findsym(i-&gt;addr, CTEXT, &amp;s) || !findlocal(&amp;s, FRAMENAME, &amp;s))
		return -1;
	offset = s.value - i-&gt;imm64;
	if (offset &gt; 0) {
		if(getauto(&amp;s, offset, CAUTO, &amp;s)) {
			bprint(i, "%s+%lld(SP)", s.name, s.value);
			return 1;
		}
	} else {
		if (getauto(&amp;s, -offset-4, CPARAM, &amp;s)) {
			bprint(i, "%s+%ld(FP)", s.name, -offset);
			return 1;
		}
	}
	return -1;
}

static int
pglobal(Instr *i, uvlong off, int anyoff, char *reg)
{
	Symbol s, s2;
	uvlong off1;

	if(findsym(off, CANY, &amp;s) &amp;&amp;
	   off-s.value &lt; 4096 &amp;&amp;
	   (s.class == CDATA || s.class == CTEXT)) {
		if(off==s.value &amp;&amp; s.name[0]=='$'){
			off1 = 0;
			geta(mymap, s.value, &amp;off1);
			if(off1 &amp;&amp; findsym(off1, CANY, &amp;s2) &amp;&amp; s2.value == off1){
				bprint(i, "$%s%s", s2.name, reg);
				return 1;
			}
		}
		bprint(i, "%s", s.name);
		if (s.value != off)
			bprint(i, "+%llux", off-s.value);
		bprint(i, reg);
		return 1;
	}
	if(!anyoff)
		return 0;
	bprint(i, "%llux%s", off, reg);
	return 1;
}

static void
address(Instr *i)
{
	if (i-&gt;ra == REGSP &amp;&amp; plocal(i) &gt;= 0)
		return;
	if (i-&gt;ra == REGSB &amp;&amp; mach-&gt;sb &amp;&amp; pglobal(i, mach-&gt;sb+i-&gt;imm64, 0, "(SB)"))
		return;
	if(i-&gt;simm &lt; 0)
		bprint(i, "-%x(R%d)", -i-&gt;simm, i-&gt;ra);
	else
		bprint(i, "%llux(R%d)", i-&gt;imm64, i-&gt;ra);
}

static	char	*tcrbits[] = {"LT", "GT", "EQ", "VS"};
static	char	*fcrbits[] = {"GE", "LE", "NE", "VC"};

typedef struct Opcode Opcode;

struct Opcode {
	uchar	op;
	ushort	xo;
	ushort	xomask;
	char	*mnemonic;
	void	(*f)(Opcode *, Instr *);
	char	*ken;
	int	flags;
};

static void format(char *, Instr *, char *);

static void
branch(Opcode *o, Instr *i)
{
	char buf[8];
	int bo, bi;

	bo = i-&gt;bo &amp; ~1;	/* ignore prediction bit */
	if(bo==4 || bo==12 || bo==20) {	/* simple forms */
		if(bo != 20) {
			bi = i-&gt;bi&amp;3;
			sprint(buf, "B%s%%L", bo==12? tcrbits[bi]: fcrbits[bi]);
			format(buf, i, nil);
			bprint(i, "\t");
			if(i-&gt;bi &gt; 4)
				bprint(i, "CR(%d),", i-&gt;bi/4);
		} else
			format("BR%L\t", i, nil);
		if(i-&gt;op == 16)
			format(0, i, "%J");
		else if(i-&gt;op == 19 &amp;&amp; i-&gt;xo == 528)
			format(0, i, "(CTR)");
		else if(i-&gt;op == 19 &amp;&amp; i-&gt;xo == 16)
			format(0, i, "(LR)");
	} else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
addi(Opcode *o, Instr *i)
{
	if (i-&gt;op==14 &amp;&amp; i-&gt;ra == 0)
		format("MOVW", i, "%i,R%d");
	else if (i-&gt;ra == REGSB) {
		bprint(i, "MOVW\t$");
		address(i);
		bprint(i, ",R%d", i-&gt;rd);
	} else if(i-&gt;op==14 &amp;&amp; i-&gt;simm &lt; 0) {
		bprint(i, "SUB\t$%d,R%d", -i-&gt;simm, i-&gt;ra);
		if(i-&gt;rd != i-&gt;ra)
			bprint(i, ",R%d", i-&gt;rd);
	} else if(i-&gt;ra == i-&gt;rd) {
		format(o-&gt;mnemonic, i, "%i");
		bprint(i, ",R%d", i-&gt;rd);
	} else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
addis(Opcode *o, Instr *i)
{
	long v;

	v = i-&gt;imm64;
	if (i-&gt;op==15 &amp;&amp; i-&gt;ra == 0)
		bprint(i, "MOVW\t$%lux,R%d", v, i-&gt;rd);
	else if (i-&gt;op==15 &amp;&amp; i-&gt;ra == REGSB) {
		bprint(i, "MOVW\t$");
		address(i);
		bprint(i, ",R%d", i-&gt;rd);
	} else if(i-&gt;op==15 &amp;&amp; v &lt; 0) {
		bprint(i, "SUB\t$%ld,R%d", -v, i-&gt;ra);
		if(i-&gt;rd != i-&gt;ra)
			bprint(i, ",R%d", i-&gt;rd);
	} else {
		format(o-&gt;mnemonic, i, nil);
		bprint(i, "\t$%ld,R%d", v, i-&gt;ra);
		if(i-&gt;rd != i-&gt;ra)
			bprint(i, ",R%d", i-&gt;rd);
	}
}

static void
andi(Opcode *o, Instr *i)
{
	if (i-&gt;ra == i-&gt;rs)
		format(o-&gt;mnemonic, i, "%I,R%d");
	else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
gencc(Opcode *o, Instr *i)
{
	format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
gen(Opcode *o, Instr *i)
{
	format(o-&gt;mnemonic, i, o-&gt;ken);
	if (i-&gt;rc)
		bprint(i, " [illegal Rc]");
}

static void
ldx(Opcode *o, Instr *i)
{
	if(i-&gt;ra == 0)
		format(o-&gt;mnemonic, i, "(R%b),R%d");
	else
		format(o-&gt;mnemonic, i, "(R%b+R%a),R%d");
	if(i-&gt;rc)
		bprint(i, " [illegal Rc]");
}

static void
stx(Opcode *o, Instr *i)
{
	if(i-&gt;ra == 0)
		format(o-&gt;mnemonic, i, "R%d,(R%b)");
	else
		format(o-&gt;mnemonic, i, "R%d,(R%b+R%a)");
	if(i-&gt;rc &amp;&amp; i-&gt;xo != 150)
		bprint(i, " [illegal Rc]");
}

static void
fldx(Opcode *o, Instr *i)
{
	if(i-&gt;ra == 0)
		format(o-&gt;mnemonic, i, "(R%b),F%d");
	else
		format(o-&gt;mnemonic, i, "(R%b+R%a),F%d");
	if(i-&gt;rc)
		bprint(i, " [illegal Rc]");
}

static void
fstx(Opcode *o, Instr *i)
{
	if(i-&gt;ra == 0)
		format(o-&gt;mnemonic, i, "F%d,(R%b)");
	else
		format(o-&gt;mnemonic, i, "F%d,(R%b+R%a)");
	if(i-&gt;rc)
		bprint(i, " [illegal Rc]");
}

static void
dcb(Opcode *o, Instr *i)
{
	if(i-&gt;ra == 0)
		format(o-&gt;mnemonic, i, "(R%b)");
	else
		format(o-&gt;mnemonic, i, "(R%b+R%a)");
	if(i-&gt;rd)
		bprint(i, " [illegal Rd]");
	if(i-&gt;rc)
		bprint(i, " [illegal Rc]");
}

static void
lw(Opcode *o, Instr *i, char r)
{
	format(o-&gt;mnemonic, i, nil);
	bprint(i, "\t");
	address(i);
	bprint(i, ",%c%d", r, i-&gt;rd);
}

static void
load(Opcode *o, Instr *i)
{
	lw(o, i, 'R');
}

static void
fload(Opcode *o, Instr *i)
{
	lw(o, i, 'F');
}

static void
sw(Opcode *o, Instr *i, char r)
{
	int offset;
	Symbol s;

	if (i-&gt;rs == REGSP) {
		if (findsym(i-&gt;addr, CTEXT, &amp;s) &amp;&amp; findlocal(&amp;s, FRAMENAME, &amp;s)) {
			offset = s.value-i-&gt;imm64;
			if (offset &gt; 0 &amp;&amp; getauto(&amp;s, offset, CAUTO, &amp;s)) {
				format(o-&gt;mnemonic, i, nil);
				bprint(i, "\t%c%d,%s-%d(SP)", r, i-&gt;rd, s.name, offset);
				return;
			}
		}
	}
	if (i-&gt;rs == REGSB &amp;&amp; mach-&gt;sb) {
		format(o-&gt;mnemonic, i, nil);
		bprint(i, "\t%c%d,", r, i-&gt;rd);
		address(i);
		return;
	}
	if (r == 'F')
		format(o-&gt;mnemonic, i, "F%d,%l");
	else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
store(Opcode *o, Instr *i)
{
	sw(o, i, 'R');
}

static void
fstore(Opcode *o, Instr *i)
{
	sw(o, i, 'F');
}

static void
shifti(Opcode *o, Instr *i)
{
	if (i-&gt;ra == i-&gt;rs)
		format(o-&gt;mnemonic, i, "$%k,R%a");
	else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
shift(Opcode *o, Instr *i)
{
	if (i-&gt;ra == i-&gt;rs)
		format(o-&gt;mnemonic, i, "R%b,R%a");
	else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
add(Opcode *o, Instr *i)
{
	if (i-&gt;rd == i-&gt;ra)
		format(o-&gt;mnemonic, i, "R%b,R%d");
	else if (i-&gt;rd == i-&gt;rb)
		format(o-&gt;mnemonic, i, "R%a,R%d");
	else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static void
sub(Opcode *o, Instr *i)
{
	format(o-&gt;mnemonic, i, nil);
	bprint(i, "\t");
	if(i-&gt;op == 31) {
		bprint(i, "\tR%d,R%d", i-&gt;ra, i-&gt;rb);	/* subtract Ra from Rb */
		if(i-&gt;rd != i-&gt;rb)
			bprint(i, ",R%d", i-&gt;rd);
	} else
		bprint(i, "\tR%d,$%d,R%d", i-&gt;ra, i-&gt;simm, i-&gt;rd);
}

static void
qdiv(Opcode *o, Instr *i)
{
	format(o-&gt;mnemonic, i, nil);
	if(i-&gt;op == 31)
		bprint(i, "\tR%d,R%d", i-&gt;rb, i-&gt;ra);
	else
		bprint(i, "\t$%d,R%d", i-&gt;simm, i-&gt;ra);
	if(i-&gt;ra != i-&gt;rd)
		bprint(i, ",R%d", i-&gt;rd);
}

static void
and(Opcode *o, Instr *i)
{
	if (i-&gt;op == 31) {
		/* Rb,Rs,Ra */
		if (i-&gt;ra == i-&gt;rs)
			format(o-&gt;mnemonic, i, "R%b,R%a");
		else if (i-&gt;ra == i-&gt;rb)
			format(o-&gt;mnemonic, i, "R%s,R%a");
		else
			format(o-&gt;mnemonic, i, o-&gt;ken);
	} else {
		/* imm,Rs,Ra */
		if (i-&gt;ra == i-&gt;rs)
			format(o-&gt;mnemonic, i, "%I,R%a");
		else
			format(o-&gt;mnemonic, i, o-&gt;ken);
	}
}

static void
or(Opcode *o, Instr *i)
{
	if (i-&gt;op == 31) {
		/* Rb,Rs,Ra */
		if (i-&gt;rs == 0 &amp;&amp; i-&gt;ra == 0 &amp;&amp; i-&gt;rb == 0)
			format("NOP", i, nil);
		else if (i-&gt;rs == i-&gt;rb)
			format("MOVW", i, "R%b,R%a");
		else
			and(o, i);
	} else
		and(o, i);
}

static void
shifted(Opcode *o, Instr *i)
{
	format(o-&gt;mnemonic, i, nil);
	bprint(i, "\t$%lux,", (ulong)i-&gt;uimm&lt;&lt;16);
	if (i-&gt;rs == i-&gt;ra)
		bprint(i, "R%d", i-&gt;ra);
	else
		bprint(i, "R%d,R%d", i-&gt;rs, i-&gt;ra);
}

static void
neg(Opcode *o, Instr *i)
{
	if (i-&gt;rd == i-&gt;ra)
		format(o-&gt;mnemonic, i, "R%d");
	else
		format(o-&gt;mnemonic, i, o-&gt;ken);
}

static	char	ir2[] = "R%a,R%d";		/* reverse of IBM order */
static	char	ir3[] = "R%b,R%a,R%d";
static	char	ir3r[] = "R%a,R%b,R%d";
static	char	il3[] = "R%b,R%s,R%a";
static	char	il2u[] = "%I,R%d,R%a";
static	char	il3s[] = "$%k,R%s,R%a";
static	char	il2[] = "R%s,R%a";
static	char	icmp3[] = "R%a,R%b,%D";
static	char	cr3op[] = "%b,%a,%d";
static	char	ir2i[] = "%i,R%a,R%d";
static	char	fp2[] = "F%b,F%d";
static	char	fp3[] = "F%b,F%a,F%d";
static	char	fp3c[] = "F%c,F%a,F%d";
static	char	fp4[] = "F%a,F%c,F%b,F%d";
static	char	fpcmp[] = "F%a,F%b,%D";
static	char	ldop[] = "%l,R%d";
static	char	stop[] = "R%d,%l";
static	char	fldop[] = "%l,F%d";
static	char	fstop[] = "F%d,%l";
static	char	rldc[] = "R%b,R%s,$%E,R%a";
static	char	rlim[] = "R%b,R%s,$%z,R%a";
static	char	rlimi[] = "$%k,R%s,$%z,R%a";
static	char	rldi[] = "$%e,R%s,$%E,R%a";

#define	OEM	IBF(~0,22,30)
#define	FP4	IBF(~0,26,30)
#define	ALL	(~0)
#define	RLDC	0xF
#define	RLDI	0xE
/*
notes:
	10-26: crfD = rD&gt;&gt;2; rD&amp;3 mbz
		also, L bit (bit 10) mbz or selects 64-bit operands
*/

static Opcode opcodes[] = {
	{31,	266,	OEM,	"ADD%V%C",	add,	ir3},
	{31,	 10,	OEM,	"ADDC%V%C",	add,	ir3},
	{31,	138,	OEM,	"ADDE%V%C",	add,	ir3},
	{14,	0,	0,	"ADD",		addi,	ir2i},
	{12,	0,	0,	"ADDC",		addi,	ir2i},
	{13,	0,	0,	"ADDCCC",	addi,	ir2i},
	{15,	0,	0,	"ADD",		addis,	0},
	{31,	234,	OEM,	"ADDME%V%C",	gencc,	ir2},
	{31,	202,	OEM,	"ADDZE%V%C",	gencc,	ir2},

	{31,	28,	ALL,	"AND%C",	and,	il3},
	{31,	60,	ALL,	"ANDN%C",	and,	il3},
	{28,	0,	0,	"ANDCC",	andi,	il2u},
	{29,	0,	0,	"ANDCC",	shifted, 0},

	{18,	0,	0,	"B%L",		gencc,	"%j"},
	{16,	0,	0,	"BC%L",		branch,	"%d,%a,%J"},
	{19,	528,	ALL,	"BC%L",		branch,	"%d,%a,(CTR)"},
	{19,	16,	ALL,	"BC%L",		branch,	"%d,%a,(LR)"},

	{31,	0,	ALL,	"CMP",		0,	icmp3},
	{11,	0,	0,	"CMP",		0,	"R%a,%i,%D"},
	{31,	32,	ALL,	"CMPU",		0,	icmp3},
	{10,	0,	0,	"CMPU",		0,	"R%a,%I,%D"},

	{31,	58,	ALL,	"CNTLZD%C",	gencc,	ir2},	/* 64 */
	{31,	26,	ALL,	"CNTLZ%W%C",	gencc,	ir2},

	{19,	257,	ALL,	"CRAND",	gen,	cr3op},
	{19,	129,	ALL,	"CRANDN",	gen,	cr3op},
	{19,	289,	ALL,	"CREQV",	gen,	cr3op},
	{19,	225,	ALL,	"CRNAND",	gen,	cr3op},
	{19,	33,	ALL,	"CRNOR",	gen,	cr3op},
	{19,	449,	ALL,	"CROR",		gen,	cr3op},
	{19,	417,	ALL,	"CRORN",	gen,	cr3op},
	{19,	193,	ALL,	"CRXOR",	gen,	cr3op},

	{31,	86,	ALL,	"DCBF",		dcb,	0},
	{31,	470,	ALL,	"DCBI",		dcb,	0},
	{31,	54,	ALL,	"DCBST",	dcb,	0},
	{31,	278,	ALL,	"DCBT",		dcb,	0},
	{31,	246,	ALL,	"DCBTST",	dcb,	0},
	{31,	1014,	ALL,	"DCBZ",		dcb,	0},
	{31,	454,	ALL,	"DCCCI",	dcb,	0},
	{31,	966,	ALL,	"ICCCI",	dcb,	0},

	{31,	489,	OEM,	"DIVD%V%C",	qdiv,	ir3},	/* 64 */
	{31,	457,	OEM,	"DIVDU%V%C",	qdiv,	ir3},	/* 64 */
	{31,	491,	OEM,	"DIVW%V%C",	qdiv,	ir3},
	{31,	459,	OEM,	"DIVWU%V%C",	qdiv,	ir3},

	{31,	310,	ALL,	"ECIWX",	ldx,	0},
	{31,	438,	ALL,	"ECOWX",	stx,	0},
	{31,	854,	ALL,	"EIEIO",	gen,	0},

	{31,	284,	ALL,	"EQV%C",	gencc,	il3},

	{31,	954,	ALL,	"EXTSB%C",	gencc,	il2},
	{31,	922,	ALL,	"EXTSH%C",	gencc,	il2},
	{31,	986,	ALL,	"EXTSW%C",	gencc,	il2},	/* 64 */

	{63,	264,	ALL,	"FABS%C",	gencc,	fp2},
	{63,	21,	ALL,	"FADD%C",	gencc,	fp3},
	{59,	21,	ALL,	"FADDS%C",	gencc,	fp3},
	{63,	32,	ALL,	"FCMPO",	gen,	fpcmp},
	{63,	0,	ALL,	"FCMPU",	gen,	fpcmp},
	{63,	846,	ALL,	"FCFID%C",	gencc,	fp2},	/* 64 */
	{63,	814,	ALL,	"FCTID%C",	gencc,	fp2},	/* 64 */
	{63,	815,	ALL,	"FCTIDZ%C",	gencc,	fp2},	/* 64 */
	{63,	14,	ALL,	"FCTIW%C",	gencc,	fp2},
	{63,	15,	ALL,	"FCTIWZ%C",	gencc,	fp2},
	{63,	18,	ALL,	"FDIV%C",	gencc,	fp3},
	{59,	18,	ALL,	"FDIVS%C",	gencc,	fp3},
	{63,	29,	FP4,	"FMADD%C",	gencc,	fp4},
	{59,	29,	FP4,	"FMADDS%C",	gencc,	fp4},
	{63,	72,	ALL,	"FMOVD%C",	gencc,	fp2},
	{63,	28,	FP4,	"FMSUB%C",	gencc,	fp4},
	{59,	28,	FP4,	"FMSUBS%C",	gencc,	fp4},
	{63,	25,	FP4,	"FMUL%C",	gencc,	fp3c},
	{59,	25,	FP4,	"FMULS%C",	gencc,	fp3c},
	{63,	136,	ALL,	"FNABS%C",	gencc,	fp2},
	{63,	40,	ALL,	"FNEG%C",	gencc,	fp2},
	{63,	31,	FP4,	"FNMADD%C",	gencc,	fp4},
	{59,	31,	FP4,	"FNMADDS%C",	gencc,	fp4},
	{63,	30,	FP4,	"FNMSUB%C",	gencc,	fp4},
	{59,	30,	FP4,	"FNMSUBS%C",	gencc,	fp4},
	{59,	24,	ALL,	"FRES%C",	gencc,	fp2},	/* optional */
	{63,	12,	ALL,	"FRSP%C",	gencc,	fp2},
	{63,	26,	ALL,	"FRSQRTE%C",	gencc,	fp2},	/* optional */
	{63,	23,	FP4,	"FSEL%CC",	gencc,	fp4},	/* optional */
	{63,	22,	ALL,	"FSQRT%C",	gencc,	fp2},	/* optional */
	{59,	22,	ALL,	"FSQRTS%C",	gencc,	fp2},	/* optional */
	{63,	20,	FP4,	"FSUB%C",	gencc,	fp3},
	{59,	20,	FP4,	"FSUBS%C",	gencc,	fp3},

	{31,	982,	ALL,	"ICBI",		dcb,	0},	/* optional */
	{19,	150,	ALL,	"ISYNC",	gen,	0},

	{34,	0,	0,	"MOVBZ",	load,	ldop},
	{35,	0,	0,	"MOVBZU",	load,	ldop},
	{31,	119,	ALL,	"MOVBZU",	ldx,	0},
	{31,	87,	ALL,	"MOVBZ",	ldx,	0},
	{50,	0,	0,	"FMOVD",	fload,	fldop},
	{51,	0,	0,	"FMOVDU",	fload,	fldop},
	{31,	631,	ALL,	"FMOVDU",	fldx,	0},
	{31,	599,	ALL,	"FMOVD",	fldx,	0},
	{48,	0,	0,	"FMOVS",	load,	fldop},
	{49,	0,	0,	"FMOVSU",	load,	fldop},
	{31,	567,	ALL,	"FMOVSU",	fldx,	0},
	{31,	535,	ALL,	"FMOVS",	fldx,	0},
	{42,	0,	0,	"MOVH",		load,	ldop},
	{43,	0,	0,	"MOVHU",	load,	ldop},
	{31,	375,	ALL,	"MOVHU",	ldx,	0},
	{31,	343,	ALL,	"MOVH",		ldx,	0},
	{31,	790,	ALL,	"MOVHBR",	ldx,	0},
	{40,	0,	0,	"MOVHZ",	load,	ldop},
	{41,	0,	0,	"MOVHZU",	load,	ldop},
	{31,	311,	ALL,	"MOVHZU",	ldx,	0},
	{31,	279,	ALL,	"MOVHZ",	ldx,	0},
	{46,	0,	0,	"MOVMW",	load,	ldop},
	{31,	597,	ALL,	"LSW",		gen,	"(R%a),$%n,R%d"},
	{31,	533,	ALL,	"LSW",		ldx,	0},
	{31,	20,	ALL,	"LWAR",		ldx,	0},
	{31,	84,	ALL,	"LWARD",	ldx,	0},	/* 64 */

	{58,	0,	ALL,	"MOVD",		load,	ldop},	/* 64 */
	{58,	1,	ALL,	"MOVDU",	load,	ldop},	/* 64 */
	{31,	53,	ALL,	"MOVDU",	ldx,	0},	/* 64 */
	{31,	21,	ALL,	"MOVD",		ldx,	0},	/* 64 */

	{31,	534,	ALL,	"MOVWBR",	ldx,	0},

	{58,	2,	ALL,	"MOVW",		load,	ldop},	/* 64 (lwa) */
	{31,	373,	ALL,	"MOVWU",	ldx,	0},	/* 64 */
	{31,	341,	ALL,	"MOVW",		ldx,	0},	/* 64 */

	{32,	0,	0,	"MOVW%Z",	load,	ldop},
	{33,	0,	0,	"MOVW%ZU",	load,	ldop},
	{31,	55,	ALL,	"MOVW%ZU",	ldx,	0},
	{31,	23,	ALL,	"MOVW%Z",	ldx,	0},

	{19,	0,	ALL,	"MOVFL",	gen,	"%S,%D"},
	{63,	64,	ALL,	"MOVCRFS",	gen,	"%S,%D"},
	{31,	512,	ALL,	"MOVW",		gen,	"XER,%D"},
	{31,	19,	ALL,	"MOVW",		gen,	"CR,R%d"},

	{63,	583,	ALL,	"MOVW%C",	gen,	"FPSCR, F%d"},	/* mffs */
	{31,	83,	ALL,	"MOVW",		gen,	"MSR,R%d"},
	{31,	339,	ALL,	"MOVW",		gen,	"%P,R%d"},
	{31,	595,	ALL,	"MOVW",		gen,	"SEG(%a),R%d"},
	{31,	659,	ALL,	"MOVW",		gen,	"SEG(R%b),R%d"},
	{31,	323,	ALL,	"MOVW",		gen,	"DCR(%Q),R%d"},
	{31,	451,	ALL,	"MOVW",		gen,	"R%s,DCR(%Q)"},
	{31,	259,	ALL,	"MOVW",		gen,	"DCR(R%a),R%d"},
	{31,	387,	ALL,	"MOVW",		gen,	"R%s,DCR(R%a)"},
	{31,	144,	ALL,	"MOVFL",	gen,	"R%s,%m,CR"},
	{63,	70,	ALL,	"MTFSB0%C",	gencc,	"%D"},
	{63,	38,	ALL,	"MTFSB1%C",	gencc,	"%D"},
	{63,	711,	ALL,	"MOVFL%C",	gencc,	"F%b,%M,FPSCR"},	/* mtfsf */
	{63,	134,	ALL,	"MOVFL%C",	gencc,	"%K,%D"},
	{31,	146,	ALL,	"MOVW",		gen,	"R%s,MSR"},
	{31,	178,	ALL,	"MOVD",		gen,	"R%s,MSR"},
	{31,	467,	ALL,	"MOVW",		gen,	"R%s,%P"},
	{31,	210,	ALL,	"MOVW",		gen,	"R%s,SEG(%a)"},
	{31,	242,	ALL,	"MOVW",		gen,	"R%s,SEG(R%b)"},

	{31,	73,	ALL,	"MULHD%C",	gencc,	ir3},
	{31,	9,	ALL,	"MULHDU%C",	gencc,	ir3},
	{31,	233,	OEM,	"MULLD%V%C",	gencc,	ir3},

	{31,	75,	ALL,	"MULHW%C",	gencc,	ir3},
	{31,	11,	ALL,	"MULHWU%C",	gencc,	ir3},
	{31,	235,	OEM,	"MULLW%V%C",	gencc,	ir3},

	{7,	0,	0,	"MULLW",	qdiv,	"%i,R%a,R%d"},

	{31,	476,	ALL,	"NAND%C",	gencc,	il3},
	{31,	104,	OEM,	"NEG%V%C",	neg,	ir2},
	{31,	124,	ALL,	"NOR%C",	gencc,	il3},
	{31,	444,	ALL,	"OR%C",		or,	il3},
	{31,	412,	ALL,	"ORN%C",	or,	il3},
	{24,	0,	0,	"OR",		and,	"%I,R%d,R%a"},
	{25,	0,	0,	"OR",		shifted, 0},

	{19,	50,	ALL,	"RFI",		gen,	0},
	{19,	51,	ALL,	"RFCI",		gen,	0},

	{30,	8,	RLDC,	"RLDCL%C",	gencc,	rldc},	/* 64 */
	{30,	9,	RLDC,	"RLDCR%C",	gencc,	rldc},	/* 64 */
	{30,	0,	RLDI,	"RLDCL%C",	gencc,	rldi},	/* 64 */
	{30,	1&lt;&lt;1, RLDI,	"RLDCR%C",	gencc,	rldi},	/* 64 */
	{30,	2&lt;&lt;1, RLDI,	"RLDC%C",	gencc,	rldi},	/* 64 */
	{30,	3&lt;&lt;1, RLDI,	"RLDMI%C",	gencc,	rldi},	/* 64 */

	{20,	0,	0,	"RLWMI%C",	gencc,	rlimi},
	{21,	0,	0,	"RLWNM%C",	gencc,	rlimi},
	{23,	0,	0,	"RLWNM%C",	gencc,	rlim},

	{17,	1,	ALL,	"SYSCALL",	gen,	0},

	{31,	27,	ALL,	"SLD%C",	shift,	il3},	/* 64 */
	{31,	24,	ALL,	"SLW%C",	shift,	il3},

	{31,	794,	ALL,	"SRAD%C",	shift,	il3},	/* 64 */
	{31,	(413&lt;&lt;1)|0,	ALL,	"SRAD%C",	shifti,	il3s},	/* 64 */
	{31,	(413&lt;&lt;1)|1,	ALL,	"SRAD%C",	shifti,	il3s},	/* 64 */
	{31,	792,	ALL,	"SRAW%C",	shift,	il3},
	{31,	824,	ALL,	"SRAW%C",	shifti,	il3s},

	{31,	539,	ALL,	"SRD%C",	shift,	il3},	/* 64 */
	{31,	536,	ALL,	"SRW%C",	shift,	il3},

	{38,	0,	0,	"MOVB",		store,	stop},
	{39,	0,	0,	"MOVBU",	store,	stop},
	{31,	247,	ALL,	"MOVBU",	stx,	0},
	{31,	215,	ALL,	"MOVB",		stx,	0},
	{54,	0,	0,	"FMOVD",	fstore,	fstop},
	{55,	0,	0,	"FMOVDU",	fstore,	fstop},
	{31,	759,	ALL,	"FMOVDU",	fstx,	0},
	{31,	727,	ALL,	"FMOVD",	fstx,	0},
	{52,	0,	0,	"FMOVS",	fstore,	fstop},
	{53,	0,	0,	"FMOVSU",	fstore,	fstop},
	{31,	695,	ALL,	"FMOVSU",	fstx,	0},
	{31,	663,	ALL,	"FMOVS",	fstx,	0},
	{44,	0,	0,	"MOVH",		store,	stop},
	{31,	918,	ALL,	"MOVHBR",	stx,	0},
	{45,	0,	0,	"MOVHU",	store,	stop},
	{31,	439,	ALL,	"MOVHU",	stx,	0},
	{31,	407,	ALL,	"MOVH",		stx,	0},
	{47,	0,	0,	"MOVMW",	store,	stop},
	{31,	725,	ALL,	"STSW",		gen,	"R%d,$%n,(R%a)"},
	{31,	661,	ALL,	"STSW",		stx,	0},
	{36,	0,	0,	"MOVW",		store,	stop},
	{31,	662,	ALL,	"MOVWBR",	stx,	0},
	{31,	150,	ALL,	"STWCCC",	stx,	0},
	{31,	214,	ALL,	"STDCCC",	stx,	0},	/* 64 */
	{37,	0,	0,	"MOVWU",	store,	stop},
	{31,	183,	ALL,	"MOVWU",	stx,	0},
	{31,	151,	ALL,	"MOVW",		stx,	0},

	{62,	0,	0,	"MOVD%U",	store,	stop},	/* 64 */
	{31,	149,	ALL,	"MOVD",		stx,	0,},	/* 64 */
	{31,	181,	ALL,	"MOVDU",	stx,	0},	/* 64 */

	{31,	498,	ALL,	"SLBIA",	gen,	0},	/* 64 */
	{31,	434,	ALL,	"SLBIE",	gen,	"R%b"},	/* 64 */
	{31,	466,	ALL,	"SLBIEX",	gen,	"R%b"},	/* 64 */
	{31,	915,	ALL,	"SLBMFEE",	gen,	"R%b,R%d"},	/* 64 */
	{31,	851,	ALL,	"SLBMFEV",	gen,	"R%b,R%d"},	/* 64 */
	{31,	402,	ALL,	"SLBMTE",	gen,	"R%s,R%b"},	/* 64 */

	{31,	40,	OEM,	"SUB%V%C",	sub,	ir3},
	{31,	8,	OEM,	"SUBC%V%C",	sub,	ir3},
	{31,	136,	OEM,	"SUBE%V%C",	sub,	ir3},
	{8,	0,	0,	"SUBC",		gen,	"R%a,%i,R%d"},
	{31,	232,	OEM,	"SUBME%V%C",	sub,	ir2},
	{31,	200,	OEM,	"SUBZE%V%C",	sub,	ir2},

	{31,	598,	ALL,	"SYNC",		gen,	0},	/* TO DO: there's a parameter buried in there */
	{2,	0,	0,	"TD",		gen,	"%d,R%a,%i"},	/* 64 */
	{31,	370,	ALL,	"TLBIA",	gen,	0},	/* optional */
	{31,	306,	ALL,	"TLBIE",	gen,	"R%b"},	/* optional */
	{31,	274,	ALL,	"TLBIEL",	gen,	"R%b"},	/* optional */
	{31,	1010,	ALL,	"TLBLI",	gen,	"R%b"},	/* optional */
	{31,	978,	ALL,	"TLBLD",	gen,	"R%b"},	/* optional */
	{31,	566,	ALL,	"TLBSYNC",	gen,	0},	/* optional */
	{31,	68,	ALL,	"TD",		gen,	"%d,R%a,R%b"},	/* 64 */
	{31,	4,	ALL,	"TW",		gen,	"%d,R%a,R%b"},
	{3,	0,	0,	"TW",		gen,	"%d,R%a,%i"},

	{31,	316,	ALL,	"XOR",		and,	il3},
	{26,	0,	0,	"XOR",		and,	il2u},
	{27,	0,	0,	"XOR",		shifted, 0},

	{0},
};

typedef struct Spr Spr;
struct Spr {
	int	n;
	char	*name;
};

static	Spr	sprname[] = {
	{0, "MQ"},
	{1, "XER"},
	{268, "TBL"},
	{269, "TBU"},
	{8, "LR"},
	{9, "CTR"},
	{528, "IBAT0U"},
	{529, "IBAT0L"},
	{530, "IBAT1U"},
	{531, "IBAT1L"},
	{532, "IBAT2U"},
	{533, "IBAT2L"},
	{534, "IBAT3U"},
	{535, "IBAT3L"},
	{536, "DBAT0U"},
	{537, "DBAT0L"},
	{538, "DBAT1U"},
	{539, "DBAT1L"},
	{540, "DBAT2U"},
	{541, "DBAT2L"},
	{542, "DBAT3U"},
	{543, "DBAT3L"},
	{25, "SDR1"},
	{19, "DAR"},
	{272, "SPRG0"},
	{273, "SPRG1"},
	{274, "SPRG2"},
	{275, "SPRG3"},
	{18, "DSISR"},
	{26, "SRR0"},
	{27, "SRR1"},
	{284, "TBLW"},
	{285, "TBUW"},	
	{22, "DEC"},
	{282, "EAR"},
	{1008, "HID0"},
	{1009, "HID1"},
	{976, "DMISS"},
	{977, "DCMP"},
	{978, "HASH1"},
	{979, "HASH2"},
	{980, "IMISS"},
	{981, "ICMP"},
	{982, "RPA"},
	{1010, "IABR"},
	{1013, "DABR"},
	{0,0},
};

static int
shmask(uvlong *m)
{
	int i;

	for(i=0; i&lt;63; i++)
		if(*m &amp; ((uvlong)1&lt;&lt;i))
			break;
	if(i &gt; 63)
		return 0;
	if(*m &amp; ~((uvlong)1&lt;&lt;i)){	/* more than one bit: do multiples of bytes */
		i = (i/8)*8;
		if(i == 0)
			return 0;
	}
	*m &gt;&gt;= i;
	return i;
}

static void
format(char *mnemonic, Instr *i, char *f)
{
	int n, s;
	ulong mask;
	uvlong vmask;

	if (mnemonic)
		format(0, i, mnemonic);
	if (f == 0)
		return;
	if (mnemonic)
		bprint(i, "\t");
	for ( ; *f; f++) {
		if (*f != '%') {
			bprint(i, "%c", *f);
			continue;
		}
		switch (*++f) {

		case 'a':
			bprint(i, "%d", i-&gt;ra);
			break;

		case 'b':
			bprint(i, "%d", i-&gt;rb);
			break;

		case 'c':
			bprint(i, "%d", i-&gt;frc);
			break;

		case 'd':
		case 's':
			bprint(i, "%d", i-&gt;rd);
			break;

		case 'C':
			if(i-&gt;rc)
				bprint(i, "CC");
			break;

		case 'D':
			if(i-&gt;rd &amp; 3)
				bprint(i, "CR(INVAL:%d)", i-&gt;rd);
			else if(i-&gt;op == 63)
				bprint(i, "FPSCR(%d)", i-&gt;crfd);
			else
				bprint(i, "CR(%d)", i-&gt;crfd);
			break;

		case 'e':
			bprint(i, "%d", i-&gt;xsh);
			break;

		case 'E':
			switch(IBF(i-&gt;w0,27,30)){	/* low bit is top bit of shift in rldiX cases */
			case 8:	i-&gt;mb = i-&gt;xmbe; i-&gt;me = 63; break;	/* rldcl */
			case 9:	i-&gt;mb = 0; i-&gt;me = i-&gt;xmbe; break;	/* rldcr */
			case 4: case 5:
					i-&gt;mb = i-&gt;xmbe; i-&gt;me = 63-i-&gt;xsh; break;	/* rldic */
			case 0: case 1:
					i-&gt;mb = i-&gt;xmbe; i-&gt;me = 63; break;	/* rldicl */
			case 2: case 3:
					i-&gt;mb = 0; i-&gt;me = i-&gt;xmbe; break;	/* rldicr */
			case 6: case 7:
					i-&gt;mb = i-&gt;xmbe; i-&gt;me = 63-i-&gt;xsh; break;	/* rldimi */
			}
			vmask = (~(uvlong)0&gt;&gt;i-&gt;mb) &amp; (~(uvlong)0&lt;&lt;(63-i-&gt;me));
			s = shmask(&amp;vmask);
			if(s)
				bprint(i, "(%llux&lt;&lt;%d)", vmask, s);
			else
				bprint(i, "%llux", vmask);
			break;

		case 'i':
			bprint(i, "$%d", i-&gt;simm);
			break;

		case 'I':
			bprint(i, "$%ux", i-&gt;uimm);
			break;

		case 'j':
			if(i-&gt;aa)
				pglobal(i, i-&gt;li, 1, "(SB)");
			else
				pglobal(i, i-&gt;addr+i-&gt;li, 1, "");
			break;

		case 'J':
			if(i-&gt;aa)
				pglobal(i, i-&gt;bd, 1, "(SB)");
			else
				pglobal(i, i-&gt;addr+i-&gt;bd, 1, "");
			break;

		case 'k':
			bprint(i, "%d", i-&gt;sh);
			break;

		case 'K':
			bprint(i, "$%x", i-&gt;imm);
			break;

		case 'L':
			if(i-&gt;lk)
				bprint(i, "L");
			break;

		case 'l':
			if(i-&gt;simm &lt; 0)
				bprint(i, "-%x(R%d)", -i-&gt;simm, i-&gt;ra);
			else
				bprint(i, "%x(R%d)", i-&gt;simm, i-&gt;ra);
			break;

		case 'm':
			bprint(i, "%ux", i-&gt;crm);
			break;

		case 'M':
			bprint(i, "%ux", i-&gt;fm);
			break;

		case 'n':
			bprint(i, "%d", i-&gt;nb==0? 32: i-&gt;nb);	/* eg, pg 10-103 */
			break;

		case 'P':
			n = ((i-&gt;spr&amp;0x1f)&lt;&lt;5)|((i-&gt;spr&gt;&gt;5)&amp;0x1f);
			for(s=0; sprname[s].name; s++)
				if(sprname[s].n == n)
					break;
			if(sprname[s].name) {
				if(s &lt; 10)
					bprint(i, sprname[s].name);
				else
					bprint(i, "SPR(%s)", sprname[s].name);
			} else
				bprint(i, "SPR(%d)", n);
			break;

		case 'Q':
			n = ((i-&gt;spr&amp;0x1f)&lt;&lt;5)|((i-&gt;spr&gt;&gt;5)&amp;0x1f);
			bprint(i, "%d", n);
			break;

		case 'S':
			if(i-&gt;ra &amp; 3)
				bprint(i, "CR(INVAL:%d)", i-&gt;ra);
			else if(i-&gt;op == 63)
				bprint(i, "FPSCR(%d)", i-&gt;crfs);
			else
				bprint(i, "CR(%d)", i-&gt;crfs);
			break;

		case 'U':
			if(i-&gt;rc)
				bprint(i, "U");
			break;

		case 'V':
			if(i-&gt;oe)
				bprint(i, "V");
			break;

		case 'w':
			bprint(i, "[%lux]", i-&gt;w0);
			break;

		case 'W':
			if(i-&gt;m64)
				bprint(i, "W");
			break;

		case 'Z':
			if(i-&gt;m64)
				bprint(i, "Z");
			break;

		case 'z':
			if(i-&gt;mb &lt;= i-&gt;me)
				mask = ((ulong)~0L&gt;&gt;i-&gt;mb) &amp; (~0L&lt;&lt;(31-i-&gt;me));
			else
				mask = ~(((ulong)~0L&gt;&gt;(i-&gt;me+1)) &amp; (~0L&lt;&lt;(31-(i-&gt;mb-1))));
			bprint(i, "%lux", mask);
			break;

		case '\0':
			bprint(i, "%%");
			return;

		default:
			bprint(i, "%%%c", *f);
			break;
		}
	}
}

static int
printins(Map *map, uvlong pc, char *buf, int n)
{
	Instr i;
	Opcode *o;

	mymap = map;
	memset(&amp;i, 0, sizeof(i));
	i.curr = buf;
	i.end = buf+n-1;
	if(mkinstr(pc, &amp;i) &lt; 0)
		return -1;
	for(o = opcodes; o-&gt;mnemonic != 0; o++)
		if(i.op == o-&gt;op &amp;&amp; (i.xo &amp; o-&gt;xomask) == o-&gt;xo) {
			if (o-&gt;f)
				(*o-&gt;f)(o, &amp;i);
			else
				format(o-&gt;mnemonic, &amp;i, o-&gt;ken);
			return i.size*4;
		}
	bprint(&amp;i, "unknown %lux", i.w0);
	return i.size*4;
}

static int
powerinst(Map *map, uvlong pc, char modifier, char *buf, int n)
{
	USED(modifier);
	return printins(map, pc, buf, n);
}

static int
powerdas(Map *map, uvlong pc, char *buf, int n)
{
	Instr instr;

	mymap = map;
	memset(&amp;instr, 0, sizeof(instr));
	instr.curr = buf;
	instr.end = buf+n-1;
	if (mkinstr(pc, &amp;instr) &lt; 0)
		return -1;
	if (instr.end-instr.curr &gt; 8)
		instr.curr = _hexify(instr.curr, instr.w0, 7);
	if (instr.end-instr.curr &gt; 9 &amp;&amp; instr.size == 2) {
		*instr.curr++ = ' ';
		instr.curr = _hexify(instr.curr, instr.w1, 7);
	}
	*instr.curr = 0;
	return instr.size*4;
}

static int
powerinstlen(Map *map, uvlong pc)
{
	Instr i;

	mymap = map;
	if (mkinstr(pc, &amp;i) &lt; 0)
		return -1;
	return i.size*4;
}

static int
powerfoll(Map *map, uvlong pc, Rgetter rget, uvlong *foll)
{
	char *reg;
	Instr i;

	mymap = map;
	if (mkinstr(pc, &amp;i) &lt; 0)
		return -1;
	foll[0] = pc+4;
	foll[1] = pc+4;
	switch(i.op) {
	default:
		return 1;

	case 18:	/* branch */
		foll[0] = i.li;
		if(!i.aa)
			foll[0] += pc;
		break;
			
	case 16:	/* conditional branch */
		foll[0] = i.bd;
		if(!i.aa)
			foll[0] += pc;
		break;

	case 19:	/* conditional branch to register */
		if(i.xo == 528)
			reg = "CTR";
		else if(i.xo == 16)
			reg = "LR";
		else
			return 1;	/* not a branch */
		foll[0] = (*rget)(map, reg);
		break;
	}
	if(i.lk)
		return 2;
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

