<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/vcodas.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/vcodas.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

	/* mips native disassembler */

typedef struct {
	uvlong addr;			/* pc of instr */
	uchar op;			/* bits 31-26 */
	uchar rs;			/* bits 25-21 */
	uchar rt;			/* bits 20-16 */
	uchar rd;			/* bits 15-11 */
	uchar sa;			/* bits 10-6 */
	uchar function;			/* bits 5-0 */
	long immediate;			/* bits 15-0 */
	ulong cofun;			/* bits 24-0 */
	ulong target;			/* bits 25-0 */
	long w0;
	char *curr;			/* current fill point */
	char *end;			/* end of buffer */
	char *err;
} Instr;

typedef struct {
	char *mnemonic;
	char *mipsco;
} Opcode;

static char mipscoload[] = "r%t,%l";
static char mipscoalui[] = "r%t,r%s,%i";
static char mipscoalu3op[] = "r%d,r%s,r%t";
static char mipscoboc[] = "r%s,r%t,%b";
static char mipscoboc0[] = "r%s,%b";
static char mipscorsrt[] = "r%s,r%t";
static char mipscorsi[] = "r%s,%i";
static char mipscoxxx[] = "%w";
static char mipscofp3[] = "f%a,f%d,f%t";	/* fd,fs,ft */
static char mipscofp2[] = "f%a,f%d";		/* fd,fs */
static char mipscofpc[] = "f%d,f%t";		/* fs,ft */

static Opcode opcodes[64] = {
	0,		0,
	0,		0,
	"j",		"%j",
	"jal",		"%j",
	"beq",		mipscoboc,
	"bne",		mipscoboc,
	"blez",		mipscoboc0,
	"bgtz",		mipscoboc0,
	"addi",		mipscoalui,
	"addiu",	mipscoalui,
	"slti",		mipscoalui,
	"sltiu",	mipscoalui,
	"andi",		mipscoalui,
	"ori",		mipscoalui,
	"xori",		mipscoalui,
	"lui",		"r%t,%u",
	"cop0",		0,
	"cop1",		0,
	"cop2",		0,
	"cop3",		0,
	"beql",		mipscoboc,
	"bnel",		mipscoboc,
	"blezl",	mipscoboc0,
	"bgtzl",	mipscoboc0,
	"instr18",	mipscoxxx,
	"instr19",	mipscoxxx,
	"instr1A",	mipscoxxx,
	"instr1B",	mipscoxxx,
	"instr1C",	mipscoxxx,
	"instr1D",	mipscoxxx,
	"instr1E",	mipscoxxx,
	"instr1F",	mipscoxxx,
	"lb",		mipscoload,
	"lh",		mipscoload,
	"lwl",		mipscoload,
	"lw",		mipscoload,
	"lbu",		mipscoload,
	"lhu",		mipscoload,
	"lwr",		mipscoload,
	"instr27",	mipscoxxx,
	"sb",		mipscoload,
	"sh",		mipscoload,
	"swl",		mipscoload,
	"sw",		mipscoload,
	"instr2C",	mipscoxxx,
	"instr2D",	mipscoxxx,
	"swr",		mipscoload,
	"cache",	"",
	"ll",		mipscoload,
	"lwc1",		mipscoload,
	"lwc2",		mipscoload,
	"lwc3",		mipscoload,
	"instr34",	mipscoxxx,
	"ld",		mipscoload,
	"ld",		mipscoload,
	"ld",		mipscoload,
	"sc",		mipscoload,
	"swc1",		mipscoload,
	"swc2",		mipscoload,
	"swc3",		mipscoload,
	"instr3C",	mipscoxxx,
	"sd",		mipscoload,
	"sd",		mipscoload,
	"sd",		mipscoload,
};

static Opcode sopcodes[64] = {
	"sll",		"r%d,r%t,$%a",
	"special01",	mipscoxxx,
	"srl",		"r%d,r%t,$%a",
	"sra",		"r%d,r%t,$%a",
	"sllv",		"r%d,r%t,R%s",
	"special05",	mipscoxxx,
	"srlv",		"r%d,r%t,r%s",
	"srav",		"r%d,r%t,r%s",
	"jr",		"r%s",
	"jalr",		"r%d,r%s",
	"special0A",	mipscoxxx,
	"special0B",	mipscoxxx,
	"syscall",	"",
	"break",	"",
	"special0E",	mipscoxxx,
	"sync",		"",
	"mfhi",		"r%d",
	"mthi",		"r%s",
	"mflo",		"r%d",
	"mtlo",		"r%s",
	"special14",	mipscoxxx,
	"special15",	mipscoxxx,
	"special16",	mipscoxxx,
	"special17",	mipscoxxx,
	"mult",		mipscorsrt,
	"multu",	mipscorsrt,
	"div",		mipscorsrt,
	"divu",		mipscorsrt,
	"special1C",	mipscoxxx,
	"special1D",	mipscoxxx,
	"special1E",	mipscoxxx,
	"special1F",	mipscoxxx,
	"add",		mipscoalu3op,
	"addu",		mipscoalu3op,
	"sub",		mipscoalu3op,
	"subu",		mipscoalu3op,
	"and",		mipscoalu3op,
	"or",		mipscoalu3op,
	"xor",		mipscoalu3op,
	"nor",		mipscoalu3op,
	"special28",	mipscoxxx,
	"special29",	mipscoxxx,
	"slt",		mipscoalu3op,
	"sltu",		mipscoalu3op,
	"special2C",	mipscoxxx,
	"special2D",	mipscoxxx,
	"special2E",	mipscoxxx,
	"special2F",	mipscoxxx,
	"tge",		mipscorsrt,
	"tgeu",		mipscorsrt,
	"tlt",		mipscorsrt,
	"tltu",		mipscorsrt,
	"teq",		mipscorsrt,
	"special35",	mipscoxxx,
	"tne",		mipscorsrt,
	"special37",	mipscoxxx,
	"special38",	mipscoxxx,
	"special39",	mipscoxxx,
	"special3A",	mipscoxxx,
	"special3B",	mipscoxxx,
	"special3C",	mipscoxxx,
	"special3D",	mipscoxxx,
	"special3E",	mipscoxxx,
	"special3F",	mipscoxxx,
};

static Opcode ropcodes[32] = {
	"bltz",		mipscoboc0,
	"bgez",		mipscoboc0,
	"bltzl",	mipscoboc0,
	"bgezl",	mipscoboc0,
	"regimm04",	mipscoxxx,
	"regimm05",	mipscoxxx,
	"regimm06",	mipscoxxx,
	"regimm07",	mipscoxxx,
	"tgei",		mipscorsi,
	"tgeiu",	mipscorsi,
	"tlti",		mipscorsi,
	"tltiu",	mipscorsi,
	"teqi",		mipscorsi,
	"regimm0D",	mipscoxxx,
	"tnei",		mipscorsi,
	"regimm0F",	mipscoxxx,
	"bltzal",	mipscoboc0,
	"bgezal",	mipscoboc0,
	"bltzall",	mipscoboc0,
	"bgezall",	mipscoboc0,
	"regimm14",	mipscoxxx,
	"regimm15",	mipscoxxx,
	"regimm16",	mipscoxxx,
	"regimm17",	mipscoxxx,
	"regimm18",	mipscoxxx,
	"regimm19",	mipscoxxx,
	"regimm1A",	mipscoxxx,
	"regimm1B",	mipscoxxx,
	"regimm1C",	mipscoxxx,
	"regimm1D",	mipscoxxx,
	"regimm1E",	mipscoxxx,
	"regimm1F",	mipscoxxx,
};

static Opcode fopcodes[64] = {
	"add.%f",	mipscofp3,
	"sub.%f",	mipscofp3,
	"mul.%f",	mipscofp3,
	"div.%f",	mipscofp3,
	"sqrt.%f",	mipscofp2,
	"abs.%f",	mipscofp2,
	"mov.%f",	mipscofp2,
	"neg.%f",	mipscofp2,
	"finstr08",	mipscoxxx,
	"finstr09",	mipscoxxx,
	"finstr0A",	mipscoxxx,
	"finstr0B",	mipscoxxx,
	"round.w.%f",	mipscofp2,
	"trunc.w%f",	mipscofp2,
	"ceil.w%f",	mipscofp2,
	"floor.w%f",	mipscofp2,
	"finstr10",	mipscoxxx,
	"finstr11",	mipscoxxx,
	"finstr12",	mipscoxxx,
	"finstr13",	mipscoxxx,
	"finstr14",	mipscoxxx,
	"finstr15",	mipscoxxx,
	"finstr16",	mipscoxxx,
	"finstr17",	mipscoxxx,
	"finstr18",	mipscoxxx,
	"finstr19",	mipscoxxx,
	"finstr1A",	mipscoxxx,
	"finstr1B",	mipscoxxx,
	"finstr1C",	mipscoxxx,
	"finstr1D",	mipscoxxx,
	"finstr1E",	mipscoxxx,
	"finstr1F",	mipscoxxx,
	"cvt.s.%f",	mipscofp2,
	"cvt.d.%f",	mipscofp2,
	"cvt.e.%f",	mipscofp2,
	"cvt.q.%f",	mipscofp2,
	"cvt.w.%f",	mipscofp2,
	"finstr25",	mipscoxxx,
	"finstr26",	mipscoxxx,
	"finstr27",	mipscoxxx,
	"finstr28",	mipscoxxx,
	"finstr29",	mipscoxxx,
	"finstr2A",	mipscoxxx,
	"finstr2B",	mipscoxxx,
	"finstr2C",	mipscoxxx,
	"finstr2D",	mipscoxxx,
	"finstr2E",	mipscoxxx,
	"finstr2F",	mipscoxxx,
	"c.f.%f",	mipscofpc,
	"c.un.%f",	mipscofpc,
	"c.eq.%f",	mipscofpc,
	"c.ueq.%f",	mipscofpc,
	"c.olt.%f",	mipscofpc,
	"c.ult.%f",	mipscofpc,
	"c.ole.%f",	mipscofpc,
	"c.ule.%f",	mipscofpc,
	"c.sf.%f",	mipscofpc,
	"c.ngle.%f",	mipscofpc,
	"c.seq.%f",	mipscofpc,
	"c.ngl.%f",	mipscofpc,
	"c.lt.%f",	mipscofpc,
	"c.nge.%f",	mipscofpc,
	"c.le.%f",	mipscofpc,
	"c.ngt.%f",	mipscofpc,
};

static char fsub[16] = {
	's', 'd', 'e', 'q', 'w', '?', '?', '?',
	'?', '?', '?', '?', '?', '?', '?', '?'
};


static int
mkinstr(Instr *i, Map *map, uvlong pc)
{
	ulong w;

	if (get4(map, pc, &amp;w) &lt; 0) {
		werrstr("can't read instruction: %r");
		return -1;
	}
	i-&gt;addr = pc;
	i-&gt;op = (w &gt;&gt; 26) &amp; 0x3F;
	i-&gt;rs = (w &gt;&gt; 21) &amp; 0x1F;
	i-&gt;rt = (w &gt;&gt; 16) &amp; 0x1F;
	i-&gt;rd = (w &gt;&gt; 11) &amp; 0x1F;
	i-&gt;sa = (w &gt;&gt; 6) &amp; 0x1F;
	i-&gt;function = w &amp; 0x3F;
	i-&gt;immediate = w &amp; 0x0000FFFF;
	if (i-&gt;immediate &amp; 0x8000)
		i-&gt;immediate |= ~0x0000FFFF;
	i-&gt;cofun = w &amp; 0x01FFFFFF;
	i-&gt;target = w &amp; 0x03FFFFFF;
	i-&gt;w0 = w;
	return 1;
}

#pragma	varargck	argpos	bprint		2

static void
bprint(Instr *i, char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	i-&gt;curr = vseprint(i-&gt;curr, i-&gt;end, fmt, arg);
	va_end(arg);
}

static void
format(char *mnemonic, Instr *i, char *f)
{
	if (mnemonic)
		format(0, i, mnemonic);
	if (f == 0)
		return;
	if (i-&gt;curr &lt; i-&gt;end)
		*i-&gt;curr++ = '\t';
	for ( ; *f &amp;&amp; i-&gt;curr &lt; i-&gt;end; f++) {
		if (*f != '%') {
			*i-&gt;curr++ = *f;
			continue;
		}
		switch (*++f) {

		case 's':
			bprint(i, "%d", i-&gt;rs);
			break;

		case 't':
			bprint(i, "%d", i-&gt;rt);
			break;

		case 'd':
			bprint(i, "%d", i-&gt;rd);
			break;

		case 'a':
			bprint(i, "%d", i-&gt;sa);
			break;

		case 'l':
			if (i-&gt;rs == 30) {
				i-&gt;curr += symoff(i-&gt;curr, i-&gt;end-i-&gt;curr, i-&gt;immediate+mach-&gt;sb, CANY);
				bprint(i, "(SB)");
			} else 
				bprint(i, "%lx(r%d)", i-&gt;immediate, i-&gt;rs);
			break;

		case 'i':
			bprint(i, "$%lx", i-&gt;immediate);
			break;

		case 'u':
			*i-&gt;curr++ = '$';
			i-&gt;curr += symoff(i-&gt;curr, i-&gt;end-i-&gt;curr, i-&gt;immediate, CANY);
			bprint(i, "(SB)");
			break;

		case 'j':
			i-&gt;curr += symoff(i-&gt;curr, i-&gt;end-i-&gt;curr,
				(i-&gt;target&lt;&lt;2)|(i-&gt;addr &amp; 0xF0000000), CANY);
			bprint(i, "(SB)");
			break;

		case 'b':
			i-&gt;curr += symoff(i-&gt;curr, i-&gt;end-i-&gt;curr,
				(i-&gt;immediate&lt;&lt;2)+i-&gt;addr+4, CANY);
			break;

		case 'c':
			bprint(i, "%lux", i-&gt;cofun);
			break;

		case 'w':
			bprint(i, "[%lux]", i-&gt;w0);
			break;

		case 'f':
			*i-&gt;curr++ = fsub[i-&gt;rs &amp; 0x0F];
			break;

		case '\0':
			*i-&gt;curr++ = '%';
			return;

		default:
			bprint(i, "%%%c", *f);
			break;
		}
	}
}

static void
copz(int cop, Instr *i)
{
	char *f, *m, buf[16];

	m = buf;
	f = "%t,%d";
	switch (i-&gt;rs) {

	case 0:
		sprint(buf, "mfc%d", cop);
		break;

	case 2:
		sprint(buf, "cfc%d", cop);
		break;

	case 4:
		sprint(buf, "mtc%d", cop);
		break;

	case 6:
		sprint(buf, "ctc%d", cop);
		break;

	case 8:
		f = "%b";
		switch (i-&gt;rt) {

		case 0:
			sprint(buf, "bc%df", cop);
			break;

		case 1:
			sprint(buf, "bc%dt", cop);
			break;

		case 2:
			sprint(buf, "bc%dfl", cop);
			break;

		case 3:
			sprint(buf, "bc%dtl", cop);
			break;

		default:
			sprint(buf, "cop%d", cop);
			f = mipscoxxx;
			break;
		}
		break;

	default:
		sprint(buf, "cop%d", cop);
		if (i-&gt;rs &amp; 0x10)
			f = "function %c";
		else
			f = mipscoxxx;
		break;
	}
	format(m, i, f);
}

static void
cop0(Instr *i)
{
	char *m = 0;

	if (i-&gt;rs &gt;= 0x10) {
		switch (i-&gt;cofun) {
	
		case 1:
			m = "tlbr";
			break;
	
		case 2:
			m = "tlbwi";
			break;
	
		case 6:
			m = "tlbwr";
			break;
	
		case 8:
			m = "tlbp";
			break;
	
		case 16:
			m = "rfe";
			break;
	
		case 24:
			m = "eret";
			break;
	
		case 32:
			m = "wait";
			break;
		}
		if (m) {
			format(m, i, 0);
			if (i-&gt;curr &lt; i-&gt;end)
				*i-&gt;curr++ = 0;
			return;
		}
	}
	copz(0, i);
}

int
_mipscoinst(Map *map, uvlong pc, char *buf, int n)
{
	Instr i;
	Opcode *o;
	uchar op;

	i.curr = buf;
	i.end = buf+n-1;
	if (mkinstr(&amp;i, map, pc) &lt; 0)
		return -1;
	switch (i.op) {

	case 0x00:					/* SPECIAL */
		o = sopcodes;
		op = i.function;
		break;

	case 0x01:					/* REGIMM */
		o = ropcodes;
		op = i.rt;
		break;

	case 0x10:					/* COP0 */
		cop0(&amp;i);
		return 4;

	case 0x11:					/* COP1 */
		if (i.rs &amp; 0x10) {
			o = fopcodes;
			op = i.function;
			break;
		}
		/*FALLTHROUGH*/
	case 0x12:					/* COP2 */
	case 0x13:					/* COP3 */
		copz(i.op-0x10, &amp;i);
		return 4;

	default:
		o = opcodes;
		op = i.op;
		break;
	}
	format(o[op].mnemonic, &amp;i, o[op].mipsco);
	return 4;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

