<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmemdraw/drawtest.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmemdraw/drawtest.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;

#define DBG if(0)
#define RGB2K(r,g,b)	((299*((ulong)(r))+587*((ulong)(g))+114*((ulong)(b)))/1000)

/*
 * This program tests the 'memimagedraw' primitive stochastically.
 * It tests the combination aspects of it thoroughly, but since the
 * three images it uses are disjoint, it makes no check of the
 * correct behavior when images overlap.  That is, however, much
 * easier to get right and to test.
 */

void	drawonepixel(Memimage*, Point, Memimage*, Point, Memimage*, Point);
void	verifyone(void);
void	verifyline(void);
void	verifyrect(void);
void	verifyrectrepl(int, int);
void putpixel(Memimage *img, Point pt, ulong nv);
ulong rgbatopix(uchar, uchar, uchar, uchar);

char *dchan, *schan, *mchan;
int dbpp, sbpp, mbpp;

int drawdebug=0;
int	seed;
int	niters = 100;
int	dbpp;	/* bits per pixel in destination */
int	sbpp;	/* bits per pixel in src */
int	mbpp;	/* bits per pixel in mask */
int	dpm;	/* pixel mask at high part of byte, in destination */
int	nbytes;	/* in destination */

int	Xrange	= 64;
int	Yrange	= 8;

Memimage	*dst;
Memimage	*src;
Memimage	*mask;
Memimage	*stmp;
Memimage	*mtmp;
Memimage	*ones;
uchar	*dstbits;
uchar	*srcbits;
uchar	*maskbits;
ulong	*savedstbits;

void
rdb(void)
{
}

int
iprint(char *fmt, ...)
{
	int n;	
	va_list va;
	char buf[1024];

	va_start(va, fmt);
	n = vseprint(buf, buf+sizeof buf, fmt, va) - buf;
	va_end(va);

	write(1,buf,n);
	return 1;
}

void
main(int argc, char *argv[])
{
	memimageinit();
	seed = time(0);

	ARGBEGIN{
	case 'x':
		Xrange = atoi(ARGF());
		break;
	case 'y':
		Yrange = atoi(ARGF());
		break;
	case 'n':
		niters = atoi(ARGF());
		break;
	case 's':
		seed = atoi(ARGF());
		break;
	}ARGEND

	dchan = "r8g8b8";
	schan = "r8g8b8";
	mchan = "r8g8b8";
	switch(argc){
	case 3:	mchan = argv[2];
	case 2:	schan = argv[1];
	case 1:	dchan = argv[0];
	case 0:	break;
	default:	goto Usage;
	Usage:
		fprint(2, "usage: dtest [dchan [schan [mchan]]]\n");
		exits("usage");
	}

//	fmtinstall('b', numbconv);	/* binary! */

	fprint(2, "%s -x %d -y %d -s 0x%x %s %s %s\n", argv0, Xrange, Yrange, seed, dchan, schan, mchan);
	srand(seed);

	dst = allocmemimage(Rect(0, 0, Xrange, Yrange), strtochan(dchan));
	src = allocmemimage(Rect(0, 0, Xrange, Yrange), strtochan(schan));
	mask = allocmemimage(Rect(0, 0, Xrange, Yrange), strtochan(mchan));
	stmp = allocmemimage(Rect(0, 0, Xrange, Yrange), strtochan(schan));
	mtmp = allocmemimage(Rect(0, 0, Xrange, Yrange), strtochan(mchan));
	ones = allocmemimage(Rect(0, 0, Xrange, Yrange), strtochan(mchan));
//	print("chan %lux %lux %lux %lux %lux %lux\n", dst-&gt;chan, src-&gt;chan, mask-&gt;chan, stmp-&gt;chan, mtmp-&gt;chan, ones-&gt;chan);
	if(dst==0 || src==0 || mask==0 || mtmp==0 || ones==0) {
	Alloc:
		fprint(2, "dtest: allocation failed: %r\n");
		exits("alloc");
	}
	nbytes = (4*Xrange+4)*Yrange;
	srcbits = malloc(nbytes);
	dstbits = malloc(nbytes);
	maskbits = malloc(nbytes);
	savedstbits = malloc(nbytes);
	if(dstbits==0 || srcbits==0 || maskbits==0 || savedstbits==0)
		goto Alloc;
	dbpp = dst-&gt;depth;
	sbpp = src-&gt;depth;
	mbpp = mask-&gt;depth;
	dpm = 0xFF ^ (0xFF&gt;&gt;dbpp);
	memset(ones-&gt;data-&gt;bdata, 0xFF, ones-&gt;width*sizeof(ulong)*Yrange);


	fprint(2, "dtest: verify single pixel operation\n");
	verifyone();

	fprint(2, "dtest: verify full line non-replicated\n");
	verifyline();

	fprint(2, "dtest: verify full rectangle non-replicated\n");
	verifyrect();

	fprint(2, "dtest: verify full rectangle source replicated\n");
	verifyrectrepl(1, 0);

	fprint(2, "dtest: verify full rectangle mask replicated\n");
	verifyrectrepl(0, 1);

	fprint(2, "dtest: verify full rectangle source and mask replicated\n");
	verifyrectrepl(1, 1);

	exits(0);
}

/*
 * Dump out an ASCII representation of an image.  The label specifies
 * a list of characters to put at various points in the picture.
 */
static void
Bprintr5g6b5(Biobuf *bio, char*, ulong v)
{
	int r,g,b;
	r = (v&gt;&gt;11)&amp;31;
	g = (v&gt;&gt;5)&amp;63;
	b = v&amp;31;
	Bprint(bio, "%.2x%.2x%.2x", r,g,b);
}

static void
Bprintr5g5b5a1(Biobuf *bio, char*, ulong v)
{
	int r,g,b,a;
	r = (v&gt;&gt;11)&amp;31;
	g = (v&gt;&gt;6)&amp;31;
	b = (v&gt;&gt;1)&amp;31;
	a = v&amp;1;
	Bprint(bio, "%.2x%.2x%.2x%.2x", r,g,b,a);
}

void
dumpimage(char *name, Memimage *img, void *vdata, Point labelpt)
{
	Biobuf b;
	uchar *data;
	uchar *p;
	char *arg;
	void (*fmt)(Biobuf*, char*, ulong);
	int npr, x, y, nb, bpp;
	ulong v, mask;
	Rectangle r;

	fmt = nil;
	arg = nil;
	switch(img-&gt;depth){
	case 1:
	case 2:
	case 4:
		fmt = (void(*)(Biobuf*,char*,ulong))Bprint;
		arg = "%.1ux";
		break;
	case 8:
		fmt = (void(*)(Biobuf*,char*,ulong))Bprint;
		arg = "%.2ux";
		break;
	case 16:
		arg = nil;
		if(img-&gt;chan == RGB16)
			fmt = Bprintr5g6b5;
		else{
			fmt = (void(*)(Biobuf*,char*,ulong))Bprint;
			arg = "%.4ux";
		}
		break;
	case 24:
		fmt = (void(*)(Biobuf*,char*,ulong))Bprint;
		arg = "%.6lux";
		break;
	case 32:
		fmt = (void(*)(Biobuf*,char*,ulong))Bprint;
		arg = "%.8lux";
		break;
	}
	if(fmt == nil){
		fprint(2, "bad format\n");
		abort();
	}

	r  = img-&gt;r;
	Binit(&amp;b, 2, OWRITE);
	data = vdata;
	bpp = img-&gt;depth;
	Bprint(&amp;b, "%s\t%d\tr %R clipr %R repl %d data %p *%P\n", name, r.min.x, r, img-&gt;clipr, (img-&gt;flags&amp;Frepl) ? 1 : 0, vdata, labelpt);
	mask = (1ULL&lt;&lt;bpp)-1;
//	for(y=r.min.y; y&lt;r.max.y; y++){
	for(y=0; y&lt;Yrange; y++){
		nb = 0;
		v = 0;
		p = data+(byteaddr(img, Pt(0,y))-(uchar*)img-&gt;data-&gt;bdata);
		Bprint(&amp;b, "%-4d\t", y);
//		for(x=r.min.x; x&lt;r.max.x; x++){
		for(x=0; x&lt;Xrange; x++){
			if(x==0)
				Bprint(&amp;b, "\t");

			if(x != 0 &amp;&amp; (x%8)==0)
				Bprint(&amp;b, " ");

			npr = 0;
			if(x==labelpt.x &amp;&amp; y==labelpt.y){
				Bprint(&amp;b, "*");
				npr++;
			}
			if(npr == 0)
				Bprint(&amp;b, " ");

			while(nb &lt; bpp){
				v &amp;= (1&lt;&lt;nb)-1;
				v |= (ulong)(*p++) &lt;&lt; nb;
				nb += 8;
			}
			nb -= bpp;
//			print("bpp %d v %.8lux mask %.8lux nb %d\n", bpp, v, mask, nb);
			fmt(&amp;b, arg, (v&gt;&gt;nb)&amp;mask);
		}
		Bprint(&amp;b, "\n");
	}
	Bterm(&amp;b);
}

/*
 * Verify that the destination pixel has the specified value.
 * The value is in the high bits of v, suitably masked, but must
 * be extracted from the destination Memimage.
 */
void
checkone(Point p, Point sp, Point mp)
{
	int delta;
	uchar *dp, *sdp;

	delta = (uchar*)byteaddr(dst, p)-(uchar*)dst-&gt;data-&gt;bdata;
	dp = (uchar*)dst-&gt;data-&gt;bdata+delta;
	sdp = (uchar*)savedstbits+delta;

	if(memcmp(dp, sdp, (dst-&gt;depth+7)/8) != 0) {
		fprint(2, "dtest: one bad pixel drawing at dst %P from source %P mask %P\n", p, sp, mp);
		fprint(2, " %.2ux %.2ux %.2ux %.2ux should be %.2ux %.2ux %.2ux %.2ux\n",
			dp[0], dp[1], dp[2], dp[3], sdp[0], sdp[1], sdp[2], sdp[3]);
		fprint(2, "addresses dst %p src %p mask %p\n", dp, byteaddr(src, sp), byteaddr(mask, mp));
		dumpimage("src", src, src-&gt;data-&gt;bdata, sp);
		dumpimage("mask", mask, mask-&gt;data-&gt;bdata, mp);
		dumpimage("origdst", dst, dstbits, p);
		dumpimage("dst", dst, dst-&gt;data-&gt;bdata, p);
		dumpimage("gooddst", dst, savedstbits, p);
		abort();
	}
}

/*
 * Verify that the destination line has the same value as the saved line.
 */
#define RECTPTS(r) (r).min.x, (r).min.y, (r).max.x, (r).max.y
void
checkline(Rectangle r, Point sp, Point mp, int y, Memimage *stmp, Memimage *mtmp)
{
	ulong *dp;
	int nb;
	ulong *saved;

	dp = wordaddr(dst, Pt(0, y));
	saved = savedstbits + y*dst-&gt;width;
	if(dst-&gt;depth &lt; 8)
		nb = Xrange/(8/dst-&gt;depth);
	else
		nb = Xrange*(dst-&gt;depth/8);
	if(memcmp(dp, saved, nb) != 0){
		fprint(2, "dtest: bad line at y=%d; saved %p dp %p\n", y, saved, dp);
		fprint(2, "draw dst %R src %P mask %P\n", r, sp, mp);
		dumpimage("src", src, src-&gt;data-&gt;bdata, sp);
		if(stmp) dumpimage("stmp", stmp, stmp-&gt;data-&gt;bdata, sp);
		dumpimage("mask", mask, mask-&gt;data-&gt;bdata, mp);
		if(mtmp) dumpimage("mtmp", mtmp, mtmp-&gt;data-&gt;bdata, mp);
		dumpimage("origdst", dst, dstbits, r.min);
		dumpimage("dst", dst, dst-&gt;data-&gt;bdata, r.min);
		dumpimage("gooddst", dst, savedstbits, r.min);
		abort();
	}
}

/*
 * Fill the bits of an image with random data.
 * The Memimage parameter is used only to make sure
 * the data is well formatted: only ucbits is written.
 */
void
fill(Memimage *img, uchar *ucbits)
{
	int i, x, y;
	ushort *up;
	uchar alpha, r, g, b;
	void *data;

	if((img-&gt;flags&amp;Falpha) == 0){
		up = (ushort*)ucbits;
		for(i=0; i&lt;nbytes/2; i++)
			*up++ = lrand() &gt;&gt; 7;
		if(i+i != nbytes)
			*(uchar*)up = lrand() &gt;&gt; 7;
	}else{
		data = img-&gt;data-&gt;bdata;
		img-&gt;data-&gt;bdata = ucbits;

		for(x=img-&gt;r.min.x; x&lt;img-&gt;r.max.x; x++)
		for(y=img-&gt;r.min.y; y&lt;img-&gt;r.max.y; y++){
			alpha = rand() &gt;&gt; 4;
			r = rand()%(alpha+1);
			g = rand()%(alpha+1);
			b = rand()%(alpha+1);
			putpixel(img, Pt(x,y), rgbatopix(r,g,b,alpha));
		}
		img-&gt;data-&gt;bdata = data;
	}
		
}

/*
 * Mask is preset; do the rest
 */
void
verifyonemask(void)
{
	Point dp, sp, mp;

	fill(dst, dstbits);
	fill(src, srcbits);
	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);
	memmove(src-&gt;data-&gt;bdata, srcbits, src-&gt;width*sizeof(ulong)*Yrange);
	memmove(mask-&gt;data-&gt;bdata, maskbits, mask-&gt;width*sizeof(ulong)*Yrange);

	dp.x = nrand(Xrange);
	dp.y = nrand(Yrange);

	sp.x = nrand(Xrange);
	sp.y = nrand(Yrange);

	mp.x = nrand(Xrange);
	mp.y = nrand(Yrange);

	drawonepixel(dst, dp, src, sp, mask, mp);
	memmove(mask-&gt;data-&gt;bdata, maskbits, mask-&gt;width*sizeof(ulong)*Yrange);
	memmove(savedstbits, dst-&gt;data-&gt;bdata, dst-&gt;width*sizeof(ulong)*Yrange);
	
	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);
	memimagedraw(dst, Rect(dp.x, dp.y, dp.x+1, dp.y+1), src, sp, mask, mp, SoverD);
	memmove(mask-&gt;data-&gt;bdata, maskbits, mask-&gt;width*sizeof(ulong)*Yrange);

	checkone(dp, sp, mp);
}

void
verifyone(void)
{
	int i;

	/* mask all zeros */
	memset(maskbits, 0, nbytes);
	for(i=0; i&lt;niters; i++)
		verifyonemask();

	/* mask all ones */
	memset(maskbits, 0xFF, nbytes);
	for(i=0; i&lt;niters; i++)
		verifyonemask();

	/* random mask */
	for(i=0; i&lt;niters; i++){
		fill(mask, maskbits);
		verifyonemask();
	}
}

/*
 * Mask is preset; do the rest
 */
void
verifylinemask(void)
{
	Point sp, mp, tp, up;
	Rectangle dr;
	int x;

	fill(dst, dstbits);
	fill(src, srcbits);
	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);
	memmove(src-&gt;data-&gt;bdata, srcbits, src-&gt;width*sizeof(ulong)*Yrange);
	memmove(mask-&gt;data-&gt;bdata, maskbits, mask-&gt;width*sizeof(ulong)*Yrange);

	dr.min.x = nrand(Xrange-1);
	dr.min.y = nrand(Yrange-1);
	dr.max.x = dr.min.x + 1 + nrand(Xrange-1-dr.min.x);
	dr.max.y = dr.min.y + 1;

	sp.x = nrand(Xrange);
	sp.y = nrand(Yrange);

	mp.x = nrand(Xrange);
	mp.y = nrand(Yrange);

	tp = sp;
	up = mp;
	for(x=dr.min.x; x&lt;dr.max.x &amp;&amp; tp.x&lt;Xrange &amp;&amp; up.x&lt;Xrange; x++,tp.x++,up.x++)
		memimagedraw(dst, Rect(x, dr.min.y, x+1, dr.min.y+1), src, tp, mask, up, SoverD);
	memmove(savedstbits, dst-&gt;data-&gt;bdata, dst-&gt;width*sizeof(ulong)*Yrange);

	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);

	memimagedraw(dst, dr, src, sp, mask, mp, SoverD);
	checkline(dr, drawrepl(src-&gt;r, sp), drawrepl(mask-&gt;r, mp), dr.min.y, nil, nil);
}

void
verifyline(void)
{
	int i;

	/* mask all ones */
	memset(maskbits, 0xFF, nbytes);
	for(i=0; i&lt;niters; i++)
		verifylinemask();

	/* mask all zeros */
	memset(maskbits, 0, nbytes);
	for(i=0; i&lt;niters; i++)
		verifylinemask();

	/* random mask */
	for(i=0; i&lt;niters; i++){
		fill(mask, maskbits);
		verifylinemask();
	}
}

/*
 * Mask is preset; do the rest
 */
void
verifyrectmask(void)
{
	Point sp, mp, tp, up;
	Rectangle dr;
	int x, y;

	fill(dst, dstbits);
	fill(src, srcbits);
	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);
	memmove(src-&gt;data-&gt;bdata, srcbits, src-&gt;width*sizeof(ulong)*Yrange);
	memmove(mask-&gt;data-&gt;bdata, maskbits, mask-&gt;width*sizeof(ulong)*Yrange);

	dr.min.x = nrand(Xrange-1);
	dr.min.y = nrand(Yrange-1);
	dr.max.x = dr.min.x + 1 + nrand(Xrange-1-dr.min.x);
	dr.max.y = dr.min.y + 1 + nrand(Yrange-1-dr.min.y);

	sp.x = nrand(Xrange);
	sp.y = nrand(Yrange);

	mp.x = nrand(Xrange);
	mp.y = nrand(Yrange);

	tp = sp;
	up = mp;
	for(y=dr.min.y; y&lt;dr.max.y &amp;&amp; tp.y&lt;Yrange &amp;&amp; up.y&lt;Yrange; y++,tp.y++,up.y++){
		for(x=dr.min.x; x&lt;dr.max.x &amp;&amp; tp.x&lt;Xrange &amp;&amp; up.x&lt;Xrange; x++,tp.x++,up.x++)
			memimagedraw(dst, Rect(x, y, x+1, y+1), src, tp, mask, up, SoverD);
		tp.x = sp.x;
		up.x = mp.x;
	}
	memmove(savedstbits, dst-&gt;data-&gt;bdata, dst-&gt;width*sizeof(ulong)*Yrange);

	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);

	memimagedraw(dst, dr, src, sp, mask, mp, SoverD);
	for(y=0; y&lt;Yrange; y++)
		checkline(dr, drawrepl(src-&gt;r, sp), drawrepl(mask-&gt;r, mp), y, nil, nil);
}

void
verifyrect(void)
{
	int i;

	/* mask all zeros */
	memset(maskbits, 0, nbytes);
	for(i=0; i&lt;niters; i++)
		verifyrectmask();

	/* mask all ones */
	memset(maskbits, 0xFF, nbytes);
	for(i=0; i&lt;niters; i++)
		verifyrectmask();

	/* random mask */
	for(i=0; i&lt;niters; i++){
		fill(mask, maskbits);
		verifyrectmask();
	}
}

Rectangle
randrect(void)
{
	Rectangle r;

	r.min.x = nrand(Xrange-1);
	r.min.y = nrand(Yrange-1);
	r.max.x = r.min.x + 1 + nrand(Xrange-1-r.min.x);
	r.max.y = r.min.y + 1 + nrand(Yrange-1-r.min.y);
	return r;
}

/*
 * Return coordinate corresponding to x withing range [minx, maxx)
 */
int
tilexy(int minx, int maxx, int x)
{
	int sx;

	sx = (x-minx) % (maxx-minx);
	if(sx &lt; 0)
		sx += maxx-minx;
	return sx+minx;
}

void
replicate(Memimage *i, Memimage *tmp)
{
	Rectangle r, r1;
	int x, y, nb;

	/* choose the replication window (i-&gt;r) */
	r.min.x = nrand(Xrange-1);
	r.min.y = nrand(Yrange-1);
	/* make it trivial more often than pure chance allows */
	switch(lrand()&amp;0){
	case 1:
		r.max.x = r.min.x + 2;
		r.max.y = r.min.y + 2;
		if(r.max.x &lt; Xrange &amp;&amp; r.max.y &lt; Yrange)
			break;
		/* fall through */
	case 0:
		r.max.x = r.min.x + 1;
		r.max.y = r.min.y + 1;
		break;
	default:
		if(r.min.x+3 &gt;= Xrange)
			r.max.x = Xrange;
		else
			r.max.x = r.min.x+3 + nrand(Xrange-(r.min.x+3));

		if(r.min.y+3 &gt;= Yrange)
			r.max.y = Yrange;
		else
			r.max.y = r.min.y+3 + nrand(Yrange-(r.min.y+3));
	}
	assert(r.min.x &gt;= 0);	
	assert(r.max.x &lt;= Xrange);
	assert(r.min.y &gt;= 0);
	assert(r.max.y &lt;= Yrange);
	/* copy from i to tmp so we have just the replicated bits */
	nb = tmp-&gt;width*sizeof(ulong)*Yrange;
	memset(tmp-&gt;data-&gt;bdata, 0, nb);
	memimagedraw(tmp, r, i, r.min, ones, r.min, SoverD);
	memmove(i-&gt;data-&gt;bdata, tmp-&gt;data-&gt;bdata, nb);
	/* i is now a non-replicated instance of the replication */
	/* replicate it by hand through tmp */
	memset(tmp-&gt;data-&gt;bdata, 0, nb);
	x = -(tilexy(r.min.x, r.max.x, 0)-r.min.x);
	for(; x&lt;Xrange; x+=Dx(r)){
		y = -(tilexy(r.min.y, r.max.y, 0)-r.min.y);
		for(; y&lt;Yrange; y+=Dy(r)){
			/* set r1 to instance of tile by translation */
			r1.min.x = x;
			r1.min.y = y;
			r1.max.x = r1.min.x+Dx(r);
			r1.max.y = r1.min.y+Dy(r);
			memimagedraw(tmp, r1, i, r.min, ones, r.min, SoverD);
		}
	}
	i-&gt;flags |= Frepl;
	i-&gt;r = r;
	i-&gt;clipr = randrect();
//	fprint(2, "replicate [[%d %d] [%d %d]] [[%d %d][%d %d]]\n", r.min.x, r.min.y, r.max.x, r.max.y,
//		i-&gt;clipr.min.x, i-&gt;clipr.min.y, i-&gt;clipr.max.x, i-&gt;clipr.max.y);
	tmp-&gt;clipr = i-&gt;clipr;
}

/*
 * Mask is preset; do the rest
 */
void
verifyrectmaskrepl(int srcrepl, int maskrepl)
{
	Point sp, mp, tp, up;
	Rectangle dr;
	int x, y;
	Memimage *s, *m;

//	print("verfrect %d %d\n", srcrepl, maskrepl);
	src-&gt;flags &amp;= ~Frepl;
	src-&gt;r = Rect(0, 0, Xrange, Yrange);
	src-&gt;clipr = src-&gt;r;
	stmp-&gt;flags &amp;= ~Frepl;
	stmp-&gt;r = Rect(0, 0, Xrange, Yrange);
	stmp-&gt;clipr = src-&gt;r;
	mask-&gt;flags &amp;= ~Frepl;
	mask-&gt;r = Rect(0, 0, Xrange, Yrange);
	mask-&gt;clipr = mask-&gt;r;
	mtmp-&gt;flags &amp;= ~Frepl;
	mtmp-&gt;r = Rect(0, 0, Xrange, Yrange);
	mtmp-&gt;clipr = mask-&gt;r;

	fill(dst, dstbits);
	fill(src, srcbits);

	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);
	memmove(src-&gt;data-&gt;bdata, srcbits, src-&gt;width*sizeof(ulong)*Yrange);
	memmove(mask-&gt;data-&gt;bdata, maskbits, mask-&gt;width*sizeof(ulong)*Yrange);

	if(srcrepl){
		replicate(src, stmp);
		s = stmp;
	}else
		s = src;
	if(maskrepl){
		replicate(mask, mtmp);
		m = mtmp;
	}else
		m = mask;

	dr = randrect();

	sp.x = nrand(Xrange);
	sp.y = nrand(Yrange);

	mp.x = nrand(Xrange);
	mp.y = nrand(Yrange);

DBG	print("smalldraws\n");
	for(tp.y=sp.y,up.y=mp.y,y=dr.min.y; y&lt;dr.max.y &amp;&amp; tp.y&lt;Yrange &amp;&amp; up.y&lt;Yrange; y++,tp.y++,up.y++)
		for(tp.x=sp.x,up.x=mp.x,x=dr.min.x; x&lt;dr.max.x &amp;&amp; tp.x&lt;Xrange &amp;&amp; up.x&lt;Xrange; x++,tp.x++,up.x++)
			memimagedraw(dst, Rect(x, y, x+1, y+1), s, tp, m, up, SoverD);
	memmove(savedstbits, dst-&gt;data-&gt;bdata, dst-&gt;width*sizeof(ulong)*Yrange);

	memmove(dst-&gt;data-&gt;bdata, dstbits, dst-&gt;width*sizeof(ulong)*Yrange);

DBG	print("bigdraw\n");
	memimagedraw(dst, dr, src, sp, mask, mp, SoverD);
	for(y=0; y&lt;Yrange; y++)
		checkline(dr, drawrepl(src-&gt;r, sp), drawrepl(mask-&gt;r, mp), y, srcrepl?stmp:nil, maskrepl?mtmp:nil);
}

void
verifyrectrepl(int srcrepl, int maskrepl)
{
	int i;

	/* mask all ones */
	memset(maskbits, 0xFF, nbytes);
	for(i=0; i&lt;niters; i++)
		verifyrectmaskrepl(srcrepl, maskrepl);

	/* mask all zeros */
	memset(maskbits, 0, nbytes);
	for(i=0; i&lt;niters; i++)
		verifyrectmaskrepl(srcrepl, maskrepl);

	/* random mask */
	for(i=0; i&lt;niters; i++){
		fill(mask, maskbits);
		verifyrectmaskrepl(srcrepl, maskrepl);
	}
}

/*
 * Trivial draw implementation.
 * Color values are passed around as ulongs containing ααRRGGBB
 */

/*
 * Convert v, which is nhave bits wide, into its nwant bits wide equivalent.
 * Replicates to widen the value, truncates to narrow it.
 */
ulong
replbits(ulong v, int nhave, int nwant)
{
	v &amp;= (1&lt;&lt;nhave)-1;
	for(; nhave&lt;nwant; nhave*=2)
		v |= v&lt;&lt;nhave;
	v &gt;&gt;= (nhave-nwant);
	return v &amp; ((1&lt;&lt;nwant)-1);
}

/*
 * Decode a pixel into the uchar* values.
 */
void
pixtorgba(ulong v, uchar *r, uchar *g, uchar *b, uchar *a)
{
	*a = v&gt;&gt;24;
	*r = v&gt;&gt;16;
	*g = v&gt;&gt;8;
	*b = v;
}

/*
 * Convert uchar channels into ulong pixel.
 */
ulong
rgbatopix(uchar r, uchar g, uchar b, uchar a)
{
	return (a&lt;&lt;24)|(r&lt;&lt;16)|(g&lt;&lt;8)|b;
}

/*
 * Retrieve the pixel value at pt in the image.
 */
ulong
getpixel(Memimage *img, Point pt)
{
	uchar r, g, b, a, *p;
	int nbits, npack, bpp;
	ulong v, c, rbits, bits;

	r = g = b = 0;
	a = ~0;	/* default alpha is full */

	p = byteaddr(img, pt);
	v = p[0]|(p[1]&lt;&lt;8)|(p[2]&lt;&lt;16)|(p[3]&lt;&lt;24);
	bpp = img-&gt;depth;
	if(bpp&lt;8){
		/*
		 * Sub-byte greyscale pixels.
		 *
		 * We want to throw away the top pt.x%npack pixels and then use the next bpp bits
		 * in the bottom byte of v.  This madness is due to having big endian bits
		 * but little endian bytes.
		 */
		npack = 8/bpp;
		v &gt;&gt;= 8 - bpp*(pt.x%npack+1);
		v &amp;= (1&lt;&lt;bpp)-1;
		r = g = b = replbits(v, bpp, 8);
	}else{
		/*
		 * General case.  We need to parse the channel descriptor and do what it says.
		 * In all channels but the color map, we replicate to 8 bits because that's the
		 * precision that all calculations are done at.
		 *
		 * In the case of the color map, we leave the bits alone, in case a color map
		 * with less than 8 bits of index is used.  This is currently disallowed, so it's
		 * sort of silly.
		 */

		for(c=img-&gt;chan; c; c&gt;&gt;=8){
			nbits = NBITS(c);
			bits = v &amp; ((1&lt;&lt;nbits)-1);
			rbits = replbits(bits, nbits, 8);
			v &gt;&gt;= nbits;
			switch(TYPE(c)){
			case CRed:
				r = rbits;
				break;
			case CGreen:
				g = rbits;
				break;
			case CBlue:
				b = rbits;
				break;
			case CGrey:
				r = g = b = rbits;
				break;
			case CAlpha:
				a = rbits;
				break;
			case CMap:
				p = img-&gt;cmap-&gt;cmap2rgb + 3*bits;
				r = p[0];
				g = p[1];
				b = p[2];
				break;
			case CIgnore:
				break;
			default:
				fprint(2, "unknown channel type %lud\n", TYPE(c));
				abort();
			}
		}
	}
	return rgbatopix(r, g, b, a);
}

/*
 * Return the greyscale equivalent of a pixel.
 */
uchar
getgrey(Memimage *img, Point pt)
{
	uchar r, g, b, a;
	pixtorgba(getpixel(img, pt), &amp;r, &amp;g, &amp;b, &amp;a);
	return RGB2K(r, g, b);
}

/*
 * Return the value at pt in image, if image is interpreted
 * as a mask.  This means the alpha channel if present, else
 * the greyscale or its computed equivalent.
 */
uchar
getmask(Memimage *img, Point pt)
{
	if(img-&gt;flags&amp;Falpha)
		return getpixel(img, pt)&gt;&gt;24;
	else
		return getgrey(img, pt);
}
#undef DBG

#define DBG if(0)
/*
 * Write a pixel to img at point pt.
 * 
 * We do this by reading a 32-bit little endian
 * value from p and then writing it back
 * after tweaking the appropriate bits.  Because
 * the data is little endian, we don't have to worry
 * about what the actual depth is, as long as it is
 * less than 32 bits.
 */
void
putpixel(Memimage *img, Point pt, ulong nv)
{
	uchar r, g, b, a, *p, *q;
	ulong c, mask, bits, v;
	int bpp, sh, npack, nbits;

	pixtorgba(nv, &amp;r, &amp;g, &amp;b, &amp;a);

	p = byteaddr(img, pt);
	v = p[0]|(p[1]&lt;&lt;8)|(p[2]&lt;&lt;16)|(p[3]&lt;&lt;24);
	bpp = img-&gt;depth;
DBG print("v %.8lux...", v);
	if(bpp &lt; 8){
		/*
		 * Sub-byte greyscale pixels.  We need to skip the leftmost pt.x%npack pixels,
		 * which is equivalent to skipping the rightmost npack - pt.x%npack - 1 pixels.
		 */	
		npack = 8/bpp;
		sh = bpp*(npack - pt.x%npack - 1);
		bits = RGB2K(r,g,b);
DBG print("repl %lux 8 %d = %lux...", bits, bpp, replbits(bits, 8, bpp));
		bits = replbits(bits, 8, bpp);
		mask = (1&lt;&lt;bpp)-1;
DBG print("bits %lux mask %lux sh %d...", bits, mask, sh);
		mask &lt;&lt;= sh;
		bits &lt;&lt;= sh;
DBG print("(%lux &amp; %lux) | (%lux &amp; %lux)", v, ~mask, bits, mask);
		v = (v &amp; ~mask) | (bits &amp; mask);
	} else {
		/*
		 * General case.  We need to parse the channel descriptor again.
		 */
		sh = 0;
		for(c=img-&gt;chan; c; c&gt;&gt;=8){
			nbits = NBITS(c);
			switch(TYPE(c)){
			case CRed:
				bits = r;
				break;
			case CGreen:
				bits = g;
				break;
			case CBlue:
				bits = b;
				break;
			case CGrey:
				bits = RGB2K(r, g, b);
				break;
			case CAlpha:
				bits = a;
				break;
			case CIgnore:
				bits = 0;
				break;
			case CMap:
				q = img-&gt;cmap-&gt;rgb2cmap;
				bits = q[(r&gt;&gt;4)*16*16+(g&gt;&gt;4)*16+(b&gt;&gt;4)];
				break;
			default:
				SET(bits);
				fprint(2, "unknown channel type %lud\n", TYPE(c));
				abort();
			}

DBG print("repl %lux 8 %d = %lux...", bits, nbits, replbits(bits, 8, nbits));
			if(TYPE(c) != CMap)
				bits = replbits(bits, 8, nbits);
			mask = (1&lt;&lt;nbits)-1;
DBG print("bits %lux mask %lux sh %d...", bits, mask, sh);
			bits &lt;&lt;= sh;
			mask &lt;&lt;= sh;
			v = (v &amp; ~mask) | (bits &amp; mask);
			sh += nbits;
		}
	}
DBG print("v %.8lux\n", v);
	p[0] = v;
	p[1] = v&gt;&gt;8;
	p[2] = v&gt;&gt;16;
	p[3] = v&gt;&gt;24;	
}
#undef DBG

#define DBG if(0)
void
drawonepixel(Memimage *dst, Point dp, Memimage *src, Point sp, Memimage *mask, Point mp)
{
	uchar m, M, sr, sg, sb, sa, sk, dr, dg, db, da, dk;

	pixtorgba(getpixel(dst, dp), &amp;dr, &amp;dg, &amp;db, &amp;da);
	pixtorgba(getpixel(src, sp), &amp;sr, &amp;sg, &amp;sb, &amp;sa);
	m = getmask(mask, mp);
	M = 255-(sa*m)/255;

DBG print("dst %x %x %x %x src %x %x %x %x m %x = ", dr,dg,db,da, sr,sg,sb,sa, m);
	if(dst-&gt;flags&amp;Fgrey){
		/*
		 * We need to do the conversion to grey before the alpha calculation
		 * because the draw operator does this, and we need to be operating
		 * at the same precision so we get exactly the same answers.
		 */
		sk = RGB2K(sr, sg, sb);
		dk = RGB2K(dr, dg, db);
		dk = (sk*m + dk*M)/255;
		dr = dg = db = dk;
		da = (sa*m + da*M)/255;
	}else{
		/*
		 * True color alpha calculation treats all channels (including alpha)
		 * the same.  It might have been nice to use an array, but oh well.
		 */
		dr = (sr*m + dr*M)/255;
		dg = (sg*m + dg*M)/255;
		db = (sb*m + db*M)/255;
		da = (sa*m + da*M)/255;
	}

DBG print("%x %x %x %x\n", dr,dg,db,da);
	putpixel(dst, dp, rgbatopix(dr, dg, db, da));
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

