<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmemdraw/ellipse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmemdraw/ellipse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;memlayer.h&gt;

/*
 * ellipse(dst, c, a, b, t, src, sp)
 *   draws an ellipse centered at c with semiaxes a,b&gt;=0
 *   and semithickness t&gt;=0, or filled if t&lt;0.  point sp
 *   in src maps to c in dst
 *
 *   very thick skinny ellipses are brushed with circles (slow)
 *   others are approximated by filling between 2 ellipses
 *   criterion for very thick when b&lt;a: t/b &gt; 0.5*x/(1-x)
 *   where x = b/a
 */

typedef struct Param	Param;
typedef struct State	State;

static	void	bellipse(int, State*, Param*);
static	void	erect(int, int, int, int, Param*);
static	void	eline(int, int, int, int, Param*);

struct Param {
	Memimage	*dst;
	Memimage	*src;
	Point			c;
	int			t;
	Point			sp;
	Memimage	*disc;
	int			op;
};

/*
 * denote residual error by e(x,y) = b^2*x^2 + a^2*y^2 - a^2*b^2
 * e(x,y) = 0 on ellipse, e(x,y) &lt; 0 inside, e(x,y) &gt; 0 outside
 */

struct State {
	int	a;
	int	x;
	vlong	a2;	/* a^2 */
	vlong	b2;	/* b^2 */
	vlong	b2x;	/* b^2 * x */
	vlong	a2y;	/* a^2 * y */
	vlong	c1;
	vlong	c2;	/* test criteria */
	vlong	ee;	/* ee = e(x+1/2,y-1/2) - (a^2+b^2)/4 */
	vlong	dxe;
	vlong	dye;
	vlong	d2xe;
	vlong	d2ye;
};

static
State*
newstate(State *s, int a, int b)
{
	s-&gt;x = 0;
	s-&gt;a = a;
	s-&gt;a2 = (vlong)(a*a);
	s-&gt;b2 = (vlong)(b*b);
	s-&gt;b2x = (vlong)0;
	s-&gt;a2y = s-&gt;a2*(vlong)b;
	s-&gt;c1 = -((s-&gt;a2&gt;&gt;2) + (vlong)(a&amp;1) + s-&gt;b2);
	s-&gt;c2 = -((s-&gt;b2&gt;&gt;2) + (vlong)(b&amp;1));
	s-&gt;ee = -s-&gt;a2y;
	s-&gt;dxe = (vlong)0;
	s-&gt;dye = s-&gt;ee&lt;&lt;1;
	s-&gt;d2xe = s-&gt;b2&lt;&lt;1;
	s-&gt;d2ye = s-&gt;a2&lt;&lt;1;
	return s;
}

/*
 * return x coord of rightmost pixel on next scan line
 */
static
int
step(State *s)
{
	while(s-&gt;x &lt; s-&gt;a) {
		if(s-&gt;ee+s-&gt;b2x &lt;= s-&gt;c1 ||	/* e(x+1,y-1/2) &lt;= 0 */
		   s-&gt;ee+s-&gt;a2y &lt;= s-&gt;c2) {	/* e(x+1/2,y) &lt;= 0 (rare) */
			s-&gt;dxe += s-&gt;d2xe;	  
			s-&gt;ee += s-&gt;dxe;	  
			s-&gt;b2x += s-&gt;b2;
			s-&gt;x++;	  
			continue;
		}
		s-&gt;dye += s-&gt;d2ye;	  
		s-&gt;ee += s-&gt;dye;	  
		s-&gt;a2y -= s-&gt;a2;
		if(s-&gt;ee-s-&gt;a2y &lt;= s-&gt;c2) {	/* e(x+1/2,y-1) &lt;= 0 */
			s-&gt;dxe += s-&gt;d2xe;	  
			s-&gt;ee += s-&gt;dxe;	  
			s-&gt;b2x += s-&gt;b2;
			return s-&gt;x++;
		}
		break;
	}
	return s-&gt;x;	  
}

void
memellipse(Memimage *dst, Point c, int a, int b, int t, Memimage *src, Point sp, int op)
{
	State in, out;
	int y, inb, inx, outx, u;
	Param p;

	if(a &lt; 0)
		a = -a;
	if(b &lt; 0)
		b = -b;
	p.dst = dst;
	p.src = src;
	p.c = c;
	p.t = t;
	p.sp = subpt(sp, c);
	p.disc = nil;
	p.op = op;

	u = (t&lt;&lt;1)*(a-b);
	if(b&lt;a &amp;&amp; u&gt;b*b || a&lt;b &amp;&amp; -u&gt;a*a) {
/*	if(b&lt;a&amp;&amp;(t&lt;&lt;1)&gt;b*b/a || a&lt;b&amp;&amp;(t&lt;&lt;1)&gt;a*a/b)	# very thick */
		bellipse(b, newstate(&amp;in, a, b), &amp;p);
		return;
	}

	if(t &lt; 0) {
		inb = -1;
		newstate(&amp;out, a, y = b);
	} else {	
		inb = b - t;
		newstate(&amp;out, a+t, y = b+t);
	}
	if(t &gt; 0)
		newstate(&amp;in, a-t, inb);
	inx = 0;
	for( ; y&gt;=0; y--) {
		outx = step(&amp;out);
		if(y &gt; inb) {
			erect(-outx, y, outx, y, &amp;p);
			if(y != 0)
				erect(-outx, -y, outx, -y, &amp;p);
			continue;
		}
		if(t &gt; 0) {
			inx = step(&amp;in);
			if(y == inb)
				inx = 0;
		} else if(inx &gt; outx)
			inx = outx;
		erect(inx, y, outx, y, &amp;p);
		if(y != 0)
			erect(inx, -y, outx, -y, &amp;p);
		erect(-outx, y, -inx, y, &amp;p);
		if(y != 0)
			erect(-outx, -y, -inx, -y, &amp;p);
		inx = outx + 1;
	}
}

static Point p00 = {0, 0};

/*
 * a brushed ellipse
 */
static
void
bellipse(int y, State *s, Param *p)
{
	int t, ox, oy, x, nx;

	t = p-&gt;t;
	p-&gt;disc = allocmemimage(Rect(-t,-t,t+1,t+1), GREY1);
	if(p-&gt;disc == nil)
		return;
	memfillcolor(p-&gt;disc, DTransparent);
	memellipse(p-&gt;disc, p00, t, t, -1, memopaque, p00, p-&gt;op);
	oy = y;
	ox = 0;
	nx = x = step(s);
	do {
		while(nx==x &amp;&amp; y--&gt;0)
			nx = step(s);
		y++;
		eline(-x,-oy,-ox, -y, p);
		eline(ox,-oy,  x, -y, p);
		eline(-x,  y,-ox, oy, p);
		eline(ox,  y,  x, oy, p);
		ox = x+1;
		x = nx;
		y--;
		oy = y;
	} while(oy &gt; 0);
}

/*
 * a rectangle with closed (not half-open) coordinates expressed
 * relative to the center of the ellipse
 */
static
void
erect(int x0, int y0, int x1, int y1, Param *p)
{
	Rectangle r;

/*	print("R %d,%d %d,%d\n", x0, y0, x1, y1); /**/
	r = Rect(p-&gt;c.x+x0, p-&gt;c.y+y0, p-&gt;c.x+x1+1, p-&gt;c.y+y1+1);
	memdraw(p-&gt;dst, r, p-&gt;src, addpt(p-&gt;sp, r.min), memopaque, p00, p-&gt;op);
}

/*
 * a brushed point similarly specified
 */
static
void
epoint(int x, int y, Param *p)
{
	Point p0;
	Rectangle r;

/*	print("P%d %d,%d\n", p-&gt;t, x, y);	/**/
	p0 = Pt(p-&gt;c.x+x, p-&gt;c.y+y);
	r = Rpt(addpt(p0, p-&gt;disc-&gt;r.min), addpt(p0, p-&gt;disc-&gt;r.max));
	memdraw(p-&gt;dst, r, p-&gt;src, addpt(p-&gt;sp, r.min), p-&gt;disc, p-&gt;disc-&gt;r.min, p-&gt;op);
}

/* 
 * a brushed horizontal or vertical line similarly specified
 */
static
void
eline(int x0, int y0, int x1, int y1, Param *p)
{
/*	print("L%d %d,%d %d,%d\n", p-&gt;t, x0, y0, x1, y1); /**/
	if(x1 &gt; x0+1)
		erect(x0+1, y0-p-&gt;t, x1-1, y1+p-&gt;t, p);
	else if(y1 &gt; y0+1)
		erect(x0-p-&gt;t, y0+1, x1+p-&gt;t, y1-1, p);
	epoint(x0, y0, p);
	if(x1-x0 || y1-y0)
		epoint(x1, y1, p);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

