<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/liboventi/plan9-thread.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/liboventi/plan9-thread.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;oventi.h&gt;

enum
{
	QueuingW,	/* queuing for write lock */
	QueuingR,	/* queuing for read lock */
};


typedef struct Thread Thread;

struct Thread {
	int pid;
	int ref;
	char *error;
	int state;
	Thread *next;
};

struct VtLock {
	Lock lk;
	Thread *writer;		/* thread writering write lock */
	int readers;		/* number writering read lock */
	Thread *qfirst;
	Thread *qlast;
	uintptr	pc;
};

struct VtRendez {
	VtLock *lk;
	Thread *wfirst;
	Thread *wlast;
};

enum {
	ERROR = 0,
};

static Thread **vtRock;

static void	vtThreadInit(void);
static void	threadSleep(Thread*);
static void	threadWakeup(Thread*);

int
vtThread(void (*f)(void*), void *rock)
{
	int tid;

	tid = rfork(RFNOWAIT|RFMEM|RFPROC);
	switch(tid){
	case -1:
		vtOSError();
		return -1;
	case 0:
		break;
	default:
		return tid;
	}
	vtAttach();
	(*f)(rock);
	vtDetach();
	_exits(0);
	return 0;
}

static Thread *
threadLookup(void)
{
	return *vtRock;
}

void
vtAttach(void)
{
	int pid;
	Thread *p;
	static int init;
	static Lock lk;

	lock(&amp;lk);
	if(!init) {
		rfork(RFREND);
		vtThreadInit();
		init = 1;
	}
	unlock(&amp;lk);

	pid = getpid();
	p = *vtRock;
	if(p != nil &amp;&amp; p-&gt;pid == pid) {
		p-&gt;ref++;
		return;
	}
	p = vtMemAllocZ(sizeof(Thread));
	p-&gt;ref = 1;
	p-&gt;pid = pid;
	*vtRock = p;
}

void
vtDetach(void)
{
	Thread *p;

	p = *vtRock;
	assert(p != nil);
	p-&gt;ref--;
	if(p-&gt;ref == 0) {
		vtMemFree(p-&gt;error);
		vtMemFree(p);
		*vtRock = nil;
	}
}

char *
vtGetError(void)
{
	char *s;

	if(ERROR)
		fprint(2, "vtGetError: %s\n", threadLookup()-&gt;error);
	s = threadLookup()-&gt;error;
	if(s == nil)
		return "unknown error";
	return s;
}

char*
vtSetError(char* fmt, ...)
{
	Thread *p;
	char *s;
	va_list args;

	p = threadLookup();

	va_start(args, fmt);
	s = vsmprint(fmt, args);
	vtMemFree(p-&gt;error);
	p-&gt;error = s;
	va_end(args);
	if(ERROR)
		fprint(2, "vtSetError: %s\n", p-&gt;error);
	werrstr("%s", p-&gt;error);
	return p-&gt;error;
}

static void
vtThreadInit(void)
{
	static Lock lk;

	lock(&amp;lk);
	if(vtRock != nil) {
		unlock(&amp;lk);
		return;
	}
	vtRock = privalloc();
	if(vtRock == nil)
		vtFatal("can't allocate thread-private storage");
	unlock(&amp;lk);
}

VtLock*
vtLockAlloc(void)
{
	return vtMemAllocZ(sizeof(VtLock));
}

/*
 * RSC: I think the test is backward.  Let's see who uses it.
 *
void
vtLockInit(VtLock **p)
{
	static Lock lk;

	lock(&amp;lk);
	if(*p != nil)
		*p = vtLockAlloc();
	unlock(&amp;lk);
}
 */

void
vtLockFree(VtLock *p)
{
	if(p == nil)
		return;
	assert(p-&gt;writer == nil);
	assert(p-&gt;readers == 0);
	assert(p-&gt;qfirst == nil);
	vtMemFree(p);
}

VtRendez*
vtRendezAlloc(VtLock *p)
{
	VtRendez *q;

	q = vtMemAllocZ(sizeof(VtRendez));
	q-&gt;lk = p;
	setmalloctag(q, getcallerpc(&amp;p));
	return q;
}

void
vtRendezFree(VtRendez *q)
{
	if(q == nil)
		return;
	assert(q-&gt;wfirst == nil);
	vtMemFree(q);
}

int
vtCanLock(VtLock *p)
{
	Thread *t;

	lock(&amp;p-&gt;lk);
	t = *vtRock;
	if(p-&gt;writer == nil &amp;&amp; p-&gt;readers == 0) {
		p-&gt;writer = t;
		unlock(&amp;p-&gt;lk);
		return 1;
	}
	unlock(&amp;p-&gt;lk);
	return 0;
}


void
vtLock(VtLock *p)
{
	Thread *t;

	lock(&amp;p-&gt;lk);
	p-&gt;pc = getcallerpc(&amp;p);
	t = *vtRock;
	if(p-&gt;writer == nil &amp;&amp; p-&gt;readers == 0) {
		p-&gt;writer = t;
		unlock(&amp;p-&gt;lk);
		return;
	}

	/*
	 * venti currently contains code that assume locks can be passed between threads :-(
	 * assert(p-&gt;writer != t);
	 */

	if(p-&gt;qfirst == nil)
		p-&gt;qfirst = t;
	else
		p-&gt;qlast-&gt;next = t;
	p-&gt;qlast = t;
	t-&gt;next = nil;
	t-&gt;state = QueuingW;
	unlock(&amp;p-&gt;lk);

	threadSleep(t);
	assert(p-&gt;writer == t &amp;&amp; p-&gt;readers == 0);
}

int
vtCanRLock(VtLock *p)
{
	lock(&amp;p-&gt;lk);
	if(p-&gt;writer == nil &amp;&amp; p-&gt;qfirst == nil) {
		p-&gt;readers++;
		unlock(&amp;p-&gt;lk);
		return 1;
	}
	unlock(&amp;p-&gt;lk);
	return 0;
}

void
vtRLock(VtLock *p)
{
	Thread *t;

	lock(&amp;p-&gt;lk);
	t = *vtRock;
	if(p-&gt;writer == nil &amp;&amp; p-&gt;qfirst == nil) {
		p-&gt;readers++;
		unlock(&amp;p-&gt;lk);
		return;
	}

	/*
	 * venti currently contains code that assumes locks can be passed between threads
	 * assert(p-&gt;writer != t);
	 */
	if(p-&gt;qfirst == nil)
		p-&gt;qfirst = t;
	else
		p-&gt;qlast-&gt;next = t;
	p-&gt;qlast = t;
	t-&gt;next = nil;
	t-&gt;state = QueuingR;
	unlock(&amp;p-&gt;lk);

	threadSleep(t);
	assert(p-&gt;writer == nil &amp;&amp; p-&gt;readers &gt; 0);
}

void
vtUnlock(VtLock *p)
{
	Thread *t, *tt;

	lock(&amp;p-&gt;lk);
	/*
	 * venti currently has code that assumes lock can be passed between threads :-)
 	 * assert(p-&gt;writer == *vtRock);
	 */
 	assert(p-&gt;writer != nil);
	assert(p-&gt;readers == 0);
	t = p-&gt;qfirst;
	if(t == nil) {
		p-&gt;writer = nil;
		unlock(&amp;p-&gt;lk);
		return;
	}
	if(t-&gt;state == QueuingW) {
		p-&gt;qfirst = t-&gt;next;
		p-&gt;writer = t;
		unlock(&amp;p-&gt;lk);

		threadWakeup(t);
		return;
	}

	p-&gt;writer = nil;
	while(t != nil &amp;&amp; t-&gt;state == QueuingR) {
		tt = t;
		t = t-&gt;next;
		p-&gt;readers++;

		threadWakeup(tt);
	}
	p-&gt;qfirst = t;
	unlock(&amp;p-&gt;lk);
}

void
vtRUnlock(VtLock *p)
{
	Thread *t;

	lock(&amp;p-&gt;lk);
	assert(p-&gt;writer == nil &amp;&amp; p-&gt;readers &gt; 0);
	p-&gt;readers--;
	t = p-&gt;qfirst;
	if(p-&gt;readers &gt; 0 || t == nil) {
		unlock(&amp;p-&gt;lk);
		return;
	}
	assert(t-&gt;state == QueuingW);

	p-&gt;qfirst = t-&gt;next;
	p-&gt;writer = t;
	unlock(&amp;p-&gt;lk);

	threadWakeup(t);
}

int
vtSleep(VtRendez *q)
{
	Thread *s, *t, *tt;
	VtLock *p;

	p = q-&gt;lk;
	lock(&amp;p-&gt;lk);
	s = *vtRock;
	/*
	 * venti currently contains code that assume locks can be passed between threads :-(
	 * assert(p-&gt;writer != s);
	 */
	assert(p-&gt;writer != nil);
	assert(p-&gt;readers == 0);
	t = p-&gt;qfirst;
	if(t == nil) {
		p-&gt;writer = nil;
	} else if(t-&gt;state == QueuingW) {
		p-&gt;qfirst = t-&gt;next;
		p-&gt;writer = t;
		threadWakeup(t);
	} else {
		p-&gt;writer = nil;
		while(t != nil &amp;&amp; t-&gt;state == QueuingR) {
			tt = t;
			t = t-&gt;next;
			p-&gt;readers++;
			threadWakeup(tt);
		}
	}

	if(q-&gt;wfirst == nil)
		q-&gt;wfirst = s;
	else
		q-&gt;wlast-&gt;next = s;
	q-&gt;wlast = s;
	s-&gt;next = nil;
	unlock(&amp;p-&gt;lk);

	threadSleep(s);
	assert(p-&gt;writer == s);
	return 1;
}

int
vtWakeup(VtRendez *q)
{
	Thread *t;
	VtLock *p;

	/*
	 * take off wait and put on front of queue
	 * put on front so guys that have been waiting will not get starved
	 */
	p = q-&gt;lk;
	lock(&amp;p-&gt;lk);
	/*
	 * venti currently has code that assumes lock can be passed between threads :-)
 	 * assert(p-&gt;writer == *vtRock);
	 */
	assert(p-&gt;writer != nil);
	t = q-&gt;wfirst;
	if(t == nil) {
		unlock(&amp;p-&gt;lk);
		return 0;
	}
	q-&gt;wfirst = t-&gt;next;
	if(p-&gt;qfirst == nil)
		p-&gt;qlast = t;
	t-&gt;next = p-&gt;qfirst;
	p-&gt;qfirst = t;
	t-&gt;state = QueuingW;
	unlock(&amp;p-&gt;lk);

	return 1;
}

int
vtWakeupAll(VtRendez *q)
{
	int i;

	for(i=0; vtWakeup(q); i++)
		;
	return i;
}

static void
threadSleep(Thread *t)
{
	if(rendezvous(t, (void*)0x22bbdfd6) != (void*)0x44391f14)
		sysfatal("threadSleep: rendezvous failed: %r");
}

static void
threadWakeup(Thread *t)
{
	if(rendezvous(t, (void*)0x44391f14) != (void*)0x22bbdfd6)
		sysfatal("threadWakeup: rendezvous failed: %r");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

