<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libplumb/mesg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libplumb/mesg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "plumb.h"

int
plumbopen(char *name, int omode)
{
	int fd, f;
	char *s, *plumber;
	char buf[128], err[ERRMAX];

	if(name[0] == '/')
		return open(name, omode);
		
	/* find elusive plumber */
	if(access("/mnt/plumb/send", AWRITE) &gt;= 0)
		plumber = "/mnt/plumb";
	else if(access("/mnt/term/mnt/plumb/send", AWRITE) &gt;= 0)
		plumber = "/mnt/term/mnt/plumb";
	else{
		/* last resort: try mounting service */
		plumber = "/mnt/plumb";
		s = getenv("plumbsrv");
		if(s == nil)
			return -1;
		f = open(s, ORDWR);
		free(s);
		if(f &lt; 0)
			return -1;
		if(mount(f, -1, "/mnt/plumb", MREPL, "") &lt; 0){
			close(f);
			return -1;
		}
		if(access("/mnt/plumb/send", AWRITE) &lt; 0)
			return -1;
	}

	snprint(buf, sizeof buf, "%s/%s", plumber, name);
	fd = open(buf, omode);
	if(fd &gt;= 0)
		return fd;

	/* try creating port; used by non-standard plumb implementations */
	rerrstr(err, sizeof err);
	fd = create(buf, omode, 0600);
	if(fd &gt;= 0)
		return fd;
	errstr(err, sizeof err);

	return -1;
}

static int
Strlen(char *s)
{
	if(s == nil)
		return 0;
	return strlen(s);
}

static char*
Strcpy(char *s, char *t)
{
	if(t == nil)
		return s;
	return strcpy(s, t) + strlen(t);
}

/* quote attribute value, if necessary */
static char*
quote(char *s, char *buf, char *bufe)
{
	char *t;
	int c;

	if(s == nil){
		buf[0] = '\0';
		return buf;
	}
	if(strpbrk(s, " '=\t") == nil)
		return s;
	t = buf;
	*t++ = '\'';
	while(t &lt; bufe-2){
		c = *s++;
		if(c == '\0')
			break;
		*t++ = c;
		if(c == '\'')
			*t++ = c;
	}
	*t++ = '\'';
	*t = '\0';
	return buf;
}

char*
plumbpackattr(Plumbattr *attr)
{
	int n;
	Plumbattr *a;
	char *s, *t, *buf, *bufe;

	if(attr == nil)
		return nil;
	if((buf = malloc(4096)) == nil)
		return nil;
	bufe = buf + 4096;
	n = 0;
	for(a=attr; a!=nil; a=a-&gt;next)
		n += Strlen(a-&gt;name) + 1 + Strlen(quote(a-&gt;value, buf, bufe)) + 1;
	s = malloc(n);
	if(s == nil) {
		free(buf);
		return nil;
	}
	t = s;
	*t = '\0';
	for(a=attr; a!=nil; a=a-&gt;next){
		if(t != s)
			*t++ = ' ';
		strcpy(t, a-&gt;name);
		strcat(t, "=");
		strcat(t, quote(a-&gt;value, buf, bufe));
		t += strlen(t);
	}
	if(t &gt; s+n)
		abort();
	free(buf);
	return s;
}

char*
plumblookup(Plumbattr *attr, char *name)
{
	while(attr){
		if(strcmp(attr-&gt;name, name) == 0)
			return attr-&gt;value;
		attr = attr-&gt;next;
	}
	return nil;
}

char*
plumbpack(Plumbmsg *m, int *np)
{
	int n, ndata;
	char *buf, *p, *attr;

	ndata = m-&gt;ndata;
	if(ndata &lt; 0)
		ndata = Strlen(m-&gt;data);
	attr = plumbpackattr(m-&gt;attr);
	n = Strlen(m-&gt;src)+1 + Strlen(m-&gt;dst)+1 + Strlen(m-&gt;wdir)+1 +
		Strlen(m-&gt;type)+1 + Strlen(attr)+1 + 16 + ndata;
	buf = malloc(n+1);	/* +1 for '\0' */
	if(buf == nil){
		free(attr);
		return nil;
	}
	p = Strcpy(buf, m-&gt;src);
	*p++ = '\n';
	p = Strcpy(p, m-&gt;dst);
	*p++ = '\n';
	p = Strcpy(p, m-&gt;wdir);
	*p++ = '\n';
	p = Strcpy(p, m-&gt;type);
	*p++ = '\n';
	p = Strcpy(p, attr);
	*p++ = '\n';
	p += sprint(p, "%d\n", ndata);
	memmove(p, m-&gt;data, ndata);
	*np = (p-buf)+ndata;
	buf[*np] = '\0';	/* null terminate just in case */
	if(*np &gt;= n+1)
		abort();
	free(attr);
	return buf;
}

int
plumbsend(int fd, Plumbmsg *m)
{
	char *buf;
	int n;

	buf = plumbpack(m, &amp;n);
	if(buf == nil)
		return -1;
	n = write(fd, buf, n);
	free(buf);
	return n;
}

static int
plumbline(char **linep, char *buf, int i, int n, int *bad)
{
	int starti;
	char *p;

	starti = i;
	while(i&lt;n &amp;&amp; buf[i]!='\n')
		i++;
	if(i == n)
		*bad = 1;
	else{
		p = malloc((i-starti) + 1);
		if(p == nil)
			*bad = 1;
		else{
			memmove(p, buf+starti, i-starti);
			p[i-starti] = '\0';
		}
		*linep = p;
		i++;
	}
	return i;
}

void
plumbfree(Plumbmsg *m)
{
	Plumbattr *a, *next;

	free(m-&gt;src);
	free(m-&gt;dst);
	free(m-&gt;wdir);
	free(m-&gt;type);
	for(a=m-&gt;attr; a!=nil; a=next){
		next = a-&gt;next;
		free(a-&gt;name);
		free(a-&gt;value);
		free(a);
	}
	free(m-&gt;data);
	free(m);
}

Plumbattr*
plumbunpackattr(char *p)
{
	Plumbattr *attr, *prev, *a;
	char *q, *v, *buf, *bufe;
	int c, quoting;

	buf = malloc(4096);
	if(buf == nil)
		return nil;
	bufe = buf + 4096;
	attr = prev = nil;
	while(*p!='\0' &amp;&amp; *p!='\n'){
		while(*p==' ' || *p=='\t')
			p++;
		if(*p == '\0')
			break;
		for(q=p; *q!='\0' &amp;&amp; *q!='\n' &amp;&amp; *q!=' ' &amp;&amp; *q!='\t'; q++)
			if(*q == '=')
				break;
		if(*q != '=')
			break;	/* malformed attribute */
		a = malloc(sizeof(Plumbattr));
		if(a == nil)
			break;
		a-&gt;name = malloc(q-p+1);
		if(a-&gt;name == nil){
			free(a);
			break;
		}
		memmove(a-&gt;name, p, q-p);
		a-&gt;name[q-p] = '\0';
		/* process quotes in value */
		q++;	/* skip '=' */
		v = buf;
		quoting = 0;
		while(*q!='\0' &amp;&amp; *q!='\n'){
			if(v &gt;= bufe)
				break;
			c = *q++;
			if(quoting){
				if(c == '\''){
					if(*q == '\'')
						q++;
					else{
						quoting = 0;
						continue;
					}
				}
			}else{
				if(c==' ' || c=='\t')
					break;
				if(c == '\''){
					quoting = 1;
					continue;
				}
			}
			*v++ = c;
		}
		a-&gt;value = malloc(v-buf+1);
		if(a-&gt;value == nil){
			free(a-&gt;name);
			free(a);
			break;
		}
		memmove(a-&gt;value, buf, v-buf);
		a-&gt;value[v-buf] = '\0';
		a-&gt;next = nil;
		if(prev == nil)
			attr = a;
		else
			prev-&gt;next = a;
		prev = a;
		p = q;
	}
	free(buf);
	return attr;
}

Plumbattr*
plumbaddattr(Plumbattr *attr, Plumbattr *new)
{
	Plumbattr *l;

	l = attr;
	if(l == nil)
		return new;
	while(l-&gt;next != nil)
		l = l-&gt;next;
	l-&gt;next = new;
	return attr;
}

Plumbattr*
plumbdelattr(Plumbattr *attr, char *name)
{
	Plumbattr *l, *prev;

	prev = nil;
	for(l=attr; l!=nil; l=l-&gt;next){
		if(strcmp(name, l-&gt;name) == 0)
			break;
		prev = l;
	}
	if(l == nil)
		return nil;
	if(prev)
		prev-&gt;next = l-&gt;next;
	else
		attr = l-&gt;next;
	free(l-&gt;name);
	free(l-&gt;value);
	free(l);
	return attr;
}

Plumbmsg*
plumbunpackpartial(char *buf, int n, int *morep)
{
	Plumbmsg *m;
	int i, bad;
	char *ntext, *attr;

	m = malloc(sizeof(Plumbmsg));
	if(m == nil)
		return nil;
	memset(m, 0, sizeof(Plumbmsg));
	if(morep != nil)
		*morep = 0;
	bad = 0;
	i = plumbline(&amp;m-&gt;src, buf, 0, n, &amp;bad);
	i = plumbline(&amp;m-&gt;dst, buf, i, n, &amp;bad);
	i = plumbline(&amp;m-&gt;wdir, buf, i, n, &amp;bad);
	i = plumbline(&amp;m-&gt;type, buf, i, n, &amp;bad);
	i = plumbline(&amp;attr, buf, i, n, &amp;bad);
	i = plumbline(&amp;ntext, buf, i, n, &amp;bad);
	if(bad){
		plumbfree(m);
		return nil;
	}
	m-&gt;attr = plumbunpackattr(attr);
	free(attr);
	m-&gt;ndata = atoi(ntext);
	if(m-&gt;ndata != n-i){
		bad = 1;
		if(morep!=nil &amp;&amp; m-&gt;ndata&gt;n-i)
			*morep = m-&gt;ndata - (n-i);
	}
	free(ntext);
	if(!bad){
		m-&gt;data = malloc(n-i+1);	/* +1 for '\0' */
		if(m-&gt;data == nil)
			bad = 1;
		else{
			memmove(m-&gt;data, buf+i, m-&gt;ndata);
			m-&gt;ndata = n-i;
			/* null-terminate in case it's text */
			m-&gt;data[m-&gt;ndata] = '\0';
		}
	}
	if(bad){
		plumbfree(m);
		m = nil;
	}
	return m;
}

Plumbmsg*
plumbunpack(char *buf, int n)
{
	return plumbunpackpartial(buf, n, nil);
}

Plumbmsg*
plumbrecv(int fd)
{
	char *buf;
	Plumbmsg *m;
	int n, more;

	buf = malloc(8192);
	if(buf == nil)
		return nil;
	n = read(fd, buf, 8192);
	m = nil;
	if(n &gt; 0){
		m = plumbunpackpartial(buf, n, &amp;more);
		if(m==nil &amp;&amp; more&gt;0){
			/* we now know how many more bytes to read for complete message */
			buf = realloc(buf, n+more);
			if(buf == nil)
				return nil;
			if(readn(fd, buf+n, more) == more)
				m = plumbunpackpartial(buf, n+more, nil);
		}
	}
	free(buf);
	return m;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

