<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libregexp/regexec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libregexp/regexec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "regexp.h"
#include "regcomp.h"


/*
 *  return	0 if no match
 *		&gt;0 if a match
 *		&lt;0 if we ran out of _relist space
 */
static int
regexec1(Reprog *progp,	/* program to run */
	char *bol,	/* string to run machine on */
	Resub *mp,	/* subexpression elements */
	int ms,		/* number of elements at mp */
	Reljunk *j
)
{
	int flag=0;
	Reinst *inst;
	Relist *tlp;
	char *s;
	int i, checkstart;
	Rune r, *rp, *ep;
	int n;
	Relist* tl;		/* This list, next list */
	Relist* nl;
	Relist* tle;		/* ends of this and next list */
	Relist* nle;
	int match;
	char *p;

	match = 0;
	checkstart = j-&gt;starttype;
	if(mp)
		for(i=0; i&lt;ms; i++) {
			mp[i].sp = 0;
			mp[i].ep = 0;
		}
	j-&gt;relist[0][0].inst = 0;
	j-&gt;relist[1][0].inst = 0;

	/* Execute machine once for each character, including terminal NUL */
	s = j-&gt;starts;
	do{
		/* fast check for first char */
		if(checkstart) {
			switch(j-&gt;starttype) {
			case RUNE:
				p = utfrune(s, j-&gt;startchar);
				if(p == 0 || s == j-&gt;eol)
					return match;
				s = p;
				break;
			case BOL:
				if(s == bol)
					break;
				p = utfrune(s, '\n');
				if(p == 0 || s == j-&gt;eol)
					return match;
				s = p+1;
				break;
			}
		}
		r = *(uchar*)s;
		if(r &lt; Runeself)
			n = 1;
		else
			n = chartorune(&amp;r, s);

		/* switch run lists */
		tl = j-&gt;relist[flag];
		tle = j-&gt;reliste[flag];
		nl = j-&gt;relist[flag^=1];
		nle = j-&gt;reliste[flag];
		nl-&gt;inst = 0;

		/* Add first instruction to current list */
		if(match == 0)
			_renewemptythread(tl, progp-&gt;startinst, ms, s);

		/* Execute machine until current list is empty */
		for(tlp=tl; tlp-&gt;inst; tlp++){	/* assignment = */
			for(inst = tlp-&gt;inst; ; inst = inst-&gt;next){
				switch(inst-&gt;type){
				case RUNE:	/* regular character */
					if(inst-&gt;r == r){
						if(_renewthread(nl, inst-&gt;next, ms, &amp;tlp-&gt;se)==nle)
							return -1;
					}
					break;
				case LBRA:
					tlp-&gt;se.m[inst-&gt;subid].sp = s;
					continue;
				case RBRA:
					tlp-&gt;se.m[inst-&gt;subid].ep = s;
					continue;
				case ANY:
					if(r != '\n')
						if(_renewthread(nl, inst-&gt;next, ms, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case ANYNL:
					if(_renewthread(nl, inst-&gt;next, ms, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case BOL:
					if(s == bol || *(s-1) == '\n')
						continue;
					break;
				case EOL:
					if(s == j-&gt;eol || r == 0 || r == '\n')
						continue;
					break;
				case CCLASS:
					ep = inst-&gt;cp-&gt;end;
					for(rp = inst-&gt;cp-&gt;spans; rp &lt; ep; rp += 2)
						if(r &gt;= rp[0] &amp;&amp; r &lt;= rp[1]){
							if(_renewthread(nl, inst-&gt;next, ms, &amp;tlp-&gt;se)==nle)
								return -1;
							break;
						}
					break;
				case NCCLASS:
					ep = inst-&gt;cp-&gt;end;
					for(rp = inst-&gt;cp-&gt;spans; rp &lt; ep; rp += 2)
						if(r &gt;= rp[0] &amp;&amp; r &lt;= rp[1])
							break;
					if(rp == ep)
						if(_renewthread(nl, inst-&gt;next, ms, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case OR:
					/* evaluate right choice later */
					if(_renewthread(tlp, inst-&gt;right, ms, &amp;tlp-&gt;se) == tle)
						return -1;
					/* efficiency: advance and re-evaluate */
					continue;
				case END:	/* Match! */
					match = 1;
					tlp-&gt;se.m[0].ep = s;
					if(mp != 0)
						_renewmatch(mp, ms, &amp;tlp-&gt;se);
					break;
				}
				break;
			}
		}
		if(s == j-&gt;eol)
			break;
		checkstart = j-&gt;starttype &amp;&amp; nl-&gt;inst==0;
		s += n;
	}while(r);
	return match;
}

static int
regexec2(Reprog *progp,	/* program to run */
	char *bol,	/* string to run machine on */
	Resub *mp,	/* subexpression elements */
	int ms,		/* number of elements at mp */
	Reljunk *j
)
{
	int rv;
	Relist *relist0, *relist1;

	/* mark space */
	relist0 = malloc(BIGLISTSIZE*sizeof(Relist));
	if(relist0 == nil)
		return -1;
	relist1 = malloc(BIGLISTSIZE*sizeof(Relist));
	if(relist1 == nil){
		free(relist1);
		return -1;
	}
	j-&gt;relist[0] = relist0;
	j-&gt;relist[1] = relist1;
	j-&gt;reliste[0] = relist0 + BIGLISTSIZE - 2;
	j-&gt;reliste[1] = relist1 + BIGLISTSIZE - 2;

	rv = regexec1(progp, bol, mp, ms, j);
	free(relist0);
	free(relist1);
	return rv;
}

extern int
regexec(Reprog *progp,	/* program to run */
	char *bol,	/* string to run machine on */
	Resub *mp,	/* subexpression elements */
	int ms)		/* number of elements at mp */
{
	Reljunk j;
	Relist relist0[LISTSIZE], relist1[LISTSIZE];
	int rv;

	/*
 	 *  use user-specified starting/ending location if specified
	 */
	j.starts = bol;
	j.eol = 0;
	if(mp &amp;&amp; ms&gt;0){
		if(mp-&gt;sp)
			j.starts = mp-&gt;sp;
		if(mp-&gt;ep)
			j.eol = mp-&gt;ep;
	}
	j.starttype = 0;
	j.startchar = 0;
	if(progp-&gt;startinst-&gt;type == RUNE &amp;&amp; progp-&gt;startinst-&gt;r &lt; Runeself) {
		j.starttype = RUNE;
		j.startchar = progp-&gt;startinst-&gt;r;
	}
	if(progp-&gt;startinst-&gt;type == BOL)
		j.starttype = BOL;

	/* mark space */
	j.relist[0] = relist0;
	j.relist[1] = relist1;
	j.reliste[0] = relist0 + nelem(relist0) - 2;
	j.reliste[1] = relist1 + nelem(relist1) - 2;

	rv = regexec1(progp, bol, mp, ms, &amp;j);
	if(rv &gt;= 0)
		return rv;
	rv = regexec2(progp, bol, mp, ms, &amp;j);
	if(rv &gt;= 0)
		return rv;
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

