<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsunrpc/server.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsunrpc/server.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;sunrpc.h&gt;

/*
 * Sun RPC server; for now, no reply cache
 */

static void sunRpcProc(void*);
static void sunRpcRequestThread(void*);
static void sunRpcReplyThread(void*);
static void sunRpcForkThread(void*);
static SunProg *sunFindProg(SunSrv*, SunMsg*, SunRpc*, Channel**);

typedef struct Targ Targ;
struct Targ
{
	void (*fn)(void*);
	void *arg;
};

SunSrv*
sunSrv(void)
{
	SunSrv *srv;

	srv = emalloc(sizeof(SunSrv));
	srv-&gt;chatty = 0;
	srv-&gt;crequest = chancreate(sizeof(SunMsg*), 16);
	srv-&gt;creply = chancreate(sizeof(SunMsg*), 16);
	srv-&gt;cthread = chancreate(sizeof(Targ), 4);

	proccreate(sunRpcProc, srv, SunStackSize);
	return srv;
}

void
sunSrvProg(SunSrv *srv, SunProg *prog, Channel *c)
{
	if(srv-&gt;nprog%16 == 0){
		srv-&gt;prog = erealloc(srv-&gt;prog, (srv-&gt;nprog+16)*sizeof(srv-&gt;prog[0]));
		srv-&gt;cdispatch = erealloc(srv-&gt;cdispatch, (srv-&gt;nprog+16)*sizeof(srv-&gt;cdispatch[0]));
	}
	srv-&gt;prog[srv-&gt;nprog] = prog;
	srv-&gt;cdispatch[srv-&gt;nprog] = c;
	srv-&gt;nprog++;
}

static void
sunRpcProc(void *v)
{
	threadcreate(sunRpcReplyThread, v, SunStackSize);
	threadcreate(sunRpcRequestThread, v, SunStackSize);
	threadcreate(sunRpcForkThread, v, SunStackSize);

}

static void
sunRpcForkThread(void *v)
{
	SunSrv *srv = v;
	Targ t;

	while(recv(srv-&gt;cthread, &amp;t) == 1)
		threadcreate(t.fn, t.arg, SunStackSize);
}

void
sunSrvThreadCreate(SunSrv *srv, void (*fn)(void*), void *arg)
{
	Targ t;

	t.fn = fn;
	t.arg = arg;
	send(srv-&gt;cthread, &amp;t);
}

static void
sunRpcRequestThread(void *v)
{
	uchar *p, *ep;
	Channel *c;
	SunSrv *srv = v;
	SunMsg *m;
	SunProg *pg;
	SunStatus ok;

	while((m = recvp(srv-&gt;crequest)) != nil){
		/* could look up in cache here? */

if(srv-&gt;chatty) fprint(2, "sun msg %p count %d\n", m, m-&gt;count);
		m-&gt;srv = srv;
		p = m-&gt;data;
		ep = p+m-&gt;count;
		if(sunRpcUnpack(p, ep, &amp;p, &amp;m-&gt;rpc) != SunSuccess){
			fprint(2, "in: %.*H unpack failed\n", m-&gt;count, m-&gt;data);
			sunMsgDrop(m);
			continue;
		}
		if(srv-&gt;chatty)
			fprint(2, "in: %B\n", &amp;m-&gt;rpc);

		if(srv-&gt;alwaysReject){
			if(srv-&gt;chatty)
				fprint(2, "\trejecting\n");
			sunMsgReplyError(m, SunAuthTooWeak);
			continue;
		}

		if(!m-&gt;rpc.iscall){
			sunMsgReplyError(m, SunGarbageArgs);
			continue;
		}

		if((pg = sunFindProg(srv, m, &amp;m-&gt;rpc, &amp;c)) == nil){
			/* sunFindProg sent error */
			continue;
		}

		p = m-&gt;rpc.data;
		ep = p+m-&gt;rpc.ndata;
		m-&gt;call = nil;
		if((ok = sunCallUnpackAlloc(pg, m-&gt;rpc.proc&lt;&lt;1, p, ep, &amp;p, &amp;m-&gt;call)) != SunSuccess){
			sunMsgReplyError(m, ok);
			continue;
		}
		m-&gt;call-&gt;rpc = m-&gt;rpc;

		if(srv-&gt;chatty)
			fprint(2, "\t%C\n", m-&gt;call);

		m-&gt;pg = pg;
		sendp(c, m);
	}
}

static SunProg*
sunFindProg(SunSrv *srv, SunMsg *m, SunRpc *rpc, Channel **pc)
{
	int i, vlo, vhi;
	SunProg *pg;

	vlo = 0x7fffffff;
	vhi = -1;

	for(i=0; i&lt;srv-&gt;nprog; i++){
		pg = srv-&gt;prog[i];
		if(pg-&gt;prog != rpc-&gt;prog)
			continue;
		if(pg-&gt;vers == rpc-&gt;vers){
			*pc = srv-&gt;cdispatch[i];
			return pg;
		}
		/* right program, wrong version: record range */
		if(pg-&gt;vers &lt; vlo)
			vlo = pg-&gt;vers;
		if(pg-&gt;vers &gt; vhi)
			vhi = pg-&gt;vers;
	}
	if(vhi == -1){
		if(srv-&gt;chatty)
			fprint(2, "\tprogram %ud unavailable\n", rpc-&gt;prog);
		sunMsgReplyError(m, SunProgUnavail);
	}else{
		/* putting these in rpc is a botch */
		rpc-&gt;low = vlo;
		rpc-&gt;high = vhi;
		if(srv-&gt;chatty)
			fprint(2, "\tversion %ud unavailable; have %d-%d\n", rpc-&gt;vers, vlo, vhi);
		sunMsgReplyError(m, SunProgMismatch);
	}
	return nil;
}

static void
sunRpcReplyThread(void *v)
{
	SunMsg *m;
	SunSrv *srv = v;

	while((m = recvp(srv-&gt;creply)) != nil){
		/* could record in cache here? */
		sendp(m-&gt;creply, m);
	}	
}

int
sunMsgReplyError(SunMsg *m, SunStatus error)
{
	uchar *p, *bp, *ep;
	int n;

	m-&gt;rpc.status = error;
	m-&gt;rpc.iscall = 0;
	m-&gt;rpc.verf.flavor = SunAuthNone;
	m-&gt;rpc.data = nil;
	m-&gt;rpc.ndata = 0;

	if(m-&gt;srv-&gt;chatty)
		fprint(2, "out: %B\n", &amp;m-&gt;rpc);

	n = sunRpcSize(&amp;m-&gt;rpc);
	bp = emalloc(n);
	ep = bp+n;
	p = bp;
	if(sunRpcPack(p, ep, &amp;p, &amp;m-&gt;rpc) &lt; 0){
		fprint(2, "sunRpcPack failed\n");
		sunMsgDrop(m);
		return 0;
	}
	if(p != ep){
		fprint(2, "sunMsgReplyError: rpc sizes didn't work out\n");
		sunMsgDrop(m);
		return 0;
	}
	free(m-&gt;data);
	m-&gt;data = bp;
	m-&gt;count = n;
	sendp(m-&gt;srv-&gt;creply, m);
	return 0;
}

int
sunMsgReply(SunMsg *m, SunCall *c)
{
	int n1, n2;
	uchar *bp, *p, *ep;

	c-&gt;type = m-&gt;call-&gt;type+1;
	c-&gt;rpc.iscall = 0;
	c-&gt;rpc.prog = m-&gt;rpc.prog;
	c-&gt;rpc.vers = m-&gt;rpc.vers;
	c-&gt;rpc.proc = m-&gt;rpc.proc;
	c-&gt;rpc.xid = m-&gt;rpc.xid;

	if(m-&gt;srv-&gt;chatty){
		fprint(2, "out: %B\n", &amp;c-&gt;rpc);
		fprint(2, "\t%C\n", c);
	}

	n1 = sunRpcSize(&amp;c-&gt;rpc);
	n2 = sunCallSize(m-&gt;pg, c);

	bp = emalloc(n1+n2);
	ep = bp+n1+n2;
	p = bp;
	if(sunRpcPack(p, ep, &amp;p, &amp;c-&gt;rpc) != SunSuccess){
		fprint(2, "sunRpcPack failed\n");
		return sunMsgDrop(m);
	}
	if(sunCallPack(m-&gt;pg, p, ep, &amp;p, c) != SunSuccess){
		fprint(2, "pg-&gt;pack failed\n");
		return sunMsgDrop(m);
	}
	if(p != ep){
		fprint(2, "sunMsgReply: sizes didn't work out\n");
		return sunMsgDrop(m);
	}
	free(m-&gt;data);
	m-&gt;data = bp;
	m-&gt;count = n1+n2;

	sendp(m-&gt;srv-&gt;creply, m);
	return 0;
}

int
sunMsgDrop(SunMsg *m)
{
	free(m-&gt;data);
	free(m-&gt;call);
	memset(m, 0xFB, sizeof *m);
	free(m);
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

