<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsunrpc/udp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsunrpc/udp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include &lt;sunrpc.h&gt;

typedef struct SunMsgUdp SunMsgUdp;
struct SunMsgUdp
{
	SunMsg	msg;
	Udphdr	udp;
};

typedef struct Arg Arg;
struct Arg
{
	SunSrv	*srv;
	Channel	*creply;
	Channel	*csync;
	int 	fd;
};

enum
{
	UdpMaxRead = 65536+Udphdrsize
};

static void
sunUdpRead(void *v)
{
	int n;
	uchar *buf;
	Arg arg = *(Arg*)v;
	SunMsgUdp *msg;

	sendp(arg.csync, 0);

	buf = emalloc(UdpMaxRead);
	while((n = read(arg.fd, buf, UdpMaxRead)) &gt; 0){
		if(arg.srv-&gt;chatty)
			fprint(2, "udp got %d (%d)\n", n, Udphdrsize);
		msg = emalloc(sizeof(SunMsgUdp));
		memmove(&amp;msg-&gt;udp, buf, Udphdrsize);
		msg-&gt;msg.data = emalloc(n);
		msg-&gt;msg.count = n-Udphdrsize;
		memmove(msg-&gt;msg.data, buf+Udphdrsize, n-Udphdrsize);
		memmove(&amp;msg-&gt;udp, buf, Udphdrsize);
		msg-&gt;msg.creply = arg.creply;
		if(arg.srv-&gt;chatty)
			fprint(2, "message %p count %d\n", msg, msg-&gt;msg.count);
		sendp(arg.srv-&gt;crequest, msg);
	}
}

static void
sunUdpWrite(void *v)
{
	uchar *buf;
	Arg arg = *(Arg*)v;
	SunMsgUdp *msg;

	sendp(arg.csync, 0);

	buf = emalloc(UdpMaxRead);
	while((msg = recvp(arg.creply)) != nil){
		memmove(buf+Udphdrsize, msg-&gt;msg.data, msg-&gt;msg.count);
		memmove(buf, &amp;msg-&gt;udp, Udphdrsize);
		msg-&gt;msg.count += Udphdrsize;
		if(write(arg.fd, buf, msg-&gt;msg.count) != msg-&gt;msg.count)
			fprint(2, "udpWrite: %r\n");
		free(msg-&gt;msg.data);
		free(msg);
	}
}

int
sunSrvUdp(SunSrv *srv, char *address)
{
	int acfd, fd;
	char adir[40], data[60];
	Arg *arg;

	acfd = announce(address, adir);
	if(acfd &lt; 0)
		return -1;
	if(write(acfd, "headers", 7) &lt; 0){
		werrstr("setting headers: %r");
		close(acfd);
		return -1;
	}
	snprint(data, sizeof data, "%s/data", adir);
	if((fd = open(data, ORDWR)) &lt; 0){
		werrstr("open %s: %r", data);
		close(acfd);
		return -1;
	}
	close(acfd); 
	
	arg = emalloc(sizeof(Arg));
	arg-&gt;fd = fd;
	arg-&gt;srv = srv;
	arg-&gt;creply = chancreate(sizeof(SunMsg*), 10);
	arg-&gt;csync =  chancreate(sizeof(void*), 10);

	proccreate(sunUdpRead, arg, SunStackSize);
	proccreate(sunUdpWrite, arg, SunStackSize);
	recvp(arg-&gt;csync);
	recvp(arg-&gt;csync);
	chanfree(arg-&gt;csync);
	free(arg);

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

