<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libthread/channel.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libthread/channel.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "threadimpl.h"

/* Value to indicate the channel is closed */
enum {
	CHANCLOSD = 0xc105ed,
};

static char errcl[] = "channel was closed";
static Lock chanlock;		/* central channel access lock */

static void enqueue(Alt*, Channel**);
static void dequeue(Alt*);
static int canexec(Alt*);
static int altexec(Alt*, int);

#define Closed	((void*)CHANCLOSD)
#define Intred	((void*)~0)		/* interrupted */

static void
_chanfree(Channel *c)
{
	int i, inuse;

	if(c-&gt;closed == 1)			/* chanclose is ongoing */
		inuse = 1;
	else{
		inuse = 0;
		for(i = 0; i &lt; c-&gt;nentry; i++)	/* alt ongoing */
			if(c-&gt;qentry[i])
				inuse = 1;
	}
	if(inuse)
		c-&gt;freed = 1;
	else{
		if(c-&gt;qentry)
			free(c-&gt;qentry);
		free(c);
	}
}

void
chanfree(Channel *c)
{
	lock(&amp;chanlock);
	_chanfree(c);
	unlock(&amp;chanlock);
}

int
chaninit(Channel *c, int elemsize, int elemcnt)
{
	if(elemcnt &lt; 0 || elemsize &lt;= 0 || c == nil)
		return -1;
	c-&gt;f = 0;
	c-&gt;n = 0;
	c-&gt;closed = 0;
	c-&gt;freed = 0;
	c-&gt;e = elemsize;
	c-&gt;s = elemcnt;
	_threaddebug(DBGCHAN, "chaninit %p", c);
	return 1;
}

Channel*
chancreate(int elemsize, int elemcnt)
{
	Channel *c;

	if(elemcnt &lt; 0 || elemsize &lt;= 0)
		return nil;
	c = _threadmalloc(sizeof(Channel)+elemsize*elemcnt, 1);
	c-&gt;e = elemsize;
	c-&gt;s = elemcnt;
	_threaddebug(DBGCHAN, "chancreate %p", c);
	return c;
}

static int
isopenfor(Channel *c, int op)
{
	return c-&gt;closed == 0 || (op == CHANRCV &amp;&amp; c-&gt;n &gt; 0);
}

int
alt(Alt *alts)
{
	Alt *a, *xa, *ca;
	Channel volatile *c;
	int n, s, waiting, allreadycl;
	void* r;
	Thread *t;

	/*
	 * The point of going splhi here is that note handlers
	 * might reasonably want to use channel operations,
	 * but that will hang if the note comes while we hold the
	 * chanlock.  Instead, we delay the note until we've dropped
	 * the lock.
	 */
	t = _threadgetproc()-&gt;thread;
	if(t-&gt;moribund || _threadexitsallstatus)
		yield();	/* won't return */
	s = _procsplhi();
	lock(&amp;chanlock);
	t-&gt;alt = alts;
	t-&gt;chan = Chanalt;

	/* test whether any channels can proceed */
	n = 0;
	a = nil;

	for(xa=alts; xa-&gt;op!=CHANEND &amp;&amp; xa-&gt;op!=CHANNOBLK; xa++){
		xa-&gt;entryno = -1;
		if(xa-&gt;op == CHANNOP)
			continue;

		c = xa-&gt;c;
		if(c==nil){
			unlock(&amp;chanlock);
			_procsplx(s);
			t-&gt;chan = Channone;
			return -1;
		}

		if(isopenfor(c, xa-&gt;op) &amp;&amp; canexec(xa))
			if(nrand(++n) == 0)
				a = xa;
	}


	if(a==nil){
		/* nothing can proceed */
		if(xa-&gt;op == CHANNOBLK){
			unlock(&amp;chanlock);
			_procsplx(s);
			t-&gt;chan = Channone;
			if(xa-&gt;op == CHANNOBLK)
				return xa - alts;
		}

		/* enqueue on all channels open for us. */
		c = nil;
		ca = nil;
		waiting = 0;
		allreadycl = 0;
		for(xa=alts; xa-&gt;op!=CHANEND; xa++)
			if(xa-&gt;op==CHANNOP)
				continue;
			else if(isopenfor(xa-&gt;c, xa-&gt;op)){
				waiting = 1;
				enqueue(xa, &amp;c);
			} else if(xa-&gt;err != errcl)
				ca = xa;
			else
				allreadycl = 1;

		if(waiting == 0)
			if(ca != nil){
				/* everything was closed, select last channel */
				ca-&gt;err = errcl;
				unlock(&amp;chanlock);
				_procsplx(s);
				t-&gt;chan = Channone;
				return ca - alts;
			} else if(allreadycl){
				/* everything was already closed */
				unlock(&amp;chanlock);
				_procsplx(s);
				t-&gt;chan = Channone;
				return -1;
			}
		/*
		 * wait for successful rendezvous.
		 * we can't just give up if the rendezvous
		 * is interrupted -- someone else might come
		 * along and try to rendezvous with us, so
		 * we need to be here.
		 * if the channel was closed, the op is done
		 * and we flag an error for the entry.
		 */
	    Again:
		unlock(&amp;chanlock);
		_procsplx(s);
		r = _threadrendezvous(&amp;c, 0);
		s = _procsplhi();
		lock(&amp;chanlock);

		if(r==Intred){		/* interrupted */
			if(c!=nil)	/* someone will meet us; go back */
				goto Again;
			c = (Channel*)~0;	/* so no one tries to meet us */
		}

		/* dequeue from channels, find selected one */
		a = nil;
		for(xa=alts; xa-&gt;op!=CHANEND; xa++){
			if(xa-&gt;op==CHANNOP)
				continue;
			if(xa-&gt;c == c){
				a = xa;
				a-&gt;err = nil;
				if(r == Closed)
					a-&gt;err = errcl;
			}
			dequeue(xa);
		}
		unlock(&amp;chanlock);
		_procsplx(s);
		if(a == nil){	/* we were interrupted */
			assert(c==(Channel*)~0);
			return -1;
		}
	}else
		altexec(a, s);	/* unlocks chanlock, does splx */
	_sched();
	t-&gt;chan = Channone;
	return a - alts;
}

int
chanclose(Channel *c)
{
	Alt *a;
	int i, s;

	s = _procsplhi();	/* note handlers; see :/^alt */
	lock(&amp;chanlock);
	if(c-&gt;closed){
		/* Already close; we fail but it's ok. don't print */
		unlock(&amp;chanlock);
		_procsplx(s);
		return -1;
	}
	c-&gt;closed = 1;		/* Being closed */
	/*
	 * Locate entries that will fail due to close
	 * (send, and receive if nothing buffered) and wake them up.
	 * the situation cannot change because all queries
	 * should be committed by now and new ones will find the channel
	 * closed.  We still need to take the lock during the iteration
	 * because we can wake threads on qentrys we have not seen yet
	 * as in alt and there would be a race in the access to *a.
	 */
	for(i = 0; i &lt; c-&gt;nentry; i++){
		if((a = c-&gt;qentry[i]) == nil || *a-&gt;tag != nil)
			continue;

		if(a-&gt;op != CHANSND &amp;&amp; (a-&gt;op != CHANRCV || c-&gt;n != 0))
			continue;
		*a-&gt;tag = c;
		unlock(&amp;chanlock);
		_procsplx(s);
		while(_threadrendezvous(a-&gt;tag, Closed) == Intred)
			;
		s = _procsplhi();
		lock(&amp;chanlock);
	}

	c-&gt;closed = 2;		/* Fully closed */
	if(c-&gt;freed)
		_chanfree(c);
	unlock(&amp;chanlock);
	_procsplx(s);
	return 0;
}

int
chanclosing(Channel *c)
{
	int n, s;

	s = _procsplhi();	/* note handlers; see :/^alt */
	lock(&amp;chanlock);
	if(c-&gt;closed == 0)
		n = -1;
	else
		n = c-&gt;n;
	unlock(&amp;chanlock);
	_procsplx(s);
	return n;
}

/*
 * superseded by chanclosing
int
chanisclosed(Channel *c)
{
	return chanisclosing(c) &gt;= 0;
}
 */

static int
runop(int op, Channel *c, void *v, int nb)
{
	int r;
	Alt a[2];

	/*
	 * we could do this without calling alt,
	 * but the only reason would be performance,
	 * and i'm not convinced it matters.
	 */
	a[0].op = op;
	a[0].c = c;
	a[0].v = v;
	a[0].err = nil;
	a[1].op = CHANEND;
	if(nb)
		a[1].op = CHANNOBLK;
	switch(r=alt(a)){
	case -1:	/* interrupted */
		return -1;
	case 1:	/* nonblocking, didn't accomplish anything */
		assert(nb);
		return 0;
	case 0:
		/*
		 * Okay, but return -1 if the op is done because of a close.
		 */
		if(a[0].err != nil)
			return -1;
		return 1;
	default:
		fprint(2, "ERROR: channel alt returned %d\n", r);
		abort();
		return -1;
	}
}

int
recv(Channel *c, void *v)
{
	return runop(CHANRCV, c, v, 0);
}

int
nbrecv(Channel *c, void *v)
{
	return runop(CHANRCV, c, v, 1);
}

int
send(Channel *c, void *v)
{
	return runop(CHANSND, c, v, 0);
}

int
nbsend(Channel *c, void *v)
{
	return runop(CHANSND, c, v, 1);
}

static void
channelsize(Channel *c, int sz)
{
	if(c-&gt;e != sz){
		fprint(2, "expected channel with elements of size %d, got size %d\n",
			sz, c-&gt;e);
		abort();
	}
}

int
sendul(Channel *c, ulong v)
{
	channelsize(c, sizeof(ulong));
	return send(c, &amp;v);
}

ulong
recvul(Channel *c)
{
	ulong v;

	channelsize(c, sizeof(ulong));
	if(recv(c, &amp;v) &lt; 0)
		return ~0;
	return v;
}

int
sendp(Channel *c, void *v)
{
	channelsize(c, sizeof(void*));
	return send(c, &amp;v);
}

void*
recvp(Channel *c)
{
	void *v;

	channelsize(c, sizeof(void*));
	if(recv(c, &amp;v) &lt; 0)
		return nil;
	return v;
}

int
nbsendul(Channel *c, ulong v)
{
	channelsize(c, sizeof(ulong));
	return nbsend(c, &amp;v);
}

ulong
nbrecvul(Channel *c)
{
	ulong v;

	channelsize(c, sizeof(ulong));
	if(nbrecv(c, &amp;v) == 0)
		return 0;
	return v;
}

int
nbsendp(Channel *c, void *v)
{
	channelsize(c, sizeof(void*));
	return nbsend(c, &amp;v);
}

void*
nbrecvp(Channel *c)
{
	void *v;

	channelsize(c, sizeof(void*));
	if(nbrecv(c, &amp;v) == 0)
		return nil;
	return v;
}

static int
emptyentry(Channel *c)
{
	int i, extra;

	assert((c-&gt;nentry==0 &amp;&amp; c-&gt;qentry==nil) || (c-&gt;nentry &amp;&amp; c-&gt;qentry));

	for(i=0; i&lt;c-&gt;nentry; i++)
		if(c-&gt;qentry[i]==nil)
			return i;

	extra = 16;
	c-&gt;nentry += extra;
	c-&gt;qentry = realloc((void*)c-&gt;qentry, c-&gt;nentry*sizeof(c-&gt;qentry[0]));
	if(c-&gt;qentry == nil)
		sysfatal("realloc channel entries: %r");
	memset(&amp;c-&gt;qentry[i], 0, extra*sizeof(c-&gt;qentry[0]));
	return i;
}

static void
enqueue(Alt *a, Channel **c)
{
	int i;

	_threaddebug(DBGCHAN, "Queuing alt %p on channel %p", a, a-&gt;c);
	a-&gt;tag = c;
	i = emptyentry(a-&gt;c);
	a-&gt;c-&gt;qentry[i] = a;
}

static void
dequeue(Alt *a)
{
	int i;
	Channel *c;

	c = a-&gt;c;
	for(i=0; i&lt;c-&gt;nentry; i++)
		if(c-&gt;qentry[i]==a){
			_threaddebug(DBGCHAN, "Dequeuing alt %p from channel %p", a, a-&gt;c);
			c-&gt;qentry[i] = nil;
			/* release if freed and not closing */
			if(c-&gt;freed &amp;&amp; c-&gt;closed != 1)
				_chanfree(c);
			return;
		}
}

static int
canexec(Alt *a)
{
	int i, otherop;
	Channel *c;

	c = a-&gt;c;
	/* are there senders or receivers blocked? */
	otherop = (CHANSND+CHANRCV) - a-&gt;op;
	for(i=0; i&lt;c-&gt;nentry; i++)
		if(c-&gt;qentry[i] &amp;&amp; c-&gt;qentry[i]-&gt;op==otherop &amp;&amp; *c-&gt;qentry[i]-&gt;tag==nil){
			_threaddebug(DBGCHAN, "can rendez alt %p chan %p", a, c);
			return 1;
		}

	/* is there room in the channel? */
	if((a-&gt;op==CHANSND &amp;&amp; c-&gt;n &lt; c-&gt;s)
	|| (a-&gt;op==CHANRCV &amp;&amp; c-&gt;n &gt; 0)){
		_threaddebug(DBGCHAN, "can buffer alt %p chan %p", a, c);
		return 1;
	}

	return 0;
}

static void*
altexecbuffered(Alt *a, int willreplace)
{
	uchar *v;
	Channel *c;

	c = a-&gt;c;
	/* use buffered channel queue */
	if(a-&gt;op==CHANRCV &amp;&amp; c-&gt;n &gt; 0){
		_threaddebug(DBGCHAN, "buffer recv alt %p chan %p", a, c);
		v = c-&gt;v + c-&gt;e*(c-&gt;f%c-&gt;s);
		if(!willreplace)
			c-&gt;n--;
		c-&gt;f++;
		return v;
	}
	if(a-&gt;op==CHANSND &amp;&amp; c-&gt;n &lt; c-&gt;s){
		_threaddebug(DBGCHAN, "buffer send alt %p chan %p", a, c);
		v = c-&gt;v + c-&gt;e*((c-&gt;f+c-&gt;n)%c-&gt;s);
		if(!willreplace)
			c-&gt;n++;
		return v;
	}
	abort();
	return nil;
}

static void
altcopy(void *dst, void *src, int sz)
{
	if(dst){
		if(src)
			memmove(dst, src, sz);
		else
			memset(dst, 0, sz);
	}
}

static int
altexec(Alt *a, int spl)
{
	volatile Alt *b;
	int i, n, otherop;
	Channel *c;
	void *me, *waiter, *buf;

	c = a-&gt;c;

	/* rendezvous with others */
	otherop = (CHANSND+CHANRCV) - a-&gt;op;
	n = 0;
	b = nil;
	me = a-&gt;v;
	for(i=0; i&lt;c-&gt;nentry; i++)
		if(c-&gt;qentry[i] &amp;&amp; c-&gt;qentry[i]-&gt;op==otherop &amp;&amp; *c-&gt;qentry[i]-&gt;tag==nil)
			if(nrand(++n) == 0)
				b = c-&gt;qentry[i];
	if(b != nil){
		_threaddebug(DBGCHAN, "rendez %s alt %p chan %p alt %p", a-&gt;op==CHANRCV?"recv":"send", a, c, b);
		waiter = b-&gt;v;
		if(c-&gt;s &amp;&amp; c-&gt;n){
			/*
			 * if buffer is full and there are waiters
			 * and we're meeting a waiter,
			 * we must be receiving.
			 *
			 * we use the value in the channel buffer,
			 * copy the waiter's value into the channel buffer
			 * on behalf of the waiter, and then wake the waiter.
			 */
			if(a-&gt;op!=CHANRCV)
				abort();
			buf = altexecbuffered(a, 1);
			altcopy(me, buf, c-&gt;e);
			altcopy(buf, waiter, c-&gt;e);
		}else{
			if(a-&gt;op==CHANRCV)
				altcopy(me, waiter, c-&gt;e);
			else
				altcopy(waiter, me, c-&gt;e);
		}
		*b-&gt;tag = c;	/* commits us to rendezvous */
		_threaddebug(DBGCHAN, "unlocking the chanlock");
		unlock(&amp;chanlock);
		_procsplx(spl);
		_threaddebug(DBGCHAN, "chanlock is %lud", *(ulong*)&amp;chanlock);
		while(_threadrendezvous(b-&gt;tag, 0) == Intred)
			;
		return 1;
	}

	buf = altexecbuffered(a, 0);
	if(a-&gt;op==CHANRCV)
		altcopy(me, buf, c-&gt;e);
	else
		altcopy(buf, me, c-&gt;e);

	unlock(&amp;chanlock);
	_procsplx(spl);
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

