<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libthread/create.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libthread/create.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "threadimpl.h"

Pqueue _threadpq;

static int
nextID(void)
{
	static Lock l;
	static int id;
	int i;

	lock(&amp;l);
	i = ++id;
	unlock(&amp;l);
	return i;
}
	
/*
 * Create and initialize a new Thread structure attached to a given proc.
 */
static int
newthread(Proc *p, void (*f)(void *arg), void *arg, uint stacksize, char *name, int grp)
{
	int id;
	Thread *t;

	if(stacksize &lt; 32)
		sysfatal("bad stacksize %d", stacksize);
	t = _threadmalloc(sizeof(Thread), 1);
	t-&gt;stksize = stacksize;
	t-&gt;stk = _threadmalloc(stacksize, 0);
	memset(t-&gt;stk, 0xFE, stacksize);
	_threadinitstack(t, f, arg);
	t-&gt;grp = grp;
	if(name)
		t-&gt;cmdname = strdup(name);
	t-&gt;id = nextID();
	id = t-&gt;id;
	t-&gt;next = (Thread*)~0;
	t-&gt;proc = p;
	_threaddebug(DBGSCHED, "create thread %d.%d name %s", p-&gt;pid, t-&gt;id, name);
	lock(&amp;p-&gt;lock);
	p-&gt;nthreads++;
	if(p-&gt;threads.head == nil)
		p-&gt;threads.head = t;
	else
		*p-&gt;threads.tail = t;
	p-&gt;threads.tail = &amp;t-&gt;nextt;
	t-&gt;nextt = nil;
	t-&gt;state = Ready;
	_threadready(t);
	unlock(&amp;p-&gt;lock);
	return id;
}

/* 
 * Create a new thread and schedule it to run.
 * The thread grp is inherited from the currently running thread.
 */
int
threadcreate(void (*f)(void *arg), void *arg, uint stacksize)
{
	return newthread(_threadgetproc(), f, arg, stacksize, nil, threadgetgrp());
}

/*
 * Create and initialize a new Proc structure with a single Thread
 * running inside it.  Add the Proc to the global process list.
 */
Proc*
_newproc(void (*f)(void *arg), void *arg, uint stacksize, char *name, int grp, int rforkflag)
{
	Proc *p;

	p = _threadmalloc(sizeof *p, 1);
	p-&gt;pid = -1;
	p-&gt;rforkflag = rforkflag;
	newthread(p, f, arg, stacksize, name, grp);

	lock(&amp;_threadpq.lock);
	if(_threadpq.head == nil)
		_threadpq.head = p;
	else
		*_threadpq.tail = p;
	_threadpq.tail = &amp;p-&gt;next;
	unlock(&amp;_threadpq.lock);
	return p;
}

int
procrfork(void (*f)(void *), void *arg, uint stacksize, int rforkflag)
{
	Proc *p;
	int id;

	p = _threadgetproc();
	assert(p-&gt;newproc == nil);
	p-&gt;newproc = _newproc(f, arg, stacksize, nil, p-&gt;thread-&gt;grp, rforkflag);
	id = p-&gt;newproc-&gt;threads.head-&gt;id;
	_sched();
	return id;
}

int
proccreate(void (*f)(void*), void *arg, uint stacksize)
{
	return procrfork(f, arg, stacksize, 0);
}

void
_freeproc(Proc *p)
{
	Thread *t, *nextt;

	for(t = p-&gt;threads.head; t; t = nextt){
		if(t-&gt;cmdname)
			free(t-&gt;cmdname);
		assert(t-&gt;stk != nil);
		free(t-&gt;stk);
		nextt = t-&gt;nextt;
		free(t);
	}
	free(p);
}

void
_freethread(Thread *t)
{
	Proc *p;
	Thread **l;

	p = t-&gt;proc;
	lock(&amp;p-&gt;lock);
	for(l=&amp;p-&gt;threads.head; *l; l=&amp;(*l)-&gt;nextt){
		if(*l == t){
			*l = t-&gt;nextt;
			if(*l == nil)
				p-&gt;threads.tail = l;
			break;
		}
	}
	unlock(&amp;p-&gt;lock);
	if (t-&gt;cmdname)
		free(t-&gt;cmdname);
	assert(t-&gt;stk != nil);
	free(t-&gt;stk);
	free(t);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

