<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libthread/id.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libthread/id.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "threadimpl.h"
#include &lt;tos.h&gt;

int
threadid(void)
{
	return _threadgetproc()-&gt;thread-&gt;id;
}

int
threadpid(int id)
{
	int pid;
	Proc *p;
	Thread *t;

	if (id &lt; 0)
		return -1;
	if (id == 0)
		return _threadgetproc()-&gt;pid;
	lock(&amp;_threadpq.lock);
	for (p = _threadpq.head; p; p = p-&gt;next){
		lock(&amp;p-&gt;lock);
		for (t = p-&gt;threads.head; t; t = t-&gt;nextt)
			if (t-&gt;id == id){
				pid = p-&gt;pid;
				unlock(&amp;p-&gt;lock);
				unlock(&amp;_threadpq.lock);
				return pid;
			}
		unlock(&amp;p-&gt;lock);
	}
	unlock(&amp;_threadpq.lock);
	return -1;
}

int
threadsetgrp(int ng)
{
	int og;
	Thread *t;

	t = _threadgetproc()-&gt;thread;
	og = t-&gt;grp;
	t-&gt;grp = ng;
	return og;
}

int
threadgetgrp(void)
{
	return _threadgetproc()-&gt;thread-&gt;grp;
}

void
threadsetname(char *fmt, ...)
{
	int fd;
	char buf[128];
	va_list arg;
	Proc *p;
	Thread *t;

	p = _threadgetproc();
	t = p-&gt;thread;
	if (t-&gt;cmdname)
		free(t-&gt;cmdname);
	va_start(arg, fmt);
	t-&gt;cmdname = vsmprint(fmt, arg);
	va_end(arg);
	if(t-&gt;cmdname &amp;&amp; p-&gt;nthreads == 1){
		snprint(buf, sizeof buf, "#p/%lud/args", _tos-&gt;pid); //getpid());
		if((fd = open(buf, OWRITE)) &gt;= 0){
			write(fd, t-&gt;cmdname, strlen(t-&gt;cmdname)+1);
			close(fd);
		}
	}
}

char*
threadgetname(void)
{
	Proc *p;

	if((p = _threadgetproc()) &amp;&amp; p-&gt;thread)
		return p-&gt;thread-&gt;cmdname;
	return nil;
}

void**
threaddata(void)
{
	return &amp;_threadgetproc()-&gt;thread-&gt;udata[0];
}

void**
_workerdata(void)
{
	return &amp;_threadgetproc()-&gt;wdata;
}

void**
procdata(void)
{
	return &amp;_threadgetproc()-&gt;udata;
}

static Lock privlock;
static int privmask = 1;

int
tprivalloc(void)
{
	int i;

	lock(&amp;privlock);
	for(i=0; i&lt;NPRIV; i++)
		if(!(privmask&amp;(1&lt;&lt;i))){
			privmask |= 1&lt;&lt;i;
			unlock(&amp;privlock);
			return i;
		}
	unlock(&amp;privlock);
	return -1;
}

void
tprivfree(int i)
{
	if(i &lt; 0 || i &gt;= NPRIV)
		abort();
	lock(&amp;privlock);
	privmask &amp;= ~(1&lt;&lt;i);
}

void**
tprivaddr(int i)
{
	return &amp;_threadgetproc()-&gt;thread-&gt;udata[i];
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

