<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libthread/sched.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libthread/sched.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "threadimpl.h"
#include &lt;tos.h&gt;

static Thread	*runthread(Proc*);

static char *_psstate[] = {
	"Moribund",
	"Dead",
	"Exec",
	"Fork",
	"Running",
	"Ready",
	"Rendezvous",
};

static char*
psstate(int s)
{
	if(s &lt; 0 || s &gt;= nelem(_psstate))
		return "unknown";
	return _psstate[s];
}

void
_schedinit(void *arg)
{
	Proc *p;
	Thread *t, **l;

	p = arg;
	_threadsetproc(p);
	p-&gt;pid = _tos-&gt;pid; //getpid();
	while(setjmp(p-&gt;sched))
		;
	_threaddebug(DBGSCHED, "top of schedinit, _threadexitsallstatus=%p", _threadexitsallstatus);
	if(_threadexitsallstatus)
		exits(_threadexitsallstatus);
	lock(&amp;p-&gt;lock);
	if((t=p-&gt;thread) != nil){
		p-&gt;thread = nil;
		if(t-&gt;moribund){
			t-&gt;state = Dead;
			for(l=&amp;p-&gt;threads.head; *l; l=&amp;(*l)-&gt;nextt)
				if(*l == t){
					*l = t-&gt;nextt;
					if(*l==nil)
						p-&gt;threads.tail = l;
					p-&gt;nthreads--;
					break;
				}
			unlock(&amp;p-&gt;lock);
			if(t-&gt;inrendez){
				_threadflagrendez(t);
				_threadbreakrendez();
			}
			free(t-&gt;stk);
			free(t-&gt;cmdname);
			free(t);	/* XXX how do we know there are no references? */
			t = nil;
			_sched();
		}
		if(p-&gt;needexec){
			t-&gt;ret = _schedexec(&amp;p-&gt;exec);
			p-&gt;needexec = 0;
		}
		if(p-&gt;newproc){
			t-&gt;ret = _schedfork(p-&gt;newproc);
			p-&gt;newproc = nil;
		}
		t-&gt;state = t-&gt;nextstate;
		if(t-&gt;state == Ready)
			_threadready(t);
	}
	unlock(&amp;p-&gt;lock);
	_sched();
}

void
needstack(int n)
{
	int x;
	Proc *p;
	Thread *t;
	
	p = _threadgetproc();
	t = p-&gt;thread;
	
	if((uchar*)&amp;x - n &lt; (uchar*)t-&gt;stk){
		fprint(2, "%s %lud: &amp;x=%p n=%d t-&gt;stk=%p\n",
			argv0, _tos-&gt;pid, &amp;x, n, t-&gt;stk);
		fprint(2, "%s %lud: stack overflow\n", argv0, _tos-&gt;pid);
		abort();
	}
}

void
_sched(void)
{
	Proc *p;
	Thread *t;

Resched:
	p = _threadgetproc();
	if((t = p-&gt;thread) != nil){
		needstack(128);
		_threaddebug(DBGSCHED, "pausing, state=%s", psstate(t-&gt;state));
		if(setjmp(t-&gt;sched)==0)
			longjmp(p-&gt;sched, 1);
		return;
	}else{
		t = runthread(p);
		if(t == nil){
			_threaddebug(DBGSCHED, "all threads gone; exiting");
			_schedexit(p);
		}
		_threaddebug(DBGSCHED, "running %d.%d", t-&gt;proc-&gt;pid, t-&gt;id);
		p-&gt;thread = t;
		if(t-&gt;moribund){
			_threaddebug(DBGSCHED, "%d.%d marked to die");
			goto Resched;
		}
		t-&gt;state = Running;
		t-&gt;nextstate = Ready;
		longjmp(t-&gt;sched, 1);
	}
}

static Thread*
runthread(Proc *p)
{
	Thread *t;
	Tqueue *q;

	if(p-&gt;nthreads==0)
		return nil;
	q = &amp;p-&gt;ready;
	lock(&amp;p-&gt;readylock);
	if(q-&gt;head == nil){
		q-&gt;asleep = 1;
		_threaddebug(DBGSCHED, "sleeping for more work");
		unlock(&amp;p-&gt;readylock);
		while(rendezvous(q, 0) == (void*)~0){
			if(_threadexitsallstatus)
				exits(_threadexitsallstatus);
		}
		/* lock picked up from _threadready */
	}
	t = q-&gt;head;
	q-&gt;head = t-&gt;next;
	unlock(&amp;p-&gt;readylock);
	return t;
}

void
_threadready(Thread *t)
{
	Tqueue *q;

	assert(t-&gt;state == Ready);
	_threaddebug(DBGSCHED, "readying %d.%d", t-&gt;proc-&gt;pid, t-&gt;id);
	q = &amp;t-&gt;proc-&gt;ready;
	lock(&amp;t-&gt;proc-&gt;readylock);
	t-&gt;next = nil;
	if(q-&gt;head==nil)
		q-&gt;head = t;
	else
		*q-&gt;tail = t;
	q-&gt;tail = &amp;t-&gt;next;
	if(q-&gt;asleep){
		q-&gt;asleep = 0;
		/* lock passes to runthread */
		_threaddebug(DBGSCHED, "waking process %d", t-&gt;proc-&gt;pid);
		while(rendezvous(q, 0) == (void*)~0){
			if(_threadexitsallstatus)
				exits(_threadexitsallstatus);
		}
	}else
		unlock(&amp;t-&gt;proc-&gt;readylock);
}

void
yield(void)
{
	_sched();
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

