<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/cache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/cache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Memory-only VtBlock cache.
 *
 * The cached Venti blocks are in the hash chains.
 * The cached local blocks are only in the blocks array.
 * The free blocks are in the heap, which is supposed to
 * be indexed by second-to-last use but actually
 * appears to be last use.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;

int vtcachenread;
int vtcachencopy;
int vtcachenwrite;
int vttracelevel;

enum {
	BioLocal = 1,
	BioVenti,
	BioReading,
	BioWriting,
	BioEmpty,
	BioVentiError
};
enum {
	BadHeap = ~0
};
struct VtCache
{
	QLock	lk;
	VtConn	*z;
	u32int	blocksize;
	u32int	now;		/* ticks for usage time stamps */
	VtBlock	**hash;	/* hash table for finding addresses */
	int		nhash;
	VtBlock	**heap;	/* heap for finding victims */
	int		nheap;
	VtBlock	*block;	/* all allocated blocks */
	int		nblock;
	uchar	*mem;	/* memory for all blocks and data */
	int		(*write)(VtConn*, uchar[VtScoreSize], uint, uchar*, int);
};

static void cachecheck(VtCache*);

VtCache*
vtcachealloc(VtConn *z, int blocksize, ulong nblock)
{
	uchar *p;
	VtCache *c;
	int i;
	VtBlock *b;

	c = vtmallocz(sizeof(VtCache));

	c-&gt;z = z;
	c-&gt;blocksize = (blocksize + 127) &amp; ~127;
	c-&gt;nblock = nblock;
	c-&gt;nhash = nblock;
	c-&gt;hash = vtmallocz(nblock*sizeof(VtBlock*));
	c-&gt;heap = vtmallocz(nblock*sizeof(VtBlock*));
	c-&gt;block = vtmallocz(nblock*sizeof(VtBlock));
	c-&gt;mem = vtmallocz(nblock*c-&gt;blocksize);
	c-&gt;write = vtwrite;

	p = c-&gt;mem;
	for(i=0; i&lt;nblock; i++){
		b = &amp;c-&gt;block[i];
		b-&gt;addr = NilBlock;
		b-&gt;c = c;
		b-&gt;data = p;
		b-&gt;heap = i;
		c-&gt;heap[i] = b;
		p += c-&gt;blocksize;
	}
	c-&gt;nheap = nblock;
	cachecheck(c);
	return c;
}

/*
 * BUG This is here so that vbackup can override it and do some
 * pipelining of writes.  Arguably vtwrite or vtwritepacket or the
 * cache itself should be providing this functionality.
 */
void
vtcachesetwrite(VtCache *c, int (*write)(VtConn*, uchar[VtScoreSize], uint, uchar*, int))
{
	if(write == nil)
		write = vtwrite;
	c-&gt;write = write;
}

void
vtcachefree(VtCache *c)
{
	int i;

	qlock(&amp;c-&gt;lk);

	cachecheck(c);
	for(i=0; i&lt;c-&gt;nblock; i++)
		assert(c-&gt;block[i].ref == 0);

	vtfree(c-&gt;hash);
	vtfree(c-&gt;heap);
	vtfree(c-&gt;block);
	vtfree(c-&gt;mem);
	vtfree(c);
}

static void
vtcachedump(VtCache *c)
{
	int i;
	VtBlock *b;

	for(i=0; i&lt;c-&gt;nblock; i++){
		b = &amp;c-&gt;block[i];
		print("cache block %d: type %d score %V iostate %d addr %d ref %d nlock %d\n",
			i, b-&gt;type, b-&gt;score, b-&gt;iostate, b-&gt;addr, b-&gt;ref, b-&gt;nlock);
	}
}

static void
cachecheck(VtCache *c)
{
	u32int size, now;
	int i, k, refed;
	VtBlock *b;

	size = c-&gt;blocksize;
	now = c-&gt;now;

	for(i = 0; i &lt; c-&gt;nheap; i++){
		if(c-&gt;heap[i]-&gt;heap != i)
			sysfatal("mis-heaped at %d: %d", i, c-&gt;heap[i]-&gt;heap);
		if(i &gt; 0 &amp;&amp; c-&gt;heap[(i - 1) &gt;&gt; 1]-&gt;used - now &gt; c-&gt;heap[i]-&gt;used - now)
			sysfatal("bad heap ordering");
		k = (i &lt;&lt; 1) + 1;
		if(k &lt; c-&gt;nheap &amp;&amp; c-&gt;heap[i]-&gt;used - now &gt; c-&gt;heap[k]-&gt;used - now)
			sysfatal("bad heap ordering");
		k++;
		if(k &lt; c-&gt;nheap &amp;&amp; c-&gt;heap[i]-&gt;used - now &gt; c-&gt;heap[k]-&gt;used - now)
			sysfatal("bad heap ordering");
	}

	refed = 0;
	for(i = 0; i &lt; c-&gt;nblock; i++){
		b = &amp;c-&gt;block[i];
		if(b-&gt;data != &amp;c-&gt;mem[i * size])
			sysfatal("mis-blocked at %d", i);
		if(b-&gt;ref &amp;&amp; b-&gt;heap == BadHeap)
			refed++;
		else if(b-&gt;addr != NilBlock)
			refed++;
	}
	assert(c-&gt;nheap + refed == c-&gt;nblock);
	refed = 0;
	for(i = 0; i &lt; c-&gt;nblock; i++){
		b = &amp;c-&gt;block[i];
		if(b-&gt;ref){
			refed++;
		}
	}
}

static int
upheap(int i, VtBlock *b)
{
	VtBlock *bb;
	u32int now;
	int p;
	VtCache *c;
	
	c = b-&gt;c;
	now = c-&gt;now;
	for(; i != 0; i = p){
		p = (i - 1) &gt;&gt; 1;
		bb = c-&gt;heap[p];
		if(b-&gt;used - now &gt;= bb-&gt;used - now)
			break;
		c-&gt;heap[i] = bb;
		bb-&gt;heap = i;
	}
	c-&gt;heap[i] = b;
	b-&gt;heap = i;

	return i;
}

static int
downheap(int i, VtBlock *b)
{
	VtBlock *bb;
	u32int now;
	int k;
	VtCache *c;
	
	c = b-&gt;c;
	now = c-&gt;now;
	for(; ; i = k){
		k = (i &lt;&lt; 1) + 1;
		if(k &gt;= c-&gt;nheap)
			break;
		if(k + 1 &lt; c-&gt;nheap &amp;&amp; c-&gt;heap[k]-&gt;used - now &gt; c-&gt;heap[k + 1]-&gt;used - now)
			k++;
		bb = c-&gt;heap[k];
		if(b-&gt;used - now &lt;= bb-&gt;used - now)
			break;
		c-&gt;heap[i] = bb;
		bb-&gt;heap = i;
	}
	c-&gt;heap[i] = b;
	b-&gt;heap = i;
	return i;
}

/*
 * Delete a block from the heap.
 * Called with c-&gt;lk held.
 */
static void
heapdel(VtBlock *b)
{
	int i, si;
	VtCache *c;

	c = b-&gt;c;

	si = b-&gt;heap;
	if(si == BadHeap)
		return;
	b-&gt;heap = BadHeap;
	c-&gt;nheap--;
	if(si == c-&gt;nheap)
		return;
	b = c-&gt;heap[c-&gt;nheap];
	i = upheap(si, b);
	if(i == si)
		downheap(i, b);
}

/*
 * Insert a block into the heap.
 * Called with c-&gt;lk held.
 */
static void
heapins(VtBlock *b)
{
	assert(b-&gt;heap == BadHeap);
	upheap(b-&gt;c-&gt;nheap++, b);
}

/*
 * locate the vtBlock with the oldest second to last use.
 * remove it from the heap, and fix up the heap.
 */
/* called with c-&gt;lk held */
static VtBlock*
vtcachebumpblock(VtCache *c)
{
	VtBlock *b;

	/*
	 * locate the vtBlock with the oldest second to last use.
	 * remove it from the heap, and fix up the heap.
	 */
	if(c-&gt;nheap == 0){
		vtcachedump(c);
		fprint(2, "vtcachebumpblock: no free blocks in vtCache");
		abort();
	}
	b = c-&gt;heap[0];
	heapdel(b);

	assert(b-&gt;heap == BadHeap);
	assert(b-&gt;ref == 0);

	/*
	 * unchain the vtBlock from hash chain if any
	 */
	if(b-&gt;prev){
		*(b-&gt;prev) = b-&gt;next;
		if(b-&gt;next)
			b-&gt;next-&gt;prev = b-&gt;prev;
		b-&gt;prev = nil;
	}

 	
if(0)fprint(2, "droping %x:%V\n", b-&gt;addr, b-&gt;score);
	/* set vtBlock to a reasonable state */
	b-&gt;ref = 1;
	b-&gt;iostate = BioEmpty;
	return b;
}

/*
 * fetch a local block from the memory cache.
 * if it's not there, load it, bumping some other Block.
 * if we're out of free blocks, we're screwed.
 */
VtBlock*
vtcachelocal(VtCache *c, u32int addr, int type)
{
	VtBlock *b;

	if(addr == 0)
		sysfatal("vtcachelocal: asked for nonexistent block 0");
	if(addr &gt; c-&gt;nblock)
		sysfatal("vtcachelocal: asked for block #%ud; only %d blocks",
			addr, c-&gt;nblock);

	b = &amp;c-&gt;block[addr-1];
	if(b-&gt;addr == NilBlock || b-&gt;iostate != BioLocal)
		sysfatal("vtcachelocal: block is not local");

	if(b-&gt;type != type)
		sysfatal("vtcachelocal: block has wrong type %d != %d", b-&gt;type, type);

	qlock(&amp;c-&gt;lk);
	b-&gt;ref++;
	qunlock(&amp;c-&gt;lk);

	qlock(&amp;b-&gt;lk);
	b-&gt;nlock = 1;
	b-&gt;pc = getcallerpc(&amp;c);
	return b;
}

VtBlock*
vtcacheallocblock(VtCache *c, int type)
{
	VtBlock *b;

	qlock(&amp;c-&gt;lk);
	b = vtcachebumpblock(c);
	b-&gt;iostate = BioLocal;
	b-&gt;type = type;
	b-&gt;addr = (b - c-&gt;block)+1;
	vtzeroextend(type, b-&gt;data, 0, c-&gt;blocksize);
	vtlocaltoglobal(b-&gt;addr, b-&gt;score);
	qunlock(&amp;c-&gt;lk);

	qlock(&amp;b-&gt;lk);
	b-&gt;nlock = 1;
	b-&gt;pc = getcallerpc(&amp;c);
	return b;
}

/*
 * fetch a global (Venti) block from the memory cache.
 * if it's not there, load it, bumping some other block.
 */
VtBlock*
vtcacheglobal(VtCache *c, uchar score[VtScoreSize], int type)
{
	VtBlock *b;
	ulong h;
	int n;
	u32int addr;

	if(vttracelevel)
		fprint(2, "vtcacheglobal %V %d from %p\n", score, type, getcallerpc(&amp;c));
	addr = vtglobaltolocal(score);
	if(addr != NilBlock){
		if(vttracelevel)
			fprint(2, "vtcacheglobal %V %d =&gt; local\n", score, type);
		b = vtcachelocal(c, addr, type);
		if(b)
			b-&gt;pc = getcallerpc(&amp;c);
		return b;
	}

	h = (u32int)(score[0]|(score[1]&lt;&lt;8)|(score[2]&lt;&lt;16)|(score[3]&lt;&lt;24)) % c-&gt;nhash;

	/*
	 * look for the block in the cache
	 */
	qlock(&amp;c-&gt;lk);
	for(b = c-&gt;hash[h]; b != nil; b = b-&gt;next){
		if(b-&gt;addr != NilBlock || memcmp(b-&gt;score, score, VtScoreSize) != 0 || b-&gt;type != type)
			continue;
		heapdel(b);
		b-&gt;ref++;
		qunlock(&amp;c-&gt;lk);
		if(vttracelevel)
			fprint(2, "vtcacheglobal %V %d =&gt; found in cache %p; locking\n", score, type, b);
		qlock(&amp;b-&gt;lk);
		b-&gt;nlock = 1;
		if(b-&gt;iostate == BioVentiError){
			if(chattyventi)
				fprint(2, "cached read error for %V\n", score);
			if(vttracelevel)
				fprint(2, "vtcacheglobal %V %d =&gt; cache read error\n", score, type);
			vtblockput(b);
			werrstr("venti i/o error");
			return nil;
		}
		if(vttracelevel)
			fprint(2, "vtcacheglobal %V %d =&gt; found in cache; returning\n", score, type);
		b-&gt;pc = getcallerpc(&amp;c);
		return b;
	}

	/*
	 * not found
	 */
	b = vtcachebumpblock(c);
	b-&gt;addr = NilBlock;
	b-&gt;type = type;
	memmove(b-&gt;score, score, VtScoreSize);
	/* chain onto correct hash */
	b-&gt;next = c-&gt;hash[h];
	c-&gt;hash[h] = b;
	if(b-&gt;next != nil)
		b-&gt;next-&gt;prev = &amp;b-&gt;next;
	b-&gt;prev = &amp;c-&gt;hash[h];

	/*
	 * Lock b before unlocking c, so that others wait while we read.
	 * 
	 * You might think there is a race between this qlock(b) before qunlock(c)
	 * and the qlock(c) while holding a qlock(b) in vtblockwrite.  However,
	 * the block here can never be the block in a vtblockwrite, so we're safe.
	 * We're certainly living on the edge.
	 */
	if(vttracelevel)
		fprint(2, "vtcacheglobal %V %d =&gt; bumped; locking %p\n", score, type, b);
	qlock(&amp;b-&gt;lk);
	b-&gt;nlock = 1;
	qunlock(&amp;c-&gt;lk);

	vtcachenread++;
	n = vtread(c-&gt;z, score, type, b-&gt;data, c-&gt;blocksize);
	if(n &lt; 0){
		if(chattyventi)
			fprint(2, "read %V: %r\n", score);
		if(vttracelevel)
			fprint(2, "vtcacheglobal %V %d =&gt; bumped; read error\n", score, type);
		b-&gt;iostate = BioVentiError;
		vtblockput(b);
		return nil;
	}
	vtzeroextend(type, b-&gt;data, n, c-&gt;blocksize);
	b-&gt;iostate = BioVenti;
	b-&gt;nlock = 1;
	if(vttracelevel)
		fprint(2, "vtcacheglobal %V %d =&gt; loaded into cache; returning\n", score, type);
	b-&gt;pc = getcallerpc(&amp;b);
	return b;
}

/*
 * The thread that has locked b may refer to it by
 * multiple names.  Nlock counts the number of
 * references the locking thread holds.  It will call
 * vtblockput once per reference.
 */
void
vtblockduplock(VtBlock *b)
{
	assert(b-&gt;nlock &gt; 0);
	b-&gt;nlock++;
}

/*
 * we're done with the block.
 * unlock it.  can't use it after calling this.
 */
void
vtblockput(VtBlock* b)
{
	VtCache *c;

	if(b == nil)
		return;

if(0)fprint(2, "vtblockput: %d: %x %d %d\n", getpid(), b-&gt;addr, c-&gt;nheap, b-&gt;iostate);
	if(vttracelevel)
		fprint(2, "vtblockput %p from %p\n", b, getcallerpc(&amp;b));

	if(--b-&gt;nlock &gt; 0)
		return;

	/*
	 * b-&gt;nlock should probably stay at zero while
	 * the vtBlock is unlocked, but diskThread and vtSleep
	 * conspire to assume that they can just qlock(&amp;b-&gt;lk); vtblockput(b),
	 * so we have to keep b-&gt;nlock set to 1 even 
	 * when the vtBlock is unlocked.
	 */
	assert(b-&gt;nlock == 0);
	b-&gt;nlock = 1;

	qunlock(&amp;b-&gt;lk);
	c = b-&gt;c;
	qlock(&amp;c-&gt;lk);

	if(--b-&gt;ref &gt; 0){
		qunlock(&amp;c-&gt;lk);
		return;
	}

	assert(b-&gt;ref == 0);
	switch(b-&gt;iostate){
	case BioVenti:
/*if(b-&gt;addr != NilBlock) print("blockput %d\n", b-&gt;addr); */
		b-&gt;used = c-&gt;now++;
		/* fall through */
	case BioVentiError:
		heapins(b);
		break;
	case BioLocal:
		break;
	}
	qunlock(&amp;c-&gt;lk);
}

int
vtblockwrite(VtBlock *b)
{
	uchar score[VtScoreSize];
	VtCache *c;
	uint h;
	int n;

	if(b-&gt;iostate != BioLocal){
		werrstr("vtblockwrite: not a local block");
		return -1;
	}

	c = b-&gt;c;
	n = vtzerotruncate(b-&gt;type, b-&gt;data, c-&gt;blocksize);
	vtcachenwrite++;
	if(c-&gt;write(c-&gt;z, score, b-&gt;type, b-&gt;data, n) &lt; 0)
		return -1;

	memmove(b-&gt;score, score, VtScoreSize);

	qlock(&amp;c-&gt;lk);
	b-&gt;addr = NilBlock;	/* now on venti */
	b-&gt;iostate = BioVenti;
	h = (u32int)(score[0]|(score[1]&lt;&lt;8)|(score[2]&lt;&lt;16)|(score[3]&lt;&lt;24)) % c-&gt;nhash;
	b-&gt;next = c-&gt;hash[h];
	c-&gt;hash[h] = b;
	if(b-&gt;next != nil)
		b-&gt;next-&gt;prev = &amp;b-&gt;next;
	b-&gt;prev = &amp;c-&gt;hash[h];
	qunlock(&amp;c-&gt;lk);
	return 0;
}

uint
vtcacheblocksize(VtCache *c)
{
	return c-&gt;blocksize;
}

VtBlock*
vtblockcopy(VtBlock *b)
{
	VtBlock *bb;

	vtcachencopy++;
	bb = vtcacheallocblock(b-&gt;c, b-&gt;type);
	if(bb == nil){
		vtblockput(b);
		return nil;
	}
	memmove(bb-&gt;data, b-&gt;data, b-&gt;c-&gt;blocksize);
	vtblockput(b);
	bb-&gt;pc = getcallerpc(&amp;b);
	return bb;
}

void
vtlocaltoglobal(u32int addr, uchar score[VtScoreSize])
{
	memset(score, 0, 16);
	score[16] = addr&gt;&gt;24;
	score[17] = addr&gt;&gt;16;
	score[18] = addr&gt;&gt;8;
	score[19] = addr;
}


u32int
vtglobaltolocal(uchar score[VtScoreSize])
{
	static uchar zero[16];
	if(memcmp(score, zero, 16) != 0)
		return NilBlock;
	return (score[16]&lt;&lt;24)|(score[17]&lt;&lt;16)|(score[18]&lt;&lt;8)|score[19];
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

