<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/debugpacket.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/debugpacket.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;
#include &lt;libsec.h&gt;

#define MAGIC 0x54798314
#define NOTFREE(p)	assert((p)-&gt;magic == MAGIC)

struct Packet
{
	char *data;
	int len;
	void (*free)(void*);
	void *arg;
	int magic;
};

Packet*
packetalloc(void)
{
	Packet *p;
	
	p = vtmallocz(sizeof *p);
	p-&gt;free = vtfree;
	p-&gt;arg = nil;
	p-&gt;magic = MAGIC;
	return p;
}

void
packetappend(Packet *p, uchar *buf, int n)
{
	NOTFREE(p);
	if(n &lt; 0)
		abort();
	if(p-&gt;free != vtfree)
		sysfatal("packetappend");
	p-&gt;data = vtrealloc(p-&gt;data, p-&gt;len+n);
	p-&gt;arg = p-&gt;data;
	memmove(p-&gt;data+p-&gt;len, buf, n);
	p-&gt;len += n;
}

uint
packetasize(Packet *p)
{
	NOTFREE(p);
	return p-&gt;len;
}

int
packetcmp(Packet *p, Packet *q)
{
	int i, len;
	
	NOTFREE(p);
	NOTFREE(q);
	len = p-&gt;len;
	if(len &gt; q-&gt;len)
		len = q-&gt;len;
	if(len &amp;&amp; (i=memcmp(p-&gt;data, q-&gt;data, len)) != 0)
		return i;
	if(p-&gt;len &gt; len)
		return 1;
	if(q-&gt;len &gt; len)
		return -1;
	return 0;
}

void
packetconcat(Packet *p, Packet *q)
{
	NOTFREE(p);
	NOTFREE(q);
	packetappend(p, q-&gt;data, q-&gt;len);
	if(q-&gt;free == vtfree)
		memset(q-&gt;data, 0xFE, q-&gt;len);
	q-&gt;free(q-&gt;arg);
	q-&gt;data = nil;
	q-&gt;len = 0;
}

int
packetconsume(Packet *p, uchar *buf, int n)
{
	NOTFREE(p);
	if(n &lt; 0)
		abort();
	if(p-&gt;len &lt; n)
		abort();
	memmove(buf, p-&gt;data, n);
	p-&gt;len -= n;
	memmove(p-&gt;data, p-&gt;data+n, p-&gt;len);
	return 0;
}

int
packetcopy(Packet *p, uchar *buf, int offset, int n)
{
	NOTFREE(p);
	if(offset &lt; 0 || n &lt; 0)
		abort();
	if(offset &gt; p-&gt;len)
		abort();
	if(offset+n &gt; p-&gt;len)
		n = p-&gt;len - offset;
	memmove(buf, p-&gt;data+offset, n);
	return 0;
}

Packet*
packetdup(Packet *p, int offset, int n)
{
	Packet *q;

	NOTFREE(p);
	if(offset &lt; 0 || n &lt; 0)
		abort();
	if(offset &gt; p-&gt;len)
		abort();
	if(offset+n &gt; p-&gt;len)
		n = p-&gt;len - offset;
	q = packetalloc();
	packetappend(q, p-&gt;data+offset, n);
	return q;
}

Packet*
packetforeign(uchar *buf, int n, void (*free)(void*), void *a)
{
	Packet *p;
	
	if(n &lt; 0)
		abort();
	p = packetalloc();
	p-&gt;data = (char*)buf;
	p-&gt;len = n;
	p-&gt;free = free;
	p-&gt;arg = a;
	return p;
}

int
packetfragments(Packet *p, IOchunk *io, int nio, int offset)
{
	NOTFREE(p);
	if(offset &lt; 0)
		abort();
	if(nio == 0)
		return 0;
	memset(io, 0, sizeof(io[0])*nio);
	if(offset &gt;= p-&gt;len)
		return 0;
	io[0].addr = p-&gt;data + offset;
	io[0].len = p-&gt;len - offset;
	return p-&gt;len;
}

void
packetfree(Packet *p)
{
	NOTFREE(p);
	if(p-&gt;free == free)
		memset(p-&gt;data, 0xFE, p-&gt;len);
	p-&gt;free(p-&gt;arg);
	p-&gt;data = nil;
	p-&gt;len = 0;
	memset(p, 0xFB, sizeof *p);
	free(p);
}

uchar*
packetheader(Packet *p, int n)
{
	NOTFREE(p);
	if(n &lt; 0)
		abort();
	if(n &gt; p-&gt;len)
		abort();
	return p-&gt;data;
}

uchar*
packetpeek(Packet *p, uchar *buf, int offset, int n)
{
	NOTFREE(p);
	if(offset &lt; 0 || n &lt; 0)
		abort();
	if(offset+n &gt; p-&gt;len)
		abort();
	return p-&gt;data+offset;
}

void
packetprefix(Packet *p, uchar *buf, int n)
{
	NOTFREE(p);
	if(n &lt; 0)
		abort();
	if(p-&gt;free != free)
		sysfatal("packetappend");
	p-&gt;data = vtrealloc(p-&gt;data, p-&gt;len+n);
	p-&gt;arg = p-&gt;data;
	memmove(p-&gt;data+n, p-&gt;data, p-&gt;len);
	memmove(p-&gt;data, buf, n);
	p-&gt;len += n;
}

void
packetsha1(Packet *p, uchar d[20])
{
	NOTFREE(p);
	sha1((uchar*)p-&gt;data, p-&gt;len, d, nil);
}

uint
packetsize(Packet *p)
{
	NOTFREE(p);
	return p-&gt;len;
}

Packet*
packetsplit(Packet *p, int n)
{
	Packet *q;
	
	NOTFREE(p);
	q = packetalloc();
	q-&gt;data = vtmalloc(n);
	q-&gt;arg = q-&gt;data;
	q-&gt;free = vtfree;
	packetconsume(p, q-&gt;data, n);
	return q;
}

void
packetstats(void)
{
}

uchar*
packettrailer(Packet *p, int n)
{
	NOTFREE(p);
	if(n &lt; 0)
		abort();
	if(n &gt; p-&gt;len)
		abort();
	return p-&gt;data + p-&gt;len - n;
}

int
packettrim(Packet *p, int offset, int n)
{
	NOTFREE(p);
	if(offset &lt; 0 || n &lt; 0)
		abort();
	if(offset+n &gt; p-&gt;len)
		abort();
	memmove(p-&gt;data+offset, p-&gt;data+offset+n, p-&gt;len-offset-n);
	p-&gt;len -= n;
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

