<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/fcall.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/fcall.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;

Packet*
vtfcallpack(VtFcall *f)
{
	uchar buf[4];
	Packet *p;

	p = packetalloc();

	buf[0] = f-&gt;msgtype;
	buf[1] = f-&gt;tag;
	packetappend(p, buf, 2);

	switch(f-&gt;msgtype){
	default:
		werrstr("vtfcallpack: unknown packet type %d", f-&gt;msgtype);
		goto Err;

	case VtRerror:
		if(vtputstring(p, f-&gt;error) &lt; 0)
			goto Err;
		break;

	case VtTping:
		break;

	case VtRping:
		break;

	case VtThello:
		if(vtputstring(p, f-&gt;version) &lt; 0
		|| vtputstring(p, f-&gt;uid) &lt; 0)
			goto Err;
		buf[0] = f-&gt;strength;
		buf[1] = f-&gt;ncrypto;
		packetappend(p, buf, 2);
		packetappend(p, f-&gt;crypto, f-&gt;ncrypto);
		buf[0] = f-&gt;ncodec;
		packetappend(p, buf, 1);
		packetappend(p, f-&gt;codec, f-&gt;ncodec);
		break;

	case VtRhello:
		if(vtputstring(p, f-&gt;sid) &lt; 0)
			goto Err;
		buf[0] = f-&gt;rcrypto;
		buf[1] = f-&gt;rcodec;
		packetappend(p, buf, 2);
		break;

	case VtTgoodbye:
		break;

	case VtTread:
		packetappend(p, f-&gt;score, VtScoreSize);
		buf[0] = vttodisktype(f-&gt;blocktype);
		if(~buf[0] == 0)
			goto Err;
		buf[1] = 0;
		buf[2] = f-&gt;count &gt;&gt; 8;
		buf[3] = f-&gt;count;
		packetappend(p, buf, 4);
		break;

	case VtRread:
		packetconcat(p, f-&gt;data);
		break;

	case VtTwrite:
		buf[0] = vttodisktype(f-&gt;blocktype);
		if(~buf[0] == 0)
			goto Err;
		buf[1] = 0;
		buf[2] = 0;
		buf[3] = 0;
		packetappend(p, buf, 4);
		packetconcat(p, f-&gt;data);
		break;

	case VtRwrite:
		packetappend(p, f-&gt;score, VtScoreSize);
		break;

	case VtTsync:
		break;

	case VtRsync:
		break;
	}

	return p;

Err:
	packetfree(p);
	return nil;
}

int
vtfcallunpack(VtFcall *f, Packet *p)
{
	uchar buf[4];

	memset(f, 0, sizeof *f);

	if(packetconsume(p, buf, 2) &lt; 0)
		return -1;

	f-&gt;msgtype = buf[0];
	f-&gt;tag = buf[1];

	switch(f-&gt;msgtype){
	default:
		werrstr("vtfcallunpack: unknown bad packet type %d", f-&gt;msgtype);
		vtfcallclear(f);
		return -1;

	case VtRerror:
		if(vtgetstring(p, &amp;f-&gt;error) &lt; 0)
			goto Err;
		break;

	case VtTping:
		break;

	case VtRping:
		break;

	case VtThello:
		if(vtgetstring(p, &amp;f-&gt;version) &lt; 0
		|| vtgetstring(p, &amp;f-&gt;uid) &lt; 0
		|| packetconsume(p, buf, 2) &lt; 0)
			goto Err;
		f-&gt;strength = buf[0];
		f-&gt;ncrypto = buf[1];
		if(f-&gt;ncrypto){
			f-&gt;crypto = vtmalloc(f-&gt;ncrypto);
			if(packetconsume(p, buf, f-&gt;ncrypto) &lt; 0)
				goto Err;
		}
		if(packetconsume(p, buf, 1) &lt; 0)
			goto Err;
		f-&gt;ncodec = buf[0];
		if(f-&gt;ncodec){
			f-&gt;codec = vtmalloc(f-&gt;ncodec);
			if(packetconsume(p, buf, f-&gt;ncodec) &lt; 0)
				goto Err;
		}
		break;

	case VtRhello:
		if(vtgetstring(p, &amp;f-&gt;sid) &lt; 0
		|| packetconsume(p, buf, 2) &lt; 0)
			goto Err;
		f-&gt;rcrypto = buf[0];
		f-&gt;rcodec = buf[1];
		break;

	case VtTgoodbye:
		break;

	case VtTread:
		if(packetconsume(p, f-&gt;score, VtScoreSize) &lt; 0
		|| packetconsume(p, buf, 4) &lt; 0)
			goto Err;
		f-&gt;blocktype = vtfromdisktype(buf[0]);
		if(~f-&gt;blocktype == 0)
			goto Err;
		f-&gt;count = (buf[2] &lt;&lt; 8) | buf[3];
		break;

	case VtRread:
		f-&gt;data = packetalloc();
		packetconcat(f-&gt;data, p);
		break;

	case VtTwrite:
		if(packetconsume(p, buf, 4) &lt; 0)
			goto Err;
		f-&gt;blocktype = vtfromdisktype(buf[0]);
		if(~f-&gt;blocktype == 0)
			goto Err;
		f-&gt;data = packetalloc();
		packetconcat(f-&gt;data, p);
		break;

	case VtRwrite:
		if(packetconsume(p, f-&gt;score, VtScoreSize) &lt; 0)
			goto Err;
		break;

	case VtTsync:
		break;

	case VtRsync:
		break;
	}

	if(packetsize(p) != 0)
		goto Err;

	return 0;

Err:
	werrstr("bad packet");
	vtfcallclear(f);
	return -1;
}

void
vtfcallclear(VtFcall *f)
{
	vtfree(f-&gt;error);
	f-&gt;error = nil;
	vtfree(f-&gt;uid);
	f-&gt;uid = nil;
	vtfree(f-&gt;sid);
	f-&gt;sid = nil;
	vtfree(f-&gt;version);
	f-&gt;version = nil;
	vtfree(f-&gt;crypto);
	f-&gt;crypto = nil;
	vtfree(f-&gt;codec);
	f-&gt;codec = nil;
	vtfree(f-&gt;auth);
	f-&gt;auth = nil;
	packetfree(f-&gt;data);
	f-&gt;data = nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

