<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/packet.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/packet.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;
#include &lt;libsec.h&gt;

typedef struct Mem Mem;
typedef struct Frag Frag;

enum {
	BigMemSize = MaxFragSize,
	SmallMemSize = BigMemSize/8,
	NLocalFrag = 2
};

/* position to carve out of a Mem */
enum {
	PFront,
	PMiddle,
	PEnd
};

struct Mem
{
	Lock lk;
	int ref;
	uchar *bp;
	uchar *ep;
	uchar *rp;
	uchar *wp;
	Mem *next;
};

enum {
	FragLocalFree,
	FragLocalAlloc,
	FragGlobal
};
	
struct Frag
{
	int state;
	Mem *mem;
	uchar *rp;
	uchar *wp;
	Frag *next;
	void (*free)(void*);
	void *a;
	Packet *p;	/* parent packet, for debugging only */
};

struct Packet
{
	int size;
	int asize;  /* allocated memory - greater than size unless foreign frags */
	ulong pc;

	Packet *next;
	
	Frag *first;
	Frag *last;
	
	Frag local[NLocalFrag];
};

static Frag *fragalloc(Packet*, int n, int pos, Frag *next);
static Frag *fragdup(Packet*, Frag*);
static void fragfree(Frag*);

static Mem *memalloc(int, int);
static void memfree(Mem*);
static int memhead(Mem *m, uchar *rp, int n);
static int memtail(Mem *m, uchar *wp, int n);

static char EPacketSize[] = "bad packet size";
static char EPacketOffset[] = "bad packet offset";
static char EBadSize[] = "bad size";

#ifdef NOTDEF
static void checkpacket(Packet*);
#endif

/*
 * the free list is primarily for speed, but it is 
 * also necessary for packetsplit that packets
 * are never freed -- a packet can contain a different
 * packet's local fragments, thanks to packetsplit!
 */
static struct {
	Lock lk;
	Packet *packet;
	int npacket;
	Frag *frag;
	int nfrag;
	Mem *bigmem;
	int nbigmem;
	Mem *smallmem;
	int nsmallmem;
} freelist;

#define FRAGSIZE(f) ((f)-&gt;wp - (f)-&gt;rp)
#define FRAGASIZE(f) ((f)-&gt;mem ? (f)-&gt;mem-&gt;ep - (f)-&gt;mem-&gt;bp : 0)

#define NOTFREE(p) assert((p)-&gt;size&gt;=0)/*; checkpacket(p)*/

Packet *
packetalloc(void)
{
	Packet *p;

	lock(&amp;freelist.lk);
	p = freelist.packet;
	if(p != nil)
		freelist.packet = p-&gt;next;
	else
		freelist.npacket++;
	unlock(&amp;freelist.lk);

	if(p == nil)
		p = vtbrk(sizeof(Packet));
	else
		assert(p-&gt;size == -1);
	p-&gt;size = 0;
	p-&gt;asize = 0;
	p-&gt;first = nil;
	p-&gt;last = nil;
	p-&gt;next = nil;
	p-&gt;pc = getcallerpc((char*)&amp;p+8);	/* might not work, but fine */

	NOTFREE(p);
	return p;
}

void
packetfree(Packet *p)
{
	Frag *f, *ff;

	if(p == nil)
		return;

	NOTFREE(p);
	p-&gt;pc = getcallerpc(&amp;p);

	for(f=p-&gt;first; f!=nil; f=ff) {
		ff = f-&gt;next;
		fragfree(f);
	}
	p-&gt;first = (void*)0xDeadBeef;
	p-&gt;last = (void*)0xDeadBeef;
	p-&gt;size = -1;

	lock(&amp;freelist.lk);
	p-&gt;next = freelist.packet;
	freelist.packet = p;
	unlock(&amp;freelist.lk);
}

Packet *
packetdup(Packet *p, int offset, int n)
{	
	Frag *f, *ff;
	Packet *pp;

	NOTFREE(p);
	if(offset &lt; 0 || n &lt; 0 || offset+n &gt; p-&gt;size) {
		werrstr(EBadSize);
		return nil;
	}

	pp = packetalloc();
	pp-&gt;pc = getcallerpc(&amp;p);
	if(n == 0){
		NOTFREE(pp);
		return pp;
	}

	pp-&gt;size = n;

	/* skip offset */
	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=f-&gt;next)
		offset -= FRAGSIZE(f);
	
	/* first frag */
	ff = fragdup(pp, f);
	ff-&gt;rp += offset;
	pp-&gt;first = ff;
	n -= FRAGSIZE(ff);
	pp-&gt;asize += FRAGASIZE(ff);

	/* the remaining */
	while(n &gt; 0) {
		f = f-&gt;next;
		ff-&gt;next = fragdup(pp, f);
		ff = ff-&gt;next;
		n -= FRAGSIZE(ff);
		pp-&gt;asize += FRAGASIZE(ff);
	}
	
	/* fix up last frag: note n &lt;= 0 */
	ff-&gt;wp += n;
	ff-&gt;next = nil;
	pp-&gt;last = ff;

	NOTFREE(pp);
	NOTFREE(p);
	return pp;
}

Packet *
packetsplit(Packet *p, int n)
{
	Packet *pp;
	Frag *f, *ff;

	NOTFREE(p);
	if(n &lt; 0 || n &gt; p-&gt;size) {
		werrstr(EPacketSize);
		return nil;
	}

	pp = packetalloc();
	pp-&gt;pc = getcallerpc(&amp;p);
	if(n == 0){
		NOTFREE(pp);
		return pp;
	}

	pp-&gt;size = n;
	p-&gt;size -= n;
	ff = nil;
	for(f=p-&gt;first; n &gt; 0 &amp;&amp; n &gt;= FRAGSIZE(f); f=f-&gt;next) {
		n -= FRAGSIZE(f);
		p-&gt;asize -= FRAGASIZE(f);
		pp-&gt;asize += FRAGASIZE(f);
		f-&gt;p = pp;
		ff = f;
	}

	/* split shared frag */
	if(n &gt; 0) {
		f-&gt;p = pp;
		ff = f;
		f = fragdup(p, ff);
		pp-&gt;asize += FRAGASIZE(ff);
		ff-&gt;wp = ff-&gt;rp + n;
		f-&gt;rp += n;
	}

	pp-&gt;first = p-&gt;first;
	pp-&gt;last = ff;
	ff-&gt;next = nil;
	p-&gt;first = f;
	if(f == nil || f-&gt;next == nil)
		p-&gt;last = f;
	NOTFREE(pp);
	NOTFREE(p);
	return pp;
}

int
packetconsume(Packet *p, uchar *buf, int n)
{
	NOTFREE(p);
	if(buf &amp;&amp; packetcopy(p, buf, 0, n) &lt; 0)
		return -1;
	return packettrim(p, n, p-&gt;size-n);
}

int
packettrim(Packet *p, int offset, int n)
{
	Frag *f, *ff;

	NOTFREE(p);
	if(offset &lt; 0 || offset &gt; p-&gt;size) {
		werrstr(EPacketOffset);
		return -1;
	}

	if(n &lt; 0 || offset + n &gt; p-&gt;size) {
		werrstr(EPacketOffset);
		return -1;
	}

	p-&gt;size = n;

	/* easy case */
	if(n == 0) {
		for(f=p-&gt;first; f != nil; f=ff) {
			ff = f-&gt;next;
			fragfree(f);
		}
		p-&gt;first = p-&gt;last = nil;
		p-&gt;asize = 0;
		NOTFREE(p);
		return 0;
	}
	
	/* free before offset */
	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=ff) {
		p-&gt;asize -= FRAGASIZE(f);
		offset -= FRAGSIZE(f);
		ff = f-&gt;next;
		fragfree(f);
	}

	/* adjust frag */
	f-&gt;rp += offset;
	p-&gt;first = f;

	/* skip middle */
	for(; n &gt; 0 &amp;&amp; n &gt; FRAGSIZE(f); f=f-&gt;next)
		n -= FRAGSIZE(f);

	/* adjust end */
	f-&gt;wp = f-&gt;rp + n;
	p-&gt;last = f;
	ff = f-&gt;next;
	f-&gt;next = nil;

	/* free after */
	for(f=ff; f != nil; f=ff) {
		p-&gt;asize -= FRAGASIZE(f);
		ff = f-&gt;next;
		fragfree(f);
	}
	NOTFREE(p);
	return 0;
}

uchar *
packetheader(Packet *p, int n)
{
	Frag *f;
	Mem *m;

	NOTFREE(p);
	if(n &lt;= 0 || n &gt; MaxFragSize) {
		werrstr(EPacketSize);
		return nil;
	}

	p-&gt;size += n;
	
	/* try and fix in current frag */
	f = p-&gt;first;
	if(f != nil) {
		m = f-&gt;mem;
		if(n &lt;= f-&gt;rp - m-&gt;bp)
		if(m-&gt;ref == 1 || memhead(m, f-&gt;rp, n) &gt;= 0) {
			f-&gt;rp -= n;
			NOTFREE(p);
			return f-&gt;rp;
		}
	}

	/* add frag to front */
	f = fragalloc(p, n, PEnd, p-&gt;first);
	p-&gt;asize += FRAGASIZE(f);
	if(p-&gt;first == nil)
		p-&gt;last = f;
	p-&gt;first = f;
	NOTFREE(p);
	return f-&gt;rp;
}

uchar *
packettrailer(Packet *p, int n)
{
	Mem *m;
	Frag *f;

	NOTFREE(p);
	if(n &lt;= 0 || n &gt; MaxFragSize) {
		werrstr(EPacketSize);
		return nil;
	}

	p-&gt;size += n;
	
	/* try and fix in current frag */
	if(p-&gt;first != nil) {
		f = p-&gt;last;
		m = f-&gt;mem;
		if(n &lt;= m-&gt;ep - f-&gt;wp)
		if(m-&gt;ref == 1 || memtail(m, f-&gt;wp, n) &gt;= 0) {
			f-&gt;wp += n;
			NOTFREE(p);
			return f-&gt;wp - n;
		}
	}

	/* add frag to end */
	f = fragalloc(p, n, (p-&gt;first == nil)?PMiddle:PFront, nil);
	p-&gt;asize += FRAGASIZE(f);
	if(p-&gt;first == nil)
		p-&gt;first = f;
	else
		p-&gt;last-&gt;next = f;
	p-&gt;last = f;
	NOTFREE(p);
	return f-&gt;rp;
}

void
packetprefix(Packet *p, uchar *buf, int n)
{
	Frag *f;
	int nn;
	Mem *m;

	NOTFREE(p);
	if(n &lt;= 0)
		return;

	p-&gt;size += n;

	/* try and fix in current frag */
	f = p-&gt;first;
	if(f != nil) {
		m = f-&gt;mem;
		nn = f-&gt;rp - m-&gt;bp;
		if(nn &gt; n)
			nn = n;
		if(m-&gt;ref == 1 || memhead(m, f-&gt;rp, nn) &gt;= 0) {
			f-&gt;rp -= nn;
			n -= nn;
			memmove(f-&gt;rp, buf+n, nn);
		}
	}

	while(n &gt; 0) {
		nn = n;
		if(nn &gt; MaxFragSize)
			nn = MaxFragSize;
		f = fragalloc(p, nn, PEnd, p-&gt;first);	
		p-&gt;asize += FRAGASIZE(f);
		if(p-&gt;first == nil)
			p-&gt;last = f;
		p-&gt;first = f;
		n -= nn;
		memmove(f-&gt;rp, buf+n, nn);
	}
	NOTFREE(p);
}

void
packetappend(Packet *p, uchar *buf, int n)
{
	Frag *f;
	int nn;
	Mem *m;

	NOTFREE(p);
	if(n &lt;= 0)
		return;

	p-&gt;size += n;
	/* try and fix in current frag */
	if(p-&gt;first != nil) {
		f = p-&gt;last;
		m = f-&gt;mem;
		nn = m-&gt;ep - f-&gt;wp;
		if(nn &gt; n)
			nn = n;
		if(m-&gt;ref == 1 || memtail(m, f-&gt;wp, nn) &gt;= 0) {
			memmove(f-&gt;wp, buf, nn);
			f-&gt;wp += nn;
			buf += nn;
			n -= nn;
		}
	}
	
	while(n &gt; 0) {
		nn = n;
		if(nn &gt; MaxFragSize)
			nn = MaxFragSize;
		f = fragalloc(p, nn, (p-&gt;first == nil)?PMiddle:PFront, nil);
		p-&gt;asize += FRAGASIZE(f);
		if(p-&gt;first == nil)
			p-&gt;first = f;
		else
			p-&gt;last-&gt;next = f;
		p-&gt;last = f;
		memmove(f-&gt;rp, buf, nn);
		buf += nn;
		n -= nn;
	}
	NOTFREE(p);
}

void
packetconcat(Packet *p, Packet *pp)
{
	Frag *f;

	NOTFREE(p);
	NOTFREE(pp);
	if(pp-&gt;size == 0)
		return;
	p-&gt;size += pp-&gt;size;
	p-&gt;asize += pp-&gt;asize;
	for(f=pp-&gt;first; f; f=f-&gt;next)
		f-&gt;p = p;

	if(p-&gt;first != nil)
		p-&gt;last-&gt;next = pp-&gt;first;
	else
		p-&gt;first = pp-&gt;first;

	p-&gt;last = pp-&gt;last;
	pp-&gt;size = 0;
	pp-&gt;asize = 0;
	pp-&gt;first = nil;
	pp-&gt;last = nil;
	NOTFREE(p);
	NOTFREE(pp);
}

uchar *
packetpeek(Packet *p, uchar *buf, int offset, int n)
{
	Frag *f;
	int nn;
	uchar *b;

	NOTFREE(p);
	if(n == 0)
		return buf;

	if(offset &lt; 0 || offset &gt;= p-&gt;size) {
		werrstr(EPacketOffset);
		return nil;
	}

	if(n &lt; 0 || offset + n &gt; p-&gt;size) {
		werrstr(EPacketSize);
		return nil;
	}
	
	/* skip up to offset */
	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=f-&gt;next)
		offset -= FRAGSIZE(f);

	/* easy case */
	if(offset + n &lt;= FRAGSIZE(f)){
		NOTFREE(p);
		return f-&gt;rp + offset;
	}

	for(b=buf; n&gt;0; n -= nn) {
		nn = FRAGSIZE(f) - offset;
		if(nn &gt; n)
			nn = n;
		memmove(b, f-&gt;rp+offset, nn);
		offset = 0;
		f = f-&gt;next;
		b += nn;
	}

	NOTFREE(p);
	return buf;
}

int
packetcopy(Packet *p, uchar *buf, int offset, int n)
{
	uchar *b;

	NOTFREE(p);
	b = packetpeek(p, buf, offset, n);
	if(b == nil)
		return -1;
	if(b != buf)
		memmove(buf, b, n);
	return 0;
}

int
packetfragments(Packet *p, IOchunk *io, int nio, int offset)
{
	Frag *f;
	int size;
	IOchunk *eio;

	NOTFREE(p);
	if(p-&gt;size == 0 || nio &lt;= 0)
		return 0;
	
	if(offset &lt; 0 || offset &gt; p-&gt;size) {
		werrstr(EPacketOffset);
		return -1;
	}

	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=f-&gt;next)
		offset -= FRAGSIZE(f);

	size = 0;
	eio = io + nio;
	for(; f != nil &amp;&amp; io &lt; eio; f=f-&gt;next) {
		io-&gt;addr = f-&gt;rp + offset;
		io-&gt;len = f-&gt;wp - (f-&gt;rp + offset);	
		offset = 0;
		size += io-&gt;len;
		io++;
	}
	for(; io &lt; eio; io++){
		io-&gt;addr = nil;
		io-&gt;len = 0;
	}
	return size;
}

void
packetstats(void)
{
	Packet *p;
	Frag *f;
	Mem *m;

	int np, nf, nsm, nbm;

	lock(&amp;freelist.lk);
	np = 0;
	for(p=freelist.packet; p; p=p-&gt;next)
		np++;
	nf = 0;
	for(f=freelist.frag; f; f=f-&gt;next)
		nf++;
	nsm = 0;
	for(m=freelist.smallmem; m; m=m-&gt;next)
		nsm++;
	nbm = 0;
	for(m=freelist.bigmem; m; m=m-&gt;next)
		nbm++;
	
	fprint(2, "packet: %d/%d frag: %d/%d small mem: %d/%d big mem: %d/%d\n",
		np, freelist.npacket,
		nf, freelist.nfrag,
		nsm, freelist.nsmallmem,
		nbm, freelist.nbigmem);

	unlock(&amp;freelist.lk);
}


uint
packetsize(Packet *p)
{
	NOTFREE(p);
	if(1) {
		Frag *f;
		int size = 0;
	
		for(f=p-&gt;first; f; f=f-&gt;next)
			size += FRAGSIZE(f);
		if(size != p-&gt;size)
			fprint(2, "packetsize %d %d\n", size, p-&gt;size);
		assert(size == p-&gt;size);
	}
	return p-&gt;size;
}

uint
packetasize(Packet *p)
{
	NOTFREE(p);
	if(0) {
		Frag *f;
		int asize = 0;
	
		for(f=p-&gt;first; f; f=f-&gt;next)
			asize += FRAGASIZE(f);
		if(asize != p-&gt;asize)
			fprint(2, "packetasize %d %d\n", asize, p-&gt;asize);
		assert(asize == p-&gt;asize);
	}
	return p-&gt;asize;
}

void
packetsha1(Packet *p, uchar digest[VtScoreSize])
{
	DigestState ds;
	Frag *f;
	int size;

	NOTFREE(p);
	memset(&amp;ds, 0, sizeof ds);
	size = p-&gt;size;
	for(f=p-&gt;first; f; f=f-&gt;next) {
		sha1(f-&gt;rp, FRAGSIZE(f), nil, &amp;ds);
		size -= FRAGSIZE(f);
	}
	assert(size == 0);
	sha1(nil, 0, digest, &amp;ds);
}

int
packetcmp(Packet *pkt0, Packet *pkt1)
{
	Frag *f0, *f1;
	int n0, n1, x;

	NOTFREE(pkt0);
	NOTFREE(pkt1);
	f0 = pkt0-&gt;first;
	f1 = pkt1-&gt;first;

	if(f0 == nil)
		return (f1 == nil)?0:-1;
	if(f1 == nil)
		return 1;
	n0 = FRAGSIZE(f0);
	n1 = FRAGSIZE(f1);

	for(;;) {
		if(n0 &lt; n1) {
			x = memcmp(f0-&gt;wp - n0, f1-&gt;wp - n1, n0);
			if(x != 0)
				return x;
			n1 -= n0;
			f0 = f0-&gt;next;
			if(f0 == nil)
				return -1;
			n0 = FRAGSIZE(f0);
		} else if (n0 &gt; n1) {
			x = memcmp(f0-&gt;wp - n0, f1-&gt;wp - n1, n1);
			if(x != 0)
				return x;
			n0 -= n1;
			f1 = f1-&gt;next;
			if(f1 == nil)
				return 1;
			n1 = FRAGSIZE(f1);
		} else { /* n0 == n1 */
			x = memcmp(f0-&gt;wp - n0, f1-&gt;wp - n1, n0);
			if(x != 0)
				return x;
			f0 = f0-&gt;next;
			f1 = f1-&gt;next;
			if(f0 == nil)
				return (f1 == nil)?0:-1;
			if(f1 == nil)
				return 1;
			n0 = FRAGSIZE(f0);
			n1 = FRAGSIZE(f1);
		}
	}
}

static Frag *
fragalloc(Packet *p, int n, int pos, Frag *next)
{
	Frag *f, *ef;
	Mem *m;

	/* look for local frag */
	f = &amp;p-&gt;local[0];
	ef = &amp;p-&gt;local[NLocalFrag];
	for(;f&lt;ef; f++) {
		if(f-&gt;state == FragLocalFree) {
			f-&gt;state = FragLocalAlloc;
			goto Found;
		}
	}
	lock(&amp;freelist.lk);	
	f = freelist.frag;
	if(f != nil)
		freelist.frag = f-&gt;next;
	else
		freelist.nfrag++;
	unlock(&amp;freelist.lk);

	if(f == nil) {
		f = vtbrk(sizeof(Frag));
		f-&gt;state = FragGlobal;
	}

Found:
	f-&gt;next = next;
	f-&gt;p = p;

	if(n == 0){
		f-&gt;mem = 0;
		f-&gt;rp = 0;
		f-&gt;wp = 0;
		return f;
	}

	if(pos == PEnd &amp;&amp; next == nil)
		pos = PMiddle;
	m = memalloc(n, pos);
	f-&gt;mem = m;
	f-&gt;rp = m-&gt;rp;
	f-&gt;wp = m-&gt;wp;
	return f;
}

Packet*
packetforeign(uchar *buf, int n, void (*free)(void *a), void *a)
{
	Packet *p;
	Frag *f;

	p = packetalloc();
	p-&gt;pc = getcallerpc(&amp;buf);
	f = fragalloc(p, 0, 0, nil);
	f-&gt;free = free;
	f-&gt;a = a;
	f-&gt;next = nil;
	f-&gt;rp = buf;
	f-&gt;wp = buf+n;

	p-&gt;first = f;
	p-&gt;last = f;
	p-&gt;size = n;
	NOTFREE(p);
	return p;
}

static Frag *
fragdup(Packet *p, Frag *f)
{
	Frag *ff;
	Mem *m;

	m = f-&gt;mem;	

	/*
	 * m-&gt;rp &amp;&amp; m-&gt;wp can be out of date when ref == 1
	 * also, potentially reclaims space from previous frags
	 */
	if(m &amp;&amp; m-&gt;ref == 1) {
		m-&gt;rp = f-&gt;rp;
		m-&gt;wp = f-&gt;wp;
	}

	ff = fragalloc(p, 0, 0, nil);
	ff-&gt;mem = f-&gt;mem;
	ff-&gt;rp = f-&gt;rp;
	ff-&gt;wp = f-&gt;wp;
	ff-&gt;next = f-&gt;next;

	/*
	 * We can't duplicate these -- there's no dup function.
	 */
	assert(f-&gt;free==nil &amp;&amp; f-&gt;a==nil);

	if(m){
		lock(&amp;m-&gt;lk);
		m-&gt;ref++;
		unlock(&amp;m-&gt;lk);
	}

	
	return ff;
}


static void
fragfree(Frag *f)
{
	if(f-&gt;mem == nil){
		if(f-&gt;free)
			(*f-&gt;free)(f-&gt;a);
	}else{
		memfree(f-&gt;mem);
		f-&gt;mem = 0;
	}

	if(f-&gt;state == FragLocalAlloc) {
		f-&gt;state = FragLocalFree;
		return;
	}

	lock(&amp;freelist.lk);
	f-&gt;next = freelist.frag;
	freelist.frag = f;
	unlock(&amp;freelist.lk);	
}

static Mem *
memalloc(int n, int pos)
{
	Mem *m;
	int nn;

	if(n &lt; 0 || n &gt; MaxFragSize) {
		werrstr(EPacketSize);
		return nil;
	}
	if(n &lt;= SmallMemSize) {
		lock(&amp;freelist.lk);
		m = freelist.smallmem;
		if(m != nil)
			freelist.smallmem = m-&gt;next;
		else
			freelist.nsmallmem++;
		unlock(&amp;freelist.lk);
		nn = SmallMemSize;
	} else {
		lock(&amp;freelist.lk);
		m = freelist.bigmem;
		if(m != nil)
			freelist.bigmem = m-&gt;next;
		else
			freelist.nbigmem++;
		unlock(&amp;freelist.lk);
		nn = BigMemSize;
	}

	if(m == nil) {
		m = vtbrk(sizeof(Mem));
		m-&gt;bp = vtbrk(nn);
		m-&gt;ep = m-&gt;bp + nn;
	}
	assert(m-&gt;ref == 0);	
	m-&gt;ref = 1;

	switch(pos) {
	default:
		assert(0);
	case PFront:
		m-&gt;rp = m-&gt;bp;
		break;
	case PMiddle:
		/* leave a little bit at end */
		m-&gt;rp = m-&gt;ep - n - 32;
		break;
	case PEnd:
		m-&gt;rp = m-&gt;ep - n;
		break; 
	}
	/* check we did not blow it */
	if(m-&gt;rp &lt; m-&gt;bp)
		m-&gt;rp = m-&gt;bp;
	m-&gt;wp = m-&gt;rp + n;
	assert(m-&gt;rp &gt;= m-&gt;bp &amp;&amp; m-&gt;wp &lt;= m-&gt;ep);
	return m;
}

static void
memfree(Mem *m)
{
	lock(&amp;m-&gt;lk);
	m-&gt;ref--;
	if(m-&gt;ref &gt; 0) {
		unlock(&amp;m-&gt;lk);
		return;
	}
	unlock(&amp;m-&gt;lk);
	assert(m-&gt;ref == 0);

/*	memset(m-&gt;bp, 0xEF, m-&gt;ep-m-&gt;bp); */
	switch(m-&gt;ep - m-&gt;bp) {
	default:
		assert(0);
	case SmallMemSize:
		lock(&amp;freelist.lk);
		m-&gt;next = freelist.smallmem;
		freelist.smallmem = m;
		unlock(&amp;freelist.lk);
		break;
	case BigMemSize:
		lock(&amp;freelist.lk);
		m-&gt;next = freelist.bigmem;
		freelist.bigmem = m;
		unlock(&amp;freelist.lk);
		break;
	}
}

static int
memhead(Mem *m, uchar *rp, int n)
{
	fprint(2, "memhead called\n");
	abort();
	lock(&amp;m-&gt;lk);
	if(m-&gt;rp != rp) {
		unlock(&amp;m-&gt;lk);
		return -1;
	}
	m-&gt;rp -= n;
	unlock(&amp;m-&gt;lk);
	return 0;
}

static int
memtail(Mem *m, uchar *wp, int n)
{
	fprint(2, "memtail called\n");
	abort();
	lock(&amp;m-&gt;lk);
	if(m-&gt;wp != wp) {
		unlock(&amp;m-&gt;lk);
		return -1;
	}
	m-&gt;wp += n;
	unlock(&amp;m-&gt;lk);
	return 0;
}

#ifdef NOTDEF
static void
checkpacket(Packet *p)
{
	int s, as;
	Frag *f;
	Frag *ff;

	s = 0;
	as = 0;
	ff=p-&gt;first;
	for(f=p-&gt;first; f; ff=f,f=f-&gt;next){
		assert(f-&gt;p == p);
		s += FRAGSIZE(f);
		as += FRAGASIZE(f);
	}
	assert(s == p-&gt;size);
	assert(as == p-&gt;asize);
	if(p-&gt;first)
		assert(ff==p-&gt;last);
}
#endif
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

